zenon Help 7.20

zenon Help 7.20

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

© 2015 Ing. Punzenberger COPA-DATA GmbH


Manual

Manual

In this area you can find the manual for zenon.


zenon product family

Manual -> zenon product family

As automation software for HMI, SCADA and reporting zenon provides a plethora of integrated functions for engineering and Runtime platform-independent.

With zenon you can:

  • Create, distribute, edit and execute automation projects
  • use integrated Soft-SPS zenon Logic
  • Collect and evaluate equipment-spanning data from a plethora of sources

attention Attention

Links in the manual to zenon overall mean in general zenon Supervisor and zenon Operator.

zenon is also available in two special editions:

  • Energy Edition: for energy and infrastructure companies
  • Pharma Edition: for the pharmaceutical industry

This editions are optimized for the respective application and contain special elements such as symbols, wizards, etc.


zenon Supervisor

Manual -> zenon product family -> zenon Supervisor

The zenon Supervisor is a comprehensive tool for creating and executing automation projects. It consists of Editor and Runtime, permits the quick creation of automation networks - also via web connection - and be used on all current Windows operating system.

For the employment on machine operation systems there is also a functionally limited version - CD_PRODUCTNAME <Operator> - available.


zenon Operator

Manual -> zenon product family -> zenon Operator

The zenon Operator is a cost-effective product which is adapted to machine operation. The principle function conforms with that of the zenon Supervisor. Compared to the zenon Supervisor the Operator is functionally limited.

The zenon Operator consists of Editor and Runtime and can be used on PC and CE operating systems.


zenon Logic

Manual -> zenon product family -> zenon Logic

zenon Logic is the programming environment in accordance with IEC 61131 included in zenon. It is available as Editor and Runtime (Soft-PLC) for zenon Supervisor and zenon Operator.


zenon Analyzer

Manual -> zenon product family -> zenon Analyzer

The zenon Analyzer offers via system-spanning analysis a management-near and controlling-near sight on all online and offline available data. It summarizes tasks which were separated until now and it eliminates friction losses which emerge due to parallel set-ups, maintenance and the coordination of different IT systems. The zenon Analyzer:

  • condenses and accounts data from different sources in different formats
  • compares them to one another
  • display the results in graphical form as report

When using the zenon Analyzer, the production process is not interrupted. The zenon Analyzer can be implemented in an existing production system without the need to reconfigure the system. At data collection and report creation the production system continues to run smoothly. The existing infrastructure is embedded in the reporting of the zenon Analyzer independent of the manufacturers.

For accessing the evaluation all you need is a standard Microsoft browser. You do not have to install, adapt or maintain any additional software. You can embed evaluations without any additionally components or plug-ins in the intranet of a company. Default reports are already shipped with the zenon Analyzer. At any time you can create, save and distribute your own evaluations.

More information about the zenon Analyzer can be find in the extra documentation of the zenon Analyzer or can be obtained from your COPA-DATA sales partner: sales@copadata.com.


Licensing

Manual -> Licensing

To be able to use zenon as an editor and/or Runtime, the product must be licensed. zenon runs in Demo Mode until it has been licensed.


License zenon

Manual -> Licensing -> License zenon

To license zenon:

  1. Open Start -> All Programs -> COPA-DATA-> Licensing

    Or:

    In the zenon Editor, open File -> General configuration -> License product ...
    Or:

    Click in the Startup Tool On the Tools, button, select Licensing and then click on Start.

  2. The dialog for entering license data opens.
  3. Select zenon Editor/Runtime
  4. Enter serial number and activation number

    You find the data for this:

    • on your license certificate
    • On the license sticker
    • in the license file License.txt

      Path Windows 7/8: C:\Users\Public\Documents\zenon_Projects\

    Note: Pay attention to capital letters and small letters when entering the data!

  5. After the Editor/Runtime is restarted, use zenon with the license entered

Licensing dialog

Parameters | Description
Editor/Runtime | Active: License is valid for the zenon Editor and/or the zenon Runtime.
Web Server | Active: License valid for zenon Web Server.
Serial number | License serial number. If there is already a license available, its serial number is displayed here. Enter the current serial number here.
Activation number | License activation number. If there is already a license available, its activation number is displayed here.
OK | Import data and start zenon with this license when it is next started.
Cancel | Discard entries and use zenon with the previous license or no license.
Request soft license | Opens the dialog to request a soft license.


Demo mode

Manual -> Licensing -> Demo mode

If the editor is not licensed, it runs in demo mode. Runtime runs in demo mode if it is not licensed.

Demo mode

Conditions

Editor:

The Editor runs:

  • the first 40 times it is started for 30 minutes
  • from the 41st to the 50th Start: 20 minutes
  • from the 51st Start at: 10 minutes

Runtime:

A not-licensed Runtime runs for 30 days or 40 starts according to which comes first.

From the 41st start or the 31st day on, Runtime only runs for 10 minutes.

The user is informed that it is running in demo mode when it starts.

Note: This behavior for unlicensed version is also applicable to the zenon Logic Workbench and Runtime.


Version information

Manual -> Licensing -> Version information

You can see which license you are currently using and which modules are included in this when starting zenon in the start screen or after clicking on Info on... in theHelp menu:

Parameters | Description
Editor version | Editor version number.
Serial number | License serial number.
Activation number | License activation number.
Expiration time (optional) | Information on the expiration date of the license for limited licenses.
Field with modules: | Information on licensed module.

In menu Help the entry Info about opens a dialog box which offers information about the zenon version and the licensing.


Selecting the appropriate license size

Manual -> Licensing -> Selecting the appropriate license size

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The licenses for the Editor and the Runtime are calculated by adding up the necessary TAGs or IOs.

Calculation via TAGs

1 TAG equals 1 variable. For determining the license size, consider the total number of TAGs (= variables) of the following drivers:

  • PLC drivers and bus drivers

Variables of the following drivers do not count:

  • Internal driver
  • system driver
  • mathematics driver
  • simulation driver

You can license TAGs for the Editor and the Runtime in the following gradation:

  • 64 TAGs
  • 128 TAGs
  • 256 TAGs
  • 512 TAGs
  • 1,024 TAGs
  • 2,048 TAGs
  • 4,096 TAGs
  • 8,192 TAGs
  • 16,384 TAGs
  • 65536 TAGs
  • unlimited

A license upgrade to a higher number of TAGs is possible at any time.

Calculation via IOs

License can also be based on I/Os. For determining the license size, consider the total number of IOs of the following drivers:

  • PLC drivers and bus drivers

Variables of the following drivers do not count:

  • Internal driver
  • system driver
  • mathematics driver
  • simulation driver

Calculation

Data type | Valence
1 bit | 1 I/Os
1 byte | 8 I/Os
1 WORD | 16 I/Os
1 DWORD | 16 I/Os
1 float | 16 I/Os
1 string (max. 64 characters) | 16 I/Os

If you cannot find the desired data type in the list, it is because of the selected driver. Some drivers have a specific denotation of the data types. You will find more information in the driver documentation of the driver you use. You will find this either in the online help in the Drivers section, as a PDF file on our installation medium or on our website www.copadata.com in the download section.

Example Example

96 binary and 20 numerical values are to be visualized in zenon:

Multiply the 20 numeric values with 16 and you receive 320 I/Os. Add these to the 96 binary values. As a result you get 416 I/Os, which now are the basis for the license size.

Display in zenon

In the status line of the detail view of the variables the following information can be found:

  • How many I/Os are used currently.
  • How many I/Os are licensed.

An example:

  • 3799/550/1: 3799 entries exist, 550 are listed because of a filter, one entry is selected.
  • For project 22730 an unlimited number of I/Os is licensed.

Note for client license

You can use client licenses if:

  • The start project is a standalone project or a client
  • The start project uses a maximum of 64 days when a license is required, if it is not a client
  • All subprojects are clients


Types of licensing

Manual -> Licensing -> Types of licensing

You can license zenon in different ways:

  • Soft licensing: Requests a unique PC identification number when the editor or Runtime is started.
    Characteristics:
    • The license cannot be stolen.
    • The license is computer related.
    • Practical for notebooks.
  • Dongle licensing: Looks for a hardware dongle at a parallel port or USB port when the editor or Runtime is started.

    Dongles are available as:

    • Workplace dongle:
    • Network dongle: A certain number of licenses are booked on a central dongle on the network, which can be used at the same time as concurrent-use licenses.

    Dongle characteristics:

    • easy handling
    • A license can be taken from one PC to another by simply moving the dongle.
    • No problems due to hard disk failures

info Information

If there is no license or all licenses are are assigned in the network, then the editor or Runtime starts in demo mode.


Soft licensing

Manual -> Licensing -> Types of licensing -> Soft licensing

The soft license assigns a computer with a unique identification. In doing so, certain components of the computer are examined. This license always only works on a certain computer. If it is to be transferred to another computer or too many components on the licensed computer are changed, it must be reissued.

To obtain a software license:

  1. In the File menu, select: General configuration -> License product.
  2. The licensing dialog opens.
  3. Enter the serial number.
  4. Click on Request soft license.
  5. The product licensing dialog opens.
    If this has not yet happened, enter the serial number.
  6. Click on License request for soft licensing.
  7. Enter your contact details.
  8. click on Next.
  9. There are two possibilities for sending these:
    1. automatic
    • Click on the Send to button
    • Select the desired COPA-DATA organization
    • When clicking on OK, the license request is sent by your email program
    • via button Print you can print your copy or send it to a connected fax machine
    1. manually
    • Click on the Finish button
    • The license request is saved as a text file
    • An information window informs you of the name and save location
    • the file is automatically opened in the Text Editor
    • send the email by email or fax to your sales partner

As soon as you have received your license data, reopen the licensing dialog and enter your activation number.


Dongle licensing

Manual -> Licensing -> Types of licensing -> Dongle licensing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With dongle licensing, a dongle is connected directly to the computer for an individual workspace license or to a network computer for a network license. zenon uses two dongle systems:

  • Wibu key
  • CodeMeter

Both systems are automatically included in the installation of zenon. Users who already work with a Wibu key will continue to receive licenses for their Wibu key dongles.

In general, no further settings need to be made for dongles used locally. The use of network dongles may mean that individual configuration is necessary. You can find these in the respective dongle software. For details of this, see the chapters on the Wibu key and CodeMeter.


WibuKey

Manual -> Licensing -> Types of licensing -> Dongle licensing -> WibuKey

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

WibuKey can be used at a single workplace or in a network. The dongle must be active in a USB port or parallel port on the local computer or as a server on a network computer.

To check the settings of the stick:

  1. Open system control
  2. Open Wibu key
  3. Select the stick to be tested on the local computer or on the network

    To list server Wibu boxes in the network, click on the Read in button

  4. Check if the number in the last column of the second row is identical with the starting number of the stick

You can read more about the operation of the stick in the network dongle chapter.


Network dongle

Manual -> Licensing -> Types of licensing -> Dongle licensing -> WibuKey -> Network dongle

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use a Wibu key in the network as a dongle, the server and client must be configured accordingly:

  • Server configuration
  • Client configuration

attention Attention

WibuyKey uses port 22347. This port is fixed and cannot be changed. Note:

  • If a firewall other than that integrated into the Windows operating system is used, this port must be enabled if you wish to use the Wibu key as a network dongle.


Configuring the server

Configuring the server

The Wibu-Key server has to run on the dongle server. The Wibu-Key server can be configured either as an application (e.g. started via Autostart) or as a service.

On installing the Wibu-Key software the options

32 Bit WkNet/WkLAN network server

Install as NT service with Autostart

have to be activated, so that the Wibu-Key server is installed as a service (recommended).

In order to start the Wibu-Key server as an application, a link to the file WkSvW32.exe has to be created in the Windows Autostart.

The file can be found in the folder C:\Programs\WIBU-KEY\Server\.


Configuring a client

Configuring a client

Some network settings for the client have to be entered in the Control Panel. Under Wibu key subsystems, you can select the type of network access you use. We use WkLan.

Under Server Name/IP address either the server name or its IP address or a mask for the IP address is entered. With Browse the list is filled with all found dongle servers.

The entries are processed in the sequence of the list and also can be combined.

If the first entry is a certain server, it is checked, if the dongle server service runs on that PC and if a dongle is plugged in (faster!). If no dongle is found here and the next entry is a filter mask, all PCs in the network going with that filter mask are are tried out.

On the Contents page, the server(s) where the dongles were found should then be listed:


CodeMeter

Manual -> Licensing -> Types of licensing -> Dongle licensing -> CodeMeter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

CodeMeter can be used at a single workplace or in a network. The CodeMeter USB stick must be active in a USB port on the local computer or as a server on a network computer. The dongle firmware must be at least version 1.16 or above.

attention Attention

If the dongle is removed during operation, the editor closes. The editor then opens in demo mode until a valid license is recognized.

To configure, start the CodeMeter control center administration application via: Windows Desktop -> Start -> All programs -> CodeMeter -> CodeMeter Control Center.

The CodeMeter control centre opens with 3 tabs:

Licensecontains information on the dongles found.

Events: Displays the number of sticks connected, the license entries, the firm items found and all access to the CodeMeter Runtime server. To log the entries on a permanent basis, activate the logging entry in the file menu.

Allocation: Configures the allocation of licenses.

License

Parameters | Description
License | Lists all active CodeMeter sticks
Name | Individual name of the stick selected; can be assigned with the button on the right.
Serial no._ | Serial number of the stick selected.
Version | Firmware version of the selected stick.
Status | Status of the selected CodeMeter stick.
Deactivated | The stick connected is deactivated and cannot be used by any application.
Activates when connected | The Stick is activated so long as it is connected; it is automatically deactivated after it is removed from the PC.
Activated | The stick is fully activated and remains activated after it is removed. Recommended status: Ensures that unauthorized persons do not have access to licenses and personal data (such as CmPasswordManager) if the stick is lost.
License updating | Starts the assistant to add, amend and delete licenses.
Eject | Allows the stick to be ejected.
Change password | Enables the password to be changed.
CodeMeter has been started/stopped | Information on whether the CodeMeter service is running. Can be changed in the Action menu.
WebAdmin | Starts the web browser with the administration user interface for network dongles Port 22350 must be open for this, for details, see the chapter on network administration.


Update certified time

Manual -> Licensing -> Types of licensing -> Dongle licensing -> CodeMeter -> Update certified time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can update the certified time saved in the dongle via the CodeMeter time server. To do this, you need an active Internet connection.

To update the time:

  1. Start the CodeMeter WebAdmin
  2. Check your network settings:
    1. Are the proxy settings correct in CodeMeter Webadmin?
    2. Is your access data up-to-date?
  3. Go to the Contents -> CmStick menu
  4. Click on the Update button.
  5. You are notified that all sticks have been updated with this.
  6. Click on OK.
  7. You receive information on the update carried out. In the event of an error message, you primarily check your access data.


Network administration

Manual -> Licensing -> Types of licensing -> Dongle licensing -> CodeMeter -> Network administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For network administration, start the WebAdmin user interface by clicking on the WebAdmin button in the CodeMeter control center. Detailed information on the individual settings can be found in the CodeMeter WebAdmin help pages. You get to this via the Help button in WebAdmin. The most important options and instructions are also in this document:

  • CodeMeter stick administration
  • License administration
  • Saving license data
  • Network settings
  • Proxy settings

attention Attention

CodeMeter WebAdmin uses port 22350. Note:

  • If a firewall other than that integrated into the Windows operating system is used, this port must be enabled.
  • If the port is changed, the WebAdmin surface cannot be started, because the port is part of the address, for example: http://localhost:22350/Content.html?BoxSerial=2-1355435

    In this case, use appropriate freeware tools or standard Windows tools to determine which port is currently being used and enter this address into the address line of the browsers instead of 22350. Then change the port back to 22350 in WebAdmin.


CodeMeter sticks

CodeMeter sticks

WebAdmin starts in Contents/CmStick view.

Here, you select the desired dongle in a drop-down list and can see its data and status as configured in the control center.

Parameters | Description
CmStick | Drop-down list of recognized sticks.
Name | Shows the name given in the control center.
Hardware | Hardware version of the stick.
First drive | Drive information for the stick, drive sizes are only given for sticks with flash memory.
Status | Activation status as defined in the control center.
Certified time | The certified time saved on the stick. is updated using the update button. Note: to update using the CodeMeter Timeserver, you require an active internet connection. Ensure that the network settings are correct, in particular in relation to current access data.
Box time | Internal time saved on the stick.
System time | Local time on the CodeMeter Runtime server.
Free memory | Free memory available on the stick. To defragment the memory, click on the Defragment button.


Licenses

Licenses

You administer your licenses in the Licenses tab in the Contents menu.

  • Select the desired dongle from the drop-down list.
  • You can find information on the licenses of these dongles below the Ing. Punzenberger COPA-DATA GmbH subheading.

Parameters | Description
Product Code | Numerical value for the product. Clicking on the number leads to the details.
Name | Ing. Punzenberger COPA-DATA GmbH
Usage units | If applicable, display of usage units remaining.
Expiration date | If applicable, the expiration date is shown. zenon switches to demo mode after this point in time.
Activation date | If applicable, the activation date is shown. zenon switches to demo mode after this point in time.
Number of licenses | Total number of licenses
  • Click on the number in the Product Code column for details.

Parameters | Description
Dongle number | Must correspond with the number of the active dongle.

Time limits

A dongle can also have a time limit:

  • Expiration date
  • Time period for use

Expiration date

The dongle is equipped with an expiration date.

In the Licenses tab in the Contents menu, the expiration date is given in the expiration date column with the date and time in UTC format.

Time period for use

The dongle is equipped with a specified usage period. This starts from the first time that zenon Editor or Runtime is used. To check the time limit:

  • Navigate to the Licenses tab in the Contents menu
  • Click in the entry under Ing. Punzenberger COPA-DATA GmbH on the digit in the Product Code column
  • The Product Item Details window opens
  • You can see the licensed period and the start date in UTC format in the Usage period line.


Network and Proxy

Network and Proxy

For faultless communication with a Network dongle and the start of WebAdmin, correct network settings are a requirement.

Parameters | Description
Network address | Select an IP address to which the CodeMeter Runtime server should connect. Standard: All. The connection is made to the first CodeMeter Runtime server found. The choice of a defined address is primarily necessary if the computer is functioning as a network license server and has several network cards.
Network port | Port for CodeMeter communication in the network. Standard: 22350 The value can be adjusted individually. In this case, it must be ensured that all CodeMeter Runtime servers use the same port. Recommendation: do not change port.
UDP response time | Maximum response time within which a UDP request must be answered. Standard: 1000 milliseconds.
Start as server | Active: The computer becomes a CodeMeter network server and makes all its licenses available in the network.
Server search list | Here, specific CodeMeter network servers can be defined by entering computer names or IP addresses. Then only the servers defined in the list are searched for. This way, requests from clients are directed to a defined CodeMeter Network server. Note: If a CodeMeter Server is in a different subnetwork, use the IP address for the search list. This search list should only be used if the CM stick cannot be found in the network.

Proxy settings

For access to CodeMeter services in the internet, such as time server, enter the applicable access data for your company here.

attention Attention

CodeMeter notes this access data. If you regularly change your access password, you must also change this in the CodeMeter WebAdmin proxy settings!


Request license

Manual -> Licensing -> Types of licensing -> Dongle licensing -> CodeMeter -> Request license

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To request or update licenses for CodeMeter, select the the Update license button in the Licenses tab in the CodeMeter control center. The license update assistant starts:

Decide if you are:

  • requesting a license
  • entering a license update
  • wish to create a receipt for COPA-DATA

License request

With license requests, you can:

  • extend an existing COPA-DATA license
  • create a new COPA-DATA license

  • To add another COPA-DATA license:
    • Select Ing. Punzenberger COPA-DATA GmbH
  • To create a new COPA-DATA license:
    • enter the CodeMeter FirmCode that you received from COPA-DATA.
  • Select a save location for your license request.


Adapt license

Manual -> Licensing -> Types of licensing -> Dongle licensing -> CodeMeter -> Adapt license

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can adapt the scope of your license concerning extent and runtime at any time. To do this:

  1. order the desired change at COPA-DATA
  2. You will receive a *. WibuCmRaU file for your dongle.
  3. install it:
    1. either via double click on the file
    2. or by dragging the file ion the CodeMeter control center
  4. You will receive a message about successfully updating your license.

    If you receive error message 229, the license on the dongle is already up to date

If it is necessary for your license request to create a .WibuCmRaC file or to install the .WibuCmRaC file with the update manually, follow the instructions in chapter Update license manually.


Request or update license

Request or update license

To update your license manually:

  1. create a .WibuCmRaC file
  2. send the file to COPA-DATA
  3. you will get an updated .WibuCmRaU file
  4. copy this to the dongle

Create WibuCmRaC file

  1. Make sure that the CodeMeter dongle is connected to your PC.
  2. open the CodeMeter control center, e.g. via Start -> Programs -> CodeMeter -> CodeMeter Control Center
  3. on tab License click button Update License
  4. The license update assistant starts
  5. click on Next

  6. select Create license and click Next.

  7. select Enhance existing license
  8. click on Next

  9. in the following dialog click Next again
  10. select the desired location for the appropriated .WibuCmRaC file
  11. click on Apply
  12. the .WibuCmRaC file is created
  13. send the file to sales@copadata.com

Install WibuCmRaU file

You will receive an updated *.WibuCmRaU file from COPA-DATA.

Install the file via double click on the file on the dongle.

Alternative:

  1. open the CodeMeter control center
  2. select install license update
  3. follow the instructions of the installation wizard


Troubleshooting

Manual -> Licensing -> Types of licensing -> Dongle licensing -> CodeMeter -> Troubleshooting

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Error

Solution

zenon only runs in demo mode.

Check

  • your licenses
  • The connection to the network dongle
  • if the license information (SERIAL7= and ACTIVATIONKEY7=) was correctly entered in zenon6.ini. Note any possible blank spaces behind the serial number (SERIAL7=) or the activation key (ACTIVATIONKEY7=).
    Path for zenon6.ini:
    Windows /7/8: %ProgramData%\COPA-DATA\System

Dongle is not found.
  • Check the network settings.
  • If the stick is in another domain, add it to the server list.
  • Increase the UDP response time.
  • If it is a virtual machine, then configure the stick as removable media.
    Attention: Configuration as removable media can - depending on the computer configuration - also lead to a computer no longer booting.
  • Configure the stick as HID.

Certified time cannot be updated.

Please check:

  • Proxy settings, especially access data and Password
  • List of time server under Settings -> time server
    for example: cmtime.codemeter.com, cmtime.codemeter.de, cmtime.codemeter.fr, cmtime.codemeter.us

Error message at updating the license:

Error at updating the CmSticks x-xxxxxxx:
This update can no longer be read in. The content of the CmStick has a newer version, error229.

The update for this license has already been written to the dongle. The dongle is up-to-date.

Windows operating system shows the message:

Low Memory

The dongle is identified as local memory. In some cases, this can lead to the operating system giving the message "Insufficient memory".

This message can be ignored.

Alternatively, the dongle can also be configured as removable media. For details about configuration see the Configure dongle as removable storage device chapter.

Attention: Configuration as removable media can - depending on the computer configuration - also lead to a computer no longer booting.

Windows operating system no longer shows symbol for the Recycle Bin.

This may happen if the dongle is identified as a fixed local network.

Alternatively, the dongle can also be configured as removable media. For details about configuration see the Configure dongle as removable storage device chapter.

Attention: Configuration as removable media can - depending on the computer configuration - also lead to a computer no longer booting.


Configuring the dongle as removable media

Configuring the dongle as removable media

The dongle is integrated into the system as a local data medium as standard. In some cases, this could lead to

  • The operating system reporting too little memory for the dongle
  • the icon for the Windows Recycle Bin no longer being displayed
  • the dongle not being found in virtual machines

This behavior of the Microsoft operating system has no effect on the functioning of Windows or zenon. If the behavior needs to be changed, the dongle can also be configured as removable media. This change is not recommended, because it can also lead to the computer no longer booting.

attention Attention

With configuration as removable media:

  • The booting of the computer can be prevented for with computers that can boot from a USB drive
  • The dongle appears as a drive in the task bar and can be removed (ejected) at any time

Configuring the CodeMeter dongle as removable media

There are two methods available to you to reconfigure the CodeMeter dongle from a local drive to removable media:

  • Using the CodeMeter command prompt
  • With the CodeMeter disk configuration tool

CodeMeter command prompt

  1. Open a CodeMeter prompt:
    Start -> All Programs-> CodeMeter-> Tools-> CodeMeter Command Prompt
  2. Read off the current configuration:
    cmu32 -s <serial> --show-config-disk
    Note: <serial> must be replaced by the serial number of your CmStick, for example 1-123456
  3. Configure the CmStick as removable media.
    cmu32 -s <serial> --set-config-disk RemovableDisk
  4. Remove the dongle and connect it to the computer again

To configure the dongle as a local drive again, use the following command:
cmu32 -s <serial> --set-config-disk LocalDisk

CodeMeter disk configuration

In current versions of CodeMeter from 4.50, the CodeMeter Disk Configuration tool is not supplied. The tool provided with earlier versions can be used however. If you are no longer able to obtain the tool from CodeMeter as a download, you can also contact support@copadata.com.

Configuration with CodeMeter Disk Configuration:

  1. Open CodeMeter Disk Configuration

  2. Select the desired dongle
    (the program only shows locally-installed dongles)
  3. open tab Options

  4. In the Disk Type property, double click on the Local Disk entry
  5. a drop-down list is displayed
  6. select the entry Removable Disk
  7. Click on the Apply Changes button
  8. Remove the dongle and connect it to the computer again


CodeMeter HID support

CodeMeter HID support

CodeMeter supports, from version 5.0, the Human Interface Device (HID) device class of USB standards. CodeMeter dongles can therefore log onto the system as an HID (human interface device) instead of a mass storage device. Special USB host drivers do not need to be installed for configuration, because the functionality is provided by the operating system. HID support is available for all CodeMeter dongles without memory.

Requirements:

  • CodeMeter container with the identification "2-xxxxxxx" (Samsung chips)
  • CodeMeter firmware 2.02 or higher

Mass storage device to HID

To switch USB communication from mass storage device to human interface device:

  1. Check, in CodeMeter WebAdmin, the status in the Content (CmContainer) tab.
  2. A drive is assigned but there is no flash memory.

  3. Call up the CodeMeter command line interface cmu: Start -> Program Files -> CodeMeter -> Tools -> CodeMeter Command Prompt.
  4. Enter the following commands in the command line interface that has been called up:

    cmu32 /s [Boxenmaske-Seriennummer] --set-config-disk HidCommunication

  5. The current status is displayed in the following output from the command line interface:

    cmu32 - CodeMeter Universal Support Tool.

    Version 5.00 of 2013-Jan-30 (Build 1039) for Win32

    Copyright (C) 2007-2013 by WIBU-SYSTEMS AG. All rights reserved.

    - CmStick/C with Serial Number 2-2251132 and version 2.01

    Version: 2.01

    Flash Size: no real flash available

    Virtual Drive: E:

    Configuration: LocalDisk with ActivePartition

    File System: FAT32

    Communication: Mass Storage Device

    Boot-Code: Int18 Boot Code

    Mdfa: 0x539

  6. Remove the dongle from the computer.
  7. Reconnect the dongle to the computer.
  8. In the CodeMeter Control Center, the switch to HID is shown in the Events tab.

  9. Check the drive in CodeMeter WebAdmin, in the Content/CmContainer tab. Nothing should be entered.

HID to mass storage device

To switch the USB communication from human interface device (HID) to mass storage device:

  1. Check, in CodeMeter WebAdmin, the status in the Content (CmContainer) tab.
  2. No drive is assigned.

  3. Call up the CodeMeter command line interface cmu: Start -> Program Files -> CodeMeter -> Tools -> CodeMeter Command Prompt.
  4. Enter the following commands in the command line interface that has been called up:

    C:\Users\fs>cmu32 /s [box mask-serial number] --set-config-disk MsdCommunication

  5. The current status is displayed in the following output from the command line interface:

    cmu32 - CodeMeter Universal Support Tool.

    Version 5.00 of 2013-Jan-30 (Build 1039) for Win32

    Copyright (C) 2007-2013 by WIBU-SYSTEMS AG. All rights reserved.

    - CmStick/C with Serial Number 2-2251132 and version 2.01

    Version: 2.01

    Flash Size: no real flash available

    Virtual Drive: No drive assigned (HID)

    Communication: Human Interface Device (HID)

    Please replug your CmDongle to apply the changes.

  6. Remove the dongle from the computer.
  7. Reconnect the dongle to the computer.
  8. In the CodeMeter Control Center, the switch to MSD is shown in the Events tab.

  9. Check the drive in CodeMeter WebAdmin, in the Content/CmContainer tab. A drive is entered but there is no flash memory.


Command line parameter for licensing tool

Manual -> Licensing -> Command line parameter for licensing tool

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The licensing tool can be controlled with the following flags as parameters:

Passing over a parameter is done by putting a `/` or a `-` before the parameter:

for example: /silent or -silent

Parameters | Description
request | forces the program to omit the first dialog and go straight to the dialog for requesting the activation key (it does not matter if the flag /silent or -silent is also used)
sernum:<num> | forces the program to use the serial number which is passed with <num> for licensing instead of reading the number from the zenon6.ini file.
actkey:<key> | forces the program to use the activation key which is passed with <key> for licensing instead of reading the key from the zenOn6.ini file.
silent | forces the program to not show a dialog. The file License.txt is still created.
mailto:<addr> | works only in connection with the flag silent and forces the program to send the license request to the specified address <addr> via e-mail.


Remote licensing

Manual -> Licensing -> Remote licensing

To allocate a license to a computer via remote connection:

  1. in the context menu of the project select Remote Transport -> Change password and display licensing
  2. start the Remote Transport
  3. as soon as the connection is established, the licensing of the remote computer is displayed

  4. enter the serial number and the activation number of your license form
  5. confirm the input by clicking OK


Characteristics of the Server Client operation

Manual -> Licensing -> Characteristics of the Server Client operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Licensing of modules in the server client operation has the following characteristics:

Historian

The following cases are distinguished:

  • Server and client licensed: Archives can be opened and edited at the client
  • Server licensed and client not licensed: Archives can be opened but not edited at the client
  • Client not licensed and started as standalone: Archive window can be opened; the individual archives cannot be opened

Automatic Line Coloring

The following cases are distinguished:

  • Server licensed and client not licensed: ALC functionality is available unrestrictedly
  • Client not licensed and started as standalone: ALC functionality is not available

info Information

If the Server is licensed for the Energy Edition, ALC is also licensed.

Batch Control

The client gets the license from the server and does not need its own license. If the server does not have a license of its own, the client cannot use the module.

Load Management

The following cases are distinguished:

  • Server licensed and client not licensed: Load ManagementEMS functionality is available without restriction
  • Client not licensed and started as standalone: Load ManagementEMS functionality is not available

Message Control

The client gets the license from the server and does not need its own license. If the server does not have a license of its own, the client cannot use the module.

Everywhere Server by zenon

Everywhere Server gets the license of the Runtime. The license for Everywhere Server is issued by Runtime. The Everywhere Server can not be used, If the Runtime does not have a corresponding license.

For this reason, it may happen that the Runtime is running, but the Everywhere Server can not be started because of missing license rights. In this case, please use the licensing tool in order to receive a corresponding license.


Golden thread through the help - an overview

Manual -> Golden thread through the help - an overview

The more powerful the control system, the more voluminous the according help.

In difference to all the other chapters, where features and functionalities are explained, this chapter should help you to find your way through our help.


Which help chapters for the start

Manual -> Golden thread through the help - an overview -> Which help chapters for the start

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

info Information

This chapter is designed for all those, who use zenon for the first time and wonder which help topics are useful for the beginning. Here you will learn about the steps needed for a simple basic project. The according information from the tutorials and the manual are linked to the according steps.


The Editor

Manual -> Golden thread through the help - an overview -> Which help chapters for the start -> The Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon:

zenon consists of two parts:

1. Editor
(operating system): Here the projects are created.

2. Runtime
: There the created equipment can be monitored and operated.

Structure of the Editor:

The Editor´s user interface consists of different areas:

Element

Contents

01 - Toolbars:

A collection of Tool bars for the Editor and its modules. They are available for:

  • Dockable windows
  • Alignment
  • Screens / Symbols
  • Editor profiles
  • Elements
  • Menu bar
  • Production & Facility Scheduler
  • Remote Transport
  • Report Generator
  • Runtime Files
  • Visibility levels
  • VBA macros

02 - Project Manager:

Tree view of the Project Manager.

03 - Detail view of the Project Manager:

Details for the module selected in the Project Manager.

04 - Main window:

Main work space; here documents such as screens or reports are displayed.

05 - Toolbar elements:

Toolbar for screen elements - vector elements and dynamic elements.

06 - Properties

Displays the properties of a selected object. Three modes are available and can be selected from the Properties toolbar.

07 - Properties help:

Displays short help messages for properties of screens, variables, functions and other elements which can be engineered.

08 - Output window

Messages are displayed here if projects are compiled and sent to Runtime.

09 - Status bar:

Shows status information for Editor readiness and screens.

10 - Toolbar properties:

Defines display and sorting options of the properties, shows Properties help.

11 - Cross-reference list:

You choose which windows are shown:

  • in the Drop-down list under Options or

The arrangement of the windows can be adjustedindividually. Just the main window cannot be hidden.

The next step:

In order to learn more about creating a project click the link in the box.

seealso See also

Creating a project


Creating a project

Manual -> Golden thread through the help - an overview -> Which help chapters for the start -> Creating a project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Creating the workspace:

The workspace is the basis for one or more projects.
How to create a new workspace is described in the Tutorial Basic.

Creating a project:

Then a new project is created in the workspace. A project is a self-contained and executable entity of engineering elements (e.g. screens, variables, functions, etc).
You can find more information on creating a project in the Basic Tutorial tutorial.

info Information

Now you are able to create a project.

The next step:

You project should also get screens? Click the link in the box below.

seealso See also

Frames and screens


Frames and screens

Manual -> Golden thread through the help - an overview -> Which help chapters for the start -> Frames and screens

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Creating a frame:

Frames define the screen area, in which the screens are opened then. Each screen is based on a frame.
You will find more information on creating frames in the Tutorial Basic and in the chapter Frames.

Creating a screen:

zenon offers different pre-defined screen types, so also the simplest "Standard", where a screen area can freely be defined. For the graphical design of the screens there are hardly any limitations.
Simply select the pre-defined screen elements to display your equipment schematically in the screen.

Extending the screen with screen elements:

zenon offers pre-defined vector and dynamic screen elements, which can be linked with functions or variables.
You will find more information on the picture elements in the Basic Tutorial; the different shapes of the pre-defined screen elements are described in detail in the Screen elements chapter.
Another possibility to save time in the engineering phase are pre-defined symbols, which you will find in the symbol library. You will find more information on symbols in the chapter Symbols and Element groups.

info Information

You now can create a new project with screens and screen elements.

The next step:

Your screen elements should display "real" values and you want to be able to monitor your equipment in zenon? Click the link in the box below.

seealso See also

Drivers and variables


Drivers and variables

Manual -> Golden thread through the help - an overview -> Which help chapters for the start -> Drivers and variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Selection of a driver

Variables are based on drivers, so a Driver has to be selected first. During the engineering phase usually one of the simulation drivers is used. Later it is replaced by the driver for the according PLC. As an open and independent system, zenon already supports more than 250 communication protocols and drivers. You can find detailed information on the individual drivers in the corresponding driver documentation. You can find these in the online help in the Driver section.

Creating a variable

Variables are the interface to the process data and represent certain measurement values or status. In order to make aware of critical events in your process, limits can be defined for variables.
You will find more information on creating a variable in the Tutorial Basic. You will find an extensive description of variables datatypes and reaction matrices in the chapter Variable definition and process data model.

Displaying values in screen elements

Screen elements can be linked to variables in order to display incoming values.
You will find more information on linking variables with dynamic screen elements in the Tutorial Basic. In the chapterScreen elements you will find a link to the dynamic - and vector screen elements of zenon.

info Information

You now have an insight on how to use variables and drivers.

The next step

You not only want to monitor but also operate? Functions have to be created and linked to be able to operate zenon.

seealso See also

Functions


Functions

Manual -> Golden thread through the help - an overview -> Which help chapters for the start -> Functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Creating a function:

Functions are the basis for operating the equipment in the Runtime. For example, they allow you to switch between the individual process screens or to change values.
Several functions can be combined and administered in a script. You will find more information on scripts in the chapter Scripts.

Linking a function to a dynamic screen element:

You will find more information in the Basic tutorial. As zenon offers a great variety of different functions, they are listed and explained in the chapter Functions overview. Additionally you will find a short description in the dialog Function new.

info Information

Now you are able to create a simple project. You can create a screen, link variables and functions to screen elements and also display limit violations.

The next step:

Time to see, what has been engineered? Click the link in the box below.

seealso See also

Starting the Runtime


Starting the Runtime

Manual -> Golden thread through the help - an overview -> Which help chapters for the start -> Starting the Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

From the Editor to the Runtime

What has been engineered in the Editor, can be monitored and operated in the Runtime. So we leave the development environment (Editor) and start the Runtime.
You will find more information on starting the Runtime in the Tutorial Basic and in the chapter Runtime.

info Information

Now you can design your projects and then monitor and operate your equipment.

More?

This of course was only a short glimpse on the possibilities offered by zenon. You want to know and to learn more? Click the link in the box below.

seealso See also

Extended Possibilities


Extended Possibilities

Manual -> Golden thread through the help - an overview -> Which help chapters for the start -> Extended Possibilities

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Here you can find numerous possibilities that you can implement with zenon:

You want to ... | No problem!
... call attention to critical process events (limit violations)? | Alarm configuration
... analyze alarms? | Industrial Performance Analyzer
... log process and system events? | Chronological Event List
... log changes in the project? | History of changes
... record and concentrate process data? | Historian
... color and dynamize lines? | Automatic Line Coloring (ALC)
... create a FDA conform user administration (password system)? | User administration
... analyze log files? | Diagnosis Viewer
... display values from the process as curves? | Extended Trend
... administer maintenance data of machines? | Industrial Maintenance Manager
... send message? | Message Control
... create a client/server network? | Network
Development environment | Editor
... import/export parts of the project? | Import/Export
... execute actions at a defined time? | Production and Facility Scheduler
... create reports? | Report Generator
... create parameter lists for set values and commands? | Recipes
... define a function sequence? | Script administration
... execute functions at a defined time? | Time control
... switch the language of the text information displayed in the Runtime? | Language switch
... control the access to certain zenon objects in Runtime with the help of variables? | Interlockings
... program cyclic tasks? | Process Control Engine (PCE)
... getting to know the integration of zenon Logic? | zenon Logic Workbench
Data exchange on ERP level? | SAP interface


Online updating of the zenon Help:

Manual -> Golden thread through the help - an overview -> Online updating of the zenon Help:

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Documentation Download Tool administers the updating of your online help including embedded help, dialog help, tooltips and the PDF product documentation from zenon and zenon Logic.

The updating is carried out online. An internet connection is necessary for this.

Contents of the documentation update:

The Documentation Download Tool supports the updates of:

  • zenon and zenon Logic product documentation
  • Driver Documentation
  • Tutorials
  • Glossary

File formats of the documentation update:

The Documentation Download Tool supports the updates of:

  • Online help for zenon and zenon Logic (.chm)
  • zenon product documentation (.pdf)

Note: The tool is only available in English

tutorial License information

Part of the standard license of the Editor and Runtime.


Guideline through the help

Manual -> Golden thread through the help - an overview -> Guideline through the help

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Here you will find an overview over the chapters of the online manual and a short introduction in the terminology of zenon. You can find notes on efficient project configuration in the Configure projects efficiently with zenon manual.

Parameters

Description

Alarm configuration

Critical process events
Alarming is used within the overall system to draw attention to critical process events and to support the user in localizing and eliminating them.

History of changes

Documentation of the engineering, Audit trail
The history of changes serves for complete documentation of the phase of engineering. The changes (e.g. change, delete, create) that are made can be logged.

Equipment Modeling

Depicts the structure and equipment and makes it possible to correctly assign details to the lower level (such as machines, recipes and processes) and to see the relationship. Complies with the standards ISA S88 and S95.

Historian

Recording process data
The objective of archiving is the recording and free multi-stage summarizing (average, total, maximum and/or minimum) of the process data in connection with a flexible and user-friendly editing level conforming to the system.

Automatic Line Coloring

Topological coloring of lines (
the automatic coloring of lines) allows easy automatic dynamizing of tubes in technology (for media) as well as in the energy distribution (for electricity).

Batch Control

The module Batch Control offers the possibility to automate batch-orientated manufacturing processes for lot products.

User administration

zenon password system supports user administration for the editor (chapter Project) and for online operation (Runtime). With its password system it supports the requirements of the FDA (Food and Drug Administration, Part 11).

Screens

The main element of a project is the screens which are to provide the operator with the most comprehensive level of information about the plants that are operated.

Chronological Event List

Operation journal, Audit trail,
all process and system events as well as user inputs can be logged in the Chronological Event List.

Controls

Integration for your own .NET user controls, ActiveX and WPF elements. Offers possibilities to access the zenon API.

Diagnosis Viewer

Reporting Tool
Allows the reading of existing zenon log files, online logging, saving of the current view, parameterizing the Diagnosis Client and the Diagnosis Server.

Dynamic screen elements and Vector screen elements

Vector and dynamic elements
zenon offers two different types of screen elements: Vector and dynamic screen elements. All elements can be dynamized.

Editor

project environment
The control system consists of Editor and Runtime: The development environment, the Editor, and the online display, the Runtime. Projects are created in the Editor, operation and monitoring is done in the Runtime.
Detailed description of the zenon engineering system, the Editor.

Energy Edition

A package with special functions for energy and process technology (such as Automatic Line Coloring).

Extended Trend

Display of values as curves
The extended trend serves for the representation of the online (HD management) and historical values (archive values) of process variables and derived process variables.

Functions

Predefined macros which can be easily used and parameterized by engineers and that can serve for modifications in zenon
User modifications in zenon are implemented via user-defined project functions. All functions used in a project are based on the existing system functions.

HTML

Display as HTML pages
The use of a screen for the display of HTML pages offers all the possibilities of the Microsoft Internet Explorer.

Import/Export

Parts of a project can be imported to zenon or exported from zenon. The format of the export file is *.XML.

Industrial Maintenance Manager

Administration of maintenance data
The Industrial Maintenance Manager helps administer machine and maintenance data. Service intervals can comfortably be planned and administered. You can see at a glance which device, equipment, machine, etc. has to be maintained today / this week / next month etc. Additionally service work done in the past is logged.

Industrial Performance Analyzer

Alarm evaluation
The Industrial Performance Analyzer locates and minimizes weak points (downtimes) of equipment.

Installation and updates

Information for the installation of zenon on different operating systems (such as Windows CE, .. Embedded, etc.)

Keyblock Runtime Start

A program that starts zenon Runtime and blocks all Windows system keys.
Users work in zenon Runtime and have no access to the operating system level.

Keyboards

Virtual keyboard
Using a screen of the keyboard screen type allows you to create a freely definable virtual keyboard.

Configuration files

Information for system administrators, who directly want to edit the INI files.

Load Management

For implementation of energy supply management for small and medium-sized power supply companies and also for industrial firms whose energy supply is arranged by special contracts.
Can be used for both forecasting and optimization.

Licensing

To be able to use zenon as an editor and/or Runtime, the product must be licensed.
zenon runs in Demo Mode until it has been licensed.

measuring unit conversion

Enables conversion and switching of base units into conversion units, for example meters into yards or meters into decimeters, centimeters and millimeters.
For the conversion units, a factor, an offset and a shift of the decimal point can be defined for conversion units, based in the relevant base unit.

Menu administration

The menu editor allows creating Windows compliant menus.

Message Control

Sending of messages via SMS, voice message or email
The task of this module is to send messages to different recipients.

Mobile applications for zenon

With the mobile applications, you can visualize your zenon projects on mobile end devices, tablets and desktop computers.

Monitor configuration

Multiple monitor system
With the zenon monitor administration of the control system you can define for each workplace if the target system of the project is equipped with one or multiple monitors.

Multi-Touch

With zenon, touch screens can also be operated with Multi-Touch gestures. Multi-Touch gestures for zooming and scrolling are suitable for navigation on touch panels in the worldview.

Network

Client/server model
The control system works as a client/server system or as a multi-hierarchical system with substations, main stations and headquarters in network environment.

Notepad

Output of logs and text files.

OPC server

The OPC server makes the variables of the project available for standard OPC client tools.

PLC Diagnosis

With the PLC Diagnosis program details of a PLC can be displayed directly in a screen of the control system. Depending on the PLC different functionalities are available. At the moment, there is the Simatic S7 Graph step chain analysis for the display of step chain information of S7 PLCs and the zenon Logic Monitoring Viewer for the display of all programs being executed in the zenon Logic Runtime.

Process Gateway

The Process Gateway serves as a coupling to higher-level systems. Parts of the zenon process image of other applications can be made available and be updated.

Production and Facility Scheduler

Schedules, switching clocks
The Production & Facility Scheduler (PFS) allows executiong actions (e.g. changing of a variable's set value, executing a function) for a period of time or in a time grid.

Programming interfaces

zenon provides different interfaces such as VBA, VSTA or .Net to include your own programs or to automate project configuration.

Project conversion

Information on compatibility, including instructions for the correct conversion of older zenon versions.

Project backup

Back up and restore existing projects.
Project backups can then be restored to the same or another computer. Project backups can also be versioned.

Project simulation

Offers the possibility to switch between simulation mode and hardware mode. In simulation mode, switching actions are executed, recipes are sent, set values are defined etc. without these operations actually being sent to the process (such as to a control unit for example).

Project manager

Information on project creation, project administration
Back up and restore projects, global projects, configuration, Remote Transport

Process data model and variable definition

Variables are the interface between the data source (PLC, field bus, etc.) and zenon.
Variables, data types, drivers, reaction matrices

Cross reference list

Project overview
The Cross Reference List serves to generate a project overview in table format. For example, it is possible to see which variables are used in what screens in the Cross Reference List.

Remote-Transport

The Remote Transport is used to transport Runtime files to a target system. This ensures that all necessary files are transferred to the target system.
Other functions (such as incremental copying, transferring of status) are available.

Reporting with the Report Generator and

documentation, evaluation and presentation of process data on the basis of online and archive data from zenon. Reporting is divided into:

  • Report Generator
  • Report Viewer

Recipes

Input lists for set values and commands
Recipes serve for the assembling of input lists for setpoint values and commands, which are executed with a function call in online operation.

Recipegroup Manager

In addition to the standard recipes, the Recipegroup Manager offers more functionalities, such as free layout, free grouping.

Runtime

Online operation, Runtime
The control system consists of Editor and Runtime: The development environment, the Editor, and the online display, the Runtime. Projects are created in the Editor, operation and monitoring is done in the Runtime.
Online operation in the Runtime

Runtime help

zenon offers the possibility to create a context-sensitive help for projects running in the Runtime.

SAP interface

zenon and SAP communicate using a two-way interface.
The control system sends messages for any desired processes to the SAP application (such as monitoring stock in real time).

Command sequences

Commands from the Command Sequencer module can be compiled into processes in Runtime and visualized. User interactions can also be executed.

Scheduler

Time-triggered function calls
The Scheduler is loaded, if the module PFS is not licensed. Its functionality is similar to the PFS, but the functional range is limited. The Scheduler allows the automatic execution of actions at a defined time.

Fonts

Fonts existing in the operating system can be used in zenon.

Script administration

Function sequence
If several user defined functions should be connected in a sequence, they must be combined into a script.

Language switch

Allows the language of text information to be switched between different languages in the Runtime.

Status processing

Attribute for variables
It is possible to issue a status for each variable with status processing. A total of 64 status bits are defined. The most common are spontaneous, invalid, manual value and replacement value.

zenon Logic Runtime

The zenon Logic Runtime interprets the compiled code (PLC code) of the zenon Logic Workbench. The Runtime runs on Windows 7/8 and 7 Embedded PCs, as well as Windows CE platforms.

zenon Logic Workbench

zenon Logic is an IEC 61131-3 programming environment. With zenon Logic development environment - the Workbench - PLCs can be engineered and programmed in the five defined languages of IEC 61131-3.

Driver simulation

If the underlying process is not available when configuring, this can be simulated and tested in advance.

Tools

A range of tools support you for the management, analysis and configuration of zenon:

  • Diagnosis Viewer: Allows zenon LOG files to be read and configured.
  • Keyblock Runtime Start: Starts zenon Runtime and at the same time blocks all Windows system keys.
  • Online updating of the zenon Help: Allows online updating of zenon Help.
  • Project Translation Interface: Tool for the translation of zenon language files. Opens or saves data for the zenon Language Translation Wizard. With this, projects can be imported into or exported out of zenon.
  • Startup Tool: Makes it possible to start the Editor and Runtime with certain parameters, to administer different zenon versions on one computer, to administer SQL instances and to define languages for Editor and Runtime.
  • System Information Collector: Reads system information and zenon information, displays it in an output window and saves it as a ZIP file.

The following are available for zenon Logic:

  • zenon Logic Runtime Manager: Administer all stand-alone/manual-start zenon Logic Runtime projects on your computer.
    The documentation for this tool is part of the zenon Logic documentation.

Variables

Variables, also called process variables or data points, are the interface between the data source (PLC, field bus, etc.) and zenon. They represent certain measured values or states of the hardware, including properties such as scaling, limit values, etc.

Interlockings

Access authorizations
Interlockings control the access to certain zenon objects during Runtime via variables.

Distributed engineering

Multi-user administration, distributed engineering
The zenon distributed engineering functionality makes it possible for multiple users to work on the same project at the same time.

Video

.avi files in zenon
Online and saved video recordings (*.avi) can be replayed by using a screen for playing videos.

Worldview

Scrolling on large screens.
By using the “Worldview overview” screen type, it is possible to scroll in standard screens that are larger than the screen resolution. Here it is also possible to zoom and depending on the zoom steps to show and hide detail information in the screen. (Zooming, panning, decluttering).

Wizards

Assistants for project support
In order to be able to handle recurring tasks in the project configuration phase phase easily and quickly, zenon offers wizards for different tasks. Users can create wizards for individual tasks.

Time control

In the time control, you can define all function calls that should be executed at a defined time or cyclically.

zenon Remote Desktop

With the zenon Remote Desktop, a remote desktop connection to a remote target system is established in order to administrate a remote computer easily.
You will see the desktop exactly as it looks on the target system.

The zenon Remote Desktop offers two connection types: one for "watching only" and one for "operating" the remote system.

zenon Science Package

The zenon Science Package makes it possible to program LEGO Mindstorms NXT 2.0 / EV 3.0. Programs are created in zenon Logic and executed on the LEGO Controller with zenon Logic, an IEC 61131-3 programming environment integrated into
zenon.

zenon Web Server and zenon Web Server Pro

The zenon Web Server gets projects onto the internet or intranet in exactly the same form. For the transfer no project adaptations are required. Contrary to the zenon Web Server Pro, the zenon Web Server only offers viewing functionality.
The zenon Web Server Pro offers complete viewing and operating functionality. It is possible to directly engage in processes over the web.

zenon for Windows CE

The zenon CE Runtime can run on different CE hardware platforms. Generally, the CE version of zenon offers the same functionalities as the PC version of zenon, however with some limitations which result from the lower hardware resources.

Allocations

Value transfer
The routing of the current value of a process variable to a second variable within a driver or across drivers is implemented with the use of allocations.


Functionality of the online help - So I find, what I need

Manual -> Golden thread through the help - an overview -> Functionality of the online help - So I find, what I need

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

It sometimes happens, that information is documented in the online help, but cannot be found with the search functionality.
So you here find a short introduction, how you can successfully search and most of all find information in our online help.

Search strategies

  • As a default help starts on tab Contents. Here you will find the entire documentation (online manual, tutorials, and driver documentation) in a tree structure.
  • Tab Search allows searching for certain terms by entering them in the search field.
  • You can save your favorite help chapters in the Favorites tab. Simply switch to the desired chapter in the Contents tab or find it with Search (double-click it) and then switch to Favorites. The selected help chapter will now be proposed under Current topic and can be added to the favorites.

Searching for words and phrases:

Parameters | Description
Single word | e.g. alarm Chapters containing the word "alarm" are listed. The grammatical variations of this word are also searched for.
Phrase | e.g. "alarm administration" Chapters are searched for the complete phrase "alarm administration". Without quotation marks chapters containing both words alarm AND administration (but not necessarily together) would be found.
Extensions | e.g. alarm* Chapters are searched for words starting with "alarm". The asterisk (*) can also be in front of the word to be searched for (e.g. *alarm)
Replace | AND Both words should appear in the same chapter. e.g. Alarm AND CEL Chapters that contain both words are displayed.
 | OR At least one of the words should appear in the chapter. e.g. Alarm OR CEL Chapters containing either the word "alarm" or the word "CEL" or both are listed.
 | NOT Only one of the words in the chapter e.g. Alarm NOT CEL Chapters containing the word "alarm" but not the word "CEL" are listed.
 | NEAR Both words in the same chapter, near to each other e.g. alarm NEAR CEL Chapters containing both words "alarm" and "CEL" with a maximum distance of eight words.


Editor

Manual -> Editor

zenon consists of two main components; Editor and Runtime. Projects are created in the Editor, operation and monitoring is done in the Runtime. The Editor is available as a 32-bit version and a 64-bit version from zenon 7.10. Projects can be edited with both versions. You can read details on compatibility with versions of zenon 7.10 in the Project conversion manual, in the 64-Bit version chapter.

In this Editor handbook, you get to know the the essential components of the Editor and information about using the Project Manager, tool bars, menus and Editor profiles. You can find more information about the context menu of the elements in chapter Screens.

tutorial License information

The zenon Editor must be licensed. The license is calculated according to the used TAGs or IOs. For details about licensing see chapter Licensing.

The Editor is available as zenon Supervisor and as zenon Operator. The versions differ in their functionalities. For details see Restrictions for zenon Operator.

Amendment to the size setting of the operating system

If the Change size of all elements property is executed in the Control Panel of the operating system or a resizing level is selected manually, then:

  • The selected enlargement factor in the zenon Editor is taken into account
  • The size and positioning of the objects is amended

SQL Server

zenon Editor works with an SQL database. This is also installed when the zenon Editor is installed. To make a connection, the Editor connects to the zenon SQL server (zenDBSrv.exe). This makes the connection to the SQL server.

Multiple monitor operation

If several monitors are in use on one PC, dialogs, toolbars etc. can be moved to other monitors. Their position is saved and retained for when the editor is next started.

info Information

If only the main monitor is available when the editor is restarted, elements that are moved may not be displayed in a visible area. To arrange all elements back on the main monitor again, activate the standard profile. This can be used to revert the positions to the default values.


Start editor

Manual -> Editor -> Start editor

You have multiple options to start the Editor:

  • Click on the zenon symbol on your desktop.
  • Use the Windows menu file -> COPA-DATA -> zenon Editor.
  • Start using the Startup Tool. This tool allows the administration of multiple versions of zenon and the configuration of the Editor and the Runtime before you start.
  • Using Windows Autostart.
  • Double clicking on a workspace file (.wsp6). The 32-bit version of the zenon Editor is thus always opened.

Dienst zenAdminSrv

The zenAdminSrv service must be started to start the editor. If the service is not available, you will see the "Editor cannot be started because the 'zenAdminSrv' service cannot be located!" error message. Activate the service and restart the editor.

When starting using Windows Autostart, zenon tries to start the editor five times and then cancels this with the error message, stating that the service cannot be located.


Compatibility

Manual -> Editor -> Compatibility

The zenon Editor is fully backwards compatible. Projects that were created with an earlier version can be opened and edited at any time.

When opening a project with a lower version number:

  • the project is automatically converted
  • a backup of the project is automatically created

Attention: Converted projects can no longer be opened in an editor with a lower version number. The project backup created during conversion can still be opened and edited.

Compatibility between the Editor and Runtime:

With the zenon Editor, Runtime files can be created for different versions of Runtime. The Runtime version therefore does not need to correspond to the Editor version. This backward compatibility is particularly suited for use of mixed systems. For example: A project that was planned with Editor 6.50 can also be started with Runtime 6.22.

attention Attention

If, in a project with a later version of the Editor, properties are shown that are not available in the earlier version, these are not available. This can lead to unwanted results in Runtime.

Creating Runtime files

To create Runtime files in the editor for earlier versions:

  1. Select the project in the project tree
  2. Navigate to the General section in project properties
  3. Open the Create RT files for property drop-down list
  4. Select the desired version:
    • Default: The Runtime files are created for the current version of the editor
    • 6.20 SP4: The Runtime files are created for version 6.20 Service Pack 4.
    • 6.21 SP0: The Runtime files are created for version 6.21 Service Pack 0.
    • 6.21 SP1: The Runtime files are created for version 6.21 Service Pack 1.
    • 6.22 SP0: The Runtime files are created for version 6.22 Service Pack 0.
    • 6.22 SP1: The Runtime files are created for version 6.22 Service Pack 1.
    • 6.50 SP0: The Runtime files are created for version 6.50 Service Pack 0.
    • 6.51 SP0: The Runtime files are created for version 6.51 Service Pack 0.
    • 7.00 SP0: The Runtime files are created for version 7.00 Service Pack 0.

Attention: In order to ensure consistency of Runtime files, all Runtime files must be newly created each time this property is changed. The configurations for all drivers are converted. Settings that do not exist in the respective version are set to the default setting.

XML

Data exported in XML is then available for import into later Editor versions.

Exception: If data from the RGM is saved to Runtime directly as an XML file using the export function, this cannot be reimported.


User interface

Manual -> Editor -> User interface

The Editor´s user interface consists of different areas:

Element

Contents

01 - Toolbars:

A collection of Tool bars for the Editor and its modules. They are available for:

  • Dockable windows
  • Alignment
  • Screens / Symbols
  • Editor profiles
  • Elements
  • Menu bar
  • Production & Facility Scheduler
  • Remote Transport
  • Report Generator
  • Runtime Files
  • Visibility levels
  • VBA macros

02 - Project Manager:

Tree view of the Project Manager.

03 - Detail view of the Project Manager:

Details for the module selected in the Project Manager.

04 - Main window:

Main work space; here documents such as screens or reports are displayed.

05 - Toolbar elements:

Toolbar for screen elements - vector elements and dynamic elements.

06 - Properties

Displays the properties of a selected object. Three modes are available and can be selected from the Properties toolbar.

07 - Properties help:

Displays short help messages for properties of screens, variables, functions and other elements which can be engineered.

08 - Output window

Messages are displayed here if projects are compiled and sent to Runtime.

09 - Status bar:

Shows status information for Editor readiness and screens.

10 - Toolbar properties:

Defines display and sorting options of the properties, shows Properties help.

11 - Cross-reference list:

You choose which windows are shown:

  • in the Drop-down list under Options or

The arrangement of the windows can be adjustedindividually. Just the main window cannot be hidden.


Adjust view

Manual -> Editor -> User interface -> Adjust view

All editor windows can be individually grouped. The properties for window grouping can be opened by right-clicking on the window border. Your own settings can be saved as Editor profiles.

Window context menu

Options

Status

Function

Undocked

active

The selected window can be freely positioned on the desktop. It is displayed in the main window. You can show multiple windows in the Main Window and switch between them.

Double-clicking on the title bar switches between Unanchored and Dock.

inactive

(default)

The selected window is docked. The dock property is active.

Dock

active

(default)

Windows can be moved anywhere you want while the left mouse button is pressed. When being moved, a Positioning aid shows the position where the window is to be inserted. On releasing the mouse button, the window is docked on to the surrounding windows.

When switching from Unanchored to Dock, the window is inserted to its last docked position.

Double-clicking on the title bar switches between Unanchored and Dock.

Hint: If you want to move a window without docking it, hold Ctrl during moving. In this case, no positioning aid is displayed.

inactive

Windows can be moved anywhere you want while the left mouse button is pressed. On releasing the button, they are shown on the relevant location in the foreground.

The Unanchored property is active.

Display in main window

active

The window is displayed in the main window as a tab.

All tabs are displayed in the main window. You change between the individual tabs by clicking on the window titles.

To display a tab as a window again, open the context menu with a right click on the window title and switch the Switch in main window property to Inactive.

inactive

(default)

The window is displayed normally.

Fade out automatically

active

As soon as the window loses the mouse focus, it is placed into the background. The window title is displayed in the left border of the editor.

To put the window back into the foreground, move the mouse over the window title.

inactive

(default)

The window is always displayed in the foreground.

Close

The selected window is closed.

To show it again, choose Menu bar -> Options > Window name


Position window

Manual -> Editor -> User interface -> Position window

Positioning

All windows in the zenon Editor can be positioned wherever you want on the desktop using:

  • Drag & drop: Windows are dragged to the desired position and either placed freely (unanchored) or docked.
  • Double-clicking on the title bar: switches between Unanchored and Dock.

Positioning aids

When moving windows from the Editor interface, positioning aids are displayed. These represent windows or their borders.

This element represents a window area in the Editor.

This element represents the border area of the Editor.

Position window

To position an element as docked:

  1. Move the element with the mouse into the desired area
  2. The positioning aid is displayed
  3. This represents a window and its areas:
    1. Center: whole window
    2. Top: upper half
    3. Bottom: lower half
    4. Right: right half
    5. Left: left half

    or the border of the Editor

  4. Move the mouse to the central positioning aid or to a positioning aid on the border of the editor and from there to the desired area
  5. The area in the Editor where the element was placed when the mouse button was released is colored in blue
  6. Move the mouse within the positioning aid to the desired area that is displayed in blue
  7. Let the mouse button go and the element is placed
  8. If a window is placed on a pre-existing window, both windows are displayed at the same location using tabs.

Examples

  1. The Properties windows is moved to Docked.
  2. In doing so, the positioning aids are displayed.

  3. The mouse pointer is led over the upper arrow of the positioning aid.
  4. The insertion area is marked in blue in the Editor.

  5. The window is inserted at the highlighted point when the mouse button is released:

  6. Now the mouse pointer is moved to above the upper border positioning aid.
  7. The insertion area is again marked in blue in the Editor.

  8. The window is inserted at the highlighted point when the mouse button is released:


Full-screen mode

Manual -> Editor -> User interface -> Full-screen mode

In the zenon Editor you can switch the main window to full-screen mode. For that

  • use keyboard shortcut Shift+F9
    or
  • select entry Full-screen mode in drop-down list Window

The full-screen hides all remaining windows and shows only the main window with all opened documents (screens, reports, ...) in full-screen mode.

The full-screen mode can be closed by:

  • the displayed button for closing the full-screen mode
  • the short key Shift+F9

Work in full-screen mode

In full-screen mode a menu for closing the full-screen mode and for displaying certain windows and toolbars is displayed.

Parameters

Description

Close full-screen

Closes the full-screen mode. You can also use keyboard shortcut Shift+F9 or Esc.

Dockable windows

Drop-down list for opening windows.

  • Properties
  • Property help

At the first use, windows are displayed at fixed defined position. Then they can be positioned freely and are displayed at the individually defined position when they are displayed again in full-screen mode.

Toolbars

Drop-down list for opening toolbars:

  • Screens
  • Alignment
  • Visibility level
  • Elements

At the first use, toolbars are displayed at fixed defined position. Then they can be positioned freely and are displayed at the individually defined position when they are displayed again in full-screen mode.


Keyboard shortcuts

Manual -> Editor -> User interface -> Keyboard shortcuts

General

Command | Key combination
Open help | F1
Start/stop full screen mode | Shift+F9
Remote: Close full-screen mode | Ctrl+Alt+Shift+F
Start VSTA Editor | Alt+F10
Start VBA Editor | Alt+F11
Wizards: Open selection | Alt+F12
Open file explorer for current project with focus on SQL folder. Corresponds to: %ProgramData%\COPA-DATA\[SQL-Ordner]\[UID]\FILES | Ctrl+Alt+E
Open file explorer with focus on project files from the current project. For example: C:\Users\Public\Documents\<CD_zenon_Projects\[Project]\INI\[Rechner]\INI | Ctrl+Alt+D
Open file explorer with focus on Runtime files from the current project. For example: C:\Users\Public\Documents\zenon_Projects\[Project]\INI | Ctrl+Alt+R
Start Runtime; create changed Runtime files beforehand. | F5
Create changed Runtime files. | F7

Editor profiles

Command | Key combination
Load Editor profile 1 | Shift+F1
Load Editor profile 2 | Shift+F2
Load Editor profile 3 | Shift+F3
Load Editor profile 4 | Shift+F4
Load Editor profile 5 | Shift+F5
Load Editor profile 6 | Shift+F6
Load Editor profile 7 | Shift+F7
Load Editor profile 8 | Shift+F8
save current Editor view as: |
Editor profile 1 | Ctrl+Shift +F1
Editor profile 2 | Ctrl+Shift +F2
Editor profile 3 | Ctrl+Shift +F3
Editor profile 4 | Ctrl+Shift +F4
Editor profile 5 | Ctrl+Shift +F5
Editor profile 6 | Ctrl+Shift +F6
Editor profile 7 | Ctrl+Shift +F7
Editor profile 8 | Ctrl+Shift +F8

Graphic editor:

Note for shortcuts: The plus sign (+) means that keys a pressed together.
For example:

Ctrl+A means: Hold key Ctrl and then press key A.

Ctrl++ means hold key Ctrl and press key +.

General

Command | Key combination
Main window: Scroll content with 'moving hand' | Press and hold Space
Close current screen | Ctrl+F4
Open properties | Alt+Return

Select

Command

Key combination

Select several objects

Press Shift or Ctrl

Deselect selected object during multi-select

Ctrl+mouse click

Selection: Change sort order. Defines the element on which all others realign

Press Shift during selection

Select hidden objects
  1. Press Alt
  2. Click object and move it

Select all elements of a screen.

Ctrl+A

Select next element according to the order of their creation

Tab

Select previous element according to the order of their creation

Shift+Tab

Positioning

Command | Key combination
Move selected object. | Cursor keys
Move by 10 pixels each time you press a cursor key | Shift+arrow keys
Move only horizontally or only vertically | Press Shift during moving
Centers the selected object in the working section | H

Actions

Command | Key combination
Saves changes | Ctrl+S
Pastes element from the clipboard | Ctrl+V Shift+Ins
Inserts element from the clipboard at its original position; original and copy lie congruently on top of each user | Ctrl+Shift+V
Copies selected element. | Ctrl+C Ctrl+Ins
Copy instead of move | Press Ctrl during moving
Deletes selected element | Del
Cuts out the selected element | Shift+Del Ctrl+X
Undoes changes | Ctrl+Z Alt+Backspace
Add or delete node in the selected element. Add: Mouse cursor turns to plus symbol (+). Delete: Mouse cursor turns to minus symbol (-). Works for polylines, polygons and pipe elements. | Ctrl+Shift
Cancel drawing of polylines and polygons | S
Cancel drawing of polylines and polygons and delete the section which was drawn last | Esc
Move selected elements one level up | +
Move selected elements one level down | -
Move selected elements to the foreground | Ctrl++
Move selected elements to the background | Ctrl+-

Scaling

Command

Key combination

Change size

Move mouse cursor to the handle so that the mouse cursor changes to an arrow. After that you can position accurate to the last pixel with the help of the Cursor keys or in steps of 10 pixels with the help of the Cursor keys+Shift.

Note: If an angel dissimilar to 0 via property Rotation angle [°] was defined for an element, scaling via arrow keys is not possible.

Scaling object around the center

Press Alt during scaling.

Proportional scaling

Press Shift during scaling

Detail view

Command | Key combination
Create a new element for the respective module | Ins
Edit the selected column | F2
Copy a selected list element | Ctrl+C
Insert a list element which was copied beforehand | Ctrl+V
Delete a selected list element | Del
Scroll up several elements in the list | Pg up
Scroll down several elements in the list | Pg down
Navigate in the list | Arrow key

Runtime

Command | Key combination
Browse through open Window windows. | Alt+Tab
Stopping the Runtime. | Alt+F4


Toolbars

Manual -> Editor -> Toolbars

The main toolbars are per default positioned below the Menu bar. - With the exception of the Elements toolbar, which is displayed to the right of the Main window. When you move the mouse arrow over a symbol, information about the function of the symbol is displayed in the status line.

The following main toolbars are available:

  • Dockable windows
  • Alignment
  • Screens / Symbols
  • Editor profiles
  • Elements
  • Menu bar
  • Production & Facility Scheduler
  • Remote Transport
  • Report Generator
  • Runtime Files
  • Visibility levels
  • VBA macros

The following windows have unique toolbars that are displayed in the upper part of the screen:

  • Details workspace
  • Properties

info Information

The titles of the toolbars always correspond to the language that was activated in the Editor when the toolbar was displayed for the first time. For example: If you used the toolbar Screens for the first time in German, the name will be retained even when you switch the Editor later to English.

If you want to switch the names to another language, you have to delete first all Editor profiles, then start the Editor in the desired language and activate the toolbars.

Editor profiles are not deleted in zenon, but on file system level. For details see chapter Deletion of Editor profiles.

Actions with symbols and toolbars

Options for toolbars can be changed in: Options -> Settings -> Toolbar tab

Actions for toolbars:

  • position anywhere on-screen
  • close
  • open

Actions for symbols:

  • delete
  • add

Position toolbar

  1. left-click on a free area of the toolbar
  2. and move the toolbar to the desired location on the screen.
  3. a rectangle shows where and how the toolbar is inserted
  4. release the mouse button to position the toolbar

Note: Toolbars which include drop-down lists can only be positioned horizontally.

Close toolbar

You can close toolbars either via the drop-down list Options or the Settings under options.

Drop-down list: fastest way in order to close a toolbar

  1. click on drop-down list Options
  2. navigate to Toolbars
  3. click on the entry for the toolbar you want to close

Settings: makes it possible to close several toolbars at once

  1. Open the menu Options -> Settings -> Tab: Toolbar
  2. Remove the check mark next to the desired toolbar
  3. confirm this with OK.

Open toolbar

You can open toolbars either via the drop-down list Options or the Settings under options.

Drop-down list: fastest way in order to open a toolbar

  1. click on drop-down list Options
  2. navigate to Toolbars
  3. click on the entry for the toolbar you want to open

Settings: makes it possible to open several toolbars at once

  1. Open the menu Options -> Settings -> Tab: Toolbar
  2. set the check mark next to the desired toolbar
  3. confirm with OK

add symbols

  1. Open the menu Options -> Settings -> Tab: Commands
  2. Choose a category from the left window
  3. Click on the desired symbol in the right window with the left mouse button
  4. Hold down the left mouse button and drag the symbol to the desired position in the toolbar

delete symbols

  1. Open the menu Options -> Settings -> Tab: Tool bar
  2. All symbols in all toolbars in the editor are activated
  3. Click with the left mouse button on the symbol
  4. move the symbol away from the toolbar and release the mouse button


Toolbar dockable windows

Manual -> Editor -> Toolbars -> Toolbar dockable windows

The following hidden or closed windows can be reactivated with the help of toolbar Dockable windows.

Symbol (from left to right) | Function
Project Manager | Activates the Project Manager.
Output window | Activates the output window.
Cross reference list | Activates the cross reference list.
Properties window | Activates the properties window .
Property help | Activates the property help window.
Options for symbol bar | Clicking on the arrow opens the submenu: Active: Tool bar is displayed If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar. Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.


Toolbar alignment

Manual -> Editor -> Toolbars -> Toolbar alignment

No.

Symbol

Function

01

align left

Aligns all elements with the left margin of the element that was marked first.

02

align right

Aligns all elements with the right margin of the element that was marked first.

03

Align up

Aligns all elements with the upper margin of the element that was marked first.

04

Align down

Aligns all elements with the bottom margin of the element that was marked first.

05

Horizontal center

Aligns the marked element with the horizontal screen center.

If multiple elements were selected, all elements are aligned according to the one selected first.

06

Vertical center

Aligns the marked element with the vertical screen center.

If multiple elements were selected, all elements are aligned according to the one selected first.

07

Same x-distance

Lines the selected elements in the order of selection up on the x-axis. The first two elements determine the distance.

08

Same y-distance

Lines the selected elements up in the order of selection on the y-axis. The first two elements determine the distance.

09

Same x-distribution:

Distributes all selected elements along the x-axis between the two elements that were selected first. For this option, at least three elements must be selected.

10

Same y-distribution:

Distributes all selected elements along the y-axis between the two elements that were selected first. For this option, at least three elements must be selected.

11

Same width

Marked elements are adjusted to the width of the first chosen element.

Note: Adjustment is according to optical coordinates. For details, see the explanation under this table.

12

Same height

Marked elements are adjusted to the height of the first chosen element.

Note: Adjustment is according to optical coordinates. For details, see the explanation under this table.

13

Same size

Marked elements are adjusted to the width and height of the first chosen element.

Note: Adjustment is according to optical coordinates. For details, see the explanation under this table.

14

Window to foreground

Moves selected elements into foreground

15

One level forward

Moves selected elements one level forward.

16

One level back

Moves selected elements one level back.

17

Window to the background

Moves selected elements to the background.

18

flip horizontally

Flips the selected element on a horizontal axis.

19

Flip vertically

Flips the selected element on a vertical axis.

20

flip 90º

Turns the selected item 90º CCW.

21

Create element group

Creates a new element group from all selected elements.

22

Disband element group

The element group is broken up into its original elements; the element group no longer exists.

23

Single edit mode element group

Enables you to edit individual elements of an element group. Button switches between individual editing mode and symbol editing mode.

24

Insert in existing element group

Opens the list of element groups in order to add the element to an element group of the list.

25

Remove from element group

Deletes the highlighted element from the active element group.

26

Replace links

Opens the dialog for replacing variables or functions which are linked to dynamic elements. Details: see chapter Replacing variables in dynamic elements.

27

Transfer properties

Transfers the properties of a selected element to another one / multiple elements.

  • Transfer to an element:

    Click on element with original properties -> click symbol transfer properties -> click target element: Properties are transferred

  • Transfer to multiple elements:

    Choose source element -> choose target elements while holding the Ctrl-key (Source and target elements are selected, the source element is highlighted by black handling points) -> click symbol transfer properties. The source element´s properties are transferred to the target elements.

Source and target object determine which properties are transferred. Normally; colors, font, text alignment and borders are transferred.

If several elements were chosen as source, the properties of the first selected element are transferred.

28

Options for symbol bar

Clicking on the arrow opens the submenu:

Active: Tool bar is displayed

If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar.

Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.

Adaptation of the same width/height/size

The adaptation of size of rotated and non-rotated elements orientates itself to the visual coordinates, not the logical ones. The stretching of rotated elements is understood as a surface of the rectangle within which the lines of the rotated element are located (bounding rectangle).

For example

Two elements before adaptation:

After adaptation using Same height:


Toolbar screens

Manual -> Editor -> Toolbars -> Toolbar screens

A toolbar is available for editing screens. Per default, it is displayed below the menu bar.

Symbol

(from left to right)

Function

Save screen

Save the current screen.

Save all

Saves all changed screens.

Cut

Cuts the selected element and stores it in the clipboard; works across projects, too. Only available if an element has been selected.

Copy

Saves a copy of the current screen to the clipboard. Only available if an element has been selected.

Paste

Inserts (i.e. pastes) a screen from the clipboard. Only available if the clipboard contains data.

Transfer format

Transfers the formatting of the element that has just been selected to the next element that is selected.

Redraw screen

Refreshes the display.

Undo

Allows undoing up to 100 actions. By default, 10 actions can be undone.

Define the number of actions: Options -> Settings ->Settings -> number of undoable actions. Enter a number between 1 and 100.

Edit mode

Switches from Zoom to Edit mode .

Zoom

Provides two zoom modes:

  • Variable zoom:
    A predefined value can be selected from the combobox, or you can directly enter any value between 15% and 400%.
  • Zoom tool:
    You can zoom directly in the screen with the two magnifier symbols (+ and -). The CTRL key switches between the different modes. The defined zoom is saved for each single screen.

Close zoom mode: Click on the Edit mode symbol in the Elements toolbar.

Help

Opens the online help

Options for symbol bar

Clicking on the arrow opens the submenu:

Active: Tool bar is displayed

If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar.

Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.


Toolbar symbols

Manual -> Editor -> Toolbars -> Toolbar symbols

The symbol library can be operated from the context menu or the toolbar:

Commands in the context menu and toolbar

Toolbar position | Context menu | Function
1 | Symbol new | Creates a new symbol.
3 | Open symbol | Opens the symbol in the symbol editor for editing purposes.
2 | New symbol group | A new symbol group is created and can be filled with selected symbols from the library or with self-defined symbols. (Copy and Paste). Only available in the global symbol library.
4 | Insert symbol as element group in screen | Creates an element group from the symbol and adds this to a screen (for details, see the Element gropus chapter).
5 | Insert symbol in screen | Links the symbol in the screen (for details, see the Symbols chapter).
not available | Linked elements | Opens the sub-menu with linked elements and the possibility to jump back into the starting element.
6 | Jump back to starting element | Jumps back to the starting element (only toolbar).
7 | Copy | Copies the selected symbol to the clipboard (only hierarchical view).
8 | Paste | Inserts the copied symbol in the active group (only hierarchical view).
9 | Delete | Deletes the selected symbol or symbol group (only hierarchical view). Attention: Deleting cannot be undone!
10 | Expand/collapse node | Allows expansion/reduction of the selected node or all nodes in the hierarchical view.
11 | Flat view | Arranges all symbols in a flat view. Facilitates the search for certain symbols. Note: In this view, you can´t create nor delete symbols and it is also impossible to copy or insert symbols from the clipboard.
12 | Hierarchic view | Sorts all symbols hierarchical in subgroups and shows dependencies.
13 | Export selected XML | Opens the dialog for XML-export of the selected symbols. (For details, see chapter Import/Export of symbols.)
14 | Export screen/symbol as a graphic file... | Exports the screen/symbol as a graphics file. The file selection dialog offers the corresponding graphics formats supported on the system. In principle, all Windows Imaging Component (WIC) codecs that support saving are provided for selection. The size of the graphics results from the screen or symbol to be exported.
15 | Import XML | Imports symbols from an XML-file (see chapter Import/Export of symbols).
16 | Remove all filters | Removes all filter settings.
17 | Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
18 | Replace text in selected cell | Opens the dialog for searching and replacing texts.
19 | Properties | Opens the Properties window for the selected entry.
20 | Help | Opens online help.


Toolbar Editor profiles

Manual -> Editor -> Toolbars -> Toolbar Editor profiles

Editor profiles can be administrated easily via the relevant toolbar.

Symbol (from left to right) | Function
Load standard profile | Resets all settings for display and position of windows and content and display of tool bars to the delivery conditions and loads the zenon standard profile.
Select Editor profile | Selection of an Editor profile from a drop-down list with 10 profiles.
Load selected Editor profile | Loads the profile selected in Select Editor profile.
Save selected Editor profile | Saves the current window settings to the profile which is displayed in Select Editor profile.
Load predefined profiles | Loads the profiles predefined by >CD_COMPANYNAME< to the first three storage locations and links them with the modules. Already existing profiles are overwritten.
Remove profile allocations | Removes all links of the predefined profiles to the modules.
Automatic saving of the Editor profiles | Active: Changes to the current profile are saved automatically if another profile is called. Inactive: Changes are not saved when another profile is called; when the profile is called the next time, the original positions are restored.
Assign individual names to Editor profile. | Opens a Dialog in which you can give Editor profiles individual names.
Options for symbol bar | Clicking on the arrow opens the submenu: Active: Tool bar is displayed If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar. Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.

Note: Further options for import and export can be added using the user-defined amendment of the commands for the tool bar.


Toolbar Elements

Manual -> Editor -> Toolbars -> Toolbar Elements

Symbol | Function
Edit mode | Switches from Zoom to Edit mode .
Ellipse/Circle | With frame and fill color, type of frame and fill pattern (circle).
Arc of a circle | With definable line thickness, line color and line type.
Segment of a circle | Draws circle segment with an opening angle of 180º (changeable), definable line thickness, color and line type.
Line | With definable line thickness, line color and line type.
Polygon | With frame and fill color, type of frame and fill pattern.
Polyline | With line type and line color.
Rectangle | With frame and fill color, type of frame and fill pattern.
Pipe | With frame and fill color, type of frame and fill pattern
Static text | With font color and selection of the type of font.
Button | Operating field in button display.
Combined element | Display of one or more variables on a screen point in color or symbol (chained characters).
Universal slider | Slider control or rotating control.
Switch | Simple command initiation or set value input element
Combo-/Listbox | Link values of variables with text messages.
Command Processing element | Only available with a license for SICAM 230
Button Screen Alarm | Only available with a license for SICAM 230
Numerical value | Display values numerically.
Bar display | Display value as bar graph.
Pointer instrument | Value in instrument display.
Dynamic text | Display limit value texts
Trend element | Simple line graphics
WPF element | Displays valid WPF XAML files.
ActiveX Element | Insert ActiveX control.
Clock | Show date and time.
Multibin | Display several variables in one screen point in color and symbol (string).
Message element | Display texts from a text table.
Status element | Apply colors from status configuration.
Options for symbol bar | Clicking on the arrow opens the submenu: Active: Tool bar is displayed If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar. Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.


Toolbar Production and Facility Scheduler

Manual -> Editor -> Toolbars -> Toolbar Production and Facility Scheduler

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Production Facility Scheduler can be edited via a toolbar, too.

Symbol (from left to right) | Function
Rename | Enables renaming of equipment.
Properties | Opens a window with the properties of the equipment.
Delete | Deletes the selected equipment after a confirmation.
Sort ascending | Sorts the selected table / column ascending.
Sort descending | Sorts the selected table / column descending.
Change date | Opens the dialog where a date is entered; switches to this date.
Show today | Switches from the shown date to the current date.
Day view | Shows a day in the calendar.
Week view | Displays a week in the calendar.
Month view | Displays a month in the calendar.
Previous element | Goes one element back in the calendar according to the entered value (one day, one week or one month).
Next element | Goes one element forward in the calendar according to the entered value (one day, one week or one month).
Switching points preview | Opens the switching points preview.
Options for symbol bar | Clicking on the arrow opens the submenu: Active: Tool bar is displayed If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar. Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.


Toolbar Remote Transport

Manual -> Editor -> Toolbars -> Toolbar Remote Transport

A development computer can set up remote connections to other stations. The Remote transport toolbar provides functions for the transfer and request of data.

Symbol

(from left to right)

Function

Remote Transport: Connection settings

Opens the configuration dialog of the remote transport for setting the target system and the target folder.

Remote Transport: Establish connection

Establishes a Remote Transport connection to the remote system.

Remote: Transfer changed Runtime files

Transfers all Runtime files that were changed on the development computer to the target computer since the last change.

Remote: Read back all Runtime files

Restores all files that can be edited in Runtime (such as recipes or user administration) from the remote system back to the local Runtime folder.

Remote: Set start project

Sets the active project as the start project on the remote system.

Remote: Start Runtime

Starts Runtime on the remote system.

Remote: Exit Runtime

Stops Runtime on the remote system.

Remote: Reload project

Executes the reload function on the remote system.

Remote Desktop: Start connection

Starts a connection to operate the target computer using zenon Remote Desktop. This allows visual operation.

Options for symbol bar

Clicking on the arrow opens the submenu:

Active: Tool bar is displayed

If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar.

Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.

Further symbols can be added using the toolbar options:

Transfer all Runtime files

Transfers all Runtime files to the target system.

Restart OS

Starts the operating system of the target computer after confirmation. Under Windows CE this option is not supported.

Get system status

Determines system status of the target computer and writes data to the output window. The following are determined:

  • Computer name
  • Operating system
  • Runtime active/not active
  • Start project
  • Real memory
  • Drives
  • Remote serial number
  • Remote activation number
  • Remote zenon version

Change password and display licensing

Opens dialog for connection establishing.

Enables:

  • Changing the password for the connection establishment
  • Display and change of the licensing of the target computer
  • Configuration of the encryption at the target computer

Note: All commands for Remote Transport are available in the project's context menu.


Toolbar Report Generator

Manual -> Editor -> Toolbars -> Toolbar Report Generator

A toolbar is available in the Editor for the Report Generator. If it is not displayed yet, you can load it:

  1. Open the menu Options -> Settings -> Tab: Toolbar
  2. Tick the checkbox next to Report Generator
  3. confirm this with OK.

Symbol (from left to right) | Function
Print report | Prints the report on the default printer.
Report - Page view | Opens the report in a preview. The report can be enlarged or minimized in the preview (zoom), you can leaf through it and it is printable.
Refresh report | Refreshes the display.
Recalculate functions | Recalculates the formulas in the report.
Function wizard | Opens a dialog that helps with the configuration of functions.
Font | Opens the dialog for cell formatting - focused on the Font tab.
Text alignment | Opens the dialog for cell formatting - focused on the Alignment tab.
Border | Opens the dialog for cell formatting, with focus on the tab Frames.
Pattern | Opens the dialog for cell formatting - focused on the Pattern tab.
Options for symbol bar | Clicking on the arrow opens the submenu: Active: Tool bar is displayed If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar. Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.


Toolbar Runtime files

Manual -> Editor -> Toolbars -> Toolbar Runtime files

A toolbar is available to transfer files from the Editor to the Runtime or vice versa:

Symbol (from left to right) | Function
Create changed Runtime files | Creates Runtime files of all files that were changed in the Editor. The drop-down menu allows to choose whether Runtime files of the active project or of all loaded projects shall be created.
Create all Runtime Files | Creates Runtime files of all files that are available in the Editor. The drop-down menu allows to choose whether Runtime files of the active project or of all loaded projects shall be created.
Import Runtime files | Files that can be changed in the Runtime (like recipes or user administration) are imported from the Runtime in the Editor.
Files that can be changed in Runtime | Opens the dialog to administer files that can be changed in Runtime.
Start Runtime | Starts Runtime.
Options for symbol bar | Clicking on the arrow opens the submenu: Active: Tool bar is displayed If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar. Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.


Toolbar visibility levels

Manual -> Editor -> Toolbars -> Toolbar visibility levels

Similar to CAD programs, you can define visibility levels in the Editor and allocate them with unique elements. That way you can easily hide unused elements in complex images and show them again anytime. 15 visibility levels are available. Levels are allocated using the properties Visibility level in the nodeGeneral. Unique levels can be activated and deactivated using the buttons of the toolbar Visibility levels:

Symbol (from left to right) | Function
Show all visibility levels | Shows all levels.
Hide all visibility levels | Hides all levels.
Visibility level<No.> | Shows / hides the relevant visibility level.
Options for symbol bar | Clicking on the arrow opens the submenu: Active: Tool bar is displayed If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar. Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.

info Information

Visibility levels only apply to the Editor and have no effect in Runtime.

Note on control elements: Control elements are always displayed at the uppermost position. That also applies if they are covered by other elements in the Editor. This ensures that they can always be reached.


Tool bar macro list

Manual -> Editor -> Toolbars -> Tool bar macro list

Macros that were created with VBA can be administrated via toolbar-item Macro list.

Symbol (from left to right) | Function
Reload list of VBA/VSTA macros | Loads all Public Sub Name () macros that are included in myWorkspace and in modules to the drop-down list of the toolbar.
Search Macro | Search for macros via combobox input field or selection from drop-down list. The drop-down list is adjusted to the widest element when opened.
Drop-down list Macros | Contains all loaded macros for selection.
Execute selected macro | Executes the macro selected in the drop-down list.
execute allocated macro #<x> | Executes the macro allocated with the symbol.
Allocate macros | Opens the allocation dialog for macros. Up to 5 macros can be allocated with the symbols 1 to 5.
VBA | Filters for VBA-macros. Only VBA-macros are displayed.
VSTA | Filters for VSTA-macros. Only VSTA-macros are displayed.
ALL | Cancels the current filter and all macros are displayed.
AZ | Sorts macros in ascending order from 0 - 9 and A - Z.
ZA | Sorts macros in descending order from Z - A and 9 - 0.
Options for symbol bar | Clicking on the arrow opens the submenu: Active: Tool bar is displayed If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar. Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.

info Information

If the macro assignment dialog does not list all macros from myWorkspace, execute the function Reload list of VBA macros in the toolbar.


Toolbar detail view

Manual -> Editor -> Toolbars -> Toolbar detail view

The project manager detail view shows matching toolbars depending on the active node. These correspond with the contents of the relevant context menu. You can find help for the unique toolbars in the relevant chapter, for example: Variable detail view toolbar.


Toolbar properties

Manual -> Editor -> Toolbars -> Toolbar properties

The properties of an object are shown and can be edited in the properties-window. A toolbar is available for administration of the properties screen.

Symbol

(from left to right)

Function

Grouped view

(default)

All properties of the selected object are logically grouped; the groups can be sorted alphabetically or logically. With the context menu, properties can be added to or removed from the Favorites.

Standard for manual: Hints in the manual concerning the properties always use the grouped view. The contents of the groups are the same as in the dialog view.

All properties

All properties of the selected object are displayed in a list. With the context menu, properties can be added to or removed from the Favorites.

Dialog view

All properties are grouped logically like in the Grouped view , the groups are displayed sorted by application priority in dialog form. In this view, no favorites can be defined.

Show/hide favorites

Shows / hides the node Favorites in the top spot of the views Grouped view or All settings. The most frequently used properties are collected here.

Default favorites are proposed.

Add / remove entries to the favorites: You can do this either by using the context menu Add to favoritesor by moving the desired properties to the favorites toolbar using Drag&Drop.

The order of the properties in the favorites is determined by the sorting criterion (ascending, descending, logic).

In the Dialog view favorites cannot be created.

Show/hide all properties

Shows / hides all nodes in the views Grouped and All Properties.

Sorted logically

(default)

Displays the properties logically sorted according to application frequency instead of alphabetically sorted in the views Grouped and All properties.

Sort ascending/descending

Displays the properties either in ascending or descending alphabetical order in the views Grouped and All properties.

Open/close all sections

Shows / hides all nodes in the views Grouped and All Properties.

Exception: The node of the current property is not closed, if Close all nodes is selected.

Display properties help

Displays the integrated help for the properties (properties help).

Release property

Symbols: Releases the selected property.

Options for symbol bar

Clicking on the arrow opens the submenu:

Active: Tool bar is displayed

If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar.

Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.


Menu bar

Manual -> Editor -> Menu bar

The menu bar contains - depending on the selected module and element - drop-down lists for the following elements.

Basic

  • File
  • Edit
  • Screens
  • Options
  • Window
  • Help

Screens and symbols

If a screen is opened, new menu items are added to the bar:

  • Elements
  • Control elements

If the General symbol library is activated, the menu item Screens is replaced with the menu item Symbols .

Report

When a report is opened:

  • The Screens menu is replaced with Report
  • The Format menu is added
  • The commands in the Edit menu are replaced


File

Manual -> Editor -> Menu bar -> File

Possible actions are:

Menu item

Action

Project

Opens the dialog for creating a new project.

Insert project into workspace

Opens the dialog to insert an existing project into the Editor.

Insert project 5.50

Opens the dialog to insert a project created with Editor 5.50.

Restore project backup

Opens the dialog to load the last version of a project saved in a project backup.

Workspace

New

Opens the dialog for creating a new workspace.

Open

Opens the dialog for creating an existing workspace.

Save

Saves the current workspace.

Save as

Saves the current workspace. Name and desired storage place can be chosen.

Close

Closes the current workspace

Create backup

Opens the dialog for the backup of all current workspace projects. The backup is stored in a compressed *.wsb-file.

Load backup

Opens the dialog for loading the projects that were saved during a backup of the workspace.

General configuration

License product

Opens the dialog License product for entering the serial number and the activation number or for requesting a softlicence.

Standard

Opens the dialog for configuration of standard settings for the save location and the printer for

  • AML
  • CEL
  • Values
  • Protocols
  • Screenshots
  • Notepad

Control panel

Opens the control panel of the operating system.

Visual Basic Editor

Opens the Visual Basic Editor

Note: This menu item is only available if you have activated VBA VSTA in the file zenon6.ini. Activate VBA by checking that the entry EIN=1 is available in area [VBA].

Wizards

Opens the dialog for selecting an assistant.

Note: This menu item is only available if you have activated VBA VSTA in the file zenon6.ini. Activate VBA by checking that the entry EIN=1 is available in area [VBA].

Update Wizards

Opens the dialog for an update of the wizard. For details see chapter Wizards section Update wizards.

Note: This menu item is only available if you have activated VBA VSTA in the file zenon6.ini. Activate VBA by checking that the entry EIN=1 is available in area [VBA].

Existing workspaces

List of existing workspaces. The last five chosen settings are shown. The updated list is written to zenon6.ini when the workspace is changed.

Exit

Terminates the zenon Editor


Edit

Manual -> Editor -> Menu bar -> Edit

Screens and symbols

When selecting a screen or symbol, the Edit menu provides special functions.

Possible actions are:

Parameters | Description
Undo | Undoes the last action. The number of actions that can be undone is defined in Options -> Settings Attention: It is not possible to undo action in the Frame Editor.
Cut | Cuts the selected objects and stores them in the clipboard.
Copy | Copies the selected objects and stores them in the clipboard.
Paste | Pastes copied or cut objects from the clipboard. Elements are always pasted centered in the editing area. If there are multiple objects, their positions in relation to each other are retained.
Paste in same position | The copy of the object is pasted in the same position as the original.
Delete | Deletes marked objects
Select all | Marks all objects in the main window.
Properties | Opens the property window.
Replace links | Opens the dialog for replacing variables or functions which are linked to dynamic elements. Details: see chapter Replacing variables in dynamic elements.
Element Position | Changes the position of marked elements ALT + left-click selects elements from deeper levels.
Foreground | Moves selected elements into foreground
Background | Moves selected elements to the background.
Forward | Moves selected elements one level forward.
Backwards | Moves selected elements one level back.
Layout | Repositions selected elements.
Left | Moves selected element left
Right | Moves selected element right
Top | Moves selected elements upwards
Bottom | Moves selected elements downwards
Arrange | Rearranges elements. Starting point is the first marked element.
same width | Marked elements are adjusted to the width of the first chosen element. Note: With rotated elements, the width is orientated to optical coordinates, not to logical coordinates. For details, see the Toolbar orientation chapter.
same height | Marked elements are adjusted to the height of the first chosen element. Note: With rotated elements, the height is orientated to optical coordinates, not to logical coordinates. For details, see the Toolbar orientation chapter.
same size | Marked elements are adjusted to the width and height of the first chosen element. Note: With rotated elements, the size is orientated to optical coordinates, not to logical coordinates. For details, see the Toolbar orientation chapter.
horizontal center | Moves marked elements in the horizontal center of the first selected element.
vertical center | Moves marked elements in the vertical center of the first selected element.
same distance in x-plane | Marked elements are grouped in a way that the distance on the X-axis is the same between them. The first two elements determine the distance.
same distance in y-plane | Marked elements are grouped in a way that the distance on the y-axis is the same between them. The first two elements determine the distance.
same allocation in x-plane | Distributes all marked elements along the x-axis between the two elements that were first selected. For this option, at least three elements must be selected.
same allocation in y-plane | distributes all marked elements along the y-axis between the two elements that were first marked. For this option, at least three elements must be selected.
flip horizontally | Flips the selected element on a horizontal axis.
flip vertically | Flips the selected element on a vertical axis.
flip 90º | Rotates the selected element 90º counterclockwise.
Key order left/right | Shows a frame which defines the horizontal sequence in which the screen elements are selected with the function Set focus
Key order up/down | Shows a frame which defines the vertical sequence in which the screen elements are selected with the function Set focus
Symbol |
Create | Creates a new symbol from all chosen elements.
Resolve | The symbol is broken up into its source elements; it exists no longer.
Single edit mode symbols / elements | Enables you to edit individual elements of a symbol. Switches between individual editing mode and symbol editing mode.
Insert in existing symbol | Opens the toolbar to insert the active symbol in a symbol from the list.
Remove from symbol | Deletes the selected element from the active symbol. After this action the element no longer belongs to the symbol.
Convert symbol into element group | Converts a symbol into an element group. The symbol is disconnected from the original symbol in the library and can only be changed locally. This conversion cannot be undone.
Tool bar | Opens a list of all symbols, used in the current screen. For each symbol its graphical components are listed.
Tab order for focus | Opens drop-down list for definition of horizontal or vertical order for Keyboard operation.
Order for left/right | Determines the horizontal order.
Order for up/down | Determines the vertical order.

Reporting

For Reports, the Edit menu provides the following entries:

Command

Description

Cut

Cuts out highlighted area and copies it to the clipboard.

Copy

Pastes the contents of the clipboard.

Paste

Copies highlighted areas to the clipboard.

Paste enhanced

Provides advanced paste options for cell operations:
  • All

Inserts everything from the clipboard.
  • Formulas

Only inserts formulas
  • Value

Only inserts values. The relationship to formulas is lost.
  • Format

Only accepts the format.

Fill

Copies the content of the first cell of a marking and transfers it to all further marked cells.

  • Down

Filling is carried out in a downward direction.
  • to the right

Filling is carried out from left to right.

Delete

Removes from highlighted cells:
  • All

Everything.
  • Contents

Contents only.
  • Format

Formats only.

Delete column/row

Deletes highlighted columns or rows.

Insert column/row

Inserts new columns or rows. Insertion is carried out above the row or to the left of the column. As many rows/columns are inserted as are highlighted in the worksheet.

Search/replace

Opens the dialog for searching and replacing in a worksheet.


Screens

Manual -> Editor -> Menu bar -> Screens

Possible actions are:

Menu item | Action
Save screen | Saves the current screen.
Save all screens | Saves all screens.
Redraw screen | Refreshes the display.
Display grid | Switches the grid on or off.
Use grid | Switches usage of the grid on or off. On: All objects are automatically aligned with the grid.
Use magnetic points | Switches magnetic points on or off. Use: If you move an object near the handling point of another object, it snaps in place at the handling point.
Zoom | Changes the resolution in fixed steps between 15% and 400%.
Screenshot print current screen. | The current screen is printed on the standard printer. Set printer properties via File -> Standard configuration -> standard.
Insert vector graphics | Opens the dialog for inserting an external vector graphic.

info Information

As soon as a screen element is active, the menu Elements is displayed. It offers all vector elements and dynamic elements analog to the tool bar elements for selection. When you select special screen types the menu Control elements is displayed in addition. It offers predefined control elements in accordance with the selected screen type.


Symbol

Manual -> Editor -> Menu bar -> Symbol

Possible actions are:

Menu item

Action

Save symbol

Saves the current symbol.

Save all symbols

Saves all symbols.

Change symbol size / background color

Opens the dialog for configuration of symbol size and background color.

Note: Changes of the background color always affect all symbols in the global system library.

Tool bar

Opens a list of all symbols, used in the current screen. For each symbol its graphical components are listed.

Full-screen mode

The full-screen hides all remaining windows and shows only the main window with all opened documents (screens, reports, ...) in full-screen mode.

The full-screen mode can be closed by:

  • the displayed button for closing the full-screen mode
  • the short key Shift+F9

Redraw symbol

Refreshes the display.

Display grid

Switches the grid on or off.

Use grid

Switches usage of the grid on or off.

On: All objects are automatically aligned with the grid.

Use magnetic points

Switches magnetic points on or off.

Use: If you move an object near the handling point of another object, it snaps in place at the handling point.

Tab order for focus

Opens drop-down list for definition of horizontal or vertical order for Keyboard operation.

Order for left/right: Determines the horizontal order.

Order for up/down: Determines the vertical order.

Zoom

Changes the resolution in fixed steps between 15% and 400%.

Screenshot print current symbol

The current symbol is printed on the default printer. Set printer properties via File -> Standard configuration -> standard.

Insert vector graphics

Opens the dialog for inserting an external vector graphic.


Window

Manual -> Editor -> Menu bar -> Window

Possible actions are:

Menu item

Action

Full-screen mode

The full-screen hides all remaining windows and shows only the main window with all opened documents (screens, reports, ...) in full-screen mode.

The full-screen mode can be closed by:

  • the displayed button for closing the full-screen mode
  • the short key Shift+F9

Close

Closes the active window

Divide

Divides the main window and positions the active windows accordingly.

List of windows

Displays open windows. A maximum of 9 windows are listed.

Window

Opens the dialog to administer windows open in the main window:

  • Activate
  • save (multiple selection is possible)
  • close (multiple selection is possible)

The active window is preselected.


Help

Manual -> Editor -> Menu bar -> Help

Possible actions are:

Menu item

Action

Info about

Opens a window with information on zenon:

  • Serial Number
  • Activation number:
  • Licensed tags/IOs
  • Licensed module

A slider can be used for navigation in the information window. Clicking in the window or pressing the Esc key closes the info window.

Getting Started

Calls up the section Tutorials in the online help.

Help

Opens the online help


Options

Manual -> Editor -> Menu bar -> Options

Possible actions are:

Menu item | Action
Settings | Opens the dialog for configuration of the basic settings, Menus, Toolbars and Commands.
Editor administration of editor profiles | Opens the Submenu for administration of the Editor profiles.
Main window with tabs | Switches the multiple screen view in the main window on and off via tabs .
Status line | Shows / hides the Editor Status line. Which is not identical with the status line of the Project Manager in the Detail view.
Project Manager | Shows the window Project Manager .
Output | Shows the Outpout window .
Cross reference list | Shows the Cross reference list .
Properties window | Shows the Properties window .
Property help | Shows the window Properties help
Toolbars | Drop-down list for displaying and hiding tool bars.
Update of the Windows CE Runtime | Opens the software for updating a Windows CE Runtime.
Define new menu entry | Opens the dialog to implement external programs with their own menu entry. Hint: If you already created another menu entry it is shown in this place. New and additional menu items are created using Options -> Settings -> Menu tools.


Settings

Manual -> Editor -> Menu bar -> Options -> Settings

Define the basic settings for zenon in the dialog Settings .

Editor options

Parameters | Description
Load last active workspace | Active: The last active workspaces are loaded and displayed in the project manager when the editor is started (default). Inactive: No workspace is loaded when the editor is started. Existing projects and workspaces can be opened and new ones can be created using the context-sensitive menu.
Show border for dynamic elements in the Editor | Active: Shows dynamical elements in the Editor with a position frame.
The filter in the detail view is case sensitive. | Active: The filter in the list view is case sensitive. Inactive: The filter in the list view makes no difference between capital and small letters (default).
Logical sorting of texts in the detailview | Active: File names containing numbers are sorted logically in the list view, e.g. 1, 2, 10, 11 inactive: File names containing numbers are sorted alphabetically in the list view, e.g. 1, 10, 11, 2
Use assistant | Active: If you want to create Archives, Combined elements and Universal sliders, the help of an assistant is offered automatically. Inactive: Archives, combined elements and universal sliders are configured manually.
Color of the filtered columns in configurable lists | Configuration of the background color for the highlighting of filtered columns in configurable lists. Clicking on the color field opens a dialog to select a color.

Screen editing

Parameters | Description
Use hardware acceleration if available | Active: Hardware acceleration is used. Inactive: Hardware acceleration is not used.
Input properties on creating | Active: If you create a dynamic element, the dialog boxes for detailed settings, like for example variable selection, open automatically. Inactive: The dynamical element is drawn; related properties must be defined seperately.
Show "Adjust links" dialog when inserting symbols | Active: On inserting a symbol in a screen, the dialog Adjust link is opened. Inactive: The dialog is not opened. Links can be substituted anytime using the command Replace link in the context menu.
Space for change of position | Prevents unwanted moving of elements Before an element is really moved, it has to be moved at least by the stated number of pixels.
Size of selection markers | xx
Undo steps | Allows undoing up to 100 actions. By default, 10 actions can be undone. Enter a number between 1 and 100.

Editor and Runtime

Parameters | Description
selected language | Choose the language for the Editor´s user interface. The Editor must be closed and started again for a language change. The default language of the Editor is English.
Do not send the bug report to Microsoft | Active: Prevents transmission of a bug report to Microsoft if a program crashes.

Screen editing

Parameters | Description
Use hardware acceleration if available | Active: Hardware acceleration is used. Inactive: Hardware acceleration is not used.
Input properties on creating | Active: If you create a dynamic element, the dialog boxes for detailed settings, like for example variable selection, open automatically. Inactive: The dynamical element is drawn; related properties must be defined seperately.
Show "Adjust links" dialog when inserting symbols | Active: On inserting a symbol in a screen, the dialog Adjust link is opened. Inactive: The dialog is not opened. Links can be substituted anytime using the command Replace link in the context menu.
Space for change of position | Prevents unwanted moving of elements Before an element is really moved, it has to be moved at least by the stated number of pixels.
Size of selection markers | xx
Undo steps | Allows undoing up to 100 actions. By default, 10 actions can be undone. Enter a number between 1 and 100.

Grid

Parameters

Description

Display grid

Active: Shows the grid that can be defined in the main window under Grid type.
Inactive: Grid is not displayed.

Use grid

Active: Screen elements are automatically aligned with the grid. This function is independent from the option Display grid.

Color

Defines the grid color. The windows color palette is used for selection.

Display

Drop-down list with the type of grid display:

  • full
  • Intersections

Vertical space

Defines the horizontal and vertical distance between unique marker points. Therefore, it also defines how finely scaled element sized can be displayed. Recommended grid distance: 10 pixels horizontally and vertically.

Horizontal space

Magnetic points

Parameters | Description
Use magnetic points | Elements have magnetic points. If you move an element and its selection marker comes near the selection marker of another element, the selection marker of the selected element is locked there and aligns itself on it.
Size in screen or symbol editor | Defines the size of the magic area in pixels (square selection markers). Enter a number between 1 and 20.
Size in the frame editor | Defines the size of the connection area in pixels (square selection markers) for the positioning of frames in relation to other frames or screen borders. Enter a number between 1 and 40.


Menu tools

Manual -> Editor -> Menu bar -> Options -> Menu tools

In the dialog Menu tools you implement external programs in the Editor´s menu structure. Individually implemented programs are shown at the end of menu item Options .

Menu contents

Options | Action
Menu contents | Lists all previously-integrated external programs.
New | Adds a new menu item.
Delete | Deletes an existing entry from the menu.
Move up | Moves the selected menu item upwards in the list and in the menu.
Move down | Moves the selected menu item downwards in the list and in the menu.
Menu text | Name under which the new menu is displayed in the options.
File | Name and path of the external program (*.exe-file) that shall be called up.
Parameters | Additional switches for calling up programs, for example file names.

Example Example

Menu text: Text editor

File: C:\Windows\notepad.exe

Parameters: C:\test.txt

Calls up Notepad and opens the file test.exe. If this file is not available, you can create it.


Color scheme

Manual -> Editor -> Menu bar -> Options -> Color scheme

You define the color scheme for the Editor in this tab.

Color scheme for Editor

Parameters | Description
Color scheme for Editor | Clicking on the drop-down list opens the list where it can be selected.
Preview | Changes the color scheme of the Editor. The dialog window remains open.
OK | Applies changes and closes dialog.
Cancel. | Discards changes and closes dialog.


Commands

Manual -> Editor -> Menu bar -> Options -> Commands

In the dialog Commands you define, which commands are available in the toolbars.

Categories

Options | Action
Categories | Select the category that includes the desired command.

Commands

Options | Action
Commands | List of available commands.
Description | Text for tooltip If you move the mouse pointer over the button, the description is shown as tooltip.

add symbols

  1. Open the menu Options -> Settings -> Tab: Commands
  2. Choose a category from the left window
  3. Click on the desired symbol in the right window with the left mouse button
  4. Hold down the left mouse button and drag the symbol to the desired position in the toolbar

delete symbols

  1. Open the menu Options -> Settings -> Tab: Tool bar
  2. All symbols in all toolbars in the editor are activated
  3. Click with the left mouse button on the symbol
  4. move the symbol away from the toolbar and release the mouse button

info Information

To undo changes to a tool bar and to restore the delivery conditions, change to tab Tool bar. Select the appropriate toolbar and click on the Reset button or on Reset all, to return all toolbars to the original state.


Toolbars

Manual -> Editor -> Menu bar -> Options -> Toolbars

You define the appearance and visibility of tool bars in the Tool bars dialog.

Toolbars

Options | Action
Toolbars | Checkbox active: Tool bar is shown in the editor.
Reset | Restores initial status for highlighted tool bar.
Reset all | Restores initial status for all tool bars.


Editor profiles

Manual -> Editor -> Editor profiles

The Editor starts with default settings with predefined windows. You can group windows and activate them to your liking. You can find details in chapter Adjust view. Your personal settings are administrated in profiles. These can be reached via

  • the task bar Editor profiles

    (see: Administrate Editor profiles with the task bar)

  • the sub item administrate Editor profiles in the Options of the task bar

    (see Administrate Editor profiles via menu)

  • with keyboard shortcuts

    (see administrate Editor profiles with keyboard shortcuts)

You can also allocate single modules to editor profiles using the context menu (see Choose Editor profiles from the context-sensitive menu) or you can use predefined profiles.

info Information

For divided windows - as in the Project Manager with main view and detail view - the width definition always applies to the whole window. The correct relationship of the window elements is defined when starting and closing the Editor.

If the ratio of the window elements to one another is changed, calling up a profile only leads to the complete window being set to the defined values. The ratio of, for example, the main view and detail view to one another is not changed.


Predefined profiles

Manual -> Editor -> Editor profiles -> Predefined profiles

In zenon three predefined profiles are available. You optimize the layout of the Editor at a resolution of 1280 x 1024 for:

  • List view (variables, functions, recipes etc.):
    Profile 1 on storage location P1:
  • Screens:
    Profile 2 on storage location P2:
  • Default for general tasks:
    Profile 3 on storage location P3:

Pre-defined profiles must be explicitly activated. They overwrite the storage locations P1, P2 and P3. If they are activated, the respective assigned profile is applied when a node in the project tree is selected. If automatic assignment of the profiles is deactivated, there is no more automatic assignment when a node is changed. The storage locations P1, P2 and P3 continue to contain the corresponding profiles. These can be further assigned manually or overwritten by self-defined profiles.

Select predefined profile

You can either activate or deactivate these profiles. For this you either use the Symbols in the tool bar for editor profiles or:

  1. open the menu Options
  2. click on Administrate Editor profiles
    • Load predefined profilesloads the predefined profiles to the first three storage locations and links them with the modules. Already existing profiles are overwritten.
    • Remove profile allocations: Removes all links of the predefined profiles to the modules.

To use the profiles select Editor profile -> [Profile number] at the desired module.

attention Attention

When activating a pre-defined profile, the corresponding settings are assigned to the save locations P1, P2 and P3 and these are renamed to P1, P2 and P3. Individual settings and naming for all other save locations (P4 to P10) are lost. The standard profile remains.

Error message when displaying predefined profiles

If you receive an error message mentioning the zenAdminSrv when selecting a predefined profile, this can have to reasons:

  1. Service zenAdminSrv runs with a lower version number as the current Editor.
    Solution: Update the service.
  2. The profiles were removed from the default folder:
    Solution: Copy file Predefined Editor Profiles.epf to folder C:\ProgramData\COPA-DATA\zenonxxx\EdProfiles (xxx equals the current zenon version number).

Profiles

Profile 1: List view

Optimized display for editing variables and list views.

Profile 2: Screens

Optimized display for editing screens.

Profile 3: Standard

Default view, optimized for modules which are not based in lists.


Administrate Editor profiles with the task bar

Manual -> Editor -> Editor profiles -> Administrate Editor profiles with the task bar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The task bar for the Editor profiles is shown by default in the middle of the second line of symbols. If it was deactiveated, right-click next to the task bars and choose Editor profiles. You get the following task bar:

Symbol (from left to right) | Function
Load standard profile | Resets all settings for display and position of windows and content and display of tool bars to the delivery conditions and loads the zenon standard profile.
Select Editor profile | Selection of an Editor profile from a drop-down list with 10 profiles.
Load selected Editor profile | Loads the profile selected in Select Editor profile.
Save selected Editor profile | Saves the current window settings to the profile which is displayed in Select Editor profile.
Load predefined profiles | Loads the profiles predefined by >CD_COMPANYNAME< to the first three storage locations and links them with the modules. Already existing profiles are overwritten.
Remove profile allocations | Removes all links of the predefined profiles to the modules.
Automatic saving of the Editor profiles | Active: Changes to the current profile are saved automatically if another profile is called. Inactive: Changes are not saved when another profile is called; when the profile is called the next time, the original positions are restored.
Assign individual names to Editor profile. | Opens a Dialog in which you can give Editor profiles individual names.
Options for symbol bar | Clicking on the arrow opens the submenu: Active: Tool bar is displayed If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar. Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.

Note: Further options for import and export can be added using the user-defined amendment of the commands for the tool bar. To export or import Editor profiles, choose the relevant option in the Main menu under Options -> Editor adminstrate Editor profiles.


Administrate Editor profiles via menu

Manual -> Editor -> Editor profiles -> Administrate Editor profiles via menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the menu, choose Options -> Editor administrate Editor profile for the administration of your Editor profiles.

You have the following possibilities:

Options | Function
Name | Opens a Dialog in which you can give profiles individual names.
Load standard profile | Resets all window setting to the factory default settings and loads the zenon standard profile.
Load predefined profiles | Loads the profiles predefined by >CD_COMPANYNAME< to the first three storage locations and links them with the modules. Already existing profiles are overwritten.
Remove profile allocations | Removes all links of the predefined profiles to the modules.
Export | Opens the data manager and saves the settings as a .zip file at any desired save location.
Import | Opens the data manager in order to import saved settings as a .zip file from any desired save location.

To select or save individual editor profiles, use the corresponding functions in the tool bar or keyboard shortcuts.


Administrate Editor profiles with the task bar

Manual -> Editor -> Editor profiles -> Administrate Editor profiles with the task bar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Possible actions are:

Command | Key combination
Load Editor profile 1 | Shift+F1
Load Editor profile 2 | Shift+F2
Load Editor profile 3 | Shift+F3
Load Editor profile 4 | Shift+F4
Load Editor profile 5 | Shift+F5
Load Editor profile 6 | Shift+F6
Load Editor profile 7 | Shift+F7
Load Editor profile 8 | Shift+F8
save current Editor view as: |
Editor profile 1 | Ctrl+Shift +F1
Editor profile 2 | Ctrl+Shift +F2
Editor profile 3 | Ctrl+Shift +F3
Editor profile 4 | Ctrl+Shift +F4
Editor profile 5 | Ctrl+Shift +F5
Editor profile 6 | Ctrl+Shift +F6
Editor profile 7 | Ctrl+Shift +F7
Editor profile 8 | Ctrl+Shift +F8


Select the editor profile in the context menu

Manual -> Editor -> Editor profiles -> Select the editor profile in the context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the project manager, editor profiles in the context menu can be selected for each project and each sub-area of a project and assigned on a permanent basis: Right-click on the branch -> Editor profiles -> choose.

An assignment can be removed by clicking None in the context menu.


Delete Editor profiles

Manual -> Editor -> Editor profiles -> Delete Editor profiles

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To reset your profile data:

  1. Delete the complete Editor folder in the path C:\Users\USERNAME\AppData\Local\COPA-DATA\zenon\Editor

    Note: USERNAME must be replaced by the username of the logged in Windows user.

  2. Delete the entry for the profile in the Windows registry under: HKEY_CURRENT_USER\Software\COPA-DATA\Editor\Profiles


Individual naming of editor profiles

Manual -> Editor -> Editor profiles -> Individual naming of editor profiles

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Editor profiles can be designed and named individually. The names are given directly in the tool bar, using a keyboard shortcut or by means of a dialog.

To configure individual profiles:

  1. Set up the editor as desired.
  2. Open the dialog for assigning an individual name:
    • Tool bar, Assign individual names for editor profiles or
    • Menu -> Options -> Editor manage editor profiles -> name

  3. Enter the desired name in the field after the desired editor profile short description.

attention Attention

When activating a pre-defined profile, the corresponding settings are assigned to the save locations P1, P2 and P3 and these are renamed to P1, P2 and P3. Individual settings and naming for all other save locations (P4 to P10) are lost. The standard profile remains.

You can call up the first eight editor profiles in the Editor at any time with the keyboard shortcuts Shift + F1 to Shift + F8. Or you select the desired editor profile using the corresponding symbol in the tool bar.


Project Manager

Manual -> Editor -> Project Manager

The Project Manager is per default located on the left side of the screen directly below the toolbars. It can be displayed in two views:

  • Project tree
  • Network topology

Project tree

The project tree contains:

  • The workspace on the left side with the projects and the General symbol library:
    • All loaded projects with their variables, functions, screens etc are available in the workspace.
    • The General symbol library contains predefined graphics and offers the possibility to create new graphics.
  • a detail view on the right side:

    This lists all elements and settings for the section selected in the tree view.

Network topology

The network topology view displays all projects in the workspace topologically and enables all network components involved to be tested, as well as testing remote transport of the Runtime files to the respective computer.

You can read details about this in the network section in the Testing network topology for validity chapter.


Workspace

Manual -> Editor -> Project Manager -> Workspace

In the workspace, the following components of a project are administrated:

  • Variables
    • Driver
    • Datatypes
    • Reaction matrix
    • Allocations
    • Alarm
    • Units
  • Screens
    • Frames
    • Fonts
    • Palettes
    • Symbol library
  • Functions
    • Scripts
  • Language file
  • Historian
  • Recipes
    • Standard Recipes
    • Recipegroup Manager
  • Batch Control
  • Time control
  • Programming interfaces
    • Process Control Engine
    • Macro list
    • VSTA
  • zenon Logic is an IEC 61131-3 programming environment.
  • Production & Facility Scheduler
  • Interlockings
  • Command Processing
  • Load Management
  • Message Control
  • Menus
  • Report Generator
  • User administration
    • User
    • User groups
  • SAP interface
  • Files: inserts external files. Drivers are not directly integrated in zenon, they are implemented via an external program.
    • Graphics
    • Help
    • Multimedia
    • Texts and formats
    • Driver
    • Report Viewer
    • Others
  • History of changes
  • Equipment Modeling
  • Project backups

The availability of unique components is subject to the chosen license. You can see which modules your license includes by clicking Help -> Info about ...

If you want to buy additional licenses, contact your distributor or sales@copadata.com.

info Information

Unique elements of the Project Manager like variables or functions can be shown in an extra window. To do so, click Open in new window in the context menu. This way, you can simultaneously edit for example variables and functions.


Workspace detail view

Manual -> Editor -> Project Manager -> Workspace -> Workspace detail view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Projects are administered in the detail view of the workspace. Only projects that are currently loaded are shown, that is the active projects and the projects with the Keep project in memory property active.

Toolbar

Symbol

Description

Project new

Opens the dialog to create a new project.

Insert project into workspace

Opens the dialog to add an existing project.

Insert project 5.50

Opens the file browser to select a project from version 5.50.

Restore project backup

Opens the dialog to restore a project backup.

Delete selected project

Deletes the selected project after a confirmation message. If several projects are selected, the the one that was highlighted last is deleted.

Workspace

Actions for the workspace:

  • New: Opens dialog to create a new workspace.
  • Open: Opens dialog to open an existing workspace.
  • Save: Saves the workspace.
  • Save as: Saves the workspace under a different name.
  • Close: Closes the active workspace.
  • Create backup: Opens the dialog for creating a backup.
  • Restore backup: Opens the dialog for restoring a backup.

Open VSTA Editor with WorkspaceAddin

Opens the VSTA editor with the zenon workspace add-in.

Open VBA editor

Opens the VBA Editor.

Wizards

Opens the dialog with the wizards.

Update wizards

Opens the dialog to update the wizards.

Remove all filters

Removes all set filter.

Properties

Opens the properties window.

Help

Opens online help.

These actions are also available as commands in the context menu of the Workspace node.


Detail view of the Project Manager

Manual -> Editor -> Project Manager -> Detail view of the Project Manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If an element is chosen in the tree view of the Project Manager, the detail view shows all included objects and their properties.

in tabular view, you can:

Action

Course of action

free to choose columns:

Right-click on a column title -> context-sensitive menu -> column choice

Change column width:

  • Move the mouse on the column title separator until the mouse pointer changes to a cross
  • keep the left mouse button pressed
  • Stretch column to desired width

Sort columns:

Clicking on the column title changes the sorting order of the list (ascending / descending).

Format column

Right-click on a column title -> context-sensitive menu -> format column

Group properties

Right click on a column title -> context-sensitive menu -> group according to that column or:

Right-click on a column title -> context-sensitive menu -> cancel grouping

Adjust display to window width

Right-click on a column title -> context-sensitive menu -> adjust size to window width

Remove columns

Right-click on a column title -> context-sensitive menu -> remove this column

Context menu

Command | Action
Ascending | sorts the column in ascending order
Descending | sorts the column in descending order
Group on this column | Groups elements according to this column
Resolve grouping | Cancels existing grouping
Column selection... | a dialog for choosing the columns which shall be displayed is opened
Format column... | Opens a dialog for formatting the column
Adjust size to window width | all columns are distributed in the whole window
Remove this column | removes column from the view

Status line

In lists, the status line of the detail view shows information about available, filtered and chosen elements.

Example Example

Display status line detail view: 39 total / 30 filtered / 2 selected means

  • 39 elements are available
  • 30 are displayed based on the filter settings
  • 2 were chosen

For Variables, the number of used and licensed TAGs / IOs is displayed,

e.g. 32 TAGs used / unlimited TAGs available.

info Information

Detailed information concerning editing and managing elements can be found in chapter Edit entriesand in the description of the respective elements.


Edit entries

Manual -> Editor -> Project Manager -> Detail view of the Project Manager -> Edit entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You have multiple options to edit the entries:

Route

Course of actions

Toolbar detail view

  • Select the cell you want to edit by left-clicking on it.
  • Click on the buttons Edit selected cell in the tool bar.

Context menu
  • Click on the desired cell with the right mouse button.
  • In the context menu select the entry Edit selected cell.

Delayed double-click

  • Mark the desired cell with a delayed-double click (click twice slowly).

Properties window

  • Mark the desired element.
  • Edit the desired entry in the window Properties.

F2 KEY

  • Select the cell you want to edit by left-clicking on it.
  • Press F2

info Information

The whole cell is marked if you click into a cell. You can see which cell you have selected by the binoculars symbol in the column title.

attention Attention

Exceptions

  • You can change only properties in the detail view that are changeable in the properties window. For example, the name of a system variable cannot be edited.
  • In the History of changes, it is not possible to make changes at all because of FDA rules.
  • In project backups you can only edit the backup name.


Toolbar detail view

Manual -> Editor -> Project Manager -> Detail view of the Project Manager -> Toolbar detail view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On the upper border of the detail view, there is a toolbar which offers you all the functions that you can also find in the context menu. Depending on what you selected in the project tree (e.g. screens, variables, symbols, etc.) you will see different buttons in the toolbar.

Buttons that cannot be used at the moment are grayed out.

Tool Bar

No. | Symbol | Action
01 | New variable | Opens the dialog for creating a new variable.
02 | Create standard function | Opens the wizard for selecting the variables and the set values and creates a matching function. The action is documented in the output window.
03 | Variable use | Creates a project analysis for selected variables in the current project and displays it as a result list in its own window.
04 | Display unused variables | Creates a project analysis for unused variables in the current project and displays it as a result list in its own window.
05 | Jump back to starting element | If you entered the list via function linked elements, the symbol leads back to the start element. Only available in the context menu when all linked elements are opened.
06 | Copy | Copies the selected entries to the clipboard.
07 | Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
08 | Delete | Deletes selected entries after a confirmation from list.
09 | Expand/collapse | Drop-down list in order to expand or to collapse all nodes or the selected nodes.
10 | Activate all | Activates all inactive elements of a structure variable.
11 | Activate | Activates the selected elements of a structure variable.
12 | Deactivate | Deactivates the selected elements of a structure variable.
13 | Export selected XML | Exports selected elements as an XML file.
14 | Import XML | Imports variables from an XML file.
15 | Import/Export | Opens the menu for importing and exporting of -Step 7 projects, dBase and CSV. Note: For additional information please read the chapter Step 7-project import in the book import - export.
16 | Extended filter | Activate/Deactivate expanded filter Activating opens the dialog to select the filter criteria.
17 | Remove all filters | Removes all filter settings.
18 | Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
19 | Replace text in selected column | Opens the dialog for searching and replacing texts.
20 | Replace text in limits | Opens the dialog for the selection of the Dynamic properties Once the property has been selected, the search and replace dialog is opened by clicking on OK.
21 | Properties | Opens the Properties window for the selected entry.
22 | Help | Opens online help.

Context menu

Menu item

Action

New variable

Opens the dialog for creating a new variable.

Create standard function

Opens the wizard for selecting the variables and the set values and creates a matching function. The action is documented in the output window.

Linked elements

Opens the submenu with linked elements.

Variable use

Creates a project analysis for selected variables in the current project and displays it as a result list in its own window.

Display unused variables

Creates a project analysis for unused variables in the current project and displays it as a result list in its own window.

Copy

Copies the selected entries to the clipboard.

Paste

Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".

Delete

Deletes selected entries after a confirmation from list.

Expand/collapse node

Allows all or selected nodes to be expanded or collapsed. Selection:

  • Expand all
  • Collapse all
  • Expand selected
  • Reduce selected

Activate all

Activates all inactive elements of a structure variable.

Activate

Activates the selected elements of a structure variable.

Deactivate

Deactivates the selected elements of a structure variable.

Export selected XML

Exports all selected entries as an XML file.

Import XML

Imports entries from an XML file.

Extended import/export

Opens the menu for importing and exporting of -Step 7 projects, dBase and CSV.

Note: For additional information please read the chapter Step 7-project import in the book import - export.

Extended filter

Activate/Deactivate expanded filter

Activating opens the dialog to select the filter criteria.

Remove all filters

Removes all filter settings.

Edit selected cell

Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.

Replace text in selected column

Opens the dialog for searching and replacing texts.

Replace text in limits

Opens the dialog for the selection of the Dynamic properties Once the property has been selected, the search and replace dialog is opened by clicking on OK.

Properties

Opens the Properties window for the selected entry.

Help

Opens online help.


Navigation in the list view

Manual -> Editor -> Project Manager -> Detail view of the Project Manager -> Navigation in the list view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To navigate in a list:

  1. Click in the column to be searched.
  2. Enter the first character to start the search. If no entry with this initial character exists, the search is immediately stopped.
  3. The first found entry is selected. An input field is displayed. The first character of the column text is selected.
    Note: You can only enter search criteria in this field. It is not possible to change the element´s name.
  4. Enter further characters to limit the search. If no matching entry is found, the entered character is rejected and the selection stays at the current position.
  5. If more than one entry exists for the search criteria, the user can reach the other entries by pressing Ctrl+up or Ctrl+down.
  6. With Backspace the last character of the search criteria is deleted and a new search with the remaining characters is initiated. The search can be stopped by deleting the last character.

Sorting

You can select multiple columns simultaneously for sorting the list view.

  1. Click on the column heading of the column with the first sorting criteria
  2. Hold down the shift key and click on the title with the second sorting criteria;
  3. You can add as many columns as you like

    For example: Sorting according to data block and offset then shows firstly all datablocks and all attendant addresses correctly sorted.

Hint: A second click on the column title changes the sorting order.


Filter list entries

Manual -> Editor -> Project Manager -> Detail view of the Project Manager -> Filter list entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Elements of the detail view can be filtered and sorted according to different criteria:

Style

Course of actions

Alphabetic sorting

Mouse click on a column title: The list is sorted according to the according column. A second mouse-click on the column title inverts the sorting.

Entering filter criteria

Directly below the column title is the location of the Fieldfor filter criteria. Here, criteria are entered.

Now only elements are shown that are corresponding to the entered search criteria.

To show all objects once again, you have to delete the filter criteria.

If you click on the filter field, a drop-down list opens listing the last used filters of this column.

Filtering on checkboxes

Lists with checkboxes (e.g. templates) can be sorted and filtered according to active / inactive checkboxes.

This works in the same way as alphabetic sorting.

You can find a drop-down list for the filtering criteria with the selection for active, inactive or all checkboxes beneath the cell under the column title.

Placeholder

There are several place holders available for filtering criteria:

  • * replaces a character sequence.
    Example: *1 filters all elements that end with the character 1, for example Variable1.
    Wildcards can only be used as a prefix or suffix.
  • ? replaces a unique character
    Example: Variable? filters all elements that start with the character sequence variable and possess an additional character, e.g. variable1, variable2, variable3 ...

Logical Link

Filter words can be linked with the logical expressions AND and OR. This also works in conjunction with wildcards (*), but not with placeholders for an individual character (?).

Cell contents as filter criterion

Words or character sequences from a cell of the detail view can be defined as filters:

  • Highlight the desired entry.
  • Hold ALT and click on the cell.
  • The entry is released in an editing field.
  • Select any chain of characters with the mouse.
  • Move the selected part with pressed left mouse button (Drag&Drop) on the filter row of the column head.
  • The chosen chain of characters becomes the new filter text.

Filter effect linked elements

Elements that are linked with the current element can be displayed using the option linked elements . If you reach an element in the detail view via this option, for example a variable, then this element is shown regardless of the current filter settings. If it is not available in the current filter, it is shown on the end of the list regardless and is selected automatically.

Change properties

After an object has been selected in the detail view or has been created via the context menu, its parameters can be defined and changed in the properties window.

Multiple selection is allowed here. If multiple objects have been selected in parallel, you can change their properties together.

Entries and changes in the properties window are valid for all selected objects. Existing entries are overwritten. The properties window provides now only properties that are valid for all selected objects.

Extended filters for variables

Especially for variables there is a dialog for refinement of the filters. You can reach it via:

  • the symbol activate extended filter in the detail view toolbar or
  • the command Extended filter in the context menu

Thus, the standard filters are expanded with the elements Data types, Selection flagsand String filters (variable name, identification, reaction matrix).
  • Execute filter: Pressing the Enter key in the filter field carries out the filtering.
  • Delete filter: To remove the filter, click on the Remove all filters button in the tool bar or select the Remove all filters command in the context menu.


Replace text in selected column

Manual -> Editor -> Project Manager -> Detail view of the Project Manager -> Replace text in selected column

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon supports search/replace functionality for strings (e.g. screen names, variable names, variable identifications). You can replace texts in active columns and within limits.

attention Attention

Only texts are considered that are situated in open structures (variables or data types). Closed structures do not exist as a target for the editor and must be expanded before the search.

Replace text in selected column:

  1. Activate the dialog with the symbol Replace text in selected column or the relevant command in the context menu.
  2. Define the parameters for 'search and replace' in the dialog.
  3. The replacement takes place in the active column. You can indentify the active column by the Binoculars symbol beneath the column title.

attention Attention

If language switching is used for variable identification (recognizable from the key word @), the Display not translated keywords property must be activated for correct finding and replacing. To activate it:

  • navigate to the Graphical design node in properties
  • Check the Display not translated keywords property checkbox


Replace text in limits

Manual -> Editor -> Project Manager -> Detail view of the Project Manager -> Replace text in limits

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To replace text in limits:

  • Activate the dialog with the symbol Replace text in limits or the relevant command in the context menu.
  • Choose the desired dynamic property from the selection window.

  • You are now in the dialog Replace text in limits.

attention Attention

Only texts are considered that are situated in open structures (variables or data types). Closed structures do not exist as a target for the editor and must be expanded before the search.


Show/hide columns

Manual -> Editor -> Project Manager -> Detail view of the Project Manager -> Show/hide columns

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can show and hide the columns available in the detail view to your liking; you can sort them in any order you like. The following settings can be also be reached using screen switching dialogs for some screens.

Show / hide columns

  1. Right-click on a column title.
  2. Select Select column from the context menu.
  3. In the following dialog, select or deselect columns:

    You can select multiple columns by holding Shift or Ctrl like you´re used to in your operating system.

  4. Available columns lists all columns that are still available. Selected columns displays all active columns.

Button | Function
Available columns | List of columns that can be displayed in the table.
Selected columns | Columns that are displayed in the table.
Add | Moves the selected column from the available ones to the selected items. After you confirm the dialog with OK, they are shown in the detail view.
Add all | Moves all available columns to the selected columns.
Remove | Removes the marked columns from the selected items and shows them in the list of available columns. After you confirm the dialog with OK, they are removed from the detail view.
Remove all | All columns are removed from the list of the selected columns.
Up | Moves the selected entry upward. This function is only available for unique entries, multiple selection is not possible.
Down | Moves the selected entry downward. This function is only available for unique entries, multiple selection is not possible.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.

Arrange columns

The columns can be ordered according to your interests. There are two possibilities for doing so

  1. In the dialog Column settings via buttons up and down.
  2. In the detail view of the Project Manager by dragging & dropping with the mouse:
    • Click with the mouse on the desired column title.
    • Hold down the left mouse button
    • and move the column title to the desired location. Two red arrows mark the location where the column is inserted.
    • Place the column by releasing the mouse button.


Column settings

Manual -> Editor -> Project Manager -> Detail view of the Project Manager -> Column settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration of the properties of the columns for configurable lists. The settings have an effect on the respective list in the Editor or - when configuring screen switching - in Runtime.

Available columns

Parameters | Description
Available columns | List of the available columns via Column selection. The highlighted column is configured via the options in the Settings area.

Settings

Parameters

Description

Settings

Settings for selected column.

Labeling

Name for column title.

The column title is online language switchable. To do this, the @ character must be entered in front of the name.

Width

Width of the column in characters.
Calculation: Number time average character width of the selected font.

Alignment

Alignment. Selection by means of radio buttons.

Possible settings:

  • Left-justified: Text is justified on the left edge of the column.
  • Centered: Text is displayed centered in the column.
  • Right: Text is justified on the right edge of the column.

Deactivate column filter in the Runtime

Active: The filter for this column cannot be changed in Runtime.

Note: Only available for:

  • Batch Control
  • Extended Trend
  • Filter screens
  • Message Control
  • Recipegroup Manager

User defined colors

Properties in order to define user-defined colors for text and background. The settings have an effect on the Editor and Runtime.

Note:

  • These settings are only available for configurable lists.
  • In addition, the respective focus in the list can be signalized in Runtime by means of different text and background colors. These are configured using the project properties.

User defined colors

Active: User-defined colors are used.

Text color

Color for text display. Clicking on the color opens the palette to select a color.

Background color

Color for the display of the cell background. Clicking on the color opens the palette to select a color.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Files

Manual -> Editor -> Project Manager -> Files

External files can be integrated in a project in the Project Manager via the node Files. An external program has to be used to edit external files. This means: You can for example integrate a video clip. But you need the according software for editing it. zenon only manages these files.

The following external files are available for you:

  • Graphics
  • Help
  • Multimedia
  • Texts and formats
  • Driver
  • Report Viewer
  • Others

Sub folders

You can create sub folders on the nodes Help, Lists, Multimedia and Others. Select the entry New folder in the context-menu. By using sub folders, you can change the language in Runtime for documents, too.

attention Attention

Subfolders are only suitable for organizing language switching. All other elements such as graphics, multimedia files etc. must always be stored in the uppermost hierarchy of the folder, because they cannot be accessed by zenon from subfolders.

Context menu

Menu item | Action
Importing graphics file | Opens the File Manager for selecting a file.
Importing language table | Opens the File Manager for selecting a file.
Importing help file | Opens the File Manager for selecting a file.
Importing multimedia file | Opens the File Manager for selecting a file.
Importing list file | Opens the File Manager for selecting a file.
Importing driver data | Opens the File Manager for selecting a file.
Importing report template | Opens the File Manager for selecting a file.
Importing other file | Opens the File Manager for selecting a file.
Help | Opens online help.


Graphics

Manual -> Editor -> Project Manager -> Files -> Graphics

Graphics files for background graphics or dynamic elements. The following formats are available:

  • *.bmp
  • *.gif
  • *.jpg
  • *.png
  • *.wmf
  • *.XAML Note: Available only for WPF element! The XAML-files cannot be previewed in the detail view!

Context menu

Menu item | Action
Add file | Opens the File Manager for selecting a file.
New folder | Inserts a new sub-folder.
Rename folder | Enables renaming of self-created sub-folders.
Delete folder | Deletes the selected self-created folder after a confirmation message.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.


Graphics toolbar and context menus

Manual -> Editor -> Project Manager -> Files -> Graphics -> Graphics toolbar and context menus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu graphics

Menu item | Action
Add file | Opens the File Manager for selecting a file.
Process file externally | Opens your operating system´s default program for editing the selected file.
Process file externally with | Opens a list of suitable programs for editing the selected file.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Remove all filters | Removes all filter settings.
Help | Opens online help.


Help

Manual -> Editor -> Project Manager -> Files -> Help

Folder for help files for the Runtime help of the project. They are saved in *.chm format.

Context menu

Menu item | Action
Add file | Opens the File Manager for selecting a file.
New folder | Inserts a new sub-folder.
Rename folder | Enables renaming of self-created sub-folders.
Delete folder | Deletes the selected self-created folder after a confirmation message.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.


Help toolbar and context menus

Manual -> Editor -> Project Manager -> Files -> Help -> Help toolbar and context menus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu help

Menu item | Action
Add file | Opens the File Manager for selecting a file.
Process file externally | Opens your operating system´s default program for editing the selected file.
Process file externally with | Opens a list of suitable programs for editing the selected file.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Remove all filters | Removes all filter settings.
Help | Opens online help.


Multimedia

Manual -> Editor -> Project Manager -> Files -> Multimedia

The following formats of audio- and video files can be implemented:

  • *.avi
  • *.mp3
  • *.mpeg
  • *.wav

Please mind that the specific codecs are required on the Runtime device for playback of audio and video files.

Context menu

Menu item | Action
Add file | Opens the File Manager for selecting a file.
New folder | Inserts a new sub-folder.
Rename folder | Enables renaming of self-created sub-folders.
Delete folder | Deletes the selected self-created folder after a confirmation message.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.


Multimedia toolbar and context menus

Manual -> Editor -> Project Manager -> Files -> Multimedia -> Multimedia toolbar and context menus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu multimedia

Menu item | Action
Add file | Opens the File Manager for selecting a file.
Process file externally | Opens your operating system´s default program for editing the selected file.
Process file externally with | Opens a list of suitable programs for editing the selected file.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Remove all filters | Removes all filter settings.
Help | Opens online help.


Texts and formats

Manual -> Editor -> Project Manager -> Files -> Texts and formats

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Texts and formats are:

  • Text files for display in the project
    file extension: .txt
  • Format files for formatting printouts
    file extension: .frm
  • HTML files that are shown in the HTML screen
    file extension: .htm or .html

Context menu

Menu item | Action
Add file | Opens the File Manager for selecting a file.
New folder | Inserts a new sub-folder.
Rename folder | Enables renaming of self-created sub-folders.
Delete folder | Deletes the selected self-created folder after a confirmation message.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.


Texts and formats toolbar ans context menu

Manual -> Editor -> Project Manager -> Files -> Texts and formats -> Texts and formats toolbar ans context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu Texts and formats

Menu item | Action
Add file | Opens the File Manager for selecting a file.
Process file externally | Opens your operating system´s default program for editing the selected file.
Process file externally with | Opens the selected file in the standard editor of the file format or offers a selection of suitable editors.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Remove all filters | Removes all filter settings.
Help | Opens online help.


Driver

Manual -> Editor -> Project Manager -> Files -> Driver

Driver files can be implemented in the following formats:

  • *.cfg
  • *.iso
  • *.tcp
  • *.bur
  • *.fms
  • *.bec
  • *.ovd
  • *.nmp
  • *.ini
  • *.h11
  • *.lst
  • *.dde
  • *.lon
  • *.opc
  • *.ecs

Usually you don´t need to enter them here. The files are automatically created when a driver is created and are saved here.

Context menu

Menu item | Action
Add file | Opens the File Manager for selecting a file.
New folder | Inserts a new sub-folder.
Rename folder | Enables renaming of self-created sub-folders.
Delete folder | Deletes the selected self-created folder after a confirmation message.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.


Driver toolbar and context menu

Manual -> Editor -> Project Manager -> Files -> Driver -> Driver toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu drivers

Menu item | Action
Add file | Opens the File Manager for selecting a file.
Process file externally | Opens your operating system´s default program for editing the selected file.
Process file externally with | Opens a list of suitable programs for editing the selected file.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Remove all filters | Removes all filter settings.
Help | Opens online help.


Report Viewer

Manual -> Editor -> Project Manager -> Files -> Report Viewer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Report templates are files in RDL 2.0 format, which can be opened, displayed and edited in the zenon Report Viewer.

Context menu

Menu item | Action
Add file | Opens the file manager for selecting a report definition file.
New folder | Inserts a new sub-folder.
Rename folder | Enables renaming of self-created sub-folders.
Delete folder | Deletes the selected self-created folder after a confirmation message.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.

Note: Only present if Report Generator and Report Viewer are licensed.
Not available if the Windows CE project option (project propertiesGeneral) is active.


Report Viewer toolbar and context menu

Manual -> Editor -> Project Manager -> Files -> Report Viewer -> Report Viewer toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Report template context menu

Menu item | Action
New report definition file | Open the dialog to create a new RDL file on the basis of the previously-defined data sets.
Open report definition file | Opens the program linked to the RFL files to edit an existing definition file. zenon first looks for MS Report Builder, then for MS Report Designer by default.
Create standard function | Only available in the toolbar. Create a screen switch to a Report Viewer screen to be selected and enters the selected RDL file into the Report definition file.
Jump back to starting element | With linked elements, jumps back to the element from which the report template was jumped to. Only present in the context menu if linked elements are present.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Import existing report definition file | Opens dialog to import existing report definition files. These must be of RDL 2.0 type.
Remove all filters | Removes all filter settings.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Help | Opens online help.


Others

Manual -> Editor -> Project Manager -> Files -> Others

Folder for storage of any file type.

Context menu

Menu item | Action
Add file | Opens the File Manager for selecting a file.
New folder | Inserts a new sub-folder.
Rename folder | Enables renaming of self-created sub-folders.
Delete folder | Deletes the selected self-created folder after a confirmation message.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.


Other toolbar and context menu

Manual -> Editor -> Project Manager -> Files -> Others -> Other toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu others

Menu item | Action
Add file | Opens the File Manager for selecting a file.
Process file externally | Opens your operating system´s default program for editing the selected file.
Process file externally with | Opens a list of suitable programs for editing the selected file.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Remove all filters | Removes all filter settings.
Help | Opens online help.


General symbol library

Manual -> Editor -> Project Manager -> General symbol library

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon is supplied with pre-defined graphics. These are saved in the General symbol library module. The symbols in the folder Screens can only be used for the current screen; the symbols of the General symbol library can be used in every project .

You can also create your own symbols as well as group symbols or link them. You can find details in chapter Screens/symbols.


Selection dialogs

Manual -> Editor -> Project Manager -> Selection dialogs

In zenon selected dialogs and filtered lists are available for the selection of specific elements. They are valid for the whole system and list the current projects and sub-projects. They are available for:

  • User
  • Screens
  • Files
  • Datatypes
  • Functions
  • Frames
  • Driver
  • Variables

Detailed information about the views can be found in chapter Detail view of the Project Manager, detailed information about filtering of the lists can be found in the subchapter Filtering list entries.

Detailed information about the selection dialogs for functions and variables and the replacement of chosen functions or variables can be found in the subchapters:

  • Functions
  • Variables


Functions Selection dialog

Manual -> Editor -> Project Manager -> Selection dialogs -> Functions Selection dialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to select functions, a filtered dialog is opened:

Element

Description

Project tree

Definition of the project from which the function should be selected.

Selection window

Selection of the function.

No selection

Depending on the element:

  • the dialog is canceled
  • already linked functions are deleted

Hint: The size of this dialog can be adjusted. The dialog size and position are saved.

Change linked function

  1. manually
    • in the Project Manager´s Detail view open the functions
    • drag the desired function on the element while holding the left mouse button
    • the previous function is substituted by the new one
  2. automatic
    • Select the entry Replace links from the context menu. For more details see chapter Substitution of variables and functions in dynamic elements.


Variables selection dialog

Manual -> Editor -> Project Manager -> Selection dialogs -> Variables selection dialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to select variables, a filtered dialog is displayed.

Hint: The size of this dialog can be adjusted. The dialog size and position are saved.

Note: These variables can also be used throughout projects sometimes. When selecting throughout projects, ensure that the corresponding projects are available in Runtime.

Linking a variable

Elements that can only be linked with one unique variable open the following dialog:

Element

Description

Project tree

Selection of the project from which the variable is to be selected.

Selection window

Selection of the variable which shall be linked. It can be linked in two ways:

  • By double-clicking on the desired variable: The dialog is closed automatically.
  • By selecting the desired variable and subsequently clicking OK.

No selection

Depending on the element:

  • the dialog is canceled
  • Variables that are already linked are deleted (such as linked lot variables in the Historian)

Note: If the desired variable is not displayed, there can by several reasons for this:

  • You have selected a filter and the desired variable does not match the filter: Check whether there is a filter active in the filter line. The information about filtered elements which is displayed at the bottom of the selection window also helps when checking for an active filter.
  • The dialog is filtered by the Editor and the variable does not match the filter. The filtered display takes place when only special data types are allowed; e.g. for the dynamic element Numerical value no string variables can be linked.
  • You have selected the wring project in the project tree.

attention Attention

The dialog generally allows the choice of multiple variables via the usual Windows keyboard shortcuts, but in this step only one can be linked. For multiple selection the first chosen variable is assigned to the element.

Linking multiple variables:

Elements that can be linked with multiple variables open the following dialog:

Element

Description

Project tree

Definition of the project from which the variable shall be selected.

Selection window

Selection of the variables:

  • Double click the selected variable in order to add it to the variable list.
  • You can move the selected variable to the variable list via Drag&Drop
  • Select the desired variable. With the help of Ctrl and/or Shift multi-selection is possible. By clicking Add the selected variables are added to the variable list.

Variable list

Lists all selected variables.

Add

Adds the currently selected variable of the selection window to the variable list.

Delete

Removes the variables which are selected in the variable list from the list.

No selection

Depending on the element:

  • the dialog is canceled
  • certain links such as lot variables in archiving can be released

Note: If the desired variable is not displayed, there can by several reasons for this:

  • You have selected a filter and the desired variable does not match the filter: Check whether there is a filter active in the filter line. The information about filtered elements which is displayed at the bottom of the selection window also helps when checking for an active filter.
  • The dialog is filtered by the Editor and the variable does not match the filter. The filtered display takes place when only special data types are allowed; e.g. for the dynamic element Numerical value no string variables can be linked.
  • You have selected the wring project in the project tree.
  • Change linked variable

Select the entry Replace links from the element´s context menu. For more details see chapter Substitution of variables and functions in dynamic elements.


Archive variables selection dialog

Manual -> Editor -> Project Manager -> Selection dialogs -> Archive variables selection dialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To select variables of an archive, there is a dialog available that offers all previously-created and configured archives for selection.

Note: These variables can also be used throughout projects sometimes. When selecting throughout projects, ensure that the corresponding projects are available in Runtime.

Linking of variables

To select variables:

  1. Select the desired archive
  2. Open the archive tree
  3. Open the variable list
  4. select the desired variables

Parameters

Description

Project tree

Selection of the project from which the variable is to be selected.

Selection window

Selection of the variables that are to be linked. It can be linked in two ways:

  • Double-clicking on the desired variable
  • Select the desired variables and then click on Paste or Replace

Paste

Adds the variable selected in the selection window to the list of variables.

Replace

Adds the variables selected in the selection window to the list of variables and replaces the variables in this list in the process. If several variables have been selected in the selection window, the one that was selected last was added.

Delete

Deletes the selected variable from the list of variables.

List of variables

List of the variables selected for linking.

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Help

Opens online help.

Hint: The size of this dialog can be adjusted. The dialog size and position are saved.


Frames

Manual -> Editor -> Project Manager -> Selection dialogs -> Frames

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the frame selection dialog, frames can be selected for the execution of functions, from:

  • Current project
  • Subprojects
  • All projects in the workspace with the Keep project in memory option active

Parameters | Description
Project tree window | Displays all projects in the workspace. Frames can be selected from the current project and from all projects with the Keep project in memory option active
Frames window | Selection of a frame. If several frames are selected, the frame at the top of the list is used to execute the function.
No selection | Removes selection and closes dialog.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Files

Manual -> Editor -> Project Manager -> Selection dialogs -> Files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can select files of the current project or sub-projects in a view that can be filtered in the file selection dialog:

  • If desired files in the Files/Graphics nodes are not yet present in the Project Manager, these can be added in the selection dialog.
  • to select a file directly from any desired folder on the computer, the Direct file selection property must be activated.


Screens

Manual -> Editor -> Project Manager -> Selection dialogs -> Screens

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the screens selection dialog, screens can be selected for the execution of functions from:

  • Current project
  • Subprojects
  • All projects in the workspace with the Keep project in memory option active

Parameters | Description
Project tree window | Displays all projects in the workspace. Screens can be selected from the current project and from all projects with the Keep project in memory option active
Screens window | Selection of the screen. If several screens are selected, the screen at the top of the list is used for the execution of the function.
No selection | Removes selection and closes dialog.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Filter screens

Manual -> Editor -> Project Manager -> Selection dialogs -> Filter screens

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When screen switching on a screen with filter to other screens (AML filter, CEL filter, time filter), a dialog for screen selection is opened for:

  • Calling screen
  • Screens to be updated

Selection of screen to be called up

Parameters | Description
Project tree window | Displays the current project. Screens can only be selected from this project.
Screens window | Selection of the screen. If several screens are selected, the screen is switched to the first selected screen.
No selection | Has no function for this screen selection.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.

Selection of screen to be updated

Parameters | Description
Project tree window | Displays the current project. Screens can only be selected from this project.
Screens window | Selection of the screens that are to be updated. Subscreens of faceplates can be selected for screen switching to AML filter, CEL filter, time filter and equipment model. For these screens, the name of the faceplate screen is placed in front of the subscreen in order to clearly distinguish them from other screens. Multiple selection is possible. Add by double-clicking or using the Add button.
Window selection | Lists all selected screens.
Add | Adds the elements highlighted in the screens window to the selection window.
Remove | Deletes highlighted elements from the selection window.
No selection | Removes all currently-linked screens.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


User

Manual -> Editor -> Project Manager -> Selection dialogs -> User

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Selection of users of the active project, all sub-projects and the global project.

Parameters | Description
List workspace | Display and selection of the projects from which users can be selected.
List user | Display of the users of the selected projects. The list can be filtered.
No selection | An already selected user is deselected.
OK | Applies changes and closes dialog.
Cancel | Discards changes and closes dialog.
Help | Opens online help.


Driver

Manual -> Editor -> Project Manager -> Selection dialogs -> Driver

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the selection dialog Drivers, the drivers of the current project or of the sub-projects can be selected in a filterable view.


Datatypes

Manual -> Editor -> Project Manager -> Selection dialogs -> Datatypes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the selection dialog Data types, the data types of the current project or the sub-projects can be selected in a filterable view.


Main window

Manual -> Editor -> Main window

In the main window documents such as screens, reports, etc. are displayed and edited. The main window is the only window that cannot be hidden.

Open multiple documents parallel.

You can display multiple screens in the main window at the same time. The screens can be selected with tabs at the top of the main window and can be positioned via options in menu item Windows. When switching the tabs, the elements in the properties window are amended to the selected tab.

To close open screens, use the keyboard shortcut Ctrl+F4, the context menu or the command Screen-> Close.

Context menu documents

Right-click on the tab of a document in order to open the context menu.

Parameters | Description
Save | Saves the document.
Close | Closes the document.
Close all others | Closes all other documents.

Position elements in the screen

Activate elements by clicking on the symbol in the Toolbar elements and open them with the mouse in the main window.

There are multiple possibilities for moving the elements:

  • Move quickly: Click element and position it with the mouse.
  • Position exactly: Click element and position it with the arrow keys.
  • Turning: Rotate the element with the "handle" on the Reference point as desired.


Properties window

Manual -> Editor -> Properties window

The properties window displays parameters and properties of objects that were selected in the detail view of the Project Manager, or of elements that were selected in a screen. You enter values and parameters in the properties window or change them for marked objects and elements. When switching the tab in the main window, the properties displayed in the properties window are amended to the active tab.

The settings for view, sorting and the favorites are saved for the next start of the Editor. When editing a property of an element in the property window, the last selected property is offered automatically, when another element is selected.

Multiselect

If you choose multiple objects at the same time (multiselect), all properties that are different in the chosen elements are shown with an orange background or are marked in red in the properties window. The properties of the last respective element selected are displayed. In the group view and All properties, a selected property can then be transferred to all other highlighted objects by pressing the Return key. (not possible in the dialog view.)

Example Example

Several objects with different fill colors are highlighted. The last highlighted element has a green fill color. The Fill color property is then displayed in green, the value #32CD32 is highlighted in red. Clicking in the input field and pressing the Return key transfers the green property to all highlighted elements.

Keyboard operation

You can navigate in the properties, too, by using the keyboard:

Key | Function
Tab or Up | Switches to the next property.
Shift+Tab or arrow down | Changes to the preceding property.
Enter or arrow right | Opens a node.
Left | Closes a node.
Pos 1 | Jumps to the first node.
End | Jumps to the last node.

Toolbar

The properties of an object are shown and can be edited in the properties-window. A toolbar is available for administration of the properties screen.

Symbol

(from left to right)

Function

Grouped view

(default)

All properties of the selected object are logically grouped; the groups can be sorted alphabetically or logically. With the context menu, properties can be added to or removed from the Favorites.

Standard for manual: Hints in the manual concerning the properties always use the grouped view. The contents of the groups are the same as in the dialog view.

All properties

All properties of the selected object are displayed in a list. With the context menu, properties can be added to or removed from the Favorites.

Dialog view

All properties are grouped logically like in the Grouped view , the groups are displayed sorted by application priority in dialog form. In this view, no favorites can be defined.

Show/hide favorites

Shows / hides the node Favorites in the top spot of the views Grouped view or All settings. The most frequently used properties are collected here.

Default favorites are proposed.

Add / remove entries to the favorites: You can do this either by using the context menu Add to favoritesor by moving the desired properties to the favorites toolbar using Drag&Drop.

The order of the properties in the favorites is determined by the sorting criterion (ascending, descending, logic).

In the Dialog view favorites cannot be created.

Show/hide all properties

Shows / hides all nodes in the views Grouped and All Properties.

Sorted logically

(default)

Displays the properties logically sorted according to application frequency instead of alphabetically sorted in the views Grouped and All properties.

Sort ascending/descending

Displays the properties either in ascending or descending alphabetical order in the views Grouped and All properties.

Open/close all sections

Shows / hides all nodes in the views Grouped and All Properties.

Exception: The node of the current property is not closed, if Close all nodes is selected.

Display properties help

Displays the integrated help for the properties (properties help).

Release property

Symbols: Releases the selected property.

Options for symbol bar

Clicking on the arrow opens the submenu:

Active: Tool bar is displayed

If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar.

Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.


Grouped view

Manual -> Editor -> Properties window -> Grouped view

The Grouped viewis active per default. It groups properties that logically belong together,

All properties can be hidden and shown using the toolbar.

info Information

Hints in the manual concerning the properties always use the grouped view. The contents of the groups are the same as in the dialog view.


Dialog view

Manual -> Editor -> Properties window -> Dialog view

The Dialog view summarizes properties in groups and presents them in dialogs.

In the Dialog view it is not possible to create favorites and to hide properties.


All properties

Manual -> Editor -> Properties window -> All properties

All properties are displayed in an alphabetically ordered list.

All properties can be hidden and shown using the toolbar.


Favorites

Manual -> Editor -> Properties window -> Favorites

The views Grouped and All properties have a node Favorites on the top position of the window. Here are properties shown that are used quite often.

Default favorites are proposed. To add own entries:

  • Right-click on the desired property.
  • In the context menu, choose <Property> add to favorites
  • The order of the properties in the favorites is determined by the Sort key (ascending, descending, logic).

To remove entries:

  • Right-click on the desired property.
  • In the context menu, choose <Property> remove from favorites

Favorites can be shown or hidden using the appropriate button in the toolbar.
Attention: In the Dialog view favorites cannot be created.


Sort properties

Manual -> Editor -> Properties window -> Sort properties

The sort key is defined with the buttons Sorted logically, Sorted ascending or Sorted descending in the toolbar. Per default the properties are sorted logically. They can be sorted alphabetically, too.

Sorted logically

The properties are sorted logically according to the likeliness of usage. This is only possible in the views Grouped and All Properties.

Sort ascending / descending

Here, properties can be sorted alphabetically ascending or descending. These options are possible in the views Grouped , All Properties and Favorites.

Close and expand nodes

It is possible to close all nodes and to expand them again in the views Grouped and All properties The node of the current property is not closed, if Close all nodes is selected.


Linked properties

Manual -> Editor -> Properties window -> Linked properties

Values can be linked for some properties such as variables or parameters in Batch Control. In this case, the value always changes if the value of the source property has been changed.

If an element accepts values from another property, this is shown with an arrow next to the value of the property.

Disconnecting the linking

To remove the linking of a value:

  1. Right-click on the property
  2. Select, in the context menu, the entry that separates the reference to the source property (wording dependent on the property)
    Note: You can also separate all values that have been transferred from the source property at once.

The linking is also removed if you overwrite the value with another value.

Changes to the source value therefore no longer have an effect on this value. The linking symbol (arrow) is no longer displayed.

Restore linking

To relink a separated value to the original source value again:

  1. Right-click on the property
  2. Select, in the context menu, the entry that reestablishes the reference to the source value (wording dependent on the property)
    Note: You can also reestablish all values that come from the source property at once.

This property therefore always accepts the respective current value of the source property. The linking symbol (arrow) is displayed again.


Property help

Manual -> Editor -> Property help

A separate window with help information on the individual properties can be shown.

To show the properties help:

  • Choose the symbol Show properties help (far right) in the properties tool bar.

  • Or choose the command Properties help from the menu Options.
  • or right-click on any title bar and choose the command Properties help in the context-sensitive menu.

Close properties help:

  • click the X on the right border of the title bar

Unlike the online help that can be called up pressing F1, this integrated properties help only describes the individually chosen property. You are provided with short information about the chosen property and a link to the more extensive online help.

The properties help can be undocked like other windows, you can position it anywhere you want on the screen.

Linked properties

You can find information on linked properties in the linked properties chapter.


Output window

Manual -> Editor -> Output window

The output window shows status information and error messages during startup of the Editor and during compilation and transfer of a project. The information is divided into different types:

  • Error
  • Warnings
  • Messages

These information messages can be shown and hidden individually. The settings for information display are retained after the Editor is closed; they are also valid for the display of new information. But no information is lost, because the settings only affect the display and not the collection of information.

Example: If warnings are hidden, they are not displayed until the display is turned on again. From that point on, all warnings are displayed. The warnings that were accumulated in the meantime are also shown.

The blue information messages cannot be hidden, because they are project-related messages that must always be visible.

Toolbar and context menu

Symbols and context menu offer the same options. The symbols´ meaning from left to right:

Symbol / entry context menu | Description
Display errors | Active: Errors are shown in red. Inactive: Errors are hidden. The chosen condition can be combined with warnings and messages and is retained when the editor is closed.
Display warnings | Active: Warnings are shown in orange. Inactive: Warnings are hidden. The chosen condition can be combined with Errors and messages and is retained when the editor is closed.
Show messages | Active: Messages are shown in black. Inactive: Messages are hidden. The chosen condition can be combined with errors and messages and is retained when the editor is closed.
Save | Saves the whole content of the output window to a LOG-file. You are free to choose storage location and file name.
Copy | Copies the selected list entry to the Windows Clipboard.
Delete | Deletes the whole contents of the output window. After this action is executed, it is not possible anymore to access the deleted contents of the output window.
Search | Opens the dialog for text search within the output window.
Help | Opens this help page.

Example Example

Delete the contents of the output window with the relevant symbol or the context menu, then generate the Runtime-files. The relevant information is provided in the output window. This information is enclosed by blue messages.

  1. Click on the symbol Messages: The standard messages (black) are hidden.
  2. Once again generate Runtime-files, the messages stay hidden.
  3. Now, hide also the display of errors (red) and warnings (orange).
  4. The blue project-related messages stay visible.
  5. Generate again runtime-files, show the messagesagain. All messages generated since the output window was deleted are visible again.


Status line

Manual -> Editor -> Status line

The Editor status bar provides information about (depending on the selected object):

  • Disposition of the Editor:
  • Function of the symbol over which the mouse pointer is located.
  • Position of the mouse pointer in screens.
  • Type and name of the active element in a screen.
  • Starting point (x/y axis), width and height of the active element in a screen.
    The 0/0 point of the axis is located in the upper left corner.

In reports, the status line has no function.


Closing the Editor

Manual -> Editor -> Closing the Editor

When closing the Editor or closing or switching the workspace, all projects are checked for changes. If there are projects whose latest Runtime files have not been created, they are listed in a dialog and offered for creation.

Parameters | Description
Yes | The Runtime files of all projects in the lists are created. Then the Editor is closed.
No | Runtime Files are not created. Then the Editor is closed.
Cancel | Runtime Files are not created. The Editor is not closed.


Project efficiently with the help of zenon

Manual -> Project efficiently with the help of zenon

Is it the first time you are using zenon?
Here you find information on how to use zenon efficiently. This chapter is recommended even when you already gathered some experience with other process control systems You´ll learn which basic ideas are behind zenon and how it works; why and how zenon helps you work easier and faster.

An overview of zenon

zenon consists of Editor and Runtime.
Projects are created in the Editor. Operation and monitoring is done in the Runtime. Editor and Runtime are compatible across versions from version 6.20 on. A project that was created with version 6.50 for example also works with Runtime version 6.22 and vice versa.

zenon mainly differs from other systems by:

  • Easy operation : Many actions can be achieved with a few mouse clicks; assistants and wizards make work easy and fast. You can work using drag&drop with the mouse or the keyboard - as you like it.
  • Practical object orientation: You work continuously with objects that can be parameterized swiftly instead of being programmed rather time-consumingly . Once defined, objects can be used across projects. You profit from inheritance and can change properties in the blink of an eye.
  • Excellent reusability of objects and elements that have been configured: Many elements, from individual variables to complete projects can be very easily and effectively reused in zenon.
  • Integrated network: Distributed engineering in the network and 100% redundancy are no longer a big effort. You can create networks by activating the relevant checkbox. This way, you can also network individual stand-alone projects to become efficient, redundant systems.

Tips and tricks

You can find useful tips in the forum of www.copadata.com. The best way to learn how get the most out of zenon is to visit the COPA-DATA trainings and workshops that are attuned to your priorities and projects. Your distributor has more information for you - or drop us a mail at sales@copadata.com.


Easy operation

Manual -> Project efficiently with the help of zenon -> Easy operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon makes projecting easier through many small amenities and thus increases your productivity. When working with zenon you´ll discover that you can solve many problems according to your preferences. For example:

Favorites

You can define your own favorites in the object properties and in the function dialog. You can choose from them at the beginning of the properties lists. That way you can swiftly access the properties you need frequently.

General keyboard operation in the Editor

The Editor can be easily operated via symbols and menus with the mouse; you can also universally use the keyboard. The shortcut key combinations from Windows also work in zenon. For example:

  • CTRL+C and CTRL+V forcopy and paste
  • INSERT creates new objects
  • DELdeletes selected objects
  • Mouse cursorkeys navigate in the views
  • Esc terminates the current action
  • Backspace jumps in the directory tree to the next higher level
  • CTRL+Z undoes the last actions with the exception of database operations

Read more about this in chapter Keyboard shortcuts.

Drag&Drop

In the Editor, it is possible to make worksteps easier by using Drag&Drop. For example:

  • Change the order of menu entries
  • Link fonts with dynamic elements like universal slider, clock, combined element etc.
  • Change the order of structure elements for structure data types
  • Change the order within a script
  • Copy or move functions using different scripts
  • Copy scripts by moving them onto the master node

Intelligent assistants and wizards for complex tasks

The assistants and wizards integrated in zenon help you to create a base project in no time or to purposefully make complex adjustments. We recommend the wizards for the universal slider, the combined element and the archiving especially for beginners.

Tooltips for elements and properties

If you move the mouse pointer above a display element (for example, a text button) or a linked property (for example the function linked to a text button), a tooltip pops up. It shows information about the linked elements, like the linked function and its parameters.

Extended drawing possibilities

The graphical editor offers a broad range of functions that make drawing the equipment easy and also offers you a lot of possibilities. From stepless zoom to scaling with a click, locking element corner points as well as automatic distribution of elements following rules. You can find details in chapter Images.

Go to linked element

For all graphical elements, functions, variables and other elements it´s possible to jump directly to the linked element. For example, you can click on a display element and are directly shown the linked variable, if you click on it you come directly to the used data type and by clicking on it you can even see the used unit. If you need to, you can conveniently take back all these steps up to the starting point with some mouse clicks.


Object-orientation

Manual -> Project efficiently with the help of zenon -> Object-orientation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

COPA-DATA sees the topic of automatization object-oriented and pragmatically. That´s how zenon works; furthermore, it can be largely automatized itself. You don´t need a programming language for zenon. You do not have to program one single line of code. Instead, you assign objects with properties using the mouse. That works not only with individual objects but also centrally for a whole project and across objects, too.

If you´re now worried that you can´t individualize zenon and are totally dependent on the object properties, the good news is: Of course you can individually adapt the design of zenon. To do so, use preferably VBA or the VSTA (.NET) development environment. Additionally, zenon offers many interfaces to communicate with hardware and software and boasts zenon Logic with an integrated SCADA logic .

Three important basic principles that help you with zenon

Three central principles make projecting with zenon easy, reliable and easy to maintain:

  1. Parameterizing instead of programming:

    Easily set the required parameters instead of programming or adapting scripts.

  2. Global / central instead of local:

    Define objects once and reuse them over and over, also across projects, instead of writing or copying scripts over and over again.

  3. Object-oriented parameterization:

    Use all advantages of object-oriented thinking.


Parameterizing instead of programming

Manual -> Project efficiently with the help of zenon -> Object-orientation -> Parameterizing instead of programming

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

How do you profit if you parameterize projects instead of programming them?

You dispense with code that is prone to errors and gain flexibility, clear structures, speed and high reusability. Four items are particularly in favor of parameterization:

  1. Predefined modules save time
    zenon contains many predefined modules. Instead of programming scripts yourself, you choose the suitable module and configure it by selecting the desired properties and parameters. That allows you to create executable projects in no time.
  2. The product from the manufacturer is already mature
    the designer concentrates on his projects. The software is developed and tested by the manufacturer, designers don´t have to write their own code. Therefore it´s very easy to operate zenon - also for employees with no experience in software engineering.
  3. Easy maintenance and adaptation of the project
    zenon works strictly object-oriented. Combined with the philosophy "setting parameters instead of programming", that means: simple maintenance and adaptation For changes and monitoring, you only have to verify or change the properties of the individual objects instead of reading and adapting long code lines. In the lifetime of the project that ensures
    • Overview: Projects can be reproduced even some years later, even by new employees.
    • Security: Error-prone scripts and programming is avoided.
    • You save time: Projection, adaptation and maintenance can be realized a lot quicker.
  4. Easy adaptation for different machines
    zenon can be adapted easily and swiftly to new or changed machines. Project adaptations can be done with just a few mouse clicks.

adapt zenon

Parameterization prevents errors in scripts from being copied again and again. It prevents tedious changes in many individual scripts if you just want to adapt little things. But that doesn´t mean you have to be inflexible. zenon, too, gives you opportunities to individually expand and adapt the system.

  • VBA/VSTA:
    With the integrated script language Visual Basic for Applications or C# and VB.NET, you can execute any code in the Runtime. This allows the execution of automation tasks, logical tasks and interfacing tasks like database access.
  • zenon Logic:
    This completely integrated control environment allows you with its SCADA logic to use all the five IEC 61131-3 languages. With it, you can complete all calculations and solve all logic problems.
  • PCE:
    The integrated Process Control Engine allows you to use VB-Script and Java Script for automation tasks.
  • ActiveX Controls:
    You can integrate standard controls like Flash Player, Acrobat Reader, etc. in zenon. Of course, the interface is disclosed so you can include your own ActiveX Controls.
  • WPF-Elements
    The direct integration of Microsoft´s Windows Presentation Foundation format allows you to integrate graphical elements like for example a button, a pointing device and many more things in this new graphics format directly in zenon images. These elements can be freely linked with variables and functions, which will allow you to implement any graphical effect you like.
  • COM-interface:
    You can access zenon via the completely disclosed COM-interface from outside. For communication needs, different programming languages like C++, .NET, Delphi and so on are provided.


Global and central instead of local

Manual -> Project efficiently with the help of zenon -> Object-orientation -> Global and central instead of local

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Properties can be defined in many ways in zenon, depending on the task:

  • directly on the object
  • Central
  • globally

Of course, in zenon you can adjust all settings directly at the object. But that is not always the smartest solution.

Define properties centrally

Often it makes sense to define settings only once centrally. This way, new objects offer the desired properties from the beginning. Changes are really easy: The desired property is changed only in one place centrally; all concerned objects adopt it automatically. That means only one click instead of many lines of code or many mouse clicks.

These central settings can be found easily from any position of the editor. Every object that gets settings directly from a central location offers the option to show them directly. You simply follow a link and see immediately how these elements are linked.

But you can´t only define properties centrally for a project, you can also define them globally.

Project globally

zenon allows you to work with more than one project at a time - and thus saves your most precious resource: Working Hours For example, it is really easy to use the same fonts in all projects. Once defined, properties like font or font size are instantly available for all projects of a work area. If you need another font for all projects, it´ll take you only some seconds to change it in the global project. What if you want to provide a project with a different font? Well, then you change this font centrally in that project.

info Information

In the global project, use a numbering system that is different from the one in the single projects. zenon always prefers the local settings if the numbers are identical.

And: Use own names for font lists that you keep consistent in the global project and in the individual projects. In doing so, you ensure that all fonts are found if the language is changed.

Overview the relations of objects:

Additionally, you can get an overview of your projects and object relations with:

  • Cross reference list:
    It shows cross references in a project and enables you to easily search for the usage of variables and functions.
  • Wizard for documentation
    It automatically creates complete project documentation. You can configure exactly what you want to be included, down to every single property.


Object-oriented parameterization

Manual -> Project efficiently with the help of zenon -> Object-orientation -> Object-oriented parameterization

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

"Object-oriented parameterization" is the fundamental philosophy of zenon. This philosophy arranges work clearly and saves time for creation and management of variables.

Each variable in zenon is based on two elements:

  • Driver
  • Data type


Drivers

Manual -> Project efficiently with the help of zenon -> Object-orientation -> Object-oriented parameterization -> Drivers

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Drivers are not directly integrated in zenon, they are implemented via a driver object type. This driver object type defines the area of the PLC that will be addressed.

Driver object type

There are many different driver object types, e.g. standard PLC markers, data blocks, inputs, outputs, counters, etc. – but also special types like alarm or driver variables.

The driver object type determines:

  • the area of the PLC
  • the driver´s granularity in that area
  • it defines the data types that can be created in the memory area

Hint: Not any data type can be created in any area. Therefore, always proceed as directed when creating a variable:

  • first the driver,
  • then driver object type and
  • lastly the data type

Aside: Granularity

Granularity is particularly important for numerical adressing PLCs, like for example Siemens S7. Not every PLC has the same resolution, and not every area in a PLC has the same resolution.

For example, the data block area of a Siemens S5 PLC is word-oriented, whereas its marker area is byte-oriented. This means that the smallest unit that can be addressed is one byte or word. Now if you want to write a bit into such an area, you have to read at least a whole byte/word, mask the desired bit, change it, and then write the whole byte/word back to the PLC.

The same information is required when addressing the areas, called offset. You start with zero and go on counting in byte/word steps. If you use automatic adressingin zenon granularity is automatically considered. So, granularity does not depend on the driver but on the driver object type.

Driver variables

Driver variables are offered by every driver and offer many advantages for projecting. They do not communicate with the PLC but read out an internal memory area of the driver which contains mainly statistical information. But you can also control special functions with variables like telephone numbers for modem connections or dial/hang-up commands.

You can find more information in the chapter Driver variables.

A dBase file with the most important driver variables is included on the installation CD of zenon. You can use it for the simple and efficient import of these variables into every driver instead of creating them manually.


Data types

Manual -> Project efficiently with the help of zenon -> Object-orientation -> Object-oriented parameterization -> Data types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Data types are the heart of object-oriented parameterization. As you cannot change anything in the driver ‑object types, they cannot be used for object-orientation. The data types, on the other hand, offer many possibilities.

We distinguish between three types:

  • Simple data types
  • Structure data types
  • Structure elements


Simple data types

Manual -> Project efficiently with the help of zenon -> Object-orientation -> Object-oriented parameterization -> Data types -> Simple data types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Simple data types are always IEC data types, that means data types defined by the IEC in the 61131-3 standard, like BOOL, INT, USINT, UDINT, STRING, WSTRING, etc. They help to define the size of an area - for example using
BOOL: 1 Bit
INT: 16 Bit signed
UINT: 16 Bit unsigned

The data types in zenon allow not only IEC data type, a lot more properties are available. They have the same description as the variables´ properties:

  • Identification
  • Unit
  • Value range
  • Limits

Why this "double accounting"?

The reason is easy to explain:
Just as a dynamical element takes over the font type and size from the linked font, the variable also takes over the value calculation, the unit and the limits from the data type it is based on.

Object-orientation

As opposed to the linking of dynamic elements and fonts, we are dealing with an object-oriented approach here: The data type object inherits its properties to the variable. The difference?

The linked/derived properties of the variable can be separated/overwritten. This works for every single property, but also for all properties at once. This means you can take over the unit from the data type centrally, yet overwrite the identification or the address directly at the variable. This is how it works:

  • Change the relevant value of the variable, then the link is separated.
    You can verify that by looking in the properties: The check is no longer there.

You can use further functions via the context menu:

  • Link property with datatype:

    If you have separated the link, you can reestablish it.

  • Separate property:

    You can separate a single property without having to change the value. If you change the value of the data type later on, the variable will not be modified by this action. This allows you to define exactly where the inheritance concept should be applied.

A useful option: you can also link or separate all properties from the data type with one mouse click. This allows you to switch to and from the original state (everything inherited) really quickly. How do I, as the user, profit from all this?

Increased flexibility: If you have many variables with the same limit, e.g. an alarm for value 1, you can simply set it at the data type. The actual limit and other optional parameters can then be set for every variable separately. You no longer have to create and update the limit for every single variable, which will drastically increase your engineering performance. The default data type BOOL has a predefined limit at 0 and 1!

If you don´t use a limit for each BOOL variable, you don´t have to take care and to manually deactivate the limit for each variable. Instead, you can conveniently use a feature of zenon and create your own BOOL data type. Proceed as directed:

  • Leave the standard data type as it is
  • Click on button New data type .
  • You will then be offered the list with the already existing data types.
  • Choose Standard BOOL:
  • Assign a name, e.g. MyBOOL
  • All the properties of the new data type are automatically taken over by the old one
  • Delete the limits inMyBool

Use this new data type MyBool to create all BOOL variables that are not supposed to have limits – this removes all unwanted limits. The other limits, which you do want to stay, will remain untouched.

Of course you can also create more of your own BOOL data types, as many as you like. All variables that require the same settings for most of their properties get their own data type. If one of the properties changes, you can perform the changes centrally and all derived variables will automatically be updated – except the ones whose links you separated.


Structure data types - structure elements - structure array

Manual -> Project efficiently with the help of zenon -> Object-orientation -> Object-oriented parameterization -> Data types -> Structure data types - structure elements - structure array

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Structure data types

Structure data type designates a group of data types whose sequence and arrangement is exactly defined. For example, a structure “Motor” can consist of the elements "Actual speed (RPM)" and "Power input".

A structure can also be nested, different hierarchy levels are possible.

With structure data types, you can build up your variable pool exactly as it exists in the PLC or in reality.

Structure element

A structure data type is actually just a hull that bears the name of the structure but does not have any properties of its own.

The properties will be assigned only after adding structure elements to the structure data type. We differentiate between the following types:

  • Linked structure data type:

    Reference to an existing data type. All properties are taken over except for the name.

    Advantage: If the structure element provides many properties of an already existing data type, they can be reused. Of course, you can still change each of the variable properties or separate them from the data type.

  • own embedded structure data type:

    allows for individual addressing settings. This new data type is only valid within this structure.

info Information

Advantage object orientation: If the structure changes somehow, it suffices to change the structure data type to adapt all variables in this structure automatically.

Changes are possible in all specifications:

  • simple properties like the unit of the data type
  • complex properties like adding or deleting a limit
  • Changing the whole structure, e.g. by changing the order of elements or adding / deleting unique structure elements in the structure data type

Structure array

If not only one machine is concerned but many, the structure array is used.

For example: 100 Pumps instead of 1 pump.
You simply change the structure variables to a structure array. With a single mouse click, 100 variables become 100 structure variables.

Sticking to our example, we have to create 12 variables for each of our pumps, which results in a total of 1200 variables. The method "object-oriented parametrization" makes that possible with just a few mouse clicks. As additional advantage, all variables are predefined. Every single variable already comes with all the properties it needs, e.g. unit, value calculation, alarms, CEL entries etc.

info Information

Structure data types are also suitable for the reuse of variables.


Example pump:

Manual -> Project efficiently with the help of zenon -> Object-orientation -> Object-oriented parameterization -> Data types -> Structure data types - structure elements - structure array -> Example pump:

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Example pump:

Initial situation

A pump consists of two motors. Each of these motors has some variables like:

  • Actual speed (RPM)
  • Power consumption
  • Output
  • etc.

Each motor has a slider with the following variables:

  • Nominal speed (RPM)
  • P-share
  • I-share

You build this constellation as directed:

  1. Create a structure slider from one data type each for
    • Nominal speed (RPM)
    • P-share
    • I-share
  2. Create a structure motor with these data types each:
    • Actual speed (RPM)
    • Power consumption
    • Output
    • etc.
  3. Adopt the slider in the structure motor .
  4. Finally, create the pump structure and integrate the motor into it.

    As we have two motors in our pump, you simply add the motor data type to your pump structure twice.

  5. Create a variable that is based on this structure data type:
    • Create new variable
    • Choose structure data type pump

    The individual elements of this structure variable are called Structure elements .You can use each of these elements everywhere in zenon- in screens, as alarms, in archives, in recipes, etc.


Tips for adressing and import / export

Manual -> Project efficiently with the help of zenon -> Object-orientation -> Object-oriented parameterization -> Tips for adressing and import / export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Practical examples:

  • Addressing
  • Import / Export

Addressing:

With numeric controls you can choose if adressing shall be automatic or semi-automatic. All properties described here can be reached, too, via VBA/VSTA and can thus be used for automatic projecting.

Automatic addressing:

The offset and, if required, the byte and bit addresses are calculated automatically for structure elements, based on the position of the structure elements - for arrays across the whole array. If you have created the same structure in the PLC and in zenon, everything works fine and you do not have to care about addressing.

Semi-automatic addressing:

Here, you assign unique start addresses already with the data type. The other addresses will then be determined based on these addresses. Of course, you can also change them later. Details can be found in Automatic addressing.

For symbolically adressed PLCs, you have to use the same name in zenon and in the PLC.

XML Import / Export:

Information like data types, structures, inherited properties etc. is also included when importing or exporting. This means that, once defined, you can comfortably export structure data types and structure variables and import them in other projects to reuse them or adapt them as needed.


Reusing elements

Manual -> Project efficiently with the help of zenon -> Reusing elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The first time a project is created, you need time for the creation of variables, functions, screens and their links. You can reduce this time considerably in following projects. Because with zenon you have the possibility to easily transfer elements that have been created to other projects.

For example, in many projects you need the standard components of every project, such as screens for the system status or detail screens for hardware components that are used repeatedly (pumps, valves, motors etc.).

The are different ways for you to reuse components:

Theme | Reuse of
Replacing variables and functions | Elements
Symbols | Screens
Structure data types | Variables
Reaction matrices | Variables
Global project | Central elements of a project
XML | Project parts by means of import and export
Wizards | Screens and elements by means of import or individualization
Reusing projects | Projects

info Information

To be able to reuse elements efficiently, ensure when you create variables, functions and screens that they are clearly named.


Replacing variables and functions

Manual -> Project efficiently with the help of zenon -> Reusing elements -> Replacing variables and functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Variables and functions that are stored as dynamic elements can be replaced in an automatic manner. This can take place at different places:

  • Replacing linking in a screen
  • Replacing linking for screen switching
  • Replacing indexes
  • You can also find more about replacement of variables and functions in the Screens manual in the Replacing linking of variables and functions section.


Naming conventions

Manual -> Project efficiently with the help of zenon -> Reusing elements -> Replacing variables and functions -> Naming conventions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To be able to replace variables and other elements securely, the naming should be systematic and standardized if possible. You therefore support not only the reusability, but also maintenance and reverse engineering.

Different systems support you with systematic naming.

For example: Energy industry

Germany

  • KKS (Kraftwerk-Kennzeichen-System - Power Plant Classification System), for details (in German), see http://de.wikipedia.org/wiki/Kraftwerk-Kennzeichensystem
  • DIN 6779 (Kennzeichnungssystematik für technische Produkte und technische Produktdokumentation - Classification System for Technical Products and Technical Product Documentation), for details (in German), see http://de.wikipedia.org/wiki/DIN_6779
  • AKZ (Anlagenkennzeichnungssystem - Equipment Classification System), for details (in German), see http://de.wikipedia.org/wiki/Anlagenkennzeichnungssystem

International

  • KKS (Power Plant Classification System), for details, see http://en.wikipedia.org/wiki/KKS_Power_Plant_Classification_System

Such standards exist for all industries. It is recommended that their naming convention is used.

SQL example

Variables are to be named in accordance with the KKS in an energy project. A corresponding variable with the label C01_MDY10-QA001_QA07 indicates:

  • Wind energy equipment C01 (row C, no. 1)
  • Wind turbine controlMDY10, Power part QA001,
  • Power protection QA07


Replacement possibilities

Manual -> Project efficiently with the help of zenon -> Reusing elements -> Replacing variables and functions -> Replacement possibilities

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Replacements can be used at different points in a project:

  • Replace linking in a screen: Screens are copied and the links are replaced in the copied screen.
  • Replacing linking for screen switching: Only one screen is used for different PLCs; the links are adapted when switching.
  • Replacing indices: Replacement of variables in a process screen using the value of index variables.


Replacing linking in a screen

Manual -> Project efficiently with the help of zenon -> Reusing elements -> Replacing variables and functions -> Replacement possibilities -> Replacing linking in a screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If variables are attached in a screen, these can be easily replaced by means of a replacement dialog. Requirement:

  • Clear naming of variables

With this, screens that have been created can continue to be used by copying & pasting. Replacement is is started using the context menu:

  • Right-click on the screen element
  • Click on Replace links

The dialog for replacement is then opened.

Example

In our example, the project has a number of variables from different equipment parts. The following are on the process screen:

  • 10 variables that come from the wind turbine control MDY10, linked to dynamic elements
  • Buttons with screen switching are present at different areas of MDY10

Using copy & paste, the person configuring the project intends to reuse the screen in its exact form for wind turbine control MDY11 and to replace the variables and/or functions by the corresponding ones from the new PLC. To do this:

  1. The dynamic elements that the variables and functions are linked to are highlighted
  2. The replacement dialog is opened

  3. In the Source field, the equipment identification *MDY10* is entered
    (the first and last * characters are wild cards)
  4. MDY11 is entered in the Target field
  5. Replacement is carried out with Accept, the replace and the dialog is closed with OK

The screen can now be used for the new PLC.


Replacing linking for screen switching

Manual -> Project efficiently with the help of zenon -> Reusing elements -> Replacing variables and functions -> Replacement possibilities -> Replacing linking for screen switching

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this method, the original screen is always used and switched in Runtime with different variables and functions. The screen contains different variables, as in the "Replacing linking in the screen" example. Replacement is carried out during switching. To do this:

  1. Several screen switching functions are configured on this screen
  2. Is offered when the dialog for replacement is created
  3. Each function contains its own replacement process

A variant of this that works with only one screen switching: Replacing indexes for arrays.


Replacing indexes

Manual -> Project efficiently with the help of zenon -> Reusing elements -> Replacing variables and functions -> Replacement possibilities -> Replacing indexes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In Arrays, replacement for variables can be carried out via index variables.

As with Replacing linking for screen switching, the screen is only used once. The linked variables are replaced during the switching. Screen switching is only configured once (different to Replacing linking in the screen) and can be reused multiple times via an index variable.

Example

Screen switching is carried out on a process screen, which contains 10 variables for wind turbine control MDY10. The objective of the person configuring the project is to reuse this screen 1:1, because the wind turbine controls MDY11, MDY12 and MDY13 have the same number of variables.

The indexing rule:

  • Source: C01 MDY10 QA001*
  • Target: C01 MDY{X01} QA001

the effect of this:

  • With screen switching, the function is informed that it must use the variable value of X01 wind turbine control index in the variable names.

    Example: If this variable has a value of 12, then the process screen is displayed with all wind turbine control variables MDY12 when screen switching is executed


Symbols

Manual -> Project efficiently with the help of zenon -> Reusing elements -> Symbols

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Symbols offer great potential for reuse. Symbols can be created in very complex forms and support inheritance. Symbols can be embedded or linked. With linking, modification at one point is sufficient to update all screens that use this symbol. Symbols can also be linked to other symbols.

Example of a button bar

A symbol (empty rectangle) is linked as the basis in all buttons.

Free-access properties make it possible to issue each button with different graphics. If the form or color of the buttons is to be changed, the "empty button" symbol must be changed. All buttons automatically accept the new form and/or color.


Free access properties

Manual -> Project efficiently with the help of zenon -> Reusing elements -> Symbols -> Free access properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Symbols pass on their properties to the objects in which they were linked. However, individual properties can be released from inheritance. The displayed graphics in our button for example. If inheritance is released, this property can be set individually for each object. Changes to this detail in the initial element no longer influence the other objects.

Reusing screens

The combination of symbols and released properties can be an effective solution for the reuse of process screens.

Example

There is a central dialog for setting parameters in a project, which is to be used for various setting of parameters. Because this is used in various areas, there is also a requirement that certain adaptations (such as background colors, screens …) should be possible.

Copy and paste:

  1. Create a process screen that contains this dialog for setting parameters
  2. Duplicate the screen using copy & paste
  3. The process screens that are duplicated can be adapted to the requirements graphically

But: Inheritance is not possible here. If the person configuring the project subsequently wishes to make changes centrally (in relation to the basic structure of the dialog for setting parameters), they must then drag these to each individual process screen.

Approach using symbols with released properties:

  1. The dialog for setting parameters is created using a symbol
  2. Elements that have to be adapted for different parameter points are decoupled via released properties from the inheritance concept
  3. The symbol is linked, positioned and adapted to the corresponding screens.

  4. If the person configuring the project decides to change the general appearance of the dialog, they make this change centrally in the symbol. This change then affects all items in which the symbol is linked.

  5. A global symbol can be adapted individually using released properties and corresponding replacement.

  6. In this case, the person configuring the project has decided to change the general graphical user interface of the dialog for setting parameters. This change is made centrally at the "Setting parameters" symbol. The individual properties of the individual parameter dialogs remain unchanged; only the properties that are contained in inheritance are contained.


Replacement with symbols

Manual -> Project efficiently with the help of zenon -> Reusing elements -> Symbols -> Replacement with symbols

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The process described in the Replacing variables and functions section can also be carried out for symbols. Here too, well-thought naming of the objects is a requirement.

When carrying out replacements for symbols, a distinction must be made between two different approaches: A symbol from a library (project/global) can be

  • inserted into a screen as an element group
  • linked into a screen

Depending on the approach, different dialogs are switched for the replacement of variables/functions.

Element groups

Here, variables are replaced directly via the replacement dialog. The dialog offers the possibility to select variables via a variable selection dialog. Using symbols in this manner is not ideally suited for reuse.

Symbols

With this process, work is carried out using replacement strings. These strings are replaced with the corresponding variables during compilation. It is not possible, via the dialog called up, to make replacements by means of a variable selection dialog. The person configuring the project works using individual replacement strings here, which are separated from each other by a semi-colon (;).

The symbol behind this replacement dialog can now be reused in various parts of the equipment. This example assumes that similar variables and functions are used in each equipment area (only differentiated by the equipment abbreviation in the name) and that these can be replaced quickly and with a clear overview.

You can find more about replacement for symbols in the Screens manual in the Symbols section.


General symbol library

Manual -> Project efficiently with the help of zenon -> Reusing elements -> Symbols -> General symbol library

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Symbols are administered either in the symbol library in the project or in the global project or in the general symbol library. The most important difference:

Symbol library

Property

General symbol library

Symbols are available in all projects. The general symbol library node is located in the project manager below the currently-loaded projects.

Label when linking in the screen: [symbol group]/[symbol name]

Rules:

  • The dialog for selecting variables offers all projects of the workspace for linking.
  • These symbols are saved in the zenon program folder and only updated when the Editor starts. These symbols are not saved during project backup.
  • Interlockings and aliases for ALC cannot be configured.
    Warning: If symols that contain interlockings or aliases are added, these settings are removed.

Symbol library the global project

Symbols are available for all projects of the workspace.

Label when linking in the screen: (g)[symbol name]

Rules:

  • The symbols copied into the symbol library of the global project retain their variable linking without changes.
  • The variable dialog offers all projects of the workspace for linking. Linked variables are placed in front of the name of the respective project.
  • The name of the Variable can be amended in the properties window. This way, for example, the prefix can be deleted with the project origin.
  • The symbols are also backed up when a project is backed up.
  • Interlockings and aliases for ALC cannot be configured.
    Warning: If symols that contain interlockings or aliases are added, these settings are removed.

Symbol library the project

Symbols are only available in the current project.

Label when linking in the screen: [Symbol name]

Rules:

  • The symbols are saved in the project folder. The project symbol library is in the current project in the Screens node and is backed up together with project backup.
  • Interlockings and aliases for ALC can be configured. These properties are also retained when symbols are added.

Symbols can be copied by dragging & dropping.

  • From the general symbol library into the symbol library in the global project
  • From the symbol library in the global project into the symbol library in the project or vice versa

Direct copying from the symbol library into the symbol library in the project or copying from the project or global project into the general symbol library is not possible.

Example

A central configuration point compiles a collection of symbols that are to be used by the configuration points distributed around the world in their individualized projects. For example, complex symbols that display important parts of process screens are displayed. This collection of symbols is in a folder or a file, for example "Global_Used_Symbols.SYM". If central graphical changes are carried out to this global collection of symbols, "Global_Used_Symbols.SYM" is simply sent to all configuration points and replaced there. Individual adaptation is carried out by means of released properties and replacement.

It is not always necessary to distribute the whole collection of symbols. An XML export/import can also be used to distribute individual selected symbols.

attention Attention

There must be clear rules when the global symbol library is used: Local configuration points must not change the symbols from the symbol collection. Each change would be overwritten at the next update.


Structure data types

Manual -> Project efficiently with the help of zenon -> Reusing elements -> Structure data types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Variables can be reused using structure data types. Complex structures can therefore be created and the advantages of inheritance can be used.

Example

The "Motor" structure data type consists of three elements:

  • Status
  • Speed
  • Temperature

The elements differ in the type of inheritance:

  • Status" and "Speed" are derived from the INT data type, but their inheritance was broken off by the embedding.
    This means: Subsequent updates to INT data type have no effect on these two elements.
  • "Temperature" also comes from the INT data type, the inheritance is intact.
    This means: Subsequent changes to the INT data type also have an effect on the settings of this structure element.

If, for example, 20 motors are now configured, variables based on the same self-created "motor" data type can be created. This can, for example, happen by creating an array of this data type. Graphic display is solved in this example by means of a symbol.

When this symbol is linked in a process screen, the fill-in variables of the symbol are replaced by those of the self-created structure data type. Ensure that the naming is well thought out from the start.

If a process screen is created as an overview of all motors, the inserted symbol can be easily duplicated by copying & pasting. The target variable must still be replaced by the corresponding sequence number at each symbol:

If limit values for the "speed" are to be added at a later time, you benefit from the existing inheritance relationship between the self-created data type and the variables that are created as a result. For the planned change, a new limit value is created for the "speed" structure element of its "motor" data type. This change to a position that has been made affects all 20 created motors.

The person configuring the project is completely free to change this inheritance relationship. A limit value for "speed" can be changed for one of the 20 created motor variables.

Note: Individual properties or all properties of a variable are disconnected from the data type.

info Information

You can read tips for using structure data types in the Structure data types - structure elements - structure array and in the Variables manual in the Structure data types section.


Reaction matrices

Manual -> Project efficiently with the help of zenon -> Reusing elements -> Reaction matrices

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Reaction matrixes ensure that a variable is the same throughout the project. In contrast to limit values, they have a central approach: A reaction matrix is configured once and then assigned to any number of variables. All variables that are linked to the reaction matrix react in the same way. The benefit: central and simple maintenance.


Global project

Manual -> Project efficiently with the help of zenon -> Reusing elements -> Global project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Standards can be defined throughout projects with a global project. With this, it is possible to define certain modules or elements for standard locations, whilst local projects define individual parameters.

The following can be configured in the global project:

  • Alarming:

    Declaration of the alarm groups, alarm classes and alarm areas to be used globally.

  • Equipment modeling:

    This can support central project configuration, because a breakdown into two "plants" can be made. In doing so, it must be clearly defined which configuration elements come from the central configuration point and which come from the local configuration point.

  • User:

    If a standard is to have certain globally-valid users, these can be defined using the global project.

  • Files:

    Graphics can be prescribed by a standard, for example, which have to be used in individually-created projects. These can be made available globally.

  • Frames:

    Defining the process screen arrangement and size of the projects to be developed. For example, it could be set out clearly in some guidelines that newly-created screens can only be created using frames from a global project. A uniform global, graphic appearance is therefore created.

  • Fonts and color palettes:

    To create uniform displayed text and colors, a pre-defined set of font lists and/or color palettes can be defined for global use.

  • Language tables:

    If, as a result of a standard, there is a defined set of terms and statements to be used in configuration, it is possible to define these using the defined language tables and to carry out the corresponding translations at the same time.

Example

A central configuration point defines standards in the areas of color, fonts, templates, etc. using a global project for all people configuring the project. The global project is distributed to all teams as a project backup. They import it into their workspace. A guideline must clearly stipulate that local configuration points must not make changes to a global project, because this would be repeatedly overwritten when updates from the central configuration point are made.

Example of an equipment model

A simple equipment model, which only makes a distinction between a central and a local configuration group. In an individualized project, this distinction could now be used for assistance when visualizing in the editor. In detail, this would look as if each configured element in the Editor was issued with a corresponding equipment group.

The existing process screens are displayed after the equipment has been assigned.

Therefore a local configuration point can clearly recognize which screens are updated by a central configuration point by means of an XML import. For people configuring a project locally, it is also clear which screens they are not permitted to change. This is because each change to globally-evaluated screens is overwritten again during the next update.

Hint: To update a global project, it is not always necessary to create and import a complete project backup. Individual changes can also be updated locally by exporting and importing via XML.


XML

Manual -> Project efficiently with the help of zenon -> Reusing elements -> XML

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Import and export via the XML interface offers diverse possibilities for reusing project parts.

attention Attention

Existing elements with the same name are overwritten during import.

Dependencies during import

If several project parts are to be imported, there are several XML files with different contents accordingly. To accept all content of several XML files, existing dependencies must be taken into account:

If, for example, a screen is imported and its associated variables do not exist in the project, the links cannot be re-established! To create all variables correctly, it can be necessary to carry out the import of a screen or variables twice.

Example for XML screen:

The most comprehensive way is to export a screen, because the XML file created contains not only the screen and the contained elements, but also the frame, associated variables and functions – everything that can be seen in the screen and that is linked directly.

In screen “A”, we use a button to execute a function “B”, which opens screen “A” again.

  • Function “B” requires screen “A”, in order for this to be linked to function “B”.
  • Screen “A” requires function “B”, in order for this to be linked to the button.

You must therefore:

  1. First import the function,
  2. then the screen and then
  3. the same function once again, because otherwise the relationship to the screen cannot be created in the function.

Harmonizing projects throughout plants

XML export/import is also suitable for guaranteeing uniformity of projects throughout a plant. If a company decides that certain project parts should be designed in a uniform manner, then the uniform elements are:

  1. Configured centrally
  2. Exported into an XML file
  3. Distributed as an XML file
  4. Accepted by each local team via XML import

Alternatively, the export and import can also be carried out with a specific wizard.

Because existing elements are overwritten are overwritten during XML import, these uniform elements must be named clearly and with a binding system. Local changes to these elements are overwritten again at the next import.

Wizards

A zenon-based wizard is offered to support the user when importing. In the wizard, the user can then select what is to be imported using decision guidance. A possible approach for this wizard is to create an XML library that contains different variants of screens and functions as individual data.

Individualization using a wizard

A wizard can also be used to configure standard functions that are present in XML format. A function is imported via XML and then adapted to individual requirements by changing certain properties that are not the same for each object. For example, there can be a screen switching function in XML format and this can be reused many time by individualizing the properties.


Wizards

Manual -> Project efficiently with the help of zenon -> Reusing elements -> Wizards

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The reuse of elements and parts of projects can be simplified and supported with wizards. Examples of where wizards are suitable most of all are:

  • Creation of template projects:

    A wizard makes it possible to create certain standard parts of a new project that is to be created by means of a few mouse clicks. In contrast to simple loading in of a complete project backup of the template project, the person configuring the project now has more scope for individualization.

    For example, a wizard can create different project types, depending on the machine.

  • Creation of pre-defined projects:

    Wizards can also help you create certain areas in a project.

    For example: Creation of a "Motor" project area.
    The wizard creates pre-defined elements for this area. With this, appropriate screens, functions, variables etc. can be configured with a few mouse clicks. In addition to the shorter configuration times, you also obtain a uniform appearance, because the wizards are programmed by a central configuration point and used by the local configuration points.

  • Configuration using pre-defined databases or files:

    Project databases or pre-defined files can also support project creation or project expansion. In doing so, the elements to be configured are described in a database or an Excel file (function name, function type, function parameters, variable name, offset …). These are read off with the help of a wizard and corresponding configurations are undertaken in zenon.

You can find out more about wizards and the creation of these in the Wizards manual


Reusing projects

Manual -> Project efficiently with the help of zenon -> Reusing elements -> Reusing projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Projects could also be reused in different ways. In doing so, mechanisms from the other chapter of reusability sometimes play a significant role.

Project backup

Save as

Multi-project administration


Project backup

Manual -> Project efficiently with the help of zenon -> Reusing elements -> Reusing projects -> Project backup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Project backups make it possible to accept complete projects.

For example, a project can be distributed to all teams as a template. These create a project backup and individualize the project.

attention Attention

This method is not suitable for transferring project changes, because all local configuration is overwritten when it is accepted.

To maintain projects that have been created this way consistently throughout all teams, the use of XML exports/imports is recommended.

In doing so, note that existing elements with the same name are overwritten during import. During configuration, the configured elements that may be overwritten during import must be clearly identified. For example, a corresponding suffix to the element name is suitable , for example, or the procedure using equipment groups, see global project section.


Save as

Manual -> Project efficiently with the help of zenon -> Reusing elements -> Reusing projects -> Save as

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Save as creates a copy of a project in the active working area under a new name and with a new GUID.

Example

Individual projects for different machine types are to be created, based on a template project. To do this:

  1. The project backup of the template project is loaded in
  2. Several differently-named projects are created in the active workspace using Save as (such as Machine 1, Machine 2, … )

Each machine project has the same initial project situation. However, the projects no longer have any connection to a template project. Changes that are made in a template project are not automatically accepted into the copied projects. However changes to the template can be introduced into individualized projects by means of XML export/import.

In doing so, note that existing elements with the same name are overwritten during import. During configuration, the configured elements that may be overwritten during import must be clearly identified. For example, a corresponding suffix to the element name is suitable , for example, or the procedure using equipment groups, see global project section.


Multi-project administration

Manual -> Project efficiently with the help of zenon -> Reusing elements -> Reusing projects -> Multi-project administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Projects can also be compiled in a workspace in zenon multi-project administration as part of of an integration project. This way, a project can be changed centrally, whilst local configuration is carried out in another project.

Example

Graphics are to be reused in a local project by means of a central configuration point, in order to create a uniform user interface globally. To do this, the central configuration creates a template project, which displays the graphical basis for all other configuration teams. However, if a change to the user interface design is made at the centrally, this must be implemented at all project sites. This can be carried out using multi-project administration: A project contains the elements to be administered centrally; another project has the local configuration.

Procedure:

  1. A template project is initially sent to all configuration teams
  2. This is then uploaded to the active workspace
  3. A second empty project is created locally, that contains the specific amendments
  4. There are now two projects in the workspace: the template project and the personalized project
  5. The multi-hierarchical arrangement of the projects is carried out in the next step
  6. The template project becomes the integration project, the individualized project becomes the sub-project

info Information

This method is not suitable for projects that are to run under Windows CE, because only one project can be started under CE.


integrated network

Manual -> Project efficiently with the help of zenon -> integrated network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Distributed engineering in the network and 100% redundancy are no longer a big effort for you using zenon You can create networks by checking the relevant checkbox in the project's properties. Creating efficiently networked, redundant systems from isolated standalone projects is just as easy.

If you have a TCP/IP Windows network, zenon automatically offers network functions with a mouse click, either as client / server model or as a multihierarchical system with substations, workspace centers and centers. It

  • create projects - also with several users - simultaneously over the network
  • ensure equipment with the 100% zenon circular redundancy perfectly
  • install distributed systems without any problems
  • have remote access to stations
  • monitor and control equipment via zenon Web Server
  • see process data in all stations in real time
  • can display actions set on one workstation (e.g. acknowledging alarms) on all others, too
  • have actions be logged and archived centrally
  • use process data instantly for ERP systems like SAP

zenon will automatically take care of the required time synchronization on all participating computers.


Tips and tricks

Manual -> Project efficiently with the help of zenon -> Tips and tricks

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In zenon, you have many keyboard shortcuts and quick methods of project configuration available. We are presenting a selection of these to you here briefly.

Tips and tricks for

  • the Editor
  • the Runtime
  • The test phase
  • Keyboard shortcuts


zenon Editor

Manual -> Project efficiently with the help of zenon -> Tips and tricks -> zenon Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tips for the zenon Editor:

General

  • Save Editor views: With Editor profiles, you can save your individually-compiled window divisions and and assign modules.
  • Open the folder for the Editor files directly: Highlight the project and press the key combination Ctrl+Alt+E.
  • Open the folder for the Runtime files directly: Highlight the project and press the key combination Ctrl+Alt+R.

Screen/symbol editor

  • Link elements:
    You can link functions, variables, fonts etc. to dynamic elements by means of Drag&Drop.
  • Add a copy at the same location:
    With the CTRL+Shift+V keyboard shortcut, you add copied elements at the exact same position as the source element.
  • Drag a circle:
    To drag a circle, drag the Ellipse/circle element with the mouse whilst holding down the Shift key.
  • Change line symmetrically:
    If you press and hold the Alt key while pulling the outer corner points, the change is carried out symmetrically.
  • Scaling:
    You can scale several screen elements at the same time: To do this:
    • Mark all elements.
    • Convert this into an element group.
    • Scale the element group as desired.
    • The individual elements are scaled in the same scale.
    • Break up the element group into individual elements again.
  • Templates for screens:
    You can convert any desired screen into a screen template.
  • Manipulate the X/Y coordinates of an element:

    You can enter the X/Y coordinates of an element or corner point of a polygon directly into a dialog or move it with the cursor keys.

    • Enter directly: Double clicking on the sizing handle of an element or corner point of a polygon opens a dialog. You can enter the X/Y coordinates of this point directly.
    • Move with the cursor: Place the mouse pointer over the sizing handle of an element or corner point of a polygon. You can now move the X/Y coordinates of this point directly with the help of the cursor keys.
  • Jump to linked element:
    Right clicking on a property in the properties window opens a context menu that allows you to jump directly to the linked element.

Language switch

  • Unit labeling:
    Set the exact unit name as tool tip. In the usual environment, users normally think in the respective national unit. For trouble-shooting, optimizing internationalization and projects with a focus on internationalization, the use of this tool tip can make their work significantly easier.
    Make this tool tip translatable; use international denominations for the country too. You can of course translate the measurement unit to the respective language.
  • Value units as a character instead of as a word:
    Use the unit display for the display of values. There will be no need for a translation then.
    Example temperature display: The term degree(s) must be translated. The symbol ° however not only is the same symbol in all languages but can also equally be used for Celcius, Fahrenheit and Kelvin.
    Set the corresponding symbol in the properties of the basic unit.
  • Conversion of values:
    Add the corresponding value conversion to every language change function. Otherwise misunderstandings might easily occur.

Symbol editor

  • Unlock property:
    You can unlock a property of an element by means of Drag&Drop, moving the property into the lower window of the symbol editor. In doing so, you must always click on the properties using their name, not the value.
  • Individual editing mode for symbols:
    With the Alt+click shortcut on an element, the element below it is activated.

Variables and drivers

  • Substitution:
    To be able to apply the possibility of substitution optimally:
    • Use structure data types.
    • Ensure that your variables are given a short and concise name.
    • Take the possibility of substitution into account at the naming stage. This naming should be unique and easily-substitutable.
    • Configure a screen as a template first, which can be reused as often as you like once it has been completed by means of a function.
  • Automatically create variables by importing:
    Many drivers support the automatic creation of variables with correct addressing by import from the PLC or from a file. To do this, right-click on the driver with the mouse and select Import variables from the driver.


zenon Runtime

Manual -> Project efficiently with the help of zenon -> Tips and tricks -> zenon Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tips for zenon Runtime:

General

  • Display screen name:
    Right click on an empty screen area and hold down the mouse button. The screen name is displayed.
  • Display linkings:
    Right click on a dynamic element and hold down the mouse button. Linked functions and/or variables are shown.
  • Communication error:
    Display by means of symbols on the numeric element:
    • Red corner at the top left: No communication with the PLC.
    • Blue corner at the top left: No communication with the server.
  • Write set value:
    Except value, also change command.

    Only the value of a variable can be changed in Runtime. If the standard dialog is used, the function that is to be executed can also be changed by means of the Command drop-down list, such as to Switch off spontaneous value for example. In order for the standard dialog to be displayed, the Screen Keyboard property must be deactivated in the Dynamic elements property.

  • Write set value directly without executing dialog:
    To write the set value directly, activate, in the properties of the dynamic element, in the Write set value group, the without dialog property.

    This setting can also be set with the Write set value function by activating the Direct to hardware option.

Historian

  • Show name of the ARX file in the screen:
    The name of the ARX file can be shown in the list of the archives in the archive revision screen in a column. To do this, set, in zenon6.ini, in the [ARCHEDIT] section, the KURZBEZEICHNUNG=1 entry. The short description is thus displayed in the list. This corresponds to the ARX file names and is also part of all aggregation archives.

Keyboard operation

  • Keyboard operation:
    Runtime can also be operated in full with the keyboard. For details, see the keyboard operation chapter in the Runtime manual.
  • Block keys:
    Windows keyboard shortcuts can be blocked. For details, see the Block keyboard shortcuts chapter in the Runtime manual.


Keyboard shortcuts

Manual -> Project efficiently with the help of zenon -> Tips and tricks -> Keyboard shortcuts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In zenon, you can carry out many actions with keyboard shortcuts.

General

Command | Key combination
Open help | F1
Start/stop full screen mode | Shift+F9
Remote: Close full-screen mode | Ctrl+Alt+Shift+F
Start VSTA Editor | Alt+F10
Start VBA Editor | Alt+F11
Wizards: Open selection | Alt+F12
Open file explorer for current project with focus on SQL folder. Corresponds to: %ProgramData%\COPA-DATA\[SQL-Ordner]\[UID]\FILES | Ctrl+Alt+E
Open file explorer with focus on project files from the current project. For example: C:\Users\Public\Documents\<CD_zenon_Projects\[Project]\INI\[Rechner]\INI | Ctrl+Alt+D
Open file explorer with focus on Runtime files from the current project. For example: C:\Users\Public\Documents\zenon_Projects\[Project]\INI | Ctrl+Alt+R
Start Runtime; create changed Runtime files beforehand. | F5
Create changed Runtime files. | F7

Editor profiles

Command | Key combination
Load Editor profile 1 | Shift+F1
Load Editor profile 2 | Shift+F2
Load Editor profile 3 | Shift+F3
Load Editor profile 4 | Shift+F4
Load Editor profile 5 | Shift+F5
Load Editor profile 6 | Shift+F6
Load Editor profile 7 | Shift+F7
Load Editor profile 8 | Shift+F8
save current Editor view as: |
Editor profile 1 | Ctrl+Shift +F1
Editor profile 2 | Ctrl+Shift +F2
Editor profile 3 | Ctrl+Shift +F3
Editor profile 4 | Ctrl+Shift +F4
Editor profile 5 | Ctrl+Shift +F5
Editor profile 6 | Ctrl+Shift +F6
Editor profile 7 | Ctrl+Shift +F7
Editor profile 8 | Ctrl+Shift +F8

Graphic editor:

Note for shortcuts: The plus sign (+) means that keys a pressed together.
For example:

Ctrl+A means: Hold key Ctrl and then press key A.

Ctrl++ means hold key Ctrl and press key +.

General

Command | Key combination
Main window: Scroll content with 'moving hand' | Press and hold Space
Close current screen | Ctrl+F4
Open properties | Alt+Return

Select

Command

Key combination

Select several objects

Press Shift or Ctrl

Deselect selected object during multi-select

Ctrl+mouse click

Selection: Change sort order. Defines the element on which all others realign

Press Shift during selection

Select hidden objects
  1. Press Alt
  2. Click object and move it

Select all elements of a screen.

Ctrl+A

Select next element according to the order of their creation

Tab

Select previous element according to the order of their creation

Shift+Tab

Positioning

Command | Key combination
Move selected object. | Cursor keys
Move by 10 pixels each time you press a cursor key | Shift+arrow keys
Move only horizontally or only vertically | Press Shift during moving
Centers the selected object in the working section | H

Actions

Command | Key combination
Saves changes | Ctrl+S
Pastes element from the clipboard | Ctrl+V Shift+Ins
Inserts element from the clipboard at its original position; original and copy lie congruently on top of each user | Ctrl+Shift+V
Copies selected element. | Ctrl+C Ctrl+Ins
Copy instead of move | Press Ctrl during moving
Deletes selected element | Del
Cuts out the selected element | Shift+Del Ctrl+X
Undoes changes | Ctrl+Z Alt+Backspace
Add or delete node in the selected element. Add: Mouse cursor turns to plus symbol (+). Delete: Mouse cursor turns to minus symbol (-). Works for polylines, polygons and pipe elements. | Ctrl+Shift
Cancel drawing of polylines and polygons | S
Cancel drawing of polylines and polygons and delete the section which was drawn last | Esc
Move selected elements one level up | +
Move selected elements one level down | -
Move selected elements to the foreground | Ctrl++
Move selected elements to the background | Ctrl+-

Scaling

Command

Key combination

Change size

Move mouse cursor to the handle so that the mouse cursor changes to an arrow. After that you can position accurate to the last pixel with the help of the Cursor keys or in steps of 10 pixels with the help of the Cursor keys+Shift.

Note: If an angel dissimilar to 0 via property Rotation angle [°] was defined for an element, scaling via arrow keys is not possible.

Scaling object around the center

Press Alt during scaling.

Proportional scaling

Press Shift during scaling

Detail view

Command | Key combination
Create a new element for the respective module | Ins
Edit the selected column | F2
Copy a selected list element | Ctrl+C
Insert a list element which was copied beforehand | Ctrl+V
Delete a selected list element | Del
Scroll up several elements in the list | Pg up
Scroll down several elements in the list | Pg down
Navigate in the list | Arrow key

Runtime

Command | Key combination
Browse through open Window windows. | Alt+Tab
Stopping the Runtime. | Alt+F4


Test of projects

Manual -> Project efficiently with the help of zenon -> Tips and tricks -> Test of projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tips for testing projects:

  • Name of the variable in the screen:
    To display a variable name in the screen, configure a combined element without status and with the default text: %n.


Runtime

Manual -> Runtime

Runtime is software that supports graphic display possibilities for HMI/SCADA projects.

tutorial License information

The zenon Runtime must be licensed. The license is calculated according to the used TAGs or IOs. For details about licensing see chapter Licensing.

It offers:

  • Process display,
  • Archiving of data such as messages and process values,
  • Integrated alarm message list,
  • Recipes,
  • Multi-Touch and much more.

attention Attention

For the optimum display of zenon in Runtime, the value Less than - 100% is recommended as a setting for the Windows display. Higher values can lead to graphic elements, symbols, texts, etc. not being displayed correctly.

Runtime is available as a 32-bit version and a 64-bit version from zenon 7.10. Projects can run on both versions. You can read details on compatibility with versions of zenon 7.10 in the Project conversion manual, in the 64-bit version chapter. The Runtime is available as zenon Supervisor and as zenon Operator for Embedded operating systems. The versions differ in their functionalities. For details see Restrictions for zenon Operator.

Several instances of Runtime

Only one instance of zenon Runtime can be started on a computer at any time. This applies regardless of whether Runtime is started as an EXE file, a Web Client or as Runtime Control (OCX).

Exception: On the terminal server or terminal client, one instance of Runtime per user can be started as an EXE file, as a Web Client or as Runtime Control (OCX). Only 1 instance can run at any time within a user context.


32 and 64-bit version

Manual -> Runtime -> 32 and 64-bit version

zenon is now available for Editor and Runtime as a 32-bit and 64-bit version. A 32-bit and a 64-bit zenon Editor and a 32-bit and a 64-bit zenon Runtime are installed on 64-bit operating systems. The file names of the executable files are identical for 32-bit and 64-bit.

On 64-bit systems, all services present in 64-bit are registered and used in the 64-bit version. Editor and Runtime can be started alternately. Projects can be executed in both Editors and in both Runtimes.

Components such as, for example, zenon Logic Runtime, zenon Logic Workbench, drivers, Process Gateway and other tools are always only used in the 32-bit version.

General limitations

The basic limitation of only 64-bit DLLs being able to be loaded in 64-bit processes also means that there are certain limitations when operating zenon. This mostly affects external components that are loaded in the Editor or Runtime. DLLs that are loaded using VBA/VSTA code and ActiveX controls are directly affected. These DLLs must be present as a 64-bit version for use in the 64-bit Editor or Runtime. ActiveX controls supplied by COPA-DATA are always available in 32-bit and 64-bit versions.

Conversion of zenon 5.50 projects

No zenon 5.50 projects can be converted with the 64-bit editor. These must be converted beforehand with the 32-bit Editor.

RGM limitation

The Access database is no longer supported in the RGM. In order to be able to use MS Access data from previous versions under 64-bit, the project must first be converted in the 32-bit Editor. The DataSource property is no longer available from version 7.10. For details, see the Converting Recipegroup manager database chapter.

VBA

VBA was converted to VBA version 7.1. Therefore VBA is also available in zenon 64-bit. If, in the VBA code, Windows API or other imported DLL functions are accessed, these calls must be adapted to 64-bit. In general, the following applies: A VBA file created with a 32-bit version cannot be used without changes in a 64-‑bit version.

There are some defines/functions available in VBA in order to write 32-bit and 64-bit compatible code. For example:

#if Win64 then

Declare PtrSafe Function MyMathFunc Lib "User32" (ByVal N As LongLong) As LongLong

#else

Declare Function MyMathFunc Lib "User32" (ByVal N As Long) As Long

#end if

#if VBA7 then

Declare PtrSafe Sub MessageBeep Lib "User32" (ByVal N AS Long)

#else

Declare Sub MessageBeep Lib "User32" (ByVal N AS Long)

#end if

You can also obtain some useful notes on the porting of VBA 32-bit code to VBA 64-bit from Microsoft:

  • Microsoft Office 2010, notes on porting: http://msdn.microsoft.com/en-us/library/ee691831.aspx
  • 32-bit and 64-bit declares for API calls: http://www.jkp-ads.com/articles/apideclarations.asp

Components in 32-bit only

The following components are also only available as 32-bit versions on 64-bit computers:

  • Some programs, such as SIC.exe and DiagViewer.exe
  • Licensing
  • Process Gateway
  • Startup Tool
  • Windows CE
  • Driver
  • zenon Logic Runtime and Workbench


Hardware requirements

Manual -> Runtime -> Hardware requirements

One of the requirements for putting Runtime into operation is that setup has been completed successfully. It is also important to have a valid license.

The minimum requirements are listed in the following table. These are based on a complete installation of Runtime. For extensive projects or several projects loaded at the same time you will need accordingly faster/stronger hardware. The minimum requirements can increase as a result of this.

Hardware

Minimum requirements

Recommended

CPU

Single core with SSE2 support.

Quad Core

RAM memory

Windows 7/8: from 512 MB.

Note: Projects with big amounts of data, Network projects, multiple projects simultaneously and projects in redundance mode need more memory.

Windows 7/8: 4096 MB

Harddisk

2 GB free space for the Runtime-installation plus additional space for the projects.

Attention: If you log historical data (e.g. Archive dataorAlarm-/CEL-Data), you need sufficient harddisk space or you have to make sure during engineering that the historical data is evacuated or deleted.

Monitor resolution

VGA with 640 x 480 pixels.

Graphics adapter

64 MB dedicated memory. Cards with shared memory can lead to performance loss. Note the System requirements when using DirectX chapter in relation to this.

Input devices

Keyboard and/or mouse. Operation via touchscreen is also possible. Many individual, customizable soft keyboards for the touchscreen are available for you.

USB interface

(optional)
  • For installation.
    Installation also possible via network or other storage media.
  • For dongle. Network dongle also available.

Network connection (optional)

64 kBits/s for standard Client/Server projects.

100 Mbit/s full duplex for redundant operation.

100 Mbits/s full duplex for standard Client/Server projects.

Remote connection (optional)

Minimum requirements: Dial-up modem with 9600 Bit/s.

1 Mbit/s full duplex.

WAN connection (optional)

Any desired connection via router, e.g. per ISDN or DSL Data transfer is slower in a WAN than in a local network for technical reasons. Be sure to check the possible data transfer rates of your WAN technology already at the time when you create the project.

Message Control (optional):

Please refer to chapter Message Control for the requirements.

Interfaces (optional)

The necessary interfaces depend on the requirements of the PLC and/or the bus connection, for example serial RS232 or RS422/485 interfaces, ISA/PCI slots, etc.


Paths for setup and operation

Manual -> Runtime -> Hardware requirements -> Paths for setup and operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Paths for zenon:

  • Setup
  • Runtime

info Info

You can display many default paths with the help of the set command:

  • start the command line (enter cmd in the Windows start area)
  • enter command set
  • with click in button Enter standard folders for Windows and zenon are displayed

Note: As absolute paths differ in different operating system, the paths are displayed as Windows environment variable in this chapter. For example %ProgramData% instead of C:\ProgramData.

Setup

During setup, paths are set for required software from third-party providers as well as the zenon Runtime folder.

The setup needs administrator rights . This is also true for changing the installtion paths.

Requirements

The installation paths of the required third-party software match the standard paths of the respective manufacturer and cannot be changed during setup.

The additional software packages that need to be installed depend on the type of installation:

  • zenon Editor
  • zenon Runtime
  • zenon Web Client
  • zenon Logic Runtime
Requirement | Editor | Runtime | Web Client | zenon Logic Runtime
Microsoft .NET Framework 3.5 SP1 | + | + | - | -
Microsoft .NET Framework 4.0 | + | + | - | -
Microsoft Visual C++ 2005 Redistributables | + | + | - | +
Microsoft Visual C++ 2010 Redistributables | + | + | + | +
Microsoft Visual C++ 2012 Redistributables | + | + | + | +
Microsoft SQL-Server 2012 SP1 Express (from 7.10 on) | + | - | - | -
VSTA | + | + | - | -
OPC-Core Components (up to 6.22 SP1) | + | + | - | -
Wibu key Dongle Software 6.0 x86/x64 | + | + | - | -
COPA-DATA Multiple Network Protocol Driver x86/x64 | + | + | - | +
CodeMeter dongle software x86/x64 | + | + | - | -
Report Viewer 10.0 (from 7.00 on) | + | + | + | -
VBA 7.1 | + | + | + | -

zenon Runtime

zenon Runtime uses the path that is set in zenon6.ini for projects. This path can be set using the Startup Tool as well as using Remote Transport from a zenon editor.

Object | Path
Project | [user-defined path]\[project]\RT
External files | [User-defined path]\[project]\RT\FILES\...
Exported archives, Chronological Event List and Alarm Message List | [User-defined path]\[project]\Export Note: Is created at the first export.
System files | Windows system folder.

zenon Logic

Paths for zenon Logic are created analogous to the zenon paths.


Demo mode

Manual -> Runtime -> Hardware requirements -> Demo mode

If Runtime is not licensed, it can be used in demo mode for 30 days. Licensing (soft licensing or dongle licensing) is possible at anytime by entering a valid serial number and activation number. Licensing is only effective once zenon has been restarted.

Note: From the 41st start or the 31st day in demo mode, Runtime only runs for 10 minutes. Runtime always runs for 30 minutes in demo mode.


Runtime under Windows Embedded Standard

Manual -> Runtime -> Hardware requirements -> Runtime under Windows Embedded Standard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The minimum requirements are valid for a Runtime installation adapted to the Windows Embedded Standard 7 SP1 operating system. The hardware must be accordingly more powerful for extensive projects.

This table only states the figures that are different to the standard installation. The other parameters correspond to the figures described in the Hardware requirements for Runtime chapter.

Hardware

Minimum requirement

Recommended

RAM memory
  • 512 MB.

Note: Projects with big amounts of data, Network projects, multiple projects simultaneously and projects in redundance mode need more memory.
  • 2048 MB

Storage medium
  • 2 GB of free memory on C:\ drive before the installation of .NET Framework 3.5 and 4.5
    800 MB of free memory after the installation of the .NET Framework
  • Plus memory space for the projects, archives, etc.
  • 80 GB

Attention: If you log historical data (e.g. Archive dataorAlarm-/CEL-Data), you need sufficient harddisk space or you have to make sure during engineering that the historical data is evacuated or deleted.


Runtime for Windows CE

Manual -> Runtime -> Hardware requirements -> Runtime for Windows CE

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The minimum requirements are based on a complete installation of the Runtime for Windows CE. The hardware must be accordingly more powerful for extensive projects.

Hardware | Minimum requirement | Recommended
CPU | At least 400 MHz | 1 GHz.
RAM memory | 64 MB. | 1024 MB for Windows CE 6.0.
Storage medium | 64 MB free harddisk space. Permanent recordable remanent storage medium for project data | 256 MB free harddisk space or more.
Network connection | For standard Client/Server projects: 10 Mbit/s full duplex. |


System requirements

Manual -> Runtime -> System requirements

zenon 7.20 can be used on all current Microsoft operating systems. The hardware being used is not important. The operating system abstracts hardware functions so far that zenon can normally be used without restrictions on any hardware.

zenon is always tested with the most up-to-date version of the operating systems with the newest available Service Packs and Hotfixes. You can thus assume that zenon can usually be used with the most recent service packs and hotfixes.

Changes in Microsoft's Service Packs and hotfixes or patches can cause incompatibilities and affect the software's functionality. If this is the case, COPA-DATA will release an updated version as soon as possible. In this case, please contact our Support: support@copadata.com.

attention Attention

For the optimum display of zenon in Runtime, the value Less than - 100% is recommended as a setting for the Windows display. Higher values can lead to graphic elements, symbols, texts, etc. not being displayed correctly.


System requirements when using DirectX

Manual -> Runtime -> System requirements -> System requirements when using DirectX

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following minimum requirements must be met when using DirectX hardware or DirectX software:

Note: For extensive projects or several projects loaded at the same time you will need accordingly faster/stronger hardware. The minimum requirements can increase as a result of this.

Parameters | Minimum requirements | Recommended
CPU: | Single core with SSE2 support. | Quad Core or more cores
Graphics card: (DirectX hardware only) | DirectX 11 mainstream graphics card. Note: When an integrated graphics chip is used in particular, it is possible, depending on the driver used, that there are impairments to the display quality. | Dedicated DirectX 11 AMD or nVidia high-end graphics card
Graphics memory: (DirectX hardware only) | 1 GB VRAM Note: The size that is actually needed depends on the number of screens called up and the elements displayed. | 2 GB VRAM
Driver graphics card: (DirectX hardware only) | The graphics card manufacturer's most recent driver.
Operating system: | DirectX hardware and DirectX software only works on operating systems that support DirectX11.1. If the system does not support DirectX 11.1, it automatically switches to Windows Enhanced. The current DirectX- Runtime must be installed. For zenon it is installed together with the setup. For the Web Client it must be installed manually.

You can check the DirectX hardware compatibility of the graphics card and the driver with the Windows operating system tool dxdiag.exe.
Up to Windows 7: Check the DDI version value under Display. The value 11 for example means DirectX 11.
From Windows 8: All supported versions of DirectX are displayed in the Display tab under Feature Levels. For example, DirectX 11 is displayed as 11.0.


Operating system

Manual -> Runtime -> System requirements -> Operating system

Operating system | Required service pack
 | zenon Editor | zenon Runtime | zenon Web Server | zenon Web Client | zenon Logic Runtime | zenon Analyzer Server
Windows 7 (Professional, Enterprise and Ultimate version, x86 and x64 versions). | SP 1 | SP 1 | SP 1 | SP 1 | SP 1 | SP 1 - x64
Windows Embedded Standard 7 (if all necessary operating system components exist). | Cannot run | SP 1 | SP 1 | SP 1 | SP 1 | Cannot run
Windows 8 and 8.1 (Standard, Professional, Enterprise version, x86 and x64 versions) | SP 0 | SP 0 | SP 0 | SP 0 | SP 0 | SP 0 - x64
Windows Embedded 8 Standard (if all necessary operating system components exist). | Cannot run | SP 0 | SP 0 | SP 0 | SP 0 | Cannot run
Windows 10 | SP 0 | SP 0 | SP 0 | SP 0 | SP 0 | SP 0
Windows Server 2008 R2 (All editions with the exception of Core) | SP 1 | SP 1 | SP 1 | SP 1 | SP 1 | SP 1 - x64
Windows Server 2012 and 2012 R2 (All editions with the exception of Core) | SP 0 | SP 0 | SP 0 | SP 0 | SP 0 | SP 0 - x64
Windows CE 6.0 (ARM and x86) | Cannot run | zenon Operator only | Pro Light only | Cannot run | Running | Cannot run
Windows Embedded Compact 7 (ARM and x86) | Cannot run | zenon Operator only | Pro Light only | Cannot run | Running | Cannot run
  • All operating systems are supported in the multi-lingual version.
  • Windows RT 8 and Windows RT 8.1 are not supported due to the system.
  • Itanium processors are not supported for any operating system.

attention Attention

Automatic Windows updates influence the installation

If an update of the Windows operating system is carried out while the zenon setup is running, it can cause problems during the zenon installation. To prevent this:

  • deactivate the automatic Windows update during the time of installation
    or
  • carry out the Windows update before starting the zenon installation

Microsoft .NET Framework

zenon needs the Microsoft .NET Framework 3.5 or higher for VSTA and WPF. If the framework is not installed, an attempt is made to install it automatically. If the .NET Framework is an operating system component, it cannot be installed automatically. The setup then displays an error message and aborts. The .NET framework must be activated manually for these operating systems: Control panel - >Programs and functions - >Activate or deactivate Windows functions.

Overview

 | Windows Embedded 7/8 Standard | Windows Embedded 8.1 Pro/Industry | Windows 7 SP1/Windows 8 and 8.1/ Server 2008 (R2) SP1, 2012 and 2012 R2 | Windows CE
Editor |  | X | X | -
Runtime | X | X | X | -
Runtime for Windows CE | - | - | - | X
Web Server | X | X | X | X
Web Client | X | X | X | -

Processors supported in the different Windows CE operating systems are listed in chapter CE versions/supported processors. You can find installation instruction for Runtime under Windows CE in chapter Runtime.

info Information

If you always use the latest version (Service Pack) of your operating system, you not only avoid compatibility issues but also security problems.


Virus scan

Manual -> Runtime -> System requirements -> Virus scan

Anti-virus software can slow down or even prevent the installation of zenon.

Note: If the anti-virus software you use leads to problems during installation, deactivate the anti-virus software for the duration of the installation. Note that the computer in question is subject to higher risks in this period. Activate your anti-virus software immediately after the installation of zenon.


File Structure

Manual -> Runtime -> System requirements -> File Structure

The special file structure is created or extended during the installation.

The zenon program files are copied to a folder which can be defined during the installation.

Additionally the installation asks for a folder for the SQL databases of the projects. The storage medium for project archiving (SQL, screens etc.) must have enough free space, because all current and future project data is stored there.

Folder | Path
Program folder | 32-bit system: C:\Program Files\COPA-DATA\zenon7xxx 64-bit system: C:\Program Files\COPA-DATA\zenon7xxx C:\Program Files (x86)\COPA-DATA\zenon7xxx
Program data folder, e.g. global symbols, print templates, log files etc. | C:\ProgramData\COPA-DATA\zenon7xxx
Database folder (SQL) | C:\ProgramData\COPA-DATA\SQL
System folder | C:\ProgramData\COPA-DATA\System
Settings Editor and profiles | C:\Users\UserName\AppData\Local\COPA-DATA\zenon\Editor
Settings Diagnosis Viewer | C:\Users\UserName\AppData\Local\COPA-DATA\zenon\DiagView

Definition Runtime folder and Data folder

Runtime folder

The Editor creates Runtime files in the Runtime folder, or they are transferred to this folder with the help of Remote Transport. When creating a project, you must define the Runtime folder. Later it can be changed in the project properties. With Remote Transport, the Runtime folder is defined in Remote Transport settings.

Data folder

The Runtime saves all data files that were created at runtime like alarm files, archive files etc. in the data folder. The data folder is created as a subfolder of the Runtime folder by default. The folder is automatically assigned the name of the computer the Runtime is running on. You can change this save location in the project properties (General/Data folder).

Hint: Never set the data folder to a removable device such as an USB stick or a network device. It is recommended that the data is recorded locally and backed up externally.

attention Attention

If the defined path does not exist or is not available, no more data is written from the Runtime. This means a complete loss of data. The Runtime can still be operated but must be restarted as soon as the path is available again. The availability of the folder can be checked via system driver variable Runtime folder not available .


Free ports

Manual -> Runtime -> System requirements -> Free ports

zenon and zenon Logic need certain communication ports for the communication in the network. If these ports are occupied by other programs like e.g. an already installed SQL server, the communication of zenon can be disturbed.

This is how you check the port assignments:

  1. Enter netstat -a -n -o in the command line.

    You can reach the command line in Windows:

    • by pressing the Windows-key and R
    • Enter cmd and confirm with OK.
    • A DOS-window pops up
    • enter the command netstat
  2. A list of all currently used TCP and UDP ports will pop up.
  3. Check the listening ports (status: LISTEN) if the process-ID (PID) of the ports needed by zenon and zenon Logic corresponds with the processes of zenon and zenon Logic.

    These PIDs can be found in the window Processes of the Windows Task Manager; for this purpose activate the column PID in the menu Select view/columns.

  4. If other software uses these ports, reconfigure this software.
    You can see the ports that zenon and zenon Logic use in the Port assignment by zenon and zenon Logic table. Here you can also see if these ports can be amended in these programs.

Port settings by zenon and zenon Logic

Application | Description | Port | Transport log
stratonrt[k].exe | zenon Logic Runtime polling communication and zenon Logic Workbench. | 1200-1210 (can be changed) | TCP
stratonrt[k].exe |  | 4500-4510 (can be changed) | TCP
stratonrt[k].exe | zenon Logic redundancy. | 7000-7010 (can be changed) | TCP
stratonrt[k].exe | zenon Logic Runtime spontaneous communication. | 9000-9010 (can be changed) | TCP
zennetsrv.exe | zenon network service. | 1100-1100 (fix) | TCP
zensyssrv.exe | zenon transport service | 1101-1101 (fix) | TCP
zendbsrv.exe | zenon database service. | 1103-1103 (fix) | TCP
zenAdminsrv.exe | zenon administration service. | 50777-50777 (fix) | TCP
zenLogSrv.exe | zenon logging service. | 50780 | TCP
zenvnc.exe | zenon remote desktop service. | 5600-5600 (fix) 5610-5610 (fix) | TCP
CodeMeter.exe | CodeMeter dongle service. | 22350 (changeable but must not be changed) | TCP
WkSvW32.exe | WibuKey network service | 22347 (fixed) | TCP


Updates (Build Setups), Service Packs and Upgrades

Manual -> Runtime -> System requirements -> Updates (Build Setups), Service Packs and Upgrades

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Update (Build Setup)

An update is installed over the existing installation; it replaces only changed files with the new version. All projects and individual settings will remain unchanged. Note that Build Setups are never 100% quality-assured. Only the bug fixes are tested. If unwanted side effects should occur because of a bug fix, it might be possible that these side effects will not be noticed during testing. COPA-DATA therefore always recommends using Service Packs. They always have to pass the whole quality-assurance process.

Note for Web Client: To install an update for the zenon Web Client, the Web Client must be uninstalled beforehand.

Service Packs

Service Packs always contain a complete version of zenon. The installation routine doesn´t replace some files. Instead, it removes the old version and installs the new one. If you install a Service Pack, all your projects and individual settings remain intact. Projects aren´t converted to the new version during installation. The respective project is converted when it´s being opened for the first time in the Editor. A dialog box notifies you about this procedure. The old version is automatically backed up.

A service pack always contains all bug fixes of previous builds.

Upgrade

If you want to install a new version of zenon, start the installation routine. The new version is being installed parallel to the old one. All projects and individual settings will remain unchanged. Projects aren´t converted to the new version during installation. The respective project is converted when it´s being opened for the first time in the Editor. A dialog box notifies you about this procedure. The old version is automatically backed up. If you want to use only the most up-to-date version, use the Windows control panel software deinstallation routine to remove the old version.

attention Attention

If an upgrade involves changing the SQL server (for example, an update from zenon 7.00 to zenon 7.10 or higher), you must back up all projects or the workspace before the installation. This backup is read back after the installation. For details see also section Multi-user projects/Update with change of SQL servers.

If you want to use multiple versions of zenon simultaneously, you have to manage them using the Startup Tool. You can start only one version at a time. You can select which version you want to run using the Startup Tool that automatically adjusts all necessary settings. You can find details in chapter Startup Tool.

info Information

New versions (Service Pack, Upgrade) always bring about structural changes. Projects and settings remain untouched during installation. If you open the Editor for the first time, projects are converted to the new version. Simultaneously, an automatic backup of the old version is created.

Converted projects cannot be edited in legacy versions. From version 6.2 on, the Editor is able to create projects for different Runtime versions.

Important tips for converting projects can be found in the revision text. This is provided with the Service Pack/Update on the installation medium under Information. It is also available online.

Multi-user projects

To ensure a change to a new zenon version in multi-user projects without data loss:

  1. Check in all checked out elements on all Clients -> Accept changes.
    Nothing must be checked out. This is true for all projects.
  2. Install the new zenon version on the Server.
  3. Convert all Server projects to the new version: For this load all projects in the Editor on the Server computer.
  4. Install the new zenon version on the Client computers.
  5. Load projects on the Clients and check them out again.

Update with change of the SQL Server

If an upgrade involves changing the SQL server (e.g. update from zenon 6.51 to zenon 7.20), additional steps are needed. These steps are carried out:

  • after all projects are checked in
  • before the new version is installed

Procedure when changing the SQL Server:

  1. check in all checked out elements on all Clients -> Accept changes.
  2. at the multi-user Server open the Editor in the starting version
  3. create backups of all projects which you want to edit or open with the new version
    • either as single project backups
    • or as backup of the complete workspace
  4. install the new version on the Server
  5. convert all Server projects to the new version by loading the project backups which you have created before once in the Editor
  6. install the update on every Client
  7. transfer the projects from the multi-user Server to the Clients
    (regard the new name of the SQL instance)
  8. the projects are converted, synchronized and ready for action

Attention: Make sure that the settings of the firewall allows the data traffic between the multi-user Server and the Clients.


Exceptions for anti-virus

Manual -> Runtime -> System requirements -> Exceptions for anti-virus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

However zenon needs a range of services and operations that could categorize anti-virus programs as potentially dangerous.

Examples of this:

  • Communication with CodeMeter --> USB dongle
  • Loading VBA or VSTA code
  • Embedding ActiveX elements in screens
  • Frequent file access, for example for archiving, CEL, AML...

Note: There are compatibility problems with Ahnlabs V3 virus scanner. If zenon refuses to start with an error message, put V3 into game mode or uninstall V3.


firewall setup

Manual -> Runtime -> System requirements -> firewall setup

zenon uses a number of ports. Any firewall that is present must allow communication via these ports. These must be enabled in the firewall if applicable.

Ports used

For communication within zenon, only TCP ports are used; no UDP ports are used. zenon requires the following ports in a network:

Service | File | Goal | TCP-port
Network service | zenNetSrv.exe | Runtime communication. | 1100
Transport service | zenSysSrv.exe | Data transfer by means of Remote Transport (Editor). | 1101
zenon Web Server | zenWebSrv.exe | On-site logging machine between web client and Runtime | 1102

Port numbers can be amended individually by means of the Listening ports tab in the Startup Tool. Note in this case that all devices affected must be amended.

furthermore, zenon services use a range of ports:

Application | Standard port
Administration Service | 50777
Analyzer Connector Service | 50778
Analyzer License Service | 50779
DB Service | 1103
Logging Service | 50780
Network Service | 1100
SNMP Trap Service | 50782
Transport Service | 1101
WEB Service Classic | 1102
WEB Service Tunneling | 8080

Note: zenon drivers that communicate by means of Ethernet use TCP and thus need authorizations in the firewall in this case, regardless of the port used.


Runtime for Windows CE

Manual -> Runtime -> Runtime for Windows CE

The Runtime installation for Windows CE consists of the following files:

File name | Description
zenonrCE.exe | The Runtime application
Cd_tooCE.dll | Necessary for the Runtime
ZennetsrvCE.dll | The control system netservice for Windows CE. Necessary for network projects.
SysSrvCE.exe | Transport service
LogCliLibCE.dll | The logserver client
zenon6.ini | Text file with settings for the Runtime like e.g. start project, language of the Runtime, etc.
UpdateCE.exe | Application, necessary for the CE Update tool.
RgermaCE.dll | German language file
RengliCE.dll | English language file
RfrancCE.dll | French language file
RitaliCE.dll | Italian language file
RrussiCE.dll | Russian language file
RspaniCE.dll | Spanish language file

Install the Runtime to the CE device with the entry CE Runtime Update-Programme (under menu Option).

info Info

The following is true for a connection to Windows CE 6.0 with CX1000, Profibus or SYCONuni: Make sure that the file CDMemDrv.dll has been transferred to the device. CDMemDrv.dll is a Windows CE device driver. The DLL is available for x86 and for ARMV4I.

Additionally there are a number of other drivers for hardware communication. If the processor type of the CE device is recognised by the editor, the Remote Transport automatically transports the drivers used in the project to the CE device. The manner or The number of transferred files is displayed in the Output Window of the Editor.

These files always have to be compatible with the according CE version and with the according processor type. Mixing files from different CE versions or even service packs can lead to failures and unwanted side effects, and is thus is not permitted.

info Info

When starting zenonrce.exe, the file syssrvce.exe is also executed. Thus it is guaranteed that a TCP connection can also be established. Long delays are avoided and only one file is necessary for the autostart functionality.


System files

Manual -> Runtime -> Runtime for Windows CE -> System files

The Windows CE Runtime requires the existence of certain system files. In case one of these files is missing, the operating system sends an error message during Runtime start, that one or various components have not been found. The following system files are required:

File | Description
mfc90u.dll | Necessary for the Runtime. On startup, an error message pops up if this file does not exist.
msvcr90.dll | Necessary for the Runtime. On startup, an error message pops up if this file does not exist.
atl90.dll | Not necessary for starting the Runtime but for the use of drivers with network connections or the use of zenon in a network. If this file does not exist, the device will not work as a client; TCP/IP driver connections will not work.
IMGDECMP.dll | Not necessary for starting the Runtime but necessary for displaying Transparency if Alpha Blending is not integrated in the operating system. Animation of GIF files is not possible with Windows CE.
VBSCRIPT.dll + JSCRIPT.dll | Not necessary for starting the Runtime. This file is needed for the PCE (Process Control Engine).

Some of these system files are installed together with the installation of zenon for CE and can be transferred to the CE device using the UpdateCE Tool. All these system files should be integrated in the operating system image of the CE device by the manufacturer.

attention Attention

For manufactures of Windows CE OS-images:
CE versions older than 6.0 need the file toolhelp.dll. Activate the following option in Platform Manager in order that the file is available on the CE device and Toolhelp.h is available in SDK.
Core OS -> Display Based Device ->Core OS Services -> Debugging Tools -> Toolhelp API. Thus the Toolhelp.dll is part of the image.
Hint: Always use the most up-to-date Servicepack of the Platform Builder.

Note: File toolhelp.dll is not used for Windows CE 6 and should not be used with CE 6.


Update of the Windows CE Runtime

Manual -> Runtime -> Runtime for Windows CE -> Update of the Windows CE Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To perform an update of Windows CE Runtime:

  • make sure that the zenon Transport Service (SysSrvCE.exe) runs in the CE device
  • make sure that you do not have established a remote connection via the zenon Editor to the device
  • In the zenon Menu, select Options and then Update Windows CE Runtime.
  • The dialog for transfer of Runtime files opens
  • configure the link
  • define the data you want to transfer
  • choose the appropriate version
  • start the update

Note: If you are transferring/installing Runtime for the first time, note the information in the Manual installation and Runtime update chapter.

Configure connection

You can configure the connections to the Windows CE device in the tab Connection.

Parameters | Description
Serial | Settings for serial connection with Windows CE device, you have to select a port.
TCP/IP | Settings for TCP/IP-connection to the Windows CE device.
Adress | IP address.
Name | Computer name
Syssrvce.exe starts with these settings | Settings for starting syssrvce.exe.
Serial | Active:: serial connection selected, port must be selected.
TCP/IP | Active: TCP/IP-connection selected.
Connection with MS ActiveSync | Settings for connection via MS ActiveSync
Use MS ActiveSync for initial transport of syssrvce.exe | Active: syssrvce.exe is transferred during the first transport via MS ActiveSync.
Destination folder | Target folder.
Help | Opens online-help
Save | Saves all changes.
Exit | Closes the update CE-tool and reminds you before to save unsaved changes.

Define files you want to transfer

Parameters | Description
Files to update | Files to be transferred.
HMI Runtime | Active: Transfers zenon files to the target device. Default: active
PLC Runtime | Active: Transfers zenon Logic files to the target device. Default: inactive
OS system files | Active: Transfers necessary files for the OS. Default: active
Update zenon6.ini | Transfers zenon6.ini to the target device. This way, the license information of the target device is also changed.
Options |
Language | Desired target system language. Default: English
HMI drivers | Selection of HMI drivers for transfer.
Available | List of available dirves.
Selected | List of selected drivers.
Add | Adds chosen drivers to the list of selected drivers.
Add all | Adds all drivers to the list of selected drivers.
Remove | Removes chosen drivers from the list of selected drivers.
Remove all | Removes all drivers from the list of selected drivers.
Help | Opens online-help
Save | Saves all changes.
Exit | Closes the update CE-tool and reminds you before to save unsaved changes.

Select version

Select the correct version in the tab Versions if it wasn´t automatically recognized.

Parameters | Description
WinCE version | Version of the target device Windows CE OS. Click the button to open a drop-down list for selection.
Processor type | Processor of the device.
Source path | Path to the folder that contains the files. Click the button ... and a dialog opens to select a folder.
New | Inserts a new, empty entry in the list.
Delete | Deletes the selected entry from the list
Test | Verifies settings.
Help | Opens online-help
Save | Saves all changes.
Exit | Closes the update CE-tool and reminds you before to save unsaved changes.

Start update

To establish a connection:

  • click on the button Start on the tab Update.

  • The data that shall be transferred is verified and displayed in a window.
  • Start the transfer to the target device by clicking on the button Next .

If the transfer cannot be initiated because files are missing, an error message with a list of missing files pops up:

  • If you get the error message The current update was not completed, the update was interrupted or not executed properly.

info Information

If you want to replace zenVNCServer.exe via update, it is terminated and restarted after the update. For this the file zenVNCSrvCE.exe must contain the

the following entry in the UpdateCE.ini in section [SOURCES_FILES_GENERAL] (exists per default):

  • zenVNCSrvCE.exe
  • zenVNCCfgCE.exe


Manual installation and Runtime-update

Manual -> Runtime -> Runtime for Windows CE -> Manual installation and Runtime-update

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Installation and update are also possible without remote transport and ActiveSync. You have to copy the needed files manually on a storage card for the CE device. You have to know CE version and processor type.

It is mandatory to copy the following files from the according folder for the correct platform to a storage card for the CE device:

  • zenonRCE.exe (Runtime)
  • LogCliLibCE.dll (Diagnosis DLL)
  • zenon6.ini (Configuration file)
  • Cd_tooCE.dll (Help DLL)
  • ZenNetSrvCE.dll (Network)
  • CDHelper.dll (Help DLL)
  • One of the following language DLLs: RChineCE.dll, RCzechCE.dll, REngliCE.dll, RFrancCE.dll, RGermaCE.dll, RItaliCE.dll, RRussiCE.dll, RSpaniCE.dll (the selected language is stipulated in the zenon6.ini file.)
  • syssrvce.exe (Transport service and diagnosis server)
  • atl90.dll (System file, possibly part of the operating system)
  • mfc90u.dll (System file, possibly part of the operating system)
  • msvcr90.dll (System file, possibly part of the operating system)

Further files, for example the driver or the remote desktop software (zenVNCCfgCE.exe and zenVNCSrvCE.exe), are optional.


Supported protocols

Manual -> Runtime -> Supported protocols

Runtime communicates with all possible controllers using drivers. The drivers support a number of protocols.

Available drivers:

  • 3964R-RK512 driver (Win, CE)
  • Allen Bradley DF1-driver (Win, CE)
  • Allen-Bradley ODVA driver (Win, CE)
  • Applicom driver (Win)
  • Applicom IO configuration (Win)
  • Archive driver (RAW format) (Win, CE)
  • ARCNET - Driver for ABB (Win)
  • AS-interface (Win)
  • Bachmann M1 driver (Win)
  • Bacnet and DDC4000 driver (Win)
  • BACnet driver Next Generation (Win, CE)
  • Beckhoff BC-BK 9000 (Win, CE)
  • Beckhoff TwinCat ADS driver (Win)
  • Beckhoff TwinCat NG driver (Win, CE)
  • Beckhoff TwinCat TC-ADS driver (Win, CE)
  • Biffi DCM (Win)
  • BR TCP-IP driver (Win)
  • BR Transponder Reader 4102/4150 (Win, CE)
  • BR-PVI based driver (Win, CE)
  • BR-PVI based driver (replaced) (Win, CE)
  • Brodersen IOTOOLS (Win)
  • Buderus32 driver (Win)
  • Codesys Arti NG SoftPLC driver (Win, CE)
  • Codesys Arti SoftPLC driver (Win, CE)
  • Codesys SoftPLC driver (Win)
  • CP001 Gateway driver (Win, CE)
  • CTI driver (Win, CE)
  • Danfoss driver (Win)
  • DataTaker driver (Win, CE)
  • DDE Client driver (Win)
  • DMX 512 driver (Win)
  • DNP3 driver (Win, CE)
  • DNP3 Slave/Outstation (Win)
  • Driver for ABB 07KT94 (Win)
  • Driver for ESA PCI CIB (Win, CE)
  • Driver for Esser BMZ 8000 (Win, CE)
  • Driver for IBH Soft PLC (Win, CE)
  • Driver for internal variables (Win, CE)
  • Driver for Mathematics variable (Win, CE)
  • Driver for Otis controller (Win, CE)
  • Driver for SE-Elektronic (Win)
  • Driver for simulator variables (Win, CE)
  • Driver for Slot PCL SPCx00 (Win)
  • Driver for system variables (Win, CE)
  • Driver for the buttons /Ketop (Win, CE)
  • Driver for VIPA CE touchpanel (Win, CE)
  • Drv for BCI hand-held scanner (Win)
  • Eldatic driver (Win)
  • Elrest CAN Network driver (Win)
  • Energy analysis device UPM 3000 (Win)
  • European Installation Bus (Win)
  • Festo EasyIP Multiprog driver (Win)
  • Festo Serial-CI driver, FST (Win)
  • File driver (Win)
  • FMS with PC card from Siemens (Win)
  • Hekatron driver (Win)
  • Hilscher CIF driver (Win)
  • Hilscher CIF Profibus (Win, CE)
  • Hilscher MPI driver (Win, CE)
  • Hilscher SYCON CifX (Win)
  • Hilscher SYCON configuration (Win, CE)
  • Hilscher SYCON configuration (Win, CE)
  • Hitachi driver (Win, CE)
  • HMI adapter driver (Win, CE)
  • HMS configuration (Win)
  • Hydrometer Driver (Win)
  • i-LON 100 driver (Win)
  • Idec driver (Win)
  • Ident System driver (Win, CE)
  • IEC 60870 - 5 - 103 Driver (Win)
  • IEC 60870-5-101_104 driver (Win, CE)
  • IEC 61400-25-4 Annex C (Win, CE)
  • IEC 61499 driver (Win)
  • IEC 61850 Client (Master) (Win, CE)
  • IEC 61850 driver (Win, CE)
  • IEC 61850 Server (Slave) (Win, CE)
  • IEC-62056-21 Driver (Win)
  • IEC60870-5-101/104 Slave (Win, CE)
  • Interbus S driver (Win)
  • Interbus-S (Win)
  • Internal driver with time stamp (Win, CE)
  • Jetter Treiber (Win)
  • K-Bus driver for CX1000 (Win, CE)
  • Kemro User ID Driver (Win, CE)
  • Kieback + Peter driver (Win)
  • KOYO Sequence driver (Win, CE)
  • LogiCAD driver (Win)
  • LON driver (Win)
  • LS Industrial Systems-XGT (Win)
  • Matsushita TCP-IP driver (Win)
  • Mininet-Master driver (Win, CE)
  • Mitsubishi - Melsec A-Q driver (Win, CE)
  • Mitsubishi - Melsec FX driver (Win, CE)
  • Modbus Energy driver (Win, CE)
  • MODBUS Master protocol (Win, CE)
  • Modbus RTU and Open Modbus TCP (Win, CE)
  • MODBUS Slave protocol (Win, CE)
  • Modicon TSX Micro driver (Win, CE)
  • Moeller Electric PSUNI driver (Win, CE)
  • OMRON driver (Win, CE)
  • Omron FINS driver (Win, CE)
  • OPC Client V2-0 driver (Win, CE)
  • OPC UA Client driver (Win, CE)
  • OSAI TCP/IP driver (Win, CE)
  • Panasonic serial driver (Win)
  • Passive Modbus RTU driver (Win)
  • PC Adapter - Vipa Green Cable (Win, CE)
  • PCS807 Profibus DP driver (Win, CE)
  • PCS812 S7 connection (Win, CE)
  • PDNet PCI - driver (Win)
  • PICnet driver (Win, CE)
  • PILZ-PSS driver (Win, CE)
  • Profibus DP Master driver (Win)
  • ProfiNet IO RT (Win, CE)
  • Reis Robotics driver (Win)
  • RTK9000 driver (Win)
  • S5 H1 driver (Win)
  • S5 TCP-IP driver (Win)
  • S7 driver for S7-200 (Win, CE)
  • S7 driver Softnet based (Win)
  • S7 MPI for Siemens CE terminals (Win, CE)
  • S7 TCP-IP driver (Win, CE)
  • S7_MPIISA driver (Win)
  • Saia Directly driver (Win, CE)
  • SAIA2ND32 driver (Win)
  • SaNORS - Asfinag SOS-telephones (Win)
  • Schiele S400 driver (Win, CE)
  • Schiele S800 driver (Win, CE)
  • Siclimat X Decos (Win)
  • Siemens S5 PD driver (Win, CE)
  • Siemens Sigmasys driver (Win)
  • SIGMATEK driver (Win)
  • Sigmatek Lasal Driver (Win, CE)
  • Simotion driver (Win)
  • SNMP Driver (Win)
  • SoftNet ProfibusDP (Win)
  • SQL Driver (Win)
  • SST Driver (Win)
  • Standard M-Bus driver (Win, CE)
  • straton driver (Win, CE)
  • straton NG driver (Win, CE)
  • straton to zenon RT connection (Win, CE)
  • Swarco Futurit (Win)
  • System 2000 driver (Win)
  • System 2000 driver with logging (Win)
  • Telco200 driver (Win)
  • Teleperm driver (Win)
  • ThinkIO/IOSystem758 (Win, CE)
  • TI 505 - 545 driver (Win)
  • Trend Driver (Win)
  • Trend NG driver (Win)
  • VDMA-XML driver (Win, CE)
  • VMEBUS driver (Win)
  • Win32 Shared memory (Win)
  • WINAC driver (Win)
  • Write variable values in SQL (Win)


Putting Runtime into operation

Manual -> Runtime -> Putting Runtime into operation

The procedure for putting Runtime into operation for the first time depends on whether the device you are operating is a turn-key device with Runtime installed or a device on which Runtime must be installed. If Runtime is already installed on the device, only the desired project needs to be copied to the Runtime device.

To do this:

  • Save your project files on an external data medium.
  • Use Drag&Drop or Copy&Paste to transfer these to your Runtime device.

or

  • Get the project from the server on the Runtime device.
  • Create a Client using the network topology.

Note: This is also possible by means of remote transport.

If Runtime is not yet installed on the device, it must first be installed. You can read how this works in the zenon standard installation chapter.

A license is required after installation in order to put it into operation. The license information is on a license form, which is enclosed with the device or the installation medium.

Note: The hard drive of the device you are operating may stop working after many years of use in a harsh industrial environment. To avoid loss of data, it may be a good idea to ensure that there is a redundant environment, such as working with both a Server and a Standby Server.


zenon Standard installation

Manual -> Runtime -> Putting Runtime into operation -> zenon Standard installation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon will automatically start its installation routine and guide you through the whole installation process when the zenon installation medium is connected. Alternatively, it is possible to start the installation by executing start.exe in the root directory of your zenon installation medium.

attention Attention

The computer is automatically restarted during installation if necessary. Close all other programs before installation.

  1. You can see the version to be installed including the build number on the start screen.
  2. Select the desired language for the installation from the drop-down list at the top left.
  3. You can receive information on zenon with:
    • Click on button i: Opens the Flash player with information on the current zenon version.
    • Click on button ? Opens the zenon help for installation as a PDF.

    Attention: This page cannot be shown again later. If you need information on the current version or need the manual for installation, open it now.

  4. Clicking on the Next button opens the window with the license conditions.
  5. Confirm the license conditions by activating the corresponding checkbox.

    You can also print the license conditions out by clicking on the Print button.

  6. Clicking on the Next button opens the window to select the desired product.
  7. Select the desired product. It is only possible to select products that have not already been installed. If you want to reinstall something, you must first uninstall it using the control panel.

    • Editor: Installs the zenon Editor and zenon Runtime. Other components required for the Editor are also installed together automatically.
    • Runtime: Installs the zenon Runtime only.
    • Web Server: Installs zenon Web Server and the respective current zenon Web Clients.
  8. By clicking on the desired product, you open the window to select the edition.
  9. Select the licensed version:
    • zenon Supervisor Edition
    • zenon Energy Edition
    • zenon Pharma Edition
    • zenon Operator Edition

  10. Click on the desired edition to open the window to select the type of installation:
    • Install now: Starts the installation of the selected edition.
      The computer may be restarted automatically during installation. Follow the instructions of the wizard
    • User defined: Opens other windows for individual installation.
      You can enter an existing serial number here and change the installation path.

User-defined installation

  1. If you select user-defined during installation, the window to enter the serial number is opened:

    • Select demo version if you do not have a license.
    • I you already have a license, enter the serial number and activation number.
  2. Clicking on the Next button opens the window to amend the installation folder.

    • If necessary, define you individual folder for the 32-bit version and the 64-bit version of the program.
    • Define the target folder for the project database.
      Note: This folder cannot be changed afterwards. The save location selected here must have sufficient memory space. All users need write authorization.
    • If you would also like to install the demo project, activate the corresponding checkbox.
      The demo project provides examples of possible usage scenarios in different industries. You can find details in the section Encryption zenon Demo-Project.
  3. Click on the Install button. Installation of the selected edition is started.
    The computer may be restarted automatically during installation. Follow the instructions of the wizard


Error treatment

Manual -> Runtime -> Putting Runtime into operation -> zenon Standard installation -> Error treatment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Check before installation:

The system requirements are checked before installation. If the requirements are not met, you are shown these on a separate page with notices on how to rectify this.

Error during installation

You will receive an error message if there are errors during installation.

If you need help from the Technical Consulting department of COPA-DATA:

  1. If possible, create a screenshot of the error message
  2. Navigate to the folder called %Temp%/SCADALOG.
  3. Here you can find the log files of the installation.
  4. Create a ZIP file with the content of the folder.
  5. Forward the file and the screenshot to support@copadata.com

If you have already closed the error message window, you can find the log files with all the installation information for the SQL server in the following folder:
C:\Program Files\Microsoft SQL Server\110\Setup Bootstrap\LOG

Hint: The file summary.txt provides information for troubleshooting.

info Information

Firewalls: zenon automatically configures the firewall installed with Windows during installation. Firewalls from other providers must be properly configured by the user

Frequent sources of error during installation:

  • The virus scanner is active and blocks the installtion because the scanner thinks it´s a virus. Solution: Seperate the system from the network, disable the virus scanner, execute the installation again.
  • The firewall was not configured correctly. Solution: Seperate the system from the network, disable the firewall, execute the installation again.
  • Erroneous SQL-installation on the system. Solution: Create project backups; if possible, deinstall SQL server, rename the SQL folder, and restart installation.


Uninstalling Runtime

Manual -> Runtime -> Putting Runtime into operation -> Uninstalling Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To uninstall Runtime:

  1. Open the Control Panel.
  2. Click on Programs.
  3. Click on Programs and Features.
  4. Select the zenon 7.20 programs.
  5. Click on Uninstall.
  6. Follow the uninstall wizard.


Starting the Runtime

Manual -> Runtime -> Starting the Runtime

There are several possibilities for starting zenon Logic Runtime:

  • Using the Editor
    • by pressing key F5
    • via symbol Start Runtime in the tool barRuntime files
  • Via the Startup-Tool
  • via the Windows start menu
  • using Windows Autostart.
  • Via the zenStartupMgr service

Dienst zenAdminSrv

The zenAdminSrv service must be started to start the Runtime. If the service is not available, you will receive an error message accordingly.

When starting via Windows Autostart, zenon attempts to start Runtime until the service is available or you end the error message by clicking on the Cancel button.

Size of the main window

The size of the Runtime window when Runtime is started is configured for the local computer in the zenon Editor.
Carry out the following steps for this configuration:

  1. Select the Workspace in the zenon Editor.
  2. Click on the Local Runtime size property group.
  3. Enter the values for Runtime window width [pixel].
  4. Enter the values for Runtime window height [pixel].

Function "Window to foreground"

The Runtime can be moved behind other running programs with the help of function Window to the background. With function Window to foreground it is moved to the foreground.

info Information

At moving the Runtime to the foreground the Runtime window is defined as the topmost window. At this the alarm status line is covered. In order to get the alarm status line back to the foreground, you can:

  • activate the system keys (deactivate project settting Lock system keys) and get back the alarm status line via Alt+Tab to the foreground
  • activate the Windows task bar and click un window Status
  • move the Runtime back to the background
  • restart the Runtime

Set start project

If you have created a project, you can start this in different ways.

Note: It is a requirement that the project generated is first transferred to the target system if the configuration computer is not also the target system.

There are several possibilities for starting a project in Runtime:

Using the Editor:

  1. Start the zenon Editor.
  2. Select the project that you want to set as the start project.
  3. Click on Set project as start project in the context menu

Via the Startup Tool:

  1. Open the Startup Tool.
  2. Click on Item-->Properties...
  3. Select, in the RT project field, the project that you want to set as the start project.

Via Remote Transport:

  1. Activate the project in in the toolbar.
  2. Select the desired project as the start project.

Via the network topology:

  1. Add a computer.
  2. Select this computer.
  3. Select the desired project as the start project.


Set up Runtime autostart

Manual -> Runtime -> Starting the Runtime -> Set up Runtime autostart

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To set up Runtime autostart, proceed as follows:

  1. Select the zenonrt.32.exe application from the C:\Program Files (x86)\COPA-DATA\zenon 7.20 SP0 directory.
  2. Create a local link for this.
  3. Copy this into the Autostart folder from the start menu.

Runtime thus starts automatically the next time you log on.


Keyblock Runtime Start

Manual -> Runtime -> Starting the Runtime -> Keyblock Runtime Start

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Keyblock Runtime Start is a program with which zenon Runtime runs as a shell. In doing so, zenon Runtime is started, but all Windows system tasks are blocked. Shortcuts such as Windows key or Ctrl+Alt+Del no longer have an effect. User can no longer access the operating system but only work on the zenon user interface.

The precondition for this is that the project properties are set Runtime title to No title (full screen). Then zenon runs in full screen mode and the Runtime cannot be minimized.

Note also the information provided in the Protect Runtime files chapter.

tutorial License information

Part of the standard license of the Editor and Runtime.


Configure start delay

Manual -> Runtime -> Starting the Runtime -> Configure start delay

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When using dongles for licensing, the Codemeter service must be ready before zenon Runtime starts. To amend the start time, you can configure a start delay for zenon Runtime.

zenon Runtime start delay

Stipulate a start delay of at least 30 seconds in the zenon6.ini file for zenon.

To do this:

  1. Open the zenon6.ini file with a text editor.
  2. Navigate to the [DEFAULT] area
  3. Enter the desired delay for STARTDELAY= .

Example:

[DEFAULT]

STARTDELAY= 30000

info Information

You can find zenon6.ini in the following path:

Windows 7/8: %ProgramData%\COPA-DATA\System\


Starting Runtime as a service

Manual -> Runtime -> Starting Runtime as a service

The zenon Runtime can automatically be started as a service by the zenStartupMgr service.

Attention: If Runtime is started using the zenStartupMgr, it can no longer be stopped or restarted by users.

To start Runtime as a service:

  1. Register the file zenStartupMgr.exe as a service:
  2. Configure the properties for sign-in.
  3. Start, if necessary, Remote Transport with zenStartupMgr
  4. Define the Runtime to be started in the Startup Tool
  5. Configure a start delay for zenon Runtime if you are using a dongle license

Register service

To register zenStartupMgr.exe as a service:

  1. Open the command line.
  2. Go to the save location of the file zenStartupMgr.exe.
    (default with 32-bit OS: %ProgramFiles(x86)%\Common Files\COPA-DATA\zenStartupMgr
    (default 64-bit OS: %ProgramFiles\Common Files\COPA-DATA\zenStartupMgr)
  3. Register the file as a service with the zenStartupMgr.exe –service command.
    Note: The service, if it is already running, is first stopped and then registered. If zenStartupMgr is running, it is closed.

Configure service for the use of many drivers

Windows as an operating system limits the number of windows that can be created due to its fixed, reserved desktop memory, depending on the version and possible integration with the desktop.

Version/action | Interactive Desktop | Non-Interactive Desktop
Windows 7 32-Bit | 12 MB | 512 KB
Windows 7/Windows Server 2008 R2 64-bit | 20 MB | 768 KB

zenon drivers each need several windows. The number of drivers that can be used can be influenced using the Allow data exchange between service and desktop option in the properties of the service.

  • Inactive A maximum of 20 drivers can be started.
  • Active: As many drivers as there are in a Runtime started as a user process can be started.

To activate the Allow data exchange between service and desktop option:

  1. Open the Windows Service Manager.
  2. Open the properties of the zenStartupMgr service.
  3. Go to the Login tab.

  4. Activate the Allow data exchange between service and desktop.
    This service must be configured to automatic start type. With the service active, the user logged on to the computer is notified if the zenon Runtime as a service opens an additional window, for example in the event of a new alarm and active status line.

    Note Windows 8/Server 2012: In order for the service to be able to be started, the entry must be set correctly in the Windows registry:

    1. Go to the entry HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Windows.
    2. Open or create the DWORD value NoInteractiveServices.
    3. Set the decimal value of 1 to 0.
  5. To stop Runtime messages being displayed on the desktop:
    Deactivate the Detection of inactive services service.

Interactive access

If it is possible to interactively access the process, then:

  1. Activate the Allow data exchange between service and desktop option in the service.
  2. Activate the Detection of interactive services service.

Note: This type of access is not suitable for use for the actual operation of Runtime. Services are intended as program instances that run in the background that are not operated by means of a user interface. If operations on the Runtime Server are to be carried out, Runtime must be started as an application. If Runtime is to run on the Server as a service, operation of Runtime can be carried out from a zenon Client.

Limitations to interactive access

If zenon Runtime is started as a service and this is nevertheless to have a graphic user interface (GUI), this is implemented by the operating system by means of the Secure Desktop (detection of interactive services) system service.

Access to the Runtime user interface via the Windows system service has been subject to several restrictions since the Vista/Server 2008 version for security reasons. Above all:

  • The interactive desktop is automatically ended after one minute of inactivity and the windows login screen is displayed.
  • Display of DirectX effects, such as glow or shadowing for elements is not possible.
  • Multi-monitor operation is not possible.


Configuration of zenon Logic Runtime

Manual -> Runtime -> Starting Runtime as a service -> Configuration of zenon Logic Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If zenon is running as a service, the user interface of the integrated zenon Logic Runtime is not available. To make changes to the configuration of zenon Logic Runtime, Runtime must be started normally.

There are different possibilities for configuration:

1. You can connect to the panel on which Runtime is to run via remote transport and enter the license for Runtime there.

2. Network configuration: Encryption via Remote Transport can also be configured.

3. See the zenon6.ini, General settings [DEFAULT] chapter.


Configuration in the Startup Tool

Manual -> Runtime -> Starting Runtime as a service -> Configuration in the Startup Tool

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can define how several programs are to be started by the service in the Startup Tool. To start an existing zenon Runtime as a service:

  1. Open the zenon Startup Tool.
  2. Click on Application.
  3. Select Options.
  4. The dialog with the settings is opened.
  5. Navigate to the Service Startup tab.

  6. To define a Runtime, click on the New button
  7. The dialog for selecting a program is opened.

  8. Click on the ... button to open the file selection dialog
  9. Go to the corresponding zenon folder
  10. Select Zenrt32.exe.
  11. Close the selection dialog and the Startup Tool.


Remote Transport

Manual -> Runtime -> Starting Runtime as a service -> Remote Transport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In its standard settings, zenon Remote Transport runs in the context of a logged-in user. In this configuration, it can neither start Runtime as a service nor reload or stop it.

Remote Transport must therefore be started with zenStartupMgr. To do this:

  1. Create an entry for the start of zenSysSrv in Startup Tool -> Service startup.
  2. Place the entry before the entry for zenrt32.exe.
  3. Deactivate zenSysSrv for logged-in users.

The Remote Transport can:

  • Transfer data to the server
  • Reload data

If Runtime runs as a service, it cannot be stopped or started by means of Remote Transport.

Deactivate Remote Transport for logged-in users

If zenSysSrv is started with zenStartupMgr, it can no longer be started by logged-in users. To avoid this, remove it from the registry manually.

zenSysSrv up to Windows 8:

  1. Open the Windows dialog to execute commands (Windows key + R).
  2. Enter msconfig.
  3. The system configuration dialog is opened.
  4. Go to the Start tab.
  5. Deactivate the automatic start of zenon by deactivating the checkbox in front of zenSysSrv.exe.
  6. Click on Accept.
  7. Close the dialog by clicking on OK.
  8. Restart the computer

zenSysSrv from Windows 8:

  1. Open the Task Manager (Crtl + Shift + Esc keys).
  2. Go to the Autostart tab.
  3. Deactivate the automatic start of zenon by deactivating the checkbox in front of zenSysSrv - Transport service.
  4. Click on Deactivate.
  5. Restart the computer

Attention: If a zenon version is re-registered via the Startup Tool, the entry is recreated and must be removed manually again.


Procedure

Manual -> Runtime -> Starting Runtime as a service -> Procedure

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If the zenStartupMrg service is started, then it starts all processes entered in the Startup Tool consecutively as child processes. If the service is ended, it ends all processes it has sent in reverse order.

Rights

All processes started by zenStartupMrg run under the user under which the the service is started by the system. This is generally the local system account. Only resources that can access the local system account can be used.
The following are thus generally not reachable:

  • Network drives
  • Network printers
  • Databases with the option Use Windows NT integrated security activated

If zenStartupMgr is started under a dedicated Windows user, no interaction with the desktop is possible.
Warning: The password of a dedicated user can neither be changed nor expire. Otherwise the service will no longer start.

Secure Desktop

Secure Desktop can be used to interactively access a process that has a user interface and is executed in a system context. The following must be the case for this:

  • In the zenStartupMgr service, the option Allow data exchange between service and desktop must be activated
  • The system service Detection of interactive services must be started

Note: This type of access is not suitable for use for the actual operation of Runtime. Services are intended as program instances that run in the background that are not operated by means of a user interface. If operations on the Runtime Server are to be carried out, Runtime must be started as an application. If Runtime is to run on the Server as a service, operation of Runtime can be carried out from a zenon Client.

Message boxes and modal dialogs are automatically suppressed if:

  • zenon Runtime is started via zenStartupMgr in the system context
    and
  • Secure Desktop is not displayed

attention Attention

Modal dialogs must never be called up via VBA or VSTA, because there is no possibility to close these again through user interaction.


Runtime as ActiveX control

Manual -> Runtime -> Runtime as ActiveX control

For KUKA HMIs, there is an ActiveX control available that allows the complete Runtime to run in a control. Runtime can thus be inserted into another application as a sub-program. The control acts, with a few exceptions, in the same way as the zenon Web Client and can also run in a browser.

Name Control: zenRuntimeCtrl.ocx

Differences to zenon Web Server:

  • Can only run within a 32-bit zenon Runtime installation
  • Server and standalone is also possible, not just client
  • Also starts the driver
  • The license is read from zenon6.ini, so a zenon Runtime license is therefore required
  • The start project is read from zenon6.ini; OCX properties server, zenon Web Server and project do not exist
  • Network communication is carried out using zenNetSrv.exe, not via zenNetSrv.dll


Operating during Runtime

Manual -> Runtime -> Operating during Runtime

Types of operation

Runtime can be operated with a mouse as well as with a keyboard or touch screen. For mouse or touch operation, you can primarily use buttons, status buttons, switches and invisible buttons in your project. The possibility of mouse operation of a screen object is signalized with a change in the cross symbol of the cursor for a button on the computer, for example by the symbol

info Information

The switching time of screens in Runtime depends on the number of linked variables. Only once all variables have been successfully signed in can the screen be operated.

If many variables are operated, this can slow the switching time. In this case, a progress bar is shown, which displays the loading progress.


Mouse

Manual -> Runtime -> Operating during Runtime -> Mouse

Clicking on a dynamic element opens (depending on the setting of the dynamic element) the standard dialog for setpoint input. Depending on the data type of the variable the following dialogs are opened:

Possible operations are:

Parameters | Description
Switch to spontaneous value | Display spontaneous value (value from PLC) if substitute value was displayed before or the value was turned off.
Modify on-change value (default) | Write new spontaneous value to the PLC
Switching and modes. Spontaneous value | Combination of the two commands above
Switch to alternate value | Display substitute value (value from variable definition), if spontaneous value was displayed before
Modify alternate value | Set new substitute value for variable
Switching and modes. Alternate value | Combination of the two commands above
Switch off spontaneous value | Turn off connection to the PLC for this value by setting status bit OFF (bit 20).
Switch on spontaneous value | Resume connection to the PLC for this value by resetting bit OFF.
Setting of binary status | - LOW (0) - HIGH (1)

Possible operations are:

Parameters | Description
Switch to spontaneous value | Display spontaneous value (value from PLC) if substitute value was displayed before or the value was turned off.
Modify on-change value (default) | Write new spontaneous value to the PLC.
Switching and modes. Spontaneous value | Combination of the two commands above.
Switch to alternate value | Display substitute value (value from variable definition),if spontaneous value was displayed before.
Modify alternate value | Set new substitute value for variable
Switching and modes. Alternate value | Combination of the two commands above.
Switch off spontaneous value | Turn off connection to the PLC for this value by setting status bit OFF (bit 20).
Switch on spontaneous value | Resume connection to the PLC for this value by resetting bit OFF.
Value | New numerical value (within defined measuring range).

Possible operations are:

Parameters | Description
Switch to spontaneous value | Display spontaneous value (value from PLC) if substitute value was displayed before or the value was turned off.
Modify on-change value (default) | Write new spontaneous value to the PLC
Switching and modes. Spontaneous value | Combination of the two commands above
Switch to alternate value | Display substitute value (value from variable definition), if spontaneous value was displayed before
Modify alternate value | Set new substitute value for variable
Switching and modes. Alternate value | Combination of the two commands above
Switch off spontaneous value | Turn off connection to the PLC for this value by setting status bit OFF (bit 20).
Switch on spontaneous value | Resume connection to the PLC for this value by resetting bit OFF.
Text | New text

Lasso

Dynamic elements which are linked with a variable or function can be pre-selected with the lasso in the Runtime and therefore by used for VBA events.

Selection per lasso

To select elements with the lasso in the Runtime, you must:

  • activate property Runtime settings/Runtime lasso in the project settings
  • activate property Runtime/selectable with lasso in the property of the dynamic element

In the Runtime several methods for selecting elements are available:

  • Select elements: Left-click on a free area and move lasso over the screen elements while holding the mouse button pressed.
  • Extend selecton: Ctrl+mouse click on an element in order to select/deselect it in addition to the other elements already selected
  • Add elements: While spanning the lasso press and hold Ctrl in order to add elements to the existing selection
  • Cancel selection: Spanning a lasso which does not contain elements.


Touch

Manual -> Runtime -> Operating during Runtime -> Touch

With zenon, touch screens can also be operated with Multi-Touch gestures. You can obtain an example project from your zenon consultant.

The following is recommended for Multi-Touch:

  • Use of a DirectX 11-compatible graphics card
  • Use DirectX hardware in the project settings for the graphics quality.

Note: With Windows 8 gestures, interaction can be configured in many areas via Multi-Touch via properties with no additional programing necessary.


Navigation with Multi-Touch in the worldview

Manual -> Runtime -> Operating during Runtime -> Touch -> Navigation with Multi-Touch in the worldview

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Multi-Touch gestures for zooming and scrolling are suitable for navigation on touch panels in the worldview. For this a screen of type Worldview overview is not necessary. The navigation can be implemented with:

  • Windows 7 touch gestures
  • Windows 8 touch gestures

Rules

  • Move: If a screen in a container is not a worldview, it accepts the settings of the faceplate screen.

Moving the worldview or worldview in the container of a faceplate

  • Screen is bigger than the frame: Content of the screen is moved.
  • Screen is the same size or smaller than the frame: No reaction.

Worldview embedded in faceplate.

  • Screen is bigger than the frame: Content of screen is moved.
  • Screen is the same size or smaller than the frame: No reaction.

Move the frame or border with the mouse if the screen is a worldview and the same size or smaller than the frame:

  • With the right mouse button: No reaction.
  • With the left mouse button: Frame is moved.

Change worldview size

The size of the worldview cannot be changed.
Exception: If the worldview is a faceplate, the size cannot be changed.

Click with right mouse button:

  • Screen is bigger than the frame: Contents are moved.
  • Screen is the same size or smaller than the frame: No reaction.

Project conversion

Values for Move horizontally and Move vertically when converting from an earlier version to zenon 7.20:

  • Screen is bigger than the frame: Move.
  • Screen is the same size or smaller than the frame: No reaction.


Navigation under Windows 7

Manual -> Runtime -> Operating during Runtime -> Touch -> Navigation with Multi-Touch in the worldview -> Navigation under Windows 7

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To be able to use Multi-Touch gestures under Windows 7 to navigate in the worldview, you must:

  • activate them via property Multi-Touch for zoom and scroll
  • or implement them via VBA/VSTA

Zoom and scroll via property Multi-Touch for zoom and scroll

To use Multi-Touch without VBA/VSTA:

  1. In the project properties in the Interaction node for the Recognition property, activate Windows 7.
  2. Deactivate property Screen size from frame in node Frame at the properties of the screen
  3. Activate property Multi-Touch for zoom and scroll in node Interaction at the properties of the screen

With this you can scroll and zoom in the screen with touch operation using Multi-Touch gestures. With this VBA/VSTA for zooming and scrolling is deactivated.

Zoom and scroll via VBA/VSTA

To implement zooming and scrolling via VBA/VSTA Events, property Multi-Touch for zoom and scroll must not be active.

The following is available in the DynPicture:

  • Property

    int ZoomLevel: Displays the current zoom level in the worldview (valid value only in the Runtime and for a worldview).

  • Style

    SetZoomAndPos(float ZoomX, float ZoomY, int ZoomLevel, int CursorX, int CursorY, int PosX, int PosY, int PosMode):

    ZoomX -> New zoom factor X direction; if not used, set to 0

    ZoomY -> New zoom factor Y direction; if not used, set to 0

    ZoomLevel -> Zoom level, if not used, set to -1

    CursorX -> Cursorposition X

    CursorY -> Cursorposition Y

    PosX -> New position X (see PosMode)

    PosY -> New position Y (see PosMode)

    PosMode -> Coordinates in Pos

    -1 = PosX, PosY are ignored

    0 = center point , original coordinates

    1 = center point, zoomed coordinates

    2 = left top, original coordinates

    3 = left top, zoomed coordinates

    4 = zoomed coordinates of the cursor from the top left
    The position of the window is changed in such a way that after the zooming the mouse cursor is still over the position of the screen

Attention: ZoomX, ZoomY and ZoomLevel can never be used simultaneously. Either you enter a ZoomLevel or a zoom factor for x and y axis.


Navigation under Windows 8

Manual -> Runtime -> Operating during Runtime -> Touch -> Navigation with Multi-Touch in the worldview -> Navigation under Windows 8

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To navigate in a worldview with Multi-Touch under Windows 8:

  1. In the project properties in the Interaction node for the Recognition property, activate Windows 8.
  2. Deactivate, for the screen in the Frame group, the Screen size from frame property and define the screen size as larger than the frame.
  3. navigate to group Interaction in the screen properties.
  4. Configure the properties for Zoomen and Verschieben.

For the move gesture, you can define the direction - horizontal, vertical or both. To do this, use the Horizontal verschieben and Vertikal verschieben properties.


Keyboard operation

Manual -> Runtime -> Operating during Runtime -> Keyboard operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can use the keyboard also for the complete navigation and operation in the Runtime. In doing so, the focus is first set to a frame; within the frame, you can navigate with the cursor keys and instigate an action with the Enter key. The following functions are used for control:

  • Set focus to frame
  • Take focus away from frame
  • Move focus
  • Activate input to the element with the focus

The order in which the elements are selected is defined via the allocation of index numbers to the elements of a screen. This definition of the navigation order also works with symbols.

The keyboard operation can also be carried out with freely allocated shortcuts such as Ctrl+M. The shortcuts can be assigned to each operation element at the property Key combination.


Functions

Manual -> Runtime -> Operating during Runtime -> Keyboard operation -> Functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For engineering the keyboard operation use the following functions:

Set focus to frame

This function sets the focus to a defined frame when operating the keys in Runtime.

To configure the function:

  1. Select, in the list of functions, in the Screens node, the Set focus to frame function
  2. The dialog for selecting a screen is opened
  3. select the frame you wish to assign
  4. For multi-monitor projects, select the virtual monitor for opening the frame

The frame with a focus is displayed with a frame in runtime. The line width and color of the frame are defined in the Graphical design/Screens node in project properties.

Frame selection dialog

In the frame selection dialog, frames can be selected for the execution of functions, from:

  • Current project
  • Subprojects
  • All projects in the workspace with the Keep project in memory option active

Parameters | Description
Project tree window | Displays all projects in the workspace. Frames can be selected from the current project and from all projects with the Keep project in memory option active
Frames window | Selection of a frame. If several frames are selected, the frame at the top of the list is used to execute the function.
No selection | Removes selection and closes dialog.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.

Set focus on frame with multiple frames called up

If a frame is displayed on a monitor several times, then the focus is switched in the reverse of the switching sequence each time the functions of the focus are executed. If, for example, with a frame that is called up several times, the screens Screen1, Screen2 and Screen3 are open and then the focus is set to this frame, the focus goes to the last screen opened, Screen3. When the Set focus to frame function is called up again, the focus is set to Screen2 etc.

Move focus

This function set the focus on a particular element in runtime with keyboard operation and can therefore be used to navigate within a frame.

Property | Action
Direction | Define the direction in which the focus should be moved. The following defined sequence applies in the editor in the context menu or under Edit/change focus sequence...
on the element | Definition of the element for the focus. Enter the object name of the element.

Activate input to the element with the focus

This function activates the element that is being focused on in the frame selected.

Take focus away from frame

This function takes the focus from the current frame in runtime. To continue operating the keyboard, the focus must be set to a frame again.


Block keyboard shortcuts

Manual -> Runtime -> Operating during Runtime -> Block keyboard shortcuts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Windows keyboard shortcuts can be blocked for online operation. The block is configured in the Editor. It is also possible to block all system keys for Runtime.

Lock Windows shortcuts

To block Windows keyboard shortcuts, activate the Lock system keys property in the Interaction area of the project properties.

Locked are:

Key combination | effect
Alt + Esc | Switches to the next application.
Alt + Tab | Switches between open applications. Direction: forwards.
Alt + Shift + Tab | Switches between open applications. Direction: backwards.
Ctrl + Tab | Switches to the next window within the application. Can be assigned application-specifically.
Ctrl + Esc | Calls up Start menu.
Alt + F4 | Closes application.
Ctrl + F4 | Closes window within an application.
Ctrl + Shift + Esc | Starts up the Windows Task Manager.
Windows key | Calls up Start menu.
Windows key + D | Minimizes or maximizes all windows.
Windows key + E | Opens Windows Explorer.
Windows key + F | Opens the search
Windows key + M | Minimizes all windows present on the task bar.
Windows key + P | Switches to presentation mode.
Windows key + R | Starts the Execute dialog.

All corresponding combinations with mouse actions are also blocked.

Not locked are:

Key combination | effect
Ctrl+Alt+Del | Restarts the computer.
Windows key + L | Locks the computer.

Lock all system keys

To lock all systen keys in the Runtime:

  • Activate the property Lock system keys
  • start the Runtime via Keyblock Runtime Start
  • consider the hints in chapter protect Runtime files


Define sort order inside a frame

Manual -> Runtime -> Operating during Runtime -> Define sort order inside a frame

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You define the sequence for the actuation of the elements in a screen with the project configuration in the zenon Editor:

  1. Open the screen.
  2. Right-click an empty area.
  3. Select Shift order for focus from the context menu.
  4. Select from the drop-down list Order for left/right or Order for up/down.
  5. Each element in the screen is displayed with a number in the top left corner.
  6. Click on the element which should be selected first.
  7. the number of the element changes to 1.
  8. click on all other elements in the order you want them to be selected:
    • Elements which have already been defined change the background color of the number.
    • Elements which cannot be selected with the help of the keyboard in the Runtime (property Focus is set to the element inactive) are displayed with a red number.
    • If you click on an element while holding Ctrl, the numbering starts with the index number of this element.

info Information

In the properties of the elements the position is displayed via the properties Focus position left/right and Focus position top/bottom. These properties are for information only. The index values of the position cannot be changed there.

Symbols

An index can also be assigned to symbols. During compiling the Runtime files, the symbol is disjointed and its elements are inserted. Thereby the order for selecting the elements which was defined in the symbol is taken into consideration.

Example Example

There are three elements in this screen: the numerical value Z, the button B and the symbol VS. The symbol from the project library receives the three numerical values: N1, N2 and N3.

If you define the order in the screen as: B - LS - Z,
the order in the Runtime is: B - N1 - N2 - N3 - N.


Positioning and operation of frames

Manual -> Runtime -> Operating during Runtime -> Positioning and operation of frames

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Frames can be switched to fixed or relatively defined positions in Runtime. In this way, keyboard screens or pop-up screens can be positioned exactly where the mouse pointer or the element to be switched is located. Frames can be switched in runtime:

  • at an absolute position
  • relative to the mouse position
  • relative to element

Absolute and relative positions are defined in the properties of the frame in the zenon Editor.

Keep position when displaying again

Windows always take their screen position from the template. If pop up screens are planned and moved whilst the program is running, the pop up screen is moved back to the planned position the next time the screen switching function is activated. Using the Keep position and size on reopening property, the template can be set to keep its position as long as it is open, regardless of screen switches. If the property is active:

  • If a screen is opened in Runtime in a manually-moved frame, its position and size are also retained if the screen is switched.
  • If another screen is opened in the in the same template, its position is retained. This also applies for a substituted call.

With this, a different position position for a template can be used on each client, because the local position is always saved.

Absolute Positioning

The frame is always switched at fixed, pre-defined coordinates. A fixed screen position is always used for all screens that are loaded automatically by the system, e.g. by the time control or a limit violation.

Relative positioning

Relative positioning is especially suited to loading pop-ups, keyboard screens or command processing screens. This is possible for all screen switches, set value inputs with freely defined keyboard screens, and command processing screens that are started manually by the user. It does not matter whether the action was triggered by a screen switch function, a set value function or directly via an element. Relative positioning is available for:

  • dynamic elements to which you can allocate a function
  • dynamic elements that can be used to send a set value (buttons, combined elements)
  • Main and Context Menus
  • execute the screen-specific function in the Alarm Message List screen

Relative positioning also works for nested function calls, i.e. when screen switching or the setting of values are triggered by a script. If the screen would stand over the screen border, it is automatically positioned at the screen border. This also applies to multi-monitor management, where screen would rise into the neighboring monitor.

attention Attention

Relative positioning only works when called up directly by the user, not with automated functions or via VBA.

relative to the element

Positions the reference point of the frame relative to the element from which the screen switch was initiated (e.g. a button or a combined element). The frame's reference point is then always placed on the element's calculated reference point. If the frame cannot be switched off in this position because the screen would then be outside the visible screen area, the alternative reference points are used.

First define a reference point for your frame and then the preferred position in the element. The following settings are available:

Property

Value

Reference point element vertical
  • bottom
  • top

Reference point element horizontal
  • Left
  • Right

Vertical movement in pixels

Enter the desired movement

Horizontal movement in pixels

Enter the desired movement

Alternative position

Define an alternative position for the reference point of the frame and the reference point at the element. Proceed with the definition of the alternative positions in the same way as with the definition of the favored positions. The alternative position is used when the frame can not be placed at the favored position.

Relative to the mouse pointer

The screen is displayed depending on the position of the mouse pointer. If the reference point is at the top left side, the frame will be loaded to the bottom right side of the reference point. If the screen cannot be displayed completely at the configured position, the position will be moved until the complete screen is inside the displayed area of the screen.

Define the frame's reference point above the two properties, vertical reference point and horizontal reference point. The reference point is marked on the frame with a red dot. The following settings are available:

Property

Value

Reference point frame vertical
  • top
  • bottom
  • centered

Horizontal frame reference point
  • Left
  • Right
  • Centered

Example Example

you have a button at the right border of the screen and try to position a popup window on its right side:

  • Reference point element: right/centered
  • Reference point element: left/centered

In Runtime, the popup screen will appear on the right side of the button, centered to the middle of the button. The popup window will not cover the button.

You use the same frame also for a button on the left screen border. There may not be enough room on the right side to completely display the popup screen. The alternative configured position will therefore be used. For this, you place the

  • alternative reference point for the element on: left/centered
  • the frame's alternative reference point on right/centered

Change the size in Runtime

The size with which a screen is called up in Runtime and the permitted changes in size are configured with the properties of the Position group.

Property

Description

Width (maximum) [pixels]:

Defines the maximum width.

Height (maximum) [pixels]:

Defines the maximum height.

Limitation Minimum:

Defines limits for minimum. Possible values:

  • Without. No limitation
    If a different value is selected, the selected limit in Runtime is displayed with a dotted line in the frame window.
  • Width: Width limitation.
  • Height. Height limitation.
  • Relative: Limitation to a percentage value of the set screen size.

Only has an effect on Multi-Touch gestures. The corresponding values are defined with the Value (minimum) property.

Default: Without

Opening size:

Defines the size with with which a screen based on this frame is called up in Runtime:

  • Frame size. Size as defined in Width (maximum) [pixels] and Height (maximum) [pixels].
    If a different value is selected, the size in Runtime is displayed with a dotted line in the frame window.
  • Width [px]. Width as defined in Value (Opening size), height is amended accordingly.
  • Height [px]. Size as defined in Value (Opening size), width is amended accordingly.
  • Relative [%]. The size defined in Width (maximum) [pixels] and Height (maximum) [pixels] is amended to the percentage value defined in Value (Opening size).

The corresponding values are defined with the Value (Opening size) property.

Default: Frame size

Moving and zooming

Frames can be moved and zoomed in Runtime.

Move

Moving always relates to the monitors defined in the monitor administration. These settings are not supported under Windows CE.

The moving of frames in Runtime can be limited to:

  • Frame border: The frame cannot be moved beyond the monitor limit.
  • Frame border area: The frame can be moved beyond the monitor limit. However there must be an area on the monitor (Minimum frame margin) that can be accessed for further actions.

The limit is only effective if the frame is already within the defined limit when it is opened. If the moving of a frame is not limited, it can - with Multi-Touch gestures for example - be moved beyond the visible area.

info Information

The moving of frames is most of all envisaged for full-screen operation. The Runtime application itself should not be moved to a different screen. If Runtime is moved, this can lead to limitations when moving.

Zoom

The limits also apply for zooming. If a limit is reached when zooming, an attempt is made to continue zooming in the free space. In doing so, the side ratio is retained.


Configurable lists

Manual -> Runtime -> Operating during Runtime -> Configurable lists

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A range of lists can be individually configured in Runtime:

  • Active Directory:
    • List in the Active Directory window (but not: tree)
  • AML
  • AML filter/CEL filter/time filter:
    • Lots: Archive selection
    • Lots: Lot selection
  • Batch:
    • List of master recipes
    • Control Recipes List
  • CEL
  • User list:
    • User list
  • Extended Trend:
    • Expanded curve list
  • Message Control:
    • Message queue
  • RGM:
    • Recipe list and recipe value table (but not: CE recipe value table)

The possible actions for these lists include the coloring of columns and the emphasis of the position with the focus.

Edit cells

You have the following possibilities for editing cells in the configurable list type lists:

  • Double click on the entry
  • Click in the cell, immediately followed by a second click (slow double click)

Depending on the screen type, there may also be a button available to activate editing.

Color columns

In configurable lists, the text color and background color of each column can be defined individually. To do this, configure the User-defined colors area in the screen switching function of the respective screen, in the Format columns tab.

Show focus

In configurable lists, the respective focus can be signalized by means of different text and background colors. The cell, column or line that is in focus is emphasized in bold. These colors are configured in the Selection colors for the object lists project properties in the Graphical design node.

Priorities

If several colors are applied on a list, the following priorities apply:

  1. General: Selection colors for the object lists
  2. RGM: Recipe value validation
  3. RGM: Online validation
  4. RGM: Interlocking
  5. List: Column color


Runtime files

Manual -> Runtime -> Runtime files

Definition of Runtime files, Runtime data, Runtime folder and data folder

Runtime files

Runtime files are files that are created by the editor that are read and interpreted by Runtime. Some Runtime files are modified by Runtime, for example:

  • Standard Recipes,
  • Recipegroup Manager etc.

The Runtime files are stored in the Runtime folder. This is defined in the Editor under General, in the properties window.

Runtime data

All data that is created and administered by Runtime, such as data from:

  • The alarm message list,
  • The chronological event list
  • The Historian etc.

This also includes data that is created by the Editor (Runtime files) and that can be amended by Runtime, such as data from:

  • Standard Recipes,
  • Recipegroup Manager,
  • User administration, etc.

The Runtime data is stored in the Runtime folder. This is defined in the Editor under General, in the properties window.

Runtime folder

The Runtime files of the project are saved in this folder. The path is entered into zenon6.ini when the start project is set. The Runtime folder can be amended in the project properties. In the Runtime folder, there is the subfolder RT and a subfolder with the name of the computer. In the RT folder, there are all Runtime files that are created by the Editor. In the Computer name folder, there are all data files that are created in Runtime.

Note: Ensure that there is sufficient memory where the Runtime data is, because there can be much data, due to archiving, AML, CEL etc.

Data folder

The Runtime saves all data files that were created at runtime like alarm files, archive files etc. in the data folder. The data folder is created as a subfolder of the Runtime folder by default. The folder is automatically assigned the name of the computer the Runtime is running on. This save location can be amended in the project properties (General/Data folder).

Hint: Never set the data folder to a removable device such as an USB stick or a network device. It is recommended that the data is recorded locally and backed up externally.


Compatibility Runtime files

Manual -> Runtime -> Runtime files -> Compatibility Runtime files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon Runtime is backward compatible. The Runtime can always load projects from older version and interpret and display these projects in accordance with their version.

Projects from version 6.20 SP4 on can be started directly without being converted first. Projects with a lower version number must be converted beforehand.

A mixed operation is also possible. This means: With the multi-project administration projects from different versions can be loaded and run at the same time.

Online compatibility

The Runtime online compatibility makes interoperability of Runtime systems (also via Web Clients) in the zenon network possible even if the version of the client Runtime is higher than the version of the server Runtime.

The current Runtime cam load projects of the following versions:

  • 6.20 SP4
  • 6.21 SP0
  • 6.21 SP1
  • 6.22 SP0
  • 6.22 SP1
  • 6.50 SP0
  • 6.51 SP0
  • 7.00 SP0
  • 7.10 SP0
  • 7.11 SP0

Due to the multi-project administration projects from different versions can be loaded. For example the Integration project can have version 7.11, a sub-project version 7.00 and another sub-project version 6.51. Mixed operation also works in the network. With this different versions can also be started with the zenon Web Client.

Note: If, from version 7.00 a different graphics quality to Windows Basic is set for a project (including the corresponding setting for the Create RT files for), Runtime up to zenon version 6.51 loads the Windows extended graphics quality. If the Windows basic graphics quality is set, this is retained.

Attention: Server and Standby Server must have the same version.

Note for Batch Control module: Runtime files for Batch Control up to and including version 7.00 SP0 are not compatible with subsequent versions. Versions from version 7.10 and later are compatible.

Compatibility between the Editor and Runtime:

With the zenon Editor, Runtime files can be created for different versions of Runtime. The Runtime version therefore does not need to correspond to the Editor version. This backward compatibility is particularly suited for use of mixed systems. For example: A project that was planned with Editor 6.50 can also be started with Runtime 6.22.

attention Attention

If, in a project with a later version of the Editor, properties are shown that are not available in the earlier version, these are not available. This can lead to unwanted results in Runtime.

Creating Runtime files

To create Runtime files in the editor for earlier versions:

  1. Select the project in the project tree
  2. Navigate to the General section in project properties
  3. Open the Create RT files for property drop-down list
  4. Select the desired version:
    • Default: The Runtime files are created for the current version of the editor
    • 6.20 SP4: The Runtime files are created for version 6.20 Service Pack 4.
    • 6.21 SP0: The Runtime files are created for version 6.21 Service Pack 0.
    • 6.21 SP1: The Runtime files are created for version 6.21 Service Pack 1.
    • 6.22 SP0: The Runtime files are created for version 6.22 Service Pack 0.
    • 6.22 SP1: The Runtime files are created for version 6.22 Service Pack 1.
    • 6.50 SP0: The Runtime files are created for version 6.50 Service Pack 0.
    • 6.51 SP0: The Runtime files are created for version 6.51 Service Pack 0.
    • 7.00 SP0: The Runtime files are created for version 7.00 Service Pack 0.

Attention: In order to ensure consistency of Runtime files, all Runtime files must be newly created each time this property is changed. The configurations for all drivers are converted. Settings that do not exist in the respective version are set to the default setting.


Runtime profiles

Manual -> Runtime -> Runtime profiles

A Runtime profile is a reproducible optical snapshot of the screen in the Runtime including information about:

  • Screen pattern (succession and position)
  • Monitor allocation
  • Filter

Runtime profiles are project- and user-related.

The following screen types support Runtime profiles:

  • Alarm Message List
  • Archive revision
  • Chronological Event List
  • Extended Trend
  • Industrial Maintenance Manager
  • Industrial Performance Analyzer
  • Report Viewer
  • Message Control
  • Variable diagnosis

Every zenon user has an own folder in which he can administrate his profiles. Administrators can see and edit all profiles of all users and copy them to user System. From user account System all users can load Runtime profiles. It serves as an exchange account for Runtime profiles.

Note: Only administrators an copy to and manage profiles in user account System. All other users can only manage their own profiles and load the profiles of user System.

Predefined profiles

Besides the individual profiles there are two pre-defined Runtime profiles:

  • DEFAULT: created by the user and selected as standard profile
  • LAST: is automatically saved to the folder of the user when he logs out
    Exception: Profile LAST is not saved:
    • for user System
    • a temporary login without writting permission

To each zenon user a start profile can be allocated during log in.

attention Attention

Profiles can only be saved correctly at the Server if all projects are available at the Server:

  • from which screens are called up at the Client
  • which call up screens with a screen switch function

Saving Runtime profiles which do not match these conditions can lead to errors in the Runtime.


Load and create profile in the Runtime

Manual -> Runtime -> Runtime profiles -> Load and create profile in the Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to create a profile in the Runtime you must engineer a respective function:

  • Save profile: saves the current profile as it was defined in the function
  • Profile administration: opens the administration of the profiles for saving, loading, allocating and administrating profiles

In addition already existing profiles can be activated in the Runtime:

  • Load profile

When loading a profile, the same state as when the profile was saved is restored. The screen structure including all filters as it was when the profile was saved is restored.

Attention: If there are screen switch functions defined at the properties of a screen for functions Start function or End function - such as (Screen switch, Index screen or Screen back ), they are not carried out! All other function types are carried out again.

If a script is called up in the two functions, the complete script and all screen switching functions therein are executed. Therefore it can happen that the screen structure after loading the profile does not match the screen structure when saving the profile.

A similar behavior displays variable Screen active variable: If a limit which contains a screen switch function is carried out in the variable, the function is carried out and may affect the display in an undesired way.


Configuring functions

Manual -> Runtime -> Runtime profiles -> Configuring functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to load, save and administrate profiles in the Runtime, you engineer a function in the Editor and assigned it to a button:

  • select New Function
  • navigate to node Screens
  • select Runtime profiles

  • the dialog for configuring functions is opened

Property | Action
Open administration dialog in the Runtime | Opens the dialog for administrating, creating, saving and loading profiles in the Runtime.
Load profile | Loads the profile defined in the dialog in the Runtime:
Default | Loads the profile DEFAULT. It was selected as the standard profile by the user from all existing profiles.
Last | Loads the profile LAST. It was automatically written to the folder of the user at log out.
Freely defined name | Loads the profile with the name which was defined in the dialog. If the profile does not exist, the current profile is kept.
Name from variable | Loads the profile whose name was generated from the defined variable.
Save profile | Saves the profile which was defined in the dialog.
Default | Saves the current profile as DEFAULT.
Freely defined name | Saves the profile with the name which was defined in the dialog.
Name from variable | Saves the profile under the name which was created from the variable defined in the dialog.


Allocate and administrate profile

Manual -> Runtime -> Runtime profiles -> Allocate and administrate profile

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Profiles can be allocated in the Editor and in the Runtime. In the Runtime you can create and save them.

In the editor

Users are assigned Runtime profiles in the Editor:

  • in the dialog for creating a new user with the property Runtime profile which is loaded after log in:

  • Via the property Runtime profile of a user:

  • In the drop-down list the following settings are available:
    • None: No profile is allocated (default setting)
    • DEFAULT: Profile DEFAULT is allocated
    • LAST: Profile LAST is allocated

In the Runtime

In the Runtime you can save, load, allocate and administrate profiles with the help of the profile administration. For this you must engineer function Runtime profiles with property Open administration dialog in the Runtime.

Note: Administrators can administrate the profiles of other users.

Property | Action
Logged in user | User who is currently logged in to the system.
User whose profiles are administrated | User whose profiles are displayed and can be administrated.
Profiles | List of the available profile.
Profile name | Name of the profile.
Last modified | Date and time of the last modification.
Rename | Opens the selected profile name in order to rename it.
Delete | Deletes the selected profile after a confirmation message.
Copy | Copies the selected profile to the user System. At this the name can be changed. Hint: Profiles at user System are available for all users which are not logged in.
Save profile | Opens the dialog for assigning a profile name and saving the profile under this name. The following characters are forbidden: Space and the special characters / | \ : * ? ! " < > $
Load profile | Loads the selected profile.
Close | Closes the dialog.

Keyboard shortcuts

Key | Action
F5 | Updates the profiles' list. At unexpected events in the zenon network such as the loss of server or standby the contents of the list are automatically updated.
Esc | Closes the dialog.
Enter | Loads the selected profile.
Ins | Saves the current state of the new profile.
F2 | Makes it possible to change the name of the selected profile.
Del | Deletes the selected profile after a confirmation message.


Storage directories of the profiles

Manual -> Runtime -> Runtime profiles -> Storage directories of the profiles

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The profile data are stored differently depending on their use in the Runtime:

Type of Runtime | Storage directory
Server or standalone: | Data are stored locally.
Client | Data are stored on the server and are requested and changed interactively.
Standby | Data are stored on the server and are requested and changed interactively and are synchronized locally.


Filter profiles

Manual -> Runtime -> Filter profiles

Filter profiles are filter settings that the user can save and call up in Runtime in relation to a certain screen.

To be able to use filter profiles, the following control elements must be configured:

Control element | Description
Filter profiles | Profile administration in Runtime.
Profile selection | Selection of a saved profile in Runtime from a drop-down list.
Save | Clicking on the button in Runtime saves the filter settings as a profile.
Delete | Clicking on the (X) button in Runtime deletes the selected profile.

With this you can in the Runtime:

  • save filters
  • use saved filters
  • delete filter profiles
  • Filter profiles can also be exported and imported with further control elements.

Save filter profile

To create a filter profile:

  1. define filter conditions in the Runtime
  2. assign a name using property filter profiles
  3. Click on Save

Use filter profile

To use a filter profile:

  1. select a filter from the drop-down list property filter profiles
  2. the filter is immediately applied

Delete filter profile

To delete a filter profile:

  1. select a filter from the drop-down list property filter profiles
  2. click on button X
  3. the profile is deleted
  4. the deleted filter is still applied as long as a new filter is defined or selected


Export and import filter profiles

Manual -> Runtime -> Filter profiles -> Export and import filter profiles

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can transfer filter profiles to other projects and other computers with the control elements for import and export.

To export profiles:

  1. create the control elements for import and export in the screen:
    Control elements -> Filter profiles -> Import or Export
  2. start the Runtime
  3. open the screen
  4. create the desired profiles
  5. save the profiles
  6. export the profiles:
    these are saved in an XML file and can be imported at the same screen type in another project

To import profiles:

  1. save the XML file with the desired profiles at the Runtime computer if it is another computer as the export computer
  2. start the Runtime
  3. open the screen
  4. import the profiles

info Information

At the import all existing profiles are deleted. The profile active at the time is not changed.

XML files can only be imported in the screen type in which they were created. If you try to import profiles of other screen types, the import is canceled and an error message is displayed.


Handling of date and time

Manual -> Runtime -> Handling of date and time

Date and time in zenon are either local time, UTC time or time periods. The basic principle is that:

  • all times "from - to" in filter such as screen switch to AML or CEL are saved in UTC
  • Times in modules such as PFS and Load Management are made in local time
  • Time periods are in seconds

Exceptions:

  • the IPA writes historic data in local time as "datetime" in the database
  • Read time from variable or write to variable does not save times but takes over the local time formatted as string from the control or writes it to the control

UTC

UTC means Coordinated Universal Time. The time unit is second. UTC is the uniform basis for the international time determination and is made available to the public via time senders and other time services. Dependent on the time zone certain time periods must be added or subtracted to or from UTC. This time period can vary one hour because of the day light saving time.
Example:

Country | Local time
Alaska | UTC -9
Australia, Queensland | UTC +10
Bulgaria | UTC +2
United Kingdom | UTC
Korea | UTC +9
Central Europe (CET) | UTC +1
Central Europe (CET) Day Light Saving Time | UTC +2
Saudi Arabia | UTC +3
USA East coast | UTC -5
United Arabic Emirates | UTC +4

Consequences to the configuration

Engineered date and time mean different date and time depending on the execution location of the Runtime.

For example: In the Editor you engineer in the PFS for the execution of a function in time zone UTC +1 the local time 14:00 o' clock. After transferring the files to a Runtime in tiem zone UTC +10, the function is carried out at 23:00 o' clock.

Switching of time zone

If the time zone is switched in the operating system, this change is automatically applied in zenon Runtime.


Switch to daylight saving time

Manual -> Runtime -> Handling of date and time -> Switch to daylight saving time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following is applicable for the switch to daylight saving time/standard time:

  • You must use the automatic Windows time amendment of the computer.
  • Do not switch the time manually!

    Manual changes can cause problems with relevant times indicated for zenon, for example for save times of archives, time control, etc.

You configure the action of the Scheduler and Production & Facility Scheduler for time switching in the settings of this module:

  • Scheduler time switching
  • Production & Facility Scheduler time switching


Alarms administration

Manual -> Alarms administration

Alarm administration informs you of faults that occur such as limits being exceeded. It comprises:

  1. Alarm status line:
    Information line that is always shown in the foreground in Runtime and contains, depending on the configuration, the most recent or oldest unacknowledged alarms.
  2. Alarm Message List (AML):
    Administers the alarms in a list in Runtime. The AML:
    • Displays alarms and their causes in an unfiltered or filtered list
    • Enables localization of the cause of the alarm
    • Enables acknowledgment of alarms
    • Enables deletion of alarms.
    • Enables printing and saving of alarms

Configure alarms by means of:

  • Setting limits for variables
  • With reaction matrices
  • Properties of the alarms

tutorial License information

Part of the standard license of the Editor and Runtime.


Configuring alarms

Manual -> Alarms administration -> Configuring alarms

Alarm administration is operated in Runtime using alarm message list screens and alarm message list filters as well as the alarm status line. The alarm status line is automatically created as a template.

Editor

To be able to use alarms in Runtime, the following must be carried out in the Editor:

  • A screen of alarm message list type can be configured
  • Limit breaches of variables or reaction matrixes are defined

In addition you can:

  • Configure alarms using filters
  • Grouping alarms
  • Adapt the screens of alarm message list type that are available in Runtime

Runtime

For the operation in the Runtime the following is used:

  • AML screen switching
  • AML filter screen switching
  • The zenon alarm functions
  • Using Alarm Message List screens
  • Alarm status line


Creating an Alarm Message List screen

Manual -> Alarms administration -> Configuring alarms -> Creating an Alarm Message List screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

An Alarm Message List screen makes it possible to display and log current and past alarms. The display can be changed using a filter. Functions make it possible to export and print the displayed alarms.

Creating an Alarm Message List filter screen

To create an Alarm Message List screen:

  1. Select, in the toolbar or in the context menu of the Screens node, the New Screen command
  2. An standard empty screen is opened
  3. Change the screen type in the detail view; to do this:
    1. click on Standard in the Screen type column
    2. Select Alarm Message List from the drop down list
  4. Click in the screen.
  5. Select the Control elements menu item in the menu bar
  6. Click on Add template in the drop-down list
  7. The standard elements are inserted
  8. Select additional elements as required and insert them into the desired place on the screen
  9. Create a screen switch function, in order to be able to call up the AML in Runtime


Control elements

Manual -> Alarms administration -> Configuring alarms -> Creating an Alarm Message List screen -> Control elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Insert template

Parameters | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.

Control elements

Control element

Description

Window

Display in Runtime
  • Alarm Message List

Display of the alarms. The appearance is configurable. Columns are defined via the Column settings filter in screen switching or via the Column settings AML property in the Alarm Message List group.
  • Set filter

Display of the currently-selected filter conditions.
  • Status

Display if Alarm Message List is active or not (Project property Alarm Message List active).
  • Total number

Time number of all alarms.
  • Number of unacknowledged

Displays number of unacknowledged alarms.

List functions

Buttons to control the lists.
  • Filter

Opens dialogs for filter selection.
  • Stop/Continue

Switch for filling the list:

Stop: New elements are no longer added automatically.

Next: New elements are added automatically.

Attention: The font of the button can be changed in the editor but is not carried over to Runtime. You can configure changes to the font using Language switching. Deletes alarm from the Alarm Message List in Runtime. Alarm must already be acknowledged.
  • Print

Prints filtered list.
  • Print with dialog

Opens printer settings before printing.

Alarm functions

Buttons for acknowledging and deleting alarms.
  • Acknowledge

Acknowledging alarm messages in Runtime.
  • Acknowledging page

All alarms displayed on the current page are acknowledged.
  • Acknowl. All

All alarms for the current filter criteria are acknowledged

Note for multi-user project: Alarms are only acknowledged for projects for which the user has authorizations. (for details on multi-user projects, see Distributed engineering chapter)

  • Visual acknowledgment

The selected alarms are visually acknowledged.

  • Visual acknowledgment and acknowledgment

The selected alarms are first visually acknowledged and then acknowledged.

  • Delete

Deletes alarm from the Alarm Message List in Runtime. Alarm must already be acknowledged.
  • Delete page

Deletes all acknowledged alarms that are displayed on the current page.
  • Delete all

Deletes all acknowledged alarms that correspond to the current filter criteria.

  • Close frame

Closes Alarm Message List
  • Linked function (display)

Displays the message allocated to the alarm message.
  • Execute function

Executes the functions configured for the alarm in Runtime.

Note: With the Start program function, the variable name of the selected alarm can be transferred as a parameter for the program to be started using the key word @alarm.name.
  • Open Help

Calls up configured Help.
  • Display

Status and elements of alarm administration.
  • Comment field

Input of free text (comment) by the user for the selected alarm. This text can be displayed in the list (Comment option in the Column settings of alarm administration.)

Navigation

Controls elements of the list.
  • Line up

Scrolls one line up.
  • Line down

Scrolls one line down.
  • Column right

Scrolls one column to the right.
  • Column left

Scrolls one column to the left.
  • Page up

Scrolls one page up.
  • Page down

Scrolls one page down.
  • Page right

Scrolls one page to the right.
  • Page left

Scrolls one page to the left.

Filter profiles

Buttons for filter settings in Runtime.

  • Profile selection

Select profile from list.
  • Save

Saves current setting as a profile.
  • Delete

Deletes selected profile.
  • Import

Imports filter profiles from export file.
  • Export

Exports filter profiles in the file.

info Information

The current filter is displayed with the Show filter control element.

With a:

  • Text filter, the expression [Txt] is displayed
  • Relative time filter: is displayed as a print-out with the following scheme:
    [T,Rel:%dd,%dh,%dm;%ds]
    Example: [T,Rel:1d,0h,0m,0s] equals one day.


Changing the appearance of the AML

Manual -> Alarms administration -> Configuring alarms -> Creating an Alarm Message List screen -> Changing the appearance of the AML

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The table view of the Alarm Message List can be adapted to individual requirements:

Scroll bars, headers and grids

To define the size and appearance of scroll bars, the header or grids for the the report:

  1. Activate, in the Representation group, the Extended graphical settings property
  2. Define the desired properties in the groups Scroll bars and Header and grid for the Alarm Message List screen element

info Information

If the Graphics file property is selected for the Display style property, then all elements for which no graphics file has been selected are shown with a color gradient. Transparent graphics cannot be used for control elements for lists.

Sorting in Runtime

To mark the relevant column for sorting in Runtime and to determine the sorting sequence, configure the graphic element for the title line:

  1. Select the Graphics files for the Display style property
  2. Link the Sort ascending and Sort descending properties with a graphics file
  3. The selected graphic for the respective sorting direction is displayed in Runtime for the sorting of relevant columns
  4. Clicking on the graphic changes the sorting sequence
  5. Clicking on the column title activates the column for sorting

Operating the header in Runtime

You can make it possible for users to operate the header in Runtime. With this an individual customization of the look is possible in the Runtime:

  • Moving columns
  • Change size
  • Changing sorting.

To do this, navigate to Alarm Message List group in the settings and select, in the Header AML property, Operable headers. Alternatively, you can also switch the header to inoperable or invisible here.

These settings apply for all headers in the project.

info Information

You can prohibit the manipulation and/or the visibility of the header for each screen Alarm Message List by deactivating the property Show header or Make header editable for the tabular view.

Preview

By activating the Extended graphical settings property in the Editor, the header and scroll bars can be previewed. This way, details such as color fill effects, light effects or grids can be configured more easily.

Attention: As the size of the scroll bars equals their size in the Runtime, the total size of the list in the Editor can vary from the size in the Runtime. This is also true for the size of the header and the font of the header.


Creating an Alarm Message List filter screen

Manual -> Alarms administration -> Configuring alarms -> Creating an Alarm Message List filter screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

It is possible to adjust filter settings for the Alarm Message List in Runtime with the help of the Alarm Message List Filter screen. Only the filter elements that are actually required are configured and provided to the user The appearance can also be freely defined and thus adapted to different end devices. All filter settings that are available in the filter for the function to switch the screen to the Chronological Event List screen can be configured.

Therefore:

  • Only the filter elements that are actually required are configured and provided to the user
  • The user only has these filters displayed and has an overview
  • The appearance can be freely defined and can, for example, ensure ease of use by means of a touch screen.

For details of use in Runtime, see Using the Alarm Message List Filter chapter.

For the definition of filter criteria, see Filter Alarm Message List Filter chapter.

attention Attention

Screens of type Alarm Message List Filter, Chronological Event List Filter and Time Filter must be engineered with an own frame. If they use the same frame as other screens, all screens based on this frame are closed when the screen is closed.

Creating an Alarm Message List filter screen

To create an Alarm Message List filter screen:

  1. in the toolbar or in the context menu of node Screens select entry New screen
  2. an empty screen of type Standard is opened
  3. Change the screen type in the detail view.
    To do this:
    1. click on Standard in the Screen type column
    2. Select Alarm Message List filter from the drop down list
  4. Select your own frame
    (AML filter cannot be based on the same template as other screens)
  5. Click in the screen.
  6. Select the Control elements menu item in the menu bar
  7. Click on Add template in the drop-down list
  8. The dialog for selecting a template is opened.
  9. Select the desired template.
  10. Select additional elements as required and insert them into the desired place on the screen
  11. Name the screen according to the selected filter.
    To do this:
    1. Click on the screen name in the detail view in the name column
    2. Select a suitable pre-defined name from the drop-down list it give it a name of your own
  12. Create a screen switch function in order to be able to call up the screen in Runtime


Control elements

Manual -> Alarms administration -> Configuring alarms -> Creating an Alarm Message List filter screen -> Control elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Alarm Message filter screen can contain the following control and display elements.

Element

Description

Insert template

Opens the dialog for selecting a template for the screen type.

Templates are shipped together with zenon and can also be created by the user.

Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.

You can read more about templates for this screen type in the Templates chapter.

General filters

Drop-down list of different general filters.

Insert all elements: General filters

Inserts all elements from the area of general filters into pre-defined places. Elements can be arranged individually.

Insert all elements: General filter (Touch)

Inserts all elements from the area of general filters into pre-defined places. Elements can be arranged individually. The elements were optimized for touch operation.

Variable filter

Alarms of which variables are displayed:
  • Variable name

Filter according to names of variables.
  • Identification

Filter according to identification of variables.
  • Case sensitive

Note capitalization when filtering the variables.

Type of alarms

Which alarms are displayed:
  • Only not acknowledged alarms

Only unacknowledged
  • Only cleared alarms

Only historical
  • Only current alarms

Only current
  • Comment required

Alarms that require a comment when acknowledged
  • Minimum time alarms active - days

Only alarms that have been current for at least the given number of days.
  • Minimum time alarms active - hours

Only alarms that have been current for at least the given number of hours.
  • Minimum time alarms active - minutes

Only alarms that have been current for at least the given number of minutes.
  • Minimum time alarms active - seconds

Only alarms that have been current for at least the given number of seconds.
  • Minimum time alarms active - milliseconds

Only alarms that have been current for at least the given number of milliseconds.

Type of alarms (Touch)

Elements optimized for touch operation for the display of alarm type, along the lines of the Alarm type menu.

  • Only not acknowledged alarms
  • Only cleared alarms
  • Only current alarms
  • Comment required
  • Minimum time active alarms - Button: Days (up)
  • Minimum time active alarms - Touch box: Days
  • Minimum time active alarms - Button: Days (down)
  • Minimum time active alarms - Button: Hours (up)
  • Minimum time active alarms - Touch box: Hours
  • Minimum time active alarms - Button: Hours (down)
  • Minimum time active alarms - Button: Minutes (up)
  • Minimum time active alarms - Touch box: Minutes
  • Minimum time active alarms - Button: Minutes (down)
  • Minimum time active alarms - Button: Seconds (up)
  • Minimum time active alarms - Touch box: Seconds
  • Minimum time active alarms - Button: Seconds (down)
  • Minimum time active alarms - Button: Milliseconds (up)
  • Minimum time active alarms - Touch box: Milliseconds
  • Minimum time active alarms - Button: Milliseconds (down)

Origin of the data

Where does the data come from:
  • Ringbuffer

From the ring buffer.
  • Historical data

From an archive.
  • Text: Max. number:

Text for Maximum number input field

  • Input field: Max. number:

Input of the maximum alarms to be displayed when historical alarms are displayed.

0: displays all

Alarm/event groups/alarm/event classes/alarm areas

List field for grouped display:
  • Alarm/event groups

Alarm/event groups
  • Alarm/event classes

Alarm/event classes
  • Alarm areas

Alarm areas

Time filter

Selection of different time filters.

Insert all elements

Opens drop-down list to select pre-defined elements for certain time periods.

Absolute period of time: classic display

Elements for the absolute time period in classic display.

Absolute period of time: compact display

Elements for the absolute time period in compact display.

Relative period of time

Elements for the relative time period.

Starting from HH:MM:SS

Elements for a time period from a defined time.

Starting from day - HH:MM:SS

Elements for a time period from a defined day at a defined time.

Starting from day, month - HH:MM:SS

Elements for a time period from a defined day in a defined month at a defined time.

Time period: 15/30/60 minutes

Elements for a time period of 15, 30 or 60 minutes.

Time period: one day

Elements for a time period of one day.

Time period: 1 or 2 weeks

Elements for a time period over one or two weeks.

Each week can be selected, both for the view for a week as as well as for the view for two weeks. With the two-week view, a time period of 14 days is selected, depending on the week selected.

Time period: one month

Elements for a time period of one month.

Time period: one year

Elements for a time period of one year.

Insert all elements (Touch)

Opens the drop-down list to select pre-defined elements for certain time periods, which have been optimized for touch operation. Like Insert all elements, the following are available:

  • Absolute period of time: classic display
  • Relative period of time
  • Starting from HH:MM:SS
  • Starting from day - HH:MM:SS
  • Starting from day, month - HH:MM:SS
  • Time period: 15/30/60 minutes
  • Time period: one day
  • Time period: 1 or 2 weeks
  • Time period: one month
  • Time period: one year

Time filter type (label)

Labeling for time filter type.

Time filter type (combobox)

Combobox: Time filter type

Time filter type (display)

Field for time filter type display.

Time filter type (radio group)

Radio buttons that show or hide certain elements in Runtime:

  • No filter
  • Absolute time filter
  • Relative time filter
  • Starting from HH:MM:SS
  • Starting from day - HH:MM:SS
  • Starting from day, month - HH:MM:SS
  • Time period 15 minutes
  • Time period 30 minutes
  • Time period 60 minutes
  • Time period 1 day
  • Time period 1 week
  • Time period 2 weeks
  • Time period 1 month
  • Time period 1 year

Time from

Fields and labeling for stating "from" time.

  • From year (label)
  • From year (combobox)
  • From month (label)
  • From month (combobox)
  • From day (label)
  • From day (combobox)
  • From hour (label)
  • From hour (combobox)
  • From minute (label)
  • From minute (combobox)
  • From second (label)
  • From second (combobox)
  • From (spin control)

Time to

Fields and labeling for stating "to" time.

  • To year (label)
  • To year (combobox)
  • To month (label)
  • To month (combobox)
  • To day (label)
  • To day (combobox)
  • To hour (label)
  • To hour (combobox)
  • To minute (label)
  • To minute (combobox)
  • To second (label)
  • To second (combobox)
  • To (spin control)

Time from (Touch)

Fields and labeling for stating "from" time, optimized for touch operation.

  • From year (label)
  • From year (combobox)
  • From month (label)
  • From month (combobox)
  • From day (label)
  • From day (combobox)
  • From hour (label)
  • From hour (combobox)
  • From minute (label)
  • From minute (combobox)
  • From second (label)
  • From second (combobox)
  • From (spin control)

Time to (Touch)

Fields and labeling for stating "to" time, optimized for touch operation.

  • To year (label)
  • To year (combobox)
  • To month (label)
  • To month (combobox)
  • To day (label)
  • To day (combobox)
  • To hour (label)
  • To hour (combobox)
  • To minute (label)
  • To minute (combobox)
  • To second (label)
  • To second (combobox)
  • To (spin control)

Filter absolute time

Fields and labeling for stating absolute time filter.

  • From (label)
  • From date (calendar display)
  • From date (date display)
  • From time (time display)
  • To (label)
  • To date (calendar display)
  • To date (date display)
  • To time (time display)

Time period

Fields and labeling for stating time periods.

  • From year (label)
  • From year (combobox)
  • From month (label)
  • From month (combobox)
  • Week (label)
  • Week (combobox)
  • From day (label)
  • From day (combobox)
  • Start time (label)
  • Start time (combobox)

Time period (Touch)

Fields and labeling for stating "from" time, optimized for touch operation.

  • From year (label)
  • From year (up)
  • From year (touchbox)
  • From year (down)
  • From month (label)
  • From month (up)
  • From month (touchbox)
  • From month (down)
  • Week (label)
  • Week (up)
  • Week (touchbox)
  • Week (down)
  • From day (label)
  • From day (up)
  • From day (touchbox)
  • Button: From day (down)
  • Start time (label)
  • Start time (up)
  • Start time (touchbox)
  • Start time button (down)

Lots

Elements for lot selection in Runtime.

Archive list

List of archives available in Runtime.

Archive list status

Status of the archive list with number for:

  • available
  • filtered
  • displayed

Lot list

List of available lots.

Lot list status

Status of the lot list with number for:

  • available
  • filtered
  • displayed

Apply time filter to lot list.

Applies the configured time filter to the selection in the lot list.

Lot name filter (Input field)

Entry of a character sequence for filtering the lot names in the lot list.

Lot name filter (Button)

Button to execute filtering for lot names.

Text filter

Drop-down list of different text filters.

Insert all elements: Text filter

Inserts all elements for text filters.

No text filter

Radio button to deselect text filter.

Search for (separate words by Space)

Radio button to activate the search

Text: Search text

Labeling for search field.

Input field: Search text

Field for input of search term.

Options

Search options
  • Case sensitive

Capitalization must be noted.
  • Words do not need to be in the text completely

Fragments can also be searched for.
  • At least one word must be in the text

At least one search term from several must be in the result.
  • All words must be in the text

All search terms must be included in the result.
  • Exact filter text must be in the text

Exact text from the input field must be contained in the result.

Show list without refresh

Switches the AML in stopped state. New alarms are not added.

OK | Button: Applies the filter settings and closes the screen. Note on faceplates: In faceplates, AML filter, CEL filter and time/lot filter screens can be used. When configuring these in Runtime, clicking on OK closes the complete faceplate. If the filter settings are to be saved and the faceplate is to stay open, click on Accept.
Cancel | Button: Cancels the configuration of the filter settings.
Apply | Button: Accepts the filter settings.
Refresh search | Button: Updates the filtered display.


Template

Manual -> Alarms administration -> Configuring alarms -> Creating an Alarm Message List filter screen -> Template

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Template | Description
List field templates (left) | Displays all pre-defined and user-defined template.
Preview and description (right) | Shows preview and description of the selected template.
Standard | Inserts standard elements.
Scada | Special templates, optimized for mouse operation.
Only variable & text filter | Adds elements for filtering for variables and text.
Without alarm groups | Adds elements for filtering for variables, text and pending minimum time without alarm groups.
Standard | Inserts standard elements.
Filters for variables, text & time | Adds elements for filtering for variables, text and time.
Filters for variables, text & time (from month) | Adds variables for filtering for variables, text and relative time range from month.
Filters for variables, text & time (from hour) | Adds variables for filtering for variables, text and relative time range from hour.
Filters for variables, text & time (from day) | Adds variables for filtering for variables, text and relative time range from day.
Filters for variables, text & time (absolute - table) | Adds elements for filtering for variables, text and absolute time range.
Filters for variables, text & time (absolute - compact) | Adds elements for filtering for variables, text and absolute time range in compact form.
Filters for variables, text & time (absolute) | Adds elements for filtering for variables, text and absolute time range.

Close dialog

Parameters | Description
Delete existing screen elements | Active: Already existing elements in the screen are deleted when taking over the template.
Apply | Inserts the elements of the selected template in the screen and closes the dialog.
Cancel | Closes dialog without inserting elements.
Help | Opens online help.


Pre-defined names

Manual -> Alarms administration -> Configuring alarms -> Creating an Alarm Message List filter screen -> Pre-defined names

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Pre-defined names are available for time filters.

Attention: The pre-defined names are not available under Windows CE.

To select a name:

  1. In the detail view, define as a time filter, chronological event list filter or alarm message list filter
  2. Click twice in the name field in the 'Name' column
  3. Select the desired pre-defined name from the drop-down.
    • AML_Filter
    • TIMEFILTER_ABSOLUTE
    • TIMEFILTER_DAY
    • TIMEFILTER_HOUR
    • TIMEFILTER_MONTH
    • TIMEFILTER_PERIOD
    • TIMEFILTER_PERIOD_DAY
    • TIMEFILTER_PERIOD_MINUTE
    • TIMEFILTER_PERIOD_MONTH
    • TIMEFILTER_PERIOD_WEEK
    • TIMEFILTER_PERIOD_YEAR
    • TIMEFILTER_RELATIVE


Filter screens

Manual -> Alarms administration -> Configuring alarms -> Creating an Alarm Message List filter screen -> Filter screens

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Filter screens

Filter screens make it possible to transfer a preset filter from one screen to another. The filter of the source screen is set using the target screen. The screens can also be of a different screen type.

attention Attention

In order for the time to be taken from the screen to be called up in Runtime, the following time range must be selected in the Editor for the screen switching function for the Alarm Message List or the Chronological Event List in the time filter: Set filter at time filter type

Call definition

The following requirements must be met for the set filters to be used:

  1. Set filter for time filter type is selected as a time period for the time filter.
  2. The screen (Alarm Message List Filter, Chronological Event List filter or Time/Lot Filter screen) is activated using a button or a combined element. Only in this way can the relationship between filter screen and source screen be maintained.
  3. The source screen and filter screen must be configured on different frames or monitors. The filter for the filter screen can only be updated if the source screen is open. This is only possible if both screens do not use the same frame or the same monitor.
  4. The screen to be called up must be compatible with the filter screen to be called up (see table).
Source screen | AML filter | CEL filter | Time filter
Archive revision | T | T | T
Extended Trend | T | T | T
Time filter | T | T | X
Alarm Message List Filter | X | C | T
Chronological Event List Filter | C | X | T
Alarm Message List | X | C | T
Chronological Event List | C | X | T

Key:

  • C: Common settings are updated.
  • T: Time settings are updated.
  • X: All settings are updated.

info Information

No filtering

The filter screen is not filtered, but opened with the configured values, if:

  • One of the conditions 1 to 3 is not met or
  • The Screen to call up setting is not activated for the Screen switching function or
  • The screen is not called up via a screen element

In this case, the Accept, Close and Update buttons are grayed out in Runtime and have no function.


Defining alarms

Manual -> Alarms administration -> Configuring alarms -> Defining alarms

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Define alarms using:

  • Limit values and statuses with variables
  • Reaction matrixes

Alarming using variables

Define the limits for variables (see Variables manual, Limits chapter). If these are breached in Runtime, an alarm is generated and displayed in the alarm status line. You configure further properties for alarm configuration with:

  • Variable properties of the group Limits and the subgroups for each limit value contained therein:
    • In Alarm Message List: The alarm is incorporated into the AML. When it is there as displayed, control it in Runtime using the alarm message list or an alarm message list filter.
    • To acknowledge: The alarm must be acknowledged before it is removed from the ring buffer.
    • To delete: the alarm must be deleted manually before it is removed from the ring buffer.
    • Print: Prints alarm to defined printer. Either the CEL or the AML is printed. You define which of the two lists is printed in project properties under Printing for.
    • Alarm/event group: allocation of an alarm/event group.
    • Alarm/event class: allocation of an alarm/event class.
  • Variable properties of the group Alarm handling:
    • Alarmbereiche: allocation of an alarm area.
    • Acknowledgement variable: Sets the value 0 or 1 for the variables defined here when an alarm is acknowledged.
    • Acknowledgement value: Value that is written to the variable defined in Acknowledgement variable.
    • Save in IPA database: Alarm is available in the Industrial Performance Analyzer for evaluation.
  • Project properties of the group AML and CEL:
    • Selection with border: selected lines are emphasized by a frame in Runtime.
    • Same comments: comments that are entered in Runtime for an alarm are also accepted in the CEL.
    • Printing active: activates online printing.
    • Printing for: defines if AML or CEL is printed online.
  • Project properties of the group Alarm Message List

    There are many properties to configure alarms available here. Above all:

    • AML activation
    • Data storage AML
    • Signalization of alarm states
    • Activation of alarm status line

    You can find details of the individual settings in the embedded help pages.

Alarming via reaction matrixes

You use a reaction matrix to evaluate limit states and status bits (see Variables manual, Reaction matrixes). Breaches of the established rules lead to an alarm. As with variables, you can also define the action to be carried out when an alarm is raised with reaction matrixes. To do this, activate the corresponding properties in the configuration dialog of the reaction matrixes.


Alarm handling

Manual -> Alarms administration -> Configuring alarms -> Alarm handling

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Alarms are saved in a ring buffer (alarm.bin) and in an alarm file (*.aml) in the Runtime folder as soon as they occur.

Ring buffer

The ring buffer includes all active alarms. At this the following things are managed:

  • Time received in millisecond as unique signature
  • additional information such as cause, value, etc.
  • Time cleared
  • Time acknowledged

When acknowledging alarms, all alarms of a variable with the same limit violation are deleted at the same time from the ring buffer.

As soon as the alarm is acknowledged, it is deleted from the ring buffer. Exception: If property To delete is set, the alarm must be deleted by the user decidedly.

Size of the ringbuffer

The size of the ring buffer must be set to an appropriated size in the project properties via property Size of the ringbuffer.
Recommended: At least number of variables for which alarms can occur.

The ring buffer is automatically saved as file alarm.bin when the Runtime is closed. If the Runtime is closed due to an unexpected event, e.g. power outage, data will be lost. To prevent this the ring buffer can be saved manually via property Save ringbuffer on change at every new entry or via function Save AML and CEL ring buffer.

Attention: In the Runtime the ring buffer is handled dynamically in the memory. Via the defined number of alarms, even alarms which do not have a cleared time stamp can be displayed. Thus alarms are displayed which exceed the size of the ring buffer.

Example Example
  • Size of the ring buffer: 100 entries
  • Active alarms in the Runtime without cleared time stamp: 120
  • Display in the AML in the Runtime: 120

Alarm file

All alarms are written in an alarm file (*.aml) at the same time as in the ring buffer. This file is created for every calendar day automatically and is managed via property Save AML data. The name of the alarm file is put together by the letter A, followed by the date in form JJMMDD and the suffix .aml; e.g. A100623.aml. These files are created automatically for every day and must be evecuated or deleted by the user if the storage space is limited. *.aml files are saved in the ...\Projektordner\Computername\Projektname folder.

Synchronizing ring buffer and alarm file

Ring buffer and alarm file are synchronized. This synchronization ensues from the ring buffer to the alarm file. All changes such as acknowledging are only carried out in the ring buffer and are then synchronized with the alarm file. Thus for example all unacknowledged alarms can be displayed in the alarm file and the acknowledge can be induced. The action however is taking place in the ring buffer.

Saving periods

The alarm file *.aml is saved each time a new entry is made.

The ring buffer (*.bin) is saved:

  • when the Runtime is closed
  • after every new entry if property Save ringbuffer on change is active
  • when function Save AML and CEL memory buffer is carried out

Note: If option Save ringbuffer on change is deactivated, it is possible that the entries in the AML and in the ring buffer do not match after a power outage.

attention Attention

If the ring buffer overflows because it is too small, unacknowledged entries remain in the alarm file. They are displayed during filtering but they cannot be acknowledged anymore. The attempt to acknowledge them can trigger the acknowledgment on the ring buffer if the alarms concern the same variable and the same limit violation.


Grouping of alarms

Manual -> Alarms administration -> Configuring alarms -> Grouping of alarms

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Alarms can be grouped and prioritized by means of:

  • Alarm/event groups: group alarms (or events) together logically
  • Alarm/event classes: serve to prioritize alarms (or events) and are used to color-code alarms in the AML and by events in the CEL
  • Alarm areas: Enable detailed evaluation of alarm/event classes by means of a combined element

Each group or class can be assigned a name, a number, a color, a function, a status variable, a graphic and an equipment group.

Alarms can be exported and imported via XML using the context menu.

info Information

A maximum of 65536 alarm/event classes and 65536 alarm/event groups can be created.

Project manager alarm context menu

Menu item | Action
Export XML all... | Exports all entries as an XML file.
Import XML... | Imports entries from an XML file.
Help | Opens online help.

info Information

Use clear, different IDs in the global project, the integration project and subprojects for alarm/event groups, class and alarm areas. You avoid clashes this way. These can lead to incorrect displays.


Alarm/event groups

Manual -> Alarms administration -> Configuring alarms -> Grouping of alarms -> Alarm/event groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Alarm/event groups combine related messages.

Creating alarm/event groups

To create a new alarm/event group:

  1. In the Project Manager, right click on the Alarm/Event Groups subnode
  2. Select the command: New alarm/event group

    (alternatively select the corresponding symbol in the toolbar or press on the Ins button)

Each group can be allocated additional information via its properties:

Parameters

Description

Name

Name of alarm/event group.

Is displayed in the filter condition of AML and CEL.

No.

Identifies the alarm/event group. The number is automatically given and cannot be changed.

Minimum: 1

Maximum: 2147483647

Note: Within a project, each respective number can only be given once for the alarm/event group. Identical numbers can be given in other projects/areas.

Synchronization: A check for conflicts is carried out when the Runtime files are created. If conflicts are found, these are displayed in the output window. However the creation of conflicts that conflict one another is not prevented. Mode of checking.

  • The project is compared with the global project when checking individual projects.
  • In multi-project administration, the project is first compared with the uppermost project, then with all other projects of this multi-project administration. Synchronization with the global project is then carried out
  • Other, independent projects are not included in the synchronization.

Color

Color of alarm/event group.

A click on the ... button opens the palette for color selection

Description

Name of alarm/event group.

Status variable

Bit variable which which the zenon Runtime indicates whether the group is active or whether the alarms of this group are ignored at the moment.

Activation/deactivation is carried out via the Alarm/event group connection active/inactive function. The status of this group is logged in the Chronologic Event List (CEL).

Clicking on the ... button opens the dialog for variable selection.

Function

Function that is to be executed if an alarm of this group is activated. Click on the ... button to open the dialog to select the function.

Graphics file

Selection of a graphic that represents the alarm/event group in the AML.

To display the graphic in the AML, select in the AML filter, in the Column settings tab for the Alarm/event group symbol the Graphics file display type.

Note: the column height in the AML depends on the selected font. The selected graphics are also scaled and adapted to the column height.

Equipment groups

Links equipment model to the alarm/event group.

Define the membership of an equipment group. Click on the ... button to open the dialog to select the equipment group.

Deleting alarm/event groups

To delete an alarm/event group:

  1. Select the alarm/event group
  2. Select Delete in the context menu or in the tool bar
  3. confirm this when requested to do so

Note: All linked variables lose their group assignment when deleted.


Context menus and alarm/event-groups toolbar

Manual -> Alarms administration -> Configuring alarms -> Grouping of alarms -> Alarm/event groups -> Context menus and alarm/event-groups toolbar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu Project manager

Menu item | Action
New alarm/event group | Creates a new alarm/event group.
Editor profile | Opens the drop-down list to select a pre-defined Editor profile.
Help | Opens online help.

Detail view of context menu and toolbar

Menu item | Action
New alarm/event group | Inserts a new alarm/event group into the list.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Remove all filters | Removes all filter settings.
Help | Opens online help.


Alarm/event classes

Manual -> Alarms administration -> Configuring alarms -> Grouping of alarms -> Alarm/event classes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Alarm/event classes serve the following purpose:

  • To prioritize alarms for the screen alarming
  • To determine the alarm color in the alarm message list
  • As a filter criterion in the alarm list and the Chronological Event List
  • To trigger acoustic alarms, for example

Creating alarm/event classes

To create a new alarm/event class:

  1. In Project Manager, right click on the Alarm/Event classes subnode
  2. Select the command: New alarm/event class

    (alternatively select the corresponding symbol in the toolbar or press on the Ins button)

Each can can be allocated additional information via the properties:

Parameters

Description

Name

Name of alarm/event class.

Is displayed in the filter condition of AML and CEL.

No.

Identifies the alarm/event class. The number is automatically given and cannot be changed.

Minimum: 1

Maximum: 2147483647

Note: Within a project, each respective number can only be given once for the alarm/event class. Identical numbers can be given in other projects/areas.

Synchronization: A check for conflicts is carried out when the Runtime files are created. If conflicts are found, these are displayed in the output window. However the creation of conflicts that conflict one another is not prevented. Mode of checking.

  • The project is compared with the global project when checking individual projects.
  • In multi-project administration, the project is first compared with the uppermost project, then with all other projects of this multi-project administration. Synchronization with the global project is then carried out
  • Other, independent projects are not included in the synchronization.

Color

Color of the alarm/event class can be used for labeling in the AML. A click on the ... button opens the color palette.

Note: Color is used for long description and status text in the AML and screen alarming

Description

Description of alarm/event class.

Status variable

Bit variable which which the zenon Runtime indicates whether the class is active or whether the alarms of this class are ignored at the moment.

Activation/deactivation is carried out via the Alarm/event group connection active/inactive function. The status of this group is logged in the Chronologic Event List (CEL).

Clicking on the ... button opens the dialog for variable selection.

Function

Function that is to be executed if an alarm of this class is activated.

Click on the ... button to open the dialog to select the function.

Graphics file

Selection of graphics that represent the alarm/event class in the AML.

To display the graphic in the AML, select in the AML filter, in the Column settings tab for the Alarm/event class symbol the Graphics file display type.

Note: In the AML, the column height is aligned to the selected font; for this reason, the graphics selected are scaled if necessary and adjusted to suit the column height.

Equipment groups

Links equipment model to the alarm/event class.

Click on the ... button to open the dialog to select the equipment group.

Deleting alarm/event classes

To delete an alarm/event class:

  1. Select the alarm/event class
  2. Select Delete in the context menu or in the tool bar
  3. confirm this when requested to do so

Note: All linked variables lose their class assignment when deleted.


Alarm/event classes context menus and alarm/event-groups toolbar

Manual -> Alarms administration -> Configuring alarms -> Grouping of alarms -> Alarm/event classes -> Alarm/event classes context menus and alarm/event-groups toolbar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu Project manager

Menu item | Action
New alarm/event class | Creates a new alarm/event class.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.

Detail view of context menu and toolbar

Menu item | Action
New alarm/event class | Inserts a new alarm/event class into the list.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Remove all filters | Removes all filter settings.
Help | Opens online help.


Alarm areas

Manual -> Alarms administration -> Configuring alarms -> Grouping of alarms -> Alarm areas

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Alarm areas make flexible alarming possible using status variables. These can be evaluated using a combined element, for example.

Alarm areas are broken down into area entries. The number of possible area entries corresponds to the number of existing alarm/event classes.

Creating alarm areas

To create a new alarm area:

  1. In Project Manager, right click on the Alarm areas subnode
  2. Select the command: New Alarm area

    (alternatively select the corresponding symbol in the toolbar or press on the Ins button)

  3. Select the desired variables in the General node
  4. Create a new area entry in the Class linking node by clicking on {New class link}

    (the number of possible area entries is limited to the number of existing alarm/event classes)

Properties for alarm areas

Parameters

Description

General

Name

Name of the alarm area.

Is displayed in the filter condition of AML and CEL.

Status variable

Byte variable:

First bit: Displays if the alarm area contains active alarms.
Second bit: Displays if this alarm area contains unacknowledged alarms. For details, see "Status variable bits".

The ... button opens the dialog for variable selection.

Number of active alarms

Variables with a value that displays the number of active alarms in this alarm area.
The ... button opens the dialog to select variables.

Number of unacknowledged alarms

Variable that contains the number of unacknowledged alarms in this alarm area as a numerical value.

No.

Identifies the alarm area. The number is automatically given and cannot be changed.

Minimum: 1

Maximum: 2147483647

Note: Within a project, each respective number can only be given once for the alarm area. Identical numbers can be given in other projects/areas.

Synchronization: A check for conflicts is carried out when the Runtime files are created. If conflicts are found, these are displayed in the output window. However the creation of conflicts that conflict one another is not prevented. Mode of checking.

  • The project is compared with the global project when checking individual projects.
  • In multi-project administration, the project is first compared with the uppermost project, then with all other projects of this multi-project administration. Synchronization with the global project is then carried out
  • Other, independent projects are not included in the synchronization.

Equipment groups

Links equipment model to the alarm area.

Define the membership of an equipment group. Click on the ... button to open the dialog to select the equipment group.

Class linking

Collects area entries. A Class linking summarizes the status variable and number of active and unacknowledged alarms for an alarm/event class. Area entries are created via the {New class link} property.

{New class link}

Creates a new area entry.

Alarm/event class

Alarm class for the area entry.

{Delete class linking}

Deletes the area entry.

Alarm/event class

Selection of alarm/event class for area entry from drop-down list. Alarm/event class must already have been created.

Further entries are similar to general settings per area entry with:

  • Status variable
  • Number of active alarms
  • Number of unacknowledged alarms

Status variable bits

Bit | Meaning
0 | 1 = Alarms are active 0 = No alarms are active
1 | 1 = Unacknowledged alarms present 0 = No unacknowledged alarms

Assign alarm ranges variables, structures or data types

Variables, structures and simple data types can be linked to up to four alarm areas.

To do this, the following are available in the Alarm handling group:

  • Alarm area 1
  • Alarm area 2
  • Alarm area 3
  • Alarm area 4

For each alarm area, the desired alarm area can be selected from drop-down list of the respective area of the desired alarm area and assigned to the object.

In Runtime, the columns Alarm area and Alarm area no. contain all linked alarm areas, separated by a comma (,). In the Message Control module, the Alarm area field contains all linked alarm areas, separated by a comma (,).


Alarm area context menus and tool bar

Manual -> Alarms administration -> Configuring alarms -> Grouping of alarms -> Alarm areas -> Alarm area context menus and tool bar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu Project manager

Menu item | Action
New Alarm area | Creates a new alarm area.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.

Detail view of context menu and toolbar

Menu item | Action
New Alarm area | Inserts a new alarm area into the list.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Remove all filters | Removes all filter settings.
Help | Opens online help.


Configuring alarm areas

Manual -> Alarms administration -> Configuring alarms -> Grouping of alarms -> Alarm areas -> Configuring alarm areas

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create an alarm area:

  1. Click on {New class link}
  2. Select the desired Alarm/event class
  3. Define for the area
    • Status variable
    • Variable for Number of active alarms and
    • Variable for Number of unacknowledged alarms

Note: Alarms are allocated to an alarm area in the Alarmbereiche properties of the variables in the Alarm handling group.

Example alarm area

Class linking | Alarm/event class | Status variable | Number of active alarms | Number of unacknowledged alarms
1 | Warning | Status_warn_1 | Active_warn_1 | Unackn_warn_1
 | Disturbance | Status_error_1 | Active_error_1 | Unackn_error_1
2 | Warning | Status_warn_2 | Active_warn_2 | Unackn_warn_2
 | Disturbance | Status_error_2 | Active_error_2 | Unackn_error_2

Example application, Energy

An alarm area is a group of objects. These are summarized in one screen. For an energy supplier, each transformer station is represented by a screen. Transformer stations A to T are displayed in four sub-pages. All alarm areas are displayed in a joint overview.

  • If a limit is breached in transformer station A, the button for transformer stations flashes in the overview screen.
  • The button flashes on the group screen, which leads to the page with the transformers stations A, B, C, D and E.
  • The button for transformer station A flashes in the detailed screen.


Alarms in global project and integration projects

Manual -> Alarms administration -> Configuring alarms -> Grouping of alarms -> Alarms in global project and integration projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Each project saves its own IDs for alarm classes, alarm groups and alarm areas. There can therefore be overlaps with global projects, integration projects and subprojects. If the same IDs are used in different projects, this can lead to entries being overwritten in the filter selection dialogs.

to avoid this, ensure that different IDs are used in all projects. To do this, create "dummy" groups/classes/areas, which you then delete again.


Alarm engineering with filters

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You configure the display of alarms using the filter. For this you have several possibilities:

  1. Define information that is displayed in Runtime in the Alarm Message List:
    With this, you define the information that is shown for an alarm.
    For details, see: Column setting for Alarm Message List.
  2. Filter alarms for the Alarm Message List when switching and modify them in Runtime:
    With this, you pre-define filters, giving the user at the machine the possibility to define their own filters.
    For details, see: Filter for Alarm Message List screen switching.
  3. Fixed filters for the Runtime:
    With this you create filters which are tailor-made for the actual use and hide unnecessary filter criteria.
    For details see: Filter Alarm Message List filters.


Column setting for Alarm Message List

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Column setting for Alarm Message List

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You define the information that is displayed in the Alarm Message List in Runtime in the column settings. You configure these in the properties of the Alarm Message List in the project:

  1. Open the Alarm Message List node in the Project Properties.
  2. Click on the Column settings AML property.
  3. The dialog for the column setting is opened.
  4. Configure the desired columns.
    Note: When configuring the screen switching, this configuration is accepted by default and can be individually adapted in the column settings tab.

Note: For calculating the column width the average character width of the selected font is used.

info Information

In project settings, you can set a default setting for the sequence and size of columns using the Column settings AML property or the Column settings CEL property. If you create a new screen switching function from an Alarm Message List screen or Chronological Event List screen, this setting is used as a default and can be amended in the corresponding tab. The setting is stored in the project.ini file.

Column configuration

Parameters

Description

Columns

In the list field of this tab all available column types are displayed.

You can change the sequence of column types by dragging & dropping in the list field:

  • Click in the Column type column
  • Move the individual entries as desired

Alternatively, you can adjust the sequence with the Move selected entry up and Move selected entry down.
  • Checkbox:

Select which column types are displayed.
  • Description:

Free text entry for a description of the column.

Change description: left-click on the corresponding area. Enter the desired value in the editing field.

Note: for column descriptions, zenon language switching is available.
  • Column width:

Defines the width of the column in characters.

Change column width: left-click on the corresponding area. Enter the desired value in the editing field.
-1 Width is calculated in Runtime using average character width

Note: For compatibility reasons, the columns with widths that could not be changed in earlier zenon versions (date and time), have the value -1.

  • Display:

For column types

  • Alarm/event class symbol
  • Alarm/event group symbol
  • Alarm status

Actual form of display can be selected in Runtime. Select the desired form from the drop-down list.

Move selected entry up

Moves selected entry up one place.

Move selected entry down

Moves selected entry down one place.

Preview field

Displays the columns defined in the list field in the width displayed there.

You can also adjust the column widths here by left clicking on the right end of a column, holding down the mouse button and moving the mouse to the left or right accordingly.

Table settings

Sort descending

Sorts the entries in the list according to the Time received column in decreasing order. These setting apply for showing a screen.
You can change the sorting order in Runtime by clicking on the column header. The sorting sequence currently being used is shown by an arrow on the column header.

Display grid

shows a grid when the list is displayed in Runtime.

Use alternating background colors

Uses line color 1 and line color 2 alternately as background colors for the list in Runtime.

Row color 1

Color that is used as a background color in in the list Runtime for all uneven numbers (1, 3, 5 etc.), if you have activated Alternating Background Colors.

Row color 2

Color that is used as a background color in in the list Runtime for all even numbers (2, 4, 6 etc.), if you have activated Alternating Background Colors.

Display in the time columns

Time

Displays the time for a list entry in the following form: HH:MM:SS

Date

Displays the date for a list entry in the following form: TT:MM:YYYY

Milliseconds

Expands the time entry by milliseconds.

Note: Must be activated if milliseconds are to be provided in exports or print-outs.

Hint: If you activate the automatic keyboard in Runtime, it is turned on when an editing field appears. You can also use this to configure the columns if you are using a computer without a keyboard.

attention Attention

The column width is given in characters and is dependent on the font used. If the column width is not a multiple of the character width of the used font, the actual column width can differ from the set column width. This can result in the text being cut of or an empty space being created.

Solution: Use proportional fonts, such as 'Courier New', for example.


Filter for Alarm Message List screen switching.

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching.

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You define which alarms are to be displayed in Runtime using filters and which are to be hidden. Filters can be defined in the editor and - depending on the requirements in the Editor - in Runtime.

To tailor the filter selection to the requirements of the operator in Runtime, use an Alarm Message List filter screen instead of an Alarm Message List screen.

To configure screen switching for an Alarm Message List screen:

  1. engineer a function screen switch to a screen of type Alarm Message List
  2. the filter dialog is opened and offers several tabs with filter criteria:
    • General
    • Time
    • Lots
    • Column settings
    • Text
    • Status
    • Project (only available in the integration project of the multi-project administration.)
    • Equipment Modeling

If linked variables or indexes are available, the following tabs can be displayed as an option.

  • Replace links
  • Replace indices

For details see in chapter Screens sections Replace links of variables and functions and Symbols.


General

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching. -> General

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the general filter, you define which alarms are shown and what access you have to the setting in Runtime. To do this, alarms are classified according to:

  • Type
  • Origin of the data
  • Variables
  • Time active
  • Alarm/event groups, classes and alarm areas

The following properties are available:

Variable filter

Parameters

Description

Variable filter

Limitation to alarms of certain variables

Variable name

Enter the name or part of the name of the variable you want to filter.

Use of the wild card * is possible. Wildcards are only permitted as a prefix or suffix; e.g. *xxx or xxx*.

Note: Filter terms entered in Runtime or in the Editor are automatically saved on the local computer in zenon6.ini and are available for selection in the drop-down list.

Identification

Enter the identification or part of the identification of the variables you want to filter. Wild card * is possible.

Use of the wild card * is possible. Wildcards are only permitted as a prefix or suffix; e.g. *xxx or xxx*.

Note: Filter terms entered in Runtime or in the Editor are automatically saved on the local computer in zenon6.ini and are available for selection in the drop-down list.

Case sensitive

Active: Capitalization is recognized when filtering for variable name and/or identification.

Type of alarms

Parameters

Description

Type of alarms

Type of alarm that is displayed.

Only not acknowledged alarms

Active: Only alarms that have not yet been acknowledged by the user are displayed.

Only cleared alarms

Active: Only alarms that have already passed, i.e. whose values no longer in the critical range, are displayed.

Only current alarms

Active: Only alarms that are still active, i.e. whose values are still in the critical range, are displayed.

Comment required

Active: Only alarms are shown for which it is necessary to leave a comment are displayed.

Alarms must be current for

Use the spin control to define the minimum time that an alarm should be active in order for it to be displayed. Possible settings:

  • Days
  • Hours (hr.)
  • Minutes (min.)
  • Seconds (sec.)
  • Milliseconds (ms)

Origin of the data

Parameters | Description
Origin of the data | Display of current or current and historical alarms.
Ringbuffer | Active: Only data from the ring buffer are displayed.
Historical data Maximum number | Active: Data from the ring buffer and historical data from the AML are displayed. The maximum number of the data which should be displayed includes the data from the ring buffer.

Alarm/event groups/classes and alarm areas

Parameters | Description
Alarm/event groups/classes, alarm areas | Selection of groups, classes and alarm area.
Alarm/event groups | From the existing alarm/event groups select the one from which alarms should be displayed.
Alarm/event classes | From the existing alarm/event classes select the one from which alarms should be displayed.

Alarm areas

Parameters | Description
Alarm areas | From the existing alarm areas select the one from which alarms should be displayed.

Runtime settings

Parameters

Description

Runtime settings

Behavior of the AML in Runtime

Show list without refresh

Active: As long as the list is displayed no new entries are added.

(not available for Export AML function.)

Show this dialog in the Runtime

Active: Before every call of the screen the filter dialog is opened. The filter settings can be modified. This option is not available with Windows CE.
Note: If, in the Lots tab, the Show lot selection dialog option is also selected, then the lot selection dialog is called up in Runtime. This is no longer displayed after reloading.

Notes for time range filters:

Show this dialog in the Runtimeactive:

  • The filter is opened in Runtime in screen switching. The filter is no longer offered on reloading. This behavior can differ for individual screen types if the dialog was displayed in screen switching and canceled.
  • The last-concluded time period is always used.

Show this dialog in the Runtimenot active:

  • Use last finished time rangeactive: The last-concluded time period is used
  • Use last finished time rangenot active: The current time period is used.

Replace dialog in Runtime with screen

Definition of a screen that is to be switched in Runtime instead of the dialog if the Offer this dialog in Runtime option is active. Only screens of the type AML Filter or Time filter will be offered.

Click the ... button and a dialog opens to select a screen.

If the linked screen is not found in Runtime, a search is made for corresponding screens with specific names.

attention Attention

Concerns zenon under Windows CE: CE systems on which the filter dialog should be displayed must have a screen resolution higher than 800*600 pixel for the dialog to be displayed completely.


Time

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching. -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Time filters make it possible to limit the data to be displayed or exported. The time filters are very flexible to implement and can be pre-set in the editor or adjusted in Runtime.

Note: Time is saved in UTC. For details see chapter Handling of date and time in chapter Runtime.

Time filters can be pre-set in both the Editor and in Runtime for:

  • Absolute period of time
  • Relative period of time
  • From
  • Time period

Time filtering can be carried out in two ways:

  1. Define time period in the Editor
    Fixed time areas are used. A time period is given in the editor. It is only possible to filter according to this time period in Runtime. Other filters - such as filtering according to variable name, alarm/event groups and alarm/event classes etc. can no longer be amended in Runtime.
  2. Time filter amendable in Runtime
    Pre-defined times are used. The time filter is defined in the Editor and can be changed in Runtime as desired.

Time filter

Filter

Selection of the filter.

Parameters

Description

No time filter

Active: No time filter is used.

Note: all Runtime entries since 1. 1. 1990 are displayed.

Absolute filter

Active: A fixed period of time is entered in the editor. When the function is executed, the defined absolute time period is exactly used.

In the settings section, the corresponding options can be shown and configured there.

Note: Time is saved in UTC. For details see chapter Handling of date and time in chapter Runtime.

Relative period of time

Active: A relative time period is entered.

In the settings section, the corresponding options can be shown and configured there.

Attention: this filter is constantly updated.

From

Active: A time from which the filter is effective is stated. If the time is not reached on the current day, filtering takes place from the corresponding time the previous day.

Selection of the area mode from drop-down list:

  • From HH:MM:SS o'clock
  • From day - HH:MM:SS o'clock
  • Starting on day, month at HH:MM:SS

In the settings section, the corresponding options can be shown and configured there.

Attention: The start point of this filter is not updated automatically. Only the existing times are used when shown.
The end time point is not defined with this filter, it is carried over.

Time period

Active: A fixed time period is entered. Selection of the area mode from drop-down list:

  • One day
  • One week
  • Two weeks
  • One month
  • One Year
  • 15 minutes
  • 30 minutes
  • 60 minutes

In the settings section, the corresponding options can be shown and configured there.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Absolute period of time

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching. -> Time -> Absolute period of time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Absolute period of time

You define a fixed time period with the absolute filter. When the function is executed, the defined absolute time period is exactly used. To set the filter:

  1. Select, in the Filter section, the Absolute time period option
  2. Configure the desired time in the Settings section

Parameters | Description
Settings | Configuration of the time filter.
Propose current date/time | Active: Time filter is displayed in Runtime.
Preset | Active: The time filter is prescribed in the Editor. Only the start time can still be configured in Runtime.
From | Start time of the filter. Selection of day, month, year, hour, minute and second
To | End time of the filter. Selection of day, month, year, hour, minute and second

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Relative period of time

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching. -> Time -> Relative period of time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Relative period of time

A relative time period is entered.

Attention: This filter is updated constantly and continues to run.
Example: You set a relative time of 10 minutes and switch to a screen with this time filter at 12:00. You are then shown the data from 11:50 to 12:00 when switching. If the screen stays open, the filter is automatically updated. At 12:01, you see the data from 11:51 - 12:01 etc.

To set the filter:

  1. Select, in the Filter section, the Relative period of time option
  2. Configure the desired time in the Settings section

Parameters | Description
Settings | Configuration of the time filter.
Propose current date/time | Active: Time filter is displayed in Runtime.
Preset | Active: The time filter is prescribed in the Editor. Only the start time can still be configured in Runtime. Selection of the relative time period in days, hours, minutes and seconds.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


From

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching. -> Time -> From

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
From

A time from which the filter is effective is defined. To set the filter:

  1. Select, in the Filter section, the Off option
  2. Select the desired filter from the drop-down list.
    • From HH:MM:SS o'clock
    • From day - HH:MM:SS o'clock
    • Starting on day, month at HH:MM:SS
  3. Configure the desired time in the Settings section

Parameters

Description

Settings

Configuration of the time filter.

[Date/Time]

Depending on the settings of the Off option, the time from which the filter is effective is configured here:

  • Starting from HH:MM:SS
  • Starting from day - HH:MM:SS
  • Starting from day, month - HH:MM:SS

Warning! The start point of this filter is not updated automatically. Only the existing times are used when shown, even if the screen remains open and 23:00:00 is reached.
The end time point is not defined with this filter, it is carried over.
  • Starting from HH:MM:SS

A time from which the filter is effective is stated. If the time is not reached on the current day, filtering takes place from the corresponding time the previous day.

Example: You enter 23:00:00. If it is then 23:30 when executing the function, then it is filtered from 23:00:00 up to the current point in time. If it is 22:30 however, then filtering takes place from 23:00:00 on the previous day to the current point in time.
  • Starting from day - HH:MM:SS

A day and time for the start of the filter are entered. If the time given has not been reached in the current month, the corresponding time from the previous month is used.

Example: You enter day 5 - 23:00:00. If it is the 10th of the month at 23:30, then filtering takes place from the 5th of the month from 23:00:00 to the current time point. If, however, it is the 4th of the month, then filtering takes place from the 5th of the previous month to the current time point.

  • Starting from day, month - HH:MM:SS

A month, day and time for the start of the filter are entered. If the time stated has not been reached in the current year, the corresponding time from the previous year is used.

Example: You enter Day 5, Month October - 23:00:00. If it is October 10th at 23:30, then filtering takes place from October 5th from 23:00:00 to the current time point. If, however, it is only October 4th, then filtering takes place from the 5th of the previous year to the current time point.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Time period

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching. -> Time -> Time period

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Time period

A time period in which the filter is effective is defined. To set the filter:

  1. Select, in the Filter section, the Time period option
  2. Configure the desired time in the Settings section

Parameters

Description

Settings

Configuration of the time filter.

Time period

Selection of a time range from a drop-down list.

Filtering for this time range is carried out in Runtime. The filter relates to the time of screen switching.
For example: The value 60 minutes shows all archives of the last hour.

If this dialog is offered in Runtime, the start time of the time range can be selected.

Modify time period

Allows amendments to cycles, postponements and extensions of time periods.

Active: Evaluation is carried out in accordance with the following rules:

  • First, the Use last finished time period option is evaluated.
  • After this, Change time period by is used.
  • Move time period to the future by is then applied.

Inactive: No changes to the time period are made.

Attention: With version 7.10, filter actions on the basis of this function led to different results than those in the versions before.

Move time period to the future by

Active: The time period defined in the filter is postponed to the future. Given in hours - minutes - seconds.

If a postponement that is the same or greater than the selected time period is set, a note to check the configuration is displayed.

Change period of time by

Active: The time period defined in the filter is modified. Given in hours - minutes - seconds.

If a change and a postponement that are the same or greater than the selected time period is set, a note to check the configuration is displayed.

Add time

Active: The time stated in Change time period by is added to the time defined in the Time range option.

Deduct time

Active: The time stated in Change time period by is deducted from the time defined in the Time range option.

Use last finished time period

Active: The last finished time period is used.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Specify time period in the Editor

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching. -> Time -> Specify time period in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Specify time period in the Editor

With this method, you enter a fixed time period into the editor, which is applied when the function is carried out in Runtime. You can then only define the start time in Runtime, but no further filter settings.

For example: You set a 30 minute time filter. In Runtime, you can now only set when this 30 minute time period is to start. However, you cannot change the filter to a day filter.

attention Attention

When using this type of filter, you can also no longer amend all other filters in Runtime that are available in the General tab. It is still possible to filter for text, status and equipment.

To create the filter:

  1. The screen must have the Filter button to start the filter in Runtime
  2. select the desired filter
  3. Configure the selected time period

Tip for time period: Activate the Offer this dialog in Runtime option in the filter dialog. This way you can amend the start time before the function is carried out. Do not have the filter displayed in Runtime when the function is turned on; this way the current time period is always used. If you have activated the Use last closed time period option, the previous time period is shown.
For example: You have set a 30 minute filter. It is 10.45 when the function is activated. If the Use last closed time period option is deactivated, the filter is set to the current time period 10:30:00 to 10:59:59. If the option is activated, the filter is set to the previous time period of 10:00:00 to 10:29:59.


Time filter can be configured in Runtime

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching. -> Time -> Time filter can be configured in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Time filter can be configured in Runtime

With this method, you stipulate a time filter in the Editor. This can be amended in Runtime before execution. To create the filter:

  1. The screen must have Filter and Display filter buttons
  2. select the desired filter:
    • Absolute period of time
    • Relative period of time
  3. Select, in the Settings section, the option Propose current date/time
  4. The filter dialog is opened in Runtime with the current date and time


Lots

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching. -> Lots

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You configure the limitation of the display to certain lots in this tab.

The lot information is also applied to the existing AML filter. If the lot filter is activated, a list of all configured lots that correspond to the configured time period is obtained from the archive server in Runtime in advance when the AML is loaded.

Attention: All variables and archives that belong to an item of equipment and the lot archive must be linked to the same equipment in the equipment model.

Filter

Settings for the application of the lot filter. Selection of one of the options:

  • No lot filter
  • Apply lot filter directly
  • Display lot selection dialog

Parameters

Description

No lot filter

Active: The lot filter is deactivated and cannot be configured. Filtering for lots is not carried out in Runtime.

Apply lot filter directly

Active: The filter configured here is applied in Runtime directly.

Display lot selection dialog

Active: The dialog for lot selection is shown in Runtime when:

  • Clicking on Filter or
  • screen switching, if the Offer this dialog in Runtime option has been activated (not available for each function/screen type)
    Note: The dialog is not shown on reloading.

Options can be pre-selected in the Editor.

Replace dialog in Runtime with screen

Not available if the Show lot selection dialog option has been selected.

Definition of a screen that is to be called up in Runtime instead of the lot selection dialog. Only time/lot filter screens are offered.

Click the ... button and the dialog opens to select a screen.

If the linked screen is not found in Runtime, a search is made for corresponding screens with specific names.

Relative lot selection

Only available for Extended Trend and faceplates and only if the option Display lot selection dialog has been activated. The Windows CE project property must be deactivated in the project properties.

  • Active: Enables several lots to be compared directly. Display always starts from the zero point.

Time

Configuration of the time filter for lot selection. Selection of one of the options:

  • No filter
  • Last lots
  • Use time filter from "Time" tab

Parameters

Description

No filter

Active: The time range set in the Time tab is not taken into account. All completed and current lots are displayed.

Last lots

Active: Input of the number of lots last concluded, according to what they should be filtered for. Input of the number in the number field or configuration via cursor keys.

The option allows the combination of both options Display current lots and Display completed lots.
Example: 3 lots are to be displayed, 2 are running and 10 have been completed. The following is shown: the two that are current and one that has been completed.

Attention: At least one of the two options Display current lots or Display completed lots must be activated. If both options have been deactivated, this corresponds to the No filter setting.

Note on compatibility: If the current lots or the combination of current and completed lots are selected and the project is compiled for a version before 7.11, the completed lots are shown in Runtime.

Display current lots

Active: The current lots are displayed.

Note: If the number of lots to be displayed is greater than the number of current lots, lots that have been completed are also shown until the set limit has been reached.
Example: 3 lots are to be displayed. 1 lot is running, 5 have been completed. The one current lot and two completed lots are displayed.

Display completed lots

Active: The completed lots are displayed.

Note: If the number of lots to be displayed is greater than the number of completed lots, lots that have been completed are also shown until the set limit has been reached.

Use time filter from "Time" tab

Active: Pre-filtering is carried out with the settings of the Time tab. The effective range of the filter can be amended within this time range. Select from drop-down list:

  • Start and end also outside filter limits: (Default)
    Lots can start before the start time configured in the Time filter and end after the configured end time.
  • Start and end only outside filter limits:
    Lots must start and end within the time points configured in the Time filter for the start and end.
  • Start also before filter limit:
    Lots can start before the start time configured in the Time filter and end after the configured end time.
  • End also after the filter limit:
    Lots can also end after the end time set in the time filter, but must start at or after the configured start time.
  • Adjust start and end to filter limits:
    Lots are cut to the time points configured in the Time filter for the start and end.

Archives

Configuration of filtering for archives. Selection of one of the options:

  • No filter
  • Static
  • From variable

Note: Only available for the following modules if the Apply lot filter directly option has been selected:

  • Archive revision
  • ETM
  • Report Generator
  • Report Viewer

Parameters

Description

No filter

Active: Filtering for archive names is not carried out.

Static

Active: Archives whose identification corresponds to the character string entered in the input field are filtered for.

Input of the archive identifications in the input field:

  • Several identifications are separated by a comma (,).
  • * or empty: All archives, no filter.

From variable

Active: The value of the variables linked here is applied as a filter for archive names in Runtime.

Click on button ... in order to open the dialog for selecting a variable.

Only available for all modules if the Apply lot filter directly option has been selected:

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.

If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for archive names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Names

Configuration of the filtering to names. Selection of one of the options:

  • No filter
  • Static
  • From variable

Parameters

Description

No filter

Active: Filtering for lot names is not carried out.

Static

Active: Lot names that correspond to the character string entered in the input field are filtered for.

Input of the lot name in the input field:

  • Several entries are separated by a pipe character (|).
  • * or empty: All lots of all displayed archives, no filter.

From variable

Active: The value of the variable linked here is applied as a filter for lot names in Runtime.

Click on the ... button to open the dialog for selecting a variable.

Not available if the option Apply lot filter directly has been selected.

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.
  • If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for lot names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Text

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching. -> Text

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The text filter allows limitation of the display to messages that contain certain search terms.

Filter by

Filter by

Parameters | Description
Filter by |
No text filter | The text filter is not used.
Search for (words separated by spaces) | The text filter filter is used. Further options are activated.
Input field | Enter the corresponding words or character strings.

Options

Parameters | Description
Options |
Note capitalization | Active: The filtering is case-sensitive.
Words do not have to appear in the text in full | Active: Parts of words can also be taken into account during filtering.
At least one word must be in the text | Active: At least one word of the search string has to be in the text.
All words must be present in the text | Active: All words must be present in the search string. In doing so, the sequence plays no role.
Filter text must appear in the text exactly | Active: The text must be exactly as defined in the search string.


Column settings

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching. -> Column settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this dialog, you define which columns you want to have displayed, including the form, sequence and sorting.

Note: All settings which you make in this tab are default settings for:

  • Alarm Message List screen
  • Alarm Message List filter screen
  • Alarm status line
  • Export to CSV, dBase or XML

These default settings can be changed when defining the individual alarm functions.

info Information

In project settings, you can set a default setting for the sequence and size of columns using the Column settings AML property or the Column settings CEL property. If you create a new screen switching function from an Alarm Message List screen or Chronological Event List screen, this setting is used as a default and can be amended in the corresponding tab. The setting is stored in the project.ini file.

Columns Parameters

Description

Columns

In the list field of this tab all available column types are displayed.

You can change the sequence of column types by dragging & dropping in the list field:

  • Click in the Column type column
  • Move the individual entries as desired

Alternatively, you can adjust the sequence with the Move selected entry up and Move selected entry down.
  • Checkbox:

Select which column types are displayed.
  • Description:

Free text entry for a description of the column.

Change description: left-click on the corresponding area. Enter the desired value in the editing field.

Note: for column descriptions, zenon language switching is available.
  • Column width:

Defines the width of the column in characters.

Change column width: left-click on the corresponding area. Enter the desired value in the editing field.
-1 Width is calculated in Runtime using average character width

Note: For compatibility reasons, the columns with widths that could not be changed in earlier zenon versions (date and time), have the value -1.

  • Display:

For column types

  • Alarm/event class symbol
  • Alarm/event group symbol
  • Alarm status

Actual form of display can be selected in Runtime. Select the desired form from the drop-down list.

Move selected entry up

Moves selected entry up one place.

Move selected entry down

Moves selected entry down one place.

Preview field

Displays the columns defined in the list field in the width displayed there.

You can also adjust the column widths here by left clicking on the right end of a column, holding down the mouse button and moving the mouse to the left or right accordingly.

Table settings

Sort descending

Sorts the entries in the list according to the Time received column in decreasing order. These setting apply for showing a screen.
You can change the sorting order in Runtime by clicking on the column header. The sorting sequence currently being used is shown by an arrow on the column header.

Display grid

shows a grid when the list is displayed in Runtime.

Use alternating background colors

Uses line color 1 and line color 2 alternately as background colors for the list in Runtime.

Row color 1

Color that is used as a background color in in the list Runtime for all uneven numbers (1, 3, 5 etc.), if you have activated Alternating Background Colors.

Row color 2

Color that is used as a background color in in the list Runtime for all even numbers (2, 4, 6 etc.), if you have activated Alternating Background Colors.

Display in the time columns

Time

Displays the time for a list entry in the following form: HH:MM:SS

Date

Displays the date for a list entry in the following form: TT:MM:YYYY

Milliseconds

Expands the time entry by milliseconds.

Note: Must be activated if milliseconds are to be provided in exports or print-outs.

Hint: If you activate the automatic keyboard in Runtime, it is turned on when an editing field appears. You can also use this to configure the columns if you are using a computer without a keyboard.

attention Attention

The column width is given in characters and is dependent on the font used. If the column width is not a multiple of the character width of the used font, the actual column width can differ from the set column width. This can result in the text being cut of or an empty space being created.

Solution: Use proportional fonts, such as 'Courier New', for example.


Status

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching. -> Status

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The status of the checkbox indicates if the status bit is to be evaluated.

Status of checkbox | Description
Black dot | The status bit is not evaluated.
0 | Only the entries where the status bit is set to false are displayed.
1 | Only the entries where the status bit is set to true are displayed.

Example Example

If the checkbox SPONT is set to 1, only the alarms are shown that are triggered by spontaneous values are displayed.

Note: You can read details on status bits in the Status processing chapter.


Project

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching. -> Project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Selection of projects that are to be taken into account for the AML. The filter for selecting sub-projects is only available in the integration project of the multi-project administration.

the selection from the integration project and all sub-projects is carried out via multi-select by pressing and holding key Ctrl and mouse click on the desired projects.


Equipment Modeling

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching. -> Equipment Modeling

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the filter all already existing equipment models are displayed. Via the context menu or via tool bar, you can create new models and groups.

To add groups to the filter:

  1. select the desired element
  2. Click on the Add button
  3. repeat the process until all necessary groups are available in the list
    (Multi-select is not possible)

To remove groups from the filter:

  1. Select the desired element
    (multiselect: Ctrl button or hold down the shift key and click on the desired element)
  2. click the Delete button

Element | Description
List of equipment models | provides models and groups for selection
Add | Adds selected groups to the filter list
Delete | removes selected groups from the filter list
Filter list | Shows all equipment groups that are to be filtered.
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Filter for Alarm Message List screen switching filter.

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching filter.

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create an Alarm Message List filter screen:

  1. Create a Screen switching function on an Alarm Message List filter screen
  2. the filter is displayed with all tabs:
    • Screens
    • General
    • Text
    • Time


Screens

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching filter. -> Screens

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab, you can define the screens that are to be updated by the screen filter.

The following settings are available:

Filter is taken from the following screen

Parameters

Description

Filter is taken from the following screen

Definition of the screen form which the filter is to be taken.

Calling screen

Active: The filter settings are take over from the screen from which the filter screen is called up. The screen button is grayed out. You cannot explicitly select a screen, because the filter is always updated from the calling screen with this setting.

Note: Settings in the General, Text and Time tabs are locked.

Predefined screen

Click on button opens the Screen selection dialog.

Select the screen from which the filter - when clicking button Update during Runtime - should be read.

Subscreens of faceplates can be selected for screen switching to AML filter, CEL filter, time filter and equipment model. For these screens, the name of the faceplate screen is placed in front of the subscreen in order to clearly distinguish them from other screens.

Attention: When the filter screen is first called up using the function, the filter configured in the function is used, not the filter of the screen stated here!

Note: It therefore only makes sense to select a screen which can adopt or fill the screen filter.

The screen selected is entered into the list of screens to be updated. If you delete it from the list, the next screen on the list is automatically entered here.

Note: Not available if you have activated the Calling screen checkbox.

Screens to be updated

Parameters | Description
Screens to be updated | Selection of the screens that are to be updated. Subscreens of faceplates can be selected for screen switching to AML filter, CEL filter, time filter and equipment model. For these screens, the name of the faceplate screen is placed in front of the subscreen in order to clearly distinguish them from other screens.
Screen selection | Click the button to open dialog Screen selection of the filter screens. Select the desired screen.
Update | Stipulation of where the filter should take effect.
Update on all monitors | Active: The screens from the list of the screens which must be updated are updated on all accessible monitors.


General

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching filter. -> General

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Variable filter

Parameters

Description

Variable filter

Limitation to alarms of certain variables

Variable name

Enter the name or part of the name of the variable you want to filter.

Use of the wild card * is possible. Wildcards are only permitted as a prefix or suffix; e.g. *xxx or xxx*.

Note: Filter terms entered in Runtime or in the Editor are automatically saved on the local computer in zenon6.ini and are available for selection in the drop-down list.

Identification

Enter the identification or part of the identification of the variables you want to filter. Wild card * is possible.

Use of the wild card * is possible. Wildcards are only permitted as a prefix or suffix; e.g. *xxx or xxx*.

Note: Filter terms entered in Runtime or in the Editor are automatically saved on the local computer in zenon6.ini and are available for selection in the drop-down list.

Case sensitive

Active: Capitalization is recognized when filtering for variable name and/or identification.

Type of alarms

Parameters

Description

Type of alarms

Type of alarm that is displayed.

Only not acknowledged alarms

Active: Only alarms that have not yet been acknowledged by the user are displayed.

Only cleared alarms

Active: Only alarms that have already passed, i.e. whose values no longer in the critical range, are displayed.

Only current alarms

Active: Only alarms that are still active, i.e. whose values are still in the critical range, are displayed.

Comment required

Active: Only alarms are shown for which it is necessary to leave a comment are displayed.

Alarms must be current for

Use the spin control to define the minimum time that an alarm should be active in order for it to be displayed. Possible settings:

  • Days
  • Hours (hr.)
  • Minutes (min.)
  • Seconds (sec.)
  • Milliseconds (ms)

Origin of the data

Parameters | Description
Origin of the data | Display of current or current and historical alarms.
Ringbuffer | Active: Only data from the ring buffer are displayed.
Historical data Maximum number | Active: Data from the ring buffer and historical data from the AML are displayed. The maximum number of the data which should be displayed includes the data from the ring buffer.

Alarm/event groups/classes and alarm areas

Parameters | Description
Alarm/event groups/classes, alarm areas | Selection of groups, classes and alarm area.
Alarm/event groups | From the existing alarm/event groups select the one from which alarms should be displayed.
Alarm/event classes | From the existing alarm/event classes select the one from which alarms should be displayed.
Alarm areas | From the existing alarm areas select the one from which alarms should be displayed.
Runtime settings | Behavior of the AML in Runtime
Show list without refresh | Active: As long as the list is displayed no new entries are added.


Text

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching filter. -> Text

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Filter by

Parameters | Description
Filter by |
No text filter | The text filter is not used.
Search for (words separated by spaces) | The text filter filter is used. Further options are activated.
Input field | Enter the corresponding words or character strings.

Options

Parameters | Description
Options |
Note capitalization | Active: The filtering is case-sensitive.
Words do not have to appear in the text in full | Active: Parts of words can also be taken into account during filtering.
At least one word must be in the text | Active: At least one word of the search string has to be in the text.
All words must be present in the text | Active: All words must be present in the search string. In doing so, the sequence plays no role.
Filter text must appear in the text exactly | Active: The text must be exactly as defined in the search string.


Time

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching filter. -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab, you define the time period that is to be used when the filter screen is opened.

You can read details of the time filter options in the Filter for screen switching, Alarm Message List/time chapter.

Filter

Selection of the filter.

Parameters

Description

No time filter

Active: No time filter is used.

Note: all Runtime entries since 1. 1. 1990 are displayed.

Absolute filter

Active: A fixed period of time is entered in the editor. When the function is executed, the defined absolute time period is exactly used.

In the settings section, the corresponding options can be shown and configured there.

Note: Time is saved in UTC. For details see chapter Handling of date and time in chapter Runtime.

Relative period of time

Active: A relative time period is entered.

In the settings section, the corresponding options can be shown and configured there.

Attention: this filter is constantly updated.

From

Active: A time from which the filter is effective is stated. If the time is not reached on the current day, filtering takes place from the corresponding time the previous day.

Selection of the area mode from drop-down list:

  • From HH:MM:SS o'clock
  • From day - HH:MM:SS o'clock
  • Starting on day, month at HH:MM:SS

In the settings section, the corresponding options can be shown and configured there.

Attention: The start point of this filter is not updated automatically. Only the existing times are used when shown.
The end time point is not defined with this filter, it is carried over.

Time period

Active: A fixed time period is entered. Selection of the area mode from drop-down list:

  • One day
  • One week
  • Two weeks
  • One month
  • One Year
  • 15 minutes
  • 30 minutes
  • 60 minutes

In the settings section, the corresponding options can be shown and configured there.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Lots

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching filter. -> Lots

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab, you can define the lots that are to be displayed.

Filter

Settings for the application of the lot filter. Selection of one of the options:

  • No lot filter
  • Apply lot filter directly
Parameters | Description
No lot filter | Active: The lot filter is deactivated and cannot be configured. Filtering for lots is not carried out in Runtime.
Apply lot filter directly | Active: The filter configured here is applied in Runtime directly.

Archive(s)

Configuration of filtering for archives. Selection of one of the options:

  • No filter
  • Static
  • From variable

Parameters

Description

No filter

Active: Filtering for archive names is not carried out.

Static

Active: Archives whose identification corresponds to the character string entered in the input field are filtered for.

Input of the archive identifications in the input field:

  • Several identifications are separated by a comma (,).
  • * or empty: All archives, no filter.

From variable

Active: The value of the variables linked here is applied as a filter for archive names in Runtime.

Click on button ... in order to open the dialog for selecting a variable.

Only available for all modules if the Apply lot filter directly option has been selected:

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.
  • If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for archive names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Name(s)

Configuration of the filtering to names. Selection of one of the options:

  • No filter
  • Static
  • From variable

Parameters

Description

No filter

Active: Filtering for lot names is not carried out.

Static

Active: Lot names that correspond to the character string entered in the input field are filtered for.

Input of the lot name in the input field:

  • Several entries are separated by a pipe character (|).
  • * or empty: All lots of all displayed archives, no filter.

From variable

Active: The value of the variable linked here is applied as a filter for lot names in Runtime.

Click on the ... button to open the dialog for selecting a variable.

Not available if the option Apply lot filter directly has been selected.

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.

If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for lot names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Column settings

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching filter. -> Column settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab, you define how the archive list and the lot list from the time/lot filter screen are displayed in Runtime:

  • Selection of the columns to be displayed
  • Sorting of the columns
  • Formatting of columns:
    • Labeling
    • Width
    • Alignment

Archive list

Parameters | Description
Archive list | Configuration of the archive list. Display of the configured columns.
Column selection | Clicking on the button opens a dialog to select and sort the columns.
Column Format | Clicking on the button opens a dialog to format the list.

Lot list

Parameters | Description
Lot list | Configuration of the lot list. Display of the configured columns.
Column selection | Clicking on the button opens a dialog to select and sort the columns.
Column Format | Clicking on the button opens a dialog to format the list.
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Column selection

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching filter. -> Column settings -> Column selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column selection

Selection and sequence of the columns.

Button | Function
Available columns | List of columns that can be displayed in the table.
Selected columns | Columns that are displayed in the table.
Add | Moves the selected column from the available ones to the selected items. After you confirm the dialog with OK, they are shown in the detail view.
Add all | Moves all available columns to the selected columns.
Remove | Removes the marked columns from the selected items and shows them in the list of available columns. After you confirm the dialog with OK, they are removed from the detail view.
Remove all | All columns are removed from the list of the selected columns.
Up | Moves the selected entry upward. This function is only available for unique entries, multiple selection is not possible.
Down | Moves the selected entry downward. This function is only available for unique entries, multiple selection is not possible.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Column Format

Manual -> Alarms administration -> Configuring alarms -> Alarm engineering with filters -> Filter for Alarm Message List screen switching filter. -> Column settings -> Column Format

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column Format

Configuration of the properties of the columns for configurable lists. The settings have an effect on the respective list in the Editor or - when configuring screen switching - in Runtime.

Available columns

Parameters | Description
Available columns | List of the available columns via Column selection. The highlighted column is configured via the options in the Settings area.

Settings

Parameters

Description

Settings

Settings for selected column.

Labeling

Name for column title.

The column title is online language switchable. To do this, the @ character must be entered in front of the name.

Width

Width of the column in characters.
Calculation: Number time average character width of the selected font.

Alignment

Alignment. Selection by means of radio buttons.

Possible settings:

  • Left-justified: Text is justified on the left edge of the column.
  • Centered: Text is displayed centered in the column.
  • Right: Text is justified on the right edge of the column.

Deactivate column filter in the Runtime

Active: The filter for this column cannot be changed in Runtime.

Note: Only available for:

  • Batch Control
  • Extended Trend
  • Filter screens
  • Message Control
  • Recipegroup Manager

User defined colors

Properties in order to define user-defined colors for text and background. The settings have an effect on the Editor and Runtime.

Note:

  • These settings are only available for configurable lists.
  • In addition, the respective focus in the list can be signalized in Runtime by means of different text and background colors. These are configured using the project properties.

User defined colors

Active: User-defined colors are used.

Text color

Color for text display. Clicking on the color opens the palette to select a color.

Background color

Color for the display of the cell background. Clicking on the color opens the palette to select a color.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Functions

Manual -> Alarms administration -> Configuring alarms -> Functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The display and handling of the Alarm Message List is controlled in Runtime using functions.

attention Attention

If functions are used in the network, regard their execution location.


Functions in the network

Manual -> Alarms administration -> Configuring alarms -> Functions -> Functions in the network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If network functions are used, the place of execution must be noted:

For functions that are used in the network:

  • The place of execution can be freely configured in some cases
  • The place of execution is stipulated in some cases

info Information

Scripts combine several functions. The place of execution then depends on the settings of the Execute script function. This setting overwrites the settings of the individual functions.

Configure place of execution

For functions where the place of execution can be freely configured, the corresponding parameters are available in the properties of the function.

To define the place of execution:

  1. navigate to the Execution group in the Properties.
  2. Select the desired place of execution by checking the checkbox. Multiple selection is possible:
    • Current computer: Function will be executed on the current computer.
    • Primary Server: Function will be executed on the Primary Server.
    • Standby Server: Function will be executed on the Standby Server.
    • Client: Function will be executed on all clients.

Overview of functions in the network

The following table shows which functions are executed and where they are executed.

Key:

  • Adjustable: Behavior can be configured

    +: Yes

    -: No

    O: Default

  • If not adjustable, O identifies the place of execution:
    • Active computer
    • Primary Server
    • Standby Server
    • Client

Function | Adjustable | Current computer | Primary Server | Standby Server | Client
AML and CEL |  |  |  |  |
Alarms: acknowledge flashing | - | O |  |  |
Alarms: delete | - |  | O | O |
Acknowledge alarms | - |  | O | O |
Alarm/event group log in/log off | - | O |  |  |
Activate/deactivate alarm message list / alarm/event groups / alarm/event classes | - |  | O | O |
Alarm Message List active | - |  | O |  |
Alarm Message List active/inactive | - |  | O |  |
Alarm message list inactive | - |  | O |  |
Export AML | + | O |  |  |
Save AML and CEL memory buffer | - |  | O | O |
Export CEL | + | O |  |  |
Print AML or CEL | + | O |  |  |
Create/print IPA document | - |  | O |  |
Switch online printing on/off | - |  | O | O |
Online printing start new page | + | O |  |  |
Switch online printer | - |  | O |  |
Application |  |  |  |  |
Select printer | + | O |  |  |
Start Load Management | - |  | O |  |
Stop Load Management | - |  | O |  |
Print Extended Trend diagram | + | O |  |  |
Switch palette | + | O |  |  |
Functions active at limit | - |  | O | O |
Functions active/inactive at limit | - |  | O | O |
Functions inactive at limit | - |  | O | O |
Open Help | + | O |  |  |
Reload project online | + | O |  |  |
Determine open maintenances | - |  | O |  |
PFS - execute user-defined event | + | O |  |  |
Activate/deactivate project simulation | - | O |  |  |
Simulate right click | + | O |  |  |
Save remanent data | + | O |  |  |
Exit Runtime | + | O |  |  |
Analyze S7 Graph heuristics | + | O |  |  |
Execute SAP function | + | O |  |  |
Language switch | + | O |  |  |
Topology - Search for ground fault | - |  | O |  |
Topology - LoadShedding | - |  | O |  |
Historian |  |  |  |  |
Archive: Stop | - |  | O | O |
Index archive | - |  | O |  |
Archive: Start | - |  | O | O |
Export archives | - | O |  |  |
Display open archives | - |  | O | O |
User administration |  |  |  |  |
Change user | + | O |  |  |
Login with dialog | + | O |  |  |
Login without password | + | O |  |  |
Logout | + | O |  |  |
Change password | - | O |  |  |
Screens |  |  |  |  |
Change ALC source color | + | O |  |  |
Indexed screen | - | O |  |  |
Close screen | + | O |  |  |
Screen: Return to last | - | O |  |  |
Screen: Move center | + | O |  |  |
Screen switch | + | O |  |  |
Activate input to the element with the focus | + | O |  |  |
Set focus to frame | + | O |  |  |
Move focus | - | O |  |  |
Take focus away from frame | + | O |  |  |
Show menu | + | O |  |  |
Monitor assign | + | O |  |  |
Runtime profiles | + | O |  |  |
Close frame | + | O |  |  |
Setpoint input for keyboard screen | - | O |  |  |
Displaying the overview window | + | O |  |  |
Fault locating in electric grids |  |  |  |  |
Acknowledge ground fault message | + | O |  |  |
Stop search for ground fault | + | O |  |  |
Start search for ground fault | + | O |  |  |
Acknowledge short-circuit message | + | O |  |  |
Message Control |  |  |  |  |
Save current queue | - |  | O |
Suppress groups/classes/areas/equipment | - |  | O |  |
Send a Message | - |  | O |  |
Send Message: activate | - |  | O |  |
Send Message: deactivate | - |  | O |  |
Network |  |  |  |  |
Authorization in network | + | O |  |  |
Redundancy switch | - |  |  | O |
Report Generator |  |  |  |  |
Print report | + |  |  |  |
Report: execute | + |  |  |  |
Export Report | + |  |  |  |
Recipes |  |  |  |  |
Recipegroup Manager | - | O |  |  |
Standard recipe | - | O |  |  |
Standard recipe single directly | + | O |  |  |
Standard recipe single with dialog | - | O |  |  |
Standard recipe single with online dialog | - | O |  |  |
Script |  |  |  |  |
Script: execute | + | O |  |  |
Script: select online | + | O |  |  |
Variable |  |  |  |  |
Export data | - |  | O |  |
Read dBase file | + | O |  |  |
Print current values | + | O |  |  |
Unit conversion | + | O |  |  |
HD administration active | - |  | O | O |
HD administration inactive | - |  | O | O |
HD administration inactive/active | - |  | O | O |
Write set value | - |  | O |  |
Driver commands | - | O |  |  |
Transfer driver simulation image to the standby | - |  |  | O |
Write time to variable | + | O |  |  |
Read time from variable | + | O |  |  |
VBA |  |  |  |  |
Open PCE editor | - |  | O |  |
Open VBA Editor | + | O |  |  |
Execute VBA macro | + | O |  |  |
Show VBA macro dialog | + | O |  |  |
VSTA |  |  |  |  |
Open VSTA editor | + | O |  |  |
Execute VSTA macro | + | O |  |  |
Show VSTA macro dialog | + | O |  |  |
Windows |  |  |  |  |
Play audio file | + | O |  |  |
File operations | + | O |  |  |
Start continuous tone | + | O |  |  |
Stop continuous tone | + | O |  |  |
Window to the background | - | O |  |  |
Window to foreground | - | O |  |  |
Print screenshot | + | O |  |  |
Start program | + | O |  |  |


AML screen switching

Manual -> Alarms administration -> Configuring alarms -> Functions -> AML screen switching

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To open an Alarm Message List filter in Runtime:

  1. Create an Alarm Message List screen
  2. create a screen switch function for this screen
  3. define the desired filter properties

In the Runtime you can modify the filter properties. Exception: In the Editor fixed time filter was defined.

Configure screen switching

To create a screen switch to a screen of type AML:

  1. in the context menu of node function select command New function
  2. click on screen switch
  3. the dialog for the screen selection will be opened
  4. select the screen of type alarm
    or create it in this dialog by clicking symbol New screen
  5. the filter is displayed with all tabs:
    • General
    • Time
    • Column settings
    • Text
    • Status
    • Project (only available in the integration project of the multi-project administration.)
    • Equipment Modeling

    If linked variables or indexes are available, the following tabs can be displayed as an option.

    • Replace links
    • Replace indices

  6. define the filters which should be pre-defined in the Runtime
  7. confirm the settings and close the dialog by clicking OK
  8. link the function with a button in order to call up the screen and to display the filter properties in the Runtime

info Information

If a screen that does not have a time filter is referenced, the time filters are deactivated.


AML screen switching filter

Manual -> Alarms administration -> Configuring alarms -> Functions -> AML screen switching -> AML screen switching filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Several filters are offered when screen switching is created for an AML screen. For details, see the Alarm configuration using filters section, in the Filters for Alarm Message List screen switching chapter.


AML filter screen switching

Manual -> Alarms administration -> Configuring alarms -> Functions -> AML filter screen switching

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To open an Alarm Message List filter screen in Runtime:

  1. Create an Alarm Message List filter screen
  2. create a screen switch function for this screen
  3. define the desired filter properties

In the Runtime the filter properties can only be controlled via the buttons defined in the screen.

Configure screen switching

To create a screen switch to a screen of type Alarm Message List Filter:

  1. in the context menu of node function select command New function
  2. click on screen switch
  3. the dialog for the screen selection will be opened
  4. select the screen of type Alarm Message List Filter
    or create it in this dialog by clicking symbol New screen
  5. the filter is displayed with all tabs:
    • Screens
    • General
    • Text
    • Time

  6. define the filters which should be pre-defined in the Runtime
  7. confirm the settings and close the dialog by clicking OK
  8. link the function with a button in order to call up the screen and to display the filter properties in the Runtime


AML filter screen switching filter

Manual -> Alarms administration -> Configuring alarms -> Functions -> AML filter screen switching -> AML filter screen switching filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Several filters are offered when screen switching is created for an AML screen. For details, see Alarm configuration using filters section, Filters for Alarm Message List filter section.


Functions for alarm administration

Manual -> Alarms administration -> Configuring alarms -> Functions -> Functions for alarm administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Different functions make it possible to handle alarms in Runtime.

To create a function for alarm administration:

  1. navigate to the Functions node
  2. select New function in the context menu or from the tool bar
  3. the dialog for selecting functions is opened
  4. navigate to the AML/CEL node

  5. select the desired function
  6. configure the function if necessary
  7. link the function to a button


Alarm/event group log in/log off

Manual -> Alarms administration -> Configuring alarms -> Functions -> Functions for alarm administration -> Alarm/event group log in/log off

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To optimize the performance of the connection, alarm/event groups that are not required can be deactivated. Their variables are then no longer required by the driver.

For this function, you must:

  1. define the action: logout or login
  2. Define the alarm/event group
    (Only one group per function can be defined)

Alarm/event group

Parameters

Description

Action

Defines action. Available actions:

  • Logout: Deactivates the alarm/event group
  • Login: Activates the alarm/event group

Alarm/event group

Selection of alarm/event group. Click the button and a dialog opens to select the group.

OK

Confirms inputs and closes dialog.

Cancel

Discards changes and closes dialog.

Help

Opens online help.

Example

An alarm group bit is created in the PLC. If this bit is set, the Alarm group active function is called via the limit administration. The variables are requested and the corresponding limits in zenon are checked. The bit can be reset in the PLC. The alarm/event group can be deactivated again above a certain limit value. On program start all limit variables are polled.


Alarms: acknowledge flashing

Manual -> Alarms administration -> Configuring alarms -> Functions -> Functions for alarm administration -> Alarms: acknowledge flashing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When flash-acknowledging in Runtime, only the flash attribute of the process variables and the flashing of all graphic elements in all screens that use this variable are reset. The entry in the alarm list is not acknowledged - except if the Flashing acknowledgement property is active.

Note: This function is not identical to the Take over flashing from limit property that is defined for each element in the Take over flashing from limit group of the element properties. The function relates to the flashing of the element content, for example text. The Take over flashing from limit property relates to the whole element.

Configuring functions

To acknowledge the flashing of alarms in Runtime:

  1. Create a new function
  2. in group AML and CEL select the function Alarms: acknowledge flashing
  3. select the frame you wish to assign
  4. Select the desired monitor for multi-monitor systems

Alarms: acknowledge flashing

Parameters

Description

Alarms: acknowledge flashing

Configuration of which alarms are to be flash-acknowledged.

All alarms in the frame

All alarms on screens of a frame with the selected name are flash acknowledged, even if it is open several times.

Click on the ... button to open the dialog to select a frame. For details, see the Frame selection dialog section.

All alarms in the calling frame

The alarms on the screen of the calling frame are flash-acknowledged. With this option selected, the monitor selection cannot be configured manually.

Monitor selection

Parameters

Description

Monitor selection

Configuration of the monitor for which flash acknowledgment of the alarms is to be configured.

Monitor

Selection of the monitor from the list.

  • All monitors
  • Current monitor
  • Selection of a virtual monitor

Only available for Multi-monitor systems and only for the All alarms in the frame option.

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Help

Opens online help.


Frame selection dialog

Manual -> Alarms administration -> Configuring alarms -> Functions -> Functions for alarm administration -> Alarms: acknowledge flashing -> Frame selection dialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Frame selection dialog

In the frame selection dialog, frames can be selected for the execution of functions, from:

  • Current project
  • Subprojects
  • All projects in the workspace with the Keep project in memory option active

Parameters | Description
Project tree window | Displays all projects in the workspace. Frames can be selected from the current project and from all projects with the Keep project in memory option active
Frames window | Selection of a frame. If several frames are selected, the frame at the top of the list is used to execute the function.
No selection | Removes selection and closes dialog.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Examples of alarm acknowledgment in Runtime

Manual -> Alarms administration -> Configuring alarms -> Functions -> Functions for alarm administration -> Alarms: acknowledge flashing -> Examples of alarm acknowledgment in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Examples of alarm acknowledgment in Runtime

Example 1

The following were configured:

  • Frame_1 (red) with the variables Var_1, Var_2 and Var_3
  • Frame_2 (green) with the variables Var_1 and Var_2

Initial situation:

  • Frame_1 is switched to Monitor_1.
  • Frame_2 is switched to Monitor_2.
  • All three variables flash due to a limit value being breached.

Reactions to the execution of the Flash-acknowledge alarms function:

  • Execution on Frame_2 on Monitor_1: Nothing happens, because this frame is not present on Monitor_1.
  • Execution on all monitors or on Monitor_2: All variables of the frame are flash-acknowledged.
    This means: Var_1 and Var_2 are flash-acknowledged. Var_3 continues to flash

Example 2

There is Button_1 on Frame_1. This flash-acknowledges the calling frame. If this button is pressed, Var_1, Var_2 and Var_3 are flash-acknowledged.

Example 3

Initial situation:

  • Frame_1 (red) is switched to Monitor_1 4 times. This frame contains certain variables. However it contains other variables in each frame due to substitution. The only common one is Var_1.
  • Frame_2 (blue) is switched to Monitor_2. This frame contains different variables to Frame_1.

Reactions to the execution of the Flash-acknowledge alarms function:

If Frame_1 is now flash-acknowledged on this monitor - or on all monitors - then:

  • The command is flash-acknowledged on all frames on this monitor
  • And thus on all variables of Frame_1

    This means:

    • Var_1 to Var_5 are flash acknowledged
    • Var_7 to Var_9 continue to flash


Alarms: delete

Manual -> Alarms administration -> Configuring alarms -> Functions -> Functions for alarm administration -> Alarms: delete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To delete alarms collectively using filter criteria, use the Delete alarms function:

  1. Create a new function
  2. Select Delete alarms.
  3. The dialog to select the filter criteria opens
    (similar to filter criteria in screen switching)

  4. define the criteria for:
    • General
    • Time
    • Text
    • Status
  5. link the function to a button

User authorization

The functions Acknowledge alarms and Delete alarms can be assigned to a user group via Function authorization. Only authorized user can acknowledge and delete alarms.

In addition, an additional operating right can be set via the To delete property in the respective subgroup of the Limits group. Selected alarms can only be removed from the Alarm Message List by users with the necessary rights.

If the To delete property is set, alarms are then only removed from the list of active alarms if they are deleted. Acknowledgment alone is not sufficient.

info Information

Alarms can only be deleted, if they have been acknowledged before.


Acknowledge alarms

Manual -> Alarms administration -> Configuring alarms -> Functions -> Functions for alarm administration -> Acknowledge alarms

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function, you acknowledge Runtime alarms from the Alarm Message List. Most importantly, global acknowledgment is possible with this.

When executing this function in Runtime, the flashing attribute of the variables and therefore screen alarming (only SICAM 230) will also be reset. The selected alarms are acknowledged.

For transfer parameters see chapter Alarm engineering with filters.

To acknowledge alarms with this function:

  1. Create a new function
  2. Select acknowledge alarms.
  3. The dialog to select the filter criteria opens
    (similar to filter criteria in screen switching)

  4. define the criteria for:
    • General
    • Time
    • Text
    • Status
  5. link the function to a button

User authorization

The functions Acknowledge alarms and Delete alarms can be assigned to a user group via Function authorization. Only authorized user can acknowledge and delete alarms.

In addition, an additional operating right can be set via the To delete property in the respective subgroup of the Limits group. Selected alarms can only be removed from the Alarm Message List by users with the necessary rights.

If the To delete property is set, alarms are then only removed from the list of active alarms if they are deleted. Acknowledgment alone is not sufficient.

info Information

Alarms can only be deleted, if they have been acknowledged before.


Alarm Message List active

Manual -> Alarms administration -> Configuring alarms -> Functions -> Functions for alarm administration -> Alarm Message List active

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function switches the status of the Alarm Message List in Runtime to active when selected.


Alarm Message List active/inactive

Manual -> Alarms administration -> Configuring alarms -> Functions -> Functions for alarm administration -> Alarm Message List active/inactive

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function switches the status of the Alarm Message List in Runtime between active and inactive when selected.


Alarm Message List inactive

Manual -> Alarms administration -> Configuring alarms -> Functions -> Functions for alarm administration -> Alarm Message List inactive

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function switches the status of the Alarm Message List in Runtime to inactive when selected.


Activate/deactivate Alarm Message List, alarm/event groups/classes

Manual -> Alarms administration -> Configuring alarms -> Functions -> Functions for alarm administration -> Activate/deactivate Alarm Message List, alarm/event groups/classes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The function makes it possible to activate or deactivate alarms of a certain group or class or all alarms of the AML or to switch between these two states.

To activate or deactivate alarms:

  1. Create a new function
  2. Select Alarm message list, Activate/deactivate alarm/event groups/classes
  3. The dialog to select alarms opens
  4. Define the criteria for the function
  5. link the function to a button

Select

Parameters | Description
Select | Selection of the alarms.
Whole alarm message list | Function applies for the whole alarm message list.
Alarms of the alarm/event group | Function applies for a certain group. Selection: Clicking on the button opens a drop-down list.
Alarms of the alarm/event class | Function applies for a certain class. Selection: Clicking on the button opens a drop-down list.

activate/deactivate

Parameters | Description
activate/deactivate | Action of the function.
Activate | Activates selected element.
deactivate | Deactivates selected element.
toggle | Switches status (active/inactive).


Export AML

Manual -> Alarms administration -> Configuring alarms -> Functions -> Functions for alarm administration -> Export AML

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function, you can export the alarms saved with filter conditions to a file or database in Runtime.

To export alarms:

  1. Create a new function.
  2. Select Export AML.
  3. The dialog for selecting filter criteria opens.

  4. Define the criteria for:
    • Export format
    • General
    • Time
    • Text
    • Status
    • Equipment Modeling
    • Project
  5. Link the function to a button.


Export format

Export format

Exports can be carried out in different formats. Which columns are exported, and how, depends on the source (AML/CEL) and the export format:

Data is exported in different ways for:

  • CSV
  • dBase
  • SQL
  • XML

info Information

The export to SQL is incremental. If there is already exported data, only new and amended data is exported.

Column selection

The selection of the columns to be exported depends on the export format:

  • CSV, DBF and XML: Selection using the dialog of the Column settings AML project property for the AML and Column settings CEL for the CEL.
  • SQL: Fixed settings for the incremental export, which cannot be configured further.
    Note: The RESLABEL column for the Resources label was added in version 7.20. Export tables that already exist can thus no longer be used. The table must be renamed for correct export.

Configure export

Export format

Parameters

Description

Export format

Selection of the file type. Possible formats:

  • dBase: DBaseIV format (*.dbf):
  • CSV
  • XML
  • SQL

Notes on dBase:

  • Filenames cannot be longer than eight characters.
  • Configured column width is used for export. If, for example, a value of 40 is set under Column settings, a maximum of 40 characters is then exported.
  • A maximum of 255 characters are exported.

Options

Parameters | Description
Options |
Export as unicode | An export to ASCII format is performed in Unicode
Incremental export | Only differences since the last backup are exported.

Export to file

Parameters

Description

Export to file

Determining the file in which the export is saved.

File name

Define file name individually.

A maximum of 32 alphanumeric characters including file suffix.

Note: Existing files with the same names are overwritten.

Generate file name automatically

Active: The file name will be generated automatically from a short identifier, a date key and an individual postfix.
Inactive: The file name is entered by the user under Filename.

(existing files are not overwritten)

For details, see the next table: Coding name for automatic naming

Postfix

Free, individual identification. Only available for Generate filename automatically.

Possible entries:

  • dBase: 1 alphanumeric character
  • ASCII and XML: 32 alphanumeric characters

Example

Display of the complete file name with automatic generation.

Set export folder

Display of the current export path configured in Project Properties. (Runtime folder property in the General/Name/Folder node.)

Export to SQL database

Parameters for export into a SQL database

Database connection

Configuration of the database connection. A click on the ... button opens the configuration dialog.

Table

Selection of the table that is to be written in.

Coding name for automatic naming

Name

AJJMMTTP.XXX

A

Short identification of the Alarm Message List

JJMMTT

Date input:

  • YY: Year, two-digits
  • MM: Month, two-digits
  • DD: Day, two-digits

P

Free, individual identification:

  • dBase: 1 alphanumeric character
  • ASCII and XML: 32 alphanumeric characters

XXX

File ending:

  • DBF: dBase
  • TXT: CSV
  • XML: XML

Formal matters

  • Format of the line entries: Is taken from the settings of the Column settings AML and Column settings CEL property.
  • Column separator: Semi-colon (;)

attention Attention

Milliseconds for printing or export

If, when printing or exporting the AML or CEL to CSV, XML or dBase format, the time in milliseconds is to be given, this property must be activated in the dialog for the column settings. To do this:

  • Navigate to the Alarm Message List or Chronological Event List nodes in properties.
  • Click on the ... button of the Column settings AML or Column settings CEL property.
  • The dialog for the column settings is opened.
  • Activate the checkbox in front of the Milliseconds property.

The additional setting must be made for both AML and CEL.

Notes SQL

attention Attention

Ensure that the provider configured in the connection is also available on the Runtime computer in Runtime.

Note: An SQL client is also installed with the zenon Editor. Because the zenon Runtime does not need an SQL Server, no SQL client is automatically installed. This can be downloaded from the Microsoft website and must be installed individually.

Ensure you install the correct version when installing the provider. This must suit the zenon version being used. This means: If a 32-bit zenon Runtime is used, the provider must be a 32-bit version. This also applies if it is installed on a 64-bit operating system and also if the database itself is a 64-bit application.

attention Attention

When using Native Client 10 and 11, the password is not automatically carried over to the provider string. It must be entered manually

e.g.: ...;User ID=sqlExampleUser1;Password=secretPassword;...


CSV: Exported columns

CSV: Exported columns

Export to CSV is mostly for further processing in other applications. The data is exported according to the selection in Column settings AML or Column settings CEL:

  • Only data from the selected columns is exported.
  • The sequence in the export file corresponds to the one defined in the dialog.
  • Separator: Semi-colon (;)
  • Column titles are not exported.


dBase: Exported columns

dBase: Exported columns

For export in to a dBase file, the data is exported in accordance with the selection in Column settings AML or Column settings CEL:

  • Only data from the selected columns is exported.
  • The sequence in the export file is defined and cannot be changed.

Columns in exported sequence:

Column | Type | Size | Description
DATUM_KOMM | Date | 8 | Alarm occurred: Date.
ZEIT_KOMMT | Character | 10 | Alarm occurred: Time.
MILLI_KOMM | Numeric | 3 | Alarm occurred: Milliseconds.
DATUM_GEHT | Date | 8 | Alarm ended: Date.
ZEIT_GEHT | Character | 10 | Alarm ended: Time.
MILLI_GEHT | Numeric | 3 | Alarm ended: Milliseconds.
DATUM_OK | Date | 8 | Alarm acknowledged: Date.
ZEIT_OK | Character | 10 | Alarm acknowledged: Time.
ALARMTEXT | Character | 40 | Limit value text.
TAG_NR | Character | 40 | Variable identification.
KOMMENTAR | Character | 45 | Comment.
STATUS | Character | 4 | Status of variable.
DATUM_REA | Date | 8 | Alarm reactivated: Date.
ZEIT_REA | Character | 10 | Alarm reactivated: Time.
MILLI_REA | Character | 3 | Alarm reactivated: Milliseconds
ANZ_REA | Character | 3 | Alarm reactivated: Meter.
STAT_REA | Character | 1 | Alarm reactivated: Variable status.
WERT | Character | 10 | Variable value.
USER | Character | 6 | User identification.
COMPUTER | Character | 48 | Computer name.
VAR_NAME | Character | 32 | Variable name.
RESLABEL | Character | 15 | Resources label.
PROJ_NAME | Character | 31 | Project name
CLASS | Character | 31 | Name of the alarm class.
GROUP | Character | 31 | Name of the alarm group.


SQL: Exported columns

SQL: Exported columns

For SQL export, the files are exported incrementally in a fixed, pre-defined sequence.

Columns in exported sequence:

Column | Type | Description
[VAR] | varchar(128) | Variable name.
[TAG] | varchar(128) | Variable identification.
[RESLABEL] | varchar(128) | Resources label.
[TEXT] | varchar(1024) | Limit value text.
[COMES_S] | int | Alarm occurred in Unix time (seconds since 01. 01. 1970).
[COMES_MS] | int | Alarm occurred: Fraction of a millisecond.
[GOES_S] | int | Alarm ended in Unix time (seconds since 01. 01. 1970).
[GOES_MS] | int | Alarm ended: Milliseconds
[QUIT] | int | Alarm acknowledged in Unix time (seconds since 01. 01. 1970).
[STATUS] | int | Status of variable.
[VALUE] | varchar(128) | Variable value.
[USERID] | varchar(128) | User identification.
[COMP] | varchar(128) | Computer name.
[REACT_S] | int | Alarm reactivated in Unix time (seconds since 01. 01. 1970).
[REACT_MS] | int | Alarm reactivated: Milliseconds
[REACT_COUNT] | int | Alarm reactivated: Meter.
[REACT_STAT] | int | Alarm reactivated: Variable status.
[ACT_TEXT] | varchar(128) | Alarm: Comment.
[PRJ] | varchar(128) | Project name.
[CLASS] | varchar(128) | Name of the alarm class.
[GROUP] | varchar(128) | Name of the alarm group.
[LASTING_S] | int | Alarm active in seconds.
[LASTING_MS] | int | Alarm active: Milliseconds.
[CLASS_NR] | int | Alarm Classes ID.
[GROUP_NR] | int | Alarm groups ID.
[USERNAME] | varchar(128) | User name.


XML: Exported columns

XML: Exported columns

When exporting to an XML file, the data is exported in accordance with the selection in Column settings AML or Column settings CEL:

  • Only data from the selected columns is exported.
  • The sequence in the export file corresponds to the one defined in the dialog.
  • Column titles are used as tags. All characters that are not permitted are removed and replaced in the process.
    Rules for replacement:
    • Space: Underscore (_).
    • Other non-permitted characters: Hyphen (-).


Save AML and CEL memory buffer

Manual -> Alarms administration -> Configuring alarms -> Functions -> Functions for alarm administration -> Save AML and CEL memory buffer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function, the content of the ring buffer for alarms and events as well as the values of mathematical variables (counters) can be saved. The entries are saved in the following files:

File | Contents | The size can be set in Properties
ALARM.BIN | Alarms | Size of the ringbuffer
CEL.BIN | Chronological Event List entries | Size of the ringbuffer
SY_MA32.BIN | Values of mathematical variables (e.g. counters) |

To save the AML ring buffer:

  1. Create a new function
  2. Select Save AML and CEL ring buffer
  3. link the function to a button


Print AML or CEL

Manual -> Alarms administration -> Configuring alarms -> Functions -> Functions for alarm administration -> Print AML or CEL

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The saved alarms and their filter conditions can be output to a printer in Runtime with this function

To configure the function:

  1. Create a new function
  2. select Print AML or CEL
  3. the dialog for selecting the list opens

  4. Select Alarm Message List
  5. the dialog for selecting filter criteria opens
  6. define the criteria for:
    • General
    • Time
    • Text
    • Status
    • Font: Selection from the fonts defined in zenon
  7. link the function to a button

info Information

In the Runtime you cannot switch between CEL and AML. To print both lists, you must engineer two functions.

Line structure

Date/Time received | Date/Time cleared | Date/Time acknowledged | Long text | Status text

The keywords available for the formatting file (ALAR.FRM for online printing and ALAR_G.FRM for offline printing) and examples of these being used can be found in the FRM configuration file chapter in the Operation in Runtime section.

The FRM file has three parts:

  • Header: at the beginning of the page
  • List part: cyclic per line
  • Footer: at the end of the page

Principles

When editing FRM files regard the following:

  • Separating the list parts:
    • Header and list part and list part and footer are seperated by %%.

      The separation marking must be used only once for the list and the footer.

    • Attention: The last line must be followed by at least two empty paragraphs. Otherwise the footer is not printed!
  • Positioning the individual entries:
    You may only use space, no tabulators.
  • Editing the FRM file in a text editor:
    Automatic line break must be deactivated otherwise undesired effects in the formatting may occur.

Keywords

The setting for the page length is made in Project Properties under AML and CEL or via the ALARM.frm or ALAR_G.frm file for the AML or BTB.frm and BTB_G.frm for the CEL.

Please keep in mind:

  • The number of the alarm entries per page results from the predetermined number of lines (e.g. Lines per page 72), less the lines used for header and footer text.
  • The Use reactivated time option must be activated in order to be able to use the keywords that evaluate the reactivation (time, number).
  • Free texts and keywords can be used in the formatting file. Key words can be used either in German or in English. The use of English key words is recommended.
  • Not every key word is suitable for every kind of printing (AML, CEL, online, offline).

The following list contains key words in English and German and their field of application.

German | English | AML offline | CEL offline | AML online | CEL online | Description
Key words for the list part
@BMKENNUNG | @RESOURCELABEL | X | X | X | X | Resources label
@DATZEITKOMMT | @DTRECEIVED | X | X | X | X | Time and Date when the alarm occurred
@DATZEITGEHT | @DTCLEARED | X | - | X | - | Time and Date when the alarm ended
@DATZEITOK | @DTACK | X | - | X | - | Time and Date when the alarm was acknowledged
@DATZEITREAKT | @DTREACTIVATE | X | - | X | - | Time and Date of reactivating: Property Use reactivated time in the project properties must be activated.
@DATZEIT | @DTLASTEVENT | - | - | X | - | Time and date of alarm received or cleared or acknowledged or reactivated
@ZEIT | @TLASTEVENT | - | - | X | X | Time of alarm received or cleared or acknowledged or reactivated
@ZEITOK | @TACK | X | - | X | - | only displays time of acknowledging
@ZTKOMMT | @TRECEIVED | X | X | X | X | only displays time of alarm received
@ZTGEHT | @TCLEARED | X | - | X | - | only displays time of end of alarm
@ZTREAKT | @TREACTIVATE | X | - | X | - | only displays time of reactivating
@TIMELASTING | @TACTIVE | X | - | X | - | Time active (difference time received - time cleared)
@ANWENDUNG | @PROJECTNAME | X | X | X | X | Project name
@KANALNAME | @VARNAME | X | X | X | X | Variable name CEL: Only entries with variables
@AK | @ACLASSNR | X | X | X | X | Alarm/event class name
@AG | @AGROUPNR | X | X | X | X | Alarm/event group number
@AGNAME | @AGROUPNAME | X | X | X | X | Name of alarm/event group
@AKNAME | ACLASSNAME | X | X | X | X | Name of alarm/event class
@TAGNR | @IDENTIFICATION | X | X | X | X | Identification (company-specific label)
@AMELDUNG | @TEXT | X | X | X | X | Alarm message text
@REAKTANZ | @NRREACTIVATE | X | - | X | - | Number of reactivations
@STATUS | @STATUS | X | X | X | X | Status information as in Alarm Message List
@WERT | @VALUE | X | X | X | X | Variable value of alarm
@REAKTIONSTEXT | @COMMENT | X | X | X | X | Commentary from the Alarm Message List. If you use dynamic limit texts, this is only available if properties Long dynamic limit texts AML or Long dynamic limit texts CEL are activated.
@USER | @USERID | X | X | X | X | AML: User who acknowledged alarm.
@RECHNER | @COMPUTER | X | X | X | X | AML: Computer on which alarm was acknowledged.
Key words for header and footer
@ANWENDUNG | @PROJECTNAME | X | X | X | X | Project name
@SEITE | @PAGE | X | X | X | X | Page number
@HEADDATZEIT | @DTSYSTEM | X | X | X | X | System date and system time
@HEADDATUM | @DSYSTEM | X | X | X | X | System date
@HEADZEIT | @TSYSTEM | X | X | X | X | System time
@USER | @USERID | X | X | X | X | User who prints
@USERNAME | @USERNAME | X | X | X | X | Full user name who triggered action
@RECHNER | @COMPUTER | X | X | X | X | Computer from which it is printed
[Text] | [Text] |  |  |  |  | Random text

attention Attention

Between the key words there must be enough space so that entries are not overwritten. In doing so, you make sure that long limit texts are also displayed correctly.

Example:

@TEXT (spaces up to here)

Setting milliseconds

attention Attention

Milliseconds for printing or export

If, when printing or exporting the AML or CEL to CSV, XML or dBase format, the time in milliseconds is to be given, this property must be activated in the dialog for the column settings. To do this:

  • Navigate to the Alarm Message List or Chronological Event List nodes in properties.
  • Click on the ... button of the Column settings AML or Column settings CEL property.
  • The dialog for the column settings is opened.
  • Activate the checkbox in front of the Milliseconds property.

The additional setting must be made for both AML and CEL.


Switch online printing on/off

Manual -> Alarms administration -> Configuring alarms -> Functions -> Functions for alarm administration -> Switch online printing on/off

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Online printing is set to a status when this function is used:

  • on: Switches online printing on
  • off: Switches online printing off
  • active/inactive: Switches online printing

To configure the function:

  1. Create a new function
  2. Select Switch online printing on/off
  3. the dialog for selecting the action opens

  4. select the desired action
  5. link the function to a button


Online printing start new page

Manual -> Alarms administration -> Configuring alarms -> Functions -> Functions for alarm administration -> Online printing start new page

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function, you control the form feed in Runtime when printing online:

The configured footer will be printed onto the current page of the printout, and then the printout will advance to the beginning of a new page. The page counter will be reset to 1 and the header will be printed out.

To configure the function:

  1. Create a new function
  2. Select Start online printing on a new page
  3. link the function to a button


Switch online printer

Manual -> Alarms administration -> Configuring alarms -> Functions -> Functions for alarm administration -> Switch online printer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function, the printer for online printing can be changed in Runtime.

To configure the function:

  1. Create a new function
  2. Select Switch online printer
  3. The dialog for selection of the user opens
  4. Select the desired screen printer from the drop-down list
  5. link the function to a button

Parameters | Description
select printer | Selection of the desired printer from the drop-down list.
Show this dialog in the Runtime | Active: When this function is executed, the dialog is opened and the printer can be defined in Runtime.


Operating during Runtime

Manual -> Alarms administration -> Operating during Runtime

The Alarm Message List is called up in Runtime via a screen switching function.

The available control elements and the look are engineered in the Editor.

Control element

Description

Window

Display in Runtime
  • Alarm Message List

Display of the alarms. The appearance is configurable. Columns are defined via the Column settings filter in screen switching or via the Column settings AML property in the Alarm Message List group.
  • Set filter

Display of the currently-selected filter conditions.
  • Status

Display if Alarm Message List is active or not (Project property Alarm Message List active).
  • Total number

Time number of all alarms.
  • Number of unacknowledged

Displays number of unacknowledged alarms.

List functions

Buttons to control the lists.
  • Filter

Opens dialogs for filter selection.
  • Stop/Continue

Switch for filling the list:

Stop: New elements are no longer added automatically.

Next: New elements are added automatically.

Attention: The font of the button can be changed in the editor but is not carried over to Runtime. You can configure changes to the font using Language switching. Deletes alarm from the Alarm Message List in Runtime. Alarm must already be acknowledged.
  • Print

Prints filtered list.
  • Print with dialog

Opens printer settings before printing.

Alarm functions

Buttons for acknowledging and deleting alarms.
  • Acknowledge

Acknowledging alarm messages in Runtime.
  • Acknowledging page

All alarms displayed on the current page are acknowledged.
  • Acknowl. All

All alarms for the current filter criteria are acknowledged

Note for multi-user project: Alarms are only acknowledged for projects for which the user has authorizations. (for details on multi-user projects, see Distributed engineering chapter)

  • Visual acknowledgment

The selected alarms are visually acknowledged.

  • Visual acknowledgment and acknowledgment

The selected alarms are first visually acknowledged and then acknowledged.

  • Delete

Deletes alarm from the Alarm Message List in Runtime. Alarm must already be acknowledged.
  • Delete page

Deletes all acknowledged alarms that are displayed on the current page.
  • Delete all

Deletes all acknowledged alarms that correspond to the current filter criteria.

  • Close frame

Closes Alarm Message List
  • Linked function (display)

Displays the message allocated to the alarm message.
  • Execute function

Executes the functions configured for the alarm in Runtime.

Note: With the Start program function, the variable name of the selected alarm can be transferred as a parameter for the program to be started using the key word @alarm.name.
  • Open Help

Calls up configured Help.
  • Display

Status and elements of alarm administration.
  • Comment field

Input of free text (comment) by the user for the selected alarm. This text can be displayed in the list (Comment option in the Column settings of alarm administration.)

Navigation

Controls elements of the list.
  • Line up

Scrolls one line up.
  • Line down

Scrolls one line down.
  • Column right

Scrolls one column to the right.
  • Column left

Scrolls one column to the left.
  • Page up

Scrolls one page up.
  • Page down

Scrolls one page down.
  • Page right

Scrolls one page to the right.
  • Page left

Scrolls one page to the left.

Filter profiles

Buttons for filter settings in Runtime.

  • Profile selection

Select profile from list.
  • Save

Saves current setting as a profile.
  • Delete

Deletes selected profile.
  • Import

Imports filter profiles from export file.
  • Export

Exports filter profiles in the file.

configuration of the display

You configure which information is displayed in the alarm status line and Alarm Message List using the alarm configuration column setting. You can reach the column setting via:

  • Project settings -> Alarm Message List -> Column settings AML (only tab Column settings )

    or

  • Function screen switch to a screen of type AML (all tabs)

Display in the value column

Only values of numeric data types can be displayed in the Value column. The column remains empty for entries with a String data type.

Functions for limits as alarm

When Runtime starts, a check is made to see if the alarm for the limit value has already occurred before Runtime was ended. If this is the case, the linked function is not carried out again.
Note: If the limit is not an alarm, execution of the limit value function when Runtime starts may be influenced by the Execute limit value function at RT start project setting in the Functions group. This setting is only influences limits that are not alarms.


Alarm status line

Manual -> Alarms administration -> Operating during Runtime -> Alarm status line

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Alarms: Status messages in red status line

The alarm status line displays alarms that cannot be acknowledged in Runtime as a red line with black text. It contains information on the variables to be triggered and the time. The alarm status line is defined as the uppermost Windows window and thus covers all zenon screens, as well as all other applications.

Alarms are acknowledged by double-clicking the right mouse button.

The appearance of the alarm status line can be amended in the project properties. The alarm status line can be covered by a further status line (blue as standard), by informing users of the number of alarms or the overrunning of the buffer.

Warnings: Warning notices in the blue status line

You can define three status messages to inform the user that the number of alarms has exceeded a certain number, or that the ring buffer of the alarm information list is going to overflow soon. These are displayed in white text with a blue background by default. The appearance can be amended in the project properties.
The status messages cover the red alarm status line as long as they are not acknowledged. You can acknowledge them by double-clicking them with the right mouse button. For that, the user must be in the according authorization group. These can be set in the user administration using the function authorizations.

The following applies for opening up the alarm status line:

  • The blue line has higher priority for the display than the red alarm status line.
  • The blue line only reacts to the total number of entries in the list
  • The maximums for the overall number of entries in the list can be defined using the properties of the Alarm status line group.
    • Message 1 number of alarms
    • Message 2 number of alarms
    • Message 3 number of alarms

    Each maximum can be allocated a message that is displayed from the bottom when it is exceeded.

  • The highest possible maximum is active at any time.
  • The blue line can only be deactivated with a right mouse click. In doing so, the adjacent maximum is only then triggered if it has been explicitly reached.
  • A deactivated maximum is only then reactivated again when it is exceeded again.

Configuring the alarm status line

To display the alarm status line in Runtime, activate the Status line active property in the Alarm Message List group in product properties.

The actions of the alarm status line in Runtime and the font to be used are defined in project properties of the Alarm status line in the Alarm Message List group:

  • display next: defines the alarm status line as a ring. The Size of the ringbuffer property is used as a ring size. If this property is deactivated, the alarm status line always contains only one alarm.
  • Display: defines if the oldest filter or the most recent alarm is displayed. The selection is made form the drop-down list.
    • oldest alarm: FIFO buffer
    • Most recent alarm: LIFO buffer

attention Attention

Behavior in multi-project administration:

The setting in the integration project defines the behavior for sub-projects, regardless of the setting of the sub-projects.

  • If the alarm status line is deactivated in a subproject, but not in the integration as a start project, the alarm status line nevertheless continues to be displayed.
  • If the alarm status line is activated in the superordinate project then it is also displayed in the sub-project, even if it has been deactivated here.
  • The alarm status line of the uppermost project is always used in Runtime.

Positioning

By default, the alarm status line is displayed on the top border of the screen (height=18 pixels with standard font). You can change its size and position in the frames. In order to do this, select the alarm status bar and deactivated option Use standard position. After that you can position the alarm status bar - in the same way as a frame - anywhere on the screen.
For multi-project administration, the alarm status line of the integration project determines the position. The settings of the subprojects are ignored.

Colors for alarm status line

The colors of the alarm status line can be amended using the properties of the Alarm status line group.

For Alarms:

  • Text color
  • Background color

For warnings of exceeding the defined number of alarms or the ring buffer exceeding capacity:

  • Message 1 text color
  • Message 1 background color
  • Message 2 text color
  • Message 2 background color
  • Message 3 text color
  • Message 3 background color


Alarm Message List

Manual -> Alarms administration -> Operating during Runtime -> Alarm Message List

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The alarm information list shows alarm messages line by line during runtime. Lines with unacknowledged alarms can be displayed as flashing.

To create and display the AML, activate the Alarm Message List active property in the Alarm Message List group. You can configure the display format in the filter of the screen switch function in the Column settings tab.

Alarms are saved in a ring buffer (alarm.bin) and in an alarm file (*.aml) in the Runtime folder as soon as they occur.

Ring buffer

The ring buffer includes all active alarms. At this the following things are managed:

  • Time received in millisecond as unique signature
  • additional information such as cause, value, etc.
  • Time cleared
  • Time acknowledged

When acknowledging alarms, all alarms of a variable with the same limit violation are deleted at the same time from the ring buffer.

As soon as the alarm is acknowledged, it is deleted from the ring buffer. Exception: If property To delete is set, the alarm must be deleted by the user decidedly.

Size of the ringbuffer

The size of the ring buffer must be set to an appropriated size in the project properties via property Size of the ringbuffer.
Recommended: At least number of variables for which alarms can occur.

The ring buffer is automatically saved as file alarm.bin when the Runtime is closed. If the Runtime is closed due to an unexpected event, e.g. power outage, data will be lost. To prevent this the ring buffer can be saved manually via property Save ringbuffer on change at every new entry or via function Save AML and CEL ring buffer.

Attention: In the Runtime the ring buffer is handled dynamically in the memory. Via the defined number of alarms, even alarms which do not have a cleared time stamp can be displayed. Thus alarms are displayed which exceed the size of the ring buffer.

Example Example
  • Size of the ring buffer: 100 entries
  • Active alarms in the Runtime without cleared time stamp: 120
  • Display in the AML in the Runtime: 120

Alarm file

All alarms are written in an alarm file (*.aml) at the same time as in the ring buffer. This file is created for every calendar day automatically and is managed via property Save AML data. The name of the alarm file is put together by the letter A, followed by the date in form JJMMDD and the suffix .aml; e.g. A100623.aml. These files are created automatically for every day and must be evecuated or deleted by the user if the storage space is limited. *.aml files are saved in the ...\Projektordner\Computername\Projektname folder.

Synchronizing ring buffer and alarm file

Ring buffer and alarm file are synchronized. This synchronization ensues from the ring buffer to the alarm file. All changes such as acknowledging are only carried out in the ring buffer and are then synchronized with the alarm file. Thus for example all unacknowledged alarms can be displayed in the alarm file and the acknowledge can be induced. The action however is taking place in the ring buffer.

Saving periods

The alarm file *.aml is saved each time a new entry is made.

The ring buffer (*.bin) is saved:

  • when the Runtime is closed
  • after every new entry if property Save ringbuffer on change is active
  • when function Save AML and CEL memory buffer is carried out

Note: If option Save ringbuffer on change is deactivated, it is possible that the entries in the AML and in the ring buffer do not match after a power outage.

attention Attention

If the ring buffer overflows because it is too small, unacknowledged entries remain in the alarm file. They are displayed during filtering but they cannot be acknowledged anymore. The attempt to acknowledge them can trigger the acknowledgment on the ring buffer if the alarms concern the same variable and the same limit violation.

AML in Runtime

Alarms in the Alarm Message List can have three states:

  • Not cleared
  • Not acknowledged
  • Not deleted

Alarms can require acknowledgment and/or require deletion.

Acknowledgment resets the flashing attribute of the variables. The deletion of an entry can only be made with a prior acknowledgment of a gone alarm event. Configuration of the acknowledgment and/or requirements for deletion is carried out via the To acknowledge and To deleteproperties in the Limits/AML/CEL nodes of variable configuration

Example for the structure of the alarm information list in the runtime:

Variable | Date/Time received | Date/Time goes | Date/Time acknowledged | Information text
Motor1_failure | 20.06.2011 1:00:04 PM | 20.06.2011 1:05:35 PM | 20.06.2011 1:05:40 PM | Motor's protective relay activated

Each row can be acknowledged by double-clicking it with the right mouse button. For that, the user must be in the according authorization group.

When the Alarm Message List is opened, the status of the alarm management is shown in the upper left corner (active or inactive).

info Information

The variables for not acknowledged alarms, acknowledged alarms and number of alarms is stored in a local list in the memory.

See variable 'Not acknowledged alarms' in the chapter Definition of the alarm and CEL filters.


Display unacknowledged alarms as flashing

Manual -> Alarms administration -> Operating during Runtime -> Alarm Message List -> Display unacknowledged alarms as flashing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Unacknowledged alarms can be displayed as flashing in the AML.

With the Unacknowledged alarms flash property active, the foreground color and background color alternate in all unacknowledged and unselected lines in the Alarm Message List every second. Selected lines do not flash.

To do this:

  1. In the Editor, navigate to the Alarm Message List section in Project Properties.
  2. Activate the checkbox in front of the Unacknowledged alarms flash property.
  3. Configure the desired colors (foreground) for Alarm received, Alarm cleared, Alarm acknowledged

    Hint: Set the Alarm/event class color property to as line background. The color of the alarm class is then used as a background color.


Acknowledge alarms

Manual -> Alarms administration -> Operating during Runtime -> Acknowledge alarms

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For the information "acknowledged" to be displayed in the AML, the following must apply:

  1. The To acknowledge property must be activated for the variables
  2. the alarm must be acknowledged

Alarms can be acknowledged via:

  • double right-click on the alarm status bar
  • double right-click on an entry in the Alarm Message List
  • Function Acknowledge alarms
  • Acknowledge button and Visual acknowledge and acknowledge in the Alarm Message List

When acknowledging an alarm:

  • All alarms of a variable with the same limit are acknowledged together.
  • Name and ID of the user who deletes the alarm are written in the Alarm Message List
  • the name of the computer from which the alarm was acknowledged is written in the Alarm Message List
  • acknowledging the alarm can be written in the Chronological Event List additionally

Alarms are saved in the ring buffer up to when they are acknowledged. At the same time they are written to a filterable alarm file (*.aml) and kept synchronized.

Attention: The Size of the ringbuffer property must be chosen appropriately. If alarms are no longer saved in the ring buffer due to a buffer overflow, unacknowledged alarms remain in the alarm file. For details see chapter Alarm Message List (AML).

info Information

If alarms require a comment, these can only be acknowledged if a comment was entered. The user must be authorized to carry out the necessary function.

Function Acknowledge alarms

The acknowledge alarm function makes it possible to

  • acknowledge alarms from the AML using a function call
  • global acknowledgment

When using this function in Runtime, the flashing attribute of the variables and therefore screen alarming (only SICAM 230) will also be reset. The selected alarms are acknowledged. For details, see Acknowledging alarms chapter.

User authorization

The functions Acknowledge alarms and Delete alarms can be assigned to a user group via Function authorization. Only authorized user can acknowledge and delete alarms.

In addition, an additional operating right can be set via the To delete property in the respective subgroup of the Limits group. Selected alarms can only be removed from the Alarm Message List by users with the necessary rights.

If the To delete property is set, alarms are then only removed from the list of active alarms if they are deleted. Acknowledgment alone is not sufficient.

info Information

Alarms can only be deleted, if they have been acknowledged before.


Required comments for acknowledgement

Manual -> Alarms administration -> Operating during Runtime -> Acknowledge alarms -> Required comments for acknowledgement

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

It is possible to make it necessary to enter a comment for alarms that require acknowledgement before the alarm can be acknowledged. To be able to enter a comment, the user needs to enter the corresponding function authorization alarm comment.

To make an alarm require a comment, the corresponding option can be set at:

  • The configuration of the reaction matrixes
  • The Comment required property in the Limits group of the variables

Comments that require alarms can subsequently only be amended by users with the Change alarm comment function authorization. If comments are changed, an entry into the CEL is made, stating the variable name and the original and amended comment.

Alarms that require a comment are checked for comments with all acknowledgment possibilities (including VBA). The necessary authorization is also checked when changes are made. The Alarm Message List can be filtered for alarms that require a comment by means of:

  • Alarm Message List filter


Visual acknowledgment

Manual -> Alarms administration -> Operating during Runtime -> Acknowledge alarms -> Visual acknowledgment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Visual acknowledgment makes it possible for the user to confirm that they have become aware of an alarm without resetting this immediately. For example, it is possible to visually acknowledge several alarms that are unrelated to one another first, and then acknowledge them and thus reset them later.

Elements for visual acknowledgment

There are two buttons available for visual acknowledgment in AML screens:

  • Visual acknowledgment
  • Visual acknowledgment and acknowledgment

The following properties are available for variables in the Alarm handling group:

  • Acknowledgement variable
  • Visual acknowledgment variable
  • Acknowledgement value

Use visual acknowledgment

To confirm an alarm with visual acknowledgment:

  1. Configure the buttons Visual acknowledgment and Visual acknowledgment and acknowledgment in the screen.
  2. Configure the Acknowledgement variable, Visual acknowledgment variable and Acknowledgement value properties for the corresponding variables.
  3. Click on the button in Runtime
    1. Visual acknowledgment: The highlighted alarms are confirmed with visual acknowledgment. The Acknowledgement value is written to the Visual acknowledgment variable.
    2. Visual acknowledgment and acknowledgment: The highlighted alarms are only confirmed with visual acknowledgment and then acknowledged. The Acknowledgement value is written to the Visual acknowledgment variable and to the Acknowledgement variable.

info Information

Visual acknowledgment and acknowledgment need different rights. For visual acknowledgment, operating authorization and keyboard authorization in the context of the user and the interlocking are necessary. For acknowledgment, the corresponding rules including validation of the entries and rights are applicable. It is therefore possible that a user can visually acknowledge an alarm but not acknowledge it.

Visual acknowledgment is always set but only if the variable already has this value.


Alarms: acknowledge flashing

Manual -> Alarms administration -> Operating during Runtime -> Alarms: acknowledge flashing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In addition to acknowledging alarms from the alarm message list, screens with alarms can also be acknowledged by template. Flash acknowledgment is called up using the flash-acknowledge alarms function or by double clicking on the corresponding element with the right mouse button. In doing so, only the flash attribute of the variables and the flashing of all graphic elements on the screen is reset. The entries are not however acknowledged in the AML.

Flashing acknowledgment in AML

A flash-acknowledgment acknowledges the alarms in the AML if the Flashing acknowledgement option is also set in alarm administration.

Only for SICAM 230. The acknowledgment in the alarm message list or on the alarm line level at the upper screen edge also acknowledges the alarm in the screen and screen alarm guidance.

Flash-acknowledging in integration projects

If alarms are to be acknowledged in integration projects using the flash-acknowledge function, all affected screens must be opened.

If screens in superordinate and subordinate project templates have the same name, the screens in the subordinate project are not opened. If the template names are different, the screens of the sub-project in the background are opened and can be flash-acknowledged.

info Information

If flash-acknowledgment is used in the network, it is only executed locally at the respective client.


Alarms: delete

Manual -> Alarms administration -> Operating during Runtime -> Alarms: delete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following is required to delete an alarm:

  • A delete alarm function is executed
    or
  • the Delete button on the screen of the alarm message list type is pressed

Alarms can only be deleted if they have been acknowledged beforehand.

If the To delete property is set for Limits, alarms are only removed from the list of active alarms if they are deleted. Acknowledgment alone is not sufficient.

User authorization

The functions Acknowledge alarms and Delete alarms can be assigned to a user group via Function authorization. Only authorized user can acknowledge and delete alarms.

In addition, an additional operating right can be set via the To delete property in the respective subgroup of the Limits group. Selected alarms can only be removed from the Alarm Message List by users with the necessary rights.

If the To delete property is set, alarms are then only removed from the list of active alarms if they are deleted. Acknowledgment alone is not sufficient.

info Information

Alarms can only be deleted, if they have been acknowledged before.


Filtering alarms

Manual -> Alarms administration -> Operating during Runtime -> Filtering alarms

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Alarms can be displayed with a filter in Runtime using:

  • filter use in the Runtime
  • Screen switching with pre-defined filter to a screen of alarm message list type
  • Screen switching with with filter when calling up a screen of alarm message list type
  • Screen switching to a screen of alarm message list filter type

Filtering in the Runtime

Filters can be used in Runtime in screens of the alarm message list type. To filter the alarms displayed in the AML:

  1. you must have engineered button Filter
  2. click on the button
  3. The alarm message list filter dialog is opened

Set filter can be saved in profiles.

Screen switching to a screen of alarm message list type

Alarms can be displayed after pre-filtering. To do this:

  1. Configure a filter for the screen switching to an alarm message list screen function
  2. The alarm message list is displayed in a filtered state when called up
  3. if the option Display dialog in the Runtime is activated for the function, you can newly define the filter before the display
  4. in the Runtime further filter settings are possible via button filter

Screen switching to an alarm message list filter screen

In order to only offer users the filters they need in Runtime, use an alarm message list filter screen. To do this:

  1. Configure screen switching to an alarm message list filter screen
  2. Call up the AML in Runtime using this function
  3. the user has a tailor-made Alarm Message List


Filter profiles

Manual -> Alarms administration -> Operating during Runtime -> Filtering alarms -> Filter profiles

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Filter profiles are filter settings that the user can save and call up in Runtime in relation to a certain screen.

To be able to use filter profiles, the following control elements must be configured:

Control element | Description
Filter profiles | Profile administration in Runtime.
Profile selection | Selection of a saved profile in Runtime from a drop-down list.
Save | Clicking on the button in Runtime saves the filter settings as a profile.
Delete | Clicking on the (X) button in Runtime deletes the selected profile.

With this you can in the Runtime:

  • save filters
  • use saved filters
  • delete filter profiles

Filter profiles can also be exported and imported with further control elements.

Save filter profile

To create a filter profile:

  1. define filter conditions in the Runtime
  2. assign a name using property filter profiles
  3. Click on Save

Use filter profile

To use a filter profile:

  1. select a filter from the drop-down list property filter profiles
  2. the filter is immediately applied

Delete filter profile

To delete a filter profile:

  1. select a filter from the drop-down list property filter profiles
  2. click on button X
  3. the profile is deleted
  4. the deleted filter is still applied as long as a new filter is defined or selected


Use alarm message list filter

Manual -> Alarms administration -> Operating during Runtime -> Filtering alarms -> Use alarm message list filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

It is possible to adjust filter settings for the Alarm Message List in Runtime with the help of the Alarm Message List Filter screen. All filter settings that are available in the filter for the function to switch the screen to the Chronological Event List screen can be configured.

Therefore:

  • Only the filter elements that are actually required are configured and provided to the user
  • The user only has these filters displayed and has an overview
  • The appearance can be freely defined and can, for example, ensure ease of use by means of a touch screen.

Filter screens

Filter screens make it possible to transfer a preset filter from one screen to another. The filter of the source screen is set using the target screen. The screens can also be of a different screen type.

attention Attention

In order for the time to be taken from the screen to be called up in Runtime, the following time range must be selected in the Editor for the screen switching function for the Alarm Message List or the Chronological Event List in the time filter: Set filter at time filter type

Call definition

The following requirements must be met for the set filters to be used:

  1. Set filter for time filter type is selected as a time period for the time filter.
  2. The screen (Alarm Message List Filter, Chronological Event List filter or Time/Lot Filter screen) is activated using a button or a combined element. Only in this way can the relationship between filter screen and source screen be maintained.
  3. The source screen and filter screen must be configured on different frames or monitors. The filter for the filter screen can only be updated if the source screen is open. This is only possible if both screens do not use the same frame or the same monitor.
  4. The screen to be called up must be compatible with the filter screen to be called up (see table).
Source screen | AML filter | CEL filter | Time filter
Archive revision | T | T | T
Extended Trend | T | T | T
Time filter | T | T | X
Alarm Message List Filter | X | C | T
Chronological Event List Filter | C | X | T
Alarm Message List | X | C | T
Chronological Event List | C | X | T

Key:

  • C: Common settings are updated.
  • T: Time settings are updated.
  • X: All settings are updated.

info Information

No filtering

The filter screen is not filtered, but opened with the configured values, if:

  • One of the conditions 1 to 3 is not met or
  • The Screen to call up setting is not activated for the Screen switching function or
  • The screen is not called up via a screen element

In this case, the Accept, Close and Update buttons are grayed out in Runtime and have no function.

Update

When a filter screen is called up (Alarm Message List filter, Chronological Event List filter, time filter), the screens configured in the screen switching function are updated in two ways:

  • If the filter screen is called up via a screen element, the target screens on the same monitor as the source screen are updated.
  • If the filter is called up in a different way or if the Update on all monitors setting is activated, all target screens configured are updated.

They are updated as soon as you click the Accept button or as soon as you closes the filter screen with the close Close button. The Cancel button discards the changes and closes the filter screen.

Update filter settings

You update the current filter settings for the source screen using the Update button. If the filter screen is not called up by a screen element or if the Calling screen has not been activated, all monitors are searched for screens that can be used for updating. The first screen that is found is then this is used for updating.


Printing and exporting alarms

Manual -> Alarms administration -> Operating during Runtime -> Printing and exporting alarms

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

AML alarms can be documented and archived by:

  • AML Print online: each event is printed on a line printer when it is displayed in the list
  • AML offline printing: The AML is printed out as a list in its current state
  • Export contents of AML (filtered)

The print used for printouts is defined via menu File -> General configuration -> Standard.

attention Attention

A configuration file *.frm is used for the print-out:

  • online: ALARM.frm
  • offline: ALAR_G.frm.

This FRM file must be in the project tree in the File section in the Texts and formats folder.

Templates for FRM files can be found in the zenon installation folder in the FRM_QRF subfolder. These can be inserted via the file in the Texts and formats section and edited there.

You can kind the key words for FRM files in the FRM configuration file chapter.


Online printing

Manual -> Alarms administration -> Operating during Runtime -> Printing and exporting alarms -> Online printing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With online printing, any alarm that occurs is immediately sent to the printer.

Attention: The online printing takes place line by line, in accordance with the ESC/P (Epson Standard for Printers) and requires an Epson-compatible printer.

To print out alarms online:

  1. define a printer
  2. navigate to the AML and CEL node in properties
  3. Activate the property Printing active
  4. Select the Printing for property in the Alarm Message List drop-down list
  5. Define the number of lines with the Lines per page property (default: 72)
  6. Configure ALARM.frm
  7. Add ALARM.frm to the Files/texts and formats node

Control print and printer in the Runtime

Page change

Form feed is carried out if:

  • a page is fully written
  • the Runtime is closed and online printing is active
  • function Online printing start new page is executed

Halt printing

To halt or to continue online printing:

  • carry out function Switch online printer on/off.

Changing and setting up a printer

To change the printer in Runtime:

  • Carry out the Switch online printer function

To set up the selected printer in Runtime:

  1. Configure a Print with dialog control element for the screen
  2. Click on the Print with dialog button in Runtime
  3. The configuration dialog is opened

Printer

Parameters | Description
Printer | Settings for the printer.
Name | Selection of the printer from the drop-down list. The list contains all printers configured in the operating system.
Properties... | Opens printer configuration dialog.
Status: | Display printer state. For information only.
Type: | Display printer type. For information only
Location: | Display the location of the printer if configured. For information only.
Comment: | Display comment about printer if configured. For information only.

Paper

Parameters | Description
Paper | Configuration of the printout.
Size | Select paper format from drop-down list.
Source | Select paper feed from drop-down list.

Alignment

Parameters

Description

Alignment

Select paper alignment. Possible parameter:

  • Portrait Format
  • Landscape

Network

Opens dialog for selecting a printer in the network.

OK

Applies configuration and closes the dialog. With this printing is started in the Runtime.

Cancel

Discards configuration and closes the dialog. In the Runtime this also cancels the printout.

Formatting example

Configuration in ALARM.FRM:

Date: @DSYSTEM | Alarm inf. list/demo proj. | Time @TSYSTEM o'clock | Text
Date/Time received | Time cleared | Information text | Status text
%% |  |  |
@DTRECEIVED | @TCLEARED | @IDENTIFICATION | @TEXT
%% |  |  |
 | Page | @PAGE |

Printout on the printer

Date: 20.03.2011 | Alarm inf. list/demo proj. | Time: 12:00 PM: | Text
Date/Time received | Time cleared | Information text | Status text
20.03.2011 13:00:00 | 20.03.2011 1:03:59 PM | Message 1 | Limit exceeded
20.03.2011 13:00:00 | 1:05:35 PM | Demo information | Limit 750 reached
20.03.2011 1:03:59 PM |  | Message 2 | Limit
20.03.2011 1:11:23 PM |  | Message 3 | off
20.03.2011 1:03:59 PM | 1:12:45 PM | Demo information | off
 | Page | 1 |


Offline printing

Manual -> Alarms administration -> Operating during Runtime -> Printing and exporting alarms -> Offline printing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Offline printing means that the Alarm Message List is printed out as it is displayed at the time in Runtime. This print out is a snapshot including all set filters and their restrictions. The print out is carried out regardless of whether the variables concerned having option print.

Print

To print the Alarm Message List offline:

  1. define a printer
  2. Configure ALAR_G.frm
  3. Add ALAR_G.frm to the Files/texts and formats node
  4. in the Runtime click button print or print with dialog.

Set up and change printer

Changing and setting up a printer

To change the printer in Runtime:

  • Carry out the Switch online printer function

To set up the selected printer in Runtime:

  1. Configure a Print with dialog control element for the screen
  2. Click on the Print with dialog button in Runtime
  3. The configuration dialog is opened

Printer

Parameters | Description
Printer | Settings for the printer.
Name | Selection of the printer from the drop-down list. The list contains all printers configured in the operating system.
Properties... | Opens printer configuration dialog.
Status: | Display printer state. For information only.
Type: | Display printer type. For information only
Location: | Display the location of the printer if configured. For information only.
Comment: | Display comment about printer if configured. For information only.

Paper

Parameters | Description
Paper | Configuration of the printout.
Size | Select paper format from drop-down list.
Source | Select paper feed from drop-down list.

Alignment

Parameters

Description

Alignment

Select paper alignment. Possible parameter:

  • Portrait Format
  • Landscape

Network

Opens dialog for selecting a printer in the network.

OK

Applies configuration and closes the dialog. With this printing is started in the Runtime.

Cancel

Discards configuration and closes the dialog. In the Runtime this also cancels the printout.

Formatting example

Configuration in ALAR_G.frm:

Date: @DSYSTEM | Closed Alarm Message List Demo Project | Time @TSYSTEM o'clock | Text
Date/Time received | Time cleared | Information text | Status text
%% |  |  |
@DTRECEIVED | @TCLEARED | @IDENTIFICATION | @TEXT
%% |  |  |
 | Page | @PAGE |

Printout on the printer

Date: 20.03.2011 | Closed Alarm Message List Demo Project | Time: 12:00 PM: | Text
Date/Time received | Time cleared | Information text | Status text
20.03.2011 13:00:00 | 20.03.2011 1:03:59 PM | Message 1 | Limit exceeded
20.03.2011 13:00:00 | 1:05:35 PM | Demo information | Limit 750 reached
20.03.2011 1:03:59 PM |  | Message 2 | Limit
20.03.2011 1:11:23 PM |  | Message 3 | off
20.03.2011 1:03:59 PM | 1:12:45 PM | Demo information | off
 | Page | 1 |


FRM configuration file

Manual -> Alarms administration -> Operating during Runtime -> Printing and exporting alarms -> FRM configuration file

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

FRM files (format files) are configuration files for printing out lists.

The FRM file has three parts:

  • Header: at the beginning of the page
  • List part: cyclic per line
  • Footer: at the end of the page

Principles

When editing FRM files regard the following:

  • Separating the list parts:
    • Header and list part and list part and footer are seperated by %%.

      The separation marking must be used only once for the list and the footer.

    • Attention: The last line must be followed by at least two empty paragraphs. Otherwise the footer is not printed!
  • Positioning the individual entries:
    You may only use space, no tabulators.
  • Editing the FRM file in a text editor:
    Automatic line break must be deactivated otherwise undesired effects in the formatting may occur.

Keywords

The setting for the page length is made in Project Properties under AML and CEL or via the ALARM.frm or ALAR_G.frm file for the AML or BTB.frm and BTB_G.frm for the CEL.

Please keep in mind:

  • The number of the alarm entries per page results from the predetermined number of lines (e.g. Lines per page 72), less the lines used for header and footer text.
  • The Use reactivated time option must be activated in order to be able to use the keywords that evaluate the reactivation (time, number).
  • Free texts and keywords can be used in the formatting file. Key words can be used either in German or in English. The use of English key words is recommended.
  • Not every key word is suitable for every kind of printing (AML, CEL, online, offline).

The following list contains key words in English and German and their field of application.

German | English | AML offline | CEL offline | AML online | CEL online | Description
Key words for the list part
@BMKENNUNG | @RESOURCELABEL | X | X | X | X | Resources label
@DATZEITKOMMT | @DTRECEIVED | X | X | X | X | Time and Date when the alarm occurred
@DATZEITGEHT | @DTCLEARED | X | - | X | - | Time and Date when the alarm ended
@DATZEITOK | @DTACK | X | - | X | - | Time and Date when the alarm was acknowledged
@DATZEITREAKT | @DTREACTIVATE | X | - | X | - | Time and Date of reactivating: Property Use reactivated time in the project properties must be activated.
@DATZEIT | @DTLASTEVENT | - | - | X | - | Time and date of alarm received or cleared or acknowledged or reactivated
@ZEIT | @TLASTEVENT | - | - | X | X | Time of alarm received or cleared or acknowledged or reactivated
@ZEITOK | @TACK | X | - | X | - | only displays time of acknowledging
@ZTKOMMT | @TRECEIVED | X | X | X | X | only displays time of alarm received
@ZTGEHT | @TCLEARED | X | - | X | - | only displays time of end of alarm
@ZTREAKT | @TREACTIVATE | X | - | X | - | only displays time of reactivating
@TIMELASTING | @TACTIVE | X | - | X | - | Time active (difference time received - time cleared)
@ANWENDUNG | @PROJECTNAME | X | X | X | X | Project name
@KANALNAME | @VARNAME | X | X | X | X | Variable name CEL: Only entries with variables
@AK | @ACLASSNR | X | X | X | X | Alarm/event class name
@AG | @AGROUPNR | X | X | X | X | Alarm/event group number
@AGNAME | @AGROUPNAME | X | X | X | X | Name of alarm/event group
@AKNAME | ACLASSNAME | X | X | X | X | Name of alarm/event class
@TAGNR | @IDENTIFICATION | X | X | X | X | Identification (company-specific label)
@AMELDUNG | @TEXT | X | X | X | X | Alarm message text
@REAKTANZ | @NRREACTIVATE | X | - | X | - | Number of reactivations
@STATUS | @STATUS | X | X | X | X | Status information as in Alarm Message List
@WERT | @VALUE | X | X | X | X | Variable value of alarm
@REAKTIONSTEXT | @COMMENT | X | X | X | X | Commentary from the Alarm Message List. If you use dynamic limit texts, this is only available if properties Long dynamic limit texts AML or Long dynamic limit texts CEL are activated.
@USER | @USERID | X | X | X | X | AML: User who acknowledged alarm.
@RECHNER | @COMPUTER | X | X | X | X | AML: Computer on which alarm was acknowledged.
Key words for header and footer
@ANWENDUNG | @PROJECTNAME | X | X | X | X | Project name
@SEITE | @PAGE | X | X | X | X | Page number
@HEADDATZEIT | @DTSYSTEM | X | X | X | X | System date and system time
@HEADDATUM | @DSYSTEM | X | X | X | X | System date
@HEADZEIT | @TSYSTEM | X | X | X | X | System time
@USER | @USERID | X | X | X | X | User who prints
@USERNAME | @USERNAME | X | X | X | X | Full user name who triggered action
@RECHNER | @COMPUTER | X | X | X | X | Computer from which it is printed
[Text] | [Text] |  |  |  |  | Random text

attention Attention

Between the key words there must be enough space so that entries are not overwritten. In doing so, you make sure that long limit texts are also displayed correctly.

Example:

@TEXT (spaces up to here)


Exporting alarms

Manual -> Alarms administration -> Operating during Runtime -> Printing and exporting alarms -> Exporting alarms

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Alarms can be exported in different formats:

  • dBase
  • CSV
  • XML
  • SQL

Export

To export alarms

  1. Create an Export AML function
  2. link the function to a button
  3. execute the function in the Runtime

info Information

The export to SQL is incremental. If there is already exported data, only new and amended data is exported.


Allocations

Manual -> Allocations

Allocations make it possible to place the current value of a variable onto a second variable within or without the driver.

In

tutorial License information

Part of the standard license of the Editor and Runtime.

zenon it is possible to write values from the controller directly into a SQL database or to write value changes from one driver to another driver when they occur. You can also make cross-project allocations.

Attention: Cross-project allocations are executed only after all projects have been loaded.

Transfer

An allocation transfers value, state and time stamp of the source variable to the target variable.

Note: At the moment state and time stamp can only be processed by the following drivers:

  • Internal driver
  • SQL driver
  • AK driver (SICAM 230)

States Real time external (T_EXTERN), Real time internal (T_INTERN)und Daylight saving time/standard time announcement (T_CHG_A) are not transferred. They are defined by the time stamp.

The signal resolution should therefore have the same limits for both variables (overflow behavior).

The transfer of the value occurs on a vale change: Whenever the source variables value is changed, the value of the target variable is changed as well. Should the value of the target variable be changed independently from that of the source variable, then the target variable has the different value as long as the value of the source variable does not change.

info Information

Allocations to Internal variables are also only carried out on the server.

Context menu Project manager

Menu item | Action
New allocation | Inserts a new allocation in the list.
Export XML all... | Exports all entries as an XML file.
Import XML... | Imports XML files.
Help | Opens online help.


Engineering in the Editor

Manual -> Allocations -> Engineering in the Editor

To define allocations:

  1. select sub-node Allocations in node Variables in the Project manager.
  2. already existing allocations are displayed in the detail view
  3. select the desired action from the context menu or the tool bar, e.g. New allocation
  4. in the properties window the properties of the new allocation are displayed and can be edited

An allocation implicitly needs:

  • an unique name
  • a source variable
  • a target variable

When selecting property Source variable or Target variable the corresponding variable list for selecting the desired variable is displayed. Each variable of one of each driver can be selected as a source. The target variable must be readable/writeable.

Each value change to the source variable is transmitted to the target variable of the allocation.

The context menu of the detailview of the Project Manager allows to cut, copy, insert or delete existing allocations.


Allocation detail view of toolbar and context menu

Manual -> Allocations -> Allocation detail view of toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu

Menu item | Action
New allocation | Inserts a new allocation in the list.
Cut | Copies the selected entries to the clipboard and deletes them from the list.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Clear | Deletes selected entries after a confirmation from list.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Properties | Opens the Properties window for the selected entry.
Export selected XML | Exports all selected entries as an XML file.
Import XML | Imports entries from an XML file.
Remove filter | Removes all filter settings.
Help | Opens online help.


Trigger variables and trigger type

Manual -> Allocations -> Trigger variables and trigger type

A trigger variable and a trigger type can be defined for assignments. Event-triggered assignments can thus be defined. Values are thus no longer assigned automatically, but only when the value of a trigger variable changes.

Trigger variable must be binary variable. Possible configurations are:

Trigger variable | Trigger type | Result
not defined |  | Each change in the source variable causes the source value to be assigned to the target variable.
defined | Edge | The assignment is only executed if the trigger variable undergoes a value change from 0 to 1. Only a positive edge of the bit variable leads to the assignment being released. The assignment is no longer instigated by a change to the value of the source variable.
defined | Gage | The assignment is always carried out as long as the trigger variable has the value 1. Each time the value of the source variable changes, the assignment is activated and the value is written to the target variable. This assignment remains active until the value of the trigger variable changes back to 0.


Automatic Line Coloring (ALC) - Topology

Manual -> Automatic Line Coloring (ALC) - Topology

The topological coloring of lines allows easy automatic dynamizing of tubes in technology (for media) as well as in the energy distribution (for electricity). So process controlled coloring of topological nets can easily be realized.

Because the tube structure is designed in the screen with all its technological elements (e.g. tanks and valves, or generators, switches and consumers), it is internally emulated as a model and the media flow is displayed in the Runtime.

In order to allow screen-overlapping models the entire design and configuration is always project-wide. You therefore have one entire topological model per project, which is used for the calculation of the tube statuses and ultimately for the coloring of the tubes.

The whole topology is created automatically from the graphic design. No other engineering actions are necessary.

info Information

The ALC algorithm only runs through once from a source starting from each switch.

Detail screens

To display individual screens, a partial area can be taken from the topological network and displayed individually by means of alias. A detail screen can be displayed with the data from different equipment parts, for instance outputs or partial networks.

tutorial License information

Must be licensed for Editor and Runtime (single-user, server, standby).

No need to be licensed for Runtime client.

Licensing is carried out using the zenon Energy Edition.

  • ALC: Included in the license for Energy Edition; provides basic properties for line coloring.
  • Topology package: Requires additional licensing on the server (not on the client) and expands ALC by:
    • Multiple supply
    • Secured supply
    • Topological interlockings
    • Transformer and separator topological elements
    • Error detection (version 6.50 and above)


ALC elements

Manual -> Automatic Line Coloring (ALC) - Topology -> ALC elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Automatic Line Coloring (ALC) makes it possible to color lines regardless of the process status. The combined element is used as the process element. Automatic line coloring allows easy automatic dynamizing of tubes in technology (for media) as well as in the topological networks (for electricity).

Engineering

For the design two types of screen elements with different functions are distinguished. On the one hand these are procedural elements (source, switch/disconnector, drain, transformer or link) and on the other hand lines.

In doing so, the technical elements have a function and a color (source and transformer). If the procedural elements are active, the connected lines take on the color of these elements at the source and transformer or they take on the color of the element's input line for the switch and the link. If the procedural elements are inactive, the color of the lines is taken from the definition in the editor.

The different functions of the elements are assigned in the properties of the combined element.

Example

A source has a connected line. A switch is connected to the line. And a second line is connected there. If the source is active, the first line is colored with the color of the Automatic Line Coloring defined in the source up to the valve. The other line is not colored before the switch is closed.

Source inactive

Source active

Switch closed

Undefined or invalid

info Information

If the procedural element status is undefined or malfunction, this is automatically detected. All connected lines and all further elements are displayed in the color of the predefined source undefined' for both states.

Number of closed switches in a series

For the correct functioning of the ALC algorithm, the number of connected switches in a series plays a role.

Recommendation: Arrange a maximum of 256 closed switches in a series between the source and the drain.


Procedural elements

Manual -> Automatic Line Coloring (ALC) - Topology -> ALC elements -> Procedural elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Procedural elements are created in zenon with a combined Element. Their state determines the coloring of the connected line.

The following settings are available:

Property

Description

Function type

Defines the technological type of the Combined element.
  • Terminator

For bus bar ends. Blocks the error message "Line only connected on one side" when being compiled in the Editor.
  • Generator

A generator generally behaves like a source, but it is considered as independent an not net-synchronous.
  • No function

The element has no function in the ALC.
Note: The "no function" function type is the default value.
  • Link

With a link a line can be continued on some other place. If a link is supplied by a line, all other links with the same link number also are supplied by this line. Here it does not matter, whether the links are in the same screen or on different screens in the project. So screen independent lines can be defined. It is possible to have more than two links with the same link number in one project.

Links can be supplied by several lines at the same time or can themselves supply several lines. In principle there is no difference between inputs and outputs. The source information is passed on to all connected lines.
Attention: Two link elements cannot be connected directly to one line. In between, there has to be at least one other procedural element (switch/disconnector or transformer).
A link cannot be switched active or inactive: it always is active.
  • Source

Passes on its color. If the source is active (value: 1), all connected lines that have Color from ALC option set in the element properties are allocated the color of the source. The color is defined in the project properties as the source color. (e.g. tanks or generators). A source is a single pole with a static source number assigned to it. The source is switchable over the state of its main variable. Generally, sources are considered as net-synchronous and detachable.

You can find details on the source in the configuration of the sources chapter.
  • Switch

With this lines can be split. If the switch is closed/active (value: 1), then the connection between the two lines is closed and the line is colored up to the next switch with the defined source color. In this case a switch forwards the source color of the input line to the output line.

If the status of the switch is malfunction, undefined or INVALID, the color of the line turns into the color undefined from the ALC configuration in the project properties. A switch thus delivers source number 0 (undefined) to its output (connection 2) instead of the incoming source number.

Example: see Switch example - colors from ALC section.
  • Valve

A slider (a valve) acts in a similar manner to a switch, but it is used for water and gas lines.

Value of the main variable:

Switch OFF: Value 0 -> Slider closed-> No water flow

Slider ON: Value 1 -> Slider closed completely-> No water flow

Slider DIF: Value 2 -> Slider partially open-> Water flow

Slider STO: Value 3 -> Slider malfunction
  • Drain

This defines the end of the line. The drain does not influence the coloring; it is only used so that the model can be displayed in full. If an external program (e.g. VBA) should access the model, then the drain probably is needed for further calculations, and so has to be inserted.
In Energy projects, the drain is used for representing consumers. These customers are considered for the calculation of the ALC interlockings (command groups) 'Consumer is undersupplied'.
  • Transformer

A transformer is a drain and a source at the same time. SO with a transformer the input color (input source) can be transformed to a new output color (transformer source color).
The output connection is only active, if the transformer is switched active. However the output line does not get the color of the input line as with a switch, but instead the color of the transformer's own source. A source must therefore be defined for each transformer. A transformer cannot be switched active or inactive, it always is active.

Reverse-feed-compatible transformer:

To have a transformer capable of reverse feed, you must select, for Source for reverse feed, a different source than UNDEFINED [0]. This means that the transformer behaves the same in both directions - from the input to the output (forward) and also from the output to the input (backward). The only difference is that the Source for reverse feed property and not the Source property is used for further distribution of the source number .

Note: Defective network statuses or missing configurations, such as a feed from the input and output at the same time or a short circuit from input and output are not specially colored. This means that the transformer capable of taking a reverse feed behaves like two transformers switched to run antiparallel that are not capable of taking a reverse feed.

Disconnector

A disconnector generally behaves like a switch. Nevertheless, a disconnector may not be connected in the topological model. A status (on, off, intermediate position, malfunction) is determined via its main variable.

Source and link number

Parameters | Description
Source | Here a source is assigned to an element. In this selection box all sources defined in the ALC configuration (in the project properties) are available. All source names are listed. This property is only active if the function type 'source', 'transformer' or 'generator' has been selected. You can find details on the source in the configuration of the sources chapter.
Link number | Only the link number is entered for a link function. All identical link numbers in a project correlate with each other. Detailed description in the function type Link. This property is only active, if the function type link has been selected.

A variable of the IEC type BOOL or integer has to be linked to the element as the main variable, so that the switch can get the status (open, closed, invalid). In the same way, the source gets its status (active/inactive) from the linked main variable.

For the function types source and transformer the defined source number is forwarded to the consumers (drains) over open/closed switches. The statuses and colors of all connected lines are calculated from the superposed sum of the supplying source numbers and procedural elements.

info Information

Only the first two bits are considered for the switching. The first bit stands for the actual switching. 0 equals off and 1 equals 1.

The second bit is the error bit. There is no error only if it is 0.

States

  • A switch and a source are switched on if the value of the linked variable is 1.
  • A switch is invalid if the value of the linked variable is >1 or has an INVALID status.
    An invalid switch provides the source number 0 (undefined) at its exit (connection 2) instead of the source number entering. In the direction towards the input the switch behaves as normal.

    Note: if the (acknowledgment) variable has the status INVALID, the whole subsequent network is INVALID, because the status of the network is not known. The status INVALID is forwarded (routed) using subsequent closed switches.

attention Attention

If in the single status the color and the fill color from the ALC is activated, also the procedural elements are colored by the status of the connected lines in the Runtime.


Switch example - colors from ALC

Manual -> Automatic Line Coloring (ALC) - Topology -> ALC elements -> Procedural elements -> Switch example - colors from ALC

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Example 1

Combined element with value status 00 and line color from ALC:

  1. Configuration in the Editor:
    • Combined element with value status 00
    • Line color from ALC active

  2. Results in the following in Runtime:
    • Source color: green
    • Color without voltage: white
    • Switch status: off/open (value 0)

Example 2

Combined element with value status 01 and colors from ALC:

  1. Engineering in the Editor
    • Combined element with value status 01
    • Line color from ALC active
    • Fill color from ALC active

  2. Results in the following in Runtime:
    • Source color: Green
    • Color without voltage: White
    • Switch status: on/closed (value1)

Example 3

Combined element with value status 00 without colors from ALC:

  1. Configuration in the Editor:
    • Combined element with value status 00
    • Line color from ALC not active

  2. Results in the following in Runtime:
    • Source color: Green
    • Color not energized and construction color of the line: White
    • Defined line and fill color of the combined element: black
    • Switch status: off/open (value 0)

Example 4

Combined element with value status 01 without colors from ALC:

  1. Engineering in the Editor
    • Combined element with value status 01
    • Line color from ALC inactive
    • Fill color from ALC inactive

  2. Results in the following in Runtime:
    • Source color = green
    • Color not energized and construction color of the line: White
    • Defined line and fill color of the combined element: black
    • Switch status: on/closed (value1)


Connection points of procedural elements

Manual -> Automatic Line Coloring (ALC) - Topology -> ALC elements -> Procedural elements -> Connection points of procedural elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When configuring, a line is connected to a procedural element (combined element) by overlapping drawings in the screen at connection points of the combined element. Only one line can be connected to the same connection point at the same time. All lines that start within the area defined, are connected (Topology from the graphic).

attention Attention

Use ALC elements only in un-rotated state because:

The calculation for the topological model for the ALC in the Editor is based on the position of the elements in un-rotated state and without considering any dynamics.

Connection points and connection areas

  • The connection area for a connection point is in the middle of each side of the combined element. Each combined element thus has four connection points.
  • The size of a connection area corresponds to 2/3 of the height and width of a combined element, but no more than 20 pixels.
  • Each connection area is centered in the middle of the respective element corner and stretches symmetrically inwards and outwards, to a maximum of 10 respective pixels.

attention

If the combined element is less than 30 pixels, connection areas within an element overlap. Lines that could touch can cause errors (compilation, coloring).

You can see the possible connection points for combined elements smaller and larger than 30 pixels in the illustration.

Colors

  • Red: Combined element
  • Blue: Connection areas

Dimensions:

  • A: height of the Combined element
  • B: width of the Combined element
  • a: Width of the connection area: 2/3 of A, but a maximum of 20 pixels.
  • b: Length of the connection area: 2/3 of B, but a maximum of 20 pixels.

Rules

  • If a line is outside the connection area, no connection is detected and there is thus no coloring of the line. So there will also be no coloring for further lines.
  • With sources, drains and Links, all described connection points can in principle be used.
    Attention: With sources and drains, only one connection point can be used at the same time. If different connection points are used at the same time, undefined states can occur.
    Elements of the type Link can also use several connection points at the same time. The incoming color information is passed on to all lines.
  • With switches/disconnectors/sliders and transformers, the connection 1 (supply) is on the left or on the top and connection 2 (output) is on the right or on the bottom. This sequence can be changed with the Switch input/output property.
    Attention: At switches and transformers it has to be cared, that only one input connection and one output connection is used. The simultaneous use of several input or output connection points results in inconsistencies and is therefore not reliable.
  • For all procedural elements the following is true: Only one line can be connected to a connection point. Junctions cannot be realized directly on an element but must be drawn with lines.


Switch input/output

Manual -> Automatic Line Coloring (ALC) - Topology -> ALC elements -> Procedural elements -> Switch input/output

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If a transformer, disconnector or switch is configured, the input and output can be switched. To do this:

  1. Select either transformer, disconnector or switch as a Function type
  2. activate the Switch input/output check box

The input is then placed at the right or at the bottom and the output is placed left or at the top.

Overview

Configuration device | Input | Output
normal | Left | Right
normal | top | below
swapped | Right | Left
swapped | below | top


Lines

Manual -> Automatic Line Coloring (ALC) - Topology -> ALC elements -> Lines

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Lines are represented by vector elements Line, Polylines and Tube.

If the option Color from ALC is activated for a line, the coloring is defined by the ALC configuration. Lines are automatically colored by the system depending on the status of the procedural elements and the ALC settings.

Here the color usually comes from the highest priority source number of the media flowing through the line, or stays "empty/not energized" just as defined in the screen with static or dynamic colors.

You define the display type by means of drop-down lists:

  • Priority for display
  • Display multiple supply
  • Display secured supply

The following options are available in the properties of the lines:

Parameters

Description

Color from ALC

Activates the automatic line coloring for these vector elements. That means: If the source for the line is active and all switches/valves leading from the source to the line are closed/open, the line is accordingly colored. If the line is fed by a single source, the defined source color is used for coloring the line. The line width is not changed.

Priority for display

Defines if multiple supply, secured supply or both are displayed.
Default: Multiple supplies

Secured supply

The element is displayed according to the rules of the secured supply.

A line is then considered to have a secure supply if it is supplied by at least two different switches or transformers with a non-system source. System sources do not contribute to secured supply, but do not exclude it.

Multiple supplies

The element is displayed according to the rules of the multiple supply.

A line is considered to have multiple supplies if it is supplied by at least two different sources. In doing do, it does not matter if they are system or user sources and from which side the line is supplied by the sources.

No priority

The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met. That means:

If a line

  • has multiple supplies and a secured supply,
  • The priority is set to No priority,
  • The display for multiple supply is set to two sources with highest priority,
  • The display for secured supply is set to double width,

then the line is twice as wide and displayed as a dashed line in two colors.

display multiple supplies

Multiple supply means that a line is supplied by multiple sources at the same time. Here you can define how lines with multiple supply are displayed.

Default: highest priority source

highest priority source

The line gets the color of the source with the highest priority.
Note: Priorities correspond to the sequence chosen in the ALC configuration.

two highest priority sources

Applies for lines fed by two or more different sources. The two sources with the highest priorities define the coloring. The line is displayed with the these two colors (dashed). The dash length can be changed using the Dashing length supplied multiple times property.

System sources apply fir multiple supplies just as with genuine sources and color lines in two colors it they are configured accordingly.

Alternative color

The color defined in the Alternative color property is used.

Dashing length supplied multiple times

Defines the dash length (in pixels) of lines, polylines or tubes for the dashed ALC coloring for two sources with the highest priority for display multiple supplies.

  • Minimal: 0 (automatic dash length)
  • Maximum: 32767
  • Default: 0

Alternative color

Alternative color for the ALC coloring of lines, polylines or tubes with multiple supplies.

display secured supply

Secured supply means that a line gets multiple supply from one source (parallel). Here you can define how 'secured supply' is displayed.

A line is always displayed as having a secure supply if it is supplied by at least two switches with a genuine source (not system source).

Default: normal

double width

Relevant for lines fed in parallel by the same source. If this is the case, the line is displayed with double the configured width. (Example: A line with line width 5 pixels is displayed with 10 pixels if secure-fed.)
If this line is fed by two or more different sources (multi-supply), the line width does not change!

The color is always defined by the source with the highest priority!

double brightness

Relevant for lines fed in parallel by the same source. The line is displayed with double the original brightness.
If this line is fed by two or more different sources (multi-supply), the line color does not change!
If this line is multi-fed from one source (secure supply), the line is displayed with double the original brightness.
Formula for the calculation of the double brightness:

  1. The defined RGB color is transformed to the HLS system.
  2. L (luminance = brightness) is recalculated with NewLuminance = 240*3/4 + L/4
  3. The color value is recalculated to the RGB system with the new brightness.

The color is always defined by the source with the highest priority!

normal

The element is displayed in the color of the source and with the configured width.

Use alias

Active: Alias is used.

Alias

Opens the dialog for selecting a model.

info Information

The source color and the priorities of the sources are defined in the project properties.

User-defined sources must have a higher ID than 9. IDs up to 9 are reserved for system sources.

info Information

The calculation of the color of a line in the Runtime is done with the following priority list:

  1. Automatic Line Coloring (highest priority, overrules all other settings)
  2. Dynamic colors
  3. Static colors


Example

Manual -> Automatic Line Coloring (ALC) - Topology -> ALC elements -> Lines -> Example

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the following example Source 0 has the color blue and Source 1 has the color red. And Source 0 is the source with the highest priority.

Source 0

Source 1

This results in the following displays for the different options:

 | Line / Polyline | Pipe
highest priority source |  |
two highest priority sources |  |
double width |  |
double brightness |  |


Connection points of lines

Manual -> Automatic Line Coloring (ALC) - Topology -> ALC elements -> Lines -> Connection points of lines

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The connection of one line (line, polyline or tube) to another line is done with overlapping drawing in the screen at connection points. The connection points - either connection areas - are at the start and the end of each line and are around 3 pixels large.

Example Example

The start point of a line has the coordinates (start point x/start point y): 150/100 pixels.
This results in a connection area (x / y): 147 - 153 / 97 - 103 pixels.

If the line start or end of this line and that of one or more other lines is within this area, the lines are automatically connected without any further engineering. A mere overlapping of the connection areas of the single lines is not sufficient!

In the following illustration the connection area is displayed graphically (the green lines are connected to the black one, the red line not.

info Information

Any number of lines can be connected in a connection area.

attention Attention

If a line is outside the connection area (e.g. the red line in the illustration), no connection is established and there is no coloring of the line. So there will also be no coloring for further lines.

Line crossings can easily be realized, if the ends of the lines are not in the connection area.

attention Attention

Use ALC elements only in un-rotated state because:

The calculation for the topological model for the ALC in the Editor is based on the position of the elements in un-rotated state and without considering any dynamics.


Checking the engineering

Manual -> Automatic Line Coloring (ALC) - Topology -> ALC elements -> Checking the engineering

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Engineer the desired procedural elements and lines in one or more screens and save these screens. Then you can check via Create all Runtime files or Create changed Runtime files whether there are any errors or conflicts in the screens. If error and/or conflicts should exist, corresponding error messages or warnings are displayed in the output window.

info Information

Double click the corresponding line in the output window. The screen with the erroneous screen element will be opened automatically. If the erroneous screen element is part of a symbol, the corresponding symbol is automatically selected.

The following error message can be displayed.

  • ALC: Screen '%s' - Two Link elements with different Link number are connected to line '%s' . (Double click opens the screen and selects the line.)
  • ALC: Screen '%s' - More than two connection points are used at element '%s'. For each element only one input and one output may be used. (Double click opens the screen and selects the element.)

The following warnings can be displayed.

  • ALC: Screen '%s' - Alias line '%s' is connected to a no-alias line. (Double click opens the screen and selects the line.)
  • ALC: Screen '%s' - Alias element '%s' is connected to a no-alias line. (Double click opens the screen and selects the element)
  • ALC: Screen '%s' - No-alias element '%s' is connected to an alias line. (Double click opens the screen and selects the element)
  • ALC: Screen '%s' - Line '%s' is only connected on one side. (Double click opens the screen and selects the line.)
  • ALC: Screen '%s' - Element '%s' is not connected. (Double click opens the screen and selects the element)
  • ALC: Screen '%s' - Element '%s' is only connected on one side. (Double click opens the screen and selects the element)

In the error messages or warnings the corresponding elements are identified using the element reference. This reference also serves as the link key for ALC aliases.


Configuration

Manual -> Automatic Line Coloring (ALC) - Topology -> Configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure ALC:

  1. In project properties, select ALC configuration the property in the Automatic Line Coloring group
  2. Click on the ... button
  3. The dialog for configuration is opened
  4. Configure the desired properties for:
    • Sources
      (note also the principles for Coloring for UNDEFINED.)
    • Interlockings
    • Screen marker


Configuration of the sources

Manual -> Automatic Line Coloring (ALC) - Topology -> Configuration -> Configuration of the sources

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The sources, e.g. their names and colors (sequence and priority), are configured project-specifically within the project properties under 'ALC configuration'.

Source colors

Parameters | Description
Number | Internal unique consecutive number, so that the source can be identified. This number is given by the system automatically and cannot be changed. Attention: IDs 0 to 9 are reserved for the system sources and must not be used user-specific.
Name | Logical name for the source (e.g.: 'water' or 'grounded'). This name is also used when selecting the source number for Combined elements. You can change the name by clicking it with the left mouse button. With this edit mode is switched on. The changes are accepted with Enter or by selecting another source. Note: The labels are not language switchable.
Line color | Line color of the respective source. This color is used for coloring lines, polylines and as the outside color of tubes.
Dashed | Check box for activation. If active, the line is drawn as dashed. Note: This check box is only active for GROUNDED. This check box is grayed out for all other sources.
New | Adds a new color.
Delete | Deletes the selected color.
Upwards (arrow symbol) | Moves selected source up one position.
Fully upwards (arrow symbol) | Moves selected source to the start of the list.
Downwards (arrow symbol) | Moves selected variable down one position.
Fully downwards (arrow symbol) | Moves selected source to the end of the list.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

The colors can be configured directly by entering the corresponding hexadecimal code or by using a color palette.

For direct input:

  1. Click on the color description with the left mouse button
  2. The field is switched to editing mode
  3. Enter the code
  4. Press the input key or select another source in oder to accept the change

To select via a color palette:

  1. highlight the desired line
  2. click on the ... button behind the color
  3. Online help is opened.
  4. select the desired color

The hexadecimal code describes the RGB color value and consists of the following. #RRGGBB.

Element | Meaning
# | Identifier to indicate that a hexadecimal color code is used.
RR | 2 digits are the red value of the color in hexadecimal system. 0-255 is 0-FF
GG | 2 digits are the green value of the color in hexadecimal system. 0-255 is 0-FF
BB | 2 digits are the blue value of the color in hexadecimal system. 0-255 is 0-FF

info Information

The sequence in this list represents the priority of the sources, with the first element having the highest priority.

To change the priorities of the single sources, they can be moved upwards or downwards using the arrow buttons

attention Attention

Limitations when deleting the sources and resetting erroneous colorings:

Sources with ID between 0 and 9 are reserved for system sources. They can:

  • Not be deleted:
  • Not be reset as an erroneous color

Deleting sources

In order for sources to be able to be deleted, they must have an ID from 10. Only the source with the highest ID can be deleted.

Resetting erroneous colorings

In order for erroneous colorings to be able to be reset once the cause has been rectified, no system source colors can be used. A color for IDs from 10 must be selected.


Coloring mode for UNDEFINED

Manual -> Automatic Line Coloring (ALC) - Topology -> Configuration -> Configuration of the sources -> Coloring mode for UNDEFINED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Coloring in the network can be implemented in two modes with the UNDEFINED status:

  • Standard
  • Input takes priority

This setting is made using the Automatic Line Coloring/Mode for coloring project property.

Standard

The graph search starts with a source and goes through the whole network, so that each closed switch (switch variable has the value 1) per direction is only gone through once, so no cycles occur. In doing so, each node visited (=line segment) is colored with the source color. The directly-related lines are marked as a node.

If the search finds a switch that has a switch variable with the following status, the UNDEFINED color is used for coloring from this point onwards:

  • INVALID [values: any desired],
  • is invalid [value: 3]
  • is in intermediate position [value: 2])

The graph search is now continued in the same form. Each switch is gone through just once per direction with the UNDEFINED color. Therefore each switch can be gone through a maximum of four times per source:

  1. with source number in forwards direction,
  2. with source number in backwards direction,
  3. with UNDEFINED in forwards direction,
  4. with UNDEFINED in backwards direction,

Input takes priority

With the Supply takes priority setting, only lines that have a supply from at least one source but not clearly from any one source are colored as UNDEFINED. If a line is supplied with at least one source, it can no longer receive an UNDEFINED color from another source.

This search is a two-stage search:

  • In the first stage, as with Standard, the source color is distributed in the network from each switched source, as long as the next switch is closed. The search is ended if the switch is open or invalid/undefined.
  • In the second stage, the search is started at each invalid/undefined switch that receives a supply from one side and the UNDEFINED color is distributed to the unsupplied side. This search also considers the switches that are invalid/undefined as closed and thus distributes the UNDEFINED color in the network until it meets a clearly open switch. In addition, a search is ended if a line element is reached that is already supplied.


Configuration of topological interlockings

Manual -> Automatic Line Coloring (ALC) - Topology -> Configuration -> Configuration of topological interlockings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

topological interlockings from the ALC for commands can be configured here.

info Information

This dialog is only available when both the "Energy Edition" and the "Automatic Line Coloring" modules are licensed.

The following conditions are available: The settings made here apply globally, for the whole Topological Model:

Parameters | Description
Voltage towards ground | Interlocking is active if a switch/disconnector is to be closed and a grounded potential is connected to its first connector and its other connector is connected or undefined.
Switching action in an area with an undefined status | Interlocking is active if a switch disconnector is to be closed and both of its connectors are 'undefined' or 'disturbed'.
Disconnector under load | Interlocking is active if certain conditions have been met for switching on or off. Conditions: See "Disconnector under load - interlocking conditions" section.
Device would no longer be supplied | Interlocking is active, when a consumer, which was supplied before, would be unsupplied after the switching action (by switch or disconnector).
Area with undefined status would increase | Interlocking is active if a switch disconnector is to be closed and one connector is 'undefined' or 'disturbed' and the other not.

If you click in the Status column in one of these interlockings, a drop-down list opens with three choices:

Parameters | Description
do not check | The selected condition is not considered in this project (topological model).
unlockable | The selected condition is considered in this project. If the condition applies, the user can unlock it with a command (Command screen). This unlocking action is logged in the Chronological Event List.
not unlockable | The selected condition is considered in this project. The user cannot unlock it.

Exception topological interlocking

The topological interlocking is not carried out if:

  • the variable of a switch has the status Revision
    or
  • the variable is manually corrects or set to Alternate value and with this is set to the same variable value as the initial value; in other words if the switch:
    • is set to OFF and then it is manually corrected to OFF or replaced.
    • is set to ON and then it is manually corrected to ON or replaced.


Disconnector under load - interlocking conditions

Manual -> Automatic Line Coloring (ALC) - Topology -> Configuration -> Configuration of topological interlockings -> Disconnector under load - interlocking conditions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For the disconnector under load topological interlocking, a disconnector can be switched if one of the following conditions is met:

When being switched on:

Before being switched:

  • The left and the right line segment receive energy from the same source
  • If the left line segment does not receive any voltage, the right line segment is grounded
  • If the left line segment is grounded, the right line segment does not receive any voltage
  • If the left line segment is not under load
  • If the right line segment is not under load

When being switched off:

After being switched:

  • The left and the right line segment would receive energy from the same source
  • If the left line segment does not receive any voltage and the right line segment is grounded
  • If the left line segment were grounded, the right line segment would not receive any voltage
  • If the left line segment were not under load
  • If the right line segment were not under load

info Information

Meaning of "not under load"

All of the following conditions must be met for the status of not under load:

  • All switches and disconnectors connected to the line segment are open.
  • All sources and consuming devices connected to the line segment are switched off.
  • No transformer may be connected to the line segment.
  • It must not be a line that is only connected to this disconnector (open line).


Configuration of the screen marker

Manual -> Automatic Line Coloring (ALC) - Topology -> Configuration -> Configuration of the screen marker

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Here you configure the color table for the color marker for the impedance-based error detection and calculation of load distribution. See also: AddMarker

Parameters | Description
Number | Unique internal serial number for clear assignment. This number is given by the system automatically and cannot be changed.
Line color | Line color of the screen marker.
Fill color | Fill color of the screen marker.
New | Adds a new color.
Clear | Deletes the selected color.

The colors can be configured directly by entering the corresponding hexadecimal code or by using a color palette.

For direct input:

  1. Click on the color description with the left mouse button
  2. The field is switched to editing mode
  3. Enter the code
  4. Press the input key or select another source in oder to accept the change

To select via a color palette:

  1. highlight the desired line
  2. click on the ... button behind the color
  3. Online help is opened.
  4. select the desired color

The hexadecimal code describes the RGB color value and consists of the following. #RRGGBB.

Element | Meaning
# | Identifier to indicate that a hexadecimal color code is used.
RR | 2 digits are the red value of the color in hexadecimal system. 0-255 is 0-FF
GG | 2 digits are the green value of the color in hexadecimal system. 0-255 is 0-FF
BB | 2 digits are the blue value of the color in hexadecimal system. 0-255 is 0-FF


Change ALC source color

Manual -> Automatic Line Coloring (ALC) - Topology -> Change ALC source color

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The foreground and background color of an ALC source can be temporarily changed for the coloring in Runtime using the Change ALC source color function. The change remains until Runtime is ended, reloaded or the function is executed again. To create the function:

  • select New Function
  • navigate to node Screens
  • select Change ALC source color

  • The dialog to define line colors and fill colors opens
  • define the desired color

Property | Function
Source | Drop-down list to select the source and display the colors currently assigned. These colors cannot be changed here.
New color for source | Click on the color and a dialog opens to select a color.


Detail screens

Manual -> Automatic Line Coloring (ALC) - Topology -> Detail screens

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To display individual screens, a partial area can be taken from the topological network and displayed individually by means of alias. The screen elements in the detail screen are not included in the topological model, but do however get their ALC colors from the model. They relate to an alias of the screen elements in the overall screen.

attention Attention

Aliases are only valid within a project.

This means that for symbols that contain links to aliases:

if the symbol is added to the general symbol library or the liberary in the global project and edited there, all ALC alias information is lost without notice!

Create alias

Aliases can be created for the elements:

  • Line
  • Polyline
  • Pipe
  • Combined element

attention Attention

An ALC alias cannot be created if a period (.) is contained in the name of the selected screen.

Solution: Replace the period in the screen name with a different character, such as an underscore for example (_).

To create a source element as an alias:

  • Activate it in the element's properties Use alias.

    To do this, ALC must be licensed and the Color from ALC property active.

  • Click on the ... button in the Alias property
  • the dialog to select the element opens.

Parameters

Description

Screen

Click the ... button and a dialog opens to select a screen.

Available ALC elements

Shows the elements that belong to a screen with the element name, type of element and function type. Clicking on an element selects an alias.

Filter

The elements can be sorted according to all columns. When setting a filter, the options offered from all other filters are reduced to values that can be sensibly combined.

  • Name: Input of a standard search term with wild cards (*). The last 12 search terms are offered in the list until the Editor is ended.
  • Element: Select from drop-down list.
  • Function type: Select from drop-down list.

Clicking on ... opens saved search or drop-down list.

If a filter is active, clicking on the X deletes the filter.

Selected alias

Shows the selected element in the field of Available ALC elements.

No selection

Removes selected element.

OK

Saves selection and closes dialog.

Cancel

Discards changes and closes dialog.

Help

Opens online help.

info Information

When selecting an element for a new alias, only elements and screens from the same project that the alias was defined in can be selected. Elements from subprojects or parallel projects are not available.

Replacing alias names

Aliases can be be changed when switching screens with Replace link. A detail screen can therefore be displayed with the data from different equipment parts, for instance lines or partial networks. Alias names are replaced along the lines of variables and functions. It is also possible to replace in elements that are used in symbols. The same dialog as is opened for the target as the Alias property.

Note: Substitution using index variables is not possible.


Error detection in the electric network

Manual -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Error detection marks grid parts that are subject to ground faults or short circuits by means of special colors in ALC. Sources for error detection are what are called ground fault or short circuit reporters that are assigned to a circuit breaker. Ground fault and short circuit reporters are always at the output of a circuit breaker element. Error messages are fixed in the screen and must be reset manually.

info Information

This function is only available when both the "Energy Edition" and the "Automatic Line Coloring" modules are licensed.

Error detection

Error detection runs locally. Each client in the network has its own independent model and can therefore search for ground faults and short circuits in different parts of the network.

Error detection in the electrical network is divided into:

  • Search for ground fault
  • Short circuit search

To configure error detection

  • You require a license for ALC and zenon Energy Edition
  • configure the appropriate screens
  • Configure ALC to the corresponding combined elements (switch, transformer, disconnector, slider)
  • configure the lines so that they are colored by ALC

Special functions are available in Runtime for error detection:

  • Start search for ground fault
  • acknowledge ground fault message
  • Stop search for ground fault
  • Acknowledge short-circuit message

Colorings

Errors can be shown by a special coloring for the lines in ALC. In Runtime, the color assigned by ALC changes automatically as soon as the status of the line changes. The colorings configured can be changed in Runtime via the change ALC source color function.

Messages are processed in the order in which they arrive. In the event of conflicts

  • The colors for displaying errors take priority
  • short circuit messages have priority over ground fault messages


Search for ground fault

Manual -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Search for ground fault

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The ground fault search serves to highlight the network parts hat potentially have a ground fault by coloring these. The color is taken from the configuration of ALC source colors for the GROUND FAULT source.

Which network parts potentially have a ground fault can be deduced from the ground fault messages from ground fault identification devices (ground fault indicators, protective device with ground fault recording). The following applies for ground faults:

  • Each device can have one to three ground fault messages.
  • Ground faults are either dealt with by permanent message processing or by transient message processing.
  • For directional ground fault devices, the direction can be lagging or leading in relation to triggering.
    • leading: First the message, then the transient bit.
    • lagging: First the transient bit, then the message.

info Information

A network component that potentially has a ground fault is then no longer considered to have a ground fault if this has been successfully connected.

Engineering

To configure the ground fault search:

  1. assign the combined element that represents the switching element to the Function type switch
  2. define the ground fault search mode, fault display and ground fault indication triggering
  3. set up the functions for start ground fault search, acknowledge ground fault search and end ground fault search

info Information

In order to also be able to set limits in intermeshed networks, only one area subject to a ground fault per path is searched for a fault.


Mode of the search for ground faults

Manual -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Search for ground fault -> Mode of the search for ground faults

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The short circuit search can either:

  • color the network part potentially subject to a short circuit
    or
  • the whole network where the short circuit is located

The coloring mode is defined via the Mode of the search for ground faults property.

To configure the property:

  • navigate to the Automatic Line Coloring node in properties
  • select the desired mode in the Mode of the search for ground faults property drop-down list
    • Color grid part: colors only the grid parts that are potentially subject to a short circuit
    • Color whole grid: colors in the whole linked grid where the short circuit is located

This setting can be changed in Runtime via the zenon API object model. In doing so, the short circuit search is recalculated once again.


Earth Fault Identification Type

Manual -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Search for ground fault -> Earth Fault Identification Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The direction and type of information processing for the switch type combined element are determined by the Type setting. to configure:

  1. navigate to the Automatic Line Coloring node in the combined element properties
  2. open the Ground fault recognition node
  3. select the desired type with the direction and type of alarm processing in the Type property
    • Direction:
      indicates if the raising edge of trip alarm or if the raising edge of a direction comes before
    • leading: The current direction status is used for the raising edge of the trip alarm
    • lagging: after a raising edge of the trip alarm, the first raising edge of a direction is waited on; if this does not occur within 2 seconds, the earth fault device is considered non-directional
    • Information processing:
      states which information can be processed
    • none: normal switch; information is not processed
    • Permanent message processing: Newly received messages are considered a new ground fault trip
    • Transient message processing: Messages that are received during a current Search are suppressed

Note: The distinction between permanent message processing and transient message processing only relates to processing the message, not to the type. Transient bit message processing need not therefore relate to a transient bit.

attention Attention

To suppress intermittent ground faults, ground fault messages that are received in intervals shorter than 2 seconds are ignored.


Ground fault display

Manual -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Search for ground fault -> Ground fault display

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The variable linked at Display is an output variable for error detection and displays the recorded status of the ground fault identification device. This is necessary because all messages remain saved internally until they are acknowledged, i.e. they do not necessarily conform to the current status of the message variables.

Each time a recording is made, a set value is sent to this variable. In doing so, the values are as follows:

Value | Meaning
0 | no ground fault
1 | ground fault forwards
2 | Ground fault backwards
3 | non-directional ground fault
4 | Error status - > both directions have activated

info Information

To reduce problems in network operation, the variable linked here should be a linked variable.


Earth fault triggering

Manual -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Search for ground fault -> Earth fault triggering

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The alarm to report an earth fault is defined by the Triggering variable It can contain information on the presence of an earth fault and the direction of the earth fault from the point of view of the earth fault recognition device. In doing so, a distinction is made between:

  • non-directional earth fault alarms
  • Directional earth fault alarms with a trip alarm
  • Directional earth fault alarms with a trip alarm

To configure the variable for the Triggering:

  1. navigate to the Automatic Line Coloring node in the combined element properties
  2. open the Ground fault recognition node
    1. for non-directional earth fault alarms

      Click on the ... button in the Triggering property

      select the variable you wish to import in the dialog that opens

      The properties for the direction remain empty

    2. for directional earth fault alarms with a trip alarm

      link the variable with Triggering and add the appropriate direction:

      Forwards: link a variable to the Forwards property

      Backwards: link a variable to the Backwards property

    3. for directional earth fault alarms without a trip alarm

      Link the variable with the corresponding direction:

      Forwards: link a variable to the Forwards property

      Backwards: link a variable to the Backwards property

      The Triggering property remains empty

Note: If you address a directional identification device with Forwards in both directions, this is then considered erroneous and ignored.


Start search for ground fault

Manual -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Search for ground fault -> Start search for ground fault

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The function Start search for ground fault serves to localize a ground fault and has two effects in Runtime:

  1. Fault reports from all ground fault identification devices that were configured with wiper message processing are ignored.
  2. The search algorithm is changed: Switch actions can only reduce the area subject to a ground fault further. Newly received messages do not therefore increase the area potentially subject to a ground fault.

To configure the Start search for ground fault function:

  • create a new function
  • navigate to the error detection node in the electrical network
  • Select the Start search for ground fault function

  • link the function to a button


Acknowledge ground fault message

Manual -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Search for ground fault -> Acknowledge ground fault message

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the Acknowledge ground fault message function, an internally recorded ground fault from a ground fault indication device can be acknowledged. In doing so, the internally-latched ground fault status is reset if the status is still pending, or highlighted as acknowledged. A recorded ground fault message is only deleted internally if this has been acknowledged and is no longer pending.

Rules when acknowledging:

  • If a variable that corresponds to a triggering or direction variable of a ground fault recognition device is linked, this special ground fault message is acknowledged.
  • If no variable has been linked, all ground fault messages are acknowledged.
  • Acknowledgment can also take place via the zenon API object model.

To configure the Acknowledge ground fault message function:

  • create a new function
  • navigate to the error detection node in the electrical network
  • Select the Acknowledge ground fault message function

  • the dialog to select a variable opens
  • link the desired variable to the function
  • link the function to a button


Stop search for ground fault

Manual -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Search for ground fault -> Stop search for ground fault

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You end the ground fault search with the Stop search for ground fault function in Runtime.

To configure the function:

  • create a new function
  • navigate to the error detection node in the electrical network
  • Select the Stop search for ground fault function

  • link the function to a button


Short circuit search

Manual -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Short circuit search

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The short circuit search serves to highlight the network parts that potentially have a short circuit by coloring these. The color is taken from the configuration of ALC source colors for the SHORT FAULT source.

The network parts that are potentially subject to short circuits are deduced from short circuit reports. A short circuit identification device (short circuit indicator, protective device) can have one to three short circuit messages. For directional short circuit indication devices, the direction can be lagging or leading in relation to triggering. A network component that potentially has a short circuit is then no longer considered to have a ground fault if this has been successfully connected.

Engineering

To configure the short circuit search:

  1. assign the combined element that represents the switching element to the Function type switch
  2. define Short circuit display andShort circuit identification triggering
  3. Set up the Acknowledge short circuit message function


Short circuit identification type

Manual -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Short circuit search -> Short circuit identification type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The direction and type of information processing for the switch type combined element are determined by the Type setting. to configure:

  1. navigate to the Automatic Line Coloring node in the combined element properties
  2. open the Short-circuit detection node
  3. select the desired type at the Type property
    • Direction:
      indicates if the raising edge of trip alarm or if the raising edge of a direction comes before
    • leading:
      The current direction status is used for the raising edge of the trip alarm
    • lagging:
      after a raising edge of the trip alarm, the first raising edge of a direction is waited on; if this does not occur within 2 seconds, the short circuit device is considered non-directional
    • Information processing:
      states which information can be processed
    • none:
      normal switch; information is not processed
    • Permanent message processing:
      Newly received messages are considered a new ground fault trip


Short circuit display

Manual -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Short circuit search -> Short circuit display

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The variable linked at Display is an output variable for error detection and displays the recorded status of the short circuit identification device. This is necessary because all messages remain saved internally until they are acknowledged, i.e. they do not necessarily conform to the current status of the message variables.

Each time a recording is made, a set value is sent to this variable. In doing so, the values are as follows:

Value | Meaning
0 | no short circuit
1 | Short circuit forwards
2 | Short circuit backwards
3 | Non-directional short circuit


Short circuit identification triggering

Manual -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Short circuit search -> Short circuit identification triggering

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The variable for the message from the short circuit identification device is defined by the Triggering variable You can receive information about the presence of a short circuit and the direction of the short circuit from the point of view of the short circuit identification device.In doing so, a distinction is made between:

  • non-directional short circuit reporters
  • directional short circuit reporters with a trip alarm
  • directional short circuit alarms with a trip alarm

To configure the variables for:

  1. navigate to the Automatic Line Coloring node in the combined element properties
  2. open the Short-circuit detection node
    1. for non-directional short circuit detection devices

      Click on the ... button in the Triggering property

      select the variable you wish to import in the dialog that opens

      The properties for the direction remain empty

    2. for directional short circuit detection devices with a trip alarm

      link the variable with Triggering and add the appropriate direction:

      Forwards: link a variable to the Forwards property

      Backwards: link a variable to the Backwards property

    3. for directional short circuit detection devices without a trip alarm

      Link the variable with the corresponding direction:

      Forwards: link a variable to the Forwards property

      Backwards: link a variable to the Backwards property

      The Triggering property remains empty


Acknowledge short circuit message

Manual -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Short circuit search -> Acknowledge short circuit message

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the Acknowledge short-circuit message function, an internally recorded short circuit from a short circuit indication device can be acknowledged. In doing so, the internally-latched ground fault status is reset if the status is still pending, or highlighted as acknowledged. A recorded short circuit message is only deleted internally if this has been acknowledged and is no longer pending.

Rules when acknowledging:

  • If a variable that corresponds to a triggering or direction variable of a short circuit recognition device is linked, this special short circuit message is acknowledged.
  • If no variable has been linked, all short circuit messages are acknowledged.
  • Acknowledgment can also take place via the zenon API object model.

To configure the Acknowledge short-circuit message function:

  • create a new function
  • navigate to the error detection node in the electrical network
  • Select the Acknowledge short-circuit message function

  • select the variable you wish to import in the dialog that opens
  • link the function to a button


Impedance-based error detection and calculation of load distribution

Manual -> Automatic Line Coloring (ALC) - Topology -> Impedance-based error detection and calculation of load distribution

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Impedance based error detection and calculation of load distribution expands ALC. Whereas ALC identifies nodes and beams, this model also detects lines and their parameters. The model is not used internally in zenon, but provides properties and methods for external evaluation.

Properties for ALC and the extended topological model

The ALC elements combined element and line (line, polyline, tube) have special properties for error detection for protection and to calculate the load distribution. These properties are not evaluated in zenon, but are available via the zenon API algorithms to be created by users.

The simple topological model for the coloring was supplements by an expanded topological model that includes all lines as separate beams. The extended topological model is stored as ALC.xml and can be read by external applications this way. ALC.xml contains two sections:

  • GraphElements: contains the extended topological model without aliases
  • GraphAliases: contains only the aliases

Each object has a unique ID, via which it is referenced in the file. The attributes correspond to a subset of the zenon screen elements that have created the elements.

GraphElement

ID | Description
Picture | Screen name
ElementID | Screen element ID
ElementRef | Screen element reference
Type | Screen element -type (see "element")
SourceID | Source number
ReverseSourceID | Source name in reverse direction
Variable | Status variable
VarProtReact | Reactance variable
MaxIType | Type of maximum current
MaxIVal | Maximum current constant value
VarMaxI | Maximum current variable
VarCurI | Instantaneous current variable
VarCalcI | Calculated current variable
VarCurP | Instantaneous power variable
LoadType | Type of load
LoadVal | Load constant value
VarLoad | Load variable
React | Reactance
Resist | Resistance
Length | Line length
Node1IDs | List of all element IDs connected with Node1
Node2IDs | List of all element IDs connected with Node2

GraphAlias

ID | Description
Picture | Screen name
ElementID | Screen element ID
ElementRef | Screen element reference
Type | Screen element -type (see "element")
OrigElemRef | Screen element - reference to the original screen element
OrigGraphElemID | ID of the original elements in "GraphElements"

API

In the object model of the zenon API, the objects ALCGraphElement and ALCGraphAlias are available for the model. These contain the same information as the XML file. These objects can be accessed in the ALC engine via:

  • GraphElemCount()
  • GraphAliasCount()
  • GraphElemItem()
  • GraphAliasItem()

User-specific topological interlockings

If a topological interlocking is checked, the following event is called up at the ALC engine:

  • void CheckInterlocking(IALCEdge* pALCEdge, long nNewState, tpLockResult* LockResult, BSTR* bsText, VARIANT_BOOL* bUnlockable);

The switch/disconnector to be switched and the new status is transferred. The event can fill LockResult, bUnlockable and bsText in order to display a breached interlocking condition. If the event handler returns tpBusy in LockResult, the event handler is queried until it no longer provides tpBusy, however for a maximum of 10 seconds. The interlocking is active after 10 seconds. The interlocking text and unlockability are reported back in bsText and bUnlockable.

Screen marker

Marker elements can be inserted into screen s via the zenon API.

These are added or deleted via the API functions in DynPictures:

  • BSTR AddMarker(BSTR bsScreenName, long nElementID, short nPosition, short nLineColorIndex, short nFillColorIndex);
  • VARIANT_BOOL DelMarker(BSTR bsID);

The GUID of the marker, which is supplied by AddMarker(), identifies the marker uniquely and serves as both the element name (with the prefix "$MARKER_") as well as the key for deletion via DelMarker(). The markers inserted via API are saved in the project according to the screen. Attention: Saving is not remanant, i.e. only until Runtime is restarted.

The markers set there are displayed regardless of the monitor on which the screen is opened. The markers are treated internally as normally operable screen elements. Mouse events are called up for this.

The appearance of the markers is set using the project settings in the Automatic Line Coloring area of the project configuration:

  • Display type of the screen marker: Triangle, circle, square, cross
  • Screen marker size: Size in pixels:
  • Line width of the screen marker: Width in pixels
  • Marker color: is defined via the index in the marker color table, that is located in the properties of the screen elements in the Automatic Line Coloring group


Batch Control

Manual -> Batch Control

The module Batch Control offers the possibility to automate batch-orientated manufacturing processes for lot products. The module complies to ANSI/ISA–88.01–1995 also know as ANSI/ISA–S88.

For Batch Control there are two different editors available in the Runtime.

  • Matrix editor: For simple, sequentially or parallel running recipes.
  • PFC editor: For complex recipes with sequence selection.

Depending on the license, either both editors or only the matrix editor is available to you.

tutorial License information

Must be licensed for Editor and Runtime (single-user, Server, Standby and Client). Licensing distinguishes after use of:

  • Matrix editor
  • Matrix Editor and PFC Editor

Editor:

For the engineering in the zenon Editor one of the Batch editors must be licensed.

Runtime:

For execution in Runtime, a Batch Editor must be licensed in order to fill the list of recipes. Creating and editing recipes is only possible for the licensed editor.

Network:

In the network the license of the Server counts. Stand-alone licenses of the Clients are ignored in network operation.

attention Attention

Hints in the property help about VBA keywords and XML export are not functional at the moment.

Note for change from 7.00 to 7.10 or higher

Before converting a project to a new zenon version all recipes must be completed. Recipes that are running continue to be executed after a restart. The restart only functions within the same zenon version.

Attention: Projects with recipes that were created in zenon 7.10 or higher cannot run in zenon 7.0.

Effects outside Batch Control

When using different versions for Editor and Runtime, problems can occur if the Batch Control module is licensed but Batch Control is not used.

Background: Some files are compiled in Runtime as soon as the module is licensed. A batch project that was compiled with 7.0 cannot be executed in 7.10.

Solutions:

  • Compile the project with an Editor of version 7.10 or higher.
  • Use a Runtime of version 7.0.
  • Use a license that does not include the Batch Control module.

Bach Control and Command Sequencer module

If both the Batch Control module and the Command Sequencer module, which both require a license, are licensed at the same time, selection of the module used is carried out by means of the project setting.

To select the preferred module in Runtime:

  • Click on the node of your project in the Editor.
  • Go to the Runtime settings project properties group.
  • Select, for License module in Runtime of the the Preferred module property, command sequence(default) or Batch Control.

The selected model is then available in Runtime for further project configuration.


Introduction

Manual -> Batch Control -> Introduction

The module Batch Control consists of three parts:

  1. The engineering environment in the zenon Editor:
    There all units (ISA nomenclature, chapter 4.2.5: units) with their phases (ISA - 5.1.2.4: phases) and reactions are created. The phases must have an equivalent in the control (ISA: equipment control) which is called process action according to ISA.
    Batch Control reflects the physical model in accordance with ISA 4.2 as flat hierarchical level based on units.
    The other levels of the model such as process cell, area, plant, etc. were deliberately forgone. When creating the batch recipes too, only the lowest level (phases) of the ISA structure model 5.1 and operations were implemented. Additional levels such as unit procedures and procedures are not available.
  2. PFC editor and Matrix editor:
    With the help of these editors, master recipes in zenon Runtime (ISA: master recipes) are created. They form the base of the control recipes which can be executed (see also ISA 5.3.1.). During the process the exact status of the Batch recipe is displayed in the respective editor and you can interfere in the recipe process.
  3. Recipe Execution Engine (REE):
    The REE is directly integrated in the zenon Runtime and executes a Batch recipe automatically in the background. Via commands such as Start, Pause, Stop etc. the user can control the REE. There are three possible modes: Au tomatic, S emi-automatic and M anual.

Special features of module Batch Control:

In contrast to most other zenon modules, a large part of the engineering - the recipe creation - is done in the Runtime and not in the Editor. This entails special features which are dealt with in the respective chapter. So for example changed phases are no longer transferred to an already released master recipe in order to prevent unwanted data changes.

The module is designed in a way which makes it completely independent of the control. This means that the data communication take place via all available zenon drivers with any PLCs or even RTUs. They only execute the process actions. The entire recipe processing is done at the computer in the REE. For changes on the Batch recipe or for new master recipes, no modifications are necessary in the PLC code.

The module follows the strict separation between the procedure of the batch recipe (ISA: Procedural Control Model) and execution of the technological function (ISA: Process Model) as describe in ISA–S88, chapter 5.2.1.

Principle structure of the communication

For the communication with the process standard zenon variables are used. As variable names often have cryptic label, an additional abstraction level was introduced. It contains the tags which are available in two types:

  • Command tag: They are used to transfer set values to the PLC when a phase is executed.
  • Return tags: They are used to return values from the PLC for evaluation.

With both tag types values can be both written (e.g. in reactions) and also read (e.g. in conditions).

Schema:

The PLC communicates with the zenon driver. The driver communicates with the zenon Runtime. The Runtime sends the values to the REE where they are processed. The REE internally works asynchronously to the zenon Runtime in a 100 ms cycle.

Network

The module Batch Control is fully capable of using a network in terms of Client/Server technology. This means that Batch recipes can be created, duplicated, edited, deleted, etc. on a Client. The whole recipe management remains always on the server. Likewise the whole process control such as start recipe, pause recipe, stop recipe, etc. can be done from the Client. Also mode changes and manual operations such as jump are possible.

attention Attention

Module Batch Control does not support redundancy. There is no synchronization between Standby Server. When the Server breaks down, the executed Batch recipes are not continued seamlessly on the Standby!


Terminology

Manual -> Batch Control -> Terminology

In the zenon module Batch Control the following terms are used:

Term | Definition
Unit | Physically available machine or equipment part with which phases can be carried out. (ISA 88 Unit)
Releasing the unit | Element of module Batch Control which cancels the allocation of a unit in the unit manager. With this the unit can be allocated by another recipe again.
Unit allocation | Element of module Batch Control which causes the allocation of a unit in the unit manager. An allocated unit can only be used by phases with the recipe. With this the unit is locked for phases of other recipes which are executed parallel.
Unit manager | Internal management mechanism which manages the unit allocation for all REE's in the Runtime.
Action | Used in Batch Control: all commands which are used for editing a recipe e.g. insert phase, testing recipes etc.
Begin simultaneous sequence | Element that ensures the separation of the recipe process in two or more sequence selections.
Begin sequence selection | Element that makes it possible to separate a recipe in two or more sequence selections of which only one can be active at a time. Each following sequence selection must start with a transition. The transition defines which sequence selection is executed in the recipe process.
Begin element | Element of module Batch Control with which every recipe begins.
Active element | Position in a recipe in the batch control module where the processing is interrupted in a semi-automatic and manual mode and the active elements are put into a pause status. With the command "next step" the process is resumed from this position.
Batch Control | Tool for creating master recipes and creating and executing control recipes in accordance with ISA-S88.
Batch operation | Automatic and sequential processing of a stack of single operations.
End simultaneous sequences | Element that combines the separation of the recipe process into two or more sequence selections back into one sequence selection.
End sequence selection | Element which brings together a sequence selection started by a begin sequence selection element.
End element | Element of module Batch Control with which every recipe ends.
Phase | Predefined process consisting of input interlocking, command and return tags, a phase done condition, event reactions, etc... (ISA 88: Phase)
Command | Used in Batch Control: a command which intervenes in the recipe process e.g start, stop, mode change etc.
Matrix recipe | Recipe in the Batch Control module which was created with the Matrix editor.
Simultaneous sequence | Area of module Batch Control. A simultaneous sequence starts with a begin simultaneous sequence element and is brought together with an end imultaneous sequence element to one execution branch. Between there are at least two sequence selections which are executed at the same time.
PFC recipe | Recipe in the batch control module, which was created with the PFC Editor
REE - Recipe Execution Engine | Part of module Batch Control for process control of recipes. The engine executes a control recipe and manages the entire process of the recipe.
Recipe | In recipes related data such as machine parameters or format data are summed up. This data can be transferred from the control system to the control and vice versa in one step. We differentiate between standard recipes and RGM recipes.The procedure is defined additionally to data in Batch Control Module in a recipe. It is distinguished between Matrix recipe and PFC Recipe.
Jump target | Element of the batch control module which allows a direct jump to a defined location of a sequence selection.
Control recipe | Part of the batch control module. Contains the process of a production process on basis of the batch process according to standard ISA S88. A control recipe is always derived from a template recipe and can be implemented once only. (ISA 88: Control Recipe)
Operation | Recipes can be divided into individual parts within the batch control module. Operation management takes place via a central library. Instances of operations can be added within the recipe. Tags of the applied phase can be edited, the structure can only be edited in the operation template.
Transition | Element of module Batch Control which contains a condition. The element is used after phases in order to ensure a defined transition from one phase to another.
Connection line | Part of the connector in the Batch Control module: Positions the connection point on the element.
Connection point | Part of the connection element in the Batch Control module. Connects two elements with eachother (e.g. phase with phase or phase with line). It changes color when the mouse pointer is on it.
Connection element | A possibility in the Batch Control of connecting elements with one another. It consists of a connection point and a connection line.
Sequence selection | Area of module Batch Control which ensures a separation in two or more sequence selections, of which only one can be active at the recipe process. It is an either/or sequence selection. A sequence selection always starts with a begin sequence selection element and ends with an end sequence selection element.
Master recipe | Part of the batch control module. Contains the process of a production process on basis of the batch process according to standard ISA S88. A recipe consists of the following components: basic functions, transitions,parallel circuits etc (ISA 88: Master recipe). Template recipes serve as templates for control recipes.
sequence selection | Execution area for the Batch Control Module Basic functions, transitions and transfer targets can be placed on it.


Procedure

Manual -> Batch Control -> Procedure

The engineering and the use of module Batch Control takes place in three main steps:

  1. Engineering in the zenon Editor
  2. Recipe creation in the Batch editor (PFC or matrix) in the Runtime
  3. Recipe execution in the Runtime

Engineering

The engineer depicts the existing physical world in the Editor. He defines and creates units and assigns phases with tags to them.

Recipe creation

In the Runtime the recipe creator defines the master recipes on base of the presets from the Editor. They define the process. At this only the units, phases and tags defined in the engineering environment can be used.
Exception: If you activate property Changeable in master recipe in group Write set value in the Editor, you can modify the corresponding tag. This is only possible for command tags.

Recipe execution

The operator executes the recipe in the Runtime. For this he starts a control recipe which is based on the control recipe. Each control recipe can only be started and used once. With this it can be assigned to a lot unambiguously. Recipes run either automatically, semi-automatically or manually.

The operator cannot influence the recipes.
Exception: If the recipe creator activates option Changeable in the control recipe, the operator can edit tags in the Runtime.


Conversion

Manual -> Batch Control -> Conversion

If the version of zenon is changed, all recipes must be ended before converting the project.

Recipes that are running continue to be executed after a restart. The restart only functions within the same zenon version.


Function authorizations

Manual -> Batch Control -> Function authorizations

For changes in the Editor and in Runtime, the corresponding function authorizations can be issued to users. A warning is displayed if operations are executed for which there are no corresponding rights. Exception: No warning is displayed when editing.

Users can also log in temporarily for the execution of operations for which they have no special authorizations. For details on this, see the Permanent and temporary login section in the User administration manual.

You can find details on the individual authorizations in the User administration chapter, most of all in the Function authorizations section.

Note:

  • These function authorizations are only available if Batch Control is licensed on the computer.
  • Operation instances always use the user rights of the recipe in which they are embedded.


Engineering in the Editor

Manual -> Batch Control -> Engineering in the Editor

To use module Batch Control in the Runtime, you must do the following in the Editor:

  • create units, phases and reactions
  • create a screen of type Batch Control
  • create a screen switch function for the screen of type Batch Control

Note: In the editor, copying and inserting of elements throughout all levels is possible.

Detail view

In module Batch Control the detail view divided in two:

  • The left part features the unit tree. The entry Unit is the starting point of the tree.
    On the next level the existing units are displayed. The phase belonging to each unit follow. Each phase has the subitem reactions.
  • In the right part a flat list of the units, phases, tags or reactions is displayed depending on what level is chosen on the left side.


Job variables

Manual -> Batch Control -> Engineering in the Editor -> Job variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Job variables can be linked in the Editor. Job variables make it possible to assign job IDs to Batch productions. In order to ensure that the variable value is available immediately, the job variable is inserted into the global connection and registered when Runtime is started. The variable is requested again on reloading.

Job variables defined in the Individual job variable property can be allocated using a function. Otherwise the global Job variable is used.

Global job variables

To link a global Job variable:

  1. navigate to the General/Job variable node in the module
  2. Link a variable in the Job variable property
  3. Select, from the drop-down list of the Apply value from job variable property, the type of transfer to Runtime:
    • When creating the control recipe:

      When creating the control recipe, the current value of the variables is transferred into the control recipe. the value is displayed in the control recipe configuration dialog The value must not be empty, otherwise the recipe cannot be created.

    • When starting the control recipe:

      In Runtime, the content of the variables is written to the recipe when the control recipe is started. The value must not be empty.

    Note about value changes: The value transferred by the variables is always changed into a string, regardless of the type of variables. When changing from real to string, 10 decimal points are taken into account. Zeros at the end are cut off.

  4. You can also define a Individual job variable if you wish

In Runtime, the allocated job ID can be displayed in the list of control recipes.

Individual job variable

To link a Individual job variable:

  1. navigate to the General/Job variable node in the module
  2. Link one or more variables in the Individual job variable property
  3. When configuring zenon functions, select the desired variable and the type of allocation


Units

Manual -> Batch Control -> Engineering in the Editor -> Units

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a new unit:

  1. in the project manager go to node Batch Control
  2. in the detail view select Unit
  3. in the context menu select menu item New unit
  4. a new unit is created in the detail view


Tool bar unit tree

Manual -> Batch Control -> Engineering in the Editor -> Units -> Tool bar unit tree

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The tool bar corresponds to the complete unit tree. Depending in the selected element symbols are available or deactivated.

Parameters

Description

Rename

Opens the name filed of the selected element for renaming.

Not available for main node Units.

Copy

Copies the selected unit to the clipboard.

Not available for main node Units.

Paste

Pastes a unit that was copied to the clipboard.

Delete

Deletes selected element after confirmation message.

Not available for main node Units.

Expand all

Displays the entire tree structure.

By clicking on the arrow you receive a drop-down list in which you can select on of the following commands:

  • Expand all: expands all nodes
  • Collapse all: collapses all nodes
  • Expand selected: expands all selected nodes
  • Collapse selected: collapses all selected nodes

A click on the button always expands all elements.

Via double click on the superordinate entry elements can also be expanded or collapsed.

Help

Opens online help.


Project tree - Batch Control context menu

Manual -> Batch Control -> Engineering in the Editor -> Units -> Project tree - Batch Control context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Parameters | Description
New unit | Creates a new unit.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.


Context menu units

Manual -> Batch Control -> Engineering in the Editor -> Units -> Context menu units

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Right click the main entry Unit in the unit tree to open a context menu:

Menu item | Action
New unit | Creates a new unit.
Replace linking in phase | Opens the dialog to replace linking for linking in phases.
Replace linking in units | Opens the dialog to replace linking for linking in units.
Paste | Pastes a unit that was copied to the clipboard.
Help | Opens online help.


Context menu unit X

Manual -> Batch Control -> Engineering in the Editor -> Units -> Context menu unit X

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Right click on a created unit in order to open the context menu:

Menu item | Action
New phase | Creates a new phase.
Replace linking in phase | Opens the dialog to replace linking for linking in phases.
Replace linking in unit | Opens the dialog to replace linking for linking in the selected unit.
Rename | Allows you to rename the selected unit.
Delete | Deletes the selected unit.
Copy | Copies the selected unit to the clipboard.
Paste | Pastes a unit that was copied to the clipboard.
Help | Opens online help.


Detail view units

Manual -> Batch Control -> Engineering in the Editor -> Units -> Detail view units

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Menu item | Action
New unit | Creates a new unit in the detail view.
Replace linking in phase | Opens the dialog to replace linking for linking in phases.
Replace linking in units | Opens the dialog to replace linking for linking in units.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Remove all filters | Removes all filter settings.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Help | Opens online help.


Detail view unit X

Manual -> Batch Control -> Engineering in the Editor -> Units -> Detail view unit X

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters | Description
New phase | Creates a new phase in the detail view.
Replace linking in phase | Opens the dialog to replace linking for linking in phases.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Remove all filters | Removes all filter settings.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected cell | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Help | Opens online help.


Information in Runtime

Manual -> Batch Control -> Engineering in the Editor -> Units -> Information in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Information on individual units can be called up and displayed using variables. Each element to be allocated initializes the values of the linked variables with 0 or empty text. The information comes from the recipe that allocates the unit when the query takes place. Variables are always only filled in the event of a change.

The variables for the information desired in Runtime is configured in the unit properties in the Runtime information group for:

  • Master recipe: Information on ID, name and description of the master recipe, as well as version and initial version.
  • Control recipe: Information on ID, name and description and job ID of of the control recipe.
  • Execution: Information on the number of active recipes and execution status and mode, numerically and as a text respectively.

    Note: The value for Number of active recipes is generally 0 or 1. If a higher number is displayed, then the start of other recipes was forced manually.

  • Phases: Information on active phases. If the phase is in an operation, the name of the operation is displayed in brackets.
  • Error: Errors are shown visually in Runtime and saved in logs. A process error in the unit is shown visually this way and the absolute number of historical procedure errors is also displayed. The counter is increased by 1 as soon as a procedure error occurs. If the phase is restarted, the historic error goes from the display; it is no longer signalized visually. The logged information is retained however. The same applies to communication failures: Symbols only display active errors; counters also inform you of historic errors.
  • Matrix information: Display of the active steps in a matrix recipe. It is always the information from the main recipe that is used, even if the object to be triggered is in an operation. All numerical variables whose data type >= 2 byte can be selected.
    PFC recipes always receive empty values or 0.

Execution status and execution mode of values

Values for variables in the Execution status (numeric) property:

Status | Return | Remark
Idle | 0 |
Running | 1 |
Executed | 2 | Is never displayed, because a completed recipe does not allocate the unit.
Stopping | 3 |
Stopped | 4 | Is never displayed, because a stopped recipe does not allocate the unit.
Pausing | 5 |
Paused | 6 |
Holding | 7 |
Held | 8 |
Aborting | 9 |
Aborted | 10 | Is never displayed, because an aborted recipe does not allocate the unit.
Restarting | 11 |

Values for variables in the Execution mode (numeric) property:

Mode | Return | Remark
Ignore | 0 | No recipe runs
Automatic | 1 |
Semi-automatic | 2 |
Manual | 3 |


Phases

Manual -> Batch Control -> Engineering in the Editor -> Phases

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The phase is the execution object of a recipe - and therefore its main component. Each phase in module Batch Control must stand facing a Technological function in the control.

Example: You want to heat up a tank. For this you need:

  1. The corresponding equipment: a heating in the tank.
  2. A temperature sensor which measures the actual temperature in the tank. Connect this sensor with a control.
  3. In the control a program which controls the heating until the set temperature is reached.
    This control program is the process action in the PLC. It
    • has an input tag: a set temperature - which is implemented via a command tag in Batch Control
    • needs an output tag - also a set temperature - which must be reached and which is implemented via a return tag in Batch Control

To inform the control about the progress of the recipe, you need corresponding status information which is transferred to the control. For this you use reactions and conditions for the response.

A phase therefore consists of:

Parameters | Description
Command tags | The set values which should be transferred to the control
Return TAGs | The response values which inform the REE about the status of the process action in the control. They can be evaluated in conditions and transitions.
Reactions | REE events can be used on the one hand to inform the process action in the control about the state of the REE and on the other hand to inform the user about errors (e.g. time outs, invalid tag values). time outs, invalid tag values).
Conditions | Are used for the evaluation of the return tags: The state of the process action in the control is evaluated.
Times | Time critical processes can be monitored with this. If the engineered time is exceeded, an event is triggered on which you can react with a reaction.

Engineering

To create a new phase:

  1. select the unit for the phase or first create the desired unit
  2. in the context menu select menu item New phase
  3. a new phase is shown in the detail view
  4. the subitem Reactions is automatically added to the phase

info Information

If several phases are selected in the Editor at once whose formulas are identical but whose tags are different, this is not displayed by color coding the different values.


Context menu phase

Manual -> Batch Control -> Engineering in the Editor -> Phases -> Context menu phase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu phase X

Right click on a created phase in order to open a context menu for creating the parameters:

Parameters | Description
New initial tag | Creates a new initial tag.
New value tag | Creates a new value tag.
New return tag | Creates a new return tag.
Replace linking in phase | Opens the dialog to replace linking for linking in phases.
Rename | Makes it possible to change the name of the currently selected phase.
Delete | Deletes the currently selected phase after a confirmation message.
Copy | Copies the selected element to the clipboard.
Paste | Pastes an element script that was copied to the clipboard.
Help | Opens online help.


Detail view phase

Manual -> Batch Control -> Engineering in the Editor -> Phases -> Detail view phase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters | Description
New initial parameter | Creates a new initial tag.
New value tag | Creates a new value tag.
New return TAG | Creates a new return tag in the detail view.
Replace links | Opens the dialog to replace links.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Remove all filters | Removes all filter settings.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Help | Opens online help.


Conditions

Manual -> Batch Control -> Engineering in the Editor -> Conditions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The conditions are used to inform the REE about the status of the process action in the control. For evaluating the conditions formulas are used which where created with the formula editor.

Hint: Use a single status tag (return tag) which takes on different values in order to transmit the status of the process action in the control to the phase. You can find an example in chapter Example for status parameter.

Engineering

To create a new condition:

  1. click on the corresponding phase
  2. in the properties select the desired conditions from node General orCondition transient states
  3. click in the field for the value or on button ...
  4. the formula editor is started
  5. define the formula for the condition

Note: The counterpart to the conditions are the reactions. With them, the execution status is transferred to the technological functions of the controller.

Transient states

As transitions the following properties are available

  • Paused
    Within the phase the process stops at:
    • Waiting for Finished
    • Waiting for allocation
    • Waiting for interlocking
    • Waiting for Phase finished
    • Check for parallel execution
  • Held
    Within the phase the process stops at:
    • Waiting for Finished
    • Waiting for allocation
    • Waiting for interlocking
    • Waiting for Phase finished
    • Check for parallel execution
  • Stopped
  • Aborted
  • Restarted
    Phase is completely restarted.
  • Escape condition
    If this condition is met, the current execution step is stopped and the phase is exited. You can find details in the Exiting a phase chapter.

Variables

Transition conditions can be linked with a binary variable which defines when the phase changes its status. The status changes is delayed until:

  • the value of the variable is defined
  • the value of the variable is 1
  • the status of the variable is not invalid.

If no variable is defined, the status change is always allowed.

All variables for the status change are requested at the advising of the variables in order to receive a value as soon as possible. The values for a variable which define a status change are read on the change to the transient status. A possible pulse must have value TRUE within the waiting period in order to be recognized.

Note: When closing the Runtime, it is not waited for the variable for the status change from stopping to stopped as at this time all variables are already signed off.


Waiting periods

Manual -> Batch Control -> Engineering in the Editor -> Conditions -> Waiting periods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The recipe creator can define waiting periods. The configuration of waiting periods (time outs) prevents that time-critical processes take too long because of unforeseen events. If the condition is not fulfilled within the defined waiting period, a corresponding event is triggered. With the reactions you can react on the event and influence the recipe process.

For all waiting periods the following is true:

  • If 0d 00:00:00 is defined as waiting period, the event is not triggered.
  • The waiting periods are independent of the recipe status (e.g. Recipe paused) and continue to run even when the Runtime is closed and restarted.
  • If a phase is held and restarted, the waiting periods are also restarted.
  • If a phase is passed through several times, the waiting periods are started again for every pass.
  • Waiting periods themselves do not influence the process. They are simply used to generate an event. The reaction must be defined in the event. After the event is triggered, it is still waited for the fulfillment of the condition.


Reactions

Manual -> Batch Control -> Engineering in the Editor -> Reactions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Reactions are the most important piece to influence the recipe process and to communicate with the control. Reactions are always based on events. This can be events of the REE (e.g.: Phase started) and also general events (e.g. Exit Runtime initiated). With the help of reactions you can e.g. tell the control when a phase has been started or finished in the REE and when all command tags have been written.

Likewise you must transfer the status of the phase to the control with the help of the reactions. Otherwise the control has no information about the process of the recipe.

Example: If you stop the REE or the phase, the event Status change: Stop will be triggered. As reaction you can transfer this status change as set value input to the control. Only then can the control react and stop the process action. You can find an example in chapter Example for status parameter.

Note: The counterpart to the reactions are the conditions. With them the states of the process action in the control is transferred to the REE.

Engineering

With each phase the node Reactions is created automatically. In this node you can created any reactions. To create a new reaction:

  1. click on reactions
  2. in the context menu select menu item New reaction
  3. a new reaction is shown in the detail view
  4. in the detail view click on the entry in column Event
  5. select the desired event from the drop-down list and define the desired reaction type in the property window.

For each reaction type several reactions are possible. They are sorted at the triggering and are executed in accordance to their priority. At this 1 is the highest priority. Reactions of the same type can only be re-sorted using the toolbar or context menu.

Some of the reactions are triggered only once in the process - e.g. time outs. If the phase is restarted, these reactions are also retriggered if necessary.

Reactions can only use tags of their own phase If reactions are copied from other phases, they try to use tags with the same name of the name phase.

Values of the reactions are logged in the CEL.

Project configuration rules

  • Reactions can appear in each object state.
  • For each reaction type several reactions are possible. They are sorted at the triggering and are executed in accordance to their priority. At this 1 is the highest priority.
  • All variables of all parameters are signed in to the driver for reading. If a value is needed at a reaction but is not yet available or invalid, the alternate value is written. The writing of the value is done without write confirmation.
  • Some of the reactions are triggered only once in the process - e.g. time outs. If the phase is restarted, these reactions are also retriggered if necessary.

Runtime: User

If zenon functions are executed by a reaction, the reaction is reported as the user System.


Context menu reactions unit tree

Manual -> Batch Control -> Engineering in the Editor -> Reactions -> Context menu reactions unit tree

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Parameters | Description
New reaction | Creates a new reaction in the detail view.
Replace links | Opens the dialog to replace links.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Help | Opens online help.


Detail view reactions

Manual -> Batch Control -> Engineering in the Editor -> Reactions -> Detail view reactions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters | Description
New reaction | Creates a new reaction in the detail view.
Execution order: Earlier | For reactions of the same type: Moves the reaction forward in the execution order.
Execution order: Later | For reactions of the same type: Moves the reaction backward in the execution order.
Execution order: Change places | Only active if exactly two reactions are chosen. The two selected reactions change their places in the execution order.
Replace links | Opens the dialog to replace links.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Remove all filters | Removes all filter settings.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Help | Opens online help.


Events

Manual -> Batch Control -> Engineering in the Editor -> Reactions -> Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Each reaction is a reaction to an event. The event is defined in property Event. For each event several reactions can be defined. The execution order can be defined in the detail view.

When validating the recipe in Runtime, the name of the event is displayed in the event of an error.
Syntax: (event name.x) whereby event name corresponds to the Event. x is a number that indicates the position in the execution sequence.

From the drop-down list you can select the following events:

Event

Description

Procedure

Events in the procedure.

Phase activated

Is the first event which is triggered.

With this event, you tell the PLC that the phase has been activated in the REE and that the phase is expected to be started soon.

Unit allocation not possible

Is triggered if the unit was not allocated successfully at first try.

Phase started

With this event you tell the PLC that the phase has been started in the REE and that it is likely that the command tags will be written soon.

Other events can be executed before the event if the Allow execution before start event has been activated for the corresponding event. For details, see the Allow execution started before phase started section.

Input interlocking blocked

Is triggered if the input lock has been successfully checked.

Makes only sense if property Interlocking condition was configured.

Input lock checked successfully

Is triggered if the input interlocking was blocked at the first check.

Makes only sense if property Interlocking condition was configured.

Finished writing command TAGs

Is triggered if all command tags have been written. It cannot be guaranteed however that really all tags arrived at the control. It depends on the communication and the respective driver. It can however be assumed.

Recommendation: Use this event to tell the PLC that the phase has written all command tags and the PLC can start processing the process actions.

Phase done condition completed

Is triggered if the phase is finished. This event is the last reaction of the phase and independent of the reason of the finishing. With this the phase done condition is fulfilled.

This event is also triggered at a restart.

Phase deactivated

Is triggered if the phase was started and now is finished.

Timeout

Timeout events.

Phase started multiple times

A phase can only be active once. If it is activated several time in parallel, this event is triggered.

Waiting period unit allocation exceeded

Is triggered if the waiting duration for the unit allocation runs. Can also occur during Paused and Held.

Waiting period input interlocking exceeded

Is triggered if the waiting duration (time out) for the input interlocking expired.

Makes only sense if a Interlocking condition was defined.

Command parameters without value

Is triggered if the command tag should be toggled and the variable linked to the tag doe not have a valid initial value.

Maximum execution period exceeded

Is triggered if the waiting duration (time out) for waiting for the phase done condition (Finished) was exceeded.

Waiting period following condition exceeded

Is triggered if the phase was not finished within the scheduled waiting duration (time out) although the phase done condition was fulfilled.

Linked variable invalid
  • If the value of a variable with status INVALID should be used, this event is created once per invalid variable and phase.
  • If the variable status changed from INVALID to not INVALID and back to INVALID, the reaction is again triggered when the variable is used.
  • If the phase is restarted, the event is triggered again when an invalid variable is used.

At the following activities it is checked for invalid variable:

  • Source variable in reaction
  • Variable for phase done condition
  • Variable for input interlocking
  • Write command tag inversely
  • Variables for status change at transient states allowed
  • Note: INVALID events are not processed in the sequence that they occur. If an INVALID event occurs whilst processing another event, this event can go before the one that is being executed.

Status change

Status change events.

If the phase changes its status, the corresponding reaction is activated.

Status change: Running

The phase is executed.

Status change: Pausing

The phase is switched to Paused at the moment.

Status change: Paused

The phase is paused.

Status change: Continue

The phase is resuming after a break.

A status change in the object from Paused to Running triggers the events Resuming and Running.

Status change: Holding

The phase is held at the moment.

Status change: Held

The phase was stopped.

Status change: Restarting

The phase is restarting at the moment.

Status change: Stopping

The phase is stopping at the moment.

Status change: Stopped

The phase was stopped.

Status change: Aborting

The phase is aborted at the moment.

Status change: Aborted

The phase was aborted.

Status change: Executed

The phase is finished.

Escape condition started

Is triggered if the Escape condition for exiting from a phase is started.

Escape condition fulfilled

Is triggered if the Escape condition for exiting from a phase is met.

Mode change

Events in relation to mode change in the REE

Mode change: Automatical

The REE switched to mode Automatical.

Mode change: Semi-automatic

The REE was switched to semi-automatic mode.

Mode change: Manual

The REE switched to mode Manual.

Close and restart Runtime

Events in relation to closing and restarting Runtime.

Exit Runtime initiated

Is triggered if the Runtime is exited. This is an especially critical state for module Batch Control as the recipe process does not stop in the control immediately. Therefor exiting the Runtime is prevented as long as module Batch Control saved all data. A process image is created which can later be used as starting point.

Likewise it is made sure that the tags of action Write set value safely arrive at the control. Internally the phase is paused only when the writing confirmation from the driver ensued.

For more details about existing the Runtime see chapter: Exit and restart Runtime.

At this event no reaction types of group Influencing the recipe are possible.

Runtime restart

The Runtime was restarted.

Interruptions and errors

Events in relation to interruptions and errors in communication and on the PLC.

Loss of communication

This event reports that communication has been interrupted.

Loss of communication fixed

This event reports that the communication failure has been rectified.

Loss of communication acknowledged

This event reports that a displayed communication failure has been acknowledged.

PLC error

Is triggered if there is a PLC error.

PLC error rectified

Is triggered if a PLC error has been rectified.

PLC error rectified by deactivating the phase

Is triggered if there was a PLC error when a phase was ended. This was changed to rectified when it ended. Does not apply for a restart of the phase.

Events on restart

The reactions phase activated, phase started and phase deactivated are always only executed once. These reactions are not triggered again after the phase has been restarted. The phase starts to proceed again, however it was not executed in full beforehand.

Along the same lines, the reaction phase deactivated is only triggered once the phase has been ended and not during a restart.

The phase started reaction is triggered if the unit allocation and the parallel execution detection has been executed. If the procedure has not exceeded this detection on restart, the reaction is triggered for the Restart command. If the process is already in an advanced state, the reaction is not carried out again.

Allow execution before "Phase started"

Events can be also be approved before the phase started event. To do this, the Allow execution before start event property must be activated for the corresponding event. This property can only be configured for events that are possible both before and after phase started. The value is automatically set according to type for all other events.

The following events are approved before and after "phase started":

  • Mode change
  • Status change
  • Exit from a phase
  • Exit Runtime initiated
  • Restart Runtime
  • Linked variable invalid
  • Phase deactivated (can occur before if the phase was exited before phase started)
  • Waiting period for subsequent conditions (can occur before if the phase was exited before phase started)
  • Communication failures (however only from the point at which the values for the Loss of communication property are waited for)

The following events are only approved before "phase started":

  • Phase activated
  • Unit allocation
  • Phase started more than once (exclusive execution)

All other events are only approved after the Phase started event.


Reaction types

Manual -> Batch Control -> Engineering in the Editor -> Reactions -> Reaction types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the properties of the reactions the reaction types more precisely defined and engineered. In group Reactions the following reaction types are available:

Reaction type

Description

Tag set value

Influences command and return tag directly. All tag data types can be used.
Attention: The value must be within of the set value limits of the variables which are linked at the tag. If this is not the case, an error message is created during the validation.

CEL entry

Creates entries in the CEL and log files. With this the reaction can be documented and the recipe process can be tracked later. For this property Create CEL entry must be activated. The text for the CEL is defined in property CEL message text.

Function

Makes it possible to link any zenon function.

With this you can e.g. call up a pop-up in order to inform the user about a certain status or start a data backup.

Note: In the network the function is always executed at the server.

Allocate tag

Makes it possible to perform a value assignment from Source tag to another Target tag. You can use both command tags and return tags. The data type of source and target tag must be identical otherwise an error is displayed at the validation of the recipe.

Recipe influence

Make it possible to:

  • Change the execution mode
  • Execute commands for the REE
  • execute phase commands

With this you can react on serious events such as Waiting duration exceeded or Linked variable invalid.

Note: Use this reaction type carefully as this reaction type influence the entire recipe process.

For each event you can only once:

  • set the Mode and
  • write a single Command

Because e.g. it does not make sense to pause and hold the recipe at the same time with the same event.

You can read more about commands in the commands and actions chapter.


TAGs

Manual -> Batch Control -> Engineering in the Editor -> TAGs

TAGs are the communication interface to the control. With them all values are transferred to the control and also read back. To not have to work with complex and for the user incomprehensible variable names in module Batch Control, the abstract level is used. Each tag consists - for each phase - of an unique name and a description. With this the engineer can give the recipe creator or user a description for what the tag is used or which effects it has.

You can add any number of tags to a phase. We distinguish between command tags and return tags. Command parameters are further subdivided into initial parameters and value parameters. Each tag can be switched between command and return tag at any time.


Detail view tag

Manual -> Batch Control -> Engineering in the Editor -> TAGs -> Detail view tag

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tool bar and context menu provide commands to create and administer variables of parameters.

Parameters | Description
New initial parameter | Creates a new initial parameter in the detail view.
New value tag | Creates a value parameter in the detail view.
New return TAG | Creates a new return tag in the detail view.
Replace links | Opens the dialog to replace links.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Remove all filters | Removes all filter settings.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Help | Opens online help.


Command TAGs

Manual -> Batch Control -> Engineering in the Editor -> TAGs -> Command TAGs

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Command parameters transfer information and values to the controller. They can be subdivided into:

  • Initial parameters: Command parameters that are set before the start event. They transfer information that must be stored before setting the input lock in the controller, for example, which control strategy is executed.
  • Value parameter: Command parameters that are sent after input locking when the phase is executed.

Command tags contain the set values which should be transferred to the control. Initial parameters and value parameter are backed up and written to the controller. You can find the exact description in chapter: Process of a phase in detail.

Command tags can also be used in transitions, conditions and reactions. Initial parameters and value parameters can have the same variable linked. This is taken into account when validating for multiple use of a variable.

Command parameters have a number of properties which can be defined via the property window. For this, the following applies:

  • Each tag must be linked with a variable.
  • The data type of the variable must correspond to the data type of the parameter.
  • The set value limits of the parameter must be within the set value limits of the variable.

If this is not the case, error messages are created during the validation.

Hint to property Changeable in master recipe: With this you define whether the value of the command TAG may be modified by the creator of the master recipe. If e.g. machine tags should not be changeable in the recipe but defined fixedly, you must deactivate this property.

Engineering

To create a new command tag:

  1. select the desired phase
  2. Select, in the context menu, the command New initial parameter or New value parameter
  3. a new command tag is created in the detail view

Note on compatibility

If Runtime files are created for zenon 7.10 or older versions, then the initial parameters and value parameters are treated the same as command parameters again. command parameters from zenon 7.10 or earlier are all converted to value parameters.


Return TAGs

Manual -> Batch Control -> Engineering in the Editor -> TAGs -> Return TAGs

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The return tags contain the return values with which the process action of the REE communicate its status. Normally the value is set by the control and evaluated by the REE. Return tags can be evaluated in transitions and conditions.

Likewise they can be used in reactions and can also be written there. For this the are listed as target tags at Allocate tag and Tag set value.

Engineering

To create a new return tag:

  1. select the desired phase for which you want to create a new return tag
  2. in the context menu select menu item New return tag
  3. a new command tag is created in the detail view


Example for status tag

Manual -> Batch Control -> Engineering in the Editor -> TAGs -> Example for status tag

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To be able to communicate with the control, you normally need two status tags:

  • one in write direction and
  • one in read direction

The variable behind these parameters should have a numeric data type such as USINT or UINT.
We recommend that you execute both parameters as return parameters. This may seem illogic for commands in write direction at first glance but has the following background: At the execution of the phase, all command tags are written. With this they are visible in the list of command tags and can therefore be deleted accidentally. This makes no sense for a command for the control. The goal is not just to communicate a single value to the control as command but to transmit the status of the phase in the the recipe.

Especially at the writing of a command tag it makes sense to not simply inform the PLC about the writing but the status when all values have been written and the PLC therefore can start to process the process action.

For this it is best to use the reaction to event Finished writing command tags. At reactions to an event you can also write values to an return tag. Therefore it is better to use return tags for both status tags.

Here is an example about which values the tags can take on:

Status tag in write direction (to the PLC): Commands

Value | Name of the event
0 | not defined
1 | Phase started
2 | Finished writing command tags
3 | Phase finished: Phase done condition fulfilled and Minimum execution duration reached (if engineered)
4 | Phase deactivated
5-9 | Reserve
10 | Status change: Pausing
11 | Status change: Resuming
12 | Status change: Holding
13 | Status change: Restarting
14 | Status change: Stopping
15 | Status change: Aborting
16-19 | Reserve
20 | Mode change: Automatical
21 | Mode change: Semi-automatic
22 | Mode change: Manual
23-29 | Reserve
30 | Exit Runtime initiated
31 | Runtime restart
32 | Unit allocation not possible
33 | Waiting period unit allocation exceeded
34 | Input interlocking blocked
35 | Waiting period input interlocking exceeded
36 | Maximum execution period exceeded
37 | Waiting period following condition exceeded
38 | Phase started multiple times

You can find the exact meaning of the events in chapter Event type.

For each entry in the table you define a corresponding reaction for writing the status value at the phase.
Hint: Use the same tag label for all phases; e.g. StatusPhase. Then you only have to engineer the reaction at one phase and can then transfer it to all phases via copy & paste. You can of course also copy the tags. Do not forget to correct the variable. They must match the respective phase.

Tag in read direction (from the PLC): Return Values

Value | Description | Linked in property
0 - 1 | Not defined |
2 | Process actionfinished | Phase done condition
3 - 9 | Reserve |
10 | Process action paused | Paused
11 | Reserve |
12 | Process action held | Held
13 | Process action restarted | Restarted
14 | Process action stopped | Stopped
15 | Process action aborted | Aborted

Link the values with a formula in the respective property.

Hint: You can copy the formula and just change the respective value. If you make this setting at the beginning of the engineering of the first phase, you can copy the entire phase and with that have this settings for all phases.


Execution period

Manual -> Batch Control -> Engineering in the Editor -> TAGs -> Execution period

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The execution duration is controlled via two independent properties. Their values must not complement one another.

Maximum execution duration

The Maximum execution duration refers to Phase deactivated and therefore to the process. It is not connected to the Minimum execution duration.

Minimum execution duration

Property Minimum execution duration defines how long zenon waits after writing the command tag independent of the check of the phase done condition. During the execution the maximum execution duration is checked. An event is triggered if this is exceeded. This can be linked to a reaction. This happens regardless of whether the phase still checks its Phase done condition or only waits for the Minimum execution duration.

The length of the minimum execution duration can exceed the maximum execution duration.

Example

  • There is a phase: Start mixing. The confirmation that the mixer runs must not take longer than 5 seconds before a warning of an error is displayed.
    Engineering: Property Maximum execution duration gets value 5 seconds with corresponding reaction.
  • The mixer however should run 15 minutes before the next phase is executed.
    Engineering: Property Minimum execution duration gets value 15 minutes.

With this the minimum execution duration is 15 minutes and the maximum execution duration 5 seconds.


Control Strategy

Manual -> Batch Control -> Engineering in the Editor -> Control Strategy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Control strategies make it possible to set parameters for different versions of a phase. Only the command parameters allocated to the control strategy are sent for each control strategy.

Configuring control strategies

To use control strategies, these must be activated in the phase. To do this:

  1. Highlight the desired phase
  2. Go to property group control strategy\
  3. Activate the checkbox in front of the Active control strategies property.
  4. Select a parameter in the control strategy tag property. This parameter defines the control strategy that is active in Runtime.
  5. The phase is thus displayed in the Editor with the Control strategies node.
  6. Right click on the node and select the entry New control strategy in the context menu.
  7. A new control strategy is created.
  8. Configure the properties of the control strategy.
    In doing so, note:
    • Name and control strategy number of the control strategy must be unique within the phase.
    • The Name must not be empty, contain a dot, consist of only spaces and must be within a maximum of 256 characters long.
  9. Add the desired command parameters.

    Note: Clicking on a parameter add its properties.
    Only the following properties in the Write set value group can be edited:

    • Tag value
    • Min. value
    • Max. value
    • Changeable in master recipe

    All other properties cannot be edited. To edit these, switch to the parameter list of the phase.

Copying control strategies

Control strategies can be copied using commands in the context menu and the toolbar and inserted into the same or other phases.

If control strategies are copied throughout phases, units or a project, only the parameter linkings that are also to be triggered in the new phase are inserted. In doing so, the conditions are the same as for inserting parameter linking.


Control strategies node context menu

Manual -> Batch Control -> Engineering in the Editor -> Control Strategy -> Control strategies node context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Right-clicking on the Control strategies node opens a context menu with the following entries:

Parameters | Description
New Control strategy | Creates a new control strategy
Paste control strategy | Pastes a control strategy from the clipboard. Copied control strategies are adapted when pasted into a phase so that Name and control strategy number are made unique, if this is not already the case in the phase.
Help | Opens online help.


Context menu selected control strategy

Manual -> Batch Control -> Engineering in the Editor -> Control Strategy -> Context menu selected control strategy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Right-clicking on the control strategy opens a context menu with the following entries:

Parameters

Description

Add command parameters

Opens the dialog to select command parameters.

Insert parameter linking

Inserts parameters that have been copied into the control strategy list of a different control strategy to the selected control strategy.

Rename

Highlights the name to be renamed.

Delete

Deletes the selected control strategy after a confirmation message.

Copy

Copies the selected control strategy. This can be pasted using Paste in the context menu of the Control strategies node.

Copied control strategies are adapted when pasted into a phase so that Name and control strategy number are made unique, if this is not already the case in the phase.

Help

Opens online help.


Toolbar and control strategy list context menu

Manual -> Batch Control -> Engineering in the Editor -> Control Strategy -> Toolbar and control strategy list context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entries in the control strategy list can be edited using symbols or entries in the context menu.

The following are available in the context menu and the toolbar:

Parameters | Description
Add command parameters | Opens the dialog to select command parameters.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Clear | Deletes selected entries after a confirmation from list.
Remove all filters | Removes all filter settings.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Properties | Opens the Properties window for the selected entry.
Help | Opens online help.


Parameters

Manual -> Batch Control -> Engineering in the Editor -> Control Strategy -> Parameters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Linking parameters

There are different methods available to link parameters to a control strategy:

  • To do this, select the Add command parameter command in the context menu of the control strategy.
  • Select, in the detail view of the control strategies in the toolbar or in the context menu of a parameter, the Add command parameter command.
  • Drag the parameter from the parameter list of the phase by dragging & dropping it onto the control strategy. Only command parameters are linked.

Note: If a parameter is deleted for a phase, the attendant parameter linking is also deleted for all control strategies.

Deleting or restoring linked values

Parameters of the control strategies take on the values of the parameters with which they are linked.
This linking can be deleted by:

  • Overwriting the value
  • Separating the linking via the context menu

The context menu can also be used to restore the link to the source parameter again.

You can read details on linked values in the Linked properties chapter in the Editor manual.

Copying parameters

Existing parameter linking can be copied between control strategies. Copying is possible throughout via phases, units and projects. When inserting parameter linkings, an attempt is made to link the names accordingly. No new parameters are created.

Insertion is possible if there is no parameter with the copied name in the target phase or the corresponding parameter is already part of the control strategy.


Keyboards

Manual -> Batch Control -> Engineering in the Editor -> Keyboards

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters can be amended in Runtime. Adapted keyboards are available for this.

Keyboards for Batch Control

You define keyboards for use in the Batch Control module in general in the properties for the module in the Edit tag/Keyboards group. Define the desired keyboards for:

  • Binary tags
  • Numeric tags
  • String tags
  • Time period tags

With the Reason for value change necessary property, you can also stipulate that each value change must have a reason. If this property is active, a dialog to enter the reason is opened before the change is made.

Keyboard for writing set value for parameter

You define keyboards for writing set values for individual parameters in the properties of the respective parameter in the Write set value/Keyboards group. To do this:

  1. Navigate to the Write set value group in the parameter properties.
  2. Activate, in the Keyboards subgroup, the Use screen Keyboard property
  3. In the Screen Keyboard property, define which keyboard screen is to be called up in Runtime

Using a keyboard

Values can be edited in the master recipe and in the control recipe if the recipe status and the parameter settings allow this. The minimum and maximum can only be changed in the master recipe and only for numerical parameters and duration parameters.

The following applies for the use of keyboards Batch Control screens:

  • Only one keyboard can be active at a time. If a new one is called up, the previous one is closed.
  • If the keyboard is active and the mouse is double-clicked with the pointer in a column in which nothing can be changed, nothing happens.
  • The following is applicable to value, minimum and maximum of a parameter:
    • If a parameter itself is linked to a keyboard, this is used.
    • If no keyboard is linked to the parameter, the keyboard this is generally linked to Batch Control in the Edit tag group is used.
    • If a keyboard is linked to the parameter, but this is no longer available, the keyboard that is also generally linked to Batch Control in the Edit tag group is used.
    • No keyboard is opened if this also does not exist.
  • Keyboards for binary inputs can be provided using the On, Off and Toggle keys.
  • When switching the units of measurement, the min/max values and the unit names are sent to the system variables again.
  • For the Changeable in control recipe property, the keyboard for Binary tags defined in the Edit tag group is searched for. If none is linked, then a search is carried out for a keyboard with the standard name SETBOOLKBD. No keyboard is opened if this also does not exist.
  • Keyboards that are directly linked to the parameter can no longer be changed after a recipe has been approved. If the keyboard linked to the parameter is deleted, only the keyboard defined in the Edit tag group can be used.


Input lock

Manual -> Batch Control -> Engineering in the Editor -> Input lock

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the help of an input interlocking the phase is only executed in the Runtime when the condition for the input interlocking is fulfilled.

The input interlocking is configured via property Interlocking condition. Via the formula editor the condition is defined which the input interlocking must fulfill. The formula can consist of one or more command tags and return tags of the phase. Value and status of the variables can also be used. The formula returns TRUE or FALSE as result. The condition can be displayed in the Runtime but cannot be changed there. The waiting period for the input interlocking is configured with the help of property Waiting period input interlocking.

If an input interlocking was defined, the phase is executed as soon as the following conditions are fulfilled:

  • the phase is active
  • the unit is allocated
  • the phase is not active twice
  • the phase is not already executed
  • the input interlocking is fulfilled

If no input interlocking is linked, the phase is executed when:

  • the phase becomes active
  • the unit is allocated
  • the phase is not executed twice
  • the needed variables all have a value

info Information

You can find more information about input interlockings in chapter Processing a phase in detail.


Create screen of type Batch Control

Manual -> Batch Control -> Engineering in the Editor -> Create screen of type Batch Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In screen of the type Batch Control master recipes and/or control recipes can be:

  • created
  • managed
  • executed in the Runtime

The display size of the screen depends on the selected template size.

To create a screen of type Batch Control:

  1. Select the New screen command in the Screens node
  2. in column Screen type select Batch Control from the drop-down list
  3. in the menu bar Control elements select one of the three default settings:
    • Insert template: provides templates for different resolutions and selection of only master recipes or default (master and control recipes)
    • Default master recipe: adds selected elements for a master recipe
    • Default control recipe: adds selected elements for a control recipe
  4. the default elements for the desired setting are created
  5. if needed you can add additional control elements from menu Control elements
  6. create a screen switch in order to display the screen in the Runtime
  7. Configure the display in Runtime (for details, see the screens manual, Designing lists chapter)

Control elements

Control element

Description

Insert template

Inserts control elements for master recipes and/or control recipes on predefined locations on the screen. These control elements can be supplemented, reduced and positioned newly.

Default (master recipes)

Inserts control elements for master recipes on predefined locations on the screen. These control elements can be supplemented, reduced and positioned newly.

Default (control recipes)

Inserts control elements for control recipes on predefined locations on the screen. These control elements can be supplemented, reduced and positioned newly.

Recipe Editor

Adds the licenses editor for creating master and control recipes.

Recipe control

Control elements for the recipe control.

Execution commands of the recipe

Control elements for recipe commands:

  • Start recipe
  • Recipe pausing
  • Recipe resuming
  • Recipe holding
  • Restart recipe
  • Recipe stopping
  • Recipe abborting

Execution commands of the phases

Control elements for phase commands:

  • Phase pausing
  • Phase resuming
  • Phase holding
  • Restart phase
  • Escape phase

Switch execution mode

Control elements for execution modes:

  • Switch to automatic mode
  • Switch to semi-automatic mode
  • Switch to manual mode

Execution navigation

Control elements for navigation in recipes:

  • Continue recipe only on selected active elements
  • Continue recipe at all execution positions
  • Skip active condition

General

General control elements:

  • Check recipe for errors
  • Edit element
  • Display grid
  • Colors for background and grid

Operation navigation

Control elements for navigation in operations:

  • Change to operation template
  • Switch to main recipe

Master recipes

Control elements for master recipes.

Master recipes list

In this list all master recipes can be displayed. The display can be limited by filters to an individual selection.

The filtering can be preset in the zenon Editor in the screen switch function. Online filtering is also possible. These filters are discarded when the screen is called up again. A permanent definition is only possible in the zenon Editor.

All commands are also possible in the context menu of the list. The commands for list management can be called from the header of the list. The commands for recipe management can be called at editing one or more recipes.

The recipes in the list cannot be edited directly in the list. Renaming, changing the description or changing the recipe status is only possible with the corresponding commands.

Column selection master recipe...

Opens a dialog in order to determine which columns should be displayed.
Attention: These changes are discarded when the screen is called up again. A permanent definition is only possible in the zenon Editor.

Format columns master recipe...

Opens a dialog to edit the column settings.
Attention: These changes are discarded when the screen is called up again. A permanent definition is only possible in the zenon Editor.

New master recipe...

Opens dialog for creating a new master recipe.

Create new version of master recipe

Creates a new version of the selected master recipe. This must be approved or marked as obsolete.

Rename master recipe

Only active if exactly one master recipe was selected.
The dialog for the input of a unique name and the description is opened.
Recipes can only be renamed if they are in status Editable.
Also use this function in order to changed the description of the control recipe.

When renaming a recipe, a CEL entry is created.

Duplicate master recipe

Only active if precisely one recipe was selected.
Creates a copy of the selected recipe. At the creation of the copy, the version of the recipe saved on the hard disk is used. If the recipe is just edited in another computer and the changes have not yet been saved, the changes are not applied. The dialog for the input of a unique name and the description is opened.

The copy of the recipe automatically receives status Editable and can be edited further.

When duplicating a recipe, a CEL entry is created.

Delete master recipe

Deletes the selected recipes irrevocably. If the recipe is opened on another computer for editing, it is automatically closed there.

Deleting is only possible if there are no control recipes which are based on the master recipe. First you must delete all control recipes.
Recipes which are currently executed in test mode (master recipe status: Test in execution) cannot be deleted. First they must be finished, stopped or canceled.

If recipes must not be deleted - e.g. FDA regimented environment - we recommend not to engineer this button or to give it an appropriated Authorization level.
When deleting a recipe, a CEL entry is created.

Open master recipe

Opens the selected master recipe in the recipe editor if screen element Recipe editor exists in the screen. Each selected master recipe is opened in a separate tab of the recipe editor.

Switch master recipe to edit mode

Changes the master recipe status of the selected recipes to Editable. In this status, recipes can again be edited completely.
Only recipes in Test mode can be set back to Editable.

Switch master recipe to test mode

Changes the master recipe status of the selected recipe to Test mode. Only faultless recipes can be switched to test mode. If error occur during the validation, you must first fix them.

Recipes in the test mode can be executed but no longer reengineered. For details about the states see chapter Recipe types and recipe states.

Release master recipe

Changes the master recipe status of the selected recipes to Released. Only recipes without errors can be released. If error occur during the validation, you must first fix them.
Only recipes in status Test mode and Editable can be released.

Released recipes can no longer be edited. Control recipes can only be created from released recipes.
For details about the states see chapter Recipe types and recipe states.

When releasing a recipe, a CEL entry is created.

Highlight master recipe as outdated

Changes the status of the recipe to outdated. The recipe can no longer be edited or approved. No control recipe can be created on the basis of this recipe.

Display associated control recipes in list

Displays all control recipes that are based on the selected master recipe and that comply with the set filter criteria.

Dynamically update control recipe list.

Deactivate the button Display associated control recipes in list. When selecting a master recipe, all attendant control recipes are displayed automatically.

Filter for displaying the control recipe

Makes it possible to filter control recipes for the following criteria:

  • Currently executed control recipes:
    Displays only control recipes which are currently executed. Only takes effect as soon as you click on Show associated control recipes in list.
  • Prepared control recipes:
    Display only control recipes which are prepared for execution. Only takes effect as soon as you click on Show associated control recipes in list.
  • Completed control recipes:
    Displays only control recipes which have already been executed. Only takes effect as soon as you click on Show associated control recipes in list.
  • Outdated control recipe

Control recipe

Control elements for control recipes.

List control recipes...

In this list all control recipes can be displayed. The display can be limited by filters to an individual selection.

Per default the list is empty. For filling the list you must:

  • select master recipes
  • Set the currently-executed control recipes,
    prepared control recipes and
    completed control recipes
    filters
  • click button display associated control recipes in list

In addition to the filters mentioned above, you can filter the list itself. The filtering can be preset in the zenon Editor in the screen switch function. Online filtering is also possible. These filters are discarded when the screen is called up again. A permanent definition is only possible in the zenon Editor.

All commands are also possible in the context menu of the list. The commands for list management can be called from the header of the list. The commands for recipe management can be called at editing one or more recipes.
The recipes in the list cannot be edited directly in the list. Renaming, changing the description or starting the recipes is only possible with the corresponding commands.

Column selection control recipe...

Opens a dialog in order to determine which columns should be displayed.
Attention: These changes are discarded when the screen is called up again. A permanent definition is only possible in the zenon Editor.

Format columns control recipe...

Opens a dialog to edit the column settings.
Attention: These changes are discarded when the screen is called up again. A permanent definition is only possible in the zenon Editor.

New control recipe...

Opens the dialog for entering a unique name and a description for the control recipe. The uniqueness of the name is also checked in the zenon network. The name must only be unique within the master recipes. Control recipes which are based on other master recipes may have the same name. The uniqueness within module Batch Control is achieved by always referencing the master recipe name and the control recipe name.

When creating a control recipe, a CEL entry is created.

Rename control recipe

Only active if exactly one control recipe was selected.
The dialog for the input of a unique name and the description is opened.
Recipes can only be renamed if they are in status Prepared.
Also use this function in order to changed the description of the control recipe.

Duplicate control recipe

Only active if precisely one recipe was selected.
Creates a copy of the selected recipe. At the creation of the copy, the version of the recipe saved on the hard disk is used. If the recipe is just edited in another computer and the changes have not yet been saved, the changes are not applied. The dialog for the input of a unique name and the description is opened.

The copy of the recipe automatically gets the status Prepared and can therefore be edited and started. The execution status of the duplicate is set to automatic.

When duplicating a recipe, a CEL entry is created.

Delete control recipe

Deletes the selected recipes irrevocably. If the recipe is opened on another computer for editing, it is automatically closed there.

Deleting is only possible if all selected recipes are not executed (control recipe status: In execution). In execution: First they must be finished, stopped or canceled.

If recipes must not be deleted - e.g. FDA regimented environment - we recommend not to engineer this button or to give it an appropriated Authorization level.
When deleting a recipe, a CEL entry is created.

Open control recipe

Opens the selected control recipe in the recipe editor if screen element Recipe editor exists in the screen. Each selected control recipe is opened in a separate tab of the recipe editor.

Start control recipe

Starts the selected control recipe in the set execution mode. The recipes are executed invisibly at the Server. It is not necessary that the recipe is opened in the recipe editor.

Parameter lists

List box for the display of parameters.

Two list boxes can be created. These are configured in the screen switching.


Screen switch Batch Control

Manual -> Batch Control -> Engineering in the Editor -> Screen switch Batch Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use Batch Control in the Runtime, engineer a screen switch function to a screen of type Batch Control:

  1. in node Functions in the context menu select menu item New function
  2. select function Screen switch
  3. select the screen of type Batch Control
  4. the filter dialog is displayed
  5. configure the
    1. Settings for the list of the master recipes/control recipes including prefiltering
    2. Variable allocations
    3. Tag list settings
  6. link the function with a button on the screen in order to switch in the Runtime


Recipe list settings

Manual -> Batch Control -> Engineering in the Editor -> Screen switch Batch Control -> Recipe list settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The settings are configured for:

  • List of master recipes
  • Control Recipes List
  • Prefilter

List of master recipes

Parameters

Description

List of master recipes

Configuration for master recipes.

Prefilter

Select from a drop-down list whether master recipes should be pre-filtered when called up. Possible settings:

  • No prefiltering: Recipes are not pre-filtered.
  • ID from variable: Recipes are filtered according to ID. Filter condition is defined in the Variable property.
  • Name from variable: Recipes are filtered according to recipe name. Filter condition is defined in the Variable property.

Variable

Definition of the variables that provide the values for the prefiltering. Click the button ... and a dialog opens to configure the variables.

Apply column settings from calling screen

Active: The column settings are accepted by the screen that is calling them up in Runtime. The corresponding properties can no longer be configured in the Editor.

List field

Display of the configured columns.

Column selection

Opens the dialog for selecting the columns

Column Format

Opens a dialog to format the columns.

Open found recipes in recipe editor

Active: The recipes found are opened in the recipe editor.

Note: The first 20 recipes found is the maximum that can be opened.

Control Recipes List

Parameters | Description
Control Recipes List | Configuration for control recipes.

Filter control recipe for status

Parameters

Description

Filter control recipe for status

Settings for the filtering of the control recipes according to their status.

Apply filter from calling screen

Active: The filter is accepted from the calling screen.

Use this filter

Selection of criteria for the status of a recipe that is to be called up. Several statuses can be selected by selecting the corresponding checkbox:

  • Prepared
  • Currently executed
  • Executed
  • Outdated

Filling the list of the control recipes at calling the screen

Settings for the filling of the list when called up. Select an option.

  • No filling
  • Apply and use selection of the master recipes from calling screen
  • Use all active master recipes

Prefilter

Select from a drop-down list whether control recipes should be prefiltered when called up. Possible settings:

  • No prefiltering: Recipes are not pre-filtered.
  • ID from variable: Recipes are filtered according to ID. Filter condition is defined in the Variable property.
  • Name from variable: Recipes are filtered according to recipe name. Filter condition is defined in the Variable property.
  • Job ID from variable: Recipes are filtered according to job ID. Filter condition is defined in the Variable property.

Variable

Definition of the variables that provide the values for the prefiltering. Click the button ... and a dialog opens to configure the variables.

Dynamic filling of the control recipe list

Parameters

Description

Dynamic filling of the control recipe list

Settings for dynamic filling of the list.

Selection of the master recipe fills list of control recipes automatically

Active: When switching in Runtime, the list of control recipes always displays the master recipes selected at this point in time.

Apply column settings from calling screen

Active: The column settings are accepted by the screen that is calling them up in Runtime. The corresponding properties can no longer be configured in the Editor.

List field

Display of the configured columns.

Column selection

Opens the dialog for selecting the columns

Column Format

Opens a dialog to format the columns.

Open found recipes in recipe editor

Active: The recipes found are opened in the recipe editor.

Note: The first 20 recipes found is the maximum that can be opened.

Show this dialog in the Runtime

Active: When calling up the function in Runtime, this dialog is opened and the user can adjust the configuration before execution.

The dialog is displayed on the current computer in Runtime. During network operation when activating the client the dialog is also displayed on the client

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

Note for variable selection using name or ID: For the selection of variables according to name or ID, numerical variables and string variables can be selected respectively. The data types are converted to the respective correct form.


Column selection

Manual -> Batch Control -> Engineering in the Editor -> Screen switch Batch Control -> Recipe list settings -> Column selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Options

Button | Function
Available columns | List of columns that can be displayed in the table.
Selected columns | Columns that are displayed in the table.
Add | Moves the selected column from the available ones to the selected items. After you confirm the dialog with OK, they are shown in the detail view.
Add all | Moves all available columns to the selected columns.
Remove | Removes the marked columns from the selected items and shows them in the list of available columns. After you confirm the dialog with OK, they are removed from the detail view.
Remove all | All columns are removed from the list of the selected columns.
Up | Moves the selected entry upward. This function is only available for unique entries, multiple selection is not possible.
Down | Moves the selected entry downward. This function is only available for unique entries, multiple selection is not possible.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.

Note: These settings are only used in Runtime for dockable windows if there is no Runtime profile available for the user who is logged in.

Examples of column selection

Column selection for list of the master recipes:

Column selection for list of the control recipes:

Column selection for list of the operations (only available in Runtime):

Column selection for Tag lists


Column Format

Manual -> Batch Control -> Engineering in the Editor -> Screen switch Batch Control -> Recipe list settings -> Column Format

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this dialog you define the column format:

Configuration of the properties of the columns for configurable lists. The settings have an effect on the respective list in the Editor or - when configuring screen switching - in Runtime.

Available columns

Parameters | Description
Available columns | List of the available columns via Column selection. The highlighted column is configured via the options in the Settings area.

Settings

Parameters

Description

Settings

Settings for selected column.

Labeling

Name for column title.

The column title is online language switchable. To do this, the @ character must be entered in front of the name.

Width

Width of the column in characters.
Calculation: Number time average character width of the selected font.

Alignment

Alignment. Selection by means of radio buttons.

Possible settings:

  • Left-justified: Text is justified on the left edge of the column.
  • Centered: Text is displayed centered in the column.
  • Right: Text is justified on the right edge of the column.

Deactivate column filter in the Runtime

Active: The filter for this column cannot be changed in Runtime.

Note: Only available for:

  • Batch Control
  • Extended Trend
  • Filter screens
  • Message Control
  • Recipegroup Manager

User defined colors

Properties in order to define user-defined colors for text and background. The settings have an effect on the Editor and Runtime.

Note:

  • These settings are only available for configurable lists.
  • In addition, the respective focus in the list can be signalized in Runtime by means of different text and background colors. These are configured using the project properties.

User defined colors

Active: User-defined colors are used.

Text color

Color for text display. Clicking on the color opens the palette to select a color.

Background color

Color for the display of the cell background. Clicking on the color opens the palette to select a color.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

Note: These settings are only used in Runtime for dockable windows if there is no Runtime profile available for the user who is logged in.


Prefiltering

Manual -> Batch Control -> Engineering in the Editor -> Screen switch Batch Control -> Recipe list settings -> Prefiltering

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To eliminate the need for all recipes to always be loaded in the recipe list in Runtime, you can define filters for master recipes and control recipes in the screen switch function. Then, the only recipes that appear in the list of master recipes and the control recipes are those that correspond to the configured filter conditions. If activated, these recipes are also opened in the recipe editor.

If you want it to be impossible for users to remove the filters in the runtime environment:

  1. Deactivate the Show this dialog in Runtime option.
  2. Block the column filter: Open the Column format... dialog and activate the Block column filter in the process screen option. With this the user cannot modify the filters in the Runtime and therefore does not get the recipes, which e.g. he is not allowed to modify, not displayed.

Filtering for master recipes

Configure:

  1. Prefiltering

    Stipulate if recipes are to be prefiltered. You can filter according to name or ID. The filter condition is queried in Runtime using a variable.

  2. Column settings
    1. in the screen switch function click on column filters for the List of the master recipes or the List of control recipes
    2. enter the desired filter text; wildcards (*) are allowed
    3. confirm the filter text with Return for it to be applied.
  3. Automatic recipe switching

    Stipulate if the recipes found when switching are also to be opened in the Recipe Editor straight away.

    Note: The first 20 recipes found is the maximum that can be opened automatically.

info Information

When reloading Runtime, the filter settings of the prefiltering for master recipes are applied again. This also applies if the value of the filter variables changes or new recipes are added to the list that do not correspond to the filter. The list is always recreated exactly after reloading.

Filtering for control recipes

Configure:

  1. Recipe status

    Filter the control recipes according to their status. You can select several states using checkboxes or accept the filter from the calling screen.

  2. Filling the recipe list

    Stipulate if and how the list of control recipes is to be filled when called up.

  3. Prefiltering

    Stipulate if recipes are to be prefiltered. You can filter according to ID, name or job ID. The filter condition is queried in Runtime using a variable

  4. Column settings
    1. in the screen switch function click on column filters for the List of the master recipes or the List of control recipes
    2. enter the desired filter text; wildcards (*) are allowed
    3. confirm the filter text with Return for it to be applied.
  5. Automatic recipe switching

    Stipulate if the recipes found when switching are also to be opened in the Recipe Editor straight away.

    Note: The first 20 recipes found is the maximum that can be opened automatically.

info Information

When reloading Runtime, the filter settings of the prefiltering for control recipes are applied again. Instead, all control recipes that correspond to the current filter in Runtime are displayed (master recipes, status, column filter).


Variable assignment

Manual -> Batch Control -> Engineering in the Editor -> Screen switch Batch Control -> Variable assignment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You link variables to elements in the recipe in this tab. This way you can display the statuses of a phase or an operation in another screen and react to these. The execution status of the recipe and the selected object can be displayed by means of string variables or numerical variables. Numerical variables are suitable, for instance, for linking to a combined element. For details on the status, see the Coding of the execution status section.

To display statuses:

  1. Create a new screen with the desired elements.
  2. Link the elements to variables
  3. Link these variables in the screen switching filter to the corresponding objects

Link variables

To link a variable:

  1. Click on the ... button
  2. The dialog for selecting a variable is opened
  3. Select the desired variable

Display

The following are displayed:

  • For the recipe that is in focus:
    • Name
    • Description
    • Status
    • Execution mode
    • Execution status
    • Recipe type
  • For the object in the recipe that is in focus (phase or operation):
    • Name
    • Description
    • Unit
    • Type
    • Status
    • Internal state
    • Start time
    • Time of the end
    • Execution counter
    • Duration of execution

Parameters

Description

Master recipe

Variable linkings for the master recipe.

Status is displayed if the recipe has the focus or a phase or operation is highlighted.

The following can be linked:

  • Name
  • Version
  • Initial version
  • Description
  • Status (text)
  • Status (numeric)

Control recipe

Variable linkings for the control recipe.

Status is displayed if the recipe has the focus or a phase or operation is highlighted.

The following can be linked:

  • Name
  • Description
  • Status (text)
  • Status (numeric)
  • Job ID (text)

Operation

Variable linkings for the operation.

Status is displayed if the recipe has the focus or a phase or operation is highlighted.

The following can be linked:

  • Name
  • Description

General

Variable linkings for general information.

Status is displayed if the recipe has the focus or a phase or operation is highlighted.

The following can be linked:

  • Execution mode (text)
  • Execution mode (numerical)
  • Execution status (text)
  • Execution status (numerical)
  • Recipe type (text)
  • Recipe type (numeric)

Selected object

Variable linkings for the selected object (phase or operation).

Status is displayed if a phase or an operation in the recipe is highlighted.

The following can be linked:

  • Name
  • Description
  • Unit
  • Type (text)
  • Type (numeric)
  • Control strategy
  • Description of control strategy
  • control strategy number
  • Status (text)
  • Status (numeric)
  • Internal state (text)
  • Internal state (numeric)
  • Start time
  • Time of the end
  • Execution counter
  • Duration of execution

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

Note: No information is displayed if several objects are highlighted.


Coding of the execution status

Manual -> Batch Control -> Engineering in the Editor -> Screen switch Batch Control -> Variable assignment -> Coding of the execution status

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Execution state

The execution state (both for the recipe and the selected object) is coded with different information:

  • Byte 0: Execution state
  • Byte 1: Status bits for the status
  • Byte 2: Type of object that is part of the status

If no recipe is opened then the string variables are empty and the numerical variables have the value 0.

Byte 0

Execution states.
The values that are possible are determined by the object type.

String | Decimal | Binary
Idle | 1 | 1
Running | 2 | 10
Executed | 3 | 11
Pause (starting from state: running) | 4 | 100
Paused | 5 | 101
Hold (starting from state: running) | 6 | 110
Hold (starting from state: Paused) | 7 | 111
Hold (starting from state: Restart) | 8 | 1000
Held | 9 | 1001
Restarting (starting from state: Held) | 10 | 1010
Stopping (starting from state: running) | 11 | 1011
Stopping (starting from state: Paused) | 12 | 1100
Stopping (starting from state: Held) | 13 | 1101
Stopped | 14 | 1110
Abborting (starting from state: running) | 15 | 1111
Abborting (starting from state: Paused) | 16 | 10000
Abborting (starting from state: Held) | 17 | 10001
Aborted | 18 | 10010

Byte 1

Status bits for the status.
The text is added to the string variable. The corresponding bits are set in the numerical variables

Value for string variable | Value for numeric variable
n elements in different states | 0b00000001
Waiting for n element(s) | 0b00000010

Byte 2

Type of object that is part of the status.
For numerical variables only.

Decimal | Binary | Meaning
1 | 1 | Recipe
2 | 10 | Phase
3 | 11 | Operation object in the recipe


Master recipe

Manual -> Batch Control -> Engineering in the Editor -> Screen switch Batch Control -> Variable assignment -> Coding of the execution status -> Master recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Master recipe

Name

Name of the currently-opened master recipe or the master recipe that belongs to the currently-opened control recipe or operation.

Description

Description of the currently-opened master recipe or the master recipe that belongs to the currently-opened control recipe or operation.

Status (text and numeric)

Status of the currently-opened master recipe or the master recipe that belongs to the currently-opened control recipe or operation.

Variable values:

String | Decimal | Binary
No recipe in active view | 0 | 0
Creation (not visible) | 1 | 1
Edit mode | 2 | 10
Released | 3 | 11
Test mode | 4 | 100
Test in execution | 5 | 101
Terminated with error | 6 | 110


Control recipe

Manual -> Batch Control -> Engineering in the Editor -> Screen switch Batch Control -> Variable assignment -> Coding of the execution status -> Control recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Control recipe

Name

Name or selection of the control recipe. The recipe must be open and have the focus. Is filled in the control recipe and in the operation instance in the control recipe.

Description

Description of the currently-selected control recipe. The recipe must be open and have the focus. Is filled in the control recipe and in the operation instance in the control recipe.

Status (text and numeric)

Status of the currently-selected control recipe or the recipe must be open and have the focus. Is filled in the control recipe and in the operation instance in the control recipe.

Variable values:

String | Decimal | Binary
no control recipe active | 0 | 0
Creation (not visible) | 1 | 1
Prepared | 2 | 10
Running | 3 | 11
Executed | 4 | 100
Terminated with error | 5 | 101


Operation

Manual -> Batch Control -> Engineering in the Editor -> Screen switch Batch Control -> Variable assignment -> Coding of the execution status -> Operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Operation

Name

Name of the operation currently open. Is filled in the operation template and in the operation instance.

Description

Description of the operation currently open. Is filled in the operation template and in the operation instance.


General

Manual -> Batch Control -> Engineering in the Editor -> Screen switch Batch Control -> Variable assignment -> Coding of the execution status -> General

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
General

Execution mode (text and numeric)

Currently-set execution mode for the currently-selected recipe. Is filled for all recipe cycles.

Variable values:

String | Decimal | Binary
Automatical | 1 | 1
Semi-automatic | 2 | 10
Manual | 3 | 11

Execution status (text and numeric)

Status of the recipe

Byte 0

Variable values:

String | Decimal | Binary
Idle | 1 | 1
Running | 2 | 10
Executed | 3 | 11
Pausing (starting from state: running) | 4 | 100
Paused | 5 | 101
Holding (starting from state: running) | 6 | 110
Held | 9 | 1001
Restarting (starting from state: Held) | 10 | 1010
Stopping (starting from state: running) | 11 | 1011
Stopped | 14 | 1110
Abborting (starting from state: running) | 15 | 1111
Aborted | 18 | 10010

Byte 1

Value for string variable | Value for numeric variable
n elements in different states | 0b00000001
Waiting for n element(s) | 0b00000010

Byte 2

Object type. For the numerical value only

Decimal | Binary | Meaning
1 | 1 | Recipe

Recipe type (text and numeric)

Recipe type of the current recipe. Is filled for all recipe cycles.

Variable values:

String | Decimal |  | Binary
Master recipe |  | 1 | 1
Control recipe |  | 2 | 10
Operation template |  | 4 | 100
Operation instance in the master recipe |  | 9 | 1001
Operation instance in the control recipe |  | 10 | 1010


Selected object

Manual -> Batch Control -> Engineering in the Editor -> Screen switch Batch Control -> Variable assignment -> Coding of the execution status -> Selected object

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Selected object

The variables for the selected object always contain data if a single phase or a single operation was selected in the currently-selected operation. It is filled for all recipe types. If no object or several objects are selected, then the string variables are empty and the numerical values are 0.

Name

Is filled with the name of the phase or the operation.

Description

Is filled with the description of the phase of the operation.

Unit

Is filled with the name of the unit of the selected phase.

Type (text and numeric)

Variable values:

String | Decimal | Binary
Phase | 3 | 11
Operation | 13 | 1101

Status (text and numeric)

Is filled with the current execution status of the element.

Value for a phase

Byte 0

Variable values:

String | Decimal | Binary
Idle | 1 | 1
Running | 2 | 10
Executed | 3 | 11
Pausing (Starting from state: running) | 4 | 100
Paused | 5 | 101
Holding (Starting from state: running) | 6 | 110
Holding (Starting from state: Paused) | 7 | 111
Holding (Starting from state: Restarting) | 8 | 1000
Held | 9 | 1001
Restarting (Starting from state: Held) | 10 | 1010
Stopping (Starting from state: running) | 11 | 1011
Stopping (Starting from state: Paused) | 12 | 1100
Stopping (Starting from state: Held) | 13 | 1101
Stopped | 14 | 1110
Aborting (Starting from state: running) | 15 | 1111
Aborting (Starting from state: Paused) | 16 | 10000
Aborting (Starting from state: Held) | 17 | 10001
Aborted | 18 | 10010

Byte 1:

Always empty.

Byte 2:

Object type. For the numerical value only

Variable values:

Decimal | Binary | Meaning
2 | 10 | Phase

Value for a operation instance

Byte 0

Variable values:

String |  | Decimal | Binary
Idle | 1 |  | 1
Running | 2 |  | 10
Executed | 3 |  | 11
Pausing (Starting from state: running) | 4 |  | 100
Paused | 5 |  | 101
Holding (Starting from state: running) | 6 |  | 110
Held | 9 |  | 1001
Restarting (Starting from state: Held) | 10 |  | 1010
Stopping (Starting from state: running) | 11 |  | 1011
Stopping (Starting from state: Paused) | 12 |  | 1100
Stopping (Starting from state: Held) | 13 |  | 1101
Stopped | 14 |  | 1110
Aborting (Starting from state: running) | 15 |  | 1111
Aborting (Starting from state: Paused) | 16 |  | 10000
Aborting (Starting from state: Held) | 17 |  | 10001
Aborted | 18 |  | 10010

Byte 1

Value for string variable | Value for numeric variable
n elements in different states | 0b00000001

The bit is always set if there are objects in the operation with a different status to that of the operation. Idle and finished are not included in this.

Byte 2:

Object type. For the numerical value only.

Variable values:

Decimal | Binary | Meaning
3 | 11 | Operation in the recipe.

Internal status (text and numeric)

Is filled with the internal execution status of the element.

Composition of the internal status:

  • Byte 0: Status
  • Byte 1: Status Bits
  • Byte 2: Object type

Value for a phase

Byte 0

Internal status. The text can be different for other objects.

Variable values:

String |  | Decimal | Binary
Idle | 1 |  | 1
Waiting for phase to be ready for starting | 2 |  | 10
Waiting for unit allocation | 3 |  | 11
Waiting for the unit allocation - timeout | 4 |  | 100
Waiting for exclusive execution | 5 |  | 101
Waiting for input interlocking | 6 |  | 110
Waiting for the input interlocking - timeout | 7 |  | 111
Waiting for phase done condition | 8 |  | 1000
Waiting for phase done condition - timeout | 9 |  | 1001
Waiting for phase done condition - error writing value | 10 |  | 1010
Waiting for minimum execution period | 11 |  | 1011
Wait until recipe has status "running" | 12 |  | 1100
Waiting for following conditions | 13 |  | 1101
Waiting for following condition - timeout | 14 |  | 1110

Byte 1

Status. For numerical variables only.

Variable values:

Decimal | Binary | Meaning
00000001 | 1 | There is an execution error.
00001000 | 8 | There is a communication error.
00010000 | 16 | Loss of communication fixed.
01000000 | 64 | Communication reestablished.

With the phase, only one of the bits can be active for the communication error. With an operation a bit is always set if it is relevant to at least one internal phase.

Byte 2

Object type. For the numerical value only.

Variable values:

Decimal | Binary | Meaning
3 | 11 | Operation in the recipe.

Possibilities for phase

Byte 0

All possibilities.

Byte 1

All possibilities.

Byte 2

Value for numeric variable |  | Meaning
Decimal | Binary
2 | 10 | Phase

Possibilities for operation instances

Byte 0

Variable values:

String | Decimal | Binary
Idle | 1 | 1
Execution of the internal objects | 8 | 1000
Waiting for following conditions | 13 | 1101

Byte 1

Always empty.

Byte 2

Variable values:

Decimal | Binary | Meaning
3 | 11 | Operation in the recipe.

Start time

Time at which the execution of the selected object has started.

Time of the end

Time at which the execution of the selected object has finished.

Duration of execution

Time period that has expired during the execution.

Execution counter

Number denoting how often the element was executed


Tag list settings

Manual -> Batch Control -> Engineering in the Editor -> Screen switch Batch Control -> Tag list settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Two parameter lists with identical options are available. These can be configured and used individually.

The parameter lists are created in the screen and configured in screen switching.

Tag List 1

Parameters

Description

Tag List 1

Display of the configured lists. The columns can:

  • be filtered
  • have their width changed by dragging the column title with the mouse
  • arranged by dragging & dropping with the mouse

Column selection

A dialog for choosing the columns which shall be displayed is opened

Column Format

Opens a dialog to format the columns.

Display command tag

Selection of the command parameters which should be displayed. Possible selection by activating the checkboxes:

  • Changeable in the master recipe:
    Only command parameters for which the changeable in the recipe option has been set in the Editor are displayed.
  • Changeable in the control recipe:
    Only command parameters for which the changeable in the recipe option has been set in the master recipe are displayed.
  • Changeable in the current recipe type:
    Only command parameters that can be changed in the current recipe type are displayed.
  • Cannot be changed in the master recipe:
    Only command parameters for which the Changeable in the recipe option has not been set in the Editor are displayed.
  • Cannot be changed in the control recipe:
    Only command parameters for which the Changeable in the recipe option has not been set in the master recipe are displayed.
  • Cannot be changed in the current recipe type:
    Only command parameters that cannot be changed in the current recipe type are displayed.

As many connections as desired can be configured. Activating all checkboxes leads to all command parameters being displayed.

Display return Tag

Active: Return parameters are displayed:

Variable for displaying the number of entries

Displays the maximum number of entries that is possible with the current pre-filtering of the screen filter. It is independent of the filtering in the columns and groupings.

A click on button ... opens the dialog for selecting variables.

Tag List 2

Parameters | Description
Tag List 2 | Parameter list 2 with identical configuration possibilities to Parameter Tag 1.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

The tag lists are recreated in Runtime if:

  • The phase was edited
  • The recipe was saved (even if the client has saved it)

info Information

Backward compatibility for displaying command parameters:

The option was expanded with version 7.11 and changed from radio buttons to checkboxes. For backward compatibility, this means:

Backward compatible writing is possible if:

Only one checkbox is set for the changeable parameters

or the combination of all checkboxes lets all parameters through

If the combination of the checkboxes results in a setting that was not previously configurable with zenon 7.10 or earlier, no parameters are displayed in the list.


zenon functions

Manual -> Batch Control -> Engineering in the Editor -> zenon functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With zenon functions, control commands can be sent to the batch execution and pre-defined control recipes can be created:

  • Execute recipe command or mode switch: sends control commands to batch execution
  • Create control recipe function: creates, in Runtime, a recipe that has been pre-defined in the Editor


Execute recipe command change or mode change

Manual -> Batch Control -> Engineering in the Editor -> zenon functions -> Execute recipe command change or mode change

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can send control commands to the batch execution with this function. To create the function:

  1. In the zenon Editor, navigate to the Functions node
  2. Select New function
  3. Go to the Batch Control in the function selections
  4. select Execute recipe command change/mode change
  5. the dialog for configuring functions is opened

Action

Parameters

Description

Action

Selection of the action to be executed:

  • Command
  • Mode

Command

Selection of the command to be executed from drop-down list:

  • Ignore
  • Start recipe
  • Recipe pausing
  • Recipe resuming
  • Recipe holding
  • Restart recipe
  • Recipe stopping
  • Recipe abborting

Mode

Selection of the mode to which the recipe is to be switched:

  • Ignore
  • Automatical
  • Semi-automatic
  • Manual

Use recipe filter for

Parameters

Description

Use recipe filter for

Selection of what the recipe filter is applied to:

  • Master recipe
  • Control recipe

The filter is processed from top to bottom For example, version is only applied to the recipes found in the master recipe filter.

Master recipe

Active: It is filtered on Master recipes.

Control recipe

Active: It is filtered on control recipes.

Note: The attendant master recipes must also be selected. If no master recipe has been selected for the control recipe, th filer cannot find the recipe being searched for in Runtime.

Hint: If the master recipe is not known, filtering of all master recipes with a placeholder is recommended.

Recipe Filter

Parameters

Description

Recipe Filter

Configuration of the recipe filter

Master recipe

Parameters for the selection of the master recipe. Selection from drop-down list:

  • Name with wildcards:
    A name with placeholder can be entered into the input field. Filtering according to this name is carried out.
  • Name from variable:
    The name of the master recipe is defined by a variable in Runtime. A click on button ... opens the dialog for selecting variables.
  • ID from variable:
    The ID of the master recipe is defined by a variable in Runtime. A click on button ... opens the dialog for selecting variables.

Version

Selection of the version from the drop-down list:

  • All:
    The version stated is ignored and each version found is used.
  • Fixed version:
    This filters for versions that are entered in this field.
    Highest possible version: 4294967295
  • Version from variable:
    The recipe that was in the linked variables at the time of execution is filtered for. Click on button ... in order to open the dialog for selecting a variable.
  • Only oldest version:
    Only the recipe with the oldest version number is used.
  • Only newest version:
    Only the recipe with the newest version number is used.

State master recipe

Status of the master recipe. Select from drop-down list.

When selecting master recipes for recipe filters:

  • All
  • Test mode
  • Test running

When selecting control recipes for recipe filters:

  • Released or outdated
  • Released
  • Outdated

Apply to found recipes

Definition of which master recipes the filter is applied to. Select from drop-down list:

  • All
  • Only oldest ID
  • Only newest ID

Control recipe

Parameters for the selection of the control recipe. Selection from drop-down list:

  • Name with wildcards:
    A name with placeholder can be entered into the input field. Filtering according to this name is carried out.
  • Name from variable:
    The name of the control recipe is defined by a variable in Runtime. A click on button ... opens the dialog for selecting variables.
  • ID from variable:
    The ID of the master recipe is defined by a variable in Runtime. A click on button ... opens the dialog for selecting variables.
    Precisely one recipe can be found if the variable value at the time of execution is a valid ID of a control recipe.
  • Job ID from variable:
    Finds control recipes that belong to the master recipes already found and which have the given job ID. Any type of variable can be linked. The value is automatically converted into STRING.

State control recipe

Definition of which recipe status the filter is applied to. Select from drop-down list:

  • All
  • Prepared
  • Running

Apply to found recipes

Definition of which control recipes the filter is applied to. Select from drop-down list:

  • All
  • Only oldest ID
  • Only newest ID

Note: Only the respective IDs are taken into account for master recipes and control recipes. The search for control recipes can find several recipes with this filter. This filter must also be activated for the master recipes for a unique result.

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Help

Opens online help.


Create control recipe function

Manual -> Batch Control -> Engineering in the Editor -> zenon functions -> Create control recipe function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the help of the function Create control recipe, a pre-defined control recipe can be created in the Editor by means of a button in Runtime. To create the function:

  1. In the zenon Editor, navigate to the Functions node
  2. Select New function
  3. Go to the Batch Control in the function selections
  4. Select Create control recipe
  5. the dialog for configuring functions is opened

Recipe Filter

Parameters

Description

Recipe Filter

Configuration of the recipe filter

The filter is processed from top to bottom For example, version is only applied to the recipes found in the master recipe filter.

Master recipe

Parameters for the selection of the master recipe. Selection from drop-down list:

  • Name with wildcards:
    A name with placeholder can be entered into the input field. Filtering according to this name is carried out.
  • Name from variable:
    The name of the master recipe is defined by a variable in Runtime. A click on button ... opens the dialog for selecting variables.
  • ID from variable:
    The ID of the master recipe is defined by a variable in Runtime. A click on button ... opens the dialog for selecting variables.

Version

Selection of the version from the drop-down list:

  • All:
    The version stated is ignored and each version found is used.
  • Fixed version:
    This filters for versions that are entered in this field.
    Highest possible version: 4294967295
  • Version from variable:
    The recipe that was in the linked variables at the time of execution is filtered for. Click on button ... in order to open the dialog for selecting a variable.
  • Only oldest version:
    Only the recipe with the oldest version number is used.
  • Only newest version:
    Only the recipe with the newest version number is used.

Apply to found recipes

Definition of which recipes the filter is applied to. Selection of ID from drop-down list:

  • All
  • Only oldest ID
  • Only newest ID

Control recipe name

Parameters

Description

Control recipe name

Configuration of the name of the control recipe.

Control recipe name

Selection of the naming from the drop-down list:

  • Automatic name: Name is automatically issued on creation
  • Name from variable: Name is taken from a variable. Click on button ... in order to open the dialog for selecting a variable.
    If there is already a recipe with the name that has been transferred from the variable, no new control recipe is created.

Job ID

Parameters

Description

Job ID

Configuration of the Job ID.

Link individual job variable

Active: A job variable can be linked. The variable must already be configured. Selection of the variable from the drop-down list:

Apply value from job variable

Definition of the time at which the job ID is transferred. During:

  • Starting control recipe
  • Creating control recipe

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

The function is nevertheless created, however without a defined target.

Help

Opens online help.

All filters always have an effect on a group of recipes with the same name. Depending on the configuration, more than one recipe can remain left over.
For example: Recipes with the filter *Test are searched for. The result is 5 versions of Test_1 and 3 versions of Test_2. If filtering for the latest version is continued, then two control recipes are created, one each for the recipe with the highest version number per group.

Note for variable selection using name or ID: For the selection of variables according to name or ID, numerical variables and string variables can be selected respectively. The data types are converted to the respective correct form.


Replace links

Manual -> Batch Control -> Engineering in the Editor -> Replace links

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Linking of variables and functions can be replaced automatically in units, phases and reactions. This process corresponds to the process for replacing linking for screen switching and replacing linking in the Editor screen. The replacement can

The following can be replaced:

  • Units: linked variables for Runtime information
  • Reactions: linked functions
  • Parameter: linked variables

To replace elements:

  1. Select the Replace linking command in the context menu or the tool bar
  2. The dialog for the replacement of links opens.

Property | Description
Source | Enter the partial string to be searched for. Place holder * and ? can be used. Placeholders are only permitted as prefix or suffix; e.g. *xxx or xxx*.
Objective | Entry of the partial string
Name | Swaps information in process variable names.
Identification | Exchanges information in the identification
Note capitalization | When swapping, be sure that any capitalization is an exact match.
Accept | Swaps target strings from the source for those defined in the target.
Variable/function | Opens the selection list for variables/functions in relation to the selected line in the list. Clicking on the variable in the list defines new target variables. Alternative: Double-click on the source variable in question.

Replace

a) Replace by manual selection

  • select the element from the list that you would like as the source
  • select a target element via the variable/function button
  • the previous element is replaced by the new one

b) automated replacement with rules

  • In the source input field, define the parameters for the element that you wish to replace
  • define the parameter for the new variable/function in the target input field
  • specify what is to be replaced via Name/Identification
  • Click on Accept

info Information

The target variable or target function can also be in a different project as the source variable or source function. In doing so, all projects concerned must be started and available on the same computer in Runtime.

attention Attention

When replacing variables, be aware of the type and signal resolution. If you replace a variable with one of an incompatible type, this can lead to errors during execution. You will be warned when making the substitution; the substitution will however be carried out.


Configure and control in the Runtime

Manual -> Batch Control -> Configure and control in the Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The entire management, creation and processing of the recipes is done in the Runtime. Editing in the zenon Editor is not possible.

Note: Runtime files up to and including version 7.00 SP0 are not compatible with subsequent versions. Versions from version 7.10 and later are compatible.

Synchronization

When loading, opening, duplicating and approving a recipe or operation, a check is made to see if the configuration of units, phases etc. has been changed in the superordinate instance, such as the Editor. For details, see the Synchronization chapter.

Selection procedure in lists:

  • Ctrl+A: selects all elements
  • Ctrl+mouse click: adds master recipe to the existing selection
  • Key Shift+mouse click: Extends selection from the currently selected master recipe to the clicked master recipe

Saving of recipes when closing Runtime

If Runtime is closed and there are still recipes that have not been saved, you are asked if these recipes are to be saved. In order for this query to not prevent Runtime closing, Runtime is automatically closed after 15 seconds if nothing is entered. Unsaved recipes are then discarded.


User interface

Manual -> Batch Control -> Configure and control in the Runtime -> User interface

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The user interface of the editor in Runtime can be configured with tool bars and dockable windows.

Example: User interface with list of the master recipes, list of the control recipe, list of the operation and PFC editor:

Switching positions

The position in the recipe is adapted depending on the recipe and status of the recipe:

  • When opening a currently-running recipe:

    It is centered on the first active element. The first active element is the one that is at the top. If there are several active elements in the same line, the element that is furthest to the left is selected. Elements with execution positions before or after this are handled the same as the active ones in this case.

  • When a recipe is first opened

    Centering is on the start of the recipe. In a PFC recipe, centering is on the start element. A matrix recipe is opened in such a way that the upper left corner is visible.


Editor operating elements

Manual -> Batch Control -> Configure and control in the Runtime -> User interface -> Editor operating elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following are available for the editor:

  • Tool bars (can be hidden)
  • Tabs
  • Dockable windows

Toolbars

There are independent toolbars available in the Editor for each type of recipe and the different status. For details, see the Matrix recipe toolbars and Toolbars and PFC recipe context menu chapters. All actions of the individual symbols can also be engineered using their own buttons in the screen. If the tool bars are thus not needed, they can be displayed or hidden using the settings in the zenon Editor.

To show/hide tool bars:

  1. In the zenon Editor, highlight the Recipe editor comment area in the Batch Control screen
  2. go to property group Representation\Display editor control elements
  3. Activate or deactivate the Toolbars checkbox


Tabs in the Editor

Manual -> Batch Control -> Configure and control in the Runtime -> User interface -> Editor operating elements -> Tabs in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If several recipes are open in the editor, these are represented with tabs. Recipes can be displayed and opened in two groups next to each other or underneath each other. To open a recipe in a new group:

  1. Select, in the context menu of the recipe, the horizontal neighboring group or vertical neighboring group command
  2. Select the type of display:
    • Move
    • Open in parallel

The control elements are always only applicable to the active recipe of the active group.

  • The active group is emphasized in color.
  • The active tab is emphasized with bold font. Information on the active tab is shown in the title bar of the editor.
  • Tabs can be moved and arranged by dragging & dropping, including between groups.

Tab context menu

Parameters

Description

Save

Saves changes in the recipe.

Close

Closes the recipe.

Close all others

Closes all other open recipes. Only the recipe in which the context menu was activated remains open.

Group horizontally

Opens the recipe in a new group below the other recipes.

  • Move display: The recipe is moved and the upper group is removed.
  • Move display parallelly The recipe is displayed in parallel in both groups.

Group vertically

Opens the recipe in a new group to the right of the active group.

  • Move display: The recipe is moved and removed from the left group.
  • Open display in parallel: The recipe is displayed in parallel in both groups.


Dockable windows

Manual -> Batch Control -> Configure and control in the Runtime -> User interface -> Editor operating elements -> Dockable windows

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the recipe editor, three windows can be shown, positioned and docked as desired:

  • List of master recipes
  • List of control recipes
  • List of the operations

For details on the selection and positioning, see the Selection and positioning chapter.

The settings are saved individually for each computer and user.

Show/hide list

The list of dockable windows can be displayed or hidden by means of settings in the zenon Editor.

To show/hide the list:

  1. In the zenon Editor, highlight the Recipe editor comment area in the Batch Control screen
  2. go to property group Representation\Display editor control elements
  3. Activate or deactivate the Dockable windows checkbox

Examples

Additional list of the operations shown in the Recipe Editor:

Additional list of master recipes, control recipes and operations shown in the Recipe Editor:

Lists of master recipes, control recipes and operations shown in the Recipe Editor:


Selection and positioning

Manual -> Batch Control -> Configure and control in the Runtime -> User interface -> Editor operating elements -> Dockable windows -> Selection and positioning

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Selection and positioning

To show and dock the window in the Editor:

  • Select the desired window using the drop-down list of the Selection of dockable windows
  • move the window to the desired position
  • Locate this with the positioning aid

The Selection of dockable windows is located at the right edge of the status bar of the Editor. Clicking on the symbol opens the list of dockable windows. Selection is carried out by means of activation/deactivation of the checkboxes.

Positioning aids

When moving windows from the Editor interface, positioning aids are displayed. These represent windows or their borders.

This element represents a window area in the Editor.

This element represents the border area of the Editor.

Position window

To position an element as docked:

  1. Move the element with the mouse into the desired area
  2. The positioning aid is displayed
  3. This represents a window and its areas:
    1. Center: whole window
    2. Top: upper half
    3. Bottom: lower half
    4. Right: right half
    5. Left: left half

    or the border of the Editor

  4. Move the mouse to the central positioning aid or to a positioning aid on the border of the editor and from there to the desired area
  5. The area in the Editor where the element was placed when the mouse button was released is colored in blue
  6. Move the mouse within the positioning aid to the desired area that is displayed in blue
  7. Let the mouse button go and the element is placed

If a window is placed on a pre-existing window, both windows are displayed at the same location using tabs.

Note: You can read more about positioning in the chapter on the zenon Editor in the User interface/Positioning windows section.


Commands and actions

Manual -> Batch Control -> Configure and control in the Runtime -> Commands and actions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Runtime the following commands and actions are available:

  • Commands effect the recipe process.
  • Actions make it possible to edit recipes.

Commands

For a command to be accepted by the phase, the following requirements are necessary:

  • The REE must run.
  • The phase must be active.
  • The phase must be in a state in which the command is allowed.

Via multi-selection the command can be sent to several phases in the same execution cycle.

Command | Description
Start recipe | Starts the recipe process.
Pause recipe | Pauses the recipe process.
Resume recipe | Resumes a held or paused recipe.
Hold recipe | Holds the recipe process.
Restart recipe | Restarts the recipe.
Stop recipe | Stops the recipe.
Recipe aborting | Aborts the recipe.
Pause phase | Pauses the phase.
Resume phase | Resumes the phase.
Hold phase | Holds phase.
Restart phase | Restarts the phase.
Switch to automatic mode | Switches the REE to automatic mode.
Switch to semi-automatic mode | Switches the REE to semi-automatic mode.
Switch to manual mode | Switches the REE to manual mode.
Continue recipe only on selected active elements | Continues a recipe at the selected position.
Continue recipe on all execution positions | Continues a recipe on every available position.
Skip active condition | Skips an active condition. Only possible in the manual mode.

Permitted commands

Execution conditions apply to recipe commands and phase commands. For example, the control recipe can no longer be stopped if it has the status of Cancel.

Note: The Reset command is not implemented in zenon Batch Control.

Overview of commands in Batch Control

Note: This overview has been taken from the ANSI/ISA-S88 standard (illustration 18).

Action on stop command

After a stop command, the phases, transitions and end simultaneous sequence immediately go to stopped status, even if other elements are still waiting for a condition for stopping. Further subsequent commands such as cancel are ignored. The stopped status remains displayed.

Actions

Action | Description
Check recipe for errors | Checks the recipe for errors and displays error messages.
Edit element | Opens the corresponding dialog for editing the selected element.
Graphical design | Opens the dialog to configure background colors, grid, and display of element ID.
Duplicate Recipe | Copies the selected recipe and adds it as copy to the list.
Create control recipe | Creates a control recipe on the basis of the approved master recipe.
New master recipe | Opens the dialog for creating a new recipe.
Save master recipe | Saves all changes which were done since the last saving.
Delete | Deletes the selected element.
Exchange phase | Opens the dialog for selecting a phase. The present phase is replaced by the newly selected phase.
Edit mode | Switches the mouse cursor from adding an element to edit mode. The switch back to the edit mode can also be achieved by pressing the Esc key.
Insert phase | Occupies the mouse cursor with a phase. It can be added to any allowed, free location via click.
Insert transition | Occupies the mouse cursor with a transition. It can be added to any allowed, free location via click.
Insert begin simultaneous sequence | Occupies the mouse cursor with a begin simultaneous sequence. It can be added to any allowed, free location via click.
Insert end simultaneous sequence | Occupies the mouse cursor with an end simultaneous sequence. It can be added to any allowed, free location via click.
Insert begin sequence selection | Occupies the mouse cursor with a begin sequence selection. It can be added to any allowed, free location via click.
Insert end sequence selection | Occupies the mouse cursor with an end sequence selection. It can be added to any allowed, free location via click.
Insert unit allocation | Occupies the mouse cursor with a unit allocation. It can be added to any allowed, free location via click.
Insert jump target | Occupies the mouse cursor with a jump target. It can be added to any allowed, free location via click.
Switch recipe to test mode | Switches recipe to the test mode.
Release recipe | Releases the recipe. With this a control recipe can be created.


Graphical design

Manual -> Batch Control -> Configure and control in the Runtime -> Graphical design

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Clicking on the symbol for the graphic design in the tool bar opens the dialog for configuring the colors, grid settings and display of the element ID.

Parameters

Description

Background color

Defines the background color of the diagram. Click on the color in order to open the palette for selecting a color.

Display grid
  • Active: Display the grid
  • Inactive: Grid is hidden.

Can only be configured for PFC recipes.

Grid color

Defines the line color of the grid. Click on the color in order to open the palette for selecting a color.

Display element ID

Inactive: No element ID is shown in the recipe.
Note: This setting is recommended for normal operation.

Active: The ID of the elements is displayed in the recipe. The exception is lines. The display is in the upper left-hand corner of the element.
Note: This setting is recommended for troubleshooting.

OK

Applies all settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.


Engineering rules for recipes

Manual -> Batch Control -> Configure and control in the Runtime -> Engineering rules for recipes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

At the engineering the rules defined in standard ANSI/ISA-S88 are generally true.

Important principles:

General

  • For all elements all connection points must be connected.
    Exception: Jump targets. Only two of the three input connection points need to be linked there.
  • The begin element is always present only once with PFC recipes and marks the beginning of the process. It is not visible with matrix recipes.
  • The end element is always present only once with PFC recipes and marks the end of the process. It is not visible with matrix recipes.
  • Phases can be inserted anywhere. You can also place several phases in succession.
  • At least one active phase should be present in the recipe.

Transitions

  • Transitions only exist in PFC recipes.
  • Two transitions may not lie one after the other.

Sequence selection

  • Sequence selections only exist in PFC recipes.
  • The first element after an begin sequence selection must be a transition.
  • The individual sequence selections which start at begin sequence selection must all end in an end sequence selection never in an end simultaneous sequence. Any element can be placed between begin and end of a sequence selection even simultaneous sequences as long as they are closed before the end sequence selection element. And end sequence selection can be replaced with jump targets at any point, including within a simultaneous sequence.
  • It is not necessary to have an end sequence selection for each begin sequence selection. You can for example have two begin sequence selection elements ending in one end sequence selection or the other way round.
  • It is not necessary to have an end sequence selection for a begin sequence selection. It can simply end in a line. If for example you have a begin sequence selection element with two paths and one of the paths ends in a jump target, it does not make sense to have an end sequence selection.

Simultaneous sequences

  • Each simultaneous sequence must contain at least one phase.
  • The first element after a Begin simultaneous sequence must no be a transition.
  • The individual sequence selections that start at a begin simultaneous sequence must all end in end simultaneous sequence, but must never end in a end sequence selection. You may use any elements between begin simultaneous sequence and end simultaneous sequence even sequence selections as long as they are closed before the end simultaneous sequence.
  • Not all sequence selections which were started in a begin simultaneous sequence must end in an end simultaneous sequence. It is enough when all sequence selections converge over an end parallel objects. Equally sequence selections from different begin simultaneous sequence objects may converge in a single end simultaneous sequence.
  • Simultaneous sequences can be embedded in simultaneous sequence.
    In doing so: each embedded simultaneous sequence must recombine with the superordinate simultaneous sequence

Lines in the PFC editor

  • Lines may be used as connections between any objects. It is allowed to add any number of lines after another.
  • Lines must not be used to connect two equal connection points.
    For example: The both inputs of two phases must not be connected directly with a line. In the engineering this connection is allowed. It is however displayed in red (error) and in the validation an error message is displayed.

Jump targets

  • Jump targets only exist in PFC recipes.
  • Jump targets correspond to an end sequence selection. They are intended to
    • jump between sequence selections,
    • jump out of sequence selections,
    • engineer loops

    For this, the following applies: A path which ends in a jump target must have started with a begin sequence selection. Otherwise the end is not reached.

  • Jump targets consist of tree inputs and one output. At least two inputs and the output must always be connected. At this it makes no difference which input connection point is connected.
  • Jump targets can be switched consecutively if at least two input connection points are allocated.
  • Jumps are prohibited:
    • between simultaneous sequences
    • to jump out of a simultaneous sequence
    • to jump in a simultaneous sequence.

Configuration of objects

Reactions

  • Reactions can appear in each object state.
  • For each reaction type several reactions are possible. They are sorted at the triggering and are executed in accordance to their priority. At this 1 is the highest priority.
  • All variables of all parameters are signed in to the driver for reading. If a value is needed at a reaction but is not yet available or invalid, the alternate value is written. The writing of the value is done without write confirmation.
  • Some of the reactions are triggered only once in the process - e.g. time outs. If the phase is restarted, these reactions are also retriggered if necessary.


Status line

Manual -> Batch Control -> Configure and control in the Runtime -> Status line

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The status line is automatically adapted to each recipe that contains the focus and initialized with its data. The the status line the following is displayed:

  • Mode of the recipe
    • Edit mode
    • Manual mode
    • Semi-automatic mode
    • Automatic mode
  • Status of the recipe:
    • Ready for start
    • Error: Currently there is an error in the recipe. The number of errors is also displayed.
    • Historical error: During the execution at least one error occurred. Currently not error exists.
    • No error: Until now the execution runs faultless.
  • Current execution status.
  • Mouse cursor position and changes such as moving the connection line
  • Deleting, adding or selecting of elements
  • Approval of a recipe
  • Finished without errors
  • Zoom level of the current view; this can also be controlled here

The global statuses of the main recipe are also displayed when executing operations.


Recipe types and recipe states

Manual -> Batch Control -> Configure and control in the Runtime -> Recipe types and recipe states

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Batch Control distinguishes between the two following recipe types:

  • PFC recipes: For free, complex processes. These are created with the PFC editor.
  • Matrix recipes: For simple, sequential, parallel processes. They are created with the matrix editor.

The following type of recipes are available:

  • Master recipes:
    Form the basis for the control recipes. The created in status Editable. If they are in status Released, they can no longer be modified.
  • Operations:
    Form a substructure that can be embedded in recipes. This can provide a better overview in complex recipes. Operations are created in a similar manner to matrix recipes or PFC recipes. The operations are created on the basis of templates and as an instance in existing matrix recipes or PFC recipes.
  • Control recipes:
    Are recipes which can be executed once. Each control recipe is based on a master recipe. Control recipes can be modified concerning the process. The process is defined by the master recipe. Changeable are only command tags for which option Changeable in control recipe was activated.

Recipes are created and edited in Runtime. If a screen that contains recipes that have not been saved is closed, the user is asked if the recipes are to be saved. If there is no input from the user within 15 seconds, the unsaved changes are discarded and the screen is closed.

Status for master recipes

Master recipes can have the following states:

  • Editable: In this state everything can be changed. Each new master recipe is created in this status.
  • Test mode: In this status the recipe behaves similar as a control recipe. As them the process cannot be modified. It can be executed and all commands, actions, modes, etc. are available. You can also change all command tags for which option Changeable in recipe was activated.
    Exception: If a phase is active at the moment, changes are not possible. Decisive for this is the status at clicking button OK. If the phase is active, the value changes are not taken over and an error message is displayed.
    In test mode recipes can be executed consecutively several times. This is not the case for control recipes.
    Changes from the Editor are only applied after reloading or after Runtime has been restarted, however only once the recipe has been ended.
  • Released: In this status no changes to the recipe are possible
    Note: Also changes to the phases or to the reactions in the Editor are not transferred to a master recipe. The status at the release are frozen.
    Exception: Changes to variable and function are not considered by these protection mechanisms. This can lead to a master recipe and all control recipes based on it becoming invalid. If e.g. the data type of a variable is changed from Bool to String, the validation function is no longer run through and the recipe can no longer be used as long as the error is not fixed in the Editor. Likewise the units themselves are not protected as they are used recipe-spanning. If a unit name is changed in the Editor, it immediately takes effect after reloading or a Runtime restart on all phases which are based on it.

    To be able to release a master recipe, the recipe must be validated without errors. The validation is done automatically during the release and and cannot be avoided. Control recipes can only be created from released recipes.

    If a master recipe with status Release should be modified, you must create a copy of the master recipe via command duplicate. The copy gets status Editable.

Status for control recipes

Control recipes can have the following states:

  • Prepared: A newly created control recipe has this status. In this status it can be started and command tags, for which option Changeable in control recipe was activated, can be changed.
  • In execution: The control recipe was started and is processed. It remains in this status until it is Completed, Stoppedor Canceled. You can learn the exact state of the recipe from the execution status.
    In this status, command parameters for which the Changeable in control recipe option was activated can be changed.
    Exception: If a phase is active at the moment, changes are not possible. Decisive for this is the status at clicking button OK. If the phase is active, the value changes are not taken over and an error message is displayed.
  • Finished: The recipe reached its final state. It can no longer be restarted and it also cannot be changed. Changes to command tags are not possible. Finished control recipes can be duplicated and deleted.


Control Strategy

Manual -> Batch Control -> Configure and control in the Runtime -> Control Strategy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Control strategies can be selected in Runtime when configuring the phase in the PFC recipe or matrix recipe. They must have already been configured in the Editor.

Control strategies can only be changed:

  • In master recipes
    • In editing mode
    • Test mode
  • In operation templates:
    • In editing mode

The control strategy cannot be changed In operation instances.

Command parameters in the phase

If control strategies are activated for a phase (Active control strategies property in the Editor), all command parameters are initially removed when this phase is inserted into a recipe.

If the control strategy is changed in the dialog to edit a phase, then:

  • All parameters currently in this phase are removed
  • The linked parameters in the newly-selected control strategy are inserted

    These parameters are only initialized with the values that the parameter linkings currently have. The existing Runtime configuration of the parameters is lost in the process. .

If a control strategy is selected for a phase, then the parameters to write to control strategy number are inserted in addition to the linked parameters. This parameter gets the parameter number as a numerical value. It is not a recipe parameter. If the same parameter is already linked to the control strategy, the configuration of the linking is ignored!

Synchronization of changes to control strategies and control strategy activation

During synchronization, changes made in the Editor for control strategies are carried over for phases. For details, see the synchronization chapter.

Display of the control strategy

Selected control strategies are displayed:

  • In the tooltip of the phase (no display if no control strategy has been selected)
  • In the phase in the recipe.

    Matrix:

    PFC:

  • In the unit information for the active phases as an appendix
  • In the report for a phase

Control strategies and variables

If a phase is selected in the recipe, the variables for the control strategy are filled.

Parameters

Data type

Description

Control strategy name

STRING

Displays the Name of the control strategy that is linked to the selected phase.

Is empty if:

  • No phase is selected
  • The phase does not use any control strategies
  • There is no control strategy currently linked to the phase
  • With multiple selection

Description of control strategies

STRING

Displays the Description of the control strategy that is linked to the selected phase.

Is empty if:

  • No phase is selected
  • The phase does not use any control strategies
  • There is no control strategy currently linked to the phase
  • With multiple selection

Control strategy number

LINT

Displays the control strategy number of the control strategy that is linked to the selected phase.

Is -1 if:

  • No phase is selected
  • The phase does not use any control strategies
  • There is no control strategy currently linked to the phase
  • With multiple selection


Master recipes

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Master recipe are the basis of control recipes. With the help of master recipes you define and test the recipe process. After a master recipe is released, its content and structure can no longer be changed.

For the creation of master recipes two editors are available:

  • Matrix editor
  • PFC editor

Depending on the license, either just the matrix editor or both editors are available.


Create master recipe

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> Create master recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A click on button Create master recipe opens the dialog Configuration master recipe.

Parameters

Description

Matrix recipe

Activate this radio button if you want to create a matrix recipe.

Note: Only possible if the corresponding license is available.

PFC recipe

Activate this radio button if you want to create a PFC recipe.

Note: Only possible if the corresponding license is available.

Name

Unique name for the recipe. The name must not contain a dot (.), a question mark (?), a @ or an asterisk (*).

Maximum length: 256 characters.

Note: When you copy a recipe the existing name is complemented with the prefix "Copy of". If the maximum length is exceeded by this, the name is shortened to the allowed length starting from the last character.

The uniqueness is checked in the entire network. Therefore it can happen that you cannot take over the name as another user on another computer in the zenon network already has used the same name and you do not see the recipe in the list of the master recipes yet.

The recipe names can be changed later but only as long as the recipe is in status Editable.

Description

Optional description for the recipe which should be created.

The description can be changed later but only as long as the recipe is in status Editable. To change the description select the symbol Rename master recipe.

OK

Applies all settings and created a new recipe.

Cancel

Closes the dialog without creating a recipe.


Tool bar and context menu for master recipe list view

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> Tool bar and context menu for master recipe list view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tool Bar

Symbol | Description
New master recipe | Opens the dialog for creating a new master recipe.
Open master recipe in Editor | Opens the selected recipe in the recipe editor.
Create new version | Creates a new version of the selected master recipe. This must be approved or marked as obsolete.
Rename master recipe | Opens dialog to rename the selected recipe.
Duplicate master recipe | Creates a copy of the selected recipe and opens the dialog to rename the duplicate.
Delete master recipe | Deletes selected recipes.
Switch master recipe to test mode | Switches selected recipe to test mode after requesting confirmation.
Switch master recipe to edit mode | Switches selected recipe to edit mode after requesting confirmation.
Release master recipe | Approves selected recipe after requesting confirmation.
New control recipe | Opens the dialog for creating a new control recipe.
Include running control recipes in the display | Includes running control recipes in the display.
Include prepared control recipes in the display | Includes prepared control recipes in the display.
Include finished control recipes in the display | Includes finished control recipes in the display.
Include outdated control recipes in the display | Includes outdated control recipes in the display.
Display list of attendant control recipes in control recipe list | Shows all control recipes that belong to approved control recipes.
Column selection | Opens the dialog for selecting the columns which should be displayed.
Column Format | Opens the dialog for configuring the column formats.

Context menu

Command | Description
New master recipe | Opens the dialog for creating a new master recipe.
Open in Recipe Editor | Opens the selected recipe in the recipe editor.
Rename | Opens dialog to rename the selected recipe.
Duplicate | Creates a copy of the selected recipe and opens the dialog to rename the duplicate.
Delete | Deletes selected recipes.
Switch to edit mode | Switches selected recipe to edit mode after requesting confirmation.
Switch to test mode | Switches selected recipe to test mode after requesting confirmation.
Release | Approves selected recipe after requesting confirmation.
Highlight as outdated | Marks the selected recipe as outdated.
New control recipe | Opens the dialog for creating a new control recipe.
Display associated control recipes in list | Shows all control recipes that belong to selected approved control recipes.


PFC recipe

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> PFC recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If you selected PFC recipe in dialog Configuration master recipe and exited the dialog with OK, the newly created recipe opens on a new tab in the PFC editor.

As each recipe needs a begin and an end element, these two elements already exist in the recipe and cannot be deleted from it.

Add the desired phases, transitions, sequence selections, simultaneous sequences and unit allocations to your recipe. Fields which are unsuitable for adding an element turn red when you move the element above it.


PFC editor

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> PFC recipe -> PFC editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the PFC editor you can create your recipes graphically.

Technical details

  • Sheet size:
    • Default: 11 x 11 cells
    • Minimum: 5 x 5 cells
    • Maximum: 500 x 1000 cells
  • Cell size
    • Default: 155 x 111 pixels
  • Outside edge: 100 pixel
  • Grid: is displayed by default; can also be hidden
  • Scroll bar: Is displayed if the document is larger than the frame.
  • Scrolling via mouse wheel: up and down or if you press and hold Shift left and right.
  • Zooming: Ctrl + mouse wheel
  • Selecting elements: left mouse click
  • Multiple selection: Ctrl + mouse click
  • Move symbol: Click element and move it over the diagram while holding the left mouse button pressed. Content can be dropped to cells with green background. If a cell turns red when you move over it, you cannot drop the content.


Tool bar and context menu PFC recipe

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> PFC recipe -> Tool bar and context menu PFC recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tool bar PFC editor: Edit mode

Parameters

Description

New master recipe...

Opens the dialog for creating a new master recipe.

Save master recipe

Saves the master recipe which is open for editing.

Graphical design

Opens the dialog to configure background colors, grid, and display of element ID.

Delete

Deletes the selected elements from the diagram.

Multiple selection via Ctrl+mouse click.

Check recipe for errors

Checks recipe for errors and displays found errors in an information window. For several errors the first errors are displayed.

The error message contains the error number, the ID of the element, its location and a message in plain text.

Edit element

Opens the corresponding dialog for editing the selected element.

Replace phase/operation

Opens dialog to select a phase or an operation and replaces the existing phase with the newly-selected one or the existing operation with a newly-selected one. Several phases or operations can be selected and replaced together.

Shortcut: Shift+double click

Edit mode

Toggles between insert mode and edit mode.

Insert phase

Adds a phase.

Insert transition

Adds a transition.

Insert begin simultaneous sequence

Adds a begin simultaneous sequence.

Insert end simultaneous sequence

Adds an end simultaneous sequence.

Insert begin sequence selection

Adds a begin sequence selection.

Insert end sequence selection

Adds an end sequence selection.

Insert unit allocation

Adds a unit allocation.

Insert jump target

Adds a jump target.

Insert operation

Adds an operation.

Switch recipe to test mode

Switches recipe to the test mode. For this the recipe must be without errors.

Release recipe

Releases the recipe. With this a control recipe can be created.

Note: Insertions remain active until you change to the edit mode using the Edit mode symbol, the Esc key or you change to another insert option via a symbol for adding a new element.

Tool bar PFC Recipe Test mode

Parameters | Description
Start recipe | Starts the recipe process.
Pause recipe | Pauses the recipe.
Resume recipe | Resumes paused recipe.
Recipe holding | Holds recipe.
Restart recipe | Restarts held recipe.
Stop recipe | Stops the recipe.
Recipe aborting | Aborts the recipe process.
Pause phase | Pauses the phase.
Resume phase | Resumes the process of a paused phase.
Hold phase | Holds phase.
Restart phase | Restarts held phase.
Escape phase | Starts process to exit from the phase.
Check recipe for errors | Starts recipe validation.
Edit element | Opens the corresponding dialog for editing the selected element.
Graphical design | Opens the dialog to configure background colors, grid, and display of element ID.
Switch to automatic mode | Switches process to automatic mode.
Switch to semi-automatic mode | Switches process to semi-automatic mode.
Switch to manual mode | Switches process to manual mode.
Continue recipe only on selected active elements | Continues a recipe at the selected position.
Continue recipe on all execution positions | Continues a recipe on every available position.
Skip active condition | Skips an active condition. Only possible in the manual mode.
Edit mode | Switches from test mode to edit mode.
Release recipe | Releases the recipe. With this a control recipe can be created.

PFC recipe tool bar: approved

Parameters

Description

Check recipe for errors

Checks recipe for errors and displays found errors in an information window. For several errors the first errors are displayed.

The error message contains the error number, the ID of the element, its location and a message in plain text.

Edit element

Opens the corresponding dialog for editing the selected element.

The dialog is opened in write-protected mode, because it is no longer possible to edit approved recipes.

Graphical design

Opens the dialog to configure background colors, grid, and display of element ID.

Duplicate recipe

Only active if precisely one recipe was selected.
Creates a copy of the selected recipe. At the creation of the copy, the version of the recipe saved on the hard disk is used. If the recipe is just edited in another computer and the changes have not yet been saved, the changes are not applied. The dialog for the input of a unique name and the description is opened.

Create control recipe

Creates a control recipe on the basis of the approved master recipe.

info Information

The functions of the individual symbols can also be configured using buttons and thus be made touch-operable. Tool bars can therefore also be hidden.


Begin element

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> PFC recipe -> Begin element

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

First element in the process. It is automatically created in the editor when a recipe is created and it cannot be deleted.


Allocate and configure unit

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> PFC recipe -> Allocate and configure unit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To allocate a unit:

  1. in the tool bar select the symbol for Insert unit allocation
  2. move the mouse to the desired position
  3. place the unit
  4. the unit is added

To configure the unit allocation:

  1. double click the unit
  2. The dialog for configuration is opened

Configuration

In a configuration dialog you can select the units which exist in the batch recipe for the Runtime. It is distinguished between allocation and release. Releases can be set selectively and globally. Units which were selected before and no longer exist in the recipe, are displayed with an appropriate note.

If the dialog is opened in an approved recipe, then it is displayed as "read only". All entries can be viewed but not changed.

Parameters

Description

List units

Displays existing units and their assigned actions.

Action

Assigns an action to the unit selected in the list.

Allocation of the unit.

Allocates the unit.

Release of the unit.

Releases the unit:

  • Release of the last allocation: The last allocation is released.
  • Recipe-spanning release: All allocations in the recipe are released.

OK

Applies settings and closes the dialog.

Cancel

Discards changes and closes the dialog.

Allocate and release units

The allocation of a unit by element unit allocation or by a phase is only possible if the unit is not yet allocated or only in the same recipe. Allocation and release of units is always done in a cycle. It is always waited until all units which should be allocated are released. Then all allocations and releases are down at the same time. Phases which are located in front of an element unit allocation remain active until the allocation was successful.

Unit allocations remain in place as long as the phase is active. When the recipe is finished and there are still allocations of elements Unit allocation active, they are released implicitly.

Note: A phase with the paused or held status does not attempt to allocate the unit. This also applies if the phase is switched to paused or held whilst waiting. An attempt to allocate the unit is only made after a restart. But: In manual mode you can force the allocation of a unit by another recipe. The recipe with the first allocation keeps the control and takes priority at the execution. If this recipe withdraws its main allocation, the recipe with the longest active forced allocation takes over the main allocation.

Actions

For each unit which is used in the recipe, you can define an action:

  • no action
  • allocate
  • release

Tool tip

In the tool tip of element Unit allocation all units are displayed which are marked for allocation or release. During the execution the Execution duration is stated and all units for which you must wait are color-coded. You must wait for units if they are allocated in another recipe.


Add and configure phase

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> PFC recipe -> Add and configure phase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To add a phase:

  1. in the tool bar select the symbol for Insert phase
  2. move the mouse to the desired position
  3. locate the phase
  4. the dialog for selecting a phase is opened
  5. select the desired phase

To configure a phase:

  1. double click the phase
  2. The dialog for configuration is opened
    (if an element has not yet been assigned a phase, double-clicking opens the dialog to select a phase)

Note: The shift key plus a double click always opens the dialog to select a phase.

Configuration

Parameters | Description
Phase active in this step | Active: Phase is active in this step
Name | Name of the phase. Only display.
Description | Comment about the phase. Only display.
Unit | Unit on which the phase is carried out. Only display.
Control strategy | Selection of a control strategy from a drop-down list. Only available if control strategies have been configured for this phase. Default: no Control strategy linked
Description of control strategies | Description of the selected control strategy. Display of the description entered in the Editor only.
General | Tab for configuration of general properties.
Parameters | Tab for configuration of parameters.
OK | Applies all changes on all tabs and closes the dialog.
Cancel | Discards all changes on all tabs and closes the dialog.

Configuration of the tabs see chapter:

  • General: Display and configuration of the settings for the phase
  • Tag: Configuration of the tags

The entry of a reason can be requested in order to make changes. To do this, either the Reason for value change necessary property must be activated in the Edit tag node for the module in general, or the Reason for value change necessary property in the General group for individual functions.

Rules for editing a phase

A phase can be edited:

  • In a master recipe in edit mode: If the user has sufficient rights.
  • In a master recipe in test mode: If the user has sufficient rights and the phase is not active.
  • In a control recipe with prepared status: If the user has sufficient rights and the Changeable in the control recipe option has been activated.
  • In a control recipe with running status: If the user has sufficient rights, the Changeable in the control recipe option has been activated and the phase is not active.

The phase can no longer be edited in pre-configured control recipes and in approved master recipes.


Selection phase

Selection phase

If a phase is added, the dialog for selecting a phase is opened.

Parameters | Description
Project tree | Displays the current project from which the phases can be selected.
List field phases | In the list all phases engineered in the Editor are displayed. This list can be filtered. The filtering is case-sensitive. Placeholders * and ? can be used.
Cursor keys | Move selected phases up or down.
No selection | Deletes already selected phases from the element.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.

All settings of the dialog are saved user-specifically when the dialog is closed.


General

General

The properties of tab General are set in the Editor with the exception of Changeable in the control recipe. The values can changed in the master recipe. A symbol indicates whether the value in the dialog matches the value in the Editor. For different values you can again apply the value defined in the Editor.

Meaning of the symbols next to the values:

Parameters | Description
 | Value in the dialog and the value in the Editor match.
 | Value in the dialog and the value in the Editor do not match.
 | Only active if the values in the recipe and Editor do not match. Click on button to apply the value from the Editor. It overrides the value in the master recipe.

For information on configuration of the basic data on these tabs, see the Add and configure phases chapter.

Parameters

Description

Waiting period unit allocation

Time in days, hours, minutes and seconds which is waited for the allocation of the unit. The waiting period can be changed in the Runtime as long as the recipe has status Editable.

After the defined period has exceeded, the event Waiting period unit allocation exceeded is triggered and the element is highlighted. Additional actions must be defined by the engineer. If no further actions take place, the waiting is continued.

Maximum: 9999T 23:59:59
Default: 0d 00:00:00

Note: A unit can only be allocated by a single recipe with status In execution at a time.

Value is predefined in the Editor and can be changed here as long as the recipe is not released.

Input interlocking

Defines conditions for input interlocking. Click on button ... or an entry to open the formula editor for defining the condition.
If an input interlocking is configured, the phase is only executed in the Runtime when the condition for the input interlocking is fulfilled. The formula can consist of one or more command tags and return tags of the phase. Value and status of the variables can be used. The formula returns TRUE or FALSE as result. The condition can be displayed in the Runtime but cannot be changed there.
The waiting period for the input interlocking is configured with the help of property Waiting period input interlocking.

Waiting period input interlocking

Time period in days, hours, minutes and seconds in which the condition defined in property Interlocking condition must return value TRUE. The waiting period begins with the beginning of the check of the input interlocking. If the condition is not fulfilled within the waiting period, the event Waiting period input interlocking exceeded is triggered and the waiting is continued. If no reaction was defined for the event which forces another behavior, it is waited until the condition is fulfilled.

If 0d 00:00:00 is defined as waiting period, the event is not triggered.

  • Minimum value: 0d 00:00:00
  • Maximum value: 9999d 23:59:59
  • Default: 0d 00:00:00

Value is predefined in the Editor and can be changed here as long as the recipe is not released.

Phase done condition

Defines the condition for phase done. Click on button ... or an entry to open the formula editor for defining the condition.
The condition can be displayed in the Runtime but cannot be changed there. The period which is waited for the fulfillment of the condition is defined via property Maximum execution duration.

Maximum execution duration

Period in days, hours, minutes and seconds in which the condition defined in property Phase done condition must return value TRUE. The waiting period begins when writing of the command parameter. If the condition is not fulfilled within the waiting period, the event Maximum execution period exceeded is triggered and the waiting is continued. If no reaction was defined for the event which forces another behavior, it is waited until the condition is fulfilled.

Note: Time keeps running when the recipe/the phase is paused.

If 0d 00:00:00 is defined as waiting period, the event is not triggered.

  • Minimum value: 0d 00:00:00
  • Maximum value: 9999d 23:59:59
  • Default: 0d 00:00:00

Value is predefined in the Editor and can be changed here as long as the recipe is not released.

Makes only sense if property Phase done condition was configured.

Read more about execution duration in chapter Execution duration.

Minimum execution duration

Minimum execution duration of the phase.

  • >0: Period which is at least waited after the writing of the command tag regardless of whether the phase done condition is fulfilled.
  • 0: Execution duration is not checked

Minimum execution duration can exceed Maximum execution duration. Value is predefined in the Editor and can be changed here as long as the recipe is not released.

Changeable in the control recipe if option Changeable in the control recipe was activated in the master recipe.

Read more about execution duration in chapter Execution duration.

Changeable in the control recipe

Active: Property can be changed in the control recipe.

Waiting period following conditions

Period in days, hours, minutes and seconds in which the phase must be deactivated. The waiting period begins when the phase done condition is reached. If the condition is not fulfilled within the waiting period, the event Waiting period following condition exceeded is triggered and the waiting is continued. If no reaction was defined for the event which forces another behavior, it is waited until the condition is fulfilled.

If 0d 00:00:00 is defined as waiting period, the event is not triggered.

  • Minimum value: 0d 00:00:00
  • Maximum value: 9999d 23:59:59
  • Default: 0d 00:00:00

Note: If the following condition exists depends on the recipe structure. Therefore the configuration of a waiting period should not be done in the Editor but in the Runtime. Value is predefined in the Editor and can be changed here as long as the recipe is not released.

For more information see chapters Times and Following conditions.

OK

Applies all changes on all tabs and closes the dialog.

Cancel

Discards all changes on all tabs and closes the dialog.


Parameters

Parameters

For information on configuration of the basic data on these tabs, see the Add and configure phases chapter.

Parameters | Description
List tag | Displays the tag configured in the Editor. Tags can be filtered and sorted according to columns. Click on symbol Edit tag, double click the tag, menu item in the context menu or press Return to open the dialog for editing a tag.
OK | Applies all changes on all tabs and closes the dialog.
Cancel | Discards all changes on all tabs and closes the dialog.

Tool bar

Symbol | Meaning
Edit tag | Opens the dialog for editing the tag.
Display all command tags | Toggles between the display of the changeable tags and all tags.
Display return tag | In addition to the command tags also displays the return tags or hides them.
Column selection | Opens the dialog for selecting the columns which should be displayed.
Column format | Opens the dialog for formating the columns.


Edit tag

Edit tag

To edit a tag in the Runtime:

  1. in dialog Edit phase select tab Tag
  2. highlight the desired tag
  3. open the dialog for editing the tags via a click on symbol Edit tag, the context menu, a double click on the tag or press Return
  4. the dialog for editing is opened

For each data type an own dialog is opened:

  • Numerical
  • Binary
  • String
  • Duration

The properties are normally configured in the Editor and only displayed in the Runtime. Exceptions are values of the data type. They can be adapted if property Changeable in master recipe was activated in the Editor.

Numeric tag

Parameters

Meaning

Parameters

Name of the TAG. Display only.

Description

Free description of the tag. Display only.

Type

Type of the tag: Command or Return. Display only.

Data type

Data type of the tag. Display only.

Changeable in the control recipe

Active: Value of the property can be changed in the control recipe.

Only available if:

  • the tag is of type command
  • it was configured in the Editor that the tag can be changed in the Batch recipe (property: ). Changeable in master recipe).

Minimum

Minimum value for the tag.

Default from the Editor can be changed when property Changeable in master recipe was activated in the Editor.
If the value is changed, it is marked with the symbol on the right side of the value. Changed values can be overwritten with the default from the Editor with the help of the button right next to it. For control strategies, synchronization takes place with the values that were set in the control strategy when linking parameters.

Minimum variable

Allowed minimum value of the variable.

Value

Name of the tag.

Default from the Editor can be changed when property Changeable in master recipe was activated in the Editor.
If the value is changed, it is marked with the symbol on the right side of the value. Changed values can be overwritten with the default from the Editor with the help of the button right next to it. For control strategies, synchronization takes place with the values that were set in the control strategy when linking parameters.

Unit

Unit of the value.

Maximum

Maximum value for the tag. Display only.

Default from the Editor can be changed when property Changeable in master recipe was activated in the Editor.
If the value is changed, it is marked with the symbol on the right side of the value. Changed values can be overwritten with the default from the Editor with the help of the button right next to it. For control strategies, synchronization takes place with the values that were set in the control strategy when linking parameters.

Maximum variable

Allowed minimum value of the variable. Display only.

Variable

Variable which is linked to the tag. Display only.

Data type variable

Data type of the variable. Display only.

Drivers

Driver of the variable. Display only.

Driver name

Description of the driver of the variable. Display only.

Cursor keys

Navigating through the tags.

They are displayed in the order of the list. At this only tags are displayed which are visible with the current filter and grouping.

If changes were done, there is a prompt before you can change to another tag whether the changes should be applied or discarded. If changes should be applied, the input is checked before advancing.

Accept

Applies all changes if the check of the changes was successful. The dialog remains open for further editing.

OK

Applies all changes and closes the dialog if the check of the changes was successful.

Cancel

Discards all changes which have not been taken over yet and closes the dialog.

Binary tag

Parameters

Meaning

Parameters

Name of the TAG. Display only.

Description

Free description of the tag. Display only.

Type

Type of the tag: Command or Return. Display only.

Data type

Data type of the tag. Display only.

Changeable in the control recipe

Active: Value of the property can be changed in the control recipe.

Only available if:

  • the tag is of type command
  • it was configured in the Editor that the tag can be changed in the Batch recipe (property: ). Changeable in master recipe).

Off

Status: Off.

Default from the Editor can be changed when property Changeable in master recipe was activated in the Editor.
If the value is changed, it is marked with the symbol on the right side of the value. Changed values can be overwritten with the default from the Editor with the help of the button right next to it. For control strategies, synchronization takes place with the values that were set in the control strategy when linking parameters.

On

Status: On.

Toggle

Toggles between the states.

Variable

Variable which is linked to the tag. Display only.

Data type variable

Data type of the variable. Display only.

Drivers

Driver of the variable. Display only.

Driver name

Description of the driver of the variable. Display only.

Cursor keys

Navigating through the tags.

They are displayed in the order of the list. At this only tags are displayed which are visible with the current filter and grouping.

If changes were done, there is a prompt before you can change to another tag whether the changes should be applied or discarded. If changes should be applied, the input is checked before advancing.

Accept

Applies all changes if the check of the changes was successful. The dialog remains open for further editing.

OK

Applies all changes and closes the dialog if the check of the changes was successful.

Cancel

Discards all changes which have not been taken over yet and closes the dialog.

String tag

Parameters

Meaning

Parameters

Name of the TAG. Display only.

Description

Free description of the tag. Display only.

Type

Type of the tag: Command or Return. Display only.

Data type

Data type of the tag. Display only.

Changeable in the control recipe

Active: Value of the property can be changed in the control recipe.

Only available if:

  • the tag is of type command
  • it was configured in the Editor that the tag can be changed in the Batch recipe (property: ). Changeable in master recipe).

String

Alphanumeric character string.

Default from the Editor can be changed when property Changeable in master recipe was activated in the Editor.
If the value is changed, it is marked with the symbol on the right side of the value. Changed values can be overwritten with the default from the Editor with the help of the button right next to it. For control strategies, synchronization takes place with the values that were set in the control strategy when linking parameters.

Possible length is limited by the String length engineered in the variable.

String length

Defines possible length of the string. Display only.

Variable

Variable which is linked to the tag. Display only.

Data type variable

Data type of the variable. Display only.

Drivers

Driver of the variable. Display only.

Driver name

Description of the driver of the variable. Display only.

Cursor keys

Navigating through the tags.

They are displayed in the order of the list. At this only tags are displayed which are visible with the current filter and grouping.

If changes were done, there is a prompt before you can change to another tag whether the changes should be applied or discarded. If changes should be applied, the input is checked before advancing.

Accept

Applies all changes if the check of the changes was successful. The dialog remains open for further editing.

OK

Applies all changes and closes the dialog if the check of the changes was successful.

Cancel

Discards all changes which have not been taken over yet and closes the dialog.

Duration

Parameters

Meaning

Parameters

Name of the TAG. Display only.

Description

Free description of the tag. Display only.

Type

Type of the tag: Command or Return. Display only.

Data type

Data type of the tag. Display only.

Changeable in the control recipe

Active: Value of the property can be changed in the control recipe.

Only available if:

  • the tag is of type command
  • it was configured in the Editor that the tag can be changed in the Batch recipe (property: ). Changeable in master recipe).

Minimum

Minimum value for the tag in format:
d hh:mm:ss

Default from the Editor can be changed when property Changeable in master recipe was activated in the Editor.
If the value is changed, it is marked with the symbol on the right side of the value. Changed values can be overwritten with the default from the Editor with the help of the button right next to it. For control strategies, synchronization takes place with the values that were set in the control strategy when linking parameters.

Minimum variable

Allowed minimum value of the variable.

Duration

Value of the parameter in the format:
T hh:mm:ss.

Default from the Editor can be changed when property Changeable in master recipe was activated in the Editor.
If the value is changed, it is marked with the symbol on the right side of the value. Changed values can be overwritten with the default from the Editor with the help of the button right next to it. For control strategies, synchronization takes place with the values that were set in the control strategy when linking parameters.

Unit

Unit of the value.

Maximum

Maximum value for the tag in format:
d hh:mm:ss.

Default from the Editor can be changed when property Changeable in master recipe was activated in the Editor.
If the value is changed, it is marked with the symbol on the right side of the value. Changed values can be overwritten with the default from the Editor with the help of the button right next to it. For control strategies, synchronization takes place with the values that were set in the control strategy when linking parameters.

Maximum variable

Allowed minimum value of the variable. Display only.

Variable

Variable which is linked to the tag. Display only.

Data type variable

Data type of the variable. Display only.

Drivers

Driver of the variable. Display only.

Driver name

Description of the driver of the variable. Display only.

Cursor keys

Navigating through the tags.

They are displayed in the order of the list. At this only tags are displayed which are visible with the current filter and grouping.

If changes were done, there is a prompt before you can change to another tag whether the changes should be applied or discarded. If changes should be applied, the input is checked before advancing.

Accept

Applies all changes if the check of the changes was successful. The dialog remains open for further editing.

OK

Applies all changes and closes the dialog if the check of the changes was successful.

Cancel

Discards all changes which have not been taken over yet and closes the dialog.


Column selection

Column selection

Button | Function
Available columns | List of columns that can be displayed in the table.
Selected columns | Columns that are displayed in the table.
Add | Moves the selected column from the available ones to the selected items. After you confirm the dialog with OK, they are shown in the detail view.
Add all | Moves all available columns to the selected columns.
Remove | Removes the marked columns from the selected items and shows them in the list of available columns. After you confirm the dialog with OK, they are removed from the detail view.
Remove all | All columns are removed from the list of the selected columns.
Up | Moves the selected entry upward. This function is only available for unique entries, multiple selection is not possible.
Down | Moves the selected entry downward. This function is only available for unique entries, multiple selection is not possible.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Column Format

Column Format

Parameters

Description

Available columns

List of the available columns via Column selection. The column selected here is configured using the settings in the Parameters section.

Parameters

Settings for selected column.

Labeling

Name for column title. The column title is online language switchable. For this you must enter the @ character in front of the name.

Width

Width of the column in characters.
Calculation: Number time average character width of the selected font.

Alignment

Alignment.

Possible settings:

  • Left: Text is justified on the left edge of the column.
  • Centered: Text is displayed centered in the column.
  • Right: Text is justified on the right edge of the column.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog.


Insert operation

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> PFC recipe -> Insert operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To insert an operation:

  1. in the tool bar select the symbol for Insert operation
  2. move the mouse to the desired position
  3. place the operation
  4. the dialog for selecting a template for the operation is opened
  5. select the desired operation
  6. The operation is inserted


Lines

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> PFC recipe -> Lines

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Lines connect elements via free connection points. To connect connection points with each other:

  1. Activate a point with the help of the mouse:
    The connection point turns green. Red means that the connection point is already taken.

  2. Drag a line to another connection point:
    A yellow arrow shows the direction of the line.. Green fields can be crossed. Red fields may not be crossed by the line.

  3. As soon as the yellow tip of the line touches the next connection point, the line is created.

Using trend curves

Lines:

  • are dragged with the mouse
  • can be moved (press and hold key Ctrl)
    At this all existing connections are separated and it is tried to reconnect the line if there are objects with connections points in the right direction at the target.
    If several lines are highlighted, the line, in whose cell the mouse cursor is, is moved.
  • can be deleted by highlighting them an pressing Del
  • are deleted when re-dragging them from beginning to end
  • have a tool tip displaying its ID.

If a line reaches a connection point of an object, the connection point becomes active. If a connection is possible, it turns green otherwise red. Connections connecting two connections points of the same type - two inputs, two outputs, etc. - are not allowed. The line can be added in any case. Not allowed connections are displayed in red and trigger a corresponding error message at testing.

The connection points of the elements are always displayed in the edit mode even if the connection point in question is connected. In status "Release" no connection points are displayed.

Properties connection point:

  • connected: highlighted red; connection is separated when the line is dragged and a new connection point can be chosen
  • open: highlighted green; at dragging a new line is created


Transition

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> PFC recipe -> Transition

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Transitions are used after phases in order to ensure a defined transition from one phase to another. Transitions display their internal status during the process and inform via a tool tip about status and process duration.

For details about transitions see section Engineering in the Editor in chapter Transitions.


Sequence selections

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> PFC recipe -> Sequence selections

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Recipes can branch and run in simultaneous sequences.

Branches and simultaneous sequences consist of:

  • single/double horizontal lines
  • Connection pieces (consisting of connection line and connection point)

Create a sequence selection

To create a sequence selection:

  1. select the symbol Insert begin sequence selection
  2. put the sequence selection on the desired location
  3. connect the input connection point with a output connection point of the preceding object
  4. connect both output connection points with the desired following objects
  5. close a sequence selection with object Insert end sequence selection

Insert simultaneous sequence

To create a simultaneous sequence:

  1. select the symbol Insert begin simultaneous sequence
  2. put the sequence selection on the desired location
  3. connect the input connection point with a output connection point of the preceding object
  4. connect both output connection points with the desired following objects
  5. close a simultaneous sequence with object Insert end simultaneous sequence

Modify and move

Branches and simultaneous sequences can be moved and changed in size.

Move

To move an object:

  1. click on the object
  2. keep the mouse button pressed
  3. move the object to the desired position

Change size

In this way object Begin/end sequence selection/simultaneous sequence can be extended and shortened. To change their size:

  1. move the mouse cursor over the object until it turns into a double arrow
  2. press and hold the left mouse button and move the mouse in the desired direction:
    • away from the object to extend it
    • into the object to shorten it
  3. at extending a new connection piece is added;
    • all fields which are concerned by the extension are marked green
    • to add several need connection pieces the process must be repeated
  4. at shortening all corresponding connection pieces are deleted


Sequence selection

Sequence selection

A branch offers the possibility to execute one of several possible ways. For this it is necessary that the first element at the beginning of a branch is a transition. This means that Begin sequence selection can only be followed by a transitions.

Procedure:

  • The path is chosen for which the transition is TRUE first.
  • Then it is waited until all transitions have a value.
  • If several transitions are TRUE at the same time, always the leftmost path for which the transition is TRUE is selected.

For begin and end the following is true: If there is a phase in front of the element and a transition behind, the phase remains active until the transition was completed.

In a sequence selection the objects are processed sequentially. Each sequence selection processes its objects independent of other branches.


Simultaneous sequences

Simultaneous sequences

At the parallel branch an execution path parts into several execution paths which are executed in parallel during the process. For the activation of the different elements within a parallel branch you cannot define a certain order.

In the process the respective intermediate area of the end parallel branch is also colored. The color matches the coloring of the phase.

Phase completed is displayed as active as soon as the first previous element has been completed. This means that a phase is Finished or a transition is passed. Transitions are marked as completed as soon as they are passed. Phases wait at Phase completed until the end parallel branch is completed. Completed means that either the following phase is active or the following transition is inactive.

During the execution the status is color-coded.


Split up and combine sequence selection

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> PFC recipe -> Sequence selections -> Split up and combine sequence selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Split up and combine sequence selection

For simultaneous sequences the sequence selection splits up a Begin simultaneous sequence and combines the single sequence selections at End simultaneous sequence. The paths of the parallel objects are independent branches. Only at End simultaneous sequence all branches are synchronized.

The possible branches are defined by the engineering. If the separate branches are allocated or released, arises in the Runtime. A branch is active as long as an object on it is active.

The object types Begin sequence selection, End sequence selection and Jump target do not allocate and release branches as these objects are processed in the same branch. Combining branches is not allowed.

End simultaneous sequences

An End simultaneous sequence combines the branches of the connected paths. The object after End simultaneous sequence is activated when all paths reaches End simultaneous sequence with their process.

The left path is ready. Therefore End simultaneous sequence is already active. The transition after End simultaneous sequence is not yet active as the right branch is not yet completed.

When the right branch is also completed:

The transition after End simultaneous sequence is activated. All objects which were active before are still active. Instead of the transition there could also be another End simultaneous sequence.

A little more complex alternative:

The areas highlighted in green are a branch.

Cascaded End simultaneous sequence:

The areas highlighted in green are a branch.


Jump target

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> PFC recipe -> Jump target

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Adds a jump target.

Jump targets make it possible to

  • jump between branches
  • jump out of branches
  • engineer loops

Jump targets consist of tree inputs and one output. At this the output is always at the bottom and the inputs are located at the top and the sides. You can connect any input connection points. A path which ends in a jump target must have started with a begin sequence selection. Otherwise the end is not reached. Jump targets are not allowed for simultaneous sequences.

During the editing all connection points are visible. In the checking mode only the connection points which are connected are displayed.


End element

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> PFC recipe -> End element

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Last element in the process. It is automatically created in the editor when a recipe is created and it cannot be deleted.


Matrix recipe

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> Matrix recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If you selected matrix recipe in dialog Configuration master recipe and exited the dialog with OK, the newly created recipe opens on a new tab in the matrix editor.


Matrix editor

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> Matrix recipe -> Matrix editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the matrix editor you can create your recipes and operations in a matrix.

Technical details

  • Matrix:
    • Columns contain phases and operations:
      Phases are inserted by clicking on the symbol above the diagonal
      Phases are inserted by clicking on the symbol below the diagonal
    • Lines contain steps with active/inactive phases.
  • Insert column/row
    Clicking on the plus sign inserts a new line or column with a phase or operation into the matrix.
  • Delete column/row Press Del to delete the highlighted line or column.
  • Move lines/columns: Lines and columns can be moved via drag & drop with the help of the mouse. Individual labels of steps remain; the step number is adapted automatically.
  • Border cells:
    • Double click on phase: opens the dialog for configuring the phase.
    • Double click on step: opens the dialog for labeling the step.
  • Selection of lines/columns:
    • left mouse click in border cell: selects a line/column.
    • Ctrl+mouse click in border cell: selects additional lines/columns.
  • Cells:
    • left mouse click: selects empty cell.
    • Shift + click: activates/deactivates phase.
    • Ctrl+click: selects several cells.
    • Double click on cell: opens the dialog for configuring the phase.
  • Scroll bar: Is displayed if the document is larger than the frame.
  • Scrolling via mouse wheel: up and down or if you press and hold Shift left and right.


Tool bars matrix recipe

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> Matrix recipe -> Tool bars matrix recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tool bars matrix recipe: Edit mode

New master recipe...

Opens the dialog for creating a new master recipe.

Save master recipe

Saves the master recipe which is open for editing.

If another recipe is opened, the current recipe is saved automatically.

Graphical design

Opens the dialog to configure background colors, grid, and display of element ID.

Delete

Deletes the selected elements from the diagram.

Multiple selection via Ctrl+mouse click.

Check recipe for errors

Checks recipe for errors and displays found errors in an information window. For several errors the first errors are displayed.

The error message contains the error number, the ID of the element, its location and a message in plain text.

Edit element

Opens the corresponding dialog for editing the selected element.

Activate selected phase

Activates the selected phase.

Deactivate selected phase

Deactivates the selected phase.

Move selected column to the left or selected step up

Moves the selected column to the left by one position or moves selected step up by one position.

Move selected column to the right or selected step down

Moves the selected column to the right by one position or moves selected step down by one position.

Switch recipe to test mode

Switches recipe to the test mode. For this the recipe must be without errors.

Release recipe

Releases the recipe. With this a control recipe can be created.

Tool bars matrix recipe: Test mode

Parameters | Description
Start recipe | Starts the recipe process.
Pause recipe | Pauses the recipe.
Resume recipe | Resumes paused recipe.
Recipe holding | Holds recipe.
Restart recipe | Restarts held recipe.
Stop recipe | Stops the recipe.
Recipe aborting | Aborts the recipe process.
Pause phase | Pauses the phase.
Resume phase | Resumes the process of a paused phase.
Hold phase | Holds phase.
Restart phase | Restarts held phase.
Escape phase | Starts process to exit from the phase.
Check recipe for errors | Starts recipe validation.
Edit element | Opens the corresponding dialog for editing the selected element.
Graphical design | Opens the dialog to configure background colors, grid, and display of element ID.
Switch to automatic mode | Switches process to automatic mode.
Switch to semi-automatic mode | Switches process to semi-automatic mode.
Switch to manual mode | Switches process to manual mode.
Continue recipe only on selected active elements | Continues a recipe at the selected position.
Continue recipe on all execution positions | Continues a recipe on every available position.
Skip active condition | Skips an active condition. Only possible in the manual mode.
Edit mode | Switches from test mode to edit mode.
Release recipe | Releases the recipe. With this a control recipe can be created.

Matrix recipe tool bar: approved

Parameters

Description

Check recipe for errors

Checks recipe for errors and displays found errors in an information window. For several errors the first errors are displayed.

The error message contains the error number, the ID of the element, its location and a message in plain text.

Edit element

Opens the corresponding dialog for editing the selected element.

Graphical design

Opens the dialog to configure background colors, grid, and display of element ID.

Duplicate recipe

Only active if precisely one recipe was selected.
Creates a copy of the selected recipe. At the creation of the copy, the version of the recipe saved on the hard disk is used. If the recipe is just edited in another computer and the changes have not yet been saved, the changes are not applied. The dialog for the input of a unique name and the description is opened.

Create control recipe

Creates a control recipe on the basis of the approved master recipe.

info Information

The functions of the individual symbols can also be configured using buttons and thus be made touch-operable. Tool bars can therefore also be hidden.


Name steps

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> Matrix recipe -> Name steps

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Steps in the matrix editor can be named individually. Double click on the cell to open the dialog for entering an individual name.

The name can have up to 100 characters and is language switchable is preceded by a @.


Add and configure phase

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> Matrix recipe -> Add and configure phase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To add a phase:

  1. Click on the plus sign above the diagonal in the last column of the matrix
  2. the dialog for selecting a phase is opened
  3. select the desired phase

To configure a phase:

  1. double click the matrix filed with the desired phase
  2. The dialog for configuration is opened

Configuration

Parameters | Description
Phase active in this step | Active: Phase is active in this step
Name | Name of the phase. Only display.
Description | Comment about the phase. Only display.
Unit | Unit on which the phase is carried out. Only display.
Control strategy | Selection of a control strategy from a drop-down list. Only available if control strategies have been configured for this phase. Default: no Control strategy linked
Description of control strategies | Description of the selected control strategy. Display of the description entered in the Editor only.
General | Tab for configuration of general properties.
Parameters | Tab for configuration of parameters.
OK | Applies all changes on all tabs and closes the dialog.
Cancel | Discards all changes on all tabs and closes the dialog.

Configuration of the tabs see section PFC editor/chapter:

  • General: Display and configuration of the settings for the phase
  • Tag: Configuration of the tags

Rules for editing a phase

A phase can be edited:

  • In a master recipe in edit mode: If the user has sufficient rights.
  • In a master recipe in test mode: If the user has sufficient rights and the phase is not active.
  • In a control recipe with prepared status: If the user has sufficient rights and the Changeable in the control recipe option has been activated.
  • In a control recipe with running status: If the user has sufficient rights, the Changeable in the control recipe option has been activated and the phase is not active.

The phase can no longer be edited in pre-configured control recipes and in approved master recipes.


Insert operation

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> Matrix recipe -> Insert operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To insert an operation:

  1. Click on the plus sign below the diagonal in the last column of the matrix
  2. the dialog for selecting a template for operation is opened
  3. select the desired templates
  4. A new operation is inserted


Master recipe - test mode

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> Master recipe - test mode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The test mode is used to test master recipes without releasing it and creating control recipes. In addition in the test mode changes in the Editor can be applied directly via reloading the Runtime.
Exception: During the execution of a recipe, the reloading of a recipe is delayed. Not until the recipe is finished, stopped or aborted, the reloading process is executed.

In test mode you cannot can the principle recipe process. You can only change values of the command tags. Changes are directly saved in the master recipe. It is not necessary to save explicitly.

Parameters

Description

Start recipe

Starts the recipe process.

Pause recipe

Pauses the recipe.

Resume recipe

Resumes paused recipe.

Hold recipe

Holds recipe.

Restart recipe

Restarts held recipe.

Stop recipe

Stops the recipe.

Abort recipe

Aborts the recipe process.

Pause phase

Pauses the phase.

Resume phase

Resumes the process of a paused phase.

Hold phase

Holds phase.

Restart phase

Restarts held phase.

Check recipe for errors

Checks recipe for errors and displays found errors in an information window. For several errors the first errors are displayed.

The error message contains the error number, the ID of the element, its location and a message in plain text.

Edit element

Opens the corresponding dialog for editing the selected element.

Graphical design

Opens the dialog to configure background colors, grid, and display of element ID.

Switch to automatic mode

Switches process to automatic mode.

Switch to semi-automatic mode

Switches process to semi-automatic mode.

Switch to manual mode

Switches process to manual mode.

Continue recipe only on selected active elements

Continues a recipe at the selected position.

Continue recipe on all execution positions

Continues a recipe on every available position.

Skip active condition

Skips an active condition.

Only possible in the manual mode.

Switch recipe to edit mode

Switches from test mode to edit mode.

Release recipe

Releases the recipe. With this a control recipe can be created.


Release master recipe

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> Release master recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can release a master recipe by selecting it and clicking button Release master recipe. Several recipes can also be selected and approved together. Approval must be confirmed by means of a dialog.

As soon as a recipe has been approved, the dialog to allocate the unit can no longer be opened. All information about the unit is displayed in the tooltip. Dialogs for transitions and phases can continue to be opened as write-protected.

info Information

Only master recipes without errors can be released. A released master recipe can no longer be edited.

For each recipe you can create a copy of the released master recipe by clicking on button Duplicate recipe. This copy can then be edited.

Recipes can only be approved if all operations contained therein have also been approved.


Highlight recipe as outdated

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> Highlight recipe as outdated

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Recipes that are no longer valid but have not been deleted should be marked as outdated. If a recipe is set to this status, it can no longer be edited or approved. No control recipe can be created on the basis of this recipe either. The recipe can however be duplicated and thus be used as the basis for new master recipes.

Only recipes that have the status approved can be marked as outdated. The following applies for attendant control recipes:

  • Control recipes that are currently being executed continue to be executed
  • Control recipes with the prepared status can no longer be executed


Versioning for master recipes

Manual -> Batch Control -> Configure and control in the Runtime -> Master recipes -> Versioning for master recipes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Master recipes can also be versioned. In doing so, a copy of an approved or obsolete report is created. This copy is in edit mode and contains a unique version number. The new recipe can be edited, but not renamed. Individual versions, including the source recipe itself, can be deleted.

Creating a version

To use versioning in Runtime:

  1. In the Editor, navigate to the General/Versioning properties group in the Batch Control node.
  2. Activate the Versioning active property.
  3. Versioning is switched on and used in Runtime.

To create a new version of a recipe in Runtime:

  1. Select the desired master recipe.
    Note: The recipe must be approved or obsolete.
  2. Select, in the context menu or on the tool bar, Create new version or click on the corresponding button in the screen.
  3. A new recipe is created.

Rules for versioning

The following applies to versioning:

  • A new version of a recipe contains the same name as the source recipe.
  • New versions of a recipe cannot be renamed. Not even if the version is in editing mode and it is the only remaining version.
  • The description can be changed for each version.
  • Each version contains a unique version number that is issued on a serial basis. Version numbers of deleted recipes remain blocked and are not reissued.
  • The version number of the new recipe and the version number of the source recipe are displayed in their own columns in the list of master recipes.
  • Version numbers are also displayed in the title bar of the recipe editor and in the tab of the recipe as well as in the list of the control recipes and in tooltips.

Only approve one version

It is possible to only allow one version of each master recipe to be approved. To do this, activate the Only approve one version property in the Editor. Only one version of each master recipe can be approved in Runtime. If a different version is approved, the one that was approved before must first be deleted or marked as obsolete.


Validate recipe

Manual -> Batch Control -> Configure and control in the Runtime -> Validate recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Recipes can be checked for error during the engineering. To validate a recipe, click on the corresponding symbol in the tool bar of the recipe editor in Runtime (green tick - Check recipe for errors). With this the recipe is checked for functionality according to internal rules. The following is especially checked:

  • Syntax (all lines connected, processable from begin to end, etc.)
  • Variables
  • Data types
  • Control Strategy: Linking of control strategies and value of the linked control strategy parameter to limits of the variable

The result of the check is displayed as pop-up in plain text. Found errors are also saved in the log file which can be analyzed with the Diagnosis Viewer.

Rules which must be adhered to during the engineering can be found in chapter Engineering rules for recipes.

attention Attention

Operations that are not connected at the time of validation are ignored during validation. Their content and processes are not checked.


Operations

Manual -> Batch Control -> Configure and control in the Runtime -> Operations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Operations form a substructure that can be embedded in recipes. This can provide a better overview in complex recipes. Operations are created in a similar manner to matrix recipes or PFC recipes. The operations are created on the basis of templates and as an instance in existing matrix recipes or PFC recipes.

Creating an operation

To create a new operation:

  1. In the Recipe Editor switch the list of operations to visible (activate checkbox)
  2. Select, in the tool bar or context menu of the list, the New operation command
  3. The dialog for configuring an operation is opened

Parameters

Description

Matrix recipe

Activate this radio button if you would like to create an operation on the basis of a matrix recipe.

Note: Only possible if the corresponding license is available.

PFC recipe

Activate this radio button if you would like to create an operation on the basis of a PFC recipe.

Note: Only possible if the corresponding license is available.

Name

Unique name for the operation. The name must not contain a dot (.), a question mark (?), a @ or an asterisk (*).

Maximum length: 256 characters.

Note: When you copy an operation the existing name is complemented with the prefix "Copy of". If the maximum length is exceeded by this, the name is shortened to the allowed length starting from the last character.

The uniqueness is checked in the entire network. Therefore it can happen that you cannot take over the name as another user on another computer in the zenon network already has used the same name and you do not see the recipe in the list of the operations yet.

The recipe names can be changed later but only as long as the recipe has the status editable.

Description

Optional description for the operation which should be created.

The description can be changed later but only as long as the operation has the status editable. To change the description select the symbol Rename operation.

OK

Applies all settings and created a new operation.

Cancel

Closes the dialog without creating an operation.

Configuration in the Recipe Editor is similar to the creation and configuration of PFC recipes and Matrix recipes.

changes to operations are only visible for the user in the operation instance if the operation instance has been saved.

Opening operations

Existing operations can be opened by:

  • Double-clicking on an operation in the list of the operations
  • The Open in Recipe Editor command in the context menu of an operation
  • Clicking on the Open symbol in the tool bar

Using operations

Operations can be inserted in recipes in the matrix editor or in the PFC editor and used as part of the recipe there.

You insert operations:

  • In the PFC editor using the Insert operation symbol
  • In the matrix recipe using the Add operation symbol

Phases and commands can be executed within operations. The position of the object in the recipe is also given in the CEL when a command is executed.

When inserting an operation into a recipe, the currently-saved version is always inserted. If the operation is open for editing, all unsaved changes are thus also not part of the inserted instance.

Saving operations

Operations are, as instances, always part of the master recipe in which they are integrated. If an operation is saved, the attendant master recipe is also saved automatically.

Tool tip

Operations have a tooltip. The following are displayed as soon as they have been executed once:

  • Execution status:
    Contains current status and original status (status from which the operation comes). The original status is evident from the visual coloring and does not always correspond to the actual last status.
  • Execution counter
  • Error:
    Shows the number of objects that currently have an error status and the number of objects that have had an error status. Each object is always only used for one error.
  • Exit from phase:
    Number of objects that are being exited from or have been exited from
  • Overall duration with time when it was deactivated and deactivated
  • Information about the status of the internal objects: Number of objects with the respective status (except idle)


Toolbar and context menu operations

Manual -> Batch Control -> Configure and control in the Runtime -> Operations -> Toolbar and context menu operations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tool bar list

Parameters | Description
New operation | Creates a new operation.
Open operation in Editor | Opens the selected operation in the recipe editor.
Rename the operation | Opens the dialog to name a recipe.
Duplicate operation | Duplicates the selected operation.
Delete operation | Deletes the selected operation.
Release operation | Checks the selected operation and approves it if no errors were found.
Column selection | Opens the dialog to select a column.
Column format | Opens the dialog to format a column.

Context menu

Parameters | Description
New operation | Creates a new operation.
Rename | Opens the dialog to name a recipe.
Duplicate | Duplicates the selected operation.
Delete | Deletes the selected operation.
Open in Editor | Opens the selected operation in the recipe editor.
Release | Checks the selected operation and approves it if no errors were found.

Tool bar PFC editor: Edit mode

Parameters

Description

New operation...

Opens the dialog for creating a new operation.

Save operation

Saves the master recipe which is open for editing.

Graphical design

Opens the dialog to configure background colors, grid, and display of element ID.

Delete

Deletes the selected elements from the diagram.

Multiple selection via Ctrl+mouse click.

Check operation for errors

Checks recipe for errors and displays found errors in an information window. For several errors the first errors are displayed.

The error message contains the error number, the ID of the element, its location and a message in plain text.

Edit element

Opens the corresponding dialog for editing the selected element.

Phase

Opens dialog for selecting a phase and replaces the existing phase by the newly selected phase. Several phases can be selected and replaced together

Shortcut: Shift+double click

Edit mode

Toggles between insert mode and edit mode.

Insert phase

Adds a phase.

Insert transition

Adds a transition.

Insert begin simultaneous sequence

Adds a begin simultaneous sequence.

Insert end simultaneous sequence

Adds an end simultaneous sequence.

Insert begin sequence selection

Adds a begin sequence selection.

Insert end sequence selection

Adds an end sequence selection.

Insert unit allocation

Adds a unit allocation.

Insert jump target

Adds a jump target.

Release operation

Releases the operation. With this a control recipe can be created.

Note: Insertions remain active until you change to the edit mode using the Edit mode symbol, the Esc key or you change to another insert option via a symbol for adding a new element.

PFC recipe tool bar: approved

Parameters

Description

Check operation template for errors

Checks recipe for errors and displays found errors in an information window. For several errors the first errors are displayed.

The error message contains the error number, the ID of the element, its location and a message in plain text.

Edit element

Opens the corresponding dialog for editing the selected element.

The dialog is opened in write-protected mode, because it is no longer possible to edit approved recipes.

Graphical design

Opens the dialog to configure background colors, grid, and display of element ID.

Duplicate operation

Only active if precisely one recipe was selected.
Creates a copy of the selected recipe. At the creation of the copy, the version of the recipe saved on the hard disk is used. If the recipe is just edited in another computer and the changes have not yet been saved, the changes are not applied. The dialog for the input of a unique name and the description is opened.


Selection of the template for an operation

Manual -> Batch Control -> Configure and control in the Runtime -> Operations -> Selection of the template for an operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Operations can be inserted into recipes as an instance. When inserting an operation into a matrix recipe or a PFC recipe, the dialog to select a template for an operation is opened. This contains all previously-configured operations:

Parameters

Description

List workspace

In the standard dialog to display the projects present in the workspace. No function in Batch Control, because operations can always be selected from the respective active project.

Hint: Drag this area down to the minimum size. It is then only displayed as minimized* in the future.

Operation list

Contains all operations that have been created. Any desired operations (matrix or PFC) can be selected for both editors (matrix and PFC).

Entries can:

  • be sorted by clicking on the column title; another click inverts the sorting
  • be filtered into filter rows by alphanumeric entries (wildcards can be used)

Cursor keys

Move the selection:

  • Up
  • Down

Status Line

Display:

  • Number of entries
  • Number of filtered entries displayed
  • Number of selected entries

No selection

Cancels existing selection for existing operation and closes the dialog.

OK

Accepts selection, closes dialog and inserts operation.

Cancel

Discards selection and closes dialog without selecting or amending a template.

*workspace minimized:


Status operation

Manual -> Batch Control -> Configure and control in the Runtime -> Operations -> Status operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The status shown for an operation always represents the status of the object with the highest priority in the operation.

The following applies to the colored identification:

  • Non-transient status: the whole operation is colored
  • Transient status: Original status and target status are displayed
  • Holding as original status: Running (green) is always displayed

Priority

Priority of the objects in an operation, starting with the highest priority:

  1. ABORTING
  2. ABORTED
  3. STOPPING
  4. STOPPED
  5. RESTARTING
  6. HOLDING
  7. HELD
  8. PAUSING
  9. PAUSED
  10. RUNNING
  11. COMPLETE
  12. IDLE


Symbol for execution

Manual -> Batch Control -> Configure and control in the Runtime -> Operations -> Symbol for execution

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The symbols correspond to the symbols generally used the REE. Operations are symbolized in the REE by triangles in the left and right corner.

Symbol

Description

Tool tip

No symbol

Idle:

No object is active in the operation.

Idle

In execution:

A symbol is always displayed whilst an operation is running.

If objects are still running in the operation, the progress symbol is shown.

Execution of the internal objects.

Phase finished:

If objects are already active after the operation, the symbol for following condition is displayed.

Waiting for Following conditions.

If an object has a different status within the operation, then a symbol is also displayed on the right.

There is a different status if an object has an empty status within the operation that does not correspond to the status of the operation and is not idle or complete.


Control recipe

Manual -> Batch Control -> Configure and control in the Runtime -> Control recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Control recipes control the progress of a recipe in the Runtime.


Create control recipe

Manual -> Batch Control -> Configure and control in the Runtime -> Control recipe -> Create control recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can create control recipes only based on released master recipes. Select the released master recipe in the list of the master recipes, which should serve as basis for your control recipe and click on button New control recipe....

Parameters

Description

Matrix recipe

Active: A matrix control recipe is created.

Only display.

PFC recipe

Active: A PFC control recipe is created.

Only display.

Job ID

The job ID provided by the job variables.

Name

Unique name for the control recipe. The name must not contain a dot (.), a question mark (?), a @ or an asterisk (*).

The uniqueness is checked in the entire network. Therefore it can happen that a name is not accepted as another user already used the same name on another computer in the zenon network at the same time.

You can change the name afterwards as long as the recipe has status Prepared.

Description

Optional description of the recipe.

OK

Applies configuration and closes the dialog.

Cancel

Discards entries and closes the dialog.

If the control recipe was created using the symbol in the toolbar, then it is automatically opened in a new tab in the recipe editor provided this has been configured in the screen. If the control recipe has been created using the context menu, it is not opened in the recipe editor.

The newly created recipe is also displayed in the list of control recipes even if it does not match the set filter criteria.


Tool bar and context menu for control recipe list view

Manual -> Batch Control -> Configure and control in the Runtime -> Control recipe -> Tool bar and context menu for control recipe list view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tool bar

Symbol | Description
Open control recipe in Editor | Opens the selected recipe in the recipe editor.
Rename control recipe | Opens dialog to rename the selected recipe.
Duplicate control recipe | Creates a copy of the selected recipe and opens the dialog to rename the duplicate.
Delete control recipe | Deletes selected recipes.
Start control recipe | Starts selected control recipe.
Column selection | Opens the dialog for selecting the columns which should be displayed.
Column format | Opens the dialog for configuring the column formats.

Context menu

Command | Description
Open in Recipe Editor | Opens the selected recipe in the Editor.
Rename | Opens dialog to rename the selected recipe.
Duplicate | Creates a copy of the selected recipe and opens the dialog to rename the duplicate.
Delete | Deletes selected recipes.
Starting | Starts selected control recipe.


Control recipe edit mode tool bar

Manual -> Batch Control -> Configure and control in the Runtime -> Control recipe -> Control recipe edit mode tool bar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters

Type

Description

Start recipe

Command

Starts the recipe process.

Pause recipe

Command

Pauses the recipe.

Resume recipe

Command

Resumes paused recipe.

Hold recipe

Command

Holds recipe.

Restart recipe

Command

Restarts held recipe.

Stop recipe

Command

Stops the recipe.

Abort recipe

Command

Aborts the recipe process.

Pause phase

Command

Pauses the phase.

Resume phase

Command

Resumes the process of a paused phase.

Hold phase

Command

Holds phase.

Restart phase

Command

Restarts held phase.

Escape phase

Command

Starts process to exit from the phase.

Check recipe for errors.

Action

Starts recipe validation.

Edit element

Action

Opens the corresponding dialog for editing the selected element.

Graphical design

Action

Opens the dialog to configure background colors, grid, and display of element ID.

Switch to automatic mode

Command

Switches process to automatic mode.

Switch to semi-automatic mode

Command

Switches process to semi-automatic mode.

Switch to manual mode

Command

Switches process to manual mode.

Continue recipe only on selected active elements

Command

Continues a recipe at the selected position.

Continue recipe on all execution positions

Command

Continues a recipe on every available position.

Skip active condition

Command

Skips an active condition.

Only possible in the manual mode.

Duplicate Recipe

Action

Only active if precisely one recipe was selected.
Creates a copy of the selected recipe. At the creation of the copy, the version of the recipe saved on the hard disk is used. If the recipe is just edited in another computer and the changes have not yet been saved, the changes are not applied. The dialog for the input of a unique name and the description is opened.

The copy of the recipe automatically gets the status Prepared and can therefore be edited and started. The execution status of the duplicate is set to automatic.

When duplicating a recipe, a CEL entry is created.


Execute control recipe

Manual -> Batch Control -> Configure and control in the Runtime -> Control recipe -> Execute control recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Control recipes can be started:

  • after selecting a control recipe in the list of the control recipes:
    • via click on button Start control recipe
    • via click on menu item Start in the context menu
  • via click on symbol Start control recipe in the tool bar if the control recipe is opened

PFC control recipe:

Matrix control recipe:

Change values

If in the master recipe property Changeable in the control recipe was activated, certain values can be adapted in the control recipe as long as the phase i snot active yet. In this case a button for synchronization is displayed next to the value. A click on this button take over the defined value from the master recipe.

No more values can be changed in control recipes that have already been executed.

Meaning of the symbols next to the values:

Symbol | Description
 | Value in the control recipe and in the master recipe match.
 | Value in the control recipe and in the master recipe are different.
 | Click on button to apply the value from the master recipe. It overrides the value in the control recipe. Only active if the values in the control recipe and the master recipe do not match.

Tool tip

A tool tip informs you about the current and historical events of an element.

The following is displayed:

  • Element name
  • General information about status and number of executions.
    Note: The counter becomes active if the phase is reactivated, including if the status is restarting, but the restart condition has not yet been run through.
  • Errors
  • Total duration including times in status Paused.
  • Timing


Synchronization

Manual -> Batch Control -> Configure and control in the Runtime -> Synchronization

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Checking for changes in the Editor

When loading, opening, duplicating or approving a recipe, a check is made to see if the configuration of the unit, phase, etc. was changed in the Editor. If a change is detected, it is taken over in the object to which the function concerned is assigned. Settings that were overwritten in Runtime are retained. When the recipe was changed, it is shown via an asterisk (*).

At reloading the recipe is also checked.

info Information

Only recipes in edit mode or test mode are updated. Recipes in test mode that are currently running are only updated after execution has ended.

If a changed recipe should be release which was not yet saved, a prompt is displayed with the following possibilities:

  • to approve the current recipe
  • to approve the saved recipe
  • cancel the release process

attention Attention

Changes to phases in the Editor are taken over without warning message when the recipe is releases in the Runtime. For all data which are not overwritten in the Runtime, the Editor is the leading system.

Synchronization of phases

Editing of phases and their parameters is possible at the four following levels:

  • in the zenon Editor
  • In the template of the operation
  • in the master recipe
  • in the control recipe

When instancing, the data form the level above is always used. Synchronization and comparison in the editing dialogs also always relates to the previous level.

Origin of data for comparison or synchronization:

Position of phase | Phase that provides comparison data
in the zenon Editor | No data to compare.
in the master recipe | Phase configured in the zenon Editor.
in the control recipe | The phase from the master recipe.
In the template of the operation | Phase configured in the zenon Editor.
In the instance of the operation in the master recipe | The phase from the template of the operation.
In the instance of the operation in the control recipe | The phase from the instance of the operation in the master recipe.

You can find information on the origin of the comparison data in the tooltips of the control elements for synchronization.

Recipes and operations

The following is always the case when synchronizing operations:

  • Master recipes are always synchronized with the editor data
  • Then the instances of operations are synchronized with the data from their templates

Synchronization is carried out if:

  • A recipe is opened,
  • loaded,
  • An operation template is saved and a recipe is opened that has an instance of this template

Values in phases and parameters correspond to the values in the templates as standard and can be overwritten locally.

Changes to control strategies and control strategy activation

The following applies for control strategies during synchronization:

  • When synchronizing recipes, phases with active control strategies are updated with the amended information (name change, new tags added, etc.).
  • If control strategies were activated for a phase in the Editor, the phase in Runtime is set to the status where no control strategy is active. It contains only return parameters.
  • If control strategies are deactivated for a phase in the Editor, the phase contains the complete current configuration of the phase after synchronization. With this switch, all changes that have been made to the phase in the recipe are discarded.


Manage recipes

Manual -> Batch Control -> Configure and control in the Runtime -> Manage recipes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The entire recipe management is done in the Runtime with the help of one or several screens of type Batch Control. Due to suitable filter settings you can achieve already filtered views for master recipes and/or control recipes.

In the screen different control elements (buttons, lists, editors) are available for different tasks. The screen is separated in three main areas which can be used and engineered in part completely independent of each other:

  • Area master recipes: Consists of a list and buttons for managing. The area can be used completely independently.
  • Area control recipe: Consists of a list and buttons for managing. The area can be used only together with the list of the master recipes as a master recipe must be selected first before the appertaining control recipes are displayed in the list.
  • Recipe editors: Depending on the set recipe type the PFC editor or the matrix editor is used. The recipe editor needs either List master recipe or both lists for a recipe to be opened in it.


Manage master recipes

Manual -> Batch Control -> Configure and control in the Runtime -> Manage recipes -> Manage master recipes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

List and list formating

List/action

Description

List master recipes

In this list all master recipes can be displayed. The display can be limited by filters to an individual selection.

The filtering can be preset in the zenon Editor in the screen switch function. Online filtering is also possible. These filters are discarded when the screen is called up again. A permanent definition is only possible in the zenon Editor.

All commands are also possible in the context menu of the list. The commands for list management can be called from the header of the list. The commands for recipe management can be called at editing one or more recipes.

The recipes in the list cannot be edited directly in the list. Renaming, changing the description or changing the recipe status is only possible with the corresponding commands.

Hint for ideal configuration of the list:

The list can be designed diversely concerning content and look:

  • Content: The displayed columns can be selected, the column format (column width, alignment, label) can be changed and you can define filters. These settings can be edited in Editor and Runtime.
  • Look: At the settings of the list in the Editor you can find diverse setting possibilities in areas Representation, Scroll bars and Color. With these properties you can even design the list ready for touch operation.

Actions for list management

Action | Description
Column selection master recipe... | Opens a dialog in order to determine which columns should be displayed. Attention: These changes are discarded when the screen is called up again. A permanent definition is only possible in the zenon Editor.
Format columns master recipe... | Opens a dialog to edit the column settings. Attention: These changes are discarded when the screen is called up again. A permanent definition is only possible in the zenon Editor.

Actions for recipe management

Action

Description

New master recipe...

Creates a new and completely empty master recipe in status Editable. The dialog for entering a unique name and a free description is displayed. The uniqueness of a name is also checked in the zenon network.
Depending on the licensing, there may also be the possibility to select the recipe type: Matrix recipe or PFC recipe. If only one of these recipe types is licensed, the licensed recipe type is fixedly set. The selected recipe type cannot be changed afterwards.

When creating a master recipe, a CEL entry is created.

Duplicate master recipe

Only active if precisely one recipe was selected.
Creates a copy of the selected recipe. At the creation of the copy, the version of the recipe saved on the hard disk is used. If the recipe is just edited in another computer and the changes have not yet been saved, the changes are not applied. The dialog for the input of a unique name and the description is opened.
The copy of the recipe automatically receives status Editable and can be edited further.

When duplicating a recipe, a CEL entry is created.

Delete master recipe

Deletes the selected recipes irrevocably. If the recipe is opened on another computer for editing, it is automatically closed there.
Deleting is only possible if there are no control recipes which are based on the master recipe. First you must delete all control recipes.
Recipes which are currently executed in test mode (master recipe status: Test in execution) cannot be deleted. First they must be finished, stopped or canceled.

If recipes must not be deleted - e.g. FDA regimented environment - we recommend not to engineer this button or to give it an appropriated Authorization level.
When deleting a recipe, a CEL entry is created.

Rename master recipe

Only active if exactly one master recipe was selected.
The dialog for the input of a unique name and the description is opened.
Recipes can only be renamed if they are in status Editable.
Also use this function in order to changed the description of the control recipe.

When renaming a recipe, a CEL entry is created.

Open master recipe

Opens the selected master recipe in the recipe editor if screen element Recipe editor exists in the screen. Each selected master recipe is opened in a separate tab of the recipe editor.

Release master recipe

Changes the master recipe status of the selected recipes to Released. Only recipes without errors can be released. If error occur during the validation, you must first fix them.
Only recipes in status Test mode and Editable can be released.

Released recipes can no longer be edited. Control recipes can only be created from released recipes.
For details about the states see chapter Recipe types and recipe states.

When releasing a recipe, a CEL entry is created.

Test master recipe

Changes the master recipe status of the selected recipe to Test mode. Only faultless recipes can be switched to test mode. If error occur during the validation, you must first fix them.

Recipes in the test mode can be executed but no longer reengineered. For details about the states see chapter Recipe types and recipe states.

Edit master recipe

Changes the master recipe status of the selected recipes to Editable. In this status, recipes can again be edited completely.
Only recipes in Test mode can be set back to Editable.

Highlight master recipe as outdated

Changes the status of the recipe to outdated. The recipe can no longer be edited or approved. No control recipe can be created on the basis of this recipe.

New control recipe...

Opens the dialog for entering a unique name and a description for the control recipe. The uniqueness of the name is also checked in the zenon network. The name must only be unique within the master recipes. Control recipes which are based on other master recipes may have the same name. The uniqueness within module Batch Control is achieved by always referencing the master recipe name and the control recipe name.

When creating a control recipe, a CEL entry is created.

Actions for filling the control recipe list

As each control recipe can be executed only once, we assume that there are very many control recipes. As during the loading of the list of the control recipes each control recipe is opened on the hard disk, it makes sense to not display all control recipes. Therefore control recipes cannot be opened automatically. They must be called up manually and via filters:

  1. Provide the fitting filter options.
  2. Select the desired master recipes.
  3. Click on button Display associated control recipes in list.
  4. All control elements complying with the filters and the selection are displayed in the list of the control recipes.
Action/filter | Description
currently executed control recipes | Opens only control recipes that are currently being executed. Control recipe status: Running
prepared control recipes | Opens only control recipes which are prepared for execution. Control recipe status: Prepared
completed control recipes | Opens only control recipes which have already been executed. Control recipe status: Finished
Display associated control recipes in list | Displays all control recipes that are based on the selected master recipe and that comply with the set filter criteria.


Manage control recipes

Manual -> Batch Control -> Configure and control in the Runtime -> Manage recipes -> Manage control recipes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

List and list formating

List/action

Description

List control recipes

In this list all control recipes can be displayed. The display can be limited by filters to an individual selection.

Per default the list is empty. For filling the list you must:

  • select master recipes
  • Set the currently-executed control recipes,
    prepared control recipes and
    completed control recipes
    filters
  • click button display associated control recipes in list

In addition to the filters mentioned above, you can filter the list itself. The filtering can be preset in the zenon Editor in the screen switch function. Online filtering is also possible. These filters are discarded when the screen is called up again. A permanent definition is only possible in the zenon Editor.

All commands are also possible in the context menu of the list. The commands for list management can be called from the header of the list. The commands for recipe management can be called at editing one or more recipes.
The recipes in the list cannot be edited directly in the list. Renaming, changing the description or starting the recipes is only possible with the corresponding commands.

Hint for ideal configuration of the list

The list can be designed diversely concerning content and look:

  • Content: The displayed columns can be selected, the column format (column width, alignment, label) can be changed and you can define filters. These settings can be edited in Editor and Runtime.
  • Look: At the settings of the list in the Editor you can find diverse setting possibilities in areas Representation, Scroll bars and Color. With these properties you can even design the list ready for touch operation.

Actions for list management

Action | Description
Column selection master recipe... | Opens a dialog in order to determine which columns should be displayed. Attention: These changes are discarded when the screen is called up again. A permanent definition is only possible in the zenon Editor.
Format columns master recipe... | Opens a dialog to edit the column settings. Attention: These changes are discarded when the screen is called up again. A permanent definition is only possible in the zenon Editor.

Actions for recipe management

Action

Description

Duplicate control recipe

Only active if precisely one recipe was selected.
Creates a copy of the selected recipe. At the creation of the copy, the version of the recipe saved on the hard disk is used. If the recipe is just edited in another computer and the changes have not yet been saved, the changes are not applied. The dialog for the input of a unique name and the description is opened.

The copy of the recipe automatically gets the status Prepared and can therefore be edited and started. The execution status of the duplicate is set to automatic.

When duplicating a recipe, a CEL entry is created.

Delete control recipe

Deletes the selected recipes irrevocably. If the recipe is opened on another computer for editing, it is automatically closed there.
Deleting is only possible if all selected recipes are not executed (control recipe status: In execution). In execution: First they must be finished, stopped or canceled.

If recipes must not be deleted - e.g. FDA regimented environment - we recommend not to engineer this button or to give it an appropriated Authorization level.
When deleting a recipe, a CEL entry is created.

Rename control recipe

Only active if exactly one control recipe was selected.
The dialog for the input of a unique name and the description is opened.
Recipes can only be renamed if they are in status Prepared.
Also use this function in order to changed the description of the control recipe.

Open control recipe

Opens the selected control recipe in the recipe editor if screen element Recipe editor exists in the screen. Each selected control recipe is opened in a separate tab of the recipe editor.

Start control recipe

Starts the selected control recipe in the set execution mode. The recipes are executed invisibly at the Server. It is not necessary that the recipe is opened in the recipe editor.


Saving on the hard disk and backup scenarios

Manual -> Batch Control -> Configure and control in the Runtime -> Manage recipes -> Saving on the hard disk and backup scenarios

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Master recipes

Each master recipe has a unique ID under which it is saved on the hard disk with file extension .MR; e.g. 9.MR
Each recipe conforms to one file. The ID of the recipe can be read from the list of the master recipes. For this column Master recipe ID must be visible.
The folder for the master recipes is a sub folder of Runtime folder: \RT\FILES\zenon\system\BatchRecipes

For the recipe management file Recipe.unique is responsible which is located in the same folder. It makes sure that the recipe names are unique.

Note: If you delete a recipe manually via the file explorer and therefore outside of the Runtime and the module Batch Control, you must delete file Recipe.unique for its content to be correct again. For example if you delete a control recipe manually, you cannot delete the respective master recipe in module Batch Control as the control recipe still exists according to module Batch Control. Only after a reinitialization of file Recipe.unique the master recipe can be deleted.

Backing up master recipes

The .MR files - and with this all master recipes - can be backed up at any time. For example you can use function File operations.

Restoring master recipes

The restoring should only be done if absolutely necessary as more current data is overwritten. Proceed as follows:

  1. Exit the Runtime.
  2. Save all existing master recipes.
  3. Rename file Recipe.unique or delete it. It automatically re-created at the Runtime start from the .MR files.
  4. Restore the .MR files from an earlier backup.
  5. Restart the Runtime.

Control recipe

Each control recipe has a unique ID under which it is saved on the hard disk with file extension .CR; e.g. 9.CR
Each recipe conforms to one file. The ID of the recipe can be read from the list of the control recipes. For this column Control recipe ID must be visible. Control recipes are always based on a master recipe and are therefore always assigned to it. The ID number circles are therefore only unique with regards to the underlying master recipe.
Example: The master recipe with ID 9 has the control recipes with IDs 1 and 2. The master recipe with ID 10 has the control recipes with IDs 1 and 2.

Therefore each master recipe has a sub folder in which the control recipes are saved. The name of the folder is always: <Master recipe ID>.crd. In our example there is the folder 9.crd with files 1.CR and 2.CR and the folder 10.crd with files 1.CR and 2.CR.

The folder for the command recipes are sub folder of Runtime folder: \RT\FILES\zenon\system\BatchRecipes\. In this folder the individual control recipe folders have been created. In each control recipe folder there is the file Recipe.unique. It makes sure that the recipe names are unique.

Backing up and restoring control recipes

Proceed in the same was as for the master recipes only that you now need to backup all .CR files and the appertaining folder structure. At restoring you must delete all Recipe.unique files. They are also restored automatically.


Recipe Execution Engine (REE)

Manual -> Batch Control -> Configure and control in the Runtime -> Recipe Execution Engine (REE)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The REE (Recipe Execution Engine) executes recipes in the Runtime. You can start any number of recipes.


Symbols and Color

Manual -> Batch Control -> Configure and control in the Runtime -> Recipe Execution Engine (REE) -> Symbols and Color

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The states during the process of a phase are displayed with the help of different symbols. Some symbols are also used for transitions and end simultaneous sequence.

Symbols and what they mean:

Symbol

Meaning

Phase starts.

Waiting for unit allocation. The unit of the phase is already being used in another recipe.

Whilst waiting for the input interlocking.

  • During the execution of a phase and the waiting for Reaction finished.
  • With transitions: Whilst running and waiting for transition condition.
  • With end simultaneous sequence: Waiting for all branches combined.

In preparation for start. After a restart when waiting for the restart conditions.

  • Reaction finished recognized; waiting for Reaction completed.
  • With transitions: Waiting for transition condition met.
  • With end simultaneous sequence: Waiting for simultaneous sequence finished and waiting for following condition.

Waiting for Minimum execution duration procedure.

Waiting for exclusive execution.

Time out for unit allocation expired.

Time out for input lock expired.

Waiting too long for value for writing.

Time out for Reaction completed expired.

Time out for Reaction ended expired.

If an error occurs during a phase, the phase is marked as faulty until it is restarted.

Status

The execution status of phases, transitions and end simultaneous sequence is signaled in color:

Status

Color

Idle:

White

Running:

Green

Finished:

blue

Stopping:

Two colors:

  • yellow
  • Original color

Stopped:

yellow

Pausing:

Two colors:

  • orange
  • Original color

Paused:

orange

Holding:

Two colors:

  • gray
  • Original color

Held:

gray

Aborting:

Two colors:

  • red
  • Original color

Aborted:

red

Restarting:

Two colors:

  • green
  • Original color

Force:

(phases or transitions only)

Violet border

Timeout:

red border

Action on stop command

After a stop command, the phases, transitions and end simultaneous sequence immediately go to stopped status, even if other elements are still waiting for a condition for stopping. Further subsequent commands such as cancel are ignored. The stopped status remains displayed.


Create recipe image

Manual -> Batch Control -> Configure and control in the Runtime -> Recipe Execution Engine (REE) -> Create recipe image

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

During batch operation, all recipes that are currently being executed can be saved with all recipe data in a recipe image (Image) . Saving is possible as follows:

  • When Runtime is closed: a recipe image of the recipe that is running is created automatically.
  • Cyclical: in a freely-definable time period between 30 and 4294967295 seconds, an optional recipe image is written
  • When activating a phase: if a phase is activated, an optional recipe image is written

These methods can also be combined as desired. It can thus be ensured that Batch operation can also be continued correctly at any time in the event of errors.

Ending the recipe image in Runtime

If the Trigger end of Runtime event is triggered, the ending of Runtime is prevented until the Batch Control module has backed up all data. A process screen is created that represents the initial status for the restart. Likewise, it is ensured that the parameters of the Write set value action arrive at the control unit securely. Internally the phase is paused only when the writing confirmation from the driver ensued. This recipe image contains the images of the REEs, the order of the allocations and all reactions that are needed when restarting. Find out more information in the chapter Exit and restart Runtime.

Cyclic writing of a recipe image

A recipe image can also be written cyclically during Runtime. As soon as Activate cyclic writing is activated, a recipe image is created in the given cycle.

To activate cyclical writing:

  1. Go, in the properties of the Batch Control module, to the Recipe image group.
  2. Activate the property Activate cyclic writing
  3. In the Cycle time [s] property, create the time period for the writing of the recipe image; the minimum time period is 30 seconds
    Note: If the cycle time is changed and reloaded, then the next time to which an image is written is recalculated.

With cyclical writing, the last two image files are always retained. Older ones are deleted. Writing is a two-stage process:

  1. The recipe image is written to the TemporaryImg.REE file.
  2. If this was successful, the next version number is issued and the temporary file is renamed to the new version.

With cyclically-created images, all recipes that are currently running are saved in the recipe image. This ensures that the recipe is appropriate to the execution status on restarting. To do this, the recipe from the recipe image overwrites the recipe in Runtime when restarting. It is only possible to restart if the recipe in question still exists and is still in an execution status. The recipe is not restarted if the recipe has already ended after the recipe image has been created.

Recipe image when activating a phase

A recipe image can also be created when activating a phase. To create a recipe image each time a phase is activated:

  1. Go, in the properties of the Batch Control module, to the Recipe image group.
  2. Activate the property Write recipe image when activating a phase

A recipe image is written in Runtime each time a phase is activated.

Saving and restoring

REE images are stored in the project folder with the following naming convention: Batch[Version-Hex].REE

With the file extension .REE, image files are read in when Runtime is started and the most recent version is identified. The most recent version is the recipe image to be loaded and remains as a file after restarting. All other files with the extension .REE are deleted.


Behavior of elements in Runtime

Manual -> Batch Control -> Configure and control in the Runtime -> Recipe Execution Engine (REE) -> Behavior of elements in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The basic principle is: Phases and all elements that follow them (transition, end simultaneous sequence, start simultaneous sequence, allocation) remain active until the next phase becomes active. (Exception: a manual skip is carried out.)

Phases

All phases paused

In manual mode, it is possible to assign all phases the status paused.
For example: The branch continues to be gone through before the end simultaneous sequence after the end of this. The active element is thus after the end simultaneous sequence and before the next phase. All phases before the end simultaneous sequence have the status paused. These phases are now only set to hold and then to restart. The other phases remain paused. If the restarted phase is ended, there is only one active element. If this is activated with the next step, then no active element is present any more. The end simultaneous sequence element remains paused however and does not switch through.

Solution: Continuation of the paused phases.

Pause and Resume

The following applies to pausing and resuming:

  • Pausing and resuming with active element: A paused phase that is active for an active element is not continued.
  • Switching from manual mode to automatic: All phases that are active for an active element are resumed.
  • If a phase is paused in manual mode and the REE is switched to automatic, the phase remains paused. Global continuation would also not put this phase back to the status of continue, because the phase was paused in manual mode.
    • A Pause phase command, followed by a global pause and a global resumption, sets phases that were paused using the Pause phase command to the status resume.
    • Phases that were paused in manual mode can be set to the status of resume with the Resume phase command.
  • The recipe status changes to running after global pausing and resumption. However phases with active elements remain paused and the active element remains unchanged.
  • The recipe status remains as running after local pausing and resumption. The recipe is resumed at the active elements. This also applies if the active element has been moved.

Sequence selections

The following applies in branchings:

  • As long as the left transition does not have a value, the right transition is ignored.
  • If the transition condition is met for both transitions, the left branch is selected.

Stopping elements

If an end simultaneous sequence is stopped, it becomes inactive immediately and does not react to any more REE commands such as cancel. Therefore is also does not change to the status aborted after a cancel command. The same applies to transitions. In contrast, phases may wait after stopping for further conditions to be met.

Transitions

  • A transition before an end simultaneous sequence remains active, including the phase before the transition after it has been run through, if the transition is active after the end simultaneous sequence but has not yet been run through.
  • In sequence selection, impulses for a transition are ignored for as long as the transition to the left of the transition concerned does not have a valid value.
  • Transitions are deactivated with hold and restart. The active element is activated again in manual or semi-automatic mode.


Mode and mode change

Manual -> Batch Control -> Configure and control in the Runtime -> Recipe Execution Engine (REE) -> Mode and mode change

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The REE can run in three modes:

  • Automatic: The recipe runs entirely automatically.
  • Semi-automatic: The recipe is executed manually. Conditions cannot be jumped.
  • Manual: Each step in the recipe or operation is executed manually; conditions that are being waited for can be skipped (forced).

To execute a recipe manually or semi-automatically, the operation types Step-by-step execution of the recipe and Jump can be used.

When switching to automatic mode, all execution positions are removed. Global commands are only executed in branches that have no execution positions.

info Information

To react on serious events, you can change the mode during the running process via reaction type influencing the recipe.


The execution status

Manual -> Batch Control -> Configure and control in the Runtime -> Recipe Execution Engine (REE) -> The execution status

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following states are possible:

Status

Description

Idle

The REE is in idle state.

In execution

When starting a control recipe, it changes to the status running.

Executed

As soon as the execution is finished, the recipe changes to status Finished. In this status execution is not possible.

Pausing

The recipe changes to status Paused.

Paused

Within the phase the process stops at:

  • Waiting for Finished
  • Waiting for Allocation
  • Waiting for Interlocking condition
  • Waiting for Phase finished
  • Check for parallel execution

Holding

The object changes to Held and does not carry out any allocations anymore. When restarted, the object is restarted and changes to running.

Held

Within the phase the process stops at:

  • Waiting for Finished
  • Waiting for Allocation
  • Waiting for Interlocking condition
  • Waiting for Phase finished
  • Check for parallel execution

Restarting

Phase is restarting.

Restarted

Phase is completely restarted.

Stopping

Stops the process and changes to Stopped.

Stopped

The object was stopped.

Aborting

Aborts the process and changes to Aborted.

Aborted

Recipe process was aborted.

If a recipe cannot be restarted in the image at the restart, its status automatically changes to Aborted.

Prepared

Prepared for execution.

Active element and jump targets

Status

Description

Continue

If an object is paused and an active element is located after it, continue has the same effect as Next step. This also includes jumps.

At a phase command the command only effects a jump in the same branch.

Held

Removed

  • With phase: execution positions in the branches
  • With global: all execution positions

Pause

Has now effects for jump targets. Already defined targets remain.

Others

Always causes the deletion of the jumps.

For a phase command only the jump in the area of the phase is deleted.


Step-by-step execution of a recipe and jumps in the recipe

Manual -> Batch Control -> Configure and control in the Runtime -> Recipe Execution Engine (REE) -> Step-by-step execution of a recipe and jumps in the recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Step-by-step execution of a recipe

A recipe can be executed step-by-step if:

  • The recipe is in either semi-automatic or manual mode
    and
  • The status of the recipe is running.

For the step-by-step execution the execution is held as soon as an element is finished with its execution. The holding is done via command Pause to the concerned execution path. As soon as all active elements in this path have reached the status of paused, the active element is marked by an red arrow. Operations are treated like all other objects of a recipe.

The execution is resumed with:

  • a selective step: selection of the corresponding arrow (green)
  • a global step: all positions with arrows for possible resuming are started

Communication error with step-by-step execution

If an communication error occurs with a phase whilst this is waiting for an active element, the active element is no longer displayed until the problem is rectified. However, if in the meantime, the execution is switched to automatic mode, then the phase is no longer paused and must be continued. This also applies if a switch to manual or semi-automatic mode is made again.

Commands

Global commands

For global commands all execution positions are deleted as the execution cannot be resumed from there.

Exceptions: Pause and Resume. The execution positions remain as they are.

Phase commands

  • Hold for a phase The active element is deleted from the execution path of the phase.
  • Resume: If there is an active element, a selective next step is executed in this execution path.

Special cases:

Phase command hold and restart in a simultaneous sequence for active end simultaneous sequence

If you hold in this example (images from left to right) a simultaneous sequence and restart it, then you will reach after a step-by-step execution the already paused end simultaneous sequence. To resume the execution from here, the left phase must receive command Resume.

Only one path in a simultaneous sequence with an active phase before step-by-step execution

If, in a simultaneous sequence with a phase before, only one path is executed completely and waiting is taking place in one of the other simultaneous sequences (phase before is running), no active element is displayed in the simultaneous sequence. To get them in the other path, the phase must be paused with a phase command. After that it is possible to execute the path completely.

However, if the simultaneous sequence with the active element continues to be executed, the phase before the simultaneous sequence is deactivated. The left path thus remains paused and without an active element. As there is not active phase, the execution can only be resumed with a global Pause and Resume.

Jump

Jump means to move from one position to another, distant position during execution in order to continue the execution there.

To jump:

  1. Select an active element with the mouse cursor
  2. move it to one of the offered targets
  3. execute the next step

All active elements in front of the source pointer are deactivated and the object after the target is activated.

If a jump is registered for which source and target are analogously the same (jumps over lines, jump targets or end sequence selection objects), this jump is ignored and a simple step is executed.

Jumping in simultaneous sequences

If, in parallel sequences, a jump is made in first simultaneous sequence via the phase, then the first phase before the simultaneous sequence is deactivated. Therefore no phase is active. Phases cannot be skipped if this means that no phase would be active in the recipe. The following behavior when skipping leads to an error:

  • Recipe with simultaneous sequence

  • A global step activates the phase before begin parallel sequence.

  • After the next step, the active element is before the phase in the simultaneous sequence.

  • The active element is moved behind this phase.

    Rule when jumping: Objects before a begin parallel sequence become inactive as soon as objects become active after this.
    Thus the first phase becomes inactive when jumping. The skipped phase in the simultaneous sequence never became active, nor did the following phases.
    Thus no phase is still active in the recipe:


Process of a phase in detail

Manual -> Batch Control -> Configure and control in the Runtime -> Recipe Execution Engine (REE) -> Process of a phase in detail

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A phase is always processed sequentially after the same pattern. To break down the exact process, you also need a following condition. For this display we use a transition as following condition. We give the phase the name Phase 1. You can find additional special process behavior with following condition in chapter Following condition.

Phase | Transition | Event
Phase is activated |  | Phase activated
All variables of the phase are registered at the drivers. |  |
Unit allocation is started and Waiting period unit allocation is started. |  | If the unit allocation was not successful in the first try: Unit allocation not possible
Optional: Unit allocation possible within the waiting period. |  | Waiting period unit allocation exceeded
Check is started whether phase isn't already executed. This can happen if the phase is already active in a simultaneous sequence or if the unit allocation was skipped manually and the phase is already executed in another recipe. |  | Phase started multiple times
Start phase |  | Phase started
Check of the input interlocking is started and Waiting period input interlocking is started. |  | If the checking of the input interlocking was not successful in the first try: Input interlocking blocked
Optional: Condition of the input interlocking not TRUE within the waiting period. |  | Waiting period input interlocking exceeded
Writing the command tag |  | When all command tags were written: Finished writing command tags
Checking of the phase-done condition is started and time for Minimum execution duration and Maximum execution duration is started. |  |
Optional: Phase-don condition fulfilled but Minimum execution duration not reached. |  |
Optional: Condition of the Phase-done condition not TRUE within the Maximum execution duration. |  | Maximum execution period exceeded
Optional: Waiting for restart of the whole execution. If the execution is still restarting (for other phases in the recipe the restart condition is not yet fulfilled), it is waited here. This guarantees that the following element is activated after the recipe changes to running. |  |
Phase-done condition is TRUE and minimum execution duration is reached or exceeded. Waiting period following condition is started. | Transition is activated | Phase finished
 | All variables of the transition are registered at the drivers. | Waiting period following condition exceeded
Optional: Following condition not within waiting period TRUE | The transition condition is checked. |
The next phase is activated. The following condition can be composed from several objects (e.g. transition + unit allocation). No till the next phase is reached (or the end of the recipe), the following condition counts as fulfilled. |  |
Phase is informed that the following condition is fulfilled. | Transition condition is TRUE. | Phase deactivated
All events of the phase are deactivated. |  |
All variables of the phase are signed off from the drivers. | All variables of the transitions are signed off from the drivers. |
The phase is deactivated. | The transition is deactivated. |

Rule for values of transitions

If a transition has value TRUE for the phase-done condition during the waiting period, it is marked as finished. If its value should later change to FALSE, the execution of the recipe is not influenced.

Global pausing and continuation if there is a communication error

If a phase is paused and there is a communication error, this cannot be simply continued. Phase commands are prevented, recipe commands are circumvented. If the recipe is paused, a Continue recipe recipe command can be sent. As a result of this, the recipe changes to the status running, but the execution path of the phase concerned remains unaffected.


Following condition

Manual -> Batch Control -> Configure and control in the Runtime -> Recipe Execution Engine (REE) -> Process of a phase in detail -> Following condition

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A phase is active as long as the following condition is fulfilled. Only once the following condition is fulfilled is the phase is deactivated. The phase completed event is triggered and the phase is deactivated. Before it is deactivated, the event reactions are executed. Se also Process of a phase in detail

The following condition can be very different. Here some examples:

  • Phase 1 followed by a phase 2:
    As soon as the phase done condition (and optional the Minimum execution duration) is fulfilled for phase 1, phase 1 is completed and phase 2 is activated.
  • Phase 1 followed by a transition:
    Only when the transition condition is fulfilled, phase 1 is completed.
  • Phase 1 and phase 2 parallel followed by an end simultaneous sequence:
    Not before the phase done condition (and optional the minimum execution duration) is fulfilled for both phases, both phases are completed.
  • Phase 1 and phase 2 parallel followed by an end simultaneous sequence followed by a transition:
    Only when the transition condition is fulfilled, both phases are completed.


Escape phase

Manual -> Batch Control -> Configure and control in the Runtime -> Recipe Execution Engine (REE) -> Escape phase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

It is possible to exit a phase during execution. Execution after the phase is then continued without having to run through the outstanding steps of the phase. It is only possible to exit a phase in manual mode. In the Editor, it is also possible to configure a condition in the Condition transient states/Escape condition property.

It is also possible to exit if the phase is in this status:

  • Running
  • Pausing
  • Paused
  • Holding
  • Held
  • Restarting

If the exit command has been reached, the current execution step is canceled and checking of the Escape condition starts immediately. If the condition exiting is met, all necessary steps are instigated so that the object changes back to the status of running:

  • Restarting: The normal procedure is continued from the Wait until the recipe has the status "running". That means: All steps between instigating the exit and Wait until the recipe has the status "running" are not executed.
  • Running: The normal procedure continues to be executed after the phase or the phase waits for the pause condition to be met.

No more transient conditions are checked from the start of the check for the exit of a phase. Only after a switch to stopping or aborting is the checking of Escape condition interrupted.

Behavior when exiting from the phase depending on the execution status:

  • Exit from the phase from holding or from held :
    A restart is only carried out internally when switching back to running. The execution data is retained with the object. This also applies if a restart is carried out during the checking Escape condition.
  • Exit from the phase if the recipe status is not running or restarting:
    If there is a different recipe status, once the condition has been met, waiting continues until the recipe status changes to running or restarting. This also makes it possible to exit with a different recipe status.
    For example: The recipe has the status held. The exit action is carried out for a phase. Then the end of the exit is only reached if the user executes a global restart command. This also makes it possible to exit if the recipe has the status held, without using the normal mechanism for a restart.

info Information

If an error occurs with communication to the PLC, the check of the exit conditions is postponed until the error has been rectified.

Suppression of reactions when exiting

Most events for the status change and mode change are suppressed whilst a phase is exited. The checking of the Escape condition has priority and the status change is also carried out without the condition being checked. Exceptions to this are stopping and aborting, as well as End Runtime triggered and Runtime restart, because these have a higher priority than Exit without phase. These events are triggered, as well as the event for Linked variable invalid.


Restart phase

Manual -> Batch Control -> Configure and control in the Runtime -> Recipe Execution Engine (REE) -> Restart phase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Phases can be restarted. In doing so, all connected active objects are deactivated, including connected simultaneous sequences. A phase always carries out a series of event for activation activation, start and finished, regardless of the number of restarts. Events that have already been carried out are skipped on restarting. Transient conditions are only checked after the start event.

Deactivation

At the restart of a phase, all active objects are deactivated in principle, however only if they are linked. Isolated active objects are not deactivated.

Sequence of deactivation

The deactivation starts from the object which has been active the longest. After the restart this object is also going to be activated. If this object is deactivated, it also deactivates all branches to which it can establish a connection via an active object.

Isolated branch

A branch is isolated if it is not connected to another branch via an active object. The deactivation only takes place between connected branches. As long as an object does not have status Completed, there is not active connection to the following object.

Restart of selected phases

One or more phases can be selected and restarted. For the selection of several phases, they must be in separate branches.

The oldest object is restarted in the selected branch. With this all active objects in the connected branches are deactivated.

Global restart

The global restart carries out a restart for all phases. The restart is done for the oldest active object and with this all connected, active objects are deactivated. All remaining active objects are in an isolated branch. Here also the oldest object is restarted until all active objects were dealt with.


Secure writing of the command parameters

Manual -> Batch Control -> Configure and control in the Runtime -> Recipe Execution Engine (REE) -> Secure writing of the command parameters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The command parameters (initial parameters and value parameters) are written to the PLC securely. The waiting time can be configured in the Editor.

Procedure

The following applies when writing command parameters:

  1. Waiting occurs until all parameters to be written as inverted have a value
    • If this is not possible within the configured waiting period, 3 attempts are made.
    • If there are still parameters with no value, no parameter is written, not even those with a value.
  2. Command parameters are written.
  3. The actual values are compared to the written values.
    • After a positive write confirmation, waiting occurs until the variables to which they were written can be read again. All written values must be active at the same time. If the waiting period has expired, writing starts again. There is a maximum of 3 repetitions.
  4. If all attempts have been unsuccessful, the Command parameter without value event is triggered.
  5. If secure writing is unsuccessful, a communication failure event is triggered. That means:
    • The error must be acknowledged.
    • The phase must be put back to the status "running".
    • Writing is restarted once continued.
    • The execution of the function is restarted in the event of a restart.
  6. The procedure can be paused, held etc. using commands whilst secure writing is being carried out. If the phase has the status paused and it is then continued, the writing is also restarted. In doing so, the values to be inverted are recalculated for a command parameter to be toggled.
  7. Writing of the command parameters can also be skipped.
  8. If Runtime is ended whilst writing the command parameters, these are rewritten when Runtime is started. Parameters to be toggled are recalculated.

Duration, start time and end time of the writing are displayed in the tooltip of the phase.

Configuring the waiting period

To configure the waiting period for secure writing:

  1. Navigate to the General/Protected writing group in the properties of the Batch Control module.
  2. Enter the desired waiting period in the Time out for protected writing property

info Information

The waiting period includes all waiting processes in the whole write process:

  • Waiting for values for all parameters to be written
  • Waiting for confirmation of the written parameters
  • Waiting for reading of the variables

If the standard value of 20 seconds is used, all wait processes within 20 seconds must be concluded positively. If the waiting period has expired without a positive result, writing is started over.


Exit and restart Runtime

Manual -> Batch Control -> Configure and control in the Runtime -> Recipe Execution Engine (REE) -> Exit and restart Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Actions on restarting

Actions can be predefined for restarting Runtime after closing. These can be defined for:

  • Restart after normal shutdown
  • Restart on system failure

One of the following actions can be selected for each of the two properties:

  • Hold recipe: The complete recipe is held after restarting.
  • Recipe pausing: The complete recipe is paused after restarting.
  • Retain recipe status: After restarting, the recipe is set to the same status as before closing.

Status change

After restarting, an attempt is made to execute the configured status change. To do this, the corresponding command must also be executable. The status Restarting for recipes and phases is handled in the same way as in execution. That means:

  • Paused is set for: In execution, pausing and restarting.
  • Held is set for: In execution, pausing, paused, holding and restarting.

Transient conditions are not checked and events are not set. Therefore the status in the recipe can be brought in line with the status of the equipment, without sending events to the equipment for the status change.

Information in recipes and unit

When restarting after Runtime has been restarted, the respective status is stored with the information in the recipes. For example: Paused after normal shutdown or Held after incorrect shutdown.

The execution status is also displayed in the unit information. The execution status (numerical and text) in the unit information contains a number and text that corresponds to that of the variables in the screen. Including information on whether triggered by a restart, information on objects with a different status and objects that delay a status change.
Caution: The content of these variables is not compatible between zenon 7.10 and 7.11.

Image file

At closing the Runtime an image file of the running recipe is created. It contains the images of the REEs, the order of the allocation and all reactions which are needed for the restart.

Allocations

After the restart the allocations match the state before the finishing. It is saved who allocated a unit and who forced an allocation in which order. If a recipe cannot be restarted (e.g. because of failed validation), the allocations for this recipe are removed.

Reactions

Reactions which were triggered by the process are also incorporated in the image if they are active. They are then executed after the REE is restarted. This guarantees that the reaction is always executed as a whole either before the image file is created or after the restart.

The Exit Runtime reaction is always executed and can never be incorporated in the image.

Synchronous writing

The REE manages the confirmation for all variables whose write set value should be executed synchronously. The time out for this is defined by the time within which the Runtime must be closed. For each write acknowledgment the time out is restarted. A time out is written in the log file.

Variables which don't access a driver are always written without an acknowledgment even if an acknowledgment is requested. Internal drivers do not support acknowledgments.

Allocate tag

As during the start of the Runtime all drivers are also started, it is possible that they do not provide valid values if they are needed at the restart. During the restart it is not waited for the value update. This does not ensure that the value is written as expected. If no value is available, the alternate value is used.

It is waited for the values of the internal driver if they are available within 2 cycles.

Checking for a communication error

A check is also made for communication errors when restarted if this has been configured.


Behavior in the network

Manual -> Batch Control -> Behavior in the network

The module Batch Control is fully capable of using a network in terms of Client/Server technology. This means that Batch recipes can be created, duplicated, edited, deleted, etc. on a Client. The whole recipe management remains always on the server. Likewise the whole process control such as start recipe, pause recipe, stop recipe, etc. can be done from the Client. Also mode changes and manual operations such as jump are possible.

attention Attention

Module Batch Control does not support redundancy. There is no synchronization between Standby Server. When the Server breaks down, the executed Batch recipes are not continued seamlessly on the Standby!

For using Batch Control in a network the following is true:

Allocation

  • The forcing of allocations can be carried out be Server and Client.

Functions

Functions are always carried out at the Server.

Phases

  • Editing phases in the master recipe:
    • Edit mode: Changes a done locally at the Client.
      If during the editing the recipe is saved on another computer in the network, the current configuration is lost. An appropriate message is displayed and the editing dialog is closed. The new data from the server are displayed.
    • Test mode: Changes a done at the Server.
  • Control recipe: Changes a done at the Server.
  • If a recipe is saved in the network, all Clients using this recipe are updated.
  • If a recipe is opened on a client, the current version on the server is always displayed, even if it has not yet been saved there.
  • If a recipe is deleted on a computer, a message is displayed on all computer on which the recipe is opened that the recipe has been deleted.

Mode

  • The mode (automatic, semi-automatic, manual) can be switched by the server and the client.
  • Jumps in the recipe and step-by-step progress of a recipe can be done from Server and Client.

Recipes

  • Recipes can be started and controlled by the zenon server and by zenon clients.
  • If parameters in a recipe are changed whilst the recipe is saved on a different zenon client, the change to the parameters is refused and not carried out.
  • A master recipe can be changed on the zenon client whilst it switches to test mode on the zenon server and is sent to the zenon client. The changes that were last saved are transferred. This means: If the zenon client saves last, the recipe is switched to editing mode again. If the zenon server saves last, the change to the zenon clients is discarded and the recipe is in test mode.
  • If a communication error occurs when deleting a recipe or an operation template, the deletion is refused with an error message.

Web Client

With a standard web client:

  • The settings for grid and color can be changed
  • No recipes can be created or edited
  • The size of the editing area cannot be changed
  • In the tool bar, all symbols that are not permitted are deactivated; it is not possible to select the corresponding objects.

Web client PRO is not affected by these restrictions.


Redundancy

Manual -> Batch Control -> Behavior in the network -> Redundancy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon Batch Control does not support redundancy. In networks that have been set up as redundant, this means:

  • If the server fails, the recipe is in an undefined status.
    It is not passed on to the standby server.
  • On the standby server, once it has stepped up to become the server:
    • Master recipes can be switched back to edit mode and deleted.
      These changes are carried over to the server once it is working again.
    • Control recipes cannot be edited or executed.
  • Starting, pausing or other commands are not possible on the Standby Server.
  • If the recipe is not edited in the Standby Server, it runs normally again as soon as the server is online again.


Reporting

Manual -> Batch Control -> Reporting

Reports for configuration of the recipes can be created with the Report Viewer integrated into zenon.

When switching to a Report Viewer screen:

  • it is possible to filter for recipes
  • Datasets for Batch Control reports can be created:
    • Master recipe
    • Control recipe
    • Recipe screens
    • Matrix cells
    • PFC structure
    • Phases
    • Parameters
    • Transitions
    • Unit allocations
    • Operation instance


Batch Control recipe filter

Manual -> Batch Control -> Reporting -> Batch Control recipe filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When screen switching to a report viewer type screen, a filter can be set for recipes from the Batch Control module. To filter according to recipes:

  1. Open the Report definition tab for screen switching
  2. go to area Filter
  3. In the Module-specific filter tab, click on Batch Control: Recipe Filter
  4. the dialog for configuring the filter is opened

Use recipe filter for

Parameters

Description

Use recipe filter for

Selection of the recipe type that is applied to the filter:

  • Master recipe
  • Control recipe

Master recipe

Active: It is filtered on Master recipes.

Control recipe

Active: It is filtered on control recipes.

Note: The attendant master recipes must also be selected. If no master recipe has been selected for the control recipe, th filer cannot find the recipe being searched for in Runtime.

Hint: If the master recipe is not known, filtering of all master recipes with a placeholder is recommended.

Recipe filter settings

Parameters

Description

Recipe filter settings

Options for the recipe filter

Apply selection from recipe list from calling Batch Control screen

Active: In Runtime, the first selected recipe of the batch screen from which the report viewer screen is called up is used. Individual settings in this dialog are then not available.

Inactive: The filter settings are changed individually using this dialog.

Master recipe

Parameters for the selection of the master recipe. Selection from drop-down list:

  • Name with wildcards:
    A name with placeholder can be entered into the input field. Filtering according to this name is carried out.
  • Name from variable:
    The name of the master recipe is defined by a variable in Runtime. A click on button ... opens the dialog for selecting variables.
  • ID from variable:
    The ID of the master recipe is defined by a variable in Runtime. A click on button ... opens the dialog for selecting variables.

Version

Selection of the version from the drop-down list:

  • All:
    The version stated is ignored and each version found is used.
  • Fixed version:
    This filters for versions that are entered in this field.
    Highest possible version: 4294967295
  • Version from variable:
    The recipe that was in the linked variables at the time of execution is filtered for. Click on button ... in order to open the dialog for selecting a variable.
  • Only oldest version:
    Only the recipe with the oldest version number is used.

Only newest version:
Only the recipe with the newest version number is used.

State master recipe

Status of the recipe Select from drop-down list:

  • Released or outdated
  • Released
  • Outdated

Filter result for

Define which ID is to be selected when filtering for names by selecting from the drop-down list:

  • Only oldest ID
  • Only newest ID

Because a report can only be used for one recipe, it is not possible to filter for "all recipes".

Control recipe

Parameters for the selection of the control recipe. Selection from drop-down list:

  • Name with wildcards:
    A name with placeholder can be entered into the input field. Filtering according to this name is carried out.
  • Name from variable:
    The name of the control recipe is defined by a variable in Runtime. A click on button ... opens the dialog for selecting variables.
  • ID from variable:
    The ID of the master recipe is defined by a variable in Runtime. A click on button ... opens the dialog for selecting variables.
    Precisely one recipe can be found if the variable value at the time of execution is a valid ID of a control recipe.
  • Job ID from variable:
    Finds control recipes that belong to the master recipes already found and which have the given job ID. Any type of variable can be linked. The value is automatically converted into STRING.
    Note: If the variable does not have a value, no recipe is sent to the Report Viewer.

State control recipe

Selection of the recipe status from the drop-down list:

  • All
  • Prepared
  • Running
  • Executed
  • Terminated with error
  • Outdated

Filter result for

Define which ID is to be selected when filtering for names or job ID by selecting from the drop-down list:

  • Only oldest ID
  • Only newest ID

OK

Applies all changes, creates filter and closes the dialog.

Cancel

Discards all changes in all tabs and closes the dialog.

Help

Opens online help.

Note for variable selection using name or ID: For the selection of variables according to name or ID, numerical variables and string variables can be selected respectively. The data types are converted to the respective correct form.


Formula editor

Manual -> Batch Control -> Formula editor

The formula editor is automatically opened if you need to enter or edit a formula. Above all:

Editor:

  • Phases
  • Interlocking conditions
  • all conditions for transitions
  • Phase done condition

Runtime:

  • Phase done condition and interlocking when editing a phase
  • Editing transitions

Note: If the phase referenced in the formula is removed and a new phase is added, the operands are reassigned in the case of operands. To do this, the same phase must be reinserted. Parameters from a different phase are not automatically linked.

Enter formula

The following input is accepted:

  • Constant as decimal number
  • Hexadecimal number if it is preceded by an x
  • Dot as decimal separator; the following is true:
    • Comma is automatically converted into a dot: 23,000 to 23.000
    • Decimal places which are only zeros are removed: 23.000 to 23

Parameters

Description

TAG list

List of the tags which can be used for the formula.

Each entry contains of:

  • a basis node for the label
  • a value
  • a status
  • the bits for value and status

A symbol at the first node displays whether it is a command or return tag.

The short indetifier at the beginning of the name is used for the formula.

Add

Opens the dialog for adding a parameter. For this, the following applies:

  • The following can be added: numeric and binary tags and tags for time duration. Values for duration are converted to seconds
  • For conditions of the phase only the tags created for it can be added.
  • Tags can be added multiple times.

Replace

Makes it possible to replace a tag. Clicking on the button opens the dialog to add a parameter.

  • Selection of a new parameter replaces the highlighted parameter.
  • Clicking on the no selection button deletes the highlighted parameter from the list.

The short identifier remains the same at replacing.

Remove

Removes the highlighted tag. For a tag to be deleted:

  • the formula must be correct
  • the selected tag must not be used in the formula

Logical operators

Via the buttons for operators, operators are added to the formula.

AND

logical 'AND'

OR

logical 'OR'

XOR

logical 'EXCLUSIVE OR'

NOT

Negation

Syntax

The operator buttons add the string shown on them to the formula.

(

Open parenthesis

)

Close parenthesis

Bit by bit and relational operators

&

And

|

Or

>

greater than

>=

greater or equal

<

less than

<=

Less then or equal

=

equal

<>

less or greater

Condition

Configuration and display of the formula.

Copy

Copies the whole formula:

  • All configured tags from the tag tree
  • Formula from the field

Paste

Pastes a formula from the clipboard. At this all already configured elements are deleted and replaced by the copied formula.

When copying formulas between phases, it is tried to resolve the operands via their names. For tags which are not found invalid entries are created in the operands list. Their point of use in the formula remain the same.

OK

Applies formula and closes the dialog.

For this the formula must be correct.

Cancel

Discards all changes and closes the dialog.

info Information

You can link up to 99 tags in a formula. X01 to X99. The length of the formula must not exceed 4096 characters.

The meaning of the bits:

Parameters | Description
value bits | 32 value bits (from 0 -31) are available. They describe the tag value bit by bit. For binary tags only bit 0 is of importance, for SINT and USINT only the bits from 0 - 7, etc.
State bits | Here you find the most commonly used status bits. You find the exact definition and use of the status bits in the Status Bits List.
value and status | In the formulas, all values (value bits and status bits) are treated as binary values and can be logically linked with AND, OR, etc. The total value and overall status are an exception to this. In order to get a Boolean result this total value has to be ORed with a constant bitwise. For this, we use the operator &. For the result 0 (false) of this logical ORing we get the binary value 0 (false), otherwise 1 (true). Example: see chapter Example bit by bit ORing

info Info

The status bits NORM and N_NORM are only available in the formula editor here and cannot be configured using the status.

info Information

Formulas with binary X values and bitwise linking can be used with a maximum of 2 binary values. If more values are required, the linking must be carried out without binary X values.

Example:

X01.Value & X02.Value -> works

X01.Value & X02.Value & X03.Value -> does not work

But:

X01.00 AND X02.00 AND X03.00 AND X04.00 AND X05.00 -> works


Adding parameters

Manual -> Batch Control -> Formula editor -> Adding parameters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Clicking on the Add button in the formula editor opens the dialog to select parameters that are to be used for a formula.

Parameters | Description
Project list | Display of the active project. Only parameters that have been created in the active project for the phase to be configured can be selected.
TAG list | List of the parameters available for the selected phase. Multiple selection is possible. Apply by selecting and and clicking on the OK button or by double clicking on a parameter.
No selection | Deletes parameters already set. Only effective for replacement of parameters. If a parameter is highlighted in the formula editor and this dialog is opened by clicking on the Replace button, then clicking on the No selection button deletes the parameter from the list in the formula editor. The short identifier remains the same at replacing.
OK | Inserts selected parameters into the parameter list of the formula and closes the dialog.
Cancel | Discards selection and closes dialog.
Help | Opens online help.


List of status bits

Manual -> Batch Control -> Formula editor -> List of status bits

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Short term | Long name | zenon Logic label
0 | M1 | User status 1 | _VSB_ST_M1
1 | M2 | User status 2 | _VSB_ST_M2
2 | M3 | User status 3 | _VSB_ST_M3
3 | M4 | User status 4 | _VSB_ST_M4
4 | M5 | User status 5 | _VSB_ST_M5
5 | M6 | User status 6 | _VSB_ST_M6
6 | M7 | User status 7 | _VSB_ST_M7
7 | M8 | User status 8 | _VSB_ST_M8
8 | NET_SEL | Select in the network | _VSB_SELEC
9 | REVISION | Revision | _VSB_REV
10 | PROGRESS | In operation | _VSB_DIREC
11 | TIMEOUT | Runtime exceedance | _VSB_RTE
12 | MAN_VAL | Manual value | _VSB_MVALUE
13 | M14 | User status 14 | _VSB_ST_14
14 | M15 | User status 15 | _VSB_ST_15
15 | M16 | User status 16 | _VSB_ST_16
16 | GI | General interrogation | _VSB_GR
17 | SPONT | Spontaneous | _VSB_SPONT
18 | INVALID | Invalid | _VSB_I_BIT
19 | T_CHG_A | Daylight saving time/winter time announcement | _VSB_SUWI
20 | OFF | Switched off | _VSB_N_UPD
21 | T_EXTERN | Real time external | _VSB_RT_E
22 | T_INTERN | Realtime internal | _VSB_RT_I
23 | N_SORTAB | Not sortable | _VSB_NSORT
24 | FM_TR | Error message transformer value | _VSB_DM_TR
25 | RM_TR | Working message transformer value | _VSB_RM_TR
26 | INFO | Information for the variable | _VSB_INFO
27 | ALT_VAL | Alternate value If no value was transferred, the defined alternate value is used otherwise the last valid value is used. | _VSB_AVALUE
28 | RES28 | Reserved for internal use (alarm flashing) | _VSB_RES28
29 | N_UPDATE | Not updated | _VSB_ACTUAL
30 | T_STD | Standard time | _VSB_WINTER
31 | RES31 | Reserved for internal use (alarm flashing) | _VSB_RES31
32 | COT0 | Cause of transmission bit 1 | _VSB_TCB0
33 | COT1 | Cause of transmission bit 2 | _VSB_TCB1
34 | COT2 | Cause of transmission bit 3 | _VSB_TCB2
35 | COT3 | Cause of transmission bit 4 | _VSB_TCB3
36 | COT4 | Cause of transmission bit 5 | _VSB_TCB4
37 | COT5 | Cause of transmission bit 6 | _VSB_TCB5
38 | N_CONF | Negative acceptance of Select by device (IEC 60870) | _VSB_PN_BIT
39 | TEST | Test bit (IEC870 [T]) | _VSB_T_BIT
40 | WR_ACK | Writing acknowledged | _VSB_WR_ACK
41 | WR_SUC | Writing successful | _VSB_WR_SUC
42 | NORM | Normal status | _VSB_NORM
43 | N_NORM | Deviation normal status | _VSB_ABNORM
44 | BL_870 | IEC 60870 Status: blocked | _VSB_BL_BIT
45 | SB_870 | IEC 60870 Status: substituted | _VSB_SP_BIT
46 | NT_870 | IEC 60870 Status: not topical | _VSB_NT_BIT
47 | OV_870 | IEC 60870 Status: overflow | _VSB_OV_BIT
48 | SE_870 | IEC 60870 Status: select | _VSB_SE_BIT
49 | T_INVAL | Time invalid | not defined
50 | CB_TRIP | Breaker tripping detected | not defined
51 | CB_TR_I | Breaker tripping detection inactive | not defined
52 | RES52 | reserved | not defined
53 | RES53 | reserved | not defined
54 | RES54 | reserved | not defined
55 | RES55 | reserved | not defined
56 | RES56 | reserved | not defined
57 | RES57 | reserved | not defined
58 | RES58 | reserved | not defined
59 | RES59 | reserved | not defined
60 | RES60 | reserved | not defined
61 | RES61 | reserved | not defined
62 | RES62 | reserved | not defined
63 | RES63 | reserved | not defined

info Information

In formulas all status bits are available. For other use the availability can be reduced.

You can read details on status processing in the Status processing chapter.


Logical operators

Manual -> Batch Control -> Formula editor -> Logical operators

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Logical links: Variables will only be checked for the logical value '0'; if the value does not equal '0', it will be considered as '1'.

In contrast to bit formulas, the technical range can be modified by a stretch factor -> (not equal '0' or '1').

Operator | Meaning
AND | logical 'AND'
NOT | Negation
OR | logical 'OR'
XOR | logical 'EXCLUSIVE OR'

The operators have the following priority in the formula calculation:

Priority | Operator
1 | & (operator for bit formulas)
2 | NOT
3 | AND
4 | XOR/OR

info Info

Up to 99 variables can be linked in one formula. X01 to X99.

info Info

The status bits NORM and N_NORM are only available in the formula editor and cannot be engineered via the status.


Bit formulas

Manual -> Batch Control -> Formula editor -> Bit formulas

Bit formulas only have a logical high or low state. In contrast to logical formulas, the raw value is already predefined (0,1).

Operator | Description
& | AND
| | OR


Example: ORing bitwise

Manual -> Batch Control -> Formula editor -> Bit formulas -> Example: ORing bitwise

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You want to find out if one of the user status bits 1-8 (M1 ... M8) of the variable X01 is set.

Usual formula:

X01.M1 OR X01.M2 OR X01.M3 OR X01.M4 OR X01.M5 OR X01.M6 OR X01.M7 OR X01.M8
This query can be made much easier by the logical ORing of the overall status.

Logical ORing:

X01.Status & 0xFF

The constant can be entered in hexadecimals, as described above:

0xFF corresponds to decimal 256; these are the first eight status bits (binary 11111111). If one of these bit is set to 1, the result of this bitwise ORing is 1 (true), otherwise it is 0 (false).

If, for example, all user status bits except the user status bit M7 should be queried, the binary statement for this would be: 10111111. Bit 7 is not of interest and is thus set to 0. This corresponds to 0xBF in hexadecimal. The expression for the formula is then: X01.Status & 0xBF.

Instead of ORing bitwise with a constant, the value can also be directly compared to a decimal number. If the comparison is wrong, the binary value is 0 (false) otherwise it is 1 (true).

Example:

You want to find out if the value is equal to the constant 202: The formula is:

X01.value = 202

If the value is equal to the constant 202, the result of the comparison is 1 (true) otherwise it is 0 (false).

Note: The bitwise ORing works with the OR character (|) in a similar manner to this example.


Comparison operators

Manual -> Batch Control -> Formula editor -> Comparison operators

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Comparison operators serve for the direct comparison of two numeric values. The result of this comparison is a binary value. "0“ if the condition is not fulfilled and „1“ if the condition is fulfilled.

Operator | Description
< | less
> | greater
<= | Less then or equal
>= | greater or equal
= | Equal
<> | unequal

To the left and to the right of the comparison operator, there has to be a (total) value or a (total) status, single bits cannot be used with these comparison operators.

There can also be a constant to the right of the comparison operator. (the constants can only be integers; a comparison to a floating point number is not possible.)
These constants are entered as hexadecimal values or decimal values in the combined element. Hexadecimal figures are automatically converted to decimal values by clicking on OK (for example, 0x64 is in decimal figures 100).

Example Example

X01.value >= X02.value
The result is 1, if the value of X01 is higher than or equal to the value of X02

X01.value = 0x64
The result is 1, if the value of X01 is exactly equal to the numeric value 100 (= hex 0x64)

(X01.value = 0x64) OR (X01.value = 0x65)
The result is 1, if the value of X01 is exactly equal to the numeric value 100 or 101 (= hex 0x64 and hex 0x65)


Examples for formulas

Manual -> Batch Control -> Formula editor -> Examples for formulas

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Simple logical AND linking between two bit values

Example Example

Formula: X01.03 AND X02.03

This formula has the status TRUE, if both bit 3 of variable 1 and bit 3 of variable 2 both have the value 1.

comparison of an analogue value or status of a variable

Example Example

(X01.Value> X02.Value)

Compare analog values with each other on a logical basis

Example Example

(X01.Value> X02.Value) AND (X01.Value = X02.Value)

Compare with value bits and status bits

Example Example

(X01.Value> X02.Value) AND (X01.Value = X02.Value) OR (X01.03 = X02.03)

Compare a value with a decimal or hexadecimal value

Example Example

Formula: (X01.Value = 111)

Formula: (X01.Value = 0x6F)

If a hexadecimal values is used, this is later transferred to decimal by clicking on OK. If a decimal value is entered and confirmed, the value continues to be displayed as a decimal value after reopening.

info Info

It is not possible to use a comma or a period when entering values.


CEL

Manual -> Batch Control -> CEL

Messages, information and errors for recipes, units, commands, reactions, events etc. are saved and displayed in the Chronological Event List ( CEL).

Groups and classes

CEL information can be allocated to groups and classes. These correspond to the alarm/event groups and alarm/event classes created in the project. The respective group or class is also entered in the CEL and can be used for filtering and grouping.

Groups and classes are allocated for actions for:

  • Recipes
  • Commands
  • Value changes
  • Jumping, forcing and step-by-step execution

Recipes

The set group or class is entered into the CEL for the following recipe actions:

  • Master recipes list
    • New
    • Create new version
    • Delete
    • Duplicate
    • Rename
    • Release
    • Highlight as outdated
    • New control recipe
  • List control recipes
    • Rename
    • Duplicate
    • Delete
  • Operation list
    • New
    • Rename
    • Duplicate
    • Delete
    • Release

Commands

The set group or class is entered for all recipe commands, phase commands, mode switches and restart messages.

Value changes

The set group or class is entered in the event of value changes to parameters in master recipes in test mode and for control recipes.

Jumping, forcing and step-by-step execution

The set group or class is entered for all manual steps, when jumping steps and when executing steps.

Allocation

Groups and classes are allocated

  • In general: in the properties of the Batch Control node in the CEL groups/classes group
  • Reactions: in the properties of the event of a reaction in the Reactions/CEL entry group


Failure handling

Manual -> Batch Control -> Failure handling

If communication failures or PLC errors occur, these can be detected in Runtime using a formula configured in the editor. In the event of a communication error, the phase concerned is paused or held (depending on configuration).


communication errors

Manual -> Batch Control -> Failure handling -> communication errors

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Detection of problems can be specially configured for each phase, because phases can also run on different PLCs. The reaction to a communication error is defined globally for all phases. In addition, a reaction to the communication error event can be configured.

To configure the detection of communication errors:

  1. highlight the desired phase
  2. Click, in the Loss of communication property group, on the Loss of communication property
  3. In the formula editor that opens, define the condition for detecting communication errors
  4. click on property Loss of communication acknowledged
  5. Define the condition to detect the reestablishment of communication
  6. Navigate to the properties for the Batch Control module
  7. In the General/Loss of communication group, open the Action for loss of communication property
  8. Select the desired reaction to a communication error from the drop-down list
    • Phase holding
    • Phase pausing

Checking in Runtime

When starting a phase or when restarting Runtime, 60 seconds is waited for values for the formula to check communication. If no values are received within this waiting time, a communication error is assumed.

Another check for communication errors is made if the phase is in a new step.

When restarting Runtime, the waiting for values can be in many steps, because the communication is started again in the middle of the process. A check for communication failures is also made at areas where a check for faults is made.

Reestablishment

Checking the formula for reestablishing communication

A loss of communication to the PLC is determined if the value of the formula for the Loss of communication property is TRUE. Waiting is carried out until communication has been reestablished, i.e. the value of the formula is FALSE. After this, waiting is continued until the value of the formula for the Loss of communication acknowledged property is TRUE or empty. The execution of the object can be continued from this time only.

In the time between the loss of communication and reestablishment of communication:

  • No phase commands can be sent to the phase concerned
  • If the status is changed directly, transient conditions are not checked
  • No reactions are triggered for a status change
  • the procedure path of the phase concerned remains the same when a continue or restart global command is executed
  • The subsequent execution positions are offset until the communication to the phase has been reestablished

Skipping the reestablishment of communication

In the event of a communication error, this can be skipped both whilst the error is active and whilst communication is being reestablished. In both cases, the communication is considered reestablished. All reactions to the skipped steps are triggered. The skipping is displayed in the tooltip.

If a communication error has been skipped, then a new one cannot occur until the value of the formula for the Loss of communication property has not changed to FALSE.

Counter for the recipe and operation for reestablished communication

In the status line of the recipe editor, there is information about errors in the recipe available above the symbol of the error display and its tooltip. Only the information with the highest priority is shown. Active errors and historical errors are not shown at the same time.

Prioritization and coding of the error display in the tooltip:

Priority | Color | Description
1 | red | Currently x errors active.
2 | red | Currently x communication errors not yet acknowledged.
3 | yellow | Errors were present.
4 | green | faultless

Note: "Currently x errors active" counts both procedure errors and communication errors.


PLC error

Manual -> Batch Control -> Failure handling -> PLC error

The detection of PLC errors can be configured for each phase.

To configure the detection of PLC errors in Runtime:

  1. Configure a variable that reports the PLC error in zenon
  2. Highlight the desired phase in the Editor in the Batch Control module.
  3. Click, in the Loss of communication property group, on the PLC error property
  4. In the formula editor that opens, define the condition for detecting PLC errors using the configured variables.
    Note: The formula can be displayed in the report.

To display the number of active and rectified PLC errors in a screen:

  1. Select the unit for whose phases PLC error detection has been configured.
  2. Go to the property group Runtime information/Error.
  3. Configure the variables for the properties.
    • Number of active PLC errors
    • Number of rectified PLC errors
  4. Configure the evaluation and display of variables in Runtime.

Checking in Runtime

If a formula is linked for PLC errors, this is checked whilst the phase is active. Checking starts once communication with the PLC has been established and lasts until the phase has been deactivated. The connection is considered established if all values for the formula for detecting communication problems have been received.

If a communication error occurs, the PLC error is not checked as long as the communication error has not been acknowledged. Once it has been acknowledged, checking continues with the currently-pending value.

PLC errors and the rectification of these are displayed with their own symbol in the phase or in the operation and each displayed with an entry in the tooltip.

If there is a PLC error when a phase is ended, this is amended to rectified. In contrast to a normal deactivation of a PLC error, a separate event is sent: PLC error rectified by deactivation of the phase. This only applies for the actual closing, but not for a restart. When restarting, no new event is sent for PLC errors that continue to be active.


Troubleshooting

Manual -> Batch Control -> Troubleshooting

Warnings and error messages are written in log files and can be analyzed with the Diagnosis Viewer. For this you must activate module Batch Control in the filter settings.

System driver variable

Batch Control provides the system driver SYSDRV with information via system driver variables. For information about there messages see manual SYSDRV in chapter Topic - Batch Control.

Reconstruction of index files

If the index file is not read when Runtime is started or it does not exist, it is reconstructed upon starting. During this time, requests from clients that need an ID or are processing an ID cannot be processed. Modifications are rejected, queries are answered after the index has been created.


Chronological Event List (CEL)

Manual -> Chronological Event List (CEL)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Chronological Event List (CEL) system events and user inputs can be logged, e.g.:

  • Alarm acknowledgement
  • Delete alarms
  • Set value
  • Send recipes
  • Change recipe
  • Archive data
  • User action
  • Network action

The entries are made in the language in which the zenon Runtime runs.

tutorial License information

Part of the standard license of the Editor and Runtime.


Engineer CEL

Manual -> Chronological Event List (CEL) -> Engineer CEL

The handling of the Chronological Event List is carried out via screens of type Chronological Event List and Chronological Event List Filter in the Runtime.

Editor

To display and filter events in the Runtime, you must do the following in the Editor:

  • engineer a screen of type Chronological Event List

In addition you can:

  • control the display of events via filter
  • with a screen of type Chronological Event List Filter adapt the available filter in the Runtime

Runtime

For the operation in the Runtime the following is used:

  • Screen switch CEL
  • Screen switch CEL filter
  • die zenon CEL functions
  • Use screen of type CEL Filter


Creating a screen of the type CEL

Manual -> Chronological Event List (CEL) -> Engineer CEL -> Creating a screen of the type CEL

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A Chronological Event List screen makes it possible to log and display system events and user operations in the Runtime. Which entries are displayed is defined via the engineering. The display can be changed by filters in the engineering and in the Runtime. Functions make it possible to export and print the displayed events.

Create a screen of type Chronological Event List

To create a screen of type Chronological Event List:

  1. Select, in the toolbar or in the context menu of the Screens node, the New Screen command
  2. An standard empty screen is opened
  3. Change the screen type in the detail view; to do this:
    1. click on Standard in the Screen type column
    2. Select Chronological Event List from the drop down list
    3. do not select the main frame if you want to close the screen in the Runtime via button Close
  4. Click in the screen.
  5. Select the Control elements menu item in the menu bar
  6. Click on Add template in the drop-down list
  7. The standard elements are inserted
  8. Select additional elements as required and insert them into the desired place on the screen
  9. create a screen switch function, in order to be able to call up the CEL in the Runtime


Control elements

Manual -> Chronological Event List (CEL) -> Engineer CEL -> Creating a screen of the type CEL -> Control elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Insert template

Parameters | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.

Control elements

Parameters

Description

Chronological Event List

Display field for the list with its events. The appearance is configurable. Columns are defined via the Column settings filter in screen switching or via the Column settings CEL property in the Chronological Event List group.

Set filter

Displays the currently selected filter.

Filter...

Opens the filter dialog.

Sort

After calling up the CEL in the Runtime, new entries are not sorted in chronological order but added to the bottom of the list.

Click on the button to newly sort the list.

To help you differentiate between sorted and unsorted entries you can assigned different colors via properties sorted text and unsorted text.

Show relative times

Active: The relative times are displayed without the focus being lost in the selected entry.

Stop/continue

Controls adding new events to the list while it is displayed:

Stop: No new entries are added to the list. The button changes its caption to Continue.

Continue: New entries are added to the list. The button changes its caption to Stop. To sort the new entries chronologically, you must click on button Sort.

Close

Ends the display of the Chronological Event List and closes the screen and the frame.

In order that after the closing the screen which was opened before is displayed, you must engineer the screen of type CEL with its own frame.

Print

Prints list as it is currently displayed.

Print with dialog

Opens printer settings before printing.

Text: Total number

Adds text "Total" in the Runtime. Must be followed by list field Total number.

Total number

Number of all events in the list

Status

Displays the status of the CEL in the Runtime.

active: Events are logged depending of the settings in the project

inactive: Events are not logged

You define the status with the help of property CEL active. Changes take effect after the Runtime has been restarted.

Text: Comment field

Adds text "comment" in the Runtime. Must be followed by list field Comment field.

Comment field

List field for entering a freely definable text by the user for the selected event.

As soon as the field loses focus, the text is taken over. To display the text in the CEL, you must activate column comment in the column definition.

Button Stop/Continue

Navigation

Controls elements of the list.
  • Line up

Scrolls one line up.
  • Line down

Scrolls one line down.
  • Column right

Scrolls one column to the right.
  • Column left

Scrolls one column to the left.
  • Page up

Scrolls one page up.
  • Page down

Scrolls one page down.
  • Page right

Scrolls one page to the right.
  • Page left

Scrolls one page to the left.

Filter profiles

Filter settings that can be saved by the user in Runtime.

  • Profile selection

Select profile from list.

  • Save

Saves an online setting in a profile.

  • Delete

Deletes selected profile.

info Information

The current filter is displayed with the Show filter control element.

With a:

  • Text filter, the expression [Txt] is displayed
  • Relative time filter: is displayed as a print-out with the following scheme:
    [T,Rel:%dd,%dh,%dm;%ds]
    Example: [T,Rel:1d,0h,0m,0s] equals one day.


Customize CEL look

Manual -> Chronological Event List (CEL) -> Engineer CEL -> Creating a screen of the type CEL -> Customize CEL look

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The table view of the Chronological Event List can be customized individually:

Scroll bars, headers and grids

To define the size and appearance of scroll bars, the header or grids for the the table:

  1. Activate, in the Representation group, the Extended graphical settings property
  2. define the desired properties in groups Scroll bars and Header and grid for element Chronological Event List in the screen

info Information

If the Graphics file property is selected for the Display style property, then all elements for which no graphics file has been selected are shown with a color gradient. Transparent graphics cannot be used for control elements for lists.

Sorting in Runtime

To mark the relevant column for sorting in Runtime and to determine the sorting sequence, configure the graphic element for the title line:

  1. Select the Graphics files for the Display style property
  2. Link the Sort ascending and Sort descending properties with a graphics file
  3. The selected graphic for the respective sorting direction is displayed in Runtime for the sorting of relevant columns
  4. Clicking on the graphic changes the sorting sequence
  5. Clicking on the column title activates the column for sorting

Note: In the case of sorting according to time stamp, entries with the same time stamp are also sorted according to the time of creation.

Operating the header in Runtime

You can make it possible for users to operate the header in Runtime. With this an individual customization of the look is possible in the Runtime:

  • Moving columns
  • Change size
  • Changing sorting.

To do this, navigate to Chronological Event List group in the settings and select, in the Header CEL property, Operable headers. Alternatively, you can also switch the header to inoperable or invisible here.

These settings apply for all headers in the project.

info Information

You can prevent the operability and the visibility of the header for each screen of type Chronological Event List by deactivating property Show header or Make header editable for the tabular view.

Preview

By activating the Extended graphical settings property in the Editor, the header and scroll bars can be previewed. This way, details such as color fill effects, light effects or grids can be configured more easily.

Attention: As the size of the scroll bars equals their size in the Runtime, the total size of the list in the Editor can vary from the size in the Runtime. This is also true for the size of the header and the font of the header.


Create a screen of the type CEL Filter

Manual -> Chronological Event List (CEL) -> Engineer CEL -> Create a screen of the type CEL Filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

It is possible to adjust filter settings for the Chronological Event List in Runtime with the help of the Chronological Event List Filter screen. Only the filter elements that are actually required are configured and provided to the user The appearance can also be freely defined and thus adapted to different end devices. All filter settings that are also available in the filter for the function to switch the screen to the Chronological Event List screen can be configured.

Therefore:

  • Only the filter elements that are actually required are configured and provided to the user
  • The user only has these filters displayed and has an overview
  • The appearance can be freely defined and can, for example, ensure ease of use by means of a touch screen.

For details of use in the Runtime, see Using the CEL Filter chapter.

For the definition of filter criteria, see Filter screen switch CEL Filter chapter.

attention Attention

Screens of type Alarm Message List Filter, Chronological Event List Filter and Time Filter must be engineered with an own frame. If they use the same frame as other screens, all screens based on this frame are closed when the screen is closed.

Create a screen of type Chronological Event List Filter

To create a screen of type Chronological Event List Filter:

  1. Select, in the toolbar or in the context menu of the Screens node, the New Screen command
  2. An standard empty screen is opened
  3. Change the screen type in the detail view; to do this:
    1. click on Standard in the Screen type column
    2. select Chronological Event List Filter from the drop-down list
  4. select your own frame
    (CEL filter cannot be based on the same frame as other screens)
  5. Click in the screen.
  6. Select the Control elements menu item in the menu bar
  7. Click on Add template in the drop-down list
  8. The dialog for selecting a template is opened
  9. select the desired template
  10. Select additional elements as required and insert them into the desired place on the screen
  11. Name the screen according to the selected filter
    To do this:
    1. Click on the screen name in the detail view in the name column
    2. Select a suitable pre-defined name from the drop-down list it give it a name of your own
  12. Create a screen switch function in order to be able to call up the screen in Runtime


Control elements

Manual -> Chronological Event List (CEL) -> Engineer CEL -> Create a screen of the type CEL Filter -> Control elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The screen of type Chronological Event List Filter can contain the following control and display elements.

Element

Description

Insert template

Opens the dialog for selecting a template for the screen type.

Templates are shipped together with zenon and can also be created by the user.

Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.

You can read more about templates for this screen type in the Templates chapter.

General filters

Drop-down list of different general filters.

Always display system messages in list

Shows a checkbox in Runtime to display or filter system messages. System messages are messages that do not relate to a variable.

Operation in Runtime:

  • Active: System messages are always displayed in Runtime. This also applies if they are to be filtered out by the text or variable filter.
    Exception: However system messages are not shown despite the checkbox being activated if they are filtered out by the time filter or the filters for data origin (ring buffer or historic data).

Example: Only messages with the text "XY" are to be displayed. However if the option is active, system messages that do not contain the term are also displayed.

Insert all elements: General filters

Inserts all elements from the area of general filters into pre-defined places. Elements can be arranged individually.

Variable filter

Alarms of which variables are displayed:
  • Variable name

Filter according to names of variables.
  • Identification

Filter according to identification of variables.
  • Case sensitive

Note capitalization when filtering the variables.

Origin of the data

Where does the data come from:
  • Ringbuffer

From the ring buffer.
  • Historical data

From an archive.
  • Text: Max. number:

Text for Maximum number input field

  • Input field: Max. number:

Input of the maximum alarms to be displayed when historical alarms are displayed.

0: displays all

Runtime settings

  • Show list without refresh

Switches the AML in stopped state. New alarms are not added.
  • Show relative times

Switches between the normal display and the relative-time display without the entries losing focus.

Relative time: All entries are displayed in the time distance to the selected entry.

The displayed time is the difference time passed since the selected entry. The selected entry automatically gets the time stamp 0. The other events have a:

  • positive time difference to the selected entry if they occurred later
  • negative time difference to the selected entry if they occurred earlier

Alarm/event groups/alarm/event classes/alarm areas

List field for grouped display:
  • Alarm/event groups

Alarm/event groups
  • Alarm/event classes

Alarm/event classes
  • Alarm areas

Alarm areas

Time filter

Drop-down list of different time filters.

Insert all elements

Opens drop-down list to select pre-defined elements for certain time periods.

Absolute period of time: classic display

Elements for the absolute time period in classic display.

Absolute period of time: compact display

Elements for the absolute time period in compact display.

Relative period of time

Elements for the relative time period.

Starting from HH:MM:SS

Elements for a time period from a defined time.

Starting from day - HH:MM:SS

Elements for a time period from a defined day at a defined time.

Starting from day, month - HH:MM:SS

Elements for a time period from a defined day in a defined month at a defined time.

Time period: 15/30/60 minutes

Elements for a time period of 15, 30 or 60 minutes.

Time period: one day

Elements for a time period of one day.

Time period: 1 or 2 weeks

Elements for a time period over one or two weeks.

Each week can be selected, both for the view for a week as as well as for the view for two weeks. With the two-week view, a time period of 14 days is selected, depending on the week selected.

Time period: one month

Elements for a time period of one month.

Time period: one year

Elements for a time period of one year.

Insert all elements (Touch)

Opens the drop-down list to select pre-defined elements for certain time periods, which have been optimized for touch operation. Like Insert all elements, the following are available:

  • Absolute period of time: classic display
  • Relative period of time
  • Starting from HH:MM:SS
  • Starting from day - HH:MM:SS
  • Starting from day, month - HH:MM:SS
  • Time period: 15/30/60 minutes
  • Time period: one day
  • Time period: 1 or 2 weeks
  • Time period: one month
  • Time period: one year

Time filter type (label)

Labeling for time filter type.

Time filter type (combobox)

Combobox: Time filter type

Time filter type (display)

Field for time filter type display.

Time filter type (radio group)

Radio buttons that show or hide certain elements in Runtime:

  • No filter
  • Absolute time filter
  • Relative time filter
  • Starting from HH:MM:SS
  • Starting from day - HH:MM:SS
  • Starting from day, month - HH:MM:SS
  • Time period 15 minutes
  • Time period 30 minutes
  • Time period 60 minutes
  • Time period 1 day
  • Time period 1 week
  • Time period 2 weeks
  • Time period 1 month
  • Time period 1 year

Time from

Fields and labeling for stating "from" time.

  • From year (label)
  • From year (combobox)
  • From month (label)
  • From month (combobox)
  • From day (label)
  • From day (combobox)
  • From hour (label)
  • From hour (combobox)
  • From minute (label)
  • From minute (combobox)
  • From second (label)
  • From second (combobox)
  • From (spin control)

Time to

Fields and labeling for stating "to" time.

  • To year (label)
  • To year (combobox)
  • To month (label)
  • To month (combobox)
  • To day (label)
  • To day (combobox)
  • To hour (label)
  • To hour (combobox)
  • To minute (label)
  • To minute (combobox)
  • To second (label)
  • To second (combobox)
  • To (spin control)

Time from (Touch)

Fields and labeling for stating "from" time, optimized for touch operation.

  • From year (label)
  • From year (combobox)
  • From month (label)
  • From month (combobox)
  • From day (label)
  • From day (combobox)
  • From hour (label)
  • From hour (combobox)
  • From minute (label)
  • From minute (combobox)
  • From second (label)
  • From second (combobox)
  • From (spin control)

Time to (Touch)

Fields and labeling for stating "to" time, optimized for touch operation.

  • To year (label)
  • To year (combobox)
  • To month (label)
  • To month (combobox)
  • To day (label)
  • To day (combobox)
  • To hour (label)
  • To hour (combobox)
  • To minute (label)
  • To minute (combobox)
  • To second (label)
  • To second (combobox)
  • To (spin control)

Filter absolute time

Fields and labeling for stating absolute time filter.

  • From (label)
  • From date (calendar display)
  • From date (date display)
  • From time (time display)
  • To (label)
  • To date (calendar display)
  • To date (date display)
  • To time (time display)

Time period

Fields and labeling for stating time periods.

  • From year (label)
  • From year (combobox)
  • From month (label)
  • From month (combobox)
  • Week (label)
  • Week (combobox)
  • From day (label)
  • From day (combobox)
  • Start time (label)
  • Start time (combobox)

Time period (Touch)

Fields and labeling for stating "from" time, optimized for touch operation.

  • From year (label)
  • From year (up)
  • From year (touchbox)
  • From year (down)
  • From month (label)
  • From month (up)
  • From month (touchbox)
  • From month (down)
  • Week (label)
  • Week (up)
  • Week (touchbox)
  • Week (down)
  • From day (label)
  • From day (up)
  • From day (touchbox)
  • Button: From day (down)
  • Start time (label)
  • Start time (up)
  • Start time (touchbox)
  • Start time button (down)

Lots

Elements for lot selection in Runtime.

Archive list

List of archives available in Runtime.

Archive list status

Status of the archive list with number for:

  • available
  • filtered
  • displayed

Lot list

List of available lots.

Lot list status

Status of the lot list with number for:

  • available
  • filtered
  • displayed

Apply time filter to lot list.

Applies the configured time filter to the selection in the lot list.

Lot name filter (Input field)

Entry of a character sequence for filtering the lot names in the lot list.

Lot name filter (Button)

Button to execute filtering for lot names.

Text filter

Drop-down list of different text filters.

Insert all elements: Text filter

Inserts all elements for text filters.

No text filter

Radio button to deselect text filter.

Search for (separate words by Space)

Radio button to activate the search

Text: Search text

Labeling for search field.

Input field: Search text

Field for input of search term.

Options

Search options
  • Case sensitive

Capitalization must be noted.
  • Words do not need to be in the text completely

Fragments can also be searched for.
  • At least one word must be in the text

At least one search term from several must be in the result.
  • All words must be in the text

All search terms must be included in the result.
  • Exact filter text must be in the text

Exact text from the input field must be contained in the result.

OK | Button: Applies the filter settings and closes the screen. Note on faceplates: In faceplates, AML filter, CEL filter and time/lot filter screens can be used. When configuring these in Runtime, clicking on OK closes the complete faceplate. If the filter settings are to be saved and the faceplate is to stay open, click on Accept.
Cancel | Button: Cancels the configuration of the filter settings.
Apply | Button: Accepts the filter settings.
Refresh search | Button: Updates the filtered display.


Template

Manual -> Chronological Event List (CEL) -> Engineer CEL -> Create a screen of the type CEL Filter -> Template

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Template | Description
List field templates (left) | Displays all pre-defined and user-defined template.
Preview and description (right) | Shows preview and description of the selected template.
Standard | Inserts standard elements.
Scada | Special templates, optimized for mouse operation.
Standard | Inserts standard elements.
Filters for variables, text & time (absolute - compact) | Adds elements for filtering for variables, text and absolute time range in compact form.
Filters for variables, text & time (absolute) | Adds elements for filtering for variables, text and absolute time range.
Filters for variables, text & time (from month) | Adds variables for filtering for variables, text and relative time range from month.
Filters for variables, text & time (from hour) | Adds variables for filtering for variables, text and relative time range from hour.
Filters for variables, text & time (from day) | Adds variables for filtering for variables, text and relative time range from day.
Filters for variables, text & time (absolute - table) | Adds elements for filtering for variables, text and absolute time range.
Filters for variables, text & time (type can be selected) | Adds elements for filtering for variables, text and selectable time range.

Close dialog

Parameters | Description
Delete existing screen elements | Active: Already existing elements in the screen are deleted when taking over the template.
Apply | Inserts the elements of the selected template in the screen and closes the dialog.
Cancel | Closes dialog without inserting elements.
Help | Opens online help.


Pre-defined names

Manual -> Chronological Event List (CEL) -> Engineer CEL -> Create a screen of the type CEL Filter -> Pre-defined names

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Pre-defined names are available for time filters.

Attention: The pre-defined names are not available under Windows CE.

To select a name:

  1. In the detail view, define as a time filter, chronological event list filter or alarm message list filter
  2. Click twice in the name field in the 'Name' column
  3. Select the desired pre-defined name from the drop-down.
    • CEL_Filter
    • TIMEFILTER_ABSOLUTE
    • TIMEFILTER_DAY
    • TIMEFILTER_HOUR
    • TIMEFILTER_MONTH
    • TIMEFILTER_PERIOD
    • TIMEFILTER_PERIOD_DAY
    • TIMEFILTER_PERIOD_MINUTE
    • TIMEFILTER_PERIOD_MONTH
    • TIMEFILTER_PERIOD_WEEK
    • TIMEFILTER_PERIOD_YEAR
    • TIMEFILTER_RELATIVE


Filter screens

Manual -> Chronological Event List (CEL) -> Engineer CEL -> Create a screen of the type CEL Filter -> Filter screens

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Filter screens

Filter screens make it possible to transfer a preset filter from one screen to another. The filter of the source screen is set using the target screen. The screens can also be of a different screen type.

attention Attention

In order for the time to be taken from the screen to be called up in Runtime, the following time range must be selected in the Editor for the screen switching function for the Alarm Message List or the Chronological Event List in the time filter: Set filter at time filter type

Call definition

The following requirements must be met for the set filters to be used:

  1. Set filter for time filter type is selected as a time period for the time filter.
  2. The screen (Alarm Message List Filter, Chronological Event List filter or Time/Lot Filter screen) is activated using a button or a combined element. Only in this way can the relationship between filter screen and source screen be maintained.
  3. The source screen and filter screen must be configured on different frames or monitors. The filter for the filter screen can only be updated if the source screen is open. This is only possible if both screens do not use the same frame or the same monitor.
  4. The screen to be called up must be compatible with the filter screen to be called up (see table).
Source screen | AML filter | CEL filter | Time filter
Archive revision | T | T | T
Extended Trend | T | T | T
Time filter | T | T | X
Alarm Message List Filter | X | C | T
Chronological Event List Filter | C | X | T
Alarm Message List | X | C | T
Chronological Event List | C | X | T

Key:

  • C: Common settings are updated.
  • T: Time settings are updated.
  • X: All settings are updated.

info Information

No filtering

The filter screen is not filtered, but opened with the configured values, if:

  • One of the conditions 1 to 3 is not met or
  • The Screen to call up setting is not activated for the Screen switching function or
  • The screen is not called up via a screen element

In this case, the Accept, Close and Update buttons are grayed out in Runtime and have no function.


Define events for CEL

Manual -> Chronological Event List (CEL) -> Engineer CEL -> Define events for CEL

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Which events are logged in the Chronological Event List is defined via:

  1. Properties of group Logging in node Chronological Event List in the project settings
    • Delete alarms
    • Alarm acknowledgement
    • Function Set SV
    • Send recipes
    • Change recipes
    • Archive data
    • Archive evacuation [h]
  2. Properties of the variables
    • AML/CEL in group Limits
    • Group Logging in CEL in node Write set value

Log set value changes

Set value changes are possible via different mechanisms. These are logged in the CEL according to the settings and the module.

Parameters

Description

Logging of set value write set value

You can define the logging of set value changes for every variable. For this the following options are available at property Logging in group Write set value:

All: All changes via dynamic elements and function Write set value are logged.

Nothing: Changes are not logged.
Only via dynamic elements: Logs only write set value via dynamic elements but not via function Write set value.

Old and new value

With property Old and new value you define whether only new or also old values are written in the protocol.

This property affects write set value via:

  • dynamic element
  • function Write set value
  • Write set value via VBA

Write set value via VBA

If function Setting values with VBA is activated, set value changes via VBA are logged in the CEL.

Standard recipes and Recipegroup Manager

For the standard recipes and the recipegroup manager the logging is controlled via the properties of group Logging in node Chronological Event List.

PFS/Scheduler

The Production & Facility Scheduler and the Scheduler log all set value changes in the CEL. This setting cannot be changed.

Note: Only new value is logged. Property Chronological Event List is not considered.


Check write set value

Manual -> Chronological Event List (CEL) -> Engineer CEL -> Define events for CEL -> Check write set value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When writing values, the value receives a status bit that is has been written. If the writting process is successful, the corresponding status bit is set:

  • WR-ACK

    The driver received a value for writing.

  • WR-SUC

    Value 1: Writing successful.

    Value 0: Writing not successful. The value could not be written.

info Information

In case of reload or Server-Standby switch, the currently active responses or writing affirmations are discarded.

This status combination are active until the next value change is triggered. Then both states are set to 0 until the writing action is finished. For evaluation the following bit combination must be requested in the reaction matrix:

WR-ACK, WR-SUC

Result:

  • WR-ACK 1, WR-SUC 1: Writing action successful.
  • WR-ACK 1, WR-SUC 0: Writing action not successful.

attention Attention

The mechanism only shows, that the writing action was successful (or not successful) to the PLC. This does not mean, that the value has indeed been changed in the PLC, since the PLC can reset/overwrite the value immediately. (For example for writing the outputs or the transient bits which are only set for a short time.)

Modules

This mechanism can be used in the following modules:

  • function Write set value: Activate option Wait for writing confirmation in the configuration dialog of the function.
  • Standard recipes: Activate property Write synchronously.
  • Recipegroup Manager: Activate property Write synchronously.
  • Command Processing

Entry in CEL

  • Function Write set value

    For the entry in the CEL you must activate property Function Set SV in node Chronological Event List in the project settings. After this the positive or negative response the execution of the function is written to the CEL.

  • Standard recipes and Recipegroup Manager

    For the entry in the CEL a system driver variable is used which is set to 1 when a recipe is written successfully. A global variable is evaluated on the Server, a local variable on every Client in order to determine when the recipe executed last was written completely.
    With this variables a CEL entry can be created via limit or reaction matrix. The query is carried out via a multi analog or a multi binary reaction matrix.


Length static limit text CEL

Manual -> Chronological Event List (CEL) -> Engineer CEL -> Define events for CEL -> Length static limit text CEL

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Via property Length static limit texts CEL you define how many characters may be used for the message text in the CEL. For each CEL file the allowed number of characters of the message texts is saved in the header. The change of this property take effect when a new CEL file is created.

Note: With dBase export the length is restricted to 254 characters.

CEL.BIN and network

In file CEL.BIN message texts are saved as variables with variable length and are transferred as such in the network. This means that CEL entries from the ring buffer are not limited in the length independent of property Length static limit texts CEL.


CEL engineering via filter

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can engineer the display of the events in the Runtime via filters. For this you have several possibilities:

  1. Define information which is displayed in the CEL in the Runtime:
    With this you define what information is displayed together with an event.
    For details see: Column settings for Chronological Event List
  2. Filter event for CEL at call up and modify in the Runtime:
    With this you define filter and give the operator at the machine the possibility to create own filters.
    For details see: Filters for screen switch CEL.
  3. Fixed filters for the Runtime:
    With this you create filters which are tailor-made for the actual use and hide unnecessary filter criteria.
    For details see: Filters for screen switch CEL filter.


Column settings for Chronological Event List

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Column settings for Chronological Event List

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You define the information that is displayed and also exported in the CEL in Runtime in the column settings. You configure these in the properties of the Chronological Event List in the project:

  1. Open the Chronological Event List node in project settings.
  2. Click on the Column settings CEL property.
  3. The dialog for the column setting is opened.
  4. Configure the desired columns.
    Note: When configuring the screen switching, this configuration is accepted by default and can be individually adapted in the column settings tab.
  5. Note: For calculating the column width the average character width of the selected font is used.

info Information

In project settings, you can set a default setting for the sequence and size of columns using the Column settings AML property or the Column settings CEL property. If you create a new screen switching function from an Alarm Message List screen or Chronological Event List screen, this setting is used as a default and can be amended in the corresponding tab. The setting is stored in the project.ini file.

Column configuration

Parameters

Description

Columns

In the list field of this tab all available column types are displayed.

You can change the sequence of column types by dragging & dropping in the list field:

  • Click in the Column type column
  • Move the individual entries as desired

Alternatively, you can adjust the sequence with the Move selected entry up and Move selected entry down.
  • Checkbox:

Select which column types are displayed.
  • Description:

Free text entry for a description of the column.

Change description: left-click on the corresponding area. Enter the desired value in the editing field.

Note: for column descriptions, zenon language switching is available.
  • Column width:

Defines the width of the column in characters.

Change column width: left-click on the corresponding area. Enter the desired value in the editing field.
-1 Width is calculated in Runtime using average character width

Note: For compatibility reasons, the columns with widths that could not be changed in earlier zenon versions (date and time), have the value -1.

  • Display:

For column types

  • Alarm/event class symbol
  • Alarm/event group symbol
  • Alarm status

Actual form of display can be selected in Runtime. Select the desired form from the drop-down list.

Move selected entry up

Moves selected entry up one place.

Move selected entry down

Moves selected entry down one place.

Preview field

Displays the columns defined in the list field in the width displayed there.

You can also adjust the column widths here by left clicking on the right end of a column, holding down the mouse button and moving the mouse to the left or right accordingly.

Table settings

Sort descending

Sorts the entries in the list according to the Time received column in decreasing order. These setting apply for showing a screen.
You can change the sorting order in Runtime by clicking on the column header. The sorting sequence currently being used is shown by an arrow on the column header.

Display grid

shows a grid when the list is displayed in Runtime.

Use alternating background colors

Uses line color 1 and line color 2 alternately as background colors for the list in Runtime.

Row color 1

Color that is used as a background color in in the list Runtime for all uneven numbers (1, 3, 5 etc.), if you have activated Alternating Background Colors.

Row color 2

Color that is used as a background color in in the list Runtime for all even numbers (2, 4, 6 etc.), if you have activated Alternating Background Colors.

Display in the time columns

Time

Displays the time for a list entry in the following form: HH:MM:SS

Date

Displays the date for a list entry in the following form: TT:MM:YYYY

Milliseconds

Expands the time entry by milliseconds.

Note: Must be activated if milliseconds are to be provided in exports or print-outs.

Hint: If you activate the automatic keyboard in Runtime, it is turned on when an editing field appears. You can also use this to configure the columns if you are using a computer without a keyboard.

attention Attention

The column width is given in characters and is dependent on the font used. If the column width is not a multiple of the character width of the used font, the actual column width can differ from the set column width. This can result in the text being cut of or an empty space being created.

Solution: Use proportional fonts, such as 'Courier New', for example.


Filters for screen switch CEL

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With filters you define which events should be displayed in the Runtime and which should be hidden. Filters can be defined in the editor and - depending on the requirements in the Editor - in Runtime.

To tailer the filter selection in the Runtime to the needs of the operator, use screen of type Chronological Event List Filter instead of Chronological Event List.

To create a screen switch to a screen of type Chronological Event List:

  1. engineer a function screen switch to a screen of type Chronological Event List
  2. the filter dialog is opened and offers several tabs with filter criteria:
    • General
    • Time
    • Lots
    • Column settings
    • Text
    • Status
    • Project (only available in the integration project of the multi-project administration.)
    • Equipment Modeling

If linked variables or indexes are available, the following tabs can be displayed as an option.

  • Replace links
  • Replace indices

For details see in chapter Screens sections Replace links of variables and functions and symbols.


General

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL -> General

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the general filter you define which events are displayed and what kind of access you have to the settings in the Runtime. To this you differentiate events according to:

  • Type
  • Origin of the data
  • Variables
  • Alarm/event groups, classes and alarm areas

The following properties are available:

Variable filter

Parameters

Description

Variable filter

Restrictions to events of certain variables

Variable name

Enter the name or part of the name of the variable you want to filter.

Use of the wild card * is possible. Wildcards are only permitted as a prefix or suffix; e.g. *xxx or xxx*.

Note: Filter terms entered in Runtime or in the Editor are automatically saved on the local computer in zenon6.ini and are available for selection in the drop-down list.

Identification

Enter the identification or part of the identification of the variables you want to filter. Wild card * is possible.

Use of the wild card * is possible. Wildcards are only permitted as a prefix or suffix; e.g. *xxx or xxx*.

Note: Filter terms entered in Runtime or in the Editor are automatically saved on the local computer in zenon6.ini and are available for selection in the drop-down list.

Case sensitive

Active: Capitalization is recognized when filtering for variable name and/or identification.

Runtime settings

Parameters

Description

Runtime settings

Behavior of the CEL in the Runtime

Show list without refresh

Active: As long as the list is displayed no new entries are added.

(Not available for function Export CEL.)

Display relative time

All entries are displayed in the time distance to the selected entry.

The displayed time is the difference time passed since the selected entry. The selected entry automatically gets the time stamp 0. The other events have a:

  • positive time difference to the selected entry if they occurred later
  • negative time difference to the selected entry if they occurred earlier

Show this dialog in the Runtime

Active: Before every call of the screen the filter dialog is opened. The filter settings can be modified. This option is not available with Windows CE.
Note: If, in the Lots tab, the Show lot selection dialog option is also selected, then the lot selection dialog is called up in Runtime. This is no longer displayed after reloading.

Notes for time range filters:

Show this dialog in the Runtimeactive:

  • The filter is opened in Runtime in screen switching. The filter is no longer offered on reloading. This behavior can differ for individual screen types if the dialog was displayed in screen switching and canceled.
  • The last-concluded time period is always used.

Show this dialog in the Runtimenot active:

  • Use last finished time rangeactive: The last-concluded time period is used
  • Use last finished time rangenot active: The current time period is used.

Replace dialog in Runtime with screen

Definition of a screen that is to be switched in Runtime instead of the dialog if the Offer this dialog in Runtime option is active. Only screens of the type CEL Filter or Time filter will be offered.

Click the ... button and a dialog opens to select a screen.

If the linked screen is not found in Runtime, a search is made for corresponding screens with specific names.

Origin of the data

Display current or current and historical events.

Ringbuffer

Active: Only data from the ring buffer are displayed.

Historical data
Maximum number

Active: Data from the ring buffer and historical data from the CEL are displayed.

The maximum number of the data which should be displayed includes the data from the ring buffer.

Alarm/event groups/classes and alarm areas

Parameters | Description
Alarm/event groups/classes, alarm areas | Selection of groups, classes and alarm area.
Alarm/event groups | From the existing alarm/event groups select the one from which alarms should be displayed.
Alarm/event classes | From the existing alarm/event classes select the one from which alarms should be displayed.
Alarm areas | From the existing alarm areas select the one from which alarms should be displayed.

Filter for system messages

Parameters

Description

Filter for system messages

Filter settings for system messages. System messages are messages that do not relate to a variable.

Exclude system messages from filter

Setting for the display of system messages regardless of the filter settings.

  • Active: System messages are always displayed in Runtime. This also applies if they are to be filtered out by the text or variable filter.
    Exception: However system messages are not shown despite the checkbox being activated if they are filtered out by the time filter or the filters for data origin (ring buffer or historic data).

Example: Only messages with the text "XY" are to be displayed. However if the option is active, system messages that do not contain the term are also displayed.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

attention Attention

Concerns zenon under Windows CE: CE systems on which the filter dialog should be displayed must have a screen resolution higher than 800*600 pixel for the dialog to be displayed completely.


Time

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Time filters make it possible to limit the data to be displayed or exported. The time filters are very flexible to implement and can be pre-set in the editor or adjusted in Runtime.

Note: Time is saved in UTC. For details see chapter Handling of date and time in chapter Runtime.

Time filters can be pre-set in both the Editor and in Runtime for:

  • Absolute period of time
  • Relative period of time
  • From
  • Time period

Time filtering can be carried out in two ways:

  1. Define time period in the Editor
    Fixed time areas are used. A time period is given in the editor. It is only possible to filter according to this time period in Runtime. Other filters - such as filtering according to variable name, alarm/event groups and alarm/event classes etc. can no longer be amended in Runtime.
  2. Time filter amendable in Runtime
    Pre-defined times are used. The time filter is defined in the Editor and can be changed in Runtime as desired.

Time filter

Filter

Selection of the filter.

Parameters

Description

No time filter

Active: No time filter is used.

Note: all Runtime entries since 1. 1. 1990 are displayed.

Absolute filter

Active: A fixed period of time is entered in the editor. When the function is executed, the defined absolute time period is exactly used.

In the settings section, the corresponding options can be shown and configured there.

Note: Time is saved in UTC. For details see chapter Handling of date and time in chapter Runtime.

Relative period of time

Active: A relative time period is entered.

In the settings section, the corresponding options can be shown and configured there.

Attention: this filter is constantly updated.

From

Active: A time from which the filter is effective is stated. If the time is not reached on the current day, filtering takes place from the corresponding time the previous day.

Selection of the area mode from drop-down list:

  • From HH:MM:SS o'clock
  • From day - HH:MM:SS o'clock
  • Starting on day, month at HH:MM:SS

In the settings section, the corresponding options can be shown and configured there.

Attention: The start point of this filter is not updated automatically. Only the existing times are used when shown.
The end time point is not defined with this filter, it is carried over.

Time period

Active: A fixed time period is entered. Selection of the area mode from drop-down list:

  • One day
  • One week
  • Two weeks
  • One month
  • One Year
  • 15 minutes
  • 30 minutes
  • 60 minutes

In the settings section, the corresponding options can be shown and configured there.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Absolute period of time

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL -> Time -> Absolute period of time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Absolute period of time

You define a fixed time period with the absolute filter. When the function is executed, the defined absolute time period is exactly used. To set the filter:

  1. Select, in the Filter section, the Absolute time period option
  2. Configure the desired time in the Settings section

Parameters | Description
Settings | Configuration of the time filter.
Propose current date/time | Active: Time filter is displayed in Runtime.
Preset | Active: The time filter is prescribed in the Editor. Only the start time can still be configured in Runtime.
From | Start time of the filter. Selection of day, month, year, hour, minute and second
To | End time of the filter. Selection of day, month, year, hour, minute and second

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Relative period of time

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL -> Time -> Relative period of time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Relative period of time

A relative time period is entered.

Attention: This filter is updated constantly and continues to run.
Example: You set a relative time of 10 minutes and switch to a screen with this time filter at 12:00. You are then shown the data from 11:50 to 12:00 when switching. If the screen stays open, the filter is automatically updated. At 12:01, you see the data from 11:51 - 12:01 etc.

To set the filter:

  1. Select, in the Filter section, the Relative period of time option
  2. Configure the desired time in the Settings section

Parameters | Description
Settings | Configuration of the time filter.
Propose current date/time | Active: Time filter is displayed in Runtime.
Preset | Active: The time filter is prescribed in the Editor. Only the start time can still be configured in Runtime. Selection of the relative time period in days, hours, minutes and seconds.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


From

From

A time from which the filter is effective is defined. To set the filter:

  1. Select, in the Filter section, the Off option
  2. Select the desired filter from the drop-down list.
    • From HH:MM:SS o'clock
    • From day - HH:MM:SS o'clock
    • Starting on day, month at HH:MM:SS
  3. Configure the desired time in the Settings section

Parameters

Description

Settings

Configuration of the time filter.

[Date/Time]

Depending on the settings of the Off option, the time from which the filter is effective is configured here:

  • Starting from HH:MM:SS
  • Starting from day - HH:MM:SS
  • Starting from day, month - HH:MM:SS

Warning! The start point of this filter is not updated automatically. Only the existing times are used when shown, even if the screen remains open and 23:00:00 is reached.
The end time point is not defined with this filter, it is carried over.
  • Starting from HH:MM:SS

A time from which the filter is effective is stated. If the time is not reached on the current day, filtering takes place from the corresponding time the previous day.

Example: You enter 23:00:00. If it is then 23:30 when executing the function, then it is filtered from 23:00:00 up to the current point in time. If it is 22:30 however, then filtering takes place from 23:00:00 on the previous day to the current point in time.
  • Starting from day - HH:MM:SS

A day and time for the start of the filter are entered. If the time given has not been reached in the current month, the corresponding time from the previous month is used.

Example: You enter day 5 - 23:00:00. If it is the 10th of the month at 23:30, then filtering takes place from the 5th of the month from 23:00:00 to the current time point. If, however, it is the 4th of the month, then filtering takes place from the 5th of the previous month to the current time point.

  • Starting from day, month - HH:MM:SS

A month, day and time for the start of the filter are entered. If the time stated has not been reached in the current year, the corresponding time from the previous year is used.

Example: You enter Day 5, Month October - 23:00:00. If it is October 10th at 23:30, then filtering takes place from October 5th from 23:00:00 to the current time point. If, however, it is only October 4th, then filtering takes place from the 5th of the previous year to the current time point.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Time period

Time period

A time period in which the filter is effective is defined. To set the filter:

  1. Select, in the Filter section, the Time period option
  2. Configure the desired time in the Settings section

Parameters

Description

Settings

Configuration of the time filter.

Time period

Selection of a time range from a drop-down list.

Filtering for this time range is carried out in Runtime. The filter relates to the time of screen switching.
For example: The value 60 minutes shows all archives of the last hour.

If this dialog is offered in Runtime, the start time of the time range can be selected.

Modify time period

Allows amendments to cycles, postponements and extensions of time periods.

Active: Evaluation is carried out in accordance with the following rules:

  • First, the Use last finished time period option is evaluated.
  • After this, Change time period by is used.
  • Move time period to the future by is then applied.

Inactive: No changes to the time period are made.

Attention: With version 7.10, filter actions on the basis of this function led to different results than those in the versions before.

Move time period to the future by

Active: The time period defined in the filter is postponed to the future. Given in hours - minutes - seconds.

If a postponement that is the same or greater than the selected time period is set, a note to check the configuration is displayed.

Change period of time by

Active: The time period defined in the filter is modified. Given in hours - minutes - seconds.

If a change and a postponement that are the same or greater than the selected time period is set, a note to check the configuration is displayed.

Add time

Active: The time stated in Change time period by is added to the time defined in the Time range option.

Deduct time

Active: The time stated in Change time period by is deducted from the time defined in the Time range option.

Use last finished time period

Active: The last finished time period is used.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Specify time period in the Editor

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL -> Time -> Specify time period in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Specify time period in the Editor

With this method, you enter a fixed time period into the editor, which is applied when the function is carried out in Runtime. You can then only define the start time in Runtime, but no further filter settings.

For example: You set a 30 minute time filter. In Runtime, you can now only set when this 30 minute time period is to start. However, you cannot change the filter to a day filter.

attention Attention

When using this type of filter, you can also no longer amend all other filters in Runtime that are available in the General tab. It is still possible to filter for text, status and equipment.

To create the filter:

  1. The screen must have the Filter button to start the filter in Runtime
  2. select the desired filter
  3. Configure the selected time period

Tip for time period: Activate the Offer this dialog in Runtime option in the filter dialog. This way you can amend the start time before the function is carried out. Do not have the filter displayed in Runtime when the function is turned on; this way the current time period is always used. If you have activated the Use last closed time period option, the previous time period is shown.
For example: You have set a 30 minute filter. It is 10.45 when the function is activated. If the Use last closed time period option is deactivated, the filter is set to the current time period 10:30:00 to 10:59:59. If the option is activated, the filter is set to the previous time period of 10:00:00 to 10:29:59.


Time filter can be configured in Runtime

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL -> Time -> Time filter can be configured in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Time filter can be configured in Runtime

With this method, you stipulate a time filter in the Editor. This can be amended in Runtime before execution. To create the filter:

  1. The screen must have Filter and Display filter buttons
  2. select the desired filter:
    • Absolute period of time
    • Relative period of time
  3. Select, in the Settings section, the option Propose current date/time
  4. The filter dialog is opened in Runtime with the current date and time


Lots

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL -> Lots

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You configure the limitation of the display to certain lots in this tab.

The lot information is also applied to the existing CEL filter. If the lot filter is activated, a list of all configured lots that correspond to the configured time period is obtained from the archive server in Runtime in advance when the CEL is loaded.

Attention: All variables and archives that belong to an item of equipment and the lot archive must be linked to the same equipment in the equipment model.

Filter

Settings for the application of the lot filter. Selection of one of the options:

  • No lot filter
  • Apply lot filter directly
  • Display lot selection dialog

Parameters

Description

No lot filter

Active: The lot filter is deactivated and cannot be configured. Filtering for lots is not carried out in Runtime.

Apply lot filter directly

Active: The filter configured here is applied in Runtime directly.

Display lot selection dialog

Active: The dialog for lot selection is shown in Runtime when:

  • Clicking on Filter or
  • screen switching, if the Offer this dialog in Runtime option has been activated (not available for each function/screen type)
    Note: The dialog is not shown on reloading.

Options can be pre-selected in the Editor.

Replace dialog in Runtime with screen

Not available if the Show lot selection dialog option has been selected.

Definition of a screen that is to be called up in Runtime instead of the lot selection dialog. Only time/lot filter screens are offered.

Click the ... button and the dialog opens to select a screen.

If the linked screen is not found in Runtime, a search is made for corresponding screens with specific names.

Relative lot selection

Only available for Extended Trend and faceplates and only if the option Display lot selection dialog has been activated. The Windows CE project property must be deactivated in the project properties.

  • Active: Enables several lots to be compared directly. Display always starts from the zero point.

Time

Configuration of the time filter for lot selection. Selection of one of the options:

  • No filter
  • Last lots
  • Use time filter from "Time" tab

Parameters

Description

No filter

Active: The time range set in the Time tab is not taken into account. All completed and current lots are displayed.

Last lots

Active: Input of the number of lots last concluded, according to what they should be filtered for. Input of the number in the number field or configuration via cursor keys.

The option allows the combination of both options Display current lots and Display completed lots.
Example: 3 lots are to be displayed, 2 are running and 10 have been completed. The following is shown: the two that are current and one that has been completed.

Attention: At least one of the two options Display current lots or Display completed lots must be activated. If both options have been deactivated, this corresponds to the No filter setting.

Note on compatibility: If the current lots or the combination of current and completed lots are selected and the project is compiled for a version before 7.11, the completed lots are shown in Runtime.

Display current lots

Active: The current lots are displayed.

Note: If the number of lots to be displayed is greater than the number of current lots, lots that have been completed are also shown until the set limit has been reached.
Example: 3 lots are to be displayed. 1 lot is running, 5 have been completed. The one current lot and two completed lots are displayed.

Display completed lots

Active: The completed lots are displayed.

Note: If the number of lots to be displayed is greater than the number of completed lots, lots that have been completed are also shown until the set limit has been reached.

Use time filter from "Time" tab

Active: Pre-filtering is carried out with the settings of the Time tab. The effective range of the filter can be amended within this time range. Select from drop-down list:

  • Start and end also outside filter limits: (Default)
    Lots can start before the start time configured in the Time filter and end after the configured end time.
  • Start and end only outside filter limits:
    Lots must start and end within the time points configured in the Time filter for the start and end.
  • Start also before filter limit:
    Lots can start before the start time configured in the Time filter and end after the configured end time.
  • End also after the filter limit:
    Lots can also end after the end time set in the time filter, but must start at or after the configured start time.
  • Adjust start and end to filter limits:
    Lots are cut to the time points configured in the Time filter for the start and end.

Archives

Configuration of filtering for archives. Selection of one of the options:

  • No filter
  • Static
  • From variable

Note: Only available for the following modules if the Apply lot filter directly option has been selected:

  • Archive revision
  • ETM
  • Report Generator
  • Report Viewer

Parameters

Description

No filter

Active: Filtering for archive names is not carried out.

Static

Active: Archives whose identification corresponds to the character string entered in the input field are filtered for.

Input of the archive identifications in the input field:

  • Several identifications are separated by a comma (,).
  • * or empty: All archives, no filter.

From variable

Active: The value of the variables linked here is applied as a filter for archive names in Runtime.

Click on button ... in order to open the dialog for selecting a variable.

Only available for all modules if the Apply lot filter directly option has been selected:

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.

If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for archive names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Names

Configuration of the filtering to names. Selection of one of the options:

  • No filter
  • Static
  • From variable

Parameters

Description

No filter

Active: Filtering for lot names is not carried out.

Static

Active: Lot names that correspond to the character string entered in the input field are filtered for.

Input of the lot name in the input field:

  • Several entries are separated by a pipe character (|).
  • * or empty: All lots of all displayed archives, no filter.

From variable

Active: The value of the variable linked here is applied as a filter for lot names in Runtime.

Click on the ... button to open the dialog for selecting a variable.

Not available if the option Apply lot filter directly has been selected.

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.
  • If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for lot names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Column settings

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL -> Column settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this dialog, you define which columns you want to have displayed, including the form, sequence and sorting.

Note: All settings which you make in this tab are default settings for:

  • Chronological Event List screen
  • Chronological Event List Filter screen
  • Export to CSV, dBase or XML

These default settings can be changed when defining the individual CEL functions.

info Information

In project settings, you can set a default setting for the sequence and size of columns using the Column settings AML property or the Column settings CEL property. If you create a new screen switching function from an Alarm Message List screen or Chronological Event List screen, this setting is used as a default and can be amended in the corresponding tab. The setting is stored in the project.ini file.

Columns Parameters

Description

Columns

In the list field of this tab all available column types are displayed.

You can change the sequence of column types by dragging & dropping in the list field:

  • Click in the Column type column
  • Move the individual entries as desired

Alternatively, you can adjust the sequence with the Move selected entry up and Move selected entry down.
  • Checkbox:

Select which column types are displayed.
  • Description:

Free text entry for a description of the column.

Change description: left-click on the corresponding area. Enter the desired value in the editing field.

Note: for column descriptions, zenon language switching is available.
  • Column width:

Defines the width of the column in characters.

Change column width: left-click on the corresponding area. Enter the desired value in the editing field.
-1 Width is calculated in Runtime using average character width

Note: For compatibility reasons, the columns with widths that could not be changed in earlier zenon versions (date and time), have the value -1.

  • Display:

For column types

  • Alarm/event class symbol
  • Alarm/event group symbol
  • Alarm status

Actual form of display can be selected in Runtime. Select the desired form from the drop-down list.

Move selected entry up

Moves selected entry up one place.

Move selected entry down

Moves selected entry down one place.

Preview field

Displays the columns defined in the list field in the width displayed there.

You can also adjust the column widths here by left clicking on the right end of a column, holding down the mouse button and moving the mouse to the left or right accordingly.

Table settings

Sort descending

Sorts the entries in the list according to the Time received column in decreasing order. These setting apply for showing a screen.
You can change the sorting order in Runtime by clicking on the column header. The sorting sequence currently being used is shown by an arrow on the column header.

Display grid

shows a grid when the list is displayed in Runtime.

Use alternating background colors

Uses line color 1 and line color 2 alternately as background colors for the list in Runtime.

Row color 1

Color that is used as a background color in in the list Runtime for all uneven numbers (1, 3, 5 etc.), if you have activated Alternating Background Colors.

Row color 2

Color that is used as a background color in in the list Runtime for all even numbers (2, 4, 6 etc.), if you have activated Alternating Background Colors.

Display in the time columns

Time

Displays the time for a list entry in the following form: HH:MM:SS

Date

Displays the date for a list entry in the following form: TT:MM:YYYY

Milliseconds

Expands the time entry by milliseconds.

Note: Must be activated if milliseconds are to be provided in exports or print-outs.

Hint: If you activate the automatic keyboard in Runtime, it is turned on when an editing field appears. You can also use this to configure the columns if you are using a computer without a keyboard.

attention Attention

The column width is given in characters and is dependent on the font used. If the column width is not a multiple of the character width of the used font, the actual column width can differ from the set column width. This can result in the text being cut of or an empty space being created.

Solution: Use proportional fonts, such as 'Courier New', for example.

info Information

If you engineered variables with measuring units, the measuring unit of the variable is displayed in the Chronological Event List. Prerequisite for this is that column type Unit is displayed.


Text

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL -> Text

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Filter by

Parameters | Description
Filter by |
No text filter | The text filter is not used.
Search for (words separated by spaces) | The text filter filter is used. Further options are activated.
Input field | Enter the corresponding words or character strings.

Options

Parameters | Description
Options |
Note capitalization | Active: The filtering is case-sensitive.
Words do not have to appear in the text in full | Active: Parts of words can also be taken into account during filtering.
At least one word must be in the text | Active: At least one word of the search string has to be in the text.
All words must be present in the text | Active: All words must be present in the search string. In doing so, the sequence plays no role.
Filter text must appear in the text exactly | Active: The text must be exactly as defined in the search string.


Status

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL -> Status

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The status of the checkbox indicates if the status bit is to be evaluated.

Status of checkbox | Description
Black dot | The status bit is not evaluated.
0 | Only the entries where the status bit is set to false are displayed.
1 | Only the entries where the status bit is set to true are displayed.

Example Example

If the checkbox SPONT is set to 1, only the alarms are shown that are triggered by spontaneous values are displayed.

Note: You can read details on status bits in the Status processing chapter.


Project

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL -> Project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Selection of the projects which should be considered for the CEL. The filter for selecting sub-projects is only available in the integration project of the multi-project administration.

the selection from the integration project and all sub-projects is carried out via multi-select by pressing and holding key Ctrl and mouse click on the desired projects.


Equipment Modeling

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL -> Equipment Modeling

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the filter all already existing equipment models are displayed. Via the context menu or via tool bar, you can create new models and groups.

To add groups to the filter:

  1. select the desired element
  2. Click on the Add button
  3. repeat the process until all necessary groups are available in the list
    (Multi-select is not possible)

To remove groups from the filter:

  1. Select the desired element
    (multiselect: Ctrl button or hold down the shift key and click on the desired element)
  2. click the Delete button

Element | Description
List of equipment models | provides models and groups for selection
Add | Adds selected groups to the filter list
Delete | removes selected groups from the filter list
Filter list | Shows all equipment groups that are to be filtered.
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Filters for screen switch CEL filter

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to engineer a screen of type Chronological Event List Filter:

  1. engineer a function screen switch to a screen of type Chronological Event List Filter
  2. the filter is displayed with all tabs:
    • Screens
    • General
    • Text
    • Time


Screens

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL filter -> Screens

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab, you can define the screens that are to be updated by the screen filter.

The following settings are available:

Filter is taken from the following screen

Parameters

Description

Filter is taken from the following screen

Definition of the screen form which the filter is to be taken.

Calling screen

Active: The filter settings are take over from the screen from which the filter screen is called up. The screen button is grayed out. You cannot explicitly select a screen, because the filter is always updated from the calling screen with this setting.

Note: Settings in the General, Text and Time tabs are locked.

Predefined screen

Click on button opens the Screen selection dialog.

Select the screen from which the filter - when clicking button Update during Runtime - should be read.

Subscreens of faceplates can be selected for screen switching to AML filter, CEL filter, time filter and equipment model. For these screens, the name of the faceplate screen is placed in front of the subscreen in order to clearly distinguish them from other screens.

Attention: When the filter screen is first called up using the function, the filter configured in the function is used, not the filter of the screen stated here!

Note: It therefore only makes sense to select a screen which can adopt or fill the screen filter.

The screen selected is entered into the list of screens to be updated. If you delete it from the list, the next screen on the list is automatically entered here.

Note: Not available if you have activated the Calling screen checkbox.

Screens to be updated

Parameters | Description
Screens to be updated | Selection of the screens that are to be updated. Subscreens of faceplates can be selected for screen switching to AML filter, CEL filter, time filter and equipment model. For these screens, the name of the faceplate screen is placed in front of the subscreen in order to clearly distinguish them from other screens.
Screen selection | Click the button to open dialog Screen selection of the filter screens. Select the desired screen.
Update | Stipulation of where the filter should take effect.
Update on all monitors | Active: The screens from the list of the screens which must be updated are updated on all accessible monitors.


General

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL filter -> General

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the general filter you define which events are displayed and what kind of access you have to the settings in the Runtime. To this you differentiate events according to:

  • Type
  • Origin of the data
  • Variables
  • Alarm/event groups, classes and alarm areas

The following properties are available:

Variable filter

Parameters

Description

Variable filter

Restrictions to events of certain variables

Variable name

Enter the name or part of the name of the variable you want to filter.

Use of the wild card * is possible. Wildcards are only permitted as a prefix or suffix; e.g. *xxx or xxx*.

Note: Filter terms entered in Runtime or in the Editor are automatically saved on the local computer in zenon6.ini and are available for selection in the drop-down list.

Identification

Enter the identification or part of the identification of the variables you want to filter. Wild card * is possible.

Use of the wild card * is possible. Wildcards are only permitted as a prefix or suffix; e.g. *xxx or xxx*.

Note: Filter terms entered in Runtime or in the Editor are automatically saved on the local computer in zenon6.ini and are available for selection in the drop-down list.

Case sensitive

Active: Capitalization is recognized when filtering for variable name and/or identification.

Origin of the data

Parameters

Description

Origin of the data

Display current or current and historical events.

Ringbuffer

Active: Only data from the ring buffer are displayed.

Historical data
Maximum number

Active: Data from the ring buffer and historical data from the CEL are displayed.

The maximum number of the data which should be displayed includes the data from the ring buffer.

Runtime settings

Behavior of the CEL in the Runtime

Show list without refresh

Active: As long as the list is displayed no new entries are added.

(Not available for function Export CEL.)

Show this dialog in the Runtime

Active: Before every call of the screen the filter dialog is opened. The filter settings can be modified.

Display relative time

All entries are displayed in the time distance to the selected entry.

The displayed time is the difference time passed since the selected entry. The selected entry automatically gets the time stamp 0. The other events have a:

  • positive time difference to the selected entry if they occurred later
  • negative time difference to the selected entry if they occurred earlier

Alarm/event groups/classes, alarm areas

Parameters | Description
Alarm/event groups/classes, alarm areas | Selection of groups, classes and alarm area.
Alarm/event groups | From the existing alarm/event groups select the one from which alarms should be displayed.
Alarm/event classes | From the existing alarm/event classes select the one from which alarms should be displayed.
Alarm areas | From the existing alarm areas select the one from which alarms should be displayed.

Filter for system messages

Parameters

Description

Filter for system messages

Filter settings for system messages. System messages are messages that do not relate to a variable.

Exclude system messages from filter

Setting for the display of system messages regardless of the filter settings.

  • Active: System messages are always displayed in Runtime. This also applies if they are to be filtered out by the text or variable filter.
    Exception: However system messages are not shown despite the checkbox being activated if they are filtered out by the time filter or the filters for data origin (ring buffer or historic data).

Example: Only messages with the text "XY" are to be displayed. However if the option is active, system messages that do not contain the term are also displayed.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

attention Attention

For zenon under Windows CE, the following is applicable: CE systems on which the filter dialog should be displayed must have a screen resolution higher than 800*600 pixel for the dialog to be displayed completely.


Text

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL filter -> Text

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Filter by

Parameters | Description
Filter by |
No text filter | The text filter is not used.
Search for (words separated by spaces) | The text filter filter is used. Further options are activated.
Input field | Enter the corresponding words or character strings.

Options

Parameters | Description
Options |
Note capitalization | Active: The filtering is case-sensitive.
Words do not have to appear in the text in full | Active: Parts of words can also be taken into account during filtering.
At least one word must be in the text | Active: At least one word of the search string has to be in the text.
All words must be present in the text | Active: All words must be present in the search string. In doing so, the sequence plays no role.
Filter text must appear in the text exactly | Active: The text must be exactly as defined in the search string.


Time

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL filter -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab, you define the time period that is to be used when the filter screen is opened.

You can read details of the time filter options in the Filter for screen switching, CEL/time chapter.

Filter

Selection of the filter.

Parameters

Description

No time filter

Active: No time filter is used.

Note: all Runtime entries since 1. 1. 1990 are displayed.

Absolute filter

Active: A fixed period of time is entered in the editor. When the function is executed, the defined absolute time period is exactly used.

In the settings section, the corresponding options can be shown and configured there.

Note: Time is saved in UTC. For details see chapter Handling of date and time in chapter Runtime.

Relative period of time

Active: A relative time period is entered.

In the settings section, the corresponding options can be shown and configured there.

Attention: this filter is constantly updated.

From

Active: A time from which the filter is effective is stated. If the time is not reached on the current day, filtering takes place from the corresponding time the previous day.

Selection of the area mode from drop-down list:

  • From HH:MM:SS o'clock
  • From day - HH:MM:SS o'clock
  • Starting on day, month at HH:MM:SS

In the settings section, the corresponding options can be shown and configured there.

Attention: The start point of this filter is not updated automatically. Only the existing times are used when shown.
The end time point is not defined with this filter, it is carried over.

Time period

Active: A fixed time period is entered. Selection of the area mode from drop-down list:

  • One day
  • One week
  • Two weeks
  • One month
  • One Year
  • 15 minutes
  • 30 minutes
  • 60 minutes

In the settings section, the corresponding options can be shown and configured there.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Lots

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL filter -> Lots

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab, you can define the lots that are to be displayed.

Filter

Settings for the application of the lot filter. Selection of one of the options:

  • No lot filter
  • Apply lot filter directly
Parameters | Description
No lot filter | Active: The lot filter is deactivated and cannot be configured. Filtering for lots is not carried out in Runtime.
Apply lot filter directly | Active: The filter configured here is applied in Runtime directly.

Archive(s)

Configuration of filtering for archives. Selection of one of the options:

  • No filter
  • Static
  • From variable

Parameters

Description

No filter

Active: Filtering for archive names is not carried out.

Static

Active: Archives whose identification corresponds to the character string entered in the input field are filtered for.

Input of the archive identifications in the input field:

  • Several identifications are separated by a comma (,).
  • * or empty: All archives, no filter.

From variable

Active: The value of the variables linked here is applied as a filter for archive names in Runtime.

Click on button ... in order to open the dialog for selecting a variable.

Only available for all modules if the Apply lot filter directly option has been selected:

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.
  • If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for archive names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Name(s)

Configuration of the filtering to names. Selection of one of the options:

  • No filter
  • Static
  • From variable

Parameters

Description

No filter

Active: Filtering for lot names is not carried out.

Static

Active: Lot names that correspond to the character string entered in the input field are filtered for.

Input of the lot name in the input field:

  • Several entries are separated by a pipe character (|).
  • * or empty: All lots of all displayed archives, no filter.

From variable

Active: The value of the variable linked here is applied as a filter for lot names in Runtime.

Click on the ... button to open the dialog for selecting a variable.

Not available if the option Apply lot filter directly has been selected.

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.

If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for lot names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Column settings

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL filter -> Column settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab, you define how the archive list and the lot list from the time/lot filter screen are displayed in Runtime:

  • Selection of the columns to be displayed
  • Sorting of the columns
  • Formatting of columns:
    • Labeling
    • Width
    • Alignment

Archive list

Parameters | Description
Archive list | Configuration of the archive list. Display of the configured columns.
Column selection | Clicking on the button opens a dialog to select and sort the columns.
Column Format | Clicking on the button opens a dialog to format the list.

Lot list

Parameters | Description
Lot list | Configuration of the lot list. Display of the configured columns.
Column selection | Clicking on the button opens a dialog to select and sort the columns.
Column Format | Clicking on the button opens a dialog to format the list.
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Column selection

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL filter -> Column settings -> Column selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column selection

Selection and sequence of the columns.

Button | Function
Available columns | List of columns that can be displayed in the table.
Selected columns | Columns that are displayed in the table.
Add | Moves the selected column from the available ones to the selected items. After you confirm the dialog with OK, they are shown in the detail view.
Add all | Moves all available columns to the selected columns.
Remove | Removes the marked columns from the selected items and shows them in the list of available columns. After you confirm the dialog with OK, they are removed from the detail view.
Remove all | All columns are removed from the list of the selected columns.
Up | Moves the selected entry upward. This function is only available for unique entries, multiple selection is not possible.
Down | Moves the selected entry downward. This function is only available for unique entries, multiple selection is not possible.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Column Format

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL engineering via filter -> Filters for screen switch CEL filter -> Column settings -> Column Format

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column Format

Configuration of the properties of the columns for configurable lists. The settings have an effect on the respective list in the Editor or - when configuring screen switching - in Runtime.

Available columns

Parameters | Description
Available columns | List of the available columns via Column selection. The highlighted column is configured via the options in the Settings area.

Settings

Parameters

Description

Settings

Settings for selected column.

Labeling

Name for column title.

The column title is online language switchable. To do this, the @ character must be entered in front of the name.

Width

Width of the column in characters.
Calculation: Number time average character width of the selected font.

Alignment

Alignment. Selection by means of radio buttons.

Possible settings:

  • Left-justified: Text is justified on the left edge of the column.
  • Centered: Text is displayed centered in the column.
  • Right: Text is justified on the right edge of the column.

Deactivate column filter in the Runtime

Active: The filter for this column cannot be changed in Runtime.

Note: Only available for:

  • Batch Control
  • Extended Trend
  • Filter screens
  • Message Control
  • Recipegroup Manager

User defined colors

Properties in order to define user-defined colors for text and background. The settings have an effect on the Editor and Runtime.

Note:

  • These settings are only available for configurable lists.
  • In addition, the respective focus in the list can be signalized in Runtime by means of different text and background colors. These are configured using the project properties.

User defined colors

Active: User-defined colors are used.

Text color

Color for text display. Clicking on the color opens the palette to select a color.

Background color

Color for the display of the cell background. Clicking on the color opens the palette to select a color.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


CEL ring buffer

Manual -> Chronological Event List (CEL) -> Engineer CEL -> CEL ring buffer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Events are saved in a ring buffer (cel.bin) and in an event file (*.cel) in the Runtime folder as soon as the occur.

Ring buffer

The ring buffer contains all active events. These are managed via:

  • Time received in millisecond as unique signature

Size of the ringbuffer

The size of the ring buffer must be large enough and is defined in the project settings with property Size of the ringbuffer.

In the Runtime old entries are kept in the list when the CEL screen is called up. As soon as new entries are added the number of the displayed entries can exceed the engineered size of the ring buffer. When the list is then called up again, the old entries are removed and the engineered size is adhered to. This behavior makes sure that no data is lost when the list is displayed.

Attention: The display of entries which exceed the defined values occupies additional memory. If the screen is called up again, the occupied memory is not freed but remains at the last peak.

Save ring buffer

The ring buffer is automatically saved as cel.bin when the Runtime is closed. If the Runtime is closed by an unexpected event such as a power outage, data loss occurs. To prevent this the ring buffer can be saved manually via property Save ringbuffer on change at every new entry or via function Save AML and CEL ring buffer.

Result file

All alarms are written together with the ring buffer in an own CEL file (*.cel) at the same time. This file is created for every calendar day automatically and is managed via property Save CEL data. The name of the file consists of the letter C, followed by the date in from JJMMTT and the suffix .cel, e.g. C100623.cel. These files are created automatically for every day and must be evecuated or deleted by the user if the storage space is limited. *.cel files are saved in folder ...\Project folder\Computer name\Project name.

Synchronizing ring buffer and alarm file

Ring buffer and CEL file are synchronized. This synchronization is always carried out from the ring buffer to the CEL file.

Saving periods

The Chronological Event List *.cel is saved with every new entry.

The ring buffer (*.bin) is saved:

  • when the Runtime is closed
  • after every new entry if property Save ringbuffer on change is active
  • when function Save AML and CEL memory buffer is carried out

Note: If option Save ringbuffer on change is deactivated, it is possible that the entries in the CEL and in the ring buffer do not match after a power outage.


Functions

Manual -> Chronological Event List (CEL) -> Functions

Via functions the display and the handling of the CEL are controlled in the Runtime.

attention Attention

If functions are used in the network, regard their execution location.


Functions in the network

Manual -> Chronological Event List (CEL) -> Functions -> Functions in the network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If network functions are used, the place of execution must be noted:

For functions that are used in the network:

  • The place of execution can be freely configured in some cases
  • The place of execution is stipulated in some cases

info Information

Scripts combine several functions. The place of execution then depends on the settings of the Execute script function. This setting overwrites the settings of the individual functions.

Configure place of execution

For functions where the place of execution can be freely configured, the corresponding parameters are available in the properties of the function.

To define the place of execution:

  1. navigate to the Execution group in the Properties.
  2. Select the desired place of execution by checking the checkbox. Multiple selection is possible:
    • Current computer: Function will be executed on the current computer.
    • Primary Server: Function will be executed on the Primary Server.
    • Standby Server: Function will be executed on the Standby Server.
    • Client: Function will be executed on all clients.

Overview of functions in the network

The following table shows which functions are executed and where they are executed.

Key:

  • Adjustable: Behavior can be configured

    +: Yes

    -: No

    O: Default

  • If not adjustable, O identifies the place of execution:
    • Active computer
    • Primary Server
    • Standby Server
    • Client

Function | Adjustable | Current computer | Primary Server | Standby Server | Client
AML and CEL |  |  |  |  |
Alarms: acknowledge flashing | - | O |  |  |
Alarms: delete | - |  | O | O |
Acknowledge alarms | - |  | O | O |
Alarm/event group log in/log off | - | O |  |  |
Activate/deactivate alarm message list / alarm/event groups / alarm/event classes | - |  | O | O |
Alarm Message List active | - |  | O |  |
Alarm Message List active/inactive | - |  | O |  |
Alarm message list inactive | - |  | O |  |
Export AML | + | O |  |  |
Save AML and CEL memory buffer | - |  | O | O |
Export CEL | + | O |  |  |
Print AML or CEL | + | O |  |  |
Create/print IPA document | - |  | O |  |
Switch online printing on/off | - |  | O | O |
Online printing start new page | + | O |  |  |
Switch online printer | - |  | O |  |
Application |  |  |  |  |
Select printer | + | O |  |  |
Start Load Management | - |  | O |  |
Stop Load Management | - |  | O |  |
Print Extended Trend diagram | + | O |  |  |
Switch palette | + | O |  |  |
Functions active at limit | - |  | O | O |
Functions active/inactive at limit | - |  | O | O |
Functions inactive at limit | - |  | O | O |
Open Help | + | O |  |  |
Reload project online | + | O |  |  |
Determine open maintenances | - |  | O |  |
PFS - execute user-defined event | + | O |  |  |
Activate/deactivate project simulation | - | O |  |  |
Simulate right click | + | O |  |  |
Save remanent data | + | O |  |  |
Exit Runtime | + | O |  |  |
Analyze S7 Graph heuristics | + | O |  |  |
Execute SAP function | + | O |  |  |
Language switch | + | O |  |  |
Topology - Search for ground fault | - |  | O |  |
Topology - LoadShedding | - |  | O |  |
Historian |  |  |  |  |
Archive: Stop | - |  | O | O |
Index archive | - |  | O |  |
Archive: Start | - |  | O | O |
Export archives | - | O |  |  |
Display open archives | - |  | O | O |
User administration |  |  |  |  |
Change user | + | O |  |  |
Login with dialog | + | O |  |  |
Login without password | + | O |  |  |
Logout | + | O |  |  |
Change password | - | O |  |  |
Screens |  |  |  |  |
Change ALC source color | + | O |  |  |
Indexed screen | - | O |  |  |
Close screen | + | O |  |  |
Screen: Return to last | - | O |  |  |
Screen: Move center | + | O |  |  |
Screen switch | + | O |  |  |
Activate input to the element with the focus | + | O |  |  |
Set focus to frame | + | O |  |  |
Move focus | - | O |  |  |
Take focus away from frame | + | O |  |  |
Show menu | + | O |  |  |
Monitor assign | + | O |  |  |
Runtime profiles | + | O |  |  |
Close frame | + | O |  |  |
Setpoint input for keyboard screen | - | O |  |  |
Displaying the overview window | + | O |  |  |
Fault locating in electric grids |  |  |  |  |
Acknowledge ground fault message | + | O |  |  |
Stop search for ground fault | + | O |  |  |
Start search for ground fault | + | O |  |  |
Acknowledge short-circuit message | + | O |  |  |
Message Control |  |  |  |  |
Save current queue | - |  | O |
Suppress groups/classes/areas/equipment | - |  | O |  |
Send a Message | - |  | O |  |
Send Message: activate | - |  | O |  |
Send Message: deactivate | - |  | O |  |
Network |  |  |  |  |
Authorization in network | + | O |  |  |
Redundancy switch | - |  |  | O |
Report Generator |  |  |  |  |
Print report | + |  |  |  |
Report: execute | + |  |  |  |
Export Report | + |  |  |  |
Recipes |  |  |  |  |
Recipegroup Manager | - | O |  |  |
Standard recipe | - | O |  |  |
Standard recipe single directly | + | O |  |  |
Standard recipe single with dialog | - | O |  |  |
Standard recipe single with online dialog | - | O |  |  |
Script |  |  |  |  |
Script: execute | + | O |  |  |
Script: select online | + | O |  |  |
Variable |  |  |  |  |
Export data | - |  | O |  |
Read dBase file | + | O |  |  |
Print current values | + | O |  |  |
Unit conversion | + | O |  |  |
HD administration active | - |  | O | O |
HD administration inactive | - |  | O | O |
HD administration inactive/active | - |  | O | O |
Write set value | - |  | O |  |
Driver commands | - | O |  |  |
Transfer driver simulation image to the standby | - |  |  | O |
Write time to variable | + | O |  |  |
Read time from variable | + | O |  |  |
VBA |  |  |  |  |
Open PCE editor | - |  | O |  |
Open VBA Editor | + | O |  |  |
Execute VBA macro | + | O |  |  |
Show VBA macro dialog | + | O |  |  |
VSTA |  |  |  |  |
Open VSTA editor | + | O |  |  |
Execute VSTA macro | + | O |  |  |
Show VSTA macro dialog | + | O |  |  |
Windows |  |  |  |  |
Play audio file | + | O |  |  |
File operations | + | O |  |  |
Start continuous tone | + | O |  |  |
Stop continuous tone | + | O |  |  |
Window to the background | - | O |  |  |
Window to foreground | - | O |  |  |
Print screenshot | + | O |  |  |
Start program | + | O |  |  |


Screen switch CEL

Manual -> Chronological Event List (CEL) -> Functions -> Screen switch CEL

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to call up a screen of type Chronological Event List:

  1. create a screen of type Chronological Event List:
  2. create a screen switch function for this screen
  3. define the desired filter properties

In the Runtime you can modify the filter properties. Exception: In the Editor fixed time filter was defined.

Configure screen switching

To create a screen switch to a screen of type CEL:

  1. in the context menu of node function select command New function
  2. click on screen switch
  3. the dialog for the screen selection will be opened
  4. select the screen of type CEL
    or create it in this dialog by clicking symbol New screen
  5. the filter is displayed with all tabs:
    • General
    • Time
    • Column settings
    • Text
    • Status
    • Project (only available in the integration project of the multi-project administration.)
    • Equipment Modeling

    If linked variables or indexes are available, the following tabs can be displayed as an option.

    • Replace links
    • Replace indices

  6. define the filters which should be pre-defined in the Runtime
  7. confirm the settings and close the dialog by clicking OK
  8. link the function with a button in order to call up the screen and to display the filter properties in the Runtime

info Information

If a screen that does not have a time filter is referenced, the time filters are deactivated.


Screen switch CEL Filter

Manual -> Chronological Event List (CEL) -> Functions -> Screen switch CEL Filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to call up a screen of type Chronological Event List Filter in the Runtime:

  1. create a screen of type Chronological Event List Filter:
  2. create a screen switch function for this screen
  3. define the desired filter properties

In the Runtime the filter properties can only be controlled via the buttons defined in the screen.

Configure screen switching

To create a screen switch to a screen of type Chronological Event List Filter:

  1. in the context menu of node function select command New function
  2. click on screen switch
  3. the dialog for the screen selection will be opened
  4. select the screen of type Chronological Event List Filter
    or create it in this dialog by clicking symbol New screen
  5. the filter is displayed with all tabs:
    • Screens
    • General
    • Text
    • Time

  6. define the filters which should be pre-defined in the Runtime
  7. confirm the settings and close the dialog by clicking OK
  8. link the function with a button in order to call up the screen and to display the filter properties in the Runtime


Functions for Chronological Event List

Manual -> Chronological Event List (CEL) -> Functions -> Functions for Chronological Event List

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Different functions enable the handling of events in the Runtime.

To create a function for the Chronological Event List:

  1. navigate to the Functions node
  2. select New function in the context menu or from the tool bar
  3. the dialog for selecting functions is opened
  4. navigate to the AML/CEL node

  5. select the desired function
  6. configure the function if necessary
  7. link the function to a button


Save AML and CEL memory buffer

Manual -> Chronological Event List (CEL) -> Functions -> Functions for Chronological Event List -> Save AML and CEL memory buffer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function, the content of the ring buffer for alarms and events as well as the values of mathematical variables (counters) can be saved. The entries are saved in the following files:

File | Contents | The size can be set in Properties
ALARM.BIN | Alarms | Size of the ringbuffer
CEL.BIN | Chronological Event List entries | Size of the ringbuffer
SY_MA32.BIN | Values of mathematical variables (e.g. counters) |

To save the AML ring buffer:

  1. Create a new function
  2. Select Save AML and CEL ring buffer
  3. link the function to a button


Export CEL

Manual -> Chronological Event List (CEL) -> Functions -> Functions for Chronological Event List -> Export CEL

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function you can export the saved events with filter options to a file or database in the Runtime.

To export CEL entries:

  1. Create a new function.
  2. Select Export CEL.
  3. The dialog for selecting filter criteria opens.

  4. Define the criteria for:
    • Export format
    • General
    • Time
    • Text
    • Status
    • Equipment Modeling
    • Project
  5. Link the function to a button.


Export format

Manual -> Chronological Event List (CEL) -> Functions -> Functions for Chronological Event List -> Export CEL -> Export format

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Exports can be carried out in different formats. Which columns are exported, and how, depends on the source (AML/CEL) and the export format:

Data is exported in different ways for:

  • CSV
  • dBase
  • SQL
  • XML

info Information

The export to SQL is incremental. If there is already exported data, only new and amended data is exported.

Column selection

The selection of the columns to be exported depends on the export format:

  • CSV, DBF and XML: Selection using the dialog of the Column settings AML project property for the AML and Column settings CEL for the CEL.
  • SQL: Fixed settings for the incremental export, which cannot be configured further.
    Note: The RESLABEL column for the Resources label was added in version 7.20. Export tables that already exist can thus no longer be used. The table must be renamed for correct export.

Configure export

Export format

Parameters

Description

Export format

Selection of the file type. Possible formats:

  • dBase: DBaseIV format (*.dbf):
  • CSV
  • XML
  • SQL

Notes on dBase:

  • Filenames cannot be longer than eight characters.
  • Configured column width is used for export. If, for example, a value of 40 is set under Column settings, a maximum of 40 characters is then exported.
  • A maximum of 255 characters are exported.

Options

Parameters | Description
Options |
Export as unicode | An export to ASCII format is performed in Unicode
Incremental export | Only differences since the last backup are exported.

Export to file

Parameters

Description

Export to file

Determining the file in which the export is saved.

File name

Define file name individually.

A maximum of 32 alphanumeric characters including file suffix.

Note: Existing files with the same names are overwritten.

Generate file name automatically

Active: The file name will be generated automatically from a short identifier, a date key and an individual postfix.
Inactive: The file name is entered by the user under Filename.

(existing files are not overwritten)

For details, see the next table: Coding name for automatic naming

Postfix

Free, individual identification. Only available for Generate filename automatically.

Possible entries:

  • dBase: 1 alphanumeric character
  • ASCII and XML: 32 alphanumeric characters

Example

Display of the complete file name with automatic generation.

Set export folder

Display of the current export path configured in Project Properties. (Runtime folder property in the General/Name/Folder node.)

Export to SQL database

Parameters for export into a SQL database

Database connection

Configuration of the database connection. A click on the ... button opens the configuration dialog.

Table

Selection of the table that is to be written in.

Coding name for automatic naming

Name

AJJMMTTP.XXX

A

Short identification of the Alarm Message List

JJMMTT

Date input:

  • YY: Year, two-digits
  • MM: Month, two-digits
  • DD: Day, two-digits

P

Free, individual identification:

  • dBase: 1 alphanumeric character
  • ASCII and XML: 32 alphanumeric characters

XXX

File ending:

  • DBF: dBase
  • TXT: CSV
  • XML: XML

Formal matters

  • Format of the line entries: Is taken from the settings of the Column settings AML and Column settings CEL property.
  • Column separator: Semi-colon (;)

attention Attention

Milliseconds for printing or export

If, when printing or exporting the AML or CEL to CSV, XML or dBase format, the time in milliseconds is to be given, this property must be activated in the dialog for the column settings. To do this:

  • Navigate to the Alarm Message List or Chronological Event List nodes in properties.
  • Click on the ... button of the Column settings AML or Column settings CEL property.
  • The dialog for the column settings is opened.
  • Activate the checkbox in front of the Milliseconds property.

The additional setting must be made for both AML and CEL.

Notes SQL

attention Attention

Ensure that the provider configured in the connection is also available on the Runtime computer in Runtime.

Note: An SQL client is also installed with the zenon Editor. Because the zenon Runtime does not need an SQL Server, no SQL client is automatically installed. This can be downloaded from the Microsoft website and must be installed individually.

Ensure you install the correct version when installing the provider. This must suit the zenon version being used. This means: If a 32-bit zenon Runtime is used, the provider must be a 32-bit version. This also applies if it is installed on a 64-bit operating system and also if the database itself is a 64-bit application.

attention Attention

When using Native Client 10 and 11, the password is not automatically carried over to the provider string. It must be entered manually

e.g.: ...;User ID=sqlExampleUser1;Password=secretPassword;...


CSV: Exported columns

Manual -> Chronological Event List (CEL) -> Functions -> Functions for Chronological Event List -> Export CEL -> CSV: Exported columns

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Export to CSV is mostly for further processing in other applications. The data is exported according to the selection in Column settings AML or Column settings CEL:

  • Only data from the selected columns is exported.
  • The sequence in the export file corresponds to the one defined in the dialog.
  • Separator: Semi-colon (;)
  • Column titles are not exported.


dBase: Exported columns

Manual -> Chronological Event List (CEL) -> Functions -> Functions for Chronological Event List -> Export CEL -> dBase: Exported columns

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For export in to a dBase file, the data is exported in accordance with the selection in Column settings AML or Column settings CEL:

  • Only data from the selected columns is exported.
  • The sequence in the export file is defined and cannot be changed.

Columns in exported sequence:

Column | Type | Size | Description
DATUM_KOMM | Date | 8 | Alarm occurred: Date.
ZEIT_KOMMT | Character | 10 | Alarm occurred: Time.
ALARMTEXT | Character | 40 | Limit value text.
TAG_NR | Character | 40 | Variable identification.
KOMMENTAR | Character | 45 | Comment.
STATUS | Character | 4 | Status of variable.
WERT | Character | 10 | Variable value.
USER | Character | 6 | User identification.
COMPUTER | Character | 48 | Computer name.
VAR_NAME | Character | 32 | Variable name.
RESLABEL | Character | 15 | Resources label.
PROJ_NAME | Character | 31 | Project name
CLASS | Character | 31 | Name of the alarm class.
GROUP | Character | 31 | Name of the alarm group.


SQL: Exported columns

Manual -> Chronological Event List (CEL) -> Functions -> Functions for Chronological Event List -> Export CEL -> SQL: Exported columns

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For SQL export, the files are exported incrementally in a fixed, pre-defined sequence.

Columns in exported sequence:

Column | Type | Description
[VAR] | varchar(128) | Variable name.
[TAG] | varchar(128) | Variable identification.
[RESLABEL] | varchar(128) | Resources label.
[TEXT] | varchar(1024) | Limit value text.
[COMES_S] | int | Alarm occurred in Unix time (seconds since 01. 01. 1970).
[COMES_MS] | int | Alarm occurred: Milliseconds fraction.
[STATUS] | int | Status of variable.
[VALUE] | varchar(128) | Variable value.
[USERID] | varchar(128) | User identification.
[COMP] | varchar(128) | Computer name.
[ACT_TEXT] | varchar(128) | Alarm: Comment.
[PRJ] | varchar(128) | Project name.
[CLASS] | varchar(128) | Name of the alarm class.
[GROUP] | varchar(128) | Name of the alarm group.


XML: Exported columns

Manual -> Chronological Event List (CEL) -> Functions -> Functions for Chronological Event List -> Export CEL -> XML: Exported columns

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When exporting to an XML file, the data is exported in accordance with the selection in Column settings AML or Column settings CEL:

  • Only data from the selected columns is exported.
  • The sequence in the export file corresponds to the one defined in the dialog.
  • Column titles are used as tags. All characters that are not permitted are removed and replaced in the process.
    Rules for replacement:
    • Space: Underscore (_).
    • Other non-permitted characters: Hyphen (-).


Print AML or CEL

Manual -> Chronological Event List (CEL) -> Functions -> Functions for Chronological Event List -> Print AML or CEL

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The saved events and their filter conditions can be output to a printer in Runtime with this function

To configure the function:

  1. Create a new function
  2. select Print AML or CEL
  3. the dialog for selecting the list opens

  4. select Chronological Event List
  5. the dialog for selecting filter criteria opens
  6. define the criteria for:
    • General
    • Time
    • Text
    • Status
    • Font: Selection from the fonts defined in zenon
  7. link the function to a button

info Information

In the Runtime you cannot switch between CEL and AML. To print both lists, you must engineer two functions.

Line structure

Date/Time received | Date/Time cleared | Date/Time acknowledged | Long text | Status text

The keywords which are available for the format file (BTB.FRM for online print and BTB_G.FRM for offline print) and examples for their use can be found in chapter FRM configuration file and in section Operation in the Runtime.

The FRM file has three parts:

  • Header: at the beginning of the page
  • List part: cyclic per line
  • Footer: at the end of the page

Principles

When editing FRM files regard the following:

  • Separating the list parts:
    • Header and list part and list part and footer are seperated by %%.

      The separation marking must be used only once for the list and the footer.

    • Attention: The last line must be followed by at least two empty paragraphs. Otherwise the footer is not printed!
  • Positioning the individual entries:
    You may only use space, no tabulators.
  • Editing the FRM file in a text editor:
    Automatic line break must be deactivated otherwise undesired effects in the formatting may occur.

Keywords

The setting for the page length is made in Project Properties under AML and CEL or via the ALARM.frm or ALAR_G.frm file for the AML or BTB.frm and BTB_G.frm for the CEL.

Please keep in mind:

  • The number of the alarm entries per page results from the predetermined number of lines (e.g. Lines per page 72), less the lines used for header and footer text.
  • The Use reactivated time option must be activated in order to be able to use the keywords that evaluate the reactivation (time, number).
  • Free texts and keywords can be used in the formatting file. Key words can be used either in German or in English. The use of English key words is recommended.
  • Not every key word is suitable for every kind of printing (AML, CEL, online, offline).

The following list contains key words in English and German and their field of application.

German | English | AML offline | CEL offline | AML online | CEL online | Description
Key words for the list part
@BMKENNUNG | @RESOURCELABEL | X | X | X | X | Resources label
@DATZEITKOMMT | @DTRECEIVED | X | X | X | X | Time and Date when the alarm occurred
@DATZEITGEHT | @DTCLEARED | X | - | X | - | Time and Date when the alarm ended
@DATZEITOK | @DTACK | X | - | X | - | Time and Date when the alarm was acknowledged
@DATZEITREAKT | @DTREACTIVATE | X | - | X | - | Time and Date of reactivating: Property Use reactivated time in the project properties must be activated.
@DATZEIT | @DTLASTEVENT | - | - | X | - | Time and date of alarm received or cleared or acknowledged or reactivated
@ZEIT | @TLASTEVENT | - | - | X | X | Time of alarm received or cleared or acknowledged or reactivated
@ZEITOK | @TACK | X | - | X | - | only displays time of acknowledging
@ZTKOMMT | @TRECEIVED | X | X | X | X | only displays time of alarm received
@ZTGEHT | @TCLEARED | X | - | X | - | only displays time of end of alarm
@ZTREAKT | @TREACTIVATE | X | - | X | - | only displays time of reactivating
@TIMELASTING | @TACTIVE | X | - | X | - | Time active (difference time received - time cleared)
@ANWENDUNG | @PROJECTNAME | X | X | X | X | Project name
@KANALNAME | @VARNAME | X | X | X | X | Variable name CEL: Only entries with variables
@AK | @ACLASSNR | X | X | X | X | Alarm/event class name
@AG | @AGROUPNR | X | X | X | X | Alarm/event group number
@AGNAME | @AGROUPNAME | X | X | X | X | Name of alarm/event group
@AKNAME | ACLASSNAME | X | X | X | X | Name of alarm/event class
@TAGNR | @IDENTIFICATION | X | X | X | X | Identification (company-specific label)
@AMELDUNG | @TEXT | X | X | X | X | Alarm message text
@REAKTANZ | @NRREACTIVATE | X | - | X | - | Number of reactivations
@STATUS | @STATUS | X | X | X | X | Status information as in Alarm Message List
@WERT | @VALUE | X | X | X | X | Variable value of alarm
@REAKTIONSTEXT | @COMMENT | X | X | X | X | Commentary from the Alarm Message List. If you use dynamic limit texts, this is only available if properties Long dynamic limit texts AML or Long dynamic limit texts CEL are activated.
@USER | @USERID | X | X | X | X | AML: User who acknowledged alarm.
@RECHNER | @COMPUTER | X | X | X | X | AML: Computer on which alarm was acknowledged.
Key words for header and footer
@ANWENDUNG | @PROJECTNAME | X | X | X | X | Project name
@SEITE | @PAGE | X | X | X | X | Page number
@HEADDATZEIT | @DTSYSTEM | X | X | X | X | System date and system time
@HEADDATUM | @DSYSTEM | X | X | X | X | System date
@HEADZEIT | @TSYSTEM | X | X | X | X | System time
@USER | @USERID | X | X | X | X | User who prints
@USERNAME | @USERNAME | X | X | X | X | Full user name who triggered action
@RECHNER | @COMPUTER | X | X | X | X | Computer from which it is printed
[Text] | [Text] |  |  |  |  | Random text

attention Attention

Between the key words there must be enough space so that entries are not overwritten. In doing so, you make sure that long limit texts are also displayed correctly.

Example:

@TEXT (spaces up to here)

Setting milliseconds

attention Attention

Milliseconds for printing or export

If, when printing or exporting the AML or CEL to CSV, XML or dBase format, the time in milliseconds is to be given, this property must be activated in the dialog for the column settings. To do this:

  • Navigate to the Alarm Message List or Chronological Event List nodes in properties.
  • Click on the ... button of the Column settings AML or Column settings CEL property.
  • The dialog for the column settings is opened.
  • Activate the checkbox in front of the Milliseconds property.

The additional setting must be made for both AML and CEL.


Switch online printing on/off

Manual -> Chronological Event List (CEL) -> Functions -> Functions for Chronological Event List -> Switch online printing on/off

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Online printing is set to a status when this function is used:

  • on: Switches online printing on
  • off: Switches online printing off
  • active/inactive: Switches online printing

To configure the function:

  1. Create a new function
  2. Select Switch online printing on/off
  3. the dialog for selecting the action opens

  4. select the desired action
  5. link the function to a button


Online printing start new page

Manual -> Chronological Event List (CEL) -> Functions -> Functions for Chronological Event List -> Online printing start new page

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function, you control the form feed in Runtime when printing online:

The configured footer will be printed onto the current page of the printout, and then the printout will advance to the beginning of a new page. The page counter will be reset to 1 and the header will be printed out.

To configure the function:

  1. Create a new function
  2. Select Start online printing on a new page
  3. link the function to a button


Switch online printer

Manual -> Chronological Event List (CEL) -> Functions -> Functions for Chronological Event List -> Switch online printer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function, the printer for online printing can be changed in Runtime.

To configure the function:

  1. Create a new function
  2. Select Switch online printer
  3. The dialog for selection of the user opens
  4. Select the desired screen printer from the drop-down list
  5. link the function to a button

Parameters | Description
select printer | Selection of the desired printer from the drop-down list.
Show this dialog in the Runtime | Active: When this function is executed, the dialog is opened and the printer can be defined in Runtime.


Operating during Runtime

Manual -> Chronological Event List (CEL) -> Operating during Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Runtime the Chronological Event List is called via a screen switch function.

The available control elements and the look are engineered in the Editor.

Parameters

Description

Chronological Event List

Display field for the list with its events. The appearance is configurable. Columns are defined via the Column settings filter in screen switching or via the Column settings CEL property in the Chronological Event List group.

Set filter

Displays the currently selected filter.

Filter...

Opens the filter dialog.

Sort

After calling up the CEL in the Runtime, new entries are not sorted in chronological order but added to the bottom of the list.

Click on the button to newly sort the list.

To help you differentiate between sorted and unsorted entries you can assigned different colors via properties sorted text and unsorted text.

Show relative times

Active: The relative times are displayed without the focus being lost in the selected entry.

Stop/continue

Controls adding new events to the list while it is displayed:

Stop: No new entries are added to the list. The button changes its caption to Continue.

Continue: New entries are added to the list. The button changes its caption to Stop. To sort the new entries chronologically, you must click on button Sort.

Close

Ends the display of the Chronological Event List and closes the screen and the frame.

In order that after the closing the screen which was opened before is displayed, you must engineer the screen of type CEL with its own frame.

Print

Prints list as it is currently displayed.

Print with dialog

Opens printer settings before printing.

Text: Total number

Adds text "Total" in the Runtime. Must be followed by list field Total number.

Total number

Number of all events in the list

Status

Displays the status of the CEL in the Runtime.

active: Events are logged depending of the settings in the project

inactive: Events are not logged

You define the status with the help of property CEL active. Changes take effect after the Runtime has been restarted.

Text: Comment field

Adds text "comment" in the Runtime. Must be followed by list field Comment field.

Comment field

List field for entering a freely definable text by the user for the selected event.

As soon as the field loses focus, the text is taken over. To display the text in the CEL, you must activate column comment in the column definition.

Button Stop/Continue

Navigation

Controls elements of the list.
  • Line up

Scrolls one line up.
  • Line down

Scrolls one line down.
  • Column right

Scrolls one column to the right.
  • Column left

Scrolls one column to the left.
  • Page up

Scrolls one page up.
  • Page down

Scrolls one page down.
  • Page right

Scrolls one page to the right.
  • Page left

Scrolls one page to the left.

Filter profiles

Filter settings that can be saved by the user in Runtime.

  • Profile selection

Select profile from list.

  • Save

Saves an online setting in a profile.

  • Delete

Deletes selected profile.

info Information

The current filter is displayed with the Show filter control element.

With a:

  • Text filter, the expression [Txt] is displayed
  • Relative time filter: is displayed as a print-out with the following scheme:
    [T,Rel:%dd,%dh,%dm;%ds]
    Example: [T,Rel:1d,0h,0m,0s] equals one day.

configuration of the display

The type of information which is displayed in the Runtime, you can configure via the column setting of the CEL. You can reach the column setting via:

  • Project settings -> Chronological Event List -> Column settings CEL (only tab Column settings )

    or

  • Function screen switch to a screen of type AML (all tabs)

Display in the value column

Only values of numeric data types can be displayed in the Value column. The column remains empty for entries with a String data type.


Filter CEL

Manual -> Chronological Event List (CEL) -> Operating during Runtime -> Filter CEL

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Events can be filtered and displayed in the Runtime via:

  • filter use in the Runtime
  • screen switch with pre-defined filter to a screen of type CEL
  • screen switch with filter for call up of a screen of type CEL
  • screen switch to a screen of type Chronological Event List Filter

Filtering in the Runtime

In the screen of type CEL you can use filter in the Runtime. To filter the results displayed in the CEL:

  1. you must have engineered button Filter
  2. click on the button
  3. the filter dialog of the CEL will be opened

Set filter can be saved in profiles.

Screen switch to a screen of type Chronological Event List

Results can be displayed in a pre-filtered way. To do this:

  1. engineer a filter for function screen switch to a screen of type CEL
  2. the CEL is displayed in a filtered way when called
  3. if the option Display dialog in the Runtime is activated for the function, you can newly define the filter before the display
  4. in the Runtime further filter settings are possible via button filter

Screen switching to an alarm message list filter screen

To make only the filter available in the Runtime, which the user needs, you can use the screen of type Chronological Event List Filter. To do this:

  1. engineer a screen switch to a screen of type Chronological Event List Filter
  2. call up the CEL via this function in the Runtime
  3. The user has an Alarm Message List that is tailor-made to their requirements.


Filter profiles

Manual -> Chronological Event List (CEL) -> Operating during Runtime -> Filter CEL -> Filter profiles

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Filter profiles are filter settings that the user can save and call up in Runtime in relation to a certain screen.

To be able to use filter profiles, the following control elements must be configured:

Control element | Description
Filter profiles | Profile administration in Runtime.
Profile selection | Selection of a saved profile in Runtime from a drop-down list.
Save | Clicking on the button in Runtime saves the filter settings as a profile.
Delete | Clicking on the (X) button in Runtime deletes the selected profile.

With this you can in the Runtime:

  • save filters
  • use saved filters
  • delete filter profiles

Filter profiles can also be exported and imported with further control elements.

Save filter profile

To create a filter profile:

  1. define filter conditions in the Runtime
  2. assign a name using property filter profiles
  3. Click on Save

Use filter profile

To use a filter profile:

  1. select a filter from the drop-down list property filter profiles
  2. the filter is immediately applied

Delete filter profile

To delete a filter profile:

  1. select a filter from the drop-down list property filter profiles
  2. click on button X
  3. the profile is deleted
  4. the deleted filter is still applied as long as a new filter is defined or selected


Use CEL filter

Manual -> Chronological Event List (CEL) -> Operating during Runtime -> Filter CEL -> Use CEL filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The screen of type Chronological Event List Filter enables you to make individual filter settings for the Alarm Message List in the Runtime. You can engineer all filter settings which are also available in the filter for function screen switch to the screen of type CEL.

Therefore:

  • Only the filter elements that are actually required are configured and provided to the user
  • The user only has these filters displayed and has an overview
  • The appearance can be freely defined and can, for example, ensure ease of use by means of a touch screen.

Filter screens

Filter screens make it possible to transfer a preset filter from one screen to another. The filter of the source screen is set using the target screen. The screens can also be of a different screen type.

attention Attention

In order for the time to be taken from the screen to be called up in Runtime, the following time range must be selected in the Editor for the screen switching function for the Alarm Message List or the Chronological Event List in the time filter: Set filter at time filter type

Call definition

The following requirements must be met for the set filters to be used:

  1. Set filter for time filter type is selected as a time period for the time filter.
  2. The screen (Alarm Message List Filter, Chronological Event List filter or Time/Lot Filter screen) is activated using a button or a combined element. Only in this way can the relationship between filter screen and source screen be maintained.
  3. The source screen and filter screen must be configured on different frames or monitors. The filter for the filter screen can only be updated if the source screen is open. This is only possible if both screens do not use the same frame or the same monitor.
  4. The screen to be called up must be compatible with the filter screen to be called up (see table).
Source screen | AML filter | CEL filter | Time filter
Archive revision | T | T | T
Extended Trend | T | T | T
Time filter | T | T | X
Alarm Message List Filter | X | C | T
Chronological Event List Filter | C | X | T
Alarm Message List | X | C | T
Chronological Event List | C | X | T

Key:

  • C: Common settings are updated.
  • T: Time settings are updated.
  • X: All settings are updated.

info Information

No filtering

The filter screen is not filtered, but opened with the configured values, if:

  • One of the conditions 1 to 3 is not met or
  • The Screen to call up setting is not activated for the Screen switching function or
  • The screen is not called up via a screen element

In this case, the Accept, Close and Update buttons are grayed out in Runtime and have no function.

Update

When a filter screen is called up (Alarm Message List filter, Chronological Event List filter, time filter), the screens configured in the screen switching function are updated in two ways:

  • If the filter screen is called up via a screen element, the target screens on the same monitor as the source screen are updated.
  • If the filter is called up in a different way or if the Update on all monitors setting is activated, all target screens configured are updated.

They are updated as soon as you click the Accept button or as soon as you closes the filter screen with the close Close button. The Cancel button discards the changes and closes the filter screen.

Update filter settings

You update the current filter settings for the source screen using the Update button. If the filter screen is not called up by a screen element or if the Calling screen has not been activated, all monitors are searched for screens that can be used for updating. The first screen that is found is then this is used for updating.


Print and export events

Manual -> Chronological Event List (CEL) -> Operating during Runtime -> Print and export events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entries in the CEL can be documented and archived via:

  • CEL Print online: each event is printed on a line printer when it is displayed in the list
  • CEL Print offline: the CEL is printed in the current state as completed list
  • Export content of the CEL (filtered)

The print used for printouts is defined via menu File -> General configuration -> Standard.

attention Attention

A configuration file *.frm is used for the print-out:

  • online: ALARM.frm
  • offline: ALAR_G.frm.

This FRM file must be in the project tree in the File section in the Texts and formats folder.

Templates for FRM files can be found in the zenon installation folder in the FRM_QRF subfolder. These can be inserted via the file in the Texts and formats section and edited there.

You can kind the key words for FRM files in the FRM configuration file chapter.


Online printing

Manual -> Chronological Event List (CEL) -> Operating during Runtime -> Print and export events -> Online printing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

At online printing each event with entry in the CEL is immediately sent to the printer.

Attention: The online printing takes place line by line in accordance with the ESC/P (Epson Standard for Printers) and demands an Epson compatible printer.

To online print entries from the CEL

  1. define a printer
  2. navigate to the AML and CEL node in properties
  3. Activate the property Printing active
  4. at property Printing for select Chronological Event List from the drop-down list
  5. Define the number of lines with the Lines per page property (default: 72)
  6. configure BTB.frm
  7. add file BTB.frm to node Files/texts and formats

Control print and printer in the Runtime

Page change

Form feed is carried out if:

  • a page is fully written
  • the Runtime is closed and online printing is active
  • function Online printing start new page is executed

Halt printing

To halt or to continue online printing:

  • carry out function Switch online printer on/off.

Changing and setting up a printer

To change the printer in Runtime:

  • Carry out the Switch online printer function

To set up the selected printer in Runtime:

  1. Configure a Print with dialog control element for the screen
  2. Click on the Print with dialog button in Runtime
  3. The configuration dialog is opened

Printer

Parameters | Description
Printer | Settings for the printer.
Name | Selection of the printer from the drop-down list. The list contains all printers configured in the operating system.
Properties... | Opens printer configuration dialog.
Status: | Display printer state. For information only.
Type: | Display printer type. For information only
Location: | Display the location of the printer if configured. For information only.
Comment: | Display comment about printer if configured. For information only.

Paper

Parameters | Description
Paper | Configuration of the printout.
Size | Select paper format from drop-down list.
Source | Select paper feed from drop-down list.

Alignment

Parameters

Description

Alignment

Select paper alignment. Possible parameter:

  • Portrait Format
  • Landscape

Network

Opens dialog for selecting a printer in the network.

OK

Applies configuration and closes the dialog. With this printing is started in the Runtime.

Cancel

Discards configuration and closes the dialog. In the Runtime this also cancels the printout.

Formatting example

Engineering in BTB.FRM:

Date: @DSYSTEM | Alarm inf. list/demo proj. | Time @TSYSTEM o'clock | Text
Date/Time received | Time cleared | Information text | Status text
%% |  |  |
@DTRECEIVED | @TCLEARED | @IDENTIFICATION | @TEXT
%% |  |  |
 | Page | @PAGE |

Printout on the printer

Date: 20.03.2011 | Alarm inf. list/demo proj. | Time: 12:00 PM: | Text
Date/Time received | Time cleared | Information text | Status text
20.03.2011 13:00:00 | 20.03.2011 1:03:59 PM | Message 1 | Limit exceeded
20.03.2011 13:00:00 | 1:05:35 PM | Demo information | Limit 750 reached
20.03.2011 1:03:59 PM |  | Message 2 | Limit
20.03.2011 1:11:23 PM |  | Message 3 | off
20.03.2011 1:03:59 PM | 1:12:45 PM | Demo information | off
 | Page | 1 |


Offline printing

Manual -> Chronological Event List (CEL) -> Operating during Runtime -> Print and export events -> Offline printing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Offline printing means that the CEL is printed our as it is displayed at the moment in the Runtime. This print out is a snapshot including all set filters and their restrictions. The print out is carried out regardless of whether the variables concerned having option print.

Print

To print the CEL offline:

  1. define a printer
  2. configure BTB_G.frm
  3. add file BTB_G.frm to node Files/texts and formats
  4. in the Runtime click button print or print with dialog.

Set up and change printer

Changing and setting up a printer

To change the printer in Runtime:

  • Carry out the Switch online printer function

To set up the selected printer in Runtime:

  1. Configure a Print with dialog control element for the screen
  2. Click on the Print with dialog button in Runtime
  3. The configuration dialog is opened

Printer

Parameters | Description
Printer | Settings for the printer.
Name | Selection of the printer from the drop-down list. The list contains all printers configured in the operating system.
Properties... | Opens printer configuration dialog.
Status: | Display printer state. For information only.
Type: | Display printer type. For information only
Location: | Display the location of the printer if configured. For information only.
Comment: | Display comment about printer if configured. For information only.

Paper

Parameters | Description
Paper | Configuration of the printout.
Size | Select paper format from drop-down list.
Source | Select paper feed from drop-down list.

Alignment

Parameters

Description

Alignment

Select paper alignment. Possible parameter:

  • Portrait Format
  • Landscape

Network

Opens dialog for selecting a printer in the network.

OK

Applies configuration and closes the dialog. With this printing is started in the Runtime.

Cancel

Discards configuration and closes the dialog. In the Runtime this also cancels the printout.

Formatting example

Configuration in BTB_G.FRM:

Date: @DSYSTEM | Closed Alarm Message List Demo Project | Time @TSYSTEM o'clock | Text
Date/Time received | Time cleared | Information text | Status text
%% |  |  |
@DTRECEIVED | @TCLEARED | @IDENTIFICATION | @TEXT
%% |  |  |
 | Page | @PAGE |

Printout on the printer

Date: 20.03.2011 | Closed Alarm Message List Demo Project | Time: 12:00 PM: | Text
Date/Time received | Time cleared | Information text | Status text
20.03.2011 13:00:00 | 20.03.2011 1:03:59 PM | Message 1 | Limit exceeded
20.03.2011 13:00:00 | 1:05:35 PM | Demo information | Limit 750 reached
20.03.2011 1:03:59 PM |  | Message 2 | Limit
20.03.2011 1:11:23 PM |  | Message 3 | off
20.03.2011 1:03:59 PM | 1:12:45 PM | Demo information | off
 | Page | 1 |


FRM configuration file

Manual -> Chronological Event List (CEL) -> Operating during Runtime -> Print and export events -> FRM configuration file

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

FRM files (format files) are configuration files for printing out lists.

The FRM file has three parts:

  • Header: at the beginning of the page
  • List part: cyclic per line
  • Footer: at the end of the page

Principles

When editing FRM files regard the following:

  • Separating the list parts:
    • Header and list part and list part and footer are seperated by %%.

      The separation marking must be used only once for the list and the footer.

    • Attention: The last line must be followed by at least two empty paragraphs. Otherwise the footer is not printed!
  • Positioning the individual entries:
    You may only use space, no tabulators.
  • Editing the FRM file in a text editor:
    Automatic line break must be deactivated otherwise undesired effects in the formatting may occur.

Keywords

The setting for the page length is made in Project Properties under AML and CEL or via the ALARM.frm or ALAR_G.frm file for the AML or BTB.frm and BTB_G.frm for the CEL.

Please keep in mind:

  • The number of the alarm entries per page results from the predetermined number of lines (e.g. Lines per page 72), less the lines used for header and footer text.
  • The Use reactivated time option must be activated in order to be able to use the keywords that evaluate the reactivation (time, number).
  • Free texts and keywords can be used in the formatting file. Key words can be used either in German or in English. The use of English key words is recommended.
  • Not every key word is suitable for every kind of printing (AML, CEL, online, offline).

The following list contains key words in English and German and their field of application.

German | English | AML offline | CEL offline | AML online | CEL online | Description
Key words for the list part
@BMKENNUNG | @RESOURCELABEL | X | X | X | X | Resources label
@DATZEITKOMMT | @DTRECEIVED | X | X | X | X | Time and Date when the alarm occurred
@DATZEITGEHT | @DTCLEARED | X | - | X | - | Time and Date when the alarm ended
@DATZEITOK | @DTACK | X | - | X | - | Time and Date when the alarm was acknowledged
@DATZEITREAKT | @DTREACTIVATE | X | - | X | - | Time and Date of reactivating: Property Use reactivated time in the project properties must be activated.
@DATZEIT | @DTLASTEVENT | - | - | X | - | Time and date of alarm received or cleared or acknowledged or reactivated
@ZEIT | @TLASTEVENT | - | - | X | X | Time of alarm received or cleared or acknowledged or reactivated
@ZEITOK | @TACK | X | - | X | - | only displays time of acknowledging
@ZTKOMMT | @TRECEIVED | X | X | X | X | only displays time of alarm received
@ZTGEHT | @TCLEARED | X | - | X | - | only displays time of end of alarm
@ZTREAKT | @TREACTIVATE | X | - | X | - | only displays time of reactivating
@TIMELASTING | @TACTIVE | X | - | X | - | Time active (difference time received - time cleared)
@ANWENDUNG | @PROJECTNAME | X | X | X | X | Project name
@KANALNAME | @VARNAME | X | X | X | X | Variable name CEL: Only entries with variables
@AK | @ACLASSNR | X | X | X | X | Alarm/event class name
@AG | @AGROUPNR | X | X | X | X | Alarm/event group number
@AGNAME | @AGROUPNAME | X | X | X | X | Name of alarm/event group
@AKNAME | ACLASSNAME | X | X | X | X | Name of alarm/event class
@TAGNR | @IDENTIFICATION | X | X | X | X | Identification (company-specific label)
@AMELDUNG | @TEXT | X | X | X | X | Alarm message text
@REAKTANZ | @NRREACTIVATE | X | - | X | - | Number of reactivations
@STATUS | @STATUS | X | X | X | X | Status information as in Alarm Message List
@WERT | @VALUE | X | X | X | X | Variable value of alarm
@REAKTIONSTEXT | @COMMENT | X | X | X | X | Commentary from the Alarm Message List. If you use dynamic limit texts, this is only available if properties Long dynamic limit texts AML or Long dynamic limit texts CEL are activated.
@USER | @USERID | X | X | X | X | AML: User who acknowledged alarm.
@RECHNER | @COMPUTER | X | X | X | X | AML: Computer on which alarm was acknowledged.
Key words for header and footer
@ANWENDUNG | @PROJECTNAME | X | X | X | X | Project name
@SEITE | @PAGE | X | X | X | X | Page number
@HEADDATZEIT | @DTSYSTEM | X | X | X | X | System date and system time
@HEADDATUM | @DSYSTEM | X | X | X | X | System date
@HEADZEIT | @TSYSTEM | X | X | X | X | System time
@USER | @USERID | X | X | X | X | User who prints
@USERNAME | @USERNAME | X | X | X | X | Full user name who triggered action
@RECHNER | @COMPUTER | X | X | X | X | Computer from which it is printed
[Text] | [Text] |  |  |  |  | Random text

attention Attention

Between the key words there must be enough space so that entries are not overwritten. In doing so, you make sure that long limit texts are also displayed correctly.

Example:

@TEXT (spaces up to here)


Export events

Manual -> Chronological Event List (CEL) -> Operating during Runtime -> Print and export events -> Export events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entries in the CEL can be exported to different formats:

  • dBase
  • CSV
  • XML
  • SQL

Export

To export entries from the CEL

  1. create function Export CEL
  2. link the function to a button
  3. execute the function in the Runtime

info Information

The export to SQL is incremental. If there is already exported data, only new and amended data is exported.


Command Sequencer

Manual -> Command Sequencer

The Command Sequencer module allows commands from the Command Processing module to be compiled into processes in zenon, to visualize these and to execute user interactions if required.


Introduction

Manual -> Command Sequencer -> Introduction

The module Command Sequencer consists of three parts:

  1. The engineering environment in the zenon Editor:
    Here, the data for command sequences is applied from the configuration in the Command Processing module.
  2. The Command Sequencer Editor in zenon Runtime:
    With this Editor, the command sequences are created in zenon Runtime. The configured command processing is the basis for command sequences. During the process, the respective status of the command processing is displayed in the Command sequencer Editor and you can make changes to the command sequence process.

Particular aspects of the Command Sequencer module

In contrast to most other zenon modules, a large part of the project configuration, namely the creation of a command sequence, is done in Runtime and not in the zenon Editor. This entails special features which are dealt with in the respective chapter.

The module is designed in a way which makes it completely independent of the control. This means that the data communication take place via all available zenon energy drivers with any PLCs or even IED. They only execute the process actions. The complete editing of a command sequence is carried out in the computer in the Command Sequences Editor. No modification to the PLC code is necessary when a change is made to a command sequence.

Principle structure of the communication

  • Command variable:
    The command variable is the variable that is linked during project configuration in the Command Processing module for the respective command action.
    With this variable, set values are transferred to the PLC when a step is executed.
  • Response variable:
    This variable is used to read back values from the PLC for evaluations.

Schema:

The PLC communicates with the zenon Energy driver, which in turn communicates with the command processing in zenon Runtime. The command processing sends the values back to the command sequence editor, where they are processed. Whilst executing a command sequence, the command sequence editor works synchronously to zenon Runtime in a cycle of 100 ms.


block - supported action types

Manual -> Command Sequencer -> Introduction -> block - supported action types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to be able to use configuration of the command processing in the Command Sequencer module, at least one action must be configured in the Command Sequencer module.

The following action types of command processing are supported in the Command Sequencer module:

  • Command
  • Forced command
  • Direct set value input
  • Direct status input
  • Replace
  • Revision
  • Direct correction
  • Block
  • Release
  • Check response value
  • Lock

info Information

You can find further information in the Energy Edition manual in the Action types chapter.


Variables for command sequences

Manual -> Command Sequencer -> Introduction -> Variables for command sequences

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon When compiling the command processing, the data model for command sequences is also created.

This is created as follows:

  • An item of switchgear is created for each response variable, which gets the variable name or variable identification of the response variable as a name.
    This created switching device is assigned the response variable. Return TAG is used as a type. Data type is: Numerical.
    The naming of the switching device can be configured in the Command Sequencer project property in the Display name in Command Sequencer Editor property.
  • A step is created for each action that is configured in the Command Processing module and for which a response variable is available. The step is given the name of the action that is displayed in the command processing tree.
  • The response variable is linked to each step created as a parameter. These parameters are, for example, significant when creating transitions.

Display name in Command Sequencer Editor

The text display of a variable in Runtime is configured in the Command Sequencer project property group in the Display name in Command Sequencer Editor property.

Depending on the configuration, the variable is displayed in the command sequence grid accordingly when shown in Runtime.

Possible display names:

  • Variable name
  • Variable identification
  • symbolic address

Validation:

A check is carried out when compiling the Runtime files in the zenon Editor.

In doing so, a check is made to see if the naming of the created switching device is unique. If this is not unique, an error message is issued in the output window of the Editor. No objects that are available for the command sequences are created for the response variable.

Error messages:

'<VariablenameX>' variable ignored for the command sequence data model, because the '<VariablennameY>' variable has already created an entry '<Naming in Command Sequences>'! Possible cause: not a unique ID or symbolic address.

A check is also carried out to see whether the variable can provide an invalid object name for the command sequence object.
'<Variablename>' variable ignored for the command sequence data model because this gives and invalid '<command sequence object name' object name! Possible Reason: empty Identification or empty symbolic Address.


Examples of views - Display name in command sequence grid

Manual -> Command Sequencer -> Introduction -> Variables for command sequences -> Examples of views - Display name in command sequence grid

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Examples of views for possible configurations of the variable names.

Display name in command sequence grid

Variable name

Variable identification

symbolic address


Terminology

Manual -> Command Sequencer -> Terminology

The following terms are used In the zenon Command Sequencer module:

Parameters

Description

Switchgear

Physically available element, for example: Switch or disconnector.

Command Sequencer Editor

Part of the Command Sequencer module to control the process of command processing. The command sequence editor carries out a command sequence in test mode. The complete process of the command sequence can be configured in the command sequence and the command sequences can be administered in the editing mode.

Command sequence

Command steps are compiled and saved in command sequences. These steps are then transferred to the controller by the control system.

Begin parallel branch

Element that ensures the breakdown of the command sequence process into two or more branches.

Transition

Element of the Command Sequencer module that contains a condition. The element is used after a step to ensure a defined transition from one step to the next.

Step

Execution of an action from the command processing, such as: Switching command: OFF.

End parallel branch

Element that combines the separation of the command sequence process into two or more branches back into one branch.

Branch

Area of the Command Sequencer module that allows separation into two or more branches, of which only one branch can be active during the process. It is an either/or branch. A branch always starts with the Begin branch and ends with the End branch element.

Assignment of switching device

Element of the Command Sequencer module that instigates the assignment of a switching device in Runtime:

  • With this element, several (or all) response variables can be reserved (assigned) in advance. The NET_SEL status bit is set for this reservation.
  • Unlocking is also carried out using a switchgear assignment element.
  • After the command sequence process, all NET_SEL status bits are automatically deleted again.

You can find further information on the status bit in the Status processing manual in the Select in the network (NET_SEL) section.

Branch

An execution area in the Command Sequencer module. Steps, transitions and jump targets can be placed on it.

End of element

Element of the Command Sequencer module with which each command sequence is forced to end.

Jump target

Element of the Command Sequencer module that allows a direct jump to a defined location of a branch.


Procedure

Manual -> Command Sequencer -> Procedure

Configuration and use use of the Command Sequencer module takes place in three main steps:

  1. Configuration of the command processing in the zenon Editor.
  2. Creation of the command sequences in the command sequence editor in Runtime.
  3. Execution of the command sequence in Runtime.

Creation of a command sequence

The user creates a command sequence in zenon Runtime. The selectable steps that correspond to the actions of command processing serve as a basis for this configuration. To do this, the command sequence in Runtime must be in edit mode.

Execution of a command sequence

The user executes the command sequence in Runtime. To do this, they first change the command sequence mode to test mode. The command sequence is then started.

The user can no longer alter command sequences in test mode. The command sequence must be switched to edit mode again in order to edit it.


Licensing

Manual -> Command Sequencer -> Licensing

The Command Sequencer module offers you the possibility to create, execute and configure command processes in a graphic flow chart.

The module can only be licensed in addition to the Energy Edition.

tutorial License information

Must be licensed for Editor and Runtime (single-user, Server, Standby and Client).

If both the Batch Control module and the Command Sequencer module, which both require a license, are licensed at the same time, selection of the module used is carried out by means of the project setting.

To select the preferred module in Runtime:

  • Click on the node of your project in the Editor.
  • Go to the Runtime settings project properties group.
  • Select, for License module in Runtime of the the Preferred module property, command sequence(default) or Batch Control.

The selected model is then available in Runtime for further project configuration.


Engineering in the Editor

Manual -> Command Sequencer -> Engineering in the Editor

To be able to use the Command Sequencer module in Runtime, you must first do the following in the zenon Editor:

  • Configure command processing.
  • Configure variables.
  • Create a command sequence screen
  • In the command sequence screen, add the command sequence editor control element.
  • Create a screen switch function for the command sequence screen

If the configuration in zenon Editor changes, this is applied by compiling the Runtime files and reloading them in zenon in the Command Sequencer module.


Create a command sequence screen

Manual -> Command Sequencer -> Engineering in the Editor -> Create a command sequence screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In a command sequence screen, command sequences are:

  • created
  • managed
  • executed in the Runtime

The display size of the screen depends on the selected template size.

To create a command sequence screen:

  1. Select the New screen command in the Screens node
  2. In the screen type column, select command sequence in the combo box
  3. in the menu bar Control elements select one of the three default settings:
    • Insert template ...: Offers templates for different resolutions and the selection of command sequences.
    • Command sequence editor: adds the screen element for the command sequence editor.
  4. the default elements for the desired setting are created
  5. if needed you can add additional control elements from menu Control elements
  6. create a screen switch in order to display the screen in the Runtime
  7. Configure the display in Runtime (for details, see the screens manual, Designing lists chapter)


Command sequence screen switching

Manual -> Command Sequencer -> Engineering in the Editor -> Command sequence screen switching

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use command sequences in Runtime, configure a screen switch function to a command sequence screen:

  1. Select the New function command in the Functions node.
  2. select the Screen switching function.
  3. select the Command Sequencer screen

Link the function with a button on the screen in order to be able to switch in Runtime.

info Information

The configuration of the Command processing module serves as a basis for operation in the Command Sequencer screen.


Project backup for command sequences

Manual -> Command Sequencer -> Project backup for command sequences

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

a project backup in the zenon Editor does not take into account the command sequences configured in Runtime.

Back up the corresponding Runtime files manually.

Back up the command sequence Runtime files:

  1. Switch to the folder of the Runtime files.
    C:\Users\Public\Documents\zenon_Projects\[Workspacename]\[Projectname]

    Note: This folder is only available if the project has been compiled at least once in zenon .
    Tip: Highlight the desired project in the zenon Editor and press the keyboard shortcut Ctrl + Alt + R to go directly to the Runtime folder.
  2. Copy the Sequences folder.
  3. Add the Sequences folder to the Runtime folder of the project backup again.
    Note: Runtime should be closed during the copy process and then reopened again.


Function authorizations

Manual -> Command Sequencer -> Function authorizations

There are no separate function authorizations for the Command Sequencer module.


Command sequences in Runtime

Manual -> Command Sequencer -> Command sequences in Runtime

All administration, creation and processing of command sequences is carried out in Runtime. Editing in the zenon Editor is not possible.

Saving of command sequences when closing Runtime

If Runtime is closed and there are still command sequences that have not been saved, you are asked if these command sequences are to be saved. In order for this query to not prevent Runtime closing, Runtime is automatically closed after 15 seconds if nothing is entered. Unsaved command sequences are then discarded.

  • Clicking on the Yes button saves all changes for all command sequences open in the command sequences Editor. Runtime is then closed.
  • Clicking on the No button closes Runtime without saving changes to the command sequences.


Command Sequencer Editor

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The command sequence editor is the graphical user interface for the configuration of command sequences in Runtime.

The following are available for the command sequence editor:

  • Tool bars
    The design of the tool bars depends on the command sequence editor mode.
  • Tabs
  • Command sequence grid
    project configuration area
  • Dockable windows

Parameters

Description

Header of the editor

Information about:

  • Current command sequence
  • Mode

command sequence editor menu bar

Menu bar with symbols to configure a command sequence.

Tabs with opened command sequences

Select the open command sequences by clicking on the respective tab.

In test mode, the color of the tab corresponds to the color of the execution status of the command sequence.

Command sequence grid

Diagram of the project configuration.

Configuration by dragging & dropping the elements from the menu bar.

Hint: To enlarge or reduce the grid, position the mouse pointer at the edge and drag it in the desired direction with the mouse button held down.

Mode display

Status display of the selected mode:

  • Edit mode:
    • Symbol for editing mode (pencil)
    • Size of the command sequence window
    • Number of configured elements
  • Test mode:
    • Symbol for test mode:
      - Automatic
      - Manual
    • Symbol for the status
      (green thumb: ready to start)
    • Execution step:
      - in execution
      - completed

Cursor position

Shows line and column of the selected choice in the command sequence grid.

Zoom bar

Setting of the zoom factor for the command sequence grid with slider.

+

Enlarges the zoom factor by 25% per click.

-

Reduces the zoom factor by 25% per click.

Selection of the dockable windows

Opens drop-down list to select the dockable windows:

  • List of command sequences

Selected dockable windows are shown or hidden.


Context menu - tabs with opened command sequences

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Context menu - tabs with opened command sequences

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If several command sequences are open in the command sequence editor, these are represented with tabs. The tabs represent the command sequences that are open in the command sequences editor. The configuration of the command sequence in the command sequence grid is shown by clicking on a tab.

Tab context menu

Parameters

Description

Save

Saves the current command sequence

Close

Closes the current command sequence

Close all others

Closes all open tabs/command sequences with the exception of the one that is currently selected.

Group horizontally

Shows all open tabs in a new view.
The view opens in a new window under the current view:

  • Move view
    Opens tab in a new window.
  • Open view at the same time
    Opens selected tab in a new window and leaves it in the tab list.

Group vertically

Shows all open tabs in a new view.
The view opens in a new window next to the current view:

  • Move view
    Opens tab in a new window.
  • Open view at the same time
    Opens selected tab in a new window and leaves it in the tab list.

Command sequences can be displayed and opened in two groups next to each other or underneath each other. To open a command sequence in a new group:

  1. Select, in the context menu of the command sequence, the Group horizontally or Group vertically command
  • Select the type of display:
    • Move display
    • Open display at the same time

The control elements are always only applicable to the active command sequence of the active group.

  • The active group is emphasized in color.
  • The active tab is emphasized with bold font. Information on the active tab is shown in the title bar of the editor.
  • Tabs can be moved and arranged by dragging & dropping, including between groups.
    Hint: Use this possibility of moving to return to the view with one group when two groups are open.


Dockable windows - list of command sequences

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Dockable windows - list of command sequences

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The list of command sequences lists all configured command sequences. Command sequences that have already been configured are edited and administered in the list of command sequences and new command sequences are created.

List of command sequences - overview:

  • New command sequences are created.
  • Command sequences that have already been configured in the command sequence editor are loaded for further editing.
  • Command sequences are renamed.
  • Command sequences are duplicated.
  • Command sequences are deleted.
  • Command sequences are switched to test mode.
  • Command sequences are switched to edit mode.
  • Columns are selected and formatted.

The columns of the list for command sequences can be sorted and filtered. The columns can be moved by means of drag&drop. Columns can be shown and hidden with the context menu (right mouse click).


Selection and positioning

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Dockable windows - list of command sequences -> Selection and positioning

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Positioning aids

When moving windows from the Editor interface, positioning aids are displayed. These represent windows or their borders.

This element represents a window area in the Editor.

This element represents the border area of the Editor.

Position window

To position an element as docked:

  1. Move the element with the mouse into the desired area
  2. The positioning aid is displayed
  3. This represents a window and its areas:
    1. Center: whole window
    2. Top: upper half
    3. Bottom: lower half
    4. Right: right half
    5. Left: left half

    or the border of the Editor

  4. Move the mouse to the central positioning aid or to a positioning aid on the border of the editor and from there to the desired area
  5. The area in the Editor where the element was placed when the mouse button was released is colored in blue
  6. Move the mouse within the positioning aid to the desired area that is displayed in blue
  7. Let the mouse button go and the element is placed

If a window is placed on a pre-existing window, both windows are displayed at the same location using tabs.


Tool bar - list of command sequences

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Dockable windows - list of command sequences -> Tool bar - list of command sequences

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters

Description

New command sequence

Creates new empty command sequence

Open command sequence in Editor

Opens the selected command sequence in the command sequence editor.

Note: Not active if no command sequence is selected.

Rename command sequence

Opens dialog to create a new command sequence or rename a command sequence.

Note: Not active if no command sequence is selected.

Note: Not active if the selected command sequence is in test mode.

Duplicate command sequence

Duplicates selected command sequence and opens dialog to create a new command sequence.

Note: Not active if no command sequence is selected.

Note: duplicated command sequence is automatically created in edit mode. When duplicating command sequences, the existing name is supplemented with the prefix "Copy of". If the maximum length is exceeded by this, the name is shortened to the allowed length starting from the last character.

Delete command sequence

Deletes selected command sequence(s). Multiple selection is possible.

A command sequence that is executed cannot be deleted. An information dialog opens in this case.

Note: Not active if no command sequence is selected.

Note: Before final deletion, an additional dialog appears requesting confirmation of whether the selected command sequence(s) are really to be deleted for good.

Switch command sequence to test mode

Switches selected command sequence(s) to test mode.
A validation of the configured command sequence is carried out automatically. Test mode only starts if the command sequence has been configured without errors.

Otherwise a notice dialog appears informing you that the command sequence is invalid. The command sequence cannot be started.

Note: Not active if no command sequence is selected.

Switch command sequence to edit mode

Switches a command sequence that is currently running in test mode back into edit mode in order to make changes.

Note: Not active if no command sequence is selected.

Column selection

Opens a dialog to select columns that are to be displayed.

Column formats

Opens dialog for the configuration of text and background colors for the display of columns in the list view.


Column selection

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Dockable windows - list of command sequences -> Tool bar - list of command sequences -> Column selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column selection

Button | Function
Available columns | List of columns that can be displayed in the table.
Selected columns | Columns that are displayed in the table.
Add | Moves the selected column from the available ones to the selected items. After you confirm the dialog with OK, they are shown in the detail view.
Add all | Moves all available columns to the selected columns.
Remove | Removes the marked columns from the selected items and shows them in the list of available columns. After you confirm the dialog with OK, they are removed from the detail view.
Remove all | All columns are removed from the list of the selected columns.
Up | Moves the selected entry upward. This function is only available for unique entries, multiple selection is not possible.
Down | Moves the selected entry downward. This function is only available for unique entries, multiple selection is not possible.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Column Format

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Dockable windows - list of command sequences -> Tool bar - list of command sequences -> Column Format

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column Format

Parameters

Description

Available columns

List of the available columns via Column selection. The column selected here is configured using the settings in the Parameters section.

Parameters

Settings for selected column.

Labeling

Name for column title. The column title is online language switchable. For this you must enter the @ character in front of the name.

Width

Width of the column in characters.
Calculation: Number time average character width of the selected font.

Alignment

Alignment.

Possible settings:

  • Left: Text is justified on the left edge of the column.
  • Centered: Text is displayed centered in the column.
  • Right: Text is justified on the right edge of the column.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog.


Tool bar - list of command sequences

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Dockable windows - list of command sequences -> Tool bar - list of command sequences

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters

Description

New command sequence

Creates an empty command sequence and opens the dialog to create a new command sequence.

Open in command sequence editor

Opens the selected command sequence in the command sequence editor.

Note: Not active if no command sequence is selected.

Rename

Opens dialog to create a new command sequence or rename a command sequence.

Note: Not active if no command sequence is selected.

Note: Not active if the selected command sequence is in test mode.

Duplicate

Duplicates selected command sequence and opens dialog to create a new command sequence.

Note: Not active if no command sequence is selected.

Note: duplicated command sequence is automatically created in edit mode. When duplicating command sequences, the existing name is supplemented with the prefix "Copy of". If the maximum length is exceeded by this, the name is shortened to the allowed length starting from the last character.

Delete

Deletes selected command sequence(s). Multiple selection is possible.

Note: Not active if no command sequence is selected.

Note: Before final deletion, an additional dialog appears requesting confirmation of whether the selected command sequence(s) are really to be deleted for good.

Switch to test mode

Switches selected command sequence(s) to test mode.
A validation of the configured command sequence is carried out automatically. Test mode only starts if the command sequence has been configured without errors.

Otherwise a notice dialog appears informing you that the command sequence is invalid. The command sequence cannot be started.

Note: Not active if no command sequence is selected.

Switch to edit mode

Switches a command sequence that is currently running in test mode back into edit mode in order to make changes.

Note: Not active if no command sequence is selected.


Command sequence grid

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Command sequence grid

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The command sequence grid is the workspace in the command sequence editor. Command sequences can be created with a graphical user interface here.

The diagram is divided into grids, with each grid offering room for one element.

Technical details

  • Sheet size:
    • Default: 11 x 11 cells
    • Minimum: 5 x 5 cells
    • Maximum: 500 x 1000 cells
  • Cell size
    • Default: 155 x 111 pixels
  • Outside edge: 100 pixel
  • Grid: is displayed by default; can also be hidden
  • Scroll bar: Is displayed if the document is larger than the frame.
  • Scrolling via mouse wheel: up and down or if you press and hold Shift left and right.
  • Zooming: Ctrl + mouse wheel
  • Selecting elements: left mouse click
  • Multiple selection: Ctrl + mouse click
  • Move symbol: Click element and move it over the diagram while holding the left mouse button pressed. Content can be dropped to cells with green background. If a cell turns red when you move over it, you cannot drop the content.


Modes

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Modes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The command sequence editor has several modes:

  • Edit mode
    Command sequences are configured and edited in this mode
  • Test mode
    Mode for testing and execution of the configured command sequences.
    The test mode has two modes:
    • Automatic mode
    • Semi-automatic mode


Command sequence - test mode

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Modes -> Command sequence - test mode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The command sequence editor executes command sequences in Runtime. You can start any number of command sequences. Test mode is for testing a command sequence but also to execute this. In addition in the test mode changes in the Editor can be applied directly via reloading the Runtime.

Exception: If a command sequence is currently being executed, the reloading of this command sequence is delayed. The reloading process is only carried once the command sequence has finished, been stopped or been canceled.

The following modes are available for execution in test mode:

  • Automatic mode
    The configured command sequence is executed in automatic mode. The command sequence is only stopped in the event of pending user interaction.
  • Semi-automatic mode
    There is a pause after each step in semi-automatic mode. A jump to the next step is only made after a corresponding click Configuration can thus be tested step by step.

info Information

The fundamental command sequence process cannot be changed in test mode. You can only change values of the command tags.


Automatic mode

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Modes -> Automatic mode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A configured command sequence runs in automatic mode. This mode is also used to visualize and control a configuration in Runtime.

If user interaction is necessary, the configured command processing screen is called up. The command sequence continues after an entry is made in the command processing.


Semi-automatic mode

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Modes -> Semi-automatic mode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The configured command sequence is executed in automatic mode. The command sequence is only stopped in the event of pending user interaction.

Only after corresponding user interaction on the Continue command sequence at all execution positions button or Only continue command sequence at corresponding execution positions does the next step become active. This mode is thus suitable for stepping through a command sequence step by step.


Tool bar - command sequence editor (edit mode)

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In edit mode of the command sequence editor, you can easily configure a command sequence in Runtime directly by means of drag&drop.

Parameters

Description

New command sequence

Creates new command sequence.

Save command sequence

Saves configured command sequence

Graphical design

Calls up dialog to select the graphical design.

The following can be selected:

  • Background color
  • Grid On/Off
  • Grid color
  • Display element ID

Delete

Deletes selected element

Note: only active if an element was selected in the command sequence grid.

Check command sequence for errors

Checks configuration of a command sequence for logical correctness and consistency.

The result is displayed in a dialog.

  • No errors during this command sequence.
  • Checking the command sequence resulted in the following warnings/errors:
    {error details}

Edit element

Calls up a dialog to change the element property for switchgear assignment and transition.

Note: not available for step.

Replace step

Opens the dialog to select a command processing action. As a result of this, already-configured steps can be assigned new actions.

Note: only active if an element was selected in the command sequence grid.

Edit mode

Switches the mouse cursor from adding an element to edit mode. The switch back to the edit mode can also be achieved by pressing the Esc key.

Add step

Occupies the mouse pointer with a step. It can be added to any allowed, free location via click.

Opens the dialog to select a command processing action.

Insert transition

Occupies the mouse pointer with a transition. It can be added to any allowed, free location via click.

Insert Begin parallel branch

Occupies the mouse cursor with a begin parallel branch. It can be added to any allowed, free location via click.

Insert End parallel branch

Occupies the mouse cursor with an end parallel branch. It can be added to any allowed, free location via click.

Insert Begin branch

Occupies the mouse cursor with a begin branch. It can be added to any allowed, free location via click.

Insert End branch

Occupies the mouse cursor with an end branch. It can be added to any allowed, free location via click.

Insert switchgear allocation

Occupies the mouse pointer with a switchgear allocation. It can be added to any allowed, free location via click.

Insert jump target

Occupies the mouse cursor with a jump target. It can be added to any allowed, free location via click.

Switch command sequence to test mode

Switches command sequence to test mode.


Graphical design

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode) -> Graphical design

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Clicking on the symbol for the graphical design in the tool bar opens the dialog for configuring the colors, grid settings and display of the element ID.

Parameters

Description

Background color

Defines the background color of the command sequence grid. Click on the color in order to open the palette for selecting a color.

Display grid
  • Active: Display the grid
  • Inactive: Grid is hidden.

Grid color

Defines the line color of the grid. Click on the color in order to open the palette for selecting a color.

Display element ID

Shows or hides the element ID. This setting is to be made for each command sequence.

Inactive: No element ID is shown in the command sequence.
Note: This setting is recommended for normal operation.

Active: The ID of the elements is displayed in the command sequence. The exception is lines. The display is in the upper left-hand corner of the element.

Hint: This setting is recommended for troubleshooting.

OK

Applies all settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Examples

Display IDs of the elements active

Display IDs of the elements inactive


Elements

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode) -> Elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following elements can be used for the configuration of a command sequence in the command sequence editor:

  • Step
  • Transition
  • Parallel branch
  • Branch
  • Switchgear allocation
  • Jump target
  • Lines

Start and end element

Each command sequence must have a start and end element.

These two elements are automatically created when a command sequence is created and cannot be deleted from the project configuration. Even if you have configured the complete project configuration and deleted it, the start element and the end element are not affected by this deletion.

Configuration of an element:

  • Set the command sequence editor to edit mode.
  • Select an element in the command sequence editor with a mouse click.
  • Position this element in the command sequence editor by means of drag&drop.
    Note: You can position the element several times.
  • Clicking on the Esc button deactivates the drag&drop functionality.


Step

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode) -> Elements -> Step

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Step

A step is always linked to a configured action of command processing in the Command Sequencer module. The actions are configured in the zenon Editor in the Command Processing module.

After positioning of a step in the command sequence grid, the Select the action dialog opens automatically. In this dialog, you select an action from the list of all actions of all command groups configured in the zenon Editor.

Action selection

Select an action and confirm the selection with OK. The command processing action is assigned to the step as a result.

Note: The OK button is active if no action has been selected. Only the linking of an action is permitted for a step.

info Information

You can find further information on configuration of the command processing in the Energy Edition manual in the Command processing chapter.


Transitions - conditions

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode) -> Elements -> Transitions - conditions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Transitions - conditions

Transitions are used after steps in order to ensure a defined transition from one step to the next. Transitions display their internal status during the process and inform via a tool tip about status and process duration.

After positioning a transition in the command sequence grid, the Condition dialog opens automatically.

Select a response variable from the list of parameters. You get this list if you click on the Add button.

This list contains the response variables of all steps that have already been inserted into the command sequence grid.

info Information

You can find further information on conditions in the Formula editor chapter in this manual.


Parallel branches

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode) -> Elements -> Parallel branches

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Parallel branches

At the parallel branch an execution path parts into several execution paths which are executed in parallel during the process. For the activation of the different elements within a parallel branch you cannot define a certain order.

The project configuration always consists of a Begin parallel branch and an End parallel branch.

Begin parallel branch

End parallel branch

In the process the respective intermediate area of the end parallel branch is also colored. The color corresponds to the coloring of the command sequence.

A parallel branch is ended if the process has been completed in all execution paths. Completed means that either the following step is active or the following transition is inactive.

Insert parallel branches

To create a parallel branch:

  1. select the symbol Insert begin parallel branch
  2. put the branch on the desired location
  3. connect the input connection point with a output connection point of the preceding object
  4. connect both output connection points with the desired following objects
  5. close a parallel branch with object Insert end parallel branch


Branch

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode) -> Elements -> Branch

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Branch

A branch offers the possibility to execute one of several possible paths. To do this, it is necessary that the first element at the start of a procedure path is a transition.

Note: A Begin branch can only be have a transition as a subsequent object.

Begin branch

End branch

Procedure:

  • The procedure path for which the first transition is TRUE is chosen.
  • Then it is waited until all transitions have a value.
  • If several transitions are TRUE at the same time, always the leftmost path for which the transition is TRUE is selected.

For begin and end the following is true: If there is a step in front of the element and a transition behind, the step remains active until the transition has been completed.

The objects are processed sequentially in a path. Each path processes its objects regardless of other paths.

Command sequences can select sequences and run in parallel branches.

branches and parallel branches consist of:

  • single/double horizontal lines
  • Connection pieces (consisting of connection line and connection point)

Create a branch

To create a branch:

  1. Select the Insert begin branch symbol
  2. Position the branch at the desired location.
  3. Connect the input connection point to an output connection point of the preceding object.
  4. Connect both output connection points with the desired following objects.
  5. Close a branch with the Insert end branch object


Modify parallel branches and branches

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode) -> Elements -> Modify parallel branches and branches

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Modify parallel branches and branches

Modify and move

Branches and parallel branches can be moved and changed in size.

Move

To move an object:

  1. click on the object.
  2. Hold down the mouse button.
  3. Move the object to the desired position.

Change size

In this way object Begin/End branch/parallel branch can be extended and shortened. To change their size:

  1. Move the mouse pointer over the object until it turns into a double arrow.
  2. Hold down the left mouse button and move it in the desired direction:
    • Away from the object to extend it.
    • Into the object to shorten it.
    • The line to continue the command sequence remains unchanged each time.
  3. at extending a new connection piece is added;
    • All fields in which lengthening is possible are colored green.
    • The process must be repeated to add several new connection pieces.
  4. All corresponding connection pieces are deleted during shortening.


Switchgear allocation

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode) -> Elements -> Switchgear allocation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Switchgear allocation

Each item of switchgear is represented by its response variable.

The switchgear allocation element of the module allocates one or more switching devices in Runtime:

  • With this element, several (or all) response variables can be reserved (assigned) in advance. The NET_SEL status bit is set for this reservation.
  • Unlocking is also carried out using a switchgear assignment element.

After the command sequence process, all NET_SEL status bits are automatically deleted again.

List of switchgear

Lists all available switchgear, its assignment and unlocking type. The list can be sorted - multiple selection is possible.

Parameters

Description

Switchgear

Switchgear according to configuration of the command processing in the zenon Editor.

Allocation

Yes, if Switchgear allocation is active.
Empty if Release is active.

Release

Yes, if Switchgear release is active. In addition, the extent of the release is shown as text:

  • selective
  • global

Empty if allocation is active.

Action

Parameters | Description
Switchgear allocation | If activated, the element is allocated to selected switchgear.
Switchgear release | If active, the element releases the selected switchgear.
Clearing the last allocation | If active, only the switchgear that was allocated in the last allocation is released. Only active if release for the switchgear is active.
Global command sequence release | If active, the switchgear that is allocated in the current allocation is released. Only active if release for the switchgear is active. Note: Allocated switchgear is automatically released again if the command sequence has been completed successfully or canceled.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.


Jump target

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode) -> Elements -> Jump target

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Jump target

The jump target element allows a direct jump to a defined point of a branch.

Jump targets make it possible to

  • To jump between procedure paths
  • To jump out of branches
  • engineer loops

Jump targets consist of tree inputs and one output. At this the output is always at the bottom and the inputs are located at the top and the sides. You can connect any input connection points. A path which ends in a jump target must have started with a Begin branch. Otherwise the end is not reached.

During the editing all connection points are visible. In the checking mode only the connection points which are connected are displayed.

attention Attention

Jump targets are not allowed for parallel branches.


Lines

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode) -> Elements -> Lines

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Lines

Lines connect elements via free connection points. To connect connection points with each other:

  1. Activate a point with the help of the mouse:
    The connection point turns green. Red means that the connection point is already taken.

  2. Drag a line to another connection point:
    A yellow arrow shows the direction of the line.. Green fields can be crossed. Red fields may not be crossed by the line.

  3. As soon as the yellow tip of the line touches the next connection point, the line is created.

Using trend curves

Lines:

  • Are dragged with the mouse.
  • Can be moved (press and hold Ctrl key)
    In doing so, all existing connections are separated and an attempt is made to reconnect the line if there are objects with connection points in the right direction at the target.
    If several lines are highlighted, the line that has a cell with mouse cursor in it is moved.
  • Can be deleted by highlighting them and pressing the Del key.
  • Are deleted when re-dragging them from the start to end.
  • have a tool tip displaying its ID.

If a line reaches a connection point of an object, the connection point becomes active. If a connection is possible, it turns green otherwise red. Connections connecting two connections points of the same type - two inputs, two outputs, etc. - are not allowed. The line can be added in any case. Not allowed connections are displayed in red and trigger a corresponding error message at testing.

The connection points of the elements are always displayed in the edit mode even if the connection point in question is connected. In status "Release" no connection points are displayed.

Properties connection point:

  • connected: highlighted red; connection is separated when the line is dragged and a new connection point can be chosen
  • open: highlighted green; at dragging a new line is created

Lines connect elements

  • Lines can be used as connections between all elements. It is allowed to add any number of lines after another.
  • Lines must not be used to connect two equal connection points.
    For example: Both inputs of two steps must not be connected directly with a line. In the engineering this connection is allowed. It is however displayed in red (error) and in the validation an error message is displayed.


Formula editor

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode) -> Formula editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The formula editor is automatically opened if you need to enter or edit a formula. Above all:

Runtime:

  • Editing transitions.

Note: If the step referenced in the formula is removed and a new step is added, the operands are reassigned in the case of operands. To do this, the same step must be reinserted. Parameters from a different phase are not automatically linked.

Enter formula

The following input is accepted:

  • Constant as decimal number
  • Hexadecimal number if it is preceded by an x
  • Dot as decimal separator; the following is true:
    • Comma is automatically converted into a dot: 23,000 to 23.000
    • Decimal places which are only zeros are removed: 23.000 to 23

Parameters

Description

TAG list

List of the tags which can be used for the formula.

Each entry contains of:

  • a basis node for the label
  • a value
  • a status
  • the bits for value and status

A symbol at the first node displays whether it is a command or return tag.

The short indetifier at the beginning of the name is used for the formula.

Add

Opens the dialog for adding a parameter. For this, the following applies:

  • The following can be added: numeric and binary tags and tags for time duration. Values for duration are converted to seconds
  • For conditions of a step, only the properties that were created for it can be used.
  • Tags can be added multiple times.

Replace

Makes it possible to replace a tag. Clicking on the button opens the dialog to add a parameter.

  • Selection of a new parameter replaces the highlighted parameter.
  • Clicking on the no selection button deletes the highlighted parameter from the list.

The short identifier remains the same at replacing.

Remove

Removes the highlighted tag. For a tag to be deleted:

  • the formula must be correct
  • the selected tag must not be used in the formula

Logical operators

Via the buttons for operators, operators are added to the formula.

AND

logical 'AND'

OR

logical 'OR'

XOR

logical 'EXCLUSIVE OR'

NOT

Negation

Syntax

The operator buttons add the string shown on them to the formula.

(

Open parenthesis

)

Close parenthesis

Bit by bit and relational operators

&

And

|

Or

>

greater than

>=

greater or equal

<

less than

<=

Less then or equal

=

equal

<>

less or greater

Condition

Configuration and display of the formula.

Copy

Copies the whole formula:

  • All configured tags from the tag tree
  • Formula from the field

Paste

Pastes a formula from the clipboard. At this all already configured elements are deleted and replaced by the copied formula.

When copying formulas between steps, an attempt is made to resolve the operands via their names. For tags which are not found invalid entries are created in the operands list. Their point of use in the formula remain the same.

OK

Applies formula and closes the dialog.

For this the formula must be correct.

Cancel

Discards all changes and closes the dialog.

info Information

You can link up to 99 tags in a formula. X01 to X99. The length of the formula must not exceed 4096 characters.

The meaning of the bits:

Parameters | Description
value bits | 32 value bits (from 0 -31) are available. They describe the tag value bit by bit. For binary tags only bit 0 is of importance, for SINT and USINT only the bits from 0 - 7, etc.
State bits | Here you find the most commonly used status bits. You find the exact definition and use of the status bits in the Status Bits List.
value and status | In the formulas, all values (value bits and status bits) are treated as binary values and can be logically linked with AND, OR, etc. The total value and overall status are an exception to this. In order to get a Boolean result this total value has to be ORed with a constant bitwise. For this, we use the operator &. For the result 0 (false) of this logical ORing we get the binary value 0 (false), otherwise 1 (true). Example: see chapter Example bit by bit ORing

info Info

The status bits NORM and N_NORM are only available in the formula editor and cannot be engineered via the status.

info Information

Formulas with binary X values and bitwise linking can be used with a maximum of 2 binary values. If more values are required, the linking must be carried out without binary X values.

Example:

X01.Value & X02.Value -> works

X01.Value & X02.Value & X03.Value -> does not work

But:

X01.00 AND X02.00 AND X03.00 AND X04.00 AND X05.00 -> works


Adding parameters

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode) -> Formula editor -> Adding parameters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Adding parameters

Clicking on the Add button in the formula editor opens the dialog to select parameters that are to be used for a formula.

Parameters | Description
Project list | Display of the active project. Only parameters that have been created in the active project for the step to be configured can be selected.
Parameter List | List of the parameters available for the selected step. Multiple selection is possible. Apply by selecting and and clicking on the OK button or by double clicking on a parameter.
No selection | Deletes parameters already set. Only effective for replacement of parameters. If a parameter is highlighted in the formula editor and this dialog is opened by clicking on the Replace button, then clicking on the No selection button deletes the parameter from the list in the formula editor. The short identifier remains the same at replacing.
OK | Inserts selected parameters into the parameter list of the formula and closes the dialog.
Cancel | Discards selection and closes dialog.
Help | Opens online help.


List of status bits

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode) -> Formula editor -> List of status bits

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
List of status bits
Bit number | Short term | Long name | zenon Logic label
0 | M1 | User status 1 | _VSB_ST_M1
1 | M2 | User status 2 | _VSB_ST_M2
2 | M3 | User status 3 | _VSB_ST_M3
3 | M4 | User status 4 | _VSB_ST_M4
4 | M5 | User status 5 | _VSB_ST_M5
5 | M6 | User status 6 | _VSB_ST_M6
6 | M7 | User status 7 | _VSB_ST_M7
7 | M8 | User status 8 | _VSB_ST_M8
8 | NET_SEL | Select in the network | _VSB_SELEC
9 | REVISION | Revision | _VSB_REV
10 | PROGRESS | In operation | _VSB_DIREC
11 | TIMEOUT | Runtime exceedance | _VSB_RTE
12 | MAN_VAL | Manual value | _VSB_MVALUE
13 | M14 | User status 14 | _VSB_ST_14
14 | M15 | User status 15 | _VSB_ST_15
15 | M16 | User status 16 | _VSB_ST_16
16 | GI | General interrogation | _VSB_GR
17 | SPONT | Spontaneous | _VSB_SPONT
18 | INVALID | Invalid | _VSB_I_BIT
19 | T_CHG_A | Daylight saving time/winter time announcement | _VSB_SUWI
20 | OFF | Switched off | _VSB_N_UPD
21 | T_EXTERN | Real time external | _VSB_RT_E
22 | T_INTERN | Realtime internal | _VSB_RT_I
23 | N_SORTAB | Not sortable | _VSB_NSORT
24 | FM_TR | Error message transformer value | _VSB_DM_TR
25 | RM_TR | Working message transformer value | _VSB_RM_TR
26 | INFO | Information for the variable | _VSB_INFO
27 | ALT_VAL | Alternate value If no value was transferred, the defined alternate value is used otherwise the last valid value is used. | _VSB_AVALUE
28 | RES28 | Reserved for internal use (alarm flashing) | _VSB_RES28
29 | N_UPDATE | Not updated | _VSB_ACTUAL
30 | T_STD | Standard time | _VSB_WINTER
31 | RES31 | Reserved for internal use (alarm flashing) | _VSB_RES31
32 | COT0 | Cause of transmission bit 1 | _VSB_TCB0
33 | COT1 | Cause of transmission bit 2 | _VSB_TCB1
34 | COT2 | Cause of transmission bit 3 | _VSB_TCB2
35 | COT3 | Cause of transmission bit 4 | _VSB_TCB3
36 | COT4 | Cause of transmission bit 5 | _VSB_TCB4
37 | COT5 | Cause of transmission bit 6 | _VSB_TCB5
38 | N_CONF | Negative acceptance of Select by device (IEC 60870) | _VSB_PN_BIT
39 | TEST | Test bit (IEC870 [T]) | _VSB_T_BIT
40 | WR_ACK | Writing acknowledged | _VSB_WR_ACK
41 | WR_SUC | Writing successful | _VSB_WR_SUC
42 | NORM | Normal status | _VSB_NORM
43 | N_NORM | Deviation normal status | _VSB_ABNORM
44 | BL_870 | IEC 60870 Status: blocked | _VSB_BL_BIT
45 | SB_870 | IEC 60870 Status: substituted | _VSB_SP_BIT
46 | NT_870 | IEC 60870 Status: not topical | _VSB_NT_BIT
47 | OV_870 | IEC 60870 Status: overflow | _VSB_OV_BIT
48 | SE_870 | IEC 60870 Status: select | _VSB_SE_BIT
49 | T_INVAL | Time invalid | not defined
50 | CB_TRIP | Breaker tripping detected | not defined
51 | CB_TR_I | Breaker tripping detection inactive | not defined
52 | RES52 | reserved | not defined
53 | RES53 | reserved | not defined
54 | RES54 | reserved | not defined
55 | RES55 | reserved | not defined
56 | RES56 | reserved | not defined
57 | RES57 | reserved | not defined
58 | RES58 | reserved | not defined
59 | RES59 | reserved | not defined
60 | RES60 | reserved | not defined
61 | RES61 | reserved | not defined
62 | RES62 | reserved | not defined
63 | RES63 | reserved | not defined

info Information

In formulas all status bits are available. For other use the availability can be reduced.

You can read details on status processing in the Status processing chapter.


Logical operators

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode) -> Formula editor -> Logical operators

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Logical operators

Logical links: Variables will only be checked for the logical value '0'; if the value does not equal '0', it will be considered as '1'.

In contrast to bit formulas, the technical range can be modified by a stretch factor -> (not equal '0' or '1').

Operator | Meaning
AND | logical 'AND'
NOT | Negation
OR | logical 'OR'
XOR | logical 'EXCLUSIVE OR'

The operators have the following priority in the formula calculation:

Priority | Operator
1 | & (operator for bit formulas)
2 | NOT
3 | AND
4 | XOR/OR

info Info

Up to 99 variables can be linked in one formula. X01 to X99.

info Info

The status bits NORM and N_NORM are only available in the formula editor and cannot be engineered via the status.


Bit formulas

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode) -> Formula editor -> Bit formulas

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit formulas

Bit formulas only have a logical high or low state. In contrast to logical formulas, the raw value is already predefined (0,1).

Operator | Description
& | AND
| | OR


Example: ORing bitwise

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode) -> Formula editor -> Bit formulas -> Example: ORing bitwise

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Example: ORing bitwise

You want to find out if one of the user status bits 1-8 (M1 ... M8) of the variable X01 is set.

Usual formula:

X01.M1 OR X01.M2 OR X01.M3 OR X01.M4 OR X01.M5 OR X01.M6 OR X01.M7 OR X01.M8
This query can be made much easier by the logical ORing of the overall status.

Logical ORing:

X01.Status & 0xFF

The constant can be entered in hexadecimals, as described above:

0xFF corresponds to decimal 256; these are the first eight status bits (binary 11111111). If one of these bit is set to 1, the result of this bitwise ORing is 1 (true), otherwise it is 0 (false).

If, for example, all user status bits except the user status bit M7 should be queried, the binary statement for this would be: 10111111. Bit 7 is not of interest and is thus set to 0. This corresponds to 0xBF in hexadecimal. The expression for the formula is then: X01.Status & 0xBF.

Instead of ORing bitwise with a constant, the value can also be directly compared to a decimal number. If the comparison is wrong, the binary value is 0 (false) otherwise it is 1 (true).

Example:

You want to find out if the value is equal to the constant 202: The formula is:

X01.value = 202

If the value is equal to the constant 202, the result of the comparison is 1 (true) otherwise it is 0 (false).

Note: The bitwise ORing works with the OR character (|) in a similar manner to this example.


Comparison operators

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode) -> Formula editor -> Comparison operators

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Comparison operators

Comparison operators serve for the direct comparison of two numeric values. The result of this comparison is a binary value. "0“ if the condition is not fulfilled and „1“ if the condition is fulfilled.

Operator | Description
< | less
> | greater
<= | Less then or equal
>= | greater or equal
= | Equal
<> | unequal

To the left and to the right of the comparison operator, there has to be a (total) value or a (total) status, single bits cannot be used with these comparison operators.

There can also be a constant to the right of the comparison operator. (the constants can only be integers; a comparison to a floating point number is not possible.)
These constants are entered as hexadecimal values or decimal values in the combined element. Hexadecimal figures are automatically converted to decimal values by clicking on OK (for example, 0x64 is in decimal figures 100).

Example Example

X01.value >= X02.value
The result is 1, if the value of X01 is higher than or equal to the value of X02

X01.value = 0x64
The result is 1, if the value of X01 is exactly equal to the numeric value 100 (= hex 0x64)

(X01.value = 0x64) OR (X01.value = 0x65)
The result is 1, if the value of X01 is exactly equal to the numeric value 100 or 101 (= hex 0x64 and hex 0x65)


Examples for formulas

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (edit mode) -> Formula editor -> Examples for formulas

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Examples for formulas

Simple logical AND linking between two bit values

Example Example

Formula: X01.03 AND X02.03

This formula has the status TRUE, if both bit 3 of variable 1 and bit 3 of variable 2 both have the value 1.

comparison of an analogue value or status of a variable

Example Example

(X01.Value> X02.Value)

Compare analog values with each other on a logical basis

Example Example

(X01.Value> X02.Value) AND (X01.Value = X02.Value)

Compare with value bits and status bits

Example Example

(X01.Value> X02.Value) AND (X01.Value = X02.Value) OR (X01.03 = X02.03)

Compare a value with a decimal or hexadecimal value

Example Example

Formula: (X01.Value = 111)

Formula: (X01.Value = 0x6F)

If a hexadecimal values is used, this is later transferred to decimal by clicking on OK. If a decimal value is entered and confirmed, the value continues to be displayed as a decimal value after reopening.

info Info

It is not possible to use a comma or a period when entering values.


Tool bar - command sequence editor (test mode)

Manual -> Command Sequencer -> Command sequences in Runtime -> Command Sequencer Editor -> Tool bar - command sequence editor (test mode)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters

Description

Start command sequence

Starts command sequence

Pause command sequence

Stops current command sequence and pauses it.

Continue command sequence

Continues paused command sequence.
Only active if the command sequence was previously paused with Pause command sequence.

Abort command sequence

Aborts the command sequence that is running.

User interactions

Switches to the command processing screen. To do this, a step must be active in the command sequence. This step must be selected by clicking on the mouse.

The screen that was linked in the command processing action is called up. If no screen is linked in the command processing action, the linked screen of the command processing group is used.

Note: Only active is the action is being executed and a user interaction is expected, for example with a two-step action or an active interlocking.

Check command sequence for errors

Checks configured command sequence for logical consistency and possible errors.

The result is displayed in a dialog.

  • No errors during this command sequence.
  • Checking the command sequence resulted in the following warnings/errors:
    {error details}

Edit element

Calls up a dialog with the element properties for switchgear allocation and transition.

No changes can be made in test mode. Switch the editor to edit mode in order to make changes.

Note: not available for step.

Graphical design

Calls up dialog to select the graphical design.

The following can be selected:

  • Background color
  • Grid On/Off
  • Grid color
  • Display element ID

Switch to automatic mode

Switches execution of the switching step to automatic mode.

Switch to semi-automatic mode

Switches execution of the switching step to semi-automatic mode.

Continue command sequence at selected execution position only

Continues a command sequence from the selected element only.

Note: only available in semi-automatic mode.

Continue command sequence at all execution positions

Continues a command sequence at all positions available - regardless of the respective position of the mouse pointer.

Note: only available in semi-automatic mode.

Switch command sequence to edit mode.

Switches to edit mode - command sequences can be edited and repositioned.


Create command sequence

Manual -> Command Sequencer -> Command sequences in Runtime -> Create command sequence

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Command sequences are named and renamed in the Command sequence configuration dialog. A descriptive text can also be configured.

You create a new command sequence in the list of command sequences.

Parameters | Description
Name | Name of the new command sequence. The name must not contain a question mark (?), a comma, an @ or an asterisk (*). Maximum length: 256 characters. Note: When duplicating command sequences, the existing name is supplemented with the prefix "Copy of". If the maximum length is exceeded by this, the name is shortened to the allowed length starting from the last character.
Description | (Optional) text for the description of a command sequence. You can change the description afterwards. To change the description, select the Rename command sequence symbol.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.


Tooltips

Manual -> Command Sequencer -> Command sequences in Runtime -> Tooltips

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tool tips in the command sequence editor visualize the respective status of a step and provide further information via the respective status.

Display of the tool tip:

To have a tool tip displayed, go to the respective step in the command sequence grid. The tool tip appears automatically when the mouse is positioned over the step.

Structure:

The tool tip consists of:

  • Command processing command (command processing group action)
    • Internal ID
    • Allocated switchgear
  • General
    • Step status
    • Internal state
    • Number of executions
  • Overall duration
    (duration)
    • Date and time stamp for start and end
  • Chronological sequence in detail
    (overall duration)
    • Switchgear allocation
      Date and time stamp for start and end
    • Duration of execution
      Date and time stamp for start and end
    • Wait for subsequent condition
      Date and time stamp for start and end


Execution status

Manual -> Command Sequencer -> Command sequences in Runtime -> Execution status

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following states are possible:

Status

Description

Idle

The command sequence is in idle state.

In execution

When starting a command sequence, it changes to running status.

Executed

As soon as the execution is finished, the command sequences switches to Finished status. In this status execution is not possible.

Pausing

The command sequence switches to paused status.

Paused

Within the phase, the process stops at:

  • Waiting for Finished
  • Waiting for Allocation
  • Waiting for Interlocking condition
  • Waiting for Phase finished
  • Check for parallel execution

Aborting

Aborts the process and changes to Aborted.

Aborted

Command sequence process was aborted.

If a command sequence cannot be restarted in the image on restarting, its status automatically changes to aborted.

Newly-occurred interlocking

Command sequence is stopped. Aborting the command sequence is now possible.

This status occurs in the following scenario:

  • An interlocking condition (one-step or two-step) waits for confirmation
  • Whilst a confirmation is waited for, the active interlocking has changed again.

Active element and jump targets

Status | Description
Continue | If an object is paused and an active element is located after it, continue has the same effect as Next step. This also includes jumps. For a step command, the command only affects the jump in the same branch.
Break | Has now effects for jump targets. Already defined targets remain.
Others | Always causes the deletion of the jumps. For a step command, only the jump in the area of the phase is deleted.


Symbols and Color

Manual -> Command Sequencer -> Command sequences in Runtime -> Symbols and Color

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The states during the process of a command sequence are displayed using different symbols. Some symbols are also used for transitions and end parallel branch.

Symbols and what they mean:

Symbol

Meaning

Command sequence starts

The connection is established.

Wait for switchgear allocation. The switchgear of the step is already used in a different command sequence or is already assigned the NET_SEL status bit.

  • During the execution of a step and the waiting for Reaction finished.
  • With transitions: Whilst running and waiting for transition condition.
  • With end parallel branch: Waiting for all branches combined.

Step has finished

  • With transitions: Waiting for transition condition met.
  • With end parallel branch: Waiting for all parallel branches finished and waiting for following condition.

Values are written.

User interaction required.
calls up configured command processing screen.

Command sequence is in semi-automatic mode and waits for the next step.
To do this, click on the "Continue command sequence at all execution positions" button. It calls up the command processing screen.

Multiple executions.

Occurs with an attempt to execute the exact same of steps at the same time.

If an error occurs during a step, the step is marked as faulty until it is restarted.

If a command sequence is paused, the current status is shown as a symbol.

Status

The execution status of steps, transitions and End parallel branch is signaled in color:

Status

Color

Idle:

White

In execution:

green

Finished:

blue

Pausing:

Two colors:

  • orange
  • Original color

Paused:

orange

Aborting:

Two colors:

  • red
  • Original color

Aborted:

red

Restarting:

Two colors:

  • green
  • Original color

Timeout:

red border

Newly-occurred interlocking

red border

Action on Stop command

After a Stop command, the steps, transitions and end parallel branch immediately go to Stopped status, even if other elements are still waiting for a condition for stopping. Further subsequent commands such as Cancel are ignored. The Stopped status remains displayed.


Validate command sequence

Manual -> Command Sequencer -> Command sequences in Runtime -> Validate command sequence

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Command sequences can be checked for errors during configuration.

  • Validation is only possible in edit mode.
  • Validation takes place automatically when switching from edit mode to test mode.

To validate a command sequence, click on the corresponding symbol in the tool bar of the command sequence editor in Runtime (green tick - Check command sequence for errors). The recipe thus is checked for functionality according to internal rules; the following in particular is checked:

  • Syntax (all lines connected, processable from begin to end, etc.)
  • Variables
  • Datatypes

The result of the check is displayed as a dialog in plain text. Found errors are also saved in the log file which can be analyzed with the Diagnosis Viewer.

Rules that must be adhered to during configuration can be found in the Project configuration rules for recipes chapter.

attention Attention

Command sequences that are not connected at the time of validation are ignored during validation. Their content and processes are not checked.

Dialog: Validation OK

Dialog: Validation with errors

If errors occur during checking, they are displayed in this dialog.

This error information includes:

  • Error number
  • Element ID
  • Position in the command sequence grid
  • Error text


Behavior of "Check response value" action type

Manual -> Command Sequencer -> Command sequences in Runtime -> Behavior of "Check response value" action type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The "Check response value" action type is used in the command sequences in particular to check the value of the response variable.

To be able to use the "Check response value" action type in the Command Sequencer module, this action type must be configured as an action in a command group in the Command Processing module in the zenon Editor.

attention Attention

This action type is not used in principle in the command processing. It was specially conceived for use in the Command Sequencer module.

For command processing, it is possible to configure this query using action buttons and to receive responses in Runtime.

The Check response value action type is to check variables for the status ON or OFF.

Whilst the Check response value action is executed, the standard key Cancel is unlocked in the Command Processing screen.

In doing so - depending on the setting of the runtime monitoring - there is a wait until the value of the response variable corresponds to the value of the checking direction - switching direction action property. If the checking value is EIN, this is the value 1; it is the value 0 for OFF.

If no runtime monitoring has been configured (runtime monitoring= "none"), the set waiting time (~24 hours) is the maximum time that is waited. Otherwise the action is ended and the TIMEOUT status bit is set for the response variable.

If, after execution of the action in the command processing screen, the other actions are not available, this is for the following reasons:

  • The timeout for runtime monitoring has not yet expired.
  • The response variable does not yet have the expected value (the value change has not yet been received).
  • The action has not yet been canceled with the Cancel button.

info Information

The Check response value action only serves to read the value of the response variable without executing an activity.

The action is intended for use in the Command Sequencer module.

If the response variable already has the value of the switching direction, the execution of the action is recognized as completed. The other buttons in the command processing screen are thus immediately available.

Note: If the response variable is set to OFF or Revision , the response value can nevertheless be checked.


Configuration rules for command sequences

Manual -> Command Sequencer -> Command sequences in Runtime -> Configuration rules for command sequences

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following important principles are applicable for configuration:

General

  • For all elements all connection points must be connected.
    Exception: Jump targets. Only two of the three input connection points need to be linked there.
  • The begin element is always present only once with a command sequence and marks the beginning of the process.
    Note: The begin element cannot be deleted.
  • The end element is always present only once with a command sequence and marks the end of the process.
    Note: The end element cannot be deleted.
  • Steps can be inserted anywhere. Several steps can also be placed in succession.
  • There should be at least one active step in a command sequence.

Transitions

  • Two transitions may not lie one after the other.

Branches

  • The first element after a Begin branch must be a transition.
  • The individual branches which start at Begin branch must all end in an End branch never in an End parallel branch. Any element can be placed between begin and end of a branch even parallel branches as long as they are closed before the End branch element. An end branch can be replaced with jump targets at any point, including within a parallel branch.
  • It is not necessary to have an End branch for each Begin branch. You can for example have two Begin branch elements ending in one End branch or the other way round.
  • It is not necessary to have an End branch for a Begin branch. It can simply end in a line. If for example you have a Begin branch element with two paths and one of the paths ends in a jump target, it does not make sense to have an End branch.

Parallel branches

  • Each parallel branch must contain at least one step.
  • The first element after a Begin parallel branch must no be a transition.
  • The individual branches that start at a Begin parallel branch must all end in one End parallel branch, but must never end in an End branch. You may use any elements between Begin parallel branch and End parallel branch even branches as long as they are closed before the End parallel branch.
  • Not all branches which were started in a Begin parallel branch must end in an End parallel branch. It is enough when all branches converge over an End parallel objects. Equally branches from different Begin parallel branch objects may converge in a single End parallel branch.
  • parallel branches allows embedding of additional parallel branches.
    In doing so: each embedded parallel branch must recombine with the superordinate parallel branch

Lines in the command sequence grid

  • Lines may be used as connections between any objects. It is allowed to add any number of lines after another.
  • Lines must not be used to connect two equal connection points.
    For example: Both inputs of two steps must not be connected directly with a line. In the engineering this connection is allowed. It is however displayed in red (error) and in the validation an error message is displayed.

Jump targets

  • Jump targets correspond to an end branch. They are intended to
    • jump between branches,
    • jump out of branches,
    • engineer loops

    For this, the following applies: A path which ends in a jump target must have started with a Begin branch. Otherwise the end is not reached.

  • Jump targets consist of tree inputs and one output. At least two inputs and the output must always be connected. At this it makes no difference which input connection point is connected.
  • Jump targets can be switched consecutively if at least two input connection points are allocated.
  • Jumps are prohibited:
    • between parallel branches
    • to jump out of a parallel branch
    • to jump in a parallel branch.


Command sequences in the zenon network

Manual -> Command Sequencer -> Command sequences in the zenon network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Command Sequencer module is also available in the zenon network. In principle, command sequences are always executed on the Server in the process.

If the Server fails, the command processing screen is not visible on the Clients. Instead of the user interface, a blue area with an error message is shown.

attention Attention

The Command Sequencer module is not redundant!

If a computer works as a Client, all changes to the command sequence data is transferred to/from Server 1. If, when carrying out project configuration in the zenon Editor, a computer is configured as Server 2, it creates a local copy of the sequence data but is not capable of redundancy switching.


Particular aspects for the command processing screen

Manual -> Command Sequencer -> Command sequences in the zenon network -> Particular aspects for the command processing screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If user interaction has been configured in the command processing, the following is applicable:

  • the command processing screen is automatically called up on the computer on which the command sequence was started.
  • On all other computers, the command processing screen can be called up by clicking on the User interaction button.
  • When executing a two-step step, a command processing screen is called up once the are no more active interlockings. The command processing screen is either that of an action or - if no screen has been configured there - the command processing screen of the command group.


Command sequences for zenon Web Server.

Manual -> Command Sequencer -> Command sequences for zenon Web Server.

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With a standard web client:

  • The settings for grid and color can be changed
  • No command sequences can be created or edited
  • The size of the editing area cannot be changed
  • In the tool bar, all symbols that are not permitted are deactivated;
    it is not possible to select the corresponding objects.

Web client PRO is not affected by these restrictions.


Configuration files

Manual -> Configuration files

Information for system administrators, who directly want to edit the INI files.

info Information

Project settings should be set up in the Editor. Changes to the INI files are reserved for experienced users.

Format in which the INI files are saved

Due to the system, only ANSI and Unicode are supported for reading the INI files.

attention Attention

UTF-8 format is not supported!

You should therefore always save your INI files as a text file in ANSI or Unicode format.

Import- and INI files

You receive information on the following configuration files:

File

Description

dBaseIV variable file

The dBase IV import file settings.

project.ini

Settings for the project.

You can find project.ini in the Runtime path of the respective project. To open the path:

  • Highlight the project
  • press the short cut Ctrl+Alt+E
  • The project's SQL folder is opened
  • Navigate to ...\FILES\zenon\system

startup.ini

zenon Startup Tool settings.

zenDB.ini:

SQL database settings

zenon6.ini

General settings for zenon

You can find zenon6.ini in the following path:

C:\ProgramData\COPA-DATA\System\

zenWebSrv.ini

Settings for zenon Web Server.

Processing of project.ini and zenon6.ini

The INI files are each processed as follows:

project.ini

The settings in project.ini are processed in the following sequence:

  1. project.ini
  2. zenon6.ini
  3. Default value

In doing so, the first entry found is used.

zenon6.ini

The settings in zenon6.ini are processed in the following order:

  1. zenon6.ini
  2. Default value

In doing so, the first entry found is used.


dBaseIV variable file

Manual -> Configuration files -> dBaseIV variable file

The dBaseIV file must have the following structure and contents for variable import and export:

attention Attention

dBase does not support structures or arrays (complex variables) at export.

DBF files must:

  • conform with there name to the 8.3 DOS format (8 alphanumeric characters for name, 3 characters for extension, no space)
  • Be stored close to the root directory (Root)

Structure

Description | Type | Field size | Comment
KANALNAME | Char | 128 | Variable name. The length can be limited using the MAX_LAENGE entry in project.ini.
KANAL_R | C | 128 | The original name of a variable that is to be replaced by the new name entered under "VARIABLENNAME" (field/column must be entered manually). The length can be limited using the MAX_LAENGE entry in project.ini.
KANAL_D | Log | 1 | The variable is deleted with the 1 entry (field/column has to be created by hand).
TAGNR | C | 128 | Identification. The length can be limited using the MAX_LAENGE entry in project.ini.
EINHEIT | C | 11 | Technical unit
DATENART | C | 3 | Data type (e.g. bit, byte, word, ...) corresponds to the data type.
KANALTYP | C | 3 | Memory area in the PLC (e.g. marker area, data area, ...) corresponds to the driver object type.
HWKANAL | Num | 3 | Bus address
BAUSTEIN | N | 3 | Datablock address (only for variables from the data area of the PLC)
ADDRESS | N | 5 | Offset
BITADR | N | 2 | For bit variables: bit address For byte variables: 0=lower, 8=higher byte For string variables: Length of string (max. 63 characters)
ARRAYSIZE | N | 16 | Number of variables in the array for index variables ATTENTION: Only the first variable is fully available. All others are only available for VBA or the Recipe Group Manager
LES_SCHR | R | 1 | Write-Read-Authorization 0: Not allowed to set value. 1: Allowed to set value.
MIT_ZEIT | R | 1 | time stamp in zenon zenon (only if supported by the driver)
OBJEKT | N | 2 | Driver-specific ID number of the primitive object comprises TREIBER-OBJEKTTYP and DATENTYP
SIGMIN | Float | 16 | Non-linearized signal - minimum (signal resolution)
SIGMAX | F | 16 | Non-linearized signal - maximum (signal resolution)
ANZMIN | F | 16 | Technical value - minimum (measuring range)
ANZMAX | F | 16 | Technical value - maximum (measuring range)
ANZKOMMA | N | 1 | Number of decimal places for the display of the values (measuring range)
UPDATERATE | F | 19 | Update rate for mathematics variables (in sec, one decimal possible) not used for all other variables
MEMTIEFE | N | 7 | Only for compatibility reasons
HDRATE | F | 19 | HD update rate for historical values (in sec, one decimal possible)
HDTIEFE | N | 7 | HD entry depth for historical values (number)
NACHSORT | R | 1 | HD data as postsorted values
DRRATE | F | 19 | Updating to the output (for zenon DDE server, in [s], one decimal possible)
HYST_PLUS | F | 16 | Positive hysteresis, from measuring range
HYST_MINUS | F | 16 | Negative hysteresis, from measuring range
PRIOR | N | 16 | Priority of the variable
REAMATRIZE | C | 32 | Allocated reaction matrix
ERSATZWERT | F | 16 | Substitute value, from measuring range
SOLLMIN | F | 16 | Minimum for set value actions, from measuring range
SOLLMAX | F | 16 | Maximum for set value actions, from measuring range
VOMSTANDBY | R | 1 | Get value from standby server; the value of the variable is not requested from the server but from the Standby Server in redundant networks
RESOURCE | C | 128 | Resources label. Free string for export and display in lists. The length can be limited using the MAX_LAENGE entry in project.ini.
ADJWVBA | R | 1 | Non-linear value adaption: 0: Non-linear value adaption is used 1: Non-linear value adaption is not used
ADJZENON | C | 128 | Linked VBA macro for reading the variable value for non-linear value adjustment.
ADJWVBA | C | 128 | ed VBA macro for writing the variable value for non-linear value adjustment.
ZWREMA | N | 16 | Linked counter REMA.
MAXGRAD | N | 16 | Gradient overflow for counter REMA.

attention Attention

When importing, the driver object type and data type must be amended to the target driver in the DBF file in order for variables to be imported.

Limit definition

Limit definition for limit values 1 to 4, and status 1 bis 4:

Description | Type | Field size | Comment
AKTIV1 | R | 1 | Limit value active (per limit value available)
GRENZWERT1 | F | 20 | technical value or ID number of a linked variable for a dynamic limit (see VARIABLEx) (if VARIABLEx is 1 and here it is -1, the existing variable linkage is not overwritten)
SCHWWERT1 | F | 16 | Threshold value for limit
HYSTERESE1 | F | 14 | Is not used
BLINKEN1 | R | 1 | Set blink attribute
BTB1 | R | 1 | Logging in CEL
ALARM1 | R | 1 | Alarm
DRUCKEN1 | R | 1 | Printer output (for CEL or Alarm)
QUITTIER1 | R | 1 | Must be acknowledged
LOESCHE1 | R | 1 | Must be deleted
VARIABLE1 | R | 1 | Dyn. limit value linking the limit is defined by an absolute value (see field GRENZWERTx).
FUNC1 | R | 1 | Functions linking
ASK_FUNC1 | R | 1 | Execution via Alarm Message List
FUNC_NR1 | N | 10 | ID number of the linked function (if “-1” is entered here, the existing function is not overwritten during import)
A_GRUPPE1 | N | 10 | Alarm/event group
A_KLASSE1 | N | 10 | Alarm/event class
MIN_MAX1 | C | 3 | Minimum, Maximum
FARBE1 | N | 10 | Color as Windows coding
GRENZTXT1 | C | 66 | Limit text
A_DELAY1 | N | 10 | Time delay
INVISIBLE1 | R | 1 | Invisible

Expressions in the column "Comment" refer to the expressions used in the dialog boxes for the definition of variables. For more information, see chapter Variable definition.


project.ini

Manual -> Configuration files -> project.ini

The file project.ini contains project specific settings. Project settings should be set up in the Editor. Changes to project.ini are only to be made by experts. Settings made in the editor, which differ from the default values, are entered by the editor in the project.ini.

Amending and accepting entries permanently

Entries in the project.ini are overwritten when reimporting projects from the Runtime. In order to guarantee that the entries that are written to project.ini are accepted, the following procedure is recommended:

  1. Identify the project: Note the GUID (the first 4-6 digits are sufficient) and close the workspace and/or the Editor
  2. To navigate to the SQL folder: There is a folder with the GUID number in the SQL directory
  3. To navigate to project.ini: The file project.ini can be found in the GUID folder at /FILES/zenon/system.
  4. Editing project.ini: Making changes to project.ini, saving it and closing it
  5. Opening the Editor: Opening the Editor again or loading the project, creating the amended Runtime files and transferring these

info Information

Regardless of the project name, project.ini is always saved as 'project.ini' at Project_SQL_Ordner/FILES/zenon/system/project.ini.

Hint: Mark the project in the project manager -> press keys Ctrl+Alt+E -> the Windows Explorer opens folder Project_SQL_directory/FILES/


General settings [DEFAULT]

Manual -> Configuration files -> project.ini -> General settings [DEFAULT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[DEFAULT]

General settings for the project.

AUFFUELLEN=

Type of saving when administering the HD and memory data:

  • 0: Each time a value arrives it is saved.
  • 1: The values are stored at the defined interval.
    With large time intervals, several items of data may need to be saved.

Default: 1

Calculation: every kth cycle time is saved. k is the largest integer divider of the HD values which should be saved which is smaller than 84.
Example: Number of values 300 -> Saves every 75. value.

It corresponds to the property Data buffering in group Runtime settings in the Editor.

BLINK=

Flash rate of dynamic elements in tenths of a second.

  • Minimum: 0
  • Maximum: 2147483647

Default: 5

E. g.: BLINK=5 corresponds to flashing with a half-second cycle.

It corresponds to the property Flash freq. [tenth sec] in group Graphical design/Runtime general in the Editor.

BTB_DRUCKEN=0

Stipulation of whether, when the ONLINE_DRUCKEN=1 setting is activated, the AML or CEL is printed:

  • 1: CEL
  • 0: AML

Default: AML

It corresponds to the property Printing for in group AML and CEL in the Editor.

CURSOR=

Display of mouse pointer:

  • 1: The mouse cursor is displayed in Runtime.
  • 0: The mouse pointer is deactivated (for touch operation for example).

Default: 1

Attention: This setting only has a effect on zenon, not on Windows standard elements such as title bars, menus, scroll bars, etc. For Windows elements, the mouse pointer must be deactivated in the operating system directly.

It corresponds to the property Cursor visible in group Graphical design/Runtime general in the Editor.

EnRtDlgFont=

Makes it possible to display dialogs and multiple-page settings with an adjustable font in the Runtime.

  • 0: inactve
  • 1: active

Default: 0

You define the font to be used by means of the RtDlgFont= property.

It corresponds to the property Adjustable dialog font in group Graphical design/Runtime general in the Editor.

FocusLineColor=

Color of the frame which identifies the object on which the focus lies in the Runtime.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

Default: 12614523 (Editor: #7B7BC0)

It corresponds to the property Focus line color in group Graphical design in the Editor/.

FocusLineWidth=

The line width of the frame that identifies the object on which the focus lies in the Runtime, in pixels.

Default: 3

It corresponds to the property Focus line width in group Graphical design/Screens in the Editor.

GW_FKT_AT_RT_START =1

Execution of the limit value functions when starting Runtime and there is a limit value breach pending.

  • 0: No
  • 1: yes

Default: 1

Attention: This property only concerns limits values that are not alarms.

In the Editor, it corresponds to the setting for the Execute limit value function at RT start variable property in the Functions group.

HDDATEN=

Recording of the HD data:

  • Active: Hard disk data (HDD) is recorded.
  • Inactive: Hard disk data (HDD) is not recorded.

Default: Active

It corresponds to the HD data active property in the Editor.

HEX=

Display type of the variable addresses:

  • 0: normal
  • 1: hexadecimal

LockVar=

Makes it possible for an operating block to be set in projects without a network by means of a binary variable.

Values:

  • 0: No variable linked.
  • >0: Internal ID of the variables

Default: 0

Should only be configured in the Editor.

It corresponds to the property Operation lock in group Interaction in the Editor.

MENU=

Display of main menus in Runtime:

  • 0: No main menus are displayed in Runtime.
  • 1: A bar for the display of menus is reserved at the upper edge of the Runtime window.

Default: 0

Attention: This option must be activated if main menus are used.

It corresponds to the property Main menus active in group Graphical design/Runtime general in the Editor.

MILLISEK=0

The HD values are displayed and processed internally, as is the refresh of the active screens, in:

  • 1: Milliseconds
  • 0: Seconds

Default: 1

It corresponds to the property Trend and HD values in milliseconds in group Runtime settings in the Editor.

MOUSE_FOCUS=

Setting for mouse focus:

  • 1: active
  • 0: inactive

ONLINE_DRUCKEN=

Logging of Runtime entries (CEL or alarm).

  • 1: active For every entry in the AML or CEL, the event is sent to the printer defined in the project settings.
  • 0: inactive

Default: 1

Selection of CEL or AML by means of the BTB= entry (0 = AML, 1 = CEL).

It corresponds to the property Printing active in group AML and CEL in the Editor.

PokeAckInCel=

CEL entry for the writing of values:

  • 1: At successful writing of values to the hardware, a corresponding entry is entered in the CEL.
  • 0: The successful writing of values is not logged in the CEL.

Default: 0

Note: This setting only has an effect on Runtime if the writing of the set value is carried out using the Write set value function.

It corresponds to the property Function Set SV in group Chronological Event List/Logging in the Editor.

RELEASE=5

Display of the main window in Runtime.

  • 0: Title with System, Min. and Max. button.
    The size of the window can be changed and it can be moved, as well as closed, by clicking on the X button. Right click on the header opens the context menu.
  • 1: Title with Min. and Max. button.
    The size of the window and be changed and it can be moved. Closing is not possible (also not via context menu, task bar or the shortcut Alt+F4). Right click on the header opens the context menu.
  • 2: Title with Minimize button.
    For earlier versions. is no longer supported. The last-valid variant is used in Runtime.
  • 3: Title with maximize button
    For earlier versions. is no longer supported. The last-valid variant is used in Runtime.
  • 4: Title without operating element
    No system menu, minimize or maximize buttons. The window can be moved and closed by clicking on button X. Right click on the header opens the context menu.
  • 5: No title (full screen).
    Complete display. Title bar is not displayed.
  • 6: Title with systemmenu.
    The window can be moved and closed by clicking on button X. Right click on the header opens the context menu.

Default: 5

Attention: If this property is changed in the Editor, Runtime must be restarted. Reloading alone does not work, because Runtime must first be be closed and then reopened in order for the main menu to be applied.

It corresponds to the property Runtime title in group Graphical design/Runtime general in the Editor.

RtDlgFont=

Selection of the font that should be used for dialogs and multiple-page settings in Runtime.

  • 0: Standard
  • 1: Font type number 1 from font list
  • 2: Font type number 2 from font list
  • 3: Font type number 3 from font list
  • 4: Font type number 4 from font list
  • 5: Font type number 5 from font list

Default: 2

Only has an effect if the EnRtDlgFont= property has the value 1.

It corresponds to the property Dialog font in group Graphical design/Runtime general in the Editor.

RTVERSION=

Version of Runtime that can be compiled for Editor files.

Example: RTVERSION=7100 creates Runtime files that are used in Runtime version 7.10 SP0.

Attention: All Runtime files must be created again after this property is changed. The configurations for all drivers are converted. Settings that do not exist in the respective version are set to the default setting.

Corresponds to the Create RT files for property in the Editor, contained in the General group.

RuntimeLasso=

Selection of several elements in Runtime.

  • 0: inactive
  • 1: active
    By moving the mouse and holding the left mouse button several elements can be selected in the Runtime. A VBA macro can excesses these elements.

Default: 0

It corresponds to the property Runtime lasso in group Interaction in the Editor.

SCREEN=

Resolution of the Runtime screen on the monitor with:

  • left
  • top
  • right
  • bottom

Each change affects the amendment of all frames, screens, fonts, etc.

Example: SCREEN=0,0,1280,1024

Is transferred from the dialog of the Monitor administration property (General tab, screen switching option) in the Graphical design/Runtime general group.

START_PICTURE=

File name of the screen that is to be called up when Runtime is started.

Example: START_PICTURE=3999147c-a1c9-4824-a92f-ecdc5427c886

It corresponds to the property Start screen in group Graphical design/Screens in the Editor.

SYSKEY=

System key lock:

  • 0: System keys are not locked
  • 1: System keys are locked in Runtime

Default: 0

System keys: Alt+TAB, Alt+ESC, Alt+F4 etc.

It corresponds to the property Lock system keys in group Interaction in the Editor.

UseGDIplus=

Stipulates the graphics quality used:

  • 0: Windows Basic. Basic graphics settings. Recommended for resource-weak hardware.
  • 4: DirectX Hardware. Graphics calculation is done by the CPU and can lead to high CPU load.
  • 5: DirectX Software. A part of the graphics calculation is done by the graphics card. If the system does not support the setting, it automatically switches to DirectX Software.

Default: 4

Note:

  • DirectX is not available under Windows CE and cannot be used for OCX.
  • The values 1, 2 and 3 must not be used.
  • When switching the mode during the engineering, there can be slight pixel deviation. There set this property before you create screens.
  • At activating Windows Base for all line types which use Line width [Pixel] > 1, all line types are set to solid line.

It corresponds to the property Graphics quality in group Graphics quality/Screens in the Editor.

USEREVENTNEEDMODEL=
  • 0: User events are also executed during days without a shift.
  • 1: User events are only executed on days with a shift.

WATCHFILES=

Stipulates whether Runtime files are indexed.

  • 0: inactive
  • 1: active

Default: 0

With active indexing, a folder cache is activated for the Runtime data for quick access.

It corresponds to the property Index Runtime files in group Runtime settings in the Editor.


AML [ALARM]

Manual -> Configuration files -> project.ini -> AML [ALARM]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[ALARM]

Entries for the Alarm Message List.

These properties should generally be set up in the Editor in the project properties of the Alarm Message List group.

AELTESTER=

Stipulation of which alarm is displayed in the alarm status line. The following happens depending on the settings for the NACHSCHIEBEN= property:

  • 1: Only the oldest unacknowledged alarm is displayed in the status bar in Runtime (NACHSCHIEBEN=0) or the oldest alarm is shown first (NACHSCHIEBEN=1).
  • 0: Only the most recent unacknowledged alarm is displayed in the status line in Runtime (NACHSCHIEBEN=0) or the most recent alarm is displayed first (NACHSCHIEBEN=1).

It corresponds to the Display property in the Editor.

ALA_ANZ=

Width of the column Text in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

ALARMMELDELISTE=

Sequence of Alarm Message List entries:

  • 0: unique variable name
  • 1: Identification
  • 2: Alarm text
  • 3: Time alarm received
  • 4: Time alarm cleared
  • 5: Time of acknowledgment

e.g.: ALARMMELDELISTE=13452
Identification-start-end-acknowledgment-alarm text

ALARM_STATE_BACK_COLOR=

Background color of the alarm status line.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

Default: 255

It corresponds to the Background color property in the Editor.

ALARM_STATE_BACK_COLOR1=

Background color for warning message 1 (STACK_WARNING_COUNT0=).

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

Default: 16711680

It corresponds to the Message 1 background color property in the Editor.

ALARM_STATE_BACK_COLOR2=

Background color for warning message 2 (STACK_WARNING_COUNT1=).

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

Default: 16711680

It corresponds to the Message 2 background color property in the Editor.

ALARM_STATE_BACK_COLOR3=

Background color for warning message 3 (STACK_WARNING_COUNT0=).

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

Default: 16711680

It corresponds to the Message 3 background color property in the Editor.

ALARM_STATE_TEXT_COLOR=

Text color of the alarm status line.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

Default: 0

It corresponds to the Text color property in the Editor.

ALARM_STATE_TEXT_COLOR1=

Text color for warning message 1 STACK_WARNING_TEXT0=.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

Default: 16777215

It corresponds to the Message 1 text color property in the Editor.

ALARM_STATE_TEXT_COLOR2=

Text color for warning message 2 STACK_WARNING_TEXT1=.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

Default: 16777215

It corresponds to the Message 2 text color property in the Editor.

ALARM_STATE_TEXT_COLOR3=

Text color for warning message 3 STACK_WARNING_TEXT2=.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

Default: 16777215

It corresponds to the Message 3 text color property in the Editor.

AREA=

Description of the column Alarm area.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

AREA_ANZ=

Width of the column Alarm area in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

AREANR=

Description of the column Alarm area number.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

AREANR_ANZ=

Width of the column Alarm area number in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

BEEP=

Output of an audible signal when the first alarm occurs:

  • 1: Audible tone is sounded. (Default)
  • 0: No sound is emitted.

CLASS_ANZ=

Width of the Alarm/event class column in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

CLASSSYMBOL_ANZ=

Width of the Alarm/event class symbol column in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

COLOR_ACKN_MARKER = xxx

If there are unacknowledged alarms, two corners flash in the color xxx. After acknowledging the flashing stops.

xxx is calculated in the following way: Red part (0-255) + 256 * green part (0-255) + 65536 * blue part (0-255)

It corresponds to the Unacknowledged alarms flash property in the Editor.

COLOR_BACKGROUND=

Use of the color from alarm class:

  • 1: Class color is interpreted as a background color
  • 0: Class color defines the text color.

Default: 0

If no class is linked to a limit, the background or text color is taken from the settings of the list element in the screen.

Is used together with the COLOR_CLASS= property.

It corresponds to the Alarm/event class color property in the Editor.

COLOR_CLASS=

Alarm/event class color is:

  • 1: used
  • 0: not used

Default: 1

Is used together with the COLOR_BACKGROUND= property.

It corresponds to the Alarm/event class color property in the Editor.

COMES_ANZ=

Width of the column Time received in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

COMPUTER_ANZ==

Width of the column Computer name in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

DELETE_IN_CEL=

Entry when deleting an alarm that must be deleted in the CEL:

  • 1: If an alarm which must be deleted is deleted, an entry is created in the Chronological Event List (CEL).
  • 0: When an alarm is deleted, no entry is created in the Chronological Event List.

Default: 0

It corresponds to the property Delete alarms in group Chronological Event List in the Editor.

DYN_LIMIT_FILE=

Use of the comment field for dynamic limit value text:

  • 0: The comment field is only used for dynamic limit texts and is therefore not available for comments.
    Maximum length: 80 characters.
  • 1: Comments and dynamic limit value texts are permitted. Dynamic contents will be stored in a file with the file format D*.AML. Will be stored in addition to the file A*.AML. The comment filed can therefore been used for comments.
    Maximum length for dynamic limit value text 254 characters.

Default: 0

It corresponds to the property Long dynamic limit texts AML in group Alarm Message List.

EIN=

Alarm processing is on program start:

  • 1: active
  • 2: inactive

Default: 1

It corresponds to the property Alarm Message List active in group Alarm Message List.

FARBE_DEL=

Text color for Alarm deleted in the Alarm Message List.

It corresponds to the property Color in group Alarm deleted in the Editor.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

FARBE_GEHT=

Text color for "Alarm cleared" in the Alarm Message List.

Corresponds to the Color property in the Editor in the Alarm cleared section in the project properties.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

FARBE_KOMMT=

Text color for Alarm received in the Alarm Message List. Corresponds to the Color property in the Editor in the Alarm received section in the project properties.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

FARBE_QUIT=

Text color for alarm-acknowledged in the Alarm Message List.

Corresponds to the Color property in the Editor in the Alarm acknowledged section in the project properties.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

GOES_ANZ=

Width of the column Time cleared in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

GRID_LINES=

Display of the columns and lines in the Alarm Message List with grid lines:

  • 0: on
  • 1: off

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

GROUP_ANZ=

Width of the Alarm/event Group column in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

GROUPSYMBOL_ANZ=

Width of the Alarm/event group symbol column in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

HEADER=

Show the column headers in the alarm message list

  • 1: Column heading is displayed.
  • 0: Column heading is not displayed.

Is used together with the HEADER_ENABLE= setting.

It corresponds to the Header AML property in the Editor.

HEADER_ENABLE=

Use of the column heading:

  • 1: Column heading can be operated. (Default.)
  • 0: Column heading is only used for display (fixed).

Is used together with the HEADER= setting.

It corresponds to the Header AML property in the Editor.

IMAGE_DEL=

Graphics file for status Alarm deleted.

It corresponds to the property Graphics file status in group Alarm deleted in the Editor.

IMAGE_GEHT=

Graphics file for Alarm cleared.

It corresponds to the property Graphics file status in group Alarm cleared in the Editor.

IMAGE_KOMMT=

Graphics file for status Alarm received.

It corresponds to the property Graphics file status in group Alarm received in the Editor.

IMAGE_QUIT=

Graphics file for status Alarm acknowledged.

It corresponds to the property Graphics file status in group Alarm acknowledged in the Editor.

LINE_BLINK_UNACK=

Behavior of lines that have not been selected with unacknowledged alarms:

  • 1: Lines that have not been selected with unacknowledged alarms flash in the Alarm Message List.
  • 0: No flashing

Default: 0

It corresponds to the Unacknowledged alarms flash property in the Editor.

MILLISEK=

Display in milliseconds for Received time:

  • 0: Milliseconds are neither displayed nor printed out
  • 1: Milliseconds are also displayed

Default: 0

NACHSCHIEBEN=

Moving of alarms to the alarm status line:

  • 1: All alarm which are not acknowledged are displayed one after another in the status line in the Runtime. As soon as an alarm is acknowledged with a right double click, the next alarm is displayed.
    Dependent of the setting of property AELTESTER= the oldest or the latest alarm is displayed first.
  • 0: Only one alarm is displayed in the status line. The status line is empty once the alarm is acknowledged. Only the next alarm to occur hides the alarm status line again.

It corresponds to the display next property in the Editor.

PREF_COMES=

Prefix for Alarm received.
Default: TEXT=>>

It corresponds to the property Prefix in group Alarm received in the Editor.

PREF_GOES=

Prefix for Alarm cleared.
Default: TEXT=<<

It corresponds to the property Prefix in group Alarm cleared in the Editor.

PREF_IMAGE_COMES=

Graphics file for prefix Alarm received.

It corresponds to the property Graphics file prefix in group Alarm received in the Editor.

PREF_IMAGE_GOES=

Graphics file for prefix Alarm cleared.

It corresponds to the property Graphics file prefix in group Alarm cleared in the Editor.

PREF_IMAGE_QUIT=

Graphics file for prefix Alarm acknowledged.

It corresponds to the property Graphics file prefix in group Alarm acknowledged in the Editor.

PREF_QUIT=

prefix for alarm acknowledged.
Default: TEXT=--

It corresponds to the property Prefix in group Alarm acknowledged in the Editor.

QUIT_ANZ=

Width of the column Time acknowledged in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

QUIT_IN_CEL=

Inclusion of the acknowledgment of an alarm into the Chronological Event List:

  • 0: will be included
  • 1: will not be included

Default: 0

Corresponds to the Alarm acknowledgement in the Logging group in the project properties for Chronological Event List.

REACT_TIME_ANZ=

Width of the column Reactivated time in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

REACT_COUNT_ANZ=

Width of the column Reactivated number in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

REACT_STAT_ANZ=

Width of the column Reactivated variable status in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

RESOURCELABEL=

Describes the column for the resources label.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

RESOURCELABEL_ANZ=

Width of the column for the resources label in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

RTEXT_ANZ=

Width of the column Reaction text in characters

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

SAVE_BIN_ALWAYS=

Setting of whether each change to the data of the Alarm Message List also has an effect on the data in alarm.bin:

  • 1: Saving active
  • 0: Saving inactive

Default: 0

It corresponds to the Save ringbuffer on change property in the Editor.

Note: If the property is set to active, this can lead to a considerable load being placed on the system - with flash disks most of all. If the property is set to inactive, this can lead to data being lost in the event of Runtime closing unexpectedly. Inactive Recommended especially for low performance.

SAVE_ONLY_STACK=

Data retention for alarms:

  • 0: All data are saved:
  • 1: Only active alarms (alarm.bin) are saved on the hard disk.
  • 2: On CE devices, only the ring buffer (alarm.bin) is saved on the hard disk; on PCs, the historic entries (*.aml) are also saved.

Default: 2

It corresponds to the Save AML data property in the Editor.

STACK_SIZE=

Maximum number of entries for the ring buffer.

Minimum: 1
Maximum: 32767
Default: 100

Recommended: At least number of variables for which alarms can occur.

Attention: The ring buffer must always be chosen appropriately. In the Runtime the ring buffer is handled dynamically in the memory. Thus alarms are displayed which exceed the size of the ring buffer. In the save file of the ring buffer (alarm.bin) alarms are only saved up to the defined number. All entries are also entered in the alarm file (*.aml) in the Runtime folder. Both files are synchronized. At a buffer overflow there can be unacknowledged entries in the alarm file.

It corresponds to the Size of the ringbuffer property in the Editor.

STACK_WARNING_COUNT0=

Number of entries in the AML that are necessary for Message 1 to be displayed in the warning line.

Attention: The value must be smaller as the value in property STACK_WARNING_COUNT1=.

It corresponds to the Message 1 number of alarms property in the Editor.

STACK_WARNING_COUNT1=

Number of entries in the AML that are necessary for Message 2 to be displayed in the warning line.

Attention: The value must be smaller as the value in property STACK_WARNING_COUNT2=.

It corresponds to the Message 2 number of alarms property in the Editor.

STACK_WARNING_COUNT2=

Number of entries in the AML that are necessary for Message 3 to be displayed in the warning line.

Attention: The value must be smaller as the value in property STACK_SIZE=.

It corresponds to the Message 3 number of alarms property in the Editor.

STACK_WARNING_TEXT0=

Text of Message 1 that is to be displayed in the warning line in Runtime. This message overlays the alarm status line.

It corresponds to the Message 1 text property in the Editor.

STACK_WARNING_TEXT1=

Text of Message 2 that is to be displayed in the warning line in Runtime. This message overlays the alarm status line.

It corresponds to the Message 2 text property in the Editor.

STACK_WARNING_TEXT2=

Text of Message 3 that is to be displayed in the warning line in Runtime. This message overlays the alarm status line.

It corresponds to the Message 3 text property in the Editor.

STAT_ANZ=

Width of the Variable status column in characters

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

STATUS=

Display of the alarm status line.

  • 1: Alarm status line is displayed.
  • 0: Alarm status line is not displayed.

Default: 1

It corresponds to the property Status line active in group Alarm status line.

Attention multi-project administration: The setting in the integration project defines the behavior for sub-projects, regardless of the setting of the sub-projects. The alarm status line of the uppermost project is always used in Runtime.

STATUS_SCHRIFT=

Index of the font selected for the text in the status row.

  • 0: Standard font (Default)

It corresponds to the Font property in the Editor.

TAG_ANZ=

Width of the column Identification in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TIME_LASTING_ANZ

Width of the column Time active in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_ACT_TEXT=

Description of the column Comment.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_CLASS=

Description of the column Alarm/Event class.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_CLASSNR=

Description of the column Alarm/Event class number.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_CLASSSYMBOL

Description of the column Alarm/Event class symbol.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_CLASSSYMBOL_STYLE

Display type of alarm/event class column symbol.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_COMES=

Description of the column Time received.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_COMP=

Description of the column Computer name.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_GOES=

Description of the column Time cleared.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_GROUP=

Description of the column Alarm/Event group.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_GROUPNR=

Description of the column Alarm/Event group number.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_GROUPSYMBOL

Description of the column Alarm/Event group symbol.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_GROUPSYMBOL_STYLE

Display type of the column Alarm/Event group symbol.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_NAME=

Description of the column Variable name.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_PROJECT=

Description of the column Project name.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_QUIT=

Description of the column Time acknowledged.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_REACT_TIME=

Description of the column Reactivate time.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_REACT_COUNT=

Description of the column Reactivate number.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_REACT_STAT=

Description of the column Reactivate variable status.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_STATUS=

Description of the column Variable status.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_STATUSCAPTION=

Description of the column Alarm status.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_STATUSCAPTION_STYLE=

Display type of the column Alarm status.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_TAGNR=

Description of the column Identification.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_TEXT=

Description of the column Text.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_TIME_LASTING=

Description of the column Time active.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_VALUE=

Description of the column Value.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_USER=

Description of the column User name.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

TITLE_USERNAME=

Description of the column User - full name.

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

UNIT=

Width of the column Measuring unit in characters

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

USER_ANZ=

Width of the column User name characters

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

VAR_ANZ=

Width of the column Variable name in characters

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.

ZEIT_TYP=

Definition of the format in which the time should be output.

  • 1: only milliseconds
  • 2: only time
  • 3: Time and milliseconds
  • 4: only date
  • 5: Date and millisecond
  • 6: Date and time
  • 7: Date, time and milliseconds

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.


Historian [ARCHIV]

Manual -> Configuration files -> project.ini -> Historian [ARCHIV]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Function

[ARCHIV]

Properties for archives.

Recommendation: Configuration by means of the dialog for archive revision in the Editor.

ARCHDIGITS=

Number of decimal places when exporting archives in TXT, XML or DBF format and for export to an SQL server.
Default: ARCHDIGITS=1

CLIENTS_LOAD_LOCAL=

Loading the archive files:

  • 1: Archive files are read locally on the client and not requested from the server. This does not work with lot selection. Only for the archive format *.arx and evacuation to SQL.
  • 0: Archive files are obtained from the Server.

Attention: The setting of an entry does not lead to the data created by Runtime being synchronized with the zenon client. The archive data must be copied to the client manually.

CLOSEDELAY=

Time that is waited for after an RDA scan until the ARV or ARX file is closed. If a another scan occurs within this waiting time, the data is written to the same file.

Default: CLOSEDELAY=5

EVAC_ERR_PERIOD=

In the event of an error in the set time period, an entry is created in the CEL. This time period can be set in hour steps.

If an ARV or ARX file cannot be read, this is renamed to AR_ and the process continues with the next file.

Default: EVAC_ERR_PERIOD=12

EXPORTFORMAT=

Export format with:

  • Date
  • Time
  • Variable (variable name)
  • Value
  • Status

EXPORTFORMAT=DZVWS

MIN_MAX_ENDE_ZEIT=

Choice of time given:

  • 1: Time when the minimum or maximum value occurs
  • 0: Time of the end of the archive

NUR_HANDWERT=

For archives listed here, only hardware is used for the calculation of aggregated archives. Entry of short descriptions, separated by spaces.

NUR_HANDWERT=X1 X2

SPEICHER=

Maximum number of values to be read in the memory for:

  • Extended Trend
  • Archive revision
  • AML
  • CEL
  • Tables

Display in kilobytes (e.g. 2000000 for 2 GB).

Default: 1000000 (=1 GB)

Attention: With archive data, all values of all variables are always read in, even if only one variable is displayed.

Note: The space available is checked before archive data (*.arx) is read in. If more than the size defined here is required, the reading in is canceled and an error message is written to the Diagnosis Viewer log.

SQL_MAXROWS=

Maximum number of values to be read from the SQL database (on archive evacuation to SQL).

Maximum: 4,294,967,295

Note: There is an automatic check that there is always at least 10 % free memory left.

STATUSSPERRBIT=

Defines the bit in the status that is used as an archive block. All values where this bit is set are not archived with their current value but with INVALID as a substitute value.

Permitted values:

  • 0 to 31
  • -1: inactive

Default: 0

TRENNZEICHEN=

Separator for export in ASCII files between the fields.

Example: TRENNZEICHEN=;

ZEIT_AUTOMATISCH=

Automatic time correction:

  • 1: For aggregated archives, an automatic time correction of -1 second is carried out. It is thus possible to set, for example, a time stamp of 00:00 (24:00) on the previous day to 23:59.
  • 0: No correction.


Automatic Line Coloring [ALC] and [ALC_TOP]

Manual -> Configuration files -> project.ini -> Automatic Line Coloring [ALC] and [ALC_TOP]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

[ALC]

Entry

Description

[ALC]

Properties in the Automatic Line Coloring node of the project properties.

GROUNDFAULTMODE=

Determines at the earth fault search whether the part of the grid in which the earth fault probably occurred or the whole grid in which the earth fault occurred is colored:

  • 0: Color power supply
  • 1: Color whole grid.

It corresponds to the Mode of the search for ground faults property in the Editor.

MARKER_BACKGROUNDx=

Background color of the marker. x stands for the number of the marker, starting with 0.

Example: MARKER_BACKGROUND3=2124031.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

Recommendation: Configuration in the dialog of the property ALC configuration.

MARKER_CNT=

Number of configured screen markers.

This value is set by the Editor.

MARKER_COLOURx=

Line color of the marker. x stands for the number of the marker, starting with 0.

Example: MARKER_COLOUR3=255.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

Recommendation: Configuration in the dialog of the property ALC configuration.

MARKERLINE=

Line width for screen markers in pixels.

It corresponds to the Line width of the screen marker property in the Editor.

MARKERSIZE=

Size of the screen markers in pixels.

It corresponds to the Screen marker size property in the Editor.

MARKERTYPE=

Display types of the screen markers

  • 0: Triangle
  • 1: Circle
  • 2: Square
  • 3: Cross

It corresponds to the Display type of the screen marker property in the Editor.

MAXOVERLOAD=

Maximum permitted current overload in percent.

Example: MAXOVERLOAD=1.000000.

It corresponds to the Maximum acceptable current overload [%] property in the Editor.

SEARCHMODE=

Defines the mode for the coloring of status UNDEFINED:

  • 0: Standard.
    The source color is distributed in the grid starting from every switched on source as long as the next switch is closed.
  • 1: Input takes priority.
    Only colors lines which are potentially supplied by at least one source but no explicitly by one source.

It corresponds to the Mode for coloring property in the Editor.

SOURCE_BACKGROUNDx=

Background color of the source. This is used as the background color for tubes and procedural elements (Combined element). x stands for the number of the source, starting with 0. This number must not be confused with the SOURCE_PRIORITYx= property.

Example: SOURCE_BACKGROUND3=2124031.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

Recommendation: Configuration in the dialog of the property ALC configuration.

SOURCE_CNT=

Number of configured sources.

This value is set by the Editor.

SOURCE_COLOURx=

Line color of source. This color is used for coloring lines, polylines and as the outside color of tubes. x stands for the number of the marker, starting with 0. This number must not be confused with the SOURCE_PRIORITYx= property.

Example: SOURCE_COLOUR3=255.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

Recommendation: Configuration in the dialog of the property ALC configuration.

SOURCE_NAME0=

Name of the source. This name is also used when selecting the source number for Combined elements. x stands for the number of the marker, starting with 0.

Example: SOURCE_NAME3=GROUNDED

Recommendation: Configuration in the dialog of the property ALC configuration.

SOURCE_PRIORITYx=

Priority when processing. This number is given by the system automatically and should not be changed.

Example: SOURCE_PRIORITY0=3
The source 0 has priority3 and is displayed and processed at the third place in the list.

[ALC_TOP]

Entry

Description

[ALC_TOP]

Properties of interlocking.

Recommendation: Configuration in the dialog of the property ALC configuration.

INTER_CNT=5

Number of configured interlockings.

This value is set by the Editor.

INTER_NOx=

Type of interlocking. x stands for the number of the entry, starting with 0. The type is defined by numbers:

  • 900: Voltage towards ground
  • 903: Switching operation in area with undefined status.
  • 905: Disconnector under load
  • 906: Device would not be supplied.
  • 907: Area with undefined status would increase

Example: INTER_NO0=900

INTER_MODEx=

Status of the interlocking. x stands for the number of the entry, starting with 0. Possible status:

  • 0: do not check
  • 1: unlockable
  • 2: not unlockable

Example: INTER_MODE0=1


Screen elements [ELEMENTE]

Manual -> Configuration files -> project.ini -> Screen elements [ELEMENTE]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[ELEMENTE]

TREND_ZEIT_FAKTOR=

Multiplication factor for time intervals when drawing in a trend element.

A trend curve is only drawn if the distance between two recorded values is x-times the necessary update rate.

  • 0: No check is carried out.

Maximum: 65535

Default: 20


CEL [BTB]

Manual -> Configuration files -> project.ini -> CEL [BTB]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[BTB]

Entries for the Chronological Event List (CEL).

These properties should generally be set up in the Editor in the project properties of the Chronological Event List group.

ARCHIV_WRITE=

Setting for whether a CEL entry is to be generated in the event of changes to archive data:

  • 0: Editing archives is logged in the CEL.
  • 1: Editing of archives is logged in the CEL:
    • Name of the archive file
    • New and old value of the variables
    • New and time stamp of the variables
    • Name of the variable

It corresponds to the Archive data property in the Editor.

AREA=

Description of the column Alarm area.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

AREA_ANZ=

Width of the column Alarm area in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

AREANR=

Description of the column Alarm area number.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

AREANR_ANZ=

Width of the column Alarm area number in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

BTBLISTE=

Desired entries and their sequence in the list

  • 0: Variable name
  • 1: Identification
  • 2: Text
  • 3: Time of occurrence
  • 6: Status information
  • 7: Value
  • 8: Output to user

Example: BTBLISTE=320

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

CLASS_ANZ=

Width of the Alarm/event class column in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

COLOR_BACKGROUND=

Use of the color from alarm class:

  • 1: Class color is interpreted as a background color
  • 0: Class color defines the text color.

Default: 0

If no class is linked to a limit, the background or text color is taken from the settings of the list element in the screen.

Is used together with the COLOR_CLASS= property.

It corresponds to the Alarm/event class color property in the Editor.

COLOR_CLASS=

Alarm/event class color is:

  • 1: used
  • 0: not used

Default: 1

Is used together with the COLOR_BACKGROUND= property.

It corresponds to the Alarm/event class color property in the Editor.

COMPUTER_ANZ=

Width of the column Computer name in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

DRUCKE_SYSMLDG=

Setting for the printout of system messages with online printing:

  • 0: output in a list only
  • 1: Printout carried out

Default: 1

It corresponds to the Print system messages property in the Editor.

DYN_LIMIT_FILE=

Use of the comment field for dynamic limit value text:

  • 0: The comment field is used for dynamic limit texts and is therefore not available for comments.
    Maximum length: 80 characters.
  • 1: Dynamic contents will be stored in a file with the file format D*.CEL. It will be stored in addition to the file C*.CEL. The comment filed can therefore been used for comments.
    Maximum length for dynamic limit value texts: 254 characters.

Default: 0

It corresponds to the Long dynamic limit texts CEL property in the Editor.

EIN=

The Chronological Event List is used.

  • 1: The Chronological Event List (CEL) is active in the Runtime. Events are recorded and the CEL is available.
  • 0: No event are recorded.

Default: 1

Note: Changes take effect after the Runtime has been restarted.

It corresponds to the CEL active property in the Editor.

FARBE_SORT=

Defines the color of the text for sorted entries in the CEL.

Note:

  • If 1 is selected for the COLOR_BACKGROUND= property, this color takes priority before selection in FARBE_SORT.
  • For SICAM 230: To have the same color everywhere in the list, you must select the same color for the FARBE_UNSORT= property.

It corresponds to the sorted text property in the Editor.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

FARBE_UNSORT=

Defines the color of the text for unsorted entries in the CEL.

It corresponds to the unsorted text property in the Editor.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

FIRST_ENTRY=

Entries to be displayed when calling up the CEL.

  • 0: No existing limit value entries are read in when Runtime is started. New entries are only made if new events occur after starting.
  • 1: When starting, limit value breaches that already exist are also entered.

GRID_LINES=

Display of the columns and lines in the Alarm Message List with grid lines:

  • 0: on
  • 1: off

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

GROUP_ANZ=

Width of the Alarm/event Group column in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

HEADER=

Show the column headers in the list.

Show the column headers in the CEL.

  • 1: Column heading is displayed.
  • 0: Column heading is not displayed.

Is used together with the HEADER_ENABLE= setting.

It corresponds to the Header CEL property in the Editor.

HEADER_ENABLE=

Use of the column heading:

  • 1: Column heading can be operated.
  • 0: Column heading is only used for display (fixed).

Is used together with the HEADER= setting.

It corresponds to the Header CEL property in the Editor.

MAXTEXTLEN=

Define how many characters the static limit text in the CEL can have as a maximum. The minimum and maximum values are also true for VBA/VSTA.

  • Minimum: 127
  • Maximum: 1023

Restriction: With dBase export the length is restricted to 256 characters.

It corresponds to the Length static limit texts CEL property in the Editor.

NAME=

Issue of a short name for the saved text files.

Requirement: The entry TXT_FILE=1

Default: NAME=BTBTTMM.TXT
(TT=day, MM=month)

RECIPE_CHANGE=

Entries when changing recipes

  • 0: Changing standard recipes and recipes of the Recipegroup Manager (RGM) is not logged in the CEL.
  • 1: When changing a recipe, it is logged with the name of the recipe in the CEL.
  • 2: The following is logged in the CEL when the recipe is changed:
    • Name of the recipe
    • New and old values of the variables
    • Names of the variable

Default: 0

It corresponds to the Change recipes property in the Editor.

RECIPE_WRITE=

Entries when writing recipes

  • 0: The changing of standard recipes and recipes of the Recipegroup Manager (RGM) is not logged in the CEL.
  • 1: When sending a recipe, it is logged with the name of the recipe in the CEL.
  • 2: When writing a recipe, it is logged in the CEL with:
    • Name of the recipe
    • New and old values of the variables
    • Names of the variable

Default: 0

It corresponds to the Send recipes property in the Editor.

RESOURCELABEL=

Describes the column for the resources label.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

RESOURCELABEL_ANZ=

Width of the column for the resources label in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

RTEXT_ANZ=

Width of the column Reaction text in characters

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

SAVE_BIN_ALWAYS=

Setting of whether each change to the data of the CEL also has an effect on the data in cel.bin:

  • 1: Saving active
  • 0: Saving inactive

Default: 0

It corresponds to the Save ringbuffer on change property in the Editor.

Note: If the property is set to active, this can lead to a considerable load being placed on the system - with flash disks most of all. If the property is set to inactive, this can lead to data being lost in the event of Runtime closing unexpectedly. Inactive Recommended especially for low performance.

SAVE_ONLY_STACK=

Data retention for CEL:

  • 0: All CEL entries (*.cel) are saved.
  • 1: Only a defined number of CEL entries (cel.bin) is saved. The number is defined via property Size of the ringbuffer.
  • 2: On CE devices only the ring buffer (cel.bin) is saved on the hard disk; on PCs the historic entries (*.cel) are also saved.

Default: 0

It corresponds to the Save CEL data property in the Editor.

SORTDESCENDING=

Sort direction

  • 0: ascending
  • 1: descending

Default: 0

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

SPONTAN=

Time point for entry in the list:

  • 1: All new CEL entries are entered immediately.
    Exceptions: The list has been stopped.
  • 0: Changes are only loaded after the list is called up again.
    Advantage: Reduces network traffic.

Default: 1

It corresponds to the Update automatically property in the Editor.

STAT_ANZ=

Width of the column Status in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TAG_ANZ=

Width of the column Identification in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_NAME=

Identifier for the Variable name column title.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_ACT_TEXT=

Description of the column Comment.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_CLASS=

Description of the column Alarm/Event class.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_CLASSNR=

Description of the column Alarm/Event class number.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_CLASSSYMBOL=

Description of the column Alarm/Event class symbol.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_CLASSSYMBOL_STYLE=

Display type of the column Alarm/Event class symbol.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_COMES=

Description of the column Time received.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_COMP=

Description of the column Computer name.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_GROUP=

Description of the column Alarm/Event group.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_GROUPNR=

Description of the column Alarm/Event group number.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_GROUPSYMBOL=

Description of the column Alarm/Event group symbol.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_GROUPSYMBOL_STYLE=

Display type of the column Alarm/Event group symbol.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_NAME=

Identifier for the Variable name column title.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_PROJECT=

Description of the column Project name.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_TAGNR=

Description of the column Identification.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_TEXT=

Description of the column Text.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_STATUS=

Description of the column Variable status.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_USER=

Description of the column User name.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_USERNAME=

Description of the column User - full name.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TITLE_VALUE=

Description of the column Value.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TXT_ANZ=

Width of the column Text in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

TXT_FILE=

Type of saving of the information:

  • 0: its own format in zenon (*.cel)
  • 1: in ASCII format (*.txt)

Default: 0
Note: This file can no longer be read for zenon.

UNIT=

Width of the column Measuring unit in characters

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

USER_ANZ=

Width of the column User name characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

VAR_ANZ=

Width of the column Variable name in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

WERT_ANZ=

Width of the column Value in characters.

Recommendation: Configuration in the Editor using the dialog of the Column settings CEL property in the Chronological Event List group or screen switching.

ZEIT_TYP=

Definition of the format in which the time should be output.

  • 1: only milliseconds
  • 2: only time
  • 3: Time and milliseconds
  • 4: only date
  • 5: Date and millisecond
  • 6: Date and time
  • 7: Date, time and milliseconds

Recommendation: Configuration in the Editor using the dialog of the Column settings AML property in the Alarm Message List group or screen switching.


Print [DRUCKER]

Manual -> Configuration files -> project.ini -> Print [DRUCKER]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[DRUCKER]

Settings for printout in Runtime.

DRUCKZEIT=

If alarms occur at virtually the same time, several entries can be compiled into one print job.

Example: DRUCKZEIT=2
No alarm can occur for at least 2 seconds so that the print job is sent.

MAXNAMEN=

When printing in Runtime, the individual entries are each sent as separate print jobs. A number can be issued to prevent naming conflicts.

Example: MAXNAMEN=9
Numbers the files through to 9.

MAXPJ=

Maximum number of the print jobs in the Windows Print Manager. If this entry is exceeded, an entry is made in the Chronological Event List (CEL).

  • Minimum: 0
  • Maximum: 65535

Default: 90

It corresponds to the property Max. print jobs in group Runtime settings in the Editor.


Extended Trend [EW_TREND]

Manual -> Configuration files -> project.ini -> Extended Trend [EW_TREND]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[EW_TREND]

Settings for the Extended Trend.

ANZEIGE_GWTEXT=0

Display of the limit value text when scanning the curves.

  • 1: on
  • 0: off


Export [EXPORT]

Manual -> Configuration files -> project.ini -> Export [EXPORT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[EXPORT]

FILEEXIST_MESSAGEBOX=

Notification when overwriting existing data when exporting data in Runtime:

  • 1: The message is displayed:
  • 0: The message is not shown.

Default: 0

It corresponds to the property Data export in group Runtime settings/Runtime messages for in the Editor.

FILEEXIST_OVERWR_APP_CAN=

Action if existing files are overwritten during export:

  • 0: The file is overwritten (=OVERWRITE).
  • 1: Data sets are appended (=APPEND).
  • 2: export is canceled (=CANCEL).

MAX_LAENGE=

Maximum length of decimal places when archiving to a DBF file.

Default=32

OK_MESSAGEBOX=

Notification on successful export of data in Runtime:

  • 1: The message is displayed:
  • 0: The message is not shown.

Default: 0

It corresponds to the property Replace files in group Runtime settings/Runtime messages for in the Editor.


Error logs [ERRORLOG] and [LON_32]

Manual -> Configuration files -> project.ini -> Error logs [ERRORLOG] and [LON_32]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[ERRORLOG]

Settings for creation and content of error log files.

[LON_32]

Settings for the LON driver.

DIAG_LEVEL=

Actions are logged in the error file depending on the level:

  • 0: no logging (default)
  • 1: Error
  • 2: Write
  • 3: Read
  • 4: Advise/Unadvise
  • 5: Internal


Functions [FUNKTIONEN]

Manual -> Configuration files -> project.ini -> Functions [FUNKTIONEN]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[FUNKTIONEN]

Entries for functions.

EIN=

Automatic function execution for limit value breach, time control etc.

  • 1: active
  • 2: inactive

Default: 2

It corresponds to the property Autom. function execution active in group Functions in the Editor.

NAMEN=

Display of the functions according to:

  • 0: Functions
  • 1: Names

PROJECTONLY=

Effect of the Screen: Return to last function:

  • 0: throughout the project
  • 1: only with screens of the project in which the function was created

Only for multi-project administration.

SOUND=

Selection of a sound for the Start continuous tone function and start of the function.

Value: Number between 1 and 255

Recommendation: Configuration by means of the function.

ZURUECK_ANZAHL=

Number of screens that are to be entered in the list for the Screen: Return to last function.
Note: Each call of the screen switch function counts, even if the screen switch does not ensue directly but is entered in the screen properties as a start function.

  • Minimum: 0
  • Maximum: 65535
  • Default: 10

Recommendation: Configuration by means of the Anzahl f. Bild zurück Fkt. function in the Functions group.

ZURUECK_SCHABLONEN=

Name of the frame whose screens in the list are to be included for the Screen: Return to last function.

Several frames can be used. These are separated by an underscore in front and a comma.
E. g.: ZURUECK_SCHABLONEN=_MAIN,_SUBNAVIGATION,

Recommendation: Configuration by means of the Main frames function in the Graphical design/Runtime general group.


Industrial Maintenance Manager [IMM]

Manual -> Configuration files -> project.ini -> Industrial Maintenance Manager [IMM]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Entry | Description
[IMM] | Entries for the Industrial Maintenance Manager (IMM).
Dns= | ODBC connection to the database of the IMM. It corresponds to the Database property in the Editor.
TableDevice= | Name of the table in the database for the devices. Is also used for metering point administration and is fixed. Should not be changed. Default: Devices It corresponds to the Table for devices property in the Editor.
TableMaint= | Name of the table in the database for maintenance works. Is predefined and fixed and should not be changed. Default: MaintenanceWorks It corresponds to the Table for maint. works property in the Editor.
TableHist= | Name of the table in the database for the histories. Is predefined and fixed and should not be changed. Default: MaintenanceHistory It corresponds to the Table for history property in the Editor.
TableDoc= | Name of the table in the database for the documents. Is predefined and fixed and should not be changed. Default: Documents It corresponds to the Table for documents property in the Editor.
Userlevel= | Authorization group that is needed in order to be able to delete data from the database. Default: 0 It corresponds to the Authorization level property in the Editor.


Network [NETZ] and [TOKEN]

Manual -> Configuration files -> project.ini -> Network [NETZ] and [TOKEN]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[NETZ]

Settings for the network.

Recommendation: Configuration by means of the properties of the Network group.

APP_CLOSE_BOX=

If a server is closed whilst clients are connected, a message can be displayed:

  • 1: At closing the Runtime on a server, a message is displayed on all connected clients that the Runtime is closed. The closing of the Runtime is delayed for 70 seconds. Thus entries can be finished correctly on the clients.
  • 0: The Runtime on the server is closed without displaying a message on the clients.

Default: 0

It corresponds to the Termination message property in the Editor.

DATENSERVER=

Selection of which server operates as the data server:

  • 0: Server 1
  • 1: Server 2

Default: 0

It corresponds to the Server 2 as data server property in the Editor.

DetectionOffTime=

Time in seconds for how long is waited to switch to process handling after a regrading.

  • Minimum: 0
  • Maximum: 65535

Default: 10

It corresponds to the Dead time after switching [s] property in the Editor.

eCriteria<Index>=

Checking criteria: A serial index number is used for each entry. For example eCriteria0, eCriteria1 ... Is used together with the WatchedVariableID<Index>, ValueLimit<Index> and Weight<Index> properties. The linking is implemented by means of the index numbers.

Values:

  • 0: No evaluation
  • 1: Only for variable status
  • 2: Going below the value
  • 3: Exceeding the value

Can be configured via the dialog of property Assessment in the Editor.

Hysteresis=

Hysteresis in assessment points that must be exceeded in order to trigger switching delay.

  • Minimum: 0
  • Maximum: 4294967296

Default: 0

It corresponds to the Hysteresis property in the Editor.

ModifiedCounter=

Counter that is incremented by one each time there is a change to a property in the Redundancy settings group. This counter is required for the validation of the evaluation in the network and is set by zenon automatically.

Attention: Must not be changed!

RatedEntries=

Number of defined evaluations. Relates to the eCriteria<Index>, WatchedVariableID<Index>, ValueLimit<Index> and Weight<Index> properties used. The linking is implemented by means of the index numbers.

RELOADDELAY_SEC=

Reload delay for clients in seconds with large network projects.

  • 0, no delay

RedundancyMode=

Type of redundancy mode for the evaluation of the network. If configured value has been selected as evaluated, this controls redundancy switching.

  • 0: Dominant.
    Does not carry out an evaluation.
  • 1: Non-dominant.
    Result of the evaluation is always zero. No switching is carried out.
  • 2: Rated.
    An evaluation is carried out and switched accordingly. This is implemented by means of the eCriteria<Index>, WatchedVariableID<Index>, ValueLimit<Index> and Weight<Index> properties.

Default: 1

Note: Only active if Redundanztyp=Software redundancy

It corresponds to the Redundancy mode property in the Editor.

Routing=

Settings for routing:

  • 0: No routing.
  • 1: The computer acts as node computer and can route packets. Thereby all network packets from the outside use this computer.
    This setting can lead to bottlenecks and influences the possible network topology. It is sensible to use it in special network constellations, e.g. for WAN networks or routed networks.

Default: 0

Recommendation: Deactivate setting.

It corresponds to the Routing active property in the Editor.

SERVER=

Setting of whether the network is used.

  • -1: Network inactive, standalone computer.
  • >= 0: Network active

Default: 0

Example: SERVER=2

It corresponds to the Network active property in the Editor.

SERVER1=

Allocation of a computer as Server 1.

Example: SERVER1=COMPUTER1

It corresponds to the Server 1 property in the Editor.

SERVER2=

Allocation of a computer as Server 2.

Example: SERVER2=COMPUTER2

It corresponds to the Server 2 property in the Editor.

SwitchDelay=

Time that the upgrade to Primary Server is delayed in seconds.

  • Minimum: 0
  • Maximum: 65535

Default: 30

Only has an effect if 2 was selected for RedundancyMode=.

It corresponds to the Switching delay [s] property in the Editor.

TYPE=

Selection of the redundancy model.

  • 1: Hardware redundancy.
    The system consists of two redundant PLCs and two redundant control system computers. Each server communicates bidirectionally with one PLC. Both computers and both PLCs are synchronizing their data. If one component in the first system crashes, the second system takes over.
  • 0: Software redundancy.
    The system consists of one PLC and two redundant control system computers. Both computers must have a connection to the PLC. Both computers communicate with the control and at the same time keep the data from the control updated. The communication to the control is managed by the computer which is the server. The server communicates bidirectionally, the standby communicates unidirectionally. If the Server crashes, the Standby Server takes over the bidirectional communication with the PLC.

Default: 0

It corresponds to the Redundancy type property in the Editor.

ValueLimit<Index>=

Limit value that is checked when the evaluation of a value takes place. A serial index number is used for each entry. For example ValueLimit0, ValueLimit1 ...

Is used together with the eCriteria<Index>, WatchedVariableID<Index> and Weight<Index> properties. The linking is implemented by means of the index numbers.

Default: 0

Can be configured via the dialog of property Assessment in the Editor.

WatchedVariableID<Index>=

ID of the variables that can be used for the evaluation. A serial index number is used for each entry. For example WatchedVariableID0, WatchedVariableID1 ...

Is used together with the eCriteria<Index>, ValueLimit<Index> and Weight<Index> properties. The linking is implemented by means of the index numbers.

Default: 0

Can be configured via the dialog of property Assessment in the Editor.

Weight<Index>=

Weighting for evaluation.

Value between 0 and 100.

A serial index number is used for each entry. For example Weight0, Weight1 ... Is used together with the eCriteria<Index>, WatchedVariableID<Index> and ValueLimit<Index> properties. The linking is implemented by means of the index numbers.

Default: 100

Can be configured via the dialog of property Assessment in the Editor.

TOKEN

Entry

Description

[TOKEN]

Administration of the operating authorizations.

ACTIVE=0

The active authorization in the network makes sure that in the network only one station at a time can carry out active operations (e.g. change set values). Passiv, reading access is always possible regardless of the option. Possible values:

  • 1: Only on computer can operate the project at a time (e.g. acknowledge alarms, write set values).
  • 0: Several computers can operate the project at the same time.

Default: 0

It corresponds to the Authorization in network active property in the Editor.

QUESTION_TIMEOUT=

Time that is available to a computer in order to respond to a query for a token issue. After the time expires without an answer, the requesting station automatically receives the authorization.

It corresponds to the Timeout for request [s] property in the Editor.

QUIT_TIMEOUT=60

Time period within which a client must confirm its operating authorization cyclically. If no confirmation is sent in this time period, the client automatically loses its token.

Attention: This value must be smaller than the time defined in property QUESTION_TIMEOUT= .

It corresponds to the Timeout for authorization [s] property in the Editor.


Password administration [PASSWORD]

Manual -> Configuration files -> project.ini -> Password administration [PASSWORD]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[PASSWORD]

Settings for the user administration.

Recommendation: Configuration by means of the User administration group.

CANAUTOLOGOFF=
  • Automatic logout:
  • 1: The user is automatically logged out if there is no operation for the time period defined in the LOGOFF= property.
  • 0: No automatic logout.

Default: 0

It corresponds to the Activate automatical logout property in the Editor.

CHANGE_PWD_PIC=

Screen that is used for changing the password instead of the modal dialog.

  • GUID: The screen with this GUID is called up when the password is changed (function call or mandatory change by the user). Only Edit user screens can be linked.
  • Empty: No screen linked. A modal dialog is called up for the login.

Default: Space

It corresponds to the Screen for password change property in the Editor.

DEL_PIC_BACK_PATH_AT_LOGOUT=

Setting for the automatic deletion of the screen-back path when switching users.

  • 0: Path is not deleted
  • >0: Path is deleted when a user is changed

Default: 0

It corresponds to the DelPicBackPathAtLogout property in the Editor.

DELUSER=

Deletion of a user in Runtime:

  • 1: Deletion of a user is permitted.
  • 0: Users can only be marked as deleted. The users remain in the list of users, but are no longer valid for operation in Runtime (in accordance with FDA guidelines).

Default: 1

It corresponds to the Deleting users property in the Editor.

DISREAKTION=

Defines the appearance of buttons that are blocked due to the settings of the operating authorizations. Is combined in the Runtime for the operation of keys with property Interlocked buttons (LOCKED_KEYS=).

Possible values:

  • 0: Normal
  • 1: Grey
  • 2: Invisible

Default: 0

Only has an effect if the LOGTEMP = property has the value 0.

It corresponds to the Locked buttons property in the Editor.

EDITSIGNATURE=

Allow changes to the signature text:

  • 0: The signature text cannot be changed in Runtime.
  • 1: A dialog to edit the signature text is opened in Runtime.

Default: 0

It corresponds to the Signature text editable property in the Editor.

LOGIN_PIC=

Screen that is used for login instead of the modal dialog. This screen is also used for the execution of the Login with dialog function.

  • GUID: The screen with this GUID is called up on login. Only login screens can be linked.
  • Empty: No screen linked. A modal dialog or the screen defined in LOGINSIGNATURE_PIC= is used for login.

Default: Space

It corresponds to the Screen for Login property in the Editor.

LOGINSIGNATURE_PIC=

Screen that is used for login with signature instead of the modal dialog.

  • GUID: The screen with this GUID is called up on login with signature. Only login screens can be linked.
  • Empty: No screen linked. A modal dialog is called up for the login with signature.

Default: Space

It corresponds to the Screen for Login with signature property in the Editor.

LOGOFF=

Time without operation (in minutes) after which a user is automatically logged out if the CANAUTOLOGOFF= property has the value 1.

It corresponds to the Time [min] property in the Editor.

LOGTEMP =

Temporary login for the execution of a function:

  • 1: If a user is not logged in and tries to operate an element which needs a user authorization, he must enter his user name and password. The user is automatically logged out again immediately after the operation
  • 0: If a user is not logged in and tries to operate an element which needs a user authorization, he receives a message that he does not have the necessary authorization.

Default: 1

Note: You can define position and size of the login mask in file zenon6.ini in section [Befehlsgabe] Position =.

It corresponds to the Temp. login active property in the Editor.

MINPWLENGTH=

Minimum length of the password in characters.

  • Minimum: 0
  • Maximum: 20

Default: 6

It corresponds to the Minimum password length property in the Editor.

PWTRIES=

Number of incorrect password entries.
The corresponding user is blocked if this number is exceeded. The block can only be lifted by an administrator. A corresponding dialog is created in the Chronological Event List (CEL).

  • Minimum: 0
  • Maximum: 65535

Default: 3

It corresponds to the Max. password error property in the Editor.

PWVALIDDAYS=

Enter a time period in days defining how long a password should stay valid. After the time expired, you must enter a new password.

  • Minimum: 0 - The password never expires and need not be renewed. For this setting the value 2147483647 is written to system driver variable "Days until password expires".
  • Maximum: 4294967295

Default: 0
Attention: For productions according to the FDA guidelines entry 0 is not allowed as the rules of the FDA demand a cyclic change of the password.

It corresponds to the Password - period of validity [d] property in the Editor.

RecursiveLogin=

Setting for automatic login/logout in subprojects:

  • 0: no automatic login/logout (default)
  • 1: automatic login/logout active

Default: 0

It corresponds to the Automatic login/logout in subprojects property in the Editor.

USERTRIES=

Number of permitted entries of a non-existent user name.
The system is blocked if this number is exceeded. With the exception of administrators, no more users can log on. The system is automatically unlocked after an administrator logs on. A corresponding entry is made in the Chronological Event List (CEL). Changes to this value are only effective in Runtime after restarting.

  • Minimum: 0
  • Maximum: 65535

Default: 3

It corresponds to the Max. user error property in the Editor.


Paths [PATH]

Manual -> Configuration files -> project.ini -> Paths [PATH]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Entry | Description
[PATH] | Configuration of the paths.
BACKUP= | Path of the saved archives default = project directory
EXPORTPFAD= | Last set export path for export of data or reports in the Runtime.
LISTEN= | Path for lists in *.txt , *.qrf and *.frm format.
REPORTS= | Path for the export or printing of reports.
VIDEO= | Path for files in *.avi format in Runtime.


Production and Facility Manager [PFM]

Manual -> Configuration files -> project.ini -> Production and Facility Manager [PFM]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[PFM]

Settings for the Production and Facility Manager

AnzeigenMitStrg=

Controls display of the dialog when pasting copied schedules.

Possible values:

  • 1: The dialog is only shown if the Ctrl button is pressed whilst the schedule is inserted.
  • 0: The dialog is always displayed.


Project linking [PROJEKTLINKS]

Manual -> Configuration files -> project.ini -> Project linking [PROJEKTLINKS]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[PROJEKTLINKS]

Parameters for linked projects for integration projects.

Linked subprojects are numbered throughout, for example: LINK1=, LINK2=, ...

GLINK=

Name of the global project.

If this is changed, the linked project references must be amended accordingly.

GLINKPATH=

Path of the global project for Runtime files.

If this is changed, files that already exist must be copied manually into the new folder.

LINK1=

Project name of the first subproject.

LINKGUID1=

Unique GUID of the first subproject.

LINKMULTI1=

Identifier for multi-user projects

  • 1: Multi-user projects.
  • 0: Standalone project.

LINKPATH1=

Project path of the first subproject.


Remote Transport [ED_REMOTE], [DIRLIST] and [TRANSPASS]

Manual -> Configuration files -> project.ini -> Remote Transport [ED_REMOTE], [DIRLIST] and [TRANSPASS]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

[ED_REMOTE]

Entry

Description

[ED_REMOTE]

Administration of the Remote Transport parameters in the network for the Editor.

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

COM=

Definition of the COM port with serial connection (DEVICE=0).

CONFIG=

Configuration of the connection by means of serial connection or TCP/IP.

For example: CONFIG=HOST=RECHNER-XY048;

DEVICE=

Type of connection:

  • 0: Serial
  • 1: TCP/IP

Default: 1

EXTRA=

Settings for Windows CE. Use of the local card reading device:

  • 0: No
  • 1: yes

Only has an effect if Windows CE has been activated in the project settings.

EXTRAEINTRAG=

Runtime folder on the target device when the local card reading device (EXTRA=1) for Windows CE is used.

IP_NAME=

Computer name or the IP address for the TCP/IP connection (DEVICE=1).

RECENT_x=

Last-used computer name. x stands for the number of the entry, starting with 0 for the last-used name.

Example: RECENT_0=ATSGA-XY007

SERVER_DOWNLOAD

Settings for the download:

  • 1: Download active.
    The download is also being carried out on Server 1 and Server 2.
  • 0: Download inactive.
    The download only takes place on the computer that has been entered.

Only has an effect if the network has been activated in the project settings and the transport medium TCP/IP has been selected.

[DIRLIST]

Entry

Description

[DIRLIST]

Settings for the folder for Remote Transport

ADD_AKTIV=

Transfer of files from the Other file folder:

  • 0: inactive
  • 1: active

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

BITMAP=

Save path for Graphics file folder.

BITMAP_AKTIV=

Transfer of files in the Graphics file folder:

  • 0: Files are not transferred.
  • 1: Files are transferred.

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

COMMENT_x=

Comments on individual entries in the source/target list. x stands for the number of the entry, starting with 0.

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

COUNT=

Number of configured lines in the source/target list in the Remote transport dialog. Is entered by the Editor.

DRV_AKTIV=

Transfer of the files from the Driver file folder:

  • 0: inactive
  • 1: active

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

HELP_AKTIV=

Transfer of the files from the Help file folder:

  • 0: inactive
  • 1: active

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

LISTEN=

Save path for the Texts and formats file folder.

LISTEN_AKTIV=

Transfer of files in the file folder for Texts and formats:

  • 0: Files are not transferred.
  • 1: Files are transferred.

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

PROJECTBASE=

Target path for Runtime folder on the remote device.

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

RDLC_AKTIV=

Transfer of the files from the Report Viewer file folder:

  • 0: inactive
  • 1: active

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

REPORTS=

Save path for Tables file folder.

REPORTS_AKTIV=

Transfer of files in the Tables file folder:

  • 0: Files are not transferred.
  • 1: Files are transferred.

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

SOURCE_x=

Source path for individually-defined file or folder for the transfer. x stands for the number of the entry, starting with 0.

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

SPALTENBREITE_0=

Width of the column active in characters

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

SPALTENBREITE_1=

Width of the column Sourcein characters

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

SPALTENBREITE_2=

Width of the column Target in characters

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

SPALTENBREITE_3=

Width of the column Editing in characters

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

SPALTENBREITE_4=

Width of the column Description in characters

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

STRAT_AKTIV=

Transferring the zenon Logic files

  • 0: inactive
  • 1: active

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

TARGET_x=

Target path for individually-defined file or folder for the transfer. x stands for the number of the entry, starting with 0.

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

TYPE_x=

Type of transfer for individually-defined files or folder. x stands for the number of the entry, starting with 0. Transfer types:

  • o: Copy
  • 1: Copy and register data
  • 2: Copy and execute data

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

VIDEO=

Save path for the Multimedia file folder.

VIDEO_AKTIV=

Transfer of files in the Multimedia file folder:

  • 0: Files are not transferred.
  • 1: Files are transferred.

Recommendation: Configuration in the dialog of the property Remote transport in the group General.

[TRANSPASS]

Entry

Description

[TRANSPASS]

Remote Transport password on the development computer.

Note: Configuration for Remote in zenon6.ini in the Remote Transport password [TRANSPASS] section.

FIX=

Password is:

  • 1: saved
  • 0: not saved

KEY=

Password for Remote Transport.

Is entered by the Editor.

KEYCRYPT=

Encrypted stored password for remote transport.

Is only used if KEY= is empty.

Default from version 7.20. The switch is carried out automatically for the conversion of a project to version 7.20. The switch must be carried out manually on the target system.

NET=

Data query for the configuration of the encryption:

  • Not 0: After a Remote Transport connection has been established, the Editor sends a query to the remote device, requesting the data for the configuration of the encryption. The entry is set by the Make connection dialog and reset to 0 straight after the request is sent.

SER=

Status of the Configure serial number and activation umber in the dialog to establish a connection.

  • 0: inactive
  • 1: active


Recipegroup Manager [RGM]

Manual -> Configuration files -> project.ini -> Recipegroup Manager [RGM]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[RGM]

Entries for the Reccipegroup Manager.

REPORTFONT=

Font for tables:

  • 1 The font can be set with Recipe Group Manager screens. The font which was specified in the settings of Font is used.
  • 0: Standard font is used.

Default: 0

If a user-defined table (created with the Report Generator) is used, the fonts set in the report are used.

It corresponds to the Table font adjustable property in the Editor.


Runtime [RT]

Manual -> Configuration files -> project.ini -> Runtime [RT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[RT]

Settings for the Runtime.

ERSTE_TASTE=

Execution of functions that are linked to a button:

  • 0: all linked functions are executed
  • 1: only the first function found is executed

GFX_LIST_SEL_CLR_0=

Color for the text of a list entry if the focus is on the element.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

e.g.: GFX_LIST_SEL_CLR_0=16777215

Default: Value of the operating system

It corresponds to the property Text color on focus in group Graphical design/Selection colors for the object lists in the Editor.

GFX_LIST_SEL_CLR_1=

Color for the text of a list entry if the focus is not on the element.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

e.g.: LIST_SEL_CLR_2=0

Default: Value of the operating system

It corresponds to the property Text color without focus in group Graphical design/Selection colors for the object lists in the Editor.

GFX_LIST_SEL_CLR_2=

Background color of a list entry if the focus is on the element.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

e.g.: LIST_SEL_CLR_2=16750899

Default: Value of the operating system

It corresponds to the property Background color on focus in group Graphical design/Selection colors for the object lists in the Editor.

GFX_LIST_SEL_CLR_3=

Background color of a list entry if the focus is not on the element.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

e.g.: LIST_SEL_CLR_2=15790320

Default: Value of the operating system

It corresponds to the property Background color without focus in group Graphical design/Selection colors for the object lists in the Editor.

LOCKED_KEYS=

Defines the look of buttons in the Runtime which are locked due to an interlocking.

Possible formats:

  • 0: normal
  • 1: gray
  • 2: invisible

This property acts independent of property Graphical identification active. A gray button can for example also display a lock symbol

Is combined with the DISREAKTION= property in Runtime ([PASSWORD] group)

It corresponds to the property Interlocked buttons in group Graphical design/Locked/Interlocked elements in the Editor.

NOT_WORKING_AKTIV=

Setting for the automatic execution of a function after a set time without operation:

  • 1: automatic execution active
  • 0: automatic execution inactive. The execution is activated (=1) or deactivated (=0) with this entry.

Default: 0

The function to be executed is defined with NOT_WORKING_FUNC= . The time period with NOT_WORKING_TIME=.

It corresponds to the property Autom. function execution active in group Functions in the Editor.

NOT_WORKING_FUNC=

Number of the function that is to executed after the tine defined in NOT_WORKING_TIME=.

It corresponds to the property Function in group Functions in the Editor.

NOT_WORKING_TIME=

Time in minutes after which the function stated in NOT_WORKING_FUNC= is to be executed.

It corresponds to the property Time without operation (in minutes) in group Functions in the Editor.

SELECTION_NORMAL=

Identification of a selected entry in a list (alarm or CEL) with:

  • 0: Border. Recommended for better readability at high screen resolutions.
  • 1: Bar. The background color of the selected lines is inverted. Recommended for better readability at low screen resolutions.

Default: 0

It corresponds to the property Selection with border in group AML and CEL in the Editor.

TOUCHSCREEN=

Automatic keyboard for touch screens:

  • 1: display if the input is necessary
  • 0: do not display

Default: 0

It corresponds to the property Automatic keyboard in group Interaction/Keyboard in the Editor.

WIN_CE=

Settings for use under Windows CE:

  • 1: Functionalities which are not supported under Windows CE are hidden in the Editor (grayed out or invisible).
  • 0: The complete licensed functionality of the Editor is available.

Default: 0

It corresponds to the property Windows CE project in group General in the Editor.

WITH_ACTION=1

Operation of the elements:

  • 0: The first element under the mouse pointer is used.
  • 1: The first element under the mouse pointer that is linked to an action is used.


Data that can be changed in Runtime [RTDATEN]

Manual -> Configuration files -> project.ini -> Data that can be changed in Runtime [RTDATEN]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[RTDATEN]

Settings for generating RT changeable data.

NOOVERWRITE_REZEPTE=

Transfer of recipe groups.

  • 0: Recipe groups are created and transferred. Recipe groups present in Runtime are overwritten.
  • 1: Recipe groups are not transferred.

Recommendation: Configuration in the editor in the dialog of the property RT changeable data.

NOOVERWRITE_REZEPTUREN=

Transfer of recipes.

  • 0: Recipes are created and transferred. Recipes present in Runtime are overwritten.
  • 1: Recipes are not transferred.

Recommendation: Configuration in the editor in the dialog of the property RT changeable data.

NOOVERWRITE_PASSWORT=

Transfer of passwords.

  • 0: Passwords are created and transferred. Recipes present in Runtime are overwritten.
  • 1: Passwords are not transferred.

Recommendation: Configuration in the editor in the dialog of the property RT changeable data.

NOOVERWRITE_FPM=

Transfer of scheduler data.

  • 0: Scheduler data is created and transferred. Scheduler data present in Runtime is overwritten.
  • 1: Scheduler data is not transferred.

Recommendation: Configuration in the editor in the dialog of the property RT changeable data.


Status [STATUS]

Manual -> Configuration files -> project.ini -> Status [STATUS]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Entry | Description
[STATUS] |
STATUS0= | Text for the status information if bit 0 is set. A short and a long text may be entered, separated by ;.
STATUSx= | As for STATUS0 with numbers x = 1 to 63.


Reports [TABELLE]

Manual -> Configuration files -> project.ini -> Reports [TABELLE]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
[TABELLE] | Properties for tables.
TRENNZEICHEN= | Separator for individual cells when exporting reports in Runtime to a file in *.TXT format. For example, only printable characters such as - or tabulator (TAB). Example: TRENNZEICHEN=TAB


Drivers

Manual -> Configuration files -> project.ini -> Drivers

Properties for Drivers.


S7TCP32 [S7TCP32]

Manual -> Configuration files -> project.ini -> Drivers -> S7TCP32 [S7TCP32]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[S7TCP32]

Settings for the driver S7TCP32

FS=

Defines whether the object types F&S DB Bit, F&S DB Byte, F&S Bit and F&S Byte are displayed:

  • 1: Display
  • 0: No display (Default)


Simotion [SIMOTION]

Manual -> Configuration files -> project.ini -> Drivers -> Simotion [SIMOTION]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[SIMOTION]

Settings for the driver Simotion.

BLOCKWRITE=

Activation of blockwrite.

  • 0: Blockwrite is turned off.
  • 1: Blockwrite is turned on. Several values per TCP request are written for both global variables and axis variables. In doing so, an unbroken save block is written for global variables and a list of variable values is sent for axis variables.


System driver [SYSTEMTREIBER]

Manual -> Configuration files -> project.ini -> Drivers -> System driver [SYSTEMTREIBER]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[SYSTEMTREIBER]

Properties for system driver.

UPDATE_SEK=

Cycle time of the system driver in seconds.

WISCHER_BOXEN=
  • 0: Messages are suppressed. In this case, bit variables are available in the system driver, with which it is also possible to react to false inputs by linking a function to a limit value.
  • 1: For wrong user input (write set value, log in, etc.) corresponding messages are displayed in the Runtime.

It corresponds to the Incorrect input property in the Editor.

WISCHER_BOXEN_USERLEVEL=

Only active if WISCHER_BOXEN=1

  • 0: No error message is shown if the user is not authorized for this operation. The system driver variable no authorization to execute function is set nevertheless and can be evaluated via limit or reaction matrix.
  • 1: If a user carries out a function in the Runtime which requires an authorization level which the logged in user does not fulfill, a window with an error message is displayed.

It corresponds to the Insufficient authorization property in the Editor.


Worldview [WORLDVIEW]

Manual -> Configuration files -> project.ini -> Worldview [WORLDVIEW]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[WORLDVIEW]

Worldview display.

MarkCenter=
  • 0: no indication of a selected station
  • 1: indicates a selected station in the screen for a short while after switching to it


zenon versions and project versioning [VERSION]

Manual -> Configuration files -> project.ini -> zenon versions and project versioning [VERSION]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[VERSION]

Information on the zenon version that was last used to edit the project and information on project versioning. These are set by the Editor and must not be changed!

BETA=

Reference to the release status of the last zenon version used.

  • 0: released version
  • 1: beta version

GUID=

GUID of the project.

PROJECT_VERSION_ACTIVE=

Versioning of the project:

  • 1: Project versioning is used. Every project backup is saved with an own version number.
  • 0: No project versioning.

Default: 0

It corresponds to the property Versioning active in group General/Versioning in the Editor.

PROJ_MAJOR=

Number of the main version. This can be freely issued.

Attention: Arbitrary changes of that number influence the consistency of the versioning.

Configuration by means of the Main version property in the General/Versioning group.

PROJ_MINOR=

Detail number for the main version. Is issued automatically.

It corresponds to the property Project version in group General/Versioning in the Editor.

PROJ_TIMESTAMP=

The time of the last project backup to the UTC in seconds.

SP=

Number of the service pack of the zenon version that was last used to edit the project.

For example: 0 for zenon 7.20 SP0.

VERSION1=

Number of the main version of zenon that was last used to edit the project.

For example: 7 for zenon 7.20 SP0.

VERSION2=

Number of the subversion of zenon that was last used to edit the project.

For example: 20 for zenon 7.20 SP0.

XML_EXPORT_ACTIVE=

XML export of versions:

  • 1: At each project backup an zip file (version.zip) is inserted. It includes 24 XML files with the backups of the individual modules.
    Note: For multi-user projects only for local backups.
  • 0: No XML export.

Default: 0

It corresponds to the property XML export active in group General/Versioning in the Editor.


startup.ini

Manual -> Configuration files -> startup.ini

Note: Settings should be set up in the Startup Tool. Changes to startup.ini are only to be made by experts.
Only the settings for encrypting communication in the network are currently documented.

Entry | Description
[Settings] |
USE_ENCRYPTION= | Activate or deactivate encryption: 0: inactive 1: active Entry will be applied in the Startup Tool after setting and saving.
ENCRYPTION_PWD | Here, the password is entered after it has been created; it is encrypted automatically. The password is encrypted by the computer, thus an identical password on different computers leads to different content for this entry. Entry will be applied in the Startup Tool after setting and saving.
PWD_VALIDATION= | Hash to check to see if the data used that is to be encrypted has changed.


zenDB.ini:

Manual -> Configuration files -> zenDB.ini:

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entries in the zenDB.ini define the connection to the SQL server. These are set up with the Startup Tool.

Entries in zenDB.ini

From version 7.10 SP0

Entry

Default value

Description

[PATH]

none

Path

DB60_SQL2012=

none

Defines the path where the SQL databases for the zenon Editor projects are stored.

Example:

DB60_SQL2012=C:\ProgramData\COPA-DATA\SQL2012\

[CONNECTION_SQL2012]

Connection settings for SQL Server 2012

USER=

Startup Tool: none
Else: zenOnSrv

Defines the user name the zenDBSrv uses to log in to the SQL Server.

PW=

Startup Tool: none
Else: srv_710

Defines the password that the zenDBSrv uses with the SQL server for authentication. The password is stored in zenDB.ini in encrypted form. However, the non-encrypted default value can be used to make a connection, because encryption attempts fail due to its lengths and the default value is used directly to make a connection.

Attention: The encryption is done via the Startup Tool. Therefore you must carry out the database setting via the Startup Tool.

Note: Each component writes this value in encrypted form to the INI file.

SQLINSTANCE=

Startup Tool: none
Else: localhost

Defines the SQL server instance to which zenDBSrv connects. A connection cannot be created with the default value, because it does not have an instance name. "localhost" in the instance names is replaced by the current computer name before the connection is made.

Example:

SQLINSTANCE=localhost\ZENON_2012

SQLPROVIDER=

Startup Tool: none
Else: SQLNCLI10.1

Optional entry for the provider, which zenDBSrv uses to make the database connection. The default value corresponds to the SQL Server 2008 R2 native client.

Example:

SQLPROVIDER=SQLNCLI10.1

Version 7.00 SP0

Entry | Default value | Description
[PATH] | none | Path
DB60_SQL2008= | none | Defines the path where the SQL databases for the zenon Editor projects are stored. Example: DB60_SQL2008=C:\ProgramData\COPA-DATA\SQL2008R2\
[CONNECTION_SQL2008] |  | Connection settings for SQL Server 2008R2
USER= | Startup Tool: none Else: zenOnSrv | Defines the user name the zenDBSrv uses to log in to the SQL Server.
PW= | Startup Tool: none Else: srv_700 | Defines the password that the zenDBSrv uses with the SQL server for authentication. The password is stored in zenDB.ini in encrypted form. However, the non-encrypted default value can be used to make a connection, because encryption attempts fail due to its lengths and the default value is used directly to make a connection. Note: Each component writes this value in encrypted form to the INI file.
SQLINSTANCE= | Startup Tool: none Else: localhost | Defines the SQL server instance to which zenDBSrv connects. A connection cannot be created with the default value, because it does not have an instance name. "localhost" in the instance names is replaced by the current computer name before the connection is made. Example: SQLINSTANCE=localhost\ZENON_2008R2
SQLPROVIDER= | Startup Tool: none Else: SQLNCLI10.1 | Optional entry for the provider, which zenDBSrv uses to make the database connection. The default value corresponds to the SQL Server 2008 R2 native client. Example: SQLPROVIDER=SQLNCLI10.1

Version 6.51 SP0

Entry | Default value | Description
[PATH] |  | Path
DB60_SQL2008= | none | Path definition. Example: DB60_SQL2005=C:\ProgramData\COPA-DATA\SQL\
[CONNECTION_SQL2005] |  |
SQLSERVICE_SQL2005= | localhost\ZENON_DEV | Name of the service that starts the SQL server instance. Must correspond to the PROVIDER_SQL2005= entry in the Data Source section. Example: SQLSERVICE_SQL2005=MSSQL$ZENON_DEV
USER= | none | User. Example: USER=zenOnSrv
PW= | none | Password. Is issued in the Startup Tool and stored in encrypted form. Example: PW=0x9C 0x94 0xC6 0x50 0x15 0x80 0x79 0x06 0x32 0xED 0x4E 0xE1 0x15 0xDD 0x7C 0x90
SQLINSTANCE= | none | SQL Instant. Example: SQLINSTANCE=localhost\ZENON_DEV

From version 6.21 SP0 to version 6.50 SP0

Entry | Default value | Description
[PATH] |  | Path
DB60_SQL2008= | None | Path definition. Example: DB60_SQL2005=C:\ProgramData\COPA-DATA\SQL\
[CONFIG] |  |
SQLSERVICE_SQL2005= | localhost\ZENON_DEV | Name of the service that starts the SQL server instance. Must correspond to the PROVIDER_SQL2005= entry in the Data Source section. Example: SQLSERVICE_SQL2005=MSSQL$ZENON_DEV
PROVIDER_SQL2005= |  | Entry for the provider, which zenDBSrv uses to make the database connection. Example PROVIDER_SQL2005=Provider=SQLNCLI.1;Password=srv_601;Persist Security Info=True;User ID=zenOnSrv;Initial Catalog=%s;Data Source=localhost\ZENON_DEV;

Up to version 6.20 SP4

Entry | Default value | Description
[PATH] |  | Path
DB60= |  | Example: DB60=C:\SQL\
[CONFIG] |  |
SQLSERVICE= | MSSQL$ZENON | Defines the path where the SQL databases for the zenon Editor projects are stored.
Provider= |  | Entry for the provider, which zenDBSrv uses to make the database connection. Example: Provider=Provider=SQLOLEDB.1;Password=zenon;Persist Security Info=False;User ID=sa;Initial Catalog=%s;Data Source=localhost\ZENON


zenon6.ini

Manual -> Configuration files -> zenon6.ini

Settings should be set up in the Editor. Changes to zenon6.ini are only to be made by experts.

info Information

You can find zenon6.ini in the following path:

Windows 7/8: %ProgramData%\COPA-DATA\System\


General settings [DEFAULT]

Manual -> Configuration files -> zenon6.ini -> General settings [DEFAULT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[DEFAULT]

General settings.

ACTIVATIONKEY7=

Encrypted activation for dongle and software licensing

The entry is as follows for versions before zenon 7.0: ACTIVATIONKEY=

Recommendation: Configuration by means of the File -> General settings -> License product dialog.

ACTIVATIONKEY7_n=

Alternative activation key for dongle. This enables the Editor and Runtime to be started with different licenses and dongles.

  • n: number between 1 and 9.

When the Editor or Runtime is started, existing license numbers and activation keys are checked in the order of their entries. If one is found, a check is made to see if the dongle for this is present. If both events are applicable, the Editor or Runtime is started; otherwise the next entry is checked.

This procedure is executed along the same lines for the SERIAL7_n= entry.

Example: Only Runtime is activated in the main ACTIVATIONKEY7= entry. There is no second entry with an activation for the Editor. A service technician who wants to put the Editor into operation only needs to insert their dongle without having to change the activation key.

AUTOEXCEPTTIME=

Time for the display of the exception box in seconds.
If this entry is missing or it is set to 0, then the box is displayed until it is confirmed with OK.

DEFANWENDUNG30=

Currently selected project

DEFWORKSPACE=

Name of the active workspace that is loaded when the program is started.

Recommendation: Selection via the General tab in the Startup Tool.

LANGUAGE=

Pre-set language:

  • ENGLISH
  • ENGLISH
  • ITALIAN
  • FRENCH
  • ...

Note: This INI entry is also valid for the zenon Web Client.

LASTPROJEKT=

Last project called up in the Editor. Is set by the Editor on ending.

Entry is ignored if, in the Startup Tool, the Overwrite INI settings option is activated.

RT_CXMAINFRAME=

Width of the resolution of all monitors minus 1 pixel.

Saves together with RT_CYMAINFRAME= the position and size of the Runtime window.

RT_CXRESOLUTION=

Width of the resolution of the target computer in Runtime in pixels, depending on the value of the RT_CXMAINFRAME property. It is not necessary to subtract a pixel from this.

RT_CYMAINFRAME=

Height of the resolution of all monitors minus 1 pixel.

Saves together with RT_CXMAINFRAME= the position and size of the Runtime window.

Attention: If the toolbar is embedded, its height must be considered and more pixels must be subtracted.

RT_CYRESOLUTION=

Height of the resolution of the target computer in Runtime in pixels, depending on the value of the RT_CYMAINFRAME property. It is not necessary to subtract a pixel from this.

RTENDDELAY=

Delay when ending Runtime in milliseconds (ms), if this is recursive in calls on ending.

Example: RTENDDELAY=30000

SCREENPROFILE=

Selected monitor profile for current computer. This is true for all projects.

Recommendation: Configuration by means of the dialog of the Monitor administration property in the project properties of the Graphical design/Runtime general group.

SERIAL7=

Serial number for dongle and software licensing

The entry is as follows for versions before zenon 7.0: SERIAL=

Recommendation: Configuration by means of the File -> General settings -> License product dialog.

SERIAL7_n=

Alternative serial number for dongle. This enables the Editor and Runtime to be started with different licenses and dongles.

  • n: number between 1 and 9.

When the Editor or Runtime is started, existing license numbers and activation keys are checked in the order of their entries. If one is found, a check is made to see if the dongle for this is present. If both events are applicable, the Editor or Runtime is started; otherwise the next entry is checked.

This procedure is executed along the same lines for the ACTIVATIONKEY7_n= entry.

Example: Only Runtime is licensed in the main SERIAL= entry. There is a second entry with license for the Editor. A service technician who wants to put the Editor into operation only needs to insert their dongle without having to change the serial number.

SICAM230KEY7

Additional activation key for SICAM 230.

STARTDELAY=

Delay of Runtime start when booting up start in milliseconds (ms).
In the event of problems with the automatic start of Runtime with the operating system, Runtime can be started after a delay with this setting. The operating system therefore has more time to start all required services.

STRING=

Name of the project that is to be reloaded if reloading is triggered at the Server.

Entry is made in the zenOn6.ini of the server.


AML and CEL filtering for name and identification [AlarmFilterDialog]

Manual -> Configuration files -> zenon6.ini -> AML and CEL filtering for name and identification [AlarmFilterDialog]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[AlarmFilterDialog]

Saves historical entries in the filter for Variable name and identification in the General tab when configuring screen switching to AML, CEL and filter screen type screens.

The list is supplemented in the event of new entries in the combo box after the filter dialog of screen switching is closed. The entry that is currently set in the combo box is not saved. The historical entries are applicable for all projects on the local computer and are available for selection in the drop-down list.

History1_COUNT=

Number of entries in the drop-down list for variable name.

History1_x=

Entry in the drop-down list for variable name. x stands for serial numbering that starts with 0.

Example: History1_2=*top

History2_COUNT=

Number of entries in the drop-down list for identification.

History2_x=

Entry in the drop-down list for identification. x stands for serial numbering that starts with 0.

Example: History2_2=*filler


Workspaces [RECENTWORKSPACES]

Manual -> Configuration files -> zenon6.ini -> Workspaces [RECENTWORKSPACES]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Shows the five workspaces that were loaded last including the path. These settings are written to zenon6.ini by the Editor on closing. These five workspaces are displayed in the File menu.

Entry

Description

[RECENTWORKSPACES]

Section for the five workspaces that were loaded last.

WORKSPACE0=

WORKSPACE1=

WORKSPACE2=

WORKSPACE3=

WORKSPACE4=

Workspace that was loaded last. The more recent, the lower the sequence number.

  • WORKSPACE0: workspace that was loaded last
  • WORKSPACE4: Workspace with the time of last use that is the longest.

The complete path to the workspace is shown.
For example: WORKSPACE0=C:\Users\Public\Documents\zenon_Projects\Demo711.wsp6


Archive revision [ARCHEDIT]

Manual -> Configuration files -> zenon6.ini -> Archive revision [ARCHEDIT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[ARCHEDIT]

Properties for archive editing.

ARCHEDITFONT=

Selection of the font.

Recommendation: Can be configured in the Runtime in the dialog diagramm window.

DATUMBREITE=

Width of the column Date/Time in characters.

Recommendation: Can be configured in the Runtime in the dialog diagramm window.

EINHEITBREITE=

Width of the column Measuring unit in characters

Recommendation: Can be configured in the Runtime in the dialog diagramm window.

KENNUNGBREITE=

Width of the column Identification in characters.

Recommendation: Can be configured in the Runtime in the dialog diagramm window.

KURZBEZEICHNUNG=

Display of the archive editing in the table:

  • 1: yes
  • 0: No

STATUSBREITE=

Width of the column Status in characters.

Recommendation: Can be configured in the Runtime in the dialog diagramm window.

VARIABLEBREITE=

Width of the column Variable in characters

Recommendation: Can be configured in the Runtime in the dialog diagramm window.

WERTBREITE=

Width of the column Value in characters.

Recommendation: Can be configured in the Runtime in the dialog diagramm window.

ZUSTANDBREITE=

Width of the column Text in characters.

Recommendation: Can be configured in the Runtime in the dialog diagramm window.

ZWANGSSPEICHERN=

Correction of entries in aggregated archives:

  • 1: all entries
  • 0: only amended entries


Command Processing [Befehlsgabe]

Manual -> Configuration files -> zenon6.ini -> Command Processing [Befehlsgabe]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[Befehlsgabe]

Attention: Only for SICAM 230.

Befehlsstring=

Logging of command in the CEL for command processing:

  • 0: inactive
  • 1: active

CODE=

Code number query:

  • 0: off
  • 1: on

CodeKontrolle=

Feasibility check when querying the code numbers:

  • 0: off
  • 1: on

POSITION=

Defines position and size of the login/logout mask.

Value range from 0 to 1. The values are entered in the following syntax, separated by a comma:
xleft, xright, yup, ydown
Default: 0.001 , 0.999 , 0.835 , 0.964

TASTE=

Key assignment for two-hand operation. Possible entries:

  • No entry: One-hand operation
  • RETURN: Enter key
  • SPACE: Space key
  • F2 to F12: One of the F keys (except F1)
  • A to Z and 0 to 9: One alphanumeric character

Default: no entry


Operating authorization in Everywhere Server by zenon [password]

Manual -> Configuration files -> zenon6.ini -> Operating authorization in Everywhere Server by zenon [password]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Entry | Description
[PASSWORD] | Configuration of the access authorization for Everywhere Server.
EVWH_ACCESS= | Authorization level that has access to the Everywhere Server. Value: Number of the configured authorization level Default: 0 (= everyone has access)


Diagnosis Server [SYS_REMOTE] and [LOGGING_SYSTEM]

Manual -> Configuration files -> zenon6.ini -> Diagnosis Server [SYS_REMOTE] and [LOGGING_SYSTEM]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

From version 7, Remote and diagnosis are carried out by means of two different services. If there are both old and new Diagnosis Clients and/or Diagnosis Servers on a device, these can be configured independently f each other by means of INI entries. For example, the LOG entries of old Diagnosis Clients are diverted, without the LOG entries of new clients being affected.

Diagnosis Server before Version 7.00 SP0

INI entry

Description

[SYS_REMOTE]

Section in zenon6.ini.

Contains parameters for zenSysSrv (Remote Transport and Diagnosis Server).

LOGDirectory=

Defines folder for the LOG files.

If there is no entry, the LOG folder in the %ProgramData% folder is used as a default value.

Example:
LOGDirectory= %ProgramData%\COPA-DATA\zenon651\LOG

CONFIG=

Configuration string for the Diagnosis Server and zenSysSrv. Remote Transport and the diagnosis system use the same server configuration up to and including version 6.51 SP0. The string consists of the following parts: DEVICE=[Device];HOST=[Hostname];PORT=[Port];TIMEOUT=[Timeout]

  • DEVICE: Sets the communication type used.
    TCP/IP and serial are available.
  • HOST: Is set to the computer name of the Diagnosis Server.
  • PORT: states the port to be used.
  • TIMEOUT: Provides the time-out time for the connection in seconds.
  • BAUD: Provides the connection speed of a serial connection.

PC configuration:

  • DEVICE=TCP/IP
  • HOST=localhost
  • PORT=1101
  • TIMEOUT=10

CE configuration:

  • DEVICE=COM1
  • BAUD=115200

LOGMinFreeDiskSpace=

Defines minimum memory (in MB) that must be available on the hard drive. LOG files are deleted before this value is gone below.

Default: 1024

LOGMaxUsedDiskSpace=

Defines the maximum memory on the hard drive in MB used for LOG files. LOG files are deleted if this value is exceeded.

Default: 1024

LOGMinUsedDiskSpace=

Defines memory on the hard drive (in MB) that is used even if there are no LOG files.

Default: 5

LOGLogLifeTime=

Defines the lifecycle of the LOG files in seconds. Older LOG files are deleted.

Default: 1209600 (corresponds to 14 days)

LOGImageCnt=

Defines the number of LOG entries, after which all incremental LOG files are written.

  • 0: inactive (default)

LOGLogUpdateTime=

Number of milliseconds, after which the LOG entries received are written to a LOG file.

Default: 2000

LOGMaxBufferedRecs=

Defines the number of LOG entries that are buffered if they cannot be written to files.

Default: 10240

LOGMaxLogFileSize=

Maximal size of a log file in bytes. If a log file reaches this size, it is closed and a new log file is created.

Default: 5242880 (corresponds to 5 MB)

LOGCheckDiskTime=

Defines the interval in seconds, in which the memory occupied by LOG files is checked.

Default: 60

INIT=

Action when starting the application with Windows CE:

  • 0: end immediately
  • 1 (or other value greater than 2): Open listening port in minimize to system tray
  • 2: only display surface

Default: 1

Note: As part of the separation of zenSysServ and zenLogServ for zenon 7.00, this default value was also changed for other versions. The default value was previously 2.

Diagnosis Server from Version 7.00 SP0

INI entry

Description

[LOGGING_SYSTEM]

Section in zenon6.ini.

Contains parameters for the Diagnosis Server. Only affects zenLogSrv and has no effect on zenSysSrv.

LOGDirectory=

Defines the folder for the LOG files.

If there is no entry, the following is used as a standard value:

  • The path extracted from the Registry,
    for example: %ProgramData%\COPA-DATA\LOG
  • the LOG folder in the ProgramData folder of the zenLogSrv, if no path is defined in the registry,
    e. g. %ProgramData%\COPA-DATA\zenon700\LOG

CONFIG=

Configuration string for the Diagnosis Server. The string consists of the following parts: DEVICE=TCP/IP;HOST=[Hostname];PORT=[Port];TIMEOUT=[Timeout]

  • DEVICE: Sets the communication type used and must always be set to TCP/IP
  • HOST: Is set to the computer name of the Diagnosis Server.
  • PORT: states the port to be used.
  • TIMEOUT: Provides the time-out time for the connection in seconds.

Configuration:

  • DEVICE=TCP/IP
  • HOST=localhost
  • PORT=50780
  • TIMEOUT=10

LOGMinFreeDiskSpace=

Defines minimum memory (in MB) that must be available on the hard drive. LOG files are deleted before this value is gone below.

Default: 1024

LOGMaxUsedDiskSpace=

Defines the maximum memory on the hard drive in MB used for LOG files. LOG files are deleted if this value is exceeded.

Default: 1024

LOGMinUsedDiskSpace=

Defines memory on the hard drive (in MB) that is used even if there are no LOG files.

Default: 5

LOGLogLifeTime=

Defines the lifecycle of the LOG files in seconds. Older LOG files are deleted.

Default: 1209600 (corresponds to 14 days)

LOGImageCnt=

Defines the number of LOG entries, after which all incremental LOG files are written.

Default: 0

LOGLogUpdateTime=

Number of milliseconds, after which the LOG entries received are written to a LOG file.

Default: 2000

LOGMaxBufferedRecs=

Defines the number of LOG entries that are buffered if they cannot be written to files.

Default: 10240

LOGMaxLogFileSize=

Maximal size of a log file in bytes. If a log file reaches this size, it is closed and a new log file is created.

Default: 5242880 (corresponds to 5 MB)

LOGCheckDiskTime=

Defines the interval in seconds, in which the memory occupied by LOG files is checked.

Default: 60

INIT=

Action when starting the application with Windows CE:

  • 0: end immediately
  • 1 (or other value greater than 2): Open listening port in minimize to system tray
  • 2: only display surface

Default: 1

Diagnosis Client before Version 7.00 SP0:

INI entry

Description

[SYS_REMOTE]

Section in zenon6.ini.

Contains parameters for the Diagnosis Client.

LOG_CONFIG=

A configuration string for the Diagnosis Client is stored here. The string consists of the following parts: DEVICE=TCP/IP;HOST=[Hostname];PORT=[Port];TIMEOUT=[Timeout]

  • DEVICE: Sets the communication type used and must always be set to TCP/IP
  • HOST: Is set to the computer name of the Diagnosis Server.
  • PORT: states the port to be used.
  • TIMEOUT: Provides the time-out time for the connection in seconds.

Configuration:

  • DEVICE=TCP/IP
  • HOST=localhost
  • PORT=1101
  • TIMEOUT=10

Diagnosis Client from Version 7.00 SP0

INI entry

Description

[LOGGING_SYSTEM]

Section in zenon6.ini.

Contains parameters for the Diagnosis Client.

LOG_CONFIG=

A configuration string for the Diagnosis Client is stored here. The string consists of the following parts:

DEVICE=TCP/IP;HOST=[Hostname];PORT=[Port];TIMEOUT=[Timeout]

  • DEVICE: Sets the communication type used and must always be set to TCP/IP
  • HOST: Is set to the computer name of the Diagnosis Server.
  • PORT: states the port to be used.
  • TIMEOUT: Provides the time-out time for the connection in seconds.

Configuration:

  • DEVICE=TCP/IP
  • HOST=localhost
  • PORT=50780
  • TIMEOUT=10

Note:

INIT under CE

Under Windows CE we urgently recommend to not set entry INIT= (in section [LOGGING_SYSTEM] or [SYS_REMOTE]) to value 2.

Reason: The value 2 means that both SysSrvCE and LogSrvCE only display the user interface and do not open the listening port.
If now a Diagnosis Client wants to establish a connection, it will fail. As in this case the Diagnosis Clients start process LogSrvCE and the process does not open the port, each Diagnosis Client starts such a process. This leads to several parallel LogSrvCE processes and to a delay in starting the Diagnosis Clients as it waits for the timeout of the connection while establishing the diagnosis connection.

zenLogSrv on a system with different versions

If zenLogSrv is used on a system with different versions as a central local diagnosis server, the entry LOG_CONFIG in the [SYS_REMOTE] such must be as follows:
DEVICE=TCP/IP;HOST=localhost;PORT=5780;TIMEOUT=10

Reason: Older clients then use zenLogSrv as the Diagnosis Server. New clients do this automatically. This service is switched on automatically on the PC when the system is started; it must be started manually with CE.

Attention: If the port cannot be reached, older clients start zenSysSrv and retry connecting to it.


Printer general [DRUCKER] and [FRM_PRNT]

Manual -> Configuration files -> zenon6.ini -> Printer general [DRUCKER] and [FRM_PRNT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Entry | Description
[DRUCKER] | Printer assignment. These settings are configured in the Editor in the following menu: File -> General configuration -> Default -> Printer.
ALARM= | Online printer for Alarm Message List or Chronological Event List in the runtime. Selection if AML or CEL in the project properties in the group AML and CEL or over the files ALAR.FRM and/or BTB.FRM.
ALARM_OFFL= | Offline printer for Alarm Message List or Chronological Event List by clicking the button print in the respective screen. Format configuration in the files ALARM_G.FRM or BTB_G.FRM. The printer defined in the ALARM= entry is used if no entry is present.
WERTE= | Printer for reports and if the function print the current value (output of the current values and tables) was selected.
HDDRUCKER= | Printer for screenshots
LISTDRUCKER= | Printer for general lists.
[FRM_PRNT] | Configuration of the formatted output of the AML/CEL with FRM_PRNT.DLL.
LINES= | Entry of the number of lines per page. Default: 0


Editor [EDITOR] and [Editor/CustomMenu]

Manual -> Configuration files -> zenon6.ini -> Editor [EDITOR] and [Editor/CustomMenu]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[EDITOR]

Settings in the Editor.

Recommendation: Configuration in the options -> settings.

CASESENSITIVEFILTER=

Filter in detail view is case sensitive

  • 0: No
  • 1: yes

DIRECTX_TYPE=

Decides whether hardware acceleration is used:

  • 1: active
  • 0: inactive

Default: 1

DYNRAHMEN=

Display frames around dynamic elements in the Editor:

  • 0 not active
  • 1: active (default)

EINGABE_SOFORT=

Immediate call up of an element's input field on creation:

  • 0: No
  • 1: yes

FANGPUNKTE=

Use of magic points:

  • 0: off
  • 1: on

FANGPUNKTESIZE=

Size of magic points for screens, in pixels.

FANGPUNKTESIZE_TEMPL=

Size of magic points for frames, in pixels.

KOORD_GLOBAL=

Display of the coordinates:

  • 0: Client coordinates of the window
  • 1: screen-independent (global) pixel coordinates

LASTWORKSPACE=

Automatic loading of the last-used workspace when the Editor is started.

  • 1: last workspace is loaded automatically
  • 0: Editor starts without loading workspace

RASTER=

Position in grid:

  • 0 not active
  • 1: active

RASTER_ABSTAND_X=

Horizontal grid distance in pixels.
Default = 5

RASTER_ABSTAND_Y=

Vertical grid distance in pixels.
Default = 5

RASTER_COLOR=

Color of the grid points.

The colour will be entered in decimal format. In the editor, it appears in hexadecimal with an # at the beginning.
Example: Colour #8000FF in the editor corresponds to 16711808 in the INI file.

RASTER_GRID=

Display grid:

  • 0: off (default)
  • 1: on

RASTER_TYPE=

Tye of grid:

  • 0: full
  • 1: dotted (is no longer supported from version 7.20 and is replaced with 0 on project conversion.)
  • 2: Intersections

RUECK_ANZ=

Number of actions that can be undone.

For example: RUECK_ANZ=10

SORTLOGICAL=

Logical sorting of texts in the detail view:

  • 0: off
  • 1: on

SPOT=

Size of the corner points of the elements
Default = 5

SUCHE=

Pixel distance up to position change to establish the same point on moving.
Default = 5

SYMBOL_COLOR=

Background color of the symbol in the symbol editor, in order to easier recognize the drawing area.

Default: White
Entry for white: SYMBOL_COLOR=16777215

USE_WIZARDS=

Use of assistants when configuring:

  • 0: off
  • 1: on

Note: Only affects assistants for configuration (e.g. archiving), but not wizards (e.g. project wizard).

WINDOW=

The Editor stores its screen position in this entry in the file zenon6.ini when it is closed. It is started at the saved position next time it is started.

  • First number: Defines if the window is minimized (1), maximized (2) or displayed normally (3).
  • Other numbers: Position from the upper left corner.

Example: WINDOW=3,109,181,589,661

WORKSPACEVIEW=

Display of the workspace in the Editor:

  • 1: Display of workspace active
  • 0: display of workspace inactive

User-defined menu

Entry | Description
[Editor/CustomMenu] | Settings for the user-defined menu in the editor. Recommendation: Configuration by means of options -> Settings -> Tools menu.
Arguments#0= | Parameter for the program execution.
File#0= | Name of the file to execute for menu entry 0.
Name#0= | Entry in the menu for program 0.


Everywhere Server [EVERYWHERE]

Manual -> Configuration files -> zenon6.ini -> Everywhere Server [EVERYWHERE]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[EVERYWHERE]

Configuration of the global properties for Everywhere Server.

CERTIFCATE=

Server certificate subject for HTTPS

Subject of the certificate. The certificate must be saved in the Machine Store in the MY node (your own certificates).

e.g.: CERTIFICATE=CN=MyComputerName

ENABLE=

  • 1: Everywhere Server is started with zenon Runtime.
  • 0: Everywhere Server is not started.

Default: 0

PORT=

HTTPS port for communication with the Everywhere Server

Default: 8050

WRITE_ACCESS=
  • 0: Only read access via Everywhere Server is possible.
  • 1: Allows the writing of variables and the acknowledgment of alarms.

Default: 0

Find out more information in the chapter <Driver variables>.


Extended Trend [EW-TREND]

Manual -> Configuration files -> zenon6.ini -> Extended Trend [EW-TREND]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[EW_TREND]

Configuration of Extended Trend

AUTOSKALIERUNG=

Defines if autoscaling by default is active or not.

  • 0: active
  • 1: inactive


Export [EXPORT]

Manual -> Configuration files -> zenon6.ini -> Export [EXPORT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[EXPORT]

Export configuration.

AML_CEL_NEU=

Export to dBase file:

  • 0: in default format
  • 1: in the columns as configured for the corresponding lists


Window settings [PROPERTY]

Manual -> Configuration files -> zenon6.ini -> Window settings [PROPERTY]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[PROPERTY]

Settings for properties window and output window.

OUTPUTHIDEERRORS=

Suppress display of errors in the output window:

  • 0: Displayed
  • 1: No display

OUTPUTHIDEMESSAGES=

Suppress display of messages in the output window:

  • 0: Displayed
  • 1: No display

OUTPUTHIDEWARNINGS=

Suppress display of warnings in the output window:

  • 0: Displayed
  • 1: No display

SHOWALL=

Display of the properties in the properties window:

  • 0: off
  • 1: on

SHOWFAVORITES=

Display of the favorites in the properties window:

  • 0: off
  • 1: on

If the VIEW= property has the value 2, favorites are always shown.

SORT=

Sorting in the properties window:

  • 0: ascending
  • 1: descending
  • 2: logical

VIEW=

View of the properties in the properties window:

  • 0: grouped
  • 1: all
  • 2: Dialog view


IP address under Windows CE [IPADDR]

Manual -> Configuration files -> zenon6.ini -> IP address under Windows CE [IPADDR]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[IPADDR]

Only under Windows CE.

Because HOSTS files are not supported under CE, computer names are assigned using an IP address assignment list.

This list is only necessary in networks without DNS. If a DNS server exists, Windows CE resolves the names by itself.
The list can only be edited by hand with a text editor. Usually only the address of the defined server has to be entered.

COMPUTERNAME1=

Allocates an IP address to a computer COMPUTERNAME1.
Example: MAIN=10.20.10.01 allocates the computer name MAIN to the corresponding IP address.

Attention: All entries (computer names) must be in capitals, otherwise they are not recognized


Message Control [MESSAGE CONTROL]

Manual -> Configuration files -> zenon6.ini -> Message Control [MESSAGE CONTROL]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[MESSAGE CONTROL]

Settings for the module Message Control.

Recommendation: Configuration via the properties of the Message Control group in the workspace including subgroups and the properties of the Project-specific settings group in the Message Control node in the project tree.

GSM_SMS=

Activation of SMS via GMS as sending type.

  • 0: active
  • not 0: inactive

Default: 0

The entry equals entry [GSM] à On in file Message32.ini and is considered at the import/export of the INI setting.

GSM_SMS_COM=

COM port that is used for the connection to the modem.

Default: empty

GSM_SMS_PIN=

PIN code which is used for authentication towards the modem.

Default: empty

GSM_SMS_SMSC=

Telephone number of the message center of the GSM provider.

Default: empty

GSM_BULK_DELETE=

0: all SMSs that have been read are deleted individually

1: all SMSs that been read are deleted at the same time

Default: 0

Outlook=

Email notification via Outlook:

  • 0: inactive
  • 1: active

Default: 0

Outlook_Profile=

Name of the Outlook profile which should be used for sending.

Default: empty

POP_APOP=

Defines whether the APOP command should be used.

  • 1: active
  • 0: inactive

Default: 0

POP_KEEP_MAILS=

Defines whether read e-mails remain on the server.

  • 1: E-mails are not deleted after they were fetched from the server
  • 0: E-mails are deleted after they were fetched from the server

Default: 0

POP_PASSWORD=

Hex dump of the encrypted password for authentication at the incoming server.

Default: empty

POP_POLL_INTERVALL=

Minimum period between two POP3 requests in seconds.

Minimal: 10

Default: 60

POP_PORT=

Defines the used port at the POP3 Server.

Default: 110

POP_SECURITY=

Type of connection protection to the POP3 Server.

  • 0, no security
  • 1: SSLv2 and SSLv3
  • 2: TLSv1

Default: 0

POP_SERVER=

POP3 Server saved.

Default: empty

POP_USER=

User name for the incoming server.

Default: empty

SMSGateway=

SMS notification via SMS gateway:

  • 0: inactive
  • 1: active

Default: 0

SMSGateway_Inbox=

Income folder for sending SMS.

Default: empty

SMSGateway_OriginId=

Sender identification for sending SMS.

Default: empty

SMSGateway_Outbox=

Outgoing folder for sending SMS.

Default: empty

SMSGateway_Prefix=

First letter of the SMS files.

Length: 1 character

Default: F

SMSGateway_SemaphorPrefix=

First letter of the lock file.

Length: 1 character

Default: S

SMSGateway_SmartAlarm=

Smart alarming is used.

Default: 0

SMSGateway_Statusbox=

Folder for the status message at SMS sending.

Default: empty

SMSGateway_TimeOut=

Timeout for outgoing messages in minutes. Defines after what period of time a message is interpreted as "not send successfully".

Default: 60

SMTP_AUTH=

Authentication at the outgoing server.

  • 0, no security
  • 1: log in to the POP3 Server before sending
  • 2: SMTP AUTH

Default: 0

SMTP_OTHER_CREDS=

Defines whether the outgoing server uses different log in data than the incoming server.

  • 0: inactive
  • 1: active

Default: 0

SMTP_PASSWORD=

Hex dump of the encrypted password for authentication at the outgoing server.

Default: empty

SMTP_OUT_ADDR=

Address for outgoing e-mails.

Default: empty

SMTP_POP_MAIL=

Email notification via OP:

  • 1: active
  • 0: inactive

Default: 0

SMTP_PORT=

Defines the used port at the SMTP Server.

Default: 25

SMTP_SECURITY=

Type of connection protection to the SMTP Server.

  • 0, no security
  • 1: SSLv2 and SSLv3
  • 2: TLSv1

Default: 0

SMTP_SERVER=

The SMTP Server entered by the user.

Default: empty

SMTP_SRV_IS_POP=

This entry defines whether the POP3 Server is used as SMTP Server.

  • 1: POP 3 is SMTP
  • 0: POP3 and SMTP are different Servers

Default: 0

SMTP_SUBJECT=

Subject for outgoing e-mails and for detecting whether an incoming e-mail at the server is relevant for the sending type.

Default: MsgCtrl_Alert

SMTP_USER=

User name saved for the outgoing server.

Default: empty

SMTP_USER_IS_ADDR=

Defines whether the user name for authentication towards the outgoing server is used as sender address for outgoing mails.

  • 1: active
  • 0: inactive

Default: 0

Speech=

Notification by text to speech:

  • 0: inactive
  • 1: active

Default: 0

Speech_Name=

Selection of speech and language

Default: empty

Speech_Rate=

Speech speed.

  • Minimum: -10
  • Maximum: 10

Default: 0

Speech_Volume=

Speech volume. Number equals the percent value of the maximum value of the selected speech.

  • Maximum: 100
  • Minimum: 1
  • 0: Number of the operating system is take over without change.

Default: 0

Subject=

Unique ID which incoming e-mails must contain in order to be processed in Message Control.

Default: empty

Telephone=

Notification by audio file:

  • 0: inactive
  • 1: active

Default: 0

Telephone_IgnoreDisconnect=

Behavior in the event of a loss of connection::

  • 1: A disconnection (e.g. recipient ends call) is ignored and the message is played back completely before the line is closed.
  • 0: Message is aborted when the connection breaks.

Default: 0

Telephone_Timeout=

Time in minutes after which a standing condition should be canceled and closed. Time interval must be longer as the time needed for playing back and confirming the message.

Default: 1

Telephone_WelcomeMessageCount=

Number of repetitions for the welcome text.

Default: 5

info Information

As some properties can take over the values of other properties and they remember the values entered last, the values in the INI entry must not always concur with the values of the properties displayed in the Editor. The following entries are concerned if they are displayed as not available:

SMTP_SERVER -> Server address

SMTP_USER -> User identification

SMTP_PASSWORD -> Password

SMTP_OUT_ADDR -> Address for outward e-mails


Network [NETZ]

Manual -> Configuration files -> zenon6.ini -> Network [NETZ]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[NETZ]

Parameters of the network operation

ENCRYPTION_PWD

Here, the password is entered after it has been created; it is encrypted automatically. The password is encrypted by the computer, thus an identical password on different computers leads to different content for this entry.

Note: This INI entry is also valid for the zenon Web Client.

NET_CONNECTCOUNT=

Number of times a TCP/IP connect is retried on the client.

  • 0:

Default = 0 (immediate retry)

NET_CONNECTWAIT_MSEC=30000

Waiting time after an unsuccessful TCP/IP connect on the client in milliseconds.
Default = 30000

NET_PROXYPORT=

Port for the connection from the web client to the web server: The Web Server eavesdrops on the port, the Web Client connects to the port.
Default:

  • TCP: 1102
  • HTTP: 8080

NET_TIMEOUT_MSEC=

Timeout for network communication in milliseconds.
Default = 30000

NET_NETMODULE_TIMEOUT_MSEC=

Timeout for module communication in milliseconds. Is not used for spontaneous module request on the client or standby. If no response comes from the server in the set time, the action is canceled.

Default = 30000

Timeout module in milliseconds

POLLING_INTERVALL=

Waiting time in milliseconds until the Web Client sends another HTTP GET request to the Web Derver if the buffer for a connection is empty.

Default: 2000

PWD_VALIDATION=

Hash to check to see if the data used that is to be encrypted has changed.

Note: This INI entry is also valid for the zenon Web Client.

QUESIZE=

Maximum number of objects in the queue in the network.
Default: 5000

TIMESYNCH=

Time synchronization:

  • 1: = Time is compared with a server project (default).
  • 0: = Time is not compared (for circular redundancy, for example)

USE_ENCRYPTION=

Activate or deactivate encryption:

0: inactive

1: active

Note: This INI entry is also valid for the zenon Web Client.

USEIPV6=

Regulates the use of IPv6.

1: Active, all TCP connections are only created via IPv6.

0: Inactive, all TCP connections are only created via IPv4.

Dual operation is not possible.

Note: If this option is changed, all ongoing zenon processes must be restarted. This concerns zenAdminSrv, zenSysSrv, zenLogSrv and zenDBSrv in particular.

The following components are not affected by the setting:

  • Driver communication with the PLCs
  • Protocol communication in the Process Gateway plug-ins
  • Workbench and Runtime communication in zenon Logic

Attention: Only works with version 7 onwards. No versions prior to version 7 can be started if this is active.

WAN=

Client's connection to the server:

  • 0: LAN (default)
  • 1: WAN

WAN_IDLETIME=

WAN idle time.
The connection to the server or client is closed after this time.
Default = 30000 ms


Path settings [PATH]

Manual -> Configuration files -> zenon6.ini -> Path settings [PATH]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[PATH]

Path settings.

BILDER=

Path of the BLD files.

BITMAP=

Permitted graphics files. The following formats are possible:

  • *.bmp
  • *.wmf
  • *.jpg
  • *.png

DLL=

Path of the DLL files (program directory).

EDOC_PATH =

Path to the EPLAN document (electronic documentation program).

For example: EDOC_PATH=C:\\Programs\EPLAN\View\1.7.11\BIN\W3u.exe

EXPORTARV=

Path for archives evacuated by user (*.arv).

GRAPHIK=

Path of the graphics files for graphics import.

ONLINE_HELP=

Path for CHM files in Runtime.

VBF30=

Path of the current project database.

WEB_PROJECT_PATH=

Folder for the Runtime files of the Web Client. The %temp%\zenWebCli folder is used if this entry is not available.


Port configuration [LISTENING_SOCKETS]

Manual -> Configuration files -> zenon6.ini -> Port configuration [LISTENING_SOCKETS]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[LISTENING_SOCKETS]

Configuration of the listening ports for applications. Changes in zenon6.ini must be transferred to all other computers included in the communication.

Attention:

  • Changes can trigger a restart of the computer.
  • All computers with which communication takes place must have the same settings.
  • These settings are not available under Windows CE.
  • The settings that were saved in the respective zenon6.ini file are used in Runtime.

Recommendation: Configure these settings using the Startup Tool.

XXX_CUST_PORT=

XXX Stands for the corresponding application.

Alternative port number. Only effective if XXX_PORT_CASE=1.

XXX_BIND_ADDRESS=

XXX Stands for the corresponding application.

Fixed IP address. Only effective if XXX_BIND_CASE=1.

XXX_BIND_ADAPTER=

XXX Stands for the corresponding application.

Name of the network parameter. Only effective if XXX_BIND_CASE=2.

XXX_BIND_CASE=

XXX Stands for the corresponding application.

Type of connection:

  • 0: All adapters (Any)
  • 1: by means of address
  • 2: by means of adapter

Note: For 1 and 2, the respective address must be configured using the corresponding entry.

XXX_PORT_CASE=

XXX Stands for the corresponding application.

Type of port assignment:

  • 0: Default port. Standard port number.
  • 1: Custom Port. Individual port number.

Note: For 1, the respective address must be configured using the corresponding entry.

Applications and their default settings

Administration Service

ADMINSRV_CUST_PORT=

Alternative port number for Administrator Service. Only effective if ADMINSRV_PORT_CASE=1.

Default: 50777

ADMINSRV_BIND_ADDRESS=

Fixed IP address for Administrator Service. Only effective if ADMINSRV_BIND_CASE=1.

Default: 0.0.0.0

ADMINSRV_BIND_ADAPTER=

Name of the network adapter for Administrator Service. Only effective if ADMINSRV_BIND_CASE=2.

Default: No entry (empty).

ADMINSRV_BIND_CASE=

Type of connection for Administrator Service.

  • 0: All adapters (Any)
  • 1: by means of address
  • 2: by means of adapter

Default: 0

Note: For 1 and 2, the respective address must be configured using the corresponding entry.

ADMINSRV_PORT_CASE=

Type of port assignment for Administrator Service.

  • 0: Default port. Standard port number.
  • 1: Custom Port. Individual port number.

Default: 0

Note: For 1, the respective address must be configured using the corresponding entry.

Analyzer Connector Service

ANACONSRV_CUST_PORT=

Alternative port number for Analyzer Connector Service. Only effective if ANACONSRV_PORT_CASE=1.

Default: 50778

ANACONSRV_BIND_ADDRESS=

Fixed IP address for Analyzer Connector Service. Only effective if ANACONSRV_BIND_CASE=1.

Default: 0.0.0.0

ANACONSRV_BIND_ADAPTER=

Name of the network adapter for Analyzer Connector Service. Only effective if ANACONSRV_BIND_CASE=2.

Default: No entry (empty).

ANACONSRV_BIND_CASE=

Type of connection for Analyzer Connector Service.

  • 0: All adapters (Any)
  • 1: by means of address
  • 2: by means of adapter

Default: 0

Note: For 1 and 2, the respective address must be configured using the corresponding entry.

ANACONSRV_PORT_CASE=

Type of port assignment for Analyzer Connector Service.

  • 0: Default port. Standard port number.
  • 1: Custom Port. Individual port number.

Default: 0

Note: For 1, the respective address must be configured using the corresponding entry.

Analyzer License Service

ANALICSRV_CUST_PORT

Alternative port number for Analyzer License Service. Only effective if ANALICSRV_PORT_CASE=1.

Default: 50779

ANALICSRV_BIND_ADDRESS=

Fixed IP address for Analyzer License Service. Only effective if ANALICSRV_BIND_CASE=1.

Default: 0.0.0.0

ANALICSRV_BIND_ADAPTER=

Name of the network adapter for Analyzer License Service. Only effective if ANALICSRV_BIND_CASE=2.

Default: No entry (empty).

ANALICSRV_BIND_CASE=

Type of connection for Analyzer License Service.

  • 0: All adapters (Any)
  • 1: by means of address
  • 2: by means of adapter

Default: 0

Note: For 1 and 2, the respective address must be configured using the corresponding entry.

ANALICSRV_PORT_CASE=

Type of port assignment for Analyzer License Service.

  • 0: Default port. Standard port number.
  • 1: Custom Port. Individual port number.

Default: 0

Note: For 1, the respective address must be configured using the corresponding entry.

DB Service

DBSRV_CUST_PORT=

Alternative port number for DB Service. Only effective if DBSRV_PORT_CASE=1.

Default: 1103

DBSRV_BIND_ADDRESS=

Fixed IP address for DB Service. Only effective if DBSRV_BIND_CASE=1.

Default: 0.0.0.0

Default: 0.0.0.0

DBSRV_BIND_ADAPTER=

Name of the network adapter for DB Service. Only effective if DBSRV_BIND_CASE=2.

Default: No entry (empty).

DBSRV_BIND_CASE=

Type of connection for DB Service.

  • 0: All adapters (Any)
  • 1: by means of address
  • 2: by means of adapter

Default: 0

Note: For 1 and 2, the respective address must be configured using the corresponding entry.

DBSRV_PORT_CASE=

Type of port assignment for DB Service.

  • 0: Default port. Standard port number.
  • 1: Custom Port. Individual port number.

Default: 0

Note: For 1, the respective address must be configured using the corresponding entry.

Logging Service

LOGSRV_CUST_PORT=

Alternative port number for Logging Service. Only effective if LOGSRV_PORT_CASE=1.

Default: 50780

LOGSRV_BIND_ADDRESS=

Fixed IP address for Logging Service. Only effective if LOGSRV_BIND_CASE=1.

Default: 0.0.0.0

LOGSRV_BIND_ADAPTER=

Name of the network adapter for Logging Service. Only effective if LOGSRV_BIND_CASE=2.

Default: No entry (empty).

LOGSRV_BIND_CASE=

Type of connection for Logging Service.

  • 0: All adapters (Any)
  • 1: by means of address
  • 2: by means of adapter

Default: 0

Note: For 1 and 2, the respective address must be configured using the corresponding entry.

LOGSRV_PORT_CASE=

Type of port assignment for Logging Service.

  • 0: Default port. Standard port number.
  • 1: Custom Port. Individual port number.

Default: 0

Note: For 1, the respective address must be configured using the corresponding entry.

Network Service

NETSRV_CUST_PORT=

Alternative port number for Network Service. Only effective if NETSRV_PORT_CASE=1.

Default: 1100

NETSRV_BIND_ADDRESS=

Fixed IP address for Network Service. Only effective if NETSRV_BIND_CASE=1.

Default: 0.0.0.0

NETSRV_BIND_ADAPTER=

Name of the network adapter for Network Service. Only effective if NETSRV_BIND_CASE=2.

Default: No entry (empty).

NETSRV_BIND_CASE=

Type of connection for Network Service.

  • 0: All adapters (Any)
  • 1: by means of address
  • 2: by means of adapter

Default: 0

Note: For 1 and 2, the respective address must be configured using the corresponding entry.

NETSRV_PORT_CASE=

Type of port assignment for Network Service.

  • 0: Default port. Standard port number.
  • 1: Custom Port. Individual port number.

Default: 0

Note: For 1, the respective address must be configured using the corresponding entry.

SNMP Trap Service

SNMPTRAPSRV_CUST_PORT=

Alternative port number for SNMP Trap Service. Only effective if SNMPTRAPSRV_PORT_CASE=1.

Default: 50782

SNMPTRAPSRV_BIND_ADDRESS=

Fixed IP address for SNMP Trap Service. Only effective if SNMPTRAPSRV_BIND_CASE=1.

Default: 0.0.0.0

SNMPTRAPSRV_BIND_ADAPTER=

Name of the network adapter for SNMP Trap Service. Only effective if SNMPTRAPSRV_BIND_CASE=2.

Default: No entry (empty).

SNMPTRAPSRV_BIND_CASE=

Type of connection for SNMP Trap Service.

  • 0: All adapters (Any)
  • 1: by means of address
  • 2: by means of adapter

Default: 0

Note: For 1 and 2, the respective address must be configured using the corresponding entry.

SNMPTRAPSRV_PORT_CASE=

Type of port assignment for SNMP Trap Service.

  • 0: Default port. Standard port number.
  • 1: Custom Port. Individual port number.

Default: 0

Note: For 1, the respective address must be configured using the corresponding entry.

Transport Service

SYSSRV_CUST_PORT=

Alternative port number for Transport Service. Only effective if SYSSRV_PORT_CASE=1.

Default: 1101

SYSSRV_BIND_ADDRESS=

Fixed IP address for Transport Service. Only effective if SYSSRV_BIND_CASE=1.

Default: 0.0.0.0

SYSSRV_BIND_ADAPTER=

Name of the network adapter for Transport Service. Only effective if SYSSRV_BIND_CASE=2.

Default: No entry (empty).

SYSSRV_BIND_CASE=

Type of connection for Transport Service.

  • 0: All adapters (Any)
  • 1: by means of address
  • 2: by means of adapter

Default: 0

Note: For 1 and 2, the respective address must be configured using the corresponding entry.

SYSSRV_PORT_CASE=

Type of port assignment for Transport Service.

  • 0: Default port. Standard port number.
  • 1: Custom Port. Individual port number.

Default: 0

Note: For 1, the respective address must be configured using the corresponding entry.

WEB Service Classic

WEBSRV_CUST_PORT=

Alternative port number for WEB Service Classic. Only effective if WEBSRV_PORT_CASE=1.

Default: 1102

WEBSRV_BIND_ADDRESS=

Fixed IP address for WEB Service Classic. Only effective if WEBSRV_BIND_CASE=1.

Default: 0.0.0.0

WEBSRV_BIND_ADAPTER=

Name of the network adapter for WEB Service Classic. Only effective if WEBSRV_BIND_CASE=2.

Default: No entry (empty).

WEBSRV_BIND_CASE=

Type of connection for WEB Service Classic.

  • 0: All adapters (Any)
  • 1: by means of address
  • 2: by means of adapter

Default: 0

Note: For 1 and 2, the respective address must be configured using the corresponding entry.

WEBSRV_PORT_CASE=

Type of port assignment for WEB Service Classic.

  • 0: Default port. Standard port number.
  • 1: Custom Port. Individual port number.

Default: 0

Note: For 1, the respective address must be configured using the corresponding entry.

WEB Service Tunneling

WEBSRVTNL_CUST_PORT=

Alternative port number for WEB Service Tunneling. Only effective if WEBSRVTNL_PORT_CASE=1.

Default: 8080

WEBSRVTNL_BIND_ADDRESS=

Fixed IP address for WEB Service Tunneling. Only effective if WEBSRVTNL_BIND_CASE=1.

Default: 0.0.0.0

WEBSRVTNL_BIND_ADAPTER=

Name of the network adapter for WEB Service Tunneling. Only effective if WEBSRVTNL_BIND_CASE=2.

Default: No entry (empty).

WEBSRVTNL_BIND_CASE=

Type of connection for WEB Service Tunneling.

  • 0: All adapters (Any)
  • 1: by means of address
  • 2: by means of adapter

Default: 0

Note: For 1 and 2, the respective address must be configured using the corresponding entry.

WEBSRVTNL_PORT_CASE=

Type of port assignment for WEB Service Tunneling.

  • 0: Default port. Standard port number.
  • 1: Custom Port. Individual port number.

Default: 0

Note: For 1, the respective address must be configured using the corresponding entry.

Overview of standard ports

Application | Standard port
Administration Service | 50777
Analyzer Connector Service | 50778
Analyzer License Service | 50779
DB Service | 1103
Logging Service | 50780
Network Service | 1100
SNMP Trap Service | 50782
Transport Service | 1101
WEB Service Classic | 1102
WEB Service Tunneling | 8080


Programming interface [PCE], [VBA], [VBA_TOOLBAR] und [VSTA]

Manual -> Configuration files -> zenon6.ini -> Programming interface [PCE], [VBA], [VBA_TOOLBAR] und [VSTA]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

PCE

Note: Starting from version 7.20, PCE will not be supported anymore and it will not be shown in the module tree of zenon anymore. While converting projects from versions lower than 7.20, which contain PCE tasks, the node PCE will be shown for these projects again. PCE will not further be developed and documented.

The INI settings can still be used.

Recommendation: Please use zenon Logic instead of PCE.

Entry

Description

[PCE]

Settings for the Process Control Engine.

ON=

Activate PCE:

  • 0: off
  • 1: on
  • Requirements: VBA must be activated.

VBA

Entry

Description

[VBA]

Parameters for Visual Basic for Applications

BREAK=

Activate VBA message box for errors, asking whether to debug during Runtime.

  • 1: on (default)
  • 0: off

EIN=

Activate VBA:

  • 0: off
    VBA is not initialized and not loaded. Therefore no IDE can be displayed and no wizards can be executed.
    VSTA is thus also deactivated.
    The COM interface can be initialized however.
  • 1: on
    VBA is initialized and loaded.

EVENT=

Activate VBA events:

  • 0: off
    Linked VBA macros are not executed.
    COM are not triggered.
  • 1: on
    VBA macros are executed and COM events are triggered.

UPDATE=

The dialog to update the wizard is called up each time the Editor is started:

  • 0: off
  • 1: on

[VBA_TOOLBAR]

Allocation of the symbols in the macro tool bar with VBA macros.

VBABUTTON_x=

Assignment of macros to symbols of the macro list. x stands for a number between 0 and 4. Up to five macros can be linked to symbols: VBABUTTON_0 to VBABUTTON_4.

For example: VBAButton_2=ActivateStartupScreen

Recommendation: Configuration by means of the macro list tool bar.

VSTA

Entry

Description

[VSTA]

Parameters for VSTA

CSHARP=

Selection of the VSTA programming language for the Editor:

  • 1: C# (Default)
  • 0: VB.NET

LOADED=

Loading the VSTA add-in:

  • 1: VSTA add-in for the Editor is loaded on start up
  • 0: When the Editor is started, a dialog asks if the VSTA add-in is to be loaded.

Note: If a defective add-in leads to the Editor crashing, the entry is automatically set to 0.

ON=

Activate VSTA:

  • 1: VSTA activated (default)
  • 0: VSTA deactivated


Remote-Transport Parameter [SYS_REMOTE]

Manual -> Configuration files -> zenon6.ini -> Remote-Transport Parameter [SYS_REMOTE]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[SYS_REMOTE]

Administration of the Remote Transport parameters in the network.

For configuration of the Diagnosis Server, see the chapter:

Diagnosis Server [SYS_REMOTE] and [LOGGING_SYSTEM].

AUTORUN=

Name and path of the program that is started with zenSysSrv.

BROWSE=

Display of the browser window in the CE zenSysSrv:

  • 0: No display
  • 1: Display

Note: The window is also not displayed if the screen is too small.

CONFIG=

Configuration string for zenSysSrv. Remote Transport and the diagnosis system use the same server configuration up to and including version 6.51 SP0. For configuration details, in particular for versions before version 7, see chapter: Diagnosis Server [SYS_REMOTE] and [LOGGING_SYSTEM].

The string consists of the following parts: DEVICE=[Device];HOST=[Hostname];PORT=[Port];TIMEOUT=[Timeout].

  • DEVICE: Sets the communication type used.
    TCP/IP and serial are available.
  • HOST: Is set to the computer name of the Diagnosis Server.
  • PORT: states the port to be used.
  • TIMEOUT: Provides the connection time-out time in seconds.
  • BAUD: Provides the connection speed of a serial connection.

PC configuration:

  • DEVICE=TCP/IP
  • HOST=localhost
  • PORT=1101
  • TIMEOUT=10

CE configuration:

  • DEVICE=COM1
  • BAUD=115200

INIT=

Determines, with CE, what happens when the zeSysSrv user interface is started:

  • 0: end
  • 1: start
  • [anything else]: only show user interface


Remote Transport password [TRANSPASS]

Manual -> Configuration files -> zenon6.ini -> Remote Transport password [TRANSPASS]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[TRANSPASS]

Remote Transport Password (on remote station).

Note: Configuration for development computer in project.ini in the Remote Transport [ED_REMOTE], [DIRLIST] and [TRANSPASS] section.

FIX=

Password is:

  • 1: saved
  • 0: not saved

KEY=

Password for Remote Transport.

KEYCRYPT=

Encrypted stored password for remote transport.

Is only used if KEY= is empty.

Default from version 7.20. The switch is carried out automatically for the conversion of a project to version 7.20. The switch must be carried out manually on the target system.


Runtime [RT]

Manual -> Configuration files -> zenon6.ini -> Runtime [RT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[RT]

Settings for the Runtime.

DRIVER_QUE=

Size of sending queue to Runtime.

  • 0: unlimited

DRIVER_COUNT=

TMP-entry for driver and Runtime. Cycle time of the thread in the driver that sends data to zenon Runtime.

For example: DRIVER_COUNT=100

DYNRAHMEN=

Defines whether borders are shown around dynamic elements in Runtime.

  • 0: Do not display
  • 1: Display

RECT_ANZ=

Setting for optimization measures.

The parts of the screens to be displayed anew are collected in rectangles and then drawn. After the defined value has been reached, the new character ranges are added to the first rectangle.

For example: RECT_ANZ=50


SYMBOL [SYMBOL]

Manual -> Configuration files -> zenon6.ini -> SYMBOL [SYMBOL]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[SYMBOL]

SUBSTITUTE=

Substitution when inserting a symbol into a screen:

  • 1: The substitution function is applied.
  • 0: No substitution.

Default: 1

Note: Only has an effect on elements that are linked to at least one variable.


Simulation [SIMULATOR]

Manual -> Configuration files -> zenon6.ini -> Simulation [SIMULATOR]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[SIMULATOR]

BACKUP=

Backup of the HD values to a hard drive:

  • 0: no backup
  • 1: Backup to hard drive (default)

DIAG_LEVEL=

Definition of which actions are logged in the error file:

  • 0: no logging (default)
  • 1: Write error (write set value)

DWBEGIN=

Start of variable addresses for DWORD.

DWEND=

End of variable addresses for DWORD.

FLOATBEGIN=

Start of variable addresses for FLOAT.

FLOATEND=

End of variable addresses for FLOAT.

MAXHDVALS=

Sets the largest offset area minus 1 for HD data. For HD-string, the offset has to stay 4 under this value.

Default: 1024

OFFSET=

Offset for control variables in the simulator.

Default: 0


Terminalserver [TERMINAL]

Manual -> Configuration files -> zenon6.ini -> Terminalserver [TERMINAL]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[TERMINAL]

Settings for terminal server

CLIENT=

Runtime on a terminal server.

Possible values:

  • 0: The Runtime can only be started once. Operation on the terminal server is not possible.
  • 1: Terminal server is used. The Runtime can be started several times, all settings for the terminal server operation are automatically set by the Runtime.

Default: 0

CLIENT_NO_FILE_ALIGN=

Parameters for synchronization of the client with the server:

  • 0: Projects are always reloaded by all clients.
  • 1: selective synchronization active.
    Only the zenon client which is started in the console session of the terminal server synchronizes the Runtime files with the zenon server

SERIALIZE=

Definition of the screen resolution:

  • 0: Screen resolution individual, all screens are recalculated for each client
  • 1: The first client started sets the screen resolution.


Drivers

Manual -> Configuration files -> zenon6.ini -> Drivers

Settings for Drivers.


BrTcp32 [BrTcp32]

Manual -> Configuration files -> zenon6.ini -> Drivers -> BrTcp32 [BrTcp32]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[BrTcp32]

Settings for the driver S7TCP32

LOGFILE=

Extended logging for the driver:

  • 1: Activates the special extended logging of the driver. View of the entries via the Diagnosis Viewer.
  • 0: No


Sipa_32 [SIPA_32]

Manual -> Configuration files -> zenon6.ini -> Drivers -> Sipa_32 [SIPA_32]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[SIPA_32]

Settings for the driver Sipa_32.

NOT_USED=

List of hardware addresses that should not be used in the project.

Example: NOT_USED=1,2,3,4

SIMUL=

Setting for hardware simulation mode. In this mode, the hardware will be simulated in the memory instead of treating every variable separately (like in simulation mode).

  • 1: activated
  • 0: deactivated


BrTcp32 [BrTcp32]

Manual -> Configuration files -> zenon6.ini -> Drivers -> BrTcp32 [BrTcp32]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Entry | Description
[SNMP_NG_TRAP_SERVICE] | Settings for the driver SNMPNG32
PollingInterval= | Polling interval of the trap receipt service in milliseconds. Default: 5000
PollingRetries= | Number of retries if polling from the trap receipt service is unsuccessful. Default: 2
PollingRetryTimeout= | Waiting time between the retries of the trap receipt service polling in milliseconds. Default: 1000


System driver [SYSTEMTREIBER], [DEFAULT] and [LOCAL_VAR]

Manual -> Configuration files -> zenon6.ini -> Drivers -> System driver [SYSTEMTREIBER], [DEFAULT] and [LOCAL_VAR]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Entry | Description
[DEFAULT] | Default settings.
UPDATE_SEK = | Cycle time of the system driver in seconds
[LOCAL_VAR] | Entries for the system driver variables.
ID_DWORD_1 = <Wert> ID_DWORD_2 = <Wert> ID_DWORD_3 = <Wert> ID_DWORD_4 = <Wert> | These entries deliver the values for the system driver variables System info -> Local system variable: DWORD1-4. These variables are intended for the identification of a single computer in the network. This means the values are always managed locally in the zenon.ini file. By default, limits can be defined for each of these variables. If there are no entries in the zenon.ini file, the values of these variables will be set to 0 in zenon in Runtime.


zenProcGateway.ini

Manual -> Configuration files -> zenProcGateway.ini

[GENERAL]

Entry

Description

[GENERAL]

General setting for Process Gateway, regardless of the modules selected.

DLL=

Selection of the DLL file that is to be used for Process Gateway. The selected DLL file determines the module selection

  • AccessDEC.dll
  • AccessSQL.dll
  • AccessMODBUS.dll
  • AccessDNP3.dll
  • AccessIEC870Sl.dll
  • AccessSNMP.dll
  • AccessOPCUA.dll
  • AccessICCP.dll
  • AccessAzure.dll


AccessDEC [DEC]

Manual -> Configuration files -> zenProcGateway.ini -> AccessDEC [DEC]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Note: The configuration file must be in the system folder.

[DEC]

Entry | Description
LOGFILE | Name of the log file (if desired, e.g. zenProcGateway.log)
PORT | Port number, where the Process Gateway waits for connection attempts
TCPTIMEOUT | timeout interval, after which the connection is closed
REFRESHRATE | time interval in milliseconds, in which the process image of zenon is checked on changes.


DNP3 Slave [DNP3]

Manual -> Configuration files -> zenProcGateway.ini -> DNP3 Slave [DNP3]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

[DNP3]

Entry

Description

SERIAL=

serial communication (1) or communication via TCP/IP (0)

COMPORT=

serial interface (COM1 = 0, COM2 = 1,...)

BAUD=

baud rate of the serial interface

BYTESIZE=

number of data bits of the serial interface

PARITY=

Parity settings of the serial interface:
(0=none,1=odd,2=even)

STOPBITS=

number of stop bits of the serial interface
(0=1, 1=1.5, 2=2)

LINKADDRLOC=

local session link address

LINKADDRREM=

remote session link address

PORT=

Communication port of communication via TCP/IP

Default: 20000

TIME_USE_UTC=

Format of the time stamp:

  • 0= Local time
  • 1 = UTC

Default: 0

Obj1BinInput=

Drop-down list with the supported Variations for the object group

1: packet format
2: with flags

Default: 1: packet format

Obj2BinInputEvent=

Drop-down list with the supported Variations for the object group

1: without time

2: with absolute time

3: with relative time

Default: 3: with relative time

Obj10BinOutput=

Drop-down list with the supported Variations for the object group

1: packet format
2: with flags
Default: 1: with flags

Obj11BinOutputEvent=

Drop-down list with the supported Variations for the object group

1: status without time
2: status with time

Default: 1: status without time

Obj20Counter=

Drop-down list with the supported Variations for the object group

1: 32 bit with flag
2: 16 bit with flag
5: 32 bit without flag
6: 16 bit without flag

Default: 5: 32 bit without flag

Obj22CounterEvent=

Drop-down list with the supported Variations for the object group

1: 32 bit with flag
2: 16 bit with flag
5: 32 bit flag and time
6: 16 bit flag and time

Default: 1: 32 bit with flag

Obj30AnalogInp=

Drop-down list with the supported Variations for the object group

1: 32 bit with flag
2: 16 bit with flag
3: 32 bit without flag
4: 16 bit without flag
5: single precision, floating-point with flag
6: double precision, floating-point with flag

Default: 6: double precision, floating-point with flag

Obj32AnalogInpEvent=

Drop-down list with the supported Variations for the object group

1: 32 bit without time
2: 16 bit without time
3: 32 bit with time
4: 16 bit with time
5: single precision, floating-point without time
6: double precision, floating-point without time

7: single precision, floating-point with time
8: double precision, floating-point with time

Default: 6: double precision, floating-point without time

Obj40AnalogOutStatus=

Drop-down list with the supported Variations for the object group

1: 32 bit with flag
2: 16 bit with flag
3: single precision, floating-point with flags
4: double precision, floating-point with flags

Default: 2: 16 bit with flag

Obj41AnalogOutput=

Drop-down list with the supported Variations for the object group

1: 32 bit without time
2: 16 bit without time
3: 32 bit with time
4: 16 bit with time
5: single precision, floating-point without time

6: double precision, floating-point without time

7: single precision, floating-point with time
8: double precision, floating-point with time

Default: 2: 16 bit without time

UNSOLICITED_RESPONSES_ENABLED=

Activated or deactivated Unsolicited Responses:

  • 0 = not active
  • 1 = active

Default: Inactive (0)

UNSOLICITED_RESPONSES_CONFIRMATION_TIMEOUT=

Time in seconds for communication to the master. A time exceedance is triggered once this time has expired.

Entry range: 1 to 60 s

Default: 5 s

UNSOLICITED_RESPONSES_RETRY_COUNTER=

Number of retries for communication to the master.

Entry range: 0 - 65535
(0 = an infinite amount of attempts)

Default: 3

UNSOLICITED_RESPONSES_MAXIMUM_EVENTS_CLASS_1=

Maximum number of events (per event class) that can be buffered before an unsolicited response is sent.

Entry range: 0 - 255
Default: 5

UNSOLICITED_RESPONSES_MAXIMUM_EVENTS_CLASS_2=

Maximum number of events (per event class) that can be buffered before an unsolicited response is sent.

Entry range: 0 - 255
Default: 5

UNSOLICITED_RESPONSES_MAXIMUM_EVENTS_CLASS_3=

Maximum number of events (per event class) that can be buffered before an unsolicited response is sent.

Entry range: 0 - 255
Default: 5

UNSOLICITED_RESPONSES_MAXIMUM_DELAY_CLASS_1=

Maximum delay per event class that is waited until a new entry is written after writing an unsolicited response.

Entry range: 0 - 65535 seconds
(0 = no delay, i.e. on value change)
Default: 5

UNSOLICITED_RESPONSES_MAXIMUM_DELAY_CLASS_2=

Maximum delay per event class that is waited until a new entry is written after writing an unsolicited response.

Entry range: 0 - 65535 seconds
(0 = no delay, i.e. on value change)
Default: 5

UNSOLICITED_RESPONSES_MAXIMUM_DELAY_CLASS_3=

Maximum delay per event class that is waited until a new entry is written after writing an unsolicited response.

Entry range: 0 - 65535 seconds
(0 = no delay, i.e. on value change)
Default: 5

[VARIABLES]

Entry

Description

COUNT

number of variables to be exported

EVENT_%d

Event handling: Handling of the events per variable.
Always belonging to a variable: e.g. EVENT_0 belongs to NAME_0

Values:

  • DEFAULT
    Handling of events is the same as in the object group
  • MOST_RECENT
    Only includes the last change of a binary change event
  • SOE
    Creates a series of events

Default: Default

NAME_n

name of the variable with the number n (0<=<COUNT)

OBJECT_n

DNP3 object type of variable number n (0<=n<COUNT)

POINT_n

DNP3 point number of variable number n (0<=n<COUNT)


ICCP-TASE.2 [ICCP]

Manual -> Configuration files -> zenProcGateway.ini -> ICCP-TASE.2 [ICCP]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


IEC870 Slave []

Manual -> Configuration files -> zenProcGateway.ini -> IEC870 Slave []

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


MODBUS Slave [MODBUS]

Manual -> Configuration files -> zenProcGateway.ini -> MODBUS Slave [MODBUS]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

[MODBUS]

Entry | Description
COMPORT | serial interface (COM1 = 0, COM2 = 1,...). Can be set using the configuration dialog.
BAUD | Baud rate of the serial interface. Can be set using the configuration dialog.
BYTESIZE | number of data bits of the serial interface
PARITY | Parity settings of the serial interface: 0=No 1=Odd 2=Even Can be set using the configuration dialog.
STOPBITS | Number of stop bits of the serial interface 0=1 1=1.5 2=2 Can be set using the configuration dialog.
TIMEOUT | timeout interval for serial communication in milliseconds
HWADDRESS | Hardware address of the MODBUS system. Default: 1 Can be set using the configuration dialog.
REFRESHRATE | Update time in milliseconds
SERIELL | Serial or TCP/IP communication: 1 = serial 0 = TCP/IP Can be set using the configuration dialog.
PORT | TCP/IP port
TCPTIMEOUT | TCP/IP timeout interval in seconds

[MODBUS VARIABLES]

Variables that are to be replaced in AccessMODBUS.

Note: This entry replaces the original [VARIABLES] entry from zenon 7.11 onwards. This prevents unnecessary replacement using shared memory for variables from the standard project.

Entry

Description

COUNT

number of variables to be exported

OFFSET_n

Modbus address that is allocated to the corresponding number (n). Numbering starts with 0.

NAME_n

Name of the variable that is allocated to the corresponding number (n). Numbering starts with 0.

Examples:

  • OFFSET_0=0
    NAME_0=EMS_Supply area 1_forecast_final_consumption
    Variable from start project
  • OFFSET_1=2
    NAME_1=BASISTUTORIAL#Temperaturfühler
    Variable from projekt "BASISTUTORIAL"


OPC UA Server [OPCUA], [DATABASE] und [VARIABLES]

Manual -> Configuration files -> zenProcGateway.ini -> OPC UA Server [OPCUA], [DATABASE] und [VARIABLES]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry

Description

[OPCUA]

Settings for the OPC UA server.

SERVER_NAME=

Name of the server.

SERVER_PORT=

Port number for the connection.

Default: 4840

CERTIFICATES_PATH=

Path to the certificate files.

Note: Entry must be deleted if a new certificate is to be created when Process Gateway is started.

SERVER_CERTIFICATE_LOCATION=

File with the public key of the server. Used by the client for encrypting messages.

  • Format: DER
  • Suffix: .der

Default: %ProgramData%\COPA-DATA\System\PKI\CA\certs\zenopcua.der

Note: Entry must be deleted if a new certificate is to be created when Process Gateway is started.

SERVER_PRIVATE_KEY_LOCATION=

File with the private key of the server. Is used by the server to decrypt the messages from the client.

  • Format: PEM
  • No password.

Default: %ProgramData%\COPA-DATA\System\PKI\CA\private\zenopcua.pem

Note: Entry must be deleted if a new certificate is to be created when Process Gateway is started.

ARCHIVE_NAME=

Name of the selected archive.

ONLY_SECURE_CONNECTIONS=

Selection of the connection security.

  • TRUE: Only secure connections are accepted for establishing a connection, with the signature or with signature and encryption.
  • FALSE: Non-secure connections are also permitted.

Default: FALSE

TRUST_ALL_CLIENT_CERTIFICATES=

Trust in client certificates:

  • TRUE: All client certificates are accepted and the connection is made.
  • FALSE: All clients that want to connect with the server must send a valid certificate. This certificate is also checked to see if it is in the list of known client certificates Certificate trust list path.

Default: TRUE

USE_USER_AUTHENTICATION=
  • TRUE: Clients can only log on to the server with a valid user ID and password.
    Note: The user administration must be active.
  • FALSE: Anonymous login is possible.

Default: FALSE

Attention: The user name and password are not transferred in encrypted form in the OPCUA telegram. If necessary, use your own users in the project without assigned authorization levels.

[DATABASE]

Configuration of the data.

PROJECT=

Project

[VARIABLES]

Configuration of the variables

PROJECT_x=

Name of the project from which the variables come. x stands for the numbering of the project, starting with 0.

Example: PROJECT_0=TEST

PARAM_x=

Parameters for project x. Numbering is from 0 upwards.

Example: PARAM_0=80:INI.Driverforinternalvariables_ModemHwAdrSet

COUNT=

Number of configured variables.

NAME_x=

Name of the variable. x stands for the numbering of the project, starting with 0.

Example: NAME_0=Driverforinternalvariables_ModemHwAdrSet


Access SNMP [SNMP]

Manual -> Configuration files -> zenProcGateway.ini -> Access SNMP [SNMP]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


AccessSQL [DATABASE]

Manual -> Configuration files -> zenProcGateway.ini -> AccessSQL [DATABASE]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


AccessAzure [Azure]

Manual -> Configuration files -> zenProcGateway.ini -> AccessAzure [Azure]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

[Azure]

Entry | Description
INTEGRITYPERIOD= | Interval of the write cycle in seconds.

[VARIABLES]

Entry

Description

Name_n=

Name of the variable for Process Gateway.
Format: SOURCEPROJECT#SOURCEVARIABLE.

Numbering (n):

n Stands for the serial number of the connection configuration.

This numbering starts with 0.

Example:

  • 1 variable results in n = 0
  • 3 variables result in, for the third entry n = 2

Count=

Number of variables.

Note: The numbering starts with 1 here. Eight connections result in Count=8.

[CONNECTIONS]

Entry

Description

CONN_n=

Name of the MS Azure connection.

Numbering (n):

n Stands for the serial number of the connection configuration.

This numbering starts with 0.

Example:

  • 1 connection results in n = 0
  • 3 connections result in, for the third entry n = 2

QUEUE_n=

Name of the MS Azure queue.

For the numbering (_n) the same rules apply as for CONN

COUNT=

Number of the configured MS Azure connections.

Note: The numbering starts with 1 here. Two connections result in Count=2.


zenWebSrv.ini

Manual -> Configuration files -> zenWebSrv.ini

Settings for zenon Web Server.

Parameters

Description

[DEFAULT]

Basic settings.

INIT=

Settings for activation of the zenon Web Server.

Different setting to 0: Web Server was started by system control.

USE_HTTP_PROXY=

Defines if the connection is made via TCP or via HTTP.

  • 0: TCP is used.
  • Not 0: HTTP tunneling is used.

Value can be set directly via the Web Server configuration dialog

[PROXY]

Exchange of data between zenon Web Server and system control.

REMOVE_CLIENT

This entry reports when a logged-in client is removed in the system control to the zenon Web Server.

MAX_CLIENT

Maximum number of clients. (depends on the license.)

AKT_CLIENT

Current number of logged-in clients.

SERIAL7=

Serial number for zenon Web Server:

ACTIVATIONKEY7=

Encrypted activation number for zenon Web Server.

LICENCEINFO

License information, as it is displayed in the system control:

  • Demo Web Server Pro
  • Demo Web Server
  • Runtime Web Server Pro
  • Runtime Web Server

[CLIENTLIST]

List of logged-in clients.

NAME_[Index 00 upwards]

Name of logged-in client.

Note: The entries in [PROXY] and [CLIENTLIST] are deleted when the zenon Web Server is started. If the service receives a control command from the system control, the entries are written or read as required.

info Information

You can find the zenWebSrv.ini in the %cd_system% path.


Controls

Manual -> Controls

In zenon you can integrate own controls. For this following is available:

  • .NET user controls (For implementing in zenon see also .NET controls in manual Screens.)
  • ActiveX (For implementing in zenon see also ActiveX in manual Screens.)
  • WPF

info Information

You can find information about how to use the zenon programming interfaces (PCE, VBA, VSTA) in manual Programming Interfaces.

tutorial License information

Part of the standard license of the Editor and Runtime.

attention Attention

Note that errors in applications such as ActiveX, PCE, VBA, VSTA, WPF and external applications that access zenon via the API can also influence the stability of Runtime.


General

Manual -> Controls -> General

Controls for zenon can be implemented via ActiveX, .NET and WPF. Via VBA/VSTA you can access the zenon API.


Access zenon API

Manual -> Controls -> General -> Access zenon API

Under zenon you can enhance an ActiveX control with special functions in order to access the zenon API.

Access the zenon API

  • In Project References, select Add References... the zenon RT object library
  • add the enhanced functions to the class code of the control

Enhanced zenon ActiveX functions

// Is called during the initializing of the control in the zenon Runtime.

public bool zenon>Init(zenon.Element dispElement)…

// Is called during the destruction of the control in the zenon Runtime.

public bool zenonExit()

// Supports the control variable linking

public short CanUseVariables()…

// Com control supports data types.

public short VariableTypes()…

// Maximum number of variables which can be linked to the control.

public short MaxVariables()…

Example

The COM object of a zenon variable is temporarily saved in a Member in order to access it later in the Paint Event of the control.

zenon.Variable m_cVal = null;

public bool zenon>Init(zenon.Element dispElement)

{

if (dispElement.CountVariable > 0) {

try {

m_cVal = dispElement.ItemVariable(0);

if (m_cVal != null) {

object obRead = m_cVal.get_Value((object)-1);

UserText = obRead.ToString();

}

}catch { }

}

return true;

}

public bool zenonExit()

{

try {

if (m_cVal != null) {

System.Runtime.InteropServices.Marshal.FinalReleaseComObject(m_cVal);

m_cVal = null;

}

}

catch { }

return true;

}

public short CanUseVariables()

{

return 1; // the variables are supported

}

public short VariableTypes()

{

return short.MaxValue; // all data types are supported

}

public short MaxVariables()

{

return 1; // as maximum one variable should be linked to the control

}

private void SamplesControl_Paint(object sender, PaintEventArgs e)

{

// zenon Variables has changed

try {

if (m_cVal != null) {

object obRead = m_cVal.get_Value((object)-1);

UserText = obRead.ToString();

}

}catch { }

}


Methods

Manual -> Controls -> General -> Methods

ActiveX and .NET controls which use zenon variables need certain methods.


CanUseVariables

Manual -> Controls -> General -> Methods -> CanUseVariables

Prototype: short CanUseVariables();

This method either returns 1 or 0

Value | Description
1: | The control can use zenon variables. For the dynamic element (via button Variable) you can only state zenon variables with the type stated via method VariableTypes in the number stated by method MaxVariables.
0: | The control cannot use zenon variables or does not have the method. You can state variables with all types without restricting the number. In the Runtime however they only can be used with VBA.


MaxVariables

Manual -> Controls -> General -> Methods -> MaxVariables

Prototype: short MaxVariables();

Here the number of variables is defined, that can be selected from the variable list.

If 1 is returned, multi-select is disabled in the variable list. A warning is displayed when several variables are selected anyway.


VariableTypes

Manual -> Controls -> General -> Methods -> VariableTypes

Prototype: short VariableTypes();

The value returned by this method is used as a mask for the usable variable types in the variable list. The value is an AND relation from the following values (defined in zenon32/dy_type.h):

Value 1 | Value 2 | Equivalent
WORD | 0x0001 | Position 0
BYTE | 0x0002 | Position 1
BIT | 0x0004 | Position 2
DWORD | 0x0008 | Position 3
FLOAT | 0x0010 | Position 4
DFLOAT | 0x0020 | Position 5
STRING | 0x0040 | Position 6
IN_OUTPUT | 0x8000 | Position 15


zenonExit

Manual -> Controls -> General -> Methods -> zenonExit

Prototype: boolean zenonExit();

This method is called by the zenon Runtime when the ActiveX control is closed.

Here all dispatch pointers on variables should be released.


zenonExitEd

Manual -> Controls -> General -> Methods -> zenonExitEd

Equals zenonExit and is executed in closing the ActiveX in the Editor.

Therewith you can also react to changes in the ActiveX e.g. values changes in Editor.

Info: Currently only available for ActiveX.


zenonInit

Manual -> Controls -> General -> Methods -> zenonInit

Prototype: boolean zenonInit(IDispatch*dispElement);

With this method (in the Runtime) the ActiveX control gets a pointer to the dispatch interface of the dynamic element. With this pointer zenon variables linked to the dynamic element can be accessed.

You define the sorting order of the handed over variables in the configuration of the ActiveX element with the help of buttons Down or Up.
The Element Input dialog appears after double-clicking the ActiveX element or after selecting property ActiveX settings in the element properties in node Representation.


zenonInitEd

Manual -> Controls -> General -> Methods -> zenonInitEd

Equals zenonInit and is executed on opening the ActiveX (double click the ActiveX) in the Editor.

Info: Currently only available for ActiveX.


ActiveX

Manual -> Controls -> ActiveX

With ActiveX the functionality of the zenon Runtime and Editor can be enhanced autonomously.

In this manual you can find:

  • Develop ActiveX elements
  • Example LatchedSwitch (C++)
  • Example CD_SliderCtrl (C++)
  • Example :NET control as ActiveX (C#)

You can find information about the dynamic element ActiveX in manual Screens in chapter ActiveX.

ActiveX for Windows CE

If an ActiveX Control should run under Windows CE, the apartment model must be set to Threading. If it is set to Free, the control will not run in zenon Runtime.


Develop ActiveX elements

Manual -> Controls -> ActiveX -> Develop ActiveX elements

The dynamic element ActiveX in zenon can forward variables to the ActiveX control without using VBA to operate the control.

The control now defines by itself, how many zenon variables it can use and of what type they may be. Additionally the properties of the control can also be defined by the dynamic element.

For this the interface (dispatch interface) of the control must support a number of certain methods .


Methods

Manual -> Controls -> ActiveX -> Develop ActiveX elements -> Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Each ActiveX control which can use zenon variables must contain the following methods:

  • CanUseVariables
  • MaxVariables
  • VariableTypes
  • zenonExit
  • zenonExitEd
  • zenonInit
  • zenonInitEd

It does not matter, which dispatch ID the methods have in the interface. On calling the methods zenon receives the correct ID from the interface.


CanUseVariables

Manual -> Controls -> ActiveX -> Develop ActiveX elements -> Methods -> CanUseVariables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Prototype: short CanUseVariables();

This method either returns 1 or 0

Value | Description
1: | The control can use zenon variables. For the dynamic element (via button Variable) you can only state zenon variables with the type stated via method VariableTypes in the number stated by method MaxVariables.
0: | The control cannot use zenon variables or does not have the method. You can state variables with all types without restricting the number. In the Runtime however they only can be used with VBA.


MaxVariables

Manual -> Controls -> ActiveX -> Develop ActiveX elements -> Methods -> MaxVariables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Prototype: short MaxVariables();

Here the number of variables is defined, that can be selected from the variable list.

If 1 is returned, multi-select is disabled in the variable list. A warning is displayed when several variables are selected anyway.


VariableTypes

Manual -> Controls -> ActiveX -> Develop ActiveX elements -> Methods -> VariableTypes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Prototype: short VariableTypes();

The value returned by this method is used as a mask for the usable variable types in the variable list. The value is an AND relation from the following values (defined in zenon32/dy_type.h):

Value 1 | Value 2 | Equivalent
WORD | 0x0001 | Position 0
BYTE | 0x0002 | Position 1
BIT | 0x0004 | Position 2
DWORD | 0x0008 | Position 3
FLOAT | 0x0010 | Position 4
DFLOAT | 0x0020 | Position 5
STRING | 0x0040 | Position 6
IN_OUTPUT | 0x8000 | Position 15


zenonExit

Manual -> Controls -> ActiveX -> Develop ActiveX elements -> Methods -> zenonExit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Prototype: boolean zenonExit();

This method is called by the zenon Runtime when the ActiveX control is closed.

Here all dispatch pointers on variables should be released.


zenonExitEd

Manual -> Controls -> ActiveX -> Develop ActiveX elements -> Methods -> zenonExitEd

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Equals zenonExit and is executed in closing the ActiveX in the Editor.

Therewith you can also react to changes in the ActiveX e.g. values changes in Editor.

Info: Currently only available for ActiveX.


zenonInit

Manual -> Controls -> ActiveX -> Develop ActiveX elements -> Methods -> zenonInit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Prototype: boolean zenonInit(IDispatch*dispElement);

With this method (in the Runtime) the ActiveX control gets a pointer to the dispatch interface of the dynamic element. With this pointer zenon variables linked to the dynamic element can be accessed.

You define the sorting order of the handed over variables in the configuration of the ActiveX element with the help of buttons Down or Up.
The Element Input dialog appears after double-clicking the ActiveX element or after selecting property ActiveX settings in the element properties in node Representation.


zenonInitEd

Manual -> Controls -> ActiveX -> Develop ActiveX elements -> Methods -> zenonInitEd

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Equals zenonInit and is executed on opening the ActiveX (double click the ActiveX) in the Editor.

Info: Currently only available for ActiveX.


Example LatchedSwitch (C++)

Manual -> Controls -> ActiveX -> Example LatchedSwitch (C++)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following example describes an ActiveX control, that realises a latched switch with two bit variables. The first variable represents the switch, the second variable the lock. The value of the switching variable of the ActiveX control can only be changed, if the locking variable has the value 0.

The status of the element is displayed with four bitmaps which can be selected in the properties dialog of the control in the zenon Editor.

Other topics in this chapter

Interface

Control

Methods

Operate and display

zenon Interface


Interface

Manual -> Controls -> ActiveX -> Example LatchedSwitch (C++) -> Interface

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The control LatchedSwitch has the following dispatch interface:

[ uuid(EB207159-D7C9-11D3-B019-080009FBEAA2),
helpstring(Dispatch interface for LatchedSwitch Control), hidden ]
dispinterface _DLatchedSwitch

{
properties:
// NOTE - ClassWizard will maintain method information here.
// Use extreme caution when editing this section.
//{{AFX_ODL_PROP(CLatchedSwitchCtrl)
[id(1)] boolean SollwertDirekt;
[id(2)] IPictureDisp* SwitchOn; // container for the bitmaps
[id(3)] IPictureDisp* SwitchOff;
[id(4)] IPictureDisp* LatchedOn;
[id(5)] IPictureDisp* LatchedOff;
//}}AFX_ODL_PROP

methods:
// NOTE - ClassWizard will maintain method information here.
// Use extreme caution when editing this section.
//{{AFX_ODL_METHOD(CLatchedSwitchCtrl)
//}}AFX_ODL_METHOD
[id(6)] short CanUseVariables();
[id(7)] short VariableTypes();
[id(8)] short MaxVariables();
[id(9)] boolean zenonInit(IDispatch* dispElement);
[id(10)] boolean zenonExit();
[id(DISPID_ABOUTBOX)] void AboutBox();

};

The properties SwitchOn to LatchedOff contain the bitmaps for displaying the four different states of the control. The bitmaps themselves are stored in objects of the class CScreenHolder. The property SollwertDirekt defines if the input of set values is done via a dialog or directly by clicking the control.


Control

Manual -> Controls -> ActiveX -> Example LatchedSwitch (C++) -> Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Implementing the control is done with the class CLatchedSwitchCtrl. As members this class has the CScreenHolder objects for the storage of the bitmaps. Additionally three dispatch drivers for the dynamic element and the variables are generated:

class CLatchedSwitchCtrl : public COleControl

{

DECLARE_DYNCREATE(CLatchedSwitchCtrl)

// Constructor

public:

CLatchedSwitchCtrl();

// Overrides

// ClassWizard generated virtual function overrides

//{{AFX_VIRTUAL(CLatchedSwitchCtrl)

public:

virtual void OnDraw (CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);

virtual void DoPropExchange (CPropExchange* pPX);

virtual void OnResetState ();

virtual DWORD GetControlFlags();

//}}AFX_VIRTUAL

// Implementation

protected:

~CLatchedSwitchCtrl();

DECLARE_OLECREATE_EX(CLatchedSwitchCtrl) // Class factory and guid

DECLARE_OLETYPELIB(CLatchedSwitchCtrl) // GetTypeInfo

DECLARE_PROPPAGEIDS(CLatchedSwitchCtrl) // Property page IDs

DECLARE_OLECTLTYPE(CLatchedSwitchCtrl) // Type name and misc status

// Message maps

//{{AFX_MSG(CLatchedSwitchCtrl)

afx_msg void OnLButtonDown(UINT nFlags, CPoint point);

//}}AFX_MSG

DECLARE_MESSAGE_MAP()

// Dispatch maps

//{{AFX_DISPATCH(CLatchedSwitchCtrl)

BOOL m_sollwertDirekt;

afx_msg void OnSollwertDirektChanged();

afx_msg LPPICTUREDISP GetSwitchOn();

afx_msg void SetSwitchOn(LPPICTUREDISP newValue);

afx_msg LPPICTUREDISP GetSwitchOff();

afx_msg void SetSwitchOff(LPPICTUREDISP newValue);

afx_msg LPPICTUREDISP GetLatchedOn();

afx_msg void SetLatchedOn(LPPICTUREDISP newValue);

afx_msg LPPICTUREDISP GetLatchedOff();

afx_msg void SetLatchedOff(LPPICTUREDISP newValue);

afx_msg short CanUseVariables();

afx_msg short VariableTypes();

afx_msg short MaxVariables();

afx_msg BOOL zenonInit(LPDISPATCH dispElement);

afx_msg BOOL zenonExit();

//}}AFX_DISPATCH

CScreenHolder m_SwitchOn;

CScreenHolder m_SwitchOff;

CScreenHolder m_LatchedOn;

CScreenHolder m_LatchedOff;

DECLARE_DISPATCH_MAP()

afx_msg void AboutBox();

// Event maps

//{{AFX_EVENT(CLatchedSwitchCtrl)

//}}AFX_EVENT

DECLARE_EVENT_MAP()

double VariantToDouble(const VARIANT FAR *v);

void VariantToCString(CString *c,const VARIANT FAR *v);

BOOL IsVariantString(const VARIANT FAR *v);

BOOL IsVariantValue(const VARIANT FAR *v);

// Dispatch and event IDs

public:

CString szVariable[2];

IElement m_dElement;

IVariable m_dLatchVar, m_dSwitchVar;

enum {

//{{AFX_DISP_ID(CLatchedSwitchCtrl)

dispidSollwertDirekt = 1L,

dispidSwitchOn = 2L,

dispidSwitchOff = 3L,

dispidLatchedOn = 4L,

dispidLatchedOff = 5L,

dispidCanUseVariables = 6L,

dispidVariableTypes = 7L,

dispidMaxVariables = 8L,

dispidZenOnInit = 9L,

dispidZenOnExit = 10L,

//}}AFX_DISP_ID

};

};


Methods

Manual -> Controls -> ActiveX -> Example LatchedSwitch (C++) -> Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following methods are used:

  • CanUseVariables
  • VariableTypes
  • MaxVariables
  • zenonInit
  • zenonExit

Other topics in this chapter

CanUseVariables

VariableTypes

MaxVariables

zenonInit

zenonExit


CanUseVariables

Manual -> Controls -> ActiveX -> Example LatchedSwitch (C++) -> Methods -> CanUseVariables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This method returns 1, so zenon variables can be used.

short CLatchedSwitchCtrl::CanUseVariables()

{

return 1;

}


VariableTypes

Manual -> Controls -> ActiveX -> Example LatchedSwitch (C++) -> Methods -> VariableTypes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The control only can work with bit variables, so 0x0004 is returned.

short CLatchedSwitchCtrl::VariableTypes()

{

return 0x0004; // Only bit variables

}


MaxVariables

Manual -> Controls -> ActiveX -> Example LatchedSwitch (C++) -> Methods -> MaxVariables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Two variables can be used. Therfore 2 is returned.

short CLatchedSwitchCtrl::MaxVariables()

{

return 2; // 2 variables

}


zenonInit

Manual -> Controls -> ActiveX -> Example LatchedSwitch (C++) -> Methods -> zenonInit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This method gets the dispatch drivers of the variables via the dispatch pointer of the dynamic element. With this pointer the variable values are read and written when clicking and drawing the control.

BOOL CLatchedSwitchCtrl::zenonInit(LPDISPATCH dispElement)

{

m_dElement = IElement(dispElement);

if (m_dElement.GetCountVariable() >= 2)

{

short iIndex = 0;

m_dSwitchVar = IVariable(m_dElement.ItemVariable(COleVariant(iIndex)));

m_dLatchVar = IVariable(m_dElement.ItemVariable(COleVariant(++iIndex)));

}

return TRUE;

}


zenonExit

Manual -> Controls -> ActiveX -> Example LatchedSwitch (C++) -> Methods -> zenonExit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This method releases the dispatch driver.

BOOL CLatchedSwitchCtrl::zenonExit()

{

m_dElement.ReleaseDispatch();

m_dSwitchVar.ReleaseDispatch();

m_dLatchVar.ReleaseDispatch();

return TRUE;

}


Operate and display

Manual -> Controls -> ActiveX -> Example LatchedSwitch (C++) -> Operate and display

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Other topics in this chapter

Setting values

Drawing


Setting values

Manual -> Controls -> ActiveX -> Example LatchedSwitch (C++) -> Operate and display -> Setting values

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A value can be set by clicking the control with the left mouse button.

If m_iSollwertDirekt is 0, a dialog for the selection of the set value is opened, otherwise the current value of the switching variable is inverted.

If the locking variable has the value 1, only a MessageBeep is executed. No value can be set via the control.

void CLatchedSwitchCtrl::OnLButtonDown(UINT nFlags, CPoint point)

{

CRect rcBounds;

GetWindowRect(&rcBounds);

COleVariant coleValue((BYTE)TRUE);

BOOL bLatch = (BOOL)VariantToDouble((LPVARIANT)&m_dLatchVar.GetValue());

BOOL bSwitch = (BOOL)VariantToDouble((LPVARIANT)&m_dSwitchVar.GetValue());

if (bLatch) // Locked!!!

MessageBeep(MB_ICONEXCLAMATION);

else

{

if (m_sollwertDirekt)

{

bSwitch = !bSwitch;

}

else

{

CSollwertDlg dlg;

dlg.m_iSollwert = bSwitch ? 1 : 0;

if (dlg.DoModal() == IDOK)

{

if (dlg.m_iSollwert == 2) // Toggle

bSwitch = !bSwitch;

else

bSwitch = (BOOL)dlg.m_iSollwert;

}

}

coleValue = (double)bSwitch;

m_dSwitchVar.SetValue(coleValue);

}

COleControl::OnLButtonDown(nFlags, point);

}


Drawing

Manual -> Controls -> ActiveX -> Example LatchedSwitch (C++) -> Operate and display -> Drawing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On drawing the control the values of the variables are read via their dispatch drivers, and accordingly one of the four defined graphics is displayed. When the value of a variable changes, the control is updated by the OnDraw routine.

void CLatchedSwitchCtrl::OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)

{

CRect rcBitmap = rcBounds;

rcBitmap.NormalizeRect();

if (!m_dElement)

{

m_SwitchOn.Render(pdc, &rcBounds, &rcBounds);

return;

}

BOOL bVal1 = 0, bVal2 = 0;

VARIANT vRes;

if (m_dSwitchVar) // Variable exists?

{

vRes = m_dSwitchVar.GetValue();

bVal1 = (BOOL)VariantToDouble(&vRes);

}

if (m_dLatchVar) // Variable exists?

{

vRes = m_dLatchVar.GetValue();

bVal1 = (BOOL)VariantToDouble(&vRes);

}

if (bVal1 && bVal2)

m_SwitchOn.Render(pdc, rcBitmap, rcBitmap);

else if (!bVal1 && bVal2)

m_SwitchOff.Render(pdc, rcBitmap, rcBitmap);

else if (bVal1 && !bVal2)

m_LatchedOn.Render(pdc, rcBitmap, rcBitmap);

else

m_LatchedOff.Render(pdc, rcBitmap, rcBitmap);

}


zenon Interface

Manual -> Controls -> ActiveX -> Example LatchedSwitch (C++) -> zenon Interface

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Classes deduced from COleDispatchDriver have to be created for the element and the variables, so that the dispatch interface of zenon can be used to set values. The easiest way to create these classes is the Class Wizard of the development environment (button Add Class, select From a type library, select zenrt32.tlb).

For our control theses are the classes IElement and IVariable. They are defined in zenrt32.h and zenrt32.cpp.


Example CD_SliderCtrl (C++)

Manual -> Controls -> ActiveX -> Example CD_SliderCtrl (C++)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following example describes an ActiveX control which equals the Windows SliderCtrl. This component can be linked with a zenon variable. The user can change the value of a variable with this slider. If the value of the variable is changed with some other dynamic element, the slider is updated.

Other topics in this chapter

Interface

Control

Methods

Operate and display

zenon Interface


Interface

Manual -> Controls -> ActiveX -> Example CD_SliderCtrl (C++) -> Interface

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The control CD_SliderCtrl has the following dispatch interface:

[ uuid(5CD1B01D-015E-11D4-A1DF-080009FD837F),

helpstring(Dispatch interface for CD_SliderCtrl Control), hidden

]

dispinterface _DCD_SliderCtrl

{

properties: //*** Properties of the controls

[id(1)] short TickRaster;

[id(2)] boolean ShowVertical;

[id(3)] short LineSize;

methods: //*** method of the control (for zenon ActiveX)

[id(4)] boolean zenonInit(IDispatch* pElementInterface);

[id(5)] boolean zenonExit();

[id(6)] short VariableTypes();

[id(7)] short CanUseVariables();

[id(8)] short MaxVariables();

[id(DISPID_ABOUTBOX)] void AboutBox();

};


Control

Manual -> Controls -> ActiveX -> Example CD_SliderCtrl (C++) -> Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Implementing the control is done with the class CD_SliderCtrlCtrl. This class has a standard Windows CSliderCtrl as a member, with which the control is subclassed. The interfaces IVaribale and IElemen t contain zenon interfaces which had to be integrated. These are deduced from COleDispatchDriver.

class CCD_SliderCtrlCtrl : public COleControl

{

DECLARE_DYNCREATE(CCD_SliderCtrlCtrl)

private: //*** member variables

BOOL m_bInitialized;

BOOL m_bShowVertical;

BOOL m_bTicksBoth;

long m_nRangeStart;

long m_nRangeEnd;

long m_nTickOrientation;

IVariable m_interfaceVariable;

IElement m_interfaceElement;

CSliderCtrl m_wndSliderCtrl;

public:

CCD_SliderCtrlCtrl();

//{{AFX_VIRTUAL(CCD_SliderCtrlCtrl)

public:

virtual void OnDraw (CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);

virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

virtual void DoPropExchange (CPropExchange* pPX);

virtual void OnResetState ();

//}}AFX_VIRTUAL

protected:

~CCD_SliderCtrlCtrl();

//*** methods for the conversion from variant

double VariantToDouble(const VARIANT FAR *vValue);

DECLARE_OLECREATE_EX(CCD_SliderCtrlCtrl) // Class factory and guid

DECLARE_OLETYPELIB (CCD_SliderCtrlCtrl) // GetTypeInfo

DECLARE_PROPPAGEIDS (CCD_SliderCtrlCtrl) // Property page IDs

DECLARE_OLECTLTYPE (CCD_SliderCtrlCtrl) // Type name and misc status

//*** methods for the functionality of the SliderCtrl

BOOL IsSubclassedControl ();

LRESULT OnOcmCommand (WPARAM wParam, LPARAM lParam);

//{{AFX_MSG(CCD_SliderCtrlCtrl)

afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);

afx_msg void HScroll(UINT nSBCode, UINT nPos);

afx_msg void HScroll(UINT nSBCode, UINT nPos);

afx_msg void OnLButtonDown(UINT nFlags, CPoint point);

afx_msg void OnLButtonUp(UINT nFlags, CPoint point);

//}}AFX_MSG

DECLARE_MESSAGE_MAP()

//{{AFX_DISPATCH(CCD_SliderCtrlCtrl)

afx_msg BOOL GetTickOnBothSides();

afx_msg void SetTickOnBothSides (short nNewValue);

afx_msg BOOL GetShowVertical();

afx_msg void SetShowVertical(BOOL bNewValue);

afx_msg short GetTickOrientation();

afx_msg void SetTickOrientation (short nNewValue);

afx_msg BOOL zenonInit(LPDISPATCH pElementInterface);

afx_msg BOOL zenonExit();

afx_msg short VariableTypes();

afx_msg short CanUseVariables();

afx_msg short MaxVariables();

//}}AFX_DISPATCH

DECLARE_DISPATCH_MAP()

afx_msg void AboutBox();

//{{AFX_EVENT(CCD_SliderCtrlCtrl)

//}}AFX_EVENT

DECLARE_EVENT_MAP()

public:

enum {

//{{AFX_DISP_ID(CCD_SliderCtrlCtrl)

dispidShowVertical = 1L,

dispidTicksOnBothSides = 2L,

dispidTickOrientation = 3L,

dispidZenOnInit = 4L,

dispidZenOnExit = 5L,

dispidVariableTypes = 6L,

dispidCanUseVariables = 7L,

dispidMaxVariables = 8L,

//}}AFX_DISP_ID

};

};


Methods

Manual -> Controls -> ActiveX -> Example CD_SliderCtrl (C++) -> Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following methods are used:

  • CanUseVariables
  • VariableTypes
  • MaxVariables
  • zenonInit
  • zenonExit

Other topics in this chapter

CanUseVariables

VariableTypes

MaxVariables

zenonInit

zenonExit


CanUseVariables

Manual -> Controls -> ActiveX -> Example CD_SliderCtrl (C++) -> Methods -> CanUseVariables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This method returns 1 so zenon variables can be used.

short CCD_SliderCtrlCtrl::CanUseVariables()

{

return 1;

}


VariableTypes

Manual -> Controls -> ActiveX -> Example CD_SliderCtrl (C++) -> Methods -> VariableTypes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The control can work with word, byte, doubleword and float variables. You will find a list of the possible data types in the general description of this method.

short CCD_SliderCtrlCtrl::VariableTypes()

{

return 0x0001 | // Word

0x0002 | // Byte

0x0008 | // D-Word

0x0010 | // Float

0x0020; // D-Float

}


MaxVariables

Manual -> Controls -> ActiveX -> Example CD_SliderCtrl (C++) -> Methods -> MaxVariables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Only one variable can be linked to this control.

short CCD_SliderCtrlCtrl::MaxVariables()

{

return 1; // 1 variables

}


zenonInit

Manual -> Controls -> ActiveX -> Example CD_SliderCtrl (C++) -> Methods -> zenonInit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The parameter dispElement contains the interface for the dynamic element. With this element the linked zenon variable determined. If it is valid, the area of the SlideCtrl is set. Additionally the settings for the display (number of ticks, …) are set. If no variable is linked, the display range is set to 0 to 0. Thus the SliderCtrl cannot be changed. The variable m_bInitialized defines that values can be set from now on.

BOOL CCD_SliderCtrlCtrl::zenonInit(LPDISPATCH dispElement)

{

//*** Determine the variable using the zenon element

m_interfaceElement = IElement(pElementInterface);

if (m_interfaceElement.GetCountVariable() > 0) {

short nIndex = 0;

m_interfaceVariable = IVariable

(m_interfaceElement.ItemVariable(COleVariant(nIndex)));

}

//*** Initialize the area of the Slider-Ctrl

if (m_interfaceVariable) {

//*** Define range

m_nRangeStart = (long) VariantToDouble(&m_interfaceVariable.GetRangeMin());

m_nRangeEnd = (long) VariantToDouble(&m_interfaceVariable.GetRangeMax());

m_wndSliderCtrl.SetRange(m_nRangeStart,m_nRangeEnd,TRUE);

//*** Define sub ticks

m_wndSliderCtrl.SetTicFreq(m_nTickCount);

m_wndSliderCtrl.SetPageSize(m_nTickCount);

m_wndSliderCtrl.SetLineSize(m_nLineSize);

} else {

m_wndSliderCtrl.SetRange(0,0,TRUE);

return FALSE;

}

m_bInitialized = TRUE;

return TRUE;

}


zenonExit

Manual -> Controls -> ActiveX -> Example CD_SliderCtrl (C++) -> Methods -> zenonExit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this method the zenon interfaces are released again.

BOOL CCD_SliderCtrlCtrl::zenonExit()

{

m_interfaceElement.ReleaseDispatch();

m_interfaceVariable.ReleaseDispatch();

return TRUE;

}


Operate and display

Manual -> Controls -> ActiveX -> Example CD_SliderCtrl (C++) -> Operate and display

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Other topics in this chapter

Drawing

Setting values


Drawing

Manual -> Controls -> ActiveX -> Example CD_SliderCtrl (C++) -> Operate and display -> Drawing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With DoSuperclassPaint the SliderCtrl is drawn (as is is a subclassed control). If at the moment of drawing the slider is moved, the variable m_bInitialized gets the value FALSE. This makes sure that the value can be changed. Normally the value of the variable is read and displayed with the method SetPos of the SliderCtrl.

void CCD_SliderCtrlCtrl::OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)

{

//*** update view

DoSuperclassPaint(pdc, rcBounds);

if (m_interfaceVariable && m_bInitialized) {

COleVariant cValue(m_interfaceVariable.GetValue());

int nValue = (int) VariantToDouble(&cValue.Detach());

m_wndSliderCtrl.SetPos(nValue);

}

}


Setting values

Manual -> Controls -> ActiveX -> Example CD_SliderCtrl (C++) -> Operate and display -> Setting values

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the method LButtonDown the variable m_bInitialized is set to FALSE, and in the event LbuttonUp it is set to TRUE again. This makes sure that the value can be changed. Otherwise the routine OnDraw would be executed and the old value would be displayed.

void CCD_SliderCtrlCtrl::OnLButtonDown(UINT nFlags, CPoint point)

{

m_bInitialized = FALSE;

COleControl::OnLButtonDown(nFlags, point);

}

void CCD_SliderCtrlCtrl::OnLButtonUp(UINT nFlags, CPoint point)

{

m_bInitialized = TRUE;

COleControl::OnLButtonUp(nFlags, point);

}

A value is sent to the hardware, when the slider is moved. In the methods Hscroll or Vscroll the value is sent to the hardware (depending if it is a horizontal or a vertical slider).

void CCD_SliderCtrlCtrl::HScroll(UINT nSBCode, UINT nPos)

{

switch (nSBCode) {

case TB_LINEUP:

case TB_PAGEUP:

case TB_LINEDOWN:

case TB_PAGEDOWN:

case TB_THUMBTRACK:

case TB_THUMBPOSITION:{

//*** Set value without dialog ?

int nValue = m_wndSliderCtrl.GetPos();

COleVariant cValue((short) nValue,VT_I2);

m_interfaceVariable.SetValue(cValue);

}

}

}


zenon Interface

Manual -> Controls -> ActiveX -> Example CD_SliderCtrl (C++) -> zenon Interface

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Classes deduced from COleDispatchDriver have to be created for the element and the variables, so that the dispatch interface of zenon can be used to set values. The easiest way to create these classes is the Class Wizard of the development environment (button Add Class, select From a type library, select zenrt32.tlb).

For our control theses are the classes IElement and IVariable. They are defined in zenrt32.h and zenrt32.cpp.


Example :NET control as ActiveX (C#)

Manual -> Controls -> ActiveX -> Example :NET control as ActiveX (C#)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following example describes a .NET control which is executed as ActiveX control in zenon.

The creation and integration is carried out in four steps:

  1. Creat Windows Form Control
  2. Change .NET user control to dual control
  3. Work via VBA with ActiveX in the Editor
  4. Connect zenon variables with the .NET user control

Other topics in this chapter

Creat Windows Form Control

Change .NET User Control to dual control

Work via VBA with ActiveX in the Editor

Connect zenon variables with the .NET user control


Creat Windows Form Control

Manual -> Controls -> ActiveX -> Example :NET control as ActiveX (C#) -> Creat Windows Form Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a Windows Form Control:

  1. Start Visual Studio 2008 and create a new Windows Form Control Library project:

  2. Rename the default control to the desired control name.
    In our example: SampesControl.cs.

  3. Open the Control Designer and add the desired control; in our case a text box:

  4. Normally controls have properties. Open the Code Designer via View Code and ass the desired properties which should be available externally.
    In our example: Externally visible property „UserText" with get and set access which contains the text of the text box:

  5. Compile the project.

    The Windows Forms Control can now be used in other Windows Forms projects.

    Important: The control must be inserted manually in the control tool box via Choose Items.


Change .NET User Control to dual control

Manual -> Controls -> ActiveX -> Example :NET control as ActiveX (C#) -> Change .NET User Control to dual control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To change the .NET in a dual control, you must first activate the COM interface for ActiveX.

  1. Open the project and activate property Register for COM interop in the Build settings:

  2. Open the file AssemblyInfo.cs and
    • set attribute ComVisible to true
    • add attribute ClassInterface

    [assembly: ComVisible(true)]

    [assembly: ClassInterface(ClassInterfaceType.AutoDual)]

  3. Open the code designer via View Code and add the necessary ActiveX attributes and using entries. Via menu Tools/Create GUID create a new GUID for the GUID attribute:

  4. For the control to be selectable as Active X user interface control, you must add the functions to the following control classes:
    • RegisterClass
    • UnregisterClass

    After that you can register the control in the registry.

  5. Compile the project again.

    The Windows Form Control is now ActiveX-able and was registered automatically during the rebuild. An additional typelib file zenOnDotNetControl.tlb was created in the output directory.

  6. To use the control on another computer:
    1. copy the DLL file and the TLB file to the target computer
    2. register the files via the command line:
      %windir%\Microsoft.NET\Framework\v2.0.50727\regasm.exe zenOnDotNetControl.dll /tlb:zenOnDotNetControl.tlb
  7. Add the extended Windows Form Control as ActiveX control to the zenon Editor:


Work via VBA with ActiveX in the Editor

Manual -> Controls -> ActiveX -> Example :NET control as ActiveX (C#) -> Work via VBA with ActiveX in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To access the properties of the control in the zenon Editor:

  1. In the zenon Editor in node Programming interfaces/VBA macros create a new Init macro with the name Init_ActiveX.

    In this macro you can access all external properties via obElem.ActiveX.

  2. Assign his macro to the ActiveX control via properties VBA macros/Init of the ActiveX element.

Example Init macro

Public Sub Init_ActiveX(obElem As Element)

obElem.AktiveX.Usertext = "Set the string to the control"

End Sub


Connect zenon variables with the .NET user control

Manual -> Controls -> ActiveX -> Example :NET control as ActiveX (C#) -> Connect zenon variables with the .NET user control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In zenon you have the possibility to enhance an ActiveX control with special functions in order to access the zenon API.

Necessary methods

  • public bool zenOnInit (Is called up during control initializing in the zenon Runtime.)
  • public bool zenOnInitED (Is used in the Editor.)
  • public bool zenOnExit() (Is called up during control destruction in the zenon Runtime.)
  • public bool zenOnExitED() (Is used in the Editor.)
  • public short CanUseVariables() (Supports linking variables.)
  • public short VariableTypes() (Supported data types by the control)
  • public MaxVariables()(Maximum number of variables which can be linked to the control.)

Add reference

  1. Select in Microsoft Visual Studio under Add References the zenon Runtime object library in order to be able to access the zenon API in the control.

  2. Add the enhanced functions in the class code of the control in order to access the whole zenon API.

    In our example the COM object of a zenon variable is temporarily saved in a Member in order to access it later in the Paint event of the control.

Other topics in this chapter

public bool zenOnInit(zenOn.Element dispElement)

public bool zenOnInitED(zenOn.Element dispElement)

public bool zenOnExit()

public bool zenOnExitED()

public short CanUseVariables()

public short VariableTypes()

public MaxVariables()


public bool zenOnInit(zenOn.Element dispElement)

Manual -> Controls -> ActiveX -> Example :NET control as ActiveX (C#) -> Connect zenon variables with the .NET user control -> public bool zenOnInit(zenOn.Element dispElement)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this method (in the Runtime) the ActiveX control gets a pointer to the dispatch interface of the dynamic element. With this pointer zenon variables linked to the dynamic element can be accessed.

You can configure the sequence of the sent variables in the Enter Element dialog with the buttons down or up. The dialog "element input" opens if:

  • you double click the ActiveX element or
  • select Properties in the context menu or
  • select the ActiveX settings property in the Representation node of the property window


public bool zenOnInitED(zenOn.Element dispElement)

Manual -> Controls -> ActiveX -> Example :NET control as ActiveX (C#) -> Connect zenon variables with the .NET user control -> public bool zenOnInitED(zenOn.Element dispElement)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Equals public bool zenOnInit and is executed when opening the ActiveX in the Editor (double click on ActiveX).


public bool zenOnExit()

Manual -> Controls -> ActiveX -> Example :NET control as ActiveX (C#) -> Connect zenon variables with the .NET user control -> public bool zenOnExit()

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This method is called by the zenon Runtime when the ActiveX control is closed. Here all dispatch pointers on variables should be released.


public bool zenOnExitED()

Manual -> Controls -> ActiveX -> Example :NET control as ActiveX (C#) -> Connect zenon variables with the .NET user control -> public bool zenOnExitED()

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Equals public bool zenOnExit() and is executed in closing the ActiveX in the Editor. With this you can react to changes, e.g. value changes, in the Editor.


public short CanUseVariables()

Manual -> Controls -> ActiveX -> Example :NET control as ActiveX (C#) -> Connect zenon variables with the .NET user control -> public short CanUseVariables()

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This method returns 1 if the control can use zenon variables and 0 if it cannot.

  • 1: For the dynamic element (via button Variable) you can only state zenon variables with the type stated via method VariableTypes in the number stated by method MaxVariables.
  • 0: If CanUseVariables returns 0 or the control does not have this method, any number of variables of all types can be defined without limitations. In the Runtime however they only can be used with VBA.


public short VariableTypes()

Manual -> Controls -> ActiveX -> Example :NET control as ActiveX (C#) -> Connect zenon variables with the .NET user control -> public short VariableTypes()

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The value returned by this method is used as a mask for the usable variable types in the variable list. The value is an AND relation from the following values (defined in zenon32/dy_type.h):

Parameters | Value | Description
WORD | 0x0001 | corresponds to position 0
BYTE | 0x0002 | corresponds to position 1
BIT | 0x0004 | corresponds to position 2
DWORD | 0x0008 | corresponds to position 3
FLOAT | 0x0010 | corresponds to position 4
DFLOAT | 0x0020 | corresponds to position 5
STRING | 0x0040 | corresponds to position 6
IN_OUTPUT | 0x8000 | corresponds to position 15


public MaxVariables()

Manual -> Controls -> ActiveX -> Example :NET control as ActiveX (C#) -> Connect zenon variables with the .NET user control -> public MaxVariables()

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Here the number of variables is defined, that can be selected from the variable list:

1: Multi-select is disabled in the variable list. A warning is displayed when several variables are selected anyway.


.NET user controls

Manual -> Controls -> .NET user controls

With .NET control the functionality of the zenon Runtime and Editor can be enhanced autonomously.

In this manual you can find:

  • Difference between control container and ActiveX
  • Example .NET control container
  • Example :NET control as ActiveX (C#)

You can find information about .NET controls in ActiveX in manual Screens in chapter .NET controls.


Different use .NET Control in Control Container or ActiveX

Manual -> Controls -> .NET user controls -> Different use .NET Control in Control Container or ActiveX

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A .NET user control can:

  • be integrated directly in the zenon ActiveX element via the CD_DotNetControlContainer control
  • be used as ActiveX control and be integrated directly in the zenon ActiveX element

Above all the differences between container control and ActiveX control are:

CD_DotNetControlContainer control

ActiveX control

  • Does not have to be registered at the computer.
  • Must be registered as Active X at the computer (regsrv32).
  • For changes at the controller only the DLL must be changed.
  • For changes at the controller the TLB must be registered again.
  • Access via VBA and VSTA only possible via the CD_DotNetControlContainer method.
  • Easy access via VBA and VSTA.


Example .NET control container

Manual -> Controls -> .NET user controls -> Example .NET control container

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tutorial you get to know how to create a simple .NET user control in Visual Studio 2010 (programming language C#) and how to integrate it with the help of the zenon CD_DotNetControlContainer control as ActiveX in a zenon ActiveX element.


General

Manual -> Controls -> .NET user controls -> Example .NET control container -> General

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The CD_DotNetControlContainer therefore acts as a wrapper between the user control and the zenon ActiveX element. All methods used in the following example and all public methods and properties are passed on via the CD_DotNetControlContainer from the user control to the ActiveX and can be used by zenon; also in VBA and VSTA.

If there is a reference to the zenon programming interface in the user control, you can directly access >CD_PRODUCTNAME< objects.

In the following example we will:

  • create .NET user control
  • add a CD_DotNetControlContainer and a .NET User Control
  • enable the access to the user control via VSTA (VBA)

Path for DLL in Editor and Runtime

The path to .Net DLL that is selected in the Editor is also used in Runtime. It is set as absolute and cannot be changed.

Ensure that the same path is used on all computers in the zenon network for Editor and Runtime.
Hint: Select an absolute path, for example: C:\Controls. Enter the path as fixed in Remote Transport and in the .NET Control Container. Use Remote Transport to harmonize this path with all computers.

Other topics in this chapter

public bool zenOnInit(zenOn.Element dispElement)

public bool zenOnExit()

public short CanUseVariables()

public short VariableTypes()

public MaxVariables()


public bool zenOnInit(zenOn.Element dispElement)

Manual -> Controls -> .NET user controls -> Example .NET control container -> General -> public bool zenOnInit(zenOn.Element dispElement)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this method (in the Runtime) the ActiveX control gets a pointer to the dispatch interface of the dynamic element. With this pointer zenon variables linked to the dynamic element can be accessed.

You can configure the sequence of the sent variables in the Enter Element dialog with the buttons down or up. The dialog "element input" opens if:

  • you double click the ActiveX element or
  • select Properties in the context menu or
  • select the ActiveX settings property in the Representation node of the property window


public bool zenOnExit()

Manual -> Controls -> .NET user controls -> Example .NET control container -> General -> public bool zenOnExit()

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This method is called by the zenon Runtime when the ActiveX control is closed. Here all dispatch pointers on variables should be released.


public short CanUseVariables()

Manual -> Controls -> .NET user controls -> Example .NET control container -> General -> public short CanUseVariables()

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This method returns 1 if the control can use zenon variables and 0 if it cannot.

  • 1: For the dynamic element (via button Variable) you can only state zenon variables with the type stated via method VariableTypes in the number stated by method MaxVariables.
  • 0: If CanUseVariables returns 0 or the control does not have this method, any number of variables of all types can be defined without limitations. In the Runtime however they only can be used with VBA.


public short VariableTypes()

Manual -> Controls -> .NET user controls -> Example .NET control container -> General -> public short VariableTypes()

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The value returned by this method is used as a mask for the usable variable types in the variable list. The value is an AND relation from the following values (defined in zenon32/dy_type.h):

Parameters | Value | Description
WORD | 0x0001 | corresponds to position 0
BYTE | 0x0002 | corresponds to position 1
BIT | 0x0004 | corresponds to position 2
DWORD | 0x0008 | corresponds to position 3
FLOAT | 0x0010 | corresponds to position 4
DFLOAT | 0x0020 | corresponds to position 5
STRING | 0x0040 | corresponds to position 6
IN_OUTPUT | 0x8000 | corresponds to position 15


public MaxVariables()

Manual -> Controls -> .NET user controls -> Example .NET control container -> General -> public MaxVariables()

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Here the number of variables is defined, that can be selected from the variable list:

1: Multi-select is disabled in the variable list. A warning is displayed when several variables are selected anyway.


Create .NET user control

Manual -> Controls -> .NET user controls -> Example .NET control container -> Create .NET user control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The user control is a simple control which can set a new value via an input field (text box). After clicking the button, the value is written to the desired zenon variable.

An additional function should automatically detect the change of value of the variable in zenon and display the new value automatically in the control.

Work steps

  1. First you create a new project in VS and use project type „Windows Forms Control Library“

    Important: Set framework to 3.5!

  2. After that rename the CS file from "UserControl" to "zenon_CD_DotNetControlContainer.cs". The files Designer.cs and the .resx are renamed automatically.

  3. In the next step you create the user control. For this use two text boxes one each for the input and the output and a button for writing new values to the zenon variable.
    Name:
    • the first text box "txtGetZenonVariable"
    • the second text box "txtSetZenonVariable"
    • the button "btnSetZenonVariable"

  4. In order to access zenon objects you need a reference to the <CD_PRODUCNAME> Programming Interface. To do this:
    • click on node "References" in the Solution Explorer
    • open the context menu
    • select Add References...
    • switch to tab COM
    • select zenon programming interface library

    After that the "zenOn" reference should be visible in the reference list.

  5. In the next step create a global variable of type zenon.variable in the code of the zenon_CD_DotNetControlContainer.cs:

  6. This variable is initialized via public method zenOnInit:

    and enabled via public method zenOnExit:

    In the following methods we define whether <CD_PRODUTCNAME> variables and data types are used and how many variables may be handed over:

  7. In the next step define in the Click-Event of button btnSetZenonVariable that when you click the button the value of text box txtSetZenonVariable is written to the zenon variable and then the content of the text box is deleted.

  8. To react to a value change of the variable, you need the Paint Event of the control. The Paint Event is also triggered if the value of the initialized zenon variable changes and it can therefore be used to update values. As variables which are referenced in the zenon ActiveX element are automatically advised, you can generally refrain from using the zenon.OnlineVariable container in the control.

The code at a glance

Here is the whole code as review:

using System;

using System.Collections.Generic;

using System.ComponentModel;

using System.Drawing;

using System.Data;

using System.Linq;

using System.Text;

using System.Windows.Forms;

using zenOn;

namespace zenon_CD_DotNetControlContainer

{

public partial class zenon_CD_DotNetControlContainer : UserControl

{

//This will be needed to get the zenon Variable Container

zenOn.Variable m_cVal = null;

public zenon_CD_DotNetControlContainer()

{

InitializeComponent();

}

/// <summary>

/// This public Method will be called by the initialization of the control during

/// the zenon Runtime.

/// </summary>

/// <param name="dispElement"></param>

/// <returns></returns>

public bool zenOnInit(zenOn.Element dispElement)

{

//Check if zenon Variables are added to the

//Control

if (dispElement.CountVariable > 0)

{

try

{

//Take the first zenon Variable and added

//to the global Variable

m_cVal = dispElement.ItemVariable(0);

}

catch { }

}

return true;

}

/// <summary>

/// This public Method will be calles by the release of the control during

/// the zenon Runtime.

/// </summary>

/// <returns></returns>

public bool zenOnExit()

{

try

{

if (m_cVal != null)

{

//Release the zenon Variable (Com-Object)

System.Runtime.InteropServices.Marshal.FinalReleaseComObject(m_cVal);

m_cVal = null;

}

}

catch { }

return true;

}

/// <summary>

/// This public Method is needed to link zenon Variables

/// to the control.

/// </summary>

/// <returns></returns>

public short CanUseVariables()

{

return 1; // Only tis Variable is supported

}

/// <summary>

/// This public Method returns the Type of

/// supported zenon Variables

/// </summary>

/// <returns></returns>

public short VariableTypes()

{

return short.MaxValue; // all Data Types supported

}

/// <summary>

/// This public Method returns the number of

/// supported zenon Variables

/// </summary>

/// <returns></returns>

public short MaxVariables()

{

return 1; // Only 1 Variable should linked to the Control

}

/// <summary>

/// This will be triggert by clicking the Button. The new Value will

/// be set to the zenon Variable

/// </summary>

/// <param name="sender"></param>

/// <param name="e"></param>

private void btnSetZenonVariable_Click(object sender, EventArgs e)

{

//Set Value from TextBox to the zenon Variable

m_cVal.set_Value(0,txtSetZenonVariable.Text.ToString());

this.txtSetZenonVariable.Text = string.Empty;

}

/// <summary>

/// This will be triggert by painting the User Control or the Value of the Variable changed.

/// After the value of the Variable changed the Control will be new painted and the new Value

/// will be set to the Textbox.

/// </summary>

/// <param name="sender"></param>

/// <param name="e"></param>

private void zenon_CD_DotNetControlContainer_Paint(object sender, PaintEventArgs e)

{

if (m_cVal != null)

{

this.txtGetZenonVariable.Text = m_cVal.get_Value(0).ToString();

return;

}

else

{

this.txtGetZenonVariable.Text = "Variable Value";

return;

}

}

}

}

Create release

AT last create a Release in order to integrate the completed DLL in zenon or in the CD_DotNetControlContainer.

For this it is necessary that you switch from Debug to Release in the settings.


add a CD_DotNetControlContainer and a .NET User Control

Manual -> Controls -> .NET user controls -> Example .NET control container -> add a CD_DotNetControlContainer and a .NET User Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To prepare the zenon project and to add the CD_DotNetControlContainer and the .NET User Control, carry out the following steps:

  1. Create an internal variable of type String and set the string length to 30.

  2. In the zenon project node Project/Files/Others add the DLL of the created .NET user controls.

    The DLL is located in the Visual Studio Project folder under bin\Release\zenon_CD_DotNetControlContainer.dll.

  3. In the project select the ActiveX element and drag it in a zenon screen.
    • The dialog Configuration is opened
    • Select the CD_DotNetControlContainer.Container control.

  4. To embed the .NET user control in the CD_DotNetControlContainer control:
    • Click on button Properties
    • A new dialog is opened

    • Click on button Load in order to select the path of the project folder, for example: C:\ProgramData\COPA-DATA\SQL\9888419d-251e-4595-b396-9be42367997c\FILES\zenon\custom\additional\zenon_CD_DotNetControlContainer.dll

    By adding the DLL to folder additional, the control is automatically transferred when copying or loading the Runtime files to another computer. With this the link is lost.

    Now the .NET user control should be displayed.

    Confirm the dialog by clicking on OK.

  5. In the last step link a variable with the control via button Variables.

    The variable selected first is automatically linked with our globally defined variable (.NET UserControl) via public method zenonInit. The linking with the control is carried out after the Runtime start.

    Then link the internal variable with a text element.

  6. After the Runtime start the control is initially empty.

    If you enter a value in the second text box and then confirm it with button Set zenon variable, the value is written to the zenon variable. (The btnSetZenonVariable_Click event is carried out.)

    This is also displayed in the zenon text element.

    If the value is directly changed in the zenon text element,

    the value is directly written in the first text box via the Paint event of the .NET control.


Accessing the user control via VSTA or VBA

Manual -> Controls -> .NET user controls -> Example .NET control container -> Accessing the user control via VSTA or VBA

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This examples shows the access via VSTA. The procedure is the same as with VBA.

  1. Enhance the control with a label (label) and name it IblzenonInfo. In this label the value of another zenon variable should be displayed. The new value should be set via a VSTA macro.

  2. Enhance the code by a property (Information) and add the properties get and set to the property. They allow you to read and write the text of the label.

  3. Create a new release for our user control and copy it to folder additional of the zenon project.
    Do not forget: Close the zenon Editor before you do this!
    Delete the old DLL and restart the zenon Editor. If the DLL is still in the folder, just delete it a second time. Now you can import the changed DLL. The CD_DotNetContainerControl and the ActiveX are updated automatically.
  4. In the zenon Editor click on the ActiveX and open the property window.

    Now you can see the new property Information in the selection window of the control and you can also set a value.

    This value is also set in the control ("myInformation")

  5. In order to able to work with the CD_DotNetControlContainer in VSTA or VBA, you first need the reference to the control. After VSTA has been opened for the project (ProjectAddin), you must add the reference of the CD_DotNetControlContainer.

    In addition you must also add the Assembly System.Windows.Forms.

  6. With the following code you can set the value of our property Information anew.

  7. Finally:
    • create a new zenon function Execute VSTA macro
    • link the function to a button

    In the Runtime the label is changed from myInformation to New Information by clicking on the button.

    And back when you click the button again.


Example :NET control as ActiveX (C#)

Manual -> Controls -> .NET user controls -> Example :NET control as ActiveX (C#)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following example describes a .NET control which is executed as ActiveX control in zenon.

The creation and integration is carried out in four steps:

  1. Creat Windows Form Control
  2. Change .NET user control to dual control
  3. Work via VBA with ActiveX in the Editor
  4. Connect zenon variables with the .NET user control

Other topics in this chapter

Creat Windows Form Control

Change .NET User Control to dual control

Work via VBA with ActiveX in the Editor

Connect zenon variables with the .NET user control


Creat Windows Form Control

Manual -> Controls -> .NET user controls -> Example :NET control as ActiveX (C#) -> Creat Windows Form Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a Windows Form Control:

  1. Start Visual Studio 2008 and create a new Windows Form Control Library project:

  2. Rename the default control to the desired control name.
    In our example: SampesControl.cs.

  3. Open the Control Designer and add the desired control; in our case a text box:

  4. Normally controls have properties. Open the Code Designer via View Code and ass the desired properties which should be available externally.
    In our example: Externally visible property „UserText" with get and set access which contains the text of the text box:

  5. Compile the project.

    The Windows Forms Control can now be used in other Windows Forms projects.

    Important: The control must be inserted manually in the control tool box via Choose Items.


Change .NET User Control to dual control

Manual -> Controls -> .NET user controls -> Example :NET control as ActiveX (C#) -> Change .NET User Control to dual control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To change the .NET in a dual control, you must first activate the COM interface for ActiveX.

  1. Open the project and activate property Register for COM interop in the Build settings:

  2. Open the file AssemblyInfo.cs and
    • set attribute ComVisible to true
    • add attribute ClassInterface

    [assembly: ComVisible(true)]

    [assembly: ClassInterface(ClassInterfaceType.AutoDual)]

  3. Open the code designer via View Code and add the necessary ActiveX attributes and using entries. Via menu Tools/Create GUID create a new GUID for the GUID attribute:

  4. For the control to be selectable as Active X user interface control, you must add the functions to the following control classes:
    • RegisterClass
    • UnregisterClass

    After that you can register the control in the registry.

  5. Compile the project again.

    The Windows Form Control is now ActiveX-able and was registered automatically during the rebuild. An additional typelib file zenOnDotNetControl.tlb was created in the output directory.

  6. To use the control on another computer:
    1. copy the DLL file and the TLB file to the target computer
    2. register the files via the command line:
      %windir%\Microsoft.NET\Framework\v2.0.50727\regasm.exe zenOnDotNetControl.dll /tlb:zenOnDotNetControl.tlb
  7. Add the extended Windows Form Control as ActiveX control to the zenon Editor:


Work via VBA with ActiveX in the Editor

Manual -> Controls -> .NET user controls -> Example :NET control as ActiveX (C#) -> Work via VBA with ActiveX in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To access the properties of the control in the zenon Editor:

  1. In the zenon Editor in node Programming interfaces/VBA macros create a new Init macro with the name Init_ActiveX.

    In this macro you can access all external properties via obElem.ActiveX.

  2. Assign his macro to the ActiveX control via properties VBA macros/Init of the ActiveX element.

Example Init macro

Public Sub Init_ActiveX(obElem As Element)

obElem.AktiveX.Usertext = "Set the string to the control"

End Sub


Connect zenon variables with the .NET user control

Manual -> Controls -> .NET user controls -> Example :NET control as ActiveX (C#) -> Connect zenon variables with the .NET user control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In zenon you have the possibility to enhance an ActiveX control with special functions in order to access the zenon API.

Necessary methods

  • public bool zenOnInit (Is called up during control initializing in the zenon Runtime.)
  • public bool zenOnInitED (Is used in the Editor.)
  • public bool zenOnExit() (Is called up during control destruction in the zenon Runtime.)
  • public bool zenOnExitED() (Is used in the Editor.)
  • public short CanUseVariables() (Supports linking variables.)
  • public short VariableTypes() (Supported data types by the control)
  • public MaxVariables()(Maximum number of variables which can be linked to the control.)

Add reference

  1. Select in Microsoft Visual Studio under Add References the zenon Runtime object library in order to be able to access the zenon API in the control.

  2. Add the enhanced functions in the class code of the control in order to access the whole zenon API.

    In our example the COM object of a zenon variable is temporarily saved in a Member in order to access it later in the Paint event of the control.

Other topics in this chapter

public bool zenOnInit(zenOn.Element dispElement)

public bool zenOnInitED(zenOn.Element dispElement)

public bool zenOnExit()

public bool zenOnExitED()

public short CanUseVariables()

public short VariableTypes()

public MaxVariables()


public bool zenOnInit(zenOn.Element dispElement)

Manual -> Controls -> .NET user controls -> Example :NET control as ActiveX (C#) -> Connect zenon variables with the .NET user control -> public bool zenOnInit(zenOn.Element dispElement)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this method (in the Runtime) the ActiveX control gets a pointer to the dispatch interface of the dynamic element. With this pointer zenon variables linked to the dynamic element can be accessed.

You can configure the sequence of the sent variables in the Enter Element dialog with the buttons down or up. The dialog "element input" opens if:

  • you double click the ActiveX element or
  • select Properties in the context menu or
  • select the ActiveX settings property in the Representation node of the property window


public bool zenOnInitED(zenOn.Element dispElement)

Manual -> Controls -> .NET user controls -> Example :NET control as ActiveX (C#) -> Connect zenon variables with the .NET user control -> public bool zenOnInitED(zenOn.Element dispElement)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Equals public bool zenOnInit and is executed when opening the ActiveX in the Editor (double click on ActiveX).


public bool zenOnExit()

Manual -> Controls -> .NET user controls -> Example :NET control as ActiveX (C#) -> Connect zenon variables with the .NET user control -> public bool zenOnExit()

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This method is called by the zenon Runtime when the ActiveX control is closed. Here all dispatch pointers on variables should be released.


public bool zenOnExitED()

Manual -> Controls -> .NET user controls -> Example :NET control as ActiveX (C#) -> Connect zenon variables with the .NET user control -> public bool zenOnExitED()

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Equals public bool zenOnExit() and is executed in closing the ActiveX in the Editor. With this you can react to changes, e.g. value changes, in the Editor.


public short CanUseVariables()

Manual -> Controls -> .NET user controls -> Example :NET control as ActiveX (C#) -> Connect zenon variables with the .NET user control -> public short CanUseVariables()

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This method returns 1 if the control can use zenon variables and 0 if it cannot.

  • 1: For the dynamic element (via button Variable) you can only state zenon variables with the type stated via method VariableTypes in the number stated by method MaxVariables.
  • 0: If CanUseVariables returns 0 or the control does not have this method, any number of variables of all types can be defined without limitations. In the Runtime however they only can be used with VBA.


public short VariableTypes()

Manual -> Controls -> .NET user controls -> Example :NET control as ActiveX (C#) -> Connect zenon variables with the .NET user control -> public short VariableTypes()

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The value returned by this method is used as a mask for the usable variable types in the variable list. The value is an AND relation from the following values (defined in zenon32/dy_type.h):

Parameters | Value | Description
WORD | 0x0001 | corresponds to position 0
BYTE | 0x0002 | corresponds to position 1
BIT | 0x0004 | corresponds to position 2
DWORD | 0x0008 | corresponds to position 3
FLOAT | 0x0010 | corresponds to position 4
DFLOAT | 0x0020 | corresponds to position 5
STRING | 0x0040 | corresponds to position 6
IN_OUTPUT | 0x8000 | corresponds to position 15


public MaxVariables()

Manual -> Controls -> .NET user controls -> Example :NET control as ActiveX (C#) -> Connect zenon variables with the .NET user control -> public MaxVariables()

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Here the number of variables is defined, that can be selected from the variable list:

1: Multi-select is disabled in the variable list. A warning is displayed when several variables are selected anyway.


WPF element

Manual -> Controls -> WPF element

With the WPF dynamic element, valid WPF/XAML files in zenon can be integrated and displayed.

info Information

All brand and product names in this documentation are trademarks or registered trade marks of the respective title holder.


Basics

Manual -> Controls -> WPF element -> Basics

XAML

XAML stands for Extensible Application Markup Language. The description language developed by Microsoft and based on XML defines the syntax in Silverlight applications and WPF user interfaces. XAML makes it possible to separate design and programming. The designer prepares the graphical user interface and creates basic animations that are then used by the developers/project planners. The project planner can control these .xaml files in a purposeful manner and animate them accordingly.

WPF

WPF stands for Windows Presentation Foundation and describes a graphics framework that is part of the Windows .NET framework:

  • WPF displays the programming environment.
  • XAML describes, based on XML, the interface hierarchy as a markup language. Depending on the construction of the XAML file, there is the possibility to link properties, events and transformations of WPF elements with variables and functions of
    CD_PRODUCTNAME<.
  • The framework unites the different areas of presentation such as user interface, drawing, graphics, audio, video, documents and typography.

Microsoft .NET 3.5 or higher is required for execution.


WPF in process visualization

Manual -> Controls -> WPF element -> Basics -> WPF in process visualization

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

XAML makes different design possibilities possible for zenon. Display elements and dynamic elements can be adapted graphically regardless of the project planning. For example, laborious illustrations are first created by designers and then imported into zenon as an XAML file and linked to the desired logic. There are many possibilities for using this, for example:

Dynamic elements in analog-look

Graphics no longer need to be drawn in zenon, but can be imported directly as an XAML file. This makes it possible to use complex, elaborately illustrated elements in process visualization. Reflections, shading, 3D effects etc. are supported as graphics. The elements that are adapted to the respective industry environment make intuitive operation possible, along the lines of the operating elements of the machine.

Intricate illustrations for intuitive operation

The integration of XAML-based display elements improves the graphics of projects and makes it very easy to display processes clearly. Elements optimized for usability make operation easier. A clear display of data makes it easier to receive complex content. The flexible options for adapting individual elements makes it easier to use for the operator. It is therefore possible for the project planners to determine display values, scales and units on their own.

Clear presentation of data and summaries

Grouped display elements make it possible to clearly display the most important process data, so that the equipment operator is always informed of the current process workflow. Graphical evaluations, display values and sliders can be grouped into an element and make quick and uncomplicated control possible.

Industry-specific displays

Elements such as thermometers, scales or bar graphs are part of the basic elements of process visualization. It is possible, using XAML, to adapt these to the respective industry. Thus equipment operators can find the established and usual elements that they already know from the machines in process visualization at the terminal.

Adaptation to corporate design

Illustrations can be adapted to the respective style requirements of the company, in order to achieve a consistent appearance through to the individual process screen. For example, the standard operation elements from zenon can be used, which can then be adapted to color worlds, house fonts and illustration styles of the corporate design.


Transfer of values from zenon to WPF

Manual -> Controls -> WPF element -> Basics -> Transfer of values from zenon to WPF

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon always works internally with the double or string. These are sent to the WPF element. The WPF element is embedded in a .NET container. It usually needs to be converted so that the data type can be used. This conversion can automatically be carried out by .NET.

The values are sent in accordance with the following rules:

  • If the .NET type (System.Object) for zenon is not evident, the value is sent as it is to .NET. .NET must take care of the display or conversion itself.
  • If the .NET type is a Boolean type (System.Boolean), then zenon writes according to the .NET convention 0 or -1.
  • If the .NET type is known, a check is carried out to see if .NET can convert the value. The converter from .NET is used for this.
    • Yes: The value is sent.
    • No: The value is sent nevertheless. If .NET reacts with an error message, the value of zenon is converted into a string and sent again.


Referenced objects

Manual -> Controls -> WPF element -> Basics -> Referenced objects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In WPF not only standard objects such as rectangles, buttons, text fields, etc. can be used, but also WPF user controls, which are referenced as assemblies.

WPF user controls are individually created objects. For example, this element can look like a tacho and provide special properties and optical effects, such as a "Value" property, which causes the pointer of the tacho to move and display the value when it is set.

The workflow for this:

  • The appearance of a user controls is labeled with standard objects, which are offered by WPF.
  • The properties and interactions are programmed.
  • The whole package is compiled and present in the form of a .NET assembly.

This assembly can also be used for WPF projects. To do this, it must be referenced (linked) in the WPF editor (for example: Microsoft Expression Blend). To do this, select the assembly in the zenon file selection dialog:

From this point in time, the WPF user controls of the assembly in the tool box can be selected under Custom user controls and used in the WPF project.

Used referenced assemblies in zenon

To use an assembly in zenon, this must be provided as a file.
Collective files in .cdwpf format administer these independently; no further configuration is necessary. Assemblies must be added to the Files folder for .xaml files:

  • Click on Files on the project tree
  • Select Other
  • Select Add file... in the context menu
  • The configuration dialog opens
  • Insert the desired assembly

When displaying a WPF file in the WPF element (Editor and Runtime), the assemblies from this folder are loaded. It is thus also ensured that that when the Runtime files are transferred using Remote Transport, all referenced assemblies are present on the target computer.

A collective file (.cdwpf) can exist alongside an XAML file with the same name. All assemblies (*.dll) from all collective files and the Other folder are copied to the work folder. Only the highest file version is used if there are several assemblies with the same name.

attention Attention

Assemblies are only only removed after loading when the application is ended. That means:

If a WPF file with a referenced assembly in zenon is displayed, then this assembly is loaded is in the memory until zenon is ended, even if the screen is closed again. If you would like to remove an assembly from the Files/Other folder, the Editor must first be restarted, so that the assembly is removed.

Multi-project administration

With multi-project administration, the same assembly must be used in all projects. If an assembly is replaced by another version in a project, it must also be replaced in all other projects that are loaded in the Editor or in Runtime.


Allocation of zenon object to WPF content

Manual -> Controls -> WPF element -> Basics -> Allocation of zenon object to WPF content

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon objects are allocated to WPF content using the name of the WPF object. In doing so, note:

Visual objects do not have a RuntimeNamePropertyAttribute property. Therefore at the time when the WPF content is loaded and created, the additional information of name is not available.

Thus a clear allocation of zenon objects to WPF objects is not possible. Therefore only logical objects are listed in the configuration dialog of zenon. Which WPF objects the RuntimeNamePropertyAttribute has available is visible in MSDN or on the Microsoft website.

Workaround

Nevertherless, the following workaround is possible to animate visual objects:

For visual elements, the animateable property is linked to the text property of an invisible text box using a data connection.

Because the text box as a logical object supports the name property, this is displayed in zenon.

The textbox property can also be animated with zenon.

This visual object is also indirectly animated as a result.


Workflows

Manual -> Controls -> WPF element -> Basics -> Workflows

The WPF/XAML technology makes new workflows in process visualization possible. The separation of design and functionality ensures a clear distinction of roles between the project planners and designers; design tasks can be easily fulfilled by using pre-existing designs, which no longer need to be modified by the project planner.

The following people are involved in the workflow to create WPF elements in zenon:

  • Designer
    • illustrates elements
    • takes care of the graphics for MS Expression Design
  • MS Expression Blend operator
    • Animates elements
    • Creates variables for the animation of WPF elements in zenon, which project planners can access
  • Project planner
    • Integrates elements into zenon:
    • stores logic and functionality

We make a distinction:

  • Workflow with Microsoft Expression Blend
  • Workflow with Adobe Illustrator


Workflow with Microsoft Expression Blend

Manual -> Controls -> WPF element -> Basics -> Workflows -> Workflow with Microsoft Expression Blend

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When using Microsoft Expression Blend, a WPF element is created in four stages:

  1. Illustration of elements in MS Expression Blend
  2. Open element in MS Expression Design and export as WPF
  3. Animation in MS Expression Blend
  4. Integration into zenon

You can find an example for creating a WPF elements with Microsoft Expression Blend in the Create button as XAML file with Microsoft Expression Blend chapter.


Workflow with Adobe Illustrator

Manual -> Controls -> WPF element -> Basics -> Workflows -> Workflow with Adobe Illustrator

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Based on traditional design processes with Adobe Illustrator the following workflow is available:

  1. Illustration of elements in Adobe Illustrator
  2. Import of .ai files and preparation in MS Expression Design
  3. WPF export from MS Expression Design
  4. Animation in MS Expression Blend
  5. Integration into zenon

You can find an example for creation in the Workflow with Adobe Illustrator chapter.


Guidelines for designers

Manual -> Controls -> WPF element -> Guidelines for designers

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This section informs you how to correctly create WPF files in Microsoft Expression Blend and Adobe Illustrator. The tutorials on Creating a button element and a bar graph element show you how fully functional WPF files for zenon can be created from pre-existing graphics in a few steps.

The following tools were used for this:

  • Adobe Illustrator CS3 (AI)
  • Microsoft Expression Design 4 (ED)
  • Microsoft Expression Blend 4 (EB)
  • zenon 6.51

info Information

If referenced objects (assemblies) are used in WPF, note the instructions in the Referenced objects chapter.


Workflow with Microsoft Expression Blend

Manual -> Controls -> WPF element -> Guidelines for designers -> Workflow with Microsoft Expression Blend

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With Microsoft Expression Blend, a WPF element:

  • is illustrated
  • is converted into WPF format using MS Expression Design
  • animated

The following example shows the illustration and conversion of a button element into an XAML file.

Note: A test version of "Microsoft Expression Blend" can be downloaded from the Microsoft website.


Create button as an XAML file with Microsoft Expression Blend

Manual -> Controls -> WPF element -> Guidelines for designers -> Workflow with Microsoft Expression Blend -> Create button as an XAML file with Microsoft Expression Blend

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Create button

  1. Start Expression Blend
  2. select the New Project option

  3. Select WPF as project type
  4. give it a path and name of your choice (MyBlendProject, for example)

    The Language and Version settings can be ignored, because no functionality is to be programmed.

  5. After the dialog has been confirmed with OK, Microsoft Blend creates a new project with the chosen settings. Expression Blend adds an empty XAML file which already contains a class reference.
  6. Delete the CS file that belongs to the XAML file using the context menu.
  7. Rename the XAML file MainControl.xaml to MyButton.xaml.
  8. The development size of the file is set at 640 x 480 pixels as standard and must still be changed:
    1. switch to XAML view
    2. correct the size to 100 x 100 pixels
    3. Delete the class reference x:Class="MyBlendProject.MyButton"

  9. switch to Design view

  10. add a button via the tool bar
  11. define the properties
    • Width: 50
    • Height: 50
    • Margins: 25

    The button is therefore at the center of the control.

  12. Save the changes and open the file in Internet Explorer to check it. You will see that the button is displayed in a size of 50 x 50 pixels.

Make button scalable

If you integrate this status into zenon, the button will always have the exact size of 50 x 50 pixels. Because the button can be implemented as a scalable button, switch to Expression Blend again:

  1. select the button in the tree view
  2. select the Group Into->Viewbox button in the context menu
  3. the button is inserted into a Viewbox
  4. Define the properties of the viewbox
    • Width: Auto
    • Height: Auto
  5. save the file

  6. If you now open the file in Internet Explorer, the button is automatically scaled when the IE window size is changed. This file will now also automatically adapt to changes in the size of the WPF element in zenon.

Change name

Before you can integrate the file into zenon, you must give the WPF element a name. The WPF elements are not named in Expression Blend as standard, and are labeled with square brackets and their type. zenon content is assigned to WPF content via the name of the WPF elements:

  • in tree view, change the name
    • of the button on MyButton
    • of the ViewBox to MyViewBox

This button can now be integrated in zenon as an XAML file.


Workflow with Adobe Illustrator

Manual -> Controls -> WPF element -> Guidelines for designers -> Workflow with Adobe Illustrator

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When Adobe Illustrator is used, a WPF element:

  • is illustrated in Adobe Illustrator
  • is converted into a WPF in MS Expression Design
  • is animated in MS Expression Blend

The following example shows the illustration and conversion of a bar graph element into an XAML file.


Bar graph illustration

Manual -> Controls -> WPF element -> Guidelines for designers -> Workflow with Adobe Illustrator -> Bar graph illustration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A bar graph is created in Adobe Illustrator.

  1. AI: Starting element for bar graph

    Illustrated in Adobe Illustrator CS3.

  2. AI: Path view of bar graph in Adobe Illustrator

    • All effects must be converted (Object -> Convert appearance)
    • All lines are transformed into paths (Object -> Path -> Contour line)
    • Do not use filters such as shading, blurring etc.

Notes on compatibility

Illustrations that were created with Adobe Illustrator are in principle suitable for WPF export. However, not all Illustrator effects can become corresponding effects in Expression Design/Blend. Note:

Effect

Description

Clipping masks

Clipping masks created in Adobe Illustrator are not correctly interpreted by Expression Design. These are usually shown in Blend as areas of black color.

We recommend creating illustrations without clipping masks.

Filters and effects

Not all Adobe Illustrator filters are transferred into Expression Design accordingly: Thus blurring filters, shading filters and corner effects from Illustrator do not work in Expression Design.

Solution:

  • Most effects can be converted so that they can be read correctly by Expression Design using the Object -> Convert appearance command in Adobe Illustrator.
  • Corner effects from Adobe Illustrator are correctly interpreted by MS Design if they are converted to AI in paths.

Text fields

To be able to link text fields with code, these must be created separately in Expression Blend. "Labels" are required for dynamic texts; simple "text fields" are sufficient for static information.

There is no possibility to create text labels in MS Design. These must be directly created in MS Blend.

Transparencies and group transparencies

There can be difficulties in Adobe Illustrator with the correct interpretation of transparency settings, in particular from group transparency settings.

However MS Expression Blend and MS Expression Design do offer the possibility to create new transparency settings.

Multiply levels

These level settings in Adobe Illustrator are not always correctly displayed by MS Expression Blend.

However, there is the possibility to "Multiply levels" directly in Expression Design.

Indicating instruments and standard positions

To prepare the graphics optimally for animation, the indicator and slider must always be set to the starting position, usually 0 or 12:00 o'clock.

Thus the position parameters for rotations etc. are also correct in Blend and an animation can be implemented without conversion of position data.


WPF export

Manual -> Controls -> WPF element -> Guidelines for designers -> Workflow with Adobe Illustrator -> WPF export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

WPF files are required for animation in Microsoft Expression Blend. We recommend Microsoft Expression Design for this export, because it provides good results and most Illustrator effects are correctly interpreted.

Note: There is a free plug-in for the direct export of WPF files from Adobe Illustrator available on the internet. This plug-in provides a quick, uncomplicated way of exporting from Illustrator, however it is less suited to the current application because it lead to graphical losses. Even color deviations from the original document are possible.

Files in .ai format can regularly be imported into Expression Design; the paths are retained in the process.
Attention: Some common Illustrator effects cannot be displayed by Expression Design correctly however (see Illustration chapter).

We export the pre-created bar graph element in 5 stages:

  1. ED: Import
    • Import the prepared Illustrator file in Microsoft Expression Design via File -> Import
  2. ED: Optimization

    • If the starting file is not correctly displayed in MS Expression Design, it can still be subsequently edited and optimized here
  3. ED: Select

    • Highlight the element for WPF export with the direct selection arrow in MS Expression Design; in this case it is the whole clock
  4. ED: Start export

    • Start the export via File -> Export
    • the dialog for configuring the export settings opens
  5. ED: Export settings

    • Enter the following export settings:
    1. Format: XAML Silverlight 4 / WPF Canvas

      Always name objects: Activate with tick

      Place the grouped object in an XAML layout container: Activate with tick

    2. Text: Editable text block
    3. Line effects: Rasterize all

The exported file has .xaml file suffix. It is prepared and animated in MS Expression Blend in the next stage.


Animation in Blend

Manual -> Controls -> WPF element -> Guidelines for designers -> Workflow with Adobe Illustrator -> Animation in Blend

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With MS Expression Blend:

  • static XAML files from MS Expression Design are animated
  • Variables for controlling effects that can be addressed by zenon are created

In thirteen steps, we go from a static XAML to an animated element, that can be embedded in zenon:

  1. EB:create project

    1. Open Microsoft Expression Blend
    2. Create a new project
    3. Select the Project type of WPF- >WPF Control Library
    4. Give it a name (in our tutorial: My_Project)
    5. Select a location where it is to be saved
    6. Select a language (in our tutorial: C#)
    7. Select Framework Version 3.5
  2. EB: delete MainControl.xaml.cs

    1. Navigate to MainControl.xaml.cs
    2. Delete this file using the Delete command in the context menu
  3. EB: Open exported XAML file

    1. Open the context menu for My_Project (right mouse button)
    2. Select Add existing element…
    3. Select the XAML file exported from Microsoft Expression Design, in order to open this in Microsoft Expression Blend
  4. EB: Open MainControl.xaml

    1. Open the automatically created MainControl.xaml
    2. In the Objects and Time axes area, navigate to the UserControl entry
  5. EB: Adapt XAML code

    1. Click on UserControl with the right mouse button
    2. Select Display XAML in the contextual menu.
    3. Delete lines 7 and 9 in the XAML code:

      x:Class="My_Project.MainControl"

      d:DesignWidth="640" d:DesignHeight="480"

  6. EB: check XAML code

    • The XAML code should now look like this:

    <UserControl

    xmlns=http://schemas.microsoft.com/winfx/2006/xaml/presentation
    xmlns:x=http://schemas.microsoft.com/winfx/2006/xaml
    xmlns:d=http://schemas.microsoft.com/expression/blend/2008
    xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"

    mc:Ignorable="d"
    x:Name="UserControl">

    <Grid x:Name="LayoutRoot"/>

    </UserControl>

  7. EB: Copy elements

    1. Open the XAML file imported from Expression Design
    2. Mark all elements
    3. Select Delete in the context menu
    4. Change back to the automatically created XAML file
  8. EB: Insert element

    1. Click on Layout Root with the right mouse button
    2. Select Insert
  9. EB: Adapt layout type

    1. Click on Layout root -> Change layout type -> Viewbox with the right mouse button
    2. The structure should now look like this: UserControl -> LayoutRoot -> Grid -> Elements
    3. Give a name for LayoutRoot and Grid by double-clicking on the names
  10. EB: Texts and values

    • Dynamic and static texts are labeled with text fields
    • Values (numbers) are issued with Labels
  11. EB: Insert labels

    • Labels replace numbers that are to be subsequently linked using INT variables (must be carried out for all number elements)
  12. EB: Set property

    • To display 100%, set the bar graph element's MaxHeight property to 341 (the maximum height of the indicator element is 340)
  13. EB: prepare for use in zenon

    1. Delete all name labels (names may only be given for elements that are to be addressed via zenon)
    2. Save the XAML file with any desired name
    3. Integrate the XAML file into zenon

A tip for checking: If the XAML file is displayed with no problems in Microsoft Internet Explorer and the window size of Internet Explorer adapts to it, it will also be correctly used in zenon.


Engineering in zenon

Manual -> Controls -> WPF element -> Engineering in zenon

To use WPF with zenon, Microsoft Framework 3.5 must be installed on both the editor computer and on Runtime.

Conditions for WPF display in zenon

The animation is currently available for simple variables; arrays and structures cannot be animated. Therefore the following WPF functions can be implemented in zenon:

  • Element properties that correspond to simple data types, such as String, Int, Bool etc.
  • Element properties of the "Object" type, which can be set with simple data types
  • Element events can be used with functions; the parameters of the events are not however available in and cannot be evaluated in zenon
  • Element transformation, for which a render transform is present for the element in the XAML file

    Attention: if the content is outside of the area of the WPF element during transformation, this part of the content is lost or is not labeled

Notes on dBase: No shade can be displayed in zenon for WPF elements.

attention Attention

If the Runtime files were created for a project for a version before 6.50, existing WPF elements are not included into Runtime screens.

Display on Windows 7

If a WPF screen contains a slider and Windows 7 Aero Effects are used, this may lead to refresh problems in zenon Editor.


CDWPF files (collective files)

Manual -> Controls -> WPF element -> Engineering in zenon -> CDWPF files (collective files)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Rules for the use of collective files:

  • The files can be in the ZIP file directly or in a joint folder.
  • The name of the XAML file should correspond to the names of the collective file.
  • Only one XAML file may be contained.
  • The preview graphic should be small and no more than 64 pixels high.
    Name of the preview file: preview.png or the name of the XAML file with the suffix png.
  • Any number of assemblies can be used. The distinction is made on the basis of the file version in numerical form.
  • Collective files do not need to contain an assembly.
  • All folders are searched and only *.dll, *.xaml and *.png files are taken into account.
  • If a If a collective file (.cdwpf) is replaced by a file with a different version, all corresponding CDWPF files in all symbols and images in all projects must be adapted.


create WPF element

Manual -> Controls -> WPF element -> Engineering in zenon -> create WPF element

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a WPF element

  1. In the elements toolbar, select the symbol for WPF element or the Elements entry in the menu
  2. Select the start point in the main window.
  3. Pull open the element with the mouse.
  4. In properties, select Representation the propertyXAML file in the group.
  5. The file selection dialog opens.
  6. Select the desired file
    Files of the following formats are valid:
    • *.xaml: Extensible Application Markup Language
    • *.cdwpf: WPF collective file, also shows preview image

    (the file must already be present in the Project Manager under Files/graphics or created in the dialog.)

  7. configure the links.

info Information

If referenced objects (assemblies) are used in WPF, note the instructions in the Referenced objects chapter.


Configuration of the linking

Manual -> Controls -> WPF element -> Engineering in zenon -> Configuration of the linking

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure a WPF element

  1. In properties, select WPF links the propertyConfiguration in the group.
  2. The dialog with three tabs opens with a preview of the XAML file and the elements present in the file

Dialog Configuration

Parameters

Description

Available elements

Shows the named file elements in a tree structure. The selected element can be linked with process data.

WPF is assigned to process data based on the element name. Therefore elements are only shown if they and the attendant elements have a name. Allocations are configured and shown in the Properties, Events, Transformations tabs.

Preview

The selected element is shown flashing in the preview.

Properties

Configuration and display of properties (variables, authorizations, interlockings, linked values).

Events

Configuration and display of events (functions).

Transformations

Configuration and display of transformations.

Name

Name of the property.

Connection

Selection of link.

Link type

Type of link (variable, authorization, function)

WPF info

Shows the current value for properties in WPF content. For the user, it is directly visible what type of property it is (Boolean, string, etc.).

Linked

Shows if a property is currently being used.

Not contained by default in the view, but can be selected using Context menu->Column selection.

info Information

Only logical objects can be displayed in the configuration dialog. Visual objects are not displayed. You can read about backgrounds and how visual objects can be animated in the Allocation of zenon object to WPF content.

Edit hyperlinks

All configured hyperlinks can be edited from the properties of the element. Click on the element and open the property group WPF links. Hyperlinks can be further configured here, without having to open the dialog.

Limitations:

  • The linking type cannot be changed here.
  • New linkings can only be created via the configuration dialog.
  • Insertion of a WPF elements into a symbol: WPF linkings cannot be exported.


Properties

Manual -> Controls -> WPF element -> Engineering in zenon -> Configuration of the linking -> Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The properties enable the linking of:

  • Variables
  • Values
  • Authorizations and interlockings

Parameters |  | Description
Name | Name of the property.
Connection | Linked variable, authorization or linked value. Clicking in the column opens the respective selection dialog, depending on the entry in the Link type column.
Link type | Selection of linking.
WPF info | Shows the current value for properties in WPF content. For the user, it is directly visible what type of property it is (Boolean, string, etc.).
Linked | Shows if a property is currently being used. Not contained by default in the view, but can be selected using Context menu->Column selection.

Create link

To create a link:

  1. Highlight the line with the property that is to be linked
  2. Click in the Link type cell
  3. select the desired link from the drop-down list.

    Available are:

    • <not linked> (deletes an existing link)
    • Authorization/interlocking
    • Variable
    • Value linking
  4. Click in the Link cell
  5. The dialog for configuring the desired link opens

info Information

Properties of WPF and zenon can be different. If, for example the visibility property is linked, there are three values available in .NET:

0 - visible

1 - invisible

2- collapsed

These values must be displayed via the linked zenon variable.


Link variable

Link variable

To link a variable with a WPF property:

  1. Highlight the line with the property that is to be linked
  2. Click in the Link type cell
  3. Select from the variable drop down list
  4. Click in the Link cell
  5. The dialog for configuring the variables opens

This dialog also applies for the selection of variables with transformations. The configuration also makes it possible to convert from zenon into WPF units.

Parameters

Description

Linked variables

Selection of the variable to be linked. A click on the ... button opens the selection dialog.

Value range of WPF element

Data to convert variable values into WPF values.

Convert value range

Active: WPF unit conversion is switched on.

Effect on Runtime: The current zenon value (incl. zenon unit) is converted to the WPF range using standardized minimum and maximum values.

For example: The value of a variable varies from 100 to 200. With the variables, the standardized range is set to 100 - 200. The aim is to display this change in value using a WPF rotary knob. For this:

  • for Transformations, the RotateTransform.Angle property is linked to the variables
  • Adjust value activated
  • a WPF value range of 0 to 360 is configured

Now the rotary knob can be turned at a value of 150, for example, by 180 degrees.

Minimum

Defines the lowest WPF value.

Maximum

Defines the highest WPF value.

OK

Accepts settings and ends the dialog.

Cancel

Discards settings and ends the dialog.

Help

Opens online help.


Link values

Link values

Linked values can either be a string or a numerical value of the double type. When selecting the screen, the selected value is sent in WPF content after loading the WPF content.

attention Attention

The data type of the WPF property need not necessarily be double or string. However only values of the string type or double are sent by zenon. These must be converted to .NET on the WPF page. For details see the Value transfer from zenon to WPF chapter.

To link a value with a WPF property:

  1. Highlight the line with the property that is to be linked
  2. Click in the Link type cell
  3. Select Value linkings from the drop-down list
  4. Click in the Link cell
  5. The dialog for configuration of value linking opens

Parameters

Description

Linked value:

Entry of a numerical value or string value.

Use string

Active: A string value is used instead of a numerical value.

The language of string values can be switched. The text is translated in Runtime when the screen is called up and sent in WPF content. If the language is switched whilst the screen is opened, the string value is retranslated and sent.

String value/numerical value

Depending on what is selected for the Use string property, a numerical value or a string value is entered into this field. For numerical values, a unit of measurement can also be selected.

Unit:

Selection of a unit of measurement from the drop down list. You must have configured this in unit switching beforehand.

The unit of measurement is allocated with the numerical value. If the units are switched in Runtime, the value is converted to the new unit of measurement and sent to WPF content.

OK

Accepts settings and ends the dialog.

Cancel

Discards settings and ends the dialog.

Help

Opens online help.


Link authorization or interlocking

Link authorization or interlocking

Authorizations cannot be granted for the whole WPF element. The element is allocated a user level. Authorizations are granted within the user level for individual controls. If an authorization is active, the value 1 is written to the element.

To link an authorization or interlocking with a WPF property:

  1. Highlight the line with the property that is to be linked
  2. Click in the Link type cell
  3. Select Authorization/interlocking from the drop down menu
  4. Click in the Link cell
  5. The dialog for configuring the authorizations opens

Parameters | Description
Link authorization/interlocking | Setting the authorizations.
Linked status | selection of an authorization that is linked to a WPF control from the drop down list. For example, visibility and operability of a WPF button can depend on a user's status.

Authorization | Description
Authorization available | If the user has sufficient rights to operate the WPF element, a value of 1 is written to the property.
Authorization does not exist | If the user does not have sufficient rights to operate the WPF element, a value of 1 is written to the property.
Not interlocked | If the element is not locked, the value 1 is written to the property.
Interlocked | If the element is locked, the value 1 is written to the property.
Can be operated | If authorization is present and the element is not locked, then a value of 1 is written to the property.
Cannot be operated | If authorization is not present or the element is not locked, then a value of 1 is written to the property.


Events

Manual -> Controls -> WPF element -> Engineering in zenon -> Configuration of the linking -> Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Events make it possible to link zenon functions to a WPF element.

Parameters |  | Description
Name | Name of the property.
Connection | Linked function. Clicking in the cell opens the configuration dialog.
Link type | Selection of linking. Clicking in the cell opens the selection dialog.
WPF info | Shows the current value for properties in WPF content. For the user, it is directly visible what type of property it is (Boolean, string, etc.).
Linked | Shows if a property is currently being used. Not contained by default in the view, but can be selected using Context menu->Column selection.

Link functions

To create a link:

  1. Highlight the line with the property that is to be linked
  2. Click in the Link type cell
  3. Select from the drop down list function
  4. Click in the Link cell
  5. The dialog for configuring the function opens

Parameters |  | Description
Linked function | Selection of the function to be linked. Clicking on the ... button opens the dialog for Function selection.
OK | Accepts selection and closes dialog.
Cancel | Discards changes and closes dialog.
Help | Opens online help.


Transformation

Manual -> Controls -> WPF element -> Engineering in zenon -> Configuration of the linking -> Transformation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The WPF element does not support rotation. If, for example, the WPF element is in a symbol and the symbol is rotated, the WPF element does not rotate with it. Therefore there is a different mechanism for Transformation with WPF to turn elements or to otherwise transform them. These transformations are configured in the Transformation tab.

Attention: If the content is outside of the WPF element area, this part of the contents is lost, i.e. it is not shown.

Parameters

Description

Name

Name of the property.

Connection

Selection of the linked variables.

Transformations are displayed in XAML as transformation objects with their own properties. If an element supports a transformation, then the possible properties of the transformation object are displayed in list view. (more on this in: Integrate button as WPF XAML in zenon

For example, if the linked variable is set at the value of 10, then this value is written as a WPF target and the WPF element is rotated by 10°.

Type of link

Selection of transformation link type.

WPF info

Shows the current value for properties in WPF content. For the user, it is directly visible what type of property it is (Boolean, string, etc.).

Linked

Shows if a property is currently being used.

Not contained by default in the view, but can be selected using Context menu->Column selection.

Link transformations

To link a transformation with a WPF property:

  1. Highlight the line with the property that is to be linked
  2. Click in the Link type cell
  3. Select from the Transformation drop down list
  4. Click in the Link cell
  5. The dialog for configuring the variables opens

The configuration also makes it possible to convert from zenon into WPF units.

Parameters

Description

Linked variables

Selection of the variable to be linked. A click on the ... button opens the selection dialog.

Value range of WPF element

Data to convert variable values into WPF values.

Convert value range

Active: WPF unit conversion is switched on.

Effect on Runtime: The current zenon value (incl. zenon unit) is converted to the WPF range using standardized minimum and maximum values.

For example: The value of a variable varies from 100 to 200. With the variables, the standardized range is set to 100 - 200. The aim is to display this change in value using a WPF rotary knob. For this:

  • for Transformations, the RotateTransform.Angle property is linked to the variables
  • Adjust value activated
  • a WPF value range of 0 to 360 is configured

Now the rotary knob can be turned at a value of 150, for example, by 180 degrees.

Minimum

Defines the lowest WPF value.

Maximum

Defines the highest WPF value.

OK

Accepts settings and ends the dialog.

Cancel

Discards settings and ends the dialog.

Help

Opens online help.


Validity of XAML Files

Manual -> Controls -> WPF element -> Engineering in zenon -> Validity of XAML Files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

XAML files are valid subject to certain requirements:

  • correct name space
  • no class references
  • Scalability

Correct name space

The WPF element can only display WPF content, i.e.:

Only XAML files with the correct WPF namespace can be displayed by the WPF element. Files that use a Silverlight namespace cannot be loaded or displayed. However, in most cases it is suffice to change the Silverlight namespace to the WPF namespace.

WPF-Namespace:

xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation" xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"

No use of class references

Because the XAML files can be loaded dynamically, it is not possible to use XAML files that contain references to classes ("class" key in header). Functions that have been programmed in independently-created C#- files cannot be used.

Scalability

If the content of a WPF element is adjusted to the size of the WPF element, then the controls of the WPF element are interlaced in a control that offers this functionality, such as a view box for example. n addition, care must be taken to ensure that the height and width elements are configured as automatic.

Checking an XAML file to see if it is correct

To check if an XAML file has the correct format:

  • Open XAML file in Internet Explorer
    • If it can be opened without additional plug-ins (Java or similar), then it can be assumed with a high degree of certainty that this file can be loaded and displayed by zenon
    • if problems occur during loading, these are then shown in Internet Explorer and the lines in which problems arise can be clearly seen

The scaling can also be tested in this manner: If the file has been created correctly, the content will adjust to the size of the Internet Explorer window.

Error message

If an invalid file is used in zenon, then an error message is displayed in the output window when loading the file in the WPF element.

For example:

"error when loading xaml-Datei:C:\ProgramData\COPA-DATA\SQL\781b1352-59d0-437e-a173-08563c3142e9\FILES\zenon\custom\media\UserControl1.xaml

The attribute "Class" cannot be found in XML namespace "http://schemas.microsoft.com/winfx/2006/xaml". Line 7 Position 2."


Pre-built elements

Manual -> Controls -> WPF element -> Engineering in zenon -> Pre-built elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon is already shipped with several WPF elements. More are available for download in the web shop.

All WPF elements have properties which determine the graphical design of the respective element (Dependency Properties). Setting the values via an XAML file or linking the property via zenon can directly change the look in the Runtime. The following tables contain the respective Dependency Properties, depending on the control.

Elements:

  • Round display
  • Progress bar
  • Vertical bar graph
  • Temperature control
  • Analog clock
  • Universal slider
  • Pareto diagram
  • Sankey diagram
  • Waterfall diagram

Replacing assembly with a newer version

Per project only one assembly for a WPF element can be used in the Editor as well as the Runtime. If two versions of an assembly are available in a project, then the first loaded file is used. A user enquiry is made as to which version should be used. No further actions are needed for the maintenance of the versions used up until now. If a newer version is chosen, all corresponding CDWPF files in all symbols and images in all projects must be adapted.

Note for Multi-Project Administration: If an assembly in a project is replaced by a new version, it must also be replaced in all other projects that are loaded in the Editor or in Runtime.


Circular gauge control

Manual -> Controls -> WPF element -> Engineering in zenon -> Pre-built elements -> Circular gauge control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Property

Function

Value

CurrentValue

Current value which should be displayed.

Double

IsReversed

Scale orientation - clockwise or anti-clockwise

Boolean

ElementFontFamily

Element font.

Font

MinValue

Minimum value of the scale.

Double

MaxValue

Maximum value of the scale.

Double

ScaleRadius

Radius of the scale.

Double

ScaleStartAngle

Angle at which the scale starts.

Double

ScaleLabelRotationMode

Alignment of the scale caption.

Enum:

  • None
  • Automatic
  • SurroundIn
  • SurroundOut

ScaleSweepAngle

Angel area which defines the size of the scale.

Double

ScaleLabelFontSize

Font size of the scale caption.

Double

ScaleLabelColor

Font color of the scale caption.

Color

ScaleLabelRadius

Radius on which the scale caption is orientated.

Double

ScaleValuePrecision

Accuracy of the scale caption.

Integer

PointerStyle

Shape of the pointer displaying the value.

Enum:

  • Arrow
  • Rectangle
  • TriangleCap
  • Pentagon
  • Triangle

MajorTickColor

Color of main ticks on the scale.

Color

MinorTickColor

Color of sub ticks on the scale.

Color

MajorTickSize

Size of main ticks on the scale.

Size

MinorTickSize

Size of sub ticks on the scale.

Size

MajorTicksCount

Number of main ticks on the scale.

Integer

MajorTicksShape

Shape/type of main ticks on the scale.

Enum:

  • Rectangle
  • Trapezoid
  • Triangle

MinorTicksShape

Shape/type of sub ticks on the scale.

Enum:

  • Rectangle
  • Trapezoid
  • Triangle

MinorTicksCount

Number of sub ticks on the scale.

Integer

PointerSize

Size of the pointer.

Size

PointerCapRadius

Size of the pointer fastening point.

Double

PointerBorderBrush

Color of pointer border.

Brush

PointerCapStyle

Shape/type of pointer fastening point.

Enum:

  • BackCap
  • FrontCap
  • Screw

PointerCapBorderBrush

Color of pointer fastening point.

Brush

PointerBrush

Color of pointer.

Brush

GaugeBorderBrush

Color of the element border.

Brush

GaugeBackgroundBrush

Color of element background.

Brush

PointerCapColorBrush

Color of pointer fastening point.

Brush

GaugeMiddlePlate

Radius of the element background middle plate.

Double

PointerOffset

Offset of the pointer (displacement).

Double

RangeRadius

Radius of the total range display.

Double

RangeThickness

Thickness of the total range display.

Double

RangeStartValue

Start value of the total range display.

Double

Range1EndValue

End value of the 1st area and start value of the 2nd range.

Double

Range2EndValue

End value of the 2nd area and start value of the 3rd range.

Double

Range3EndValue

End value of the 3rd area and start value of the 4th range.

Double

Range4EndValue

End value of the 4th area and start value of the 5th range.

Double

Range5EndValue

End value of the 5th area and start value of the 6th range.

Double

Range6EndValue

End value of the 6th range.

Double

Range1ColorBrush

Color of the first range.

Brush

Range2ColorBrush

Color of the sedond range.

Brush

Range3ColorBrush

Color of the third range.

Brush

Range4ColorBrush

Color of the fourth range.

Brush

Range5ColorBrush

Color of element fifth range.

Brush

Range6ColorBrush

Color of element sixth range.

Brush

ScaleOuterBorderBrush

Color of the scale border.

Brush

ScaleBackgroundBrush

Color of scale background.

Brush

ValueTextFrameStyle

Shape/type of value display.

Enum:

  • LargeFrame
  • SmallFrame
  • None

ValueTextContent

Content of the value display.

Enum:

  • Text
  • TextValue
  • Value

ValueTextSize

Font size of the value display.

Double

ValueTextColor

Font size of the value display.

Color

IsGlasReflection

Activate the glass effect on the element.

Boolean

GaugeOffsett

Lowering the rotation point of the whole element.

Double


Progress bar - ProgressBarControl

Manual -> Controls -> WPF element -> Engineering in zenon -> Pre-built elements -> Progress bar - ProgressBarControl

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Property | Function | Value
CurrentValue | Current value which should be displayed. | Double
MinValue | Minimum value of the value area. | Double
MaxValue | Maximum value of the value area. | Double
ProgressbarDivisionCount | Number of divisions of the progress bar. | Integer
VisibilityText | Visibility of the value display. | Boolean
TextSize | Font size of the value display. | Double
TextColor | Color of the value display. | Color
ProgressBarBoxedColor | Color of the border of the progress bar. | Color
ProgressBarMarginDistance | Distance of the progress bar box from the element edge (left, top, right, down). | Double
ProgressBarInactiveBrush | Indicator color not active. | Brush
ProgressBarActiveBrush | Indicator color active. | Brush
ProgressBarPadding | Distance of the progress bar from the progress bar box (left, top, right, down). | Double
ElementBorderBrush | Color of the element border. | Brush
ElementBackgroundBrush | Color of element background. | Brush


Bar graph vertical - VerticalBargraphControl

Manual -> Controls -> WPF element -> Engineering in zenon -> Pre-built elements -> Bar graph vertical - VerticalBargraphControl

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Property | Function | Value
CurrentValue | Current value which should be displayed. | Double
MinValue | Minimum value of the scale. | Double
MaxValue | Maximum value of the scale. | Double
MajorTicksCount | Number of main ticks on the scale. | Integer
MinorTicksCount | Number of sub ticks on the scale. | Integer
MajorTickColor | Color of main ticks on the scale. | Color
MinorTickColor | Color of sub ticks on the scale. | Color
ElementBorderBrush | Color of the element border. | Brush
ElementBackgroundBrush | Color of element background. | Brush
ElementGlassReflection | Activate the glass effect on the element. | Visibility
ElementFontFamily | Element font. | Font
ScaleFontSize | Font size of the scale. | Double
ScaleFontColor | Font color of the scale. | Color
IndicatorBrush | Bar graph fill color. | Brush
BargraphSeparation | Number of bar graph dividion. | Integer
BargraphSeparationColor | Color of the scale division. | Color


Temperature indicator - TemperatureIndicatorControl

Manual -> Controls -> WPF element -> Engineering in zenon -> Pre-built elements -> Temperature indicator - TemperatureIndicatorControl

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Property

Function

Value

CurrentValue

Current value which should be displayed.

Double

MinValue

Minimum value of the scale.

Double

MaxValue

Maximum value of the scale.

Double

MajorTicksCount

Number of main ticks on the scale.

Integer

MinorTicksCount

Number of sub ticks on the scale.

Integer

TickNegativColor

Color of the negative main tick (gradient to TickPositivColor).

Color

TickPositivColor

Color of the positive main tick (gradient to TickNegativColor).

Color

MinorTickColor

Color of the sub ticks.

Color

ElementBorderBrush

Color of the element border.

Brush

ElementBackgroundBrush

Color of element background.

Brush

ElementGlassReflection

Activate the glass effect on the element.

Visibility

ElementFontFamily

Element font.

Font

IndicatorColor

Color of the indicator fill color.

Color

IndicatorBorderColor

Color of the indicator border.

Color

MajorTickSize

Size of main ticks on the scale.

Size

MinorTickSize

Size of sub ticks on the scale.

Size

ScaleLetteringDistance

Distance of the scale caption (vertical), each x. main tick should be captioned.

Integer

IndicatorScaleDistance

Distance between indicator and scale (horizontal).

Double

ScaleFontSize

Font size of the scale.

Double

ScaleFontColor

Font color of the scale.

Color

Unit

Unit.

String

ElementStyle

Shape/type of element.

Enum:

  • SmallFrame
  • Unit
  • None


Analog clock - AnalogClockControl

Manual -> Controls -> WPF element -> Engineering in zenon -> Pre-built elements -> Analog clock - AnalogClockControl

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Property

Function

Value

ElementStyle

Shape/type of element.

Enum:

  • SmallNumbers
  • BigNumbers
  • No

ElementBackgroundBrush

Color of element background.

Brush

ElementGlassReflection

Activate the glass effect on the element.

Visibility

Offset

Value in hours (h) which displays the time lag to the system clock.

Int16

OriginText

Text which is displayed in the clock (e.g. location).

String


Universal slider - UniversalReglerControl

Manual -> Controls -> WPF element -> Engineering in zenon -> Pre-built elements -> Universal slider - UniversalReglerControl

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Property

Function

Value

CurrentValue

Current value which should be displayed.

Double

ElementFontFamily

Element font.

Font

MinValue

Minimum value of the scale.

Double

MaxValue

Maximum value of the scale.

Double

Radius

Double

ScaleRadius

Radius of the scale.

Double

ScaleStartAngle

Angle at which the scale starts.

Double

ScaleLabelRotationMode

Alignment of the scale caption.

Enum:

  • None
  • Automatic
  • SurroundIn
  • SurroundOut

ScaleSweepAngle

Angel area which defines the size of the scale.

Double

ScaleLabelFontSize

Font size of the scale caption.

Double

ScaleLabelColor

Font color of the scale caption.

Color

ScaleLabelRadius

Radius on which the scale caption is orientated.

Double

ScaleValuePrecision

Accuracy of the scale caption.

Integer

ElementStyle

Display type of the element

Enum:

  • Knob
  • Plate
  • None

MajorTickColor

Color of main ticks on the scale.

Color

MinorTickColor

Color of sub ticks on the scale.

Color

MajorTickSize

Size of main ticks on the scale.

Size

MinorTickSize

Size of sub ticks on the scale.

Size

MajorTicksCount

Number of main ticks on the scale.

Integer

MajorTicksShape

Shape/type of main ticks on the scale.

Enum:

  • Rectangle
  • Trapezoid
  • Triangle

MinorTicksShape

Shape/type of sub ticks on the scale.

Enum:

  • Rectangle
  • Trapezoid
  • Triangle

MinorTicksCount

Number of sub ticks on the scale.

Integer

BackgroundBorderBrush

Color of the element border.

Brush

BackgroundBrush

Color of element background.

Brush

PointerCapColorBrush

Color of pointer fastening point.

Brush

GaugeMiddlePlate

Radius of the element background middle plate.

Double

ValueFontSize

Font size of the value display.

Double

ValueFontColor

Font size of the value display.

Color

IsGlasReflection

Activate the glass effect on the element.

Boolean

KnobBrush

Color of the knob.

Brush

IndicatorBrush

Color of the indicator.

Brush

IndicatorBackgroundBrush

Background color of the inactive indicator.

Brush

KnobSize

Diameter of the knob.

Double

KnobIndicatorSize

Indicator size of the knob.

Size

ElementSize

Size of the element.

Size

VisibilityKnob

Activating of the knob.

Boolean

ValuePosition

Position of the value display.

Double

ValueVisibility

Activating the value display.

Boolean


Pareto diagram

Manual -> Controls -> WPF element -> Engineering in zenon -> Pre-built elements -> Pareto diagram

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Pareto diagram, WPF element is available to exclusive partners of COPA-DATA and is available to these via the Partner Portal.

An example of a Pareto diagram in Runtime is shown below:

The following settings can be made in the WPF configuration window under COPADATA-ELEMENT:

Property | Function | Value
zenonBarColor1 | Color of the first Bar | Color (String)
zenonBarColor2 | Color of the sedond Bar | Color (String)
zenonBarColor3 | Color of the third Bar | Color (String)
zenonBarColor4 | Color of the fourth Bar | Color (String)
zenonBarColor5 | Color of element fifth Bar | Color (String)
zenonBarColor6 | Color of element sixth Bar | Color (String)
zenonBarColor7 | Color of element seventh Bar | Color (String)
zenonBarColor8 | Color of element eighth Bar | Color (String)
zenonBarColor9 | Color of element ninth Bar | Color (String)
zenonBarColor10 | Color of element tenth Bar | Color (String)
zenonColorPercentageLine | Color of the percentage line (relative sum frequency). | Color (String)
zenonLineVisibility | Visibility of the percentage line (relative sum frequency). | Boolean
zenonVariable1_Label | Labeling for the 1st Bar | String
zenonVariable1_Value | Value of the 1st Bar | Double
zenonVariable2_Label | Labeling for the 2nd Bar | String
zenonVariable2_Value | Value of the 2nd Bar | Double
zenonVariable3_Label | Labeling for the 3rd Bar | String
zenonVariable3_Value | Value of the 3rd Bar | Double
zenonVariable4_Label | Labeling for the 4th Bar | String
zenonVariable4_Value | Value of the 4th Bar | Double
zenonVariable5_Label | Labeling for the 5th Bar | String
zenonVariable5_Value | Value of the 5th Bar | Double
zenonVariable6_Label | Labeling for the 6th Bar | String
zenonVariable6_Value | Value of the 6th Bar | Double
zenonVariable7_Label | Labeling for the 7th Bar | String
zenonVariable7_Value | Value of the 7th Bar | Double
zenonVariable8_Label | Labeling for the 8th Bar | String
zenonVariable8_Value | Value of the 8th Bar | Double
zenonVariable9_Label | Labeling for the 9th Bar | String
zenonVariable9_Value | Value of the 9th Bar | Double
zenonVariable10_Label | Labeling for the 10th Bar | String
zenonVariable10_Value | Value of the 10th Bar | Double

The following events can be used and linked to zenon functions:

Event | Function | Value
zenonBar1Click | Function that is executed when the 1st bar is clicked on. | Function
zenonBar2Click | Function that is executed when the 2nd bar is clicked on. | Function
zenonBar3Click | Function that is executed when the 3rd bar is clicked on. | Function
zenonBar4Click | Function that is executed when the 4th bar is clicked on. | Function
zenonBar5Click | Function that is executed when the 5th bar is clicked on. | Function
zenonBar6Click | Function that is executed when the 6th bar is clicked on. | Function
zenonBar7Click | Function that is executed when the 7th bar is clicked on. | Function
zenonBar8Click | Function that is executed when the 8th bar is clicked on. | Function
zenonBar9Click | Function that is executed when the 9th bar is clicked on. | Function
zenonBar10Click | Function that is executed when the 10th bar is clicked on. | Function


Sankey diagram

Manual -> Controls -> WPF element -> Engineering in zenon -> Pre-built elements -> Sankey diagram

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Sankey diagram, WPF element is available to exclusive partners of COPA-DATA and is available to these via the Partner Portal.

The Sankey wizard must be used to model a Sankey diagram. The wizard creates an XML file that is then evaluated by the WPF element. To do this, the zSankeyName property must be given the name of the XML file. The XML file must be in the Other folder of a project. This is saved there by the wizard.

An example of a Sankey diagram in Runtime is shown below:

The following settings can be made in the WPF configuration window under COPADATA-ELEMENT:

Property | Function | Value
FontSize | Font size of the texts. | Integer
zBackgroundColor | Background color of the diagram. | Color (String)
zFontColor | Color of the texts. | Color (String)
zFontFamily | Font of all texts. | Font (String)
zLossDetectionActive | Automatic loss detection activated/deactivated. If true, then losses are automatically shown at a node points as flows. | Boolean
zNoDataText | Text that is displayed if there are no values to display and zPrevireActive is false. | String
zNoValidXMLText | Text that is displayed if no valid XML file with entered name has been found and zPreviewActive is false. | String
zNumberOfDecimalPlaces | Denotes how many decimal places are to be displayed. | Integer
zPreviewActive | Display of a preview activated/deactivated. The preview can be displayed if There is no data present (the modeled diagram is filled with default values) or the XML file was not found or this does not contain a valid definition (an example Sankey diagram is displayed). | Boolean
zRefreshRate | Rate at which the diagram is refreshed in ms. | Integer
zSankeyName | Name of the XML file with the modeling of the diagram. | String
zShowRelativeValues | Display of the values in absolute false or relative values true. | Boolean

Note: The Sankey diagram does not work in zenon Web Client.


Waterfall diagram

Manual -> Controls -> WPF element -> Engineering in zenon -> Pre-built elements -> Waterfall diagram

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The waterfall diagram, WPF element is available to exclusive partners of COPA-DATA and is available to these via the Partner Portal.

The meaning and waterfall chart wizard must be used to model a waterfall diagram. A waterfall can be modeled with this wizard. The information is saved directly for the variables concerned in the Analyzer --> Parameters for waterfall diagram.

An example of a waterfall diagram in Runtime is shown below:

The following settings can be made in the WPF configuration window under COPADATA-ELEMENT:

Property | Function | Value
zenonRefreshRate | Time between the refreshes of the diagram in ms. | Integer
zenonWaterfallIdentifier | Name of the waterfall diagram. | String
zenonZSystemModel | Equipment group of the variables used. | String

Note: The waterfall diagram does not work in zenon Web Client.


Examples: Integration of WPF in zenon

Manual -> Controls -> WPF element -> Engineering in zenon -> Examples: Integration of WPF in zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can see how XAML files are created and integrated as WPF elements in zenon from the following examples:

  • Integrate button as WPF XAML in zenon
  • Integrate bar graph as WPF XAML in zenon
  • Integrate DataGrid Control in zenon

Other topics in this chapter

Integrate button as WPF XAML in zenon

Integrate bar graph as WPF XAML in zenon

Integrate DataGrid Control in zenon


Integrate button as WPF XAML in zenon

Manual -> Controls -> WPF element -> Engineering in zenon -> Examples: Integration of WPF in zenon -> Integrate button as WPF XAML in zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Example structure:

  • Creating a button in Microsoft Expression Blend
  • Integrate into zenon
  • Link to a variable and a function
  • adjust the button to the size of the element
  • Create button

As a first step, create a button as described in the Create button as XAML file with Microsoft Expression Blend chapter. To be able to use the XAML file in zenon, insert this in the project tree in the Files/graphics folder.

Integrate button

Note: A zenon project with the following content is used for the following description:

  • An empty screen as a start screen
  • an internal variable int of type Int
  • a function Funktion_0 of typeSend value to hardware with:
    • Direct to hardware option activated
    • Set was set to 45

To integrate the button:

  1. open the empty screen
  2. place a WPF element in the screen
  3. select XAML file in the properties window
  4. select the XAML file (e. g. MyButton.xaml and close the dialog
  5. select the Configuration property

Configure the button

The configuration dialog shows a preview of the selected XAML file. All elements named in the XAML file are listed in the tree:

  1. select the WPF button, which is in LayoutRoot->MyViewBox->MyButton
  2. Look in the Properties EntryContent tab; this contains the button's text
  3. Click the Link type column
  4. Select Variable from the drop down list
  5. Click in the Link column
  6. the variable selection dialog is opened
  7. select the int variable to link this variable with the Content property

Events

To also assign events:

  1. select the events tab

  2. look for the 'Click' entry, this event is triggered by the WPF element, as soon as the button is clicked
  3. Click in the Link type column
  4. Select Function from the drop down list
  5. Click in the Link column
  6. the function selection dialog is opened
  7. select Function_0
  8. Confirm the changes with OK
  9. Insert a numerical value element into the screen
  10. Link this numerical value element to the int variables too.
  11. Compile the Runtime files and start Runtime.

The WPF element is displayed in Runtime, the button text is 0. As soon as you click on the button, the click event is triggered and the set value function is carried out. The value 45 is sent directly to the hardware and both numerical value and button display the value 45 .

Define a set value of 30 via the numerical value element; this value is then also assumed by the WPF element.

Authorization

Similar to a numerical value, a WPF element can be locked according to authorizations (lock symbol) or switched to be operable. Set the user authorization level to 1 for the WPF element and create a user called Test withauthorization level 1. In addition, set up the functions Login with dialog and Logout . You link these two functions with 2 new text buttons on the screen.

In the WPF element configuration dialog, select the MyButton WPF button and select the Properties: tab

  1. Select the IsEnabled element
  2. Click in the Link type column
  3. Select Authorizations/interlocking from the drop down list
  4. Click in the Link column
  5. In the drop-down list, select the Authorized option

  6. Close the dialog with OK

Compile the Runtime file and note that Authorizations to be Transferred must also be selected. After Runtime has been started, the WPF button is displayed as deactivated on the screen and cannot be operated. If you now log in as the user Test, the button is activated and can be operated. The button is locked again as soon as you log out.

Transformation

The XAML files must still be adapted to use transformations:

  1. switch to the Expression Blend program
  2. select MyButton, so that the properties of the element are visible in the events window

  3. Under Transform at RenderTransform select the Apply relative transform option

    As a result of this, a block is inserted into the XAML file, which save the transformation settings in runtime.

  4. Save the file and replace the old version in zenon with this new file.
  5. Open the WPF element configuration dialog again:
    1. select the MyButton button
    2. select the Transformations tab

    1. select the RotateTransform.Angle element
    2. Click in the Link type column
    3. Select Transformations from the drop down list
    4. Click in the Link column
    5. the variable selection dialog is opened
    6. select the int variable to link this variable with the RotateTransform.Angle property

Compile the Runtime files and start Runtime. Log in as the Test user and click on the button. The button has the value 45 and the WPF element rotates by 45°.


Integrate bar graph as WPF XAML in zenon

Manual -> Controls -> WPF element -> Engineering in zenon -> Examples: Integration of WPF in zenon -> Integrate bar graph as WPF XAML in zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Example structure:

  • Creating a bar graph in Adobe Illustrator and converting it to WPF
  • Integrate into zenon
  • Linking with variables
  • Adapting the bar graph WPF element

Create bar graph

The first step is to generate a bar graph as described in the Workflow with Adobe Illustrator chapter. To be able to use the XAML file in zenon, insert this in the project tree in the Files/graphics folder.

Integrate bar graph

Note: A zenon project with the following content is used for the following description:

  • An empty screen as a start screen
  • Four variables from the internal driver for
    • Scale 0
    • Scale central
    • Scale high
    • Current value
  • A variable from the mathematics driver for displaying the current value (255)

To integrate the bar graph:

  1. open the empty screen
  2. place a WPF element in the screen
  3. select XAML file in the properties window
  4. Select the desired XAML file (for example bar graph_vertical.xaml) and close the dialog

Adjust bar graph

Before configuration, the scale of the XAML file is adapted if necessary:

To do this:

  • Create a new mathematics variable that calculates the new value in relation to the scaling, for example:
  • Variable: 0-1000
  • Mathematic variable {value created in xaml file}*Variable/1000

    The XAML file is then configured.

Configure bar graph

  1. Click on the WPF element and select the Configuration property
  2. The configuration dialog shows a preview of the selected XAML file.
  3. Select the minimum value, the average value and the maximum value and link each of these to the corresponding variable in the Content property

  4. Select the Slider and link the Value property to the mathematics variables (in our example: calculation)

  5. Check the project planning in Runtime:


Integrate DataGrid Control in zenon

Manual -> Controls -> WPF element -> Engineering in zenon -> Examples: Integration of WPF in zenon -> Integrate DataGrid Control in zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create DataGrid control, you need:

  • WPF Toolkit: available as a download at http://wpf.codeplex.com
  • Visual Studio

Ensure that you always create projects that are based on .NET Framework 3.5.

Create WPF user control

  1. Create a WPF User Control in Visual Studio.

    In our example, it is given the name MyWPFLibrary.

  2. Add the WPF Toolkit assemblies to the references. To do this:
    1. Right-click on the project
    2. Select Add reference…
    3. Select this in the .NET tab
    4. Select System.Data and System.Data.DataSetExtensions too if these are not already present
  3. Create a new data connection in Server Explorer. To do this:
    1. right-click on Data Connections
    2. Select Add connection…

    In our example, the database Northwind is used; this has been created by Microsoft as an example database.

    After adding the connection, the Server Explorer window should look a little like this:

    A new DataSet is created in the next step.

Creating a DataSet

  1. Right-click on the project
  2. In the context menu, select the Ad New Item....
  3. Create a new DataSet.
  4. double click the DataSet It should now open in the designer.
  5. Drag the tables that you need into the DataSet design window.

The XAML file is configured in the next step.

Configuration of XAML file

  1. Insert the namespaces into the XAML file.
    You need the namespace of the WPF toolkits and a reference to the class:

  2. Define the resources and the DataGrid that is to be used in the WPF:

    <UserControl.Resources>

    <my1:MyDataSet x:Key="MyDataSet" />

    <CollectionViewSource x:Key="customersViewSource" Source="{Binding Path=Customers, Source={StaticResource MyDataSet}}" />

    </UserControl.Resources>

    <Grid DataContext="{StaticResource customersViewSource}">

    <my:DataGrid Height="304" HorizontalAlignment="Left" Margin="6,7,0,0" Name="dataGrid1" VerticalAlignment="Top" Width="497" DisplayMemberPath="CompanyName" ItemsSource="{Binding}" SelectedValuePath="CustomerID" />

    </Grid>

  3. Open the code-behind file (xaml.cs) and insert the following lines in the constructor:

    public UserControl1()

    {

    InitializeComponent();

    MyWPFLibrary.MyDataSet ds = ((MyWPFLibrary.MyDataSet)(this.FindResource("MyDataSet")));

    MyWPFLibrary.MyDataSetTableAdapters.CustomersTableAdapter ta = new MyWPFLibrary.MyDataSetTableAdapters.CustomersTableAdapter();

    ta.Fill(ds.Customers);

    System.Windows.Data.CollectionViewSource customersViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("customersViewSource")));

    customersViewSource.View.MoveCurrentToFirst();

    }

    This has the following effect:

    • Get DataSet
    • Create a new ReportAdapter
    • Fill DataSet
    • Provide this information to the DataGrid Control

The solution can now be built.

Build

Now create the solution Some DLLs are created in the output folder in the process.

You now have a DLL with the necessary functionality available. However zenon can only display XAML files that cannot be linked to the code-behind file. Therefore another DLL is required that references the DLL that has just been built. To do this:

  1. Create another project, another WPF user control library.
  2. It was called DataGridControl in our example.
  3. Insert a reference to the project that has just been built into this new project.

  4. The XAML files looks as follows:

  5. Because all necessary content is contained in the DLL and no code-behind is necessary, delete:

    x:Class="test.UserControl1"

  6. Also delete (for the positioning) the following lines

    mc:Ignorable="d"

    d:DesignHeight="300" d:DesignWidth="300"

  7. Define what is to be displayed in the XAML file. To do this, add the following lines:

    <UserControl xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"

    xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"

    xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"

    xmlns:d="http://schemas.microsoft.com/expression/blend/2008"

    xmlns:mywpflib="clr-namespace:MyWPFLibrary;assembly=MyWPFLibrary">

    <Grid x:Name="GridName">

    <mywpflib:UserControl1 HorizontalAlignment="Left" Name="userControl11" VerticalAlignment="Top"/>

    </Grid>

    </UserControl>

    The xmlns:mywpflib="clr-namespace:MyWPFLibrary;assembly=MyWPFLibrary" line defines the namespace mywpflib and stipulates that this should use the assembly built before.

  8. Insert a pre-existing name into the TAGs of the grid.
  9. Insert the control mywpflib:UserControl1 from our library and give it a name, because zenon can only modify objects that have a name.
  10. Construct this solution.
    This now leads to an error message:

  11. To rectify the error, simply delete the code-behind file and carry out a rebuild.

In the next step, the XAML file is added in zenon.

Steps in zenon

  1. Open the zenon Editor
  2. Go to File -> Graphics
  3. Select Add file... in the context menu

  4. Select the XAML file from the save location and insert this.

  5. Insert the DLLs with the functionality for the XAML file. To do this:
    1. Select, in the context menu, File -> OtherAdd file....
    2. Select the WPFToolkit.dll and the DLL of the first project

  6. Create a screen.
  7. Insert a WPF element and select an XAML file. You should now see the following:

Note: If the XAML file is to be deleted or updated within the zenon project, it may be the case that the DLLs are still open and cannot be deleted from the file folder. The editor must be restarted in order to delete them. It may also be sufficient to deactivate the project and reactivate it again.


Error treatment

Manual -> Controls -> WPF element -> Engineering in zenon -> Error treatment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entries in LOG files

Entry | Level | Meaning
Xaml file found in %s with different name, using default! | Warning | The name of the collective file and the name of the XAML file contained therein do not correspond. To avoid internal conflicts, the file with the name of the collective file and the suffix .xaml is used.
no preview image found in %s | Warning | The collective file does not contain a valid preview graphic (preview.png or [names of the XAML file].png). Thus no preview can be displayed.
Xaml file in %s not found or not unique! | Error | The collective file does not contain an XAML file or several files with the suffix .xaml. It cannot be used.
Could not remove old assembly %s | Warning | There is an assembly that is to be replaced with a newer version, but cannot be deleted.
Could not remove old assembly %s | Error | A new version is available for an assembly in the work folder, but it cannot be copied there. Possible reason: The old example is still loaded, for example. The old version continues to be used, the new version cannot be used,
file exception in %s | Error | A file error occurred when accessing a collective file.
Generic exception in %s | Error | A general error occurred when accessing a collective file.


Cross-reference list

Manual -> Cross-reference list

The cross-reference list gives an overview which modules and functions are linked how.
zenon provides two instruments for this:

  • Cross-reference list: displays links in the project tabularly The cross-reference list always relates to the project that is currently active.
  • Project analysis: analyzes the use of functions and variables and finds not used functions or variables

tutorial License information

Part of the standard license of the Editor and Runtime.


Cross reference list

Manual -> Cross-reference list -> Cross reference list

The cross-reference list creates a project overview in table form for the project that is currently active.
All relationships between variables, functions, screens, recipes etc. are displayed for documentation and traceability. For example, it is possible to see which variables are used in what screens in the Cross Reference List.


General

Manual -> Cross-reference list -> Cross reference list -> General

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To display the cross-reference list, click, in the Options menu, on the entry Cross-reference list. The cross-reference list is opened.

In order to get information about a certain module, simply expand the corresponding node. Available are:

Module

Elements that can be displayed

Historian
  • Functions
  • Variables

Screens
  • Elements
  • Menus
  • Symbols: There are three different symbol libraries available in zenon. For details, see the symbol library chapter.
  • Variables

Elements
  • Screens
  • Variables

ETM
  • Functions

Functions

  • Historian
  • Automatic function call
  • Screens
  • Bitmap button
  • Button
  • Menus
  • PFS
  • Reaction matrix
  • Scripts
  • Invisible button
  • Variable limits
  • Time control

Menus
  • Screens
  • Functions
  • Variables

PFS
  • Functions
  • Variables

Reaction matrix
  • Functions
  • Variables

Recipegroup Manager
  • Recipegroups
  • Variables

Scripts
  • Functions

Standard Recipes
  • Variables

Symbols
  • Screens
  • Symbols: Symbols: There are three different symbol libraries available in zenon. For details, see the symbol library chapter.

Variables
  • Historian
  • Screens
  • Elements
  • Extended Trend
  • Mathematics
  • Menus
  • PFS
  • Reaction matrix
  • Recipegroup Manager
  • Standard Recipes
  • Allocations

Time control
  • Functions

Allocations
  • Variables

After a click on one of the supported objects information about it is displayed in the list on the right part of the window.

Information about the selected topic is displayed in the list area. The contents can be sorted and filtered.

  • Sorting: Clicking on the column header sorts the column; a second click reverses the sorting.
  • Filter: Enter the search criteria in the filter box in the column header. Several filters can be linked into a chain.
    To remove the filter: Delete the content of the filter box.


Symbol libraries

Manual -> Cross-reference list -> Cross reference list -> General -> Symbol libraries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Note when using symbol libraries that zenon distinguishes between three different symbol libraries:

Symbol library

Property

General symbol library

Symbols are available in all projects. The general symbol library node is located in the project manager below the currently-loaded projects.

Label when linking in the screen: [symbol group]/[symbol name]

Rules:

  • The dialog for selecting variables offers all projects of the workspace for linking.
  • These symbols are saved in the zenon program folder and only updated when the Editor starts. These symbols are not saved during project backup.
  • Interlockings and aliases for ALC cannot be configured.
    Warning: If symols that contain interlockings or aliases are added, these settings are removed.

Symbol library the global project

Symbols are available for all projects of the workspace.

Label when linking in the screen: (g)[symbol name]

Rules:

  • The symbols copied into the symbol library of the global project retain their variable linking without changes.
  • The variable dialog offers all projects of the workspace for linking. Linked variables are placed in front of the name of the respective project.
  • The name of the Variable can be amended in the properties window. This way, for example, the prefix can be deleted with the project origin.
  • The symbols are also backed up when a project is backed up.
  • Interlockings and aliases for ALC cannot be configured.
    Warning: If symols that contain interlockings or aliases are added, these settings are removed.

Symbol library the project

Symbols are only available in the current project.

Label when linking in the screen: [Symbol name]

Rules:

  • The symbols are saved in the project folder. The project symbol library is in the current project in the Screens node and is backed up together with project backup.
  • Interlockings and aliases for ALC can be configured. These properties are also retained when symbols are added.

Symbols can be copied by dragging & dropping.

  • From the general symbol library into the symbol library in the global project
  • From the symbol library in the global project into the symbol library in the project or vice versa
  • Direct copying from the symbol library into the symbol library in the project or copying from the project or global project into the general symbol library is not possible.


The context menu

Manual -> Cross-reference list -> Cross reference list -> The context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The cross-reference list provides a range of functionality:

  • Print list: Prints the list area of the Cross Reference List containing selected information.
  • Search for list element : Opens a dialog to search for a certain element.
  • Function calls: Opens a dialog with a list of the defined functions.
  • Variable use : Opens a dialog with a list of the defined variables.
  • Unused variables : Displays all unused variables in the list area.
  • Unused functions : Displays all unused functions in the list area.
  • Unused fonts : Displays all unused fonts in the list area.
  • Texts used in screens: Searches for texts used in screens.
  • Select list elements : Opens a dialogbox for the selection of one or more listed elements.
  • Help: Opens online help.
  • Delete: Deletes unused elements (variables, functions and fonts).
    Is only displayed if there are deletable elements

To execute one of the functions:

  1. Set the focus to the list window
  2. carry out a right click
  3. Select the desired function from the context menu


Print list

Manual -> Cross-reference list -> Cross reference list -> The context menu -> Print list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Selecting the Print list command from the context menu opens the standard dialog to select a printer and the options for print-out.


Search for list element

Manual -> Cross-reference list -> Cross reference list -> The context menu -> Search for list element

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Selection of the Search for list element command from the context menu opens the following dialog:

Parameters | Description
Search for | Entry of a character sequence.
OK | Applies search parameters and closes the dialog. The first thing that is found in the list that corresponds to the search term is displayed. A match from the first character onwards is looked for. Example: Element name: A search for W finds Wizard_10. A search for Z does not find the element.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Function calls

Manual -> Cross-reference list -> Cross reference list -> The context menu -> Function calls

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Selecting the command Function calls from the context menu opens the following dialogbox, in which all defined functions of the current project are listed:

An element can be selected. Clicking on OK displays the element with all its uses in the cross-reference list.


Variable use

Manual -> Cross-reference list -> Cross reference list -> The context menu -> Variable use

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Selection of the Variable use command from the context menu opens the dialog that contains all used variables.

An element can be selected. Clicking on OK displays the element with all its uses in the cross-reference list.


Unused variables / functions / fonts

Manual -> Cross-reference list -> Cross reference list -> The context menu -> Unused variables / functions / fonts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the list of unused elements (variables, functions and fonts) the context menu gets an additional menu entry delete. This allows elements to be selected and deleted from the list.

attention Attention

The display of objects that are not used relates to internal relationships. The use in symbols, via the programming interface in the Process Gateway, in zenon Logic or other external components is not taken into account.

Always check other possible uses before deleting and create a backup copy!


Select list elements

Manual -> Cross-reference list -> Cross reference list -> The context menu -> Select list elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Selection of the Select list elements command from the context menu opens the dialog to search in the list.

Parameters

Description

from - to

Active: A search for elements with certain letters at the start is carried out. Selection of the range of starting letter in the alphabet from drop-down lists:

  • from: first letter of the range
  • to: last letter of the range

All elements that have their first letter in the defined range are found. The search direction is always A->Z.

All elements beginning with ...

Active: A search for elements that start with a certain character sequence is made.

OK

Applies search rules, closes the dialog and highlights the elements found in the list.

Cancel

Discards all changes and closes the dialog.

Help

Opens online help.


Project analysis

Manual -> Cross-reference list -> Project analysis

The project analysis analyzes the use of elements in a project.

At this:

  • the link with other elements can be analyzed
  • you can search for unused elements

Currently the project analysis is available for:

  • Functions
  • Scripts
  • Variables

Analyze the use of an element

To analyze an element:

  1. highlight the desired variable or function in the detail view
  2. In the context menu, select the Variable use, Function use or script use command
  3. the result list is displayed in an own window

  4. via the context menu you can jump to an element

Find not used elements

To find the not used elements:

  1. highlight the node variable or function in the project tree
  2. In the context menu, select the Display unused functions, Display unused variables or Display unused scripts command
  3. the result list is displayed in an own window

  4. via the context menu you can jump to an element or delete it

attention Attention

The following elements cannot be found by the project analysis:

  • Variables which are only used in VBA or VSTA
  • Variables which are used in screens of type Report Generator (report function)

Before you delete elements you must check whether variables which should be deleted are used in VBA/VSTA or in report functions.


Result list

Manual -> Cross-reference list -> Project analysis -> Result list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The results of the single analysis processes are displayed in a list in an own window in the project analysis. This window opens - if it is not active yet - automatically after the analysis process. The results can be used in two ways:

  • Analyse use in the project: jump to linked element
  • find not used elements: jump to displayed element or delete displayed element

Analysis element use

The project analysis displays its result in a list.

It contains:

  • The project name
  • the module
  • the name of the linked elements

To jump to a displayed element:

  1. highlight the element
  2. select menu item Jump to linked element from the context menu
  3. the linked element is highlighted in the detail view of its module node

Find not used elements

The search for unused elements returns its results in a list.

It contains:

  • The project name
  • the module
  • the name of the unused elements

Jump to element

To jump to a displayed element:

  1. highlight the element
  2. select menu item Jump to linked element from the context menu
  3. the linked element is highlighted in the detail view of its module node

Delete elements

To delete one or more elements:

  1. highlight the desired elements (multiple selection is possible)
  2. in the context menu select the command Delete selected elements
  3. the elements are deleted from the project after a confirmation message


Distributed engineering

Manual -> Distributed engineering

The Multi-user-function of zenon makes it possible, that multiple users concurrently work at the same project. For this, the projects are stored on a central SQL Server and can be worked on from different workstations at the same time. The central storage of the project will be called Server DB in the following text.

For example: One user creates the screens while another one can concurrently define the variables.

info Information

Hint for terminology:

"Check in" equals property Accept changes

"Check out" equals property Enable changes

IP protocol

The communication in the zenon network can be done via IPv4 or IPv6. For details see the Network manual, Requirements chapter.

tutorial License information

Part of the standard license of the Editor and Runtime.


Information about SQL Server

Manual -> Distributed engineering -> Information about SQL Server

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon from version 7.00 SP0 on

For distributed engineering all participants access a central SQL Server. From zenon version 7.00 SP0 on all participants must use version 7.00 or higher:

  • Editor: from 7.00 SP0 on
  • DBSrv: from 7.00
  • SQL Server: SQL Server 2008 R2 Express Edition

Update

When updating the project server to SQL Server 2008 Express, all Clients must also be updated. SQL Server 2005 and SQL Server 2008 are not compatible.


Possibilities of the multi-user administration

Manual -> Distributed engineering -> Possibilities of the multi-user administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The multi-user administration can be used for:

  • Standalone in order to test changes without risk
  • a local Server with several clients
  • a network Server with several clients


Local Server

Manual -> Distributed engineering -> Possibilities of the multi-user administration -> Local Server

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this case the server project AND a local project copy are stored at the same PC.

It is possible to create multi-user projects on one single computer. This makes for example sense when you want to check changes first. To do this e.g. changes are allowed for a screen, it is edited and tested in the Runtime. After this the changes can be checked in or rejected. The original screen stays unchanged, until the changes in the screen are accepted.


Local several to which several clients access

Manual -> Distributed engineering -> Possibilities of the multi-user administration -> Local several to which several clients access

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The server database and a local project copy are on one PC. The clients also work with a local project copy. Changes in the local project copy are transferred to the server database, when the changes are accepted. On the server computer also a local project copy is edited.


Access server with multiple clients

Manual -> Distributed engineering -> Possibilities of the multi-user administration -> Access server with multiple clients

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The server database is on the central computer. Multiple Clients connect to this server. Local project copies are created on each client.

Local project copies 1-3 of the Server DB

info Information

A mixture of the described configurations is possible. E.g. each computer has one or more server databases for different projects and at the same time only one local project copy of another server database.

Server without log ins

On servers on which no user is logged in, file zendbsrv.exe must run as device.

The zendbsrv service starts the zensyssrv service for logging tasks. For the operating system Windows 7 this is not permitted via Remote Transport due to security reasons. The file must to be registered manually:

zendbsrv.exe -service

Hint: Also register file zensyssrv.exe as service: zensyssrv.exe -service

info Information

As soon as both files are registered, you can no longer use the Remote Transport under Windows 7, i.e. start the Runtime via Remote Transport.


Creating a new multi-user project

Manual -> Distributed engineering -> Creating a new multi-user project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When a new project is created, the checkbox Multiuser project has to be activated. Enter or select the server for the multiuser project in field project server. If a server is selected, the checkbox Multiuser project is automatically activated.

If no server is selected in field project server, the project, i.e. the server database, is created on the local PC. A local project copy is created automatically with which you can work directly in the Editor.

Requirements:

  • Project database server (zendbsrv.exe) must be started on the server and the client
  • firewall setup:
    • you must unblock the programs zendbsrv.exe and sqlservr.exe.
    • SQL browser must be enabled for the Server and the Client.
  • Necessary open ports:
    • 1103
    • 1433 for SQL Server: this port can change therefore the SQL Server process must be taken out completely from the firewall
    • 1434 for SQL Browser
  • The name resolution in the network must work
  • Reverse lookup must deliver the same computer name both at the server and at the client

attention Attention

Workspaces do not support multiple users because they are station-specific. So the project hierarchy can be defined differently on different computers. The users have to communicate directly so that the hierarchy is the same on all stations.

Creating a client for a multiuser project

Execute the following steps in order to create a client for a multiuser project:

  1. Select File -> Insert existing project...
  2. In the following dialog select under computer name the name of the Server-DB. Under Project selection select again the computer name and the server nam (DB)
  3. Select Multiuser project

Notes on configuration with zenon Logic

Note when configuring with zenon Logic:

  • In the zenon Logic Workbench, lines can be created in the All projects node MultiSpy and the global Binding Editor can be called up. The following is applicable for these settings: They are
    • Not saved as multi-user
    • Not transferred to the project server
    • Removed again in the next synchronization
  • If new zenon Logic projects are created in the zenon Logic Workbench via File -> Add new project, the following is applicable: They are
    • Not transferred to the project server
    • Deleted again in the next synchronization

Attention: Multi-user zenon Logic projects can only be created using the zenon Editor.


Convert single-user projects to multi-user projects

Manual -> Distributed engineering -> Convert single-user projects to multi-user projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To convert a single-user project to multi-user project:

  1. Make sure that the global project is a multi-user project.
    If this is not the case, remove the existing global project from the workspace and create a new multi-user global project via the context menu of the workspace. Project new
  2. Then convert the single-user project: in the context menu select menu item Multi-user -> Convert to multi-user project
  3. You receive a warning that you cannot undo this step.
    You can however create a single-user project from a project backup of a multi-user project.
  4. Confirm the warning by clicking on Yes.

info Information

At the conversion the computer on which the action is carried out is defined as the database server for the project. This property cannot be changed later.


Converting multi-user project to single user project

Manual -> Distributed engineering -> Converting multi-user project to single user project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To convert a multi-user project to single-user project:

  1. Make sure that all project changes are taken over by all clients:
    • Project -> Context menu -> Multi-user -> Synchronize
  2. Ccreate a project backup:
    • Node project backup -> Context menu -> Create backup
    • Enter a name and a description in the dialog. You can also backup a local project copy.
  3. Create a new project from the backup:
    • Workspace -> Context menu -> Restore project backup.
    • Select the desired project backup.
    • Activate checkbox Create new project.
    • Confirm your selection by clicking OK.
    • Enter a new project name.
  4. The project is created as single-user project.
    The multi-user project also still exists.

Note: To convert the local project copy to a single-user project, you can also select option Project -> Save as ... in the Editor.


Working with a multi-user project

Manual -> Distributed engineering -> Working with a multi-user project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Multi-user projects enable manifold access to modules. When engineering multi-user projects, especially take care for:

  • the proceed at Enable changes and Accept changes and their handling for changes in several modules
  • Deleting elements
  • Synchronizing elements
  • the exceptions of VBA and RGM

Rename project

Projects can be renamed with the Save as command, because it is always the local project copy that is saved.

To save a server project under a new name:

  1. Make a backup of the server project.
  2. Select Restore backup as a new project in the context menu.
  3. Name it as you wish.

The project is now available with a new name.


Extend and synchronize project

Manual -> Distributed engineering -> Working with a multi-user project -> Extend and synchronize project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If a new element (e.g. a variable or a screen) has been created, this element first is only available locally and changes are automatically allowed.

If the changes are accepted, another client must synchronize so that the changed elements are also available on his computer.

If after creating a new element the changes are rejected, it is, as if thie element never had existed.

The difference between a new variable and a new screen is, that after a synchronization the variable is not visible on the other computers, if the changes have not jet been accepted. After a synchronization the screen is visible as under construction on the other computers.

See also chapter Screens / Frame editor.

After another user has added or deleted an element, the project has to be synchronized in order to receive the changes. This is done with the entry Project/Synchronize in the context menu of the project.

The following configurations can be done in this context menu:

Command | Description
Multi-user/synchronize | The project is synchronized.
Multi-user/activate offline mode | The offline mode is activated. Changes take effect only locally and are not taken over centrally as long as the project remains offline.
Multi-user/activate online mode | The online mode is activated. If elements have been edited and taken over be other users in the mean time, they overwrite changes from the offline mode.
Update local version | The local copy is updated with the Server DB. The project is reloaded into the Editor. Attention: Exception: The Elements/Modules, that are checked out by this user.

info Information

The elements that have been checked out by the same user, that has done the synchronization, will not be overwritten by the synchronization. The local changes are protected from overwritten by the check out status.

Exception:
User A checks out elements offline. User B checks out elements online. If user A reconnects to the server, the elements checked out by both users are overwritten with the data of user B. If from a team one member is out of office, we recommend not the change the project in this offline phase!


Changes to existing elements

Manual -> Distributed engineering -> Working with a multi-user project -> Changes to existing elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If changes should be done in a element, this element has to be checked out first. This prohibits that more than one user can access to the same element. Elements that are checked out cannot be changed by other users.

The Element can be changed by the user it has been checked out. This user has the exclusive change rights. For all other users this element is prohibited and locked.

In order to allow changes at an element, the user has to select "allow changes" in the context menu of the element. It is possible, to check out only single elements, e.g. one variable. To do this the entry Allow changes in the context menu of the single variable in the detailview is activated. It is also possible to check out e.g. all the variables of the project at once vie the node.

If a project is a multi-user project the entry Under construction is added to the Project Manager. In the detail view of the list, the elements of the current project are listed. The default columns are: Status, Element, Target and Module. Additional columns can be added in the context menu of the column headers with the entry 'field selection'. With the additional columns the list shows an overview, which elements are edited by which user at which computer at the moment.

info Information

If you want to use subprojects in a multi-user environment, make sure, that both projects have the entry Allow changes activated before dragging the subproject under the integration project.

An element/module can only be 'read' but not edited, as long as the user has not fetched the authorization for it. The authorization can be fetched with the context menu of the element Allow changes or directly at opening the element.


Deleting projects

Manual -> Distributed engineering -> Working with a multi-user project -> Deleting projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If a project is deleted, only the local project copy is deleted. The server DB remains available and other clients can still work with it. It is still possible to add the project to the workspace. Here a new local project copy is created again.

If a user deletes his local project copy, all check out information and thus all changes of this user are lost.


Disconnect client

Manual -> Distributed engineering -> Working with a multi-user project -> Disconnect client

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the functionality disconnect client it is possible to disconnect the local project copy of an user from the server database. So all check out information of this user is deleted. Changing the elements locked by this user again is possible.

It can be necessary to disconnect a client, if the user is not in the office and has checked-out elements, which urgently have to be edited or the computer of this user is defective.

attention Attention

If the client of an user has been disconnected and the this user opens the project copy, the project is offline. It is no longer possible to go online. First the local project copy has to be deleted and again copied from the server.

Requirement:

A client can only be disconnected, if the computer, where the local project copy has been edited, cannot be reached.

With the main menu File -> Insert existing project the Project Database Manager can be opened. Under multi-user and connected local project copies you will find all users, which have (had) a local project copy.

With disconnect the entry for this user is deleted from the server database. After the client has been disconnected, the dialog can be closed.

attention Attention

This action cannot be undone! If the user on this computer again wants to access the multi-user project, the local project copy has to be deleted and again be inserted.


Backup mechanism

Manual -> Distributed engineering -> Working with a multi-user project -> Backup mechanism

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In general, the following should be noted for the backup mechanism with distributed engineering:

  • Only local project states can be backed up.
  • As long as they have not been synchronized, restoring is also possible.


Project backup

Manual -> Distributed engineering -> Working with a multi-user project -> Backup mechanism -> Project backup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The project backup is executed in the project manager in the node Project backups.


Project backups of local project copies

Manual -> Distributed engineering -> Working with a multi-user project -> Backup mechanism -> Project backup -> Project backups of local project copies

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A project backup can be made using the context menu of the Project backups module. To make a local project backup, the Create local project copy check box must be activated in the Save project backup dialog box.

Local project backups can only be made within the same offline session as the backup.

info Information

You can find further information in the project backup manual in the Project backup detail view tool bar chapter.


Project backup of server projects

Manual -> Distributed engineering -> Working with a multi-user project -> Backup mechanism -> Project backup -> Project backup of server projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A backup of a server project can be executed from each client, if the checkbox Save local project is not active.

info Information

You can find further information in the project backup manual in the Back up and export project chapter.


Restore project backup

Manual -> Distributed engineering -> Working with a multi-user project -> Backup mechanism -> Restore project backup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A project backup can be restored using the context menu of the Project backups module.

Local project restores can only be carried out within the same offline session as the backup.

info Information

You can find further information in the project backup manual in the Project backup detail view tool bar chapter.


Restore project backup of local project copies

Manual -> Distributed engineering -> Working with a multi-user project -> Backup mechanism -> Restore project backup -> Restore project backup of local project copies

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Restoring a local project copy is only possible, as long as no synchronization has been executed.
If a project has been synchronized since the last backup, the user only has the possibility to Restore backup as new project. Thus the project is restored as a single user project.

info Information

You can find further information in the project backup manual in the Restore project backup chapter.


Allow, accept and reject changes

Manual -> Distributed engineering -> Working with a multi-user project -> Allow, accept and reject changes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To make changes to a project, the respective elements (functions, variables, screens, ...) must be enabled for change (Enable changes). After the editing the elements must be protected from change and must be transferred to the Server (Accept changes).

Note: New and deleted elements are always transferred at the next synchronization. If you delete an element, it can still be edited on another computer. However it is finally deleted after the next synchronization.

Parameters

Description

Update local version

If other users made changes in the server project, the local project copy can be updated with the menu entry.

Updates only single existing Elements/Modules. New elements at the Server are therefore not available, synchronization is required.

Enable changes

In order to be able to change elements, the status ‘Allow changes’ has to be activated for them. This can be done in the context menu of the selected element.
To make quicker work possible, you can enable changes for the whole module at variables. This means that all variables, drivers and data types are locked for all other users.

Accept changes

The changes are transferred into the server project. The element/module is then unlocked for other users.
If changes were allowed for a complete module, they only can be accepted for the module.
This means, that all variables, drivers and datatypes are transferred and unlocked for other users. Accepting a single element is not possible in this case.
The changes in the local project copy are rejected and overwritten by the server data. The element/module is then unlocked for other users.

Undo changes

All variables, drivers and datatypes are rejected and unlocked for other users. Rejecting a single element is not possible in this case.

info Information

When you change the project name, Undo changes is not possible. The changed project name remains.

Changes on several modules at the same time

If a module is enabled for changes and if elements of other modules are newly created and linked with this module, all affected elements/modules must be set to Accept changes. Enable the newly created elements/modules first and then enable the already existing ones. If you now enable the module which was originally disabled, you may lose new engineerings.

Example:

  • On one Client the RGM is checked out.
  • A new recipe group is created. Then a new recipe.
  • An existing variable is added to the recipe group.
  • Three new variables are created and added.
  • Interlockings are checked out and a new interlocking is added.
  • A new keyboard screen is created with a new frame.
  • In the recipe group the new created interlocking is assigned.
  • The keyboard screen is assigned.
  • A new variable for the visibility is created and linked with a variable in the recipe group.

If only the recipe group is set to Accept changes and another Client is synchronized:

  • the other Clients gets:
    • a recipe group with a linked variable
    • and a recipe which contains the variable
  • all other information is lost

If this Client disables, edits and enables the recipe group, all newly engineered information is lost.

For correct acceptance Accept changes must be carried out for:

  • RGM
  • Recipe group
  • Recipe
  • Variables
  • Interlockings
  • Keyboard screen
  • Frame for keyboard screen


Status of the elements and the modules

Manual -> Distributed engineering -> Working with a multi-user project -> Allow, accept and reject changes -> Status of the elements and the modules

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If an Element has been checked out, the Symbol in the project manager and the detail view changes. The user who has checked out the element gets a checkbox with a green check mark displayed. All other users get a checkbox with a red X. A ! means, that within the node single elements are checked out.

See chapter Legend.

In the special case of the variable administration the symbols are displayed slightly transparently, if the module has been checked out.

Example Example

All variables are checked out by a user. Another user cannot change these variables, but he can add an additional variable.

Exception: Module checkout

The following actions are only possible if the whole module is set to Enable changes:

  • creating array variables
  • creating structure data types
  • copying and pasting array and structure variables
  • creating variables based on a structure data type with array
  • changing the array settings of a variable
  • changing array settings in zenon Logic of a variable with zenon profile

info Information

If a variable is created without the whole module Variable set to Enable changes, the dimensions are automatically set to 0. This prevents creating a structure variable unintentionally.

The following elements/modules can only be set to Enable changes or Accepts changes as a whole:

  • Archives
  • User
  • Menus
  • Reaction matrix
  • Standard recipes
  • Recipegroups
  • Scripts
  • Fonts
  • Interlockings
  • Allocations

Display changed on date in the detail window

In the detail window there a two columns available which information about the last time changes were made:

  • Last change accepted: Displays at all lists, whose content concern distributed engineering, the time of the last update in the database or of the last check in.
  • Last modified: Displays time stamp of the last change of the files in the file system.

If the columns are not displayed, you can activate them via:

  1. right-clicking on the column header
  2. in the context menu select menu item Column selection
    (It depends on the module which columns are available.)
  3. select the desired columns in the selection list on the left-hand side (multi-select is possible)
  4. add the columns by clicking button Add -> to the right-hand list
  5. Via buttons Up and Down you select the desired position
  6. confirm and close the dialog by clicking OK


Key of the symbols

Manual -> Distributed engineering -> Working with a multi-user project -> Allow, accept and reject changes -> Key of the symbols

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following symbols indicate the status of the elements in multiuser projects.

(for example: A screen can be changed by a user [image])

Elements in the detail view of the Project Manager:

Symbol | Description
 | New element has been added in the local project copy. On the first check-in the element is transferred to the server.
 | New module has been added in the local project copy. On the first check-in the module is transferred to the server.
 | Elements have been marked as deleted in the local project copy. On the first check-in the element is deleted on the server.
 | Modul has been marked as deleted in the local project copy. On the first check-in the module is deleted on the server.
 | Element can be edited by the current user.
 | Module can be edited by the current user.
 | Element is locked by another user.

Display in the project tree:

Symbol | Description
 | Module can be edited by the current user.
 | Module is edited by another user and thus is locked for the current user.
 | At least one element of the module is marked for editing (not the entire module).


Deleting elements

Manual -> Distributed engineering -> Working with a multi-user project -> Deleting elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Data base elements are only displayed as deleted at first. At the other clients no more changes can be done to these elements, the are displayed as “locked”. If „accept changes“ is selected, the elements are finally deleted. It is possible to undo the deletion with "undo changes".

Example Example

This is true for variables for instance: The changes have to be accepted to allow deleting.

File elements such as screens, files (language table, graphics) etc. are directly deleted when a confirmation is done on the executing computer. New and deleted elements are always transferred at the next synchronization. If you delete an element, it can still be edited on another computer. However it is finally deleted after the next synchronization.


Synchronization of the multi-user project

Manual -> Distributed engineering -> Working with a multi-user project -> Synchronization of the multi-user project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

After another user has added or deleted an element, the project has to be synchronized in order to receive the changes. This is done in the context menu of the project with the entry Project -> Context menu -> Multi-user -> Synchronize or All modules/update local version.

The following configurations can be done in this context menu:

Parameters

Description

Synchronization

The local copy is updated with the Server DB. The project is reloaded into the Editor.
Attention: Exception: The Elements/Modules, that are checked out by this user.

Update local version

See synchronize

Enable changes

Checks out Elements/Modules

Accept changes

Checks in Elements/Modules

Undo changes

The changes of the element are not accepted but discarded. After Undo changes the project is overwritten by the Server database again.

Attention: If changes are undone at an element that has not yet been “accepted”, the changes that depend on this element are also undone.

New and deleted elements are always transferred at the next synchronization.

info Information

The Elements/Modules that have been checked out by the same user, that has done the synchronization, will not be included into the synchronization.


Recipegroup Manager

Manual -> Distributed engineering -> Working with a multi-user project -> Recipegroup Manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Filter dialog in the Runtime

If you activate property Show dialog in the Runtime at the options of the Recipe value list in the screen switch, there are only restricted options available in Windows CE:

  • Recipe Filter
  • Column settings (for recipe table)

Recipe selection, Equipment modeling and column settings for the recipe list are not available.


VBA and VSTA

Manual -> Distributed engineering -> Working with a multi-user project -> VBA and VSTA

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Select the entry Open VBA Editors or Open VSTA Editor in the context menu of Programming interfaces, then the Editor is checked out and changes are enabled.

Attention: In general in VBA changes are possible even if the element has been set to Enable changes on another computer.
Therefore consider the following before making changes via VBA:

  1. before you take over changes: check whether you are dealing with a multi.user project
  2. if yes: check whether the element is added by another Client
  3. if yes: check whether the element has the local status Enable changes (check out)
    1. if yes: the object can be changed,
    2. if no: the object must be set to Enable changes
    • check again whether the object has the Enable changes status
    • if yes: the object can be changed in VBA
  4. after the changes the object must be set to status Accept changes (check in) via VBA

attention Attention

In multi user projects the VBA Editor must not be opened with Alt+F11. If VBA is not checked out, changes are not accepetd. When the VBA Editor is opened, a warning message is displayed that indicates which projects are affected.


Close the Editor

Manual -> Distributed engineering -> Working with a multi-user project -> Close the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Each user should accept the changes of his objects before closing the Editor, the workspace or the project. As long as this has not happened, other users cannot edit these objects. See also chapter Editor / Closing the Editor. Closing the Editor.

If you close without accepting the changes, a dialog for accepting or refusing the changes is displayed:

Parameters | Description
List field elements | Lists all elements which are disabled for editing. Changes for the displayed elements can be accepted or discarded via the respective button.
Accept changes | The changes of all elements are accepted.
Undo changes | The changes of all elements are discarded.
Edit... | Closing is cancelled.
Next | Continues the closing process for the current project. The elements remain disabled for the other users. If several Multi-user projects should be closed, this dialog is displayed for the project which should be closed next.
Next (all) | Continues the closing process for all Multi-user project in the workspace which should be closed. The elements remain disabled for the other users.
Help | Opens online help.


Working offline

Manual -> Distributed engineering -> Working offline

While working offline there is no connection to the server, e.g. when the engineer takes the project with him on the laptop.

To switch a project offline, the entry Activate offline mode has to be selected in the context menu of the project. Projects having no connection to the database server will be activated offline automatically.

info Information

IAccept changes and Reject changes is not possible during the offline operation.

Only Allow changes is available in offline mode, otherwise no changes would be possible in offline operation. Accept changes can be activated in the online period.


Switch offline

Manual -> Distributed engineering -> Working offline -> Switch offline

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There might be different circumstances when switching offline


Elements/modules are locked by another user

Manual -> Distributed engineering -> Working offline -> Switch offline -> Elements/modules are locked by another user

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

At the moment of switching offline another user edits the element/module. In this case no changes can be done offline.


Elements/Modules are checked ot by the same user during offline switch

Manual -> Distributed engineering -> Working offline -> Switch offline -> Elements/Modules are checked ot by the same user during offline switch

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

At the moment of switching offline the same user edits the element/module. In this case no online changes by another user are possible.


No elements/modules are checked out during going offline

Manual -> Distributed engineering -> Working offline -> Switch offline -> No elements/modules are checked out during going offline

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

At the time of switching offlineno elements/modules are checked out.

Case 1:

Offline changes for an element/module are allowed, but the same is also possible online.

User A changes an element/module offline, user B online.

When user A goes online, it is recognized that user B is just editing the module/element online.

The changes made by user A are lost.

attention Attention

In this case the changes made offline (by user A) are lost!

Case 2:

When user A accepts his changes, user B already accepted his changes.

The changes made by user A overwrite the changes made by user B when going online.

attention Attention

In this case the changes made online (by user B) are overwritten!


From offline to online

Manual -> Distributed engineering -> Working offline -> From offline to online

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To switch an Offline-project online again, the entry Project/online has to be selected in the context menu. The project is reloaded into the Editor immediately.


Possibilities in offline operation

Manual -> Distributed engineering -> Working offline -> Possibilities in offline operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Elements/modules

Create, change, rename, delete


Driver simulation

Manual -> Driver simulation

If the underlying process is not available when configuring, this can be simulated and tested in advance. Three modes are available for this:

  • Simulation static: constant values simulated by the driver
  • Simulation - counting: values simulated by the driver are counted up
  • simulation - programmed: Values are calculated via a simulation project with zenon Logic

attention Attention

If the driver is stopped in mode Simulation - counting, only the counting is stopped. The variable is not switched to faulty. In all other modes the driver is really stopped.

Note: Simulation - programmed is not supported by drivers for:

  • Internal variables
  • Mathematical variables
  • Simulator variables
  • System variables

info Information

zenon variables which represent the zenon Logic IO variables are available in the project in state Driver simulation programmed.

tutorial License information

Part of the standard license of the Editor and Runtime.


Simulation static

Manual -> Driver simulation -> Simulation static

For a static simulation, no communication to the control is established; the values are simulated by the driver. In this mode the value remains constant. Values can be changed by the Runtime or the user. At a restart of the Runtime with Simulation - static theses values will however not be saved and are lost.


Simulation - counting

Manual -> Driver simulation -> Simulation - counting

For a counting simulation, no communication to the control is established; instead the values are simulated by the driver. In this mode, the driver increments the values within a value range automatically, starting with 0. If the maximum value has been reached, the counting process starts at 0 again.

info Information

For negative starting values, the counting process only starts at 0.

INT uses the maximum value from USINT to count.

attention Attention

If the driver is stopped in mode Simulation - counting, only the counting is stopped. The variable is not switched to faulty. In all other modes the driver is really stopped.


Simulation - programmed

Manual -> Driver simulation -> Simulation - programmed

For Simulation - programmed, no communication is established to the PLC; instead, the values are calculated by a freely programmable simulation project. The simulation project is created with the help of the zenon Logic Workbench and runs in the zenon Logic Runtime. It enables the status and time stamp of variables to be modified on the driver. Write commands to variables by zenon are forwarded to the simulation, redundant servers and Standby Servers are synchronized. This is how you also simulate complex processes.

To start the simulation program, select the Simulation - programmed mode in driver configuration.

info Information

Windows CE

Simulation - programmed is not available for Windows CE.


Editor

Manual -> Driver simulation -> Simulation - programmed -> Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


Create project

Manual -> Driver simulation -> Simulation - programmed -> Editor -> Create project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a program for Simulation - programmed, you must:

  • select a single process driver
  • make sure that the project name is valid.

attention Attention

Simulation - programmed is not supported by drivers for:

  • Internal variables
  • Mathematical variables
  • Simulator variables
  • System variables

To create a simulation project:

  • click in the group Driver simulation project in the property Edit on Click here ->
  • A new zenon Logic project is created.
  • Name and port numbers for Event port and Standard port are automatically issued; change these as you wish
  • the zenon Logic Workbench is opened

The simulation project's workshop is automatically closed if:

  • the zenon editor is closed
  • a driver is deleted and its simulation project is currently being edited in Workbench
  • the simulation project for the driver is deleted via the Delete property
  • the simulation project is renamed

info Information

Port numbers: At creating the simulation project for this project a distinct port number is assigned automatically. An automatically assigned port number is only unique for the respective project. In multi-hierarchical projects, it must be ensured that a port number is only used once in all projects that run in Runtime. If a port number is used more than once, communication errors can occur with zenon Logic Workbench/Runtime.

Port numbers can be amended manually. A port number must meet the following conditions:

  • It must be free in the project.
  • It must be unique for all projects that run in Runtime.
  • It must be available on the computer on which the driver runs.

Permitted port numbers:

  • Minimum: 6000 (with automatic allocation, manually: recommended)
  • Maximum: 6999 (with automatic allocation, manually: recommended)

Project archiving

A zenon Logic project contains many files and folders. To manage them, in particular to simplify distributed engineering, all files are archived in compressed form in the Simul_<Treiber-ID>.zip file in the <Sql Projekt Pfad>\FILES\zenon\custom\drivers. This file is in the driver files in the editor. When starting zenon Logic Workbench, the files are automatically decompressed are compressed again when it is ended.

Creating variables

When creating variables in a simulation project, the succession is important:

  1. create the variable
  2. select the valid data type in the zenon Logic Workbench
  3. after that activate property embed symbol

Background: Variables are created with the PLC marker driver object type by default. This object type does not support all data types for all drivers. If a variable is copied in the zenon Logic Workbench with active property embed symbol, you must deactivate this property in order to change the data type. With this the variable is then deleted in zenon.

info Information

Error message "Can not create variable"

A variable cannot be created in the simulation object if the driver does not have driver object types - exception

driver variable - which support this data type.

On activation of embed symbol, the error message "can not create variable" is displayed.

Structure data types

At creating variable with a structure data type:

  • they are created with the driver object type PLC marker if possible
  • all driver object types with the exception of driver variable are tried until one can be used for all elements
  • if no fitting driver object type is available,
    • no variable is created for non-structure variables
    • driver object type PLC marker is used for structure variables

Example:

A structure data type contains elements of type UINT and STRING. A variable is created for S7TCP driver and embed symbol is activated.

  • The variable is not created in PLC marker but as Ext. Data module, in which all structure elements are present.
  • A new type LINT is added; it is not supported by the Ext. Datablock.
  • When a new variable is created, it is created as type PLC marker. Only the first complex variable can be activated (UINT). The object type Ext. remains for the existing structure variable Data and the last structure element (LINT) cannot be activated.

Compiling the files

If a simulation project is compiled in zenon Logic Workbench, this causes a variable to be created in zenon and the Runtime program file.
When compiling, a subfolder is created in Runtime-Folder\RT\FILES\zenon\custom\drivers with the name of the simulation project. The file with the code of the simulation is SIMULRT.COD is archived in this folder.

The following message is displayed in the output window:

SIMULRT.COD

And if compiled with the C compiler, then also:

T5APP.DLL

attention Attention

For multi-user projects you must not create simulation projects offline. They cannot be deleted anymore.


Delete project

Manual -> Driver simulation -> Simulation - programmed -> Editor -> Delete project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To delete a simulation project:

  1. click on the Click Here-> button in the Delete property in the Driver simulation project group
  2. confirm this when requested to do so
  3. the ZIP file with the project files is deleted
  4. the zenon Logic Workbench is ended

Note:

  • the Runtime folder for the simulation project remains
  • function Undo is not available for this action,
  • click on Edit to create a new simulation project
  • for multi-user projects:
    • the driver must be configured to Make changes possible so that the simulation program can be deleted
    • the project is not displayed as deleted on other Clients as long as it has not been synchronized;

      if you try to open a deleted project before it has been synchronized (click on Edit), a new simulation project will be created

    • you cannot reverse the deletion of single-user projects via Cancel changes

attention Attention

The Simulation project is immediately removed from the local database and the server database when deleted. This action cannot be undone!

Note: Manual deletion of the ZIP file of the driver also leads to the simulation project being deleted. Requirement: The zenon Logic Workbench for this driver is not opened. We do not recommend doing it this way!


Distributed engineering

Manual -> Driver simulation -> Simulation - programmed -> Editor -> Distributed engineering

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For multi-user projects, all running zenon Logic Workbenches that are part of the project are closed when:

  • Accept changes for modules that are completely locked for other users in Enable changes, such as variables, drivers and data types
  • Discard changes:
    • new projects are not created on the server
    • Changes in the simulation program are lost
    • Driver files not present in the server database are also lost in the local database
  • Synchronize:
    changes made locally to the simulation program program are lost
  • Update local version:
    changes made locally to the simulation program in the simulation program are lost

attention Attention

The status of the simulation project's ZIP file may not be additionally modified(Accept Changes, Enable Changes, Discard Changes multi-user status), to ensure correct Accept Changes and Enables Changes for the driver!

Delete project

For multi-user projects

  • the driver must be configured to Make changes possible so that the simulation program can be deleted
  • the project is not displayed as deleted on other Clients as long as it has not been synchronized;
    • if you try to open a deleted project before it has been synchronized (click on Edit), a new simulation project will be created
  • you cannot reverse the deletion of single-user projects via Cancel changes

attention Attention

A simulation project with the status of Enable Changes cannot be deleted in Offline mode.

A simulation project created offline in a multi-user project can therefore no longer be deleted.


Change driver

Manual -> Driver simulation -> Simulation - programmed -> Editor -> Change driver

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For a driver change in zenon the following is true:

  • The simulation project is maintained.
  • All ports are however set to 0. To receive working port numbers, open the project in the Editor. At this new port numbers are entered automatically. Port numbers can also be assigned manually.

attention Attention

Drivers that are linked to a zenon Logic project using the integrated solution cannot be exchanged.


XML export/import

Manual -> Driver simulation -> Simulation - programmed -> Editor -> XML export/import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A project in mode Simulation - programmed can be exported via XML. It can however not be imported as new project for another driver.

Workaround:

  1. Export the zenon Logic programs.
  2. Import them to the new project for the new driver.
  3. Replace the variables via search and replace.


Driver configuration

Manual -> Driver simulation -> Simulation - programmed -> Driver configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There are four modes available when configuring the driver:

  • Hardware
  • Simulation - counting
  • Simulation static
  • Simulation - programmed

Select the simulation - programmed mode.


Driver variable status

Manual -> Driver simulation -> Simulation - programmed -> Driver configuration -> Driver variable status

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The status of zenon Logic is shown in the driver variables SimulRTState at Offset 60. The variable is numerical and cannot be written to. The value informs you of the status of Runtime:

Bit | Meaning | Description
31 | without application | Runtime has not loaded a program, the program was stopped or not loaded to Runtime.
30 | not instanced | Runtime was not instanced, for example because the DLL with Runtime could not be loaded, there is too little memory, the DLL is not present or is the wrong version.
18 | p-code available | p-code is available together with compiled code, switching is possible.
17 | compiled code active | Runtime runs with compiled code (otherwise: interpreted p-code)
16 | compiled code available | Compiled code from the C compiler is available
15 | application is loaded | An application is present, Runtime is running
14 | can't start - missing handlers | Some "C" functions are missing
13 | active breakpoints installed | At least one breakpoint was set by the debugger.
12 | CT segment exists | Application was compiled with the "complex variables in separate segment".
11 | Reserved | (internal, for Runtime only.)
10 | sysinfo request is available | (internal, for Runtime only.)
9 | freeze event production | Binding does not transmit events.
8 | single cycle mode | (intern, for Runtime and debugger only.)
7 | Reserved | (internal, for Runtime only.)
6 | locked variables | At least one variable is blocked.
5 | trigo functions are in degrees | Trigonometric functions are stated in degrees.
4 | log message(s) in stack | (internal, for Runtime only.)
3 | application stopped between 2 progs | Runtime stopped between two steps during debugging
2 | application stopped on SFC breakpt | (internal, for Runtime only.)
1 | application stopped on error | Runtime stopped with a serious error, restart required.
0 | application is running | TRUE = application is in "run" mode. FALSE = application pauses in "cycle to cycle" mode.

info Information

The driver variable SimulRTState with Offset 60 displays the status of Runtime on the server. This is also true when the variable is displayed on the Standby.


Cyclical synchronization

Manual -> Driver simulation -> Simulation - programmed -> Driver configuration -> Cyclical synchronization

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Simulations run in a network on the server and Standby Server independently of one another. When the Standby Server starts, there is a synchronization with the server, however:

  • This first synchronization is postponed by the packet runtime
  • Small differences in the execution lead to growing diversion

The status of the simulated variables also therefore becomes different. In order to keep these differences low, use the Transfer driver simulation image to standby to synchronize the simulation image:

  • create a new function
  • Select Transfer driver simulation image to standby

  • The dialog to select the driver opens

  • In the list, all process-connected drivers (with the exception of the simulator) are available (clicking on the column heading changes the sorting)
  • Select the driver that is to be synchronized
  • Each time a function is called up on the Standby Server, an image is requested from the server for the selected driver

The differences in the current simulation status can be minimized through cyclical activation. Adapt the grid of the execution to the extent of the data to be synced, because this places a load on the network and computer.

The Execution of the function is set at Standby Server and fixed; it cannot be changed. It only happens if:

  • The computer is the Standby Server
  • The Server is online
  • The project is a network project
  • Drivers were selected for syncing

To change the selection of the drivers

  • In the driver properties, click in the General group in the Parameter properties
  • The dialog for selecting the driver opens


zenon Logic Workbench

Manual -> Driver simulation -> Simulation - programmed -> zenon Logic Workbench

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Simulation - programmed is programmed in the in the zenon Logic Workbench, which works in close conjunction with the zenon Editor. For the simulation, (in contrast to the integrated solution) only the variables of a driver are exchanged between the editors.

Definition of the variables to be exchanged:

When starting zenon Logic Workbench, all driver variables that are not yet present in zenon Logic are created as global variables. The Embed symbol is automatically activated for these.

Visibility

If a new variable is defined in Workbench in the global or retain area, this is only visible in zenon Logic. To make it visible in zenon too, the Embed symbols option must be activated. From this point in time, all variables are updated by both editors.

If the Embed symbol option is deactivated, the variable is deleted in the zenon editor. This action enables global or retain variables to be defined in zenon Logic, which are not visible for zenon.

For a newly-created variable created by the zenon Logic Workbench in zenon, an attempt is made to assign this to the SPSMERKER area. In the event that the zenon driver does not support the configured data type, a search is made for the first data area that supports the data type. If no area is found, the variable cannot be created.

A variable is only locked if in the case of a multi-user project and the enable changes status has not been set.

Project Settings

Some settings under Project -> Project parameters... >-Further options-> Extended in zenon Logic influence the functionality of the simulation.

Extended settings

Description

Runtime: execute mode

Recommendation:

Mode: triggered

cycle time: 1/4 to 1/3 of the driver update time
for frequent value changes to simulated variables lead to increased load placed on the computer.

compiler/options: Embed symbols of all variables

Recommendation: Deactivate.
Active: Data for a variable are exchanged, because the symbol names are assigned in Runtime.

But: Changes to the configuration of the variables are not updated between zenon and zenon Logic. It is no longer possible to make changes online.

compiler/options: Retain capitalization of symbols

without effect: Variable names are always converted to capitals in Runtime.

compiler/options: Create status bits for variables with a profile

Active: The status of variables is simulated or reacted to in the simulation program.

"C" compiler

Native code is supported.

Name of the DLL that the compiled code must contain: t5app.dll.


Runtime

Manual -> Driver simulation -> Simulation - programmed -> Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


Functionality

Manual -> Driver simulation -> Simulation - programmed -> Runtime -> Functionality

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon Logic Runtime offers the following functions:

  • File transfer
  • Data types:
    • BOOL
    • BYTE
    • DINT
    • DWORD
    • INT
    • LINT
    • LREAL
    • REAL
    • SINT
    • STRING
    • TIME
    • UDINT
    • UINT
    • USINT
    • WORD
  • zenon arrays (see also Arrays and simulation)
  • Date stamp/time stamp
  • Digital recording of values
  • Dynamically linked function blocks, stored in t5block*.dll
  • Hot Restart
  • Logging:
    • Trace messages from the program (printf)
    • Error messages in Runtime
    • all sent to Workbench and to the diagnosis server
  • Machine code: Native compiled code with C post compiler (not available under Windows CE)
  • Online Change
  • Programming languages: IL, AS, FDB, LD, ST
  • Retain Data (remanant Data)
  • Special function blocks and features:
    • Data serialization
    • dynamic memory allocation
    • embedded recipes
    • embedded variable lists
    • File Management
    • Files
    • Math
    • Random
    • Signals
    • String tables
    • Trigonometry
    • Time
  • Spontaneous communication
    • Value change as an event
    • 16 connections
    • Hysteresis
  • UDP & TCP/IP for IEC languages
  • Variable interlocking


Arrays and simulation

Manual -> Driver simulation -> Simulation - programmed -> Runtime -> Arrays and simulation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To simulate multidimensional arrays at driver simulation, you must activate property 'Save complex variables in own segment' in the zenon Logic Workbench.

Arrays with start index 1

If at a simulation arrays with start index 1 exist, these arrays are created with one more index in the zenon Logic Workbench.

Example Example

In zenon an array has indices 1 to 4. This array has the indices 0 to 4 in the zenon Logic Workbench.

This guarantees that the same indices are used in zenon and in zenon Logic. Index 0 is not transferred to the driver.

If you change array in the zenon Logic Workbench, you must consider this additional index.


Runtime files

Manual -> Driver simulation -> Simulation - programmed -> Runtime -> Runtime files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When creating the Runtime files, a subfolder with the name of the simulation project is created in the Runtime folder of the project in the path \RT\FILES\zenon\custom\drivers. The file with the code of the simulation is simulrt.cod and is archived in this folder.

Once successfully compiled in the Workbench and transferred to the Runtime folder, the following message is shown in the output window of the Editor:

SIMULRT.COD

And if compiled with the C compiler, then also:

T5APP.DLL

Remote Transport

The Runtime files for the simulation are created as a subfolder of the driver files. For remote transport, the and all information contained in it is transferred to the target computer


Data exchange

Manual -> Driver simulation -> Simulation - programmed -> Runtime -> Data exchange

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The exchange of data from zenon Logic Runtime to the driver starts with the 2nd cycle of zenon Logic Runtime. Therefore the first run is available to initialize all variables in Runtime.

Data is only exchanged if:

  • The variable is requested and:
    • did not yet receive a value
    • does not have the status Switched off (OFF/_VSB_N_UPD) or Alternate value (ALT_VAL/_VSB_AVALUE) in the driver
    • is still required by the driver.
    • has changed value or status

The exchange of data to the driver is carried out asynchronously to the Runtime cycle. The driver runs through the value changes once per update cycle. All values changed - with the exception of the Switched off (OFF/_VSB_N_UPD) or Alternate value (ALT_VAL/_VSB_AVALUE) status - are entered into the list of variables to be updated in the driver and sent to Runtime.

Transfer driver simulation image to standby function

This function is only executed on the Standby Server (for configuration, see Cyclical comparison chapter). The data is synchronously fetched from the driver on the server that is compiling the image. The driver has 5 seconds of time for this. Because the data for the image is created in the same thread in which the simulation is running, it must be ensured that the simulation is processed within 5 seconds. If this time is exceeded, no image is transferred for this driver.

Value simulation

Value changes are not transferred immediately, but stored in a buffer. The size of the buffer amounts to 8192 value changes or the five time the number of variables, according to whatever value is greater. The delay in transferring resulting from the driver cycle can be up to 100 ms. If the value changes again whilst it is waiting to be transferred, all values that have not yet been transferred are sent to Runtime and the new value is then noted. This can lead to an increased load for the computer and network, but ensures that all values are transferred in Runtime.

Driver write command

If simulation - programmed is configured and active, the write commands at standby are passed through in Runtime.

Write operations are carried out by the driver asynchronously to Runtime. Data is exchanged via a buffer. The size of the buffer amounts to 8192 value changes or the five time the number of variables, according to whatever value is greater.

Write commands are ran through after their values are changed in Runtime. If a write command cannot be executed correctly, the error message Write queue full! Write command for <DP-Name> lost! is displayed.

If the status bits are activated, setting Writing successful will display if the value was written from the driver to the value of the variable. The Runtime program should delete this status again after processing the write command. A status bit that is already active does not cause any delay in the driver writing again. Write commands are also executed if the Runtime program was stopped by a breakpoint.

Note: Not all write commands from the driver must be visible in Runtime. If several write commands are in the buffer,only the last one is visible in Runtime.

switch off variables, switch to substitute value

If the variable is switched off or switched to a substitute value, this is not recognizable for Runtime. Changes in values that are also carried out by Runtime are not assigned to the variables in the driver. If the variables are again switched to spontaneous value or activated, the current value is again carried over from Runtime to the driver. When turning off the spontaneous value, status bit OFF is set. When you switch back to the spontaneous value, the OFF bit is reset.


Data storage

Manual -> Driver simulation -> Simulation - programmed -> Runtime -> Data storage

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Retain Data

Retain data is stored in the SimulRt<TreiberID>.ret file. One file such as this is created per simulation, provided retain variables are present. The file is taken into account when a comparison is carried out in the network.

Driver remanent

The Simulation - programmed setting at the driver start is not a criterion in order to restore the remanant variable image.


Redundancy

Manual -> Driver simulation -> Simulation - programmed -> Runtime -> Redundancy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Start on the Standby Server

If the driver is already running on a Standby Server, then the image for the simulation should already be available. In this case, the simulation is started "hot" with this image. If there is no image, a warm a start is carried out.

Transfer driver simulation image to standby function

This function is only executed on the Standby Server (for configuration, see Cyclical comparison chapter). The data is synchronously fetched from the driver on the server that is compiling the image. The driver has 5 seconds of time for this. Because the data for the image is created in the same thread in which the simulation is running, it must be ensured that the simulation is processed within 5 seconds. If this time is exceeded, no image is transferred for this driver.

Synchronization

In addition to the program files of the simulation, the following are also compared:

  • Retain data (*.ret)
  • all *.simul files
    This file extension is created by the simulation program for simulation specific files and archived in the folder with the computer description below the Runtime folder.


Status

Manual -> Driver simulation -> Simulation - programmed -> Runtime -> Status

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Status simulation

For the status simulation, in zenon Logic under Project -> Project parameters -> Extended -> Compiler -> Options -> Create status bits for variables with a profile must be active. If the status of a variable is modified, this triggers the transmission of a variable to the driver.

Changes to the following states does not trigger a value change at the driver and is also not taken over from the simulation:

  • Real time external (T_EXTERN/_VSB_RT_E)
  • Real time internal (T_INTERN/_VSB_RT_I)
  • Standard time (T_STD/_VSB_WINTER)
  • Writing acknowledged (WR_ACK/_VSB_WR_ACK)
  • Writing successful (WR_SUC/_VSB_WR_SUC)
  • Normal status (NORM/_VSB_NORM)
  • Deviation from normal status (N_NORM/_VSB_ABNORM)
  • Select in the network (NET_SEL/_VSB_SELEC)
  • Runtime exceeded (TIMEOUT/_VSB_RTE)
  • In process (PROGRESS/_VSB_DIREC)
  • Switched off (OFF/_VSB_N_UPD)
  • Substitute value (ALT_VAL/_VSB_AVALUE)

info Information

State bit Writing successful (WR_SUC/_VSB_WR_SUC) is available in the Runtime program and can be set back in order to display successful writing.

However only setting back the state does not trigger the transfer to the zenon Runtime. Only value changes are transferred from the driver to the Runtime.

Status bits handled differently

The following status bits cancel each other out:

Bit

Description

17: Spontaneous
(SPONT/_VSB_SPONT)

Status Spontaneous is set. This is the status set if status handling is turned off or no status was defined. Status GI + INAVLID is deleted.

18: Invalid
(INVALID/_VSB_I_BIT)

Status INVALID is set. Status SPONTAN + GI is deleted.

16: General query
(GI/_VSB_GR)

Status General query is set. Status SPONTAN + INAVLID is deleted.

8: Select in the network
(NET_SEL/_VSB_SELEC)

If this status bit is active (BSO activation/deactivation) the following status bits are accepted with 0 and also transmitted as 0 to the driver to identify a change:

  • Select in the network (NET_SEL)
  • Cause of transmission (COTx)
  • Select (SE_870)
  • N_CONF (P/N-BIT)
  • Test bit (TEST)
  • Writing successful (WR_SUC)

select before operate (SBO)

Status simulation must be available in the Runtime program in order for Select Before Operate to be reacted to. The procedure for Select Before Operate is defined in Runtime.

Activation

If a SBO select is sent to the driver, it triggers a value being written with state Select in the network (NET_SEL) + cause of transmission (COT_act).

A corresponding SBO procedure must be implemented and must start in Runtime.

The state bit Select in the network (NET_SEL) must be set back in the Runtime program.

Deactivation

The deactivation triggers the writing of a values with status Select in the network (NET_SEL) + Cause of transmission (COT_deact).

The SBO procedure must be ended in Runtime accordingly.

The state bit Select in the network (NET_SEL) must be set back in the Runtime program.


Start / stop

Manual -> Driver simulation -> Simulation - programmed -> Runtime -> Start / stop

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Driver start

The value updating only starts at the Standby Server if the driver has received the process image from its server. The image must be received within the time out module, otherwise the driver will start without an image. If the Standby Server is upgraded to the server within the waiting waiting time, waiting is also ended. Drivers that start in a network project or without a network have no waiting time. This behavior applies for both the simulation as well as for the hardware mode.

Runtime start

If the driver starts the simulation - programmed, the first stage is loading the DLL with the simulation Runtime. After this, Runtime is parametered and the Runtime program starts, provided it can be successfully loaded.

If an image of Runtime is present, Runtime is started hot with this. Otherwise, a warm start is carried out. If this is also not possible, an attempt is made to start Runtime cold. If there is no valid program, Runtime boots up stopped. The status of all variables is set to INVALID.

The simulation program runs in it own thread and is therefore completely independent from the driver cycle.

info Information

Retain variables

Retain data contain only the value of the zenon Logic variables not their status. This means for the start:

  • Warm start: The status which was set for a variable is restored - regardless of whether it is a retain variable or not.
  • Cold start with retain variables: Only the value of the retain variable in zenon Logic is restored, not the status.

Stop Runtime

If Runtime is stopped, the status INVALID is set for all variables. Variables that are requested when Runtime is stopped have the status INVALID as initialization. Runtime secures the data for the warm start and online change:

  • SIMULRT.HOT: contains the data for the hot restart.
  • SIMULRT.UPD: contains the data for the online change.

Both these files are created in the Runtime program folder. Runtime must have write authorization for this folder.

Reload

  • Recompiling the simulation project:
    causes the corresponding driver to be reloaded.
  • Modification of the Time Out module:
    is not recognized as a change by Runtime and does not cause the driver to be reloaded.

Standard implementation in the driver kit triggers a hot restart when reloading the simulation project. If this is not possible (for example because the program is different), a cold start is carried out with retain.

Removing Runtime

If Runtime is running, this is stopped. Before Runtime is removed, all outstanding value updates are sent to the driver. Only then is Runtime released and SimulRuntime.dll removed from the PC.


Driver commands

Manual -> Driver simulation -> Simulation - programmed -> Runtime -> Driver commands

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Driver commands are used to influence drivers via zenon, e.g. start and stop.
The engineering is implemented with the help of function Driver commands.

Stop/start driver

If the driver is stopped in simulation - programmed mode, this will result in Runtime being removed from the memory. All variables obtain status INVALID. When the driver is restarted, the simulation is reloaded and Runtime is started.

Switch hardware/simulation driver

When switching between modes Hardware and Simulation, the driver behaves according to the following pattern:

  1. If the driver was configured for hardware mode in the Editor:
    • the driver is set to mode Simulation static after function Driver command is executed with parameter Driver in simulation mode.
  2. If the driver was configured in the Editor for one of the simulation modes (static, counting, programmed:
    • the driver is set to hardware mode and communicated with the control after function Driver command is executed with parameter Driver in hardware mode.
    • the driver then changes back to the configured simulation mode after function Driver command was executed with parameter Driver in simulation mode


Variable assignment

Manual -> Driver simulation -> Simulation - programmed -> Runtime -> Variable assignment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon driver is allocated to the zenon Logic variables via the names converted into capital letters. If the zenon Runtime requests a variable from the driver, it forwards this to the simulation. If no simulation is loaded, the variable receives status Switched off ( OFF/VSB_N_UPD) when the driver is stopped. Otherwise it receives status Invalid (INVALID/_VSB_I_BIT). Variables of driver variable object type are never requested by the simulation.


Time stamp

Manual -> Driver simulation -> Simulation - programmed -> Runtime -> Time stamp

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use the time stamp, in zenon Logic under Project -> Project parameters -> Extended -> Compiler -> Options ->Statusbit create for variables with profile must be activated.

If in the Runtime program, the date for a variable is set, the value of the date and time is used as the time stamp. When the date or time changes during the last cycle, this always triggers a transfer of the value to the driver. This also applies if neither the value nor the status have changed.

Most drivers only transfer a new time stamp if the value and/or status change at the same time. An example of an exception is the IEC870 driver, which also transfers new timestamps from the hardware (or Simulation - programmed) with the same value and same status to Runtime.

info Information

It must be ensured that the date and time always increase. If this is not the case, this can lead to problems when archiving. The date must be a value greater or less than 0.

Variables stamped by the Runtime program receive the status Real time external (T_EXTERN/_VSB_RT_E).

All variables to be transferred to the driver that are not stamped by Runtime receive a joint time stamp in the cycle. This ensures that the time corresponds to that of the change. These drivers receive the status Real time internal (T_INTERN/_VSB_RT_I).

Date & Time

The following applies for all date and time information:

  • Times are UTC.
  • All times must be between 02. 01. 1970 and 2038.
  • Dates are converted into a string in the format YYYY/MM/DD.
  • The time is converted into the format HH:MM:SS.


Pleas not for variables in simulation projects

Manual -> Driver simulation -> Simulation - programmed -> Pleas not for variables in simulation projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following is true for the creation and modification of variables in simulation projects:

  1. zenon Logic

    If variables are created for a simulation project in the zenon Logic Workbench, they do not have a valid addressing for the communication. If the communication is switch to hardware, the communication can be interrupted when the new variables are used in screens without a adjusting the addressing correctly.

  2. Rename

    If a variable is renamed in a simulation project, the name of the variable is also changed in zenon accordingly. So for example you must adjust the names of variables which are used in a VBA project also in the VBA code.

  3. Integrated solutions

    Variables of integrated solutions such as zenon Logic, IEC870 or IEC850 must not be renamed in the simulation project. In this case the variables lose their project information.
    For example: If you rename Project0/Global/NewVar to myNeVariablenwVar in the simulation project, it becomes myNewVar in zenon. After the renaming a communication with the zenon Logic Runtime is impossible.

  4. Communication based on variable names

    Variables of a driver which communicates based on the variable names must not be renamed in the simulation project.

  5. Deleting or importing variables

    If a variable is deleted or imported while online change is activated in zenon Logic, all variables are removed and inserted again in zenon Logic.

  6. Variables with active "embed" symbol

    Variables which exist in a program and whoses "embed" symbol is active are not available via the Shared Memory interface in zenon. If a variable with an active "embed" symbol is moved from the global area to a program, the variable is deleted in zenon.


Error messages

Manual -> Driver simulation -> Simulation - programmed -> Error messages

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Engineering in the zenon Editor

Error message

Cause and solution

The choosen name is already used for another driver or contains invalid characters! Please choose a different name.

The new name of the simulation project is already used in the project or is not valid.

  • Give it a valid name

The simulation project from the <File name>/<Description> driver has not been compiled and cannot be supported! Please compile the project in Workbench.

A simulation project is available for the driver in Workbench. This was not compiled however.

  • Start the zenon Logic Workbench with this driver's simulation project
  • compile the project

Hint: I does not make a difference if the diver settings are set to simulation - programmed in the driver settings

Write queue full! Write command for <Name Variable> lost!

Displays the loss of a write command.


Energy Edition

Manual -> Energy Edition

zenon Energy Edition is a package with special functionality for the energy sector and the procedural technology. The user benefits from easy-to-implement functions that allow for an individual adjustment of the application to the physical environment.

tutorial License information

Must be licensed in Editor and Runtime.

The following is available for the Energy Edition:

  • Command Processing
  • ALC (Automatic Line Coloring): Already included in the license for Energy Edition, provides basic properties for line coloring.
  • Command sequences
  • Topological element transformer
  • Topology package: Requires additional licensing on the server (not on the client) and expands ALC by:
    • Multiple supply
    • Secured supply
    • Topological interlockings
    • Topological element disconnector
    • Error detection and ground fault search


Automatic Line Coloring (ALC) - Topology

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The topological coloring of lines allows easy automatic dynamizing of tubes in technology (for media) as well as in the energy distribution (for electricity). So process controlled coloring of topological nets can easily be realized.

Because the tube structure is designed in the screen with all its technological elements (e.g. tanks and valves, or generators, switches and consumers), it is internally emulated as a model and the media flow is displayed in the Runtime.

In order to allow screen-overlapping models the entire design and configuration is always project-wide. You therefore have one entire topological model per project, which is used for the calculation of the tube statuses and ultimately for the coloring of the tubes.

The whole topology is created automatically from the graphic design. No other engineering actions are necessary.

info Information

The ALC algorithm only runs through once from a source starting from each switch.

Detail screens

To display individual screens, a partial area can be taken from the topological network and displayed individually by means of alias. A detail screen can be displayed with the data from different equipment parts, for instance outputs or partial networks.

tutorial License information

Must be licensed for Editor and Runtime (single-user, server, standby).

No need to be licensed for Runtime client.

Licensing is carried out using the zenon Energy Edition.

  • ALC: Included in the license for Energy Edition; provides basic properties for line coloring.
  • Topology package: Requires additional licensing on the server (not on the client) and expands ALC by:
    • Multiple supply
    • Secured supply
    • Topological interlockings
    • Transformer and separator topological elements
    • Error detection (version 6.50 and above)


ALC elements

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> ALC elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Automatic Line Coloring (ALC) makes it possible to color lines regardless of the process status. The combined element is used as the process element. Automatic line coloring allows easy automatic dynamizing of tubes in technology (for media) as well as in the topological networks (for electricity).

Engineering

For the design two types of screen elements with different functions are distinguished. On the one hand these are procedural elements (source, switch/disconnector, drain, transformer or link) and on the other hand lines.

In doing so, the technical elements have a function and a color (source and transformer). If the procedural elements are active, the connected lines take on the color of these elements at the source and transformer or they take on the color of the element's input line for the switch and the link. If the procedural elements are inactive, the color of the lines is taken from the definition in the editor.

The different functions of the elements are assigned in the properties of the combined element.

Example

A source has a connected line. A switch is connected to the line. And a second line is connected there. If the source is active, the first line is colored with the color of the Automatic Line Coloring defined in the source up to the valve. The other line is not colored before the switch is closed.

Source inactive

Source active

Switch closed

Undefined or invalid

info Information

If the procedural element status is undefined or malfunction, this is automatically detected. All connected lines and all further elements are displayed in the color of the predefined source undefined' for both states.

Number of closed switches in a series

For the correct functioning of the ALC algorithm, the number of connected switches in a series plays a role.

Recommendation: Arrange a maximum of 256 closed switches in a series between the source and the drain.


Procedural elements

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> ALC elements -> Procedural elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Procedural elements are created in zenon with a combined Element. Their state determines the coloring of the connected line.

The following settings are available:

Property

Description

Function type

Defines the technological type of the Combined element.
  • Terminator

For bus bar ends. Blocks the error message "Line only connected on one side" when being compiled in the Editor.
  • Generator

A generator generally behaves like a source, but it is considered as independent an not net-synchronous.
  • No function

The element has no function in the ALC.
Note: The "no function" function type is the default value.
  • Link

With a link a line can be continued on some other place. If a link is supplied by a line, all other links with the same link number also are supplied by this line. Here it does not matter, whether the links are in the same screen or on different screens in the project. So screen independent lines can be defined. It is possible to have more than two links with the same link number in one project.

Links can be supplied by several lines at the same time or can themselves supply several lines. In principle there is no difference between inputs and outputs. The source information is passed on to all connected lines.
Attention: Two link elements cannot be connected directly to one line. In between, there has to be at least one other procedural element (switch/disconnector or transformer).
A link cannot be switched active or inactive: it always is active.
  • Source

Passes on its color. If the source is active (value: 1), all connected lines that have Color from ALC option set in the element properties are allocated the color of the source. The color is defined in the project properties as the source color. (e.g. tanks or generators). A source is a single pole with a static source number assigned to it. The source is switchable over the state of its main variable. Generally, sources are considered as net-synchronous and detachable.

You can find details on the source in the configuration of the sources chapter.
  • Switch

With this lines can be split. If the switch is closed/active (value: 1), then the connection between the two lines is closed and the line is colored up to the next switch with the defined source color. In this case a switch forwards the source color of the input line to the output line.

If the status of the switch is malfunction, undefined or INVALID, the color of the line turns into the color undefined from the ALC configuration in the project properties. A switch thus delivers source number 0 (undefined) to its output (connection 2) instead of the incoming source number.

Example: see Switch example - colors from ALC section.
  • Valve

A slider (a valve) acts in a similar manner to a switch, but it is used for water and gas lines.

Value of the main variable:

Switch OFF: Value 0 -> Slider closed-> No water flow

Slider ON: Value 1 -> Slider closed completely-> No water flow

Slider DIF: Value 2 -> Slider partially open-> Water flow

Slider STO: Value 3 -> Slider malfunction
  • Drain

This defines the end of the line. The drain does not influence the coloring; it is only used so that the model can be displayed in full. If an external program (e.g. VBA) should access the model, then the drain probably is needed for further calculations, and so has to be inserted.
In Energy projects, the drain is used for representing consumers. These customers are considered for the calculation of the ALC interlockings (command groups) 'Consumer is undersupplied'.
  • Transformer

A transformer is a drain and a source at the same time. SO with a transformer the input color (input source) can be transformed to a new output color (transformer source color).
The output connection is only active, if the transformer is switched active. However the output line does not get the color of the input line as with a switch, but instead the color of the transformer's own source. A source must therefore be defined for each transformer. A transformer cannot be switched active or inactive, it always is active.

Reverse-feed-compatible transformer:

To have a transformer capable of reverse feed, you must select, for Source for reverse feed, a different source than UNDEFINED [0]. This means that the transformer behaves the same in both directions - from the input to the output (forward) and also from the output to the input (backward). The only difference is that the Source for reverse feed property and not the Source property is used for further distribution of the source number .

Note: Defective network statuses or missing configurations, such as a feed from the input and output at the same time or a short circuit from input and output are not specially colored. This means that the transformer capable of taking a reverse feed behaves like two transformers switched to run antiparallel that are not capable of taking a reverse feed.

Disconnector

A disconnector generally behaves like a switch. Nevertheless, a disconnector may not be connected in the topological model. A status (on, off, intermediate position, malfunction) is determined via its main variable.

Source and link number

Parameters | Description
Source | Here a source is assigned to an element. In this selection box all sources defined in the ALC configuration (in the project properties) are available. All source names are listed. This property is only active if the function type 'source', 'transformer' or 'generator' has been selected. You can find details on the source in the configuration of the sources chapter.
Link number | Only the link number is entered for a link function. All identical link numbers in a project correlate with each other. Detailed description in the function type Link. This property is only active, if the function type link has been selected.

A variable of the IEC type BOOL or integer has to be linked to the element as the main variable, so that the switch can get the status (open, closed, invalid). In the same way, the source gets its status (active/inactive) from the linked main variable.

For the function types source and transformer the defined source number is forwarded to the consumers (drains) over open/closed switches. The statuses and colors of all connected lines are calculated from the superposed sum of the supplying source numbers and procedural elements.

info Information

Only the first two bits are considered for the switching. The first bit stands for the actual switching. 0 equals off and 1 equals 1.

The second bit is the error bit. There is no error only if it is 0.

States

  • A switch and a source are switched on if the value of the linked variable is 1.
  • A switch is invalid if the value of the linked variable is >1 or has an INVALID status.
    An invalid switch provides the source number 0 (undefined) at its exit (connection 2) instead of the source number entering. In the direction towards the input the switch behaves as normal.

    Note: if the (acknowledgment) variable has the status INVALID, the whole subsequent network is INVALID, because the status of the network is not known. The status INVALID is forwarded (routed) using subsequent closed switches.

attention Attention

If in the single status the color and the fill color from the ALC is activated, also the procedural elements are colored by the status of the connected lines in the Runtime.


Switch example - colors from ALC

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> ALC elements -> Procedural elements -> Switch example - colors from ALC

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Example 1

Combined element with value status 00 and line color from ALC:

  1. Configuration in the Editor:
    • Combined element with value status 00
    • Line color from ALC active

  2. Results in the following in Runtime:
    • Source color: green
    • Color without voltage: white
    • Switch status: off/open (value 0)

Example 2

Combined element with value status 01 and colors from ALC:

  1. Engineering in the Editor
    • Combined element with value status 01
    • Line color from ALC active
    • Fill color from ALC active

  2. Results in the following in Runtime:
    • Source color: Green
    • Color without voltage: White
    • Switch status: on/closed (value1)

Example 3

Combined element with value status 00 without colors from ALC:

  1. Configuration in the Editor:
    • Combined element with value status 00
    • Line color from ALC not active

  2. Results in the following in Runtime:
    • Source color: Green
    • Color not energized and construction color of the line: White
    • Defined line and fill color of the combined element: black
    • Switch status: off/open (value 0)

Example 4

Combined element with value status 01 without colors from ALC:

  1. Engineering in the Editor
    • Combined element with value status 01
    • Line color from ALC inactive
    • Fill color from ALC inactive

  2. Results in the following in Runtime:
    • Source color = green
    • Color not energized and construction color of the line: White
    • Defined line and fill color of the combined element: black
    • Switch status: on/closed (value1)


Connection points of procedural elements

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> ALC elements -> Procedural elements -> Connection points of procedural elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When configuring, a line is connected to a procedural element (combined element) by overlapping drawings in the screen at connection points of the combined element. Only one line can be connected to the same connection point at the same time. All lines that start within the area defined, are connected (Topology from the graphic).

attention Attention

Use ALC elements only in un-rotated state because:

The calculation for the topological model for the ALC in the Editor is based on the position of the elements in un-rotated state and without considering any dynamics.

Connection points and connection areas

  • The connection area for a connection point is in the middle of each side of the combined element. Each combined element thus has four connection points.
  • The size of a connection area corresponds to 2/3 of the height and width of a combined element, but no more than 20 pixels.
  • Each connection area is centered in the middle of the respective element corner and stretches symmetrically inwards and outwards, to a maximum of 10 respective pixels.

attention

If the combined element is less than 30 pixels, connection areas within an element overlap. Lines that could touch can cause errors (compilation, coloring).

You can see the possible connection points for combined elements smaller and larger than 30 pixels in the illustration.

Colors

  • Red: Combined element
  • Blue: Connection areas

Dimensions:

  • A: height of the Combined element
  • B: width of the Combined element
  • a: Width of the connection area: 2/3 of A, but a maximum of 20 pixels.
  • b: Length of the connection area: 2/3 of B, but a maximum of 20 pixels.

Rules

  • If a line is outside the connection area, no connection is detected and there is thus no coloring of the line. So there will also be no coloring for further lines.
  • With sources, drains and Links, all described connection points can in principle be used.
    Attention: With sources and drains, only one connection point can be used at the same time. If different connection points are used at the same time, undefined states can occur.
    Elements of the type Link can also use several connection points at the same time. The incoming color information is passed on to all lines.
  • With switches/disconnectors/sliders and transformers, the connection 1 (supply) is on the left or on the top and connection 2 (output) is on the right or on the bottom. This sequence can be changed with the Switch input/output property.
    Attention: At switches and transformers it has to be cared, that only one input connection and one output connection is used. The simultaneous use of several input or output connection points results in inconsistencies and is therefore not reliable.
  • For all procedural elements the following is true: Only one line can be connected to a connection point. Junctions cannot be realized directly on an element but must be drawn with lines.


Switch input/output

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> ALC elements -> Procedural elements -> Switch input/output

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If a transformer, disconnector or switch is configured, the input and output can be switched. To do this:

  1. Select either transformer, disconnector or switch as a Function type
  2. activate the Switch input/output check box

The input is then placed at the right or at the bottom and the output is placed left or at the top.

Overview

Configuration device | Input | Output
normal | Left | Right
normal | top | below
swapped | Right | Left
swapped | below | top


Lines

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> ALC elements -> Lines

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Lines are represented by vector elements Line, Polylines and Tube.

If the option Color from ALC is activated for a line, the coloring is defined by the ALC configuration. Lines are automatically colored by the system depending on the status of the procedural elements and the ALC settings.

Here the color usually comes from the highest priority source number of the media flowing through the line, or stays "empty/not energized" just as defined in the screen with static or dynamic colors.

You define the display type by means of drop-down lists:

  • Priority for display
  • Display multiple supply
  • Display secured supply

The following options are available in the properties of the lines:

Parameters

Description

Color from ALC

Activates the automatic line coloring for these vector elements. That means: If the source for the line is active and all switches/valves leading from the source to the line are closed/open, the line is accordingly colored. If the line is fed by a single source, the defined source color is used for coloring the line. The line width is not changed.

Priority for display

Defines if multiple supply, secured supply or both are displayed.
Default: Multiple supplies

Secured supply

The element is displayed according to the rules of the secured supply.

A line is then considered to have a secure supply if it is supplied by at least two different switches or transformers with a non-system source. System sources do not contribute to secured supply, but do not exclude it.

Multiple supplies

The element is displayed according to the rules of the multiple supply.

A line is considered to have multiple supplies if it is supplied by at least two different sources. In doing do, it does not matter if they are system or user sources and from which side the line is supplied by the sources.

No priority

The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met. That means:

If a line

  • has multiple supplies and a secured supply,
  • The priority is set to No priority,
  • The display for multiple supply is set to two sources with highest priority,
  • The display for secured supply is set to double width,

then the line is twice as wide and displayed as a dashed line in two colors.

display multiple supplies

Multiple supply means that a line is supplied by multiple sources at the same time. Here you can define how lines with multiple supply are displayed.

Default: highest priority source

highest priority source

The line gets the color of the source with the highest priority.
Note: Priorities correspond to the sequence chosen in the ALC configuration.

two highest priority sources

Applies for lines fed by two or more different sources. The two sources with the highest priorities define the coloring. The line is displayed with the these two colors (dashed). The dash length can be changed using the Dashing length supplied multiple times property.

System sources apply fir multiple supplies just as with genuine sources and color lines in two colors it they are configured accordingly.

Alternative color

The color defined in the Alternative color property is used.

Dashing length supplied multiple times

Defines the dash length (in pixels) of lines, polylines or tubes for the dashed ALC coloring for two sources with the highest priority for display multiple supplies.

  • Minimal: 0 (automatic dash length)
  • Maximum: 32767
  • Default: 0

Alternative color

Alternative color for the ALC coloring of lines, polylines or tubes with multiple supplies.

display secured supply

Secured supply means that a line gets multiple supply from one source (parallel). Here you can define how 'secured supply' is displayed.

A line is always displayed as having a secure supply if it is supplied by at least two switches with a genuine source (not system source).

Default: normal

double width

Relevant for lines fed in parallel by the same source. If this is the case, the line is displayed with double the configured width. (Example: A line with line width 5 pixels is displayed with 10 pixels if secure-fed.)
If this line is fed by two or more different sources (multi-supply), the line width does not change!

The color is always defined by the source with the highest priority!

double brightness

Relevant for lines fed in parallel by the same source. The line is displayed with double the original brightness.
If this line is fed by two or more different sources (multi-supply), the line color does not change!
If this line is multi-fed from one source (secure supply), the line is displayed with double the original brightness.
Formula for the calculation of the double brightness:

  1. The defined RGB color is transformed to the HLS system.
  2. L (luminance = brightness) is recalculated with NewLuminance = 240*3/4 + L/4
  3. The color value is recalculated to the RGB system with the new brightness.

The color is always defined by the source with the highest priority!

normal

The element is displayed in the color of the source and with the configured width.

Use alias

Active: Alias is used.

Alias

Opens the dialog for selecting a model.

info Information

The source color and the priorities of the sources are defined in the project properties.

User-defined sources must have a higher ID than 9. IDs up to 9 are reserved for system sources.

info Information

The calculation of the color of a line in the Runtime is done with the following priority list:

  1. Automatic Line Coloring (highest priority, overrules all other settings)
  2. Dynamic colors
  3. Static colors


Example

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> ALC elements -> Lines -> Example

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the following example Source 0 has the color blue and Source 1 has the color red. And Source 0 is the source with the highest priority.

Source 0

Source 1

This results in the following displays for the different options:

 | Line / Polyline | Pipe
highest priority source |  |
two highest priority sources |  |
double width |  |
double brightness |  |


Connection points of lines

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> ALC elements -> Lines -> Connection points of lines

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The connection of one line (line, polyline or tube) to another line is done with overlapping drawing in the screen at connection points. The connection points - either connection areas - are at the start and the end of each line and are around 3 pixels large.

Example Example

The start point of a line has the coordinates (start point x/start point y): 150/100 pixels.
This results in a connection area (x / y): 147 - 153 / 97 - 103 pixels.

If the line start or end of this line and that of one or more other lines is within this area, the lines are automatically connected without any further engineering. A mere overlapping of the connection areas of the single lines is not sufficient!

In the following illustration the connection area is displayed graphically (the green lines are connected to the black one, the red line not.

info Information

Any number of lines can be connected in a connection area.

attention Attention

If a line is outside the connection area (e.g. the red line in the illustration), no connection is established and there is no coloring of the line. So there will also be no coloring for further lines.

Line crossings can easily be realized, if the ends of the lines are not in the connection area.

attention Attention

Use ALC elements only in un-rotated state because:

The calculation for the topological model for the ALC in the Editor is based on the position of the elements in un-rotated state and without considering any dynamics.


Checking the engineering

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> ALC elements -> Checking the engineering

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Engineer the desired procedural elements and lines in one or more screens and save these screens. Then you can check via Create all Runtime files or Create changed Runtime files whether there are any errors or conflicts in the screens. If error and/or conflicts should exist, corresponding error messages or warnings are displayed in the output window.

info Information

Double click the corresponding line in the output window. The screen with the erroneous screen element will be opened automatically. If the erroneous screen element is part of a symbol, the corresponding symbol is automatically selected.

The following error message can be displayed.

  • ALC: Screen '%s' - Two Link elements with different Link number are connected to line '%s' . (Double click opens the screen and selects the line.)
  • ALC: Screen '%s' - More than two connection points are used at element '%s'. For each element only one input and one output may be used. (Double click opens the screen and selects the element.)

The following warnings can be displayed.

  • ALC: Screen '%s' - Alias line '%s' is connected to a no-alias line. (Double click opens the screen and selects the line.)
  • ALC: Screen '%s' - Alias element '%s' is connected to a no-alias line. (Double click opens the screen and selects the element)
  • ALC: Screen '%s' - No-alias element '%s' is connected to an alias line. (Double click opens the screen and selects the element)
  • ALC: Screen '%s' - Line '%s' is only connected on one side. (Double click opens the screen and selects the line.)
  • ALC: Screen '%s' - Element '%s' is not connected. (Double click opens the screen and selects the element)
  • ALC: Screen '%s' - Element '%s' is only connected on one side. (Double click opens the screen and selects the element)

In the error messages or warnings the corresponding elements are identified using the element reference. This reference also serves as the link key for ALC aliases.


Configuration

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure ALC:

  1. In project properties, select ALC configuration the property in the Automatic Line Coloring group
  2. Click on the ... button
  3. The dialog for configuration is opened
  4. Configure the desired properties for:
    • Sources
      (note also the principles for Coloring for UNDEFINED.)
    • Interlockings
    • Screen marker


Configuration of the sources

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Configuration -> Configuration of the sources

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The sources, e.g. their names and colors (sequence and priority), are configured project-specifically within the project properties under 'ALC configuration'.

Source colors

Parameters | Description
Number | Internal unique consecutive number, so that the source can be identified. This number is given by the system automatically and cannot be changed. Attention: IDs 0 to 9 are reserved for the system sources and must not be used user-specific.
Name | Logical name for the source (e.g.: 'water' or 'grounded'). This name is also used when selecting the source number for Combined elements. You can change the name by clicking it with the left mouse button. With this edit mode is switched on. The changes are accepted with Enter or by selecting another source. Note: The labels are not language switchable.
Line color | Line color of the respective source. This color is used for coloring lines, polylines and as the outside color of tubes.
Dashed | Check box for activation. If active, the line is drawn as dashed. Note: This check box is only active for GROUNDED. This check box is grayed out for all other sources.
New | Adds a new color.
Delete | Deletes the selected color.
Upwards (arrow symbol) | Moves selected source up one position.
Fully upwards (arrow symbol) | Moves selected source to the start of the list.
Downwards (arrow symbol) | Moves selected variable down one position.
Fully downwards (arrow symbol) | Moves selected source to the end of the list.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

The colors can be configured directly by entering the corresponding hexadecimal code or by using a color palette.

For direct input:

  1. Click on the color description with the left mouse button
  2. The field is switched to editing mode
  3. Enter the code
  4. Press the input key or select another source in oder to accept the change

To select via a color palette:

  1. highlight the desired line
  2. click on the ... button behind the color
  3. Online help is opened.
  4. select the desired color

The hexadecimal code describes the RGB color value and consists of the following. #RRGGBB.

Element | Meaning
# | Identifier to indicate that a hexadecimal color code is used.
RR | 2 digits are the red value of the color in hexadecimal system. 0-255 is 0-FF
GG | 2 digits are the green value of the color in hexadecimal system. 0-255 is 0-FF
BB | 2 digits are the blue value of the color in hexadecimal system. 0-255 is 0-FF

info Information

The sequence in this list represents the priority of the sources, with the first element having the highest priority.

To change the priorities of the single sources, they can be moved upwards or downwards using the arrow buttons

attention Attention

Limitations when deleting the sources and resetting erroneous colorings:

Sources with ID between 0 and 9 are reserved for system sources. They can:

  • Not be deleted:
  • Not be reset as an erroneous color

Deleting sources

In order for sources to be able to be deleted, they must have an ID from 10. Only the source with the highest ID can be deleted.

Resetting erroneous colorings

In order for erroneous colorings to be able to be reset once the cause has been rectified, no system source colors can be used. A color for IDs from 10 must be selected.


Coloring mode for UNDEFINED

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Configuration -> Configuration of the sources -> Coloring mode for UNDEFINED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Coloring in the network can be implemented in two modes with the UNDEFINED status:

  • Standard
  • Input takes priority

This setting is made using the Automatic Line Coloring/Mode for coloring project property.

Standard

The graph search starts with a source and goes through the whole network, so that each closed switch (switch variable has the value 1) per direction is only gone through once, so no cycles occur. In doing so, each node visited (=line segment) is colored with the source color. The directly-related lines are marked as a node.

If the search finds a switch that has a switch variable with the following status, the UNDEFINED color is used for coloring from this point onwards:

  • INVALID [values: any desired],
  • is invalid [value: 3]
  • is in intermediate position [value: 2])

The graph search is now continued in the same form. Each switch is gone through just once per direction with the UNDEFINED color. Therefore each switch can be gone through a maximum of four times per source:

  1. with source number in forwards direction,
  2. with source number in backwards direction,
  3. with UNDEFINED in forwards direction,
  4. with UNDEFINED in backwards direction,

Input takes priority

With the Supply takes priority setting, only lines that have a supply from at least one source but not clearly from any one source are colored as UNDEFINED. If a line is supplied with at least one source, it can no longer receive an UNDEFINED color from another source.

This search is a two-stage search:

  • In the first stage, as with Standard, the source color is distributed in the network from each switched source, as long as the next switch is closed. The search is ended if the switch is open or invalid/undefined.
  • In the second stage, the search is started at each invalid/undefined switch that receives a supply from one side and the UNDEFINED color is distributed to the unsupplied side. This search also considers the switches that are invalid/undefined as closed and thus distributes the UNDEFINED color in the network until it meets a clearly open switch. In addition, a search is ended if a line element is reached that is already supplied.


Configuration of topological interlockings

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Configuration -> Configuration of topological interlockings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

topological interlockings from the ALC for commands can be configured here.

info Information

This dialog is only available when both the "Energy Edition" and the "Automatic Line Coloring" modules are licensed.

The following conditions are available: The settings made here apply globally, for the whole Topological Model:

Parameters | Description
Voltage towards ground | Interlocking is active if a switch/disconnector is to be closed and a grounded potential is connected to its first connector and its other connector is connected or undefined.
Switching action in an area with an undefined status | Interlocking is active if a switch disconnector is to be closed and both of its connectors are 'undefined' or 'disturbed'.
Disconnector under load | Interlocking is active if certain conditions have been met for switching on or off. Conditions: See "Disconnector under load - interlocking conditions" section.
Device would no longer be supplied | Interlocking is active, when a consumer, which was supplied before, would be unsupplied after the switching action (by switch or disconnector).
Area with undefined status would increase | Interlocking is active if a switch disconnector is to be closed and one connector is 'undefined' or 'disturbed' and the other not.

If you click in the Status column in one of these interlockings, a drop-down list opens with three choices:

Parameters | Description
do not check | The selected condition is not considered in this project (topological model).
unlockable | The selected condition is considered in this project. If the condition applies, the user can unlock it with a command (Command screen). This unlocking action is logged in the Chronological Event List.
not unlockable | The selected condition is considered in this project. The user cannot unlock it.

Exception topological interlocking

The topological interlocking is not carried out if:

  • the variable of a switch has the status Revision
    or
  • the variable is manually corrects or set to Alternate value and with this is set to the same variable value as the initial value; in other words if the switch:
    • is set to OFF and then it is manually corrected to OFF or replaced.
    • is set to ON and then it is manually corrected to ON or replaced.


Disconnector under load - interlocking conditions

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Configuration -> Configuration of topological interlockings -> Disconnector under load - interlocking conditions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For the disconnector under load topological interlocking, a disconnector can be switched if one of the following conditions is met:

When being switched on:

Before being switched:

  • The left and the right line segment receive energy from the same source
  • If the left line segment does not receive any voltage, the right line segment is grounded
  • If the left line segment is grounded, the right line segment does not receive any voltage
  • If the left line segment is not under load
  • If the right line segment is not under load

When being switched off:

After being switched:

  • The left and the right line segment would receive energy from the same source
  • If the left line segment does not receive any voltage and the right line segment is grounded
  • If the left line segment were grounded, the right line segment would not receive any voltage
  • If the left line segment were not under load
  • If the right line segment were not under load

info Information

Meaning of "not under load"

All of the following conditions must be met for the status of not under load:

  • All switches and disconnectors connected to the line segment are open.
  • All sources and consuming devices connected to the line segment are switched off.
  • No transformer may be connected to the line segment.
  • It must not be a line that is only connected to this disconnector (open line).


Configuration of the screen marker

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Configuration -> Configuration of the screen marker

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Here you configure the color table for the color marker for the impedance-based error detection and calculation of load distribution. See also: AddMarker

Parameters | Description
Number | Unique internal serial number for clear assignment. This number is given by the system automatically and cannot be changed.
Line color | Line color of the screen marker.
Fill color | Fill color of the screen marker.
New | Adds a new color.
Clear | Deletes the selected color.

The colors can be configured directly by entering the corresponding hexadecimal code or by using a color palette.

For direct input:

  1. Click on the color description with the left mouse button
  2. The field is switched to editing mode
  3. Enter the code
  4. Press the input key or select another source in oder to accept the change

To select via a color palette:

  1. highlight the desired line
  2. click on the ... button behind the color
  3. Online help is opened.
  4. select the desired color

The hexadecimal code describes the RGB color value and consists of the following. #RRGGBB.

Element | Meaning
# | Identifier to indicate that a hexadecimal color code is used.
RR | 2 digits are the red value of the color in hexadecimal system. 0-255 is 0-FF
GG | 2 digits are the green value of the color in hexadecimal system. 0-255 is 0-FF
BB | 2 digits are the blue value of the color in hexadecimal system. 0-255 is 0-FF


Change ALC source color

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Change ALC source color

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The foreground and background color of an ALC source can be temporarily changed for the coloring in Runtime using the Change ALC source color function. The change remains until Runtime is ended, reloaded or the function is executed again. To create the function:

  • select New Function
  • navigate to node Screens
  • select Change ALC source color

  • The dialog to define line colors and fill colors opens
  • define the desired color

Property | Function
Source | Drop-down list to select the source and display the colors currently assigned. These colors cannot be changed here.
New color for source | Click on the color and a dialog opens to select a color.


Detail screens

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Detail screens

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To display individual screens, a partial area can be taken from the topological network and displayed individually by means of alias. The screen elements in the detail screen are not included in the topological model, but do however get their ALC colors from the model. They relate to an alias of the screen elements in the overall screen.

attention Attention

Aliases are only valid within a project.

This means that for symbols that contain links to aliases:

if the symbol is added to the general symbol library or the liberary in the global project and edited there, all ALC alias information is lost without notice!

Create alias

Aliases can be created for the elements:

  • Line
  • Polyline
  • Pipe
  • Combined element

attention Attention

An ALC alias cannot be created if a period (.) is contained in the name of the selected screen.

Solution: Replace the period in the screen name with a different character, such as an underscore for example (_).

To create a source element as an alias:

  • Activate it in the element's properties Use alias.

    To do this, ALC must be licensed and the Color from ALC property active.

  • Click on the ... button in the Alias property
  • the dialog to select the element opens.

Parameters

Description

Screen

Click the ... button and a dialog opens to select a screen.

Available ALC elements

Shows the elements that belong to a screen with the element name, type of element and function type. Clicking on an element selects an alias.

Filter

The elements can be sorted according to all columns. When setting a filter, the options offered from all other filters are reduced to values that can be sensibly combined.

  • Name: Input of a standard search term with wild cards (*). The last 12 search terms are offered in the list until the Editor is ended.
  • Element: Select from drop-down list.
  • Function type: Select from drop-down list.

Clicking on ... opens saved search or drop-down list.

If a filter is active, clicking on the X deletes the filter.

Selected alias

Shows the selected element in the field of Available ALC elements.

No selection

Removes selected element.

OK

Saves selection and closes dialog.

Cancel

Discards changes and closes dialog.

Help

Opens online help.

info Information

When selecting an element for a new alias, only elements and screens from the same project that the alias was defined in can be selected. Elements from subprojects or parallel projects are not available.

Replacing alias names

Aliases can be be changed when switching screens with Replace link. A detail screen can therefore be displayed with the data from different equipment parts, for instance lines or partial networks. Alias names are replaced along the lines of variables and functions. It is also possible to replace in elements that are used in symbols. The same dialog as is opened for the target as the Alias property.

Note: Substitution using index variables is not possible.


Error detection in the electric network

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Error detection marks grid parts that are subject to ground faults or short circuits by means of special colors in ALC. Sources for error detection are what are called ground fault or short circuit reporters that are assigned to a circuit breaker. Ground fault and short circuit reporters are always at the output of a circuit breaker element. Error messages are fixed in the screen and must be reset manually.

info Information

This function is only available when both the "Energy Edition" and the "Automatic Line Coloring" modules are licensed.

Error detection

Error detection runs locally. Each client in the network has its own independent model and can therefore search for ground faults and short circuits in different parts of the network.

Error detection in the electrical network is divided into:

  • Search for ground fault
  • Short circuit search

To configure error detection

  • You require a license for ALC and zenon Energy Edition
  • configure the appropriate screens
  • Configure ALC to the corresponding combined elements (switch, transformer, disconnector, slider)
  • configure the lines so that they are colored by ALC

Special functions are available in Runtime for error detection:

  • Start search for ground fault
  • acknowledge ground fault message
  • Stop search for ground fault
  • Acknowledge short-circuit message

Colorings

Errors can be shown by a special coloring for the lines in ALC. In Runtime, the color assigned by ALC changes automatically as soon as the status of the line changes. The colorings configured can be changed in Runtime via the change ALC source color function.

Messages are processed in the order in which they arrive. In the event of conflicts

  • The colors for displaying errors take priority
  • short circuit messages have priority over ground fault messages


Search for ground fault

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Search for ground fault

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The ground fault search serves to highlight the network parts hat potentially have a ground fault by coloring these. The color is taken from the configuration of ALC source colors for the GROUND FAULT source.

Which network parts potentially have a ground fault can be deduced from the ground fault messages from ground fault identification devices (ground fault indicators, protective device with ground fault recording). The following applies for ground faults:

  • Each device can have one to three ground fault messages.
  • Ground faults are either dealt with by permanent message processing or by transient message processing.
  • For directional ground fault devices, the direction can be lagging or leading in relation to triggering.
    • leading: First the message, then the transient bit.
    • lagging: First the transient bit, then the message.

info Information

A network component that potentially has a ground fault is then no longer considered to have a ground fault if this has been successfully connected.

Engineering

To configure the ground fault search:

  1. assign the combined element that represents the switching element to the Function type switch
  2. define the ground fault search mode, fault display and ground fault indication triggering
  3. set up the functions for start ground fault search, acknowledge ground fault search and end ground fault search

info Information

In order to also be able to set limits in intermeshed networks, only one area subject to a ground fault per path is searched for a fault.


Mode of the search for ground faults

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Search for ground fault -> Mode of the search for ground faults

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The short circuit search can either:

  • color the network part potentially subject to a short circuit
    or
  • the whole network where the short circuit is located

The coloring mode is defined via the Mode of the search for ground faults property.

To configure the property:

  • navigate to the Automatic Line Coloring node in properties
  • select the desired mode in the Mode of the search for ground faults property drop-down list
    • Color grid part: colors only the grid parts that are potentially subject to a short circuit
    • Color whole grid: colors in the whole linked grid where the short circuit is located

This setting can be changed in Runtime via the zenon API object model. In doing so, the short circuit search is recalculated once again.


Earth Fault Identification Type

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Search for ground fault -> Earth Fault Identification Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The direction and type of information processing for the switch type combined element are determined by the Type setting. to configure:

  1. navigate to the Automatic Line Coloring node in the combined element properties
  2. open the Ground fault recognition node
  3. select the desired type with the direction and type of alarm processing in the Type property
    • Direction:
      indicates if the raising edge of trip alarm or if the raising edge of a direction comes before
    • leading: The current direction status is used for the raising edge of the trip alarm
    • lagging: after a raising edge of the trip alarm, the first raising edge of a direction is waited on; if this does not occur within 2 seconds, the earth fault device is considered non-directional
    • Information processing:
      states which information can be processed
    • none: normal switch; information is not processed
    • Permanent message processing: Newly received messages are considered a new ground fault trip
    • Transient message processing: Messages that are received during a current Search are suppressed

Note: The distinction between permanent message processing and transient message processing only relates to processing the message, not to the type. Transient bit message processing need not therefore relate to a transient bit.

attention Attention

To suppress intermittent ground faults, ground fault messages that are received in intervals shorter than 2 seconds are ignored.


Ground fault display

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Search for ground fault -> Ground fault display

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The variable linked at Display is an output variable for error detection and displays the recorded status of the ground fault identification device. This is necessary because all messages remain saved internally until they are acknowledged, i.e. they do not necessarily conform to the current status of the message variables.

Each time a recording is made, a set value is sent to this variable. In doing so, the values are as follows:

Value | Meaning
0 | no ground fault
1 | ground fault forwards
2 | Ground fault backwards
3 | non-directional ground fault
4 | Error status - > both directions have activated

info Information

To reduce problems in network operation, the variable linked here should be a linked variable.


Earth fault triggering

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Search for ground fault -> Earth fault triggering

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The alarm to report an earth fault is defined by the Triggering variable It can contain information on the presence of an earth fault and the direction of the earth fault from the point of view of the earth fault recognition device. In doing so, a distinction is made between:

  • non-directional earth fault alarms
  • Directional earth fault alarms with a trip alarm
  • Directional earth fault alarms with a trip alarm

To configure the variable for the Triggering:

  1. navigate to the Automatic Line Coloring node in the combined element properties
  2. open the Ground fault recognition node
    1. for non-directional earth fault alarms

      Click on the ... button in the Triggering property

      select the variable you wish to import in the dialog that opens

      The properties for the direction remain empty

    2. for directional earth fault alarms with a trip alarm

      link the variable with Triggering and add the appropriate direction:

      Forwards: link a variable to the Forwards property

      Backwards: link a variable to the Backwards property

    3. for directional earth fault alarms without a trip alarm

      Link the variable with the corresponding direction:

      Forwards: link a variable to the Forwards property

      Backwards: link a variable to the Backwards property

      The Triggering property remains empty

Note: If you address a directional identification device with Forwards in both directions, this is then considered erroneous and ignored.


Start search for ground fault

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Search for ground fault -> Start search for ground fault

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The function Start search for ground fault serves to localize a ground fault and has two effects in Runtime:

  1. Fault reports from all ground fault identification devices that were configured with wiper message processing are ignored.
  2. The search algorithm is changed: Switch actions can only reduce the area subject to a ground fault further. Newly received messages do not therefore increase the area potentially subject to a ground fault.

To configure the Start search for ground fault function:

  • create a new function
  • navigate to the error detection node in the electrical network
  • Select the Start search for ground fault function

  • link the function to a button


Acknowledge ground fault message

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Search for ground fault -> Acknowledge ground fault message

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the Acknowledge ground fault message function, an internally recorded ground fault from a ground fault indication device can be acknowledged. In doing so, the internally-latched ground fault status is reset if the status is still pending, or highlighted as acknowledged. A recorded ground fault message is only deleted internally if this has been acknowledged and is no longer pending.

Rules when acknowledging:

  • If a variable that corresponds to a triggering or direction variable of a ground fault recognition device is linked, this special ground fault message is acknowledged.
  • If no variable has been linked, all ground fault messages are acknowledged.
  • Acknowledgment can also take place via the zenon API object model.

To configure the Acknowledge ground fault message function:

  • create a new function
  • navigate to the error detection node in the electrical network
  • Select the Acknowledge ground fault message function

  • the dialog to select a variable opens
  • link the desired variable to the function
  • link the function to a button


Stop search for ground fault

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Search for ground fault -> Stop search for ground fault

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You end the ground fault search with the Stop search for ground fault function in Runtime.

To configure the function:

  • create a new function
  • navigate to the error detection node in the electrical network
  • Select the Stop search for ground fault function

  • link the function to a button


Short circuit search

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Short circuit search

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The short circuit search serves to highlight the network parts that potentially have a short circuit by coloring these. The color is taken from the configuration of ALC source colors for the SHORT FAULT source.

The network parts that are potentially subject to short circuits are deduced from short circuit reports. A short circuit identification device (short circuit indicator, protective device) can have one to three short circuit messages. For directional short circuit indication devices, the direction can be lagging or leading in relation to triggering. A network component that potentially has a short circuit is then no longer considered to have a ground fault if this has been successfully connected.

Engineering

To configure the short circuit search:

  1. assign the combined element that represents the switching element to the Function type switch
  2. define Short circuit display andShort circuit identification triggering
  3. Set up the Acknowledge short circuit message function


Short circuit identification type

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Short circuit search -> Short circuit identification type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The direction and type of information processing for the switch type combined element are determined by the Type setting. to configure:

  1. navigate to the Automatic Line Coloring node in the combined element properties
  2. open the Short-circuit detection node
  3. select the desired type at the Type property
    • Direction:
      indicates if the raising edge of trip alarm or if the raising edge of a direction comes before
    • leading:
      The current direction status is used for the raising edge of the trip alarm
    • lagging:
      after a raising edge of the trip alarm, the first raising edge of a direction is waited on; if this does not occur within 2 seconds, the short circuit device is considered non-directional
    • Information processing:
      states which information can be processed
    • none:
      normal switch; information is not processed
    • Permanent message processing:
      Newly received messages are considered a new ground fault trip


Short circuit display

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Short circuit search -> Short circuit display

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The variable linked at Display is an output variable for error detection and displays the recorded status of the short circuit identification device. This is necessary because all messages remain saved internally until they are acknowledged, i.e. they do not necessarily conform to the current status of the message variables.

Each time a recording is made, a set value is sent to this variable. In doing so, the values are as follows:

Value | Meaning
0 | no short circuit
1 | Short circuit forwards
2 | Short circuit backwards
3 | Non-directional short circuit


Short circuit identification triggering

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Short circuit search -> Short circuit identification triggering

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The variable for the message from the short circuit identification device is defined by the Triggering variable You can receive information about the presence of a short circuit and the direction of the short circuit from the point of view of the short circuit identification device.In doing so, a distinction is made between:

  • non-directional short circuit reporters
  • directional short circuit reporters with a trip alarm
  • directional short circuit alarms with a trip alarm

To configure the variables for:

  1. navigate to the Automatic Line Coloring node in the combined element properties
  2. open the Short-circuit detection node
    1. for non-directional short circuit detection devices

      Click on the ... button in the Triggering property

      select the variable you wish to import in the dialog that opens

      The properties for the direction remain empty

    2. for directional short circuit detection devices with a trip alarm

      link the variable with Triggering and add the appropriate direction:

      Forwards: link a variable to the Forwards property

      Backwards: link a variable to the Backwards property

    3. for directional short circuit detection devices without a trip alarm

      Link the variable with the corresponding direction:

      Forwards: link a variable to the Forwards property

      Backwards: link a variable to the Backwards property

      The Triggering property remains empty


Acknowledge short circuit message

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Error detection in the electric network -> Short circuit search -> Acknowledge short circuit message

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the Acknowledge short-circuit message function, an internally recorded short circuit from a short circuit indication device can be acknowledged. In doing so, the internally-latched ground fault status is reset if the status is still pending, or highlighted as acknowledged. A recorded short circuit message is only deleted internally if this has been acknowledged and is no longer pending.

Rules when acknowledging:

  • If a variable that corresponds to a triggering or direction variable of a short circuit recognition device is linked, this special short circuit message is acknowledged.
  • If no variable has been linked, all short circuit messages are acknowledged.
  • Acknowledgment can also take place via the zenon API object model.

To configure the Acknowledge short-circuit message function:

  • create a new function
  • navigate to the error detection node in the electrical network
  • Select the Acknowledge short-circuit message function

  • select the variable you wish to import in the dialog that opens
  • link the function to a button


Impedance-based error detection and calculation of load distribution

Manual -> Energy Edition -> Automatic Line Coloring (ALC) - Topology -> Impedance-based error detection and calculation of load distribution

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Impedance based error detection and calculation of load distribution expands ALC. Whereas ALC identifies nodes and beams, this model also detects lines and their parameters. The model is not used internally in zenon, but provides properties and methods for external evaluation.

Properties for ALC and the extended topological model

The ALC elements combined element and line (line, polyline, tube) have special properties for error detection for protection and to calculate the load distribution. These properties are not evaluated in zenon, but are available via the zenon API algorithms to be created by users.

The simple topological model for the coloring was supplements by an expanded topological model that includes all lines as separate beams. The extended topological model is stored as ALC.xml and can be read by external applications this way. ALC.xml contains two sections:

  • GraphElements: contains the extended topological model without aliases
  • GraphAliases: contains only the aliases

Each object has a unique ID, via which it is referenced in the file. The attributes correspond to a subset of the zenon screen elements that have created the elements.

GraphElement

ID | Description
Picture | Screen name
ElementID | Screen element ID
ElementRef | Screen element reference
Type | Screen element -type (see "element")
SourceID | Source number
ReverseSourceID | Source name in reverse direction
Variable | Status variable
VarProtReact | Reactance variable
MaxIType | Type of maximum current
MaxIVal | Maximum current constant value
VarMaxI | Maximum current variable
VarCurI | Instantaneous current variable
VarCalcI | Calculated current variable
VarCurP | Instantaneous power variable
LoadType | Type of load
LoadVal | Load constant value
VarLoad | Load variable
React | Reactance
Resist | Resistance
Length | Line length
Node1IDs | List of all element IDs connected with Node1
Node2IDs | List of all element IDs connected with Node2

GraphAlias

ID | Description
Picture | Screen name
ElementID | Screen element ID
ElementRef | Screen element reference
Type | Screen element -type (see "element")
OrigElemRef | Screen element - reference to the original screen element
OrigGraphElemID | ID of the original elements in "GraphElements"

API

In the object model of the zenon API, the objects ALCGraphElement and ALCGraphAlias are available for the model. These contain the same information as the XML file. These objects can be accessed in the ALC engine via:

  • GraphElemCount()
  • GraphAliasCount()
  • GraphElemItem()
  • GraphAliasItem()

User-specific topological interlockings

If a topological interlocking is checked, the following event is called up at the ALC engine:

  • void CheckInterlocking(IALCEdge* pALCEdge, long nNewState, tpLockResult* LockResult, BSTR* bsText, VARIANT_BOOL* bUnlockable);

The switch/disconnector to be switched and the new status is transferred. The event can fill LockResult, bUnlockable and bsText in order to display a breached interlocking condition. If the event handler returns tpBusy in LockResult, the event handler is queried until it no longer provides tpBusy, however for a maximum of 10 seconds. The interlocking is active after 10 seconds. The interlocking text and unlockability are reported back in bsText and bUnlockable.

Screen marker

Marker elements can be inserted into screen s via the zenon API.

These are added or deleted via the API functions in DynPictures:

  • BSTR AddMarker(BSTR bsScreenName, long nElementID, short nPosition, short nLineColorIndex, short nFillColorIndex);
  • VARIANT_BOOL DelMarker(BSTR bsID);

The GUID of the marker, which is supplied by AddMarker(), identifies the marker uniquely and serves as both the element name (with the prefix "$MARKER_") as well as the key for deletion via DelMarker(). The markers inserted via API are saved in the project according to the screen. Attention: Saving is not remanant, i.e. only until Runtime is restarted.

The markers set there are displayed regardless of the monitor on which the screen is opened. The markers are treated internally as normally operable screen elements. Mouse events are called up for this.

The appearance of the markers is set using the project settings in the Automatic Line Coloring area of the project configuration:

  • Display type of the screen marker: Triangle, circle, square, cross
  • Screen marker size: Size in pixels:
  • Line width of the screen marker: Width in pixels
  • Marker color: is defined via the index in the marker color table, that is located in the properties of the screen elements in the Automatic Line Coloring group


Command Processing

Manual -> Energy Edition -> Command Processing

Command processing serves primarily for the secured switching of variables in energy technology. 'Secured' means that there is a check whether the switching operation is allowed, according to the configured interlocking condition and the dynamically updated topology (current physical state of the topological network). The configuration of the topology and the topological commands is done via the ALC (Automatic Line Coloring) module.

tutorial License information

Included in the license for Energy Edition.

Command groups always contain a set of defined actions, which are usually adjusted to a specific data point (a specific device) . For example, different command groups can be defined individually and centrally for different topological elements (switch / disconnector etc.) .

A data point for the command always consists of 2 physical variables: a response variable and a command variable.

The response variable is defined centrally for the whole command group. It represents the status of the topological element. For example whether the switch is open or closed. A defined command variable is assigned to every action inside a command group. The driver uses this variable to write commands to the controller.

Depending on the action to be executed, these commands are executed on one of the two variables.

Example Example

'Switching command on'
Sends the command/the new value to the command variable. The success of the triggered action can be checked by means of the response variable.

Status input off'
Resets all configured status bits of the response variable. The command variable is not affected by this action (note: command variable is the response variable).

Name replacement

To simplify and to generalize the definition of the variables, the variable references (for command variables, response variables and condition variables) can be defined using a name replacement. In doing so, wildcards '*' can be used. Wild cards are only allowed as prefix or suffix, i.e. *xxx or xxx*

As a result of this flexible definition, generally-valid procedures can be defined, which are then applicable for several data points. The number of command groups that must be defined is thus reduced considerably.

Example Example
  • Definition of the command variables '*_BE'
  • Definition of the response variables '*_RM'

In Runtime, the command automatically adds the name of the response variable, which is shown/selected in the process screen, to the name of the command variable. The names of both variables differ only in their endings.

Two-step command operations are usually performed via a context menu and the screen type „Command“. Specific control elements are available for this screen type. They enable an individual optical and functional design of the command. This way, individual actions, for example, can be assigned to action buttons directly. After this, these actions can be selected by the user directly. This screen type also includes the necessary requirements in order to carry out functions such as unlocking, two-step execution, two-hand operation, locking etc. Such a screen can be called up by means of a function at the screen element directly (instead of the set value dialog), or via a context menu.

From the command groups and the current status of the topological model (automatic line coloring - interlockings) it is evident in runtime whether an action (switching operation) is permitted at a certain time

  • (no interlocking condition applicable),
  • not permitted (there is a non-unlockable condition applicable) or
  • can be executed after unlocking (unlocakble condition applicable).

In the zenon network, there is synchronization of actions from the command processing, which concern a certain response variable - by activating NET_SEL Status bits. The parallel execution of different users on the same object (same variables) is thus precluded. Parallel execution on different response variables is supported.

Context menu Project manager

Menu item | Action
New command group | Creates a new command group.
Export XML all... | Exports all entries as an XML file.
Import XML... | Imports measuring units from an XML file.
Editor profile | Opens the drop-down list for selecting a Editor profile.
Help | Opens online help.

info Information

Command groups can be exported, imported and copied and pasted using the clipboard. The same applies for actions and their interlocking conditions, even different command groups.

attention Attention

All of the following functions are only available if zenon Energy Edition is licensed.


Command detail view toolbar and context menu

Manual -> Energy Edition -> Command Processing -> Command detail view toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Command and command group context menu

Menu item | Action
New command group | Creates a new command group.
Export XML all... | Exports all entries as an XML file.
Export selected XML.. | Exports selected entries as an XML file.
Import XML... | Imports from an XML file.
Copy | Copies the selected command group to the clipboard.
Paste | Pastes command groups from the clipboard.
Delete | Deletes the selected command group after requesting confirmation.
Rename | Enables renaming of a command group.
Properties | Opens the properties window for the selected command group.
Help | Opens online help.

Context menu group actions

Menu item | Action
Command new | Creates a new command and opens the properties.
New auto/remote command | Creates a new auto/remote command and opens the properties.
New forced command | Creates a new mandatory command and opens the properties.
New set value input | Creates a new set value input and opens the properties.
New status input | Creates a new status input and opens the properties.
New replace | Creates a new replace action and opens the properties.
New revision | Creates a new revision and opens the properties.
New manual correction | Creates a new manual correction action and opens the properties.
New block | Creates a new block action and opens the properties.
New release | Creates a new manual correction and opens the properties.
Check response value | Creates a new check response variable action. Note: This action checks the status of a variable without writing a value.
New lock | Creates a new lock and opens the properties.
Paste | Pastes action from the clipboard.
Help | Opens online help.

Context menu individual action

Menu item | Action
New interlocking condition | Creates a new interlocking condition. Note: Grayed out for mandatory command command actions.
Copy | Copies the selected action to the clipboard.
Paste | Pastes action from the clipboard.
Delete | Deletes the selected action after requesting confirmation.
Help | Opens online help.

Context menu condition

Menu item | Action
Remove interlocking condition | Deletes selected condition.
Copy | Copies the selected condition.
Paste | Pastes the condition from the clipboard.
Properties | Opens the property window for the selected element.
Help | Opens online help.

Context menu group variables

Menu item | Action
Add variable... | Opens the dialog for selecting a variable.
Paste | Pastes variable from the clipboard.
Help | Opens online help.

Context menu individual variable

Menu item | Action
Remove variable | Deletes the selected variable from the group after requesting confirmation.
Copy | Copies selected variables to the clipboard.
Paste | Pastes variable from the clipboard.
Properties | Opens the property window for the selected element.
Help | Opens online help.


Engineering in the Editor

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

info Information

For tests too, use a driver that supports the evaluation of the COT (Cause of Transmission) in full, for example the IEC 60870-5-101_104 driver. COT evaluation is an enhanced functionality to monitor communication during a command using the Runtime monitoring setting. The status bits COTx of the command variables can also be evaluated in the reaction matrices multi-numerical and multi-binary.


Creating a screen of the type command

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Creating a screen of the type command

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The creation of the command screen in the editor is done by the definition of a new screen of the type command. (You will find more information on the pre-defined screen types in the manual Screens/Pre-defined screen types'.)

The screen 'Command' is used for user interaction via command during the runtime (one and two-step command) It allows the user to perfrom all activities that are necessary for command execution. This can be, for example, the unlocking of an active command group or the confirmation of the execution of a two-step command.

info Information

When using the one-step command, you can also use a context menu or a standard function. The screen type command is then not required in the project.

You can use specific control elements for this screen type, which allow all user actions necessary for command and which visualize current information about the status of the action to be executed. (e.g. display of the switching direction)

After the screen is opened an empty screen is displayed. You add the default control elements via menu Control elements/Add template.

info Information

Beneath the groups you can find a collection of control elements which you need for special actions. E.g. all control elements for locking elements . Thus saving the time for manually searching for all needed control elements.


Variables of the command group

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Variables of the command group

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Command groups use both the variables of the switching actions (the response variable and command variable) and the variables of the command conditions.

In order for variables to be able to be used in the command processing module, a command group must also be assigned for the respective variable (variable of the command condition). This assignment is made in the variables node => for the variable => in the Write set value properties group => in the drop-down menu of the Command group property.

Ensure that this assignment is configured for both response variables and command variables.

Example:

Assuming that that command group "DPI one stage" was configured with the name of the response variable *_RV and the switching actions in this group with the name of the action variable *_CO.

In the SCADA project, variables with the name ied9_100_RV (position of the switch) and ied9_100_CO (command for switch) are configured.

Then link the two variables ied9_100_RV and ied9_100_CO in the command group property to the "DPI one stage command group". The respective wild card * is replaced with "ied9_100" in Runtime. This way, other variables, such as ied9_101_RV and ied9_101_CO (etc.) can be linked to this command group.

info Information

As a result of the different use of limit values / reaction matrices for the command variable / return variable, individual switching directions can be displayed for the actions. Always depends on the variables on which the action to be executed is carried out.


Limits and reaction matrices for switching direction texts

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Variables of the command group -> Limits and reaction matrices for switching direction texts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the first step of the two-step command, user-definable switching direction texts are displayed (e.g. in the context menu) for Command actions. These texts can be defined via the limits or via the states of the reaction matrices.

You therefore also have the possibility to issue different texts for each variable that uses the same command group. Thus several variable pairs (each response variable and command variable) use one command group. Additional individualization of the command group is then not necessary.

These texts give the user a better understanding or a better overview of the actions that are available in Runtime (e.g. 'Command: Open disconnector')

If no limit value has been created for a variable and no reaction matrices are linked, the action uses a standard text:

Switching direction of the action | Standard text
None | @NONE
Off | @OFF
On | @ON
Diff | @INTER
Fault | @FAULT
Direct | @DIR

info Information

As the switching direction texts are read out from the limit settings, they are completely language switchable.


Project overlapping variables

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Variables of the command group -> Project overlapping variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

attention Attention

The variables used in the command groups must be in the same project in order for the command to work properly.

If you do use a variable from another project (e.g. subordinate project in multi-project administration), the command group, the response variable, the action variable and the action-specific screen ('command' screen) is expected to also exist in the other project.

info Information

You can also use project-overlapping variables for the interlockings by the process. The above limitations apply only to the variables of the command group.


Define Command Processing

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Select the Command entry in the project tree Select New command group in the context menu.

After creating a new command group, it is added to the detail view of the project manager with standard name "Befehlsgruppe + Index ". The index is replaced by a consecutive number.

Note: This name serves for the unique identification of the interlocking in the system.

info Information

You can assign any name you like to the command groups. However, the names must be unique within the project (applies for standard interlockings and command groups).

The following parameters are available for command groups:

Parameters

Description

Name

Name of the command group. Must be unique among all interlockings in the project. This name is used later with the variable that uses this command group. However the actual assignment is made with a unique, serial numeric ID, so that a command group can be renamed at any time.

Variable name of response

This is the variable name or the mask for the replacement of the response variable.

The placeholder for the replacement text is the character sequence ‚*’ within a name.

Example:

  • *_RV
  • */stVal[ST]

Only one placeholder, *' can be used in the name. When entering the mask, it is important to take care that this name results in an existing variable name after replacement.

Attention: If the name remains empty or the variable that is used here (replaced or absolute) does not exist at the time of compiling, this command group is not available in RT. A corresponding message in the output window points this error out during compiling.

Set status PROGRESS

If activated, status bit In progress (PROGRESS) is written for actions command and Manual correction. The value that the status bit is set to depends on the switching direction of the action.

The status bit is set to 1 if:

  • the Return state/switching direction of the action is ON or OFF.
  • The response variable does not already have the value of the set switching direction.

The status bit is set when checking the interlockings and remains until the execution of the action has been completed.
This also implies that, in the case of SBO, the status PROGRESS is only set after a successful 'Select' (SE+COT_actcon) and then remains set during runtime monitoring and/or edge delay.

If the execution of the action is triggered by a context menu or if it is a one-step action, the status bit is also set accordingly.

Watchdog timer

There is the following setting for this drop-down list:

  • none: The watchdog timer is deactivated. However with SBO, there is a wait for confirmation of the 'Select' (SE+COT_actcon) and it is then ensured that 'Select' has been ended - so that the PLC reacts to 'Execute' COT_act in the envisaged time. If not, then the 'Select' is deactivated - a 'Cancel' (SE+COT_deact) is sent for this.
  • Response variable: The value of the response variable is used to determine if the command was successful.
  • via cause of transmission: The Cause of Transmission (COT) of the command variable is used to check whether the process was successful.

Screen modal

If this is active, the screen is displayed modally, independent of the setting 'Modal dialog' in the screen settings.

Screen title from response variable

The identification of the response variable is shown in the screen title. This only happens when there a title was configured for the screen at the frame.

Text is online language switchable.

Screen

Name of the screen to be loaded if the screen is not opened using the 'Screen : Switch to' function.

Note: Actions called up via the context menu open, for the confirmation of the second stage or interlocking text, a screen that was defined for the action. Only if no screen has been linked for the action is a defined screen also used here.

Breaker tripping detection

Only available if property Set status PROGRESS is activated.

Active: The response variable is monitored for a change from <> 0 to 0. The identification only sets the status bit CD_TRIP (50) to 1 if:

  • The status bit CB_TR_I (51) is not 1, otherwise the identification is suppressed.
  • The status bit PROGRESS (10) is not 1, otherwise the value change of the response variable is considered a result of its own command.

Attention: Value changes that are a delayed consequence of its own command can be recognized as breaker tripping. This happens if the PROGRESS bit has already been deleted or if the action does not support runtime monitoring.

Suppress detection

Entering the formula with which the detection of a breaker tripping can be suppressed. A click on button ... opens the formula editor.

All variables of the interlocking can be used for the formula. Name replacements with '*' - as with the definition of the interlocking conditions of an action - are possible.

The suppression sets the status bit CB_TR_I (51) to 1.

With active recognition, all variables whose status or value are used in the formula for breaker tripping detection are activated for reading when the program is started after loading all projects, and remain this way as long as Runtime is running. Variables from projects loaded in Runtime can be used.

Note: Variables that are used in the formula cannot be deleted from the list of the variables linked to the command group.

info Information

The response and action variables do not need to be in the list of the variables linked to the command group. Their names need only be configured for the command group and in the action.


Command in Distributed Engineering

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Command in Distributed Engineering

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

info Information

Because the command conditions and the general interlockings (standard functionality / without energy edition) are deposited in the same structure in the editor, the checkout symbol is set to identical for both nodes in the project tree (enable changes). All actions on the command conditions also apply to the general interlockings and vice versa.

Variables marked for deletion are considered as not existent for the compilation of the command conditions. During compiling, the respective error messages are displayed in the output window.


Create action

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Create action

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Actions define the switching commands that are possible for command groups. By selecting the element 'Action' in the detail view of the command group, you can define a new action with a right mouse click. Details of the defined actions are also shown in the detail view after creation (e.g. "switching command: *_BE [ON,1]").

All further settings for the actions are made in the properties window. Some of the properties are inactive, depending on the action type.

Available properties:

Parameters

Description

Action settings

Action variable

Variables on which is written. For some actions, this is the response variable. In this case, the field is locked.

The placeholder for the replacement text is the character sequence ‚*’ within a name. Only one placeholder can be used in a name.

If the variable that is used here (replaced or absolute) does not exist during compiling, the action is not available in the RT. An according message announces this error during compiling.

Click on the ... button to open the dialog for selecting a variable.

Default: No Allocation

Action type

Shows the type of command. For editing, only approved for command action type, where possible settings are switching command or pulse command.

Default: Switching command

Return state/switching direction

Defines the expected value or the status of the response variable after action execution.

Locked for the actions block, lock and release.

Default: Off

Command

Defines the value that is written to the command variable with the Command action.

Note: only available for the command actions switching command- and pulse command, auto/remote command and forced command.

Default: 0

Edge delay

Time in milliseconds by which the resetting of the value is delayed for a pulse command.

Note: Only available for the pulse command action.
There is no wait until until runtime monitoring has ended.

Default: 1000 ms

Set value

Defines the value that is written to the controller.

Note: Only available if Return state/switching direction has been set to DIR.

Modifiable states

List of the states which can be modified with the Set status action.

Note: Only available for the action 'Status input'.

Default: None modifiable

Command Processing screen

Screen

Command Processing screen that is used when the action has been carried out using the context menu of the element. If no screen is entered, the screen that is entered in the Screen property for the command is used. An engineered screen which is not available, creates an error message when creating the Runtime files. In this case the action is not taken over.

Default: none.

Note: If the command is called up by a dynamic screen element, this property is ignored and the screen that is entered in the Screen property in the command group is always used.
Not available for the auto/remote command action type.

Action button

Allocation of the action to an action button in the screen, defined at the command group. If the command group is used for another screen (e.g. via function), the allocation to the action button remains nevertheless. In other words, the action is always placed on the button with the allocated action ID. If such a button is missing, the action is not available in the screen. Only the action buttons that were not allocated yet are provided in the selection list.

This setting is locked if no screen was allocated to the command group and for the Lock action type.

Default: No Allocation

Nominal/actual value comparison

If this is active, there will be a check whether the value of the response variable already matches the switching direction. If this is true, an unlockable interlocking variable is shown.

Note: Only active for command action type

Default: Inactive

Close automatically

If this is active then the screen is closed automatically after action execution.

Note: Not available for the auto/remote command action type.

Default: Inactive

two-stage

If this is active, only after operating the Execute 2 control. Step that executes action. If not active, the action is executed after releasing the last interlocking or, if there is no upcoming interlocking, immediately.

Note: Locked for the lock and auto/remote command actions.

Default: Active

Two-hand operation

If active, the control element becomes Execute 2. Step is only unlocked if the Ctrl key is held down.

Not available if no two-step execution has been configured.

Note: For the Execute 2nd step control element, the selectable with lasso property must not be active with two-hand operation.

Default: Inactive

Menu ID

The menu ID is used for the creation of Context menus in the Runtime.

Note: If two actions are fitted with the same ID, they are tagged with a special symbol in the action tree. They can then not be called up by the context menu.

Options

Suppress CEL entry

If this is active, no entry in the CEL will be made when executing an action.

Default: Inactive

Timeout

Timeout for the runtime monitoring in seconds for switching command and pulse command actions.

This setting is also applicable as a timeout for Select.

Unit is seconds

Only available for the actions Command, Auto/remote command, Check response, Setpoint input and Forced command.

Default: 30

Timeout can be canceled

Allows the cancellation of the timeout in runtime monitoring.

Only available for the command and Setpoint input actions.

If the command has already been executed - after COT_actcon has been received - the Cancel button cancels runtime monitoring.

Buttons are therefore active and operable again.

Note: Not all drivers support deactivation during execution. If not, no Cancel is sent to the controller; the action is canceled only.

Use Qualifier of Command

Allows commands to provide additional information (Qualifier of Command). The requirement for this is that the driver also supports this option. Possible drivers are, for example, IEC850, IEC870 and DNP3.

Is only available for the actions command, auto/remote command and forced command.

Default: inactive

Qualifier of command

Entry of a numerical value that is sent to the driver as a command parameter. This input possibility is only available if Use qualifier of command has been activated.

Entry range: 0 - 127

Default: 0

attention Attention

The identification of the action types in the menu ID must be clear, so that they are clearly identifiable in the context menu. If two actions have the same ID, they are tagged with the special symbol M in the action tree.

info Information

By selecting single properties, you receive additional information about functionality in the Property Help.

info Information

Actions and command conditions, once defined, can be exported / imported in XML. This allows for easy archiving and reusing in other applications.

info Information

The status can be set using the command status input.


Action types

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Action types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The action types are the available command procedures. According to the command, different activities are performed.

The system provides a variety of actions. The following action types can be defined for the command groups:

Action type

Remark
  • Command new

Switching command or pulse command. Uses the value of the command variable to write the configured command status to the controller.

Note: the switching command is suitable for individual and dual commands with the Energy driver (IEC60870, IEC61850, DNP3).
  • New auto/remote command

The remote command is forwarded from the Process Gateway or the zenon API to the command processing and processed as a switching command.

The action is not available in a command processing screen nor via the context menu.

  • New forced command

The forced command action type allows the setting of a command, even if the response variable is empty, OFF, NT or INVALID .

Note: the action is intended for emergency shutdowns and should only be used with caution.
  • New set value input

Writes a desired numerical value to the command variable.
  • New status input

Changes the status bits of the response variable. Only applicable for status bits in the modifiable status list.
  • New replace

Changes the status of the response variable to substitute value (ALT_VAL) and writes value to the response variable.
  • New revision

Sets the REVISION status bit of the response variable.

Note: Alarm handling is suppressed in the revision.
  • New manual correction

Sets the value of the selected response variable according to the switching direction.

Note: the communication protocols in Energy (IEC60870, IEC61850, DNP3) preclude direct writing to the response variable.

  • New block

Switches off the response variable (OFF status bit).

Note: the switched-off variables are no longer read by the connected hardware.
  • New release

Sets substitute value replacement value (ALT_VAL) to 0.

Note: as a consequence, the response variable has received the value from the controller again.
  • Check response value

Checks the status of the response variable without executing an activity.

Note: the action is intended for use in the command sequences module.
  • New lock

The response variable locks for further action upon entry of a valid locking code.

Note: The action types are listed in the above breakdown in the sequence in which the action types are offered in the zenon context menu. However the sequence in the main window is alphabetical.

In the detail view of command processing, the actions in the tree are shown with the respective selected switching direction and configured action value.

attention Attention

The identification of the action types in the Menu ID must be clear, so that they are clearly identifiable in the context menu. If two actions have the same ID, they are tagged with the special symbol M in the action tree.


Action type command

Action type command

Depending to the command type, this action type is used in the system as a switching command' or Pulse command.

When the command is executed, a value (0 or 1) is written to the command variable. The value of the command determines the Command property of the action.

This action type supports Select Before Operate and runtime monitoring. The value which that is then expected for the response variable as a result of the command is to be defined under the response message status/switching direction (on/off/none) property.

Switching direction | Value of the response variable after a command has been executed
None | Will not change or must be specifically monitored.
Off | Value will be 0.
On | Value will be 1.

With pulse commands, a value is written to the controller twice. The second time, there is, after the configured edge delay, an automatic reset to 0 or 1 (depending on the switching direction). However this does not happen if Select Before Operate (SBO) has been activated for the command variable. If the SBO property has been activated for the action variable, a pulse command acts in the same way as a switching command.

Please keep in mind: The pulse command is not recommended for Energy drivers. The pulse command should only be used with a PLC that expects a pulse instead of an edge.

info Note

If, during the execution of the action, the current value of the response variable is different to the one defined in the switching direction and the switching direction was defined to be on or off, the in progress ( PROGRESS ) status bit is set. To do this, activate the Set PROGRESS status property of the command group.


Auto/remote command action type

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Action types -> Auto/remote command action type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Auto/remote command action type

The remote command (via Process Gateway, VBA, etc.) is forwarded to the zenon command processing, which processes the sequence (checking of interlocking, forwarding to driver, response, etc.) like a switching command .

The command is not accessible via the command screen or the context menu.

The command is only supported by a previous Select . The action variable must have the Select Before Operate property activated.

When Runtime is ended, or reloaded, any Select that has been set is discarded. This means: The master connected to the Process Gateway is not informed and must get this itself using the interruption to the connection.

The VBA interface can use the IVariable::SetValueWithStatusEx method and the status bits to be transferred decide whether writing should be either direct or via the command processing. If the status bit NET_SEL (bit 8) has already been set (the command processing screen is open for example), the command is not executed. If the status bit is not set, it is set and writing is executed by command processing or commands are forwarded to the command processing. The response value of the method provides information on whether command processing has been activated or whether the command has been executed.

Transfer of the status bits of the action variable to the method:

  • SE_870 + COT_act(6) - Select activation
    Determines the command to be executed and activates the command. The response variable of the method provides information on whether this is possible.
  • SE_870 + COT_deact(8) - Deactivation (Cancel)
    Ongoing command is canceled.
  • COT_act(6) - Activation (Operate/Execute)
    Execute for command is executed.

In order for this method to be able to execute command processing, a remote command action must exist whose switching direction corresponds to the transferred set value. The actual value written to the driver, Select etc, results form the properties of the action.

Note: When an interlocking takes effect, a (language-switchable) CEL entry with the configured text is created.

info Information

You can get further information in the Select before Operate chapter In the Process Gateway IEC870 slave manual.


Mandatory command action type

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Action types -> Mandatory command action type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Mandatory command action type

The forced command action type allows the setting of a command, even if the response variable is empty, OFF, Not topical or invalid (INVALID). It is not intended for emergency shutdowns.

Interlockings cannot be created for the forced command, because it cannot be guaranteed that the condition variables have a valid value in Runtime.

Note: The forced command corresponds to a switching command without conditions.

attention Attention

The early or erroneous configuration of a forced command in Runtime can have dramatic consequences for the equipment. Always set this command with care and protect it with user authorizations.


Action type set point input

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Action types -> Action type set point input

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Action type set point input

The setpoint input action type offers the possibility to set any desired numerical value to the command variable. The command window offers special control elements for this, which allow manual definition of the set value. With the help of property Return state/switching direction you can define how the set value should be written:

Switching direction

Value of the response variable

DIR

Set value is written directly. You define the value which should be written with the help of function Set value.

The text which should be displayed can be engineered using a limit/rema for the state/value 5. If this is not the case, a standard text is used.

Nominal/actual value comparison is not supported.

The action can be carried out several times in a row.

Set value

Value of the command processing screen of the Set value element is written to the action variable.

In one-step execution, the value is written when pressing the Execute standard key or when pressing the action button(if configured).
In two-step execution, the value is written when pressing the Execute 2 step standard key.

For further information, read the information in the Apply actions chapter.

attention Attention

When writing the set value directly neither the limits of the linked variable are checked nor is it checked if the write set value is allowed for this variable.


Action type status input

Action type status input

Changes the status bits of the response variable. The following is executed, depending on the definition of the switching direction:

Switching direction | Action
Off | The states configured in the Modifiable states list are all reset to 0.
On | The states configured in the list Modifiable states are all set to 1 (active).
None | The states configured in the Modifiable states list must be defined in Runtime with the help of the Set status control element. Each status bit is defined individually using a checkbox.

If you change a status bit in Runtime, the change is logged in the Chronological Event List (status including value). These language of these messages can be switched in Runtime.

info Information

For all status defaults, there is always a write to the response variable.

info Info

If a switch is locked using the lock action, the status bit M1 of the response variable is set.

The status bits OFF and REVISION are also handled in other actions.

In addition, the status bits CB_TRIP and CB_TR_I reflect the results from the property of the breaker trip detection command group.


Action type replace

Action type replace

The process value of a remote-controlled switch is temporarily replaced with a replacement value (due to revision, maintenance work, or an ongoing connection outage, for example).

The response variable is set to the status alternative value Alternate value ( ALT_VAL ). In addition, the value defined by the switching direction is placed on the response variable.

Switching direction | Alternate value
Off | 0
On | 1
Diff | 2
Fault | 3
None | 4


Action type revision

Action type revision

Sets or resets the Revision status bit The response variable as configured in the switching direction property.

Switching direction | Status
Off | Set to 0
On | Set to 1


Action type manual correction

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Action types -> Action type manual correction

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Action type manual correction

The correct action sets the value of the response variable according to the setting of the switching direction:

Note: the communication protocols in Energy (IEC60870, IEC61850, DNP3) preclude direct writing to the response variable. The action will be unsuccessful in these drivers! To execute a command, the setting of the value to a command variable is expected.

Switching direction

Action

Off

0

On

1

Diff

2

Fault

3

DIR

The set value is written directly. You define the value which should be written with the help of function Set value.

The text to be displayed can be configured using a limit or a reaction matrix for the state/value 5. If this is not the case, a standard text is used.

Nominal/actual value comparison is not supported. The action can be carried out several times in a row.

Set value

Value of the Set value control element is written to the response variable.

attention Attention

When writing the set value directly neither the limits of the linked variable are checked nor is it checked if the write set value is allowed for this variable.

info Information

The In progress (PROGRESS) status bit is set if:

  • When the action is carried out, the current value of the response variable is different to the value set for the switching direction
    and
  • the switching direction was defined as on or off.

Manual correction

Manual correction is the manual correction of a non-remote switch in zenon. A variable is usually corrected without a connection to the process. There should never really be an invalid i-bit pending for such variables. It is indeed possible, but it makes no sense to correct a variable with a reference to the process! The PLC will overwrite this value again.

Behavior:

Correction is completely normal value setting from the perspective of the driver.

Opposite of this - Action: Replace

The process value of a remote-controlled switch is primarily replaced with a replacement value (due to maintenance work, for example).


Action type block

Action type block

the response variable is switched off as a result of executing this action.

The status bit of the response variable is set to OFF . The switched-off variables are no longer read by the connected hardware.

Note: Can only be configured once per command group.


Action type release

Action type release

The Release actions resets the replacement value ( ALT_VAL ) status bit to 0 (inactive). If the Switched off ( OFF ) status bit is also active, it is also set to 0 (inactive). runtime receives the current value from the driver for the response variable once the Release action has been carried out.

The action can only be executed in Runtime, if the replacement value ( ALT_VAL ) (value: 1). is active for the selected response variable. 1).

Note: Can only be configured once per command group.


Check response value action type

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Action types -> Check response value action type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Check response value action type

The Check response value action type is to check variables for the status ON or OFF.

Whilst the Check response value action is executed, the standard key Cancel is unlocked in the Command Processing screen.

In doing so - depending on the setting of the runtime monitoring - there is a wait until the value of the response variable corresponds to the value of the checking direction - switching direction action property. If the checking value is EIN, this is the value 1; it is the value 0 for OFF.

If no runtime monitoring has been configured (runtime monitoring= "none"), the set waiting time (~24 hours) is the maximum time that is waited. Otherwise the action is ended and the TIMEOUT status bit is set for the response variable.

If, after execution of the action in the command processing screen, the other actions are not available, this is for the following reasons:

  • The timeout for runtime monitoring has not yet expired.
  • The response variable does not yet have the expected value (the value change has not yet been received).
  • The action has not yet been canceled with the Cancel button.

info Information

The Check response value action only serves to read the value of the response variable without executing an activity.

The action is intended for use in the Command Sequencer module.

If the response variable already has the value of the switching direction, the execution of the action is recognized as completed. The other buttons in the command processing screen are thus immediately available.

Note: If the response variable is set to OFF or Revision , the response value can nevertheless be checked.


Action type lock

Action type lock

Enables the lock of a response variable for the actions of the command.

Note:

  • Can only be configured once per command group.
  • Interlocking conditions are not supported for the action. Locks can always be executed.

info Information

If a switch is locked using the Lock action, status bit M1 is set.

A prerequisite for this is that users have a lock code configured in the user administration module. Locking/unlocking a response variable can only be done with the correct input of a lock code.

The same variable can be locked by multiple users in parallel. Actions for the response variables are possible only after alls locks have been unlocked by entering the lock code.

There can be no actions executed if

  • Actions of the command variables use the locked variable as response variable (e.g. switching command)
  • Actions of the command variables use the locked variable as an action variable (e.g. replace)

A list of the currently-active locks can be shown in the command screen using a special lock list control element.

The lock code can be defined individually for every user. These parameters are set directly for a pre-existing user with the lock code: property.

You can also set the lock code for an existing user in Runtime.

In the Runtime you cannot delete users who still have an active command lock.

attention Attention

Users can be deleted in the development environment. This causes the loss of the defined locks after restarting or reloading.

Users locked (activated) in the user administration cannot activate or deactivate command locks.

info Information

Information about active locks is also synchronized in the redundant network and is therefore available after redundancy switching.


Apply actions

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Apply actions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Command in the Energy Edition can be used in different situations. The user can choose the variant they prefer. It is also possible to use different methods simultaneously (element-related).

  • Calling up a screen switching function on a Command Processing screen.
  • Calling up a numeric value, combined element, dynamic text, bar graph, clock, universal slider, pointer instrument or status element screen.
    For activation, the Write set value property must be configured to command using the element.
  • Call via a context menu if command was set for the action type property. The command processing screen is opened for any possible interaction with the user (e.g. pending interlocking).
  • It is called up using the Command Sequencer module.

As soon as the variable is linked to a command group, direct input of set values is only possible using a command processing screen or a command context menu. Exception: If the command group contains a setpoint input action with switching direction'set value', this action is used for the command variables (not response variables).

This happens:

  • When calling up the Write set value function.
  • When calling up the screen element; also if the Write set value via of the element has the value dialog box or element.
  • When calling up a set value context menu.

However then neither the status bit NET_SEL of the response variable is taken into account nor is a Select executed.

Attention: with this type of execution, a pending interlocking condition in the write set value action prevents writing of a set value. in doing so, no interaction with the user is undertaken.


Screen switch to command screen

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Apply actions -> Screen switch to command screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Screen switch to command screen

If a command screen is selected with the screen switch function, the configuration dialog for the screen switching function has the following parameters:

Parameters | Description
Variable defining the command | The variable configured here defines the command group to be used. The screen determines the appropriate response variable and the associated action variable via the name of the variable.
Initial step | Defines the step (status) in which the command screen is loaded. Step 1: The screen is loaded and waits for action definition and action execution. Action executions must be performed manually by the user. Lock: The screen is opened in the command step for the action lock.


Command processing via dynamic screen elements

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Apply actions -> Command processing via dynamic screen elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Command processing via dynamic screen elements

If, for a dynamic screen element, the Command' option is configured for the Set value via setting, the command window can be opened in Runtime by left-clicking on the element. The screen to be opened is defined at the command group of the variable linked to the element. The corresponding action or response variable is automatically determined from the response variable.

info Information

With the 'Command' option selected, the command window is called up instead of the standard 'Write set value' standard dialog.

The following screen types support the Command option:

  • Numerical value
  • Combined element
  • Text element
  • Bar display
  • Pointer instrument
  • Status element
  • Clock
  • Universal slider

If no command group was defined for the variable assigned to the element, or if the response variable of the command group does not exist, an error entry for the diagnosis viewer is generated. The screen is not opened then.

"Write set value via" - dialog box or element

If, for an element with the setting "Write set value via", the "input field" or "Element" option is used, and the variable assigned to the element has a command group, all changes to the set value are also carried out via the command group. The following requirements must be met in order for a value to be written:

  • The command group must have the "Write set value" action configured and the resulting action variable must be the variable of the selected screen element.
  • No interlocking condition can prevent execution of the action.

info Information

If one of the previously-stated requirements is breached, the writing is not carried out and no set value is written to the variable.


Command processing via context menu

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Apply actions -> Command processing via context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Command processing via context menu

The command can also be instigated at the element directly via the context menu - property Runtime - context menu. This is the most frequently used method. In this regard, the context menu is already the first step of the two-step action.

The menu must have an entry of the command processing action type. The display of the single action is defined automatically by the menu. The display of the actions can be influenced selectively, depending on the 'names' of the menu entry.

When creating a new action in the Command Processing, a menu ID corresponding to the action type and the switching direction for the Action type property is created and offered in the drop-down list. If the content corresponds to an ID defined as standard text for the action type and switching direction, the content is adapted if the action type or switching direction change.

To create a context menu for the command:

  1. Create the desired actions in the command
  2. Select Action type in the properties of the context menu item as a command
  3. Select the desired action and switching direction via the drop-down menu with the Menu ID property
  4. Give it a clear label in the Text property
    Note: If no entry is defined for Text, the field is automatically filled with the "command" label.

attention Attention

The name of the Text property must be unique. If two names the same are issued, further menu items with the same name are not displayed.

Because automatically created menu items with the same action result in the same text, there are macros available for these.

The character sequence ID_CMD_AUTO is reserved for automatically created menu items. These must always be used with macros, because otherwise only the menu item is inserted.

When checking for duplicate entries the following rules apply:

  • Manual menu points have priority over automatic ones.
  • If it is the same type then the last entry has twice the priority.
  • If a duplicate entry is found, a warning is set off in the log. This includes the menu ID and description. Automatically expandable entries have <auto> added to the ID.

Actions for Action type command

Action | Switching direction | Menu ID
ID_CMD_AUTO |  | This menu entry automatically shows all possible actions for an element, if no direct menu entry from the list is used already.
Pulse command | On (1) | ID_CMD_EBEF_ON
Pulse command | OFF (1) | ID_CMD_EBEF_OFF
Pulse command | NONE | ID_CMD_EBEF_NONE
Switching command | On (1) | ID_CMD_DBEF_ON
Switching command | OFF (2) | ID_CMD_DBEF_OFF
Switching command | NONE | ID_CMD_DBEF_NONE
Set value | NONE | ID_CMD_SVALUE
Set value | DIRECT | ID_CMD_SVALUE_DIR
Status input | NONE | ID_CMD_STATE
Status input | On (1) | ID_CMD_STATE_ON
Status input | OFF (0) | ID_CMD_STATE_OFF
Replace | NONE | ID_CMD_REPL_NONE
Replace | On (1) | ID_CMD_REPL_ON
Replace | OFF (0) | ID_CMD_REPL_OFF
Replace | DIST | ID_CMD_REPL_DEF
Replace | DIFF | ID_CMD_REPL_DIFF
Manual correction | NONE | ID_CMD_UPD_NONE
Manual correction | On (1) | ID_CMD_UPD_ON
Manual correction | OFF (0) | ID_CMD_UPD_OFF
Manual correction | DIFF | ID_CMD_UPD_DIFF
Manual correction | DIST | ID_CMD_UPD_DEF
Manual correction | DIRECT | ID_CMD_UPD_DIR
Block | NONE | ID_CMD_BLOCK
Release | NONE | ID_CMD_UNLOCK
Lock | NONE | ID_CMD_LOCK
Revision | OFF (0) | ID_CMD_REV_OFF
Revision | On (1) | ID_CMD_REV_ON
Mandatory command | On (1) | ID_CMD_FORCE_ON
Mandatory command | Off (0) | ID_CMD_FORCE_OFF
Mandatory command | NONE | ID_CMD_FORCE_NONE

Name of the menu items of the context menu

1. Automatic creation

Entries which were created via ID_CMD_AUTO automatically receive a name after the following pattern: 'Action name' plus 'Limit text of the switching direction'.

2. Manual creation from table

If the menu entries are created from the table, for every action under 'Display - Text' a text must be defined for the entry in the context menu.

Names for the menu entries:

Command, Set value, Status, Replace, Release, Manual correction, Block, Lock, Revision

Action texts

Action | Text
Pulse command Switching command | Text from the limit text, according to the switching direction.
Manual correction Replace | If a switching direction (other than 'None') is defined, the text from the limit text according to the switching direction is displayed.
Status | 'OFF' or 'ON', depending on the current switching direction
Revision | Text from the limit text, according to the switching direction.
Others | No special action text is displayed.

Example Example

Displayed text for a switching command with defined limit:

'Command: switching direction ON'

info Information
  • All displayed texts are language switchable with the standard mechanisms. See also: Which texts are language switchable?
  • All displayed menu entries are automatically sorted alphabetically.

The currently used command group is determined via the variable which is linked with the screen element. If no command group is assigned to the variable or if there is no response variable, the context menu is not displayed in the Runtime (an according error message is transferred to the diagnosis server).

info Information

The menu entries of the command are displayed depending on the command group. The menu entry is showed only when the connected action exists. Consequently, if the variable of the element is the command variable, only the actions for the command variable plus the action 'Lock' can be displayed. Actions for the response variable are hidden automatically.

Availability conditions

The menu entries are only released when the corresponding actions are executable. The following conditions are requirements:

  • All menu entries are locked if the NET_SEL status bit of the response variable is active.
  • All menu entries are locked, when the response variable could not be determined.
  • All menu entries are locked, when the response variable has no value and could not get a value within 30 seconds.
  • All menu entries are locked on an Internet Client without write access.
  • Menu entries are locked when there is no connection to the server.
  • The menu entry connected to the 'Release' action is locked when the ALT_VAL status bit of the action variable is not active.
  • The menu entry connected to the 'Replace' action, whose switching direction matches the value of the action variable, is locked.
  • All menu entries, except the one which is connected with the action 'Lock', are locked, when a change lock is active for the response variable.
  • When the REVISION status bit of the response variable is active, the actions 'Set value', 'Replace', 'Correct', and 'Command' are locked.
  • As long as a watchdog timer, an edge generation or an SBO is active for the command group, all menu entries are locked. This results from the fact that the NET_SEL status bit also stays active.


Macros for the context menu

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Apply actions -> Macros for the context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Macros for the context menu

A macro is a defined character sequence that is replaced by another text when menu items are created in Runtime. Virtually all macros can occur more than once per menu item. They can also contain further macros as a result. In doing so, the expansion sequence must be considered. Macros are not case sensitive when configuring menus. If macros contain a macro as a result, the macro must be contained in capitals in the result. The entry is made with $ as a prefix and suffix.

The sequence of the expansion is from left to right in the following priority.

  1. $NOTE$
  2. $TAG$
  3. $REMA<Status>$
  4. $RDIR$
  5. $ALL$
  6. $DIR$
  7. $ACT$
  8. $NOTE$

Macro

Description

$NOTE$

The whole text including the macro is interpreted as a note. If the resulting text is empty, the $ALL$ macro is used.

$TAG$

Is replaced by the identification of the action variable.

The identification can be translated by the online language translation function. If no translation character (@) is contained, the whole identification is highlighted for translation.

$REMA<Status>$

<Status> is a Rema or limit value state, the text of which is used as a replacement.

If the status is not present, the menu item is not displayed.

The limit value text is translated linguistically according to the placement of @ .

The status can be a number between -231 and 231-1. Leading characters and a prefix are permitted. If characters are contained that cannot be converted to a number, or the number is outside the given area, the menu item is not displayed.

$RDIR$

Text for the switching direction from reaction matrix/limit value as in $DIR$ macro, with the exception of:

  • Action Write set value direct
    The text is taken from the rema/limit value of the status, which corresponds to the value of the set point to be set.
  • Action Status on and Status off
    Text is taken from the rema/limit value for the on or off statuses.
  • Action Correct direct
    The text is taken from the rema/limit value of the status, which corresponds to the value of the set point to be set.

$ALL$

Results in Action naming: Switching direction.

Corresponds to the combination of the $ACT$: macro $DIR$

Note: If a context menu is created for the command, the default text is $ALL$, even if the menu already has text configured for it but the action type changes to command.

$DIR$

Switching direction of the action.

$ACT$

Action naming of the action.

$NOTE$

For the last macro, the note macro is again checked and the text to the right of this including the macro is deleted.

If the resulting text is empty or only consists of spaces, the menu item is not inserted.

Automatically created menu items

Automatically created menu items are created as a menu ID with ID_CMD_AUTO. In this case, macros must always be used, because otherwise only a menu item would be inserted.

Compatibility

Previous to version 6.51 text at automatic menu items was ignored. When converting projects that were created with versions earlier than 6.51, the macros $ALL$$NOTE$ are automatically inserted before the configured text. Therefore the menu items behave as before.

Online Language Switch

The labeling for the menu item in the Text property is translated linguistically before macro expansion from the character @.

Note: If, for the $TAGS$ macro, no translation indicator (@) is contained, the complete text is translated.


Error messages when the context menu is called up

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Apply actions -> Error messages when the context menu is called up

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Error messages when the context menu is called up

When menus are loaded in the Runtime environment, their content is checked for consistency. If an error occurs, corresponding error messages are issued for the Diagnosis Viewer. The following messages can appear:

Parameters | Description
Menu entry for command suppressed, because name is several times in the menu! | The menu already contains a menu entry with the name used in the command. Do not use that name for any other menu entries for the command processing.
Menu entry for command suppressed, because description is several times in the menu! | There is already a menu entry with the same description in the menu. Automatically created menu entries are not added, when a menu entry with the same description is already there.
Text for menu entry cannot be detected! | The description of an automatically created menu entry could not be determined. This most probably indicates a missing limit text.
No command group linked to variable of the screen element! | The variable associated with the screen element has no command group or a no longer valid command group. According error messages are given during compiling.
Response variable does not exist! | The response variable used in the command group does not exist.
Select cannot be activated! | Status bit NET_SEL (8) could not be activated within the timeout.


Execution of actions via the context menu

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Apply actions -> Execution of actions via the context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Execution of actions via the context menu

After activation of a menu item for command processing, the assigned action is carried out. Execution via a menu activates the setting of the NET_SEL status bit in the first step. Only if this is successful is the execution of the actual action ('switching command', for example) started.

A command window is then opened if one of the following criteria has been met:

  • If the action to be executed is Write set value, Status input with input or Correction, the screen assigned to the action in the "Stage 1" step is opened. The set value /status to be written can then be defined in the screen.
  • If the action to be carried out is lock, the action-specific screen is called up with the "lock" step.
  • If an active locking condition prevents execution, the screen configured in the Unlocking step for the action is called up. Execution is also prevented if SBO could not be activated without errors.
  • If two-stage execution is configured for the action, the action-specific screen is called up in the "Stage 2" step.
  • If no specific screen has been configured for the action, the screen that has been configured centrally for the command group is opened.

info Information

If none of the above-mentioned conditions are applicable, the action is executed immediately, without further operations.


Set value context menu

Set value context menu

If the variable assigned to a screen element is linked to a command group, the writing of a set value is also handled by the command. The requirement for this is that a Write set value action is present with 'set value' switching direction. If this is missing, the writing of the set value is not carried out.

info Information

An active interlocking condition prevents the writing of a set value.


Command conditions

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Command conditions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Command groups contain both the definition of the switch actions and the definition of the command interlocking conditions. Command conditions are optimum parameters that can be defined application-specifically.

Each action within a command group can also be supplemented with command conditions. These process-controlled interlockings prevent unwanted execution of actions, depending on the current process state.

The following three parts are significant in a command group for the command conditions:

Parameters | Description
Actions | These define which command is executed, on which variables these actions are applied and set the parameters for the internal interlockings.
Condition variables | These define which variables in the command conditions can be used.
Command conditions | The execution of commands in is also made dependent on the current process status by these conditions.

The actions automatically check the internal conditions. These internal conditions are to check whether the basic requirements for the execution of an action have been met (plausibility check). Example: The activation of the Select will be rejected by the PLC.

Note: Configured interlocking conditions have no influence on this check.

seealso See also

General interlockings


Defining command conditions

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Defining command conditions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Any number of command conditions can be defined for every action. These conditions allow for an additional restriction of the ability to execute an action. These conditions are defined with formulas, in which you can use the variables from the active projects. The formula addresses the linked variables via the index in the condition.

info Information

The condition variable is automatically replaced if a ’*’ is used in the definition.


Define condition variable

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Defining command conditions -> Define condition variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Define condition variable

First we have to define variables which can be used later for the formulas of the command conditions. If the defined conditions are fulfilled by the linked process variables later, during Runtime, the user has the respective actions available.

info Information

If a variable which was used in a command condition is deleted later on, the index within the condition is adjusted. The succeeding variables are put forward and the formulas are adjusted automatically.

The following procedure is recommended for defining a command condition:

Example Example
  1. Select the node Variable in the detail view of the command and select the option 'New' in the context menu.
  2. In the selection dialog, select a process variable, which serves as the base for the formulas of the command conditions. You can also abort the variable selection dialog, which leads to an empty definition. You can define an automatic replacement for this empty link with a '*'.
  3. Select an already existing action and the node 'Conditions' in the detail view. With 'New condition', you can define any number of conditions for every action. The definition is performed with formulas; non-fulfilled conditions cause a lock of the associated actions in Runtime.


Interlocking condition

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Defining command conditions -> Interlocking condition

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Interlocking condition

Any number of command conditions can be defined for every action. Theses conditions are checked before execution of the respective action. If a check fails, the respective action cannot be executed in Runtime.

The conditions are defined as formulas. This syntax is analogous to the definition of the formulas in the Formula Editor.

Additionally, the following interlocking types (in addition to the command groups) are checked before action execution:

Internal interlocking conditions

These conditions are checked automatically before every action execution; the engineer cannot influence this. These Internal interlocking conditions are predefined by the system and serve as plausibility checks.

Example Example
  • The response variable is already selected in the zenon network (has set NET_SEL status from other Client).
  • The response variable already has the desired value and the action was configured with Nominal/actual comparison.
  • In the SBO, the Select was not accepted by the controller (status bits: SE_870 + COT_actcon(7) + N_CONF).

Topological interlocking conditions

These conditions result from the current topological status during Runtime. These conditions are defined in the 'Configuration of the topological interlockings' settings.


Internal interlocking conditions

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Defining command conditions -> Internal interlocking conditions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Internal interlocking conditions

With the help of the internal interlocking conditions the basic requirements for the action are checked (plausibility check). The results or the addressing of an interlocking are displayed in Runtime in the command window as interlocking text.

Parameters | Description
Status already exists | The state which should be set equals the current value of the response variable. This check is only active if the command group of the 'Nominal/actual value comparison' is active. This interlocking can be unlocked (insofar as the user has authorization for this).
Internal error occurred | Command Processing cannot execute the check. This happens when the data type of the action variable is not allowed for this action. Example: 'Pulse command on' action for string variables. This interlocking cannot be unlocked.
no interlocking object | Command group could not be determined. This interlocking is not unlockable.
Action not defined | Action to be executed could not be determined. This interlocking is not unlockable.
Differences between local and global interlocking | Pulse command parameter not consistent. Error setting parameters This interlocking cannot be unlocked.
One or more values are not available | Value of condition variable not available. Lock code: 14 Value of condition variable invalid (INVALID). Lock code: 15 This interlocking is not unlockable.
Locking administration not valid | The administration of the lockings could not be loaded or is invalid. This interlocking is not unlockable.
Variable locked for changes | Command locked by response variable (status bit M1). This interlocking is not unlockable.
SBO rejected | The activation of the Select was rejected by the PLC. This interlocking is not unlockable.
Timeout for SBO activation | No confirmation for the activation (positive or negative) was received within the timeout. This interlocking is not unlockable.
Timeout for SBO deactivation | No confirmation for the deactivation (positive or negative) was received within the timeout. This interlocking is not unlockable.
Timeout for execution | There was no notice for finishing the action execution within the timeout. The TIMEOUT status bit is set for the response variable. This interlocking cannot be unlocked.
SBO expired | The PLC has reported the expiration of the SBO activation. The second execution step will attempt to send a Select again. This interlocking cannot be unlocked.


Formula editor

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Define Command Processing -> Formula editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The formula editor provides support when creating formulas with logical or comparative operators with a combined element, for interlockings and commands. If additional variables are required for a formula, create these in the formula variables area of the status window by clicking on the Add button. existing formulas are displayed in the status list with the lettersF .

Note on the input of decimal points:

  • Decimal separator: Comma (,) is automatically converted into a dot (.):
  • Zero as a decimal point is removed automatically; 23,000 automatically becomes 23

Creating a formula

Click on the Formula button in the status window The formula editor opens

You select the bits for your formula in the left screen.

On the right, you find the operators for logical and comparative operations.

The formula created is displayed in the Formula area.

info Information

Up to 99 variables can be linked in one formula. X01 to X99. The length of the formula must not exceed 4096 characters.

The meaning of the bits:

Parameters

Description

value bits

32 value bits (from 0 -31) are available. They describe the variable value bit by bit. For binary variables, only bit 0 is of importance, for SINT and USINT only the bits from 0-7, etc.

Note: The value refers to the raw value (signal range) of the variables and not to the converted measuring range.

status bits

Here you find the most commonly used status bits. You find the exact definition and use of the status bits in the Status Bits List.

not acknowledged

Not acknowledged is treated like a usual status bit. But here it is listed separately, because it does not belong to the classical variable statuses.

value and status

All values (value bits and status bits) in the formula are considered as binary value and can be linked with logical operators such as AND or OR.
The total value and overall status are an exception to this. In order to get a Boolean result this total value has to be ORed with a constant bitwise. For this, we use the operator &.
For the result 0 (false) of this logical ORing we get the binary value 0 (false), otherwise 1 (true).

Example: see chapter Example bit by bit ORing

info Info

The status bits NORM and N_NORM are only available in the formula editor and cannot be engineered via the status.

If other settings outside the formula are set for the current status, they are combined with the formula with a logical AND.

Refer to the examples section for examples.

info Information

Formulas with binary X values and bitwise linking can be used with a maximum of 2 binary values. If more values are required, the linking must be carried out without binary X values.

Example:

X01.Value & X02.Value -> works

X01.Value & X02.Value & X03.Value -> does not work

But:

X01.00 AND X02.00 AND X03.00 AND X04.00 AND X05.00 -> works


List of status bits

List of status bits
Bit number | Short term | Long name | zenon Logic label
0 | M1 | User status 1 | _VSB_ST_M1
1 | M2 | User status 2 | _VSB_ST_M2
2 | M3 | User status 3 | _VSB_ST_M3
3 | M4 | User status 4 | _VSB_ST_M4
4 | M5 | User status 5 | _VSB_ST_M5
5 | M6 | User status 6 | _VSB_ST_M6
6 | M7 | User status 7 | _VSB_ST_M7
7 | M8 | User status 8 | _VSB_ST_M8
8 | NET_SEL | Select in the network | _VSB_SELEC
9 | REVISION | Revision | _VSB_REV
10 | PROGRESS | In operation | _VSB_DIREC
11 | TIMEOUT | Runtime exceedance | _VSB_RTE
12 | MAN_VAL | Manual value | _VSB_MVALUE
13 | M14 | User status 14 | _VSB_ST_14
14 | M15 | User status 15 | _VSB_ST_15
15 | M16 | User status 16 | _VSB_ST_16
16 | GI | General interrogation | _VSB_GR
17 | SPONT | Spontaneous | _VSB_SPONT
18 | INVALID | Invalid | _VSB_I_BIT
19 | T_CHG_A | Daylight saving time/winter time announcement | _VSB_SUWI
20 | OFF | Switched off | _VSB_N_UPD
21 | T_EXTERN | Real time external | _VSB_RT_E
22 | T_INTERN | Realtime internal | _VSB_RT_I
23 | N_SORTAB | Not sortable | _VSB_NSORT
24 | FM_TR | Error message transformer value | _VSB_DM_TR
25 | RM_TR | Working message transformer value | _VSB_RM_TR
26 | INFO | Information for the variable | _VSB_INFO
27 | ALT_VAL | Alternate value If no value was transferred, the defined alternate value is used otherwise the last valid value is used. | _VSB_AVALUE
28 | RES28 | Reserved for internal use (alarm flashing) | _VSB_RES28
29 | N_UPDATE | Not updated | _VSB_ACTUAL
30 | T_STD | Standard time | _VSB_WINTER
31 | RES31 | Reserved for internal use (alarm flashing) | _VSB_RES31
32 | COT0 | Cause of transmission bit 1 | _VSB_TCB0
33 | COT1 | Cause of transmission bit 2 | _VSB_TCB1
34 | COT2 | Cause of transmission bit 3 | _VSB_TCB2
35 | COT3 | Cause of transmission bit 4 | _VSB_TCB3
36 | COT4 | Cause of transmission bit 5 | _VSB_TCB4
37 | COT5 | Cause of transmission bit 6 | _VSB_TCB5
38 | N_CONF | Negative acceptance of Select by device (IEC 60870) | _VSB_PN_BIT
39 | TEST | Test bit (IEC870 [T]) | _VSB_T_BIT
40 | WR_ACK | Writing acknowledged | _VSB_WR_ACK
41 | WR_SUC | Writing successful | _VSB_WR_SUC
42 | NORM | Normal status | _VSB_NORM
43 | N_NORM | Deviation normal status | _VSB_ABNORM
44 | BL_870 | IEC 60870 Status: blocked | _VSB_BL_BIT
45 | SB_870 | IEC 60870 Status: substituted | _VSB_SP_BIT
46 | NT_870 | IEC 60870 Status: not topical | _VSB_NT_BIT
47 | OV_870 | IEC 60870 Status: overflow | _VSB_OV_BIT
48 | SE_870 | IEC 60870 Status: select | _VSB_SE_BIT
49 | T_INVAL | Time invalid | not defined
50 | CB_TRIP | Breaker tripping detected | not defined
51 | CB_TR_I | Breaker tripping detection inactive | not defined
52 | RES52 | reserved | not defined
53 | RES53 | reserved | not defined
54 | RES54 | reserved | not defined
55 | RES55 | reserved | not defined
56 | RES56 | reserved | not defined
57 | RES57 | reserved | not defined
58 | RES58 | reserved | not defined
59 | RES59 | reserved | not defined
60 | RES60 | reserved | not defined
61 | RES61 | reserved | not defined
62 | RES62 | reserved | not defined
63 | RES63 | reserved | not defined

info Information

In formulas all status bits are available. For other use the availability can be reduced.

You can read details on status processing in the Status processing chapter.


Logical operators

Logical operators

Logical links: Variables will only be checked for the logical value '0'; if the value does not equal '0', it will be considered as '1'.

In contrast to bit formulas, the technical range can be modified by a stretch factor -> (not equal '0' or '1').

Operator | Meaning
AND | logical 'AND'
NOT | Negation
OR | logical 'OR'
XOR | logical 'EXCLUSIVE OR'

The operators have the following priority in the formula calculation:

Priority | Operator
1 | & (operator for bit formulas)
2 | NOT
3 | AND
4 | XOR/OR

info Info

Up to 99 variables can be linked in one formula. X01 to X99.

info Info

The status bits NORM and N_NORM are only available in the formula editor and cannot be engineered via the status.


Bit formulas

Bit formulas

Bit formulas only have a logical high or low state. In contrast to logical formulas, the raw value is already predefined (0,1).

Operator | Description
& | AND
| | OR


Example: ORing bitwise

Example: ORing bitwise

You want to find out if one of the user status bits 1-8 (M1 ... M8) of the variable X01 is set.

Usual formula:

X01.M1 OR X01.M2 OR X01.M3 OR X01.M4 OR X01.M5 OR X01.M6 OR X01.M7 OR X01.M8
This query can be made much easier by the logical ORing of the overall status.

Logical ORing:

X01.Status & 0xFF

The constant can be entered in hexadecimals, as described above:

0xFF corresponds to decimal 256; these are the first eight status bits (binary 11111111). If one of these bit is set to 1, the result of this bitwise ORing is 1 (true), otherwise it is 0 (false).

If, for example, all user status bits except the user status bit M7 should be queried, the binary statement for this would be: 10111111. Bit 7 is not of interest and is thus set to 0. This corresponds to 0xBF in hexadecimal. The expression for the formula is then: X01.Status & 0xBF.

Instead of ORing bitwise with a constant, the value can also be directly compared to a decimal number. If the comparison is wrong, the binary value is 0 (false) otherwise it is 1 (true).

Example:

You want to find out if the value is equal to the constant 202: The formula is:

X01.value = 202

If the value is equal to the constant 202, the result of the comparison is 1 (true) otherwise it is 0 (false).

Note: The bitwise ORing works with the OR character (|) in a similar manner to this example.


Comparison operators

Comparison operators

Comparison operators serve for the direct comparison of two numeric values. The result of this comparison is a binary value. "0“ if the condition is not fulfilled and „1“ if the condition is fulfilled.

Operator | Description
< | less
> | greater
<= | Less then or equal
>= | greater or equal
= | Equal
<> | unequal

To the left and to the right of the comparison operator, there has to be a (total) value or a (total) status, single bits cannot be used with these comparison operators.

There can also be a constant to the right of the comparison operator. (the constants can only be integers; a comparison to a floating point number is not possible.)
These constants are entered as hexadecimal values or decimal values in the combined element. Hexadecimal figures are automatically converted to decimal values by clicking on OK (for example, 0x64 is in decimal figures 100).

Example Example

X01.value >= X02.value
The result is 1, if the value of X01 is higher than or equal to the value of X02

X01.value = 0x64
The result is 1, if the value of X01 is exactly equal to the numeric value 100 (= hex 0x64)

(X01.value = 0x64) OR (X01.value = 0x65)
The result is 1, if the value of X01 is exactly equal to the numeric value 100 or 101 (= hex 0x64 and hex 0x65)


Examples for formulas

Examples for formulas

Simple logical AND linking between two bit values

Example Example

Formula: X01.03 AND X02.03

This formula has the status TRUE, if both bit 3 of variable 1 and bit 3 of variable 2 both have the value 1.

comparison of an analogue value or status of a variable

Example Example

(X01.Value> X02.Value)

Compare analog values with each other on a logical basis

Example Example

(X01.Value> X02.Value) AND (X01.Value = X02.Value)

Compare with value bits and status bits

Example Example

(X01.Value> X02.Value) AND (X01.Value = X02.Value) OR (X01.03 = X02.03)

Compare a value with a decimal or hexadecimal value

Example Example

Formula: (X01.Value = 111)

Formula: (X01.Value = 0x6F)

If a hexadecimal values is used, this is later transferred to decimal by clicking on OK. If a decimal value is entered and confirmed, the value continues to be displayed as a decimal value after reopening.

info Info

It is not possible to use a comma or a period when entering values.


Create menu

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Create menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Command can also be activated via a context menu. Context menus are created in the Editor using node Menus and are defined in the properties of the element they concern.

Generally there are three types of menu entries:

Parameters

Description

Action type

Sets out which type of action is to be carried out via the corresponding menu item in Runtime. Not all action types are available in the main menu, some are only available via the context menu.

  • Acknowledge alarm (context menu only)
  • Command input (context menu only)
  • Acknowledge flashing (context menu only)
  • Function
  • Help
  • No action
  • Send value to hardware
  • VBA macro (context menu only)

Submenu

Opens a sub-menu in Runtime.

Separator

A horizontal line divides menu entries.

Underline text: Entering a & causes the following characters to be displayed as underlined.

Plan entries

To configure a menu item in the main menu or context menu:

  1. Activate the corresponding menu cell
  2. In properties, select:
    • Action type: depending on menu type
      see also: Main menu action types and Context menu action types
    • Menu ID: Entry ID
      Note: There are pre-defined types with a fixed ID available in the command input at Command input
    • Text: clear labeling of the menu cells

attention Attention

The name of the Text property must be unique. If two names the same are issued, further menu items with the same name are not displayed.

You can find details on the definition on context menus for command processing in chapter menusCommand Processing.


Create Runtime files - start the Runtime

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Create Runtime files - start the Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When creating Runtime files for the command groups, a check for engineering errors and correct replacement is performed.

For every variable which has a command group allocated to it, a specific version of the command group for zenon is created. This version only contains these actions which can be triggered over this variable.

Example Example

The command group for the command variable only has actions on this command variable anymore. Except for the action 'Lock'. This action is also available for the command variable.

info Information

The compiling of the command must also be triggered after changes to the variables.


Replace links

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Create Runtime files - start the Runtime -> Replace links

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to increase the reusabilty of the command group, there is the possibility to replace the variable references. Replacement is possible for the response, command and condition variable.

During the replacement, the placeholder, '*’, is automatically replaced by the name of the variables that are assigned to the command.

Example Example

Let's assume that we have the variables xyz_RM, abcRM and bool_RM.

Our mask is '*_RM’.

Variable name | Replacement text | Result | Comment
xyz_RM | xyz | xyz_RM | Variable exists, assignment is possible
abcRM | <empty> | _RM | The mask is not correct, because '_' is missing. Variable does not exist.
bool_RM | bool | bool_RM | Variable exists, assignment is possible

info Information

If it is detected that the variable for which the command group is to be compiled corresponds to the response variable. The replacement text is determined by the response variable. Otherwise the replacement text is defined by the action variable or the first action appropriate to the variable.

If the replacement text was determined correctly, the placeholder '*' is replaced by this.

The following points should therefore be taken into account with the labeling:

  • The names of the variables and the mask should be selected in such a way that these can be clearly assigned.
  • The names of the variables that are used for the response, command and condition variables should be able to be created from the same replacement text.
  • If the response variable is replaced but not the command variable, particular care should be taken to ensure that the command group that is created for the command variable also uses the expected response variable.
  • Another test run for the command group with the response variable ensures that only actions whose action variable uses the same response variable with its compiled interlocking are contained. Actions that breach this rule create a warning and are removed.


Error while creating Runtime data

Manual -> Energy Edition -> Command Processing -> Engineering in the Editor -> Create Runtime files - start the Runtime -> Error while creating Runtime data

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

At the creation of the Runtime data for the command, an extensive validation is carried out concerning wrong engineering and not-available references.

info Information

After an Error the object the caused the error is not available during runtime.

If the command group has an Error, no command group is assigned to the variable. Consequently, during the Runtime, all user operations are locked.

A Warning is generated when the project would cause a problem but runs error-free.

In the error messages, the following placeholders are used:

<VERNAME> | Placeholder is replaced in the error message by the name of the command group.
<VERRM> | Placeholder is replaced in the error message by the name of the response variable.
<AUFVAR> | Placeholder is replaced in the error message by the name of the variable to which the command group is assigned.
<ACTVAR> | Placeholder is replaced in the error message by the name of the variable of the action.
<Actionname> | Placeholder is replaced in the error message by the description of the action.
<VARNAME> | Placeholder is replaced by the variable in the visualization.

The following error messages can occur during the creation of the Runtime files:

Message text

Description

<VERNAME>: Interlocking PV <VERRM> does not exist!

Condition variable for general interlocking not available.

Variable '<AUFVAR>' uses not existing command!

Variable uses a non-existing command.

(<AUFVAR>) command '<VERNAME>' contains no actions!

Command groups without action are not considered by the Runtime. This message can also be a follow-up error.

(<AUFVAR>) response variable '<VARRM>' does not use the command group '<VERNAME>'

A response variable using another command group is used. The response variable always has to be linked with the interlocking, which uses it as response variable.

(<AUFVAR>) response varibale '<VARRM>' for command processing '<VERNAME>' uses a driver without process linking!

The response variable must lie on a driver with process connection.

(<AUFVAR>Command processing '<VERNAME>' contains no actions after compiling!

A command group without actions does not make sense.

(<AUFVAR>) response variable '<VARRM>' of command processing '<VERNAME>' not available!

The used response variable is not present or marked as deleted.

(<AUFVAR>) command processing '<VERNAME>' uses screen '<Bild GUID>'(<BILDNAME>) which is not of the type Power!

This message is a warning. If a user action becomes necessary during execution, it cannot be performed.

(<AUFVAR>) command processing '<VERNAME>' uses not available screen '<Bild GUID>'!

The screen assigned to the command group does not exist.

(<AUFVAR>) Replaced action variable '<ACTVAR>' for action '<Action name>' of command processing '<VERNAME>' not available!

The action variable, after a replacement, is not present or marked as deleted.

(<AUFVAR>) action '<actionname>' of the command'<VERNAME>' uses the not existing variable '<ACTVAR>'

The action uses a varibale which is not present in the project or marked as deleted.

(<AUFVAR>) action variable '<ACTVAR>' for action '<Actionname>' of command processing '<VERNAME>' uses a driver without process connection!

The variable assigned to an action must not lie on an internal driver.

<VERNAME>(<AUFVAR>): Aktion '<Actionname>' already exists!

The following actions may only be configured once per action variable and command group:

  • Switching command with the same command status.
  • Correction with the same switching direction.
  • Replacing with the same switching direction.
  • Revision with the same switching direction.
  • Pulse command
  • Setpoint input
  • Release
  • Block
  • Lock

<VERNAME>(<AUFVAR>): Action '<Actionname>': Pulse and switching command not possible for the same command variable!

Pulse and switching command must not be used together.

(<AUFVAR>) Action '<Actionname>' of the command '<VERNAME>' uses screen '<Bild GUID>('<Bildname>') which is not of type Power!

This message is a warning. No user actions will be possible.

(<AUFVAR>) Action '<Actionname>' of the command '<VERNAME>' uses not existing screen '<Bild GUID>'!

The action is assigned to a non-exising screen.

<VERNAME>(<AUFVAR>): Interlocking PV '<VARNAME>' does not exist!

Replaced condition variable does not exist.

(<AUFVAR>) Variable '<VARNAME>' of action interlocking condition of the command '<VERNAME>' does not exist!

Variable of the interlocking condition does not exist.

(<AUFVAR>) action variable '<VARNAME>' for action '<Actionname>' of command group '<VERNAME>' uses another command group!

The action variables used for a command group may only be connected to no command group or to the command group in which they are used.

(<AUFVAR>) command variable <ACTVAR> does not have a validly compiled interlocking! Action <Actionname> removed.

The action variable used in the action has no compiled command group. This message can also be a follow-up error.

(<AUFVAR>) command variable <ACTVAR> uses response variable <VARNAME>! Action <Actionname> removed.

The compiled command group of the response variable contains actions with action variables which do not use the same response variable as <AUFVAR>.
Note: There must not be any actions of response variables changing other response variables.


Operating during Runtime

Manual -> Energy Edition -> Command Processing -> Operating during Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A watchdog timer is automatically carried out in the background if a used enters commands in Runtime.


Command procedure

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Command procedure

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This description for the procedure of a command with the command processing is applicable for the following command action types:

  • Command
  • Auto/Remote command
  • Mandatory command (only in part)
  • Setpoint input

The procedure of a command depends on the following parameters:

Variable property:

  • Select before Operate (SBO) Not active:
    In this case, no Select-command is executed by a command function.
    Note: A driver (for example: DNP3_NG or IEC850) can nevertheless execute a Select automatically. This has no effect on the command however. The command will, in this case, react to an unsuccessful Select in the same way as an unsuccessful Operate/Execute .
  • Select before Operate (SBO) Active:
    If Select before Operate is active for the action variable, a Select (COT_act(6), SE) is always forwarded to the driver by the command processing. In doing so, there is a wait - regardless of the type of runtime transfer configured - until the complete command process has been completed.

    Attention: The SBO variable property has corresponding effects on runtime monitoring.
    If SBO is activated, the action buttons (and context menu entries) are deactivated in runtime monitoring for each configuration until COT contains the value COT_accterm(10).
    This also applies if "none" or "via response variable" are configured for runtime monitoring.
    If no COT_accterm is received, only a TIMEOUT status bit is set.

info Info

If a variable is configured with an active Select before Operate and the driver does not support a COT , then no reaction to a sent Select will "come" from the PLC. Once the configured Timeout has expired, the command screen will inform you of the "Timeout on SBO activation" interlocking condition.

Type of runtime monitoring:

  • None
    • Without SBO: "fire & forget" - sends command and does not wait.
    • With SBO: there is a wait in the background, but no TIMEOUT status bit is set even if the timeout has expired.
  • Via cause of transmission only (COT)
  • Only via response variable (RV)
  • Via RV and COT

Properties in the command action:

  • One-step:
    After a successful Select , the command automatically transfers the Operate/Execute to the driver.
  • Two-step:
    A successful Select activates the buttons Execute 2nd Step and Cancel in the command processing screen:
    • If Execute 2nd Step is clicked on, the command transfers an Operate/Execute (COT_act(6), no SE) to the driver.
    • If Cancel is clicked on, a Cancel (COT_deact (8), SE) is forwarded to the driver.

  • Timeout:
    The configured value states how long is waited for a response from the PLC. Respectively:
    • After writing an Select command.
    • After writing an Execute command.
    • After writing an Cancel command.
  • Timeout can be canceled:
    Configuration states whether the user can cancel runtime monitoring after setting an Execute command.


Select before Operate

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Command procedure -> Select before Operate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The runtime monitoring property only has an influence on the Execute command. The Select command is not influenced by runtime monitoring. The command processing action waits for as long as is configured in the Timeout property (Options property group in the command action) after a Select wartet has been sent.

In doing so, this can lead to the following dependencies:

  • SPS does not react
  • SPS reacts negatively
  • SPS reacts positively
    • User does not send an Execute or Cancel

For canceling a Select - regardless of the type of runtime monitoring configured - the following is applicable:

  1. If SBO has been activated for the action variable, a Select can be canceled by the user for two-stage commands. After a successful Select (COT=7, SE), the command can send a Deactivation (COT=8, SE) if the Cancel button is clicked.
  2. There is then a wait for a response from the PLC or a timeout.
    The action ends:
    1. if the configured timeout time has expired or
    2. if the PLC confirms the cancellation (COT=9, any SE or PN).
      The receipt of a COT=9 discards the PROGRESS status bit.
  3. The measurement time starts at the point when the user clicks the Cancel button. The time period that has expired - whilst the action waits for a Select - does not influence the time period in which the action waits for a confirmation of the cancellation.
  4. The response variable does not receive a TIMEOUT status bit.
  5. The same action always applies, regardless of the configuration of the runtime monitoring property.

Note: the PN bit - Positive(0)/Negative(1) - is reflected on the status bit N_CONF of the action variable.


SBO - no reaction from the PLC

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Command procedure -> Select before Operate -> SBO - no reaction from the PLC

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
SBO - no reaction from the PLC

The command first sends a Select to the driver. All buttons in the command processing window are grayed out while the action waits for a reaction from the PLC. Information is shown in the command processing screen once the timeout action has expired. This message is displayed in the field of the interlocking text: internal interlocking condition "Timeout for SBO activation". In this case, only the Cancel button is available. All other buttons of the command processing window are still grayed out.

Entries in the context menu are also not available.

Note: The response variable contains neither a TIMEOUT nor a PROGRESS status bit.
The same action applies for Select , regardless of which value is configured for runtime monitoring. The process is the same for two-step actions and one-step actions.


SBO - negative reaction from the PLC

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Command procedure -> Select before Operate -> SBO - negative reaction from the PLC

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
SBO - negative reaction from the PLC

The command triggers the driver to send a Select (COT_act(6) + SE) . If a negative response is received by the PLC (COT_actcon(7) + SE + PN=1), waiting is no longer carried out.

  • The PROGRESS bit is removed by clicking on the Cancel button. The response variable does not receive a TIMEOUT status bit in the process.
  • If the action receives a negative response to Select, this information is displayed in the field of the interlocking test: internal interlocking condition "SBO rejected". In this case, only the Cancel button is available. All other buttons of the command processing window are still grayed out.

Entries in the context menu are also not available.

The same action applies to Select , regardless of which value is configured for runtime monitoring. The process is the same for two-step actions and one-step actions.

Note: the PN bit - Positive(0)/Negative(1) - is reflected on the status bit N_CONF of the action variable.


SBO - positive reaction from the PLC

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Command procedure -> Select before Operate -> SBO - positive reaction from the PLC

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
SBO - positive reaction from the PLC

If the PLC reacts positively to a Select (COT_actcon(7) + SE) (thus a confirmed Select), the action goes to the next step => execution

  • The command ends the waiting for a Select.
  • The response variable has its PROGRESS status bit set. However this is only if the current value of the response variable is different to the value of the command.

The following applies once the Select has been confirmed:

  1. One-step commands:
    The command processing automatically sends an Operate/Execute (COT_act(6), no SE) to the PLC.
  2. Two-stage actions:
    The Execute 2nd step and Cancel in the command processing screen become active. If a user confirms the Execute 2nd step button, the command processing sends an Operate/Execute to the PLC.

The PROGRESS bit is reset if the PLC confirms the Execute (COT_actcon(7)) or after expiry of the following runtime monitoring.


SBO - positive reaction from the PLC but the user does not send an Execute or Cancel

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Command procedure -> Select before Operate -> SBO - positive reaction from the PLC but the user does not send an Execute or Cancel

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
SBO - positive reaction from the PLC but the user does not send an Execute or Cancel

If the user, after a successful Select , triggers neither an Execute nor a Cancel , there is a wait for user interaction with no time limitation. It can thus happen - provided the PLC supports Select Timeout - that this time expires. If this happens, the PLC sends a Select-Termination (COT=10, SE, PN=1). The command reacts to the Select-Termination received so that - if the user does in fact trigger an Execute - the command automatically sends another Select first.
Once the Cancel button has been clicked on, a Select or Cancel is not sent to the PLC again.

Note: Is only relevant for two-step actions.


Watchdog timer

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Command procedure -> Watchdog timer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The cause of transmission (COT) is used to exchange information between zenon and the controller about whether a command is to be written or whether writing was successful. The action variable receives a COT corresponding to the level of the command. In the background, the command then checks to see if the response variable then changes its value and if the COT action variable changes according to the command.

Note: Value changes of the response variable will only be taken into account after COT_act(6).

info Information

COTx Status bits result in a value. This value can be evaluated in Runtime - just like all other status bits - using multi-numeric or multi-binary reaction matrices.

Note: COT is supported not only by IEC870, but also by some other Energy drivers - different versions thereof. Some drivers support COT although the protocol itself does not contain COT (e.g. IEC850, DNP3). You can find details in the corresponding driver documentation.

Runtime monitoring and interlocking conditions of the action:

Interlockings are checked during runtime monitoring:

  1. For direct execution (= without Select).
  2. When the Select is activated (= before Select).
  3. If no Select is pending (Select is OK but Execute has failed, because of a change in condition).

  • The current command action shows messages about active interlockings. The user must unlock these. To do this, they must have the corresponding user rights. The interlocking must also be able to be unlocked. Otherwise this action can only be canceled.
  • If this action is canceled by a configured interlocking, no command is sent to the PLC.
  • If a Select has already been sent, cancellation is automatic. In this case, a Deactivation is sent.
  • The response variable does not receive a TIMEOUT bit in the process. If a PROGRESS bit is already set, this is reset.

With two-step configuration of the action:

The two-step action checks the interlocking and provides a message during the first step:

  • Direct execution - no SBO:
    Applicable for the moment when the first button is clicked.
  • Active SBO:
    Applicable for the moment when the confirmation for Select is received.

By clicking on the button to unlock the interlocking, Execute 2nd step becomes available. If the button is clicked on, an Execute is sent to the PLC. If Cancel has been clicked on and a Select has already been sent, the action sends a Deactivation (COT_deact(8)+SE) to the PLC.

With one-step configuration of the action:

If there is an interlocking in the first stage, a message is displayed and there is a wait for a reaction from the user. If the user selected On or Off, the Confirm button will be active. The value is then sent to the PLC. If the user clicks on Cancel and a Select was carried out beforehand, the action sends a Deactivation (Cancel).

If there was no outstanding interlocking for the first stage before the conditions have changed and before the user has carried out a Confirm by clicking, the action will check the interlocking conditions again. If there are then still interlockings pending, a message is displayed and there is a wait for a cancellation from the user.

Note: In this case, the interlocking cannot be unlocked by a user.

info Information

Single-step actions have the same action in all scenarios.

Runtime monitoring and negative responses from the PLC:

  • Execute negative
    During runtime monitoring, the PLC can react negatively to an Execute/Operate (COT_actcon(7) + PN). If the negative ration to an Execute was received, runtime monitoring is ended.
  • Execute Termination negative
    If Execution Termination (COT_actterm(10) + PN) is reported as negative by the PLC, runtime monitoring will no longer wait for a value change to the response variable and ends immediately.

The PROGRESS status bit is reset. The TIMEOUT status bit is not set for the response variable.

Note: the PN bit - Positive(0)/Negative(1) - is reflected on the status bit N_CONF of the action variable.


Cancellation of runtime monitoring

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Command procedure -> Watchdog timer -> Cancellation of runtime monitoring

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Cancellation of runtime monitoring

If the Timeout can be cancelled property has been activated for a command, the user can cancel runtime monitoring with the "Cancel" button.

In doing so, the command sends the cancellation to the driver. The driver (e.g. IEC850) only forwards a Cancel Request to the PLC if the Cancel Operate property is active, then the user can also cancel using the Cancel button.

Note: Not all drivers support this cancellation of an Execute. You can find further information in the respective driver documentation.


Runtime monitoring via response variable only (RV)

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Command procedure -> Watchdog timer -> Runtime monitoring via response variable only (RV)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Runtime monitoring via response variable only (RV)

Runtime monitoring via the response variable is the most-used type of runtime checking. It reacts to a change of the value of the response variable. The value that is expected for the response variable due to the command is defined in the response status/switching direction - on/off.

Negative responses from the PLC (COT_actcon(7) + PN) end runtime monitoring.

Note: Changes to the value of the response variable are only taken into account after COT_act(6) of the action variable. Prior value changes of the response variable - for example already after Select without an Operate/Execute having been sent - are ignored.


Runtime monitoring via cause of transmission only (COT)

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Command procedure -> Watchdog timer -> Runtime monitoring via cause of transmission only (COT)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Runtime monitoring via cause of transmission only (COT)

With runtime monitoring via COT only, runtime monitoring does not react to the value of the response variable (RV) but only to the cause of transmission - the status bits COTx status bits of the action variable.

Example without SBO:

The process in detail:

  1. The value and COT_act(6) are sent to the action variable.
  2. The PROGRESS status bit is sent to the response variable .
  3. If the controller receives the value COT_act, there is a wait for the subsequent values COT_actcon(7) and COT_actterm(10).
  4. End of the process:
    1. The process is ended if COT_actterm has been received.
    2. If, in the configured timeout time, no COT_actterm has been received, then:
      - the process is ended and
      - the TIMEOUT status bit of the response variable is activated.
      Note: You configure this time in the Timeout property for the command action.
  5. The PROGRESS status bit is reset.


Runtime monitoring via COT (cause of transmission) and RV (response variable)

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Command procedure -> Watchdog timer -> Runtime monitoring via COT (cause of transmission) and RV (response variable)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Runtime monitoring via COT (cause of transmission) and RV (response variable)

With runtime monitoring via COT and RV, the runtime monitoring reacts to the value of the response variable (RV) and to the cause of transfer - the COTx status bits of the action variable.

Example without SBO:

The process in detail:

  1. The value and COT_act(6) are sent to the action variable.
  2. The PROGRESS status bit is sent to the response variable .
  3. If the controller receives the value COT_act, there is a wait for the subsequent values COT_actcon(7) or COT_actterm (10).
  4. End of the process:
    1. The process is ended if both conditions have been met:
    • COT_actterm was received

      and

    • The value of the response variables corresponds to the switching direction (response status/ switching direction property).
      It does not matter which of the two conditions is met first. As soon as both of them are fulfilled, the procedure will be terminated.
    1. If only one or none of the above conditions from item 4a is met within the configured timeout, then:
      - the process is ended and
      - the TIMEOUT status bit of the response variable is activated.
  5. The PROGRESS status bit is reset.


Command screen control elements

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Command screen control elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A command screen allows control in Runtime and an overview of the commands. The command can be controlled via buttons.

Creating a screen of the type command

To create a command screen:

  1. Select, in the toolbar or in the context menu of the Screens node, the New Screen command
  2. An standard empty screen is opened
  3. Change the screen type in the detail view; to do this:
    1. click on Standard in the Screen type column
    2. Select Command from the drop down list
  4. Click in the screen.
  5. Select the Control elements menu item in the menu bar
  6. Click on Add template in the drop-down list
  7. The standard elements are inserted
  8. Select additional elements as required and insert them into the desired place on the screen
  9. Create a screen switch function, in order to be able to call up the command in Runtime

Command processing screen template - standard

The following control elements are available in Runtime:

Control element

Description

Insert template

Opens the dialog for selecting a template for the screen type.

Templates are shipped together with zenon and can also be created by the user.

Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.

Action/command

Active action/command

Displays the pending action of the command group.

Switching direction

The switching direction configured for the active action. The texts are documented with the "switching direction" setting.

Depending on the active action, the following text is shown:

Command, revision, correction, replace: Text from limit value, depending on switching direction.

Status: On or Off

Other: empty

Interlockings

Active interlocking

Interlocking text of the active interlocking.

Unlock

If an unlockable interlocking is upcoming, it can be unlocked with this button.

Note: This control is shown only when the screen is in the step 'Unlock'.

The Control is locked when the upcoming interlocking is not unlockable.

Select / execute

On

Command button for switching command, to close a switch for example.

Off

Command button for switching command, to open a switch for example.

Confirm

Confirms for the pending two-step action.
A two-step switching command, for example, is only executed after clicking on this button.

Cancel
  • Closes command processing screen. The pending action is not executed.
  • Cancel for pending, two-step action.
  • Cancellation of the execution of an action (depending on project configuration, for example: Operate in the case of SBO).

The button is grayed out if the screen is in 'Step 1'.

Name

Control type

Default

Action buttons

Text

Buttons, which can have an action assigned to them. By clicking in the screen, the assigned action is activated and the screen changes to the step "Release"

The button is not shown when:

  • No action is assigned to the button in the current command group.
  • The variable, with which the screen was loaded, is the command variable, and the action assigned to the button does not use the command variable as action variable. However, if the action 'Lock' was assigned to the button, it is visible.

The button is shown as locked when:

  • The screen is not in 'Step 1'.
  • The response variable has set one of the status bits I_KENNUNG(18), OFF(20) or NICHT_AKTUELL(29) and writes the assigned action to the command variable.
  • The response variable has the status REVISION(9) active and the assigned action writes to the command variable.
  • The response variable has the status REVISION(9) active and the assigned action is 'Correct'.
  • The assigned action is 'Release' and the response variable does not have the status Alternativevalue(27) active.
  • The assigned action is 'Correct' and the value of the response variable matches the switching direction.
  • The assigned action is 'Replace' and the value of the response variable matches the switching direction.
  • The response variable has the status REVISION(9) active and the assigned action is 'Replace'.
  • The assigned action is 'Revision' and the value of the response variable matches the switching direction.

Action1

Action2

RV TTA

Text

Name of the response variable

X

RV identification

Text

Name of the response variable

X

Action variable unit

Text

Unit of the current action variable.

X

Action variable set status

List

Defines the status to be set for the action 'Status default' for the switching direction 'None'. The statuses are set to the current status and updated when changes occur.

Is locked when the active action is not 'Set status'.

Switching direction

Text

The switching direction configured for the active action. The texts are documented with the setting 'Switching direction'.

Depending on the active action, the following text is shown:

Command, revision, correction, replace: Text from limit value, depending on switching direction.

Status: On or Off

Other: empty

X

Execute Step 2

Button

Delivers the actions to execution.

This control is visible only when the screen is in 'Step 2'.

The Control is locked when:

  • Two handed operation was configured and the key 'Ctrl' is not pressed.
  • The status REVISION(9) of the response variable is set and the assigned action is 'Command', 'Set value', 'Replace' or 'Correct'.
  • The button was already clicked.

X

Action variable minimum

Numerical

Minimum value of the action variable.

Not visible if the action variable is of data type 'String'.

Action variable maximum

Numerical

Minimum value of the action variable.

Not visible if the action variable is of data type 'String'.

Scrollbars

Numerical

Setpoint input with scroll bar Sets the value in the control 'Set value' or is set by this value.

Not visible if the action variable is of data type 'String'.

The Control is locked when:

- No action is active.

- The screen is not in 'Step 1'.

Set value

Numerical, Text

Allows the input of the set value.

By clicking the Control, it is switched to edit mode and the setpoint input is possible. The edit mode can be left again with "Enter".

The new value is set only after clicking the control 'Execute'.

The desired value for the action 'Set value' is provided with this control.

The Control is locked when:

- The status REVISION(9) of the response variable is set.

- No action is active.

- The screen is not in 'Step 1'.

RV value

Text

Value of the response variable

X

RV status

Text

Contains the status of the response variable in the short form.

X

RV unit

Text

Unit of the response variable

X

Interlocking text

Text

Text of the upcoming interlocking.

Text is online language switchable

X

No interlocking

If an unlockable interlocking is upcoming, it can be unlocked with this button.

Note: This control is shown only when the screen is in the step 'Unlock'.

The Control is locked when the upcoming interlocking is not unlockable.

X

Exit

Button

Closes the screen without action execution.

The button is only visible in a modal screen.

This button is important for modal screens, because it is required to leave the screen in case of an error!

Cancel

Button

Aborts the execution of the command and returns to 'Step 1'.

The button is locked when the screen is in 'Step 1'.

X

Lock list

List

Contains the locks that were activated at the response variable.

Is locked when no action 'Lock' was configured for the command group.

Text is online language switchable

User identification

Input field

For entering the user identification for the lock.

Is locked when no action 'Lock' was configured for the command group.

Lock code

Input field

For entering the user-specific lock code.

Is locked when no action 'Lock' was configured for the command group.

Execute lock

Button

Activates a lock for the user entered in the Control 'User identification'.

Is locked when no action 'Lock' was configured for the command group.

This user action is logged in the CEL, if not suppressed by the engineering.

Unlock

Button

Removes the lock by the user entered in the user identification.

Is locked when no action 'Lock' was configured for the command group.

This user action is logged in the CEL, if not suppressed by the engineering.

Execute

Button

Takes over the value of the Control 'Set value' or 'Set status'

This Control is visible only when the screen is in 'Step 1'.

The Control is locked additionally to the general lock, when:

  • The active action is not 'Set status', 'Set value' or 'Correct set value'.
  • The value in the control 'Set value' for the action variable is invalid.

Comment

Input field

Comment about the lock.

Action variable Status

Text

Status of the active action variable in short form.

X

Action variable Name

Text

Name of the active action variable.

X

Action variable Identification

Text

Identification of the active action variable.

X

Action variable value

Text

Value of the active action variable.

X

Active action

Text

Name of the active action.

X


Command screen - complete

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Command screen control elements -> Command screen - complete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A command screen allows control in Runtime and an overview of the commands. The command can be controlled via buttons.

Creating a screen of the type command

To create a command screen:

  1. Select, in the toolbar or in the context menu of the Screens node, the New Screen command
  2. An standard empty screen is opened
  3. Change the screen type in the detail view; to do this:
    1. click on Standard in the Screen type column
    2. Select Command from the drop down list
  4. Click in the screen.
  5. Select the Control elements menu item in the menu bar
  6. Click on Add template in the drop-down list
  7. Select, as a template, Complete in the Energy template folder
  8. The standard elements are inserted
  9. Select additional elements as required and insert them into the desired place on the screen
  10. Create a screen switch function, in order to be able to call up the command in Runtime

Parameters

Description

Response variable

Name

Name of the response variable

Identification

Name of the response variable

Status

Contains the short description of the status bits for the response variable.

Value

Current value of the response variable

Measuring unit

Measuring unit of the response variable

Action variable

Name

Name of the action variable

Identification

Identification of the action variable

Status

Contains the short description of the status bits for the action variable.

Example:

  • Bits for COT
  • Status SE_870 during Select
  • Status PN bit in the event of a negative response from the PLC

Note: The status bits contain the response variable for the the "status input" action.

Value

Current value of the action variable or input field for setpoint input command action.

Note: This value changes during the course of the action from an existing to a current value. The display is only updated with COT=7 (COT_actcon) or WR-SUC .

  • The following is applicable for a configured setpoint input:
    The value to be set for the 'Set value' action is stipulated by this control. By clicking the Control, it is switched to edit mode and the setpoint input is possible. It is possible to leave the editing mode again by pressing the Enter key.
    However the new value is only set when the "Execute" control is clicked on.
    The control is locked if:
    - The response variable has set the status REVISION(9) .
    - no action is active.
    - The screen is not in the "Step 1" stage

Measuring unit

Measuring unit of the action variable

Lock

Controls from the Lock group are locked if no "Lock" action is configured in the command group.

User

For entering the user identification for the lock.

Lock code

For entering the user-specific lock code.

Comment

Optional text that can be entered by the user for the lock.

Lock

Activates a lock by the user entered in the "User" control.

Note: This user action is logged in the CEL, if not suppressed by the engineering.

Unlock

Removes the lock that has been set up by the user entered in the "User" control.
This guarantees that only people's own locks can be removed.

Note: This user action is logged in the CEL, if not suppressed by the engineering.

Lock list

List of active locks:

  • User
    Name of the user who has activated the lock.
  • Locking time
    Time stamp of the interlocking
  • Note
    Text for the interlocking.

Action/command

Active action/command

Type of active command action such as dual command, for example.

Switching direction

The switching direction configured for the active action. The texts are documented with the setting 'Switching direction'.

Depending on the active action, the following text is shown:

Command, revision, correction, replace: Text from limit value, depending on switching direction.

Status: On or Off

Other: empty

Interlockings

Active interlocking

The active interlocking according to the configuration or texts from ALC - topological interlocking.

Unlock

This button unlocks an active, unlockable interlocking.

Note: This control is shown only when the screen is in the step 'Unlock'.

The Control is locked when the upcoming interlocking is not unlockable.

Select / execute

On

First-step command button, to close a switch for example.

Note: Only visible in Step 1

Off

First-step command button, to open a switch for example.

Note: Only visible in Step 1

Confirm

Second-step command button.

Note: Only visible in Step 2

Cancel

Second-stage command button.
Aborts the execution of the command and returns to 'Step 1'.

The button is grayed out if the screen is in 'Step 1'.

Close

Closes the command window.

Additional control elements

Actions

Action 1 ... Action 20

Buttons for desired actions of the 1st step.

The command action is configured in the Command processing field property group in the Action button property window.

Note: If the action is already assigned to a button, it is grayed out in the list.

Information control element

Minimum

Display of the minimum value of the set value.

Maximum
  • Display of the maximum value of the set value.

Interlocking list

Overview box of the active interlockings:

  • Text
    Text of the interlocking as configured
  • Active (yes/no)
  • Unlockable (yes/no)
  • Unlocked (yes/no)
  • Type

Unlock all

Unlocks all active and unlockable interlockings


Blocked or locked elements

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Command screen control elements -> Blocked or locked elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

General lock of the Controls

Some requirements must be met in order to unlock the controls in the screen. Since these requirements usually concern several controls, they are not listed with the control each time, but they are documented here.

  1. All Controls except Exit are locked when:
  • the screen is not the owner of the active NET SEL
  • No command was configured for the add-on variable
  • the response variable does not exist
  • The response variable has not received a value yet
  • the INVALID bit status is active for the selected variable
  • an action for the action variable is running
  • Runtime monitoring for the action variable is running
    Note: The Cancel button can be active here - regardless of the configuration.
  • There is a wait for the SBO confirmation from the Select
  • the data of the lock are being transmitted
  • the data of the lock are invalid
  • the currently-registered user does not have the necessary authorization levels
  1. All Controls except Exit and the controls for the lock are locked when:
  • one of the locking conditions of point 1 apply
  • The response variable was locked against commands
  • the status bit S_MERKER_1(0), i.e. the command lock, of the response variable was set

Command Processing

  • Action buttons:
    Action buttons are locked if
    • The authorization level of the user who is logged in does not allow execution.
    • The variable is locked.
    • There is already a command being executed
  • Unlocking:
    Unlocking is only possible if the user does not have the necessary authorization levels for this.
  • Context menu:
    Menu items that are assigned to a command action can only be selected if the registered user has the necessary authorizations.

Loading a screen with initial step 'Lock'

If the screen is loaded with the initial step 'Lock', all but the following controls are hidden in the screen:

  • RV TTA
  • RV identification
  • RV value
  • RV status
  • RV measuring unit
  • Lock code
  • User identification
  • Execute lock


Reload project online

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Reload project online

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If online reloading is instigated, the following effects must be expected:

If runtime monitoring, edge generation or SBO is active, the reloading is delayed until this has ended.

An opened command screen is closed and the process is started again after reloading depending on the current step:

Step before reloading | Action after reloading
Step 1 | Screen is called up again for Step 1
Interlocking or Step 2 | Unlocking step is activated. The interlocking is executed again.
Lock | Lock is activated again

Before it is called up again, the add-on variable, response variable, command group and action are determined again. The controls are locked if one of the objects is no longer present.

If the command group was removed or replaced for the add-on variable, the screen with locked controls is called up. The screen must then be called up again or the command must be executed again.

If the command group was removed or replaced for the response variable, all command locks are removed by the variables.

If a user who has activated a command lock no longer exists, the lock is removed. The status bit S_MERKER_1(0) is updated accordingly.


Logging in the CEL

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Logging in the CEL

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the CEL, the following user actions are logged in addition to the switching actions.

Parameters | Description
Unlock | The unlocking of an active interlocking is noted in the CEL.
Unlock all | A corresponding CEL entry is created for each unlocked interlocking.
Execute action | If the "Suppress CEL entry" action setting is not active, the execution of the action is logged in the CEL.


Lock return variable

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Lock return variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For a locked response variable, the statusbit S_MERKER_1(0) is set. The lock can be activated or deactivated by entering the username and the lock code defined during the user definition. One lock can be activated per user. The active locks are remanent and are also considered after a system restart.

info Information

The locks are automatically synchronized in the network; therefore, they can also be used in redundant operation.


Server change in redundant operation

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Server change in redundant operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If the Primary Server changes, the Select object is lost and the command must be executed again. The same applies for the SBO.


Exit Runtime

Manual -> Energy Edition -> Command Processing -> Operating during Runtime -> Exit Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As long as there are still active actions in the system, the proper exiting of the runtime (e.g. over a function call) is delayed.

Exiting is also delayed while the SBO procedure is active. If SBO is active, it will be deactivated.

info Information

This situation can arise especially for the action 'Pulse command' with watchdog and/or edge generation with one-step execution. The runtime is exited after the action was finished.


Equipment Modeling

Manual -> Equipment Modeling

The Equipment modeling recreates the structure of equipment in the editor. According to standard ISA S88 and S95, you can depict all levels of a company with zenon:

The upper levels enable details from the lower levels to be classified correctly and to be linked with each other. The lower levels refer to specific equipment which is compiled for process control and process monitoring.

tutorial License information

Part of the standard license of the Editor and Runtime.

Equipment modeling in zenon

With zenon, you can display the overall model and create any desired machines, buildings or processes. Data can be grouped and filtered during run time and in the editor. Equipment models can also be displayed as a separate screen in Runtime and used as a filter for other switched screens.

Equipment models can be created for all projects in the global project or in individual projects.

info Information

The language of equipment modeling cannot be switched.

Equipment modeling window

The equipment models can be opened in a window of their own:

  • To do this, select the Open new window ... command in the equipment modeling context menu in the project manager
  • a new window with the equipment models is opened by default in the lower area of the editor
  • Like all windows, you can place this window where you like in the editor
  • If you also keep the detailed equipment modeling view open, the contents of both windows are synchronized, so that you can make changes in both.


Create equipment model

Manual -> Equipment Modeling -> Create equipment model

You can create as many equipment models as you like and group these according to certain criteria. First you create the model, then you create groups.

To create a new model:

  • Decide whether you want to create a local or a global equipment model
  • in the context menu of node Equipment modeling select command New equipment model

    or, in the Tool bar, reselect the symbol for New equipment model

  • In the detail view, a new node with the default name Equipment model X is created (X stands for the serial numbering)
  • change the name to suit your requirements. To do this, press the F2 key on the name when highlighted or triple-click on the name field

info Information

There are equipment models from global projects and local projects available. In the event of naming conflicts, local equipment projects are preferred.

Hint: Ensure that you use clear names when configuring equipment models. For example, give global equipment models a corresponding prefix or suffix. This way you avoid having the same names in local and global equipment models. And you can easily identify the origin of the displayed equipment model in selection lists.

To create a new group:

  • In the context menu of a model or an upper-level grouping, select the New equipment group command

    or press the 'insert' key

    or, in the Toolbar, select the symbol for New equipment group

  • In the model structure, a new group with the default name Equipment group X is created (X stands for the serial numbering)
  • adapt the name to your needs: The name field is already in edit mode straight after being created. You can subsequently press the F2 key with the name highlighted or click on the name field three times
  • you can have as many groups and sub-groups as you like


Edit equipment model

Manual -> Equipment Modeling -> Create equipment model -> Edit equipment model

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Groups can be resorted, copied, moved and deleted within a model and throughout all models:

Selection

Equipment models and equipment groups can also be selected via multi-select if the elements are:

  • on the same level
  • within the same model
  • and within the same superior group

    .

The selection is carried out with Ctrl+left mouse button clicked:
Note: With Shift+mouse click you can make a selection of several elements on different levels. The editing possibilities in the context menu and in the tool bar are however deactivated.

Delete

  • highlight the desired node
  • select Delete in the context menu or in the toolbar, or press the DEL key
  • the node and all its sub-groups are deleted

Move via Drag&Drop

  • highlight the desired node
  • hold down the left mouse button
  • move the node to the desired area and release the mouse button

Sort via Drag&Drop

  • highlight the desired node
  • hold down the control key and move the node to the desired position with the left mouse button
  • a horizontal line shows the area whrere you can insert the node

Copy and paste

  • highlight the desired node
  • select Copy in the context menu or in the toolbar, or press control and C together
  • highlight the desired target-node
  • select Insert in the context menu or in the toolbar, or press control and V together
  • the node being copied is inserted
    • sub-nodes are not copied together with the node
    • If there is already an element with the same name, Copy of is placed in front of the inserted element

Rename

To rename models or groups:

  1. highlight the model/group
  2. press key F2 or perform a triple click on the model/group

After a renaming:

  • the models are sorted alphabetical again
  • groups remain in the created structure

attention Attention

The actions delete, resort, move, rename and insert cannot be undone.


Context menu Project manager

Manual -> Equipment Modeling -> Create equipment model -> Context menu Project manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Command

Function

New equipment model

creates a new equipment model with the default name, equipment model X (X stands for a serial number)

Open in new window

opens a new window in the editor that contains the equipment model

Export XML all

Exports all entries as an XML file.

Import XML

Imports elements from an XML file. In doing so, the following rules apply:

  • Models/groups that are to be imported that do not yet exist are inserted.
  • Existing models/groups that are not included in the import file are retained.
  • Pre-existing models/groups are replaced by those to be imported.

Editor profile

Opens the drop-down list to select a pre-defined Editor profile.

Help

Opens online help.


Detail view of toolbar and context menu

Manual -> Equipment Modeling -> Create equipment model -> Detail view of toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tool bar

Symbol

Function

New equipment model

creates a new equipment model with a default name, Equipmentmodel X (X stands for a serial number)

New equipment group

creates a new equipment model group with the default name, Equipmentgroup X (X stands for a serial number)

Linked elements

Opens the dialog to display linked elements.

Copy

copies the selected group together with the sub-groups

Paste

inserts the copied groups in another group or another model. If a group with the same name already exists, the inserted group receives the prefix Copy of

Delete

deletes the selected group with all sub-groups

Expand/
collapse node

Opens the drop-down list list to expand or reduce nodes.
  • Expand all

Expands all nodes.
  • Reduce all

Reduces all nodes.
  • Expand selected

Expands the highlighted nodes.
  • Reduce selected

Reduces the highlighted nodes.

Export selected XML

Exports the selected entries as an XML file.

Import XML

Imports elements from an XML file. In doing so, the following rules apply:

  • Models/groups that are to be imported that do not yet exist are inserted.
  • Existing models/groups that are not included in the import file are retained.
  • Pre-existing models/groups are replaced by those to be imported.

Help

Opens online help.

Context menu Equipment modeling

Symbol

Function

New equipment model

creates a new equipment model with a default name, Equipment model X (X stands for a serial number)

Paste

inserts the copied groups in another group or another model. If a group with the same name already exists, the inserted group receives the prefix Copy of

Expand/
collapse node

Opens the drop-down list list to expand or reduce nodes.
  • Expand all

Expands all nodes.
  • Reduce all

Reduces all nodes.
  • Expand selected

Expands the highlighted nodes.
  • Reduce selected

Reduces the highlighted nodes.

Export XML all

Exports all entries as an XML file.

Import XML

Imports elements from an XML file. In doing so, the following rules apply:

  • Models/groups that are to be imported that do not yet exist are inserted.
  • Existing models/groups that are not included in the import file are retained.
  • Pre-existing models/groups are replaced by those to be imported.

Help

Opens online help.

Equipment models and equipment groups context menu

Symbol

Function

New equipment group

creates a new equipment model group with the default name, Equipment group X (X stands for a serial number)

Linked elements

Opens the dialog to display linked elements.

(is only displayed if there are linked elements)

Copy

copies the selected group togehter with the sub-groups

Paste

inserts the copied groups in another group or another model. If a group with the same name already exists, the inserted group receives the prefix Copy of

Delete

deletes the selected group with all sub-groups

Expand/
collapse node

Opens the drop-down list list to expand or reduce nodes.
  • Expand all

Expands all nodes.
  • Reduce all

Reduces all nodes.
  • Expand selected

Expands the highlighted nodes.
  • Reduce selected

Reduces the highlighted nodes.

Export XML all

Exports all entries as an XML file.

Export selected XML

Exports all entries as an XML file.

Import XML

Imports elements from an XML file. In doing so, the following rules apply:

  • Models/groups that are to be imported that do not yet exist are inserted.
  • Existing models/groups that are not included in the import file are retained.
  • Pre-existing models/groups are replaced by those to be imported.

Help

Opens online help.


Link models with elements and objects

Manual -> Equipment Modeling -> Link models with elements and objects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Each equipment group can be linked to any desired zenon elements or objects. You have several options for linking a group with an element:

  • Via the element's Equipment groups property
  • copy and paste the element into the desired group of the model
  • Drag&drop the equipment group to the element's property Equipment groups
  • Drag&drop the element to the equipment group

Equipment groups property

To link by means of an element's property:

  1. select the element
  2. In the General node, click on the Equipment groups property
  3. the Dialog to allocate elements to equipment groups opens
  4. allocate the desired equipment groups (for details, see the sub-chapter on Equipment modeling dialog)

info Information

No inheritance

If equipment models are selected or created for the configuration of data types, drivers, functions, variables etc. using the Equipment groups property, they are only used for filtering and are not inherited.

For example: An equipment model selected in a data type is not inherited to variables based on this data type.

Copy and paste

To link using copy and paste:

  1. select the element
  2. copy the element (shortcut Copy or press the ctrl+C keys)
  3. highlight the equipment group you wish to change.
  4. paste the element (shortcut Paste command or press the ctrl+V keys)

Drag&Drop of the equipment group

To link the equipment group to the element by drag&drop

  1. select the equipment groups
  2. with the left mouse button pressed, drag this to the property Equipment groups in the element's node General

Drag&Drop of the element

To link the element to the equipment group by drag&drop:

  1. select the element in the project manager detail view
  2. with the left mouse button pressed, drag it to the desired equipment group

info Information

At drag&drop of structure variables: Only activated variables are taken into account. Inactive elements are not linked. For closed structure trees check whether all desired variables are active.


Equipment modeling dialog

Manual -> Equipment Modeling -> Link models with elements and objects -> Equipment modeling dialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the dialog, you can also allocate an element to a desired equipment group. The dialog opens if you select, in the properties of an element in the General node, the Equipment groups property:

Property

Description

Toolbar

Symbols to:

  • Edit local equipment models
  • Expand or collapse the display
  • Display of information

List of equipment models

provides models and groups for selection The list separates the display into equipment models from the global project and from local projects.

Local equipment models can be created, edited or deleted.

Add

Adds the selected group to the filter list.

Remove

Removes all selected groups from the filter list.

Filter list

Shows all equipment groups that are to be filtered.

OK

Applies settings and closes the dialog.

Cancel

Discards the selection and closes the dialog.

Attention: Any changes that have been made to the structure of local equipment models are retained.

Help

Opens online help.

Add groups

  • select the desired equipment model
    Attention: If there are naming conflicts between global and local equipment models, the local equipment models are displayed and the global ones are ignored. You can get information on possible conflicts by clicking on the corresponding symbol (triangle with exclamation mark) in the tool bar.
  • Select an equipment group or level.
  • Add the new group to the list with the Add button in the lower area of the dialog
  • Subgroups are not automatically added.
  • it is possible to link as many groups as you want.

Delete groups

  • Select the desired elements in the list in the lower area of the dialog (multiple selection is possible)
  • Click the Delete button

Note: Changes in a tree element remain preserved independent of clicking button Cancel. Cancel only means that no element was selected.

Filter for equipment groups in screen switching

At the screen switch to a screen of type AML, CEL or RGM and at function Suppress groups/classes/areas/equipment (Message Control) you can filter for equipment groups in the filter dialog. You can find instructions at the description of the corresponding dialogs:

  • AML Equipment modeling
  • CEL Equipment modeling
  • RGM Equipment modeling
  • Message Control suppress groups/classes/areas/equipment


Selecting the equipment groups toolbar

Manual -> Equipment Modeling -> Link models with elements and objects -> Equipment modeling dialog -> Selecting the equipment groups toolbar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Actions in the window of the existing equipment model can be controlled using the toolbar.
Description of the symbols, starting from the left:

Symbol

Description

New equipment model

Creates a new Equipment model.

(for local equipment models only)

New group

Creates a new equipment group below the highlighted entry.

(for local equipment models only)

Edit

Makes it possible to edit the name.

(for local equipment models only)

Delete

Deletes the selected entry.

(for local equipment models only)

Copy

Copies the selected entry.

Paste

Pastes copied entries from the clipboard below the highlighted entry. If a group with the same name already exists, the inserted group receives the prefix Copy of

(for local equipment models only)

Attention: If equipment models are copied from the global project to the local project and not renamed, there are two models with the same names. Both can be selected, however no linking is created on confirmation.

Hint: Always rename models copied from the global project to the local project.

Expand all

All nodes are expanded.

Collapse all

All nodes are collapsed.

Expansion of the selection

The selected node is expanded.

Collapse of the selection

The selected entry is collapsed.

Warnings

Displays warnings.

For example, equipment models from the global project that are not displayed because models with the same name from the local project are preferred.


Editing local equipment models

Manual -> Equipment Modeling -> Link models with elements and objects -> Equipment modeling dialog -> Editing local equipment models

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Equipment models and equipment groups from local projects can also be edited in the linking dialog. Equipment groups from the global project can only be selected and copied.

The possible actions and editing methods are limited, in contrast to the editing of equipmet models in the equipment modeling node. Elements are only edited using the toolbar.

Attention: Changes to the structure of local equipment model are retained, regardless of whether the dialog is left with OK or Cancel.

Possible actions are:

Action | Global project | Local project
Create new Equipment model | - | X
Create new Equipment group | - | X
Change name | - | X
Delete | - | X
Copy Attention: If equipment models are copied from the global project to the local project and not renamed, there are two models with the same names. Both can be selected, however no linking is created on confirmation. Hint: Always rename models copied from the global project to the local project. | X | X
Paste | - | X
Add to filter list | X | X

Key:

  • -: not possible
  • X: possible


List of linked elements

Manual -> Equipment Modeling -> Link models with elements and objects -> List of linked elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

All elements that are linked to the equipment group can be displayed as a list for each equipment group. You can go directly to the linked element via the context menu.

  1. In the equipment group desired, select
  2. in the context menu, select the command Linked elements...

    (For details, see the sub-chapter on Linked elements context menu)

  3. the list of linked elements is opened

In the context menu, you can

  • go directly to the element
  • delete the element from the list; the element then loses its link to this equipment group


Elements linked to the context menu

Manual -> Equipment Modeling -> Link models with elements and objects -> List of linked elements -> Elements linked to the context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the dialog for linked elements, individual elements can be opened or deleted from the list in the editor by means of the context menu:

Command | Description
Jump to linked element | goes to the element in the editor, the list remains open
Remove selected elements | deletes the selected element from the list, the connection to this equipment group is broken
Help | Opens online help.


Export and import models

Manual -> Equipment Modeling -> Export and import models

Equipment models and equipment groups can be imported by means of XML as well as via the API.

attention Attention

The complete equipment model is overwritten on import. Existing equipment models and equipment groups with the same name as imported objects are overwritten on import. Objects that are not contained in the import file are deleted.

XML

Export

To export models:

  1. Mark the desired equipment model.
  2. Select, in the context menu or in the tool bar, Export XMl.
    Alternatively, select Export all XMLs in the context menu.
  3. The dialog for selecting a save path is opened
  4. Select the save location and name.
  5. The selected models or all models are exported by clicking on OK.
  6. The success of the export and possible errors are displayed in the output window.

Import

To import models:

  1. select Import XML... in the context menu or in the tool bar
  2. The dialog to open an XML export file is opened.
  3. Select the desired XML file.
  4. Clicking on OK imports the models and groups contained in the XML file.
  5. The success of the export and possible errors are displayed in the output window.

API

The following methods are used for import and export via VBA/VSTA:

  • Export: SystemModelManager.Export
  • Import: SystemModelManager.Import


Screen of type Equipment model

Manual -> Equipment Modeling -> Screen of type Equipment model

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With an equipment model screen, the following is possible in Runtime:

  • Other, already-open screens can be filtered for certain equipment groups
  • All functions linked to a certain equipment group are automatically listed consecutively

Filtering for an equipment group always has an effect on the screens that have already been opened. If screens are called up again or reloaded, they are displayed again without the equipment model screen filter.

info Information

Screens that display data from the AML, CEL or RGM can be filtered. In principle, all screen types can be selected. However if these do not contain any data from the AML, CEL or RGM, they are ignored in Runtime.


Creating a screen of the type Equipment model

Manual -> Equipment Modeling -> Screen of type Equipment model -> Creating a screen of the type Equipment model

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create an equipment model screen:

  1. create a new screen
  2. select Equipment model as screen type
  3. an empty screen is created
  4. Click on Add template in the drop-down list
  5. The dialog for selecting a template is opened
  6. select the desired template
  7. Change the control elements to what you want

Control elements | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.
Equipment model (label) | Text field to display the name of the equipment model shown in the screen.
Equipment model (structure) | Tree element that display the group structure of the selected equipment model.
Buttons |
Apply selection | The group selected in the tree is used as a filter for the screens selected in the screen switching. The screen must already be open for the filter to work.
Execute functions | All functions of the local project that are currently linked to the group selected in the tree are executed. The order of execution is not determined.
Expand all | All nodes of the tree are expanded and all subgroups are displayed.
Collapse all | All expanded nodes are collapsed. Only the main groups of the tree are displayed.
Expand selection | The selected node of the tree is expanded.
Collapse selection | The selected node of the tree is collapsed.


Screen switch to a screen of type Equipment model

Manual -> Equipment Modeling -> Screen of type Equipment model -> Screen switch to a screen of type Equipment model

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a function to switch to an equipment model screen:

  1. Select New function
  2. select Screen switching
  3. Select the equipment model screen
  4. The dialog for configuration is opened
  5. Configure the equipment model to be displayed and the screen that can be updated with it
  6. Confirm the configuration by clicking on the OK button

Equipment Model displayed

Parameters | Description
Equipment Model displayed | Selection of the equipment model to be displayed in Runtime.
Static name | Selection of a model from a drop-down list. The list contains all equipment models contained in the local project and in the global project. In the event of naming conflicts (the same name for a local and a global equipment model) the local equipment model is displayed. All local equipment models and all global equipment models with unique names are always offered.
Name from variable | The model is read when a screen is switched from the string variables stated here. Clicking on the ... button opens the dialog to select a string variable. If the variable cannot be read in Runtime, the name remains empty. No equipment model is displayed
Selected equipment group | Selection of a variable to which the selected equipment group in the screen is written in Runtime. Clicking on the ... button opens the dialog to select a string variable.

Screens to be updated

Parameters

Description

Screens to be updated

Selection of the screens that can be filtered for equipment models with the equipment model screen in Runtime.

Screens that display data from the AML, CEL or RGM can be filtered. In principle, all screen types can be selected. However if these do not contain any data from the AML, CEL or RGM, they are ignored in Runtime.

Update

Parameters | Description
Update | Update mode.
Update on all monitors | Active: The screens listed in the Screens to be updated list are searched for on all monitors. Inactive: The screens listed in the Screens to be updated list are only searched for on the calling monitor.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.

Note: This filter can only be configured in the Editor, not in Runtime any more.


Filter in detail view

Manual -> Equipment Modeling -> Filter in detail view

It is possible to fiIter according to equipment groups in Project manager detail view. If these are not yet displayed, select Filter selection in the context menu and add Equipment groups. To filter:

  • click on the filter symbol in the Equipment groups column header
  • the Selection dialog for equipment groups is opened
  • add the desired filter criteria to the list
  • only elements linked to the selected equipment groups are displayed in the detail view

To reset the filter:

  • click on the filter symbol in the Equipment groups column header
  • the Selection dialog for equipment groups is opened
  • remove the filter criteria from the list


Filtering in the Runtime

Manual -> Equipment Modeling -> Filtering in the Runtime

To filter for equipment groups in Runtime, you have the following possibilities:

  • Define filter when screen switching: Create function screen switch to the desired screen and define the filter in tab Equipment modeling. In the Runtime the data is displayed in accordance with the defined filter. The Filter button must be present to change the filter in Runtime.
  • Screen of type Equipment model: Create an equipment model screen and allocate it an equipment model when screen switching. You can select equipment groups in Runtime and apply it as a filter to screens that have already been opened. Furthermore, all functions linked to an equipment group can be executed one after the other at the press of a button.


Filtering with screen switching

Manual -> Equipment Modeling -> Filtering in the Runtime -> Filtering with screen switching

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

It is possible to filter equipment groups during runtime for the following functions:

  • AML and CEL:
    • Alarms: delete
    • Alarms: Acknowledge
    • Export AML
  • Screen switching to:
    • AML: Alarms are only displayed if their variables are linked to the equipment groups.
    • CEL: Entries are only displayed if their variables are linked to the equipment groups.
    • Recipegroup Manager: Recipegroups are only offered in the drop-down list if they are included in the filter. If new recipegroups are created, these can be conncted to existing equipment groups. This newly-created data can be restored again from the runtime files in the editor. In doing so, the linked equipment groups are also restored.
  • Message Control:
    • Suppress groups/classes/areas/equipment

Creating a filter

To create function screen switch and to filter on equipment groups:

  1. create a picture switch function.
  2. select the desired picture
  3. click on the equipment modeling tab in the dialog filter
  4. select the model and equipment group
  5. confirm this with OK.

Element | Description
List of equipment models | provides models and groups for selection
Add | Adds selected groups to the filter list
Delete | removes selected groups from the filter list
Filter list | Shows all equipment groups that are to be filtered.
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Using an equipment model screen in Runtime

Manual -> Equipment Modeling -> Filtering in the Runtime -> Using an equipment model screen in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In Runtime, other previously-switched screens that contain data from AML or CEL can be filtered for equipment groups.

Control elements | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.
Equipment model (label) | Text field to display the name of the equipment model shown in the screen.
Equipment model (structure) | Tree element that display the group structure of the selected equipment model.
Buttons |
Apply selection | The group selected in the tree is used as a filter for the screens selected in the screen switching. The screen must already be open for the filter to work.
Execute functions | All functions of the local project that are currently linked to the group selected in the tree are executed. The order of execution is not determined.
Expand all | All nodes of the tree are expanded and all subgroups are displayed.
Collapse all | All expanded nodes are collapsed. Only the main groups of the tree are displayed.
Expand selection | The selected node of the tree is expanded.
Collapse selection | The selected node of the tree is collapsed.

Example

The alarms of hall 3 in a factory are to be displayed.

Configuration:

  • Hall 3 is defined as its own equipment group in the equipment model.
  • When switching screens to an equipment model screen, the following happens:
    • The equipment model that contains hall 3 is selected
    • The AML screen is selected as the screen to be updated

The following happens in Runtime:

  • The Alarm Message List is called up
  • The equipment model is called up
  • The equipment model is selected as hall 3
  • The Apply selection button is pressed

The switched AML screen now only shows the alarms that relate to hall 3


Extended Trend

Manual -> Extended Trend

The Extended Trend is used for the representation of online and historical values(Archive values) of process variables and derived process variables in form of curves. It makes it possible to reread historic data. Scrolling in the Extended Trend provides a ruler and zoom function together with a trend analysis. In contrast to the trend dynamic element, it is possible to zoom, browse, query and scale online values and values from archives.

tutorial License information

Must be licensed for Editor and Runtime (single-user, Server, Standby and Client).

Note: An Extended Trend Starter Edition with limited functionality is already included in the standard license.

Extended Trend Starter Edition

In the standard package of zenon, a reduced version of Extended Trend with limited functionality is included with the Starter Edition.

The Starter Edition has the following limitations:

  • no XY trend
  • no second time axis
  • number of curves limited to 8
  • no logarithmic representation
  • Scanning with a cursor

For additional limitations on use in Windows CE projects, the zenon Operator under Windows CE manual, Limitations for zenon chapter.

Warning!

You cannot use any functions that exceed the limitations mentioned above if you have only the Starter Edition license in the Editor.

If you only have the Extended Trend Starter Edition license in the Runtime, you cannot use screen switch functions that do not follow the rules mentioned above. The Extended Trend screen will then be loaded with the default filter (=empty filter). An entry in the Diagnosis Server is made

Example: You try to perform a screen switch to an Extended Trend Module screen with 10 curves in Runtime with the Starter Edition. The Extended Trend screen will be opened, but no curves will be shown.

Licensing

The Extended Trend Starter Edition on the PC can be upgraded to the full Extended Trend module version at any time, without compatibility problems. For I/O licensed version, the Starter Edition is not available.

Windows CE

For the Windows CE 6.0 Runtime, the Extended Trend Module Starter Edition is available in combination with the Historian Starter Edition. None of the two modules are available for any older Windows CE versions. The extended curve list control element is not available in Windows CE. Therefore all control elements that relate to this element are only displayed if the project is not a CE project.


Engineering in the Editor

Manual -> Extended Trend -> Engineering in the Editor

To use Extended Trend in Runtime, you must the following must be carried out in the Editor:

  • An Extended Trend screen is created
  • A screen switching function is created
  • Curves are configured


Creating screens of type Extended Trend

Manual -> Extended Trend -> Engineering in the Editor -> Creating screens of type Extended Trend

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Extended Trend is operated in Runtime with the help of an Extended Trend screen. This screen must be created in the editor first.

To create an Extended Trend screen:

  1. Select, in the toolbar or in the context menu of the Screens node, the New Screen command
  2. An standard empty screen is opened
  3. Change the screen type in the detail view; to do this:
    1. click on Standard in the Screen type column
    2. Select Extended Trend from the drop-down list
  4. Click in the screen.
  5. Select the Control elements menu item in the menu bar
  6. Click on Add template in the drop-down list
  7. The standard elements are inserted
  8. Select additional elements as required and insert them into the desired place on the screen

Element

Description

Insert template

Opens the dialog for selecting a template for the screen type.

Templates are shipped together with zenon and can also be created by the user.

Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.

Window

Selection of the window to be displayed for diagrams and curves in Runtime.

Diagram

Window to display trend curve

Diagram name

Shows the diagram name.

Set filter

Displays the status of the current time filter in Runtime.

Cursor Output list

Shows the position of the cursor in the diagram window and the values set in diagram settings and cursor output

Extended curve list

Curve list that can be edited in Runtime. The following can be edited:

  • Curve name
  • Title
  • Color
  • Fill color
  • Area display
  • Y-Axis
  • Active
  • Sorting order

Note: Not available under Windows CE. Is replaced by the curve list (outdated) there.

Curve list (outdated)

List of curves.

Is used for CE for compatibility reasons. The extended curve list is recommended for all other projects.

Diagram functions

Pre-defined controls for diagrams.

Filter

Display of set filter.

Chart settings

Activates the dialog for diagram settings and cursor output

Curves

Change curve parameters.

x-axis

opens the dialog for x-axis settings.

Refresh

Refreshes the display.

Stop

Do not refresh screen.

Next

Update screen

Cursor on/off

Query values

Double cursor on/off

Display values that are between two cursors.

Print

Prints diagram.

Note: Printouts made using the Print button of the Extended Trend screen may be different to those made using the Extended Trend screen switching or Print Extended Trend diagram functions. The functions assume a window size of 1000 x 700. Printing via the button is in the proportion defined in the Editor.

Print with dialog

Choose the printer before printing out the diagram.

Copy to clipboard

Copy representation into the intermediate store.

Export data displayed

exports all visible data of all curves as a CSV file.

Diagram navigation

Buttons for navigation in the diagram.

Cursor one pixel to the left

Places cursor one pixel to the left.

If the Shift key is pressed at the same time, the cursor is moved by 10 pixels.

Cursor one pixel to the right

Places cursor one pixel to the right.

If the Shift key is pressed at the same time, the cursor is moved by 10 pixels.

Backwards

Scroll backward on the time axis (history)

Quarter backwards

Moves the time period displayed back by a quarter of the measuring unit selected.

Forward

Scroll forward on the time axis (current)

Quarter forwards

Moves the displayed time period forwards by a quarter of the unit selected.

Zoom

Zoom display

Step back

Reduce display

Zoom +

reduces display time intervals

Zoom -

Increases display time intervals

Zoom to 100 %

Sets zoom factor to 100%.

This zoom action is saved in the zoom history.

For example: zooming is used

  • to zoom 2x into a selected area of the Extended Trend,
  • then zoom content to 100% is selected and
  • then a selected area is zoomed into again,

then there are 4 zoom events in the history. These can be gone back to again using the Back button.

Filter profiles

Buttons for filter settings in Runtime.

Profile selection

Select profile from list.

Save

Saves current setting as a profile.

Delete

Deletes selected profile.

Import

Imports filter profiles from export file.

Export

Exports filter profiles in the file.

info Information

The cursor one pixel to the left and cursor one pixel to the right control elements move the cursor if it is active, not the trend.

Arrow keys on the keyboard can also be used instead of the control elements.

If you hold down the Shift key when moving with the cursor keys, the movement is carried out in 10-pixel increments.


Screen switch - Extended Trend

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The parameters for the trend diagram to be displayed in Runtime are defined with the screen switching. Each trend curve is provided with its own name. We recommend not displaying too many trend curves at the same time, so you can maintain a good overview. Several variables can be configured for the configuration of curves, which can then be freely activated in Runtime.

To configure screen switching:

  1. Select New function in the context menu in the Function node
  2. The dialog for selecting a function is opened
  3. navigate to node Screens
  4. select Screen switch
  5. select the desired screen of type Extended Trend
  6. The dialog for configuring the diagram is opened

Tab | Description
Data | Configuration of the source of data and curve administration.
Display | Configuration of the diagram display.
X-Axis | Configuration of the x-axis.
Time | Configuration of the time filter.
Lots | Configuration of the lot filter.
Column setting | Configuration of the columns to be displayed:
Printer settings | Configuration of the settings for printing diagrams and saving them as a screen.
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Data

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> Data

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration of data origin and curves and how they are displayed in Runtime.

The possible options vary depending on the origin of the data.

  • Online data
  • Block array
  • Archive data

Configuration of data

Origin of the data

Parameters

Description

Origin of the data

Selection of the data origin:

  • Online data
  • Block array
  • Archive data

Can only be selected as long as no curves have been configured.

Online data

Active: Current online values and saved values are used for the display.

Block array

Active: Variables with array values are used for the display. You can limit the display of variables to those that are based on a driver that supports variables with array values using this.

The display of variables with array values works just like the XY display. However, you may not select a time filter or X variable. Enter, in the X-axis tab (XY-display) for Scale From and To the corresponding array indexes of the source data.

Note: Block array corresponds to the Block array size property that can be set for a variable and is not identical to array variables.

Archive data

Active: Archive values saved in the database (in ARX format or SQL data) are used for the display.

Note: Archives in XML, dBase or TXT formats are no longer displayed after the storage cycle has expired.

Options

Parameters

Description

Options

Configuration of options, depending on the origin of the data.

Sort data

Only available for online data and archive data.

Active: The data is sorted with a time stamp after loading.

Note: The use of this option can impair the performance, because the data must be re-sorted each time.

Recommendation: Use this option if the data comes from an external source and it cannot be ensured that the sequence is correct.

Delta data only

Only available for archive data.

Active: When switching or updating the trend, only archives with amended data are loaded.

Use archives from read-back folders

Only available for archive data.

The historical data from the readback folder is used for the display.

When loading archive data from the readback folder, the archive data from the Runtime path and from all subfolders of the readback folder is also read.

Automatically select appropriate aggregated archive

Only available for archive data.

Active: The appropriate aggregation archive is automatically selected in Runtime.

How it works in Runtime

  • If a very large time range is selected in the base archive or zooming out is carried out very often, then very large amounts of data are generally required.
    With this option active, only the data from the next aggregated archive is displayed. If the diagram is zoomed in on again, the diagram switches back to the previous archive.
  • Threshold: Root from diagram width = number of values from the aggregated archive.
    Example: Diagram width 625 pixel results in a threshold of 25 values.
    If the threshold cannot be determined, 15 values is used as a default.
  • The archive that appears first in the following sequence is selected from the aggregated archives: - Average
    - Maximum
    – Minimum
    – Sum
    Note: If the variable for the diagram is selected from an aggregated archive, then:
    - only the same aggregation function is used
    - no longer gone back to the direction of the base archive
  • If several aggregated archives are present on one level with the same aggregation function, the first one is always used.
  • If only a sum variable is found for a variable from the base archive, there is a warning in the diagnosis viewer and in the output window of the Editor.

Default setting:

  • active
  • With the exception of projects that were created before version 7.11 and converted to the current version.

Curves

Parameters

Description

Curves

Display and activation of the configured curves. Double clicking on the entry opens the dialog for configuring the curve.

The display in Runtime can be activated and deactivated here and the sequence of the display can be configured.

The displayed columns in the curve list correspond to the current configuration of the extended curve list in the Column settings tab.

Important columns:

  • Curve name: The curve name is displayed.
  • Title: The configured curve title is displayed.
  • Color: The configured curve color is displayed.
  • Y-axis: Activation/deactivation of the display of the Y-axis in Runtime by clicking in the checkbox.
    If the checkbox has been deactivated, the Y-axis for the curve can be selected and displayed in Runtime in the Extended Trend screen.
  • Active: Activation/deactivation of the display of the curve in Runtime by clicking in the checkbox.
    If the checkbox has been deactivated, the curve can be selected and displayed in Runtime in the Extended Trend screen.
  • Variable name: The variable name is displayed.
  • Variable identification: The variable identification is displayed.
  • Sorting order: Defines the sequence in which the curves are displayed in this tab and in Runtime. The sequence can be changed by clicking in a cell and entering a number. Alternatively, the sequence can be changed by clicking on the column heading and then using Drag&Drop.
    Minimum: 1
    Maximum: Number of curves.
    Sorting is instigated by clicking on the column heading.
    The sequence can also be configured in Runtime.

Note:

  • The permitted number of curves depends on the license.
  • When selecting an string archive variable, the Gantt display option is automatically displayed in the Curve settings dialog.
  • Sorting according to other columns as a sequence does not have an effect on the sequence of the curve display.

Add

Opens the dialog to select a variable, depending on the origin of the data:

  • Online data: numeric variables
  • Block array: numeric variables
  • Archive data: Variables of existing archives

Edit

Opens the dialog to configure curves.

This dialog can also be opened by double clicking on a curve in the Curves list.

Delete

Removes selected curves from the list.

Only available if curves have been configured.

Proposal for hard disk data storage

Parameters | Description
Proposal for hard disk data storage | Only available for online data. Offers the values proposed by the properties of the Harddisk data storage group in the zenon Editor. The calculation of the proposal is directly related to the refresh rate (Display tab). For YT display, the time configured in the time filter is also included in the calculation.
Number | Number of values that are written. Corresponds to the value that is entered in the Number of values property.
Cycle time | Cycle time in seconds. Corresponds to the value that is entered in the Cycle time [s] property.
Preview | Displays the current value of variables that are to be replaced by the proposed values.
Accept proposal | Active: Writes the proposed values to the respective properties of the variables when the dialog is closed with OK. Note: It is activated if the Harddisk data storage active property is deactivated.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

Note: The options available for this filter for import and export up to version 7.10 have been temporarily removed. The import of filters from projects created in other versions is thus not possible at present.

Harddisk data storage

If online variables are to e displayed in Extended Trend, it is recommended that the values for saving the variable values are coordinated on the hard drive. If, when configuring the screen switching to an Extended Trend screen, the option Online data is selected, the system proposes optimal values for saving the variable values to the hard disk. These values can also be amended manually.

In the zenon Editor, you can find these properties in the Harddisk data storage group.
This includes the properties:

  • Harddisk data storage active: Switches data saving on or off.
  • Number of values: Number of values that are saved.
  • Cycle time [s]: Cycle time in seconds.
  • Recording type: type of saving:
    • Hard disk data (cyclical):: Cyclical writing of values to the hard disk.
    • Resorted values (RDA): The values are written blockwise by the driver on to the hard disk.
      Suitable for post mortem analysis. The control unit must therefore be configured to save data in the event of an error and to write this to the hard drive once back in operation.

If hard disk data backup is not used, data is not saved in Runtime.


Block array

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> Data -> Block array

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To set up variables with array data:

  • Define the Block array size property in the Additional settings group for the corresponding variable, for example 10

  • Select, for the screen switching function, the Block array property on the Extended Trend screen :

Result in Runtime

  1. The Extended Trend screen is still empty when Runtime is started:

  2. The values of the variables with block arrays are displayed as soon as the recipe values are set:


Display

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> Display

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Settings for the display of the diagram in Runtime:

Diagram name

Parameters

Description

Diagram name

Freely-configurable diagram name.

Maximum length: 30 characters
Integrate lot names dynamically: The diagram name can contain lot names. To do this, insert the character sequence %c% into the name. In Runtime, each %c% is replaced by the lot names that replace the filter requirements.
For example: The diagram name Diagram1_%C%_End results in Diagram1_Lot1_End in Runtime

Refresh

Settings for the allocation of the monitors.

Scroll width

Stipulation of the screen scrolling in percent if the right edge of the diagram has been reached.

Possible values: 0 to 100:
Attention Only available for YT display.

Refresh rate

Set the refresh rate in seconds.

  • The value must be greater than 0 for online data and block array.
  • The screens cannot be loaded statically for online data and block array.
  • For archive data, the refresh rate automatically adapts to the loading time of the data. If loading lasts longer than half of the refresh interval, the refresh rate is doubled.
    Alternatively, the value for the refresh rate can be set to 0 for archive data. This results in the displayed data not being updated.
    This setting is helpful if a large amount of data is to be displayed in the ETM. If, in this case, Refresh rate is set to a low value, this can lead to an infinite loop.

Respective maximum: 3600 s

Optimize refresh rate: When reading archive data, a log message is created at the start and the end by the server (including standalone servers) and the client. The log message can be read with the help of the Diagnosis Viewer. With this it can be determined how long the reading lasts and the Refresh rate and be defined accordingly.

Offset

Moving the zero point of the time axis to the stated value in seconds.

Maximum: 65535 s

Not available for block array data source.

Design

Parameters | Description
Design | Settings for the design of the diagram.
Font | Selection of the user-defined font for the axis labels and the value indicators from a drop-down list
Background | Selection of the background color for the displayed graphics. Clicking on the button opens the dialog to select the screen.
Grid | Selection of the color for the overlaid grid. Clicking on the button opens the dialog to select the screen.
Distance diagram to window border | Settings for the stipulation of the distance between the diagram and the window frames. Respective minimum: 10 px Respective maximum: 2000 px
Top | Distance between the upper edge of the control element and the trend curves represented inside it. (Attention: Room for later optional showing of stored details with active pointer)
Bottom | Distance between the lower edge of the control element and the X-axis (Origin 0%-Y-axis) (Attention: take the room for two-line labeling of the X-axis for the configured user defined font into account)
Left | Distance between the left edge of the control element and the Y-axis (Origin 0%-X-axis) (Attention: take the room for the left-hand side labeling of the Y-axis for the configured user-defined font into account)
Right | Distance between the left edge of the control element and the y-axis (Origin 100%-X-axis) (Attention: take the room for the right-hand side labeling of the Y-axis for the configured user defined font into account)

Runtime

Parameters

Description

Runtime

Settings for action in Runtime.

Show this dialog in the Runtime

Requirement: A time period is defined in the time filter. If, in the X axis tab for the XY display, the option Comparison with 2nd time period is activated, two time filters for both X-axes are offered.

Active: Before every call of the screen the filter dialog is opened. The filter settings can be modified. This option is not available with Windows CE.
Note: If, in the Lots tab, the Show lot selection dialog option is also selected, then the lot selection dialog is called up in Runtime. This is no longer displayed after reloading.

Notes for time range filters:

Show this dialog in the Runtimeactive:

  • The filter is opened in Runtime in screen switching. The filter is no longer offered on reloading. This behavior can differ for individual screen types if the dialog was displayed in screen switching and canceled.
  • The last-concluded time period is always used.

Show this dialog in the Runtimenot active:

  • Use last finished time rangeactive: The last-concluded time period is used
  • Use last finished time rangenot active: The current time period is used.

Replace time filter with screen

Only available if the Offer this dialog in Runtime option has been activated.

Replaces the dialog with a time/lot filter screen in Runtime. The currently-linked screen is displayed.

Click the ... button and the dialog opens to select a screen. Only screens from the project calling them up and time/lot filter screens are offered.

When selecting a filter screen, the BOX SCREEN information is also shown in the detail view of the function in the Parameter column; without a linked screen, only BOX is displayed.

Display cross-hair in XY diagram

Display of the cross-hair in Runtime:

  • Active: switched on
  • Inactive: switched off

Only available if XY display has been activated in the X-axis tab.

X-Axis: Variable for value of the 1st cursor

Variable for abscissa of the first cursor.

Clicking on the ... button opens the dialog to select a LREAL or DWORD/DINT/UDINT variable.

When calling up and moving the cursor in Runtime, its abscissa (time or X value) is written to the assigned variable. In doing so, the values are saved in Unix time format (number of seconds passed since 1 January 1970 00:00 UTC).

X-Axis: Variable for value of the 2nd cursor

Variable for abscissas of the second cursor.

Clicking on the ... button opens the dialog to select a LREAL or DWORD/DINT/UDINT variable.

When calling up and moving the cursor in Runtime, its abscissa (time or X value) is written to the assigned variable. In doing so, the values are saved in Unix time format (number of seconds passed since 1 January 1970 00:00 UTC).

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


X-Axis

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> X-Axis

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Settings for the X-axis. This can be configured in two different forms:

  • YT-display: Display of the trend curves over the configured time range.
    When configuring the time axis, the time range, the lots and the axis display can be defined.
  • XY display: Display of the values by means of a variable or derived variable (location curves, working points etc.)
    Only available if, in the Lots tab, the Relative lot selection option is not active.


YT display

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> X-Axis -> YT display

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

X-Axis

Parameters

Description

X-Axis

Selection of display type.

YT display

Active: The display of the curves over time is configured.

XY display

Active: Display of the curves using another variable is configured.

Variable for X-Axis

(not available for YT display.) )

Axis title

(not available for YT display.) )

Position

Entry of a percentage value for the positioning of the X-axis in relation to the height of the Y-axis.

Possible values: 0 to 100.

For example:

  • 0 %: Positioning at the lower end of the Y-axis.
  • 100 %: Positioning at the upper end of the Y-axis.
  • 50 %: Positioning in the middle of the Y-axis.

Color

Definition of the axis color. Click on the color and a dialog opens to select a color.

Note: Can be configured independently of the trend curve color.

Show vertical grid lines

Active: Vertical assistance lines are displayed at the main ticks in Runtime.

Comparison with 2nd Period

Active: Display comparison with a second time period.

Only for archives with a filter for a time range or a lot. A comparison with relative lot filter is not possible.

Two time ranges are displayed at the same time for each per archive variable (e.g. comparison over a week).

Two trends are called up when it is called up. The second time range is displayed on the opposite labeling side of the time axis in the Color of the grid.

Only available with a full license.

Real-time display

Active: The axis must already have time markers.

Inactive: The switching time is defined as 00:00 and is labeled relatively in the past (-01:00).

Labeling

Position of the axis labeling.

Above the axis

Axis labeling above the axis.

Below the axis

Axis labeling below the axis.

Type of axis

(not available for YT display.) )

Linear

(not available for YT display.) )

Logarithmic

(not available for YT display.) )

Scaling

Definition of the axis subdivision.

Number of main ticks

Number of main subdivisions with value indication.

Maximum: 60

Length of main ticks

Length of main tick lines in pixels.

Maximum: 10

Number of subsidiary ticks

Number of subdivisions between two main subdivisions.

Maximum: 60

Number of main ticks automatically

(not available for YT display.) )

Sizing handle cursor

Parameters

Description

Sizing handle cursor

Definition of the circle-shaped sizing handle displayed in the middle to make it easier to use the rulers, such as in touch operation.

Diameter

Diameter of the sizing handle in pixels.

  • 0: no sizing handle (compatible with projects from versions before version 7)
  • >0: Sizing handle is displayed according to the value entered

Default: 0

Maximum: 100

Scale

Parameters

Description

Scale

Stipulation of the values for the scale by activating the checkboxes:

  • YY: Year
  • MM: Month
    DD: Day
  • HH: Hour
  • MM: Minutes
  • SS: Second
  • MS: Millisecond

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


XY display

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> X-Axis -> XY display

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Only available if, in the Lots tab, the Relative lot selection option is not active.

Parameters

Description

X-Axis

Selection of display type.

YT display

Active: The display of the curves over time is configured.

XY display

Active: Display of the curves using another variable is configured.

Variable for X-Axis

Selection and marking of one of the variables allocated to the diagram. It is used for the X axis.

Clicking on the ... button opens the dialog for variable selection, depending on the origin of the data.

Axis title

Text of axis labeling in Runtime.

Maximum length: 30 characters

Position

Entry of a percentage value for the positioning of the X-axis in relation to the height of the Y-axis.

Possible values: 0 to 100

For example:

  • 0 %: Positioning at the lower end of the Y-axis.
  • 100 %: Positioning at the upper end of the Y-axis.
  • 50 %: Positioning in the middle of the Y-axis.

Color

Definition of the axis color. Click on the color and a dialog opens to select a color.

Note: Can be configured independently of the trend curve color.

Show vertical grid lines

Active: Vertical assistance lines are displayed at the main ticks in Runtime.

Comparison with 2nd Period

(not available for XY display.)

Real-time display

(not available for XY display.)

Text

Position of the axis labeling.

Above the axis

Axis labeling above the axis.

Below the axis

Axis labeling below the axis.

Type of axis

Selection of the display of the axis:

  • Linear
  • Logarithmic

Linear

Active: Linear display of the axis.

Logarithmic

Active: Logarithmic display of the axis.

Only available with a full license.

Scaling

Definition of the axis subdivision.

Number of main ticks

Number of main subdivisions with value indication.

Maximum: 100

Length of main ticks

Length of main tick lines in pixels.

Maximum: 4 - 10

Number of subsidiary ticks

Number of subdivisions between two main subdivisions.

Maximum: 4 - 10

Number of main ticks automatically

(not available for YT display.) )

Sizing handle cursor

Sizing handle cursor | (not available for XY display.)
Diameter | (not available for XY display.)

Scale

Scale

Stipulation of the values for the scale by activating the checkboxes:

  • YY: Year
  • MM: Month
    DD: Day
  • HH: Hour
  • MM: Minutes
  • SS: Second
  • MS: Millisecond

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

info Information

Display of X-axis in the diagram from version 6.51

Archive data for the X-axis is no longer loaded for performance reasons. To display the X-axis in the diagram anyway:

  • Add the variable selected for the variable for X-axis as well as the curve in the diagram
  • Deactivate the display for this curve

info Information

If an XY display is configured, then only the respective current value is shown when the scanning is started. This cannot be updated. The cursor cannot be moved.


Time

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration of the time filter. Not available for block array data source.

Note: Time is saved in UTC. For details see chapter Handling of date and time in chapter Runtime.

Time filters can be pre-set in both the Editor and in Runtime for:

  • Absolute period of time
  • Relative period of time
  • From
  • Time period

Time filtering can be carried out in two ways:

  1. Define time period in the Editor
    Fixed time areas are used. A time period is given in the editor. It is only possible to filter according to this time period in Runtime. Other filters - such as filtering according to variable name, alarm/event groups and alarm/event classes etc. can no longer be amended in Runtime.
  2. Time filter configurable in Runtime
    The time filter is defined in the Editor and can be changed in Runtime as desired.

Time filter

Filter

Selection of the filter.

Parameters

Description

No time filter

Active: No time filter is used.

Note: all Runtime entries since 1. 1. 1990 are displayed.

Absolute filter

Active: A fixed period of time is entered in the editor. When the function is executed, the defined absolute time period is exactly used.

In the settings section, the corresponding options can be shown and configured there.

Note: Time is saved in UTC. For details see chapter Handling of date and time in chapter Runtime.

Relative period of time

Active: A relative time period is entered.

In the settings section, the corresponding options can be shown and configured there.

Attention: this filter is constantly updated.

From

Active: A time from which the filter is effective is stated. If the time is not reached on the current day, filtering takes place from the corresponding time the previous day.

Selection of the area mode from drop-down list:

  • From HH:MM:SS o'clock
  • From day - HH:MM:SS o'clock
  • Starting on day, month at HH:MM:SS

In the settings section, the corresponding options can be shown and configured there.

Attention: The start point of this filter is not updated automatically. Only the existing times are used when shown.
The end time point is not defined with this filter, it is carried over.

Time period

Active: A fixed time period is entered. Selection of the area mode from drop-down list:

  • One day
  • One week
  • Two weeks
  • One month
  • One Year
  • 15 minutes
  • 30 minutes
  • 60 minutes

In the settings section, the corresponding options can be shown and configured there.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

Note: The No time filter option is not available for Extended Trend.


Absolute period of time

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> Time -> Absolute period of time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You define a fixed time period with the absolute filter. When the function is executed, the defined absolute time period is exactly used. To set the filter:

  1. Select, in the Filter section, the Absolute time period option
  2. Configure the desired time in the Settings section

Parameters | Description
Settings | Configuration of the time filter.
Propose current date/time | Active: Time filter is displayed in Runtime.
Preset | Active: The time filter is prescribed in the Editor. Only the start time can still be configured in Runtime.
From | Start time of the filter. Selection of day, month, year, hour, minute and second
To | End time of the filter. Selection of day, month, year, hour, minute and second

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Relative period of time

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> Time -> Relative period of time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A relative time period is entered.

Attention: This filter is updated constantly and continues to run.
Example: You set a relative time of 10 minutes and switch to a screen with this time filter at 12:00. You are then shown the data from 11:50 to 12:00 when switching. If the screen stays open, the filter is automatically updated. At 12:01, you see the data from 11:51 - 12:01 etc.

To set the filter:

  1. Select, in the Filter section, the Relative period of time option
  2. Configure the desired time in the Settings section

Parameters | Description
Settings | Configuration of the time filter.
Propose current date/time | Active: Time filter is displayed in Runtime.
Preset | Active: The time filter is prescribed in the Editor. Only the start time can still be configured in Runtime. Selection of the relative time period in days, hours, minutes and seconds.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


From

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> Time -> From

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A time from which the filter is effective is defined. To set the filter:

  1. Select, in the Filter section, the Off option
  2. Select the desired filter from the drop-down list.
    • From HH:MM:SS o'clock
    • From day - HH:MM:SS o'clock
    • Starting on day, month at HH:MM:SS
  3. Configure the desired time in the Settings section

Parameters

Description

Settings

Configuration of the time filter.

[Date/Time]

Depending on the settings of the Off option, the time from which the filter is effective is configured here:

  • Starting from HH:MM:SS
  • Starting from day - HH:MM:SS
  • Starting from day, month - HH:MM:SS

Warning! The start point of this filter is not updated automatically. Only the existing times are used when shown, even if the screen remains open and 23:00:00 is reached.
The end time point is not defined with this filter, it is carried over.
  • Starting from HH:MM:SS

A time from which the filter is effective is stated. If the time is not reached on the current day, filtering takes place from the corresponding time the previous day.

Example: You enter 23:00:00. If it is then 23:30 when executing the function, then it is filtered from 23:00:00 up to the current point in time. If it is 22:30 however, then filtering takes place from 23:00:00 on the previous day to the current point in time.
  • Starting from day - HH:MM:SS

A day and time for the start of the filter are entered. If the time given has not been reached in the current month, the corresponding time from the previous month is used.

Example: You enter day 5 - 23:00:00. If it is the 10th of the month at 23:30, then filtering takes place from the 5th of the month from 23:00:00 to the current time point. If, however, it is the 4th of the month, then filtering takes place from the 5th of the previous month to the current time point.

  • Starting from day, month - HH:MM:SS

A month, day and time for the start of the filter are entered. If the time stated has not been reached in the current year, the corresponding time from the previous year is used.

Example: You enter Day 5, Month October - 23:00:00. If it is October 10th at 23:30, then filtering takes place from October 5th from 23:00:00 to the current time point. If, however, it is only October 4th, then filtering takes place from the 5th of the previous year to the current time point.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Time period

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> Time -> Time period

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A time period in which the filter is effective is defined. To set the filter:

  1. Select, in the Filter section, the Time period option
  2. Configure the desired time in the Settings section

Parameters

Description

Settings

Configuration of the time filter.

Time period

Selection of a time range from a drop-down list.

Filtering for this time range is carried out in Runtime. The filter relates to the time of screen switching.
For example: The value 60 minutes shows all archives of the last hour.

If this dialog is offered in Runtime, the start time of the time range can be selected.

Modify time period

Allows amendments to cycles, postponements and extensions of time periods.

Active: Evaluation is carried out in accordance with the following rules:

  • First, the Use last finished time period option is evaluated.
  • After this, Change time period by is used.
  • Move time period to the future by is then applied.

Inactive: No changes to the time period are made.

Attention: With version 7.10, filter actions on the basis of this function led to different results than those in the versions before.

Move time period to the future by

Active: The time period defined in the filter is postponed to the future. Given in hours - minutes - seconds.

If a postponement that is the same or greater than the selected time period is set, a note to check the configuration is displayed.

Change period of time by

Active: The time period defined in the filter is modified. Given in hours - minutes - seconds.

If a change and a postponement that are the same or greater than the selected time period is set, a note to check the configuration is displayed.

Add time

Active: The time stated in Change time period by is added to the time defined in the Time range option.

Deduct time

Active: The time stated in Change time period by is deducted from the time defined in the Time range option.

Use last finished time period

Active: The last finished time period is used.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Specify time period in the Editor

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> Time -> Specify time period in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this method, you enter a fixed time period into the editor, which is applied when the function is carried out in Runtime. You can then only define the start time in Runtime, but no further filter settings.

For example: You set a 30 minute time filter. In Runtime, you can now only set when this 30 minute time period is to start. However, you cannot change the filter to a day filter.

attention Attention

When using this type of filter, you can also no longer amend all other filters in Runtime that are available in the General tab. It is still possible to filter for text, status and equipment.

To create the filter:

  1. The screen must have the Filter button to start the filter in Runtime
  2. select the desired filter
  3. Configure the selected time period

Tip for time period: Activate the Offer this dialog in Runtime option in the filter dialog. This way you can amend the start time before the function is carried out. Do not have the filter displayed in Runtime when the function is turned on; this way the current time period is always used. If you have activated the Use last closed time period option, the previous time period is shown.
For example: You have set a 30 minute filter. It is 10.45 when the function is activated. If the Use last closed time period option is deactivated, the filter is set to the current time period 10:30:00 to 10:59:59. If the option is activated, the filter is set to the previous time period of 10:00:00 to 10:29:59.


Time filter can be configured in Runtime

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> Time -> Time filter can be configured in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this method, you stipulate a time filter in the Editor. This can be amended in Runtime before execution. To create the filter:

  1. The screen must have Filter and Display filter buttons
  2. select the desired filter:
    • Absolute period of time
    • Relative period of time
  3. Select, in the Settings section, the option Propose current date/time
  4. The filter dialog is opened in Runtime with the current date and time


Lots

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> Lots

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration of the lot filter. Only available for archive data data source.

The Relative lot selection option is only available for the YT axis and only if no curves have been configured.

Filter

Settings for the application of the lot filter. Selection of one of the options:

  • No lot filter
  • Apply lot filter directly
  • Display lot selection dialog

Parameters

Description

No lot filter

Active: The lot filter is deactivated and cannot be configured. Filtering for lots is not carried out in Runtime.

Apply lot filter directly

Active: The filter configured here is applied in Runtime directly.

Display lot selection dialog

Active: The dialog for lot selection is shown in Runtime when:

  • Clicking on Filter or
  • screen switching, if the Offer this dialog in Runtime option has been activated (not available for each function/screen type)
    Note: The dialog is not shown on reloading.

Options can be pre-selected in the Editor.

Replace dialog in Runtime with screen

Not available if the Show lot selection dialog option has been selected.

Definition of a screen that is to be called up in Runtime instead of the lot selection dialog. Only time/lot filter screens are offered.

Click the ... button and the dialog opens to select a screen.

If the linked screen is not found in Runtime, a search is made for corresponding screens with specific names.

Relative lot selection

Only available for Extended Trend and faceplates and only if the option Display lot selection dialog has been activated. The Windows CE project property must be deactivated in the project properties.

  • Active: Enables several lots to be compared directly. Display always starts from the zero point.

Time

Configuration of the time filter for lot selection. Selection of one of the options:

  • No filter
  • Last lots
  • Use time filter from "Time" tab

Parameters

Description

No filter

Active: The time range set in the Time tab is not taken into account. All completed and current lots are displayed.

Last lots

Active: Input of the number of lots last concluded, according to what they should be filtered for. Input of the number in the number field or configuration via cursor keys.

The option allows the combination of both options Display current lots and Display completed lots.
Example: 3 lots are to be displayed, 2 are running and 10 have been completed. The following is shown: the two that are current and one that has been completed.

Attention: At least one of the two options Display current lots or Display completed lots must be activated. If both options have been deactivated, this corresponds to the No filter setting.

Note on compatibility: If the current lots or the combination of current and completed lots are selected and the project is compiled for a version before 7.11, the completed lots are shown in Runtime.

Display current lots

Active: The current lots are displayed.

Note: If the number of lots to be displayed is greater than the number of current lots, lots that have been completed are also shown until the set limit has been reached.
Example: 3 lots are to be displayed. 1 lot is running, 5 have been completed. The one current lot and two completed lots are displayed.

Display completed lots

Active: The completed lots are displayed.

Note: If the number of lots to be displayed is greater than the number of completed lots, lots that have been completed are also shown until the set limit has been reached.

Use time filter from "Time" tab

Active: Pre-filtering is carried out with the settings of the Time tab. The effective range of the filter can be amended within this time range. Select from drop-down list:

  • Start and end also outside filter limits: (Default)
    Lots can start before the start time configured in the Time filter and end after the configured end time.
  • Start and end only outside filter limits:
    Lots must start and end within the time points configured in the Time filter for the start and end.
  • Start also before filter limit:
    Lots can start before the start time configured in the Time filter and end after the configured end time.
  • End also after the filter limit:
    Lots can also end after the end time set in the time filter, but must start at or after the configured start time.
  • Adjust start and end to filter limits:
    Lots are cut to the time points configured in the Time filter for the start and end.

Archives

Configuration of filtering for archives. Selection of one of the options:

  • No filter
  • Static
  • From variable

Note: Only available for the following modules if the Apply lot filter directly option has been selected:

  • Archive revision
  • ETM
  • Report Generator
  • Report Viewer

Parameters

Description

No filter

Active: Filtering for archive names is not carried out.

Static

Active: Archives whose identification corresponds to the character string entered in the input field are filtered for.

Input of the archive identifications in the input field:

  • Several identifications are separated by a comma (,).
  • * or empty: All archives, no filter.

From variable

Active: The value of the variables linked here is applied as a filter for archive names in Runtime.

Click on button ... in order to open the dialog for selecting a variable.

Only available for all modules if the Apply lot filter directly option has been selected:

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.

If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for archive names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Names

Configuration of the filtering to names. Selection of one of the options:

  • No filter
  • Static
  • From variable

Parameters

Description

No filter

Active: Filtering for lot names is not carried out.

Static

Active: Lot names that correspond to the character string entered in the input field are filtered for.

Input of the lot name in the input field:

  • Several entries are separated by a pipe character (|).
  • * or empty: All lots of all displayed archives, no filter.

From variable

Active: The value of the variable linked here is applied as a filter for lot names in Runtime.

Click on the ... button to open the dialog for selecting a variable.

Not available if the option Apply lot filter directly has been selected.

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.
  • If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for lot names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Column settings

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> Column settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration of the column settings for the extended curve list.

Parameters

Description

Cursor output / values between first and second cursor

Configuration of the column types and column widths to be displayed.

Column type

Column types available:

Cursor output

  • Date
  • Variable
  • Value
  • Measuring unit
  • Limit Text
  • Status

Values between first and second cursor

  • Minimum
  • Average
  • Maximum
  • Time difference
  • Value difference
  • Sum
  • Standard deviation
  • Number of measuring points

Clicking in the checkbox activates/deactivates the display of the type in Runtime.

Width

Column width of the column output or column width of the measuring points between first and second cursor in the cursor output list. The value corresponds to the number of the characters.

Clicking in the value allows it to be edited.

Show header in scan window in compatibility mode

Active: For zenon versions before 6.51 SP0, column headings are shown for "scan window in compatibility mode". Is used to display converted projects in Runtime, for example.

Not necessary for projects from version 6.51 onwards. All column titles are displayed in the Scan list.

Extended curve list

Configuration of the column settings for the extended curve list.

List field

Display of the configured columns.

Column selection

Opens dialog to select the columns.

Column Format

Opens dialog to format the columns.

OK

Applies all changes in all tabs and closes the dialog.

Cancel

Discards all changes in all tabs and closes the dialog.

Help

Opens online help.

info Information

The title of the header of the cursor output list can be changed with the help of the language switch.

To provide the header also when converting projects of older versions, you can either delete the existing cursor output list and replace it with the new element or you activate checkbox Display header.

If you create projects for zenon version earlier than 6.51 SP0, you can insert the respective cursor output list after you selected the desired Runtime version.


Column selection

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> Column settings -> Column selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You configure the columns to be displayed in Runtime here.

Button | Function
Available columns | List of columns that can be displayed in the table.
Selected columns | Columns that are displayed in the table.
Add | Moves the selected column from the available ones to the selected items. After you confirm the dialog with OK, they are shown in the detail view.
Add all | Moves all available columns to the selected columns.
Remove | Removes the marked columns from the selected items and shows them in the list of available columns. After you confirm the dialog with OK, they are removed from the detail view.
Remove all | All columns are removed from the list of the selected columns.
Up | Moves the selected entry upward. This function is only available for unique entries, multiple selection is not possible.
Down | Moves the selected entry downward. This function is only available for unique entries, multiple selection is not possible.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Column Format

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> Column settings -> Column Format

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The columns are formatted here.

Configuration of the properties of the columns for configurable lists. The settings have an effect on the respective list in the Editor or - when configuring screen switching - in Runtime.

Available columns

Parameters | Description
Available columns | List of the available columns via Column selection. The highlighted column is configured via the options in the Settings area.

Settings

Parameters

Description

Settings

Settings for selected column.

Labeling

Name for column title.

The column title is online language switchable. To do this, the @ character must be entered in front of the name.

Width

Width of the column in characters.
Calculation: Number time average character width of the selected font.

Alignment

Alignment. Selection by means of radio buttons.

Possible settings:

  • Left-justified: Text is justified on the left edge of the column.
  • Centered: Text is displayed centered in the column.
  • Right: Text is justified on the right edge of the column.

Deactivate column filter in the Runtime

Active: The filter for this column cannot be changed in Runtime.

Note: Only available for:

  • Batch Control
  • Extended Trend
  • Filter screens
  • Message Control
  • Recipegroup Manager

User defined colors

Properties in order to define user-defined colors for text and background. The settings have an effect on the Editor and Runtime.

Note:

  • These settings are only available for configurable lists.
  • In addition, the respective focus in the list can be signalized in Runtime by means of different text and background colors. These are configured using the project properties.

User defined colors

Active: User-defined colors are used.

Text color

Color for text display. Clicking on the color opens the palette to select a color.

Background color

Color for the display of the cell background. Clicking on the color opens the palette to select a color.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Customize view of cursor output list

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> Column settings -> Customize view of cursor output list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The appearance of the cursor output list can be adapted to individual requirements:

Scroll bars, headers and grids

To define the size and appearance of scroll bars, the header or grids for the reports:

  1. Activate, in the Representation group, the Extended graphical settings property
  2. Define the desired properties in the groups Scroll bars and Header and grid for the Alarm Message List element on the screen

info Information

If the Graphics file property is selected for the Display style property, then all elements for which no graphics file has been selected are shown with a color gradient. Transparent graphics cannot be used for control elements for lists.

Sorting in Runtime

To mark the relevant column for sorting in Runtime and to determine the sorting sequence, configure the graphic element for the title line:

  1. Select the Graphics files for the Display style property
  2. Link the Sort ascending and Sort descending properties with a graphics file
  3. The selected graphic for the respective sorting direction is displayed in Runtime for the sorting of relevant columns
  4. Clicking on the graphic changes the sorting sequence
  5. Clicking on the column title activates the column for sorting

Operating the header in Runtime

You can make it possible for users to operate the header in Runtime. With this an individual customization of the look is possible in the Runtime:

  • Moving columns
  • Change size
  • Changing sorting.

To do this, navigate to Alarm Message List group in the settings and select, in the Header AML property, Operable headers. Alternatively, you can also switch the header to inoperable or invisible here.

These settings apply for all headers in the project.

info Information

You can prohibit the manipulation and/or the visibility of the header for each screen Alarm Message List by deactivating the property Show header or Make header editable for the tabular view.

Preview

By activating the Extended graphical settings property in the Editor, the header and scroll bars can be previewed. This way, details such as color fill effects, light effects or grids can be configured more easily.

Attention: As the size of the scroll bars equals their size in the Runtime, the total size of the list in the Editor can vary from the size in the Runtime. This is also true for the size of the header and the font of the header.


Printer settings

Manual -> Extended Trend -> Engineering in the Editor -> Screen switch - Extended Trend -> Printer settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration of the settings for the print-out or output to a file.

Output

Parameters

Description

Output

Configuration of the output type and the corresponding options.

Printer

Active: The diagram is output to the printer that is defined in the General configuration of zenon by default for screenshots. See also the chapter on printers.

File

Active: The diagram is saved as a file. Configure the output with the options:

  • Type
  • Width
  • Height
  • Stipulation of file name
  • Automatic file name
  • With prefix

These options are only available for output to a file.

Type

Selection of the file type from the drop-down list. Available are:

  • JPG
  • BMP
  • SVG

Width

Entry of the width of the graphics file in pixels.

Height

Entry of the height of the graphics file in pixels.

Stipulation of file name

Active: Entry of any desired file name.

Automatic file name

Active: The filename is issued automatically.

Format: <Prefix_><YYYYMMDD>_<HHMM>.<Type>

With prefix

Only available if automatic file name has been activated.

Enter a desired prefix for the automatically-created filename. This is prefixed by the name separated by an underscore (_).

Options

Parameters | Description
Options | Configuration of the options.
Show key | Active: A key is printed out with the diagram. This informs you of the curves and their colors, for example.
Print on one page | Active: The key is output on the same page as the diagram.

Header and footer, heading and comment

Parameters

Description

Header and footer, heading and comment

For printing an Extended Trend diagram, additional information can be configured for the header and footer, as well as a heading and comments.

Four buttons are available for easier input:

  • Date
  • Time
  • Diagram name
  • Page number

Header

Entry of information for the header in the following areas:

  • Left
  • Center
  • Right

Footer

Entry of information for the footer in the following areas:

  • Left
  • Center
  • Right

Title

Entry of a title.

Comment

Entry of a comment.

OK

Applies all changes in all tabs and closes the dialog.

Cancel

Discards all changes in all tabs and closes the dialog.

Help

Opens online help.

Note: Printouts made using the Print button of the Extended Trend screen may be different to those made using the Extended Trend screen switching or Print Extended Trend diagram functions. The functions assume a window size of 1000 x 700. Printing via the button is in the proportion defined in the Editor. Cancel


Configuring curves

Manual -> Extended Trend -> Engineering in the Editor -> Configuring curves

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Curves are created by clicking on the Add button in the Data tab. To configure curves:

  1. Highlight the curve in the list
  2. Click on the Edit button
  3. The dialog for configuration is opened
  4. configure:
    1. Curve parameters
    2. Y-axis parameter


Curve parameters

Manual -> Extended Trend -> Engineering in the Editor -> Configuring curves -> Curve parameters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For each trend curve the curve features can be parameterized.

Curve

Parameters | Description
Curve | Configuration of the curve.
Curve name | Freely definable curve name. The variable name is entered by default. Note: Subsequent amendment of the variable name has no influence on the existing curve names.
Line width [Pixel] | Defines the width of the curve in pixels.
Distance from the top frame [Pixel] | Only available for Gantt display. Definition of the distance in pixels from Gantt chart to the top diagram frame.

Type of display

Parameters

Description

Type of display

Definition of line type for trend curve. Possible formats:

  • Line
  • Dashes
  • Dots
  • Dash-dot
  • Dash-dot-dot

Note: If, in the Graphics quality property, Windows basis was selected, only solid lines can be displayed in Extended Trend for a line width of greater than 1.

Interpolation

Active: Values are connected using polylines (supporting positions).

Inactive: Value changes are displayed as line jumps (stepped display).

Lengthen curve

Active: The curve is lengthened from the last available datapoint to the current moment.

Area display

Active: The values are displayed as surfaces instead of lines.

Gantt display

Active: Gantt display for this curve is activated. The curve name is used as labeling

For details on limitations, seethe Gantt display and Y-axis parameters sections.

Display limit

Only available for Gantt display.

Active: The numerical limit is displayed.

Display limit text

Only available for Gantt display.

Active: The description of the limit value is displayed.

Color

Parameters

Description

Color

Configuration of the color display.

Curve color

Configuration of the curve color. Clicking on Color opens the color selection dialog.

Fill color

Configuration of the fill color. Clicking on Color opens the color selection dialog.

Only effective if the Area display option has been activated.

Transparency of the fill color [%]

Stipulation of the transparency of the fill color in percent. This can prevent curves being overlaid by curves with area display.

  • 0 %: no transparency
  • 100 %: fully transparent

Note: Not available for Windows CE.

Display offset

Parameters | Description
Display offset | Configuration of the display offset
Days | Moves the curve by the set number of days.
Hours | Moves the curve by the set number of hours.
Minutes | Moves the curve by the set number of seconds.
Turn of month | Moves the curve by a month.
Turn of year | Moves the curve by a year.
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Y-axis parameter

Manual -> Extended Trend -> Engineering in the Editor -> Configuring curves -> Y-axis parameter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The curve parameters are defined this dialog and the curve parameters dialog.

Display

Parameters

Description

Display

Parameters for display of curves in Runtime.

Axis title

Name of the axis.

Position

Positioning of the Y-axis on the X-axis in percentage of the length of the X-axis.

  • 0: left,
  • 100: right

Color

Configuration of the axis color. Clicking on Color opens the color selection dialog.

Attention: Can be configured independently of the trend curve color.

Display horizontal grid lines

Display of help lines on the main ticks.

not available for Gantt display.

Type of axis

Parameters | Description
Type of axis | Defining of the scaling of the Y-axis. not available for Gantt display.
Linear | Linear division of the Y-axis. not available for Gantt display.
Logarithmic | Logarithmic division of the Y-axis

Scale

Parameters

Description

Scale

Define representation range of the process variables within their configured technical limits (zoom function).

not available for Gantt display.

From

Scaling start value.

To

Scaling end value.

Automatic scaling

Active: The scaling of the axis is automatically determined for this curve in Runtime. The min/max values of the area to be displayed are used as axis limits.

If the checkbox is activated, the input fields for the scaling (From/To) are no longer available for individual configuration.

Text

Parameters | Description
Text | Position of the axis labeling
Left of the axis | Values are displayed to the left of the axis.
Right of the axis | Values are displayed to the right of the axis.
Exponential display | Values are displayed exponentially. not available for Gantt display.
Hide unit | Active: Unit for axis labeling is not displayed. Allows the display of several variables with different units. Default: inactive not available for Gantt display.

Scaling

Parameters | Description
Scaling | Definition of the axis subdivision. not available for Gantt display.
Number of main ticks | Number of main ticks with value indication.
Length of main ticks (in pixels) | Length of main ticks in pixels.
Number of subsidiary ticks | Number of subdivisions between two main ticks.
Number of main ticks automatically | Automatic setting of scaling and axis subdivision during online operation.
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

The display of curve and Y-axis are configured using the checkboxes for Y-axis and Active in the Data tab.


Gantt display

Manual -> Extended Trend -> Engineering in the Editor -> Configuring curves -> Gantt display

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the help of the Gantt display you can visualize the state of a piece of equipment in the Extended Trend. For example it can be displayed when a piece of equipment has been in operation, in maintenance, idle and so one. With the display in the Extended Trend it is possible to compare the states of a piece of equipment with the characteristic curve of the process. Thus you can make conclusion about the behavior of a piece of equipment. For example you detect an abnormal behavior of the characteristic curve of the process but you see according to the Gantt chart that the equipment was in maintenance at that time.

Engineering

With the Gantt display, the limits and reaction matrices are taken into consideration for the evaluation, not the actual values of the respective variables. The display reflects the status of a piece of equipment; the exact value does not play a role.

The individual Gantt charts are displayed in the top frame of the control element. Take care that you engineer the frame large enough so that no display problems arise.

As a basis for the color of the respective Gantt charts the violated limit or reaction matrix is used. In doing so, the currently-configured limits and states of the Reaction matrix are always used for this. If you change them, even historic evaluations are displayed with the current values. There is no history for the limits or the states of a Reaction matrix.

Note: If a Gantt curve is also intended to show the current status then, in the configuration of the archiving in the Save tab, the Save process image on startup option must be activated.

Curve parameters

The curve settings for the Gantt display are changed using the same dialog as the general curve configuration. The parameters to be set differ in part:

  • The curve name is used as labeling
  • Distance from the top edge: A negative value must be entered here to display the curve in Extended Trend.
  • Display limit
  • Display limit text

    If the options Display limit and Display limit text are used together, the display is:
    Limit text/limit value

Y-Axis

The Y-axis is configured using the same dialog as the general curve configuration. The label is configured here.

  • Color
  • Position in % of the width of the X-axis (measured from the left)

The following Y-axis settings are not available for Gantt displays:

  • Display horizontal grid line
  • Type of axis
  • Scale
  • Exponential display
  • Scaling

Display during Runtime:

Gantt display for string variables

The configuration of the curve settings for Gantt display for string archive variables is different from the configuration of other Gantt displays in these aspects:

  • Display limit: is inactive
  • Display limit value text: is inactive
  • Alternative color: replaces the fill color property and is initialized with a color that differs from the curve color

In the Runtime:

Display with this Gantt display is as with a conventional Gantt display, however with the following differences:

  • For each new value of the variable, the bar changes color between curve color and alternative color
  • The string value of the variables is displayed as a text

Notes on configuration of the Gantt display for string variables

For Gantt curves with text, the line width is not amended automatically. The default value 0 here corresponds to a width of 1 pixel. The font is taken from the settings in the Display tab; the font color is black.

If, for the recording of string variables in the archive, record on change has been selected and he current status is to be displayed, then the Save process screen on startup option must be activated.

If Runtime files were created for a version before zenon 7.11, then:

  • The Gantt display curve for string variables is not removed
  • A bar without text is displayed for as long as the variable has a value


Filter profiles

Manual -> Extended Trend -> Engineering in the Editor -> Filter profiles

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Filter profiles are filter settings that the user can save and call up in Runtime in relation to a certain screen.

To be able to use filter profiles, the following control elements must be configured:

Control element | Description
Filter profiles | Profile administration in Runtime.
Profile selection | Selection of a saved profile in Runtime from a drop-down list.
Save | Clicking on the button in Runtime saves the filter settings as a profile.
Delete | Clicking on the (X) button in Runtime deletes the selected profile.

With this you can in the Runtime:

  • save filters
  • use saved filters
  • delete filter profiles

Filter profiles can also be exported and imported with further control elements.


"Print Extended Trend diagram" function

Manual -> Extended Trend -> Engineering in the Editor -> "Print Extended Trend diagram" function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the help of the Print Extended Trend diagram function, you can print Extended Trend diagrams or save them in a file (JPG, BMP or SVG) without opening the Extended Trend screen.

To configure the function:

  1. Create a new function
  2. navigate to the Applications node
  3. Select Print Extended Trend diagram

The function will be created along the lines of screen switching.

Note: Printouts made using the Print button of the Extended Trend screen may be different to those made using the Extended Trend screen switching or Print Extended Trend diagram functions. The functions assume a window size of 1000 x 700. Printing via the button is in the proportion defined in the Editor.


Entries in the project.ini

Manual -> Extended Trend -> Engineering in the Editor -> Entries in the project.ini

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following entries are possible in the project.ini file for the extended trend.

Parameters

Description

[DEFAULT]

General settings

MILLISEK=
  • 1: Display in millisecond grid
  • 0: minimal in the update grid

[EW_TREND]

ANZEIGE_GWTEXT=
  • 1: Display limit value text (default)
  • 0: do not display

[ARCHIV]

Archive configuration

ARCHDIGITS=

Number of decimal places when exporting archives in TXT, XML or DBF format and for export to a SQL server.
Default: 1

TRENNZEICHEN=

Separator for export to ASCII file.
Default: ;

SPEICHER=

Maximum number of values that are read in for Extended Trend, archive revision and reports.

Default: 1000

SQL_MAXROWS=

Maximum number values which can be read from the SQL.

Entry is ensued in 1000 steps.
100 = 100.000 values.

As of version 6.50, there is an automatic check that there is always at least 10% free memory left.


Operating during Runtime

Manual -> Extended Trend -> Operating during Runtime

In online operation the window for the Extended Trend is opened via a function call . The screen pre-defined in the Editor is called up.

With extended curve list:

There are different control elements available to operate the extended trend and the displays, depending on the engineering.

Element

Description

Window

Selection of the window to be displayed for diagrams and curves in Runtime.

Diagram

Window to display trend curve

Diagram name

Shows the diagram name.

Set filter

Displays the status of the current time filter in Runtime.

Cursor Output list

Shows the position of the cursor in the diagram window and the values set in diagram settings and cursor output

Extended curve list

Curve list that can be edited in Runtime. The following can be edited:

  • Curve name
  • Title
  • Color
  • Fill color
  • Area display
  • Y-Axis
  • Active
  • Sorting order

Note: Not available under Windows CE. Is replaced by the curve list (outdated) there.

Curve list (outdated)

List of curves.

Is used for CE for compatibility reasons. The extended curve list is recommended for all other projects.

Diagram functions

Pre-defined controls for diagrams.

Filter

Display of set filter.

Chart settings

Activates the dialog for diagram settings and cursor output

Curves

Change curve parameters.

x-axis

opens the dialog for x-axis settings.

Refresh

Refreshes the display.

Stop

Do not refresh screen.

Next

Update screen

Cursor on/off

Query values

Double cursor on/off

Display values that are between two cursors.

Print

Prints diagram.

Note: Printouts made using the Print button of the Extended Trend screen may be different to those made using the Extended Trend screen switching or Print Extended Trend diagram functions. The functions assume a window size of 1000 x 700. Printing via the button is in the proportion defined in the Editor.

Print with dialog

Choose the printer before printing out the diagram.

Copy to clipboard

Copy representation into the intermediate store.

Export data displayed

exports all visible data of all curves as a CSV file.

Diagram navigation

Buttons for navigation in the diagram.

Cursor one pixel to the left

Places cursor one pixel to the left.

If the Shift key is pressed at the same time, the cursor is moved by 10 pixels.

Cursor one pixel to the right

Places cursor one pixel to the right.

If the Shift key is pressed at the same time, the cursor is moved by 10 pixels.

Backwards

Scroll backward on the time axis (history)

Quarter backwards

Moves the time period displayed back by a quarter of the measuring unit selected.

Forward

Scroll forward on the time axis (current)

Quarter forwards

Moves the displayed time period forwards by a quarter of the unit selected.

Zoom

Zoom display

Step back

Reduce display

Zoom +

reduces display time intervals

Zoom -

Increases display time intervals

Zoom to 100 %

Sets zoom factor to 100%.

This zoom action is saved in the zoom history.

For example: zooming is used

  • to zoom 2x into a selected area of the Extended Trend,
  • then zoom content to 100% is selected and
  • then a selected area is zoomed into again,

then there are 4 zoom events in the history. These can be gone back to again using the Back button.

Filter profiles

Buttons for filter settings in Runtime.

Profile selection

Select profile from list.

Save

Saves current setting as a profile.

Delete

Deletes selected profile.

Import

Imports filter profiles from export file.

Export

Exports filter profiles in the file.

info Information

The cursor one pixel to the left and cursor one pixel to the right control elements move the cursor if it is active, not the trend.

Arrow keys on the keyboard can also be used instead of the control elements.

If you hold down the Shift key when moving with the cursor keys, the movement is carried out in 10-pixel increments.

If in Extended Trend archive values are displayed or if the continuous updating of the online data is switched off then the current values of the curves up to the current time are re-read in by pressing the Refresh button. Or it is updated according to the refresh times defined in Diagram.

Paging in extended trend beyond the represented X-axis is possible with the use of the << button (display older values) or >>(display more recent values). If online data is displayed, a maximum entry depth as defined for the process variables can be shown. For archive values, the configuration of the archives stored in the database is decisive.

info Information

The refresh rate dynamically adjusts to the loading time of the data for archive trend. If loading lasts longer than half of the refresh interval, the refresh rate is doubled.

Zoom

Clicking on the Zoom + button plus dragging an area on the diagram displays the values in a more detailed resolution and at a smaller interval (X and Y axis). Zooming is only possible if the selected area covers at least one subdivision per axis. Multiple zooming is possible. Clicking on the Rezoom button switches the zoom factor back to the levels at which they were previously defined.

Online data

With Online data and refreshing the visualization changes with each refresh corresponding to the most current entry. To be able to scroll through, ongoing refreshing must be switched of by means of the Stop button. If the continuous updating should be reactivated then the Next button is to be pressed. With the diagram's next refresh cycle the new data and the new X-axis range are updated.

info Information

Online variables in Extended Trend:

The online variables for Extended Trend are configured in the Editor and can no longer be changed in Runtime. The HDD ring buffer is also configured for the variable during configuration in the editor. It is not possible to create or change the ring buffer for variables in Runtime. Online variables therefore cannot be adapted in Runtime.

Variables from archives can also continue to be added in Runtime.


Cursor

Manual -> Extended Trend -> Operating during Runtime -> Cursor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Click on button Cursor on/off in order to start the scanning mode. A cursor appears in the middle of the diagram. You can move the cursor by left-clicking on it and moving the mouse while still pressing the mouse button. You can also use the keyboard. Press Left or Right in order to move the cursor in small steps. To carry out larger steps, press Shift at the same time. You can see the respective value in the cursor output window. Click on button Cursor on/off again in order to exit the scanning mode. The following information can be displayed in the cursor output window:

Parameters | Description
Date | Date/Time of the saved value
Variable | Variable name of the saved value
Value | Technical value of the saved value
Unit | Unit of the saved value
Limit Text | Condition text (limit value text) of the saved value.
Status | Status of the saved value .
Minimum | Minimum of the period of representation (optional).
Average | Average of the period of representation (optional).
Maximum | Maximum of the period of representation (optional)

In order to change the displayed information and the according column widths, click on the button Diagram settings... The dialog to configure the Extended Trend is opened. :

In the Column settings tab, you can set the column widths for the different entries in the cursor output window. With the help of the checkbox you decide which columns you want to display.

info Information

If an XY display is configured, then only the respective current value is shown when the scanning is started. This cannot be updated. The cursor cannot be moved.

Double cursor on/off

If you engineered the control element Double cursor on/off, you have the possibility to use a second cursor in the diagram. With this a scanning with two separate cursors is possible. Click on button Double cursor on/off in order to display two cursors on at the left end and one at the right end of the diagram. You can move the second cursors either with the help of the mouse or the keyboard. In order to do this, press and hold Ctrl and press Left or Right to move the cursor in small steps. To carry out larger steps, press Shift at the same time.

The values between the first and the second cursor are displayed in the cursor output window. You can customize the available columns as desired in the Diagram settings and cursor output dialog.

info Information

The double cursor is not available for the block array data type.

Writing abscissas in variables

Two variables can be defined for the cursor, in which the abscissas are written for calling up and moving the cursor (time or X values). The variables can be LREAL or DWORD/DINT/UDINT variable and are configured in the screen switching in the Display tab. In doing so, the values are saved in Unix time format (number of seconds passed since 1 January 1970 00:00 UTC).


Export data

Manual -> Extended Trend -> Operating during Runtime -> Export data

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As a control element, an Export all data button for Extended Trend can be inserted and used in Runtime. In doing so, all visible data of all curves displayed is saved in a text file in CSV format.

Format of CSV file

  • The output is in the form of a Unicode text file.
  • Separator: Semi-colon (;)
  • You are free to choose storage location and file name in the save dialog.
  • The file has no header.
  • The data is displayed in this order in the text file:

    Variable name;Identification;Value;Unit;Status;Time

Property

Format

Variable name:

Character string

Identification:

Character string

Value:
  • Up to 8 digits before the decimal separator,
  • 8 digits behind the decimal separator

Unit:

Character string

Status:

Character string

Time:

dd.mm.yyyy hh:mm:ss.ms

There is no output if an exported variable property is empty.

Example: MyVarREAL_4;;978.45000000;;SPONT;09.09.2011 09:37:44.443

attention Attention

If too many curves are selected for export, the data collection can require a considerable amount of time.


Chart settings

Manual -> Extended Trend -> Operating during Runtime -> Chart settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

From the existing configuration, which was done in the editor, temporary changes (without saving) can be carried out in runtime. To open the dialog for configuration, click on the Diagram button.

fi

Important amendment options:

Parameters | Description
Other data: Curve > active | Activates and deactivates the display of the curve.
Other data: Curves -> Y-axis | Representation of the curve's y-axis
Other data: Curve -> editing | Editing the settings of the selected trend curve.
Column settings | Settings of the diagram parameters.
Representation: Design | User defined font for x- and y-axis labeling and value indication
Representation: Update | Updating of the diagram for online data


Operate extended curve list

Manual -> Extended Trend -> Operating during Runtime -> Operate extended curve list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If the extended curve list is configured in the Editor, curves can be edited in Runtime. It is possible:

  • To filter for:
    • Activation
    • Color
    • Curve name
    • Sorting order
    • Title
    • Variable name
    • Variable identification
    • Y-Axis
  • To edit curve names
  • To edit titles
  • To edit colors
  • To activate or deactivate the Y-axis
  • To activate or deactivate curves
  • To change the display sequence

To edit an element, double click in the corresponding cell of the list.

info Information

The extended curve list cannot be displayed with Windows CE and is replaced by the normal curve list.

Sort curves

The sequence in which the curves are logged in the ETM can be defined:

  • In the Editor: when screen switching in the Data tab in the configuration of the curve list
  • In Runtime: in the extended curve list

The Sequence column must be displayed in the curve list in order to be able to change the sequence.

In the Runtime

To change the sequence in which the curves are drawn:

  1. Click in the extended curve list window.
  2. Select the curve to be changed.
  3. Click in the cell of the Sequence column.
  4. Enter the desired number. The other curves are rearranged automatically. A low position means that the curve is drawn earlier (displayed further back); a higher position means that the curve is drawn later (displayed further forwards):
    • Minimum: 1
    • Maximum: Number of curves

Sorting is carried out by clicking on the column header. Sorting according to other columns as a sequence does not have an effect on the sequence of the curve display.

Drag&Drop

Under certain circumstances, the curve list can be sorted in the editor and in Runtime by means of Drag&Drop:

  1. Sort the list according to the Sequence column.

    Attention: The list is also sorted according to a sequence when it is first shown. However for Drag&Drop, the column header must be explicitly clicked for sorting! It has no effect whether sorting is ascending or descending.

  2. Ensure that there are no groupings.
  3. Click in the line with the desired curve.
  4. Drag the curve to the desired place. The place where it is inserted is shown with a red border.

Designing checkboxes with graphics

Checkboxes with graphics can be designed individually. To do this, assign the desired graphics to the corresponding properties of the curve list in the editor. The graphics must already be created in the Files\graphics node. Properties to be configured in the Representation group:

  • On
  • On (inactive)
  • Off
  • Off (inactive)

The defined graphics are drawn in Runtime with the aspect ratio being taken into account.


Filter for screen switch

Manual -> Extended Trend -> Operating during Runtime -> Filter for screen switch

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The filter settings configured in screen switching can be modified in Runtime. For that

  1. Open the screen switching function in the Editor.
  2. Activate the Offer this dialog in the Runtime option in the Display tab.

In Runtime, the following is displayed when the screen is called up, depending on the configuration:

  • Complete configuration dialog
  • Lot filter activated: Lot filter is offered
  • Lot filter deactivated, time range time filter: Time filter is offered

Configuration of lot filter

If you set option no time filter as time filter type, all Runtime entries since 1. 1. 2000 are displayed.

attention Attention

All configured lot archives are offered in the list of archives. The same archive as in the screen switching must be selected here. Only then is data also displayed.

Parameters

Description

Lot filter

Selection of the recipe group that is to be imported. The filter consists of the two lists:

  • List of archives: a list of the archives
  • List of lots: List of lots allocated to the selected archive.

List of archives

Selection of the desired archive

node *:

  • Collects all lots of the displayed archive.
  • The key is the lot name.
  • The start time is the start time of the earliest lot.
  • The end time is the latest end time of all lots.

List of lots

Display of the lots allocated to the selected archive.

Filtering through entry of text, date, time or rime range - depending on type.

Sort by clicking on the header.

Lot name

Displays the name of all available lots.

Filter: Entry of a character sequence. Only lots matching the respective character string will be displayed.

Start date

Shows the start date of all available lots.

Filter: Entry of a start date or selection from a calendar.

Start time

Only available if you entered a start date.

Display of the start time of all available lots.

Filter: Entry of a start time. * means 12:00:00 AM o' clock.

End date

Shows the start date of all available lots.

Filter: Entry of an end date or selection from a calendar.

End time

Only available if you entered an end date.

Display of the start time of all available lots.

Filter: Entry of a start time. * means 11:59:59 PM o' clock.

Duration

This column displays the duration for each available lot.

Display only.

info Information

Still open lots are also displayed if they match the set filter criteria.

info Information

The value of the lot variable is written in the index file and in the header of the ARX file at the start of the lot. These entries are adjusted with every change of the variable. When the lot is closed, the value of the lot variable at this moment is finally written in the index file and in the header.

Thus the lot name is final when the lot is closed.

SQL

Lot filtering to archive values evacuated into SQL is carried out by means of a time filter. This time filter contains all values of the archive between the start time and end time of the lot. The lot start time and lot end time are also included. Milliseconds are not taken into account with this time filtering.

Configuration of time range

The filter dialog for the time setting can be be offered in Runtime as specialized for a time range. To do this:

  1. Open the screen switching function in the Editor.
  2. Click on Filter.
  3. Open the Time tab
  4. Select the Time period option.

In Runtime, instead of the complete dialog, only one dialog to configure the time range is offered. For example, for the One day setting:

Example

With this setting, individual time ranges, such as shifts, can quickly be called up and configured.

For example: Shift from 6:00 AM until 2:00 PM.

  1. Select, as a time period: One day.

    As a default a day lasts from 00:00 till 00:00.

  2. Set the postponement of the time range to six hours.

    Now the day lasts from 6:00 a.m. till 6:00 a.m. the next day.

  3. Now set the time period to 16 hours.
  4. Keep the option Deduct time.

    This means that there will be back-calculation from 06:00 on the next day by 16 hours. Now the day lasts from 6:00 a.m. till 2:00 p.m., which corresponds exactly to a morning shift.

  5. Transfer the new Runtime files.
  6. Restart the Runtime.
  7. Select the desired day in the screen switching.

You get the data of the selected day from 06:00 am to 2:00 pm.


Fast change of axis parameters in the online operation

Manual -> Extended Trend -> Operating during Runtime -> Fast change of axis parameters in the online operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To determine the value of displayed curves precisely, the X-axis and Y-axis can be moved. Moving is possible by means of:

  • Dragging & dropping with the left mouse button
    • Moving the x-axis vertically
    • Moving the y-axis horizontally
      The y-axis is duplicated when moved: The original axis remains in place when the copy is moved.
  • Click on the axis with the right mouse button to open the configuration dialog:
    • X-axis tab ,YT display
    • Y-axis dialog

The movement is reset when the screen is reopened.


Functions and scripts

Manual -> Functions and scripts

The user can influence zenon via user-defined project functions. Scripts make it possible to compile several user-defined functions and execute these in a sequence in Runtime.

tutorial License information

Part of the standard license of the Editor and Runtime.


Functions

Manual -> Functions and scripts -> Functions

All functions used in a project are based on the existing system functions. These are pre-defined macros that are easy to use and parameterize by the user.

Functions are configured or selected using:

  • The Functions node
  • The Select functions and scripts dialog


Detail view of context menus and toolbar

Manual -> Functions and scripts -> Functions -> Detail view of context menus and toolbar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Project Manager

Menu item | Action
Function new | Opens a window with function selection to create a new function.
Display unused functions | Creates a project analysis for unused functions in the current project and displays it as result list in an own window.
Export XML all... | Exports all entries as an XML file.
Import XML... | Imports entries from an XML file.
Open in new window... | Opens a new window in order to view and edit the function. The window is displayed at the lower edge of the Editor as a default setting. This can be moved as desired.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.

Detail view

Toolbar and context menu

Menu item | Action
Function new | Opens the dialog for creating a new function.
Parameters | Opens the dialog for entering the parameter.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Export selected XML | Exports all selected entries as an XML file.
Import XML | Imports entries from an XML file.
Function use... | Creates a project analysis for selected functions in the current project and displays it as result list in an own window.
Remove all filters | Removes all filter settings.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Help | Opens online help.


Overview functions in zenon

Manual -> Functions and scripts -> Functions -> Overview functions in zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Functions are sorted in the following groups:

  • AML and CEL
  • Application
  • Historian
  • Batch Control
  • User administration
  • Screens
  • Fault locating in electric grids
  • Message Control
  • Network
  • Report Generator / Report Viewer / Analyzer
  • Recipes
  • Script
  • Variable
  • VBA
  • VSTA
  • Windows


Favorites

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> Favorites

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This group contains functions that you have defined as favorites.

To add functions to this group:

  • Drag the desired functions into this group with Drag & Drop in order to be able to access them more quickly.


AML and CEL

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> AML and CEL

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This group contains functions for the handling of the alarm message list (AML) and the Chronological Event List (CEL).

Function | Description
Alarms: acknowledge flashing | This function acknowledges the flashing of all elements of the currently open screen of a selected frame. More in chapter: Alarms: acknowledge flashing
Alarms: delete | This function deletes filtered alarms. More in chapter: Alarms: delete
Alarms: acknowledge | This function acknowledges filtered alarms. More in chapter: Alarms: acknowledge
Alarm/event group log in/log off | This function switches on/off the connection to the PLC for a selected alarm/event group. More in chapter: Alarm/event group log in/log off
Alarm Message List active | This function activates the entire alarm message list. More in chapter: Alarm Message List active
Alarm Message List active/inactive | This function activates/deactivates the entire alarm message list. More in chapter: Alarm Message List active/inactive
Alarm Message List inactive | This function deactivates the entire alarm message list. More in chapter: Alarm Message List inactive
Activate/deactivate Alarm Message List, alarm/event groups/classes | This function activates/deactivates an alarm/event group, an alarm/event class or the entire Alarm Message List. More in chapter: Activate/deactivate alarm message list / alarm/event groups / alarm/event classes
Export AML | This function exports filtered entries of the alarm message list to an external format. More in chapter: Export AML
Save AML and CEL memory buffer | This function saves current alarms and events to file ALARM.BIN and CEL.BIN and values from the mathematics variables (counter) in file SY_MA32.BIN. More in chapter: Save AML and CEL memory buffer
Export CEL | This function exports filtered entries of the Chronologic Event List (CEL) to an external format. More in chapter: Export CEL
Print AML or CEL | This function prints selected entries of the alarm list (AML) or the Chronological Event List (CEL). More in chapter: Print AML or CEL
Create/print IPA document | This function creates an IPA report and writes it to an HTML file or prints it out. More in chapter: Create IPA document
Switch online printing on/off | This function switches on/off online printing of the alarm message list or the Chronological Event List (CEL). More in chapter: Switch online-printing on/off
Online printing start new page | In activated online printing this function finishes a page and starts a new one. The page number is reset to 1. More in chapter: Online printing start new page
Switch online printer | This function switches the online printing to a selected printer. Optionally, a dialog for the user can be opened before that. More in chapter: Switch online printer


Application

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> Application

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This group contains functions for the handling of project settings.

Function | Description
Select printer | This function opens a dialog in which the user can select printers for the different print tasks. More in chapter: Select printer
Start Load Management | This function starts the optimization for a selected service area in the Load Management module. This function is only carried out on the server. More in chapter: Start Load Management
Stop Load Management | This function stops the optimization for a selected service area in the EMS module. This function is only carried out on the server. More in chapter: Stop Load Management
Print Extended Trend diagram | With the help of this function you can print diagrams of the extended trend or save them in a file (JPG or BMP) without opening the screen Extended Trend. More in chapter: Print Extended Trend diagram
Switch palette | Creates a function in order to switch between palettes in the Runtime. More in chapter: Switch palette
Functions active at limit | This function activates the function administration. Automatically executed functions (e.g. via time control, limit violation, etc.) are executed. More in chapter: Functions active at limit
Functions active/inactive at limit | This function switches the function administration on or off. Automatically executed functions (e.g. via time control, limit violation, etc.) are not executed. More in chapter: Functions active/inactive at limit
Functions inactive at limit | This function switches the function administration off. Automatically executed functions (e.g. via time control, limit violation, etc.) are not executed. More in chapter: Functions inactive at limit
Open help | This function opens a selected help page from a CHM file. More in chapter: Open help
Reload project online | This function reloads only changed or all Runtime files. More in chapter: Reload project online
Determine open maintenances | This function sends currently open maintenances from the IMM to status variables. More in chapter: Determine open maintenances
Switch on/off simulation | This function switches between simulation mode and hardware mode. The type of simulation mode or hardware mode can be selected. More in chapter: Activate/deactivate project simulation
PFS - execute user-defined event | This function executes a PFS event previously created by a user. More in chapter: PFS - execute user-defined event
Simulate right click | This function interprets the next mouse click as a right click. More in chapter: Simulate right click
Save remanent data | Allows to the save the data of the configured modules. The choices are: AML ring buffer, CEL ring buffer, system driver and mathematics driver, internal driver, remanent images of all drivers, locking of the Command Processing. More in chapter: Save remanent data
Exit Runtime | This function closes the zenon Runtime. More in chapter: Exit Runtime
S7 Graph heuristics | This function makes it possible to carry out the S7 Graph heuristics without the screen S7 Graph being active. More in chapter: S7 Graph heuristics
Execute SAP function | Enables call up of a SAP function in the Runtime. More in chapter: Execute SAP function
Language switch | This function switches to a selected language in multi-lingual projects. More in chapter: Language switch
Topology - Search for ground fault | Call up of the short circuit detection. More in chapter: Topology - Search for ground fault
Topology - Check connections | Determines the supply state of the topological devices and depicts them on variables. More in chapter: Topology - LoadShedding


Historian

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> Historian

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This group contains functions for the optional module Historian.

Function | Description
Archive: Stop | This function stops a selected archive of the optional module Historian. More in chapter: Archive: Stop
Index archive | This function indexes archives. More in chapter: Index archive
Archive: Start | This function starts a selected archive of the optional module Historian. More in chapter: Archive: Start
Export archives | This function exports filtered archive entries of the optional module Historian to an external format. More in chapter: Export archives
Display open archives | This function displays a list of running archives of the optional module Historian. More in chapter: Display open archives


Batch Control

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> Batch Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This group contains functions for the Batch Control.

Function | Description
Execute recipe command change or mode change | You can send control commands to the batch execution with this function. More in chapter: Execute recipe command change or mode change
Create control recipe function | With the help of this function, a pre-defined control recipe can be created in the Editor by means of a button in Runtime. More in chapter: Create control recipe function


User administration

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> User administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This group contains functions for the User administration.

Function | Description
Change user | This function opens a dialog, where a logged-in administrator can create, edit or delete users and user groups. More in chapter: Change user
Login with dialog | This function opens the standard login dialog. More in chapter: Login with dialog
Login without password | This function logs in a selected user without asking for his password. More in chapter: Login without password
Logout | This function logs out the currently logged in user. More in chapter: Logout
Change password | This function opens a dialog in which the currently logged-in user can change their password. More in chapter: Change password


Screens

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> Screens

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This group contains functions for the handling of Screens.

Function | Description
ALC source colors | Function for the configuration of the ALC source colors for the error detection in electric grids. More in chapter: ALC source colors
Screen with index | This function opens a screen with a name containing a selected variable. More in chapter: Screen with index
Close screen | This function closes a selected screen. More in chapter: Close screen
Screen: Return to last | This function returns to the previously opened screen of the selected frame. More in chapter: Screen: Return to last
Delete path for "Screen: Return to last" | with this function, the path of the Screen: Return to last function can be deleted in Runtime. More in chapter: Delete path for "Screen: Return to last"
Screen: Move center | This function scrolls or zooms in a worldview screen. More in chapter: Screen: Move center
Screen switch | This function opens a selected screen. Optionally, a dialog for the user can be opened before that. Note: Without dialog the function is carried out with the highest priority (1). If a dialog is called up before the execution, the priority is downgraded to high (2). More in chapter: Screen switch
Activate input to the element with the focus | This function executed the functionality of the element, which currently has the input focus. More in chapter: Activate input to the element with the focus
Set focus to frame | This function sets the input focus to the currently open screen of a selected frame. This allows to create projects with pure keyboard operation. More in chapter: Set focus to frame
Move focus | This function sets the input focus to a certain element on the picture, whose frame currently has the focus. More in chapter: Move focus
Take focus away from frame | This function takes the input focus away from the currently open screen of a selected frame. This allows to create projects with pure keyboard operation. More in chapter: Take focus away from frame
Show menu | This function opens or closes a selected main menu. Optionally, a dialog for the user can be opened before that. More in chapter: Show menu
Monitor assign | This function assigns a selected virtual monitor to a selected real monitor. Optionally, a dialog for the user can be opened before that. More in chapter: Monitor assign
Runtime profiles | Creates a function with which the profile administration can be opened, a profile can be created or loaded in the Runtime More in chapter: Runtime profiles
Move frame to foreground | With this function, screens that are covered by other screens in Runtime can be moved to the foreground. More in chapter: Move frame to foreground
Close frame | This function closes the currently open screen of a selected frame. More in chapter: Close frame
Print screenshot | This function prints out a screenshot of the whole monitor or frames in Runtime. More in chapter: Print screenshot
Setpoint input for keyboard screen | This function sets a predefined value or writes a predefined value in the keyboard screen type. More in chapter: Setpoint input for screen keyboard
Show overview window | This function opens an overview window. With this you can simulate a multi-monitor system on a one-monitor system. More in chapter: Show overview window


Fault locating in electric grids

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> Fault locating in electric grids

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Contains functions for the fault locating in electric grids.

Function | Description
Acknowledge ground fault message | Function for acknowledging an earth fault message. Opens the dialog for selecting a variable. More in chapter: Acknowledge ground fault message
Stop search for ground fault | Function for closing the search for earth fault. More in chapter: Stop search for ground fault
Start search for ground fault | Function for starting the search for earth fault. More in chapter: Start search for ground fault
Acknowledge ground fault message | Function for acknowledging a short-circuit message. Opens the dialog for selecting a variable. More in chapter: Acknowledge short-circuit message


Message Control

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> Message Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This group contains functions for the optional module Message Control.

Function | Description
Save current queue | In the Runtime saves the current message queue. More in chapter: Save current queue
Group/class/area/equipment suppressed | Makes it possible to suppress the sending of messages for certain alarms. More in chapter: Suppress groups/classes/areas/equipment:
Send a Message | Creates a function for sending messages. More in chapter: Send a Message
Send Message: activate | Activates Message Control in the Runtime for the activated project. More in chapter: Send Message: activate
Send Message: deactivate | Deactivates Message Control in the Runtime for the activated project. More in chapter: Send Message: deactivate


Network

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> Network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This group contains functions for the handling of a Network.

Function

Description

Authorization in the network

This function fetches or releases the authorization in a network.

More in chapter: Authorization in network

Redundancy switch

This function exchanges the Primary Server and the Standby Server of the project.

The configuration dialog is slightly different, depending on the selected Redundancy mode:

  • Rated
  • Not dominant

Note: With Redundancy mode not dominant, no additional configuration is necessary.

Note: Not available if the CE terminal serves as a data server. You can find further information in the zenon Operator manual in the CE terminal as a data server chapter.

More in chapter: Redundancy switch


Report Generator / Report Viewer / Analyzer

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> Report Generator / Report Viewer / Analyzer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This group contains functions for:

  • Report Generator
  • Report Viewer
  • zenon Analyzer
Function | Description
Analyzer: Create report | Event-controlled report creation makes it possible to use an event as a trigger for the creation and dispatch of a report in the COPA-DATA product zenon Analyzer; a value change for example. More in chapter: zenon Analyzer
Report Generator: execute | This function executes a selected report of the optional module Report Generator. More in chapter: Report: execute
Print Report Generator | This function prints a selected report of the optional module Report Generator. More in chapter: Print report
Export Report Generator | This function exports a selected report of the optional module Report Generator to an external format. More in chapter: Export Report
Report Viewer: export / print | Makes it possible to issue reports in Runtime as a PDF or online print. More in chapter: Export or print report.


zenon Analyzer

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> Report Generator / Report Viewer / Analyzer -> zenon Analyzer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon provides functions that make the exchange of data with the COPA-DATA product zenon Analyzer more easy.

Event-driven report creation

Event-triggered report creation makes it possible to use an event - such as a change of value, for instance - as a trigger for the creation and sending of a report. These reports can be created by means of a zenon function.

Other topics in this chapter

Create an Analyzer report using the zenon function

General settings

Parameter List

Configuration of the values


Create an Analyzer report using the zenon function

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> Report Generator / Report Viewer / Analyzer -> zenon Analyzer -> Create an Analyzer report using the zenon function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Create an Analyzer report using the zenon function

Requirements

In order for you to be able to create an event-triggered report for the zenon Analyzer via the zenon Analyzer: Create report function, the following requirements must be met:

  • zenon version 7.20 or higher
  • Connection with corresponding rights to an Analyzer server version 2 or higher
  • Analyzer Server Wrapper must be installed. Installation is carried out by means of a selection item in the zenon setup.
  • Runtime and Editor must both be restarted after installation of the Analyzer Server Wrapper, so that they can find the installed Analyzer Server Wrapper DLLs.
  • Recommendation: In order to be sure that the Windows authentication works, the Analyzer server should be in the same domain as zenon Editor and zenon Runtime.

Problem solution

  • Communication problems with the Analyzer server: Check the communication in the network as well as the authentication (user and access rights).
  • Reports are rendered but do not contain any data: Check the license of the Analyzer server:

Creating a function

To create the function:

  1. Create a new function.
  2. Navigate to the Report Generator / Report Viewer / Analyzer group in the selection dialog.

  3. Select the Analyzer: Create Report function.
  4. The dialog for configuration is opened:
  5. Configure, in the General settings tab, the connection parameters and select the desired report.

    Attention: Before a switch is made to the second tab, a connection must be made and a report must be selected!

  6. Configure the report parameters in the Parameter list tab.
    When switching to the second tab, an attempt is made to set values that already exist for the parameter input. If this is not successful, the list of set parameter values is displayed as empty.

    Default values can be replaced by individual values. To do this, deactivate the checkbox in front of the value and click on the value. A dialog to enter the new value is opened

  7. Connect the function with a button or an event in order to be able to access it in Runtime

Procedure in Runtime

Procedure when triggering the function to create a report in Runtime:

  1. The configured connection is established.
  2. The selected report is set.
  3. The selected parameter values are set for this report.
  4. The report is created and output in the desired form.
  5. The file name is generated and the file is saved in the export folder of the project.
  6. The complete file name is written to the selected variable.


General settings

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> Report Generator / Report Viewer / Analyzer -> zenon Analyzer -> General settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
General settings

In this tab, the connection to the Analyzer server is configured and selected in the report. This tab must be configured before the switch to parameter list.

General settings tab

Analyzer Server

Parameters

Description

Analyzer Server

Configuration of the connection to the Analyzer server.

Version

Select the version of the Analyzer server from the drop-down list. Only available if there is no connection.

Computer name

Entry of the name of the computer on which the Analyzer server runs. Only available if there is no connection.

Use Windows authentication

Selection of the type of authentication:

  • Active: Windows authentication is used.
  • Inactive: The user must enter the user name and password.

User name

Entry of the user name.

Only available if Use Windows authentication is inactive and there is no connection.

Password

Entry of the password for authentication.

The characters entered are not shown and the length of the password is hidden. The password is saved in encrypted form and is only decrypted to establish a connection.

Only available if Use Windows authentication is inactive and there is no connection.

Connect

Clicking on the button establishes a connection to the analyzer server.

Once the connection has been successfully established, the drop-down lists for report and format are updated.

Close connection

Clicking on the button disconnects the existing connection.

Report creation

Parameters

Description

Report creation

Configuration of the basis data for the report.

Report

Selection of the report from a drop-down list.

Format

Selection of the output format from a drop-down list:

  • CSV
  • Excel
  • MHTML (Web Archive)
  • PDF
  • TIFF file
  • Word
  • XML file with report data

Include time stamp in file name
  • Active: The execution time stamp is included in the file name.

Sequence of file name creation:

  • The report name without a path is the starting point.
    Example: Alarms
  • The time stamp is then added if activated. Example on 15/8/2014 at 15:20:00: Alarms_2014_08_15_15_20_00
  • The file name extension is then added according to the selected output format.
    Example: Alarms_2014_08_15_15_20_00.pdf
  • If there is already a file with this name in the export folder of the project, a counter is added until the file name is unique.
    Example:
    Alarms_2014_08_15_15_20_00.pdf
    Alarms_2014_08_15_15_20_00 (2).pdf
    Alarms_2014_08_15_15_20_00 (3).pdf

Variable for path to file created

Shows the currently-selected zenon variable that contains the path to the written report file.

Click on button ... in order to open the dialog for selecting a variable.

Hint: An event-triggered report can thus be‑sent from zenon via a script or email when a lot archive is closed or when a limit has been breached In doing so, this variable is used to define the attachment of the Message Control function Send a Message.
Procedure:

  • Firstly, the report function that writes the variable is executed.
  • Then the Send a Message function is executed, which reads the attachment path from the variables.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Parameter List

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> Report Generator / Report Viewer / Analyzer -> zenon Analyzer -> Parameter List

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Parameter List

You configure the report parameters in this tab. The controls that are offered depend on the selection of the report in the General settings tab.

Parameter list tab

Parameters

Description

Parameter List

Display of the report parameters. The sequence corresponds to the sequence in the report.

Recommendation: Configure the parameters from top to bottom.

Parameter Name

Display of the parameter name.
Cannot be configured here.

Standard

Defines whether the parameter is set to its default value.

  • Active: The default value from the report is used.
  • Inactive: The value is selected individually by clicking in the Value column.

Clicking with the mouse or pressing the empty button with the parameter highlighted switches the checkbox. If a parameter has a default value, the checkbox is grayed out and inactive.

Value

Display of the current value of the parameter.

  • If the Standard checkbox is activated, the text default value is displayed here and the cell does not allow any input.
  • If the Standard checkbox is deactivated, the currently-configured value is shown here.
    Clicking on the cell or pressing the Enter key with the parameter highlighted opens the input dialog for the respective value.

If a parameter cannot be entered, the text not available is displayed and the cell is deactivated. This can mean, for example, that values for a different parameter must be set first in order to fill the list of values.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

Tip for lot/shift reports

In Runtime, the value of a zenon string variable is read. A search for this string as a label is carried out in the list of predefined values for the parameter. The value of the label to be corresponded to is then the parameter value, i.e. the selected shift or lot.

The lot variables of a lot archive can be used here. For the lot report, carry out the Analyzer: Create report function when closing the lot archive. The report then has the last lot of this archive as a time filter.


Configuration of the values

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> Report Generator / Report Viewer / Analyzer -> zenon Analyzer -> Configuration of the values

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Configuration of the values

For the configuration of the parameter values, there are appropriate dialogs available for each input. The configuration is carried out depending on the input possibility for:

  • A value without a predefined value: Entry of the value.
  • Several values without predefined values: Entry of the values and adding to a list.
  • A value with predefined value: Selection from drop-down list or list.
  • Several values with pre-defined values: Select from list.

The dialogs that are offered depend on the report selection:

Examples of frequently-used dialogs:

Equipment Groups

Selection of desired equipment groups:

  1. Select the desired equipment groups in the top list.
  2. Click on Add.
    The selected groups are added to the lower list.
  3. If you want to remove equipment groups again, highlight these in the lower list and click on Remove.
  4. To transfer all selected equipment groups to the report, click on OK.

Archives

  1. Select the desired archive in the the upper list.
  2. Click on Add.
    the selected archives are added to the lower list.
  3. If you want to remove archives again, highlight these in the lower list and click on Remove.
  4. To transfer all selected archives groups to the report, click on OK.

Compression

  1. Select the desired compression from the drop-down list
  2. Click on OK.

  1. Select the desired compression function from the drop-down list.
  2. Click on OK.

Maximum value

  1. Enter the desired value into the field.
  2. Click on OK.

Minimum value

  1. Enter the desired value into the field.
  2. Click on OK.

Projects

  1. Select the desired project in the upper list.
  2. Click on Add.
    the selected projects are added to the lower list.
  3. If you want to remove projects again, highlight these in the lower list and click on Remove.
  4. To transfer all selected projects to the report, click on OK.

Variables

Selection of the desired variables.

  1. Select the desired variables in the upper list.
  2. Click on Add.
    The selected variables are added to the lower list.
  3. If you want to remove variables, highlight these in the lower list and click on Remove.
  4. To transfer all selected variables to the report, click on OK.

Time span

  1. Select the desired date and the time for
    1. From
    2. To
  2. Click on OK.


Recipes

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> Recipes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This group contains functions for the handling of Standard Recipes and recipes of the optional module Recipegroup Manager.

Function | Description
Recipegroup Manager | This function writes, reads, copies, imports or exports a selected recipe of the optional module Recipegroup Manager (RGM). Optionally, a dialog for the user can be opened before that. More in chapter: Recipegroup Manager
Standard Recipe | This function writes, reads, copies, imports or exports a selected standard recipe. Optionally, a dialog for the user can be opened before that. More in chapter: Standard recipe
Standard Recipe single directly | This function sends the values of a selected standard recipe to the PLC. More in chapter: Standard Recipe single directly
Standard Recipe single with dialog | This function opens a dialog, where the user can change and execute a standard recipe. More in chapter: Standard Recipe single with dialog
Standard Recipe single with online dialog | This function opens a dialog, where the user can select and execute and/or edit a standard recipe. More in chapter: Standard Recipe single with online dialog


Script

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> Script

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This group contains functions for the handling of Scripts.

Function | Description
Script: execute | This function executes a selected script. More in chapter: Script: execute
Script: select online | This function opens a dialog in which the user can select and execute a script. More in chapter: Script: select online


Variable

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> Variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This group contains functions for the handling of Variables.

Function | Description
Export data | This function exports values of selected variables saved on the hard disk (*.HDD) to an external format. More in chapter: Export data
Read dBase file | This function reads a selected dBase file and executes it as a recipe. More in chapter: Read dBase file
Print current values | This function prints current values of selected variables. More in chapter: Print current values
Unit conversion | Switches from basic unit to conversion unit. More in chapter: Unit conversion
HD administration inactive | This function switches hard disk data storage off. HDD files are not written. More in chapter: HD administration inactive
HD administration active | This function switches hard disk data storage on. HDD files are written. More in chapter: HD administration active
HD administration inactive/active | This function switches hard disk data storage on or off. HDD files are (not) written. More in chapter: HD administration inactive/active
Write set value | This function sends a new value for a selected variable to the PLC. More in chapter: Write set value
Driver Commands | This function sends a selected command to a selected driver. Optionally, a dialog for the user can be opened before that. More in chapter: Driver Commands
Transfer driver simulation image to the Standby Server | Is only carried out at the Standby Standby Server. Demands an image for the selected drivers from the server when it is executed. The driver has 5 seconds of time for this. More in chapter: Transfer driver simulation image to the standby
Write time to variable | This function reads the system time of the operating system and writes it to a string variable in the PLC. This way, the system time of the PLC can be synchronized with the operating system. More in chapter: Write time to variable
Read time from variable | This function reads the time from a string variable of the PLC and sets the system time of the operating system accordingly. This way, the system time of the PLC can be synchronized with the operating system. More in chapter: Read time from variable


VBA

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> VBA

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This group contains functions for the handling of VBA macros.

Function | Description
Open PCE editor | This function opens the editor of the optional module Process Control Engine (PCE). More in chapter: Open PCE editor
Open VBA editor | This function opens the VBA editor. More in chapter: Open VBA Editor
Execute VBA macro | This function executes a selected VBA macro. Attention: The VBA Event project inactive is carried out by script AUTO_END_xxx. Therefore the zenon function Execute VBA macro is no longer executed in scripts as VBA is not running at this time. VBA macros which should be carried out in "AUTOEND" must be called via Project.Inactive. More in chapter: Execute VBA macro
Show VBA macro dialog | This function opens the VBA macro dialog. More in chapter: Show VBA macro dialog


VSTA

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> VSTA

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This group contains functions for the handling of VSTA.

Function | Description
Open VSTA editor | This function opens the VSTA editor. More in chapter: Open VSTA Editor
Execute VSTA macro | This function executes a selected VSTA macro. More in chapter: Execute VSTA macro
Show VSTA macro dialog | This function opens the VSTA macro dialog. More in chapter: Show VSTA macro dialog


Windows

Manual -> Functions and scripts -> Functions -> Overview functions in zenon -> Windows

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This group contains functions for the handling of operating system functionality.

Function | Description
Play audio file | This function plays a selected audio file (*.wav) once. More in chapter: Play audio file
File operations | This function copies, deletes or moves selected files. Optionally, a dialog for the user can be opened before that. More in chapter: File operations
Start continuous tone | This function plays a selected audio file (*.wav) continuously. More in chapter: Start continuous tone
Stop continuous tone | This function stops the continuous playing of a audio file (*.wav). More in chapter: Stop continuous tone
Window to the background | This function switches the zenon Runtime to the background. More in chapter: Window to the background
Window to foreground | This function switches the zenon Runtime to the foreground. More in chapter: Window to foreground
Print screenshot | This function prints either the current screen or the currently open screen of a selected frame. Optionally the print-out can be routed to a fax. More in chapter: Print screenshot
Start program | This function starts an external program. Transfer parameters can be defined. Optionally, a dialog for the user can be opened before that. More in chapter: Start program


Engineering in the Editor

Manual -> Functions and scripts -> Functions -> Engineering in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can configure functions in Runtime in the zenon Editor.


Creating and editing functions

Manual -> Functions and scripts -> Functions -> Engineering in the Editor -> Creating and editing functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Creating a new function:

In the context menu of the entry Functions in the Project Manager the following commands are available:

Parameters | Description
Function new ... | A new function is created and can be defined in the properties window.
Script new | A new Script (bundle of functions) is created.
Export XML all... | Export all functions to an XML file See chapter Import/Export.
Import XML ... | Import functions from an XML file. See chapter Import/Export.
Open in new window... | Opens the detailview of the functions in a new window.
Profile | See chapter Profiles.


Selecting a function

Manual -> Functions and scripts -> Functions -> Engineering in the Editor -> Selecting a function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to create a new function, select the entry New function. The function selection dialog opens. If a function is selected, you will find a dialog help in the lower part of the dialog. There the selected function is explained. You will find more information in the chapter Overview functions.

A function is created after you have selected it and confirmed with OK. The parameters of this new function can now be defined in the properties window.

If you press the 'Help' button after the selection, you will be forwarded directly to the corresponding function in the online help.

Similar to the properties window also here an individually definable favourite view is available. The section 'Favourites' is always at the top of the list. As a default it contains the functions 'Screen switch' and 'Send value to hardware'. Any function can be added to or removed from the favourites with the context menu or by Drag&Drop.

If a function is selected, you will find a dialog help in the lower part of the dialog. You will find more information on the single functions in the chapter Overview functions.


Deleting functions

Manual -> Functions and scripts -> Functions -> Engineering in the Editor -> Deleting functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to delete a function, the function has to be selected in the detail view and deleted with the DEL key.


Inserting functions from other projects

Manual -> Functions and scripts -> Functions -> Engineering in the Editor -> Inserting functions from other projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

It is possible to insert functions from other projects of the same workspace.

This is possible for screens (Screen Start-end Function, Buttons), limits, time control, scheduler, scripts, menus, projects (automatic function execution, archive).


System functions

Manual -> Functions and scripts -> Functions -> System functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

System functions are not limited to one module. They have an effect on the complete zenon project configuration and control computer settings such as the selection of a printer for example.


Application - functions

Manual -> Functions and scripts -> Functions -> System functions -> Application - functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

General zenon functions

Parameters | Description
Select printer | This function opens a dialog in which the user can select printers for the different print tasks. Note: This function is not available for all CE devices.
Start Load Management |
Stop Load Management |
Print Extended Trend diagram | With the help of this function, you can print Extended Trend diagrams or save them in a file (JPG, BMP or SVG) without opening the Extended Trend screen.
Switch palette | Creates a function in order to switch between palettes in the Runtime.
Functions active at limit | This function activates the function administration. Automatically executed functions (e.g. via time control, limit violation, etc.) are executed.
Functions active/inactive at limit | This function switches the function administration on or off. Automatically executed functions (e.g. via time control, limit violation, etc.) are (not) executed.
Functions inactive at limit | This function switches the function administration off. Automatically executed functions (e.g. via time control, limit violation, etc.) are not executed.
Open help | This function opens a selected help page from a CHM file.
Reload project online | This function reloads amended Runtime files in the Editor.
Simulate right click | This function interprets the next mouse click as a right click.
Save remanent data | Allows to the save the data of the configured modules. The choices are: AML ring buffer, CEL ring buffer, system driver and mathematics driver, internal driver, remanent images of all drivers and locking of the Command Processing.
Exit Runtime | This function ends the Runtime of the control system.
Execute SAP function | Carries out an SAP function defined in the SAP interface in the Runtime. The SAP function in turn triggers a remote function call (RFC) in the SAP system.
Language switch | This function switches to a selected language in multi-lingual projects.


Select printer

Manual -> Functions and scripts -> Functions -> System functions -> Application - functions -> Select printer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The printers for the different lists are generally defined in the Standard Configuration.

This function is used to change the printer selection during online operation. This function needs no parameters.

The settings of the printers are done as described in the chapter Configuration/Standard/Printer.


Functions active at limit

Manual -> Functions and scripts -> Functions -> System functions -> Application - functions -> Functions active at limit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function you activate the administration of the limit functions in the Runtime.


Functions inactive at limit

Manual -> Functions and scripts -> Functions -> System functions -> Application - functions -> Functions inactive at limit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function you deactivate the administration of the limit functions in the Runtime.


Function active/inactive at limit

Manual -> Functions and scripts -> Functions -> System functions -> Application - functions -> Function active/inactive at limit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function you can switch limit functions between states 0 and 1 in the Runtime. The status stored in the zenon6.ini file will be loaded when the Runtime is started:

[FUNKTIONEN]

ON=0 -> inactive

ON=1 -> active


Reload project online

Manual -> Functions and scripts -> Functions -> System functions -> Application - functions -> Reload project online

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function loads changed Runtime files, without having to restart the Runtime.

info Information

If the names of the server or Standby Server are changed in the Editor, these cannot be loaded subsequently. They are only updated by restarting Runtime.

attention Attention

PNG graphics files cannot be overwritten if they are currently being displayed in Runtime.

Background: The Runtime protects opened .png files against overwriting.

Solution: Before Remote Transport is instigated, it must be ensured that screens with *.png files:

  • Are not called up in Runtime
  • Are not being used by another program

This also applies for the reloading of amended Runtime files. The Runtime sync in the network does not work for a *.png screen if this is switched on a zenon computer that is involved in the process (standby server, client).


Exit program

Manual -> Functions and scripts -> Functions -> System functions -> Application - functions -> Exit program

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function is used to exit th Runtime in a defined way (logging in CEL, close the archives, execute the AUTOEND script etc.).

No transfer parameters are needed.

attention Attention
  • The VBA Event project inactive is carried out by script AUTO_END_xxx. Therefore the zenon function Execute VBA macro is no longer executed in scripts as VBA is not running at this time. VBA macros which should be carried out in "AUTO_END" must be called via Project.Inactive.
  • Cyclical archives must not be given in the AUTOEND script.


Simulate right click

Manual -> Functions and scripts -> Functions -> System functions -> Application - functions -> Simulate right click

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

After executing this function in the Runtime the next mouse click or the next touch on the touchscreen is interpreted as a click with the right mouse button.

With this function it is possible to use context menus also on touchscreens.

No transfer parameters are needed.


Save remanent data

Manual -> Functions and scripts -> Functions -> System functions -> Application - functions -> Save remanent data

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Function Save remanent data makes it possible to save remanent data at any time in the Runtime. The function can be imported and exported. In order to configure the function:

  1. select New Function
  2. navigate to node Applications
  3. select Save remanent data
  4. the dialog for the selection of the modules opens.

Module | Description
AML ringbuffer | Active: AML ring buffer is saved.
CEL ringbuffer | Active: CEL ring buffer is saved.
System driver and mathematics driver | Active: Data of the system driver and of the mathematics driver are saved.
Internal driver | Active: Data of the internal driver are saved.
Remanent images of all drivers | Active: Data of all drivers are saved.
Locking of the Command Processing | Active: Data of the locking of the command processing are saved.

If errors occur during the saving process, they are written to the error protocol.

info Information

If the Runtime runs in simulation mode (project simulation active), function Save remanent datadoes not save values from the following drivers:

  • Internal driver
  • mathematics driver
  • system driver


Windows - Functions

Manual -> Functions and scripts -> Functions -> System functions -> Windows - Functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Functions that trigger something in the operating system.

Parameters | Description
Play audio file | This function plays a selected audio file (*.wav) once.
File operations | This function copies, deletes or moves selected files. Optionally, a dialog for the user can be opened before that.
Start continuous tone | This function plays a selected audio file (*.wav) continuously.
Stop continuous tone | This function stops the continuous playing of a audio file (*.wav).
Window to the background | This function switches the Runtime of the control system to the background.
Window to foreground | This function switches the zenon Runtime to the foreground. Attention: At switch to foreground the alarm status bar is overlaid.
Start program | This function starts an external program. Transfer parameters can be defined. Optionally, a dialog for the user can be opened before that.


Play audio file

Manual -> Functions and scripts -> Functions -> System functions -> Windows - Functions -> Play audio file

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function is used to play the indicated audio file (*.wav) once whenever the function is called in the Runtime. Provide the audio file as transfer parameter.


File Operations

Manual -> Functions and scripts -> Functions -> System functions -> Windows - Functions -> File Operations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function is used to perform a defined file operation during runtime (copying, moving and deleting).

Give the file operation and the file parameters as the transfer parameters. This function is configured via an input dialog.

Possible file operations:

Parameters | Description
Copy | copies files from one name and path to a new name and path. Transfer parameters are considered.
Move | Moves files from one name and path to a new name and path and deletes them in source path. Transfer parameters are considered.
delete | Delete files. Transfer parameters are considered.

If the given source cannot be found (file or path is not present or incorrect), the function will not be executed. By default, no error message is generated. You can also force an error message via the options; we do not recommend this, as this might block the runtime or the processing of other functions.

Additional options can be configured after the file operation is defined.

Parameters

Description

Source/Target

Enter the path to source and target. You can also use wild cards (*) for source and target. (Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.)
There are three ways of defining a path:

  • absolute (You can also use the button '...' next to the text field).
  • relative according to runtime folder (Link: more about the runtime folder)
  • relative according to the data folder. (Link: more about the data folder).

For example:

absolute:
Source 'C:\temp\datenbank.mdb' to target 'D:\backup\' -> The file 'database.mdb'is copied to the directory 'D:\backup\'. In order for the copying to work, the target directory must already exist and it must be followed by a backslash.

relative:
relative according to the data directory: '*.aml' to target 'D:\backup\' copies all files of the alarm list to the folder 'D:\backup\'.

Rename files:
It is possible to rename single files. For example: 'C:\temp\datenbank.mdb' to target 'D:\backup\backupdb.mdb' copies the file 'datenbank.mdb' to the directory 'D:\backup\' and renames it to 'backupdb.mdb'.

Renaming several files simultaneously with wild cards is not possible.

Consider subfolders

Looks for files also in the sub folder of the source path and creates that tree structure in the target directory.

Overwrite existing files

If the source file already exists in the destination directory, it will be overwritten by the new file.

Display error messages

If copying or moving file is not possible, an error message is displayed as system message We do not recommend to activate this option, as it may block the runtime or the processing of other functions.

Show dialog at Runtime

Before the function is executed in online operation, a dialog box is loaded, which allows to adjust parameters (file operation, source, target etc.). The modified settings remain during the runtime of the online operation. In this dialog box, the option dialog box before execution is missing.

Only execute if file(s)

File operation is executed only when time criterion was defined (days, hours).

older than

The file must be older than the entered time. '1 day' always means 24 hours after execution time.

newer than

The file must be more up to date than the entered time. '1 day' always means 24 hours after execution time.
Note: 'not older than' must be bigger than 'not younger than'.


Start continuous tone

Manual -> Functions and scripts -> Functions -> System functions -> Windows - Functions -> Start continuous tone

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

By using this function the defined audio file (*.wav) is played repeatedly in the Runtime via a function call until function Stop continuous tone is executed. Provide the audio file as transfer parameter.


Stop continuous tone

Manual -> Functions and scripts -> Functions -> System functions -> Windows - Functions -> Stop continuous tone

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function stops the repeated playing of an audio file (*.wav) which has been started via function Start continuous tone.


Window to the background

Manual -> Functions and scripts -> Functions -> System functions -> Windows - Functions -> Window to the background

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function the zenon window is switched to the background in the Runtime. The entry SYSKEY in the file project.ini is not regarded. The selection of other applications (program manager) is possible.

[DEFAULT] |
... |
SYSKEY= | 0 - system keys active
 | 1 - system keys blocked (default)

No transfer parameters are needed.


Window to foreground

Manual -> Functions and scripts -> Functions -> System functions -> Windows - Functions -> Window to foreground

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function the zenon window is switched to the foreground in the Runtime. All other applications are switched to the background (Exception: applications with the always in the foreground property). The entry SYSKEY in the file project.ini is regarded.

Entry

Meaning

[DEFAULT]

SYSKEY=

Block or activation of the system keys:

  • 0: System keys active
  • 1: System keys blocked (default)

No transfer parameters are needed.

info Information

At moving the Runtime to the foreground the Runtime window is defined as the topmost window. At this the alarm status line is covered. In order to get the alarm status line back to the foreground, you can:

  • activate the system keys (deactivate project settting Lock system keys) and get back the alarm status line via Alt+Tab to the foreground
  • activate the Windows task bar and click un window Status
  • move the Runtime back to the background
  • restart the Runtime


Start program

Manual -> Functions and scripts -> Functions -> System functions -> Windows - Functions -> Start program

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function is used to execute an external program (*.exe) from the Runtime. On executing the function transfer parameters for the application to start can be defined.

Give the program file (*.EXE) as the transfer parameter. This function is configured via an input dialog.

Configurable options are:

Parameters | Description
Name | name of file which will be executed; search and select via button is possible
Parameters | transfer parameter for program
Show this dialog in the Runtime | changes program and parameter during online operation when function is called

The program is selected via a dialog mask.

For the start of a program it has to be in a search path (system environment under Windows NT). User-defined programs (Visual Basic) should be stored in the installation path of zenon.

When the Alarm Message List is active and an alarm in the list has been selected, the call of the variables' name can be transferred as a parameter (for external database information systems). The parameter is transferred as a key word.

Parameters | Description
@alarm.name | Name of the variable
@alarm.unit | unit of the variable
@alarm.value | value, which violated a limit
@alarm.stext | limit text
@alarm.ctime | time comes (value in seconds since 1.1.1970)
@alarm.ctimemilli | with milliseconds
@alarm.gtime | Time cleared
@alarm.gtimemilli | with milliseconds
@alarm.qtime | Time acknowledged
@alarm.user | user, who quitted
@alarm.identification | Identification of the variable

If no Alarm Message List is open, or several or no alarms are selected, no transfer parameters are generated. If several Alarm Message Lists are displayed (global or selective list), the entry of the first found list is used.

When the Chronologic Event list is active and an entry in the list has been selected, the call of the variables' name can be transferred as a parameter (for external database information systems). The parameter is transferred as a key word.

Parameters | Description
@cel.name | Name of the variable
@cel.unit | unit of the variable (only if a variable is linked)
@cel.value | value, which violated a limit (only if limit entry)
@cel.stext | limit text
@cel.ctime | time comes (value in seconds since 1.1.1970)
@cel.ctimemilli | with milliseconds
@cel.user | user, who quitted
@cel.identification | Identification of the variable

If no Chronologic Event List is open, or several or no entries are selected, no transfer parameters are generated. If several Chronologic Event Lists are open (global or selective list), the entry of the first found list is used.

Additional parameters are:

@screen

screen from within which the function was executed

This function is used to to consider the effects of the started program on the system as a whole (required resources, multitasking, program stability, etc.).


Execution sequence during Runtime

Manual -> Functions and scripts -> Functions -> Execution sequence during Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The execution of functions in the Runtime is done according to a 3 priority levels:

  • Priority 1: Immediate (it is executed immediately)
  • Priority 2: High (a dialog is displayed before it is executed)
  • Priority 3: Low

If for a function with priority 1 a dialog is displayed before the function is carried out, the priority is set to 2.

Within one project all functions of one script are in the same queue. In one script all functions of the same priority level are executed. These functions are executed one after the other.

Example Example

Via a script a screen arrangement with screens of different projects is activated via function Screen Switch. This arrangement depends on the sequence of execution (screens above other screens).

Priority of the execution in the Runtime

Function groups

Functions

Priority

AML and CEL

Controlling the AML and CEL administration

  • Alarms: acknowledge flashing

1

  • Alarms: delete

1

  • Acknowledge alarms

1

  • Alarm/event group log in/log off

1

  • Alarm Message List active

1

  • Alarm Message List active/inactive

1

  • Alarm Message List inactive

1

  • Activate/deactivate Alarm Message List, alarm/event groups, alarm/event classes

1

  • Save AML and CEL memory buffer

1

  • Print AML or CEL

3

  • Export alarms

2

  • Export CEL

2

  • Create/print IPA document

1

  • Switch online printing on/off

1

  • Online printing start new page

?

  • Switch online printer

3

Application

Call applications

  • Select printer

3

  • Print extended trend diagram

1

  • Switch palette

2

  • Functions with inactive/active limit values

1

  • Functions active at limit

1

  • Functions inactive at limit

1

  • Open Help

3

  • Reload project online

1

  • Determine open maintenances

3

  • Execute PFS event

1

  • Exit program

3

  • Simulate right click

3

  • Save remanent data

1

  • Analyze S7 Graph heuristics

1

  • Switch simulation on/off

1

  • Language switch

2

Historian

control of archives

1

  • Archive: Stop

1

  • Index archive

1

  • Archive: Start

1

  • Archive: List of active archives

2

  • Export archives

1

User administration

User administration

  • Change user

3

  • Login with dialog

2

  • Login without password

2

  • Logout

2

  • Change password

2

Screens

Select and control screens

  • Change ALC source color

1

  • Screen with index

1

  • Close screen

2

  • Screen: Return to last

1

  • Screen: Move center

1

  • Screen switch

1

  • Activate input to the element with the focus

1

  • Set focus to frame

1

  • Move focus

1

  • Take focus away from frame

1

  • Show menu

1

  • Monitor assign

1

  • Runtime profiles

1

  • Close frame

1

  • Overview Window

1

Fault locating in electric grids

  • Acknowledge ground fault message

1

  • Stop search for ground fault

1

  • Start search for ground fault

1

  • Acknowledge short-circuit message

1

Message Control

sending of messages (Message Control)

  • Save current queue

1

  • Group/class/area/equipment suppressed

1

  • Send a Message

1

  • Send Message: activate

1

  • Send Message: deactivate

1

Network

Network - Functions

  • Authorization in network

1

  • Redundancy switch

1

Report Generator

Functions for reports

  • Print report

2

  • Export report

2

  • Report: execute

2

Recipes

operating recipes

  • Recipegroup Manager

2

  • Standard Recipe

2

  • Standard recipe single directly

2

  • Standard recipe single with dialog

2

  • Standard recipe single with online dialog

2

Script

Execute functional blocks (scripts)

  • Script: execute

1

  • Script: select online

2

Variable

Functions for variables

  • Export data

3

  • Read dBase file

2

  • Print current values

2

  • measuring unit conversion

2

  • HD administration active

1

  • HD administration inactive

1

  • HD administration inactive/active

1

  • Write set value

1

  • Driver Commands

2

  • Transfer driver simulation image to the standby

1

  • Write time to variable

1

  • Read time from variable

1

VBA

VBA - Functions

  • Open PCE editor

3

  • Open VBA Editor

3

  • Execute VBA macro

3

  • Show VBA macro dialog

3

VSTA

VSTA functions

  • Open VSTA editor

3

  • Execute VSTA macro

3

  • Show VSTA macro dialog

3

Windows

  • Play audio file

2

  • File operations

3

  • Start continuous tone

1

  • Stop continuous tone

1

  • Window to the background

2

  • Window to foreground

2

  • Print screenshot

2

  • Start program

2


Scripts

Manual -> Functions and scripts -> Scripts

Scripts compile several functions together in order to execute these in a sequence in Runtime. zenon also provides some pre-defined scripts.

Scripts are configured or selected using:

  • The Scripts node
  • The Select functions and scripts dialog


Context menu and tool bar for scripts

Manual -> Functions and scripts -> Scripts -> Context menu and tool bar for scripts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu Project manager

Menu item | Action
Script new | Creates a new script.
Export XML all... | Exports all entries as an XML file.
Import XML... | Imports entries from an XML file.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.

Scripts tool bar detail view

Symbol

Description

Script new

Adds a new script to the list.

Add functions

Opens the dialog for adding functions.

Use of scripts

Opens the Project analysis in the main window and displays the elements with which the selected script is used.

Show unused scripts

Opens the Project analysis in the main window and shows unused scripts.

Copy

Copies the selected script or the selected functions to the Windows clipboard.

Paste

Pastes an element that was copied to the Windows clipboard.

Delete

Deletes the selected script or removes the selected function from the script.

Expand/collapse

Allows all or selected nodes to be expanded or collapsed. Selection:

  • Expand all
  • Collapse all
  • Expand selected
  • Reduce selected

Export selected XML

Exports selected entries as an XML file.

Import XML

Imports elements from an XML file.

Edit selected cell

Renames the script. It is also possible by left-clicking the field with the mouse or by pressing F2.

Properties

Opens the Properties window for the selected entry.

Help

Opens online help.

Context menu selected script

Parameters

Description

Add functions

Opens the dialog for adding functions.

Script new

Adds a new script to the list.

Create standard function

Automatically creates a standard function for the selected script.

Use of scripts

Opens the project analysis in the main window and displays the elements with which the selected script is used.

Show unused scripts

Opens the project analysis in the main window and shows unused scripts.

Copy

Copies the selected script or the selected functions to the Windows clipboard.

Paste

Pastes an element that was copied to the Windows clipboard.

Delete

Deletes the selected script or removes the selected function from the script.

Expand/collapse node

Allows all or selected nodes to be expanded or collapsed. Selection:

  • Expand all
  • Collapse all
  • Expand selected
  • Reduce selected

Export selected XML

Exports selected entries as an XML file.

Import XML

Imports elements from an XML file.

Edit selected cell

Renames the script. It is also possible by left-clicking the field with the mouse or by pressing F2.

Properties

Opens the Properties window for the selected entry.

Help

Opens online help.


Engineering in the Editor

Manual -> Functions and scripts -> Scripts -> Engineering in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure or edit scripts, click on the Scripts node and select the desired action in the tool bar or in the context menu.

info Information

When you change the script name, the parameters of the linked functions are changed accordingly. With multi-user projects, functions are changed automatically after requesting confirmation (Allow changes). After the name has been changed successfully, the script is changed.

Configuring a script

To configure a new script:

  1. Select New symbol in the context menu or in the tool bar.
  2. A new script is added to the list.
  3. Issue a name or select a pre-defined script from the drop-down list.
  4. Add functions and sort them.
    Functions are executed in the sequence of the project configuration.
  5. Create a function to start the script in Runtime.

Add functions and place them in sequence

You can add new functions to a script using a command or add or change the sequence of previously-linked functions by dragging & dropping.

Function new

To add a function to a script using a command:

  1. Select Add functions in the context menu or in the tool bar.
  2. The dialog to select one or several functions is opened.
  3. Select the desired functions and close the dialog by clicking OK
  4. The functions are added to the end of the list of pre-existing functions.

Drag & drop actions

To add a function to a script by dragging & dropping:

  1. Select the desired function from the a script.
  2. Move the function to the desired position:
    • Within the source script: The sequence of the function is changed.
      Hint: If the Shift key is held when dragging & dropping, the function is copied.
    • In a different script: The function is copied to the target script.
      If the node of the script is closed, the function is added at the end.
      If the node is opened, the function is inserted at the displayed location.
      Hint: If the Shift key is held when dragging & dropping, the function is deleted in the source script.


Pre-defined scripts

Manual -> Functions and scripts -> Scripts -> Pre-defined scripts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon provides a range of pre-defined scripts. The action of this script in Runtime is pre-defined. The functions to be executed must be configured individually.

Script

Description

AUTOSTART

The start information (e.g. open headings and status lines, reset alarm outputs etc.) is configured in the script.

The script will be executed automatically at the start of Runtime when the start screen is called up if the project is the Runtime start project. The script is not executed, if the project is not defined as the start project or if it is a sub-project in a multi-hierarchical network.

Attention: The start screen must not be executed in the AUTOSTART script because it is defined via the project property Start screen.

For switching to a partial screens that belongs to a main screen, such as screen-specific menus etc., a separate script is defined. This ensures that on selection of the screen via the Screen switch function, selection from the screen catalog or the Return to last screen function, all detail screens are always opened with it.

AUTOEND

The defined end functions are configured in the script.

The script is executed automatically when Runtime is ended if the project is the Runtime start project. The script is not executed, if the project is not defined as the start project or if it is a sub-project in a multi-hierarchical network.

Attention:

  • The VBA Event Project.Inactive is executed by the AUTOEND_xxx script. Therefore the zenon function Execute VBA macro is no longer executed in scripts as VBA is not running at this time. VBA macros which should be carried out in AUTOEND must be called via Project.Inactive.
  • Cyclical archives must not be included in the AUTOEND script.

AUTOSTART_CLIENT

The start information (e.g. open headings and status lines, reset alarm outputs etc.) is configured in the script. The script will be executed automatically at start of the Runtime on a client and before activation of start display on a client if the project is the Runtime start project.

AUTOEND_CLIENT

The defined end functions are configured in the script.

The script will be executed automatically at the end of Runtime on a client if the project is the Runtime start project.

AUTOSTART_SRVPRJ

Script will be executed automatically at the start of Runtime operation on the computer that is the server for the project, before opening the start screen, regardless of whether the project has been defined as the start project or whether it is a sub-project in a multi-hierarchical network.

AUTOEND_SRVPRJ

Script will be executed automatically at the end of Runtime operation on the computer that is the server for the project, regardless of whether the project has been defined as the start project or whether it is a sub-project in a multi-hierarchical network.

The following scripts are available for simulation mode; they are executed automatically:

Script | Description
AUTOSTART_SIMUL | If Runtime is started in simulation mode, the script with the name AUTOSTART_SIMUL is executed automatically if it is available.
AUTOEND_SIMUL | If Runtime is ended in simulation mode, the script with the name AUTOEND_SIMUL is executed automatically if it is available.


Executing scripts in Runtime

Manual -> Functions and scripts -> Scripts -> Executing scripts in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Scripts can be started in Runtime by means of functions: zenon provides two functions for this:

  • Script: Execute Executes a script that was pre-defined in the Editor in Runtime.
  • Script: Select online Allows selection of the script to be executed in Runtime.

To configure a function to execute a script:

  1. Select the New function command in the Functions node
  2. The dialog to select the function is opened.
  3. Navigate to the Scripts node.
  4. Select the desired function:
    1. Execute script, in order to execute the script selected in this dialog directly
    2. Scripts with online selection in order to make it possible to select the script that is to be executed in Runtime.
  5. Confirm the configuration by clicking OK.

Select script dialog

Parameters | Description
List of projects (left) | Selection of the project from which the script is to be selected. Note: Ensure, when selecting scripts from a different project than the current one, that this project is also available in Runtime.
List of scripts (right) | Selection of the script. Only one script can be linked. Scripts can be created and edited using the tool bar and context menu. New scripts and changes are saved immediately. The functions of a script can be rearranged by means of Drag & Drop.
No selection | Removes a pre-existing linking and closes the dialog.
OK | Applies settings and closes the dialog. With Execute script, the selected script is started in Runtime when this function is executed. With Script with online selection, this dialog is opened in Runtime when this function is executed.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.

Toolbar and context menu

Symbol/Command

Description

Script new

Adds a new script to the list.

Add functions

Opens the dialog for adding functions.

Copy

Copies the selected script to the clipboard.

Paste

Pastes script from the clipboard.

Expand/collapse

Allows all or selected nodes to be expanded or collapsed. Selection:

  • Expand all
  • Collapse all
  • Expand selected
  • Reduce selected

Edit selected cell (only toolbar)

Renames the script. It is also possible by left-clicking the field with the mouse or by pressing F2.

Replace text in selected column (only toolbar)

Opens the dialog to search and replace texts in the currently-selected column.

Scripts in the network

With an active network, it is possible to use the properties in the Execution group to define the computer on which the script is executed.

info Information

Take care of the priorities of the script execution in the network


Priorities in the network

Manual -> Functions and scripts -> Scripts -> Priorities in the network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

At active network you define via proeprty node Execution for scripts where the script is executed:

  • Current computer
  • Client
  • Server
  • Standby

This execution location is true for functions contained in the script. Function which had a different execution location assigned, take over the execution location defined here.

Example 1: Current computer

  • Function 1 was defined with execution location Server.
  • Function 2 was defined with execution location Client.
  • For function Execute script the current computer was defined.
  • Consequence: Both functions are carried out on the same computer; the computer in which fucntion Execute scripts is executed. This can be a Client, a Server or a Standby.

Example 2: Client versus Server

  • The script contains 2 functions with execution location Client.
  • For function Execute script Server was defined.
  • Consequence: Both scripts are executed on the Server no matter on which computer Execute script was started.

Example 3: Driver commands:

Driver commands are executed on the Server and the Standby per default. If a script with driver commands is started on the Client, then:

  • the function driver command is started on the Client
  • the driver is stopped after the execution of the script on the Server


Select Functions and scripts dialog

Manual -> Functions and scripts -> Select Functions and scripts dialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Individual functions and scripts can be configured for many functions in dialogs, properties and dynamic elements by means of a specific dialog. Several functions are configured in their own dialogs.
The dialog to select functions and scripts is called up for:

  • Archive configuration / tab for Runtime: Execute function for archive start or archive end
  • Combo box/list box: each element that has its own functions
  • Dialogs: all properties with functions
  • Dynamic elements: all properties with functions and double click on a dynamic element
  • Reaction matrices: Function
  • Replace links: Replace function dialog
  • WPF: Event properties

The dialog offers the possibility to select functions and to configure scripts:

  • Functions selection: Selection of a function or creation of a new function
  • Script selection: Selection of a script or creation of a new script as well as assignment of a function Script: execute


Functions selection

Manual -> Functions and scripts -> Select Functions and scripts dialog -> Functions selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Selection ands configuration of functions that are to be linked.

To select a function:

  1. Select the project that contains the function.

    Note: If a different project than the current one is selected, ensure that the project is available in Runtime.

  2. Select the desired function.
    If necessary, it is possible to use the tool bar or context menu to create new functions or copy existing functions.
  3. Confirm the selection by clicking OK.

Function selection dialog

Parameters

Description

List of projects (left)

Selection of the project from which the function is to be selected.

Note: Ensure, when selecting functions from a different project than the current one, that this project is also available in Runtime.

List of functions (right)

Selection of the function. Only one function can be linked. If more than one function is selected, then the function that was selected last was linked.

Functions can be created and edited using the tool bar and context menu. New functions and changes are saved immediately.

OK

Applies the selected function and closes the dialog.

Cancel

Closes the dialog without linking a function.

Help

Opens help

No selection

Removes a pre-existing linking and closes the dialog.

Toolbar and context menu

Symbol/Command | Description
Function new | Adds a new function to the list.
Copy | Copies the selected function to the clipboard.
Paste | Pastes a function from the clipboard.


Script selection

Manual -> Functions and scripts -> Select Functions and scripts dialog -> Script selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Selection and configuration of scripts that are to be linked, as well as assignment of the Script: execute function.

To select a script:

  1. Select the project that contains the script.

    Note: If a different project than the current one is selected, ensure that the project is available in Runtime.

  2. Select the desired script.
  3. Edit the script if required.
    You can use the commands of the context menu or tool bar to create new scripts, add functions and copy or rename scripts.
  4. Confirm the selection by clicking OK.

Script selection dialog

Parameters | Description
List of projects (left) | Selection of the project from which the script is to be selected. Note: Ensure, when selecting scripts from a different project than the current one, that this project is also available in Runtime.
List of scripts (right) | Selection of the script. Only one script can be linked. Scripts can be created and edited using the tool bar and context menu. New scripts and changes are saved immediately. The functions of a script can be rearranged by means of Drag & Drop.
Function: Script: execute | Selection of the function that is to execute the selected script from a combo box. The combo box contains, in a drop-down list, all functions that have already been defined that can execute the selected script. The name for a new function to execute the script can be entered in the input field.
OK | Accepts the selected or newly-issued name for the Script: execute function, links the selected script and closes the dialog.
Cancel | Closes the dialog without linking a script.
Help | Opens help
No selection | Removes a pre-existing linking and closes the dialog.

Toolbar and context menu

Symbol/Command

Description

Script new

Adds a new script to the list.

Add functions

Opens the dialog for adding functions.

Copy

Copies the selected script to the clipboard.

Paste

Pastes script from the clipboard.

Expand/collapse

Allows all or selected nodes to be expanded or collapsed. Selection:

  • Expand all
  • Collapse all
  • Expand selected
  • Reduce selected

Edit selected cell (only toolbar)

Renames the script. It is also possible by left-clicking the field with the mouse or by pressing F2.

Replace text in selected column (only toolbar)

Opens the dialog to search and replace texts in the currently-selected column.


Historian

Manual -> Historian

In zenon, the Historian takes on the saving of process data as well as the export of the archived data. The data is thus available for subsequent processing and evaluation - even outside of zenon.

The module Historian is available in zenon in two versions:

  • Archivserver Starter Edition: function-limited base version
  • Historian licensed version

tutorial License information

Must be licensed for Editor and Runtime (standalone, server, standby).

Note: The function-limited Archivserver Starter Edition is already included in the standard license.

You will find the Historian in the Project Manager.

In zenon, you can evaluate archive data and further process it with:

  • Archive revision screen
  • Extended Trend
  • Report Generator
  • Report Viewer
  • zenon Analyzer


General information

Manual -> Historian -> General information

Archiving is carried out with different methods and with different types of recording.

To use archiving:

  • Create archives and aggregated archives in the Editor.
  • Call up archives in Runtime by means of an archive revision screen.
  • Save the archive data in different formats.
  • Evaluate archive data with other modules such as Extended Trend, Report Generator, Report Viewer and zenon Analyzer.

Time

Archive use local time when saved. The local time that is shown on the computer consists of: UTC + time zone + standard time/daylight saving time. The zenon Runtime automatically considers the local time for archive requests.

Detailed information

You can find detailed information on formats, time and RDA types in the Further information section.


Historian licensed version

Manual -> Historian -> General information -> Historian licensed version

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Historian Starter Edition on the PC can be upgraded to the full Historian version at any time, without compatibility problems (license extension).

  • If the Historian is licensed, all Historian functionality is available.
  • Historian Starter Edition is available in combination with Extended Trend Starter Edition for Windows CE 6.0 Runtime (data export in CE only available in CSV format).

Included with the licensed version

The licensed version of the Historian has:

  • Data logging: cyclic, event-triggered, on change
  • Cascaded data aggregation (aggregated archives)
  • Lot recording
  • RDA archiving
  • SQL evacuation
  • User-defined start/stop of recording
  • Function execution when starting and closing the archive
  • Automatic data evacuation
  • Automatic creation of substitute archives
  • Data export via a function (to XML for example)
  • Manual revision of archive data

SQL evacuation

The licensed version of the Historian can be enhanced by SQL evacuation. To do this, zenon SQL Server must be licensed


Historian Starter Edition

Manual -> Historian -> General information -> Historian Starter Edition

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The standard license of the TAG-based zenon version on the PC includes the limited version of Historian as a Starter Edition.

Limitations

The Starter Edition is based on the standard Historian but has the following restrictions:

  • no RDA
  • no record on change or event triggered scanning - only cyclical recording type
  • No evacuation of the data
  • no Aggregated archive
  • no lot archiving
  • No manual revision of archive data
  • Export under CE only possible in ASCII format (this is also possible in XML and DBF format on a PC)
  • Archive data can only be saved in the ARX format

attention Attention
  • If, in the Editor, only the die Historian Starter Edition is licensed, functionalities beyond its restrictions cannot be configured.
  • If, in Runtime, only the Historian Starter Edition is licensed, archives that exceed its restrictions are not started. An entry in the diagnosis server is created.
    No save operations can be carried out by the report or archive revision.
    Example: An archive with event triggered scanning is created. It is not started in Runtime. This means that no data is recorded for the archive.

Note: For I/O licensed version, the Starter Edition is not available.


Types of archiving

Manual -> Historian -> Types of archiving

The archiving is based on the principle of cascading archives. In doing so, the desired variables are recorded in a base archive and transferred to an aggregation archive by means of an aggregation function. This process can be continued as often as desired. Archives can be created in different ways. There are up to three methods of recording available for each type of creation.

Creation

An archive can be created in different ways:

  • At start and end of Runtime:
    The archive is always active if Runtime is running.
  • User defined:
    The time period in which the archive can be written to is defined using the Archive: Start and Archive: Stop functions.
  • RDA (Real Time Data Acquisition):
    Reads archived values in the controller and saves them to a zenon archive.

Recording types

Data can be recorded in archives using different methods:

  • Cyclical:
    The values of the assigned variables are written to the archive in a defined interval. The value for milliseconds is automatically set to 0 in the time stamp.
  • Event-triggered:
    The archive is assigned a trigger variable. When the value of the trigger value is set to 1, the values of the variables are always written to the archive that was assigned in the variable selection.
  • On-change:
    The values of the assigned variables are written to the archive each time there is a value change.
    Note: In order to keep the amounts of data recored low, the configuration of a Hysteresis, especially a Negative for archive and Positive for archive, is recommended for this type of recording. For details, read the Hysteresis chapter in the Variables manual.

The type of hysteresis that is available depends on the method used to create the archive.

attention Attention

In an archive of the type On change variables are also saved on each status change.

For example: If a driver is stopped, all its variables receive the status OFF.. Therefore stopping and starting a driver causes two entries.

  1. OFF
  2. SPONT or GI (if the reconnection is successful)

This also happens when the variable value does not change.

Aggregation

The summarizing function is initiated at the ending of the save cycle. The following aggregation functions are available:

  • Sum
  • Average
  • Minimum
  • Maximum

Several aggregation archives can also be used at the same time in a project.

attention Attention

Strings cannot be compressed.

Storage

In order to keep a complete save cycle, the archive data can be saved or exported by means of a function.

Storage

Description

Database

For each archive, there are files in which the defined number of archive cycles can be kept. If the configured number of files is exceeded, files can either be discarded or exported.

File export

After closing of an archive cycle it is immediately exported to a file.

Export function

Archive export saves archives with time filters in the following standard file formats:

  • ASCII
  • dBase
  • SQL
  • XML

For this, the following applies:

  • Files can be stored locally and in the computer in the network.
  • The file names are issued independently from the system.
  • The name contains the year, month, day, hour minute and second of the export:
    YYMMDDhhmmss.XML


At start and end of Runtime

Manual -> Historian -> Types of archiving -> At start and end of Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this form of archiving, the archive is started when Runtime is started and stopped when Runtime is closed. The recording of data can be as follows:

  • cyclic
  • event-triggered
  • on change


Starting and stopping archives via functions

Manual -> Historian -> Types of archiving -> Starting and stopping archives via functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Archiving in zenon can also be controlled manually with the help of the Start archive and Close archive functions.

As long as an archive is active, values can be written to the archive. With recording via functions, the recording can be as follows:

  • cyclic
  • event-triggered
  • on change


RDA - Real time Data Acquisition

Manual -> Historian -> Types of archiving -> RDA - Real time Data Acquisition

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The RDA functionality is used in order to read values which were archived in the control and to save them in a zenon archive. The recording can be as follows:

  • On change

A typical application for this is controllers that do not permanently communicate with zenon or that are to archive many values in a short period of time.
For example: For a controller with communication in the event of a value change, values should be archived in a time period <100 ms. zenon allows a minimum of 100 ms. In this case, the values are collected from the controller and read as a block using RDA.

RDA can also be used for the postmortem analysis in the event of PLC errors, if the PLC supports this.

Configuration

To configure RDA:

  1. Define the variables in the PLC.
    • A separate, continuous, linear area has to be created in the PLC for each RDA variable.
    • The data type for the variables must not be less than that in which the PLC is organized.
    • The first variable of the area designated for the RDA in the PLC serves as a trigger for instigating the transfer process.
      This means: If this variable is set to the value 1 (or >0) by the PLC, the subsequent values (as defined in the header) are loaded and archived in zenon. Afterwards, the driver automatically resets the variable to the value 0.
  2. Define the variable in zenon.

    The values are displayed in the archive in the format of the data type of the RDA variable.
    Example: If the values are displayed as a floating-point number (REAL) in the archive, the RDA variable must have the data type REAL.

    Attention: The variable property Recording type for Harddisk data storage must be set to Postsorted values (RDA).

  3. Create the archive in zenon and select the RDA variables.
    The archive must be set as the on change recording type.

Note: You can find detailed information on RDA archiving in the RDA chapter in the Further information section.

info Information

You can find out whether your driver supports RDA in the documentation for the respective driver.

Drivers with symbolic communication do not generally support RDA. However there is a workaround for some of these drivers. You can find information on this for the respective driver and in the Notes chapter.


Archiving concept

Manual -> Historian -> Archiving concept

In principle, up to 1296 different archives can be open for each project. This number results from the possibilities for naming the short description: Two alphanumeric characters (A-Z, 0-9) result in 362 archives. You can create as many variables as you want for each archive. The number of closed and stored archives is only limited by the disk space available.

Even before the archive has been created, it is necessary to define which data is to be archived and in which granularity.

Recommendations:

  • Keep archives easily manageable and do not store large amounts of data, because:
    • Unnecessary archives create a high requirement for disk space and can place an unnecessary load on your computer in certain circumstances.
    • Archives that are too large need extra resources and time when displayed in Runtime.
  • Attempt to recognize how the data belongs together and have this influence the composition of your archive.

Basic questions

A concept should be created before the archiving is configured. The following decision is important:

  • What data should be used
    • at what intervals
    • via which driver/protocol
    • for what purpose
  • What data should be used
    • in which zenon modules or external applications

Origin of the data

The origin of the data is one of the most important points when creating an archive. In doing so, it is mostly a matter of:

  • What type of data is it?
  • How is data transferred to zenon?

Further important information for configuration:

  • Driver:
    What drivers establish the connection to the PLC?
    data can only be written to an archive as fast as the driver can provide it.
  • Granularity
    In what level of detail does the data need to be recorded?
    For example: Foe a water meter, it is usually sufficient to archive one value daily. In contrast, for a press in car manufacturing, possible value changes in the range of a few milliseconds need to be recorded.
  • Storage period:
    How long should data be available in zenon?
    The more data is archived within a certain time, the more memory requirements are increased.
  • Granularity for long-term archiving:
    For large amounts of data, it is important to plan how long this is to be present in a certain resolution. For example, is it necessary to also use the data in that level of detail years after it has been collected? Or are average values or sums over longer periods of time sufficient? In the latter case, aggregation archives are created in zenon.

Use of data

It is not just the origin of the data that plays an important role when archiving; subsequent use in zenon should also be considered.

Archive data is mostly used in trends and reports. In order to keep the storage requirement and loading times as low as possible, it is necessary to keep the data as efficiently as possible.

Note: Always encapsulate data according to its use. This means: The save cycle of the archives must be well selected. The time period of the data in a capsule should correspond to that time period of the data used in zenon.

For example: Data from the last ten minutes is to be examined in a trend. If only one capsule per archive is saved each day, the complete archive of a day must be read in order to display data for 10 minutes. The majority of the data is thus loaded for nothing. Vice versa, if the capsules are saved in intervals of one minute, 10 capsules must be opened for consideration.

In the concept of data usage, the content of the information per capsule and the number of required files must be balanced out. Frequently-used methods:

  • Conceiving archives for different purposes.
    For example, archives for long-term data storage and archives for use in trends, which is only saved for a short period of time.
  • Also compiling data that is used jointly into an archive.
    For example data for use in a trend in an archive for display in the trend. This avoids several capsules having to be loaded for different curves in a trend, which may include data that is of no significance to the trend.

Resolution of print and monitor resolution

With the use of data in Extended Trend in particular, the resolution of the screen or printing plays a decisive role. This is because the resolution limits the number of values per curve that can be meaningfully displayed. If the trend curve is displayed in an element with a width of 1,000 pixels, no more than 1,000 values per curve can be displayed.


Best Practice

Manual -> Historian -> Archiving concept -> Best Practice

The configuration of archives must primarily take in to account which data, from which time period, is needed for which purpose. In doing so, it is important to optimize the size and number of the archives. Archives that are too large could lead to computers being put under too high a load and high consumption of memory or prevent the execution of Runtime. The recording types and cycle times that are supported depend on the PLC and driver.

You can find information on effective configurations in this chapter.

Configuration for the "on change" recording type

The on change recording type saves each change. This can add up to 36,000 values per second with up to 10 values. If larger time periods need to be displayed, large archives need to be read in Runtime. All values are of all variables are always read in, even if only one variable is displayed. The maximum number of values to be read in the memory for Extended Trend, archive revision, AML, CEL and tables can be amended. The size is limited to 1 GB as standard. The size can be amended in zenon6.ini and the SPEICHER= entry.

Recommendations:

  • Find out which variables cause the most entries.
  • Configure hysteresis for fluctuating values. The number of entries is thus reduced.
  • Amend the value for SPEICHER= to your system.
  • Test how the archive files grow in size on a test system before implementing the system productively.

Configuration for display in a trend

The data that can be displayed in a trend is also limited by the physical restrictions of the screen or the print-out. If a trend diagram covers more than 1440 pixels, for example, a maximum of 1440 values can also only be displayed in theory. If 5 pixels are available for a value, this corresponds to the value every five minutes within 24 hours.

Recommendations:

  • Evaluate what data and time periods are needed in Runtime.
  • Pack the variables that are displayed together into an archive instead of dividing the archives according to variables.
  • Use aggregated archives.
  • Amend the save cycles of archives and aggregation archives to the time periods to be displayed.

    The less redundant data that needs to be read in and transferred to the network, the less effort there is for Runtime.

  • Use zoom for longer periods of time to display data from aggregation archives instead of showing all data from a base archive.
  • Index the Runtime files (Index Runtime files project property).
  • Index the lot variables (configuration of the archives).
  • With large amounts of data, deactivate the automatic updating of the display in the trend.

Configuration for reporting

Recommendations:

  • Only use the on change recording type if absolutely necessary.
    Note that the recording of each change can lead to very large amounts of data.
  • Use archives with cyclic recording.
  • Amend the recording time periods and save cycles to the periods to be displayed.


Engineering in the Editor

Manual -> Historian -> Engineering in the Editor

Archives are created and administered in the Historian module in the Editor.


Detail view

Manual -> Historian -> Engineering in the Editor -> Detail view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Archives are shown in a table in the detail view. The columns of this table are fixed and cannot be configured individually. The column width can be amended with the mouse. Incremental searching is possible in the columns.

Table columns

The following is displayed for each archive:

  • Archives
  • Start, stop
  • Start
  • Recording type
  • Evacuate
  • Lot variable
  • Number
  • estimated size

Search in the table

To search in the table:

  1. Click on the desired column heading.
  2. A symbol (binoculars) shows that a search is being carried out in this column.
  3. Type in the search term.
  4. The first appropriate entry is highlighted.


Toolbar and context menus

Manual -> Historian -> Engineering in the Editor -> Toolbar and context menus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Project tree

Context menu Historian

Menu item | Action
New archive | Opens the wizard for creating a new archive.
Export XML all | Exports all archives as an XML file.
Import XML | Imports XML files.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.

Detail view

Toolbar Historian and archives

Parameters | Description
New archive | Opens the wizard for creating an archive.
New aggregated archive | Opens the wizard to create an aggregated archive.
Edit archive | Opens the dialog for editing the selected archive.
Add variable | Opens the dialog for selecting variables.
Remove variable | Deletes a variable from the list without confirmation.
Jump back to starting element | If you entered the list via function linked elements, the symbol leads back to the start element. Only available in the context menu when all linked elements are opened.
Delete | Deletes the selected archive.
Export selected XML | Exports selected archives as an XML file.
Import XML | Imports XML files.
Rename | Makes it possible to change the name of the archive.
Help | Opens online help.

Context menu Historian

Menu item | Action
New archive | Opens the wizard for creating a new archive.
Save | Saves changed archives.
Export XML all | Exports all archives as an XML file.
Import XML | Imports XML files.
Help | Opens online help.

Context menu Archive

Menu item | Action
Edit archive | Opens the dialog for editing the selected archive.
Add variable | Opens the dialog for selecting variables.
New aggregated archive | Opens the wizard to create an aggregated archive.
Create template | Opens the dialog to create a template for aggregated archives.
Import template | Opens the dialog to import a template for aggregated archives.
Delete | Deletes the selected archive
Export selected XML | Exports selected archives as an XML file.
Import XML | Imports XML files.
Rename | Makes it possible to change the name of the archive.
Help | Opens online help.

Aggregated archive context menu

Menu item | Action
Edit archive | Opens the dialog for editing the selected archive.
Add variable | Opens the dialog for selecting variables.
New aggregated archive | Opens the wizard to create an aggregated archive.
Delete | Deletes the selected archive
Export selected XML | Exports selected archives as an XML file.
Import XML | Imports XML files.
Rename | Makes it possible to change the name of the archive.
Help | Opens online help.

Context menu variable list

Menu item | Action
Add variable | Opens the dialog for selecting variables.
Help | Opens online help.

Context menu variable

Menu item | Action
Remove variable | Deletes variable from the list. Attention: Deletion is carried out without a request for confirmation.
Help | Opens online help.


Creating a new archive

Manual -> Historian -> Engineering in the Editor -> Creating a new archive

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can create archives manually or with the help of an assistant. In order for the assistant to be able to be started, the Use assistants option in the Options/settings menu of the Editor must be activated.

To create a new archive with the assistant:

  1. Ensure that the Use assistants option has been activated.
  2. Navigate to the Historian node.
  3. Select New archive in the context menu or in the tool bar.
  4. The assistant is started. Follow the steps in the Assistant.

To create a new archive individually:

  1. Navigate to the Historian node.
  2. Select New archive in the context menu or in the tool bar.
  3. The dialog New archive is opened.
    If the assistant is started, close this using the Cancel button.
  4. Configure the archive according to the Edit archive dialog.


Assistant

Manual -> Historian -> Engineering in the Editor -> Creating a new archive -> Assistant

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The assistant supports you in the basic configuration of an archive. The assistant supports you when creating archives and aggregated archives. It allows the entry of the name and short name of the archive, and also enables you to select variables and templates and amend the settings for the recording type of variable values.

Parameters | Description
Next | Moves to the next page of the assistant.
Back | Leads you to the previous page of the assistant.
Cancel | All entered settings are lost. No archive is created.
Finish | Only available at the end of the wizard. Ends the assistant. The new archive is entered in the archive tree (detail view of the project manager).

If you want to configure the archive without the help of the wizard, click on Cancel.

If the assistant is not displayed, then:

  1. Open the Options drop-down list in the Editor
  2. Select Settings
  3. Activate, in the Settings tab, the Use wizard option

Configuration with the wizard

  1. Click on the Next button once the wizard has been started. Configuration starts by giving a name and a short description.
  2. Enter a short description (2 characters are obligatory) and a name.

    • Short name: 2 characters. Can only contain alphanumerical characters: all letters from A to Z and figures from 0 to 9, but no country-specific characters or special characters.
      Note: The short name cannot be changed later on.
    • Name: Entry of a valid name for the archive.
      The following characters are not permitted: / \ : * ? < > ! | " ' # % @
      The name can be changed later on.
  3. Click on Next.
  4. The variable selection is configured.

    1. Click on the Variable selection button.
    2. The dialog to select variables that are to be archived is opened.
    3. Select the desired variables.
  5. Click on Next.

    The template to be used for the desired aggregation structure is selected.

    Clicking on the Template Selection button opens the dialog to select a template.

    • Templates can only be imported for base archives with cyclic scanning. These archives cannot have any aggregated archives yet.
    • The dialog is only opened if at least one template is present.

    Attention: No check to see if the template contains a valid aggregation structure is carried out.

    Further sequence of the assistant:

    • Selecting a template The assistant is thus completed. Click on the Finish button.
    • No template selected: Click on Next to configure the recording type individually.
  6. Configure the type of recording if you have not selected a template in the previous step.

    Selection of recording type from drop-down list.

  7. Click on Next.

    Configure new aggregation archives if you want to.

    1. Click on New to create a new aggregation archive or on Edit to change the name of an existing archive.
    2. Assign the aggregation archive the desired aggregation types. These always apply for all aggregation archives shown in this dialog.
    3. To delete an aggregation archive, click on Remove.
  8. Close the assistant by clicking on Finish.

Possible recording types

Parameters

Description

Cyclic scanning

Set the Cycle time.

Record on change

Configure:

  • Possible saving of the process image
  • The initialization value if required

Event-triggered recording

Configure:

  • An event variable by clicking on the ... button
  • the timestamp
  • The initialization value if required

For details see recording type chapter.

info Information

With a new archive, the dialog for the recording type is displayed. Not with an aggregated archive, because an aggregation archive always carries out recording in the event of a change.


Edit archive

Manual -> Historian -> Engineering in the Editor -> Edit archive

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To edit archives:

  1. Highlight the desired archive
  2. Select Edit archive in the context menu or in the toolbar, or press the Enter key
  3. The dialog to configure an archive is opened

Note: This dialog is opened if a new archive is created and the wizard is deactivated.


Properties

Manual -> Historian -> Engineering in the Editor -> Edit archive -> Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab, you define the identification and select variables, lots and equipment models.

Note: You can find help for configuring the properties of aggregated archives in the Aggregated archives chapter.

Description

Parameters

Description

Description

Name and identification of the archive.

Identification

Two-digit unique identification of the archive. This identification is integrated into the name of the ARX file when saving the archive data and during automatic name issuing when exporting. The assignment of the files is thus assured

Attention: The identification can only be issued when creating a new archive. It cannot be changed afterwards.
Note: Only alphanumeric characters (A-Z and 0-9) are permitted for the identification. Possible problems during export or evacuation of the archive are thus avoided.

Archive name

Freely-definable name of the archive.

Note: The following characters are not permitted: / \ : * ? < > ! | " ' # % @

Variable selection

Display and configuration of the variables that should be taken into account in this archive.

  • Add variables:
    Select Add variable in the context menu. You can add variables to the archive from all projects which are in the same workspace. Ensure that variables from other projects are also available in Runtime.
  • Delete variables:
    Highlight the variable and select Delete variable in the context menu.

Note: Seamless redundancy is only supported for variables that come from the same project as the archive.

Lots

Parameters

Description

Lots

Configuration of lots. See also the Lot archiving chapter.

Lot variable

Selection of lot variables. These must be string-type variables. The value of the variable is used as lot name. Click on the ... button to open the dialog for selecting the variable.

Note: The value of the variable is used as lot name. While the archive is open, the value of the variable and therefore the lot name can change. Kindly note this at filtering. The value of the variable when ending the archive is used as final lot name.

Index lots

Active: The lot values of this archive are automatically indexed. This allows quicker access to the lot values.

Lots can also be indexed in Runtime with the Index archive function.

Equipment Modeling

Parameters | Description
Equipment Modeling | Configuration of equipment models.
Equipment Groups | Selection of an equipment group for the archive. Click on the button ... in order to open the dialog for selecting an equipment group.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

info Information

Archives can contain variables from sub-projects. Variables from sub-projects can be identified by the variable name. This contains the project name.

Variable from sub-projects can also be used for lot variables (lot archiving) and the event variable.


Runtime

Manual -> Historian -> Engineering in the Editor -> Edit archive -> Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab, you define when and how archives are started and stopped and which functions are also executed in addition to archive start or archive end.

Start and stop

Parameters

Description

Start and stop

Selection of how archives are started and stopped in Runtime.

At start and end of Runtime

The archive is automatically started and stopped with the Runtime.

In doing so, the time that has been set under Start of archiving is also taken into account. If this is in the future, there is no archiving until this time is reached.

Attention: If you activate this setting, the archive must not be stopped or started using functions. This can cause unwanted behavior in Runtime.

User-defined (e.g. via functions)

The archive is started and stopped as defined by the user. For example, by using the Start an archive and Stop an archive functions

These functions can be triggered:

  • manually by the user
  • by events
  • by time control

Attention: These functions do not correspond to those of the settings for Execute function on.

RDA block archive

The archive is administered via RDA.

In doing so, archived values are read off in the control unit and saved in an archive. This is triggered by a trigger variable.

Execute function on

Parameters | Description
Execute function on | Selection of functions that are to be executed when the archive is started and ended. Attention: These functions are executed on starting and ending. However they do not trigger starting or ending. Functions to close and start an archive are configured separately in the project and linked to a button or event.
Archive start | Selection of a function that is to be carried out when the archive is started.

Archive end

Parameters | Description
Archive end | Selection of a function that is to be carried out when an archive is ended.

Start of archiving

Parameters

Description

Start of archiving

Stipulation of the start time.

Date/Time

Definition of the start time for the scan and save cycle.

The set time defines the first save time of the files that are to be archived. It is used as the basis of calculations for the set save cycles.

Example: You define an archive that is to be saved weekly. This save cycle starts at the set start time. If this is set to a Tuesday, your weekly archive runs from Tuesday to Tuesday.

Recommendations:

  • Leave the start time on the 1. 1. at 00:00. This ensures that monthly archives and yearly archives always start on the first day of each month/year.
  • The start of the scan and save cycle should contain a rounded time and date in the past, so that data recording is started automatically with the next time Runtime is started.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Recording type

Manual -> Historian -> Engineering in the Editor -> Edit archive -> Recording type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab, you define how data is recorded to the archives.

Cyclically

Parameters | Description
Cyclically | Settings for cyclic recording. The cycle is freely selectable. However it is closely related to the save cycle. Hint: The save cycle should be a multiple of the scan cycle. Otherwise there could be overlaps between scanning and saving the archives. This leads to imprecisions in the aggregated archives. Note: The value for milliseconds is automatically set to 0 in the time stamp.
Cyclic scanning | Active: Archive data is recorded cyclically. After that define the cycle time.
Cycle time: | Define the cycle time (days, hours, minutes and seconds) in which values are to be written to the archive.
Monthly | Reading in of the values is done at every month change
Offset | Define how long the archive is active and how long the requested values should be waited for. This setting is important if an archive is closed directly after reading the last value. The offset is primarily needed for slower drivers. It does not have any influence on the time stamp of the values. Note: The offset must always be smaller than the cycle time.

Event-triggered

Parameters

Description

Event-triggered

Settings for the event-triggered recording.

Event-triggered recording

Active: Archive data is recorded on an event-triggered basis.

Trigger variable

Selection of the variables that are to trigger the reading of the values. The reading is triggered by the rising edge of this trigger variable from 0 to 1. Select by clicking on the ... button.

Time stamp is taken from

Definition of how the time stamp is set. It can be accepted from:

  • Trigger variable
  • Archive variable

On change

Parameters | Description
On change | Settings for recording on change. Hint: This method should not be applied for heavily-fluctuating values, because this could lead to an exceptionally high amount of entries.
Record on change | Active: Variables are only written to the archive when their values change spontaneously. Recommendation: Stipulate a measurement range for a Hysteresis in order to avoid fluctuating values. These can quickly create large amounts of data. For details, see the Hysteresis chapter in the Variables manual.
Save process image during start | Active: On creating a new archive file the current values of the variables are written into the archive. Note: Must be activated if a Gantt curve is also to display the current status in Extended Trend.
Save process image during exit | Active: On closing an archive file the current values of the variables are written into the archive.

Event-triggered/On change

Parameters

Description

Event-triggered/On change

Ignore initializing value

If a variable is read for the first time, an initialization value can be entered. This happens, for example, when Runtime is started or if a Server 2 upgrades to Server 1.

  • Active: The initialization value is not taken into account in the archive.
  • Inactive: The initialization value is taken into account. The starting and switching by the server is entered.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Save

Manual -> Historian -> Engineering in the Editor -> Edit archive -> Save

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab, you define how archives are saved.

attention Attention

The current Alpha archive is deleted when changing the save type or the cycle. An Alpha archive is the archive file that is being written by zenon.

Save options in the dialog

Saving format

Selection of how archives are saved.

Parameters | Description
internal database (*.arx) | Active: Data is available for subsequent editing and evaluation in a ring (FIFO). The data is initially stored in the following folder: [Project Path]\[Computer Name]\[Project Name]. They are moved to the export folder hen moved (FIFO).
dBase (*.dbf) | Active: When the archive is closed, the data is immediately evacuated to a dBase file (*.dbf) Attention: For evacuated archives, archive revision, log creation and line graphics are no longer possible.
CSV (*.txt) | Active: When the archive is closed, the data is immediately evacuated to a CSV file (*.txt) Attention: For evacuated archives, archive revision, log creation and line graphics are no longer possible.
Save as unicode | Active: The TXT file is saved as Unicode.
XML (*.xml) | Active: At ending the archive, the data are immediately evacuated as a *.XML file. Attention: For evacuated archives, archive revision, log creation and line graphics are no longer possible.

Note: In the Historian Starter Edition, only saving to the internal database (ARX) is possible.

Saving cycle

Defines the interval in which archives are created. This cycle has a reciprocal effect on the recording type in Runtime. For details, see Cycles in Runtime.

Parameters

Description

Cycle time

Active: The length of the archives is defined in days, hours, minutes and seconds.

This option has an effect on the file size and the number of archive files, and determines the cycle for aggregated archives.

define the values for:

  • Days
  • Hours
  • Minutes
  • Seconds

Note: These values also have an effect on user-defined archives. These are used to calculate the number of archives to be archived.

Recommendation: Values greater that 30 seconds.

Turn of month

Active: The archive is saved each time the month changes (monthly archive).

Turn of year

Active: The archive is saved each time the year changes (annual archive).

Note: This setting already defines the cycle for aggregated archives.

attention Attention

User-defined starting and ending of archives:

Information in the Cycle option does not have an effect on the starting and stopping of archives, because this is carried out via functions. However this value does have an influence on how many archive files are stored. The various actual sizes of the archive files are not taken into account here.

The number of archive files to be stored is calculated as follows:
storage duration/Cycle time.
Evacuation is started after this. This ensures that evacuation is carried out with user-defined archiving after a certain number. The number of files to be stored is limited to 65535. The configuration of save cycle and duration of storage takes this into account automatically.

Example:

  • storage duration: 5 hours (= 300 minutes)
  • Cycle: 15 minutes

Result: 300/15 = 20 archive files to be stored.

Evacuation

Configuration of the evacuation of archives. Archives are deleted locally after evacuation.

Parameters

Description

Storage duration

Define the duration of storage for the archive before it is evacuated.

Granularity

  • Hours
  • Days
  • Months
  • Years

A maximum of 65535 archive files can be stored.

Attention: The duration of storage is directly dependent on the save cycle. If the save cycle is changed, the values for the duration of storage are amended to the maximum.

Examples:

  • Cycle time: 1 second
    maximum storage time 18 hours.
  • Cycle time 1 minute
    maximum storage time 1092 hours or 45 days or 1 month.

Attention: No archive is saved if the value 0 is entered. The only existing archive is the current one.

Evacuation after storage time

Setting the evacuation method.

Do not evacuate (archives are deleted)

Active: Archives are deleted after the duration of storage has expired.

internal database (*.arx)

Active: Archives are evacuated in the *.arx internal database format.

If the number of the archives, that want to be evacuated is reached, the oldest archives are stored in an ARX format. This file can then be imported in zenon again and it can be read and written there.

SQL database

Active: Archives are evacuated to an SQL database. Selection of database. Click on the ... button to open the dialog to select and configure a database.

Databases can also be evacuated in the MS Azure service bus.

In contrast to dBase, ASCII or XML archives evacuated into an SQL database are automatically reloaded when necessary (e.g. for Extended Trend).
Attention: Archives evacuated to SQL can be read in zenon but it is no longer possible to write to them.

You can find details on evacuation to SQL databases in the Evacuating archives to an SQL database in the Further information section.

Create table

Clicking on this button opens the dialog to create or update tables in the SQL database.

Using MS Azure Service Bus for writing

Active: Writing to the SQL table is not carried out directly via the OLEDB connection and SQL INSERT statement, but via the MS Azure service bus.

The connection name for the MS Azure service bus must be entered in the field under the option.

For details, read the Further information section in the MS Azure service bus chapter.

XML (*.xml)

Active: Archives are evacuated in XML format.

CSV (*.txt)

Active: Archives are evacuated in CSV format into a text file.

Export as unicode

Active: Activate this checkbox in order to save the evacuated TXT files as Unicode.

dBase (*.dbf)

Active: Archives evacuated in DBF format.

Exported columns in CSV/dBase evacuation:

With the two evacuation options dBase and CSV, certain parameters of archived variables can also be evacuated.

Enter the desired parameters into the text field in this sequence:

  • V: Variable name
  • I: Variable identification
  • W: Value
  • S: Status
  • D: Date
  • Z: Time

Default: DZVWS

The path for the save location of the evacuation files is configured using the General/File storage project property. SQL evacuation is not included in this. The path is set in the Evacuated archives option (see also Project-related folder chapter). In addition, the path to read back archives can also be defined using the Read-back folder for archives option. These paths can also refer to the same save location. Exported archive data files can thus also be read back again without manual copying. Different paths make sense if, for example, read-back is from a DVD and the exported data is only burnt onto new DVDs at defined times.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

Export parameters

The column separator character for ASCII export and the decimal points for TXT, DBF, XML and SQL can be amended in the project.ini file:

Section: [ARCHIV]

Entries:

  • TRENNZEICHEN=
  • ARCHDIGITS=

File names

The file names of the archives to be exported are issued as follows:

Parameters | Description
XXYYMMTThhmmss.xxx | File name
XX | Short archive description
YY | Year (e.g. 14 for 2014)
MM | Year (e.g. 03 for 2005)
DD | Day
hh | Hours in UTC.
mm | Minute
ss | Second
xxx | File format


Options

Manual -> Historian -> Engineering in the Editor -> Edit archive -> Options

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab, you define criteria for creating aggregation archives. You can set exclusive and inclusive filters to different status bits to do this.

Calculations for aggregated archives

Parameters

Description

Calculations for aggregated archives

Only accept values in the aggregated archive calculation if the following status filter is true

Active: Activated status bits are taken into account for the calculation of values of aggregation archives.

The additional statuses are

  • shown in the archive editor
  • Shown in the report and can also be set there

For the definition of the status, see the Status processing chapter:

Each status bit can have one of 5 possible states:

  • empty: is not evaluated
  • green 0: Is taken into account if the value is 0.
  • green 1: Is taken into account if the value is 1.
  • red 0: Is not taken into account if the value is 0.
  • red 1: Is not taken into account if the value is 1.

Note: If the checkbox is activated, at least one status bit must be activated.

Set time stamp in aggregated archives

Parameters | Description
Set time stamp in aggregated archives |
Time stamp of minimum/ maximum value | Active: The time stamp of the minimum/maximum value found is used as a time stamp.
time stamp of calculation | Active: The time stamp of the calculation is used as a time stamp.

Alternate archive

Parameters

Description

Alternate archive

Create alternate archives

Behavior if Runtime is not active:

  • Active: Missing archive files are created the next time Runtime starts.
    Note: To do this, cyclic recording must be selected.
  • Inactive: Only the current cycle is filled up.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

Creating a status filter

By clicking the checkbox next to each displayed status, you can decide for each value of the archive if it is to be used for the aggregated archive.

Example Example

In the aggregated archive, only values for which bit NORM is set and bit INVALID is not set are taken into account.

For this you set a green 1 for bit NORM and a red 1 for bit INVALID. The check boxes of all other bits remain gray.

You can explicitly include or exclude set or un-set bits.

info Information

Not all status bits set during illustration are also visualized. Non-visualized bits are:

  • T_EXTERN (status bit 21)
  • T_INTERN (status bit 22)
  • INFO (status bit 26)
  • RES28 (status bits 28)
  • RES31 (status bits 31)
  • WR_ACK (status bit 40)
  • WR_SUC (status bit 41)
  • COT0 (status bit 32) to COT5 (status bit 37)
  • T_STD (status bit 30)

Non-visualized status bits are:

  • not saved as a TXT file or written as an XML
  • Not printed when printing out
  • Not shown in the Recipegroup Manager

You can find an overview of all status bits in the Status bits chapter


Example

Manual -> Historian -> Engineering in the Editor -> Edit archive -> Example

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The start and end time of an archive file, as well as the time points for the entry of variable values into the archive file are calculated from the options of the following tabs:

  • Runtime: Start of archiving
  • Recording type: Cyclic scanning
  • Save: Saving cycle

The calculation of the time point for the entry of variable values into the archive file is restarted for each archive file.

attention Attention

Note the difference between:

  • The scanning and save cycle (SSC) and
  • Cycle time (CT)

These must not be confused.

Example

  • Identification: XX
  • Start of archiving: 01.01.2013, 00:00:00
  • Cyclic scanning: 13 seconds (00:00:13)
  • Saving cycle: 1 minute (00:01:00)

Result:

Date | Time | Archive file
07.12.2013 | 03:08:13 | xx80131207020900.arx
07.12.2013 | 03:08:26 | xx80131207020900.arx
07.12.2013 | 3:08:39 AM | xx80131207020900.arx
07.12.2013 | 3:08:52 AM | xx80131207020900.arx
07.12.2013 | 3:09:13 AM | xx80131207021000.arx
07.12.2013 | 3:09:26 AM | xx80131207021000.arx
07.12.2013 | 3:09:39 AM | xx80131207021000.arx
07.12.2013 | 3:09:52 AM | xx80131207021000.arx
  • Each archive file contains data for a minute each.
  • Data recording for each archive file starts at hh:mm:13.

Determination of the DTV

The determination of the time of the first value (DTV) is achieved by rounding the scan and save cycle to the cycle time. In doing so, note:

  • The rounding of the scan and save cycle to the first cycle time is carried out in accordance with the following model:
    • Hours with hours
    • Minutes with minutes
    • Seconds with seconds

    This means: If the time (H:M:S) of the recording and save cycle to be rounded is less than that of the cycle time, the latter is always 0.

  • If the cycle time is a day, the recording and save cycle is always taken as 0:0:0 o'clock Recording starts at 00:00.
  • For monthly cycle time, recording always takes place on the first day of the month at 00:00:00.

Some examples:

  • SSC: Scan and save cycle
  • ASZr: Scan and save cycle rounded:
  • AZ: Cycle time
  • EZW: Time first value
SSC | AZ -> | EZW; | ASZr + AZ = | EZW
XX:XX:XX | 1T 00:00:00 | 00:00:00; | 00:00:00 + 00:00:00 | 00:00.00
00:01:00 | 0T 23:59:00 | 23:59:00; | 00:00:00 + 23:59:00 | 11:59:00 PM
12:30:00 AM | 0D 00:30:00 | 01:00:00; | 12:30:00 AM + 12:30:00 AM | 1:00:00 AM
12:30:00 AM | 0D 12:29:00 AM | 12:58:00 AM; | 12:29:00 AM + 12:29:00 AM | 12:58:00 AM
12:30:00 AM | 0D 12:05:00 AM | 12:35:00 AM; | 12:30:00 AM + 12:05:00 AM | 12:35:00 AM
12:29:00 AM | 0D 12:05:00 AM | 12:30:00 AM; | 12:25:00 AM + 12:05:00 AM | 12:30:00 AM
12:00:00 AM | 2D 12:00:00 AM | 12:30:00 AM; | 00:00:00 + 2d00:00:00 | 3. 12:00:00 AM


Aggregated archives

Manual -> Historian -> Engineering in the Editor -> Aggregated archives

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Aggregated archives always relate to a base archive, the data of which it shows in compressed form. Within zenon, aggregated archives act like any other archive. You can do the following with aggregated archives:

  • Edit them in Runtime using an archive revision screen
  • Include them in reports and trends
  • evacuate

The following calculation methods are available for the compression of data:

  • Sum
  • Average
  • Minimum
  • Maximum

The use of aggregation archives is recommended for large amounts of data most of all. For a comparison of time periods such as complete weeks, months or years, average values or sums are often sufficient. The raw data can thus be prepared in a clear manner and the amount of data can be reduced.

Creating an aggregation archive

To create an aggregation archive:

  1. In the detail view, select the archive that is to be aggregated.
  2. Select New aggregated archive in the tool bar or in the context menu
  3. The assistant is started provided it is activated in the options.
    (in order for the assistant to be able to be started, the Use assistants option must be activated in the Editor in the Options/settings menu)
  4. Please define a name!

  5. Select the Variable and the method of aggregation.

    Click on the Variable selection button to open the dialog to select a variable and the aggregation method.

    Aggregated archives are also recorded on change. The scan cycle of the aggregation archive is set via the save cycle of the respective base archive. The values selected for the aggregated archive are always calculated if a base archive is closed and saved. zenon recognizes the closing of the basic archive as a value change and triggers the calculations for the aggregated archive.


Variable selection and aggregation method

Manual -> Historian -> Engineering in the Editor -> Aggregated archives -> Variable selection and aggregation method

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the variables selection dialog, the variables to be aggregated and the aggregation method are selected.

Available archives

Parameters | Description
Available archives | Select, from the variable list, the variables that should be taken into account in the aggregated archive. Multi-select with Ctrl or Shift.
Sum | Active: Values of the selected variables are added depending on the save cycle.
Average | Active: Average value of the selected variables is generated.
Minimum | Active: The minimum per selected variable is determined.
Maximum | Active: The maximum per selected variable is determined.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

Amend time stamp for average value

The time stamp in an aggregated archive corresponds to the time when the ARX file was closed.
This leads to the following situation:

  • The values of a day, X, are saved to an archive. The start time is thus 00:00, the save time is 24:00.
  • The aggregation archive for this day, X, has an average value and received the times stamp 00:00:00 on day X + 1. (the minimum and maximum can have the same or the original time stamp; in our case we assume the original)
  • If filtering for the day X, 00:00:00, up to day X + 1, 00:00:00 is carried out in the aggregated archive, you get the values for minimum and maximum with the original time stamp for the day X.
  • You get the average value for the day X-1 (time stamp day X, 00:00:00). The value for the day X, which is in the file with the time stamp day X + 1, 00:00:00, is expected.
  • The minimum and maximum thus have a time stamp within the selected time period; the average value has a time stamp outside this time period.

Solution

In order to receive a matching time stamp, set the time stamp for the average value back by one second. To do this, enter, in project.ini, in the [ARCHIV] section, the value 1 for ZEIT_AUTOMATISCH=.

The time for the aggregation archive is thus automatically set to one second before saving. Day X+1, 00:00:00, becomes day X, 23:59:00.


Editing aggregation archives

Manual -> Historian -> Engineering in the Editor -> Aggregated archives -> Editing aggregation archives

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The editing of aggregation archives differs from the editing of base archives in terms of the properties most of all. For aggregation archives, variables are assigned to the calculation methods.

Description

Parameters

Description

Description

Name and identification of the archive.

Identification

Two-digit unique identification of the archive. Is used for the automatic name issuing with export functions.

Attention: The identification can be issued when creating a new base archive. It cannot be subsequently changed.

Archive name

Freely-definable name of the archive.

Note: The following characters are not permitted: / \ : * ? < > ! | " ' # % @

Variable selection

Parameters

Description

Variable selection

Select the calculation method in the archive and and add variables to it or remove variables that are to be taken into account in the aggregation archive. Multi-select with Ctrl or Shift.

  • Sum: Values of the attendant variables are added depending on the save cycle.
  • Average: Average value of the values of the attendant variables is generated.
  • Minimum: The minimum per attendant variable is determined.
  • Maximum: The maximum per attendant variable is determined.

Adding or deleting variables:

  • Add variables:
    Select Add variable in the context menu. You can add variables from the base archive.
  • Delete variables:
    Highlight the variable and select Delete variable in the context menu.

Lots

Parameters

Description

Lots

Configuration of lots. (See also chapter Lot selection .)

Lot variable

Selection of lot variables. These must be string-type variables. The value of the variable is used as lot name. Click on the ... button to open the dialog for selecting the variable.

Note: The value of the variable is used as lot name. While the archive is open, the value of the variable and therefore the lot name can change. Kindly note this at filtering. The value of the variable when ending the archive is used as final lot name.

Index lots

Active: The lot values of this archive are automatically indexed. This allows quicker access to the lot values.

Equipment modeling

Parameters | Description
Equipment modeling | Configuration of equipment models.
Equipment Groups | Selection of an equipment group for the archive. Click on the button ... in order to open the dialog for selecting an equipment group.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

Note: Further tabs are configured in same way as editing the archive.

Limitations

  • Aggregated archives are automatically set to record on change by zenon. The recording type cannot be changed.
  • The save cycle results from the length of the attendant base archive. The values of the variables are always written to the aggregated archive whenever the basis archive is ended.
  • All entries of the base archive are used by default for calculation (i.e. also INVALID entries and manual values).
    Exception: In the base archive, the Only accept values in the aggregated archive calculation if the following status filter is true property in the options is activated and configured.


Templates for aggregated archives

Manual -> Historian -> Engineering in the Editor -> Aggregated archives -> Templates for aggregated archives

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Templates for aggregated archives make it possible to import existing aggregated archives into base archives. Structures that have already been configured can be easily reused this way.

There are pre-configured templates available that are supplied with zenon. In addition, individual configurations can be saved as templates.

Templates can only be imported for base archives with cyclic scanning. These archives cannot have any aggregated archives yet.

Template paths

The templates are stored in two paths:

  • Pre-defined templates:
    In the subfolder of the installation folder: \Templates\Archives\<Language>\<Filename>.xml
  • User-defined Templates:
    %programdata%\COPA-DATA\zenon7.20plates\Templates\Archives\<Language>\<Filename>.xml

    Note: Depending on the type of registration, this path can also be in the program folder. zenon automatically takes this into account.

File format

Templates are stored in XML format. The template contains metadata with:

  • Description of the template
  • Name of the template
  • The main settings of the archive for each archive of the hierarchy


Importing templates

Manual -> Historian -> Engineering in the Editor -> Aggregated archives -> Templates for aggregated archives -> Importing templates

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To import templates for aggregated archives:

  1. Highlight the desired base archive.
  2. Select the Import template command in the context menu.
  3. The dialog for selecting a template is opened.
  4. Select the desired template.
  5. Click on the Accept button.
  6. The aggregated archive is imported.

info Information

Templates can only be imported for base archives with cyclic scanning. These archives cannot have any aggregated archives yet.

Parameters | Description
Templates window | Display of the templates present.
Selected templates window | Display of the selected aggregated archive.
Apply | Imports the aggregated archive into the base archive and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Supplied templates

Manual -> Historian -> Engineering in the Editor -> Aggregated archives -> Templates for aggregated archives -> Supplied templates

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following pre-configured templates are supplied with zenon:

  • Counters: Counting aggregated archive, which aggregates from one day over a week, a month and a year up to two years and stores the data for up to 10 years.
  • Standard: Standard aggregated archive, which aggregates from 30 minutes over an hour, a day and a month to one year and stores the data for up to 16 years.
  • Energy: Aggregated archive for energy, which aggregates from 15 minutes over an hour, a day and a month to one year and stores the data for up to one year.

Supplied templates are write-protected and cannot be changed. They are shown in the dialog with blue symbols. Self-created templates have red symbols.

Aggregated archive counter

Archive level | Current aggregation level | Aggregated archive aggregation level | Storage
1: CO-P_COU_30MIN | 30 minutes | 1 hour | 14 days
2: C2-P_COU_1HOUR | 1 hour | 1 day | 6 months
3: C3-P_COU_1DAY | 1 day | When the month changes | 3 years
4: C4-P_COU_1MONTH | 1 month | When the year changes | 10 years

Aggregated archive standard

Archive level | Current aggregated archive | Aggregated archive aggregation | Storage
1: DO-P_STD_1DAY | 1 day | 7 days | 1 year
2: D2-P_STD_1WEEK | 1 week | When the month changes | 3 years
3: D3-P_STD_1MONTH | 1 month | When the year changes | 10 years
4: D4-P_STD_1YEAR | 1 year | 2 years | 16 years

Aggregated archive energy

Archive level | Current aggregated archive | Aggregated archive aggregation | Storage
1: EO-P_ENE_15MIN | 15 minutes | 1 hour | 14 days
2: E1-P_ENE_1HOUR | 1 hour | 1 day | 6 months
3: E2-P_ENE_1DAY | 1 day | 30 days | 1 year


Creating and editing templates

Manual -> Historian -> Engineering in the Editor -> Aggregated archives -> Templates for aggregated archives -> Creating and editing templates

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Templates can be created individually. Templates can only be created for base archives (first level) and only for archives with cyclic scanning. The menu item is deactivated for all other archives, and not present for aggregated archives.

To create a separate template:

  1. Highlight the desired aggregated archive in the detail view
  2. Select Create template in the context menu.
  3. The dialog for configuring templates is opened
  4. Select the desired folder or create a new one
  5. Assign a meaningful name for the template.
  6. Confirm the new template by clicking on OK.

When creating a template, the complete hierarchy of the selected aggregated archive is used.

Note: Supplied templates and their folder structure cannot be edited or deleted.

Creating and editing templates

Parameters | Description
List of templates | Contains a folder structure with all pre-defined templates. Templates can be selected and the name and description can be edited. Pre-defined elements cannot be edited.
Name | Name of the template. Hint: Select a meaningful name in order to quickly be able to find the correct template when importing.
Description | Detailed description of the template.
New folder | Creates a new folder in the highlighted folder. Keyboard operation: Ins key.
Rename | Opens the highlighted element for editing. Keyboard operation: F2 key. Pre-defined elements cannot be renamed.
Delete | Deletes the selected element. If templates are only to be deleted and no new ones are to be created, the dialog must be closed by clicking on Cancel. Keyboard operation: Del key. Note: Pre-defined elements cannot be deleted.

Close dialog

OK | Applies settings and closes the dialog. The template saves the settings of all aggregated archives to the selected archive.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.

Create, edit and delete elements

Creating a folder

To create a new folder:

  1. Highlight the existing folder
  2. Click on the New folder button
    oder

    Press the Insert key
    or

    Select New folder in the context menu of the superordinate folder

Edit element

To edit an element:

  1. highlight the element
  2. Change the name and/or description
    or

    Select the corresponding command in the context menu of the element.

Delete element

To delete an element:

  1. highlight the element
  2. Click on the Delete button
    or

    Press the Del key
    or

    Select the Delete element in the context menu of the element

  3. Close the dialog by clicking on Cancel

Changing the structure

To change the structure:

  1. Highlight the desired element (folder or template)
  2. Drag it with the mouse to the folder where it is to be a subfolder

Edit folder and templates without accepting the archive settings

You can also edit folders and templates without accepting the archive settings on closing

To do this, edit the elements in the left window with the list of templates.


Add and remove variables

Manual -> Historian -> Engineering in the Editor -> Add and remove variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Variables and their aggregation types are displayed in the detail view of the archive.

Variables can be added or removed here:

  • Add:
    To add variables, select the Add variable command in the context menu or in the tool bar by means of Drag&Drop.
  • Remove:
    Select the desired variables and press the Del key or select the Remove variable command in the context menu or the tool bar.
    Attention: Variables are removed from the variable list without a request for confirmation.

Adding a variable to a base archive

To add a variable to a base archive:

  1. Select Add variable in the context menu, the tool bar of the base archive or the variable list.
  2. The selection dialog is opened

    Add the desired variables.

  3. Close the dialog.
  4. If there are aggregation archives, then the dialog to add the new variables for aggregation archives is opened.

    Select whether the variables are to be added to all existing aggregation archives, and with which aggregation types:

    • Apply to all aggregation archives: The newly-added variables are taken into account in all existing aggregation archives. Wen activating, the desired aggregation archives (sum total, average value, minimum, maximum) must be selected.

Adding a variable to an aggregation archive

To add a variable to an aggregation archive:

  1. Select Add variable in the context menu, the tool bar of the base archive or the variable list.
  2. The selection dialog is opened, depending on the type of archive:
    1. No subordinate aggregation archive present

    Add the desired variables.

    1. Subordinate aggregation archive present:

      Select the desired variables and aggregation archives.

      If these variables are to be applied in all subordinate aggregation archives, then activate the In Apply to all aggregation archives option.

  3. Close the dialog.

Insert variables into the aggregation archive by means of Drag&Drop

Additional variables can also be inserted into an aggregation archive directly by means of Drag&Drop. There are two methods available to you for doing this:

  • Individual variable:
    Select an individual variable from the variable list of the base archive and drag this with the left mouse button held down to the desired data compression type of an attendant aggregation archive.
  • All variables:
    Drag the complete base archive to a data compression type. In doing so, all variables contained therein are allocated.


Lot archiving

Manual -> Historian -> Engineering in the Editor -> Lot archiving

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Lot archiving allows for the easy allocation of lot designations to an archive. Lot labeling allows you to filter archive data, such as in Extended Trend or the Report Generator, as you wish when processing it further.

A lot archive is used most of all if no cyclical processes are to be recorded. For example in a drinks-filling plant, where different products are manufactured in different qualities. In doing so, the freely-definable lot names can be used very easily to make a link between the archive and the lot. The lot name can then also be used for filtering in Runtime.

Because lot archives are not based on defined time periods or a number of value entries, it makes sense to index these. It is thus possible to access the data more quickly at a later time.

The main differences between a lot archive and an archive:

  • defined start and stop time of the archive (Generally: not cyclic)
  • defined lot name

info Information

The value of the lot variable is written in the index file and in the header of the ARX file at the start of the lot. These entries are adjusted with every change of the variable. When the lot is closed, the value of the lot variable at this moment is finally written in the index file and in the header.

Thus the lot name is final when the lot is closed.

Index

For quicker access to the lot values in the lot filter, an index can be created for each archive. The index is stored in the file [short name].ARI An entry is made in the index file each time a lot archive is saved. This entry contains an archive name, lot description and end time. With the evacuation of the archive the index also is updated.

Archives can be deleted or moved using file file operations. In this case, the index file must be reindexed. To do this, use the Index archive function.

Automatic indexing

Activate, when configuring the base archive or the aggregation archive, the Index lots option in the Properties tab. The index is only created from archive files in the Runtime folder. If reading is from the from the read-back folder, reading-in is carried out file by file.

The new creation of a lot index is carried out with the Index archive function. Use this function if data is to be saved to a Runtime folder manually, or to be read manually from it. The index files is not evacuated with it and also not read when the data is obtained from the read-back folder. Indexing again only accesses the archive files in the Runtime folder. If archive files are read back from the read-back folder, these are not moved back to the Runtime folder again. The data would be loaded to the RAM. New indexing thus accesses data in the Runtime folder, but not data in the read-back folder.

Function Index archive

Generating the index file can be a time-consuming procedure depending on the amount of the archive files. In order not to block the Runtime, this is done in the background. If the new indexing is not finished but lot values are needed, this request has to wait until the procedure is finished. With the Execute synchronously option, there is a wait until the new indexing is finished before the function is executed.


Creating a screen of the type Archive Revision

Manual -> Historian -> Engineering in the Editor -> Creating a screen of the type Archive Revision

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The archive revision screen makes it possible to display, configure and edit archives in Runtime.

To create a screen of the type Alarm Message List:

  1. In the tool bar or the context menu, select the New screen command in the context menu of the Screens node.
    A standard empty screen is called up.
  2. Change the screen type in the detail view. To do this:
    1. click on Standard in the Screen type column
    2. Select the Archive revision entry from the drop down list
  3. Click in the screen.
  4. Select the Control elements menu item in the menu bar
  5. Click on Add template in the drop-down list.
  6. The standard elements are automatically inserted
  7. Select additional elements as required and add them at the desired place on the screen or delete superfluous elements.
  8. Create a screen switch function in order to be able to call up the screen in Runtime.
  9. In screen switching, configure the content that is to be displayed in the screen in Runtime.

Archive revision screen

Parameters | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.
Window | Control elements for windows.
Archive data window | Display of the archive data in Runtime.
Set filter (list) | Definition of the set filter.
Set filter (display) | Display of the set filter.
Archive status | Display of the archive status.
Short name | Display of the short description of the displayed archive.
Total number | Display of the number of the displayed values.
Number of INVALID | Display of the number of variables with the status INVALID.
List functions | Buttons for controlling the list functions in Runtime.
Open archive | Opens the dialog to select an archive.
Close archive | Closes the archive that is currently open.
Save archive | Saves changes in the archive and updates the aggregated archives on request.
Edit entry | Opens the dialog to edit the selected archive entry.
Insert entry | Opens the dialog to insert archive entries into the archive files. If there are no archive files for this time range, no entries can be inserted. A corresponding error message is shown if an attempt to insert an entry is made.
Delete entry | Deletes selected archive entries after confirmation query.
Select | Clicking on the button opens the dialog to configure the filter.
Column configuration | Opens the dialog to configure column width and font.
Print | Prints list to configured printer.
Filter profiles | Control elements for filter profiles.
Profile selection | Entry of a name for a new filter profile or selection of a filter profile from a drop-down list.
Save | Saves current filter as a profile with the name given in the filter profile text field.
Delete | Deletes the currently-selected filter profile.
Import | Opens dialog to import a filter profile.
Export | Opens dialog to export a filter profile.


Functions

Manual -> Historian -> Functions

In zenon, there are several functions available to control archiving.

  • Screen switch - archive revision: Configuration of screen switching including filtering
  • Archive: Start: Start archive manually
  • Archive: Stop: Stop archive manually
  • Show active archives: Show active archives in Runtime
  • Index Archive: Start/renew Indexing for archive
  • Export archives: Export archive


Screen switch - archive revision

Manual -> Historian -> Functions -> Screen switch - archive revision

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To open an archive revision screen in Runtime and to set the parameters:

  1. Create a screen of type Archive Revision.
  2. Create a screen switch function for this screen
  3. Define the desired filter properties

Setting the parameters of the content to be displayed in Runtime is carried out using the filter conditions of the screen switching. You can access the same screen repeatedly with different functions and have differently-filtered lists shown.

In the Runtime you can modify the filter properties. Exception: In the Editor fixed time filter was defined.

Configure screen switching

To create a screen switch to a screen of type Archive Revision:

  1. In the context menu of node function select command New function.
  2. Click on screen switch.
  3. The dialog for the screen selection will be opened.
  4. select the screen of type Archive Revision
  5. the dialog for archive selection is displayed.
  6. Highlight the archive that is to be displayed in Runtime for screen switching.
  7. Use the Format option to configure how the data is to be sorted for the display.
  8. Configure the desired filter for variables, status bits, time and lots.
    To do this, click on the Filter button.
  9. Close the filter dialog and and archive dialog by clicking on OK for each.

Archive selection dialog

Parameters

Description

Filter name

Name of the configured filter.

This name is attached to the parameters of the screen switching function and serves to distinguish between different screen switching functions with different filter configurations.

Archives

List of available archives.

Attention: An archive must be selected. This is displayed in Runtime. If a lot archive is to be displayed, this must correspond to the configured archive for the selection in Runtime.

Format

display format and sorting of displayed archive entries:

  • Time: Filter for date and time
  • Variable: according to variable name
  • Unsorted: no sorting

Use archives from read-back folder

Active: Archives from the read-back folder are also used.

Inactive: Only current archives are used.

When loading archive data from the readback folder, the archive data from the Runtime path and from all subfolders of the readback folder is also read.

Attention: Before you can access evacuated archives using the Use archives from read-back folder option, they must first be copied to the read-back folder. At the evacuation archives are saved in folder Evacuated archives. This folder does not comply with the read-back folder. You define the folders in the Standard settings dialog on the Folder tab. You can find the dialog under File -> General configuration -> Standard.

Hint: The folder for evacuated archives and archives from read-back folder can also be set as the same one, in order to avoid manual copying. Different paths make sense if, for example, read-back is from a DVD and the exported data is only burnt onto new DVDs at defined times.

Close dialog

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Filter

Opens the dialog to configure the filter criteria:

  • Archive filter: Variables (only available if an archive has been selected) and status bits
  • Time: Time filter
  • Lots: Lot filter

Help

Opens online help.


Archive filter

Manual -> Historian -> Functions -> Screen switch - archive revision -> Archive filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters

Description

Status list

Selection of the status bits that are to be filtered for. Selection and deselection by clicking on the respective status bit.

Only available if the All entries option has been deactivated.

Variable list

Variables that are to be displayed from the selected archive. Select and deselect them by clicking in the checkbox in front of the variables.

Only available if the All entries option has been deactivated.

Value (in base unit)

Active: Filtering is carried out for archive values whose value is between a minimum and a maximum or which contain a certain character sequence as a string.

Input of:

  • Minimum: Lower limit of the value
  • Maximum: Upper limit of the value
  • String mask: Character sequence that is be filtered for

Only available if the All entries option has been deactivated.

Delete selection

Only available if the dialog is called up in Runtime using the Selection button.

In Runtime, when the dialog is called up using the Selection button, the entries in the list that correspond to the selected variables and status bits are highlighted.

  • Active: Removes all bold font in the list when the dialog is closed.

Show this dialog in the Runtime

Active: Before every call of the screen the filter dialog is opened. The filter settings can be modified. This option is not available with Windows CE.
Note: If, in the Lots tab, the Show lot selection dialog option is also selected, then the lot selection dialog is called up in Runtime. This is no longer displayed after reloading.

Notes for time range filters:

Show this dialog in the Runtimeactive:

  • The filter is opened in Runtime in screen switching. The filter is no longer offered on reloading. This behavior can differ for individual screen types if the dialog was displayed in screen switching and canceled.
  • The last-concluded time period is always used.

Show this dialog in the Runtimenot active:

  • Use last finished time rangeactive: The last-concluded time period is used
  • Use last finished time rangenot active: The current time period is used.

All entries

Active: Settings apply for all statuses and variables. The entries in status list, variable list and value cannot be selected individually.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Time

Manual -> Historian -> Functions -> Screen switch - archive revision -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration of the time filter.

Note: Time is saved in UTC. For details see chapter Handling of date and time in chapter Runtime.

Time filters can be pre-set in both the Editor and in Runtime for:

  • Absolute period of time
  • Relative period of time
  • From
  • Time period

Time filtering can be carried out in two ways:

  1. Define time period in the Editor
    Fixed time areas are used. A time period is given in the editor. It is only possible to filter according to this time period in Runtime. Other filters - such as filtering according to variable name, alarm/event groups and alarm/event classes etc. can no longer be amended in Runtime.
  2. Time filter configurable in Runtime
    The time filter is defined in the Editor and can be changed in Runtime as desired.

Configuring the time filter

Filter

Selection of the filter.

Parameters

Description

No time filter

Active: No time filter is used.

Note: all Runtime entries since 1. 1. 1990 are displayed.

Absolute filter

Active: A fixed period of time is entered in the editor. When the function is executed, the defined absolute time period is exactly used.

In the settings section, the corresponding options can be shown and configured there.

Note: Time is saved in UTC. For details see chapter Handling of date and time in chapter Runtime.

Relative period of time

Active: A relative time period is entered.

In the settings section, the corresponding options can be shown and configured there.

Attention: this filter is constantly updated.

From

Active: A time from which the filter is effective is stated. If the time is not reached on the current day, filtering takes place from the corresponding time the previous day.

Selection of the area mode from drop-down list:

  • From HH:MM:SS o'clock
  • From day - HH:MM:SS o'clock
  • Starting on day, month at HH:MM:SS

In the settings section, the corresponding options can be shown and configured there.

Attention: The start point of this filter is not updated automatically. Only the existing times are used when shown.
The end time point is not defined with this filter, it is carried over.

Time period

Active: A fixed time period is entered. Selection of the area mode from drop-down list:

  • One day
  • One week
  • Two weeks
  • One month
  • One Year
  • 15 minutes
  • 30 minutes
  • 60 minutes

In the settings section, the corresponding options can be shown and configured there.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Absolute period of time

Manual -> Historian -> Functions -> Screen switch - archive revision -> Time -> Absolute period of time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You define a fixed time period with the absolute filter. When the function is executed, the defined absolute time period is exactly used. To set the filter:

  1. Select, in the Filter section, the Absolute time period option
  2. Configure the desired time in the Settings section

Parameters | Description
Settings | Configuration of the time filter.
Propose current date/time | Active: Time filter is displayed in Runtime.
Preset | Active: The time filter is prescribed in the Editor. Only the start time can still be configured in Runtime.
From | Start time of the filter. Selection of day, month, year, hour, minute and second
To | End time of the filter. Selection of day, month, year, hour, minute and second

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Relative period of time

Manual -> Historian -> Functions -> Screen switch - archive revision -> Time -> Relative period of time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A relative time period is entered.

Attention: This filter is updated constantly and continues to run.
Example: You set a relative time of 10 minutes and switch to a screen with this time filter at 12:00. You are then shown the data from 11:50 to 12:00 when switching. If the screen stays open, the filter is automatically updated. At 12:01, you see the data from 11:51 - 12:01 etc.

To set the filter:

  1. Select, in the Filter section, the Relative period of time option
  2. Configure the desired time in the Settings section

Parameters | Description
Settings | Configuration of the time filter.
Propose current date/time | Active: Time filter is displayed in Runtime.
Preset | Active: The time filter is prescribed in the Editor. Only the start time can still be configured in Runtime. Selection of the relative time period in days, hours, minutes and seconds.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


From

Manual -> Historian -> Functions -> Screen switch - archive revision -> Time -> From

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A time from which the filter is effective is defined. To set the filter:

  1. Select, in the Filter section, the Off option
  2. Select the desired filter from the drop-down list.
    • From HH:MM:SS o'clock
    • From day - HH:MM:SS o'clock
    • Starting on day, month at HH:MM:SS
  3. Configure the desired time in the Settings section

Parameters

Description

Settings

Configuration of the time filter.

[Date/Time]

Depending on the settings of the Off option, the time from which the filter is effective is configured here:

  • Starting from HH:MM:SS
  • Starting from day - HH:MM:SS
  • Starting from day, month - HH:MM:SS

Warning! The start point of this filter is not updated automatically. Only the existing times are used when shown, even if the screen remains open and 23:00:00 is reached.
The end time point is not defined with this filter, it is carried over.
  • Starting from HH:MM:SS

A time from which the filter is effective is stated. If the time is not reached on the current day, filtering takes place from the corresponding time the previous day.

Example: You enter 23:00:00. If it is then 23:30 when executing the function, then it is filtered from 23:00:00 up to the current point in time. If it is 22:30 however, then filtering takes place from 23:00:00 on the previous day to the current point in time.
  • Starting from day - HH:MM:SS

A day and time for the start of the filter are entered. If the time given has not been reached in the current month, the corresponding time from the previous month is used.

Example: You enter day 5 - 23:00:00. If it is the 10th of the month at 23:30, then filtering takes place from the 5th of the month from 23:00:00 to the current time point. If, however, it is the 4th of the month, then filtering takes place from the 5th of the previous month to the current time point.

  • Starting from day, month - HH:MM:SS

A month, day and time for the start of the filter are entered. If the time stated has not been reached in the current year, the corresponding time from the previous year is used.

Example: You enter Day 5, Month October - 23:00:00. If it is October 10th at 23:30, then filtering takes place from October 5th from 23:00:00 to the current time point. If, however, it is only October 4th, then filtering takes place from the 5th of the previous year to the current time point.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Time period

Manual -> Historian -> Functions -> Screen switch - archive revision -> Time -> Time period

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A time period in which the filter is effective is defined. To set the filter:

  1. Select, in the Filter section, the Time period option
  2. Configure the desired time in the Settings section

Parameters

Description

Settings

Configuration of the time filter.

Time period

Selection of a time range from a drop-down list.

Filtering for this time range is carried out in Runtime. The filter relates to the time of screen switching.
For example: The value 60 minutes shows all archives of the last hour.

If this dialog is offered in Runtime, the start time of the time range can be selected.

Modify time period

Allows amendments to cycles, postponements and extensions of time periods.

Active: Evaluation is carried out in accordance with the following rules:

  • First, the Use last finished time period option is evaluated.
  • After this, Change time period by is used.
  • Move time period to the future by is then applied.

Inactive: No changes to the time period are made.

Attention: With version 7.10, filter actions on the basis of this function led to different results than those in the versions before.

Move time period to the future by

Active: The time period defined in the filter is postponed to the future. Given in hours - minutes - seconds.

If a postponement that is the same or greater than the selected time period is set, a note to check the configuration is displayed.

Change period of time by

Active: The time period defined in the filter is modified. Given in hours - minutes - seconds.

If a change and a postponement that are the same or greater than the selected time period is set, a note to check the configuration is displayed.

Add time

Active: The time stated in Change time period by is added to the time defined in the Time range option.

Deduct time

Active: The time stated in Change time period by is deducted from the time defined in the Time range option.

Use last finished time period

Active: The last finished time period is used.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Specify time period in the Editor

Manual -> Historian -> Functions -> Screen switch - archive revision -> Time -> Specify time period in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this method, you enter a fixed time period into the editor, which is applied when the function is carried out in Runtime. You can then only define the start time in Runtime, but no further filter settings.

For example: You set a 30 minute time filter. In Runtime, you can now only set when this 30 minute time period is to start. However, you cannot change the filter to a day filter.

attention Attention

When using this type of filter, you can also no longer amend all other filters in Runtime that are available in the General tab. It is still possible to filter for text, status and equipment.

To create the filter:

  1. The screen must have the Filter button to start the filter in Runtime
  2. select the desired filter
  3. Configure the selected time period

Tip for time period: Activate the Offer this dialog in Runtime option in the filter dialog. This way you can amend the start time before the function is carried out. Do not have the filter displayed in Runtime when the function is turned on; this way the current time period is always used. If you have activated the Use last closed time period option, the previous time period is shown.
For example: You have set a 30 minute filter. It is 10.45 when the function is activated. If the Use last closed time period option is deactivated, the filter is set to the current time period 10:30:00 to 10:59:59. If the option is activated, the filter is set to the previous time period of 10:00:00 to 10:29:59.


Time filter can be configured in Runtime

Manual -> Historian -> Functions -> Screen switch - archive revision -> Time -> Time filter can be configured in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this method, you stipulate a time filter in the Editor. This can be amended in Runtime before execution. To create the filter:

  1. The screen must have Filter and Display filter buttons
  2. select the desired filter:
    • Absolute period of time
    • Relative period of time
  3. Select, in the Settings section, the option Propose current date/time
  4. The filter dialog is opened in Runtime with the current date and time


Lots

Manual -> Historian -> Functions -> Screen switch - archive revision -> Lots

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration of the lot filter.

The lot information is also applied to the existing time filter.

If the lot filter is activated, the following happens in Runtime:

  • A list of all configured lots that correspond to the configured time period is obtained in advance from the archive
  • The list of the archives is filtered for this.

    Attention: The lot archive selected in Runtime must correspond to the archive selected in the screen switching.

Filter

Settings for the application of the lot filter. Selection of one of the options:

  • No lot filter
  • Apply lot filter directly
  • Display lot selection dialog

Parameters

Description

No lot filter

Active: The lot filter is deactivated and cannot be configured. Filtering for lots is not carried out in Runtime.

Apply lot filter directly

Active: The filter configured here is applied in Runtime directly.

Display lot selection dialog

Active: The dialog for lot selection is shown in Runtime when:

  • Clicking on Filter or
  • screen switching, if the Offer this dialog in Runtime option has been activated (not available for each function/screen type)
    Note: The dialog is not shown on reloading.

Options can be pre-selected in the Editor.

Replace dialog in Runtime with screen

Not available if the Show lot selection dialog option has been selected.

Definition of a screen that is to be called up in Runtime instead of the lot selection dialog. Only time/lot filter screens are offered.

Click the ... button and the dialog opens to select a screen.

If the linked screen is not found in Runtime, a search is made for corresponding screens with specific names.

Relative lot selection

Only available for Extended Trend and faceplates and only if the option Display lot selection dialog has been activated. The Windows CE project property must be deactivated in the project properties.

  • Active: Enables several lots to be compared directly. Display always starts from the zero point.

Time

Configuration of the time filter for lot selection. Selection of one of the options:

  • No filter
  • Last lots
  • Use time filter from "Time" tab

Parameters

Description

No filter

Active: The time range set in the Time tab is not taken into account. All completed and current lots are displayed.

Last lots

Active: Input of the number of lots last concluded, according to what they should be filtered for. Input of the number in the number field or configuration via cursor keys.

The option allows the combination of both options Display current lots and Display completed lots.
Example: 3 lots are to be displayed, 2 are running and 10 have been completed. The following is shown: the two that are current and one that has been completed.

Attention: At least one of the two options Display current lots or Display completed lots must be activated. If both options have been deactivated, this corresponds to the No filter setting.

Note on compatibility: If the current lots or the combination of current and completed lots are selected and the project is compiled for a version before 7.11, the completed lots are shown in Runtime.

Display current lots

Active: The current lots are displayed.

Note: If the number of lots to be displayed is greater than the number of current lots, lots that have been completed are also shown until the set limit has been reached.
Example: 3 lots are to be displayed. 1 lot is running, 5 have been completed. The one current lot and two completed lots are displayed.

Display completed lots

Active: The completed lots are displayed.

Note: If the number of lots to be displayed is greater than the number of completed lots, lots that have been completed are also shown until the set limit has been reached.

Use time filter from "Time" tab

Active: Pre-filtering is carried out with the settings of the Time tab. The effective range of the filter can be amended within this time range. Select from drop-down list:

  • Start and end also outside filter limits: (Default)
    Lots can start before the start time configured in the Time filter and end after the configured end time.
  • Start and end only outside filter limits:
    Lots must start and end within the time points configured in the Time filter for the start and end.
  • Start also before filter limit:
    Lots can start before the start time configured in the Time filter and end after the configured end time.
  • End also after the filter limit:
    Lots can also end after the end time set in the time filter, but must start at or after the configured start time.
  • Adjust start and end to filter limits:
    Lots are cut to the time points configured in the Time filter for the start and end.

Archives

Configuration of filtering for archives. Selection of one of the options:

  • No filter
  • Static
  • From variable

Note: Only available for the following modules if the Apply lot filter directly option has been selected:

  • Archive revision
  • ETM
  • Report Generator
  • Report Viewer

Parameters

Description

No filter

Active: Filtering for archive names is not carried out.

Static

Active: Archives whose identification corresponds to the character string entered in the input field are filtered for.

Input of the archive identifications in the input field:

  • Several identifications are separated by a comma (,).
  • * or empty: All archives, no filter.

From variable

Active: The value of the variables linked here is applied as a filter for archive names in Runtime.

Click on button ... in order to open the dialog for selecting a variable.

Only available for all modules if the Apply lot filter directly option has been selected:

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.

If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for archive names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Names

Configuration of the filtering to names. Selection of one of the options:

  • No filter
  • Static
  • From variable

Parameters

Description

No filter

Active: Filtering for lot names is not carried out.

Static

Active: Lot names that correspond to the character string entered in the input field are filtered for.

Input of the lot name in the input field:

  • Several entries are separated by a pipe character (|).
  • * or empty: All lots of all displayed archives, no filter.

From variable

Active: The value of the variable linked here is applied as a filter for lot names in Runtime.

Click on the ... button to open the dialog for selecting a variable.

Not available if the option Apply lot filter directly has been selected.

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.
  • If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for lot names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Archive: Start

Manual -> Historian -> Functions -> Archive: Start

This function starts an already-configured archive in Runtime.

attention Attention

Attention: If starting and stopping of the archive is defined via Start/End of the Runtime, the manual starting or stopping of archives via functions can lead to undesired behavior of the Runtime.

To configure the function:

  1. Select, in the Functions node, New function in the toolbar or the context menu.
  2. The dialog for selecting a function is displayed.
  3. Navigate to node Historian
  4. Select the Archive: Start function.
  5. The dialog for archive selection is opened:
  6. Select the desired archive
  7. Close the dialog by clicking on OK.
    The archive name is shown as a parameter in the list of functions.
  8. Link the function to a button.

In Runtime, the function starts the selected archive if it is executed.

Archive selection dialog

Parameters | Description
Available archives | Display of all configured base archives and aggregation archives. Selection by clicking on the entry.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Archive: Stop

Manual -> Historian -> Functions -> Archive: Stop

This function stops a selected archive in Runtime.

attention Attention

Attention: If starting and stopping of the archive is defined via Start/End of the Runtime, the manual starting or stopping of archives via functions can lead to undesired behavior of the Runtime.

To configure the function:

  1. Select, in the Functions node, New function in the toolbar or the context menu.
  2. The dialog for selecting a function is displayed.
  3. Navigate to node Historian
  4. Select the Archive: Stop function.
  5. The dialog for archive selection is opened:
  6. Select the desired archive
  7. Close the dialog by clicking on OK.
    The archive name is shown as a parameter in the list of functions.
  8. Link the function to a button.

In Runtime, the function stops the selected archive if it is executed.

Archive selection dialog

Parameters | Description
Available archives | Display of all configured base archives and aggregation archives. Selection by clicking on the entry.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Index archive

Manual -> Historian -> Functions -> Index archive

For quicker access to the lot values in the lot filter, an index can be created for each archive. The index is stored in the file [short name].ARI An entry is made in the index file each time a lot archive is saved. This entry contains an archive name, lot description and end time. With the evacuation of the archive the index also is updated.

Archives can be deleted or moved using file file operations. In this case, the index file must be reindexed. To do this, use the Index archive function.
Note: Indexing can also be automatic. To do this, activate the Index lots option in the Properties tab when configuring the archive.

You can read details on indexing in the lot archives chapter.

info Information

The Index archive function is always executed on the Primary Server.

To configure the function:

  1. Select, in the Functions node in the tool bar or in the context menu, New function.
  2. The dialog for selecting a function is displayed.
  3. Navigate to node Historian
  4. Select the Index archive function.
  5. The dialog for archive selection is opened:
    Only lot archives are displayed.
  6. Select the desired archive
  7. Close the dialog by clicking on OK.
    The archive name is shown as a parameter in the list of functions.
  8. Link the function to a button.

In Runtime, the function indexes the selected archive if it is executed.

Archive selection dialog

Parameters | Description
Available archives | Display of all configured lot archives. Selection by clicking on the entry.
Execute synchronously | Is only valid when executed in a script. Active: The next function only starts if this function has been completed.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Show active archives

Manual -> Historian -> Functions -> Show active archives

This function opens a window in Runtime that displays all currently-opened archives. The window is permanently displayed in the foreground.

To configure the function:

  1. Select, in the Functions node in the tool bar or in the context menu, New function.
  2. The dialog for selecting a function is displayed.
  3. Navigate to node Historian
  4. Select the Display open archives function.
  5. Link the function to a button.


Export archives

Manual -> Historian -> Functions -> Export archives

This function exports the recored entries of an archive to a file. The language of the identification and measuring unit can be switched on export. These are exported in the language in which Runtime is running.

The following must be configured for export:

  • General information on formats, content and export destination
  • the archive
  • the time filter
  • the lot filter

attention Attention

The file name of the export file must not contain any special characters.
Prohibited are: \ / : * ? " < > |

To engineer the archive export:

  1. Select, in the Functions node in the tool bar or in the context menu, New function.
  2. The dialog for selecting a function is displayed.
  3. Navigate to node Historian
  4. Select the Export archives function.
  5. The filter dialog for the configuration of the export is opened.

info Information

The number of decimal points when exporting archives in TXT, XML or DBF form, as well evacuation to an SQL Server, can be amended in the project.ini file with the ARCHDIGITS= setting in the [ARCHIV] section.

Default: ARCHDIGITS=1

Filter dialog

Tabs

Description

General

Definition of:

  • Export format
  • Columns to be exported
  • Options
  • Export file

Archive

Selection of the archive to be exported

Time

Stipulation of the corresponding time range.

Lots

Select desired lots

info Information

When exporting an active lot archive, the following entries are set automatically:

  • End time: the time of the export
  • Lot name: the current value of the lot variables

Attention: These values do not need to correspond to the values of the lot archive that has been ended.

Table structure and behavior on export

Table structure

Statements:

  • Table _DATA:

    "CREATE TABLE [" + szDBTable "_DATA"] ([PRJ] varchar(128),[ARV] varchar(2),[VAR] varchar(128),[CALCULATION] int,[TIMESTAMP_S] int,[TIMESTAMP_MS] int,[VALUE] varchar(128),[STATUS] int)"

  • Table_BATCH for lots:

    "CREATE TABLE [" + szDBTable + "_BATCH] ([PRJ] varchar(128),[ARV] varchar(2),[BATCH] varchar(128),[START_S] int,[END_S] int)"

Behavior on export

  1. No table name stated:

    The table called _DATA is created and the values are entered.
    (the table called _BATCH is also created, although no filters are active and no values are entered.)

  2. State table name XXX:

    The tables XXX_DATA and XXX_BATCH are created and the values are entered depending on configuration (lot activated/deactivated).

When exporting, either no name or the table name without _DATA is entered in zenon. If values are to be inserted into a certain table (such as MYPROJECT_DATA, only MYPROJECT can be given as a table name in zenon. If the name MYPROJECT_DATA is given, the table MYPROJECT_DATA_DATA is created and filled.

If a pre-existing table is exported (no name or named ohne _DATA), the values are also entered into the table. This happens regardless of whether the same values are already present in the table.

Memory check at reading back

When saved archives are read back the available memory is checked.

Save type

Save checking

SQL

If less than 10% of the memory available in the system are free, the read back of the data from the SQl server is canceled.

ARX files

The space available is checked before archive data (*.arx) is read in. The read in is canceled if:

  • less than 10% of the available memory is free
  • the size of the reserved memory (SPEICHER=) defined in project.ini is exceeded

The cancelation is documented in the Diagnosis Viewer via an error message.

attention Attention

If files are created in the Historian which exceed either the reserved memory in the project.ini or the 10% rule, these files cannot be read in.


General

Manual -> Historian -> Functions -> Export archives -> General

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following are defined in this tab:

  • Export format
  • Contents
  • File options

Export format

Selection of the format in which the export is to be made.

Format

Description

dBase

Active: Export in a Base IV - file (*.dbf).
Caution: DBF files must:

  • conform with there name to the 8.3 DOS format (8 alphanumeric characters for name, 3 characters for extension, no space)
  • be stored near the root folder

CSV

Active: Export to a CSV text file (*.txt).

Structure (-> stands for tabulator):
Name -> identification -> value -> unit -> (state_HI_DWORD)(state_LO_DWORD) -> second

XML

Active: Export to an XML file (*.xml).

SQL

Active: Export to an SQL database

Note: For export to an SQL database, the corresponding license must be present for the Editor and Runtime.

Exported columns

Selection of the columns of the database that are to be exported. This selection only applies for export to dBase and CSV. Fixed columns are defined for XML and SQL. If XML or SQL is selected as an export format, the column selection is grayed out.

Note: The short form(s) of the selected columns are listed beneath the selection boxes for the columns to be exported. In doing so, the order is the order of selection. Each short form is in the brackets next to the column name.

dBase and CSV

The following columns can be selected:

Column | Description
Variable name (V) | Active: Variable name column is exported. Contains the names of the variables.
Identification (I) | Active: Identification column is exported. Contains the variable identification.
Value (W) | Active: Value column is exported. Contains the technical value of the variables.
Unit (U) | Active: Unit column is exported. Contains the attendant unit of a value.
Status (S) | Active: Status column is exported. Displays the status of the variables.
Date (D) | Active: Date column is exported. Contains the date stamp of the variables.
Time (Z) | Active: Time column is exported. Contains the time stamp of the variables.

SQL

Columns for export are defined and fixed, and can no longer be selected. The following are exported:

Column | Description
PRJ | Project name
ARV | Archive identification
VAR | Variable name
CALCULATION | Not zero for entries from aggregation archives.
TIMESTAMP_S | Time stamp of the variables in Unix format.
TIMESTAMP_MS | Milliseconds for the time stamp.
VALUE | Value of the variables.
STATUS | Status of the variables (decimal value).

Options

Additional options for export.

Parameters | Description
Show this dialog in the Runtime | Active: This dialog is displayed in Runtime when the screen is called up.
Use archives from read-back folder | Active: Archives to be exported are read from the readback folder. When loading archive data from the readback folder, the archive data from the Runtime path and from all subfolders of the readback folder is also read.
Export as unicode | Active: The exported file is saved in Unicode (UTF-16). Only available for export format CSV.

Export to file

Definition of the file to which archives are exported.

Parameters

Description

File name

User-defined freely-available file name. The file is saved under the same name for each export.
Note: The name may not contain any special characters. Prohibited are: \ / : * ? " < > |

Only available if the Generate file name automatically option has been deactivated.

Generate file name automatically

Active: File names are automatically created from a short identifier and a day key.

Format of day key: YYMMDDHHMMSS.yyy

  • YY: Year (two-digits)
  • MM: Month (two-digits)
  • DD: Day (two-digits)
  • HH: Hour (two-digits)
  • MM: Minutes (two digits)
  • SS: Seconds (two digits)
  • yyy: file type (DBF, TXT, XML)

Generate name from lot name

Active: the lot name is taken for the creation of the export file name.

Only available if the Generate file name automatically option has been activated.

Attention: The lot name must not contain any special characters.

Postfix

Free identification that is automatically appended to the file names.

Maximum 29 ASCII characters.
Note: Only available if the Generate filename automatically is active.

Set export folder

Display of the defined export path.

You can change the folder in the Editor in the following menu: File-> General configuration-> Standard tab -> Exported archives folder.

Export to SQL database

Parameters | Description
Database connection | When evacuating to an SQL database: Stipulation of the database to be used. Note: Export to an SQL database must be licensed for the Editor and Runtime.
Table | When evacuating to an SQL database: Stipulation of the table to be used. Note: Export to an SQL database must be licensed for the Editor and Runtime.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Archive

Manual -> Historian -> Functions -> Export archives -> Archive

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The archive to be exported is selected in this tab.

Selection of an archive

Parameters | Description
Selection of an archive | Selection of an already-created archive from the archive tree. The selected archive name is displayed as a parameter in the list of functions.
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Time

Manual -> Historian -> Functions -> Export archives -> Time

The time filter is configured in this tab.

Filter

Selection of the filter.

Parameters

Description

No time filter

Active: No time filter is used.

Note: all Runtime entries since 1. 1. 1990 are displayed.

Absolute filter

Active: A fixed period of time is entered in the editor. When the function is executed, the defined absolute time period is exactly used.

In the settings section, the corresponding options can be shown and configured there.

Note: Time is saved in UTC. For details see chapter Handling of date and time in chapter Runtime.

Relative period of time

Active: A relative time period is entered.

In the settings section, the corresponding options can be shown and configured there.

Attention: this filter is constantly updated.

From

Active: A time from which the filter is effective is stated. If the time is not reached on the current day, filtering takes place from the corresponding time the previous day.

Selection of the area mode from drop-down list:

  • From HH:MM:SS o'clock
  • From day - HH:MM:SS o'clock
  • Starting on day, month at HH:MM:SS

In the settings section, the corresponding options can be shown and configured there.

Attention: The start point of this filter is not updated automatically. Only the existing times are used when shown.
The end time point is not defined with this filter, it is carried over.

Time period

Active: A fixed time period is entered. Selection of the area mode from drop-down list:

  • One day
  • One week
  • Two weeks
  • One month
  • One Year
  • 15 minutes
  • 30 minutes
  • 60 minutes

In the settings section, the corresponding options can be shown and configured there.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

Configuration is along the lines of time filtering for screen switching.


Lots

Manual -> Historian -> Functions -> Export archives -> Lots

The lot filter is configured in these tabs.

Filter

Settings for the application of the lot filter. Selection of one of the options:

  • No lot filter
  • Apply lot filter directly
  • Display lot selection dialog

Parameters

Description

No lot filter

Active: The lot filter is deactivated and cannot be configured. Filtering for lots is not carried out in Runtime.

Apply lot filter directly

Active: The filter configured here is applied in Runtime directly.

Display lot selection dialog

Active: The dialog for lot selection is shown in Runtime when:

  • Clicking on Filter or
  • screen switching, if the Offer this dialog in Runtime option has been activated (not available for each function/screen type)
    Note: The dialog is not shown on reloading.

Options can be pre-selected in the Editor.

Replace dialog in Runtime with screen

Not available if the Show lot selection dialog option has been selected.

Definition of a screen that is to be called up in Runtime instead of the lot selection dialog. Only time/lot filter screens are offered.

Click the ... button and the dialog opens to select a screen.

If the linked screen is not found in Runtime, a search is made for corresponding screens with specific names.

Relative lot selection

Only available for Extended Trend and faceplates and only if the option Display lot selection dialog has been activated. The Windows CE project property must be deactivated in the project properties.

  • Active: Enables several lots to be compared directly. Display always starts from the zero point.

Time

Configuration of the time filter for lot selection. Selection of one of the options:

  • No filter
  • Last lots
  • Use time filter from "Time" tab

Parameters

Description

No filter

Active: The time range set in the Time tab is not taken into account. All completed and current lots are displayed.

Last lots

Active: Input of the number of lots last concluded, according to what they should be filtered for. Input of the number in the number field or configuration via cursor keys.

The option allows the combination of both options Display current lots and Display completed lots.
Example: 3 lots are to be displayed, 2 are running and 10 have been completed. The following is shown: the two that are current and one that has been completed.

Attention: At least one of the two options Display current lots or Display completed lots must be activated. If both options have been deactivated, this corresponds to the No filter setting.

Note on compatibility: If the current lots or the combination of current and completed lots are selected and the project is compiled for a version before 7.11, the completed lots are shown in Runtime.

Display current lots

Active: The current lots are displayed.

Note: If the number of lots to be displayed is greater than the number of current lots, lots that have been completed are also shown until the set limit has been reached.
Example: 3 lots are to be displayed. 1 lot is running, 5 have been completed. The one current lot and two completed lots are displayed.

Display completed lots

Active: The completed lots are displayed.

Note: If the number of lots to be displayed is greater than the number of completed lots, lots that have been completed are also shown until the set limit has been reached.

Use time filter from "Time" tab

Active: Pre-filtering is carried out with the settings of the Time tab. The effective range of the filter can be amended within this time range. Select from drop-down list:

  • Start and end also outside filter limits: (Default)
    Lots can start before the start time configured in the Time filter and end after the configured end time.
  • Start and end only outside filter limits:
    Lots must start and end within the time points configured in the Time filter for the start and end.
  • Start also before filter limit:
    Lots can start before the start time configured in the Time filter and end after the configured end time.
  • End also after the filter limit:
    Lots can also end after the end time set in the time filter, but must start at or after the configured start time.
  • Adjust start and end to filter limits:
    Lots are cut to the time points configured in the Time filter for the start and end.

Archives

Configuration of filtering for archives. Selection of one of the options:

  • No filter
  • Static
  • From variable

Note: Only available for the following modules if the Apply lot filter directly option has been selected:

  • Archive revision
  • ETM
  • Report Generator
  • Report Viewer

Parameters

Description

No filter

Active: Filtering for archive names is not carried out.

Static

Active: Archives whose identification corresponds to the character string entered in the input field are filtered for.

Input of the archive identifications in the input field:

  • Several identifications are separated by a comma (,).
  • * or empty: All archives, no filter.

From variable

Active: The value of the variables linked here is applied as a filter for archive names in Runtime.

Click on button ... in order to open the dialog for selecting a variable.

Only available for all modules if the Apply lot filter directly option has been selected:

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.

If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for archive names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Names

Configuration of the filtering to names. Selection of one of the options:

  • No filter
  • Static
  • From variable

Parameters

Description

No filter

Active: Filtering for lot names is not carried out.

Static

Active: Lot names that correspond to the character string entered in the input field are filtered for.

Input of the lot name in the input field:

  • Several entries are separated by a pipe character (|).
  • * or empty: All lots of all displayed archives, no filter.

From variable

Active: The value of the variable linked here is applied as a filter for lot names in Runtime.

Click on the ... button to open the dialog for selecting a variable.

Not available if the option Apply lot filter directly has been selected.

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.
  • If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for lot names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

The lot filter is configured along the lines of filtering when screen switching.


Operating during Runtime

Manual -> Historian -> Operating during Runtime

Archives can be displayed and edited in Runtime with an archive revision screen.

Archives that are created in Runtime are stored as *.arx files in the Runtime folder of the computer:

%Public%\Documents\zenon_Projects\[workspace]\[project]\[computer name]\[project]

The current archive file has the name of the identifier. If the archive is closed, this file is saved and renamed, and another file with the name as the identifier as the name is created. For renaming, the UTC time is used for the area. The files are accessed in Runtime by means of filters. Operations with the files in the file browser are not necessary.

Values from archives can be edited, deleted and supplemented in Runtime, depending on the setting.

Attention: If files are created in the Historian which exceed either the reserved memory in the project.ini or the 10% rule, these files cannot be read in. For details, see the Export archives chapter.

info Information

For a decimal value, a comma (,) or a period (.) can be used as a decimal separator. In doing so, the decimal separator is automatically changed to a period internally.

Creating an Archive Revision screen

Control element | Description
Archive data window | Display of the archive data in Runtime.
Set filter (list) | Definition of the set filter.
Set filter (display) | Display of the set filter.
Archive status | Display of the archive status.
Short name | Display of the short description of the displayed archive.
Total number | Display of the number of the displayed values.
Number of INVALID | Display of the number of variables with the status INVALID.
Open archive | Opens the dialog to select an archive.
Close archive | Closes the archive that is currently open.
Save archive | Saves changes in the archive and updates the aggregated archives on request.
Edit entry | Opens the dialog to edit the selected archive entry.
Insert entry | Opens the dialog to insert archive entries into the archive files. If there are no archive files for this time range, no entries can be inserted. A corresponding error message is shown if an attempt to insert an entry is made.
Delete entry | Deletes selected archive entries after confirmation query.
Select | Clicking on the button opens the dialog to configure the filter.
Column configuration | Opens the dialog to configure column width and font.
Print | Prints list to configured printer.
Profile selection | Entry of a name for a new filter profile or selection of a filter profile from a drop-down list.
Save | Saves current filter as a profile with the name given in the filter profile text field.
Delete | Deletes the currently-selected filter profile.
Import | Opens dialog to import a filter profile.
Export | Opens dialog to export a filter profile.

Filter profiles

Filter profiles are filter settings that the user can save and call up in Runtime in relation to a certain screen.

To be able to use filter profiles, the following control elements must be configured:

Control element | Description
Filter profiles | Profile administration in Runtime.
Profile selection | Selection of a saved profile in Runtime from a drop-down list.
Save | Clicking on the button in Runtime saves the filter settings as a profile.
Delete | Clicking on the (X) button in Runtime deletes the selected profile.

With this you can in the Runtime:

  • save filters
  • use saved filters
  • delete filter profiles

Filter profiles can also be exported and imported with further control elements.

Functions

In online operation the following functions for archive control and monitoring are available.

  • Archive: Start: Manual starting of an archive selected in the Editor.
  • Archive: Stop: Manual ending of the archive selected in the Editor.
  • Index Archive: Subsequent indexing of lot archives.
  • Show active archives: Display of the archives that are currently running.
  • Export archives: Export of archives in various formats.

Editing of archives saved in SQL

Values can be changed with archives saved in SQL.
However it is not possible to:

  • Change the time stamp
  • Delete values
  • Insert values


Procedure

Manual -> Historian -> Operating during Runtime -> Procedure

When starting an archive in Runtime, a file xx.arx (xx = short identifier of the archive) is created. As soon as the archive is stopped, it is closed and named according to the rules.

String variables can also be archived.

attention Attention

Never close Runtime whilst archives are running. This also applies to ongoing processes that use archives (Batch Control, for example).

Reason: Ending with an archive running prevents correct closing.

Runtime was ended with a running archive

Problem: Runtime was ended whilst the archive was still running. That means:

  • The archive will not be closed.
  • The file can thus not be renamed.
  • the ARX file is still present

This leads to the following behavior:

  • The archive no longer continues to run when Runtime is restarted.

    If the archive is configured as a cyclic archive, then it is filled in with default values for the missing area in the current interval when Runtime is restarted. If no value was transferred, the defined alternate value is used otherwise the last valid value is used. Existing entries are not overwritten.

  • Execution of the Archive: Stop function no longer stops the archive. The ARX file can thus not be copied correctly.
  • No archive export can be carried out as long as there is an ARX file.

Solution: Start the archive again and then stop it. The archive is then correctly closed and renamed.
There may be invalid values in the archive.
Hint for engineering: In the scripts AUTOEND and/or AUTOEND_SERVPROJ, close all manually-started archives. These are thus automatically stopped and closed when Runtime is ended.

Values with a stopped archive

If values are generated whilst an archive is stopped, then:

  • With cyclic archives, substitute values are used to fill them
  • With archives without defined sampling time points, the last respective value with the status I-Bit is written to the archive

Reloading and server switch

If reloading is triggered in the Runtime that is running or there is a reclassification between Server 1 and Server 2, duplicate or moved values may occur.


Select

Manual -> Historian -> Operating during Runtime -> Select

Clicking on the selection button opens the dialog to select values that are to be displayed in bold.

All entries that correspond to the selected criteria are highlighted in the list. The bold print is removed again by activating the Delete selection option.

Filter dialog

Parameters

Description

Status list

Selection of the status bits that are to be filtered for. Selection and deselection by clicking on the respective status bit.

Only available if the All entries option has been deactivated.

Variable list

Variables that are to be displayed from the selected archive. Select and deselect them by clicking in the checkbox in front of the variables.

Only available if the All entries option has been deactivated.

Value (in base unit)

Active: Filtering is carried out for archive values whose value is between a minimum and a maximum or which contain a certain character sequence as a string.

Input of:

  • Minimum: Lower limit of the value
  • Maximum: Upper limit of the value
  • String mask: Character sequence that is be filtered for

Only available if the All entries option has been deactivated.

Delete selection
  • Active: All bold print in the list is removed when the dialog is closed.
    Deactivates input possibility for status bits and variables.

All entries

Active: Settings apply for all statuses and variables. The entries in status list, variable list and value cannot be selected individually.


Lot filter and time filter

Manual -> Historian -> Operating during Runtime -> Lot filter and time filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The filter settings configured in screen switching can be modified in Runtime. For that

  1. Open the screen switching function in the Editor.
  2. Click on Filter.
  3. Activate the Offer this dialog in the Runtime option in the Archive filter tab.
  4. If individual variables are also to be configured in Runtime, then deactivate the All entries option in th Editor.

In Runtime, the time filter or lot filter is displayed when the screen is called up, depending on the configuration:

  • Lot filter activated: Lot filter is offered
  • Lot filter deactivated: Time filter is offered

Configuration of lot filter

If you set option no time filter as time filter type, all Runtime entries since 1. 1. 2000 are displayed.

attention Attention

All configured lot archives are offered in the list of archives. The same archive as in the screen switching must be selected here. Only then is data also displayed.

Parameters

Description

Lot filter

Selection of the recipe group that is to be imported. The filter consists of the two lists:

  • List of archives: a list of the archives
  • List of lots: List of lots allocated to the selected archive.

List of archives

Selection of the desired archive

node *:

  • Collects all lots of the displayed archive.
  • The key is the lot name.
  • The start time is the start time of the earliest lot.
  • The end time is the latest end time of all lots.

List of lots

Display of the lots allocated to the selected archive.

Filtering through entry of text, date, time or rime range - depending on type.

Sort by clicking on the header.

Lot name

Displays the name of all available lots.

Filter: Entry of a character sequence. Only lots matching the respective character string will be displayed.

Start date

Shows the start date of all available lots.

Filter: Entry of a start date or selection from a calendar.

Start time

Only available if you entered a start date.

Display of the start time of all available lots.

Filter: Entry of a start time. * means 12:00:00 AM o' clock.

End date

Shows the start date of all available lots.

Filter: Entry of an end date or selection from a calendar.

End time

Only available if you entered an end date.

Display of the start time of all available lots.

Filter: Entry of a start time. * means 11:59:59 PM o' clock.

Duration

This column displays the duration for each available lot.

Display only.

info Information

Still open lots are also displayed if they match the set filter criteria.

info Information

The value of the lot variable is written in the index file and in the header of the ARX file at the start of the lot. These entries are adjusted with every change of the variable. When the lot is closed, the value of the lot variable at this moment is finally written in the index file and in the header.

Thus the lot name is final when the lot is closed.

SQL

Lot filtering to archive values evacuated into SQL is carried out by means of a time filter. This time filter contains all values of the archive between the start time and end time of the lot. The lot start time and lot end time are also included. Milliseconds are not taken into account with this time filtering.

Configuration of time range

The filter dialog for the time setting can be be offered in Runtime as specialized for a time range. To do this:

  1. Open the screen switching function in the Editor.
  2. Click on Filter.
  3. Open the Time tab
  4. Select the Time period option.

In Runtime, instead of the complete dialog, only one dialog to configure the time range is offered. For example, for the One day setting:

Example

With this setting, individual time ranges, such as shifts, can quickly be called up and configured.

For example: Shift from 6:00 AM until 2:00 PM.

  1. Select, as a time period: One day.

    As a default a day lasts from 00:00 till 00:00.

  2. Set the postponement of the time range to six hours.

    Now the day lasts from 6:00 a.m. till 6:00 a.m. the next day.

  3. Now set the time period to 16 hours.
  4. Keep the option Deduct time.

    This means that there will be back-calculation from 06:00 on the next day by 16 hours. Now the day lasts from 6:00 a.m. till 2:00 p.m., which corresponds exactly to a morning shift.

  5. Transfer the new Runtime files.
  6. Restart the Runtime.
  7. Select the desired day in the screen switching.

You get the data of the selected day from 06:00 am to 2:00 pm.


Define font and column width

Manual -> Historian -> Operating during Runtime -> Define font and column width

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For the list with the archive data, the font type and column width can also be changed in Runtime. To do this, the Diagram window control element must be configured. In Runtime, a click on the button opens the dialog for the configuration of the column width and the font:

Parameters | Description
Column width | Column width in characters. To amend the column width, enter the desired value in the text field in the text field next to the column.
Font | Selection of font type from drop-down list. All the fonts configured in the Editor are offered.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Standard | Sets all entries for column width to default values. The selected font is not changed.


Editing values

Manual -> Historian -> Operating during Runtime -> Editing values

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Variable values in archives can be edited in Runtime. To edit values:

  1. Highlight the entry in the list of archive data.

    Note: Several entries can also be selected at the same time.

  2. Click on the Open button or double click on the entry.
  3. The dialog to edit the value is opened.
  4. Enter the desired value and time stamp.

    If several archives are changed at the saved at the same time, all receive the value and time stamp entered in the dialog.

  5. Confirm the dialog by clicking on OK.

    If one or more values have been changed, then following happens after clicking on OK:

    • The status of the entry is set to manual value (MAN_VAL)..
    • The amended line is colored in blue
    • The column title is colored red
    • The Save button is activated
  6. Save the updated list by clicking on the Save button.
    Once the amended list has been saved, the color of the column title is reset again.

Edit archive dialog

Parameters

Description

Value

Entry of the new value

If several values have been selected, then:

  • The default value is always set to 0
  • The new value is applied to all highlighted entries

Time

Entry of the new time stamp

If several values have been selected, then:

  • The default value is always set to 0
  • The new value is applied to all highlighted entries

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.


Inserting values

Manual -> Historian -> Operating during Runtime -> Inserting values

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

New values can also be inserted into an existing archive.

To insert new values:

  1. Click on the Insert button.
  2. The dialog to create new values is opened

  3. Select a variable.
  4. Enter value, number and time stamp.
  5. Confirm the selection by clicking on OK.

    The following happens by clicking on OK and the entry in the list:

    • The status of the entry is set to manual value (MAN_VAL)
    • The new line is colored blue
    • The column title is colored red
    • The Save button is activated
  6. Save the updated list by clicking on the Save button.
    Once the amended list has been saved, the color of the column title is reset again.

Note:

  • If an entry is highlighted before the dialog has been opened, then:
    • The time stamp and cycle cannot be changed
    • If the new value is entered below the highlighted variable
  • No new values can be inserted into archives saved in SQL.
  • Once the amended list has been saved, the color of the column title is reset again.

Insert new dialog value

Parameters | Description
Value | Entry of the new value
Number | Entry of the number of the desired values.
Cycle time | Entry of cycle time in seconds.
Date | Entry of the date.
Time | Entry of the time point.
Variables | Selection of the variables from a list.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.


Store values in archive

Manual -> Historian -> Operating during Runtime -> Store values in archive

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

New and amended values must be saved so that they can be transferred to the archive. To do this, click on the Save button. The amended values are thus saved in the archive. If there are also aggregated archives for the archive, these are automatically updated.

If there are unsaved values in the archive, these are displayed by the headers being colored red.


Print archive

Manual -> Historian -> Operating during Runtime -> Print archive

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Archives are printed as a list by default by clicking on the Print button. This list can also be given a title line. To do this, there must be a format file with the name ARV_G.FRM in zenon.

To format the print-out:

  1. Create a formatting file:
    • Name: ARV_G.FRM
  2. Import the file in the Editor in the subnodes: Files\Texts and formats.

    This corresponds to the save location: %PUBLIC%\Documents\zenon_Projects\[Workspace]\[Project]\RT\FILES\zenon\custom\lists

  3. Check the printer set for lists and formats in the File -> General configuration -> Default -> Printer -> Values and protocols for output menu.

Configuration of the file called ARV_G.FRM

Create a text file with the name ARV_G.FRM.

This file contains the key words for the formating of the printout in Runtime.

Attention: The key words are entered in German for all languages.

Keyword | Meaning
@AMELDUNG | Limit value text of the archive entry.
@ARCHIVNAME | Name of the archive.
@DATZEIT | Date/time stamp of the archive entry.
@EINHEIT | Unit of the archive entry.
@HEADZEIT | Date/time stamp of the archive.
@KANALNAME | Variable name of the archive entry.
@SEITE | Page number for the print-out.
@STATUS | Status text of the archive entry
@TAGNR | Variable identification of the entry.
@WERT | Value of the archive entry.

The key words for the part of the cyclically-repeated archive entries in the list are included with the %% character.

Example

@HEADZEIT @ARCHIVNAME
Page: @SEITE -----------------

Date/Timet Variable name Value Measuring unit Status text Status
----------------------------------------------------------------------------------------------------------------
%%
@DATZEIT @KANALNAME @WERT @EINHEIT @AMELDUNG @STATUS
%%


Cycles in Runtime

Manual -> Historian -> Operating during Runtime -> Cycles in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The configuration of the recording type and saving in the Editor, as well as the start time of the archives has an effect on the execution in Runtime accordingly:

The start time set in the archive serves as the basis for the calculation of the save times. The save cycles are added from this time point on. zenon thus knows, each time Runtime is started, when the currently-running Alpha archive will be closed and a new file needs to be started.

If Runtime is stopped whilst data is being written to an archive, this file remains open. The next time it is started, Runtime checks to see if the file should now be closed.

  • Yes: The file is closed and a new file is started immediately.
  • No: The new data is added to the existing file and the file is used again. Values that are generated during the time that Runtime is down are entered by zenon with the corresponding Archive filler value and receive the status INVALID.

info Information

Always configure the scan cycle and save cycle in such a way that they are in whole-number multiples of one another, in order to avoid overlapping and thus imprecision in aggregated archives.


Use of archive data in zenon

Manual -> Historian -> Use of archive data in zenon

Data from archiving can be reused in zenon:

  • Report Generator
  • Report Viewer
  • Extended Trend

Furthermore, data can also be evaluated with the COPA-DATA product zenon Analyzer.


Report Generator

Manual -> Historian -> Use of archive data in zenon -> Report Generator

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Report Generator works on a cell-orientated basis.

Example for a report:

Each of these cells can be assigned certain formats and functions. A report is configured as its own screen as a Report Generator screen. The data is calculated, output and displayed using pre-defined report functions. These can be entered into the respective cells using a dialog or manually. To be able to display reports in Runtime, they must be configured in the Editor.

attention Attention

The desired printer must be selected before creating the report, because the page formatting of a report depends on the printer that has been set. Subsequent changing of the printer can necessitate reformatting of the existing table.


Archive and logging functions

Manual -> Historian -> Use of archive data in zenon -> Report Generator -> Archive and logging functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Basics

All archive functions build on the basic archive(FILTERINDEX,PARAMETER,RICHTUNG) function.

The expansions are distinguishable by additional letters in function names.

Code | Meaning | Comment
r | read only | There is only read access to the archive. Changed values cannot be saved.
sp | Columns | Provides special formatting to define cells to be used.
min | Mathematics | Only has an effect on value and time.
ex | extended | provides special treatments.
w | write | Writing is possible.

Filter index

The filter index creates a distinction between archive filter numbers used in the report functions and variables from the archives.

Example Example

=archive(5,"value","downwards")

FILTERINDEX = 5

The entry present in the filter under no. 5 is used for the report function.

Parameters

Options | Possible value
value | [1-n]
status | [1-n]
time | [1-n]
number | [1]

Direction

Options | Meaning
Right | Value is entered to the right (row). There must be sufficient cells left free for expected entries from further report creation. Attention: If an archivesp function is created with only one column, the value is entered downwards (in the column).
bottom | Value is entered downwards (column). There must be sufficient cells left free for expected entries from further report creation. Attention: If an archivesp function is created with only one row, the value is entered to the right (in the row).

All archive functions can be created with the function assistant.

On outputting the status information, the settings from the project.ini file in the [STATUS] section or the settings from the internally defined allocation are used. If the status labeling was changed in project.ini, the changed name is given. (Tip: makes it possible to keep the project compatible with old status labels.)

In online operation, the query time is either defined in the function query or given in Runtime when a report file is opened.

Change archive entries

If permitted by user authorizations, archive values can also be changed in Runtime. Changes are either saved manually via the Save control element or automatically saved when saving a report file. The status of an amended entry is automatically set to manual value.

info Information

Changing string fields in the report: If a text consists only of numbers, spaces are removed by default when it is saved. Spaces that are desired must be displayed by ASCII character 255 (Alt+255).


Report Viewer

Manual -> Historian -> Use of archive data in zenon -> Report Viewer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Report Viewer also allows archive data to be prepared for the user. However, in contrast to the Report Generator, these can not longer be modified. For this, the Report Viewer offers extensive graphic possibilities for display, such as diagrams. In addition, two time ranges for incoming analyses can be compared with one another.

To be able to create reports using the Report Viewer, software from third-party providers will also be required. Microsoft Report Designer is therefore also installed when zenon is installed. This opens as soon as you create a new report. There is a separate screen type for display in Runtime.

You can find details on the configuration in the Report Viewer manual.


Extended Trend

Manual -> Historian -> Use of archive data in zenon -> Extended Trend

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Extended Trend, which requires a license, provides online values and archive values from variables as curves. In contrast to the trend dynamic element, it is possible to zoom, browse, query and scale online values and values from archives. As with the Report Generator and the Report Viewer, there is also a separate screen type for Extended Trend. You can read details on the configuration switch in the Extended Trend manual.

Extended Trend Starter Edition

The standard license of the TAG based version on the PC includes a reduced version of the Extended Trend Module.

The Extended Trend Starter Edition has the following limitations:

  • no XY trend
  • no second time axis
  • number of curves limited to 8
  • no logarithmic representation
  • no scanning
  • no zooming


Additional information

Manual -> Historian -> Additional information

This section contains background information on archives and archiving.


Format of archive files

Manual -> Historian -> Additional information -> Format of archive files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Archives have the following data structure:

  • The archive file with the identification ARX contains the variable definitions and numerical data.
  • The ARS file contains the String data.
  • The archive header contains the archive definition and may or may not contain values of lot variables.
  • The memory that is reserved for the value of the lot variable is - in case the lot variable is a string - dependent on the string length. For numeric variables, a fixed amount of 32 characters is reserved. Lot strings are stored in Unicode. If no lot variable is defined, no memory is reserved.
  • The data record in the ARX file has a length of 24 bytes and also offers the possibility to store double values. The status information is 64 bit.
  • Archives can be stored at an interval of 1 second. For cyclical archives, it is recommended that save cycles greater than 30 seconds are adhered to.

Conversion of projects before version 6.20 SP0

From version 6.20 SP0, archive files are stored in ARX format; before that, the ARV format was used. If a project is converted, a check is made when Runtime is started to see whether there are archive files in ARV format in the Runtime folder. After confirmation of the conversion, the files are converted into ARX format. This conversion is done for all projects, before the projects start. The ARV files are deleted during the conversion. For evacuation to SQL, further columns must be added to the table.

Recommendation: Back up the ARV files before conversion.

Naming an archive

The name of an archive is formed of:

  • Short name
  • Save time in UTC in the format YYMMTThhmmss
  • File extension .arx

For example: XX140403071200.arx

XX | Name of the archive
14 | Year
04 | Month
03 | Day
07 | Hour (UTC)
12 | Minutes
00 | Second

UTC time and local time

Archive use local time when saved. The local time that is set on the computer consists of: UTC + time zone + standard time/daylight saving time. The zenon Runtime automatically considers the local time for archive requests.

Example: Berlin in the summer

  • Local time: 2:00 p.m.
  • UTC: 2:00 p.m. local time less 1 hour summer time less 1 hour time zone = 12:00 o' clock UTC
    The value that occurs locally at 2:00 p.m. is saved with the time 12:00.

You request values between 13:00 and 15:00 local time in Berlin. The Runtime then requests from the archive the values with a time stamp between 11:00 and 13:00 and displays them with the local time (13:00 to 15:00).


String variables

Manual -> Historian -> Additional information -> Format of archive files -> String variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

String variables can be archived. They are stored in a file called [short description][time].ARS. This file contains only the data of the strings and forms a logical unit with the ARX file. Information on whether a sting archive has to exist or not is stored in the ARX file. If no strings are stored in the archive, no ARS archive is created. If there are strings, the ARS file must be present.

attention Attention

File operations must include both files. If a required ARS file is missing, the data from the ARX file is also not loaded.

The string data is stored in Unicode with dynamic data length. This happens in order to save memory and is independent of the defined string length. In the data record of the ARX file, the position of the String record in the ARS file is stored. Assumptions about where strings are located in the ARS archive are misleading, as strings change their position when being edited.

An alternate value for strings is available in the variable properties, so that the archive is always supplied with values. The String archive filler value is used if zenon (e.g. for filling cyclic archives) needs a value for a string variable and no value is available. If no value was transferred, the defined alternate value is used otherwise the last valid value is used.

For the calculation of archive sizes, the editor calculates with maximal string length.

Size of data field

In general, the size of the data field is as large as the longest string variable in the archive. In doing so, the following applies for:

  • Archive evacuation:
    When creating the tables for archive evacuation with the zenon Editor, the column width is adjusted to the longest string.
  • Archive export:
    The column width is fixed at 128 characters. Characters that go beyond this are ignored.

Note on system driver variables: The string length is limited to 5 characters and cannot be changed. The string contents of the system driver variables can however be longer than 5 characters. Insert an additional string variable with a length of, for example, 256 characters into the archive in order to avoid data loss.

attention Attention

If the length of a string variable to be archived changes, this data field must be adapted when moving it to SQL or exporting it to SQL.

Note: These changes must be made before the changes are accepted in Runtime. Otherwise the longer Strings could be archived shortened.

Amend data field for SQL

The amendment can either be carried out manually with a tool for database administration (e.g. Management Studio for MS-SQL Server) or in the archive configuration.

To amend the data field in the zenon editor, carry out the following steps for each archive:

  1. Select Edit archive in the context menu of the archive
  2. Switch to the Save tab
  3. Go to the Evacuation after storage time section:
  4. Click on Create tables.


Evacuate to an SQL database

Manual -> Historian -> Additional information -> Evacuate to an SQL database

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The evacuation of archives to an SQL database allows the standardized storage of data for use in other applications. At the same time, the data can also continue to be used in zenon trends and reports. SQL databases also allow targeted optimization of data storage.

A distinction is made between two different stages of data storage when storing archive data in an SQL database.

  • Short-term data: Corresponds to the Keep archives setting in the Save dialog. These are saved in ARX format on the local data carrier.
  • Long-term data: After the period stated here the contents of this file is written to the SQL database as a combined transaction and deleted on the local disc.

If data from this archive is required for trends or reports, the locally-saved short-term data is automatically combined with the long-term data stored in the SQL database into a seamless dataflow again.

This property can also be used to use external data in zenon. After the necessary database tables have been created, these can be filled with data using external tools. The archive does not need to be started for this. The data inserted into the table is thus available for display in a zenon trend or a report.

SQL archives can also be evacuated to an MS Azure service bus. To do this, the Use MS Azure service bus for writing option must be activated for the archive configuration in the Save tab.

attention Attention

Duplicates cannot be evacuated to the SQL database due to the primary key!

  • Problem: Duplicates can occur with variables whose time stamp comes from an external device. For example: The controller sends special events shortly before a connection failure and repeats sending once the connection has been established again. Two entries with the same value and time stamp are then present.
    The SQL export cancels during an attempt to evacuate data with duplicates.
  • Solution: Remove the duplicates before evacuation in the Archive revision screen.

Duplicates from canceling when closing Runtime

If an export to the SQL database is carried out when Runtime is ended, Runtime is only ended if the export has been completed. If Runtime is ended prematurely in this time period by means of the process desk or the task manager, the following status occurs:

  • Part of the values are already in the SQL database
  • However the archive file was not deleted

When Runtime is restarted, an attempt is made to evacuate the archive file that is still present to the SQL database. Duplicates are not evacuated due to the primary key and are deleted from the Runtime folder. Originals are evacuated.

Formats of the tables

A table is generated for each archive in the database that contains the evacuated archive data. Additionally a cross reference table for the whole project is generated containing the allocation between the variable names and the unique numerical variable IDs.

info Information

When creating the SQL tables for archive data, lots and variables, a primary key is automatically created via the Editor.

Attention: For performance reasons, the primary key for archives is not optimized for non-cross-project variable references. The project GUID of the variables is thus not included. If archives with cross-project variable references are to be evacuated in SQL, the primary key must be deleted manually or supplemented with the project GUID.

Format of the data table

The data table consists of the following columns:

Column

Type

Meaning

VARIABLE

int[4]

numerical variable ID

CALCULATION

int[4]

Type of data reduction in aggregated archives.

Up to 4 values are possible: Sum, average value, minimum, maximum.
When exporting the aggregated archive to a file (e.g. .csv), the values 1 to 4 are written as strings:

  • 1=Sum
  • 2=Average value
  • 3=Minimum
  • 4=Maximum

At evacuation or export to SQL the values are written as Integer in ASCII code:

  • 49=Sum
  • 50=Average value
  • 51=Minimum
  • 52=Maximum

TIMESTAMP_S

int[4]

Time stamp in Unix time format

TIMESTAMP_MS

int[4]

Milliseconds for the time stamp

VALUE

float[8]

Value

STATUS

int[4]

Status flag of the value (zenon state)

GUID

varchar[36]

Records the project GUID of the variables. Must not be ZERO.

STRVALUE

varchar

the length depends on the longest string variable to be archived. For numerical variables this field has the value ZERO.

Primary key, clustered: TIMESTAMP_S and TIMESTAMP_MS and VARIABLE and CALCULATION and GUID.

The name of the database table comprises the project name and the short name of the archive together. Both tables are connected with an underscore:
ProjectName_ShortName
If the project name is ARV_IN_DB and the short name of the archive is A1, the table name is: ARV_IN_DB_A1.

attention Attention

Because the GUID is included in the index, the value of NOT must be zero. From zenon version 7.20, an empty string is entered instead of ZERO for the evacuation of variables of your own project for the GUID.

If Runtime files for version 7.11 or earlier are compiled, there is a compatibility problem as a result: Because ZERO is written in the GUID column here, the evacuation does not work.

Solution: The table in the SQL Server must be created manually without GUID in the primary key or completely without a primary key.

For example, with the following syntax:

CREATE TABLE [$projectname$_$archivename$]

(

[VARIABLE] int,

[CALCULATION] int,

[TIMESTAMP_S] int,

[TIMESTAMP_MS] int,

[VALUE] float,

[STATUS] int,

[GUID] varchar(36),

[STRVALUE] varchar(?),

CONSTRAINT [PK_$projectname$_$archivename$] PRIMARY KEY CLUSTERED

(

[TIMESTAMP_S] ASC,

[TIMESTAMP_MS] ASC,

[VARIABLE] ASC,

[CALCULATION] ASC

)

)

Format of the table for the lot name

The table with the lot names for SQL evacuated archives:

  • has the name [Project name]_[archive abbreviation]_BATCH
  • consists of 3 columns
Column | Type | Meaning
BATCH | varchar (128) | Lot name
START_S | int | Unix time stamp of the lot beginning
END_S | int | Unix time stamp of the lot end

Primary key, clustered: START_S and END_S.

Format of the cross reference table

Column | Type | Meaning
VARIABLE | int[4] | numerical variable ID
NAME | varchar[128] | Name of the variable
GUID | varchar[36] | Records the project GUID of the variables. Must not be ZERO.

Primary key, clustered: VARIABLE and GUID.

The name of the cross reference table is combined from the project name and the suffix VARIABLES. The two parts are connected with an underscore character. So if the project name is ARV_IN_DB, the table name will be ARV_IN_DB_VARIABLES.


MS Azure service bus

Manual -> Historian -> Additional information -> Evacuate to an SQL database -> MS Azure service bus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If the Using MS Azure Service Bus for writing option has been activated for the SQL evacuation of an archive, all archive values are added to the Azure service bus queue with the name archivequeue. This must exist in the MS Azure namespace of the configured connection. The MS Azure connection name is entered in the input field under the option.

Configuration

In MS Azure, there must be at least one instance of an AzureZenonArchiveWorker cloud service running, which receives the archive values from the queue with the name archivequeue and inserts these into the Azure SQL storage. The table format corresponds to the classical SQL evacuation of an archive.

The cloud service must be displayed manually with the AzureArchiveCloudService.cspkg deployment package via the MS Azure configuration user interface. You can find the package in the following folder: %ProgramData%\COPA-DATA\zenon7.20\CloudServices.

Settings:

  • Zenon.ArchiveServiceBus.ConnectionString: Corresponds to the MS Azure connection name in archive configuration.
  • Zenon.ArchiveSQLServer.ConnectionString: Denotes the name for the MS Azure SQL storage destination.

Procedure

The archive files are read via an OLEDB connection and SQL SELECT statement. The OLEDB connection name therefore generally shows the same MS Azure SQL storage as in the output connection name (Zenon.ArchiveSQLServer.ConnectionString) in AzureZenonArchiveWorker.


Conversion

Manual -> Historian -> Additional information -> Evacuate to an SQL database -> Conversion

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If archives from zenon versions before 6.20 SP0 are used in a new version, the following columns must be added manually:

  • STRVALUE in data table
  • GUID in cross-reference table

The columns are either added to the database directly or via the dialog in zenon Editor.

To add the columns in the Editor:

  1. Open the Edit archive dialog for each archive concerned.
  2. Open the Save tab.
  3. Open the dialog with the SQL database option.
  4. Close the dialog by clicking on OK.

After closing the dialog the according changes in the database are performed.

attention Attention

If these changes are not performed, no archive data will be evacuated to the SQL database.


Configuration

Manual -> Historian -> Additional information -> Evacuate to an SQL database -> Configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To store the data of an archive in a SQL database:

  1. Select in tab Save property SQL database.
  2. Click on the ... button
  3. The dialog to select a database is opened.
    1. Configure the provider.
      For example SQL Server Native Client.
    2. Configure the connection Verbindung.

      For example with zenon 2012 Server, with the standard zenon database user zenOnSrv, with the password srv_700.

    3. Test the connection.
    4. Close the dialog by clicking on OK.

    Once you have confirmed the dialog, zenon creates the cross-reference table and data table in the database. As soon as there is data to be evacuated, this is inserted into the data table. If zenon loses the connection to the database during operation, the data remains saved locally. The evacuation is continued as soon as the connection has been successfully reestablished.

  4. Click on the Create tables button if necessary.

    Via button Create table the tables can be created newly or adapted automatically at any time. If for example variables are added to or removed from an archive or the provider string is adapted manually. Every time you add or remove variables to or from archives which are configured for SQL evacuation, the tables must be updated in SQL.

attention Attention

When using Native Client 10 and 11, the password is not automatically carried over to the provider string. It must be entered manually

e.g.: ...;User ID=sqlExampleUser1;Password=secretPassword;...

Note: If you configure an archive for SQL evacuation and reconfigure the archive at a later time, you must adapt the tables in SQL respectively.
For example: You have configured an archive for the evacuation to SQL; the tables in SQL have already been configured. According to this, you link a variable for lot archiving. In this case, the tables in SQL must be created again. Otherwise the evacuation to SQL cannot be carried out, because the table for the lot information is not present.

attention Attention

Ensure that the provider configured in the connection is also available on the Runtime computer in Runtime.

Note: An SQL client is also installed with the zenon Editor. Because the zenon Runtime does not need an SQL Server, no SQL client is automatically installed. This can be downloaded from the Microsoft website and must be installed individually.

Ensure you install the correct version when installing the provider. This must suit the zenon version being used. This means: If a 32-bit zenon Runtime is used, the provider must be a 32-bit version. This also applies if it is installed on a 64-bit operating system and also if the database itself is a 64-bit application.


RDA

Manual -> Historian -> Additional information -> RDA

More detailed information on the configuration and administration of the RDA archiving.


PLC data format

Manual -> Historian -> Additional information -> RDA -> PLC data format

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Possible RDA data types are:

  • BYTE
  • WORD
  • DWORD
  • FLOAT

They depend on the drivers used in zenon.

Note: You can find out whether your driver supports RDA in the driver documentation.

attention Attention

No values from the future can be read in. Values can be in the future if the system times in the PLC and the computer are different. Ensure that the system times are always synchronized.


Description header

Manual -> Historian -> Additional information -> RDA -> Description header

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters

Description

Index [0]

RDA variable that has been added to the archive. Decides on the data type (for example BYTE, WORD, DWORD, FLOAT).

  • The size depends on the data type in zenon.
  • The trigger flag is set to 1 by the PLC if values are to be obtained. Once zenon has obtained the data, the flag is automatically reset to 0 by the driver.

Index [1]

Number of values that to be saved.

32-bit Intel format. Set by the PLC.

Index [2]

Cycle time in milliseconds; is used for TYPE 1 and 4 .

32-bit Intel format. Set by the PLC.

Index [3]

RDA type:

  • Type 1: Without time (is no longer used)
  • Type 2: With time format 1 (is no longer used)
  • Type 3: With time format 2
  • Type 4: Without time

32-bit Intel format. Set by the PLC.

Index [4]

Number of the most recent value. Should correspond to the value in Index [1].

32-bit Intel format. Set by the PLC.

Index [5]

Contains data. The content depends on the type.

  • Type 3: Values
  • Type 4: Time stamp.

Index [6]

Contains data. The content depends on the type.

  • Type 3: Time stamp
  • Type 4: Values

Index [etc.]


Time stamp format

Manual -> Historian -> Additional information -> RDA -> Time stamp format

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The time format is shown by an 8-byte long expression:

Byte | Corresponds to | Possible values
1 | Year Note: The time format starts with the year 1900 in a two-digit written form. 1900 = 00. Three digits are used from the year 2000 2000 = 100. | e.g. 99, 100, 114, etc.
2 | Month | 1 - 12
3 | Day | 1 - 31
4 | Hour | 0 - 23
5 | Minute | 0 - 59
6 | Second | 0 - 59
7 | Hundredths of a second | 0 - 100
8 | reserved | -


Types

Manual -> Historian -> Additional information -> RDA -> Types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There are different types available for RDA archiving. The following are currently used:

  • TYP 3
  • TYP 4

Attention: Type 1 and type 2 can still be configured for compatibility reasons. However they are no longer used or documented.
Type 1 was replaced by type 4; type 2 was replaced by type 3.


TYP 3

Manual -> Historian -> Additional information -> RDA -> Types -> TYP 3

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Index | Description
Index [0] | RDA variable.
Index [1] | Number of values to be saved.
Index [2] | Is ignored. (cycle time in milliseconds.)
Index [3] | RDA type.
Index [4] | Number of the most recent value.
Index [5] | First saved value. Size: Depends on the zenon data type.
Index [6] | Time stamp for the first value. (for details, see time stamp format).
Index [7] | Second saved value. Size: Depends on the zenon data type.
Index [8] | Time stamp for the second value. (for details, see time stamp format).
Index [...] | [n-th value]


TYP 4

Manual -> Historian -> Additional information -> RDA -> Types -> TYP 4

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Index

Description

Index [0]

RDA variable.

Index [1]

Number of values to be saved.

Index [2]

Cycle time in milliseconds

Index [3]

RDA type.

Index [4]

Number of the most recent value.

Index [5]

Time stamp.
For details, see time stamp format. First saved value.

Size: Depends on the zenon data type.

Index [6]

Saved values.

  • Value 1
  • Value 2
  • Value 3
  • Value 4
  • etc.


Note:

Manual -> Historian -> Additional information -> RDA -> Note:

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Note the following for RDA archiving:

  • The transfer of data takes time. With a trigger event, it is possible, depending on the number of values, that there is a transfer time of several seconds.
  • In redundancy operation, the longer transfer time may result in a server that is currently reading an RDA file not being able to synchronize completely due to a fault. The Sever that is to take over would read the RDA archive once again, because the trigger in this case has not yet been set to 0.
  • With TYPE 4, in contrast to TYPE 3, only the starting time is transferred.
  • The zenon RDA mechanism needs a coherent block in the controller that can be addressed with an offset. RDA is therefore generally not possible for drivers with symbolic addressing. There is a workaround available for some symbolically-addressable drivers. You can find an example afterwards under Example of a data type declaration in accordance with IEC 61131-3. You can find details in the respective driver documentation.

Example of a data type declaration in accordance with IEC 61131-3

RDA-Typ 3:

TYPE RDA_DATA_3 : (* Structure for RDA type 3 payload *)

STRUCT

Value : DINT; (* value

TimeStamp : ARRAY[0..7] OF BYTE; (* Time stamp (year, month, day, hour, minute, second, 1/100th second, reserve) *)

END_STRUCT

END_TYPE

TYPE RDA_3 : (* Structure for RDA type 3 *)

STRUCT

Trigger : DINT; (* trigger variable *)

Count : UDINT; (* Number of data sets *)

Cycle : UDINT; (* Cycle time in [ms] (only relevant for type 1 and 4) *)

RDA_Type : UDINT; (* RDA type, 1 - 4 *)

Oldest : UDINT; (* Index of the oldest value (placeholder for compatibility reasons, only relevant for type 1) *)

Data : ARRAY[0..19] OF RDA_DATA_3; (* Payload *)

END_STRUCT

END_TYPE

RDA-Typ 4:

TYPE RDA_4 : (* Structure for RDA type 4 *)

STRUCT

Trigger : DINT; (* trigger variable *)

Count : UDINT; (* Number of data sets *)

Cycle : UDINT; (* Cycle time in [ms] (only relevant for type 1 and 4 *)

RDA_Type : UDINT; (* RDA type, 1 - 4 *)

Oldest : UDINT; (* Index of the oldest value (placeholder for compatibility reasons, only relevant for type 1) *)

TimeStamp : ARRAY[0..7] OF BYTE; (* Time stamp of the first value (year, month, day, hour, minute, second, 1/100th second, reserve)) *)

Data : ARRAY[0..19] OF DINT; (* Payload *)

END_STRUCT

END_TYPE


History of changes

Manual -> History of changes

The history of changes serves for complete documentation of the phase of engineering. All changes to a project such as change, delete, create, etc. can be protocoled. Per default the history of changes turned off and must be activated in the Editor.

tutorial License information

Part of the standard license of the Editor and Runtime.

Project manager context menu

Menu item | Action
Export XML all... | Exports all entries as an XML file.
Export CSV all... | Exports all entries as an CSV file.
Activate extended filter | Opens the dialog for Engineering enhanced filter settings.
Deactivate extended filter | Deletes the settings for the extended filters and deactivates the property for the engineering of the extended filter settings.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.


Engineering in the Editor

Manual -> History of changes -> Engineering in the Editor

The history of changes must be activated in the Editor. To do this:

  1. navigate to Group History of changes in project properties
  2. Activate the propertyHistory of changes active
  3. select via property Detailling level which details should be recorded:
    • Object: Only the object names of the changed objects are logged.
    • Properties: Additionally to the object names the changed properties and the new values are displayed in the history of changes.
    • Value changes: Not only the new value of a property is displayed but also the old one. This makes complete traceability of the changes of values possible. This setting causes the most detail level of logging.
  4. For multi-user projects, the ability to enter a comment can be automatically unlocked for write access via the Automatically allow changes property;
    this setting is deactivated by default, because it can impair performance significantly

Protecting the history of changes

The activating/deactivating of the history of changes can be protected from unauthorized user access. To do this:

  1. navigate to Group User administration in project properties
  2. click in the field of property Function authorizations
  3. the dialog for changing the function authorization is opened
  4. select for Turn on/off history of changes the desired authorization level


Change history detail view of toolbar and context menu

Manual -> History of changes -> Engineering in the Editor -> Change history detail view of toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu

Menu item | Action
Filter Module | Sets the filter to the module of the selected entry.
Filter object | Sets the filter to the object of the selected entry.
Activate extended filters | Activates the property for engineering extended filter settings.
Deactivate extended filters | Deletes the settings for the extended filters and deactivates the property for the engineering of the extended filter settings.
Remove all filters | Removes all filter settings.
Copy | Copies the selected entries to the clipboard.
Delete | Deletes selected entries after a confirmation from list.
Export selected XML | Exports all selected entries as an XML file.
Export selected CSV | Exports all selected entries as an CSV file.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Properties | Opens the Properties window for the selected entry.
Help | Opens online help.


Logged data

Manual -> History of changes -> Logged data

If the history of changes is activated, the changes are displayed in the detail view of the project manager according to the selected settings. The first entry documents the activation of the History of changes. At deactivation the last entry is the deactivating of the history of changes.

Entry

Description

State

State of the object for multi-user projects.

Green: Object has the state Enable changes

Empty: Object has the state Apply changes

time stamp

Date and time.

Action

Type of interference. Possible values:

  • New
  • Changed
  • Deleted
  • New - VBA
  • Changed - VBA
  • Deleted - VBA

Module

The module (e.g. PFS, archive, report) where the changes have been made.

Object

Object which was changed.

Element

Element which was changed. Recorded is the name as defined in property Element name.

Property

The property of the objects/elements which were changed.

Old value

The value of the property before changes were done.

Only available if you selected Value change in project property Detailling level.

New value

Value of the property after the change.

Only available if in project settings under Detailling level

Properties or Value changes was selected.

User

The user who carried out the changes. If the user administration is not activated or no user is logged in, the Windows user is read out and entered.

Computer

The name of the computer where the changes have been made.

Comment

Freely usable text.

You can sort the columns as you wish by dragging&dropping. Each column can be filtered for certain content.

Note: If you can certain properties which open a dialog for additional settings, not all changes are recorded.
For example: In module Batch Control you change a parameter which is linked to a phase via a formula. This change is not recorded. If you change the formula, the change is recorded.


Filter data

Manual -> History of changes -> Logged data -> Filter data

There are two possibilities to filter displayed list of the history of changes:

  1. Enhanced filter of the history of changes
  2. Filter of the list view

Enhanced filter of the history of changes

You can reach the enhanced filter via the context menu in the project manager or in the detail view.

General settings

Parameters | Description
Maximum number of entries | Defines the maximum number of data sets which are displayed in the list. 0: Unlimited number Default: 1000

Time filter

Parameters | Description
Time period | Enables filtering on a specified time period or to or from a certain point in time. Active: Only entries from the given time period are displayed. Default: deactivated
From | Date and time after which changes should be displayed.
To | Date and time up to which changes should be displayed.


Logged actions

Manual -> History of changes -> Logged actions

In the history of changes the following is protocoled:

Object

Changes

zenon Logic
  • zenon Logic New project
  • zenon Logic Delete project
  • zenon Logic Change project

Archives
  • New archive
  • Delete archive
  • Change archive
  • Add variable
  • Delete variable

User
  • New user
  • Delete user
  • Change user

Screens
  • New screen
  • Delete screen
  • Change screen

Files
  • Add file
  • Delete file
  • Change file

Data types
  • Datatype new
  • Delete data type
  • Change data type

Dynamic elements/ Vector elements
  • Element new
  • Delete element
  • Change element

Functions
  • Function new
  • Delete function
  • Change function

Menus
  • Main menu new
  • Delete main menu
  • Change main menu
  • Context menu new
  • Delete context menu
  • Change context menu

Message Control
  • At saving changes

Process Control Engine (PCE)
  • At saving changes

Project
  • Move project within project tree

Project backup
  • Creating a project backup with version number.

Reaction matrices
  • Rema new
  • Delete Rema
  • Change Rema

Report
  • New report
  • Delete report
  • Change report- when saved

Recipe
  • Recipe new
  • Delete recipe
  • Change Recipe
  • Add variable
  • Delete variable
  • Change value

Recipegroups
  • Recipe group new
  • Recipe group delete
  • Change Recipe group
  • Recipe new
  • Change Recipe
  • Delete recipe
  • Add variable
  • Delete variable
  • Change value
  • Change source
  • Change source type

Frames
  • Frame new
  • Delete frame
  • Change frame

Scheduler
  • At saving changes

Fonts
  • Font new
  • Delete font
  • Change font

Scripts
  • Script new
  • Delete script
  • Change script

Language table
  • New entry
  • Delete entry
  • Change entry

Drivers
  • Driver new
  • Delete Driver
  • Change Driver

VBA
  • When saved the changes in the VBA-Editor an entry is generated.

Variables
  • Variable new
  • Delete variable
  • Change data point

Interlockings
  • New interlocking
  • Change interlocking
  • Delete interlocking
  • Variable new
  • Delete variable

Time control
  • Time function new
  • Delete time function
  • Change time function


Export data

Manual -> History of changes -> Export data

The data of the history of changes can be exported as XML or CSV file.

To export data:

  1. Highlight the desired entries
    (multiple selection is possible using the key combinations Ctrl+left mouse button, Shift+left mouse button and Ctrl+a)
  2. select the desired export form (XML or CSV) in the context menu
  3. the dialog for selecting where to save the file is opened
  4. enter a name and confirm by clicking Save

Note: The headings of the entries in the exported data are in English.


Import - Export

Manual -> Import - Export

Parts of a project (e.g. functions,variables, screens, etc.) can be imported to zenon or exported from zenon. Thus you can use, save or edit externally elements in other projects.

tutorial License information

Import and export are part of the standard license for the most formats.

Exception: SQL export must be additionally licensed.


General

Manual -> Import - Export -> General

The exported data can then be edited externally and be imported into the same or another project.

attention Attention

Limitations:

  • Formulas:
    import and export via CSV or dBase does not support driver-specific variable settings, for example no formulas. Export and import these via XML.
  • XML and backward compatibility:
    there is no backward compatibility with XML import/export. Data from older zenon versions cannot be taken over. The handover of data from newer to older versions is not supported.

The following functionalities of a project are available for import/export:

  • Variable definition
    • Data types
    • Reaction matrices
    • Allocations
  • Screens
    • Frames
    • Fonts
  • Functions
    • Script - Functions
  • Historian
  • Standard recipes
  • Recipegroup Manager
  • Time control
  • Interlockings
  • Menu administration
  • User administration

Here either all objects of one type or only selected objects can be exported.

  • All objects: Select the folder of the project manager -> Context menu XML Export all ...
  • Selected objects: Select one or more objects in the detail view ->Context menu XML Export selected...

On exporting/importing the objects are identified by their names not by their internal IDs, i.e.if objects are imported into another project, they do not have the same internal IDs there!

During the import a progress bar displays the status of the import/export.

attention Attention

If an element in the project and in the import file have the same name, then the element in the project is overwritten by the element from the import file. (The only exception are the data types.)

The properties of the objects are listed in the export file with their internal name, that is also used for the access from VBA.

The properties are described in detail in the properties help of the Editor.

Properties that do not exist in the import file (e.g. because they were deleted), are filled with default settings for elements that do not exist in the project and are newly created. If the elements already exist in the project, the missing properties stay unchanged.

Example Example

A variable first is imported without the offset. So the offset is initialised with the default value 0. With the S7 import the offset is changed to 100. Later the variable is imported again, the offset in the import file still missing. So the offset 100 stays unchanged.

attention Attention

The XML file to be imported has to be consistent. There is no plausibility check on importing the file. If there are errors in the import file, this can lead to undesired effects, even crashes.

You particularly have to care for this, if not all properties exist in the XML file and thus are filled with default values. For example: A binary variable has a limit of 300.


Archives

Manual -> Import - Export -> Archives

The export file for the archives has the following sections:

Archive list

On exporting/importing archives the linked variables or functions are not automatically exported/imported. You have to care, that the needed variables or functions are exported/imported before. Either all archives at the same time or selected archives can be exported/ imported.


Screens

Manual -> Import - Export -> Screens

Exporting screens

The included variables and functions are exported with the screens. The export file for the screens has the following sections:

  • Screens
  • Frames
  • Symbols
  • Variables
  • Functions

To export screens:

  1. highlight the desired screens
  2. select Export selected XML... in the context menu of the detail view
    Alternate: select, in the context menu of the Screen node, the XML export all... command
  3. the selection dialog for the saving location is opened
  4. select the desired saving location
  5. assign a name
  6. pay attention to file type XML
  7. confirm by clicking on the Save button

The selected screens are exported to an XML file and can be imported in this or in other projects at any time.

Importing screens

To import screens:

  1. in the context menu of node Screens or in the detail view Screens select the Import XML command
  2. the selection dialog for the saving location is opened
  3. navigate to the saving location of the desired XML file
  4. Select the desired file
  5. confirm the import by clicking on the Open button

The screens are imported.

Name conflicts during the import

At the import of a screen the name (attribute ShortName) which is stored in the XML file is used for the name of the screen which is created. If a screen with the same name already exist, the import is halted and an error message is displayed:

Parameters | Description
Yes | The screen described in the error message is replaced by the screen from the XML file at the import. If a new conflict occurs, the error message is displayed again.
No | The screen described in the error message is not imported. The existing screen is maintained. If a new conflict occurs, the error message is displayed again.
Yes, all | The screen described in the error message is replaced by the screen from the XML file at the import. This setting is used automatically when errors due to using the same name occur. All affected screen are replaced.
No, all | The screen described in the error message is not imported. The existing screen is maintained. This setting is used automatically when errors due to using the same name occur. All affected screen are maintained.

Note: Only the ShortName is used. The file name does not matter for the name of the screens which should be imported. Thus it cannot be used to solve the conflict.

Variables and functions in screens

Dynamic elements and Frames are automatically imported together with the screens. Variables and functions have to be imported manually before from the same file.

Only variables and functions of the first level are treated, i.e. variables and functions that are directly linked to the screen. As on the one hand variables can be linked to functions (e.g. setting values) but on the other hand functions can be linked to variables (e.g. limit functions), it can be necessary to first import the variables, then the functions, and then the variables again. Then all links should work correctly.

Example: A screen contains a button with a function Send value to hardwrae to a variable. The function is imported with the screen but not the variable.

info Information

Here we recommend using the XML Import Wizards.


Frames

Manual -> Import - Export -> Screens -> Frames

Frames can be imported/exported independently from the screens.

The frames are exported with the original coordinates (depending on the resolution of the source computer) When importing the frames, you have to be aware, that they are not automatically adapted to the resolution of the target computer.


Fonts

Manual -> Import - Export -> Screens -> Fonts

When exporting fonts, the following is exported:

  • Font list
  • Fonts

All these data are automatically imported with the fonts.


Symbols

Manual -> Import - Export -> Screens -> Symbols

Import/export of symbols is possible from the project and the global symbol library. Single or selected symbols or the entire library can be imported or exported. The path for the export can be defined freely.

Export symbols

To export symbols:

  1. highlight the desired symbols
  2. select Export selected XML... in the context menu of the detail view
    Alternate: select, in the context menu of the project symbol library node, the XML export all... command
  3. the selection dialog for the saving location is opened
  4. select the desired saving location
  5. assign a name
  6. pay attention to file type XML
  7. confirm by clicking on the Save button

The selected symbols are exported to an XML file and can be imported in this or in other projects at any time.

Import symbols

To import symbols:

  1. in the context menu of the node or the detail view of the Project symbol library or in the detail view of the Global symbol library select Import XML... command
  2. the selection dialog for the saving location is opened
  3. navigate to the saving location of the desired XML file
  4. Select the desired file
  5. confirm the import by clicking on the Open button

The symbols are imported.

Name conflicts during the import

At the import of a symbols the name (attribute ShortName) which is stored in the XML file is used for the name of the symbol which is created. If a symbol with the same name already exist, the import is halted and an error message is displayed:

Parameters | Description
Yes | The symbol described in the error message is replaced by the symbol from the XML file at the import. If a new conflict occurs, the error message is displayed again.
No | The symbol described in the error message is not imported. The existing symbol is maintained. If a new conflict occurs, the error message is displayed again.
Yes, all | The symbol described in the error message is replaced by the symbol from the XML file at the import. This setting is used automatically when errors due to using the same name occur. All affected symbols are replaced.
No, all | The symbol described in the error message is not imported. The existing symbol is maintained. This setting is used automatically when errors due to using the same name occur. All affected symbols are maintained.

Note: Only the ShortName is used. The file name does not matter for the name of the symbol which should be imported. Thus it cannot be used to solve the conflict.


User

Manual -> Import - Export -> User

The export file for the users has the following sections:

User list

Locally users, that have been created in the project, can be exported/ imported.

attention Attention

The passwords of the users are exported in an encrypted form! So they cannot be changed directly in the export file.


Data types

Manual -> Import - Export -> Data types

The export file for the data types has the following sections:

Data type list

See also chapter: Import of variables and datatypes.


Creating data types manually

Manual -> Import - Export -> Data types -> Creating data types manually

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

attention Attention

Only for experts

If a data type should be entered in the XML file manually, the following definition should be used:

info Information

<Apartment ShortName=' zenon(R) type list' Version=' 0x00000000' >
<Type TypeID=' 3' IsComplex=' FALSE' >
<Name>UINT</Name>
</Type>
</Apartment>

The other properties of the data type definition should be left out.


Functions

Manual -> Import - Export -> Functions

On exporting/importing functions the linked variables, etc. are not automatically exported/imported. You have to care, that the needed objects are exported/imported before.

info Information

From zenon version 6.50 and above, time information is saved in an XML based function in UTC (seconds from 01.01.1970, 00:00 am). This affects, for example, functions such as screen switching on the following screen types:

  • Alarm Message List
  • Alarm Message List Filter
  • Archive revision
  • Chronological Event List
  • Chronological Event List Filter
  • Extended Trend
  • Production & Facility Scheduler
  • Report
  • Time filter

For versions of zenon older than 6.50, this information is saved on a string based format (for example 02.01.1970 01:00:00).


Scripts

Manual -> Import - Export -> Functions -> Scripts

The export file for the scripts has the following sections:

Script list

On exporting/importing scripts the linked functions are not automatically exported/imported. You have to care, that the needed functions are exported/imported before.

Each script has its own section in the export file containing the script's name and the names of the linked functions.


Menus

Manual -> Import - Export -> Menus

The export file for the menus has the following sections:

Menu list

On exporting/importing menus the linked variables, functions, help pages and macros are not automatically exported/imported. You have to take care that the needed variables or functions are exported/imported before.


Reaction matrices

Manual -> Import - Export -> Reaction matrices

The export file for the reaction matrices has the following sections:

Reaction matrix list


Standard recipes

Manual -> Import - Export -> Standard recipes

The export file for the standard recipes has the following sections:

Recipe list

Variable list

Driver list

Data type list

The included variables are exported with the standard recipes. The recipes are imported automatically. The variables have to be imported manually before from the same file.

In addition to the XML import/export, standard recipes can also be imported in ASCII format.
Attention: With the ASCII import recipes can only be imported singly.

The non-linearized value of the recipe is saved. This value is used for VBA and for the export of recipes via XML.


Recipegroups

Manual -> Import - Export -> Recipegroups

The export file for the recipes of the Recipegroup Manager has the following sections:

  • Recipegroup list

On exporting/importing the recipe groups and their recipes, the linked variables are not automatically exported/imported. Take care that the needed variables are exported/imported before.

The XML file is based on the recipegroups, i.e. single recipegroups are are imported (with their variables and recipes and recipe values). After an import, existing recipe values, which are not in the import file, will still exist. The same is true for recipes and linked variables.

When importing a single recipe from the recipegroup, the following applies: The associated recipegroup must be selected. An according message will be shown in the output window.

info Information

In addition to XML, the RGM also supports ASCII import of recipes.
Attention: With the ASCII import recipes can only be imported singly.


Variables

Manual -> Import - Export -> Variables

Variables can be exported and imported with zenon :

  • XML: Export and Import; during import the files are analyzed and in case of conflicts, solutions are offered
  • CSV: Export and Import; during import the present data is overwritten
  • DBF : Export and Import; during import the present data is overwritten
  • S7: Import
  • TwinCAT Projekt: Import

info Information

When importing/exporting via CSV, no complex variables (structure variables, arrays) can be imported or exported.

Export

The export file for the variables has the following sections:

  • Variable list
  • Driver list
  • Data type list

Along with the variables the drivers and the datatypes are also exported. See also manual Variables, chapter Export data.

attention Attention

A driver is absolutely necessary in the XML file, too; otherwise no variables are imported! Also be aware that the XML file driver settings are project-dependent.

Import

During Import of the variables, zenon opens a dialogbox in which the source drivers of the XML file can be allocated to target drivers in the project. All variables of the source driver are then imported as variables of the selected target driver. The data types are automatically imported with the variables. The drivers have to be created in the project before the import. See chapter Import of variables and datatypes.

attention Attention

Changes for variables are collected in a unsorted list. Therefore only one change per variable can be taken over per import. If several changes should be taken over, it must be done via several import processes.

Example: If the same variable is renamed and deleted in the same import process, the import could lead to a not deleted but renamed variable in the project.

Import structure variables:

Structures

Structures which differ from existing ones can be imported in already existing structures. Variables based on this are automatically adapted.

  • The structure elements are identified by their name.
  • At already existing structure elements the type is adapted if necessary.
  • Non-existing elements are added.
  • Elements which do not exist in the structure data type are removed.

Inactive variables

At the import of structure variables, active and inactive variables are imported. Existing imports are not overwritten at the import. If an inactive variable is imported to a project and then activated, it stays active even after a new XML import.


Import and export of variables and datatypes

Manual -> Import - Export -> Variables -> Import and export of variables and datatypes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For the import/export of variables the following is true:

  • The import/export must not be started from the global project.
  • The start takes place via:
    • Context menu of variables or data typ in the project tree
    • or context menu of a variable or a data type
    • or symbol in the symbol bar variables

attention Attention

When importing/overwriting an existing data type, all variables based on the existing data type are changed.

Example:

There is a data type XYZ derived from the type INTwith variables based on this data type. The XML file to be imported also contains a data type with the name XYZ but derived from type STRING. If this data type is imported, the existing data type is overwritten and the type of all variables based on it is adjusted. I.e. the variables are now no longer INT variables, but STRING variables.


XML import

Manual -> Import - Export -> Variables -> XML import

When importing variables or datatypes they are analyzed by zenon according to the Driver allocation. The user can subsequently decide what to do with the according variables / datatypes:

  • import
  • overwrite
  • do not import

Only reasonable actions are offered.

The following conflicts prevent the import:

  • The data type already exists and the linked variable cannot be converted to the data type you want to import.
  • The data type is complex and the elements of the existing one differ from the elements of the one to be imported in number or name.
  • The data type is complex and contains the same elements, but the elements differ in their data types, so that a conversion of the linked variables is not possible.
  • The variable type cannot imported (see above).
  • The variable type differs from the existing one (simple/complex).
  • The driver assignment for the variable is incorrect (the assigned driver does not support the according datatype and/ot the respective area).

TAGs

Description

Elements to be imported

Lists all variables and data types that are to be imported. For complex variables, the according simple variables are shown. Structured types can be expanded, the elements of structure datatypes are displayed for information purposes.

Symbols show if the element can be imported (green check mark), cannot be imported (red X) or if a conflict must be solved (blue symbol).

Import details:

Describes import status and offers solutions for conflict resolution.

Description

Describes the element status.

Available actions

Describes the available actions.

Action

Drop-down list with the available actions and the currently selected action. If only one action is possible, it is preselected and cannot be changed.

Import new data type / variable

The variable / data type does not exist yet. It is created by the import. (Default)

Cannot be changed by the user.

Do not import data type/variable

The variable/data type already exists, there are conflicts.

Cannot be changed by the user.

Import data type/variable

The variable/data type already exists, there are no conflicts.

The user can decide whether the variable/data type should be overwritten or not imported. Per default, the variable/data type is overwritten.

Limitations

  • Consistency

    The XML file to be imported has to be consistent. There is no plausibility check on importing the file. If there are errors in the import file, this can lead to undesirable effects in the project, and even crashes.

    You particularly have to care for this, if not all properties exist in the XML file and thus are filled with default values. For example: A binary variable has a limit of 300.

  • Backward compatibility

    At the XML import/export there is no backward compatibility. Data from older zenon versions cannot be taken over. The handover of data from newer to older versions is not supported.

  • Structure data types

    Structure data types must have the same number of structure elements. If, for example, a structure data type in the project has three structure elements, a data type with the same name in the XML file but four structure elements, none of the variables based on this data type from the export file are imported into the project.


Allocate driver

Manual -> Import - Export -> Variables -> XML import -> Allocate driver

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The command Import opens the dialog for driver assignment:

Parameters | Description
Allocation table | Displays the current allocation.
Allocate driver object type | Opens the dialog for allocating the driver object types.
Cancel driver allocation | Resolves existing allocations.
Driver list | Lists all existing dirvers of the project.
Create new driver | Open dialog in order to create a new driver.
Allocate driver | Allocates the selected driver from the driver list to the driver selected from the allocation table.
OK | Applies settings, closes the dialog and starts the import.
Cancel | Discards settings and closes the dialog without import.
Help | Opens online help.

Create new driver

During import, you can create and allocate new drivers by using the button New driver In the process, the dialog for Creating and Configuring new drivers is opened.


Assign area

Manual -> Import - Export -> Variables -> XML import -> Assign area

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters | Description
Allocation table | Displays the current allocation.
Cancel allocation | Resolves existing allocations.
Driver object type of the target driver | List of the available drive object types.
Allocate driver object type | Allocates the selected driver object type of the target driver to the selected driver object type in the allocation table.
OK | Applies settings and closes the dialog.
Cancel | Discards settings and closes the dialog.
Help | Opens online help.


Error treatment import

Manual -> Import - Export -> Variables -> XML import -> Error treatment import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If during the variable import incompatibilities are noticed, the dialog for error treatment is opened.

Elements to be imported

Parameters | Description
Elements to be imported | List of elements which should be imported. Faulty elements are highlighted.

Import details

Parameters | Description
Import details | Details about the import.
Description | Error description.

Available actions

Parameters | Description
Possible actions | Description of the actions which can be set for this error.
Actions | Drop-down list for the selection of the desired action.
OK | Take over actions, closes the dialog and imports variables.
Cancel | Discards the entry and cancels the import of the variables.


Manual editing of the variables XML file

Manual -> Import - Export -> Variables -> XML import -> Manual editing of the variables XML file

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

XML-files can be edited after export and/or before the import with an external program.

attention Attention

External editing of XML files is recommended only for experts.
Incorrect imports can damage or destroy your project. Therefore always save your project before you edit it.

The header definitions must contain the following attributes:

TAGs | Description
ShortName | Name of the variable
DriverID | Driver ID Please consider that the identification of every driver is project-dependent. You can identify the driver exactly by creating a driver and an associated variable in your project and exporting it via XML.
TypeID | ID for the data type CAUTION: the TYPEID also depends on the project. Details can be found in Import for data types.
HWObjectType | Identification of the driver object type The area on the PLC is defined here, e.g. data block area, marker area, input, output, etc. Please consider that not every driver supports all object types. Please look at the documentation of the according driver to find out which driver supports which object types. The correct identifications are listed in the category tpKanaltypes in the VBA object catalogue.
HWObjectName | Name for the driver object type Redundant information for the HWObjectType. This property only serves for information purposes.
IsComplex | TRUE = Structure variable FALSE = simple variable
Matrix | Name of the linked reaction matrix This property is empty if no reaction matrix is linked.

Syntax examples for editing the XML file:

No. | Example | Expression | Comment
1 | Creating a new variable during import | <Variable ShortName='WIZ_VAR_10' DriverID='4' TypeID='2' HWObjectType='8' HWObjectName='PLC marker' IsComplex='FALSE' Matrix=''> |
2. | Deleting an existing variable during import | <Variable ShortName='WIZ_VAR_10' Delete='TRUE' DriverID='4' TypeID='2' HWObjectType='8' HWObjectName='PLC marker' IsComplex='FALSE' Matrix='>> | If the variable existed in the zenon project, you can delete it by using the attribute Delete. Please make sure that the attribute is not empty. This means it must contain e.g. TRUE or FALSE. The content of the entry is not evaluated in this case.
3. | Renaming an existing variable during import | <Variable ShortName='WIZ_VAR_10' Delete='TRUE' DriverID='4' TypeID='2' HWObjectType='8' HWObjectName='SPS-Merker' IsComplex='FALSE' Matrix='' NewName='Standard_1'> | When renaming, the variable is first imported and then renamed. This means you can change the variable´s properties and rename it at the same time. If there is already a variable with the new name, renaming fails. The output window provides you with further information.


CSV import

Manual -> Import - Export -> Variables -> CSV import

Variables can be exportedwith zenon to CSV files and imported from CSV files, for example for further editing in Microsoft Excel. Variables exported to CSV are always saved as TXT files in unicode format.

If the compatibility limit of Microsoft Excel was surpassed during the export and the export was executed in spite of a warning, the TXT file to be imported doesn´t contain all exported data.

Format specification

  • Separator: Tab
  • File ending: .txt
  • Encoding: The exported file is encoded in unicode. The file to be imported has to be encoded in unicode, too.

info Information

Import and Export via CSV or dBase supported; no driver specific variable settings, such as formulas. Use export/import via XML for this.

Compatibility with Microsoft Excel

Export to Excel

For proper import of exported variables in CSV files in Microsoft Excel, please mind:

  • Format:
    In order for Microsoft Excel to use the proper decimal seperator, you have to set the format in your operating system´s Regional and language options to English. Attention: This setting is mandatory for the usage of decimal seperators, otherwise the values are interpreted/saved incorrectly.
  • Unicode:
    The files must be saved in Microsoft Excel as Unicode text (.txt). They are saved as TXT files. In older versions of Microsoft Excel, the description can differ slightly.
    Attention: When using a different format, the data cannot be imported properly!
  • @ sign:
    Microsoft Excel interprets @ signs in a cell not as text and therefore might not allow editing. You have to change the cell type (category) from Standard to Text for editing cells with @ signs. For that
    • mark the cell or the column
    • right-click on the cell and choose the command Format cells in the context menu.
    • Switch the category in the dialog to Text
  • Maximum values:
    • Microsoft Excel 97-2003: 65536 lines, 256 columns
    • Microsoft Excel 2007: 1048576 lines, 16384 columns

attention Attention

If the number of 16384 or 256 columns and 1048576 or 65536 lines is exceeded, a dialog pops up and you can select to export correspondingly less dynamic properties (if possible). If you choose the limitation, as many dynamical properties as possible are exported.

Statistical properties are not limited.

If removing the dynamical properties is not sufficient, an additional message pops up.

For the maximum number of variables you have to take into account that the header needs its own line, too.

Import from Excel

At the import from Excel you must not delete the last (empty) line. Otherwise the CSV file cannot be imported to zenon.


Minimum requirements

Manual -> Import - Export -> Variables -> CSV import -> Minimum requirements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Definition of formats

Format | Contents
VariableName | Name the variable shall bear
DriverName | Description of available driver
DriverType | Type of available driver
HWObjectType | Number of driver Object type, the name depends on the language. Is also described as driver object type and can be found out either through export of an according variable or with the help of the driver documentation.
TypeName | Name of the available Data type

Contents

  • Driver of imported DRIVERTYPE and imported DRIVERNAME must exist:
    If no driver with the DRIVERTYPE and the DRIVERNAME can be found, the next step is to try to link the variable with a similar driver. First, only the DRIVERTYPE, then only the DRIVERNAME is looked for. If no driver for an allocation can be found, the next step is to try to link the variable with the Internal driver, then with an existing driver. If no driver is available or the variable can´t be allocated to a driver, the variable is not imported. The dialog driver allocation (see chapter Import of variables and data types) allows to create and/or change the relevant link before the variable is imported. This dialog can be opened after the file you want to import has been selected.
  • Simple data type with the imported TYPENAME and the imported HWOBJECTTYPE:
    If the data type with the relevant TYPENAME is not available, the variable is not imported. After all further variables have been executed/imported, the output window displays how many variables could not be imported because of missing data types.

Header

A header must exist to describe the property values:
The Header describes the properties based on columns. The first entry in the header is always valid for the first values entry, the second entry in the header is always valid for the second values entry and so on. The number of fields in the header must correspond with the maximum number of fields of the whole file.

  • The header
    need not be located in the first line of the file, but it must be the first/top line of all lines.
  • The case
    • is not important for the header.
    • is considered for the property values.
  • The header must be concise and complete.
    If an empty field (area between separators) is located in the header, the import is cancelled.
    Definition empty field: Two successive separators without content in between.
  • Leading and terminating spaces
    in a field (no matter if with or without quotation marks) are interpreted as such. No spaces are removed. Therefore, the value/field must be precise.
  • The separator
    should not be used at the end of a line, with one exception: An existing field with an empty value.
  • All fields (area between separators) where the separator appears must be in quotation marks.
    That affects only the according field. The remaining fields that do not meet these criteria do not have to be in quotation marks. Tabulator-separators are automatically removed in a field in quotation marks.
  • If quotation marks are to be used,
    the whole field (area between separators) must be within quotation marks and each intentional quotation must also be directly doubled. Thus, the number of quotation marks must always be even.
    Example:
    • T"e"st becomes "T""e""st",
    • "AB"C" becomes """AB""C""",
    • AB"C becomes "AB""C"
  • Only two quotation marks in a field without text in between them are not valid for empty values.
  • Empty fields (2 successive separators)
    are interpreted as a non-existing entry for this column. If the field of a property that exists for the variable is empty and therefore not set the standard value of this property is used.
  • If less fields exist for values than determined in the header,
    the remaining non-existing fields are interpreted for values as empty fields.
  • If the number of values/fields
    in a line is greater than the number of fields determined in the header, the last/affected values/fields are ignored.
  • Semicolon and comma
    can be freely used in fields (without quotation marks).
  • Points
    are always considered decimal separators for numeric values.
  • Empty lines are allowed.
    They are ignored.

Names, links and replacements

  • Every variable must have its own name in the file.
    If multiple variables with the same name exist, then the first one is imported and the others are ignored.
  • Links must exist.
    Reaction matrix, functions, variables, alarm areas, alarm/event groups, alarm/event classes, interlocking and so on are only linked during import if they exist in the project. If the element does not exist under the name, the element is not linked. If a property cannot be linked, the remaining properties are nevertheless imported, regardless of that fact.
  • Dynamic properties (like for example limits) have a common identification and a sequence number.
    The sequence number begins with 0. The description is similar to the XML export format. (for example: Limits_8_Active, Limits_8_Text, Limits_8_LimitValue, …)
  • array variables and variables of complex data types are neither exported nor imported.
  • Available complex variables are not overwritten during the installation.
  • The import of a variable is allowed if the same name exists in a child element of an existing complex variable. If e.g. the name of the variable you want to import is ABC.DEF and the variable DEF in the zenon Editor is a child of variable ABC in the Editor, the variable is inserted nevertheless.
  • All properties that are imported or exported have similar column/header names as in the XML import or export. The column/header names are found out the easiest way by exporting an according variable.
  • Some drivers have driver-specific properties. To find the according column/header names, exporting a variable with the corresponding driver is the most suitable solution.

Limitations

Properties that are not exported or imported:

  • ID_ComplexVariable
  • ID_Complex
  • HWObjectName
  • ID_DriverTyp
  • DriverID
  • TypeID
  • IsComplex
  • All IsLocal or Flag properties
  • IsSWProtokol, IsSW_Akt and IsSW_VBA


Delete or rename variable during import

Manual -> Import - Export -> Variables -> CSV import -> Delete or rename variable during import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can delete or renamed variables during the import. The deleting is carried out via an entry in field KANAL_D. The renaming is carried out via an entry in field KANAL_R. The variable which should be deleted or renamed is defined in filed VariableName.

Delete variables

Variables are deleted if valid entries are detected in filed KANAL_D and in field VariableName of the CSV file.

Field | Function | valif if
KANAL_D | Sets delete command. | 1
VariableName | Name of the variable which should be deleted | Entry which does not consists solely of unprintable characters

For deleting you can use CSV files which only consist of these two fields (Short-Format).

Rename variable

Variables are renamed if valid entries are detected in filed KANAL_R and in field VariableName of the CSV file.

Field | Function | valif if
KANAL_R | Original name of the variable which should be replaced. | Entry which does not consists solely of unprintable characters
VariableName | New variable name. | Entry which does not consists solely of unprintable characters

For renaming you can use CSV files which only consist of these two fields (Short-Format).

attention Attention

If the renaming and the deleting is commanded in the same line, the variable is deleted.

Messages in the output window

If variables are deleted or renamed during the CSV import, messages are displayed in the output window of the Editor stating the success or the failure of the actions:

Message | Level | Description
Rename variable '%s' does not exist. | Warning | The variable which should be renamed and is referred to by the variable name stated in field KANAL_R does not exist.
Variable '%s' which should be deleted does not exist. | Warning | The variable which should be deleted and is referred to by the variable name stated in field VariableName does not exist.
Variable '%s' was renamed in '%s'. | Normal | The renaming of the variable was successful.
Variable '%s' was deleted. | Normal | The deleting of the variable was successful.
%i of %i variable(s) renamed. | Normal or Warning | This message is only displayed when renaming is carried out with valid fields, i.e. fields which are not empty KANAL_R. The first placeholder (%i) equals the number of the successful renamings. The second placeholder equals the number of the commanded renamings. If not all renamings could be carried out successfully, the output is formatted as Warning.
%i of %i variable(s) deleted. | Normal or Warning | This message is only displayed when deleting is carried out via valid KANAL_D fields (numeric value 1). The first placeholder (%i) equals the number of the successful deletions. The second placeholder equals the number of the commanded deletions. If not all deletions could be carried out successfully, the output is formatted as Warning.


Compatibility with Microsoft Excel

Manual -> Import - Export -> Variables -> CSV import -> Compatibility with Microsoft Excel

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Export to Excel

For proper import of exported variables in CSV files in Microsoft Excel, please mind:

  • Format:
    In order for Microsoft Excel to use the proper decimal seperator, you have to set the format in your operating system´s Regional and language options to English. Attention: This setting is mandatory for the usage of decimal seperators, otherwise the values are interpreted/saved incorrectly.
  • Unicode:
    The files must be saved in Microsoft Excel as Unicode text (.txt). They are saved as TXT files. In older versions of Microsoft Excel, the description can differ slightly.
    Attention: When using a different format, the data cannot be imported properly!
  • @ sign:
    Microsoft Excel interprets @ signs in a cell not as text and therefore might not allow editing. You have to change the cell type (category) from Standard to Text for editing cells with @ signs. For that
    • mark the cell or the column
    • right-click on the cell and choose the command Format cells in the context menu.
    • Switch the category in the dialog to Text
  • Maximum values:
    • Microsoft Excel 97-2003: 65536 lines, 256 columns
    • Microsoft Excel 2007: 1048576 lines, 16384 columns

attention Attention

If the number of 16384 or 256 columns and 1048576 or 65536 lines is exceeded, a dialog pops up and you can select to export correspondingly less dynamic properties (if possible). If you choose the limitation, as many dynamical properties as possible are exported.

Statistical properties are not limited.

If removing the dynamical properties is not sufficient, an additional message pops up.

For the maximum number of variables you have to take into account that the header needs its own line, too.

Import from Excel

At the import from Excel you must not delete the last (empty) line. Otherwise the CSV file cannot be imported to zenon.


Example for import

Manual -> Import - Export -> Variables -> CSV import -> Example for import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For the import of a variable, the following information must be provided in the file:

VariableName | DriverName | DriverType | HWObjectType | TypeName
Test | MyDriver | Intern | 33 | Mydata type

Before you can import the file, you have to ensure that a driver called "MyDriver" type Internal has been created in the project. This driver must support the channel type / HWObjectType. In addition, the data type "MyData type" must exist. After you selected the file for import, a dialog for driver assignment pops up. In this dialog, all variables to be imported of a driver created in the project can be linked with another driver. If you want to use the same driver, you can confirm the dialog directly with OK. Then the variables are imported.


CSV export

Manual -> Import - Export -> Variables -> CSV export

Variables can be exported with zenon to CSV files and imported from CSV files, for example for further editing in Microsoft Excel.

Exception: Complex data types and array variables must not be exported.

attention Attention

The data is exported to a tabulator-seperated unicode text file with the ending .txt instead of .csv.

Background: Microsoft Excel saves CSV-files as ANSI text files with ; as seperator. If saved as CSV in Excel, the unicode is removed. That would irrepabably damage the export data for the project.

Export options

  1. Export of all exportable variables in the project
  2. Export of selected exportable variables
    • only available if at least one exportable variable has been selected

During export of the variables, a dialog pops up where you can choose the save location and the file name. The file ending is predefined .txt.

If there are too many properties in the file that you want to export to and edit in Microsoft Excel, you are offered several possibilities:

  • Cut off properties or lines:
    Only part of, for example, the limits or variables is being exported (that depends on the limitation). Primarily information that cannot be handled by older Microsoft Excel versions is not exported. The exported file can be edited with an external program.
  • Export all properties
  • Cancel export

Compatibility with Microsoft Excel

Export to Excel

For proper import of exported variables in CSV files in Microsoft Excel, please mind:

  • Format:
    In order for Microsoft Excel to use the proper decimal seperator, you have to set the format in your operating system´s Regional and language options to English. Attention: This setting is mandatory for the usage of decimal seperators, otherwise the values are interpreted/saved incorrectly.
  • Unicode:
    The files must be saved in Microsoft Excel as Unicode text (.txt). They are saved as TXT files. In older versions of Microsoft Excel, the description can differ slightly.
    Attention: When using a different format, the data cannot be imported properly!
  • @ sign:
    Microsoft Excel interprets @ signs in a cell not as text and therefore might not allow editing. You have to change the cell type (category) from Standard to Text for editing cells with @ signs. For that
    • mark the cell or the column
    • right-click on the cell and choose the command Format cells in the context menu.
    • Switch the category in the dialog to Text
  • Maximum values:
    • Microsoft Excel 97-2003: 65536 lines, 256 columns
    • Microsoft Excel 2007: 1048576 lines, 16384 columns

attention Attention

If the number of 16384 or 256 columns and 1048576 or 65536 lines is exceeded, a dialog pops up and you can select to export correspondingly less dynamic properties (if possible). If you choose the limitation, as many dynamical properties as possible are exported.

Statistical properties are not limited.

If removing the dynamical properties is not sufficient, an additional message pops up.

For the maximum number of variables you have to take into account that the header needs its own line, too.

Import from Excel

At the import from Excel you must not delete the last (empty) line. Otherwise the CSV file cannot be imported to zenon.


S7-project

Manual -> Import - Export -> Variables -> S7-project

With zenon, Step 7 projects can be imported. When importing an Step 7 project, the corresponding variables are created in zenon.

Different prescribed rules can be used for conversion of existing variable names from Step 7 projects for import in zenon.

Redundancy

Only the first CPU found per station (rack) is offered for import.


Requirements for the import of Step 7 project variables

Manual -> Import - Export -> Variables -> S7-project -> Requirements for the import of Step 7 project variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To be able to import variables from an Step 7 project in zenon:

  • The Step 7 project must be available locally on the hard drive or on in the network.
  • The Step 7 project must not be opened by an Step 7 program folder in the S7 Simatic Manager.
    If it is open there, the import may be unsuccessful, depending on the exclusive access that the S7 Simatic Manager secures. Stations, for example, are then shown.
  • Everything must be translated in Step 7 or PC S7, so that all objects in zenon can be transferred.
  • Step 7 projects from version 11 must be, before import into zenon, exported with the Variable Export Manager.

info Information

For the import of PCS7-projects, the subdirectory CSV_export is needed. In this subdirectory you need a CSV-file for each station of the project with the same name as the station. For the import, the hierarchical names from this file are used.

Particular factors when importing from Step 7, version 11

From version 11, Step 7 is part of the TIA framework from Siemens. For variable import in zenon, the variables of a TIA Step 7 project must, before export into zenon, be exported with the Variable Export Manager.

tutorial License information

From Step 7 version 11, Step 7 variables must, before import into zenon, be exported with the Variable Export Manager.

This tool is included in the standard license for Editor and Runtime.


Variable Export Manager

Manual -> Import - Export -> Variables -> S7-project -> Requirements for the import of Step 7 project variables -> Variable Export Manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the Variable Export Manager, you export variables from Step 7 from version 11 and prepare these for import into zenon.

In doing so, please note that different variable export managers are used for TIA versions 11, 12 and 13.

Overview

  • Step 7 Up to version 11:
    Automatic import - no additional steps necessary.
  • Step 7 Version 11 and 12:
    Export of an S7 project via CD_TIAProject_Exporter.exe
    (save location: C:\Programme (x86)\COPA-DATA\zenon 7.20 SP0\)

    Import into zenon using Enhanced import.

  • Step 7 Version 13:
    Export of an S7 project via CD_TIA13Project_Exporter.exe
    (save location: C:\Program Files (x86)\COPA-DATA\zenon 7.20 SP0\)
    Import into zenon using enhanced import.

Requirements

To prepare variables from Step 7 projects for import into zenon, the following must be the case on the export computer:

  • The corresponding TIA software from Siemens must be installed
  • The Variable Export Manager must be present.
    To use the Variable Export Manager, copy the corresponding program from the zenon installation folder or from the zenon installation medium onto the computer on which the Variable Export Manager is to be used.


Variable Export Manager user interface

Manual -> Import - Export -> Variables -> S7-project -> Requirements for the import of Step 7 project variables -> Variable Export Manager user interface

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters | Description
Progress bar | Shows the progress of the export process
Export | Starts a new export. Available as soon as the previous export has been completed.
Cancel | Cancels the export.
Close | Closes the Variable Export Manager Note: Inactive when an import is ongoing.

info Information

The Variable Export Manager is only available in English in both versions.


Variable export - Variable Export Manager

Manual -> Import - Export -> Variables -> S7-project -> Requirements for the import of Step 7 project variables -> Variable export - Variable Export Manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To export variables from Step 7 from version 11:

  1. Start the Variable Export Manager.
    Note: Ensure that you start the correct version of the Variable Export Manager.
  2. The dialog to select a Step 7 project is opened.
  3. Select the desired project.
    Note: TIA projects have the file extension .ap11, .ap12 or .ap13
  4. Click on the Open button to continue.
  5. The dialog to select the save location and name is opened.
  6. Select a save location and name for the export file
  7. Confirm the entry with Save.
  8. the export is started
  9. Copy the export file to the computer on which the import is to take place in zenon
  10. Continue with the usual S7 import


Import S7 project import dialog

Manual -> Import - Export -> Variables -> S7-project -> Import S7 project import dialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Project selection

Parameters | Description
S7 project file | Save location and name of the selected import file. Note: possible file suffixes are .zst and .s7p.
... | Click on the ... button to open the dialog to select the import file.
Target driver | Display of the selected driver. Note: This display is for information purposes only. Changes are no longer possible in this dialog.
Project structure | Shows the structure of the selected import or project file. The tree view can be made larger by clicking on [+] or smaller by clicking on [-].

Options

Parameters | Description
Only MuO variables | If active, only "Operate and Monitor" variables are imported. Default: Inactive

Variable naming

Parameters | Description
Name is created using technological levels | Select the technological levels (1-5 and circle) from CFC programming that are to be used for naming the variables. Default: All levels including circle are activated.
Separator | Selection of the character that separates the selected technological levels from one another. Default: \
Internal nomenclature | The internal nomenclature is used for the names of the created objects. Example: S0 (for net address = 0)
WinCC nomenclature | The WinCC nomenclature is used for the names of the created objects. Example: S7 program
Combined | Both the internal nomenclature and the WinCC nomenclature is used for the names of the created objects. A dot (.) is used as a separator.

Import target

Parameters

Description

Variable list

The variables are imported in the zenon variable list.

During import, a check is made to see whether a variable with the corresponding name already exists. If this is the case, zenon-specific attributes are retained. This means that a comparative merging of the imported variables and the existing variables takes place.

Note: If the same project is imported with different naming rules (nomenclatures), the variables are also recreated. Merging of the existing variables does not then take place.

Therefore you must ensure that, when you import a project that has already been imported again, you select the same nomenclature as for the initial export.

File

The variables are imported into the specified file (*.dbf). You can edit this file and import it into zenon.

File path and name

Only active if file was selected as an import destination.
The file name and path is entered using the "..." button.

...

Opens the dialog to select a destination path and to enter the destination file name.

Note: Note the limited field sizes of the DBF file. If the field sizes are exceeded, information can get lost during the import.

Only active if file was selected as an import destination.

Navigation

Parameters | Description
Execute | Starts the import. The dialog for selection of the stations opens.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.

info Information

Import dialog settings are remanent and are saved. The last settings use are displayed again the next time the dialog is called up.


Import Step 7 projects into COPA-DATA

Manual -> Import - Export -> Variables -> S7-project -> Import S7 project import dialog -> Import Step 7 projects into COPA-DATA

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To import Step 7 projects:

  1. In the zenon Editor, navigate to the Variables node
  2. Right click on the Variables node
  3. Select, in the context menu, the Extended Import/Export -> Import S7 Project entry.
  4. The driver selection dialog to select a driver is opened.
  5. Select the desired driver from the list in this selection dialog.
  6. Click on the 'OK' button.
  7. The import assistant is opened.
  8. Follow the steps in the import assistant
    1. Select the desired project
    2. Select the desired stations
    3. Configure the stations
    4. Select the variables


Select stations

Select stations

Select the desired stations

Available stations

Parameters

Description

List of stations

Lists all available stations of the selected project file.

  • Net address
  • Prefix
  • Station
  • CPU

Note:

  • List can be sorted; multiple selection is possible.
  • CPU: Only the first CPU found per station (rack) is offered for import.

Select all

Selects all listed stations.

Settings...

Opens the dialog for station settings.
This dialog offers additional filtering possibilities for the list of variables to be imported.

Navigation

Parameters | Description
OK | Accepts the selection and opens the dialog to select variables. Note: Depending on the size of the Step 7 project, this procedure can take some time.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Settings of the stations

Manual -> Import - Export -> Variables -> S7-project -> Import S7 project import dialog -> Import Step 7 projects into COPA-DATA -> Settings of the stations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Settings of the stations

In this dialog you can set filters and change other settings. For example, it is possible to filter for variables of a certain data type only, or for variables of one or several data blocks. In addition, further requirements for the issuing of variable names can be given in this dialog.

These settings influence the list of variables that are offered in the Dialog to select the variables.

Settings

Parameters | Description
Net address | States the Net address and affects the station name. Default: 1 Note: Always starts with 0.

Pre-filter

Filtering for the variables to be imported according to data blocks and data types.

Parameters

Description

Active

Activates pre-filtering for:

  • Data blocks
  • Datatypes
  • Areas

Active: uses the variables and data types displayed in the list as a prefilter. Differences between Step 7 and zenon are not displayed.

Inactive: All variables and data types of Step 7 and zenon are compared during import. Differences are displayed. You are asked if you want to delete or merge elements that are not present.

Default: Inactive

Data blocks

List of the data blocks present in the Step 7 project.

Select the data blocks from which you want to import variables.

Note: Grayed out if prefiltering is not activated. also grayed out if No blocks in areas is activated.

Multiple selection is possible.

Datatypes

List of data types.
Only variables that are based on the selected data types are taken into account for variable import.

Select the data types that are based on the variables that you want to import.

Note: Grayed out if prefiltering is not activated. Multiple selection is possible.

Areas

Select the desired area in which variables are searched for.

  • All areas
  • Only blocks
  • No blocks
    Deactivates the possibility of pre-filtering variables according to data blocks.

Options

Filter criteria that already compare variables present in zenon with the variables to be imported.

Parameters | Description
Offer only not available variables | Only the variables that do not yet exist in zenon are offered for import.
Only show available variables | Variables that already exist are searched for. These can be merged during import.
Search for variables to be deleted | After the variable selection, all variables that are not available in the Step 7 project are displayed. They can be deleted from the zenon Project. Note: Cannot be selected if pre-filtering has not been activated.
Assignment to existing variables according to address instead of name | Active: Pre-existing driver variables are merged using the variable address instead of the name. It is thus possible to accept amended names from a Step7 project. Default: Inactive

Prefix

Additional configuration for the naming of the variables to be imported.

Parameters

Description

None

The imported variables are not assigned prefixes in front of the name.

Net address

The imported names are assigned the net address followed by a point as prefix in front of the name.

Free entry

The imported variables are not assigned a freely-selectable prefix in front of the variable name.

When importing a variable, the prefix entered is put in front of the variable name, with a dot as a separator.

Note: Ensure that you use the same prefix again if you import again. Otherwise the variables are created twice.

Input field

Text field for the entry of the prefix.
Note: Input field is only active if free entry has been selected.

Navigation

Parameters | Description
OK | Accepts selection and returns to the select stations dialog. Note: Depending on the size of the Step 7 project, this procedure can take some time.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Variable selection

Manual -> Import - Export -> Variables -> S7-project -> Variable selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

All variables present for import are shown in this dialog. This list is the result of your configuration in the previous dialogs.

Existing variables

Parameters

Description

Project

Project tree of the original Step 7 project.

This overview is enlarged with [+] and reduced with [-]. After selecting the project, the Step 7 variables contained therein are created in the variable list.

Variable list

List of all the variables available for variable import.

  • Variable name
  • Comment
  • Data area
  • Data type
  • Data block
  • Offset
  • Bit
  • Attributes
  • Address information.

From this list, select the variables that you want to import into zenon.

Note: This list can be sorted and filtered. The list can be amended by clicking on the right mouse button and selecting the Format columns... menu entry.

Variables to be imported

Parameters | Description
List of selected variables | Select the variables that you want to import from the variable list. Accept these with the Add button.
Add | Adds selected variables from the variable preview window to the list of variables to be imported.
Release | Removes selected variable(s) from the list of the variables to be imported.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog. The variables from the Step 7 project are imported according to the settings in zenon accordingly.
Cancel | Discards all changes and closes the dialog. You return to the Import S7 project dialog as a result.
Help | Opens online help.

You can select either the whole project or individual stations in the tree view. The corresponding variables are shown in the variable preview window, depending on the selection. Select the desired variables and click the button Add to add the variable to the import. The selected variables are shown in the lower part of the dialog. To remove variables from there, select the desired variables and click the button Remove.

info Info

With the help of Ctrl and/or Shift you can select more than one entry at a time.

  • By pressing and holding Ctrl you can select a number of entries.
  • By pressing and holding Shift and select two entriey, you select all entries which lie between the two selected entries.
  • By pressing and holding both Ctrl and Shift and selecting two entries, all entries which lie between the selected entries are selected. The entries which were selected beforehand remain selected.

After finishing, click the button OK to close the dialog and confirm the modifications you made. The variables are created in zenon.


dBase import and export

Manual -> Import - Export -> Variables -> dBase import and export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Data can be exported to and imported from dBase.

info Information

Import and Export via CSV or dBase supported; no driver specific variable settings, such as formulas. Use export/import via XML for this.

Import DBF file

To start the import:

  1. right-click on the variable list
  2. in the drop-down list of Extended export/import... select the Import dBase command
  3. follow the import assistant

The format of the file is described in the chapter File structure.

info Information

Note:

  • Driver object type and data type must be amended to the target driver in the DBF file in order for variables to be imported.
  • dBase does not support structures or arrays (complex variables) at import.

Export DBF file

To start the export:

  1. right-click on the variable list
  2. in the drop-down list of Extended export/import... select the Export dBase... command
  3. follow the export assistant

attention Attention

DBF files:

  • must correspond to the 8.3 DOS format for filenames (8 alphanumeric characters for name, 3 character suffix, no spaces)
  • must not have dots (.) in the path name.
    e.g. the path C:\users\John.Smith\test.dbf is invalid.
    Valid: C:\users\JohnSmith\test.dbf
  • must be stored close to the root directory in order to fulfill the limit for file name length including path: maximum 255 characters

The format of the file is described in the chapter File structure.

info Information

dBase does not support structures or arrays (complex variables) at export.


dBaseIV variable file

Manual -> Import - Export -> Variables -> dBase import and export -> dBaseIV variable file

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The dBaseIV file must have the following structure and contents for variable import and export:

attention Attention

dBase does not support structures or arrays (complex variables) at export.

DBF files must:

  • conform with there name to the 8.3 DOS format (8 alphanumeric characters for name, 3 characters for extension, no space)
  • Be stored close to the root directory (Root)

Structure

Description | Type | Field size | Comment
KANALNAME | Char | 128 | Variable name. The length can be limited using the MAX_LAENGE entry in project.ini.
KANAL_R | C | 128 | The original name of a variable that is to be replaced by the new name entered under "VARIABLENNAME" (field/column must be entered manually). The length can be limited using the MAX_LAENGE entry in project.ini.
KANAL_D | Log | 1 | The variable is deleted with the 1 entry (field/column has to be created by hand).
TAGNR | C | 128 | Identification. The length can be limited using the MAX_LAENGE entry in project.ini.
EINHEIT | C | 11 | Technical unit
DATENART | C | 3 | Data type (e.g. bit, byte, word, ...) corresponds to the data type.
KANALTYP | C | 3 | Memory area in the PLC (e.g. marker area, data area, ...) corresponds to the driver object type.
HWKANAL | Num | 3 | Bus address
BAUSTEIN | N | 3 | Datablock address (only for variables from the data area of the PLC)
ADDRESS | N | 5 | Offset
BITADR | N | 2 | For bit variables: bit address For byte variables: 0=lower, 8=higher byte For string variables: Length of string (max. 63 characters)
ARRAYSIZE | N | 16 | Number of variables in the array for index variables ATTENTION: Only the first variable is fully available. All others are only available for VBA or the Recipe Group Manager
LES_SCHR | R | 1 | Write-Read-Authorization 0: Not allowed to set value. 1: Allowed to set value.
MIT_ZEIT | R | 1 | time stamp in zenon zenon (only if supported by the driver)
OBJEKT | N | 2 | Driver-specific ID number of the primitive object comprises TREIBER-OBJEKTTYP and DATENTYP
SIGMIN | Float | 16 | Non-linearized signal - minimum (signal resolution)
SIGMAX | F | 16 | Non-linearized signal - maximum (signal resolution)
ANZMIN | F | 16 | Technical value - minimum (measuring range)
ANZMAX | F | 16 | Technical value - maximum (measuring range)
ANZKOMMA | N | 1 | Number of decimal places for the display of the values (measuring range)
UPDATERATE | F | 19 | Update rate for mathematics variables (in sec, one decimal possible) not used for all other variables
MEMTIEFE | N | 7 | Only for compatibility reasons
HDRATE | F | 19 | HD update rate for historical values (in sec, one decimal possible)
HDTIEFE | N | 7 | HD entry depth for historical values (number)
NACHSORT | R | 1 | HD data as postsorted values
DRRATE | F | 19 | Updating to the output (for zenon DDE server, in [s], one decimal possible)
HYST_PLUS | F | 16 | Positive hysteresis, from measuring range
HYST_MINUS | F | 16 | Negative hysteresis, from measuring range
PRIOR | N | 16 | Priority of the variable
REAMATRIZE | C | 32 | Allocated reaction matrix
ERSATZWERT | F | 16 | Substitute value, from measuring range
SOLLMIN | F | 16 | Minimum for set value actions, from measuring range
SOLLMAX | F | 16 | Maximum for set value actions, from measuring range
VOMSTANDBY | R | 1 | Get value from standby server; the value of the variable is not requested from the server but from the Standby Server in redundant networks
RESOURCE | C | 128 | Resources label. Free string for export and display in lists. The length can be limited using the MAX_LAENGE entry in project.ini.
ADJWVBA | R | 1 | Non-linear value adaption: 0: Non-linear value adaption is used 1: Non-linear value adaption is not used
ADJZENON | C | 128 | Linked VBA macro for reading the variable value for non-linear value adjustment.
ADJWVBA | C | 128 | ed VBA macro for writing the variable value for non-linear value adjustment.
ZWREMA | N | 16 | Linked counter REMA.
MAXGRAD | N | 16 | Gradient overflow for counter REMA.

attention Attention

When importing, the driver object type and data type must be amended to the target driver in the DBF file in order for variables to be imported.

Limit definition

Limit definition for limit values 1 to 4, and status 1 bis 4:

Description | Type | Field size | Comment
AKTIV1 | R | 1 | Limit value active (per limit value available)
GRENZWERT1 | F | 20 | technical value or ID number of a linked variable for a dynamic limit (see VARIABLEx) (if VARIABLEx is 1 and here it is -1, the existing variable linkage is not overwritten)
SCHWWERT1 | F | 16 | Threshold value for limit
HYSTERESE1 | F | 14 | Is not used
BLINKEN1 | R | 1 | Set blink attribute
BTB1 | R | 1 | Logging in CEL
ALARM1 | R | 1 | Alarm
DRUCKEN1 | R | 1 | Printer output (for CEL or Alarm)
QUITTIER1 | R | 1 | Must be acknowledged
LOESCHE1 | R | 1 | Must be deleted
VARIABLE1 | R | 1 | Dyn. limit value linking the limit is defined by an absolute value (see field GRENZWERTx).
FUNC1 | R | 1 | Functions linking
ASK_FUNC1 | R | 1 | Execution via Alarm Message List
FUNC_NR1 | N | 10 | ID number of the linked function (if “-1” is entered here, the existing function is not overwritten during import)
A_GRUPPE1 | N | 10 | Alarm/event group
A_KLASSE1 | N | 10 | Alarm/event class
MIN_MAX1 | C | 3 | Minimum, Maximum
FARBE1 | N | 10 | Color as Windows coding
GRENZTXT1 | C | 66 | Limit text
A_DELAY1 | N | 10 | Time delay
INVISIBLE1 | R | 1 | Invisible

Expressions in the column "Comment" refer to the expressions used in the dialog boxes for the definition of variables. For more information, see chapter Variable definition.


Interlockings

Manual -> Import - Export -> Interlockings

The export file for the interlockings has the following sections:

  • Interlocking list

During export/import of the interlockings the linked variables are not automatically exported/imported. You have to watch out that the needed variables are exported/imported beforehand.


Command group

Manual -> Import - Export -> Interlockings -> Command group

Export

Command groups can be exported one by one or all together.

info Information

The command groups and the interlocking can not be exported together!

Import

For the import of command groups the following is true:

  • The relation between existing command groups and command groups to be imported is created using the name. If a command group with this name exists, it is updated.
  • If a general interlocking with this name exists, a new command group is created with new names.
  • Not existing command groups are created.
  • General interlockings from the import file are not imported.
  • Absolute variable references are created by the name.
  • New created command groups are getting an unique ID, which is not in use.


Time control

Manual -> Import - Export -> Time control

The export file for the time control has the following sections:

Time function list

Functions list

The included functions are exported with the time functions. The time functions are imported automatically. The functions have to be imported manually before from the same file.


Allocations

Manual -> Import - Export -> Allocations

The export file for the allocations has the following sections:

Allocation list

On exporting/importing allocations the linked variables are not automatically exported/imported. Pay attention that the needed variables are exported/imported before.


Error messages

Manual -> Import - Export -> Error messages

Error during import or export are displayed in the output window.

Error message | Possible cause and solution
Error: "The file cannot be opened as it has already been opened by another user." | File is locked for editing. User must release file before the import/export can be carried out again.
Error: "Database cannot be created or opened" | The rights for creating the field may be missing or the file is corrupt.
Error: "Variable is invalid and cannot be saved" | Variable is invalid. Check all parameters of the variable.
Error: "Variable could not be added to the database." | Error during the recording in the database.
Error: "Variable contains an invalid hardware address." | A hardware address of the variable is not correct. Correct the address before starting the import again.
Error: "Driver does not provide an object for import/export. Import/export is not carried out." | The selected driver does not have any objects which can be imported/exported.
Error: "Variable cannot be deleted as it is does not exist" | A variable which is selected for deleting does no longer exist.
Warning: "Variable with the new name already exists. Import is carried out with the old name. | A variable which should be renamed during the import is not renamed as a variable with the same name already exist. It is imported with its original name.
Warning: "Variable cannot be renamed and is newly created." | A variable which should be renamed cannot be renamed. It is

Errors during the XML import are treated and solved in an own dialog.


Industrial Maintenance Manager (IMM)

Manual -> Industrial Maintenance Manager (IMM)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Industrial Maintenance Manager (IMM) administers machine and maintenance data. Service intervals can comfortably be planned and administered. You can see at a glance which device, equipment, machine, etc. has to be maintained today / this week / next month etc. Additionally service work done in the past is logged.

tutorial License information

Must be licensed for Editor and Runtime (single-user, Server, Standby and Client).


Functionalities

Manual -> Industrial Maintenance Manager (IMM) -> Functionalities

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
  • Devices can be copied and pasted; a consecutive number is added to the device name.
  • The list view can be adjusted in the screen filter. Column selection, column width, column name and their order can be modified.
  • Every list view can be displayed and printed as an HTML file via Stylesheet.
  • The equipment identifier can only be created via the context menu in the tree.
  • Multi-hierarchic equipment identifiers
  • Devices can be created via the context menu in the tree or in the list, provided that an equipment was selected in the tree. This equipment is then automatically inserted in the device as equipment identifier.
  • By clicking on the column button, the elements are sorted alphabetically.
  • Multi-project capable
  • Server-Client
  • Deleting devices is subject to a userlevel, which allows to ways of deleting. On the one hand, deleting in the sense that data is retained in the database and history entries are not lost. For this method, the flag ACTIVE in the database is set to 0. Alternatively, a complete and final deletion: all data from the database, including the maintenance tasks and the history, are deleted.
  • The checkboxes in the tree view for the equipment identifiers are a filter. If they are set, only devices, history entries and maintenance tasks belonging to this equipment identifier are displayed.


Limitations

Manual -> Industrial Maintenance Manager (IMM) -> Limitations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The module stores all data in a Microsoft SQL Server database (SQL Server 2000 and higher). The MS SQL Server is not included in zenon. However, you can use the SQL Server Express Edition which is installed with the zenon Editor.

Other SQL servers like Oracle are not supported.


Preparatory works

Manual -> Industrial Maintenance Manager (IMM) -> Preparatory works

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


Database

Manual -> Industrial Maintenance Manager (IMM) -> Preparatory works -> Database

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Creating an own database.

Start a new instance of the command prompt (cmd.exe).

Start the service program osql.exe.

osql.exe -E -S computer name / instance name

Instructions for creating a database

1> CREATE DATABASE database name

2> GO

Database name

any name for the database. e.g.: Maintenance

Close the service program osql.exe with 'exit'.


Engineering

Manual -> Industrial Maintenance Manager (IMM) -> Preparatory works -> Engineering

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Four tables are created in the database. The names of the tables are issued and fixed and correspond to the names that are used in the measuring point administration:

  • Table for devices: Devices
  • Table for maint. works: MaintenanceWorks
  • Table for history: MaintenanceHistory
  • Table for documents: Documents

Database connection

In the project properties, the ODBC string can be manually edited in the Industrial Maintenance Manager node by means of the Database property. Clicking on the ... button opens the dialog for configuration.

New...

Click on this button to add a new file data source.

In the dialog field 'Create new data source' select the driver SQL Server and click on Next in order to enter the name or the storage place of the new DSN file.

Again, click on Next'to display a summary of the new information.

Click on Finish to open the driver specific setup dialog.

If you select a server name from the list, no further configuration settings are necessary.

Again click on Next.

Again click on Next.

Now you can select the previously created database.

Click on Finish.

Now you can test the selected connection.

attention Attention

When using Native Client 10 and 11, the password is not automatically carried over to the provider string. It must be entered manually

e.g.: ...;User ID=sqlExampleUser1;Password=secretPassword;...


Creating a screen of the type IMM

Manual -> Industrial Maintenance Manager (IMM) -> Creating a screen of the type IMM

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a screen of type IMM:

  1. create a new screen
  2. as screen type select Industrial Maintenance Manger (IMM) from the drop-down list
  3. select Add template in the control element menu
  4. The standard elements are inserted
  5. Select additional elements as required and insert them into the desired place on the screen
  6. Create a screen switch function in order to be able to call up the screen in Runtime

Parameters

Description

Insert template

Opens the dialog for selecting a template for the screen type.

Templates are shipped together with zenon and can also be created by the user.

Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.

List

List of processes which are displayed in the Runtime.

List functions

Control elements to control the list.

Filter

Applies filter.

New equipment identifier

Creates a new equipment identifier.

Delete equipment identifier

Deletes selected equipment identifier.

Device

Control elements for devices.
  • New

Adds a new device.
  • Edit

Makes it possible to edit the selected device.
  • Delete

Deletes device.
  • Mark as inactive

Switches device to inactive.
  • Replace

Carries out device exchange.

Copy

Copies selected element to the clipboard.

Paste

Pastes the selected element from the clipboard.

Change counter

Carries out counter exchange.

Edit maintenance

Makes it possible to edit a maintenance.

Execute maintenance

Switches to carry out maintenance.

Execute repair

Switches to carry out repair.

Print list

Prints out list.

Print details

Prints out details.

Refresh

Refreshes view.

Filter profiles

Buttons for filter settings in Runtime.

Profile selection

Select profile from list.

Save

Saves current setting as a profile.

Delete

Deletes selected profile.

Import

Imports filter profiles from export file.

Export

Exports filter profiles in the file.


Display during Runtime

Manual -> Industrial Maintenance Manager (IMM) -> Creating a screen of the type IMM -> Display during Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If you call up a screen of type IMM during Runtime, it is displayed divided in two areas.


Left side: Tree

Manual -> Industrial Maintenance Manager (IMM) -> Creating a screen of the type IMM -> Display during Runtime -> Left side: Tree

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters | Description
Master data | The equipment identifications are used as nodes. These nodes have a checkbox to limit the selection. This selection defines the output in the list. In the master data, the maintenance tasks and the history only data belonging to the selected equipments are displayed. Note: Devices from the list can be moved to other equipment by means of Drag&Drop.
History | Here the history data is filtered on periods of time. With free filter a dialog for the selection of any period of time is opened.
Maintenance tasks | Here the 'current' maintenance tasks are filtered on periods of time. With free filter a dialog for the selection of any period of time is opened.


Right side: List

Manual -> Industrial Maintenance Manager (IMM) -> Creating a screen of the type IMM -> Display during Runtime -> Right side: List

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Here the selection from the tree view is displayed as a list. The list can be sorted ascending or descending on any column. Additionally there is a context menu in this view, which offers different functions depending on the selection in the tree view.

Selection master data

Command

Description

Device new

Under New device new master data can be created. The definition is done in a dialog with three tabs. On the first page the data for the device is entered. On the page 'Maintenance tasks' any number of maintenance tasks for this device can be created. For an overview the titles of the maintenance tasks are displayed in a list on this page. On the last page any number of documents can be assigned to the device. For an overview these are displayed in a list similar to the maintenance tasks. On doubleclicking a document the according document is opened, if the according program is installed.

Note: Devices can be moved to other equipment in the master data by means of Drag&Drop.

Edit device

Similar to 'New device' with the only difference, that the fields are filled with the existing data. A device has to be selected.

Device exchange

The variables for operations and hours counters are changed here! The calculation for scheduling maintenances is based on these variables. If a device exchange is performed, a history entry is made. Additionally, the maintenance interval is reset and the new variable values are used as the initial values for the calculation of maintenances.

The device data stays the same, only the linked variables are exchanged. These have to be entered in a dialog. If the variable does not exist, a warning is displayed, that in the moment no valid variables are linked with the device.

Counter exchange

If a counter is exchanged, the variable stays the same, but the counter reading (variable value) is changed. If a counter is exchanged, a history entry is made. You can choose whether the maintenance interval should be reset or not.

A new start value for the exchanged device can be entered.

Delete device

The selected device can be deleted. All associated data (maintenance tasks, history data and documents) are deleted. For security reasons the user is asked again, if the data should really be deleted.

Enter master data

Parameters

Description

Name

Name of the device.

Equipment identification

Display of equipment identification.

Name plate

Name plate data:

  • Type
  • Manufacture
  • Serial number

Free description:

Input field for free description.

Date of implementation

Entry of the date of putting into operation.

Variables

Configuration of the variables.

Switching cycle counter

Selection of the variables for the switching cycle counter.

Click on button ... in order to open the dialog for selecting a variable.

Max. counter content

Maximum permitted counter status.

Operating hours

Assignment of the variables for the operating hours.

Click on button ... in order to open the dialog for selecting a variable.

Max. counter content

Maximum permitted counter status.

Response variable

After maintenance work has been carried out, the value defined here is written to the linked variable. Click on button ... in order to open the dialog for selecting a variable.

Configure maintenance work

Parameters

Description

Name

Name for job.

Comment

Comments about the job.

Note: You can create a line break via shortcut Ctrl+Return.

Authorization level

Entry of the authorization levels that are required for execution.

Maintenance interval

Configuration of the maintenance interval for:

  • Period in days
  • Switching cycle counter
  • Operating hours

Process interaction

Properties for interaction.

Return value

Value that is written after maintenance work has been carried out on the device linked to the response variable.

Status variable

Variable that displays the status of the maintenance work.

  • 0: Maintenance not due
  • 1: Maintenance due

Click on button ... in order to open the dialog for selecting a variable.

The variable is written when updating the IMM screen as well as when executing the Determine open maintenances function.

Edit data

The following access to files is supported:

Local drives | Local harddisk
UNC path | e. g. \\Server name\release name
Connected drives | Released harddisk of a network computer

attention Attention

Requirement: To be able to display the documents, you must install an apropriated viewer. e.g. Adobe Acrobat Reader for .pdf files.

Device exchange

Counter exchange

Selection maintenance tasks

By doubleclicking a maintenance task the data of this maintenance task are displayed. But the data cannot be changed.

Execute repair | If a repair is performed, a history entry is made. The maintenance task remains in the queue, because it is not considered as performed. An entry in the history is created. Similar to 'Execute maintenance' with the only difference, that the counter can be updated.
Print list |

The displayed list is written to am XML file as it is and displayed in a HTML browser with a stylesheet. This HTML file then can be saved or directly printed.

Print details

The data for the selected maintenance task are output.

Edit maintenance

Here the data of the selected maintenance task can be edited.

Execute maintenance

If a maintenance is executed, the counters are updated and a history entry is generated. Additionally, the maintenance task is considered as done for this interval, and so it is removed from the queue.

Under 'Documents' the linked documents are displayed in a list. With doubleclicking a file it is opened, if an according program is installed.

Selection history

Here there is only one menu entry Print list. Same procedure as under maintenance task - Print list.


Maintenance task

Manual -> Industrial Maintenance Manager (IMM) -> Maintenance task

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The calculation of pending maintenance is the main task of IMM. Maintenance tasks can have three different maintenance intervals:

- a time span in days

- an hours counter or

- an operations counter.

The due date of the maintenances is calculated from these intervals.

If a maintenance comes into the warning zone, it shows up in the list for due maintenances, including a notice that it has reached the warning level . If it reaches the maintenance intervall, the maintenance is set to due, which also shows up in the list of maintenances.

The function 'Determine maintenances'

With the function Determine maintenances, the list of all due maintenances in the selected time span is retrieved from the IMM. These due maintenances are then used to determine the equipment-specific status values as configured.

Numerical set values equalling the total number of due maintenances for equipment matching the selected filter criteria are sent to the according status variables.

If you create a new function Determine maintenances in the Editor, the following configuration dialog appears:

Period | Here you can select the period for which you want to determine due maintenances (see IMM).


Period

Manual -> Industrial Maintenance Manager (IMM) -> Maintenance task -> Period

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the maintenance task data a time interval in days can be entered. In addition, an period of advance notice can be set, which means: the maintenance task should be evaluated as a 'current' maintenance task this many days before the end of the time interval. (message 'Maintenance due in xx days'.)

If the period of time or the counter value of the maintenance interval is reached, the maintenance is entered with the text 'Maintenance interval exceeded'.

The date of the last maintenance is updated for each execution. On creating the maintenance task this date is set to the current date.


Hours and operations counter

Manual -> Industrial Maintenance Manager (IMM) -> Maintenance task -> Hours and operations counter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For the calculation of a 'current' maintenance the difference between the 'old' counter value at the last maintenance and the current one is divided by the number of the passed days since the last maintenance and added to the 'old' one. If this is higher than allowed, the maintenance is evaluated as 'current' and is displayed in the list.

If a variable has a lower value than at the last maintenance, a message is displayed.


Data input

Manual -> Industrial Maintenance Manager (IMM) -> Data input

The variable values are only entered in the maintenance data, if the maintenance task is newly created. Otherwise the old values stay.

If a device is created and no variables are linked, the initial value stays in the maintenance task. Also in this constellation the variable values in the maintenance task are not overwritten, if the variable is entered later. A message is displayed, if the variable needed for the maintenance calculation still has the initial value. The variable value only can be changed by executing a repair, a device exchange or a maintenance task.


Integration in the process

Manual -> Industrial Maintenance Manager (IMM) -> Integration in the process

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
  • Message about the success of maintenance tasks An Integer variable can be assigned to the device. You also have to define the return value of this variable in the maintenance task. If maintenance tasks need not be distinguished, you can always enter the same value here. If no value is entered, no value is set for the variable.
  • Response in the process: A variable indicating the status of the maintenance can be assigned to every maintenance task. (Status Ok : 0 and Status due : 1)


Operating during Runtime

Manual -> Industrial Maintenance Manager (IMM) -> Operating during Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following functions are available:

  • New device: Create a new device. An equipment identifier must be selected.
  • Edit device: Edit a device. A device has to be selected.
  • Device inactive: Switch a device to inactive, i.e. data is no longer displayed but remains in the database.
  • Execute maintenance: A maintenance must be selected to perform this.
  • Refresh: The data from the database and the variables are refreshed.
  • Filters: Loads the screen filter dialog to modify columns.
  • Print: Generates an HTML file with the desired list view. The current view is captured as it is. The history and the upcoming maintenances can be printed.
  • Print details: View the details of a maintenance task in HTML. A maintenance task must be selected.


Functions

Manual -> Industrial Maintenance Manager (IMM) -> Functions


Screen switch

Manual -> Industrial Maintenance Manager (IMM) -> Functions -> Screen switch

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When creating an IMM type screen switching function, the dialog to configure the column settings is shown. These can be configured separately for:

  • Master data
  • Maintenance tasks
  • History


Master data

Manual -> Industrial Maintenance Manager (IMM) -> Functions -> Screen switch -> Master data

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration of the history to be displayed:

  • current operating hours counter
  • current switching cycle counter
  • Equipment identifier
  • Description
  • Brand
  • Device
  • Activation date
  • Serial Number
  • Status
  • Type
  • Time period since last maintenance

Parameters | Description
Column type | Definition via check box which columns should be displayed during Runtime. Label cannot be edited. Active: Column is displayed in the Runtime.
Description | Defines the header of the respective column. You can configure it as language switchable. The value can be edited.
Width | Defines the width of the column in pixels. You can also define the width of the column by clicking and dragging the column with the mouse in the list with the horizontal display of the column names. The value can be edited.
Move selected entry up | Moves the selected column up. You can also move the columns with drag&drop.
Move selected entry down | Moves the selected column down. You can also move the columns with drag&drop.
Field with horizontal display of the column names | Shows the columns which are active in the list. You can define the size of the columns by clicking and dragging the column borders with the mouse.


Maintenance tasks

Manual -> Industrial Maintenance Manager (IMM) -> Functions -> Screen switch -> Maintenance tasks

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration of the maintenance work to be displayed:

  • current operating hours counter
  • current switching cycle counter
  • Equipment identifier
  • Description
  • Due date
  • Device
  • Internal - external
  • Comment
  • Status
  • Maintenance task
  • Time period since last maintenance

Parameters | Description
Column type | Definition via check box which columns should be displayed during Runtime. Label cannot be edited. Active: Column is displayed in the Runtime.
Description | Defines the header of the respective column. You can configure it as language switchable. The value can be edited.
Width | Defines the width of the column in pixels. You can also define the width of the column by clicking and dragging the column with the mouse in the list with the horizontal display of the column names. The value can be edited.
Move selected entry up | Moves the selected column up. You can also move the columns with drag&drop.
Move selected entry down | Moves the selected column down. You can also move the columns with drag&drop.
Field with horizontal display of the column names | Shows the columns which are active in the list. You can define the size of the columns by clicking and dragging the column borders with the mouse.


History

Manual -> Industrial Maintenance Manager (IMM) -> Functions -> Screen switch -> History

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration of the history to be displayed:

  • Equipment identifier
  • Users
  • Description
  • Date
  • Device
  • Comment
  • Maintenance task
  • Counter reading at maintenance

Parameters | Description
Column type | Definition via check box which columns should be displayed during Runtime. Label cannot be edited. Active: Column is displayed in the Runtime.
Description | Defines the header of the respective column. You can configure it as language switchable. The value can be edited.
Width | Defines the width of the column in pixels. You can also define the width of the column by clicking and dragging the column with the mouse in the list with the horizontal display of the column names. The value can be edited.
Move selected entry up | Moves the selected column up. You can also move the columns with drag&drop.
Move selected entry down | Moves the selected column down. You can also move the columns with drag&drop.
Field with horizontal display of the column names | Shows the columns which are active in the list. You can define the size of the columns by clicking and dragging the column borders with the mouse.


Determine open maintenances

Manual -> Industrial Maintenance Manager (IMM) -> Functions -> Determine open maintenances

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Function Determine open maintenances fetches the list of all pending maintenances from the IMM for a certain period of time. These are used to determine the equipment-specific status values as configured.

When carrying out the function:

  • numeric set values are written to the corresponding status variables; these set values match the total of the pending maintenances which are in the equipment and which match the allocation of equipment IDs to status variables
  • the status variables engineered at the device and at the maintenances are updated

To configure the function:

  • Select New function...
  • open branch Application
  • select Determine open maintenance
  • The dialog for configuring the function opens

Parameters | Description
Period | Period of time for which the pending maintenance was determined Note: Time is saved as local time. For details see chapter Handling of date and time in chapter Runtime.
Equipment label | Enter the equipment label which should be allocated to a status variable. Form: Equipment label are separated by comma and entered as lists. Equipment label may contain wildcards. (Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.)
Status variable | A numerical variable that contains the number of open maintenances of the equipment entered under Equipment identifier as a set value.
Allocations | List of allocations of equipment labels to status variables.
Add | Adds an allocation line.
Delete | Deletes the selected allocation.

Example Example

2 maintenances are active in Equipment1 and 1 maintenance is active in Equipment2.
Equipment1 and Equipment2 are the only equipments in this example.
The function is engineered similar to the displayed screenshot.

The status variables contain the following set values:

Maintenances_today_all = 3

Maintenances_today_all2 = 3

Maintenances_today_equipment1_2 = 3

Maintenances_today_equipment1 = 2

Maintenances_today_equipment2 = 1

info Information

In network operation, the function is always executed on the server.


Industrial Performance Analyzer

Manual -> Industrial Performance Analyzer

The Industrial Performance Analyzer (IPA) is designed in order to display and evaluate alarm data and associated downtimes in different list views. The IPA accesses a SQL database in which alarms - if they are engineered appropriately - are stored.

tutorial License information

Must be licensed for Editor and Runtime (single-user, Server, Standby and Client).

By its different filter settings, the IPA offers maximal flexibility. So for example you can filter on individual areas of your equipment and thus only those alarms are displayed which occurred in these areas. The IPA makes it also possible to detect and trace weak spots of your equipment. This is especially helpful during the implementation of new equipment in order to get to the root of initial difficulties and to fix them. Together with the module Production & Facility Scheduler (PFS) the IPA makes it possible to display downtimes with the break times already subtracted. It automatically subtracts the break time which it receives from the PFS from the actual downtime. There you can see the net downtime of your equipment. In addition the IPA can take shift time and shift names from the PFS. This facilitates the engineering and you save time. And you must maintain the shift times and shift names only once. Furthermore it is assured that PFS and IPA use the same data.

info Information

The industrial performance analyzer is designed for running on a PC. Therefore it is operated with keyboard and mouse. The complete operability with a touch screen is not guaranteed.


Basic functionality

Manual -> Industrial Performance Analyzer -> Basic functionality

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

All alarm data which were engineered correspondingly (see also Variables) are stored in a SQL database. The IPA supports ODBC-able databases such as Oracle SQL server, Microsoft SQL server, Microsoft MSDE, MySQL server etc. These servers can either be on your local computer or somewhere in the network.

In the Runtime the corresponding alarm data are saved in a buffer und from there written to the database cyclically. The cycle time is defined in the Editor (see also General settings).

It is possible that various Runtime projects write in the same database.

By using a central storage for the alarm data, a high data security and a high availability of the alarm data is ensured.

In the zenon Runtime the display and evaluation of the alarm data is implemented in the screen Industrial Performance Analyzer.


Engineering in the Editor

Manual -> Industrial Performance Analyzer -> Engineering in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You must make the following settings in order to display and to evaluate alarm data in the Runtime.


General settings

Manual -> Industrial Performance Analyzer -> Engineering in the Editor -> General settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Under the proyect properties you find the section There you define settings for the IPA which concern the whole project.

The following properties are available:

Parameters | Description
IPA active | Select this property in order to activate the IPA.
Database | Define the database in which the IPA should write the alarm data (see also Database)
Table name | Enter a freely definable name for the database table for your IPA data. A table with this name is automatically created in the database when the Runtime connects to the database for the first time.
Saving cycle | Define the interval in which the alarm data is written from the buffer to the database. In practice values are between 2 and 5 minutes.
Buffer size | Define how many alarms the buffer should be able to save. At the end of each interval the contents of the buffer is written to the database. After that the buffer is empty. If there are more alarms than the number you have entered within the interval, the oldest alarms will be lost at first.
Shift from PFS | Select this property in order to apply the times for the shifts from the Production & Facility Scheduler. If you activate this property, you can display downtimes with breaks already subtracted during the evaluation of the alarms.
Shift from variable | Select a variable of type INT. Together with the property shift name from list, you can assign numbers to shift names.
Pre-defined time filter | Define different time filters which you can access in the Runtime.
Alarm reason | Define different time filters which you can access in the Runtime.
Equipment identification | Define different equipment identifiers which you can access in the Runtime.
Equipment identification via | You can decide whether you want to use the beginning of a variable identification or the beginning of a variable name as part of the equipment identification.
Shift name from PFS | Select this property in order to apply the shift names for the defined shifts from the Production & Facility Scheduler.
Shift name from list | Define shift names to values. Via the value of the variable which you entered under Shift name from variable the defined shift name is displayed for the corresponding alarm in the Runtime.
To delete | Via the drop-down list select the user authorization which a user must have in order to delete database entries of the Industrial Performance Analyzer.
For editing | Via the drop-down list select the user authorization which a user must have in order to edit database entries of the Industrial Performance Analyzer.


Database

Manual -> Industrial Performance Analyzer -> Engineering in the Editor -> General settings -> Database

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

At property Database you click on the button with the three dots in order to reach the dialog for selecting the file data source.

  1. In order to create a DSN file you click New....
  2. Select entry SQL server in the following dialog and click Next.
  3. Enter a new for the data source and again click Next.
  4. Click Finish in order to exit the dialog.
  5. Select the corresponding SQL server under Server and click Next.
  6. You do not have to change anything in the appearing dialog. Click on Next.
  7. Activate check box change standard database to: and select the desired database. Click Continue.
  8. Again you do not have to change anything in this dialog. Click Finish in order to exit the dialog.

The next dialog shows you your setting in overview. You can test the data source there. Confirm this and the following dialog with OK.

attention Attention

When using Native Client 10 and 11, the password is not automatically carried over to the provider string. It must be entered manually

e.g.: ...;User ID=sqlExampleUser1;Password=secretPassword;...


Pre-define time filter

Manual -> Industrial Performance Analyzer -> Engineering in the Editor -> General settings -> Pre-define time filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When you select this setting, the following dialog will be dislpayed.

Parameters | Description
Add... | Add a new filter time. Enter a distinct name and set a start and end time in the appearing dialog.
Change... | Only active when you have selected an existing entry. You can change the name, the start time and the end time in the appearing dialog.
Delete | Only active when you have selected one or more existing entries. Deletes the selected time filters.

The time filters you define here are available in the Runtime. For example you can define the times of the shifts (early shift, late shift etc.) here once and then in the screen Industrial Performance Analyzer you can access these times when filtering.

Note: Time is saved as local time. For details see chapter Handling of date and time in chapter Runtime.


Add predefined time filter

Manual -> Industrial Performance Analyzer -> Engineering in the Editor -> General settings -> Pre-define time filter -> Add predefined time filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Via dialog Definition you can add new time filter or edit existing ones.

Parameters | Description
Name | Unique name of the time filter.
Time of begin | Time from which on the time filter is valid.
Time of the end | Time at which the time filter ends.


Alarm causes

Manual -> Industrial Performance Analyzer -> Engineering in the Editor -> General settings -> Alarm causes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When you select this setting, the following dialog will be dislpayed.

Parameters | Description
Add... | Add a new alarm reason. Assign a distinct name and number in the appearing dialog.
Change... | Only active when you have selected an existing entry. You can change the number and the name in the appearing dialog.
Delete | Only active when you have selected one or more existing entries. Deletes the selected alarm reasons.

The alarm reasons you define here are available in the Runtime. In the screen Industrial Performance Analyzer you can assign an alarm reason to each alarm. You select the alarm reason from a list which you administrate here.


Add alarm cause

Manual -> Industrial Performance Analyzer -> Engineering in the Editor -> General settings -> Alarm causes -> Add alarm cause

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Via dialog Alarm cause you can add new causes or edit existing ones.

Parameters | Description
Number | Unique number of the alarm cause.
Name | Unique cause.


Equipment identification

Manual -> Industrial Performance Analyzer -> Engineering in the Editor -> General settings -> Equipment identification

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When you select this setting, the following dialog will be dislpayed.

Parameters | Description
Add... | Add a new equipment identification. Enter a name for the equipment identification in the appearing dialog.
Change... | Only active when you have selected an existing entry. You can change the name of the equipment identification in the appearing dialog.
Delete | Only active when you have selected one or more existing entries. Deletes the selected equipment identification.

The equipment identification you define here are available in the Runtime. The equipment identification can appear as prefix in the name or in the identification of the variable (see also property Equipment identification via in General properties). The prefix is ended by an underscore '_'. An allocation to an equipment identification only takes place if a created equipment identification exactly matches the prefix.

Example Example

Equipment identification:

  • Equipment11

Variable name or variable identification:

  • Equipment1_Variable1
  • Equipment11_Variable1

Only variable Equipment11_Variable1 is allocated to the created equipment identification Equipment11.

With the help of the equipment identification, you can filter for the desired pieces of equipment.


Add equipment identification

Manual -> Industrial Performance Analyzer -> Engineering in the Editor -> General settings -> Equipment identification -> Add equipment identification

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Via dialog Equipment identification you can add new equipment identifications or edit existing ones.

Parameters | Description
Equipment identification | Name for the equipment identification.


Shift name from list

Manual -> Industrial Performance Analyzer -> Engineering in the Editor -> General settings -> Shift name from list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When you select this setting, the following dialog will be dislpayed.

Parameters | Description
Add... | Add a new shift name. Assign a distinct name and number in the appearing dialog.
Change... | Only active when you have selected an existing entry. You can change the number and the name in the appearing dialog.
Delete | Only active when you have selected one or more existing entries. Deletes the selected shift names.

The shift names you define here are available in the Runtime. They help you when filtering. Only those alarms are displayed which occurred in the corresponding shift.


Add shift name from list

Manual -> Industrial Performance Analyzer -> Engineering in the Editor -> General settings -> Shift name from list -> Add shift name from list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Via dialog Shift name you can add new shifts or edit existing ones.

Parameters | Description
Number | Unique number of the shift.
Name | Unique name of the shift.


Variables

Manual -> Industrial Performance Analyzer -> Engineering in the Editor -> Variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to save alarms in the IPA database, you must activate checkbox Save in IPA database for each corresponding variable. Only alarms from variables for which this property has been activated are stored in the database and can then be displayed and evaluated in screen Industrial Performance Analyzer.

attention Attention

In the limit text of the variable and in the variable identification only characters are allowed which may be used in SQL statements.


Language switch

Manual -> Industrial Performance Analyzer -> Engineering in the Editor -> Language switch

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Industrial Performance Analyzer the language switch is available for the following areas:

  • Alarm/event group and alarm/event classes
  • Equipment identification

    Note: As character '@' is not allowed in variable names, language switch for equipment identification is only available if you select Equipment identification via via Variable identification.

  • Alarm reason
  • Shift name

    Note: As character '@' is not allowed in the Production & Facility Scheduler, language switch for shift names is not available if you selected the respective entries for Shift name from list.

You must tag the terms for which language switch should be used with character '@'. In addition you must make sure that corresponding entries are available in the language file.


Screen Industrial Performance Analyzer

Manual -> Industrial Performance Analyzer -> Engineering in the Editor -> Screen Industrial Performance Analyzer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to display and to evaluate the alarm data, which the Industrial Performance Analyzer stores in the database, in the Runtime, you need the screen Industrial Performance Analyzer.

Create a new screen (see also Screens) and select as Screen type Industrial Performance Analyzer. Via the menu Control elements you can add the standard elements for the screen Industrial Performance Analyzer by selecting menu entry Add template. As an alternative, you can add the necessary control elements individually via menu Control elements.

Control element | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.
Window | Control elements for windows.
List | Tabular display of the alarm data. The information is read from the table in the database and are than displayed here.
List type | Text filed that displays the selected list type.
Set filter | Display of the set filter.
List functions | Control elements to control the list.
Filter... | Opens the filter dialog.
Filter back | Loads the last filter setting. The ten last filter settings are being saved.
Filter reset | Deactivates all filter settings.
Update database | Reads again the data from the database.
Create document | Creates a document with the selected data and opens the document. The data are displayed in form of a table.
Create diagram | Displays the selected data in a diagram.
Diagram settings | Definition of the layout for the diagram; e.g. bar or pie diagram.
Filter profiles | Buttons for filter settings in Runtime.
Profile selection | Select profile from list.
Save profile | Saves current setting as a profile.
Delete profile | Deletes selected profile.
Import | Imports filter profiles from export file.
Export | Exports filter profiles in the file.


Function Screen switch

Manual -> Industrial Performance Analyzer -> Engineering in the Editor -> Function Screen switch

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If you create a function screen switch (see also Functions) to screen Industrial Performance Analyzer, the IPA filter dialog is displayed. There you can set filters and make settings which are taken into account when the Runtime switches to the screen Industrial Performance Analyzer.

You can find more information about the settings of the filter dialog in chapter Filter.


Function Create/print IPA document

Manual -> Industrial Performance Analyzer -> Engineering in the Editor -> Function Create/print IPA document

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function, you can automatically create an IPA report and save it as an HTML document or print it out on the Windows standard printer. You can find the function in the group AML and CEL.

The can use the same filter options in the same way as when using the screen switch function to the screen Industrial Performance Analyzer. On tab Target document you select whether the report should be printed on the Windows standard printer or saved as a file in the export folder.

If you want to save the report to a file, activate checkbox To file and enter a name for the file.

attention Attention

Take care that you enter the file name including .html in order for your computer to recognize the file without a problem and to open it with an appropriated software program.

Example for file name:

IPA_010109.html

If you do not activate the checkbox, the report will be printed.


Operation in the Runtime

Manual -> Industrial Performance Analyzer -> Operation in the Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You operate the IPA in the Runtime with the help of the screen Industrial Performance Analyzer. The screen is opened with the filter settings and parameters which were defined in the Editor. You will receive the display which you defined in the Editor.

Each display has its own default sorting of the columns (see chapter Filter). You can also sort the display yourself using each available column. Click on the header of the desired column and the display is sorted after this column. If you want to use more than one column just press and hold Ctrl and then click the desired columns on after the other. Thus you receive a cascaded sorting. If you no longer use the default sorting, an arrow next to a column header indicates that the display is sorted by this column. You can sort either ascending or descending. If you left-click on a column once, the entries are sorted in descending order. Another left-click switches between the sorting directions.

For the operation of the Industrial Performance Analyzer and the display of the alarm data the control elements engineered in the Editor are available (see also Screen Industrial Performance Analyzer).

Delete entries

You can only delete entries from the database using the internal Industrial Performance Analyzer. In order to delete an entry right-click the desired entry. Select menu item delete selected line from the database in the context menu. If you have the necessary authorization, the entry is deleted (see also General settings).

Alarm reason and commentary

If you want to add an alarm cause and/or a commentary to an alarm, you have two possibilities. Double click the desired line. In the appearing dialog you can select an alarm reason from the dropdown list Alarm reason and you can enter a commentary in the text field Commentary.

You can also reach the dialog by right-clicking the desired line and selecting menu item Edit alarm reason from the context menu.


Filter

Manual -> Industrial Performance Analyzer -> Operation in the Runtime -> Filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the help of the filter dialog you define the look of screen Industrial Performance Analyzer. You decide which alarms are displayed and by which criteria they are sorted.

Each list type displays determined columns and has its own default sorting. There are three list types sum lists, statistics list and single list.

Sum list

List name | available columns | default sorting
class related | Alarm/event class, Number, Total duration | Column: Number, starting with the largest number
Single breakdown related | Variable, Variable identification, Number, Total duration, Total duration gross, Limit text, Alarm/event classes, Alarm/event groups, Equipment, Project | Column: Number, starting with the largest number
group related | Alarm/Event class, Number, Total duration | Column: Number, starting with the largest number
Equipment related | Equipment, Number, Total duration | Column: Number, starting with the largest number

Statistics list

List name | available columns | default sorting
Total downtime of an equipment | Equipment, Total duration | Column: Total duration, starting with the longest alarm
n shortest alarms | Status, Variable, Variable identification, Begin, Duration, Duration gross, Alarm/event class, Alarm/event group, Limit text, Shift start, Shift end, Equipment, Project, Alarm cause, Commentary | Column: Duration, starting with the shortest alarm
n most frequent alarms | Number, Variable, Variable identification, Begin, Total duration, Total duration gross, Alarm/event class, Alarm/event group, Limit text, Equipment, Project, Alarm cause, Commentary | Column: Number, starting with the largest number
n longest alarms | Status, Variable, Variable identification, Begin, Duration, Duration gross, Alarm/event class, Alarm/event group, Limit text, Shift start, Shift end, Equipment, Project, Alarm cause, Commentary | Column: Duration, starting with the longest alarm
n last alarms | Status, Variable, Variable identification, Begin, Duration, Duration gross, Alarm/event class, Alarm/event group, Limit text, Shift start, Shift end, Equipment, Project, Alarm cause, Commentary | Column: Duration, starting with the oldest alarm

Enter the desired number n in the field n=.

Single list

List name | available columns | default sorting
Alarm Message List | Status, Variable, Variable identification, Begin, Duration, Duration gross, Alarm/event class, Alarm/event group, Limit text, Shift start, Shift end, Equipment, Project, Alarm cause, Commentary | Column: Duration, starting with the oldest alarm


Database and view

Manual -> Industrial Performance Analyzer -> Operation in the Runtime -> Filter -> Database and view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Select the desired view under View.

The fields DSN name and Table show the connection to the SQL server and the name of the table in which the IPA writes the alarm data. These fields are purely informative. You cannot make any changes (see also Database). You can make setting using these properties:

Parameters | Description
Display grid | Shows a raster when displaying the alarm data.
n= | Define how many entries the views n shortest alarms, n most frequent alarms, n longest alarms and n last alarms should contain.


Date/Time

Manual -> Industrial Performance Analyzer -> Operation in the Runtime -> Filter -> Date/Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use this filter, activate the checkbox Active. If you close the dialog via OK, your settings are used on the display. If you deactivate checkbox Active, the settings are retained. They are however not used on the display.

Select Today, Yesterday, Day before yesterday or Selectable in the date filter. If you select Selectable, enter a freely defined date range. If you activate with time, enter the desired time for the start and end date. If you do not activate with time, the time range is from 0 a.m. on the start date to 12 p.m. on the end date.

Select Selectable or Self-defined in the time filter. If you select Selectable, enter a freely defined time range. If you select Self-defined, choose a time range which you have created in the Editor beforehand. See also chapter Pre-define time filter.

Note: Time is saved as local time. For details see chapter Handling of date and time in chapter Runtime.

info Information

The time range under Time is valid for each day which has been selected under Date. If you select Selectable under Date, 01.10.2008 under Start and 05.10.2008 under End, the time range, which you have selected under Time, is valid for each of the five days starting October 1st and ending October 5th. October.


Equipment identification

Manual -> Industrial Performance Analyzer -> Operation in the Runtime -> Filter -> Equipment identification

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use this filter, activate the checkbox Active. If you close the dialog via OK, your settings are used on the display. If you deactivate checkbox Active, the settings are retained. They are however not used on the display.

In the filter of the equipment identification one or more pieces of equipment can be activated. You can select the entries in the left list and move them to the right list with the help of the arrow key.

The alarms of the pieces of equipment of the right-hand list will be displayed.

The equipment identification is carried out using the prefix of the variable name or the variable identification depending on your project setting (see also General settings). You administrate the list for the equipment identification in the Editor under Equipment identification.

info Info

At filtering more than one entry can be selected at a time. You can select more than one entry by pressing and holding Ctrl or Shift. By pressing and holding Ctrl you can select a number of entries. By pressing and holding Shift you select all entries which lie between the two selected entries. By pressing and holding both Ctrl and Shift all entries which lie between the selected entries are selected. The entries which were selected beforehand remain selected.


Alarm/event classes

Manual -> Industrial Performance Analyzer -> Operation in the Runtime -> Filter -> Alarm/event classes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use this filter, activate the checkbox Active. If you close the dialog via OK, your settings are used on the display. If you deactivate checkbox Active, the settings are retained. They are however not used on the display.

In the filter of the alarm/event classes one or more alarm/event classes can be activated. You can select the entries in the left list and move them to the right list with the help of the arrow key.

The alarms of the groups in the right list will be displayed.

info Information

In the Runtime, only the name of the alarm/event class is displayed. Thus a better sorting of the entries is achieved. The number of the alarm/event class is not displayed.

info Info

At filtering more than one entry can be selected at a time. You can select more than one entry by pressing and holding Ctrl or Shift. By pressing and holding Ctrl you can select a number of entries. By pressing and holding Shift you select all entries which lie between the two selected entries. By pressing and holding both Ctrl and Shift all entries which lie between the selected entries are selected. The entries which were selected beforehand remain selected.


Alarm groups

Manual -> Industrial Performance Analyzer -> Operation in the Runtime -> Filter -> Alarm groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use this filter, activate the checkbox Active. If you close the dialog via OK, your settings are used on the display. If you deactivate checkbox Active, the settings are retained. They are however not used on the display.

In the filter of the alarm/event group one or more alarm/event groups can be activated. You can select the entries in the left list and move them to the right list with the help of the arrow key.

The alarms of the groups in the right list will be displayed.

info Information

In the Runtime only the name of the alarm/event group is displayed. Thus a better sorting of the entries is achieved. The number of the alarm/event group is not displayed.

In doing so, sorting is not alphabetical, but always according to he index.

info Info

At filtering more than one entry can be selected at a time. You can select more than one entry by pressing and holding Ctrl or Shift. By pressing and holding Ctrl you can select a number of entries. By pressing and holding Shift you select all entries which lie between the two selected entries. By pressing and holding both Ctrl and Shift all entries which lie between the selected entries are selected. The entries which were selected beforehand remain selected.


Miscellaneous

Manual -> Industrial Performance Analyzer -> Operation in the Runtime -> Filter -> Miscellaneous

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab a few additional filter functions are available.

Parameters | Description
Alarm duration | Filtering on alarm duration. Only alarms whose duration is within this time frame will be considered.
Alarm frequency | Filtering alarm data on alarm frequency. Only alarms whose frequency is within this frame will be considered. This filter can only be activated if the n most frequent alarms has been selected in the list view.
Alarm status | Filtering by alarm status. Choose from one of these possibilities: current, cleared or both.
Limit text filter | Filtering alarm data on the limit text of the alarm. Either on the text – e.g. 'Test' lists all alarms with the word 'Test' in the alarm text - (case sensitive or not) or with Regular expressions.
Variable identification text filter | Filtering alarm data on the identification text of the alarm. Either on text or with Regular expressions.
Project filter | Filtering on the project, from which the alarm has been written to the database. When filtering on several projects, they have to be separated with the character ','.


Regular expressions

Manual -> Industrial Performance Analyzer -> Operation in the Runtime -> Filter -> Miscellaneous -> Regular expressions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Regular expressions indicate a string pattern which consists of normal characters (e.g. letters, digits etc.) and special characters which are referred to as meta characters. When filtering or searching in texts you can define a particular character string.

info Information

Do not confuse regular expressions with wildcards - e.g. * equals any string. Regular expressions are way more efficient and make it possible to define your search very precise.

The following list constists of all meta characters and how they are used as regular expressions:

Meta character | Description
\ | Marks the next character as a special character, a literal, a backreference, or an octal escape. For example n matches the character n. \n matches a newline character. The sequence \\ matches \ and \( matches (.
^ | Matches the position at the beginning of the input string.
$ | Matches the position at the end of the input string.
* | Matches the preceding character or subexpression zero or more times. For example zo* matches "z, zo, zoo etc.
+ | Matches the preceding character or subexpression one or more times. For example zo+ matches zo, zoo etc. but not z.
? | Matches the preceding character or subexpression zero‑ or one time. For example do(es)? matches the do in do or does.
? | When this character immediately follows any of the other quantifiers (*, +, ?, {n}, {n,}, {n,m}) the matching pattern is non-greedy. A non-greedy pattern matches as little of the searched string as possible, whereas the default greedy pattern matches as much of the searched string as possible. For example in the string oooo, o+? matches a single o while o+ matches all os.
. | Matches any single character except \n. To match any character including the \n use a pattern such as [\s\S].
(Pattern) | A subexpression that matches pattern and captures the match. To match parentheses characters ( ), use \( or \).
x|y | Matches either x or y. For example z|food matches z or food. (z|f)ood matches zood or food.
[xyz] | A character set. Matches any one of the enclosed characters. Example: [abc] matches the a in plain.
[^xyz] | A negative character set. Matches any character not enclosed. Example: [^abc] matches the p in plain.
[a-z] | A range of characters. Matches any character in the specified range. Example: For example [a-z] matches any lowercase alphabetic character in the range a through z.
[^a-z] | A negative range of characters. Matches any character not in the specified range. Example: For example [^a-z] matches any character not in the range a through z.
\cx | Matches the control character indicated by x. For example \cMmatches a Ctrl+M or a carriage return character. The value of x must be in the range of A to Z or a to z. If not, c is assumed to be a literal c‑character.
\f | Matches a form-feed character. Equivalent to \x0c and \cL.
\t | Matches a tab character. Equivalent to \x09 and \cI.
\v | Matches a vertical tab character. Equivalent to \x0b and \cK.
\num | Matches num, where num is a positive integer. A reference back to captured matches. Example: For example (.)\1 matches two consecutive identical characters.


Shift start

Manual -> Industrial Performance Analyzer -> Operation in the Runtime -> Filter -> Shift start

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use this filter, activate the checkbox Active. If you close the dialog via OK, your settings are used on the display. If you deactivate checkbox Active, the settings are retained. They are however not used on the display.

In the filter Shift begin one or more shifts can be activated. You can select the entries in the left list and move them to the right list with the help of the arrow key.

The filter Shift begin refers to the shift which has been active at the time when Alarm received was active. You can administrate the list with the shift names in the Editor under Schift name from list.

info Info

At filtering more than one entry can be selected at a time. You can select more than one entry by pressing and holding Ctrl or Shift. By pressing and holding Ctrl you can select a number of entries. By pressing and holding Shift you select all entries which lie between the two selected entries. By pressing and holding both Ctrl and Shift all entries which lie between the selected entries are selected. The entries which were selected beforehand remain selected.


Shift end

Manual -> Industrial Performance Analyzer -> Operation in the Runtime -> Filter -> Shift end

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use this filter, activate the checkbox Active. If you close the dialog via OK, your settings are used on the display. If you deactivate checkbox Active, the settings are retained. They are however not used on the display.

In the filter Shift end one or more shifts can be activated. You can select the entries in the left list and move them to the right list with the help of the arrow key.

The filter Shift end refers to the shift which has been being active at the time when Alarm received was active. The alarms and shifts of the right listbox will be displayed. You can administrate the list with the shift names in the Editor under Schift name from list.

info Info

At filtering more than one entry can be selected at a time. You can select more than one entry by pressing and holding Ctrl or Shift. By pressing and holding Ctrl you can select a number of entries. By pressing and holding Shift you select all entries which lie between the two selected entries. By pressing and holding both Ctrl and Shift all entries which lie between the selected entries are selected. The entries which were selected beforehand remain selected.


Alarm reason

Manual -> Industrial Performance Analyzer -> Operation in the Runtime -> Filter -> Alarm reason

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use this filter, activate the checkbox Active. If you close the dialog via OK, your settings are used on the display. If you deactivate checkbox Active, the settings are retained. They are however not used on the display.

In the filter alarm reasons one or more alarm reasons can be activated. You can administrate the alarm reasons in the Editor in the area Alarm reasons.

info Info

At filtering more than one entry can be selected at a time. You can select more than one entry by pressing and holding Ctrl or Shift. By pressing and holding Ctrl you can select a number of entries. By pressing and holding Shift you select all entries which lie between the two selected entries. By pressing and holding both Ctrl and Shift all entries which lie between the selected entries are selected. The entries which were selected beforehand remain selected.


Column definition

Manual -> Industrial Performance Analyzer -> Operation in the Runtime -> Filter -> Column definition

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab you customized the preset columns.

Parameters | Description
List view | Select the desired list from the dropdown list.
Columns | In this list all columns are displayed which are available for the selected list view.
User-defined | Activate this checkbox in order to customize the preset value for column title and column width.
Column titles | Enter new title for selected column.
Column width | Define the width for the selected column in pixel. If you enter 0, the column is not displayed.


Create document

Manual -> Industrial Performance Analyzer -> Operation in the Runtime -> Create document

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Additional to the display of the alarm data a document in HTML format can be created. These documents con be printed or saved.

After you have set all desired filters and sort options, you can generate the document by clicking Create document.

The layout of the document is defined with a XSL file (stylesheet). The following pre-defined files are available:

XSL file | Description
Single_list.xsl | single alarm display
Statistical_duration.xsl | statistic display of the total down time of an equipment
Statistical_frequency.xsl | statistic display of the n most frequent, n shortest, n longest, n last alarms
Sum_list_equipment.xsl | equipment related sum list
Sum_list_single_alarm.xsl | single alarm related sum list
Sum_list_group.xsl | group related sum list
Sum_list_class.xsl | class related sum list

These style sheets ar located in:

C:\ProgramData\COPA-DATA\zenon7.20\IPA\

For several stylesheet, a dialog asks for the stylesheet to be used.


Diagram

Manual -> Industrial Performance Analyzer -> Operation in the Runtime -> Diagram

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For the sum lists and the statistics list n most frequent alarms a diagram can be created in addition to the document.

With the settings of the diagram, its layout is defined.

On the tab Diagram general one of the following diagrams can be selected:

Diagram type | Description
Horizontal bar chart | Bar diagram is displayed horizontally.
Vertical bar chart | Bar diagram is displayed vertically.
Pie Chart | For the pie diagram 3D or 2D can be selected.

The summed alarms are displayed based on the time or the number. In the entry Miscellaneous the color of the bars are defined. Additionally the display of a grid is activated here.

On the tab Labeling you select the font and the color of the diagram labeling. The Style defines the text to be displayed.

On the tab Key you select the font and color of the key script. Here you also define, how the key should be displayed and where it should appear.


Installation and updates

Manual -> Installation and updates

During the first installation of zenon and during execution of Service Packs and upgrades, the installation routine automatically starts and leads you through the whole installation process. If the autostart from media feature has been deactivated, start the installation by executing start.exe in the root directory of your zenon installation medium.

Notes for the installation:

  • Before installing zenon:
    • All current operating system updates must be installed
    • There must not be a restart pending
  • With Windows 7 Embedded Standard, zenon is installed using the normal installation routine. You can find the hardware requirements in the Runtime under Windows Embedded Standard chapter.
  • zenon for Windows CE is installed using the normal installation routine. You can find details in chapter Runtime for Windows CE.
  • During the installation of zenon, the COPA-DATA Multiple Network Protocol Driver (cdprotdrv.sys) is installed. To start the driver, the operating system must be restarted after installation.

attention Attention

From Version 7.10 zenon cannot be installed on systems on which the Microsoft SQL Server Data Engine (MSDE) is already installed. This affects all systems on which zenon 6.20 or an earlier version has been installed.

info Information

If you receive an error message during installation stating that a service cannot be started, then:

  • first reboot the computer
  • then start the zenon setup again

64-bit operating systems: Installation of older version after installation of a version starting from 7.10

If, on a 64-bit operating system, after installation of zenon7.10 or higher, a version of zenon with a lower version number is installed, the 64-bit services of version 7.10 or higher must be re-registered afterwards using the command line. Registration can be carried out using a batch file or manually.

Registration with a batch file:

  1. Copy the file named Register.bat from the zenon installation medium.
  2. You can find this in the following folder: ...\Additional_Software\Register Admin Service and Log Service x64\
  3. Execute the file on the respective computer as an administrator.

manual registration:

  1. Run the command line with administrative rights
  2. Navigate to the folder C:\Program Files\Common Files\COPA-DATA\zenAdminSrv
  3. Start the service zenAdminSrv.exe with the parameter -service
  4. navigate to folder C:\Program Files\Common Files\COPA-DATA\zenLogSrv
  5. Start the service zenLogSrv.exe with the parameter -service

Example Example

zenAdminSrv:

  • Folder: C:\Program Files\Common Files\COPA-DATA\zenAdminSrv
  • Command: zenAdminSrv.exe -service

zenLogSrv:

  • Folder: C:\Program Files\Common Files\COPA-DATA\zenLogSrv
  • Command: zenLogSrv.exe -service

Installation of version 7.x and version 6.51 on the same computer

If a version 7.x is installed on a system that already has zenon 6.51 installed, the Multiple Network Protocol Driver must be reinstalled after a reboot.

For that

  1. Restart the system
  2. For x64 systems:
    1. On the installation medium, open the path Additional_Software\COPA-DATA Multiple Network Protocol Driver x64
    2. Execute the file called Install.bat
  3. For x86 systems:
    1. On the installation medium, open the path Additional_Software\COPA-DATA Multiple Network Protocol Driver x86
    2. Execute the file called Install.bat

This means that the driver is reinstalled and properly linked to the network adapters.


System requirements

Manual -> Installation and updates -> System requirements

zenon 7.20 can be used on all current Microsoft operating systems. The hardware being used is not important. The operating system abstracts hardware functions so far that zenon can normally be used without restrictions on any hardware.

zenon is always tested with the most up-to-date version of the operating systems with the newest available Service Packs and Hotfixes. You can thus assume that zenon can usually be used with the most recent service packs and hotfixes.

Changes in Microsoft's Service Packs and hotfixes or patches can cause incompatibilities and affect the software's functionality. If this is the case, COPA-DATA will release an updated version as soon as possible. In this case, please contact our Support: support@copadata.com.

attention Attention

For the optimum display of zenon in Runtime, the value Less than - 100% is recommended as a setting for the Windows display. Higher values can lead to graphic elements, symbols, texts, etc. not being displayed correctly.


System requirements when using DirectX

Manual -> Installation and updates -> System requirements -> System requirements when using DirectX

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following minimum requirements must be met when using DirectX hardware or DirectX software:

Note: For extensive projects or several projects loaded at the same time you will need accordingly faster/stronger hardware. The minimum requirements can increase as a result of this.

Parameters | Minimum requirements | Recommended
CPU: | Single core with SSE2 support. | Quad Core or more cores
Graphics card: (DirectX hardware only) | DirectX 11 mainstream graphics card. Note: When an integrated graphics chip is used in particular, it is possible, depending on the driver used, that there are impairments to the display quality. | Dedicated DirectX 11 AMD or nVidia high-end graphics card
Graphics memory: (DirectX hardware only) | 1 GB VRAM Note: The size that is actually needed depends on the number of screens called up and the elements displayed. | 2 GB VRAM
Driver graphics card: (DirectX hardware only) | The graphics card manufacturer's most recent driver.
Operating system: | DirectX hardware and DirectX software only works on operating systems that support DirectX11.1. If the system does not support DirectX 11.1, it automatically switches to Windows Enhanced. The current DirectX- Runtime must be installed. For zenon it is installed together with the setup. For the Web Client it must be installed manually.

You can check the DirectX hardware compatibility of the graphics card and the driver with the Windows operating system tool dxdiag.exe.
Up to Windows 7: Check the DDI version value under Display. The value 11 for example means DirectX 11.
From Windows 8: All supported versions of DirectX are displayed in the Display tab under Feature Levels. For example, DirectX 11 is displayed as 11.0.


Operating system

Manual -> Installation and updates -> System requirements -> Operating system

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Operating system | Required service pack
 | zenon Editor | zenon Runtime | zenon Web Server | zenon Web Client | zenon Logic Runtime | zenon Analyzer Server
Windows 7 (Professional, Enterprise and Ultimate version, x86 and x64 versions). | SP 1 | SP 1 | SP 1 | SP 1 | SP 1 | SP 1 - x64
Windows Embedded Standard 7 (if all necessary operating system components exist). | Cannot run | SP 1 | SP 1 | SP 1 | SP 1 | Cannot run
Windows 8 and 8.1 (Standard, Professional, Enterprise version, x86 and x64 versions) | SP 0 | SP 0 | SP 0 | SP 0 | SP 0 | SP 0 - x64
Windows Embedded 8 Standard (if all necessary operating system components exist). | Cannot run | SP 0 | SP 0 | SP 0 | SP 0 | Cannot run
Windows 10 | SP 0 | SP 0 | SP 0 | SP 0 | SP 0 | SP 0
Windows Server 2008 R2 (All editions with the exception of Core) | SP 1 | SP 1 | SP 1 | SP 1 | SP 1 | SP 1 - x64
Windows Server 2012 and 2012 R2 (All editions with the exception of Core) | SP 0 | SP 0 | SP 0 | SP 0 | SP 0 | SP 0 - x64
Windows CE 6.0 (ARM and x86) | Cannot run | zenon Operator only | Pro Light only | Cannot run | Running | Cannot run
Windows Embedded Compact 7 (ARM and x86) | Cannot run | zenon Operator only | Pro Light only | Cannot run | Running | Cannot run
  • All operating systems are supported in the multi-lingual version.
  • Windows RT 8 and Windows RT 8.1 are not supported due to the system.
  • Itanium processors are not supported for any operating system.

attention Attention

Automatic Windows updates influence the installation

If an update of the Windows operating system is carried out while the zenon setup is running, it can cause problems during the zenon installation. To prevent this:

  • deactivate the automatic Windows update during the time of installation
    or
  • carry out the Windows update before starting the zenon installation

Microsoft .NET Framework

zenon needs the Microsoft .NET Framework 3.5 or higher for VSTA and WPF. If the framework is not installed, an attempt is made to install it automatically. If the .NET Framework is an operating system component, it cannot be installed automatically. The setup then displays an error message and aborts. The .NET framework must be activated manually for these operating systems: Control panel - >Programs and functions - >Activate or deactivate Windows functions.

Overview

 | Windows Embedded 7/8 Standard | Windows Embedded 8.1 Pro/Industry | Windows 7 SP1/Windows 8 and 8.1/ Server 2008 (R2) SP1, 2012 and 2012 R2 | Windows CE
Editor |  | X | X | -
Runtime | X | X | X | -
Runtime for Windows CE | - | - | - | X
Web Server | X | X | X | X
Web Client | X | X | X | -

Processors supported in the different Windows CE operating systems are listed in chapter CE versions/supported processors. You can find installation instruction for Runtime under Windows CE in chapter Runtime.

info Information

If you always use the latest version (Service Pack) of your operating system, you not only avoid compatibility issues but also security problems.


Additional software

Manual -> Installation and updates -> System requirements -> Additional software

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

SQL Server

zenon Editor works with an SQL database. This is also installed when zenon is installed.

  • Up to version 6.20 SP4: SQL-Server 2000 (MSDE)
  • From version 6.21 SP0 on: SQL Server 2005 Express
  • From version 7.00 SP0 on: SQL Server 2008R2 SP1 Express
  • From version 7.10 SP0: SQL Server 2012 SP1 Express

attention Attention

Regard when changing the version of the SQL Server: Projects must be backed up and exported in the original version and then imported back in the new version.

Dongle

  • Software required for dongle protection (Wibu-Key or CodeMeter) is automatically installed and updated.


User authorization

Manual -> Installation and updates -> System requirements -> User authorization

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Windows administrator rights are required for installation.

Standard Windows user rights are required for ongoing operation. The user account control (UAC) can be activated at the highest security level.


Virus scan

Manual -> Installation and updates -> System requirements -> Virus scan

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Anti-virus software can slow down or even prevent the installation of zenon.

Note: If the anti-virus software you use leads to problems during installation, deactivate the anti-virus software for the duration of the installation. Note that the computer in question is subject to higher risks in this period. Activate your anti-virus software immediately after the installation of zenon.


Hardware requirements

Manual -> Installation and updates -> System requirements -> Hardware requirements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

PC version and CE version of zenon have different requirements concerning the needed hardware. In this chapter you find hardware requirements for the unique versions of Editor and Runtime as well as Web Server and Web Client.

The Editor uses a Microsoft SQL Server as SQL Server and has higher hardware requirements than the Runtime. If Editor and Runtime shall be running on a system simultaneously, the requirements add up.

attention Attention

Graphics cards with their own graphics memory and DirectX support are recommended. Shared-memory graphics cards may require too much working memory and may thus lead to performance impairments. Note the System requirements when using DirectX chapter in relation to this. The recommended configuration from this chapter is to be noted for the use of Multi-Touch.


Editor

Manual -> Installation and updates -> System requirements -> Hardware requirements -> Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The minimum requirements are based on a complete installation of the Editor. For extensive projects or several projects loaded at the same time you will need accordingly faster/stronger hardware. The minimum requirements can increase as a result of this.

Hardware | Minimum requirements | Recommended
CPU | Single core with SSE2 support. | Quad Core
RAM memory | Windows 7/8: from 1024 MB. Note: The more projects you have simultaneously available in memory, the more memory you need. | Windows 7/8: 4096 MB
Harddisk | At least 4 GB free space for a complete installation plus additional space for the projects. |
Monitor resolution | Extended VGA with 1024 x 768 pixels. | Double monitor setup: 2 times 1680 x 1050.
Graphics adapter | 64 MB dedicated memory. Cards with shared memory can lead to performance loss. Note the System requirements when using DirectX chapter in relation to this. |
Input devices | Standard keyboard or standard mouse. |
USB interface or DVD drive | For the installation, regardless of installation medium. The installation is also possible via network. Installation files can also be downloaded from the customer area of the COPA-DATA website. |
Parallel or USB interface | In case of dongle licensing required for dongle. For network dongle only required for the dongle server. |
Network connection (optional) | Recommended 10 Mbit/s with TCP/IP protocol for Remote Transport, network dongle, project backups on central file server, multi-user capable Editor, etc. | 100 MBit/s


Runtime

Manual -> Installation and updates -> System requirements -> Hardware requirements -> Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The minimum requirements are based on a complete installation of Runtime. For extensive projects or several projects loaded at the same time you will need accordingly faster/stronger hardware. The minimum requirements can increase as a result of this.

Hardware

Minimum requirements

Recommended

CPU

Single core with SSE2 support.

Quad Core

RAM memory

Windows 7/8: from 512 MB.

Note: Projects with big amounts of data, Network projects, multiple projects simultaneously and projects in redundance mode need more memory.

Windows 7/8: 4096 MB

Harddisk

2 GB free space for the Runtime-installation plus additional space for the projects.

Attention: If you log historical data (e.g. Archive dataorAlarm-/CEL-Data), you need sufficient harddisk space or you have to make sure during engineering that the historical data is evacuated or deleted.

Monitor resolution

VGA with 640 x 480 pixels.

Graphics adapter

64 MB dedicated memory. Cards with shared memory can lead to performance loss. Note the System requirements when using DirectX chapter in relation to this.

Input devices

Keyboard and/or mouse. Operation via touchscreen is also possible. Many individual, customizable softkeyboards for the touchscreen are available for you. In addition, there is the possibility of Multi-Touch operation.

USB interface

(optional)
  • For installation.
    Installation also possible via network or other storage media.
  • For dongle. Network dongle also available.

Network connection (optional)

64 kBits/s for standard Client/Server projects.

100 Mbit/s full duplex for redundant operation.

100 kBits/s full duplex for standard Client/Server projects.

Remote connection (optional)

Minimum requirements: Dial-up modem with 9600 Bit/s.

1 Mbit/s full duplex.

WAN connection (optional)

Any desired connection via router, e.g. per ISDN or DSL Data transfer is slower in a WAN than in a local network for technical reasons. Be sure to check the possible data transfer rates of your WAN technology already at the time when you create the project.

Message Control (optional):

Please refer to chapter Message Control for the requirements.

Interfaces (optional)

The necessary interfaces depend on the requirements of the PLC and/or the bus connection, for example serial RS232 or RS422/485 interfaces, ISA/PCI slots, etc.


Runtime under Windows Embedded Standard

Manual -> Installation and updates -> System requirements -> Hardware requirements -> Runtime under Windows Embedded Standard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The minimum requirements are valid for a Runtime installation adapted to the Windows Embedded Standard 7 SP1 operating system. The hardware must be accordingly more powerful for extensive projects.

This table only states the figures that are different to the standard installation. The other parameters correspond to the figures described in the Hardware requirements for Runtime chapter.

Hardware

Minimum requirement

Recommended

RAM memory
  • 512 MB.

Note: Projects with big amounts of data, Network projects, multiple projects simultaneously and projects in redundance mode need more memory.
  • 2048 MB

Storage medium
  • 2 GB of free memory on C:\ drive before the installation of .NET Framework 3.5 and 4.5
    800 MB of free memory after the installation of the .NET Framework
  • Plus memory space for the projects, archives, etc.
  • 80 GB

Attention: If you log historical data (e.g. Archive dataorAlarm-/CEL-Data), you need sufficient harddisk space or you have to make sure during engineering that the historical data is evacuated or deleted.


Runtime for Windows CE

Manual -> Installation and updates -> System requirements -> Hardware requirements -> Runtime for Windows CE

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The minimum requirements are based on a complete installation of the Runtime for Windows CE. The hardware must be accordingly more powerful for extensive projects.

Hardware | Minimum requirement | Recommended
CPU | At least 400 MHz | 1 GHz.
RAM memory | 64 MB. | 1024 MB for Windows CE 6.0.
Storage medium | 64 MB free harddisk space. Permanent recordable remanent storage medium for project data | 256 MB free harddisk space or more.
Network connection | For standard Client/Server projects: 10 Mbit/s full duplex. |


Web Server

Manual -> Installation and updates -> System requirements -> Hardware requirements -> Web Server

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The minimum requirements are based on a complete installation of the Web Server. For extensive projects or several projects loaded at the same time you will need accordingly faster/stronger hardware. The minimum requirements can increase as a result of this.

Hardware | Minimum requirements | Recommended
CPU | Single core with SSE2 support. |
RAM memory | Windows 7/8: from 1024 MB. |
Harddisk | 256 MB free harddisk space. | 1 GB free harddisk space.
Network connection | 10 Mbit/s full duplex. | 100 Mbit/s full duplex.
Remote connection (optional) | Minimum requirements: Dial-up modem with 9600 Bit/s. | 1 Mbit/s full duplex.


Web Client

Manual -> Installation and updates -> System requirements -> Hardware requirements -> Web Client

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The minimum requirements are based on a complete installation of the Web Client. For extensive projects or several projects loaded at the same time you will need accordingly faster/stronger hardware. The minimum requirements can increase as a result of this.

Hardware | Minimum requirements | Recommended
CPU | Single core with SSE2 support. | Quad Core
RAM memory | Windows 7/8: from 1024 MB. |
Harddisk | 64 MB free space for the Web Client plus additional space for the projects. | 80 GB free harddisk space.
Network connection | 10 Mbit/s full duplex. | 100 Mbit/s full duplex.
Remote connection (optional) | Minimum requirements: Dial-up modem with 9600 Bit/s. | 1 Mbit/s full duplex.
Graphics adapter | 64 MB dedicated memory. Cards with shared memory can lead to performance loss. Note the System requirements when using DirectX chapter in relation to this. |


File Structure

Manual -> Installation and updates -> System requirements -> File Structure

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The special file structure is created or extended during the installation.

The zenon program files are copied to a folder which can be defined during the installation.

Additionally the installation asks for a folder for the SQL databases of the projects. The storage medium for project archiving (SQL, screens etc.) must have enough free space, because all current and future project data is stored there.

Folder | Path
Program folder | 32-bit system: C:\Program Files\COPA-DATA\zenon7xxx 64-bit system: C:\Program Files\COPA-DATA\zenon7xxx C:\Program Files (x86)\COPA-DATA\zenon7xxx
Program data folder, e.g. global symbols, print templates, log files etc. | C:\ProgramData\COPA-DATA\zenon7xxx
Database folder (SQL) | C:\ProgramData\COPA-DATA\SQL
System folder | C:\ProgramData\COPA-DATA\System
Settings Editor and profiles | C:\Users\UserName\AppData\Local\COPA-DATA\zenon\Editor
Settings Diagnosis Viewer | C:\Users\UserName\AppData\Local\COPA-DATA\zenon\DiagView

Definition Runtime folder and Data folder

Runtime folder

The Editor creates Runtime files in the Runtime folder, or they are transferred to this folder with the help of Remote Transport. When creating a project, you must define the Runtime folder. Later it can be changed in the project properties. With Remote Transport, the Runtime folder is defined in Remote Transport settings.

Data folder

The Runtime saves all data files that were created at runtime like alarm files, archive files etc. in the data folder. The data folder is created as a subfolder of the Runtime folder by default. The folder is automatically assigned the name of the computer the Runtime is running on. You can change this save location in the project properties (General/Data folder).

Hint: Never set the data folder to a removable device such as an USB stick or a network device. It is recommended that the data is recorded locally and backed up externally.

attention Attention

If the defined path does not exist or is not available, no more data is written from the Runtime. This means a complete loss of data. The Runtime can still be operated but must be restarted as soon as the path is available again. The availability of the folder can be checked via system driver variable Runtime folder not available .


Free ports

Manual -> Installation and updates -> System requirements -> Free ports

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon and zenon Logic need certain communication ports for the communication in the network. If these ports are occupied by other programs like e.g. an already installed SQL server, the communication of zenon can be disturbed.

This is how you check the port assignments:

  1. Enter netstat -a -n -o in the command line.

    You can reach the command line in Windows:

    • by pressing the Windows-key and R
    • Enter cmd and confirm with OK.
    • A DOS-window pops up
    • enter the command netstat
  2. A list of all currently used TCP and UDP ports will pop up.
  3. Check the listening ports (status: LISTEN) if the process-ID (PID) of the ports needed by zenon and zenon Logic corresponds with the processes of zenon and zenon Logic.

    These PIDs can be found in the window Processes of the Windows Task Manager; for this purpose activate the column PID in the menu Select view/columns.

  4. If other software uses these ports, reconfigure this software.
    You can see the ports that zenon and zenon Logic use in the Port assignment by zenon and zenon Logic table. Here you can also see if these ports can be amended in these programs.

Port settings by zenon and zenon Logic

Application | Description | Port | Transport log
stratonrt[k].exe | zenon Logic Runtime polling communication and zenon Logic Workbench. | 1200-1210 (can be changed) | TCP
stratonrt[k].exe |  | 4500-4510 (can be changed) | TCP
stratonrt[k].exe | zenon Logic redundancy. | 7000-7010 (can be changed) | TCP
stratonrt[k].exe | zenon Logic Runtime spontaneous communication. | 9000-9010 (can be changed) | TCP
zennetsrv.exe | zenon network service. | 1100-1100 (fix) | TCP
zensyssrv.exe | zenon transport service | 1101-1101 (fix) | TCP
zendbsrv.exe | zenon database service. | 1103-1103 (fix) | TCP
zenAdminsrv.exe | zenon administration service. | 50777-50777 (fix) | TCP
zenLogSrv.exe | zenon logging service. | 50780 | TCP
zenvnc.exe | zenon remote desktop service. | 5600-5600 (fix) 5610-5610 (fix) | TCP
CodeMeter.exe | CodeMeter dongle service. | 22350 (changeable but must not be changed) | TCP
WkSvW32.exe | WibuKey network service | 22347 (fixed) | TCP


Paths for setup and operation

Manual -> Installation and updates -> Paths for setup and operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Paths for zenon:

  • Setup
  • Editor
  • Runtime

info Info

You can display many default paths with the help of the set command:

  • start the command line (enter cmd in the Windows start area)
  • enter command set
  • with click in button Enter standard folders for Windows and zenon are displayed

Note: As absolute paths differ in different operating system, the paths are displayed as Windows environment variable in this chapter. For example %ProgramData% instead of C:\ProgramData.

Setup

At setup paths are set for:

  • Prerequisits
  • zenon Editor
  • zenon SQL folder

Only the paths for zenon Editor and zenon SQL folder can be customized.
The setup needs administrator rights . This is also true for changing the installtion paths.

Requirements

The installation paths of the required third-party software match the standard paths of the respective manufacturer and cannot be changed during setup.

The additional software packages that need to be installed depend on the type of installation:

  • zenon Editor
  • zenon Runtime
  • zenon Web Client
  • zenon Logic Runtime
Requirement | Editor | Runtime | Web Client | zenon Logic Runtime
Microsoft .NET Framework 3.5 SP1 | + | + | - | -
Microsoft .NET Framework 4.0 | + | + | - | -
Microsoft Visual C++ 2005 Redistributables | + | + | - | +
Microsoft Visual C++ 2010 Redistributables | + | + | + | +
Microsoft Visual C++ 2012 Redistributables | + | + | + | +
Microsoft SQL-Server 2012 SP1 Express (from 7.10 on) | + | - | - | -
VSTA | + | + | - | -
OPC-Core Components (up to 6.22 SP1) | + | + | - | -
Wibu key Dongle Software 6.0 x86/x64 | + | + | - | -
COPA-DATA Multiple Network Protocol Driver x86/x64 | + | + | - | +
CodeMeter dongle software x86/x64 | + | + | - | -
Report Viewer 10.0 (from 7.00 on) | + | + | + | -
VBA 7.1 | + | + | + | -

zenon

The installation of zenon Editor requires two paths:

  • zenon Editor:
    • 32 bit systems: %ProgramFiles(x86)%\COPA-DATA\zenon [Version]
    • 64 bit systems: %ProgramFiles%\COPA-DATA\zenon [Version]

    These paths can be customized during the installation.

  • zenon SQL folder:
    • From version 7.10 on: %ProgramData%\COPA-DATA\SQL2012\

    These paths can be customized manually via zenDB.ini.

zenon Editor

In the zenon Editor teh following paths are used as default:

Object | Path
Workspace | %CD_USERDATA% For example: C:\Users\Public\Documents\zenon_Projects
Projects | %CD_USERDATA% For example: C:\Users\Public\Documents\<CD_zenon_Projects Hint for short cuts: highlight the project -> Ctrl+Alt+D
SQL folder of the project | %ProgramData%\COPA-DATA\[SQL-Ordner]\[UID]\FILES Hint for short cuts: highlight the project -> Ctrl+Alt+E
project.ini | %ProgramData%\COPA-DATA\[SQL-Ordner]\[UID]\FILES\zenon\system
zenon6.ini | %ProgramData%\COPA-DATA\System For example: C:\ProgramData\COPA-DATA\System
Backup | %ProgramData%\COPA-DATA\[SQL-folder]\UID]\BACKUP %ProgramData%\COPA-DATA\[SQL-Ordner\UID]\FILES\[Projekte]
Compiled files | %CD_USERDATA%\[Workspace]\[Project]\RT
External files | %CD_USERDATA%\[Workspace]\[Project]\RT\FILES\... Note: Can be set in the project using the file storage property.
System files | Windows system folder.

zenon Runtime

In the zenon Editor teh following paths are used as default:

Object | Path
Projects | %CD_USERDATA%\[Workspace]\[Project]\RT
External files | %CD_USERDATA%\[Workspace]\[Project]\RT\FILES\...
Exported archives, Chronological Event List and Alarm Message List | %CD_USERDATA%\[Workspace]\[Project]\Export Note: Is created at the first export.
System files | Windows system folder.

zenon Logic

Paths for zenon Logic are created analogous to the zenon paths.


zenon Standard installation

Manual -> Installation and updates -> zenon Standard installation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon will automatically start its installation routine and guide you through the whole installation process when the zenon installation medium is connected. Alternatively, it is possible to start the installation by executing start.exe in the root directory of your zenon installation medium.

attention Attention

The computer is automatically restarted during installation if necessary. Close all other programs before installation.

  1. You can see the version to be installed including the build number on the start screen.
  2. Select the desired language for the installation from the drop-down list at the top left.
  3. You can receive information on zenon with:
    • Click on button i: Opens the Flash player with information on the current zenon version.
    • Click on button ? Opens the zenon help for installation as a PDF.

    Attention: This page cannot be shown again later. If you need information on the current version or need the manual for installation, open it now.

  4. Clicking on the Next button opens the window with the license conditions.
  5. Confirm the license conditions by activating the corresponding checkbox.

    You can also print the license conditions out by clicking on the Print button.

  6. Clicking on the Next button opens the window to select the desired product.
  7. Select the desired product. It is only possible to select products that have not already been installed. If you want to reinstall something, you must first uninstall it using the control panel.

    • Editor: Installs the zenon Editor and zenon Runtime. Other components required for the Editor are also installed together automatically.
    • Runtime: Installs the zenon Runtime only.
    • Web Server: Installs zenon Web Server and the respective current zenon Web Clients.
  8. By clicking on the desired product, you open the window to select the edition.
  9. Select the licensed version:
    • zenon Supervisor Edition
    • zenon Energy Edition
    • zenon Pharma Edition
    • zenon Operator Edition

  10. Click on the desired edition to open the window to select the type of installation:
    • Install now: Starts the installation of the selected edition.
      The computer may be restarted automatically during installation. Follow the instructions of the wizard
    • User defined: Opens other windows for individual installation.
      You can enter an existing serial number here and change the installation path.

User-defined installation

  1. If you select user-defined during installation, the window to enter the serial number is opened:

    • Select demo version if you do not have a license.
    • I you already have a license, enter the serial number and activation number.
  2. Clicking on the Next button opens the window to amend the installation folder.

    • If necessary, define you individual folder for the 32-bit version and the 64-bit version of the program.
    • Define the target folder for the project database.
      Note: This folder cannot be changed afterwards. The save location selected here must have sufficient memory space. All users need write authorization.
    • If you would also like to install the demo project, activate the corresponding checkbox.
      The demo project provides examples of possible usage scenarios in different industries. You can find details in the section Encryption zenon Demo-Project.
  3. Click on the Install button. Installation of the selected edition is started.
    The computer may be restarted automatically during installation. Follow the instructions of the wizard


Error treatment

Manual -> Installation and updates -> zenon Standard installation -> Error treatment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Check before installation:

The system requirements are checked before installation. If the requirements are not met, you are shown these on a separate page with notices on how to rectify this.

Error during installation

You will receive an error message if there are errors during installation.

If you need help from the Technical Consulting department of COPA-DATA:

  1. If possible, create a screenshot of the error message
  2. Navigate to the folder called %Temp%/SCADALOG.
  3. Here you can find the log files of the installation.
  4. Create a ZIP file with the content of the folder.
  5. Forward the file and the screenshot to support@copadata.com

If you have already closed the error message window, you can find the log files with all the installation information for the SQL server in the following folder:
C:\Program Files\Microsoft SQL Server\110\Setup Bootstrap\LOG

Hint: The file summary.txt provides information for troubleshooting.

info Information

Firewalls: zenon automatically configures the firewall installed with Windows during installation. Firewalls from other providers must be properly configured by the user

Frequent sources of error during installation:

  • The virus scanner is active and blocks the installtion because the scanner thinks it´s a virus. Solution: Seperate the system from the network, disable the virus scanner, execute the installation again.
  • The firewall was not configured correctly. Solution: Seperate the system from the network, disable the firewall, execute the installation again.
  • Erroneous SQL-installation on the system. Solution: Create project backups; if possible, deinstall SQL server, rename the SQL folder, and restart installation.


zenon for Windows CE

Manual -> Installation and updates -> zenon for Windows CE

Components

The CE version of zenon consists of the following components:

  • zenon CE Runtime
  • Language DLLs
  • Network DLL
  • Driver DLLs
  • zenon6.ini
  • Transport service

Prerequisite for the installation of the Runtime on remote systems

  • PC version and CE version of zenon have to match (same version, same Service Pack). CE must already be installed on the PC.
  • Either the transport service (SysSrvCE.exe) of zenon must be installed and started on the CE terminal or an ActiveSync-connection is needed. Tips for the manual installation via storage media can be found in chapter Manual Installation and Runtime-Update.
  • The CE terminal to which the data shall be transported has to have at least 8 megabytes free "Program Memory", so that we can guarantee correct transport. This parameter can be adapted via the Control Panel System properties.

Course of actions

Details about compatibility. installation and update can be found in chapters:

  • CE versions / supported processors
  • Update of the Windows CE Runtime

info Information

The Runtime for Windows CE can be licensed with the Remote Transport. When you establish the connection to the target system, you can enter the serial number and the license number for the CE version. The serial number is saved on the CE device in the zenon6.ini file. The activation number is saved in the registry.

info Info

If, when starting zenonrce.exe, the syssrvce.exe file is also executed, then it can be ensured that a TCP connection can always be established. Thus only one file is necessary for the autostart functionality. However a time delay between both starts must be configured.

Reason: When starting zenonRCE, zenLogSrvCE also starts automatically. However when starting syssrvce, zenLogSrvCE is also started.

If zenonRCE and syssrvce are started within a very short period of time, both attempt to start zenLogSrvCE. This leads to an error message.

Solution: To avoid this, configure a time delay between the start of zenonRCE and zenLogSrvCE. To do this, you can set the STARTDELAY= entry in zenon6.ini. Runtime (zenLogSrvCE) is thus started later. A check is then made to see whether zenLogSrvCE is already running and this does not start again.


CE - versions and supported processors

Manual -> Installation and updates -> zenon for Windows CE -> CE - versions and supported processors

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the current zenon version 7.20 the following Windows CE versions and processors are supported:

  • CE 6.00 for x86
  • CE 6.00 for ARMV4/V5

info Information

You can find information about the supported CE versions and processors for earlier zenon versions in the corresponding documentation or you can contact the COPA-DATA support.


System files

Manual -> Installation and updates -> zenon for Windows CE -> System files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Windows CE Runtime requires the existence of certain system files. In case one of these files is missing, the operating system sends an error message during Runtime start, that one or various components have not been found. The following system files are required:

File | Description
mfc90u.dll | Necessary for the Runtime. On startup, an error message pops up if this file does not exist.
msvcr90.dll | Necessary for the Runtime. On startup, an error message pops up if this file does not exist.
atl90.dll | Not necessary for starting the Runtime but for the use of drivers with network connections or the use of zenon in a network. If this file does not exist, the device will not work as a client; TCP/IP driver connections will not work.
IMGDECMP.dll | Not necessary for starting the Runtime but necessary for displaying Transparency if Alpha Blending is not integrated in the operating system. Animation of GIF files is not possible with Windows CE.
VBSCRIPT.dll + JSCRIPT.dll | Not necessary for starting the Runtime. This file is needed for the PCE (Process Control Engine).

Some of these system files are installed together with the installation of zenon for CE and can be transferred to the CE device using the UpdateCE Tool. All these system files should be integrated in the operating system image of the CE device by the manufacturer.

attention Attention

For manufactures of Windows CE OS-images:
CE versions older than 6.0 need the file toolhelp.dll. Activate the following option in Platform Manager in order that the file is available on the CE device and Toolhelp.h is available in SDK.
Core OS -> Display Based Device ->Core OS Services -> Debugging Tools -> Toolhelp API. Thus the Toolhelp.dll is part of the image.
Hint: Always use the most up-to-date Servicepack of the Platform Builder.

Note: File toolhelp.dll is not used for Windows CE 6 and should not be used with CE 6.


Update of the Windows CE Runtime

Manual -> Installation and updates -> zenon for Windows CE -> Update of the Windows CE Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To perform an update of Windows CE Runtime:

  • make sure that the zenon Transport Service (SysSrvCE.exe) runs in the CE device
  • make sure that you do not have established a remote connection via the zenon Editor to the device
  • In the zenon Menu, select Options and then Update Windows CE Runtime.
  • The dialog for transfer of Runtime files opens
  • configure the link
  • define the data you want to transfer
  • choose the appropriate version
  • start the update

Note: If you are transferring/installing Runtime for the first time, note the information in the Manual installation and Runtime update chapter.

Configure connection

You can configure the connections to the Windows CE device in the tab Connection.

Parameters | Description
Serial | Settings for serial connection with Windows CE device, you have to select a port.
TCP/IP | Settings for TCP/IP-connection to the Windows CE device.
Adress | IP address.
Name | Computer name
Syssrvce.exe starts with these settings | Settings for starting syssrvce.exe.
Serial | Active:: serial connection selected, port must be selected.
TCP/IP | Active: TCP/IP-connection selected.
Connection with MS ActiveSync | Settings for connection via MS ActiveSync
Use MS ActiveSync for initial transport of syssrvce.exe | Active: syssrvce.exe is transferred during the first transport via MS ActiveSync.
Destination folder | Target folder.
Help | Opens online-help
Save | Saves all changes.
Exit | Closes the update CE-tool and reminds you before to save unsaved changes.

Define files you want to transfer

Parameters | Description
Files to update | Files to be transferred.
HMI Runtime | Active: Transfers zenon files to the target device. Default: active
PLC Runtime | Active: Transfers zenon Logic files to the target device. Default: inactive
OS system files | Active: Transfers necessary files for the OS. Default: active
Update zenon6.ini | Transfers zenon6.ini to the target device. This way, the license information of the target device is also changed.
Options |
Language | Desired target system language. Default: English
HMI drivers | Selection of HMI drivers for transfer.
Available | List of available dirves.
Selected | List of selected drivers.
Add | Adds chosen drivers to the list of selected drivers.
Add all | Adds all drivers to the list of selected drivers.
Remove | Removes chosen drivers from the list of selected drivers.
Remove all | Removes all drivers from the list of selected drivers.
Help | Opens online-help
Save | Saves all changes.
Exit | Closes the update CE-tool and reminds you before to save unsaved changes.

Select version

Select the correct version in the tab Versions if it wasn´t automatically recognized.

Parameters | Description
WinCE version | Version of the target device Windows CE OS. Click the button to open a drop-down list for selection.
Processor type | Processor of the device.
Source path | Path to the folder that contains the files. Click the button ... and a dialog opens to select a folder.
New | Inserts a new, empty entry in the list.
Delete | Deletes the selected entry from the list
Test | Verifies settings.
Help | Opens online-help
Save | Saves all changes.
Exit | Closes the update CE-tool and reminds you before to save unsaved changes.

Start update

To establish a connection:

  • click on the button Start on the tab Update.

  • The data that shall be transferred is verified and displayed in a window.
  • Start the transfer to the target device by clicking on the button Next .

If the transfer cannot be initiated because files are missing, an error message with a list of missing files pops up:

  • If you get the error message The current update was not completed, the update was interrupted or not executed properly.

info Information

If you want to replace zenVNCServer.exe via update, it is terminated and restarted after the update. For this the file zenVNCSrvCE.exe must contain the

the following entry in the UpdateCE.ini in section [SOURCES_FILES_GENERAL] (exists per default):

  • zenVNCSrvCE.exe
  • zenVNCCfgCE.exe


Manual installation and Runtime-update

Manual -> Installation and updates -> zenon for Windows CE -> Manual installation and Runtime-update

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Installation and update are also possible without remote transport and ActiveSync. You have to copy the needed files manually on a storage card for the CE device. You have to know CE version and processor type.

It is mandatory to copy the following files from the according folder for the correct platform to a storage card for the CE device:

  • zenonRCE.exe (Runtime)
  • LogCliLibCE.dll (Diagnosis DLL)
  • zenon6.ini (Configuration file)
  • Cd_tooCE.dll (Help DLL)
  • ZenNetSrvCE.dll (Network)
  • CDHelper.dll (Help DLL)
  • One of the following language DLLs: RChineCE.dll, RCzechCE.dll, REngliCE.dll, RFrancCE.dll, RGermaCE.dll, RItaliCE.dll, RRussiCE.dll, RSpaniCE.dll (the selected language is stipulated in the zenon6.ini file.)
  • syssrvce.exe (Transport service and diagnosis server)
  • atl90.dll (System file, possibly part of the operating system)
  • mfc90u.dll (System file, possibly part of the operating system)
  • msvcr90.dll (System file, possibly part of the operating system)

Further files, for example the driver or the remote desktop software (zenVNCCfgCE.exe and zenVNCSrvCE.exe), are optional.


Pocket PCs (PDA - Handheld PC)

Manual -> Installation and updates -> zenon for Windows CE -> Pocket PCs (PDA - Handheld PC)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Pocket PCs are no longer supported from version 7 on.


Error treatment

Manual -> Installation and updates -> zenon for Windows CE -> Error treatment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Possible errors:

Error | Possible solution
Connection error when updating via COM. | Windows Explorer being open delays the access time. Closing Explorer rectifies the problem.
Transport service does not work. | Check the version of the transport service. At least: Version 5.21 SP3 or higher or version 5.50 SP1 or higher.
Runtime update program cannot establish a connection. | Close open connections of the Editor to the CE transport service.


zenon Logic Runtime for Windows CE

Manual -> Installation and updates -> zenon Logic Runtime for Windows CE

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The installation of the zenon Logic Runtime (PLC Runtime) on a CE system is similar to the installation of the Runtime for Windows CE.

Requirement: Executable transport service under CE

The CE version of the zenon Logic Runtime consists of the following components:

  • zenon Logic Runtime
  • Language DLLs
  • zenon Logic IO driver
  • zenon6.ini

Installation

  • In the zenon Menu, select Options/Update Windows CE Runtime.
  • The dialog for transfer of Runtime files opens.
  • Activate the Checkbox PLC Runtime in the Files window to copy the files zenon Logic needs to the CE execution directory.
  • Switch to tab Connection.

  • Define the connection to the Windows CE device. Enter the IP-address or the serial port.
  • If zenon6.ini shall also be transferred, select update zenon6.ini. This way, the license information of the target device is also changed.
  • Select the proper version in the window CE Runtime versions, if it wasn´t automatically recognized.

Update

Works as described in chapter Update of Windows CE Runtime .

Attention: You have to activate the option PLC Runtime in the tab "Files" !

info Information

The MFC files are always transferred using Windows CE 6.0.


zenon Web Server

Manual -> Installation and updates -> zenon Web Server

To install zenon Web Server or zenon Web Server Pro:

  1. Activate the WWW services on the computer.

    Folder C:\inetpub\wwwroot must exist.

  2. Start the zenon installation medium. The start screen is displayed

    If you have deactivated the autostart feature, execute start.exe from the installation medium.

  3. Select the zenon Web Server.
    Depending on the version of the operating system (32-bit or 64-bit), the corresponding version of the zenon Web Server will be installed.
  4. Follow the installation routine.
  5. Restart the computer.

After installation, You can find the setup files for the web client in subfolders of the zenon Web Server installation path (xxx stands for the respective version of zenon), for example: C:/Program Files (x86)/COPA-DATA/zenonWebserver/zenon/controlversions/Versionxxx/zenon_Webclient_Setup_ENGLISH.EXE
or

C:/Inetpub/wwwroot/zenon/controlversions/Versionxxx/zenon_Webclient_Setup_ENGLISH.EXE

The website examples (index*.html and init*.html) are also installed. These can be found in the subfolder zenon of the zenon Web Server installation path, for example:
C:/Programs/zenonWebserver/zenon/index.htm
or
C:/Inetpub/wwwroot/zenon/index.html

info Information

The zenon Web Server service is started automatically only in the licensed version. In demo mode, you have to start the zenon Web Server manually via zenon Web Server console in the Control Panel.

Additional information

You can find details about the zenon Web Server in the manual zenon Web Server and Web Server Pro, about the licensing in manual Licensing.


zenon Web Client

Manual -> Installation and updates -> zenon Web Client

The zenon Web Client is mainly an ActiveX control displaying the information in a browser. The display is just as on a normal client. The connection to the Runtime server is implemented via the zenon Web Server using TCP/IP communication.

The setup files for the Web Client can be found after installation in subdirectories of the Web Server installation path (xxx stands for the respective version of zenon), for example: C:/Program Files/COPA-DATA/zenonWeb Server/zenon/controlversions/Versionxxx/zenon_Webclient_Setup_GERMAN.EXE
or

C:/Inetpub/wwwroot/zenon/controlversions/Versionxxx/zenon_Webclient_Setup_ENGLISH.EXE

All Web Client Setups are digitally signed and can be provided for download via internet, too, without any problems. You can find further Web Client setups on the zenon Web Server CD in folder Web Client Versions. There are according language versions for each version.

info Info

The Web Client sends error files and LOG files. With the installation of the Web Client, the diagnosis server is also installed.


Updates (Build Setups), Service Packs and Upgrades

Manual -> Installation and updates -> Updates (Build Setups), Service Packs and Upgrades

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Update (Build Setup)

An update is installed over the existing installation; it replaces only changed files with the new version. All projects and individual settings will remain unchanged. Note that Build Setups are never 100% quality-assured. Only the bug fixes are tested. If unwanted side effects should occur because of a bug fix, it might be possible that these side effects will not be noticed during testing. COPA-DATA therefore always recommends using Service Packs. They always have to pass the whole quality-assurance process.

Note for Web Client: To install an update for the zenon Web Client, the Web Client must be uninstalled beforehand.

Service Packs

Service Packs always contain a complete version of zenon. The installation routine doesn´t replace some files. Instead, it removes the old version and installs the new one. If you install a Service Pack, all your projects and individual settings remain intact. Projects aren´t converted to the new version during installation. The respective project is converted when it´s being opened for the first time in the Editor. A dialog box notifies you about this procedure. The old version is automatically backed up.

A service pack always contains all bug fixes of previous builds.

Upgrade

If you want to install a new version of zenon, start the installation routine. The new version is being installed parallel to the old one. All projects and individual settings will remain unchanged. Projects aren´t converted to the new version during installation. The respective project is converted when it´s being opened for the first time in the Editor. A dialog box notifies you about this procedure. The old version is automatically backed up. If you want to use only the most up-to-date version, use the Windows control panel software deinstallation routine to remove the old version.

attention Attention

If an upgrade involves changing the SQL server (for example, an update from zenon 7.00 to zenon 7.10 or higher), you must back up all projects or the workspace before the installation. This backup is read back after the installation. For details see also section Multi-user projects/Update with change of SQL servers.

If you want to use multiple versions of zenon simultaneously, you have to manage them using the Startup Tool. You can start only one version at a time. You can select which version you want to run using the Startup Tool that automatically adjusts all necessary settings. You can find details in chapter Startup Tool.

info Information

New versions (Service Pack, Upgrade) always bring about structural changes. Projects and settings remain untouched during installation. If you open the Editor for the first time, projects are converted to the new version. Simultaneously, an automatic backup of the old version is created.

Converted projects cannot be edited in legacy versions. From version 6.2 on, the Editor is able to create projects for different Runtime versions.

Important tips for converting projects can be found in the revision text. This is provided with the Service Pack/Update on the installation medium under Information. It is also available online.

Multi-user projects

To ensure a change to a new zenon version in multi-user projects without data loss:

  1. Check in all checked out elements on all Clients -> Accept changes.
    Nothing must be checked out. This is true for all projects.
  2. Install the new zenon version on the Server.
  3. Convert all Server projects to the new version: For this load all projects in the Editor on the Server computer.
  4. Install the new zenon version on the Client computers.
  5. Load projects on the Clients and check them out again.

Update with change of the SQL Server

If an upgrade involves changing the SQL server (e.g. update from zenon 6.51 to zenon 7.20), additional steps are needed. These steps are carried out:

  • after all projects are checked in
  • before the new version is installed

Procedure when changing the SQL Server:

  1. check in all checked out elements on all Clients -> Accept changes.
  2. at the multi-user Server open the Editor in the starting version
  3. create backups of all projects which you want to edit or open with the new version
    • either as single project backups
    • or as backup of the complete workspace
  4. install the new version on the Server
  5. convert all Server projects to the new version by loading the project backups which you have created before once in the Editor
  6. install the update on every Client
  7. transfer the projects from the multi-user Server to the Clients
    (regard the new name of the SQL instance)
  8. the projects are converted, synchronized and ready for action

Attention: Make sure that the settings of the firewall allows the data traffic between the multi-user Server and the Clients.


FAQ

Manual -> Installation and updates -> FAQ

Errors during the installation mostly occur when the replacement or creation of files is prevented by a virus scanner or by existing installations. Here you can find the most frequent reasons for installation errors and their solution.

zenon

Problem

Solution

Installation is terminated.

Typical error message: Error 1304. Error writing to file...

Deactivate the virus scanner. Close unnecessary programs.

Roll back after OPCenum.exe - error.

It is possible that parts of the OPC server which already exist on the system cannot be overwritten.

  • Delete the following files:
    - C:\Windows\System32\OPC*.dll
    - C:\Windows\System32\OPCenum.exe
  • Delete folder:
    C:\Program Files\Common Files\OPC Foundation
  • Delete all registry entries which contain opcenum.

Demo projects were installed but are not displayed. New projects cannot be created.

Check the computer name. The computer:

  • must not consist of more than 15 characters
  • must be in accordance with the convention of the NetBIOS computer name

Error message that a service cannot be started.
  • first reboot the computer
  • then start the zenon setup again

SQL Server

General

Problem | Solution
The installation is unsuccessful because the password does not meet the requirements. | If the minimum password length is changed from a default 8 to a value greater than 10 via the local Windows security guideline, then the installation of the SQL Server will be unsuccessful because the zenon SQL password consists of 10 characters.

SQL Server 2008

Problem

Solution

The zenDBSrv cannot establish a connection to the data base.

Possible reasons:

  • Instance of the SQL Server is not correct or does not run.
  • Entries in the zenDB.ini are not correct.
  • Wrong password.
  • zenDBCli.dll or zenDBSrv were not registered correctly.

Log entry:

Invalid Connection Configuration: No SQL Server Instance!

In the zenDB.ini no SQL Server instance is configured for the database connection. Without an instance the zenDBSrv cannot connect and therefore closes itself.

SQL Server 2005

Problem

Solution

SQL server cannot be installed.

At the installation of the SQL server the following components are also installed:

  • Microsoft SQL Server 2005
  • Microsoft SQL Server Native Client
  • Microsoft SQL Server VSS Writer
  • Microsoft SQL Server Setup Suport Files (English)
  • MSXML 6.0 Parser

If one of these components already exists on the system, the installation can fail.

Check whether the components to be installed already exist on the system and uninstall them.

The log file of the SQL server may help you when searching for the cause of errors: You can find it as summary.txt in folderC:\Program Files\Microsoft SQL Server\90\Setup Bootstrap\LOG.

Error message:
The sa password must meet SQL Server password policy requirements. For strong password guidelines, see Authentication Mode, in SQL Server Books Online.

Deactivate the HP ProtectTool Credential Manager.

Error message:
The installation of the Microsoft SQL-Servers 2005 Express Edition + .NET Framework 2.0 has failed. The setup is terminated.

Check the requirements for the SQL server:

  • Memory
  • Processor

Web client 6.22
IPA cannot find the XSL files.

Create the following entries in the registry.

HKLM\SOFTWARE\COPA-DATA\DataDir

  • UserData
  • System
  • ProgramData_6220
  • ProgramDir_6220

Note: Fix as of 6.22 SP1

SQL server cannot be installed.

If zenon was uninstalled, a new installation may fail if the uninstall folder is not deleted.

Solution: Deleting or renaming subfolders

  • Data
  • Template Data

in folder %program files%\Microsoft SQL Server\MSSQL.x\MSSQL.

SQL server 2005 on Toshiba computers

Problem

Solution

In the SQL log file (e.g. SQLSetup0006_AUTOTRONIC031_SQL.log) which was created during the installation, the following errors can be found:

  • Error Code: 1067
    MSI (s) (48!3C) [09:25:30:515]: Product: Microsoft SQL Server 2005 Express Edition --
  • Error 29503. The SQL Server service failed to start. For more information, see the SQL Server Books Online topics, "How to: View SQL Server 2005 Setup Log Files" and "Starting SQL Server Manually."
    The error is (1067) The process terminated unexpectedly.
  • Error 29503. The SQL Server service failed to start. For more information, see the SQL Server Books Online topics, "How to: View SQL Server 2005 Setup Log Files" and "Starting SQL Server Manually."
    The error is (1067) The process terminated unexpectedly.

Reason for this error is mostly a missing key in the Windows registry.
In this case:

  • Deinstall all SQL-relevant software such as
    Microsoft SQL Server 2005, Microsoft SQL Server Native Client, Microsoft SQL Server Setup Support Files, Microsoft SQL Server Server VSS Writer, ...
  • open regedit
  • go to key :
    HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Servi ces\Tcpip\Parameters
  • right click on Parameters
  • select new New -> Character string
  • type Domain as new value
  • press key Return and close regedit
  • Carry out the separate installation of SQL Server 2005 on zenon Installation Medium -> Additional_Software\SQL Server 2005 Express Edition
    Note: Only included on the installation medium up to version 6.51.
  • for this execute file Install.bat
  • after SQL Server 2005 was installed correctly, install zenon again


Technical support

Manual -> Installation and updates -> Technical support

Basic Support

If you need support for the installation, our employees in Technical Consulting would be happy to help you.

User with basic support can reach the hotline at the following e-mail address: support@copadata.com.

Advanced and Premium Support

If you have an Advanced or Premium service agreement, please use the telephone number or email address provided in that. Our sales employees (sales@copadata.com) will gladly assist you, if you want to upgrade your free basic service agreement to an Advanced or Premium service agreement.


Interlocking

Manual -> Interlocking

Interlockings control the access to certain zenon objects in Runtime using variables. Operation can be blocked or released depending on variables. Depending on process statuses, operations can be activated/deactivated.

It is possible to create and use various interlockings within one project. In each interlocking several parallel interlocking conditions are possible.

tutorial License information

Part of the standard license of the Editor and Runtime.

Interlocking of Objects

All dynamic elements except trend element and message element.

Context menu Project manager

Parameters | Description
New interlocking | Creates a new interlocking and opens the dialog for selecting variables.
Export XML all | Exports all entries of the interlocking as an XML file.
Import XML | Imports XML files.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.

info Information

Variables for the interlocking can be replaced. For more details see chapter Substitution of variables and functions in dynamic elements.

Example Example

A machine is in full automatic operation, so it should not be switched to manual operation. Only if a certain operation status (e.g. STOP) is reached, it is allows to be switched. With an interlocking the button for switching between manual and automatic operation can be locked in the visualization surface, until this status (e.g. STOP) is true. This can avoid incorrect operation.


Detail view of context menu and toolbar

Manual -> Interlocking -> Detail view of context menu and toolbar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tool Bar

Symbol | Description
New interlocking | Creates a new interlocking and opens the dialog for selecting variables.
New interlocking condition | Creates a new interlocking condition.
Add variable | Opens the dialog for selecting variables.
Copy | Copies the selected condition.
Paste | Pastes the condition from the clipboard.
Delete | Deletes selected condition.
Export selected XML | Exports selected entries as an XML file.
Import XML | Imports from an XML file.
Rename | Enables the element to be renamed. It is also possible by left-clicking the field with the mouse or by pressing F2.
Properties | Opens the property window for the selected element.
Help | Opens online help.

Context menu interlockings

Parameters | Description
New interlocking | Creates a new interlocking and opens the dialog for selecting variables.
Paste | Pastes the interlocking from the clipboard.
Export XML all | Exports all entries of the interlocking as an XML file.
Import XML | Imports XML files.
Help | Opens online help.

Context menu individual interlocking

Parameters | Action
Add variable | Opens the dialog for selecting a variable.
New interlocking condition | Creates a new interlocking condition.
Copy | Copies the selected interlocking.
Paste | Pastes the interlocking from the clipboard.
Delete | Deletes selected interlocking.
Export XML all | Exports all entries as an XML file.
Import XML | Imports from an XML file.
Rename | Enables the element to be renamed. It is also possible by left-clicking the field with the mouse or by pressing F2.
Properties | Opens the property window for the selected element.
Help | Opens online help.

Context menu group variables

Parameters | Action
Add variable | Opens the dialog for selecting variables.
Paste | Pastes the condition from the clipboard.
Help | Opens online help.

Context menu individual variable

Parameters | Action
Delete variable | Deletes the selected variable after requesting confirmation.
Copy | Copies selected variable
Paste | Pastes the variables from the clipboard.
Properties | Opens the property window for the selected element.
Help | Opens online help.

Context menu interlocking conditions

Parameters | Action
New interlocking condition | Creates a new interlocking condition.
Paste | Pastes the condition from the clipboard.
Help | Opens online help.


Engineering in the Editor

Manual -> Interlocking -> Engineering in the Editor


Creating Interlockings

Manual -> Interlocking -> Engineering in the Editor -> Creating Interlockings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Select Interlockings in the Project Manager to display the defined interlockings in the Detailview of the Project Manager. A right click on General Interlockings opens a popup menu, in which a new interlocking can be created.

The new Interlocking can be renamed in the properties window. A right click on Variables again opens a popup menu. Here, one or more variables can be linked to the according interlocking.

attention Attention

A variable must not be an interlocking variable and a response variable at the same time. This configuration would lead to an infinite loop.

The interlocking can be linked to a condition. To do this, one or more conditions have to be created in the properties window. For each condition, a binary formula can be entered in the properties window under Logical link.

info Information

An element in the visualization surface is locked, if the interlocking condition applies, i.e. is logical 1 – TRUE.

Interlocking: If several conditions are defined in one interlocking, it is sufficient for locking the element if only one condition is fulfilled.

The formula editor can be used to define binary and numeric formulas as a locking condition. It is opened by clicking on the Logical linking property in the properties window. The formula editor allows the definition of Binary statements with the help of the linked variables and logical or bitwise and comparison operators. See also chapter Screens /Comparison operators.

info Information

Unlocking: If several conditions are linked to the interlocking, all conditions that are met must be unlocked.


Formula editor

Manual -> Interlocking -> Engineering in the Editor -> Formula editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The formula editor provides support when creating formulas with logical or comparative operators with a combined element, for interlockings and commands. If additional variables are required for a formula, create these in the formula variables area of the status window by clicking on the Add button. existing formulas are displayed in the status list with the lettersF .

Note on the input of decimal points:

  • Decimal separator: Comma (,) is automatically converted into a dot (.):
  • Zero as a decimal point is removed automatically; 23,000 automatically becomes 23

Creating a formula

Click on the Formula button in the status window The formula editor opens

You select the bits for your formula in the left screen.

On the right, you find the operators for logical and comparative operations.

The formula created is displayed in the Formula area.

info Information

Up to 99 variables can be linked in one formula. X01 to X99. The length of the formula must not exceed 4096 characters.

The meaning of the bits:

Parameters

Description

value bits

32 value bits (from 0 -31) are available. They describe the variable value bit by bit. For binary variables, only bit 0 is of importance, for SINT and USINT only the bits from 0-7, etc.

Note: The value refers to the raw value (signal range) of the variables and not to the converted measuring range.

status bits

Here you find the most commonly used status bits. You find the exact definition and use of the status bits in the Status Bits List.

not acknowledged

Not acknowledged is treated like a usual status bit. But here it is listed separately, because it does not belong to the classical variable statuses.

value and status

All values (value bits and status bits) in the formula are considered as binary value and can be linked with logical operators such as AND or OR.
The total value and overall status are an exception to this. In order to get a Boolean result this total value has to be ORed with a constant bitwise. For this, we use the operator &.
For the result 0 (false) of this logical ORing we get the binary value 0 (false), otherwise 1 (true).

Example: see chapter Example bit by bit ORing

info Info

The status bits NORM and N_NORM are only available in the formula editor and cannot be engineered via the status.

If other settings outside the formula are set for the current status, they are combined with the formula with a logical AND.

Refer to the examples section for examples.

info Information

Formulas with binary X values and bitwise linking can be used with a maximum of 2 binary values. If more values are required, the linking must be carried out without binary X values.

Example:

X01.Value & X02.Value -> works

X01.Value & X02.Value & X03.Value -> does not work

But:

X01.00 AND X02.00 AND X03.00 AND X04.00 AND X05.00 -> works


List of status bits

Manual -> Interlocking -> Engineering in the Editor -> Formula editor -> List of status bits

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Short term | Long name | zenon Logic label
0 | M1 | User status 1 | _VSB_ST_M1
1 | M2 | User status 2 | _VSB_ST_M2
2 | M3 | User status 3 | _VSB_ST_M3
3 | M4 | User status 4 | _VSB_ST_M4
4 | M5 | User status 5 | _VSB_ST_M5
5 | M6 | User status 6 | _VSB_ST_M6
6 | M7 | User status 7 | _VSB_ST_M7
7 | M8 | User status 8 | _VSB_ST_M8
8 | NET_SEL | Select in the network | _VSB_SELEC
9 | REVISION | Revision | _VSB_REV
10 | PROGRESS | In operation | _VSB_DIREC
11 | TIMEOUT | Runtime exceedance | _VSB_RTE
12 | MAN_VAL | Manual value | _VSB_MVALUE
13 | M14 | User status 14 | _VSB_ST_14
14 | M15 | User status 15 | _VSB_ST_15
15 | M16 | User status 16 | _VSB_ST_16
16 | GI | General interrogation | _VSB_GR
17 | SPONT | Spontaneous | _VSB_SPONT
18 | INVALID | Invalid | _VSB_I_BIT
19 | T_CHG_A | Daylight saving time/winter time announcement | _VSB_SUWI
20 | OFF | Switched off | _VSB_N_UPD
21 | T_EXTERN | Real time external | _VSB_RT_E
22 | T_INTERN | Realtime internal | _VSB_RT_I
23 | N_SORTAB | Not sortable | _VSB_NSORT
24 | FM_TR | Error message transformer value | _VSB_DM_TR
25 | RM_TR | Working message transformer value | _VSB_RM_TR
26 | INFO | Information for the variable | _VSB_INFO
27 | ALT_VAL | Alternate value If no value was transferred, the defined alternate value is used otherwise the last valid value is used. | _VSB_AVALUE
28 | RES28 | Reserved for internal use (alarm flashing) | _VSB_RES28
29 | N_UPDATE | Not updated | _VSB_ACTUAL
30 | T_STD | Standard time | _VSB_WINTER
31 | RES31 | Reserved for internal use (alarm flashing) | _VSB_RES31
32 | COT0 | Cause of transmission bit 1 | _VSB_TCB0
33 | COT1 | Cause of transmission bit 2 | _VSB_TCB1
34 | COT2 | Cause of transmission bit 3 | _VSB_TCB2
35 | COT3 | Cause of transmission bit 4 | _VSB_TCB3
36 | COT4 | Cause of transmission bit 5 | _VSB_TCB4
37 | COT5 | Cause of transmission bit 6 | _VSB_TCB5
38 | N_CONF | Negative acceptance of Select by device (IEC 60870) | _VSB_PN_BIT
39 | TEST | Test bit (IEC870 [T]) | _VSB_T_BIT
40 | WR_ACK | Writing acknowledged | _VSB_WR_ACK
41 | WR_SUC | Writing successful | _VSB_WR_SUC
42 | NORM | Normal status | _VSB_NORM
43 | N_NORM | Deviation normal status | _VSB_ABNORM
44 | BL_870 | IEC 60870 Status: blocked | _VSB_BL_BIT
45 | SB_870 | IEC 60870 Status: substituted | _VSB_SP_BIT
46 | NT_870 | IEC 60870 Status: not topical | _VSB_NT_BIT
47 | OV_870 | IEC 60870 Status: overflow | _VSB_OV_BIT
48 | SE_870 | IEC 60870 Status: select | _VSB_SE_BIT
49 | T_INVAL | Time invalid | not defined
50 | CB_TRIP | Breaker tripping detected | not defined
51 | CB_TR_I | Breaker tripping detection inactive | not defined
52 | RES52 | reserved | not defined
53 | RES53 | reserved | not defined
54 | RES54 | reserved | not defined
55 | RES55 | reserved | not defined
56 | RES56 | reserved | not defined
57 | RES57 | reserved | not defined
58 | RES58 | reserved | not defined
59 | RES59 | reserved | not defined
60 | RES60 | reserved | not defined
61 | RES61 | reserved | not defined
62 | RES62 | reserved | not defined
63 | RES63 | reserved | not defined

info Information

In formulas all status bits are available. For other use the availability can be reduced.

You can read details on status processing in the Status processing chapter.


Logical operators

Manual -> Interlocking -> Engineering in the Editor -> Formula editor -> Logical operators

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Logical links: Variables will only be checked for the logical value '0'; if the value does not equal '0', it will be considered as '1'.

In contrast to bit formulas, the technical range can be modified by a stretch factor -> (not equal '0' or '1').

Operator | Meaning
AND | logical 'AND'
NOT | Negation
OR | logical 'OR'
XOR | logical 'EXCLUSIVE OR'

The operators have the following priority in the formula calculation:

Priority | Operator
1 | & (operator for bit formulas)
2 | NOT
3 | AND
4 | XOR/OR

info Info

Up to 99 variables can be linked in one formula. X01 to X99.

info Info

The status bits NORM and N_NORM are only available in the formula editor and cannot be engineered via the status.


Bit formulas

Manual -> Interlocking -> Engineering in the Editor -> Formula editor -> Bit formulas

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Bit formulas only have a logical high or low state. In contrast to logical formulas, the raw value is already predefined (0,1).

Operator | Description
& | AND
| | OR


Example: ORing bitwise

Manual -> Interlocking -> Engineering in the Editor -> Formula editor -> Bit formulas -> Example: ORing bitwise

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You want to find out if one of the user status bits 1-8 (M1 ... M8) of the variable X01 is set.

Usual formula:

X01.M1 OR X01.M2 OR X01.M3 OR X01.M4 OR X01.M5 OR X01.M6 OR X01.M7 OR X01.M8
This query can be made much easier by the logical ORing of the overall status.

Logical ORing:

X01.Status & 0xFF

The constant can be entered in hexadecimals, as described above:

0xFF corresponds to decimal 256; these are the first eight status bits (binary 11111111). If one of these bit is set to 1, the result of this bitwise ORing is 1 (true), otherwise it is 0 (false).

If, for example, all user status bits except the user status bit M7 should be queried, the binary statement for this would be: 10111111. Bit 7 is not of interest and is thus set to 0. This corresponds to 0xBF in hexadecimal. The expression for the formula is then: X01.Status & 0xBF.

Instead of ORing bitwise with a constant, the value can also be directly compared to a decimal number. If the comparison is wrong, the binary value is 0 (false) otherwise it is 1 (true).

Example:

You want to find out if the value is equal to the constant 202: The formula is:

X01.value = 202

If the value is equal to the constant 202, the result of the comparison is 1 (true) otherwise it is 0 (false).

Note: The bitwise ORing works with the OR character (|) in a similar manner to this example.


Comparison operators

Manual -> Interlocking -> Engineering in the Editor -> Formula editor -> Comparison operators

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Comparison operators serve for the direct comparison of two numeric values. The result of this comparison is a binary value. "0“ if the condition is not fulfilled and „1“ if the condition is fulfilled.

Operator | Description
< | less
> | greater
<= | Less then or equal
>= | greater or equal
= | Equal
<> | unequal

To the left and to the right of the comparison operator, there has to be a (total) value or a (total) status, single bits cannot be used with these comparison operators.

There can also be a constant to the right of the comparison operator. (the constants can only be integers; a comparison to a floating point number is not possible.)
These constants are entered as hexadecimal values or decimal values in the combined element. Hexadecimal figures are automatically converted to decimal values by clicking on OK (for example, 0x64 is in decimal figures 100).

Example Example

X01.value >= X02.value
The result is 1, if the value of X01 is higher than or equal to the value of X02

X01.value = 0x64
The result is 1, if the value of X01 is exactly equal to the numeric value 100 (= hex 0x64)

(X01.value = 0x64) OR (X01.value = 0x65)
The result is 1, if the value of X01 is exactly equal to the numeric value 100 or 101 (= hex 0x64 and hex 0x65)


Examples for formulas

Manual -> Interlocking -> Engineering in the Editor -> Formula editor -> Examples for formulas

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Simple logical AND linking between two bit values

Example Example

Formula: X01.03 AND X02.03

This formula has the status TRUE, if both bit 3 of variable 1 and bit 3 of variable 2 both have the value 1.

comparison of an analogue value or status of a variable

Example Example

(X01.Value> X02.Value)

Compare analog values with each other on a logical basis

Example Example

(X01.Value> X02.Value) AND (X01.Value = X02.Value)

Compare with value bits and status bits

Example Example

(X01.Value> X02.Value) AND (X01.Value = X02.Value) OR (X01.03 = X02.03)

Compare a value with a decimal or hexadecimal value

Example Example

Formula: (X01.Value = 111)

Formula: (X01.Value = 0x6F)

If a hexadecimal values is used, this is later transferred to decimal by clicking on OK. If a decimal value is entered and confirmed, the value continues to be displayed as a decimal value after reopening.

info Info

It is not possible to use a comma or a period when entering values.


Operating during Runtime

Manual -> Interlocking -> Operating during Runtime


Usage of Interlockings

Manual -> Interlocking -> Operating during Runtime -> Usage of Interlockings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Whether a Dynamic element which has been linked to an interlocking is locked or unlocked depends on the result of the logical condition. If the condition is fulfilled – the result is logical 1 -, the element is locked.

To lock a desired dynamic element, select it. In the property window Runtime/Authorization/Interlockings select one of the defined general Interlockings.

info Information

In order to display whether the element is locked in the Runtime, you can turn on the display of a lock symbol for interlocked elements in the project properties under User administration/Graphical identification active.

In addition you can fashion the look of an interlocked button via property Interlocked buttons (graphical design) or Locked buttons (User administration).


Keyboards

Manual -> Keyboards

Keyboards serve as virtual keyboards in zenon. Entries are possible in Runtime using a touchscreen with a virtual keyboard.

tutorial License information

Part of the standard license of the Editor and Runtime.

Note: Use of the virtual keyboard and the hardware keyboard in combined operation is not recommended.

Two different types of keyboards can be configured in zenon Editor:

  • Automatic keyboard.
  • Configurable keyboard.

Use of keyboards in zenon:

  • Keyboards are used in in zenon to write set values.
  • Individual keyboards can be used in Batch Control.
    • You can find further information in the Batch Control manual, in the Keyboards chapter.
  • You can do the following in recipe groups:
    • Link a keyboard screen for each recipe parameter
    • Define keyboards for each parameter data type

You can find further information in the RGM manual in the Keyboard chapter.

Special case: A string keyboard is called up for the action type user status in the Recipegroup Manager.
If, in the Recipegroup Manager, a bool or numeric recipe parameter has the action type changed to user status, the general string keyboard configured in the RGM is called up. If no keyboard screen is linked there, direct editing mode is activated in the recipe value table.


Automatic keyboard

Manual -> Keyboards -> Automatic keyboard

To use the automatic keyboard, proceed as follows:

  1. Open the zenon Editor
  2. Click on the project with which you would like to work.
  3. Click on Interaction in the properties.
  4. Activate the Automatic keyboard setting there under the Keyboard heading.

This setting is not activated by default. When activating, the automatic keyboard is created by the system and is automatically called up in Runtime relatively close to the element. It appears where a set value is to be entered. You can configure your own properties such as size or position by means of the properties in the Editor.

Note: There are no automatic keyboards available for the profile control elements. In this case, it is recommended that you create your own keyboard and call it up using a button. It is therefore also possible to enter a profile name using your own, manually-activated keyboard.


Size of the keyboard

Manual -> Keyboards -> Automatic keyboard -> Size of the keyboard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The size of the keyboard can be freely defined by the user.

To do this:

  1. Open the zenon Editor
  2. Click on the project with which you would like to work.
  3. Click on Interaction in the properties.
  4. Activate the Automatic keyboard setting under the Keyboard heading.
  5. Enter the desired size in percent in the Keyboard size [%] field.

info Information

The height of the title bar is obtained from the display settings. The following can be changed using the setting via Control Panel -> Appearance -> Display -> Advanced -> Element: Palette title.


Position of the keyboard

Manual -> Keyboards -> Automatic keyboard -> Position of the keyboard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can define a preferred position and also an alternative position in the properties of the keyboard. If there is not enough space for the keyboard at the preferred position, it will be displayed at the alternative position. If there is also not enough space there, the position will be defined by the system. You define the position with the help of four values.

Property | Description
Horizontal | Left (default) positions the left corner of the keyboard in relation to the top or bottom left corner of the element. Right positions the right corner of the keyboard in relation to the top or bottom right corner of the element.
Horizontal offset [pixel] | Horizontal space (in pixels) to the selected element for the preferred position of the automatic keyboard. Positive values move the keyboard to the right, negative values move it to the left. Default: 2.
Vertical | With top (default) or bottom you position the keyboard above or below the element.
Vertical offset [pixel] | Vertical space (in pixels) to the selected element for the preferred position of the automatic keyboard. Positive values move the keyboard upwards, negative values move it downwards. Default: 2.


Configurable keyboard

Manual -> Keyboards -> Configurable keyboard

The keyboard can be configured or defined by the user. To do this, proceed as follows:

  1. Open the zenon Editor
  2. Click on the project with which you would like to work.
  3. Create a new frame under Screen ->Templates.

    Note: Keyboards always need their own frame that should only be used for keyboards.

  4. Define the desired properties in relation the position and size of the keyboard.
  5. Under Screens, create a new keyboard screen.
  6. Select a template for the keyboard under Control elements.

In the properties, you can change the color, the form or the naming of the keyboard keys as you wish.

Note: Use of the Standard template is recommended.


Creating a screen of the type keyboard

Manual -> Keyboards -> Configurable keyboard -> Creating a screen of the type keyboard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You have several possibilities for creating a new keyboard screen:

Context menu in the project manager:

  1. Click on Screens in the Project Manager.
  2. A right click opens the context menu.
  3. Click on New screen in the context menu.

Toolbar

  1. Click on Screens in the Project Manager.
  2. In the detail view of the Project Manager, click on New screen in the tool bar.

You have several possibilities for determining the screen type of the new screen:

Detail view of the Project Manager:

  1. In the detail view of the Project Manager, click on the screen type of the newly created screen.
  2. Select the keyboard screen type in the drop-down list.

Properties:

  1. Click on General in the properties.
  2. Click on the arrow on the right under screen type and select the keyboard screen type in the drop-down list.
  3. In the properties of the General group, select a pre-defined keyboard as a name or give it a freely-definable name.

Attention: Keyboard screens with reserved names have priority at Runtime over other keyboard screens, including the screen Automatic keyboard for touch operation.

If a keyboard screen is called up over the whole screen, instead of just a dialog, it can be the case that menus are hidden.

Hint: In that case, engineer a Close frame function which allows you to close the open keyboard-frame.

In the screen properties, under General, there are several key words under Name. You can read what these are for in the following:

Reserved names

For screen type keyboard, the following names have been reserved:

Name

Description

DIALOGKBD

if a picture with this name exists, it will be opened in the Runtime every time a dialog is loaded, e.g. for entering a new recipe name in the RGM.

Attention: The DIALOGKBD is not designated to be used with control element Set value input element and not suitable for it. The use of this combination can cause errors in the Runtime.

SETBOOLKBD

if a picture with this name exists, it will be opened in the Runtime every time an input for binary variables is required.

SETSTRINGKBD

If a picture with this name exists, it will be used in Runtime instead of the standard dialog box for string variables.

SETVALUEKBD

If a picture with this name exists, it will be used in Runtime instead of the standard dialog box for numeric variables. The control element set value input must be inserted in the keyboard.

Attention: When Caps lock is activated, you cannot enter anything in a keyboard of type SETVALUEKBD as instead of numbers the respective special characters would be entered.
Exception: French keyboards need the Shift key or Caps lock for entering numbers.

Note: Use the control element Set value input only for keyboards which are created for the input of input set value (SETVALUEKBD, SETSTRINGKBD). It is automatically connected to the variable of the dynamic element that is to receive the set value. When using a normal Keyboard, unwanted results may occur.

It is imperative for Keyboards that are used for setpoint input to have the control element Setpoint input projected in the screen. If not, it is impossible to enter values or to send set values.

Note: Is in the project

  • a screen of type Keyboard with the reserved name DIALOGKBD available
  • and at the same time a screen of type Login
  • and the automatic keyboard property in the keyboard group is activated,

the screens must not be based on the same frame. In this case, the DIALOGKBD would be used automatically.

A keyboard button has more properties than a normal button in zenon Editor. This can be seen and defined under Display. Special characters can be defined this way.


Control elements

Manual -> Keyboards -> Configurable keyboard -> Control elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Control element | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.
Alphanumerical left | Definition of the keys for self-created keyboard; left side of a normal standard keyboard.
Alphanumerical right | Definition of the keys for self-created keyboard; right side of a normal standard keyboard.
Number lock | Definition of the keys for self-created keyboard; number keys of a normal standard keyboard.
Function keys | Definition of the keys for self-created keyboard; function keys and Escape key of a normal standard keyboard.

Recommendation: Use a template.

Control element | Description
Write set value | Control element for write set value.
Set value input | Allows the input a set value. Must be configured in the screen for SETBOOLKBD, SETSTRINGKBD and SETVALUEKBD.
Value ++ | Carries out addition calculations. Adds 1 to the value.
Decrement | Carries out subtraction calculations. Subtracts 1 from the value.
Value on | The value is 1, i.e. true. Example: Machine is on.
Value off | The value is 0, i.e. false. Example: Machine is off.
Toggle value | True/false switch.
OK | Sets the value and closes the window.
Cancel | Closes the window.


Keys for Recipegroup Manager

Manual -> Keyboards -> Configurable keyboard -> Keys for Recipegroup Manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For the RGM, there are the following special control elements available under Control elements -> Recipegroup Manager specific when configuring the keyboard screen:

Control element

Description

Send value

The set value is written to the variable, updated in the recipe and the keyboard is closed.

Save recipe

The recipe is saved

Send value and save recipe

The set value is written to the variable, updated in the recipe, the recipe is saved and the keyboard is closed.

Value displays as Text 1
to
Value displays as Text 32

Keys can be linked with limits from a reaction matrix. To do this, the variable of the recipe parameter

  • must be linked with Numeric reaction matrix or String reaction matrix and
  • "equals" states must be included

Assigned keys are shown in runtime and labeled with the text from the reaction matrix.

Clicking the button writes the linked value in the reaction matrix as a proposal for the recipe value in the Set value input control element.


Automatic key labeling

Manual -> Keyboards -> Configurable keyboard -> Automatic key labeling

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The labeling of the Keyboard can be either freely defined or defined by the operating system. To do this, activate or deactivate, in the screen properties under Representation, the Automatic labeling option. The language is automatically taken from the operating system and the keys are automatically labeled after that. This option is well suited to other countries that want to work with the keyboard. All keyboard layouts that are supported by Windows are available. The functionality of the virtual keyboard keys corresponds to the hardware keyboard. The configured labeling is ignored in the process.

For this, the following applies:

  1. Active:
    • For letters, numbers and F keys of the screen of the type Keyboard the original labeling of the keyboard layout of the operating system is used.
    • No alternative labeling can be defined.
    • If keys have been labeled differently, the original labeling will still be used in the Runtime. Function keys such as Tab or Shift can still be labeled differently.

The keypad of the keyboard is not automatically labeled and the label can be adapted in the Runtime at any time independent of the setting of property Automatic labeling.

  1. Inactive:
    • All keys can be labeled individually and are displayed in the Runtime correspondingly.
    • The labeling of the keys can be amended in the Editor in the properties, under Representation.
    • In the Runtime the alternative label is displayed.


Keyboards in the Web Client

Manual -> Keyboards -> Configurable keyboard -> Keyboards in the Web Client

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If a keyboard is loaded in the Runtime, it stays open even if the Runtime is minimized. In the OS task bar, a drop down list for the keyboard is shown.

attention Attention

Individually adapted screens of type Keyboard may under certain circumstances not work properly with the Mozilla Firefox browser.

Reason: Mozilla Firefox loads new windows in the background without putting the focus on them. Depending on the project configuration, individually-adapted keyboard screens are closed as soon as they are no longer in focus.

Solution: Use a different browser such as Microsoft Internet Explorer or Google Chrome, or use the "Close on loss of focus" frame option".

Automatic keyboards are not affected!


Hardware keyboards and virtual keyboards used together

Manual -> Keyboards -> Hardware keyboards and virtual keyboards used together

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Virtual keyboards act like hardware keyboards in the operating system. If virtual keyboards are used together with hardware keyboards, they affect each other. Settings on the hardware keyboards - e.g. determine whether Shift is used - affect the virtual keyboard and vice versa.

Examples:

  • If CAPS lock is pressed on the hardware keyboard, it is also true for the virtual keyboard. In this case you cannot enter numbers via the automatic keyboard.
  • If you press key Num on the hardware keyboard in order to switch of the number pad, the number pad on the virtual keyboard is also turned off.

Note: Use of the virtual keyboard and the hardware keyboard in combined operation is not recommended.


Language switch

Manual -> Language switch

This functionality is essential for the realization of international projects. For example when:

  • Delivering a project in different languages
  • central services, which can be accessed from different countries
  • Decentral equipment, which can be accessed worldwide
  • language switchable operation of equipment

The language change function allows the language of text information to be switched between different languages in the Runtime. For project configuration, a language table has been created in the detail view of the Language file node.

tutorial License information

Part of the standard license of the Editor and Runtime.

Context menu Project manager

Menu item | Action
New language file... | Opens the dialog for creating a new language file.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.


Language switchable texts

Manual -> Language switch -> Language switchable texts

Language switching can be used for:

  • texts displayed in the Runtime:
    E.g. limit texts, variable identification.
  • Fonts:
    e. g. Arial Unicode.
  • Texts in AML, CEL and IPA:
    Status texts and system messages in the Alarm Message List, Chronological Event List and in the Industrial Performance Analyzer
  • Alarm/event groups, alarm/event classes:
    Group and class names.
  • Runtime dialogs:
    e.g. Standard login window, alarm filter dialog.
  • Runtime help:
    The entire Runtime help is language switchable (Preparatory work for language switchable help).
  • List path:
    Switching of texts for a screen of the screen type List or HTML pages for screen type HTML.
  • Media path:
    Switching of folders for graphics files, help, multimedia, texts ,formats and Report Viewer.
  • S7 graph function chart:
    Switching of dynamic and static elements.

The language change function supports:

Parameters | Description
Graphical elements | Text
 | Link Text
 | Text button
 | Multi-binary element
 | Combined element
 | Universal slider
 | ComboListBox
Variables | Identification (Name is not changeable)
 | Unit
 | Limit text The dynamic limit text makes it possible to insert the current value of a variable into the limit text of another variable. At this fixed text can be linked via an index with keywords from a language file. For details see: Dynamic limit text and Using keywords in text lists in manual Variables.
Screens | Screen name
Standard recipes | Recipe name
Menus | Menus
Report Generator | Standard Texts
IPA | Texts
Alarm administration/ Chronologic Event List | List headlines (column labels), alarm/event groups and alarm/event classes name
Archive Revision | Table headline (Name of the column)
Runtime | Dialogs in the Runtime
Reaction matrices | Limit value text
Tooltips | Everywhere where signature texts for dynamic elements were defined.
Signatur texts | Everywhere where tooltips can be used

The following are not language switchable:

Type | Description
Variables | Variable name (the Variable identification is language switchable), String alternate value
Functions | Function name
Fonts | Name
Frames | Name
Drivers | Name (can be set during driver selection)
Data types | Name
Reaction matrices | Name
Allocations | Name
Script | Name
Archive | Description
Time control | Name
Process Control Engine (PCE) | Taskname
Interlockings | Name
Menus | Name


Languag switch detail view toolbar and context menu

Manual -> Language switch -> Languag switch detail view toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Menu item

Action

New language file

Inserts a new empty language file in the table.

Create standard function

Creates a function Language switch and opens the dialog for configuration.

Save

Saves language file.

Copy file

Copies selected file to the clipboard.

Copy key

Copies selected key to the clipboard.

Paste

Pasts content of the clipboard (file or key) to the language tale. The pasted file is visible after you refreshed the Editor view.

Delete file

Deletes selected language files from the language table.

Delete key

Deletes selected key from the language table.

Jump back to starting element

If you entered the list via function linked elements, the symbol leads back to the start element.
Only available in the context menu when all linked elements are opened.

Export file

Exports selected language file in format TXT.

Import file

Imports file in TXT format.

Extended import/export

Opens the menu for importing and exporting of -Step 7 projects, dBase and CSV.

Note: For additional information please read the chapter Step 7-project import in the book import - export.

Find

Opens dialog for searching after entries in the active language file.

Replace

Opens dialog in order to find and replace entries in the active language file.

Font for selected language file

Opens drop-down list to select the font:

  • Selection: The dialog for selecting a font is opened
  • Default font: Default font is used

Language file for editor

Opens drop-down list to select language file for the Editor.

Remove all filters

Removes all filter texts from the columns.

Character table

Opens the Windows character table.

Update local version

Only available at distributed engineering.

Synchronizes the local copy of the language file with the server database and updates it.

Enable changes

Only available at distributed engineering.

Locks language files against change by the user.

Accept changes

Only available at distributed engineering.

Transfers local changes to the server database and unlocks the language file for other users.

Undo changes

Only available at distributed engineering.

Discards all local changes and unlocks the language file for other users.

Help

Opens online help.

info Information

The processes export file, copy, search and replace are all referring to the active language file. Active means:

At clicking the language table the file in whose column you click is set to active. The file name of the active file is displayed in the property window and the column of the file receives a binoculars symbol in the column header.


Keywords

Manual -> Language switch -> Keywords

Define key words

Keywords are marked by character @.

For this, the following applies:

@Text

The whole text will be translated.

Text

This text will not be translated.

@Text

The text between the two “@” will be translated.

The following applies here: After an odd number of “@” the text will be translated (start counting at the beginning of the entry).

For example:@user@Doe

  • User is translated
  • Doe is not translated

The text between the first and the second @ is translated, the text between the second and the third @ is not translated!

Linking

It is possible to link text elements which are to be translated with those which are not to be translated.

@The user@ Doe @is logged out.

@Text1@ Text2 @Text3

  • Text 1: will be translated
  • Text 2: will not be translated
  • Text 3: will be translated

Displaying key words in the Runtime

If a keyword is linked to a translation, the translated text is displayed in the Runtime.

If a keyword is not linked to a translation, no text is displayed in the Runtime.

Texts which are not yet translated can be displayed as keyword. To do this:

  1. navigate to Graphical design -> in the project settings Runtime general
  2. Activate the propertyDisplay not translated keywords
  3. not translated texts are than displayed as @key word in the Runtime


Language table

Manual -> Language switch -> Language table

To engineer a language switch you must create a language table in the project manager. This language table is based on a text file.

For this, the following applies:

  • The table always contains column key word.
  • The column ZENONSTR.TXT is created automatically. This file cannot be deleted but expanded. When the Runtime starts this file is loaded automatically.
  • Each language receives an own column in the language table.
  • For each column an own language file is created. In the column the key word is saved together with its translation. Key word and translation are separated by the pipe character |.
  • If a key word is entered in the language table, automatically all columns of this line are filled with the key word. This key word is then replaced by the translation of the respective language.
  • If no translation is available, the key word is displayed in the Runtime.


Create new language file

Manual -> Language switch -> Language table -> Create new language file

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a new language file:

  1. open the context menu of the entry Language file in the project manager
  2. select entry New.
  3. the dialog for opening a new language file is opened

  4. give a freely definable name

    Note: Special characters are not allowed; the file extension *.txt is set automatically

  5. confirm by clicking on the OK button
  6. the new file is added to the language table on the far right side

At creating a new language file, language-dependent subfolders with the name of the new file are created in folder for external binary files:

  • Graphics
  • Help
  • Multimedia
  • Texts and formats
  • Report Viewer


Display and handling

Manual -> Language switch -> Language table -> Display and handling

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Multi-line display

Key texts and translation can be displayed in multi-line.

To define the line height individually:

  1. move the mouse to the header on the left-hand side of column key word
  2. go to the separator line of the lines until the mouse cursor changes to a cross
  3. with the left mouse button pressed, drag the line to the desired height

To customize the line height individually

  1. move the mouse to the header on the left-hand side of column key word
  2. go to the separator line of the lines until the mouse cursor changes to a cross
  3. double-click on the separator line
  4. the line height is automatically adapted to the content; the line break for texts is carried out according to the column width

Note: The defined line heights are not saved when you leave the list.

Find and replace

It is possible to search texts and text fragments in a language table. At this regular expressions can be used. At the same time the references can also be replaced. Find and replace is always valid for the column in which the cursor is located.

To find and replace:

  1. activate the desired column
  2. carry out a right click
  3. in the context menu select either Search or Replace.

Incremental search

  1. By pressing any alphanumeric key in the list an incremental search is started:
  2. The next line of the active column whose text matches the search criterion is selected.
  3. The search always refers to the first character of the line. For example:

    r finds the line starting with red but not the one starting with green

Sort

To sort the table:

  1. click on the column header of the column which should be sorted
  2. the column is sorted whereas the sorting order (ascending/descending) is displayed by an arrow above the column label
  3. another click in the column header changes the sorting order

Filter

The language table can be filtered. For this the filter text is entered in the header of the column which should be filtered. All lines which do not match the filter criterion are removed from the list. In the filter text you can use wildcards "*" (several characters) and "?" (single character). You can combine several filters.

To reset the filter, delete the filter text from the header or use command Remove all filters from the context menu.

Copy and Paste

Via the context menu you can copy the active file to the clipboard with the help of command Copy file. To paste a file from the clipboard, select command Paste from the context menu.

At pasting it is differentiated between your own project and a foreign project:

  • At pasting to the same project a new file with name "Copy n of xxx.txt" is pasted:
    • n = Number of the copy
    • xxx = name of the copied file
  • At pasting in another project, it is checked whether a language file with the same name already exists.
    • If a language file with the same name already exists, there is a query whether the file should be overwritten.
    • If the language file does not exist, it is insert with the name of the copied file in the project.

Note: Key texts can also be copied and pasted with shortcuts Ctrl+C and Ctrl+V. This is not possible for language files.

Rename

The file name of the active file is displayed in the property window as property File name. Here you can change the name of the language file (column). At renaming a language file the corresponding language-depending sub-folders in the binary files folders are also renamed (see chapter Create new language file).

Use language table in the Editor

Keywords can be translatedand used during engineering in the Editor. Thus you can - without having to start the Runtime - check for example whether the text filed length are large enough for all languages.

To use a language file in the Editor:

  1. in the context menu, select the Language file for Editor entry.
  2. select the desired file in the sub-menu
  3. the language file which is active in the Editor is highlighted in the column header with green font

Fonts

Fonts can also be changed via the context menu of the language table.

You can create global fonts in the global project. The entries existing there are available for all projects in the workspace.

info Information

If the font is not displayed correctly in the list view, you must activate font Arial Unicode in the Control Panel.


Search

Manual -> Language switch -> Language table -> Display and handling -> Search

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To search in the language table execute a right-click on the desired column and select command Search from the context menu.

Parameters

Description

Search for

Input of the search term.

Only whole words
  • Active: Only the search term defined in the input filed is found.
  • Inactive: Terms which contain the search term are also found.
    Example: "Text" also finds "Texture"

The case
  • Active: The search is case-sensitive.
    Example: "Text" only finds "Text" but not "text.
  • Inactive: Case sensitivity has no influence on the search results.

Search direction

Defines search direction.

Up

Active: It is searched from the highlighted cell up.

Down

Active: It is searched from the highlighted cell down.

Continue search

Finds and highlights next reference.

Cancel

Closes search


Replace

Manual -> Language switch -> Language table -> Display and handling -> Replace

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To search and replace in the language table execute a right-click on the desired column and select command Replace from the context menu.

Parameters

Description

Search for

Input of the search term.

replace with

Input of the term which should replace the search term.

Only whole words
  • Active: Only the search term defined in the input filed is found.
  • Inactive: Terms which contain the search term are also found.
    Example: "Text" also finds "Texture"

The case
  • Active: The search is case-sensitive.
    Example: "Text" only finds "Text" but not "text.
  • Inactive: Case sensitivity has no influence on the search results.

Find next

Finds and highlights next reference.

Replace

The found term is replaced.

Replacing all

All found search terms in the active column are replaced automatically.

Cancel

Closes search


Key words in the language table

Manual -> Language switch -> Language table -> Key words in the language table

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Key words for language switchable text are marked by a @ in zenon. In the language table key words are entered without character @. Existing control characters @ are removed automatically.

For the entries in the language table the following is true:

  • for each @ packages are created
  • these must be inserted individually in the language table.

    Example: The language switchable text "@The user@ Doe @is logged out." has two entries in the language table:

    • Line 1: The user
    • Line 2: is logged out
  • after an import each language file initially receives the key words which it had prior to the import
  • as soon as something is changed in the language table (e.g. entry of a new key word) all key words of all languages are synchronized
    • each language file then contains all key words
  • all keywords entered in the table newly are always written in all available languages

attention Attention

The import can lead to new key words for which no translation exists in the already existing language file. In this case the key words are displayed in the Runtime.

Add new keys

New keys are entered in the last (empty) line. At entering a new key text all translations of the line are filled with the new key text.

If you press Ins,

  1. the last line is selected independent of the position of the cursor
  2. the cell is opened in order to edit the key word

Edit key and translations

The editing of cells in the list is done by clicking on a cell in the selected line. If you press F2, the cell on which the focus currently lies is edited.

Delete key and translations

You can either delete single translations or whole keys including all translations.

To delete a key word with all translations:

  1. select the line
  2. press Del or select Delete key from the context menu
  3. the key word is deleted together with all translations without a confirmation request.
  4. you can select and delete several lines at once (Ctrl+ mouse click; Shift+mouse click)

To delete translations:

  1. select the line
  2. column key word must not be active
  3. press and hold the shift key and press Del
  4. the translation of the active column is deleted

Copy and Paste

To copy key words:

  1. highlight the desired line (multi-select is possible)
  2. press Ctrl+C or select Copy key from the context menu
  3. the key words are copied to the clipboard

To past key words:

  1. click in the language table
  2. press Ctrl+VC or select Paste from the context menu
  3. the key words and translations are pasted from the clipboard to the list
  4. if a copied key already exists in the list, a new key Copy n of xxx is created
    • n = Number of the copy
    • xxx = name of the copied key


Edit language files externally

Manual -> Language switch -> Edit language files externally

Language files can also be edited externally. For this they must be exported. The export can be:

  • TXT file: Edit with text editor
  • CSV file: Edit with Microsoft Excel

To edit a language file:

  1. export the desired file
  2. carry out the changes depending of the export type with
    • text editor or
    • Microsoft Excel
  3. import the file again in the Editor

attention Attention

Note for external change:

  • At the import the new file is not simply overwritten but merged with the file available in the current project. For details see: Export and import language files
  • Changes always only affect the key word and the selected language. All other languages remain unchanged or empty.


Export and import language files

Manual -> Language switch -> Edit language files externally -> Export and import language files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Export

To export a language file:

  1. click in the desired column (for TXT export)
  2. open the context menu with a right-click
  3. select the desired export type:
    • Export file: exports the language table in the TXT format
      Is especially suitable for forwarding to other users and the import in other projects. Always only concerns the selected language file.
    • Extended import/export -> Export CSV all: exports all existing tables in the CSV format
      Is especially suitable for external editing. Always concerns all language files of a language table.
  4. the dialog for selecting saving location and file name is opened
  5. save the export file
  6. a message informs you about the export and offers to open the export folder
    • Click on button Yes to open the export folder and to close the dialog
    • Click on button No to close the dialog

Import

To import a language file:

  1. click in the language table
  2. open the context menu with a right-click
  3. select the desired import type:
    • Import file: imports a file in TXT format
    • Extended import/export -> Import CSV: imports a file in CSV format
  4. the dialog for selecting a file is opened
  5. Click OK to import the file

attention Attention

The import can lead to new key words for which no translation exists in the already existing language file. In this case the key words are displayed in the Runtime.

Import of TXT

Text files must match the format of the language table for the import: Key text + | + Translation

At the import the new file is not simply overwritten but merged with the file available in the current project:

  • Entries which exist in the import file and in the project are overwritten with the import entries.
  • Entries which only exist in the project are not changed.
  • Entries which only exist in the file which is imported are added.
  • If a language file of the import file does not yet exist in the project, a new file with a new name is created.

Import of CSV

CSV files must match the format of the language table for the import:

  • Valid column separators must be used:
    • Pipe (|)
    • Semi-colon (;)
    • TAB (->)

    If other characters are used as column separators, an error message is displayed.

  • The first line must contain a list of the files whereas a placeholder for column key words must be located at the first position.
  • The file must have the extension .csv. If this is not the case, an error message is displayed.
  • In the additional lines you can find the respective key text and the translations texts separated by the column separator. The key text must always be in the first column.
  • If a language file which is stated in a column heading does not yet exist, a new file with the indicated name is created.
  • Existing files are merged from a text file in the same way as at the import.

Example Example

Structure CSV file :

Key word|ZENONSTR.TXT|FRENCH.TXT|ENGLISH.TXT|GERMAN.TXT

A1004|A1004|F1004|E1004|D1004

A14|A14|F14|E14|D14

A25|A25|F25|E25|D25


Editing in text file

Manual -> Language switch -> Edit language files externally -> Editing in text file

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Edit in a text file

The following applies for language files:

  • The content is entered as text in chronologic order.
  • The separator between a key word and a translated term is the pipe symbol |.
  • Only the term after the pipe symbol is translated.

Example Example

|

eins|one

zwei|two

drei|three


Editing in MS Excel

Manual -> Language switch -> Edit language files externally -> Editing in MS Excel

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Editing with MS Excel is also possible. In order to edit a language file in MS Excel:

  1. export the language table to a CSV file with file extension .csv
  2. open the file with MS Excel (double click the file)
  3. the export file is automatically imported to Excel
  4. the data are displayed as follows:
    • Column A: Keyword
    • additional columns: Translation; a translation per column
    • a separator is not displayed
  5. edit the texts as you like
  6. save the file as CSV file.

To use the changed language file in zenon, import the CSV file to zenon.


Fonts

Manual -> Language switch -> Fonts

During the language switch it can be necessary to use different fonts; e.g. a Unicode font for East Asian characters.

Definition via font lists

Define fonts and font lists in node Screens/Fonts. The font lists created here can be selected via function Language switch.

Note: You can find details about fonts and lists in chapters Fonts in manual Screens.

Language file assign font type directly

Font types can be assigned to language files directly. However this only defines the optical display in the language file. The display of the translated texts in the Editor and in the Runtime is not affected. The display is defined via Font lists.

To assign a font type to a language file:

  1. select a column of the language file
  2. select Font for selected language file/Selection from the context menu
  3. the Windows standard dialog for selecting fonts is opened
  4. select the font you wish to assign

    Note: additional settings of the standard dialog such as font color do not affect the display in zenon

info Information

Font type and language file can be already used and displayed in the Editor. Select the following from the context menu:

  • of the language file: Language file for Editor -> select desired file
  • of the font list: Font list for selected language file -> select desired list

attention Attention

At vector element Static text fonts can also be embedded. They can then not be changed via the language file.


Pre-defined keywords - system text in CEL

Manual -> Language switch -> Pre-defined keywords - system text in CEL

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There are pre-defined keywords for all texts, that are used in the Runtime as defaults.

You will find pre-defined keywords in the file CEL_Keys.txt in folder [zenon Installation]\Wizards_NotSupported\Additional

Recommendation: For the engineering use the language table wizard.

Attention: Probable changes are overwritten during a zenon update. So we recommend saving the changed file and copying it to the new version after the update.

The Runtime language has to be set to English, so that the language switching works for the dialogs or with the pre-defined keywords for the CEL, because the keywords are defined in English.

Texts which are used in the column headlines of the Chronological Event List and the Alarm management can be configured in the project settings. The dialog is called up via: Chronological Event List -> Column settings CEL or Alarm Message List -> Column settings AML or in the corresponding function Screen switch.

The procedure is the same as with texts. A @ at the beginning of the description makes language switching possible.


Paths for language switch of the Runtime help

Manual -> Language switch -> Paths for language switch of the Runtime help

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For the files necessary for the language switch, the necessary entries are automatically created in subfolder to the files when creating a language file:

  • Graphics
  • Help
  • Multimedia
  • Texts and formats
  • Report Viewer

At the configuration of function Language switch the respective folder can be selected:

attention Attention

The files must have the same name in the different languages, but they are stored in different folders.

The default path is already given in the Editor. If the function Language change is executed, the path is changed. It is also possible to create individual folders in the project tree in node File.

info Information

It is possible to create several levels of subfolders in node File. In function language switch you can only select folders which are located in the first level.

If the language switch is not activated, the default paths are the standard folders.

attention Attention

In general, language switching in Runtime is not possible with the HMTL help on Microsoft operating systems. Help in which the language can be switched must be configured via a HTML screen.

Exception: Help under Windows CE.


Evacuating translations

Manual -> Language switch -> Evacuating translations

To evacuate texts for translation:

export the language table to CSV

have the texts translated

import the changed CSV file

take care that at distributed engineering you must activate Enable changes for the language file in order to be able to edit it.

attention Attention

In multi-user projects key texts and their translation can only be changed if changes are enabled for the files. Translation text of files for which changes are not possible cannot be selected or edited.

Key texts can only be changed if changes are enabled for all files. At entering new keys, the keys are only entered in files for which changes are enabled.


Function Language switch

Manual -> Language switch -> Function Language switch

With this function, text information, for example text information for buttons, can be switched to a different language in the Runtime. When creating a new language file, a language-specific subfolder is created in the respective files for graphics, help, multimedia, texts and format, and Report Viewer. This is given the same name as the new language file. The respective files are stored in this folder. The active subfolder can be switched with the Language switch function. If there is no file with the given name present in the folder, an attempt is made to load the file from the superordinate non-language-specific folder.

To configure the function:

  1. Select New function...
  2. navigate to node Application
  3. select Language switch
  4. Configure language switching in the dialog that opens

Parameters | Description
Language file | Opens the file manager for selecting a language file.
Font list | Drop-down list with a list of the fonts defined in the editor.
Folder switching | Contains paths for required files.
Graphics | Drop-down list with language-specific subfolders for graphics.
Help | Drop-down list with language-specific subfolders for CHM Runtime help files.
Multimedia | Drop-down list with language-specific subfolders for multimedia files.
Texts and formats | Drop-down list with language-dependant subfolders for texts and formats
Report definition files | Drop-down list with language-specific subfolders for Report Viewer
OK | Accepts configuration, creates function and closes dialog.
Cancel | Discards settings, closes dialog and creates functions with target.
Help | Opens online help.


Load Management

Manual -> Load Management

The Load Management is a tool for the support of the economical management. It is for implementation of energy supply management for small and medium-sized power supply companies and also for industrial firms whose energy supply is arranged by special contracts.

The module includes two high-quality functions to support the user:

  • Forecast (short-term forecast): To avoid load peaks and to automate load shedding.
  • Optimization: Optimization of the determined energy consumption of a billing period.

The focus is on energy-related electrical equipment, but the module can also be used without problems for mixed equipment from electricity and gas grids. Special forecasting and optimization models have been implemented for gas grids.

tutorial License information

Must be licensed in Editor and Runtime.

Context menu Project manager

Menu item | Action
Export XML all... | Exports all entries as an XML file.
Import XML... | Imports entries from an XML file.
Help | Opens online help.


Introduction

Manual -> Load Management -> Introduction

The task of a Load Management is to optimize the operation of customers with special contracts, such as energy supply companies or industrial companies. Energy trend calculations are used as a significant aid; these serve as the basis for automated optimization of energy consumption.

The situation in electricity and gas grids is sometimes significantly different and thus requires, in a Load Management, different consideration in terms of forecasting and optimization.


Initial situation in the electricity industry

Manual -> Load Management -> Introduction -> Initial situation in the electricity industry

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As a ruler in the energy industry a rate is used which includes both the investments of the provider and the arising costs for power generation and grid maintenance.

In order to set the price, these companies normally take into consideration a number of the peak power consumptions which arose over the year. The determination of the average power consumption takes place in a fixed measuring time, normally 15 to 30 minutes. In addition the price also includes the received power. Contracts concluded on this basis are valid on the long term.


Initial situation in the natural gas industry

Manual -> Load Management -> Introduction -> Initial situation in the natural gas industry

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When working with natural gas, peaks in demand can be compensated by taking natural gas from gas storages, storing it in the natural gas grid (pressure adaptation) and device which can be switch or turned off.

In gas storages or in the grid certain amount of natural gas can be stored preventively in order to use them on demand. In addition non-contractual supplied natural gas contingents are used which are referred to as spotgas.


Aims of an economic management

Manual -> Load Management -> Introduction -> Aims of an economic management

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The aim of the economic management when using electricity and natural gas as power source is to receive as much energy as possible from your provided for an as low as possible price (optimization).

Potential savings come along when expensive peak power consumptions are avoided. The peak power consumptions during a measuring period can be avoided by pointedly controlled interventions.

  • Load shedding at switchable devices
  • Input of own generators

In order to do this, it is necessary to anticipate the average power consumption of a measuring period (prediction). Thus a threatening violation of the set limit can be recognized timely and an appropriate intervention can be carried out.


Functionality of the whole system

Manual -> Load Management -> Functionality of the whole system

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The electrical energy area and the natural gas area act in quite similar ways. As it is not possible to store electrical energy in noteworthy amounts, the contract conditions of the electrical energy providers are adjusted to this fact.

In the natural gas area not only the contract conditions must be adhered to but there are also arrangements necessary in order to store the natural gas.


Function of the system when electricity is used as the power source

Manual -> Load Management -> Functionality of the whole system -> Function of the system when electricity is used as the power source

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The measuring period for the supply with electrical power is normally 15 or 30 minutes. During this time the averaged power received at the hand-over point - from here on it is referred to as power or load - or the equivalent amount of energy is determined and recorded.

The price is usually fitted to the three highest values which accrued for the measuring periods in different months. The price is then valid on the long term.

The average power which is used to calculate the price can be reduced when corresponding peak power consumptions are limited due to pointedly controlled interventions. This short term optimization can be achieved by the following interventions:

  • Load shedding at switchable devices
  • Increasing input of own generators

The aim of this optimization is to not exceed the contractual set limit for the power in a measuring period under no circumstances. Additionally, the energy consumption should stay very close below the set limit in order to receive as much energy as possible.

The consumption optimization is performed by way of a short-term trend calculation. The measured values which were gathered during the handling interval (typically 30, 60 or 180 seconds) are used to perform a trend analysis. The calculated trend is projected to the end of the period.


Function of the system when natural gas is used as the power source

Manual -> Load Management -> Functionality of the whole system -> Function of the system when natural gas is used as the power source

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The measuring period normally is an hour or a day when natural gas is supplied. During this time the determined amount of natural gas at the hand-over point is rated.

If the limit is exceeded, here a high price must also be paid. The definition of the price when the limit is exceeded is much more specific than in the electricity area.

Basically in the gas grid it is also targeted to not exceed the agreed limit.

Possible interventions are the following:

  • Load shedding at switchable devices
  • Own production of natural gas in liquified gas facilities
  • Switching boilers to other fuels
  • Switching combined heat and power units to other fuels
  • Using natural gas from gas storages

Using natural gas which is stored in gas storages is important because it may only be small amounts which are available but these are needed during peak demands. Independent of the amount of the stored natural gas, a strategy must be defined how these storages are filled again over short or long periods of time.

Possible actions

The exceeding of the limit with hour contracts is inhibited by a consumptions projection with turning off or switching devices.

Basically the expansion of the measuring period to a (gas) day is possible. However there are times during the day in which the behavior of the trend leads to unrealistic large amounts at the end of the day. In addition the balance between night and day is not taken into consideration. Therefor in this case the system is built in a way that:

  • a prediction of the consumption takes palce
  • a plan is created which guarantees that the limit is not exceeded
  • a short term projection observes that the planned maximum amount is not exceeded


Principal thoughts

Manual -> Load Management -> Functionality of the whole system -> Principal thoughts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following chapter deals with thoughts and examples which make it easier for the user to indentify and select changeable elements of your plant. The question is what elements and devices can be influenced by the Load Management directly or indirectly in a sensible way.


Options in order to influence the output in the electrical power area

Manual -> Load Management -> Functionality of the whole system -> Principal thoughts -> Options in order to influence the output in the electrical power area

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Option

Description

Directly switchable devices

Devices which can be switched off briefly without interrupting any production processes are part of this group (industrial furnaces, pumps for water storages etc.).

The loads have a fixed value. In general the are depended on the device and therefore known of measureable.

Direct heatings

Because of their storage effect, these device can be switched off briefly without decreasing the quality of supply significantly (heating in warm water storages, electrically operated floor heatings etc.).

The loads consist of a consistent part and a part which is temperature-dependent. Additional the load is dependent on how long the device was switched off.

Monovalent heat pumps

In general these pumps are operated in the same way as direct heatings.

The temperature-dependent part is more distinctive and rise with falling outside temperatures (pumps used for generating heat including air conditioners) or rises with rising outside temperatures (air conditioners). The load is dependent on how long the device was switched off.

Bivalent heat pumps

These can choose between fuels they use. Beneath a certain temperature they are switched to a different fuel by their control unit of by the optimization.

At that no supply constraints emerge for the devices. These components are only switched in the long term and restrictively because the switching should not take place constantly.

When the temperature falls, the load increases up to the switching point. There it vanishes completely.

Night storage heatings

These devices are supplied with energy according to schedule or if there is any needed output during low rate periods. They are switched off during the remaining time.

The load depends essentially on the outside temperature. It is noticeable how many heatings are switched on (this is limited by the installed power) and how long they are charged.

Peak load aggregates and emergency power aggregates

These aggregates are switched on/off as required. In some cases these aggregates are controllable. The number of uses should be limited because the start of these aggregates coupled with additional costs on wear. In addition these aggregates should run for a minimum time in order to avoid thermal damages.

Combined heat and power units (CHPs)

These aggregates were primarily built to generate heat and are controlled by the heat demand during their operation (heat priority).

Some aggregates can be directly used to generate electric power (electric power demand). In general this operational mode is inefficient if the generated heat is not used at the same time. Therefore the use is only beneficial if the heat demand is corresponding or there is a possibility to store the heat.

The load reduction with regard to the take over point depends on the nominal size and for controlled or heat demand controlled aggregates from their working point.

It is quiet common to combine aggregates to groups. According to the heat demand, a certain quantity from the group is used. The maximum power lowering in the electrical power area is given by the number an nominal power of the used aggregates.

Lowering the voltage

In the electrical power area it is possible to lower the voltage in some grids. In order to achieve this, the transformers to the medium voltage level are switched to a lower level.

The voltage-dependence of the devices (ohmic load) causes another load demand provided that the voltage or output is not adjusted by subordinated controls.

The load reduction is dependent on the grid load, on the possible lowering of the voltage (minimum voltages must be adhered to) and on the composition of the devices.


Options in order to influence the output in the gas area

Manual -> Load Management -> Functionality of the whole system -> Principal thoughts -> Options in order to influence the output in the gas area

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Option | Description
Directly switchable devices | Devices which can be switched off briefly without interrupting any production processes are part of this group.
Furnaces or combined heat and power unit | These can be switched to another fuel (e.g. from natural gas to oil) according to their design.
Natural gas storage | These are available in different sizes depending on the company. The piping can also be used as a storage if its volume is appropriate and its geographical extension and the operation mode are suitable. Natural gas can be taken from the storage in order to compensate peaks.


Power consumption characteristics of devices

Manual -> Load Management -> Functionality of the whole system -> Principal thoughts -> Power consumption characteristics of devices

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to reconstruct the actual needed output, models must be used which represent the power consumption of the switched off components. These models are allocated to different classes.

Type | Description
Constant output | When switched on, an aggregate (pump, furnace) runs with a previously defined power consumption. Accordingly the output is reduced by the amount of the power consumption when the device is switched off. In this case it is enough to indicate the nominal power as a constant.
Directly temperature-dependent | The temperature dependence of the devices is directly dependent of weather effects and rises with thermal output approximately proportional to the negative gradient of the outdoor temperature. With respect to cooling capacity the behavior inverses itself.
Loading period model | At that the temperature makes itself felt with the size of the switch-on output and the length of the following loading period until the output drops when all heat stores are full.
Dependence on the switch-off time | At that several devices - because of the temporary cool down or warm up - are switched on dependent on the previous switch-off time. After a short period of time they switch themselves off again.
Dependent on the production process | In the industry sector behavior can occur - caused by production processes - which are subject to no behavior patterns or dependencies. These can only be determined by the production schedules.


Load management method

Manual -> Load Management -> Load management method

The Load Management for electrical energy (electric current) is based on a time line analysis. At that the measured output progress is analyzed and extrapolated to the future. The forecast horizon of the Load Management corresponds to the remaining time of the measuring period.


Input values

Manual -> Load Management -> Load management method -> Input values

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As input value the Load Management expects a value from a counter or a calculated value which is supplied by the drivers or the result of the calculation of a mathematical formula in zenon.

Attention: It must be made sure that the value is supplied exactly one time in the update interval. Values must not be absent or be there twice.

The dimension: MW, kW , kWh or m3

The system is designed on the basis of kW and hour. Therefore all power and energy amounts which must be entered in parameterization masks refer to these dimension. Internally the Load Management functions calculate without the dimensions. Thus it does not really matter in what dimensions the values are delivered and interpreted as long as they refer to the same basis. The base unit can be either kW or MW.

In the natural gas area it is also possible to calculate with standard m3. Combarability of the cubicmeters must be granted. This is only possible when using the standard cubic meter. The conversion of cubic meters in amount of energy and its timely connection is not necessary.

info Information

Because the Load Management is a component which can cause high costs if it fails, it is very important the the input values are secured. It is recommended that values for this module are secured by using sensible alternate values or an alternate value strategy.


The model for the short term prognosis

Manual -> Load Management -> Load management method -> The model for the short term prognosis

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For the projection of the current power progress it is necessary to design a mathematical model of the power progress. By extrapolation of the power progress of this model over the remaining time of the billing period, the expected power value at the end of the period is estimated.

Power trend

At the end of the period T the power P prog (T) is to calculate. In order to calculate the current power trend a linear function is used which is extrapolated to the end of the period.

P prog (T) = P const (t) + P trend (t) * ( T - t )

The mathematical polygon factors p0, p1 are named after their physical meaning in order to make it easier to understand.

Factor | Description
P prog | prognosticated power value
P const | Power constant (value of the last values)
P trend | Power trend (linear ascent(descent)
D | Point in time of the end of the measuring period
t | current time

Energy trend

Deducted from this the energy trend up to the end of the period E(T) can be calculated with the function

E prog (T) =P aver (t) * t + P const (t) * (T - t) + ½ * P trend (t) * (T - t)

Factor | Description
E prog | prognosticated energy value
P aver | average power value

The first addend describes the determined energy up to the time t. The energy can be either determined by the average power value as described in the formula or is is given as a direct calculated energy value E(t).

The second addend continues the present constant power to the end of the period and calculates the constant energy amount from that.

The third addend describes the additional influence of the trend.

Concerning the energy calculation for the actual billing a value is necessary which is set back exactly at the beginning of the measuring period. Therefore it is not possible to use externally filtered values.

From the formula mentioned above the average value at the end of the period is determinable.

P prog aver (T) = E prog (T) / T

Parameters | Description
P prog aver | prognosticated average power value


Calculation of the correction power

Manual -> Load Management -> Load management method -> The model for the short term prognosis -> Calculation of the correction power

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

During the measuring period the average power

P limit = agreed limit

can be obtained. Over the measuring period T this power equals

E limit = P limit * T

.

By comparing this power with the expected energy E prog (T) at the end of the period, the de- and exceedance of the agreed limit

E corr = E prog (T) - E limit

can be assessed. The de-/ or exceedance can be balanced by carrying out the corresponding switchings.

Minding that at time t only T-t balance time is available. Therewith a large correction power

P corr (t) = E corr / (T-t)

is necessary.


Actual value and real value forecast

Manual -> Load Management -> Load management method -> The model for the short term prognosis -> Actual value and real value forecast

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The forecast is carried out for several trends in the Load Management module.

  • The first trend considers the power consumption. This trend calculates the ascent of the the power requirement as actual value forecast.
  • A second trend factor considers the switchings which have taken place in the past.
  • A third trend factor calculates the influence of the switchings which will take place in the future.

The trend functions are laid on top of each other and result in the real value forecast. It describes the actual power consumption to the end of the billing period which is to be expected.


Lowering the supply limit

Manual -> Load Management -> Load management method -> The model for the short term prognosis -> Lowering the supply limit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As the load trend can never be exactly predicted and as there are usually deviations of the switchable loads, it is necessary to go slightly below the actual supply set value for security reasons.

This is why there is a percentage Safety distance [%] for the supply limit during parameterization, which must be undershot before connections are triggered.

Digit | Description
1 | Supply limit (set value)
2 | Safety distance
3 | Deactivate hysteresis
4 | Activate hysteresis
5 | Hysteresis for switching

Around this limit a hysteresis can be built with the help of Activate hysteresis [%] and Deactivate hysteresis [%] . In doing so the Activate hysteresis [%] eliminates a part of the Safety distance [%].

attention Attention

Take care that Activate hysteresis [%] is in any case smaller than the Safety distance [%]. Otherwise the system reacts too late if the agreed limit is exceeded


Operating principle of the obtaining rule

Manual -> Load Management -> Load management method -> Operating principle of the obtaining rule

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Closed Loop operation

Normally the obtaining rule is applied in the Closed Loop operation. There switch on and switch off times are calculated in accordance with the results of the optimization part. The switching is triggered directly by the corresponding switching commands.

info Information

In the Load Management module the immediate switching points do not have to be used at the devices. You can decide whether you want to make direct switching possible or whether switching must be cleared by the user first.

attention Attention

The unchecked use of the closed loop operation necessitates an intensive pilot stage. At that all switchings which are then done by the control must be checked by the user. This pilot stage must be adjusted to the size and complexity of the system. It is possible that the pilot stage lasts up to one year.


Output determination for the devices

Manual -> Load Management -> Load management method -> Operating principle of the obtaining rule -> Output determination for the devices

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The output determination for the devices is especially important with regard to the assessment of the effect caused by switchings. The problem is that the output of the switched off devices cannot be measured directly and must sometimes be estimated.

In the system two mechanisms are implemented in order to determine the output

  • Fixed value by parameterization

    The value (e.g. the nominal power) is considered by the optimization as fixed and is always available.

  • Measuring the current value.

    The value is measured and zenon describes this value with the help of a variable in the devices.

The initial value for the output of the device is determined with a polling of the variable value during the beginning of the optimization. In order to compensate errors due to fluctuations, the optimization calculates a gliding average value using the consecutively arriving measurements.

info Information

If a component is switched off when the optimization starts, its output is presumed as zero. Thus the SCADA function cannot determine a valid output value as prerequisite for the use of the component. The component must be switch on by hand once.

attention Attention

As long as not at least one value has arrived, the output value of the component is not known and cannot be used for the optimization.


Primary factors

Manual -> Load Management -> Load management method -> Operating principle of the obtaining rule -> Output determination for the devices -> Primary factors

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The amount of the energy

In general the device selection is determined by the amount of energy which can be switched on or off.

If the requested amount of energy cannot be reached exactly, it is treated as a minimum value at a switch-off request and a maximum value at a switch-on request. At that you are on the save side regarding the adherence of the datum line.

info Information

During the Runtime the amount of energy can be adjusted dynamically with the help of a variable.

Availability

The availability controls if the device is usable in general. The availability can be set manually and is always set back when the component can not be used because of operational reasons (e.g. at overhauls) or when the optimization should not use it.

Conditions which arise during the process can also determine the availability of the component and control its use by the optimization.

info Info

In the Runtime the availability can be adjusted dynamically with the help of a variable. For example time tables with respect to the availability can be implemented with the help of a scheduler or the Production & Facility Scheduler.


Secondary factors

Manual -> Load Management -> Load management method -> Operating principle of the obtaining rule -> Output determination for the devices -> Secondary factors

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Lock times and release times of the devices

With the help of the lock times you can control during which times the components are not available for the optimization. The times which are not designated as lock times represent the release times.

attention Attention

During the lock times the components are not influenced by the optimization - or only in the released direction. Thus the components remain in the state they had reached at the end of the release time.

Minimum and maximum switching times

You can specify the minimum and maximum time for the single switch states (on/off) for each used device and generator. The time indicates what time period must have elapse at least in order to trigger a switching in the opposite direction.

This parameter is important for aggregates because in order to avoid thermal damages and damages caused by soot they must not be switched off right after they were switched on. Thus for example a certain amount of time must have passed after the heating groups had been activated before they switch on.

Switching frequency

If devices and generators can only be switched a limited number of times in a certain time period, the components are no longer switched when this number is exceeded. Beside the number of switchings a time period must also be defined in order to carry out the parameterization.

Example Example

Maximum 25 switchings in 12 hours

Switching priorities

The switching of the components is planned in accordance with a priority schedule. At that switch-on and switch-off priorities are listed separately. The user can determine the priorities in accordance with the operation requirements. The component with the highest priority (highest numerical value) is switched first.

If there is a requirement to switch the components in a sorted order by having the device that was switched on first be the one switched off last, a number pattern must be applied to all components: ascending for the first switch-on and descending for the last switch-off.

info Information

If several devices have the same priority in one plant, the Load Management automatically ensures that on average all devices of the same level are switched equally often.


Switching process

Manual -> Load Management -> Load management method -> Operating principle of the obtaining rule -> Switching process

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The term switch-off request on the part of the optimization always refers to the reaction of the device which decreases the needed output and therewith the obtained output because it is switched-off. Therefore the request for the switch-off can be fulfilled by switching on an aggregate.

Processes during a switching

Digit | Description
1 | Pre-warning on
2 | Output order ON
3 | Delay time for switch-on
4 | Pre-warning off
5 | Output order OFF
6 | Delay time for switch-off

Delay time for the switch-on (switch-on dead time)

Equals the time period from activating the switching order until the nominal power is reached.

This time - dependent on the aggregate - can be quite long; e.g starting up the aggregate und synchronization, rearwards controlled heating etc.

Delay time for the switch-off (switch-off dead time)

Time period from activating the switching order until the output is zero. You must add the time of the activation of the switching order to the time when the total output is zero.

Forewarn time for the switching-on and the switching-off (length of forewarn time)

The switching times are planned to a second in order to exactly control the amount of energy. In order to give the user the opportunity to adhere to the times in the open-loop operation a certain lead time to carry out the switching is necessary. This is defiend by Advance warning time. Hereby the user receives information about switchings which are planned before they are actually carried out.

attention Attention

As the Load Management assumes that the switchings are carried out, the suggested switchings should be carried out in the corresponding time in respect to the exactness of the forecast.

Tactic of the switching schedule

In general the switching selection happens in a away that as few switchings as possible are carried out. This calms the grid operation and keeps up the availability of the devices whose use are limited by a maximum of switchings. In addition conflicts are minimized which can occur at the command output of the switchings.

The use of components with a much higher output than that is used for the correction is possible by a specific time control. The components are used for such a short time that the compensate the needed output.

Suppressed switchings at the beginning of a measuring period

At the beginning of a measuring period it is possible that larger switchings are carried out or large deviations to the actual output average value are set in order to compensate large amounts of energy at the end of the period. That is way it is necessary at the beginning of the period to give the system the opportunity to adjust itself to the new circumstances.

That is why a Down time begin tariff interval can be engineered in the system. During this time the optimization doe not carry out any switchings.

attention Attention

If for a long time no response is received for a switch command which was issued by the EMS (on the response variable), the Load Management assumes that the action failed und tries to carry out another switching (on the next available component). Therefore you must always ensure that the correct response about the success of a switchng operation is transferred to the Load Management.


Overlapping of schedule inputs

Manual -> Load Management -> Load management method -> Overlapping of schedule inputs

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The switching of aggregates and devices according to fixed times with the help of the Scheduler or the Production & Facility Scheduler is possible with several applications. As there is not explicit link between these modules and the short term optimization, these switchings are not monitored in regard of the output trend. They are also not displayed in the trend of the obtained output. They are interfering in the short time optimization with regard to its result.

In order that these interferences do not have radical effects, external switchings should be engineered in a way that they take place at period change. If this is not possible, they should be scheduled right after a period change so that the interfering influence on the control can still be compensated. These switchings should be finished within Down time begin tariff interval and the influence of the switching on the input value should be present.


Multi-level combined heat and power plants (CHPs)

Manual -> Load Management -> Multi-level combined heat and power plants (CHPs)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Multi-level CHPs can be regarded as one component. It is possible to describe CHPs with 2 to n levels.

The CHPs are controlled by a set value. Additionally different output levels can be defined which this set value can take on. The actual output of the CHP is registered by a measurement (variable) and sent to the Load Management.

attention Attention

A CHP is only available for the Load Management when it has reached its nominal power. The availability flag is set accordingly by the engineering. The Load Management cannot switch off the CHP but only switch it to its nominal power.


Set value processing at CHPs

Manual -> Load Management -> Multi-level combined heat and power plants (CHPs) -> Set value processing at CHPs

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The number of values which the set value can become equals the number of the defined levels. The value which the set value can become always equals exactly one of the defined values for the levels. The Load Management does not allocate another number to the set value.

The initialization is carried out with the currently measured output. If this value does not equal a defined level, the next smaller level is allocated. The CHP is treated as unavailable as long as the measured output does not match a level. If the measured output is disturbed, the CHP is not available and the set value is initialized as recently as a valid measured value arrives.

As a measured output does not have to equal a set value exactly, a hysteresis is defined around the set value. A level counts as reached or set as soon as the current output value is within the hysteresis of the given set value. The hysteresis can be defined for each CHP individually.

The defined levels must not be skipped when allocating the set value. The Load Management appoints the set value only to the next higher or lower level.

A set value input is only carried out if the CHP shows an explicit level (considering the hysteresis) at that time. Otherwise the CHP is not available because the measured value does not equal a level.


Planned switchings for CHPs

Manual -> Load Management -> Multi-level combined heat and power plants (CHPs) -> Planned switchings for CHPs

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When planning the set value inputs for a CHP, the conditions for the set value inputs must be taken into consideration. If several levels of a CHP are necessary in order to cover the output, keep in mind that it is only possible to switch from one level to the next level when executing a switching schedule. At that the set value inputs for each level must be in accordance with the delay times for the switch-on and switch-off of each level.

attention Attention

You must consider that the forewarning is only given at a defined level setting. Thus you must regard the length of the forewarning time for the individual levels when creating the switching schedule.


Priorities of CHPs

Manual -> Load Management -> Multi-level combined heat and power plants (CHPs) -> Priorities of CHPs

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A CHP has a fixed switch-on and switch-off priority. The values can be controlled by variables. Thus priorities can be controlled flexible. The takeover of a new priority takes place at the next rate interval change.

The priorities are not set for each level individually but are valid for the whole CHP.

If a least two CHPs have the same priority, the rolling priority procedure is used. A more important condition for CHPs with same priority is that they are set to the same level if possible or that they differentiate by one level at the most. The prerequisite for this is that both the switch-on priority and the switch-off priority of these CHPs is the same.

The internal reference counter for the number of switchings is incremented when the CHP is switched on. This is exactly the case when the current output passes over from one level to the next higher level. At devices using electrical current the reference counter is incremented when the component is switched off. Thus within one priority level the switching between two CHPs is compared to the switch-on and switch-off of a device.


Time-dependent restrictions for CHPs

Manual -> Load Management -> Multi-level combined heat and power plants (CHPs) -> Time-dependent restrictions for CHPs

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

CHPs need special care with regard to their time behavior. The Load Management must consider special requirements at a level switch and at delay times while the CHP are running.


Running time according to level switching

Manual -> Load Management -> Multi-level combined heat and power plants (CHPs) -> Time-dependent restrictions for CHPs -> Running time according to level switching

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The minimum and maximum running time of CHPs must be set for each level. Instead of four times for a component (minimum switch-on time, minimum switch-off time, maximum switch-on time and maximum switch-off time) there are only two times - minimum and maximum runtime per level - in order to describe a CHP with levels.

The minimum running time (switch-on time) of a level indicates how long the CHP has to run at the least on this level. After a level is reached, the optimization must wait at least this amount of time before a new set value input can be made for the next lower level.

The maximum running time of a level indicates how long a CHP is allowed to run on this level at the most. With the exception of the lowest level (nominal power), the CHP is switched to the next lower level after this time expires. At that a level counts as active even if the CHP actually runs on a higher level. The maximum running time of the individual levels must be attuned to other restrictions with regard to minimum running time and forewarning. Thus a timely switch to a lower level is possible. The optimization must also prevent set value inputs to a higher level when the maximum running time cannot be adhered to e.g. because of the minimum running time of the higher level.

info Information

Manual switching can cause violations of the defined restrictions. These are intercepted by the Load Management.

For the lowest level (nominal level) the maximum running time has a different meaning than for the other levels. The maximum running time of the lowest level indicates how long a CHP is allowed to run on this level alone at the most. After that the CHP must be switched to the next higher level.

Example for the parameterization of the individual levels:

Step | 0 | 1 | 2 | 3 | 4
Output | 100 | 200 | 300 | 400 | 500
minimum switch-on time (in seconds) | -- | 60 | 60 | 60 | 60
Forewarn time (in seconds) | -- | 210 | 0 | 0 | 0
Delay time for switch-on (in seconds) | -- | 30 | 30 | 30 | 30
Delay time for switch-off (in seconds) | -- | 30 | 30 | 30 | 30
Minimum value for the maximum switch-on time (in seconds) | 210 | 240 | 180 | 120 | 60

The times which must be entered in the parameterization for the switch-on and switch-off always refer to the level for which they are entered. This means that the switch-off time which is parameterized for one level is considered if a "switching" is carried out from this level to the next lower level. The switch-on time is considered if a "switching" is carried out from a lower level to this level.

As the lowest level represents the CHP running with nominal power, no information for minimal running time, forewarn time, delay time for switch-on and delay time for switch-off is necessary.

The minimal allowed values for the maximum switch-on times of each level are as follows:

  • For the first level:

    Forewarn time of the next higher level

  • For the last level:

    maximum/minimum switch-on time, forewarn time of the last level

  • For all other levels:

    maximum/minimum switch-on time, forewarn time of next higher level

    + delay time for switch-on for the next higher level

    + minimum value for the maximum switch-on time of the next higher level

    + forewarn time of the next higher level

    + delay time for switch-off for the next higher level

If for one CHP the maximum switch-on time for one level is below the calculated minimum value for the maximum switch-on time, the CHP is treated as not available and a corresponding availability identification is set for the readiness.


Expiration of the delay time

Manual -> Load Management -> Multi-level combined heat and power plants (CHPs) -> Time-dependent restrictions for CHPs -> Expiration of the delay time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A set value remains at a certain level until that level is reached or until the defined delay time has passed. In case the delay time expires, the set value is re-initialized according to the currently measured performance. This requires determining the level of the current performance. The following cases can apply:

  • The current performance value matches the old level:

    The set value did not have any effect and is therefore reset to the old value.

  • The current value does not match any level:

    There can be a check whether the current performance has approached the new set value.
    In that case, the configured set value can be kept; otherwise, it must be reinitalized.

  • The current value matches another level:

    The performance of the CHP has changed in contrast to the set value input. This corresponds to a manual switch despite availability for the Load Management. See Manual switch for further steps.

Switching plans to the next levels must be revised or exchanged if the previously configured set value of a switching action for a CHP was not reached. For any further switching actions, different components will be preferred.


Manual operation of CHPs

Manual -> Load Management -> Multi-level combined heat and power plants (CHPs) -> Manual operation of CHPs

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If a measured value of the current output without set point input is outside of the level set by the Load Management, this component is accepted as not available because it is obvious that the Load Managementis not controlling it at the time.

If a measured value of the current output re-enters the hysteresis area of a defined level, the difference to the set value is registered and the difference at the level setting is assumed to be manual operation. The set value is set to the newly identified level.

A recognized manual operation is transmitted to the forecast so that it can be considered in the trend calculation.


Setting load management parameters

Manual -> Load Management -> Setting load management parameters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The engineering of the Load Management is carried out via a hierarchic tree structure. There corresponding sub-objects are linked to individual objects depending on their type. Sub-objects are added by selecting the corresponding menu item in the context menu of the selected node.

All object have property Name and Description. The engineering of the individual objects is carried out via the property window.

All adjustable properties which are available in the property window are described in the help window after you click on them.

info Information

All mentioned or shown properties are only visible if the module Load Management is licensed. The licensed Load Management module is a separate element in the project tree. The settings in the Load Management can be made with the help of this entry.

attention Attention

Within the Load Management all existing units (grids, device groups, generators, devices etc.) should have a distinct name in order to ensure the perfect function of the forecast and the optimization.

All objects have the following menu entries:

Menu/Entry | Description
Cut | Cuts the selected object(s) and copies it/them to the clipboard.
Copy | Copies selected object(s) to the clipboard.
Paste | Pastes object(s) from the clipboard. Starting from the selected node, only objects from the same level or the level directly beneath it can be pasted.
Delete | Deletes selected object(s) including all sub-objects.
Export XML all ... | Exports the whole project to an XML file.
Export selected XML ... | Exports selected objects including sub-objects to an XML file.
Import XML... | Imports objects from an XML file. Only objects (and their exported sub-objects) can be imported which are of the level directly beneath the selected node.
info Information
All values of variables which are used in the Load Management to state or adjust time values during the Runtime (e.g. switch-on time variable) are interpreted as seconds. Therefore a numerical value of 300 corresponds to a time period of 5 minutes (=300 seconds).

In order to ensure the correct functionality of the Load Management, you must create at least the following variables for a supply area:

  • Current total consumption
  • Supply limit
  • Start value of estimation
  • First switching value
  • Estimated error range
  • Estimated final consumption
  • Last switching value
  • Gross actual deviation
  • Net actual deviation

info Information

In the context menu for a supply area you can find the menu item "Create variable". When selected, it automatically creates variables for the properties listed above and links the variables with the properties.

You must at least create the following variables for a generator/device in order to ensure the functionality of the Load Management.

  • Switching state for the generator
  • Switching state for the device
  • Availability


Minimum requirements

Manual -> Load Management -> Setting load management parameters -> Minimum requirements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Supply area

For the correct functionality of the Load Management, you must create at least the following variables for a supply area:

  • Current total consumption
  • Supply limit
  • Start value of estimation
  • First switching value
  • Estimated error range
  • Estimated final consumption
  • Last switching value
  • Gross actual deviation
  • Net actual deviation

info Info

In the context menu for a supply area you can find the menu item Create variable. It automatically creates variables for the properties listed above and links the variables with the properties. Properties Current total consumption and Supply limit are an exception. You must create them manually.

Generators/Devices

For the correct functionality of the Load Management, you must create at least the following variables for a generator/device:

  • for the device
    • Switching state
    • Standby output variable
      or value for property Standby output
  • for the generator
    • Switching state
    • Nominal output variable
      or value for property Nominal output
  • for the generator and the device
    • Availability


Load Management: Detail view of toolbars and context menus

Manual -> Load Management -> Setting load management parameters -> Load Management: Detail view of toolbars and context menus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entry | Action
New | Creates a new object, depending on the position in the tree.
Gas grid new | Creates a new gas grid.
Copy | Copies selected element to the clipboard.
Paste | Pastes objects from the clipboard.
Delete | Deletes selected element after confirmation message.
Export selected XML | Exports all selected elements as an XML file.
Import XML... | Imports objects from an XML file.
Properties | Opens the property window for the selected element.
Help | Opens the online-help for the Load Management module.

Context menus grids

Entry | Action
New power grid | Creates a new power grid.
Gas grid new | Creates a new gas grid.
Paste | Inserts objects of the type Grid.
Export XML all... | Exports all defined grids to an XML file.
Import XML... | Imports objects of the type Grid.
Properties | Opens the property window for the selected element.
Help | Opens the online-help for the Load Management module.

Additional context menus:

Power grids

Natural gas grids


Power grids

Manual -> Load Management -> Setting load management parameters -> Load Management: Detail view of toolbars and context menus -> Power grids

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu power grid

Entry | Action
New supply area | Creates a new supply area.
Copy | Copies the currently selected device group. You can not copy more than one group at a time (no multi-select).
Paste | Inserts objects of the type gas storage.
Delete | Deletes the currently selected device group. You can not delete more than one group at a time (no multi-select).
Export XML all... | Exports all device groups of the selected grid.
Export XML selected... | Exports the selected entries as an XML file.
Import XML ... | Imports objects of the type Supply area.
Properties | Opens the properties window.
Help | Opens the online-help for the Load Management module.

Context menu supply area

Entry | Action
Generator new | Creates a new generator in the selected supply area.
New device group | Creates a new device group in the supply area.
Creating variables | Automatically creates the minimally required variables for the selected supply area and links them with the fitting properties.
Cut | No function at the supply area.
Copy | Copies the currently selected supply area. You can copy more than one supply area at a time using multi-select.
Paste | It is possible to paste objects of the type Supply area.
Delete | Deletes the currently selected supply area. You can delete more than one supply area at a time using multi-select.
Export XML selected... | Exports the currently selected supply area. You can export more than one supply area at a time using multi-select.
Import XML ... | Imports objects of the type Supply area.
Properties | Opens the properties window.
Help | Opens the online-help for the Load Management module.

Context menu generator (group)

Entry | Action
Generator new | Creates a new generator for the selected supply area.
Paste | Inserts objects of the type Generator.
Export XML all... | Exports all generators of the supply area
Import XML... | Imports objects of the type Generator.
Help | Opens the online-help for the Load Management module.

Context menu generator

Entry | Action
Generator new | Creates a new generator for the selected supply area.
Paste | Inserts objects of the type Generator.
Export XML all... | Exports all generators of the supply area
Import XML... | Imports objects of the type Generator.
Help | Opens the online-help for the Load Management module.

Context menu device groups (group)

Entry | Action
New device group | Creates a new device group.
Paste | Inserts objects of the type Device group.
Export XML all... | Exports the device group including all defined devices within the group.
Import XML... | Imports objects of the type Device group.
Help | Opens the online-help for the Load Management module.

Context menu device group

Entry | Action
New device | Creates a new device in the selected device group.
Cut | No function at the device group.
Copy | Copies the currently selected device group. You can not copy more than one group at a time (no multi-select).
Paste | Inserts objects of the type Device group, Device.
Delete | Deletes the currently selected device group. You can not delete more than one group at a time (no multi-select).
Export XML all... | Exports all device groups of the selected grid.
Export XML selected... | Exports the currently selected device group. You can not export more than one group at a time (no multi-select).
Import XML ... | Imports objects of the type Supply area.
Help | Opens the online-help for the Load Management module.

Context menu device

Entry | Action
Cut | No function at the device group.
Copy | Copies the currently selected device group. You can not copy more than one group at a time (no multi-select).
Paste | Inserts objects of the type Device group, Device.
Delete | Deletes the currently selected device group. You can not delete more than one group at a time (no multi-select).
Properties | Opens the properties window.
Export XML all... | Exports all device groups of the selected grid.
Export XML selected... | Exports the currently selected device group. You can not export more than one group at a time (no multi-select).
Import XML ... | Imports objects of the type Supply area.
Help | Opens the online-help for the Load Management module.


Natural gas grids

Manual -> Load Management -> Setting load management parameters -> Load Management: Detail view of toolbars and context menus -> Natural gas grids

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu natural gas grid

Entry | Action
New supply area | Creates a new supply area.
Copy | Copies the currently selected device group. You can not copy more than one group at a time (no multi-select).
Paste | Inserts objects of the type gas storage.
Delete | Deletes the currently selected device group. You can not delete more than one group at a time (no multi-select).
Export XML selected... | Exports the selected entries as an XML file.
Import XML ... | Imports objects of the type Supply area.
Properties | Opens the properties window.
Help | Opens the online-help for the Load Management module.

Context menu supply area

Entry | Action
Gas storage new | Creates a new gas storage in the selected supply area.
Liquid gas plant new | Creates a new liquid gas storage in the selected supply area.
New device group | Creates a new device group in the supply area.
Creating variables | Automatically creates the minimally required variables for the selected supply area and links them with the fitting properties.
Copy | Copies the currently selected supply area. You can copy more than one supply area at a time using multi-select.
Paste | It is possible to paste objects of the type Supply area.
Delete | Deletes the currently selected supply area. You can delete more than one supply area at a time using multi-select.
Export XML selected... | Exports the currently selected supply area. You can export more than one supply area at a time using multi-select.
Import XML ... | Imports objects of the type Supply area.
Properties | Opens the properties window.
Help | Opens the online-help for the Load Management module.

Context menu gas storage

Entry | Action
Gas storage new | Creates a new gas storage for the selected supply area.
Paste | Inserts objects of the type Generator.
Export XML all... | Exports all generators of the supply area
Import XML... | Imports objects of the type Generator.
Help | Opens the online-help for the Load Management module.

Context menu liquid gas plant

Entry | Action
Liquid gas plant new | Creates a new liquid gas plant for the selected supply area.
Paste | Inserts objects of the type Generator.
Export XML all... | Exports all generators of the supply area
Import XML... | Imports objects of the type Generator.
Help | Opens the online-help for the Load Management module.

Context menu device groups

Entry | Action
New device group | Creates a new device group.
Paste | Inserts objects of the type Device group.
Export XML all... | Exports the device group including all defined devices within the group.
Import XML... | Imports objects of the type Device group.
Help | Opens the online-help for the Load Management module.

Context menu device group

Entry | Action
Gas storage new | Creates a new gas storage in the selected supply area.
Liquid gas plant new | Creates a new liquid gas storage in the selected supply area.
Copy | Copies the currently selected device group. You can not copy more than one group at a time (no multi-select).
Paste | Inserts objects of the type Device group, Device.
Delete | Deletes the currently selected device group. You can not delete more than one group at a time (no multi-select).
Export XML all... | Exports all device groups of the selected grid.
Export XML selected... | Exports the selected entries as an XML file.
Import XML ... | Imports objects of the type Supply area.
Help | Opens the online-help for the Load Management module.

Context menu gas storage (group)

Entry | Action
Gas storage new | Creates a new gas storage.
Paste | Inserts objects of the type Device group, Device.
Export XML all... | Exports all device groups of the selected grid.
Export XML selected... | Exports the selected entries as an XML file.
Import XML ... | Imports objects of the type Supply area.
Help | Opens the online-help for the Load Management module.

Context menu gas storage

Entry | Action
Cut | No function at the device group.
Copy | Copies the currently selected device group. You can not copy more than one group at a time (no multi-select).
Paste | Inserts objects of the type gas storage.
Delete | Deletes the currently selected device group. You can not delete more than one group at a time (no multi-select).
Properties | Opens the properties window.
Export XML all... | Exports all device groups of the selected grid.
Export XML selected... | Exports the currently selected device group. You can not export more than one group at a time (no multi-select).
Export XML selected... | Exports the selected entries as an XML file.
Import XML ... | Imports objects of the type Supply area.
Help | Opens the online-help for the Load Management module.

Context menu liquid gas plants (group)

Entry | Action
Liquid gas plant new | Creates a liquid gas plant.
Paste | Inserts objects of the type Device group, Device.
Export XML all... | Exports all device groups of the selected grid.
Export XML selected... | Exports the selected entries as an XML file.
Import XML ... | Imports objects of the type Supply area.
Help | Opens the online-help for the Load Management module.

Context menu liquid gas plant

Menu/Entry | Description
Cut | No function at the device group
Copy | Copies the currently selected device group. You can not copy more than one group at a time (no multi-select).
Paste | Inserts objects of the type Liquid gas plant.
Delete | Deletes the currently selected device group. You can not delete more than one group at a time (no multi-select).
Properties | Opens the properties window.
Export XML all... | Exports all device groups of the selected grid.
Export XML selected... | Exports the selected entries as an XML file.
Import XML ... | Imports objects of the type Supply area.
Help | Opens the online-help for the Load Management module.

Context menu device

Entry | Action
Cut | No function at the device group.
Copy | Copies the currently selected device group. You can not copy more than one group at a time (no multi-select).
Paste | Inserts objects of the type Device group, Device.
Delete | Deletes the currently selected device group. You can not delete more than one group at a time (no multi-select).
Properties | Opens the properties window.
Export XML all... | Exports all device groups of the selected grid.
Export XML selected... | Exports the currently selected device group. You can not export more than one group at a time (no multi-select).
Import XML ... | Imports objects of the type Supply area.
Help | Opens the online-help for the Load Management module.


Data for load management

Manual -> Load Management -> Setting load management parameters -> Data for load management

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Load Management needs a historic data basis in order to calculate the trend and to perform the optimization. If no historic data are available for the data points, the Load Management cannot start the calculation. Therefore no calculated value is displayed for the Estimated final consumption.

At the moment the Load Management has no interface to the Historian. This is not necessary for the short term optimization. For this the historic data which were recorded via option Harddisk data storage are enough.

The following settings depending on the period length are recommended for the recording of the HD data.

Number of past values

As guideline use the following rule-of-thumb:

The Historic data area which is provided by the Harddisk data storage has to be at least 1.5 times the size of the corresponding Billing period. If not enough data are available, the calculation of the optimization is not started.

attention Attention

At the beginning of the Billing period the Load Management needs a Current total consumption for the displayed supply area. Thereby the new value must be transferred to the Load Management during the next but one Optimization cycle, i.e. if the optimization cycle is 30 seconds, the value must be transferred in the period between 30 an 60 seconds.

If the Load Management does not receive a value in this period, the new initialization of the Load Management can be carried out during the next billing period at the earliest.


Grids

Manual -> Load Management -> Setting load management parameters -> Grids

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The collective node contains all projects which have been created in the grid but does not offer any setting possibilities itself.

Options:

Menu/Entry | Description
New power grid | Creates a new power grid.
Gas grid new | Creates a new gas grid.
Paste | Inserts objects of the type Grid.
Export XML all... | Exports all defined grids to an XML file.
Import XML... | Imports objects of the type Grid.
Help | Opens the online-help for the Load Management module.

You must place a distinct Name with each created grid. In order to ease identification you can place a free Description with each grid as an option. This is not mandatory. Gas grids contain a few additional Settings.

info Information

For each project only 1 power grid and 1 gas grid can be created or administrated.


Natural gas grids

Manual -> Load Management -> Setting load management parameters -> Grids -> Natural gas grids

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For natural gas grids additional configuration possibilities are available. With their help you can configure grid-wide parameters such as Temperature or Characteristic days and total results such as Adjusted consumption or Forecast for the whole grid.

All adjustable properties which are available in the property window of the natural gas grid are described in the help window after you click on them.


Supply area

Manual -> Load Management -> Setting load management parameters -> Supply area

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The supply area is the level of the object hierarchy which is used as a basis for the forecast and the optimization.

info Information

In order to start the Load Management for a particular supply area, a function of the type "Load Management" must be executed which has this supply area as parameter.

Settings for the supply area of a power grid

For supply areas the following settings are available:

  • Input values: Defines variables for the supply of the current values and the supply limits.
  • Calculated values: Settings in order to adjust parameters for the forecast and the optimization with the help of variables during the Runtime.
  • Parameter: Important settings for the optimization of the supply area with direct influence to the switchings of the Load Management.
  • Status information: Setting which variable holds the information about the availability of the Load Management screen.

All in the respective groups adjustable properties are described in the help window after you click on them.

Context menu entries

Menu/Entry | Description
Generator new | Creates a new generator in the selected supply area.
New device group | Creates a new device group in the supply area.
Creating variables | Automatically creates the minimally required variables for the selected supply area and links them with the fitting properties.
Cut | No function at the supply area.
Copy | Copies the currently selected supply area. You can copy more than one supply area at a time using multi-select.
Paste | It is possible to paste objects of the type Supply area.
Delete | Deletes the currently selected supply area. You can delete more than one supply area at a time using multi-select.
Export XML all... | Exports all supply areas of the selected grid.
Export XML selected... | Exports the currently selected supply area. You can export more than one supply area at a time using multi-select.
Import XML ... | Imports objects of the type Supply area.
Help | Opens the online-help for the Load Management module.


Additional parameters for the gas supply areas

Manual -> Load Management -> Setting load management parameters -> Supply area -> Additional parameters for the gas supply areas

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The supply area is the level of the object hierarchy which is used as a basis for the forecast and the optimization.

info Info

In order to start the Load Management for a supply area, a "Load Management" function must be executed that has this supply area as a parameter.

Supply areas for a gas grid have Specific gas parameters. With the help of them e.g. Adjusted consumption, Forecast and Optimum load can be defined but also the relation between liquid gas supply and general supply. All adjustable properties are described in the help window after you click on them.

Context menu entries:

Menu/Entry | Description
Gas storage new | Creates a new gas storage in the selected supply area.
Liquid gas plant new | Creates a new liquid gas storage in the selected supply area.


Device group

Manual -> Load Management -> Setting load management parameters -> Device group

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Individual devices are combined in a device group. At that each device group can contain any number of devices.

Context menu entries at node "Device groups".

Menu/Entry | Description
New device group | Creates a new device group.
Paste | Inserts objects of the type Device group.
Export XML all... | Exports the device group including all defined devices within the group.
Import XML... | Imports objects of the type Device group.
Help | Opens the online-help for the Load Management module.

info Information

These settings are identical for device groups in the power grid and in the gas grid.

Context menu entries at the node of a device group:

Menu/Entry | Description
New device | Creates a new device in the selected device group.
Cut | No function at the device group.
Copy | Copies the currently selected device group. You can not copy more than one group at a time (no multi-select).
Paste | Inserts objects of the type Device group, Device.
Delete | Deletes the currently selected device group. You can not delete more than one group at a time (no multi-select).
Export XML all... | Exports all device groups of the selected grid.
Export XML selected... | Exports the currently selected device group. You can not export more than one group at a time (no multi-select).
Import XML ... | Imports objects of the type Supply area.
Help | Opens the online-help for the Load Management module.


Additional parameters for the gas device groups

Manual -> Load Management -> Setting load management parameters -> Device group -> Additional parameters for the gas device groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Individual devices are combined in a device group. At that each device group can contain any number of devices.

Device groups in gas grids have additional settings such as Adjusted consumption or Forecast with the configuration of upper and lower forecast errors. In addition, there are Optimum load, Current consumption and Daily energy.

Context menu entries

Menu/Entry | Description
Gas storage new | Creates a new gas storage in the selected supply area.
Liquid gas plant new | Creates a new liquid gas storage in the selected supply area.

attention Attention

A liquid gas storage can be created using the node "Supply area" no sooner than a gas storage with option Piping storage has been created.

Directly creating a liquid gas storage (without creating a gas storage first) is only possible in a device group.


Generator

Manual -> Load Management -> Setting load management parameters -> Generator

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Using the node Generator you can create new Generators for the selected supply area using the context menu.

Generators serve to lower the currently obtained power. Basically it is possible to engage each generator or to set it on higher load (Peak performance). If a generator is engaged, the power currently obtained (Current average consumption) is immediately lowered.

Context menu entries at node "Generator".

Menu/Entry | Description
Generator new | Creates a new generator for the selected supply area.
Paste | Inserts objects of the type Generator.
Export XML all... | Exports all generators of the supply area
Import XML... | Imports objects of the type Generator.
Help | Opens the online-help for the Load Management module.

Properties

In addition to name and identification, properties can be defined in different groups for the generator:

  • Capacity/Priority: Defines the basic behavior of pieces of equipment in the electric grid.
  • Switching times: Default of different life spans or timely requirements to single pieces of equipment.
  • Switching frequency: Definition of the maximum number of switchings per time unity.
  • Switching variables: Variable for the adaption of important parameters during the Runtime.
  • Locking times: Excludes single pieces of equipment of the Load Management from the optimization.
  • Switching steps: Define switching levels for combined heat and power units.

All adjustable properties are described in the help window after you click on them.

attention Attention

The switching priority is regarded by the Load Management taking all equipment into account. That means the same number circle is applied for generators and devices. Therefore the priorities for all defined equipment must be considered because it is not distinguished between generators and devices.

Context menu entries for the selected generator:

Menu/Entry | Description
Cut | No function at the device group.
Copy | Copies the currently selected device group. You can not copy more than one group at a time (no multi-select).
Paste | Inserts objects of the type Device group, Device.
Delete | Deletes the currently selected device group. You can not delete more than one group at a time (no multi-select).
Export XML all... | Exports all device groups of the selected grid.
Export XML selected... | Exports the currently selected device group. You can not export more than one group at a time (no multi-select).
Import XML ... | Imports objects of the type Supply area.
Help | Opens the online-help for the Load Management module.


Switching steps

Manual -> Load Management -> Setting load management parameters -> Generator -> Switching steps

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The CHPs (combined heat and power units) are a special case within the Load Management. This special type of generators can adjust their output in levels. In order to define a CHP, you can define switching levels for a random device in the Load Management.

Basically you can define under the node Switching steps settings for the Setpoint variable, for the current output and for the Hysteresis for each CHP.

For every CHP any number of switching levels can be defined:

Each switching level offers settings for the output, the forewarning of the switching and the switch-on and switch-off. All adjustable properties are described in the help window after you click on them.

attention Attention

If switching levels are defined for a generator, these settings overwrite the standard parameters of the generator. An according warning is displayed during compiling in the output window. "


Device

Manual -> Load Management -> Setting load management parameters -> Device

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Load Management devices are the essential components which "use up" energy. By switching devices on and off the Load Management can interfere in a regulative way. At that it helps to avoid peak loads.

Context menu entries for the selected device group:

Menu/Entry | Description
New device | Creates a new device in the currently selected supply area.
Cut | No function at the device group.
Copy | Copies the currently selected device group. You can not copy more than one group at a time (no multi-select).
Paste | Inserts objects of the type Device group, Device.
Delete | Deletes the currently selected device group. You can not delete more than one group at a time (no multi-select).
Export XML all... | Exports all device groups of the selected grid.
Export XML selected... | Exports the currently selected device group. You can not export more than one group at a time (no multi-select).
Import XML ... | Imports objects of the type Supply area.
Help | Opens the online-help for the Load Management module.

Properties

In addition to name and identification, properties can be defined in different groups for the device:

Capacity/Priority: Defines the basic behavior of pieces of equipment in the electric grid.

Switching times: Default of different life spans or timely requirements to single pieces of equipment.

Switching frequency: Definition of the maximum number of switchings per time unity.

Switching variables: Variable for the adaption of important parameters during the Runtime.

Locking times: Excludes single pieces of equipment of the Load Management from the optimization.

All adjustable properties are described in the help window after you click on them.

Context menu entries for the selected device:

Menu/Entry | Description
Cut | No function at the device group.
Copy | Copies the currently selected device group. You can not copy more than one group at a time (no multi-select).
Paste | Inserts objects of the type Device group, Device.
Delete | Deletes the currently selected device group. You can not delete more than one group at a time (no multi-select).
Export XML all... | Exports all device groups of the selected grid.
Export XML selected... | Exports the currently selected device group. You can not export more than one group at a time (no multi-select).
Import XML ... | Imports objects of the type Supply area.
Help | Opens the online-help for the Load Management module.


Additional settings for the gas devices

Manual -> Load Management -> Setting load management parameters -> Device -> Additional settings for the gas devices

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Load Management devices are the essential components which "use up" energy. By switching devices on and off the Load Management can interfere in a regulative way. At that it helps to avoid peak loads.

Devices in gas grids have additional settings for output such as Proportion of group [%], Return [€/kWh]/Priority and information about minimum and maximum temperature. All adjustable properties are described in the help window after you click on them.


Specific elements of the natural gas grid

Manual -> Load Management -> Setting load management parameters -> Specific elements of the natural gas grid

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Hereafter the devices and elements used when working with natural gas grids are described. The settings documented hereafter are not available for electricity grids.


Natural gas storage

Manual -> Load Management -> Setting load management parameters -> Specific elements of the natural gas grid -> Natural gas storage

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the help of a gas storage, it is possible to shape the storage capacity of a natural gas supply area. They can be used in the following situations:

  1. As gas storage in the supply area
  2. As a piping storage a gas storage can be used to display the storage capacity of a geographically expanded piping.
  3. As gas storage in device group.

Context menu entries for the selected gas storage group:

Menu/Entry | Description
Gas storage new | Creates a new gas storage.
Paste | Inserts objects of the type Device group, Device.
Delete | Deletes the currently selected device group. You can not delete more than one group at a time (no multi-select).
Export XML all... | Exports all device groups of the selected grid.
Import XML ... | Imports objects of the type Supply area.
Help | Opens the online-help for the Load Management module.

Properties

In addition to name and identification, properties for the gas storage can be defined in different groups:

Type/Capacity: Settings for the basic behavior of the devices in the gas grid.

Switching variables: Variable for the adaption of important parameters during the Runtime.

Fill level: Here the Load Management receives important information about filling level and minimal and maximal value.

Switching times: Default of different life spans or timely requirements to single pieces of equipment.

All adjustable properties are described in the help window after you click on them.

Context menu entries for the selected gas storage:

Menu/Entry | Description
Cut | No function at the device group.
Copy | Copies the currently selected device group. You can not copy more than one group at a time (no multi-select).
Paste | Inserts objects of the type gas storage.
Delete | Deletes the currently selected device group. You can not delete more than one group at a time (no multi-select).
Export XML all... | Exports all device groups of the selected grid.
Export XML selected... | Exports the currently selected device group. You can not export more than one group at a time (no multi-select).
Import XML ... | Imports objects of the type Supply area.
Help | Opens the online-help for the Load Management module.


Liquid gas plant

Manual -> Load Management -> Setting load management parameters -> Specific elements of the natural gas grid -> Liquid gas plant

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Load Management liquid gas plant are classical gas storage devices. Basically they are used to equalize peaks. In case of a peak, gas can be taken from the storage.

Context menu entries for the selected gas storage group:

Menu/Entry | Description
Liquid gas plant new | Creates a liquid gas plant.
Paste | Inserts objects of the type Device group, Device.
Delete | Deletes the currently selected device group. You can not delete more than one group at a time (no multi-select).
Export XML all... | Exports all device groups of the selected grid.
Import XML ... | Imports objects of the type Supply area.
Help | Opens the online-help for the Load Management module.

Properties

In addition to name and identification, properties for the liquid gas plant can be defined in different groups:

Type/Capacity: Settings for the basic behavior of the devices in the gas grid.

Switching variables: Switching variables: Variable for the adaption of important parameters during the Runtime.

Fill level: Here the Load Management receives important information about filling level and minimal and maximal value.

Switching times: Default of different life spans or timely requirements to single pieces of equipment.

All adjustable properties are described in the help window after you click on them.

Context menu entries for the selected liquid gas plant:

Menu/Entry | Description
Cut | No function at the device group
Copy | Copies the currently selected device group. You can not copy more than one group at a time (no multi-select).
Paste | Inserts objects of the type Liquid gas plant.
Delete | Deletes the currently selected device group. You can not delete more than one group at a time (no multi-select).
Export XML all... | Exports all device groups of the selected grid.
Export XML selected... | Exports the selected entries as an XML file.
Import XML ... | Imports objects of the type Supply area.
Help | Opens the online-help for the Load Management module.


Locking times

Manual -> Load Management -> Setting load management parameters -> Locking times

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For both generators and devices it is possible to define times in which switchings can be carried out only restricted or not at all. Any number of lock times can be defined for each generator/device.

info Information

In natural gas grids lock times are only available for devices.

Any number of lock times can be defined for each element. You must ensure that the lock times do not overlap. If they do, it is possible that the component cannot be switched by the Load Management anymore.

info Information

The lock time parameters are set in the project and cannot be changed during the Runtime.


Creating a process screen

Manual -> Load Management -> Setting load management parameters -> Creating a process screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The operating of the Load Management module during the Runtime is done with a screen of the type Load Management. This screen must be created in the editor first. (You will find more information on the pre-defined screen types in the chapter Screens / Pre-defined screen types.)

After the screen is opened an empty screen is displayed. You can add control elements via menu Control elements.


Engineering the screen switch function

Manual -> Load Management -> Setting load management parameters -> Engineering the screen switch function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When creating a screen switch function for a screen of the type Load Management the following dialog is displayed:

In the Runtime the Load Management screen is opened with the help of a screen switch function. For the screen call-up the following parameter can be set:

Property | Description
Grids | Selection of the grids. After that the available areas are displayed in the selection box Supply area.
Supply areas | The selected supply area is displayed in the Runtime n of the optimization. Only one supply area can be displayed per screen. You have however the possibility to open several screens of the type Load Management parallel. At that several supply areas can be displayed parallel.
Current value | This field is only for display. You cannot change the value. The variable of the property Current value of the currently selected supply area is displayed.
Final value of forecast | This field is only for display. You cannot change the value. The variable of the property Final value forecast of the currently selected supply area is displayed.
Forecast average | This field is only for display. You cannot change the value. The variable of the property Forecast average of the currently selected supply area is displayed.
Supply limit | This field is only for display. You cannot change the value. The variable of the property Supply limit of the currently selected supply area is displayed.
Scale maximum | Upper limit of the range scale for the display of the characteristic curve in the Load Management screen.
Scale minimum | Lower limit of the range scale for the display of the characteristic curve in the Load Management screen.
Billing period (min.) | This field is only for display. You cannot change the value. Shows the currently set length of the Billing period for the selected supply area.
Value color and width | Color and line width for the display of the elements for the current average value and for the forecasted average value.
Axis color and width | Color and line width for the display of the chart axes.
Curve color and width | Color and line width for the display of the chart curves (display of the current value and the scheduled switchings).
Font axis | Font which is used for the axis caption and the trend curve.

Switching operation

For the engineering of the switching operation you define the filter settings for the display in the Runtime in tab Column settings for the switching operations preview. You can find details in chapter Column settings for the switching operations preview.


Create function start/stop

Manual -> Load Management -> Setting load management parameters -> Create function start/stop

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For each area you must start the optimization separately in the Runtime. For this you use the function Start Load Management.
In order to stop started areas, create the function Stop Load Management.

Note: These functions are only carried out on the server.

attention Attention

In the Runtime all started areas recorded by the licensing. Take care of sufficient licensing.

Hint: Stop the optimization of areas if they are not needed in order to use your license in an optimal way.. In order to stop areas regularly e.g. in the night or in certain shifts, you can control functions Start Load Management or Stop Load Management with the help of the Production & Facility Scheduler.

Load Management Start

  • select New Function
  • click on Start Load Management in the node applications
  • the dialog for the selection of the areas opens

  • first select the desired grid
  • then select the desired area
  • by clicking OK the function is created

Stop Load Management

  • select New Function
  • click on Load Management stop in the node applications
  • the dialog for the selection of the areas opens

  • first select the desired grid
  • then select the desired area
  • by clicking OK the function is created


Engineering switching operations preview

Manual -> Load Management -> Setting load management parameters -> Engineering switching operations preview

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Planned switching operations can be displayed as a preview in the Runtime.

In order to engineer the switching operations preview in the Runtime:

  1. Link a String variable to the desired Load Management supply area with the help of property Planned switchings (group Status information). The variable receives a list of all planned switching operations from the Load Management.

    Hint: A String variable from the internal driver makes most sense.
    For server operation set the calculation to Network. Thus the variable is distributed in the whole zenon network.

  2. Define the desired content of the switching operations preview. For this open tab Load Management Column settings for the switching operations preview in the dialog of the screen switch function to the screen Load Management.
  3. Insert the Table view: control element into the the Load Management screen. Switching operations preview on.

    You can customize color and font using its properties.

Language switch

You can switch between languages for all information displayed in the switching operations preview with the help of the language table.

For this you can define the name for the column titles in the filter dialog. For example if you define a name such as @Switching time, @Object name or similar, these names are replaced by the corresponding entries from the language table in the Runtime.

In addition the whole content of the switching operations preview can be replaced:

  1. Object names are replaced by putting a @ in front of them during the Load Management engineering. For example: @Generator1
  2. Current value and switching value can either have a numerical content (with CHP steps) or @On/@Off


Column settings for the switching operations preview

Manual -> Load Management -> Setting load management parameters -> Engineering switching operations preview -> Column settings for the switching operations preview

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Via the column setting you can define which information is displayed in what order.

Note: The language of all information displayed in the switching operations can be switched via the language table:
Select the name with a @ before it, for example @Schaltzeit, so that this can be replaced with the corresponding language table entries in Runtime.

In the list field of this tab all available column types are displayed. With the help of a checkbox you decide which column types are displayed. You can change the description and the width of each column type by left-clicking the corresponding area and entering the desired value in the input field.

Parameters | Description
Column type | Type of the column. Cannot be edited. The display in the Runtime is activated or deactivated with the help of a checkbox.
Description | Defines the header of the respective column. You can configure it as language switchable. The value can be edited.
Width | Defines the width of the column in pixels. You can also define the width of the column by clicking and dragging the column with the mouse in the list with the horizontal display of the column names. The value can be edited.
Move selected entry up | Moves the selected column up. You can also move the columns with drag&drop.
Move selected entry down | Moves the selected column down. You can also move the columns with drag&drop.
Field with horizontal display of the column names | Shows the columns which are active in the list. You can define the size of the columns by clicking and dragging the column borders with the mouse.

attention Attention

The column width is dependent on the used font. If the column width is not a multiple of the character width of the used font, the actual column width can differ from the set column width.


Switching operations preview in the Runtime

Manual -> Load Management -> Setting load management parameters -> Engineering switching operations preview -> Switching operations preview in the Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Runtime screen Switching operations preview displays the upcoming switching operations with date and consequence:


Internal state of the components

Manual -> Load Management -> Internal state of the components

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Internally in the Load Management different states for the components are carried along. This states can be shown using a variable. We recommend to monitor the states with reaction matrix and e.g. to evaluate them in the Chronological Event List.

The variable Internal switching state of components can take on the following values:

General reasons (valid for all components)

Value | Description
0 | Not used (Booting).
100 | Service is possible.
101 | No switching request of the peak load forecast.
102 | Deactivated until the end of the rate interval.
103 | The switching forewarn command is invalid.
104 | Not enough time in order to forewarn.
105 | The forewarn time has not yet expired.
106 | It is not possible to add output at the end of the rate interval because of the parameterization.
107 | The switching state cannot be detected.
200 | Delay time has not expired yet.
201 | Component is set to "not available.
202 | Availability message is invalid.
203 | No variable is defined in order to determine the operation state.
204 | Parameterization is faulty.
205 | Dead time has not expired yet.
206 | Report of the current switching state is invalid.
207 | No data for the gliding average value of the output are available yet.
208 | Current output value is invalid.
209 | Is set to "implicit" (schedule medium-term).
210 | Text address or value for switch-on priority is invalid.
211 | Text address or value for switch-off priority is invalid.
212 | Blocking time is active, blocking time type OFF.
213 | Blocking time is active, blocking time type ON.
214 | Maximum number of switchings has already been reached.
215 | Switching command cannot be used.
216 | Minimum switching time has not been reached yet.
217 | Schedule data have not been written completely yet.
218 | General problem.
219 | Command variable cannot be used for switching.
220 | No command defined for sending the switching forewarning.
221 | Extended parameterization for minimum power-on time per time unit not valid.
222 | Because of other restrictions, it is not possible to stick to restriction "Adhere to minimum power-on time per time unit".
223 | Switched on implicitly because of "minimum switch-on time per time unit".
250 | Variable or value for minimum switch-on time is invalid.
251 | Variable or value for minimum switch-off time is invalid.
252 | Variable or value for maximum switch-on time is invalid.
253 | Variable or value for maximum switch-off time is invalid.
254 | Restrictions are not reasonable.

Reasons for storage

Value | Description
4000 | Current filling level value is invalid.
4001 | Current roll out (actual value) is invalid.
4001 | Roll out is implicit because of the manual set value.
4003 | Storage capacity limited because of filling level limit.
4004 | Storage is full.
4005 | Set value for storage is not defined.
4006 | Maximum roll in capacity and maximum roll out capacity are both 0.
4007 | Variable which is used to measure the current filling level is invalid.

Reasons for CHPs (generator)

Value | Description
5000 | The current output does not comply with a level output.
5001 | CHP does not run below nominal power.
5002 | The CHP only has one level can cannot be switched.
5003 | The CHP runs with nominal power and cannot be switched down further.
5004 | The highest switched on level cannot be switched off because of the minimal switch-on time per time unit.
5005 | The CHP is already running on its highest level.
5006 | The variable which is used to measure the current output is invalid.
5007 | The forewarning for a level was activated. Waiting for set value input.
5008 | The variable for the set value is invalid.
5009 | The order of the output guidelines by variables is not ascending.
5010 | The value of a parameterized maximum switch-on time of a level is too small.
5011 | Maximum running time of a level has been reached. The level is switched off.


Creation of the Runtime files

Manual -> Load Management -> Creation of the Runtime files

After engineering the functions Start Load Management or Stop Load Management a consistency check of the EMS engineering is carried out during the creation of the Runtime files. If problems occur, a corresponding message is displayed in the output window (e.g. if necessary variables were not allocated).

Runtime does not start

If a project cannot be started in the Runtime, it can have the following reasons:

  • wrong engineering
  • missing license: With the function Start Load Management the license is checked. If the license is not available, the Load Management does not start and a corresponding entry is generated in the log.


Operating load management in Runtime

Manual -> Load Management -> Operating load management in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Screens of the Load Management make it possible to monitor the prognosis and the optimization during the Runtime in form of a trend screen.

The single operating elements are positioned in the screen with the help control elements (prognosis area and the display of the current supply area).

For example a prognosis can look like this:

Digit | Description (properties of the supply area)
1 | Previous tariff interval
2 | Current tariff interval
3 | Supply limit
4 | First switching value
5 | Estimated final consumption
6 | Current average consumption value
7 | Start value of estimation
8 | Last switching value
9 | Estimated error range
10 | Forecast average value

info Information

The screen in Runtime only serves for the display of optimization and prognosis data. No interventions can be carries out in the screen. Parameters of the Load Management module are exclusively controlled via variables.


measuring unit conversion

Manual -> measuring unit conversion

measuring unit conversion enables conversion and switching of base units into conversion units, for example meters into yards or meters into decimeters, centimeters and millimeters. A base unit contains the initial value for a conversion. The conversion measuring unit contains the converted value in relation to the base value. Both have a unit name. A Factor, a Offset and a Shift of the decimal point can be defined for conversion units, based on the relevant base unit.

A base unit can be selected when setting parameters for a variable. It is possible to switch between the different units during runtime using the Unit switching function.

tutorial License information

Part of the standard license of the Editor and Runtime.

Context menu Project manager

Menu item | Action
New base unit | Creates a new base unit.
Export XML all | Exports all entries as an XML file.
Import XML | Imports measuring units from an XML file.
Help | Opens online help.

info Information

You must not use the unit conversion together with the variablerw Report function. This Report function provides a unit conversion for older projects. If the unit defined in the measuring unit conversion of a variable is changed by the report function in Runtime, you must carry out the configuration in the measuring unit conversion again.


Units detail view of toolbar and context menu

Manual -> measuring unit conversion -> Units detail view of toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu units detail view

Menu item | Action
New base unit | Creates a new base unit.
Export XML all | Exports all entries as an XML file.
Import XML | Imports measuring units from an XML file.
Help | Opens online help.

Context menu and tool bar base unit/conversion unit

Menu item | Action
New base unit | Creates a new base unit.
New conversion unit | Creates a new conversion unit for the superordinate base unit.
Linked elements: Jump back to starting element | Drop-down list with link back to the element from which you can reach the measuring unit. Only available if the unit is linked to another element.
Rename | Makes it possible to rename the unit. Attention: If units are renamed, all measuring units that are already linked to variables or used in functions must then have the respective variable or command amended manually. See also: Allocate a base unit to a variable Measuring Unit conversion function.
Export XML all | Exports all entries as an XML file.
Import XML | Imports measuring units from an XML file.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of".
Delete | Deletes selected entries.
Help | Opens online help.


Engineer measuring units

Manual -> measuring unit conversion -> Engineer measuring units

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You must create a base unit and a conversion unit for the conversion, as well as defining the parameters for conversion. The conversion is carried out using the formula y=kx+d (Austria) or y=mx+b (Germany). Each base unit can be allocated to a variable as a measuring unit.

To create a new base unit:

  • select the measuring units node in Project Manager
  • right-click on measuring units
  • select the New base unit command from the context menu
  • a new entry is created in the list
  • give the measuring unit a name
  • create the conversion unit

To create a new conversion unit:

  • right-click on a base unit
  • select the Conversion unit command from the context menu
  • a new entry is created in the list
  • give the unit a name
  • define a Factor for the conversion
  • define a value for the Shift of the decimal point
  • define a value for the Offset


Allocate a base unit to a variable

Manual -> measuring unit conversion -> Allocate a base unit to a variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Base units are allocated to a variable in the Measuring unit property (General node).

You are free to name units as you wish here. If the measuring unit conversion is used during runtime, select a pre-defined basis unit from the drop-down list.

Hint: If you give it a name of your choice, it is best to create a link with the same name straight away in Node units - the basic unit.

You must create a Unit conversion function in order to be able to convert during runtime.

attention Attention

If a measuring unit is subsequently renamed, variables already linked to this are not automatically renamed.

To rename measuring units already linked:

  • select detail view in Project Manager
  • select the measuring units column or add this to the view if it is still displayed
  • in the context menu, select the Text command in Replace selected column
  • In the opening dialog, search by name and replace it with the new name


Function measuring unit conversion

Manual -> measuring unit conversion -> Function measuring unit conversion

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to carry out measuring unit conversion in the Runtime, create function unit conversion:

  • select the Functions node in Project Manager
  • in the context menu, select the command New function...
  • navigate to the variable
  • Select the measuring unit conversion function

    Note: The execution of function Unit conversion triggers a refresh of the report if it is displayed at the moment.

  • The dialog for the definition of the measuring unit conversion opens.

Property | Description
Unit conversion | Dialog for the allocation of conversion units to basic units.
Base unit | List of the created basic units.
Switch to | Drop-down list for the selection of the conversion unit. You can either select a conversion unit or the basic unit. Engineered conversion unit: In the Runtime the basic unit is converted to the conversion unit. <Base unit>: The basic unit is still active in the Runtime.

info Information

The units are not exported with the XML export of this function. You must export the units separately.

attention Attention

If a measuring unit is renamed afterwards, the renamed basic unit is automatically taken into consideration in the function. However you must change the conversion units manually.


Runtime

Manual -> measuring unit conversion -> Runtime

Each variable value for each input or output in addition to those used as standard when converting signal units to measuring range units is converted in runtime.

  • Output: A conversion unit for a variable is activated with the Unit switch function. The value in measuring units is subject to the pre-defined offset and factor. In addition, to convert the value into a string, the number of decimals set for a variable is corrected accordingly.
  • Input The conversion is carried out along the lines of output in the other direction.

Limitations:

  • At the export the new units are exported.
  • Values that are saved as a string are not recalculated for output. These values remain in the measuring unit that was active at the time of creating the string. This particularly affects all values inserted into the text of a CEL entry, such as "Set value changed from OLD to NEW" etc.
  • Operating hours and operations counters in Industrial Maintenance Manager are always displayed in base units here.
  • Outputs in the EMS screen are always displayed in the base unit.

VBA

Values above VBA are always accessed in base units. For example, Variable.Value does not provide a value with units switched, because it is not a value output. 4 new functions have been incorporated into Variable. so that unit switching can also be used above VBA:

Keyword | Description
SecondaryUnitName | gives the name of the conversion unit set
SecondaryUnitDigits | gives the decimals for the conversion unit set
CalcSecondaryUnitValue | converts the value of the base unit into the value of the conversion unit
CalcPrimaryUnitValue | converts the value of the conversion unit into the value of the base unit


Menus

Manual -> Menus

Windows-compliant menus are created in the menu editor. Two different types of menus are available:

  • Main menus
  • Context menus

Note: The operating system does not allow separate menus for single screens or frames.

tutorial License information

Part of the standard license of the Editor and Runtime.

Context menu Project manager

Menu item | Action
New main menu | Inserts a new main menu in the menu list of the detail view.
New context menu | Inserts a new context menu in the menu list of the detail view.
Export XML all... | Exports all entries as an XML file.
Import XML | Imports entries from an XML file.
Editor profile | Opens the context menu with pre-defined Editor profiles.
Help | Opens online help.


Engineering in the Editor

Manual -> Menus -> Engineering in the Editor

Select menu item Project Manager in order to open the menu editor in detailed view. You can chose from main and sub menus. With the context menu (entry Main menu new or Context menu new) you can create new menus. They then are displayed in the right part of the detail view. Menus can be imported and exported. You will find more information in chapter Import / Export / Menus.

attention Attention

Requirement if main menus should be displayed in Runtime: The Main menus active (NodesGraphical design) property must be activated in project properties.

Create new menu item

To create a new menu item:

  1. Highlight the last entry
  2. Confirm this with the Enter key
  3. A new empty input field is created

Create new sub-menu

To create a new sub-menu, activate the Submenu property in the superordinate menu item. A new entry field is thus opened for the sub-menu.

Move menu item

  1. Highlight the desired item (multiple selection is possible)
  2. Hold down the left mouse button and move it to the new position
  3. Note: If you move sub-menus to a menu item that is not defined as a sub-menu, the items are created as main menus.
    If you move the uppermost item, all sub-menus are moved with it.

Copy menu item

  1. Highlight the desired item (multiple selection is possible)
  2. Select Copy in the context menu or in the tool bar
  3. Select the save location for the copy

    Note: If you copied sub-menus to a menu item that is not defined as a sub-menu, the items are created as main menus.
    If you copy the uppermost item, all sub-menus are copied with it.

  4. Select Insert in the context menu or in the tool bar
  5. Hold down the left mouse button and move it to the new position

Rename menu item

  1. select the menu item and edit it via:
    • Double-click or delayed double-click on the entry
      or
    • press key F2 or key Return when the entry is selected
      or
    • select command Rename in the context menu or from the tool bar
  2. the current entry is highlighted
  3. Enter the new name
  4. confirm the change via:
    • Pressing key Return
    • switch to another menu item
  5. or cancel the changes by pressing Esc

Multiple selection

To edit several entries at once

  • press and hold Ctrl and click on the entries

    or

  • press and hold Shift and click on the entries

    or

  • press and hold Shift and use the arrow keys of the keyboard

To deselect an entry, click on the entry while still holding Ctrl or Shift.

To deselect all entries and only select a single entry, click on the desired entry.


Tool bar and context menus for detail view and details

Manual -> Menus -> Engineering in the Editor -> Tool bar and context menus for detail view and details

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tool Bar

Menu item | Action
New main menu | Inserts a new main menu in the menu list of the detail view.
New context menu | Inserts a new context menu in the menu list of the detail view.
Create standard function | Opens the dialog for selecting an action and creates a suitable function. The action is documented in the output window.
Jump back to starting element | If you entered the list via function linked elements, the symbol leads back to the start element. Only available in the context menu when all linked elements are opened.
Copy | Copies the selected entry to the clipboard.
Paste | Pastes the contents of the clipboard.
Delete | Deletes the selected entry without confirmation.
Export selected XML | Exports selected entries as an XML file.
Import XML | Imports entries from an XML file.
Rename | Opens menu item for renaming.
Properties | Opens the properties window for the selected entry.
Help | Opens online help.

Context menu Runtime menus

Menu item | Action
New main menu | Inserts a new main menu in the menu list of the detail view.
New context menu | Inserts a new context menu in the menu list of the detail view.
Paste | Pastes copied menu entry into the corresponding branch (Main menus or Context menus) as Copy x of, whereby x is a consecutive number.
Help | Opens online help.

Context menus main menus

Menu item | Action
New main menu | Inserts a new main menu in the menu list of the detail view.
Paste | Pastes copied menu entry of a main menu as copy x of, whereby x is a consecutive number.
Help | Opens online help.

Context menus context menus

Menu item | Action
New context menu | Inserts a new context menu in the menu list of the detail view.
Paste | Pastes copied menu entry of a context menu as copy x of, whereby x is a consecutive number.
Help | Opens online help.

Context menus menus

Menu item | Action
Create standard function | Opens the dialog for selecting an action and creates a suitable function. The action is documented in the output window.
Linked elements | Lists linked elements. Clicking on the entry opens the linked element in the Editor.
Copy | Copies the selected entry.
Paste | Pastes copied menu entry as copy x of, whereby x is a consecutive number.
Delete | Deletes the selected entry without confirmation.
Export selected XML | Exports selected entries as an XML file.
Import XML | Imports entries from an XML file.
Properties | Opens the properties window for the selected entry.
Help | Opens online help.

Context menu details

Menu item | Action
Rename | Opens menu item for renaming.
Create new in front of selected | Adds a new menu item in front of the highlighted menu item.
Copy | Copies the selected menu item to the clipboard.
Paste | Pastes the contents of the clipboard.
Delete | Deletes the selected menu item without confirmation.
Properties | Opens the properties window for the menu item.
Help | Opens online help.


Define entries

Manual -> Menus -> Engineering in the Editor -> Define entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Generally there are three types of menu entries:

Parameters

Description

Action type

Sets out which type of action is to be carried out via the corresponding menu item in Runtime. Not all action types are available in the main menu, some are only available via the context menu.

  • Acknowledge alarm (context menu only)
  • Command input (context menu only)
  • Acknowledge flashing (context menu only)
  • Function
  • Help
  • No action
  • Send value to hardware
  • VBA macro (context menu only)

Submenu

Opens a sub-menu in Runtime.

Separator

A horizontal line divides menu entries.

Underline text: Entering a & causes the following characters to be displayed as underlined.

Plan entries

To configure a menu item in the main menu or context menu:

  1. Activate the corresponding menu cell
  2. In properties, select:
    • Action type: depending on menu type
      see also: Main menu action types and Context menu action types
    • Menu ID: Entry ID
      Note: There are pre-defined types with a fixed ID available in the command input at Command input
    • Text: clear labeling of the menu cells

attention Attention

The name of the Text property must be unique. If two names the same are issued, further menu items with the same name are not displayed.


Main menu action types

Manual -> Menus -> Engineering in the Editor -> Define entries -> Main menu action types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Parameters | Description
Function | A defined function of zenon is executed by selecting the menu entry in the Runtime.
Help | A help chapter from a CHM file is displayed.
No action | No action is executed.
Setting values | By selecting menu item Setting values a fixed value can be send or a variable value can be increase or decrease by a fixed amount during Runtime. The entry is made with the help of the zenon standard dialog box. If one of the 3 keyboard screens (SETVALUEKBD, SETBOOLKBD or SETSTRINGKBD) is available in the project, it is automatically used. For this action a variable can be selected directly, or if used in a context menu the variable can be selected from the clicked element.


Action types context menu

Manual -> Menus -> Engineering in the Editor -> Define entries -> Action types context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Parameters | Description
Function | A defined function of zenon is executed by selecting the menu entry in the Runtime.
Help | A help chapter from a CHM file is displayed.
No action | No action is executed.
Setting values | By selecting menu item Setting values a fixed value can be sent or a variable value can be increased or decreased by a fixed amount during Runtime. The entry is made with the help of the zenon standard dialog box. If one of the 3 keyboard screens (SETVALUEKBD, SETBOOLKBD or SETSTRINGKBD) is available in the project, it is automatically used. For this action a variable can be selected directly, or if used in a context menu the variable can be selected from the clicked element.
VBA macro | A VBA macro is executed by selecting the menu entry in the Runtime. You can only select the VBA macros which are declared as Init event.
Alarms: Acknowledge | The alarms of all variables linked to the dynamic element that the context menu relates to are acknowledged.
Acknowledge flashing | Switches off the blinking of all alarms for variables that are linked to the dynamic element, which the context menu relates to. The alarms are not acknowledged by this.
Command input | Opens the defined command input window (only with an energy license)


Command Processing

Manual -> Menus -> Engineering in the Editor -> Define entries -> Action types context menu -> Command Processing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When creating a new action in the Command Processing, a menu ID corresponding to the action type and the switching direction for the Action type property is created and offered in the drop-down list. If the content corresponds to an ID defined as standard text for the action type and switching direction, the content is adapted if the action type or switching direction change.

To create a context menu for the command:

  1. Create the desired actions in the command
  2. Select Action type in the properties of the context menu item as a command
  3. Select the desired action and switching direction via the drop-down menu with the Menu ID property
  4. Give it a clear label in the Text property
    Note: If no entry is defined for Text, the field is automatically filled with the "command" label.

attention Attention

The name of the Text property must be unique. If two names the same are issued, further menu items with the same name are not displayed.

Because automatically created menu items with the same action result in the same text, there are macros available for these.

The character sequence ID_CMD_AUTO is reserved for automatically created menu items. These must always be used with macros, because otherwise only the menu item is inserted.

When checking for duplicate entries the following rules apply:

  • Manual menu points have priority over automatic ones.
  • If it is the same type then the last entry has twice the priority.
  • If a duplicate entry is found, a warning is set off in the log. This includes the menu ID and description. Automatically expandable entries have <auto> added to the ID.

Actions for Action type command

Action | Switching direction | Menu ID
ID_CMD_AUTO |  | This menu entry automatically shows all possible actions for an element, if no direct menu entry from the list is used already.
Pulse command | On (1) | ID_CMD_EBEF_ON
Pulse command | OFF (1) | ID_CMD_EBEF_OFF
Pulse command | NONE | ID_CMD_EBEF_NONE
Switching command | On (1) | ID_CMD_DBEF_ON
Switching command | OFF (2) | ID_CMD_DBEF_OFF
Switching command | NONE | ID_CMD_DBEF_NONE
Set value | NONE | ID_CMD_SVALUE
Set value | DIRECT | ID_CMD_SVALUE_DIR
Status input | NONE | ID_CMD_STATE
Status input | On (1) | ID_CMD_STATE_ON
Status input | OFF (0) | ID_CMD_STATE_OFF
Replace | NONE | ID_CMD_REPL_NONE
Replace | On (1) | ID_CMD_REPL_ON
Replace | OFF (0) | ID_CMD_REPL_OFF
Replace | DIST | ID_CMD_REPL_DEF
Replace | DIFF | ID_CMD_REPL_DIFF
Manual correction | NONE | ID_CMD_UPD_NONE
Manual correction | On (1) | ID_CMD_UPD_ON
Manual correction | OFF (0) | ID_CMD_UPD_OFF
Manual correction | DIFF | ID_CMD_UPD_DIFF
Manual correction | DIST | ID_CMD_UPD_DEF
Manual correction | DIRECT | ID_CMD_UPD_DIR
Block | NONE | ID_CMD_BLOCK
Release | NONE | ID_CMD_UNLOCK
Lock | NONE | ID_CMD_LOCK
Revision | OFF (0) | ID_CMD_REV_OFF
Revision | On (1) | ID_CMD_REV_ON
Mandatory command | On (1) | ID_CMD_FORCE_ON
Mandatory command | Off (0) | ID_CMD_FORCE_OFF
Mandatory command | NONE | ID_CMD_FORCE_NONE
info Information
For more information about using the contexst menus in the Command see chapter Energy Edition in section Context menu Command.


Macros for the context menu

Macros for the context menu

A macro is a defined character sequence that is replaced by another text when menu items are created in Runtime. Virtually all macros can occur more than once per menu item. They can also contain further macros as a result. In doing so, the expansion sequence must be considered. Macros are not case sensitive when configuring menus. If macros contain a macro as a result, the macro must be contained in capitals in the result. The entry is made with $ as a prefix and suffix.

The sequence of the expansion is from left to right in the following priority.

  1. $NOTE$
  2. $TAG$
  3. $REMA<Status>$
  4. $RDIR$
  5. $ALL$
  6. $DIR$
  7. $ACT$
  8. $NOTE$

Macro

Description

$NOTE$

The whole text including the macro is interpreted as a note. If the resulting text is empty, the $ALL$ macro is used.

$TAG$

Is replaced by the identification of the action variable.

The identification can be translated by the online language translation function. If no translation character (@) is contained, the whole identification is highlighted for translation.

$REMA<Status>$

<Status> is a Rema or limit value state, the text of which is used as a replacement.

If the status is not present, the menu item is not displayed.

The limit value text is translated linguistically according to the placement of @ .

The status can be a number between -231 and 231-1. Leading characters and a prefix are permitted. If characters are contained that cannot be converted to a number, or the number is outside the given area, the menu item is not displayed.

$RDIR$

Text for the switching direction from reaction matrix/limit value as in $DIR$ macro, with the exception of:

  • Action Write set value direct
    The text is taken from the rema/limit value of the status, which corresponds to the value of the set point to be set.
  • Action Status on and Status off
    Text is taken from the rema/limit value for the on or off statuses.
  • Action Correct direct
    The text is taken from the rema/limit value of the status, which corresponds to the value of the set point to be set.

$ALL$

Results in Action naming: Switching direction.

Corresponds to the combination of the $ACT$: macro $DIR$

Note: If a context menu is created for the command, the default text is $ALL$, even if the menu already has text configured for it but the action type changes to command.

$DIR$

Switching direction of the action.

$ACT$

Action naming of the action.

$NOTE$

For the last macro, the note macro is again checked and the text to the right of this including the macro is deleted.

If the resulting text is empty or only consists of spaces, the menu item is not inserted.

Automatically created menu items

Automatically created menu items are created as a menu ID with ID_CMD_AUTO. In this case, macros must always be used, because otherwise only a menu item would be inserted.

Compatibility

Previous to version 6.51 text at automatic menu items was ignored. When converting projects that were created with versions earlier than 6.51, the macros $ALL$$NOTE$ are automatically inserted before the configured text. Therefore the menu items behave as before.

Online Language Switch

The labeling for the menu item in the Text property is translated linguistically before macro expansion from the character @.

Note: If, for the $TAGS$ macro, no translation indicator (@) is contained, the complete text is translated.


Graphical design

Manual -> Menus -> Engineering in the Editor -> Define entries -> Graphical design

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The menus can be influenced graphically via the following functions

Parameters | Description
Graphics file | Displays a graphics file in the left area.
Background graphic | A graphics file is used as the background of the menu entry. The alignment can be either in original size or stretched.
Check mark | Displays a check mark in the left area. This check mark has no influence on the availability of the linked functionality but only serves the display. The display and the functionality can only be controlled via VBA/VSTA in the Runtime.
visible | Activated: Menu item is displayed in Runtime and linked functionality is available. The visibility can only be controlled via VBA/VSTA in Runtime.
Separator active | Displays a horizontal dividing line instead of the menu item for logical categorization of the menu. The dividing line can be defined in a width of 0 to 50 pixels and in any color desired.


Submenu

Manual -> Menus -> Engineering in the Editor -> Define entries -> Submenu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create sub-menus:

  1. Activate the property Submenu
  2. A new, empty menu field is created to the right of this
  3. Define the items for the sub-menu or further sub-menus

Sub-menus are shown by an arrow to the right. Sub-menus can also be created as nested sub-menus.


Operating during Runtime

Manual -> Menus -> Operating during Runtime

The menu editor menus correspond to the usual functionality that is common in Windows applications.

Menus are located and fixed in the upper left corner in Runtime.

Note: If there is alarm pending, the alarm line may cover the menus. In this case, the menus can only be operated once the alarms have been acknowledged. To avoid this, plan the alarm status line at a different location or activate frames for the template.


Displays menus in Runtime

Manual -> Menus -> Operating during Runtime -> Displays menus in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To display main menus in Runtime, the corresponding Show menu function must be created and linked.

Context menu are defined in the properties for the respective dynamic elements.

User administration

If user administration is configured for the project, the display behavior of the menu in Runtime can be amended to the user operating authorizations.

info Information

You can read more information about the configuration of user administration in the user administration chapter.

Engineering in the Editor.

  1. Click on the main node of your project.
  2. Go to the User administration property group.
  3. Select the desired behavior in the Locked menu items property.
  4. Assign a Authorization level :
    For the assignment of the respective Authorization level :
    1. Switch to the Authorization property group.
    2. Set the corresponding password level in the Authorization level property.


Displaying main menus

Manual -> Menus -> Operating during Runtime -> Displays menus in Runtime -> Displaying main menus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function controls the display of main menus.

  1. Create a new function with New function
  2. In the Screens node, select the Display menu function
  3. Define the action to be carried out and the main menu

Parameters | Description
Action | Selection of the action:
Show menu | The selected menu is displayed.
Hide menu | The selected menu is hidden.
Change menu | The current menu is hidden and the selected menu is displayed instead.
If no menu exists | The selected menu is displayed, if no menu is displayed at the moment.
Menu | Selection of menu.
Show this dialog in the Runtime | Active: This dialog is opened when the function is carried out in Runtime.
info Information
In the zenon Web Client (Web Server and Web Server Pro) the main menus are not displayed. Under CE (zenon under Windows CE) menus can only be displayed in the standards supported by Windows CE. Colors and fonts different than the Windows colors/fonts cannot explicitly be selected in the menus under CE.

When the standard function is created from the context menu in the detail view, zenon automatically creates the function 'Show menu' for the selected menu.


Displaying context menus

Manual -> Menus -> Operating during Runtime -> Displays menus in Runtime -> Displaying context menus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menus can be used in Runtime for dynamic elements. To display a context menu in Runtime, link the context menu with the desired dynamic element.

To do this:

  1. navigate to the Runtime node in the dynamic element properties
  2. select the Context menu property
  3. select the desired context menu from the drop-down list

attention Attention

Context menus are referenced via their name. This means: If a context menu is renamed, the linking to the dynamic element is lost and must be recreated.


Message Control

Manual -> Message Control

The optional module Message Control allows for an automatic sending and acknowledgement of messages. The sending is triggered via a function which can be linked with an event. Available media for sending include the following:

  • E-mail message via Outlook
  • E-mail message via SMTP
  • SMS message via GSM modem
  • SMS message via SMS gateway
  • Voice message with audio file via modem on telephone
  • Voice message text-to-speech via modem on telephone

The status of this transmission is logged in the Chronologic Event List (CEL).

The configuration takes place in two stages:

  • General settings for sending: in the properties of the Message Control group of the workspace.
  • Project-specific settings: in the properties of the Message Control node in the respective project.

tutorial License information

Must be licensed for Editor and Runtime (single-user, server, standby). Not available for clients.

Context menu project-specific settings in project manager.

Menu item | Action
Help | Opens online help.


Compatibility with version 6.xx

Manual -> Message Control -> Compatibility with version 6.xx

Changes in version 7 compared to older versions

As of version zenon 7.00 SP0 module Message Control differs basically from earlier versions in terms of technology and configuration.

Important technical changes:

  • COM Server is no longer used
  • the additional component of company DerDack is no longer used
  • the ZenMsgQueue is replaced by an own screen of type Message Control
  • the configuration is carried out in property Message Control of the workspace (sending) and properties Project-specific settings for module Message Control in the project (project-specific)
  • there is no detail view anymore
  • the shift model and the calendar functionality has been removed
  • there are no Runtime changeable files anymore
  • Sending e-mails is possible via Outlook or a SMTP Server whereas SMTP allows the sending of attachments
  • the configuration of the sending type is no longer saved in file message32.ini but in file zenon6.ini
  • Evaluating the limit texts: Up to now the evaluation of compound texts in module Message Control differed from the evaluation of standard limit texts. From version 7.00 on both are evaluated in the same way. @StringTabelle+%var1

You can find details about the configuration in chapter Configure Message Control.

attention Attention

Only projects from version 5.50 SP7 on can be converted to version 7.

Conversion

Due to the profound changes a 100% compatibility cannot be guaranteed for the conversion. This is also true for compiling RT files for older versions. At converting especially take care for:

  • User:
    • Users with the same name (first name, last name) existing: User is used and information is added.
    • No according user available: A new user is created. The link to the replacement and to the user group is resolved. The user is added to the existing or at the conversion to the created group.
  • User groups:
    • User group with same name exists: User group is used and information is added.
    • No according user group available: A new user group is created.
  • Functions:

    Show recipient-database function was removed.
    This function can no longer be created with the Editor. At the conversion it is not deleted however. Its call up in the Runtime has no effect and creates a log entry.

  • Paging:
    Paging is no longer available as sending type. Existing functions with sending type Paging are changed to sending type GSM at the conversion. A message in the output window indicates this. After the conversion you must check the settings of the function.
  • RT changeable files:
    Because the user administration was changed, RT changeable files are no longer required for Message Control. There is no possibility in version 7 to read back old Runtime data. If the Runtime files of a project prior to version 7 are needed, you must read them back in an Editor prior to zenon 7 and then converted.
  • Shifts and calendars:
    The functionality for shifts and calendars was removed. Existing functions with target type Shift are changed to target type Group at the conversion. However no group is linked. A message in the output window indicates this. After the conversion you must check the settings of the function.
  • SMS-Gateway:
    As the simple interface does not offer a technical possibility to assign messages distinctly, from version 7 on only the enhanced interface is supported. At conversion you must make sure that the SMS Server from company Dialogs is configured correspondingly. Otherwise the sending fails.

Import and export

Previous versions of message control and versions from zenon 7.00 SP0 on save their settings in different files:

  • up to 6.51 SP0:
  • from version 7.00 SP0 on: zenon6.ini

Import settings

If a previous version of zenon is opened in version 7 or higher the settings from the previous message32.ini are taken over and adapted as far as possible. The configuration always has to be checked manually since not all settings can be converted 100% correctly. For instance, shift schedules are assigend to groups which have to be further configured.

Export settings

The configuration can be written from version 7 to the message32.ini for previous versions. To do so, click on the global working area property Message Control/Export settings to Messag32.ini (v6.XX) and confirm the security query.

Attention: By executing the property Export settings to Messag32.ini (v6.XX) all corresponding entries in message32.ini are overwritten. For this reason the INI file might contain entries which cannot be carried out in the present module message control or which disable configurations.


Requirements

Manual -> Message Control -> Requirements

The requirements for using Message Control depend on the desired transmission media:

Medium

Requirement

E-mail message via Outlook:

Running Microsoft Outlook instance

E-mail message via SMTP:

The Runtime server executing the sending must be connected to a network.

An e-mail account must be available. The servers with access to the account must be available.

SMS via GSM:

A GSM modem must be connected to the computer and must be approachable via a serial port (COM port). Usually USB modems create a virtual COM port during the installation through which they can be approached.

SMS message via SMS gateway:

SMS server of DIALOGS Software GmbH

Speech output:

Voice modem with DTMF functionality.

Text-to-speech engine. (Partially contained in operating systems. Extendable by a separate text-to-speech package from COPA-DATA.)

Telephone:

Voice modem with DTMF functionality.

If an ISDN adapter is used it must support the following functions.

  • Support of voice messages (LINEMEDIAMODE_AUTOMATEDVOICE)
  • Support of DTMF signals (for receiving the PIN code when acknowledging a message)
  • Support of Telephony Application Programming Interface (TAPI)

Limitations

  • This module is not available under Windows CE.


Supported AT commands

Manual -> Message Control -> Supported AT commands

Message Control supports the following AT commands:

Goal | Command | Answer | Comment on the response.
Connection test: | AT\r | \r\nOK\r\n | at the end
Query PIN status | AT+CPIN?\r | +CPIN: | At a desired point in the response plus \r\n at the end
Enter PIN: | AT+CPIN="[PIN-Code]"\r | \r\nOK\r\n | at the end
Switch modem to SMS-PDU mode: | AT+CMGF=0\r | \r\nOK\r\n | at the end
Set the telephone number of the SMS message center: Note: With an SMSC number, set the country code too (00xy or +xy; xy stands for the corresponding figures). | AT+CSCA="[SMSC telephone number]"\r | \r\nOK\r\n | at the end
Check to see if the modem has switched to SMS-PDU mode: | AT+CMGF?\r | \r\nOK\r\n | at the end
Check to see if the modem has set the given SMS message center: | AT+CSCA?\r | \r\nOK\r\n | at the end
Send message to this number. Modem signalizes Ready for PDU if the command was accepted: | AT+CMGS="[PDU-length]"\r | \r\n>[space] |
PDU for the SMS to be sent to the number specified previously with completion flag: | [SMS-PDU][0x1A] | \r\nOK\r\n | at the end
List SMSs from the memory with status set by flag: | AT+CMGL=[Flag]\r | \r\nOK\r\n | at the end
Delete all SMSs with status set by flag from the memory (regardless of index): | AT+CMGD=0,[Flag]\r | \r\nOK\r\n | at the end
Delete SMS with the given index from the memory: | AT+CMGD=[Index]\r | \r\nOK\r\n | at the end

Note: For AT+CMGD commands, it is sufficient if one of the two versions is supported.

Arguments:

  • \r --> Carriage Return --> 0x0D
  • \n --> Line Feed --> 0x0A

Error search

Error messages contain the notice ERROR in the response. You can find details on troubleshooting and testing the connection in the Messages and error handling chapter.


Configure Message Control

Manual -> Message Control -> Configure Message Control

Message Control is configured via:

  • global properties of the media for sending
  • project-specific properties for the message
  • Functions which are executed in Runtime for sending and management of messages

Messages can be sent and acknowledged as:

  • E‑email
  • SMS
  • Voice message

Configuring the sending of a message

In order to configure the sending of a message:

  1. Select the medium for sending.
  2. Activate the Sending mode active property for this medium.
  3. Configure the medium.
  4. Configure the project-specific properties.
  5. Configure the users or user groups that are to be reached via the medium.
  6. Create a Send message function and

    link the function:

    1. with a button or
    2. with the property Function in case of limit values which are supposed to send this message in case of violations

      For linking with a limit value, content that is dynamically generated in Runtime can be sent. In order to use several Send a Message functions for a limit value, use a script that contains these functions and is linked to the limit value.

Configuration of the message

A message is composed of several parts:

  • Subject: defined for e-mails using:
    • Subject (ID) in the global settings for Outlook
    • Subject for outgoing e-mails in the global settings for e-‑mail message via SMTP
    • Dynamic part of the subject property in the project-specific settings for e-‑mail via SMTP or Outlook
  • Welcome and misentry: is defined for language messages using:
    • Voice message text-to-speech via modem

      or

    • Voice message audiofile via modem
  • Message text: defined for e-mails, SMS and voice messages in:
    • the Option Constant Text

Configure the administration of the message queue

In order to administrate messages in the Runtime:

  1. create a screen of type Message Control
  2. create and configure a function Screen switch for this screen.
  3. link the function to a button

By doing so in Runtime messages can be checked for their status and the message queue can be supervised.

Message Control in Runtime

In order to use Message Control in Runtime:

  1. activate Message Control via
    • Active during Runtime start property Once this property is activated Message Control will automatically start in Runtime.
    • Function Send Message: activate: If this function is carried out Message Control is started. Messages are only processed from this point of time on.

During normal closing of Runtime an image of the current message queue is saved. This image can also be created anytime in Runtime using the Save current queue function. Message Control can be closed with the function Send Message: deactivate in Runtime.

Suppress message

Message Control has a list of deactivated elements. Deactivated means that their alarms do not trigger a message.

If during a violation of limit values the function Send Message is linked the messages are only created and sent if neither variable nor alarm are suppressed.

  • The variable is suppressed if its area or a linked equipment group is contained in the list of suppressed elements.
  • The alarm is suppressed if the alarm/event group, the alarm/event class or the alarm area is contained in the list of suppressed elements.

This list can be modified with the function Suppress groups/classes/areas/equipment in Runtime. Alarms and equipment can be activated or deactivated. Suppressed entries are logged in the CEL provided for the property Log in CEL all confirmations or only negative confirmations was selected.

Activating or deactivating entries is carried out remanently in the network. If for instance for maintentance purposes the alarms of an equipment section are switched off this setting will remain active even after closing Runtime and will be re-applied during a restart.


General settings for sending

Manual -> Message Control -> Configure Message Control -> General settings for sending

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The media used employed for sending the messages are globally defined and can be used by every project and every working area.

Available media for sending include the following:

  • E-mail message via Outlook
  • E-mail message via SMTP
  • SMS message via GSM modem
  • SMS message via SMS gateway
  • Voice message audiofile via modem
  • Voice message text-to-speech via modem

In order to configure the properties:

  1. highlight the working area
  2. select the Message Control group in properties
  3. activate and configure the desired media types

The settings in zenon6.ini are saved in the area [Message Control].

attention Attention

These properties of the Message Control group in the workspace are not project-specific. Changes to this area are only effective in Runtime after it has been restarted.


E-mail message via Outlook

Manual -> Message Control -> Configure Message Control -> General settings for sending -> E-mail message via Outlook

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to send a message as e-mail via Microsoft Outlook it is required that:

  • the sending mode was activated via the property Sending mode active
  • on the executing computer a running Microsoft Outlook instance with a connection to the network/internet is available

If messages must be acknowledged it has to be taken care that the mailbox is retrieved within the timeframe availablefor acknowledgement. This period of time is defined with the function Send message (tab acknowledgement).

attention Attention

For Outlook, the following applies for use with message control:

  • 32-bit Outlook requires the 32-bit version of zenon.
  • 64-bit Outlook requires the 64-bit version of zenon.

Mixed operation is not possible in any combination.

Configuration

  1. Activate the sending mode via the property Sending mode active.
  2. Define the name of the Outlook profile to be used via the property Profile.
  3. Define an unambiguous subject via the property Subject (ID).
    This subject is the criterion for passing on incoming messages to the module Message Control. E-mails which do not contain this ID are not passed on to the Message Control. It has to:
    • have a length of at least four characters
    • remain unchanged in case of answers
  4. Configure the properties for Project-specific settings.
  5. Configure Users and user groups.
  6. Create required functions and connect them with buttons or events.

Behaviour in Runtime

  1. As soon as the Runtime is started messages are retrieved.
  2. Messages are composed according to the settings and are sent as soon as a corresponding function is carried out.
  3. If a user responds to a message their response is read when the messages are retrieved and is then passed on to Message Control.
  4. Receipt of the message is acknowledged.


E-mail message via SMTP

Manual -> Message Control -> Configure Message Control -> General settings for sending -> E-mail message via SMTP

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to send a message as e-mail via an SMTP server it is required that:

  • the sending mode was activated via the property Sending mode active
  • the executing computer is connected with the mail server
  • an e-mail account is defined
  • the mail server is configured with the access data

If messages must be acknowledged it has to be taken care that the mailbox is retrieved within the timeframe availablefor acknowledgement. This period of time is defined with the function Send message (tab acknowledgement).

Configuration

  1. Activate the sending mode via the property Sending mode active.
  2. Configure the properties for:
    • Incoming mail server
    • Outgoing mail server
  3. Configure the properties for project-specific settings.
  4. Configure Users and user groups.
  5. Create required functions and connect them with buttons or events.

Behavior in Runtime

  1. As soon as the Runtime is started messages are retrieved.
  2. Messages are composed according to the settings and are sent as soon as a corresponding function is carried out.
  3. If a user responds to a message their response is read when the messages are retrieved and is then passed on to Message Control.
  4. Receipt of the message is acknowledged.

Only one thread at a time can open connections. A connection is always opened for the thread requiring it and is closed immediately after exchanging data. While a message is being sent no other thread can retrieve the incoming messages or send messages at the same time. If the incoming messages are retrieved it is also not possible for another thread to start a retrieval or send messages.

If during this procedure an error occurs, such as authentication failed or command not supported, all active connections are closed.

The correct settings for the configuration are available from the provider of the employed e-mail account.

Procedure

Retrieving incoming e-mails

  1. Establishing a connection with the parameterized incoming mail server and the corresponding port.
    If the connection is or is not secure depends on the settings of property Encryption.
  2. All mails in the mail inbox are retrieved by the commands STAT and RETR. It is decided on the basis of the subject whether an e-‑mail is relevant. Not relevant messages are skipped. Relevant messages are forwarded to Message Control and - as long as the Leave read e-mail on server property is deactivated - deleted from the server with the DELE command.
    Note for HTML emails: All HTML control characters are removed on receipt.
  3. The connection is closed by sending the QUIT command and subsequent closing of the connection.

Sending of an e-mail

  1. According to the setting a secure or unsecured connection to the SMTP server is established.
  2. If configured the SMTP authentication is carried out with the AUTH command.
  3. The message to be sent is transferred in MIME format with the SMTP commands MAIL, RCPT and DATA.
  4. The SMTP connection is closed by sending the QUIT command and subsequent closing of the connection.
  5. If there is a POP3 connection this is also closed.


SMS message via GSM modem

Manual -> Message Control -> Configure Message Control -> General settings for sending -> SMS message via GSM modem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For sending a message as SMS via a GSM modem:

  • the sending mode must have been activated via the property Sending mode active
  • a GSM modem must be connected to the sending computer and must be approachable via a serial port (COM port)
    Note: usually USB modems create a virtual COM port during the installation through which they can be approached.
  • The GSM modem probably has to be initialized with a manufacturer software in order to be able to connect to the GSM network.

Configuration

  1. Activate the sending mode via the property Sending mode active.
  2. Select the COM port of the modem from the drop-down menu via the propertyModem connection (serial).
    The correct port is displayed in the system properties of the modem.
    Note: After a reconnection of the modem or a reboot of the computer the modem probably will have to be re-initialized with the manufacturer software before it can be used with Message Control. The COM port may change with a reconnection of the modem or a reboot of the computer.
  3. In the property PIN code enter the PIN for the modem, if required.
  4. Check the connection by clicking Check connection.
  5. Enter the telephone number for the short message center in the property field Number of SMS center.
  6. Configure the properties for Project-specific settings.
  7. Configure Users and user groups.
  8. Create required functions and connect them with buttons or events.

Behaviour in Runtime

  1. As soon as the Runtime is started the connection to the modem is being established and configured.
  2. Messages are being retrieved.
  3. Messages are composed according to the settings and are sent as soon as a corresponding function is carried out.
  4. If a user responds to a message their response is read when the messages are retrieved and is then passed on to message control.
  5. Receipt of the message is acknowledged.
  6. If after retrieving no incomplete multi-part messages are present anymore the messages which were read are deleted at the modem.
  7. During the closing of Runtime the modem is disconnected.

info Information

If the modem is reconnected or the computer rebooted it is recommended to:

  • execute the configuration software delivered by the GSM operator so that the modem is initialized and connects with the network.
  • check in the system control if the modem uses the same COM port again after reconnecting.

Constants, timeouts and parameters

Entry

Value

Description

Timeout for AT commands

10000 ms

The modem has 10 seconds to respond to the transmission of an AT command.

SMS polling interval

20000 ms

Every 20 seconds it is checked if new SMS have arrived and they are being read. If no incomplete multi-part SMS are present anymore all messages which were read are deleted.

COM timeouts

Write: 5 seconds

read: immediate return

5 seconds are available for writing the bytes on the COM port (max. 400 in case of SMS-PDU with maximum size).

During the reading of the COM port the current content of the receive buffer is read and immediately returned.

COM state configuration
  • Baud: 9600
  • Binary mode
  • Parity check: inactive
  • Clear-to-Send and Data-Set-Ready: not controlled
  • Data-Terminal-Ready and Request-To-Send Flow Control: activated
  • Bit per byte: 8
  • Parity: None
  • Stop Bit:1

Standard configuration of a serial port.

Buffer

Limit

Maximum value

Description

Size of send buffer and size of receive buffer for the serial port in byte

4096

The individual PDUs have a maximum size of 400 byte. During the sending of an SMS the individual PDUs are sent one after another.

During receiving all SMS arrived since the last polling interval are retrieved at once as block. Thus the modem can move at least 10 PDUs at once into the receive buffer of the serial port.

Size of the total buffer for conversion and incoming SMS in byte

12288

Since an SMS-PDU occupies a maximum of 400 byte in the receive buffer within one polling interval of 20 seconds a maximum of 30 SMS parts with maximum size can be received with this buffer.

The maximum size of an SMS to be sent is 6144 Unicode characters.


SMS message via SMS gateway

Manual -> Message Control -> Configure Message Control -> General settings for sending -> SMS message via SMS gateway

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For sending a message as SMS via an SMS gateway:

  • the sending mode must have been activated via the property Sending mode active
  • an SMS server of the company DIALOGS GmbH must be present and configured.

Procedure

SMS server configuration

For the correct configuration of the SMS servers, please contact the manufacturer, DIALOGS GmbH.

The following is applicable in order for it to work with zenon:

  • The following folders must be present:
    • Inbox
    • Outbox
    • State
  • zenon moves messages to these folders.
  • The SMS gateway reads and fills these folders.
  • zenon monitors these folders:
    As soon as new messages or information is in them, these are forwarded to Message Control.

Configuration in zenon

  1. Activate the sending mode via the property Sending mode active.
  2. Configure Outbox folder, Inbox folder and State folder.
  3. Configure the First letter of the SMS file.
    This initial letter is unique in the project. If an SMS gateway is used by various projects, for each project a unique prefix must be defined.
  4. configure First letter of the lock/semaphore file: Sets initial letter for the lock/semaphore files. This starting letter is unique in the project. If an SMS gateway is used by various projects, for each project a unique prefix has to be defined.
  5. Configure the property Smart alarming.
    If the property is activated the SMS are treated as follows:
    • all outgoing messages are being checked. If the message starts with the text ALARM!, the message is not sent in the usual format (ID; message) but in the format: ALARM! ID; message.
    • Along with the sending of a message starting with ALARM! the recipient’s mobile phone is automatically switched to "very loud", provided this is supported by the phone.
    • Incoming messages are also checked for this character string.
      If there is a (!) in position 6, the first six characters are cut off and the message is forwarded by Message Control.
  6. Configure the properties for Project-specific settings.
  7. Configure Users and user groups.
  8. Create required functions and connect them with buttons or events.

Behaviour in Runtime

  1. As soon as the Runtime is started messages are retrieved.
  2. Messages are composed according to the settings and are sent as soon as a corresponding function is carried out.
  3. If a user responds to a message their response is read when the messages are retrieved and is then passed on to Message Control.
  4. Receipt of the message is acknowledged.


Voice message audiofile via modem

Manual -> Message Control -> Configure Message Control -> General settings for sending -> Voice message audiofile via modem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For sending a voice message as audiofile:

  • the sending mode was activated via the property Sending mode active
  • one audiofile respectively has to be deposited in the node Files/Multimedia audiofiles for:
    • Greeting
    • Message
    • Failure entry
  • a modem must be connected to the sending computer and must be configured
  • The telephone of the recipient must support DTMF

Procedure

Configuration

  1. Activate the sending mode via the property Sending mode active.
  2. Configure the settings for Time-out and Repeat welcome text.
  3. Select the modem for sending via property Line name.
    Selection from a drop-down menu which lists all modems configured in the system control.
  4. Configure the properties for Project-specific settings.
  5. Configure Users and user groups.
  6. Create required functions and connect them with buttons or events.
  7. This method must be acknowledged.

Behavior in Runtime

  1. A function calls up the dispatch method.
  2. A call is initiated via the modem.
  3. If the call is accepted, the greeting is played back first.
  4. To continue and listen to the message, the PIN code must first be entered.
  5. If the PIN code has been entered correctly, the message is played back.
  6. The message must be acknowledged by the recipient with the respectively valid code:
    • PIN code for confirmation
    • NA code for rejection

In addition, the recipient can:

  • replay the file just listened to by pressing the hash key (#) on the phone
  • Undo the entry by pressing the star key (*).
    In this case the greeting is being played back again


Voice message text-to-speech via modem

Manual -> Message Control -> Configure Message Control -> General settings for sending -> Voice message text-to-speech via modem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For sending a voice message via text-to-speech:

  • the sending mode must have been activated via the property Sending mode active
  • a modem must be connected to the sending computer and must be configured
  • The telephone of the recipient must support DTMF
  • A text-to-speech (TTS) engine must be installed.
  • The corresponding language file must be installed

Language files

Depending on the version of the Editor, (32-bit or 64-bit), the corresponding speech (32-bit-compatible or 64-bit-compatible) must be installed and configured.

To do this:

  1. Close the Editor.
  2. Select the correct speech for the Editor (sapi.cpl):
    • 32-bit-compatible speech for the 32-bit Editor: C:\Windows\SysWOW64\Speech\SpeechUX\sapi.cpl
    • 64-bit-compatible speech for the 64-bit Editor: C:\Windows\System32\Speech\SpeechUX\sapi.cpl
  3. Start the Editor and select the configured speech in the Voice property.

Sequence

Configuration

  1. Activate the sending mode in the Voice message (Text to Speech) section via the Sending mode active property.
  2. Configure the settings for Time-out and Repeat welcome text in the Voice message (Audio file) section
  3. Select the modem for sending in the Voice message (Audio file) section using the Line name property.
    Selection from a drop-down menu which lists all modems configured in the system control.
  4. Define language and voice in the Voice message (Text to Speech) using the Voice property.
    Note: The COPA-DATA sales partner will provide you with additional voices and languages.
  5. Configure the properties for Project-specific settings.
  6. Configure Users and user groups.
  7. Create required functions and connect them with buttons or events.
  8. This method must be acknowledged.

Behaviour in Runtime

  1. As soon as a function activates the sending mode a call is initiated via the modem.
  2. As soon as the call is answered the greeting and message are replayed.
  3. The message must be acknowledged or rejected by the recipient with the respectively valid code.
    • PIN code for confirmation
    • NA code for rejection

    In addition, the recipient can:

    • replay the file just listened to by pressing the hash key (#) on the phone
    • undo the entry by pressing the star key (*); in this case the greeting is being replayed

info Information

Depending on the operating system and the software installed voices and languages are already provided which zenon can access. The COPA-DATA sales partner will provide you with further voices and languages. Currently available are: German, English (US, UK, Indian), French and Spanish.


zenon6.ini entries

Manual -> Message Control -> Configure Message Control -> General settings for sending -> zenon6.ini entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Message Control is mainly configured via global and project-specific properties. In the zenon6.ini the global properties of the media are displayed in section [Message Control]:

Entry

Description

[MESSAGE CONTROL]

Settings for the module Message Control.

Recommendation: Configuration via the properties of the Message Control group in the workspace including subgroups and the properties of the Project-specific settings group in the Message Control node in the project tree.

GSM_SMS=

Activation of SMS via GMS as sending type.

  • 0: active
  • not 0: inactive

Default: 0

The entry equals entry [GSM] à On in file Message32.ini and is considered at the import/export of the INI setting.

GSM_SMS_COM=

COM port that is used for the connection to the modem.

Default: empty

GSM_SMS_PIN=

PIN code which is used for authentication towards the modem.

Default: empty

GSM_SMS_SMSC=

Telephone number of the message center of the GSM provider.

Default: empty

GSM_BULK_DELETE=

0: all SMSs that have been read are deleted individually

1: all SMSs that been read are deleted at the same time

Default: 0

Outlook=

Email notification via Outlook:

  • 0: inactive
  • 1: active

Default: 0

Outlook_Profile=

Name of the Outlook profile which should be used for sending.

Default: empty

POP_APOP=

Defines whether the APOP command should be used.

  • 1: active
  • 0: inactive

Default: 0

POP_KEEP_MAILS=

Defines whether read e-mails remain on the server.

  • 1: E-mails are not deleted after they were fetched from the server
  • 0: E-mails are deleted after they were fetched from the server

Default: 0

POP_PASSWORD=

Hex dump of the encrypted password for authentication at the incoming server.

Default: empty

POP_POLL_INTERVALL=

Minimum period between two POP3 requests in seconds.

Minimal: 10

Default: 60

POP_PORT=

Defines the used port at the POP3 Server.

Default: 110

POP_SECURITY=

Type of connection protection to the POP3 Server.

  • 0, no security
  • 1: SSLv2 and SSLv3
  • 2: TLSv1

Default: 0

POP_SERVER=

POP3 Server saved.

Default: empty

POP_USER=

User name for the incoming server.

Default: empty

SMSGateway=

SMS notification via SMS gateway:

  • 0: inactive
  • 1: active

Default: 0

SMSGateway_Inbox=

Income folder for sending SMS.

Default: empty

SMSGateway_OriginId=

Sender identification for sending SMS.

Default: empty

SMSGateway_Outbox=

Outgoing folder for sending SMS.

Default: empty

SMSGateway_Prefix=

First letter of the SMS files.

Length: 1 character

Default: F

SMSGateway_SemaphorPrefix=

First letter of the lock file.

Length: 1 character

Default: S

SMSGateway_SmartAlarm=

Smart alarming is used.

Default: 0

SMSGateway_Statusbox=

Folder for the status message at SMS sending.

Default: empty

SMSGateway_TimeOut=

Timeout for outgoing messages in minutes. Defines after what period of time a message is interpreted as "not send successfully".

Default: 60

SMTP_AUTH=

Authentication at the outgoing server.

  • 0, no security
  • 1: log in to the POP3 Server before sending
  • 2: SMTP AUTH

Default: 0

SMTP_OTHER_CREDS=

Defines whether the outgoing server uses different log in data than the incoming server.

  • 0: inactive
  • 1: active

Default: 0

SMTP_PASSWORD=

Hex dump of the encrypted password for authentication at the outgoing server.

Default: empty

SMTP_OUT_ADDR=

Address for outgoing e-mails.

Default: empty

SMTP_POP_MAIL=

Email notification via OP:

  • 1: active
  • 0: inactive

Default: 0

SMTP_PORT=

Defines the used port at the SMTP Server.

Default: 25

SMTP_SECURITY=

Type of connection protection to the SMTP Server.

  • 0, no security
  • 1: SSLv2 and SSLv3
  • 2: TLSv1

Default: 0

SMTP_SERVER=

The SMTP Server entered by the user.

Default: empty

SMTP_SRV_IS_POP=

This entry defines whether the POP3 Server is used as SMTP Server.

  • 1: POP 3 is SMTP
  • 0: POP3 and SMTP are different Servers

Default: 0

SMTP_SUBJECT=

Subject for outgoing e-mails and for detecting whether an incoming e-mail at the server is relevant for the sending type.

Default: MsgCtrl_Alert

SMTP_USER=

User name saved for the outgoing server.

Default: empty

SMTP_USER_IS_ADDR=

Defines whether the user name for authentication towards the outgoing server is used as sender address for outgoing mails.

  • 1: active
  • 0: inactive

Default: 0

Speech=

Notification by text to speech:

  • 0: inactive
  • 1: active

Default: 0

Speech_Name=

Selection of speech and language

Default: empty

Speech_Rate=

Speech speed.

  • Minimum: -10
  • Maximum: 10

Default: 0

Speech_Volume=

Speech volume. Number equals the percent value of the maximum value of the selected speech.

  • Maximum: 100
  • Minimum: 1
  • 0: Number of the operating system is take over without change.

Default: 0

Subject=

Unique ID which incoming e-mails must contain in order to be processed in Message Control.

Default: empty

Telephone=

Notification by audio file:

  • 0: inactive
  • 1: active

Default: 0

Telephone_IgnoreDisconnect=

Behavior in the event of a loss of connection::

  • 1: A disconnection (e.g. recipient ends call) is ignored and the message is played back completely before the line is closed.
  • 0: Message is aborted when the connection breaks.

Default: 0

Telephone_Timeout=

Time in minutes after which a standing condition should be canceled and closed. Time interval must be longer as the time needed for playing back and confirming the message.

Default: 1

Telephone_WelcomeMessageCount=

Number of repetitions for the welcome text.

Default: 5

info Information

As some properties can take over the values of other properties and they remember the values entered last, the values in the INI entry must not always concur with the values of the properties displayed in the Editor. The following entries are concerned if they are displayed as not available:

SMTP_SERVER -> Server address

SMTP_USER -> User identification

SMTP_PASSWORD -> Password

SMTP_OUT_ADDR -> Address for outward e-mails


Project-specific settings

Manual -> Message Control -> Configure Message Control -> Project-specific settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can find the project-specific settings in the node Message Control in the corresponding project. The properties for configuration of the message and its delivery are contained there. General propertiesfor sending media are configured in the properties Message Control of the working area.

Activating Message Control for the project

In Runtime, Message Control can be activated as follows:

  • Active during Runtime start property Once this property is activated Message Control will automatically start in Runtime.
  • Function Send Message: activate: If this function is carried out Message Control is started. Messages are only processed from this point of time on.

Message Control can be closed with the function Send Message: deactivate in Runtime.

Project-specific properties

The following can be set in the project-specific properties:

  • Dynamic part of the subject via the property Dynamic part of the subject: Incoming messages are filtered for this content for forwarding to Message Control.
  • Logging the message via property Log in CEL: In the Chronologic Event List messages can be logged according to different criteria:
  • Confirm all:
    All messages
  • No confirmations:
    No messages
  • Negative confirmations only:
    Only messages that are rejected or not responded to (including repetitions)
    • Positive confirmations only:
      Only messages that have already been acknowledged
  • Marking the message status by means of color and graphics: The column status of the screen Message Control can display the status of a message by means of a graphic and color.
  • Rules for the repetition of interrupted calls

info Information

Rules for interrupted calls:

  • If a call is interrupted without confirmation or a decline and the interruption is not classified as a hardware error, then:
    • The call is not repeated for the same addressee
    • If substitutes or group members who have not yet been messaged are messaged
  • If a call is interrupted by a hardware error, then the call for the same addressee is sent again according to the number of repetitions set in the Max. number of attempts property.

Configuration of the message

It comprises:

  1. Static part: unalterable subject which is defined in the global settings for e-mails.
  2. Dynamic part: project-specific part of the subject. Is defined with the property Dynamic part of the subject.

Structure of the dynamic part of the subject:

  • Text parts are separated from one another with a semi colon (;).
  • $: marks text that contains the parameter.
  • A parameter can:
    • Be a key from the language table, such as @MyText;
    • Relate to a variable, when executing the function via AML or a limit value breach such as %Var1;
    • Be a compiled entry in the language table: for example %@Var2+MultipleText
  • @ marks language switching
  • % marks variables
  • %% marks limit value text parameters for variables

    A variable can be stated between the two percentage marks.
    If no variable is given, the value relates to the main variable.

    • Messages end with a semicolon (;).

Parameters

In the Runtime

Action

key:

@MyText

A check is made to see if an entry in @MyText is present in the language table for the current language.
  • Existing: entry is added to the message.
  • Not existing: According to the settings of the project properties Display not translated keywords either @MyText or MyText is added to the message.

Variable:

%Var1%

A check is made if the variable exists and the value can be read.

  • Existing: Value of the variable is taken and added to the text as string.
  • Not existing/not readable: The text xxx is added to the message.

Compound entry:

@StringTable+%var1Text

A check is made if:

  • 1. the variable exists and the value can be read. Value is attached to the prefix text ("MultipleText") as string.
  • 2. an entry in the language table exists for the text
  • Variable and text exist:
    text is added to the message.
    Example: Value of the variable is 33. The language table is then checked for @StringTable33 and the corresponding text is added.
  • Not existing: According to the settings of the project properties Display not translated keywords either @MyText or MyText is added to the message.

Example: $@Attention;%Var1;


Create a screen of type Message Control

Manual -> Message Control -> Configure Message Control -> Create a screen of type Message Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With a screen of type Message Control you manage the message queue of a project in Runtime.

To create a screen of type Message Control:

  1. create a new screen
  2. selectMessage Control in the drop-down menu for the screen type
  3. Click in the screen.
  4. select the control elements menu ->Insert template
  5. the control elements are added to the screen
  6. create a function for the screen switching and connect this with a button in order to be able to connect the screen to Runtime

Control elements | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.
Buttons | Buttons for Runtime actions.
Refresh | Refreshes view. The current data are loaded onto the screen from the message queue. The point of time of the last update can be displayed with the field Last update.
Delete | Deletes selected entry from the list. It is only possible to delete messages which have not been sent yet.
Filter | Opens Dialog to configure the filters for the view.
Stop/continue | Starts and stops the cyclic update of the list.
Window | Lists and fields which can be displayed in Runtime.
Number of messages | Number of currently existing messages.
Last Update | Point of time of last update.
Suppressed alarm/event groups | Alarm/event groups for which messages were suppressed and the alarms of which thus are not displayed in the message queue.
Suppressed alarm/event classes | Alarm/event classes for which messages were suppressed and the alarms of which thus are not displayed in the message queue.
Suppressed alarm/event areas | Alarm/event areas for which messages were suppressed and the alarms of which thus are not displayed in the message queue.
Suppressed equipment | Equipment for which messages were suppressed and the alarms of which thus are not displayed in the message queue.
Message queue | List of messages. Contains messages which have been sent, confirmed or deleted or remain to be sent. The messages are only displayed and cannot be edited anymore. Column headings can be named individually and are localizable by putting @ before them.
Filter profiles | Profile administration
Profile selection | Opens the dialog for selecting a profile.
Save | Saves current setting as a profile.
Delete | Deletes profile.
Import | Opens dialog for importing profiles from a file.
Export | Opens dialog for exporting profiles from a file.

info Information

The columns of the list can be confirgured via the Filter for the function screen switching in the Editor, in Runtime via screen switching -> show dialog in the RT or the button Filter. Columns of the list can be provided with individual labels and are localizable.


User administration

Manual -> Message Control -> Configure Message Control -> User administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Users and user groups for Message Control are created and managed in the zenonuser administration. In the user administration the property Message Control user or respectively Message Control group must be active in order to use a user in Message Control.

Users and user groups are referenced by names.

User

Parameters

Description

Message Control User

Active: The user is used by the module Message Control.

Telephone

Number of the voice-compatible telephone device of the user. Used for text to speech.

Enter numbers. In addition, the following are permitted:

  • The prefix + as an abbreviation for 00 of the international area code is permitted.
  • The following separators are also permitted in AD user administration: Minus (-), slash (/) and space
    Note: When communicating between AD and Message Control, separators are ignored as soon as the data from the is mapped to a zenon object.

Cell phone

Mobile phone number of the user. Used for messages via GSM and SMS (text messages).

Enter numbers. In addition, the following are permitted:

  • The prefix + as an abbreviation for 00 of the international area code is permitted.
  • The following separators are also permitted in AD user administration: Minus (-), slash (/) and space
    Note: When communicating between AD and Message Control, separators are ignored as soon as the data from the is mapped to a zenon object.

Email

E-mail address of the user

Substitute person

If a user has not been reached or they do not accept the message, a substitute person can be given. A click on button ... Opens the dialog to select a user.

PIN code

PIN code with which the user confirms the message.

NA code

PIN code with which the user rejects the receipt of the message (not available). The message is then sent to the next user in the list.

If there is no other user entered in the list, the message is entered as "not successfully acknowledged". The function assigned to this is executed. In addition, a "rejected by" CEL entry is created in each case.

Note: You can find further information on the assignment of functions in the Confirmation of receipt - confirmation of receipt settings chapter.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

attention Attention

The acknowledgment codes for PIN (confirmation) and NA (rejection) must differ and should not be too similar.

If both codes are identical the code is interpreted as PIN and therefore as confirmation of the message.

If an unknown code is received, an SMS and e-‑mail is sent to the substitute person. The error message is played back for voice messages.

Sequence within the user group

Users can be sequenced through the property User order within a user group.

Parameters | Description
Users | List of all available users.
Up | Moves selected user up one place.
Down | Moves selected user down one place.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.

For Runtime the sequence of the users from the global user administration is added to the defined sequence in this property. As a consequence, local users are always displayed before global users.

info Information

Get details on the user administration in zenon in the manual User administration.


Functions

Manual -> Message Control -> Configure Message Control -> Functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Functions control the use of Message Control in Runtime.

With this:

  • Message control is activated and deactivated
  • messages are sent
  • the screen of type Message Control is connected for managing the message queue
  • the message queue is saved
  • elements for messages are disabled


Screen switching to a screen of type Message Control

Manual -> Message Control -> Configure Message Control -> Functions -> Screen switching to a screen of type Message Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With a screen switching of type Message Control you access a in for Runtime in order to supervise the message queue. To configure screen switching:

  1. Create a new function
  2. select Screen switch
  3. the selection dialog for the screen is opened
  4. select the desired screen of type Message Control
  5. the dialog for configuring the column settings is opened
  6. configure the columns
  7. close the configuration by clicking OK
  8. connect the function with a button in order to be able to access it for Runtime


Column settings

Manual -> Message Control -> Configure Message Control -> Functions -> Screen switching to a screen of type Message Control -> Column settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Settings for filtering messages

Parameters | Description
List field | Display of the configured columns.
Column selection | Opens dialog to select the columns.
Column Format | Opens dialog to format the columns.
OK | Applies all changes and closes dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Column selection

Manual -> Message Control -> Configure Message Control -> Functions -> Screen switching to a screen of type Message Control -> Column settings -> Column selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column selection

Definition of the columns displayed in the Runtime.

Button | Function
Available columns | List of columns that can be displayed in the table.
Selected columns | Columns that are displayed in the table.
Add | Moves the selected column from the available ones to the selected items. After you confirm the dialog with OK, they are shown in the detail view.
Add all | Moves all available columns to the selected columns.
Remove | Removes the marked columns from the selected items and shows them in the list of available columns. After you confirm the dialog with OK, they are removed from the detail view.
Remove all | All columns are removed from the list of the selected columns.
Up | Moves the selected entry upward. This function is only available for unique entries, multiple selection is not possible.
Down | Moves the selected entry downward. This function is only available for unique entries, multiple selection is not possible.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Column format

Manual -> Message Control -> Configure Message Control -> Functions -> Screen switching to a screen of type Message Control -> Column settings -> Column format

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column format

Formatting of columns.

Configuration of the properties of the columns for configurable lists. The settings have an effect on the respective list in the Editor or - when configuring screen switching - in Runtime.

Available columns

Parameters | Description
Available columns | List of the available columns via Column selection. The highlighted column is configured via the options in the Settings area.

Settings

Parameters

Description

Settings

Settings for selected column.

Labeling

Name for column title.

The column title is online language switchable. To do this, the @ character must be entered in front of the name.

Width

Width of the column in characters.
Calculation: Number time average character width of the selected font.

Alignment

Alignment. Selection by means of radio buttons.

Possible settings:

  • Left-justified: Text is justified on the left edge of the column.
  • Centered: Text is displayed centered in the column.
  • Right: Text is justified on the right edge of the column.

Deactivate column filter in the Runtime

Active: The filter for this column cannot be changed in Runtime.

Note: Only available for:

  • Batch Control
  • Extended Trend
  • Filter screens
  • Message Control
  • Recipegroup Manager

User defined colors

Properties in order to define user-defined colors for text and background. The settings have an effect on the Editor and Runtime.

Note:

  • These settings are only available for configurable lists.
  • In addition, the respective focus in the list can be signalized in Runtime by means of different text and background colors. These are configured using the project properties.

User defined colors

Active: User-defined colors are used.

Text color

Color for text display. Clicking on the color opens the palette to select a color.

Background color

Color for the display of the cell background. Clicking on the color opens the palette to select a color.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Save current queue

Manual -> Message Control -> Configure Message Control -> Functions -> Save current queue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function saves an image of the current message queue. If the Runtime is closed normally this image will be replaced by a valid image of the queue when closing the Runtime. To engineer the function:

  1. Create a new function
  2. in group Message Control select the function Save current queue
  3. connect the function with a button in order to be able to access it for Runtime

This function is always performed at the computer executing the process.


Group/class/area/equipment suppressed

Manual -> Message Control -> Configure Message Control -> Functions -> Group/class/area/equipment suppressed

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Message Control has a list of deactivated elements. Deactivated means that their alarms do not trigger a message. The list can be changed with this function. Alarms and equipment can be activated or deactivated. The projection takes place in the Editor and can be released for changes in Runtime.

If a Limits is linked to a function Send a Message the messages are only created and sent if neither variable nor alarm are suppressed.

  • The variable is suppressed if its area or a linked equipment group is contained in the list of suppressed elements.
  • The alarm is suppressed if the alarm/event group, the alarm/event class or the alarm area is contained in the list of suppressed elements.

Suppressed entries are logged in the CEL provided for the property Log in CEL all confirmations or only negative confirmations was selected.

Configuring functions

To configure the function:

  1. Create a new function
  2. in group Message Control select the function Group/class/area/equipment suppressed
  3. the dialog for configuring the elements to be suppressed or activated is opened.
  4. configure the elements
  5. Close the dialog by clicking on OK.
  6. connect the function with a button in order to be able to access it for Runtime


General

Manual -> Message Control -> Configure Message Control -> Functions -> Group/class/area/equipment suppressed -> General

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters

Description

Alarm/event groups

List of configured alarm/event groups.

Alarm areas

List of configured alarm areas.

Alarm/event classes

List of configured alarm/event classes.

Activate

Active: When activating the function the selected elements are added to the list of suppressed elements.

Deactivate

Active: When activating the function the selected elements are removed from the list of suppressed elements.

Display this dialog in Runtime

Active: When calling up the function in Runtime, this dialog is opened and the user can adjust the configuration before execution.

The dialog is displayed on the current computer in Runtime. During network operation when activating the client the dialog is also displayed on the client

OK

Accepts settings in all tabs and closes dialog.

Cancel

Discards settings in all tabs and closes dialog.

Help

Opens online help.

Selecting elements from a list performed via mouseclick. Multiple selection is possible. A simple mouseclick is enough, it is not necessary to press additional keys. Clicking twice on a selected element deselects the element.


Equipment modeling

Manual -> Message Control -> Configure Message Control -> Functions -> Group/class/area/equipment suppressed -> Equipment modeling

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Property

Description

Toolbar

Symbols to:

  • Edit local equipment models
  • Expand or collapse the display
  • Display of information

List of equipment models

provides models and groups for selection The list separates the display into equipment models from the global project and from local projects.

Local equipment models can be created, edited or deleted.

Add

Adds the selected group to the filter list.

Remove

Removes all selected groups from the filter list.

Filter list

Shows all equipment groups that are to be filtered.

OK

Applies settings and closes the dialog.

Cancel

Discards the selection and closes the dialog.

Attention: Any changes that have been made to the structure of local equipment models are retained.

Help

Opens online help.

Add groups

  • select the desired equipment model
    Attention: If there are naming conflicts between global and local equipment models, the local equipment models are displayed and the global ones are ignored. You can get information on possible conflicts by clicking on the corresponding symbol (triangle with exclamation mark) in the tool bar.
  • Select an equipment group or level.
  • Add the new group to the list with the Add button in the lower area of the dialog
  • Subgroups are not automatically added.
  • it is possible to link as many groups as you want.

Delete groups

  • Select the desired elements in the list in the lower area of the dialog (multiple selection is possible)
  • Click the Delete button

Note: Changes in a tree element remain preserved independent of clicking button Cancel. Cancel only means that no element was selected.

In the Runtime

When executing the function the setting configured in the dialog is sent as request to the process-executing computer. It is then analyzed.


Send a Message

Manual -> Message Control -> Configure Message Control -> Functions -> Send a Message

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function allows for a sending of messages in Runtime. To do so, link this function with:

  • an alarm (function for group, class or area)
  • a limit value (property Limits/Function),
  • a response matrix (function)
  • a time control (via button or PFS)

To configure the function:

  1. Create a new function.
  2. Select the Send a Message function in the Message Control group.
  3. The dialog for configuration is opened:

  4. Configure
    • Sending mode
    • Message
    • Acknowledgment of receipt
  5. Close the dialog by clicking on OK.
  6. Link the function.

    For linking with a limit value or reaction matrix, content that is dynamically generated in Runtime can be sent. In order to use several Send a Message functions for a limit value, use a script that contains these functions and is linked to the limit value.

info Information

In Runtime the function Send a Message is always performed at the computer executing the process.


Sending mode

Manual -> Message Control -> Configure Message Control -> Functions -> Send a Message -> Sending mode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab the sending mode, recipient and method are configured.

Parameters

Description

Sending mode

Selection of the sending mode from the drop-down list: In this list only media are shown whose property Sending mode active had been activated in the Message Control Properties of the working area.

Recipient

Recipient settings:

Type

Selection of recipient pattern from the drop-down list. Possible selection:

  • User group: Sending to a group.
    Selection of a group in case of switching the option or via option recipient name.
    The sending mode for the group is defined in the option Method.
  • User: Sending to an individual user (and the substitute person defined in their profile). Selection of a user in case of switching the option or via option recipient name.

Method

Only available if the option Type user group was selected.

Selection of sending method from drop-down list. Possible methods:

  • Group call: All users of the group will receive the message parallelly.
    (Note: in previous versions to zenon 7.00 this method corresponded the sending type Group sending.)
  • Successive call: The message is delivered to the users according to the defined sequence group successively until the first user positively acknowledges receipt. The group is only run through once. If there is no positive acknowledgement the sending is ended.
  • Infinite successive call: In principle corresponds to the Successive call, however, includes a repetition: After the last recipient the group is being run through again beginning on the top. The message is being sent until it is positively acknowledged by the first recipient.

Recipient name

Only available if the option Name from variable is deactivated.

Opens dialog for selection of a recipient or a recipient group - depending on the selection in the option Type.

Name from variable

Active: The variable is read in Runtime and a user or user group from the user administration is read out through its value. Click on button ... in order to open the dialog for selecting a variable.

OK

Applies all changes in all tabs and closes the dialog.

Dialog can only be closed if all required options have been configured.

Cancel

Discards all changes in all tabs and closes the dialog.

Help

Opens online help.


Message

Manual -> Message Control -> Configure Message Control -> Functions -> Send a Message -> Message

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab the content of the message is defined. Available options and configuration depend on the selection of the sending media in the option sending mode on the tab sending mode.

Messages are individually configured:

  • E-mail via Outlook and SMS via GSM or SMS gateway
  • E-mail message via SMTP
  • Voice message audiofile via modem
  • Voice message text-to-speech via modem

You can find details on configuration of the parameters for messages in the Parameters for messages chapter.

info Information

If parameters or values of additional variables are included in a message, these variables are not automatically logged on at the driver. If a variable is not logged on at the point of time the function is being carried out it must be logged on during the activity. Under certain circumstances (e.g. in case of slow serial communication with the hardware) this can result in delays since it has to be waited until the first value is provided by the driver and can be analyzed by the function.


E-mail via Outlook and SMS via GSM or SMS gateway

E-mail via Outlook and SMS via GSM or SMS gateway

Configuration of the message text for:

  • E-mail message via Outlook
  • SMS message via GSM modem
  • SMS message via SMS gateway

Parameters

Description

Free message text

Integral part of the message.

This text is searched for placeholders:

  • $: indicates "formatted" text. The text is subsequently parsed for parameters.
  • Text components are considered parameters if they are separated from the rest of the text with a semicolon (;) and end with a semicolon (;).
  • A Parameter can be:
    - key of the language table
    - name of a variable
    - compound entry in the language table

Parameters can be copied from the List of limit value text parameters. You can read more about the subject in the Parameters for meesages chapter.

Text from limit value

Properties for additional parameters from limit values.

active

Active: Adds additional parameters from the limit value to the constant text. Configuration via options:

  • from variable
  • from penultimate variable
  • List limit value text parameters

Attention: If this option is active only limit value violations can trigger this function.

from variable

Parameters are taken over from the defined variable. Click on button ... in order to open the dialog for selecting a variable.

from penultimate variable

Parameters are taken over from the variable whose limit value was violated.

List limit value text parameters

Selecting parameters from list by activating the corresponding checkbox. Sequence is definded by drag & drop with the mouse or the buttons move entry up and move entry down.

Split placeholders:
Displays placeholders which can be used in free message text.
If the option from variable or from penultimate variable or the variable selection is changed the example entry will be adjusted. Placeholders can be copied.

Structure: %Variable%Parameter; (origin)

  • %: percentage sign as prefix for variables and parameters
  • Variable: Variable. If no variable is indicated the following parameter refers to the main variable.
  • Parameter: Parameters
  • ;: semicolon ends string.
  • Origin: Only information, not used for free text. Indicates which variables can be used for the parameter :
    main variable via limit value
    main variable via AML
    additional variable via limit value or AML

For details, see the Parameters for messages and Parameter limit value text chapters.

If invalid parameters are used a corresponding error message is displayed in the message:
<Invalid Parameter: 'Parameter'>.

Move selected entry up

Places selected element one step higher.

Move selected entry down

Places selected element one step lower.

Show this dialog in the Runtime

Active: Opens this dialog in Runtime before executing the function.

Attention - Behaviour in Runtime:

  • In Runtime this function is always performed at the computer executing the process. If the function is started on a client the dialog is displayed on the computer executing the process.
  • If no entry is made the dialog is automatically closed after 30 seconds and the function is carried out.
  • If the dialog is edited and closed with OK the changes will be saved and the function carried out.
  • If the dialog is closed with cancel no message is being sent. This process is documented in the CEL provided for the property Log in CEL all confirmations or only negative confirmations was selected.

OK

Applies all changes in all tabs and closes the dialog.

Dialog can only be closed if all required options have been configured.

Cancel

Discards all changes in all tabs and closes the dialog.

Help

Opens online help.


E-mail message via SMTP

E-mail message via SMTP

E-mail message via SMTP

Configuration of the message text for:

  • E-mail message via SMTP

Parameters

Description

Free message text

Integral part of the message.

This text is searched for placeholders:

  • $: indicates "formatted" text. The text is subsequently parsed for parameters.
  • Text components are considered parameters if they are separated from the rest of the text with a semicolon (;) and end with a semicolon (;).
  • A Parameter can be:
    - key of the language table
    - name of a variable
    - compound entry in the language table

Parameters can be copied from the List of limit value text parameters. You can read more about the subject in the Parameters for meesages chapter.

Appendix

Configuration of an appendix to the e-mail. Screenshots can be sent as appendix. Click on button ... in order to open the dialog for selecting a file. This has to be deposited in the node Files/Graphics.

When sending the message the selected file is added as attachment to the e-mail.

Note: To send files from other folders with desired folder information, select the from variable option.

from variable

Active: Select a string variable. Click on button ... in order to open the dialog for selecting a variable.

The value of the string variables is read in Runtime and the content is analyzed. The path to the appendix is set according to the analysis:

  • Absolute path: this is used without changes
  • No absolute path: the value of the string variables is attached to the path to the zenon graphics folder

When setting the path, a check is not carried out to see which expansion the file has. Thus in doing so, NO CHECK IS CARRIED OUT TO SEE WHICH EXPANSION HAS THE FILE. Variables can be sent desired file formats from the attachment path, in particular PDFs and Office documents from any desired path.

Text from limit value

Properties for additional parameters from limit values.

active

Active: Adds additional parameters from the limit value to the constant text. Configuration via options:

  • from variable
  • from penultimate variable
  • List limit value text parameters

Attention: If this option is active only limit value violations can trigger this function.

from variable

Parameters are taken over from the defined variable. Click on button ... in order to open the dialog for selecting a variable.

from penultimate variable

Parameters are taken over from the variable whose limit value was violated.

List limit value text parameters

Selecting parameters from list by activating the corresponding checkbox. Sequence is definded by drag & drop with the mouse or the buttons move entry up and move entry down.

Split placeholders:
Displays placeholders which can be used in free message text.
If the option from variable or from penultimate variable or the variable selection is changed the example entry will be adjusted. Placeholders can be copied.

Structure: %Variable%Parameter; (origin)

  • %: percentage sign as prefix for variables and parameters
  • Variable: Variable. If no variable is indicated the following parameter refers to the main variable.
  • Parameter: Parameters
  • ;: semicolon ends string.
  • Origin: Only information, not used for free text. Indicates which variables can be used for the parameter :
    main variable via limit value
    main variable via AML
    additional variable via limit value or AML

For details, see the Parameters for messages and Parameter limit value text chapters.

If invalid parameters are used a corresponding error message is displayed in the message:
<Invalid Parameter: 'Parameter'>.

Move selected entry up

Places selected element one step higher.

Move selected entry down

Places selected element one step lower.

Show this dialog in the Runtime

Active: Opens this dialog in Runtime before executing the function.

Attention - Behaviour in Runtime:

  • In Runtime this function is always performed at the computer executing the process. If the function is started on a client the dialog is displayed on the computer executing the process.
  • If no entry is made the dialog is automatically closed after 30 seconds and the function is carried out.
  • If the dialog is edited and closed with OK the changes will be saved and the function carried out.
  • If the dialog is closed with cancel no message is being sent. This process is documented in the CEL provided for the property entries into CEL all confirmations or only negative confirmations was selected.

OK

Applies all changes in all tabs and closes the dialog.

Dialog can only be closed if all required options have been configured.

Cancel

Discards all changes in all tabs and closes the dialog.

Help

Opens online help.


Voice message audiofile via modem

Voice message audiofile via modem

Configuration of the message text for:

  • Voice message with audiofile via modem.

Parameters

Description

Greeting

Select the file containing the greeting text.

Click on button ... in order to open the dialog for selecting a file. This has to be deposited in the node File/Multimedia.

The file can be played for testing with the button Play.

Message

Select the file containing the message text.

Click on button ... in order to open the dialog for selecting a file. This has to be deposited in the node File/Multimedia.

The file can be played for testing with the button Play.

Failure entry

Select the file containing the text in case of failure entries by the recipient.

Click on button ... in order to open the dialog for selecting a file. This has to be deposited in the node File/Multimedia.

The file can be played for testing with the button Play.

Show this dialog in the Runtime

Active: Opens this dialog in Runtime before executing the function.

Attention - Behaviour in Runtime:

  • In Runtime this function is always performed at the computer executing the process. If the function is started on a client the dialog is displayed on the computer executing the process.
  • If no entry is made the dialog is automatically closed after 30 seconds and the function is carried out.
  • If the dialog is edited and closed with OK the changes will be saved and the function carried out.
  • If the dialog is closed with cancel no message is being sent. This process is documented in the CEL provided for the property entries into CEL all confirmations or only negative confirmations was selected.

OK

Applies all changes in all tabs and closes the dialog.

Dialog can only be closed if all required options have been configured.

Cancel

Discards all changes in all tabs and closes the dialog.

Help

Opens online help.


Voice message text-to-speech via modem

Voice message text-to-speech via modem

Configuration of the message text for:

  • Voice message with text-to-speech via modem.

Parameters

Description

Greeting

Enter the text to be displayed for greeting via the text-to-speech engine.

The text can contain dynamic components. These are configured in the same way as dynamic texts.

The text can be played for testing with the button Play.

Message

Enter the text to be displayed as message via the text-to-speech engine.

The text can contain dynamic components. These are configured in the same way as dynamic texts.

The text can be played for testing with the button Play.

Failure entry

Enter the text to be displayed in case of failure entries by the recipient via the text-to-speech engine.

The text can contain dynamic components. These are configured in the same way as dynamic texts.

The text can be played for testing with the button Play.

Show this dialog in the Runtime

Active: Opens this dialog in Runtime before executing the function.

Attention - Behaviour in Runtime:

  • In Runtime this function is always performed at the computer executing the process. If the function is started on a client the dialog is displayed on the computer executing the process.
  • If no entry is made the dialog is automatically closed after 30 seconds and the function is carried out.
  • If the dialog is edited and closed with OK the changes will be saved and the function carried out.
  • If the dialog is closed with cancel no message is being sent. This process is documented in the CEL provided for the property entries into CEL all confirmations or only negative confirmations was selected.

OK

Applies all changes in all tabs and closes the dialog.

Dialog can only be closed if all required options have been configured.

Cancel

Discards all changes in all tabs and closes the dialog.

Help

Opens online help.


Acknowledgment of receipt

Manual -> Message Control -> Configure Message Control -> Functions -> Send a Message -> Acknowledgment of receipt

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab the required confirmations and the response to them are defined.

attention Attention

Synchronously transmitted messages (text-to-speech message via modem and voice message with audio file via modem ) can only be confirmed synchronously via the respective transmission medium. The use of other transmission methods for communication (such as email or SMS) is not possible. The message must be acknowledged immediately via the same connection which is still open.

Acknowledgment settings

Parameters | Description
Acknowledgment of receipt | Settings for acknowledgement of receipt.
Acknowledgement of receipt required | Active: The message is only removed from the message queue if within the waiting period an acknowledgement of receipt has arrived or the waiting period has run out. For voice messages this option is always active and cannot be deactivated.
Waiting period | Period of time in minutes during which the receipt has to be acknowledged before the message is forwarded to a subsitute person.
Confirmation codes | Settings for acknowledgement codes.
Use message-specific codes | Inactive: The codes defined in the properties of the user administration for Message Control user/PIN code and Message Control user/NA code are used. Active: The defined codes in the following options PIN code and NA code are used for confirmation.
PIN code | Individual code for confirming the message.
NA code | Individual code for rejecting the message.
Function execution | Selection of functions to be executed after a message has been confirmed, rejected or not acknowledged at all.
In case of confirmation | Functions which are executed if the message is confirmed. A click on the Select button opens the function selection dialog.
In case of lack of confirmation | Functions which are executed if there is no response to the message. A click on the Select button opens the function selection dialog.
In case of negative confirmation | Functions which are executed if the receipt of message is rejected. A click on the Select button opens the function selection dialog.
OK | Applies all changes in all tabs and closes the dialog. Dialog can only be closed if all required options have been configured.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

Configuration of confirmation of receipt via‑email

When interpreting receipt confirmations via email,‑the first 3 characters of the subject line are ignored.

Background: Receipt confirmations are generally introduced with RE: etc. If outgoing messages are collected in the same folder as incoming ones, outgoing messages being interpreted as incoming confirmations of receipt must be prevented. To do this, it is assumed that receipt confirmations differ from outgoing messages in the 3 characters at the start.

Configuration: The subject of a receipt confirmation must be introduced by 3 desired characters.


Send Message: activate

Manual -> Message Control -> Configure Message Control -> Functions -> Send Message: activate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function activates Message Control for the project in which the function is located. When the function is called the project is logged on in Message Control. From this point of time on messages are created and transmitted.

To configure the function:

  1. Create a new function
  2. in group Message Control select the function Send Message: activate
  3. the function is created

Note: In order to securely log on a project during the Runtime start activate the property Active during Runtime start in property group Project-specific settings for Message Control.


Send Message: deactivate

Manual -> Message Control -> Configure Message Control -> Functions -> Send Message: deactivate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function deactivates Message Control for the project in which the function is located. When the function is called all messages of this project are removed from the message queue and the project is logged off from Message Control. Subsequently, the message queue of the project will be cleared. As long as Message Control is deactivated for a project no new messages can be created or transmitted.

To configure the function:

  1. Create a new function
  2. in group Message Control select the function Send Message: deactivate
  3. the function is created


Parameters for messages

Manual -> Message Control -> Configure Message Control -> Parameters for messages

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The text of messages can be configured dynamically. It is searched for placeholders before dispatch and evaluated. Control characters are noted in the process. This applies for:

  • E-mail via Outlook and SMS via GSM or SMS gateway
  • E-mail message via SMTP
  • Voice message text-to-speech via modem
  • Dynamic part of the subject property:

Creation of a message

  • Text parts are separated from one another with a semi colon (;).
  • $: marks text that contains the parameter.
  • A parameter can:
    • Be a key from the language table, such as @MyText;
    • Relate to a variable, when executing the function via AML or a limit value breach such as %Var1;
    • Be a compiled entry in the language table: for example %@Var2+MultipleText
  • @ marks language switching
  • % marks variables
  • %% marks limit value text parameters for variables

    A variable can be stated between the two percentage marks.
    If no variable is given, the value relates to the main variable.

    • Messages end with a semicolon (;).

Partly different parameters are available for the main variable, additional variable and depending on the function call.

Attention: If additional variables are added using a placeholder, these variables first have to be registered and read if they are not registered at the point of executing the function. The sending is then delayed. For this reason, additional variables should only be used cautiously.

List of parameter text

Parameters

In the Runtime

Action

key:

@MyText

A check is made to see if an entry in @MyText is present in the language table for the current language.
  • Existing: entry is added to the message.
  • Not existing: According to the settings of the project properties Display not translated keywords either @MyText or MyText is added to the message.

Variable:

%Var1%

A check is made if the variable exists and the value can be read.

  • Existing: Value of the variable is taken and added to the text as string.
  • Not existing/not readable: The text xxx is added to the message.

Compound entry:

@StringTable+%var1Text

A check is made if:

  • 1. the variable exists and the value can be read. Value is attached to the prefix text ("MultipleText") as string.
  • 2. an entry in the language table exists for the text
  • Variable and text exist:
    text is added to the message.
    Example: Value of the variable is 33. The language table is then checked for @StringTable33 and the corresponding text is added.
  • Not existing: According to the settings of the project properties Display not translated keywords either @MyText or MyText is added to the message.

Example: $@Caution ;%Var1%Name;


Text from limit value and free text

Manual -> Message Control -> Configure Message Control -> Parameters for messages -> Text from limit value and free text

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration of text from limit value

To link limit values:

  1. In the Message tab, activate the option Text from limit value active (Message Control function Send a Message).
  2. Activate the option from breached variable.
  3. Activate the checkboxes for the desired values.
    For parameters, see List of limit value text parameters.
  4. Order the selected parameters by dragging & dropping or with the corresponding buttons.
  5. Ensure that the limit value breach triggers the function.

Alternatively: Configure the Free message text option.

Configuration of free message text

Structure

$FreeText;%Variable%Text;

Start sign -> free text between semicolon -> contains parameters with %% as a sign

  • Start sign: $ (parameters are then taken into account in free text)
  • Free text: is inserted between semicolons (;)
  • Prefix for Limit field text parameters: 2 percentage signs (%% or % variable name %)

    If no variable is stated, the following parameter refers to the main variable.

  • End of the character sequence: Semicolons (;)

Example

$Text Message Control ;%%Name; Text ;%%LimitText; Text ;%Master%VariableStatus ;Text;

  • $: Start of the message with the first message text
  • %%Name: Name of the breached variable plus text
  • %%LimitText: Limit value text of the breached variable plus text
  • %Master%VariableStatus: Status of the "Master" variable plus text

Note: Place a space before the separator. The individual blocks are then separated correctly with a space-

List of limit value text parameters

Parameters | Main variable - Activating via limit value | Main variable - Activating via AML | Additional variable AML/limit value
%%Name (Variable name:) | Name of the variable, corresponds to property Name. | Name of the variable, corresponds to property Name. | Name of the variable, corresponds to property Name.
%%Identification (Identification) | Description of the variable, corresponds to property Identification. | Description of the variable, corresponds to property Identification. | Description of the variable, corresponds to property Identification.
%%LimitText (Limit value text) | Limit value text of the alarm object with interpretation of the dynamic limit value text. | Limit value text of the alarm object with interpretation of the dynamic limit value text. | Text of the state as defined in property Limit text.
%%MessageCreateTimeStamp (Time stamp of the message) | Point of time during which the message is created. (Function activation, not violation or sending). | Point of time during which the message is created. (Function activation, not violation or sending). | Point of time during which the message is created. (Function activation, not violation or sending).
%%ResourceLabel (Resource Label Identification) | Text for the resource label identification of the variable, corresponds to property Resources label. | Text for the resource label identification of the variable, corresponds to property Resources label. | Text for the resource label identification of the variable, corresponds to property Resources label.
%%LimitTimeReceived (Time alarm is generated) | Time stamp of the alarm object. | Time stamp of the alarm object. | -
%% (Current value) | No parameter. Value of the variable when activating the function (without unit). | No parameter. Value of the variable when activating the function (without unit). | No parameter. Value of the variable when activating the function (without unit).
%%VariableStatus (Status) | Status of the variable as string (when activating the function). | Status of the variable as string (when activating the function). | Status of the variable as string (when activating the function).
%%VariableTimeStamp (Time stamp of the variable) | Time stamp of the variable (when activating the function). | Time stamp of the variable (when activating the function). | Time stamp of the variable (when activating the function).
%%MessageTimeAcknowledge (Remaining time for confirmation) | Available time for acknowledgement in minutes. Only available if acknowledgement of receipt required was activated. | Available time for acknowledgement in minutes. Only available if acknowledgement of receipt required was activated. | Available time for acknowledgement in minutes. Only available if acknowledgement of receipt required was activated.
%%Address (Address) | Address. | Address. | Address.
%%Unit Measuring unit: | Technical unit according to Measuring unit property. | Technical unit according to Measuring unit property. | Technical unit according to Measuring unit property.
%%AlarmArea (Alarm area) | Alarm area of the main variable. | Alarm area of the main variable. | Alarm area of the additional variable.
%%LimitTimeAcknowledged (Time alarm is acknowledged) | - | Time stamp of the alarm object. | -
%%UserId (User identification) | - | User identification of the user who started the action. Conforms to property User identification. | -
%%UserName (User name) | - | Complete name of the user who started the action. Conforms to property Complete name. | -
%%ComputerName (Computer name) | - | Name of the computer on which the action was started. | -
%%Comment (Comment) | - | Comment of the alarm object. | -
%%AlarmGroup (Alarm/event group) | Alarm/event group of the alarm object (as text). | Alarm/event group of the alarm object (as text). | Alarm/event group of the alarm object (as text).
%%AlarmClass (Alarm/event class) | Alarm/event class of the alarm object (as text). | Alarm/event class of the alarm object (as text). | Alarm/event class of the alarm object (as text).
%%AlarmTimeActive (Time alarm is pending) | - | Period of time the alarm has been pending. | -

Error treatment

If invalid parameters are used a corresponding error message is displayed in the message:
Invalid Parameter: 'Parameter'>.

This text can be changed and translated with the language switching. To do so, two keywords have to be created:

  • <Invalid Parameter:
  • >

If parameters are used in the wrong context or if a parameter cannot be read (for instance because a variable does not exist) the string IDS_STRING2501 (---) is added to the message instead of the value. This text can be changed and translated with the language switching.


Message Control in Runtime

Manual -> Message Control -> Message Control in Runtime

In Runtime Message Control is either started automatically (property Active during Runtime start active) or with the function Send Message: activate.

If Message Control is active and an event defined for message sending occurs:

  • a message configured for this is being sent
  • its acknowledgement is being analyzed
  • the functions used for acknowledgement are executed

attention Attention

During the analysis of messages in the e-mail folder all messages with matching subject line are interpreted and set to status "read". If in the mailbox for Message Control other messages are received, too, those may probably set to "read".

Management in Runtime

The Message Queue can be managed with a screen of type Message Control.

Message Control is being closed when closing the Runtime or by the function Send Message: deactivate.

Time stamp in Alarm Message List and Message Control

When the function Send message is activated a copy of the alarm object is transmitted to the function. The message text is created and translated when the function is activated. If the function is activated via AML it will use a copy of the alarm object from the AML. So the content always corresponds to a current combination of process and alarm status.

Message Queue Remanence

If the Runtime is closed normally an image of the current message queue is created and saved. This image is reloaded during the start of Runtime and is being processed by Message Control. The data are saved in a folder called MessageRT_Image.bin. The following data are saved:

  • Current messages in the queue
  • Suppressed alarm groups
  • Suppressed alarm class
  • Suppressed areas
  • Suppressed equipment

Network

You can find further information on the behaviour in the network in the Networkchapter.

Acknowledging

Every message can unambiguously be identified by a GUID. According to the configured media and sending mode messages can also be acknowledged through other media. For more information about the acknowledgement of messages see chapter Message acknowledgement.

Language switch

The language of message texts can completely be switched. To do so, the following will be analyzed:

  • the area Constant Text
  • the parameter Dynamic Limit value Text
  • Limit value text of a limit value in the AML/CEL

The selectable columns in type Message Control are language switchable if they are configured correspondingly.


Connect screen of the type Message Control

Manual -> Message Control -> Message Control in Runtime -> Connect screen of the type Message Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The screen of type Message Control makes a copy of the current message queue and control elements for analysis and filtering available in Runtime. The content of the elements displayed in the message list list field corresponds to the point of time when the screen is connected and is not automatically updated. The display can be updated anytime by clicking on the button Update. The button Stop/Continue allows for a cyclical update. A text field indicates the point of time of the last update.

The message list contains messages which

  • are waiting to be sent
  • are being sent
  • have already been sent
  • have been confirmed
  • have been deleted

Suppressed groups, classes, areas and equipment whose alarms are not displayed in the list are displayed in separate list fields.

The columns of the message list can be configured individually (see Filter) and can be provided with individual column headings. These labelings are localizable.

Control elements | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.
Buttons | Buttons for Runtime actions.
Refresh | Refreshes view. The current data are loaded onto the screen from the message queue. The point of time of the last update can be displayed with the field Last update.
Delete | Deletes selected entry from the list. It is only possible to delete messages which have not been sent yet.
Filter | Opens Dialog to configure the filters for the view.
Stop/continue | Starts and stops the cyclic update of the list.
Window | Lists and fields which can be displayed in Runtime.
Number of messages | Number of currently existing messages.
Last Update | Point of time of last update.
Suppressed alarm/event groups | Alarm/event groups for which messages were suppressed and the alarms of which thus are not displayed in the message queue.
Suppressed alarm/event classes | Alarm/event classes for which messages were suppressed and the alarms of which thus are not displayed in the message queue.
Suppressed alarm/event areas | Alarm/event areas for which messages were suppressed and the alarms of which thus are not displayed in the message queue.
Suppressed equipment | Equipment for which messages were suppressed and the alarms of which thus are not displayed in the message queue.
Message queue | List of messages. Contains messages which have been sent, confirmed or deleted or remain to be sent. The messages are only displayed and cannot be edited anymore. Column headings can be named individually and are localizable by putting @ before them.
Filter profiles | Profile administration
Profile selection | Opens the dialog for selecting a profile.
Save | Saves current setting as a profile.
Delete | Deletes profile.
Import | Opens dialog for importing profiles from a file.
Export | Opens dialog for exporting profiles from a file.


Acknowledgement of messages

Manual -> Message Control -> Message Control in Runtime -> Acknowledgement of messages

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Messages can be confirmed or rejected by the recipient. Depending on the medium messages must either mandatorily or optionally be acknowledged.

Medium

To acknowledge

  • -: no
  • +: yes

E-mail message via Outlook

-

E-mail message via SMTP

-

SMS message via GSM modem

-

SMS message via SMS gateway

-

Voice message audiofile via modem

+

Voice message text-to-speech via modem

+

If a message is not, incorrectly or rejectively acknowledged it is being sent to the next substitute person. If a substitute is defined, the message is not sent again. The status is logged in the CEL. During the acknowledging of messages linked functions can be carried out.

info Information

Rules for interrupted calls:

  • If a call is interrupted without confirmation or a decline and the interruption is not classified as a hardware error, then:
    • The call is not repeated for the same addressee
    • If substitutes or group members who have not yet been messaged are messaged
  • If a call is interrupted by a hardware error, then the call for the same addressee is sent again according to the number of repetitions set in the Max. number of attempts property.

Configuring the confirmation

In order to configure the confirmation or rejection of the message:

  1. In the function Send Message open the tab Acknowledgement of receipt.
  2. Activate the checkbox Acknowledgement required (always active for voice messages).
  3. Define the waiting period (Timeout) within which the message must be acknowledged.
    After the waiting period has expired the message will be sent to the next person on the list.
  4. Configure the codes for confirmation (PIN) or rejection (NA code) as follows:
    1. properties of the user:
      Message Control user -> PIN code and NA code
      or
    2. in the function via:
      checkbox Use message-specific codes -> PIN code and NA code

    If codes are configured both via properties and the function the codes of the function are valid.
    Hint: If codes are configured via the function it is recommended to make a note in Message text for the recipient to use the right code for activation or rejection.

  5. Define the functions which are to be executed after receiving the code for:
    1. message was confirmed
    2. message was neither confirmed nor rejected
    3. message was rejected
  6. Close the dialog by clicking on the OK button.

Acknowledgement in Runtime

During sending every message which must be acknowledged receives an individual, explicit identification (GUID). All activities of the message are allocated by means of this identification. If a message must be acknowledged, the identification is automatically added to the message text.

In order to acknowledge a message, according to the medium the recipient has to send the message number and PIN in a defined format.

Thus it is also possible to acknowledge written messages through other sending modes than those configured. The following must be the case for this:

  • the message must have been sent as e-mail or SMS
  • the response must be as e-mail or SMS
  • the response must contain the GUID
  • the response must contain the code for acknowledgement
  • the medium used for responding must be configured

E‑Acknowledging e-mails

An e-mail is acknowledged as follows:

  • The response is being sent using the reply function of the e-mail program of the recipient.
  • The original subject must not be changed in the email. This means: The contents defined in Outlook in Subject (ID) or for SMTP in Subject for outgoing e-mails must remain unchanged. These will identify and allocate the message during receipt in zenon.
  • However the subject must have at least three characters placed in front of it as a response. For example RE: or AW:.
  • The response text must contain:
    • GUID: At the start of the message. There must be no other character, including spaces, in front.
    • Semi-colon (;): Separator.
    • Text: Contains PIN code or NA code.

    for example: 43d3c61d-ccc9-4c76-bc2c-61c2d12b0db3;0246

  • In Message Control e-mails for Message Control are identified by means of the subject.
    Attention: The response subject must be marked as response. To do this, the message is checked on receipt to see if it starts with at least three characters such as RE: or AW:.
  • Message Control analyzes GUID and code and subsequently executes the functions set in the function Send Message.

Note: if the medium SMS was configured a message sent via e-mail can also be acknowledged via SMS.

Acknowledging SMS

An SMS is acknowledged as follows:

  • The response is being sent using the reply function of the user's telephone.
  • The response text must contain:
    • GUID: At the start of the message. There must be no other character, including spaces, in front.
    • Semi-colon (;): Separator.
    • Text: Contains PIN code or NA code.

    for example: 43d3c61d-ccc9-4c76-bc2c-61c2d12b0db3;0246

  • Message Control analyzes GUID and code and subsequently executes the functions set in the function Send Message.

info Information

SMSs to Smartphones can also be received and acknowledged with the Notifier App by zenon . To do this, the App the response as an SMS in Alarm-ID;PIN bzw. Alarm-ID;NA format.

if the medium e-mail was configured a message sent via SMS can also be acknowledged via e-mail.

Voice message

Voice messages always must be acknowledged. A voice message is acknowledged as follows:

  • The telephone of the recipient must support DTMF.
  • The receiving modem of the equipment musst support DTMF.
  • The message is read to the recipient with greeting and message text.
  • The recipient acknowledges the message via key signals with PIN code or NA code.
  • The recipient can:
    • have messages repeated:
      by pressing the #key on the telephone. The previously sent message (greeting, message or error message) is being repeated.
    • re-set sent code:
      by pressing the *key on the telephone. The code (PIN or NA) previously sent by the recipient is revoked. The message is replayed starting again with the greeting.
  • Message Control analyzes the code and subsequently executes the functions set in the function Send Message.

Note: Voice messages always must be acknowledged by telephone.


Network

Manual -> Message Control -> Message Control in Runtime -> Network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the network, the message queue is permanently being synchronized between server and standby server. If new messages are created at the server these are transferred to the standby. When the server or standby server are booting, the message queue is synchronized with the primary server or standby server. Since the server and standby server use different resources, messages can only be acknowledged at the sending computer.

Similarly, the list of suppressed elements is being synchronized and remanently saved.

The function Send message is only executed at the process-executing computer. Sending by the client is not supported.

User

Users are edited by means of the zenon user administration. For this reason, users can be edited at the server, standby server or client. Editing is also possible through web server and web client.

No resource sharing

The server and standby server must not share resources. Identical resources for different media at the same computer must also not be used. That means:

  • E-mail (SMTP): The server and standby server use different email accounts.
  • E-mail (Outlook): The server and standby server use different Outlook profiles.
  • GSM: The server and standby server use different modems and SIM cards with different telephone numbers.
  • SMS (SMS gateway): The Server and Standby Server use different files and folders.
  • Voice message: The server and standby server use different modems and different telephone numbers.
  • Every computer:

    uses a separate modem and telephone number respectively for:

    • SMS via GSM
    • SMS message via SMS gateway
    • Voice message with audiofile
    • Voice message text-to-speech

    Uses different accounts for:

    • Outlook
    • E-mail message via SMTP

Behaviour in case of failure

In the event of a server failure, the standby server will resend all messages in the message queue that must be acknowledged after having been upgraded to server. This may result in a duplicate sending of messages, but it ensures correct acknowledgement, since messages can only be acknowledged at the sending computer.

After a failure resulting in a reboot of the computer GSM modems probably will have to be re-initialized and their COM ports checked.


Messages and error handling

Manual -> Message Control -> Messages and error handling

Messages, notes and errors can be logged and displayed with the Diagnose Viewer in a separate module [Message Control]. Message details can be found in section LOG entries.

Network

The network traffic can be read with Wireshark. In case of an unsecured transmission all the commands sent to the server as well as the responses are visible in plain text in Capture. In case of encrypted connections the SSL / TLS Handshake can be checked, however, the exchange of user data cannot be checked.

Server

In order to check if a server supports certain commands, a Telnet session can be established with the server.

In Windows 7, the Telnet client can be installed as follows:

  1. Open system control.
  2. Open Programs and functions.
  3. Open Activate or deactivate Windows functions.
  4. Activate checkbox in front of Telnet client.
  5. Close dialog by clicking OK.
  6. The Telnet client is being installed.

In the command line the connection can only be opened with the command telnet [server name or IP address] [port e.g. 25 or 110].

Mail server

The connection to the mail server can be checked with a mail-client program (e.g. Outlook). If an unencrypted connection is used the analysis with Wireshark can display the supported SMTP and POP3 commands.

DNS

The name resolution can be checked with a program such as nslookup. nslookup can both resolve names to IP addresses and IP addresses to names. To do so, a valid DNS server has to be registered in the IP configuration of the computer.

GSM

For the analysis in case of problems with GSM it is possible for instance to use the following:

  • Serial Port Monitoring:
    for supervising the communication between zenon and the GSM modem.
  • HyperTerminal:
    allows to send AT commands to the modem.
    Microsoft Hyperterminal or Putty (open source) for example.
    Note: Hyperterminal was only supplied by Microsoft up to Windows XP. Can be copied manually for other operating systems.

AT commands

For troubleshooting with AT commands:

  1. Ensure that the driver suitable for the operating system is installed. To do this, use the preferred driver of the modem manufacturer from the driver CD or the homepage of the manufacturer.
  2. Check to see if the driver has been installed properly and that the modem is ready for operation.
  3. Use a hyperterminal to connect to the COM port of the modem. Microsoft Hyperterminal or Putty (open source) for example.
  4. Type in the AT command AT in the main window of the terminal.
    The modem should respond with OK.
  5. Test the AT commands that have created an error message in the LOG file. Note any possible preparations for the modem, such as the creation of a message in the queue.
  6. Check to see that the responses of the modem correspond to those in the list of supported AT commands.


Check list

Manual -> Message Control -> Messages and error handling -> Check list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In case of problems check:

Problem

Possible cause

Solution

SMTP mail

Outgoing mails are not being sent, incoming mails not received.

The sending mode is not configured correctly. LOG messages like "inactive sending mode", "server not available", "user cannot be found", "SMTP / POP 3 authentication failed" are indicating this.
  • Is the Sending mode active property activated?
  • Is the user who is supposed to receive the mail set as „Message Control User" (property Message Control user activated)?
  • Was an e-mail address configured for the user?
  • Are the user data transferred to the Runtime after a change (property RT changeable data)?
  • Is the configuration of the sending mode correct? Compare to the data of the e-mail provider.

The server is registered correctly, but is not available (error messages when connecting).
  • Does the name resolution work?
  • Is the server available (Ping)?
  • Does the firewall allow for the connection with the configured port? Both the computer firewall and the domain firewall can block this. Check with Telnet.

The server does not support a command (error message with "Command not supported" or similar in the LOG file).
  • Check if the server supports the command (e.g. with Thunderbird or Telnet).

If possible select a different configuration (e.g. SMTP AUTH commands can be bypassed with "register at the incoming mail server before sending e-mails". APOP can be deactivated and replaced by user and password.

The server requires an encrypted connection. Since the mail is sent in unencrypted form the server disconnects.
  • In this case the analysis with Wireshark shows that the server sends "STARTTLS". Since this command is not supported the connection should be protected via SSL or TLS.

The server does not support the selected protection mechanism (error messages when establishing an encrypted connection).
  • Select other protection configuration or plain text transmission.

SMS-GSM

zenon cannot establish a connection with the modem.
  • Wrong COM port (file-not-found error when opening the COM port).
  • COM port busy (e.g. by the configuration software of the manufacturer, access-denied error when opening the COM port).
  • Error when configuring the COM port/modem not responding.
  • The modem does not support the SMS-PDU mode (AT+CMGG error message or PDU mode error message in LOG).
  • Probably the modem requires a PIN / is the PIN incorrect? (PIN error messages in LOG)
  • Too many attempts to log on with an incorrect PIN? (PUK error message in LOG) In this case, the connection between zenon and the modem is only possible again once the PUK has been entered manually and thus the lock been lifted.
  • Check COM port and modem configuration.
  • Check PIN, if necessary release manually with the PUK.

Connection is established, but sending and receiving do not work.
  • Has a connection first been established between the modem and the GSM network? In most cases, the connection with the network is only established after accessing the manufacturer software!
  • Despite this the modem is not connected with the network (check with manufacturer software): Look for a location with better reception.
  • The SMSC telephone number that has been entered is not correct. (before entry in zenon/the first time a connection is established, including via "Check modem", load the SMSC with HyperTerminal from the modem and write it down)
  • Look at error message in LOG
  • Connect modem for the first time with manufacturer software with the GSM network.
  • Put modem in different location.
  • Check telephone number.
    Has the country code for the SMSC (00xy bzw. +xy) been set correctly?


LOG entries

Manual -> Message Control -> Messages and error handling -> LOG entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entries in the LOG file of the diagnose viewer.

  • Miscellaneous messages
  • E-mail via SMTP/POP
  • SMS
  • OpenSSL Library


LOG entries

Manual -> Message Control -> Messages and error handling -> LOG entries -> LOG entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The listing of these LOG entries is ordered alphabetically according to levels and entries.

  • Debug
  • Deep Debug
  • MSG
  • Warnings


LOG entries

Manual -> Message Control -> Messages and error handling -> LOG entries -> LOG entries -> LOG entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Debug

Level | Entry | Description
DEBUG | Attaching to current call. | The sending mode attaches to the active call.
DEBUG | Connected | A connection has been established.
DEBUG | Couldn't send MessageDeleteRequest notification to Mainstation. | The attempt to send a delete request telegram to the process-executing computer has failed.
DEBUG | Current Message %Nachricht Inhalt% | The current message (content, settings, etc.) is traced in the LOG.
DEBUG | File alignment request could not be send to mainstation. | The attempt to send an alignment request telegram to the process-executing computer has failed.
DEBUG | Invalid code '%s' entered. | An invalid code was entered.
DEBUG | Mail to Benutzer '%s' was successfully added to the outbox. | The message to user [name] was successfully transferred to the Outlook outbox.
DEBUG | MessageDeleteRequest Response: %d messages were deleted from the queue. | A delete response was received: [Number] messages were removed from the queue.
DEBUG | Messaging canceled: The end of the Benutzer list for the Group (%s) has been reached. | The end of user group [name] was reached, the sending is cancelled.
DEBUG | Requesting File alignment from mainstation. | An alignment request is sent to the process-executing computer.
DEBUG | Send SMS to Benutzer %s. | An SMS is being sent to the user [address].
DEBUG | Sending mail to Benutzer '%s' using address: %s. | A message for the user [name] is prepared and [sent] to the address.
DEBUG | Sending MessageDeleteRequest for %d messages to Mainstation. | A delete request for [number] messages is sent to the process-executing computer.
DEBUG | SMS to Benutzer %s transmitted to the outbox. | An SMS was transferred to the user [address] in the outbox.
DEBUG | The #-sign was entered: Repeating the last message. | # was entered: the last message is repeated.
DEBUG | The *-sign was entered: Clearing the current key. | A * was entered, the current entered code is being reset.
DEBUG | The current call be terminated now. | A call is active, it is closed now.
DEBUG | The is no call in progress, nothing to terminate. | No call is active, nothing can be closed.
DEBUG | The line %s has been closed. | The line [] has successfully been closed.
DEBUG | The line %s has been opened. | The line [] has successfully been opened.
DEBUG | The message %s should have been acknowledged by now, handling TimeOut. | The message [ID] should already have been confirmed, TimeOut is being processed.
DEBUG | The message %s should have been Sent by now, handling hardware TimeOut. | The message [ID] should already have been sent, TimeOut is being processed.
DEBUG | The Message %s was NOT successfully sent to %s! | The message [ID] could not be sent to [recipient].
DEBUG | The Message %s was not successfully sent to %s, and will be send again! | The message [ID] could not be sent to [recipient] and will be sent again.
DEBUG | The Message %s was successfully sent to %s! | The message [ID] was successfully sent to [recipient].
DEBUG | The next Benutzer (%s) for the group (%s) will be notified, previous Benutzer was:%s | The next user [name] from user group [name] is notified, the previous user was user [name].
DEBUG | The sending of message %s was completed. | The sending process for message [ID] has been completed.
DEBUG | Valid Acknowlegde-code entered. | A valid PIN code for confirming the message was entered.
DEBUG | Valid NegAcknowlegde-code entered. | A valid NA code for rejecting the message was entered.


LOG entries

Manual -> Message Control -> Messages and error handling -> LOG entries -> LOG entries -> LOG entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Deep Debug

Level | Entry | Description
DEEPDEBUG | A changed notification of message(%s) was received, the old message object will be updated! | The project received a change telegram for the message with the GUID [number]. The local (previous) object is updated.
DEEPDEBUG | A delete message(s) request was received! | A delete request telegram was received.
DEEPDEBUG | A getqueue request was received, sending queue. | An alignment request was received. The current queue and the current status are being sent.
DEEPDEBUG | A remove notification of message(%s) was received, the message object will be removed from the list. (%s) | The project received a remove telegram for message with GUID [number]. The local (previous) object is deleted.
DEEPDEBUG | All messages for project %s will be removed. | All messages of project [name] are removed from Message Control.
DEEPDEBUG | An addded notification of message(%s) was received, the message object will be added to the list. (%s) | The project received an add telegram for message with GUID [number]. The new object is added.
DEEPDEBUG | An ChangeSuppressionRequest was received. The local suppression-state will be updated! | A ChangeSuppression-Request was received. The local suppression status is updated.
DEEPDEBUG | An update of the message control state was received. The local state will be updated! | The project received a MessageControl-StateChange telegram for message with GUID [number]. The new object is added.
DEEPDEBUG | Current message count is (%d) | There are [number] messages in the queue. (Entry is created when creating and deleting messages.)
DEEPDEBUG | Firing MessageAcknowledged | MessageAcknowledged is being fired.
DEEPDEBUG | Firing MessageAcknowledgeTimeOut | MessageAcknowledgeTimeOut is being fired.
DEEPDEBUG | Firing MessageCreated | MessageCreated is being fired.
DEEPDEBUG | Firing MessageDeleted | MessageDeleted is being fired.
DEEPDEBUG | Firing MessageIn: (Identfier:'%s',Message:'%s') | Message is being fired, Id value is %s, MessageTExt is %s.
DEEPDEBUG | Firing MessageNegAcknowledged | MessageNegAcknowledged is being fired.
DEEPDEBUG | Firing MessageSendError | MessageSendError is being fired.
DEEPDEBUG | Firing MessageSent | MessageSent is being fired.
DEEPDEBUG | Last index set to %d. | The last applied index was set to [value].
DEEPDEBUG | MessageAcknowledged fired | MessageAcknowledged was fired.
DEEPDEBUG | MessageAcknowledgeTimeOut fired | MessageAcknowledgeTimeOut was fired.
DEEPDEBUG | MessageChangedNotify received for Message %s ignored (no longer Mainstation)! | The project received a changed notification for message with GUID [number] from Message Control, however, it is no longer the process-executing instance.
DEEPDEBUG | MessageCreated fired | MessageCreated was fired.
DEEPDEBUG | MessageDeleted fired | MessageDeleted was fired.
DEEPDEBUG | MessageIn fired: (Identfier:'%s',Message:'%s') | Message was fired, Id value is %s, MessageTExt is %s.
DEEPDEBUG | MessageNegAcknowledged fired | MessageNegAcknowledged was fired.
DEEPDEBUG | MessageSendError fired | MessageSendError was fired.
DEEPDEBUG | MessageSent fired | MessageSent was fired.
DEEPDEBUG | Messaging TimeOut watchdog activated for Project '%s' | For the project [name] the TimeOut supervision was started.
DEEPDEBUG | Messaging-Queue is being saved. | The current message queue is saved.
DEEPDEBUG | Project %s signed off. | The project is logged off from the engine.
DEEPDEBUG | Project %s signed on. | The project is logged on to Message Control.
DEEPDEBUG | SB state: %s(%u) | The status of the standby server has changed and is now %s (%d).
DEEPDEBUG | Sending added notification for message %s to SB. | The message object with GUID [number] was created. The "new" object is also sent to the standby server.
DEEPDEBUG | Sending changed notification for message %s to SB. | The message object with GUID [number] has changed, the "new" object is sent to the standby server.
DEEPDEBUG | Sending MessageCtrl-StateChanged to SB. | A MessageControl-StateChange telegram is sent to the standby server.
DEEPDEBUG | Sending remove notification for message %s to SB. | The message object with GUID [number] was removed; a remove telegram is sent to the standby server.
DEEPDEBUG | Switch to server:%s | The current instance is upgraded to server.
DEEPDEBUG | Switch to standby:%s | The current instance is downgraded to standby server.
DEEPDEBUG | The message %s is added to the Queue. | The message with Guid [number] was added to the queue.
DEEPDEBUG | The Message (%s) was removed from the project queue. | The message with Guid [number] was removed from the queue.


LOG entries

Manual -> Message Control -> Messages and error handling -> LOG entries -> LOG entries -> LOG entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

LOG Level MSG & MSG

Level | Entry | Description
logLe_MSG | Logging on to default mapi profile %s | If no profile was selected, the sending mode identifies the first profile and logs on with it.
MSG | Loggin off of MAPI profile %s. | Log-off from profile [name].
MSG | Logging on to mapi profile %s | Log-on on profile [name].
MSG | MessageControl has been activated. | Message Control was activated.
MSG | MessageControl has been deactivated. | Message Control was deactivated.
MSG | Selected dispatcher '%s' is busy->try again... | The selected sending mode [type] is busy: Another attempt will be made later.
MSG | The incoming message for %s contains the correct Ack-Code. | The incoming message [ID] contains a valid PIN code for confirming the message.
MSG | The incoming message for %s contains the correct NegAck-Code. | The incoming message [ID] contains a valid NA code for rejecting the message.
MSG | The incoming message for %s does not contain a valid code. | The incoming message [ID] does not contain a valid code.


LOG entries

Manual -> Message Control -> Messages and error handling -> LOG entries -> LOG entries -> LOG entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Warnings

Level | Entry | Description
WARNINGS | A Send-Message function was executed for a Group which does not contain any Message Control users! | A sending-message function was executed for a group which is empty or does not contain activated users for Message Control.
WARNINGS | Index exceeded 99999, starting from 0. | Maximum index for file name reached, starts again with 0.
WARNINGS | TAPI returned [Number] available devices. | Number of modems that can be addressed via TAPI. This message is created in the log if the devices available from zenon will be determined and displays which devices can be addressed by the OS by means of TAPI.
WARNINGS | Not all required modes are supported: LINEBEARERMODE_VOICE:[ModemID]-> the device [Modem ID],LINEFEATURE_MAKECALL:[Modem ID]- the device [Modem Name] can't be used! | Once the number of TAPI devices has been determined, these are filtered for the necessary modes. Note: If a device does not support one of the required modes, this mode is not shown. This log entry displays clearly which mode is not present.


LOG entries

Manual -> Message Control -> Messages and error handling -> LOG entries -> LOG entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The listing of these LOG entries is ordered alphabetically according to levels and entries.

  • Debug
  • Error
  • Warning


LOG entries

Manual -> Message Control -> Messages and error handling -> LOG entries -> LOG entries -> LOG entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Error

Level | Entry | Description
Error | [SMTP / POP3] not connected | The attempt was made to send data to the outgoing mail server or to retrieve data from the incoming mail server, although the server is not connected.
Error | Creating Connection failed. Errorcode: [Code] | The object for a connection (both secure and plain text) could not be created.
Error | Creating SSL/TLS Method failed. Errorcode: [Code] | The SSL/TLS method required for establishing a secure connection could not be created.
Error | No Destination E-Mail-Address specified | In case of an outgoing e-mail no target address was entered.
Error | Opening Connection failed. Errorcode: [Code] | A connection (both secure and plain text) could not be established.
Error | Reading SSL Structure failed. Errorcode: [Code] | Reading the SSL/TLS structure of a secure connection failed.
Error | SMTP AUTH should be used, but the Server neither supports AUTH LOGIN nor the minimum implementation AUTH PLAIN | SMTP authentication should be used, however the server does not have the required commands for an EHLO response listed in the list of supported extension commands (AUTH LOGIN and AUTH PLAIN, the latter is the minimum implementation in accordance with RFC 2554).
Error | The Server did not respond an OK Code to HELO. Response: [response from the SMTP server] | The outgoing mail server did not respond to the EHLO command or the HELO command with an OK code. (The response is attached to the LOG message.) The server is considered not to be available.
Error | The Server did not send a Waiting-For-Data-Response to the AUTH LOGIN [command / Benutzer data]: [response from the SMTP server] | The outgoing mail server has not sent the expected response to the AUTH LOGIN command of the corresponding user names. (The response is attached to the LOG message.)
Error | The Server did not send a Waiting-For-Data-Response to the AUTH PLAIN command: [response from the SMTP server] | The outgoing mail server has not sent the expected response to the AUTH PLAIN command. (The response is attached to the LOG message.)
Error | The Server did not send an OK-Response to the AUTH LOGIN password data: [response from the SMTP server] | The SMTP server has not confirmed the AUTH LOGIN password data with OK. The login has failed.
Error | The Server did not send an OK-Response to the AUTH PLAIN data: [response from the SMTP server] | The SMTP server has not confirmed the AUTH PLAIN data with OK. The login has failed. (The response is attached to the LOG message.)
Error | The Server did not send an OK-Response to the MAIL command: [response from the SMTP server] | The outgoing mail server has not confirmed the MAIL command (sending of a new mail) with OK. (The response is attached to the LOG message.)


LOG entries

Manual -> Message Control -> Messages and error handling -> LOG entries -> LOG entries -> LOG entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Warning

Level | Entry | Description
WARNING | No Subject for the E-Mail specified | No subject was specified for an outgoing mail. Though this is not an error a mail without subject may cause a spam filter to block this mail.
WARNING | No Text for the E-Mail specified | No text was included for an outgoing mail. Though this is not an error a mail without text may cause a spam filter to block this mail.
WARNING | The Server did not respond an OK Code to EHLO. Response: [response from the SMTP server] | The outgoing mail server responded with an error code to the EHLO command (response contained in the LOG message). The SMTP server does not support extensions. Extensions are used for SMTP authentication. This is not an error because SMTP authentication is not mandatory and the concerned functions carry out an error detection.


LOG entries

Manual -> Message Control -> Messages and error handling -> LOG entries -> LOG entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Error

Level

Entry

Description

ERROR

[telephone number] is not a valid SMSC telephone number!

The inserted telephone number of the short message center is invalid. Has the country code (00xy or +xy) been set correctly?

Only the contained characters (probably + as prefix, otherwise only numbers) will be checked, however, it is not being checked if the telephone number actually exists or if this really is a short message center!

ERROR

[telephone number] is not a valid telephone number!

The inserted recipient telephone number is invalid. Only the contained characters (probably + as prefix, otherwise only numbers) will be checked, however, it is not being checked if the telephone number actually exists or if this really is a short message center!

ERROR

Error on opening the port [COM-Port]: [error number in HEX]

The indicated serial port could not be opened. The indicated error number can be looked up in the MSDN Library and will give clues on the probable causes of the error.

ERROR

Error on configuring the port [COM-Porp] [state / timeouts / buffers]: [error number in HEX]

The indicated COM port could not be configured. State, timeouts and buffers are configured. The indicated error number can be looked up in the MSDN Library.

ERROR

The total input buffer ([number] bytes) is too small for the [number] bytes received from the modem.

The input buffer is too small to record all data sent by the modem. The input buffer is created with a size of 12 KB. For receiving an SMS with maximum size approximately 400 bytes are required. This error will occur if within a polling interval (see below) SMS data of more than 12 KB are incoming.

ERROR

The modem returned an error to the [AT command] command: [error message]

The modem responded with an error message to an AT command. The error message is attached to the LOG message. An AT error code may be contained in the error message.

If an authentication via PIN code is required this is transferred with the command AT+CPIN. If an incorrect code is entered the modem will respond with an error to this request.

ERROR

The modem did not respond to the [AT command] command.

A timeout occurred while waiting for the response of the modem for an AT command.

ERROR

The modem did not switch in SMS PDU mode.

Though the modem has confirmed the AT command for activating the SMS-PDU mode with OK this has not been activated.

ERROR

The modem did not apply the SMSC telephone number.

Though the modem has confirmed the AT command for setting the telephone number of the short message center with OK the telephone number has not been saved as short message center.

ERROR

Error: not connected

The attempt was made to send, receive or delete an SMS while no connection with the modem could previously be established.

ERROR

The modem returned an error to the transmission of the PDU: [error message]

The modem responded with an error message to the transmission of an SMS-PDU. The error message is attached to the LOG message. An AT error code may be contained in the error message.

ERROR

The modem did not respond to transmission of the PDU.

While waiting for the response of the modem to the transmission of an SMS-PDU a timeout occurred.

ERROR

Error on writing data: [error number in HEX]

An error occurred during the sending of data via the serial port. The error number can be looked up in the MSDN Library.

ERROR

Not all bytes have been sent.

Not all data were sent although the function for sending data via the serial port did not report an error.

ERROR

Error on reading data: [error number in HEX]

An error occurred during receiving data via the serial port. The error number can be looked up in the MSDN Library.

ERROR

The source SMSC telephone number [telephone number] contains the not supported character [character]

The telephone number of the short message center of the sender received during the SMS receipt contains an invalid character.

ERROR

The source telephone number [telephone number] contains the not supported character [character]

The telephone number of the sender received during the SMS receipt contains an invalid character.

ERROR

The syntax of the timestamp [time stamp] is incorrect.

The time stamp of the GSM network received during the SMS receipt does not correspond to the expected format.

ERROR

The byte [byte as HEX] could not be converted.

A byte contained in the PDU could not be converted into a number by a HEX string.

ERROR

Insufficient buffer to convert SMS text [Text]

The buffer for converting outgoing SMS (12 KB at 6144 characters) is insufficient.

ERROR

The format flag [byte as HEX] is not supported.

The formatting of an incoming SMS is not supported.

ERROR

Could not convert [byte as HEX], Extensionlanguage [byte as HEX], Extensionlanguage [byte as HEX]

A character contained in the 7-bit-SMS data section could not be decoded. The employed alphabets basis table and extension table are attached as language identifiers (see Standard 3GPP TS 23.038 V10.0.0 (2011-03).)

ERROR

Insufficient data to decode multilanguage fragmented SMS!

An SMS was received in several parts, the individual parts using different alphabets. However, the information on the alphabets needed for conversion is not complete.

ERROR

The input byte stream is not a valid unicode text.

A received Unicode SMS does not contain valid Unicode text (only an even byte number is valid, since there are 2 bytes per character in Unicode).

ERROR

Insufficient Buffer to decode PDU

The 12 KB buffer is too small for decoding a PDU.

ERROR

The PDU is not a valid byte stream.

A received PDU is not a valid hex dump of a byte stream.

ERROR

The PDU length does not match the SMS text length

The number of bytes contained in a received PDU does not match the length specification in the SMS control data.

ERROR

The Modem requests the PUK.

The modem requests the Personal Unlock Key (PUK) for authentication. This is not used by Message Control and, as a consequence, the attempt to establish a connection with the modem is cancelled. After an incorrect PIN code was entered several times the SIM card in the modem requests the PUK for authentication, subsequently requiring to reset the PIN code.

Attention: Incorrect entering of the PUK may render the SIM card useless!

ERROR

The Modem responded with an unknown PIN Status: [response from the modem]

The PIN status check of the modem delivered an unexpected result. The response of the modem to the check of the PIN status is attached to the LOG message.

ERROR

The Modem requests a PIN and the PIN-Input is empty.

The modem requires an authentication with a PIN code, however, the user did not enter any.

ERROR

The Modem did not respond with READY-State after PIN-Authentication: [String]

Although the transmission of the PIN code was confirmed with OK by the modem, the PIN status of the modem was not set on “READY” (no PIN input required anymore). The response of the modem to the check of the PIN status is attached to the LOG message.

DEBUG

Port [COM-Port] opened successfully

The indicated serial port was opened successfully.

DEBUG

Modem configured successfully for SMS-PDU-Mode and SMSC [telephone number]

The modem was successfully configured for the SMS-PDU mode and the indicated telephone number of the short message center.

DEBUG

Connection to modem closed.

The connection to the modem and the serial port was closed.

DEBUG

SMS successfully sent to [telephone number]

An SMS was successfully sent to the indicated telephone number.

DEBUG

Successfully received SMS from [telephone number]

An SMS was successfully received from the indicated telephone number.

DEBUG

The Modem does not need a PIN.

The modem does not require a PIN authentication.

DEBUG

Authentication with the PIN succeeded.

Authentication with the configured PIN code succeeded.


LOG entries

Manual -> Message Control -> Messages and error handling -> LOG entries -> LOG entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Error codes and the error messages from the OpenSSL Library in format „Errorcode: [Code]. Errormessage: [String]".

The server responses have the following structure:

  • POP3 responses only start with „OK“ if no error has occurred.
  • SMTP server responses start with a three-digit status code:
    • 2xx = OK
    • 3xx = waiting for data
    • 4x and 5 xx = error

Error messages in the Diagnosis Viewer.

Level

Entry

Description

ERROR

No Destination E-Mail-Address specified

In case of an outgoing mail no target address was entered.

ERROR

Creating SSL/TLS Method failed. Errorcode: [Code]. Errormessage: [String]

The SSL/TLS method required for establishing a secure connection could not be created.

ERROR

Creating Connection failed. Errorcode: [Code]. Errormessage: [String]

The object for a connection (both secure and plain text) could not be created.

ERROR

Reading SSL Structure failed. Errorcode: [Code]. Errormessage: [String]

Reading the SSL/TLS structure of a secure connection failed.

ERROR

Opening Connection failed. Errorcode: [Code]. Errormessage: [String]

A connection (both secure and plain text) could not be established.

ERROR

The Server did not respond an OK Code to HELO. Response: [Antwort des SMTP Servers]

The outgoing mail server neither responded to the EHLO nor HELO command with an OK code (response is attached to the LOG message). The server is considered not to be available.

ERROR

The Server did not send a Waiting-For-Data-Response to the AUTH LOGIN [command / Benutzer data]: [response from the SMTP server]

The outgoing mail server has not sent the expected response to the AUTH LOGIN command of the corresponding user names. The response is attached to the LOG message.

ERROR

The Server did not send an OK-Response to the AUTH LOGIN password data: [response from the SMTP server]

The SMTP server has not confirmed the AUTH LOGIN password data with OK. The login has failed.

ERROR

The Server did not send a Waiting-For-Data-Response to the AUTH PLAIN command: [response from the SMTP server]

The outgoing mail server has not sent the expected response to the AUTH PLAIN command. The response is attached to the LOG message.

.

ERROR

The Server did not send an OK-Response to the AUTH PLAIN data: [response from the SMTP server]

The SMTP server has not confirmed the AUTH PLAIN data with OK. The login has failed. The response is attached to the LOG message.

ERROR

SMTP AUTH should be used, but the Server neither supports AUTH LOGIN nor the minimum implementation AUTH PLAIN

SMTP authentication should be used, however, during the EHLO response the server has not listed the required commands in the list of supported extension commands.

The following commands are required: AUTH LOGIN and AUTH PLAIN, the latter is the minimum implementation according to RFC 2554.

ERROR

[SMTP / POP3] not connected

The attempt was made to send data to the outgoing mail server or to retrieve data from the incoming mail server, although the server is not connected.

ERROR

The Server did not send an OK-Response to the MAIL command: [response from the SMTP server]

The outgoing mail server has not confirmed the MAIL command (sending of a new mail) with OK. The response is attached to the LOG message.

ERROR

The Server did not send an OK-Response to the RCPT command: [response from the SMTP server]

The outgoing mail server has not confirmed the RCPT command (adds a recipient) with OK. The response is attached to the LOG message.

ERROR

The Server did not send a Waiting-For-Data-Response to the DATA command: [response from the SMTP server]

The outgoing mail server has not sent the expected response to the DATA command (mail data is being transferred). The response is attached to the LOG message.

ERROR

The Server did not send an OK-Respone to the transmitted Data: [response from the SMTP server]

The outgoing mail server has not confirmed the transmitted mail data with OK. The response is attached to the LOG message.

ERROR

APOP Authentication is required but the Server did not send APOP Data

For authentication at the incoming mail server the APOP command is required, however, the incoming mail server has not sent the required data.

ERROR

Creating APOP Digest failed. Errorcode: [Code]. Errormessage: [String]

The MD5 hash for APOP authentication could not be created.

ERROR

The Server did not send an OK-Response to the [POP3-Kommando] command: [response from the POP3 server]

The incoming mail server has not confirmed a command with OK. The response is attached to the LOG message.

The following commands might be affected: APOP, USER, PASS, STAT, RETR, DELE.

Note: If the DELE command still contains the reference „Could not delete mail“ the e-mail was received though could not be deleted. Since the e-mail was successfully received it is being forwarded to Message Control.

ERROR

The OK-Response to the STAT command did not have the expected Format: [response from the POP3 server]

The response of the incoming mail server to the STAT command did not correspond to the format definition according to RFC 1939.

Format: OK<space>[number of mails in mailbox]<space>[total size of all mails in mailbox in bytes]

ERROR

[Sending / Receiving] Data failed. Errorcode: [Code]. Errormessage: [String]

Sending or receiving data via an OpenSSL network connection has failed.


Mobile applications for zenon

Manual -> Mobile applications for zenon

With the mobile applications, you can visualize your zenon projects on mobile end devices, tablets and desktop computers. The basis of this display is an existing zenon project. There is no additional project configuration work required.

For display on mobile end devices, tablets and desktop computers, there are zenon apps available in the respective app store.
You can also create your own mobile applications for the visualization of your zenon project configuration. You can find further information and examples of code in the Everywhere Server data model chapter.

The following Apps are available:

  • Notifier-App by zenon:
    Allows the receipt and acknowledgment of SMS messages that are sent by the Message Control module.
    This App is available for the Android operating system.
  • Everywhere Server by zenon:
    Provides zenon data for mobile applications.
  • Everywhere App by zenon:
    This app allows simple access to zenon via smartphones, tablets and desktop computers.
    The following apps are available:
    • Everywhere App by zenon for Windows Mobile
    • Everywhere App by zenon for iPhone, iPad product range
    • Everywhere App by zenon for Windows Desktop
    • Everywhere App by zenon for Android

Once a server has been configured, the following functions are available via the app:

  • Real-time display of values of a zenon project
  • Authentication by means of the mobile application
  • Selection of the equipment model of the active project
  • Assignment of the configured user authorizations (via .INI entry)
  • Individual variables can be activated
  • Display of values in lists ...
    • ... with graphic progress bars
    • ... with dynamic pointer instruments
    • ... Alarm messages with time


Everywhere Server by zenon

Manual -> Mobile applications for zenon -> Everywhere Server by zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Everywhere Server by zenon is for visualization of real-time data of a zenon project configuration on smartphones, tablets and desktop computers.

It runs in the context of zenon Runtime and is configured in zenon6.ini. No additional program need be started for configuration.

tutorial License information

The Everywhere Server by zenon must be licensed.

Any device that supports the OData protocol can be used as a client.

In addition to its programming, an app is provided for smartphones, tablets and desktop computers.

These apps are available for free in the respective app stores.


Licensing

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Licensing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Everywhere Server by zenon

Everywhere Server gets the license of the Runtime. The license for Everywhere Server is issued by Runtime. The Everywhere Server can not be used, If the Runtime does not have a corresponding license.

For this reason, it may happen that the Runtime is running, but the Everywhere Server can not be started because of missing license rights. In this case, please use the licensing tool in order to receive a corresponding license.


Requirements

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Requirements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use the server for use with mobile applications, the following requirements must be met:

  • zenon from version 7.11 on
  • Users have to be configured in the project.
    For details about user administration, see also the Elements in the report area chapter.
  • For communication via HTTPS, the corresponding port must be enabled on the Server and the Client. This is port 8050 by default.
  • zenon Runtime must also be running on the computer on which Everywhere Server by zenon is running.
    This computer/server must be contactable in the Internet or internal network.

Requirement for the use of Everywhere App by zenon

The following requirements need only be met if the zenon project is visualized with Everywhere App by zenon:

  • An equipment model must be configured in the project.
    Variables can be linked from zenon 7.11 at each level.
    You can find details on the configuration of an equipment model in the Equipment modeling chapter.
  • zenon Runtime must also be running on the computer on which Everywhere Server by zenon is running.
    The computer/server must be contactable in the Internet. To do this, the computer must have a public IP address.
    Attention: 192.168.xxx.xxx is not a public address!


Data security

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Data security

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Secure transfer of data via HTTPS is ensured by the use of the Transport Layer Security encryption protocol (TLS). The identity of the Server is checked by the Client. This guarantees the integrity, origin and target of the data transfer.

Overview of communication

  • Everywhere Server by zenon uses a server certificate.
    Everywhere Server is not started without a server certificate. This server certificate is created with the Everywhere - Certificate creator.exe tool.
    If several servers are in use, separate server certificates can be used for each server.
  • The server certificate is based on a root certificate.
    If several servers are in use, separate server certificates can be used for each server.
    These server certificates originate from the same root certificate.
    Advantage: different servers can be called up with a single root certificate.
  • The root certificate can be purchased or you can create one yourself.
    Root certificates are also called SLL certificates.
    Tip: If a root certificate or SLL certificate is purchased from a provider, there is no installation on the Client. These certificates are installed together with the installation of the operating system.


Configuration

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Everywhere Server by zenon is integrated into zenon Runtime. No additional program needs to be started. The necessary settings are made in zenon6.ini directly.

Hint Hint

All .ini entries can also be made with the Everywhere.Config.exe program. This program offers a graphical user interface. The configurations are also transferred to zenon6.ini.

zenon6.ini entries:

  • Open zenon6.ini in an text editor.
    Note: You can find zenon6.ini under the following path: %ProgramData%\COPA-DATA\System
  • Insert the server entries:

Entry

Description

[EVERYWHERE]

Configuration of the global properties for Everywhere Server.

CERTIFCATE=

Server certificate subject for HTTPS

Subject of the certificate. The certificate must be saved in the Machine Store in the MY node (your own certificates).

e.g.: CERTIFICATE=CN=MyComputerName

ENABLE=

  • 1: Everywhere Server is started with zenon Runtime.
  • 0: Everywhere Server is not started.

Default: 0

PORT=

HTTPS port for communication with the Everywhere Server

Default: 8050

WRITE_ACCESS=
  • 0: Only read access via Everywhere Server is possible.
  • 1: Allows the writing of variables and the acknowledgment of alarms.

Default: 0

Due to the system, only ANSI and Unicode are supported for reading the INI files.

attention Attention

UTF-8 format is not supported!

You should therefore always save your INI files as a text file in ANSI or Unicode format.

Hint Hint

You can find further information on .ini entries in the Configuration files manual.


Configuration with the Everywhere.Config.exe

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Configuration -> Configuration with the Everywhere.Config.exe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The .ini entries for the Everywhere Server can also be configured using the Everywhere.Config.exe program. You can find this program in the folder C:\Program Files (x86)\Common Files\COPA-DATA\STARTUP.

Information

The program Everywhere.Config.exe is only available in English.

Double-clicking on the program opens the configuration dialog:

Parameters | Description
Enable Everywhere server | If the checkbox is active, the Everywhere Server by zenon starts when zenon Runtime is started. Default: inactive Note: If this checkbox is not active, all other settings are also inactive and grayed out.
Enable Everywhere write access | Activates write access to variables and alarms (acknowledgment) by the server. 0: read access only 1: Writing to variables and acknowledgment of alarms possible Default: 0
HTTPS port: | HTTPS port that is used by the Everywhere Server by zenon. Default: 8050
Server certificate | Server certificate for HTTPS communication. This can be selected in the drop-down list. This drop-down list contains all available certificates. Note: The certificate must contain a private key. If no server certificate is selected, Everywhere Server is not started! Certificates can be created with the Everywhere.CertificateCreator.exe tool.
Add | The Everywhere.CertificateCreator.exe program is opened by clicking on the button. This program is used for the creation of separate server certificates. The entry in the drop-down list is based on the Friendly name of the Everywhere.CertificateCreator.exe
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.

Note: These configurations are saved in zenon6.ini.
You can find further information about these .ini entries in the Configuration files manual in the Everywhere Server [EVERYWHERE] chapter

attention Attention

The configuration is also applicable for all zenon installations on one computer.


User authorization

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Configuration -> User authorization

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The assignment of configured user authorizations is possible via the zenon6.ini file or in the zenon Editor.

In the Editor:

  • Click on the Workspace node
  • Select the Everywhere Server property group
  • Select, from the Authorization level drop-down list, the authorization level that is to have access to Everywhere Server.

info Information

Authorization level 0 means write and read access for all users.

You can find further information in the user administration manual in the Authorization levels chapter.

INI entry:

To configure the level of user authorization for Everywhere Server, the following must be added to the zenon6.ini file:

Entry | Description
[PASSWORD] | Configuration of the access authorization for Everywhere Server.
EVWH_ACCESS= | Authorization level that has access to the Everywhere Server. Value: Number of the configured authorization level Default: 0 (= everyone has access)


Everywhere - Certificate creator

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Configuration -> Everywhere - Certificate creator

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Everywhere - Certificate creator is used to create new server certificates. Certificates are required for secure communication between the client and server. You can find this program in the folder C:\Program Files (x86)\Common Files\COPA-DATA\STARTUP.

To start the program, double-click on Everywhere.CertificateCreator.exe. A configuration dialog is opened:

Parameters | Description
Server certificate |
Host name resp. IP address | Name or IP address via which the Everywhere Server is accessed by the clients. This is either the IP address or the name of the computer on which the service is running, or the address/name of the firewall/router that connects the computer to the internet.
Additional subject attributes (e.g. O=COPA-DATA, L=Salzburg,C=AT) | Additional attributes for the certificate (optional).
Friendly name | Name for the display in the program Everywhere.Config.exe.
Issuer (Authority certificate) | Issuer certificate or certificate that is to be used to verify the server certificate. The certificates present are shown in the drop-down list. The entry in the drop-down list is based on the Friendly name from the Create root certificate dialog.
Add private CA certificate | Opens dialog to configure the root certificate. Note: The root certificate is a mandatory part of the server certificate!
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.

attention Attention

Administrator rights are required to execute this program.


Create root certificate

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Configuration -> Create root certificate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A root certificate is used on the mobile device for secure communication between the server and mobile devices (iPhone, Windows-Phone). This ensures that the end device is also actually connected to the given server.

To create your own root certificate:

  • Click, in the Everywhere - Certificate creator, the Add private CA certificate button .
  • The configuration dialog is opened:

Parameters |  | Description
Subject |  |
Common name (CN) | General name Default: CA for Everywhere Server
Organization (O) |  | Company name Default: Company
Organizational unit (OU) |  | Name of the organizational unit (department name) Default: Department
Locality (L) |  | Locality name Default: Salzburg
State (ST) |  | State or district name Default: Salzburg
Country (C) |  | Country name Default: AT
Additional settings |  | Additional information
Friendly name |  | Short name Default: CA for Everywhere Server
OK |  | Accepts the changes and opens the save dialog to save the root certificate.
Cancel |  | Discards all changes and closes the dialog.


Certificate on the client

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Configuration -> Certificate on the client

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The certificate is checked on the Client. If this certificate has not been created by a root certificate from a generally-known authority (=purchase certificate), the certificate used must be installed on the Client.

Installation of a certificate on the Client

Unverified certificates must be installed on the Client in order for them to be accepted.

Carry out the following steps for the installation:

  1. Place the exported certificate (.cer file) on a web server or FTP server.
  2. Open this certificate on the client using the browser.
  • Alternatively, it can also be sent as an email attachment and opened on the client.


Certificates

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Configuration -> Certificates

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To install Everywhere Server by zenon correctly, carry out the following steps:

  1. Start the Everywhere.Config.exe. program
  2. Activate the Enable Everywhere server checkbox
  3. Enter the correct port in the Port (HTTPS) input field.
  4. Select a server certificate from the Server certificate drop-down list.

Create a server certificate

To create a server certificate:

  1. Click the Add button in the Everywhere.Config.exe program to start the Everywhere - Certificate creator program.
  2. Enter your data into the input fields.
  3. Assign a Friendly name.
  4. Select an SLL certificate from the Issuer (Authority certificate) drop-down list.

Creation of a root certificate (SLL certificate)

Purchase a certificate from a provider of SLL certificates.
Installation on the Client becomes superfluous as a result, because common certificate providers are already installed on the end device by default.
Search for "SLL certificates" on the Internet. Some providers are, for example:

  1. GoDaddy (http://www.godaddy.com)
  2. VeriSign (http://www.verisign.com)
  3. CAcert (http://wiki.cacert.org/FAQ/AboutUs)

Alternatively, create your own root certificate:

  1. Click, in the Everywhere - Certificate creator, the Add private CA certificate button.
  2. Enter your data into the input fields.
  3. Assign a Friendly name.
  4. Click on the OK button
  5. The dialog to save the SLL certificate appears.
  6. Name your SLL certificate and save it.

info Information

This saved root certificate is the certificate that must be installed on the Client.


CEL entries

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> CEL entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When logging into the Everywhere Server, a CEL entry is created if

  • the login data sent was checked by Runtime.

    This happens:
    • On the first request of a client.
    • Every 5 minutes
    • Always before a write request if more than a second has passed since the last check.

For variables that have not been acknowledged, alarms and CEL entries are supported by an incremental transfer of value changes.

LOG entries:

Level error

Description

Level Error

Errors that occur during the execution of the Everywhere Server.

However not an error that has something to do with the execution of client requests.

Level Warning

Errors that occur during the execution of the Everywhere Server.

However not an error that has something to do with the execution of client requests.

Level Success

Successfully-executed client requests that lead to a change of the internal status of the Everywhere Server or the zenon Runtime.

Level Failed
  • Error in the execution of client requests
  • Error in the checking of credentials

Level Msg

Everywhere Server status:

  • Start / stop
  • Successful creation of sessions
  • Ending of sessions

Level Debug

Incoming and outgoing requests with

  • Session-ID,
  • URI (Uniform Resource Identifier)
  • Method and status

Level Deep Debug

Status of the Everywhere Server as well as incoming and outgoing requests, compiled into an entry (Level Msg + Level Debug).


Data model of the Everywhere Server

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Data model of the Everywhere Server

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Open Data Protocol (= OData) is used as an interface for the inclusion of data in your own web application. This protocol is a "WCF data service".

This data service is a "RESTful services" (REpresentational State Transfer Architecture – REST). Only methods for manipulating or querying the data model are defined in this (CRUD – Create – Read – Update – Delete).

Because these methods cover the HTTP commands ((GET, PUT, POST, DELETE) data services can be implemented very well via the HTTP protocol. In doing so, the desired object is identified by means of the URL and the operation via the respective HTTP command.

Hint Hint

PUT, CREATE and DELETE must "point" to different instances.
You can find further information in the official ODATA online documentation.
Link: http://www.odata.org/documentation/odata-version-2-0/operations/

The data is, like a relational database, organized in tables. Filter criteria can be defined for querying data (comparable to an SQL query).

Note: In contrast to traditional data services, a session-dependent data model is used in the Everywhere service. This means that the data model can - depending on the session - contain different data.

info Information

The Everywhere service is a WCF data service.
You can find details and comprehensive documentation for the OData services at: www.odata.org.


Data model - static project data

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Data model of the Everywhere Server -> Data model - static project data

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Equipment Models (Collection)

  • Type: Everywhere.Service.Data.ZenonEquipmentModel
    • Name (string)
    • Guid (string, key)
    • EquipmentGroups (collection, Everywhere.Service.Data.ZenonEquipmentGroup)

EquipmentGroups (Collection)

  • Type: Everywhere.Service.Data.ZenonEquipmentGroup
    • Guid (string, key)
    • Name (string)
    • ParentGroup (Everywhere.Service.Data.ZenonEquipmentGroup)
    • ChildGroups (collection, Everywhere.Service.Data.ZenonEquipmentGroup)
    • Model (Everywhere.Service.Data.ZenonEquipmentModel)

Variables (Collection)

  • Type: Everywhere.Service.Data.ZenonEquipmentModel
    • EquipmentGroupGuids (String, commaseparated GUIDs of the related groups)
    • MinimumValue (Real)
    • MaximumValue (Real)
    • Unit (String)
    • ResourcesLabel (String)
    • Identification (String)
    • Name (String)
    • Id (int, key)

AlarmClasses (Collection)

  • Type: Everywhere.Service.Data.ZenonAlarmClass
    • EquipmentGroupGuids (String, commaseparated GUIDs of the related groups)
    • Description (String)
    • Number (int, key)
    • Name (String)

AlarmGroups (Collection)

  • Type: Everywhere.Service.Data.ZenonAlarmGroup
    • EquipmentGroupGuids (String, commaseparated GUIDs of the related groups)
    • Description (String)
    • Number (int, key)
    • Name (String)

Archives (Collection)

  • Type: Everywhere.Service.Data.ZenonArchive
    • Id (String, key)
    • Name (String)
    • Values (Collection, Everywhere.Service.Data.ZenonArchiveValue)

ArchiveValues (Collection)

  • Type: Everywhere.Service.Data.ZenonArchiveValue
    • ArchiveId (String, key)
    • VariableName (String)
    • Timestamp (Int64, Unixtime [ms], key)
    • Type (int, key, None = 0, Sum = 1, Average = 2, Min = 3, Max = 4)
    • Value (string)
    • VariableId (int, key)


Data model - project data that changes

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Data model of the Everywhere Server -> Data model - project data that changes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Below you can find the data model for values that update themselves.

Alarms (Collection)

  • Type: Everywhere.Service.Data.ZenonAlarm
    • Deleted (bool)
    • Acknowledged (bool, writeable)
    • VariableStatus (Int64)
    • Value (string)
    • AlarmClass (Everywhere.Service.Data.ZenonAlarmClass)
    • AlarmGroup (Everywhere.Service.Data.ZenonAlarmGroup)
    • UserId (String)
    • ReactivateNumber (int)
    • ReactivateStatus (Int64)
    • ReactivateTime (Int64, Unixtime [ms])
    • TimeAcknowledged (Int64, Unixtime [ms])
    • TimeCleared (Int64, Unixtime [ms])
    • TimeReceived (Int64, Unixtime [ms], key)
    • ComputerName (string)
    • Comment (string, writeable)
    • Text (string)
    • Variable (Everywhere.Service.Data.ZenonVariable)
    • AlarmStatus (int)
    • Cookie (int)
    • Id (int, key)

Example Example

The "Acknowledged" and "Comment" properties can be used to acknowledge an alarm in zenon or to save a comment.

These properties can then be transferred to the server with the "PUT" or "MERGE" command.

CEL (Collection)

  • Type: Everywhere.Service.Data.ZenonEvent
    • VariableStatus (Int64)
    • Value (string)
    • AlarmClass (Everywhere.Service.Data.ZenonAlarmClass)
    • AlarmGroup (Everywhere.Service.Data.ZenonAlarmGroup)
    • UserId (String)
    • TimeReceived (Int64, Unixtime [ms], key)
    • ComputerName (string)
    • Comment (string )
    • Text (string)
    • Variable (Everywhere.Service.Data.ZenonVariable)
    • Cookie (int)
    • Id (int, key)

OnlineVariables (Collection)

  • Type: Everywhere.Service.Data.ZenonOnlineVariable
    • Id (int, key)
    • Variable (Everywhere.Service.Data.ZenonVariable)
    • Status (Int64)
    • Timestamp TimeReceived (Int64, Unixtime [ms])
    • Value (string, writeable)

Example Example
  • To sign variables in again, a new instance must be created in the collection. This is carried out with the CREATE command.
    This registration is removed again with DELETE.
  • For identification of the online variable that was created on the client, its ID must be established. This ID corresponds to the ID of the zenon variable whose values are to be queried.
    PUT or MERGE writes a value to a variable.


Querying archives

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Data model of the Everywhere Server -> Querying archives

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Archive variables can only be queried from the respective project of the Everywhere Server. Cross-project variables are not supported.

Note on the querying of archive values:

In order to query archive data, the following properties must also be entered for the server query:

  • Archive ID
  • Start time
  • End time

attention Attention

Values without these filter criteria being stated cannot be queried.

Examples:

  • https://89.26.13.1:8050/zendata/DEMO_AUTOMOTIVE/ArchiveValues?$format=json&$filter=ArchiveId%20eq%20%27FI%27%20and%20Timestamp%20gt%201377690800000L%20and%20Timestamp%20lt%201377690862000L
  • https://89.26.13.1:8050/zendata/DEMO_AUTOMOTIVE/Archives%28%27FI%27%29/Values?$format=json&$filter=Timestamp%20gt%201379934601375L%20and%20Timestamp%20lt%201379934601377L%20and%20VariableName%20eq%20%27BodyShop1.Actual%27


Calling up the data model using a web browser

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Data model of the Everywhere Server -> Calling up the data model using a web browser

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The data model of the Everywhere Server can be displayed in a web browser. This can be used to give you a quick overview and test the first programming lines.

To call up a data model, use Mozilla Firefox or Google Chrome (recommended).

Attention: Microsoft Internet Explorer does not support the full functionality!

URI address

https://server address or DNS name:port number\zendata\project name

Parameters | Description
https:// | URI schematic of the WWW communication protocol. https: stands for the secure transfer protocol Hypertext Transfer Protocol Secure
Server address or DNS name | IP address or DNS name of the Everywhere Server.
: | : (colon) Separates the server address from the port number.
Port number | Port number for communication, as configured in Everywhere Server.
zendata | Constant: is always zendata
Project name | Name of the zenon project configuration.

Example Example

https://89.26.13.1:8050/zendata/Demo_Automotive


Logging in to the data model

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Data model of the Everywhere Server -> Calling up the data model using a web browser -> Logging in to the data model

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If it is not possible to log in when in secure mode (https://), a warning sign appears in the browser.
This warning sign can be skipped by clicking on the respective button (Chrome: "Continue anyway", Firefox: "I am aware of the risk"). Communication then takes place unsecured.

The login dialog appears:

User name:

The user name is the session ID at the same time. This session ID comprises:

Time Stamp|Device ID|User Name

Parameters

Description

Time stamp

32-bit time stamp of the session:

  • UTC Unix time
    (UTF8 coded: 8-digit HEX string)
  • must be 8 digits

|

Pipe character
Alt GR key and <-key

Device ID

ID of the end device (mobile device, ...) - normally UUID. The device ID is device-dependent and must be unique.

|

Pipe character
Alt GR key and <-key

User name

User name, as configured in zenon. When entering this, note capitalization.
Note: The user name must not contain a colon.

Example Example

538497B4|550e8400-e29b-11d4-a716-446655440000|Manager

Password:

The password comprises:

Type of password sendingand password

Parameters

Description

Type of password sending

How the password is sent:

  • =
    (equal sign)
    unencrypted
  • +
    (plus sign)
    encrypted

Note: The password must be preceded with the type of sending (= or +). Otherwise logging in to the data model will not be successful!

Password

Password as configured in zenon.

Note: Pay attention to capital letters and small letters when entering the data!

Example Example

+Manager
Encrypted communication with the Everywhere Server - login with the password Manager.


Examples

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Data model of the Everywhere Server -> Examples

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can find some examples of code here. Theses examples should show how values from the server can be updated.
Note: The examples use the Java programming language.

Other topics in this chapter

Examples for browser display

Example of code - calling up OEntity objects from the server

Other examples of code


Examples for browser display

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Data model of the Everywhere Server -> Examples -> Examples for browser display

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A browser can be used to display your zenon project configuration in a browser.
Note: The web addresses shown here relate to the demo project of the Everywhere Server.

Data model - overview

To display a simplified overview of your data model in your browser, enter the following URI into the browser:

https://89.26.13.1:8050/zendata/DEMO_AUTOMOTIVE

Data model - detailed overview

The following URI lists the complete data model:

https://89.26.13.1:8050/zendata/DEMO_AUTOMOTIVE/$metadata

Display of variables

You get an overview of all variables with the URl:

https://89.26.13.1:8050/zendata/DEMO_AUTOMOTIVE/Variables?$format=json

Display of variables with filtering

The display of variables can be filtered. The address below displays the variable with the ID 321

https://89.26.13.1:8050/zendata/DEMO_AUTOMOTIVE/Variables?$format=json&$filter=Id%20eq%20321

Note: You can find a precise description of all filters in the OData online documentation. You can find this documentation on the Internet at the address www.odata.org.


Example of code - calling up OEntity objects from the server

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Data model of the Everywhere Server -> Examples -> Example of code - calling up OEntity objects from the server

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This example shows how information in relation to an OEntity object can be called up from the server. This data can thus be taken on for the user programming. This example also shows how properties can be called up from a data object.

/**

*

* @param position: Object at which position of the entityset should be returned

* @return the finished Item Alarm for the Listt of Alarms

*/

protected Alarm GetAlarmFromEntity(int position) {

Alarm retAlarm = new Alarm();

// We use position as listItemId. Here we could use some other unique id

// to reference the list data

ListView listViewAlarms = (ListView)findViewById(R.id.Alarmlist);

OEntity var = alarms.elementAt(position).getLink("Variable", OLink.class).getRelatedEntity();

int EntityItemCnt= alarms.count();

OProperty<String> varName = var.getProperty("Name", String.class);

OProperty<String> alarmText = alarms.elementAt(position).getProperty("Text", String.class);

String Header = varName.getValue() + " - " + alarmText.getValue();

// Body data

Bundle bodyBundle = new Bundle();

OProperty<?> alarmValue = alarms.elementAt(position).getProperty("Value");

String timeReceived = alarms.elementAt(position).getProperty("TimeReceived").getValue().toString();

String timeCleared = alarms.elementAt(position).getProperty("TimeCleared").getValue().toString();

String Acknowledged = alarms.elementAt(position).getProperty("Acknowledged").getValue().toString();

Date date = new java.util.Date(Long.parseLong(timeReceived));

String dateString = new SimpleDateFormat("dd.MM.yyyy HH:mm").format(date);

retAlarm.setAlarmName(varName.getValue());

retAlarm.setTimeReceived(dateString);

retAlarm.setValue(alarmValue.getValue().toString());

retAlarm.setAcknowledged(Acknowledged);

retAlarm.setCleared(timeCleared);

retAlarm.setAlmText(alarmText.getValue());

return retAlarm;

}


Other examples of code

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Data model of the Everywhere Server -> Examples -> Other examples of code

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Other examples for programming with OData are on the Internet.

The example given shows how how information relating to an OEntity objects can be called up from the server to the end device. This example also shows how properties of a data object can be received.

Link: https://github.com/vorburger/odata4j/tree/master/odata4j-core/src/test/java/org/odata4j

attention Attention

This Internet site is not shown in Internet Explorer!


Using the app on a mobile device (Android)

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Data model of the Everywhere Server -> Using the app on a mobile device (Android)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to use your own applications on a mobile end device (Android), compile it with the Eclipse program.
Eclipse is a programming tool for developing software and was originally used as an integrated development environment for the Java programming language.

info Information

Eclipse is available as a free download.

Installation:

In order to be able to use Eclipse for your development environment, install the program including the Android Developer Bundle.

The following components must be installed on the development computer:

  • The Android Developer Bundle
    The Android Developer Bundle is available free on the Internet.
    Link to the installer: http://developer.android.com/sdk/index.html
    It is important that the correct driver for the mobile device is installed on the Desktop computer. Otherwise no communication between the development computer and the end device is possible.
  • The Java Development and Runtime Environment
    The Java Development Environment (JRE) and the Java Runtime Environment (JSE) must be installed on the development computer.

    JRE and JSE can be downloaded directly form the Java website. Both environments must be installed separately.
    Link to download: www.oracle.com/technetwork/java/javase/downloads/index.html
  • Required libraries:
    To be able to use OData in Eclipse, you then need to link the appropriate library for your preferred development environment in Eclipse .
    Libraries for the common programming languages can be found on the OData Internet site. Select your desired programming language in the tabs shown in order to get to the respective downloads.
    Link to the libraries: www.odata.org/libraries.


Recommended settings for the Eclipse programming environment

Manual -> Mobile applications for zenon -> Everywhere Server by zenon -> Data model of the Everywhere Server -> Using the app on a mobile device (Android) -> Recommended settings for the Eclipse programming environment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure Eclipse for mobile end devices, carry out the following steps:

  1. Select, the Run configurations... entry in the Run menu bar.
  2. The configuration dialog for a new Run configuration appears.
  3. Click on the symbol New launch configuration.
  4. In the Android Application tree, the new entry NEW_configuration is added.
  5. Name your Android app project in the Android tab.
  6. Click on the Browse... button to select your Android project. This is then transferred to the mobile device.
  7. Now connect your mobile end device to the development computer.

  8. Configure your target device in the Target tab.

  9. Ensure that the Always prompt to pick device property is activated.
    Note: In this case, you are asked before execution which device your app is to be executed on.
  10. Start the debug process:
  11. Start the app.
    Note: For the remaining entries, it is recommended that the existing default settings are left unchanged.
  12. After clicking on the Play or Debug buttons, you are requested to select your end device or your emulator in order to start the program.
  13. The app is then started automatically on the end device.


Everywhere App by zenon

Manual -> Mobile applications for zenon -> Everywhere App by zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Apps allow the visualization of a zenon project on mobile end devices, tablets and desktop computers. The range of functions is identical. The graphical user interface varies depending on the operating system used.

The respective apps guide you through your project configuration step by step. You select the respective parameters you want and thus receive the attendant information. Navigation is intuitive and follows a chronological sequence.

The following Apps are available:

  • Everywhere App by zenon for MS Windows Phone
  • Everywhere App by zenon for iPhone and iPad
  • Everywhere App for Desktop for Desktop
  • Everywhere App by zenon for Android

tutorial License information

All apps are available in the manufacturers' stores free of charge.


Requirements

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Requirements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Everywhere App by zenon visualizes the project configuration provided by Everywhere Server on a smartphone, tablet or desktop computer.

System requirements

  • Windows Phone 7.5 or higher (Windows Phone 8 or higher recommended)
  • iOS 6 or higher for Apple iPhone and iPad
  • Windows 8 or higher for Everywhere App for Desktop
  • Android 2.2.x - Froyo or higher

info Information

The Everywhere App by zenon user interface is only available in English.


Installation

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Installation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Carry out the following steps in order to be able to use Everywhere App by zenon on your device:

  • Start the app store.
  • Enter zenon or Everywhere App as a search term.
  • Select Everywhere App by zenon.

Hint Hint

A profile for a demo project is already installed during the installation. You can thus also test Everywhere App by zenon if you have not yet configured your own project with zenon.


Note for OEM user:

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Installation -> Note for OEM user:

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

info Information

Always select Everywhere App by zenon!
The app is used for different products.

Everywhere App by zenon is compatible with all OEM project configurations.


Everywhere App by zenon for MS Windows Phone

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for MS Windows Phone

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


Authentication

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for MS Windows Phone -> Authentication

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The login screen allows you to log in to an Everywhere Server by zenon and to select user profiles.

Parameters

Description

Profile

Name of the selected profile.

  • Tapping on the profile name opens the dialog to select an existing profile.
  • Tapping on the profile name also opens the dialog to create a new profile.

User name

User name for login at the Everywhere Server.

Password

Password for login at the Everywhere Server.

Note: Pay attention to capital letters and small letters when entering the data!

App Bar

login (Symbol >) | Logs the app into Everywhere Server and switches to the next screen.
... | Extends the display of the app bar.


Profile List

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for MS Windows Phone -> Profile List

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The profile overview lists existing profiles and administers these.

Parameters | Description
Profile List | Lists existing profiles. The profile that is currently selected is highlighted in color. Tapping on the desired profile activates the profile and switches to the login screen.

App Bar

Parameters | Description
edit (pencil symbol) | Tapping on the symbol switches to the symbol display from edit (pencil symbol) to add (+ symbol).
add (+ Symbol) | Tapping on the edit symbol makes the add symbol available. Another tap opens the screen to configure a profile.
... | Extends the display of the app bar.

To edit an existing profile:

  • Tap the edit symbol in the app bar.
  • Tap an existing profile from the list.


Edit Profile

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for MS Windows Phone -> Edit Profile

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this screen, existing profiles can be changed and new profiles can be configured.

Parameters

Description

Profile name

Name of the profile:
Freely selectable

Server host name

Name of the Everywhere Server to which a connection is to be created.

Port HTTPS

Port address for the connection to the Everywhere Server.

Default: 8050

Project name

Project name for the connection to Everywhere Server.

Display variables by:

Display of the variables.
Select from drop-down list:

  • Name
    Variable display according to name
  • Identification
    Variable display according to identification
  • Res. Label
    Variable display according to resources label

Remember password:

(Slider)

Save password for input. The setting is also shown as text:

  • OFF: (slider left and bright)
    Password for login is not saved in the profile settings.
  • On: (slider left and dark)
    Password is saved in the profile settings.

Default: OFF

App Bar

Parameters | Description
Save (Symbol) | Saves the current settings and returns to the profile overview.
Delete (Recycle Bin symbol) | Deletes the selected profile.
... | Extends the display of the app bar.


Equipment Model

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for MS Windows Phone -> Equipment Model

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This screen shows the configured equipment model.

Tapping on the equipment model names switches to the next screen with the selection of the equipment groups.

App Bar

continue (Symbol >) | Logs the app into Everywhere Server and switches to the next screen.
logout (X-Symbol) | Ends connection to the server and returns to the login screen.
... | Extends the display of the app bar.


Equipment Groups

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for MS Windows Phone -> Equipment Groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this screen, the configured equipment groups are listed and selected.

Tapping on the equipment model names switches to the next screen with the selection of the allocated variables.

App Bar

continue (Symbol >) | Logs the app into Everywhere Server and switches to the next screen.
logout (X-Symbol) | Ends connection to the server and returns to the login screen.
... | Extends the display of the app bar.


Variables selection

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for MS Windows Phone -> Variables selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this screen, configured variables from the selected equipment group are listed and selected.

Lists all available variables. Select the variables by tapping.

Note: All variables can be selected or deselected with the Extended app bar.

App Bar

continue (Symbol >) | Logs the app into Everywhere Server and switches to the next screen.
logout (X-Symbol) | Ends connection to the server and returns to the login screen.
... | Extends the display of the app bar.

Extended app bar

(only visible if the app bar has been extended by tapping on ...)

select all variables | Activates/deactivates all variables in the list.
clear variables | Shows new screen with detail view of the selected variable(s). Inactive if no variable is selected.


Values view

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for MS Windows Phone -> Values view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This screen visualizes the values of the selected variables. There are two views available.

Variable list

Parameters

Description

Variablenliste

List of selected variables:

Tapping on the variable switches between "normal view" and "detailed view"

  • Normal view:
    Variable name
    Variable value (numerical)
    Variable value (bar display)
  • Detail view:
    Variable name
    Date and time of last update
    Communication type
    Data type of the variable
    value with pointer instrument display


Alarm List

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for MS Windows Phone -> Alarm List

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This screen visualizes active alarms in a list. Alarms can be acknowledged by tapping on the alarm entry.

Alarms

Parameters

Description

Liste mit Alarmeinträgen

List of active alarms:

  • Variable name
    Value
    Date and time of the alarm
    Acknowledged alarm: Yes/No
    Cleared alarm: Yes/No

Tapping on an alarm entry acknowledges that entry.

App Bar

...

Extends the display of the app bar.


Acknowledge alarms

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for MS Windows Phone -> Acknowledge alarms

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

An alarm can be acknowledged by tapping on the list entry.

Acknowledging an alarm with Everywhere App:

  1. Tap on the alarm entry in the alarm screen.
  2. A dialog is opened.
  3. Tap Yes if you want to acknowledge the alarm.
  4. No closes the acknowledgment dialog

After acknowledgment, the entry for the alarm (Acknowledged:) shows the date and time of acknowledgment.


Everywhere App by zenon for iPhone and iPad

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for iPhone and iPad

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


Authentication

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for iPhone and iPad -> Authentication

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The login screen allows you to log in to an Everywhere Server by zenon and to select user profiles.

Parameters | Description
Profilname | Name of the selected profile.
(arrow symbol) | Opens the profile overview screen.
Username | User name for login at the Everywhere Server.
Passwort | Password for login at the Everywhere Server.
Login (Button) | Logs the app into Everywhere Server and switches to the next screen.

Note: Pay attention to capital letters and small letters when entering the data!


Profile List

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for iPhone and iPad -> Profile List

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The profile overview lists existing profiles and administers these.

Parameters | Description
< Back | Switches back to the login screen
Edit | Switches the list of existing profiles into edit mode Note: if the Edit button is clicked, it is displayed as + symbol. A red - in a red cross is placed before it in the list of configured profiles. (the screen to edit the profiles opens by clicking on the profile name.)
> (Symbol) | Opens the screen to edit the profiles.
Profile name | List of the already-configured profiles.

Creating a new profile

  • To create a new profile, click on the + button

Editing a profile

To switch to the editing mode of a profile:

  • Tap on the > symbol, on the right next to the profile name.


Edit Profile

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for iPhone and iPad -> Edit Profile

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this screen, existing profiles can be changed and new profiles can be configured.

Parameters

Description

Cancel

Cancels input and returns to the profile overview.

Save

Saves the input and returns to the profile overview.

Profile name

Name of the profile:
Freely selectable

Server

Name of the Everywhere Server to which a connection is to be created.

HTTPS Port

Port address for the connection to the Everywhere Server.

Default: 8050

Project

Project name for the connection to Everywhere Server.

Display variables by:

(Tool bar)

Display of the variables.
Select from drop-down list:

  • Name
    Variable display according to name
  • Identification
    Variable display according to identification
  • Res. Label
    Variable display according to resources label

Remember password:

(Slider)

Save password for input:

  • OFF: (slider left and bright)
    Password for login is not saved in the profile settings
  • On: (slider right and dark)
    Password is saved in the profile settings

Default: OFF


Equipment Model

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for iPhone and iPad -> Equipment Model

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This screen shows the configured equipment model.

Parameters | Description
Logout | Ends connection to the server and returns to the login screen.
Project name | List of available projects on the Everywhere Server
> (Symbol) | Opens the screen to select an equipment model.


Equipment groups and variables

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for iPhone and iPad -> Equipment groups and variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This screen lists available equipment groups of the selected equipment model as well as the attendant variables.

Header

Parameters | Description
Back | Returns to previous screen. Note: Swipe to the right also returns to the previous screen.
Logout | Ends connection to the server and returns to the login screen.

EQUIPMENT GROUPS

Parameters | Description
List of equipment groups |
> (Symbol) |

Variables

Parameters | Description
Variable list | List of the available variables. Selection/deselection by simply tapping. Selected variables are indicated by a blue tick.

Footer

Parameters | Description
Select/Deselect all | Activates/deactivates all variables in the list.
Show Details | Shows new screen with detail view of the selected variable(s). Inactive if no variable is selected.


Variables selection

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for iPhone and iPad -> Variables selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this screen, configured variables from the selected equipment group are listed and selected.

Header

Parameters | Description
Back | Returns to previous screen. Note: Swipe to the right also returns to the previous screen.
Logout | Ends connection to the server and returns to the login screen.

Variables

Parameters | Description
Variable list | List of the available variables. Selection/deselection by simply tapping. Selected variables are indicated by a blue tick.

Footer

Parameters | Description
Select/Deselect all | Activates/deactivates all variables in the list.
Show Details | Shows new screen with detail view of the selected variable(s). Inactive if no variable is selected.


Values view

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for iPhone and iPad -> Values view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This screen visualizes the values of the selected variables. There are two views available.

Header

Parameters | Description
Back | Returns to previous screen. Note: Swipe to the right also returns to the previous screen.
Logout | Ends connection to the server and returns to the login screen.

Variable overview

Parameters

Description

Variable list

List of selected variables:

  • Normal view:
    Variable name
    Variable value (numerical)
    Variable value (bar display)
  • Detail view:
    Variable name
    Date and time of last update
    Communication type
    Data type of the variable
    value with pointer instrument display

Footer

Parameters | Description
Values (Symbol) | Switches to display of values of the variables. Blue background if active.
Alarms (Symbol) | Switches to display of alarms. Blue background if active.


Alarm List

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for iPhone and iPad -> Alarm List

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This screen visualizes active alarms in a list. Alarms can be acknowledged by tapping on the alarm entry.

Alarms

Parameters

Description

List with alarm entries

List of active alarms:

  • Variable name
    Value
    Date and time of the alarm
    Acknowledged alarm: Yes/No
    Cleared alarm: Yes/No

Tapping on an alarm entry acknowledges that entry.

Footer

Parameters | Description
Values (Symbol) | Switches to display of values of the variables. Blue background if active.
Alarms (Symbol) | Switches to display of alarms. Blue background if active.


Acknowledge alarms

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for iPhone and iPad -> Acknowledge alarms

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

An alarm can be acknowledged by tapping on the list entry.

Acknowledge an alarm with Everywhere App:

  1. Tap on the alarm entry in the alarm screen.
  2. A dialog is opened.
  3. Tap Yes if you want to acknowledge the alarm.
  4. No closes the acknowledgment dialog

After acknowledgment, the entry for the alarm (Acknowledged:) shows the date and time of acknowledgment.


Everywhere App for Desktop

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App for Desktop

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


Authentication

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App for Desktop -> Authentication

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The login screen allows you to log in to an Everywhere Server by zenon and to select user profiles.

Parameters

Description

Profile

Name of the selected profile.

  • Tapping or left-clicking opens the drop-down list to select an existing profile.

User name

User name for login at the Everywhere Server.

Password

Password for login at the Everywhere Server.

login

(Symbol)

Logs the app into Everywhere Server and switches to the next screen.

Note: Pay attention to capital letters and small letters when entering the data!

App Bar

Parameters | Description
edit (pencil symbol) | Tapping or left-clicking opens the screen to configure a profile.


Profile List

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App for Desktop -> Profile List

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The profile overview lists existing profiles and administers these.

Navigation

<-
(Symbol)

Switches to the previous screen.

Parameters

Description

Profile List

Lists existing profiles.

  • The profile that is currently selected is accentuated graphically.
  • Tapping or left-clicking on the desired profile selects the profile.
  • Tap or click the edit symbol to edit the selected profile.

App Bar

Parameters | Description
Edit (pencil symbol) | Switches the selected profile to editing mode.
Add (+ Symbol) | Creates a new profile.
Delete (Recycle Bin symbol) | Deletes the selected profile.
Save (Disk symbol) | Saves changes to the selected profile. Note: Inactive if no profile is being edited.
Reset (X-Symbol) | Discards all inputs. Note: Inactive if no profile is being edited.

To edit an existing profile:

  • Tap or click on an existing profile from the list.
  • Tap or click on the edit symbol in the app bar.


Edit Profile

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App for Desktop -> Edit Profile

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this screen, existing profiles can be changed and new profiles can be configured.

Navigation

<-
(Symbol)

Switches to the previous screen.

Parameters

Description

Profile name

Name of the profile:
Freely selectable

Server host name

Name or IP address of the Everywhere Server to which a connection is to be created.

Port HTTPS

Port address for the connection to the Everywhere Server.

Default: 8050

Project name

Project name for the connection to Everywhere Server.

Display variables by:

(Drop-down list)

Display of the variables.
Select from drop-down list:

  • Name
    Variable display according to name
  • Identification
    Variable display according to identification
  • Res. Label
    Variable display according to resources label

Remember password:

(Slider)

Save password for input. The setting is also shown as text:

  • OFF: (slider left and bright)
    Password for login is not saved in the profile settings
  • On: (slider right and dark)
    Password is saved in the profile settings

Default: OFF

App Bar

Parameters | Description
Edit (pencil symbol) | Switches the selected profile to editing mode.
Add (+ Symbol) | Creates a new profile.
Delete (Recycle Bin symbol) | Deletes the selected profile.
Save (Disk symbol) | Saves changes to the selected profile.
Reset (X-Symbol) | Discards all inputs.


Equipment model and equipment groups

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App for Desktop -> Equipment model and equipment groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This screen shows the configured equipment model. Once an equipment model has been selected, the attendant equipment groups are displayed.

The attendant hierarchy is displayed by selecting an equipment group.
If a selected group contains variables, the view switches to the variable overview screen.

App Bar

Logout
(open lock symbol)

Ends connection to the server and returns to the login screen.


Variables selection

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App for Desktop -> Variables selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this screen, configured variables from the selected equipment group are listed and selected.

Select the variables by tapping or left-clicking.

<- (Symbol) | Switches to the previous screen.
-> (Symbol) | Switches to the next screen.
All | Activates/deactivates all variables.
Show only selected | Only the selected variables are displayed in the screen of the variable view. Inactive if there is not at least one variables selected.

App Bar

Logout
(open lock symbol)

Ends connection to the server and returns to the login screen.


Values view

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App for Desktop -> Values view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This screen visualizes the values of the selected variables. There are two views available.

Select the variables by left-clicking or tapping.

<- (Symbol) | Switches to the previous screen.
-> (Symbol) | Switches to the next screen.

Variable list

Parameters

Description

Variable display

Tapping or left-clicking on the variable switches between "normal view and "detailed view"

  • Normal view:
    Variable name
    Variable value (numeric)
    Variable value (bar display)
    Min, max and unit
  • Detail view:
    Variable name
    Date and time of the last update
    Communication type
    Data type of the variable
    Value in numerical display
    Value with pointer instrument display

App Bar

Logout
(open lock symbol)

Ends connection to the server and returns to the login screen.


Alarm List

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App for Desktop -> Alarm List

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This screen visualizes active alarms in a list. Alarms can be acknowledged by tapping on the alarm entry.

Select the alarms by tapping or left-clicking.

<-
(Symbol)

Switches to the previous screen.

Alarms

Parameters

Description

List with alarm entries

List of active alarms:

  • Variable name
    Value
    Date and time of the alarm
    Acknowledged alarm: Yes/No
    Cleared alarm: Yes/No

This alarm can be acknowledged by tapping or left-clicking.

App Bar

Logout
(open lock symbol)

Ends connection to the server and returns to the login screen.


Acknowledge alarms

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App for Desktop -> Acknowledge alarms

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

An alarm can be acknowledged by tapping on the list entry.

Acknowledging an alarm with Everywhere App for Desktop:

  1. Tap or click on the alarm entry in the alarm screen.
  2. A dialog is opened.
  3. Tap or click Yes if you want to acknowledge the alarm.
  4. No closes the acknowledgment dialog

After acknowledgment, the entry for the alarm (Acknowledged:) shows the date and time of acknowledgment.


Everywhere App by zenon for Android

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for Android

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


Authentication

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for Android -> Authentication

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The login screen allows you to log in to an Everywhere Server by zenon and to select user profiles.

Action Bar - Action Buttons

Parameters | Description
Action Overflow (symbol: three vertical dots) | Click the button to open a drop-down list of the actions.
Edit current profile | Opens the screen to configure a profile.
Quit | Closes the app and switches back to the Start screen of the Android device.

Parameters | Description
Profile | Name of the selected profile. Tapping on the profile name opens the dialog to select an existing profile.
Username | User name for login at the Everywhere Server.
Password | Password for login at the Everywhere Server.
Login | Logs the app into Everywhere Server and switches to the next screen.

Note: Pay attention to capital letters and small letters when entering the data!

App Bar

Parameters | Description
zurück (symbol: curved arrow to the right) | Switches to the previous app screen.
Home (symbol: house) | Closes the app and switches back to the Start screen of the Android device.
nn (symbol: overlaid screens) | Overview of the last apps open on the device.

info Information

The appearance and functionality of the app bar is the same on all screens. This bar is very often already integrated into the hardware of an Android device. In this case, app bar is displayed.


Profile List

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for Android -> Profile List

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The profile overview lists existing profiles and administers these.

Action Bar - Action Buttons

Parameters | Description
< (Symbol) | Switches back one screen.
+ (Symbol) | Creates a new profile and switches to the Edit profile screen.

Parameters

Description

Profile List

Lists existing profiles.

A long click on an entry opens a context menu:

  • Edit profile
    Switches to the profile editing screen. Allows changes to an existing profile.
  • Delete profile
    Deletes selected profile.

Tapping on the desired profile activates the profile and switches to the login screen.

To edit an existing profile:

  • Tap an existing profile from the list.
    Attention: Ensure that you tap on the list entry for a long time.
  • Select the Edit profile entry in the context menu that appears.
  • You switch to the Edit profile screen.


Edit Profile

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for Android -> Edit Profile

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this screen, existing profiles can be changed and new profiles can be configured.

Action Bar - Action Buttons

Parameters | Description
< (Symbol) | Switches back one screen.
Save (Disk symbol) | Saves the current settings and returns to editing the profiles.

Parameters

Description

Profile name

Name of the profile:
Freely selectable

Server host name

Name of the Everywhere Server to which a connection is to be created.

Port HTTPS

Port address for the connection to the Everywhere Server.

Default: 8050

Project name

Project name for the connection to Everywhere Server.

Display variables by:

Display of the variables.
Select from drop-down list:

  • Name
    Variable display according to name
  • Identification
    Variable display according to identification
  • Res. Label
    Variable display according to resources label

Remember password:

(Checkbox)

Save password for input. The setting is also shown as text:

  • inactive:
    Password for login is not saved in the profile settings
  • active:
    Password is saved in the profile settings.

Default: inactive.


Equipment model and equipment groups

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for Android -> Equipment model and equipment groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This screen shows the configured equipment model. Tapping on an equipment model shows the equipment groups contained therein. Tapping on an equipment group name switches to the next screen with the selection of the allocated variables.

Action Bar - Action Buttons

Parameters | Description
< (Symbol) | Switches back one screen.
Logout: (symbol: curved arrow to the left) | Ends connection to the server and returns to the login screen.

Parameters | Description
[name of equipment group] | For easier orientation, either the equipment model name or the equipment group name - depending on the selection - is displayed in orange text above the list.
List of the configured equipment groups or variables. | Lists existing profiles: Clicking on the equipment group name switches to the overview of configured equipment groups. Clicking on an equipment group name switches to the variable overview and lists all variables configured in the equipment group in a list.


Variables selection

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for Android -> Variables selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this screen, configured variables from the selected equipment group are listed and selected.

Action Bar - Action Buttons

Parameters | Description
< (Symbol) | Switches back one screen.
Favorites (star symbol) | Adds the selected variable(s) to the list of favorites.
Delete favorites (Recycle Bin symbol) | Deletes all variables from the list of favorites.
Action Overflow (symbol: three vertical dots) | Click the button to open a drop-down list of the actions.
Display favorites | Displays all variables from the list of favorites in a list.
Display variables | Displays all activated variables of the selected equipment group in a list. To activate a variable, the checkbox in the right column must be activated.
Logout | Ends connection to the server and returns to the login screen.
Display all | Selects all listed variables. This is visualized by a blue tick in the checkbox next to the variable name.


Values view

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for Android -> Values view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This screen visualizes the values of the selected variables. There are two views available.

Action Bar - Action Buttons

Parameters | Description
< (Symbol) | Switches back one screen.
Logout: (symbol: curved arrow to the left) | Ends connection to the server and returns to the login screen.

Variable list

Parameters

Description

Variable list

List of selected variables:

Clicking on the variable switches between "normal view" and "detailed view"

  • Normal view:
    Variable name
    Variable value (numerical)
  • Detailed view:
    Variable name
    Variable value
    Minimum and Maximum value
    Value in bar graph display


Acknowledging alarm list and alarms

Manual -> Mobile applications for zenon -> Everywhere App by zenon -> Everywhere App by zenon for Android -> Acknowledging alarm list and alarms

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The alarms are integrated directly into the value view of the variables. If there is an alarm, a warning sign is shown next to the variable in the value view screen.

A long click on the variable entry opens the attendant alarm entry. The alarm can be confirmed in the subsequent dialog.

Action Bar - Action Buttons

Parameters | Description
< (Symbol) | Switches back one screen.
Logout: (symbol: curved arrow to the left) | Ends connection to the server and returns to the login screen.

Alarms

Parameters | Description
List with alarm entries | The word Alarms_ is placed in front of the variable name. A long tap on an alarm entry opens the dialog to acknowledge an alarm.

Confirm alarm dialog

Parameters

Description

Variablenname

Name of the variable with pending alarm.
The word "Alarm_" is placed in front of the variable name.

Wert

Value of the variable.

Aknowledged:

Alarm confirmed:

  • No:
    Alarm has not yet been confirmed
  • Yes:
    Alarm has already been confirmed

Default: No

Note: This field cannot be changed.

Clear

Alarm ended:

  • No:
    The alarm state still keeps occurring.
  • Yes:
    The alarm state no longer occurs.

Default: No

Note: This field cannot be changed.

Cancel

Closes the dialog and returns to the value view of the variables.

Acknowledge

Confirms alarm and closes the dialog.

Acknowledging an alarm with Everywhere App:

  1. Click on the alarm entry in the value view for a long time.
  2. A dialog is opened.
  3. Tap Acknowledge if you want to acknowledge the alarm.
  4. Cancel closes the acknowledgment dialog

After acknowledgment, the entry for the alarm (Acknowledged:) shows the date and time of acknowledgment.


Notifier App by zenon

Manual -> Mobile applications for zenon -> Notifier App by zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Notifier App by zenon makes it possible to acknowledge alarms that are sent by means of Message Control as an SMS to a Smartphone.

Note: The App is only available for devices with the Android operating system.

tutorial License information

The Notifier App by zenon is freely available. It works together with the Message Control module. This requires a license.


Functionality

Manual -> Mobile applications for zenon -> Notifier App by zenon -> Functionality

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Notifier App by zenon displays SMSs that have been sent by the Message Control module and contain certain key words or have been sent by certain telephone numbers. After receipt, an alarm is played back on the Smartphone for 30 seconds.

If the message is opened within the time period, the user can acknowledge the alarm by SMS or reject it. If the message is ignored, then the information is filed to the Notification-Bar. If this is activated, the acknowledgment screen is called up again.


Configuration

Manual -> Mobile applications for zenon -> Notifier App by zenon -> Configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Key words and telephone numbers, as well as PIN and NA can be set up when the App is started.

To use the App:

  1. Download the Notifier App by zenon from the store.
  2. On the Homescreen, open the Notifier App.

  3. The configuration window is shown.

Configure app

The configuration screen allows the configuration of:

  • Keywords
  • Telephone numbers from which SMSs are received
  • PNA and NA

Configure keywords

To configure keywords:

  1. Click on the button Show Words.
  2. A list of configured key words is shown.

  3. If a key word is selected, it can be deleted by means of a dialog.
  4. To accept a new key word, click on the Add New Item button.
  5. The dialog to add it is opened.

  6. Enter the key word and click on Add.

Configure telephone numbers

To configure telephone numbers from which SMSs can be displayed:

  1. Click on the button Show Numbers.
  2. A list of the configured telephone numbers is displayed.
  3. If a telephone number is selected, it can be deleted by means of a dialog.
  4. To accept a new telephone number, click on the Add New Item button.
  5. The dialog to add it is opened.
  6. Enter the telephone number and click on Add.

Configure PIN and NA

To configure PIN and NA:

  1. Click on the PIN and NA button.
  2. The dialog to enter the PIN and NA is opened.

  3. Enter the necessary PIN for acknowledgment.
  4. Enter the necessary NA for rejecting the alarm.
  5. Click on OK.


Configure keywords

Manual -> Mobile applications for zenon -> Notifier App by zenon -> Configuration -> Configure keywords

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure keywords:

  1. Click on the button Show Words.
  2. A list of configured key words is shown.

  3. If a key word is selected, it can be deleted by means of a dialog.
  4. To create a new key word, click on the + button.
    Note: With Android version <3.0, adding is carried out by clicking on the Add New Item button.
  5. The dialog to add it is opened.

  6. Enter the key word and click on Add.

    Note: Only one single keyword can be entered. Spaces are not permitted:


Configure telephone numbers

Manual -> Mobile applications for zenon -> Notifier App by zenon -> Configuration -> Configure telephone numbers

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure telephone numbers from which SMSs are displayed:

  1. Click on the button Show Numbers.
  2. A list of the configured telephone numbers is displayed.

  3. If a telephone number is selected, it can be deleted by means of a dialog.
  4. To create a new telephone number, click on the + button.

    Note: With Android version <3.0, adding is carried out by clicking on the Add New Item button.

  5. The dialog to add it is opened.

  6. Enter the telephone number and click on Add.

Attention: Telephone numbers must be entered in the format +[country code][number].
Example: +4369912345678


Configure PIN and NA code

Manual -> Mobile applications for zenon -> Notifier App by zenon -> Configuration -> Configure PIN and NA code

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure PIN and NA code:

  1. Click on the button Codes.

  2. The codes for PIN and NA are shown.
  3. To enter or change a code, click in the input field.
  4. The touch keyboard to enter the PIN and NA is opened.

  5. Enter the 4-digit PIN required for acknowledgment.
  6. Enter the 4-digit NA required for rejecting the alarm.
  7. Click on OK.


Receive and acknowledge alarm SMS

Manual -> Mobile applications for zenon -> Notifier App by zenon -> Receive and acknowledge alarm SMS

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Receive alarm SMS

Procedure for receipt of SMS:

  1. The Notifier App by zenon checks all incoming SMSs for key words and sender telephone number.
  2. If the telephone number or a word in the text of the SMS correspond to the set parameters, an alarm is played back for 30 seconds and a notice window is opened.

  3. To accept the alarm SMS and to react to this, click on OK.
  4. If you do not react within 30 seconds, the window is closed, the alarm is ended and information is filed to the Notification-Bar.

Respond to alarm SMS

If the alarm SMS is received, a dialog with the message and response possibilities is opened.

Parameters | Description
Positive Acknowledge | Acknowledges the alarm. An SMS in Alarm-ID;PIN format is sent. The PIN must be stored in the configuration to do this.
Negative Acknowledge | Declines acknowledgment of the alarm. An SMS in Alarm-ID;NA format is sent. The NA must be stored in the configuration to do this.
SMS Text: | Display of the text of the SMS.
Later | Clicking on the button opens the dialog without a reaction. Information is stored in the Notification-Bar.

After an action has been executed, a window with the summary of the last-selected action is displayed.

Close the App by clicking on OK.

info Information

You can also find details on acknowledging the Message Control module in the Acknowledging messages chapter in the Message Control manual.

Execute the app from the notification bar once again

If the alarm is ignored or the Notifier App by zenon is ended without an action, information is sent to the Notification-Bar.

To react to this message:

  1. Click on the alarm symbol.
  2. Select the alarm entry.

  3. The Notifier App by zenon is opened with the window to answer an SMS.


Monitor administration

Manual -> Monitor administration

The monitor administration makes it possible to easily organize several monitors.

The tasks of the monitor administration are:

  • Operation: Mixed operation of 1 and 2 monitor systems.
    For example, three monitors are used in a control room, two are used on a client and the maintenance technician's notebook only has one monitor.
  • Screen output: Free output of a screen on any monitor and changing of the assignment of a screen -> monitor in the Runtime.
    All screen types (such as AML, menus) and functions (such as screen acknowledgement), that are assigned to this screen or this screen are accepted automatically.
  • Adjusting the resolution: Inclusion of computers with different resolutions in one project.
    For example: The monitor resolution when configured is 1680 x 1050. The resolution on the target device is 1024 x 768. In this case, zenon automatically adapts the resolution correctly, but the circles become elliptical due to the different aspect ratio. So it is possible, in the monitor configuration, to correctly define the target resolution for the Runtime.

info Information

The minimum recommended resolution in Runtime is 1024 x 768 pixels. Smaller resolutions can also be configured. However it may then not be possible to operate some online dialogs. This only affects a few dialogs. If these are not used, the resolution can be selected as lower.

Settings in zenon and Windows

The monitor administration in zenon affects frames and screens. It is recommended that the size of the frame is adjusted to the size of the monitor displayed or the monitors to be displayed. Larger frames protrude into other monitors or are not shown in full.

Dialog boxes - even those in zenon - are subject to the Windows settings.

attention Attention

The following is applicable when several projects are used:

  • If more than one project is held in the memory, the active project determines the monitor settings for all loaded projects.
  • If the active project is a single monitor project, no target monitor can by chosen in a multi monitor project.
  • For multi-project administration, the settings of the integration project are always applicable in Runtime.

tutorial License information

Part of the standard license of the Editor and Runtime.


Concept and requirements

Manual -> Monitor administration -> Concept and requirements

Screens are switched to virtual monitors using monitor administration. Virtual monitors are assigned using real monitors. This assignment can be set individually using monitor profiles. Projects can therefore be individualized for different configurations.

The monitor administration relates to:

  • Fixing the default resolution for a project.
    For example, 2048 x 768 for two monitors with a resolution of 1024 x 768 each.
    This is set and fixed for Runtime.
  • Naming of real monitors.
  • Definition of virtual monitors that are assigned to the real monitors.
    With the virtual monitors, it is possible to display a 3-monitor system (3 real and 3 virtual monitors) on a single-monitor system (1 real and 3 virtual monitors), for example.
  • There is the possibility to amend the assignment of virtual monitors to real monitors in the Editor and in Runtime.
    A virtual monitor can therefore be moved to a different real monitor instead of the configured one, for example.
  • Overview window with a screen or monitor overview.
    This makes it possible to quickly select a monitor by selecting the desired screen area in the window. This can also be carried out with optional scrollbars.

Procedure

When using several monitors:

  • Screens are allocated to virtual monitors in screen switching
  • Virtual monitors can be allocated to real monitors as desired

The project can therefore be correctly displayed on different systems with a different amount of monitors with the need for reconfiguration

Engineering

The monitor configuration has different effects:

  • New projects
  • Existing projects

Recommended workflow: With a new project, set up the monitor administration before you define frames and screens. Start by determining the resolution for Runtime.

attention Attention

For the optimum display of zenon in Runtime, the value Less than - 100% is recommended as a setting for the Windows display. Higher values can lead to graphic elements, symbols, texts, etc. not being displayed correctly.


Requirements for the Runtime

Manual -> Monitor administration -> Concept and requirements -> Requirements for the Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The real monitor resolution has to be entered in zenon6.ini, so that the monitor administration works correctly in a multi-monitor system.

Exception: these settings are not necessary for zenon Web Client.

INI entries

The following entries are necessary in the [DEFAULT] area:

  • The entries RT_CXMAINFRAME and RT_CYMAINFRAME define the resolution of the size of the main window (sum of all monitors) in pixels.
    Attention: The numbers entered must be 1 pixel less than the actual monitor size, because counting starts at 0.
  • The entries RT_CXRESOLUTION and RT_CYRESOLUTION define the reference resolution (resolution of the primary monitor) in pixels for the adaptation of the resolution to the target computer in Runtime. It is not necessary to subtract a pixel from this.
Entry | Meaning
[DEFAULT] | Section where the entry is made.
SCREENPROFILE= | Selected monitor profile for current computer. Name of the configuration. For example: ScreenProfile=Standard Is defined on the configuration computer by means of Configuration of general settings. This may need to be defined on other computers by means of a manual entry in zenon6.ini.
RT_CXMAINFRAME= | Width of the resolution of all monitors minus 1 pixel. For example, for two screens with a width of 1280 pixels each: RT_CXMAINFRAME=2559
RT_CYMAINFRAME= | Height of the resolution of all monitors minus 1 pixel. For example, for a screen height of 1024 pixels: RT_CYMAINFRAME=1023 Attention: If the windows toolbar is shown, its height must be considered and more pixels must be subtracted accordingly.
RT_CXRESOLUTION= | Width of the resolution of the target computer in Runtime in pixels, depending on the value of the RT_CXMAINFRAME property. It is not necessary to subtract a pixel from this.
RT_CYRESOLUTION= | Height of the resolution of the target computer in Runtime in pixels, depending on the value of the RT_CYMAINFRAME property. It is not necessary to subtract a pixel from this.

attention Attention

The following configurations can lead to nothing being displayed or images only being displayed on the first screen:

  • If the values are greater than the area that is actually available, it is possible that nothing will be displayed.
    Solution: Correct the data in the INI file.
  • If the Windows task bar is displayed in a fixed position, screens may only be displayed on the first monitor.
    Solution: Set Windows task bar to Hide task bar automatically.
    Or: Define RT_CYMAINFRAME in such a way that nothing is displayed in the task bar, for example: RT_CYMAINFRAME=1023 instead of 1280.

Example

A project was configured for monitors with the resolution 1920x1080.
The project is to be adapted to monitors with a resolution of 1024x768.

Resolution of target computer: Monitor 1 and monitor 2: 1024x768

To do this, the entries in zenon6.ini must be set as follows:

  • RT_CXMAINFRAME=2047 (1024 *2 – 1)
  • RT_CYMAINFRAME=767 (768 – 1)
  • RT_CXRESOLUTION=1024
  • RT_CYRESOLUTION=768


New project

Manual -> Monitor administration -> Concept and requirements -> New project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Define the screen resolution before you start configuration. This resolution should not be subsequently changed, as this can lead to stretching of the screens if the width:height ratio of the resolutions is not the same.

When a new project is created, the screen resolution for the monitor configuration is automatically adjusted to the current screen resolution. If a project is to run on a computer with a different resolution, adjust the settings before starting the configuration.

To be able to assign screens from different real monitors in a different combination, you define as many virtual monitors accordingly.


Adapt existing project

Manual -> Monitor administration -> Concept and requirements -> Adapt existing project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If changes are made to monitor administration in existing projects, all screen switching must be adapted.

However, monitor administration can have advantages for existing products. For example:

  • Suppression of double screens for different resolutions
  • Integration of computers with different numbers of monitors in one network project
    To keep the amount of changes that need to be made low, it is best to work in the overview screen for a low amount of monitors. This way, all monitors can be selected quickly.


Engineering in the Editor

Manual -> Monitor administration -> Engineering in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Editor, you define the administration for:

  • New projects
  • Existing projects

To configure monitor administration:

  1. navigate to the Graphical design node in properties
  2. Click in the Runtime general subgroup in the Monitor administration property
  3. The configuration dialog is opened
  4. Define the general settings
  5. Define the individual settings for different profiles

attention Attention

The frame coordinates for absolute positioning always relate to the upper left corner of the main screen. This must be the monitor that is the furthest to the left.

You can find an example for the configuration of a project with different monitor settings in the example configuration section.


General settings

Manual -> Monitor administration -> Engineering in the Editor -> General settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dialog for configuration of the general monitor properties:

Physical monitors

Property | Description
Physical monitors | Number of real monitors available (hardware). You adjust the settings for the monitors on the profile pages. (see Individual settings and Configuration of real monitors).
Number | Shows the number of currently defined real monitors.

Virtual monitors

Property | Description
Virtual monitors | Number of virtual monitors. You adjust the settings for the monitors on the profile pages. (see Individual settings and Configuration of virtual monitors).
Number | Displays the number of currently defined virtual monitors as V_00 to V_nn. The first real monitor is configured as the standard monitor by zenon.
Change | Clicking on the button opens the dialog to configure the number of virtual monitors.
Names | List of the names of virtual monitors.
Rename... | Opens dialog to rename virtual monitors. Free text input with a maximum of 15 characters.

attention Attention

The first virtual monitor is configured as the standard monitor by zenon.

Monitor profiles

Property | Description
Monitor profiles | Defines central monitor profiles for Runtime. Each monitor profile has its own tab for individual configuration. The configuration of monitor profiles for other computers may need to be carried out manually by means of an INI entry.
Copy... | Creates a new profile based on the selected profile and opens the dialog for entering a name.
Rename... | Opens the dialog for renaming a profile.
Delete... | Deletes the selected profile without confirmation.
Monitor profile which is loaded by the Runtime on this computer | Opens the drop-down list for selecting the profiles which should be used in the Runtime. Note: On a remote computer, you may have to enter the profile in the file zenon6.ini manually:

Monitor resolution

Property

Description

Monitor resolution

Resolution in which the project is carried out in the Runtime. (see also Requirements for Runtime chapter)

Hint: Define these settings before you start engineering the project. Changes later on can cause distortion in the display if the relation width/height does not fit the resolution!
Standard: Resolution of the current computer.

Apply from current monitor

Applies the resolution of the currently active monitor as resolution for the monitor profile.

OK

Applies changes and closes dialog.

Cancel

Discards changes and closes dialog.

Help

Opens online help.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

Define monitor profile on Runtime computer

If you have only the Runtime and not the Editor installed on a computer, you can define the desired monitor profile as follows:

  1. Open the file zenon6.ini with a text editor.
  2. navigate to the [DEFAULT] area
  3. add the following entry:
    ScreenProfile=name of the monitor profile
  4. Save the file and close the text editor

info Information

The standard profile is always loaded by default on the zenon Web Client. However, you can stipulate a different monitor profile using the SCREENPROFILE= entry in zenon6.ini.


Individual settings

Manual -> Monitor administration -> Engineering in the Editor -> Individual settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Each monitor profile is represented in the configuration by its own tab. Here you define the settings for real and virtual monitors and the behavior in Runtime.

Online menu

Property | Description
Online menu | Behavior of the online menu in the Runtime.
Show online menu | Active: The menu is displayed at a screen switch in the Runtime and offers the monitors for which the property Online menu was activated.
Display time | Time in seconds for which the online menu is kept open.
Change label for button "Cancel" | Active: Button used to close the online selection menu is displayed in Runtime. Font of the button can be changed as desired. % shows the remaining seconds until the automatic cancel.
Esc closes the online menu | Active: The online menu can also be closed by pressing Esc.

Appearance in the Runtime

Property

Description

Appearance in the Runtime

Defines display options in the Runtime

Adjust to monitor resolution

Active: The project resolution is adjusted to the monitor resolution of the current computer.

inactive: Here you can fix the resolution of the project, i.e. the resolution of the project is not adjusted to the current resolution.

Take the header into account when making the adjustment

Active: The title height is considered in the frame editor and in the runtime.

This property exists out of compatibility reasons and is usually not needed.

Consider main menu

Active: The menu height is considered in the frame editor and in the runtime.

This property exists out of compatibility reasons and is usually not needed.

Keep aspect ratio
  • Active: If there is a change to a different resolution in Runtime, the aspect ratio is retained.
  • Inactive: The aspect ratio may be changed.

Attention: A change to the aspect ratio can have an effect on the display.
For example:

  • Circles are shown as oval.
  • The connection points are no longer correct for rotated elements.
  • Symbols are displayed as broken up.

Show scrollbars

Active: Scroll bars are displayed in the Runtime. These scroll bars make it possible to navigate in screens that exceed the monitor size.

Physical monitors

Property | Description
Physical monitors | List with all physical monitors and the properties allocated to them.
Change | Opens the dialog for defining the individual properties of the selected real monitor.

Virtual monitors

Property | Description
Virtual monitors | List with all virtual monitors and the properties allocated to them. Screen switching relates to virtual monitors. Virtual monitors are assigned to real monitors in Runtime.
Change | Opens the dialog for defining the individual properties of the selected real virtual monitor.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Defining real monitors

Manual -> Monitor administration -> Engineering in the Editor -> Individual settings -> Defining real monitors

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Clicking on the Change button in the Real monitors section in the tab for the individual setting of a monitor profile opens the dialog to configure real monitors.

Parameters | Description
Name | Name of the monitor. Free text input with a maximum of 15 characters.
Position | Describes the position and resolution of the monitor. For example: Monitor left: 0/0/1680/1050 Monitor right: 1680/0/3360/1050
Monitor does not exist, allocate to | Active: Makes it possible to select another physical monitor from a drop-down list which is allocated to it, for example because it is not currently connected to the computer. The monitor is then displayed on the assigned one in Runtime. Scroll bars make it possible to scroll between both monitor screens.
Show in the online menu | Active: In Runtime, this monitor is offered in the menu each time a screen is switched to that enables individual selection of a monitor.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Configuring virtual monitors

Manual -> Monitor administration -> Engineering in the Editor -> Individual settings -> Configuring virtual monitors

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Clicking on the Change button in the Virtual monitors section in the tab for the individual setting of a monitor profile opens the dialog to configure virtual monitors.

Parameters | Description
Name | Display of the name. This can be changed in the General settings tab.
Set allocation | Settings for the assignment of the lot monitor.
Show in the online menu | Active in Runtime, the online menu for selecting monitors is displayed each time a screen is called up that is allocated to this monitor.
Allocate to physical monitor | Gives a fixed allocation of a virtual monitor to a real monitor. This allocation can be amended using the Monitor assign function.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Change monitor resolution

Manual -> Monitor administration -> Change monitor resolution

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If the monitor resolution is changed in the Monitor administration project property, this has an effect on the frames and the screens therein with their screen elements. Elements contained in screens can be distorted after the change and shown at other positions. When changing the monitor resolution, the global project and the individual projects must be amended accordingly.

Global project

Change of resolution in the monitor administration

If the resolution is changed in the monitor administration dialog of the global project, the size of the frames in the global project is amended accordingly. The size of screens based on these frames and the elements contained therein are also changed.

attention Attention

After the resolution has been changed in the global project, the screens and elements are displayed according to the new resolution. However, in Runtime, they continue to be displayed with the settings of the respective project in which they are used. The resolution must therefore always be amended in the project too.

Change to the frame size

If only the size of the frames is changed in the global project, but the resolution in the monitor administration remains the same, elements in screens that are based on these global frames are also changed.

Integration project and in subprojects

Change of resolution in the monitor administration

Each project has its own monitor administration.

If the resolution is changed in the monitor administration, the size of the frames of this project is amended accordingly. The size of screens that are based on these templates and the elements contained therein are also amended.

Hint Hint
  • For multi-hierarchical projects:
    Amend the monitor administration settings for each project in the editor.
  • Without adaptation to resolution:
    If only the size of the frames and screens is to be changed, but the size and position is not to be changed, then export the screens into an XML file before amendment. Import the screens after the amendment again.

attention Attention

When configuring screen switching in the editor, a list of the monitors that can be selected is shown. The content of this list depends on the last Monitor administration dialog that has been configured and confirmed with OK - regardless of the project in which multi-project administration of this project was carried out. This means: A change in Project A has an effect on the content of the list in Project B.

Solution: Open and confirm the dialog in the project by carrying out a screen switch.

Example

A project has the resolution 1280 x 720. This is to be changed to 1920 x 1080.

Initial situation

There are the following projects with the following settings:

  • Global project with:
    • Frames: maximum 1280 x 720
    • Configured resolution 1280 x 720
  • Integration project:
    • Screens: maximum 1280 x 720
    • Configured resolution 1280 x 720
  • Subprojects:
    • Screens: maximum 1280 x 720
    • Configured resolution 1280 x 720

Configuration

The configuration depends on whether the elements contained in the screens are also to be amended.

Configuration including change of elements:

  1. Global project:

    Change the resolution in the monitor administration to 1920 x 1080. Frames, screens and elements are thus amended.

  2. Integration project:

    Change the resolution in the monitor administration to 1920 x 1080. The setting is thus amended for Runtime.

  3. Subprojects:

    Change the resolution in the monitor administration to 1920 x 1080. The setting is thus amended for Runtime.

Configuration without change of elements:

  1. Export all screens to an XML file.
  2. Amend the monitor resolution
  3. Import the screens from the XML file.


Functions of the monitor administration

Manual -> Monitor administration -> Functions of the monitor administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The monitor administration can be controlled in Runtime using zenon functions.

Available are:

  • Settings for screen switching: The dialog for screen selection is expanded with the settings for monitor allocation.
  • Assign monitor: Makes it possible to allocate a virtual monitor to a real monitor in Runtime.
  • Display overview window: Switches an overview window on in Runtime or closes it. The window shows all configured real monitors or frames and makes it possible to quickly select and switch these.

Settings for monitor selection are available for the following functions:

  • Set focus to frame
  • Close frame
  • Close screen


Settings for screen switching

Manual -> Monitor administration -> Functions of the monitor administration -> Settings for screen switching

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As soon as monitor administration is configured for more than one monitor, there are additional options available for screen switching in the selection dialog for screens to select the monitor on which the screen is to be displayed:

Additional options

Description

Scroll to monitor
  • Active: Scroll bars are shown in Runtime, which make it possible to scroll to the monitor.

Monitor

Selection of the monitor from the drop-down list.

This contains all virtual monitors defined in the monitor administration plus the Current monitor entry.

Virtual monitor: The screen is switched to the monitor that is linked to the selected virtual monitor.

If no real monitor was allocated to the virtual monitor during configuration, but instead the option Display online selection menu was selected, the a selection window to select areal monitor is offered.

Current monitor: Always opens the screen on the monitor from which the call comes. For example:
The button to open the AML is pressed on the left monitor, then the AML is switched to the left monitor. If the button to switch the AML to the right monitor is pressed, then the AML is switched to the right,

In the function overview, the monitor on which the screen is displayed is shown in brackets.

For example:

START (V_00) means: Switching is effected on the START screen and this is displayed on the virtual monitor V_00.
REL means display on the current monitor.

Online menu

If a screen switching function is carried out with the Display online selection menu option activated, the menu to select a monitor is shown before the function is activated. The contents of the menu and the duration it is displayed are defined in the monitor configuration.


Monitor assign

Manual -> Monitor administration -> Functions of the monitor administration -> Monitor assign

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the Monitor assign function, virtual monitors can be assigned to real monitors in Runtime, regardless of the configured assignment.

To configure the function:

  1. Create a new function
  2. navigate to node Screens
  3. Select the Monitor assign function
  4. The dialog to assign a virtual monitor to a real monitor is opened
  5. Create an assignment
  6. Close the dialog by clicking on OK
  7. Allocate a button to the function

Monitor allocation dialog

Parameters | Description
Name | Selection the virtual monitor from the drop-down list. All virtual monitors configured in the monitor administration are listed.
Set allocation | Selection of the assignment by means of radio buttons:
Show in the online menu | Switches to a dialog in Runtime to select the desired real monitor.
Allocate to physical monitor | Allocates a virtual monitor to a real monitor. Monitor is selected from the drop-down list. This list contains all real monitors available in monitor administration.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

The functions are displayed in the detail view with the objective of allocation.

For example:

  • V_00,(ONLINE): The virtual monitor V_00 is assigned to a real monitor in Runtime using the online menu.
  • ???,???: assignment dialog was discarded; no function was carried out.
  • V_00,Left screen: The virtual monitor V_00 is assigned to the real monitor Left screen.


Displaying the overview window

Manual -> Monitor administration -> Functions of the monitor administration -> Displaying the overview window

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Show overview window function displays the overview window in Runtime, which shows the real monitors or frames in a multi-monitor system. A monitor and/or a frame can be activated by means of a mouse click.

To configure the function:

  1. Create a new function
  2. navigate to node Screens
  3. Select the Show overview window function
  4. the dialog for configuring the overview window is opened
  5. Configure the overview window
  6. Close the dialog by clicking on OK
  7. Allocate a button to the function

Displaying the overview window

Settings

Parameters | Description
Settings | The function can either open, close or toggle the overview window. Selection is carried out by means of radio buttons:
Display | Active: The overview window is opened.
Toggle | Active: The display is switched between open and closed.
Close | Active: The overview window is closed.
Display of | Selection of display in the overview window. Either frames or monitors are displayed.
Frames | Active: The overview window divides the screen into frames.
Monitors | Active: The overview window divides the screen into monitors.

Window style

Parameters

Description

Window style

with title

Active: The overview window has a Windows title bar.

System menu

Active: A system menu is displayed if the title bar is activated.

with border

Active: Overview window is displayed with a border. The window size can be adjusted in Runtime by dragging the border. Selection of the border width by means of radio buttons:
  • fine

Active: Bold border.
  • bold

Active: Fine border.

Position

Parameters

Description

Position

Position of the overview window on the screen, calculated in pixels from the upper left edge for:

  • top
  • bottom
  • Left
  • Right

Colors

Parameters | Description
Color |  | Definition of the colors in the overview screen. Clicking on Color opens the palette.
Background color |  | Color of window background.
current view |  | Currently displayed frames/monitors.
Border |  | Color of border.
Selected |  | Selected frames/monitors.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Example configuration

Manual -> Monitor administration -> Example configuration

In this example, you can see possible configurations for the following project requirements:

  1. 1 server with 2 monitors with a resolution of 1680 x 1050 each
  2. 1 client with one monitor with a resolution of 1680 x 1050
  3. 1 notebook for the service team with a resolution of 1024 x 768

Goal

We are configuring the project so that a server with 2 screens can be visualized. For the client, we adjust the settings so that all tasks can be displayed on a single screen. We also change the resolution of the display for the service notebook. When in operation, the corresponding monitor profile must be selected on the corresponding Runtime computer in order to have the correct display.

Start configuration

  1. Configure the INI file in accordance with the instructions in the Requirements for Runtime chapter in order to set the resolution in Runtime.
  2. The basic configuration is set up in the monitor configuration:
    Navigate to Project Properties-> Graphical design -> Runtime general.
  3. Click on the Monitor administration property.
  4. The dialog for monitor configuration is opened
  5. First configure the General settings
  6. Then configure the individual settings for:
    1. The server with 2 monitors
    2. The client with one monitor
    3. The notebook for the Service Team

Other topics in this chapter

General configuration

Configuration with 2 monitors

Client configuration with one monitor

Configuration of Service Team notebook

Other configuration


General configuration

Manual -> Monitor administration -> Example configuration -> General configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following is carried out first for the configuration:

  • General settings are established, such as the number of virtual and real monitors
  • Profiles for the three different configurations are created

General settings

Monitors

For our example, we are defining:

  • 2 real monitors
  • 2 virtual monitors:
    • One for each process screen
    • One for the desired switching of the menu bar: We can thus always determine whether the menu is called up on the right or left, without influencing the process screens.

Just to remind you: Virtual monitors are the objective of screen switches. These are assigned to real monitors in Runtime. Now you have the possibility of routing between the real and the virtual monitors. If, for example, there is no second monitor, such as with a notebook, the screens' output can simply be routed to the left monitor, without changing the configuration of the functions.

Resolution

The set resolution is an important factor. This is the reference size for the amendment. It is set once before the project configuration is started and should not be subsequently changed. If this setting is subsequently changed, all coordinates of the elements are recalculated in the screens.

We enter our target resolution of 1680 x 1050.

Monitor profiles

We create a separate profile for each configuration of our example. In our example:

  • Server 2 Mon
  • Client 1 Mon
  • Notebook small

To do this:

  1. Highlight the Standard profile
  2. Click on Copy
  3. The dialog for renaming is opened
  4. Enter the new name (the length is limited to 15 characters)
  5. click on OK
  6. Repeat the process for all datasets to be configured.

Each profile has its own tab for individual configuration in the monitor configuration.

We are starting with the Server 2 Mon tab.


Configuration with 2 monitors

Manual -> Monitor administration -> Example configuration -> Configuration with 2 monitors

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The first configuration is for our server with two monitors.

We will configure:

  • The online menu
  • The appearance in Runtime
  • The real monitors
  • The virtual monitors

Online menu

The online selection menu makes it possible to select the real monitor that a screen is switched to in Runtime. The following must be the case for this:

  • The online selection menu must be activated
  • In the allocation of the virtual monitor, Display online menu must be selected
    or

    an allocate monitor function must be configured

For our example:

  • Activate the option
  • Select a Display duration of 10 seconds: If no action has been set by then, the menu disappears again
  • Activate the Label option: this means that a Cancel button will be offered in Runtime
  • Label the button with Cancel = %: The remaining time until cancellation is thus shown in the menu
  • Activate the Esc key closes menu option: this means that the menu can also be closed in Runtime using the Esc key

The menu is then displayed in Runtime when a switch to a virtual monitor with an online menu is made:

The real monitors M_00 and M_01 are available. There is still 10 seconds time to make a selection after cancelling. Clicking on Cancel or pressing the Esc button closes the menu immediately.

Screen settings in Runtime

To display the screen in Runtime:

  • Deactivate the Adapt display to screen resolution option: the display thus always remains in the configured size. (if this option is active, the display is adapted to the current resolution.)
  • Activate the Display scroll bars option: this provides scroll bars in Runtime that make it possible to scroll through the screen

Configuration of real monitors

Two monitors are available on the server. The two real monitors from the example project are configured accordingly.

The second monitor, for example, receives the corresponding coordinates in order to connect to the first monitor on the right horizontally.

The name can be set for each configuration. To configure monitors:

  1. Open each of the monitors in sequence by clicking on the Change button
  2. Give it a name; in our example this will simply be M_00 and M_01
  3. Deactivate the Monitor does not exist... option (we need this in the other configuration)
  4. Enter the coordinates.
    The calculation is made from the upper left corner of the left monitor
  5. Activate the Display in online menu option, so that the monitor is also available in Runtime

Configuration of virtual monitors

In this configuration, the virtual monitors are assigned to the real monitors.

Just to remind you: Screen switches refer to real monitors. Assignment of virtual monitors decides the real monitor on which the screen is actually switched.

In our example, there are three virtual monitors available. The two first ones are each assigned to a real monitor. The third virtual monitor makes it possible to switch the menu bar on or off as desired. This is not assigned to a real monitor, but this allocation should be offered in the online menu.

To assign the first two virtual monitors:

  1. Open each of the monitors in sequence by clicking on the Change button
  2. The names are only displayed; they are the same for all profiles and can only be changed in the General tab
  3. Select Assignment to real monitor
  4. Select the desired real monitor from the drop-down list.
    • M_00 for Left monitor
    • M_01 for Right monitor

Configuration of the third virtual monitor is similar.

Difference: instead of Assign to real monitor, select the Display in online menu option.

The profile is therefore configured for the server with 2 monitors.

Now change to the Client 1 Mon tab.


Client configuration with one monitor

Manual -> Monitor administration -> Example configuration -> Client configuration with one monitor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration for the client with one monitor generally corresponds to server configuration. However, there is only one screen available here. This results in two significant differences:

  1. The second real monitor must be mapped onto the first one
  2. The online selection menu for the menu bar is superfluous; it is assigned directly

For the real monitors:

  1. Open the configuration of the monitors M_01
  2. Activate the Monitor does not exist, therefore assign to option
  3. Select from the M_00 drop down list

The online selection menu is not needed in Runtime, but you can leave the options active.

For virtual monitors:

  1. Open the configuration of the monitor Menu bar
  2. Activate the Assign to real monitor option
  3. Select from the M_00 drop down list

The whole configuration for Client 1 Mon now looks as follows:

Now only the notebook configuration is missing from our example. Change to the Notebook small tab.


Configuration of Service Team notebook

Manual -> Monitor administration -> Example configuration -> Configuration of Service Team notebook

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The configuration of the notebook for the service team corresponds to the configuration of the client computer with a monitor. The resolution is different however. This must be adjusted. To do this:

  1. Open the configuration of the real monitor M_00
  2. Enter the corresponding coordinates,
    in our example: 0/0/1024/768

The resolution is now adjusted to the real resolution of the notebook and monitor M_01 is mapped to monitor M_00 as on the client. You will now have scrollbars in Runtime to be able to scroll the display.

All other settings correspond to those of the client computer:

Confirm the configuration by clicking on OK.


Other configuration

Manual -> Monitor administration -> Example configuration -> Other configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the project, you must subsequently:

  • For screen switches, select the virtual monitor that the screen is to be switched to
  • Define the respective monitor profile to be used on the different computers (for the configuration computer, select the profile in monitor configuration)
  • For functions such as Set focus on frame, Close frame or Close screen decide the monitors for which the action is applicable
  • If necessary, configure an Assign monitor function, to be able to assign virtual monitors to real monitors in Runtime regardless of the initial configuration
  • Configure an overview window in order to be able to navigate easily in Runtime


Monitor administration in Runtime

Manual -> Monitor administration -> Monitor administration in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There are different possibilities available in Runtime,

  • for selecting monitors
    and
  • navigating between monitors

info Information

If Runtime is started via a Remote Desktop connection, the resolution of the Remote computer is used. The resolution may then possibly be different to that configured, whereby differences in the display may occur.

The resolution of the remote monitor can also be defined by means of an INI file (See Setting monitor profile on Runtime computer section in the General settings chapter).


Monitor selection in Runtime

Manual -> Monitor administration -> Monitor administration in Runtime -> Monitor selection in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There are different options available for assigning virtual monitors to real monitors in Runtime:

  • Online selection when being called up
  • Assign monitor function

Online menu

If a screen switching function is carried out with the Display online selection menu option activated, the menu to select a monitor is shown before the function is activated. The contents of the menu and the duration it is displayed are defined in the monitor configuration.

Assign monitor function

The Assign monitor function makes it possible to call up the online menu regardless of screen switching and to allocate virtual monitors to a real monitor.


Navigation in Runtime

Manual -> Monitor administration -> Monitor administration in Runtime -> Navigation in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Navigation between monitors is possible in Runtime by means of:

  • Overview Window
  • Scroll bars

Overview Window

Overview windows are configured as a function. Either a specific function is created for displaying and closing the overview window, or you use the toggle function to switch between the window being switched on or off.

A window is shown in Runtime when the function is carried out. This shows the complete screen area available, divided into monitors or frames. Different functions must each be configured for the display of frames and monitors.

Monitors or frames are selected by clicking the mouse in the window.

Scroll bars

Screens can be navigated quickly using scroll bars. Scroll bars are displayed if:

  • The Display scroll bars property was activated in the monitor profile
  • A real monitor or a different real monitor is mapped


Multi-Touch

Manual -> Multi-Touch

With zenon, touch screens can also be operated with Multi-Touch gestures.
You can obtain an example project from your zenon consultant.

Requirements

The following is recommended for Multi-Touch:

  • Activation of DirectX hardware for the zenon property Graphical design/Graphics quality In doing so, note the recommended minimum requirements from the System requirements when using DirectX chapter.

Configuring Multi-Touch

To use Multi-Touch:

  1. Deactivate the Windows CE project project property
  2. Configure Multi-Touch in:
    1. project properties
    2. screen properties
    3. properties of the dynamic elements

Amendment in project properties

To amend the project property:

  1. go to group Interaction
  2. Select the Recognition function in the in Multi-Touch group
    • Windows 7: activates
      gestures that are supported by Windows 7, as well as Multi-Touch in VSTA
      Multi-Touch for zooming and scrolling in worldview
    • Windows 8: activates
      gestures that are supported by Windows 8, as well as Multi-Touch in VSTA
      Native Windows 8 Multi-Touch support
  3. Select the desired properties in the other subgroups:
    • Input visualization for pen
    • Input visulization for touch

attention Attention

In the Control Panel of Windows 8, the visualization of the Finger and pen input can be set globally:

  • If the visualization is deactivated, then there is also no visualization in zenon, regardless of what has been configured.
  • If "Optimize visual feedback for the output to an external monitor" is used, then the visual feedback is enhanced and always displayed in zenon, regardless of the settings in the project properties.

Default: Visual feedback is activated but no enhanced. The behavior can also be set with zenon.

Adaptation of screens and dynamic elements in the projects

In the project, you can find configuration options for Multi-Touch with the following properties:

  • For screens, in the groups:
    • Interaction
    • Programming interface
    • VSTA gesture recognition
  • For dynamic elements, in the groups:
    • VSTA gesture recognition


Gestures

Manual -> Multi-Touch -> Gestures

With zenon Multi-Touch, you have all Windows based gestures available. You can see the amount of input points that your touch system provides in the system properties in the System area.

Windows 7 gestures

Selection of gestures that are often used in zenon:

Gesture | Description | Windows standard
Select | Touching an object, followed by a movement of the finger in one direction. | Drag with the mouse or selection.
Press and hold | Press the target and tap with a second finger. | Right click.
Tap and hold | Press, wait for the ring animation, release. | Right click.
Gestures | Quick pulling movement in one direction. | Move up, down, forwards or backwards.
Tap/Double tap | Tap with one finger or tap twice quickly. | Click/double click.
Slow moving | Move one or two fingers up or down. | Scroll.
Zoom | Moving two fingers away from one another. | Zoom (Ctrl button plus mouse wheel).
Two-finger tap | Tap at the same time with two fingers. The target is between the fingers. | None.

Windows 8 gestures

Selection of gestures that are often used in zenon:

Gesture | Description | Windows standard
Press and hold | Press the target and tap with a second finger. | Right click.
Tap and hold | Press, wait for the ring animation, release. | Right click.
Tap/Double tap | Tap with one finger or tap twice quickly. | Click/double click.
Flick | Move one finger quickly in the direction in which the screen is to move. Is for quick screen scrolling in menus or pages or to move sideways in hubs. | Scroll.
Pan | Touch page with one or two fingers and move by dragging. | Scroll.
Drag | Place one finger on the object and drag with the finger. | To switch between screens or menus. Select and move objects.
Zoom | Moving two fingers away from one another. | Zoom (Ctrl button plus mouse wheel).

Behavior of zenon for 2-finger gestures (Windows 8)

If the screen is touched with two fingers in Windows 8, the action depends on the elements that are touched.

Behavior when a button is held:

  • First finger touches and holds button with linked function:
    • The button is pressed.
  • The second finger touches the screen outside the button:
    • The action of the button is canceled; the button is shown as not pressed.
    • Multi-Touch actions that have already started are canceled.
    • A new Multi-Touch action is searched for (zooming, for example).

Behavior with second finger on button:

  • First finger holds empty position in the screen:
    • No action.
  • Second finger touches and holds button:
    • No action is triggered for the button. It behaves as though the second finger was also on an empty position in the screen. Multi-Touch actions are possible for the screen.


Configuring the interaction

Manual -> Multi-Touch -> Configuring the interaction

With Windows 8 gestures, interaction can be configured in many areas via Multi-Touch via properties with no additional programing necessary.

Requirement: In the project properties, Windows 8 must be selected in the Interaction node for the Recognition property. zenon must be running on a Windows 8 computer in Runtime.

Configuration

Interactions can be configured for:

  • Some screen types
  • Dynamic screen elements
  • Touchboxes

The actions that can be assigned to gestures depends on the screen and/or screen element that is to be configured.

To configure interactions for screens:

  1. Set the focus to the desired screen
  2. navigate to the Interaction node in properties
  3. Select the desired properties in the subgroups

To configure interactions for screen elements:

  1. Set the focus to the desired screen element
  2. navigate to the Runtime node in properties
  3. Select the desired properties in the subgroups

info Information

Frames can also be moved with the mouse if the screen is not a worldview. To do this, the Move Frame via mouse property must be activated. In Runtime, a left mouse click in a free area of the screen and then moving the mouse with the mouse button held down moves the whole screen.

Reciprocal effects

The Move Frame via mouse property cannot be activated at the same time as the properties Move horizontally and Move vertically. Either movement of a frame with a mouse, or the horizontal/vertical movement by means of touch operation can be activated.

Note this special case: With the following scenario, both properties are set and remain unconfigurable after that:

  • The Move horizontally or Move vertically property is activated.
  • Recognition project property for Interaction is set to Windows 7 or deactivated.
  • Move Frame via mouse property is activated.
  • Recognition property is set to Windows 8 again.

Solution:

  • Set the Recognition property back to Windows 7 or deactivated.
  • Deactivate the Move Frame via mouse property.


Reactions

Manual -> Multi-Touch -> Configuring the interaction -> Reactions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Reactions to gestures can be individually configured for screens and screen elements:

  1. The following are available in the Interaction group for supported screens:
    • Reactions to Tap and hold
    • Reactions to Double tap
  2. The following are available in the Runtime group for dynamic screen elements:
    • Reactions to Tap and hold
  3. In the Runtime group, the following are available for various elements, depending on the screen type:
    • Double tap
    • Tap

Reactions are used to define what happens when the respective gesture is detected on the screen or screen element in Runtime.

  • Reaction: Selection of the desired reactions from the drop-down list. The reactions that are available depend on the screen type/element.
  • Function: Selection of a function configured in zenon if Execute own function was selected.

Note: There is a significant difference between screens and screen elements with Execute own function: Interlockings and user rights can also be configured for screen elements. This is not possible for screens, because the screen does not have screen functions.

Screens

  • can be used for runtime environments that are not touch-compatible
  • are backwards-compatible: new gestures can also be supported and gestures can also receive new settings

If a screen is copied, the respective properties that have been set are accepted.


Manipulation

Manual -> Multi-Touch -> Configuring the interaction -> Reactions -> Manipulation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Screens and certain screen elements can be manipulated with touch gestures. You can define the desired reaction for a gesture in the Editor in Manipulation group for:

  • Move (only diagram window in Extended Trend)
  • Move horizontally
  • Move vertically
  • Zoom

Whether screens or screen elements are manipulated depends on the setting of the configuration of the size:

  • Screen size from frame property active: The screen is manipulated (moved, zoomed).
  • Worldview: The respective active element in the screen is manipulated provided the element supports this.
    Definition of worldview: Screen size from frame property is inactive and the screen is larger than the frame.

info Information

The Move Frame via mouse property cannot be activated at the same time as the properties Move horizontally and Move vertically. Either movement of a frame with a mouse, or the horizontal/vertical movement by means of touch operation can be activated.

Note this special case: With the following scenario, both properties are set and remain unconfigurable after that:

  • The Move horizontally or Move vertically property is activated.
  • Recognition project property for Interaction is set to Windows 7 or deactivated.
  • Move Frame via mouse property is activated.
  • Recognition property is set to Windows 8 again.

Solution:

  • Set the Recognition property back to Windows 7 or deactivated.
  • Deactivate the Move Frame via mouse property.

Zoom

A screen can only be zoomed within the limits that have been set for the following properties:

  • Width (maximum) [pixels]
  • Height (maximum) [pixels]
  • Breite(Minimum) [Pixel]
  • Höhe(Minimum) [Pixel]

If a limit has been reached when zooming, then an attempt is made to continue zooming in the free directions. The page ratio is taken into account in the process.

Faceplate screens cannot be zoomed.

Faceplates

With faceplates, both the faceplate screen and each screen container have their own gestures for manipulation. Gestures have an effect on the screen container if the faceplate screen is not a worldview.

Gesture effect in detail:


Double tap

Manual -> Multi-Touch -> Configuring the interaction -> Reactions -> Double tap

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Double tapping on screens

The following screens are available as a reaction to Double tap:

  • No reaction
  • Execute own function
  • Display status window

Double tapping on elements in screens

AML

The AML list in the AML screen aids as Reaction for Double tap:

  • No reaction
  • Execute own function
  • Acknowledge alarm: for selected alarms
  • Execute alarm: for selected alarms
  • Help for executing alarm: for selected alarms
  • Stop/continue list: independently of alarms.

Double tapping on a list entry always leads to this being selected and the corresponding function being executed. Double tapping in an area outside the list entries only leads to independent functions, but no alarm-specific functions.

Extended Trend

The diagram window in an Extended Trend screen aids as Reaction for Double tap:

  • No reaction
  • Execute own function
  • Zoom to 100 %
  • Rezoom

Lists in other screens

Some lists in screens aid as Reaction for Double tap:

  • No reaction
  • Execute own function


Tapping with screen elements

Manual -> Multi-Touch -> Configuring the interaction -> Reactions -> Tapping with screen elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following are available for screen elements as Reaction on Tap:

  • No reaction
  • Execute own function
  • Apply


Tap and hold

Manual -> Multi-Touch -> Configuring the interaction -> Reactions -> Tap and hold

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Pressing and holding on screens

The following screens are available as a reaction to Tap and hold:

  • No reaction
  • Execute own function
  • Display status window

Pressing and holding on screen elements

The following are available for screen elements as a reaction to Tap and hold:

  • No reaction
  • Execute own function
  • Display context menu


Evaluating events

Manual -> Multi-Touch -> Evaluating events

Events that are to be evaluated via the programming interface can be defined in detail for screens. The evaluation is carried out via VSTA at screen level. To configure the evaluation of events: the Recognition property in the project properties for Interaction must be set to Windows 8

  1. go to group Programming interface
  2. go to subgroup Multi-Touch events
  3. Select the desired property from the drop-down list of the Raw data event routing property:
    • All events: all events are evaluated
    • Deactivated: the evaluation is deactivated
    • Only selected events: only the events activated via checkboxes are evaluated

The following events are available:

  • PointerDown
  • PointerEnter
  • PointerLeave
  • PointerUp
  • PointerUpdate
  • PointerWheel
  • PointerHWheel
  • PointerDeviceChange
  • PointerDeviceInRange
  • PointerDeviceOutOfRange
  • NCPointerDown
  • NCPointerUp
  • NCPointerUpdate
  • PointerActivate
  • PointerCaptureChanged

You can find details about events in the Object model section or at the Microsoft Help for MSDN (http://msdn.microsoft.com/en-us/library/hh454903(v=vs.85).aspx).


VSTA gesture detection

Manual -> Multi-Touch -> VSTA gesture detection

The properties for VSTA gesture detection make it possible to activate and deactivate the flags of the interaction contexts separately. You can find the properties for the VSTA gesture detection in the properties for:

  • Screens: Gestures that relate to the screen
  • Dynamic elements: Gestures that relate to an individual dynamic element

The properties are only available if the Recognition property is set in the project properties for Interaction on Windows 8.

The selected configuration is available in Runtime and can be edited via VSTA.

You can find details about events in the Object model section or at the Microsoft Help for MSDN (http://msdn.microsoft.com/en-us/library/windows/desktop/hh448838(v=vs.85).aspx).

Screens

You can find the properties for the VSTA gesture detection for screens in the VSTA gesture recognition properties group of the screen. As soon as the Gesture recognition active property was activated, the following gestures are available for selection:

  • Manipulation
  • Exact
  • Translation X
  • Translation Y
  • Rails X
  • Rails Y
  • Translation inertia
  • Rotation
  • Rotation inertia
  • Scaling
  • Scaling inertia
  • Cross slide
  • Cross slide horizontal
  • Cross slide select
  • Cross slide speed bump
  • Cross slide rearrange
  • Cross slide exact
  • Tap
  • Tap double
  • Secondary tap
  • Drag
  • Hold
  • Hold (mouse)

Dynamic elements

You can find the properties for the VSTA gesture detection for dynamic elements in the VSTA gesture recognition properties group of the element. As soon as the Gesture recognition active property was activated, the following gestures are available for selection:

  • Manipulation
  • Exact
  • Translation X
  • Translation Y
  • Rails X
  • Rails Y
  • Translation inertia
  • Rotation
  • Rotation inertia
  • Scaling
  • Scaling inertia
  • Cross slide Cross slide horizontal
  • Cross slide select
  • Cross slide speed bump
  • Cross slide rearrange
  • Cross slide exact
  • Tap
  • Tap double
  • Secondary tap
  • Drag
  • Hold
  • Hold (mouse)


Example project for Windows 7

Manual -> Multi-Touch -> Example project for Windows 7

This example project for Multi-Touch under Windows 7 is designed for a resolution of 1920x1080. It contains:

  • Start page
  • Navigation
  • Alarm Line
  • Screen of type Login

Start page

The start page displays an overview of the complete production line. Several equipment Icons are visible at the same time. You can scroll to other equipment using gestures. Tap on an Icon changes to the selected equipment. The following is also available in the screen:

  • Alarm line at the top edge: Displays the last alarm of the complete production line. You can drag out the alarm line. This will display the whole Alarm Message List.
  • Login button: Makes it possible to log in different users.
  • Exit button: Closes the Runtime and can only be operated by users with administrator rights.

Navigation

In the lower screen area, the navigation depicts the whole production line with the help of Icons in a horizontal scroll area. In addition an energy worldview is available. It is selected via the button located at the lower center. A machine is selected with a Tap on a visible Icon. In this project only the equipment Filler can be selected. If you press and hold the Filler Icon long enough, a Glow effect is displayed. The list can be scrolled using a Swipe gesture; a Tap on the scrolling list stops this again.

The scroll speed is determined via the acceleration of the Drag movement:

  • Slow: follows the finger
  • Faster: follows quickly behind

The navigation is centered on the Filler Icon when the start screen is called up.

Alarm Line

At the top edge of the screen an alarm line is located. It displays the last alarm of the complete production line. It can be opened to display the Alarm Message List.
Operation:

  • Open:
    • A Tap on the line opens the AML up to the half of the screen.
    • Via gestures the AML can be customized to an individual size.
  • Close:
    • A Tap outside of the frame closes the opened AML.
    • You can also move up the AML manually.

Login screen

The Login screen offers a gesture-based login in the style of Windows 8. Before you enter a password, you must select a user by means of a Tap. After that you can start entering the password for the selected user via Hovering. For example:

Administrator:

Maintenance:

Operator:

In addition there is a logout button which logs out the currently logged in user and opens the login screen. The login screen is a modal dialog which dims the background.


Equipment screen

Manual -> Multi-Touch -> Example project for Windows 7 -> Equipment screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The equipment screen offers the alarm line with the same functionality as on the start page. filtered for the piece of equipment.

In addition, there is the Workspace concept with freely positionable windows, which are stored in a Dock when they are not used. The Workspace spans several screens to which you can change via Swipe gesture, Tab navigation or navigation button. In the lower area there is a activation area for two-hand operation and a home button. At the right top edge there is an operable display for the Workspace.

Dock

Icons can be dragged from the Dock to the Workspace where they are then displayed as a Faceplate in a defined base size. If a Faceplate is placed on the Workspace , its Icon is displayed as deactivated. If a Faceplate is closed, its Icon is activated again. Tap & hold on a deactivated Icon pinpoints an open Faceplate and jumps to the Workspace used by it.

Workspace

You can place an scale any number of Workspaces on each of the four personalizable Faceplates

  • Faceplate Move to the vertical screen edge: After a delay of 2 seconds, a change to the next Workspace is carried out and the Faceplate can be positioned freely.
  • Faceplate Jump to the vertical screen edge (Swipe gesture): The Faceplate is moved to the next Workspace, the current Workspace remains open.
  • Faceplate Close/remove: Move Faceplate to the dock or down via a Swipe gesture.
    As an option, each Faceplate can be closed via the X button, which is located at the top right corner.

The Faceplates called up, their position, size, etc. are saved in the user profile. A Faceplate can be resized (larger/smaller) via a Zoom/Pinch gesture. Each Faceplate can also be moved. A selected Faceplate is moved to the foreground via Z-Order-Manipulation but always remains behind the alarm line. At the next login the position and size data of the individual Faceplates are read and they are positioned accordingly.

Two-hand operation

In the bottom left corner there is an activation area for two-hand operation. If a locked element is actuated, the activation area flashes and a locked element can be unlocked via this area.

Possibilities for two-hand operation:

  • Button: for example home
  • Input set value: Keyboard is called up and set value can be entered,
  • Jog operation

A consideration of the activation order (activation before action) is engineered in the demo project. At jog operation (Faceplate operation) the active activation is constantly checked.

Circle menu

The circle menu was implemented for faster navigation between Workspaces. It is activated using Tap&Hold anywhere on the Workspace and is displayed around the finger touching the screen. The workspace is selected by Draggen the finger in one of the areas. The switch is carried out when the finger leaves the screen. The action can be canceled by Draggen outside or inside the menu area.

Home button

There is a Home button in the right bottom corner. With the help of the home button you can switch to the start screen. The Home button can only be activated with two-hand operation.


VSTA Code

Manual -> Multi-Touch -> Example project for Windows 7 -> VSTA Code

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Class description

MultiTouchManagement

Complete handling of the whole Multi-Touch application. At creating the MultitouchManagement class, the classes LoginWindow, NavigationsWindow and WindowManagement are instanced.

LoginWindow

In this class the important component of the user login and the password pattern recognition are included.

NavigationWindow

Handles the "Icon" faceplate positioning screen and manages the whole opening process of the Faceplates which are called up.

WindowManagement

Is responsible for processing all touch events of all faceplates (move, scale, etc.). In addition, this class takes care of saving and reading all needed Faceplate information in the Runtime.

WindowProperties

For each Faceplate, an independent instance is instanced, which provides all necessary data of the Faceplates . In terms of data retention, all instances are saved in an XML file when Runtime is closed and can therefore provide the last valid settings of the Faceplates at the start of Runtime.


Basic information on Multi-Touch with Windows 7

Manual -> Multi-Touch -> Example project for Windows 7 -> Basic information on Multi-Touch with Windows 7

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Events

If you activate project setting Multi-Touch active, you get the events for TouchManipulationStartEvent, TouchManipulationDeltaEvent, and TouchManipulationCompleteEvent for corresponding event handler declaration in the Runtime. Via method SetupTouchInertia you can define the inertial parameter for each screen. The following display shows a schematic process of the fired events:

Generally a TouchManipulationStartEvent is fired first. As long as you execute the gesture, TouchManipulationDeltaEvents and at the end of the gesture a concluding TouchManipulationCompleteEvent is fired. The handed over parameter IContacts gives back the number of the fingers currently on the screen.

After finishing the touch gesture the inertia values are calculated by the inertia processor via the values handed over by method SetupTouchInertia and finished via TouchManipulationDeltaEvents and the calculated inertia values with a singular TouchManipulationCompleteEvent.

As no finger is on the screen during the calculation of the inertia values, the handed over IContacts parameter is 0. The number of the TouchManipulationDeltaEvents needed by the inertia processor depends on the handed over parameters by method SetupTouchInertia. Depending on the inertia the inertia processor needs more or less events to finish the gesture.

If during the firing of the calculated inertia events another gesture is started, no additional TouchManipulationDeltaEvents come from the old gesture. After a concluding TouchManipulationCompleteEvents, the events for the new gesture are started immediately via a TouchManipulationStartEvents.

In addition events TouchEvent, ElementMouseOver, ElementLeftButtonDown and ElementLeftButtonUp are fired at a gesture.

Native Multi-Touch in the worldview

To implement zooming and scrolling via VBA/VSTA Events, property Multi-Touch for zoom and scroll must not be active. If you activate this property, zenon take care about the zoom and scroll gestures in the engineered worldview. For more information see chapter: Navigation with Multi-Touch in the worldview.


FAQs

Manual -> Multi-Touch -> Example project for Windows 7 -> FAQs

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Frequently asked questions and practical answers.

Note: The properties Name for object list and Help chapter can be used in zenon as freely definable properties.

How do I add a new Faceplate?

The example project consists of 13 Faceplates, which are displayed as Icons in the Navigation_Bottom navigation screen. To generate a context between the individual icons and the Faceplates to be used, you must adhere to the name convention. The name of the respective Icons must be a perfect match with the corresponding screen and its frame. A connection between the screens can only be accomplished when this chain (Icon - frame - screen) is observed.

To call up the respective screens, you also must engineer a screen switch function. The name of the screen switch function consists of the prefix "scr" and the name of the Faceplates. If this name convention is observed, the complete handling is then managed by the Multi-Touch Management.

How to create feedback if the pressed button or the value display element needs two-hand operation?

To ensure two-hand operation, both pressure points must be provided each on an own screen and frame. In the example project, the screen is called Enabler.

At engineering the interlocking must be linked with enableArea for two-hand operable elements. This engineering makes sure that feedback is automatically generated provided the Enabler (two-hand operation) is not pressed. This element is only operable if the Enabler is pressed.

How to create a jog mode button?

To create a button with a jog operation functionality:

  • make sure that the name of the button contains the part name "HOLD"
  • navigate to the Runtime node in the element properties
  • enter a reference according to the following pattern in property Name for object list: Variable name|value change
    (You can find an example in the Faceplate_Operation screen - the ^^^ button.)

How to create a button for changing the Workspace?

For this you can use prefab symbol Tab. The variable demoCurrentWorkspace depicts the value of the currently active Workspace in the whole project. The following settings manipulate the variable and newly adjust all opened screens:

Group tab_inactive:

The Help chapter property must contain the WorkspaceSwitch entry.

property Name for object list must contain an entry according to the following pattern: demoCurrentWorkspace|PAGE (for example: demoCurrentWorkspace|3)

How to create a new user?

In screen Login you must draw a user-specific pattern on the 16 possible square for logging in a user. As soon as you touch the first square, the password input is triggered. It is closed as soon as the finger leaves the screen. Immediately after the pattern is entered, the password is verified. The login is carried out automatically after positive acknowledgment.

During the input of the password pattern a typographic password is created in the background which can be compared with the engineered project users via a function. The first square is interpreted as 'A', the second as 'B', etc. and put together to a coherent password via line-dependent hovering of the squares.

To add a new user:

  • create a new user in the user administration
  • create a personal password
  • make sure that the user can be selected in screen login and engineer the same properties as for the already engineered buttons of the user selection

How to call up the circle menu?

The circle menu is opened.

  • around a finger which touches the workspace
    and
  • does not move for more than 800 ms

In the circle menu, you have the possibility to switch between the Workspaces to the desired Workspace by dragging your finger.

How to filter the freely pull-down AML?

The AML always stays called up and the equipment-based filtering is carried out by a simple filter possibility of the screen switch function to screen AML and AML-collapsed.

How to call up a piece of equipment?

Items of equipment are displayed via a fixed order of processes such as customizing the filter, screen switch function, calling up equipment-related navigation areas, positioning the equipment-dependent Faceplates, etc. In this example project, the order of the functions which are to be called up is engineered in a zenon script, which is called up at triggering the equipment Icons in the start screen.

Where is the information of the Faceplates saved?

Size, position, workspace, visibility, and scaling factor are written in a configuration file. These are located in a subfolder of folder %HOMEPATH%\AppData\Local\Ing._Punzenberger_COPA-DA\.


Navigation with Multi-Touch in the worldview

Manual -> Multi-Touch -> Navigation with Multi-Touch in the worldview

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Multi-Touch gestures for zooming and scrolling are suitable for navigation on touch panels in the worldview. For this a screen of type Worldview overview is not necessary. The navigation can be implemented with:

  • Windows 7 touch gestures
  • Windows 8 touch gestures

Rules

  • Move: If a screen in a container is not a worldview, it accepts the settings of the faceplate screen.

Moving the worldview or worldview in the container of a faceplate

  • Screen is bigger than the frame: Content of the screen is moved.
  • Screen is the same size or smaller than the frame: No reaction.

Worldview embedded in faceplate.

  • Screen is bigger than the frame: Content of screen is moved.
  • Screen is the same size or smaller than the frame: No reaction.

Move the frame or border with the mouse if the screen is a worldview and the same size or smaller than the frame:

  • With the right mouse button: No reaction.
  • With the left mouse button: Frame is moved.

Change worldview size

The size of the worldview cannot be changed.
Exception: If the worldview is a faceplate, the size cannot be changed.

Click with right mouse button:

  • Screen is bigger than the frame: Contents are moved.
  • Screen is the same size or smaller than the frame: No reaction.

Project conversion

Values for Move horizontally and Move vertically when converting from an earlier version to zenon 7.20:

  • Screen is bigger than the frame: Move.
  • Screen is the same size or smaller than the frame: No reaction.


Navigation under Windows 7

Manual -> Multi-Touch -> Navigation with Multi-Touch in the worldview -> Navigation under Windows 7

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To be able to use Multi-Touch gestures under Windows 7 to navigate in the worldview, you must:

  • activate them via property Multi-Touch for zoom and scroll
  • or implement them via VBA/VSTA

Zoom and scroll via property Multi-Touch for zoom and scroll

To use Multi-Touch without VBA/VSTA:

  1. In the project properties in the Interaction node for the Recognition property, activate Windows 7.
  2. Deactivate property Screen size from frame in node Frame at the properties of the screen
  3. Activate property Multi-Touch for zoom and scroll in node Interaction at the properties of the screen

With this you can scroll and zoom in the screen with touch operation using Multi-Touch gestures. With this VBA/VSTA for zooming and scrolling is deactivated.

Zoom and scroll via VBA/VSTA

To implement zooming and scrolling via VBA/VSTA Events, property Multi-Touch for zoom and scroll must not be active.

The following is available in the DynPicture:

  • Property

    int ZoomLevel: Displays the current zoom level in the worldview (valid value only in the Runtime and for a worldview).

  • Style

    SetZoomAndPos(float ZoomX, float ZoomY, int ZoomLevel, int CursorX, int CursorY, int PosX, int PosY, int PosMode):

    ZoomX -> New zoom factor X direction; if not used, set to 0

    ZoomY -> New zoom factor Y direction; if not used, set to 0

    ZoomLevel -> Zoom level, if not used, set to -1

    CursorX -> Cursorposition X

    CursorY -> Cursorposition Y

    PosX -> New position X (see PosMode)

    PosY -> New position Y (see PosMode)

    PosMode -> Coordinates in Pos

    -1 = PosX, PosY are ignored

    0 = center point , original coordinates

    1 = center point, zoomed coordinates

    2 = left top, original coordinates

    3 = left top, zoomed coordinates

    4 = zoomed coordinates of the cursor from the top left
    The position of the window is changed in such a way that after the zooming the mouse cursor is still over the position of the screen

Attention: ZoomX, ZoomY and ZoomLevel can never be used simultaneously. Either you enter a ZoomLevel or a zoom factor for x and y axis.


Navigation under Windows 8

Manual -> Multi-Touch -> Navigation with Multi-Touch in the worldview -> Navigation under Windows 8

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To navigate in a worldview with Multi-Touch under Windows 8:

  1. In the project properties in the Interaction node for the Recognition property, activate Windows 8.
  2. Deactivate, for the screen in the Frame group, the Screen size from frame property and define the screen size as larger than the frame.
  3. navigate to group Interaction in the screen properties.
  4. Configure the properties for Zoomen and Verschieben.

For the move gesture, you can define the direction - horizontal, vertical or both. To do this, use the Horizontal verschieben and Vertikal verschieben properties.


Network

Manual -> Network

zenon networks can be set up very quickly and securely.

zenon in the network allows you to, among other things:

  • Complete access to Runtime on different computers, actions such as acknowledgment of alarms to a workspace are therefore visible to all others
  • Centralized logging and archiving
  • Creation of redundant systems (see redundancy, circular redundancy)
  • Integrated evaluation methods for redundancy switching
  • Creation of distributed systems (see multi-project administration)
  • Use of zenon Web Server and zenon Web Client for mobile access
  • Use of zenon in a terminal server environment
  • Use of strong encryption
  • Concurrent work on a project from several stations (see distributed engineering)

tutorial License information

Part of the standard license of the Editor and Runtime.

Simple administration of the zenon network

The network functionality of zenon makes it possible to implement projects as distributed on different computers and to create complex network constellations very efficiently. In doing so, project constellations can also be though out in such a way that certain project content is only visible at a certain location (a certain computer) for an activity. The zenon Editor supports users in creating and configuring such constellations.

The integrated topology administration creates interrelationships for the individual projects in the process, with the attendant computers in graphical form. A testing routine checks the configured structure to see that it is complete and that there are no configuration errors.

info Information

With network projects, note the roles (Primary Server, Standby Server, Client) in which modules and functions can be administered and executed.

WAN

Within a network, zenon transfers data spontaneously – and is thus already optimized for use with in a WAN. Depending on the configuration, it is also recommended that the watchdog traffic between the client and Primary Server is limited. The communication distance between client and Primary Server can be automatically closed. The routers then establish a new connection when data exchange is absolutely necessary.

zenon Web Server

The zenon Web Server allows access to Runtime via the intranet or internet. No adaptations to the project are necessary. Access is via the zenon Web Client. This offers the same look & feel as zenon Runtime. The zenon Web Server is available as:

  • zenon Web Server: Pure monitoring functionality.
  • zenon Web Server Pro: Complete operation and monitoring functionality. It is possible to directly engage in processes over the web.
  • zenon Web Server Pro Light: Limited functionality of zenon Web Server PRO for use with zenon Operator.


Concepts

Manual -> Network -> Concepts

With zenon, it is possible to create various network topologies, starting from a simple client-server model through to comprehensive multi-hierarchical models.

IT-specific terms such as Server and Client are also used in zenon. However, in order to achieve unique identification of the individual components for complex multi-hierarchical structures with various computers and projects involved, we always speak of roles in zenon. Roles are always to be considered from the point of view of a project.

zenon Runtime can start one or more projects depending on the project setup (see also multi-project administration). In doing so, the computer on which Runtime is started assumes one of the following roles for the respective projects:

  • Primary Server
  • Standby Server
  • Client

These roles are shown below using examples in different topologies.

info Info

If, in the course of this documentation, we speak of Primary Server, Standby Server or Client, the role that the computer takes for the project is always meant.


Client-server model

Manual -> Network -> Concepts -> Client-server model

In the Client-Server model, one computer is the Primary Server; all other computers are Clients.

  • Computer 1 is the Primary Server for Project A.
  • Computer 2 is the Client for Project A.

For details, see the Client-Server model chapter.


Redundant model

Manual -> Network -> Concepts -> Redundant model

In the redundant model, one computer is the Primary Server and one computer is the Standby Server. All other computers are Clients.
If the Primary Server fails, the Standby Server takes on this role. All Clients connect to the new Primary Server.

Redundancy without Clients

  • Computer 1 is the Primary Server for Project A.
  • Computer 2 is the Standby Server for Project A.
  • If Computer 1 fails, Computer 2 is the new Primary Server for Project A.

Redundancy with Clients

  • Computer 1 is the Primary Server for Project A.
  • Computer 2 is the Standby Server for Project A.
  • If Computer 1 fails, Computer 2 is the new Primary Server for Project A. All Clients automatically connect to Computer 2.

For details, see the Redundancy chapter.


Multi-hierarchical models

Manual -> Network -> Concepts -> Multi-hierarchical models

It is possible to create different multi-hierarchical topologies with the help of multi-project administration. In doing so, it is possible to start several projects on one computer. The computer assumes a certain role for the project in the process.

Note: Multi-hierarchical projects can be executed without a network on individual computers.

Examples:

Multi-client model

  • Computer 1 is the Primary Server for Project A.
  • Computer 2 is the Primary Server for Project B.
  • Project I runs on Computer 3 (integration project) as a standalone project and starts Projects A and B.
    • Computer 3 is a Client for both of these projects.

Multi-server model

  • Project I runs on Computer 1 (integration project) as a standalone project and starts Projects A and B.
    • Computer 1 is the Primary Server for both of these projects.
  • Project I runs on Computer 2 (integration project) as a standalone project and starts Projects A and B.
    • Computer 2 is a Client for both of these projects.
  • Computer 3 is the Client for Project A.
  • Computer 4 is the Client for Project A.

Multi-client-multi-server model

  • Project I runs on Computer 1 (integration project) as a standalone project and starts Projects A, B, C and D.
    • Computer 1 is the Primary Server for projects A and B.
    • Computer 1 is the Client for projects C and D.
  • Project I runs on Computer 2 (integration project) as a standalone project and starts Projects A, B, C and D.
    • Computer 2 is the Client for projects A and B.
    • Computer 2 is the Primary Server for projects C and D.
  • Project I runs on Computer 3 (integration project) as a standalone project and starts Projects A, B, C and D.
    • Computer 3 is the Client for projects A, B, C and D.

For details, see the multi-project administration chapter.


Requirements

Manual -> Network -> Requirements

A basic requirement for using zenon is a functional Windows network.

General

The following requirements must be met:

  • TCP/IP as the network protocol
  • Functional naming, can be chosen as DNS, WINS or local HOST files.
  • Free TCP Port 1100:
    If a network project is loaded, zenon Runtime automatically starts the zenNetSrv network service. This program opens port 1100. This must therefore be reachable remotely and may not be blocked by a firewall.

info Info

zenon networks work with all supported operating systems.

IPv4 and IPv6

The zenon network allows the choice of using IPv4 or IPv6. Dual operation is not possible. The setting is made via:

  • Network configuration in the Startup Tool
    or
  • In zenon6.ini

If this setting is changed, all ongoing zenon processes must be restarted. This concerns zenAdminSrv, zenSysSrv, zenLogSrv and zenDBSrv in particular.

The following components are not affected by the setting; they always use IPv4:

  • Driver communication with the PLCs
  • Protocol communication in the Process Gateway plug-ins
  • Workbench and Runtime communication in zenon Logic

attention Attention

IPv6 only works with zenon version 7.00 onwards. No versions prior to zenon version 7.00 can be started if this is active.

Ports used

For communication within zenon, only TCP ports are used; no UDP ports are used. zenon requires the following ports in a network:

Service | File | Goal | TCP-port
Network service | zenNetSrv.exe | Runtime communication. | 1100
Transport service | zenSysSrv.exe | Data transfer by means of Remote Transport (Editor). | 1101
zenon Web Server | zenWebSrv.exe | On-site logging machine between web client and Runtime | 1102

Port numbers can be amended individually by means of the Listening ports tab in the Startup Tool. Note in this case that all devices affected must be amended.

Standard ports

Application | Standard port
Administration Service | 50777
Analyzer Connector Service | 50778
Analyzer License Service | 50779
DB Service | 1103
Logging Service | 50780
Network Service | 1100
SNMP Trap Service | 50782
Transport Service | 1101
WEB Service Classic | 1102
WEB Service Tunneling | 8080

Check the requirements

Name resolution

To check the name resolution:

  1. Start the windows command line (cmd.exe)
  2. Enter the following command: ping COMPUTER NAME.
  3. If the name resolution is correct, you receive the IP address of the computer with Runtime as the answer; otherwise you receive an error message

TCP ports

To check the contactability of the TCP port 1100:

  1. Start Runtime with a network project on a Remote computer:
    This starts the program zenNetSrv.exe and the TCP port 1100 is opened
  2. Start the windows command line (cmd.exe)
  3. Enter the following command: telnet COMPUTERNAME 1100.
  4. As soon as a connection is established, the content of the command line window disappears; otherwise there is an error message.

Note: The Telnet command is not part of the Windows operating system and must be installed separately. You can find instructions for this in the operating system help pages (search for: Telnet).


Time synchronization in the network

Manual -> Network -> Requirements -> Time synchronization in the network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With network projects, all computers in the network must be time-synchronized. zenon automatically carries out the synchronization necessary for this.

In a topology with several Primary Servers (such as circular redundancy), it is recommended that time synchronization is implemented by means of an external time service (such as DCF77) or Windows resources. In this case, the automatic time synchronization in zenon must be deactivated.

attention Attention

If the time difference between the server and the client is more than 5 seconds, no more files are synchronized.

Automatic time synchronization in zenon

If the time synchronization is to be turned on or off manually, the following entry in zenon6.ini must be amended:

[Netz]

TIMESYNCH=1 -> automatic time synchronization active (default)

TIMESYNCH=0 -> automatic time synchronization inactive

External time synchronization using the operating system

If the automatic time synchronization in zenon was deactivated, synchronization can be carried out via the operating system. To do this, a time server must be specified for this (with or without an external time service such as DCF77), which takes on the time synchronization with the other computers.

In the conventional Client-Server/Standby topology (without multi-project administration), the Primary Server is the active time master. This should keep its own time itself by means of an external time service if possible. The respective clients get the current time from this (depending on the timeout that has been set) and update their own times accordingly. Communication is carried out via SNTP (Simple Network Time Protocol), which takes the delay time into account.

info Information

Watchdog

Time synchronization is carried out periodically at the set time-out time.

When using the default setting of 30 seconds for the Network communication timeout property in the Startup Tool, the network service (zenNetSrv.exe) of each client sends a Watchdog to the network service (zenNetSrv.exe) of the Primary Server every 10 seconds during online operation. If the Primary Server responds to at least one of the three watchdogs within the 30 seconds, the client assumes that the network connection is working.

Configuration in the Startup Tool:

Application -> Options-> Network configuration tab -> Option Network communication timeout.

Configuration in zenon6.ini:

Alternatively, the setting can be made directly in zenon6.ini:

[Netz]

NET_TIMEOUT_MSEC=30000

(time-out in milliseconds, default: 30000.)

Note the additional configuration necessary in WAN.

Attention: The minimum timeout time is 5 seconds. If a lower value is defined, this is interpreted as 5 seconds.

Commands under Windows

For external synchronization using Windows, enter the following command with the respective necessary arguments in the console for command processing: NET TIME [\\Computer name | /DOMAIN[:Domain name] : /RTSDOMAIN[:Domain name]] [/SET] [/YES]

Argument

Description

NET TIME
  • Synchronizes the time of the computer with that of another computer or another domain
    or
  • Displays the time for a computer or a domain

If this command is executed without further arguments, then the current date and the current time of the computer that was defined as the time server for the domains is displayed.

Computer name

The name of the computers that checks or is to be synchronized.

DOMAIN[:Domain name]

The time is synchronized with the primary domain controller of the Domain name domain.

RTSDOMAIN[:Domain name]

The time of the computer is synchronized with a reliable time server from the Domain name domain.

/SET

Synchronizes the clock of the computer with the stated computer and/or the stated domain. After the command has been set, the server time is displayed and a request is made to see if this time is to be set.

/YES

Displays the current server time and synchronizes this with the local computer without a further request or confirmation.

Example Example

NET TIME \\Server /SET /YES


Time synchronization in the WAN

Manual -> Network -> Requirements -> Time synchronization in the network -> Time synchronization in the WAN

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In a WAN and for dial-up connection, the standard defined value of 30 seconds for the timeout means that the connection would probably be maintained permanently.

Select a timeout time in the WAN that only initiates the establishment of a connection at the desired interval. However, note: The longer the time-out, the later server failures are detected. For example, if you select 64800 as the time for the timeout, the time-out time is 18 hours. A connection is made every 6 hours and a watchdog is sent. A server failure would thus only be noticed after around 18 hours.

info Information

If no entry for the timeout is defined in zenon6.ini, the standard timeout of 30 seconds is used when Runtime is started.

Function Screen switch

Active data is requested when a screen is switched. Procedure:

  • A check is made to see if a watchdog was sent to the Primary Server in the last 30 seconds.
  • If this is not the case, a watchdog is sent to the Primary Server immediately. the waiting time for a response is 40 seconds.
  • If a Server break down is recognized, the zenon network service automatically tries to reconnect every 30 seconds.

This would lead to a permanent connection establishment in the WAN network. This behavior can lead to entries in zenon6.ini being amended:

  1. Open zenon6.ini.
  2. Navigate to the
    [NETZ] section.
  3. Create or edit the entry

    NET_CONNECTWAIT_MSEC=30000
    This defines the value for a reconnect in milliseconds.

    Maximum value: Time-out time

  4. Create or edit the entry

    NET_CONNECTCOUNT=

    This defines the number of repetitions for a reconnect per cycle.

    The default is 0 repetitions, this means 1 attempt at reconnection.


Setting up the zenon network

Manual -> Network -> Setting up the zenon network

In the zenon network, you work with:

Parameters

Description

Server:

Computer with connection to the PLC. The server takes on the administration of process and project data exclusively. Communication is checked by means of a watchdog.

In the event of a server failure, the Standby Server undertakes its tasks, provided a standby was defined. As soon as the server is ready again, it automatically takes on its tasks and synchronizes all data.

Standby Server:

Takes on, in redundant systems, the role of the server, if this fails. It acts like a client in the network, but al saves all data like the server. In the event of hardware redundancy, the standby communicates with the redundant PLC both ways.

The standby works with an internal buffer. Data loss during the downtime between server failure and the standby taking on the server role is thus avoided.

Clients:

Each computer on which Runtime is started is a client. Clients connect to the server to receive process data or to send this.

Data server:

The Data server is a computer with direct communication to the process but no server tasks. In normal operation, the data server sends all data to the Server, which manages data storage and data distribution. In the event of a network or server breakdown, the data server continues to work as a single station and therefore guarantees proper operation of the process. The data is transferred as soon as the server connection is re-established.
Field of application: An on-site operating system without powerful hardware, such as an IPC or CE terminal. Complete data archiving and data distribution is carried out by the data server. On-site operation is still possible in the event of a server failure. This is not the case in a conventional Client-Server model.

info Information

Server and client are not defined in relation to a computer, but in relation to a project.

If the names of the Server or Standby Server are changed, these cannot be reloaded. They are only updated by restarting Runtime.

Topologies

zenon supports several network topologies:

  • Client server network: The same project runs on the server and all clients.
  • Multi-server network: A client can access different servers and thus display the data of different projects at the same time.
  • Multi-client-multi-server model: All clients and servers communicate with each other. Other projects can be accessed from each project.

Configuring the network

To make a network network-compatible:

  1. navigate to the Network node in properties
  2. Activate the Network active property
  3. Use the Server 1 property to define the computer that takes on the server role in the project
    Note: The IP address is not sufficient; the name of the computer must be entered.

If necessary, you still configure the following in this section:

  • Standby Server: Server 2 property:
  • Redundancy: Redundancy type property:
  • Termination message: Defines if, when Runtime is ended on a server, the clients are informed 70 seconds in advance

With this, you have configured the basic properties. Repeat these steps for all clients in the zenon network. Remote computers can also be set up using remote transport.

attention Attention

Issuing a name for Server 1 and Server 2:

  • The computer name must be entered.
    The IP address is not permitted.
  • "localhost" must not be used.


Client-server model

Manual -> Network -> Setting up the zenon network -> Client-server model

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the conventional Client-Server model, only one project is used, which is started on all computers involved. In doing so, a certain computer is the Primary Server for this project. All other connected computers are Clients.

To set up the Client-Server model, the following must be the case in the project:

  • The Network active property must be activated
  • The name of the computer that is to be the Primary Server is to be entered in the Server 1 property

Recommendation: Select the most powerful computer in the network as the Primary Server.

In the zenon Client-Server model:

  • Only the Primary Server has a direct connection to the PLC
  • The Primary Server administers all process data (such as online data, archive data, alarms, recipes, etc.)
  • The Primary Server administers all project data (such as screens, functions, defined variables, etc.)
  • Each other computer starts as a Client in the network
  • Each client establishes the connection to the Primary Server when Runtime is started,
    • synchronizes the project data and
    • displays the current process data

info Information

The Client-Server model is fully supported under Windows CE. Windows CE devices can be used as Primary Servers or as a Client.


Configuring the Primary Server

Manual -> Network -> Setting up the zenon network -> Client-server model -> Configuring the Primary Server

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Primary Server makes the connection to the PLC and administers all data, both online data and configuration data. The Clients synchronize their data with the Primary Server.

To set up the Primary Server

  1. Activate the Network active property
  2. Define the computer that is to be the Primary Server for the project using the Server 1 property.
    Note: The IP address must not be used; the name of the computer must be entered.
  3. Note the correct configuration of the internal variable drivers
  4. Create AUTOSTART and AUTOEND scripts for the clients if necessary

attention Attention

Issuing a name for Server 1 and Server 2:

  • The computer name must be entered.
    The IP address is not permitted.
  • "localhost" must not be used.

If the development computer on which you created the project is also the Primary Server, configuration is now complete.


Configuring the clients

Manual -> Network -> Setting up the zenon network -> Client-server model -> Configuring the clients

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Clients can be set up via Remote Transport, via the network topology or manually. Setup via Remote Transport or the network topology is recommended.

For this, the following applies:

  • If the development station also is a client, simply start the Runtime there.
  • You set up all other clients either by means of Remote Transport, network topology or manually.
  • If special processes are to be executed on the clients, a respective script in the project must be created, which defines the behavior on startup (AUTOSTART_CLIENT script) and when being ended (AUTOEND_CLIENT script).


Set up client with Remote Transport

Manual -> Network -> Setting up the zenon network -> Client-server model -> Configuring the clients -> Set up client with Remote Transport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

By default, Remote Transport always transports the Runtime files to the computer that is defined as the server in the network properties. To set up clients from the development computer by Remote Transport, the Remote Transport connection must be set up before the Client is set up.

To set up clients using Remote Transport:

  1. Open the General node in Project Properties.
  2. Click on the Remote transport property.
  3. The dialog Remote Transport is opened
  4. Enter, in Connection under Name, the name of the client in the network.
  5. Close the project configuration with OK.
  6. Establish a connection to Remote Transport.
    To continue to use Remote Transport, it is best to use the tool bar symbols.
  7. Transport all Runtime files to the client with Remote Transport.
  8. Set the start project for the client with Remote Transport.
  9. Start the Runtime on the client with Remote Transport.
  10. Close the Remote Transport connection


Setting up a Client by means of network topology

Manual -> Network -> Setting up the zenon network -> Client-server model -> Configuring the clients -> Setting up a Client by means of network topology

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Network topology is suitable for setting up several Clients at the same time. In doing so, Runtime files can be transferred to several computers at the same time by means of multiple selection. For details, see the network topology chapter.


Setting up the client manually

Manual -> Network -> Setting up the zenon network -> Client-server model -> Configuring the clients -> Setting up the client manually

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure clients for the start of Runtime:

  1. Close zenon Editor and zenon Runtime.
  2. Open the file zenon6.ini with a text editor.
    You can find the file in the folder %ProgramData%\COPA-DATA\System\
  3. Remove the line VBF30=.... or comment this line out.

    (This entry defines which project is to be loaded when Runtime is started.)

  4. Leave the Editor closed and start Runtime.
  5. A request is made in a dialog, requesting which project is to be loaded.

  6. Activate the check box for the Load project from Runtime server option.

  7. Enter:
    1. Runtime server: Computer that is set up as the Primary Server. The name can be entered directly or selected from a list using the ... button.
    2. Project name: Name of the project that runs on the Primary Server.
      Note: Ensure that the project names are correct. If the folder name does not correspond to the project name, the project name must be changed here!
    3. Project target folder: Folder for Runtime on the client's local hard drive. You either can select an existing folder using the … button or enter a path manually. If a folder that does not exist is entered, this is created automatically.
    4. Confirm the input by clicking OK.
  8. zenon Runtime:
    1. Creates a connection to the Primary Server
    2. Copies its Runtime files to a project target folder
    3. Starts Runtime
    4. Requests a restart of Runtime if necessary
  9. The entry VBF30=... in the zenon6.ini file is set on the project target folder.

    Runtime then starts the network project automatically on the client each time it is started.

Repeat this process for each client.


Behavior in Runtime

Manual -> Network -> Setting up the zenon network -> Client-server model -> Configuring the clients -> Behavior in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Network projects can be operated in the same way in the network by all computers in Runtime and Clients and are visualized in the same way. If there is no valid project defined when Runtime is started, the dialog to define the Runtime projects is opened. For details, see the Set up client manually section.

Differences between the Primary Server and the Client:

  • Only the Primary Server of the project has a connection to the hardware and administers the process data.
  • The other computers (Clients) receive, from this:
    • Current values of the variables
    • Chronological Event List system messages
    • Alarm information
    • Recipes
    • Archive data
    • etc.

The transfer from the Primary Server to the Clients (such as a value change from a driver) is spontaneous and event-triggered (such as calling up a trend screen, which needs archive data from a Primary Server).

Monitoring the connection

When using the default setting of 30 seconds for the Network communication timeout property in the Startup Tool, the network service (zenNetSrv.exe) of each client sends a Watchdog to the network service (zenNetSrv.exe) of the Primary Server every 10 seconds during online operation. If the Primary Server responds to at least one of the three watchdogs within the 30 seconds, the client assumes that the network connection is working.


Redundancy

Manual -> Network -> Setting up the zenon network -> Client-server model -> Configuring the clients -> Redundancy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Redundant SCADA servers are used, if 100% process control and data safety is demanded, even when the server fails.

You achieve this fail safety by defining a second server, a so-called Standby Server, along with the project server. This standby automatically recognized a server failure Then it takes on the entire functionality of the server.

In order to avoid data loss in the time between the server failure and the recognition of the failure the standby always buffers all data. After a server failure this buffer is merged with the last data from the server and the new incoming data, so no data can be lost. So the control system guarantees seamless redundancy.

Depending on the configuration of the redundancy mode property, the original server is started either as a Server or as a Standby after restarting.

Redundancy mode | Description
Non-dominant | The original Server (Server1) starts as a Standby. Server 2 retains the Server role.
Dominant | The original Server (Server 1) takes on the role of Server again after all data has been synced. Server 2 is downgraded to the Standby.
Rated | Depending on the configured evaluation, the original server is started either as a Server or as a Standby after restarting.

info Info

If the standby is running, when the server is started, the server copies all Runtime data from the standby. If you made any changes in the project data, while the server was offline and you have only updated them on the (not running) server, these changes will be overwritten, when the server copies the data from the standby.

In this case you have to update the standby before starting the server; or you close the standby when starting the server. As soon as it is restarted the standby then will get the new data from the (running) server.

Configuring the standby

  • In the network properties, in addition to the server, enter the name of the Standby Server.
  • To transfer the Runtime files, the process is the same as with the client.

The control system supports two different kinds of redundancy:

Software redundancy | The PLC is not redundant. Only the control system is redundant. (standard case)
Hardware redundancy | Both the PLC and the control system are redundant.


Multi-project administration

Manual -> Network -> Setting up the zenon network -> Multi-project administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Multi-project administration makes decentralized solutions possible. Sub-projects can be distributed to different computers. The individual computers in turn can be the Primary Server, Standby Server or Client for the respective sub-projects.

The following is possible with the help of multi-project administration:

  • Several projects in one workspace can be edited in the Editor at the same time
  • Several projects can be started at the same time and thus variables, functions, archives etc. from other projects can be accessed directly throughout projects

info Information

Multi-project administration is not available under zenon Operator. Here, only one project and a global project per workspace can be created and administered in the Editor. Runtime can only start one project.

Structure

An integration project that is loaded in Runtime as a start project is required.

zenon creates a multi-hierarchical project tree, at the top of which is the integration project. Multi-project administration makes it possible to place the projects in a logical connection to one another.

info Information

Configure and check the topology with the zenon network topology.

Work efficiently with multi-project administration and the project hierarchy

zenon enables you to reuse data and screens from existing projects consistently. zenon multi-project administration makes a logical connection between the individual projects and places these in a hierarchical connection to one another. The user can display this project hierarchy graphically in the zenon Editor, by dragging the projects to the desired position with the mouse and thus creating a multi-hierarchical project tree.

The project that is highest in the hierarchy is the integration project. All other projects are subordinate to this project. The data from individual projects is available throughout all projects in the project structure.

The zenon multi-project structure is comparable to a file folder:

  • Additional sheets – zenon projects – can be added at any time. The folder always automatically covers all information of the sheets stored in there. It is possible to browse through the pages at any time and look at the information, without taking the individual pages out. In the zenon multi-project structure, users can change between the individual screens or projects without having to take these out.
  • The integration project can be compared to the contents of the file folder. It serves as a central navigation project and makes it possible to display screens or data from the subordinate projects. The individual projects are autonomous and can continue to be operated autonomously. Access from a project to the data or screens of another project is enabled via the zenon standard interfaces. Expansions or amendments to projects are made directly in the individual projects. Any maintenance work that may be carried out only has an influence on the respective project; the overall system remains unaffected by this.

Multi-project administration means

  • Small-sized, clear structures.
  • Easy, quick and clear maintenance of the individual projects.
    It is possible, for example, to deactivate individual projects without influencing the others. In the same way projects can be distributed to different processors.
  • Load distribution.
  • Cross-project operation, as all projects on a processor are simultaneously activate.
  • Multiple-hierarchy network structure allows the centralization of data (measured values, alarms, plant information, archive data, etc.) in a higher-ranking level.
  • No limit on projects per processor.
  • Summary of projects to large control rooms.
  • Node structure – physical network separation.


Definition of the structure in the Editor

Manual -> Network -> Setting up the zenon network -> Multi-project administration -> Definition of the structure in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The structure is created by simply dragging & dropping in the Editor. You also need, in addition to productive projects, an integration project that administers all other projects. Because standalone projects do not send data to other computers, a Primary Server must be defined in each (sub-)project. The integration project itself can also be a network-capable productive project.

Example

Three projects are used in this example:

  • Integration project IPRO
  • Productive project PRO1
  • Productive project PRO2

To create the structure:

  1. Create:
    • IPRO
    • PRO1
    • PRO2
    • And define a Primary Server for each computer
      (the integration project can also be implemented as a standalone project)
  2. In the Project Manager, drag PRO1 to IPRO by holding the left mouse button
  3. Do the same for PRO2
  4. PRO1 and PRO2 are now displayed in the Project Manager as branches of the IPRO

The hierarchical structure of the network has thus been created.

info Information

In order for elements of sub-projects, such as screens, variables or functions to be able to be selected, the Keep project in the memory function (in the project context menu) must be activated.


Transferring and starting projects

Manual -> Network -> Setting up the zenon network -> Multi-project administration -> Transferring and starting projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the help of the network topology, the integration project can automatically be transferred to the respective target computer with all sub-projects. All sub-projects are also automatically transferred if the integration project is also the start project.

For details of network topology, read the Administering and checking network topology chapter. You can find the configuration of the computer with an example for automatic transfer of sub projects in the Configuration of computers in the network section.

Transferring and starting projects manually

Remote Transport can be used to transfer and start projects manually.
Each project is individually transferred to the corresponding computer.

  • With Remote Transport, move all Runtime files of PRO1 to its Primary Server.
  • Set the start project with Remote Transport.
  • Start the Runtime with Remote Transport.
  • Stop the online connection.
  • Do the same for PRO2.

info Info

In order to transfer the integration project and both sub-projects to a Client via Remote Transport, 3 Remote Transport processes are necessary (a process for each project).

Network topology is preferred here, because all projects can also be transferred to several computers at the same time.


Administering projects

Manual -> Network -> Setting up the zenon network -> Multi-project administration -> Administering projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You have the following possibilities, among others, for accessing the data from sub-projects:

  • Integration project
  • Navigation between projects
  • Using variables or functions from another project
  • Sending recipes to different variables in different projects
  • Create archives for use throughout projects
  • Creating a joint AML or CEL for different projects

attention Attention

During configuration, note the roles in which the modules and functions are executed (Primary Server, Standby Server, Client). You can find a list of the possible configurations here: Behavior of modules in the network.


The integration project

Manual -> Network -> Setting up the zenon network -> Multi-project administration -> Administering projects -> The integration project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The integration project administers subprojects that can be accessed in Runtime. The integration project can be used as a pure administration project in multi-project administration (for example just for the navigation to the sub-projects) or also as a complete productive project (with its own PLC connection, archiving, etc.). If the integration project is used as a start project, all sub-projects are automatically started in Runtime.

In an integration project, you can for example create central Alarm Message Lists or Chronological Event lists for all subordinate projects with a few mouse clicks. This allows the alarms of all sub-projects in the Alarm Message List of the integration project to be displayed in chronological order.

attention Attention

When designing the multi-project administration, ensure that the navigation works.

info Information

These must be editable in order to be able to delete subprojects. For example, a subproject that has been created with an earlier editor version than the integration project can only be deleted after conversion.


Navigation between projects

Manual -> Network -> Setting up the zenon network -> Multi-project administration -> Administering projects -> The integration project -> Navigation between projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Navigation between projects

When administering more than one sub-project in an integration project, it is absolutely necessary to ensure that it is possible to switch from one subproject to another or to the integration project in Runtime.
Hint: Create a template that is always in the foreground. Create a screen with navigation buttons based on this.

Screen switch to subprojects

To switch between screens of individual projects, use the zenon screen switching function. In order for the navigation to be available at all times, first create a frame that is always in the foreground:

  1. Create a new template that offers space for the navigation controls.
  2. Assign it the Always in the foreground property.
  3. Activate the properties Border type and Title (this means that the template can be moved in Runtime).
    Of course a template can also be used without a frame and title being in a fixed position.
  4. Create a screen with navigation buttons on the basis of this template

Example of switching between PRO1 and PRO2

  1. Create a new Screen switch function.
  2. If there is more than one project available in the current workspace, the dialog to select a screen for the selection of a project is expanded.

  3. Select PRO1.
  4. Select the start screen of PRO1 and close the dialog with OK.
  5. Repeat the process for PRO2.
  6. Add two text buttons with the text PRO1 and PRO2 to the navigation screen.
  7. Link the the two text buttons to the functions that have been created.

attention Attention

zenon does not check in the Editor to see if the network structure in Runtime actually allows access to the selected project/screen.

For example, in the Editor, screen switching to a screen in the integration project can be created in the project PRO1. This switching only works in Runtime if the integration project has also been started. This screen switching will not work on a computer on which the PRO1 project (start project) has been started.


Variables and functions

Manual -> Network -> Setting up the zenon network -> Multi-project administration -> Administering projects -> The integration project -> Variables and functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Variables and functions

You can access variables and functions from other projects in the same workspace directly by means of dynamic elements.

Variable example

  1. Open the IPRO start screen.
  2. Add a new counter value dynamic element.
  3. The variable selection dialog now opens.

  4. Here, you can select not just variables from the IPRO. To select a variable from a different project:
    1. Click on a project in the left list area
    2. You are offered the attendant variables
    3. select the variable you want to assign
  5. Select a variable from PRO1 or PRO2.

Proceed in the same way for functions.

attention Attention

zenon does not check in the Editor to see if the network structure in Runtime actually allows access to the selected project and its variables/functions.

For example, in the Editor, in project PRO1, a variable from the integration project can be selected. This connection only works in Runtime if the integration project has also been started. This connection will not work on a computer on which only project PRO1 has been started (start project).


Archives

Archives

Values of variables of different projects of the workspace can be recorded in an archive. The values recorded in this way can be filtered, displayed in list form or trend form, and they can be printed or exported just like data from normal archives.

Example of archive

  1. In the project IPRO open the node Historian.
  2. Create a new archive named BA - BASIS.
  3. Open the context menu of RECIPE1 and select Add variable.
  4. The dialog for selecting variables is opened

  5. Here, you can select not just variables from the IPRO. To select variables from other projects:
    1. Click on a project in the left list area
    2. You are offered the attendant variables
    3. select the variable you want to assign
  6. Select variables from PRO1 and PRO2.
  7. The project name is written in front of the variable name in the archive variable list.

attention Attention

zenon does not check in the Editor to see if the network structure in Runtime actually allows access to the selected project and its variables.

For example, in the Editor, in project PRO1, a variable from the integration project can be selected. This connection only works in Runtime if the integration project has also been started. This connection will not work on a computer on which only project PRO1 has been started (start project).

Redundancy

After the selection of variables has been concluded, a message box indicates that seamless recording is guaranteed under all circumstances.

Example

  • The project PRO1 is executed redundantly; one computer is the Primary Server, a second computer is the Standby Server.
  • The same applies for the project PRO2.
  • The integration project with the subordinate projects PRO1 and PRO2 is started on a third computer. This is the client for all sub-projects.

If variables of the projects PRO1 and PRO2 are now archived in the integration project, then the computer receives the data about the network from the respective Primary Server from PRO1 and PRO2.
If, for example, the Primary Server of PRO1 fails, for the time period until the Standby Server of PRO1 has taken over the Server role, there would be alternative values in the archive for variables from PRO1.
Cause: The Standby buffer of the seamless redundancy only caches local project variables and only tracks these.
See also redundancy.
Solution: In order to ensure recording without interruptions, the archiving must be local in a redundantly-executed subproject.


Recipes

Recipes

You can write values to variables from different projects of the workspace in a recipe.

Recipe example

  1. In the project IPRO open the node Recipes.
  2. Create, under Standard recipe recipes a new recipe with the name Recipe 1.
  3. Open the context menu of Recipe 1 and select Add variable.
  4. The dialog for selecting variables is opened

  5. Here, you can select not just variables from the IPRO. To select variables from other projects:
    1. Click on a project in the left list area
    2. You are offered the attendant variables.
    3. Select variables from PRO1 and PRO2.
    4. The name of the respective project is also placed in front of the variable name in variable list of the recipe.

Proceed in the same way for the Recipegroup Manager.

attention Attention

zenon does not check in the Editor to see if the network structure in Runtime actually allows access to the selected project and its variables.

For example, in the Editor, in project PRO1, a variable from the integration project can be selected. This connection only works in Runtime if the integration project has also been started. This connection will not work on a computer on which only project PRO1 has been started (start project).


Alarms and CEL

Manual -> Network -> Setting up the zenon network -> Multi-project administration -> Administering projects -> The integration project -> Alarms and CEL

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Alarms and CEL

In zenon, system messages and alarms from different projects of a workspace can be displayed together in a list. These entries can be filtered, displayed, printed or exported just the data from normal Alarm Message Lists or Chronological Event Lists.

AML example

  1. Create an AML screen.
  2. Add control elements to the screen via Control elements -> Add templates.
  3. Create a function Screen switch for this screen.
  4. The filter dialog for alarm lists is opened.
  5. Open the Project tab.
  6. Select the project that is to be displayed in the AML of the IPRO.
    Multiple selection button Ctrl plus a mouse click.)

  7. Open the Column settings tab.
  8. Select the Project name property for display in Runtime.
    You thus gain an overview of the project from which an alarm comes in Runtime.

Proceed in the same way for the Chronological Event List.


Horizontal transparency

Manual -> Network -> Setting up the zenon network -> Horizontal transparency

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Multi-project administration also allows horizontal transparency.

Horizontal transparency means that all projects that are on the same level can be called up on one computer. The requirement for this is an integration project with corresponding navigation, which starts these projects.

Example

Several terminals belong to one machine. Each has its own visualization project. With the help of horizontal transparency, it is possible to show and operate, on each terminal, its own project and all other projects. This way the entire machine can be monitored and operated from each terminal.


Optimization for projects with a large number of Clients

Manual -> Network -> Setting up the zenon network -> Optimization for projects with a large number of Clients

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Large network projects can, under certain circumstances with standard settings, place the Primary Server under full load for a period of time by reloading many Clients. The extent of the load depends on several factors (Primary Server resources, available bandwidth, etc.).
Guideline values:

  • Runtime files of 10 MB or larger
  • More than 50 clients

In this case, the reloading process can be optimized in order to prevent all Clients being reloaded at the same time. You can make this happen with the RELOADDELAY_SEC entry in project.ini. With this, reloading is delayed by a random value.
For this:

  1. Open project.ini in the \Project_SQL_fodler\FILES\zenon\system\ folder
    Hint: Highlight the project in the project manager and press the keys Ctrl+Alt+E; the Windows Explorer opens the \Project_SQL_folder\FILES\ folder
  2. Navigate to the [NETZ] section
  3. Create the entry RELOADDELAY_SEC=Value
  4. Select a value value for the delay.

When reloading, a random delay in seconds is calculated for each client, which is between 0 and the selected value. 0 means no delay (standard action). The selected value has no influence on standalone projects, the Primary Server or the Standby Server.

Note: This entry should only be set in every large projects with a noticeable delay when reloading. The standard settings provide better performance in normal projects.


Strong encryption of network communication

Manual -> Network -> Strong encryption of network communication

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon enables strong encryption of communication in the zenon network. Strong encryption works from zenon Version 7.0 for all supported operating systems and for the Web Client.

If encryption is active, communication between the Primary Server, Standby Server, Clients and Web Clients is in encrypted form; the zenon Web Server only forwards data packets and is not affected by encryption.

info Information

Network communication was also encrypted in earlier versions of zenon. The method has changed with version 7. The term "encryption" in conjunction with zenon 7 or later always means strong encryption.


Basics

Manual -> Network -> Strong encryption of network communication -> Basics

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Encryption for zenon Runtime is available from version 7.0. It is not possible to communicate with earlier versions of zenon if encryption is switched on. Encryption does not impair any zenon functionality.

Basic encryption from zenon 7.00

To use the strong encryption of the zenon network, note:

  • The password is encrypted individually on each computer and stored in zenon6.ini. That means:
    • The password cannot be transferred by copying zenon6.ini to another computer.
    • If hardware components are changed, in the network adapter area in particular, the password may be invalid and need to be re-entered.
  • Encryption must always be activated or deactivated for all components involved in the zenon network. Communication between encrypted and unencrypted systems is not possible. Web Servers only act as a proxy computer and are not affected by encryption.
  • If encryption is activated on a computer, it always applies for the projects of this computer with the Network active property active.

info Information

AES 192 from Microsoft is used as the encryption algorithm for network communication.

SHA 256 from Microsoft is used in order to generate the key from the entered password.

Compatibility

Encryption is not compatible with versions prior to zenon 7.00 SP0. That means:

System 1 | System 2 | Communication
zenon 7 encrypted | zenon 7 encrypted | Yes
zenon 7 unencrypted | zenon 7 unencrypted or zenon prior to version 7 unencrypted | Yes
zenon 7 encrypted | zenon 7 unencrypted or zenon prior to version 7 unencrypted | No

Errors are logged in the Diagnosis Viewer's log file.

Example

The following illustration shows an example of a network with Primary Server, Standby Server, two clients, one Web Server and two Web Clients. All devices are running zenon 7.00 SP0. The devices are configured as follows:

  • Encryption is activated on the Primary Server using the Startup Tool.
  • Encryption is also activated on the Standby Server and client A via Remote Transport when Runtime files are transferred.
  • Client B and Web Client B still communicate without encryption.
  • On Web Client A, encryption is activated on the server using the Startup Tool.
  • Because the Web Server does not evaluate the data packets, but instead forwards these on immediately, it does not require encryption. In theory, it can also have an older version, and the Web Clients can nevertheless create encrypted connections.

This configuration leads to the following result:

  • The Standby Server communicates successfully with the Primary Server.
  • Client A can log in to the Primary Server and exchange data.
  • Because client B sends unencrypted messages and these are rejected by the Primary Server because encryption is active, client B cannot communicate with the Primary Server and is therefore offline.
  • Web Client A logs on to the server via the Web Server and can exchange data.
  • The unencrypted messages from Web Client B are forwarded from the Web Server to the Primary Server, but the server rejects these. Web Client B cannot communicate with the Primary Serverr and is therefore offline.

As soon as encryption via Remote Transport or the Startup Tool configuration on client B and via enrcypt network communication on Web Client B is activated, these connections can also make connections to the Primary Server.


Activate encryption

Manual -> Network -> Strong encryption of network communication -> Activate encryption

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Encryption can be activated in different ways:

  • via the Startup Tool for the local computer and the Web Client
  • via Remote Transport

Hint

For quick, easy activation of the encryption, it is recommended that the configuration is carried our on a computer using Remote Transport.


Locally via the Startup Tool

Manual -> Network -> Strong encryption of network communication -> Activate encryption -> Locally via the Startup Tool

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To activate encryption on the local computer or for the Web Client:

  1. Open the zenon Startup Tool
  2. Click on Application -> Options
  3. The dialog for the settings of the zenon Startup Tool is opened
  4. Select the 'Network configuration' tab

  5. Check the checkbox Encrypt network communication
  6. Enter the password and confirm this
  7. confirm the dialog by clicking OK


Via Remote Transport

Manual -> Network -> Strong encryption of network communication -> Activate encryption -> Via Remote Transport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Encryption can be be activated on remote computers using Remote Transport. However, this is only possible if the Remote Transport connection is protected with a password.

To activate encryption using Remote Transport:

  1. Click on the corresponding button in the Remote Transport toolbar

    or select, in the project's context menu: Set up Remote Transport> connection.

  2. The dialog for setting up the connection is opened

  3. Enter the connection password or create one, if none has been set
  4. Activate the Configure encryption of network communication checkbox
  5. Click on OK.
  6. The dialog for encryption of network communication is opened

  7. Activate the Encrypt network communication checkbox
  8. Issue a password (for criteria, see the network password encryption section.)
    To quickly transfer the local configuration to other computers, the local password can first be read via Read local configuration.
  9. Confirm the dialog by clicking on the OK button.


Network encryption password

Manual -> Network -> Strong encryption of network communication -> Network encryption password

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following is applicable for encryption of the communication in the network:

  • Minimum length 8 characters
  • Maximum length: 20 characters
    The displayed length is always set at 20 characters, in order to hide the actual length.
  • Permitted characters:
    • Letters: A - Z; a - z
    • Digits: 0 - 9
    • Special characters
  • Characters that are not permitted:
    • Space
    • Enter key (Return key)
  • Summary: a password must contain at least 1 figure and 1 letter


Checklist for errors

Manual -> Network -> Strong encryption of network communication -> Checklist for errors

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the event of errors, check:

  • Do all computers have access to the network and does the naming resolution work between the computers?
  • Was the Network active property activated for the project in the Editor?
  • Is zenon Runtime version 7.00 SP0 or higher being used? (relevant if encryption is being used)
  • Is - for projects with encryption - the configuration correct on all computers?
    (USE_ENCRYPTION setting in zenon6.ini: The same for all computers, either 0, 1 or not present.)
  • Was the password set correctly?
  • Was the hardware changed on one of the computers involved after the encryption has been configured?
  • Does a ping work on a computer?
    • Yes: Network connection present, fault is with the communication.
    • No: Check the network.
  • Is it possible to connect to Telnet?
    • The connection is made: Both computers communicate at the same level. Check the password.
    • The connection is made and lost again: One computer communicates with encryption, one without encryption.
    • Faulty connection: zenon Runtime does not run on the target computer.

    Note: Telnet must be installed as an extra on more recent Windows operating systems. Connection is generally made via port 1100.
    The Telnet command is then: open [IPAdresse] 1100

  • Are the required (operating system) functions available (primarily relevant for CE terminals)?
    • Non-existent functions lead to Runtime not being able to start.
  • If the service provider or one of the algorithms is not available, an error message is written to the log file when Runtime is started.

Errors are logged in the Diagnosis Viewer's log file.


Error message

Manual -> Network -> Strong encryption of network communication -> Error message

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Errors are either displayed in the output window of the zenon Editors or in pop-ups and/or in the log files of the Diagnosis Viewer.

No connection

If a client has been configured with an incorrect encryption password (not the same as the password on the Primary Server) then this is evident from the following events:

  • The Client is offline, although the Primary Server can be reached by pinging.
  • The Primary Server writes error messages to the log file:

    SysMod Error: Serialize in Object Project: [project name] Modul: [module number]

    or:

    NET Error During Decryption [Error number]

Pop-ups and error messages

Encryptions errors are notified by means of pop-ups and entries in log files or in the zenon output window.


Error messages in pop-ups

Manual -> Network -> Strong encryption of network communication -> Error message -> Error messages in pop-ups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Startup Tool and Web Client

The following error messages are output by the zenon Startup Tool as a pop-up for local encryption or by Encrypt Network Communication Tool for the configuration of the Web Clients. The messages that come directly from the Startup Tool or from the Encrypt Network Communication Tool are always in English; messages from Runtime itself are in the language that has been set.

Error message | Description
The password has to be entered in both text boxes! | When configuring the encryption, the user has left one of the two input fields (Password or Password confirmation) empty.
The passwords you typed do not match. Please retype the password in both boxes. | The content of the input field for password confirmation is different to the content of the input field for the password.
The network password does not fulfill the password criteria! Password criteria: - Minimum length = 8 - Maximum length = 20 - At least one character of the Latin charset - At least one number - No spaces | The password entered does not meet the password criteria. The password criteria are displayed in the error message.
The network password could not be encrypted! | An error occurred when encrypting the network password.
The network encryption configuration in the file zenon6.ini is invalid. Please enter a new configuration. | When opening the Network configuration tab, it was established that the zenon6.ini file does not contain a valid configuration for the network encryption. A new configuration must be entered.
The network encryption password in zenon6.ini is invalid. | The password read in from the zenon6.ini file is invalid and must be reentered.
The password for network encryption is invalid and must be entered again! | Message when Runtime starts if the password cannot be verified.

Remote Transport

The following error messages are given by Remote Transport as a pop-up when the remote computer is encrypted.

Error message | Description
For configuring the network encryption, the Remote Transport connection must be protected with a password! | An attempt was made to configure remote encryption without securing the Remote Transport connection by means of a password.
You must enter the password in both input fields! | When configuring the encryption, the user has left one of the two input fields (Password or Password confirmation) empty.
The password confirmation does not match the password! | The content of the input field for password confirmation is different to the content of the input field for the password.
The password entered does not correspond to the password criteria. Password criteria: At least 8 characters Maximum 20 characters At least one letter At least one number No spaces | The password entered does not fulfill the password criteria. The password criteria are displayed in the error message.
An error occurred when encrypting the password! | An error occurred when encrypting the password. If this error occurs during configuration via Remote Transport, a more detailed error message is written to the log.
An error occurred when decrypting the network password from zeon6.ini. | The password stored in zenon6.ini cannot be decrypted. If this error occurs during configuration via Remote Transport, a more detailed error message is written to the log.
The encryption configuration in zenon6.ini is not valid and must be reentered. | The password read off from zenon6.ini is invalid. The password must be entered again.


Error messages in the output window

Manual -> Network -> Strong encryption of network communication -> Error message -> Error messages in the output window

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Errors are displayed in the output window as messages:

Message | Level | Description
The server reports an error when compiling the data for the encryption configuration. | ERROR | The remote zenSysSrv reports an error when compiling the information for the encryption of the password for network encryption. The adapter information cannot be read off.
*** Configure the encryption of the network communication at the target system. |  | This message is at the start of the conclusion message after encryption has been configured on a remote device via Remote Transport. After this, there is a message in relation to the success of the remote configuration.
The server reports an error when the encryption configuration is changed. | ERROR | The remote zenSysSrv reports an error when the encryption configuration is saved to the remote device. The configuration was not saved.
The configuration was successfully saved on the server. | MESSAGE | The remote zenSysSrv reports that the encryption configuration was successfully saved.
The version of the remote zenSysSrv is too low. The encryption cannot be configured. | ERROR | An attempt was made to configure the encryption on a remote device, which has a zenSysSrv from a version prior to version 7.00 SP0. Encryption is only available from zenon version 7.00 SP0; an earlier version of zenSysSrv cannot therefore configure this.


Error messages in log files

Manual -> Network -> Strong encryption of network communication -> Error message -> Error messages in log files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Encryption

Errors in encrypted network traffic are documented in log entries. The Error IDs of the error messages in the following summary are system or COM error codes. You can find more information in the MSDN library.

LOG entry

Level

Description

NET Error During Acquiring Cryptography Context [Error-ID]

ERRORS

The creation of a service provider for encryption was unsuccessful.

NET Error During Creating Hash [Error-ID]

ERRORS

The creation of a hash value was unsuccessful.

NET Error During Using Hash [Error-ID]

ERRORS

The processing of a hash value was unsuccessful.

NET Error During Destroying Hash [Error-ID]

ERRORS

The release of a hash value that is no longer required was unsuccessful.

NET Error During Deriving Key [Error-ID]

ERRORS

The creation of a key for symmetrical encryption was unsuccessful.

NET Error During Configuring Key [Error-ID]

ERRORS

The setting of parameters for symmetrical encryption was unsuccessful.

NET Error Cryptography Not Initialized!

ERRORS

An encryption or decryption function was called up but initialization of the required parameters (service provider, key) was unsuccessful.

NET Error Invalid Pointer passed!

ERRORS

An encryption or decryption function was given invalid parameters.

NET Error Message Length Must Not Be 0!

ERRORS

The encryption function was called up with an empty message.

NET Error During Buffer Length Calculation [Error-ID]

ERRORS

The calculation of required buffer size for encryption was unsuccessful.

NET Error Buffer Length Must Not Be 0!

ERRORS

The buffer for encryption or decryption has not been created.

NET Error During Decryption 0x%x

ERRORS

An error occurred during decryption.

NET Error During Encryption 0x%x

ERRORS

An error occurred during encryption.

NET Error: Encryption Is Required And Project [Projekt] Received Plaintext Network Message

ERRORS

Encryption is active and a decrypted message was received. The message is discarded in this case.

NET Error: Encryption Is Not Supported And Project [Projekt] Received Encrypted Network Message

ERRORS

Encryption is not active and an encrypted message was received. The message is discarded in this case.

NET Cryptography Successfully Initialized

DEBUG

The parameters required for encryption and decryption were initialized successfully. The parameters are initialized when Runtime is started.

NET Uninitializing Cryptography

DEBUG

The parameters required for encryption and decryption were released. This happens when Runtime is ended. If the log connection is separated before release, the message does not appear in the Diagnosis Viewer.

NET Error During Buffer Size Calculation [Error ID]

ERRORS

An error occurred when the necessary buffer size for compiling information for encrypting or decrypting the network password was calculated.

NET Error During Buffer Size Calculation: No Adapters

ERRORS

The computer does not have a network adapter. For this reason, the network password cannot be encrypted or decrypted.

NET Error During Adapter Info Query [Error ID]

ERRORS

An error occurred when the adapter information for encrypting or decrypting the network password was read off.

NET Error Password Not Properly Formatted

ERRORS

The hex dump of the encrypted password is in an invalid format.

NET Error During Password Decryption [Error ID]

ERRORS

An error occurred when decrypting the network password.

NET Error During Encrypting Password [Error ID]

ERRORS

An error occurred when encrypting the network password.

NET Cryptography Is Disabled

DEBUG

Encryption of the network traffic is deactivated.

NET Error No Password

ERRORS

Encryption is active, but no password is entered.

NET Error Password Could Not Be Decrypted

ERRORS

The password for network encryption could not be decrypted.

NET Password successfully loaded

DEBUG

The password for network encryption has been loaded successfully.

Network Cryptography Disabled By Remote Configuration

DEBUG

zenSysSrv reports that encryption of network traffic on the computer was deactivated by the Remote Transport configuration.

Network Cryptography Disabled By Remote Configuration

DEBUG

zenSysSrv reports that encryption of network traffic on the computer was activated by the Remote Transport configuration.

Network Cryptography Remote Configuration Error

ERRORS

A configuration sent by Remote Transport for network encryption is erroneous.

Error During Buffer Size Calculation [Error ID]

ERRORS

An error occurred when the necessary buffer size for compiling information for encrypting or decrypting the network password for the configuration of Remote Transport was calculated.

Error During Buffer Size Calculation: No Adapters

ERRORS

The computer does not have a network adapter. For this reason, the network password cannot be encrypted or decrypted and thus not set via Remote Transport (it must therefore be connected via COM). The use of network encryption on a computer without a network adapter makes no sense however.

Error During Adapter Info Query [Error ID]

ERRORS

An error occurred when the adapter information for encrypting or decrypting the network password for configuration via Remote Transport was read off.

NET Error During Decrypting Password: The Password is Invalid!

ERRORS

The password is no longer valid, because the

initial data for computer-dependent encryption has changed.

This error can be rectified by configuring the password again.

The decryption process is usually cancelled before the validity of the password is checked, because the old password cannot be decrypted with the new encryption data.

This leads to the "NET Error During Password Decryption 0x80090005" error, where instead of "NET Error During Password Decryption The Password is Invalid! is displayed. Another consequence is that a password that is now invalid on the computer in question can lead to error messages when network packages are sent or received. The error message "NET Error Cryptography Not Initialized!" is written to the log file.


zenon on the Terminal Server

Manual -> Network -> zenon on the Terminal Server

The zenon Runtime can also be used together with a terminal server solution.

Limitations:

  • The Editor cannot run on a terminal server.
  • Project simulation is not available for clients at the terminal server.

info Information

Keep in mind that the name of the terminal client is resolved. That means: The name of the device that initiates the terminal connection is the name of the Clients for the zenon network.

Attention: Ensure that all corresponding ports have been unlocked when using a firewall.

Terminal server solutions are offered by several manufacturers. All tests with zenon were carried out using the Windows terminal server (Windows Remote Desktop Services).

attention Attention

When using zenon with a terminal server, it must be licensed with a Network dongle.

Several instances of Runtime

Only one instance of zenon Runtime can be started on a computer at any time. This applies regardless of whether Runtime is started as an EXE file, a Web Client or as Runtime Control (OCX).

Exception: On the terminal server or terminal client, one instance of Runtime per user can be started as an EXE file, as a Web Client or as Runtime Control (OCX). Only 1 instance can run at any time within a user context.


How terminal servers work

Manual -> Network -> zenon on the Terminal Server -> How terminal servers work

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With terminal servers, it is possible to provide data and applications centrally, regardless of the end device. Terminal servers make it possible to start several shell instances (desktops) that are separate from one another on the terminal server. If a client connects to the terminal server, a new shell instance is created and the client is assigned its own graphic user interface. The applications are executed on the terminal server itself and the data is saved on the terminal server. Input (via the keyboard, mouse etc.) and output (display, audio, etc.) is on the Client.

info Info

Not all software is compatible with terminal servers.


Advantages and disadvantages

Manual -> Network -> zenon on the Terminal Server -> Advantages and disadvantages

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Advantages

  • Only one computer (the terminal server) has to be maintained.
  • Clients do not have to be very powerful (Thin Clients).
  • Clients can have different operating systems (Windows, Windows CE, Linux, Unix, MacOS, iOS, Android etc.).
  • High degree of data security, because no data is saved on the Client.

Disadvantages

  • All started programs of all instances run on one computer (the terminal server).
    This:
    • must have sufficient computing power for all started programs.
    • must have sufficient RAM for all started programs.
  • All interfaces have to be shared. E.g. network adapters, COM ports, parallel ports.
  • The network load can be high with an appropriate number of Clients (such as transfer of graphic data).
  • The screen resolution is defined by the client started first. If screens in different resolutions are to be used, this can be implemented on the terminal server by means of an entry in zenon6.ini (SERIALIZE=1). All screens are then calculated again for the client, which further increases the necessary performance for the terminal server.


Operation zenon at the terminal server

Manual -> Network -> zenon on the Terminal Server -> Operation zenon at the terminal server

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On a terminal server, operation is possible as:

  • zenon Client possible without limitations
  • zenon standalone systems only worthwhile and possible:
    • as a superordinate integration project to start several Client sub-projects
    • without drivers, database connections etc.
  • zenon Primary Server not possible

Schematic display

For example, the topology of a Terminal Server network with zenon could look as follows:

Computer | Description
A. | zenon Primary Runtime Server
B. | Terminal Server and n-fold Runtime Client
C. | Terminal Clients (input and output only)


Required settings

Manual -> Network -> zenon on the Terminal Server -> Required settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order for zenon Runtime to be able to be started more than once on the terminal server, several settings must be made. The settings for registration, screen resolution and transfer service can be undertaken with the zenon Startup Tool.

info Information

The following parameters are automatically set with registration via the Startup Tool:

  • INI entries:
    [TERMINAL]
    CLIENT=1
    SERIALIZE=1
  • Registration of ZenSysSrv.exe as a service
  • Deregistration of ZenDBSrv.exe

General settings

  1. Registration

    Register the use on the terminal server via the zenon Startup Tool.
    Alternatively, you can configure the corresponding INI entries manually.

    zenon6.ini entry:
    The following entry must be added in zenon6.ini on the terminal server. On the Primary Runtime server no settings are needed.

    [TERMINAL]
    CLIENT=1

    1: The Runtime can be started several times, all settings for the terminal server operation are automatically set by the Runtime.
    0: The Runtime can only be started once. Operation on the terminal server is not possible. (standard setting)

  2. Automatic adjustment of the screen resolution

    Per default the first client at the terminal server defines the screen resolution. This setting can be amended on the terminal server with the following entry in zenon6.ini:

    [TERMINAL]
    SERIALIZE=1

    1: Each client gets its own resolution.
    0: The first client defines the resolution.

  3. Transfer

    The transport service (zensyssrv.exe) must be registered and started as a Windows service, not as a standard EXE file. This setting is automatically set when registering via the Startup Tool, but can also be set manually.

    Manual setting:

    1. Start the program from the command line interface with the -service option.

      For example: C:\Programs (x86)\COPA-DATA\zenon720\zenSysSrv.exe -service

    2. Then start the Windows Service Manager. The service will be started automatically during every computer restart.

    Note: The setup always registers the transport service as a standard EXE. Therefore the transport service must be re-registered as a Windows service after every reinstallation.

  4. Runtime folder

    All users must have write access to the Runtime folder. All Windows users (Windows users: All) in Windows Explorer must have complete access to the Runtime folder and all its subfolders.

attention Attention

If TERMINAL=1 is set, the project simulation is no longer available.

Selective reloading of single projects

Projects can also be synchronized selectively. In this case clients only reload projects if project changes exist. To activate the selective reloading:

  1. open the file zenon6.ini with a text editor
  2. go to area [TERMINAL]
  3. edit or create entry: CLIENT_NO_FILE_ALIGN=
  4. possible values:

    0: Projects are always reloaded by all clients

    1: selective synchronization active. Only the zenon client which is started in the console session of the terminal server synchronizes the Runtime files with the zenon server

After synchronizing the Runtime files the console client writes file reloadindicator.tmp in the directory which contains file project.ini of the program . The session clients at the terminal server check every 10 seconds whether this file is available. Does it exist and is its file time stamp newer that the date of the last reload, a session client reloads automatically.

Entry in zenon6.ini for selective reload

[TERMINAL]

CLIENT=1

CLIENT_NO_FILE_ALIGN=1

SERIALIZE=1


zenon Remote Desktop versus Terminal Server

Manual -> Network -> zenon on the Terminal Server -> zenon Remote Desktop versus Terminal Server

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The terminal server solution is different from zenon Remote Desktop primarily due to the following points:

zenon Remote Desktop connection | Terminal server connection
All connected stations always see one and the same desktop. If e.g. one user starts a program, all see the same program, the same mouse cursor, the same keyboard input, etc. | Each connected station has its own desktop - an own instance. Only it sees, what happens there. Mouse actions and keyboard inputs only affect this one instance.
 | That also means: In each instance a program can be started separate, e.g. a text editor. The program then runs on the terminal server several times and therefore needs more resources.


Administering and checking network topology

Manual -> Network -> Administering and checking network topology

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The network topology is displayed in a separate project manager tab.

It consists of three areas:

  • Topology tree (top left): shows active projects; the global project is not displayed
  • Event tree (top right): only the result is displayed; represents the topology tree of a selected computer
  • Computer list(bottom): List display and configuration of computers in the network


Topology tree

Manual -> Network -> Administering and checking network topology -> Topology tree

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The topology tree displays active projects in hierarchical form.

Parameters | Description
Project name | Is defined in the project tree tab and cannot be changed here.
Network active | Displays whether the network option is active for this project. The setting can be changed via the Network active property.
Server 1 | Displays the Primary Server defined for this project. The setting can be changed via the context menu, the symbol in the tool bar or the Server 1 property.
Server 2 | Displays the Standby Server defined for this project. The setting can be changed via the context menu, the symbol in the tool bar or the Server 2 property.

Toolbar and context menu

Property | Description
Set computer as Primary Server | Defines the computer highlighted in the computer list as the Primary Server for the project highlighted in the tree.
Set computer as Standby Server | Defines the computer highlighted in the computer list as the Standby Server for the project highlighted in the tree.
Delete Primary Server | Deletes the Primary Server defined for the highlighted project.
Delete Standby Server | Deletes the Standby Server defined for the highlighted project.
Help | Opens online help.


Result tree

Manual -> Network -> Administering and checking network topology -> Result tree

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The result tree represents the project tree of the computer selected in the computer list from the project, which is set as a start project for the selected computer and displays these project settings.

The result tree is empty if:

  • The start project of the selected computer was not found
  • More than one computer in the list was selected

Parameters

Description

Project name

Projects that are assigned to the selected computer.

Role

Role of the computer:

  • Primary Server
  • Standby Server
  • Client

Primary Server

Name of the computer that acts as a Primary Server to Runtime.

Standby Server

Name of the computer that acts as a Standby Server to Runtime.

Result of test

Shows detailed error messages for topology test.


Computer list

Manual -> Network -> Administering and checking network topology -> Computer list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The computer list shows all computers that have been added and allows them to be configured. The list relates to the workspace and is saved in the workspace file (*.wsp6).

Parameters

Description

Computer name

Name of the computer. Can be changed by:

  • Click in the cell: Clicking on the ... button opens a drop-down list of the computers currently available in the network.
  • Edit computer entry in the context menu or the tool bar
  • Computer name property.

Start project

The start project assigned to the computer Can be changed by:

  • Click in the cell: Select from drop-down list.
  • Set start project entry in the context menu or the toolbar Sets the project selected in the topology tree as the start project.
  • Start project property.

Start project Runtime folder

Folder for project files on the target computer. The files of the start project are saved in this folder. All other projects relating to this correspond to the structure of the Runtime folder set up on the local computer.

For example:
Start project Runtime folder: C:\Projecs\Top = location where start project is stored.
Sub projects are stored in C:\Projects\.

Hint: Use the project name as folder name in order to create the same structure as on the engineering computer automatically.

The Start project Runtime folder can be changed by:

  • double clicking on the computer: Opens computer configuration dialog.
  • Click in the cell: Manual entry possible.
  • Start project Runtime folder property.

Result of test

Shows the result of the topology test.

  • OK: All projects are free of errors.
  • Error detected - For details see detail view! One or more projects have an error.
  • Critical error detected - For details see the detail view! A project has a serious error. Serious errors halt further testing.
  • Not tested, because there is a serious error in the structure: The computer was not fully tested, because the test was ended due to a serious error.

Detailed error messages are displayed in the result tree.

Toolbar and context menu

Entry | Description
Add computer... | Opens the Configure computer dialog in the network.
Edit computer... | Opens the dialog to configure the computer in the network for these computers.
Delete computer | Deletes computer from the topology after requesting confirmation. Attention: Deletion of the Primary Server or Standby Server leads to serious errors in the topology.
Set start project | Sets the project selected in the topology tree as the start project.
Copy Runtime files from all projects on the computer | Copies all projects valid for the selected computer to the target computer. The result is displayed in the output window.
Help | Opens online help.


Computer network configuration dialog

Manual -> Network -> Administering and checking network topology -> Computer list -> Computer network configuration dialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following data is necessary to configure the computers:

Parameters

Description

Computer name

Clicking on the ... button opens a drop-down list of the computers currently available in the network.

Start project

Selection of the start project from a drop-down list.

Start project Runtime folder:

Folder for project files on the target computer. The files of the start project are saved in this folder. All other projects relating to this correspond to the structure of the Runtime folder set up on the local computer.

Hint: Use the project name as folder name in order to create the same structure as on the engineering computer automatically.

For example:
Project name = I-Project
at Start project Runtime folder enter: C:\Projects\I_Project
The sub-projects in relation to this path are stored at C:\Projects\Projektname, for example:
The project name is SubProject1, then the Runtime folder for this is C:\Projects\SubProject1.

Requirement: The Runtime folders are left at their default settings and the projects were created at one file level.

If this is not the case, it may be the case that subprojects cannot be copied, because the relative folder cannot be created from the start project.

Example: The integration project has the following set up as a Runtime folder: C:\Workspace\Projects\I_Project. The sub project has the following set up as a Runtime folder: C:\Subproject. The start project Runtime folder is set to C:\Project. The sub project cannot be transferred, because the relative folder would be..\..\Project. This does not work, because the Runtime folder for the sub project would be below C:\.
Solution: Set the Runtime folder project property correctly. It is best to do it so that the Runtime folder is at the same level for all projects.


Error messages from topological testing

Manual -> Network -> Administering and checking network topology -> Error messages from topological testing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The topology test is always carried out if settings concerning the topology change. The effect of each change can be observed immediately this way. The topology is also tested if the topological view is changed.

Tests carried out

  • Is the project defined in the project tree available in the project tree?
  • Was a Primary Server defined?
  • Were different computers defined for Primary Server and Standby Server?
  • Can the client achieve its Primary Server/Standby Server?
  • Can the Primary Server reach its clients?
  • Can the Standby Server reach its clients?
  • Is the Primary Server available for a project in the topology?
  • Is the Standby Server available for a project in the topology?
  • Is a computer included more than once in the path from Client to the Primary Server?

Not tested:

  • Is a client only updated on one path by the Primary Server or do several paths exist?

Client to server

  • Does the client reach its Primary Server via the Primary Server's chain?
  • Was a computer that routes switched to its Standby Server?

    Info: The server must also be be able to be reached by the client via the project's Standby Server that routes.

Error message

Errors that are recognized during the topology test are displayed in the result tree in the test result column.

Error

Reason

Solution

The start project is unknown!

Start project cannot be found.

Correct project configuration or include missing project in the workspace.

The computer is entered as a server and standby!

Server and Standby Server must be different computers.

Define different computers as Server and Standby Server.

No computer is entered as server!

The project is a network project but no server was configured.

Define a computer as a server.

The project is not started on computer (name)! However it is necessary because higher hierarchic levels need access to it.

The project is not loaded on the computer stated. The project is however routed via this.

Adapt topology or start project for the computer or deactivate the Routing active property.

Circular access to the server: The computer (name) redirects to the client (name)!

The routing path from the client to server goes around in a circle. The computer that acts as a node redirects to the client.

Adapt topology or start project for the computer or deactivate the Routing active property.

Circular access to the standby: The computer (name) redirects to the client (name)!

The routing path from the client to the standby goes around in a circle. The computer that acts as a node redirects to the client.

Adapt topology or start project for the computer or deactivate the Routing active property.

The computer (name) is not included in the list of computers

Computer is missing in the list of computers for the topology.

Add computer to topology.

Not checked because there is critical error in the topology

No check could be made out for this computer because there was a critical error.

Rectify other errors so that the check can also check this computer.

Circular access path: (computer names)

The routing path from the client its the server/standby goes around in a circle.

The "computer names" field contains the names of the computer that are affected.

Structure: The first computer is always the client. The separator between the computer names indicates whether the following computer is a server or standby.

  • > identifies the following computer as a server.
  • "+" labels the following computer as a standby.

For example: Computer1+Computer2 > Computer3

Adapt topology or start project for the computer or deactivate the Routing active property.

Circular access path exists from server to client!

The server is found according to the node when searching for the client computer.

Adapt topology or start project for the computer or deactivate the Routing active property.

The server (name) does not reach this client!

The path is not closed from the stated server to the client. The client is included in the client list on the server but is not updated. (The blue dots do not disappear on the client.)

Adapt topology or start project for the computer or deactivate the Routing active property.


Redundancy

Manual -> Network -> Redundancy

Redundancy in zenon ensures that processes are not interrupted even in the event of a failure of the Primary Server and that no data is lost. In zenon, we speak of seamless redundancy.

Seamless redundancy means that the time period between the failure of the Primary Server and detection of the failure is protected from data loss. This is implemented as follows:

  • The Standby Server detects the failure of the Primary Server and automatically takes on the complete functionality thereof.
  • In order to avoid data loss in the time period between the server failure and the detection of the failure, the Standby Server always buffers all data.
  • After a failure of the Primary Server, this buffer is merged with the last data from the server and the new incoming data, so no data can be lost.

info Info

For zenon Operator, depending on the role, the following is applicable for connections to the server with Supervisor license:

Client

  • Connection to Server 1 and Server 2 is possible.
  • Client connects to the Standby Server if the Primary Server fails.
  • Several instances of a driver are supported.
  • All variables of all drivers are displayed and can be written.
  • Archives can be read.
  • Redundancy switching can be executed.

Standby Server:

  • Start as a Standby Server is possible.
  • A warning message must be confirmed.
  • Variables of the Standby Server are displayed.
  • Archives of the Standby Server are displayed.
  • Only the first instance of a driver is started on the Standby Server.
  • After redundancy switching, variables of the second instance of a driver have the status INVALID. This status also remains after being switched again.

Data server:

  • More than one instance of a driver can be started. However only one of the instances can send values to Runtime. zenon Operator thus behaves along the lines of a CE panel on which only one driver can be started for technical reasons.

Standalone

  • A warning message must be confirmed.
  • Variables of the Standby Server are not displayed.

info Information

Project changes need only be entered on the Primary Server; the standby server and the connected clients automatically synchronize online data. This ensures that the project status is the same on all computers.

Software redundancy and hardware redundancy

With redundant systems in zenon, a distinction is made between software redundancy and hardware redundancy.

Circular redundancy

zenon circular redundancy is a special form of redundancy that allows seamless redundancy for several projects with a low amount of hardware being used and very simple configuration.

zenon redundancy and zenon Logic redundancy

You can find details on the combination of zenon redundancy and zenon Logic redundancy in the zenon Logic Runtime manual).

info Info

If only one controller is available, which offers only one communication channel, the Stop at the Standby Server option in the general settings of the driver configuration can be activated. The driver is thus stopped at the Standby Server and only started again at the upgrade.


Setting up the Standby Server

Manual -> Network -> Redundancy -> Setting up the Standby Server

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To set up the Standby Server:

  1. Open, in the project properties in the Editor, the Network group.
  2. Enter, in the Server 2 property, the name of the computer that is to serve as the Standby Server for the project. (the computer must have a connection to the PLC.)

    You can enter the computer name:

    1. By selecting from the drop-down list after clicking on the ... button
    2. Manually

Select, in the Redundancy type property, the desired redundancy form from the drop-down list:

info Information

Servers from different domains are permitted!
In this case, configure the server name including the domain name.

Eg: terminal_01.mydomain.net


Types of redundancy

Manual -> Network -> Redundancy -> Types of redundancy

For redundant systems with zenon, a distinction is made between:

  • Software redundancy:
    Only the Primary Server communicates with the controller in two directions (write and read). The Standby Server communication is read-only.
  • Hardware redundancy:
    PLCs are also designed as redundant. The Standby Server communicates two ways with the controller that is designed as redundant.

You can find the selection of this in the configuration of the Standby Server.


Software redundancy

Manual -> Network -> Redundancy -> Types of redundancy -> Software redundancy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following components are required for software redundancy:

  • A controller
  • Two redundant computers (Primary Server and Standby Server)

In operation, the Primary Server communicates with the controller in two ways, the Standby Server communicates with the controller as read-only and synchronizes its data from the Primary Server.

In the event of a failure of the Primary Server:

  • The Standby Server becomes the new Primary Server
  • Seamless redundancy ensures that all data is complete without omissions, including data from the time between the failure and the switch
  • The new Primary Server communicates with the PLC both ways


Hardware redundancy

Manual -> Network -> Redundancy -> Types of redundancy -> Hardware redundancy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In zenon networks, there are two types of hardware redundancy available:

  • Non-dominant
    In a non-dominant network, the Primary Server communicates both ways with the first controller; the Standby Server communicates with the controller both ways.
    The Standby Server synchronizes with the Primary Server; the second PLC synchronizes with the first PLC.
  • Evaluated
    In an evaluated network, configurable criteria are evaluated in a matrix. The server roles are given according to the result.
    Caution: Please note the limitations in evaluated networks if a CE terminal acts as a data server.


Hardware redundancy

Manual -> Network -> Redundancy -> Types of redundancy -> Hardware redundancy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In a non-dominant network, the Primary Server communicates both ways with the the first controller; the Standby Server communicates with the second controller both ways.
The Standby Server synchronizes with the Primary Server; the second PLC synchronizes with the first PLC.

In the event of a failure of the Primary Server or the first controller:

  • The Standby Server becomes the new Primary Server
  • Seamless redundancy ensures that all data is complete without omissions, including data from the time between the failure and the switch
  • The Primary Server communicates both ways with the second controller


Redundancy in an evaluated network

Manual -> Network -> Redundancy -> Types of redundancy -> Redundancy in an evaluated network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With hardware redundancy in an evaluated network, evaluation criteria decide which computer takes on the role of the Primary Server and which takes on the role of the Standby Server.

This evaluation can be freely configured and can include several different criteria. Each criterion is assigned evaluation points - the weighting. The sum of the weighting points then decides on the respective server role.

info Information

If one of the two servers - regardless of whichever role they have - loses the other server (for example: hardware failure), it automatically upgrades to the Primary Server.

Reasons for delaying the regrading:

  • The internal modules have not yet been fully initialized. This is possible if a driver delays the regrading process.
  • The regrading is already active and not yet completed.
  • The file sync is still active.
  • Reloading is taking place.

Note: As a result of the automatic cyclical, renewed activation of the regrading, this is therefore only suspended until the process is permitted.

attention Attention

If, in an evaluated network, server redundancy switching is triggered due to an evaluation, there is no guarantee that pending functions in the queue of the old Primary Server have also actually been processed successfully before switching.

This is because during redundancy switching in evaluated networks, both servers take on the role of the Primary Server for a short time. In this time, Server 1 and Server 2 synchronize their data. The time period of this status depends on the network load and can be between 200 and 500 milliseconds.

Time synchronization

In an evaluated network, the time synchronization of of Server 1 and Server 2 should always be deactivated by means of the zenon network.

The following is recommended for this:

  • Deactivate the automatic time synchronization in zenon.
  • Activate external time synchronization on Server 1 and Server 2 by means of the operating system

You can find detailed information on this in the Time synchronization in the network chapter.


Redundancy in an evaluated network

Manual -> Network -> Redundancy -> Types of redundancy -> Redundancy in an evaluated network -> Redundancy in an evaluated network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following project configurations are used for the operation of an evaluated network:

  1. Server 1 and Server 2
  2. Redundancy type is software redundancy
  3. Redundancy mode is evaluated
  4. Redundancy evaluation
    You can find details on redundancy evaluation under "Configuration of redundancy evaluation".
  5. Switching delay [s]
  6. Dead time after switching [s]
  7. Hysteresis (the evaluation points)


Configuration of redundancy evaluation

Manual -> Network -> Redundancy -> Types of redundancy -> Redundancy in an evaluated network -> Configuration of redundancy evaluation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The dialog to configure redundancy evaluation is opened by clicking on "..." in the Assessment properties field in the Network properties group.

The result of this evaluation is evaluated with the system variables Evaluation result for Server 1 and Evaluation result for 2.
Note: You can find further information on the network system variables in the System driver manual, in the Topic - network chapter.

The fields in this dialog can be filtered and sorted.

Parameters

Description

Name of the variable

List of the variables that can be used for the evaluation.

Note: A maximum of 200 variables can be used for the redundancy evaluation.

Weighting

Value of the test criteria.
Provides the value of the individual test criteria in the entirety of the test results.

The weightings, of all variables that are true are counted up.
Input range: 0 - 1000
Default: 100

Comparison

States the type of comparison, from which the value of the weighting is taken into account in the overall assessment.

Drop-down list:

  • Not used
    No comparison to the weighting is carried out.
  • Only status OK /value OK
    Only a check to see if there is a value is carried out. As soon as there is a valid value, the value of the weighting is used for the overall evaluation.
  • Values from limit are OK
    Values that are greater than or the same as the limit that has been entered use the value of the weighting in the overall evaluation.
  • Values up to limit are OK
    Values that are less than or the same as the limit that has been entered use the value of the weighting in the overall evaluation.

Default: not used

Limit

Limit for comparison with "Values from limit are OK" or "Values up to limit are OK"

Default: 0

Note: If the comparison is "not used" or "Only status OK /value OK", entries in this field have no influence on the evaluation.

Add...

Opens the dialog to select variables.

Remove

Removes the selected variable from the list
Note: Multiple selection is possible.

Cancel filtering

Removes the filter criteria

Close dialog

Parameters

Description

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Help

Opens online help.

Example Example

A variable is configured in the evaluation dialog with the following settings:

  • Weighting: 50
  • Comparison: Values from limit are OK
  • Limit: 50

Set the value of the variable to 55. The condition becomes true as a result and the weighting of 50 is added to the result of the system variable Evaluation result for Server 1.

a further variable is configured with the following settings:

  • Weighting: 30
  • Comparison: Values up to limit are OK
  • Limit: 10

As long as the value of this second variable =< 10, the weighting is added to the system variable.

If the value of the second variable is 5 for example, the evaluation result for Server 1 (if the previously-described variable is true) is 80.


Switching delay, down time and hysteresis

Manual -> Network -> Redundancy -> Types of redundancy -> Redundancy in an evaluated network -> Switching delay, down time and hysteresis

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Switching delay

The Switching delay [s] is the time (tolerance time) in which value changes of the evaluation result do not trigger a regrading. In doing so, short peaks or a brief failure do not lead to an immediate server change.

Note: A further improvement of the evaluation result during the configured switching delay does not reset the timer.

Example Example

If a Switching delay [s] of 30 seconds is configured, the evaluation on the current Standby Server must be at least 30 seconds better than that of the Primary Server in order to trigger regrading.

After successful regrading, the timers of Dead time after switching [s] and Switching delay [s] switching delay can run at the same time; both must have expired in order to trigger a regrading.

Down time

This setting prevents resetting on the basis of the Primary server during the configured time.

Note: the "Redundancy switching" function can be executed.

Example Example

If the evaluation of the current Standby Server - after the last regrading within the set down time - is better than that of the current server, there is not another regrading until this time expires. The start of the "time calculation" is the time in which the role swap of the server is completed.

If the evaluation increases within the down time of the Standby to more than that of the Server, but it goes down again to below or the same as the server before it expires, there is no regrading.

Hysteresis (in evaluation points)

If a Hysteresis is configured, a check is made before redundancy switching to see whether the evaluation results between the two computers (Server 1 and Server 2) have at least reached this. A difference the same as the hysteresis already triggers switching,

Example Example

Server 1 is Primary Server.

Server 1 and Server 2 each have evaluation result 0.

The Hysteresis is configured with value 100.

If the evaluation changes from Server 2 to 99, nothing happens, but if the value reaches 100a regrading is triggered.


Switching delay - example

Manual -> Network -> Redundancy -> Types of redundancy -> Redundancy in an evaluated network -> Switching delay, down time and hysteresis -> Switching delay - example

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Switching delay - example

In this example, the switching of the two servers is triggered by xxx. Once the reason for switching has occurred, the delay time is waited before Server 2 becomes the Primary Server. Although Server 1 could take on the role of the Primary Server again, the delay time is waited for before Server 1 takes on the role of the Primary Server.

You can see that Server 2 gets Primary Server after the difference between the evaluation system variables was higher than the hysteresis for the time of the Switching delay.
After the switch the Dead time after switching starts to count.

At the point where the difference is again higher than the hysteresis, the switching delay starts to count and Server 2 will get the Standby server.


LOG entries in the evaluated network

Manual -> Network -> Redundancy -> Types of redundancy -> Redundancy in an evaluated network -> LOG entries in the evaluated network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following log entries are written in the Diagnosis Viewer for the evaluated network:

Log entry

Debug Level

Description

LOG SendData Project:RATED_NET To:CDSBG079.COPA-DATA.INTERNAL Modul:10 Prior:0 Class:CD_CSystemDaten

Debug

Data from the CD_CSystemDaten class is transported via connection 0 (watchdog) to computer cdsbg079.

The module gives the zenon module to the one that has the data.

Module 10: Synchronous execution network module

LOG SendData Project:RATED_NET To:W7X64 Modul:10 Prior:0 Class:CD_CSrv1SystemDaten

Debug

As above, the target is Server2 and the source is Server1

LOG ReceiveData Project:RATED_NET To:S Modul:10 Class:CD_CSrv2SystemDaten

Debug

As above, the target is Server and the source is Server1

<Beschreibung> Prj:<ProjektName> client:<ClientRechner> Cmd:<CommandTxt>(<CommandNum>) Timeout:<Timeout>, ReqId:<ReqId> reload:<Reload> stat1:<SubCommand> stat2:<Stat2> string:<AddText> list:<ItemCnt>

Description of the function for which the message is created. e.g.: Server received system data.; Client send watchdog; etc.

ClientRechner: Source or target depending on direction

CommandTxt: Command as plain text. e.g.: Server_REQ_DateiListe

CommandNum: Numerical identification of the command:

  • 0 = Server_REQ_LifeMsg,
  • 1 = Server_REQ_DateiListe,
  • 2 = Server_REQ_GetDatei,
  • 3 = Client_REQ_UpdateProjekt,
  • 4 = Server_REQ_RedundanzUmschaltung,
  • 5 = NETSRV_ConnectionClosed,
  • Timeout: Timeout in ms

ReqId: Request ID

Reload: 1 if Server is in Reload, otherwise 0

SubCommand: Number of subcommand. Meaning depending on CommandNum

For Command 0 ServerReqLifeMsg:

  • 1 = STAT_CLIENT_ABGEWIESEN,
  • 2 = STAT_CLIENT_ANGENOMMEN
  • 3 = STAT_CLIENT_SERVERCLOSE
  • 4 = STAT_CLIENT_SERVERSWITCH
  • 5 = STAT_CLIENT_SB_ANGENOMMEN
  • 6 = STAT_SB_SERVER_TO_SB
  • 7 = STAT_PEER_ALIVE

For Command 4 redundancy switching:

  • 0 = IdleChangeOfDominance
  • 1 = AdviseChangeOfDominance
  • 2 = ConfirmChangeOfDominance

Stat2: Additional command-specific information. e.g.: With command Server_Req_LifeMsg, subcommand: STAT_CLIENT_ANGENOMMEN, response for a Client logging on to a Server is the project version number in HiWORD.

AddText: Additional text.

ItemCnt: Number of objects in the list.

That is the basic information.

Client send watchdog. Prj:RATED_NET client:ATSZG-WKS053.COPA-DATA.INTERNAL Cmd:Server_REQ_LifeMsg(0) Timeout:30000, ReqId:0 reload:0 stat1:2(STAT_CLIENT_ANGENOMMEN) stat2:1 string: list:0 quantifier:<Quant> role:<RoleTxt>(<RoleNum>)

Message from Server1 to Server2

Quant: Current evaluation.

RoleTxt: Current role as text

RoleNum: Current role as number

Server received system data. Prj:RATED_NET client:WKS053-W7X64 Cmd:Server_REQ_LifeMsg(0) Timeout:30000, ReqId:0 reload:0 stat1:2(STAT_CLIENT_ANGENOMMEN) stat2:1 string: list:0 expSrv1role:<ExpRoleTxt>(<ExpRoleNum>)

ExpRoleTxt: Role expected by Server2 for Server 1 as text.

ExpRoleNum: Expected role as number

Manual role switch for project %s denied.

WARNINGS

Manual redundancy switching cannot be carried out because a regrading is already active.

Current evaluated server1 role: %s(%i) Performing manual role switch.

DEBUG

A manual redundancy switch is carried out. Server 1 must switch its role according to the message.

Unknown standby logon! Project:<PrjName> new client <Pc>!

ERROR

Message is logged if a Client logs on as a Standby Server, but the Client name does not correspond to that of Server 1 or Server 2. The identification is carried out through the host name.

PrjName: Project that logs on to the Standby Server.

PC: Name with which the Standby Server logs on.

Unknown standby logon! Project:<PrjName> new client <Pc>!

ERROR

Message is logged if a Client logs on as a Standby Server, but the Client name does not correspond to that of Server 1 or Server 2. The identification is carried out through the host name.

PrjName: Project that logs on to the Standby Server.

PC: Name with which the Standby Server logs on.


Configuration of seamless redundancy

Manual -> Network -> Redundancy -> Types of redundancy -> Configuration of seamless redundancy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For the configuration of seamless redundancy for a zenon project, you only need two simple, conventional computers.

Define, in the project properties:

  1. A computer that is to be the Primary Server for the project
  2. A computer that is to be the Standby Server for the project

Procedure for seamless redundancy

  • One computer is the Primary Server and one computer is the Standby Server for a project.
  • As in a normal Client-Server model, the Primary Server has ownership of all data.
  • The Standby Server acts outwardly to the user like any other computer on the network that has started the project.
  • The Standby Server independently records all historical data such as alarms, events and archives and synchronizes other data (recipes, users, etc.) with the Primary Server.
  • If the Primary Server fails, the Standby Server upgrades itself and takes over its tasks.
    • In order to avoid data loss in the time period between the server failure and the detection of the failure, the standby always buffers all data.
      After a failure of the Primary Server, this buffer is merged with the last data from the server and the new incoming data, so no data can be lost.
  • All Clients connect to the new Primary Server.
  • If the original Primary Server goes online again, a distinction must be made between when redundancy mode is used:

Dominant

  • The original Primary Server goes online again.
    In doing so:
    • It connects to the current Primary Server.
    • It synchronizes all data.
    • It becomes the Primary Server itself again.
  • The original Standby Server becomes the Standby Server again.
  • All Clients connect to the new Primary Server.

Non-dominant

  • The original Primary Server goes online again.
    In doing so:
    • It connects to the current Primary Server.
    • It synchronizes all data.
    • It becomes the Standby Server itself.
  • The current Primary Server remains the Primary Server.
  • All Clients retain the connection to this.

Rated

  • With evaluated redundancy mode, the roles of Primary Server and Standby Server are given on the basis of an evaluation matrix.
  • Both computers each carry out an evaluation calculation on the basis of configured evaluation criteria.
    The current Primary Server is then the computer that has the higher evaluation.
  • If both computers have the same evaluation, no exchange of roles is carried out.
  • Alarms and CEL entries are each written by the Primary Server.
  • The Clients each connect to the Primary Server.

info Info

Project changes need only be entered on the Primary Server; the standby server and the connected clients automatically synchronize online data. This ensures that the project status is the same on all computers.

Software redundancy and hardware redundancy

With redundant systems in zenon, a distinction is made between software redundancy and hardware redundancy.

Circular redundancy

zenon circular redundancy is a special form of redundancy that allows seamless redundancy for several projects with a low amount of hardware being used and very simple configuration.

zenon redundancy and zenon Logic redundancy

You can find details on the combination of zenon redundancy and zenon Logic redundancy in the zenon Logic Runtime manual).

info Info

If only one controller is available, which offers only one communication channel, the Stop at the Standby Server option in the general settings of the driver configuration can be activated. The driver is thus stopped at the Standby Server and only started again at the upgrade.


Special setups in the communication between Primary Server and Standby Server

Manual -> Network -> Redundancy -> Special setups in the communication between Primary Server and Standby Server

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Note the rules in the following setup:

  • The Primary Server has failed
  • The Standby Server has taken on its role
  • The original Primary Server is restarted
  • The original Primary Server gets all Runtime files from the current Primary Server (originally the Standby Server)

In exceptional cases, there may be conflicts if:

  1. Changes have only been made to the project of the original Primary Server that has been stopped
  2. It is not clear, due to network problems, which computer is the Primary Server.

1. Project changes with the Primary Server stopped

If, during the time in which Runtime is stopped on the original Primary Server, you make changes to the project and introduce these before synchronizing on this (stopped) computer, these changes are overwritten again as soon as the original Primary Server gets the data from the current Primary Server (the original Standby Server).

To prevent this: Introduce the amended data onto the Primary Server (configured Standby Server) as well, before starting the original (configured) Primary Server.

2. Project changes in redundancy mode and/or the servers used

The following changes are only accepted after the Primary Server has restarted:

  • Change of the Redundancy mode.
  • Changes in the Server 1 properties and/or Server 2 in the Network properties group.

attention Attention

In this case, reloading the project is not sufficient to apply the necessary changes! To accept all changes, restart the Primary Server.

Runtime on the Standby Server does not need to be restarted. Here, it is sufficient if the Standby Server is restarted.

3. Server role not clear due to network problems

In exceptional cases, it may happen that both computers are the Primary Server. The cause of this can be, for example, a loss of network connection due to a switch failure, a disconnected network cable etc. In this case, the communication between the Primary Server, Standby Server and Clients depends on the error screen.

If, with this setup, the error screen is resolved and both servers communicate with each other again (at this time), then the original (configured) server has data sovereignty. That means: The standby server's more recent data could be overwritten.

To prevent this:

  1. Always check the role distribution with the current Primary Server system variable:
    You will see the role that Runtime has and discover duplicate Primary Servers.
  2. End zenon Runtime on the Primary Server that lost the network connection.
  3. Set up the network connection again.
  4. Restart zenon Runtime on this computer.
  5. Runtime then starts the project with the computer as a Standby Server, updates its data and only then switches back to the Primary Server role.

Hint: Monitor the network connection with the Redundancy Management Tool.

attention Attention

PNG graphics files cannot be overwritten if they are currently being displayed in Runtime.

Background: The Runtime protects opened .png files against overwriting.

Solution: Before Remote Transport is instigated, it must be ensured that screens with *.png files:

  • Are not called up in Runtime
  • Are not being used by another program

This also applies for the reloading of amended Runtime files. The Runtime sync in the network does not work for a *.png screen if this is switched on a zenon computer that is involved in the process (standby server, client).


Integrated evaluation methods for redundancy switching

Manual -> Network -> Redundancy -> Integrated evaluation methods for redundancy switching

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the dominant network, the Standby (as the Primary Server) regularly sends a telegram to the (dominant) Server 1, so that this - as soon as it receives a connection - can take on its role again. In an evaluated network, no telegram is sent any more in this case.

If there are two servers, the evaluation decides on the role.

Use of dominant behavior in zenon Logic

  • A driver can delay upgrading to a server on the dominant server. This function is no longer present in an evaluated network with severs that have equal rights.
  • Archives also receive an extra byte per entry on the Standby Server as well as on the Server 2. This ensures that the archives are different and are included in a synchronization.
  • Furthermore, the network topology for the drivers uses the terms Dominant and Standby as well as the roles as Server or Standby. However only the role is evaluated, so no change is therefore necessary.
  • zenon Logic is supplied with information on the label and role via CStratonVM::UpdatePrjSTates. The only thing that is evaluated is whether a computer is configured as a Standby and not the Primary Server. in this case, zenon Logic is also not active.


zenon circular redundancy

Manual -> Network -> Redundancy -> zenon circular redundancy

zenon circular redundancy allows seamless redundancy for several projects with a low amount of hardware being used.

Two computers are normally required for each redundant project: one computer as the Primary Server and one computer as the Standby Server. 3 projects would thus require 6 computers. Just three computers are sufficient for implementing three projects with zenon circular redundancy. Another computer is added for each further project. For this, zenon combines multi-project administration with seamless redundancy.

Concept of circular redundancy

Circular redundancy uses the possibility of multi-project administration. Several projects can run simultaneously on one computer. Each computer is the Primary Server for a project and the Standby Server for a second "neighboring project" and can also be the Client for further projects. This results in a circle. Instead of four computers, for example, and licenses for two projects, six for three or eight for four, you only need half of that.

Topology with three projects

  • Computer 1 is the Primary Server for Project A and Standby Server for Project B.
  • Computer 2 is the Primary Server for Project B and Standby Server for Project C.
  • Computer 3 is the Primary Server for Project C and Standby Server for Project A.

    The circle is closed!

  • Each computer can be a Client for the other projects at the same time.
  • Expense: 3 computers and 3 Runtime licenses

info Info

An integration project is needed to start more than one project on a computer.

Normally you would need six computers and six Runtime licenses in this example. zenon circular redundancy is of course not limited to three projects, but can connect as many projects as desired in a circle. The fact that the computers can also be clients for other projects allows easy implementation of a low-cost, fail-safe, highly-available production line.

Time synchronization for zenon circular redundancy

If zenon time synchronization is active, the Standby Server and clients always receive the current time from the Primary Server. This makes no sense when using zenon circular redundancy, because the individual PCs are Primary Server and Standby Server at the same time. Computer 1 for example, would thus obtain the time from computer 2, computer 2 would obtain it from computer 3 etc.

Recommendation: In this case, deactivate the zenon time synchronization and carry out external time synchronization. You can find instructions for this in Time synchronization in the network.


Redundancy Management Tool

Manual -> Network -> Redundancy Management Tool

The Redundancy Management Tool monitors the network adapter and its connection to the network. If the device loses the connection to the network - e.g. by removing the network cable, the Redundancy Management Tool stops the Runtime. This process can be canceled by the operator within a configurable period of time. If the connection to the network is reestablished, the Redundancy Management Tool restarts the Runtime.

Start and configuration

The Redundancy Management Tool can be configured via a dialog or via command line.

To open the dialog, there a three possible ways:

  • From the Windows start folder: Start -> All programs -> COPA-DATA -> Tools 7.20 -> Redundancy Management Tool
  • Via the Startup Tool: Tools -> zenon_redman
  • Direct start of the file zenon_redman.exe from the zenon program folder

After the start the Redundancy Management Tool is also displayed as symbol in the right area of the Windows task bar. Double click on the symbol to open the configuration dialog:

Parameters

Description

Status

Status of the network adapter.

Network adapter connection state

Information about the status:

  • Connected: Connection to the network established.
  • Disconnected: Connection to the network interrupted.

Runtime state

Status of the zenon Runtime

  • Running: Runtime is running.
  • Stopped by Redundancy Management Tool: Runtime was closed by the tool.
  • Stopped: Runtime is not running.

Settings

Settings.

Monitored network adapter

Selection of the network adapter which should be monitored from the drop-down list. List displays all found adapters in the device.

Runtime shutdown delay

Setting of the delay time in seconds before the Runtime is closed. In this period of time the operator can cancel the closing of the Runtime.

  • Maximum value: 2147483647 s.
    Values above this are interpreted as 0.

Apply

Applies the settings, writes values in the INI file and closes the dialog.

INI file

At the configuration via the dialog, file RedMan.ini is created in path %ProgramData%\COPA-DATA\System. It contains the following entries.

Parameters | Description
[DEFAULT] |
ADAPTER= | Selected LAN connection.
DELAY= | Value for delay time.

Command line

The Redundancy Management Tool can also be started via the command line.

Possible parameters:

  • ADAPTER=‘Name‘: Defines the network adapter which should be monitored.
  • DELAY=‘Seconds‘: Defines the waiting time after a connection loss.
    Maximum value: 2147483647. Values above this are interpreted as 0.
  • HELP,?: Displays help about the command line parameters

info Information

At the configuration via command line:

  • these settings are taken over directly
  • the configuration is deactivated in the dialog
  • no INI file is written

In the Runtime

During the Runtime the Redundancy Management Tool monitors continuously the network connection. If the connection is interrupted, the Redundancy Management Tool displays a warning and closes the Runtime after the configured delay time.

As soon as the connection is available again, the Redundancy Management Tool restarts the Runtime.

Click on button Cancel to halt the countdown and prevent the closing of the Runtime. If the connection is reestablished, the dialog is displayed again when the connection fails again. The user can cancel again or let the tool close the Runtime.

The current status of the connection and the Runtime is also always displayed in the configuration dialog.

Error treatment

Error message

Error are displayed by pop-up messages.

Message | Meaning
GetAdapterAddresses not supported on this patform! Error code '%u'! | Operating system version is not supported
GetAdapterAddresses did not return information about network adapters. Error code '%u'! | No network adapter found.

Log files of the Diagnosis Viewer

In the log file of the Diagnosis Viewer the following is documented:

Entry | Debug Level | Meaning
Network link '%s' down for '%u' seconds. zenon Runtime will be terminated. | Error | Network connection failed: The Runtime is closed.
Network link '%s' is up. Restarting zenon Runtime now. | Information | Network connection available again: The Runtime is restarted


Routing

Manual -> Network -> Routing

For routing, the packets of subordinate projects are sent to the first client project (FCP) in the branch. The computer acts as node computer and can route packets. Thereby all network packets from the outside use this computer. This setting can lead to bottlenecks and influences the possible network topology. It is only worthwhile using it in special network setups, e.g. for WAN networks or routed networks.

  • Example:
    If, in a setup consisting of several computers, not all computers can reach the others, a computer can act as a router.
  • Technical implementation:
    The Server 1 and the Server 2 of the subordinate projects are amended on that of the FCP; this is the Server 1/Server 2 active in runtime.

General notes on routing

Basic rules

Two basic rules must be noted when configuring network structures with routing. If one of these rules is not adhered to, communication problems or other undesired effects may occur depending on the respective structure.

  • Rule 1: Server and levels
    A PC that acts as a server may only in one level (circular redundancy) act as a server or Standby several times. It must not be defined as a server a level above or below.
  • Rule 2: Standalone

    If the start project is a single-user project, only one single level below can be used for network projects.

Client sends to a server

  • The client sends the packet to the server active in the project in Runtime.
  • If the project on this computer is not the server, the packet is sent until it arrives at the server.
  • This functionality is not affected by an integration project.

Server sends to a client with routing

  1. If the server has a direct client connection to the client, the packet is sent there.
  2. If there is no client connection to the target computer, the server sends the packet to all computers on which the project is running for which it acts as a server.
  3. If the node has a direct client connection to the client, the packet is sent there.
  4. If the computer works as a node, then the packet is sent to all computers which have connected to the node computer. It the target computer is also the source computer, the packet is not sent any further.
  5. The procedure is continued at point 3.

Note: Points 2 and 4 are only carried out if routing is active on these computers.

info Information

The Server and Standby need not correspond to what has been configured on the client computers, otherwise they may change themselves depending on the topology of the respective computer.

What is a client connection?

A network service connection is labeled as a client connection if it is made to the server or standby handling the process by a client. This is recognizable in that there is a connection to port 1100 on the target computer.

attention Attention

It is not guaranteed that that a pure client computer added to a functional, defined topology will work. It is possible that some projects cannot be reached by the server due to routing on client computers in particular.

Rules for routing before zenon version 6.50:

  1. The first client network project of a branch on a PC defines the server and standby for all subordinate projects in the branch. This also applies
    • If a subordinate project on this PC server or standby were
    • for projects that do not really have a Standby Server
  2. If the subordinate project is not a network project or is not a server, the branches of the subprojects of the start project are considered in parallel. Different computers can therefore be servers for the subprojects. The rules from item 1 apply for the branches.
  3. Single user projects are not taken into account for the topology, with the exception of the start project.
  4. If the start project is not a server (i.e. single user, client or standby not handling the process), routing is not activated in the network service. This only affects the direction from the server to the client.

Rules for routing from zenon version 6.50:

The Routing active property is deactivated as standard from version 6.50 onwards.

Without routing

If the Routing active property is not active for the start project on the computer, routing does not take place. Each project then connects directly to the corresponding computer, where it is the server. The computer is then not a node and packets are also not routed from here.

With routing

The rules as they were prior to 6.50 remain valid.

Exception:

  • A project that is a server or standby on the computer remains a server or standby, even if the superordinate project uses another server or standby.

Checking the routing

To check the routing settings, use the procedure from "Administering network topology".


Authorization in the network

Manual -> Network -> Authorization in the network

A network project can be operated from all stations in the same way with the basic settings.

Operating here means actively intervening in the process, such as:

  • Send values
  • Write recipes
  • Acknowledge alarms
  • etc.

There is thus the danger that two users on two different stations want to set different values for the same variable at the same time.

In this case:

  • Both actions are executed
  • The values that is entered last overwrites all previous ones

In zenon you have the possibility to allow operation of the project only from one station at the time. In this case the operator has to get the authorization, before he can operate the project. Opening screens, as well as read access to lists such as AML, CEL, recipes, etc. is possible on each station as always.

info Information

Operating authorizations for projects without a network can be implemented by evaluating a binary variable for the project property Operation lock. For details, see the Operating authorizations chapter in the Project administration and workspace manual.

Procedure

The following is applicable if the Authorization in network active property is active:

  • Authorization must be obtained if active operation takes place.
  • If operation is blocked by another computer, a dialog is opened on the compute that is blocking it.
  • The user who is locking it can approve the authorization or keep it locked.
  • If there is no response, the authorization is approved after a pre-set time-out.
  • If an interruption in the network connection is recognized, then the authorization for this computer is reset.

For details see chapter:

  • Configuring authorization
  • Authorization in Runtime

System variables for authorization

The system variables inform you about authorization:

  • Computer with authorization: Name of the computer that has the authorization (string)
  • Authorization present for this computer: Computer has authorization (Bool)
  • Authorization not granted: Computer requests authorization, but does not receive it (Bool)

For details, see the Network messages from the system driver chapter.


Configuring authorization

Manual -> Network -> Authorization in the network -> Configuring authorization

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To enable authorization in the network, you must:

  • Activating authorizations and setting time-outs
  • Configuring functions for getting and approving operating authorizations in Runtime

Activating authorizations

The operating authorization in the network must be activated in the project properties.

  • navigate to the Network group in Project Properties.
  • Activate the Authorization in network active property.
  • Define the Timeout for request [s]:

    Defines the period of time in which a computer can respond to an approval request. The authorization is automatically approved after this time has expired.

    Default: 60 seconds

  • Define the Timeout for authorization [s]:

    Defines the period of time in which a computer that has authorization must report to the Primary Server. The authorization is automatically approved after this time has expired. Connection interruptions in the network are therefore recognized. The authorization can therefore not be blocked by a compute that cannot be contacted.

    Default: 60 seconds.

    Attention: Select the time period as shorter than the network timeout.

Functions for authorization in Runtime

To obtain authorizations or to approve these, the corresponding functions must be available in Runtime. To do this, create two buttons that are designated for the corresponding functions:

  • Get authorization: Obtains authorization from the user's own computer
  • Approve authorization: Approve authorization or explicit request

Get authorization

  1. Create a new function.
  2. Select the Authorization in network function in the Network group.
  3. The selection dialog for authorizations in the network is opened.

  4. Select Get.

If this function is executed in Runtime, the authorization can be obtained from the user's own station.

Approve authorization

  1. Create a new function.
  2. Select the Authorization in network function in the Network group.
  3. The selection dialog for authorizations in the network is opened.
  4. Select Approve.

If this function is executed in Runtime, the authorization can be approved again.


Authorization in Runtime

Manual -> Network -> Authorization in the network -> Authorization in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If the Authorization in network active property is active, active operations are only executed in Runtime if there is operating authorization for the station.

Example

If there is no operating authorization, a set value should be written to a variable:

  1. The set value is not sent to the hardware when the button is clicked on.
  2. Instead, a message box opens informing you that you do not have the authorization for this project.
  3. Click on the button Obtain the operating authorization.

Does not block authorization for any other computer:

If the operation is freely available:

  • You receive the authorization
  • You can write the set value
  • You can, after the operation, make this available to others using the Approve authorization function

Blocks authorization for another computer:

If authorization is blocked:

  • A dialog is opened on the computer that is blocking
  • The user of the computer that is blocking must explicitly release the authorization
    • Yes: The authorization is passed over to the other computer
    • No: Authorization remains blocked
    • No reaction: Countdown corresponding to the time-out time defined in the Timeout for authorization [s] property runs out. The authorization is automatically released at 00:00.


zenon functions in the network

Manual -> Network -> zenon functions in the network

Special zenon functions for the network:

  • Authorization in network
  • Redundancy switch
    1. in redundancy mode: Dominant
    2. in redundancy mode: Non-dominant
    3. in redundancy mode: Rated

In general, the location of execution must be noted when using functions in the network. For some functions, the location of execution can be freely configured; this is fixed for others.


Authorization in network

Manual -> Network -> zenon functions in the network -> Authorization in network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To obtain authorizations or to approve these, the corresponding functions must be available in Runtime. To do this, create two buttons that are designated for the corresponding functions:

  • Get authorization: Obtains authorization from the user's own computer
  • Approve authorization: Approve authorization or explicit request

Get authorization

  1. Create a new function.
  2. Select the Authorization in network function in the Network group.
  3. The selection dialog for authorizations in the network is opened.

  4. Select Get.

If this function is executed in Runtime, the authorization can be obtained from the user's own station.

Approve authorization

  1. Create a new function.
  2. Select the Authorization in network function in the Network group.
  3. The selection dialog for authorizations in the network is opened.
  4. Select Approve.

If this function is executed in Runtime, the authorization can be approved again.


Redundancy switching in the dominant network

Manual -> Network -> zenon functions in the network -> Redundancy switching in the dominant network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function, switching between the Primary Server and Standby Server is possible. The current Primary Server thus becomes the Standby Server and vice versa. The change is permanent until:

  • The function is executed again

    or

  • Runtime files from the Editor are reloaded

info Info

This function is not suitable for testing redundancy, as the behavior differs from that of a server failure.

To configure the function:

  1. Create a new function.
  2. Select, in the Network group, the Redundancy switching function.

    (further configuration is not necessary for the dominant network mode.)

  3. Link the function to a button.


Redundancy switching in a non-dominant network

Manual -> Network -> zenon functions in the network -> Redundancy switching in a non-dominant network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function, switching between the Primary Server and Standby Server is possible. The current Primary Server thus becomes the Standby Server and vice versa. The change is permanent until:

  • The function is executed again

    or

  • Runtime files from the Editor are reloaded

info Info

This function is not suitable for testing redundancy, as the behavior differs from that of a server failure.

To configure the function:

  1. Create a new function.
  2. Select, in the Network group, the Redundancy switching function.
  3. Select the switching direction
  4. Link the function to a button.

Scenarios of this being used in practice are, for example: Maintenance work on the Primary Server, improved hardware connection to the Standby Server, etc.

info Information

The redundancy switching function is not available if the network has been activated.


Redundancy switching in an evaluated network

Manual -> Network -> zenon functions in the network -> Redundancy switching in an evaluated network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For the Redundancy switching function in an evaluated network, the switching direction is also configured in the Redundancy switching dialog.

Parameters

Description

Switching direction

Toggle

Primary Server and Standby Server switch roles.

Server 1

Server 1 becomes (or remains) Primary Server.

Server 2

Server 2 becomes (or remains) Primary Server.

Without (reactivation of the assessment)

No switching takes place.
Instead, a possible switching for the suppression time configured in the properties field is prevented for the configured duration.
If the suppression time is 0, the switching is carried out immediately.

Note: This option is only available in an evaluated network.

Suppression time

The time in minutes, within which no automatic redundancy switching takes place due to an amended evaluation.
If the value is 0, the automatic switching is carried out as configured in the evaluation principles.

Range of values: 0 to 10080 minutes (= one week)

In conjunction with an activated server, this means that the selected server (Server 1 or Server 2) remains the Primary Server during this time, regardless of the current evaluation result.

If Dead time after switching [s] and the suppression time are configured differently in an evaluated network, the greater value prevails here.

Note: This option is only available in an evaluated network.

Navigation

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.

To configure the function:

  1. Create a new function.
  2. Select, in the Network group, the Redundancy switching function.
  3. Select the switching direction in the Redundancy switching dialog.
  4. Enter the suppression time (optional).
  5. Link the function to a button.

Hint Hint

Configure a separate redundancy switching function for each switching direction.

attention Attention

After Server 1 has failed and been restarted immediately, the time configured in the Switching delay [s] property at least must expire before redundancy switching can be executed.
If the redundancy switching is executed before expiry of the Switching delay [s], two Primary Servers are active before the expiry of the delay time.


Behavior of zenon modules in the network

Manual -> Network -> Behavior of zenon modules in the network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With network projects, the behavior of individual modules and functions in the network should be noted.


AML and CEL

Manual -> Network -> Behavior of zenon modules in the network -> AML and CEL

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Alarming

The alarming is administered on the Primary Server. The Primary Server answers requests for alarming from the clients. Changes are synchronized between the Primary Server and Standby Server.

Chronological Event List

The CEL is administered on the respective Primary Server. Changes are synchronized between the Primary Server and the Standby Standby Server.

In an evaluated network, no CEL entries are created for regrading due to the evaluation.

Hint Hint

In order to log the evaluations in the CEL, create a system driver variable "Evaluation Result Server 1" or "Evaluation result Server 2":

  • Select, in the workspace, in the Variables node, the New variable... entry
  • Select SYSDRV - driver for system variables as a driver.
  • In the Variables of the system driver dialog, select the Network entry in the Theme entry.
  • Select Evaluation Result Server 1 and Evaluation Result Server 2 and add these to those to be created by clicking on the Add button.


Historian

Manual -> Network -> Behavior of zenon modules in the network -> Historian

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Archiving is carried out on the Primary Server.

The Primary Server synchronizes the archive data with the Standby Server and responds to requests from the Clients (such as calling up an Extended Trend screen).


Batch Control

Manual -> Network -> Behavior of zenon modules in the network -> Batch Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The module Batch Control is fully capable of using a network in terms of Client/Server technology. This means that Batch recipes can be created, duplicated, edited, deleted, etc. on a Client. The whole recipe management remains always on the server. Likewise the whole process control such as start recipe, pause recipe, stop recipe, etc. can be done from the Client. Also mode changes and manual operations such as jump are possible.

attention Attention

Module Batch Control does not support redundancy. There is no synchronization between Standby Server. When the Server breaks down, the executed Batch recipes are not continued seamlessly on the Standby!

For using Batch Control in a network the following is true:

Allocation

  • The forcing of allocations can be carried out be Server and Client.

Functions

Functions are always carried out at the Server.

Phases

  • Editing phases in the master recipe:
    • Edit mode: Changes a done locally at the Client.
      If during the editing the recipe is saved on another computer in the network, the current configuration is lost. An appropriate message is displayed and the editing dialog is closed. The new data from the server are displayed.
    • Test mode: Changes a done at the Server.
  • Control recipe: Changes a done at the Server.
  • If a recipe is saved in the network, all Clients using this recipe are updated.
  • If a recipe is opened on a client, the current version on the server is always displayed, even if it has not yet been saved there.
  • If a recipe is deleted on a computer, a message is displayed on all computer on which the recipe is opened that the recipe has been deleted.

Mode

  • The mode (automatic, semi-automatic, manual) can be switched by the server and the client.
  • Jumps in the recipe and step-by-step progress of a recipe can be done from Server and Client.

Recipes

  • Recipes can be started and controlled by the zenon server and by zenon clients.
  • If parameters in a recipe are changed whilst the recipe is saved on a different zenon client, the change to the parameters is refused and not carried out.
  • A master recipe can be changed on the zenon client whilst it switches to test mode on the zenon server and is sent to the zenon client. The changes that were last saved are transferred. This means: If the zenon client saves last, the recipe is switched to editing mode again. If the zenon server saves last, the change to the zenon clients is discarded and the recipe is in test mode.
  • If a communication error occurs when deleting a recipe or an operation template, the deletion is refused with an error message.

Web Client

With a standard web client:

  • The settings for grid and color can be changed
  • No recipes can be created or edited
  • The size of the editing area cannot be changed
  • In the tool bar, all symbols that are not permitted are deactivated; it is not possible to select the corresponding objects.

Web client PRO is not affected by these restrictions.


User administration

Manual -> Network -> Behavior of zenon modules in the network -> User administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

User administration is administered on the Primary Server. Log-in procedure:

  1. The login request is sent to the Primary Server.
  2. It answers with the list of authorized users.
  3. The client verifies the data.

If changes to user administration are made on a client in Runtime, the complete user list is sent from the client to the Primary Server.

info Info

Active Directory, ADAM, ADLDS users

If Active Directory, ADAM or ADLDS users are used, all computers (regardless of whether they are the Primary Server, Standby Server or Client) communicate directly with the Active Directory, ADAM or ADLDS server.

This means that all computers must be in the corresponding infrastructure (such as Active Directory domains when Active Directory users are used); it is not sufficient that only the Primary Server is in the Active Directory domains with the corresponding users.


Files

Manual -> Network -> Behavior of zenon modules in the network -> Files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Lists for the files of all modules are created when data is exchanged between the Primary Server and the Standby Server. The Primary Server monitors these lists for changes. Changes that are detected are transferred to the Standby Server.

attention Attention

The Primary Server does not react to watchdogs that are sent by the Standby Server when lists are created. Note this when stipulating the time for the network timeout.

With Remote Transport, all files required for the project are transferred to the target system.

In doing so, all files are always transferred to the folder:

  • Standard

    All files that are in the project's Runtime folder (...\RT\FILES\zenon\system\).
    These files determine the appearance and behavior of the project and are transferred as standard:

info Info

Files with the following suffixes are not transferred by default:

  • .hot
  • .ho
  • .ret
  • .re
  • Optional

    In addition, all files that are embedded into the project must be transferred. They are selected using the Active checkbox of the Remote Transport settings. These files are in the following subfolders of the project directory:

    • \zenon\custom\graphics: for graphics
    • \zenon\custom\lists: for language tables
    • \zenon\custom\media: for all media files
    • \zenon\custom\reports: for the reports of the Report Generator
    • \zenon\custom\help: for help files
    • \zenon\custom\additional: for additional files
    • \zenon\custom\additional: for Report Viewer files
    • \zenon\custom\drivers:for drivers
    • \straton: for zenon Logic

    Recommendation: Project basis path, graphics, language tables, report tables and media files are always transferred.
    The following are transferred from the basis path by default: The files project.ini, Projekt.vba, Monitor.mon and the Projekt folder.

    As a default zenon always uses relative paths and not absolute paths, so that the files can easily be found on the target system.

    For the files that can be transferred optionally, the original paths should be used (empty field under target), so that zenon can find them on the target system.

Global project

attention Attention

If the time difference between the server and the client is more than 5 seconds, no more files are synchronized.


Extended Trend

Manual -> Network -> Behavior of zenon modules in the network -> Extended Trend

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Extended Trend shows information from archives and online data. This data is saved in the Primary Server and requested by the Primary Server if required (if a trend screen is called up on the client).


Functions

Manual -> Network -> Behavior of zenon modules in the network -> Functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For functions that are used in the network:

  • The place of execution can be freely configured in some cases
  • The place of execution is stipulated in some cases

info Information

Scripts combine several functions. The place of execution then depends on the settings of the Execute script function. This setting overwrites the settings of the individual functions.

Configure place of execution

For functions where the place of execution can be freely configured, the corresponding parameters are available in the properties of the function.

To define the place of execution:

  1. navigate to the Execution group in the Properties.
  2. Select the desired place of execution by checking the checkbox. Multiple selection is possible:
    • Current computer: Function will be executed on the current computer.
    • Primary Server: Function will be executed on the Primary Server.
    • Standby Server: Function will be executed on the Standby Server.
    • Client: Function will be executed on all clients.

Overview of functions in the network

The following table shows which functions are executed and where they are executed.

Key:

  • Adjustable: Behavior can be configured

    +: Yes

    -: No

    O: Default

  • If not adjustable, O identifies the place of execution:
    • Active computer
    • Primary Server
    • Standby Server
    • Client

Function | Adjustable | Current computer | Primary Server | Standby Server | Client
AML and CEL |  |  |  |  |
Alarms: acknowledge flashing | - | O |  |  |
Alarms: delete | - |  | O | O |
Acknowledge alarms | - |  | O | O |
Alarm/event group log in/log off | - | O |  |  |
Activate/deactivate alarm message list / alarm/event groups / alarm/event classes | - |  | O | O |
Alarm Message List active | - |  | O |  |
Alarm Message List active/inactive | - |  | O |  |
Alarm message list inactive | - |  | O |  |
Export AML | + | O |  |  |
Save AML and CEL memory buffer | - |  | O | O |
Export CEL | + | O |  |  |
Print AML or CEL | + | O |  |  |
Create/print IPA document | - |  | O |  |
Switch online printing on/off | - |  | O | O |
Online printing start new page | + | O |  |  |
Switch online printer | - |  | O |  |
Application |  |  |  |  |
Select printer | + | O |  |  |
Start Load Management | - |  | O |  |
Stop Load Management | - |  | O |  |
Print Extended Trend diagram | + | O |  |  |
Switch palette | + | O |  |  |
Functions active at limit | - |  | O | O |
Functions active/inactive at limit | - |  | O | O |
Functions inactive at limit | - |  | O | O |
Open Help | + | O |  |  |
Reload project online | + | O |  |  |
Determine open maintenances | - |  | O |  |
PFS - execute user-defined event | + | O |  |  |
Activate/deactivate project simulation | - | O |  |  |
Simulate right click | + | O |  |  |
Save remanent data | + | O |  |  |
Exit Runtime | + | O |  |  |
Analyze S7 Graph heuristics | + | O |  |  |
Execute SAP function | + | O |  |  |
Language switch | + | O |  |  |
Topology - Search for ground fault | - |  | O |  |
Topology - LoadShedding | - |  | O |  |
Historian |  |  |  |  |
Archive: Stop | - |  | O | O |
Index archive | - |  | O |  |
Archive: Start | - |  | O | O |
Export archives | - | O |  |  |
Display open archives | - |  | O | O |
User administration |  |  |  |  |
Change user | + | O |  |  |
Login with dialog | + | O |  |  |
Login without password | + | O |  |  |
Logout | + | O |  |  |
Change password | - | O |  |  |
Screens |  |  |  |  |
Change ALC source color | + | O |  |  |
Indexed screen | - | O |  |  |
Close screen | + | O |  |  |
Screen: Return to last | - | O |  |  |
Screen: Move center | + | O |  |  |
Screen switch | + | O |  |  |
Activate input to the element with the focus | + | O |  |  |
Set focus to frame | + | O |  |  |
Move focus | - | O |  |  |
Take focus away from frame | + | O |  |  |
Show menu | + | O |  |  |
Monitor assign | + | O |  |  |
Runtime profiles | + | O |  |  |
Close frame | + | O |  |  |
Setpoint input for keyboard screen | - | O |  |  |
Displaying the overview window | + | O |  |  |
Fault locating in electric grids |  |  |  |  |
Acknowledge ground fault message | + | O |  |  |
Stop search for ground fault | + | O |  |  |
Start search for ground fault | + | O |  |  |
Acknowledge short-circuit message | + | O |  |  |
Message Control |  |  |  |  |
Save current queue | - |  | O |
Suppress groups/classes/areas/equipment | - |  | O |  |
Send a Message | - |  | O |  |
Send Message: activate | - |  | O |  |
Send Message: deactivate | - |  | O |  |
Network |  |  |  |  |
Authorization in network | + | O |  |  |
Redundancy switch | - |  |  | O |
Report Generator |  |  |  |  |
Print report | + |  |  |  |
Report: execute | + |  |  |  |
Export Report | + |  |  |  |
Recipes |  |  |  |  |
Recipegroup Manager | - | O |  |  |
Standard recipe | - | O |  |  |
Standard recipe single directly | + | O |  |  |
Standard recipe single with dialog | - | O |  |  |
Standard recipe single with online dialog | - | O |  |  |
Script |  |  |  |  |
Script: execute | + | O |  |  |
Script: select online | + | O |  |  |
Variable |  |  |  |  |
Export data | - |  | O |  |
Read dBase file | + | O |  |  |
Print current values | + | O |  |  |
Unit conversion | + | O |  |  |
HD administration active | - |  | O | O |
HD administration inactive | - |  | O | O |
HD administration inactive/active | - |  | O | O |
Write set value | - |  | O |  |
Driver commands | - | O |  |  |
Transfer driver simulation image to the standby | - |  |  | O |
Write time to variable | + | O |  |  |
Read time from variable | + | O |  |  |
VBA |  |  |  |  |
Open PCE editor | - |  | O |  |
Open VBA Editor | + | O |  |  |
Execute VBA macro | + | O |  |  |
Show VBA macro dialog | + | O |  |  |
VSTA |  |  |  |  |
Open VSTA editor | + | O |  |  |
Execute VSTA macro | + | O |  |  |
Show VSTA macro dialog | + | O |  |  |
Windows |  |  |  |  |
Play audio file | + | O |  |  |
File operations | + | O |  |  |
Start continuous tone | + | O |  |  |
Stop continuous tone | + | O |  |  |
Window to the background | - | O |  |  |
Window to foreground | - | O |  |  |
Print screenshot | + | O |  |  |
Start program | + | O |  |  |


Message Control

Manual -> Network -> Behavior of zenon modules in the network -> Message Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Message Control will be executed on the Primary Server.

The Primary Server synchronizes with the Standby Server.


Programming interfaces

Manual -> Network -> Behavior of zenon modules in the network -> Programming interfaces

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

VBA and VSTA

Code in VBA or VSTA is always, by default, executed locally on the system on which it is started or where events occur.

The place of execution can however be defined otherwise when this is called up via the function.

PCE

PCE is always executed on the server in the network. On standalone computers in standalone projects.


Cross reference list

Manual -> Network -> Behavior of zenon modules in the network -> Cross reference list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The use of variables in evaluated networks is also taken into account. The property name of the place of usage is stated as the element name. This is either "event variable" or "evaluations".

You can find out further information in the cross-reference list manual.


Report Generator & Report Viewer

Manual -> Network -> Behavior of zenon modules in the network -> Report Generator & Report Viewer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The *.xrs files of the Report Generator and the *.rdl files of the Report Viewer are synchronized on all systems in the network (Clients, Standby Server, Primary Server).

Editor

If the file is modified in the zenon Editor, transferred to the Primary Server and reloaded, it is automatically distributed to the other computers in the network.

Runtime

If the file is amended in Runtime, the changes are only saved on a temporary basis and replaced the next time a reload takes place or when Runtime is restarted.


Recipes

Manual -> Network -> Behavior of zenon modules in the network -> Recipes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The execution of recipes is different for standard recipes and the RGM.

Standard Recipes

Standard recipes are managed on the Primary Server and on the Standby Server.

If a standard recipe is changed by a user in Runtime, the client requests the full recipe list from the Primary Server. In the event of changes, the recipe list is sent back to the Primary Server.

info Information

This list is not identical to the file rezepturen.cmp

If a recipe is changed and executed in Runtime on the client, it is executed with the new values. When the standard recipe, you are given the option to save the changes.

Recipegroup Manager

When the Recipegroup Manager screen is loaded on the client, a list of all recipe names is requested by the Primary Server. As soon as a recipe is selected, it is loaded by the Primary Server.


Scripts

Manual -> Network -> Behavior of zenon modules in the network -> Scripts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Scripts combine several functions. The place of execution depends on the settings of the Execute script function. This setting overwrites the settings of the individual functions.

The execution of scripts in the network is controlled with predefined scripts:

Script | Description | Place of execution
AUTOSTART | The script is executed automatically when Runtime starts before the start screen is loaded if the project is the Runtime start project. It is not executed when subordinate projects are started. | Network project: Primary Server Single-user project: Active computer
AUTOEND | The script is executed automatically when Runtime is ended if the project is the Runtime start project. It is not executed when subordinate projects are ended. | Network project: Primary Server Single-user project: Active computer
AUTOSTART_CLIENT | The script is executed automatically on a client when Runtime starts before the start screen is loaded if the project is the Runtime start project. It is not executed when subordinate projects are started. | Client
AUTOEND_CLIENT | The script is executed automatically on a client when Runtime is ended if the project is the Runtime start project. It is not executed when subordinate projects are ended. | Client
AUTOSTART_SRVPRJ | Script is executed automatically when Runtime is started for any desired project on the Primary Server before the start screen is loaded. | Server
AUTOSTART_SRVPRJ | Script is automatically executed when Runtime of a desired project is ended on the Primary Server. | Server


Driver - Variables - limit values

Manual -> Network -> Behavior of zenon modules in the network -> Driver - Variables - limit values

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the zenon network, the Primary Server normally communicates with the controller via the driver. Requests from the Client are routed via the Primary Server. This gets the information from the controller and forwards it to the Client. Limit values are monitored by the Primary Server.

Driver

Drivers are executed on the Primary Server and Standby Server.

Internal variables

For internal variables, it is possible to define whether each individual variable is calculated locally or in the network in zenon.

To do this:

  1. Navigate to the Internal Variable node in the properties of internal variables

  2. Define the place of execution using the Calculation property:
    1. Local: The internal variable is evaluated and managed locally for network projects, i.e. also on the Standby Server and the Clients. The values are not synchronized with other computers in the network.
    2. Network: With network projects, the internal variable is evaluated and administered on the project's Primary Server. It has the same value on the Primary Server and all Clients.

Note: Not available if the CE terminal serves as a data server. You can find further information in the zenon Operator manual in the CE terminal as a data server chapter.

Limit values and reaction matrices

In principle, limit values and reaction matrices are monitored on the Primary Server (where the AML is also administered).

Furthermore, the following applies for local internal variables:

  • Limit values and reaction matrices are monitored locally on all computers (Primary Server, Standby Server and Clients).
  • Linked limit values are only executed where the limit value of the local internal variable was breached.
  • Limit value breaches of these variables on the Standby Server or Client are not an alarm.


Time control

Manual -> Network -> Behavior of zenon modules in the network -> Time control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Time control will be executed on the Primary Server. The function triggered is executed on the systems that were selected for execution of the function in the settings.


Allocations

Manual -> Network -> Behavior of zenon modules in the network -> Allocations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Allocations are always executed on the Primary Server.

attention Attention

This is relevant to local internal variables most of all. These are not executed on the Standby Server or on Clients!


Network messages from the system driver

Manual -> Network -> Network messages from the system driver

The following system driver variables are available for this subject area:

Name

Data type

Comment

Current Primary Server

STRING

local

Computer name of the current Primary Server
If the name was acquired from the hosts file, it will be the name used there. For DNS, this is the fully qualified domain name.

Note: If the network is deactivated, the variable sends the status INVALID. The Current Standby Server remains empty in contrast.

Current Primary Server

STRING

local

Computer name of the server which is currently not handling processes.
If the name was acquired from the hosts file, this is the name entered there. For DNS, this is the fully qualified domain name.

Number of connected clients

UDINT

Delivers the number of clients currently connected to the server. This number also includes the standby server, if there is one.

Authorization: not granted

BOOL

Shows whether a requested authorization is denied in the network. The value of this variable is changed only for a short time and then changed back to the initial state.

  • 0 = operating authorization request accepted
  • 1 = operating authorization request declined

Authorization: Present here

BOOL

Shows whether there is an authorization for the current project on the local computer.

  • 0 = No
  • 1 = Yes

Authorization: Computer that owns it.

STRING

Shows the name of the computer that has the authorization for the currently loaded project.

Result of evaluation, Server 1

UDINT

In the event of changes to a variable from the evaluation matrix, this value is written to the corresponding system driver variable for Server 1 and Server 2 after calculation of the new result of the evaluation. The values are equal to one another (server <-> standby), so that the current value is always displayed on both sides. However, after the other side has a failure, this value remains for the attendant variable and only updates itself once it reconnects.

Note: You can find further information on evaluation in the Network manual in the Configuration of redundancy evaluation chapter.

Result of evaluation, Server 2

UDINT

In the event of changes to a variable from the evaluation matrix, this value is written to the corresponding system driver variable for Server 1 and Server 2 after calculation of the new result of the evaluation. The values are equal to one another (server <-> standby), so that the current value is always displayed on both sides. However, after the other side has a failure, this value remains for the attendant variable and only updates itself once it reconnects.

Note: You can find further information on evaluation in the Network manual in the Configuration of redundancy evaluation chapter.

Names of connected clients

STRING

Delivers the names of the clients currently connected to the server. The standby server, if there is one, is also included.

Network timeout [ms]

UDINT

Shows the timeout in milliseconds for the zenon network as configured in the project configuration.

Primary Server <-> Standby Server data synchronization

BOOL

A binary variable that takes the value 1 for a short time when the system performs a redundancy switch between server and standby server.

  • 0= No Redundancy switch over
  • 1= Redundancy switch over

Server failure

BOOL

local

Indicates that the connection to the process handling server was lost.
Depending on the network position of the computer, this means:

  • Dominant Server: While it is not yet the process handling server, the value changes to TRUE if the connection to the process handling server is lost. Always FALSE after synchronization.
  • Non-dominant Server: Changes to TRUE if the connection to the dominant server, which was the process handling server, is lost. Changes back to FALSE if the Standby Server was promoted to be the Primary Server.
    EVALUATION: Preferably via a REMA, as the Alarm Management is also swapped and taken over by the SB at that time. The Online Container is also not suitable because the variables are re-initialized during redundancy switching.
  • Client: Changes to TRUE if the connection to the process handling server is lost. Changes back to FALSE if the client connects to the SB computer that is now the process handling server.

Primary Server shut down

BOOL

local

Indicates the regular stop of the process handling server.
The value changes to TRUE if the process handling server was stopped properly. FALSE if there is a process handling server in the net.

Depending on the network position of the computer, this means:

  • • Dominant Server: While it is not yet the process handling server, the value changes to TRUE if the process handling server has stopped.
  • • Non-dominant Server: Changes to TRUE if the dominant server, which was the process handling server, has stopped. Changes back to FALSE if the StandBy was promoted to be the process handling server.
  • EVALUATION: Preferably via a REMA, as the Alarm Management is also swapped and taken over by the SB at that time. The Online Container is also not suitable because the variables are re-initialized during redundancy switching.
  • • Client: Changes to TRUE if the dominant server has stopped. Changes back to FALSE if the client connects to the SB computer that is now the process handling server.
    Is also TRUE while the process handling non-dominant server changes back to be the non-process handling server.

Standalone/Primary Server/Standby Server/Client

DINT

Shows the type of the local computer in the network.

  • -1 = Standalone
  • 0 = Client
  • 1 = Primary Server
  • 2 = Standby Server

Server-Standby in data update

BOOL

A binary variable that takes on the value 1 if the server and the standby server are synchronizing files after a redundancy switch.

0 = no data sync

1 = file sync active

Standby Server failure

BOOL

Changes to TRUE if the connection to the currently non-process handling server is terminated unexpectedly. If there is a connection, the value is FALSE.

Depending on the network position of the computer, this means:

  • Dominant Server: The variable only acts as described from the time when the standby became the server handling the process.
  • Non-dominant Server: If, during file synchronization, the connection to a server that is dominant but is not handling the process is interrupted, the value changes to TRUE. Always FALSE if not the server handling the process.
  • Client: As per server handling the process.

Standby Server shut down

BOOL

Is TRUE on the process handling server, if the non-process handling server was stopped properly and if there is no connection anymore. Changes to FALSE if the non-process handling server has registered at the process handling server.

Depending on the network position of the computer, this means:

  • Dominant Server: Only from the time when the standby became the server handling the process does the variable act as described.
  • Non-dominant Server: If this is ended during file synchronization with a server that is dominant but is not handling the process, the value changes to TRUE. Always FALSE if not the server handling the process.
  • Client: As per server handling the process.

Standby Server started:

BOOL

TRUE if the non-process handling server has registered at the process-handling server and if the data update was performed and the connection between the two computers is active.

Depending on the network position of the computer, this means:

  • Dominant Server: Only from the time when the standby became the server handling the process does the variable act as described.
  • Non-dominant Server: Becomes TRUE if the dominant server not handling the process starts. Changes to FALSE if the computer is the server handling the process.
  • Client: As per server handling the process.

Switch from Primary Server to Standby Server

BOOL

A binary variable that takes on the value 1 if the server becomes the standby server during a redundancy switch.

  • 0= registered server is available as server in the network.
  • 1 = registered server is available as standby server in the network.

Switch from Standby Server to Primary Server

BOOL

A binary variable that takes on the value 1 if the standby server becomes the server during a redundancy switch.

  • 0 = registered Standby Server is available as standby server in the network.
  • 1 = registered Standby Server is available as server in the network.


OPC server

Manual -> OPC server

The OPC server makes the variables of the project available for standard OPC client tools.

The use of the OPC UA Server is recommended for several operations. It is part of the COPA-DATA Process Gateway

tutorial License information

Must be licensed in Editor and Runtime.


Compare OPC Server and OPC UA Server

Manual -> OPC server -> Compare OPC Server and OPC UA Server

The OPC UA server system has superseded the OPC server. Use of an OPC UA server is recommended for most applications.

OPC Server

  • OPC Task Force since 1995
  • Uniform interface for automation systems
  • Based on Microsoft's COM/DCOM technology
  • OPC foundation since 1996
  • several specifications for different applications

OPC UA Server

  • First vision 2003
  • Released in 2006, not yet all parts

Comparison of OPC server to OPC UA server

Parameters | OPC Server | OPC UA Server
Data model | Limited | for all applications
Implementation | Manufacturer-dependent | Manufacturer-independent
Interoperability | no | yes
Configuration | laborious | simple
Network use | Not recommended (security); Windows CE cannot be used | yes
Network technology | DCOM (error-prone, unstable) | OPC UA TCP binary protocol
Performance | low | high
Platforms | Windows only | independent
Redundancy | no | yes
Resource requirements | high | lower
Service-orientated architecture | no | yes
Security | outdated | In accordance with current standards
Connection security | no | provided
Windows CE | no | yes


Technical background

Manual -> OPC server -> Technical background

The concept of OPC ist conceived for the application in the cell and management level. Here the OPC server offers data from the control level

OPC Clients and OPC Server

OPC Server

OPC defines objects, which are described by object interfaces. In the OPC server there are two kinds of object interfaces, which can be addressed by an OPC client:

  • The COM custom interface
  • The OLE automation interface

Object interface of the OPC server

The COM-Interface is used by function pointer orientated languages such as C++. Through the automation interface it is possible to communicate with script languages such as Visual Basic.

OPC object hierarchy

An OPC server consists of three hierarchical gradated objects:

  • The server
  • Groups and
  • Items

An OPC server shows the real objects as items (variables). These items are within the OPC server unique. The client organizes the items in one or more OPC groups.


General OPC Server Information

Manual -> OPC server -> Technical background -> General OPC Server Information

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The OPC server:

  • is an "Out of Process" server.
  • Runs in a single thread apartment (STA)
  • Is registered as COM server MULTIPLEUSE
    That means: The server runs only once as a process instance. Several OPC clients sign into the same server.
  • Currently only works locally


Item Addressing:

Manual -> OPC server -> Technical background -> Item Addressing:

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The OPC server has to be able to distinguish, from which projects the variables come, because serveral projects can be started in the Runtime. So the server uses the following nomenclature for the process variables: Projectname.Variablename

Example Example

Project1.ActualValue

Project1 = name of the project currently running in the Runtime

. (Point) = Separator

Current value = Existing name of variable


Group information

Manual -> OPC server -> Technical background -> Group information

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A group name can be freely defined. For example: Test group 1.

The update cycle in the group is not considered by the OPC Server as the OPC Server has an on-change data connection to the Runtime. Therefore every modification of value will be transmitted to the OPC Server without cyclically requesting the value.

info Information

OPC clients must create an own group for each zenon project.


Supported OPC Specifications:

Manual -> OPC server -> Technical background -> Supported OPC Specifications:

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

OPC Data Access Servers Version 1.0

OPC Data Access Servers Version 2.0

Supported OPC Interfaces:

Interfaces | supported
IOPCServer | Yes
IOPCBrowseServerAddressSpace | Yes
IOPCServerPublicGroups | No
IPersistFile | Yes
IOPCCommon (from 2.0) | Yes
IOPCSyncIO | No
IOPCItemProperties (from 2.0) | Yes
IConnectionPointContainer (from 2.0) | Yes


Installing the OPC Server

Manual -> OPC server -> Installing the OPC Server

As a default the control system OPC Server is installed and registered with the control system. If you did not install the OPC Server in a user-defined installation, you have to install it later. With Control Panel – Software the existing installation can be edited.

To use OPC Servers, you still have to install the OPC core components. You can find them on the installation medium with the additional programs.


Registering the OPC Server

Manual -> OPC server -> Registering the OPC Server

The OPC Server has to be registered correctly. For security reasons, the setup does not register the OPC server by default. After installation, the OPC server can therefore not be discovered by an OPC client. You must first explicitly register the OPC server.

Proceed in the following way:

  1. Install the OPC-DA core components from the OPC Foundation. The setup is in the DVD in the "AdditionalSoftware" directory.
  2. Open the zenon Startup Tool
  3. Select Tools in the right menu bar
  4. Select OPC Server in the list
  5. Enter the desired parameters in the Command line parameters drop-down list
    Possible inputs:
    • zenopcsrv.exe /RegSrv: registers the OPC server; a message is given if this is not successful
    • zenopcsrv.exe /RegSrvD: registers the OPC server and also gives a message if this is successful
    • zenopcsrv.exe /UnregSrv: deregisters the OPC server; a message is given if this is not successful
    • zenopcsrv.exe /UnregSrvD: deregisters the OPC server and also gives a message if this is successful
  6. Click on the Start button

In the event of errors, check that you have sufficient authorizations.


Licensing the OPC Server

Manual -> OPC server -> Licensing the OPC Server

The OPC Server only runs, if it is correctly licenced. Otherwise you get the following error message:

Licencing is done with the standard licencing procedure. On ordering the OPC Server you have to state, on which computer the OPC Server should be installed, and the Runtime serial number you use there. From the licencing office you then get a new serial number and a new activation number for that computer. With these the OPC Server is licensed. These numbers have to be entered in the zenon6.ini with the tool licence order (Start – Programs – COPA-DATA – Licence order).


Settings in zenon

Manual -> OPC server -> Settings in zenon

VBA has to be activated, so that the control system OPC Server can get data from the Runtime. Please check, if the following entries in the zenon6.ini are set correctly:

[VBA]

EVENT=1 Switches on or off the event mechanism for the VBA – COM interface )

Default =0

This setting must be set to EVENT=1.

attention Attention

If the event mechanism in the Runtime is deactivated, the OPC Server can access the variables for writing, but the reading access does not work!
The OPC Server then gets no change events from the Runtime. For the connection quality all OPC Clients will display “disturbed”.

No further settings in zenon are necessary.

The OPC Server reads out the running Runtime and offers all variables of all running projects for the connection.

info Information

As soon as the Runtime is started, you can read out all variables from all projects that are available in the Runtime. This is independent from the fact, if the included projects are standalone, client or server projects.


Browsing of the OPC Server

Manual -> OPC server -> Browsing of the OPC Server

OPC Clients use two different methods to find and to browse the variable information of the OPC Server. Finding the OPC Servers installed on the PC can be done in two ways.

  • Reading out the Registry
  • Browsing with the additional program OPCEnum.exe

The additional program OPCEnum is not distributed. So it can happen that an OPC Client cannot find the control system OPC Server, because it uses this browsing method. Read the documentation of the OPC Client to find out whether the browsing method can be changed to reading out the registry. (For the Matrikon OPC Explorer you find that under Options.) If this is not the case, you must install the program OPCEnum.

Hint: If you install the freely available Matrikon OPC Simulator Server, OPCEnum is also installed.

info Information

When browsing the control system OPC Server offers all variables that exist in the running control system Runtime. So you have to make sure, that the control system Runtime is running, before you start browsing the variables.


Starting/stopping the OPC Server

Manual -> OPC server -> Starting/stopping the OPC Server

The OPC Server is automatically started by the first client that connects to it and it is stopped by the last client that disconnects.


Logging

Manual -> OPC server -> Logging

For monitoring and evaluating the activities of the <CD_PRODUCTNAM> OPC Server the Diagnose Viewer is used.


Asynchronous read request

Manual -> OPC server -> Asynchronous read request

The OPC interface IAsyncIO and the OPC interface IAsyncIO2 support multiple asynchronous read requests.


REMOTE access with DCOM

Manual -> OPC server -> REMOTE access with DCOM

With DCOM technology, it is possible for an OPC client to have read/write access to the zenon OPC Server over the network.

attention Attention

The OPC server is optimized for local use; use in a network is expressly not recommended!
Background: OPC network communication works using DCOM technology from Microsoft, which has proven itself to be prone to errors and unstable. Particular disconnections, such as unplugging a network cable and very long time-out periods are problematic in industrial applications.

Recommended solution:

  • Using an OPC_UA Servers
    or
  • zenon Runtime is installed and works as a client for the desired program on the computer on which the OPC client is running. zenon OPC Server is started for this client. In this way, zenon OPC Server can be connected to the OPC client.

attention Attention

Make sure, that always the user of the OPC Client application logs in at the server. In certain cases, this does not have to be the user registered on the client PC.
This is then the case if the application is started with another user. This happens e.g., if the Runtime (with an OPC Client driver, that connects to the remote OPC Server) is started with the Remote Transport. Then the OPC Client runs in the context of the SYSTEM user and in the context of the logged in user.
In any case, you must enter the correct user on the OPC Server PC in Access authorizations!!


Windows Firewall

Manual -> OPC server -> REMOTE access with DCOM -> Windows Firewall

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Windows firewall blocks all incoming connections. So also the connection attempts of the OPC Client to the OPC Server are blocked. So you have to completely deactivate the firewall or to configure it correctly.

As the correct configuration could not be found, when this tutorial was written, we recommend at the moment to deactivate the Windows firewall completely.


General authorization

Manual -> OPC server -> REMOTE access with DCOM -> General authorization

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The user – in whose context the OPC Client runs – must have administrator rights on the server PC, so that the OPC Client can log in at the OPC Server PC and gets the according rights there to start and configure the OPC Server.

Start the Control panel on the OPC Server and open the entry “User accounts”. With 'Add…' add a new user, with which the OPC Client logs in, and configure this user as an administrator. See example 'user' in the screenshot.

info Information

The best is to use the same Windows user on the OPC Server and on the OPC Client and to add this user to the administrator group.
Attention! It is not sufficient to have local users with the same name on both computers. It has to be the same domain user!


DCOM configuration

Manual -> OPC server -> REMOTE access with DCOM -> DCOM configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You only have to do this on the OPC Server PC. No settings are necessary on the Client PC.


PC wide settings

Manual -> OPC server -> REMOTE access with DCOM -> DCOM configuration -> PC wide settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Start the program DCOMCNFG from the Windows\\System32 directory.

Open the console root and switch to the Component services - Computer - Workspace.

Select the Properties in the context menu of the workspace.

Usually you do not have to make changes in the property pages “General”, “Options”, “Standard protocols” and “MSDTC”.

Open the property page “Standard settings”. Here you have to make sure, that DCOM is activated for this computer. Do not care about the other settings.

The following settings have been tested:

  • Activate COM internet service - not active
  • Standard authentication level - connect
  • Standard identity change level - identify
  • Additional security for allocation logging - not active

On the property page “COM standard security” you will find the settings for the access authorization.

attention Attention

The limit settings for the access authorizations and the start and activation authorizations must be set, otherwise remote access is prevented by the operating system!

The limits to access authorizations and the start and activation authorizations must be edited.


Setting the access authorization

Manual -> OPC server -> REMOTE access with DCOM -> DCOM configuration -> PC wide settings -> Setting the access authorization

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Click on “Edit limits…”. In the dialog you can define the access authorizations. First add the needed users (in our example the Praktikant) and allow the remote access! You also have to allow the remote access for the user “ANONYMOUS-ANMELDUNG” necessarily.

attention Attention

Never remove the user “ANONYMOUS-ANMELDUNG” or prohibit the local access.
With this you would prevent any COM data traffic on your PC!

info Information

Never remove the user “ANONYMOUS-ANMELDUNG” or prohibit the local access.
With this you would prevent any COM data traffic on your PC! You now have to configure the user “ANONYMOUS-ANMELDUNG” correctly. For all other settings the user with which the OPC Client logs in is sufficient.


Setting the start authorization

Manual -> OPC server -> REMOTE access with DCOM -> DCOM configuration -> PC wide settings -> Setting the start authorization

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Similar to the access authorization you have to add the OPC Client user/s and allow all authorizations.


Application specific settings

Manual -> OPC server -> REMOTE access with DCOM -> DCOM configuration -> Application specific settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The security specific settings should be configured directly in the application and not in the standard settings of the workstation.

Start the program DCOMCNFG from the Windows\\System32 directory.

Open the console root and switch to the Component services – Computer – Workspace – DCOM – Configuration. It may occur, that not correctly registered programs are listed. Confirm the message boxes with “Yes”. So the programs are added to the registry.

Search the OPC Server from the list and click on the OPC Server with the right mouse button. Select the properties in the context menu.

info Information

The OPC Server is independent of the zenon version. So the name of the OPC Server can differ from the version number of your control system installation. Usually you will see the name OPC Server for Version 5.21. Don’t get confused, it has no influence on the functionality. Important is the unique application ID (AppID). It has to be correct. The AppID of the OPC server is: {CA2AF1F9-C031-42B7-8BF3-6C6041B23EAC}
Check if the path leads to the correct OPC Server. You will find the path of the the registered OPC Server under Local path.

You have to do the following settings in this dialog:

On the property page General: Authentification level: connect

On the property page Execution place: Execute application on this computer

On the property page Security:

Start and activation authorization | Select adjust. With a click on “Edit…” you open the authorization dialog. Add the necessary users and activate all authorizations.
Access authorization | Select adjust. With a click on “Edit…” you open the authorization dialog. Add the necessary users and activate all access authorizations.
Configuration authorization | Select adjust. With a click on “Edit…” you open the authorization dialog. Add the necessary users and activate the configuration authorizations for full access and reading.

On the property page End points: Click on “Add...” and add connection oriented TCP/IP with the standard points.

On the property page Identity: Select “Interactive user”


Remote browsing the OPC Server

Manual -> OPC server -> REMOTE access with DCOM -> Remote browsing the OPC Server

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As already described in Browsing the OPC Server there are two methods, how an OPC Client can find and browse an OPC Server. Also for remote browsing the OPC Client can use both methods.


Browsing with Registry entry

Manual -> OPC server -> REMOTE access with DCOM -> Remote browsing the OPC Server -> Browsing with Registry entry

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The OPC Client has to support browsing per Registry and has to be configured accordingly. Additionally the access to the Registry of the remote server has to be possible.


Browsing with OPC Enum

Manual -> OPC server -> REMOTE access with DCOM -> Remote browsing the OPC Server -> Browsing with OPC Enum

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The program OPCEnum.exe has to be installed on the OPC Server PC (it is not shipped). The OPC Enum program has to be correctly configured in the DCOM configuration like the OPC server. Grant access authorization for the remote OPC client. Configure the settings similar to the settings for the OPC Server). Otherwise the OPC Client cannot establish a DCOM connection to the OPC Enum program and thus browsing does not work.


PLC Diagnosis

Manual -> PLC Diagnosis

With the PLC Diagnosis program details of a PLC can be displayed directly in a screen of the control system. Depending on the PLC different functionalities are available. At the moment the S7 Graph functional chart analysis for the display of functional chart information of S7 PLCs and the zenon Logic Monitoring Viewer for the display of all programs being executed in the zenon Logic Runtime (Soft PLC) are available.

In the Runtime the currently active steps from the PLC are displayed graphically. Alarm information can be directly transferred to the Alarm Message List.

tutorial License information

Must be licensed for Editor and Runtime (single-user, Server, Standby and Client). available for zenon Operator and under Windows CE as a licensed module.


S7 graph

Manual -> PLC Diagnosis -> S7 graph

You have the possibility to create a screen of the type S7 Graph in zenon. In this screen you can display the functional chart, the active step, the name of the functional chart, the number of the functional chart etc. of a S7 control with S7 Graph programming.


Changing from ActiveX CD_Graph7Diag.ocx to the screen of the type S7 Graph

Manual -> PLC Diagnosis -> S7 graph -> Changing from ActiveX CD_Graph7Diag.ocx to the screen of the type S7 Graph

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The functionality of the ActiveX CD_Graph7Diag.ocx has been taken over by the screen S7 Graph and the function Analyze S7 Graph heuristics. In order to change from ActiveX to the screen and the function or to display S7 Graph in zenon, carry out the following steps:

  1. If you have not already done it, carry out the S7 Graph import so that the required variables and files are created.
  2. Create screen of the type S7 Graph.
  3. Create screen switch functions to screen S7 Graph. Enter the respective variables and files (see also Filter for screen switch).
  4. If you need the heuristics, create the function Analyze S7 Graph heuristics and enter the respective variables and files (see also Function Analyze S7 graph heuristics).

Changes compared to the ActiveX

  • Buttons LD and FBD are now distinct control elements
  • Heuristics is detached from the actual display. Thus heuristics needs a function of its own.
  • Button forward and back make it possible to navigate step-by-step through the step detail view.


Requirements for the automatic import

Manual -> PLC Diagnosis -> S7 graph -> Requirements for the automatic import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Even though importing is extensively automatic, some preparatory work has to be done in the S7 Graph project in order to make the import of functional charts possible in zenon. The following prerequisites are necessary:

1. Data block settings

You must make sure that the configuration of the data block is correct.

Make the following settings in tab Translate/Save:

Parameters | Entry
FB Parameter | user defined
Interface description | Individual structures / Load in AS
Run capability | Standard FC necessary
Chain properties | Criteria analysis data in DB

Make the following settings in tab Message:

Parameters | Entry
Message handling | Message with ALARM_SQ / ALARM_S

2. Generate sources

For each functional chart to be imported a current source must be generated. This is done in the S7 Graph editor via File -> Generate source. Take care that the name of the source has to match the FB name of the functional chart. So for a functional chart in the function block 12 the name of the source must be FB12 (or fb12).

3. Instance DB number

In order to make the allocation of the function block of the functional chart to the according instance data block (Instance-DB) possible, you may not change the default setting (DB name = FB name).


Import data from S7 Graph project

Manual -> PLC Diagnosis -> S7 graph -> Import data from S7 Graph project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Right-click entry Variables in the project manager. Select menu entry Extended import/export from the context menu and Import S7 Graph project.... You can also reach the context menu by selecting the node Variables and right-clicking on the project manager detail view.

Select the appropriate driver that is used for communication with the PLC in the following dialog and confirm your selection with OK.

attention Attention

Before the import in Step 7 or PC S7 everything must be translated for all objects to be adopted in zenon.

Import S7 Graph project

info Information

The settings you make in this dialog are saved. When you open the dialog again, all settings you made are displayed again.

The following settings are available.

Parameters | Description
Project selection |
S7 project file | Select the desired project file (*.s7p).
Target driver | The driver you have selected before is displayed there. You cannot change it there.
Create elements for S7 Graph |
Instance DB variable | Creates variables of the type USINT which depicts the instance data block of the functional chart. All status information is communicated with the help of this variable.
Message variable | Creates an internal variable of type STRING which displays the status of the heuristics.
Reaction matrix | Creates a numeric reaction matrix. The reaction matrix is used for linking with the Alarm-S variable. With this they cause an alarm in zenon. The import of alarms for S7 Graph is carried out via PDIAG Import Wizard.
Alarms must be acknowledged | If you activate this checkbox, all alarms created by the reaction matrix must be acknowledged.
Variable naming |
Separator | Define the character which will be positioned between the nomenclature and the name of the functional chart.
Internal nomenclature | Uses the internal nomenclature for the created objects. Example: S0 (for net address = 0)
WinCC nomenclature | Uses the WinCC nomenclature for the created objects. Example: S7 program
Combined | Uses both the internal and the WinCC nomenclature for the names of the created objects. A dot is used as a separator.

Confirm the dialog with Execute.

Select the desired stations (CPU) in the following dialog. The dialog supports multi-select. You can select several functional charts at once if you press and hold Ctrl or Shift while making your selection. Enter the net address for the communication. Confirm this dialog with OK. An analysis of the S7 project is carried out. Depending on the size of the project, it can take some time.

IN the next dialog select the functional charts which you want to import. The dialog supports multi-select. You can select several functional charts at once if you press and hold Ctrl or Shift while making your selection. If no source is found for a functional chart, it is displayed in the Comment with the entry !!. No source!!. These functional charts cannot be imported. Confirm the dialog with OK. The import is carried out and the respective objects are created in zenon. The source of the functional chart (*.gr7) and the symbolism of the functional chart (*.seq) are imported as well. The are saved in the zenon Editor under Files -> Others -> S7 Graph.


Language switch

Manual -> PLC Diagnosis -> S7 graph -> Import data from S7 Graph project -> Language switch

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Texts in the S7 Graph chart can be engineered as language changeable. In zenon the language changeability is usually marked by a preceded @. In the SIMATIC manager it is however not possible to create keywords with preceded @. Therefore the language change is carried out via text comparison:

  1. in the language table the corresponding elements are entered without the @
  2. all dynamic fields of the screen are searched and it is tried to find a translation for:
    • Information: Name of the active sequential function chart
    • Information: Name of the active step
    • all texts from Graphical Display: Active steps
    • all texts from Graphical Display: Whole functional chart
    • all texts of Information: Symbol table
  3. static fields must have the key character @ as prefix and an entry in the language table must be created for:
    • Step back
    • Step forward
    • Switch LD/FBD

The display of the texts for functional charts and transitions and the texts in the symbol table take place automatically if the corresponding entries exist in .GR7 or .SEQ.

You can read details on language switch in the Language switch chapter.


Screen S7 Graph

Manual -> PLC Diagnosis -> S7 graph -> Screen S7 Graph

The screen of the type S7 Graph supersedes the functionality of the ActiveX CD_Graph7Diag.ocx.

To create the screen:

  1. select New screen
  2. select S7 Graph from the the drop-down list
  3. name the screen
  4. add the default elements via menu item Control elements -> Add template
  5. add additional needed elements via sub items of menu item control elements if necessary

Parameters | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.
Windows | Elements for the graphic display.
Active steps | Display of the active step or steps from the engineered functional chart.
Whole functional chart (not default) | General view of the functional chart. Displays all engineered functional charts. Is controlled via SFC forward and SFC back.
Symbol table | Displays in two columns the address and the corresponding symbol name.
Information | Elements for informational purpose.
Name of the active sequential function chart | Shows the name of the active sequential function chart.
Name of the active step | Shows the name of the active step.
Number of the active step | Shows the number of the active step.
Control | Elements for the PLC.
Switch LD/FBD | With the help of this button you can switch between notations LD and FBD.
Step forward (not default) | In the Runtime moves one step forward.
Step back (not default) | In the Runtime moves one step back.
SFC forward (not default) | In the Runtime in view Whole functional chart moves one functional chart forward if there are several charts in the function block diagram.
SFC back (not default) | In the Runtime in view Whole functional chart navigates one SFC back if there are several SFCs in a function block.


Filter for screen switch

Manual -> PLC Diagnosis -> S7 graph -> Filter for screen switch

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If you use function screen switch to the screen S7 Graph, the following dialog is displayed.

Parameters | Description
S7 Graph file |
S7 Graph source | Select the the file (*.gr7) which has been generated by the S7 Graph import. This file contains the full logics (steps, transitions, surveillances etc.).
Symbol allocation file | Select the the file (*.seq) which has been generated by the S7 Graph import. This file contains the assignment of absolute operands (equals physical address) to symbolic operands or symbolism (equals logical identifier). Example: Input "E 1.0 = pushbutton 1"
Variable |
Instance DB variable | zenon variable which displays the instance data block of the functional chart. All status information is communicated with the help of this variable.
Representation |
Type of display | Select if you would like the display as a contact plan (COP) or as a function plan (FUP). If you configure the Switch COP/FUP button in your screen, you can switch between the two display types in Runtime.
Line width [Pixel] | Define the line width in pixels of the connection line between the elements.
Font | Select the desired font from the drop-down list for all labels in screen S7 Graph.
Colors | Define the colors for the high level and low level states and for the symbols. Click on the respective colored rectangle in order to change the color.


Function Analyze S7 Graph heuristics

Manual -> PLC Diagnosis -> S7 graph -> Function Analyze S7 Graph heuristics

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function makes it possible to carry out the S7 Graph heuristics without the screen S7 Graph being active. Thus for example an analysis can be carried out by a S7 PDiag error message via an Alarm S variable. The heuristics looks through the stage that currently has a problem in order to determine the cause

The following properties are available.

Parameters | Description
S7 Graph file |
S7 Graph source | Select the the file (*.gr7) which has been generated by the S7 Graph import. This file contains the full logics (steps, transitions, surveillances etc.).
Symbol allocation file | Select the the file (*.seq) which has been generated by the S7 Graph import. This file contains the assignment of absolute operands (equals physical address) to symbolic operands or symbolism (equals logical identifier). Example: Input "E 1.0 = pushbutton 1"
Variables |
Instance DB variable | zenon variable which displays the instance data block of the functional chart. All status information is communicated with the help of this variable.
Message variable | Variable of type STRING which displays the status text of the heuristics.


Description of the operand analysis

Manual -> PLC Diagnosis -> S7 graph -> Description of the operand analysis

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to make clear, which step is disturbed and which operand in the transitions is responsible, the message variable is filled with a telling message. This message is generated in the following steps:


1. Search disturbed step

Manual -> PLC Diagnosis -> S7 graph -> Description of the operand analysis -> 1. Search disturbed step

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If the sent alarm variable is of the type UDINT, it contains the number of the disturbed step in case of an error. Thsi can be used for further evaluations. If only a BOOL variable is sent, the first actie step, which is disturbed at the moment, is used.


2. Selection of edited transition

Manual -> PLC Diagnosis -> S7 graph -> Description of the operand analysis -> 2. Selection of edited transition

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If in the disturbed step there are several transitions to following steps, only the transition with the lowest transition number is evaluated.


3. Find missing operands

Manual -> PLC Diagnosis -> S7 graph -> Description of the operand analysis -> 3. Find missing operands

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The disturb cause which was detected in this way is displayed with the help of the message variable. The content of this variable is updated when you execute function Analyze S7 Graph heuristics.

In order to find the missing operands in the defined transition the condition tree is processed hierarchically. This can be demonstrated best in the FUP display (see example illustration below). The following cases are distinguished on finding an operator:

AND

All paths are traced which are not fulfilled at the time of the evaluation (i.e. red in the illustration).

OR

The fulfillment level, the proportion of fulfilled inputs and the total number of inputs are calculated for each path. Then only the paths that have the highest fulfillment level are traced. If thee are several paths with the same fulfillment level, the first one is used.

With this method a possible small but nevertheless - with high probability - meaningful number of operands is found, which can be important for the next step.

In the example illustration this method would only find the operand M102.2, because this is the smallest possible number of operands, which is necessary to change the disturbed transition to undisturbed.


zenon Logic Monitoring Viewer

Manual -> PLC Diagnosis -> zenon Logic Monitoring Viewer

info Information

This tool visually displays and evaluates zenon Logic programs. With the Monitoring Viewer actions in the zenon Logic Runtime can directly be displayed in a screen in zenon.


Requirements

Manual -> PLC Diagnosis -> zenon Logic Monitoring Viewer -> Requirements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As of zenon 6.20 SP3 the ActiveX X5Monitoring.ocx which carries out the zenon Logic program display is installed in the zenon program folder and registered in the operating system. For earlier zenon versions you must carry out the installation and registration manually.

At the moment this module is only available for the PC version of zenon.

A licence for the PLC Analysis is needed for using the zenon Logic Monitoring Viewer.

The Wizard zenon Logic Monitoring Builder has to be executed in the zenon Logic Workbench, before the zenon Logic Monitoring Viewer can display the current program code. The Wizard is executed in the zenon Logic Workbench under Tools > Create Monitoring Application.

This Wizard has to be licensed.

Different properties can be changed in the wizard. For example: The authorization for viewing programs or forcing variables can be defined (locked, password protected, open).

The Wizard creates a <ProjektName>.K5m file and save it in the zenon project folder.


Integration of ActiveX in a zenon screen

Manual -> PLC Diagnosis -> zenon Logic Monitoring Viewer -> Integration of ActiveX in a zenon screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the zenon Editor select the dynamic element ActiveX and draw it in a zenon screen in the desired size. Now a dialog for the selection of the ActoveX control opens. Select X5Monitoring Control and click on Properties.

In the following dialog enter the path of the file, which has been created with the Monitoring Builder and set the communication parameters:

info Information

If now paths have been changed, while the Monitoring Builder Wizards was running, the monitoring file is in the SQL directory of the zenon project. Find out the GUID (e.g. by checking the zenon Logic project properties in zenon) and browse for the *.K5m file. You can normally find it in the standard path.

C:\ProgramData\COPA-DATA\SQL\<GIUID>/FILES/straton/<zenon Logic Project Name>/<zenon Logic Project Name.K5m>.

info Information

For the Connection settings only use IP addresses and no computer names! If the zenon Logic Runtime runs on the same computer as zenon, enter 127.0.0.1 for the localhost.

Separated with a colon (:) enter the Runtime port of the zenon Logic Runtime after the IP address. Usually it is 1200.


Display the ActiveX in a zenon screen during runtime

Manual -> PLC Diagnosis -> zenon Logic Monitoring Viewer -> Display the ActiveX in a zenon screen during runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Confirm the two dialog with OK. After creating the zenon Runtime files and starting the zenon and zenon Logic Runtime, the PLC code is displayed in the according zenon screen:

Depending on the authorization defined in the Monitoring Builder Wizard programs can only be seen or also values can be forced.


Process Gateway

Manual -> Process Gateway

The Process Gateway serves as a coupling to higher-level systems. Parts of the zenon process image of other applications can be made available and be updated.

tutorial License information

Must be licensed for Editor and Runtime (single-user, Server, Standby and Client).

info Information

The Process Gateway user interface is only available in English.


General

Manual -> Process Gateway -> General

It is thought as an add-on to the Runtime of the control system and only works in combination with it.

That means: If zenon Runtime has not been started, the Process Gateway does not start!

Variable assignment using names

Please note that assignment is always via the variable name in the Process Gateway.

This is particularly important if:

  • Variable names in the project configuration are changed in zenon Editor.
  • Variables in the project configuration in the Editor are deleted.
  • zenon calls up a new start project.

In this case, module-independent error dialogs appear when Process Gateway is started.

attention Attention

If a variable assignment is erroneous, the Process Gateway is not started! The Process Gateway only starts if the incorrect variable assignment has been corrected.

The first error dialog lists the unknown variables.

  • In this case, amend the variable assignment again.
  • To do this, remove all incorrectly-assigned variables from the respective export area and re-add the corresponding variables.

The dialog that follows contains module-dependent error messages.

LOG entry

The following LOG entry is created in the event of incorrect variable assignment:

LOG entry | Description
Failed to update value for variable %s. | No COM connection to zenon could be established, or the variable is not (or no longer) available in zenon or has been renamed.


Requirements

Manual -> Process Gateway -> Requirements

Runtime: On the computer on which the Process Gateway should run, the Runtime with the corresponding release version and a loaded project that corresponds to the configuration has to be started before it is started. If Runtime is stopped, the Process Gateway is also stopped automatically.

info Information

The Process Gateway uses the COM interface to access zenon data. The COM interface is used by VBA and is only available if zenon6.ini is present in the file under under [VBA] the entry EVENT=1.

Modules: There are different modules for the Process Gateway, that take over the communication to external applications. At the moment these modules are:

File | Description | Connection to
AccessDEC.dll | Slave for DEC | Hundamp;S-DEC-System
AccessDNP3.dll | Slave for DNP3 | DNP3 master
AccessICCP.dll | ICCP/TASE.2 protocol | ICCP Server
AccessIEC870Sl.dll | Slave for IEC 60870-5-01/104 | IEC 60870 master
AccessMODBUS.dll | Slave for Modbus | Modbus master
AccessOPCUA.dll | OPC US Server | OPC UA client
AccessSNMP.dll | SNMP agent | SNMP client
AccessSQL.dll | SQL Online-Interface | SQL databases
AccessAzure.dll | MS Windows Azure | Microsoft Azure

Note: The module to be started is selected and configured in its own INI file of the Process Gateway, not in zenon6.ini as is otherwise the case for zenon! This INI file is called zenProcGateway.INI and is located in the following folder: C:\ProgramData\COPA-DATA\System.

attention Attention

If the Modbus Slave driver is used, the Process Gateway only supports:

  • Function Code 3: Read Multiple Registers
  • Function Code 16: Write Multiple Registers


Installation

Manual -> Process Gateway -> Installation

The add-on only consists of the zenProcGateway.exe file. It is preferable to copy this to the zenon program folder. However it is possible to have any folder as the installation folder. The module to be used with the zenProcGateway has to be in the same folder as zenProcGateway.exe. Exception: SNMP.

The configuration file zenProcGateway.ini is saved in the system folder. In this file, an entry DLL in the section [GENERAL] has to be set to the name of the module.

This INI file is called zenProcGateway.INI and is located in the following folder: C:\ProgramData\COPA-DATA\System.

Module | Entry in zenProcGateway.ini
DEC | [GENERAL] DLL=AccessDEC.dll
SQL | [GENERAL] DLL=AccessDEC.dll
MODBUS | [GENERAL] DLL=AccessMODBUS.dll
DNP3 | [GENERAL] DLL=AccessDNP3.dll
IEC870Sl | [GENERAL] DLL=AccessIEC870Sl.dll
SNMP | [GENERAL] DLL=AccessSNMP.dll
OPCUA | [GENERAL] DLL=AccessOPCUA.dll
ICCP/TASE.2 | [GENERAL] DLL=AccessICCP.dll

If a configuration file with a different name is to be used (e.g. for operation with multiple instances), you have to start zenProcGateway.EXE with the command line parameter /ini:<file> . That file must be in the system folder, too.

Example Example

zenProcGateway.EXE /ini:MyConfig.INI


zenProcGateway.ini

Manual -> Process Gateway -> Installation -> zenProcGateway.ini

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

[GENERAL]

Entry

Description

[GENERAL]

General setting for Process Gateway, regardless of the modules selected.

DLL=

Selection of the DLL file that is to be used for Process Gateway. The selected DLL file determines the module selection

  • AccessDEC.dll
  • AccessSQL.dll
  • AccessMODBUS.dll
  • AccessDNP3.dll
  • AccessIEC870Sl.dll
  • AccessSNMP.dll
  • AccessOPCUA.dll
  • AccessICCP.dll
  • AccessAzure.dll


Configuration Process Gateway

Manual -> Process Gateway -> Installation -> Configuration Process Gateway

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure Process Gateway:

Create an INI file (optional):

  1. Create a project backup.
  2. Save this with the name zenProcGateway.ini in the folder C:\ProgramData\zenon\System.
  3. Create, in the text file, a text entry with the desired module (this example uses the DNP3 module):
    [GENERAL]
    DLL=AccessDNP3.dll

Due to the system, only ANSI and Unicode are supported for reading the INI files.

attention Attention

UTF-8 format is not supported!

You should therefore always save your INI files as a text file in ANSI or Unicode format.

Configuration

Start the Process Gateway:

Start the program zenProcGateway.exe by double clicking on it. You can find the program by default on your computer in the following folder: C:\Program Files (x86)\COPA-DATA\zenon 7.20 SP0. Alternatively, you can also start the Process Gateway in the Startup Tool:

  1. Click, in the Startup Tool, the Tools button.
  2. In the following dialog Start something else ... Select Process Gateway from the list of tools.
  3. Click on the Start button.
  4. The dialog for configuring Process Gateway is opened.
  5. Clicking on the Settings button opens a configuration dialog for the selected module.

info Information

These configurations are considerably different from one another and depend on the selected module.

You can find documentation for the respective configuration dialog in the respective modules.

If the gateway is started without a valid configuration file or if this file does not contain an entry about the communication module, you will be offered a selection list with all available communication modules after the start:

Select the desired module and click on the button OK A corresponding INI file is created and filled with the INI entry for the selected module. You can then continue with the configuration of the Process Gateway.


Project configuration

Manual -> Process Gateway -> Installation -> Configuration Process Gateway -> Project configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If no special project name is defined in the configuration file (zenProcGateway.ini), all specifications refer to the first project loaded by the Runtime (integration project). Any project in the hierarchy of a multi project system can be accessed by setting the entry PROJECT in the section [GENERAL] of the configuration file (zenProcGateway.ini) to the corresponding project name.


Module configuration

Manual -> Process Gateway -> Installation -> Configuration Process Gateway -> Module configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The configuration of a single module depends on the type of this module. With the configuration button the configuration dialog of the module is opened.


Security configuration

Manual -> Process Gateway -> Installation -> Configuration Process Gateway -> Security configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Process Gateway can be executed hidden to protect it from unauthorized access. If the Process Gateway is started in the command line with the parameter /hide (or -hide), it starts invisible and cannot be configured or stopped. The Process Gateway closes automatically when zenon is closed.


DEC

Manual -> Process Gateway -> DEC


Module configuration

Manual -> Process Gateway -> DEC -> Module configuration

The following dialog appears after the Settings button is clicked:

Here the variables that should be connected can be selected. In the list on the left-hand side all variables which are available in zenon are displayed. These can be selected and moved to the DEC export list with the '>' button. With the button '<' they can be removed again. If a variable is moved to the export list, a dialog for the name assignment of the zenon variable to the DEC variable opens:

The assignment is defined with a four digit press number and the four digit parameter name. Entered characters are automatically changed to upper case. The variables selected in this way then are continuously synchronized in zenon or in the connected DEC system.

In the lower part of the configuration dialog the TCP/IP connection to the DEC system can be configured.

The port number indicates the port where the Process Gateway waits for incoming connections.

The timeout is the time without response, after that the connection is closed.


Logging

Manual -> Process Gateway -> DEC -> Logging

All telegrams received by the DEC system and the responds from the Process Gateway can be logged.

To do this an entry LOGFILE in the section [DEC] of the configuration file with the name of the log file has to exist. This file then is created in the same folder as zenProcGateway.exe.

Example for this entry:
[DEC]
LOGFILE=zenProcGateway.log


Configuration file: specific entries for AccessDEC

Manual -> Process Gateway -> DEC -> Configuration file: specific entries for AccessDEC

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The configuration file must be in the system folder.

Note: The configuration file must be in the system folder.

[DEC]

Entry | Description
LOGFILE | Name of the log file (if desired, e.g. zenProcGateway.log)
PORT | Port number, where the Process Gateway waits for connection attempts
TCPTIMEOUT | timeout interval, after which the connection is closed
REFRESHRATE | time interval in milliseconds, in which the process image of zenon is checked on changes.


DNP3 slave

Manual -> Process Gateway -> DNP3 slave


Module configuration

Manual -> Process Gateway -> DNP3 slave -> Module configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following dialog appears in the Process Gateway after the Settings button is clicked:

Variables

Here the variables that should be connected can be selected. On the left-hand side all variables which are available in zenon are displayed. You can select them there and move them to the DNP3 export list with the button >. With the button < they can be removed again.
As a result of the fact that variables are selected from a list, it is ensured that each variable is only used once.

The point list (Exported into DNP3) also contains the project reference of a variable. If a variable belongs to the default project, it is displayed with "[Project]#[Variable Name]" in the point list. If it belongs to the default project (marked with *), it is only listed in the point list with the variable name.

If a variable is moved to the export list, a dialog for the name assignment of the zenon variable to an object and point number in DNP3 opens.

The variables selected in this way then are available in the DNP3 slave and are continuously synchronized between zenon and the DNP3’s object database.

Allocation of object groups to event classes

The allocation of object groups to event classes is defined and fixed and is as follows:

Event Class 1: Binary inputs

Event Class 2: Analog inputs

Event Class 3: Binary Outputs, Analog Outputs, Running Counters, Octet Strings

Variables

Parameters | Description
Variables | Area for variable selection, depending on the selected project.
Available in SCADA | Area for the display of the available projects and the variables assigned to the selected project.
Projects | List of the projects available in the DNP3 module of the Process Gateway. The default project is marked with a * in front of the project name. This is generally the configured start project. Exception: A different file is configured in the INI file. Please also note the information on naming the variables for DNP3 in the Process Gateway.
Variables | List of all variables of the selected project available in zenon. These are also displayed by selecting a project by clicking in the Projects area. The variables are selected in this area and applied using the > button in the Exported into DNP3 area. Note: Multiple selection (Shift or ALT key) is possible.
Button > | Selected variables from the Variables list are moved to Exported into DNP3. Clicking on the > button opens the object settings dialog.
Button < | Selected variables are removed from the Exported into DNP3 list.
Exported into DNP3 | Export list of the assigned variables. Double clicking on the entry opens the object settings dialog. The variables selected in this way are available on the DNP3 slave. These variables are continually synchronized between zenon and the DNP3 object database. Please also note the information on naming the variables for DNP3 in the Process Gateway.

DNP3 connection

In the lower part of the configuration dialog the serial or TCP/IP connection for the DNP3 slave can be configured.

Parameters

Description

Unsolicited Responses

Button for the configuration of responses that that are not requested (Unsolicited Responses), which the Process Gateway sends to the DNP3 master.

Attention: The DNP3-Master can also request Unsolicited Responses from the Process Gateway. However to do this, the functionality must be activated in the Process Gateway.

The number of events and the maximum time delay can be configured for each event class.

Timeout and Retry are given for all event classes together.

Clicking on the button opens the configuration dialog.

Note: Entries are remanent.

Event Handling

Button for the configuration of event handling

Clicking on the button opens the configuration dialog.

Variations

Button for the configuration of the Variations per object group.

Clicking on the button opens the configuration dialog.

Local Session Link Adress

Link address of the slave.

Default: 3

Note: Only one active session is supported, regardless of whether serial or TCP/IP communication is used.

Remote Link Address (Master)

Link address of the master.

Default: 4

Note: Only one active session is supported, regardless of whether serial or TCP/IP communication is used.

Time Zone

Button to select the time format:

  • Local Time
  • UTC

Serial

Serial

Configurations of the serial interface for communication on the DNP3 slave

Port

Drop-down list for the configuration of the communication interface:

Value range: COM 1 to COM 64

Default: COM 1

Note: Only active if Serial is activated as the communication method.

Stop Bits

Drop-down list for the configuration of the number of stopbits transferred:

  • 1
  • 1.5
  • 2

Default: 1

Note: Only active if Serial is activated as the communication method.

Parity

Drop-down list for the configuration of the parity:

  • No
  • Odd
  • Even

Default: No (= no parity)

Note: Only active if Serial is activated as the communication method.

Data Bits

Drop-down list for the configuration of the number of data bits transferred:

  • 5
  • 6
  • 7
  • 8

Default: 8

Note: Only active if Serial is activated as the communication method.

Baudrate

Drop-down list to select the Baud rate for serial interface communication.

Selection options: 110, 300, 600, 1200, 2400, 4800, 9600, 19200, 38400, 56000, 57600, 115200, 128000, 256000

Default: 9600

Note: Only active if Serial is activated as the communication method.

TCP/IP

TCP/IP | Configurations for communication in a network via TCP/IP.
Port | Input field for the configuration of the "Listener-/Horch-" protocol port Default: 20000 Note: Only active if TCP/IP is activated as the communication method.

Close dialog

OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.


Naming of the variables for DNP3 in the Process Gateway.

Manual -> Process Gateway -> DNP3 slave -> Module configuration -> Naming of the variables for DNP3 in the Process Gateway.

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The variable name of the DNP3 slave for communication to the DNP3 master comprises the following components:

  • Project name
  • #
    A # character is inserted after the project name as a separator
    Attention: There is no project name and separator with start projects!
    If a variable name in the DNP3 module of the Process Gateway is not preceded by a project, the project defined in the INI file is automatically placed in front for communication to the DNP3 master.
    If there is no project defined in the INI file, this corresponds to the start project in Runtime.
    The start project is marked with a * in the module configuration, in the Available in SCADA group, in the Projects .
  • Variable name
    As configured in zenon.
  • Object type
    As configured in the Object Settings dialog .
  • Point index
    As configured in the Object Settings dialog .
  • Event handling
    As configured in the Object Settings dialog .


Variable selection - object settings

Manual -> Process Gateway -> DNP3 slave -> Module configuration -> Variable selection - object settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If a variable is moved to the export list, a dialog for the name assignment of the zenon variable to an object and point number in DNP3 opens:

The variables selected in this way then are available in the DNP3 slave and are continuously synchronized between zenon and the DNP3’s object database.

Settings

Parameters

Description

Name

Name of the variable for which the configurations can be carried out.

Note: For information only and grayed out, because it cannot be changed.

Object

Drop-down list to select the driver data type to the driver

  • Analog inputs
  • Analog Output Status
    (written value is mirrored as a response after successful writing)
  • Binary inputs
  • Binary Output Status
  • Running Counters
  • String Data

Default: Binary inputs

Event Handling

Denotes which events can be processed:

  • Default
    Events are handled as defined in the object group.
    For this, please note the configuration in the event handling dialog.
  • SOE
    Events are treated as a Serie of Events).
  • Most recent
    Only the last change of a binary change event is retained.

Note: Inactive if the data type is string data.

Default: Default

Point

Pointindex For the event.

Default: 0

Note: Ensure that the point index is unique for each variable. It is recommended that that the point index is started at 0 and numbered incrementally.

Close dialog

OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog. Note: The variable is in this case not available on the DNP3 slave.

info Information

If several variables have been selected during module configuration, a switch to the configuration dialog of the next variable is made by clicking on the OK or Cancel buttons. A separate configuration dialog is thus called up step by step for each selected variable.


Unsolicited Responses

Manual -> Process Gateway -> DNP3 slave -> Module configuration -> Unsolicited Responses

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dialog for the configuration of the Unsolicited Responses in the object settings:

Parameters

Description

Enable unsolicited response

Check box to activate the use of Unsollicited responses. If this check box is not activated, no unsolicited responses are generated.

Default: inactive

Note: If this property is not active, all of the following entries are grayed out.

Attention: If this option is not active, no unsolicited responses are sent to the master. Even if these are requested by the master.

Timeout

Time in seconds for communication to the master. A time exceedance is triggered once this time has expired.

Entry range: 1 to 60 s

Default: 5 s

Note: This setting depends on the type and speed of its communication to the master. In principle, the slower the communication, the higher the Timeout time.

Number of retries

Number of retries for communication to the master.

Entry range: 0 - 65535
(0 = an infinite amount of attempts)

Default: 3

Example: If an unsolicited response is sent to the master, this is confirmed by the master. If this confirmation from the master remains outstanding, a confirmation is sent as many times as configured in Number of retries. A new unsolicited response is then created.

Event Class 1

Maximum Number of Events | Maximum number of events (per event class) that can be buffered before an unsolicited response is sent. Entry range: 0 - 255 Default: 5
Maximum Delay | Maximum delay per event class that is waited until a new entry is written after writing an unsolicited response. Entry range: 0 - 65535 seconds (0 = no delay, i.e. on value change) Default: 5

Maximum Number of Events and Maximum Delay work together. The value that is reached first triggers communication to the master.
Note: You can also prioritize the three event classes with these entries.

Event Class 2

Maximum Number of Events | Maximum number of events (per event class) that can be buffered before an unsolicited response is sent. Entry range: 0 - 255 Default: 5
Maximum Delay | Maximum delay per event class that is waited until a new entry is written after writing an unsolicited response. Entry range: 0 - 65535 seconds (0 = no delay, i.e. on value change) Default: 5

Event Class 3

Maximum Number of Events | Maximum number of events (per event class) that can be buffered before an unsolicited response is sent. Entry range: 0 - 255 Default: 5
Maximum Delay | Maximum delay per event class that is waited until a new entry is written after writing an unsolicited response. Entry range: 0 - 65535 seconds (0 = no delay, i.e. on value change) Default: 5

Close dialog

OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.


Event Handling

Manual -> Process Gateway -> DNP3 slave -> Module configuration -> Event Handling

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration dialog for event groups and their behavior when the value of variable is changed.

Possible options are:

  • Behavior on deletion
  • Behavior on value change
  • Buffer size

Parameters

Description

Delete on buffer overflow

Global setting for which event is deleted when the buffer is full:

  • Oldest
    Oldest entries are deleted.
  • Newest
    Most recent entries are deleted.

Default: Oldest

Binary Change Events

Parameters | Description
Buffer Size | Setting for buffer size for the respective event group. Entry range: 1 - 65535 Default: 100

Binary Output Events

Parameters | Description
Buffer Size | Setting for buffer size for the respective event group. Entry range: 1 - 65535 Default: 100

Analog Change Events

Parameters | Description
Buffer Size | Setting for buffer size for the respective event group. Entry range: 1 - 65535 Default: 100

Analog Output Events

Parameters | Description
Buffer Size | Setting for buffer size for the respective event group. Entry range: 1 - 65535 Default: 100

Counter Events

Parameters | Description
Buffer Size | Setting for buffer size for the respective event group. Entry range: 1 - 65535 Default: 100

String Events

Parameters | Description
Buffer Size | Setting for buffer size for the respective event group. Entry range: 1 - 65535 Default: 100

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.


Variations per object group - variations

Manual -> Process Gateway -> DNP3 slave -> Module configuration -> Variations per object group - variations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this dialog, (Variations) can be configured for the following object groups:

  • 1 Binary Input
  • 2 Binary Input Event
  • 10 Binary Output
  • 11 Binary Output Event
  • 20 Counter
  • 22 Counter Event
  • 30 Analog Input
  • 32 Analog Input Event
  • 40 Analog Output Status
  • 42 Analog Output Event

Different variations are supported depending on the object group:

Parameters | Description
Binary Input | Drop-down list with the supported Variations for the object group Binary Input: 1: packet format 2: with flags Default: 1: packet format
Binary Input Event | Drop-down list with the supported Variations for the object group Binary Input Event: 1: without time 2: with absolute time 3: with relative time Default: 3: with relative time
Binary Output | Drop-down list with the supported Variations for the object group Binary Output: 1: packet format 2: with flags Default: 1: with flags
Binary Output Event | Drop-down list with the supported Variations for the object group Binary Output Event: 1: status without time 2: status with time Default: 1: status without time
Counter | Drop-down list with the supported Variations for the object group Counter: 1: 32 bit with flag 2: 16 bit with flag 5: 32 bit without flag 6: 16 bit without flag Default: 5: 32 bit without flag
Counter Event | Drop-down list with the supported Variations for the object group Counter Event: 1: 32 bit with flag 2: 16 bit with flag 5: 32 bit flag and time 6: 16 bit flag and time Default: 1: 32 bit with flag
Analog Input | Drop-down list with the supported Variations for the object group Analog Input: 1: 32 bit with flag 2: 16 bit with flag 3: 32 bit without flag 4: 16 bit without flag 5: single precision, floating-point with flag 6: double precision, floating-point with flag Default: 6: double precision, floating-point with flag
Analog Input Event | Drop-down list with the supported Variations for the object group Analog Input Event: 1: 32 bit without time 2: 16 bit without time 3: 32 bit with time 4: 16 bit with time 5: single precision, floating-point without time 6: double precision, floating-point without time 7: single precision, floating-point with time 8: double precision, floating-point with time Default: 6: double precision, floating-point without time
Analog Output | Drop-down list with the supported Variations for the object group Binary Input: 1: 32 bit with flag 2: 16 bit with flag 3: single precision, floating-point with flags 4: double precision, floating-point with flags Default: 2: 16 bit with flag
Analog Output Event | Drop-down list with the supported Variations for the object group Analog Output Event: 1: 32 bit without time 2: 16 bit without time 3: 32 bit with time 4: 16 bit with time 5: single precision, floating-point without time 6: double precision, floating-point without time 7: single precision, floating-point with time 8: double precision, floating-point with time Default: 2: 16 bit without time

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.


Communication - procedure

Manual -> Process Gateway -> DNP3 slave -> Communication - procedure

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Value changes are executed via COM. An update in stack direction only occurs if:

  • It is the first value for the object (initial value).
  • The value changes (value change).
  • The status bits Invalid or Not current change (value change of the status bit).

The time stamp of the change is applied in the event of a change. This time stamp is applied from the COM event and transferred to the stack event. The Time Zone setting determines the type of time stamp:

  • Local time or
  • UTC time

The stack no longer checks for a value change, but the gateway cyclically takes the value changes from the queue of the COM threads and forwards them to the stack for entry into the event buffer of the corresponding object group. Event values and static vales (with poll in the stack) are read from the shadow of the item and no longer from the shared memory. The time stamp is applied from the COM event and transferred to the stack event as a local time with millisecond precision.

Binary and analog output variables are written from the master to the Process Gateway.

In addition, these variables send the value back to the master, the same thing that binary and analog input variables do if the assigned variables are changed in zenon Runtime.

As a result of the fact that variables are selected from a list, it is ensured that double selection is prevented.


Device Profile

Manual -> Process Gateway -> DNP3 slave -> Device Profile

The template for the Device Profile is installed together with the DNP3 Process Gateway by the setup. You can find the file DNP3_ProcessGateway.xml in the following folder: %ProgramData%\COPA-DATA\zenon[Version]\CommunicationProfiles\Dnp3\ProcessGateway\


Configuration file: specific entries for Access DNP3

Manual -> Process Gateway -> DNP3 slave -> Configuration file: specific entries for Access DNP3

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The configuration file must be in the system folder. This INI file is called zenProcGateway.INI and is located in the following folder: C:\ProgramData\COPA-DATA\System.

[DNP3]

Entry

Description

SERIAL=

serial communication (1) or communication via TCP/IP (0)

COMPORT=

serial interface (COM1 = 0, COM2 = 1,...)

BAUD=

baud rate of the serial interface

BYTESIZE=

number of data bits of the serial interface

PARITY=

Parity settings of the serial interface:
(0=none,1=odd,2=even)

STOPBITS=

number of stop bits of the serial interface
(0=1, 1=1.5, 2=2)

LINKADDRLOC=

local session link address

LINKADDRREM=

remote session link address

PORT=

Communication port of communication via TCP/IP

Default: 20000

TIME_USE_UTC=

Format of the time stamp:

  • 0= Local time
  • 1 = UTC

Default: 0

Obj1BinInput=

Drop-down list with the supported Variations for the object group

1: packet format
2: with flags

Default: 1: packet format

Obj2BinInputEvent=

Drop-down list with the supported Variations for the object group

1: without time

2: with absolute time

3: with relative time

Default: 3: with relative time

Obj10BinOutput=

Drop-down list with the supported Variations for the object group

1: packet format
2: with flags
Default: 1: with flags

Obj11BinOutputEvent=

Drop-down list with the supported Variations for the object group

1: status without time
2: status with time

Default: 1: status without time

Obj20Counter=

Drop-down list with the supported Variations for the object group

1: 32 bit with flag
2: 16 bit with flag
5: 32 bit without flag
6: 16 bit without flag

Default: 5: 32 bit without flag

Obj22CounterEvent=

Drop-down list with the supported Variations for the object group

1: 32 bit with flag
2: 16 bit with flag
5: 32 bit flag and time
6: 16 bit flag and time

Default: 1: 32 bit with flag

Obj30AnalogInp=

Drop-down list with the supported Variations for the object group

1: 32 bit with flag
2: 16 bit with flag
3: 32 bit without flag
4: 16 bit without flag
5: single precision, floating-point with flag
6: double precision, floating-point with flag

Default: 6: double precision, floating-point with flag

Obj32AnalogInpEvent=

Drop-down list with the supported Variations for the object group

1: 32 bit without time
2: 16 bit without time
3: 32 bit with time
4: 16 bit with time
5: single precision, floating-point without time
6: double precision, floating-point without time

7: single precision, floating-point with time
8: double precision, floating-point with time

Default: 6: double precision, floating-point without time

Obj40AnalogOutStatus=

Drop-down list with the supported Variations for the object group

1: 32 bit with flag
2: 16 bit with flag
3: single precision, floating-point with flags
4: double precision, floating-point with flags

Default: 2: 16 bit with flag

Obj41AnalogOutput=

Drop-down list with the supported Variations for the object group

1: 32 bit without time
2: 16 bit without time
3: 32 bit with time
4: 16 bit with time
5: single precision, floating-point without time

6: double precision, floating-point without time

7: single precision, floating-point with time
8: double precision, floating-point with time

Default: 2: 16 bit without time

UNSOLICITED_RESPONSES_ENABLED=

Activated or deactivated Unsolicited Responses:

  • 0 = not active
  • 1 = active

Default: Inactive (0)

UNSOLICITED_RESPONSES_CONFIRMATION_TIMEOUT=

Time in seconds for communication to the master. A time exceedance is triggered once this time has expired.

Entry range: 1 to 60 s

Default: 5 s

UNSOLICITED_RESPONSES_RETRY_COUNTER=

Number of retries for communication to the master.

Entry range: 0 - 65535
(0 = an infinite amount of attempts)

Default: 3

UNSOLICITED_RESPONSES_MAXIMUM_EVENTS_CLASS_1=

Maximum number of events (per event class) that can be buffered before an unsolicited response is sent.

Entry range: 0 - 255
Default: 5

UNSOLICITED_RESPONSES_MAXIMUM_EVENTS_CLASS_2=

Maximum number of events (per event class) that can be buffered before an unsolicited response is sent.

Entry range: 0 - 255
Default: 5

UNSOLICITED_RESPONSES_MAXIMUM_EVENTS_CLASS_3=

Maximum number of events (per event class) that can be buffered before an unsolicited response is sent.

Entry range: 0 - 255
Default: 5

UNSOLICITED_RESPONSES_MAXIMUM_DELAY_CLASS_1=

Maximum delay per event class that is waited until a new entry is written after writing an unsolicited response.

Entry range: 0 - 65535 seconds
(0 = no delay, i.e. on value change)
Default: 5

UNSOLICITED_RESPONSES_MAXIMUM_DELAY_CLASS_2=

Maximum delay per event class that is waited until a new entry is written after writing an unsolicited response.

Entry range: 0 - 65535 seconds
(0 = no delay, i.e. on value change)
Default: 5

UNSOLICITED_RESPONSES_MAXIMUM_DELAY_CLASS_3=

Maximum delay per event class that is waited until a new entry is written after writing an unsolicited response.

Entry range: 0 - 65535 seconds
(0 = no delay, i.e. on value change)
Default: 5

[VARIABLES]

Entry

Description

COUNT

number of variables to be exported

EVENT_%d

Event handling: Handling of the events per variable.
Always belonging to a variable: e.g. EVENT_0 belongs to NAME_0

Values:

  • DEFAULT
    Handling of events is the same as in the object group
  • MOST_RECENT
    Only includes the last change of a binary change event
  • SOE
    Creates a series of events

Default: Default

NAME_n

name of the variable with the number n (0<=<COUNT)

OBJECT_n

DNP3 object type of variable number n (0<=n<COUNT)

POINT_n

DNP3 point number of variable number n (0<=n<COUNT)


LATCH_ON and LATCH_OFF

Manual -> Process Gateway -> DNP3 slave -> LATCH_ON and LATCH_OFF

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Command Control Code from the PLC is written to USINT variables as an 8-bit value via Process Gateway. The following applies for transfer to zenon variables:

Destination variable of the command | Result
BOOL: | Set value LATCH_ON: 1 Set value LATCH_OFF: 0
USINT: | Set value corresponds to control code.
all other variables: | Command failed.

Only direct control is supported. Select, SBO and Operate are not supported.

Master, control mode direct | Process Gateway | Value zenon USINT
LATCH_ON | Binary Output Statuses | 3
LATCH_OFF | Binary Output Statuses | 4
Pulse On | Binary Output Statuses | 1
Pulse Off | Binary Output Statuses | 2
Trip | Binary Output Statuses | 129
Close | Binary Output Statuses | 65

For zenon binary output statuses BOOL, only LATCH_ON/LATCH_OFF is supported.


ICCP-TASE.2

Manual -> Process Gateway -> ICCP-TASE.2

The IEC 60870-6 TASE.2 ICCP protocol can be used with the AccessICCP.dll module via the zenon Process Gateway. ICCP-TASE.2 supports conformance blocks 1 and 2 as client and server. It acts in the same way as for establishing communication as a server.

With the initialization of communication, zenon Process Gateway applies the addressing settings from the request received in accordance with ISO 8650-1 (for example AP-title, AE-qualifier) and automatically uses these OSI addressing parameters for further communication.

Port

Communication is effected via port 102 by default, or another port defined in the configuration file. The port is opened on startup and remains open. It allows the connection of clients. The maximum number can be defined in the configuration file.

Configuration of INI file

Path to the configuration file: %CD_SYSTEM%\zenProcGateway.ini.

Entry

Description

[ICCP]

Group

SERVER_PORT=

Number of the port.

Default: 102

MAX_CONNECTIONS=

Maximum number of connections.

0: unlimited

MAJOR_VERSION_NUMBER=

Main version number.

MINOR_VERSION_NUMBER=

Minor version number.

BILATERAL_TABLE_ID=

Name of bilateral table.

LOCAL_DOMAIN_NAME=

Local domain name.

REMOTE_DOMAIN_NAME=Remote

Remote domain name.

[VARIABLES]

Group for configured variables. The following are listed:

  • Parameters of each variable
  • Number of variables
  • Names of the variable

PARAM_0=

Parameter for variable.

The first is counted as 0 and the counter is increased by 1 with every further parameter. The identifier corresponds to the identifier of the variable name.

PARAM_0 Corresponds to NAME_0.

Example: PARAM_0=1,0,0,Variable

COUNT=

Number of configured variables

NAME_0=

Name of the variable.

The first is counted as 0 and the counter is increased by 1 with every further variable. This identifier corresponds to the parameter identifier.

PARAM_0 corresponds to NAME_0.

Example: NAME_0=MyName


Module configuration

Manual -> Process Gateway -> ICCP-TASE.2 -> Module configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The module must be configured when it is started for the first time.

Parameters | Description
Library | Shows the names of the DLL.
Description | Describes functionality.
OK | Accepts selection and starts configuration dialog.
Cancel | Cancels start of the Process Gateway.

First start

To start the Process Gateway with the ICCP/TASE.2 module:

  1. Start the Process Gates
    (no other module can be configured).
  2. The dialog to select the module is opened
  3. Select ICCP/TASE.2 protocol
  4. click on OK
  5. The dialog for configuring the module is opened
  6. Configure the tabs
    • General
    • Server variables
    • Client variables

The dialog to select the module is not offered

Starts the Process Gateway with another module that has already been configured without offering the dialog to select a module, then:

  1. Close the Process Gateway
  2. Navigate to the INI file
  3. Add a comment for the module in the file or delete the INI file
  4. Restart the Process Gateway

Start with configured module

Start the Process Gateway with a module that has already been configured; a dialog with static data is opened.

Parameters | Description
Statistic information | Information on updates
Exit | Closes process gateway.
Configuration | Opens configuration dialog.
Help | Opens online help.

Configuration

Configuration is carried out using three tabs. It can be confirmed and closed by clicking on OK if all three tabs have been configured.

Parameters | Description
General | General settings.
Server variables | Configuration of the server variables.
Client variables | Configuration of the client variables.
OK | Accepts settings in all tabs and closes the dialog.
Cancel | Discards settings in all tabs and closes the dialog.
Help | Opens online help.

In both tabs for server variables and client variables the variables that are provided on the ICCP server or were read in via the ICCP server are selected.

If a connection to the server was made by a client, the verification of the bilateral table IDs is carried out. At the same time, a client connection to the counterpart is established and the variables to be communicated are registered as a dataset and spontaneous communication of the DSTransferSet is activated.


General

Manual -> Process Gateway -> ICCP-TASE.2 -> Module configuration -> General

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration of the general settings.

Parameters | Description
Connection | Connection settings.
Biliteral Table ID | The bilateral table ID is compared to the client by the server when the connection to the server is made and allows only authorized clients to have access to the data.
Local Domaine Name | Name of the local domain that is used for all server variables.
Remote Domain Name | Name of the remote domain that is used for all client variables.
Error message | Display of missing configuration data.
OK | Accepts the settings of all tabs, saves the configuration in the zenProcGateway.ini file, starts the ICCP server and waits for incoming connections.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

Note of bilateral table ID: The unique bilateral table ID must be the same on all devices that communicate with the ICCP gateway. It is queried when a connection is made by both partners. The connection is disconnected if they do not correspond. The domain names provide the names used at MMS protocol level to variables that are communicating. It must be set as the same mirror image for the partners.


Server variables

Manual -> Process Gateway -> ICCP-TASE.2 -> Module configuration -> Server variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Selection and configuration of the variables that are provided on the ICCP client.

Parameters

Description

Available in zenon

List of the variables available in zenon.

Exported to ICCP

List of the variables exported to ICCP. Display:

  • Name in zenon
  • ICCP-Name
  • Type

ICCP name and type can be changed using the Variable name, Data type and Extended type options.

Cursor keys

Moving selected variables between the two lists.

  • Key >>: Copies all variables from zenon to ICCP.
  • Key <<: Removes all variables from the ICCP list.
  • Key >: Copies selected variables from zenon to ICCP
  • Key <: Removes selected variables from the ICCP list.

Variables can also be added to the list for zenon by double clicking on the variable for the ICCP list.

Variable name

Allows renaming of the zenon variable names highlighted in the list for ICCP.

Data type

Selection of an ICCP data type for the variables selected in the list:

  • State
  • Real
  • Discrete

Standard display of zenon variables on ICCP:

  • BOOL on State
  • REAL on Real
  • INT on Discrete

Depending on the zenon variables on which they are based, data types can also not be available (grayed out).

Extended type

Selection of an ICCP variable addition for the variables selected in the list:

  • None: none
  • Quality flags: Quality
  • Timestamp: Quality + time stamp
  • Extended: Quality + time stamp + change counter
  • Timestamp Extended: Quality + extended timestamp

Depending on the zenon variables on which they are based, data types can also not be available (grayed out).

OK

Accepts the settings of all tabs, saves the configuration in the zenProcGateway.ini file, starts the ICCP server and waits for incoming connections.

Cancel

Discards all changes in all tabs and closes the dialog.

Help

Opens online help.


Client variables

Manual -> Process Gateway -> ICCP-TASE.2 -> Module configuration -> Client variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Selection and configuration of the variables that are provided on the ICCP client.

Parameters

Description

Available in zenon

List of the variables available in zenon.

Exported to ICCP

List of the variables exported to ICCP. Display:

  • Name in zenon
  • ICCP-Name
  • Type

ICCP name and type can be changed using the Variable name, Data type and Extended type options.

Cursor keys

Moving selected variables between the two lists.

  • Key >>: Copies all variables from zenon to ICCP.
  • Key <<: Removes all variables from the ICCP list.
  • Key >: Copies selected variables from zenon to ICCP
  • Key <: Removes selected variables from the ICCP list.

Variables can also be added to the list for zenon by double clicking on the variable for the ICCP list.

Variable name

Allows renaming of the zenon variable names highlighted in the list for ICCP.

Data type

Selection of an ICCP data type for the variables selected in the list:

  • State
  • Real
  • Discrete

Standard display of zenon variables on ICCP:

  • BOOL on State
  • REAL on Real
  • INT on Discrete

Depending on the zenon variables on which they are based, data types can also not be available (grayed out).

Extended type

Selection of an ICCP variable addition for the variables selected in the list:

  • None: none
  • Quality flags: Quality
  • Timestamp: Quality + time stamp
  • Extended: Quality + time stamp + change counter
  • Timestamp Extended: Quality + extended timestamp

Depending on the zenon variables on which they are based, data types can also not be available (grayed out).

OK

Accepts the settings of all tabs, saves the configuration in the zenProcGateway.ini file, starts the ICCP server and waits for incoming connections.

Cancel

Discards all changes in all tabs and closes the dialog.

Help

Opens online help.


IEC870 Slave

Manual -> Process Gateway -> IEC870 Slave

Language

The driver and its dialogs for configuration are only available in English.

Structure

PLCs addressed with the IEC870SI driver, are divided into sectors. These sectors contain IOs (information objects) representing the actual variables. IOs refer to a variable of the process control system.

You can configure several PLCs with the IEC870SI driver. According to the used protocol, they are associated directly to a Master or polled by a Master.

Identification and addressing

  • 870-101: The PLC is identified by a link address.
  • 870-104: The PLC is identified by the IP address of the Master.
  • Sector: Addressed by COA.
  • IO: Addressed by type identification and IOA.

In the following chapters, you will read how to configure the IEC870SI driver, how communication takes place and you will read about compatibility issues.

info Information

For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Send value via the COM interface in the CEL if the Setting values with VBA property is active (Logging in CEL group).


Module configuration

Manual -> Process Gateway -> IEC870 Slave -> Module configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There are many settings you can change in the IEC870SI driver All lists in the configuration window can be sorted. To change the sorting sequence, simply click on the column title.

Settings:

The settings for protocols 101 and 104 differ.

In the main window, you can choose the protocol you want to use and define general settings:

  • (Protocol) 870-101
    unlocks the settings for protocol 101 and locks all other input fields.
  • (Protocol) 870-104
    unlocks the settings for protocol 104 and locks all other input fields.

Devices

Devices are created and deleted in the Devices section of the main window. These devices are configured in the tabs.

The following device settings are available in Process Gateway for 870-101- and 870-104 protocols:

  • Device,
  • Sector
  • Sequence of Events SOE and
  • 104 settings

info Information

Only the general properties are documented in this section. You can find the protocol-dependent configurations in the section for the respective protocol or in the description of the respective device settings.

Parameters

Description

Settings

Configuration file

Name of the configuration file. This is where all active settings are stored and also loaded from. The name you enter must be a valid file name. Otherwise, no data can be stored. In this case, you will get an error message.

Only enter the file name without path. You do not have to add the file extension XML, as it will be added automatically during saving. The current INI directory will be used as path.

The file name will automatically be entered in the INI file of the process gateway as configuration.
You can find the INI file in the system folder of the process control system. It is called 'SCADAProcGateway.ini' - SCADA is the placeholder for the name of the process control system.

Import...

Loads configuration data from an XML configuration file. The current settings are replaced by the ones stored in the file. The current setting for the 'configuration file' remains the same.

Export...

Stores the current settings in a file.

Attention: Device that still have the default ID '????' (defined during creation) will not be exported. To export them, you must first configure the device in the configuration window "Device".

870-104

activates protocol 104, unlocks all input fields for 104 and locks settings for 101.

871-101

activates protocol 101, unlocks all input fields for 101 and locks settings for 104.

Deactivate standard DPI/DCS mapping and use internal mapping (not recommended).

Deactivates standard communication via DPI (Deep Packet Inspection) and DCS (Distributed Control System) and uses internal mapping for this.
Default: Inactive

Note: Not recommended!

Devices

List of configured devices.

Add

Adds a new device with standard settings. By default, it gets the invalid ID '????' and invalid IP/link addresses. Before you can use or export the device, you must configure it.

Delete

Deletes the selected device. This button is not active if no device has been selected.

Device

Tab for the configuration of the devices

Sector

Tab for the configuration of the sectors

SOE

Tab for the configuration of the sequence of events

104 settings

Tab for 870-104 protocol-specific configuration
Note: Not active if 870-101 is selected as a protocol.

OK

Accepts all changed settings. They will immediately be stored in the current configuration file (as defined in 'Configuration file').
Attention: After clicking on 'OK', all active Master connections will be closed and restarted with the new settings. There may be communication errors during that.

Cancel

Discards all changed settings. Nothing is stored.

Help

Opens online help.


Settings for 870-101

Manual -> Process Gateway -> IEC870 Slave -> Module configuration -> Settings for 870-101

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

info Information

Only the general properties of the 870-101 protocol are documented in this section. You can find further information in the general description of the respective device settings.

Parameters | Description
Settings |
870-104 | activates protocol 104, unlocks all input fields for 104 and locks settings for 101.
871-101 | activates protocol 101, unlocks all input fields for 101 and locks settings for 104.
Port | Port for the communication to the end device. Default: 2404 Note: Inactive if 870-101 is selected as a protocol.
Deactivate standard DPI/DCS mapping and use internal mapping (not recommended). | Deactivates standard communication and uses internal mapping for this. Default: Inactive
Devices | List of configured devices.
Add | Adds a new device with standard settings. By default, it gets the invalid ID '????' and invalid IP/link addresses. Before you can use or export the device, you must configure it.
Delete | Deletes the selected device. This button is not active if no device has been selected.
OK | Accepts all changed settings. They will immediately be stored in the current configuration file (as defined in 'Configuration file'). Attention: After clicking on 'OK', all active Master connections will be closed and restarted with the new settings. There may be communication errors during that.
Cancel | Discards all changed settings. Nothing is stored.
Help | Opens online help.


Settings for 870-104

Manual -> Process Gateway -> IEC870 Slave -> Module configuration -> Settings for 870-104

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

info Information

Only the general properties of the 870-104 protocol are documented in this section. You can find further information in the general description of the respective device settings.

Parameters | Description
Protocol 870-104 | activates protocol 104, unlocks all input fields for 104 and locks settings for 101.
Port | TCP port to which the Masters connect. Defined by the norm as 2404. Our drivers allow you to have several instances of the Process Gateway running at the same time. That is why you can change this port: Allowed port numbers: 1200 to 65.535
Devices | List of configured devices.
Add | Adds a new device with standard settings. By default, it gets the invalid ID '????' and invalid IP/link addresses. Before you can use or export the device, you must configure it.
Delete | Deletes the selected device. This button is not active if no device has been selected.
OK | Accepts all changed settings. They will immediately be stored in the current configuration file (as defined in 'Configuration file'). Attention: After clicking on OK, all active Master connections will be closed and restarted with the new settings. There may be communication errors during that.
Cancel | Discards all changed settings. Nothing is stored.
Help | Opens online help.


XML-File

Manual -> Process Gateway -> IEC870 Slave -> Module configuration -> Settings for 870-104 -> XML-File

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The configuration of the IEC870SI is stored in an XML file. You can import and export different configurations with the buttons 'Export' and 'Import' in the main window.

The active configuration is stored in the INI file, for example:
[IEC 870]
SETTINGS=IEC870SLAVE.XML

You can choose any name. The path is the same as in the INI file.

Structure of the XML file

The names of most fields intuitively indicate their meaning. The settings correspond to those that are permitted in the dialog.

The values and structure of the XML file are verified when the file is read. Erroneous entries trigger an error message that is also logged.

attention Attention

XML entries are case sensitive. Pay attention to use correct upper and lower cases.

Name | Property
process_gateway_IEC870Slave | The root node must have this name. Otherwise, the reading process will stop with an error.
VERSION | Contains the current version of attributes and nodes.
Device_x | Nodes for the device configuration. X is replaced by a consecutive number, starting with 1. This way of naming nodes is not obligatory. A device is created for every node.
LinkAdr | In protocol 101, the 'link address' is set here. It must be unique for all devices. For protocol 104, this entry has no meaning.
IpAdr | In protocol 104, the IP address of the Master is entered here. It must be unique for all devices. For protocol 101, this entry has no meaning.
Sector_x | Number of nodes per configured sector. X is replaced by the COA. This way of naming nodes is not obligatory. A sector is created for every node.
IO_x | Number of nodes per information object. X is replaced by a consecutive number, starting with 1. This way of naming nodes is not obligatory. An IO is created for every node.
ScadaVar | When the document is loaded, the existence of the specified variable in the project is verified. Variables without project reference are looked for in the default project. [ScadaProjectName#]ScadaVariableName. (Scada stands for the name of the process control system.)
TypeId | Type identification. When the document is loaded, the system will check if the type ID with the specified variable data type is possible.
COA | Common object address. Must be unique for every device per sector.
IOA | Information object address. In combination with the type ID, it must be unique per sector.
Is101active | With the value '1', the protocol 101 is activated, otherwise 104 will be active.
BSTime | Time for background scan Unit of measurement: ms. 0 deactivates the background scan. Default: 0
CYTime | time for cyclical data transfer Unit of measurement: ms. 0 deactivates the cyclical transfer. Default: 0 Available in version 2 and above
KindOfTransfer | States the type of data transfer. 0: Spontaneous. Is also the default value. 1: backscan 2: Cyclic 3: off 4: Spontaneous transfer with buffering Default: 0 Available in version 3 and above
DeActDPIStd | DPI /DCS compliant (IEC60870 compliant) data transfer or internal control system format
Version | 6: describes an XML file with the following fields for SOE support
EnableSOE | 0 = inactive 1 = SOE active
MaxBufferedFilesSOE | Maximum number of buffered SOE files.
AutodeleteFilesSOE | 0 = no Autodelete 1 = Autodelete if maximum file number reached
MaxEventsPerFileSOE | Maximum number of ASDUs per file
PostTrgToSOE | Post trigger timeout in [ms]
FileToSOE | File timeout in [ms]
Information Object setting for SOE support | Additional settings that must be made for SOE support at Information Object.
Version | 4: describes an XML file with the following fields for SOE support
KindOfTransfer | Defines when an update triggers a transfer. 0: Spontaneous 1: Background scan 2: Periodic 3: no diffusing
TrgSOE | 0 = inactive 1 = IO acts as trigger
EvDetectionSOE | determines when a change to an IO value or status can trigger a write in the SOE file. 0: SOE active 1: Saves all changes. 2: Raising edges 3: Falling edges 4: Raising and falling edges
HysteresisNegative | Value of the negative hysteresis
HysteresisPositive | Value of the positive hysteresis

Example configuration for protocol 101:

Example configuration for protocol 104:


Double Point Value Mapping

Manual -> Process Gateway -> IEC870 Slave -> Module configuration -> Settings for 870-104 -> Double Point Value Mapping

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Double Point Value Mapping Is a standard function of the zenon Energy driver. It only influences zenon Runtime and has no influence on the driver communication with a device. Configuration is carried out in the driver settings in the Basic Settings tab.

The driver uses Double Point Value Mapping to convert values so that they are displayed in a user-friendly manner. However this only applies to HMIs.

Double Point Values

The driver always communicates with one device with values for Double Points as defined in the Energy Standards with 2-bit information. That means:

Parameters | Double Point | Value | Meaning
Intermediate | 00b | 0 | Switches are neither open nor closed, for example the end position has not yet been reached
Off | 01b | 1 | Switch open
On | 10b | 2 | Close switch/switch closed
Fault | 11b | 3 | Error

Double Points Are coded with 2-bits in the energy sector for historical reasons: The transmission of a telegram to a serial connection (RS232) with a series of values that only contain 0 was not safeguarded against transmission errors. In order to increase the certainty, it was decided in the first standards that the value for OFF is not to be sent as 0 but as 01b, which corresponds to decimal 1. These Double Point Values also precisely reflect the type of how two sensors record the physical position of a switch.

However, the values sent this way may be confusing for people:

  • OFF = 1
  • ON = 2

Humans are used to all other devices and systems:

  • OFF = 0
  • ON = 1

At the same time, single point values are also defined with OFF = 0 in the same standard.

Thus everybody who is involved must always be aware of the technical level on which they are acting and receiving and sending information. In stressful situations, this can very easily lead to serious mistakes. For example, if ON is sent instead of OFF.

In order to avoid this dangerous error, the zenon Energy driver offers its own Double Point Value Mapping.

Mapping

With the Double Point Value Mapping, all Double Points in zenon have the following values:

  • Intermediate = 2
  • Off = 0
  • On = 1
  • Fault = 3

info Information

This function can be deactivated in the driver settings. However some functions such as command processing or ALC can no longer be used then.

Recommendation: Do not use numerical elements and numerical values to display OFF/ON or OPEN/CLOSE. Use combined elements with graphic symbols or text elements instead.

Table Double Point Values

The following is applicable to the Inactive setting of Deactivate standard double point value mapping:
The driver depicts the double point values for Runtime according to the zenon column (stVal : CODED ENUM in DPS and DPC Classes, IEC 61850-7-3).

Position | Position Decimal | position value Binary-string | Transferred Dbpos value (unmapped) | zenon (mapped)
intermediate state | 0 | 00 | 0x00 | 2
off | 1 | 01 | 0x40 | 0
on | 2 | 10 | 0x80 | 1
bad state | 3 | 11 | 0xC0 | 3

This means in Runtime (for example):

Parameters | mapped | unmapped
off | 0 | 64
on | 1 | 128

You can find further information in the chapter entitled: Driver-specific functions


DPI / DCS mapping

Manual -> Process Gateway -> IEC870 Slave -> Module configuration -> DPI / DCS mapping

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

It is possible to configure whether DPI/DCS (double-point information/double command state) should be transferred in accordance with the IEC60870 standard or in the zenon internal display. The default is transfer (between Process Gateway and an IEC 60870 Master) in accordance with the norm.

Setting

Functionality

Deactivate standard

Active: Mapping is deactivated. Values for DPI/DCS correspond directly to the values of zenon.

Inactive: Values for DPI/DCS are mapped as follows, which also guarantees standard behavior for command processing:

  • zenon value 0 = DPI/DCS value 1 (= OFF)
  • zenon value 1 = DPI/DCS value 2 (= ON)
  • zenon value 2 = DPI value 0
  • zenon value 3 = DPI value 3

This setting is automatically activated if an XML File with version 1 is read in.


Devices

Manual -> Process Gateway -> IEC870 Slave -> Module configuration -> Devices

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters | Description
Device | ID of the device Default: ???
Name | Name of the device
Add | Adds a new device with standard settings. By default, it gets the invalid ID '????' and invalid IP/link addresses. Before you can use or export the device, you must configure it.
Delete | Deletes the selected device. This button is not active if no device has been selected.

Devices are created and deleted on the left-hand side of the dialog.

Clicking on the Add button adds a device, which is configured in the Device, Sector, SOE and 104settings tabs. Several devices can be created. A simple click on the respective device in the list opens the attendant configuration.


Device

Manual -> Process Gateway -> IEC870 Slave -> Module configuration -> Devices -> Device

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the part of the main window called 'Device' you can define the settings of the device. Certain areas are grayed out depending on the protocol selected. A precise definition of which input fields are available for which protocol is in the list below.

Parameters

Protocol

Description

Common Settings

Name

101
104

Name of the device for easy identification

File transfer directory

101

104

Defines the directory for transfer of files and directories.

Note: The files are sent to the master.

File Transfer in Control Direction Directory

101
104

Defines the directory in which the files for transfer of files and directories are stored.

Note: These files are received by the master.

All files with the NOF 255 (the temporary NOF for reverse file transfer) are ignored for the directory query.

Short pulse

101
104

Defines the size of the pulse for the Qualifier of Command with the value 'short pulse duration' (QOC = 1) in milliseconds.
Valid values: 0 to 4294967295

Default: 1000 ms
Note: In the debug mode, there will also be a pulse for values greater than/equal to 10000, even with QOC = 0. This allows you to test the pulse generation with our IEC870 drivers.

Long pulse

101
104

Defines the size of the pulse for the Qualifier of Command with the value 'long pulse duration' (QOC = 2) in milliseconds.
Valid values: 0 to 4294967295.

Default: 2000 ms

Max APDU size

104

Maximum length of APDU data as defined in the standard 870-5-104 5.
Valid values: between 25 and 253.

Default: 253

Max. user data

101

Maximum length of user data as defined in TF1.2 870-5-2 3.2 .
Valid values: between (19 + LAF size + COA size + COT size + IOA size) and (255).

Default: 253

Commands active

101

104

This options allows you to activate write access. Process information in control direction are executed. If this options is deactivated, an entry in the error protocol is created.

This setting can be individualized by means of a variable in zenon (IOA 2).

Default: active

870-101 specific

870-101 specific

COA size

101

Defines the length of the COA (common object address). You can only change the COA size for 101. For 104, the value is automatically set to 2, in accordance with the standard.
Selection of address size from drop-down list. Valid:

  • 1 octet
  • 2 octets

Default: 2

COT size

101

Defines the length of the COT (cause of transmission). You can only change the COT size for 101. For 104, the value is fixed as 2, in accordance with the standard.

Selection of address size from drop-down list. Valid:

  • 1 octet
  • 2 octets

Default: 2

IOA size

101

Defines the length of the IOA (information object address). You can only change the IOA size for 101. For 104, the value is fixed as 3, in accordance with the standard.

Selection of address size from drop-down list. Valid:

  • 1 octet
  • 2 octets
  • 3 octets

Default: 3

Link address

101

Link address Via the link address contained in the TF 1.2 frame, the master specifies the device that the command is intended for. With link addresses, a Master can communicate with multiple devices. The allowed range of the address depends on the setting 'links address size' in the main settings.
Link address size = 1 allows a range of 0 to 254
Link address size = 2 allows a range of 0 to 65534

Default: -1

Note: The current value is lost if the protocol is changed.

Master polling timeout

101

Shows the time in seconds in which the master must execute a query to the slave.

If there is no query within this time, the connection is ended.

Default: 0

Note: 0 deactivates the monitoring.

870-104 specific

IP-Adress

104

IP address of the Master. This allows to identify the device that the Master communicates with. All IP addresses except 255.255.255.255 are allowed.

Note: The current value is lost if the protocol is changed.


Sector

Manual -> Process Gateway -> IEC870 Slave -> Module configuration -> Devices -> Sector

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Sector tab lists all sectors defined in the device. If you select a sector, its Information Objects (IOs) will be displayed.

Parameters | Description
Sectors |
New | Activates the dialog for creating a new sector. You close this subsequent dialog and create a new sector by clicking on OK.
Edit | Activates the dialog for editing the selected sector. You can also launch the editor by double-clicking on the sector in the list. This button is inactive if no sector was selected.
Delete | Deletes the selected sector. This button is inactive if no sector was selected.
Information Objects |
New | Activates the dialog for creating new IOs. This subsequent dialog is closed and a new IO is created by clicking on 'OK'. This button is inactive if no sector was selected.
Edit | Activates the dialog for editing the selected IO. You can also launch the editor by double-clicking on the IO in the list. This button is inactive if no IO was selected.
Delete | Deletes the selected information object. This button is inactive if no IO was selected.


Sector Settings

Sector Settings

Parameters

Description

Sector Settings

Name

Any name. For easy identification of a sector.

COA

The COMMON ADDRESS OF ASDUs (IEC 60870-5-101 7.2.4) by which the sector is addressed.
This number must be unique on the device side (1..254).

Time for Background scan [min]

Supports the requirements of IEC 60870 Norm Chapter 7.4.13 "Background Scan". The values are sent with COT = 2. Cycle time is stated in minutes.

Values are transferred cyclically in the time grid set up for all IOs with the "Background Scan" option activated.

Values are only transferred cyclically if no spontaneous value is transferred within the time set.

If the value is "0", cyclical transfer of values is deactivated for this sector.

Time for periodic transfer [s]

Support of cyclical data transfer corresponding to the norm (IEC 60870-5-5 6.3). The values are sent with COT = 1. Cycle time is stated in seconds.

Values are transferred cyclically for all IOs with the "Periodic data transfer" option activated. IOs are transferred cyclically and not spontaneously.

If the value is "0", cyclical transfer of values is deactivated for this sector.

Select before execute

If active, a prior select is necessary for an execute.

SBE Timeout [s]

Timeout in seconds within which the select sequence must be ended and an execute must be carried out.
Inactive if Select before execute is not active.
Default: 30 s
Input range: 1 to 65.535

Transmition of integrated totals

Selection of the transfer mode (see IEC 60870-5-101 7.4.8) for the integrated totals - the IOs of type:

  • 15 (M_IT_NA_1)
  • 16 (M_IT_NA_1)
  • 37 (M_IT_NA_1)

No reset is supported. An FRZ with a reset triggers a warning.

For modes A to D, IOs are requested immediately after connecting to the master of zenon/zenon Logic. Value changes to integrated totals IOs are administered in their own buffer. This can buffer the larger value of (IT IO number) * 4, or 2048 value changes.

With general interrogation

Integrated Totals are also transferred during a general interrogation (C_IC_NA_1).

Mode A: Local freeze with spontaneous transmission

Integrated totals are transferred when a value is changed.

Mode B: Local freeze with counter interrogation

Integrated totals are only transferred with a counter interrogation command (C_CI_NA_1). To do this, a maximum of five seconds is waited after the interrogation is activated until all ITs have been supplied with values. ITs without a value are transferred with an invalid qualifier. The value changes are buffered until the interrogation is completed (freeze active). All ITs thus transfer the value of the point in time, when the last IT was supplied with a value.

Mode C: freeze and transmit by counter interrogation Transmition of integrated totalscommands

As with mode B.

Mode D: freeze by counter interrogation command, frozen values spontaneous

Transfer as with mode C, mode A is activated after conclusion of the interrogation.

OK

By pressing the button OK, you can check whether the COA is available in the device. If it is already in use you will receive an error message. If it is available, the setting is accepted and the dialog is closed.

Cancel

Discards all entries and closes the dialog.

Help

Opens online help.


Information Objects

Information Objects

Parameters

Description

Settings

Information Object

Defines the address under which the IO is addressed (IEC 60870-5-101 7.2.5). In combination with the type ID (Type identifications), it must be unique for each sector.

Default: 1

Type identification

Drop-down list with the supported Type identifications (IEC 60870-5-101 7.2.1).

Default: <0> Internal status

This setting is also called type ID.

It also determines the variables of the process control system that can be associated to the IO based on their data type.

Note: You can also find more detailed information on type ID in the chapters Assignment of data types and Interoperability.

SCADA variable

Defines the variable from the process control system associated with the IO.
Syntax: <Project name>#<variable name> define the project connection.
Variables without project reference are looked for in the default project.
While entering, the system checks if the specified variable exists in the according project and if it has a data type compatible with the type identification.
The Button '...' opens the dialog for variable selection.
Read more about this in the section 'Variable selection'.
(Scada stands for the name of the process control system.)

Data Transfer

Determines the type of data transfer for IOs

Default: Spontaneous

Spontaneous

IO data transfer is spontaneous.

Background Scan

IOs are transferred as a background scan in accordance with the IEC 60870 norm. A data point that does not receive a new spontaneous value within the set background scan time is automatically sent by the gateway after the time has expired. Values are only transferred if no spontaneous value has yet been transferred within the time set.

The setting is inactive if the background scan is locked at the sector (Time=0) or if the type ID used does not support the background scan.

M_SP_TA_1, M_SP_TB_1, M_DP_TA_1, M_DP_TB_1, M_ST_TA_1, M_ST_TB_1, M_ME_TA_1, M_ME_TB_1, M_ME_TC_1, M_ME_TD_1, M_ME_TE_1, M_ME_TF_1, M_BO_TB_1, M_BO_TA_1

For these type IDs, they are mapped to the corresponding TID without a time stamp when the background scan is sent.

The setting is not available for any other type ID.

Periodic Data Transfer

Periodic data transfer in accordance with IEC 60870-5-5-6.3 norm.

IOs are transferred cyclically and not spontaneously.

The setting is inactive if periodic data transfer is locked for the sector (Time=0) or if the type ID used does not support periodic data transfer.

The type ID =9,11,13 supports periodic transfer:

M_ME_NA_1, M_ME_NB_1, M_ME_NC_1

The setting is not available for any other type ID.

Off

Changes in value are not transferred. No value is sent for the IO during a general interrogation (GI).

Spontaneous, buffered when master is offline

The data is buffered until it can be read by the master again. All buffered data is sent with the status COT_spont (3). The last buffered value is sent with the status COT_inrogen (20) again.

Buffering can be activated for the type IDs <30..37>:

M_SP_TB_1, M_DP_TB_1, M_ST_TB_1, M_BO_TB_1, M_ME_TD_1, M_ME_TE_1, M_ME_TF_1 und M_IT_TB_1

The setting is not available for any other type ID.

Sequences of events

These settings define the IO-specific behavior for SOE. The SOE transfer (see IEC norm 60870-5-101 7.4.11.3.1) can also be activated for the type IDs <30..37>:

M_SP_TB_1, M_DP_TB_1, M_ST_TB_1, M_BO_TB_1, M_ME_TD_1, M_ME_TE_1, M_ME_TF_1 und M_IT_TB_1

Default: Inactive

Inactive

Data point is not used for SOE description.

Is automatically used for all type IDs that do not support SOE.

All events

Each value or status change triggers a write in the open file.

The setting is blocked if the type ID if not planned for the SOE function.

Raising Edge

If the value changes from 0 to <> 0, then it triggers the write mode in the open file.

The setting is blocked if the type ID if not planned for the SOE function.

Falling Edge

If the value changes from <> 0 to 0, then it triggers the write mode in the open file.

The setting is blocked if the type ID if not planned for the SOE function.

Raising + Falling Edge

A change of value from 0 to <> 0 or from <> 0 to 0 triggers a write in the open file.

The setting is blocked if the type ID if not planned for the SOE function.

File trigger

If a value is to be written due to the settings previously described, a new file is created and opened for the activated file, provided this has not yet been opened. The trigger event itself is also written to the SOE file.

The setting is blocked if the type ID if not planned for the SOE function.

Default: Inactive

Hysteresis

Value changes that are within the hysteresis are not transferred for the permitted TID if they have the Spontaneous selection.

A transfer is therefore triggered:

  • If type identification allows hysteresis.
    The type identifications <9> to <14> and <34> to <36> are not permitted.
  • With spontaneous transfer
  • With a value change that acts >= the hysteresis (according to the direction).

Negative

Negative Hysteresis, from measuring range

Default: 0

Note: only active if type identification is not <9> to <14> or <34> to <36>. This field is also inactive if the value Data Transfer is not spontaneous.

Erroneous and meaningless entries (such as text input or incorrect hysteresis values) are ignored and must be taken into account by the person configuring the project.

Positive

Positive hysteresis, from measuring range

Default: 0

Note: only active if type identification is not <9> to <14> or <34> to <36>. This field is also inactive if the value Data Transfer is not spontaneous.

Erroneous and meaningless entries (such as text input or incorrect hysteresis values) are ignored and must be taken into account by the person configuring the project.

OK

Your settings are verified after pressing the button "OK". If they are valid, they are accepted and the dialog is closed.

Cancel

Discards all entries and closes the dialog.

Help

Opens online help.

Note: The XML file of the configuration must, from zenon 7.11 onwards, contain the entry HysteresisNegative and HysteresisPositive for each IO.

info Information

The communication for Spontaneous data transfer, Background Scan and Periodic Data Transfer starts once the first general request has been received (C_IC_NA_1). For background scan and periodic data transfer, the start of the transfer cycle is calculated per IO from the time of the answer to the general query.


Data point selection

Data point selection

This dialog lists all available projects and their variables.

Parameters

Description

Projekte

An asterisk (*) marks the default project.

Variablen

The list of variables is filtered. You only see the variables that can be used with the 'type identification' selected for the IO. Selecting a project updates the list of variables.

OK

Assumes the selected variable. Alternatively, the variable can be assumed by double clicking. When loading, the currently configured project and the variable will be selected.

The same variable can be used several times:
for several IOs in the same sector or other sectors,
for the same device or another one.

If the dialog remains open and there is a reload in the Runtime, all lists will be emptied and refilled after the reload is finished.

Cancel

Discards all entries and closes the dialog.

Help

Opens online help.


Mapping of the data types

Mapping of the data types

The zenon data types are compared to the IEC60870 data types in the following table.

Process Gateway |  | zenon
IEC 60870-5-101 ASDU | Type identification | Data type | Comment
M_SP_NA_1 | 1 | BOOL |
M_SP_TA_1 | 2 | BOOL |
M_SP_TB_1 | 30 | BOOL |
M_DP_NA_1 | 3 | USINT |
M_DP_TA_1 | 4 | USINT |
M_DP_TB_1 | 31 | USINT |
M_ST_NA_1 | 5 | USINT | Corresponds to whole VTI (IEC60870-5-101 7.2.6.5). Bit 8 is the Transient bit.
M_ST_TA_1 | 6 | USINT | See above
M_ST_TB_1 | 32 | USINT | See above
M_BO_NA_1 | 7 | UDINT |
M_BO_TA_1 | 8 | UDINT |
M_BO_TB_1 | 33 | UDINT |
M_ME_NA_1 | 9 | REAL | If, in zenon, values of the variables in the norm range for 'normalized values' <-1 .. 1-2-15> are gone below or exceeded, the value of the IO is amended in ASDU and the OV quality bit is set.
M_ME_TA_1 | 10 | REAL | See above
M_ME_TD_1 | 34 | REAL | See above
M_ME_NB_1 | 11 | INT |
M_ME_TB_1 | 12 | INT |
M_ME_TE_1 | 35 | INT |
M_ME_NC_1 | 13 | REAL |
M_ME_TC_1 | 14 | REAL |
M_ME_TF_1 | 36 | REAL |
M_IT_NA_1 | 15 | DINT |
M_IT_TA_1 | 16 | DINT |
M_IT_TB_1 | 37 | DINT |
M_EI_NA_1 | 70 | USINT | A value change from 126 to 127 causes End of initialization to be sent to the master
C_SC_NA_1 | 45 | BOOL | mirrors the command direction during execution
C_SC_TA_1 | 58 | BOOL | See above
C_DC_NA_1 | 46 | USINT | See above
C_DC_TA_1 | 59 | USINT | See above
C_RC_NA_1 | 47 | USINT | See above
C_RC_TA_1 | 60 | USINT | See above
C_SE_NA_1 | 48 | REAL | See above
C_SE_TA_1 | 61 | REAL | See above
C_SE_NB_1 | 49 | INT | See above
C_SE_TB_1 | 62 | INT | See above
C_SE_NC_1 | 50 | REAL | See above
C_SE_TC_1 | 63 | REAL | See above
C_BO_NA_1 | 51 | UDINT | See above
C_BO_TA_1 | 64 | UDINT | See above
C_IC_NA_1 | 100 | - | Is executed automatically and the execution is not reflected in zenon
C_CI_NA_1 | 101 | - | Is executed automatically and the execution is not reflected in zenon
C_RD_NA_1 | 102 | - | Is executed automatically and the execution is not reflected in zenon
C_CS_NA_1 | 103 | BOOL | The enable variable of the time synchronization
C_TS_NA_1 | 104 | - | Is executed automatically and the execution is not reflected in zenon
C_TS_TA_1 | 107 | - | See above
C_RP_NA_1 | 105 | USINT | QRP during execution
F_DR_TA_1 | 126 | USINT | For spontaneous directory transfer


Sector

Sector

XML fields

Parameters

Description

Version

The CNT_MODE field is expected from version 3 onwards.

CNT_MODE

Configured mode of integrated totals IOs.

Sector

The new items ToSBe and ob SBE are added for the sector:

  • ToSBe:
    Timeout [ms] for Select before execute: 1000 - 65535000
  • SBE:
    0 => not required 1 => necessary for execute

Configured mode

Parameters | Description
0 | With general interrogation. (Default)
1 | Mode A
2 | Mode B
3 | Mode C
4 | Mode D

Error codes

Code | Description
13 | Advise for integrated totals fail.
14 | Queue overrun. Integrated totals values lost.
16 | Advise failed for command variable
17 | List of value changes for command variables with SBE too long. Value change has been lost. 2048 value changes are buffered as a minimum, or four times the number of active Select Before Execute (SBE) - depending on which value is greater.
572 | Counter interrogation. Unsupported QCC.
573 | Counter interrogation. Unexpected IOA.
574 | Counter interrogation. Unsupported COT.
575 | Buffer for integrated totals interrogation data too small.

Warnings

Code | Description
1011 | QCC FRZ is only partly supported.
1012 | Counter interrogation already active.
1014 | Activation confirmation already confirmed.

Error message

Message | Description
Unsupported qualifier of counter interrogation. <command> | Unknown QCC. RQT is only supported with 5.
Counter interrogation processed without reset. < command> | Warning. Reset is not supported.
Can't advise IT data point. Device:(<device>)<device> Sector:(<COA>)<Sektorname> adv:0x<Advise-ID> | Data points for integrated totals could not be requested.
IT Values lost, queue full! Device:(<device>)<device> Sector:(<COA>)<Sektorname> <Wertänderung> | The buffer for the value changes of IT IOs is full. The value change is lost.


104 settings

Manual -> Process Gateway -> IEC870 Slave -> Module configuration -> Devices -> 104 settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Set the timeout times and APDUs in the 104 tab.

Note: The input fields of this tab are only available if 870-104 has been selected as a protocol.

Parameters | Description
Timeouts | Timeout settings of the connection
T0: time-out of connection establishment | Timeout for establishing connection. Value range 0 - 4294967295 Default value: 30000
T1: Time-out send or test APDUs | Time-out for frame confirmation by the master. Value range: 0 - 4294967295 Default value: 15000
T2: Time-out for ack. in case of no data msg | Time-out, within which the master should confirm if no data is exchanged. Value range: 0 - 4294967295 Default value: 10000
T3: Time-out for sending test frames | Time after which a U-frame is sent to the master if no data is to be transferred. Value range: 0 - 4294967295 Default value: 20000
APDUs | Settings for the ISO 7816 standard: Application Protocol Data Unit (APDU).
k: Maximum difference receive sequence nr to send state | Number of maximum I-frames not yet confirmed by the master. Value range: 0 - 4294967295 Default value: 12
w: Latest acknowledge after receiving w I-Format APDUs | Number of I-frames received after a confirmation is sent. Value range: 0 - 4294967295 Default value: 8

info Information

The Reset to default button resets all input to the default values


Communication

Manual -> Process Gateway -> IEC870 Slave -> Communication

This chapter explains details on the communication in the Process Gateway:

  • Play
  • General interrogation
  • Reset
  • Value changes
  • Priority
  • Read
  • Process Initialized
  • File transfer
    • Storage and naming of files for transfer
    • Spontaneous directory transfer
  • Sequence of Events (SOE)
    • Warnings
    • Error message
  • Time synchronization
  • DPI / DCS mapping
  • Select Before Operate
  • Qualifier of command
  • Invalid Bit Handling
  • Normalized Values
  • Monitoring command
  • Internal type T00
  • Pulse generation
  • Reload project online
  • Broadcasts
  • Realtime invalid - Statusbit T_INVAL
  • Test commands


Start:

Manual -> Process Gateway -> IEC870 Slave -> Communication -> Start:

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When the process gateway is started, it loads the configured driver.

The driver then attempts to read its active configuration from the file entered in the INI file. If this is not possible, an error message is displayed and the configuration dialog is opened.

If the dialog is not left with OK, the application closes.

attention Attention

If the application is launched as invisible, there will be no configuration dialog. The Process Gateway will automatically quit if its configuration is invalid or missing.


General query

Manual -> Process Gateway -> IEC870 Slave -> Communication -> General query

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The general query triggers an establishment of the connection to zenon Runtime in the IEC870 slave. The receipt of the GI - C_IC_NA_1 - from a master is a requirement for spontaneous communication, background scan and periodic data transfer. This connection is built up in sectors.

If the connection cannot be established in Runtime, there is a negative confirmation of the general query. A query that is already active for the sector is ended and a warning is logged.

Value changes for IOs whose value has already been reported to the master are buffered as long as the GI is running.

During a project reload, it is not possible to connect to the RT. The general request will fail in this case.

attention Attention

In accordance with the IEC60870 standard, a master must start communication with a general query. For this reason, the slave closes the connection if the master has not sent a GI in the envisaged time.


End of connection and resets

Manual -> Process Gateway -> IEC870 Slave -> Communication -> End of connection and resets

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The reset in the slave is triggered if a master connects:

  • 870-101: All commands will be rejected until the function code for reset (0) has been received. The code causes a reset in the link layer and the application layer.
  • 870-104: As a result of the connection being disconnected, a master can detect the interruption immediately and starts the initialization process again.

Ending communication

In general, communication is ended if:

  • The Process Gateway application is ended
  • Changes to the configuration of the slave are activated
  • Runtime reloads
  • the master has established the connection but no general query was sent
  • The list of the value changes that have not been sent for the sector has overflowed
  • A non-supported command has been received (command is answered in the negative and the connection is ended for security reasons).
  • A command with a non-supported address is received (command is answered in the negative and the connection is ended for security reasons).


'Reset process command' - T105 - request

Manual -> Process Gateway -> IEC870 Slave -> Communication -> End of connection and resets -> 'Reset process command' - T105 - request

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The slave can inform <CD_PRODUCKNAME> Runtime of the receipt of a C_RP_NA_1 command. To do this:

  • create an IO of type T105with IOA 0.

If a master is sent the command C_RP_NA_1, the value of the variable is set to 0 and then to the value of QRP.

The slave confirms receipt of the command to the master and changes the value of the corresponding T105 variable for Runtime but otherwise the command has no effect in the slave. The optional sending of the 'End of initialization' (T70) is not executed automatically.


'End of Initialization' - T70 - send

Manual -> Process Gateway -> IEC870 Slave -> Communication -> End of connection and resets -> 'End of Initialization' - T70 - send

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

From the process control system, it is possible to instigate an ASDU<70> - M_EI_NA_1 ('End of initialization') being sent to the master. To do this:

  • create an IO of type T70 with IOA 0.

The transfer is triggered if the current value of the variable is 126 and this is amended to 127. As COI (Cause of initialization), 2 (remote reset) is used.


Transfer of the value changes

Manual -> Process Gateway -> IEC870 Slave -> Communication -> Transfer of the value changes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The IEC870 slave receives, from zenon Runtime, all value changes of the requested variables. Because, as a result of this, the list of process information that has not yet been transferred to the master can become very large, the list of outstanding value changes is limited.

Limit: at least: 2048 values or 4 x number of IOs per sector.

If a master receives the values more slowly than they are generated in the process control system, the list can exceed this maximum. The slave can then no longer buffer the value changes that have not yet been transferred. The slave therefore terminates the connection to the master. The master is thus requested to obtain the next connection with a general query, so that it gets current, only recent variable values.

attention Attention

The Master must be able to recognize a communication interrupt, so he can react with a new general request. This is why no process commands will be executed until the Master has caused a reset.

Every time there is a chance of data loss (value changes were lost), a reset will be triggered.


Reload project online

Manual -> Process Gateway -> IEC870 Slave -> Communication -> Reload project online

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If one of the projects is reloaded in the zenon Runtime, the connection to all projects using the IOs in the sector will be closed. The device (Device) with the according sector must be reset. That means: The connection to the master is closed.

While the reload is active, you cannot establish a connection to the Runtime. This means that general requests are also not possible.


Data priorities

Manual -> Process Gateway -> IEC870 Slave -> Communication -> Data priorities

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The driver supports class 1 and class 2 files.

Spontaneous communication, background scan and periodic data transfer belong to class 1.

The whole file transfer is treated as class 2. This makes sure that value changes will be transferred to the Master even during a file transfer.


Internal type T00 (status variable)

Manual -> Process Gateway -> IEC870 Slave -> Communication -> Internal type T00 (status variable)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The internal type T00 is used for communication between the Slave and the process control system.

For the status variables, each numeric zenon variable can be assigned, for example internal drivers.

IOA 1

The variable provides the status information as to whether there is already a connection to the master. Create an IO of type T00 with IOA 1. If a connection is established, the value will change from 0 to 1.

IOA 2

A decision as to whether commands are carried out in control direction can be made for each sector by means of a zenon variable for each sector. For rejected commands, a master receives COT_actcon (7) + PN as confirmation. Rejected commands create a warning in the log.

The zenon variable must be of UINT or DWORD type and is assigned with T00 at IOA . If the value of the variable is = 1, the commands are approved. The variable must not have the status INVALID. The commands are always approved if no IO is configured.

This setting can be set globally using the Commands active property.

The enhanced meaning of the IOA 2 variable:

Value | Description
0 | Commands are rejected; sets PN bit
1 | Commands are approved
2 | Silent mode: accept without execution or error message
3.... | Reserved for future versions

info Information

Attendant warning message:

Commands for sector deactivated, execution prohibited. <Command text>

Warning: 1009 command in control direction was received, but rejected due to a missing enable.

IOA 3

Status variable is set to 1 if the number of SOE files in the transfer directory exceeds the maximum number of buffered files.

IOA 4

Variable provides status information on the current or most recently processed SOE file:

0 - initialization. As long as no SOE file was written.

1 - SOE file is opened

2 - file was closed

3 - too many SOE files in the directory

4 - error when writing the SOE file

5 - errors when creating the SOE file

IOA 5

Variable provides status information by means of file transfer in Monitoring Direction ("Standard Direction" - from the master to the slave).

0 - no transfer active

1 - section is selected

2 - section is requested

3 - waiting on section confirmation

4 - waiting on confirmation of file transfer

255 - error when transferring

IOA 6

Variable provides the number of SOE files present in the transfer directory.

IOA 7

Variable provides status information by means of file transfer in Control Direction ("Reverse Direction" - from the slave to the master).

The information is integrated in a DWORD as follows: [IOA of the transferred files] * 256 + [status information].

Possible status information:

1 = transfer is ongoing

2 - Transfer is ongoing - the transfer that had not been completed beforehand is terminated by the transfer that has currently been started.
Status 3 is also written for the transfer that has been terminated. However because the new status is immediately written afterwards, it cannot be guaranteed in the case of zenon that this is visible in Runtime.

3 - Transfer was terminated due to an error.

4 - File transfer was completed and file is available.


Time synchronization

Manual -> Process Gateway -> IEC870 Slave -> Communication -> Time synchronization

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order for time synchronization to be carried out - on receipt of C_CS_NA_1 , there must be, at any desired Device/Sektor a type T103 IO connected to a process variable. The first IO that uses type T103 is used as an enable.

This variable must have a value of <> 0 and must not have any of the following status bits set:

  • INVALID (Bit 18)
  • OFF (Bit 20)
  • ALT_VAL (Bit 27)
  • BL_870 (Bit 44)

Non execution of the command due to a missing enable (value 0 or status) does not lead to the connection being terminated, the command is only confirmed negatively - COT_actcon + PN.

The missing configuration of the enable variable or the missing value of the enable variable leads to the connection being lost when the C_CS_NA_1 command is received.


Broadcasts

Manual -> Process Gateway -> IEC870 Slave -> Communication -> Broadcasts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Global address 0xFF(FF) in the Common Address of ASDU (COA) is supported for the following Typ IDs:

  • C_IC_NA_1 - General query - ASDU<100>
  • C_CS_NA_1 - Time synchronization - ASDU<103>

No additional project configuration steps are necessary for this.

attention Attention

For Data Link Layer, the Broadcast Adress 0xFF(FF) - "all outstations" is not supported in 60870-4-101 communication.

The Broadcast Adress 0xFF(FF) - "all outstations" - in Data Link Layer in 60870-4-101 communication is not supported.


Mapping of status bits in message direction

Manual -> Process Gateway -> IEC870 Slave -> Communication -> Mapping of status bits in message direction

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The IEC870 slave supports the sending of quality bits for the information objects. The quality bits of the IO are set - in ASDUs in 'monitor direction' - using certain status bits of the linked zenon variable.

The quality bits are assigned to the status bits of the variables as follows:

Status bit in zenon | IEC60870 quality descriptor bits | Notes
INVALID | IV (invalid) NT (not topical) | The slave forwards the INVALID status bit in message direction as two quality bits.
OFF | IV (invalid) |
OV_870 | OV (overflow) | OV_870 status bits that already have the variables in zenon are sent to the master. If values for Normalized Values (T09) go below or exceed the norm range <-1 .. 1-2-15>, the OV quality bit is set, even if the variable does not have the status bit in zenon.
BL_870 | BL (blocked) |
SB_870 | SB (substituted) |
ALT_VAL | SB (substituted) | Up to zenon version 7.10, it is mapped the same as the OFF bit.
NT_870 | NT (not topical) |
T_INVAL (time invalid) | Only in "Binary Time 2a" (CP24Time2a/CP56Time2a) BS[24]- IV (invalid) | The slave forwards the T_INVAL status bit in the time stamp of the IOs with "time tag" only.


Commands

Manual -> Process Gateway -> IEC870 Slave -> Communication -> Commands

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A command received - T45..T64 - is set as the value for the zenon variables. In sectors without Select routing, a confirmation, which is always positive, is always sent to the master immediately - COT_actcon (7) and COT_actterm (10).

In such sectors, a Select is also immediately also confirmed automatically - COT_actcon + SE and the zenon variable change neither the value nor the status bit.


Select routing

Manual -> Process Gateway -> IEC870 Slave -> Communication -> Commands -> Select routing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Select routing can only be used together with command module - auto/remote actions.

If Select routing was configured for the sector being addressed, there is a wait in receipt of a Select until, via the command variable of zenon, the status SE_870 is acknowledged with COT_actcon (7) and possibly with N_CONF (corresponds to PN).

Only once this has happened is a confirmation to the master (for example a Control Center) triggered. All others for this IO are rejected as long as a selection is taking place.

Timeout, cancel and missing select

The following rules apply for the different possibilities for responding to a Select routing :

  • If Select routing is configured on a sector, one Select Timeout per IO is started for each Select.
  • The slave checks whether the Timeout has expired and then sets the variable to SE, COT_actterm (10) and PN.
  • If a Cancel - COT_deact (8) is received by the master for an ongoing Select , confirmation is provided with COT_deactcon (9) and the Select is deleted.
  • If an Execute or Cancel is received without a Select beforehand, it is responded to with PN - negative.


Pulse generation - 'Qualifier of Command'

Manual -> Process Gateway -> IEC870 Slave -> Communication -> Commands -> Pulse generation - 'Qualifier of Command'

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The IEC870 slave supports pulse generation for commands received. The Qualifier of Command (QoC) is supported for all commands envisaged in the IEC60870 standard (T45,T46,T47 and T58,T59,T60).

For example, an individual command received - an ASDU of type T45 - with QoC has the following effect on a zenon variable:

  • QoC 0: Undefined in accordance with IEC standard. Behaves in slave as in QoC 3 persistent output.
  • QoC 1: Short pulse. The zenon variable assumes the value 'ON' and changes, after the time defined in the Process Gateway settings to 'OFF'.
  • QoC 2: Long pulse. The zenon variable assumes the value 'ON' and changes, after the time defined in the Process Gateway settings to 'OFF'.
  • QoC 3: Persistent output. The zenon variable assumes the value 'ON' (or 'OFF') and retains the value. This must be reset to receive further commands.

As soon as communication is ended, the pulse for all other active pulse variables will be stopped (i.e. an OFF will be written). If a pulse is triggered for a running pulse generation, the active pulse generation will be stopped. The variable contains the value 'OFF'.

Note: For SCS (single command state), the value 'OFF' is always 0, for DCS (double command state) an 'OFF' is 00b at protocol level, then 2 or 0 in zenon, depending on the "DPI/DCS mapping" setting.

Note: In sectors with Select routing , pulse generation cannot be carried out because 'OFF' after Select is in conflict with Execute .


File transfer

Manual -> Process Gateway -> IEC870 Slave -> Communication -> File transfer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following applies for file transfer:

  • The values 1-4 are supported in the AFQ UI4
  • The values 0-6 are supported in the SCQ UI4;
    0 and 1 are both 'select file'

If a new transfer is started while another one is still active, the currently active transfer will be interrupted and the new one will be started.


Storage and naming

Manual -> Process Gateway -> IEC870 Slave -> Communication -> File transfer -> Storage and naming

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Use the following scheme for storage and naming:

<Configured folder>\<COA>\<IOA>.<NOF>

Only 1 = 'Name of file' is supported as NOF (transparent file).
The maximum size of files for transfer is 16.711.680 Bytes.

Example

Folder in the module configuration: C:\TEMP\IEC870

File 1100.1: For IO of sector COA=151 and IOA 1100

Save location: C:\TEMP\IEC870\151\1100.1


Spontaneous directory transfer

Manual -> Process Gateway -> IEC870 Slave -> Communication -> File transfer -> Spontaneous directory transfer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Spontaneous transfer of files in the folder for file transfer can be triggered by the process control system. To do this:

  • create an IO of type F_DR_NA_1 (T126) with IOA '0'.
Value | Meaning
Change from 1 to 2 | Starting transfer
3 | Transfer active
4 | Transfer finished
5 | Transfer failure

Nested activation is prevented.


Sequence of Events (SOE)

Manual -> Process Gateway -> IEC870 Slave -> Communication -> Sequence of Events (SOE)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Settings in the main SOE window:

Parameters | Description
Use sequences of events | If active, the SOE for the selected device is activated. If inactive, all SOE settings to the IOs are ignored. Default: inactive

File settings per sector

Parameters | Description
Buffered SOE Files | If the number set for SOE files in the folder is reached for the sector, a spontaneous directory transfer (type ID "F_DT_TA_1") is triggered. If the number of files in the folder is doubled, the oldest file will start to be deleted (ring buffer function). Value range 1 to 1024. Default: 1024
Events per File | Number of value changes that are written in a file before it is closed. Value range: 1 to 4096. Default: 512
Automatically delete SOE file | If active, the reaction is that this is then automatically closed for type ID "F_AF_NA_1" (confirmation for file) for an SOE file.

Time-outs

Parameters | Description
Post trigger timeout | If no ASDU is written to the file within this period of time, this is then closed. The time period starts over with each ASDU written. Value range: 100ms to 120000ms Default: 1000ms
File timeout | Maximum time for which the file remains open (regardless of the number of events). Value range: 100ms to 120000ms Default: 5000ms

First value

The exchange of data for SOE starts immediately once the Gateway has been initialized. The exchange of data for data in monitoring direction only starts when a master has connected and triggered a general interrogation (GI). The first value that is initialized does not trigger an event and is thus also not entered into the file. The same applies if Runtime is again ready to exchange data after reloading.

File transfer

As part of the SOE function for transparent (1), event (3) is also supported as NOF.

Files are not transferred automatically if the maximum number of SOE files to be buffered is exceeded.

The IEC 60870 norm describes this with "may be activated". The Gateway does not support any file transfers activated by the salvo in the current version.

Directory Transfer

As part of the SOE function for transparent (1), event (3) is also supported as NOF.

Automatic directory transfer:

In accordance with the IEC 60870 norm, an automatic spontaneous directory transfer is activated for the following reasons with existing SOE files:

  • 24 hours after the last automatic directory transfer.
  • if the master connects
  • if the maximum number of files to be buffered is exceeded


Warnings

Manual -> Process Gateway -> IEC870 Slave -> Communication -> Sequence of Events (SOE) -> Warnings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Warning message | Meaning
Sequences of events for device <Devicename> sector <Sectorname> are activated but no trigger defined | The device has SOE activated, on the server there is an IO with SOE active but the trigger was not activated for any IO. No file is created without a trigger. At least one IO must have the trigger activated for the sector.
SOE value change without trigger and file is closed. Value lost! Device:(<Device ID>)<Device-Name> Sector:(<COA>)<Sector name> <Value information> | A value change was not written because the SOE file is not open. Code:1010


Error message

Manual -> Process Gateway -> IEC870 Slave -> Communication -> Sequence of Events (SOE) -> Error message

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Error message | Meaning
Sequence of events active but no directory for the file transfer defined! | SOE files are archived in the file transfer folder. Therefore a folder for file transfer must be present.
SOE values lost, queue full! Device:(<Device ID>)<Device-Name> Sector:(<COA>)<Sector name> <Value information> | for IOs that have a SOE activated, data is exchanged to the stack via a queue. This can assume a value of 2048 or 4 * the number of SOE IO’s in sector entries. If this number is exceeded, this error message is created and the value change is lost. Error code: 6
Can't create subdirectory for file transfer. Device:(<Device ID>)<Device name> Sector:(<COA>)<Sector name> system error:<System error code> | The subfolder for the sector is automatically created for SOE in the folder for file transfers. This error shows that this folder could not be created. SOE then indicates that this sector is NOT available. Error code: 10
System error code | Contains the error code returned from the operating system.
Can't advise SOE data point. Device:(<Device ID>)<Device name> Sector:(<COA>)<Sector name> adv:0x<Advise ID> | Data point request for SOE IOs failed. SOE then indicates that this sector is NOT available. Error code: 11
Write asdu to file <Filename> fail! Device:(<Device ID>)<Device name> Sector:(<COA>)<Sector name> <Value> system error: <System error code> | ASDU write to SOE file failed. Error code: 8
Illegal file name <Filename> detected! Device:(<Device ID>)<Device name> Sector:(<COA>)<Sector name> | Filenames for the file transfer have a defined format <IOA>.<NOF>. The file does not adhere to this convention. Error code: 12
Auto delete for file failed! System error: <System error code> <File transfer information> | Error code: 9
File transfer information | Contains the information that identifies the file transfer.


LOG entries

Manual -> Process Gateway -> IEC870 Slave -> Communication -> Sequence of Events (SOE) -> LOG entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The sequence of events writes the following entries to the LOG file

Parameters | Description
deviceIp: | IP address from the device
devicename: | Name of device
COA: | Care of Address -> according to standard
SecName: | Sector description
TypeyId: | Command number
TypeIdAsTxt: | Command as text
IOA: | According to standard
AdviseID: | ID via which value changes are requested and assigned
Value: | Value transferred
TimeStamp: | Time of value change. From the driver or command
QUALDESC: | According to standard
SBEValue: | COT, select and pn mapped to unique enums: 0: Not select relevant 1: actcon+pn+select 2: actcon+select 3: deactcon+pn+select, 4: deactcon+select 5: actterm+pn+select, 6: actterm+select,
Confirmed: | 1 if select already confirmed
COT: | According to standard
CotTxt: | Cot asText
Qualifier: | According to standard and command
Originator: | According to standard
QU: | Qualifier of command QU 7.2.6.26
DCS: | 7.2.6.16 Double command (IEV 371-03-03)
ControlCommand: | Depending on control command

Example for 45:

<TypeId> <TypeIdAsTxt> Device:(<deviceip>)<devicename> Sector:(<IOA>)< SecName > ioa:<IOA> cot:(<COT>)<CotTxt> ori:<Originator> sel:<QOC S/E> qu:<QU> dcs:<DCS>

ValueChange cmd(<TypeyId>)<<TypeId>> <TypeIdAsTxt> ioa:<IOA> id:<AdviseID> value:<Wert> time:<TimeStamp> state:< QUALDESC > sir:<SBEValue>

LOG entry | Module/Level | Description
SBE IED processing. Device:(<deviceIp>)<devicename> Sector:(<COA>)<SecName> <ValueChange> SBE command: advise:<AdviseID> conf:<confirmed> <ControlCommand> | OSI7/Debug | Each value change that is processed for SBE creates this log message
Wrn:1014 SBE activation already confirmed! Device:(<DeviceIp>)<devicename> Sector:(<COA>)<SecName> <ValueChange> | OSI7/Warnung | Renewed conformation for Select received and ignored
Error:16 Advise for SBE data point fail. SBE command: advise:<AdviseId> conf:<confirmed> <ControlCommand> | Scada/error | Variable could not be requested.
Error:17 SBE value lost, queue full! Device:(<DeviceIp>)<devicename> Sector:(<COA>)<SecName> <ValueChange> | Scada/Error | Value change for SBE lost because the source is full.


Read - T102 - request

Manual -> Process Gateway -> IEC870 Slave -> Communication -> Read - T102 - request

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Maximum 2048 read requests - C_RD_NA_1 - can be active at the same time. Once this limit has been reached, further read requests are rejected.

A read request is executed for each IO with the requested IOA .
Several requests for one IO can be active at the same time.
Read requests will be processed even if the general request is not finished yet.

The response to the read command does not need to be configured and automatically runs in the background.


Test - T104 and T107 - requests

Manual -> Process Gateway -> IEC870 Slave -> Communication -> Test - T104 and T107 - requests

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The IEC870 slave responds to the master automatically with the two test commands C_TS_NA_1 (ASDU<104>) and C_TS_TA_1 (ASDU<107>).

This response does not need to be engineerd and runs in the background.

info Information

You can find further information on command IDs the Interoperability chapter.


Error analysis

Manual -> Process Gateway -> IEC870 Slave -> Error analysis

Should there be communication problems, this chapter will assist you in finding out the error.

Other topics in this chapter

Analysis tool

Error codes

Check list


Analysis tool

Manual -> Process Gateway -> IEC870 Slave -> Error analysis -> Analysis tool

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Process Gateway behaves like a zenon driver and writes messages to a common log file. To display them correctly and clearly, use the Diagnosis Viewer program that was also installed with zenon. You can find it under Start/All programs/zenon/Tools 7.20 -> Diagviewer. In general:

zenon driver log all errors in the log files. The default folder for the log files is subfolder LOG in directory ProgramData, example:

C:\ProgramData\COPA-DATA\LOG. Log files are text files with a special structure.

Attention: With the default settings, a driver only logs error information. With the Diagnosis Viewer you can enhance the diagnosis level for most of the drivers to "Debug" and "Deep Debug". With this the driver also logs all other important tasks and events.

In the Diagnosis Viewer you can also:

  • follow currently created entries live
  • customize the logging settings
  • change the folder in which the log files are saved

Note:

  1. In Windows CE even errors are not logged per default due to performance reasons.
  2. The Diagnosis Viewer displays all entries in UTC (coordinated world time) and not in local time.
  3. The Diagnosis Viewer does not display all columns of a log file per default. To display more columns activate property Add all columns with entry in the context menu of the column header.
  4. If you only use Error logging, the problem description is in column Error text. For other diagnosis level the description is in column General text.
  5. For communication problems many drivers also log error numbers which the PLC assigns to them. They are displayed in Error text and/or Error code and/or Driver error parameter(1 and 2). Hints on the meaning of error codes can be found in the driver documentation and the protocol/PLC description.
  6. At the end of your test set back the diagnosis level from Debug or Deep Debug. At Debug and Deep Debug there are a great deal of data for logging which are saved to the hard drive and which can influence your system performance. They are still logged even after you close the Diagnosis Viewer.

Note: Process Gateway is not available under Windows CE.

info Information

You can find further information on the Diagnosis Viewer in the Diagnose Viewer chapter.


Logging

Manual -> Process Gateway -> IEC870 Slave -> Error analysis -> Analysis tool -> Logging

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The driver supports a comprehensive logging function for:

  • Client name
  • zenProcGateway_IEC870Slave
  • Modules

Client name

The way the name of the client is displayed in the diagnosis viewer depends on the configuration. That is why the name changes if you change the TCP port, the COM port or the protocol. In this case, the logging settings may also change.

If the Process Gateway is started several times with the same settings, the same client name will be used. The error messages of the different instances can be distinguished by the process ID.

Example Example

zenProcGateway_IEC870Slave

  • 104 protocol with standard port 2404
  • 101 if COM1 selected.
  • If the configuration has not been loaded yet, error messages during startup will always be visible under this client.

zenProcGateway_IEC870Slave:COM4

  • 101 with COM4.
    The name contains the used COM port.

zenProcGateway_IEC870Slave:Port:12345

  • 104 with port 12345.
    The name contains the port for the Master connection.

Modules

Error messages are shown for all modules:

  • IEC870 Slave
  • OSI2
  • OSI7
  • SCADA Runtime (ScadaRT)

IEC870 Slave

Concerns the connection to the Process Gateway and its configuration.

Information about:

  • Errors during engineering

OSI2

Concerns the protocol level. This where framing with its according functions is implemented.

Information about:

  • Received data as byte dump
  • Sent data as byte dump
  • Function codes for 101
  • Errors on this level, e.g. in the framing
  • APCI for 104 (870-5-104 5)

Levels

  • Msg: Frame interpreting
  • Debug:
    Received and sent data
    Frame analysis.
    New Master connection.
  • Deep Debug: Every request about existence of characters. Produces a large number of logging entries!

OSI7

Concerns the application layer.
This is where commands are interpreted and executed.

Information about:

  • Logging 'process and system information'
  • Errors in the ASDUs

Levels:

  • Warning: Recursive interrogation
  • Msg: Process information, System information
  • Debug: Confirmed I-frames
  • Deep Debug: Interrogation runs. Produces a large number of logging entries!

SCADA Runtime (ScadaRT)

Messages for connection to the Runtime:

Information about:

  • advised and unadvised variables
  • updated variables
  • Deactivating the project

Levels

  • Debug:
    changed values
    project inactive


Error codes

Manual -> Process Gateway -> IEC870 Slave -> Error analysis -> Error codes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following error codes can be displayed in the Diagnosis Viewer:

Error code | Meaning
570 | Value change for unknown cyclical IO
571 | Transfer buffer too small to transfer a cyclical IO

Error messages for file transfer in reverse direction

Error number | Error level | Description
20 | Error message | Creation of the temporary file for the file transfer in reverse direction was unsuccessful.
1017 | Warning | File transfer in reverse direction is already active, the ongoing one will be ended and a new one started.
21 | Error message | Segment data write error occurred
22 | Error message | Length of the data exceeds the expected file length
23 | Error message | Checksum of the transferred segments incorrect for the sector.
24 | Error message | Checksum for file incorrect.
25 | Error message | Segment data transferred for sector exceeds the data length defined at the start
26 | Error message | Sector data transfer is reported as finished but the amount of segment data transferred does not correspond to that stated at the start.
27 | Error message | File data is reported as completed but the given file length does not correspond.
581 | Error message | Unexpected IOA with SG
582 | Error message | Unexpected NOF with SG
583 | Error message | Unexpected NOS with SG
584 | Error message | Unexpected NOS with LS
585 | Error message | Unexpected NOS with LS
586 | Error message | Unexpected NOS with LS
587 | Error message | FR with non-supported NOF. We only support 1 == transparent


Check list

Manual -> Process Gateway -> IEC870 Slave -> Error analysis -> Check list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
  • Is the COM port in use by another application or are the settings incorrect?
  • Is the device (PLC) that you are trying to communicate with connected to the power supply?
  • Is the cable between PLC and PC/IPC connected correctly?
  • Have you analyzed the error file (which errors did occur)?
  • For additional error analyses, please send a project backup and the LOG file of the DiagViewer to the support team responsible for you.


Interoperability

Manual -> Process Gateway -> IEC870 Slave -> Interoperability

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This companion standard presents sets of parameters and alternatives from which subsets must be selected to implement particular telecontrol systems. Certain parameter values, such as the choice of 'structured' or'unstructured' fields of the informationobject address of ASDUs represent mutually exclusive alternatives. This means that only one value of the defined parameters is admitted per system. Other parameters, such as the listed set of different process information incommand and in monitor direction allow the specification of the complete set orsubsets, as appropriate for given applications. This clause summarizes theparameters of the previous clauses to facilitate a suitable selection for aspecific application. If a system is composed of equipment stemming from different manufacturers, it is necessary that all partners agree on the selected parameters.

The interoperability list is defined as in IEC 60870-5-101 and extended with parameters used in this standard. The text descriptions of parameters which are not applicable to this companion standard are strike-through (corresponding check box is marked black).

NOTE In addition, the full specification of a system may require individual selection of certain parameters for certain parts of the system, such as the individual selection of scaling factors for individually addressable measured values.

The selected parameters should bemarked in the white boxes as follows:

[ ] Function or ASDU is not used
[ X ] Function or ASDU is used as standardized (default)
[ R ] Function or ASDU is used in reverse mode
[ B ] Function or ASDU is used in standard and reverse mode

The possible selection (blank, X , R , or B ) is specified for each specific clause or parameter.

A black check box indicates that the option cannot be selected in this companion standard.

1. System or device

(system-specific parameter, indicate definition of a system or a device by marking one of the following with ' X ')

[ ] System definition
[ ] Controlling station definition (Master)
[ X ] Controlled station definition (Slave)

2. Network Configuration: 101 only

(network-specific parameter, all configurations that are used are to be marked ' X ')

[ X ] Point-to-point | [ X ] Multipoint
[ X ] Multiple point to point | [ ] Multipoint-star

3. Physical Layer: 101 only

(network-specific parameter, all interfaces and data rates that are used are to be marked ' X ')

Transmission speed (control direction)

Unbalanced interchange Circuit V.24/V.28 Standard | Unbalanced interchange Circuit V.24/V.28 Recommended if >1 200 bit/s | Balanced interchange Circuit X.24/X.27
[ ] 100 bit/s | [ X ] 2400 bit/s | [ ] 2400 bit/s
[ ] 200 bit/s | [ X ] 4800 bit/s | [ ] 4800 bit/s
[ X ] 300 bit/s | [ X ] 9600 bit/s | [ ] 9600 bit/s
[ X ] 600 bit/s | [ X ] 19200 bit/s | [ ] 19200 bit/s
[ X ] 1200 bit/s | [ X ] 38400 bit/s | [ ] 38400 bit/s
 | [ X ] 56000 bit/s | [ ] 56000 bit/s
 | [ X ] 57600 bit/s | [ ] 64000 bit/s
 | [ X ] 115200 bit/s |
 | [ X ] 128000 bit/s |
 | [ X ] 256000 bit/s |

Transmission speed (monitor direction)

Unbalanced interchange Circuit V.24/V.28 Standard | Unbalanced interchange Circuit V.24/V.28 Recommended if >1 200 bit/s | Balanced interchange Circuit X.24/X.27
[ ] 100 bit/s | [ X ] 2400 bit/s | [ ] 2400 bit/s
[ ] 200 bit/s | [ X ] 4800 bit/s | [ ] 4800 bit/s
[ X ] 300 bit/s | [ X ] 9600 bit/s | [ ] 9600 bit/s
[ X ] 600 bit/s | [ X ] 19200 bit/s | [ ] 19200 bit/s
[ X ] 1200 bit/s | [ X ] 38400 bit/s | [ ] 38400 bit/s
 | [ X ] 56000 bit/s | [ ] 56000 bit/s
 | [ X ] 57600 bit/s | [ ] 64000 bit/s
 | [ X ] 115200 bit/s |
 | [ X ] 128000 bit/s |
 | [ X ] 256000 bit/s |

4. Link layer: 101 only

(network-specific parameter, all options that are used are to be marked ' X '. Specify the maximum frame length. If a non-standard assignment of class 2 messages is implemented for unbalanced transmission, indicate the Type ID and COT of all messages assigned to class 2.)

Frame format FT 1.2, single character 1 and the fixed time out interval are used exclusively in this companion standard.

Link transmission | Frame length [octets] | Address field of the link
[ ] Balanced transmission | [255] Maximum length L (both directions)* | [ ] not present (balanced transmission only)
[ X ] Unbalanced transmission |  | [ X ] One octet
 |  | [ X ] Two octets
 |  | [ X ] Structured
 |  | [ X ] Unstructured

*may be reduced by the system

Link Address 0xFF(FF) - broadcast to all outstations - is not supported.

The structure of Link Address is not interpreted.

When using an unbalanced link layer, the following ASDU types are returned in class 2 messages (low priority) with the indicated causes of transmission:

[ ] The standard assignment of ASDUs to class 2 messages is used as follows:

Type identification | Cause of transmission
9, 11, 13, 21 | <1>

[ X ] A special assignment of ASDUs to class 2 messages is used as follows:

Type identification | Cause of transmission
120 - 126 | All (as specified in the standard)

Note: (In response to a class 2 poll, a controlled station may respond with class 1 data when there is no class 2 data available).

5. Application Layer

Transmission mode for application data

Mode 1 (Least significant octet first), as defined in 4.10 of IEC 60870-5-4, is used exclusively in this companion standard.

Common address of ASDU

(system-specific parameter, all configurations that are used are to be marked ' X ')

ASDU adress
101 only [ X ] One octet | [ X ] Two octets

The ASDU address 0xFF(FF) - global address - is supported only for C_IC_NA_1 and C_CS_NA_1

Information object address

(system-specific parameter, all configurations that are used are to be marked ' X ')

Object adress
101 only [ X ] One octet | [ X ] Structured
101 only [ X ] Two octets | [ X ] Unstructured
[ X ] Three octets |

Cause of transmission

(system-specific parameter, all configurations that are used are to be marked ' X ')

Cause of transmission
101 only [ X ] One octet | [ X ] Two octets (with originator address) Originator address is set to zero if not used.

Length of APDU: 104 only

(system-specific parameter, specify the maximum length of the APDU per system)
The maximum length of APDU for both directions is 253. The maximum length may be reduced by the system.

[ 253 ] Maximum length of APDU per system

Selection of standard ASDUs

Process information in monitor direction

(station-specific parameter, mark each Type ID ' X ' if it is only used in the standard direction, ' R ' if only used in the reverse direction, and ' B ' if used in both directions).

Mark | Parameter | Type
[ B ] | <1>: = Single-point information | M_SP_NA_1
[ B ] | <2>: = Single-point information with time TAG | M_SP_TA_1
[ B ] | <3>: = Double-point information | M_DP_NA_1
[ B ] | <4>: = Double-point information with time TAG | M_DP_TA_1
[ B ] | <5>: = Step position information | M_ST_NA_1
[ B ] | <6>: = Step position information with time TAG | M_ST_TA_1
[ B ] | <7>: = Bitstring of 32 bit | M_BO_NA_1
[ B ] | <8>: = Bitstring of 32 bit with time TAG | M_BO_TA_1
[ B ] | <9>: = Measured value, normalized value | M_ME_NA_1
[ B ] | <10>: = Measured value, normalized value with time TAG | M_ME_TA_1
[ B ] | <11>: = Measured value, scaled value | M_ME_NB_1
[ B ] | <12>: = Measured value, scaled value with time TAG | M_ME_TB_1
[ B ] | <13>: = Measured value, short floating point value | M_ME_NC_1
[ B ] | <14>: = Measured value, short floating point value with time TAG | M_ME_TC_1
[ B ] | <15>: = Integrated totals | M_IT_NA_1
[ B ] | <16>: = Integrated totals with time TAG | M_IT_TA_1
[ ] | <17>: = Event of protection equipment with time TAG | M_EP_TA_1
[ ] | <18>: = Packed start events of protection equipment with time TAG | M_EP_TB_1
[ ] | <19>: = Packed output circuit information of protection equipment with time TAG | M_EP_TC_1
[ ] | <20>: = Packed single-point information with status change detection | M_SP_NA_1
[ ] | <21>: = Measured value, normalized value without quality descriptor | M_ME_ND_1
[ B ] | <30>: = Single-point information with time TAG CP56Time2a | M_SP_TB_1
[ B ] | <31>: = Double-point information with time TAG CP56Time2a | M_DP_TB_1
[ B ] | <32>: = Step position information with time TAG CP56Time2a | M_ST_TB_1
[ B ] | <33>: = Bitstring of 32 bit with time TAG CP56Time2a | M_BO_TB_1
[ B ] | <34>: = Measured value, normalized value with time TAG CP56Time2a | M_ME_TD_1
[ B ] | <35>: = Measured value, scaled value with time TAG CP56Time2a | M_ME_TE_1
[ B ] | <36>: = Measured value, short floating point value with time TAG CP56Time2a | M_ME_TF_1
[ B ] | <37>: = Integrated totals with time TAG CP56Time2a | M_IT_TB_1
[ ] | <38>: = Event of protection equipment with time TAG CP56Time2a | M_EP_TD_1
[ ] | <39>: = Packed start events of protection equipment with time TAG CP56Time2a | M_EP_TE_1
[ ] | <40>:= Packed output circuit information of protection equipment with time TAG CP56Time2a | M_EP_TF_1

Either the ASDUs of the set <2>, <4>, <6>, <8>, <10>, <12>, <14>, <16>, <17>, <18>, <19> or of the set <30> – <40> are used.

Process information in control direction

(station-specific parameter, mark each Type ID ' X ' if it is only used in the standard direction, ' R ' if only used in the reverse direction, and ' B ' if used in both directions).

Mark | Parameter | Type
[ X ] | <45>: = Single command | C_SC_NA_1
[ X ] | <46>: = Double command | C_DC_NA_1
[ X ] | <47>: = Regulating step command | C_RC_NA_1
[ X ] | <48>: = Set point command, normalized value | C_SE_NA_1
[ X ] | <49>: = Set point command, scaled value | C_SE_NB_1
[ X ] | <50>: = Set point command, short floating point value | C_SE_NC_1
[ X ] | <51>: = Bitstring of 32 bit | C_BO_NA_1
[ X ] | <58>: = Single command with time TAG CP56Time2a | C_SC_TA_1
[ X ] | <59>: = Double command with time TAG CP56Time2a | C_DC_TA_1
[ X ] | <60>: = Regulating step command with time TAG CP56Time2a | C_RC_TA_1
[ X ] | <61>: = Set point command, normalized value with time TAG CP56Time2a | C_SE_TA_1
[ X ] | <62>: = Set point command, scaled value with time TAG CP56Time2a | C_SE_TB_1
[ X ] | <63>: = Set point command, short floating point value with time TAG CP56Time2a | C_SE_TC_1
[ X ] | <64>:= Bitstring of 32 bit with time TAG CP56Time2a | C_BO_TA_1

Either the ASDUs of the set <45> – <51> or of the set <58> – <64> are used.

System information in monitor direction

(station-specific parameter, mark ' X ' if used)

Mark | Parameter | Type
[ X ] | <70> : = End of initialization | M_EI_NA_1

System information in control direction

(station-specific parameter, mark each Type ID ' X ' if it is only used in the standard direction, ' R ' if only used in the reverse direction, and ' B ' if used in both directions).

Mark | Parameter | Type
[ X ] | <100>: = Interrogation command* | C_IC_NA_1
[ X ] | <101>: = Counter interrogation command | C_CI_NA_1
[ X ] | <102>: = Read command | C_RD_NA_1
[ X ] | <103>: = Clock synchronization command (option see 7.6)* | C_CS_NA_1
[ X ] | <104>: = Test command | C_TS_NA_1
[ X ] | <105>: = Reset process command | C_RP_NA_1
[ ] | <106>: = Delay acquisition command | C_CD_NA_1
[ X ] | <107>: = Test command with time TAG CP56Time2a | C_TS_TA_1

*also with global address - with Common Address of ASDU = 0xFF(FF)

Parameter in control direction

(station-specific parameter, mark each Type ID ' X ' if it is only used in the standard direction, ' R ' if only used in the reverse direction, and ' B ' if used in both directions).

Mark | Parameter | Type
[ ] | <110>: = Parameter of measured value, normalized value | P_ME_NA_1
[ ] | <111>: = Parameter of measured value, scaled value | P_ME_NB_1
[ ] | <112>: = Parameter of measured value, short floating point value | P_ME_NC_1
[ ] | <113>: = Parameter activation | P_AC_NA_1

File transfer

(station-specific parameter, mark each Type ID ' X ' if it is only used in the standard direction, ' R ' if only used in the reverse direction, and ' B ' if used in both directions).

Mark | Parameter | Type
[ B ] | <120>: = File ready | F_FR_NA_1
[ B ] | <121>: = Section ready | F_SR_NA_1
[ B ] | <122>: = Call directory, select file, call file, call section | F_SC_NA_1
[ B ] | <123>: = Last section, last segment | F_LS_NA_1
[ B ] | <124>: = Ack file, ack section | F_AF_NA_1
[ B ] | <125>: = Segment | F_SG_NA_1
[ X ] | <126>: = Directory {blank or X, only available in monitor (standard) direction} | F_DR_TA_1

Type identifier and Cause of transmission assignments

(station-specific parameters)

Shaded boxes: option not required.
Blank: functions or ASDU not used.

Mark Type Identification/Cause of transmission combinations:
' X ' if only used in the standard direction;
' R ' if only used in the reverse direction;
' B ' if used in both directions.

Type identification |  | Cause of transmission
 |  | 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 20 to 36 | 37 to 41 | 44 | 45 | 46 | 47
<1> | M_SP_NA_1 |  | B | B |  | X |  |  |  |  |  |  |  |  | X |  |  |  |  |
<2> | M_SP_TA_1 |  |  | B |  | X |  |  |  |  |  |  |  |  |  |  |  |  |  |
<3> | M_DP_NA_1 |  | B | B |  | X |  |  |  |  |  |  |  |  | X |  |  |  |  |
<4> | M_DP_TA_1 |  |  | B |  | X |  |  |  |  |  |  |  |  |  |  |  |  |  |
<5> | M_ST_NA_1 |  | B | B |  | X |  |  |  |  |  |  |  |  | X |  |  |  |  |
<6> | M_ST_TA_1 |  |  | B |  | X |  |  |  |  |  |  |  |  |  |  |  |  |  |
<7> | M_BO_NA_1 |  | B | B |  | X |  |  |  |  |  |  |  |  | X |  |  |  |  |
<8> | M_BO_TA_1 |  |  | B |  | X |  |  |  |  |  |  |  |  |  |  |  |  |  |
<9> | M_ME_NA_1 | B | B | B |  | X |  |  |  |  |  |  |  |  | X |  |  |  |  |
<10> | M_ME_TA_1 |  |  | B |  | X |  |  |  |  |  |  |  |  |  |  |  |  |  |
<11> | M_ME_NB_1 | B | B | B |  | X |  |  |  |  |  |  |  |  | X |  |  |  |  |
<12> | M_ME_TB_1 |  |  | B |  | X |  |  |  |  |  |  |  |  |  |  |  |  |  |
<13> | M_ME_NC_1 | B | B | B |  | X |  |  |  |  |  |  |  |  | X |  |  |  |  |
<14> | M_ME_TC_1 |  |  | B |  | X |  |  |  |  |  |  |  |  |  |  |  |  |  |
<15> | M_IT_NA_1 |  |  | B |  | X |  |  |  |  |  |  |  |  | X1 | X |  |  |  |
<16> | M_IT_TA_1 |  |  | B |  | X |  |  |  |  |  |  |  |  |  | X |  |  |  |
<17> | M_EP_TA_1 |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
<18> | M_EP_TB_1 |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
<19> | M_EP_TC_1 |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
<20> | M_PS_NA_1 |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
<21> | M_ME_ND_1 |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
<30> | M_SP_TB_1 |  |  | B |  | X |  |  |  |  |  |  |  |  |  |  |  |  |  |
<31> | M_DP_TB_1 |  |  | B |  | X |  |  |  |  |  |  |  |  |  |  |  |  |  |
<32> | M_ST_TB_1 |  |  | B |  | X |  |  |  |  |  |  |  |  |  |  |  |  |  |
<33> | M_BO_TB_1 |  |  | B |  | X |  |  |  |  |  |  |  |  |  |  |  |  |  |
<34> | M_ME_TD_1 |  |  | B |  | X |  |  |  |  |  |  |  |  |  |  |  |  |  |
<35> | M_ME_TE_1 |  |  | B |  | X |  |  |  |  |  |  |  |  |  |  |  |  |  |
<36> | M_ME_TF_1 |  |  | B |  | X |  |  |  |  |  |  |  |  |  |  |  |  |  |
<37> | M_IT_TB_1 |  |  | B |  | X |  |  |  |  |  |  |  |  |  | X |  |  |  |
<38> | M_EP_TD_1 |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
<39> | M_EP_TE_1 |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
<40> | M_EP_TF_1 |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
<45> | C_SC_NA_1 |  |  |  |  |  | X | X | X2 | X2 | X |  |  |  |  |  |  |  | X | X
<46> | C_DC_NA_1 |  |  |  |  |  | X | X | X2 | X2 | X |  |  |  |  |  |  |  | X | X
<47> | C_RC_NA_1 |  |  |  |  |  | X | X | X2 | X2 | X |  |  |  |  |  |  |  | X | X
<48> | C_SE_NA_1 |  |  |  |  |  | X | X | X2 | X2 | X |  |  |  |  |  |  |  | X | X
<49> | C_SE_NB_1 |  |  |  |  |  | X | X | X2 | X2 | X |  |  |  |  |  |  |  | X | X
<50> | C_SE_NC_1 |  |  |  |  |  | X | X | X2 | X2 | X |  |  |  |  |  |  |  | X | X
<51> | C_BO_NA_1 |  |  |  |  |  | X | X | X2 | X2 | X |  |  |  |  |  |  |  | X | X
<58> | C_SC_TA_1 |  |  |  |  |  | X | X | X2 | X2 | X |  |  |  |  |  |  |  | X | X
<59> | C_DC_TA_1 |  |  |  |  |  | X | X | X2 | X2 | X |  |  |  |  |  |  |  | X | X
<60> | C_RC_TA_1 |  |  |  |  |  | X | X | X2 | X2 | X |  |  |  |  |  |  |  | X | X
<61> | C_SE_TA_1 |  |  |  |  |  | X | X | X2 | X2 | X |  |  |  |  |  |  |  | X | X
<62> | C_SE_TB_1 |  |  |  |  |  | X | X | X2 | X2 | X |  |  |  |  |  |  |  | X | X
<63> | C_SE_TC_1 |  |  |  |  |  | X | X | X2 | X2 | X |  |  |  |  |  |  |  | X | X
<64> | C_BO_TA_1 |  |  |  |  |  | X | X | X2 | X2 | X |  |  |  |  |  |  |  | X | X
<70> | M_EI_NA_1* |  |  |  | X |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
<100> | C_IC_NA_1 |  |  |  |  |  | X | X | X | X | X |  |  |  |  |  |  |  | X |
<101> | C_CI_NA_1 |  |  |  |  |  | X | X |  |  | X |  |  |  |  |  |  |  | X |
<102> | C_RD_NA_1 |  |  |  |  | X |  |  |  |  |  |  |  |  |  |  |  | X | X | X
<103> | C_CS_NA_1 |  |  |  |  |  | X | X |  |  |  |  |  |  |  |  |  | X | X |
<104> | C_TS_NA_1 |  |  |  |  |  | X | X |  |  |  |  |  |  |  |  |  |  |  |
<105> | C_RP_NA_1 |  |  |  |  |  | X | X |  |  |  |  |  |  |  |  |  | X | X |
<106> | C_CD_NA_1 |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
<107> | C_TS_TA_1 |  |  |  |  |  | X | X |  |  |  |  |  |  |  |  |  |  |  |
<110> | P_ME_NA_1 |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
<111> | P_ME_NB_1 |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
<112> | P_ME_NC_1 |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
<113> | P_AC_NA_1 |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
<120> | F_FR_NA_1 |  |  |  |  |  |  |  |  |  |  |  |  | X |  |  |  |  | X |
<121> | F_SR_NA_1 |  |  |  |  |  |  |  |  |  |  |  |  | X |  |  |  |  | X |
<122> | F_SC_NA_1 |  |  |  |  | X |  |  |  |  |  |  |  | X |  |  |  | X | X |
<123> | F_LS_NA_1 |  |  |  |  |  |  |  |  |  |  |  |  | X |  |  |  |  | X |
<124> | F_AF_NA_1 |  |  |  |  |  |  |  |  |  |  |  |  | X |  |  |  | X | X |
<125> | F_SG_NA_1 |  |  |  |  |  |  |  |  |  |  |  |  | X |  |  |  |  | X |
<126> | F_DR_TA_1* |  |  | X |  | X |  |  |  |  |  |  |  |  |  |  |  |  |  |

* Blank or X only

1 Optional.

2 Slave confirms deactivations of write command (TI <45> ... <64>) but by deactivated 'Select routing' the corresponding activation is already transferred to execution; COT_actcon and COT_actterm were already sent.

COT | Cause of Transmission |
<0> | not used |
<1> | periodic, cyclic | per/cyc
<2> | background scan | back
<3> | spontaneous | spont
<4> | initialized | init
<5> | request or requested | req
<6> | activation | act
<7> | activation confirmation | actcon
<8> | deactivation | deact
<9> | deactivation confirmation | deactcon
<10> | activation termination | actterm
<11> | return information caused by a remote command | retrem
<12> | return information caused by a local command | retloc
<13> | file transfer | file
<14...19> | reserved |
<20> | interrogated by station interrogation | inrogen
<21...36> | interrogated by interrogation of the group 1..16 | inro1..16
<37> | requested by general counter request | reqcogen
<38...41> | requested by counter interrogation of the group 1 ... 4 | reqco1..4
<42, 43> | reserved |
<44> | unknown type identification |
<45> | unknown cause of transmission |
<46> | unknown common address of ASDU |
<47> | unknown information object address |
<48, 63> | for special use (private range) |

6. Basic application functions

Station initialization

(station-specific parameter, mark 'X' if function is used)

[ ] Remote initialization

Cyclic data transmission

(station-specific parameter, mark ' X ' if function is only used in the standard direction, ' R ' if only used in the reverse direction, and ' B ' if used in both directions)

[ X ] Cyclic data transmission

Read procedure

(station-specific parameter, mark ' X ' if function is only used in the standard direction, ' R ' if only used in the reverse direction, and ' B ' if used in both directions)

[ X ] Read procedure

Spontaneous transmission

(station-specific parameter, mark ' X ' if function is only used in the standard direction, ' R ' if only used in the reverse direction, and ' B ' if used in both directions)

[ B ] Spontaneous transmission

Double transmission of information objects with cause of transmission spontaneous

(station-specific parameter, mark each information type ' X ' where both a Type ID without time and corresponding Type ID with time are issued in response to a single spontaneous change of a monitored object)

The following type identifications may be transmitted in succession caused by a single status change of an information object. The particular information object addresses for which double transmission is enabled are defined in a project-specific list.

[ ] Single-point information M_SP_NA_1, M_SP_TA_1, M_SP_TB_1 and M_PS_NA_1
[ ] Double-point information M_DP_NA_1, M_DP_TA_1 and M_DP_TB_1
[ ] Step position information M_ST_NA_1, M_ST_TA_1 and M_ST_TB_1
[ ] Bitstring of 32 bit M_BO_NA_1, M_BO_TA_1 and M_BO_TB_1 (if defined for a specific project)
[ ] Measured value, normalized value M_ME_NA_1, M_ME_TA_1, M_ME_ND_1 and M_ME_TD_1
[ ] Measured value, scaled value M_ME_NB_1, M_ME_TB_1 and M_ME_TE_1
[ ] Measured value, short floating point number M_ME_NC_1, M_ME_TC_1 and M_ME_TF_1

Station interrogation

(station-specific parameter, mark ' X ' if function is only used in the standard direction, ' R ' if only used in the reverse direction, and ' B ' if used in both directions).

[ X ] global |  |
[ ] group 1 | [ ] group 7 | [ ] group 13
[ ] group 2 | [ ] group 8 | [ ] group 14
[ ] group 3 | [ ] group 9 | [ ] group 15
[ ] group 4 | [ ] group 10 | [ ] group 16
[ ] group 5 | [ ] group 11 | Information object addresses assigned to each group must be shown in a separate table.
[ ] group 6 | [ ] group 12

Clock synchronization

(station-specific parameter, mark ' X ' if function is only used in the standard direction, ' R ' if only used in the reverse direction, and ' B ' if used in both directions).

[ X ] Clock synchronization

[ ] Day of week used
[ ] RES1, GEN (time tag substituted/ not substituted) used
[ B ] SU-bit (summertime) used

optional, see 7.6

Command transmission

(station-specific parameter, mark ' X ' if function is only used in the standard direction, ' R ' if only used in the reverse direction, and ' B ' if used in both directions).

[ X ] Direct command transmission
[ X ] Direct set point command transmission
[ X ] Select and execute command
[ X ] Select and execute set point command
[ X ] C_SE ACTTERM used

[ X ] No additional definition
[ X ] Short-pulse duration (duration determined by a system parameter in the outstation)
[ X ] Long-pulse duration (duration determined by a system parameter in the outstation)
[ X ] Persistent output

[ setting ] Supervision of maximum delay in command direction of commands and set point commands
[ no limit ] Maximum allowable delay of commands and set point commands

Transmission of integrated totals

(station-specific parameter, mark ' X ' if function is only used in the standard direction, ' R ' if only used in the reverse direction, and ' B ' if used in both directions).

[ X ] Mode A: Local freeze with spontaneous transmission
[ X ] Mode B: Local freeze with counter interrogation
[ X ] Mode C: Freeze and transmit by counter-interrogation commands
[ X ] Mode D: Freeze by counter-interrogation command, frozen values reported spontaneously

[ X ] Counter read
[ X ] Counter freeze without reset
[ ] Counter freeze with reset
[ ] Counter reset

[ X ] General request counter
[ ] Request counter group 1
[ ] Request counter group 2
[ ] Request counter group 3
[ ] Request counter group 4

Parameter loading

(station-specific parameter, mark ' X ' if function is only used in the standard direction, ' R ' if only used in the reverse direction, and ' B ' if used in both directions).

[ ] Threshold value
[ ] Smoothing factor
[ ] Low limit for transmission of measured values
[ ] High limit for transmission of measured values

Parameter activation

(station-specific parameter, mark ' X ' if function is only used in the standard direction, ' R ' if only used in the reverse direction, and ' B ' if used in both directions).

[ ] Act/deact of persistent cyclic or periodic transmission of the addressed object

Test procedure

(station-specific parameter, mark ' X ' if function is only used in the standard direction, ' R ' if only used in the reverse direction, and ' B ' if used in both directions).

[ X ] Test procedure

File transfer

(station-specific parameter, mark 'X' if function is used).
File transfer in monitor direction

[ X*] Transparent file
[ ] Transmission of disturbance data of protection equipment
[ X ] Transmission of sequences of events
[ ] Transmission of sequences of recorded analogue values

* a data can be transparently transported by the system but not generated or evaluated. Maximum file size is 16711680 bytes.

File transfer in control direction

[ X ] Transparent file

Background scan

(station-specific parameter, mark ' X ' if function is only used in the standard direction, ' R ' if only used in the reverse direction, and ' B ' if used in both directions).

[ X ] Background scan

Acquisition of transmission delay

(station-specific parameter, mark ' X ' if function is only used in the standard direction, ' R ' if only used in the reverse direction, and ' B ' if used in both directions).

[ ] Acquisition of transmission delay

Definition of time outs: 104 only

Parameter | Default value | Remarks | Selected value
t0 | 30 s | Time-out of connection establishment | setting
t1 | 15 s | Time-out of send or test APDUs | setting
t2 | 10 s | Time-out for acknowledges in case of no data messages; t2 < t1 | setting
t3 | 20 s | Time-out for sending test frames in case of a long idle state; t3 > t1 | setting

Recommended range for timeouts t0 - t2 : 1s to 255s, accuracy 1s

Recommended range for timeout t3 : 0s to 48hrs, accuracy 1s
Long timeouts for t3 may be needed in special cases where satellite links or dialup connections are used (e.g. to establish connection and collect values only once per day or week). For dialup connections it may be necessary to give up the connection supervision completely. This is achievable by setting the timeout t3 to zero.

Maximum number of outstanding I format APDUs k and latest acknowledge APDUs (w): 104 only

Parameter | Default value | Remarks | Selected value
k | 12 APDUs | Maximum difference receive sequence number to send state variable | setting
w | 8 APDUs | Latest acknowledge after receiving w I format APDUs | setting

Recommended range of values k: 1 to 32767 APDUs, accuracy 1 APDU

Recommended range of values w: 1 to 32767 APDUs, accuracy 1 APDU (Recommendation: w should not exceed two-thirds of k)

Portnumber: 104 only

Parameter | Default value | Remarks
Portnumber | 2404 | setting

Redundant connections

[ ] Number N of redundancy group connections used

RFC 2200 suite

RFC 2200 is an official Internet Standard which describes the state of standardization of protocols used in the Internet as determined by the Internet Architecture Board (IAB). It offers a broad spectrum of actual standards used in the Internet. The suitable selection of documents from RFC 2200 defined in this standard for given projects has to be chosen by the user of this standard.

[ ] Ethernet 802.3
[ ] Serial X.21 interface
[ ] Other selection from RFC 2200:

List of valid documents from RFC 2200
1. ..........................................................................
2. ..........................................................................
3. ..........................................................................
4. ..........................................................................
5. ..........................................................................
6. ..........................................................................
7. etc.


MODBUS Slave

Manual -> Process Gateway -> MODBUS Slave


Module configuration

Manual -> Process Gateway -> MODBUS Slave -> Module configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Clicking on the Settings button in the start dialog for the Process Gateway opens the dialog for selecting the variables. The variables selected in this way are continuously synchronized in zenon or in the MODBUS system.

Variables

Parameters

Description

Variables

Selection of variables that are exported to MODBUS and synchronized with zenon.

Available in Scada

Displays all variables available in zenon

With multi-project administration, variables from active projects can be selected.

  • Projectsshows all available projects; the standard project is marker with a *
  • Variablesoffers all variables from the selected project to be transferred

Exported into MODBUS

Lists all variables exported to MODBUS and their offset. List can be sorted by clicking on headings.

  • Variables:
    List of all SCADA variables that are exported to the MODBUS.

    Variables that do not come from the standard project, receive the project name as a prefix, separated by a # in front of the variable name.
  • Offset:
    Offset of the variable (MODBUS holding register offset)

Pfeiltasten

Allocation of the variables to MODBUS:

  • Clicking on the > button adds variables from the Available in Scada list to the Exported into MODBUS list. A dialog to allocate the address is opened (see Allocation dialog section).
  • Clicking on the < button removes variables from the Exported into MODBUS list and inserts them back into the Available in Scada list.

MODBUS Connection

MODBUS Connection

MODBUS connection settings.

Slave Adress

Modbus hardware address.

Default: 1

Serial

Active: Serial connection is used.

  • Port: Serial interface that is used for access to the MODBUS system.
  • Stop bits: number of stop bits.
    Default: 1
  • Parity: Parity setting:
    No (default)
    Odd
    Even
  • Data bit: number of data bits.
    Default: 8
  • Baud rate: baud rate of the serial interface.
    Default: 9600

TCP/IP

Active: TCP/IP connection is used.

  • Port: Port address for the connection.
  • Timeout: Waiting period.

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Note:

  • Change of name of project and/or variables in the Editor:
    If a project name or a variable name is changed in the Editor, this change must subsequently be carried out in the configuration file, so that the name in the INI file and in the prefix of the Exported into MODBUS are amended accordingly.
  • Change to standard project:
    If the standard project is changed in multi-project administration, the variables must be amended.
    Variables of the standard project must not have a prefix. All other variables need a Projectname# prefix.

Allocation dialog

If a variable is moved, by clicking on the button> in the Exported into MODBUS list, the dialog to address the zenon variable to an offset in the MODBUS appears:

Parameters | Description
Name | Name of the variable. Note: The name of the variable is grayed out, because it can no longer be changed.
Offset | Offset: MODBUS holding register offset. Offset of the variable in MODBUS Attention: 0 is always entered as the offset by default.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.


Hardware address of the MODBUS system

Manual -> Process Gateway -> MODBUS Slave -> Hardware address of the MODBUS system

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The MODBUS system of the Process Gateway has a MODBUS hardware address that can be defined. This is set in the configuration dialog with the Slave Adress property. The address 1 is given as standard.


Configuration file: specific entries for AccessMODBUS

Manual -> Process Gateway -> MODBUS Slave -> Configuration file: specific entries for AccessMODBUS

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The configuration file zenProcGateway.ini contains specific entries for MODBUS. The file must be in the system folder.

[MODBUS]

Entry | Description
COMPORT | serial interface (COM1 = 0, COM2 = 1,...). Can be set using the configuration dialog.
BAUD | Baud rate of the serial interface. Can be set using the configuration dialog.
BYTESIZE | number of data bits of the serial interface
PARITY | Parity settings of the serial interface: 0=No 1=Odd 2=Even Can be set using the configuration dialog.
STOPBITS | Number of stop bits of the serial interface 0=1 1=1.5 2=2 Can be set using the configuration dialog.
TIMEOUT | timeout interval for serial communication in milliseconds
HWADDRESS | Hardware address of the MODBUS system. Default: 1 Can be set using the configuration dialog.
REFRESHRATE | Update time in milliseconds
SERIELL | Serial or TCP/IP communication: 1 = serial 0 = TCP/IP Can be set using the configuration dialog.
PORT | TCP/IP port
TCPTIMEOUT | TCP/IP timeout interval in seconds

[MODBUS VARIABLES]

Variables that are to be replaced in AccessMODBUS.

Note: This entry replaces the original [VARIABLES] entry from zenon 7.11 onwards. This prevents unnecessary replacement using shared memory for variables from the standard project.

Entry

Description

COUNT

number of variables to be exported

OFFSET_n

Modbus address that is allocated to the corresponding number (n). Numbering starts with 0.

NAME_n

Name of the variable that is allocated to the corresponding number (n). Numbering starts with 0.

Examples:

  • OFFSET_0=0
    NAME_0=EMS_Supply area 1_forecast_final_consumption
    Variable from start project
  • OFFSET_1=2
    NAME_1=BASISTUTORIAL#Temperaturfühler
    Variable from projekt "BASISTUTORIAL"


MS Azure

Manual -> Process Gateway -> MS Azure

AccessAzure.dll Writes the variable values of Runtime to an MS Azure service bus queue. These can then be obtained with the AzureDrv driver from MS Azure and integrated into zenon or zenon Analyzer processes.

The Process Gateway then establishes a connection to MS Azure cyclically and takes all messages received from the the service bus queue with the configured names. These messages are unpacked and the online values contained therein are allocated to the variables. The key for this is the symbolic address.

All messages that are already in the queue when the connection is first successfully established are deleted and discarded.

This means: Each driver instance on each computer has its own queue as an input signal.
Example: The service bus queue for the computer MYSERVER1 and the configured prefix onlinedata is called the following in MS Azure: onlinedata_myserver1.

Numeric (DOUBLE) and alphanumeric (STRING) values are supported. The time stamp and the system status bits are transferred to the target variable.


Module configuration

Manual -> Process Gateway -> MS Azure -> Module configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration dialog for MS Azure connection via Process Gateway.

Variables

In the Variables group, you configure the variables whose values are saved by zenon in an MS Azure service bus.

Parameters

Description

Available in Scada

Displays all variables available in zenon

With multi-project administration, variables from active projects can be selected.

Projects

List of all available projects.
The standard project is marked with a *.

Variables

List of all variables of the selected project.

List can be sorted; multiple selection is possible.

Hint: Double clicking on the variable moves it.

Button >

Selected variables from the list of variables are moved to the Exported into MS Azure list.

Button <

Selected variables are removed from the Exported into MS Azure list.

Exported into MS Azure

List of the variables that are written to the MS Azure service bus queue by Process Gateway.

Naming:

  • Project name
  • # (as separator)
  • Variable name.

The key for the values in MS Azure is always PROJECTNAME#VARIABLENAME.

Hint: Double clicking on the variable moves it.

MS Azure Connections

All target connections in which the current values of the selected variable are to be inserted in MS Azure are to be entered into the MS Azure Connections group.

In doing so, the current variable values are added to the connection created in All at the same time.

Parameters

Description

List of MS Azure connections

Lists all connections to MS Azure configured. Each connection consists of the connection name (MS Azure Connection) and the Service Bus Queue Namen.

  • Creation of a new connection with the button New...
  • A selected connection can be amended with the Edit... button.

MS Azure Connection

MS Azure connection address.

Service Bus Queue name

Name of the queue in the MS Azure service bus.

New...

Opens dialog to configure the MS Azure connection.

Edit...

Opens existing connections to configure the MS Azure connection.

Delete

Deletes the selected MS Azure connection from the list.

MS Azure settings

Parameters

Description

Integrity period

Time interval in which the current values of the selected variables are written to the MS Azure service bus as an image.

If the value of a variable changes during this this time period, the value change is immediately transferred to the MS Azure queue.
Default: 5 s

Navigation

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.


MS Azure Connection Settings

Manual -> Process Gateway -> MS Azure -> Module configuration -> MS Azure Connection Settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration dialog for the connection to MS Azure:

Parameters

Description

MS Azure Connection

MS Azure connection address.

Note: You can read and copy the desired service bus name space in the Azure administration portal under Manage Connection Strings.

Service Bus Queue name

Name of the MS Azure service bus queue.

The name of the service bus queue comprises:

  • The freely-configurable prefix
  • An underscore (_)
  • The NETBIOS computer name (without domain name suffix) in small lettering

Note: Only characters that appear in the name of an MS Azure service bus queue are permitted. If possible, use a simple, short and meaningful name. Avoid special characters, language-specific letters and blank spaces.

info Information

The Service Bus Queue Name can be freely configured.
This queue is automatically created in MS Azure during the first communication to MS Azure.

Create a separate MS Azure Connection for each computer that calls up data from MS Azure (via the AzureDrv driver).


Message format

Manual -> Process Gateway -> MS Azure -> Message format

The messages in the queue must have a serialized .NET class OnlineValueMessage .

Format:

public class OnlineValueMessage

{

public string strVarProject { get; set; }

public string strVarName { get; set; }

public long nVarID { get; set; }

public double fValue { get; set; }

public string strValue { get; set; }

public bool bValueIsString { get; set; }

public long nTime_s { get; set; }

public short nTime_milli { get; set; }

public long nStatus { get; set; }

}


Error message

Manual -> Process Gateway -> MS Azure -> Error message

Error message in the LOG file:

Error message | Debug Level | Description
Project %s inactive fail! | Error | The project-inactive event could not be processed by the Gateway in the given time.
Project %s active fail! | Error | The project-active event could not be processed by the Gateway in the given time.
Value change queue full: Value change for id:%u of project:%s lost! | Error | The queue for the value changes from Runtime is full. Additional values are discarded. The connection to Azure is probably too slow in order to forward all value changes.
Adding of %d Online Rows failed for '%s' Queue '%s | Error | The insertion of value changes into the service bus queue was unsuccessful.
Adding of %d Online Rows succeeded for '%s' Queue '%s' | Deep Debug: | The insertion of value changes into the service bus queue was successful.
Starting to add Online Rows failed for '%s' Queue '%s' | Error | The establishment of the a connection to the service bus queue was unsuccessful.
Creating Azure Wrapper failed | Error | The ManagedAzureWrapper.dll could not be loaded.


Configuration file: specific entries for MS Azure

Manual -> Process Gateway -> MS Azure -> Configuration file: specific entries for MS Azure

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The configuration file zenProcGateway.ini contains specific entries for MS Azure.

[Azure]

Entry | Description
INTEGRITYPERIOD= | Interval of the write cycle in seconds.

[VARIABLES]

Entry

Description

Name_n=

Name of the variable for Process Gateway.
Format: SOURCEPROJECT#SOURCEVARIABLE.

Numbering (n):

n Stands for the serial number of the connection configuration.

This numbering starts with 0.

Example:

  • 1 variable results in n = 0
  • 3 variables result in, for the third entry n = 2

Count=

Number of variables.

Note: The numbering starts with 1 here. Eight connections result in Count=8.

[CONNECTIONS]

Entry

Description

CONN_n=

Name of the MS Azure connection.

Numbering (n):

n Stands for the serial number of the connection configuration.

This numbering starts with 0.

Example:

  • 1 connection results in n = 0
  • 3 connections result in, for the third entry n = 2

QUEUE_n=

Name of the MS Azure queue.

For the numbering (_n) the same rules apply as for CONN

COUNT=

Number of the configured MS Azure connections.

Note: The numbering starts with 1 here. Two connections result in Count=2.


OPC UA Server

Manual -> Process Gateway -> OPC UA Server

The OPC server makes the variables of the project available for standard OPC client tools.

info Information

The OPC UA server can be used for all zenon versions from 5.50.

The predecessor to the OPC UA servers is the OPC server. This is not part of the Process Gateway.

The OPC UA driver and all dialogs are only available in English.

Multi-Project capability

The OPC UA server is multi-project compatible from zenon 7.11 onwards. Variable from the Runtime project and all its subprojects can be selected. In doing so, the object name from the variable name and the project name are combined. Configurations for OPC UA clients that were created before zenon 7.11 are thus not compatible. These must be amended when using zenon 7.11 or higher.


Compare OPC Server and OPC UA Server

Manual -> Process Gateway -> OPC UA Server -> Compare OPC Server and OPC UA Server

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The OPC UA server system has superseded the OPC server. Use of an OPC UA server is recommended for most applications.

OPC Server

  • OPC Task Force since 1995
  • Uniform interface for automation systems
  • Based on Microsoft's COM/DCOM technology
  • OPC foundation since 1996
  • several specifications for different applications

OPC UA Server

  • First vision 2003
  • Released in 2006, not yet all parts

Comparison of OPC server to OPC UA server

Parameters | OPC Server | OPC UA Server
Data model | Limited | for all applications
Implementation | Manufacturer-dependent | Manufacturer-independent
Interoperability | no | yes
Configuration | laborious | simple
Network use | Not recommended (security); Windows CE cannot be used | yes
Network technology | DCOM (error-prone, unstable) | OPC UA TCP binary protocol
Performance | low | high
Platforms | Windows only | independent
Redundancy | no | yes
Resource requirements | high | lower
Service-orientated architecture | no | yes
Security | outdated | In accordance with current standards
Connection security | no | provided
Windows CE | no | yes


Module configuration

Manual -> Process Gateway -> OPC UA Server -> Module configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Start:

To start the process gateway with the OPC UA module, this must be entered into the zenProcGateway.ini. The configuration of the certificate is queried when the process gateway is first started with the OPC UA module. If no independent certificates are to be used, the certificates can be automatically created by clicking on Yes.

After the Process Gateway has been started, statistical information on the number of updates in the time period displayed and the number of unsuccessful updates is displayed. The configuration can also be started in this dialog.

Parameters | Description
Exit | Closes process gateway.
Configuration | Opens configuration dialog.
Help | Opens help.

To configure the server and variables:

  1. Click on Configuration
  2. In the dialog that opens, you configure:
    • Server
    • Variables


Server

Manual -> Process Gateway -> OPC UA Server -> Module configuration -> Server

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Clicking on Configuration in the Process Gateway statistics dialog opens the configuration dialog:

Parameters

Description

Name

Name of the server as it is shown on the client.

Port

TCP port via which the client establishes the connection.

Default: 4841

Certificates path

Path to the certificate files.

Server certificate path

File with the public key of the server. Used by the client for encrypting messages.

  • Format: DER
  • Suffix: .der

Server private key path

File with the private key of the server. Is used by the server to decrypt the messages from the client.

  • Format: PEM
  • No password.

Accept secure connections only

Active: Only secure connections are accepted for establishing a connection, with the signature or with signature and encryption:

  • Basic128Rsa15:
    RSA15 as key wrap algorithm and
    128-bit basic as algorithm for the message encryption
  • Basic256:
    256-bit basic as algorithm for message encryption

Default: inactive

Note: for connections with a signature, the packages are secured against tampering, but the contents of the package are not encrypted.

Trust all client certificates
  • Active: All client certificates are accepted and the connection is made.
  • Inactive: All clients that want to connect with the server must send a valid certificate. This certificate is also checked to see if it is in the list of known client certificates (certificate trust list path).

Note: An OPCUA client without a secure connection does not send a certificate. For an OPCUA client with a secure connection, the certificate must always be stored in the Trust List folder.

Use zenon authentication
  • Active: Clients can only log on to the server with a valid user ID and password.
    Note: The user administration must be active.
  • Inactive: Anonymous login is possible.

Attention: The user name and password are not transferred in encrypted form in the OPCUA telegram. If necessary, use your own users in the project without assigned authorization levels.

Archive for historical data

Archive for historical data. Selection of the archive description from the drop-down list. Only one individual archive from one of the projects can be selected in Runtime. The archive must already have been created in the project.

OK

Applies all changes in all tabs and closes the dialog.

Attention: All active connections are ended and the server is restarted with the new settings. Connection errors may occur in the process.

Cancel

Discards all changes in all tabs and closes the dialog.

Help

Opens online help.


Certificates

Manual -> Process Gateway -> OPC UA Server -> Module configuration -> Server -> Certificates

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

All certificates must correspond to the format X509.

Certificate store

The OPC UA server in the Process Gateway uses an OpenSSL Directory certificate store. The OPCUA server cannot currently be configured and the Windows Certificate Store (local user or local machine) cannot be used.

Server certificate

The server certificate created on initial startup is a self-signed certificate. The certificate contains a public key. A suitable 1024-large private RSA key is also generated.

As a uniform resource identifier (URI) in the SubjectAltName field, it contains the Full Qualitfied Domainname (FQN) of the computer and the default port number 4841 from the OPC UA server and a DNS entry with the computer name. The URI of the OPCUA servers is compiled dynamically and changes if, for example, the port number is changed. The server certificate is not changed in this case. A client that carries out a strict check of the server certificate can, under certain circumstances, reject the server certificate.

It is also possible to use your own certificate with a suitable private key. The certificate must comply with the guidelines for Application Instance certificates in accordance with the OPC UA standard. The SubjectAltName field must contain the URI of the server.

Certificate Trust List/Certificate Trust Chain

All certificates with the suffix .der are checked by the OPC UA server and classed as a trustworthy certificate. As an alternative to the self-designated Application Instance certificate of an OPC UA clients, the public root certificate of the Certificate Authority that was used to sign an Application Instance certificate of an OPC UA client can also be stored. The Application Instance certificate of the client does not need to be present on the server in this case.

Certificate Revocation List

If an OPC UA client uses an Application Instance certificate that is signed by a Certificate Authority, the Certificate Revocation List is also checked by the server in addition to the certificate. The OPC UA server checks all files with the suffix .crl in the Crl subfolder.
Attention: The .crl file must be stored in PEM format. Only one single .crl file can be present per certificate authority.

The connection is denied if:

  • The client certificate is included in the Revocationlist BadCertificateRevoked
  • The CRL is no longer current (BadCertificateTimeInvalid)

If, for a certificate that has been signed by a Certificate Authority, there is no Certificate Revocation List, it is assumed that there is none and the certificate is considered trustworthy.


Generate new certificate

Manual -> Process Gateway -> OPC UA Server -> Module configuration -> Server -> Generate new certificate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If necessary, new certificates can be generated when the OPC UA server is started.
To do this:

  1. Remove the existing certificates.
    There are two possibilities for doing so:
    1. Delete the following folder: %programdata%\COPA-DATA\system\PKI.
      In doing so, all trusted certificates and certificate revocation lists are removed.
      Or:
    2. Delete the following files in order to get all other certificates and lists:

      zenopcua.der in the folder %programdata%\COPA-DATA\system\PKI\CA\certs

      zenopcua.pem in the folder %programdata%\COPA-DATA\system\PKI\CA\private

      zenopcua.crl in the folder %programdata%\COPA-DATA\system\PKI\CA\crl

  2. Open the zenprocgateway.ini configuration file.
  3. Navigate to the section [OPCUA].
  4. Remove the following entries:
    • CERTIFICATES_PATH=
    • SERVER_CERTIFICATE_LOCATION=
    • SERVER_PRIVATE_KEY_LOCATION=
  5. Start the OPCUA Process Gateway.
  6. Confirm the message box with yes in order to create new certificates.

attention Attention

If server certificates need to be renewed, each OPC UA client that needs a valid server certificate must receive the renewed certificate.


Variables

Manual -> Process Gateway -> OPC UA Server -> Module configuration -> Variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Variables

Variables for the OPC UA Process Gateway can be selected automatically or individually.

There are variables from the current project and its subprojects available. The name on the server consists of the variable names and the project names.

attention Attention

Variables that do not have the Setting values active property set in the Editor cannot be written to by an OPC UA client.

Defining variables

If no variables are defined in the OPC UA server configuration, then all variables from the zenon project are added to the OPC UA address space. All variables (including system variables) are visible for the clients. In doing so, each variable is given its own node with an automatically-issued numerical identifier and namespace index 80.

with manual configuration (at least one configured variable), the values defined by the user are used. The namespace index 80 and a string identifier with the variable names are also entered as standard.

Parameters

Description

Available in Scada

List of existing variables.

Filter

The existing variables can be displayed as filtered according to:

  • Project
  • Name

The placeholders (* or ?) are permitted for the filter text.

Exported to OPC UA

List of exported variables.

The variables can be sorted according to:

  • NS index
  • Identifier
  • Project
  • zenon name

Node Id

Namespace index

Defines the namespace index in the node ID for the selected OPC UA variable.

The value:

  • must not be empty
  • must be numerical
  • must be greater than 0

Identifier

Defines the identifier in the node ID for the selected OPC UA variable.

  • A numerical identifier is automatically created with numerical input.
  • If a GUID is entered, a GUID identified is created, otherwise the identifier is treated as a string.
    GUID-Form: xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx)

The field must not be empty.

To export variables to OPC UA:

  1. Select the desired variables in Available in zenon (multiple selection is possible)
  2. Click on the arrow direction Exported to OPC UA

    To export all variables, click on the double arrow

The zenon variable name is used as browser name and display name.

info Information

For zenon variables with a slash (/) in the names, the / is replaced by a dot (.). The parts of the name separated by a slash are saved in their own subfolders.

Example: The zenon variable "Static/Scalar/Int32" is divided into:

  • An OPC UA variable "Int32"
  • I a folder called "Scalar",
  • which is a subfolder of the "Static" folder

This works with all data types, multi-dimensional arrays, umlauts in names and slashes at the end.


Start:

Manual -> Process Gateway -> OPC UA Server -> Start:

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When started, the process gateway loads the configured driver.

The driver tries to read the active configuration from the given INI file. If this is not possible, an error message will be given and the configuration dialog will be opened for you. If the configuration is not confirmed with OK, the process gateway is closed.

attention Attention

If the application is started as invisible, there is also no configuration dialog displayed. If the configuration is invalid or not present, the process gateway is automatically closed.


Connection

Manual -> Process Gateway -> OPC UA Server -> Connection

The OPC UA process gateway only supports the OPC UA TCP binary protocol and does not contain a discovery server. The client must also connect directly to the server. The connection address corresponds to the scheme: opc.tcp://hostname.of.server:port

The connection can be secured.


Security

Manual -> Process Gateway -> OPC UA Server -> Security

The module uses the security procedures that correspond to OPC UA (signing and encrypting messages) as defined in the standard. Certificates can be checked or all accepted, depending on the setting.

Secure connections

If the Accept secure connections only option is activated, then the server only accepts connections that use either sign or sign & encrypt as a security mode. Furthermore, Basic128Rsa15 or Basic256 must be used by the client as a Security Policy. If this option is deactivated, any desired combination of security mode and security policy is accepted.

User administration

If user administration is activated in the zenon project and at least one user is created, the option use zenon user authentication is available. If it is activated, only clients that send a valid user/password combination have access to the data on the OPC UA server. If it is inactive, no check is carried out and both anonymous and all user/password combinations are accepted.


Alarms and states

Manual -> Process Gateway -> OPC UA Server -> Alarms and states

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The OPC UA Process Gateway supports the zenon information model for alarms and states. It is activated as soon as a variable has at least a limit value.

From the time of activation, a linked client can be informed about limit values of a variable being exceeded. It is also in a position to confirm the alarm, as in zenon Runtime.

The OPC weighting, as defined in the standard, is shown on the index of the alarm/event classes linked to the limit value. The index of an alarm/event class is automatically incremented by the zenon Editor with each new alarm/event class and can be checked in the properties. Up to 20 classes with the following allocation are supported:

OPC UA range | zenon alarm/event class | OPC weighting
HIGH | 20 | 1000
 | 19 | 950
 | 18 | 900
 | 17 | 850
MEDIUM HIGH | 16 | 800
 | 15 | 750
 | 14 | 700
 | 13 | 650
MEDIUM | 12 | 600
 | 11 | 550
 | 10 | 500
 | 9 | 450
MEDIUM LOW | 8 | 400
 | 7 | 350
 | 6 | 300
 | 5 | 250
LOW | 4 | 200
 | 3 | 150
 | 2 | 100
 | 1 | 50

If a variable with no alarm class is linked, the lowest possible classification 1 (LOW) is used.

Illustration zenon alarm as object

zenon variables and related alarms are illustrated in the OPC UA server as objects.

The screenshot displays the inclusion of the zenon project (TEST651) and the zenon variables (WIZ_VAR_10, WIZ_VAR_11, WIZ_VAR_12) as objects in the upper area. This includes the alarms when the limits set up have been reached (Limit 750 reached! etc).

Logging

The driver supports a comprehensive logging function via the diagnosis viewer.


Service Sets

Manual -> Process Gateway -> OPC UA Server -> Service Sets

Service Set | Is supported
Discovery Service Set |
FindServers | yes
GetEndpoints | yes
RegisterServer | No
SecureChannel Service Set |
OpenSecureChannel | no
CloseSecureChannel | no
Session Service Set |
CreateSession | yes
ActivateSession | yes
CloseSession | yes
Cancel | no
NodeManagement Service Set |
AddNodes | no
AddReferences | no
DeleteNodes | no
DeleteReferences | no
View Service Set |
Browse | yes
BrowseNext | no
TranslateBrowsePathsToNodeIds | yes
RegisterNodes | no
UnregisterNodes | no
Query Service Set |
QueryFirst | no
QueryNext | no
Attribute Service Set |
Read | yes
HistoryRead | yes
Write | yes
HistoryUpdate | no
Method Service Set |
Call | yes
MonitoredItem Service Set |
CreateMonitoredItems | yes
ModifyMonitoredItems | yes
SetMonitoringMode | yes
SetTriggering | no
DeleteMonitoredItems | yes
Subscription Service Set |
CreateSubscription | yes
ModifySubscription | yes
SetPublishingMode | yes
Publish | yes
Republish | yes
TransferSubscriptions | no
DeleteSubscriptions | yes


Error message

Manual -> Process Gateway -> OPC UA Server -> Error message

Error mesages in the log file:

Error message | Debug Level | Description
Failed to validate client certificate | Error | The client certificate could not be validated. It is either invalid (the date of validity may have been overwritten) or it was not found in the list of known client certificates. Additional information including an error number describes the error in more detail.
Wrong user/password supplied while trying to activate session (User: %s) | Error | User authentication failed. The name for the user to be authenticated is displayed.
Login of user '%s' succeeded. | Deep Debug: | User authentication successful.
Variable '%s' could not be added to OPC UA address space, because node '%s' with the same node identifier already exists | Error | A variable defined by the user could not be created, because another variable with the same identifier already exists.
Failed to initialize server architecture: An internal error occurred as a result of a programming or configuration error. (0x80020000) | Error | A certificate file, private key file or certificate revocation list file is not in the correct format.


SNMP agent

Manual -> Process Gateway -> SNMP agent


SNMP architecture

Manual -> Process Gateway -> SNMP agent -> SNMP architecture

The Windows SNMP agent supports SNMP version 2 (SNMPv2c). It also supports the SNMP functions (GET, GETNEXT, GETBULK, SET, TRAP).

More details about Microsoft's implementation of the SNMP can be found on the Microsoft TechNet Website: “How SNMP Works” http://technet2.microsoft.com/windowsserver/en/library/bf555774-2d63-4e96-b432-c4b7bcac6b531033.mspx

Windows operating system components with a connection to the Process Gateway and the Runtime:


Management Information Base (MIB)

Manual -> Process Gateway -> SNMP agent -> Management Information Base (MIB)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Management Information Base (MIB) is organized in the form of a tree structure, in which the SNMP agent provides the variables = (OID – Object Identifier). See below: the MIB structure, with additional variables provided via the Process Gateway.


MIB structure

Manual -> Process Gateway -> SNMP agent -> MIB structure

Info block structure is always present |  |  |  |
OID | Description | Data type | Access | Change is sent as Trap
1.3.6.1.4.1.300.1.1.0 | copadata.info.statusinfo, Runtime is (Online, Offline) | string | read | yes
1.3.6.1.4.1.300.1.2.0 | copadata.info.statusval, Runtime is 1=Online 0=Offline | integer | read | yes
1.3.6.1.4.1.300.1.3.0 | copadata.info.watchdog | integer | read | no
1.3.6.1.4.1.300.1.4.0 | copadata.info.project, name of project which the Process Gateway reads variables from | string | read | no

Variable structure (table) is dynamically adjusted, according to the configuration of the Process Gateway |  |  |  |
OID | Description | Data type | Access | Change is sent as Trap
1.3.6.1.4.1.300.2.1.0 | copadata.variables.ifNumber, number of configured variables=OID | integer | read | yes
1.3.6.1.4.1.300.2.2.1.X | copadata.variables.ifTables.ifIndex, configured OID index from the Process Gateway configuration | integer | read | no
1.3.6.1.4.1.300.2.2.2.X | copadata.variables.ifTables.ifName, variable name | string | read | no
1.3.6.1.4.1.300.2.2.3.X | copadata.variables.ifTables.ifValue, variable value as Integer. All numerical data types are formatted to an SNMP Integer data type. ATTENTION: the decimal places of REAL and DOUBLE are lost. | integer | according to configuration in Process Gateway | no
1.3.6.1.4.1.300.2.2.4.X | copadata.variables.ifTables.ifValueAsString, variable value as String. All numerical data types are formatted to an SNMP String data type. | string | according to configuration in Process Gateway | yes
1.3.6.1.4.1.300.2.2.5.X | copadata.variables.ifTables.ifStatus, variable status value | integer | read | yes
1.3.6.1.4.1.300.2.2.6.X | copadata.variables.ifTables.ifTimestamp, variable time stamp | integer | read | yes


Module configuration

Manual -> Process Gateway -> SNMP agent -> Module configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following dialog appears after the Settings button is clicked:

Here the variables that should be connected can be selected. On the left-hand side all variables which are available in zenon are displayed. You can select them there and move them to the SNMP export list with the button > You can remove them from the export list with the button “<”. If you move a variable to the export list, a dialog for the name assignment of the zenon variable to an OID address in the SNMP structure appears:

The variables selected in this way are then available on the SNMP server and are continuously synchronized between zenon and the SNMP OID structure. For every OID address you can define whether it can be write-accessed via SNMP SET. The exact structure of every OID address is described in the chapter "MIB structure.


Configuration file: specific entries for Access SNMP

Manual -> Process Gateway -> SNMP agent -> Configuration file: specific entries for Access SNMP

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The configuration file must be in the system folder.

Parameters | Description
[SNMP] |
REFRESHRATE | Update time in milliseconds

Parameters | Description
[VARIABLES] |
COUNT | number of variables to be exported
NAME_n | name of the variable with the number n (0<=<COUNT)
PARAM_n | Parameter SNMP OID table offset and the information R=read only / RW=read and write with the number n (0<=n<COUNT)

Export of variables

For the successful export the project name in zenProcgateway.ini in folder %CD_SYSTEM% must be entered correctly. Enter it here:

[DEFAULT]
PROJECT=

Attention: If the entry is wrong or missing the gateway is closed without any error messages. Thus the variable is not available.


Configuration of the Windows SNMP agent

Manual -> Process Gateway -> SNMP agent -> Configuration of the Windows SNMP agent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To make sure that the Windows SNMP Agent (SNMP.exe) provides the zenon MIB partial structure, the Process Gateway file AccessSNMP.dll in the registry must be configured accordingly:

  1. Installation of the Windows SNMP service via the control panel:
    • Via module: Programs and functions - >Activate or deactivate Windows functions.

    Note: With Windows 8, the computer must be restarted once the SNMP service has been added.

  2. Installation of Process Gateway with the file AccessSNMP.dll in the folder
    %Program Files (x86)%\COPA-DATA\zenon 7.20
  3. Add the following keys and character strings using the registry editor. The paths and content are sometimes different for 32-bit systems and 64-bit systems:

    32-Bit:

    • [HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\SNMP\Parameters\ExtensionAgents]
      Name=ProcessGateway
      Value=SOFTWARE\COPA-DATA\SNMP\CurrentVersion
    • [HKEY_LOCAL_MACHINE\SOFTWARE\COPA-DATA\SNMP\CurrentVersion]
      Name=Pathname
      Wert=C:\Program Files\COPA-DATA\zenon 7.20\AccessSNMP.dll

    64-Bit:

    • [HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\SNMP\Parameters\ExtensionAgents]
      Name=ProcessGateway
      Value=SOFTWARE\COPA-DATA\SNMP\CurrentVersion
    • [HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\COPA-DATA\SNMP\CurrentVersion]
      Name=Pathname
      Value=C:\Program Files (x86)\COPA-DATA\zenon 7.20\AccessSNMP.dll
  4. Start the SNMP service.
    This loads the process gateway file AccessSNMP.dll via the registry configuration.
    Further configuration settings for the Windows SNMP service: Control panel -> Administration-> Services-> SNMP service-> Properties
    1. Traps: tab Defines the IP address in the network to which traps are sent:

    • Communityname: Must be identical on manager and agent
    • Trap destinations: Addresses of the destinations as host names, IP addresses or IPX addresses
    1. Security: tab Defines the rights with which an SNMP client can access the SNMP agent:

    • Rights: Must be set to "READ WRITE"
    • Community: Must be identical on manager and agent


SQL

Manual -> Process Gateway -> SQL


Module configuration

Manual -> Process Gateway -> SQL -> Module configuration

The configuration of the database connection consists of two parts.

  1. OLE-DB connection: This OLE-DB connection can be defined in the configuration dialog using the selection button for the connect string. Then the standard dialog for data connection properties is opened.
  2. Additionally the name of the table can be defined, if the standard name ONLINE_VALUES should not be used.
    This can be set with the TABLE entry in the [DATABASE] section of the configuration file (zenProcGateway.ini). The settings are taken over by the add-on when starting it.

attention Attention

If table names are defined manually in the configuration file (zenProcGateway.ini), these table names must also be amended or created in the database by hand.

Oracle databases

Use of the Process Gateway and AccessSQL.dll in conjunction with Oracle databases can cause errors: It it possible, with some ODBC drivers, that no online values are written to the database. The advanced ODBC logging then issues the error message "1843".

The problem can be solved by changing the ODBC driver. For example, the ODBC driver 9.02.00.05 for Oracle 9.2 works.


Variable selection

Manual -> Process Gateway -> SQL -> Variable selection

In the configuration dialog the zenon variables that should be written to the SQL process image can be defined. In order to do this the variables available in the zenon project - listed in the left part - have to be added to the image - listed in the right part.


Creating tables

Manual -> Process Gateway -> SQL -> Creating tables

After closing the configuration dialog with OK, the table structure of the SQL database is automatically generated. For the case, that it is created by hand:


Operation in a redundant system

Manual -> Process Gateway -> SQL -> Operation in a redundant system

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In redundant operation two alternatives are available. In the first way the SQL database runs locally on both servers and the Process Gateway also runs on both servers. As only online values are handled no further alignment between the databases is necessary. The big disadvantage of this version is the high network load that is a result from the additional reading of online values on the Standby Server.

In the second version the Process Gateway only runs on the Runtime server and writes data to a local or a remote SQL database. In this alternative no additional network load between the Runtime Server and the Standby Server occurs and in the case of the remote SQL database the Server is not strained by external requests to that database.


Configuration file: specific entries for AccessSQL

Manual -> Process Gateway -> SQL -> Configuration file: specific entries for AccessSQL

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The configuration file must be in the system folder.

Parameters | Description
[DATABASE] |
INITSTRING | OLE-DB connect-string to the SQL database
TABLE_ONL | name of the table that receives the process image
TABLE_VAR | name of the table that receives the variable IDs
REFRESHRATE | maximum refresh rate in milliseconds

Parameters | Description
[VARIABLES] |
COUNT | number of variables to be exported
NAME_n | name of variable number n (0


Table format

Manual -> Process Gateway -> SQL -> Table format


Table for process image

Manual -> Process Gateway -> SQL -> Table format -> Table for process image

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
VARIABLE | int[4] | ID of the zenon variable
VALUE | varchar[64] | current value as string
VALUE_NUM | float | current value as float
TIMESTAMP | int[4] | time stamp of the current value (as UNIX time)
TIMESTAMP2 | datetime | time stamp of the current value (as datetime)
STATUS | int[4] | status word of the current value


Table for variable IDs

Manual -> Process Gateway -> SQL -> Table format -> Table for variable IDs

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
VARIABLE | int[4] | ID of the zenon variable
NAME | varchar[128] | name of the control system variable


Production and Facility Scheduler (PFS)

Manual -> Production and Facility Scheduler (PFS)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Production & Facility Scheduler (PFS) allows executiong actions (e.g. changing of a variable's set value, executing a function) for a period of time or in a time grid.

tutorial License information

Must be licensed in Editor and Runtime.

Context menu Project manager

Menu item | Action
New time model group | Opens the wizard for creating a new time model group.
New event | Creates a new event.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.


General

Manual -> Production and Facility Scheduler (PFS) -> General

The optional module Production & Facility Scheduler (PFS) enables actions to be executed in relation to a specific period of time or according to a time model.

The PFS can be configured in both the Editor and Runtime environments. Configuration within the Runtime environment can be restricted by applying user rights. All configurations established in relation to the Runtime environment can be read back to the Editor; otherwise these configurations are specific.

All stated times are independent of time zone and daylight saving time and standard time.

info Information

If the project is not displayed after the Editor is started:

  • open the menu Option
  • select the command Project manager


Toolbar and context menu PFS

Manual -> Production and Facility Scheduler (PFS) -> Toolbar and context menu PFS

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Symbol | Description
Function new ... | Depend on the selected element, a new element is created and the respective dialog is opened.
Cut | Cuts the selected element.
Copy | Copies selected element.
Paste | Pastes the element from the clipboard.
Delete | Deletes selected element
Help | Opens online help.

Context menu

Menu item

Action

Save

Saves changes in the engineering of the PFS.

Reject

Rejects all changes since the last time the PFS has been saved.

Properties

Opens the dialog for configuring:

  • Time change
  • Holidays
  • Table color
  • Record shift times

Switching point preview

Opens the switching point preview dialog.

Filter criteria ...

Opens the dialog for selecting filters.

Help

Opens online help.

info Information

You can find explanations on context menus of individual elements of the tree and the table in the respective chapters especially in chapter Object types.


Views in the Production Facility Scheduler

Manual -> Production and Facility Scheduler (PFS) -> Views in the Production Facility Scheduler

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The PFS environment display is divided into two areas: The hierarchical tree view on the left side and the table view on the right side.


Tree view

Manual -> Production and Facility Scheduler (PFS) -> Views in the Production Facility Scheduler -> Tree view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The tree view enables users to easily identify on which level an object is located, and to which element(s) it relates. The tree view's congruence is illustrated by level lines. This is important information as the behaviour of objects depends on their relations.
A context menu, specifically related to each type of object, can be opened by right-clicking on the required object.

This area also enables users to copy, move and delete objects, provided that they are authorised to perform such operations.


Table view

Manual -> Production and Facility Scheduler (PFS) -> Views in the Production Facility Scheduler -> Table view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The right-hand area of the PFS environment displays, according to the type of object selected in the tree view, the data related to the object. Some objects (e.g. schedules) can be configured in greater detail in this area, whereas other objects only enable users to display their current configuration, which cannot be modified here. For example: Events

If editing in the table is possible, you can access the necessary commands via context menus. So you can define the desired settings.

With some object types, users can also enter data directly into the table's cells e.g. times to be used in schedules.


Engineering with the Production and Facility Scheduler

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this section, we will proceed, step by step, to create a first PFS project; throughout this procedure, we will perform the following operations:

  • Creating time model groups, models and schedules.
  • Creating absolute and relative times using links to variables and/or functions.
  • Creating and executing user-defined events.
  • Using editing functions such as copying, moving and deleting.
  • Linking schedules and models within the calendar.
  • Checking over the created configuration using the switching point preview mode.
  • Creating schedules in relation to the Runtime environment.

You should be familiar with creating projects, variables, functions, frames and screens. In this regard, only descriptions of the settings directly related to the PFS will be provided in the following section. If you need more information on these basic functionality, please refer to the appropriate chapter in the documentation.

info Information

Labels in lists such as calendar, schedules, events etc, are always displayed in the language the project was created.


Task description

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Task description

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The task we must create is set as follows: a factory workshop (Hall I), containing two production lines (Line I and Line II) running on a shift from 06.00 to 18.00, must be heated, and its lighting system switched on and off. The heating needs a pre-heating time of 2 hours for line I and 1 hour for line II, where production line I has to be heated to 83° and production line II to 45°. If there is no production, heating should go down to 20°. Lights should be switched on 10 minutes earlier or switched off 10 minutes later. The production shift's start and end, as well as the various breaks' start and end, are signalled by a six-second horn tone. A break is scheduled for 15 minutes at 9.00, lunch break is scheduled for one hour at 12.00, and another break is scheduled for 15 minutes at 15.00. Production takes place 5 days a week; no production is scheduled on holidays or weekends. This workshop is located in Austria. Every 6 hours, the waste water pump must be activated for 30 seconds.


Step 1: Preparatory work

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 1: Preparatory work

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this step, we will carry out some preparatory tasks prior to configuring the PFS. We will create a project, a driver is implemented and the necessary variables for our example are created.

  1. Create a new project named PfsSample in a new workspace.
  2. In the context menu of the project select Runtime files ->RT changeable files....
  3. Deselect the Do not generate and transfer checkbox for the PFS. This way, any changes made to the PFS in the Editor will be recompiled; changes made in the Runtime environment will however be lost.
  4. Deselect the Do not decompile checkbox for the PFS. Changes made in the Runtime are transferred to the Editor with decompiling.
  5. Integrate the simulation driver. Accept all settings of the configuration.
  6. Create the following variables:
    • HD-Bit; Offset 10; Bit 0; Name: Horn
    • HD-Bit; Offset 10; Bit 1; Name: Light I
    • HD-Bit; Offset 10; Bit 2; Name: Light II
    • HD-Bit; Offset 10; Bit 3; Name: Waste water pump
    • HD-Word; Offset 11; Name: Heating P I
    • HD-Word; Offset 12; Name: Heating P II
  7. Activate the PFS by clicking on the appropriate node in the project manager. The empty PFS workspace should now be displayed on the screen.
  8. Maximize the window Project info by activating the option Float in main window or deactivating the option Allow docking in the context menu of the window. An enlarged display area within the project window proves very useful when configuring the PFS.


Step 2: Settings Production and Facility Scheduler

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 2: Settings Production and Facility Scheduler

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this step, we will configure parameters that apply to the whole of the PFS environment. To determine the appropriate holidays, you must specify in which country the current PFS project is set.


Step 3: Create time model groups

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 3: Create time model groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this step, we will create a new time model group, and configure it according to our requirements.

In this case, Hall I will be designated as the time model group, as this hall requires specifically designed models (refer to time model object). Whenever several different models are required for one same calendar day, you will be required to divide a project into several different time model groups.

Expand the main node Production & Facility Scheduler. You should now see 3 additional entries. Time model groups, Events and Calendar

Right-click on the Time model group entry to open the context menu, and click on the Create item. Now page Time model group properties of the time model group is displayed. The Label field remains empty, as we are creating a new time model group.

Type Hall I in the Name field - i.e. the new time model group name. The time model group's designation (i.e. label) must be unique throughout the whole of the PFS environment. In this particular case, we are quite sure it is.

The Start of day (00:00:00) and End of Day (23:59:59) parameters can remain as such. These statements define the time model group's cycle for one full day.

Once you have made sure that the time model group designation is valid, click on OK to save these settings and create the new time model group.

You can now see a new entry has appeared under the Time model group header, called Hall I; this entry contains two further entries: Schedules and Time models.


Step 4: Create model

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 4: Create model

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Models are required to define relative times, and contain all the shift and break time information.

Select the Create menu item in the Time model context menu.

A new time model, named New time model has now been created. When it appears on screen, this entry automatically switches to "Rename" mode, as the presence of the input field reveals. Rename the entry to Workday. Should you involuntarily click anywhere else on the screen, the program exits "Rename mode" for this entry, and the model designation New time model remains. Click twice (but don't double-click!) on the New time model label to switch back to "Rename mode". You can also do this by selecting the Rename item in the relevant context menu. The designation provided must be unique throughout all of the time model group.


Step 5: Create shifts and breaks

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 5: Create shifts and breaks

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Shifts are a decisive element in the process of defining relative switching times. This consideration not only concerns relative events such as Shift start and Shift end, but also the identification of production start and production end times.

Select the top cell in the Shift/Break column. To create a new shift, select the Create shift context menu item. Be sure to provide a unique designation for the new shift. We name the shift Shift 1. With the tab key or the mouse we move to the column Start time. Our shift should start at 06:00:00 a.m. and last until 06:00:00 p.m. So as a start time we enter 06:00:00 and as an end time 18:00:00.

Shifts are displayed on a grey background, whereas breaks are displayed as white areas.

Our working forces fortunately also get to take some breaks throughout the day, which we shall now define. To do so, select a cell from a line within the shift, and open the relevant context menu. To define a new break, select the Create break menu item. We shall call this new break Morning. We want our first break to start at 09:00:00 and end at 09:15:00.

We shall now proceed to create the lunch break. Designation: Lunch break; start: 12:00:00; End: 1:00:00 PM

There remains one break, namely the afternoon break, which we have yet to create. Name: Afternoon; start: 15:00:00; End:

Our model named Working day should now be configured as follows:


Step 6: Define holiday model

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 6: Define holiday model

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As no production takes place on bank holidays - whereas such holidays can occur on any day between Monday and Friday -, holidays require the use of a specific model. This model is very simple, as it contains no shifts. In this situation, you should always remember that a model related to a special day has priority over default models used for "usual" Monday-to-Sunday weeks. The emphasis lies on "default models". To briefly explain this, let us simply say that single-day allocations have a higher priority level than special days. A model which does not comprise any shifts possesses the same priority level as a day to which no models are linked.

As described in step 4, create a model named Holiday. No shifts whatsoever are to be defined in this model.


Step 7: User-defined event horn duration

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 7: User-defined event horn duration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

We shall now configure the project in order to make a horn sound for 6 seconds, both at the start of shifts and breaks as well as at the end of shifts and breaks. This six-second horn tone can be defined very efficiently by means of a user-defined event.

What is a user-defiend event? User-defined events are in fact relative switching times, which are special owing to the fact that they can be defined by the user proceeding to define the project. To initiate a user-defiend event, select the PFS: execute event menu item. This function will define the execution time point for the function as a trigger for the required user-defined event. The actual execution of the event will then occur, according to any offset value you may have configured.

Now that we have broached the principle, let us proceed to the creation. Right-click on the Event entry to open the context menu, then create a new event by clicking on the Create item. The event is created with the name New user event, and the new entry automatically switches over to "Rename mode". As you recall, the procedure is very similar in style to that described in step 4, "Creating Models". Change the event's designation to Horn tone. The event's designation must be unique throughout the whole of the PFS environment.

Access the function administration area, and add the PFS: execute event function to the Horn Tone user-defined event.


Step 8: Thoughts about schedule structure

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 8: Thoughts about schedule structure

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The project we are currently defining comprises two production lines, which we shall include in separate schedules. At the same time however, some tasks will be identical for both lines. On both lines, the lights must be switched on 10 minutes before the shift starts, and be left on for 10 minutes after the shift has ended. This will be represented in an additional, upper-level schedule. We shall here make good use of the program's capacity to hand times from previously defined schedules down to subsequent schedules. However, only the switching point in fact remains identical here, as each production line is equipped with its own lighting system. The waster water pump must also be activated, and this will follow in the additional upper-level schedule.

After this, we will still need to configure the horn. This configuration is identical on both lines, since only one horn equips both halls; hence, this will be treated in the additional upper-level schedule.

Hall schedule. Hall designation. We must configure the horn, the waste water pump and the lighting system's timing.

Schedule for Line I: Additional lower-level Hall schedule. Designation for Line I; lights must be switched on and off. Set temperature.

Schedule for Line II: Additional lower-level Hall schedule. Designation for Line II; lights must be switched on and off. Set temperature.

Now that we have established these principles, we shall create the schedules themselves.


Step 9: Schedule for the hall

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 9: Schedule for the hall

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The first schedule we must create contains the switching points for Hall I. In addition, it also contains all the switching times, which must be identical in the additional lower-level schedules.

Let us start by creating our first schedule. In order to do so, expand the Production & Facility Scheduler, Time model group, Hall I branches in the tree view so that the Schedule entry located near time model group Hall I is visible. Right-click on the Schedule entry to open the appropriate context menu, and click on the Create item. The various schedule-related settings are now displayed on screen. In the field Name specify the schedule name Hall. The schedule should now be active (i.e. the checkbox Activate schedule checkbox should be selected), and should not be defined as a structure schedule (the Structure schedule checkbox should not be selected).

We must be able to execute the user-defined event Horn Tone. To do so, we will add this specific function to the list of functions used in the schedule. Right-click on the Function list entry to open the appropriate context menu, and click on the item Add function. Confirm the previously defined function PFS - execute event [Horn tone]. This function shall now be added to the schedule's list of functions, and can be used as of now.

In addition, we want to create and save the variables Horn and Waste water pump, which will serve to activate the horn and waste water pump. To do so, we must add these variables to the schedule-specific list of variables. Open the relevant context menu, and click on the item Add variable. The list of variables that then appears onscreen enables you to add the required variables; to do so, double-click on a variable in the list of available variables, or select a variable before clicking on the button Add.

Once you have defined these actions, your schedule should be configured as follows.


Step 10: Thoughts about the times

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 10: Thoughts about the times

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Times serve to define the point in time for the execution of switching points. Two different types of time are available:

Absolute time: this type requires you to directly provide a specific time. The execution time itself will not change, regardless of whether the switching point has been executed or not. Execution will only be withheld if the schedule or the switching point have been deactivated, or if the schedule has not correctly been linked to the day. This type of time is ideal when an execution time has been categorically defined.

Relative time: In this case, the effective execution time depends not only on the configured type of event, but also on the way models are positioned in the calendar, on the type of day (standard day or holiday), and a number of other factors. The execution conditions are described in detail in the Time types section. Basically, the execution point of time depends on a number of other factors, hence the "relative time" denomination. The interest in using this type of time is that, in the event where a reference needs to be modified, all related execution times will be updated automatically. However, there is also one disadvantage which users should bear in mind. Owing to the fact that the execution time is not directly displayed, times defined using this time type cannot be supervised as easily as absolute times. The switching point preview mode however provides a solution to this problem.

So, which time types should we use to meet the requirements of our task? To answer this question, let us briefly consider how and why various actions should be carried out and various elements switched on/off.

First of all, the horn. It should sound for 6 seconds whenever shifts and breaks start or end. The start of the horn tone is directly related to each shift or break. We know when the shifts and breaks start and end. Thus, it should be possible to use these times directly. However, when a shift changes, these times must be adapted; therefore, other related times (e.g. silencing the horn) will need to be adapted likewise. This can be the cause of quite a few mistakes. By using the relative times Shift start, Shift end, Break start and Break end, any necessary adjustments will be performed automatically. To obtain a 6-second horn tone, we shall apply a 6-second offset to our user-defined event, which will define the horn deactivation.

The production lines lighting system. These depend directly on the shift times, and shall therefore be executed as Shift start and Shift end.

The production lines temperatures. These also depend directly on the shift.

The waste water pump. This element should be activated at specific intervals - every 6 hours - for 30 seconds. There is no specific relation to the shifts or breaks. Therefore, absolute times are definitely recommended here.

Now that we have analysed the various execution times, we can proceed to the configuration itself.


Step 11: Times for the schedule Hall

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 11: Times for the schedule Hall

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

We shall start by creating the starting time for the waste water pump operation. To do so, select the cell in the first row near the column Type of time. Open the relevant context menu, and select Create time grid; this opens a dialog, enabling you to create a time grid. Once you activate the checkbox As cyclic time, the additional fields are activated.

Fill in the required fields in the dialog according to the screen capture above. With our settings four absolute times are created. Midnight, 6:00 a.m., noon and 6:00 p.m.

30 seconds after activation, the pump must be switched off. Therefore, we shall now define another 4 switching times, applying, as we do so, a 30-second offset to the times we have already set. To obtain this offset, specify 00:00:30 as a start time.

We shall now proceed to configure the horn. Right-click on the table view to open the relevant context menu, and select Create time. A new absolute time period has now been created. However, we now require a relative time. Switch over to the Type of time column in the same line, and change the time type to Relative. Now, if you change back to the column Time, the time indication disappears, and a list box containing the available relative events is activated. Select the event Shift start. The offset value remains 0, as the horn must be activated immediately at the start of the shift. The horn must not only announce shift starts, but should also sound at shift ends, break starts and break ends. Therefore, create 3 additional relative times with the matching relative events. The horn should be switched off 6 seconds after being activated. To configure this, add a relative time with the relative event Horn Tone to the list. Horn Tone is the user-defined event we previously defined. Specify a 0.1 minute offset, i.e. 6 seconds. This value defines the horn tone duration.

We shall now deal with the heating issue. Create 2 relative times - for the shift start, use offset values of -120 and -60, respectively.

We are still missing the activation times for the lighting system. Create 2 relative times - for the shift start, use an offset value of -10, and for the shift end, use an offset value of 10.


Step 12: Switching points schedule Hall

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 12: Switching points schedule Hall

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

We have used times to define moments at which events are executed, and must now define what will actually happen at the specified time. This is what switching times are used for.

Let us begin with the waste water pump. Select the absolute time period 00:00:00. In the context neu click the entry Create switching point. A new line is added just after the selected time; this line represents the switching point. Switching points contain the following columns: Active, Type of link, Links, Action and Password. Let us take a quick look at these fields.

Active: This field enables you to deactivate a switching point. You can use it to block a switching point’s execution.

Type of link: This field specifies if a variable must be modified, for instance, or if a function must be performed. The other types of links are broached in the Switching point object section.

Links: According to the selected type of link, this field enables users to select the required variable or function.

Action: When the Variable link type is selected, this field contains the set value which must be written. When dealing with functions, this field is just as important as the Active field.

Password: Enables specific permissions to be requested for the configuration of the Runtime environment.

We shall now proceed to define the switching point. The currently selected column is Type of link. Select the item Variable from the list box. Now, change to the column Links. Select the Waste water pump from the list box. Now, change over to the column Action. In this column, specify a value of "1". This means that at 00:00:00, the set value will be set to 1 for the Waste water pump variable.

Now, create the following switching points, proceeding as described above:

  • 12:00:30 AM Variable: Waste water pump; Set value: 0
  • 6:00:00 AM Variable: Waste water pump; Set value: 1
  • 6:00:30 AM Variable: Waste water pump; Set value: 0
  • 12:00:00 PM Variable: Waste water pump; Set value: 1
  • 12:00:30 PM Variable: Waste water pump; Set value: 0
  • 6:00:30 PM Variable: Waste water pump; Set value: 1
  • 6:00:30 PM Variable: Waste water pump; Set value: 0

We shall now deal with the horn. As you recall, we have defined a number of relative times for the horn.
Shift start offset 0, Shift end offset 0, Break start offset 0, Break end offset 0 and Horn Tone offset 0,1.
Two switching points must be executed for the horn tone start and end, respectively. The first switching point activates the horn. The second switching point triggers the user-defined event Horn Tone.
The relative time Horn Tone must then deactivate the horn. So, let us proceed to create the required switching points. Unlike the waste water pump configuration above, this configuration uses 4 different times, thus requiring several switching points. For instance, for the time Shift start offset 0 we could activate the Create switching points function twice consecutively. However, a more convenient solution is provided. To do this select the time Shift start Offset 0. In the context menu activate Add switching points. The program now displays the Create switching points dialog. Select the function PFS Event [Horn Tone] and the variable Horn. Then click on Add to effectively add these to the results list. After you have clicked on OK, two switching points using the relevant Type and Link parameters will be created. You must still set the set value to 1 for the switching point variable Horn. Now, use the same method to define the switching points for the relative times Shift end, Break start and Break end. We shall now create the final switching point for the horn by defining for the relative time Horn tone a switching point which will sets the variable Horn to 0.

info Information

A decimal value can be entered with a colon as well as with a point, the decimal point will automatically be changed to a point.


Step 13: Schedule line I

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 13: Schedule line I

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When we previously considered the facility's structure, we decided to deal with the temperature and lighting system in additional, lower-level schedules.

Thus, we shall now create the schedule for Line I. To do so, select the schedule Hall in the tree view. Open the context menu and select Create to activate the Schedule Properties dialog, as we have already discussed. The Name should be Line I, and we shall not add any variables to the contents already provided. This section will provide the opportunity to learn about the subsequent modification of variable and function links.

Select Line I in the new schedule and the variable list in the tree view. We link the variable Light i and Heating P I with the schedule via the context menu and Add variable.

When you select schedule Line I, all times defined in previous schedules are displayed on a grey background in the table. Times displayed on a grey background identify times that have been "inherited" from previously defined schedules. If a previously defined item is altered in the "parent" schedule, times in the "child" schedules will be updated automatically.

We shall now define the switching times for the Temperature and Lighting system elements. To do so, proceed as you did in the schedule Hall.


Step 14: Schedule line II

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 14: Schedule line II

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Create a new schedule, named Line II, with the identical purpose of managing switching points.


Step 15: Thoughts about calendar allocation

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 15: Thoughts about calendar allocation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Times defined in schedules are not related to any dates; these relations will be defined by allocating the times to days in a calendar. This allocation process must be carried out separately for absolute and relative times. Allocations can be carried out for each separate time model group.


Absolute times

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 15: Thoughts about calendar allocation -> Absolute times

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When dealing with absolute times, the linking of the schedule to specific calendar days is a decisive element. In this case, the following types of links are supported:

Use schedule on this day.

Do not use schedule on this day.

Use schedule on this holiday.

Use schedule on weekdays.


Relative times

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 15: Thoughts about calendar allocation -> Relative times

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When dealing with relative times, the allocation of a model to a day is as decisive an aspect as the shifts defined within the model. In this case, the following types of links are supported:

Use model on this day.

Use holiday model if the concerned day is a holiday

Use model on weekdays.


Step 16: Execute calendar allocation

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 16: Execute calendar allocation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Select the entry Calendar in the tree view. The table now displays the current month. Each week comprises the Model – Hall I and Schedule – Hall I lines; select the Schedule – Hall I cell for Monday. Access the appropriate context menu, and select the Selecting schedules item to activate the schedule selection dialog. Select the schedule Hall, then click on the button Add to add this item to the results list. The complete identification Hall I. Hall, as derived from the schedule, is now displayed. Exit the dialog by clicking on OK; the Duration of series dialog is now displayed onscreen. Our schedule must be executed on a weekly basis, without any defined ending date, on days from Monday to Sunday. To define allocations to special days, access the Properties of the schedule Hall Calendar filling. This section also enables you to perform weekday allocation tasks. No calendar filling is necessary for schedules Line I and Line II, as these schedules do not use any switching points with absolute times.

Relative times will require model allocation tasks to be carried out, which we will proceed with as follows. Select the cell Model Hall I Monday. Access the appropriate context menu, and select Select model to activate the model linking dialog. Select the model Workday, then add this item to the results list. Click on OK to close the dialog; you will be asked to confirm whether this model should be defined as a default. Click on Yes: this model will now be linked to every Monday. If you click on No, the model will only be linked to this particular Monday. We shall activate this model for every Monday. You can now repeat this process for weekdays from Tuesday to Friday. However, a simpler possibility would be to access the page Properties - Calendar filling for time model group Hall I, and to proceed with allocations from there. Select the model Workday for weekdays ranging from Tuesdays to Fridays, and select the model Holiday for special days. If you now switch back to the calendar view, you will see which models are allocated to which days.


Step 17: Checking the engineering

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 17: Checking the engineering

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Editor allows you to check over the current schedule configuration and calendar filling. To do so, you will use the switching point overview mode. This preview mode enables you to view any requested period of time, including past periods.


Step 18: PFS in the Runtime

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 18: PFS in the Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Runtime environment, the activated switching points are processed and executed second by second. This process begins when the Runtime environment is started up, and remains active until the Runtime environment is closed.

The PFS also enables you to proceed to the entire configuration within the Runtime environment, which differs only slightly from the Editor.

The main differences are as follows:

  • Auhtorization for viewing, modifying, adding and deleting entries is active.
  • Context menu functions can be activated in the screen type by means of switches.
  • The switching point preview mode displays user-defined events with reference to the event's existing triggering times.
  • Saving a modified configuration activates these triggering times instantaneously.

For our Runtime environment tests, we will configure:

  • A starting screen using the screen type Standard.
  • A PFS screen using the screen type Production and Facility Scheduler.
  • In the PFS screen, the default objects.
  • In the start screen, a button which activates the "Screen: Switch to" function to switch over to the PFS screen. We shall not broach filter settings at this point.
  • In the start screen, several display fields, which will be used to display the variables' states.


Step 19: Execution in the Runtime

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 19: Execution in the Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When executing an absolute switching point, date and time indications are decisive. Relative and absolute times, which bear no relation to dates, are defined - using the calendar filling process - in relation to absolute switching times. To proceed to our tests now, we will have to change the system time - the alternative being that you have a lot of time on your hands, and can afford to wait for the end of the day!

The PFS is well aware of any changes made to the time, and such alterations can therefore, according to the current configuration and actual change in time, generate diverse reactions. For proof, let us take a look at the Properties section of the Production & Facility Scheduler. The Time change page defines the way the PFS will react when the time is changed.


Positive time change

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 19: Execution in the Runtime -> Positive time change

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Make up for switching points command initiates the execution of the switching points comprised in the period of time ranging from the command's execution to the corrected time, until the moment matching the new (i.e. corrected) time is reached.

The Recalculate switching points control initiates a recalculation of the switching points, proceeding from the corrected time onwards. Any switching points comprised in the period ranging from the command's execution time to the new (i.e. corrected) time are not executed.


Negative time change

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 19: Execution in the Runtime -> Negative time change

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Reject switching points command does not initiate any new calculations; thus, switching points will only be executed again once the command's execution time (i.e. former time) has been reached.

The Recalculate switching points control redefines the absolute switching points, proceeding from the corrected time onwards. With this command, the switching points will be executed again.

The above statements related to time correction issues are only applicable as long as the Runtime environment has not been closed down. In the event of a restart, the calculation of all switching points will always occur on the basis of the current system time. In addition, any corrections made to the system time must be greater than the time tolerance defined in the program.

Bearing in mind the way the PFS reacts in the event of change of time, we recommend that you only "increase" (i.e. proceed to "positive" time changes) the time when attempting to check over a configuration you have created. If you need to reinitialise the time, close the Runtime environment, change the time, and restart the Runtime environment.

For the time being, restart the Runtime environment, and change the time. For the sake of testing, a particularly "exciting" moment occurs at 12 o'clock: at this time indeed, the horn must be activated for 6 seconds. Test this function.

As we have only one trigger defined for the Horn Tone user-defined event, only the execution time point appears in the switching point overview. Execution time point: 12:00:06.


Step 20: Resume

Manual -> Production and Facility Scheduler (PFS) -> Engineering with the Production and Facility Scheduler -> Step 20: Resume

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Throughout these 20 steps, we have learned about the basics of the PFS. You should now be able to create your own PFS projects.

The separation of the switching times into 3 schedules is not mandatory; we proceeded this way in order to illustrate the possibility of using "inherited" (i.e. previously defined) times. Had we used only one schedule, the configuration process would have required fewer operations.

Here is a short recap of the required steps:

  1. Create user-defined events.
  2. Creating the time model group
  3. Create the models.
  4. Create the schedule.
  5. Create the absolute times.
  6. Create the relative times.
  7. Create the switching points.
  8. Link the schedule to the calendar for the absolute times.
  9. Link the models to the calendar for the relative times.


Advanced configuration in the Production and Facility Scheduler

Manual -> Production and Facility Scheduler (PFS) -> Advanced configuration in the Production and Facility Scheduler

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


Drag&Drop

Manual -> Production and Facility Scheduler (PFS) -> Advanced configuration in the Production and Facility Scheduler -> Drag&Drop

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Objects can be moved quickly and easily from one to another via drag&drop. Basically, this process is equivalent to a cut and paste operation. You must be aware that objects can only be moved towards objects of similar nature. The mouse pointer will visually indicate whether you can drop an object or not. If you attempt to drop an object on a forbidden target, the process is cancelled. This detail can prove useful, for instance if you have accidentally selected and started dragging an unrequested object to another branch in the tree view.


Filtering the PFS configuration

Manual -> Production and Facility Scheduler (PFS) -> Advanced configuration in the Production and Facility Scheduler -> Filtering the PFS configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As the number of time model groups, models, schedules and switching times grows, you will find it harder to find a specific object, or to display a relevant detailed overview. A filtering function has been designed to lessen this problem. In the tree view window, select the Filter criteria item in the Production & Facility Scheduler context menu to activate the Filter dialog. You can read more specifically about the Filter dialog in the PFS filter dialog section; for the time being, we will concentrate on utilizing the function.

Filtering is only performed on the actual display of objects. An object which does not match the filter is not be displayed. However it still exist. This indication should clear any misunderstanding that may arise - for instance, when a new schedule is created, and its name is added to a filtered schedule. This situation will indeed display an error message stating that the specified name already exists.

If new objects are created that do not correspond to the filter, these remain visible until the display is next updated. For example, the creation of a time that is outside of the filter. As long as you do not exit the current schedule, this time will remain visible. However, when the screen is next updated, the specified time will disappear - but it nonetheless remains available. The filter is first reused when the display is called up again.

Linked schedules and models within the calendar can be filtered in the same way.


Mass processing

Manual -> Production and Facility Scheduler (PFS) -> Advanced configuration in the Production and Facility Scheduler -> Mass processing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Now, who has never run into the following problem: All absolute times between 06:00:00 a.m. and 08:00:00 p.m. should be moved by 00:43:25. Then you sit there, calculate and correct all the times, and that perhaps for a dozen of times. Mass processing was integrated to the PFS in order to meet such requirements. This function enables users to make changes to selected cells on a specific schedule level, according to the required type of column. The problem we previously mentioned can therefore be solved with just a few mouse clicks and data inputs.

By using this function in conjunction with filters, you can efficiently reduce the number of elements you wish to modify.

The following columns support the mass processing function:

Parameters | Description
Type of time | Enables you to change the type of time used.
Time | For absolute times the time can be changed. To do this open the dialog Change time.
Offset | For relative times the offset can be changed. To do this open the dialog Change offset.
Active | Allows you to change the activation status.
Action | Depending on the type of link, the activation or the macro to be executed can be changed. To do this open the dialog Change value.


Structure schedules

Manual -> Production and Facility Scheduler (PFS) -> Advanced configuration in the Production and Facility Scheduler -> Structure schedules

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Structure schedules are used to create a visual structure for schedules in the tree view. A schedule becomes a structure schedule when you activate the Structure schedule checkbox in the Schedule properties dialog.

Structure schedules have no allocated variables or functions, nor do they have any allocated times or switching points. Structure schedules can replicate lower-level additional schedules, thus visually creating a logical congruence with these.


Configuring Screen switch for PFS windows

Manual -> Production and Facility Scheduler (PFS) -> Advanced configuration in the Production and Facility Scheduler -> Configuring Screen switch for PFS windows

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When used on PFS screens, the filter dialog for the Screen: Switch to function allows you to define which type of data you wish to display, and to customise the table display accordingly.

Parameters | Description
Filtering the tree view | Select the object you wish to activate when switching to the screen. The object must match the defined filter criteria, or you must first deactivate the filter. Also refer to Tree view filter for Screen switch.
Filtering the table view | This function defines the table view format. Also refer to Table view filter for Screen switch.


Permissions for the Runtime environment

Manual -> Production and Facility Scheduler (PFS) -> Advanced configuration in the Production and Facility Scheduler -> Permissions for the Runtime environment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Permissions can be granted for each object contained in the tree view, according to the concerned object's functionality. In the Runtime environment, the currently logged in user can only execute a function if he knows the appropriate password. Permissions are always object-related.

If a user does not have the rights to see an object, this object and all it sub-objects are hidden. Even if the user has rights for one of the sub-objects.

The permission required to modify an object includes the right to modify permissions.


Using the PFS in a network

Manual -> Production and Facility Scheduler (PFS) -> Advanced configuration in the Production and Facility Scheduler -> Using the PFS in a network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The PFS can be installed within a network, in which case the execution of switching points will only occur at server level. If a standby server is available, it will process the switching point list appropriately, but will however not execute any of the switching points it contains. Process synchronisation is carried out according to the system's time.

The way in which the PFS reacts when changing from the standby to the server can be configured. The problem with such changes is that the standby server cannot tell when the last switching process from the server took place. This is why the setting Reject SB switch (accessible by successively selecting Properties, Time change in the Production & Facility Scheduler) was designed.

Reject switching points | When switching points are cancelled, the process continues onwards from the current position in the standby server. This can imply that a number of switching points may not be executed.
Recalculate switching points | Switching points are recalculated on the basis of the current time -30 seconds, and their execution then begins immediately. This can imply that a number of switching points may be executed twice.

When the server once again becomes available on the network and the standby server switches over to it, the server is synchronised using the current PFS data. This ensures that the execution of the switching points continues seamlessly.

Server | Executes switching points. Saves the current PFS configuration. Rejects changes made by clients (without confirmation) if the configuration changes have not been saved.
Client | Does not ensure any switching point execution. Project data can be edited. Receives notification whenever project data items have been changed following external changes made to the project. Triggering time points for user events are always defined according to the client's system time.
Standby | As long as the standby server is the client Reaction in the event of a changeover can be configured. Saves the current PFS configuration.


Converting projects

Manual -> Production and Facility Scheduler (PFS) -> Advanced configuration in the Production and Facility Scheduler -> Converting projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When a project created using a program version prior to version 5.50 is activated, the profiles contained in the structure schedules are converted. Profiles are no longer supported in version 5.50 or later versions. For each profile, a structure schedule is created, containing the linked schedules. The linked schedules contain all the times which fall within the profile's activation/deactivation times.

The day information contained in the profile schedule is input into the calendar.

The configuration process can be viewed in the Editor's output window.


VBA interface

Manual -> Production and Facility Scheduler (PFS) -> Advanced configuration in the Production and Facility Scheduler -> VBA interface

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The PFS contains a VBA interface, which is integrated to the VBA object Project. In addition, switching points can be linked to a VBA macro of the Execute_Value type. In this case, the switching point is applied as a parameter to the VBA Macro.

Further, the VBA Macro is responsible for performing switching processing tasks.


Object types

Manual -> Production and Facility Scheduler (PFS) -> Object types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Objects contain the configuration which users have defined for them. Two types of object types can be identified:

Editable object types and Fix defined object types


Fixed object types

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Fixed object types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Provided that the previous object (i.e. 'parent object') has been created and that the relevant display permission has been granted to users, these object types are always available. They cannot be moved, renamed or deleted. If these objects are masked, all the related 'child objects' also become unavailable.
For example: Time model groups always contain the fixed object types Schedules and Time models.


Editable object types

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Editable object types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

These object types are created according to the number of objects required during the configuration process.


Production and Facility Scheduler object

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Production and Facility Scheduler object

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This constitutes the root object type for the whole of the PFS. Any settings defined in this object are then applied to the whole of the PFS. This is a fixed-type object.

Parameters | Description
Save | Saves the changes you have made. In the Runtime environment, all parameters are saved in the Runtime data, and a new calculation of the switching points is performed on the basis of the modified configuration.
Reject | After you have validated your choice by closing the confirmation dialog, all the changes you have made will be rejected. Please be aware that no cancellation is possible!
Properties | This item displays the settings pages for the PFS Properties section.
Switching point preview | Activates the switching point preview mode.
Filter criteria | Activates the Filter dialog.
Help | Activates the online help.


Object time model groups

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Object time model groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This object contains all time model groups defined in the PFS. This is a fixed-type object.

Parameters | Description
Function new ... | Creates a new time model group and displays the Properties page for the new time model group.
Paste | If a time model group is currently stored in the clipboard, it can be pasted as a copy. When copies are created, their name is extended with a number, thus maintaining the uniqueness of their designation.
Permission | Activates the object's rights dialog.
Help | Displays online help.


Object editable time model groups

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Object editable time model groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Time model groups contain their specific schedules and time models. In addition, these objects allow users to define fundamental settings related to relative switching times.

In the calendar, users can allocate schedules and models to each day for each time model group listed.

Each time model group always contains the Schedules and Time models fixed object types.

Parameters | Description
Copy | Copies the selected time model group or groups to the clipboard.
Rename | In the tree view the identification of the time model group changes to the edit mode. Only the identification can be changed. The new designation provided must be unique throughout the whole of the PFS environment.
Delete | Deletes all selected time model groups after a safety dialog requests you to confirm your choice.
Properties | Displays the page containing the time model group.
Authorizations | Opens the Permissions dialog.
Help | Activates online help.


Schedule object

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Schedule object

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This object contains all schedules of first order. This is a fixed-type object.

Context menu

Menu item | Action
Function new ... | Creates a new schedule.
Paste | Pastes a schedule from the clipboard.
Authorizations | Opens the authorization dialog.
Help | Opens the Onlinehelp.


New schedule context menu

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Schedule object -> New schedule context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Menu item | Action
Function new ... | Creates a new schedule.
Copy | Copies selected schedules.
Cut | Cuts selected schedules.
Paste | Pastes schedules from the clipboard.
Inactive/Active | Switches between active and inactive for selected schedules.
Rename | Makes it possible to rename the schedules.
Delete | Deletes the selected schedules after a confirmation message.
Properties | Opens the Properties window for the selected entry.
Authorizations | Opens the authorization dialog.
Help | Opens online help.


Context menu time display new schedule

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Schedule object -> Context menu time display new schedule

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The displayed menu items depend on the area in which the right-click was carried out. Entries which are not displayed all the time receive the additon (optional).

Menu item | Action
Create time grid | Opens the dialog for creating a time grid.
Create time | Inserts a new time in the list.
Create switching point | Creates a new switching point.
Creating switching points | Opens the dialog for creating several switching points.
Delete time | Deletes the selected time.
Delete switching points | Deletes the selected switching point.
Change time(optional) | Opens the dialog for changing the time.
Absolute point of time(optional) | Activates option Relative point of time
Relative point of time(optional) | Activates option Absolute point of time
All values active(optional) | Sets valueactive.
All values inactive(optional) | Sets valueinactive.
Help | Opens online help.


Editable schedule object

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Editable schedule object

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Schedules are the core of the PFS. They contain the times and switching points necessary to the execution of important objects.

Schedules can be replicated into new schedules, in which case the "child" schedules "inherit" any times defined in the "parent" schedules. No limitations apply to the multiple schedule's organisational depth.

Parameters | Description
Function new ... | Creates a new "child" schedule, and displays the relevant settings page.
Copy | The selected schedules are copied to the clipboard.
Cut | The selected schedules are cut and placed in the clipboard. Cut schedules are identified in a special manner, and will only disappear fully once they have been inserted (i.e. pasted) in another schedule. A schedule which you have cut cannot be pasted into itself or into the schedule located directly above it.
Paste | Inserts (i.e. pastes) schedules from the clipboard. The inserted schedule's designation is then modified, in order to preserve the uniqueness of each schedule's name.
Inactive/Active | Activates or deactivates the schedule. Switching points contained in deactivated schedules will not be executed!
Rename | Allows users to change the schedule's name. The new designation must be unique throughout the schedule level.
Delete | Deletes the selected schedules and their "child" schedules, after asking you to confirm your choice by answering a safety question.
Properties | This command displays the settings pages for the Schedule properties section.
Authorizations | Opens the Permissions dialog.
Help | Activates online help.


Functions list object

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Functions list object

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This object contains the array of functions related to the schedule. Only functions related to a schedule can indeed be used in said schedule. This is a fixed-type object.

Context menu function list

Menu item | Action
Add function | Enables users to allocate a new function to the schedule. When the list of defined functions appears onscreen, select the required function and validate it by clicking on OK.
Insert function | Inserts (i.e. pastes) functions from the clipboard into the list.
Authorizations | Opens the authorization dialog.
Help | Opens online help.

Context menu function

Menu item | Action
Copy | Copies selected functions.
Cut | Cuts selected functions.
Replace function | Opens the dialog for replacing selected functions.
Remove function | Deletes selected functions from the list.
Authorizations | Opens the Permissions dialog.
Help | Activates online help.


Object time

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Object time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Times define the time point at which linked switching points must be executed.

Two different types of time are available:

  • absolute
  • relative

Previously defined times are replicated in "child" schedules, in which they are displayed on a grey background.


Absolute time type

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Object time -> Absolute time type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Times are directly defined in the Time field. If the schedule is linked to a specific day, any active switching times linked to the absolute time point are executed. The Offset field is of no importance here.

The time model group cycle and model allocation fields are not used here either.


Relative time type

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Object time -> Relative time type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For this time type an event is selected at the time. This event is changed to an absolute switching point in the preview or in the Runtime. The criteria according to which the absolute switching point is created, depends on the event and the related engineering. An offset can be specified for each event, and will delay the execution time point accordingly.

Parameters

Description

Start of cyle

Performed daily at midnight.

Start of cycle without production

Activated on days which are not linked to any shift. The time point is the start of the day for the relevant time model group.

A day is also considered to be without production when, for instance, the last shift ends at only 02:00:00 on the same day.

Start of cycle with production

Activated on days for which at least one shift has been defined. The time point is the start of the day for the relevant time model group.

Begin of production

This event is executed at the start of the first shift, provided that the first shift follows a day without production.

End of production

This event is executed at the end of the last shift, provided that the last shift is followed by a day without production. Thus, if further production is scheduled to take place on the following day, the shift at the end of the day is not considered as an end of production.

Start of shift

This event is executed at the start of each shift.

End of shift

This event is executed at the end of each shift.

Start of break

This event is executed at the start of each break.

End of break

This event is executed at the end of each break.

User-defined event

Various previously defined user-defiend events can be allocated. The switching point will be initiated when the trigger event related to the user-defined event occurs.

Shift start first shift

Executed at the start of the first shift in the time model group's cycle.

Shift end last shift

Executed at the end of the last shift in the time model group's cycle.

Shift-free start

Activated at the end of the shift, if the start of the next shift occurs with an offset greater than 1 second.

Shiftfree end

Activated at the start of a shift following a shift-free period of time.

Shift-free start without production end

Activated at the start of a shift-free period of time, provided that no End of production is scheduled immediately after.

Shift-free end without production start

Activated at the end of a shift-free period of time, provided that no Start of production is scheduled immediately after.

Shift start first shift without production start

Activated at the start of the first shift, provided that no Start of production is scheduled simultaneously.

Shift end first shift without production end

Activated at the end of the last shift, provided that no End of production is scheduled simultaneously.

Shift start without production start

Activated at the start of the shift, provided that no Start of production is scheduled simultaneously.

Shift end without production end

Activated at the end of the shift, provided that no end of production is scheduled simultaneously.


Offset

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Object time -> Offset

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When working with relative times, the execution time point can be modified by means of an offset. An offset cannot be greater than +/- 1 day -1 second. When working with user-defined events, only positive offsets can be specified. The offset is specified in minutes, seconds being defined after the decimal point with a precision of 1/100th of a minute.

Parameters | Description
Create time grid | This command displays the settings page required for the cyclic creation of an absolute time period.
Create time | Creates a new time.
Create switching point | Creates a new switching point at the given time.
Creating switching points | Enables users to define switching points for several variables or functions within once same task, if no switching points have previously been defined.
Delete time | Deletes the selected times, including all related switching points.
Delete switching points | Deletes the selected switching points.
Absolute time period | Changes the type of time to Absolute.
Relative time | Changes the type of time to Relative.
Help | Activates online help.


Time context menu

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Object time -> Time context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The menu items not broached here are identical to those described in the Time type context menu section.

  • Change time: This menu item activates the time change dialog.


Object switching point

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Object switching point

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The switching point defines the action to be executed once the execution time point is attained.


Active

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Object switching point -> Active

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This setting enables users to authorise or block the execution of a switching point.


Type of link

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Object switching point -> Type of link

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The type of link defines which element must be executed. The following types of links can be specified:

Parameters | Description
Variable | The set value is defined using the value specified for the action.
Function | The function specified for the action is executed.
VBA Macro with Variable | The macro defined in Macro -> Browser -> ModuleScheduler -> ExecuteValue referring to the specified variable is executed.
VBA Macro with function | The macro defined in Macro -> Browser -> ModuleScheduler -> ExecuteValue referring to the specified function is executed.


Replace

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Object switching point -> Replace

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Contains the list of the variables or functions linked to the schedule.


Action

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Object switching point -> Action

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

According to the selected link type, the cell has the following significance:

Parameters | Description
Variable | The set value which must be defined for the relevant variable.
Function | Contains the state of the Active parameter.
VBA Macro with Variable | Name of the macro which must be executed.
VBA Macro with function | Name of the macro which must be executed.


Authorizations

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Object switching point -> Authorizations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Necessary authorization level needed for editing in the Runtime.


Object time model

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Object time model

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This object contains all the time models defined for the current time model group. This is a fixed-type object.

A time model contains the definition of the shifts and pauses which are required for the relevant relative events.

Context menu time model

Menu item | Action
New time model | Creates a new time model.
Paste | Pastes time models from the clipboard.
Authorizations | Opens the authorization dialog.
Help | Opens online help.

Context menu time model

Menu item | Action
Copy | Copies the selected models.
Cut | Cuts selected models.
Rename | Makes it possible to rename the time model.
Delete | Deletes selected models.
Authorizations | Opens the Permissions dialog.
Help | Opens online help.


Context time model group

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Object time model -> Context time model group

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context time model group

Menu item | Action
Function new ... | Creates a new time model. When creating a new time model, you can immediately specify a new and unique name for it.
Paste | Inserts (I.e. pastes) time models from the clipboard to the list.
Authorizations | Opens the authorization dialog.
Help | Opens online help.

Context menu time model

Menu item | Action
Save | Saves changes in the engineering of the PFS.
Reject | Rejects all changes since the last time the PFS has been saved.
Properties | Opens the Properties window for the selected entry.
Switching point preview | Opens the switching point preview dialog.
Filter criteria ... | Opens the dialog for selecting filters.
Help | Opens online help.


Shift object

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Shift object

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A time model contains the defined shifts. Shifts are required to execute relative events. Shifts must not overlap, and must be defined within the limits of the time model group cycle.

Shifts are displayed on a grey background in the table view.

Parameters | Description
Create shift | Creates a new shift.
Create break | Creates a new break during the shift.
Delete shift | Deletes the selected shift, including all related breaks.
Help | Opens online help.

Note: Time is saved as local time. For details see chapter Handling of date and time in chapter Runtime.


Break object

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Break object

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Several breaks can be defined for one same shift. Breaks must not overlap, and must be defined within the shift.

Parameters | Description
Create break | Creates a new break during the shift.
Delete break | Deletes the break during the shift.
Help | Displays online help.


Event object

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Event object

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This object contains various user-defined events for the PFS. This is a fixed-type object.

Parameters | Description
Function new ... | Creates a new user-defined event. When creating a new user event, you must specify a new and unique name for it.
Paste | Inserts (i.e. pastes) user-defined events from the clipboard.
Authorizations | Opens the Permissions dialog.
Help | Activates online help.


Object user event

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Object user event

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

User events are events created by the user. These are defined for the whole of the PFS environment. User events are initiated when a triggering time point is input by means of the Execute PFS event. The number of user events is only limited by the available disk space or memory.

Owing to the missing required triggers, the Editor does not display user events in the switching point preview mode. In the Runtime environment, triggers are kept in the memory for 14 days at most to allow previous switching points to be analyzed. When the Runtime environment is closed down, these triggers are deleted.

The table view window contains a list of all the defined user events (displayed on a grey background) as well as the schedules they are linked to.

Context menu event

Menu item | Action
Function new ... | Creates a new user event.
Paste | Pastes a user event from the clipboard.
Authorizations | Opens the Permissions dialog.
Help | Activates online help.

Context menu user event

Menu item | Action
Copy | Copies the selected user event to the clipboard.
Rename | Enables users to specify a new name for the required user event.
Delete | Deletes the selected user events.
Authorizations | Opens the Permissions dialog.
Help | Activates online help.


Calendar object

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Calendar object

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The absolute and relative switching times defined in a schedule bear no actual relation to days, as only times are defined for them. The calendar enables users to define on which days a specific schedule must be executed. To this end, users can allocate an active model and active schedules to each day, for each time model group listed.

The calendar offers various views, which can be selected according to the level of detail required for the information.

Context menu calendar

Menu item | Action
Function new ... | Creates a new calendar.
Paste | Pastes a calendar from the clipboard.
Authorizations | Opens the Permissions dialog.
Help | Activates online help.

info Information

In the calendar you can define single days as special days. On these days the schedules defined for special days are carried out. Every day (Monday to Sunday) can be defined as special day.


Absolute time

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Calendar object -> Absolute time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to execute absolute switching points on a specific day, the relevant schedule must be linked to the required day. To do so, select the Schedules cell on the required day. Open the context menu to access the schedule selection dialog, and create the link. The linked schedule identification is input into the cell. In Day view, these schedules can be displayed in full detail.


Relative time

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Calendar object -> Relative time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When executing relative times in conjunction with absolute switching points, the way a model is linked (or not) to a specific day is a decisive element. The calendar day always starts with the start of day defined for the time model group. Should the time model group's cycle extend beyond the day, any times defined prior to the start of the day are considered to belong to the previous day.

For example: Start of day, 02:00:00 - End of day, 01:59:59. When only one user-defined event trigger occurs on Monday 15.10.2001 at 00:30:00, the model defined for Sunday 14th shall be used. If the trigger in fact occurs around 02:00:00, the model defined for Monday shall be used.

e.g.: Start of day, 6:00:00 AM - End of day, 9:59:59 PM. When only one user-defined event trigger occurs on Monday 15.10.2001 at 00:30:00, the model defined for Monday15th shall be used.


Month view

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Calendar object -> Month view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The month view aims to display the complete month in the calendar window. Should the available display space not be sufficient, the interface will attempt to display the current day in the window. The large display area is designed to allow a quick overview.

Double-click on a schedule cell to open the relevant schedule(s) in the table view, where you can edit it (or them).

Context menu month view

Menu item | Action
Selecting models | Opens the dialog for selecting a model.
Select schedules | Opens the dialog for selecting schedules.
Day view | Switches to daily view.
Week view | Switches to weekly view.
Month view | Switches to monthly view.
Go to today | Switches to the current date.
Switch to date | Opens the dialog for selecting a date.
Show previous element | Displays the previous element.
Show next element | Displays the next element.
Help | Activates online help.


Week view

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Calendar object -> Week view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The weekly view displays the allocation pattern on a weekly basis.

Context menu weekly view

Menu item | Action
Selecting models | Opens the dialog for selecting a model.
Select schedules | Opens the dialog for selecting schedules.
Day view | Switches to daily view.
Week view | Switches to weekly view.
Month view | Switches to monthly view.
Go to today | Switches to the current date.
Switch to date | Opens the dialog for selecting a date.
Show previous element | Displays the previous element.
Show next element | Displays the next element.
Help | Activates online help.


Day view

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Calendar object -> Day view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Day view offers detailed information about the way schedules are linked to days.

Context menu daily view

Menu item | Action
Select schedules | Opens the dialog for selecting schedules.
Show schedule | Opens the selected schedule in a new window.
Day view | Switches to daily view.
Week view | Switches to weekly view.
Month view | Switches to monthly view.
Go to today | Switches to the current date.
Switch to date | Opens the dialog for selecting a date.
Show previous element | Displays the previous element.
Show next element | Displays the next element.
As default | The schedule must systematically be executed on the current weekday.
As single day | The schedule is executed on this day only.
Delete | When a schedule is defined as a default, an exception is made for this day. In the event of an execution on this day only, the single-day execution will be deleted.
Help | Activates online help.


Types of model allocations

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Calendar object -> Types of model allocations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When using models, the following allocation types can be defined:

Use model on this day.

Use holiday model if the concerned day is a holiday

Use model on weekdays.


Schedule allocation types

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Calendar object -> Schedule allocation types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Schedules can be allocated to days as follows:

Use schedule on this day.

Do not use schedule on this day.

Use schedule on holiday, if the concerned day is a holiday

Use schedule on weekdays.


Model allocations in the Calendar view

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Calendar object -> Model allocations in the Calendar view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Models can also be allocated directly in the Calendar view. Once you have selected the cells to define the models you wish to use for a specific time model group and day, the various models available for the time model group are listed. Select a model to allocate it to the current day. When you exit the cell, the PFS will ask you to confirm whether or not you wish to use the selected model as a default model for that day.


Model context menu

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Calendar object -> Model context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This context menu can be accessed by right-clicking on the Model field in the monthly and weekly calendar view window.

Parameters | Description
Selecting models | Opens the model selection dialog.
Show model | Activates the table view Edit model.
Day view | Switches over to Day view.
Week view | Switches over to Week view.
Go to today | Switches over to Day view for the current date.
Switch to date | Switches over to Day view for the selected date.
Previous element | Accesses the previously displayed element.
Next element | Accesses the next element.
As default | Defines the current model as a standard model for the weekday for the current time model group.
Delete | Deletes the model allocation for the selected day. If the allocation concerns the standard model selected for the day, the weekday allocation for the time model group is deleted.
Help | Activates online help.


Context menu schedule

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Calendar object -> Context menu schedule

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To activate this context menu, select the schedules' cell for a specific day, and right-click on a time model group. The menu items not specifically broached here are identical to those described in the Model context menu section.

Parameters

Description

Select schedules

Opens the schedule selection dialog.

Show schedule

Activates the table view Edit schedule.

As default

The schedule is entered as default for the selected week day.

As single day

The schedule is executed on this day only.

Delete

Opens a dialog for selecting what should be deleted:

  • Delete all elements: All schedule of this type are deleted.
  • Delete only this element: For this element an exception is created for the selected day.


Variable list object

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Variable list object

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This object contains the array of variables related to the schedule. Only variables related to a schedule can indeed be used for the relevant switching points. This is a fixed-type object.

Context menu variable list

Menu item | Action
Add variable | Adds a new variable to the schedule. This is also possible during Runtime.
Insert variable | Inserts (i.e. pastes) variables from the clipboard.
Authorizations | Opens the authorization dialog.
Help | Opens online help.

Context menu variable

Menu item | Action
Copy | Copies selected variables
Cut | Cuts selected variables.
Replace variable | Opens the dialog for replacing selected variables.
Remove variable | Deletes selected variables from the list.
Authorizations | Opens the Permissions dialog.
Help | Activates online help.


Object variable

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Variable list object -> Object variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The set value of variables linked to a schedule can be modified using the switching points.

Parameters | Description
Copy | Copies the selected variables to the clipboard.
Cut | Copies the selected variables to the clipboard, and marks them for deleting. The variables are only deleted once they have effectively been inserted into another schedule. Switching points using these variables will be deleted.
Replace variable | Allows users to replace a variable with another variable. If the new variable is already available in the schedule, the original variable is deleted. All switching points using the original variable are transferred to the new variable.
Delete variable | Deletes the variable allocation link to the schedule. Switching points using these variables will be deleted.
Authorizations | Opens the Permissions dialog.
Help | Activates online help.


Functions object

Manual -> Production and Facility Scheduler (PFS) -> Object types -> Functions object

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Functions linked to the schedule can be allocated at the level of the switching points, and executed this way.

Parameters | Description
Copy | Copies the selected functions to the clipboard.
Cut | The selected functions are copied to the clipboard and are marked for deletion. The functions are only deleted once they have effectively been inserted (i.e. pasted) into another schedule. Switching points using these functions will be deleted.
Replace function | Allows users to replace a selected function with another function. All switching points using the source function are modified in order to match the target function. If the target function is already linked to the schedule, the source function's allocation is deleted.
Remove function | Deletes the function's allocation link to the schedule. Switching points using this function will be deleted.
Authorizations | Opens the Permissions dialog.
Help | Activates online help.


Properties

Manual -> Production and Facility Scheduler (PFS) -> Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to configure the properties of the Production & Facility Scheduler:

  • right-click Production & Facility Scheduler in the detail view of the project manager
  • select Properties in the context menu
  • select the tab you want to edit
    • Time change: offers settings for switching between daylight saving time and standard time
    • National holidays: configures national holidays
    • Table colors: defines the colors of the switching points
    • Record shift times: makes it possible to record shift data


Time change

Manual -> Production and Facility Scheduler (PFS) -> Properties -> Time change

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This page defines the PFS' reaction in the event where the system time is changed (e.g. summer time to winter time).

Possible options are:

Parameters | Description
Positive time change | The time is set ahead, the Systemtime is set into the future (e.g. summer time)
Make up for switching points | Actions between the current time and the newly set time, are executed directly after the time setting.
Recalculate switching points | Actions between the current time and the newly set time, are ignored and not executed. Switching points are recalculated.
Negative time change | The time is set back, the Systemtime is set into the past (e.g. winter time)
Reject switching points | Switching points are recalculated. Switiching points are calculated when the original time is reached.
Recalculate switching points | Action, between the current time and the newly set time, are recalculated. (That means that when the defined time is reached, they are executed.) This causes a double execution of swithing points in the corrected time period.
SB Switch | Standby Server switch, valid for timeout during redundance switch.
Reject switching points | The execution of switching points starts according to the current position of the Standby. Switching points in the switching period might not be executed.
Recalculate switching points | The switching points are recalculated and exectued according to the new time. This might cause a double execution of switching points.
Tolerance zone for time deviation | Tolerance, in how far the systemtime can be changed, without causing a recalculation of switching points according to the criteria described above.

attention Attention

Always carry out a switch to daylight saving time/standard time with the automatic Windows time switching. Never change the time manually, because this could lead to errors with times that are relevant to zenon.


Holidays

Manual -> Production and Facility Scheduler (PFS) -> Properties -> Holidays

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This page is used to select country-specific holidays.

The base data for the official holidays are in file Holidays.txt in folder %programdata%\COPA-DATA\zenon[Version]. It can be edited with a text editor.

Entries specific to a country begin with the country's identification, enclosed in angle brackets, followed by a key number as in Microsoft Office. The definition of holidays can be found in the following line, the name and date of the holiday.

For example:

[Austria] 45

All Saint's Day, 2006/11/1

All Saint's Day, 2007/11/1

All Saint's Day, 2008/11/1

All Saint's Day, 2009/11/1

All Saint's Day, 2010/11/1

All Saint's Day, 2011/11/1

All Saint's Day, 2012/11/1

Ascension Day, 2006/5/25

Ascension Day, 2007/5/17

Ascension Day, 2008/5/1

Ascension Day, 2009/5/21

Ascension Day, 2010/5/13

Ascension Day, 2011/6/2

Ascension Day, 2012/5/17

Assumption Day, 2006/8/15

Assumption Day, 2007/8/15

Assumption Day, 2008/8/15

Assumption Day, 2009/8/15

Assumption Day, 2010/8/15

Assumption Day, 2011/8/15

Assumption Day, 2012/8/15

...


Table colors

Manual -> Production and Facility Scheduler (PFS) -> Properties -> Table colors

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This section defines the colors used to represent switching points in the calendar.

Possible options are:

Parameters | Description
Days |
Default | Calendar day without any specific characteristics.
Special day | Date is a holiday.
Change day light saving time -> standard time | Date of the change from day light saving time to standard time.
Change standard time -> day light saving time | Date of the change from standard time to day light saving time.
Time models |
Default | Time model used for this weekday is active.
Exception | Use time model on this day only.
Special day | The specific time model for holidays is being used.
Schedules |
Default | The schedule is active on this weekday
Special day | Schedule is active on this special day
Skip | Schedule is not active on this day only.
Single day | Schedule is active on this day only.
Multiple entry | Several properties match this day.


Link of a equipment model

Manual -> Production and Facility Scheduler (PFS) -> Properties -> Link of a equipment model

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To link an equipment group with a time model group:

  1. select the time model group
  2. Select the Property command in the context menu
  3. the settings dialog of the time model is opened
  4. select Equipment modeling tab

  5. select the desired equipment group
  6. add it via button Add
  7. confirm by clicking OK as soon as you have added all desired equipment groups

Note: The linking of equipment model groups with time model groups is the requirement for recording shift times in a SQL data base. If several equipment model groups are linked, historic shift data are saved in several tables. If the link of a equipment model group to a time model group is changed, a new table with the GUID of the new equipment model group is created. For this, the following applies:

  • The data of the existing table are not taken over.
  • The existing table is however not deleted.


Editable time model groups

Manual -> Production and Facility Scheduler (PFS) -> Properties -> Editable time model groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The properties of the time model groups make it possible to adjust the time model group cycle times and to make model allocations. To open the dialog, access an existing time model group's context menu and click on menu item Properties ....


Time model group properties

Manual -> Production and Facility Scheduler (PFS) -> Properties -> Editable time model groups -> Time model group properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This settings page contains the designation and the time model group cycle information.

The following settings can be defined:

Setting | Description
Description | Defines the time model group's name. This field cannot be left empty, and the designation provided must be unique throughout the PFS environment.
Start of day | Defines the start of the day for this time model group.
End of day | Defines the end of the day for this time model group.

Note: Time is saved as local time. For details see chapter Handling of date and time in chapter Runtime.


Default allocation of the models

Manual -> Production and Facility Scheduler (PFS) -> Properties -> Editable time model groups -> Default allocation of the models

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This settings page enables users to specify a default model to be used on each weekday, as well as on holidays.


Editable schedules

Manual -> Production and Facility Scheduler (PFS) -> Properties -> Editable schedules

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The settings page enable users to configure schedules, and to proceed to calendar-filling operations. To open the dialog box, access an existing schedule's context menu and click on the Properties item.


Time context menu

Manual -> Production and Facility Scheduler (PFS) -> Properties -> Editable schedules -> Time context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This page enables users to configure the schedule, and to allocate the available variables or functions to the schedule.

Parameters | Description
Description | Displays the schedule's name. This name (i.e. designation) must be unique throughout the whole of the schedule's level.
Schedule active | Switches the schedule to active or inactive mode. Switching points contained in inactive schedules will not be executed.
Structure schedule | A structure schedule does not comprise any allocated functions or variables. It is only used to structure the schedules.
List of functions | Contains the functions which have been linked to the schedule. Processing is carried out as usual with Functions objects.
Variable list | Contains the variables which have been linked to the schedule. Processing is carried out as usual with Variables objects.


Calendar filling

Manual -> Production and Facility Scheduler (PFS) -> Properties -> Editable schedules -> Calendar filling

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This settings page enables users to perform the weekday allocation process for the schedule.

Calendar filling

Activates the schedule for the relevant weekday. For more information, please also refer to the Calendar section.


Dialogs

Manual -> Production and Facility Scheduler (PFS) -> Dialogs


PFS switching point preview

Manual -> Production and Facility Scheduler (PFS) -> Dialogs -> PFS switching point preview

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Production & Facility Scheduler context menu enables users to access the switching point preview mode.

The switching point preview mode is a powerful diagnosis tool enabling users to check over the PFS configuration. It defines and displays, according to the selected filter criteria, absolute and relative switching points and absolute execution times. Therefore, it enables users to assess the effects of the changes they have made before they actually apply them to the equipment. This preview can also be used to display a history of times. The definition is always performed on the basis of the current configuration.

User-defined events can not be executed in the Editor. In the Runtime environment, trigger time points for user-defined events are kept in memory for 14 days at the most; therefore, the history of execution times can only be traced back in time over this period of time.

You can also filter the configured objects, for instance if you only wish to search within a specific schedule.

When you close the dialog by clicking on OK, the settings you have defined are saved, and will remain available until the next time you open access the dialog.

Search dialog in text fields

Fields Time model group, Schedule, Variable and Function support wildcards at the filtering:

fill-in | Meaning
Text | The naming have to be Text
*Text | The naming have to end with Text
Text* | The naming have to start with Text
T??t | Any character is possible on second and third place.

Property

Description

Selection of the filter criteria

Time model group

Defines the filter to use with the equipment you are examining. Only switching points inherent to the relevant equipment will appear in the preview.
ATTENTION: Input is case sensitive!

Schedule

Defines the filter to use with the schedule you are examining. Only switching points inherent to the relevant schedules will be displayed in the preview window.
ATTENTION: Input is case sensitive!

Variable

Defines the filter to be applied to the variables you are searching. Only switching points linked to relevant variables and matching the criteria defined in the mask will be displayed in the preview window.
ATTENTION: Input is case sensitive!

Function

Defines the filter to be applied to the functions you are searching. Only switching points linked to relevant functions and matching the criteria defined in the mask will be displayed in the preview window.
ATTENTION: Input is case sensitive!

Filtering of

Selection of the data which are used for the creation of the preview via drop-down list:

  • editable data
    considers the changed data for determine the preview. The preview thus enables you to check over your configuration before saving any new settings.
  • saved data
    creates the preview on the basis of the configuration used for the switching points execution.

Switching point criteria

This option enables you to define the period of time for which you wish to create a preview.

Preview

Starts defining execution times according to the established criteria.

Contains the table with the switching points which are executed throughout the specified period and match the filter criteria. Deactivated switching points or switching points contained in deactivated schedules are highlighted.


PFS filter dialog

Manual -> Production and Facility Scheduler (PFS) -> Dialogs -> PFS filter dialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The filter dialog enables you to reduce the number of visible objects in the PFS to the objects matching the filter criteria.

Note: Time is saved as local time. For details see chapter Handling of date and time in chapter Runtime.

The filter function enables you to fill in a filter mask to isolate certain types of objects. When a filter is activated, the filtered branch is identified with a funnel symbol, designating the filtering process. The filtering function is case-sensitive.

Fields Time model group, Schedule, Variable and Function support wildcards at the filtering:

fill-in | Meaning
Text | The naming have to be Text
*Text | The naming have to end with Text
Text* | The naming have to start with Text
T??t | Any character is possible on second and third place.

When "child" objects match the filter criteria, the "parent" objects are also displayed, even if they do not match the criteria defined in the filter. The exception to this rule is the time model group. If the time model group filter does not match the time model group criteria, the whole of time model group is masked, even in the event where some lower-level objects indeed match the filter criteria.


Authorizations

Manual -> Production and Facility Scheduler (PFS) -> Dialogs -> Authorizations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

These enable you to define the user password level required to perform the relevant actions on the object. If the object does not support a specific functionality, this setting is locked.

If the permissions are edited in the Runtime environment, these can then only be modified on levels at which the logged in user currently owns permissions.

Permissions are only taken into account in the Runtime environment.

Parameters | Description
Display | These levels enable users to display an object and all its related lower-level branches.
Function new ... | These levels enable users to authorise or block the creation of lower-level objects.
Change | These levels enable users to modify the object's settings or permissions.
Rename | Levels allowing renaming operations.
Delete | Levels enabling users to delete an object and all its related lower-level branches.


Cyclic creation of switching times

Manual -> Production and Facility Scheduler (PFS) -> Dialogs -> Cyclic creation of switching times

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This dialog enables you to create, in one single process, several absolute switching times within a defined period of time for a specific, configurable domain.

To open the dialog , access an existing schedule's context menu in the table view, and click on the "Create time grid" item.

Parameters | Description
Cycle/Time | Defines the time or the creation grid.
As cyclic time | When this option is activated, several switching times can be created.
Password level | Is not yet supported! Should be 0.
Start time | Time with which the creation process begins.
End time | Time with which the creation process ends.

Note: Time is saved as local time. For details see chapter Handling of date and time in chapter Runtime.


Schedule selection

Manual -> Production and Facility Scheduler (PFS) -> Dialogs -> Schedule selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This dialog enables you to select schedules which shall be linked to a day. When you select the required schedules and add these to the list, the schedules are then inserted into the list of linked schedules.

To open the dialog , access the calendar Day view's context menu, and click on the Selecting schedule item.


Schedule activation period

Manual -> Production and Facility Scheduler (PFS) -> Dialogs -> Schedule activation period

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This dialog enables you to define the required schedules for a specific period or time, or to select them according to a model in the calendar.

To open the dialog:

  1. right click a line or cell with schedule in the calendar view
  2. select Select schedules in the context menu
  3. the dialog for selecting schedules will be opened

  4. highlight the desired schedules and confirm them by clicking OK
  5. the dialog for setting the duration of series is opened

Duration of series

Parameters | Description
Duration of series | Settings for the duration of series.
No end date | Execution starts with creating the series and does not have an end date (default setting). Series is executed weekly.
Starts on | Date for start.
Ends on | Date for end.

Serial pattern

Parameters

Description

Recurrence Pattern

Type of execution.

Detail field

Options for serial pattern depending on the selection of:

  • Daily
  • Weekly
  • Monthly
  • Yearly

Daily

Execution can be set in the detail field to:

  • Every [number] days: Enter a number for the execution rhythm.
    Default: 1
  • Every work day: Series is executed on every work day (in accordance with the set official holiday calendar).

Weekly

Execution can be set in the detail field to certain week days.

Monthly

Execution can be set in the detail field to:

  • on: Selection of the date
  • every month: Enter a number for the execution rhythm.

Yearly

Execution can be set in the detail field to certain dates.

Selected schedules

Parameters | Description
Selected schedules | List of selected schedules.
Select | Click on button in order to open the schedule selection dialog.
OK | Accepts input and closes dialog.
Cancel | Discards entries and closes the dialog.
Help | Opens online help.


Model selection

Manual -> Production and Facility Scheduler (PFS) -> Dialogs -> Model selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This dialog enables you to allocate one model per time model group to the required day.

  1. click on cell Models in the calendar view

  2. select Select models in the context menu
  3. select the desired model
  4. click on button Add
  5. confirm the dialog by clicking OK


Table view schedule editing

Manual -> Production and Facility Scheduler (PFS) -> Dialogs -> Table view schedule editing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Right click on a schedule in the calendar view in order to open the context menu. Command Display schedule opens the configuration dialog.

This view enables you to modify the schedules linked within the calendar. The function scope is identical to that of the Time or Switching point tables.


Table view model editing

Manual -> Production and Facility Scheduler (PFS) -> Dialogs -> Table view model editing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Right click on a time model in the calendar view in order to open the context menu. Command Display model opens the configuration dialog.

This view enables you to modify the models linked within the calendar. The editing possibilities are identical to those for shifts and breaks.


Change time

Manual -> Production and Facility Scheduler (PFS) -> Dialogs -> Change time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This dialog enables you to delay the selected times according to an offset you have defined.

To open the dialog box, access a selected time entry's context menu, and click on the Change time command.


Adjusting offset

Manual -> Production and Facility Scheduler (PFS) -> Dialogs -> Adjusting offset

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Enables you to modify the selected offsets.

To open the dialog box, access a selected offset's context menu, and click on the Adjust offset command.


Change value

Manual -> Production and Facility Scheduler (PFS) -> Dialogs -> Change value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This command enables you to change the selected cells in the Action column.

To open the dialog box, access a selected value's context menu, and click on the Change value command.

Parameters

Description

Variable

Change value by

Changes the contents of the currently selected cells by the specified amount.

Change value to

Changes the contents of the currently selected cells to the specified amount.

Linear increasing starting with

Changes the contents of the currently selected cells by a defined amount. The amount is increased by one with each modified cell.

Linear decreasing starting with

Changes the contents of the currently selected cells by a defined amount. The amount is reduced by one with each modified cell.

Function

Change status to

Changes the activation of the currently selected switching points to the specified state:

  • active
  • inactive

Macro

Change macro to

Changes the macro to the selected macro.


Creating switching points

Manual -> Production and Facility Scheduler (PFS) -> Dialogs -> Creating switching points

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The dialog box is opened via the context menu of a selected time entry and the command Create switching points.

In the upper list, select the entries for which you wish to create switching points, and insert these by clicking on the Add button in the lower list.

info Information

Per default switching points are always created as inactive in the Runtime and must be activated decidedly in order for them to work. Per default switching point are created as active in the Editor. .


Duplicate

Manual -> Production and Facility Scheduler (PFS) -> Dialogs -> Duplicate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The dialog can be called up during copying a schedule in order to control:

  • whether subordinate child schedules should be also copied when pasting
  • whether variables are substituted when pasting

Parameters | Description
only duplicate the current schedule | Inserts (i.e. pastes) only the top-level schedule from the clipboard.
duplicate the current schedule and the child schedule | The schedule will be inserted (i.e. pasted) along with all its related lower-level schedules. This embodies the standard method when this dialog is deactivated.
Open substitute dialog | Display the replacement dialog. This enables you to exchange variables when inserting them.
Display dialog box only if Ctrl-key is pressed | Suppresses the dialog. The schedule and the child schedules are always copied without substitution. In this case, pressing the Ctrl key during pasting will enable you to display the dialog. Note: This function can also be controlled via an entry in project.ini: [PFM] AnzeigenMitStrg = [Value] Values: 1: The dialog is only shown if the Ctrl button is pressed whilst the schedule is inserted. 0: The dialog is always displayed.
OK | Applies entries and closes the dialog.
Cancel | Discards entries and closes the dialog.
Help | Opens online help.


Execute PFS event

Manual -> Production and Facility Scheduler (PFS) -> Execute PFS event

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

By using this function a defined PFS event can be executed in the Runtime in order to trigger a relative time in the PFS.


Screen type Production and Facility Scheduler

Manual -> Production and Facility Scheduler (PFS) -> Screen type Production and Facility Scheduler

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

By using a Production & Facility Scheduler screen you can administer schedules and time models.

This screen type is only available, if the PFS has been licensed, otherwise the screen type Scheduler can be selected. (You will find more information on the pre-defined screen types in the chapter 'Screens / Pre-defined screen types'.)

The creation of the PFS screen is done by the definition of a new screen of the screen type Production & Facility Scheduler.

On opening the screen an empty screen is opened and the Drop-down list Control elements in the menu line is filled.

By selecting the entry Add template in the menu Control elements pre-defined control elements are loaded with default values at pre-defined positions.

Control element | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.
Schedule window | The schedule is displayed.
General | General control elements:
Save |
Reject |
Switching point preview |
Filter criteria ... |
Cut |
Copy ... |
Paste ... |
Rename |
Delete |
Properties ... |
Settings ... |
Ascending |
Descending |
Lists |
Schedule window |
Buttons |
Time model group | Create time model group
Schedule | - Create schedule ... - Activate schedule - Add variable ... - Remove variable - Remove function - Replace links ... - Create time grid... - Create time... - Create switching point - Creating switching points ... - Delete time - Delete switching points
Time model | - Create time model ... - Create shift - Create break - Delete shift - Delete break
Event | - Create events
Calendar | - Selecting model ... - Select schedule ... - Show this day ?- Go to today? - Switch to date ... - As default - As single day - Forwards - Backwards - Day view - Week view - Month view
Mass processing | - All values active - All values inactive - abolute time period - time relative - Change time ... - change the value ... - Selecting event ... - Adjusting offset...

You will find more information on changed Runtime files in the chapter Project and Workspace / RT changeable files.


Screen switch - PFS

Manual -> Production and Facility Scheduler (PFS) -> Screen switch - PFS

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


Filter tree view for screen switch

Manual -> Production and Facility Scheduler (PFS) -> Screen switch - PFS -> Filter tree view for screen switch

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The available settings are identical to those in the PFS filter dialog. An additional option enables you to specify whether or not you wish to activate the filter dialog before switching to screen activation. The object selected in the tree view will be selected again when you switch back to the screen.

Note: Time is saved as local time. For details see chapter Handling of date and time in chapter Runtime.


Filter table view for screen switch

Manual -> Production and Facility Scheduler (PFS) -> Screen switch - PFS -> Filter table view for screen switch

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This settings page enables you to define the columns and titles which will be used in the various table views.

Parameters | Description
Available fields | According to the selected view, the available columns are displayed in the list. Only selected columns will be displayed at a later point.
Labeling | Contains the table's heading. This text can be identified as requiring translation by means of a @ character.
Width | Column width
Alignment | Alignment of the columns' headings.
Objects | Lists the various objects for which views can be configured.
Preferred view | Lists the possible views for the requested object.


Programming interfaces

Manual -> Programming interfaces

Different interfaces to integrate your own programs or to automate planning are available in zenon:

  • Macro list
  • VSTA
  • Process Control Engine (PCE)
    Starting from version 7.20, PCE will not be supported anymore and it will not be shown in the module tree of zenon anymore. While converting projects from versions lower than 7.20, which contain PCE tasks, the node PCE will be shown for these projects again. PCE will not further be developed and documented.

Recommendation: Please use zenon Logic instead of PCE

tutorial License information

Part of the standard license of the Editor and Runtime.

Context menu

Menu item | Action
Open PCE editor | Opens the PCE editor.
Open VBA Editor | Opens the VBA editor
Open VSTA editor | Opens the VSTA editor.
Editor profile | Opens the drop-down list for selecting a Editor profile.
Help | Opens online help.

info Information

you can find information on the creation and implementation of controls (ActiveX, .NET, WPF) in the Controls manual.
You can find information on engineering and use of the SAP interface in the SAP interface chapter.

Open VBA and VSTA Editor

VBA Editor

VBA starts the same development environment for workspace and project. To open the VBA Editor:

  1. navigate to the Programming interfaces node
  2. right-click on VBA macros
  3. select Open in VBA Editor... in the context menu

Alternative: press the short cut Ctrl+F11

VSTA Editor

VSTA provides separate development environments for workspace and project. You can only use one of them at a time. At the start every other VSTA development environment which is open will be close.

To open the VSTA Editor for the workspace:

  1. press the short cut Alt+F10
  2. the code for the workspace and all loaded projects is displayed

To open the VSTA Editor for the currently loaded project:

  1. navigate to the Programming interfaces node
  2. right click on VSTA
  3. select Open VSTA Editor... in the context menu
  4. the Editor is opened for the currently loaded project

API from version 7.10:

For the use of zenon programming interfaces, the following is applicable from zenon 7.10:

  • VSTA / .NET: .NET Framework 3.5 must be installed.
  • VBA: If, in the VBA code, Windows API or other imported DLL functions are accessed, these calls must be adapted to the 64-bit environment. In general, the following applies: A VBA file created with a 32-bit version cannot be used without changes in a 64-bit version of VBA.

attention Attention

Note that errors in applications such as ActiveX, PCE, VBA, VSTA, WPF and external applications that access zenon via the API can also influence the stability of Runtime.

Other topics in this chapter

Process Control Engine (PCE)

Macro list

VSTA

Objectmodel


Process Control Engine (PCE)

Manual -> Programming interfaces -> Process Control Engine (PCE)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

attention Attention

Starting from version 7.20, PCE will not be supported anymore and it will not be shown in the module tree of zenon anymore. While converting projects from versions lower than 7.20, which contain PCE tasks, the node PCE will be shown for these projects again. PCE will not further be developed and documented.

Recommendation: Please use zenon Logic instead of PCE.

Other topics in this chapter

The PCE Editor

Course of actions

VB Script - Introduction


The PCE Editor

Manual -> Programming interfaces -> Process Control Engine (PCE) -> The PCE Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The PCE can be found in the Project Manager in the entry Programming interfaces. The PCE Editor is opened with the entry Open PCE Editor in the context menu.

Other topics in this chapter

The Taskmanager

The editing area

The output window

The menus of the PCE Editor

The icon bar of the PCE Editor


The Taskmanager

Manual -> Programming interfaces -> Process Control Engine (PCE) -> The PCE Editor -> The Taskmanager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Taskmanager of the PCE Editor lists the existing tasks and the linked variables.

A doubleclick on a task opens it in the editing area. With the right mouse button the context menu of a task can be opened.

The context menu of a task has four entries:

Parameters | Description
Task properties... | Opens the properties dialog of the task.
Task variables... | Opens the variable selection. So you can add new variables to the task.
Delete task | Deletes the task without any further query.
Compile tasks | Compiles the task.


The editing area

Manual -> Programming interfaces -> Process Control Engine (PCE) -> The PCE Editor -> The editing area

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the editing area of the PCE Editor the code of the tasks is entered in VB Script or Java Script.


The output window

Manual -> Programming interfaces -> Process Control Engine (PCE) -> The PCE Editor -> The output window

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


The menus of the PCE Editor

Manual -> Programming interfaces -> Process Control Engine (PCE) -> The PCE Editor -> The menus of the PCE Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Other topics in this chapter

Menu File

Menu Edit

Menu Run

Menu View

Menu Window

Menu help


Menu File

Manual -> Programming interfaces -> Process Control Engine (PCE) -> The PCE Editor -> The menus of the PCE Editor -> Menu File

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The menu File includes the following commands:

Parameters | Description
Save | Saves new or changed tasks.
Print | Prints the current task.
Close | Closes the PCE Editor.


Menu Edit

Manual -> Programming interfaces -> Process Control Engine (PCE) -> The PCE Editor -> The menus of the PCE Editor -> Menu Edit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The menu Edit includes the following commands:

Parameters | Description
Undo | Undoes the last executed action.
Redo | Repeats the last executed action.
Cut | Moves a text to the Windows Clipboard.
Copy | Copies a text to the Windows Clipboard.
Paste | Pastes a text from the Windows Clipboard.
Delete |
Select all | Selects the entire text of the task.
Find | Searches for a text in the current task.
Find next | Goes to the next place of finding.
Find previous | Goes to the previous place of finding.
Replace... | Replaces a text in the task by another.
Bookmarks | Administration of bookmarks in the code of the task.
- set bookmark | Sets a bookmark at the selected line in the code.
- next bookmark | Goes to the next bookmark in the code.
- previous bookmark | Goes to the previous bookmark in the code.
- delete all bookmarks | Deletes all bookmarks in the code.


Menu Run

Manual -> Programming interfaces -> Process Control Engine (PCE) -> The PCE Editor -> The menus of the PCE Editor -> Menu Run

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The menu Run includes the following commands:

Save and restart all tasks |
Compile tasks | Compiles the task.


Menu View

Manual -> Programming interfaces -> Process Control Engine (PCE) -> The PCE Editor -> The menus of the PCE Editor -> Menu View

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The menu View includes the following commands:

Parameters | Description
Options | Opens the settings dialog of the PCE Editor.
Task manager | Opens/closes the Taskmanager window.
Output | Opens/closes the Output window.
Status Bar | Opens/closes the status bar.


Menu Window

Manual -> Programming interfaces -> Process Control Engine (PCE) -> The PCE Editor -> The menus of the PCE Editor -> Menu Window

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The menu Window includes the following commands:

Close

Arrange

Divide

Align symbols

List of the last open windows


Menu help

Manual -> Programming interfaces -> Process Control Engine (PCE) -> The PCE Editor -> The menus of the PCE Editor -> Menu help

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The menu Help includes the following commands:

Command

Action

Help

Opens online help.

Info about…

Opens a window with information on zenon:

  • Serial Number
  • Activation number:
  • Licensed tags/IOs
  • Licensed module

A slider can be used for navigation in the information window. Clicking in the window or pressing the Esc key closes the info window.


The icon bar of the PCE Editor

Manual -> Programming interfaces -> Process Control Engine (PCE) -> The PCE Editor -> The icon bar of the PCE Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The most important commands of the PCE Editor can also be executed with the icons of the icon bar.

The following icons are available:

Parameters | Description
Close | Closes the PCE Editor.
Save all | Saves new or changed tasks.
Print active screen | Prints the current task.
Cut | Moves a text to the Windows Clipboard.
Copy | Copies a text to the Windows Clipboard.
Paste | Pastes a text from the Windows Clipboard.
Undo | Undoes the last executed action.
Redo | Repeats the last executed action.
Find | Searches for a text in the current task.
Find next | Goes to the next place of finding.
Find previous | Goes to the previous place of finding.
Replace... | Replaces a text in the task by another.
Save and restart |
Start debugger |
Next bookmark | Goes to the next bookmark in the code.
Set bookmark | Sets a bookmark at the selected line in the code.
Previous bookmark | Goes to the previous bookmark in the code.
Delete all bookmarks | Deletes all bookmarks in the code.


Course of actions

Manual -> Programming interfaces -> Process Control Engine (PCE) -> Course of actions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Other topics in this chapter

Creating a task

Entering code

Function Show PCE

Executing tasks


Creating a task

Manual -> Programming interfaces -> Process Control Engine (PCE) -> Course of actions -> Creating a task

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the context menu of the Taskmanager a new task can be created.

Other topics in this chapter

Properties of the task

Variables of the task


Properties of the task

Manual -> Programming interfaces -> Process Control Engine (PCE) -> Course of actions -> Creating a task -> Properties of the task

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

After creating the task the properties dialog of the new task opens automatically.

The following properties can be defined:

Parameters | Description
Name | Unique name of the task.
Type | Tasks can be executed cyclic or once. Cyclic: the task is executed cyclically in the interval defined under limit of time schedule. Once: the task is executed one single time.
Priority | Process priorities for operating system multithreading (idle, low, normal, high, highest, time critical). Default: Normal main process: the task runs in the same thread as Runtime. If the task gets into a waiting loop or crashes, that also influences the Runtime.
Script file | Selection of the script file: VB-Files (*.vbs) for VB Script or JS-Files (*.js) for Java Script. The according file is created, when the task is opened in the editing area for the first time.
Start type | System start : automatically started with Runtime. (This is the only way to use the PCE under Windows CE, as Windows CE does not support VBA.) event triggered: the task is started in a VBA macro with the statement "thisProject.Tasks.Item("Taskname").Run".
Cycle time to reach | For cyclic tasks the interval in milliseconds that should be achieved. If this cycle time is not achieved, the task is executed as fast as possible.

For a later change of the properties this dialog can also be opened with the context menu of the task and the entry Task Properties….


Variables of the task

Manual -> Programming interfaces -> Process Control Engine (PCE) -> Course of actions -> Creating a task -> Variables of the task

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

After defining the properties the variable selection dialog is automatically opened. Here the variables that should be processed in the task are selected.

All variables that are read or written in the task should be linked here. There is also the possibility to access the variables via the variables object, but only the variables directly linked to the task are automatically updated when initializing the task before execution.

The variables must have the following syntax:

Task.Value('Variable name')=123

For a later change of the variable selection this dialog can also be opened with the context menu of the task and the entry Task Variables….


Entering code

Manual -> Programming interfaces -> Process Control Engine (PCE) -> Course of actions -> Entering code

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Doubleclicking the task in the Taskmanager opens it in the editing area. If the task is opened for the first time, the according VBS or JS file is created now.

Four procedures are automatically created:

Parameters | Description
Task_Init() | This procedure is automatically executed when starting the task.
Task_Main() | This procedure is either executed once (type once) or cyclically (type cyclic).
Task_Exit() | This procedure is automatically executed when stopping the task.
Task_Timer(lTimerId) | This procedure is executed cyclically, as long as the according time is running. The cycle time is defined as a parameter with the starting of the timer.

Generally speaking the PCE uses the same object model as VBA (see VBA Tutorials). When using VBA objects (except the object Task) multithreading is lost, because these objects only can be accessed from the main thread.

attention Attention

Not all funtions of the COM interface are multithread-able and therefore can only be used in a main tread context. If a different property than "in the main process" is set as PCE task, there must not be any access from the PCE to the main thread. In case there is an access to the COM interface nevertheless, this can lead to undefined system states, e.g. a Runtime freeze.

Of special importance are the collection Tasks and the object Task.

Other topics in this chapter

The collection Tasks

The object Task


The collection Tasks

Manual -> Programming interfaces -> Process Control Engine (PCE) -> Course of actions -> Entering code -> The collection Tasks

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Count

Item

Parent


The object Task

Manual -> Programming interfaces -> Process Control Engine (PCE) -> Course of actions -> Entering code -> The object Task

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

ActualCycleTime

Property

Currently achieved cycle time of the task

CountVariable

Property

Number of variables linked to the task

CycleTime

Property

Defined cycle time of the task

DynProperties

Property

ErrorNumber

Property

ErrorString

Property

Exit

Event

On init

Event

ItemVariable

Method

Main

Event

MemValue

Property

With "Task.MemValue("Name")=value" an internal variable is created and a value is assigned to it. There is no need to declare the variable before.

This variable can also be accessed from other tasks. So it allows the exchange of values between tasks.

Name

Property

Name of the current task

Parent

Property

The collection Tasks

Priority

Property

Priority of the current task

Run

Method

Starts a task

Sleep

Method

Holds a task

StartTimer

Method

The method "StartTimer" starts a timer of the task.

Status

Property

Stop

Method

Stops a task

StopTimer

Method

The method "StopTimer" stops a timer of the task.

Timer

Event

Type

Property

Value

Property

With "Task.Value("name of linked variable")=value" a variable of the project can get a new value.


Function Show PCE

Manual -> Programming interfaces -> Process Control Engine (PCE) -> Course of actions -> Function Show PCE

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the zenon function Show PCE the PCE Editor can be opened from the Runtime.


Executing tasks

Manual -> Programming interfaces -> Process Control Engine (PCE) -> Course of actions -> Executing tasks

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tasks can be executed when the system is started or can be event-triggered.

Other topics in this chapter

Executing tasks with system start

Executing tasks event triggered


Executing tasks with system start

Manual -> Programming interfaces -> Process Control Engine (PCE) -> Course of actions -> Executing tasks -> Executing tasks with system start

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If in the configuration of the task the Start type is set to System start , the task is automatically started with the Runtime.

This is the only way to use the PCE under Windows CE, as Windows CE does not support VBA.


Executing tasks event triggered

Manual -> Programming interfaces -> Process Control Engine (PCE) -> Course of actions -> Executing tasks -> Executing tasks event triggered

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Other topics in this chapter

On a PC

On a CE terminal


On a PC

On a PC

A task can also be started event triggered. In this case the Start type has to be set to Event driven . Now the task is no longer automatically started with the Runtime.

A VBA macro has to be created in order to execute a task by pressing a button, by a limit violation or any other event. With the following VBA statement the task can be started: thisProject.Tasks.Item(Taskname).Run
The task is automatically started in an own thread if in the configuration Priority Main process has not been set.

With the following VBA statement the task can be stopped at any time: thisProject.Tasks.Item("Taskname").Stop

Note: To execute a task more than once, it must also be explicitly stopped after it has ended, so that it can be restarted.
Instruction: thisProject.Tasks.Item(Taskname).Stop
It can be restarted after being stopped properly.


On a CE terminal

Manual -> Programming interfaces -> Process Control Engine (PCE) -> Course of actions -> Executing tasks -> Executing tasks event triggered -> On a CE terminal

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
On a CE terminal

As Windows CE does not support VBA, the procedure for execution on a PC is not possible on a CE terminal. But there is a possibility to execute tasks event triggered also here.

A task with the Start type System start is created. This task is automatically started with the Runtime. And this task gets the Priority Main process so that it runs in the same thread as the Runtime. Now bit variables are linked to that task, then will execute other tasks event triggered. With the following statement the task can be started: Parent.Item(Taskname).Run
Now the task is automatically started in an own Thread if in the configuration the Priority Main process has not been set.

With the following statement the task can be stopped at any time: Parent.Item("Taskname").Stop


VB Script - Introduction

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Other topics in this chapter

Data types

Variables

Constants

Operators

Conditional Statements

Looping Through Code

Types of procedures

Coding Conventions


Data types

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Data types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Other topics in this chapter

Variant

Variant Subtypes


Variant

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Data types -> Variant

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

VBScript has only one data type called a Variant. A Variant is a special kind of data type that can contain different kinds of information, depending on how it is used. Because Variant is the only data type in VBScript, it is also the data type returned by all functions in VBScript.

At its simplest, a Variant can contain either numeric or string information. A Variant behaves as a number when you use it in a numeric context and as a string when you use it in a string context. That is, if you are working with data that looks like numbers, VBScript assumes that it is numbers and does what is most appropriate for numbers. You can always make numbers behave as strings by enclosing them in quotation marks (" "). If you work with data that only can be interpreted as strings, VBScript will interpret them as strings.


Variant Subtypes

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Data types -> Variant Subtypes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Beyond the simple numeric or string classifications, a Variant can make further distinctions about the specific nature of numeric information. For example, you can have numeric information that represents a date or a time. When used with other date or time data, the result is always expressed as a date or a time. You can also have a rich variety of numeric information ranging in size from Boolean values to huge floating-point numbers. These different categories of information which can be contained in a Variant are called subtypes . Most of the time, you can just put the kind of data you want in a Variant , and the Variant behaves in a way that is most appropriate for the data it contains.

The following summary shows subtypes of data that a Variant can contain.

Subtype | Meaning
Empty | Variant is uninitialized. Value is 0 for numeric variables or a zero-length string ("") for string variables.
Null | Variant intentionally contains no valid data.
Boolean | Contains either TRUE or FALSE.
Byte | Contains integer in the range 0 to 255.
Integer | Contains integer in the range -32,768 to 32,767.
Currency | -922,337,203,685,477.5808 bis 922,337,203,685,477.5807.
Long | Contains integer in the range -2,147,483,648 to 2,147,483,647.
Single | Contains a single-precision, floating-point number in the range -3.402823E38 to -1.401298E-45 for negative values; 1.401298E-45 to 3.402823E38 for positive values.
Double | Contains a double-precision, floating-point number in the range -1.79769313486232E308 to -4.94065645841247E-324 for negative values; 4.94065645841247E-324 to 1.79769313486232E308 for positive values.
Date (Time) | Contains a number that represents a date between January 1, 100 to December 31, 9999.
String | Contains a variable-length string that can be up to approximately 2 billion characters in length.
Object | Contains an object.
Error | Contains an error number.


Variables

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A variable is a convenient placeholder that refers to a computer memory location where you can store program information that may change during the time your script is running. For example, you might create a variable called ClickCount to store the number of times a user clicks an object on a particular Web page. Where the variable is stored in computer memory is unimportant. What is important is that you only have to refer to a variable by name to see or change its value. In VBScript, variables are always of one fundamental data type, Variant.

Other topics in this chapter

Declaring Variables

Limitations for names

Scope and Lifetime of Variables

Assigning Values to Variables

Scalar Variables and Array Variables


Declaring Variables

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Variables -> Declaring Variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You declare variables explicitly in your script using the Dim statement, the Public statement, and the Private statement. Example:

Dim DegreesFahrenheit

You declare multiple variables by separating each variable name with a comma. Example:

Dim Top, Bottom, Left, Right


Limitations for names

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Variables -> Limitations for names

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Variable names follow the standard rules for naming anything in VBScript. A variable name:

  • Must begin with an alphabetic character.
  • Cannot contain an embedded period.
  • Must not exceed 255 characters.
  • Must be unique in the scope in which it is declared.


Scope and Lifetime of Variables

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Variables -> Scope and Lifetime of Variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When you declare a variable within a procedure, only code within that procedure can access or change the value of that variable. It has local scope and is a procedure-level variable.

If you declare a variable outside a procedure, you make it recognizable to all the procedures in your script. This is a script-level variable, and it has script-level scope.

The lifetime of a variable depends on how long it exists. The lifetime of a script-level variable extends from the time it is declared until the time the script is finished running. At procedure level, a variable exists only as long as you are in the procedure. When the procedure exits, the variable is destroyed.

Local variables are ideal as temporary storage space when a procedure is executing. You can have local variables of the same name in several different procedures because each is recognized only by the procedure in which it is declared.


Assigning Values to Variables

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Variables -> Assigning Values to Variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Values are assigned to variables creating an expression as follows: the variable is on the left side of the expression and the value you want to assign to the variable is on the right. Example:

B = 200


Scalar Variables and Array Variables

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Variables -> Scalar Variables and Array Variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Much of the time, you only want to assign a single value to a variable you have declared. A variable containing a single value is a scalar variable. Other times, it is convenient to assign more than one related value to a single variable. Then you can create a variable that can contain a series of values. This is called an array variable. Array variables are declared nearly like scalar variables The only difference is, that in the declaration brackets follow the names of array variables. In the following example, a single-dimension array containing 11 elements is declared:

Dim A(10)

Although the number shown in the parentheses is 10, all arrays in VBScript are zero-based, so this array actually contains 11 elements. In a zero-based array, the number of array elements is always the number shown in parentheses plus one. This kind of array is called a fixed-size array.

You assign data to each of the elements of the array using an index into the array. Beginning at zero and ending at 10, data can be assigned to the elements of an array as follows:

A(0) = 256

A(1) = 324

A(2) = 100

. . .

A(10) = 55

Similarly, the data can be retrieved from any element using an index into the particular array element you want. Example:

. . .

SomeVariable = A(8)

. . .

Arrays aren't limited to a single dimension. You can have as many as 60 dimensions, although most people can't comprehend more than three or four dimensions. You can declare multiple dimensions by separating an array's size numbers in the parentheses with commas. In the following example, the MyTable variable is a two-dimensional array consisting of 6 rows and 11 columns:

Dim MyTable(5, 10)

In a two-dimensional array, the first number is always the number of rows; the second number is the number of columns.

You can also declare an array whose size changes during the time your script is running. This is called a dynamic array. The array is initially declared within a procedure using either the Dim statement or using the ReDim statement. However, for a dynamic array, no size or number of dimensions is placed inside the parentheses. Example:

(Dim AnArray()

ReDim AnotherArray()

To use a dynamic array, you must subsequently use ReDim to determine the number of dimensions and the size of each dimension. In the following example, ReDim sets the initial size of the dynamic array to 25. A subsequent ReDim statement resizes the array to 30, but uses the Preserve keyword to preserve the contents of the array as the resizing takes place.

ReDim MyArray(25)

. . .

ReDim Preserve MyArray(30)


Constants

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Constants

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A constant is a meaningful name that takes the place of a number or string and never changes. VBScript defines a number of intrinsic constants . You can get information about these intrinsic constants from the VBScript Language Reference.

You create user-defined constants in VBScript using the Const statement. So you can assign a meaningful name to string or numerical constants. Then you can assign them literal values and use them in a script. Example:

Const MyString = "This is a string."

Const MyAge = 49

Note that the string literal is enclosed in quotation marks (" "). Quotation marks are the most obvious way to differentiate string values from numeric values. You represent Date literals and time literals by enclosing them in number signs (#). Example:

Const CutoffDate = #6-1-97#

You may want to adopt a naming scheme to differentiate constants from variables. This will prevent you from trying to reassign constant values while your script is running. For example, you might want to use a "vb" or "con" prefix on your constant names, or you might name your constants in all capital letters. Care that constants and variables can be distinguished. So you avoid problems when creating complex scripts.


Operators

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Operators

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

VBScript has a full range of operators, including arithmetic operators, comparison operators, concatenation operators, and logical operators.

Other topics in this chapter

Operator Precedence

Arithmetic Operators

Comparison Operators

Logical Operators


Operator Precedence

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Operators -> Operator Precedence

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If several operators appear in a statement, each part is evaluated and resolved in a pre-defined sequence. This sequence is called operator precedence. You can use parentheses to override the order of precedence and force some parts of an expression to be evaluated before others. Operations within parentheses are always performed before those outside. Within parentheses, however, standard operator precedence is maintained.

When expressions contain operators from more than one category, arithmetic operators are evaluated first, comparison operators are evaluated next, and logical operators are evaluated last. Comparison operators all have equal precedence; that is, they are evaluated in the left-to-right order in which they appear. Arithmetic and logical operators are evaluated in the following order of precedence.


Arithmetic Operators

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Operators -> Arithmetic Operators

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Description | Symbol
Exponentiation | ^
Unary negation | -
Multiplication | *
Division | /
Integer division | /
Modulus arithmetic | Mod
Addition | +
Subtraction | -
String concatenation |


Comparison Operators

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Operators -> Comparison Operators

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Description | Symbol
Equality | =
Inequality | <>
Less than | <
Greater than | >
Less than or equal to | <=
Greater than or equal to | >=
Opject equivalence | Is


Logical Operators

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Operators -> Logical Operators

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If several operators appear in a statement, each part is evaluated and resolved in a pre-defined sequence. This sequence is called operator precedence. You can use parentheses to override the order of precedence and force some parts of an expression to be evaluated before others. Operations within parentheses are always performed before those outside. Within parentheses, however, standard operator precedence is maintained.

When expressions contain operators from more than one category, arithmetic operators are evaluated first, comparison operators are evaluated next, and logical operators are evaluated last. Comparison operators all have equal precedence; that is, they are evaluated in the left-to-right order in which they appear. Arithmetic and logical operators are evaluated in the following order of precedence.


Conditional Statements

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Conditional Statements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can control the flow of your script with conditional statements and looping statements. Using conditional statements, you can write VBScript code that makes decisions and repeats actions.

Other topics in this chapter

Making Decisions Using If...Then...Else

Making Decisions with Select Case


Making Decisions Using If...Then...Else

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Conditional Statements -> Making Decisions Using If...Then...Else

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The If...Then...Else statement is used to evaluate whether a condition is True or False and, depending on the result, to specify one or more statements to run. Usually the condition is an expression that uses a comparison operator to compare one value or variable with another. For information about comparison operators, see Comparison Operators. If...Then...Else statements can be nested to as many levels as you need.

Other topics in this chapter

Running Statements if a Condition is True

Running Certain Statements if a Condition is True and Running Others if a Condition is False

Deciding Between Several Alternatives


Running Statements if a Condition is True

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Conditional Statements -> Making Decisions Using If...Then...Else -> Running Statements if a Condition is True

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Running Statements if a Condition is True

To run only one statement when a condition is True, use the single-line syntax for the If...Then...Else statement. The following example shows the single-line syntax. Notice that this example omits the Else keyword.

Sub FixDate()
Dim myDate
myDate = #2/13/95#
If myDate < Now Then myDate = Now
End Sub

To run more than one line of code, you must use the multiple-line (or block) syntax. This syntax includes the End If statement, as shown in the following example:

Sub AlertUser(value)
If value = 0 Then
AlertLabel.ForeColor = vbRed
AlertLabel.Font.Bold = True
AlertLabel.Font.Italic = True
End If
End Sub

To run only one statement when a condition is True, use the single-line syntax for the If...Then...Else statement. The following example shows the single-line syntax. Notice that this example omits the Else keyword.

Sub FixDate()
Dim myDate
myDate = #2/13/95#
If myDate < Now Then myDate = Now
End Sub

To run more than one line of code, you must use the multiple-line (or block) syntax. This syntax includes the End If statement, as shown in the following example:

Sub AlertUser(value)
If value = 0 Then
AlertLabel.ForeColor = vbRed
AlertLabel.Font.Bold = True
AlertLabel.Font.Italic = True
End If
End Sub


Running Certain Statements if a Condition is True and Running Others if a Condition is False

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Conditional Statements -> Making Decisions Using If...Then...Else -> Running Certain Statements if a Condition is True and Running Others if a Condition is False

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Running Certain Statements if a Condition is True and Running Others if a Condition is False

You can use an If...Then...Else statement to define two blocks of executable statements: one block to run if the condition is True, the other block to run if the condition is False.

Sub AlertUser(value)
If value = 0 Then
AlertLabel.ForeColor = vbRed
AlertLabel.Font.Bold = True
AlertLabel.Font.Italic = True
Else
AlertLabel.Forecolor = vbBlack
AlertLabel.Font.Bold = False
AlertLabel.Font.Italic = False
End If
End Sub


Deciding Between Several Alternatives

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Conditional Statements -> Making Decisions Using If...Then...Else -> Deciding Between Several Alternatives

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Deciding Between Several Alternatives

A variation on the If...Then...Else statement allows you to choose from several alternatives. Adding ElseIf clauses expands the functionality of the If...Then...Else statement so you can control program flow based on different possibilities.

Example:
Sub ReportValue(value)
If value = 0 Then
MsgBox value
ElseIf value = 1 Then
MsgBox value
ElseIf value = 2 then
Msgbox value
Else
Msgbox Walue out of range!
End If


Making Decisions with Select Case

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Conditional Statements -> Making Decisions with Select Case

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Select Case structure provides an alternative to If...Then...ElseIf for selectively executing one block of statements from among multiple blocks of statements. A Select Case statement provides capability similar to the If...Then...Else statement, but it makes code more efficient and readable.

A Select Case structure works with a single test expression that is evaluated once, at the top of the structure. The result of the expression is then compared with the values for each Case in the structure. If there is a match, the block of statements associated with that Case is executed, as in the following example.

Select Case Document.Form1.CardType.Options(SelectedIndex).Text
Case MasterCard
DisplayMCLogo
ValidateMCAccount
Case Visa
DisplayVisaLogo
ValidateVisaAccount
Case American Express
DisplayAMEXCOLogo
ValidateAMEXCOAccount
Case Else
DisplayUnknownImage
PromptAgain
End Select


Looping Through Code

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Looping Through Code

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Looping allows you to run a group of statements repeatedly. Some loops repeat statements until a condition is False; others repeat statements until a condition is True. There are also loops that repeat statements a specific number of times.

The following looping statements are available in VBScript:

Parameters | Description
Using Do loops: | Loops while or until a condition is True.
Using While...Wend: | Loops while a condition is True.
Using For...Next: | Uses a counter to run statements a specified number of times.
Using For Each...Next: | Repeats a group of statements for each item in a collection or each element of an array.

Other topics in this chapter

Using Do Loops

Using While...Wend

Using For...Next

Using For Each...Next


Using Do Loops

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Looping Through Code -> Using Do Loops

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can use Do...Loop statements to run a block of statements an indefinite number of times. The statements are repeated either while a condition is True or until a condition becomes True.

Other topics in this chapter

Repeating Statements While a Condition is True

Repeating a Statement Until a Condition Becomes True

Exiting a Do...Loop Statement from Inside the Loop


Repeating Statements While a Condition is True

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Looping Through Code -> Using Do Loops -> Repeating Statements While a Condition is True

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Repeating Statements While a Condition is True

Use the While keyword to check a condition in a Do...Loop statement. You can check the condition before you enter the loop (as shown in the following ChkFirstWhile example), or you can check it after the loop has run at least once (as shown in the ChkLastWhile example). In the ChkFirstWhile procedure, if myNum is set to 9 instead of 20, the statements inside the loop will never run. In the ChkLastWhile procedure, the statements inside the loop run only once because the condition is already False.

Sub ChkFirstWhile()
Dim counter, myNum
counter = 0

myNum = 20

Do While myNum > 10

myNum = myNum - 1

counter = counter + 1

Loop

MsgBox 'The loop made ' & counter & ' repetitions.'

End Sub

Sub ChkLastWhile()

Dim counter, myNum

counter = 0

myNum = 9

Do
myNum = myNum - 1
counter = counter + 1

Loop While myNum > 10

MsgBox 'The loop made ' & counter & ' repetitions.'

End Sub


Repeating a Statement Until a Condition Becomes True

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Looping Through Code -> Using Do Loops -> Repeating a Statement Until a Condition Becomes True

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Repeating a Statement Until a Condition Becomes True

There are two ways to use the Until keyword to check a condition in a Do...Loop statement. You can check the condition before you enter the loop (as shown in the following ChkFirstUntil example), or you can check it after the loop has run at least once (as shown in the ChkLastUntil example). As long as the condition is False, the looping occurs.

Sub ChkFirstUntil()

Dim counter, myNum

counter = 0

myNum = 20

Do Until myNum = 10

myNum = myNum - 1

counter = counter + 1

Loop

MsgBox 'The loop made ' & counter & ' repetitions.'

End Sub

Sub ChkLastUntil()

Dim counter, myNum

counter = 0

myNum = 1

Th

myNum = myNum - 1

counter = counter + 1

Loop Until myNum = 10

MsgBox 'The loop made ' & counter & ' repetitions.'

End Sub


Exiting a Do...Loop Statement from Inside the Loop

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Looping Through Code -> Using Do Loops -> Exiting a Do...Loop Statement from Inside the Loop

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Exiting a Do...Loop Statement from Inside the Loop

You can exit a Do...Loop by using the Exit Do statement. Because you usually want to exit only in certain situations, such as to avoid an endless loop, you should use the Exit Do statement in the True statement block of an If...Then...Else statement. If the condition is False, the loop runs as usual.

In the following example, myNum is assigned a value that creates an endless loop. The If...Then...Else statement checks for this condition, preventing the endless repetition.

Sub ExitExample()

Dim counter, myNum

counter = 0

myNum = 9

Do Until myNum = 10

myNum = myNum - 1

counter = counter + 1

If myNum < 10 Then Exit Do

Loop

MsgBox 'The loop made ' & counter & ' repetitions.'

End Sub


Using While...Wend

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Looping Through Code -> Using While...Wend

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The While...Wend statement is provided in VBScript for those who are familiar with its usage. However, because of the lack of flexibility in While...Wend, it is recommended that you use Do...Loop instead.


Using For...Next

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Looping Through Code -> Using For...Next

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can use For...Next statements to run a block of statements a specific number of times. For loops, use a counter variable whose value increases or decreases with each repetition of the loop.

The following example causes a procedure called MyProc to execute 50 times. The For statement specifies the counter variable x and its start and end values. The Next statement increments the counter variable by 1.

Sub DoMyProc50Times()

Dim x

For x = 1 To 50

MyProc

Next

End Sub

Using the Step keyword, you can increase or decrease the counter variable by the value you specify. In the following example, the counter variable j is incremented by 2 each time the loop repeats. When the loop is finished, the total is the sum of 2, 4, 6, 8, and 10.

Sub DoMyProc50Times()

Dim x

For x = 1 To 50

MyProc

Next

End Sub

To decrease the counter variable, use a negative Step value. You must specify an end value that is less than the start value. In the following example, the counter variable myNum is decreased by 2 each time the loop repeats. When the loop is finished, total is the sum of 16, 14, 12, 10, 8, 6, 4, and 2.

Sub NewTotal()

Dim myNum, total

For myNum = 16 To 2 Step -2

total = total + myNum

Next

MsgBox 'The total is ' & total

End Sub


Using For Each...Next

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Looping Through Code -> Using For Each...Next

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A For Each...Next loop is similar to a For...Next loop. Instead of repeating the statements a specified number of times, a For Each...Next loop repeats a group of statements for each item in a collection of objects or for each element of an array. This is especially helpful if you don't know how many elements are in a collection.

In the following HTML code example, the contents of a Dictionary object is used to place text in several text boxes.

<HTML>

<HEAD><TITLE>Formulare und Elemente</TITLE></HEAD>

<SCRIPT LANGUAGE='VBScript'>

<!--

Sub cmdChange_OnClick

Dim d 'Create a variable

Set d = CreateObject('Scripting.Dictionary')

d.Add '0', 'Athen' 'Add some keys and items

d.Add '1', 'Belgrad'

d.Add '2', 'Kairo'

For Each I in d

Document.frmForm.Elements(I).Value = D.Item(I)

Next

End Sub

-->

</SCRIPT>

<BODY>

<CENTER>

<FORM NAME='frmForm'

<Input Type = 'Text'><p>

<Input Type = 'Text'><p>

<Input Type = 'Text'><p>

<Input Type = 'Text'><p>

<Input Type = 'Button' NAME='cmdChange' VALUE='Hierauf klicken'><p>

</FORM>

</CENTER>

</BODY>

</HTML>


Types of procedures

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Types of procedures

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Other topics in this chapter

Sub Procedures

Function Procedures

Getting data into and out of procedures

Using Sub and Function Procedures in Code


Sub Procedures

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Types of procedures -> Sub Procedures

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A Sub procedure is a series of VBScript statements (enclosed by Sub and End Sub statements) that perform actions but don't return a value. A Sub procedure can take arguments (constants, variables, or expressions that are passed to it by a calling procedure). If a Sub procedure has no arguments, its Sub statement must include an empty set of parentheses ().

The following Sub procedure uses two intrinsic, or built-in, VBScript functions, MsgBox and InputBox, to prompt a user for information. It then displays the results of a calculation based on that information. The calculation is performed in a Function procedure created using VBScript. The Function procedure is shown after the following discussion.

Sub ConvertTemp()

temp = InputBox('Please enter the temperature in degrees F.', 1)

MsgBox 'The temperature is ' & Celsius(temp) & ' degrees C.'

End Sub


Function Procedures

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Types of procedures -> Function Procedures

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A Function procedure is a series of VBScript statements enclosed by the Function and End Function statements. A Function procedure is similar to a Sub procedure, but can also return a value. A Function procedure can take arguments (constants, variables, or expressions that are passed to it by a calling procedure). If a Function procedure has no arguments, its Function statement must include an empty set of parentheses. A Function returns a value by assigning a value to its name in one or more statements of the procedure. The return type of a Function is always a Variant.

In the following example, the Celsius function calculates degrees Celsius from degrees Fahrenheit. When the function is called from the ConvertTemp Sub procedure, a variable containing the argument value is passed to the function. The result of the calculation is returned to the calling procedure and displayed in a message box.

Sub ConvertTemp()

temp = InputBox('Please enter the temperature in degrees F.', 1)

MsgBox 'The temperature is ' & Celsius(temp) & ' degrees C.'

End Sub

Function Celsius(fDegrees)

Celsius = (fDegrees - 32) * 5 / 9

End Function


Getting data into and out of procedures

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Types of procedures -> Getting data into and out of procedures

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Each piece of data is passed into your procedures using an argument . Arguments serve as placeholders for the data you want to pass into your procedure. When you create a procedure using either the Sub statement or the Function statement, parentheses must be included after the name of the procedure. Any arguments are placed inside these parentheses, separated by commas. For example, in the following example, fDegrees is a placeholder for the value being passed into the Celsius function for conversion.

Function Celsius(fDegrees)

Celsius = (fDegrees - 32) * 5 / 9

End Function


Using Sub and Function Procedures in Code

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Types of procedures -> Using Sub and Function Procedures in Code

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A Function in your code must always be used on the right side of a variable assignment or in an expression.

Examples:

Temp = Celsius(fDegrees)

or

MsgBox 'The temperature is ' & Celsius(temp) & ' degrees C.'

To call a Sub procedure from another procedure, type the name of the procedure along with values for any required arguments, each separated by a comma. The Call statement is not required, but if you do use it, you must enclose any arguments in parentheses.

The following example shows two calls to the MyProc procedure. In the one case the Call statement is used in the code, in the other one it is not. Both calls have the same result.

Call MyProc(firstarg, secondarg)

MyProc firstarg, secondarg


Coding Conventions

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Coding Conventions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Coding conventions are suggestions are designed to help you write code using Microsoft Visual Basic Scripting Edition.

Coding conventions can include the following:

Naming conventions for objects, variables, and procedures

Commenting conventions

Text formatting and indenting guidelines

The main reason for using a consistent set of coding conventions is to standardize the structure and coding style of a script or set of scripts so that you and others can easily read and understand the code. Using good coding conventions results in clear, precise, and readable source code that is consistent with other language conventions and is intuitive.

Other topics in this chapter

Constant Naming Conventions

Variable Naming Conventions

Variable Scope

Descriptive Variable and Procedure Names

Object Naming Conventions

Code Commenting Conventions


Constant Naming Conventions

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Coding Conventions -> Constant Naming Conventions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Earlier versions of VBScript had no mechanism for creating user-defined constants. Constants, if used, were implemented as variables and distinguished from other variables using all uppercase characters. Multiple words were separated using the underscore (_) character.

Examples:

USER_LIST_MAX
NEW_LINE

Although this way of naming constants still works, you can use a different way of naming. You can create real constants with the statement Const. This convention uses a mixed-case format in which constant names have a "con" prefix.

For example:

conYourOwnConstant


Variable Naming Conventions

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Coding Conventions -> Variable Naming Conventions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To enhance readability and consistency, use the following summary with descriptive names for variables in your VBScript code.

Subtype | Prefix | Example
Boolean | bln | blnFound
Byte | byt | bytRasterData
Date (Time) | dtm | dtmStart
Double | dbl | dblTolerance
Error | err | errOrderNum
Integer | int | intQuantity
Long | lng | lngDistance
Object | obj | objCurrent
Single | sng | sngAverage
String | str | strFirstName


Variable Scope

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Coding Conventions -> Variable Scope

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Variables should always be defined with the smallest scope possible. VBScript variables can have the following scope.

Valid range | Declaration | Visibility
Procedure-level | Event, Function, or Sub procedure. | Visible in the procedure in which it is declared.
Script-level | HEAD section of an HTML page, outside any procedure. | Visible in every procedure in the script.

Other topics in this chapter

Variable Scope Prefixes


Variable Scope Prefixes

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Coding Conventions -> Variable Scope -> Variable Scope Prefixes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Variable Scope Prefixes

As script size grows, so does the value of being able to quickly differentiate the scope of variables. A one-letter scope prefix preceding the type prefix provides this, without unduly increasing the size of variable names.

Valid range | Prefix | Example
Procedure-level | None | dblVelocity
Script-level | sec | sblnCalcInProgress


Descriptive Variable and Procedure Names

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Coding Conventions -> Descriptive Variable and Procedure Names

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the core of a variable or procedure name also capitals should be used. The name should be long enough to describe the use of the variable. In addition, procedure names should begin with a verb, such as InitNameArray or CloseDialog.

For frequently used or long terms, standard abbreviations are recommended to help keep name length reasonable. In general, variable names greater than 32 characters can be difficult to read. When using abbreviations, make sure they are consistent throughout the entire script. For example, randomly switching between Cnt and Count within a script or set of scripts may lead to confusion.


Object Naming Conventions

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Coding Conventions -> Object Naming Conventions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following table lists recommended conventions for objects you may encounter while programming VBScript.

Object type | Prefix | Example
3D Panel | pnl | pnlGroup
Animated button | ani | aniMailBox
Check box | chk | chkReadOnly
Combo box, drop-down list box | cbo | cboEnglish
Command button | cmd | cmdExit
Common dialog | dlg | dlgFileOpen
Frame | fra | fraLanguage
Horizontal scroll bar | hsb | hsbVolume
Image | img | imgIcon
Label | lbl | lblHelpMessage
Line | lin | linVertical
List Box | lst | lstPolicyCodes
Spin | spn | spnPages
Text box | txt | txtLastName
Vertical scroll bar | vsb | vsbRate
Slider | sld | sldScale


Code Commenting Conventions

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Coding Conventions -> Code Commenting Conventions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Each procedure should start with a short comment describing the purpose of the procedure. This description should not go into implementation details (how operations are executed), because these might change with the time. This could result in maintenance effort for the comments and - even worse - wrong comments. The code itself and any necessary inline comments describe the implementation.

Arguments passed to a procedure should be described when their purpose is not obvious and when the procedure expects the arguments to be in a specific range. Return values for functions and variables that are changed by a procedure, especially through reference arguments, should also be described at the beginning of each procedure.

Procedure header comments should include the following section headings. For examples, see the "Formatting Your Code" section that follows.

Section Heading | Comment
Purpose | What the procedure does (not how).
Assumptions | List of the procedure's effect on each external variable, control, or other element.
Effects | List of the procedure's effect on each external variable, control, or other element.
Inputs | Explanation of each argument that is not obvious. Each argument should be on a separate line with inline comments.
Return Values | Explanation of the value returned.

Remember the following points:

Every important variable declaration should include an inline comment describing the use of the variable being declared.

Variables, controls, and procedures should be named clearly to ensure that inline comments are only needed for complex implementation details.

At the beginning of your script, you should include an overview that describes the script, enumerating objects, procedures, algorithms, dialog boxes, and other system dependencies. Sometimes a piece of pseudocode describing the algorithm can be helpful.

Other topics in this chapter

Code formating


Code formating

Manual -> Programming interfaces -> Process Control Engine (PCE) -> VB Script - Introduction -> Coding Conventions -> Code Commenting Conventions -> Code formating

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Code formating

Screen space should be conserved as much as possible, while still allowing code formatting to reflect logic structure and nesting. Here are a few suggestions:

  • Indent standard nested blocks four spaces.
  • Indent the overview comments of a procedure one space.
  • The statements on the highest level, directly following the overview comment, should be indented with four blanks. Each nested block should again be indented by four blanks.

Example:

The following code adheres to VB Script coding conventions.

  • ' Purpose: Searches for the first appearance of the stated user in the data field UserList.
  • Inputs: strUserList(): the list of users to be searched.
  • strZielUser: the name of the user to search for.
  • Return values: Index of the first appearance of strTargetUser in the data field strUserList.
    If the target user is not found, return -1. -1.

Function intFindUser (strUserList(), strTargetUser)

Dim i ' Loop counter.

Dim blnFound ' 'Target found' flag.

intFindUser = -1

i = 0 ' Initialize loop counter

Do While i <= Ubound(strUserList) and Not blnFound

If strUserList(i) = strTargetUser Then

blnFound = True ' Set flag to True

intFindUser = i ' Set return value to loop count

End If

i = i + 1 ' Increment loop counter

Loop

End Function


Macro list

Manual -> Programming interfaces -> Macro list

You can use VBA and VSTA in order to extend zenon functionality. The usage of macros with zenon is described.

Context menu

Menu item | Action
Open VBA Editor | Opens the VBA Editor.
Export all VBE | Opens the dialog for selecting the storage directory for the VBE export.
Import VBE | Opens the dialog for selecting the VBE import file.
Editor profiles | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.

info Information

If VBA macros are changed in the Editor,

  • the Runtime files are compiled and transferred to the Runtime
  • the Runtime is reloaded
  • VSTA elements are also reloaded even if no changes were made in VSTA

VBA starts the same development environment for workspace and project. To open the VBA Editor:

  1. navigate to the Programming interfaces node
  2. right-click on VBA macros
  3. select Open in VBA Editor... in the context menu

Alternative: press the short cut Ctrl+F11

Other topics in this chapter

VBA toolbar and context menu detail view

VBA on 64-bit systems

Basics

Macros in the Editor

Functions in zenon

Developing wizard in VBA

Frequently asked questions

Examples


VBA toolbar and context menu detail view

Manual -> Programming interfaces -> Macro list -> VBA toolbar and context menu detail view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tool Bar

Menu item | Action
New VBA macro | Creates a new macro and opens the macro Editor.
Open VBA Editor | Opens the VBA Editor.
Save | Saves macros.
Remove | Deletes the selected element.
Export all VBE | Opens the dialog for selecting the storage directory for the VBE export.
Import VBE | Opens the dialog for selecting the VBE import file.
Rename | Makes it possible to rename the selected macro.
Help | Opens online help.

Context menu module

Menu item | Action
Open VBA Editor | Opens the VBA Editor.
Save | Saves macros.
Export all VBE | Opens the dialog for selecting the storage directory for the VBE export.
Import VBE | Opens the dialog for selecting the VBE import file.
Help | Opens online help.

Context menu module

Menu item | Action
New VBA macro | Creates a new macro and opens the VBA Editor.
Help | Opens online help.

Context menu macro

Menu item | Action
Edit | Opens macro in the Editor for editing. Alternatively: Enter button or double click.
Remove | Deletes macro. Alternatively: Del key
Rename | Opens list elements for editing. Alternatively: F2 key.
Help | Opens online help.

Tool bar editor

Macros that were created with VBA can be administrated via toolbar-item Macro list.

Symbol (from left to right) | Function
Reload list of VBA/VSTA macros | Loads all Public Sub Name () macros that are included in myWorkspace and in modules to the drop-down list of the toolbar.
Search Macro | Search for macros via combobox input field or selection from drop-down list. The drop-down list is adjusted to the widest element when opened.
Drop-down list Macros | Contains all loaded macros for selection.
Execute selected macro | Executes the macro selected in the drop-down list.
execute allocated macro #<x> | Executes the macro allocated with the symbol.
Allocate macros | Opens the allocation dialog for macros. Up to 5 macros can be allocated with the symbols 1 to 5.
VBA | Filters for VBA-macros. Only VBA-macros are displayed.
VSTA | Filters for VSTA-macros. Only VSTA-macros are displayed.
ALL | Cancels the current filter and all macros are displayed.
AZ | Sorts macros in ascending order from 0 - 9 and A - Z.
ZA | Sorts macros in descending order from Z - A and 9 - 0.
Options for symbol bar | Clicking on the arrow opens the submenu: Active: Tool bar is displayed If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar. Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.

info Information

If the macro assignment dialog does not list all macros from myWorkspace, execute the function Reload list of VBA macros in the toolbar.


VBA on 64-bit systems

Manual -> Programming interfaces -> Macro list -> VBA on 64-bit systems

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon has supported 64-bit operating systems since version 7.10. VBA was thus converted to VBA version 7.1. Therefore VBA is also available in zenon 64-bit. If, in the VBA code, Windows API or other imported DLL functions are accessed, these calls must be adapted to 64-bit. In general, the following applies: A VBA file created with a 32-bit version cannot be used without changes in a 64-‑bit version.

There are some defines/functions available in VBA in order to write 32-bit and 64-bit compatible code. For example:

#if Win64 then

Declare PtrSafe Function MyMathFunc Lib "User32" (ByVal N As LongLong) As LongLong

#else

Declare Function MyMathFunc Lib "User32" (ByVal N As Long) As Long

#end if

#if VBA7 then

Declare PtrSafe Sub MessageBeep Lib "User32" (ByVal N AS Long)

#else

Declare Sub MessageBeep Lib "User32" (ByVal N AS Long)

#end if

You can also obtain some useful notes on the porting of VBA 32-bit code to VBA 64-bit from Microsoft:

  • Microsoft Office 2010, notes on porting: http://msdn.microsoft.com/en-us/library/ee691831.aspx
  • 32-bit and 64-bit declares for API calls: http://www.jkp-ads.com/articles/apideclarations.asp


Basics

Manual -> Programming interfaces -> Macro list -> Basics

Describes the basics of the programming language VBA - Visual Basic for Applications

Other topics in this chapter

Object PROPERTIES

Object METHODS

Object EVENTS

VBA object structure in zenon

How to use VBA macros

How to insert an ActiveX element in zenon?

Access from an external program

Functionality of online variables

List of status bits

Lasso for selecting dynamic elements in the Runtime


Object PROPERTIES

Manual -> Programming interfaces -> Macro list -> Basics -> Object PROPERTIES

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

An object property is a certain attribute of the object. In case of a variable object this e.g. can be the value, the name or the identification. In case of a circle the position or the color of the circle in the screen. Each object has at least one property (usually more), each property has a certain value. While the property name is a text, the property value is a value between 0 and e.g. 1000.

The special thing with properties is, that with changing the property value in a VBA program you can change the behaviour or the appearance of the object. If you e.g. change the property value of a variable object, the currently selected variable gets this new value. You cannot cange the value of each property. The property count of the variable object cannot be changed, because it represents the number of created variables. You cannot add variables by changing the value of Count. So some properties are read only, i.e. their values only can be read.


Object METHODS

Manual -> Programming interfaces -> Macro list -> Basics -> Object METHODS

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Beside the properties each object can have methods. A method is not an attribute but a request to the object to do something. So a form has the method Show. What does it do? It requests the form to appear on the screen. Accordingly the form disappears when using the method Unload.

The advantage of methods is, that the programmer does not have to know anything about the structure of the object and most of all has no opportunity to chnage the internal data of the object.

Executing the method Show or Unload works as follows:

frmSollwert.Show or Unload frmSollwert

If you want to open another form, the method stays the same, only the name of the form (object name) changes.

frmChange.Show or Unload frmChange

So one and the same method can be used for different object types. But not every object must have methods.


Object EVENTS

Manual -> Programming interfaces -> Macro list -> Basics -> Object EVENTS

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In 90% of working with objects you will use properties and methods, but there is a third kind of attributes objects can have: Events. Some objects of the control system object hierarchy can react on events. Events take place during the work with zenon on their own.

Example Example

Whenever a screen is opened, an open event is triggered in the according screen object. As a programmer you can add commands to the event procedure (procedure to be executed, when the event happens), which define, what should happen in this case. One example for this is changing a variable. You can create an event, which reacts on value changes of a variable.


VBA object structure in zenon

Manual -> Programming interfaces -> Macro list -> Basics -> VBA object structure in zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Basically there is a object list and objects again and again in the project structure.

Example:

Projects – Project

Variables – Variable

Elements – Element

You can find more about the object model:

  • in the VBA help

  • in the graphical overview which you can obtain from COPA-DATA complete as printed overview.

  • in the VBA object browser


How to use VBA macros

Manual -> Programming interfaces -> Macro list -> Basics -> How to use VBA macros

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to create a new macro in the window Project info on the property page Macro Browser select a desired event, when the new macro should be executed.

Clicking on this event with the right mouse button opens a menu.

Select the menu entry "New macro..." Thus zenon generates a procedure:

Public Sub LeftClickUp_Sollwert(obElem As Element)
End Sub

If a macro already exists, it can be edited, deleted or renamed by clicking it with the right mouse button.

attention Attention

If you select menu item Rename macro, take care that you do not change the name of the event e.g. LeftClickUp_..., - of the current name. Otherwise renaming will not be executed. Additionally you have to change the name of the sub program to be executed in the VBA Editor by hand, if you rename a macro.

After you have filled the procedure generated by zenon with the source code to be executed, the created macro has to be linked to an element.

Doubleclicking the element opens the property dialog of the element.

On the property page Events the macro is linked to the element.

Clicking the element with the left mouse button executed the LeftClickDown event of the element and the linked macro.

Other topics in this chapter

Inserting existing macros


Inserting existing macros

Manual -> Programming interfaces -> Macro list -> Basics -> How to use VBA macros -> Inserting existing macros

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to insert existing macros into another project do the following:

  1. In the VBA Editor export all needed forms and modules and import them in the other project.
  2. Event dependent macros, in ModulElement.bas, are not displayed in the macro browser at the moment. So this macros have to be created in the macro browser.

    The easiest way is to use the name of the existing macro.

    e.g.:
    LeftClickUp_ DateSet2
    LeftClickUp_ DateSet4
    LeftClickUp_ TimeSet
    Draw_ Date2
    Draw_ Date4
    Draw_ Time

  3. On creating the macros zenon generates procedures with the same name as the existing macros. You have to delete these generated procedures.
  4. Connect the macros as usual with a dynamic element.


How to insert an ActiveX element in zenon?

Manual -> Programming interfaces -> Macro list -> Basics -> How to insert an ActiveX element in zenon?

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

An ActiveX element is drawn into the screen like any other dynamic element; a dialog opens, where you musz select an ActiveX element.

  • After you have selected the element from the list, you can links variables to it. For this click the button Variable and select a variable or create a new one.
  • In the next step we give the ActiveX element an object name, so that we can access it in VBA.
  • In our example we give it the object name Slide6_DW18, because it is an AcziveX element Slider linked to the variable Doubleword18.
  • Now the Slider element has to be activated and edited in the VBA Editor.
  • For this we create a new macro as described in chapter "How to use VBA macros?".

The macro Init_Slider passes the element to be initialized to a sub program in the control system object thisProject, whereby the allocation to the current project is defined.

Public SubInit_Slider(obElem AsElement)
thisProject . Init _ Slider obElem
End Sub

Just like in the macro Init_Slider also Draw_SliderValue passes the element to the control system object thisProject.

Public Sub Draw_SliderValue (obElem As Element, ByVal hdc As OLE _ HANDLE )
thisProject.Draw_Slider obElem
obElem.Draw hdc
End Sub

The code below is added in the control system object this Project.

Public Declarations
Public WithEvents obSlider As Slider
Public obSliderPV As Variable
Public Sub Init_Slider (obElem As Element)
Set obSlider = obElem.ActiveX

'ActiveX exists
If obSlider Is Nothing Then
Exit Sub
End If
Set obSliderPV = obElem . ItemVariable(0)
'variable exists
If obSliderPV Is Nothing Then
Exit Sub
End If
obSlider.Max = obSliderPV.RangeMax
obSlider.Min = obSliderPV.RangeMin
obSlider.TickFrequency = 1000
obSlider.LargeChange = 25
obSlider.SmallChange = 1
obSlider.Value = obSliderPV.Value

End Sub

Public Sub Draw _ Slider ( obElem As Element )
Dim vVar As Variant
Dim obDynPic As DynPicture

Set obSliderPV = obElem.ItemVariable ( 0 )
Set obDynPic = thisProject.DynPictures. Item (BILD_1)
'variable exists
If obSliderPV Is Nothing Then
Exit Sub
End If


Access from an external program

Manual -> Programming interfaces -> Macro list -> Basics -> Access from an external program

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to access zenon data from an external program such as e.g. Visual Basic the COM interface is used. This COM interface is also used by VBA. So there are only a few small differences, that should be cared of.

Other topics in this chapter

Visual Basic 6


Visual Basic 6

Manual -> Programming interfaces -> Macro list -> Basics -> Access from an external program -> Visual Basic 6

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to be able to access the COM interface it has to be implemented:

With this type library you can access the application object of zenon (the Runtime).

As here there is no thisProject object, it has to be created to get access to the data.

Dim obProject As zenon.Project
Set obProject = zenon.Application.Projects.Item(PROJEKTNAME)

If the VB project should work with all zenon projects - should be project name independent - it can be defined in the following way:

Set obProject = zenon.Application.Projects.Item(0)

After the project object (thisProject) has been created, e.g. the variables can be accessed for reading and writing.

Read:

Value = obProject.Variables.Item(Variablenname).Value

Write:

obProject.Variables.Item(Variablenname).Value = Value


Functionality of online variables

Manual -> Programming interfaces -> Macro list -> Basics -> Functionality of online variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can imagine a VBA OnlineVariable as a container; this container contains control system variables, which have to be added. If the value of one of the variables of the container changes, this is indicated with an event.

Other topics in this chapter

Functionality of the event:

Define and create container

Put variables in the container

Create event

Activate event

Switching off the event

Remove on closing


Functionality of the event:

Manual -> Programming interfaces -> Macro list -> Basics -> Functionality of online variables -> Functionality of the event:

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If the container is activated (Container.Define), all variables in the container are forced once, so that the current value of the variables are known. So the procedure Container_VariableChange is executed for each variable in the container. As soon as all variables then have been initialized, this event always occurs, if one of the variables of the container changes its value.

So it is avoided, that a value is read, which is not the current value of the variable.


Define and create container

Manual -> Programming interfaces -> Macro list -> Basics -> Functionality of online variables -> Define and create container

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Definition:

Public WithEvents Container As OnlineVariable

With this line of code the container is defined.

Creating:

Set Container = thisProject . OnlineVariables . CreateOnlineVariables ( Containername )


Put variables in the container

Manual -> Programming interfaces -> Macro list -> Basics -> Functionality of online variables -> Put variables in the container

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Container . Add Variablenname1
Container . Add Variablenname2
Container . Add Variablenname3
Container . Add Variablenname4
...

Repeat this line, until all needed variables are added to the container.


Create event

Manual -> Programming interfaces -> Macro list -> Basics -> Functionality of online variables -> Create event

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Private Sub Container_VariableChange(ByVal obVar As zenon.IVariable)

...

End Sub

This event is automatically created, when the container is selected in the left combobox at the top of the VBA Editor. The procedure above then is added to the source code. With obVar the variable with the changed value is passed on. When this event occurs, e.g. the current value of the variable (ob-Var.Value) can be read. Refer to the object hierarchy in the VBA documentation to see the properties and values of variables, which can be used.


Activate event

Manual -> Programming interfaces -> Macro list -> Basics -> Functionality of online variables -> Activate event

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Container.Define

This command line activates the monitoring of the variables in the container. After executing the command Define, the container is active.


Switching off the event

Manual -> Programming interfaces -> Macro list -> Basics -> Functionality of online variables -> Switching off the event

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Container.Undefine

With this command the surveillance in the container is switched off. The event (VariableChange) is no longer carried out.


Remove on closing

Manual -> Programming interfaces -> Macro list -> Basics -> Functionality of online variables -> Remove on closing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order not to leave anything in the memory on closing the Runtime, the container has to be removed at the latest on closing the Runtime.

thisProject . OnlineVariables . DeleteOnlineVariables ( Containername )

Not before the container is deleted can another container with the same name be created.


List of status bits

Manual -> Programming interfaces -> Macro list -> Basics -> List of status bits

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Short term | Long name | zenon Logic label
0 | M1 | User status 1 | _VSB_ST_M1
1 | M2 | User status 2 | _VSB_ST_M2
2 | M3 | User status 3 | _VSB_ST_M3
3 | M4 | User status 4 | _VSB_ST_M4
4 | M5 | User status 5 | _VSB_ST_M5
5 | M6 | User status 6 | _VSB_ST_M6
6 | M7 | User status 7 | _VSB_ST_M7
7 | M8 | User status 8 | _VSB_ST_M8
8 | NET_SEL | Select in the network | _VSB_SELEC
9 | REVISION | Revision | _VSB_REV
10 | PROGRESS | In operation | _VSB_DIREC
11 | TIMEOUT | Runtime exceedance | _VSB_RTE
12 | MAN_VAL | Manual value | _VSB_MVALUE
13 | M14 | User status 14 | _VSB_ST_14
14 | M15 | User status 15 | _VSB_ST_15
15 | M16 | User status 16 | _VSB_ST_16
16 | GI | General interrogation | _VSB_GR
17 | SPONT | Spontaneous | _VSB_SPONT
18 | INVALID | Invalid | _VSB_I_BIT
19 | T_CHG_A | Daylight saving time/winter time announcement | _VSB_SUWI
20 | OFF | Switched off | _VSB_N_UPD
21 | T_EXTERN | Real time external | _VSB_RT_E
22 | T_INTERN | Realtime internal | _VSB_RT_I
23 | N_SORTAB | Not sortable | _VSB_NSORT
24 | FM_TR | Error message transformer value | _VSB_DM_TR
25 | RM_TR | Working message transformer value | _VSB_RM_TR
26 | INFO | Information for the variable | _VSB_INFO
27 | ALT_VAL | Alternate value If no value was transferred, the defined alternate value is used otherwise the last valid value is used. | _VSB_AVALUE
28 | RES28 | Reserved for internal use (alarm flashing) | _VSB_RES28
29 | N_UPDATE | Not updated | _VSB_ACTUAL
30 | T_STD | Standard time | _VSB_WINTER
31 | RES31 | Reserved for internal use (alarm flashing) | _VSB_RES31
32 | COT0 | Cause of transmission bit 1 | _VSB_TCB0
33 | COT1 | Cause of transmission bit 2 | _VSB_TCB1
34 | COT2 | Cause of transmission bit 3 | _VSB_TCB2
35 | COT3 | Cause of transmission bit 4 | _VSB_TCB3
36 | COT4 | Cause of transmission bit 5 | _VSB_TCB4
37 | COT5 | Cause of transmission bit 6 | _VSB_TCB5
38 | N_CONF | Negative acceptance of Select by device (IEC 60870) | _VSB_PN_BIT
39 | TEST | Test bit (IEC870 [T]) | _VSB_T_BIT
40 | WR_ACK | Writing acknowledged | _VSB_WR_ACK
41 | WR_SUC | Writing successful | _VSB_WR_SUC
42 | NORM | Normal status | _VSB_NORM
43 | N_NORM | Deviation normal status | _VSB_ABNORM
44 | BL_870 | IEC 60870 Status: blocked | _VSB_BL_BIT
45 | SB_870 | IEC 60870 Status: substituted | _VSB_SP_BIT
46 | NT_870 | IEC 60870 Status: not topical | _VSB_NT_BIT
47 | OV_870 | IEC 60870 Status: overflow | _VSB_OV_BIT
48 | SE_870 | IEC 60870 Status: select | _VSB_SE_BIT
49 | T_INVAL | Time invalid | not defined
50 | CB_TRIP | Breaker tripping detected | not defined
51 | CB_TR_I | Breaker tripping detection inactive | not defined
52 | RES52 | reserved | not defined
53 | RES53 | reserved | not defined
54 | RES54 | reserved | not defined
55 | RES55 | reserved | not defined
56 | RES56 | reserved | not defined
57 | RES57 | reserved | not defined
58 | RES58 | reserved | not defined
59 | RES59 | reserved | not defined
60 | RES60 | reserved | not defined
61 | RES61 | reserved | not defined
62 | RES62 | reserved | not defined
63 | RES63 | reserved | not defined

info Information

In formulas all status bits are available. For other use the availability can be reduced.

You can read details on status processing in the Status processing chapter.


Lasso for selecting dynamic elements in the Runtime

Manual -> Programming interfaces -> Macro list -> Basics -> Lasso for selecting dynamic elements in the Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynamic elements which are linked with a variable or function can be pre-selected with the lasso in the Runtime and therefore by used for events.

With method SelElements the user can identify selected dynamic elements as selected in the Runtime. These DynPicture.SelElements can then by used for events sich as drag&drop.

Selection per lasso

To select elements with the lasso in the Runtime, you must:

  • activate property Runtime lasso in the project settings
  • activate property Runtime/selectable with lasso in the property of the dynamic element
  • property Move Frame via mouse must be activated

There are several methods for selecting elements available in Runtime, depending on the settings for touch operation:

  • Touch operation deactivated or Windows 7 (Recognition property deactivated or Windows 7):
    • Left mouse click + movement: New selection is created.
    • Left mouse click + Ctrl key + movement: Selection is expanded.
  • Native Windows 8 touch operation active (Recognition property on Windows 8):
    • Left mouse click + movement: Screen is moved
    • Left mouse click + Ctrl key + movement: Screen is moved.
    • Left mouse click + Shift key + movement: New selection is created.
    • Left mouse click + Ctrl key + Shift key + movement: Selection is expanded.

Rules:

  • Only elements that are visible can be selected.
  • If a button is selected and it is clicked on, the respective function is executed.
  • If a button is clicked on with a mouse button and the mouse is moved before the mouse button is released, the respective function is not executed.
  • Cancel selection: Spanning a lasso which does not contain elements.


Macros in the Editor

Manual -> Programming interfaces -> Macro list -> Macros in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Macros can be carried out with the help of a configurable Toolbar in the Editor. For this macros are linked with buttons in toolbar VBA.

In addition macros can be run manually using the VBA Editor.

With the help of Wizards repeating engineering tasks can be run or whole projects can be created with the click on a button. As examples a few wizards are already included in the shipped version of zenon. These wizards can be enhanced and completed at will. They help when creating a project, at the import and export, at creating variables and so on. You can find details in chapter Wizards.

Editor events

Editor events are part of the VBA workspace and make it possible to react to Events in the workspace programming, e.g. for wizards or Remote Transport. For example:

  • OnElementCreated
  • OnElementDeleted
  • OnElementDoubleClicked
  • OnObjectCreated
  • ...

All Events and information about them can be found in the help in chapter Object Model.

Other topics in this chapter

Tool bar macro list

Linking macros


Tool bar macro list

Manual -> Programming interfaces -> Macro list -> Macros in the Editor -> Tool bar macro list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Macros that were created with VBA can be administrated via toolbar-item Macro list.

Symbol (from left to right) | Function
Reload list of VBA/VSTA macros | Loads all Public Sub Name () macros that are included in myWorkspace and in modules to the drop-down list of the toolbar.
Search Macro | Search for macros via combobox input field or selection from drop-down list. The drop-down list is adjusted to the widest element when opened.
Drop-down list Macros | Contains all loaded macros for selection.
Execute selected macro | Executes the macro selected in the drop-down list.
execute allocated macro #<x> | Executes the macro allocated with the symbol.
Allocate macros | Opens the allocation dialog for macros. Up to 5 macros can be allocated with the symbols 1 to 5.
VBA | Filters for VBA-macros. Only VBA-macros are displayed.
VSTA | Filters for VSTA-macros. Only VSTA-macros are displayed.
ALL | Cancels the current filter and all macros are displayed.
AZ | Sorts macros in ascending order from 0 - 9 and A - Z.
ZA | Sorts macros in descending order from Z - A and 9 - 0.
Options for symbol bar | Clicking on the arrow opens the submenu: Active: Tool bar is displayed If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar. Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.

info Information

If the macro assignment dialog does not list all macros from myWorkspace, execute the function Reload list of VBA macros in the toolbar.


Linking macros

Manual -> Programming interfaces -> Macro list -> Macros in the Editor -> Linking macros

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Macros can be called via a button in the toolbar. A maximum of five macros can be linked this way. Via button Assign macros the dialog for assigning macros is opened.

Parameters | Description
Macro # | Macro number matches the number of the button in the toolbar. A click on button ... opens the dialog for selecting the macro.
OK | Creates links to the buttons and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.

Parameters | Description
Existing selection | List of macros which can be linked.
No selection | Deletes existing assignment for the button.
OK | Assigns the selected macro to the button.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Functions in zenon

Manual -> Programming interfaces -> Macro list -> Functions in zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In dialog Function selection you can find the following functions under element VBA.

Function | Description
Open PCE editor | Opens the editor of the optional module Process Control Engine (PCE).
Open VBA Editor | Opens the VBA editor
Execute VBA Macro | Executes a selected VBA macro. Attention: The VBA Event project inactive is carried out by script AUTO_END_xxx. Therefore zenon function Execute VBA macro is no longer executed in scripts as VBA is not running at this time.
Show VBA macro dialog | Opens the VBA macro dialog.

Other topics in this chapter

Execute VBA Macro


Execute VBA Macro

Manual -> Programming interfaces -> Macro list -> Functions in zenon -> Execute VBA Macro

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If you select function Execute VBA macro, the following dialog is displayed.

These settings are available.

Parameters | Description
Macro selection | Opens the dialog for selecting the macros (see also Macro selection) Hint: Only lists VBA macros that match the number of parameters defined at the function Parameter (below).
Parameters | Enter the desired value (string) for a parameter.
New | Click on this button in order to apply the value at parameter in the list of available parameter.
Delete | Click on this button in order to delete the selected entry from the list of available parameter. You can always only delete one entry at a time.
Up | Click on this button in order to move the selected entry up one place. In the parameter order the entry is moved one place to the front.
Down | Click on this button in order to move the selected entry down one place. In the parameter order the entry is moved one place to the back.

It is possible to add strings to macros which were created with parameters. These strings are transferred in the Runtime as individual parameters when the macro is carried out.

info Information

You must make sure that the number of parameters of the linked macro matches the number of the created parameters.

Other topics in this chapter

Macro selection


Macro selection

Manual -> Programming interfaces -> Macro list -> Functions in zenon -> Execute VBA Macro -> Macro selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

After clicking button ..., the following dialog is displayed.

Select the desired macro from the available macros and then click OK.


Developing wizard in VBA

Manual -> Programming interfaces -> Macro list -> Developing wizard in VBA

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Since version 6 it is possible to automate engineering projects with wizards. So frequently recurring tasks can be sourced out to a wizard which executes the desired actions, e.g. creating a project, creating frames and screens in a pre-defined standard.

Another field of application for wizards are automated changes in existing projects, e.g. changing properties of dynamic elements in all screens of an existing project.

The basis for the wizards is Microsoft Visual Basic for Applications (VBA) and the object model of zenon.

At the moment the following wizards are available:

  • Project Wizard
  • Import Wizard
  • World View Wizard
  • Find VBA-Text Wizard
  • Wizard for keyword creation
  • Wizard for keyword translation
  • Wizard for creating variables

The wizards are available as VBA source code files on the installation medium. New wizards can be implemented with the VBA environment.

Other topics in this chapter

Using a wizard

Structure of a wizard

Integration in VBA

Developing a wizard

Updating wizards


Using a wizard

Manual -> Programming interfaces -> Macro list -> Developing wizard in VBA -> Using a wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The menu entry Wizards in the menu File opens the wizard selection. In this dialog all activated wizards are displayed in their categories.

If a wizard has no category, the category Not linked is automatically created. In this category all not linked wizards are displayed.

By selecting a wizard and pressing the button OK the selected wizard is executed.

info Information

Wizards only support single-user projects and not multi-user projects.


Structure of a wizard

Manual -> Programming interfaces -> Macro list -> Developing wizard in VBA -> Structure of a wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A wizard is a UserForm stored in the application specific node of the application. Usually the UserForm consists of a multi-page element displaying the single steps of the wizard.

With a button Next the next page of the multi-page element is displayed. All entries have to be stored temporarily - the creation of objects, e.g. frames, screens, ... has to be done with Finishing the wizards.

info Information

UserForms to be used as wizards have to contain some public methods, which provide the control system with information about the wizard. If this routines are missing in a UserForm, it is not treated as a wizard.


Integration in VBA

Manual -> Programming interfaces -> Macro list -> Developing wizard in VBA -> Integration in VBA

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The wizards are stored in the application specific node ZWorkspace. This object represents the currently loaded workspace in the Editor and is only available in the zenon Editor.

All objects in this VBA project can access the current workspace with teh object MyWorkspace. It is always linked to the currently active project, which can be accessed with the property ActiveDocument.

The contents of the object ZWorkspace are stored in the file ZenWorkspace.vba. It is copied to the installation directory with the first installation of version 6. This file is not overwritten by later updates. You will find more information on updating wizards at the end of this tutorial.


Developing a wizard

Manual -> Programming interfaces -> Macro list -> Developing wizard in VBA -> Developing a wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This tutorial develops a wizard creating variables for a defined driver.

Start the VBA environment from the zenon Editor and change to folder ZWorkspace/Forms. This file contains the basics for developing a wizard. Change the name of the UserForm.

If the folder mentioned above is not available, you can import it via Import the Import file command.

info Information

For developing a wizard knowledge about the object model of zenon and VBA are required. These topics are not part of this tutorial.

Create the surface displayed above. Then switch to the code module of the UserForm and scroll to the end of the file. There you will find the following methods.

  • Public Function GetWizardName () As String

    Returns the unique name of the wizard. Change the contents to Wizard for creating variables

  • Public Function GetWizardInfo () As String

    Returns a short description displayed in the wizard selection. Change the contents to Wizard for creating variables to a selected driver

  • Public Function GetWizardCategory () As String

    Returns the category of the wizard. In the wizard selection the wizards are displayed in a tree structure of the categories. Change the contents to Variables.

  • Public Function IsZenOnWizard () As Boolean

    Displaying the wizard in the wizard selection. If this method returns False, the wizard is not displayed, e.g. because it is not yet finished. Change the return type to True.

These methods provide the information about the wizard, which is requested by the control system. Keep in mind that the wizard is only displayed in the wizard selection if the method IsZenOnWizard returns True.

Switch to the event Initialize of the UserForm and change the contents of the string array m_strCaption. As oru wizard only consits of two steps, you can delete the other allocations.

Add the following definitions to the top area of the code module:

Private m_obDriver As Driver
Private m_obVarType As VarType
Private m_nChannelType As Integer

Create a method for initializing the driver combobox. The task of this routine is to display all the loaded drivers of the current project in a combobox.

cbDriver.Clear
Dim nIndex As Long
For nIndex = 0 To MyWorkspace.ActiveDocument.Drivers.Count - 1
Dim obDriver As Driver
Set obDriver = MyWorkspace.ActiveDocument.Drivers.Item(nIndex)
If (Not obDriver Is Nothing) Then
cbDriver.AddItem
obDriver.Name
End If
Next nIndex
If (cbDriver.ListCount > 0) Then
cbDriver.ListIndex = 0
End If

Additionally we need a routine displaying all defined variable types of the project in a combobox.

If (Not m_obDriver Is Nothing) Then
cbVarType.Clear
Dim nIndex As Long , nSelect As Integer
For nIndex = 0 To MyWorkspace.ActiveDocument.VarTypes.Count - 1
Dim obVarType As VarType
Set obVarType = MyWorkspace.ActiveDocument.VarTypes.Item(nIndex)
If ( Not obVarType Is Nothing And obVarType.IsSimple = True) Then
cbVarType.AddItem
obVarType.Name
If (obVarType.Name = INT) Then
nSelect = nIndex
End If
End If
Next nIndex
cbVarType.ListIndex = nSelect
End If

On opening the wizard all existing variables are checked to find a free start offset for the the new variables to be created. This is done with the following method.

Private Function FindHighestOffsetVar() As Long
On Error GoTo Error
Dim nIndex As Long , nOffset As Long
For nIndex = 0 To MyWorkspace.ActiveDocument.Variables.Count - 1

Dim obVar As Variable
Set obVar = MyWorkspace.ActiveDocument.Variables.Item(nIndex)
If ( Not obVar Is Nothing) Then
If (obVar.Offset > nOffset) Then
nOffset = obVar.Offset
End If
End If
Next nIndex
FindHighestOffsetVar = nOffset
Exit Function
Error : MsgBox
Error occurs: + Err.Description + Source + Err.Source
End Function

Switch to the event Initialize of the UserForm and add the following lines to this method:

txtStart.Value = CStr(FindHighestOffsetVar + 1)

InitializeDriver

The allocation to txtStart sets the proposed start offset for the variables to be created. The method InitializeDriver fills the combobox with the existing drivers.

Create an event Change for the driver combobox and add the following code. After having selected a driver the variable types are acquired. The selected driver object is stored in the variable m_obDriver for later use.

Private Sub cbDriver_Change()
cmdNext.Enabled = True
Set m_obDriver = MyWorkspace.ActiveDocument.Drivers.Item(cbDriver.Value)
If ( Not m_obDriver Is Nothing) Then
InitializeVarType
End If
End Sub

Create an event Change for the variable type combobox and add the following code. The selected variable type is stored in the variable m_obVarType for later use.

Private Sub cbVarType_Change()
Set m_obVarType = MyWorkspace.ActiveDocument.VarTypes.Item(cbVarType.Value)
End Sub

Now the only thing left is to create the event routine for creating the variables with the defined settings. This is done with the button Finish.

Private Sub cmdFinish_Click()
On Error GoTo Error
If (cbVarType.ListIndex = -1) Then
MsgBox 'Please select a variable type'
cbVarType.SetFocus
Exit Sub
End If
If (txtStart.Value = Or txtCount.Value = Or txtStep.Value = ) Then
MsgBox 'Please enter Start-Offset', 'count of creating variables and the step'
txtStart.SetFocus
End If
If (m_obVarType Is Nothing) Then
MsgBox 'Variable type + cbVarType.Name + doesnt exist!'
Exit Sub
End If
Dim nPrvMousePtr As Integer
nPrvMousePtr = MousePointer
MousePointer = fmMousePointerHourGlass
DoEvents
Dim strName As String
Dim nIndex As Long , nVarIndex As Integer
Dim nStartOff As Long , nStep As Integer
nVarIndex = 1
nStartOff = CLng (txtStart.Value)
nStep = CLng (txtStep.Value)
For nIndex = 0 To CLng (txtCount.Value - 1)
Dim obVar As Variable
strName = txtName.Value + _ + CStr (nIndex + 1)
'*** Guaranteeing uniqueness of the variable name
Dim bResult As Boolean
bResult = False
Do
Set obVar = MyWorkspace.ActiveDocument.Variables.Item(strName)
If (obVar Is Nothing) Then
bResult = True
Else
nVarIndex = nVarIndex + 1
strName = txtName.Value + _ + CStr (nVarIndex)
End If
Loop While
bResult = False
'*** Create variable
Set obVar = MyWorkspace.ActiveDocument.Variables.CreateVar (strName, m_obDriver, tpSPSMerker, m_obVarType)
If ( Not obVar Is Nothing) Then
obVar.Offset = nStartOff
nStartOff = nStartOff + nStep
End If
Next nIndex
MousePointer = nPrvMousePtr
Unload Me
Exit Sub
Error :
MousePointer = nPrvMousePtr
MsgBox Error occurs: + Err.Description + Source + Err.Source
End Sub

On finishing the wizard it is checked, if the defined settings are valid. If this is not the case, a messages is displayed and the user is demanded to correct the entries.

If the defined settings are valid, the variables are created. The variables are named with a name and an index. If a variables with the same name already exists in the project, the next free index is acquired. In our code example always a variable with the channel type PLC marker is created. With each cycle the offset of the variable is increased.


Updating wizards

Manual -> Programming interfaces -> Macro list -> Developing wizard in VBA -> Updating wizards

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To update the wizards:

  1. Select Update wizards.. in the File menu.
  2. a dialog for updating available wizards is opened
  3. select the desired wizards
  4. start the update by clicking Start update

If a wizard or a class already exists in the workspace, a warning is displayed.

attention Attention

Already existing wizards are overwritten during the update. Individual changes made at the wizard are lost.


Frequently asked questions

Manual -> Programming interfaces -> Macro list -> Frequently asked questions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this chapter a few frequently asked questions are answered. You can find additional solutions online in the COPA-DATA User forum.

Other topics in this chapter

Why does the button stay pressed?

Macro is not performed with the first click

Macros no longer work in the Runtime?

Windows CE and VBA


Why does the button stay pressed?

Manual -> Programming interfaces -> Macro list -> Frequently asked questions -> Why does the button stay pressed?

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If a button is linked e.g. to a LeftClickUp event, in the end of the precedure the LeftClickUp has to be executed.

Public Sub LeftClickUp_Schalter(obElem As Element)
frmSchalter.Show

obElem.LeftClickUp
End Sub


Macro is not performed with the first click

Manual -> Programming interfaces -> Macro list -> Frequently asked questions -> Macro is not performed with the first click

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The solution matches the one from the question: Why does the button stay pressed:

If a button is linked e.g. to a LeftClickUp event, in the end of the precedure the LeftClickUp has to be executed.

Public Sub LeftClickUp_Schalter(obElem As Element)
frmSchalter.Show

obElem.LeftClickUp
End Sub


Macros no longer work in the Runtime?

Manual -> Programming interfaces -> Macro list -> Frequently asked questions -> Macros no longer work in the Runtime?

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This effect can occur, if the VBA Editor is opened in the Runtime and then Stop/Start is pressed to stop/start VBA. In this case the objects (OnlineVariables, ScreenObjects, ...) become invalid, because they lose the link in case of a new initialization.


Windows CE and VBA

Manual -> Programming interfaces -> Macro list -> Frequently asked questions -> Windows CE and VBA

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Editor VBA can be used for wizards. It cannot be used in the Runtime. For detailed information about the Editor refer to chapter How to create projects in CE.


Examples

Manual -> Programming interfaces -> Macro list -> Examples

Here you can find a few examples for VBA

Other topics in this chapter

MouseEvents and ActiveX Control initialization

Display variable information

Read and write variable values

Read and write variables and implement online variables

Use dialog multiple times

Alarm – Events and ActiveX Control handling

Access to alarms

Set switch (working with process variables)


MouseEvents and ActiveX Control initialization

Manual -> Programming interfaces -> Macro list -> Examples -> MouseEvents and ActiveX Control initialization

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Option Explicit

Public Sub Init_ActiveX(obElem As Element)

'Initializing ActiveX...

thisProject.Init_MSChart_AX obElem

End Sub

Public Sub LeftClickUp_Sample1(obElem As Element)

'Initializing Userform...

frmSample1.InitForm obElem

'Show Userform

frmSample1.Show

End Sub

Public Sub LeftClickUp_Sample2(obElem As Element)

'Initializing Userform...

frmSample2.InitForm obElem

'Show Userform

frmSample2.Show

End Sub

Public Sub LeftClickUp_Sample3(obElem As Element)

'Initializing Userform...

frmSample3.InitForm obElem

'Show Userform

frmSample3.Show

End Sub

Public Sub LeftClickUp_Sample4(obElem As Element)

Dim NewForm As New frmSample4

'Initializing NEW Userform...

NewForm.InitForm obElem

'Show NEW Userform

NewForm.Show (0)

End Sub


Display variable information

Manual -> Programming interfaces -> Macro list -> Examples -> Display variable information

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Show variable name for clicked element:

Option Explicit

Dim obVar As Variable

'User defined Public Procedure for initializing Objects

Public Sub InitForm(obElem As Element)

'set the variable object like the linked variable of the element

Set obVar = obElem.ItemVariable(0)

'write variable name into the textbox

txtVarName.Text = obVar.Name

End Sub

Private Sub cmdExit_Click()

'close Userform

Unload Me

End Sub


Read and write variable values

Manual -> Programming interfaces -> Macro list -> Examples -> Read and write variable values

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Read value from variable and write it back:

Option Explicit

Dim obVar As Variable

'User defined Public Procedure for initializing Objects

Public Sub InitForm(obElem As Element)

'set the variable object like the linked variable of the element

Set obVar = obElem.ItemVariable(0)

'write variable name into the textbox

txtVarName.Text = obVar.Name

End Sub

Private Sub cmdExit_Click()

'close Userform

Unload Me

End Sub

Private Sub cmdRead_Click()

'read value from variable and write into textbox

txtValue.Text = obVar.Value

End Sub

Private Sub cmdWrite_Click()

'write text as value to variable

obVar.Value = txtValue.Text

'or changing text to value before writing...

'obVar.Value = Val(txtValue.Text)

End Sub


Read and write variables and implement online variables

Manual -> Programming interfaces -> Macro list -> Examples -> Read and write variables and implement online variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Read variable information, write values and implement online variables:

Option Explicit

Dim obVar As Variable

Dim WithEvents zOnlineVariable As OnlineVariable

'User defined Public Procedure for initializing Objects

Public Sub InitForm(obElem As Element)

'set the variable object like the linked variable of the element

Set obVar = obElem.ItemVariable(0)

'write variable name into the textbox

txtVarName.Text = obVar.Name

'create an OnlineVariable container

Set zOnlineVariable = thisProject.OnlineVariables.CreateOnlineVariables("OLV")

'add variables to the container (by name of the variable)

zOnlineVariable.Add obVar.Name

End Sub

Private Sub cmdExit_Click()

'close Userform

Unload Me

End Sub

Private Sub cmdRead_Click()

'read value from variable and write into textbox

txtValue.Text = obVar.Value

End Sub

Private Sub cmdWrite_Click()

'write text as value to variable

obVar.Value = txtValue.Text

'or changing text to value before writing...

'obVar.Value = Val(txtValue.Text)

End Sub

Private Sub cmdOLV_Start_Click()

'start the OnlineVariable - Define

'the VariableChange Event will be executed

zOnlineVariable.Define

End Sub

Private Sub cmdOLV_Stop_Click()

'stop the OnlineVariable - UnDefine

'the VariableChange Event will be stopped

zOnlineVariable.Undefine

End Sub

Private Sub zOnlineVariable_VariableChange(ByVal obVar As IVariable)

'write actual value into textbox

txtOLV.Text = obVar.Value

End Sub

Private Sub UserForm_Terminate()

'the VariableChange Event will be stopped if running

zOnlineVariable.Undefine

'delete OnlineVariable container

thisProject.OnlineVariables.DeleteOnlineVariables ("OLV")

End Sub


Use dialog multiple times

Manual -> Programming interfaces -> Macro list -> Examples -> Use dialog multiple times

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Userforms can be used multiple times.

Option Explicit

Dim obVar As Variable

Dim WithEvents zOnlineVariable As OnlineVariable

Dim strOLVName As String

Public Sub InitForm(obElem As Element)

'set the variable object like the linked variable of the element

Set obVar = obElem.ItemVariable(0)

'write variable name into the textbox

txtVarName.Text = obVar.Name

'create name for Online Container

strOLVName = "OLV_" & obElem.Name

'get existing online container

Set zOnlineVariable = thisProject.OnlineVariables.Item(strOLVName)

'check if online container exists

If zOnlineVariable Is Nothing Then

'create an OnlineVariable container

Set zOnlineVariable = thisProject.OnlineVariables.CreateOnlineVariables(strOLVName)

'add variables to the container (by name of the variable)

zOnlineVariable.Add obVar.Name

End If

End Sub

Private Sub cmdExit_Click()

Unload Me 'close Userform

End Sub

Private Sub cmdRead_Click()

'read value from variable and write into textbox

txtValue.Text = obVar.Value

End Sub

Private Sub cmdWrite_Click()

'write text as value to variable

obVar.Value = txtValue.Text

'or changing text to value before writing...

'obVar.Value = Val(txtValue.Text)

End Sub

Private Sub cmdOLV_Start_Click()

'the VariableChange Event will be executed

zOnlineVariable.Define

End Sub

Private Sub cmdOLV_Stop_Click()

'the VariableChange Event will be stopped

zOnlineVariable.Undefine

End Sub

Private Sub zOnlineVariable_VariableChange(ByVal obVar As IVariable)

'write actual value into textbox

txtOLV.Text = obVar.Value

End Sub

Private Sub UserForm_Terminate()

'the VariableChange Event will be stopped if running

zOnlineVariable.Undefine

'delete OnlineVariable container

thisProject.OnlineVariables.DeleteOnlineVariables (strOLVName)

End Sub


Alarm – Events and ActiveX Control handling

Manual -> Programming interfaces -> Macro list -> Examples -> Alarm – Events and ActiveX Control handling

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Option Explicit

Dim WithEvents obChart As MSChart

Dim WithEvents zOLV As OnlineVariable

Dim WithEvents zAlarm As Alarm

'procedure is executed on startup of the zenon Runtime

Private Sub Project_Active()

'init the alarm object for events

Set zAlarm = thisProject.Alarm

End Sub

'procedure is executed when an Alarm comes

Private Sub zAlarm_AlarmComes(ByVal obItem As IAlarmItem)

Dim strInfo As String

'write specific information about the alarm into a StringVariable

strInfo = obItem.Text & " - " & obItem.Name

thisProject.Variables.Item("Var_Comes").Value = strInfo

End Sub

'procedure is executed when an Alarm has gone

Private Sub zAlarm_AlarmGoes(ByVal obItem As IAlarmItem)

Dim strInfo As String

'write specific information about the alarm into a StringVariable

strInfo = obItem.Text & " - " & obItem.Name

thisProject.Variables.Item("Var_Goes").Value = strInfo

End Sub

'procedure is executed when an Alarm was acknowledged by a user

Private Sub zAlarm_AlarmAcknowledged(ByVal obItem As IAlarmItem)

Dim strInfo As String

'write specific information about the alarm into a StringVariable

strInfo = obItem.Text & " - " & obItem.Name

thisProject.Variables.Item("Var_Acknowledged").Value = strInfo

End Sub

'procedure is executed on terminating the zenon Runtime

Private Sub Project_Inactive()

'free the alarm object

Set zAlarm = Nothing

'delete OnlineVariable for Chart actualization...

thisProject.OnlineVariables.DeleteOnlineVariables "CHART"

End Sub

'procedure for MSChart ActiveX initialization...

Public Sub Init_MSChart_AX(YourAX As Element)

Set obChart = YourAX.AktiveX

obChart.RowCount = 3

obChart.ColumnCount = 1

Set zOLV = thisProject.OnlineVariables.Item("CHART")

'does existing OnlineVariable exist?

If zOLV Is Nothing Then

'if not, create it...

Set zOLV = thisProject.OnlineVariables.CreateOnlineVariables("CHART")

zOLV.Add "Internal_UINT_001"

zOLV.Add "Internal_UINT_002"

zOLV.Add "Internal_UINT_003"

End If

zOLV.Undefine 'if not stopped, refreshing not possible

'START watching variables...

zOLV.Define

End Sub

'event on Variable change - refresh chart...

Private Sub zOLV_VariableChange(ByVal obVar As IVariable)

'setting values to display in chart control

Select Case obVar.Name

Case "Internal_UINT_001"

obChart.Row = 1

obChart.RowLabel = "Var1"

obChart.Data = obVar.Value

Case "Internal_UINT_002"

obChart.Row = 2

obChart.RowLabel = "Var2"

obChart.Data = obVar.Value

Case "Internal_UINT_003"

obChart.Row = 3

obChart.RowLabel = "Var3"

obChart.Data = obVar.Value

End Select

End Sub

'event of the Chart AX...

Private Sub obChart_DblClick()

MsgBox "You have DoubleClicked the ActiveX!"

End Sub


Access to alarms

Manual -> Programming interfaces -> Macro list -> Examples -> Access to alarms

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Description:

In the form frmAlarm an alarm from the memory can be selected in a combobox. After the selection all data of the alalm are written to the textboxes below (group, class, variable, ...).

We use an event independent macro to display frmAlarm, because we do not link it to an element.

Sub Alarm ()
frmAlarm.Show
End Sub

'The macro is executed with the function Execute macro.

'On opening the form it is initialized and so the following procedure is executed. This procedure cares, that all alarms in the memory are written to the combobox in the form.

Private Sub UserForm _ Initialize ()

'fill combobox with all AlarmItems
Dim i As Integer
Dim obAlarmItems As AlarmItems
Dim obAlarm As Alarm

Set obAlarm = thisProject.Alarm
Set obAlarmItems = obAlarm.AlarmItems (*)

If obAlarmItems.Count = 0 Then
MsgBox (# Alarms = 0 )
Exit Sub
End If

For i = 0 To obAlarmItems.Count - 1
cmbAlarmItems.AddItem obAlarmItems.Item ( i ). Name
Next i

txtAktiv.Text = obAlarm.Aktiv
cmbAlarmItems.Text = cmbAlarmItems.List ( 0 )
End Sub

'Wenn nun ein Alarm aus der Combobox ausgewählt wird reagiert das Change - Ereigniss der Combobox.
Private Sub cmbAlarmItems _ Change ()

'put actual properties from AlarmItem in textboxes
Dim obAlarmItems As AlarmItems
Dim obAlar As Alarm

Set obAlarm = thisProject.Alarm
Set obAlarmItems = obAlarm.AlarmItems (*)
txtComputer.Text = obAlarmItems.Item ( cmbAlarmItems.ListIndex ).Computer
txtCountreactivated.Text = obAlarmItems.Item ( cmbAlarmItems.ListIndex ).Countreactivated
txtName.Text = obAlarmItems.Item ( cmbAlarmItems.ListIndex ). Name
txtProjectname.Text = obAlarmItems.Item ( cmbAlarmItems.ListIndex ).Projectname
txtStatus.Text = obAlarmItems.Item ( cmbAlarmItems.ListIndex ).Status
txtStatusreactivated.Text = obAlarmItems.Item ( cmbAlarmItems.ListIndex ).Statusreactivated
txtTagname.Text = obAlarmItems.Item ( cmbAlarmItems.ListIndex ).Tagname
txtTimecomes.Text = obAlarmItems.Item ( cmbAlarmItems.ListIndex ).Timecomes
txtTimegoes.Text = obAlarmItems.Item ( cmbAlarmItems.ListIndex ).Timegoes
txtTimequitted.Text = obAlarmItems.Item ( cmbAlarmItems.ListIndex ).Timequitted
txtTimereactivated.Text = obAlarmItems.Item ( cmbAlarmItems.ListIndex ).Timereactivated
txtUser.Text = obAlarmItems.Item ( cmbAlarmItems.ListIndex ).User
txtUsertext.Text = obAlarmItems.Item ( cmbAlarmItems.ListIndex ).Usertext
txtValue.Text = obAlarmItems.Item ( cmbAlarmItems.ListIndex ).Value
tbGroup.Text = obAlarmItems.Item ( cmbAlarmItems.ListIndex ).AlarmGroup
tbClass.Text = obAlarmItems.Item ( cmbAlarmItems.ListIndex ).AlarmClass
End Sub


Set switch (working with process variables)

Manual -> Programming interfaces -> Macro list -> Examples -> Set switch (working with process variables)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this example we draw a pump consisting of a circle and a triangle. Define the triangle as a symbol. On top draw a multibinary element and link it to three bit marker variables.

Additionally define, which color the triangle should get, if the values of the variables change.

First we combine the multibinary element with a macro, which opens a form frmSwitch.

In the form frmSwitch we will be able to change the values of the three bit marker variables.

info Information

Only one of the three variables may have the value 1. (i.e. if one variable is set to 1, the other two have to be set to 0)

To be able to use this macro several times in project with different variables, you only may link bit marker variables ti the multibinary element, which contail in their names, which status of the pump they control.

for example:
Variable_Auto
Variable_Hand
Variable_Revi

info Information

The suffixes _Auto, _Hand and _Revi are fixly defined in the source code of the example.

With this five characters suffix of the variable names it is defined, which variable is set to 1 and which is set to 0 on clicking a toggle button.

In the macro LeftClickUp_Switch a sub program FindVariable is called in the form frmSwitch, which gets the clicked element obElem.

Public Sub LeftClickUp_Schalter (obElem As Element)
frmSchalter.FindVariable obElem
position (pixel to points = (pixel * 0.75))
frmSchalter.Top = obElem.Bottom * 0.75
frmSchalter.Left = obElem.Left * 0.75
frmSchalter.Show
obElem.LeftClickUp
End Sub

Module global variable declaration:

Dim cmdLast As ToggleSchaltfläche
Dim strHand As String
Dim strAuto As String
Dim strRevi As String
In the sub program FindVariable all variables linked to the passed element are checked.

Depending on the suffix (_Auto, _Hand or _Revi) the variable names are assigned to the string variables declared above.

Additionally the status of the variables is determined and depending on the value (1 or 0) the according toggle button is pressed or not.

On opening the form frmSwitch the name of the currently pressed toggle button is written to a string variable. For the case, that the user decides to cancel his action, the original values are reset.

Public Sub FindVariable (obElem As Element)
Dim i As Integer
Dim obVariable As Variable

For i = 0 To obElem . CountVariable - 1
Select Case Right $( obElem . ItemVariable ( i ). Name , 5 )
Case _ Auto
strAuto = obElem . ItemVariable ( i ). Name

Case _ Hand
strHand = obElem . ItemVariable ( i ). Name

Case _ Revi
strRevi = obElem . ItemVariable ( i ). Name
End Select
Next i

Set obVariable = thisProject . Variables . Item ( strHand )
If obVariable . Value = 1 Then
tbHand . Value = True
Set cmdLast = tbHand
End If

Set obVariable = thisProject . Variables . Item ( strAuto )
If obVariable . Value = 1 Then
tbAuto . Value = True
Set cmdLast = tbAuto
End If

Set obVariable = thisProject . Variables . Item ( strRevi )
If obVariable . Value = 1 Then
tbRev . Value = True
Set cmdLast = tbRev
End If

If tbHand . Value = False And tbAuto . Value = False And tbRev . Value = False Then
tbOff . Value = True
Set cmdLast = tbOff
End If
End Sub

The self-created function VarExists only checks, whether the linked variables really exist. If this is not the case, an error message is displayed. Variable doesn't exist.

Function VarExists ()

Dim obVariable As Variable
Set obVariable = thisProject . Variables . Item (strHand)

If obVariable Is Nothing Then
MsgBox (Variable doesnt extist)
VarExitsts = False
Exit Function
End If

Set obVariable = thisProject . Variables . Item (strAuto)
If obVariable Is Nothing Then
MsgBox ( Variable doesnt extist )
VarExitsts = False
Exit Function
End If

Set obVariable = thisProject . Variables . Item (strRev)
If obVariable Is Nothing Then
MsgBox ( Variable doesnt extist )
VarExitsts = False
Exit Function
End If

VarExists = True
End Function

If the user clicks Cancel, the value change is undone and the original status is reset.

Private Sub cmdExit _ Click ()
cmdLast.Value = True
Unload Me
End Sub

Private Sub cmdOk _ Click ()
Unload Me
End Sub

If one toggle button is pressed, no other toggle button may be pressed.

Private Sub tbAuto_Change ()
If tbAuto . Value = False And tbHand.Value = False And tbRev . Value = False Then
tbOff . Value = True
End Sub

In the click event of every toggle button it is checked, whether it is pressed and whether the variable exists. If both conditions are true, the values are sent to the linked variables.


VSTA

Manual -> Programming interfaces -> VSTA

The functionality of zenon Runtime and the Editor can be independently expanded with .NET programming using Visual Studio Tools for Applications - VSTA.

VSTA is also available, with limited functionality for zenon Web Server and zenon Web Client.

info Information

If VBA macros are changed in the Editor,

  • the Runtime files are compiled and transferred to the Runtime
  • the Runtime is reloaded
  • VSTA elements are also reloaded even if no changes were made in VSTA

VSTA provides separate development environments for workspace and project. You can only use one of them at a time. At the start every other VSTA development environment which is open will be close.

To open the VSTA Editor for the workspace:

  1. press the short cut Alt+F10
  2. the code for the workspace and all loaded projects is displayed

To open the VSTA Editor for the currently loaded project:

  1. navigate to the Programming interfaces node
  2. right click on VSTA
  3. select Open VSTA Editor... in the context menu

the Editor is opened for the currently loaded project

Other topics in this chapter

Basics

Creating a VSTA project

Examples


Basics

Manual -> Programming interfaces -> VSTA -> Basics

VSTA is a Microsoft development environment that is based on .NET technology. It is necessary to have basic knowledge of object-orientated programming, .NET and C#/Visual Basic.NET to understand it.

Other topics in this chapter

Setting up the VSTA environment

Access to the object model in zenon

Functions in zenon

Debugging a VSTA add-in

New events in VSTA

Creating a backup of VSTA projects


Setting up the VSTA environment

Manual -> Programming interfaces -> VSTA -> Basics -> Setting up the VSTA environment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Support for VSTA is already activated as standard in zenon. When deactivating VBA support, the VSTA environment is also not available any more.

The VSTA environment can be manually activated or deactivated with the following entry in C:\ProgramData\COPA-DATA\System\zenon6.ini

Activate VSTA | Deactivate VSTA
[VSTA] ON=1 | [VSTA] ON=0

Support for VBA is activated or deactivated as follows:

Activate VBA | Deactivate VBA
[VBA] EIN=1 | [VBA] EIN=0

After this, the development environment for VSTA in zenon is available.

info Information

VSTA allows the development of projects in the programming languages C# and Visual Basic.NET. C# is envisaged as the standard language for VSTA projects in the Editor. The language can be changed to Visual Basic.NET with the following entry:

[VSTA]

CSHARP=0


Access to the object model in zenon

Manual -> Programming interfaces -> VSTA -> Basics -> Access to the object model in zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon that is also used in VBA can be accessed in VSTA. The object model offers the same functionality in both development environments.

attention Attention

Some changes to the object model have been made due to limitations in naming VSTA objects. You can find these in the table below

Old property | New property
IDriver.Name | IDriver.Identification
IDriver.Driver | IDriver.Name
Old event | New event
IApplication.Close | IApplication.OnClose
IZenWorkspace.Startup | IZenWorkspace.OnStartup
IZenWorkspace.Exit | IZenWorkspace.OnExit

Access is VSTA is enabled via the this object and the replaces the MyWorkspace object in VBA. The following methods and objects are identical. In the following method, a template with the name "TemplateName" is created in zenon.

public void Macro1()

{

this.ActiveDocument.Templates().Create("TemplateName", true);

}

info Information

In contrast to VBA, capitalization and brackets after function names are important in VSTA.

To access the methods in zenon, the project must be saved and compiled using via the following steps:

  1. Click on File -> Save MyWorkspace.cs to save the project.
  2. Click on File -> Build WorkspaceAddin to compile the project.

After this, the method is available as a macro in the VBA macro toolbar in the zenon editor. If the macro assignment dialog does not list all macros from MyWorkspace, the function 'Reload list of VBA macros' has to be executed from the toolbar.

info Information

VSTA macros with parameters, e.g. Public void MacroWithParam(string mString), are not supported and also not made available in the macro tool bar.


Functions in zenon

Manual -> Programming interfaces -> VSTA -> Basics -> Functions in zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For VSTA, new functions were created in zenon. These are in the "VSTA" function group.

At the same time as existing VBA functions, similar functions were implemented for VSTA:

Function name | Description
Open VSTA editor | opens the VSTA editor in Runtime
Execute VSTA macro | A VSTA macro can be selected in the editor, which is started when executing the function in Runtime. Note: VSTA macros with parameters, e.g. Public void MacroWithParam(string mString), are not supported. They are neither offered at the engineering in the Editor nor at the start of the function in the Runtime.
Show VSTA macro dialog | A dialog is shown in Runtime, in which existing VSTA macros are shown and can be selected and executed

Other topics in this chapter

Execute VSTA macro


Execute VSTA macro

Manual -> Programming interfaces -> VSTA -> Basics -> Functions in zenon -> Execute VSTA macro

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dialog for configuration of the Execute VSTA macro function.

Parameters | Description
Existing macros |
List of VSTA macros | Lists all existing VSTA macro. Selection of a macro from the list by clicking on it. Note: A double click executes the selected macro.
None selected | Discards the selection and closes the dialog.
OK | Executes selected macro and closes the dialog.
Cancel | Discards the selection and closes the dialog.
Help | Opens online help.


Debugging a VSTA add-in

Manual -> Programming interfaces -> VSTA -> Basics -> Debugging a VSTA add-in

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

It is possible to debug add-ins you have written yourself with the VSTA Editor. In doing so, note that project add ins can only be debugged in zenon Runtime and workspace add-ins can only be debugged in zenon Editor.

A debug session is started via the Debug - Start Debugging menu. You can place breakpoints in the same way as the VBA editor, by left clicking in the gray breakpoint toolbar at the left margin next to the respective cell.

info Information

When debugging Runtime add-ins consider:

The Runtime files changed in zenon must be newly created before debugging.


New events in VSTA

Manual -> Programming interfaces -> VSTA -> Basics -> New events in VSTA

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Because an add-in is terminated when compiling amended code, starting a debug session or ending a debug session, new events were implemented in VSTA. These enable, for example, an object reference to be evaluated and approved and existing data to be saved.

Two events exist for each termination. The first event is started shortly before termination, the second after the start of a new add-in session.

Event | Description
OnPreVSTADebugStart | Is triggered shortly before a debug session is started. When starting, an active add-in is removed, references must be approved and existing data must be saved if necessary.
OnVSTADebugStart | Is triggered shortly after a debug session is started.
OnPreVSTADebugStop | Is triggered shortly before a debug session is stopped. When stopping a debug session, an active add-in is removed, references must be approved and existing data must be saved if necessary.
OnVSTADebugStopped | Is triggered shortly after a debug session is stopped.
OnPreVSTAUpdate | Is triggered before the add-in is removed if a new version of the add-in was successfully created.
OnPostVSTAUpdate | Is triggered when a new version of the add-in is loaded.


Creating a backup of VSTA projects

Manual -> Programming interfaces -> VSTA -> Basics -> Creating a backup of VSTA projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

VSTA projects in Runtime are automatically zipped when creating the Runtime file and included in workspace saves.

VSTA projects in the editor must be saved manually however.
You can find the VSTA Editor projects in the folder C:\ProgramData\COPA-DATA\*version*\VSTAWorkspace\.


Creating a VSTA project

Manual -> Programming interfaces -> VSTA -> Creating a VSTA project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Similar to VBA, there is the possibility in VSTA to create projects for both the editor and Runtime. In principle, projects in the editor are implemented in the C# programming language. For Runtime and Editor, both C# and Visual Basic.NET are available.

info Information

Only one project can be displayed at a time in the VSTA editor. In addition, only one instance of the VSTA editors can be active. When starting the VSTA editor, any instance that may already be running is closed.

Other topics in this chapter

VSTA projects in the editor

VSTA projects in Runtime

Developing wizards in VSTA


VSTA projects in the editor

Manual -> Programming interfaces -> VSTA -> Creating a VSTA project -> VSTA projects in the editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When creating a project for the zenon editor, a VSTA add-in for the workspace is loaded. To edit the add-in, the VSTA editor must be opened via File - Open VSTA editor.... The user interface of the VSTA editor is identical to Microsoft's Visual Studio development environment.

info Information

VSTA editor help can be accessed via the Help / Contents menu. This help gives an overview of the editor's functions, the features of the .NET framework and programming in Visual Basic.NET and C#.

The VSTA add-in basically consists of the MyWorkspace class. This class can now be expanded with your own methods. The class accommodates the following two methods by default:

Function | Description
MyWorkspace_Startup | Is executed automatically when starting zenon, after a build has been created and when a debug session is started.
MyWorkspace_Shutdown | Is executed automatically when starting zenon, after a build has been created and when a debug session is started.

attention Attention

The method names may only start with Macro (for example Macro1, MacroVSTA) may not contain parameters and must be defined as Public . In addition, the class names and other methods and events created by VSTA may not be changed.

To access the methods in zenon, the project must be saved and compiled using via the following steps:

  1. Click on File -> Save MyWorkspace.cs to save the project.
  2. Click on File -> Build WorkspaceAddin to compile the project.

After this, the method is available as a macro in the VBA macro toolbar in the zenon editor. If the macro assignment dialog does not list all macros from MyWorkspace, the function 'Reload list of VBA macros' has to be executed from the toolbar.


VSTA projects in Runtime

Manual -> Programming interfaces -> VSTA -> Creating a VSTA project -> VSTA projects in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a VSTA project for Runtime, the VSTA environment must be started. Proceed in the following way:

  1. Open the program interfaces item in the project manager.
  2. Open the VSTA context menu.
  3. Click on Open VSTA editor...

Select the desired language in the selection dialog that now appears. After this, a project is created in the desired programming language.

info Information

The desired language cannot be changed later; this dialog is therefore only shown the first time.

In this project, a class named ThisProject is created by zenon, which accommodates the following two methods:

Function | Description
ThisProject_Startup | Is executed automatically when Runtime is started
ThisProject_Shutdown | Is executed automatically when Runtime is ended

The class can now be expanded with your own methods.

attention Attention

The method names may only start with Macro (for example Macro1, MacroVSTA) may not contain parameters and must be defined as Public . In addition, the class names and other methods and events created by VSTA may not be changed.

There is access to all Runtime functionalities via the zenon object model. Editor-specific functions cannot be used, as in VBA.

zenon Runtime is automatically started when the debugger is started. Further information can be found in the chapter on debugging a VSTA add-in.

info Information

VSTA editor help can be accessed via the Help / Contents menu. This help gives an overview of the editor's functions, the features of the .NET framework and programming in Visual Basic.NET and C#.


Developing wizards in VSTA

Manual -> Programming interfaces -> VSTA -> Creating a VSTA project -> Developing wizards in VSTA

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The VSTA environment, like VBA, offers the possibility to develop your own wizards.

To be able to access a form in the zenon object model, a reference to this must be copied to the form. To do this, a method is created in the MyWorkspace class. In the following example example, a form is instanced with the name wizard and the method ZenonInstance with a reference to the zenon object model is called as a parameter. The wizard form is shown by selecting ShowDialog().

public void Macro1()

{

Form1 Wizard = new Form1();

Wizard.ZenonInstance(this.Application);

Wizard.ShowDialog();

}

A member variable must be created in the form code, which recognizes the zenon object model.

public zenOn.IApplication m_Zenon=null;

Lastly, the ZenonInstance method is created. This methods takes the object model reference and places it in the m_Zenon object.

public void ZenonInstance(zenOn.IApplication app)

{

m_Zenon = app;

}

Now, your own classes and methods can be developed in the form, which make use of the object model. All methods, objects and attributes are available via the m_Zenon object.


Examples

Manual -> Programming interfaces -> VSTA -> Examples

Here you find some examples of VSTA being used, both in Runtime and in the editor.

Other topics in this chapter

Creating variables in the zenon editor

Writing project information in the zenon output window

Reading in of variables in zenon via regular expressions


Creating variables in the zenon editor

Manual -> Programming interfaces -> VSTA -> Examples -> Creating variables in the zenon editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this example, a text file is opened and the contents of this are used to create variables in the zenon editor. The text file contains any desired number of lines. Each line includes the name and data type of a variable; these are separated by a comma (example: Variable1,BOOL).

The Macro1 method first looks for the internal driver in the zenon editor. After this, the user is shown a file selection dialog in which he must select the text file. The method then reads the text file and creates the variables. The GetDataType method is then required to determine and assign the attendant data type when creating the variables.

C# code

using System;

using System.Windows.Forms;

using System.IO;

using zenOn;

namespace WorkspaceAddin

{

[System.AddIn.AddIn("MyWorkspace", Version = "1.0", Publisher = "", Description = "")]

public partial class MyWorkspace

{

private void MyWorkspace_Startup(object sender, EventArgs e)

{

}

private void MyWorkspace_Shutdown(object sender, EventArgs e)

{

}

public IVarType GetDataType(string vType)

{

//gets the corresponding vartypes for bool, int, real and strings

IVarType retType;

switch (vType)

{

case "BOOL":

retType = this.ActiveDocument.VarTypes().Item("BOOL");

break;

case "INT":

retType = this.ActiveDocument.VarTypes().Item("INT");

break;

case "REAL":

retType = this.ActiveDocument.VarTypes().Item("REAL");

break;

case "STRING":

retType = this.ActiveDocument.VarTypes().Item("STRING");

break;

default:

retType = this.ActiveDocument.VarTypes().Item("INT");

break;

}

return retType;

}

//Reads a defined text file and creates corresponding variables on the zenon internal driver

public void MacroCreateVariablesFromFile()

{

//create objects that will take the internal driver and the variable type

IDriver zenonInternDriver = null;

//search for the Internal driver and throw exception if no driver was found

try

{

for (int driverCount = 0; driverCount < this.ActiveDocument.Drivers().Count; driverCount++)

{

if (this.ActiveDocument.Drivers().Item(driverCount).Name == "Intern")

{

zenonInternDriver = this.ActiveDocument.Drivers().Item(driverCount);

break;

}

}

}

catch (Exception driverEx)

{

MessageBox.Show("Unable to find zenon 'Intern' driver. Error: " + driverEx.Message);

throw;

}

this.ActiveDocument.Variables().DoAutoSave(false);

try

{

OpenFileDialog varFileSelect = new OpenFileDialog();

String[] varLine = new String[2];

//show file dialog

if (varFileSelect.ShowDialog() == DialogResult.OK)

{

string line = string.Empty;

//open new stream reader with selected file

StreamReader importReader = new StreamReader(varFileSelect.FileName, System.Text.Encoding.Default);

//read in line by line, split the lines when a ',' occurs and create variables

while ((line = importReader.ReadLine()) != null)

{

varLine = line.Split(new Char[] { ',' });

this.ActiveDocument.Variables().CreateVar(varLine[0], zenonInternDriver, tpKanaltypes.tpSystemVariable, GetDataType(varLine[1]));

}

importReader.Close();

}

}

catch (Exception fileEx)

{

MessageBox.Show("An error occurred while opening the file: " + fileEx.Message);

throw;

}

this.ActiveDocument.Variables().DoAutoSave(true);

}

#region VSTA generated code

private void InternalStartup()

{

this.Startup += new System.EventHandler(MyWorkspace_Startup);

this.Shutdown += new System.EventHandler(MyWorkspace_Shutdown);

}

#endregion

}

}


Writing project information in the zenon output window

Manual -> Programming interfaces -> VSTA -> Examples -> Writing project information in the zenon output window

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this example, it is demonstrated how the output window of the zenon editors can be accessed using VSTA. The method named Macro1 reads out the process screens created in the project for this, identifies the respective template and identifies all drivers available as well as their labels.

C# code

using System;

namespace WorkspaceAddin

{

[System.AddIn.AddIn("MyWorkspace", Version = "1.0", Publisher = "", Description = "")]

public partial class MyWorkspace

{

private void MyWorkspace_Startup(object sender, EventArgs e)

{

}

private void MyWorkspace_Shutdown(object sender, EventArgs e)

{

}

public void MacroPrintDebugInformation()

{

string picName = string.Empty;

string corTemp = string.Empty;

string driverName = string.Empty;

string driverDescription = string.Empty;

//print start string into output window

this.Application.DebugPrint(" --------------START--------------", zenOn.tpDebugPrintStyle.tpMsg);

//go through all pictures and print name and used template into output window

for (int i = 0; i < this.ActiveDocument.DynPictures().Count; i++)

{

picName = this.ActiveDocument.DynPictures().Item(i).Name;

corTemp = this.ActiveDocument.DynPictures().Item(i).get_DynProperties("Template").ToString();

this.Application.DebugPrint(" Picture '" + picName + "' uses Template '" + corTemp + "'", zenOn.tpDebugPrintStyle.tpMsg);

}

//print seperator string into output window

this.Application.DebugPrint(" ------------------------------", zenOn.tpDebugPrintStyle.tpMsg);

//go through all drivers and print name and description into output window

for (int i = 0; i < this.ActiveDocument.Drivers().Count; i++)

{

driverName = this.ActiveDocument.Drivers().Item(i).Name;

driverDescription = this.ActiveDocument.Drivers().Item(i).Identification;

this.Application.DebugPrint(" Driver '" + driverName + "' has description '" + driverDescription + "'", zenOn.tpDebugPrintStyle.tpMsg);

}

//print end string into output window

this.Application.DebugPrint(" ---------------END---------------", zenOn.tpDebugPrintStyle.tpMsg);

}

#region VSTA generated code

private void InternalStartup()

{

this.Startup += new System.EventHandler(MyWorkspace_Startup);

this.Shutdown += new System.EventHandler(MyWorkspace_Shutdown);

}

#endregion

}

}


Reading in of variables in zenon via regular expressions

Manual -> Programming interfaces -> VSTA -> Examples -> Reading in of variables in zenon via regular expressions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the following example, zenon variables are read out in a Runtime project and saved in a local text file.

Using regular expressions, variables are only read if their names start with 3 figures and a subsequent underscore (for example "001_var" or "234_xyz"). The user is then requested to select a folder. A text file with a time-dependent file name is created in this folder. In this file, name, labeling and current value of all applicable variables is saved separately with a semi colon.

info Information

It is possible that manual references may have to be added to execute the example in zenon Runtime. To do this, open the context menu in project explorer and click on Add Reference... The references required in this example are as follows:

  • Microsoft.VisualStudio.Tools.Applications.Runtime.v9.0
  • System
  • System.AddIn
  • System.Data
  • System.Windows.Forms
  • System.Xml
  • zenonVSTAProxy6500

C# code

using System;

using System.Text.RegularExpressions;

using System.IO;

using System.Windows.Forms;

namespace ProjectAddin

{

[System.AddIn.AddIn("ThisProject", Version = "1.0", Publisher = "", Description = "")]

public partial class ThisProject

{

private void ThisProject_Startup(object sender, EventArgs e)

{

}

private void ThisProject_Shutdown(object sender, EventArgs e)

{

}

public void MacroGetFilteredVariables()

{

string filename = string.Empty;

string name = string.Empty;

string description = string.Empty;

string value = string.Empty;

//define regular expression pattern

Regex match = new Regex("^([0-9]){3}[_]");

try

{

filename = FolderSelection("Select place to store the variable information");

//create stream writer to the .txt file

StreamWriter matchedVariables = new StreamWriter(filename, true);

//run through all variables in zenon

for (int i = 0; i < this.Variables().Count; i++)

{

//if name of the variable matches the pattern, get name, tag name and current value

if (match.IsMatch(this.Variables().Item(i).Name))

{

name = this.Variables().Item(i).Name;

description = this.Variables().Item(i).Tagname;

value = this.Variables().Item(i).get_Value(0).ToString();

//write information to the .txt file

matchedVariables.WriteLine(name + ";" + description + ";" + value);

}

}

//close stream

matchedVariables.Close();

}

catch (Exception ex)

{

MessageBox.Show("An error occured -> " + ex.Message);

throw;

}

}

private string FolderSelection(String caption)

{

string selectedPath = string.Empty;

//create a dialog for selecting the output folder

FolderBrowserDialog folderSelect = new FolderBrowserDialog();

folderSelect.Description = caption;

try

{

if (folderSelect.ShowDialog() == DialogResult.OK)

{

//if selection was valid, get the current date, put it to file date format

//then create a txt file with the name "zenonVar" and the corresponding date

DateTime currentTime = DateTime.Now;

selectedPath = folderSelect.SelectedPath + "\\zenonVar" + currentTime.ToFileTime() + ".txt";

}

}

catch (Exception ex)

{

MessageBox.Show("An error occurred: " + ex.Message);

throw;

}

return selectedPath;

}

#region VSTA generated code

private void InternalStartup()

{

this.Startup += new System.EventHandler(ThisProject_Startup);

this.Shutdown += new System.EventHandler(ThisProject_Shutdown);

}

#endregion

}

}


Objectmodel

Manual -> Programming interfaces -> Objectmodel

In this area you can find the zenon object model. This model is true for VBA, VSTA, PCE and the external COM interface.

info Information

The zenon Object Model help is only available in the online help (not in the PDF manual) and only in English.

Other topics in this chapter

Constants

Alarm

AlarmItem

AlarmItems

ALCEdge

ALCEngne

ALCGraphAlias

ALCGraphElem

ALCNode

Application

Archive

ArchiveED

ArchiveFilter

ArchiveFilters

ArchiveFilterVariable

ArchiveFilterVariables

Archives

ArchivesED

ArchiveValue

ArchiveValues

ArchiveVarED

ArchiveVariable

ArchiveVariables

ArvTemplate

ArvTemplates

BatchControlRecipe

BatchControlRecipePhaseEditedEventData

BatchControlRecipes

BatchControlStrategy

BatchCRSelectionChangedEventData

BatchManager

BatchMasterRecipe

BatchMasterRecipes

BatchMRSelectionChangedEventData

BatchOperation

BatchPhase

BatchPhaseChanges

BatchPhaseCommunicationErrorEventData

BatchPhaseEscapeEventData

BatchPhaseExecutionErrorEventData

BatchPhaseModeChangedEventData

BatchPhasePlcErrorEventData

BatchPhaseProgressEventData

BatchPhaseRuntimeEventData

BatchPhaseStateChangedEventData

BatchRecipeId

BatchRecipeModeChangedEventData

BatchRecipeStateChangedEventData

BatchTag

BatchTags

BatchTagValue

Cel

CelItem

CelItems

ColorPalettes

ComplexItem

Driver

Drivers

DynPicture

DynPictureInstances

DynPictures

EdLimit

Element

Elements

FileManager

FileManagerFileItem

FileManagerFolder

FontItem

FontList

FontLists

Interlocking

Interlockings

LanguageTable

Limit

Limits

MdiElement

MdiElements

MDITemplate

MDITemplates

MessageControl

MessageControlMessage

OnlineVariable

OnlineVariables

Passwords

PfsCalendar

PfsEngine

PfsEvent

PfsEvents

PfsGroup

PfsGroups

PfsHoliday

PfsHolidays

PfsModellBreak

PfsModellBreaks

PfsModellShift

PfsModellShifts

PfsSchedule

PfsScheduleDay

PfsScheduleDays

PfsScheduleLink

PfsScheduleLinks

PfsSchedules

PfsScheduleTime

PfsScheduleTimes

PfsScheduleValue

PfsScheduleValues

PfsSwitchingPoint

PfsSwitchingPointFilter

PfsTimeModell

PfsTimeModells

PictureFilter

Project

Projects

PropParam

Recipe

Recipes

RecipeValue

Rema

Remas

RemoteTransport

RemoteTransportCustom

RGMRecipe

RGMRecipeGroup

RGMRecipeGroups

RGMRecipeValue

RGMRecipeVar

RtFunction

RtFunctions

SapFunction

SapFunctions

SapParameter

SapParameters

SapRow

SapRows

SapTable

SapTables

Script

Scripts

State

SymbolElements

Symbols

SystemModel

SystemModelGroup

SystemModelManager

Task

Tasks

Template

Templates

TimeFunction

TimeFunctions

Units

User

UserGroup

VarAssignment

VarAssignments

Variable

Variables

VariableValue

VarType

VarTypes

ZenMenu

ZenMenuItem

ZenMenus

ZenWorkspace


Constants

Manual -> Programming interfaces -> Objectmodel -> Constants

List of constants

Other topics in this chapter

tpAdrMode

tpALCGroundFaultMode

tpALCGroundFaultType

tpALCShortFaultType

tpALCType

tpArvVarCal

tpBatchBoolValue

tpBatchCRState

tpBatchCRStateFilter

tpBatchExecutionMode

tpBatchExecutionState

tpBatchMRState

tpBatchPhaseCommunicationErrorState

tpBatchPhaseEscapeState

tpBatchPhaseExecutionError

tpBatchPhasePlcErrorState

tpBatchPhaseRuntimeEvent

tpBatchPhaseState

tpBatchTagDataType

tpBatchTagType

tpBuildMethod

tpCRCreateResult

tpDatatypes

tpDebugPrintStyle

tpDriverMode

tpDriverStatus

tpDynPicturesTypes

tpElementTypes

tpFunctionTypes

tpGlobalMultiTouchMode

tpHardcopyOutput

tpKanaltypes

tpLockResult

tpLoginResult

tpModulePaths

tpMsgCtrlCelDetail

tpNetSendType

tpPfsData

tpPfsDayLink

tpPfsDefaultDays

tpPfsEventTypes

tpPfsLinkTypes

tpPfsTimeTypes

tpProjectNetTypes

tpRecipeRenameResult

tpRema

tpRemoteTransportType

tpRGMRecipeImport

tpRTCustomAction

tpRunStates

tpSapActivity

tpSapError

tpScreenRawEventRouting

tpStateBit

tpTaskStatus

tpTaskTyp

tpZenMenus

tpZenPathType


tpAdrMode

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpAdrMode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpAdrMode constants.

Name | Value | Description
tpAdrPacked | 1 | Packed
tpAdrAccType | 2 | Acc Type
tpAdrManual | 3 | Manual


tpALCGroundFaultMode

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpALCGroundFaultMode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpALCGroundFaultMode constants.

Name | Value | Description
tpALCGroundFaultModePart | 0 | Part
tpALCGroundFaultModeFull | 1 | Full


tpALCGroundFaultType

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpALCGroundFaultType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpALCGroundFaultType constants.

Name | Value | Description
tpALCGroundFaultTypeNone | 0 | None
tpALCGroundFaultTypeTransAdv | 1 | Adv
tpALCGroundFaultTypeTransLag | 2 | Lag
tpALCGroundFaultTypePermAdv | 3 | Perm Adv
tpALCGroundFaultTypePermLag | 4 | Perm Lag


tpALCShortFaultType

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpALCShortFaultType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpALCShortFaultType constants.

Name | Value | Description
tpALCShortFaultTypeNone | 0 | None
tpALCShortFaultTypePermAdv | 1 | Perm Adv
tpALCShortFaultTypePermLag | 2 | Perm Lag


tpALCType

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpALCType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpALCType constants.

Name | Value | Description
tpALCTypeNone | 0 | None
tpALCTypeSource | 1 | Source
tpALCTypeSwitch | 2 | Switch
tpALCTypeSink | 3 | Sink
tpALCTypeTrafo | 4 | Trafo
tpALCTypeLink | 5 | Link


tpArvVarCal

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpArvVarCal

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpArvVarCal constants.

Name | Value | Description
tpCalc_All | 0 | All calculations
tpCalc_Sum | 1 | Sum
tpCalc_Mean | 2 | Mean
tpCalc_Min | 3 | Min
tpCalc_Max | 4 | Max


tpBatchBoolValue

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpBatchBoolValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpBatchBoolValue constants.

Name | Value | Description
tpBatchBoolFalse | 0 | Set to false
tpBatchBoolTrue | 1 | Set to true
tpBatchBoolToggle | 2 | Toggle value


tpBatchCRState

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpBatchCRState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpBatchCRState constants.

Name | Value | Description
tpCRStateCreating | 1 | Creating
tpCRStatePrepared | 2 | Prepared
tpCRStateExecuting | 3 | Executing
tpCRStateExecuted | 4 | Executed,
tpCRStateTerminated | 5 | Terminated
tpCRStateOutdated | 7 | Outdated


tpBatchCRStateFilter

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpBatchCRStateFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpBatchCRStateFilter constants.

Name | Value | Description
tpCRStateFilterPrepared | 1 | Prepared
tpCRStateFilterExecuting | 2 | Executing
tpCRStateFilterFinished | 4 | Executed or Terminated
tpCRStateFilterOutdated | 8 | Outdated
tpCRStateFilterAll | 65535 | All


tpBatchExecutionMode

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpBatchExecutionMode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpBatchExecutionMode constants.

Name | Value | Description
tpExecutionModeAutomatic | 1 | Automatisch
tpExecutionModeSemiAutomatic | 2 | Halbautomatisch
tpExecutionModeManual | 3 | Manuell


tpBatchExecutionState

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpBatchExecutionState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpBatchExecutionState constants.

Name | Value | Description
tpExecutionStateIdle | 0 | resetted or aborted or never started
tpExecutionStateRunning | 1 | running the sequence
tpExecutionStateComplete | 2 | sequence is finished
tpExecutionStateStopping | 3 | processing stop
tpExecutionStateStopped | 4 | stopped
tpExecutionStatePausing | 5 | processing pause
tpExecutionStatePaused | 6 | paused
tpExecutionStateHolding | 7 | processing hold
tpExecutionStateHeld | 8 | held
tpExecutionStateAborting | 9 | abort in progress
tpExecutionStateAborted | 10 | aborted
tpExecutionStateRestarting | 11 | restart in progress


tpBatchMRState

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpBatchMRState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpBatchMRState constants.

Name | Value | Description
tpMRStateCreating | 0 | Erzeugung
tpMRStateEditing | 1 | Editiermodus
tpMRStateApproved | 2 | Freigegeben
tpMRStateTesting | 3 | Testmodus
tpMRStateExecutingTest | 4 | Ausf?hrungsmodus
tpMRStateTerminated | 5 | Abgeschlossen
tpMRStateOutdated | 8 | Veraltet


tpBatchPhaseCommunicationErrorState

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpBatchPhaseCommunicationErrorState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpBatchPhaseCommunicationErrorState constants.

Name | Value | Description
tpCommunicationErrorPending | 0 | The communication error condition of the phase is true - The communication is interrupted
tpCommunicationErrorFixed | 1 | The communication error condition of the phase switched back from true to false, but has not yet been acknowledged
tpCommunicationErrorAcknowledged | 2 | A no longer active communication error has been acknowledged


tpBatchPhaseEscapeState

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpBatchPhaseEscapeState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpBatchPhaseEscapeState constants.

Name | Value | Description
tpEscapeStarted | 0 | The escape process for the phase has been started
tpEscapeCompleted | 1 | The escape process for the phase has been finished


tpBatchPhaseExecutionError

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpBatchPhaseExecutionError

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpBatchPhaseExecutionError constants.

Name | Value | Description
tpExecutionErrorAllocationTimeout | 0 | Unit allocation was not possible within the timeout
tpExecutionErrorMultipleExecution | 1 | The same phase was started twice
tpExecutionErrorInterlockingTimeout | 2 | The interlocking condition could not be passed within the timeout
tpExecutionErrorWriteCommandTagsTimeout | 3 | Writing the commantags was not possible within the timeout
tpExecutionErrorDoneTimeout | 4 | The done condition could not be passsed within the timeout
tpExecutionErrorFollowingConditionTimeout | 5 | The phase was not deactivated within the timeout
tpExecutionErrorVariableInterruption | 6 | A needed variable was interrupted


tpBatchPhasePlcErrorState

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpBatchPhasePlcErrorState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpBatchPhasePlcErrorState constants.

Name | Value | Description
tpPlcErrorPending | 0 | The PLC error condition is true - The PLC reported an error
tpPlcErrorFixed | 1 | The PlC error condition switched back from true to false - there is no longer an error in the PLC
tpPlcErrorFixedByDeactivation | 2 | The Phase was deactivated while the PLC Error was still active


tpBatchPhaseRuntimeEvent

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpBatchPhaseRuntimeEvent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpBatchPhaseRuntimeEvent constants.

Name | Value | Description
tpRuntimeShutdown | 0 | A runtime shutdown was triggert while the phase was active
tpRuntimeRestart | 1 | The runtime was started and the execution of this phase was continued, because it was active before shutown


tpBatchPhaseState

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpBatchPhaseState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpBatchPhaseState constants.

Name | Value | Description
tpPhaseStateActivated | 0 | Phase was activated
tpPhaseStateUnitAllocationFailed | 1 | First unit allocation failed
tpPhaseStateStarted | 2 | Phase was started - active for the PLC
tpPhaseStateInterlockingBlocked | 3 | Interlocking condition was blocked the first time
tpPhaseStateInterlockingCompleted | 4 | Interlocking condition was passed
tpPhaseStateWritingCommandTagsCompleted | 5 | Writing Command Tags was finished
tpPhaseStateDoneCompleted | 6 | Done condition was passed
tpPhaseStateDeactivated | 7 | Phase was deactivated


tpBatchTagDataType

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpBatchTagDataType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpBatchTagDataType constants.

Name | Value | Description
tpTagDataTypeBool | 0 | Bool tag
tpTagDataTypeString | 1 | String tag
tpTagDataTypeNumeric | 2 | Numerical tag
tpTagDataTypeDuration | 3 | Duration tag


tpBatchTagType

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpBatchTagType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpBatchTagType constants.

Name | Value | Description
tpTagTypeReturn | 0 | Return tag
tpTagTypeInitial | 1 | Inital tag
tpTagTypeValue | 2 | Value Tag


tpBuildMethod

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpBuildMethod

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpBuildMethod constants.

Name | Value | Description
tpAll | 0 | All
tpIncremental | 1 | Incremental


tpCRCreateResult

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpCRCreateResult

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpCRCreateResult constants.

Name | Value | Description
tpCRCreateSuccess | 0 | The recipe was created successfully.
tpCRCreateOtherError | 1 | A general error has occured.
tpCRCreateWrongLicense | 2 | You do not have the required license for the operation.
tpCRCreateRecipeNotFound | 3 | The master recipe was not found.
tpCRCreateRecipeWrongState | 4 | The master recipe is in the wrong state. It needs to be "approved" to allow the creation of control recipes.
tpCRCreateRecipeInvalid | 5 | The master recipe is invalid.
tpCRCreateInvalidJobIdVariable | 6 | The job id variable is invalid.
tpCRCreateInvalidJobId | 7 | The job id variable has an invalid value.


tpDatatypes

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpDatatypes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpDatatypes constants.

Name | Value | Description
tptypeBIT | 8 | BOOL
tptypeINT_8 | 10 | SINT
tptypeUINT_8 | 9 | USINT
tptypeINT_16 | 1 | INT
tptypeUINT_16 | 2 | UINT
tptypeINT_32 | 3 | DINT
tptypeUINT_32 | 4 | UDINT
tptypeINT_64 | 26 | LINT
tptypeUINT_64 | 27 | ULINT
tptypeFLOAT_REAL | 5 | REAL
tptypeSTRING | 12 | STRING


tpDebugPrintStyle

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpDebugPrintStyle

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpDebugPrintStyle constants.

Name | Value | Description
tpNrm | 16777216 | Show message (black)
tpWarn | 33554432 | Display warning (orange)
tpErr | 67108864 | Show errors (red)
tpMsg | 134217728 | Default style (blue)


tpDriverMode

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpDriverMode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpDriverMode constants.

Name | Value | Description
tpSimul | 0 | Simulation
tpHardware | 1 | Hardware


tpDriverStatus

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpDriverStatus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpDriverStatus constants.

Name | Value | Description
tpStop | 0 | Stop
tpStart | 1 | Start


tpDynPicturesTypes

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpDynPicturesTypes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpDynPicturesTypes constants.

Name | Value | Description
tpStandard | 0 | Standard
tpListWindow | 1 | Nodepad
tpAML | 2 | Alarm message list
tpArchEdit | 3 | Archive revision
tpCEL | 4 | Chronologic event list
tpETM | 5 | Extended trend
tpVideo | 6 | Video
tpReports | 7 | Report Generator
tpBefehl | 8 | DBAG Command (Sicam 230)
tpBefehlsgabe | 9 | DBAG Command(Sicam 230)
tpStatus | 10 | State (Sicam230)
tpHelp | 11 | Peak Load Projection
tpRGM | 12 | RGM
tpLogin | 13 | Login
tpHTML | 14 | HTML
tpKeyboard | 15 | Keyboard
tpPFS | 16 | Production & Facility Scheduler
tpRezepturen | 17 | Recipe
tpZustand | 18 | State protocol (Sicam 230)
tpWeltbild | 19 | World view
tpBefBewag | 20 | Scripting command output (Sicam 230)
tpVarStatus | 21 | Variable diagnosis
tpSea | 22 | Switching sequence (Sicam 230)
tpASM | 23 | Industrie Performance Analyzer
tpAlmMgmt | 24 | Alarm management (Sicam 230)
tpIMM | 25 | Industrie Maintainance Manager
tpEnergy | 26 | Command input
tpEMS | 27 | Last-Management
tpTimeFilter | 28 | Time filter
tpAlarmFilter | 29 | Alarm Message List Filter
tpCELFilter | 30 | Chronological Event List
tpGraph7 | 31 | S7 graph
tpBatchControl | 32 | Batch
tpReportViewer | 33 | Report viewer
tpMessageControl | 34 | Message control
tpFaceplate | 35 | Faceplate
tpSystemModel | 36 | System Model
tpADUA | 37 | Active Directory User Administration
tpUserList | 38 | Benutzerliste
tpEditUser | 39 | Benutzer editieren
tpGroupList | 40 | Benutzergruppenliste
tpShiftManagement | 41 | Schichtverwaltung
tpSchaltfolgen | 42 | Schaltfolgen


tpElementTypes

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpElementTypes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpElementTypes constants.

Name | Value | Description
tpDynBargraph | 0 | Bar display
tpDynZahlenElem | 1 | Numerical value
tpDynText | 2 | Dynamic text
tpDynTrend | 4 | Trend element
tpDynZeiger | 5 | Pointer instrument
tpDynBewegt | 6 | Only for compatibility
tpDynBinaer | 7 | Status element
tpDynBitmap | 8 | Only for compatibility
tpDynVerkn | 9 | Only for compatibility
tpDynButton | 10 | Button
tpDynSchalter | 11 | Switch
tpDynMultibin | 12 | Multibin
tpDynMeldung | 13 | Message element
tpDynUhr | 14 | Clock
tpDynBefMdi | 15 | Only for compatibility
tpDynStatus | 16 | Combined Element
tpDynBaButton | 17 | Only for compatibility
tpDynControl | 18 | Only for compatibility
tpDynAegel | 19 | Only for compatibility
tpDynActiveX | 20 | ActiveX
tpDynTopLgt | 21 | Only for compatibility
tpDynTopStrg | 22 | Only for compatibility
tpDynInstrument | 23 | Universal slider
tpDynCombiList | 24 | tpDynCombiList
tpDynWindows | 25 | Only for compatibility
tpDynListbox | 26 | Only for compatibility
tpDynCombobox | 27 | Only for compatibility
tpDynListCtrl | 28 | Only for compatibility
tpDynWPF | 29 | WPF element
tpDynGFXListCtrl | 30 | Only for compatibility
tpDynListCtrlNoH | 31 | Only for compatibility
tpDynMarker | 32 | Only for compatibility
tpDynBatchParamList | 33 | Batch Param List
tpDynBatchRecipeFrame | 34 | Batch Recipe Frame
tpDynPictureContainer | 35 | Picture Container
tpDot | 100 | Only for compatibility
tpLine | 101 | Line
tpRectangle | 102 | Rectangle
tpCircle | 103 | EllipseCircle
tpPolyLine | 104 | Polyline
tpText | 107 | Static text
tpArc | 108 | Arc of a circle
tpSolid | 109 | Only for compatibility
tpTraceDr | 111 | Only for compatibility
tpKegel | 114 | Only for compatibility
tpFillPara | 115 | Only for compatibility
tpFillTria | 116 | Only for compatibility
tpFillBlock | 117 | Only for compatibility
tpPie | 121 | Only for compatibility
tpRoundRect | 127 | Only for compatibility
tpPolygon | 128 | Polygon
tpSymbol | 129 | Embedded symbol
tpSymbolLnk | 130 | Linked symbol
tpSegme_Dxf | 131 | Segment of a circle
tpWMF | 133 | Only for compatibility
tpEMF | 134 | Only for compatibility
tpWinkel | 135 | Only for compatibility
tpPipe | 136 | Pipe


tpFunctionTypes

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpFunctionTypes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpFunctionTypes constants.

Name | Value | Description
tpPicture | 3 | Screen switch
tpLastPicture | 4 | Screen: Return to last
tpPrintAmlCel | 5 | Print AML or CEL
tpExportAmlCel | 6 | Export AML
tpPrintHardCopy | 8 | Print screenshot
tpAlarmAckBlink | 10 | Alarms: acknowledge flashing
tpExit | 12 | Exit Runtime
tpSendVal | 13 | Write set value
tpPlaySound | 14 | Play audio file
tpExecute | 15 | Start program
tpCloseTemplate | 17 | Close fram
tpReadDBaseFile | 18 | Read dBase file
tpSelectScript | 19 | select online
tpExecuteScript | 20 | execute
tpSwitchOnlinePrint | 22 | Switch online printing onoff
tpPrintActual | 23 | Print current values
tpClosePicture | 26 | Close screen
tpExportData | 29 | Export data
tpSelectRecipeOffline | 30 | Standard recipe single with dialog
tpSelectRecipeOnline | 31 | Standard recipe single with online dialog
tpSelectRecipeDirect | 32 | Standard recipe single directly
tpRedundancySwitch | 33 | Redundancy switch
tpActivateAlarm | 34 | Alarm Message List active
tpDeactivateAlarm | 35 | Alarm Message List inactive
tpActDeactAlarm | 38 | Alarm Message List activeinactive
tpFunctionsOnOff | 42 | Functions activeinactive at limit
tpTrendOnOff | 43 | HD administration inactiveactive
tpTrendOn | 44 | HD administration active
tpTrendOff | 45 | HD administration inactive
tpArchiveStart | 46 | Archive: Start
tpArchiveStop | 47 | Archive: Stop
tpListActiveArchive | 48 | Display open archives
tpFunctionsOn | 51 | Functions active at limit
tpFunctionsOff | 52 | Functions inactive at limit
tpCommandOutput | 60 | SAT function
tpCreateSCProtocol | 61 | SAT function
tpFuncLogin | 70 | Log in with dialog
tpFuncLogout | 71 | Log out
tpChangePassword | 72 | Change password
tpBeepStart | 73 | Start continuous tone
tpBeepFinish | 74 | Stop continuous tone
tpExportCel | 76 | Export CEL
tpPrintReport | 77 | Print Report Generator
tpLoginNoPassword | 78 | Login without password
tpReadTextlist | 79 | Language change
tpExportReport | 80 | Export Report Generator
tpCreateProtocol | 81 | Online printing start new page
tpFileOperation | 82 | File operations
tpDriverCommand | 83 | Driver Commands
tpAlarmAck | 84 | Alarms: acknowledge
tpWindowToBack | 85 | Window to the background
tpWindowToFront | 86 | Window to the foreground
tpTemplateFocusOn | 87 | Set focus to the frame
tpTemplateFocusOff | 88 | Take focus away from frame
tpActivateInput | 91 | Activate input to the element with the focus
tpExecReport | 92 | Report Generator: execute
tpRecipeGroupManager | 93 | Recipegroup Manager
tpExportArchive | 95 | Export archives
tpOverviewWindow | 96 | Show overview window
tpUserEdit | 97 | Change user
tpMonitorAssign | 98 | Monitor assign
tpAlarmsGroupsClasses | 99 | Activatedeactivate Alarm Message List, alarmevent groupsclasses
tpSendMessage | 100 | Send a Message
tpVBAEditor | 101 | Open VBA editor
tpVBAMacroDialog | 102 | Show VBA macro dialog
tpShowPCE | 103 | Open PCE editor
tpVBAExecMacro | 104 | Execute VBA macro
tpNetAuth | 105 | Authorization in the network
tpReloadProject | 106 | Reload project online
tpShowRecipeDB | 107 | Show receiving database
tpSaveAlarms | 108 | Save AML and CEL memory buffer
tpSetFocus | 109 | Move focus
tpPictureIndex | 110 | Screen with index
tpAlarmgroupOnOff | 111 | Alarmevent group log inlog off
tpWriteTime | 112 | Write time to variable
tpReadTime | 113 | Read time from variable
tpDeleteAlarm | 114 | Alarms: delete
tpSendMessageAct | 115 | Send Message: activate
tpSendMessageDeact | 116 | Send Message: deactivate
tpExecPFSEvent | 117 | PFS - execute user-defined event
tpVSTAEditor | 130 | Open VSTA editor
tpVSTAExecMacro | 131 | Execute VSTA macro
tpVSTAMacroDialog | 132 | Show VSTA macro dialog
tpAlignVmImage | 139 | Transfer driver simulation image to the standby
tpSimulation | 141 | Activatedeactivate project simulation
tpSapCallFunction | 149 | Execute SAP function
tpEarthfault | 150 | Earthfault search
tpMsgSuppress | 151 | Groupclassareaequipment suppressed
tpMsgSaveQueue | 152 | Save current queue
tpReportViewerPrint | 153 | Report Viewer: export print
tpBatchStateModeCmd | 154 | Execute recipe command changemode change
tpBatchCreateCr | 155 | Create control recipe
tpTemplateToFront | 156 | Funktion "Schablone in Vordergrund bringen"


tpGlobalMultiTouchMode

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpGlobalMultiTouchMode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpGlobalMultiTouchMode constants.

Name | Value | Description
tpGMTNone | 0 | Multi-Touch recognition: deactivated
tpGMTWindows7 | 1 | Multi-Touch recoginition: Windows 7
tpGMTWindows8 | 2 | Multi-Touch recognition: Windows8


tpHardcopyOutput

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpHardcopyOutput

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpHardcopyOutput constants.

Name | Value | Description
tpBMP | 0 | Imagetype BMP of dynpicture hardcopy(...)


tpKanaltypes

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpKanaltypes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpKanaltypes constants.

Name | Value | Description
tpControlStatus | 0 | Control Status
tpAdChan | 1 | AdChan
tpDaChan | 2 | DaChan
tpDigital | 3 | Digital
tpFilter | 4 | Filter
tpStrings | 5 | Strings
tpConfigDef | 6 | Congif Def
tpVirtuell | 7 | Virtuell
tpSPSMerker | 8 | SPSMerker
tpSonderMerker | 9 | SonderMerker
tpSPSEingang | 10 | SPSEingang
tpSPSAusgang | 11 | SPSAusgang
tpTimerEvent | 12 | Timer Event
tpTriggerEvent | 13 | Trigger Event
tpInitFile | 14 | Init File
tpDatenbaustein | 15 | Datenbaustein
tpTerminal | 16 | Terminal
tpVirtuellOnlBerechnen | 17 | Calculate Virtuell Online
tpDataTakerChan | 18 | Data Taker Change
tpProgram | 19 | Program
tpSPSDatenRegister | 20 | SPSDatenRegister
tpSPSFileRegister | 21 | SPSFileRegister
tpSPSTimer | 22 | SPSTimer
tpSPSZaehler | 23 | SPSCounter
tpHWStatus | 24 | Hardware State
tpDataBlock | 25 | DataBlock
tpEzObjekt | 32 | EzObject
tpSystemVariable | 33 | SystemVariable
tpExBaustein | 34 | ExBaustein
tpDriverVariable | 35 | DriverVariable
tpSonderMerker1 | 36 | SonderMerker1
tpCsFirst | 64 | CsFirst
tpCsLast | 79 | CsLast
tpCsDialog | 80 | CsDialog
tpCsDaialogLast | 95 | CsDialogLast
tpCsDbFirst | 96 | CsDbFirst
tpCsDbLast | 127 | CsDbLast


tpLockResult

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpLockResult

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpLockResult constants.

Name | Value | Description
tpAllowed | 0 | Allowed
tpLocked | 1 | Locked
tpBusy | 2 | Busy


tpLoginResult

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpLoginResult

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpLoginResult constants.

Name | Value | Description
tpLoginOk | -2 | Login Ok
tpWrongUser | -2 | Wrong user
tpWrongPassword | -2 | Wrong password
tpWrongUserSystemLocked | -2 | Wrong user - System locked
tpSystemLocked | -2 | System locked
tpUserLocked | -2 | User locked
tpWrongPasswordUserLocked | -2 | Wrong password - User locked
tpPasswordExpired | -2 | Password expired
tpUserDeactivated | -2 | User deactivated
tpSamePassword | -2 | Same Password
tpInvalidConfirmation | -2 | Invalid Confirmation
tpPasswordTooShort | -2 | Password Too Short
tpDefaultError | -2 | Default Error


tpModulePaths

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpModulePaths

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpModulePaths constants.

Name | Value | Description
tpPathGraphic | 0 | Graphic
tpPathExport | 1 | Export
tpPathBMP | 2 | BMP
tpPathAlloc | 3 | Alloc
tpPathList | 4 | List
tpPathMedia | 5 | Media
tpPathReport | 6 | Report
tpPathBackup | 7 | Backup
tpPathExpArchives | 8 | ExpArchives
tpPathLanguage | 9 | Language
tpPathHelp | 10 | Help
tpPathPictures | 11 | Pictures
tpPathPCE | 12 | PCE
tpPathSystem | 13 | System
tpPathVideos | 14 | Videos
tpPathDrivers | 15 | Drivers
tpPathAdditional | 17 | Additional
tpPathRDLC | 18 | RDLC


tpMsgCtrlCelDetail

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpMsgCtrlCelDetail

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpMsgCtrlCelDetail constants.

Name | Value | Description
tpCelDetailAll | 0 | All
tpCelDetailPositiv | 1 | Positive
tpCelDetailNegative | 2 | Negative
tpCelDetailNone | 3 | None


tpNetSendType

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpNetSendType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpNetSendType constants.

Name | Value | Description
tpToServer | 0 | To server
tpToStandby | 1 | To standby
tpToAllClients | 2 | To all clients
tpToSpecificClient | 3 | To specific client


tpPfsData

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpPfsData

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpPfsData constants.

Name

Value

Description


tpPfsDayLink

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpPfsDayLink

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpPfsDayLink constants.

Name | Value | Description
tpPfsExecute | 48 | Execute
tpPfsSkip | 49 | Skip
tpPfsDefaultDay | 50 | Default day
tpPfsDefaultHDay | 51 | Default HDay
tpPfsUnused | 52 | Unused


tpPfsDefaultDays

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpPfsDefaultDays

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpPfsDefaultDays constants.

Name | Value | Description
tpPfsMonday | 2 | Monday
tpPfsTuesday | 3 | Tuesday
tpPfsWednesday | 4 | Wednesday
tpPfsThursday | 5 | Thursday
tpPfsFriday | 6 | Friday
tpPfsSaturday | 7 | Saturday
tpPfsSunday | 1 | Sunday
tpPfsHoliday | 8 | Holiday


tpPfsEventTypes

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpPfsEventTypes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpPfsEventTypes constants.

Name | Value | Description
tpPfsCycleStart | 1 | Cyclestart
tpPfsCycleStartWithProduction | 2 | Cyclestart with production
tpPfsCycleStartWithoutProduction | 3 | Cyclestart without production
tpPfsProductionStart | 4 | Production start
tpPfsProductionEnd | 5 | Production end
tpPfsShiftStart | 6 | Shift start
tpPfsShiftEnd | 7 | Shift end
tpPfsBreakStart | 8 | Break start
tpPfsBreakEnd | 9 | Break end
tpPfsUserEvent | 10 | User event
tpPfsShiftStartFirstDay | 11 | Shift start first day
tpPfsShiftEndLastDay | 12 | Shift start last day
tpPfsShiftFreeStart | 13 | Shift free start
tpPfsShiftFreeEnd | 14 | Shift free end
tpPfsShiftFreeWithoutProductionEnd | 15 | Shift free without production end
tpPfsShiftFreeWithoutProductionStart | 16 | Shift free without production start
tpPfsShiftFirstDayWithoutProductionStart | 17 | Shift start on first day without production
tpPfsShiftLastDayWithoutProductionEnd | 18 | Shift end on last day without production
tpPfsShiftWithoutProductionStart | 19 | Shift without production start
tpPfsShiftWithoutProductionEnd | 20 | Shift without production end


tpPfsLinkTypes

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpPfsLinkTypes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpPfsLinkTypes constants.

Name | Value | Description
tpPfsVariable | 32 | Variable
tpPfsFunction | 33 | Function
tpPfsVariableWithMacro | 34 | Variable with Macro
tpPfsFunctionWithMacro | 35 | Function with Macro


tpPfsTimeTypes

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpPfsTimeTypes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpPfsTimeTypes constants.

Name | Value | Description
tpPfsAbsoluteTime | 149 | PFS Timemodel absolute
tpPfsRelativeTime | 150 | PFS Timemodel relative


tpProjectNetTypes

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpProjectNetTypes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpProjectNetTypes constants.

Name | Value | Description
tpMainstation | 0 | Mainstation
tpServer | 1 | Server
tpStandBy | 2 | StandBy
tpClient | 3 | Client


tpRecipeRenameResult

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpRecipeRenameResult

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpRecipeRenameResult constants.

Name | Value | Description
tpRecipeRenameSuccess | 0 | The recipe was renamed successfully.
tpRecipeRenameOtherError | 1 | A general error has occured.
tpRecipeRenameInvalidName | 2 | The new name is not a valid batch recipe name.
tpRecipeRenameDuplicateName | 3 | A recipe with the new name already exists.
tpRecipeRenameRecipeWrongState | 4 | The recipe is not in a state that allows it to be renamed.
tpRecipeRenameNotVersionOne | 5 | It is not the first version of the master recipe, so the name cannot be changed.


tpRema

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpRema

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpRema constants.

Name | Value | Description
tpBinaer | 1 | Binary
tpAnalog | 2 | Numeric
tpMultiBinaer | 3 | Multi binary
tpMultiAnalog | 4 | Multi numeric
tpString | 5 | String


tpRemoteTransportType

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpRemoteTransportType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpRemoteTransportType constants.

Name | Value | Description
tpSerial | 0 | Serial
tpTCP | 1 | TCP


tpRGMRecipeImport

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpRGMRecipeImport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpRGMRecipeImport constants.

Name | Value | Description
tpOverwriteRecipe | 0 | Overwrite Recipe
tpCreateNewRecipe | 1 | Create New Recipe
tpValuesDiffer | 2 | Values Differ


tpRTCustomAction

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpRTCustomAction

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpRTCustomAction constants.

Name | Value | Description
tpCopy | 0 | Copy
tpCopyRegister | 1 | Copy Register
tpCopyExecute | 2 | Copy Execute


tpRunStates

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpRunStates

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpRunStates constants.

Name | Value | Description
tpRS_proc | 0 | Proc
tpRS_2proc | 1 | To proc
tpRS_2sim | 2 | To sim
tpRS_simul | 3 | Simul
tpRS_sim2sim | 4 | Sim to Sim


tpSapActivity

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpSapActivity

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpSapActivity constants.

Name | Value | Description
tpSapActivity_inactive | 0 | Function not called
tpSapActivity_inqueue | 1 | Function waiting
tpSapActivity_active | 2 | Function active


tpSapError

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpSapError

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpSapError constants.

Name | Value | Description
tpSapError_No_Connection | -1 | No connection to SAP-System
tpSapError_Ok | 0 | OK
tpSapError_Failure | 1 | Error occurred
tpSapError_Exception | 2 | Exception raised
tpSapError_Sys_Exception | 3 | System exception raised, connection closed
tpSapError_Call | 4 | Call received
tpSapError_Internal_Com | 5 | Internal communication, repeat (internal use only)
tpSapError_Closed | 6 | Connection closed by the other side
tpSapError_Retry | 7 | No data yet (RfcListen or RfcWaitForRequest only)
tpSapError_No_Tid | 8 | No Transaction ID available
tpSapError_Executed | 9 | Function already executed
tpSapError_Synchronize | 10 | Synchronous Call in Progress (only for Windows)
tpSapError_Memory_Insufficient | 11 | Memory insufficient
tpSapError_Version_Mismatch | 12 | Version mismatch
tpSapError_Not_found | 13 | Function not found (internal use only)
tpSapError_Call_Not_Supported | 14 | This call is not supported
tpSapError_Not_Owner | 15 | Caller does not own the specified handle
tpSapError_Not_Initialized | 16 | RFC not yet initialized
tpSapError_System_Called | 17 | A system call such as RFC_PING for connection test is executed
tpSapError_Invalid_Handle | 18 | An invalid handle was passed to an API call
tpSapError_Invalid_Parameter | 19 | An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected.
tpSapError_Canceled | 20 | An rfc call has been canceled by user
tpSapError_Conversion | 21 | An error during conversion has been detected
tpSapError_Invalid_Protocol | 22 | The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format
tpSapError_Timeout | 23 | Timeout


tpScreenRawEventRouting

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpScreenRawEventRouting

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpScreenRawEventRouting constants.

Name | Value | Description
tpScreenRawEventRoutingDeactivated | 0 | Deactivated
tpScreenRawEventRoutingAllEvents | 1 | All events
tpScreenRawEventRoutingSelectedEvents | 2 | Selected events


tpStateBit

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpStateBit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpStateBit constants.

Name | Value | Description
tpBitAlarm | 1 | Alarm
tpBitPrint | 4 | Print
tpBitBlink | 8 | Blink
tpBitFkt | 16 | Execute function
tpBitFktQuery | 32 | Execute function query
tpBitNoQuit | 128 | No Quit
tpBitDelete | 256 | Delete
tpBitBtb | 512 | Not real-time
tpBitBtbRt | 1024 | Real-time
tpBitTransparent | 2048 | Transparent
tpBitFktServer | 4096 | Execute function on server
tpBitFktClient | 8192 | Execute function on client
tpBitQuitAlarm | 16384 | Protocol alarm accepted
tpBitOutAlarm | 32768 | Alarm on outgoing alarm


tpTaskStatus

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpTaskStatus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpTaskStatus constants.

Name | Value | Description
tpStopTask | 0 | Stop
tpInitTask | 1 | Initialize
tpRunTask | 2 | Run


tpTaskTyp

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpTaskTyp

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpTaskTyp constants.

Name | Value | Description
tpCycleTask | 0 | Cyclic
tpCallTask | 1 | Once


tpZenMenus

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpZenMenus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpZenMenus constants.

Name | Value | Description
tpVariable | 2 | Variable
tpRtFunction | 1 | RtFunction
tpVbaMacro | 3 | VbaMacro
tpZenHelp | 6 | ZenHelp


tpZenPathType

Manual -> Programming interfaces -> Objectmodel -> Constants -> tpZenPathType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

List of predefined tpZenPathType constants.

Name | Value | Description
tpzenOnIniPath | 0 | Ini Path
tpzenOnExePath | 1 | Exe Path
tpzenOnUserPath | 2 | User Path
tpzenOnAppDataPath | 3 | AppData Path


Alarm

Manual -> Programming interfaces -> Objectmodel -> Alarm

Remarks

Provides access to the alarm control system, active alarms and their current status. alarm events can be used to directly react to

any occuring new alarm messages.

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

void ThisProject_Active()

{

//Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

//Assign the alarm object and init event handlers

this.zenonAlarm = this.Alarm();

this.zenonAlarm.AlarmComes += new AlarmComesEventHandler(zenonAlarm_AlarmComes);

this.zenonAlarm.AlarmGoes += new AlarmGoesEventHandler(zenonAlarm_AlarmGoes);

this.zenonAlarm.AlarmAcknowledged += new AlarmAcknowledgedEventHandler(zenonAlarm_AlarmAcknowledged);

}

void ThisProject_Inactive()

{

//Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

//Unregister any previously registered event

zenonAlarm.AlarmAcknowledged -= new AlarmAcknowledgedEventHandler(zenonAlarm_AlarmAcknowledged);

zenonAlarm.AlarmComes -= new AlarmComesEventHandler(zenonAlarm_AlarmComes);

zenonAlarm.AlarmGoes -= new AlarmGoesEventHandler(zenonAlarm_AlarmGoes);

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

//procedure is executed when an Alarm comes

void zenonAlarm_AlarmComes(IAlarmItem obItem)

{

//print specific information to Debug window...

Debug.Print("{0} > {1}", obItem.Timecomes, obItem.Text);

}

//procedure is executed when an Alarm has gone

void zenonAlarm_AlarmAcknowledged(IAlarmItem obItem)

{

//print specific information to Debug window

Debug.Print("{0} < {1}", obItem.TimeAcknowledged, obItem.Text);

}

//procedure is executed when an Alarm was acknowledged by a user

void zenonAlarm_AlarmGoes(IAlarmItem obItem)

{

//print specific information to Debug window

Debug.Print("{0} | {1}", obItem.Timegoes, obItem.Text);

}

VB.NET

Private zenonAlarm As IAlarm

Private Sub ThisProject_Active()

'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

' << TODO: Add Initialization code here >>

'Assign the alarm object and init event handlers

Me.zenonAlarm = Me.Alarm()

AddHandler Me.zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes

AddHandler Me.zenonAlarm.AlarmGoes, AddressOf zenonAlarm_AlarmGoes

AddHandler Me.zenonAlarm.AlarmAcknowledged, AddressOf zenonAlarm_AlarmAcknowledged

End Sub

Private Sub ThisProject_Inactive()

'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

' << TODO: Add Clean-up code here >>

'Unregister any previously registered event

RemoveHandler zenonAlarm.AlarmAcknowledged, AddressOf zenonAlarm_AlarmAcknowledged

RemoveHandler zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes

RemoveHandler zenonAlarm.AlarmGoes, AddressOf zenonAlarm_AlarmGoes

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

'procedure is executed when an Alarm comes

Private Sub zenonAlarm_AlarmComes(ByVal obItem As IAlarmItem)

'print specific information to Debug window...

Debug.Print("{0} > {1}", obItem.Timecomes, obItem.Text)

End Sub

'procedure is executed when an Alarm has gone

Private Sub zenonAlarm_AlarmAcknowledged(ByVal obItem As IAlarmItem)

'print specific information to Debug window

Debug.Print("{0} < {1}", obItem.TimeAcknowledged, obItem.Text)

End Sub

'procedure is executed when an Alarm was acknowledged by a user

Private Sub zenonAlarm_AlarmGoes(ByVal obItem As IAlarmItem)

'print specific information to Debug window

Debug.Print("{0} | {1}", obItem.Timegoes, obItem.Text)

End Sub

VBA

Dim WithEvents zAlarm As Alarm

'procedure is executed on startup of the zenOn runtime
Private Sub Project_Active()
'init the alarm object for events
Set zAlarm = thisProject.Alarm
End Sub

'procedure is executed when an Alarm comes
Private Sub zAlarm_AlarmComes(ByVal obItem As IAlarmItem)
'print specific information to Debug window...
Debug.Print obItem.Timecomes & " > " & obItem.Text
End Sub

'procedure is executed when an Alarm has gone
Private Sub zAlarm_AlarmGoes(ByVal obItem As IAlarmItem)
'print specific information to Debug window...
Debug.Print obItem.Timegoes & " < " & obItem.Text
End Sub

'procedure is executed when an Alarm was acknowledged by a user
Private Sub zAlarm_AlarmAcknowledged(ByVal obItem As IAlarmItem)
'print specific information to Debug window...
Debug.Print obItem.TimeAcknowledged & " | " & obItem.Text
End Sub

'procedure is executed on terminating the zenOn Runtime
Private Sub Project_Inactive()
'free the alarm object
Set zAlarm = Nothing
End Sub

Other topics in this chapter

Alarm-Properties

Alarm-Methods

Alarm-Events

Alarm-Dynamic properties


Alarm-Properties

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | Aktiv | Alarm-module in-/active | not used | read only
IProject | Parent | Parent-object | read only | read only

Other topics in this chapter

Parent

Aktiv


Parent

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Aktiv

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Properties -> Aktiv

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the status of the alarm administration. If the value is True, the alarms administration is active. If it is not active the alarm buffer cannot be extended, i.e. no further alarms occur. It does not influence clearing existing alarms.De/activating the alarms administration is possible with the following functions of the control system:· Alarms active· Alarms inactive· Alarms active/inactive· Alarms/groups/classes

Datatype

Aktiv() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Alarm-Methods

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IAlarmItems | AlarmItems | - | not used | available
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used
void | ResetQueryFilter | Resets the QueryFilter | not used | read only

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

AlarmItems

ResetQueryFilter


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a StringArray of all Dynproperties available for this Object. Example how to call this method:

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object. A blank String like that returns the first layer of properties: DynPropertiesEnum("")

VBA

bsPath As String

Examples

VBA

Sub ReadDynProps() Dim vProps As VariantDim i As Integer'get all DynProperties of the actual object (DynPicture, Element, ...) vProps = zenOnObject.DynPropertiesEnum("")

'Print informations of DynProperties into output window

For i = 0

To UBound(vProps) Debug.Print vProps(i)

Next i

End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

VBA

bsPath As String

Examples

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With DynProperties it is possible to get access to additional Properties/Methods of Objects.

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property. Example: "NetActive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

VBA

bsPath As String

vValue As Variant

Examples

VBA

Sub SetDynProp()

'Sample: Set the Network Aktive Flag of the Project. MyWorkspace.ActiveDocument.DynProperties("NetActive") = True 'also set a computer as server... MyWorkspace.ActiveDocument.DynProperties("NetServer") = "COMPUTERNAME"

End Sub


AlarmItems

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Methods -> AlarmItems

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns the object AlarmItems of the alarming module. In this collection all existing alarms are listed. With the method Item you can access single alarms. The single alarm entries contain information on the alarms.Filter String:If the string is not "*", then the string should represent the name (case sensitive) of a zenon function.If a function with the given name exists, the filter settings within this function will be used.--> only version 6.51 and above.

Datatype

AlarmItems(String strFilter) As AlarmItems

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

The filtering is not implemented at this time. For later use

C#

String strFilter

VBA

strFilter As String

Examples

C#

public void MacroGetAlarmItems()

{

IAlarm zenonAlarm = this.Alarm();

IAlarmItems zenonAlarmItems = zenonAlarm.AlarmItems("*");

for (int i = 0; i < zenonAlarmItems.Count; ++i)

{

IAlarmItem zenonAlarmItem = zenonAlarmItems.Item(i);

PrintAlarm(zenonAlarmItem);

}

}

private void PrintAlarm(IAlarmItem alarm)

{

Debug.Print("TimeComes : " + alarm.Timecomes);

Debug.Print("TimeGoes : " + alarm.Timegoes);

Debug.Print("TimeAcknowledged : " + alarm.TimeAcknowledged);

Debug.Print("Text : " + alarm.Text);

Debug.Print("Variable : " + alarm.Variable().Name);

Debug.Print("Value : " + alarm.Value);

}

VB.NET

' Displays the amount of alarms currently in memory and

' * the alarm text of all the different alarms.

'

Public Sub MacroGetAlarmItems()

'Get alarm object(s) from active project

Dim zenonAlarm As IAlarm = Me.Alarm()

Dim zenonAlarmItems As IAlarmItems = zenonAlarm.AlarmItems("*")

MessageBox.Show(String.Format("{0} Alarms in memory...", zenonAlarmItems.Count))

'get text of active alarms...

For i As Integer = 0 To zenonAlarmItems.Count - 1

Dim zenonAlarmItem As IAlarmItem = zenonAlarmItems.Item(i)

Debug.Print(zenonAlarmItem.Text)

Next

End Sub

VBA

Public Sub GetAlarmItems()
Dim zAML As Alarm
Dim zAML_Items As AlarmItems
Dim zAML_Item As AlarmItem
Dim i As Integer
'set alarm objects
Set zAML = thisProject.Alarm

'get all items
Set zAML_Items = zAML.AlarmItems("*")

'get specific item using the screen switch function as filter

' Set zAML_Items = zAML.AlarmItems("myFunction")
'get count of active alarms...
MsgBox zAML_Items.Count & " Alarms in memory..."
'get text of active alarms...
For i = 0 To zAML_Items.Count - 1
Set zAML_Item = zAML_Items.Item(i)
Debug.Print zAML_Item.Text
Next i
End Sub


ResetQueryFilter

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Methods -> ResetQueryFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Specify AML filter or set default value.

Datatype

ResetQueryFilter() As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

//Manipulation using the query filter

Project.Aml.ResetQueryFilter()

Project.Aml.SetDynProp(„QueryFilter.XXX", ZZZ)

//get items using the query filter

Project.Aml.AmlItems(„.")


Alarm-Events

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
void | AlarmAcknowledged | Event: Is fired by alarm going... | not used | available | yes | yes
void | AlarmComes | Returns the alarm-items objects | not used | available | yes | yes
void | AlarmGoes | Event: Is fired by alarm coming... | not used | available | yes | yes
void | AlarmListSelectionChanged | Event: Is fired when the selection in the alarmlist has changed... | not used | available | yes | yes
void | AlarmUsertextChanged | Event: Is fired when the usertext has changed... | not used | available | yes | yes
void | SelectionChangedEx | Event: selection array in the alarm list has been changed... | not used | read only | yes | yes

Other topics in this chapter

AlarmComes

AlarmGoes

AlarmAcknowledged

AlarmListSelectionChanged

AlarmUsertextChanged

SelectionChangedEx


AlarmComes

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Events -> AlarmComes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the alarm-items objects, Event is fired when an Alarm comes up...To get these Event, an Object has to be declared and initialised

Datatype

AlarmComes(AlarmItem obItem) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

Returns an Object of Type AlarmItem (The AlarmItem which comes up)

C#

AlarmItem obItem

VBA

obItem As AlarmItem

Examples

C#

private IAlarm zenonAlarm;

void zenonAlarm_AlarmComes(IAlarmItem obItem)

{

//print specific information to Debug window...

Debug.Print("{0} > {1}", obItem.Timecomes, obItem.Text);

}

void ThisProject_Active()

{

//Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

//Assign the alarm object and init event handler

this.zenonAlarm = this.Alarm();

this.zenonAlarm.AlarmComes += new AlarmComesEventHandler(zenonAlarm_AlarmComes);

}

void ThisProject_Inactive()

{

//Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

//Unregister previously registered event handler

zenonAlarm.AlarmComes -= new AlarmComesEventHandler(zenonAlarm_AlarmComes);

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

VB.NET

Private zenonAlarm As IAlarm

Private Sub zenonAlarm_AlarmComes(obItem As IAlarmItem)

'print specific information to Debug window...

Debug.Print("{0} > {1}", obItem.Timecomes, obItem.Text)

End Sub

Private Sub ThisProject_Active()

'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

' << TODO: Add Initialization code here >>

'Assign the alarm object and init event handler

Me.zenonAlarm = Me.Alarm()

AddHandler Me.zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes

End Sub

Private Sub ThisProject_Inactive()

'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

' << TODO: Add Clean-up code here >>

'Unregister previously registered event handler

RemoveHandler zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

VBA

Dim WithEvents zAlarm As Alarm

Private Sub Project_Active()
Set zAlarm = thisProject.Alarm
End Sub

Private Sub zAlarm_AlarmComes(ByVal obItem As IAlarmItem)
Debug.Print obItem.Text
End Sub


AlarmGoes

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Events -> AlarmGoes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This Event is fired when an alarm has been gone.To get these Event, an Object has to be declared and initialised.

Datatype

AlarmGoes(AlarmItem obItem) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

Returns an Object of Type AlarmItem (The AlarmItem which has gone)

C#

AlarmItem obItem

VBA

obItem As AlarmItem

Examples

C#

private IAlarm zenonAlarm;

void zenonAlarm_AlarmGoes(IAlarmItem obItem)

{

//print specific information to Debug window

Debug.Print("{0} | {1}", obItem.Timegoes, obItem.Text);

}

void ThisProject_Inactive()

{

//Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

//Unregister previously registered event handler

zenonAlarm.AlarmGoes -= new AlarmGoesEventHandler(zenonAlarm_AlarmGoes);

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

void ThisProject_Active()

{

//Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

//Assign the alarm object and init event handler

this.zenonAlarm = this.Alarm();

this.zenonAlarm.AlarmGoes += new AlarmGoesEventHandler(zenonAlarm_AlarmGoes);

}

VB.NET

Private zenonAlarm As IAlarm

Private Sub zenonAlarm_AlarmGoes(obItem As IAlarmItem)

'print specific information to Debug window

Debug.Print("{0} | {1}", obItem.Timegoes, obItem.Text)

End Sub

Private Sub ThisProject_Inactive()

'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

'Unregister previously registered event handler

RemoveHandler zenonAlarm.AlarmGoes, AddressOf zenonAlarm_AlarmGoes

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

Private Sub ThisProject_Active()

'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

'Assign the alarm object and init event handler

Me.zenonAlarm = Me.Alarm()

AddHandler Me.zenonAlarm.AlarmGoes, AddressOf zenonAlarm_AlarmGoes

End Sub

VBA

Dim WithEvents zAlarm As Alarm

Private Sub Project_Active()
Set zAlarm = thisProject.Alarm
End Sub

Private Sub zAlarm_AlarmGoes(ByVal obItem As IAlarmItem)
Debug.Print obItem.Text
End Sub


AlarmAcknowledged

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Events -> AlarmAcknowledged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This Event is fired when an alarm was acknowledged by a user.To get these Event, an Object has to be declared and initialised

Datatype

AlarmAcknowledged(AlarmItem obItem) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

The returned object is an object of type AlarmItem and has all properties and methods like the original AlarmItem object.

C#

AlarmItem obItem

VBA

obItem As AlarmItem

Examples

C#

private IAlarm zenonAlarm;

void zenonAlarm_AlarmAcknowledged(IAlarmItem obItem)

{

//print specific information to Debug window

Debug.Print("{0} < {1}", obItem.TimeAcknowledged, obItem.Text);

}

void ThisProject_Inactive()

{

//Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

// << TODO: Add Clean-up code here >>

//Unregister previously registered event handler

zenonAlarm.AlarmAcknowledged -= zenonAlarm_AlarmAcknowledged;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

void ThisProject_Active()

{

//Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

// << TODO: Add Initialization code here >>

//Assign the alarm object and init event handler

this.zenonAlarm = this.Alarm();

this.zenonAlarm.AlarmAcknowledged += new AlarmAcknowledgedEventHandler(zenonAlarm_AlarmAcknowledged);

}

VB.NET

Private zenonAlarm As IAlarm

Private Sub zenonAlarm_AlarmAcknowledged(obItem As IAlarmItem)

'print specific information to Debug window

Debug.Print("{0} < {1}", obItem.TimeAcknowledged, obItem.Text)

End Sub

Private Sub ThisProject_Inactive()

'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

' << TODO: Add Clean-up code here >>

'Unregister previously registered event handler

RemoveHandler zenonAlarm.AlarmAcknowledged, AddressOf zenonAlarm_AlarmAcknowledged

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

Private Sub ThisProject_Active()

'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

' << TODO: Add Initialization code here >>

'Assign the alarm object and init event handler

Me.zenonAlarm = Me.Alarm()

AddHandler Me.zenonAlarm.AlarmAcknowledged AddressOf zenonAlarm_AlarmAcknowledged

End Sub

VBA

Dim WithEvents zAlarm As Alarm

Private Sub Project_Active()
Set zAlarm = thisProject.Alarm
End Sub

Private Sub zAlarm_AlarmAcknowledged(ByVal obItem As IAlarmItem)
Debug.Print obItem.Text
End Sub


AlarmListSelectionChanged

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Events -> AlarmListSelectionChanged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The event will be fired whenever the Selection in the list is changed, when an item is selected the Entry will be passed on through the zenon-API. When an item has been deselected, the eventparameter will be "Nothing".Additionally the event will be triggered whenever an AML/CEL picture is closed. (This could lead the event being triggered twice with "Nothing").NOTE: When the Property "hide current selection" has been set at the listcontrol, the event will/should not be fired(!)

Datatype

AlarmListSelectionChanged(AlarmItem obItem) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

The returned object is an object of type AlarmItem and has all properties and methods like the original AlarmItem object.

C#

AlarmItem obItem

VBA

obItem As AlarmItem

Examples

C#

private IAlarm zenonAlarm;

void ThisProject_Active()

{

//Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

//Assign the alarm object and init event handlers

this.zenonAlarm = this.Alarm();

this.zenonAlarm.AlarmListSelectionChanged += new AlarmListSelectionChangedEventHandler(zenonAlarm_AlarmListSelectionChanged);

}

void ThisProject_Inactive()

{

//Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

this.zenonAlarm.AlarmListSelectionChanged -= zenonAlarm_AlarmListSelectionChanged;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

void zenonAlarm_AlarmListSelectionChanged(IAlarmItem obItem)

{

if (obItem != null) //Note: If the parameter object ist null an object was deselected

{

Debug.Print("AlarmListSelectionChanged: {0}", obItem.Text);

}

}

VB.NET

Private zenonAlarm As IAlarm

Private Sub ThisProject_Active()

'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

'Assign the alarm object and init event handlers

Me.zenonAlarm = Me.Alarm()

AddHandler Me.zenonAlarm.AlarmListSelectionChanged, AddressOf zenonAlarm_AlarmListSelectionChanged

End Sub

Private Sub ThisProject_Inactive()

'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

RemoveHandler Me.zenonAlarm.AlarmListSelectionChanged, AddressOf zenonAlarm_AlarmListSelectionChanged

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

Private Sub zenonAlarm_AlarmListSelectionChanged(obItem As IAlarmItem)

If obItem IsNot Nothing Then

'Note: If the parameter object ist null an object was deselected

Debug.Print("AlarmListSelectionChanged: {0}", obItem.Text)

End If

End Sub

VBA

Private Sub zAMLPIC_Open()
'boolen flag to remember the open event
bAML = True
'init AML Object to get the AlarmListSelectionChanged event
Set zAML = thisProject.Alarm
End Sub

Private Sub zAMLPIC_Close()
'release object
Set zAML = Nothing
End Sub

Private Sub zAML_AlarmListSelectionChanged(ByVal obItem As IAlarmItem)
'If the boolen is TRUE, the first events can be ignored
'because in this case the events returns the default
'selection on opening the picture
If bAML = True Then
bAML = False
Else
If obItem Is Nothing Then Exit Sub
Debug.Print "A_Changed - " & obItem.Text
End If
End Sub


AlarmUsertextChanged

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Events -> AlarmUsertextChanged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Event is triggered if an entry is made in the AML list in the column for comments. The entried string is transferred to the event, where it can be manipulated and is afterwards entried in the column for comments. For CEL comments, an event should be analogically built in, as well.

Datatype

AlarmUsertextChanged(String bsText) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

String bsText

VBA

VBA-Syntax

Examples

C#

private IAlarm zenonAlarm;

void ThisProject_Active()

{

//Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

//Assign the alarm object and init event handlers

this.zenonAlarm = this.Alarm();

this.zenonAlarm.AlarmUsertextChanged += new AlarmUsertextChangedEventHandler(zenonAlarm_AlarmUsertextChanged);

}

void ThisProject_Inactive()

{

//Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

this.zenonAlarm.AlarmUsertextChanged -= zenonAlarm_AlarmUsertextChanged;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

void zenonAlarm_AlarmUsertextChanged(ref string bsText)

{

//Just print out the new text

Debug.Print(bsText);

}

VB.NET

Private zenonAlarm As IAlarm

Private Sub ThisProject_Active()

'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

'Assign the alarm object and init event handlers

Me.zenonAlarm = Me.Alarm()

AddHandler Me.zenonAlarm.AlarmUsertextChanged, AddressOf zenonAlarm_AlarmUsertextChanged

End Sub

Private Sub ThisProject_Inactive()

'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

RemoveHandler Me.zenonAlarm.AlarmUsertextChanged, AddressOf zenonAlarm_AlarmUsertextChanged

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

Private Sub zenonAlarm_AlarmUsertextChanged(ByRef bsText As String)

'Just print out the new text

Debug.Print(bsText)

End Sub

VBA

Dim WithEvents zAlarm As Alarm

Private Sub Project_Active()

Set zAlarm = thisProject.Alarm

End Sub

Private Sub zAlarm_AlarmUsertextChanged(bsText As String)

bsText = bsText & "Projekt-Zeit"

End Sub


SelectionChangedEx

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Events -> SelectionChangedEx

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SelectionChangedEx(LPVARIANT arrSelection) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

ref object arrSelection


Alarm-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

CDlgAlarm

Other topics in this chapter

CDlgAlarm


CDlgAlarm

Manual -> Programming interfaces -> Objectmodel -> Alarm -> Alarm-Dynamic properties -> CDlgAlarm

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description


AlarmItem

Manual -> Programming interfaces -> Objectmodel -> AlarmItem

Remarks

The object AlarmItem contains information on an alarm. The different items can be accessed with the method Alarm of the current project. The returned object contains the collection AlarmItems, which lists every single alarm in the project.If the object Alarm was defined with WithEvents (Or has assigned event handlers in C#), the events for received/cleared/acknowledged alarms are executed. Those events have a AlarmItem object as a parameter.

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

public void MacroGetAlarmItems()

{

IAlarm zenonAlarm = this.Alarm();

IAlarmItems zenonAlarmItems = zenonAlarm.AlarmItems("*");

for (int i = 0; i < zenonAlarmItems.Count; ++i)

{

IAlarmItem zenonAlarmItem = zenonAlarmItems.Item(i);

PrintAlarm(zenonAlarmItem);

}

}

private void PrintAlarm(IAlarmItem alarm)

{

Debug.Print("TimeComes : " + alarm.Timecomes);

Debug.Print("TimeGoes : " + alarm.Timegoes);

Debug.Print("TimeAcknowledged : " + alarm.TimeAcknowledged);

Debug.Print("Text : " + alarm.Text);

Debug.Print("Variable : " + alarm.Variable().Name);

Debug.Print("Value : " + alarm.Value);

}

VB.NET

Public Sub MacroGetAlarmItems()

Dim zenonAlarm As IAlarm = Me.Alarm()

Dim zenonAlarmItems As IAlarmItems = zenonAlarm.AlarmItems("*")

For i As Integer = 0 To zenonAlarmItems.Count - 1

Dim zenonAlarmItem As IAlarmItem = zenonAlarmItems.Item(i)

PrintAlarm(zenonAlarmItem)

Next

End Sub

Private Sub PrintAlarm(alarm As IAlarmItem)

Debug.Print("TimeComes : " & Convert.ToString(alarm.Timecomes))

Debug.Print("TimeGoes : " & Convert.ToString(alarm.Timegoes))

Debug.Print("TimeAcknowledged : " & Convert.ToString(alarm.TimeAcknowledged))

Debug.Print("Text : " & Convert.ToString(alarm.Text))

Debug.Print("Variable : " + alarm.Variable().Name)

Debug.Print("Value : " & Convert.ToString(alarm.Value))

End Sub

VBA

Public Sub GetAlarmItems()
Dim zAML As Alarm
Dim zAML_Items As AlarmItems
Dim zAML_Item As AlarmItem
Dim i As Integer

'set alarm objects
Set zAML = thisProject.Alarm
Set zAML_Items = zAML.AlarmItems("*")

'get text of active alarms...
For i = 0 To zAML_Items.Count - 1
Set zAML_Item = zAML_Items.Item(i)
Call PrintAlarm(zAML_Item)
Next i
End Sub

Sub PrintAlarm(YourAlarmItem As AlarmItem)
'this procedure will print out a set of informations
'depending to the given AlarmItem...
Debug.Print "TimeComes : " & YourAlarmItem.Timecomes
Debug.Print "TimeGoes : " & YourAlarmItem.Timegoes
Debug.Print "TimeAcknowledged: " & YourAlarmItem.TimeAcknowledged
Debug.Print "Text : " & YourAlarmItem.Text
Debug.Print "Variable : " & YourAlarmItem.Variable.Name
Debug.Print "Value : " & YourAlarmItem.Value
End Sub

Other topics in this chapter

AlarmItem-Properties

AlarmItem-Methods


AlarmItem-Properties

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
short | AlarmClass | Alarmclass | not used | read only
short | AlarmGroup | Alarmgroup | not used | read only
BSTR | Computer | Computer, which raised the alarm | not used | read only
long | Countreactivated |  | not used | read only
BSTR | Name | Name | not used | read only
IAlarmItems | Parent | Parent-object | read only | read only
BSTR | Projectname | Project-name | not used | read only
long | Status | Status of the variable | not used | read only
long | Statusreactivated |  | not used | read only
BSTR | Tagname | TagName of the linked variable | not used | read only
BSTR | Text | Alarmtext of the variable (limit/rema) | not used | read only
DATE | TimeAcknowledged |  | not used | read only
DATE | Timecomes | Time of the alarm | not used | read only
DATE | Timegoes |  | not used | read only
DATE | Timequitted | For internal use only | not used | not used
DATE | Timereactivated |  | not used | read only
BSTR | User | User, which raised the alarm | not used | read only
BSTR | Usertext |  | not used | available
VARIANT | Value | Value of the variable | not used | read only
long | Index | Index of the alarm in the variable limits list or conditions in reaction matrix | not used | read only

Other topics in this chapter

Parent

Name

Tagname

Projectname

Text

Status

Index

Value

Timecomes

Timegoes

Timequitted

TimeAcknowledged

Timereactivated

Statusreactivated

Countreactivated

User

Computer

Usertext

AlarmGroup

AlarmClass


Parent

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As AlarmItems

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property returns the name of the variable linked to the alarm entry. This variable can also be found with the method Variable of this object.The variable was defined as an alarm variable in the limit/REMA definition.The name of the variable is unique. With this name the variable can be found in the central variables list of the project.

Datatype

Name() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Tagname

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> Tagname

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property returns the identification of the variable that executed the alarm. Further properties of the linked variable can be found out with the method Variable. In this case the object Variable is returned.

Datatype

Tagname() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Projectname

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> Projectname

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the name of the project in which the alarm occurred. Since the object Alarm is always executed in the current project, this property is always the same as Project.Name and thisProject.Name in VBA.With this name the project can be found in the central project list of the application.

Datatype

Projectname() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Text

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> Text

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Alarmtext of the variable (limit/rema)

Datatype

Text() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Status

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> Status

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property returns the status of the value, that executed the alarm, e.g. the variable Heating_1 has a maximum limit of 10. The value is set to 15 on error. In this case the property contains the status of the value 15.The returned value contains the status in bit code.The following stati are possible in the control system:· Invalid (I-Bit)· Not actualized· Alternate value (EWERT)· General request (GA)· Spontan· Summer/Winter time· Switched off (N_AKT)· Realtime external· Realtime internal· Wintertime· Hand value· User flag 1 .. 8 (ST_M1 .. ST_M8)· Select (SELEC)· Revision (REV)· Run contact (LAUF)· Runtime overflow (LZÜ)· Fail Trafo (SM_TR)· NS· INFO· Set direction

Datatype

Status() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Index

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> Index

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the index of the alarm in the alarm collection.

Datatype

Index() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Value

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> Value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property returns the „invalid“ value responsible for the occurence of the alarm. The current value was changed from the raw value to a zenOn value.The property value is set on the first event „received“ of the alarm entry. If the alarm is reactivated, only the number of reactivations, the time received and the status of the value is updated.

Datatype

Value() As VARIANT

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Timecomes

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> Timecomes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property contains the time stamp of the first event „received“.If the option with time reactivated in the alarm configuration is set, this alarm entry is also used for the next violation (unless it is acknowledged). Thereby the time received, the number of reactivations and the status of the value is updated.The property Timereactivated returns the time of the last event „received“.If this option is not set each event „received“ creates an own alarm entry with the appropriate information.

Datatype

Timecomes() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Timegoes

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> Timegoes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property contains the time stamp of the event „cleared“. The event „cleared“ is executed an the end of the alarm, i.e. the limit violation no longer exists. The time stamp of the event „cleared“ always is greater than that of the event „received“ (see Timecomes).If the option with time reactivated in the alarm configuration is set, it is possible that the time cleared is smaller than the time reactivated (see Timereactived).

Datatype

Timegoes() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Timequitted

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> Timequitted

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property contains the time stamp of the event „acknowledged“. Acknowledging an alarm means, that the user read the entry and reacted. Acknowledging is always done by a user.On acknowledging the fields computer and user are set to the current computer and user. This action closes the alarm entry.

Datatype

Timequitted() As DATE

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes


TimeAcknowledged

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> TimeAcknowledged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property contains the time stamp of the event „acknowledged“. Acknowledging an alarm means, that the user read the entry and reacted. Acknowledging is always done by a user.On acknowledging the fields computer and user are set to the current computer and user. This action closes the alarm entry.

Datatype

TimeAcknowledged() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Timereactivated

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> Timereactivated

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property contains the time stamp of the last event „received“. Usually this is the property Timecomes.If the option with time reactivated in the alarm configuration is set, this entry is updated the next time the alarm occurs (unless it is acknowledged). Thereby the time received, the number of reactivations and the status of the value is updated.

Datatype

Timereactivated() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Statusreactivated

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> Statusreactivated

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the status of the reactivated, violated value. Usually this is the property of the current status.If the option with time reactivated in the alarm configuration is set, this property returns the status of the newest violation. With this setting a received unacknowledged alarm only generates one entry. On the next occurence a counter is increased and the time received and the status of the value is updated.

Datatype

Statusreactivated() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Countreactivated

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> Countreactivated

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the number of the reactivations of the alarm. In the project configuration the option with time reactivated can be set. So a received and not acknowledged alarm only generates one entry. A new occuarance of the alarm only sets a counter, updates the time received and the status.If this option is not used every occurance of the alarm generates a new entry.

Datatype

Countreactivated() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


User

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> User

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the identification of the user that acknowledged the current alarm. The user logged in at that time is found out and his identification is read. This is transferred to the object Alarm. If no user is logged in, the user SYSTEM is automatically logged in.With this identification the user can be located in the central user administration of the process control system.

Datatype

User() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Computer

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> Computer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the name of the computer, on which the action occurred, e.g. acknowledging an alarm. The field for the computer name is limited to 47 characters.If the project runs stand-alone (without network), this property returns the name of the computer, where the project runs. In a network this name can be a client, a server or a stand-by.

Datatype

Computer() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Usertext

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> Usertext

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

additional Text defined by the User.

Datatype

Usertext() As String

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


AlarmGroup

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> AlarmGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the defined alarm class. A limit or a status in a REMA can be linked with an alarm class.As a default no alarm group is linked.A maximum of 256 different alarm groups can be defined. The alarm groups serve for the object orientated technological differenciation:- Group 1 = pumps- Group 2 = electricity- Group 3 = ...

Datatype

AlarmGroup() As short

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


AlarmClass

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Properties -> AlarmClass

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the defined alarm class. A limit or a status in a REMA can be linked with an alarm class.As a default no alarm class is linked.A maximum of 8 different alarm classes can be defined. The alarm classes have the following tasks:- Priorityfor picture alarming- Colour switching- Definition of alarm colours in the alarms list and for picture alarming- Filter criteria in the alarms list and chronologic events list- Function calling- Execution of e.g. acoustic alarming

Datatype

AlarmClass() As short

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


AlarmItem-Methods

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | Acknowledge | Quit the Alarm | not used | available
VARIANT_BOOL | Delete | Delete the Alarm | not used | available
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
VARIANT_BOOL | Quit | For internal use only | not used | not used
IVariable | Variable | Returns the linked variable | not used | read only
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

Variable

Quit

Acknowledge

Delete


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object. A blank String like that returns the first layer of properties: DynPropertiesEnum("")

VBA

bsPath As String

Examples

VBA

Sub ReadDynProps()

Dim vProps As Variant

Dim i As Integer

'get all DynProperties of the actual object (DynPicture, Element, ...)

vProps = zenOnObject.DynPropertiesEnum("")

'Print informations of DynProperties into output window

For i = 0

To UBound(vProps) Debug.Print vProps(i)

Next i

End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property. Example: "NetActive"

VBA

bsPath As String

Examples

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetActive" Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

VBA

bsPath As String

vValue As Variant

Examples

VBA

Sub SetDynProp() 'Sample: Set the Network Aktive Flag of the Project. MyWorkspace.ActiveDocument.DynProperties("NetActive") = True 'also set a computer as server... MyWorkspace.ActiveDocument.DynProperties("NetServer") = "COMPUTERNAME"

End Sub


Variable

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Methods -> Variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the variable linked to the alarm entry. The variable contains general process information, whereas the alarm entry contains information on the alarm.Refer to the chapter Variable for more detailled information.Hint: The variable should be checked on Nothing.

Datatype

Variable() As Variable

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

private IAlarm zenonAlarm;

void ThisProject_Active()

{

//Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

this.zenonAlarm = this.Alarm();

zenonAlarm.AlarmComes += new AlarmComesEventHandler(zenonAlarm_AlarmComes);

}

void zenonAlarm_AlarmComes(IAlarmItem obItem)

{

//Read the name of the corresponding alarm variable and its datatype - print both to the CEL

//Check if the variable is null first.

if(obItem.Variable() != null)

{

this.Cel().WriteCelString(string.Format("An alarm for {0} has gone off, the variable has data type {1}",

obItem.Variable().Name, obItem.Variable().DataType));

}

}

void ThisProject_Inactive()

{

//Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

this.zenonAlarm.AlarmComes -= new AlarmComesEventHandler(zenonAlarm_AlarmComes);

this.zenonAlarm = null;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

VB.NET

Private zenonAlarm As IAlarm

Private Sub ThisProject_Active()

'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

Me.zenonAlarm = Me.Alarm()

AddHandler zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes

End Sub

Private Sub zenonAlarm_AlarmComes(obItem As IAlarmItem)

'Read the name of the corresponding alarm variable and its datatype - print both to the CEL

'Check if the variable is null first.

If obItem.Variable() IsNot Nothing Then

Me.Cel().WriteCelString(String.Format("An alarm for {0} has gone off, the variable has data type {1}", obItem.Variable().Name, obItem.Variable().DataType))

End If

End Sub

Private Sub ThisProject_Inactive()

'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

RemoveHandler Me.zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes

Me.zenonAlarm = Nothing

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub


Quit

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Methods -> Quit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Method to set an Alarm as "quitted"

Datatype

Quit() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

private IAlarm zenonAlarm;

void ThisProject_Active()

{

//Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

this.zenonAlarm = this.Alarm();

zenonAlarm.AlarmComes += new AlarmComesEventHandler(zenonAlarm_AlarmComes);

}

void ThisProject_Inactive()

{

//Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

this.zenonAlarm.AlarmComes -= new AlarmComesEventHandler(zenonAlarm_AlarmComes);

this.zenonAlarm = null;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

void zenonAlarm_AlarmComes(IAlarmItem obItem)

{

//As soon as a new alarm occurs it will be quitted without any user interaction

obItem.Quit();

}

VB.NET

Private zenonAlarm As IAlarm

Private Sub ThisProject_Active()

'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

Me.zenonAlarm = Me.Alarm()

AddHandler zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes

End Sub

Private Sub ThisProject_Inactive()

'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

RemoveHandler Me.zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes

Me.zenonAlarm = Nothing

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

Private Sub zenonAlarm_AlarmComes(obItem As IAlarmItem)

'As soon as a new alarm occurs it will be quitted without any user interaction

obItem.Quit()

End Sub


Acknowledge

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Methods -> Acknowledge

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Method to set an Alarm as "acknowledged"

Datatype

Acknowledge() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

private IAlarm zenonAlarm;

void ThisProject_Active()

{

//Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

this.zenonAlarm = this.Alarm();

zenonAlarm.AlarmComes += new AlarmComesEventHandler(zenonAlarm_AlarmComes);

}

void ThisProject_Inactive()

{

//Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

this.zenonAlarm.AlarmComes -= new AlarmComesEventHandler(zenonAlarm_AlarmComes);

this.zenonAlarm = null;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

void zenonAlarm_AlarmComes(IAlarmItem obItem)

{

//As soon as a new alarm occurs it will be acknowledged without any user interaction

obItem.Acknowledge();

}

VB.NET

Private zenonAlarm As IAlarm

Private Sub ThisProject_Active()

'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

Me.zenonAlarm = Me.Alarm()

AddHandler zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes

End Sub

Private Sub ThisProject_Inactive()

'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

RemoveHandler Me.zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes

Me.zenonAlarm = Nothing

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

Private Sub zenonAlarm_AlarmComes(obItem As IAlarmItem)

'As soon as a new alarm occurs it will be acknowledged without any user interaction

obItem.Acknowledge()

End Sub


Delete

Manual -> Programming interfaces -> Objectmodel -> AlarmItem -> AlarmItem-Methods -> Delete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Method to set an Alarm as "deleted"

Datatype

Delete() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

private IAlarm zenonAlarm;

void ThisProject_Active()

{

//Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

this.zenonAlarm = this.Alarm();

zenonAlarm.AlarmComes += new AlarmComesEventHandler(zenonAlarm_AlarmComes);

}

void ThisProject_Inactive()

{

//Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

this.zenonAlarm.AlarmComes -= new AlarmComesEventHandler(zenonAlarm_AlarmComes);

this.zenonAlarm = null;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

void zenonAlarm_AlarmComes(IAlarmItem obItem)

{

//As soon as a new alarm occurs it will be deleted without any user interaction

obItem.Delete();

}

VB.NET

Private zenonAlarm As IAlarm

Private Sub ThisProject_Active()

'Create any required API-References here (Event handlers, OnlineContainers, local references,etc. )

Me.zenonAlarm = Me.Alarm()

AddHandler zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes

End Sub

Private Sub ThisProject_Inactive()

'Release all API-References here (Event handlers, OnlineContainers, local references, etc. )

RemoveHandler zenonAlarm.AlarmComes, AddressOf zenonAlarm_AlarmComes

Me.zenonAlarm = Nothing

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

Private Sub zenonAlarm_AlarmComes(obItem As IAlarmItem)

'As soon as a new alarm occurs it will be deleted without any user interaction

obItem.Delete()

End Sub


AlarmItems

Manual -> Programming interfaces -> Objectmodel -> AlarmItems

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The alarm entries are administered in this collection. If a new alarm occurs, it is added to this collection.The single alarm entries contain information on the alarm, e.g. name, variable, alarm group, alarm class, ...

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

/* Displays the amount of alarms currently in memory and

* the alarm text of all the different alarms.

*/

public void MacroGetAlarmItems()

{

//Get alarm object(s) from active project

IAlarm zenonAlarm = this.Alarm();

IAlarmItems zenonAlarmItems = zenonAlarm.AlarmItems("*");

MessageBox.Show(string.Format("{0} Alarms in memory...", zenonAlarmItems.Count));

//get text of active alarms...

for(int i = 0; i < zenonAlarmItems.Count; ++i)

{

IAlarmItem zenonAlarmItem = zenonAlarmItems.Item(i);

Debug.Print(zenonAlarmItem.Text);

}

}

VB.NET

' Displays the amount of alarms currently in memory and

' * the alarm text of all the different alarms.

'

Public Sub MacroGetAlarmItems()

'Get alarm object(s) from active project

Dim zenonAlarm As IAlarm = Me.Alarm()

Dim zenonAlarmItems As IAlarmItems = zenonAlarm.AlarmItems("*")

MessageBox.Show(String.Format("{0} Alarms in memory...", zenonAlarmItems.Count))

'get text of active alarms...

For i As Integer = 0 To zenonAlarmItems.Count - 1

Dim zenonAlarmItem As IAlarmItem = zenonAlarmItems.Item(i)

Debug.Print(zenonAlarmItem.Text)

Next

End Sub

VBA

'*** In this example all alarm entries are read and displayed in the Output window of VBA.
'*** Run Aml_Items and write information of the items to the debug-window of the VBA-IDE
Public Sub Aml_Items()
Dim obAml As Alarm
Dim obAmlItem As AlarmItem
'*** Get Alarm-object of the current project
Set obAml = thisProject.Alarm
'*** Write information to debug-window of the VBA-IDE
For nIndex = 0 To obAml.AlarmItems.Count - 1
Set obAmlItem = obAml.AlarmItems.Item(nIndex)
If Not obAmlItem Is Nothing Then
Debug.Print "Alarm: " & obAmlItem.Name & _
" Variable: " & obAmlItem.Variable.Name & _
" AmlGroup: " & CStr(obAmlItem.AlarmGroup) & _
" AmlClass: " & CStr(AlarmItem.AlarmClass)
End If
Next nIndex
End Sub

'**********************************************************************
'* This codesample browses all alarms and searches in the alargroups *
'* 1-3 for non acknowledged alarms. *
'* ------------------------------------------------------------------ *
'* Autor: Mark Clemens Support, COPA-DATA GmbH *
'**********************************************************************
Dim obAml As Alarm
Dim obAmlItem As AlarmItem
Dim obAmlItems As AlarmItems
Dim nIndex As Variant
Dim obVariable As Variable
Dim nAcknowledged1, nAcknowledged2, nAcknowledged3 As Boolean

Sub Aml_Items()
'*** Reset internal variables
nAcknowledged1 = False
nAcknowledged2 = False
nAcknowledged3 = False
'*** Get Alarm-object of the current project
Set obAml = thisProject.Alarm
'*** Get all alarmitems
Set obAmlItems = obAml.AlarmItems("*")

'get specific item using the screen switch function as filter

'Set obAmlItems = obAml.AlarmItems("myFunction")
For nIndex = 0 To obAmlItems.Count - 1
Set obAmlItem = obAmlItems.Item(nIndex)
If (Not obAmlItem Is Nothing) Then
'*** Define which alarmgroups should be searched
Select Case obAmlItem.AlarmGroup
Case 1
'*** Search for non acknowledged alarms by comparing the TimeAcknowledged Date
If obAmlItem.TimeAcknowledged = "01.01.1970 01:00:00" Then
nAcknowledged1 = True
End If
Case 2
'*** Search for non acknowledged alarms by comparing the timeacknowledged Date
If obAmlItem.TimeAcknowledged = "01.01.1970 01:00:00" Then
nAcknowledged2 = True
End If
Case 3
'*** Search for non acknowledged alarms by comparing the timeacknowledged Date
If obAmlItem.TimeAcknowledged = "01.01.1970 01:00:00" Then
nAcknowledged3 = True
End If
End Select
End If
Next nIndex
'*** After all Alarms have been analyzed set the processvariables
'***Group 1
Set obVariable = thisProject.Variables.Item("group1_not_acknowledged")
If Not (obVariable Is Nothing) Then
If nAcknowledged1 = True Then
obVariable.Value = 1
Else
obVariable.Value = 0
End If
End If
'***Group 2
Set obVariable = thisProject.Variables.Item("group2_not_acknowledged")
If Not (obVariable Is Nothing) Then
If nAcknowledged2 = True Then
obVariable.Value = 1
Else
obVariable.Value = 0
End If
End If
'***Group 3
Set obVariable = thisProject.Variables.Item("group3_not_acknowledged")
If Not (obVariable Is Nothing) Then
If nAcknowledged3 = True Then
obVariable.Value = 1
Else
obVariable.Value = 0
End If
End If
End Sub

Other topics in this chapter

AlarmItems-Properties

AlarmItems-Methods


AlarmItems-Properties

Manual -> Programming interfaces -> Objectmodel -> AlarmItems -> AlarmItems-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | Aktiv | Alarm-module in-/active | not used | read only
long | Count | Count of the alarm-items | read only | read only
IAlarm | Parent | Parent-object | read only | read only

Other topics in this chapter

Parent

Aktiv

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> AlarmItems -> AlarmItems-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Alarm

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Aktiv

Manual -> Programming interfaces -> Objectmodel -> AlarmItems -> AlarmItems-Properties -> Aktiv

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the status of the alarm administration. If the value is True, the alarms administration is active. If it is not active the alarm buffer cannot be extended, i.e. no further alarms occur. It does not influence clearing existing alarms.De/activating the alarms administration is possible with the following functions of the control system:· Alarms active· Alarms inactive· Alarms active/inactive· Alarms/groups/classes

Datatype

Aktiv() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> AlarmItems -> AlarmItems-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


AlarmItems-Methods

Manual -> Programming interfaces -> Objectmodel -> AlarmItems -> AlarmItems-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IAlarmItem | Item | Returns the alarm-item on the given position | available | available

Other topics in this chapter

Item


Item

Manual -> Programming interfaces -> Objectmodel -> AlarmItems -> AlarmItems-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the object for the alarm entry at the position vID. All existing alarms of the project are in this collection. The returned object Alarmitem contains important information on the alarm.This method Item only allows accessing with the index.Hint: Check the returned object on Nothing, if no object for the search creteria was found.

Datatype

Item(VARIANT vIndex) As AlarmItem

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

vID As Variant

Unique index for the position of the element in the list. Care that the index is < Count, i.e. for nIndex = 0 to Count-1

C#

object vIndex

VBA

vIndex As Variant

Examples

VBA

'*** In this example all alarm entries are read and displayed in the Output window of VBA.
'*** Run Aml_Items and write information of the items to the debug-window of the VBA-IDE
Public Sub Aml_Items()
Dim obAml As Alarm
Dim obAmlItem As AlarmItem
'*** Get Alarm-object of the current project
Set obAml = thisProject.Alarm
'*** Write information to debug-window of the VBA-IDE
For nIndex = 0 To obAml.AlarmItems.Count - 1
Set obAmlItem = obAml.AlarmItems.Item(nIndex)
If Not obAmlItem Is Nothing Then
Debug.Print "Alarm: " & obAmlItem.Name & _
" Variable: " & obAmlItem.Variable.Name & _
" AmlGroup: " & CStr(obAmlItem.AlarmGroup) & _
" AmlClass: " & CStr(AlarmItem.AlarmClass)
End If
Next nIndex
End Sub

'**********************************************************************
'* This codesample browses all alarms and searches in the alargroups *
'* 1-3 for non acknowledged alarms. *
'* ------------------------------------------------------------------ *
'* Autor: Mark Clemens Support, COPA-DATA GmbH *
'**********************************************************************
Dim obAml As Alarm
Dim obAmlItem As AlarmItem
Dim obAmlItems As AlarmItems
Dim nIndex As Variant
Dim obVariable As Variable
Dim nAcknowledged1, nAcknowledged2, nAcknowledged3 As Boolean

Sub Aml_Items()
'*** Reset internal variables
nAcknowledged1 = False
nAcknowledged2 = False
nAcknowledged3 = False
'*** Get Alarm-object of the current project
Set obAml = thisProject.Alarm
'*** Get all alarmitems
Set obAmlItems = obAml.AlarmItems("*")
For nIndex = 0 To obAmlItems.Count - 1
Set obAmlItem = obAmlItems.Item(nIndex)
If (Not obAmlItem Is Nothing) Then
'*** Define which alarmgroups should be searched
Select Case obAmlItem.AlarmGroup
Case 1
'*** Search for non acknowledged alarms by comparing the TimeAcknowledged Date
If obAmlItem.TimeAcknowledged = "01.01.1970 01:00:00" Then
nAcknowledged1 = True
End If
Case 2
'*** Search for non acknowledged alarms by comparing the timeacknowledged Date
If obAmlItem.TimeAcknowledged = "01.01.1970 01:00:00" Then
nAcknowledged2 = True
End If
Case 3
'*** Search for non acknowledged alarms by comparing the timeacknowledged Date
If obAmlItem.TimeAcknowledged = "01.01.1970 01:00:00" Then
nAcknowledged3 = True
End If
End Select
End If
Next nIndex
'*** After all Alarms have been analyzed set the processvariables
'***Group 1
Set obVariable = thisProject.Variables.Item("group1_not_acknowledged")
If Not (obVariable Is Nothing) Then
If nAcknowledged1 = True Then
obVariable.Value = 1
Else
obVariable.Value = 0
End If
End If
'***Group 2
Set obVariable = thisProject.Variables.Item("group2_not_acknowledged")
If Not (obVariable Is Nothing) Then
If nAcknowledged2 = True Then
obVariable.Value = 1
Else
obVariable.Value = 0
End If
End If
'***Group 3
Set obVariable = thisProject.Variables.Item("group3_not_acknowledged")
If Not (obVariable Is Nothing) Then
If nAcknowledged3 = True Then
obVariable.Value = 1
Else
obVariable.Value = 0
End If
End If
End Sub


ALCEdge

Manual -> Programming interfaces -> Objectmodel -> ALCEdge

Remarks

With this object you have the opportunity to get informations about a selected procedural element.

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

public void MacroALCEdge()

{

//Get ALC engine and child objects

IALCEngine zenonAlcEngine = this.ALCEngine();

IALCEdge zenonAlcEdge = zenonAlcEngine.EdgeItem(0);

IALCNode zenonAlcNodeOne = zenonAlcEdge.Node1;

IALCNode zenonAlcNodeTwo = zenonAlcEdge.Node2;

//Returns the ID of the procedural element on the screen

MessageBox.Show("ElementID of the procedural element: " + zenonAlcEdge.ElementID);

//Returns the screen in which the procedural element is used

MessageBox.Show("Screen: " + zenonAlcEdge.Picture);

//Returns the ID of the ALC source (the list of these ids is available from the project property "Automatic line coloring")

MessageBox.Show("Source ID: " + zenonAlcEdge.SourceID);

//Returns the internal name of the procedural elements type

MessageBox.Show(zenonAlcEdge.Type.ToString());

MessageBox.Show("Linked variable: " + zenonAlcEdge.Variable);

//Returns the ID of the procedural elements node on the screen

//Note: Not all procedural elements contain two nodes

MessageBox.Show("Link ID Node1: " + zenonAlcNodeOne.LinkID);

//Returns the ID of the procedural elements second node on the screen

MessageBox.Show("Link ID Node2: " + zenonAlcNodeTwo.LinkID);

}

VB.NET

Public Sub MacroALCEdge()

'Get ALC engine and child objects

Dim zenonAlcEngine As IALCEngine = Me.ALCEngine()

Dim zenonAlcEdge As IALCEdge = zenonAlcEngine.EdgeItem(0)

Dim zenonAlcNodeOne As IALCNode = zenonAlcEdge.Node1

Dim zenonAlcNodeTwo As IALCNode = zenonAlcEdge.Node2

'Returns the ID of the procedural element on the screen

MessageBox.Show("ElementID of the procedural element: " + zenonAlcEdge.ElementID)

'Returns the screen in which the procedural element is used

MessageBox.Show("Screen: " + zenonAlcEdge.Picture)

'Returns the ID of the ALC source (the list of these ids is available from the project property "Automatic line coloring")

MessageBox.Show("Source ID: " + zenonAlcEdge.SourceID)

'Returns the internal name of the procedural elements type

MessageBox.Show(zenonAlcEdge.Type.ToString())

MessageBox.Show("Linked variable: " + zenonAlcEdge.Variable)

'Returns the ID of the procedural elements node on the screen

'Note: Not all procedural elements contain two nodes

MessageBox.Show("Link ID Node1: " + zenonAlcNodeOne.LinkID)

'Returns the ID of the procedural elements second node on the screen

MessageBox.Show("Link ID Node2: " + zenonAlcNodeTwo.LinkID)

End Sub

VBA

Sub ALCEdge()

Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcEdge As ALCEdge 'Child object from type ALCEngine
Dim zAlcNode1 As ALCNode 'Child object from type ALCEngine
Dim zAlcNode2 As ALCNode 'Child object from type ALCEngine

'Get ALCEngine data from the project
Set zAlcEngine = thisProject.ALCEngine
'Get the first procedural element of the project
Set zAlcEdge = zAlcEngine.EdgeItem(0)

'Returns the ID of the procedural element in the screen
MsgBox "ElementID of the procedural element = " & zAlcEdge.ElementID
'Returns the screen in which the procedural element is used
MsgBox "Screen = " & zAlcEdge.Picture
'Returns the ID of the ALC source (the list of these Ids is available at the project property "Automatic line coloring")
MsgBox "Source ID = " & zAlcEdge.SourceID

'Returns the type of procedural element
If zAlcEdge.Type = 0 Then
MsgBox "Type = tpALCTypeNode"
ElseIf zAlcEdge.Type = 1 Then
MsgBox "Type = tpALCTypeSource"
ElseIf zAlcEdge.Type = 2 Then
MsgBox "Type = tpALCTypeSwitch"
ElseIf zAlcEdge.Type = 3 Then
MsgBox "Type = tpALCTypeSink"
ElseIf zAlcEdge.Type = 4 Then
MsgBox "Type = tpALCTypeTrafo"
ElseIf zAlcEdge.Type = 5 Then
MsgBox "Type = tpALCTypeLink"
End If

'Returns the variable which is linked to the procedural element
MsgBox "Linkes variable = " & zAlcEdge.Variable.Name

'Returns the first connected node (HINT:Not all procedural elements include two Nodes!)
Set zAlcNode1 = zAlcEdge.Node1
'Returns the ID of the node in the screen
MsgBox "Link ID Node1 = " & zAlcNode1.LinkID
'Returns the second connected node
Set zAlcNode2 = zAlcEdge.Node2
'Returns the ID of the node in the screen
MsgBox "Link ID Node2 = " & zAlcNode2.LinkID

End Sub

Other topics in this chapter

ALCEdge-Properties


ALCEdge-Properties

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | ElementID | Returns the ID of the element the edge is connected with. | read only | read only
BSTR | ElementRef | Returns the reference name of the element the edge is connected with. | not used | available
tpALCGroundFaultType | GroundFaultType | Returns the ground fault detection type if the edge is of type Switch. | not used | available
IVariable | GroundFaultVarDisp | Returns the attached ground fault display Variable if ground fault detection is enabled. | not used | available
IVariable | GroundFaultVarFwd | Returns the attached ground fault forward Variable if ground fault detection is enabled. | not used | available
IVariable | GroundFaultVarRev | Returns the attached ground fault reverse Variable if ground fault detection is enabled. | not used | available
IVariable | GroundFaultVarTrg | Returns the attached ground fault trigger Variable if ground fault detection is enabled. | not used | available
IALCNode | Node1 | Returns the first ALC node. | read only | read only
IALCNode | Node2 | Returns the second ALC node. | read only | read only
BSTR | Picture | Returns the name of the picture the element is located in. | read only | read only
long | ReverseSourceID | Returns the reverse Source ID if the edge is of type Trafo. | not used | available
tpALCShortFaultType | ShortFaultType | Returns the short fault detection type if the edge is of type Switch. | not used | available
IVariable | ShortFaultVarDisp | Returns the attached short fault display Variable if short fault detection is enabled. | not used | available
IVariable | ShortFaultVarFwd | Returns the attached short fault forward Variable if short fault detection is enabled. | not used | available
IVariable | ShortFaultVarRev | Returns the attached short fault reverse Variable if short fault detection is enabled. | not used | available
IVariable | ShortFaultVarTrg | Returns the attached short fault trigger Variable if short fault detection is enabled. | not used | available
long | SourceID | Returns the Source ID if the edge is of type Source or Trafo. | read only | read only
tpALCType | Type | Returns the type of this ALC edge. | read only | read only
IVariable | Variable | Returns the attached Variable if the edge is of type Source or Switch. | read only | read only

Other topics in this chapter

Node1

Node2

Type

SourceID

ReverseSourceID

Variable

Picture

ElementID

ElementRef

GroundFaultType

GroundFaultVarTrg

GroundFaultVarFwd

GroundFaultVarRev

GroundFaultVarDisp

ShortFaultType

ShortFaultVarTrg

ShortFaultVarFwd

ShortFaultVarRev

ShortFaultVarDisp


Node1

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> Node1

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an object from type "ALCNode". It represents a node which is connected to the procedural element. Hint: It is also possible that only one of the two nodes is connected to the procedural element.

Datatype

Node1() As ALCNode

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Node2

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> Node2

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an object from type "ALCNode". It represents a node which is connected to the procedural element. Hint: It is also possible that only one of the two nodes is connected to the procedural element.

Datatype

Node2() As ALCNode

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Type

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Type() As tpALCType

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


SourceID

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> SourceID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the ID of the ALC source (the list of these IDs is available at the zenOn project property "Automatic line coloring")

Datatype

SourceID() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ReverseSourceID

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> ReverseSourceID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ReverseSourceID() As long

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


Variable

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> Variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an object from type "Variable". It represents the variable which is linked to the procedural element.

Datatype

Variable() As Variable

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Picture

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> Picture

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the picture in which the procedural element is used.

Datatype

Picture() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ElementID

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> ElementID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the ID of the procedural element in the picture.

Datatype

ElementID() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetNameOfElement()
Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcEdge As ALCEdge 'Child object from type ALCEngine

'Get first procedural element of the project
Set zAlcEdge = thisProject.ALCEngine.EdgeItem(0)
'Get name of this procedural element (combielement)
Debug.Print "Name of element = " & FindElem(zAlcEdge).Name

End Sub

Function FindElem(zAlcEdge As ALCEdge) As Element
Dim i As Integer
Dim zPIC As DynPicture

'Get picture object
Set zPIC = thisProject.DynPictures.Item(zAlcEdge.Picture)
'Enum elements in picture
For i = 0 To zPIC.Elements.count - 1
'Check element id
If zPIC.Elements.Item(i).ID = zAlcEdge.ElementID Then
'Return Element
Set FindElem = zPIC.Elements.Item(i)
Exit Function
End If
Next i
End Function


ElementRef

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> ElementRef

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ElementRef() As String

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


GroundFaultType

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> GroundFaultType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

GroundFaultType() As tpALCGroundFaultType

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


GroundFaultVarTrg

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> GroundFaultVarTrg

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

GroundFaultVarTrg() As Variable

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


GroundFaultVarFwd

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> GroundFaultVarFwd

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

GroundFaultVarFwd() As Variable

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


GroundFaultVarRev

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> GroundFaultVarRev

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

GroundFaultVarRev() As Variable

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


GroundFaultVarDisp

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> GroundFaultVarDisp

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

GroundFaultVarDisp() As Variable

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


ShortFaultType

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> ShortFaultType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ShortFaultType() As tpALCShortFaultType

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


ShortFaultVarTrg

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> ShortFaultVarTrg

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ShortFaultVarTrg() As Variable

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


ShortFaultVarFwd

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> ShortFaultVarFwd

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ShortFaultVarFwd() As Variable

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


ShortFaultVarRev

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> ShortFaultVarRev

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ShortFaultVarRev() As Variable

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


ShortFaultVarDisp

Manual -> Programming interfaces -> Objectmodel -> ALCEdge -> ALCEdge-Properties -> ShortFaultVarDisp

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ShortFaultVarDisp() As Variable

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


ALCEngne

Manual -> Programming interfaces -> Objectmodel -> ALCEngne

Remarks

With this object you have the opportunity to get line and procedural elements via an index or from specific Screens and specific Element IDs.

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

public void MacroGetEdgeItem()

{

IALCEngine zenonAlcEngine = this.ALCEngine();

//Get the first ALC procedural element of the project

IALCEdge zenonAlcEdge = zenonAlcEngine.EdgeItem(0);

MessageBox.Show("Element is in screen: " + zenonAlcEdge.Picture);

}

VB.NET

Public Sub MacroGetEdgeItem()

Dim zenonAlcEngine As IALCEngine = Me.ALCEngine()

'Get the first ALC procedural element of the project

Dim zenonAlcEdge As IALCEdge = zenonAlcEngine.EdgeItem(0)

MessageBox.Show("Element is in screen: " + zenonAlcEdge.Picture)

End Sub

VBA

'This method searches a procedural element via an index in the project
Sub GetEdgeItem()

Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcEdge As ALCEdge 'Child object from type ALCEngine

'Get ALCEngine data from the project
Set zAlcEngine = thisProject.ALCEngine
'Get the first ALC procedural element of the project
Set zAlcEdge = zAlcEngine.EdgeItem(0)
MsgBox "Element is in screen = " & zAlcEdge.Picture
FindEdge

End Sub

'This method searches for a procedural element in a specific screen with a specific ElementID
Sub FindEdge()

Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcEdge As ALCEdge 'Child object from type ALCEngine

'Get ALCEngine data from the project
Set zAlcEngine = thisProject.ALCEngine
'Returns an ALC procedural element with a specific ID (element ID in the screen) from a specific screen
Set zAlcEdge = zAlcEngine.FindEdge("BILD3", 10)
'Show the name of the variable which is connected to the procedural element
MsgBox "Variable of the element = " & zAlcEdge.Variable.Name
NodeItem

End Sub

'This method searches a line element via an index in the project
Sub NodeItem()

Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcNode As ALCNode 'Child object from type ALCEngine
Dim LineStates As Variant 'Collect the line states
Dim i As Integer

'Get ALCEngine data from the project
Set zAlcEngine = thisProject.ALCEngine
'Number of connections in the project
MsgBox "Node count = " & zAlcEngine.NodeCount
'Get the first line element of the screen
Set zAlcNode = zAlcEngine.NodeItem(0)

LineStates = zAlcNode.LineStates
'Show the first line state in RT (Be careful that the line has to have a state unequal "empty")
MsgBox "Line state = " & LineStates(0)
FindNode

End Sub

'This method searches for a line element in a specific screen with a specific ElementID
Sub FindNode()

Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcNode As ALCNode 'Child object from type ALCEngine

'Get ALCEngine data from the project
Set zAlcEngine = thisProject.ALCEngine
'Returns an ALC line element with a specific ID (element ID in the screen) from a specific screen
Set zAlcNode = zAlcEngine.FindNode("BILD3", 18)
'Returns the number of procedural elements which are connected to the line element
MsgBox "Number of connected procedural elements = " & zAlcNode.EdgeCount

End Sub

Other topics in this chapter

ALCEngine-Properties

ALCEngine-Methods

ALCEngine-Events


ALCEngine-Properties

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | EdgeCount | Returns the number of ALC edges. | read only | read only
long | GraphAliasCount | Returns the number of ALC alias elements. | read only | read only
long | GraphElemCount | Returns the number of ALC elements. | read only | read only
tpALCGroundFaultMode | GroundFaultMode | Get/Set the ground fault mode. | not used | available
long | NodeCount | Returns the number of ALC nodes. | read only | read only
IProject | Parent | Returns the parent of the ALCEngine Object. | read only | read only
double | MaxOverload |  | not used | read only

Other topics in this chapter

Parent

NodeCount

EdgeCount

GraphElemCount

GraphAliasCount

GroundFaultMode

MaxOverload


Parent

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


NodeCount

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Properties -> NodeCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the number of nodes in a project.

Datatype

NodeCount() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


EdgeCount

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Properties -> EdgeCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the number of procedural elements (generator, source, switch, disconnector, drain, transformator, link) from a project.

Datatype

EdgeCount() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


GraphElemCount

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Properties -> GraphElemCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects.

Datatype

GraphElemCount() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


GraphAliasCount

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Properties -> GraphAliasCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects.

Datatype

GraphAliasCount() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


GroundFaultMode

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Properties -> GroundFaultMode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

GroundFaultMode() As tpALCGroundFaultMode

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


MaxOverload

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Properties -> MaxOverload

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MaxOverload() As double

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ALCEngine-Methods

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | AckGroundFault | Acknowledges a ground fault detection. | not used | available
void | AckShortFault | Acknowledges a short fault detection. | not used | available
IALCEdge | EdgeItem | Returns the ALC edge at the given index. | read only | read only
IALCEdge | FindEdge | Returns the ALC edge associated to the given element. | read only | read only
IALCEdge | FindEdgeByRef | Returns the ALC edge associated to the given element. | not used | read only
IALCNode | FindNode | Returns the ALC node associated to the given element. | read only | read only
IALCNode | FindNodeByRef | Returns the ALC node associated to the given element. | not used | read only
IALCGraphAlias | GraphAliasItem | Returns the ALC alias element at the given index. | read only | read only
IALCGraphElem | GraphElemItem | Returns the ALC element at the given index. | read only | read only
IALCNode | NodeItem | Returns the ALC node at the given index. | read only | read only

Other topics in this chapter

NodeItem

EdgeItem

GraphElemItem

GraphAliasItem

FindNode

FindEdge

FindNodeByRef

FindEdgeByRef

AckGroundFault

AckShortFault


NodeItem

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Methods -> NodeItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns a node from the project. Such an element is from object type "ALCNode".

Datatype

NodeItem(long lIndex) As ALCNode

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

Position of the element in the project.

C#

long lIndex

VB.NET

Dim lIndex As Long

VBA

lIndex As Long

Examples

VBA

Sub NodeItem()

Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcNode As ALCNode 'Child object from type ALCEngine

'Get ALCEngine data from the project
Set zAlcEngine = MyWorkspace.ActiveDocument.ALCEngine
'Get the first node of the picture
Set zAlcNode = zAlcEngine.NodeItem(0)
'Returns the number of procedural elements which are connected to the line element
MsgBox "Number of edges = " & zAlcNode.EdgeCount

End Sub


EdgeItem

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Methods -> EdgeItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns a procedural element (generator, source, switch, disconnector, drain, transformator, link) from the project. Such an element is from type ALCEdge.

Datatype

EdgeItem(long lIndex) As ALCEdge

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

Position of the element in the project.

C#

long lIndex

VB.NET

Dim lIndex As Long

VBA

lIndex As Long

Examples

VBA

Sub GetEdgeItem()

Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcEdge As ALCEdge 'Child object from type ALCEngine

'Get ALCEngine data from the project
Set zAlcEngine = MyWorkspace.ActiveDocument.ALCEngine
'Get the first ALC procedural element of the project
Set zAlcEdge = zAlcEngine.EdgeItem(0)
MsgBox "Element is in picture = " & zAlcEdge.Picture

End Sub


GraphElemItem

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Methods -> GraphElemItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets a ALCElement item.

Datatype

GraphElemItem(long lIndex) As ALCGraphElem

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

long lIndex

VB.NET

Dim lIndex As Long

VBA

lIndex As Long

Examples

C#

//Iterate all ALCGraph elements using the GraphElemCount property. this.ActiveDocument is the active workspace

//Create an instance of the zenOn.IALCGraphElem to collect a Graph element on index

//Print the output using the output window, use: this.Parent.DebugPrint().

public void Macro_GraphElem()

{

for (int i = 0; i < this.ActiveDocument.ALCEngine().GraphElemCount; i++)

{

zenOn.IALCGraphElem AlcElem = this.ActiveDocument.ALCEngine().GraphElemItem(i);

this.Parent.DebugPrint(string.Format("ID: {0}; Type: {1}; Picture: {2}", AlcElem.ElementID, AlcElem.Type, AlcElem.Picture), zenOn.tpDebugPrintStyle.tpNrm);

}

}

VB.NET

//Iterate all ALCGraph elements using the GraphElemCount property. this.ActiveDocument is the active workspace

//Create an instance of the zenOn.IALCGraphElem to collect a Graph element on index

//Print the output using the output window, use: this.Parent.DebugPrint().

Public Sub Macro_GraphElem()

For i As Integer = 0 To Me.ActiveDocument.ALCEngine().GraphElemCount - 1

Dim AlcElem As zenOn.IALCGraphElem = Me.ActiveDocument.ALCEngine().GraphElemItem(i)

Me.Parent.DebugPrint(String.Format("ID: {0}; Type: {1}; Picture: {2}", AlcElem.ElementID, AlcElem.Type, AlcElem.Picture), zenOn.tpDebugPrintStyle.tpNrm)

Next

End Sub


GraphAliasItem

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Methods -> GraphAliasItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets a ALCAlias item of a ALCElement.

Datatype

GraphAliasItem(long lIndex) As ALCGraphAlias

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

long lIndex

VB.NET

Dim lIndex As Long

VBA

lIndex As Long

Examples

C#

//Iterate all ALCGraph aliases using the GraphAliasCount property. this.ActiveDocument is the active workspace

//Create an instance of the zenOn.IALCGraphAlias to collect a Graph element on index

//Print the output using the output window, use: this.Parent.DebugPrint().

public void Macro_GraphAlias()

{

for (int i = 0; i < this.ActiveDocument.ALCEngine().GraphAliasCount; i++)

{

zenOn.IALCGraphAlias AlcAlias = this.ActiveDocument.ALCEngine().GraphElemItem(i);

this.Parent.DebugPrint(string.Format("ID: {0}; Type: {1}; Picture: {2}", AlcAlias.ElementID, AlcAlias.Type, AlcAlias.Picture), zenOn.tpDebugPrintStyle.tpNrm);

}

}

VB.NET

//Iterate all ALCGraph aliases using the GraphAliasCount property. this.ActiveDocument is the active workspace

//Create an instance of the zenOn.IALCGraphAlias to collect a Graph element on index

//Print the output using the output window, use: this.Parent.DebugPrint().

Public Sub Macro_GraphAlias()

For i As Integer = 0 To Me.ActiveDocument.ALCEngine().GraphAliasCount - 1

Dim AlcAlias As zenOn.IALCGraphAlias = Me.ActiveDocument.ALCEngine().GraphElemItem(i)

Me.Parent.DebugPrint(String.Format("ID: {0}; Type: {1}; Picture: {2}", AlcAlias.ElementID, AlcAlias.Type, AlcAlias.Picture), zenOn.tpDebugPrintStyle.tpNrm)

Next

End Sub


FindNode

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Methods -> FindNode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns an ALC node from a specific picture with a specific ID (ID of the element in the picture).

Datatype

FindNode(String bsPicture, long lElementID) As ALCNode

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

ID from one of the line elements which is connected to the node. String that defines the Screen in which the ALC element is used.

VBA

lElementID As Long

bsPicture As String

Examples

VBA

Sub FindNode()

Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcNode As ALCNode 'Child object from type ALCEngine

'Get ALCEngine data from the project
Set zAlcEngine = thisProject.ALCEngine
'Returns a ALC node with a specific ID (ID from one of the connected line elements) from a specific picture
Set zAlcNode = zAlcEngine.FindNode("BILD3", 18)
'Returns the number of procedural elements which are connected to the line element
MsgBox "Number of connected procedural elements = " & zAlcNode.EdgeCount

End Sub


FindEdge

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Methods -> FindEdge

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns a procedural element (generator, source, switch, disconnector, drain, transformator, link) from a specific picture with a specific ID (ID of the element in the picture).

Datatype

FindEdge(String bsPicture, long lElementID) As ALCEdge

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

ID of the element in the Screen. String that defines the Screen in which the ALC element is used.

VBA

lElementID As Long

bsPicture As String

Examples

VBA

Sub FindEdge()

Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcEdge As ALCEdge 'Child object from type ALCEngine

'Get ALCEngine data from the project
Set zAlcEngine = MyWorkspace.ActiveDocument.ALCEngine
'Returns an ALC procedural element with a specific ID (element ID in the picture) from a specific picture
Set zAlcEdge = zAlcEngine.FindEdge("BILD3", 17)
'Show the ALC ID if the element
MsgBox "Source ID of the element = " & zAlcEdge.SourceID

End Sub


FindNodeByRef

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Methods -> FindNodeByRef

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

FindNodeByRef(String bsElemRef) As ALCNode

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


FindEdgeByRef

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Methods -> FindEdgeByRef

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

FindEdgeByRef(String bsElemRef) As ALCEdge

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


AckGroundFault

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Methods -> AckGroundFault

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

AckGroundFault(IVariable pVariable) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


AckShortFault

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Methods -> AckShortFault

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

AckShortFault(IVariable pVariable) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


ALCEngine-Events

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | CheckInterlocking | Event: Is fired to check interlockings. | not used | available

Other topics in this chapter

CheckInterlocking


CheckInterlocking

Manual -> Programming interfaces -> Objectmodel -> ALCEngne -> ALCEngine-Events -> CheckInterlocking

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is fired to check topological interlockings. The operated switch and also the new condition are assigned.The event uses LockResult, bUnlockable or bsText to indicate a violated lock condition. If the Lockresult is tpBusy the event will be fired until the result is no longer tpBusy for a maximum of 10 sec. After the elapsed time the locking will be activ. BsText and bUnlockable apply information concerning the locking text and the unlocking conditions.

Datatype

CheckInterlocking(ALCEdge pALCEdge, long nNewState, tpLockResult LockResult, String bsText, Boolean bUnlockable) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


ALCGraphAlias

Manual -> Programming interfaces -> Objectmodel -> ALCGraphAlias

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this object you have the opportunity to get line and procedural elements via an index or from specific Screens and specific Element IDs.

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

/*

* Iterate all ALCGraph aliases using the GraphAliasCount property. this.ActiveDocument is the active workspace

* Create an instance of the zenOn.IALCGraphAlias to collect a Graph element on index

* Print the output using the output window, use: this.Parent.DebugPrint().

*/

public void Macro_GraphAlias()

{

for (int i = 0; i < this.ActiveDocument.ALCEngine().GraphAliasCount; i++)

{

zenOn.IALCGraphAlias alcAlias = this.ActiveDocument.ALCEngine().GraphAliasItem(i);

this.Parent.DebugPrint(string.Format("ID: {0}; Type: {1}; Picture: {2}", alcAlias.ElementID, alcAlias.Type, alcAlias.Picture), zenOn.tpDebugPrintStyle.tpNrm);

}

}

VB.NET

'

' * Iterate all ALCGraph aliases using the GraphAliasCount property. this.ActiveDocument is the active workspace

' * Create an instance of the zenOn.IALCGraphAlias to collect a Graph element on index

' * Print the output using the output window, use: this.Parent.DebugPrint().

'

Public Sub Macro_GraphAlias()

For i As Integer = 0 To Me.ActiveDocument.ALCEngine().GraphAliasCount - 1

Dim alcAlias As zenOn.IALCGraphAlias = Me.ActiveDocument.ALCEngine().GraphAliasItem(i)

Me.Parent.DebugPrint(String.Format("ID: {0}; Type: {1}; Picture: {2}", alcAlias.ElementID, alcAlias.Type, alcAlias.Picture), zenOn.tpDebugPrintStyle.tpNrm)

Next

End Sub

VBA

Other topics in this chapter

ALCGraphAlias-Properties


ALCGraphAlias-Properties

Manual -> Programming interfaces -> Objectmodel -> ALCGraphAlias -> ALCGraphAlias-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | ElementID | Returns the ID of the element the edge is connected with. | read only | read only
BSTR | ElementRef | Returns the reference name of the element the edge is connected with. | read only | read only
IALCGraphElem | OriginalGraphElem | Returns the original ALC element. | read only | read only
BSTR | Picture | Returns the name of the picture the element is located in. | read only | read only
tpALCType | Type | Returns the type of this ALC edge. | read only | read only

Other topics in this chapter

OriginalGraphElem

Type

Picture

ElementID

ElementRef


OriginalGraphElem

Manual -> Programming interfaces -> Objectmodel -> ALCGraphAlias -> ALCGraphAlias-Properties -> OriginalGraphElem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OriginalGraphElem() As ALCGraphElem

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Type

Manual -> Programming interfaces -> Objectmodel -> ALCGraphAlias -> ALCGraphAlias-Properties -> Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Type() As tpALCType

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Picture

Manual -> Programming interfaces -> Objectmodel -> ALCGraphAlias -> ALCGraphAlias-Properties -> Picture

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Picture() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ElementID

Manual -> Programming interfaces -> Objectmodel -> ALCGraphAlias -> ALCGraphAlias-Properties -> ElementID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ElementID() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ElementRef

Manual -> Programming interfaces -> Objectmodel -> ALCGraphAlias -> ALCGraphAlias-Properties -> ElementRef

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ElementRef() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ALCGraphElem

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this object you have the opportunity to get line and procedural elements via an index or from specific Screens and specific Element IDs.

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

/*

* Iterate all ALCGraph elements using the GraphElemCount property. this.ActiveDocument is the active workspace

* Create an instance of the zenOn.IALCGraphElem to collect a Graph element on index

* Print the output using the output window, use: this.Parent.DebugPrint().

*/

public void Macro_GraphElem()

{

for (int i = 0; i < this.ActiveDocument.ALCEngine().GraphElemCount; i++)

{

zenOn.IALCGraphElem alcElem = this.ActiveDocument.ALCEngine().GraphElemItem(i);

this.Parent.DebugPrint(string.Format("ID: {0}; Type: {1}; Picture: {2}", alcElem.ElementID, alcElem.Type, alcElem.Picture), zenOn.tpDebugPrintStyle.tpNrm);

}

}

VB.NET

'

' * Iterate all ALCGraph elements using the GraphElemCount property. this.ActiveDocument is the active workspace

' * Create an instance of the zenOn.IALCGraphElem to collect a Graph element on index

' * Print the output using the output window, use: this.Parent.DebugPrint().

'

Public Sub Macro_GraphElem()

For i As Integer = 0 To Me.ActiveDocument.ALCEngine().GraphElemCount - 1

Dim alcElem As zenOn.IALCGraphElem = Me.ActiveDocument.ALCEngine().GraphElemItem(i)

Me.Parent.DebugPrint(String.Format("ID: {0}; Type: {1}; Picture: {2}", alcElem.ElementID, alcElem.Type, alcElem.Picture), zenOn.tpDebugPrintStyle.tpNrm)

Next

End Sub

VBA

Other topics in this chapter

ALCGraphElem-Properties

ALCGraphElem-Methods


ALCGraphElem-Properties

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | ElementID | Returns the ID of the element the edge is connected with. | read only | read only
BSTR | ElementRef | Returns the reference name of the element the edge is connected with. | read only | read only
double | Length | Returns the length | read only | read only
long | LoadType | Returns the load type | read only | read only
double | LoadVal | Returns the fixed load value | read only | read only
long | MaxIType | Returns the maximal current type | read only | read only
double | MaxIVal | Returns the fixed maximal current | read only | read only
long | Node1Count | Returns the number of elements connected to first node. | read only | read only
long | Node2Count | Returns the number of elements connected to second node. | read only | read only
BSTR | Picture | Returns the name of the picture the element is located in. | read only | read only
double | React | Returns the reactance | read only | read only
double | Resist | Returns the resistance | read only | read only
long | ReverseSourceID | Returns the reverse Source ID if the edge is of type Trafo. | read only | read only
long | SourceID | Returns the Source ID if the edge is of type Source or Trafo. | read only | read only
tpALCType | Type | Returns the type of this ALC edge. | read only | read only
IVariable | VarCalcI | Returns the variable for calculated current | read only | read only
IVariable | VarCurI | Returns the variable for actual current | read only | read only
IVariable | VarCurP | Returns the variable for actual power | read only | read only
IVariable | Variable | Returns the attached Variable if the edge is of type Source or Switch. | read only | read only
IVariable | VarLoad | Returns the variable for load value | read only | read only
IVariable | VarMaxI | Returns the variable for maximal current | read only | read only
IVariable | VarProtReact | Returns the variable for protection reactance | read only | read only

Other topics in this chapter

Node1Count

Node2Count

Type

SourceID

ReverseSourceID

Variable

Picture

ElementID

ElementRef

VarProtReact

MaxIType

MaxIVal

VarMaxI

VarCurI

VarCalcI

VarCurP

LoadType

LoadVal

VarLoad

React

Resist

Length


Node1Count

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> Node1Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Node1Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Node2Count

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> Node2Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Node2Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Type

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Type() As tpALCType

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


SourceID

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> SourceID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SourceID() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ReverseSourceID

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> ReverseSourceID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ReverseSourceID() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Variable

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> Variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Variable() As Variable

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Picture

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> Picture

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Picture() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ElementID

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> ElementID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ElementID() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ElementRef

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> ElementRef

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ElementRef() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


VarProtReact

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> VarProtReact

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

VarProtReact() As Variable

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


MaxIType

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> MaxIType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MaxIType() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


MaxIVal

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> MaxIVal

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MaxIVal() As double

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


VarMaxI

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> VarMaxI

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

VarMaxI() As Variable

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


VarCurI

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> VarCurI

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

VarCurI() As Variable

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


VarCalcI

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> VarCalcI

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

VarCalcI() As Variable

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


VarCurP

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> VarCurP

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

VarCurP() As Variable

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


LoadType

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> LoadType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

LoadType() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


LoadVal

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> LoadVal

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

LoadVal() As double

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


VarLoad

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> VarLoad

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

VarLoad() As Variable

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


React

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> React

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

React() As double

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Resist

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> Resist

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Resist() As double

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Length

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Properties -> Length

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Length() As double

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ALCGraphElem-Methods

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IALCGraphElem | Node1Item | Returns the the element connected to first node at the given index. | read only | read only
IALCGraphElem | Node2Item | Returns the the element connected to second node at the given index. | read only | read only

Other topics in this chapter

Node1Item

Node2Item


Node1Item

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Methods -> Node1Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Node1Item(long lIndex) As ALCGraphElem

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Node2Item

Manual -> Programming interfaces -> Objectmodel -> ALCGraphElem -> ALCGraphElem-Methods -> Node2Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Node2Item(long lIndex) As ALCGraphElem

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ALCNode

Manual -> Programming interfaces -> Objectmodel -> ALCNode

Remarks

With this object you have the opportunity to get informations about the line and procedural elements of a single node in your topology.

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

public void MacroAlcNode()

{

IALCEngine zenonAlcEngine = this.ALCEngine();

//Get the first node of the project

IALCNode zenonAlcNode = zenonAlcEngine.NodeItem(2);

//Return the number of procedural devices which are connected to the node

MessageBox.Show("Number of connected procedural elements: " + zenonAlcNode.EdgeCount);

//Return one of the connected procedural elements

IALCEdge zenonAlcEdge = zenonAlcNode.EdgeItem(0);

//Return type of the connected procedural element

MessageBox.Show(zenonAlcEdge.Type.ToString());

//Return ID of the link connected to the node

MessageBox.Show("Link iD: " + zenonAlcNode.LinkID);

}

VB.NET

Public Sub MacroAlcNode()

Dim zenonAlcEngine As IALCEngine = Me.ALCEngine()

'Get the first node of the project

Dim zenonAlcNode As IALCNode = zenonAlcEngine.NodeItem(2)

'Return the number of procedural devices which are connected to the node

MessageBox.Show("Number of connected procedural elements: " + zenonAlcNode.EdgeCount)

'Return one of the connected procedural elements

Dim zenonAlcEdge As IALCEdge = zenonAlcNode.EdgeItem(0)

'Return type of the connected procedural element

MessageBox.Show(zenonAlcEdge.Type.ToString())

'Return ID of the link connected to the node

MessageBox.Show("Link iD: " + zenonAlcNode.LinkID)

End Sub

VBA

Sub ALCNode()

Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcNode As ALCNode 'Child object from type ALCEngine
Dim zAlcEdge As ALCEdge 'Child object from type ALCEngine
Dim CountElements As Long
Dim LineStates As Variant
Dim i As Integer

'Get ALCEngine data from the project
Set zAlcEngine = thisProject.ALCEngine
'Get the first node of the project
Set zAlcNode = zAlcEngine.NodeItem(2)

'Return the number of procedural devices which are connected to the node
MsgBox "Number of connected procedural elements = " & zAlcNode.EdgeCount
'Return one of the connected procedural elements
Set zAlcEdge = zAlcNode.EdgeItem(0)
'Return type of connected procedural element
If zAlcEdge.Type = 0 Then
MsgBox "Type = tpALCTypeNode"
ElseIf zAlcEdge.Type = 1 Then
MsgBox "Type = tpALCTypeSource"
ElseIf zAlcEdge.Type = 2 Then
MsgBox "Type = tpALCTypeSwitch"
ElseIf zAlcEdge.Type = 3 Then
MsgBox "Type = tpALCTypeSink"
ElseIf zAlcEdge.Type = 4 Then
MsgBox "Type = tpALCTypeTrafo"
ElseIf zAlcEdge.Type = 5 Then
MsgBox "Type = tpALCTypeLink"
End If

'Return number of line elements which are connected to the node
CountElements = UBound(zAlcNode.ElementIDs)
MsgBox "Number of connected line elements = " & CountElements

'Print current states of a node
If (IsEmpty(zAlcNode.LineStates)) Then
Debug.Print "No line state active"
Else
LineStates = zAlcNode.LineStates
For i = 0 To UBound(LineStates)
Debug.Print "State " & i & " = " & LineStates(i)
Next i
End If

'Return link ID if a link (procedural element) is connected to the node
MsgBox "Link ID = " & zAlcNode.LinkID

End Sub

Other topics in this chapter

ALCNode-Properties

ALCNode-Methods


ALCNode-Properties

Manual -> Programming interfaces -> Objectmodel -> ALCNode -> ALCNode-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | EdgeCount | Returns the number of edges connected to this node. | read only | read only
VARIANT | ElementIDs | Returns the IDs of the elements the Node is connected with. | read only | read only
VARIANT | ElementRefs | Returns the reference names of the elements the Node is connected with. | not used | available
VARIANT | LineStates | Returns the all line states at this node. | not used | read only
long | LinkID | Returns the ID of the linked Source. | read only | read only
VARIANT | Pictures | Returns the names of the pictures the Node is in. | read only | read only

Other topics in this chapter

EdgeCount

LineStates

LinkID

Pictures

ElementIDs

ElementRefs


EdgeCount

Manual -> Programming interfaces -> Objectmodel -> ALCNode -> ALCNode-Properties -> EdgeCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the number of procedural devices which are connected to the node.

Datatype

EdgeCount() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


LineStates

Manual -> Programming interfaces -> Objectmodel -> ALCNode -> ALCNode-Properties -> LineStates

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a set of ALC states which are currently active in runtime. These states are a declared in the zenOn project settings at the "Automatic Line Coloring" property.

Datatype

LineStates() As VARIANT

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


LinkID

Manual -> Programming interfaces -> Objectmodel -> ALCNode -> ALCNode-Properties -> LinkID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the ID of a projected link (procedural element) which is available for this node.

Datatype

LinkID() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Pictures

Manual -> Programming interfaces -> Objectmodel -> ALCNode -> ALCNode-Properties -> Pictures

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a set of pictures where the line elements of the node are projected. This is helpful when links (procedural elements) are projected and so one node is extracted over many pictures.

Datatype

Pictures() As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ElementIDs

Manual -> Programming interfaces -> Objectmodel -> ALCNode -> ALCNode-Properties -> ElementIDs

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a set of IDs of the line elements which are connected to the node.

Datatype

ElementIDs() As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ElementRefs

Manual -> Programming interfaces -> Objectmodel -> ALCNode -> ALCNode-Properties -> ElementRefs

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ElementRefs() As VARIANT

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


ALCNode-Methods

Manual -> Programming interfaces -> Objectmodel -> ALCNode -> ALCNode-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IALCEdge | EdgeItem | Returns the ALC edge at the given index. | available | available

Other topics in this chapter

EdgeItem


EdgeItem

Manual -> Programming interfaces -> Objectmodel -> ALCNode -> ALCNode-Methods -> EdgeItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns an object from type "ALCEdge". You have the opportunity to get one of the procedural elements which are connected to the node.

Datatype

EdgeItem(long lIndex) As ALCEdge

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

Select one of the connected procedural elements. With the "EdgeCount" property you see how many elements are connected (counting starts at 0).

VBA

lIndex As Long

Examples

VBA

Sub EdgeItem()

Dim zAlcEngine As ALCEngine 'Object from type ALCEngine
Dim zAlcNode As ALCNode 'Child object from type ALCEngine
Dim zAlcEdge As ALCEdge 'Child object from type ALCEngine

'Get ALCEngine data from the project
Set zAlcEngine = thisProject.ALCEngine
'Get the first line element of the project
Set zAlcNode = zAlcEngine.NodeItem(0)

'Return the number of procedural devices which are connected to the node
MsgBox "Number of connected procedural elements = " & zAlcNode.EdgeCount
'Return one of the connected procedural elements
Set zAlcEdge = zAlcNode.EdgeItem(0)
'Return type of connected procedural element
If zAlcEdge.Type = 0 Then
MsgBox "Type = tpALCTypeNode"
ElseIf zAlcEdge.Type = 1 Then
MsgBox "Type = tpALCTypeSource"
ElseIf zAlcEdge.Type = 2 Then
MsgBox "Type = tpALCTypeSwitch"
ElseIf zAlcEdge.Type = 3 Then
MsgBox "Type = tpALCTypeSink"
ElseIf zAlcEdge.Type = 4 Then
MsgBox "Type = tpALCTypeTrafo"
ElseIf zAlcEdge.Type = 5 Then
MsgBox "Type = tpALCTypeLink"
End If

End Sub


Application

Manual -> Programming interfaces -> Objectmodel -> Application

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Includes the whole application of the control system. This is the only object in the hierarchy, that can be used by the internal function GetObject of Visual Basic. You can only use GetObject, if the Runtime of the control system is already running.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

/* NOTE:

* Uses Reference System.Windows.Forms to display messages via System.Windows.Forms.MessageBox

* Make sure the reference is added and the namespace is included for the working code file

*/

public void MacroGetProjects()

{

//Use a string builder to generate a list of gathered information

StringBuilder buildResult = new StringBuilder();

buildResult.AppendLine(string.Format("Active Project: {0}", this.ActiveDocument.Name));

buildResult.AppendLine("Projects in Workspace:");

//Iterate through every single project and add its name to the string builder

for(int i = 0; i < Application.Projects().Count; ++i)

{

zenOn.IProject zenonProject = Application.Projects().Item(i);

if (zenonProject != null)

buildResult.AppendLine(zenonProject.Name);

}

MessageBox.Show(buildResult.ToString(), "GetProjects", MessageBoxButtons.OK);

}

VB.NET

' NOTE:

' * Uses Reference System.Windows.Forms to display messages via System.Windows.Forms.MessageBox

' * Make sure the reference is added and the namespace is included for the working code file

'

Public Sub MacroGetProjects()

'Use a string builder to generate a list of gathered information

Dim buildResult As New StringBuilder()

buildResult.AppendLine(String.Format("Active Project: {0}", Me.ActiveDocument.Name))

buildResult.AppendLine("Projects in Workspace:")

'Iterate through every single project and add its name to the string builder

For i As Integer = 0 To Application.Projects().Count - 1

Dim zenonProject As zenOn.IProject = Application.Projects().Item(i)

If zenonProject IsNot Nothing Then

buildResult.AppendLine(zenonProject.Name)

End If

Next

MessageBox.Show(buildResult.ToString(), "GetProjects", MessageBoxButtons.OK)

End Sub

VBA

Public Sub GetProjects()
Dim strResult As String
Dim zPROJECT As Project
Dim i As Integer

'get active project...
strResult = "Active Project: " & MyWorkspace.ActiveDocument.Name & vbCrLf & vbCrLf
'get projects in workspace...
strResult = strResult & "Projects in Workspace:" & vbCrLf
For i = 0 To ApplicationED.Projects.Count - 1
Set zPROJECT = ApplicationED.Projects.Item(i)
If Not zPROJECT Is Nothing Then
strResult = strResult & zPROJECT.Name & vbCrLf
End If
Next i
'Show Result in a Messagebox
MsgBox strResult, vbInformation, "GetProjects"
End Sub

Other topics in this chapter

Application-Properties

Application-Methods

Application-Events


Application-Properties

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
BSTR | Computer |  | available | available | yes | yes
VARIANT_BOOL | Enabled |  | available | available | yes | yes
VARIANT_BOOL | Hide |  | available | available | yes | yes
OLE_HANDLE | hWnd |  | available | available | yes | yes
VARIANT_BOOL | IsElementWizard | For internal use only | not used | not used | yes | yes
IZenWorkspace | MyWorkspace | Returns the ZenWorkspace object (Editor Only). | read only | not used | yes | yes
BSTR | Name |  | available | available | yes | yes
BSTR | Path |  | available | available | yes | yes
long | RunState | Returns the Application run state. | read only | read only | yes | yes
BSTR | Version |  | available | available | yes | yes
long | VersionNumber | Returns the Application version. | read only | read only | yes | yes
VARIANT | WizardResult | For internal use only | not used | not used | yes | yes

Other topics in this chapter

Hide

Path

hWnd

Enabled

Name

Version

VersionNumber

Computer

RunState

WizardResult

IsElementWizard

MyWorkspace


Hide

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Properties -> Hide

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property returns/sets the visibility of the main window. If the value is True, the main window is hidden. With the value False the main window is shown again.The sample listed below accesses the object Application of the control system from an external application and hides/shows the main window depending of the status.

Datatype

Hide() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub zenOnHide()
Dim obZenOn As zenOn.Application
'Get existing Object (zenOn Runtime)
Set obZenOn = GetObject(, "zenOn.Application")
If (obZenOn Is Nothing) Then
MsgBox "zenOn Runtime not running"
Exit Sub
End If
'Hide/Show Application...
obZenOn.Hide = Not m_obZenOn.Hide
End Sub


Path

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Properties -> Path

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property returns the path from which the application was started. The name of the application is added to the path.For Example:C:\Program Files\COPA-DATA\zenOn620\zenrt32.exe

Datatype

Path() As String

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


hWnd

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Properties -> hWnd

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property returns the handle of the main window of the application. The handle mostly is needed for API calls, e.g. to send messages to the window.

Datatype

hWnd() As OLE_HANDLE

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Enabled

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Properties -> Enabled

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Sets the visibility of the application main window. This property can be read as well as written. If the value is set to False, the window is deactivated. Thus online operation, e.g. switching pictures in the Runtime, is prevented.As a default the value is set to True. In this case online operation is possible.The example listed below accesses the object Application of the control system from an external application and de/activates the main window depending of the status.

Datatype

Enabled() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub zenOnEnable()
Dim obZenOn As zenOn.Application
'Get existing Object (zenOn Runtime)
Set obZenOn = GetObject(, "zenOn.Application")
If (obZenOn Is Nothing) Then
MsgBox "zenOn Runtime not active"
Exit Sub
End If
'Enable/Disable Main Window...
obZenOn.Enabled = Not obZenOn.Enabled
End Sub


Name

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property returns the name of the application.

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Version

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Properties -> Version

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property returns the version of the application.

Datatype

Version() As String

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


VersionNumber

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Properties -> VersionNumber

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

VersionNumber() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Computer

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Properties -> Computer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property returns the name of the computer on which the Runtime is running.

Datatype

Computer() As String

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


RunState

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Properties -> RunState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

RunState() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


WizardResult

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Properties -> WizardResult

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

WizardResult() As VARIANT

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes


IsElementWizard

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Properties -> IsElementWizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

IsElementWizard() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes


MyWorkspace

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Properties -> MyWorkspace

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the Workspace object.

Datatype

MyWorkspace() As ZenWorkspace

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes


Application-Methods

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | Activate | - | available | available
void | Close | - | available | available
void | DebugPrint | - | available | not used
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
void | MDIChild | For internal use only | not used | not used
void | Modeless | For internal use only | available | available
void | PrepareModeless | For internal use only | available | available
IProjects | Projects | - | available | available
BSTR | zenOnPath [GET] | - | read only | read only
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

Projects

Close

Activate

PrepareModeless

Modeless

MDIChild

zenOnPath [GET]

DebugPrint


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

VBA

bsPath As String


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.
Example: "NetActive"

VBA

bsPath As String

Examples

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.
Example: "NetActive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

VBA

bsPath As String

vValue As Variant


Projects

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Methods -> Projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the collection of projects loaded in the Runtime (object Application). With this projectlist the loaded projects can be accessed. The collection Projects can be accessed directly or it can be stored in a temporary variable.Each project is offered as Project object in VBA (IProject in VSTA).

Datatype

Projects() As Projects

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

//Iterate through all projects and create the runtime files

public void MacroCreateAllRuntimeFiles()

{

for (int i = 0; i < Application.Projects().Count; ++i)

{

zenOn.IProject zenonProject = Application.Projects().Item(i);

try

{

//tpAll re-creates every single runtime file in the project

zenonProject.Build(zenOn.tpBuildMethod.tpAll);

}

catch (Exception ex)

{

this.Parent.DebugPrint(string.Format("Error while creating project {0} | Error Message: {1}",

zenonProject.Name, ex.Message), zenOn.tpDebugPrintStyle.tpErr);

throw;

}

}

}

VB.NET

'Iterate through all projects and create the runtime files

Public Sub MacroCreateAllRuntimeFiles()

For i As Integer = 0 To Application.Projects().Count - 1

Dim zenonProject As zenOn.IProject = Application.Projects().Item(i)

Try

'tpAll re-creates every single runtime file in the project

zenonProject.Build(zenOn.tpBuildMethod.tpAll)

Catch ex As Exception

Me.Parent.DebugPrint(String.Format("Error while creating project {0} | Error Message: {1}", zenonProject.Name, ex.Message), zenOn.tpDebugPrintStyle.tpErr)

Throw

End Try

Next

End Sub

VBA

'create all runtime files for all projects in the workspace...
Public Sub CreateAllRuntimeFiles()
Dim i As Integer
On Error Resume Next
For i = 0 To ApplicationED.Projects.Count - 1
ApplicationED.Projects.Item(i).Build tpAll
Next i
End Sub


Close

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Methods -> Close

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Closes the application.

Datatype

Close() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

//This Macro will simply close the zenon application

public void MacroCloseApplication()

{

Application.Close();

}

VB.NET

'This Macro will simply close the zenon application

Public Sub MacroCloseApplication()

Application.Close()

End Sub


Activate

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Methods -> Activate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method switches the main window of the application to the foreground (if this is not already the case).

Datatype

Activate() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

/* NOTE:

* Uses Reference System.Windows.Forms to display messages via System.Windows.Forms.MessageBox

* Make sure the reference is added and the namespace is included for the working code file

*/

void ThisProject_Active()

{

this.Alarm().AlarmComes += new AlarmComesEventHandler(ThisProject_AlarmComes);

}

void ThisProject_AlarmComes(IAlarmItem obItem)

{

//this.Parent.Parent is the actual Application object. for further details check the

//class diagram for the zenOn API object model

this.Parent.Parent.Activate();

}

void ThisProject_Inactive()

{

this.Alarm().AlarmComes -= new AlarmComesEventHandler(ThisProject_AlarmComes);

FreeObjects();

}

VB.NET

' NOTE:

' * Uses Reference System.Windows.Forms to display messages via System.Windows.Forms.MessageBox

' * Make sure the reference is added and the namespace is included for the working code file

'

Private Sub ThisProject_Active()

Me.Alarm().AlarmComes += New AlarmComesEventHandler(AddressOf ThisProject_AlarmComes)

End Sub

Private Sub ThisProject_AlarmComes(obItem As IAlarmItem)

'this.Parent.Parent is the actual Application object. for further details check the

'class diagram for the zenOn API object model

Me.Parent.Parent.Activate()

End Sub

Private Sub ThisProject_Inactive()

Me.Alarm().AlarmComes -= New AlarmComesEventHandler(AddressOf ThisProject_AlarmComes)

FreeObjects()

End Sub


PrepareModeless

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Methods -> PrepareModeless

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method is part of the zenOn API only for compatability reasons. It serves no purpose at all and will instantly return.

Datatype

PrepareModeless(String strFormName, VARIANT strProjectName) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Modeless

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Methods -> Modeless

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method is part of the zenOn API only for compatability reasons. It serves no purpose at all and will instantly return.

Datatype

Modeless(IDispatch dispUserForm) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


MDIChild

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Methods -> MDIChild

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method is part of the zenOn API only for compatability reasons. It serves no purpose at all and will instantly return.

Datatype

MDIChild(IDispatch dispUserForm) As void

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes


zenOnPath [GET]

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Methods -> zenOnPath [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

zenOnPath(tpZenPathType lPath) As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

Number or Constant

VBA

lPath As tpZenPathType

Examples

C#

public void MacroOpenZenonFolder()

{

//Gets the (user) path of the zenOn application

string folder = this.Application.get_zenOnPath(tpZenPathType.tpzenOnUserPath);

//Opens the folder in a new explorer window or prints an error.

try

{

System.Diagnostics.Process.Start(folder);

}

catch (Exception ex)

{

this.Application.DebugPrint("Error opening user path: " + ex.Message, tpDebugPrintStyle.tpErr);

}

}

VB.NET

Public Sub MacroOpenZenonFolder()

'Gets the (user) path of the zenOn application

Dim folder As String = Me.Application.get_zenOnPath(tpZenPathType.tpzenOnUserPath)

'Opens the folder in a new explorer window or prints an error.

Try

System.Diagnostics.Process.Start(folder)

Catch ex As Exception

Me.Application.DebugPrint("Error opening user path: " + ex.Message, tpDebugPrintStyle.tpErr)

End Try

End Sub


DebugPrint

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Methods -> DebugPrint

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Sends a message to the output window of the editor.

Datatype

DebugPrint(String bsText,tpDebugPrintStyle tpStyle) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

public void MacroDebugPrintExample()

{

//Use different channels of the debug output to print some text

this.Application.DebugPrint("this is a normal text", tpDebugPrintStyle.tpNrm);

this.Application.DebugPrint("this is a warning", tpDebugPrintStyle.tpWarn);

this.Application.DebugPrint("this is an informative text", tpDebugPrintStyle.tpMsg);

this.Application.DebugPrint("this is an error", tpDebugPrintStyle.tpErr);

}

VB.NET

Public Sub MacroDebugPrintExample()

'Use different channels of the debug output to print some text

Me.Application.DebugPrint("this is a normal text", tpDebugPrintStyle.tpNrm)

Me.Application.DebugPrint("this is a warning", tpDebugPrintStyle.tpWarn)

Me.Application.DebugPrint("this is an informative text", tpDebugPrintStyle.tpMsg)

Me.Application.DebugPrint("this is an error", tpDebugPrintStyle.tpErr)

End Sub


Application-Events

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
void | OnClose |  | available | available | yes | yes

Other topics in this chapter

OnClose


OnClose

Manual -> Programming interfaces -> Objectmodel -> Application -> Application-Events -> OnClose

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnClose() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

/* NOTE:

* Uses Reference System.Windows.Forms to display messages via System.Windows.Forms.MessageBox

* Make sure the reference is added and the namespace is included for the working code file

*/

void ThisProject_Active()

{

this.Parent.Parent.OnClose += new OnCloseEventHandler(Parent_OnClose);

}

void Parent_OnClose()

{

//When the runtime is about to be closed a message box will be displayed.

MessageBox.Show("The application is about to be closed!");

}

void ThisProject_Inactive()

{

this.Parent.Parent.OnClose -= new OnCloseEventHandler(Parent_OnClose);

FreeObjects();

}

VB.NET

Imports System.Windows.Forms 'NOTE: The reference System.Windows.Forms has to be included into the reference list.

Private Sub ThisProject_Active()

AddHandler Me.Parent.OnClose, AddressOf Parent_OnClose

End Sub

Private Sub Parent_OnClose()

'When the runtime is about to be closed a message box will be displayed.

MessageBox.Show("The application is about to be closed!")

End Sub

Private Sub ThisProject_Inactive()

RemoveHandler Me.Parent.OnClose, AddressOf Parent_OnClose

FreeObjects()

End Sub


Archive

Manual -> Programming interfaces -> Objectmodel -> Archive

Remarks

The "Archive" object contains project information like the name, the source archive and other properties. The archive also is the basis for "ArchiveVariables" and "ArchiveFilters".The "ArchiveVariables" object contains all archive variables. Each archive variable contains further projecting information.With the "ArchiveFilters" object you can define and execute dynamic filters. In a filter you can define the variables from which you need the values. Additionally you can define the time period and the status. On executing the filter you get a list with all Runtime variables for that filter.

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

public void MacroZenOnArchive()

{

//Gets the first archive of the project

IArchive zenonArchive = this.Archives().Item(0);

if (zenonArchive == null)

{

//There is no archive, the user will be informed...

this.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr);

return;

}

//There is an archive, output some details on it

this.Parent.Parent.DebugPrint("Name: " + zenonArchive.Name, tpDebugPrintStyle.tpMsg);

this.Parent.Parent.DebugPrint("Type: " + zenonArchive.Type.ToString(), tpDebugPrintStyle.tpMsg);

this.Parent.Parent.DebugPrint("Term: " + zenonArchive.LongName,tpDebugPrintStyle.tpMsg);

this.Parent.Parent.DebugPrint("ID: " + zenonArchive.ID, tpDebugPrintStyle.tpMsg);

}

VB.NET

Public Sub MacroZenOnArchive()

'Gets the first archive of the project

Dim zenonArchive As IArchive = Me.Archives().Item(0)

If zenonArchive Is Nothing Then

'There is no archive, the user will be informed...

Me.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr)

Return

End If

'There is an archive, output some details on it

Me.Parent.Parent.DebugPrint("Name: " + zenonArchive.Name, tpDebugPrintStyle.tpMsg)

Me.Parent.Parent.DebugPrint("Type: " & zenonArchive.Type.ToString(), tpDebugPrintStyle.tpMsg)

Me.Parent.Parent.DebugPrint("Term: " + zenonArchive.LongName, tpDebugPrintStyle.tpMsg)

Me.Parent.Parent.DebugPrint("ID: " + zenonArchive.ID, tpDebugPrintStyle.tpMsg)

End Sub

VBA

Sub zenOn_Archive()
'Declarations
Dim zArchive As Archive

'Initialize zArchive with the first available archive
Set zArchive = thisProject.Archives.Item(0)

'If no archive is available ...
If zArchive Is Nothing Then
'... then inform the user
MsgBox ("No archive available!")

'Otherwise, output some details on the archive
Else
'Output the name
Debug.Print "Name: " & zArchive.Name
'Output the type
Select Case zArchive.Type
Case Is = 1
Debug.Print vbTab & "Type: Cyclic scanning"
'Output the cycle rate, if the archive is cyclic
Debug.Print vbTab & "Cycle rate: " & zArchive.Cycle
Case Is = 2
Debug.Print vbTab & "Type: Event-triggered scanning"
Case Is = 3
Debug.Print vbTab & "Type: Spontaneous scanning"
End Select

'Output the term
Debug.Print vbTab & "Term: " & zArchive.LongName
'Output the ID
Debug.Print vbTab & "ID: " & zArchive.ID
End If
End Sub

Other topics in this chapter

Archive-Properties

Archive-Methods


Archive-Properties

Manual -> Programming interfaces -> Objectmodel -> Archive -> Archive-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
BSTR | Name | Two-character unique short identifier of the archive; Relevant for automatic issuing of names with export functions; (CAUTION: Release of the other input fields occurs only after input of the short identifier) | not used | read only | yes | yes
long | Cycle | Reading in of the values is done cyclically by the system (days, hours, minutes and seconds) | not used | read only | yes | yes
long | ID |  | not used | read only | yes | yes
BSTR | Identifier | Returns the archive identifier. | not used | read only | yes | yes
BSTR | LongName | For internal use only | not used | read only | yes | yes
IArchives | Parent |  | not used | read only | yes | yes
short | Type |  | not used | read only | yes | yes

Other topics in this chapter

Parent

ID

Name

Type

Cycle

LongName

Identifier


Parent

Manual -> Programming interfaces -> Objectmodel -> Archive -> Archive-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Archives

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ID

Manual -> Programming interfaces -> Objectmodel -> Archive -> Archive-Properties -> ID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the unique ID of the current archive.

Datatype

ID() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> Archive -> Archive-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the name of the current "Archive" object.

Datatype

Name() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Type

Manual -> Programming interfaces -> Objectmodel -> Archive -> Archive-Properties -> Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Type() As short

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Cycle

Manual -> Programming interfaces -> Objectmodel -> Archive -> Archive-Properties -> Cycle

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the cycle rate of the current archive in seconds.Hint: In the case of an event-triggered or spontaneous scanning archive, this property will return 0.

Datatype

Cycle() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


LongName

Manual -> Programming interfaces -> Objectmodel -> Archive -> Archive-Properties -> LongName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the identificator, also called "term" within zenOn, of the current archive.

Datatype

LongName() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Identifier

Manual -> Programming interfaces -> Objectmodel -> Archive -> Archive-Properties -> Identifier

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the identificator, also called "term" within zenOn, of the current archive.

Datatype

Identifier() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Archive-Methods

Manual -> Programming interfaces -> Objectmodel -> Archive -> Archive-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IArchiveFilters | ArchiveFilters | - | not used | available
IArchiveVariables | ArchiveVariables | - | not used | available
VARIANT | BatchIndex [GET] | Returns the batchinformation of the archive. | not used | read only
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

BatchIndex [GET]

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

ArchiveFilters

ArchiveVariables


BatchIndex [GET]

Manual -> Programming interfaces -> Objectmodel -> Archive -> Archive-Methods -> BatchIndex [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the index of the archive.

Datatype

BatchIndex() As VARIANT

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> Archive -> Archive-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> Archive -> Archive-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> Archive -> Archive-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.
Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> Archive -> Archive-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.
Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


ArchiveFilters

Manual -> Programming interfaces -> Objectmodel -> Archive -> Archive-Methods -> ArchiveFilters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a collection ("ArchiveFilters" object) of all available filters. It is also possible to create new filters and delete existing ones.Hint: For further information, please have a look at the "ArchiveFilters" part.

Datatype

ArchiveFilters() As ArchiveFilters

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ArchiveVariables

Manual -> Programming interfaces -> Objectmodel -> Archive -> Archive-Methods -> ArchiveVariables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a collection ("ArchiveVariables" object) with all assigned archive variables.Hint: For further information, please have a look, at the "ArchiveVariables" part.

Datatype

ArchiveVariables() As ArchiveVariables

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ArchiveED

Manual -> Programming interfaces -> Objectmodel -> ArchiveED

Remarks

The "ArchiveED" object contains project information like the name, the source archive and other properties.It is used within the editor in order to initialize the archive. Hence, the object won't be available in the runtime. In the "Archive" object, which will be available in the runtime, some properties will be set to read-only. Therefore all important initialization should be done by means of the "ArchiveED" object.

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

public void MacroZenOnArchiveEd()

{

IArchiveED zenonArchiveEd = this.ActiveDocument.ArchivesED().Item("01");

/* if there is no such archive available create it with

* the given identification name "01" and the name

* "zenon_ArchiveED"

*/

if (zenonArchiveEd == null)

{

zenonArchiveEd = this.ActiveDocument.ArchivesED().

CreateArchive("01", "zenOn_ArchiveED", null);

}

//Create some settings for the Archive

zenonArchiveEd.set_DynProperties("Cyclic", 1);

zenonArchiveEd.set_DynProperties("TimeGap", 5);

zenonArchiveEd.set_DynProperties("Offset", 0);

zenonArchiveEd.set_DynProperties("Cycle", 60);

//Set the Cycle Start to 12:00 local time on the 30th of July 2007

zenonArchiveEd.set_DynProperties("CycleStart",

TimeConversion.SystemToZenOn(

new DateTime(2007, 07, 30, 12, 0, 0)));

zenonArchiveEd.AddVariable("WIZ_VAR_12", tpArvVarCal.tpCalc_All, null);

//Output the new configuration (To Debug, for example)

this.Parent.

DebugPrint("Name: " +

zenonArchiveEd.get_DynProperties("ShortName") + " - "

+ zenonArchiveEd.get_DynProperties("LongName"),

tpDebugPrintStyle.tpNrm);

this.Parent.DebugPrint("Cyclic: " +

zenonArchiveEd.get_DynProperties("Cyclic"),

tpDebugPrintStyle.tpNrm);

this.Parent.DebugPrint("Scanning cycle: " +

zenonArchiveEd.get_DynProperties("TimeGap"),

tpDebugPrintStyle.tpNrm);

this.Parent.DebugPrint("Offset: "

+ zenonArchiveEd.get_DynProperties("Offset") + " sec",

tpDebugPrintStyle.tpNrm);

this.Parent.DebugPrint("Save Cycle: " +

zenonArchiveEd.get_DynProperties("Cycle"),

tpDebugPrintStyle.tpNrm);

//We have to reconvert the internally used time stamp format to a human readable format

this.Parent.DebugPrint("Cycle start: " +

TimeConversion.ZenOnToSystem((uint)zenonArchiveEd.get_DynProperties("CycleStart")).ToString(),

tpDebugPrintStyle.tpNrm);

}

VB.NET

Public Sub MacroZenOnArchiveEd()

Dim zenonArchiveEd As IArchiveED = Me.ActiveDocument.ArchivesED().Item("01")

' if there is no such archive available create it with

' * the given identification name "01" and the name

' * "zenon_ArchiveED"

'

If zenonArchiveEd Is Nothing Then

zenonArchiveEd = Me.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", Nothing)

End If

'Create some settings for the Archive

zenonArchiveEd.set_DynProperties("Cyclic", 1)

zenonArchiveEd.set_DynProperties("TimeGap", 5)

zenonArchiveEd.set_DynProperties("Offset", 0)

zenonArchiveEd.set_DynProperties("Cycle", 60)

'Set the Cycle Start to 12:00 local time on the 30th of July 2007

zenonArchiveEd.set_DynProperties("CycleStart", TimeConversion.SystemToZenOn(New DateTime(2007, 7, 30, 12, 0, 0)))

zenonArchiveEd.AddVariable("WIZ_VAR_12", tpArvVarCal.tpCalc_All, Nothing)

'Output the new configuration (To Debug, for example)

Me.Parent.DebugPrint("Name: " & zenonArchiveEd.get_DynProperties("ShortName") & " - " & zenonArchiveEd.get_DynProperties("LongName"), tpDebugPrintStyle.tpNrm)

Me.Parent.DebugPrint("Cyclic: " & zenonArchiveEd.get_DynProperties("Cyclic"), tpDebugPrintStyle.tpNrm)

Me.Parent.DebugPrint("Scanning cycle: " & zenonArchiveEd.get_DynProperties("TimeGap"), tpDebugPrintStyle.tpNrm)

Me.Parent.DebugPrint("Offset: " & zenonArchiveEd.get_DynProperties("Offset") & " sec", tpDebugPrintStyle.tpNrm)

Me.Parent.DebugPrint("Save Cycle: " & zenonArchiveEd.get_DynProperties("Cycle"), tpDebugPrintStyle.tpNrm)

'We have to reconvert the internally used time stamp format to a human readable format

Me.Parent.DebugPrint("Cycle start: " & TimeConversion.ZenOnToSystem(CUInt(zenonArchiveEd.get_DynProperties("CycleStart"))).ToString(), tpDebugPrintStyle.tpNrm)

End Sub

VBA

Sub zenOn_ArchiveED()
'Declarations
Dim zArchiveED As ArchiveED
Dim zTimeConvert As clsTimeConvert
Dim i As Integer

'Initialize zArchiveED with the archive selected by the identification name "01"
Set zArchiveED = MyWorkspace.ActiveDocument.ArchivesED.Item("01")
'If no such archive is available ...
If zArchiveED Is Nothing Then
'... then create a whole new archive with the identification name "01" and the name "zenOn_ArchiveED"
Set zArchiveED = MyWorkspace.ActiveDocument.ArchivesED.CreateArchive("01", "zenOn_ArchiveED", Nothing)
End If

'Initialize zTimeConvert by creating a new instance of the zenOn "clsTimeConvert" macro
Set zTimeConvert = New clsTimeConvert

With zArchiveED
'Set the scanning mode: Cyclic scanning
.DynProperties("Cyclic") = 1
'Set the scanning cycle rate: 5 seconds
.DynProperties("TimeGap") = 5
'Set the offset: 0 seconds
.DynProperties("Offset") = 0
'Set the saving cycle: 60 seconds
.DynProperties("Cycle") = 60
'Set the start time of the cycle: 2007-07-30 12:00:00
.DynProperties("CycleStart") = zTimeConvert.System2zenOn(CDbl(CDate("30.07.2007 12:00:00")))
'Add the "WIZ_VAR_12" variable to the archive
.AddVariable "WIZ_VAR_12", 0, Nothing
End With

'Output the configuration
With zArchiveED
'Output the identifier and the name
Debug.Print "Name: " & .DynProperties("ShortName") & " - " & .DynProperties("LongName")
'Output the scanning mode
Debug.Print vbTab & "Cyclic: " & .DynProperties("Cyclic")
'Output the scanning cycle
Debug.Print vbTab & "Scanning cycle: " & .DynProperties("TimeGap") & " sec."
'Output the offset
Debug.Print vbTab & "Offset: " & .DynProperties("Offset") & " sec."
'Output the archive saving cycle
Debug.Print vbTab & "Save cycle: " & .DynProperties("Cycle") & " sec."
'Output the start time of the cycle
Debug.Print vbTab & "Cycle start: " & Format(zTimeConvert.zenOn2System(CDbl(.DynProperties("CycleStart"))), "yyyy-mm-dd hh:mm:ss")
End With

End Sub

Other topics in this chapter

ArchiveED-Properties

ArchiveED-Methods

ArchiveED-Dynamic properties


ArchiveED-Properties

Manual -> Programming interfaces -> Objectmodel -> ArchiveED -> ArchiveED-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IArchivesED | Parent |  | read only | read only

Other topics in this chapter

Parent


Parent

Manual -> Programming interfaces -> Objectmodel -> ArchiveED -> ArchiveED-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As ArchivesED

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ArchiveED-Methods

Manual -> Programming interfaces -> Objectmodel -> ArchiveED -> ArchiveED-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | - | read only | read only
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IArchiveVarED | Item | - | available | not used
VARIANT_BOOL | RemoveVariable | - | available | not used
IArchiveVarED | AddVariable | - | available | not used
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used
short | ImportArvTemplate |  | available | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

AddVariable

RemoveVariable

Item

Count

ImportArvTemplate


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> ArchiveED -> ArchiveED-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> ArchiveED -> ArchiveED-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.
A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> ArchiveED -> ArchiveED-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> ArchiveED -> ArchiveED-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


AddVariable

Manual -> Programming interfaces -> Objectmodel -> ArchiveED -> ArchiveED-Methods -> AddVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Adds a new Variable to the collection. The varialbe is identified by its name or ID.

Datatype

AddVariable(VARIANT vNameOrId, tpArvVarCal tpCalculation, IArchiveED* pSourceArchive) As ArchiveVarED

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MacroAddVariableArchiveED()

{

IArchiveED zenonArchiveED = this.ActiveDocument.ArchivesED().Item("01");

if (zenonArchiveED == null)

{

/* if there is no such archive available create it with

* the given identification name "01" and the name

* "zenon_ArchiveED"

*/

zenonArchiveED = this.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", null);

}

/* Add a variable to a given ArchiveED object

* Set the calculation type to All

* Set the source Archive to NULL

*/

IArchiveVarED zenonArchVar = zenonArchiveED.AddVariable("WIZ_VAR_12", tpArvVarCal.tpCalc_All, null);

if (zenonArchiveED == null)

{

//The variable "WIZ_VAR_12" is non-existant

this.Parent.DebugPrint("Variable not found!", tpDebugPrintStyle.tpMsg);

}

}

VB.NET

Public Sub MacroAddVariableArchiveED()

Dim zenonArchiveED As IArchiveED = Me.ActiveDocument.ArchivesED().Item("01")

If zenonArchiveED Is Nothing Then

' if there is no such archive available create it with

' * the given identification name "01" and the name

' * "zenon_ArchiveED"

'

zenonArchiveED = Me.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", Nothing)

End If

' Add a variable to a given ArchiveED object

' * Set the calculation type to All

' * Set the source Archive to NULL

'

Dim zenonArchVar As IArchiveVarED = zenonArchiveED.AddVariable("WIZ_VAR_12", tpArvVarCal.tpCalc_All, Nothing)

If zenonArchiveED Is Nothing Then

'The variable "WIZ_VAR_12" is non-existant

Me.Parent.DebugPrint("Variable not found!", tpDebugPrintStyle.tpMsg)

End If

End Sub

VBA

VBA-Syntax


RemoveVariable

Manual -> Programming interfaces -> Objectmodel -> ArchiveED -> ArchiveED-Methods -> RemoveVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Removes an assigned "Variable" object from the collection. The variable is identified by its name or ID.

Datatype

RemoveVariable(VARIANT vNameOrId) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MacroRemoveVariableArchiveED()

{

IArchiveED zenonArchiveED = this.ActiveDocument.ArchivesED().Item("01");

if (zenonArchiveED == null)

{

/* if there is no such archive available create it with

* the given identification name "01" and the name

* "zenon_ArchiveED"

*/

zenonArchiveED = this.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", null);

}

if (zenonArchiveED.RemoveVariable("WIZ_VAR_12"))

{

//The variable was removed correctly

this.Parent.DebugPrint("Variable removed from archive!", tpDebugPrintStyle.tpMsg);

}

else

{

//The variable was not removed correctly i.e. not found

this.Parent.DebugPrint("Variable was not found!", tpDebugPrintStyle.tpMsg);

}

}

VB.NET

Public Sub MacroRemoveVariableArchiveED()

Dim zenonArchiveED As IArchiveED = Me.ActiveDocument.ArchivesED().Item("01")

If zenonArchiveED Is Nothing Then

' if there is no such archive available create it with

' * the given identification name "01" and the name

' * "zenon_ArchiveED"

'

zenonArchiveED = Me.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", Nothing)

End If

If zenonArchiveED.RemoveVariable("WIZ_VAR_12") Then

'The variable was removed correctly

Me.Parent.DebugPrint("Variable removed from archive!", tpDebugPrintStyle.tpMsg)

Else

'The variable was not removed correctly i.e. not found

Me.Parent.DebugPrint("Variable was not found!", tpDebugPrintStyle.tpMsg)

End If

End Sub

VBA

VBA-Syntax


Item

Manual -> Programming interfaces -> Objectmodel -> ArchiveED -> ArchiveED-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an "ArchiveVarED" object from the collection, which is identified by the parameter vNameOrPos.The parameter vNameOrPos can have two values:

  • Element name:The element can be accessed with the unique name of the corresponding "Variable" object that was assigned to the "ArchiveVarED" object.
  • Index:Access with an index is mostly used in combination with the property "Count" to find out the position of the "ArchiveVarED" object in the list.

Hint: The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vNameOrPos) As ArchiveVarED

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MacroIterateArchiveED()

{

IArchiveED zenonArchiveED = this.ActiveDocument.ArchivesED().Item("01");

if (zenonArchiveED == null)

{

/* if there is no such archive available create it with

* the given identification name "01" and the name

* "zenon_ArchiveED"

*/

zenonArchiveED = this.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", null);

}

//Iterate through all archive variables and print their names

for (int i = 0; i < zenonArchiveED.Count(); ++i)

{

this.Parent.DebugPrint("Variable " + ((IVariable)zenonArchiveED.Item(i).

get_DynProperties("Variable")).Name +

" is in " + zenonArchiveED.get_DynProperties("LongName"), tpDebugPrintStyle.tpMsg);

}

}

VB.NET

Public Sub MacroIterateArchiveED()

Dim zenonArchiveED As IArchiveED = Me.ActiveDocument.ArchivesED().Item("01")

If zenonArchiveED Is Nothing Then

' if there is no such archive available create it with

' * the given identification name "01" and the name

' * "zenon_ArchiveED"

'

zenonArchiveED = Me.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", Nothing)

End If

'Iterate through all archive variables and print their names

For i As Integer = 0 To zenonArchiveED.Count() - 1

Me.Parent.DebugPrint("Variable " + DirectCast(zenonArchiveED.Item(i).get_DynProperties("Variable"), IVariable).Name & " is in " & zenonArchiveED.get_DynProperties("LongName"), tpDebugPrintStyle.tpMsg)

Next

End Sub

VBA

VBA-Syntax


Count

Manual -> Programming interfaces -> Objectmodel -> ArchiveED -> ArchiveED-Methods -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MacroIterateArchiveED()

{

IArchiveED zenonArchiveED = this.ActiveDocument.ArchivesED().Item("01");

if (zenonArchiveED == null)

{

/* if there is no such archive available create it with

* the given identification name "01" and the name

* "zenon_ArchiveED"

*/

zenonArchiveED = this.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", null);

}

//Iterate through all archive variables and print their names

for (int i = 0; i < zenonArchiveED.Count(); ++i)

{

this.Parent.DebugPrint("Variable " + ((IVariable)zenonArchiveED.Item(i).

get_DynProperties("Variable")).Name +

" is in " + zenonArchiveED.get_DynProperties("LongName"), tpDebugPrintStyle.tpMsg);

}

}

VB.NET

Public Sub MacroIterateArchiveED()

Dim zenonArchiveED As IArchiveED = Me.ActiveDocument.ArchivesED().Item("01")

If zenonArchiveED Is Nothing Then

' if there is no such archive available create it with

' * the given identification name "01" and the name

' * "zenon_ArchiveED"

'

zenonArchiveED = Me.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", Nothing)

End If

'Iterate through all archive variables and print their names

For i As Integer = 0 To zenonArchiveED.Count() - 1

Me.Parent.DebugPrint("Variable " + DirectCast(zenonArchiveED.Item(i).get_DynProperties("Variable"), IVariable).Name & " is in " & zenonArchiveED.get_DynProperties("LongName"), tpDebugPrintStyle.tpMsg)

Next

End Sub

VBA

VBA-Syntax


ImportArvTemplate

Manual -> Programming interfaces -> Objectmodel -> ArchiveED -> ArchiveED-Methods -> ImportArvTemplate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ImportArvTemplate(BSTR FileName) As short

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA

Private Sub ImportArvTemplate()

Dim obArchsED As ArchivesED

Dim obArchED As ArchiveED

Dim iRet As Integer

Set obArchsED = MyWorkspace.ActiveDocument.ArchivesED

Set obArchED = obArchsED.Item(0)

If Not obArchED Is Nothing Then

iRet = obArchED.ImportArvTemplate("C:\ProgramData\COPA-DATA\zenon711\Templates\Archives\GERMAN\6eeae916-0098-40ab-9dc9-a9ce1dcf4bb5.xml", True)

End If

End Sub


ArchiveED-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> ArchiveED -> ArchiveED-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Archive

Other topics in this chapter

Archive


Archive

Manual -> Programming interfaces -> Objectmodel -> ArchiveED -> ArchiveED-Dynamic properties -> Archive

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | ShortName | ShortName | This property gets/sets the identificator of an archive.
VT_BSTR | LongName | LongName | This property gets/sets the name of the archive.
ZT_VARIABLE | ChargeVar | ChargeVar | This property gets/sets the variable which is used as batch variable.
VT_BOOL | IsChargeIdx | IsChargeIdx | "This property gets/sets the ""index batches"" option of an batch archive. "
VT_BSTR | Format | Format | This property gets/sets the format of ASCII/dBase evacuation files.
VT_UI4 | LastIndex | LastIndex |
VT_UI4 | FktStart | FktStart | This property gets/sets the function which is linked as end function via its function ID.
VT_UI4 | FktEnd | FktEnd | This property gets/sets the function which is linked as end function via its function ID.
VT_UI2 | Modus | Modus | This property gets/sets the kind of start and stop of an archive. At start and end of runtime = 3 User defined = 2 RDA block archive = 0
VT_UI4 | CycleStart | CycleStart | This property gets/sets the cycle start time.
VT_UI4 | Cycle | Cycle | This property gets/sets the number of values which are arranged in an archive file. For example: Scan cycle of 1 second and cyclic file creation every 30 seconds sets the cycle property on value 30.
VT_BSTR | DataSource | DataSource | This property gets/sets the database provider string for the sql evacuation of the archives.
VT_BOOL | UseAzureServiceBus | UseAzureServiceBus | Description
VT_BSTR | AzureConnection | AzureConnection | Description
VT_BSTR | SourceShortName | SourceShortName | This property gets the identificatior of the head archive. It is only set when a follow archive is available.
ZT_VARIABLE | EventVar | EventVar | This property gets/sets the trigger variable of an archive.
VT_UI4 | Flags | Flags | "This property gets/sets the ""option"" settings of an archive via a bit coded value."
VT_BOOL | Unicode | Unicode | This property gets/sets the unicode flag when the saving format ASCII is used for archives.
VT_UI8 | StateF | StateF |
VT_UI8 | StateActiveF | StateActiveF |
VT_UI8 | StateFBanned | StateFBanned |
VT_UI8 | StateActiveFBanned | StateActiveFBanned |
VT_UI4 | TimeGap | TimeGap |
VT_UI4 | Offset | Offset | This property gets/sets the offset time (in sec) when cyclic scanning is used.
VT_I1 | Cyclic | Cyclic | "This property gets/sets the scanning settings of an archive. Cyclic scanning, Cycle = 9 Cyclic scanning, Monthly = 13 Event triggered scanning, Internal = 7 Event triggered scanning, External = 15 Spontaneous scanning = 14"
VT_UI4 | BeginTime | BeginTime | Returns the time an archive file is created.
VT_UI4 | FileFormat | FileFormat | "This property gets/sets the kind of archive saving format. Internal database (*.arx), no evacuation = 9 Internal database (*.arx), evacuation in internal format (*.arx) = 2049 Internal database (*.arx), evacuation in SQL database (*.arx) = 1025 Internal database (*.arx), evacuation in XML format (*.xml) = 513 Internal database (*.arx), evacuation in ASCII format (*.txt) = 33 Internal database (*.arx), evacuation in dBase IV format (*.dbf) = 33 dBase IV format (*.dbf), no evacuation = 10 ASCII file (*.txt), no evacuation = 10 XML file (*.xml), no evacuation = 264 "
VT_UI2 | Count | Count | This property gets/sets the number of archive files which are evacuated. For example: Scan cycle of 10 minutes and an evacuation storage time of 2 hours sets the count property on value 6.
VT_BOOL | AuslUnicode | AuslUnicode | This property returns if the archive is evacuated in unicode when the evacuation via ASCII is selected.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


ArchiveFilter

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The "ArchiveFilter" object is used to filter archive entries by a specified date / time and state.

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

public void MarcroZenOnArchiveFilter()

{

//Gets the first archive of the project

IArchive zenonArchive = this.Archives().Item(0);

if (zenonArchive == null)

{

//There is no archive, the user will be informed...

this.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr);

return;

}

IArchiveFilter zenonArchiveFilter = zenonArchive.ArchiveFilters().CreateArchiveFilter();

for (int i = 0; i < zenonArchive.ArchiveVariables().Count; ++i)

{

//Add every archive variable to the archive filter

zenonArchiveFilter.AddArchiveVariable(zenonArchive.ArchiveVariables().Item(i));

}

//Set the StartTime to 14:00 on the 30th of july 2007

zenonArchiveFilter.StartTime = (int)TimeConversion.

SystemToZenOn(new DateTime(2007, 07, 30, 14, 0, 0));

//Set the EndTime to 11:15 on the 31st of july 2007

zenonArchiveFilter.EndTime = (int)TimeConversion.

SystemToZenOn(new DateTime(2007,07,31,11,15,00));

zenonArchiveFilter.StatusMask = 0x41000; //Check only I-BIT + HWERT

zenonArchiveFilter.StatusBit = 0x41000; //Return data if one of those bit is true or both

//Initiate a filter query

IArchiveFilterVariables zenonArchiveVariables = zenonArchiveFilter.Query();

for (int i = 0; i < zenonArchiveVariables.Count; ++i)

{

this.Parent.Parent.DebugPrint("Variable: " + zenonArchiveVariables.Item(i).ArchiveVariable().Name, tpDebugPrintStyle.tpNrm);

this.Parent.Parent.DebugPrint("I-BIT + HWERT: " + zenonArchiveVariables.Item(i).ArchiveValues().Count, tpDebugPrintStyle.tpNrm);

}

}

VB.NET

Public Sub MarcrozenOnArchiveFilter()

'Gets the first archive of the project

Dim zenonArchive As IArchive = Me.Archives().Item(0)

If zenonArchive Is Nothing Then

'There is no archive, the user will be informed...

Me.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr)

Return

End If

Dim zenonArchiveFilter As IArchiveFilter = zenonArchive.ArchiveFilters().CreateArchiveFilter()

For i As Integer = 0 To zenonArchive.ArchiveVariables().Count - 1

'Add every archive variable to the archive filter

zenonArchiveFilter.AddArchiveVariable(zenonArchive.ArchiveVariables().Item(i))

Next

'Set the StartTime to 14:00 on the 30th of july 2007

zenonArchiveFilter.StartTime = CInt(TimeConversion.SystemToZenOn(New DateTime(2007, 7, 30, 14, 0, 0)))

'Set the EndTime to 11:15 on the 31st of july 2007

zenonArchiveFilter.EndTime = CInt(TimeConversion.SystemToZenOn(New DateTime(2007, 7, 31, 11, 15, 0)))

zenonArchiveFilter.StatusMask = &H41000

'Check only I-BIT + HWERT

zenonArchiveFilter.StatusBit = &H41000

'Return data if one of those bit is true or both

'Initiate a filter query

Dim zenonArchiveVariables As IArchiveFilterVariables = zenonArchiveFilter.Query()

For i As Integer = 0 To zenonArchiveVariables.Count - 1

Me.Parent.Parent.DebugPrint("Variable: " + zenonArchiveVariables.Item(i).ArchiveVariable().Name, tpDebugPrintStyle.tpNrm)

Me.Parent.Parent.DebugPrint("I-BIT + HWERT: " + zenonArchiveVariables.Item(i).ArchiveValues().Count, tpDebugPrintStyle.tpNrm)

Next

End Sub

VBA

Sub zenOn_ArchiveFilter()
'Declarations
Dim zArchive As Archive
Dim zArvFilter As ArchiveFilter
Dim zArvVars As ArchiveFilterVariables
Dim zTimeConvert As clsTimeConvert
Dim dTime As Double
Dim i As Integer

'Initialize zArchive with the first available archive
Set zArchive = thisProject.Archives.Item(0)

'If no archive is availabe, then ...
If zArchive Is Nothing Then
'... inform the user
MsgBox ("No archive available!")

Else
'Initialize zArvFilter by creating a new archive filter
Set zArvFilter = zArchive.ArchiveFilters.CreateArchiveFilter

'Every archive variable within the collection...
For i = 0 To zArchive.ArchiveVariables.Count - 1
'... will be added to the archive filter
zArvFilter.AddArchiveVariable zArchive.ArchiveVariables.Item(i)
Next i

'Initialize zTimeConvert by creating a new instance of the zenOn "clsTimeConvert" macro
Set zTimeConvert = New clsTimeConvert

'Set dTime by converting the desired system time into the zenOn compatible UTC time
dTime = zTimeConvert.System2zenOn(CDbl(CDate("30.07.2007 14:00:00")))
'Set the converted time as the start time for the filter
zArvFilter.StartTime = dTime

'Set dTime by converting the desired system time into the zenOn compatible UTC time
dTime = zTimeConvert.System2zenOn(CDbl(CDate("31.07.2007 11:15:00")))
'Set the converted time as the end time for the filter
zArvFilter.EndTime = dTime

'All I-BIT and HWERT bits
zArvFilter.StatusMask = &H41000 'Check only I-BIT + HWERT
zArvFilter.StatusBit = &H41000 'Return data if one of those bits are TRUE or both

'Initialize zArvVars by initiating a new filter query
Set zArvVars = zArvFilter.Query

'For every filtered variable within the result...
For i = 0 To zArvVars.Count - 1
With zArvVars.Item(i)
'... output the name of the variable ...
Debug.Print "Variable: " & .ArchiveVariable.Name
'... and the amount of I-BIT and HWERT bits within the specified time range
Debug.Print vbTab & "I-BIT + HWERT: " & .ArchiveValues.Count & vbNewLine
End With
Next i
End If
End Sub

Other topics in this chapter

ArchiveFilter-Properties

ArchiveFilter-Methods


ArchiveFilter-Properties

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | CountArchiveVariables |  | not used | read only
long | EndTime |  | not used | available
IArchiveFilters | Parent |  | not used | read only
long | Raster |  | not used | available
VARIANT_BOOL | ReadOnlyVarsInFilter | Load only in the filter defined variables. | not used | available
long | StartTime |  | not used | available
long | StatusBit |  | not used | available
long | StatusMask |  | not used | available

Other topics in this chapter

StartTime

EndTime

Parent

Raster

StatusMask

StatusBit

CountArchiveVariables

ReadOnlyVarsInFilter


StartTime

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Properties -> StartTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the start time of the filter as long.

Every data that is within the range of the "StartTime" and "EndTime" properties, will not be filtered out and therefore returned.

ATTENTION: zenOn uses UTC time internally, hence the desired start time has to be converted from the local time zone into UTC.

Datatype

StartTime() As long

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

The following macro should be used to set the time correctly. Follow the instructions inside the macro header.

C#

/* This utility class can be used to convert zenOn internal time stamps to

* an actual DateTime structure of the .net framework and backwards. Import

* this file into your current solution, i.e. project in the VSTA editor

* and you can use both of the static methods. Make sure the file is in the

* same namespace of your main project file or import it with "using".

*/

using System;

namespace WorkspaceAddin

{

public static class TimeConversion

{

public static DateTime ZenOnToSystem(uint time)

{

return new DateTime(1970, 1, 1).

AddSeconds(time).

ToLocalTime();

}

public static uint SystemToZenOn(DateTime time)

{

return (uint)time.ToUniversalTime().

Subtract(new DateTime(1970, 1, 1)).

TotalSeconds;

}

}

}

VB.NET

' * This utility class can be used to convert zenOn internal time stamps to

' * an actual DateTime structure of the .net framework and backwards. Import

' * this file into your current solution, i.e. project in the VSTA editor

' * and you can use both of the static methods. Make sure the file is in the

' * same namespace of your main project file or import it with "using".

Public NotInheritable Class TimeConversion

Private Sub New()

End Sub

Public Shared Function ZenOnToSystem(time As UInteger) As DateTime

Return New DateTime(1970, 1, 1).AddSeconds(time).ToLocalTime()

End Function

Public Shared Function SystemToZenOn(time As DateTime) As UInteger

Return CUInt(Math.Truncate(time.ToUniversalTime().Subtract(New DateTime(1970, 1, 1)).TotalSeconds))

End Function

End Class

VBA

'##############################################################################
'## Name : clsTimeConvert ##
'## Description: Macro to convert from local time into UTC and vice versa ##
'## ##
'## Instructions ##
'## 1. Copy the macro into a textfile and save it under "clsTimeConvert.cls" ##
'## 2. Import the file into the VBA project ##
'## >> File -> Import file... ##
'## >> Shortcut CTRL + M ##
'## 3. Declare a variable as "clsTimeConvert" within the VBA project ##
'## e.g. Dim zTimeConversion as clsTimeConvert ##
'## 4. Convert from local time into UTC ##
'## e.g. zTimeConvert.System2zenOn(CDbl(CDate("30.07.2007 14:00:00"))) ##
'##############################################################################
Option Explicit
Private Declare Function GetTimeZoneInformation _
Lib "kernel32" (lpTimeZoneInformation As TIME_ZONE_INFORMATION) As Long
Private Type SYSTEMTIME
wYear As Integer
wMonth As Integer
wDayOfWeek As Integer
wDay As Integer
wHour As Integer
wMinute As Integer
wSecond As Integer
wMilliseconds As Integer
End Type
Private Type TIME_ZONE_INFORMATION
Bias As Long
StandardName(1 To 64) As Byte
StandardDate As SYSTEMTIME
StandardBias As Long
DaylightName(1 To 64) As Byte
DaylightDate As SYSTEMTIME
DaylightBias As Long
End Type
Const TIME_ZONE_ID_UNKNOWN = &H0
Const TIME_ZONE_ID_STANDARD = &H1
Const TIME_ZONE_ID_DAYLIGHT = &H2
Dim SommerZeit As Boolean
Dim SommerZeitDate As Date
Dim SommerZeitName$
Dim SommerZeitGMT&
Dim NormalZeitDate As Date
Dim NormalZeitName$
Dim NormalZeitGMT

Public Function zenOn2System(dTime As Double) As Double
'Converts zenOn (GMT) time to system time format...
zenOn2System = (dTime - GetTimeZone) / 86400 + 25569
End Function

Public Function System2zenOn(lTime As Double) As Double
'Converts system time to zenOn time (GMT) format...
System2zenOn = (lTime - 25569) * 86400 + GetTimeZone
End Function

Private Function GetTimeZone() As Long
Dim TZI As TIME_ZONE_INFORMATION
Dim Result&, ErrFlag As Boolean
Result = GetTimeZoneInformation(TZI)
Select Case Result
Case TIME_ZONE_ID_UNKNOWN
SommerZeit = False
Case TIME_ZONE_ID_STANDARD
SommerZeit = False
Case TIME_ZONE_ID_DAYLIGHT
SommerZeit = True
Case Else
Exit Function
End Select
If SommerZeit = True Then
GetTimeZone = (60 * TZI.Bias) + (60 * TZI.DaylightBias)
Else
GetTimeZone = (60 * TZI.Bias) + (60 * TZI.StandardBias)
End If
End Function


EndTime

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Properties -> EndTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the end time of the filter.

Every data that is within the range of the "StartTime" and "EndTime" properties, will not be filtered out and therefore returned.

Hint: For further information, please have a look at the StartTime property part.

Datatype

EndTime() As long

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


Parent

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As ArchiveFilters

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Raster

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Properties -> Raster

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

If the utilized archive type is none cyclic and this property is set to 0, then all archive entries between the start- and the end time will be returned.Otherwise (i.e. "Raster" property set greater than 0 and the archive type is cyclic) not all archive entries will be returned, but beginning with the start time each N-th (N="Raster") entry is returned.<h5>Example:</h5>Cyclic archive with an cylic rate of 15 minutes (900 seconds) &amp;rarr; Entries are recorded every 15 minutes (e.g. 07:45, 08:00, 08:15, ...)"StartTime" is 12:15 and the "Raster" property is set to 3 &amp;rarr; Every third entry is returned (e.g. 12:15, 13:00, 13:45, 14:30, ...)ATTENTION: If the start time doesn't match the archive cyle time then no data entries will be returned.e.g. Archive entries are 12:15, 12:30, 12:45, 13:00, ..."Raster" is set to 3, but "Start-Time" is set to 12:16 &amp;rarr; It would return 12:16, 13:01, 13:46 but archive cycle is lagging one minute behind &amp;rarr; No entries will be returned!

Datatype

Raster() As long

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


StatusMask

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Properties -> StatusMask

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

StatusMask() As long

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


StatusBit

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Properties -> StatusBit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the value of the relevant state bits.

Hint: For further information on state bits, please have a look at the ReaStatusStd part within the "State" object.

'No state bit filtering -> Default

zArvFilter.StatusMask = 0 'Check none of the states

zArvFilter.StatusBit = 0 '"StatusBit" doesn't matter

'All I-BIT bits

zArvFilter.StatusMask = &H40000 'Check only I-BIT

zArvFilter.StatusBit = &H40000 'Return data if I-BIT is TRUE'

All states, except I-BIT bits

zArvFilter.StatusMask = Not &H40000 'Check all states without I-BIT

zArvFilter.StatusBit = &HFFFFFFFF 'Return data if any of the other bits is TRUE

'All I-BIT and HWERT bits

zArvFilter.StatusMask = &H41000 'Check only I-BIT + HWERT

zArvFilter.StatusBit = &H41000 'Return data if one of those bits is TRUE or both

'All states, except I-BIT + HWERT bits

zArvFilter.StatusMask = Not &H41000 'Check all states without I-BIT + HWERT

zArvFilter.StatusBit = &HFFFFFFFF 'Return data if any of the other bits is TRUE

Datatype

StatusBit() As long

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


CountArchiveVariables

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Properties -> CountArchiveVariables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the amount of "ArchiveVariable" objects within the collection.

Datatype

CountArchiveVariables() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ReadOnlyVarsInFilter

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Properties -> ReadOnlyVarsInFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ReadOnlyVarsInFilter() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


ArchiveFilter-Methods

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | AddArchiveVariable | - | not used | available
VARIANT_BOOL | ApplyChanges | - | not used | available
IArchiveFilterVariables | ArchiveFilterVariables | - | not used | available
VARIANT_BOOL | ArchiveFilterVariablesInfo | Return arrays with the information to all the defined variables in the filter. | not used | available
VARIANT_BOOL | ArchiveFilterVariablesInfoEx | Return arrays with the information to all the defined variables in the filter. Works cross-project. | not used | available
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IArchiveVariable | ItemArchiveVariable | - | not used | available
IArchiveFilterVariables | Query | - | not used | available
VARIANT_BOOL | QueryBlock | - | not used | available
VARIANT_BOOL | QueryBlockEx | - | not used | available
VARIANT_BOOL | RemoveArchiveVariable | - | not used | available
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

RemoveArchiveVariable

AddArchiveVariable

ItemArchiveVariable

Query

ArchiveFilterVariables

QueryBlock

ApplyChanges

ArchiveFilterVariablesInfo

ArchiveFilterVariablesInfoEx

QueryBlockEx


RemoveArchiveVariable

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Methods -> RemoveArchiveVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Removes an "ArchiveVariable" object (which was formerly added to the filter) from the filter. The object is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique name.
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "ArchiveVariable" object in the list.

Datatype

RemoveArchiveVariable(VARIANT vNameOrPos) As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MacroRemoveAllVariables()

{

//Gets the first archive of the project

IArchive zenonArchive = this.Archives().Item(0);

if (zenonArchive == null)

{

//There is no archive, the user will be informed...

this.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr);

return;

}

//Get the first archive filter of the archive

IArchiveFilter zenonArchiveFilter = zenonArchive.ArchiveFilters().Item(0);

if (zenonArchiveFilter == null)

{

//There is no filter, the user will be informed

this.Parent.Parent.DebugPrint("No filter available!", tpDebugPrintStyle.tpErr);

return;

}

//Remove all variables from the filter

while (zenonArchiveFilter.ArchiveFilterVariables().Count > 0)

{

zenonArchiveFilter.RemoveArchiveVariable(0);

}

}

VB.NET

Public Sub MacroRemoveAllVariables()

'Gets the first archive of the project

Dim zenonArchive As IArchive = Me.Archives().Item(0)

If zenonArchive Is Nothing Then

'There is no archive, the user will be informed...

Me.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr)

Return

End If

'Get the first archive filter of the archive

Dim zenonArchiveFilter As IArchiveFilter = zenonArchive.ArchiveFilters().Item(0)

If zenonArchiveFilter Is Nothing Then

'There is no filter, the user will be informed

Me.Parent.Parent.DebugPrint("No filter available!", tpDebugPrintStyle.tpErr)

Return

End If

'Remove all variables from the filter

While zenonArchiveFilter.ArchiveFilterVariables().Count > 0

zenonArchiveFilter.RemoveArchiveVariable(0)

End While

End Sub

VBA

VBA-Syntax


AddArchiveVariable

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Methods -> AddArchiveVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Adds an existing archive variable ("ArchiveVariable" object) to the filter. Thus, the data of the variable will be returned after the filtering.The following code initiates that all assigned archive variables will be added to the archive filter.

Datatype

AddArchiveVariable(IArchiveVariable ArchiveVariable) As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

"ArchiveVariable" object that should be added to the filter.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

ArchiveVariable As ArchiveVariable

Examples

C#

public void MacroAddAllVariables()

{

//Gets the first archive of the project

IArchive zenonArchive = this.Archives().Item(0);

if (zenonArchive == null)

{

//There is no archive, the user will be informed...

this.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr);

return;

}

//Create an archive filter and add any available variable to it

IArchiveFilter zenonArchiveFilter = zenonArchive.ArchiveFilters().CreateArchiveFilter();

for (int i = 0; i < zenonArchive.ArchiveVariables().Count; ++i)

{

zenonArchiveFilter.AddArchiveVariable(zenonArchive.ArchiveVariables().Item(i));

}

}

VB.NET

Public Sub MacroAddAllVariables()

'Gets the first archive of the project

Dim zenonArchive As IArchive = Me.Archives().Item(0)

If zenonArchive Is Nothing Then

'There is no archive, the user will be informed...

Me.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr)

Return

End If

'Create an archive filter and add any available variable to it

Dim zenonArchiveFilter As IArchiveFilter = zenonArchive.ArchiveFilters().CreateArchiveFilter()

For i As Integer = 0 To zenonArchive.ArchiveVariables().Count - 1

zenonArchiveFilter.AddArchiveVariable(zenonArchive.ArchiveVariables().Item(i))

Next

End Sub

VBA

Sub zenOn_AddArchiveVariable(ByRef zArchive As Archive)
'Declarations
Dim zArFilter As ArchiveFilter
Dim i As Integer

'Initialize zArFilter by creating a new archive filter
Set zArFilter = zArchive.ArchiveFilters.CreateArchiveFilter

'Every archive variable within the collection...
For i = 0 To zArchive.ArchiveVariables.Count - 1
'... will be added to the archive filter
zArFilter.AddArchiveVariable zArchive.ArchiveVariables.Item(i)
'Output the name of the added variable
Debug.Print "Variable """ & zArchive.ArchiveVariables.Item(i).Name & """ added!"
Next i

End Sub


ItemArchiveVariable

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Methods -> ItemArchiveVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an "ArchiveVariable" object (which was formerly added to the filter) from the collection. The object is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique name.
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "ArchiveVariable" object in the list.

Hint: The returned object should be checked on Nothing, if no object for the search criteria was found. For further information please have a look at the ArchiveVariable topic itself.

Datatype

ItemArchiveVariable(VARIANT vNameOrPos) As ArchiveVariable

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MarcoGetVariablesInArchiveFilter()

{

//At first the archive is created

IArchive zenonArchive = this.Archives().Item(0);

if (zenonArchive == null)

{

//There is no archive, the user will be informed...

this.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr);

return;

}

//Get the first available archivefilter

IArchiveFilter filter = zenonArchive.ArchiveFilters().Item(0);

//Iterates through all ArchiveVariable objects

for (int i = 0; i < filter.CountArchiveVariables; ++i)

{

IArchiveVariable zenonFilterVariable =

filter.ItemArchiveVariable(i);

//Do something with the current variable

}

}

VB.NET

Public Sub MarcoGetVariablesInArchiveFilter()

'At first the archive is created

Dim zenonArchive As IArchive = Me.Archives().Item(0)

If zenonArchive Is Nothing Then

'There is no archive, the user will be informed...

Me.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr)

Return

End If

'Get the first available archivefilter

Dim filter As IArchiveFilter = zenonArchive.ArchiveFilters().Item(0)

'Iterates through all ArchiveVariable objects

For i As Integer = 0 To filter.CountArchiveVariables - 1

'Do something with the current variable

Dim zenonFilterVariable As IArchiveVariable = filter.ItemArchiveVariable(i)

Next

End Sub

VBA

VBA-Syntax


Query

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Methods -> Query

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Initiates the filtering of the data.Returns an "ArchiveFilterVariables" object, if data matched the filter query. Hence, the returned object will contain the filtered data.Otherwise, this method will return "Nothing", if no data was matched. A full example can be found in the ArchiveFilter main topic: Creating a filter, executing a query and gathering data.

Datatype

Query() As ArchiveFilterVariables

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

//For information on how to query a filter have a look at the main topic "ArchiveFilter"

VB.NET

'For information on how to query a filter have a look at the main topic "Archive Filter"

VBA

'For information on how to query a filter have a look at the main topic "Archive Filter"


ArchiveFilterVariables

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Methods -> ArchiveFilterVariables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an "ArchiveFilterVariables" object, containing a collection of all filtered archive variables. For futher information please have a look at the ArchiveFilterVariables topic.

Datatype

ArchiveFilterVariables() As ArchiveFilterVariables

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


QueryBlock

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Methods -> QueryBlock

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Like the "Query" method, the "QueryBlock" command initiates the filtering of the data.

The difference between these two methods is, that the "QueryBlock" method is dedicated for performance oriented tasks, because the usage of arrays is faster than the approach of the "Query" method with the collections. The drawback of the "QueryBlock" method is the increased complexity of coding.

The "QueryBlock" command requires two parameters:

vPvIDs: A variant variable which will constitute an array containing all IDs of the filtered variables.

vValues: A variant variable which will store an cascaded array designed the following way:

Level: Return type, e.g.

'Declaration
Dim zValues As Variant
'Initiates the filtering
zArvFilter.QueryBlock zPvIDs, zValues
'zValues is the return type, which contains all variables and the corresponding values

Level: Variable, e.g.

'Declaration
Dim vVarTemp As Variant
'Assign the first variable within the cascaded "zValues" array to "vVarTemp"
vVarTemp = zValues(0)

Level: Variable values, e.g.

'Declaration
Dim vValTemp As Variant
'Assign the the third value within the vVarTemp variable to "vValTemp"
vValTemp = vVarTemp(2)
'Alternatively: Third value of the first variable within "zValues"
vValTemp = zValues(0)(2)

Level: Value parameters

vValTemp (0) 'Returns the date and time when the value was recorded
'Hint: The time has to be converted from zenOn internally UTC into local time.
'Use the zenOn "clsTimeConvert" macro to do so.
zValues (0)(2)(0) 'Alternatively

vValTemp (1) 'Returns the milliseconds, in addition to the time, when the value was recorded
zValues (0)(2)(1) 'Alternatively

vValTemp (2) 'Returns the value that was recorded at the specified time and date
zValues (0)(2)(1) 'Alternatively

vValTemp (3) 'Returns the state type, e.g. &H40000 -> I-BIT
zValues (0)(2)(1) 'Alternatively

Datatype

QueryBlock(LPVARIANT vPvIDs,LPVARIANT vValues) As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

vValues As Variant

"Variant" variable for the "QueryBlock" method, in order to store a cascaded array which is filled with the filtered variables and the recorded values.
The array is returned by the method, hence the user has only to pass an "Variant" variable.

vPvIDs As Variant

"Variant" variable for the "QueryBlock" method, in order to store an array of IDs of the corresponding filtered archive variables.
The array is returned by the method, hence the user has only to pass an "Variant" variable.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vValues As Variant

vPvIDs As Variant

Examples

The following example initiates a filtering with the "QueryBlock" command and outputs the details of the filter result.

ATTENTION: The passed "ArchiveFilter" object has to be initialized beforehand, i.e. filter starttime and endtime, etc.

Hint:
In order to output the correct date and time of the filter result, the zenOn "clsTimeConvert" macro should be used.
For the macro code and further information on the macro and the time conversion, please have a look at the StartTime part.

C#

public void zenonArchiveFilterQueryBlock(ref IArchiveFilter zenonArchiveFilter)

{

object zenonPvIds = null;

object zenonValues = null;

zenonArchiveFilter.QueryBlock(ref zenonPvIds, ref zenonValues);

int[] zenonQueriedPvIds = (int[])zenonPvIds;

object[] zenonQueriedValues = (object[])zenonValues;

for (int i = 0; i < zenonQueriedValues.Length; ++i)

{

object[] currentValue = (object[])zenonQueriedValues[i];

for (int j = 0; i < currentValue.Length; ++j)

{

object[] specificValues = (object[])currentValue[j];

System.Diagnostics.Debug.Print("{0}. Value", j + 1);

System.Diagnostics.Debug.Print("Variable Name: {0}", zenonArchiveFilter.

ArchiveFilterVariables().ItemById(zenonQueriedPvIds[i]).

ArchiveVariable().Name);

System.Diagnostics.Debug.Print("Variable ID: {0}", zenonQueriedPvIds[i]);

int time = (int)specificValues[0];

System.Diagnostics.Debug.Print("Time: {0}", TimeConversion.

ZenOnToSystem((uint)time).ToString());

System.Diagnostics.Debug.Print("Milliseconds: {0}", specificValues[1]);

System.Diagnostics.Debug.Print("Value: {0}", specificValues[2]);

System.Diagnostics.Debug.Print("State: 0x{0}", ((int)specificValues[3]).ToString("X"));

}

}

}

VB.NET

Public Sub zenonArchiveFilterQueryBlock(ByRef zenonArchiveFilter As IArchiveFilter)

Dim zenonPvIds As Object = Nothing

Dim zenonValues As Object = Nothing

zenonArchiveFilter.QueryBlock(zenonPvIds, zenonValues)

Dim zenonQueriedPvIds As Integer() = DirectCast(zenonPvIds, Integer())

Dim zenonQueriedValues As Object() = DirectCast(zenonValues, Object())

For i As Integer = 0 To zenonQueriedValues.Length - 1

Dim currentValue As Object() = DirectCast(zenonQueriedValues(i), Object())

Dim j As Integer = 0

While i < currentValue.Length

Dim specificValues As Object() = DirectCast(currentValue(j), Object())

System.Diagnostics.Debug.Print("{0}. Value", j + 1)

System.Diagnostics.Debug.Print("Variable Name: {0}", zenonArchiveFilter.ArchiveFilterVariables().ItemById(zenonQueriedPvIds(i)).ArchiveVariable().Name)

System.Diagnostics.Debug.Print("Variable ID: {0}", zenonQueriedPvIds(i))

Dim time As Integer = CInt(specificValues(0))

System.Diagnostics.Debug.Print("Time: {0}", TimeConversion.ZenOnToSystem(CUInt(time)).ToString())

System.Diagnostics.Debug.Print("Milliseconds: {0}", specificValues(1))

System.Diagnostics.Debug.Print("Value: {0}", specificValues(2))

System.Diagnostics.Debug.Print("State: 0x{0}", CInt(specificValues(3)).ToString("X"))

j += 1

End While

Next

End Sub

VBA

Public Sub zenOn_ArchiveFilter_QueryBlock(ByRef zArvFilter As ArchiveFilter)
'Declarations
Dim zTimeConvert As clsTimeConvert
Dim zPvIDs As Variant
Dim zValues As Variant
Dim i As Integer
Dim j As Integer
Dim vVarTemp As Variant
Dim vValTemp As Variant
Dim nVarCount As Integer
Dim nValCount As Integer

'Initialize zTimeConvert by creating a new instance of the zenOn "clsTimeConvert" macro
Set zTimeConvert = New clsTimeConvert

zArvFilter.QueryBlock zPvIDs, zValues

'Get the number of variables and assign it to "nVarCount"
nVarCount = UBound(zValues, 1)
'For every filtered variable output the recorded values
For i = 0 To nVarCount
'Assign the current variable to "vVarTemp"
vVarTemp = zValues(i)
'Get the number of values within the variable and assign it to "nValCount"
nValCount = UBound(vVarTemp, 1)
'For every value within the filtered variable output the recorded details
For j = 0 To nValCount
'Assign the current value to "vValTemp"
vValTemp = vVarTemp(j)
'Output the count number of the current value
Debug.Print j + 1 & ". Value"
'Output the variable name to which the value belongs
Debug.Print vbTab & "Var-Name: " & zArvFilter.ArchiveFilterVariables.ItemById(zPvIDs(i)).ArchiveVariable.Name
'Output the ID of the variable
Debug.Print vbTab & "Var-ID" & vbTab & ": " & CStr(zPvIDs(i))
'Output the date and time when the value was recorded -> Format: year-month-day hour:minute:second.millisecond
Debug.Print vbTab & "Time" & vbTab & ": " & Format(zTimeConvert.zenOn2System((vValTemp(0))), "yyyy-mm-dd hh:mm:ss") & "." & CStr(vValTemp(1))
'Output the value that was recorded
Debug.Print vbTab & "Value" & vbTab & ": " & CStr(vValTemp(2))
'Output the state of the value
Debug.Print vbTab & "State" & vbTab & ": &H" & Hex(vValTemp(3))
Next j
Next i

End Sub


ApplyChanges

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Methods -> ApplyChanges

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Apply changes on the filter.

Datatype

ApplyChanges() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ArchiveFilterVariablesInfo

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Methods -> ArchiveFilterVariablesInfo

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns information on the assigned archive filter variables.Following three parameters have to be passed:

  • Count: Returns the amount of archive filter variables.
  • vIDs: Returns the IDs of the archive filter variables.
  • vNames: Returns the names of the archive filter variables.

Datatype

ArchiveFilterVariablesInfo(long Count, LPVARIANT vIDs, LPVARIANT vNames) As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

"Variant" variable passed to the "ArchiveFilterVariablesInfo" method, in order to return the IDs of the archive filter variables.

"Variant" variable passed to the "ArchiveFilterVariablesInfo" method, in order to return the amount of archive filter variables.

"Variant" variable passed to the "ArchiveFilterVariablesInfo" method, in order to return the names of the archive filter variables.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vIDs As Variant

Count As Long

vNames As Variant

Examples

C#

public void zenonArchiveFilterArchiveVariablesInfo(ref IArchiveFilter zenonArchiveFilter)

{

int count = 0;

object idsReturn = null;

object namesReturn = null;

zenonArchiveFilter.ArchiveFilterVariablesInfo(ref count, ref idsReturn, ref namesReturn);

int[] ids = (int[])idsReturn;

string[] names = (string[])namesReturn;

for (int i = 0; i < count; ++i)

{

//Print the number of the variable

System.Diagnostics.Debug.Print("{0}. Variable", i + i);

//Print the name of the variable

System.Diagnostics.Debug.Print("Name: {0}", names[i]);

//Print the ID of the variable

System.Diagnostics.Debug.Print("ID: {0}", ids[i]);

}

}

VB.NET

Public Sub zenonArchiveFilterArchiveVariablesInfo(ByRef zenonArchiveFilter As IArchiveFilter)

Dim count As Integer = 0

Dim idsReturn As Object = Nothing

Dim namesReturn As Object = Nothing

zenonArchiveFilter.ArchiveFilterVariablesInfo(count, idsReturn, namesReturn)

Dim ids As Integer() = DirectCast(idsReturn, Integer())

Dim names As String() = DirectCast(namesReturn, String())

For i As Integer = 0 To count - 1

'Print the number of the variable

System.Diagnostics.Debug.Print("{0}. Variable", i + i)

'Print the name of the variable

System.Diagnostics.Debug.Print("Name: {0}", names(i))

'Print the ID of the variable

System.Diagnostics.Debug.Print("ID: {0}", ids(i))

Next

End Sub

VBA

Public Sub zenOn_ArchiveFilter_ArchiveFilterVariablesInfo(ByRef zArvFilter As ArchiveFilter)
'Declarations
Dim zCount As Long
Dim zIDs As Variant
Dim zNames As Variant

'Initiate the information query
zArvFilter.ArchiveFilterVariablesInfo zCount, zIDs, zNames

'For every archive filter variable within the collection...
For i = 0 To zCount - 1
'... output the variable count
Debug.Print i + 1 & ". Variable"
'... output the name
Debug.Print vbTab & "Name: " & zNames(i)
'... output the ID
Debug.Print vbTab & "ID" & vbTab & ": " & zIDs(i)
Next i

End Sub


ArchiveFilterVariablesInfoEx

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Methods -> ArchiveFilterVariablesInfoEx

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Like the "ArchiveFilterVariablesInfo" method, this command returns information on the assigned archive filter variables.Additionally it will also return information on the project name and the utilized calculation mode, if it is a following archive.Following five parameters have to be passed:

  • Count: Returns the amount of archive filter variables.
  • vIDs: Returns the IDs of the archive filter variables.
  • vNames: Returns the names of the archive filter variables.
  • vProjects: Returns the project name.
  • vCalculations: Returns the calculation mode, if it is a following archive.

Datatype

ArchiveFilterVariablesInfoEx(long Count, LPVARIANT vIDs, LPVARIANT vNames, LPVARIANT vProjects, LPVARIANT vCalculations) As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


QueryBlockEx

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilter -> ArchiveFilter-Methods -> QueryBlockEx

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Like the "QueryBlock" method, the "QueryBlockEx" command initiates the filtering of the data.

The difference between these two methods is, that the "QuerBlockEx" command will also return the project name and the utilized calculation modes (if it is a following archive) in addition to the "QueryBlock" results.

Hint: For further information, please have a look at the QueryBlock part.

Datatype

QueryBlockEx(LPVARIANT vProjects, LPVARIANT vPvIDs, LPVARIANT vCalculations, LPVARIANT vValues) As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

vValues As Variant

"Variant" variable for the "QueryBlockEx" method, in order to store a cascaded array which is filled with the filtered variables and the recorded values.
The array is returned by the method, hence the user has only to pass an "Variant" variable.

vCalculations As Variant

"Variant" variable for the "QueryBlockEx" method, in order to store an array of calculation modes, which were utilized by the recorded values.
The array is returned by the method, hence the user has only to pass an "Variant" variable.
Hint: For further information on calculation modes, please have a look at the Calculation property within the "ArchiveVariable" object.

vPvIDs As Variant

"Variant" variable for the "QueryBlockEx" method, in order to store an array of IDs of the corresponding filtered archive variables.
The array is returned by the method, hence the user has only to pass an "Variant" variable.

vProjects As Variant

"Variant" variable for the "QueryBlockEx" method, in order to store an array of project names, where the filter was applied.
The array is returned by the method, hence the user has only to pass an "Variant" variable.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vValues As Variant

vCalculations As Variant

vPvIDs As Variant

vProjects As Variant

Examples

The following example initiates a filtering with the "QueryBlockEx" command and outputs details on the project name and the utilized calculation modes.

ATTENTION: The passed "ArchiveFilter" object has to be initialized beforehand, i.e. filter starttime and endtime, etc.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Public Sub zenOn_ArchiveFilter_QueryBlockEx(ByRef zArvFilter As ArchiveFilter)
'Declarations
Dim zPvIDs As Variant
Dim zValues As Variant
Dim zProjects As Variant
Dim zCalculations As Variant
Dim i As Integer

'Initiate the filtering
Debug.Print zArvFilter.QueryBlockEx(zProjects, zPvIDs, zCalculations, zValues)

'Output every project name
For i = 0 To UBound(zProjects, 1)
Debug.Print CStr(zProjects(i))
Next i

'Output every calculation mode
For i = 0 To UBound(zCalculations, 1)
Debug.Print CStr(zCalculations(i))
Next i

End Sub


ArchiveFilters

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This collection administers all filter objects.HINT:As a default there are no filters. You can administer any number of filters.With "CreateArchiveFilter" you can create a new filter. On the contrary, you can delete an existing filter with "DeleteArchiveFilter".Like in any other collection you can access an ArchiveFilter object with the "Item" method.

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

public void MacroQueryAllFilters()

{

//Executes a query on all filters currently in the first archive of the project

IArchiveFilters zenonFilters = this.Archives().Item(0).ArchiveFilters();

for (int i = 0; i < zenonFilters.Count; ++i)

{

IArchiveFilter zenonFilter = zenonFilters.Item(i);

if (zenonFilter != null)

zenonFilter.Query();

}

}

VB.NET

Public Sub MacroQueryAllFilters()

'Executes a query on all filters currently in the first archive of the project

Dim zenonFilters As IArchiveFilters = Me.Archives().Item(0).ArchiveFilters()

For i As Integer = 0 To zenonFilters.Count - 1

Dim zenonFilter As IArchiveFilter = zenonFilters.Item(i)

If zenonFilter IsNot Nothing Then

zenonFilter.Query()

End If

Next

End Sub

VBA

Sub zenOn_ArchiveFilters()
'Declarations
Dim zArvFilters As ArchiveFilters
Dim zArvFilter As ArchiveFilter
Dim i As Integer

'Initialize zArvFilters with the archive filter collection of the first available archive
Set zArvFilters = thisProject.Archives.Item(0).ArchiveFilters

'For every archive filter within the collection ...
For i = 0 To zArvFilters.Count - 1
'... assign it to zArvFilter
Set zArvFilter = zArvFilters.Item(i)
'If the filter is available (zArvFilter is not "Nothing")...
If Not (zArvFilter Is Nothing) Then
'... then initiate the filtering
zArvFilter.Query
End If
Next i

End Sub

Other topics in this chapter

ArchiveFilters-Properties

ArchiveFilters-Methods


ArchiveFilters-Properties

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilters -> ArchiveFilters-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | not used | read only
IArchive | Parent |  | not used | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilters -> ArchiveFilters-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Archive

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilters -> ArchiveFilters-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ArchiveFilters-Methods

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilters -> ArchiveFilters-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IArchiveFilter | CreateArchiveFilter | - | not used | available
VARIANT_BOOL | DeleteArchiveFilter | - | not used | available
IArchiveFilter | Item | - | available | available

Other topics in this chapter

Item

CreateArchiveFilter

DeleteArchiveFilter


Item

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilters -> ArchiveFilters-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an "ArchiveFilter" object from the collection, which is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique name.
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "ArchiveFilter" object in the list.

Hint: The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vNameOrPos) As ArchiveFilter

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

//For an example on how to iterate through all filters using the Item method have a look at the main topic "ArchiveFilters" or the sub-topic "DeleteArchiveFilter"

VB.NET

'For an example on how to iterate through all filters using the Item method have a look at the main topic "ArchiveFilters" or the sub-topic "DeleteArchiveFilter"

VBA

'For an example on how to iterate through all filters using the Item method have a look at the main topic "ArchiveFilters" or the sub-topic "DeleteArchiveFilter"


CreateArchiveFilter

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilters -> ArchiveFilters-Methods -> CreateArchiveFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method creates a new "ArchiveFilter" object. Afterwards, the filter is configurable in order to return the required data.

Datatype

CreateArchiveFilter() As ArchiveFilter

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MarcroZenOnArchiveFilter()

{

//Gets the first archive of the project

IArchive zenonArchive = this.Archives().Item(0);

if (zenonArchive == null)

{

//There is no archive, the user will be informed...

this.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr);

return;

}

IArchiveFilter zenonArchiveFilter = zenonArchive.ArchiveFilters().CreateArchiveFilter();

for (int i = 0; i < zenonArchive.ArchiveVariables().Count; ++i)

{

//Add every archive variable to the archive filter

zenonArchiveFilter.AddArchiveVariable(zenonArchive.ArchiveVariables().Item(i));

}

//Set the StartTime to 14:00 on the 30th of july 2007

zenonArchiveFilter.StartTime = (int)TimeConversion.

SystemToZenOn(new DateTime(2007, 07, 30, 14, 0, 0));

//Set the EndTime to 11:15 on the 31st of july 2007

zenonArchiveFilter.EndTime = (int)TimeConversion.

SystemToZenOn(new DateTime(2007,07,31,11,15,00));

zenonArchiveFilter.StatusMask = 0x41000; //Check only I-BIT + HWERT

zenonArchiveFilter.StatusBit = 0x41000; //Return data if one of those bit is true or both

//Initiate a filter query

IArchiveFilterVariables zenonArchiveVariables = zenonArchiveFilter.Query();

for (int i = 0; i < zenonArchiveVariables.Count; ++i)

{

this.Parent.Parent.DebugPrint("Variable: " + zenonArchiveVariables.Item(i).ArchiveVariable().Name, tpDebugPrintStyle.tpNrm);

this.Parent.Parent.DebugPrint("I-BIT + HWERT: " + zenonArchiveVariables.Item(i).ArchiveValues().Count, tpDebugPrintStyle.tpNrm);

}

}

VB.NET

public void MarcrozenOnArchiveFilter()

{

//Gets the first archive of the project

IArchive zenonArchive = this.Archives().Item(0);

if (zenonArchive == null)

{

//There is no archive, the user will be informed...

this.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr);

return;

}

IArchiveFilter zenonArchiveFilter = zenonArchive.ArchiveFilters().CreateArchiveFilter();

for (int i = 0; i < zenonArchive.ArchiveVariables().Count; ++i)

{

//Add every archive variable to the archive filter

zenonArchiveFilter.AddArchiveVariable(zenonArchive.ArchiveVariables().Item(i));

}

//Set the StartTime to 14:00 on the 30th of july 2007

zenonArchiveFilter.StartTime = (int)TimeConversion.

SystemToZenOn(new DateTime(2007, 07, 30, 14, 0, 0));

//Set the EndTime to 11:15 on the 31st of july 2007

zenonArchiveFilter.EndTime = (int)TimeConversion.

SystemToZenOn(new DateTime(2007,07,31,11,15,00));

zenonArchiveFilter.StatusMask = 0x41000; //Check only I-BIT + HWERT

zenonArchiveFilter.StatusBit = 0x41000; //Return data if one of those bit is true or both

//Initiate a filter query

IArchiveFilterVariables zenonArchiveVariables = zenonArchiveFilter.Query();

for (int i = 0; i < zenonArchiveVariables.Count; ++i)

{

this.Parent.Parent.DebugPrint("Variable: " + zenonArchiveVariables.Item(i).ArchiveVariable().Name, tpDebugPrintStyle.tpNrm);

this.Parent.Parent.DebugPrint("I-BIT + HWERT: " + zenonArchiveVariables.Item(i).ArchiveValues().Count, tpDebugPrintStyle.tpNrm);

}

}

VBA

VBA-Syntax


DeleteArchiveFilter

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilters -> ArchiveFilters-Methods -> DeleteArchiveFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method removes an existing filter ("ArchiveFilter" object) from the collection.Subsequently, the filter won't be available any more. Trying to access it, will return an incorrect filter or a segmentation fault.

Datatype

DeleteArchiveFilter(VARIANT vNameOrPos) As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MacroDeleteAllFilters()

{

//Deletes all filters on the first archive of the project

IArchiveFilters zenonFilters = this.Archives().Item(0).ArchiveFilters();

for (int i = 0; i < zenonFilters.Count; ++i)

{

zenonFilters.DeleteArchiveFilter(i);

}

}

VB.NET

Public Sub MacroDeleteAllFilters()

'Deletes all filters on the first archive of the project

Dim zenonFilters As IArchiveFilters = Me.Archives().Item(0).ArchiveFilters()

For i As Integer = 0 To zenonFilters.Count - 1

zenonFilters.DeleteArchiveFilter(i)

Next

End Sub

VBA

VBA-Syntax


ArchiveFilterVariable

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilterVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The "ArchiveFilterVariable" object contains the filtered archive variable for the "ArchiveFilter" object.

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

//This method gathers some information on a variable in the passed IArchiveFilter object.

//The information is then sent to the standard debug output of the zenOn editor.

public void ZenOnArchiveFilterVariable(ref IArchiveFilter zenonArchiveFilter)

{

//Get the first available filtered variable

IArchiveFilterVariable zenonArchiveFilterVariable = zenonArchiveFilter.ArchiveFilterVariables().Item(0);

if (zenonArchiveFilterVariable == null)

{

//If there is no variable available, inform the user

//NOTE: The variable will not be available if there was no filter query executed

this.Parent.Parent.DebugPrint("No filtered archive variable available!", tpDebugPrintStyle.tpNrm);

return;

}

//And if there is, output some details

this.Parent.Parent.DebugPrint("Variable: " +

zenonArchiveFilterVariable.ArchiveVariable().Name, tpDebugPrintStyle.tpNrm);

for (int i = 0; i < zenonArchiveFilterVariable.ArchiveValues().Count; ++i)

{

this.Parent.Parent.DebugPrint((i + 1) + ". Value: " +

zenonArchiveFilterVariable.ArchiveValues().Item(i).Value, tpDebugPrintStyle.tpNrm);

}

}

VB.NET

'This method gathers some information on a variable in the passed IArchiveFilter object.

'The information is then sent to the standard debug output of the zenOn editor.

Public Sub ZenOnArchiveFilterVariable(ByRef zenonArchiveFilter As IArchiveFilter)

'Get the first available filtered variable

Dim zenonArchiveFilterVariable__1 As IArchiveFilterVariable = zenonArchiveFilter.ArchiveFilterVariables().Item(0)

If zenonArchiveFilterVariable__1 Is Nothing Then

'If there is no variable available, inform the user

Me.Parent.Parent.DebugPrint("No filtered archive variable available!", tpDebugPrintStyle.tpNrm)

Return

End If

'And if there is, output some details

Me.Parent.Parent.DebugPrint("Variable: " + zenonArchiveFilterVariable__1.ArchiveVariable().Name, tpDebugPrintStyle.tpNrm)

For i As Integer = 0 To zenonArchiveFilterVariable__1.ArchiveValues().Count - 1

Me.Parent.Parent.DebugPrint(((i + 1) & ". Value: ") + zenonArchiveFilterVariable__1.ArchiveValues().Item(i).Value, tpDebugPrintStyle.tpNrm)

Next

End Sub

VBA

Sub zenOn_ArchiveFilterVariable(ByRef zArvFilter As ArchiveFilter)
'Declarations
Dim zArvFilterVar As ArchiveFilterVariable
Dim i As Integer

'Initialize zArvFilterVar with the first available filtered archive variable
Set zArvFilterVar = zArvFilter.ArchiveFilterVariables.Item(0)

'If no filtered archive variable is available ...
'HINT: Filtered archive variables are only availabe after a archive filter query was initiated
If zArvFilterVar Is Nothing Then
'... then inform the user
MsgBox ("No filtered archive variable available!")

'Otherwise, output some details
Else
'Output the variable name
Debug.Print "Variable: " & zArvFilterVar.ArchiveVariable.Name

With zArvFilterVar.ArchiveValues
'For every archive value within "zArvFilterVar" ...
For i = 0 To .Count - 1
'... output the recorded value
Debug.Print vbTab & i + 1 & ".Value: " & .Item(i).Value
Next i
End With
End If
End Sub

Other topics in this chapter

ArchiveFilterVariable-Properties

ArchiveFilterVariable-Methods


ArchiveFilterVariable-Properties

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilterVariable -> ArchiveFilterVariable-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IArchiveFilterVariables | Parent |  | not used | read only

Other topics in this chapter

Parent


Parent

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilterVariable -> ArchiveFilterVariable-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As ArchiveFilterVariables

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ArchiveFilterVariable-Methods

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilterVariable -> ArchiveFilterVariable-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IArchiveValues | ArchiveValues | - | not used | available
VARIANT | ArchiveValuesBlock | - | not used | read only
IArchiveVariable | ArchiveVariable | - | not used | available

Other topics in this chapter

ArchiveVariable

ArchiveValues

ArchiveValuesBlock


ArchiveVariable

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilterVariable -> ArchiveFilterVariable-Methods -> ArchiveVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an "ArchiveVarible" object, which constitutes the assigned archive variable. For further information, please have a look at the "ArchiveVariable" part.

Datatype

ArchiveVariable() As ArchiveVariable

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ArchiveValues

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilterVariable -> ArchiveFilterVariable-Methods -> ArchiveValues

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an "ArchiveValues" object, which contains a collection of all "ArchiveValue" objects assigned to this filtered archive variable. For further information, please have a look at the "ArchiveValues" part.

Datatype

ArchiveValues() As ArchiveValues

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ArchiveValuesBlock

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilterVariable -> ArchiveFilterVariable-Methods -> ArchiveValuesBlock

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an array of values for the actual ArchiveFilterVariable object.This works only when a query has already been executed.

Datatype

ArchiveValuesBlock() As VARIANT

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ArchiveFilterVariables

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilterVariables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an "ArchiveFilterVariables" object, containing a collection of the filtered archive variables.This object is utilized by the "ArchiveFilter" object, in order to access the collection of "ArchiveFilterVariable" objects.

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

//This method gathers some information on a variable in the passed IArchiveFilter object.

//The information is then sent to the standard debug output of the zenOn editor.

public void ZenOnArchiveFilterVariable(ref IArchiveFilter zenonArchiveFilter)

{

//Get the first available filtered variable

IArchiveFilterVariable zenonArchiveFilterVariable = zenonArchiveFilter.ArchiveFilterVariables().Item(0);

if (zenonArchiveFilterVariable == null)

{

//If there is no variable available, inform the user

this.Parent.Parent.DebugPrint("No filtered archive variable available!", tpDebugPrintStyle.tpNrm);

return;

}

//And if there is, output some details

this.Parent.Parent.DebugPrint("Variable: " +

zenonArchiveFilterVariable.ArchiveVariable().Name, tpDebugPrintStyle.tpNrm);

for (int i = 0; i < zenonArchiveFilterVariable.ArchiveValues().Count; ++i)

{

this.Parent.Parent.DebugPrint((i + 1) + ". Value: " +

zenonArchiveFilterVariable.ArchiveValues().Item(i).Value, tpDebugPrintStyle.tpNrm);

}

}

VB.NET

'This method gathers some information on a variable in the passed IArchiveFilter object.

'The information is then sent to the standard debug output of the zenOn editor.

Public Sub ZenOnArchiveFilterVariable(ByRef zenonArchiveFilter As IArchiveFilter)

'Get the first available filtered variable

Dim zenonArchiveFilterVariable__1 As IArchiveFilterVariable = zenonArchiveFilter.ArchiveFilterVariables().Item(0)

If zenonArchiveFilterVariable__1 Is Nothing Then

'If there is no variable available, inform the user

Me.Parent.Parent.DebugPrint("No filtered archive variable available!", tpDebugPrintStyle.tpNrm)

Return

End If

'And if there is, output some details

Me.Parent.Parent.DebugPrint("Variable: " + zenonArchiveFilterVariable__1.ArchiveVariable().Name, tpDebugPrintStyle.tpNrm)

For i As Integer = 0 To zenonArchiveFilterVariable__1.ArchiveValues().Count - 1

Me.Parent.Parent.DebugPrint(((i + 1) & ". Value: ") + zenonArchiveFilterVariable__1.ArchiveValues().Item(i).Value, tpDebugPrintStyle.tpNrm)

Next

End Sub

VBA

Sub zenOn_ArchiveFilterVariables(ByRef zArvFilter As ArchiveFilter)
'Declarations
Dim zArvFilterVars As ArchiveFilterVariables
Dim i As Integer

'Initialize zArvFilterVars with the filtered archive variable collection of the current archive
Set zArvFilterVars = zArvFilter.ArchiveFilterVariables

'If no filtered archive variables are available ...
'HINT: Filtered archive variables are only availabe after a archive filter query was initiated
If zArvFilterVars Is Nothing Then
'... then inform the user
MsgBox ("No filtered archive variables available!")

'Otherwise:
Else
'For every filtered archive variable ...
For i = 0 To zArvFilterVars.Count - 1
'... output the name
Debug.Print i + 1 & ". Variable: " & zArvFilterVars.Item(i).ArchiveVariable.Name
Next i
End If
End Sub

Other topics in this chapter

ArchiveFilterVariables-Properties

ArchiveFilterVariables-Methods


ArchiveFilterVariables-Properties

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilterVariables -> ArchiveFilterVariables-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | not used | read only
IArchiveFilter | Parent |  | not used | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilterVariables -> ArchiveFilterVariables-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As ArchiveFilter

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilterVariables -> ArchiveFilterVariables-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ArchiveFilterVariables-Methods

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilterVariables -> ArchiveFilterVariables-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IArchiveFilterVariable | Item | - | available | not used
IArchiveFilterVariable | ItemById | - | not used | available
IArchiveFilterVariable | ItemByIdEx | - | not used | read only

Other topics in this chapter

Item

ItemById

ItemByIdEx


Item

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilterVariables -> ArchiveFilterVariables-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an "ArchiveFilterVariable" object from the collection, which is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique name.
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "ArchiveFilterVariable" object in the list.

Hint: The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vNameOrPos) As ArchiveFilterVariable

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ItemById

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilterVariables -> ArchiveFilterVariables-Methods -> ItemById

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an "ArchiveFilterVariable" object from the collection specified by its internal uniqe ID, which is identified by the parameter vVariableId.Hint: The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

ItemById(VARIANT vVariableId) As ArchiveFilterVariable

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ItemByIdEx

Manual -> Programming interfaces -> Objectmodel -> ArchiveFilterVariables -> ArchiveFilterVariables-Methods -> ItemByIdEx

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an object of type ArchiveFilterVariable.

Datatype

ItemByIdEx(VARIANT vVariableId, VARIANT vProjectName, VARIANT vCalculation) As ArchiveFilterVariable

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

Uniqe PvID of linked zenOn Variable

Type of claculation as long
Calculation Types

Projectname as string

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vVariableId As Variant

vCalculation As Variant

vProjectName As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetArchiveFilterVariable(zArvFilter As ArchiveFilter)
Dim zVariable As Variable
Dim zFilterVar As ArchiveFilterVariable
'get variable object to read the PvID!
Set zVariable = thisProject.Variables.Item("WIZ_VAR_10")
'get the filtervariable with SUM calculation
Set zFilterVar = zArvFilter.ArchiveFilterVariables.ItemByIdEx(zVariable.PvID, thisProject.Name, 1)
End Sub


Archives

Manual -> Programming interfaces -> Objectmodel -> Archives

Remarks

The object is a collection of all existing archives.With the property "Parent" you come to the parent of the object. The parent of the Archives object is a Project. In the Project most of the modules are anchored.With the property "Item" you can search for an archive. As search criteria you can enter the position of the archive in the list or the name.With the property "Count" you find out the number of elements in the list. With a loop you then can iterate through all elements and e.g display them.

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

//The Macro lists any Archive in the current project and prints its name

//as well as the names of any contained variable

public void MacroZenOnArchives()

{

IProject zenonProject = this.Project;

IArchives zenonArchives = zenonProject.Archives();

for (int i = 0; i < zenonArchives.Count; ++i)

{

this.Parent.Parent.DebugPrint(i + ". Archive: " + zenonArchives.Item(i).Name,

tpDebugPrintStyle.tpMsg);

}

}

public void zenOnArchiveVariables(ref IArchiveVariables zenonArchiveVariables)

{

for (int i = 0; i < zenonArchiveVariables.Count; ++i)

{

this.Parent.Parent.DebugPrint(i + zenonArchiveVariables.Item(i).Name,

tpDebugPrintStyle.tpMsg);

}

}

VB.NET

'The Macro lists any Archive in the current project and prints its name

'as well as the names of any contained variable

Public Sub MacroZenOnArchives()

Dim zenonProject As IProject = Me.Project

Dim zenonArchives As IArchives = zenonProject.Archives()

For i As Integer = 0 To zenonArchives.Count - 1

Me.Parent.Parent.DebugPrint((i & ". Archive: ") + zenonArchives.Item(i).Name, tpDebugPrintStyle.tpMsg)

Next

End Sub

Public Sub zenOnArchiveVariables(ByRef zenonArchiveVariables__1 As IArchiveVariables)

For i As Integer = 0 To zenonArchiveVariables__1.Count - 1

Me.Parent.Parent.DebugPrint(i + zenonArchiveVariables__1.Item(i).Name, tpDebugPrintStyle.tpMsg)

Next

End Sub

VBA

Sub zenOn_Archives()
'Declarations
Dim zProject As Project
Dim zArchives As Archives
Dim i As Integer

'Initialize zProject with the current project
Set zProject = thisProject
'Initialize zArchives with the current "Archive" object collection
Set zArchives = zProject.Archives

'For every "Archive" object within the collection...
For i = 0 To zArchives.Count - 1
'... output the name ...
Debug.Print i + 1 & ". Archive: " & zArchives.Item(i).Name
'... and the name of the included variables
Call zenOn_ArchiveVariables(zArchives.Item(i).ArchiveVariables)
Next i

End Sub

Sub zenOn_ArchiveVariables(ByRef zArchiveVars As ArchiveVariables)
'Declarations
Dim i As Integer

'For every "ArchiveVariable" object within the collection...
For i = 0 To zArchiveVars.Count - 1
'... output the name of the variable
Debug.Print vbTab & i + 1 & ". Var: " & zArchiveVars.Item(i).Name
Next i

End Sub

Other topics in this chapter

Archives-Properties

Archives-Methods


Archives-Properties

Manual -> Programming interfaces -> Objectmodel -> Archives -> Archives-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | not used | read only
IProject | Parent |  | not used | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> Archives -> Archives-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> Archives -> Archives-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Archives-Methods

Manual -> Programming interfaces -> Objectmodel -> Archives -> Archives-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IArchive | Item | - | available | not used

Other topics in this chapter

Item


Item

Manual -> Programming interfaces -> Objectmodel -> Archives -> Archives-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an "Archive" object from the collection, which is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique name.
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "Archive" object in the list.

Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vNameOrPos) As Archive

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

//The Macro lists any Archive in the current project and prints its name

//as well as the names of any contained variable

public void MacroZenOnArchives()

{

IProject zenonProject = this.Project;

IArchives zenonArchives = zenonProject.Archives();

for (int i = 0; i < zenonArchives.Count; ++i)

{

this.Parent.Parent.DebugPrint(i + ". Archive: " + zenonArchives.Item(i).Name,

tpDebugPrintStyle.tpMsg);

}

}

public void zenOnArchiveVariables(ref IArchiveVariables zenonArchiveVariables)

{

for (int i = 0; i < zenonArchiveVariables.Count; ++i)

{

this.Parent.Parent.DebugPrint(i + zenonArchiveVariables.Item(i).Name,

tpDebugPrintStyle.tpMsg);

}

}

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ArchivesED

Manual -> Programming interfaces -> Objectmodel -> ArchivesED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The "ArchivesED" object manages the collection of "ArchiveED" objects.

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

public void MacroArchivesED()

{

IArchivesED zenonArchivesED = this.ActiveDocument.ArchivesED();

//For each archiveED in the project, output identification name and name

for (int i = 0; i < zenonArchivesED.Count; ++i)

{

this.Parent.DebugPrint(zenonArchivesED.Item(i).get_DynProperties("ShortName") +

" - " + zenonArchivesED.Item(i).get_DynProperties("LongName"),

tpDebugPrintStyle.tpMsg);

}

}

VB.NET

Public Sub MacroArchivesED()

Dim zenonArchivesED As IArchivesED = Me.ActiveDocument.ArchivesED()

'For each archiveED in the project, output identification name and name

For i As Integer = 0 To zenonArchivesED.Count - 1

Me.Parent.DebugPrint(zenonArchivesED.Item(i).get_DynProperties("ShortName") & " - " & zenonArchivesED.Item(i).get_DynProperties("LongName"), tpDebugPrintStyle.tpMsg)

Next

End Sub

VBA

Sub zenOn_ArchivesED()
'Declarations
Dim zArchivesED As ArchivesED
Dim i As Integer

'Initialize zArchivesED with the archives of the current editor project
Set zArchivesED = MyWorkspace.ActiveDocument.ArchivesED

'For every archive within the collection ...
For i = 0 To zArchivesED.Count - 1
With zArchivesED.Item(i)
'... output the identifier and the name
Debug.Print .DynProperties("ShortName") & " - " & .DynProperties("LongName")
End With
Next i

End Sub

Other topics in this chapter

ArchivesED-Properties

ArchivesED-Methods


ArchivesED-Properties

Manual -> Programming interfaces -> Objectmodel -> ArchivesED -> ArchivesED-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | read only | not used
IProject | Parent |  | read only | not used

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> ArchivesED -> ArchivesED-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> ArchivesED -> ArchivesED-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes


ArchivesED-Methods

Manual -> Programming interfaces -> Objectmodel -> ArchivesED -> ArchivesED-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CheckIn | Save module modifications to server (editor). | available | not used
VARIANT_BOOL | CheckOut | Allow module modifications (editor). | available | not used
IArchiveED | CreateArchive | - | available | not used
VARIANT_BOOL | DelArchive | - | available | not used
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | Get | Get the latest version from the server (editor). | available | not used
VARIANT_BOOL | Import | Imports the selected XML file | available | not used
VARIANT_BOOL | IsCheckedOut | Returns true when the current module checked out by the current user (editor). | read only | not used
VARIANT_BOOL | IsDifferent | Return true when the local- and server version are different (editor). | read only | not used
VARIANT_BOOL | IsLocked | Returns true when the current module is Locked by another user (editor). | read only | not used
IArchiveED | Item | - | available | not used
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used
VARIANT_BOOL | UndoCheckOut | Undo module modifications (editor). | available | not used
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used

Other topics in this chapter

Item

CreateArchive

DelArchive

Get

CheckOut

CheckIn

UndoCheckOut

IsLocked

IsCheckedOut

IsDifferent

SingleExport

Export

Import


Item

Manual -> Programming interfaces -> Objectmodel -> ArchivesED -> ArchivesED-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an "ArchiveED" object from the collection, which is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique identification name (ShortName).
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "ArchiveED" object in the list.

Hint: The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vNameOrPos) As ArchiveED

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MacroArchivesED()

{

IArchivesED zenonArchivesED = this.ActiveDocument.ArchivesED();

//For each archiveED in the project, output identification name and name

for (int i = 0; i < zenonArchivesED.Count; ++i)

{

this.Parent.DebugPrint(zenonArchivesED.Item(i).get_DynProperties("ShortName") +

" - " + zenonArchivesED.Item(i).get_DynProperties("LongName"),

tpDebugPrintStyle.tpMsg);

}

}

VB.NET

Public Sub MacroArchivesED()

Dim zenonArchivesED As IArchivesED = Me.ActiveDocument.ArchivesED()

'For each archiveED in the project, output identification name and name

For i As Integer = 0 To zenonArchivesED.Count - 1

Me.Parent.DebugPrint(zenonArchivesED.Item(i).get_DynProperties("ShortName") & " - " & zenonArchivesED.Item(i).get_DynProperties("LongName"), tpDebugPrintStyle.tpMsg)

Next

End Sub

VBA

VBA-Syntax


CreateArchive

Manual -> Programming interfaces -> Objectmodel -> ArchivesED -> ArchivesED-Methods -> CreateArchive

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new archive ("ArchiveED" object) by its term, the name and optionally the source archive, if the new archive should be the following archive of the specified one.

Datatype

CreateArchive(String bstrShortName, String bstrLongName, IArchiveED pSourceArchive) As ArchiveED

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MacroCreateArchive()

{

IArchiveED zenonArchiveED = this.ActiveDocument.ArchivesED().Item("01");

if (zenonArchiveED == null)

{

/* if there is no such archive available create it with

* the given identification name "01" and the name

* "zenon_ArchiveED"

*/

zenonArchiveED = this.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", null);

}

}

VB.NET

Public Sub MacroCreateArchive()

Dim zenonArchiveED As IArchiveED = Me.ActiveDocument.ArchivesED().Item("01")

If zenonArchiveED Is Nothing Then

' if there is no such archive available create it with

' * the given identification name "01" and the name

' * "zenon_ArchiveED"

'

zenonArchiveED = Me.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", Nothing)

End If

End Sub

VBA

VBA-Syntax


DelArchive

Manual -> Programming interfaces -> Objectmodel -> ArchivesED -> ArchivesED-Methods -> DelArchive

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Delete an existing archive ("ArchiveED" object) by its name.

Datatype

DelArchive(String bstrShortName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

VBA-Syntax

Examples

C#

public void MacroDelArchive()

{

IArchiveED zenonArchiveED = this.ActiveDocument.ArchivesED().Item("01");

if (zenonArchiveED != null)

{

//If there is an archive of given criteria - delete it

this.ActiveDocument.ArchivesED().DelArchive("01");

}

}

VB.NET

Public Sub MacroDelArchive()

Dim zenonArchiveED As IArchiveED = Me.ActiveDocument.ArchivesED().Item("01")

If zenonArchiveED IsNot Nothing Then

'If there is an archive of given criteria - delete it

Me.ActiveDocument.ArchivesED().DelArchive("01")

End If

End Sub

VBA

VBA-Syntax


Get

Manual -> Programming interfaces -> Objectmodel -> ArchivesED -> ArchivesED-Methods -> Get

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype

Get() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

VBA-Syntax

Examples

C#

public void MacroGetArchive()

{

//NOTE: This will not be functional in a non-multiuser project

this.ActiveDocument.ArchivesED().Get();

//The Archive is now up to date and can be used

}

VB.NET

Public Sub MacroGetArchive()

'NOTE: This will not be functional in a non-multiuser project

Me.ActiveDocument.ArchivesED().[Get]()

'The Archive is now up to date and can be used

End Sub

VBA

VBA-Syntax


CheckOut

Manual -> Programming interfaces -> Objectmodel -> ArchivesED -> ArchivesED-Methods -> CheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype

CheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

/* In case of a multiuser project you need to checkout your ArchiveEd object

* before editing it and you have to check it in again as soon as you're done.

* To do soyou can use the provided methods CheckIn and CheckOut of the ArchiveED

* object.

*/

public void MacroServerArchiveEd()

{

IArchivesED zenonArchives = this.ActiveDocument.ArchivesED();

if (!zenonArchives.CheckOut())

{

//Some error occured, the user will be informed

this.Parent.DebugPrint("Error while checking out archives",

tpDebugPrintStyle.tpErr);

}

//Do something with the archives in the collection object

//Code...

zenonArchives.CheckIn();

}

VB.NET

' In case of a multiuser project you need to checkout your ArchiveEd object

' * before editing it and you have to check it in again as soon as you're done.

' * To do soyou can use the provided methods CheckIn and CheckOut of the ArchiveED

' * object.

'

Public Sub MacroServerArchiveEd()

Dim zenonArchives As IArchivesED = Me.ActiveDocument.ArchivesED()

If Not zenonArchives.CheckOut() Then

'Some error occured, the user will be informed

Me.Parent.DebugPrint("Error while checking out archives", tpDebugPrintStyle.tpErr)

End If

'Do something with the archives in the collection object

'Code...

zenonArchives.CheckIn()

End Sub

VBA

VBA-Syntax


CheckIn

Manual -> Programming interfaces -> Objectmodel -> ArchivesED -> ArchivesED-Methods -> CheckIn

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype

CheckIn() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

/* In case of a multiuser project you need to checkout your ArchiveEd object

* before editing it and you have to check it in again as soon as you're done.

* To do soyou can use the provided methods CheckIn and CheckOut of the ArchiveED

* object.

*/

public void MacroServerArchiveEd()

{

IArchivesED zenonArchives = this.ActiveDocument.ArchivesED();

if (!zenonArchives.CheckOut())

{

//Some error occured, the user will be informed

this.Parent.DebugPrint("Error while checking out archives",

tpDebugPrintStyle.tpErr);

}

//Do something with the archives in the collection object

//Code...

zenonArchives.CheckIn();

}

VB.NET

' In case of a multiuser project you need to checkout your ArchiveEd object

' * before editing it and you have to check it in again as soon as you're done.

' * To do soyou can use the provided methods CheckIn and CheckOut of the ArchiveED

' * object.

'

Public Sub MacroServerArchiveEd()

Dim zenonArchives As IArchivesED = Me.ActiveDocument.ArchivesED()

If Not zenonArchives.CheckOut() Then

'Some error occured, the user will be informed

Me.Parent.DebugPrint("Error while checking out archives", tpDebugPrintStyle.tpErr)

End If

'Do something with the archives in the collection object

'Code...

zenonArchives.CheckIn()

End Sub

VBA

VBA-Syntax


UndoCheckOut

Manual -> Programming interfaces -> Objectmodel -> ArchivesED -> ArchivesED-Methods -> UndoCheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype

UndoCheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsLocked

Manual -> Programming interfaces -> Objectmodel -> ArchivesED -> ArchivesED-Methods -> IsLocked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype

IsLocked() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MacroLocked()

{

//NOTE: This will not be functional in a non-multiuser project

if (this.ActiveDocument.ArchivesED().IsLocked())

{

//The archives are currently locked

this.Parent.DebugPrint("Archives are locked", tpDebugPrintStyle.tpWarn);

}

}

VB.NET

Public Sub MacroLocked()

'NOTE: This will not be functional in a non-multiuser project

If Me.ActiveDocument.ArchivesED().IsLocked() Then

'The archives are currently locked

Me.Parent.DebugPrint("Archives are locked", tpDebugPrintStyle.tpWarn)

End If

End Sub

VBA

VBA-Syntax


IsCheckedOut

Manual -> Programming interfaces -> Objectmodel -> ArchivesED -> ArchivesED-Methods -> IsCheckedOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype

IsCheckedOut() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MacroCheckedOut()

{

//NOTE: This will not be functional in a non-multiuser project

if (this.ActiveDocument.ArchivesED().IsCheckedOut())

{

//The archives are currently checked out

this.Parent.DebugPrint("Archives are checked out", tpDebugPrintStyle.tpWarn);

}

}

VB.NET

Public Sub MacroCheckedOut()

'NOTE: This will not be functional in a non-multiuser project

If Me.ActiveDocument.ArchivesED().IsCheckedOut() Then

'The archives are currently checked out

Me.Parent.DebugPrint("Archives are checked out", tpDebugPrintStyle.tpWarn)

End If

End Sub

VBA

VBA-Syntax


IsDifferent

Manual -> Programming interfaces -> Objectmodel -> ArchivesED -> ArchivesED-Methods -> IsDifferent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype

IsDifferent() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MacroIsDifferent()

{

//NOTE: This will not be functional in a non-multiuser project

//Checks if there are differences between local and server file

if (this.ActiveDocument.ArchivesED().IsDifferent())

{

this.Parent.DebugPrint("Differences between local and server version.",

tpDebugPrintStyle.tpMsg);

}

else

{

this.Parent.DebugPrint("No differences between local and server version",

tpDebugPrintStyle.tpMsg);

}

}

VB.NET

Public Sub MacroIsDifferent()

'NOTE: This will not be functional in a non-multiuser project

'Checks if there are differences between local and server file

If Me.ActiveDocument.ArchivesED().IsDifferent() Then

Me.Parent.DebugPrint("Differences between local and server version.", tpDebugPrintStyle.tpMsg)

Else

Me.Parent.DebugPrint("No differences between local and server version", tpDebugPrintStyle.tpMsg)

End If

End Sub

VBA

VBA-Syntax


SingleExport

Manual -> Programming interfaces -> Objectmodel -> ArchivesED -> ArchivesED-Methods -> SingleExport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SingleExport(VARIANT vIndexOrName,BSTR bsFileName) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Export

Manual -> Programming interfaces -> Objectmodel -> ArchivesED -> ArchivesED-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export settings to an xml file

Datatype

Export(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to export.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub Project Active()

Set mypicevents = thisProject.Dynpictures

Stop

thisProject.SystemModelManager.Export("AnlagenmodellEditorB.xml")

thisProject.SystemModelManager.Import("AnlagenmodellEditorB.xml")
End Sub


Import

Manual -> Programming interfaces -> Objectmodel -> ArchivesED -> ArchivesED-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import settings from an xml file. Existing settings will be replaced/merged.

Datatype

Import(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to import.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub Project Active()

Set mypicevents = thisProject.Dynpictures

Stop

thisProject.SystemModelManager.Export("AnlagenmodellEditorB.xml")

thisProject.SystemModelManager.Import("AnlagenmodellEditorB.xml")
End Sub


ArchiveValue

Manual -> Programming interfaces -> Objectmodel -> ArchiveValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The "ArchiveValue" object contains the value parameters for the "ArchiveFilterVariable" object.

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

//This method will output information of the passed ArchiveFilterVariable object

public void ArchiveValue(IArchiveFilterVariable zenonArvFilterVariable)

{

IArchiveValue zenonArvValue = zenonArvFilterVariable.

ArchiveValues().Item(0);

if (zenonArvValue == null)

{

//No value available

}

else

{

//Output some information of the value

this.Parent.Parent.DebugPrint("Date / Time: " +

TimeConversion.ZenOnToSystem((uint)zenonArvValue.Time).ToString(),

tpDebugPrintStyle.tpMsg);

this.Parent.Parent.DebugPrint("Recorded Value: " + zenonArvValue.Value,

tpDebugPrintStyle.tpMsg);

this.Parent.Parent.DebugPrint("State: &H" + zenonArvValue.Status.ToString("X"),

tpDebugPrintStyle.tpMsg);

}

}

VB.NET

'This method will output information of the passed ArchiveFilterVariable object

Public Sub ArchiveValue(zenonArvFilterVariable As IArchiveFilterVariable)

Dim zenonArvValue As IArchiveValue = zenonArvFilterVariable.ArchiveValues().Item(0)

'No value available

If zenonArvValue Is Nothing Then

Else

'Output some information of the value

Me.Parent.Parent.DebugPrint("Date / Time: " & TimeConversion.ZenOnToSystem(CUInt(zenonArvValue.Time)).ToString(), tpDebugPrintStyle.tpMsg)

Me.Parent.Parent.DebugPrint("Recorded Value: " + zenonArvValue.Value, tpDebugPrintStyle.tpMsg)

Me.Parent.Parent.DebugPrint("State: &H" & zenonArvValue.Status.ToString("X"), tpDebugPrintStyle.tpMsg)

End If

End Sub

VBA

Sub zenOn_ArchiveValue(ByRef zArvFilterVar As ArchiveFilterVariable)
'Declarations
Dim zArvValue As ArchiveValue
Dim zTimeConvert As clsTimeConvert

'Initialize zArvValue with the first available value within the current archive variable
Set zArvValue = zArvFilterVar.ArchiveValues.Item(0)

'Initialize zTimeConvert by creating a new instance of the zenOn "clsTimeConvert" macro
Set zTimeConvert = New clsTimeConvert

'If no value is available ...
If zArvValue Is Nothing Then
'... then inform the user
MsgBox ("No value available!")

'Otherwise:
Else
'Output the date and time when the value was recorded
Debug.Print "Date / Time: " & Format(zTimeConvert.zenOn2System(CDbl(zArvValue.Time)), "yyyy-mm-dd hh:mm:ss") & "." & zArvValue.TimeMilliSec
'Output the recorded value
Debug.Print "Recorded value: " & zArvValue.Value
'Output the state of the value
Debug.Print "State: &H" & Hex(zArvValue.Status)
End If

End Sub

Other topics in this chapter

ArchiveValue-Properties

ArchiveValue-Methods


ArchiveValue-Properties

Manual -> Programming interfaces -> Objectmodel -> ArchiveValue -> ArchiveValue-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IArchiveValues | Parent |  | not used | read only
long | Status |  | not used | available
long | Time |  | not used | available
long | TimeMilliSec |  | not used | available
VARIANT | Value |  | not used | available

Other topics in this chapter

Parent

Time

TimeMilliSec

Value

Status


Parent

Manual -> Programming interfaces -> Objectmodel -> ArchiveValue -> ArchiveValue-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As ArchiveValues

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Time

Manual -> Programming interfaces -> Objectmodel -> ArchiveValue -> ArchiveValue-Properties -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or modifies the time when the value was recorded.

ATTENTION: zenOn uses UTC time internally, hence the desired start time has to be converted from the local time zone into UTC.

Please use the zenOn "clsTimeConvert" macro do that correctly.
For the macro code and further information on the zenOn "clsTimeConvert" macro, please have a look at the StartTime property within the "Archive Filter" object.

Datatype

Time() As long

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


TimeMilliSec

Manual -> Programming interfaces -> Objectmodel -> ArchiveValue -> ArchiveValue-Properties -> TimeMilliSec

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or modifies the milliseconds, in addition to the time, when the value was recorded.

Datatype

TimeMilliSec() As long

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


Value

Manual -> Programming interfaces -> Objectmodel -> ArchiveValue -> ArchiveValue-Properties -> Value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or modifies the value that was recorded.

Datatype

Value() As VARIANT

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


Status

Manual -> Programming interfaces -> Objectmodel -> ArchiveValue -> ArchiveValue-Properties -> Status

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or modifies the state of the recorded value.

Hint: For further information on state bits, please have a look at the ReaStatusStd part within the "State" object.

Datatype

Status() As long

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


ArchiveValue-Methods

Manual -> Programming interfaces -> Objectmodel -> ArchiveValue -> ArchiveValue-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
VARIANT_BOOL | SetModified | - | not used | available
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

SetModified


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> ArchiveValue -> ArchiveValue-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> ArchiveValue -> ArchiveValue-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.
Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> ArchiveValue -> ArchiveValue-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> ArchiveValue -> ArchiveValue-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.
Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


SetModified

Manual -> Programming interfaces -> Objectmodel -> ArchiveValue -> ArchiveValue-Methods -> SetModified

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Use this method, in order to adopt parameter modifications.

Datatype

SetModified() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

//This method is only used to apply changes, for a detailed example on how to make changes to an ArchiveValue and how to use this method correctly have a look at the main topic of the ArchiveValues collection ("ArchiveValues")

VB.NET

'This method is only used to apply changes, for a detailed example on how to make changes to an ArchiveValue and how to use this method correctly have a look at the main topic of the ArchiveValues collection ("ArchiveValues")

VBA

'This method is only used to apply changes, for a detailed example on how to make changes to an ArchiveValue and how to use this method correctly have a look at the main topic of the ArchiveValues collection ("ArchiveValues")


ArchiveValues

Manual -> Programming interfaces -> Objectmodel -> ArchiveValues

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The "ArchiveValues" object manages the "ArchiveValue" objects.This object is utilized by the "ArchiveFilterVariable" object, in order to access the collection of "ArchiveValue" objects.

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

public void ArchiveValues(IArchiveFilterVariable zenonArvFilterVariable)

{

IArchiveValues zenonArvValues = zenonArvFilterVariable.ArchiveValues();

if (zenonArvValues == null)

{

//There are no archive values, inform the user

this.Parent.Parent.DebugPrint("There are no archive values",

tpDebugPrintStyle.tpErr);

return;

}

//Create a new archive value

/* ##############################################################

* # Attention #

* # This code is designed for spontaneous archive types. #

* # If it is used in combination with a cyclic archive, the #

* # code may corrupt the archive which results in a loss of #

* # data. #

* # #

* # Use at your own risk #

* ##############################################################

*/

IArchiveValue zenonArvValue = zenonArvValues.CreateArchiveValue();

zenonArvValue.Status = 0x1000;

zenonArvValue.Time = (int)TimeConversion.SystemToZenOn(

new DateTime(2007, 07, 30, 12, 0, 0));

zenonArvValue.TimeMilliSec = 0;

//Set your desired value

zenonArvValue.Value = 1531;

//Apply changes to the value

zenonArvValue.SetModified();

//For every archive value within the collection

for (int i = 0; i < zenonArvValues.Count; ++i)

{

zenonArvValue = zenonArvValues.Item(i);

//Print the current objects value

this.Parent.Parent.DebugPrint(i + 1 + ". Value", tpDebugPrintStyle.tpMsg);

//Print the current objects recording time

this.Parent.Parent.DebugPrint("Date / Time: " +

TimeConversion.ZenOnToSystem((uint)zenonArvValue.Time).ToString(),

tpDebugPrintStyle.tpMsg);

//Print the current objects recorded value

this.Parent.Parent.DebugPrint("Recorded value: " + zenonArvValue.Value,

tpDebugPrintStyle.tpMsg);

//Print the current objects state

this.Parent.Parent.DebugPrint("State: &H" + zenonArvValue.Status.ToString("X"),

tpDebugPrintStyle.tpMsg);

}

}

VB.NET

Public Sub ArchiveValues(zenonArvFilterVariable As IArchiveFilterVariable)

Dim zenonArvValues As IArchiveValues = zenonArvFilterVariable.ArchiveValues()

If zenonArvValues Is Nothing Then

'There are no archive values, inform the user

Me.Parent.Parent.DebugPrint("There are no archive values", tpDebugPrintStyle.tpErr)

Return

End If

'Create a new archive value

' ##############################################################

' * # Attention #

' * # This code is designed for spontaneous archive types. #

' * # If it is used in combination with a cyclic archive, the #

' * # code may corrupt the archive which results in a loss of #

' * # data. #

' * # #

' * # Use at your own risk #

' * ##############################################################

'

Dim zenonArvValue As IArchiveValue = zenonArvValues.CreateArchiveValue()

zenonArvValue.Status = &H1000

zenonArvValue.Time = CInt(TimeConversion.SystemToZenOn(New DateTime(2007, 7, 30, 12, 0, 0)))

zenonArvValue.TimeMilliSec = 0

'Set your desired value

zenonArvValue.Value = 1531

'Apply changes to the value

zenonArvValue.SetModified()

'For every archive value within the collection

For i As Integer = 0 To zenonArvValues.Count - 1

zenonArvValue = zenonArvValues.Item(i)

'Print the current objects value

Me.Parent.Parent.DebugPrint(i + 1 & ". Value", tpDebugPrintStyle.tpMsg)

'Print the current objects recording time

Me.Parent.Parent.DebugPrint("Date / Time: " & TimeConversion.ZenOnToSystem(CUInt(zenonArvValue.Time)).ToString(), tpDebugPrintStyle.tpMsg)

'Print the current objects recorded value

Me.Parent.Parent.DebugPrint("Recorded value: " + zenonArvValue.Value, tpDebugPrintStyle.tpMsg)

'Print the current objects state

Me.Parent.Parent.DebugPrint("State: &H" & zenonArvValue.Status.ToString("X"), tpDebugPrintStyle.tpMsg)

Next

End Sub

VBA

Sub zenOn_ArchiveValues(ByRef zArvFilterVar As ArchiveFilterVariable)
'Declarations
Dim zArvValues As ArchiveValues
Dim zArvValue As ArchiveValue
Dim zTimeConvert As clsTimeConvert
Dim i As Integer

'Initialize zArvValue with the archive values collection of the current archive variable
Set zArvValues = zArvFilterVar.ArchiveValues

'Initialize zTimeConvert by creating a new instance of the zenOn "clsTimeConvert" macro
Set zTimeConvert = New clsTimeConvert

'If no value is available ...
If zArvValues Is Nothing Then
'... then inform the user
MsgBox ("No archive values available!")

'Otherwise:
Else
'Create a new archive value
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
'!! ATTENTION: !!
'!! This code is designed for spontaneous archive types. !!
'!! If it is used in combination with a cyclic archive, this !!
'!! code may corrupt the archive, which results in an loss of !!
'!! data. !!
'!! !!
'!! USE AT YOUR OWN RISK !!
'!! !!
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

'Initialize zArvValue by creating a new value entry
Set zArvValue = zArvValues.CreateArchiveValue

'Set the state of the value to a manual entry
zArvValue.Status = &H1000
'Set the time when the value was entered
zArvValue.Time = zTimeConvert.System2zenOn(CDbl(CDate("30.07.2007 12:00:00")))
'Set the milliseconds, in addition to the time
zArvValue.TimeMilliSec = 0
'Set the desired value
zArvValue.Value = 1531

'Apply the modifications to the value
zArvValue.SetModified

'For every archive value within the collection
For i = 0 To zArvValues.Count - 1
'Assign the current archive value to zArvValue
Set zArvValue = zArvValues.Item(i)
'Output the count of the value
Debug.Print i + 1 & ". Value"
'Output the date and time when the value was recorded
Debug.Print vbTab & "Date / Time: " & Format(zTimeConvert.zenOn2System(CDbl(zArvValue.Time)), "yyyy-mm-dd hh:mm:ss") & "." & zArvValue.TimeMilliSec
'Output the recorded value
Debug.Print vbTab & "Recorded value: " & zArvValue.Value
'Output the state of the value
Debug.Print vbTab & "State: &H" & Hex(zArvValue.Status)
Next i
End If
End Sub

Other topics in this chapter

ArchiveValues-Properties

ArchiveValues-Methods


ArchiveValues-Properties

Manual -> Programming interfaces -> Objectmodel -> ArchiveValues -> ArchiveValues-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | not used | read only
IArchiveFilterVariable | Parent |  | not used | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> ArchiveValues -> ArchiveValues-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As ArchiveFilterVariable

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> ArchiveValues -> ArchiveValues-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ArchiveValues-Methods

Manual -> Programming interfaces -> Objectmodel -> ArchiveValues -> ArchiveValues-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IArchiveValue | CreateArchiveValue | - | not used | available
VARIANT_BOOL | DeleteArchiveValue | - | not used | available
IArchiveValue | Item | - | available | available

Other topics in this chapter

Item

CreateArchiveValue

DeleteArchiveValue


Item

Manual -> Programming interfaces -> Objectmodel -> ArchiveValues -> ArchiveValues-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an "ArchiveValue" object from the collection, which is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique name.
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "ArchiveValue" object in the list.

Hint: The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vNameOrPos) As ArchiveValue

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

//For a detailed example on how to use this method have a look at the main topic ArchiveValues

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateArchiveValue

Manual -> Programming interfaces -> Objectmodel -> ArchiveValues -> ArchiveValues-Methods -> CreateArchiveValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method creates a new "ArchiveValue" object.

Datatype

CreateArchiveValue() As ArchiveValue

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

//For a detailed example have a look at the main topic ArchiveValues

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteArchiveValue

Manual -> Programming interfaces -> Objectmodel -> ArchiveValues -> ArchiveValues-Methods -> DeleteArchiveValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method removes an existing archive value ("ArchiveValue" object) from the collection.

Datatype

DeleteArchiveValue(VARIANT vNameOrPos) As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MacroDeleteArchiveValues()

{

/*

* Gets the first ArchiveFilterVariable object in the first filter of

* the first archive, NOTE: Those are required to exist in order for the

* macro to work.

*/

IArchiveFilterVariable zenonArvVariable = this.Archives().Item(0)

.ArchiveFilters()

.Item(0).ArchiveFilterVariables()

.Item(0);

IArchiveValues zenonArchiveValues = zenonArvVariable.ArchiveValues();

//Deletes any ArchiveValue in the collection

while (zenonArchiveValues.Count > 0)

{

zenonArchiveValues.DeleteArchiveValue(0);

}

}

VB.NET

Public Sub MacroDeleteArchiveValues()

'

' * Gets the first ArchiveFilterVariable object in the first filter of

' * the first archive, NOTE: Those are required to exist in order for the

' * macro to work.

'

Dim zenonArvVariable As IArchiveFilterVariable = Me.Archives().Item(0).ArchiveFilters().Item(0).ArchiveFilterVariables().Item(0)

Dim zenonArchiveValues As IArchiveValues = zenonArvVariable.ArchiveValues()

'Deletes any ArchiveValue in the collection

While zenonArchiveValues.Count > 0

zenonArchiveValues.DeleteArchiveValue(0)

End While

End Sub

VBA

VBA-Syntax


ArchiveVarED

Manual -> Programming interfaces -> Objectmodel -> ArchiveVarED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The "ArchiveVarED" object contains the assigned "Variable" object and projecting information on the calculation mode.The object is utilized by the "ArchiveED" object.

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

public void MacroArchiveVarEd()

{

IArchiveED zenonArchiveEd = this.ActiveDocument.ArchivesED().Item("01");

/* if there is no such archive available create it with

* the given identification name "01" and the name

* "zenon_ArchiveED"

*/

if (zenonArchiveEd == null)

{

zenonArchiveEd = this.ActiveDocument.ArchivesED().

CreateArchive("01", "zenOn_ArchiveED", null);

}

IArchiveVarED zenonArvVarEd = zenonArchiveEd.Item("WIZ_VAR_10");

if (zenonArvVarEd == null)

{

//If the variable is not assigned to the archive, add it

zenonArvVarEd = zenonArchiveEd.AddVariable("WIZ_VAR_10", tpArvVarCal.tpCalc_All, null);

}

//Output the name of the variable

this.Parent.DebugPrint("Variable Name: " +

((IVariable)zenonArvVarEd.get_DynProperties("Variable")).Name,

tpDebugPrintStyle.tpMsg);

//Output the calculation mode

this.Parent.DebugPrint("Calculation mode " +

Enum.GetName(typeof(tpArvVarCal),

zenonArvVarEd.get_DynProperties("Calculation")),

tpDebugPrintStyle.tpMsg);

}

VB.NET

Public Sub MacroArchiveVarEd()

Dim zenonArchiveEd As IArchiveED = Me.ActiveDocument.ArchivesED().Item("01")

' if there is no such archive available create it with

' * the given identification name "01" and the name

' * "zenon_ArchiveED"

'

If zenonArchiveEd Is Nothing Then

zenonArchiveEd = Me.ActiveDocument.ArchivesED().CreateArchive("01", "zenOn_ArchiveED", Nothing)

End If

Dim zenonArvVarEd As IArchiveVarED = zenonArchiveEd.Item("WIZ_VAR_10")

If zenonArvVarEd Is Nothing Then

'If the variable is not assigned to the archive, add it

zenonArvVarEd = zenonArchiveEd.AddVariable("WIZ_VAR_10", tpArvVarCal.tpCalc_All, Nothing)

End If

'Output the name of the variable

Me.Parent.DebugPrint("Variable Name: " + DirectCast(zenonArvVarEd.get_DynProperties("Variable"), IVariable).Name, tpDebugPrintStyle.tpMsg)

'Output the calculation mode

Me.Parent.DebugPrint("Calculation mode " & [Enum].GetName(GetType(tpArvVarCal), zenonArvVarEd.get_DynProperties("Calculation")), tpDebugPrintStyle.tpMsg)

End Sub

VBA

Sub zenOn_ArchiveVarED(ByRef zArchiveED As ArchiveED)
'Declarations
Dim zArvVarED As ArchiveVarED

'Initialize zArvVarED with the "ArchiveVarED" object, where the variable named "WIZ_VAR_10" is assigned to it.
Set zArvVarED = zArchiveED.Item("WIZ_VAR_10")
'If the variable is not assigned to it ...
If zArvVarED Is Nothing Then
'... then add it to the archive
Set zArvVarED = zArchiveED.AddVariable("WIZ_VAR_10", 0, Nothing)
End If

'Output the variable name
Debug.Print "Variable name: " & zArvVarED.DynProperties("Variable").Name

'Output the calculation mode
Select Case zArvVarED.DynProperties("Calculation")
Case 0
Debug.Print "Calculation mode: All values"
Case 1
Debug.Print "Calculation mode: Sum"
Case 2
Debug.Print "Calculation mode: Average"
Case 3
Debug.Print "Calculation mode: Minimum"
Case 4
Debug.Print "Calculation mode: Maximum"
End Select

End Sub

Other topics in this chapter

ArchiveVarED-Methods

ArchiveVarED-Dynamic properties


ArchiveVarED-Methods

Manual -> Programming interfaces -> Objectmodel -> ArchiveVarED -> ArchiveVarED-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> ArchiveVarED -> ArchiveVarED-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> ArchiveVarED -> ArchiveVarED-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> ArchiveVarED -> ArchiveVarED-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> ArchiveVarED -> ArchiveVarED-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ArchiveVarED-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> ArchiveVarED -> ArchiveVarED-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Variable archive

Other topics in this chapter

Variable archive


Variable archive

Manual -> Programming interfaces -> Objectmodel -> ArchiveVarED -> ArchiveVarED-Dynamic properties -> Variable archive

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_UI1 | Calculation | Calculation |
ZT_VARIABLE | Variable | Variable |


ArchiveVariable

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This object is an archive variable containing the projecting information. "ArchiveVariable" objects are assigned to "Archive" objects.

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

public void MacroArchiveVariable()

{

//Gets the first archive of the project

IArchive zenonArchive = this.Archives().Item(0);

if (zenonArchive == null)

{

//There is no archive, the user will be informed...

this.Parent.Parent.DebugPrint("No archive available!",

tpDebugPrintStyle.tpErr);

return;

}

IArchiveVariable zenonArvVar = zenonArchive.ArchiveVariables().Item(0);

if (zenonArvVar == null)

{

//There is no variable available

this.Parent.Parent.DebugPrint("No variable available",

tpDebugPrintStyle.tpErr);

return;

}

//Output the name of the assigned variable

this.Parent.Parent.DebugPrint("Name: " + zenonArvVar.Name,

tpDebugPrintStyle.tpMsg);

//Output the ID of the variable

this.Parent.Parent.DebugPrint("ID: " + zenonArvVar.ID,

tpDebugPrintStyle.tpMsg);

//Output the utilized unit

this.Parent.Parent.DebugPrint("Unit: " + zenonArvVar.Unit,

tpDebugPrintStyle.tpMsg);

//Output the calculation mode, if it is a following archive

this.Parent.Parent.DebugPrint("Calculation mode: " + zenonArvVar.Calculation,

tpDebugPrintStyle.tpMsg);

}

VB.NET

Public Sub MacroArchiveVariable()

'Gets the first archive of the project

Dim zenonArchive As IArchive = Me.Archives().Item(0)

If zenonArchive Is Nothing Then

'There is no archive, the user will be informed...

Me.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr)

Return

End If

Dim zenonArvVar As IArchiveVariable = zenonArchive.ArchiveVariables().Item(0)

If zenonArvVar Is Nothing Then

'There is no variable available

Me.Parent.Parent.DebugPrint("No variable available", tpDebugPrintStyle.tpErr)

Return

End If

'Output the name of the assigned variable

Me.Parent.Parent.DebugPrint("Name: " + zenonArvVar.Name, tpDebugPrintStyle.tpMsg)

'Output the ID of the variable

Me.Parent.Parent.DebugPrint("ID: " + zenonArvVar.ID, tpDebugPrintStyle.tpMsg)

'Output the utilized unit

Me.Parent.Parent.DebugPrint("Unit: " + zenonArvVar.Unit, tpDebugPrintStyle.tpMsg)

'Output the calculation mode, if it is a following archive

Me.Parent.Parent.DebugPrint("Calculation mode: " + zenonArvVar.Calculation, tpDebugPrintStyle.tpMsg)

End Sub

VBA

Sub zenOn_ArchiveVariable(ByRef zArchive As Archive)
'Declarations
Dim zArvVar As ArchiveVariable

'Initialize zArvVar with the first available archive variable within the collection
Set zArvVar = zArchive.ArchiveVariables.Item(0)

'If no archive variable is available ...
If zArvVar Is Nothing Then
'... then inform the user
MsgBox ("No archive variable available!")

'Otherwise, output some details
Else
'Output the name of the assigned variable
Debug.Print "Name: " & zArvVar.Name
'Output the ID
Debug.Print "ID: " & zArvVar.ID
'Output the utilized unit
Debug.Print "Unit: " & zArvVar.Unit
'Output the utilized calculation mode, if it is a following archive
Debug.Print "Calculation mode: " & zArvVar.Calculation
End If
End Sub

Other topics in this chapter

ArchiveVariable-Properties

ArchiveVariable-Methods


ArchiveVariable-Properties

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariable -> ArchiveVariable-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | Calculation |  | not used | read only | yes | yes
long | ID |  | not used | read only | yes | yes
BSTR | LongText |  | not used | read only | yes | yes
BSTR | Name |  | not used | read only | yes | yes
IArchiveVariables | Parent |  | not used | read only | yes | yes
IArchiveVariable | SourceVariable |  | not used | read only | yes | yes
BSTR | Unit |  | not used | read only | yes | yes

Other topics in this chapter

Parent

Name

SourceVariable

Calculation

ID

LongText

Unit


Parent

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariable -> ArchiveVariable-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As ArchiveVariables

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariable -> ArchiveVariable-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the name of the current "ArchiveVariable" object.

Datatype

Name() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


SourceVariable

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariable -> ArchiveVariable-Properties -> SourceVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

To get the SourceVariable As ArchiveVariable

Datatype

SourceVariable() As ArchiveVariable

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Calculation

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariable -> ArchiveVariable-Properties -> Calculation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Calculation() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ID

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariable -> ArchiveVariable-Properties -> ID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the unique ID of the current "ArchiveVariable" object.

Datatype

ID() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


LongText

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariable -> ArchiveVariable-Properties -> LongText

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the identifier of the current "ArchiveVariable" object.

Datatype

LongText() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Unit

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariable -> ArchiveVariable-Properties -> Unit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the unit (as string) of the current "ArchiveVariable" object.

Datatype

Unit() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ArchiveVariable-Methods

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariable -> ArchiveVariable-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IVariable | Variable | - | not used | available

Other topics in this chapter

Variable


Variable

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariable -> ArchiveVariable-Methods -> Variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the assigned variable as "Variable" object.

Datatype

Variable() As Variable

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

//For further details on how to use Variable objects have a look at the actual "Variable" topic.

VB.NET

'For further details on how to use Variable objects have a look at the actual "Variable" topic.

VBA

Sub zenOn_ArchiveVariable(ByRef zArchive As Archive)
'Declarations
Dim zArvVar As ArchiveVariable

'Initialize zArvVar with the first available archive variable within the collection
Set zArvVar = zArchive.ArchiveVariables.Item(0)

'If no archive variable is available ...
If zArvVar Is Nothing Then
'... then inform the user
MsgBox ("No archive variable available!")

'Otherwise, output some details
Else
'Output the name of the assigned variable
Debug.Print "Name: " & zArvVar.Name
'Output the ID
Debug.Print "ID: " & zArvVar.ID
'Output the utilized unit
Debug.Print "Unit: " & zArvVar.Unit
'Output the utilized calculation mode, if it is a following archive
Debug.Print "Calculation mode: " & zArvVar.Calculation
End If
End Sub


ArchiveVariables

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The "ArchiveVariables" object is a collection of all defined "ArchiveVariable" objects.This object is utilized by the "Archive" object, in order to access the collection of "ArchiveVariable" objects.

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

public void MacroArchiveVariables()

{

//Gets the first archive of the project

IArchive zenonArchive = this.Archives().Item(0);

if (zenonArchive == null)

{

//There is no archive, the user will be informed...

this.Parent.Parent.DebugPrint("No archive available!",

tpDebugPrintStyle.tpErr);

return;

}

IArchiveVariables zenonArvVariables = zenonArchive.ArchiveVariables();

for (int i = 0; i < zenonArvVariables.Count; ++i)

{

//Output the name of the variable for each variable in the collection

this.Parent.Parent.DebugPrint(i + 1 + ". Variable: " + zenonArvVariables.Item(i).Name,

tpDebugPrintStyle.tpMsg);

}

}

VB.NET

Public Sub MacroArchiveVariables()

'Gets the first archive of the project

Dim zenonArchive As IArchive = Me.Archives().Item(0)

If zenonArchive Is Nothing Then

'There is no archive, the user will be informed...

Me.Parent.Parent.DebugPrint("No archive available!", tpDebugPrintStyle.tpErr)

Return

End If

Dim zenonArvVariables As IArchiveVariables = zenonArchive.ArchiveVariables()

For i As Integer = 0 To zenonArvVariables.Count - 1

'Output the name of the variable for each variable in the collection

Me.Parent.Parent.DebugPrint((i + 1 & ". Variable: ") + zenonArvVariables.Item(i).Name, tpDebugPrintStyle.tpMsg)

Next

End Sub

VBA

Sub zenOn_ArchiveVariables(ByRef zArchive As Archive)
'Declarations
Dim zArVars As ArchiveVariables
Dim i As Integer

'Initialize zArVars with the variable collection of the passed archive
Set zArVars = zArchive.ArchiveVariables

'For every variable within the collection...
For i = 0 To zArVars.Count - 1
'... output the name of the variable
Debug.Print i + 1 & ". Variable: " & zArVars.Item(i).Name
Next i

End Sub

Other topics in this chapter

ArchiveVariables-Properties

ArchiveVariables-Methods


ArchiveVariables-Properties

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariables -> ArchiveVariables-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | not used | read only
IArchive | Parent |  | not used | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariables -> ArchiveVariables-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Archive

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariables -> ArchiveVariables-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ArchiveVariables-Methods

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariables -> ArchiveVariables-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IArchiveVariable | Item | - | available | available
IArchiveVariable | ItemById | - | not used | available
IArchiveVariable | ItemByIdEx | - | not used | read only

Other topics in this chapter

Item

ItemById

ItemByIdEx


Item

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariables -> ArchiveVariables-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an "ArchiveVariable" object from the collection, which is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique name.
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "ArchiveVariable" object in the list.

Hint: The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vNameOrPos) As ArchiveVariable

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

//For details on how to get a specific variable by its collection Id have a look at the main topic "ArchiveVariables"

VB.NET

'For details on how to get a specific variable by its collection Id have a look at the main topic "ArchiveVariables"

VBA

'For details on how to get a specific variable by its collection Id have a look at the main topic "ArchiveVariables"


ItemById

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariables -> ArchiveVariables-Methods -> ItemById

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an "ArchiveVariable" object from the collection specified by its internal uniqe ID, which is identified by the parameter vVariableId.Hint: The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

ItemById(VARIANT vVariableId) As ArchiveVariable

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ItemByIdEx

Manual -> Programming interfaces -> Objectmodel -> ArchiveVariables -> ArchiveVariables-Methods -> ItemByIdEx

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an object of type ArchiveFilterVariable.

Datatype

ItemByIdEx(VARIANT vVariableId, VARIANT vProjectName, VARIANT vCalculation) As ArchiveVariable

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

Uniqe PvID of linked zenOn Variable

Type of claculation as long
Calculation Types

Projectname as string

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vVariableId As Variant

vCalculation As Variant

vProjectName As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetArchiveVariable(zArchive As Archive)
Dim zVariable As Variable
Dim zArvVar As ArchiveVariable
'get variable object to read the PvID!
Set zVariable = thisProject.Variables.Item("WIZ_VAR_10")
'get the archivevariable with SUM calculation
Set zArvVar = zArchive.ArchiveVariables.ItemByIdEx(zVariable.PvID, thisProject.Name, 1)
End Sub


ArvTemplate

Manual -> Programming interfaces -> Objectmodel -> ArvTemplate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is used to call the dynamic properties for this object.

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

public void MacroGetTemplates()

{

IArvTemplates zenonArvTemplates = this.GetArvTemplates();

if (zenonArvTemplates != null)

{

//Get the first template if the collection is not a null pointer

IArvTemplate zenonArvTemplate = zenonArvTemplates.Item(0);

if (zenonArvTemplate != null)

{

this.Parent.DebugPrint("Name: " + zenonArvTemplate.get_DynProperties("Name"),

tpDebugPrintStyle.tpMsg);

this.Parent.DebugPrint("GUID: " + zenonArvTemplate.get_DynProperties("GUID"),

tpDebugPrintStyle.tpMsg);

this.Parent.DebugPrint("ImportPath: " + zenonArvTemplate.get_DynProperties("ImportPath"),

tpDebugPrintStyle.tpMsg);

this.Parent.DebugPrint("Folder: " + zenonArvTemplate.get_DynProperties("Folder"),

tpDebugPrintStyle.tpMsg);

this.Parent.DebugPrint("Language: " + zenonArvTemplate.get_DynProperties("Language"),

tpDebugPrintStyle.tpMsg);

this.Parent.DebugPrint("Description: " + zenonArvTemplate.get_DynProperties("Description"),

tpDebugPrintStyle.tpMsg);

this.Parent.DebugPrint("CopaDataTemplate: " + zenonArvTemplate.get_DynProperties("CopaDataTemplate"),

tpDebugPrintStyle.tpMsg);

}

}

}

VB.NET

Public Sub MacroGetTemplates()

Dim zenonArvTemplates As IArvTemplates = Me.GetArvTemplates()

If zenonArvTemplates IsNot Nothing Then

'Get the first template if the collection is not a null pointer

Dim zenonArvTemplate As IArvTemplate = zenonArvTemplates.Item(0)

If zenonArvTemplate IsNot Nothing Then

Me.Parent.DebugPrint("Name: " & zenonArvTemplate.get_DynProperties("Name"), tpDebugPrintStyle.tpMsg)

Me.Parent.DebugPrint("GUID: " & zenonArvTemplate.get_DynProperties("GUID"), tpDebugPrintStyle.tpMsg)

Me.Parent.DebugPrint("ImportPath: " & zenonArvTemplate.get_DynProperties("ImportPath"), tpDebugPrintStyle.tpMsg)

Me.Parent.DebugPrint("Folder: " & zenonArvTemplate.get_DynProperties("Folder"), tpDebugPrintStyle.tpMsg)

Me.Parent.DebugPrint("Language: " & zenonArvTemplate.get_DynProperties("Language"), tpDebugPrintStyle.tpMsg)

Me.Parent.DebugPrint("Description: " & zenonArvTemplate.get_DynProperties("Description"), tpDebugPrintStyle.tpMsg)

Me.Parent.DebugPrint("CopaDataTemplate: " & zenonArvTemplate.get_DynProperties("CopaDataTemplate"), tpDebugPrintStyle.tpMsg)

End If

End If

End Sub

VBA

Private Sub GetTemplates()

Dim IArvTemplates As ArvTemplates

Dim IArvTemplate As ArvTemplate

Dim Count As Integer

Dim Ok As Boolean

' --- Auswahl über den Namen

Set IArvTemplates = MyWorkspace.GetArvTemplates()

If Not IArvTemplates Is Nothing Then

Set IArvTemplate = IArvTemplates.Item("Test 3")

Ok = PrintTemplate(IArvTemplate)

End If

' --- Auswahl über den Index

Set IArvTemplates = MyWorkspace.GetArvTemplates()

If Not IArvTemplates Is Nothing Then

Count = IArvTemplates.Count

For i = 0 To Count - 1

Set IArvTemplate = IArvTemplates.Item(i)

Ok = PrintTemplate(IArvTemplate)

Next

End If

End Sub

Private Function PrintTemplate(IArvTemplate As ArvTemplate) As Boolean

If Not IArvTemplate Is Nothing Then

Debug.Print ("Name: " & IArvTemplate.DynProperties("Name"))

Debug.Print ("GUID: " & IArvTemplate.DynProperties("GUID"))

Debug.Print ("ImportPath: " & IArvTemplate.DynProperties("ImportPath"))

Debug.Print ("Folder: " & IArvTemplate.DynProperties("Folder"))

Debug.Print ("Language: " & IArvTemplate.DynProperties("Language"))

Debug.Print ("Description: " & IArvTemplate.DynProperties("Description"))

Debug.Print ("CopaDataTemplate: " & IArvTemplate.DynProperties("CopaDataTemplate"))

PrintTemplate = True

Else

PrintTemplate = False

End If

End Function

Other topics in this chapter

ArvTemplate-Methods

ArvTemplate-Dynamic properties


ArvTemplate-Methods

Manual -> Programming interfaces -> Objectmodel -> ArvTemplate -> ArvTemplate-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used | yes | yes
VARIANT | DynPropertiesEnum [GET] |  | read only | not used | yes | yes
VARIANT | DynProperties [GET] |  | read only | not used | yes | yes

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> ArvTemplate -> ArvTemplate-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As IPropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> ArvTemplate -> ArvTemplate-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum [GET](BSTR bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> ArvTemplate -> ArvTemplate-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties [GET](BSTR bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


ArvTemplate-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> ArvTemplate -> ArvTemplate-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

CArvTemplate

Other topics in this chapter

CArvTemplate


CArvTemplate

Manual -> Programming interfaces -> Objectmodel -> ArvTemplate -> ArvTemplate-Dynamic properties -> CArvTemplate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Name | Name | Description
VT_BSTR | GUID | GUID | Description
VT_BSTR | Language | Language | Description
VT_BSTR | ImportPath | ImportPath | Description
VT_BSTR | Folder | Folder | Description
VT_BSTR | Description | Description | Description
VT_BOOL | CopaDataTemplate | CopaDataTemplate | Description


ArvTemplates

Manual -> Programming interfaces -> Objectmodel -> ArvTemplates

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Templates can be transfered in screens.

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

public void MacroGetTemplates()

{

IArvTemplates zenonArvTemplates = this.GetArvTemplates();

if (zenonArvTemplates != null)

{

//Get the first template if the collection is not a null pointer

IArvTemplate zenonArvTemplate = zenonArvTemplates.Item(0);

if (zenonArvTemplate != null)

{

this.Parent.DebugPrint("Name: " + zenonArvTemplate.get_DynProperties("Name"),

tpDebugPrintStyle.tpMsg);

this.Parent.DebugPrint("GUID: " + zenonArvTemplate.get_DynProperties("GUID"),

tpDebugPrintStyle.tpMsg);

this.Parent.DebugPrint("ImportPath: " + zenonArvTemplate.get_DynProperties("ImportPath"),

tpDebugPrintStyle.tpMsg);

this.Parent.DebugPrint("Folder: " + zenonArvTemplate.get_DynProperties("Folder"),

tpDebugPrintStyle.tpMsg);

this.Parent.DebugPrint("Language: " + zenonArvTemplate.get_DynProperties("Language"),

tpDebugPrintStyle.tpMsg);

this.Parent.DebugPrint("Description: " + zenonArvTemplate.get_DynProperties("Description"),

tpDebugPrintStyle.tpMsg);

this.Parent.DebugPrint("CopaDataTemplate: " + zenonArvTemplate.get_DynProperties("CopaDataTemplate"),

tpDebugPrintStyle.tpMsg);

}

}

}

VB.NET

Public Sub MacroGetTemplates()

Dim zenonArvTemplates As IArvTemplates = Me.GetArvTemplates()

If zenonArvTemplates IsNot Nothing Then

'Get the first template if the collection is not a null pointer

Dim zenonArvTemplate As IArvTemplate = zenonArvTemplates.Item(0)

If zenonArvTemplate IsNot Nothing Then

Me.Parent.DebugPrint("Name: " & zenonArvTemplate.get_DynProperties("Name"), tpDebugPrintStyle.tpMsg)

Me.Parent.DebugPrint("GUID: " & zenonArvTemplate.get_DynProperties("GUID"), tpDebugPrintStyle.tpMsg)

Me.Parent.DebugPrint("ImportPath: " & zenonArvTemplate.get_DynProperties("ImportPath"), tpDebugPrintStyle.tpMsg)

Me.Parent.DebugPrint("Folder: " & zenonArvTemplate.get_DynProperties("Folder"), tpDebugPrintStyle.tpMsg)

Me.Parent.DebugPrint("Language: " & zenonArvTemplate.get_DynProperties("Language"), tpDebugPrintStyle.tpMsg)

Me.Parent.DebugPrint("Description: " & zenonArvTemplate.get_DynProperties("Description"), tpDebugPrintStyle.tpMsg)

Me.Parent.DebugPrint("CopaDataTemplate: " & zenonArvTemplate.get_DynProperties("CopaDataTemplate"), tpDebugPrintStyle.tpMsg)

End If

End If

End Sub

VBA

Private Sub GetTemplates()

Dim IArvTemplates As ArvTemplates

Dim IArvTemplate As ArvTemplate

Dim Count As Integer

Dim Ok As Boolean

' --- Auswahl über den Namen

Set IArvTemplates = MyWorkspace.GetArvTemplates()

If Not IArvTemplates Is Nothing Then

Set IArvTemplate = IArvTemplates.Item("Test 3")

Ok = PrintTemplate(IArvTemplate)

End If

' --- Auswahl über den Index

Set IArvTemplates = MyWorkspace.GetArvTemplates()

If Not IArvTemplates Is Nothing Then

Count = IArvTemplates.Count

For i = 0 To Count - 1

Set IArvTemplate = IArvTemplates.Item(i)

Ok = PrintTemplate(IArvTemplate)

Next

End If

End Sub

Private Function PrintTemplate(IArvTemplate As ArvTemplate) As Boolean

If Not IArvTemplate Is Nothing Then

Debug.Print ("Name: " & IArvTemplate.DynProperties("Name"))

Debug.Print ("GUID: " & IArvTemplate.DynProperties("GUID"))

Debug.Print ("ImportPath: " & IArvTemplate.DynProperties("ImportPath"))

Debug.Print ("Folder: " & IArvTemplate.DynProperties("Folder"))

Debug.Print ("Language: " & IArvTemplate.DynProperties("Language"))

Debug.Print ("Description: " & IArvTemplate.DynProperties("Description"))

Debug.Print ("CopaDataTemplate: " & IArvTemplate.DynProperties("CopaDataTemplate"))

PrintTemplate = True

Else

PrintTemplate = False

End If

End Function

Other topics in this chapter

ArvTemplates-Properties

ArvTemplates-Methods


ArvTemplates-Properties

Manual -> Programming interfaces -> Objectmodel -> ArvTemplates -> ArvTemplates-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | Count | Count of Archive Templates in the Collection | available | not used | yes | yes

Other topics in this chapter

Count


Count

Manual -> Programming interfaces -> Objectmodel -> ArvTemplates -> ArvTemplates-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Count() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


ArvTemplates-Methods

Manual -> Programming interfaces -> Objectmodel -> ArvTemplates -> ArvTemplates-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
IArvTemplate | Item | Returns the Archive Template by Name or Position | available | not used | yes | yes

Other topics in this chapter

Item


Item

Manual -> Programming interfaces -> Objectmodel -> ArvTemplates -> ArvTemplates-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Item(VARIANT vPosOrName) As IArvTemplate

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


BatchControlRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

A batch control recipe is an instance of a batch master recipe created for a single execution.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Other topics in this chapter

BatchControlRecipe-Properties

BatchControlRecipe-Methods


BatchControlRecipe-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | ID | Returns the Id of the control recipe | not used | read only | yes | yes
BSTR | Name | Returns the name of the control recipe | not used | read only | yes | yes
BSTR | Description | Returns the description of the control recipe | not used | read only | yes | yes
tpBatchCRState | CRState | Returns the state the control recipe | not used | read only | yes | yes
BSTR | JobId | Returns the job id the control recipe | not used | read only | yes | yes
IVariable | JobVariable | Returns the job variable of the control recipe | not used | read only | yes | yes
DATE | CreatedTime | Returns the creation time of the control recipe | not used | read only | yes | yes
BSTR | CreatedUserName | Returns the creation user name of the control recipe | not used | read only | yes | yes
BSTR | CreatedUserId | Returns the creation user id of the control recipe | not used | read only | yes | yes
DATE | StartedTime | Returns the started time of the control recipes | not used | read only | yes | yes
BSTR | StartedUserName | Returns the started user name of the control recipe | not used | read only | yes | yes
BSTR | StartedUserId | Returns the started user id of the control recipe | not used | read only | yes | yes
long | MRId | Returns the Id of the master recipe | not used | read only | yes | yes
BSTR | MRName | Returns the name of the master recipe | not used | read only | yes | yes
BSTR | MRDescription | Returns the description of the master recipe | not used | read only | yes | yes
tpBatchMRState | MRState | Returns the state of the master recipe | not used | read only | yes | yes
tpBatchExecutionState | ExecutionState | Returns the state of the recipe engine | not used | read only | yes | yes
BSTR | Type | Returns the type of the recipe | not used | read only | yes | yes
tpBatchExecutionMode | ExecutionMode | Returns the mode of the recipe | not used | read only | yes | yes
DATE | ApprovedTime | Returns the approved time of the master recipe | not used | read only | yes | yes
BSTR | ApprovedUserName | Returns the approved user name of the master recipe | not used | read only | yes | yes
BSTR | ApprovedUserId | Returns the approved user id of the master recipe | not used | read only | yes | yes
DATE | OutdatedTime | Returns the outdated time of the master recipe | not used | read only | yes | yes
BSTR | OutdatedUserName | Returns the outdated user name of the master recipe | not used | read only | yes | yes
BSTR | OutdatedUserId | Returns the outdated user id of the master recipe | not used | read only | yes | yes
long | MRVersion | Returns the version of the master recipe | not used | read only | yes | yes
long | MRSourceVersion | Returns the version of the source master recipe | not used | read only | yes | yes

Other topics in this chapter

ID

Name

Description

CRState

JobId

JobVariable

CreatedTime

CreatedUserName

CreatedUserId

StartedTime

StartedUserName

StartedUserId

MRId

MRName

MRDescription

MRState

ExecutionState

Type

ExecutionMode

ApprovedTime

ApprovedUserName

ApprovedUserId

OutdatedTime

OutdatedUserName

OutdatedUserId

MRVersion

MRSourceVersion


ID

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> ID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ID() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Name() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Description

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> Description

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Description() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


CRState

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> CRState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CRState() As tpBatchCRState

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


JobId

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> JobId

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

JobId() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


JobVariable

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> JobVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

JobVariable() As IVariable

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


CreatedTime

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> CreatedTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreatedTime() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


CreatedUserName

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> CreatedUserName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreatedUserName() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


CreatedUserId

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> CreatedUserId

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreatedUserId() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


StartedTime

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> StartedTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

StartedTime() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


StartedUserName

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> StartedUserName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

StartedUserName() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


StartedUserId

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> StartedUserId

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

StartedUserId() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


MRId

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> MRId

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MRId() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


MRName

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> MRName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MRName() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


MRDescription

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> MRDescription

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MRDescription() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


MRState

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> MRState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MRState() As tpBatchMRState

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ExecutionState

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> ExecutionState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ExecutionState() As tpBatchExecutionState

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Type

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Type() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ExecutionMode

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> ExecutionMode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ExecutionMode() As tpBatchExecutionMode

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ApprovedTime

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> ApprovedTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ApprovedTime() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ApprovedUserName

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> ApprovedUserName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ApprovedUserName() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ApprovedUserId

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> ApprovedUserId

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ApprovedUserId() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


OutdatedTime

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> OutdatedTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OutdatedTime() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


OutdatedUserName

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> OutdatedUserName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OutdatedUserName() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


OutdatedUserId

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> OutdatedUserId

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OutdatedUserId() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


MRVersion

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> MRVersion

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Version number of the template recipe.

Datatype

MRVersion() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


MRSourceVersion

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Properties -> MRSourceVersion

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Version number of the source recipe.

Datatype

MRSourceVersion() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchControlRecipe-Methods

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
tpRecipeRenameResult | SetNameAndDescription | Tries to rename the recipe and sets the description. Returns a result code whether the operation was successful or not. | not used | read only | yes | yes

Other topics in this chapter

SetNameAndDescription


SetNameAndDescription

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipe -> BatchControlRecipe-Methods -> SetNameAndDescription

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method changes the name and the description of the control recipe if possible. The method returns a result code for the operation.

Note, that the control recipe instance you are working on is a copy of the original data. To get an updated version of the control recipe you have to get it again from the control recipes container.

Datatype

SetNameAndDescription(BSTR newName, BSTR newDescription) As tpRecipeRenameResult

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

//Function to rename a control recipe and set its description

public void Macro_SetControlRecipeNameAndDescription()

{

//Get the control recipe that is to be renamed

IBatchControlRecipe cr = BatchManager().MasterRecipes().Item("masterRecipeName", 1).

ControlRecipes(tpBatchCRStateFilter.tpCRStateFilterAll).ItemByName("oldControlRecipeName");

//rename the control recipe and set its description

tpRecipeRenameResult result = cr.SetNameAndDescription("newName", "newDescription");

//Output result if the operation failed

if (result != tpRecipeRenameResult.tpRecipeRenameSuccess)

{

MessageBox.Show(null, "Rename Failed. Error Code: " + result.ToString(), "rename master recipe result", MessageBoxButtons.OK, MessageBoxIcon.None);

}

}

VB.NET

'Function to rename a control recipe and set its description

Public Sub Macro_SetControlRecipeNameAndDescription()

'Get the control recipe that is to be renamed

Dim cr As IBatchControlRecipe = BatchManager().MasterRecipes().Item("masterRecipeName", 1).ControlRecipes(tpBatchCRStateFilter.tpCRStateFilterAll).ItemByName("oldControlRecipeName")

'rename the control recipe and set its description

Dim result As tpRecipeRenameResult = cr.SetNameAndDescription("newName", "newDescription")

'Output result if the operation failed

If result <> tpRecipeRenameResult.tpRecipeRenameSuccess Then

MessageBox.Show(Nothing, "Rename Failed. Error Code: " & result.ToString(), "rename master recipe result", MessageBoxButtons.OK, MessageBoxIcon.None)

End If

End Sub

VBA

'Function to rename a control recipe and set its description

Public Sub SetControlRecipeNameAndDescription()

'Get the control recipe that is to be renamed

Dim cr As BatchControlRecipe

Set cr = thisProject.BatchManager.MasterRecipes.Item("masterRecipeName", 1).ControlRecipes(tpCRStateFilterAll).ItemByName("oldControlRecipeName")

'rename the control recipe and set its description

Dim result As tpRecipeRenameResult 'resultcode for the operation

result = cr.SetNameAndDescription("newName", "newDescription")

'Output result if the operation failed

If result <> tpRecipeRenameSuccess Then

MsgBox ("Rename Failed. Error Code: " & CStr(result))

End If

End Sub


BatchControlRecipePhaseEditedEventData

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipePhaseEditedEventData

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The data class that gets passed when the ControlRecipePhaseEdited Event of the BatchManager is fired. It contains all relevant information for this event.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

void ThisProject_Active()

{

//Check in the ControlRecipePhaseEdited Event

BatchManager().ControlRecipePhaseEdited += new ControlRecipePhaseEditedEventHandler(ThisProject_ControlRecipePhaseEdited);

}

void ThisProject_ControlRecipePhaseEdited(IBatchControlRecipePhaseEditedEventData eventData)

{

//Get the ID of the changed tags from the event data changes collection

string additionalInformation = "Changes[Tag-ID]: ";

for (var index = 0; index < eventData.Changes.TagIdCount; index++)

{

additionalInformation += "" + eventData.Changes.TagIdByIndex(index) + "; ";

}

additionalInformation += " -- Comment:\"" + eventData.Comment + "\"";

//Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] Control Recipe Edited. >> " + additionalInformation);

}

void ThisProject_Inactive()

{

//Check out the ControlRecipePhaseEdited Event

BatchManager().ControlRecipePhaseEdited -= ThisProject_ControlRecipePhaseEdited;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

VB.NET

Private Sub ThisProject_Active()

'Check in the ControlRecipePhaseEdited Event

AddHandler BatchManager().ControlRecipePhaseEdited, AddressOf ThisProject_ControlRecipePhaseEdited

End Sub

Private Sub ThisProject_ControlRecipePhaseEdited(eventData As IBatchControlRecipePhaseEditedEventData)

'Get the ID of the changed tags from the event data changes collection

Dim additionalInformation As String = "Changes[Tag-ID]: "

For index As var = 0 To eventData.Changes.TagIdCount - 1

additionalInformation += "" & eventData.Changes.TagIdByIndex(index) & "; "

Next

additionalInformation += " -- Comment:""" & Convert.ToString(eventData.Comment) & """"

'Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] Control Recipe Edited. >> " & additionalInformation)

End Sub

Private Sub ThisProject_Inactive()

'Check out the ControlRecipePhaseEdited Event

RemoveHandler BatchManager().ControlRecipePhaseEdited, AddressOf ThisProject_ControlRecipePhaseEdited

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

VBA

Other topics in this chapter

BatchControlRecipePhaseEditedEventData-Properties


BatchControlRecipePhaseEditedEventData-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipePhaseEditedEventData -> BatchControlRecipePhaseEditedEventData-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
DATE | Time | Time when the event was fired | not used | read only | yes | yes
IBatchOperation | Operation | Operation that contains the phase that fired the event. null if the phase is in no operation | not used | read only | yes | yes
IBatchControlRecipe | ControlRecipe | Control recipe for which the event was fired | not used | read only | yes | yes
IUser | User | Logged in user | not used | read only | yes | yes
IBatchPhase | OldPhase | Phase before the change | not used | read only | yes | yes
IBatchPhase | NewPhase | Phase after the change | not used | read only | yes | yes
BSTR | Comment | User Comment for the change | not used | read only | yes | yes
IBatchPhaseChanges | Changes | Ids of the changed Tags | not used | read only | yes | yes

Other topics in this chapter

Time

Operation

ControlRecipe

User

OldPhase

NewPhase

Comment

Changes


Time

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipePhaseEditedEventData -> BatchControlRecipePhaseEditedEventData-Properties -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Timestamp at which the event was fired

Datatype

Time() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Operation

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipePhaseEditedEventData -> BatchControlRecipePhaseEditedEventData-Properties -> Operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Operation that contains the changed phase that fired the event. Null if the phase is not located in an operation.

Datatype

Operation() As IBatchOperation

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ControlRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipePhaseEditedEventData -> BatchControlRecipePhaseEditedEventData-Properties -> ControlRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Control recipe that contains the phase that has been changed.

Datatype

ControlRecipe() As IBatchControlRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


User

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipePhaseEditedEventData -> BatchControlRecipePhaseEditedEventData-Properties -> User

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

User that has changed the phase

Datatype

User() As IUser

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


OldPhase

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipePhaseEditedEventData -> BatchControlRecipePhaseEditedEventData-Properties -> OldPhase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

): Phase configuration from before the change

Datatype

OldPhase() As IBatchPhase

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


NewPhase

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipePhaseEditedEventData -> BatchControlRecipePhaseEditedEventData-Properties -> NewPhase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Phase configuration after the change.

Datatype

NewPhase() As IBatchPhase

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Comment

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipePhaseEditedEventData -> BatchControlRecipePhaseEditedEventData-Properties -> Comment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Edit comment the user has entered for the change. Empty if change comments are disabled.

Datatype

Comment() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Changes

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipePhaseEditedEventData -> BatchControlRecipePhaseEditedEventData-Properties -> Changes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Object that contains information what parts of the phase where changed.

Datatype

Changes() As IBatchPhaseChanges

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchControlRecipes

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

A collection of the batch control recipes. It is used to iterate and get the control recipes.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

public void MacroBatchControlRecipes()

{

//Get all BatchControlRecipes of a specific masterRecipe "masterRecipeName"

IBatchControlRecipes recipes = BatchManager()

.MasterRecipes().Item("masterRecipeName", 1)

.ControlRecipes(tpBatchCRStateFilter.tpCRStateFilterAll);

//Print the name of all BatchControlRecipe objects inside the BatchControlRecipes collection

for (int i = 0; i < recipes.Count; i++)

this.Parent.Parent.DebugPrint(recipes.ItemByIndex(i).Name, tpDebugPrintStyle.tpMsg);

}

VB.NET

Public Sub MacroBatchControlRecipes()

'Get all BatchControlRecipes of a specific masterRecipe "masterRecipeName"

Dim recipes As IBatchControlRecipes = BatchManager().MasterRecipes().Item("masterRecipeName", 1).ControlRecipes(tpBatchCRStateFilter.tpCRStateFilterAll)

'Print the name of all BatchControlRecipe objects inside the BatchControlRecipes collection

For i As Integer = 0 To recipes.Count - 1

Me.Parent.Parent.DebugPrint(recipes.ItemByIndex(i).Name, tpDebugPrintStyle.tpMsg)

Next

End Sub

VBA

Other topics in this chapter

BatchControlRecipes-Properties

BatchControlRecipes-Methods


BatchControlRecipes-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipes -> BatchControlRecipes-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | Count | Returns the count of items in the collection of control recipes | not used | read only | yes | yes

Other topics in this chapter

Count


Count

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipes -> BatchControlRecipes-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Count() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchControlRecipes-Methods

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipes -> BatchControlRecipes-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
IBatchControlRecipe | ItemByIndex | Returns the control recipe item at the given index | not used | read only | yes | yes
IBatchControlRecipe | ItemByName | Returns the control recipe item with the specified name | not used | read only | yes | yes
IBatchControlRecipe | ItemById | Returns the control recipe item with the specified Id | not used | read only | yes | yes
IBatchRecipeId | Create | Creates a new control recipe. Returns the Id of the new Recipe or an empty Id if no recipe could be created. | not used | read only | yes | yes

Other topics in this chapter

ItemByIndex

ItemByName

ItemById

Create


ItemByIndex

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipes -> BatchControlRecipes-Methods -> ItemByIndex

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ItemByIndex(long lIndex) As IBatchControlRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


ItemByName

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipes -> BatchControlRecipes-Methods -> ItemByName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ItemByName(BSTR bstrName) As IBatchControlRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


ItemById

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipes -> BatchControlRecipes-Methods -> ItemById

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ItemById(long lId) As IBatchControlRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Create

Manual -> Programming interfaces -> Objectmodel -> BatchControlRecipes -> BatchControlRecipes-Methods -> Create

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method creates a new control recipe for the master recipe to which this control recipe container belongs.

Datatype

Create() As IBatchRecipeId

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

//Function to create a new control recipe

public void Macro_NewControlRecipe()

{

//Get a the control recipes container for the master recipe for which we want to create a new control recipe

IBatchMasterRecipe mr = BatchManager().MasterRecipes().Item("someMasterRecipe", 1);

IBatchControlRecipes crs = mr.ControlRecipes(tpBatchCRStateFilter.tpCRStateFilterAll);

//Create a new control recipe

tpCRCreateResult result; //Variable for the result code of the create operation

IBatchRecipeId newId; //Variable for the Id of the new control recipe

newId = crs.Create(out result);

//Output the result of the operation

string output = "MrId:" + newId.MRId.ToString() +

" CrId:" + newId.CRId.ToString() +

" result:" + result.ToString();

MessageBox.Show(null, output, "Create control recipe result", MessageBoxButtons.OK, MessageBoxIcon.None);

}

VB.NET

'Function to create a new control recipe

Public Sub Macro_NewControlRecipe()

'Get a the control recipes container for the master recipe for which we want to create a new control recipe

Dim mr As IBatchMasterRecipe = BatchManager().MasterRecipes().Item("someMasterRecipe", 1)

Dim crs As IBatchControlRecipes = mr.ControlRecipes(tpBatchCRStateFilter.tpCRStateFilterAll)

'Create a new control recipe

Dim result As tpCRCreateResult

'Variable for the result code of the create operation

Dim newId As IBatchRecipeId

'Variable for the Id of the new control recipe

newId = crs.Create(result)

'Output the result of the operation

Dim output As String = "MrId:" & newId.MRId.ToString() & " CrId:" & newId.CRId.ToString() & " result:" & result.ToString()

MessageBox.Show(Nothing, output, "Create control recipe result", MessageBoxButtons.OK, MessageBoxIcon.None)

End Sub

VBA

'Function to create a new control recipe

Public Sub NewControlRecipe()

'Get a the control recipes container for the master recipe for which we want to create a new control recipe

Dim mr As BatchMasterRecipe

Set mr = thisProject.BatchManager.MasterRecipes.Item("someMasterRecipe", 1)

Dim crs As BatchControlRecipes

Set crs = mr.ControlRecipes(tpCRStateFilterAll)

'Create a new control recipe

Dim result As tpCRCreateResult 'Variable for the result code of the create operation

Dim newId As BatchRecipeId 'Variable for the Id of the new control recipe

Set newId = crs.Create(result)

'Output the result of the operation

Dim output As String

output = "MrId:" & newId.MRId & " CrId:" & newId.CRId & " result:" & CStr(result)

MsgBox (output)

End Sub


BatchControlStrategy

Manual -> Programming interfaces -> Objectmodel -> BatchControlStrategy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

A control strategy used in batch phases. Control strategies are used to configure the command tags of a phase.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

BatchControlStrategy-Properties


BatchControlStrategy-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchControlStrategy -> BatchControlStrategy-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | Number | Strategy number of the control strategy | not used | read only | yes | yes
BSTR | Name | Name of the control strategy | not used | read only | yes | yes
BSTR | Description | Description of the control strategy | not used | read only | yes | yes

Other topics in this chapter

Number

Name

Description


Number

Manual -> Programming interfaces -> Objectmodel -> BatchControlStrategy -> BatchControlStrategy-Properties -> Number

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Strategy number of the control strategy.

Datatype

Number() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> BatchControlStrategy -> BatchControlStrategy-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Name of the control strategy.

Datatype

Name() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Description

Manual -> Programming interfaces -> Objectmodel -> BatchControlStrategy -> BatchControlStrategy-Properties -> Description

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Description of the control strategy.

Datatype

Description() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchCRSelectionChangedEventData

Manual -> Programming interfaces -> Objectmodel -> BatchCRSelectionChangedEventData

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

An object of this type is passed as a parameter in the CRSelectionChangedEvent

string ScreenName; Name of the Picture, in which the selection was changed

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

// instance variable for the _batchManager to register the events

private IBatchManager _batchManager;

void ThisProject_Active()

{

_batchManager = this.BatchManager();

// Register event

_batchManager.CRSelectionChanged += new CRSelectionChangedEventHandler(ThisProject_CRSelectionChanged);

}

void ThisProject_Inactive()

{

// Unregister Event

_batchManager.CRSelectionChanged -= new CRSelectionChangedEventHandler(ThisProject_CRSelectionChanged);

}

void ThisProject_CRSelectionChanged(IBatchCRSelectionChangedEventData eventData)

{

// Get control recipe selection for the screen in which the selection has changed

object[] selectedCRIds = (object[])_batchManager.SelectedCRIds(eventData.ScreenName);

// Build an output string

string selectedCRIdsInfo = "Selected CRIds[CRId | MRId): ";

foreach (object selectedCRId in selectedCRIds)

{

IBatchRecipeId crId = (IBatchRecipeId)selectedCRId;

selectedCRIdsInfo += crId.CRId + " | " + crId.MRId + "; ";

}

// Write an output message

System.Diagnostics.Debug.Print("\n" + selectedCRIdsInfo);

}

VB.NET

' instance variable for the _batchManager to register the events

Private _batchManager As IBatchManager

Private Sub ThisProject_Active()

_batchManager = Me.BatchManager()

' Register event

AddHandler _batchManager.CRSelectionChanged, AddressOf ThisProject_CRSelectionChanged

End Sub

Private Sub ThisProject_Inactive()

' Unregister Event

RemoveHandler _batchManager.CRSelectionChanged, AddressOf ThisProject_CRSelectionChanged

End Sub

Private Sub ThisProject_CRSelectionChanged(eventData As IBatchCRSelectionChangedEventData)

' Get control recipe selection for the screen in which the selection has changed

Dim selectedCRIds As Object() = DirectCast(_batchManager.SelectedCRIds(eventData.ScreenName), Object())

' Build an output string

Dim selectedCRIdsInfo As String = "Selected CRIds[CRId | MRId): "

For Each selectedCRId As Object In selectedCRIds

Dim crId As IBatchRecipeId = DirectCast(selectedCRId, IBatchRecipeId)

selectedCRIdsInfo += crId.CRId + " | " + crId.MRId & "; "

Next

' Write an output message

System.Diagnostics.Debug.Print(vbLf & selectedCRIdsInfo)

End Sub

VBA

Dim WithEvents zBatchManager As BatchManager

Private Sub Project_Active()

'Register events

Set zBatchManager = thisProject.BatchManager

End Sub

Private Sub Project_Inactive()

'Unregister events

Set zBatchManager = Nothing

End Sub

Private Sub zBatchManager_CRSelectionChanged(ByVal eventData As IBatchCRSelectionChangedEventData)

'Get the CRs of the calling screen

Dim selectedCRIds() As BatchRecipeId

selectedCRIds = zBatchManager.selectedCRIds(eventData.ScreenName)

Dim selectedCRIdsInfo As String

selectedCRIdsInfo = "Selected CRIds[CRId | MRId): "

'Get the CR Ids data

For i = 0 To UBound(selectedCRIds)

selectedCRIdsInfo = selectedCRIdsInfo & selectedCRIds(i).CRId & " | " & selectedCRIds(i).MRId & "; "

Next i

'Show messagebox with recipe Id

MsgBox (selectedCRIdsInfo)

End Sub

Other topics in this chapter

BatchCRSelectionChangedEventData-Properties


BatchCRSelectionChangedEventData-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchCRSelectionChangedEventData -> BatchCRSelectionChangedEventData-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
BSTR | ScreenName | Name of the screen in which the selection of the recipe list was changed | not used | read only | yes | yes

Other topics in this chapter

ScreenName


ScreenName

Manual -> Programming interfaces -> Objectmodel -> BatchCRSelectionChangedEventData -> BatchCRSelectionChangedEventData-Properties -> ScreenName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Name of the Picture, in which the selection was changed

Datatype

ScreenName() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchManager

Manual -> Programming interfaces -> Objectmodel -> BatchManager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Used to get the template recipe collection.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

public void MacroBatchManager()

{

IBatchManager batchManager = this.BatchManager();

//Get a master recipe over its index

int mrIndex = 0;

IBatchMasterRecipe masterRecipe = batchManager.MasterRecipes().ItemByIndex(mrIndex);

// Get a master recipe over its ID

int mrId = 42;

masterRecipe = batchManager.MasterRecipes().ItemById(mrId);

//Get the data of a master recipe over its name

string mrName = "TestMR1";

masterRecipe = batchManager.MasterRecipes().Item(mrName, 1);

//Do something with the BatchMaterRecipe

}

VB.NET

Public Sub MacroBatchManager()

Dim batchManager As IBatchManager = Me.BatchManager()

'Get a master recipe over its index

Dim mrIndex As Integer = 0

Dim masterRecipe As IBatchMasterRecipe = batchManager.MasterRecipes().ItemByIndex(mrIndex)

' Get a master recipe over its ID

Dim mrId As Integer = 42

masterRecipe = batchManager.MasterRecipes().ItemById(mrId)

'Get the data of a master recipe over its name

Dim mrName As String = "TestMR1"

masterRecipe = batchManager.MasterRecipes().Item(mrName, 1)

'Do something with the BatchMaterRecipe

End Sub

VBA

Public Sub test()

// Get a master recipe over its ID

Set masterRecipe = thisProject.batchManager.MasterRecipes. ItemById (10)

//Get the data of a master recipe over its name

Set masterRecipe = thisProject.batchManager.MasterRecipes. ItemByName ("TestMR1")

//Get a master recipe over its index

Set masterRecipe = thisProject.batchManager.MasterRecipes.ItemByIndex(10)

'print text and approved time to debug window

Debug.Print ("ApprovedTime: " & masterrecipe.ApprovedTime)

End Sub

Other topics in this chapter

BatchManager-Properties

BatchManager-Methods

BatchManager-Events


BatchManager-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
IProject | Project | Returns the parent object | not used | read only | yes | yes

Other topics in this chapter

Project


Project

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Properties -> Project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Project() As IProject

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchManager-Methods

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
IBatchMasterRecipes | MasterRecipes | Returns the collection of MasterRecipes | not used | read only | yes | yes
VARIANT | SelectedMRIds | Returns the Ids of the selected master recipes | not used | read only | yes | yes
VARIANT | SelectedCRIds | Returns the Ids of the selected control recipes | not used | read only | yes | yes

Other topics in this chapter

MasterRecipes

SelectedMRIds

SelectedCRIds


MasterRecipes

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Methods -> MasterRecipes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the collection of MasterRecipes.

Datatype

MasterRecipes() As IBatchMasterRecipes

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

/* NOTE: This example is to be seen in context of a windows forms environment and

* will not work if such is not given.

*/

private IBatchManager _batchManager;

public BatchControlViewer(IBatchManager batchManager)

{

_batchManager = batchManager;

InitializeComponent();

}

private void BatchControlViewer_Load(object sender, EventArgs e)

{

_batchManager.PhaseCommErrorEvent += new PhaseCommErrorEventEventHandler(_batchManager_PhaseCommErrorEvent);

_batchManager.PhaseEscapeEvent += new PhaseEscapeEventEventHandler(_batchManager_PhaseEscapeEvent);

_batchManager.PhaseExecErrorEvent += new PhaseExecErrorEventEventHandler(_batchManager_PhaseExecErrorEvent);

_batchManager.PhaseModeChangedEvent += new PhaseModeChangedEventEventHandler(_batchManager_PhaseModeChangedEvent);

_batchManager.PhasePlcErrorEvent += new PhasePlcErrorEventEventHandler(_batchManager_PhasePlcErrorEvent);

_batchManager.PhaseProgressEvent += new PhaseProgressEventEventHandler(_batchManager_PhaseProgressEvent);

_batchManager.PhaseRtEvent += new PhaseRtEventEventHandler(_batchManager_PhaseRtEvent);

_batchManager.PhaseStateChangedEvent += new PhaseStateChangedEventEventHandler(_batchManager_PhaseStateChangedEvent);

}

void _batchManager_PhaseStateChangedEvent(IBatchStateChangedEventData eventData)

{

AddEventTextToList("[" + eventData.Time.ToString() + "] PhaseStateChangedEvent: " + eventData.OldState + " -> " + eventData.NewState);

}

void _batchManager_PhaseRtEvent(IBatchRtEventData eventData)

{

AddEventTextToList("[" + eventData.Time.ToString() + "] PhaseRtEvent");

}

void _batchManager_PhaseProgressEvent(IBatchProgressEventData eventData)

{

AddEventTextToList("[" + eventData.Time.ToString() + "] PhaseProgressEvent");

}

void _batchManager_PhasePlcErrorEvent(IBatchPlcErrorEventData eventData)

{

AddEventTextToList("[" + eventData.Time.ToString() + "] PhasePlcErrorEvent");

}

void _batchManager_PhaseModeChangedEvent(IBatchModeChangedEventData eventData)

{

AddEventTextToList("[" + eventData.Time.ToString() + "] PhaseModeChangedEvent: " + eventData.OldMode + " -> " + eventData.NewMode);

}

void _batchManager_PhaseExecErrorEvent(IBatchExecErrorEventData eventData)

{

AddEventTextToList("[" + eventData.Time.ToString() + "] PhaseExecErrorEvent");

}

void _batchManager_PhaseEscapeEvent(IBatchEscapeEventData eventData)

{

AddEventTextToList("[" + eventData.Time.ToString() + "] PhaseEscapeEvent");

}

void _batchManager_PhaseCommErrorEvent(IBatchCommErrorEventData eventData)

{

AddEventTextToList("[" + eventData.Time.ToString() + "] PhaseCommErrorEvent");

}

private void AddEventTextToList(string eventText)

{

_listBox_events.Items.Add(eventText);

_listBox_events.SelectedIndex = _listBox_events.Items.Count - 1;

}

private void _button_clearEventList_Click(object sender, EventArgs e)

{

_listBox_events.Items.Clear();

}

private void _button_clearErrorList_Click(object sender, EventArgs e)

{

_listBox_errors.Items.Clear();

}

private void _button_reloadMR_Click(object sender, EventArgs e)

{

_dataGridView_MR.Rows.Clear();

List<int> mrIDList = new List<int>();

int mrCnt = _batchManager.MasterRecipes().Count;

for (var index = 0; index < mrCnt; index++)

{

IBatchMasterRecipe masterRecipe_temp = _batchManager.MasterRecipes().ItemByIndex(index);

if(masterRecipe_temp!= null)

mrIDList.Add(Convert.ToInt32(masterRecipe_temp.ID));

}

List<string> mrNameList = new List<string>();

foreach (var mrID in mrIDList)

mrNameList.Add(_batchManager.MasterRecipes().ItemById(mrID).Name);

foreach(string mrName in mrNameList)

{

IBatchMasterRecipe masterRecipe = _batchManager.MasterRecipes().ItemByName(mrName);

_dataGridView_MR.Rows.Add(masterRecipe.ApprovedTime,

masterRecipe.ApprovedUserId,

masterRecipe.ApprovedUserName,

masterRecipe.Description,

masterRecipe.ID,

masterRecipe.MrState,

masterRecipe.Name,

masterRecipe.OutdatedTime,

masterRecipe.OutdatedUserId,

masterRecipe.OutdatedUserName,

masterRecipe.ReeMode,

masterRecipe.ReeState,

masterRecipe.Type

);

}

Test(new Action<bool>((x) => { BatchMasterRecipe mr = new BatchMasterRecipe(); }));

Test(new Action<bool>((x) => { new BatchMasterRecipe().ApprovedTime = DateTime.Now; }));

Test(new Action<bool>((x) => { new BatchMasterRecipe().ApprovedUserId = "0"; }));

Test(new Action<bool>((x) => { new BatchMasterRecipe().ApprovedUserName = "0"; }));

Test(new Action<bool>((x) => { new BatchMasterRecipe().Description = "0"; }));

Test(new Action<bool>((x) => { new BatchMasterRecipe().ID = 0; }));

Test(new Action<bool>((x) => { new BatchMasterRecipe().MrState = tpBatchMrState.tpMRState_Creating; }));

Test(new Action<bool>((x) => { new BatchMasterRecipe().Name = "0"; }));

Test(new Action<bool>((x) => { new BatchMasterRecipe().OutdatedTime = DateTime.Now; }));

Test(new Action<bool>((x) => { new BatchMasterRecipe().OutdatedUserId = "0"; }));

Test(new Action<bool>((x) => { new BatchMasterRecipe().OutdatedUserName = "0"; }));

Test(new Action<bool>((x) => { new BatchMasterRecipe().Parent = null; }));

Test(new Action<bool>((x) => { new BatchMasterRecipe().ReeMode = tpBatchREEMode.tpRM_Automatic; }));

Test(new Action<bool>((x) => { new BatchMasterRecipe().ReeState = tpBatchREEState.tpRS_ABORTED; }));

Test(new Action<bool>((x) => { new BatchMasterRecipe().Type = "0"; }));

}

private void Test(Delegate d)

{

try

{

d.DynamicInvoke(false);

}

catch (Exception ex)

{

_listBox_errors.Items.Add(ex.InnerException.Message + " -> " + ex.InnerException.TargetSite);

}

}

VB.NET

' NOTE: This example is to be seen in context of a windows forms environment and

' * will not work if such is not given.

'

Private _batchManager As IBatchManager

Public Sub New(batchManager As IBatchManager)

_batchManager = batchManager

InitializeComponent()

End Sub

Private Sub BatchControlViewer_Load(sender As Object, e As EventArgs)

AddHandler _batchManager.PhaseCommErrorEvent, AddressOf _batchManager_PhaseCommErrorEvent

AddHandler _batchManager.PhaseEscapeEvent, AddressOf _batchManager_PhaseEscapeEvent

AddHandler _batchManager.PhaseExecErrorEvent, AddressOf _batchManager_PhaseExecErrorEvent

AddHandler _batchManager.PhaseModeChangedEvent, AddressOf _batchManager_PhaseModeChangedEvent

AddHandler _batchManager.PhasePlcErrorEvent, AddressOf _batchManager_PhasePlcErrorEvent

AddHandler _batchManager.PhaseProgressEvent, AddressOf _batchManager_PhaseProgressEvent

AddHandler _batchManager.PhaseRtEvent, AddressOf _batchManager_PhaseRtEvent

AddHandler _batchManager.PhaseStateChangedEvent, _batchManager_PhaseStateChangedEvent

End Sub

Private Sub _batchManager_PhaseStateChangedEvent(eventData As IBatchStateChangedEventData)

AddEventTextToList("[" & eventData.Time.ToString() & "] PhaseStateChangedEvent: " & Convert.ToString(eventData.OldState) & " -> " & Convert.ToString(eventData.NewState))

End Sub

Private Sub _batchManager_PhaseRtEvent(eventData As IBatchRtEventData)

AddEventTextToList("[" & eventData.Time.ToString() & "] PhaseRtEvent")

End Sub

Private Sub _batchManager_PhaseProgressEvent(eventData As IBatchProgressEventData)

AddEventTextToList("[" & eventData.Time.ToString() & "] PhaseProgressEvent")

End Sub

Private Sub _batchManager_PhasePlcErrorEvent(eventData As IBatchPlcErrorEventData)

AddEventTextToList("[" & eventData.Time.ToString() & "] PhasePlcErrorEvent")

End Sub

Private Sub _batchManager_PhaseModeChangedEvent(eventData As IBatchModeChangedEventData)

AddEventTextToList("[" & eventData.Time.ToString() & "] PhaseModeChangedEvent: " & Convert.ToString(eventData.OldMode) & " -> " & Convert.ToString(eventData.NewMode))

End Sub

Private Sub _batchManager_PhaseExecErrorEvent(eventData As IBatchExecErrorEventData)

AddEventTextToList("[" & eventData.Time.ToString() & "] PhaseExecErrorEvent")

End Sub

Private Sub _batchManager_PhaseEscapeEvent(eventData As IBatchEscapeEventData)

AddEventTextToList("[" & eventData.Time.ToString() & "] PhaseEscapeEvent")

End Sub

Private Sub _batchManager_PhaseCommErrorEvent(eventData As IBatchCommErrorEventData)

AddEventTextToList("[" & eventData.Time.ToString() & "] PhaseCommErrorEvent")

End Sub

Private Sub AddEventTextToList(eventText As String)

_listBox_events.Items.Add(eventText)

_listBox_events.SelectedIndex = _listBox_events.Items.Count - 1

End Sub

Private Sub _button_clearEventList_Click(sender As Object, e As EventArgs)

_listBox_events.Items.Clear()

End Sub

Private Sub _button_clearErrorList_Click(sender As Object, e As EventArgs)

_listBox_errors.Items.Clear()

End Sub

Private Sub _button_reloadMR_Click(sender As Object, e As EventArgs)

_dataGridView_MR.Rows.Clear()

Dim mrIDList As New List(Of Integer)()

Dim mrCnt As Integer = _batchManager.MasterRecipes().Count

For index As var = 0 To mrCnt - 1

Dim masterRecipe_temp As IBatchMasterRecipe = _batchManager.MasterRecipes().ItemByIndex(index)

If masterRecipe_temp IsNot Nothing Then

mrIDList.Add(Convert.ToInt32(masterRecipe_temp.ID))

End If

Next

Dim mrNameList As New List(Of String)()

For Each mrID As var In mrIDList

mrNameList.Add(_batchManager.MasterRecipes().ItemById(mrID).Name)

Next

For Each mrName As String In mrNameList

Dim masterRecipe As IBatchMasterRecipe = _batchManager.MasterRecipes().ItemByName(mrName)

_dataGridView_MR.Rows.Add(masterRecipe.ApprovedTime, masterRecipe.ApprovedUserId, masterRecipe.ApprovedUserName, masterRecipe.Description, masterRecipe.ID, masterRecipe.MrState, _

masterRecipe.Name, masterRecipe.OutdatedTime, masterRecipe.OutdatedUserId, masterRecipe.OutdatedUserName, masterRecipe.ReeMode, masterRecipe.ReeState, _

masterRecipe.Type)

Next

End Sub

VBA


SelectedMRIds

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Methods -> SelectedMRIds

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets all the id's of the selected recipes in the recipelist in the „bstrScreenName". If a Batchscreen ist found a INT [] is returned with the id's of the selected recipes.

Datatype

SelectedMRIds(BSTR bstrScreenName) As VARIANT

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

void ThisProject_Active()

{

//When a element ist clicked a event is fired

this.DynPictures().ElementLeftButtonDown += new ElementLeftButtonDownEventHandler(ThisProject_ElementLeftButtonDown);

}

void ThisProject_ElementLeftButtonDown(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)

{

//Get the current name of the screen

currentPictureName = obDynPicture.Name;

}

void ThisProject_Inactive()

{

this.DynPictures().ElementLeftButtonDown -= new ElementLeftButtonDownEventHandler(ThisProject_ElementLeftButtonDown);

FreeObjects();

}

#region Macros (Add macros in this region)

public void Macro_ShowSelectedRecipes()

{

if (currentPictureName == "")

return;

//Definition of the selected recipe Ids buffers

int[] selectedMRIds =(int[])this.BatchManager().SelectedMRIds(currentPictureName);

object[] selectedCRIds = (object[])this.BatchManager().SelectedCRIds(currentPictureName);

//Get MR Ids data

string selectedMRIdsInfo = "Selected MRIds: ";

foreach (int selectedMRId in selectedMRIds)

selectedMRIdsInfo += selectedMRId + "; ";

//Get CR Ids data

string selectedCRIdsInfo = "Selected CRIds[CRId | MRId): ";

foreach (object selectedCRId in selectedCRIds)

{

IBatchRecipeId crId = (IBatchRecipeId)selectedCRId;

selectedCRIdsInfo += crId.CRId + " | " + crId.MRId + "; ";

}

//Show messagebox with selected recipe Ids

MessageBox.Show(null, selectedMRIdsInfo + "\n" + selectedCRIdsInfo, "Selected Recipe Ids", MessageBoxButtons.OK, MessageBoxIcon.None);

}

#endregion

VB.NET

Private Sub ThisProject_Active()

'When a element ist clicked a event is fired

AddHandler Me.DynPictures().ElementLeftButtonDown, AddressOf ThisProject_ElementLeftButtonDown

End Sub

Private Sub ThisProject_ElementLeftButtonDown(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)

'Get the current name of the screen

currentPictureName = obDynPicture.Name

End Sub

Private Sub ThisProject_Inactive()

RemoveHandler Me.DynPictures().ElementLeftButtonDown, AddressOf ThisProject_ElementLeftButtonDown

FreeObjects()

End Sub

#Region "Macros (Add macros in this region)"

Public Sub Macro_ShowSelectedRecipes()

If currentPictureName = "" Then

Return

End If

'Definition of the selected recipe Ids buffers

Dim selectedMRIds As Integer() = DirectCast(Me.BatchManager().SelectedMRIds(currentPictureName), Integer())

Dim selectedCRIds As Object() = DirectCast(Me.BatchManager().SelectedCRIds(currentPictureName), Object())

'Get MR Ids data

Dim selectedMRIdsInfo As String = "Selected MRIds: "

For Each selectedMRId As Integer In selectedMRIds

selectedMRIdsInfo += selectedMRId & "; "

Next

'Get CR Ids data

Dim selectedCRIdsInfo As String = "Selected CRIds[CRId | MRId): "

For Each selectedCRId As Object In selectedCRIds

Dim crId As IBatchRecipeId = DirectCast(selectedCRId, IBatchRecipeId)

selectedCRIdsInfo += crId.CRId + " | " + crId.MRId & "; "

Next

'Show messagebox with selected recipe Ids

MessageBox.Show(Nothing, selectedMRIdsInfo & vbLf & selectedCRIdsInfo, "Selected Recipe Ids", MessageBoxButtons.OK, MessageBoxIcon.None)

End Sub

#End Region

VBA

Public Sub ShowSelectedRecipes()

'Definition of the screen name

Dim dynPictureName As String

dynPictureName = "MainWindow"

'Get the MRs of the calling screen

Dim selectedMRIds() As Long

selectedMRIds = thisProject.BatchManager.selectedMRIds(dynPictureName)

'Get the CRs of the calling screen

Dim selectedCRIds() As BatchRecipeId

selectedCRIds = thisProject.BatchManager.selectedCRIds(dynPictureName)

Dim selectedMRIdsInfo As String

selectedMRIdsInfo = "Selected MRIds: "

'Get the MR Ids data

For i = 0 To UBound(selectedMRIds)

selectedMRIdsInfo = selectedMRIdsInfo & selectedMRIds(i) & "; "

Next i

selectedMRIdsInfo = selectedMRIdsInfo & vbCrLf

Dim selectedCRIdsInfo As String

selectedCRIdsInfo = "Selected CRIds[CRId | MRId): "

'Get the CR Ids data

For i = 0 To UBound(selectedCRIds)

selectedCRIdsInfo = selectedCRIdsInfo & selectedCRIds(i).CRId & " | " & selectedCRIds(i).MRId & "; "

Next i

'Show messagebox with selected recipe Ids

MsgBox (selectedMRIdsInfo + selectedCRIdsInfo)

End Sub


SelectedCRIds

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Methods -> SelectedCRIds

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets all the id's of the selected control recipes in the recipelist in the „bstrScreenName". If a Batchscreen ist found a BatchRecipeId [] is returned with the id's of the selected control recipes.

Datatype

SelectedCRIds(BSTR bstrScreenName) As VARIANT

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

void ThisProject_Active()

{

//When a element ist clicked a event is fired

this.DynPictures().ElementLeftButtonDown += new ElementLeftButtonDownEventHandler(ThisProject_ElementLeftButtonDown);

}

void ThisProject_ElementLeftButtonDown(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)

{

//Get the current name of the screen

currentPictureName = obDynPicture.Name;

}

void ThisProject_Inactive()

{

this.DynPictures().ElementLeftButtonDown -= new ElementLeftButtonDownEventHandler(ThisProject_ElementLeftButtonDown);

FreeObjects();

}

#region Macros (Add macros in this region)

public void Macro_ShowSelectedRecipes()

{

if (currentPictureName == "")

return;

//Definition of the selected recipe Ids buffers

int[] selectedMRIds =(int[])this.BatchManager().SelectedMRIds(currentPictureName);

object[] selectedCRIds = (object[])this.BatchManager().SelectedCRIds(currentPictureName);

//Get MR Ids data

string selectedMRIdsInfo = "Selected MRIds: ";

foreach (int selectedMRId in selectedMRIds)

selectedMRIdsInfo += selectedMRId + "; ";

//Get CR Ids data

string selectedCRIdsInfo = "Selected CRIds[CRId | MRId): ";

foreach (object selectedCRId in selectedCRIds)

{

IBatchRecipeId crId = (IBatchRecipeId)selectedCRId;

selectedCRIdsInfo += crId.CRId + " | " + crId.MRId + "; ";

}

//Show messagebox with selected recipe Ids

MessageBox.Show(null, selectedMRIdsInfo + "\n" + selectedCRIdsInfo, "Selected Recipe Ids", MessageBoxButtons.OK, MessageBoxIcon.None);

}

#endregion

VB.NET

Private Sub ThisProject_Active()

'When a element is clicked a event is fired

AddHandler Me.DynPictures().ElementLeftButtonDown, AddressOf ThisProject_ElementLeftButtonDown

End Sub

Private Sub ThisProject_ElementLeftButtonDown(obDynPicture As IDynPicture, obElement As IElement, lPosX As Integer, lPosY As Integer, lButton As Integer)

'Get the current name of the screen

currentPictureName = obDynPicture.Name

End Sub

Private Sub ThisProject_Inactive()

RemoveHandler Me.DynPictures().ElementLeftButtonDown, AddressOf ThisProject_ElementLeftButtonDown

FreeObjects()

End Sub

#Region "Macros (Add macros in this region)"

Public Sub Macro_ShowSelectedRecipes()

If currentPictureName = "" Then

Return

End If

'Definition of the selected recipe Ids buffers

Dim selectedMRIds As Integer() = DirectCast(Me.BatchManager().SelectedMRIds(currentPictureName), Integer())

Dim selectedCRIds As Object() = DirectCast(Me.BatchManager().SelectedCRIds(currentPictureName), Object())

'Get MR Ids data

Dim selectedMRIdsInfo As String = "Selected MRIds: "

For Each selectedMRId As Integer In selectedMRIds

selectedMRIdsInfo += selectedMRId & "; "

Next

'Get CR Ids data

Dim selectedCRIdsInfo As String = "Selected CRIds[CRId | MRId): "

For Each selectedCRId As Object In selectedCRIds

Dim crId As IBatchRecipeId = DirectCast(selectedCRId, IBatchRecipeId)

selectedCRIdsInfo += crId.CRId + " | " + crId.MRId & "; "

Next

'Show messagebox with selected recipe Ids

MessageBox.Show(Nothing, selectedMRIdsInfo & vbLf & selectedCRIdsInfo, "Selected Recipe Ids", MessageBoxButtons.OK, MessageBoxIcon.None)

End Sub

#End Region

VBA

Examples

C#

void ThisProject_Active()

{

//When a element ist clicked a event is fired

this.DynPictures().ElementLeftButtonDown += new ElementLeftButtonDownEventHandler(ThisProject_ElementLeftButtonDown);

}

void ThisProject_ElementLeftButtonDown(IDynPicture obDynPicture, IElement obElement, int lPosX, int lPosY, int lButton)

{

//Get the current name of the screen

currentPictureName = obDynPicture.Name;

}

void ThisProject_Inactive()

{

this.DynPictures().ElementLeftButtonDown -= new ElementLeftButtonDownEventHandler(ThisProject_ElementLeftButtonDown);

FreeObjects();

}

#region Macros (Add macros in this region)

public void Macro_ShowSelectedRecipes()

{

if (currentPictureName == "")

return;

//Definition of the selected recipe Ids buffers

int[] selectedMRIds =(int[])this.BatchManager().SelectedMRIds(currentPictureName);

object[] selectedCRIds = (object[])this.BatchManager().SelectedCRIds(currentPictureName);

//Get MR Ids data

string selectedMRIdsInfo = "Selected MRIds: ";

foreach (int selectedMRId in selectedMRIds)

selectedMRIdsInfo += selectedMRId + "; ";

//Get CR Ids data

string selectedCRIdsInfo = "Selected CRIds[CRId | MRId): ";

foreach (object selectedCRId in selectedCRIds)

{

IBatchRecipeId crId = (IBatchRecipeId)selectedCRId;

selectedCRIdsInfo += crId.CRId + " | " + crId.MRId + "; ";

}

//Show messagebox with selected recipe Ids

MessageBox.Show(null, selectedMRIdsInfo + "\n" + selectedCRIdsInfo, "Selected Recipe Ids", MessageBoxButtons.OK, MessageBoxIcon.None);

}

#endregion

VB.NET

VBA

Public Sub ShowSelectedRecipes()

'Definition of the screen name

Dim dynPictureName As String

dynPictureName = "MainWindow"

'Get the MRs of the calling screen

Dim selectedMRIds() As Long

selectedMRIds = thisProject.BatchManager.selectedMRIds(dynPictureName)

'Get the CRs of the calling screen

Dim selectedCRIds() As BatchRecipeId

selectedCRIds = thisProject.BatchManager.selectedCRIds(dynPictureName)

Dim selectedMRIdsInfo As String

selectedMRIdsInfo = "Selected MRIds: "

'Get the MR Ids data

For i = 0 To UBound(selectedMRIds)

selectedMRIdsInfo = selectedMRIdsInfo & selectedMRIds(i) & "; "

Next i

selectedMRIdsInfo = selectedMRIdsInfo & vbCrLf

Dim selectedCRIdsInfo As String

selectedCRIdsInfo = "Selected CRIds[CRId | MRId): "

'Get the CR Ids data

For i = 0 To UBound(selectedCRIds)

selectedCRIdsInfo = selectedCRIdsInfo & selectedCRIds(i).CRId & " | " & selectedCRIds(i).MRId & "; "

Next i

'Show messagebox with selected recipe Ids

MsgBox (selectedMRIdsInfo + selectedCRIdsInfo)

End Sub


BatchManager-Events

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
void | PhaseProgress | Event is fired when there is a significant change to the internal State of a phase in during execution | not used | read only | yes | yes
void | PhaseExecutionError | Event is fired when an execution error occures in a phase (Timeouts, etc.) | not used | read only | yes | yes
void | PhaseStateChanged | Event is fired when the execution state of a phase is changed | not used | read only | yes | yes
void | PhaseModeChanged | Event is fired when the execution mode of a phase is changed | not used | read only | yes | yes
void | PhaseRuntimeEvent | Event is fired when runtime events are triggered during the execution of a phase | not used | read only | yes | yes
void | PhaseCommunicationError | Event is fired when the communication error state of a phase is changed | not used | read only | yes | yes
void | PhasePlcError | Event is fired when the plc error state of a phase is changed | not used | read only | yes | yes
void | PhaseEscape | Event is fired when the escape state of a phase is changed | not used | read only | yes | yes
void | ControlRecipePhaseEdited | Event is fired when a phase in a control recipe gets edited | not used | read only | yes | yes
void | RecipeStateChanged | Event is fired when the execution state of a recipe is changed | not used | read only | yes | yes
void | RecipeModeChanged | Event is fired when the execution mode of a recipe is changed | not used | read only | yes | yes
void | MRSelectionChanged | Event is fired when the selection in a Master Recipe List is changed | not used | read only | yes | yes
void | CRSelectionChanged | Event is fired when the selection in a Control Recipe List is changed | not used | read only | yes | yes

Other topics in this chapter

PhaseProgress

PhaseExecutionError

PhaseStateChanged

PhaseModeChanged

PhaseRuntimeEvent

PhaseCommunicationError

PhasePlcError

PhaseEscape

ControlRecipePhaseEdited

RecipeStateChanged

RecipeModeChanged

MRSelectionChanged

CRSelectionChanged


PhaseProgress

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Events -> PhaseProgress

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is fired when the phase progress changes.

List of events:

  • Phase activated
  • Unit allocation not possible
  • Phase started
  • Input interlocking blocked
  • Waiting period unit allocation exceeded
  • Waiting period input interlocking exceeded
  • Finished writing command tags
  • Maximum waiting period phase done condition exceeded
  • Phase done condition completed
  • Phase deactivated

IBatchPhaseProgressEventData contains a enum property which contains the event type.

Datatype

PhaseProgress(IBatchPhaseProgressEventData eventData) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

void ThisProject_Active()

{

//Check in the PhaseProgress Event

BatchManager().PhaseProgress += new PhaseProgressEventHandler(

ThisProject_PhaseProgress);

}

void ThisProject_PhaseProgress(IBatchPhaseProgressEventData eventData)

{

//Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhaseProgress: " + eventData.PhaseState);

}

void ThisProject_Inactive()

{

//Check out the PhaseProgress Event

BatchManager().PhaseProgress -= ThisProject_PhaseProgress;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

VB.NET

Private Sub ThisProject_Active()

'Check in the PhaseProgress Event

AddHandler BatchManager().PhaseProgress, AddressOf ThisProject_PhaseProgress

End Sub

Private Sub ThisProject_PhaseProgress(eventData As IBatchPhaseProgressEventData)

'Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] PhaseProgress: " & Convert.ToString(eventData.PhaseState))

End Sub

Private Sub ThisProject_Inactive()

'Check out the PhaseProgress Event

RemoveHandler BatchManager().PhaseProgress, AddressOf ThisProject_PhaseProgress

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

VBA

Dim WithEvents zBatchManager As batchManager

'procedure is executed on startup of the zenOn runtime

Private Sub Project_Active()

'init the Batchmanager object for events

Set zBatchManager = thisProject.batchManager

End Sub

'procedure is executed on terminating the zenOn Runtime

Private Sub Project_Inactive()

'free the batchmanager object

Set zBatchManager = Nothing

End Sub

'procedure is executed when a phase is in progress

Private Sub zBatchManager_PhaseProgress(ByVal eventData As IBatchPhaseProgressEventData)

'print time and specific information to debug window

Debug.Print (eventData.Time & " VBA-Event: Phase in Progress")

End Sub


PhaseExecutionError

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Events -> PhaseExecutionError

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Fired when execution error occurs.

List of events:

  • Phase started multiple times
  • Waiting period unit allocation exceeded
  • Waiting period input interlocking exceeded
  • Command tag without value

Datatype

PhaseExecutionError(IBatchPhaseExecutionErrorEventData eventData) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

void ThisProject_Active()

{

//Check in the PhaseExecutionError Event

BatchManager().PhaseExecutionError += new PhaseExecutionErrorEventHandler(

ThisProject_PhaseExecutionError);

}

void ThisProject_PhaseExecutionError(IBatchPhaseExecutionErrorEventData eventData)

{

//Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhaseExecutionError: " + eventData.ExecutionErrorState);

}

void ThisProject_Inactive()

{

//Check out the PhaseExecutionError Event

BatchManager().PhaseExecutionError -= ThisProject_PhaseExecutionError;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

VB.NET

Private Sub ThisProject_Active()

'Check in the PhaseExecutionError Event

AddHandler BatchManager().PhaseExecutionError, AddressOf ThisProject_PhaseExecutionError

End Sub

Private Sub ThisProject_PhaseExecutionError(eventData As IBatchPhaseExecutionErrorEventData)

'Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] PhaseExecutionError: " & Convert.ToString(eventData.ExecutionErrorState))

End Sub

Private Sub ThisProject_Inactive()

'Check out the PhaseExecutionError Event

RemoveHandler BatchManager().PhaseExecutionError, AddressOf ThisProject_PhaseExecutionError

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

VBA

Dim WithEvents zBatchManager As batchManager

'procedure is executed on startup of the zenOn runtime

Private Sub Project_Active()

'init the batchmanager object for events

Set zBatchManager = thisProject.batchManager

End Sub

'procedure is executed on terminating the zenOn Runtime

Private Sub Project_Inactive()

'free the batchmanager object

Set zBatchManager = Nothing

End Sub

'procedure is executed when a phase gets an error

Private Sub zBatchManager_PhaseExecutionError(ByVal eventData As IBatchPhaseExecutionErrorEventData)

'print time and specific information to debug window

Debug.Print (eventData.Time & " VBA-Event: Execution Error")

End Sub


PhaseStateChanged

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Events -> PhaseStateChanged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Fired when the phase state changes (running, paused, etc...).

List of displayed execution events:

  • State change: In execution
  • State change: Pausing
  • State change: Paused
  • State change:Finished
  • State change: Restart
  • State change: Holding
  • State change: Held
  • State change: Stopping
  • State change: Stopped
  • State change: Aborting
  • State change: Aborted
  • State change: Continue

Datatype

PhaseStateChanged(IBatchPhaseStateChangedEventData eventData) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

void ThisProject_Active()

{

//Check in the PhaseStateChanged Event

BatchManager().PhaseStateChanged += new PhaseStateChangedEventHandler(

ThisProject_PhaseStateChanged);

}

void ThisProject_PhaseStateChanged(IBatchPhaseStateChangedEventData eventData)

{

//Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhaseStateChanged: " + eventData.OldSExecutiontate + " -> " + eventData.NewExecutionState);

}

void ThisProject_Inactive()

{

//Check out the PhaseStateChanged Event

BatchManager().PhaseStateChanged -= ThisProject_PhaseStateChanged;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

VB.NET

Private Sub ThisProject_Active()

'Check in the PhaseStateChanged Event

AddHandler BatchManager().PhaseStateChanged, AddressOf ThisProject_PhaseStateChanged

End Sub

Private Sub ThisProject_PhaseStateChanged(eventData As IBatchPhaseStateChangedEventData)

'Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] PhaseStateChanged: " & Convert.ToString(eventData.OldSExecutiontate) & " -> " & Convert.ToString(eventData.NewExecutionState))

End Sub

Private Sub ThisProject_Inactive()

'Check out the PhaseStateChanged Event

RemoveHandler BatchManager().PhaseStateChanged, AddressOf ThisProject_PhaseStateChanged

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

VBA

Dim WithEvents zBatchManager As batchManager

'procedure is executed on startup of the zenOn runtime

Private Sub Project_Active()

'init the Batchmanager object for events

Set zBatchManager = thisProject.batchManager

End Sub

'procedure is executed on terminating the zenOn Runtime

Private Sub Project_Inactive()

'free the batchmanager object

Set zBatchManager = Nothing

End Sub

'procedure is executed when the state of the phase gets changed

Private Sub zBatchManager_PhaseStateChanged(ByVal eventData As IBatchPhaseStateChangedEventData)

'print time and specific information to debug window

Debug.Print (eventData.Time & " Phase state changed")

End Sub


PhaseModeChanged

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Events -> PhaseModeChanged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Fired when a execution mode changes (manual, semi-automatic, automatic), during a active phase.

List of events

  • REE mode change: automatic
  • REE mode change: semi-automatic
  • REE mode change: manual

Datatype

PhaseModeChanged(IBatchPhaseModeChangedEventData eventData) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

void ThisProject_Active()

{

//Check in the PhaseModeChanged Event

BatchManager().PhaseModeChanged += new PhaseModeChangedEventHandler(ThisProject_PhaseModeChanged);

}

void ThisProject_PhaseModeChanged(IBatchPhaseModeChangedEventData eventData)

{

//Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhaseModeChanged: " + eventData.OldExecutionMode + " -> " + eventData.NewExecutionMode);

}

void ThisProject_Inactive()

{

//Check out the PhaseModeChanged Event

BatchManager().PhaseModeChanged -= ThisProject_PhaseModeChanged;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

VB.NET

Private Sub ThisProject_Active()

'Check in the PhaseModeChanged Event

AddHandler BatchManager().PhaseModeChanged, AddressOf ThisProject_PhaseModeChanged

End Sub

Private Sub ThisProject_PhaseModeChanged(eventData As IBatchPhaseModeChangedEventData)

'Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] PhaseModeChanged: " & Convert.ToString(eventData.OldExecutionMode) & " -> " & Convert.ToString(eventData.NewExecutionMode))

End Sub

Private Sub ThisProject_Inactive()

'Check out the PhaseModeChanged Event

RemoveHandler BatchManager().PhaseModeChanged, AddressOf ThisProject_PhaseModeChanged

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

VBA

Dim WithEvents zBatchManager As batchManager

'procedure is executed on startup of the zenOn runtime

Private Sub Project_Active()

'init the Batchmanager object for events

Set zBatchManager = thisProject.batchManager

End Sub

'procedure is executed on terminating the zenOn Runtime

Private Sub Project_Inactive()

'free the batchmanager object

Set zBatchManager = Nothing

End Sub

'procedure is executed when the execution mode gets changed while a phase is active

Private Sub zBatchManager_PhaseModeChanged(ByVal eventData As IBatchPhaseModeChangedEventData)

'print time and specific information to debug window

Debug.Print (eventData.Time & " VBA-Event: Phase Mode changed")

End Sub


PhaseRuntimeEvent

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Events -> PhaseRuntimeEvent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Fired when closing or restarting the runtime, during a active phase.

List of events:

  • Runtime closing
  • Runtime restart

Datatype

PhaseRuntimeEvent(IBatchPhaseRuntimeEventData eventData) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

void ThisProject_Active()

{

//Check in the PhaseRuntime Event

BatchManager().PhaseRuntimeEvent += new PhaseRuntimeEventEventHandler(

ThisProject_PhaseRuntimeEvent);

}

void ThisProject_PhaseRuntimeEvent(IBatchPhaseRuntimeEventData eventData)

{

//Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhaseRuntimeEvent: "

+ eventData.RuntimeEvent);

}

void ThisProject_Inactive()

{

//Check out the PhaseRuntime Event

BatchManager().PhaseRuntimeEvent -= ThisProject_PhaseRuntimeEvent;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

VB.NET

Private Sub ThisProject_Active()

'Check in the PhaseRuntime Event

AddHandler BatchManager().PhaseRuntimeEvent, AddressOf ThisProject_PhaseRuntimeEvent

End Sub

Private Sub ThisProject_PhaseRuntimeEvent(eventData As IBatchPhaseRuntimeEventData)

'Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhaseRuntimeEvent: " + eventData.RuntimeEvent)

End Sub

Private Sub ThisProject_Inactive()

'Check out the PhaseRuntime Event

RemoveHandler BatchManager().PhaseRuntimeEvent, AddressOf ThisProject_PhaseRuntimeEvent

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

VBA

Dim WithEvents zBatchManager As batchManager

'procedure is executed on startup of the zenOn runtime

Private Sub Project_Active()

'init the Batchmanager object for events

Set zBatchManager = thisProject.batchManager

End Sub

'procedure is executed on terminating the zenOn Runtime

Private Sub Project_Inactive()

'free the batchmanager object

Set zBatchManager = Nothing

End Sub

'procedure is executed when the RT gets started or closed while a phase is active

Private Sub zBatchManager_PhaseRuntimeEvent(ByVal eventData As IBatchPhaseRuntimeEventData)

'print time and specific information to debug window

Debug.Print (eventData.Time & " VBA-Event: RT event")

End Sub


PhaseCommunicationError

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Events -> PhaseCommunicationError

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Fired in case of a communication error, or the communication state changes.

List of events:

  • Loss of communication
  • Loss of communication fixed
  • Loss of communication acknowledged

Datatype

PhaseCommunicationError(IBatchPhaseCommunicationErrorEventData eventData) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

void ThisProject_Active()

{

//Check in the PhaseCommunicationError Event

BatchManager().PhaseCommunicationError += new PhaseCommunicationErrorEventHandler(

ThisProject_PhaseCommunicationError);

}

void ThisProject_PhaseCommunicationError(IBatchPhaseCommunicationErrorEventData eventData)

{

//Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhaseCommunicationError: " + eventData.CommunicationErrorState);

}

void ThisProject_Inactive()

{

//Check out the PhaseCommunicationError Event

BatchManager().PhaseCommunicationError -= ThisProject_PhaseCommunicationError;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

VB.NET

Private Sub ThisProject_Active()

'Check in the PhaseCommunicationError Event

AddHandler BatchManager().PhaseCommunicationError, AddressOf ThisProject_PhaseCommunicationError

End Sub

Private Sub ThisProject_PhaseCommunicationError(eventData As IBatchPhaseCommunicationErrorEventData)

'Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] PhaseCommunicationError: " & Convert.ToString(eventData.CommunicationErrorState))

End Sub

Private Sub ThisProject_Inactive()

'Check out the PhaseCommunicationError Event

RemoveHandler BatchManager().PhaseCommunicationError, AddressOf ThisProject_PhaseCommunicationError

'Final release and garbage collection of any API-Objects.

FreeObjects

End Sub

VBA

Dim WithEvents zBatchManager As batchManager

'procedure is executed on startup of the zenOn runtime

Private Sub Project_Active()

'init the Batchmanager object for events

Set zBatchManager = thisProject.batchManager

End Sub

'procedure is executed on terminating the zenOn Runtime

Private Sub Project_Inactive()

'free the batchmanager object

Set zBatchManager = Nothing

End Sub

'procedure is executed when a active phase gets a communication error or the error state gets changed

Private Sub zBatchManager_PhaseCommunicationError(ByVal eventData As IBatchPhaseCommunicationErrorEventData)

'print time and specific information to debug window

Debug.Print (eventData.Time & " VBA-Event: Communication error")

End Sub


PhasePlcError

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Events -> PhasePlcError

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Fired when a plc error enters or leaves.

Datatype

PhasePlcError(IBatchPhasePlcErrorEventData eventData) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

void ThisProject_Active()

{

//Check in the PhasePlcError Event

BatchManager().PhasePlcError += new PhasePlcErrorEventHandler(

ThisProject_PhasePlcError);

}

void ThisProject_PhasePlcError(IBatchPhasePlcErrorEventData eventData)

{

//Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhasePlcError: " + eventData.PlcErrorState);

}

void ThisProject_Inactive()

{

//Check out the PhasePlcError Event

BatchManager().PhasePlcError -= ThisProject_PhasePlcError;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

VB.NET

Private Sub ThisProject_Active()

'Check in the PhasePlcError Event

AddHandler BatchManager().PhasePlcError, AddressOf ThisProject_PhasePlcError

End Sub

Private Sub ThisProject_PhasePlcError(eventData As IBatchPhasePlcErrorEventData)

'Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] PhasePlcError: " & Convert.ToString(eventData.PlcErrorState))

End Sub

Private Sub ThisProject_Inactive()

'Check out the PhasePlcError Event

RemoveHandler BatchManager().PhasePlcError, AddressOf ThisProject_PhasePlcError

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

VBA

Dim WithEvents zBatchManager As batchManager

'procedure is executed on startup of the zenOn runtime

Private Sub Project_Active()

'init the Batchmanager object for events

Set zBatchManager = thisProject.batchManager

End Sub

'procedure is executed on terminating the zenOn Runtime

Private Sub Project_Inactive()

'free the batchmanager object

Set zBatchManager = Nothing

End Sub

'procedure is executed when the PLC gets an error or the error is gone while a phase is active

Private Sub zBatchManager_PhasePlcError(ByVal eventData As IBatchPhasePlcErrorEventData)

'print time and specific information to debug window

Debug.Print (eventData.Time & " VBA-Event: PLC error")

End Sub


PhaseEscape

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Events -> PhaseEscape

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Fired when closing/leaving a phase.

List of events:

  • Escape condition started
  • Escape condition fulfilled

Datatype

PhaseEscape(IBatchPhaseEscapeEventData eventData) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

void ThisProject_Active()

{

//Check in the PhaseEscape Event

BatchManager().PhaseEscape += new PhaseEscapeEventHandler(

ThisProject_PhaseEscape);

}

void ThisProject_PhaseEscape (IBatchPhaseEscapeEventData eventData)

{

//Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhaseEscape: "

+ eventData.EscapeState);

}

void ThisProject_Inactive()

{

//Check out the PhaseEscape Event

BatchManager().PhaseEscape -= ThisProject_PhaseEscape;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

VB.NET

Private Sub ThisProject_Active()

'Check in the PhaseEscape Event

AddHandler BatchManager().PhaseEscape, AddressOf ThisProject_PhaseEscape

End Sub

Private Sub ThisProject_PhaseEscape(eventData As IBatchPhaseEscapeEventData)

'Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] PhaseEscape: " + eventData.EscapeState)

End Sub

Private Sub ThisProject_Inactive()

'Check out the PhaseEscape Event

RemoveHandler BatchManager().PhaseEscape, AddressOf ThisProject_PhaseEscape

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

VBA

Dim WithEvents zBatchManager As batchManager

'procedure is executed on startup of the zenOn runtime

Private Sub Project_Active()

'init the Batchmanager object for events

Set zBatchManager = thisProject.batchManager

End Sub

'procedure is executed on terminating the zenOn Runtime

Private Sub Project_Inactive()

'free the batchmanager object

Set zBatchManager = Nothing

End Sub

'procedure is executed when a phase gets or is escaped

Private Sub zBatchManager_PhaseEscape(ByVal eventData As IBatchPhaseEscapeEventData)

'print time and specific information to debug window

Debug.Print (eventData.Time & " VBA-Event: Escape")

End Sub


ControlRecipePhaseEdited

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Events -> ControlRecipePhaseEdited

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The event gets fired, when a phase in a control recipe is edited. The eventData object contains all information about the change that was made.

Datatype

ControlRecipePhaseEdited(IBatchControlRecipePhaseEditedEventData eventData) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

void ThisProject_Active()

{

//Check in the ControlRecipePhaseEdited Event

BatchManager().ControlRecipePhaseEdited += new ControlRecipePhaseEditedEventHandler(ThisProject_ControlRecipePhaseEdited);

}

void ThisProject_ControlRecipePhaseEdited(IBatchControlRecipePhaseEditedEventData eventData)

{

//Get the ID of the changed tags from the event data changes collection

string additionalInformation = "Changes[Tag-ID]: ";

for (var index = 0; index < eventData.Changes.TagIdCount; index++)

{

additionalInformation += "" + eventData.Changes.TagIdByIndex(index) + "; ";

}

additionalInformation += " -- Comment:\"" + eventData.Comment + "\"";

//Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] Control Recipe Edited. >> " + additionalInformation);

}

void ThisProject_Inactive()

{

//Check out the ControlRecipePhaseEdited Event

BatchManager().ControlRecipePhaseEdited -= ThisProject_ControlRecipePhaseEdited;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

VB.NET

Private Sub ThisProject_Active()

'Check in the ControlRecipePhaseEdited Event

AddHandler BatchManager().ControlRecipePhaseEdited, AddressOf ThisProject_ControlRecipePhaseEdited

End Sub

Private Sub ThisProject_ControlRecipePhaseEdited(eventData As IBatchControlRecipePhaseEditedEventData)

'Get the ID of the changed tags from the event data changes collection

Dim additionalInformation As String = "Changes[Tag-ID]: "

For index As var = 0 To eventData.Changes.TagIdCount - 1

additionalInformation += "" & eventData.Changes.TagIdByIndex(index) & "; "

Next

additionalInformation += " -- Comment:""" & Convert.ToString(eventData.Comment) & """"

'Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] Control Recipe Edited. >> " & additionalInformation)

End Sub

Private Sub ThisProject_Inactive()

'Check out the ControlRecipePhaseEdited Event

RemoveHandler BatchManager().ControlRecipePhaseEdited, AddressOf ThisProject_ControlRecipePhaseEdited

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

VBA


RecipeStateChanged

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Events -> RecipeStateChanged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired when the execution state of a recipe changes

Changes to the recipe execution state that cause this event:

  • State change: running
  • State change: pausing
  • State change: paused
  • State change: resume
  • State change: holding
  • State change: held
  • State change: restarting
  • State change: stopping
  • State change: stopped
  • State change: aborting
  • State change: aborted
  • State change: complete

Datatype

RecipeStateChanged(IBatchRecipeStateChangedEventData eventData) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

void ThisProject_Active()

{

//Check in the RecipeStateChanged Event

BatchManager().RecipeStateChanged += new RecipeStateChangedEventHandler (

ThisProject_RecipeStateChanged);

}

void ThisProject_RecipeStateChanged(IBatchRecipeStateChangedEventData eventData)

{

//Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] RecipeStateChanged: " + eventData.OldExecutionState + " -> " + eventData.NewExecutionState);

}

void ThisProject_Inactive()

{

//Check out the RecipeStateChanged Event

BatchManager().RecipeStateChanged -= ThisProject_RecipeStateChanged;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

VB.NET

Private Sub ThisProject_Active()

'Check in the RecipeStateChanged Event

AddHandler BatchManager().RecipeStateChanged, AddressOf ThisProject_RecipeStateChanged

End Sub

Private Sub ThisProject_RecipeStateChanged(eventData As IBatchRecipeStateChangedEventData)

'Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] RecipeStateChanged: " & Convert.ToString(eventData.OldExecutionState) & " -> " & Convert.ToString(eventData.NewExecutionState))

End Sub

Private Sub ThisProject_Inactive()

'Check out the RecipeStateChanged Event

RemoveHandler BatchManager().RecipeStateChanged, AddressOf ThisProject_RecipeStateChanged

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

VBA

Dim WithEvents zBatchManager As batchManager

'procedure is executed on startup of the zenOn runtime

Private Sub Project_Active()

'init the Batchmanager object for events

Set zBatchManager = thisProject.batchManager

End Sub

'procedure is executed on terminating the zenOn Runtime

Private Sub Project_Inactive()

'free the batchmanager object

Set zBatchManager = Nothing

End Sub

'procedure is executed when a recipe changes its state

Private Sub zBatchManager_ RecipeStateChanged (ByVal eventData As IBatchRecipeStateChangedEventData)

'print time and specific information to debug window

Debug.Print (eventData.Time & " VBA-Event: Recipe State change")

End Sub


RecipeModeChanged

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Events -> RecipeModeChanged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired if the execution mode of a recipe is changed during its execution. Additionally it is fired once at the start of the recipe with the initial mode as old and as new mode.

Changes to the execution mode that cause this event:

  • Mode Change: automatic
  • Mode Change: semi-automatic
  • Mode Change: manual

Datatype

RecipeModeChanged(IBatchRecipeModeChangedEventData eventData) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

void ThisProject_Active()

{

//Check in the RecipeModeChanged Event

BatchManager().RecipeModeChanged += new RecipeModeChangedEventHandler (

ThisProject_RecipeModeChanged);

}

void ThisProject_RecipeModeChanged(IBatchRecipeModeChangedEventData eventData)

{

//Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] RecipeModeChanged: " + eventData.OldExecutionMode + " -> " + eventData.NewExecutionMode);

}

void ThisProject_Inactive()

{

//Check out the RecipeModeChanged Event

BatchManager().RecipeModeChanged -= ThisProject_RecipeModeChanged;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

VB.NET

Private Sub ThisProject_Active()

'Check in the RecipeModeChanged Event

AddHandler BatchManager().RecipeModeChanged, AddressOf ThisProject_RecipeModeChanged

End Sub

Private Sub ThisProject_RecipeModeChanged(eventData As IBatchRecipeModeChangedEventData)

'Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" & Convert.ToString(eventData.Time) & "] RecipeModeChanged: " & Convert.ToString(eventData.OldExecutionMode) & " -> " & Convert.ToString(eventData.NewExecutionMode))

End Sub

Private Sub ThisProject_Inactive()

'Check out the RecipeModeChanged Event

RemoveHandler BatchManager().RecipeModeChanged, AddressOf ThisProject_RecipeModeChanged

'Final release and garbage collection of any API-Objects.

FreeObjects()

End Sub

VBA

Dim WithEvents zBatchManager As batchManager

'procedure is executed on startup of the zenOn runtime

Private Sub Project_Active()

'init the Batchmanager object for events

Set zBatchManager = thisProject.batchManager

End Sub

'procedure is executed on terminating the zenOn Runtime

Private Sub Project_Inactive()

'free the batchmanager object

Set zBatchManager = Nothing

End Sub

'procedure is executed when a recipe changes its mode

Private Sub zBatchManager_ RecipeModeChanged (ByVal eventData As IBatchRecipeModeChangedEventData)

'print time and specific information to debug window

Debug.Print (eventData.Time & " VBA-Event: Recipe Mode change")

End Sub


MRSelectionChanged

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Events -> MRSelectionChanged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired when the selection in the screen element master recipe list changes.

Datatype

MRSelectionChanged(IBatchMRSelectionChangedEventData eventData) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

// local variable for the batchManager to register the events

private IBatchManager batchManager = null;

void ThisProject_Active()

{

// Register event

batchManager.MRSelectionChanged += new MRSelectionChangedEventHandler(ThisProject_MRSelectionChanged);

}

void ThisProject_Inactive()

{

// unregister Event

batchManager.MRSelectionChanged -= new MRSelectionChangedEventHandler(ThisProject_MRSelectionChanged);

}

void ThisProject_MRSelectionChanged(IBatchMRSelectionChangedEventData eventData)

{

// Get master recipe selection for the screen in which the selection has changed

int[] selectedMRIds = (int[])batchManager.SelectedMRIds(eventData.ScreenName);

// Build an output string

string selectedMRIdsInfo = "Selected MRIds: ";

foreach (int selectedMRId in selectedMRIds)

selectedMRIdsInfo += selectedMRId + "; ";

// Write an output message

System.Diagnostics.Debug.Print("\n" + selectedMRIdsInfo);

}

VB.NET

' local variable for the batchManager to register the events

Private batchManager As IBatchManager = Nothing

Private Sub ThisProject_Active()

' Register event

AddHandler batchManager.MRSelectionChanged, AddressOf ThisProject_MRSelectionChanged

End Sub

Private Sub ThisProject_Inactive()

' unregister Event

RemoveHandler batchManager.MRSelectionChanged, AddressOf ThisProject_MRSelectionChanged

End Sub

Private Sub ThisProject_MRSelectionChanged(eventData As IBatchMRSelectionChangedEventData)

' Get master recipe selection for the screen in which the selection has changed

Dim selectedMRIds As Integer() = DirectCast(batchManager.SelectedMRIds(eventData.ScreenName), Integer())

' Build an output string

Dim selectedMRIdsInfo As String = "Selected MRIds: "

For Each selectedMRId As Integer In selectedMRIds

selectedMRIdsInfo += selectedMRId + "; "

Next

' Write an output message

System.Diagnostics.Debug.Print(Convert.ToString(vbLf) & selectedMRIdsInfo)

End Sub

VBA

Examples

C#

// local variable for the batchManager to register the events

private IBatchManager batchManager = null;

void ThisProject_Active()

{

// Register event

batchManager.MRSelectionChanged += new MRSelectionChangedEventHandler(ThisProject_MRSelectionChanged);

}

void ThisProject_Inactive()

{

// unregister Event

batchManager.MRSelectionChanged -= new MRSelectionChangedEventHandler(ThisProject_MRSelectionChanged);

}

void ThisProject_MRSelectionChanged(IBatchMRSelectionChangedEventData eventData)

{

// Get master recipe selection for the screen in which the selection has changed

int[] selectedMRIds = (int[])batchManager.SelectedMRIds(eventData.ScreenName);

// Build an output string

string selectedMRIdsInfo = "Selected MRIds: ";

foreach (int selectedMRId in selectedMRIds)

selectedMRIdsInfo += selectedMRId + "; ";

// Write an output message

System.Diagnostics.Debug.Print("\n" + selectedMRIdsInfo);

}

VB.NET

VBA

Dim WithEvents zBatchManager As BatchManager

Private Sub Project_Active()

'Register events

Set zBatchManager = thisProject.BatchManager

End Sub

Private Sub Project_Inactive()

'Unregister events

Set zBatchManager = Nothing

End Sub

Private Sub zBatchManager_MRSelectionChanged(ByVal eventData As IBatchMRSelectionChangedEventData)

'Get the MRs of the calling screen

Dim selectedMRIds() As Long

selectedMRIds = zBatchManager.selectedMRIds(eventData.ScreenName)

Dim selectedMRIdsInfo As String

selectedMRIdsInfo = "Selected MRIds: "

'Get the MR Ids data

For i = 0 To UBound(selectedMRIds)

selectedMRIdsInfo = selectedMRIdsInfo & selectedMRIds(i) & "; "

Next i

'Show messagebox with recipe Ids

MsgBox (selectedMRIdsInfo)

End Sub


CRSelectionChanged

Manual -> Programming interfaces -> Objectmodel -> BatchManager -> BatchManager-Events -> CRSelectionChanged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired when the selection in the screen element control recipe list changes.

Datatype

CRSelectionChanged(IBatchCRSelectionChangedEventData eventData) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

// local variable for the batchManager to register the events

private IBatchManager batchManager = null;

void ThisProject_Active()

{

batchManager = this.BatchManager();

// Register event

batchManager.CRSelectionChanged += new CRSelectionChangedEventHandler(ThisProject_CRSelectionChanged);

}

void ThisProject_Inactive()

{

// unregister Event

batchManager.CRSelectionChanged -= new CRSelectionChangedEventHandler(ThisProject_CRSelectionChanged);

}

void ThisProject_CRSelectionChanged(IBatchCRSelectionChangedEventData eventData)

{

// Get control recipe selection for the screen in which the selection has changed

object[] selectedCRIds = (object[])batchManager.SelectedCRIds(eventData.ScreenName);

// Build an output string

string selectedCRIdsInfo = "Selected CRIds[CRId | MRId): ";

foreach (object selectedCRId in selectedCRIds)

{

IBatchRecipeId crId = (IBatchRecipeId)selectedCRId;

selectedCRIdsInfo += crId.CRId + " | " + crId.MRId + "; ";

}

// Write an output message

System.Diagnostics.Debug.Print("\n" + selectedCRIdsInfo);

}

VB.NET

' local variable for the batchManager to register the events

Private batchManager As IBatchManager = Nothing

Private Sub ThisProject_Active()

batchManager = Me.BatchManager()

' Register event

AddHandler batchManager.CRSelectionChanged, AddressOf ThisProject_CRSelectionChanged

End Sub

Private Sub ThisProject_Inactive()

' unregister Event

RemoveHandler batchManager.CRSelectionChanged, AddressOf ThisProject_CRSelectionChanged

End Sub

Private Sub ThisProject_CRSelectionChanged(eventData As IBatchCRSelectionChangedEventData)

' Get control recipe selection for the screen in which the selection has changed

Dim selectedCRIds As Object() = DirectCast(batchManager.SelectedCRIds(eventData.ScreenName), Object())

' Build an output string

Dim selectedCRIdsInfo As String = "Selected CRIds[CRId | MRId): "

For Each selectedCRId As Object In selectedCRIds

Dim crId As IBatchRecipeId = DirectCast(selectedCRId, IBatchRecipeId)

selectedCRIdsInfo += crId.CRId + " | " + crId.MRId + "; "

Next

' Write an output message

System.Diagnostics.Debug.Print(Convert.ToString(vbLf) & selectedCRIdsInfo)

End Sub

VBA

Examples

C#

// local variable for the batchManager to register the events

private IBatchManager batchManager = null;

void ThisProject_Active()

{

// Register event

batchManager.CRSelectionChanged += new CRSelectionChangedEventHandler(ThisProject_CRSelectionChanged);

}

void ThisProject_Inactive()

{

// unregister Event

batchManager.CRSelectionChanged -= new CRSelectionChangedEventHandler(ThisProject_CRSelectionChanged);

}

void ThisProject_CRSelectionChanged(IBatchCRSelectionChangedEventData eventData)

{

// Get control recipe selection for the screen in which the selection has changed

object[] selectedCRIds = (object[])batchManager.SelectedCRIds(eventData.ScreenName);

// Build an output string

string selectedCRIdsInfo = "Selected CRIds[CRId | MRId): ";

foreach (object selectedCRId in selectedCRIds)

{

IBatchRecipeId crId = (IBatchRecipeId)selectedCRId;

selectedCRIdsInfo += crId.CRId + " | " + crId.MRId + "; ";

}

// Write an output message

System.Diagnostics.Debug.Print("\n" + selectedCRIdsInfo);

}

VB.NET

VBA

Dim WithEvents zBatchManager As BatchManager

Private Sub Project_Active()

'Register events

Set zBatchManager = thisProject.BatchManager

End Sub

Private Sub Project_Inactive()

'Unregister events

Set zBatchManager = Nothing

End Sub

Private Sub zBatchManager_CRSelectionChanged(ByVal eventData As IBatchCRSelectionChangedEventData)

'Get the CRs of the calling screen

Dim selectedCRIds() As BatchRecipeId

selectedCRIds = zBatchManager.selectedCRIds(eventData.ScreenName)

Dim selectedCRIdsInfo As String

selectedCRIdsInfo = "Selected CRIds[CRId | MRId): "

'Get the CR Ids data

For i = 0 To UBound(selectedCRIds)

selectedCRIdsInfo = selectedCRIdsInfo & selectedCRIds(i).CRId & " | " & selectedCRIds(i).MRId & "; "

Next i

'Show messagebox with recipe Id

MsgBox (selectedCRIdsInfo)

End Sub


BatchMasterRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Object with the properties for the recipe. These properties can be read.

Property table: BatchMasterRecipe-Properties

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

public void MacroBatchMasterRecipe()

{

IBatchManager batchManager = this.BatchManager();

//Get a master recipe over its index

int mrIndex = 0;

IBatchMasterRecipe masterRecipe = batchManager.MasterRecipes().ItemByIndex(mrIndex);

// Get a master recipe over its ID

int mrId = 42;

masterRecipe = batchManager.MasterRecipes().ItemById(mrId);

//Get the data of a master recipe over its name

string mrName = "TestMR1";

masterRecipe = batchManager.MasterRecipes().Item(mrName, 1);

//Do something with the BatchMasterRecipe

}

VB.NET

Public Sub MacroBatchMasterRecipe()

Dim batchManager As IBatchManager = Me.BatchManager()

'Get a master recipe over its index

Dim mrIndex As Integer = 0

Dim masterRecipe As IBatchMasterRecipe = batchManager.MasterRecipes().ItemByIndex(mrIndex)

' Get a master recipe over its ID

Dim mrId As Integer = 42

masterRecipe = batchManager.MasterRecipes().ItemById(mrId)

'Get the data of a master recipe over its name

Dim mrName As String = "TestMR1"

masterRecipe = batchManager.MasterRecipes().Item(mrName, 1)

'Do something with the BatchMasterRecipe

End Sub

VBA

Public Sub test()

// Get a master recipe over its ID

Set masterRecipe = thisProject.batchManager.MasterRecipes. ItemById (10)

//Get the data of a master recipe over its name

Set masterRecipe = thisProject.batchManager.MasterRecipes. ItemByName ("TestMR1")

//Get a master recipe over its index

Set masterRecipe = thisProject.batchManager.MasterRecipes.ItemByIndex(10)

'print text and approved time to debug window

Debug.Print ("ApprovedTime: " & masterrecipe.ApprovedTime)

End Sub

Other topics in this chapter

BatchMasterRecipe-Properties

BatchMasterRecipe-Methods


BatchMasterRecipe-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | ID | Returns the Id of the recipe | not used | read only | yes | yes
BSTR | Name | Returns the name of the recipe | not used | read only | yes | yes
BSTR | Description | Returns the description of the recipe | not used | read only | yes | yes
tpBatchMRState | MRState | Returns the state of the recipe | not used | read only | yes | yes
tpBatchExecutionState | ExecutionState | Returns the state of the recipe engine | not used | read only | yes | yes
BSTR | Type | Returns the type of the recipe | not used | read only | yes | yes
tpBatchExecutionMode | ExecutionMode | Returns the mode of the recipe | not used | read only | yes | yes
DATE | ApprovedTime | Returns the approved time of the recipe | not used | read only | yes | yes
BSTR | ApprovedUserName | Returns the approved user name of the recipe | not used | read only | yes | yes
BSTR | ApprovedUserId | Returns the approved user id of the recipe | not used | read only | yes | yes
DATE | OutdatedTime | Returns the outdated time of the recipe | not used | read only | yes | yes
BSTR | OutdatedUserName | Returns the outdated user name of the recipe | not used | read only | yes | yes
BSTR | OutdatedUserId | Returns the outdated user id of the recipe | not used | read only | yes | yes
long | Version | Returns the version of recipe | not used | read only | yes | yes
long | SourceVersion | Returns the version of the source recipe | not used | read only | yes | yes

Other topics in this chapter

ID

Name

Description

MRState

ExecutionState

Type

ExecutionMode

ApprovedTime

ApprovedUserName

ApprovedUserId

OutdatedTime

OutdatedUserName

OutdatedUserId

Version

SourceVersion


ID

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Properties -> ID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ID() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Name() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Description

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Properties -> Description

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Description() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


MRState

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Properties -> MRState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MRState() As tpBatchMRState

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ExecutionState

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Properties -> ExecutionState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ExecutionState() As tpBatchExecutionState

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Type

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Properties -> Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Type() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ExecutionMode

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Properties -> ExecutionMode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ExecutionMode() As tpBatchExecutionMode

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ApprovedTime

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Properties -> ApprovedTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ApprovedTime() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ApprovedUserName

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Properties -> ApprovedUserName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ApprovedUserName() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ApprovedUserId

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Properties -> ApprovedUserId

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ApprovedUserId() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


OutdatedTime

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Properties -> OutdatedTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OutdatedTime() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


OutdatedUserName

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Properties -> OutdatedUserName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OutdatedUserName() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


OutdatedUserId

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Properties -> OutdatedUserId

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OutdatedUserId() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Version

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Properties -> Version

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Version number of the template recipe.

Datatype

Version() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


SourceVersion

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Properties -> SourceVersion

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Version number of the source recipe.

Datatype

SourceVersion() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchMasterRecipe-Methods

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
IBatchControlRecipes | ControlRecipes | Returns the collection of control recipes | not used | read only | yes | yes
tpRecipeRenameResult | SetNameAndDescription | Tries to rename the recipe and sets the description. Returns a result code whether the operation was successful or not. | not used | read only | yes | yes

Other topics in this chapter

ControlRecipes

SetNameAndDescription


ControlRecipes

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Methods -> ControlRecipes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ControlRecipes(tpBatchCRStateFilter eFilter) As IBatchControlRecipes

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


SetNameAndDescription

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipe -> BatchMasterRecipe-Methods -> SetNameAndDescription

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method changes the name and the description of the master recipe if possible. The method returns a result code for the operation.

Note, that the master recipe instance you are working on is a copy of the original data. To get an updated version of the master recipe you have to get it again from the master recipes container.

Datatype

SetNameAndDescription(BSTR newName, BSTR newDescription) As tpRecipeRenameResult

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

//Function to rename a master recipe and set its description

public void Macro_SetMasterRecipeNameAndDescription()

{

//Get the master recipe that is to be renamed

IBatchMasterRecipe mr = BatchManager().MasterRecipes().Item("oldMasterRecipeName", 1);

//rename the master recipe and set its description

tpRecipeRenameResult result = mr.SetNameAndDescription("newName", "newDescription");

//Output result if the operation failed

if (result != tpRecipeRenameResult.tpRecipeRenameSuccess)

{

MessageBox.Show(null, "Rename Failed. Error Code: " + result.ToString(), "rename master recipe result", MessageBoxButtons.OK, MessageBoxIcon.None);

}

}

VB.NET

'Function to rename a master recipe and set its description

Public Sub Macro_SetMasterRecipeNameAndDescription()

'Get the master recipe that is to be renamed

Dim mr As IBatchMasterRecipe = BatchManager().MasterRecipes().Item("oldMasterRecipeName", 1)

'rename the master recipe and set its description

Dim result As tpRecipeRenameResult = mr.SetNameAndDescription("newName", "newDescription")

'Output result if the operation failed

If result <> tpRecipeRenameResult.tpRecipeRenameSuccess Then

MessageBox.Show(Nothing, "Rename Failed. Error Code: " & result.ToString(), "rename master recipe result", MessageBoxButtons.OK, MessageBoxIcon.None)

End If

End Sub

VBA

'Function to rename a master recipe and set its description

Public Sub SetMasterRecipeNameAndDescription()

'Get the master recipe that is to be renamed

Dim mr As BatchMasterRecipe

Set mr = thisProject.BatchManager.MasterRecipes.Item("oldMasterRecipeName", 1)

'rename the master recipe and set its description

Dim result As tpRecipeRenameResult 'resultcode for the operation

result = mr.SetNameAndDescription("newName", "newDescription")

'Output result if the operation failed

If result <> tpRecipeRenameSuccess Then

MsgBox ("Rename Failed. Error Code: " & CStr(result))

End If

End Sub


BatchMasterRecipes

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Lists all template recipes. Specific recipes can be read from the collection.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

public void MacroBatchMasterRecipe()

{

IBatchManager batchManager = this.BatchManager();

//Get a master recipe over its index

int mrIndex = 0;

IBatchMasterRecipe masterRecipe = batchManager.MasterRecipes().ItemByIndex(mrIndex);

// Get a master recipe over its ID

int mrId = 42;

masterRecipe = batchManager.MasterRecipes().ItemById(mrId);

//Get the data of a master recipe over its name

string mrName = "TestMR1";

masterRecipe = batchManager.MasterRecipes().Item(mrName, 1);

//Do something with the BatchMasterRecipe

}

VB.NET

Public Sub MacroBatchMasterRecipe()

Dim batchManager As IBatchManager = Me.BatchManager()

'Get a master recipe over its index

Dim mrIndex As Integer = 0

Dim masterRecipe As IBatchMasterRecipe = batchManager.MasterRecipes().ItemByIndex(mrIndex)

' Get a master recipe over its ID

Dim mrId As Integer = 42

masterRecipe = batchManager.MasterRecipes().ItemById(mrId)

'Get the data of a master recipe over its name

Dim mrName As String = "TestMR1"

masterRecipe = batchManager.MasterRecipes().Item(mrName, 1)

'Do something with the BatchMasterRecipe

End Sub

VBA

Public Sub test()

// Get a master recipe over its ID

Set masterRecipe = thisProject.batchManager.MasterRecipes. ItemById (10)

//Get the data of a master recipe over its name

Set masterRecipe = thisProject.batchManager.MasterRecipes. ItemByName ("TestMR1")

//Get a master recipe over its index

Set masterRecipe = thisProject.batchManager.MasterRecipes.ItemByIndex(10)

'print text and approved time to debug window

Debug.Print ("ApprovedTime: " & masterrecipe.ApprovedTime)

End Sub

Other topics in this chapter

BatchMasterRecipes-Properties

BatchMasterRecipes-Methods


BatchMasterRecipes-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipes -> BatchMasterRecipes-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | Count | Returns the count of items in the collection of master recipes | not used | read only | yes | yes

Other topics in this chapter

Count


Count

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipes -> BatchMasterRecipes-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Count() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchMasterRecipes-Methods

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipes -> BatchMasterRecipes-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
IBatchMasterRecipe | ItemByIndex | Returns the master recipe item at the given index | not used | read only | yes | yes
IBatchMasterRecipe | Item | Returns the master recipe item with the specified name | not used | read only | yes | yes
IBatchMasterRecipe | ItemById | Returns the master recipe item with the specified Id | not used | read only | yes | yes

Other topics in this chapter

ItemByIndex

Item

ItemById


ItemByIndex

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipes -> BatchMasterRecipes-Methods -> ItemByIndex

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ItemByIndex(long lIndex) As IBatchMasterRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Item

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipes -> BatchMasterRecipes-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Item(BSTR bstrName, long lVersion) As IBatchMasterRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


ItemById

Manual -> Programming interfaces -> Objectmodel -> BatchMasterRecipes -> BatchMasterRecipes-Methods -> ItemById

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ItemById(long lId) As IBatchMasterRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


BatchMRSelectionChangedEventData

Manual -> Programming interfaces -> Objectmodel -> BatchMRSelectionChangedEventData

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

An object of this type is passed as a parameter in the MRSelectionChangedEvent

string ScreenName: Name of the Picture, in which the selection was changed

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

// local variable for the batchManager to register the events

private IBatchManager batchManager = null;

void ThisProject_Active()

{

// Register event

batchManager.MRSelectionChanged += new MRSelectionChangedEventHandler(ThisProject_MRSelectionChanged);

}

void ThisProject_Inactive()

{

// unregister Event

batchManager.MRSelectionChanged -= new MRSelectionChangedEventHandler(ThisProject_MRSelectionChanged);

}

void ThisProject_MRSelectionChanged(IBatchMRSelectionChangedEventData eventData)

{

// Get master recipe selection for the screen in which the selection has changed

int[] selectedMRIds = (int[])batchManager.SelectedMRIds(eventData.ScreenName);

// Build an output string

string selectedMRIdsInfo = "Selected MRIds: ";

foreach (int selectedMRId in selectedMRIds)

selectedMRIdsInfo += selectedMRId + "; ";

// Write an output message

System.Diagnostics.Debug.Print("\n" + selectedMRIdsInfo);

}

VB.NET

' local variable for the batchManager to register the events

Private batchManager As IBatchManager = Nothing

Private Sub ThisProject_Active()

' Register event

AddHandler batchManager.MRSelectionChanged, AddressOf ThisProject_MRSelectionChanged

End Sub

Private Sub ThisProject_Inactive()

' unregister Event

RemoveHandler batchManager.MRSelectionChanged, AddressOf ThisProject_MRSelectionChanged

End Sub

Private Sub ThisProject_MRSelectionChanged(eventData As IBatchMRSelectionChangedEventData)

' Get master recipe selection for the screen in which the selection has changed

Dim selectedMRIds As Integer() = DirectCast(batchManager.SelectedMRIds(eventData.ScreenName), Integer())

' Build an output string

Dim selectedMRIdsInfo As String = "Selected MRIds: "

For Each selectedMRId As Integer In selectedMRIds

selectedMRIdsInfo += selectedMRId & "; "

Next

' Write an output message

System.Diagnostics.Debug.Print(vbLf & selectedMRIdsInfo)

End Sub

VBA

Dim WithEvents zBatchManager As BatchManager

Private Sub Project_Active()

'Register events

Set zBatchManager = thisProject.BatchManager

End Sub

Private Sub Project_Inactive()

'Unregister events

Set zBatchManager = Nothing

End Sub

Private Sub zBatchManager_MRSelectionChanged(ByVal eventData As IBatchMRSelectionChangedEventData)

'Get the MRs of the calling screen

Dim selectedMRIds() As Long

selectedMRIds = zBatchManager.selectedMRIds(eventData.ScreenName)

Dim selectedMRIdsInfo As String

selectedMRIdsInfo = "Selected MRIds: "

'Get the MR Ids data

For i = 0 To UBound(selectedMRIds)

selectedMRIdsInfo = selectedMRIdsInfo & selectedMRIds(i) & "; "

Next i

'Show messagebox with recipe Ids

MsgBox (selectedMRIdsInfo)

End Sub

Other topics in this chapter

BatchMRSelectionChangedEventData-Properties


BatchMRSelectionChangedEventData-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchMRSelectionChangedEventData -> BatchMRSelectionChangedEventData-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
BSTR | ScreenName | Name of the screen in which the selection of the recipe list was changed | not used | read only | yes | yes

Other topics in this chapter

ScreenName


ScreenName

Manual -> Programming interfaces -> Objectmodel -> BatchMRSelectionChangedEventData -> BatchMRSelectionChangedEventData-Properties -> ScreenName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Name of the Picture, in which the selection was changed

Datatype

ScreenName() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchOperation

Manual -> Programming interfaces -> Objectmodel -> BatchOperation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

A sub-recipe, that can then be used in master recipes.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

BatchOperation-Properties


BatchOperation-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchOperation -> BatchOperation-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | ChartId | Id of the chart operation object in the recipe | not used | read only | yes | yes
BSTR | Name | Name of the operation | not used | read only | yes | yes
BSTR | Description | Description of the operation | not used | read only | yes | yes

Other topics in this chapter

ChartId

Name

Description


ChartId

Manual -> Programming interfaces -> Objectmodel -> BatchOperation -> BatchOperation-Properties -> ChartId

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Id of the chart operation object in the recipe.

Datatype

ChartId() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> BatchOperation -> BatchOperation-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Name of the operation.

Datatype

Name() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Description

Manual -> Programming interfaces -> Objectmodel -> BatchOperation -> BatchOperation-Properties -> Description

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Description of the operation.

Datatype

Description() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchPhase

Manual -> Programming interfaces -> Objectmodel -> BatchPhase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

A functional block, that encapsulates the communication with the plc for a specific procedure.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

BatchPhase-Properties


BatchPhase-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchPhase -> BatchPhase-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | ChartId | Id of the chart phase object in the recipe or operation | not used | read only | yes | yes
BSTR | Name | Name of the phase | not used | read only | yes | yes
BSTR | Description | Description of the phase | not used | read only | yes | yes
tpBatchExecutionState | PhaseState | Execution state of the phase | not used | read only | yes | yes
long | ExecutionCounter | Execution counter of the phase | not used | read only | yes | yes
IBatchControlStrategy | ControlStrategy | Currently active control strategy | not used | read only | yes | yes
IBatchTags | Tags | Collection for the tags of the phase | not used | read only | yes | yes

Other topics in this chapter

ChartId

Name

Description

PhaseState

ExecutionCounter

ControlStrategy

Tags


ChartId

Manual -> Programming interfaces -> Objectmodel -> BatchPhase -> BatchPhase-Properties -> ChartId

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Id of the chart phase object in the recipe or operation.

Datatype

ChartId() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> BatchPhase -> BatchPhase-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Name of the phase.

Datatype

Name() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Description

Manual -> Programming interfaces -> Objectmodel -> BatchPhase -> BatchPhase-Properties -> Description

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Description of the phase.

Datatype

Description() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


PhaseState

Manual -> Programming interfaces -> Objectmodel -> BatchPhase -> BatchPhase-Properties -> PhaseState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Execution state of the phase.

Datatype

PhaseState() As tpBatchExecutionState

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ExecutionCounter

Manual -> Programming interfaces -> Objectmodel -> BatchPhase -> BatchPhase-Properties -> ExecutionCounter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Execution counter of the phase.

Datatype

ExecutionCounter() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ControlStrategy

Manual -> Programming interfaces -> Objectmodel -> BatchPhase -> BatchPhase-Properties -> ControlStrategy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Currently active control strategy.

Datatype

ControlStrategy() As IBatchControlStrategy

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Tags

Manual -> Programming interfaces -> Objectmodel -> BatchPhase -> BatchPhase-Properties -> Tags

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Tags() As IBatchTags

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchPhaseChanges

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseChanges

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Object that contains what changes were made in the phase (contains the IDs of the changed tags)

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

BatchPhaseChanges-Properties

BatchPhaseChanges-Methods


BatchPhaseChanges-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseChanges -> BatchPhaseChanges-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | TagIdCount | Count of tag ids in the collection | not used | read only | yes | yes

Other topics in this chapter

TagIdCount


TagIdCount

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseChanges -> BatchPhaseChanges-Properties -> TagIdCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Count of the IDs for the changed tags.

Datatype

TagIdCount() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchPhaseChanges-Methods

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseChanges -> BatchPhaseChanges-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | TagIdByIndex | Gets a tag id from the collection by its index | not used | read only | yes | yes

Other topics in this chapter

TagIdByIndex


TagIdByIndex

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseChanges -> BatchPhaseChanges-Methods -> TagIdByIndex

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns an ID of a changed Tag for lIndex. lIndex has to lie between 0 and TagIdCount-1. If it does not, the Method will return 0.

Datatype

TagIdByIndex(long lIndex) As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

void ThisProject_Active()

{

//Check in the ControlRecipePhaseEdited Event

BatchManager().ControlRecipePhaseEdited += new ControlRecipePhaseEditedEventHandler(ThisProject_ControlRecipePhaseEdited);

}

void ThisProject_ControlRecipePhaseEdited(IBatchControlRecipePhaseEditedEventData eventData)

{

//Get the ID of the changed tags from the event data changes collection

string additionalInformation = "Changes[Tag-ID]: ";

for (var index = 0; index < eventData.Changes.TagIdCount; index++)

{

additionalInformation += "" + eventData.Changes.TagIdByIndex(index) + "; ";

}

additionalInformation += " -- Comment:\"" + eventData.Comment + "\"";

//Write debug message to the listener when event is fired.

System.Diagnostics.Debug.WriteLine("[" + eventData.Time + "] Control Recipe

Edited. >> " + additionalInformation);

}

void ThisProject_Inactive()

{

//Check out the ControlRecipePhaseEdited Event

BatchManager().ControlRecipePhaseEdited -= ThisProject_ControlRecipePhaseEdited;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

VB.NET

VBA


BatchPhaseCommunicationErrorEventData

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseCommunicationErrorEventData

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The data class that gets passed when the PhaseCommunicationError Event of the BatchManager is fired. It contains all relevant information for this event.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

BatchPhaseCommunicationErrorEventData-Properties


BatchPhaseCommunicationErrorEventData-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseCommunicationErrorEventData -> BatchPhaseCommunicationErrorEventData-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
DATE | Time | Time when the event was fired | not used | read only | yes | yes
IBatchOperation | Operation | Operation that contains the phase that fired the event. null if the phase is in no operation | not used | read only | yes | yes
IBatchPhase | Phase | Phase for which the event was fired | not used | read only | yes | yes
IBatchMasterRecipe | MasterRecipe | Master recipe for which the event was fired | not used | read only | yes | yes
IBatchControlRecipe | ControlRecipe | Control recipe for which the event was fired | not used | read only | yes | yes
tpBatchPhaseCommunicationErrorState | CommunicationErrorState | New state of the communication error | not used | read only | yes | yes

Other topics in this chapter

Time

Operation

Phase

MasterRecipe

ControlRecipe

CommunicationErrorState


Time

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseCommunicationErrorEventData -> BatchPhaseCommunicationErrorEventData-Properties -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Timestamp at which the event was fired.

Datatype

Time() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Operation

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseCommunicationErrorEventData -> BatchPhaseCommunicationErrorEventData-Properties -> Operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Operation that contains the phase that fired the event. Null if the phase is not located in an operation.

Datatype

Operation() As IBatchOperation

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Phase

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseCommunicationErrorEventData -> BatchPhaseCommunicationErrorEventData-Properties -> Phase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Phase that fired the event.

Datatype

Phase() As IBatchPhase

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


MasterRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseCommunicationErrorEventData -> BatchPhaseCommunicationErrorEventData-Properties -> MasterRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype

MasterRecipe() As IBatchMasterRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ControlRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseCommunicationErrorEventData -> BatchPhaseCommunicationErrorEventData-Properties -> ControlRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype

ControlRecipe() As IBatchControlRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


CommunicationErrorState

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseCommunicationErrorEventData -> BatchPhaseCommunicationErrorEventData-Properties -> CommunicationErrorState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

New state for the communication error.

Datatype

CommunicationErrorState() As tpBatchPhaseCommunicationErrorState

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchPhaseEscapeEventData

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseEscapeEventData

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The data class that gets passed when the PhaseEscape Event of the BatchManager is fired. It contains all relevant information for this event.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

BatchPhaseEscapeEventData-Properties


BatchPhaseEscapeEventData-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseEscapeEventData -> BatchPhaseEscapeEventData-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
DATE | Time | Time when the event was fired | not used | read only | yes | yes
IBatchOperation | Operation | Operation that contains the phase that fired the event. null if the phase is in no operation | not used | read only | yes | yes
IBatchPhase | Phase | Phase for which the event was fired | not used | read only | yes | yes
IBatchMasterRecipe | MasterRecipe | Master recipe for which the event was fired | not used | read only | yes | yes
IBatchControlRecipe | ControlRecipe | Control recipe for which the event was fired | not used | read only | yes | yes
tpBatchPhaseEscapeState | EscapeState | New internal execution position of the phase | not used | read only | yes | yes

Other topics in this chapter

Time

Operation

Phase

MasterRecipe

ControlRecipe

EscapeState


Time

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseEscapeEventData -> BatchPhaseEscapeEventData-Properties -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Timestamp at which the event was fired.

Datatype

Time() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Operation

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseEscapeEventData -> BatchPhaseEscapeEventData-Properties -> Operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Operation that contains the phase that fired the event. Null if the phase is not located in an operation.

Datatype

Operation() As IBatchOperation

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Phase

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseEscapeEventData -> BatchPhaseEscapeEventData-Properties -> Phase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Phase that fired the event.

Datatype

Phase() As IBatchPhase

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


MasterRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseEscapeEventData -> BatchPhaseEscapeEventData-Properties -> MasterRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype

MasterRecipe() As IBatchMasterRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ControlRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseEscapeEventData -> BatchPhaseEscapeEventData-Properties -> ControlRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype

ControlRecipe() As IBatchControlRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


EscapeState

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseEscapeEventData -> BatchPhaseEscapeEventData-Properties -> EscapeState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

New escape state.

Datatype

EscapeState() As tpBatchPhaseEscapeState

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchPhaseExecutionErrorEventData

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseExecutionErrorEventData

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The data class that gets passed when the PhaseExecutionError Event of the BatchManager is fired. It contains all relevant information for this event.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

BatchPhaseExecutionErrorEventData-Properties


BatchPhaseExecutionErrorEventData-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseExecutionErrorEventData -> BatchPhaseExecutionErrorEventData-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
DATE | Time | Time when the event was fired | not used | read only | yes | yes
IBatchOperation | Operation | Operation that contains the phase that fired the event. null if the phase is in no operation | not used | read only | yes | yes
IBatchPhase | Phase | Phase for which the event was fired | not used | read only | yes | yes
IBatchMasterRecipe | MasterRecipe | Master recipe for which the event was fired | not used | read only | yes | yes
IBatchControlRecipe | ControlRecipe | Control recipe for which the event was fired | not used | read only | yes | yes
tpBatchPhaseExecutionError | ExecutionError | Type of the error that occured | not used | read only | yes | yes

Other topics in this chapter

Time

Operation

Phase

MasterRecipe

ControlRecipe

ExecutionError


Time

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseExecutionErrorEventData -> BatchPhaseExecutionErrorEventData-Properties -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Timestamp at which the event was fired.

Datatype

Time() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Operation

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseExecutionErrorEventData -> BatchPhaseExecutionErrorEventData-Properties -> Operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Operation that contains the phase that fired the event. Null if the phase is not located in an operation.

Datatype

Operation() As IBatchOperation

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Phase

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseExecutionErrorEventData -> BatchPhaseExecutionErrorEventData-Properties -> Phase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Phase that fired the event.

Datatype

Phase() As IBatchPhase

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


MasterRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseExecutionErrorEventData -> BatchPhaseExecutionErrorEventData-Properties -> MasterRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype

MasterRecipe() As IBatchMasterRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ControlRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseExecutionErrorEventData -> BatchPhaseExecutionErrorEventData-Properties -> ControlRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype

ControlRecipe() As IBatchControlRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ExecutionError

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseExecutionErrorEventData -> BatchPhaseExecutionErrorEventData-Properties -> ExecutionError

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Type of the execution error of the phase that triggered this event.

Datatype

ExecutionError() As tpBatchPhaseExecutionError

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchPhaseModeChangedEventData

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseModeChangedEventData

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The data class that gets passed when the PhaseModeChanged Event of the BatchManager is fired. It contains all relevant information for this event.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

BatchPhaseModeChangedEventData-Properties


BatchPhaseModeChangedEventData-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseModeChangedEventData -> BatchPhaseModeChangedEventData-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
DATE | Time | Time when the event was fired | not used | read only | yes | yes
IBatchOperation | Operation | Operation that contains the phase that fired the event. null if the phase is in no operation | not used | read only | yes | yes
IBatchPhase | Phase | Phase for which the event was fired | not used | read only | yes | yes
IBatchMasterRecipe | MasterRecipe | Master recipe for which the event was fired | not used | read only | yes | yes
IBatchControlRecipe | ControlRecipe | Control recipe for which the event was fired | not used | read only | yes | yes
tpBatchExecutionMode | OldExecutionMode | Execution mode before the change | not used | read only | yes | yes
tpBatchExecutionMode | NewExecutionMode | Execution mode after the change | not used | read only | yes | yes
IUser | User | Logged in user | not used | read only | yes | yes

Other topics in this chapter

Time

Operation

Phase

MasterRecipe

ControlRecipe

OldExecutionMode

NewExecutionMode

User


Time

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseModeChangedEventData -> BatchPhaseModeChangedEventData-Properties -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Timestamp at which the event was fired.

Datatype

Time() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Operation

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseModeChangedEventData -> BatchPhaseModeChangedEventData-Properties -> Operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Operation that contains the phase that fired the event. Null if the phase is not located in an operation.

Datatype

Operation() As IBatchOperation

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Phase

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseModeChangedEventData -> BatchPhaseModeChangedEventData-Properties -> Phase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Phase that fired the event.

Datatype

Phase() As IBatchPhase

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


MasterRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseModeChangedEventData -> BatchPhaseModeChangedEventData-Properties -> MasterRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype

MasterRecipe() As IBatchMasterRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ControlRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseModeChangedEventData -> BatchPhaseModeChangedEventData-Properties -> ControlRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype

ControlRecipe() As IBatchControlRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


OldExecutionMode

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseModeChangedEventData -> BatchPhaseModeChangedEventData-Properties -> OldExecutionMode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Mode from before the change.

Datatype

OldExecutionMode() As tpBatchExecutionMode

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


NewExecutionMode

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseModeChangedEventData -> BatchPhaseModeChangedEventData-Properties -> NewExecutionMode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

New mode from after the change.

Datatype

NewExecutionMode() As tpBatchExecutionMode

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


User

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseModeChangedEventData -> BatchPhaseModeChangedEventData-Properties -> User

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Copy of the user that triggered the mode change. If it is triggered by toolbar button or zenon button with a batch recipe commando, the user is the currently logged in user at the moment and client the mode change is triggered. If the mode change is triggered by reaction of a phase or an automated function call (etc.) a copy of the SYSTEM user will be sent.

This user is for information only. Trying to change its password or Name or anything else will have no effect on the real user, because this is a copy. The original user may even no longer exist due to the delay in a network

Datatype

User() As IUser

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchPhasePlcErrorEventData

Manual -> Programming interfaces -> Objectmodel -> BatchPhasePlcErrorEventData

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The data class that gets passed when the PhasePlcError Event of the BatchManager is fired. It contains all relevant information for this event.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

BatchPhasePlcErrorEventData-Properties


BatchPhasePlcErrorEventData-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchPhasePlcErrorEventData -> BatchPhasePlcErrorEventData-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
DATE | Time | Time when the event was fired | not used | read only | yes | yes
IBatchOperation | Operation | Operation that contains the phase that fired the event. null if the phase is in no operation | not used | read only | yes | yes
IBatchPhase | Phase | Phase for which the event was fired | not used | read only | yes | yes
IBatchMasterRecipe | MasterRecipe | Master recipe for which the event was fired | not used | read only | yes | yes
IBatchControlRecipe | ControlRecipe | Control recipe for which the event was fired | not used | read only | yes | yes
tpBatchPhasePlcErrorState | PlcErrorState | New state of the PLC error | not used | read only | yes | yes

Other topics in this chapter

Time

Operation

Phase

MasterRecipe

ControlRecipe

PlcErrorState


Time

Manual -> Programming interfaces -> Objectmodel -> BatchPhasePlcErrorEventData -> BatchPhasePlcErrorEventData-Properties -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Timestamp at which the event was fired.

Datatype

Time() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Operation

Manual -> Programming interfaces -> Objectmodel -> BatchPhasePlcErrorEventData -> BatchPhasePlcErrorEventData-Properties -> Operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Operation that contains the phase that fired the event. Null if the phase is not located in an operation.

Datatype

Operation() As IBatchOperation

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Phase

Manual -> Programming interfaces -> Objectmodel -> BatchPhasePlcErrorEventData -> BatchPhasePlcErrorEventData-Properties -> Phase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Phase() As IBatchPhase

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


MasterRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchPhasePlcErrorEventData -> BatchPhasePlcErrorEventData-Properties -> MasterRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype

MasterRecipe() As IBatchMasterRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ControlRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchPhasePlcErrorEventData -> BatchPhasePlcErrorEventData-Properties -> ControlRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype

ControlRecipe() As IBatchControlRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


PlcErrorState

Manual -> Programming interfaces -> Objectmodel -> BatchPhasePlcErrorEventData -> BatchPhasePlcErrorEventData-Properties -> PlcErrorState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

New escape state.

Datatype

PlcErrorState() As tpBatchPhasePlcErrorState

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchPhaseProgressEventData

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseProgressEventData

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The data class that gets passed when the PhaseProgress Event of the BatchManager is fired. It contains all relevant information for this event.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

BatchPhaseProgressEventData-Properties


BatchPhaseProgressEventData-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseProgressEventData -> BatchPhaseProgressEventData-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
DATE | Time | Time when the event was fired | not used | read only | yes | yes
IBatchOperation | Operation | Operation that contains the phase that fired the event. null if the phase is in no operation | not used | read only | yes | yes
IBatchPhase | Phase | Phase for which the event was fired | not used | read only | yes | yes
IBatchMasterRecipe | MasterRecipe | Master recipe for which the event was fired | not used | read only | yes | yes
IBatchControlRecipe | ControlRecipe | Control recipe for which the event was fired | not used | read only | yes | yes
tpBatchPhaseState | PhaseState | New internal execution position of the phase | not used | read only | yes | yes

Other topics in this chapter

Time

Operation

Phase

MasterRecipe

ControlRecipe

PhaseState


Time

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseProgressEventData -> BatchPhaseProgressEventData-Properties -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Timestamp at which the event was fired.

Datatype

Time() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Operation

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseProgressEventData -> BatchPhaseProgressEventData-Properties -> Operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Operation that contains the phase that fired the event. Null if the phase is not located in an operation.

Datatype

Operation() As IBatchOperation

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Phase

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseProgressEventData -> BatchPhaseProgressEventData-Properties -> Phase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Phase that fired the event.

Datatype

Phase() As IBatchPhase

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


MasterRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseProgressEventData -> BatchPhaseProgressEventData-Properties -> MasterRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype

MasterRecipe() As IBatchMasterRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ControlRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseProgressEventData -> BatchPhaseProgressEventData-Properties -> ControlRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype

ControlRecipe() As IBatchControlRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


PhaseState

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseProgressEventData -> BatchPhaseProgressEventData-Properties -> PhaseState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

New internal state for the phase execution. The change of this state triggered this event.

Datatype

PhaseState() As tpBatchPhaseState

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchPhaseRuntimeEventData

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseRuntimeEventData

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The data class that gets passed when the PhaseRuntimeEvent Event of the BatchManager is fired. It contains all relevant information for this event.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

BatchPhaseRuntimeEventData-Properties


BatchPhaseRuntimeEventData-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseRuntimeEventData -> BatchPhaseRuntimeEventData-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
DATE | Time | Time when the event was fired | not used | read only | yes | yes
IBatchOperation | Operation | Operation that contains the phase that fired the event. null if the phase is in no operation | not used | read only | yes | yes
IBatchPhase | Phase | Phase for which the event was fired | not used | read only | yes | yes
IBatchMasterRecipe | MasterRecipe | Master recipe for which the event was fired | not used | read only | yes | yes
IBatchControlRecipe | ControlRecipe | Control recipe for which the event was fired | not used | read only | yes | yes
tpBatchPhaseRuntimeEvent | RuntimeEventType | Type of the Runtime event that occured | not used | read only | yes | yes

Other topics in this chapter

Time

Operation

Phase

MasterRecipe

ControlRecipe

RuntimeEventType


Time

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseRuntimeEventData -> BatchPhaseRuntimeEventData-Properties -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Timestamp at which the event was fired.

Datatype

Time() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Operation

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseRuntimeEventData -> BatchPhaseRuntimeEventData-Properties -> Operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Operation that contains the phase that fired the event. Null if the phase is not located in an operation.

Datatype

Operation() As IBatchOperation

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Phase

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseRuntimeEventData -> BatchPhaseRuntimeEventData-Properties -> Phase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Phase that fired the event.

Datatype

Phase() As IBatchPhase

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


MasterRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseRuntimeEventData -> BatchPhaseRuntimeEventData-Properties -> MasterRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype

MasterRecipe() As IBatchMasterRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ControlRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseRuntimeEventData -> BatchPhaseRuntimeEventData-Properties -> ControlRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype

ControlRecipe() As IBatchControlRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


RuntimeEventType

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseRuntimeEventData -> BatchPhaseRuntimeEventData-Properties -> RuntimeEventType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Type of runtime event that triggered this event.

Datatype

RuntimeEventType() As tpBatchPhaseRuntimeEvent

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchPhaseStateChangedEventData

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseStateChangedEventData

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The data class that gets passed when the PhaseStateChanged Event of the BatchManager is fired. It contains all relevant information for this event.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

BatchPhaseStateChangedEventData-Properties


BatchPhaseStateChangedEventData-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseStateChangedEventData -> BatchPhaseStateChangedEventData-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
DATE | Time | Time when the event was fired | not used | read only | yes | yes
IBatchOperation | Operation | Operation that contains the phase that fired the event. null if the phase is in no operation | not used | read only | yes | yes
IBatchPhase | Phase | Phase for which the event was fired | not used | read only | yes | yes
IBatchMasterRecipe | MasterRecipe | Master recipe for which the event was fired | not used | read only | yes | yes
IBatchControlRecipe | ControlRecipe | Control recipe for which the event was fired | not used | read only | yes | yes
tpBatchExecutionState | OldExecutionState | Execution state before the change | not used | read only | yes | yes
tpBatchExecutionState | NewExecutionState | Execution state after the change | not used | read only | yes | yes
IUser | User | Logged in user | not used | read only | yes | yes
IUser | User | Logged in user | not used | read only | yes | yes

Other topics in this chapter

Time

Operation

Phase

MasterRecipe

ControlRecipe

OldExecutionState

NewExecutionState

User


Time

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseStateChangedEventData -> BatchPhaseStateChangedEventData-Properties -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Timestamp at which the event was fired.

Datatype

Time() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Operation

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseStateChangedEventData -> BatchPhaseStateChangedEventData-Properties -> Operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Operation that contains the phase that fired the event. Null if the phase is not located in an operation.

Datatype

Operation() As IBatchOperation

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Phase

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseStateChangedEventData -> BatchPhaseStateChangedEventData-Properties -> Phase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Phase that fired the event.

Datatype

Phase() As IBatchPhase

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


MasterRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseStateChangedEventData -> BatchPhaseStateChangedEventData-Properties -> MasterRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype

MasterRecipe() As IBatchMasterRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ControlRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseStateChangedEventData -> BatchPhaseStateChangedEventData-Properties -> ControlRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype

ControlRecipe() As IBatchControlRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


OldExecutionState

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseStateChangedEventData -> BatchPhaseStateChangedEventData-Properties -> OldExecutionState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Mode from before the change.

Datatype

OldExecutionState() As tpBatchExecutionState

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


NewExecutionState

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseStateChangedEventData -> BatchPhaseStateChangedEventData-Properties -> NewExecutionState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

New state from after the change.

Datatype

NewExecutionState() As tpBatchExecutionState

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


User

Manual -> Programming interfaces -> Objectmodel -> BatchPhaseStateChangedEventData -> BatchPhaseStateChangedEventData-Properties -> User

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

User() As IUser

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchRecipeId

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeId

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains both the master recipe Id and the control recipe Id for a recipe.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

BatchRecipeId-Properties


BatchRecipeId-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeId -> BatchRecipeId-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | MRId | Master recipe Id of the recipe | not used | read only | yes | yes
long | CRId | Control recipe Id of the recipe | not used | read only | yes | yes

Other topics in this chapter

MRId

CRId


MRId

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeId -> BatchRecipeId-Properties -> MRId

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MRId() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


CRId

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeId -> BatchRecipeId-Properties -> CRId

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CRId() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchRecipeModeChangedEventData

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeModeChangedEventData

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The data class that gets passed when the RecipeModeChanged Event of the BatchManager is fired. It contains all relevant information for this event.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

BatchRecipeModeChangedEventData-Properties


BatchRecipeModeChangedEventData-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeModeChangedEventData -> BatchRecipeModeChangedEventData-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
DATE | Time | Time when the event was fired | not used | read only | yes | yes
IBatchMasterRecipe | MasterRecipe | Master recipe for which the event was fired | not used | read only | yes | yes
IBatchControlRecipe | ControlRecipe | Control recipe for which the event was fired | not used | read only | yes | yes
IUser | User | Logged in user | not used | read only | yes | yes
tpBatchExecutionMode | OldExecutionMode | Execution mode before the change | not used | read only | yes | yes
tpBatchExecutionMode | NewExecutionMode | Execution mode after the change | not used | read only | yes | yes
IUser | User | Logged in user | not used | read only | yes | yes

Other topics in this chapter

Time

MasterRecipe

ControlRecipe

User

OldExecutionMode

NewExecutionMode


Time

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeModeChangedEventData -> BatchRecipeModeChangedEventData-Properties -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Timestamp of the value

Datatype

Time() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


MasterRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeModeChangedEventData -> BatchRecipeModeChangedEventData-Properties -> MasterRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype

MasterRecipe() As IBatchMasterRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ControlRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeModeChangedEventData -> BatchRecipeModeChangedEventData-Properties -> ControlRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype

ControlRecipe() As IBatchControlRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


User

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeModeChangedEventData -> BatchRecipeModeChangedEventData-Properties -> User

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Copy of the currently logged User at the time the switch was triggered via GUI. For automated changes (reactions, automatically executed zenon functions) this is a copy of the SYSTEM.

Datatype

User() As IUser

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


OldExecutionMode

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeModeChangedEventData -> BatchRecipeModeChangedEventData-Properties -> OldExecutionMode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Old execution mode before the event.

Datatype

OldExecutionMode() As tpBatchExecutionMode

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


NewExecutionMode

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeModeChangedEventData -> BatchRecipeModeChangedEventData-Properties -> NewExecutionMode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

New execution mode after the event.

Datatype

NewExecutionMode() As tpBatchExecutionMode

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchRecipeStateChangedEventData

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeStateChangedEventData

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The data class that gets passed when the RecipeStateChanged Event of the BatchManager is fired. It contains all relevant information for this event.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

BatchRecipeStateChangedEventData-Properties


BatchRecipeStateChangedEventData-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeStateChangedEventData -> BatchRecipeStateChangedEventData-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
DATE | Time | Time when the event was fired | not used | read only | yes | yes
IBatchMasterRecipe | MasterRecipe | Master recipe for which the event was fired | not used | read only | yes | yes
IBatchControlRecipe | ControlRecipe | Control recipe for which the event was fired | not used | read only | yes | yes
tpBatchExecutionState | OldExecutionState | Execution state before the change | not used | read only | yes | yes
tpBatchExecutionState | NewExecutionState | Execution state after the change | not used | read only | yes | yes
IUser | User | Logged in user | not used | read only | yes | yes

Other topics in this chapter

Time

MasterRecipe

ControlRecipe

User

OldExecutionState

NewExecutionState


Time

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeStateChangedEventData -> BatchRecipeStateChangedEventData-Properties -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Timestamp of the value

Datatype

Time() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


MasterRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeStateChangedEventData -> BatchRecipeStateChangedEventData-Properties -> MasterRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Master Recipe that fired this event. Null if the event was fired by a control recipe.

Datatype

MasterRecipe() As IBatchMasterRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ControlRecipe

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeStateChangedEventData -> BatchRecipeStateChangedEventData-Properties -> ControlRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Control recipe that fired this event. Null if the event was fired by a master recipe.

Datatype

ControlRecipe() As IBatchControlRecipe

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


User

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeStateChangedEventData -> BatchRecipeStateChangedEventData-Properties -> User

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Copy of the user that triggered the event. For user-triggered changes Only, this is the currently logged user at the time of the change is performed. The logged user is only used for the switch to the direct resulting transient state: Start(IDLE->RUNNING), resume(PAUSED->RUNNING) and switches to transient states. For the other changes to the absolute states the SYSTEM user is used, because they are triggered by the execution itself. Also all automated changes (reactions, automatically executed zenon functions) use the SYSTEM user.

Datatype

User() As IUser

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


OldExecutionState

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeStateChangedEventData -> BatchRecipeStateChangedEventData-Properties -> OldExecutionState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Old execution state before the event.

Datatype

OldExecutionState() As tpBatchExecutionState

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


NewExecutionState

Manual -> Programming interfaces -> Objectmodel -> BatchRecipeStateChangedEventData -> BatchRecipeStateChangedEventData-Properties -> NewExecutionState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

New execution state after the event.

Datatype

NewExecutionState() As tpBatchExecutionState

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchTag

Manual -> Programming interfaces -> Objectmodel -> BatchTag

Remarks

The object that encapsulates a variable for the purposes of the batch execution.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

BatchTag-Properties


BatchTag-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchTag -> BatchTag-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | ID | ID of the tag | not used | read only | yes | yes
BSTR | Name | Name of the tag | not used | read only | yes | yes
BSTR | Description | Description of the tag | not used | read only | yes | yes
IVariableValue | CurrentValue | Current value of the variable linked as the current value variable on the tag | not used | read only | yes | yes
IVariableValue | TagVariableValue | Current value of the variable linked as the tag variable on the tag | not used | read only | yes | yes
IBatchTagValue | TagValue | Value that is to be written on the tag variable | not used | read only | yes | yes
BSTR | Unit | Unit of the tag | not used | read only | yes | yes
tpBatchTagDataType | DataType | Data type for the tag | not used | read only | yes | yes
tpBatchTagType | TagType | Type of the tag | not used | read only | yes | yes
IVariable | TagVariable | Main Variable of the tag. For command tags the value is written onto this variable. | not used | read only | yes | yes
IVariable | CurrentValueVariable | For command tags this is the variable that shows the current value for the tag on the PLC. | not used | read only | yes | yes

Other topics in this chapter

ID

Name

Description

CurrentValue

TagVariableValue

TagValue

Unit

DataType

TagType

TagVariable

CurrentValueVariable


ID

Manual -> Programming interfaces -> Objectmodel -> BatchTag -> BatchTag-Properties -> ID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

ID of the tag.

Datatype

ID() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> BatchTag -> BatchTag-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Name of the tag.

Datatype

Name() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Description

Manual -> Programming interfaces -> Objectmodel -> BatchTag -> BatchTag-Properties -> Description

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Description of the tag.

Datatype

Description() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


CurrentValue

Manual -> Programming interfaces -> Objectmodel -> BatchTag -> BatchTag-Properties -> CurrentValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Current value of the variable linked as the current value variable on the tag .

Datatype

CurrentValue() As IVariableValue

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


TagVariableValue

Manual -> Programming interfaces -> Objectmodel -> BatchTag -> BatchTag-Properties -> TagVariableValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Current value of thje variable linked as tag varaible.

Datatype

TagVariableValue() As IVariableValue

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


TagValue

Manual -> Programming interfaces -> Objectmodel -> BatchTag -> BatchTag-Properties -> TagValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

): Value that is written on the tag variable.

Datatype

TagValue() As IBatchTagValue

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Unit

Manual -> Programming interfaces -> Objectmodel -> BatchTag -> BatchTag-Properties -> Unit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Unit of the tag.

Datatype

Unit() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


DataType

Manual -> Programming interfaces -> Objectmodel -> BatchTag -> BatchTag-Properties -> DataType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype of the tag.

Datatype

DataType() As tpBatchTagDataType

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


TagType

Manual -> Programming interfaces -> Objectmodel -> BatchTag -> BatchTag-Properties -> TagType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Type of the tag (initial, value, return).

Datatype

TagType() As tpBatchTagType

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


TagVariable

Manual -> Programming interfaces -> Objectmodel -> BatchTag -> BatchTag-Properties -> TagVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Variable that is linked on the Tag. For command tags this is the one that has the values written to it.

Datatype

TagVariable() As IVariable

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


CurrentValueVariable

Manual -> Programming interfaces -> Objectmodel -> BatchTag -> BatchTag-Properties -> CurrentValueVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

If the readable datapoint differs from the writeable one for a command tag, the readable one can be linked here. It is null for tags on which it is not linked.

Datatype

CurrentValueVariable() As IVariable

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchTags

Manual -> Programming interfaces -> Objectmodel -> BatchTags

Remarks

A collection of tags. Allows you to iterate and get tags.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

BatchTags-Properties

BatchTags-Methods


BatchTags-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchTags -> BatchTags-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | Count | Count of the tags | not used | read only | yes | yes

Other topics in this chapter

Count


Count

Manual -> Programming interfaces -> Objectmodel -> BatchTags -> BatchTags-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

number of tags in the collection.

Datatype

Count() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


BatchTags-Methods

Manual -> Programming interfaces -> Objectmodel -> BatchTags -> BatchTags-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
IBatchTag | ItemByIndex | Gets a tag by its index in the collection | not used | read only | yes | yes
IBatchTag | ItemByName | Gets a tag by its name | not used | read only | yes | yes
IBatchTag | ItemById | Gets a tag by its ID | not used | read only | yes | yes

Other topics in this chapter

ItemByIndex

ItemByName

ItemById


ItemByIndex

Manual -> Programming interfaces -> Objectmodel -> BatchTags -> BatchTags-Methods -> ItemByIndex

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets a batch tag by its index in the collection.

Datatype

ItemByIndex(long lIndex) As IBatchTag

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

using System.Diagnostics;

void ThisProject_Active()

{

//Check in the PhaseProgress Event

BatchManager().PhaseProgress += new PhaseProgressEventHandler(

ThisProject_PhaseProgress);

}

void ThisProject_PhaseProgress(IBatchPhaseProgressEventData eventData)

{

//Write 3 debug messages with tag data to the listener when event is fired.

Debug.WriteLine(eventData.Phase.Tags.ItemByIndex(0).TagValue.String);

Debug.WriteLine(eventData.Phase.Tags.ItemById(0).Name);

Debug.WriteLine(eventData.Phase.Tags.ItemByName("ExampleTag1").ID);

//…Write tag count to debugger

Debug.WriteLine(eventData.Phase.Tags.Count);

}

void ThisProject_Inactive()

{

//Check out the PhaseProgress Event

BatchManager().PhaseProgress -= ThisProject_PhaseProgress;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

VB.NET

VBA

Dim WithEvents zBatchManager As batchManager

'procedure is executed on startup of the zenOn runtime

Private Sub Project_Active()

'init the Batchmanager object for events

Set zBatchManager = thisProject.batchManager

End Sub

'procedure is executed on terminating the zenOn Runtime

Private Sub Project_Inactive()

'free the batchmanager object

Set zBatchManager = Nothing

End Sub

'procedure is executed when a phase is in progress

Private Sub zBatchManager_PhaseProgress(ByVal eventData As IBatchPhaseProgressEventData)

'print tag data to debug window

Debug.Print (eventData.Phase.Tags.ItemByIndex(0).TagValue.String)

Debug.Print (eventData.Phase.Tags.ItemById(0).Name)

Debug.Print (eventData.Phase.Tags.ItemByName("ExampleTag1").ID)

Debug.Print (eventData.Phase.Tags.Count)

End Sub


ItemByName

Manual -> Programming interfaces -> Objectmodel -> BatchTags -> BatchTags-Methods -> ItemByName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets a batch tag by its name.

Datatype

ItemByName(BSTR bstrName) As IBatchTag

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

using System.Diagnostics;

void ThisProject_Active()

{

//Check in the PhaseProgress Event

BatchManager().PhaseProgress += new PhaseProgressEventHandler(

ThisProject_PhaseProgress);

}

void ThisProject_PhaseProgress(IBatchPhaseProgressEventData eventData)

{

//Write 3 debug messages with tag data to the listener when event is fired.

Debug.WriteLine(eventData.Phase.Tags.ItemByIndex(0).TagValue.String);

Debug.WriteLine(eventData.Phase.Tags.ItemById(0).Name);

Debug.WriteLine(eventData.Phase.Tags.ItemByName("ExampleTag1").ID);

//…Write tag count to debugger

Debug.WriteLine(eventData.Phase.Tags.Count);

}

void ThisProject_Inactive()

{

//Check out the PhaseProgress Event

BatchManager().PhaseProgress -= ThisProject_PhaseProgress;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

VB.NET

VBA

Dim WithEvents zBatchManager As batchManager

'procedure is executed on startup of the zenOn runtime

Private Sub Project_Active()

'init the Batchmanager object for events

Set zBatchManager = thisProject.batchManager

End Sub

'procedure is executed on terminating the zenOn Runtime

Private Sub Project_Inactive()

'free the batchmanager object

Set zBatchManager = Nothing

End Sub

'procedure is executed when a phase is in progress

Private Sub zBatchManager_PhaseProgress(ByVal eventData As IBatchPhaseProgressEventData)

'print tag data to debug window

Debug.Print (eventData.Phase.Tags.ItemByIndex(0).TagValue.String)

Debug.Print (eventData.Phase.Tags.ItemById(0).Name)

Debug.Print (eventData.Phase.Tags.ItemByName("ExampleTag1").ID)

Debug.Print (eventData.Phase.Tags.Count)

End Sub


ItemById

Manual -> Programming interfaces -> Objectmodel -> BatchTags -> BatchTags-Methods -> ItemById

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets a batch tag by its id.

Datatype

ItemById(long lId) As IBatchTag

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

using System.Diagnostics;

void ThisProject_Active()

{

//Check in the PhaseProgress Event

BatchManager().PhaseProgress += new PhaseProgressEventHandler(

ThisProject_PhaseProgress);

}

void ThisProject_PhaseProgress(IBatchPhaseProgressEventData eventData)

{

//Write 3 debug messages with tag data to the listener when event is fired.

Debug.WriteLine(eventData.Phase.Tags.ItemByIndex(0).TagValue.String);

Debug.WriteLine(eventData.Phase.Tags.ItemById(0).Name);

Debug.WriteLine(eventData.Phase.Tags.ItemByName("ExampleTag1").ID);

//…Write tag count to debugger

Debug.WriteLine(eventData.Phase.Tags.Count);

}

void ThisProject_Inactive()

{

//Check out the PhaseProgress Event

BatchManager().PhaseProgress -= ThisProject_PhaseProgress;

//Final release and garbage collection of any API-Objects.

FreeObjects();

}

VB.NET

VBA

Dim WithEvents zBatchManager As batchManager

'procedure is executed on startup of the zenOn runtime

Private Sub Project_Active()

'init the Batchmanager object for events

Set zBatchManager = thisProject.batchManager

End Sub

'procedure is executed on terminating the zenOn Runtime

Private Sub Project_Inactive()

'free the batchmanager object

Set zBatchManager = Nothing

End Sub

'procedure is executed when a phase is in progress

Private Sub zBatchManager_PhaseProgress(ByVal eventData As IBatchPhaseProgressEventData)

'print tag data to debug window

Debug.Print (eventData.Phase.Tags.ItemByIndex(0).TagValue.String)

Debug.Print (eventData.Phase.Tags.ItemById(0).Name)

Debug.Print (eventData.Phase.Tags.ItemByName("ExampleTag1").ID)

Debug.Print (eventData.Phase.Tags.Count)

End Sub


BatchTagValue

Manual -> Programming interfaces -> Objectmodel -> BatchTagValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Value for a tag that is written to the variable of the tag. It contains fields for all possible data types of the tag.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

BatchTagValue-Properties


BatchTagValue-Properties

Manual -> Programming interfaces -> Objectmodel -> BatchTagValue -> BatchTagValue-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
tpBatchBoolValue | Bool | Bool value | not used | read only | yes | yes
BSTR | String | String value | not used | read only | yes | yes
double | Numeric | Numerical value | not used | read only | yes | yes
long | Duration | Duration value in seconds | not used | read only | yes | yes

Other topics in this chapter

Bool

String

Numeric

Duration


Bool

Manual -> Programming interfaces -> Objectmodel -> BatchTagValue -> BatchTagValue-Properties -> Bool

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Bool value for the tag.

Datatype

Bool() As tpBatchBoolValue

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


String

Manual -> Programming interfaces -> Objectmodel -> BatchTagValue -> BatchTagValue-Properties -> String

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

String value for the tag.

Datatype

String() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Numeric

Manual -> Programming interfaces -> Objectmodel -> BatchTagValue -> BatchTagValue-Properties -> Numeric

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Numerical value for the tag.

Datatype

Numeric() As double

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Duration

Manual -> Programming interfaces -> Objectmodel -> BatchTagValue -> BatchTagValue-Properties -> Duration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Duration value for the tag.

Datatype

Duration() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Cel

Manual -> Programming interfaces -> Objectmodel -> Cel

Remarks

The CEL Object represents the "Chronological Event List" an offers the feature to write user defined Events into the list or react on entries in the list...There are some methods and events implemented, to see how they are working look at the Sample below or take a detailed look at the objects properties...

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

private ICel zenonCel;

private IDynPicture zenonCelPicture;

private bool celFlag = false;

void ThisProject_Inactive()

{

this.zenonCelPicture.Open -= new OpenEventHandler(zenonCelPicture_Open);

this.zenonCelPicture = null;

if (this.zenonCel != null)

{

this.zenonCel.CelListSelectionChanged -= new CelListSelectionChangedEventHandler(zenonCel_CelListSelectionChanged);

this.zenonCel = null;

}

FreeObjects();

}

void zenonCelPicture_Open()

{

celFlag = true;

zenonCel = this.Cel();

zenonCel.CelListSelectionChanged += new CelListSelectionChangedEventHandler(zenonCel_CelListSelectionChanged);

}

void zenonCel_CelListSelectionChanged(ICelItem obItem)

{

if (celFlag == true)

celFlag = false;

else

System.Diagnostics.Debug.Print("C_Changed - " + obItem.Text);

}

void ThisProject_Active()

{

//Initialize screen objects to get Open/Close events of the screen

this.zenonCelPicture = this.DynPictures().Item("CEL");

this.zenonCelPicture.Open += new OpenEventHandler(zenonCelPicture_Open);

}

VB.NET

Private zenonCel As ICel

Private zenonCelPicture As IDynPicture

Private celFlag As Boolean = False

Private Sub ThisProject_Inactive()

RemoveHandler Me.zenonCelPicture.Open, AddressOf zenonCelPicture_Open

Me.zenonCelPicture = Nothing

If Me.zenonCel IsNot Nothing Then

RemoveHandler Me.zenonCel.CelListSelectionChanged, AddressOf zenonCel_CelListSelectionChanged

Me.zenonCel = Nothing

End If

FreeObjects()

End Sub

Private Sub zenonCelPicture_Open()

celFlag = True

zenonCel = Me.Cel()

AddHandler Me.zenonCel.CelListSelectionChanged, AddressOf zenonCel_CelListSelectionChanged

End Sub

Private Sub zenonCel_CelListSelectionChanged(obItem As ICelItem)

If celFlag = True Then

celFlag = False

Else

System.Diagnostics.Debug.Print("C_Changed - " & Convert.ToString(obItem.Text))

End If

End Sub

Private Sub ThisProject_Active()

'Initialize screen objects to get Open/Close events of the screen

Me.zenonCelPicture = Me.DynPictures().Item("CEL")

AddHandler Me.zenonCelPicture.Open, AddressOf zenonCelPicture_Open

End Sub

VBA

'##########################################################
'### this Code can be used within the 'thisProject' ###
'### object class, because of the project events! ###
'##########################################################
'Declare Objects to get the Events...
Dim WithEvents zCEL As Cel
Dim WithEvents zCELPIC As DynPicture
Dim bCEL As Boolean

'##########################################################
'### Project Events - START/END of the zenOn Runtime ###
'##########################################################
Private Sub Project_Active()
'Init screen pbjects to get Open/Close events of the screens
Set zCELPIC = thisProject.DynPictures.Item("CEL")
End Sub

Private Sub Project_Inactive()
'release objects
Set zCELPIC = Nothing
End Sub

'##########################################################
'### Procedures/Events for the Chronological event list ###
'##########################################################
Private Sub zCELPIC_Open()
'boolen flag to remember the open event
bCEL = True
'init CEL Object to get the CelListSelectionChanged event
Set zCEL = thisProject.Cel
End Sub

Private Sub zCELPIC_Close()
'release object
Set zCEL = Nothing
End Sub

Private Sub zCEL_CelListSelectionChanged(ByVal obItem As ICelItem)
'If the boolen is TRUE, the first events can be ignored
'because in this case the events returns the default
'selection on opening the screen
If bCEL = True Then
bCEL = False
Else
Debug.Print "C_Changed - " & obItem.Text
End If
End Sub

Other topics in this chapter

Cel-Properties

Cel-Methods

Cel-Events

Cel-Dynamic properties


Cel-Properties

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IProject | Parent | Parent-object | read only | read only

Other topics in this chapter

Parent


Parent

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Cel-Methods

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
ICelItems | CelItems | Return the CelItems | not used | read only
void | WriteCelString | Creates a new cel-item (only runtime) | not used | available
void | WriteCelStringEx | Creates a new extended cel-item (only runtime) | not used | available
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used
VARIANT | DynPropertiesEnum [GET] |  | read only | read only
VARIANT | DynProperties [GET] |  | available | available
void | DynProperties [PUT] |  | available | available
void | WriteCelStringTimestamp | Creates a new extended cel-item including timestamp (Runtime only) | not used | available
void | ResetQueryFilter | Resets the QueryFilter | not used | read only

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

WriteCelString

WriteCelStringEx

WriteCelStringTimestamp

CelItems

ResetQueryFilter


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As IPropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum [GET](BSTR bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties [GET](BSTR bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties [PUT](BSTR bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


WriteCelString

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Methods -> WriteCelString

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new cel-item (only runtime)

Datatype

WriteCelString(String strCelString) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

The given String will be written into the chronological event list (actual Timestamp)
Example: "VBA Error " & Err.Number & " in procedure DoSome!"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

strCelString As String

Examples

C#

public void WriteStringToCel(string text)

{

//Writes a new standard CEL entry

this.Cel().WriteCelString(text);

}

VB.NET

Public Sub WriteStringToCel(text As String)

'Writes a new standard CEL entry

Me.Cel().WriteCelString(text)

End Sub

VBA

Public Sub WriteString2CEL(YourText As String)
'a new entry will be generated in the CEL with the actual timestamp...
thisProject.Cel.WriteCelString YourText
End Sub


WriteCelStringEx

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Methods -> WriteCelStringEx

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new extended cel-item (only runtime)

Datatype

WriteCelStringEx(String strCelString,String szPvName,long iGroup,long iClass,VARIANT Value,long Status) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

StatusValue contains all actual status information as single bits...

Status Bits:

Status | Bit | Value (DEC) | Value (HEX)
ST_M1 / Status1 | 0 | 1 | 1
ST_M2 / Status2 | 1 | 2 | 2
ST_M3 / Status3 | 2 | 4 | 4
ST_M4 / Status4 | 3 | 8 | 8
ST_M5 / Status5 | 4 | 16 | 10
ST_M6 / Status6 | 5 | 32 | 20
ST_M7 / Status7 | 6 | 64 | 40
ST_M8 / Status8 | 7 | 128 | 80
SELEC / Select | 8 | 256 | 100
REV / Revision | 9 | 512 | 200
DIREC / Desired direction | 10 | 1.024 | 400
RTE / Runtime exceeded | 11 | 2.048 | 800
MVALUE / Manual value | 12 | 4.096 | 1000
ST_M14 / Status14 | 13 | 8.192 | 2000
ST_M15 / Status15 | 14 | 16.384 | 4000
ST_M16 / Status16 | 15 | 32.768 | 8000
GR / General request | 16 | 65.536 | 10000
SPONT / Spontaneous | 17 | 131.072 | 20000
I-BIT / Invalid | 18 | 262.144 | 40000
SU/WI / Summer/winter time announcement | 19 | 524.288 | 80000
N_UPDATE / switched off | 20 | 1.048.576 | 100000
RT_E / Realtime external | 21 | 2.097.152 | 200000
RT_I / Realtime internal | 22 | 4.194.304 | 400000
NSORT / Not sortable | 23 | 8.388.608 | 800000
DM_TR / Default message trafo value | 24 | 16.777.216 | 1000000
RM_TR / Running message trafo value | 25 | 33.554.432 | 2000000
INFO / Info for variable | 26 | 67.108.864 | 4000000
AVALUE / Alternative value | 27 | 134.217.728 | 8000000
ACTUAL / Not updated | 29 | 536.870.912 | 20000000
WINTER / Winter time | 30 | 1.073.741.824 | 40000000
BLINK / Blink | 31 | 2.147.483.648 | 80000000
TCBx / Transmission cause bit x | 32 | 4.294.967.296 | 100000000
TCBx / Transmission cause bit x | 33 | 8.589.934.592 | 200000000
TCBx / Transmission cause bit x | 34 | 17.179.869.184 | 400000000
TCBx / Transmission cause bit x | 35 | 34.359.738.368 | 800000000
TCBx / Transmission cause bit x | 36 | 68.719.476.736 | 1000000000
TCBx / Transmission cause bit x | 37 | 137.438.953.472 | 2000000000
PN_BIT / P/N bit | 38 | 274.877.906.944 | 4000000000

ID of AlarmClass for filtering within the chronological event list...

The given String will be written into the chronological event list (actual Timestamp)

Example: "VBA Error " & Err.Number & " in procedure DoSome!"

ID of AlarmGroup for filtering within the chronological event list...

Name of a variable, the variable will be listed in the chronological event list...

Value as Variant, means the value entry within the chronological event list...

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Status As Long

iClass As Long

strCelString As String

iGroup As Long

szPvName As String

Value As Variant

Examples

C#

public void WriteExStringToCel(string text, string variableName,

int groupNumber, int classNumber, object vValue, int status)

{

//Writes a new extended CEL entry with given names, grpNr, clsNr, value and status bits

this.Cel().WriteCelStringEx(text, variableName, groupNumber, classNumber, vValue, status);

}

VB.NET

Public Sub WriteExStringToCel(text As String, variableName As String, groupNumber As Integer, classNumber As Integer, vValue As Object, status As Integer)

'Writes a new extended CEL entry with given names, grpNr, clsNr, value and status bits

Me.Cel().WriteCelStringEx(text, variableName, groupNumber, classNumber, vValue, status)

End Sub

VBA

Public Sub WriteExString2CEL(YourText As String, VarName As String, _
GroupNr As Long, ClassNr As Long, _
vValue As Variant, lStatus As Long)
'a new entry will be generated in the CEL with the actual timestamp...
Call thisProject.Cel.WriteCelStringEx(YourText, VarName, GroupNr, _
ClassNr, vValue, lStatus)
End Sub


WriteCelStringTimestamp

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Methods -> WriteCelStringTimestamp

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new cel-item + timestamp (only runtime)

Datatype

WriteCelStringTimestamp(BSTR strCelString, BSTR szPvName, long iGroup, long iClass, VARIANT Value, long Status, long Time, short TimeMilliSec) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

public void WriteTimeStampToCel(string text, string variableName,

int groupNumber, int classNumber, object vValue, int status, int time, short milliseconds)

{ //Writes a new extended CEL entry with the given names, grpNr, clsNr, value, status bits and time

//NOTE: zenon time format necessary for the time parameter

this.Cel().WriteCelStringTimestamp(text, variableName, groupNumber, classNumber, vValue, status,

time, milliseconds);

}

VB.NET

Public Sub WriteTimeStampToCel(text As String, variableName As String, groupNumber As Integer, classNumber As Integer, vValue As Object, status As Integer, _

time As Integer, milliseconds As Short)

'Writes a new extended CEL entry with the given names, grpNr, clsNr, value, status bits and time

'NOTE: Zenon time format necessary for the time parameter

Me.Cel().WriteCelStringTimestamp(text, variableName, groupNumber, classNumber, vValue, status, _

time, milliseconds)

End Sub

VBA

Public Sub writeCel()

Call thisProject.Cel.WriteCelStringTimestamp("Mytext", "RGM_visible", 1, 1, 0, 0, 123, 456)

End Sub


CelItems

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Methods -> CelItems

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Object to get all Items are actually in memory...

Filter String: If the string is not "*", then the string should represent the name (case sensitive) of a zenon function.If a function with the given name exists, the filter settings within this function will be used. --> only version 6.51 and above

Datatype

CelItems(String strFilter) As CelItems

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A Filter is not implemented yet. To avoid problems in future use always the asterisk...
Example:

Debug.Print zCelItems("*").Count

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

strFilter As String

Examples

C#

public void MacroGetAllCelItems()

{

//Print text for each item

for (int i = 0; i < this.Cel().CelItems("*").Count; ++i )

System.Diagnostics.Debug.Print(this.Cel().CelItems("*").Item(i).Text);

}

VB.NET

Public Sub MacroGetAllCelItems()

'Print text for each item

For i As Integer = 0 To Me.Cel().CelItems("*").Count - 1

System.Diagnostics.Debug.Print(Me.Cel().CelItems("*").Item(i).Text)

Next

End Sub

VBA

'##########################################################
'### Get all CEL Items of the project ###
'##########################################################
Public Sub GetAllItems()
Dim i As Integer
'get all items in memory...
For i = 0 To thisProject.Cel.CelItems("*").Count - 1
'print text of item to outputwindow
Debug.Print thisProject.Cel.CelItems("*").Item(i).Text
Next i
End Sub

'get specific item using the screen switch function as filter

'thisProject.Cel.CelItems("myFunction").Count - 1


ResetQueryFilter

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Methods -> ResetQueryFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Specify Cel filter or set default value.

Datatype

ResetQueryFilter() As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

//Manipulation using the query filter

Project.Cel.ResetQueryFilter()

Project.Cel.SetDynProp(„QueryFilter.XXX", ZZZ)

//get items using the query filter

Project.Cel.AmlItems(„.")

VB.NET

VBA


Cel-Events

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description |  | Editor | Runtime | VBA | VSTA
void | CelItemAdded | Event is fired when a new entry has been added to the CEL |  | not used | available | yes | yes
void | CelItemCommentChanged |  | not used |  | available | yes |  | yes
void | CelListSelectionChanged |  | not used |  | read only | yes |  | yes
void | SelectionChangedEx | Event: selection array in the event list has been changed... | not used |  | read only | yes |  | yes

Other topics in this chapter

CelItemAdded

CelListSelectionChanged

CelItemCommentChanged

SelectionChangedEx


CelItemAdded

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Events -> CelItemAdded

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Event is fired, when a new item was added...

Datatype

CelItemAdded(CelItem obItem) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

Returns the added CelItem as Object...

C#

private ICel zenonCel;

void ThisProject_Active()

{

this.zenonCel = this.Cel();

this.zenonCel.CelItemAdded += new CelItemAddedEventHandler(zenonCel_CelItemAdded);

}

void zenonCel_CelItemAdded(ICelItem obItem)

{

//Print every time an item is added to the CEL

System.Diagnostics.Debug.Print("CellItemAdded - " + obItem.Text);

}

void ThisProject_Inactive()

{

this.zenonCel.CelItemAdded -= new CelItemAddedEventHandler(zenonCel_CelItemAdded);

this.zenonCel = null;

FreeObjects();

}

VB.NET

Private zenonCel As ICel

Private Sub ThisProject_Active()

Me.zenonCel = Me.Cel()

AddHandler Me.zenonCel.CelItemAdded, AddressOf zenonCel_CelItemAdded

End Sub

Private Sub zenonCel_CelItemAdded(obItem As ICelItem)

'Print every time an item is added to the CEL

System.Diagnostics.Debug.Print("CellItemAdded - " & Convert.ToString(obItem.Text))

End Sub

Private Sub ThisProject_Inactive()

RemoveHandler Me.zenonCel.CelItemAdded, AddressOf zenonCel_CelItemAdded

Me.zenonCel = Nothing

FreeObjects()

End Sub

VBA

obItem As CelItem

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Dim WithEvents zCEL As Cel

'##########################################################
'### Procedures/Events of the Project ###
'##########################################################
Private Sub Project_Active()
'init CEL Object to get the CelItemAdded event
Set zCEL = thisProject.Cel
End Sub

Private Sub Project_Inactive()
'release object
Set zCEL = Nothing
End Sub

'##########################################################
'### Procedures/Events for the CEL DynPicture ###
'##########################################################
Private Sub zCEL_CelItemAdded(ByVal obItem As ICelItem)
'when a new entry was generated....
Debug.Print "CelItemAdded - " & obItem.Text
End Sub


CelListSelectionChanged

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Events -> CelListSelectionChanged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The event will be fired whenever the Selection in the list is changed, when an item is selected the Entry will be passed on through the zenon-API. When an item has been deselected, the eventparameter will be "Nothing".Additionally the event will be triggered whenever an AML/CEL picture is closed. (This could lead the event being triggered twice with "Nothing").NOTE: When the Property "hide current selection" has been set at the listcontrol, the event will/should not be fired(!)

Datatype

CelListSelectionChanged(CelItem obItem) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

Returns the added CelItem as Object...

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

obItem As CelItem

Examples

C#

private ICel zenonCel;

private IDynPicture zenonCelPicture;

private bool celFlag = false;

void ThisProject_Inactive()

{

this.zenonCelPicture.Open -= new OpenEventHandler(zenonCelPicture_Open);

this.zenonCelPicture = null;

if (this.zenonCel != null)

{

this.zenonCel.CelListSelectionChanged -= new CelListSelectionChangedEventHandler(zenonCel_CelListSelectionChanged);

this.zenonCel = null;

}

FreeObjects();

}

void zenonCelPicture_Open()

{

celFlag = true;

zenonCel = this.Cel();

zenonCel.CelListSelectionChanged += new CelListSelectionChangedEventHandler(zenonCel_CelListSelectionChanged);

}

void zenonCel_CelListSelectionChanged(ICelItem obItem)

{

if (celFlag == true)

celFlag = false;

else

System.Diagnostics.Debug.Print("C_Changed - " + obItem.Text);

}

void ThisProject_Active()

{

//Initialize screen objects to get Open/Close events of the screen

this.zenonCelPicture = this.DynPictures().Item("CEL");

this.zenonCelPicture.Open += new OpenEventHandler(zenonCelPicture_Open);

}

VB.NET

Private zenonCel As ICel

Private zenonCelPicture As IDynPicture

Private celFlag As Boolean = False

Private Sub ThisProject_Inactive()

RemoveHandler Me.zenonCelPicture.Open, AddressOf zenonCelPicture_Open

Me.zenonCelPicture = Nothing

If Me.zenonCel IsNot Nothing Then

RemoveHandler Me.zenonCel.CelListSelectionChanged, AddressOf zenonCel_CelListSelectionChanged

Me.zenonCel = Nothing

End If

FreeObjects()

End Sub

Private Sub zenonCelPicture_Open()

celFlag = True

zenonCel = Me.Cel()

AddHandler Me.zenonCel.CelListSelectionChanged, AddressOf zenonCel_CelListSelectionChanged

End Sub

Private Sub zenonCel_CelListSelectionChanged(obItem As ICelItem)

If celFlag = True Then

celFlag = False

Else

System.Diagnostics.Debug.Print("C_Changed - " & Convert.ToString(obItem.Text))

End If

End Sub

Private Sub ThisProject_Active()

'Initialize screen objects to get Open/Close events of the screen

Me.zenonCelPicture = Me.DynPictures().Item("CEL")

AddHandler Me.zenonCelPicture.Open, AddressOf zenonCelPicture_Open

End Sub

VBA

Dim WithEvents zCELPIC As DynPicture
Dim WithEvents zCEL As Cel
Dim bCEL As Boolean

'##########################################################
'### Procedures/Events of the Project ###
'##########################################################
Private Sub Project_Active()
'set this object to get the Picture Open/Close Events...
Set zCELPIC = thisProject.DynPictures.Item("CELPICTURENAME")
End Sub

Private Sub Project_Inactive()
'release object
Set zCELPIC = Nothing
End Sub

'##########################################################
'### Procedures/Events for the CEL DynPicture ###
'##########################################################
Private Sub zCELPIC_Open()
'boolen flag to remember the open event
bCEL = True
'init CEL Object to get the CelListSelectionChanged event
Set zCEL = thisProject.Cel
End Sub

Private Sub zCELPIC_Close()
'release object
Set zCEL = Nothing
End Sub

'##########################################################
'### Procedures/Events for the ChronologicalEventList ###
'##########################################################
Private Sub zCEL_CelListSelectionChanged(ByVal obItem As ICelItem)
'If the boolen is TRUE, the first events can be ignored
'because in this case the events returns the default
'selection on opening the picture
If bCEL = True Then
bCEL = False
Else
If obItem Is Nothing Then Exit Sub
Debug.Print "SelectionChanged - " & obItem.Text
End If
End Sub


CelItemCommentChanged

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Events -> CelItemCommentChanged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CelItemCommentChanged(String bsText) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

private ICel zenonCel;

void ThisProject_Active()

{

this.zenonCel = this.Cel();

this.zenonCel.CelItemCommentChanged += new CelItemCommentChangedEventHandler(zenonCel_CelItemCommentChanged);

}

void zenonCel_CelItemCommentChanged(ref string bsText)

{

System.Diagnostics.Debug.Print("New CEL Comment: " + bsText);

//Note: bsText may be edited in this method since its passed by reference

}

void ThisProject_Inactive()

{

this.zenonCel.CelItemCommentChanged -= new CelItemCommentChangedEventHandler(zenonCel_CelItemCommentChanged);

this.zenonCel = null;

FreeObjects();

}

VB.NET

Private zenonCel As ICel

Private Sub ThisProject_Active()

Me.zenonCel = Me.Cel()

AddHandler Me.zenonCel.CelItemCommentChanged, AddressOf zenonCel_CelItemCommentChanged

End Sub

Private Sub zenonCel_CelItemCommentChanged(ByRef bsText As String)

System.Diagnostics.Debug.Print("New CEL Comment: " & bsText)

'Note: bsText may be edited in this method since its passed by reference

End Sub

Private Sub ThisProject_Inactive()

RemoveHandler Me.zenonCel.CelItemCommentChanged, AddressOf zenonCel_CelItemCommentChanged

Me.zenonCel = Nothing

FreeObjects()

End Sub

VBA

VBA-Syntax


SelectionChangedEx

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Events -> SelectionChangedEx

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Fired when the selection changes in CEL.

Datatype

SelectionChangedEx(LPVARIANT arrSelection) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

void ThisProject_Active()

{

this.zenonCel = this.Cel();

this.zenonCel.SelectionChangedEx += new SelectionChangedExEventHandler(zenonCel_SelectionChangedEx);

}

void zenonCel_SelectionChangedEx(ref object arrSelection)

{

if (arrSelection == null)

return;

//One or more items have been selected

object[] selectedItems = (object[]) arrSelection;

for (int i = 0; i < selectedItems.Length; ++i)

{

ICelItem item = (ICelItem)selectedItems[i];

System.Diagnostics.Debug.Print(item.Text);

}

}

void ThisProject_Inactive()

{

this.zenonCel.SelectionChangedEx -= new SelectionChangedExEventHandler(zenonCel_SelectionChangedEx);

this.zenonCel = null;

FreeObjects();

}

VB.NET

Private Sub ThisProject_Active()

Me.zenonCel = Me.Cel()

AddHandler Me.zenonCel.SelectionChangedEx, AddressOf zenonCel_SelectionChangedEx

End Sub

Private Sub zenonCel_SelectionChangedEx(ByRef arrSelection As Object)

If arrSelection Is Nothing Then

Return

End If

'One or more items have been selected

Dim selectedItems As Object() = DirectCast(arrSelection, Object())

For i As Integer = 0 To selectedItems.Length - 1

Dim item As ICelItem = DirectCast(selectedItems(i), ICelItem)

System.Diagnostics.Debug.Print(item.Text)

Next

End Sub

Private Sub ThisProject_Inactive()

RemoveHandler Me.zenonCel.SelectionChangedEx, AddressOf zenonCel_SelectionChangedEx

Me.zenonCel = Nothing

FreeObjects()

End Sub

VBA

Private WithEvents MyEvents As Cel

Private Sub MyEvents_SelectionChangedEx(arrSelection As Variant)

Dim i As Integer

Dim zCelEntry As CelItem

Stop

If IsEmpty(arrSelection) Then Exit Sub

For i = 0 To UBound(arrSelection)

Set zCelEntry = arrSelection(i)

Debug.Print zCelEntry.Text

Next i

End Sub

Private Sub Project_Active()

Set MyEvents = thisProject.Cel

End Sub


Cel-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

CDlgCel

Other topics in this chapter

CD_CCelFilter

CDlgCel


CD_CCelFilter

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Dynamic properties -> CD_CCelFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BOOL | ShowSysEntriesForever | ShowSysEntriesForever | Description
VT_BSTR | FileName | FileName | With this property you get/set the file name for the different export mechanism.
VT_BSTR | VarFilter | VarFilter | "Filters for variable names, where system messages are masked out, as they are not linked to a variable. Wildcards can be used here. Default = ""*"" (All variables)"
VT_BSTR | FilterTitel | FilterTitel | "Filters for the identifictaion of variables, where system messages are masked out, as they are not linked to a variable. Wildcards can be used here. Default = ""*"""
VT_BOOL | IsFilterRT | IsFilterRT | "Displays the configuration dialog within the runtime, if set TRUE."
VT_BOOL | IsMatchCase | IsMatchCase | "Filter is case sensitive, if set TRUE. Otherwise the case sensitivity is ignored."
VT_BOOL | IsFromFiles | IsFromFiles | "Filter is applied to file entries, if set TRUE. Otherwise, the filter is applied to the entries from the memory. Hint: The maximum amount of entries which should be filtered from the file is specified by the ""EntriesCount"" DynProperty."
VT_BOOL | IsReadAll | IsReadAll |
VT_BOOL | IsAutoName | IsAutoName |
VT_BOOL | IsAML | IsAML | "Prints the alarm list, if set TRUE. Otherwise the CEL list will be printed."
VT_BOOL | IsDBASE | IsDBASE |
VT_BOOL | IsXML | IsXML |
VT_BOOL | IsRelationTime | IsRelationTime | "Display of relative times (relative to selected entries), if set TRUE."
VT_BOOL | IsUnicode | IsUnicode |
VT_BOOL | IsIncremental | IsIncremental |
VT_BOOL | IsFilterExp | IsFilterExp | "Opens the list stopped, if set TRUE. "
VT_BOOL | IsAcknowledged | IsAcknowledged | "Filters unacknowledged alarms, if set TRUE."
VT_BOOL | IsAscentOnly | IsAscentOnly | "Prints only current alarms, if set TRUE."
VT_UI2 | EntriesCount | EntriesCount | "Specifies the maximum amount of entries that should be filtered from a file. Hint: Only available, if the DynProperty ""IsFromFiles"" is set TRUE."
ZT_SCHRIFT | Font | Font | "Specifies the font that should be used. The parameter that is passed, is the index of the font within the specified font list. 0 = Standard font 1 = Default font 1 ... 5 = Default font 5 6 = User specified font 1 ... = etc. "
VT_BSTR | Classes | Classes | "Filters for alarm classes, where system messages are marked out, as they are not linked to a variable. Multiple class numbers have to be seperated with a semicolon. zFct.DynProperties(""PictFilter.Classes"") = ""1;2;"""
VT_BSTR | Groups | Groups | "Filters for alarm groups, where system messages are marked out, as they are not linked to a variable. Multiple group numbers have to be seperated with a semicolon. zFct.DynProperties(""PictFilter.Groups"") = ""1;2;"""
VT_BSTR | ResString | ResString |
ZT_ZEIT | IncTime | IncTime | "Gets or sets the minimal time for current alarms in seconds. Hint: Milliseconds can be specified with the ""mSeconds"" DynProperty."
VT_UI2 | mSeconds | mSeconds | "Gets or sets the milliseconds in addition to the ""IncTime"" DynProperty."
More... | TimeFilter | TimeFilter |
More... | ListInfo | ListInfo |
VT_BSTR | ProjectNames | ProjectNames | "Specifies the names of the projects. Multiple project names are seperated with a semicolon. zFct.DynProperties(""PictFilter.ProjectNames"") = ""PROJECT1;PROJECT2;"""
More... | TextFilter | TextFilter |
More... | StatusFilter | StatusFilter |
VT_BOOL | IsSQL | SQLBase |
VT_BSTR | SQLBase | SQLBase |
VT_BSTR | SQLTable | SQLTable |
More... | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.
More... | RTMDIFilterScreen | RTMDIFilterScreen |
VT_BSTR | Areas | Areas |
VT_BOOL | IsGoneOnly | IsGoneOnly |
VT_BOOL | NeedComment | NeedComment |
ZT_GUID | FilterPartGUID | FilterPartGUID | Description as text.
VT_BOOL | EditableInRT | EditableInRT | Description as text.


CDlgCel

Manual -> Programming interfaces -> Objectmodel -> Cel -> Cel-Dynamic properties -> CDlgCel

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | QueryFilter | Status |


CelItem

Manual -> Programming interfaces -> Objectmodel -> CelItem

Remarks

This object deliveres all information stored with the cel item...You can read this like shown in the Sample, but ther some more, like the Username, the Computer, Value or something else...

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

public void MacroGetAllCelItems()

{

//Print text for each item

for (int i = 0; i < this.Cel().CelItems("*").Count; ++i )

System.Diagnostics.Debug.Print(this.Cel().CelItems("*").Item(i).Text);

}

VB.NET

Public Sub MacroGetAllCelItems()

'Print text for each item

For i As Integer = 0 To Me.Cel().CelItems("*").Count - 1

System.Diagnostics.Debug.Print(Me.Cel().CelItems("*").Item(i).Text)

Next

End Sub

VBA

'##########################################################
'### Get all CEL Items of the project ###
'##########################################################
Public Sub GetAllItems()
Dim i As Integer
Dim zCItem As CelItem
'get all items in memory...
For i = 0 To thisProject.Cel.CelItems("*").Count - 1
'set object to a specific item...
Set zCItem = thisProject.Cel.CelItems("*").Item(i)
'print time, text, Variablename and User-Comment of item to outputwindow
Debug.Print "Time: " & zCItem.Time
Debug.Print "Text: " & zCItem.Text
Debug.Print "Variable: " & zCItem.VariableName
Debug.Print "Comment: " & zCItem.Comment
Debug.Print "-----------------------------"
Next i
End Sub

Other topics in this chapter

CelItem-Properties

CelItem-Methods


CelItem-Properties

Manual -> Programming interfaces -> Objectmodel -> CelItem -> CelItem-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
short | Class | Returns the class | not used | read only
BSTR | Comment | Returns the comment | not used | available
BSTR | Computer | Returns the computer name | not used | read only
short | Group | Returns the group | not used | read only
long | Status | Return the status | not used | read only
BSTR | TagName | Returns the Tagname of the variable | not used | read only
BSTR | Text | Returns the text | not used | read only
DATE | Time | Returns the time | not used | read only
BSTR | User | Returns the user | not used | read only
VARIANT | Value | Returns the value | not used | read only
BSTR | VariableName | Returns the name of the variable | not used | read only
BSTR | Tagname | Returns the Tagname of the variable | not used | read only

Other topics in this chapter

VariableName

Tagname

Text

Status

Value

Time

User

Computer

Comment

Class

Group


VariableName

Manual -> Programming interfaces -> Objectmodel -> CelItem -> CelItem-Properties -> VariableName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The Name of the Variable as string

Datatype

VariableName() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Tagname

Manual -> Programming interfaces -> Objectmodel -> CelItem -> CelItem-Properties -> Tagname

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Tagname() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Text

Manual -> Programming interfaces -> Objectmodel -> CelItem -> CelItem-Properties -> Text

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The Text of the actual entry...

Datatype

Text() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Status

Manual -> Programming interfaces -> Objectmodel -> CelItem -> CelItem-Properties -> Status

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Status() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Value

Manual -> Programming interfaces -> Objectmodel -> CelItem -> CelItem-Properties -> Value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The Value of the Variable...

Datatype

Value() As VARIANT

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Time

Manual -> Programming interfaces -> Objectmodel -> CelItem -> CelItem-Properties -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The time when the entry was created...The Time is given as Double, but if you print it out, you will get the Date/Time format of the system...

Datatype

Time() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


User

Manual -> Programming interfaces -> Objectmodel -> CelItem -> CelItem-Properties -> User

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The user who was logged in during the entry has been added....

Datatype

User() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Computer

Manual -> Programming interfaces -> Objectmodel -> CelItem -> CelItem-Properties -> Computer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The Computername, where the Entry was raised...

Datatype

Computer() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Comment

Manual -> Programming interfaces -> Objectmodel -> CelItem -> CelItem-Properties -> Comment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

A comment which can be changed by the user...

Datatype

Comment() As String

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


Class

Manual -> Programming interfaces -> Objectmodel -> CelItem -> CelItem-Properties -> Class

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Alarm/CEL class as number (the number which was set in the Alarm/CEL configuration...

Datatype

Class() As short

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Group

Manual -> Programming interfaces -> Objectmodel -> CelItem -> CelItem-Properties -> Group

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Alarm/CEL group as number (the number which was set in the Alarm/CEL configuration...

Datatype

Group() As short

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


CelItem-Methods

Manual -> Programming interfaces -> Objectmodel -> CelItem -> CelItem-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> CelItem -> CelItem-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> CelItem -> CelItem-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.
A blank String like that returns the first layer of properties:DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> CelItem -> CelItem-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.
Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> CelItem -> CelItem-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


CelItems

Manual -> Programming interfaces -> Objectmodel -> CelItems

Remarks

With this object it is possible to get all CEL entries are in memory. You are able to read all properties of each item...Hint:The Filter should be set always like "*", because this feature is implemented for future and does not work for now.

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

public void MacroGetAllCelItems()

{

//Print text for each item

for (int i = 0; i < this.Cel().CelItems("*").Count; ++i )

System.Diagnostics.Debug.Print(this.Cel().CelItems("*").Item(i).Text);

}

VB.NET

Public Sub MacroGetAllCelItems()

'Print text for each item

For i As Integer = 0 To Me.Cel().CelItems("*").Count - 1

System.Diagnostics.Debug.Print(Me.Cel().CelItems("*").Item(i).Text)

Next

End Sub

VBA

'##########################################################
'### Get all CEL Items of the project ###
'##########################################################
Public Sub GetAllItems()
Dim i As Integer
'get all items in memory...
For i = 0 To thisProject.Cel.CelItems("*").Count - 1
'print text of item to outputwindow
Debug.Print thisProject.Cel.CelItems("*").Item(i).Text
Next i
End Sub

'get specific item using the screen switch function as filter

'thisProject.Cel.CelItems("myFunction").Count - 1

Other topics in this chapter

CelItems-Properties

CelItems-Methods


CelItems-Properties

Manual -> Programming interfaces -> Objectmodel -> CelItems -> CelItems-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Returns the amount of CelItems | read only | read only
ICel | Parent | Parent-object | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> CelItems -> CelItems-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Cel

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> CelItems -> CelItems-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


CelItems-Methods

Manual -> Programming interfaces -> Objectmodel -> CelItems -> CelItems-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
ICelItem | Item | Returns the CelItem at the given index | available | not used

Other topics in this chapter

Item


Item

Manual -> Programming interfaces -> Objectmodel -> CelItems -> CelItems-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

To get a defined entry of the List.You can read all available properties like the Text or the Name of the linked Variable, the Username and so on...

Datatype

Item(VARIANT vIndex) As CelItem

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ColorPalettes

Manual -> Programming interfaces -> Objectmodel -> ColorPalettes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

public void MacroReadColorPaletteDynProperties()

{

/*

* ColorPalettes are accessed via DynamicProperties, a list of those can be found in the help file

* Or you can display them via the Method get_DynPropertiesEnum("name");

* The following example shows how to read some of the dynamic properties

*/

IColorPalettes zenonPalettes = this.ActiveDocument.ColorPalettes();

uint count = (uint)zenonPalettes.get_DynProperties("Palette[-1]");

for (int i = 0; i < count; ++i)

{

//Get the palette name as string

string name = (string)zenonPalettes.get_DynProperties("Palette[" + i.ToString() + "].PaletteName");

//Get the palette entries as string

string entries = (string)zenonPalettes.get_DynProperties("Palette[" + i.ToString() + "].PaletteColors");

//Print result

System.Diagnostics.Debug.Print("{0}: {1}", name, entries);

}

}

public void MacroWriteColorPaletteDynProperties()

{

/*

* ColorPalettes are accessed via DynamicProperties, a list of those can be found in the help file

* Or you can display them via the Method get_DynPropertiesEnum("name");

* The following example shows how to write some of the dynamic properties

*/

IColorPalettes zenonPalettes = this.ActiveDocument.ColorPalettes();

//Create a new palette for example

zenonPalettes.CreateDynProperty("Palette");

//Define two colors for the new palette

string colors = "#FF0000;#0000FF";

uint count = (uint)zenonPalettes.get_DynProperties("Palette[-1]");

zenonPalettes.set_DynProperties("Palette[" + (count - 1).ToString() + "].PaletteColors", colors);

zenonPalettes.set_DynProperties("Palette[" + (count - 1).ToString() + "].PaletteName", "VSTA_Test_Palette");

}

VB.NET

Public Sub MacroReadColorPaletteDynProperties()

'

' * ColorPalettes are accessed via DynamicProperties, a list of those can be found in the help file

' * Or you can display them via the Method get_DynPropertiesEnum("name");

' * The following example shows how to read some of the dynamic properties

'

Dim zenonPalettes As IColorPalettes = Me.ActiveDocument.ColorPalettes()

Dim count As UInteger = CUInt(zenonPalettes.get_DynProperties("Palette[-1]"))

For i As Integer = 0 To count - 1

'Get the palette name as string

Dim name As String = DirectCast(zenonPalettes.get_DynProperties("Palette[" & i.ToString() & "].PaletteName"), String)

'Get the palette entries as string

Dim entries As String = DirectCast(zenonPalettes.get_DynProperties("Palette[" & i.ToString() & "].PaletteColors"), String)

'Print result

System.Diagnostics.Debug.Print("{0}: {1}", name, entries)

Next

End Sub

Public Sub MacroWriteColorPaletteDynProperties()

'

' * ColorPalettes are accessed via DynamicProperties, a list of those can be found in the help file

' * Or you can display them via the Method get_DynPropertiesEnum("name");

' * The following example shows how to write some of the dynamic properties

'

Dim zenonPalettes As IColorPalettes = Me.ActiveDocument.ColorPalettes()

'Create a new palette for example

zenonPalettes.CreateDynProperty("Palette")

'Define two colors for the new palette

Dim colors As String = "#FF0000;#0000FF"

Dim count As UInteger = CUInt(zenonPalettes.get_DynProperties("Palette[-1]"))

zenonPalettes.set_DynProperties("Palette[" & (count - 1).ToString() & "].PaletteColors", colors)

zenonPalettes.set_DynProperties("Palette[" & (count - 1).ToString() & "].PaletteName", "VSTA_Test_Palette")

End Sub

VBA

Sub Read_ColorPalettes_DynProps()
Dim zPRJ As Project
Dim vProps As Variant

Dim i As Integer

Set zPRJ = MyWorkspace.ActiveDocument
'get all DynProperties of the actual object (ColorPalettes)
vProps = zPRJ.ColorPalettes.DynPropertiesEnum("")
'Print informations of DynProperties into output window
For i = 0 To UBound(vProps)
Debug.Print vProps(i)
Next i
'Result:
'Palette,SUBITEM,Palette,
'ColorNames,String,Color name,

vProps = zPRJ.ColorPalettes.DynPropertiesEnum("Palette")
'Print informations of DynProperties into output window
For i = 0 To UBound(vProps)
Debug.Print vProps(i)
Next i
'Result:
'PaletteColors,String,Colors of the palette,
'PaletteName,String,Palette name,

Debug.Print zPRJ.ColorPalettes.DynProperties("ColorNames")
'Result:
'Color_01;Color_02;Color_03;Color_04;Colo5_05;

For i = 0 To zPRJ.ColorPalettes.DynProperties("Palette[-1]")
Debug.Print zPRJ.ColorPalettes.DynProperties("Palette[" & i & "].PaletteName")
Debug.Print zPRJ.ColorPalettes.DynProperties("Palette[" & i & "].PaletteColors")
Next i
'Result:
'Light
'#FFFFFF;#FFFF00;#FFC0CB;#AFEEEE;#00005E;
'Dark
'#000000;#0000FF;#8B0000;#388E8E;#E6E6FA;

'In the sample Project there were 2 colorpalettes with 5 colors each...
End Sub

Sub Write_ColorPalettes_DynProps()
Dim zPRJ As Project
Dim strColors As String
Dim nCount As Integer

Set zPRJ = MyWorkspace.ActiveDocument

'create a new ColorPalette
Call zPRJ.ColorPalettes.CreateDynProperty("Palette")

'define a set of 5 colors as a string...
strColors = "#FFEEDD;#FF8800;#FFC5DB;#AFFE12;#01205F;"

'get number of ColorPalettes
nCount = zPRJ.ColorPalettes.DynProperties("Palette[-1]")

'set name of Palette...
zPRJ.ColorPalettes.DynProperties("Palette[" & nCount - 1 & "].PaletteName") = "VBA_Colors_" & nCount
'set defined colors...
zPRJ.ColorPalettes.DynProperties("Palette[" & nCount - 1 & "].PaletteColors") = strColors

End Sub

Sub AddNewColor()
Dim zPRJ As Project
Dim vColors As Variant
Dim i As Integer
Dim strColor As String

Set zPRJ = MyWorkspace.ActiveDocument

'get actual color-names
vColors = Split(zPRJ.ColorPalettes.DynProperties("ColorNames"), ";")
For i = 0 To UBound(vColors) - 1
Debug.Print i & ": " & vColors(i)
Next i

'add a new Color...
strColor = zPRJ.ColorPalettes.DynProperties("ColorNames")
strColor = strColor & "Color_" & Format(UBound(vColors) + 1, "00") & ";"
zPRJ.ColorPalettes.DynProperties("ColorNames") = strColor

End Sub

Other topics in this chapter

ColorPalettes-Methods

ColorPalettes-Dynamic properties


ColorPalettes-Methods

Manual -> Programming interfaces -> Objectmodel -> ColorPalettes -> ColorPalettes-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CreateDynProperty | - | available | not used
void | DynProperties [PUT] | - | available | not used
VARIANT | DynProperties [GET] | - | available | not used
VARIANT | DynPropertiesEnum [GET] | - | read only | not used
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | Import | Imports the selected XML file | available | not used
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

SingleExport

Export

Import

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

CreateDynProperty


SingleExport

Manual -> Programming interfaces -> Objectmodel -> ColorPalettes -> ColorPalettes-Methods -> SingleExport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export a single ColorPalette to an XML File.

Datatype

SingleExport(VARIANT vIndexOrName,String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Export

Manual -> Programming interfaces -> Objectmodel -> ColorPalettes -> ColorPalettes-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Export(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to export.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

public void MacroExportColorPalettes()

{

IProject zenonProject = this.ActiveDocument;

if(zenonProject.ColorPalettes().Export(@"C:\Temp\ColorPalettes.xml"))

System.Diagnostics.Debug.Print("Export successful");

else

System.Diagnostics.Debug.Print("Export failed");

}

VB.NET

Public Sub MacroExportColorPalettes()

Dim zenonProject As IProject = Me.ActiveDocument

If zenonProject.ColorPalettes().Export("C:\Temp\ColorPalettes.xml") Then

System.Diagnostics.Debug.Print("Export successful")

Else

System.Diagnostics.Debug.Print("Export failed")

End If

End Sub

VBA

Private Sub ExportColorPalettes()
Dim zPRJ As Project
Dim bResult As Boolean

'get active project...
Set zPRJ = MyWorkspace.ActiveDocument

'export color palettes...
bResult = zPRJ.ColorPalettes.Export("C:\Temp\ColorPalettes.xml")

'check result, write to output-window...
If bResult = False Then
ApplicationED.DebugPrint "VBA Export of ColorPalettes failed.", tpErr
Else
ApplicationED.DebugPrint "VBA ColorPalettes exported.", tpMsg
End If

End Sub


Import

Manual -> Programming interfaces -> Objectmodel -> ColorPalettes -> ColorPalettes-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Imports settings using a xml file. New settings are added, existing settings will be replaced.

Datatype

Import(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to import.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

public void MacroImportColorPalettes()

{

IProject zenonProject = this.ActiveDocument;

if (zenonProject.ColorPalettes().Import(@"C:\Temp\ColorPalettes.xml"))

System.Diagnostics.Debug.Print("Import successful");

else

System.Diagnostics.Debug.Print("Import failed");

}

VB.NET

Public Sub MacroImportColorPalettes()

Dim zenonProject As IProject = Me.ActiveDocument

If zenonProject.ColorPalettes().Import("C:\Temp\ColorPalettes.xml") Then

System.Diagnostics.Debug.Print("Import successful")

Else

System.Diagnostics.Debug.Print("Import failed")

End If

End Sub

VBA

Private Sub ImportColorPalettes()
Dim zPRJ As Project
Dim bResult As Boolean

'get active project...
Set zPRJ = MyWorkspace.ActiveDocument

'import color palettes...
bResult = zPRJ.ColorPalettes.Import("C:\Temp\ColorPalettes.xml")

'check result, write to output-window...
If bResult = False Then
ApplicationED.DebugPrint "VBA Import of ColorPalettes failed.", tpErr
Else
ApplicationED.DebugPrint "VBA ColorPalettes imported.", tpMsg
End If

End Sub


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> ColorPalettes -> ColorPalettes-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> ColorPalettes -> ColorPalettes-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.
A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub Read_ColorPalettes_DynProps()
Dim zPRJ As Project
Dim vProps As Variant

Dim i As Integer

Set zPRJ = MyWorkspace.ActiveDocument
'get all DynProperties of the actual object (ColorPalettes)
vProps = zPRJ.ColorPalettes.DynPropertiesEnum("")
'Print informations of DynProperties into output window
For i = 0 To UBound(vProps)
Debug.Print vProps(i)
Next i
'Result:
'Palette,SUBITEM,Palette,
'ColorNames,String,Color name,

vProps = zPRJ.ColorPalettes.DynPropertiesEnum("Palette")
'Print informations of DynProperties into output window
For i = 0 To UBound(vProps)
Debug.Print vProps(i)
Next i
'Result:
'PaletteColors,String,Colors of the palette,
'PaletteName,String,Palette name,

Debug.Print zPRJ.ColorPalettes.DynProperties("ColorNames")
'Result:
'Color_01;Color_02;Color_03;Color_04;Colo5_05;

For i = 0 To zPRJ.ColorPalettes.DynProperties("Palette[-1]")
Debug.Print zPRJ.ColorPalettes.DynProperties("Palette[" & i & "].PaletteName")
Debug.Print zPRJ.ColorPalettes.DynProperties("Palette[" & i & "].PaletteColors")
Next i
'Result:
'Light
'#FFFFFF;#FFFF00;#FFC0CB;#AFEEEE;#00005E;
'Dark
'#000000;#0000FF;#8B0000;#388E8E;#E6E6FA;

'In the sample Project there were 2 colorpalettes with 5 colors each...
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> ColorPalettes -> ColorPalettes-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.
Example: "ColorNames"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub Read_ColorPalettes_DynProps()
Dim zPRJ As Project
Dim vProps As Variant

Dim i As Integer

Set zPRJ = MyWorkspace.ActiveDocument
'get all DynProperties of the actual object (ColorPalettes)
vProps = zPRJ.ColorPalettes.DynPropertiesEnum("")
'Print informations of DynProperties into output window
For i = 0 To UBound(vProps)
Debug.Print vProps(i)
Next i
'Result:
'Palette,SUBITEM,Palette,
'ColorNames,String,Color name,

vProps = zPRJ.ColorPalettes.DynPropertiesEnum("Palette")
'Print informations of DynProperties into output window
For i = 0 To UBound(vProps)
Debug.Print vProps(i)
Next i
'Result:
'PaletteColors,String,Colors of the palette,
'PaletteName,String,Palette name,

Debug.Print zPRJ.ColorPalettes.DynProperties("ColorNames")
'Result:
'Color_01;Color_02;Color_03;Color_04;Colo5_05;

For i = 0 To zPRJ.ColorPalettes.DynProperties("Palette[-1]")
Debug.Print zPRJ.ColorPalettes.DynProperties("Palette[" & i & "].PaletteName")
Debug.Print zPRJ.ColorPalettes.DynProperties("Palette[" & i & "].PaletteColors")
Next i
'Result:
'Light
'#FFFFFF;#FFFF00;#FFC0CB;#AFEEEE;#00005E;
'Dark
'#000000;#0000FF;#8B0000;#388E8E;#E6E6FA;

'In the sample Project there were 2 colorpalettes with 5 colors each...
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> ColorPalettes -> ColorPalettes-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.
Example: "ColorNames"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub Write_ColorPalettes_DynProps()
Dim zPRJ As Project
Dim strColors As String
Dim nCount As Integer

Set zPRJ = MyWorkspace.ActiveDocument

'create a new ColorPalette
Call zPRJ.ColorPalettes.CreateDynProperty("Palette")

'define a set of 5 colors as a string...
strColors = "#FFEEDD;#FF8800;#FFC5DB;#AFFE12;#01205F;"

'get number of ColorPalettes
nCount = zPRJ.ColorPalettes.DynProperties("Palette[-1]")

'set name of Palette...
zPRJ.ColorPalettes.DynProperties("Palette[" & nCount - 1 & "].PaletteName") = "VBA_Colors_" & nCount
'set defined colors...
zPRJ.ColorPalettes.DynProperties("Palette[" & nCount - 1 & "].PaletteColors") = strColors

End Sub

Sub AddNewColor()
Dim zPRJ As Project
Dim vColors As Variant
Dim i As Integer
Dim strColor As String

Set zPRJ = MyWorkspace.ActiveDocument

'get actual color-names
vColors = Split(zPRJ.ColorPalettes.DynProperties("ColorNames"), ";")
For i = 0 To UBound(vColors) - 1
Debug.Print i & ": " & vColors(i)
Next i

'add a new Color...
strColor = zPRJ.ColorPalettes.DynProperties("ColorNames")
strColor = strColor & "Color_" & Format(UBound(vColors) + 1, "00") & ";"
zPRJ.ColorPalettes.DynProperties("ColorNames") = strColor

End Sub


CreateDynProperty

Manual -> Programming interfaces -> Objectmodel -> ColorPalettes -> ColorPalettes-Methods -> CreateDynProperty

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreateDynProperty(String bsPath) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.
Example: "Palette"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub Write_ColorPalettes_DynProps()
Dim zPRJ As Project
Dim strColors As String
Dim nCount As Integer

Set zPRJ = MyWorkspace.ActiveDocument

'create a new ColorPalette
Call zPRJ.ColorPalettes.CreateDynProperty("Palette")

'define a set of 5 colors as a string...
strColors = "#FFEEDD;#FF8800;#FFC5DB;#AFFE12;#01205F;"

'get number of ColorPalettes
nCount = zPRJ.ColorPalettes.DynProperties("Palette[-1]")

'set name of Palette...
zPRJ.ColorPalettes.DynProperties("Palette[" & nCount - 1 & "].PaletteName") = "VBA_Colors_" & nCount
'set defined colors...
zPRJ.ColorPalettes.DynProperties("Palette[" & nCount - 1 & "].PaletteColors") = strColors

End Sub

Sub AddNewColor()
Dim zPRJ As Project
Dim vColors As Variant
Dim i As Integer
Dim strColor As String

Set zPRJ = MyWorkspace.ActiveDocument

'get actual color-names
vColors = Split(zPRJ.ColorPalettes.DynProperties("ColorNames"), ";")
For i = 0 To UBound(vColors) - 1
Debug.Print i & ": " & vColors(i)
Next i

'add a new Color...
strColor = zPRJ.ColorPalettes.DynProperties("ColorNames")
strColor = strColor & "Color_" & Format(UBound(vColors) + 1, "00") & ";"
zPRJ.ColorPalettes.DynProperties("ColorNames") = strColor

End Sub


ColorPalettes-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> ColorPalettes -> ColorPalettes-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Color palettes

Other topics in this chapter

CD_CPalette

Color palettes


CD_CPalette

Manual -> Programming interfaces -> Objectmodel -> ColorPalettes -> ColorPalettes-Dynamic properties -> CD_CPalette

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | PaletteName | Palette name | Name der Farbpalette. Default: Color palette plus Indexnummer, z. B.: Color palette 1 Mehr im Online-Handbuch.
VT_BSTR | PaletteColors | Colors of the palette |


Color palettes

Manual -> Programming interfaces -> Objectmodel -> ColorPalettes -> ColorPalettes-Dynamic properties -> Color palettes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | ColorNames | Color name |
More... | Palette | Palette | Contains the properties of the palette. More in the online help.


ComplexItem

Manual -> Programming interfaces -> Objectmodel -> ComplexItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This object represents the items of a structure datatype.

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

public void MacroComplexItem()

{

IVarTypes zenonVarTypes = this.ActiveDocument.VarTypes();

for (int i = 0; i < zenonVarTypes.Count; ++i)

{

//Check if the Datatype has a complex sub-element

if (zenonVarTypes.Item(i).IsSimple() == 0 && zenonVarTypes.Item(i).SubItemCount() > 0)

{

for(int j = 0; j < zenonVarTypes.Item(i).SubItemCount(); ++j)

{

//If so, print every sub elements name, NOTE: Other dynamic properties can be

//seen at the dynamic properties page of this object

IComplexItem zenonComplexItem = zenonVarTypes.Item(i).SubItem(j);

System.Diagnostics.Debug.Print(zenonComplexItem.get_DynProperties("Name").ToString());

}

}

}

}

VB.NET

Public Sub MacroComplexItem()

Dim zenonVarTypes As IVarTypes = Me.ActiveDocument.VarTypes()

For i As Integer = 0 To zenonVarTypes.Count - 1

'Check if the Datatype has a complex sub-element

If zenonVarTypes.Item(i).IsSimple() = 0 AndAlso zenonVarTypes.Item(i).SubItemCount() > 0 Then

For j As Integer = 0 To zenonVarTypes.Item(i).SubItemCount() - 1

'If so, print every sub elements name, NOTE: Other dynamic properties can be

'seen at the dynamic properties page of this object

Dim zenonComplexItem As IComplexItem = zenonVarTypes.Item(i).SubItem(j)

System.Diagnostics.Debug.Print(zenonComplexItem.get_DynProperties("Name").ToString())

Next

End If

Next

End Sub

VBA

Public Sub test_IComplexItem()
Dim zComplexItem As ComplexItem
Dim zVarTypes As VarTypes
Dim i As Integer, j As Variant, k As Long

Set zVarTypes = thisProject.VarTypes
For i = 0 To zVarTypes.Count - 1
If (zVarTypes.Item(i).IsSimple = 0 And zVarTypes.Item(i).SubItemCount > 1) Then
Set zComplexItem = zVarTypes.Item(i).SubItem(1)

'write properties
zComplexItem.DynProperties("BitOffset") = 2 'EDwriteable
zComplexItem.DynProperties("Description") = "YourDescr..." 'EDwriteable
zComplexItem.DynProperties("Dim1") = 2 'EDwriteable
zComplexItem.DynProperties("Dim2") = 2 'EDwriteable
zComplexItem.DynProperties("Dim3") = 2 'EDwriteable
Debug.Print zComplexItem.DynProperties("HasRef") 'ReadOnly
zComplexItem.DynProperties("ID_DataTyp") = 19 'EDwriteable
Debug.Print zComplexItem.DynProperties("ItemIndex") 'ReadOnly
zComplexItem.DynProperties("Name") = "YourName" 'EDwriteable
zComplexItem.DynProperties("Offset") = 10 'EDwriteable

'read properties
Debug.Print zComplexItem.DynProperties("BitOffset")
Debug.Print zComplexItem.DynProperties("Description")
Debug.Print zComplexItem.DynProperties("Dim1")
Debug.Print zComplexItem.DynProperties("Dim2")
Debug.Print zComplexItem.DynProperties("Dim3")
Debug.Print zComplexItem.DynProperties("HasRef")
Debug.Print zComplexItem.DynProperties("ID_DataTyp")
Debug.Print zComplexItem.DynProperties("ItemIndex")
Debug.Print zComplexItem.DynProperties("Name")
Debug.Print zComplexItem.DynProperties("Offset")

'Methods
zComplexItem.MoveItemDown
zComplexItem.MoveItemUp
End If
Next i
End Sub

Other topics in this chapter

ComplexItem-Properties

ComplexItem-Methods


ComplexItem-Properties

Manual -> Programming interfaces -> Objectmodel -> ComplexItem -> ComplexItem-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IVarType | Parent |  | read only | read only

Other topics in this chapter

Parent


Parent

Manual -> Programming interfaces -> Objectmodel -> ComplexItem -> ComplexItem-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As VarType

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ComplexItem-Methods

Manual -> Programming interfaces -> Objectmodel -> ComplexItem -> ComplexItem-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
VARIANT_BOOL | MoveItemDown | - | available | not used
VARIANT_BOOL | MoveItemUp | - | available | not used
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

MoveItemUp

MoveItemDown


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> ComplexItem -> ComplexItem-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> ComplexItem -> ComplexItem-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.
A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> ComplexItem -> ComplexItem-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.
Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> ComplexItem -> ComplexItem-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.
Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


MoveItemUp

Manual -> Programming interfaces -> Objectmodel -> ComplexItem -> ComplexItem-Methods -> MoveItemUp

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

move the ComplexItem one up in the Tree...

Datatype

MoveItemUp() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MacroComplexItemMoveDown()

{

IVarTypes zenonVarTypes = this.ActiveDocument.VarTypes();

for (int i = 0; i < zenonVarTypes.Count; ++i)

{

//Check if the Datatype has a complex sub-element

if (zenonVarTypes.Item(i).IsSimple() == 0 && zenonVarTypes.Item(i).SubItemCount() > 0)

{

for (int j = 0; j < zenonVarTypes.Item(i).SubItemCount(); ++j)

{

//If so, move it down once in the tree

IComplexItem zenonComplexItem = zenonVarTypes.Item(i).SubItem(j);

zenonComplexItem.MoveItemDown();

}

}

}

}

VB.NET

Public Sub MacroComplexItemMoveDown()

Dim zenonVarTypes As IVarTypes = Me.ActiveDocument.VarTypes()

For i As Integer = 0 To zenonVarTypes.Count - 1

'Check if the Datatype has a complex sub-element

If zenonVarTypes.Item(i).IsSimple() = 0 AndAlso zenonVarTypes.Item(i).SubItemCount() > 0 Then

For j As Integer = 0 To zenonVarTypes.Item(i).SubItemCount() - 1

'If so, move it down once in the tree

Dim zenonComplexItem As IComplexItem = zenonVarTypes.Item(i).SubItem(j)

zenonComplexItem.MoveItemDown()

Next

End If

Next

End Sub

VBA

VBA-Syntax


MoveItemDown

Manual -> Programming interfaces -> Objectmodel -> ComplexItem -> ComplexItem-Methods -> MoveItemDown

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

move the ComplexItem one down in the Tree...

Datatype

MoveItemDown() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Driver

Manual -> Programming interfaces -> Objectmodel -> Driver

Remarks

The object Driver includes important information on the defined drivers, e.g. name, driver, status and mode.

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

public void MacroDriver()

{

//Get a driver object or create a new one if it does not exist

//NOTE: The user might have to fill in settings for the driver, depending on its type

IDrivers zenonDrivers = this.ActiveDocument.Drivers();

IDriver zenonDriver = zenonDrivers.Item("NewSimulationDriver");

if (zenonDriver == null)

zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32");

//Use the driver object to access its methods etc.

}

VB.NET

Public Sub MacroDriver()

'Get a driver object or create a new one if it does not exist

'NOTE: The user might have to fill in settings for the driver, depending on its type

Dim zenonDrivers As IDrivers = Me.ActiveDocument.Drivers()

Dim zenonDriver As IDriver = zenonDrivers.Item("NewSimulationDriver")

If zenonDriver Is Nothing Then

zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")

End If

'Use the driver object to access its methods etc.

End Sub

VBA

Public Sub DriversSample()
Dim zDrivers As Drivers
Dim zDriver As Driver
Dim i As Integer

'get drivers collection
Set zDrivers = MyWorkspace.ActiveDocument.Drivers

'Enumerate existing drivers in the project
For i = 0 To zDrivers.Count - 1
Debug.Print zDrivers.Item(i).Name
Next i

'Create a new driver and check if already exists
Set zDriver = zDrivers.Item("NewSimulationDriver")
If zDriver Is Nothing Then
Set zDriver = zDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")
End If

End Sub

Other topics in this chapter

Driver-Properties

Driver-Methods

Driver-Dynamic properties


Driver-Properties

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
BSTR | Identification | Name | available | read only
BSTR | Name | Programname | available | read only
IDrivers | Parent | Parent-object | read only | read only

Other topics in this chapter

Parent

Identification

Name


Parent

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Drivers

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Identification

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Properties -> Identification

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Identification() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the name (EXE) of the driver.

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Driver-Methods

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | Browse | Imports variables from PLC or file. | available | not used
VARIANT_BOOL | CheckIn | Save module modifications to server (editor). | available | not used
VARIANT_BOOL | CheckOut | Allow module modifications (editor). | available | not used
VARIANT_BOOL | CloseConfig | Closes driver config and stops driver. | available | not used
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
VARIANT_BOOL | Get | Get the latest version from the server (editor). | available | not used
VARIANT_BOOL | IsCheckedOut | Returns true when the current module checked out by the current user (editor). | read only | not used
VARIANT_BOOL | IsDifferent | Return true when the local- and server version are different (editor). | read only | not used
VARIANT_BOOL | IsLocked | Returns true when the current module is Locked by another user (editor). | read only | not used
VARIANT_BOOL | OpenConfig | Starts driver and opens driver config for access via properties. | available | not used
VARIANT_BOOL | SupportsChannel | Returns True when the given channeltype is supported for the given datatype. | available | not used
VARIANT_BOOL | UndoCheckOut | Undo module modifications (editor). | available | not used
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

Get

CheckOut

CheckIn

UndoCheckOut

IsLocked

IsCheckedOut

IsDifferent

SupportsChannel

OpenConfig

CloseConfig

Browse


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.
Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.
Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


Get

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Methods -> Get

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype

Get() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MacroDriverMultiuser()

{

//Get a driver object or create a new one if it does not exist

//NOTE: The user might have to fill in settings for the driver, depending on its type

IDrivers zenonDrivers = this.ActiveDocument.Drivers();

IDriver zenonDriver = zenonDrivers.Item("NewSimulationDriver");

if (zenonDriver == null)

zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32");

if (!zenonDriver.IsCheckedOut())

{

if (zenonDriver.CheckOut())

{

//The driver was checked out by the user who executed this macro

if (zenonDriver.Get())

{

//Got the latest version of the driver

//Edit some properties of the driver

zenonDriver.Name = "NewName";

//Check the driver in again so others can check it out

zenonDriver.CheckIn();

}

else

{

zenonDriver.UndoCheckOut();

//The latest version could not be received, undo the checkout

}

}

else

{

//The driver can't currently be checked out

}

}

else

{

//Someone else has the object checked out!

}

}

VB.NET

Public Sub MacroDriverMultiuser()

'Get a driver object or create a new one if it does not exist

'NOTE: The user might have to fill in settings for the driver, depending on its type

Dim zenonDrivers As IDrivers = Me.ActiveDocument.Drivers()

Dim zenonDriver As IDriver = zenonDrivers.Item("NewSimulationDriver")

If zenonDriver Is Nothing Then

zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")

End If

If Not zenonDriver.IsCheckedOut() Then

If zenonDriver.CheckOut() Then

'The driver was checked out by the user who executed this macro

If zenonDriver.[Get]() Then

'Got the latest version of the driver

'Edit some properties of the driver

zenonDriver.Name = "NewName"

'Check the driver in again so others can check it out

zenonDriver.CheckIn()

Else

'The latest version could not be received, undo the checkout

zenonDriver.UndoCheckOut()

End If

'The driver can't currently be checked out

Else

End If

'Someone else has the object checked out!

Else

End If

End Sub

VBA

VBA-Syntax


CheckOut

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Methods -> CheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype

CheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MacroDriverMultiuser()

{

//Get a driver object or create a new one if it does not exist

//NOTE: The user might have to fill in settings for the driver, depending on its type

IDrivers zenonDrivers = this.ActiveDocument.Drivers();

IDriver zenonDriver = zenonDrivers.Item("NewSimulationDriver");

if (zenonDriver == null)

zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32");

if (!zenonDriver.IsCheckedOut())

{

if (zenonDriver.CheckOut())

{

//The driver was checked out by the user who executed this macro

if (zenonDriver.Get())

{

//Got the latest version of the driver

//Edit some properties of the driver

zenonDriver.Name = "NewName";

//Check the driver in again so others can check it out

zenonDriver.CheckIn();

}

else

{

zenonDriver.UndoCheckOut();

//The latest version could not be received, undo the checkout

}

}

else

{

//The driver can't currently be checked out

}

}

else

{

//Someone else has the object checked out!

}

}

VB.NET

Public Sub MacroDriverMultiuser()

'Get a driver object or create a new one if it does not exist

'NOTE: The user might have to fill in settings for the driver, depending on its type

Dim zenonDrivers As IDrivers = Me.ActiveDocument.Drivers()

Dim zenonDriver As IDriver = zenonDrivers.Item("NewSimulationDriver")

If zenonDriver Is Nothing Then

zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")

End If

If Not zenonDriver.IsCheckedOut() Then

If zenonDriver.CheckOut() Then

'The driver was checked out by the user who executed this macro

If zenonDriver.[Get]() Then

'Got the latest version of the driver

'Edit some properties of the driver

zenonDriver.Name = "NewName"

'Check the driver in again so others can check it out

zenonDriver.CheckIn()

Else

'The latest version could not be received, undo the checkout

zenonDriver.UndoCheckOut()

End If

'The driver can't currently be checked out

Else

End If

'Someone else has the object checked out!

Else

End If

End Sub

VBA

VBA-Syntax


CheckIn

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Methods -> CheckIn

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype

CheckIn() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MacroDriverMultiuser()

{

//Get a driver object or create a new one if it does not exist

//NOTE: The user might have to fill in settings for the driver, depending on its type

IDrivers zenonDrivers = this.ActiveDocument.Drivers();

IDriver zenonDriver = zenonDrivers.Item("NewSimulationDriver");

if (zenonDriver == null)

zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32");

if (!zenonDriver.IsCheckedOut())

{

if (zenonDriver.CheckOut())

{

//The driver was checked out by the user who executed this macro

if (zenonDriver.Get())

{

//Got the latest version of the driver

//Edit some properties of the driver

zenonDriver.Name = "NewName";

//Check the driver in again so others can check it out

zenonDriver.CheckIn();

}

else

{

zenonDriver.UndoCheckOut();

//The latest version could not be received, undo the checkout

}

}

else

{

//The driver can't currently be checked out

}

}

else

{

//Someone else has the object checked out!

}

}

VB.NET

Public Sub MacroDriverMultiuser()

'Get a driver object or create a new one if it does not exist

'NOTE: The user might have to fill in settings for the driver, depending on its type

Dim zenonDrivers As IDrivers = Me.ActiveDocument.Drivers()

Dim zenonDriver As IDriver = zenonDrivers.Item("NewSimulationDriver")

If zenonDriver Is Nothing Then

zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")

End If

If Not zenonDriver.IsCheckedOut() Then

If zenonDriver.CheckOut() Then

'The driver was checked out by the user who executed this macro

If zenonDriver.[Get]() Then

'Got the latest version of the driver

'Edit some properties of the driver

zenonDriver.Name = "NewName"

'Check the driver in again so others can check it out

zenonDriver.CheckIn()

Else

'The latest version could not be received, undo the checkout

zenonDriver.UndoCheckOut()

End If

'The driver can't currently be checked out

Else

End If

'Someone else has the object checked out!

Else

End If

End Sub

VBA

VBA-Syntax


UndoCheckOut

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Methods -> UndoCheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype

UndoCheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MacroDriverMultiuser()

{

//Get a driver object or create a new one if it does not exist

//NOTE: The user might have to fill in settings for the driver, depending on its type

IDrivers zenonDrivers = this.ActiveDocument.Drivers();

IDriver zenonDriver = zenonDrivers.Item("NewSimulationDriver");

if (zenonDriver == null)

zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32");

if (!zenonDriver.IsCheckedOut())

{

if (zenonDriver.CheckOut())

{

//The driver was checked out by the user who executed this macro

if (zenonDriver.Get())

{

//Got the latest version of the driver

//Edit some properties of the driver

zenonDriver.Name = "NewName";

//Check the driver in again so others can check it out

zenonDriver.CheckIn();

}

else

{

zenonDriver.UndoCheckOut();

//The latest version could not be received, undo the checkout

}

}

else

{

//The driver can't currently be checked out

}

}

else

{

//Someone else has the object checked out!

}

}

VB.NET

Public Sub MacroDriverMultiuser()

'Get a driver object or create a new one if it does not exist

'NOTE: The user might have to fill in settings for the driver, depending on its type

Dim zenonDrivers As IDrivers = Me.ActiveDocument.Drivers()

Dim zenonDriver As IDriver = zenonDrivers.Item("NewSimulationDriver")

If zenonDriver Is Nothing Then

zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")

End If

If Not zenonDriver.IsCheckedOut() Then

If zenonDriver.CheckOut() Then

'The driver was checked out by the user who executed this macro

If zenonDriver.[Get]() Then

'Got the latest version of the driver

'Edit some properties of the driver

zenonDriver.Name = "NewName"

'Check the driver in again so others can check it out

zenonDriver.CheckIn()

Else

'The latest version could not be received, undo the checkout

zenonDriver.UndoCheckOut()

End If

'The driver can't currently be checked out

Else

End If

'Someone else has the object checked out!

Else

End If

End Sub

VBA

VBA-Syntax


IsLocked

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Methods -> IsLocked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype

IsLocked() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void MacroDriver()

{

//Get a driver object or create a new one if it does not exist

//NOTE: The user might have to fill in settings for the driver, depending on its type

IDrivers zenonDrivers = this.ActiveDocument.Drivers();

IDriver zenonDriver = zenonDrivers.Item("NewSimulationDriver");

if (zenonDriver == null)

zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32");

if (zenonDriver.IsLocked())

{

//Modification Changes are currently locked due to a checkout

}

else

{

//Use the driver object to access its methods etc.

}

}

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsCheckedOut

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Methods -> IsCheckedOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype

IsCheckedOut() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void DriverTryCheckOut(IDriver zenonDriver)

{

//Checks if the passed object is checked out before performing a checkout

if(!zenonDriver.IsCheckedOut())

{

zenonDriver.CheckOut();

//Object can be used for further purposes

}

else

{

//The object is already checked out and cannot be checked out again

}

}

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsDifferent

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Methods -> IsDifferent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype

IsDifferent() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

public void CheckInChanges(IDriver zenonDriver)

{

//Checks if any changes occured on the driver object and if so, updates it

if(zenonDriver.IsDifferent())

{

if(zenonDriver.Get())

{

//Driver object is up to date

}

else

{

//An error occured while getting the newest version of the object

}

}

else

{

//No pending changes

}

}

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SupportsChannel

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Methods -> SupportsChannel

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns "True" when the actual driver object supports the given VarType and ChannelType combination.

Datatype

SupportsChannel(tpKanaltypes ChannelType, IVarType ObVarType) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

ChannelType (constant) to be checked.

VarType object to be checked.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

ChannelType As tpKanaltypes

ObVarType As VarType

Examples

C#

public void MacroChannelSupport()

{

IVarType zenonVarType = this.ActiveDocument.VarTypes().Item("UINT");

IDrivers zenonDrivers = this.ActiveDocument.Drivers();

IDriver zenonDriver = zenonDrivers.Item("NewSimulationDriver");

if (zenonDriver == null)

zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32");

if(zenonDriver.SupportsChannel(tpKanaltypes.tpSPSMerker, zenonVarType))

System.Diagnostics.Debug.Print("Supported by the driver");

else

System.Diagnostics.Debug.Print("Not supported by the driver");

}

VB.NET

Public Sub MacroChannelSupport()

Dim zenonVarType As IVarType = Me.ActiveDocument.VarTypes().Item("UINT")

Dim zenonDrivers As IDrivers = Me.ActiveDocument.Drivers()

Dim zenonDriver As IDriver = zenonDrivers.Item("NewSimulationDriver")

If zenonDriver Is Nothing Then

zenonDriver = zenonDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")

End If

If zenonDriver.SupportsChannel(tpKanaltypes.tpSPSMerker, zenonVarType) Then

System.Diagnostics.Debug.Print("Supported by the driver")

Else

System.Diagnostics.Debug.Print("Not supported by the driver")

End If

End Sub

VBA

Sub Channelsupport()
Dim zDRV As Driver
Dim zVTP As VarType
'get a Driver object for Simulation-Driver
Set zDRV = MyWorkspace.ActiveDocument.Drivers.Item("SIMUL_WIZ")
'get a VarType object for UINT
Set zVTP = MyWorkspace.ActiveDocument.VarTypes.Item("UINT")

If zDRV.SupportsChannel(tpSPSMerker, zVTP) = True Then
Debug.Print "This combination is supported by the driver."
Else
Debug.Print "NOT supported by this driver!"
End If
End Sub


OpenConfig

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Methods -> OpenConfig

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

VBA access to driver configuration available only for S7TCP32, IEC870, Logix3, Steriflow
This is possible by using the DynProperties.

In the example shown below the Dynproperties for S7TCP32, IEC870, Logix3 are used.

The Steriflow driver only uses following Dynproperty:

"CfgFileTransferDirectory" this property needs the transfer directory as parameter.

Datatype

OpenConfig() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Public Sub CreateDriverS7TCP_Dyn()

Dim zDrivers As Drivers

Dim zDriver As Driver

Dim zDriverS7TCP As Driver

Dim vProps As Variant

Dim vValue As Variant

Dim inti As Integer

Dim intj As Integer

Dim sDateiname As String

Dim sBezeichnung As String

sDateiname = "S7TCP32"

sBezeichnung = "S7_Test_1"

'show all exist

Set zDrivers = MyWorkspace.ActiveDocument.Drivers

'Enumerate existing drivers in the project

For inti = 0 To zDrivers.Count - 1

Debug.Print zDrivers.Item(inti).Name

Next inti

Debug.Print "================================================="

'Create a new driver without dirver configuration dialog and check if already exists

Set zDriver = zDrivers.Item(sBezeichnung)

If zDriver Is Nothing Then

'Set zDriver = zDrivers.CreateDriver(sBezeichnung, sDateiname)

Set zDriver = zDrivers.CreateDriverEx(sBezeichnung, sDateiname, False)

End If

Set zDriverS7TCP = zDrivers.Item(sBezeichnung)

Debug.Print zDriverS7TCP.Name

Call zDriverS7TCP.OpenConfig

vProps = zDriverS7TCP.DynPropertiesEnum("")

Debug.Print "========== DynProperties =============="

For intj = 0 To UBound(vProps)

Debug.Print vProps(intj)

Next intj

Debug.Print "============================================================================================="

Call zDriverS7TCP.CloseConfig(False)

'Change some configuration on the driver

Call zDriverS7TCP.OpenConfig

Debug.Print "Modus (General Driver Mode) :" & zDriverS7TCP.DynProperties("GenDriverMode")

'Change General Driver mode from Hardware to Simulation-counter

zDriverS7TCP.DynProperties("GenDriverMode") = 1

'Show some DynProperties

Debug.Print "======================================_General_=========================================="

Debug.Print "Modus (General Driver Mode) : " & zDriverS7TCP.DynProperties("GenDriverMode")

Debug.Print "Update-Liste im Speicher Halten : " & zDriverS7TCP.DynProperties("GenKeepUpdatelist")

Debug.Print "Ausgänge schreibbar : " & zDriverS7TCP.DynProperties("GenOutputWriteable")

Debug.Print "Variablenabbild remanent : " & zDriverS7TCP.DynProperties("GenRemanentImage")

Debug.Print "Update Zeit Clobal : " & zDriverS7TCP.DynProperties("GenUseGlobalUpdateTime")

Debug.Print "Clobale Updatezeit in ms : " & zDriverS7TCP.DynProperties("GenGlobalUpdateTime")

Debug.Print "Priorität normal : " & zDriverS7TCP.DynProperties("GenPrioUpdateTime0")

Debug.Print "Priorität erhöht : " & zDriverS7TCP.DynProperties("GenPrioUpdateTime1")

Debug.Print "Priorität hoch: " & zDriverS7TCP.DynProperties("GenPrioUpdateTime2")

Debug.Print "Priorität höchste : " & zDriverS7TCP.DynProperties("GenPrioUpdateTime3")

Debug.Print "===============================_S7- TCP Configuration_==================================="

Debug.Print "TCP- Konfiguration : " & zDriverS7TCP.DynProperties("CfgConfFileName")

Debug.Print "Fehlerwartezeit : " & zDriverS7TCP.DynProperties("CfgErrorWaitTime")

Debug.Print "Char-String ohne Header : " & zDriverS7TCP.DynProperties("CfgStringWithoutHeader")

Debug.Print "==============================_S7- TCP Connection_======================================="

Debug.Print "This settings must be set in the configuration file ."

Debug.Print "========================================================================================="

Debug.Print "Name : " & zDriverS7TCP.DynProperties("Name")

Debug.Print "DriverId : " & zDriverS7TCP.DynProperties("DriverId")

Debug.Print "NameFile : " & zDriverS7TCP.DynProperties("NameFile")

Debug.Print "========================================================================================="

Call zDriverS7TCP.CloseConfig(True)

End Sub

'Extra für Steriflow

Public Sub BrowseProperties()

Dim drv As Driver

Dim PropertyList As Variant

Dim i As Integer

'Zuweisen des Treibers mit der Bezeichnung Steriflow driver

Set drv = MyWorkspace.ActiveDocument.Drivers.Item("Steriflow driver")

'über DynPropertiesEnum bekommen wir eine Liste aller Properties, die die API des Treibers implementiert

drv.OpenConfig

PropertyList = drv.DynPropertiesEnum("")

'in dieser For-Schleife gehen wir die Properties durch und schreiben sie zeilenweise ins Ausgabefenster des zenon Editors

For i = 0 To UBound(PropertyList) - 1

ApplicationED.DebugPrint PropertyList(i), tpMsg

Next i

End Sub


CloseConfig

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Methods -> CloseConfig

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CloseConfig(Boolean bSave) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Defines wether to save (True) the actual driver configuration or not (False).

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bSave As Boolean

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Browse

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Methods -> Browse

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Browse(String bsFilter, String bsResult) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Driver specific filterstring for online import of variables.

IEC870: Net=NetAddress;Filter={Address="Filterstring1";Type="Filterstring2";}; Logix32: Net=NetAddress;Struct="Filterstring1";Name="Filterstring2"; The Filterstrings must be used as in the dialog when importing manual ly in the editor...

Returns a message as String like you can see in the LogViewer...

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFilter As String

bsResult As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Driver-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Driver

Other topics in this chapter

Driver


Driver

Manual -> Programming interfaces -> Objectmodel -> Driver -> Driver-Dynamic properties -> Driver

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BSTR

Name

Identification

Unique name of the driver.
zenon identifies the driver with the help of this name and not with the help of the file name. Thus it is possible to load the same driver several times. This is for example necessary when you must access same control types which are connected to differenent serial interfaces.
Attention: This property is not available for language switch.

More in the online help.

VT_BSTR

Description

Description

Description of the driver.

More in the online help.

VT_BSTR

NameFile

File name

File name of the driver.
The file is located in program folder of the control system.

More in the online help.

VT_UI4

DriverId

Driver Id

VT_UI2

SimulPort

Standard port

Only available if a simulation project has been created.

TCP/IP port for the communication with the zenon Logic Workbench.
Permitted port numbers:

  • Minimum: 6000 (with automatic allocation, manually: recommended)
  • Maximum: 6999 (with automatic allocation, manually: recommended)

Default: 6000

The port number must:

  • Be free in the project
  • Be unique for all projects that run in Runtime
  • Be available on the computer on which the driver runs.

When creating the simulation project, a unique port number is assigned automatically.

Note: An automatically assigned port number is only unique for the respective project. In multi-hierarchic projects you must check this in order to avoid communication errors with the zenon Logic Workbench/Runtime.

More in the online help.

VT_UI2

SimulEvPort

Event port

Only available if a simulation project has been created.

TCP/IP port for spontaneous data exchange. The port number must be distinct, not used in the project and available on the computer on which the driver runs At creating the simulation project a distinct port number is assigned automatically.

Note: An automatically assigned port number is only unique for the respective project. In multi-hierarchic projects you must check this in order to avoid communication errors with the zenon Logic Workbench/Runtime.

Minimum: 6001 (with automatic allocation, manually: recommended)

Maximum: 6998 (with automatic allocation, manually: recommended)

Default: 6001

More in the online help.

VT_BSTR

SimulName

Name

Name of the simulation project. If there is no valid name available at the start of the zenon Logic Workbench, a name is assigned automatically. The name consists of the driver name and its description.

Conditions for valid names:

- must not be empty

- must be distinct in the project

- may only consist of characters which are allowed in zenon Logic; forbidden are: /\:*?<>!|"

Minimum: 1 character

Maximum: 15 characters.

More in the online help.

ZT_AKZ

SystemModelGroup

Equipment groups

Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group.

More in the online help.


Drivers

Manual -> Programming interfaces -> Objectmodel -> Drivers

Remarks

The object Drivers, is a collection of which contains the defined drivers of the project.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public Sub DriversSample()
Dim zDrivers As Drivers
Dim zDriver As Driver
Dim i As Integer

'get drivers collection
Set zDrivers = MyWorkspace.ActiveDocument.Drivers

'Enumerate existing drivers in the project
For i = 0 To zDrivers.Count - 1
Debug.Print zDrivers.Item(i).Name
Next i

'Create a new driver and check if already exists
Set zDriver = zDrivers.Item("NewSimulationDriver")
If zDriver Is Nothing Then
Set zDriver = zDrivers.CreateDriver("NewSimulationDriver", "SIMUL32")
End If

End Sub

Other topics in this chapter

Drivers-Properties

Drivers-Methods


Drivers-Properties

Manual -> Programming interfaces -> Objectmodel -> Drivers -> Drivers-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Count of defined drivers | read only | read only
IProject | Parent | Parent-object | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> Drivers -> Drivers-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> Drivers -> Drivers-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Drivers-Methods

Manual -> Programming interfaces -> Objectmodel -> Drivers -> Drivers-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IDriver | CreateDriver | Creates a new driver | available | not used
IDriver | CreateDriverEx | Creates a new driver | available | not used
VARIANT_BOOL | DeleteDriver | Deletes the given driver | available | not used
IDriver | Item | Returns driver by position or name | available | available

Other topics in this chapter

Item

CreateDriver

CreateDriverEx

DeleteDriver


Item

Manual -> Programming interfaces -> Objectmodel -> Drivers -> Drivers-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the object Driver from the collection, which is identified by the parameter vID.The parameter vID can have two values:

Datatype

Item(VARIANT vID) As Driver

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

vID As Variant Index or name. If the parameter is a numerical value, the driver is searched by its index (>= 0 and <= Count-1).
If it is an alphanumerical value, the driver is searched by its name.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vID As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateDriver

Manual -> Programming interfaces -> Objectmodel -> Drivers -> Drivers-Methods -> CreateDriver

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new driver and returns the created driver as Driver object.

Datatype

CreateDriver(String strName,String strEXEName) As Driver

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateDriverEx

Manual -> Programming interfaces -> Objectmodel -> Drivers -> Drivers-Methods -> CreateDriverEx

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new driver and returns the created driver as Driver object. If the parameter bShowDlg is true the driver creation dialog is shown to the user.

Datatype

CreateDriverEx(String strName,String strEXEName,Boolean bShowDlg) As Driver

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteDriver

Manual -> Programming interfaces -> Objectmodel -> Drivers -> Drivers-Methods -> DeleteDriver

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deletes the given driver by its name

Datatype

DeleteDriver(String strName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPicture

Manual -> Programming interfaces -> Objectmodel -> DynPicture

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This collection contains the defined Screens. The single Screens can contain different dynamic elements. Each Screen is linked to a Frame, that contains general information on the outer appearance.Screens always come from the current project – the global project is ignored, as Screens are not supported in global projects.The single Screens can be found in the collection by their unique name or by the index. Each Screen is identified by an unique name.Hint:For the use of events in an object DynPicture an object DynPicture of this Screen must be defined with WithEvents.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

'##############################################
'## VBA Code in the Module "ModuleElement" ##
'## ---------------------------------------- ##
'## LeftClickUp - Event has to be created in ##
'## the Editor with the Name "PopUp"... ##
'## (Scripting - VBA Makros - ModuleElement) ##
'##############################################

'event for clicking on a element
Public Sub LeftClickUp_PopUp(obElem As Element)
'save the position information of the element to public
'member variables in the thisProject Classmodule...
thisProject.lLeft = obElem.Left
thisProject.lTop = obElem.Top
'execute different functions depending to the element name...
'Example for FuntionName: POPUP_Valve001
'>> Valve001 ist the Objectname of the Element!
thisProject.RtFunctions.Item("POPUP_" & obElem.Name).Start
End Sub

'###############################################
'## VBA Code in the ClassModule "thisProject" ##
'## ----------------------------------------- ##
'## When the POPUP Screen opens, the Open - ##
'## Event is executed and the new positions ##
'## will be set with the Move - Method ##
'###############################################

'declaration of the position members...
Public lLeft As Long
Public lTop As Long
'declaring the DynPicture Object for the OPEN event...
Dim WithEvents dynPicPOPUP As DynPicture

'on project startup...
Private Sub Project_Active()
'setting the Dynpicture object to the "POPUP" Screen...
Set dynPicPOPUP = thisProject.DynPictures.Item("POPUP")
'check if there was a problem an initializing the DynPicture Object...
If dynPicPOPUP Is Nothing Then
MsgBox "moving the Screen is not possible..."
End If
End Sub

'when the Screen opens...
Private Sub dynPicPOPUP_Open()
'moving the Screen...
dynPicPOPUP.Move lLeft, lTop, dynPicPOPUP.Width, dynPicPOPUP.Height
End Sub

'on project exit...
Private Sub Project_Inactive()
If dynPicPOPUP Is Nothing Then Exit Sub
'release the object...
Set dynPicPOPUP = Nothing
End Sub

Other topics in this chapter

DynPicture-Properties

DynPicture-Methods

DynPicture-Events


DynPicture-Properties

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
VARIANT_BOOL | AutoKBLayout | Use regional settings for keyboard layout | available | read only | yes | yes
OLE_COLOR | BackColor |  | available | read only | yes | yes
BSTR | BackgroundImage | Background image for the picture | available | read only | yes | yes
long | BackgroundImageStyle | Style for the background image | available | read only | yes | yes
long | BorderStyle | Style of the picture-border (for resizing) | available | read only | yes | yes
long | Bottom | Bottom-coordinate of the picture | read only | not used | yes | yes
VARIANT_BOOL | Enable |  | available | available | yes | yes
long | EndFunction | Rt-Function by closing the picture | available | read only | yes | yes
long | Height | Height of the picture | available | read only | yes | yes
VARIANT_BOOL | Hide |  | available | available | yes | yes
long | Left | Left-coordinate of the picture | read only | read only | yes | yes
short | MonitorId | Returns the ID of the Monitor on which the picture is opened. (RT-Only) | not used | read only | yes | yes
BSTR | Name |  | available | read only | yes | yes
VARIANT_BOOL | Online |  | not used | read only | yes | yes
IDynPictures | Parent |  | read only | read only | yes | yes
IPictureFilter | PictureFilter | Return the current picture filter. (RT-Only) | not used | available | yes | yes
long | Right | Right-coordinate of the picture | read only | not used | yes | yes
VARIANT_BOOL | ShowInCE | Use picture in CE-projects | available | not used | yes | yes
VARIANT_BOOL | ShowModal | Show picture as modal dialog | available | not used | yes | yes
VARIANT_BOOL | ShowTitle | Shows the name in the titelbar | available | not used | yes | yes
long | StartFunction | Rt-Function by showing the picture | available | not used | yes | yes
BSTR | Template |  | available | read only | yes | yes
long | Top | Top-coordinate of the picture | read only | read only | yes | yes
long | Type |  | available | not used | yes | yes
VARIANT_BOOL | UseTemplateSize | Use size-properties of the linked template | available | not used | yes | yes
long | Width | Width of the picture | available | read only | yes | yes
long | ZoomLevel | Zoom level of a world picture (RT-Only) | not used | read only | yes | yes
long | InstanceId | Returns the template instance ID of the DynPicture. (RT-Only) | not used | read only | yes | yes
IElement | DynPictureContainer | Returns the container element in which the DynPicture is contained, or NULL when the DynPicture is not inside a container. (RT-Only) | not used | read only | yes | yes
IDynPictureInstances | Instances | Returns a collection containing all instances of the DynPicture. (RT-Only) | not used | read only | yes | yes
BSTR | Template |  | available | read only | yes | yes

Other topics in this chapter

Parent

Name

Type

Template

BackColor

ZoomLevel

Hide

Enable

Online

StartFunction

EndFunction

UseTemplateSize

ShowTitle

ShowModal

BorderStyle

ShowInCE

BackgroundImage

BackgroundImageStyle

Left

Top

Right

Bottom

Width

Height

AutoKBLayout

PictureFilter

MonitorId

InstanceId

DynPictureContainer

Instances


Parent

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As DynPictures

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the unique name of the current picture. With this name the picture can be found in the central pictures list of the project.

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Type

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Type() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Template

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> Template

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Template() As BSTR

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


BackColor

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> BackColor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

BackColor() As OLE_COLOR

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ZoomLevel

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> ZoomLevel

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Indicates the actual zoom level in the world view. (Valid value only in the Runtime and for one world view.)

Datatype

ZoomLevel() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Hide

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> Hide

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property can influence the visibility of the picture. Usually this property returns False, i.e. the picture is displayed.If the property is set to True, the picture is displayed invisibly. The picture stays invisible, until this property is set back to False.Hint: Reopening the picture does not change this setting.

Datatype

Hide() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Enable

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> Enable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property de/activates the current picture. Usually this property returns True, i.e. operation of the picture is allowed.If this property returns False, the picture is deactivated. In this case the elements of the picture cannot be operated, e.g. clicking on dynamic elements.The picture stays inactive, until this property is set back to True.Hint: Reopening the picture does not change this setting.

Datatype

Enable() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Online

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> Online

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property checks, if the current picture is open.The following example searches for the picture START. If it is found, a MsgBox informs the user, whether or not the picture is corrently opened.

Datatype

Online() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'*** Is the current picture shown
Public Sub LeftClickUp_Picture_IsOnline(obElem As Element)
Dim obPicture As DynPicture

'*** Get picture-object
Set obPicture = thisProject.DynPictures.Item("START")
If (obPicture Is Nothing) Then
MsgBox "Error: Picture-object is invalid..."
Exit Sub
End If

'*** is picture shown?????
If (obPicture.Online = True) Then
MsgBox "Picture 'Start' is shown at the moment..."
Else
MsgBox "Picture 'Start' is NOT shown at the moment..." & vbCrLf & _
"Current Picture is '" & obElem.Parent.Parent.Name & "'!"
End If

obElem.LeftClickUp
End Sub


StartFunction

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> StartFunction

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the name of the function that should be executed automatically when the picture is opened in the Runtime.Hint: If more than one function should be executed, then a script with all the desired functions has to be created and the function for executing the script has to be linked here.

Datatype

StartFunction() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


EndFunction

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> EndFunction

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the name of the function that should be executed automatically when the picture is closed in the Runtime.Hint: If more than one function should be executed, then a script with all the desired functions has to be created and the function for executing the script has to be linked here.

Datatype

EndFunction() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


UseTemplateSize

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> UseTemplateSize

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Use size-properties of the linked Frame.Hint: If set TRUE the properties "Height" and "Width" cannot be set.

Datatype

UseTemplateSize() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


ShowTitle

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> ShowTitle

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Shows the titlebar, if set TRUE.

Datatype

ShowTitle() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


ShowModal

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> ShowModal

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Show picture as modal dialog, if set TRUE.As long as this picture is open in the Runtime, no other picture beside it can be operated (e.g. for a login picture). Other pictures that were opened out of this picture can be operated.

Datatype

ShowModal() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


BorderStyle

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> BorderStyle

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

BorderStyle() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ShowInCE

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> ShowInCE

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The picture is also displayed under Windows CE, if set TRUE.Thus in networks with PCs and CE devices, functionalities, which are not supported by Windows CE, can be used on the PCs without having problems on the CE devices.

Datatype

ShowInCE() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


BackgroundImage

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> BackgroundImage

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the path to the background image for the DynPicture.

Datatype

BackgroundImage() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


BackgroundImageStyle

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> BackgroundImageStyle

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

BackgroundImageStyle() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Left

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> Left

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the position of the left picture border in pixel. The value defines the distance from the left border of the screen.The following VBA example moves the current picture to the bottom and to the right by 10 pixels.

Datatype

Left() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'*** The current picture is moved by 10 pixel/side (top,bottom,left,right)
Public Sub LeftClickUp_Picture_Move(obElem As Element)
Dim obPicture As DynPicture

'*** Get picture-object
Set obPicture = obElem.Parent.Parent
If (obPicture Is Nothing) Then
MsgBox "Error: Picture-object is invalid..."
Exit Sub
End If

'*** De/-activate the current picture
obPicture.Move obPicture.Left + 10, obPicture.Top + 10, obPicture.Width, obPicture.Height
obElem.LeftClickUp
End Sub


Top

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> Top

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the position of the top picture border in pixel. The value defines the distance from the top border of the screen.The following VBA example moves the current picture to the bottom and to the right by 10 pixels.

Datatype

Top() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'*** The current picture is moved by 10 pixel/side (top,bottom,left,right)
Public Sub LeftClickUp_Picture_Move(obElem As Element)
Dim obPicture As DynPicture

'*** Get picture-object
Set obPicture = obElem.Parent.Parent
If (obPicture Is Nothing) Then
MsgBox "Error: Picture-object is invalid..."
Exit Sub
End If

'*** De/-activate the current picture
obPicture.Move obPicture.Left + 10, obPicture.Top + 10, obPicture.Width, obPicture.Height
obElem.LeftClickUp
End Sub


Right

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> Right

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the position of the right picture border in pixel. The value defines the distance from the left border of the screen.The following VBA example moves the current picture to the bottom and to the right by 10 pixels.

Datatype

Right() As long

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'*** The current picture is moved by 10 pixel/side (top,bottom,left,right)
Public Sub LeftClickUp_Picture_Move(obElem As Element)
Dim obPicture As DynPicture

'*** Get picture-object
Set obPicture = obElem.Parent.Parent
If (obPicture Is Nothing) Then
MsgBox "Error: Picture-object is invalid..."
Exit Sub
End If

'*** De/-activate the current picture
obPicture.Move obPicture.Left + 10, obPicture.Top + 10, obPicture.Width, obPicture.Height
obElem.LeftClickUp
End Sub


Bottom

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> Bottom

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the position of the bottom picture border in pixel. The value defines the distance from the top border of the screen.

Datatype

Bottom() As long

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes


Width

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> Width

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the defined width of the picture in pixels. The width of the picture is the difference between the right and the left border.Hint: This property cannot be set, if the property "UseTemplateSize" is set TRUE.The following VBA example moves the current picture to the bottom and to the right by 10 pixels.

Datatype

Width() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'*** The current picture is moved by 10 pixel/side (top,bottom,left,right)
Public Sub LeftClickUp_Picture_Move(obElem As Element)
Dim obPicture As DynPicture

'*** Get picture-object
Set obPicture = obElem.Parent.Parent
If (obPicture Is Nothing) Then
MsgBox "Error: Picture-object is invalid..."
Exit Sub
End If

'*** De/-activate the current picture
obPicture.Move obPicture.Left + 10, obPicture.Top + 10, obPicture.Width, obPicture.Height
obElem.LeftClickUp
End Sub


Height

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> Height

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the defined height of the picture in pixels. The height of the picture is the difference between the bottom and the top border.Hint: This property cannot be set, if the property "UseTemplateSize" is set TRUE.The following VBA example moves the current picture to the bottom and to the right by 10 pixels.

Datatype

Height() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'*** The current picture is moved by 10 pixel/side (top,bottom,left,right)
Public Sub LeftClickUp_Picture_Move(obElem As Element)
Dim obPicture As DynPicture

'*** Get picture-object
Set obPicture = obElem.Parent.Parent
If (obPicture Is Nothing) Then
MsgBox "Error: Picture-object is invalid..."
Exit Sub
End If

'*** De/-activate the current picture
obPicture.Move obPicture.Left + 10, obPicture.Top + 10, obPicture.Width, obPicture.Height
obElem.LeftClickUp
End Sub


AutoKBLayout

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> AutoKBLayout

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Enables or disables the automatic keyboard layout functionality.Hint: Only available for pictures of type "Keyboard".

Datatype

AutoKBLayout() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


PictureFilter

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> PictureFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

PictureFilter() As PictureFilter

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


MonitorId

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> MonitorId

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MonitorId() As short

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


InstanceId

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> InstanceId

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the template instance ID of the DynPicture. (RT-Only).

Datatype

InstanceId() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


DynPictureContainer

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> DynPictureContainer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the container element in which the DynPicture is contained, or NULL when the DynPicture is not inside a container. (RT-Only).

Datatype

DynPictureContainer() As IElement

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Instances

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Properties -> Instances

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a collection containing all instances of the DynPicture. (RT-Only).

Datatype

Instances() As IDynPictureInstances

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


DynPicture-Methods

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | Activate | Activates the picture (only runtime) | available | available
void | BringToTop | Brings picture to top of Z-order | not used | available
VARIANT_BOOL | CheckIn | Save module modifications to server (editor). | available | not used
VARIANT_BOOL | CheckOut | Allow module modifications (editor). | available | not used
VARIANT_BOOL | CloseDynPicture | Closes the Screen when its currently opened (RT-Only) | not used | available
VARIANT_BOOL | Copy | Copies the picture | available | not used
VARIANT_BOOL | CreateMdiDefaultElements | Create the MDI-Default elements (only with MDI-Windows) | available | not used
void | DeselectElements | Deselects all currently selected Elements | not used | available
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IElements | Elements | Returns the Elements-list | available | available
VARIANT_BOOL | Get | Get the latest version from the server (editor). | available | not used
VARIANT_BOOL | Hardcopy | Creates a Bitmap of the picture, with the appearance as shown in the editor. | available | not used
short | ImportMdiElements | Imports the MDI-Default elements from a template (only with MDI-Windows) | available | not used
IElement | InsertSymbol | Insert a symbol from the symbol-library | available | not used
VARIANT_BOOL | IsCheckedOut | Returns true when the current module checked out by the current user (editor). | read only | not used
VARIANT_BOOL | IsDifferent | Return true when the local- and server version are different (editor). | read only | not used
VARIANT_BOOL | IsLocked | Returns true when the current module is Locked by another user (editor). | read only | not used
IMdiElements | MdiElements | Returns the list of the available MDI-controls | available | not used
void | Move | - | available | available
VARIANT_BOOL | Save | - | available | not used
IElements | SelElements | Returns the list of selected Elements | not used | available
void | SetZoomAndPos | Sets zoom factors and position of a world picture (RT-Only) | not used | available
VARIANT_BOOL | UndoCheckOut | Undo module modifications (editor). | available | not used
void | Update | - | not used | available
void | UpdateAll | Update the picture | not used | available
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used
IMDITemplates | CreateMDIScreenTemplate | Create MDI-Screen template from an picture. | available | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

Activate

Elements

Update

UpdateAll

Move

BringToTop

SetZoomAndPos

CloseDynPicture

Save

Copy

CreateMdiDefaultElements

ImportMdiElements

CreateMDIScreenTemplate

MdiElements

InsertSymbol

SelElements

DeselectElements

Hardcopy

Get

CheckOut

CheckIn

UndoCheckOut

IsLocked

IsCheckedOut

IsDifferent


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


Activate

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> Activate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method brings the current picture to the foreground – if it is overlapped by another picture.Be aware, that the according picture has to be opened before.The picture „Dialog“ will be switched to the foreground. If the picture is not open yet, a MsgBox shall inform the user. By switching to another picture the picture is brought to the background – but not closed. The example was written in zenOn-VBA.

Datatype

Activate() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Elements

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> Elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the collection of the defined dynamic elements contained in the picture.Each defined dynamic element is available as an object Element. The defined dynamic elements can be accessed in the collection by their unique names or by their indices.The name has to be given to the element explicitely by the user. For more detailed information have a look at the Element and Elements parts.

Datatype

Elements() As Elements

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Update

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> Update

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method redraws a certain area of the picture. The user has to know which part of the picture should be redrawn. The parameters include the corners of the rectangular area that should be redrawn.Hint: Use UpdateAll to redraw the entire picture.

Datatype

Update(long Left, long Top, long Bottom, long Right) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


UpdateAll

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> UpdateAll

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method redraws the entire picture. All elements in the picture are redrawn.

Datatype

UpdateAll() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Move

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> Move

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Updates the position of a DynPicture object. In order to ensure the new position is visualized make sure to call the UpdateAll method of the DynPicture object.

Datatype

Move(long Left, long Top, long Width, long Height) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Left As Long

Height As Long

Top As Long

Width As Long

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub
'*** The current picture is moved by 10 pixel/side (top,bottom,left,right)
Public Sub LeftClickUp_Picture_Move(obElem As Element)
Dim obPicture As DynPicture

'*** Get picture-object
Set obPicture = obElem.Parent.Parent
If (obPicture Is Nothing) Then
MsgBox "Error: Picture-object is invalid..."
Exit Sub
End If

'*** De/-activate the current picture
obPicture.Move obPicture.Left + 10, obPicture.Top + 10, obPicture.Width, obPicture.Height
obElem.LeftClickUp
End Sub


BringToTop

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> BringToTop

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Calling this method will bring a picture without "always on top" to the highest z order of all pictures without "always on top" and a picture with "always on top" on the highest z-order of all pictures with "always on top". Pictures without "always on top" therefore will not cover pictures with "always on top".

Datatype

BringToTop() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SetZoomAndPos

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> SetZoomAndPos

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Updates the Zoom and position of a dynamic picture, like the internal function would.

Datatype

SetZoomAndPos(FLOAT ZoomX, FLOAT ZoomY, long ZoomLevel, long CursorX, long CursorY, long PosX, long PosY, long iPosMode) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

ZoomX - New zoom factor in x direction (-1 if not used)

ZoomY - New zoom factor in y direction (-1 if not used)

ZoomLevel - Cannot be used with ZoomX and ZoomY (0 if not used)

PosX - New x position according to PosMode

PosY - New y position according to PosMode

PosMode - Determines how PosX and PosY are interpreted

-1 = PosX, PosY are ignored

0 = Set the center point and use original coordinates

1 = Set the center point and use new coordinates

2 = From the top left, use original coordinates

3 = From the top left, use zoomed coordinates

4 = Use the zoomed coordinates of the cursor from the top left, the window position is changed so that the cursor stays in the same position.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CloseDynPicture

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> CloseDynPicture

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Closes a opened screen. In case the screen is not open, the return value of the function = FALSE.

Datatype

CloseDynPicture() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

//This function closes a specific screen.

public void Macro_Test_CloseDynpicture()

{

//The function returns true: screen is open

//The function returns false: screen not open

if (!this.DynPictures().Item("Screen 2").CloseDynPicture())

{

System.Windows.Forms.MessageBox.Show("Couldn't close, no window with assigned name is open!");

}

else

{

System.Windows.Forms.MessageBox.Show("Closed window");

}

}

VB.NET

'This function closes a specific screen.

Public Sub Macro_Test_CloseDynpicture()

'The function returns true: screen is open

'The function returns false: screen not open

If Not Me.DynPictures().Item("Screen 2").CloseDynPicture() Then

System.Windows.Forms.MessageBox.Show("Couldn't close, no window with assigned name is open!")

Else

System.Windows.Forms.MessageBox.Show("Closed window")

End If

End Sub

VBA

VBA-Syntax


Save

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> Save

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Method to save the picture (changes in this collection)

Datatype

Save() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Copy

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> Copy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Copies the settings of an existing "DynPicture" object to the current object.

Datatype

Copy(IDynPicture PictureSource) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

"DynPicture" object from which the settings should be copied from.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

PictureSource As DynPicture

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_CopyDynPicture()
'Declarations
Dim zPic As DynPicture
Dim zPicCopy As DynPicture

'Initialize zPic with the start picture
Set zPic = MyWorkspace.ActiveDocument.DynPictures.Item("START")
'Initialize zPicCopy by creating a new picture linked to Frame "MAIN_WIZARD" as standard picture type
Set zPicCopy = MyWorkspace.ActiveDocument.DynPictures.Create("zPicCopy", "MAIN_WIZARD", 0)

'Copy the settings from zPic to zPicCopy
zPicCopy.Copy zPic

End Sub


CreateMdiDefaultElements

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> CreateMdiDefaultElements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Create the MDI-Default elements (only by MDI-Windows)

Datatype

CreateMdiDefaultElements() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ImportMdiElements

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> ImportMdiElements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Imports the MDI-Default elements from a template (only with MDI-Windows). Use the Boolean DelElements) to define the replacement of existing settings.

The method returns an error code on the result of the import can be evaluated:
0 = OK
-1 = Screen not loaded
-2 = No screen type
-3 = The specified file does not exist
-4 = Import failed
-5 = Type of template and screen type do not match
-6 = Error loading screen

Datatype

ImportMdiElements(String FileName, Boolean DelElements) As short

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

bool DelElements

The parameter specifies the file name which the template is stored.
If an empty file name ("") specified, the default elements of the MDI type of screen to be created.
In this case behaves the method (almost) the same as the method "CreateMdiDefaultElements"

string FileName

The parameter specifies wheter to override a existing items with the same file name.
True = Override
False = none

VB.NET

Dim FileName As String

The parameter specifies the file name which the template is stored.
If an empty file name ("") specified, the default elements of the MDI type of screen to be created.
In this case behaves the method (almost) the same as the method "CreateMdiDefaultElements"

Dim DelElements As Boolean

The parameter specifies wheter to override a existing items with the same file name.
True = Override
False = none

VBA

FileName As String

The parameter specifies the file name which the template is stored.
If an empty file name ("") specified, the default elements of the MDI type of screen to be created.
In this case behaves the method (almost) the same as the method "CreateMdiDefaultElements"

DelElements As Boolean

The parameter specifies wheter to override a existing items with the same file name.
True = Override
False = none

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub ImportMdiTemplate()

Dim Picture As DynPicture

Dim Res As Integer

Set Picture = MyWorkspace.ActiveDocument.DynPictures.Item("Bild 2")

If Not Picture Is Nothing Then

Res = Picture.ImportMdiElements("C:\ProgramData\COPA-DATA\zenon700\Templates\ ScreenTypes\Keyboard\6eeae916-0098-40ab-9dc9-a9ce1dcf4bb5.zip", True)

If Res = 0 Then

Picture.Save

End If

End Sub


CreateMDIScreenTemplate

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> CreateMDIScreenTemplate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a template from a screen

Datatype

CreateMDIScreenTemplate(BSTR bsFilename, BSTR bsGroup, BSTR bsDescription, BOOL bOverwrite) As IMDITemplates

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA

Private Sub CreateMDIScreenTemplate()

Dim Picture As DynPicture

Dim Template As MDITemplate

Set Picture = MyWorkspace.ActiveDocument.DynPictures.Item("Bild 2")

' * Diese Funktion erstellt aus einem Bild ein Template *

' * Die ersten zwei Parameter müssen mitübergeben werden, sonst Fehler *

' * Der dritte Parameter ist optional und ist die Beschreibung zum Template *

' * Der vierte Parameter gibt an ob ein Template, welches existiert, *

' * überschrieben werden soll, sofern dies kein CD Template ist *

' * zurückgegeben wird das fertige MDITemplate *

Template=Picture.CreateMDIScreenTemplate("TemplateBild2.xml", "Schablonen.Copadata", "Dieses Template tut dieses und jenes", True)

If Not Template Is Nothing Then

' Hat funktioniert

Else

' Error

End If

End Sub


MdiElements

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> MdiElements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the list ("MdiElements" object) of the available MDI-controls.

Datatype

MdiElements() As MdiElements

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


InsertSymbol

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> InsertSymbol

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Insert a symbol from the symbol-library by its name and symbol group name.

Datatype

InsertSymbol(String bsName, String bsLibrary, Boolean bLinked) As Element

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

1. bsName

- Name of the symbol within the library.

2. bsLibrary

- "" (Emtpy string) if from the local project

- "SymbolGroupName" if from the General symbol library

- "~|GPLN|~" if from the library in the global project

3. bLinked

- If set TRUE the symbol constitutes a linked symbol. Otherwise the symbol will be embedded.

Examples

C#

public void MacroInsertSymbol()

{

//This macro demonstrates how to insert a symbol via the VSTA API

IDynPicture zenonPictureStart = this.ActiveDocument.DynPictures().Item("Start");

//Insert the symbol "battery_charging" from group "batteries_16_9" to the start picture linked

zenonPictureStart.InsertSymbol("battery_charging", "batteries_16_9", true);

}

VB.NET

Public Sub MacroInsertSymbol()

'This macro demonstrates how to insert a symbol via the VSTA API

Dim zenonPictureStart As IDynPicture = Me.ActiveDocument.DynPictures().Item("Start")

'Insert the symbol "battery_charging" from group "batteries_16_9" to the start picture linked

zenonPictureStart.InsertSymbol("battery_charging", "batteries_16_9", True)

End Sub

VBA

Sub zenOn_DynPicture_InsertSymbol()
'Declarations
Dim zPic As DynPicture

'Initialize zPic with the start picture
Set zPic = MyWorkspace.ActiveDocument.DynPictures.Item("START")

'Insert linked symbol "Brake motor" from the category "F_Motors" to the start picture
zPic.InsertSymbol "Brake motor", "F_Motors", True

End Sub


SelElements

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> SelElements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a list ("Elements" object) of selected "Element" objects within the picture.Hint: Only available, if the lasso selection is activated within the project.<span style="font-family:courier new;">MyWorkspace.ActiveDocument.DynProperties("RuntimeLasso") = True</span>

Datatype

SelElements() As Elements

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_DynPicture_ListSelection()
'Declarations
Dim zPic As DynPicture
Dim i As Integer

'Initialize zPic with the start picture
Set zPic = thisProject.DynPictures.Item("START")

'For every selected element in the start picture...
For i = 0 To zPic.SelElements.Count - 1
'...output the name
Debug.Print i + 1 & ". item: " & zPic.SelElements.Item(i).Name
Next i

'Deselect all selected elements
zPic.DeselectElements

End Sub


DeselectElements

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> DeselectElements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deselects all selected elements in the corresponding picture.Hint: Only available, if the lasso selection is activated within the project.<span style="font-family:courier new;">MyWorkspace.ActiveDocument.DynProperties("RuntimeLasso") = True</span>

Datatype

DeselectElements() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Hardcopy

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> Hardcopy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Exports the picture into a file. Currently only the export as a bitmap file is available.

Datatype

Hardcopy(String bsFileName,tpHardcopyOutput lOutputFormat) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Get

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> Get

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype

Get() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckOut

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> CheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype

CheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckIn

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> CheckIn

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype

CheckIn() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


UndoCheckOut

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> UndoCheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype

UndoCheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsLocked

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> IsLocked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects. NOTE: In a multiu-user project it is recommended to check for IsLocked == false before performing any modification changes at all.

Datatype

IsLocked() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsCheckedOut

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> IsCheckedOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype

IsCheckedOut() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsDifferent

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Methods -> IsDifferent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype

IsDifferent() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPicture-Events

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description |  | Editor | Runtime
void | Close | Event is fired by closing the picture |  | not used | available
void | Open | Event is fired by opening the picture |  | not used | available
void | Timer |  | not used |  | available

Other topics in this chapter

Open

Close

Timer


Open

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Events -> Open

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is executed, when the current picture is opened.Hint: For the use of events, the "DynPicture" object must be defined with WithEvents.

Datatype

Open() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'Declaration of zPIC, in order to use it with events
Dim WithEvents zPIC As dynpicture

'Event is fired, when project is opened
Private Sub Project_Active()
'Initialize zPIC with the start picture
Set zPIC = thisProject.DynPictures.Item("START")
End Sub

'Event is fired, when picture is opened
Private Sub zPIC_Open()
'Output the time when the picture was opened
Debug.Print Now & " Picture OPENED!"
End Sub

'Event is fired, when project is closed
Private Sub Project_Inactive()
'Deinitialize zPIC on project close
Set zPIC = Nothing
End Sub


Close

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Events -> Close

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is executed on closing the current picture.Hint: For the use of events, the "DynPicture" object must be defined with WithEvents.

Datatype

Close() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'Declaration of zPIC, in order to use it with events
Dim WithEvents zPIC As dynpicture

'Event is fired, when project is opened
Private Sub Project_Active()
'Initialize zPIC with the start picture
Set zPIC = thisProject.DynPictures.Item("START")
End Sub

'Event is fired, when picture is closed
Private Sub zPIC_Close()
'Output the time when the picture was closed
Debug.Print Now & " Picture CLOSED!"
End Sub

'Event is fired, when project is closed
Private Sub Project_Inactive()
'Deinitialize zPIC on project close
Set zPIC = Nothing
End Sub


Timer

Manual -> Programming interfaces -> Objectmodel -> DynPicture -> DynPicture-Events -> Timer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is executed in a cyclic interval – depending on the flash frequency set in the project. In this event extended visualization effects can be realized, e.g. mini animations.Hint: For the use of events, the "DynPicture" object must be defined with WithEvents.

Datatype

Timer() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPictureInstances

Manual -> Programming interfaces -> Objectmodel -> DynPictureInstances

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Used to check if a screen is displayed in the runtime. With the Count() property the amount of screens is determined. The Item() property is used to determine the Dynpicture object for each instance.

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Public Sub LeftClickUp_Default(obElem As Element)

Dim FacePlate As DynPicture

Dim DynPictureContainer As Element

Dim strTrace As String

strTrace = "Das Element befindet sich auf Bild:" & obElem.Parent.Parent.Name & " mit InstanzID:" & obElem.Parent.Parent.InstanceId

If Not obElem.Parent.Parent.DynPictureContainer Is Nothing Then

strTrace = strTrace & " in einen BildContainer:" & obElem.Parent.Parent.DynPictureContainer.Name

strTrace = strTrace & ", welches sich auf Bild:" & obElem.Parent.Parent.DynPictureContainer.Parent.Parent.Name & " mit InstanzId:" & obElem.Parent.Parent.DynPictureContainer.Parent.Parent.InstanceId & "befindet."

End If

MsgBox strTrace

Dim myPiccheck As DynPicture

Set myPiccheck = thisProject.DynPictures.ItemOnMonitor(obElem.Parent.Parent.Name, obElem.Parent.Parent.MonitorId)

Debug.Print myPiccheck.Name

End Sub

Public Sub GetScreens()

Dim myinstances As DynPictureInstances

Dim myDynPicture As DynPicture

Stop

Set myinstances = thisProject.DynPictures.Item("Bild 2").Instances

If (myinstances.Count > 0) Then

For i = 0 To myinstances.Count - 1

Set myDynPicture = myinstances.Item(i)

If (Not myDynPicture Is Nothing) Then

Debug.Print "instance:" & myDynPicture.Name & " " & myDynPicture.InstanceId

End If

Next

End If

End Sub

Other topics in this chapter

DynPictureInstances-Properties

DynPictureInstances-Methods


DynPictureInstances-Properties

Manual -> Programming interfaces -> Objectmodel -> DynPictureInstances -> DynPictureInstances-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | Count | Returns the amount of instances of the given DynPicture object. (RT-Only) | not used | read only | yes | yes

Other topics in this chapter

Count


Count

Manual -> Programming interfaces -> Objectmodel -> DynPictureInstances -> DynPictureInstances-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the amount of instances of the given DynPicture object. (RT-Only).

Datatype

Count() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


DynPictureInstances-Methods

Manual -> Programming interfaces -> Objectmodel -> DynPictureInstances -> DynPictureInstances-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
IDynPicture | Item | Returns instances at the given index. (RT-Only) | not used | read only | yes | yes

Other topics in this chapter

Item


Item

Manual -> Programming interfaces -> Objectmodel -> DynPictureInstances -> DynPictureInstances-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns instances at the given index. (RT-Only).

Datatype

Item(long lIndex) As IDynPicture

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA

Public Sub LeftClickUp_Default(obElem As Element)

Dim FacePlate As DynPicture

Dim DynPictureContainer As Element

Dim strTrace As String

strTrace = "Das Element befindet sich auf Bild:" & obElem.Parent.Parent.Name & " mit InstanzID:" & obElem.Parent.Parent.InstanceId

If Not obElem.Parent.Parent.DynPictureContainer Is Nothing Then

strTrace = strTrace & " in einen BildContainer:" & obElem.Parent.Parent.DynPictureContainer.Name

strTrace = strTrace & ", welches sich auf Bild:" & obElem.Parent.Parent.DynPictureContainer.Parent.Parent.Name & " mit InstanzId:" & obElem.Parent.Parent.DynPictureContainer.Parent.Parent.InstanceId & "befindet."

End If

MsgBox strTrace

Dim myPiccheck As DynPicture

Set myPiccheck = thisProject.DynPictures.ItemOnMonitor(obElem.Parent.Parent.Name, obElem.Parent.Parent.MonitorId)

Debug.Print myPiccheck.Name

End Sub

Public Sub GetScreens()

Dim myinstances As DynPictureInstances

Dim myDynPicture As DynPicture

Stop

Set myinstances = thisProject.DynPictures.Item("Bild 2").Instances

If (myinstances.Count > 0) Then

For i = 0 To myinstances.Count - 1

Set myDynPicture = myinstances.Item(i)

If (Not myDynPicture Is Nothing) Then

Debug.Print "instance:" & myDynPicture.Name & " " & myDynPicture.InstanceId

End If

Next

End If

End Sub


DynPictures

Manual -> Programming interfaces -> Objectmodel -> DynPictures

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This collection contains the defined Screens. The single Screens can contain different dynamic elements. Each Screen is linked to a Frame, that contains general information on the outer appearance.Screens always come from the current project – the global project is ignored, as Screens are not supported in global projects.The single Screens can be found in the collection by their unique name or by the index. Each Screen is identified by an unique name.

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub CreateScreen()
Dim zPIC As DynPicture
Const ScreenName As String = "Alarm-Screen"
Const TemplateName As String = "MAIN"
'check if Screen already exists...
Set zPIC = MyWorkspace.ActiveDocument.DynPictures.Item(ScreenName)
If zPIC Is Nothing Then
'create new Screen if not existing...
Set zPIC = MyWorkspace.ActiveDocument.DynPictures.Create(ScreenName, TemplateName, tpAML)
'set the backcolor and create Default MDI Elements
With zPIC
.BackColor = vbRed
.CreateMdiDefaultElements
End With
End If
End Sub

Sub ScreenList()
Dim i, n As Integer
Dim zProject As Project
Dim zPicture As DynPicture
'use this in VBA at zenOn Runtime...
'Set zProject = thisproject
'or use this in the zenOn Editor...
Set zProject = MyWorkspace.ActiveDocument
'run trough all screens of the project...
For i = 0 To zProject.DynPictures.Count - 1
Set zPicture = zProject.DynPictures.Item(i)
Debug.Print zPicture.Name
'get count of elements within the actual screen
Debug.Print zPicture.Elements.Count & " Elements in this Screen..."
Next i
End Sub

Other topics in this chapter

DynPictures-Properties

DynPictures-Methods

DynPictures-Events


DynPictures-Properties

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Returns count of the elements | read only | read only
IProject | Parent | The parent object of the current object | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


DynPictures-Methods

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
BSTR | AddMarker | Adds a marker into a screen | not used | available
IDynPicture | Create | Creates and returns a new Object | available | not used
VARIANT_BOOL | Delete | Deletes the objects from collection | available | not used
VARIANT_BOOL | DelMarker | Deletes a marker from a screen | not used | available
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | Import | Imports the selected XML file | available | not used
IDynPicture | Item | Returns a object at a position or by a specified key | available | available
IDynPicture | ItemOnMonitor | Returns a screen with given name on the given monitor.(RT-Only) | not used | available
VARIANT_BOOL | SetupTouchInertia | Setup inertia settings for multitouch manipulation | not used | available
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used
VARIANT | GetPointerInfo | For internal use only | not used | available
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used

Other topics in this chapter

Item

ItemOnMonitor

Create

Delete

Export

SingleExport

Import

SetupTouchInertia

AddMarker

DelMarker

GetPointerInfo


Item

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the object "DynPicture" from the collection, which is identified by the parameter vID.The parameter vID can have two values:<ul><li>Index: Access with an index mostly is used in combination with the property Count to find out the position of the variable object in the list.</li><li>Picture name: The picture can also be accessed with its unique name.</li></ul>Hint:The returned object should always be checked on Nothing, in case no object was found for the search criteria.

Datatype

Item(VARIANT vDynPictureID) As DynPicture

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ItemOnMonitor

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Methods -> ItemOnMonitor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ItemOnMonitor(String bsSName, short MonitorId) As DynPicture

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Create

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Methods -> Create

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Create(String bsName,String bsTemplate,tpDynPicturesTypes tpType) As DynPicture

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Delete

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Methods -> Delete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deletes the corresponding "DynPicture" object from the collection by its unique name.

Datatype

Delete(String bsName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Export

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export settings to an xml file

Datatype

Export(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SingleExport

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Methods -> SingleExport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SingleExport(VARIANT vIndexOrName,BSTR bsFileName) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Import

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced. Note: One xml file may contain more than one picture.

Datatype

Import(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to import.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


SetupTouchInertia

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Methods -> SetupTouchInertia

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SetupTouchInertia(FLOAT Deceleration, FLOAT AngularDeceleration, FLOAT ExpansionDeceleration) As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


AddMarker

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Methods -> AddMarker

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Adds a marker into the screen. The GUID of the marker, which is provided by the AddMarker(), is the explicit id as well as the element name, with the following prefix: $MARKER_.

It is also used as key to delete the marker using: DelMarker(). Those markers that are inserted using the API are stored imaged-based in the project. This is non-retentive beyond Runtime restart. The markers are handled internally as a normal picture elements, therefore mouse events are called. Siehe auch: Konfiguration der Bildmarker

Datatype

AddMarker(String bsScreenName, long nElementID, short nPosition, short nLineColorIndex, short nFillColorIndex) As String

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

String bsScreenName

long nElementID

short nPosition

short nLineColorIndex

short nFillColorIndex

VB.NET

Dim bsScreenName As [String]

Dim nElementID As Long

Dim nPosition As Short

Dim nLineColorIndex As Short

Dim nFillColorIndex As Short

VBA

VBA-Syntax

Examples

C#

/* Use only for Runtime, that means use the VSTA/VBA editor for the activated project to create your macro.

* This example will place a marker on a line element.

*/

public void Macro_AddMarker()

{

//Get the screen with your elements, in this case: line, button and a numeric value

zenOn.IDynPicture screen = this.DynPictures().Item("Screen 0");

//Get the line element from the screen

zenOn.IElement lineElement = screen.Elements().Item("Line_3");

//To add the marker we have to assign following properties:

//- the screen with the according element

//- the element ID

//- the position of the marker on the line, in this case 20% of the total lenght.

//- the color index of the border line

//- the color index of the filling

//the color index can be defined in the editor under: Project properties->ALC->ALC configuration.

//this will open a dialog, choose the Screen marker TAB and define your colors. Use the corresponding

//index 0... for your properties.

this.DynPictures().AddMarker("Screen 0", lineElement.ID, 20, 1, 2);

}

VB.NET

Use only for Runtime, that means use the VSTA/VBA editor for the activated project to create your macro.

This example will place a marker on a line element.

Public Sub Macro_AddMarker()

//Get the screen with your elements, in this case: line, button and a numeric value

Dim screen As zenOn.IDynPicture = Me.DynPictures().Item("Screen 0")

//Get the line element from the screen

Dim lineElement As zenOn.IElement = screen.Elements().Item("Line_3")

//To add the marker we have to assign following properties:

//- the screen with the according element

//- the element ID

//- the position of the marker on the line, in this case 20% of the total lenght.

//- the color index of the border line

//- the color index of the filling

//the color index can be defined in the editor under: Project properties->ALC->ALC configuration.

//this will open a dialog, choose the Screen marker TAB and define your colors. Use the corresponding

//index 0... for your properties.

Me.DynPictures().AddMarker("Screen 0", lineElement.ID, 20, 1, 2)

End Sub

VBA

VBA-Syntax


DelMarker

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Methods -> DelMarker

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deletes a marker from a screen. The ID is provided by the AddMarker().

Datatype

DelMarker(String bsID) As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

string bsID

VB.NET

Dim bsID As String

VBA

VBA-Syntax

Examples

C#

/* Use only for Runtime, that means use the VSTA/VBA editor for the activated project to create your macro.

* This example will first place a marker on a line element and then delete it.

* using the specific ID of the marker.

*/

public void Macro_DelMarker()

{

//Get the screen with your elements, in this case: line, button and a numeric value

zenOn.IDynPicture screen = this.DynPictures().Item("Screen 0");

//Get the line element from the screen

zenOn.IElement lineElement = screen.Elements().Item("Line_3");

//The return value from the AddMarker() is the specific ID of this marker.

string markerId = this.DynPictures().AddMarker("Screen 0", lineElement.ID, 20, 1, 2);

//To delelete this marker we have to assign the specific ID

bool isDeleted = this.DynPictures().DelMarker(markerId);

//Use the return value to check if the marker was deleted

if (isDeleted == true) MessageBox.Show("Marker: " + markerId + " deleted!");

}

VB.NET

// Use only for Runtime, that means use the VSTA/VBA editor for the activated project to create your macro.

//This example will first place a marker on a line element and then delete it.

//using the specific ID of the marker.

Public Sub Macro_DelMarker()

//Get the screen with your elements, in this case: line, button and a numeric value

Dim screen As zenOn.IDynPicture = Me.DynPictures().Item("Screen 0")

//Get the line element from the screen

Dim lineElement As zenOn.IElement = screen.Elements().Item("Line_3")

//The return value from the AddMarker() is the specific ID of this marker.

Dim markerId As String = Me.DynPictures().AddMarker("Screen 0", lineElement.ID, 20, 1, 2)

//To delelete this marker we have to assign the specific ID

Dim isDeleted As Boolean = Me.DynPictures().DelMarker(markerId)

//Use the return value to check if the marker was deleted

If isDeleted = True Then

MessageBox.Show("Marker: " & markerId & " deleted!")

End If

End Sub

VBA

VBA-Syntax


GetPointerInfo

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Methods -> GetPointerInfo

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets the information for the specified pointer associated with the current message.

//Layout of the pointer_info structure

typedef struct tagPOINTER_INFO {

POINTER_INPUT_TYPE pointerType;

UINT32 pointerId;

UINT32 frameId;

POINTER_FLAGS pointerFlags;

HANDLE sourceDevice;

HWND hwndTarget;

POINT ptPixelLocation;

POINT ptHimetricLocation;

POINT ptPixelLocationRaw;

POINT ptHimetricLocationRaw;

DWORD dwTime;

UINT32 historyCount;

INT32 inputData;

DWORD dwKeyStates;

UINT64 PerformanceCount;

POINTER_BUTTON_CHANGE_TYPE ButtonChangeType;

} POINTER_INFO;

See also: GetPointerInfo (msdn)

Datatype

GetPointerInfo(VARIANT vPointerId) As VARIANT

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | No
VSTA | yes

Parameters

C#

IDynPicture obDynPicture

object vPointerId

VB.NET

obDynPicture As IDynPicture

vPointerId As Object

Examples

C#

/// <summary>

/// Helper function that takes a screen and a pointer ID and writes information about the pointer into the CEL

/// </summary>

/// <param name="obDynPicture">the zenon screen</param>

/// <param name="vPointerId">the pointer object</param>

private void GetPointerInfo(zenOn.IDynPicture obDynPicture, object vPointerId)

{

//get method name and print in CEL

string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);

Cel().WriteCelString(CelString);

//get pointer infos

try

{

//cast this on an object array

object[] PointerInfo = (object[])DynPics.GetPointerInfo(vPointerId);

//iterate through all

for (int i = 0; i < PointerInfo.Length; i++)

{

//if the type of the object is an array, we suppose it is the POINT type - which has definition for x and y position

if (PointerInfo[i] is System.Object[])

{

//to get the information, we have to cast it first to object[] because the compiler would not accept the index otherwise and convert it to a string then

Cel().WriteCelString(Pointer_Info_Definition[i] + " for x has value " + Convert.ToString(((object[])(PointerInfo[i]))[0]));

Cel().WriteCelString(Pointer_Info_Definition[i] + " for y has value " + Convert.ToString(((object[])(PointerInfo[i]))[1]));

}

else

{

//if it's not object[], simply cast it to string and write an CEL entry

switch (i)

{

case 0:

PointerType pt = (PointerType)(Convert.ToUInt32(PointerInfo[i]));

Cel().WriteCelString("PointerType: " + pt.ToString());

break;

case 3:

PointerFlags pf = (PointerFlags)(Convert.ToUInt32(PointerInfo[i]));

Cel().WriteCelString("PointerFlags: " + pf.ToString());

break;

default:

Cel().WriteCelString(Pointer_Info_Definition[i] + " has value " + PointerInfo[i].ToString());

break;

}

}

}

}

catch (Exception ex)

{

Cel().WriteCelString("Can't get PointerInfo: " + ex.Message);

}

}

VB.NET

/// <summary>

/// Helper function that takes a screen and a pointer ID and writes information about the pointer into the CEL

/// </summary>

/// <param name="obDynPicture">the zenon screen</param>

/// <param name="vPointerId">the pointer object</param>

Private Sub GetPointerInfo(obDynPicture As zenOn.IDynPicture, vPointerId As Object)

'get method name and print in CEL

Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)

Cel().WriteCelString(CelString)

'get pointer infos

Try

'cast this on an object array

Dim PointerInfo As Object() = DirectCast(DynPics.GetPointerInfo(vPointerId), Object())

'iterate through all

For i As Integer = 0 To PointerInfo.Length - 1

'if the type of the object is an array, we suppose it is the POINT type - which has definition for x and y position

If TypeOf PointerInfo(i) Is System.Object() Then

'to get the information, we have to cast it first to object[] because the compiler would not accept the index otherwise and convert it to a string then

Cel().WriteCelString(Pointer_Info_Definition(i) + " for x has value " & Convert.ToString(DirectCast(PointerInfo(i), Object())(0)))

Cel().WriteCelString(Pointer_Info_Definition(i) + " for y has value " & Convert.ToString(DirectCast(PointerInfo(i), Object())(1)))

Else

'if it's not object[], simply cast it to string and write an CEL entry

Select Case i

Case 0

Dim pt As PointerType = DirectCast(Convert.ToUInt32(PointerInfo(i)), PointerType)

Cel().WriteCelString("PointerType: " & pt.ToString())

Exit Select

Case 3

Dim pf As PointerFlags = DirectCast(Convert.ToUInt32(PointerInfo(i)), PointerFlags)

Cel().WriteCelString("PointerFlags: " & pf.ToString())

Exit Select

Case Else

Cel().WriteCelString(Pointer_Info_Definition(i) + " has value " & PointerInfo(i).ToString())

Exit Select

End Select

End If

Next

Catch ex As Exception

Cel().WriteCelString("Can't get PointerInfo: " + ex.Message)

End Try

End Sub


DynPictures-Events

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description |  | Editor | Runtime
void | Close | Event is fired when a screen is closed. |  | not used | available
void | ElementInit | Event is fired when an element is initialized.(RT-Only) |  | not used | available
void | ElementLeftButtonDblClick | Event is fired when an element is double clicked with the left mouse button.(RT-Only) |  | not used | available
void | ElementLeftButtonDown | Event is fired when the left mouse button is pushed down on an element.(RT-Only) |  | not used | available
void | ElementLeftButtonUp | Event is fired when the right mouse button is released on an element.(RT-Only) |  | not used | available
void | ElementMouseOver | Event is fired when the mouse is moved over an element.(RT-Only) |  | not used | available
void | ElementRightButtonDblClk | Event is fired when an element is double clicked with the right mouse button.(RT-Only) |  | not used | available
void | ElementRightButtonDown | Event is fired when the right mouse button is pushed down on an element.(RT-Only) |  | not used | available
void | ElementRightButtonUp | Event is fired when the right mouse button is released on an element.(RT-Only) |  | not used | available
void | Open | Event is fired when a screen is opened. |  | not used | available
void | TouchEvent | Event is fired for all touch events.(RT-Only) |  | not used | available
void | TouchManipulationCompleteEvent | Event is fired when a touch manipulation ends.(RT-Only) |  | not used | available
void | TouchManipulationDeltaEvent | Event is fired when a touch manipulation is in progress.(RT-Only) |  | not used | available
void | TouchManipulationStartEvent | Event is fired when a touch manipulation starts.(RT-Only) |  | not used | available
void | WindowPosChanged | Event is fired when a screen is moved or resized.(RT-Only) |  | not used | available
void | ElementGesture | For internal use only | not used |  | available
void | NCPointerDown | For internal use only | not used |  | available
void | NCPointerUp | For internal use only | not used |  | available
void | NCPointerUpdate | For internal use only | not used |  | available
void | PictureGesture | For internal use only | not used |  | available
void | PointerActivate | For internal use only | not used |  | available
void | PointerCaptureChanged | For internal use only | not used |  | available
void | PointerDeviceChange | For internal use only | not used |  | available
void | PointerDeviceInRange | For internal use only | not used |  | available
void | PointerDeviceOutOfRange | For internal use only | not used |  | available
void | PointerDown | Posted when a pointer makes contact over the client area of a screen. |  | not used | available
void | PointerEnter | Sent to a screen when a pointer moves into the boundaries of the screen. |  | not used | available
void | PointerHWheel | Posted to the screen with foreground keyboard focus when a horizontal scroll wheel is rotated. |  | not used | available
void | PointerLeave | Sent to a screen when a pointer moves out of the boundaries of the screen. |  | not used | available
void | PointerUp | Posted when a pointer that made contact over the client area of a screen breaks contact. |  | not used | available
void | PointerUpdate | Posted to provide an update on a pointer that made contact over the client area of a screen or on a hovering uncaptured pointer over the client area of a screen. |  | not used | available
void | PointerWheel | Posted to the screen with foreground keyboard focus when a scroll wheel is rotated. |  | not used | available
void | PointerDown | For internal use only | not used |  | available
void | PointerEnter | For internal use only | not used |  | available
void | PointerLeave | For internal use only | not used |  | available
void | PointerUp | For internal use only | not used |  | available
void | PointerUpdate | For internal use only | not used |  | available
void | PointerWheel | For internal use only | not used |  | available
void | PointerHWheel | For internal use only | not used |  | available

Other topics in this chapter

TouchEvent

TouchManipulationStartEvent

TouchManipulationDeltaEvent

TouchManipulationCompleteEvent

Open

Close

WindowPosChanged

ElementInit

ElementRightButtonDblClk

ElementRightButtonDown

ElementRightButtonUp

ElementLeftButtonDblClick

ElementLeftButtonDown

ElementLeftButtonUp

ElementMouseOver

PictureGesture

ElementGesture

PointerDown

PointerEnter

PointerLeave

PointerUp

PointerUpdate

PointerWheel

PointerHWheel

NCPointerDown

NCPointerUp

NCPointerUpdate

PointerActivate

PointerCaptureChanged


TouchEvent

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> TouchEvent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

TouchEvent(SAFEARRAY(long) pvX, SAFEARRAY(long) pvY, SAFEARRAY(OLE_HANDLE) pvSource, SAFEARRAY(long) pvID, SAFEARRAY(long) pvFlags, SAFEARRAY(long) pvMask, SAFEARRAY(long) pvTime, SAFEARRAY(long) pvExtraInfo, SAFEARRAY(long) pvXContact, SAFEARRAY(long) pvYContact) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


TouchManipulationStartEvent

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> TouchManipulationStartEvent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

TouchManipulationStartEvent(long lX, long lY) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


TouchManipulationDeltaEvent

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> TouchManipulationDeltaEvent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is triggered regularly when executing an action. The parameter indicate the changes since the last delta event and/or the start event.

lX: X-Koordinate in Pixel

lY: Y-Koordinate in Pixel

lTransX: Translation X-Achse in Pixel

lTransY: Translation Y-Ache in Pixel

fScaleFactor: Skalierungsfaktor (1=100%)

fRotation: Rotation in Radianten

bInertia: Gibt an ob der Event durch den Trägheitsprozessor oder die Geste selbst verursacht wurde

Datatype

TouchManipulationDeltaEvent(long lX, long lY, long lTransX, long lTransY, FLOAT fScaleFactor, FLOAT fRotation, long lContacts) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

If Not obDynPictures.SetupTouchInertia(0, 0, 0) Then

Debug.Print "Error setting up inertia"

End If

Private Sub obDynPictures_TouchManipulationStartEvent(ByVal lX As Long, ByVal lY As Long)

End Sub

Private Sub obDynPictures_TouchManipulationDeltaEvent(ByVal lX As Long, ByVal lY As Long, ByVal lTransX As Long, ByVal lTransY As Long, ByVal fScaleFactor As Single, ByVal fRotation As Single, ByVal bInertia As Boolean)

End Sub

Private Sub obDynPictures_TouchManipulationCompleteEvent(ByVal lX As Long, ByVal lY As Long, ByVal lTransX As Long, ByVal lTransY As Long, ByVal fScaleFactor As Single, ByVal fRotation As Single, ByVal bInertia As Boolean)

End Sub


TouchManipulationCompleteEvent

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> TouchManipulationCompleteEvent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is triggered when ending an action. The parameter indicate the changes since the start of the action.

If the idle processor is active, the event is triggered two times.

When the action ends (bInertia = FALSE), the parameter indicate the changes since the start of the action.

After the idle calculation (bInertia = TRUE), the parameter indicate the changes since the start of the idle calculation. (since the end of the action)

lX: X-Koordinate in Pixel

lY: Y-Koordinate in Pixel

lTransX: Translation X-Achse in Pixel

lTransY: Translation Y-Ache in Pixel

fScaleFactor: Skalierungsfaktor (1=100%)

fRotation: Rotation in Radianten

bInertia: Gibt an ob der Event durch den Trägheitsprozessor oder die Geste selbst verursacht wurde

Datatype

TouchManipulationCompleteEvent(long lX, long lY, long lTransX, long lTransY, FLOAT fScaleFactor, FLOAT fRotation, long lContacts) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

If Not obDynPictures.SetupTouchInertia(0, 0, 0) Then

Debug.Print "Error setting up inertia"

End If

Private Sub obDynPictures_TouchManipulationStartEvent(ByVal lX As Long, ByVal lY As Long)

End Sub

Private Sub obDynPictures_TouchManipulationDeltaEvent(ByVal lX As Long, ByVal lY As Long, ByVal lTransX As Long, ByVal lTransY As Long, ByVal fScaleFactor As Single, ByVal fRotation As Single, ByVal bInertia As Boolean)

End Sub

Private Sub obDynPictures_TouchManipulationCompleteEvent(ByVal lX As Long, ByVal lY As Long, ByVal lTransX As Long, ByVal lTransY As Long, ByVal fScaleFactor As Single, ByVal fRotation As Single, ByVal bInertia As Boolean)

End Sub


Open

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> Open

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Open(DynPicture obDynPicture) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Close

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> Close

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Close(DynPicture obDynPicture) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


WindowPosChanged

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> WindowPosChanged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

WindowPosChanged(DynPicture obDynPicture) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ElementInit

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> ElementInit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ElementInit(Element obElement) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'Declaration of DynPictures, in order to use it with events
Dim WithEvents zDynPictures As DynPictures

Private Sub Project_Active()
'Reference to the zenon Project DynPictures
Set zDynPictures = thisProject.DynPictures
End Sub

'This event is triggered when an element is initialized
Private Sub zDynPictures_ElementInit(ByVal obElement As IElement)
Debug.Print ("Element name: " & obElement.Name)
End Sub


ElementRightButtonDblClk

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> ElementRightButtonDblClk

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ElementRightButtonDblClk(DynPicture obDynPicture, IElement obElement, long lPosX, long lPosY, long lButton) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ElementRightButtonDown

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> ElementRightButtonDown

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ElementRightButtonDown(DynPicture obDynPicture, IElement obElement, long lPosX, long lPosY, long lButton) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ElementRightButtonUp

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> ElementRightButtonUp

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ElementRightButtonUp(DynPicture obDynPicture, IElement obElement, long lPosX, long lPosY, long lButton) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ElementLeftButtonDblClick

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> ElementLeftButtonDblClick

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ElementLeftButtonDblClick(DynPicture obDynPicture, IElement obElement, long lPosX, long lPosY, long lButton) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ElementLeftButtonDown

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> ElementLeftButtonDown

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ElementLeftButtonDown(DynPicture obDynPicture, IElement obElement, long lPosX, long lPosY, long lButton) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ElementLeftButtonUp

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> ElementLeftButtonUp

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ElementLeftButtonUp(DynPicture obDynPicture, IElement obElement, long lPosX, long lPosY, long lButton) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ElementMouseOver

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> ElementMouseOver

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ElementMouseOver(DynPicture obDynPicture, IElement obElement, long lPosX, long lPosY, long lButton) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PictureGesture

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> PictureGesture

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Defines the output of the Interaction Context object. See also:

INTERACTION_CONTEXT_OUTPUT

interaction_context_output (msdn)

Datatype

PictureGesture(IDynPicture* obDynPicture, VARIANT interactionContextOutput) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | No
VSTA | yes

Parameters

C#

IDynPicture obDynPicture

object interactionContextOutput

VB.NET

obDynPicture As IDynPicture

interactionContextOutput As Object

Examples

C#

/// <summary>

/// event handler for the PictureGesture event

/// </summary>

/// <param name="obDynPicture">screen on which the event occured</param>

/// <param name="interactionContextOutput">object that contains the information about the gesture</param>

void DynPics_PictureGesture(zenOn.IDynPicture obDynPicture, object interactionContextOutput)

{

CELMakeSeperator();

string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);

Cel().WriteCelString(CelString);

WriteInteractionContextOutputToCEL(interactionContextOutput);

}

VB.NET

/// <summary>

/// event handler for the PictureGesture event

/// </summary>

/// <param name="obDynPicture">screen on which the event occured</param>

/// <param name="interactionContextOutput">object that contains the information about the gesture</param>

Private Sub DynPics_PictureGesture(obDynPicture As zenOn.IDynPicture, interactionContextOutput As Object)

CELMakeSeperator()

Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)

Cel().WriteCelString(CelString)

WriteInteractionContextOutputToCEL(interactionContextOutput)

End Sub


ElementGesture

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> ElementGesture

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Defines the output of the Interaction Context object. See also: interaction_context_output (msdn)

Datatype

ElementGesture(IElement* obElement, VARIANT interactionContextOutput) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | No
VSTA | yes

Parameters

C#

IElement obElement

object interactionContextOutput

VB.NET

obElement As IElement

interactionContextOutput As Object

Examples

C#

/// <summary>

/// event handler for the ElementGesture event

/// </summary>

/// <param name="obElement">element on which the event occured</param>

/// <param name="interactionContextOutput">object that contains the information about the gesture</param>

void DynPics_ElementGesture(zenOn.IElement obElement, object interactionContextOutput)

{

CELMakeSeperator();

string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obElement.Name);

Cel().WriteCelString(CelString);

WriteInteractionContextOutputToCEL(interactionContextOutput);

}

VB.NET

/// <summary>

/// event handler for the ElementGesture event

/// </summary>

/// <param name="obElement">element on which the event occured</param>

/// <param name="interactionContextOutput">object that contains the information about the gesture</param>

Private Sub DynPics_ElementGesture(obElement As zenOn.IElement, interactionContextOutput As Object)

CELMakeSeperator()

Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obElement.Name)

Cel().WriteCelString(CelString)

WriteInteractionContextOutputToCEL(interactionContextOutput)

End Sub


PointerDown

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> PointerDown

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Posted when a pointer makes contact over the client area of a window. This input message targets the window over which the pointer makes contact, and the pointer is implicitly captured to the window so that the window continues to receive input for the pointer until it breaks contact.

Datatype

PointerDown (IDynPicture* obDynPicture, IElement* obElement, VARIANT vPointerId, VARIANT_BOOL bNew, VARIANT_BOOL bInRange, VARIANT_BOOL bInContact, VARIANT_BOOL bPrimary, VARIANT_BOOL bFirstButton, VARIANT_BOOL bSecondButton, VARIANT_BOOL bThirdButton, VARIANT_BOOL bFourthButton, VARIANT_BOOL bFifthButton, long lX, long lY) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | No
VSTA | yes

Parameters

C#

IDynPicture obDynPicture

IElement obElement

object vPointerId

bool bNew

bool bInRange

bool bInContact

bool bPrimary

bool bFirstButton

bool bSecondButton

bool bThirdButton

bool bFourthButton

bool bFifthButton

int lX

int lY

VB.NET

obDynPicture As IDynPicture

obElement As IElement

vPointerId As Object

bNew As Boolean

bInRange As Boolean

bInContact As Boolean

bPrimary As Boolean

bFirstButton As Boolean

bSecondButton As Boolean

bThirdButton As Boolean

bFourthButton As Boolean

bFifthButton As Boolean

lX As Integer

lY As Integer

Examples

C#

void DynPics_PointerDown(zenOn.IDynPicture obDynPicture, zenOn.IElement obElement, object vPointerId, bool bNew, bool bInRange, bool bInContact, bool bPrimary, bool bFirstButton, bool bSecondButton, bool bThirdButton, bool bFourthButton, bool bFifthButton, int lX, int lY)

{

string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);

string ButtonMatrix = "";

ButtonMatrix += (bFirstButton == true) ? "[1]" : "[x]";

ButtonMatrix += (bSecondButton == true) ? "[2]" : "[x]";

ButtonMatrix += (bThirdButton == true) ? "[3]" : "[x]";

ButtonMatrix += (bFourthButton == true) ? "[4]" : "[x]";

ButtonMatrix += (bFifthButton == true) ? "[5]" : "[x]";

CelString += string.Format("pointer-id: {0}, is-new: {1}, is-in-range: {2}, is-in-contact: {3}, is-primary: {4}, buttons: {5}, [X, Y]: {6},{7}", Convert.ToString(vPointerId), bNew, bInRange, bInContact, bPrimary, ButtonMatrix, lX, lY);

Cel().WriteCelString(CelString);

}

VB.NET

Private Sub DynPics_PointerDown(obDynPicture As zenOn.IDynPicture, obElement As zenOn.IElement, vPointerId As Object, bNew As Boolean, bInRange As Boolean, bInContact As Boolean, _

bPrimary As Boolean, bFirstButton As Boolean, bSecondButton As Boolean, bThirdButton As Boolean, bFourthButton As Boolean, bFifthButton As Boolean, _

lX As Integer, lY As Integer)

Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)

Dim ButtonMatrix As String = ""

ButtonMatrix += If((bFirstButton = True), "[1]", "[x]")

ButtonMatrix += If((bSecondButton = True), "[2]", "[x]")

ButtonMatrix += If((bThirdButton = True), "[3]", "[x]")

ButtonMatrix += If((bFourthButton = True), "[4]", "[x]")

ButtonMatrix += If((bFifthButton = True), "[5]", "[x]")

CelString += String.Format("pointer-id: {0}, is-new: {1}, is-in-range: {2}, is-in-contact: {3}, is-primary: {4}, buttons: {5}, [X, Y]: {6},{7}", Convert.ToString(vPointerId), bNew, bInRange, bInContact, bPrimary, _

ButtonMatrix, lX, lY)

Cel().WriteCelString(CelString)

End Sub


PointerEnter

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> PointerEnter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Sent to a window when a new pointer enters detection range over the window (hover) or when an existing pointer moves within the boundaries of the window.

The PointerEnter notification can be used by a window to provide feedback to the user while the pointer is over its surface or to otherwise react to the presence of a pointer over its surface.

Datatype

PointerEnter (IDynPicture* obDynPicture, IElement* obElement, VARIANT vPointerId, VARIANT_BOOL bNew, VARIANT_BOOL bInRange, VARIANT_BOOL bInContact) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | No
VSTA | yes

Parameters

C#

IDynPicture obDynPicture

IElement obElement

object vPointerId

bool bNew

bool bInRange

bool bInContact

VB.NET

obDynPicture As IDynPicture

obElement As IElement

vPointerId As Object

bNew As Boolean

bInRange As Boolean

bInContact As Boolean

Examples

C#

void DynPics_PointerEnter(zenOn.IDynPicture obDynPicture, zenOn.IElement obElement, object vPointerId, bool bNew, bool bInRange, bool bInContact)

{

string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);

if (obElement != null)

{

CelString += string.Format("on element {0}, ", obElement.Name);

}

CelString += string.Format("pointer-id: {0}, is-new: {1}, is-in-range: {2}, is-in-contact: {3}", Convert.ToString(vPointerId), bNew, bInRange, bInContact);

Cel().WriteCelString(CelString);

}

VB.NET

Private Sub DynPics_PointerEnter(obDynPicture As zenOn.IDynPicture, obElement As zenOn.IElement, vPointerId As Object, bNew As Boolean, bInRange As Boolean, bInContact As Boolean)

Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)

If obElement IsNot Nothing Then

CelString += String.Format("on element {0}, ", obElement.Name)

End If

CelString += String.Format("pointer-id: {0}, is-new: {1}, is-in-range: {2}, is-in-contact: {3}", Convert.ToString(vPointerId), bNew, bInRange, bInContact)

Cel().WriteCelString(CelString)

End Sub


PointerLeave

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> PointerLeave

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Sent to a window when a pointer leaves detection range over the window (hover) or when a pointer moves outside the boundaries of the window.

The PointerLeave notification can be used by a window to change mode or stop any feedback to the user while the pointer is over the window surface.

Datatype

PointerLeave (IDynPicture* obDynPicture, IElement* obElement, VARIANT vPointerId, VARIANT_BOOL bInRange, VARIANT_BOOL bInContact) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | No
VSTA | yes

Parameters

C#

IDynPicture obDynPicture

IElement obElement

object vPointerId

bool bInRange

bool bInContact

VB.NET

Dim obDynPicture As IDynPicture

Dim obElement As IElement

Dim vPointerId As Object

Dim bInRange As Boolean

Dim bInContact As Boolean

Examples

C#

void DynPics_PointerLeave(zenOn.IDynPicture obDynPicture, zenOn.IElement obElement, object vPointerId, bool bInRange, bool bInContact)

{

string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);

CelString += string.Format("pointer-id: {0}, is-in-range: {1}, is-in-contact: {2}", Convert.ToString(vPointerId), bInRange, bInContact);

Cel().WriteCelString(CelString);

}

VB.NET

Private Sub DynPics_PointerLeave(obDynPicture As zenOn.IDynPicture, obElement As zenOn.IElement, vPointerId As Object, bInRange As Boolean, bInContact As Boolean)

Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)

CelString += String.Format("pointer-id: {0}, is-in-range: {1}, is-in-contact: {2}", Convert.ToString(vPointerId), bInRange, bInContact)

Cel().WriteCelString(CelString)

End Sub


PointerUp

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> PointerUp

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Posted when a pointer that made contact over the client area of a window breaks contact. This input message targets the window over which the pointer makes contact and the pointer is, at that point, implicitly captured to the window so that the window continues to receive input messages including the PointerUp notification for the pointer until it breaks contact.

Important:

When a window loses capture of a pointer and it receives the PointerCaptureChanged notification, it typically will not receive any further notifications. For this reason, it is important that you not make any assumptions based on evenly paired PointerDown/PointerUp or PointerEnter/PointerLeave notifications.

Datatype

PointerUp (IDynPicture* obDynPicture, IElement* obElement, VARIANT vPointerId, VARIANT_BOOL bIsCanceled, VARIANT_BOOL bInRange, VARIANT_BOOL bInContact, VARIANT_BOOL bPrimary, VARIANT_BOOL bFirstButton, VARIANT_BOOL bSecondButton, VARIANT_BOOL bThirdButton, VARIANT_BOOL bFourthButton, VARIANT_BOOL bFifthButton, long lX, long lY) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | No
VSTA | yes

Parameters

C#

IDynPicture obDynPictureI

Element obElement

object vPointerId

bool bIsCanceled

bool bInRange

bool bInContact

bool bPrimary

bool bFirstButton

bool bSecondButton

bool bThirdButton

bool bFourthButton

bool bFifthButton

int lX

int lY

VB.NET

Dim obDynPictureI As IDynPicture

Dim obElement As Element

Dim vPointerId As Object

Dim bIsCanceled As Boolean

Dim bInRange As Boolean

Dim bInContact As Boolean

Dim bPrimary As Boolean

Dim bFirstButton As Boolean

Dim bSecondButton As Boolean

Dim bThirdButton As Boolean

Dim bFourthButton As Boolean

Dim bFifthButton As Boolean

Dim lX As Integer

Dim lY As Integer

Examples

C#

void DynPics_PointerUp(zenOn.IDynPicture obDynPicture, zenOn.IElement obElement, object vPointerId, bool bIsCanceled, bool bInRange, bool bInContact, bool bPrimary, bool bFirstButton, bool bSecondButton, bool bThirdButton, bool bFourthButton, bool bFifthButton, int lX, int lY)

{

string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);

string ButtonMatrix = "";

ButtonMatrix += (bFirstButton == true) ? "[1]" : "[x]";

ButtonMatrix += (bSecondButton == true) ? "[2]" : "[x]";

ButtonMatrix += (bThirdButton == true) ? "[3]" : "[x]";

ButtonMatrix += (bFourthButton == true) ? "[4]" : "[x]";

ButtonMatrix += (bFifthButton == true) ? "[5]" : "[x]";

CelString += string.Format("pointer-id: {0}, is-canceled: {1}, is-in-range: {2}, is-in-contact: {3}, is-primary: {4}, buttons: {5}, [X, Y]: {6},{7}", Convert.ToString(vPointerId), bIsCanceled, bInRange, bInContact, bPrimary, ButtonMatrix, lX, lY);

Cel().WriteCelString(CelString);

}

VB.NET

Private Sub DynPics_PointerUp(obDynPicture As zenOn.IDynPicture, obElement As zenOn.IElement, vPointerId As Object, bIsCanceled As Boolean, bInRange As Boolean, bInContact As Boolean, _

bPrimary As Boolean, bFirstButton As Boolean, bSecondButton As Boolean, bThirdButton As Boolean, bFourthButton As Boolean, bFifthButton As Boolean, _

lX As Integer, lY As Integer)

Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)

Dim ButtonMatrix As String = ""

ButtonMatrix += If((bFirstButton = True), "[1]", "[x]")

ButtonMatrix += If((bSecondButton = True), "[2]", "[x]")

ButtonMatrix += If((bThirdButton = True), "[3]", "[x]")

ButtonMatrix += If((bFourthButton = True), "[4]", "[x]")

ButtonMatrix += If((bFifthButton = True), "[5]", "[x]")

CelString += String.Format("pointer-id: {0}, is-canceled: {1}, is-in-range: {2}, is-in-contact: {3}, is-primary: {4}, buttons: {5}, [X, Y]: {6},{7}", Convert.ToString(vPointerId), bIsCanceled, bInRange, bInContact, bPrimary, _

ButtonMatrix, lX, lY)

Cel().WriteCelString(CelString)

End Sub


PointerUpdate

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> PointerUpdate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Posted to provide an update on a pointer that made contact over the non-client area of a window or when a hovering uncaptured contact moves over the non-client area of a window. While the pointer is hovering, the message targets whichever window the pointer happens to be over. While the pointer is in contact with the surface, the pointer is implicitly captured to the window over which the pointer made contact and that window continues to receive input for the pointer until it breaks contact.

If a window has captured this pointer, this message is not posted. Instead, a PointerUpdate is posted to the window that has captured this pointer.

Each pointer has a unique pointer identifier during its lifetime. The lifetime of a pointer begins when it is first detected.

A PointerEnter message is generated if a hovering pointer is detected. A PointerDown message followed by a PointerEnter message is generated if a non-hovering pointer is detected.

During its lifetime, a pointer may generate a series of PointerUpdate messages while it is hovering or in contact.

The lifetime of a pointer ends when it is no longer detected. This generates a PointerLeave message.

When a pointer is aborted, POINTER_FLAG_CANCELED is set.

A PointerLeave message may also be generated when a non-captured pointer moves outside the bounds of a window.

Datatype

PointerUpdate (IDynPicture* obDynPicture, IElement* obElement, VARIANT vPointerId, VARIANT_BOOL bNew, VARIANT_BOOL bInRange, VARIANT_BOOL bInContact, VARIANT_BOOL bPrimary, VARIANT_BOOL bFirstButton, VARIANT_BOOL bSecondButton, VARIANT_BOOL bThirdButton, VARIANT_BOOL bFourthButton, VARIANT_BOOL bFifthButton, long lX, long lY) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | No
VSTA | yes

Parameters

C#

IDynPicture obDynPicture

IElement obElement

object vPointerId

bool bNew

bool bInRange

bool bInContact

bool bPrimary

bool bFirstButton

bool bSecondButton

bool bThirdButton

bool bFourthButton

bool bFifthButton

int lX

int lY

VB.NET

Dim obDynPicture As IDynPicture

Dim obElement As IElement

Dim vPointerId As Object

Dim bNew As Boolean

Dim bInRange As Boolean

Dim bInContact As Boolean

Dim bPrimary As Boolean

Dim bFirstButton As Boolean

Dim bSecondButton As Boolean

Dim bThirdButton As Boolean

Dim bFourthButton As Boolean

Dim bFifthButton As Boolean

Dim lX As Integer

Dim lY As Integer

Examples

C#

void DynPics_PointerUpdate(zenOn.IDynPicture obDynPicture, zenOn.IElement obElement, object vPointerId, bool bNew, bool bInRange, bool bInContact, bool bPrimary, bool bFirstButton, bool bSecondButton, bool bThirdButton, bool bFourthButton, bool bFifthButton, int lX, int lY)

{

string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);

string ButtonMatrix = "";

ButtonMatrix += (bFirstButton == true) ? "[1]" : "[x]";

ButtonMatrix += (bSecondButton == true) ? "[2]" : "[x]";

ButtonMatrix += (bThirdButton == true) ? "[3]" : "[x]";

ButtonMatrix += (bFourthButton == true) ? "[4]" : "[x]";

ButtonMatrix += (bFifthButton == true) ? "[5]" : "[x]";

CelString += string.Format("pointer-id: {0}, is-new: {1}, is-in-range: {2}, is-in-contact: {3}, is-primary: {4}, buttons: {5}, [X, Y]: {6},{7}", Convert.ToString(vPointerId), bNew, bInRange, bInContact, bPrimary, ButtonMatrix, lX, lY);

Cel().WriteCelString(CelString);

}

VB.NET

Private Sub DynPics_PointerUpdate(obDynPicture As zenOn.IDynPicture, obElement As zenOn.IElement, vPointerId As Object, bNew As Boolean, bInRange As Boolean, bInContact As Boolean, _

bPrimary As Boolean, bFirstButton As Boolean, bSecondButton As Boolean, bThirdButton As Boolean, bFourthButton As Boolean, bFifthButton As Boolean, _

lX As Integer, lY As Integer)

Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)

Dim ButtonMatrix As String = ""

ButtonMatrix += If((bFirstButton = True), "[1]", "[x]")

ButtonMatrix += If((bSecondButton = True), "[2]", "[x]")

ButtonMatrix += If((bThirdButton = True), "[3]", "[x]")

ButtonMatrix += If((bFourthButton = True), "[4]", "[x]")

ButtonMatrix += If((bFifthButton = True), "[5]", "[x]")

CelString += String.Format("pointer-id: {0}, is-new: {1}, is-in-range: {2}, is-in-contact: {3}, is-primary: {4}, buttons: {5}, [X, Y]: {6},{7}", Convert.ToString(vPointerId), bNew, bInRange, bInContact, bPrimary, _

ButtonMatrix, lX, lY)

Cel().WriteCelString(CelString)

End Sub


PointerWheel

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> PointerWheel

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Posted to the window with foreground keyboard focus when a horizontal scroll wheel is rotated.

To retrieve the wheel scroll units, use the inputData filed of the POINTER_INFO structure returned by calling GetPointerInfo function. This field contains a signed value and is expressed in a multiple of WHEEL_DELTA. A positive value indicates a rotation forward and a negative value indicates a rotation backward.

Note that the wheel inputs may be delivered even if the mouse cursor is located outside of application’s window. The wheel messages are delivered in a way very similar to the keyboard inputs. The focus window of the foregournd message queue receives the wheel messages.

POINTER_INFO structure:

//Helper array that stores the definition of the POINTER_INFO so we can have a look at it more nicely in the CEL

string[] Pointer_Info_Definition = {

"PointerType",

"PointerID",

"FrameID",

"PointerFlags",

"SourceDevice",

"hwndTarget",

"PixelLocation",

"HimetricLocation",

"PixelLocationRaw",

"HimetricLocationRaw",

"Time",

"historyCount",

"inputData",

"KeyStates",

"PerformanceCount",

"ButtonChangeType"

};

Datatype

PointerWheel (IDynPicture* obDynPicture, IElement* obElement, VARIANT vPointerId, long lWheelDelta, long lX, long lY) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | No
VSTA | yes

Parameters

C#

IDynPicture obDynPicture

IElement obElement

object vPointerId

int lWheelDelta

int lX

int lY

VB.NET

Dim obDynPicture As IDynPicture

Dim obElement As IElement

Dim vPointerId As Object

Dim lWheelDelta As Integer

Dim lX As Integer

Dim lY As Integer

Examples

C#

void DynPics_PointerWheel(zenOn.IDynPicture obDynPicture, zenOn.IElement obElement, object vPointerId, int lWheelDelta, int lX, int lY)

{

string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);

CelString += string.Format("pointer-id: {0}, wheel-delta: {1}, [X,Y]; {2}, {3}", Convert.ToString(vPointerId), lWheelDelta, lX, lY);

Cel().WriteCelString(CelString);

}

VB.NET

Private Sub DynPics_PointerWheel(obDynPicture As zenOn.IDynPicture, obElement As zenOn.IElement, vPointerId As Object, lWheelDelta As Integer, lX As Integer, lY As Integer)

Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)

CelString += String.Format("pointer-id: {0}, wheel-delta: {1}, [X,Y]; {2}, {3}", Convert.ToString(vPointerId), lWheelDelta, lX, lY)

Cel().WriteCelString(CelString)

End Sub


PointerHWheel

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> PointerHWheel

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Posted to the window with foreground keyboard focus when a horizontal scroll wheel is rotated.

To retrieve the wheel scroll units, use the inputData filed of the POINTER_INFO structure returned by calling GetPointerInfo function. This field contains a signed value and is expressed in a multiple of WHEEL_DELTA. A positive value indicates a rotation forward and a negative value indicates a rotation backward.

Note that the wheel inputs may be delivered even if the mouse cursor is located outside of application’s window. The wheel messages are delivered in a way very similar to the keyboard inputs. The focus window of the foregournd message queue receives the wheel messages.

POINTER_INFO structure:

//Helper array that stores the definition of the POINTER_INFO so we can have a look at it more nicely in the CEL

string[] Pointer_Info_Definition = {

"PointerType",

"PointerID",

"FrameID",

"PointerFlags",

"SourceDevice",

"hwndTarget",

"PixelLocation",

"HimetricLocation",

"PixelLocationRaw",

"HimetricLocationRaw",

"Time",

"historyCount",

"inputData",

"KeyStates",

"PerformanceCount",

"ButtonChangeType"

};

Datatype

PointerHWheel (IDynPicture* obDynPicture, IElement* obElement, VARIANT vPointerId, long lWheelDelta, long lX, long lY) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | No
VSTA | yes

Parameters

C#

IDynPicture obDynPicture

IElement obElement

object vPointerId

int lWheelDelta

int lX

int lY

VB.NET

obDynPicture As IDynPicture

obElement As IElement

vPointerId As Object

lWheelDelta As Integer

lX As Integer

lY As Integer

Examples

C#

void DynPics_PointerHWheel(zenOn.IDynPicture obDynPicture, zenOn.IElement obElement, object vPointerId, int lWheelDelta, int lX, int lY)

{

string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);

CelString += string.Format("pointer-id: {0}, wheel-delta: {1}, [X,Y]; {2}, {3}", Convert.ToString(vPointerId), lWheelDelta, lX, lY);

Cel().WriteCelString(CelString);

}

VB.NET

Private Sub DynPics_PointerHWheel(obDynPicture As zenOn.IDynPicture, obElement As zenOn.IElement, vPointerId As Object, lWheelDelta As Integer, lX As Integer, lY As Integer)

Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)

CelString += String.Format("pointer-id: {0}, wheel-delta: {1}, [X,Y]; {2}, {3}", Convert.ToString(vPointerId), lWheelDelta, lX, lY)

Cel().WriteCelString(CelString)

End Sub


NCPointerDown

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> NCPointerDown

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Posted when a pointer makes contact over the non-client area of a window. The message targets the window over which the pointer makes contact. The pointer is implicitly captured to the window so that the window continues to receive input for the pointer until it breaks contact.

If a window has captured this pointer, this message is not posted. Instead, a NCPointerDown is posted to the window that has captured this pointer.

If the application does not process this message, DefWindowProc may perform one or more system actions depending on the hit-test result included in the message. Typically, applications should not need to handle this message.

Datatype

NCPointerDown(IDynPicture*obDynPicture, VARIANT vPointerId, long lHitTestResult, long lX, long lY) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | No
VSTA | yes

Parameters

C#

IDynPicture obDynPicture

int lPointerId

int lHitTestResult

int lX

int lY

VB.NET

obDynPicture As IDynPicture

lPointerId As Integer

lHitTestResult As Integer

lX As Integer

lY As Integer

Examples

C#

void DynPics_NCPointerDown(zenOn.IDynPicture obDynPicture, int lPointerId, int lHitTestResult, int lX, int lY)

{

string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);

CelString += string.Format("pointer-id: {0}, hit-test-result: {1}, [X,Y]: {2}, {3}", lPointerId, lHitTestResult, lX, lY);

Cel().WriteCelString(CelString);

}

VB.NET

Private Sub DynPics_NCPointerDown(obDynPicture As zenOn.IDynPicture, lPointerId As Integer, lHitTestResult As Integer, lX As Integer, lY As Integer)

Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)

CelString += String.Format("pointer-id: {0}, hit-test-result: {1}, [X,Y]: {2}, {3}", lPointerId, lHitTestResult, lX, lY)

Cel().WriteCelString(CelString)

End Sub


NCPointerUp

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> NCPointerUp

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Posted when a pointer that made contact over the non-client area of a window breaks contact. The message targets the window over which the pointer makes contact and the pointer is, at that point, implicitly captured to the window so that the window continues to receive input for the pointer until it breaks contact, including the NCPointerUp notification.

If a window has captured this pointer, this message is not posted. Instead, a NCPointerUp is posted to the window that has captured this pointer.

Datatype

NCPointerUp(IDynPicture*obDynPicture, VARIANT vPointerId, long lX, long lY) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | No
VSTA | yes

Parameters

C#

IDynPicture obDynPicture

int lPointerId

int lX

int lY

VB.NET

obDynPicture As IDynPicture

lPointerId As Integer

lX As Integer

lY As Integer

Examples

C#

void DynPics_NCPointerUp(zenOn.IDynPicture obDynPicture, int lPointerId, int lX, int lY)

{

string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);

CelString += string.Format("pointer-id: {0}, [X,Y]: {1}, {2}", lPointerId, lX, lY);

Cel().WriteCelString(CelString);

}

VB.NET

Private Sub DynPics_NCPointerUp(obDynPicture As zenOn.IDynPicture, lPointerId As Integer, lX As Integer, lY As Integer)

Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)

CelString += String.Format("pointer-id: {0}, [X,Y]: {1}, {2}", lPointerId, lX, lY)

Cel().WriteCelString(CelString)

End Sub


NCPointerUpdate

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> NCPointerUpdate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Posted to provide an update on a pointer that made contact over the non-client area of a window or when a hovering uncaptured contact moves over the non-client area of a window. While the pointer is hovering, the message targets whichever window the pointer happens to be over. While the pointer is in contact with the surface, the pointer is implicitly captured to the window over which the pointer made contact and that window continues to receive input for the pointer until it breaks contact.

If a window has captured this pointer, this message is not posted. Instead, a NCPointerUpdateis posted to the window that has captured this pointer.

Datatype

NCPointerUpdate(IDynPicture*obDynPicture, VARIANT vPointerId, long lHitTestResult, long lX, long lY) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | No
VSTA | yes

Parameters

C#

IDynPicture obDynPicture

int lPointerId

int lHitTestResult

int lX

int lY

VB.NET

obDynPicture As IDynPicture

lPointerId As Integer

lHitTestResult As Integer

lX As Integer

lY As Integer

Examples

C#

void DynPics_NCPointerUpdate(zenOn.IDynPicture obDynPicture, int lPointerId, int lHitTestResult, int lX, int lY)

{

string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);

CelString += string.Format("pointer-id: {0}, hit-test-result: {1}, [X,Y]: {2}, {3}", lPointerId, lHitTestResult, lX, lY);

Cel().WriteCelString(CelString);

}

VB.NET

Private Sub DynPics_NCPointerUpdate(obDynPicture As zenOn.IDynPicture, lPointerId As Integer, lHitTestResult As Integer, lX As Integer, lY As Integer)

Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)

CelString += String.Format("pointer-id: {0}, hit-test-result: {1}, [X,Y]: {2}, {3}", lPointerId, lHitTestResult, lX, lY)

Cel().WriteCelString(CelString)

End Sub


PointerActivate

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> PointerActivate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Sent to an inactive window when a primary pointer generates a PointerDown over the window. As long as the message remains unhandled, it travels up the parent window chain until it is reaches the top-level window. Applications can respond to this message to specify whether they wish to be activated.

Datatype

PointerActivate(IDynPicture*obDynPicture, OLE_HANDLE hWnd, long lHitTestResult, VARIANT vPointerId) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | No
VSTA | yes

Parameters

C#

IDynPicture obDynPicture

int hWnd

int lHitTestResult

object vPointerId

VB.NET

obDynPicture As IDynPicture

hWnd As Integer

lHitTestResult As Integer

vPointerId As Object

Examples

C#

void DynPics_PointerActivate(zenOn.IDynPicture obDynPicture, int hWnd, int lHitTestResult, object vPointerId)

{

string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);

CelString += string.Format("pointer-id: {0}, hit-test-result: {1}, hWnd = {2}", Convert.ToString(vPointerId), lHitTestResult, hWnd.ToString());

Cel().WriteCelString(CelString);

GetPointerInfo(obDynPicture, vPointerId);

}

VB.NET

Private Sub DynPics_PointerActivate(obDynPicture As zenOn.IDynPicture, hWnd As Integer, lHitTestResult As Integer, vPointerId As Object)

Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)

CelString += String.Format("pointer-id: {0}, hit-test-result: {1}, hWnd = {2}", Convert.ToString(vPointerId), lHitTestResult, hWnd.ToString())

Cel().WriteCelString(CelString)

GetPointerInfo(obDynPicture, vPointerId)

End Sub


PointerCaptureChanged

Manual -> Programming interfaces -> Objectmodel -> DynPictures -> DynPictures-Events -> PointerCaptureChanged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Sent to a window that is losing capture of an input pointer. A window should use this notification to stop processing subsequent messages and initiate any cleanup required for the pointer being lost. Processing of gestures associated with the pointer should also be terminated and remaining contacts re-associated with the window.

Datatype

PointerCaptureChanged(IDynPicture*obDynPicture, VARIANT vPointerId, OLE_HANDLE hWnd) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | No
VSTA | yes

Parameters

C#

IDynPicture obDynPicture

object vPointerId

int hWnd

VB.NET

obDynPicture As IDynPicture

vPointerId As Object

hWnd As Integer

Examples

C#

void DynPics_PointerCaptureChanged(zenOn.IDynPicture obDynPicture, object vPointerId, int hWnd)

{

string CelString = string.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name);

CelString += string.Format("pointer-id: {0}", Convert.ToString(vPointerId));

Cel().WriteCelString(CelString);

}

VB.NET

Private Sub DynPics_PointerCaptureChanged(obDynPicture As zenOn.IDynPicture, vPointerId As Object, hWnd As Integer)

Dim CelString As String = String.Format("VSTA: {0} on {1} ", System.Reflection.MethodBase.GetCurrentMethod().Name, obDynPicture.Name)

CelString += String.Format("pointer-id: {0}", Convert.ToString(vPointerId))

Cel().WriteCelString(CelString)

End Sub


EdLimit

Manual -> Programming interfaces -> Objectmodel -> EdLimit

Remarks

The object EDLimit is only availaible within the zenOn Editor and is not usable during Runtime. It represents the limits from the variables as well as from the datatypes.

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public Sub test_EDLimit()
Dim zEDLimit As EdLimit
Dim zVAR As Variable
Dim vDynProps As Variant
Dim strDynProp As String

'FROM DataType
'Set zEDLimit = Myworkspace.ActiveDocument.VarTypes.Item("UINT").EdLimitItem(0)

'FROM Variable
Set zVAR = MyWorkspace.ActiveDocument.Variables.Item("WIZ_VAR_10")
Set zEDLimit = zVAR.EdLimitItem(0)

'READ SETTINGS of EDLimit for Variable and Datatype
Debug.Print "Active : " & zEDLimit.Active
Debug.Print "Alarm : " & zEDLimit.Alarm
Debug.Print "AlarmAck : " & zEDLimit.AlarmAck
Debug.Print "AlarmDelete : " & zEDLimit.AlarmDelete
Debug.Print "Blinking : " & zEDLimit.Blinking
Debug.Print "Cel : " & zEDLimit.Cel
Debug.Print "Class : " & zEDLimit.Class
Debug.Print "Color : " & zEDLimit.color
Debug.Print "Delay : " & zEDLimit.Delay
Debug.Print "Group : " & zEDLimit.Group
Debug.Print "HelpCapture : " & zEDLimit.HelpCapture
Debug.Print "HelpFile : " & zEDLimit.HelpFile
Debug.Print "Invisible : " & zEDLimit.Invisible
Debug.Print "IsMax : " & zEDLimit.IsMax
Debug.Print "IsSimple : " & zEDLimit.IsSimple
Debug.Print "IsVariable : " & zEDLimit.IsVariable
Debug.Print "LimitValue : " & zEDLimit.LimitValue
Debug.Print "ParentID : " & zEDLimit.ParentID
Debug.Print "Print : " & zEDLimit.Print
Debug.Print "Text : " & zEDLimit.Text
Debug.Print "ThresholdValue: " & zEDLimit.ThresholdValue

'READ DYNPROPERTIES of EDLimit for Variable and Datatype
vDynProps = zEDLimit.DynPropertiesEnum("")
For Each strItem In vDynProps
strDynProp = Mid(strItem, 1, InStr(1, strItem, ",") - 1)
Debug.Print "--------------------"
Debug.Print strItem
Debug.Print zEDLimit.DynProperties(strDynProp)
Next

End Sub

Other topics in this chapter

EdLimit-Properties

EdLimit-Methods


EdLimit-Properties

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | Active | Limit in/-active | available | not used
VARIANT_BOOL | Alarm |  | available | not used
VARIANT_BOOL | AlarmAck |  | available | not used
VARIANT_BOOL | AlarmComment |  | available | not used
VARIANT_BOOL | AlarmDelete |  | available | not used
VARIANT_BOOL | Blinking |  | available | not used
VARIANT_BOOL | Cel |  | available | not used
short | Class |  | available | not used
long | Color |  | available | not used
long | Delay |  | available | not used
short | Group |  | available | not used
BSTR | HelpCapture |  | available | not used
BSTR | HelpFile |  | available | not used
VARIANT_BOOL | Invisible |  | available | not used
VARIANT_BOOL | IsMax |  | available | not used
VARIANT_BOOL | IsSimple |  | available | not used
VARIANT_BOOL | IsVariable |  | available | not used
double | LimitValue |  | available | not used
IDispatch | Parent | Parent-object | read only | read only
long | ParentID | ID of the variable | available | not used
VARIANT_BOOL | Print |  | available | not used
BSTR | Text |  | available | not used
double | ThresholdValue |  | available | not used
IVariable | Variable |  | available | not used

Other topics in this chapter

Parent

Active

ParentID

IsSimple

IsMax

IsVariable

LimitValue

Variable

ThresholdValue

Text

Color

Invisible

Blinking

Alarm

HelpFile

HelpCapture

AlarmAck

AlarmDelete

Cel

Print

Group

Class

Delay

AlarmComment


Parent

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Dispatch

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Active

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> Active

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Limit in/-active

Datatype

Active() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


ParentID

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> ParentID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

ID of the variable or datatype

Datatype

ParentID() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


IsSimple

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> IsSimple

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns -1 when the datatype is a simple datatype and 0 when it is a complex datatype.

Datatype

IsSimple() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


IsMax

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> IsMax

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

MIN or MAXLimit will be reached on underrun the limit or on overflow the setting...

Datatype

IsMax() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


IsVariable

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> IsVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The limit value is not defined through a fixed technical assignment of value, but through the technical value of another variable.A 'Variable' has to be linked also with this limit.

Datatype

IsVariable() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


LimitValue

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> LimitValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Value when the Limit is reached.

Datatype

LimitValue() As double

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Variable

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> Variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Variable as object, which should be used as dynamic limit value.Only available, if the dynamic limit is active!

Datatype

Variable() As Variable

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


ThresholdValue

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> ThresholdValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

A threshold value can be defined, that is used for the releasing of the limit violation. So undesired reactions on quick series of alarms for analog values can be avoided.

Example 1: Maximum value = 900, threshold = 10 makes 890Limit is violated above 900 and violation is released under 890.

Example 2: Minimum value = 900, threshold = 10 makes 910Limit is violated below 900 and violation is released over 910.

In differnce to the hysteresis this property does not influence the display of the value but only the alarm behaviour.

Datatype

ThresholdValue() As double

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Text

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> Text

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Text of the limit as it is displayed in lists, in the status line, and in dynamic elements on a limit violation.

Datatype

Text() As String

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Color

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> Color

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Color of this Limit

Datatype

Color() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Invisible

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> Invisible

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Invisible Flag can be used with the 'Status' element for example...

Datatype

Invisible() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Blinking

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> Blinking

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Blinking will be enabled if this flag is set to true...

Datatype

Blinking() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Alarm

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> Alarm

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Should the Limit raise an Alarm?

Datatype

Alarm() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


HelpFile

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> HelpFile

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Represents the HelpFile if you use the embedded help features of zenOn

Datatype

HelpFile() As String

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


HelpCapture

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> HelpCapture

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Represents the HelpCapture if you use the embedded help features of zenOn

Datatype

HelpCapture() As String

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


AlarmAck

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> AlarmAck

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The Alarm has to be acknowledged by the user whe n this flag is set to true.

Datatype

AlarmAck() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


AlarmDelete

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> AlarmDelete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The Alarm has to be deleted by the user whe n this flag is set to true.

Datatype

AlarmDelete() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Cel

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> Cel

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Write into CEL...

Datatype

Cel() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Print

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> Print

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Alarm or limit violation (with set option "in CEL") is printed online.

Datatype

Print() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Group

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> Group

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Group number of this Limit

Datatype

Group() As short

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Class

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> Class

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Class of this Limit

Datatype

Class() As short

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Delay

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> Delay

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Delay of this Limit in seconds

Datatype

Delay() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


AlarmComment

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Properties -> AlarmComment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

AlarmComment() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


EdLimit-Methods

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> EdLimit -> EdLimit-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


Element

Manual -> Programming interfaces -> Objectmodel -> Element

Remarks

This object contains the most important information on a defined dynamic element, e.g. type, position, colour, ...

Dynamic elements are created in the Editor of the contol system. With a DynPicture you get the list of the defined elements. In the project the central list of the defined Screens is available.
Most of the dynamic elements can be linked to variables or functions. Additionally these elements can be linked to different VBA macros. The VBA macros are managed in the Macro Browser of the Editor and liked to the properties of the elements.

Hint:
The VBA macros are only available within the control system. External applications have no access to the defined macros.

The following VBA macros are available:

  • Init: available
  • LeftClickUp: available
  • LeftClickDown: Executed on releasing the left mouse button
  • LeftDClick: Executed on doubleclicking the left mouse button
  • RightClickUp: Executed on clicking the right mouse button
  • RightClickDown: Executed on releasing the right mouse button
  • RightDClick: Executed on doubleclicking the right mouse button
  • SetFocus: Executed on activating the element
  • KillFocus: Executed on leaving the element
  • Draw: Executed on drawing the element

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

'Sample how to get all elements within an symbol...
Sub GetItAll()
'Define objects...
Dim zPIC As DynPicture
Dim zELE As Element
'allocate the Screen
Set zPIC = MyWorkspace.ActiveDocument.DynPictures.Item("ScreenName")
'check if Screen object is valid...
If zPIC Is Nothing Then Exit Sub
'allocate the element
Set zELE = zPIC.Elements.Item("SymbolName")
'check if element object is valid...
If zELE Is Nothing Then Exit Sub
'get all elements within the symbol an its sub symbols...
Call GetElements(zELE)
End Sub

'Procedure with recursive calls to get all subsymbols...
Sub GetElements(zElem As Element)
Dim i As Integer
For i = 0 To zElem.Elements.Count - 1
'check if element is of type symbol
If zElem.Elements.Item(i).Type = tpSymbol Then
'recursiv call
Call GetElements(zElem.Elements.Item(i))
Else
'print the name of each element...
Debug.Print i & ": " & zElem.Elements.Item(i).Name
End If
Next i
End Sub

Other topics in this chapter

Element-Properties

Element-Methods

Element-Dynamic properties


Element-Properties

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
OLE_COLOR | BackColor | Background-Color | available | available
IVariable | BackColorVariable |  | available | not used
long | Bottom | Height of the element | available | read only
long | CountVariable | Count of linked variables | read only | read only
ISymbolElements | Elements | Returns the list of linked symbols | available | not used
VARIANT_BOOL | Enable | De/-Activates the element (only runtime) | read only | available
VARIANT_BOOL | Focus | Sets the focus to the element | read only | read only
OLE_COLOR | ForeColor | Text-Color | available | read only
long | Height | Height of the element | available | read only
BSTR | HelpCapture | Help-Index in the helpfile for context-sensitive help | available | read only
BSTR | HelpFile | Name of the linked helpfile | available | read only
VARIANT_BOOL | Hide | Show/Hide the element (only runtime) | not used | available
BYTE | HorizontalOrigin |  | available | read only
BSTR | HotKey | Hotkey for the element | available | read only
OLE_HANDLE | hWnd | Handle for picture | not used | read only
long | ID | ID of the element (unique) | read only | read only
long | Left | Left-coordinate of the element | available | read only
IVariable | LineColorVariable |  | available | not used
BSTR | MenuName | Name of the linked zenOn-Menu | available | read only
BSTR | Name | Name of the element (optional) | available | read only
IElements | Parent | Parent-Object of the element | read only | read only
short | PasswordLevel | Password-Level for user-action | available | read only
long | Right | Width of the element | available | read only
BSTR | StationName |  | available | read only
VARIANT_BOOL | SymbolInLibrary | Insert the given symbol into the symbol-library | read only | not used
long | SymbolNo |  | read only | read only
BSTR | ToolTip | Info-Text for the element (is shown by mouseover in the runtime) | available | not used
long | Top | Top-coordinate of the element | available | read only
IVariable | TwistVariable |  | available | not used
double | TwistVarMax |  | available | read only
double | TwistVarMin |  | available | read only
long | TwistViewMax |  | available | read only
long | TwistViewMin |  | available | read only
long | Type | Type of the element () | read only | read only
BYTE | VerticalOrigin |  | available | read only
double | VisibilityFrom |  | available | read only
VARIANT_BOOL | VisibilityFromLimit |  | available | read only
double | VisibilityTo |  | available | read only
IVariable | VisibilityVariable |  | available | not used
long | Width | Width of the element | available | read only
IVariable | XVariable |  | available | not used
double | XVarMax |  | available | read only
double | XVarMin |  | available | read only
long | XViewMax |  | available | read only
long | XViewMin |  | available | read only
IVariable | XZoomVariable |  | available | not used
double | XZoomVarMax |  | available | read only
double | XZoomVarMin |  | available | read only
long | XZoomViewMax |  | available | read only
long | XZoomViewMin |  | available | read only
IVariable | YVariable |  | available | not used
double | YVarMax |  | available | read only
double | YVarMin |  | available | read only
long | YViewMax |  | available | read only
long | YViewMin |  | available | read only
IVariable | YZoomVariable |  | available | not used
double | YZoomVarMax |  | available | read only
double | YZoomVarMin |  | available | read only
long | YZoomViewMax |  | available | read only
long | YZoomViewMin |  | available | read only
short | ZoomMax |  | available | read only
short | ZoomMin |  | available | read only
tpLockResult | InterlockingStatus | Returns whether the Element is currently interlocked. | not used | read only
IRtFunction | Function | Returns the linked Function. | read only | read only
IInterlocking | Interlocking | Returns the linked Interlocking. | read only | read only

Other topics in this chapter

Parent

Name

Type

Enable

Hide

Left

Top

Right

Bottom

Width

Height

BackColor

ForeColor

Focus

CountVariable

PasswordLevel

hWnd

ID

HotKey

MenuName

HelpFile

HelpCapture

ToolTip

StationName

ZoomMin

ZoomMax

HorizontalOrigin

VerticalOrigin

VisibilityVariable

VisibilityFromLimit

VisibilityFrom

VisibilityTo

LineColorVariable

BackColorVariable

XVariable

XVarMin

XVarMax

XViewMin

XViewMax

YVariable

YVarMin

YVarMax

YViewMin

YViewMax

XZoomVariable

XZoomVarMin

XZoomVarMax

XZoomViewMin

XZoomViewMax

YZoomVariable

YZoomVarMin

YZoomVarMax

YZoomViewMin

YZoomViewMax

TwistVariable

TwistVarMin

TwistVarMax

TwistViewMin

TwistViewMax

SymbolNo

SymbolInLibrary

Elements

InterlockingStatus

Function

Interlocking


Parent

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Elements

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the name of the dynamic element. This property is optional, i.e. if the user did not define a name, an empty string is returned.Hint: With this unique name a dynamic element can be found in the list of the dynamic elements of the picture.

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Type

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the type of the "Element" object.The following table gives an overview of the common element types:

Value | Hex | Name | Description
0 | &H0 | tpDynBargraph | Bar Graph
1 | read only | tpDynZahlenElem | Numerical value
2 | read only | tpDynText | Link Text
4 | yes | tpDynTrend | Trend Graph
5 | yes | tpDynZeiger | Indicating instrument
6 | &H6 | tpDynBewegt | Move element
7 | &H7 | tpDynBinaer | Binary element
8 | &H8 | tpDynBitmap | Bitmap button
9 | &H9 | tpDynVerkn | Invisible button
10 | &HA | tpDynButton | Text button
11 | &HB | tpDynSchalter | Switch
12 | &HC | tpDynMulitbin | Multi-binary element
13 | &HD | tpDynMeldung | Message
14 | &HE | tpDynUhr | Clock
15 | &HF | tpDynBefMdi | Command element
16 | &H10 | tpDynStatus | State element
17 | &H11 | tpDynBaButton | Picture alarm
18 | &H12 | tpDynControl | Control element
19 | &H13 | tpDynAegel |
20 | &H14 | tpDynActiveX | ActiveX element
21 | &H15 | tpDynTopLgt | Topological line
22 | &H16 | tpDynTopStrg | Topological branch
23 | &H17 | tpDynInstrument | Universal Slider
24 | &H18 | tpDynCombiList | ComboListBox
29 | &H1D | tpDynWPF | WPF Element
100 | &H64 | tpDot |
101 | &H65 | tpLine | Line
102 | &H66 | tpRectangle | Rectangle
103 | &H67 | tpCircle | Ellipse / Circle
104 | &H68 | tpPolyLine | Polyline
107 | &H6B | tpText | Text
108 | &H6C | tpArc | Arc of circle
109 | &H6D | tpSolid |
111 | &H6F | tpTraceDr |
114 | &H72 | tpKegel |
115 | &H73 | tpFillPara |
116 | &H74 | tpFillTria |
117 | &H75 | tpFillBlock |
121 | &H79 | tpPie | Pie
127 | &H7F | tpRoundRect | Rounded rectangle
128 | &H80 | tpPolygon | Polygon
129 | &H81 | tpSymbol | Embedded symbol
130 | &H82 | tpSymbolLnk | Linked symbol
131 | &H83 | tpSegme_Dxf | Graphical element of DXF
133 | &H85 | tpWMF | Graphical element of WMF
134 | &H86 | tpEMF | Graphical element of EMF
135 | &H87 | tpWinkel | 3D-angle
136 | &H88 |  | Tube

Datatype

Type() As long
VBA | yes | tpDynBargraph | Bar Graph
VSTA | yes | tpDynBargraph | Bar Graph

Availability

Environment | Available
Editor | read only
Runtime | read only


Enable

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> Enable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

De/activates the dynamic element. If deactivated, actions like setting a value are not executed.Usually this property returns True indicating, that the element is active. Setting it to False deactivates the element.Hint: VBA macros are also executed, if the element is deactivated. Standard actions, e.g. executing functions for a button are not executed when deactivated.The following example de/activates the dynamic element BITMAP_BTN_1, which is on the current picture, depending on the current status of the element.

Datatype

Enable() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'*** De/-activate element BITMAP_BTN_1
Public Sub LeftClickUp_Element_Enabled(obElem As Element)
Dim obElement As Element
Dim obPicture As DynPicture

'*** Get picture-Object
Set obPicture = obElem.Parent.Parent
If (obPicture Is Nothing) Then
MsgBox "Error: Picture-object is invalid..."
Exit Sub
End If

'*** Get element BITMAP_BTN_1
Set obElement = obPicture.Elements.Item("BITMAP_BTN_1")
If (obElement Is Nothing) Then
MsgBox "Error: element BITMAP_BTN_1 doesn't exists..."
Exit Sub
End If

'*** De/-activate element
obElement.Enable = Not obElement.Enable
obElement.Update
End Sub


Hide

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> Hide

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property can influence the visibility of the dynamic element. Usually this property returns False, i.e. the element is displayed.If the property is set to True, the element is hidden. And the element stays invisible, until this property is set back to False.Reopening the picture resets the element.The following example influences the visibility of the dynamic element BITMAP_BTN_1, which exists in the current picture.

Datatype

Hide() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'*** Change visibility of BITMAP_BTN_1
Public Sub LeftClickUp_Element_Hide(obElem As Element)
Dim obElement As Element
Dim obPicture As DynPicture

'*** Get picture-Object
Set obPicture = obElem.Parent.Parent
If (obPicture Is Nothing) Then
MsgBox "Error: Picture-object is invalid..."
Exit Sub
End If

'*** Get element BITMAP_BTN_1
Set obElement = obPicture.Elements.Item("BITMAP_BTN_1")
If (obElement Is Nothing) Then
MsgBox "Error: element BITMAP_BTN_1 doesn't exists..."
Exit Sub
End If

'*** De/-activate element
obElement.Hide = Not obElement.Hide
obElement.Update
End Sub


Left

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> Left

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the position of the left window border of the dynamic element in pixel. The value defines the distance from the left border of the screen.The following example moves a Bitmap-Button to the right by the width of the element. If the right border of the picture is reached, the element is moved to the left border.

Datatype

Left() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'*** Move picture
Public Sub LeftClickUp_Element_Move_Horizontal(obElem As Element)
Dim obElement As Element
Dim obPicture As DynPicture
Dim nWidth As Long

'*** Get picture-Object
Set obPicture = obElem.Parent.Parent
If (obPicture Is Nothing) Then
MsgBox "Error: Picture-object is invalid..."
Exit Sub
End If

'*** Get element BITMAP_BTN_1
Set obElement = obPicture.Elements.Item("BITMAP_BTN_1")
If (obElement Is Nothing) Then
MsgBox "Error: element BITMAP_BTN_1 doesn't exists..."
Exit Sub
End If

'*** moves element to top of the picture
nWidth = (obElement.Bottom - obElement.Top)

'*** moves element
If (obElement.Right <= obPicture.Width) Then
obElement.Move obElement.Right, obElement.Top,
(obElement.Right + nWidth), obElement.Bottom
Else
obElement.Move obPicture.Left, obElement.Top,
obPicture.Left + nWidth, obElement.Bottom
End If
End Sub


Top

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> Top

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the position of the top window border of the dynamic element in pixel. The value defines the distance from the top border of the screen.The following example moves a Bitmap-Button down by the height of the element. If the bottom border of the picture is reached, the element is moved to the top border.

Datatype

Top() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'*** Move element BITMAP_BTN_1
Public Sub LeftClickUp_Element_Move(obElem As Element)

Dim obElement As Element
Dim obPicture As DynPicture
Dim nHeight As Long
Dim nOldTop As Long

Set obPicture = obElem.Parent.Parent
If (obPicture Is Nothing) Then
MsgBox "Error: Picture-object is invalid..."
Exit Sub
End If

Set obElement = obPicture.Elements.Item("BITMAP_BTN_1")
If (obElement Is Nothing) Then
MsgBox "Error: element BITMAP_BTN_1 doesn't exists..."
Exit Sub
End If

nHeight = (obElement.Bottom - obElement.Top)
nOldTop = obElement.Top

'*** moves element
If (obElement.Bottom > obPicture.Height) Then
obElement.Move obElement.Left, 0, obElement.Right, (nHeight)
Else
obElement.Move obElement.Left, obElement.Bottom, obElement.Right,
(obElement.Bottom + nHeight)
End If

'*** update picture
obElement.Update
obPicture.Update obElement.Left, nOldTop, obElement.Right,
(obElement.Bottom + nHeight)
obElem.LeftClickUp
End Sub


Right

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> Right

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the position of the right window border of the dynamic element in pixel. The value defines the distance from the left border of the screen.

Datatype

Right() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Bottom

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> Bottom

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the position of the bottom window border of the dynamic element in pixel. The value defines the distance from the top border of the screen.

Datatype

Bottom() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Width

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> Width

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Width of the element (in pixel).

Datatype

Width() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Height

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> Height

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Height of the element (in pixels).

Datatype

Height() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


BackColor

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> BackColor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

BackColor() As OLE_COLOR

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


ForeColor

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> ForeColor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ForeColor() As OLE_COLOR

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Focus

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> Focus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property checks, if the current element has the focus. Only one element per picture can have the focus at the same time.An element gets the focus, when clicking on it with the mouse or switching to it with the Tab key.In the later case the Tab functionality for the Runtime has to be activated.

Datatype

Focus() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


CountVariable

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> CountVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the number of variables linked to the dynamic element.Hint: With the method "ItemVariable" the single variables of the dynamic element can be found out.The following VBA example reads all variables of a Trend element and displays them in the Debug window of VBA. Then the user is asked if VBA should be opened, to let him read the messages.

Datatype

CountVariable() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'*** Get variables of trend TREND_1.

Public Sub LeftClickUp_Element_Variables(obElem As Element)
Dim obElement As Element
Dim obPicture As DynPicture
Dim obVariable As Variable
Dim obFunction As RtFunction
Dim nIndex As Long

'*** Get picture-Object
Set obPicture = obElem.Parent.Parent
If (obPicture Is Nothing) Then
MsgBox "Error: Picture-object is invalid..."
Exit Sub
End If

'*** Get element TREND_1
Set obElement = obPicture.Elements.Item("TREND_1")
If (obElement Is Nothing) Then
MsgBox "Error: element BITMAP_BTN_1 doesn't exists..."
Exit Sub
End If

'*** Get variables of trend
Debug.Print "TREND_1: " + CStr(obElement.CountVariable) + " variabls
End Sub


PasswordLevel

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> PasswordLevel

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property returns the password level of the dynamic element. Usually this method returns 0 indicating, that no password level is set.If the value is > 0, only users with the defined password level are allowed to execute the action.

Datatype

PasswordLevel() As short

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


hWnd

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> hWnd

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the handle for the dynamic element. Each window in Windows is identified by a handle. This handle is used for most of the standard routines, e.g. for drawing.

Datatype

hWnd() As OLE_HANDLE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ID

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> ID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

ID of the element (unique)

Datatype

ID() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


HotKey

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> HotKey

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Hotkey for the element

Datatype

HotKey() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


MenuName

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> MenuName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Name of the linked zenOn-Menu as string.

Datatype

MenuName() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


HelpFile

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> HelpFile

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Name of the linked helpfile

Datatype

HelpFile() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


HelpCapture

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> HelpCapture

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Help-Index in the helpfile for context-sensitive help

Datatype

HelpCapture() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ToolTip

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> ToolTip

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Info-Text for the element (is shown by mouseover in the runtime)

Datatype

ToolTip() As String

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


StationName

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> StationName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Element is entered into the object list of the world view with the text defined with this property as string.

Datatype

StationName() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ZoomMin

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> ZoomMin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Lowest zoom step in which the element should be visible in the worldview. Default: -1.Hint: Where visible from zoom step -1 to -1 means, that the element is visible in all zoom steps.

Datatype

ZoomMin() As short

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ZoomMax

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> ZoomMax

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Highest zoom step in which the element should be visible in the worldview. Default: -1.Hint: Where visible from zoom step -1 to -1 means, that the element is visible in all zoom steps.

Datatype

ZoomMax() As short

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


HorizontalOrigin

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> HorizontalOrigin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

HorizontalOrigin() As BYTE

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


VerticalOrigin

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> VerticalOrigin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

VerticalOrigin() As BYTE

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


VisibilityVariable

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> VisibilityVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Name (as string) of the variable, whose value should influence the visibility of the element.Hint: If no variable is linked, the element is always visible.

Datatype

VisibilityVariable() As Variable

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


VisibilityFromLimit

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> VisibilityFromLimit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

If set TRUE, the visibility of the element will be influenced by the limit definition of the variable.ATTENTION: At least for one limit of the variable the property "invisible" must be activated.Otherwise, the visibility is influenced by the properties "VisibilityFrom" and "VisibilityTo" of the element.Hint: Only available, after a variable has been assigned to the property "VisibilityVariable".

Datatype

VisibilityFromLimit() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


VisibilityFrom

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> VisibilityFrom

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Lowest value of the variable, for which the element is visible.Hint: Only available, after a variable has been assigned to the property "VisibilityVariable" and the property "VisibilityFromLimit" is set to FALSE.

Datatype

VisibilityFrom() As double

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


VisibilityTo

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> VisibilityTo

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Highest value of the variable, for which the element is visible.Hint: Only available, after a variable has been assigned to the property "VisibilityVariable" and the property "VisibilityFromLimit" is set to FALSE.

Datatype

VisibilityTo() As double

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


LineColorVariable

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> LineColorVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Name (as string) of the variable, whose limit colors should influence the line/text color of the element.

Datatype

LineColorVariable() As Variable

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


BackColorVariable

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> BackColorVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Name (as string) of the variable, whose limit colors should influence the background/filling color of the element.

Datatype

BackColorVariable() As Variable

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


XVariable

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> XVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Name of the variable for horizontal moving of the element as string.

Datatype

XVariable() As Variable

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


XVarMin

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> XVarMin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Lowest variable value for horizontal moving of the element.Hint: A variable has to be assigned to the property "XVariable", in order to use this property.

Datatype

XVarMin() As double

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


XVarMax

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> XVarMax

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Highest variable value for horizontal moving of the element.Hint: A variable has to be assigned to the property "XVariable", in order to use this property.

Datatype

XVarMax() As double

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


XViewMin

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> XViewMin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Horizontal position of the element for variable minimum (in pixels).Hint: A variable has to be assigned to the property "XVariable", in order to use this property.

Datatype

XViewMin() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


XViewMax

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> XViewMax

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Horizontal position of the element for variable maximum (in pixels).Hint: A variable has to be assigned to the property "XVariable", in order to use this property.

Datatype

XViewMax() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


YVariable

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> YVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Name of the variable for vertical moving of the element as string.

Datatype

YVariable() As Variable

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


YVarMin

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> YVarMin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Lowest variable value for vertical moving of the element.Hint: A variable has to be assigned to the property "YVariable", in order to use this property.

Datatype

YVarMin() As double

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


YVarMax

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> YVarMax

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Highest variable value for vertical moving of the element.Hint: A variable has to be assigned to the property "YVariable", in order to use this property.

Datatype

YVarMax() As double

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


YViewMin

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> YViewMin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Vertical position of the element for variable minimum (in pixels).Hint: A variable has to be assigned to the property "YVariable", in order to use this property.

Datatype

YViewMin() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


YViewMax

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> YViewMax

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Vertical position of the element for variable maximum (in pixels).Hint: A variable has to be assigned to the property "YVariable", in order to use this property.

Datatype

YViewMax() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


XZoomVariable

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> XZoomVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Name of the variable for zooming the width of the element as string.

Datatype

XZoomVariable() As Variable

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


XZoomVarMin

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> XZoomVarMin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Lowest variable value for zooming the width of the element.Hint: A variable has to be assigned to the property "XZoomVariable", in order to use this property.

Datatype

XZoomVarMin() As double

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


XZoomVarMax

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> XZoomVarMax

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Highest variable value for zooming the width of the element.Hint: A variable has to be assigned to the property "XZoomVariable", in order to use this property.

Datatype

XZoomVarMax() As double

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


XZoomViewMin

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> XZoomViewMin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Zoom factor of the width of the element for variable minimum (in %).Hint: A variable has to be assigned to the property "XZoomVariable", in order to use this property.

Datatype

XZoomViewMin() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


XZoomViewMax

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> XZoomViewMax

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Zoom factor of the width of the element for variable maximum (in %).Hint: A variable has to be assigned to the property "XZoomVariable", in order to use this property.

Datatype

XZoomViewMax() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


YZoomVariable

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> YZoomVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Name of the variable for zooming the height of the element as string.

Datatype

YZoomVariable() As Variable

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


YZoomVarMin

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> YZoomVarMin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Lowest variable value for zooming the height of the element.Hint: A variable has to be assigned to the property "YZoomVariable", in order to use this property.

Datatype

YZoomVarMin() As double

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


YZoomVarMax

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> YZoomVarMax

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Highest variable value for zooming the height of the element.Hint: A variable has to be assigned to the property "YZoomVariable", in order to use this property.

Datatype

YZoomVarMax() As double

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


YZoomViewMin

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> YZoomViewMin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Zoom factor of the height of the element for variable minimum (in %).Hint: A variable has to be assigned to the property "YZoomVariable", in order to use this property.

Datatype

YZoomViewMin() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


YZoomViewMax

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> YZoomViewMax

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Zoom factor of the height of the element for variable maximum (in %).Hint: A variable has to be assigned to the property "YZoomVariable", in order to use this property.

Datatype

YZoomViewMax() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


TwistVariable

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> TwistVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Name of the variable for rotating the element as string.

Datatype

TwistVariable() As Variable

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


TwistVarMin

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> TwistVarMin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Lowest variable value for rotating the element.Hint: A variable has to be assigned to the property "TwistVariable", in order to use this property.

Datatype

TwistVarMin() As double

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


TwistVarMax

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> TwistVarMax

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Highest variable value for rotating the element.Hint: A variable has to be assigned to the property "TwistVariable", in order to use this property.

Datatype

TwistVarMax() As double

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


TwistViewMin

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> TwistViewMin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Rotation angle of the element for variable minimum (in &#176;).Hint: A variable has to be assigned to the property "TwistVariable", in order to use this property.

Datatype

TwistViewMin() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


TwistViewMax

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> TwistViewMax

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Rotation angle of the element for variable maximum (in &#176;).Hint: A variable has to be assigned to the property "TwistVariable", in order to use this property.

Datatype

TwistViewMax() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


SymbolNo

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> SymbolNo

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Number of symbol within the picture

Datatype

SymbolNo() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


SymbolInLibrary

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> SymbolInLibrary

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Insert the given symbol into the symbol-library

Datatype

SymbolInLibrary() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes


Elements

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> Elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the collection ("SymbolElements" object) of the embedded "Element" objects.

Datatype

Elements() As SymbolElements

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


InterlockingStatus

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> InterlockingStatus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

InterlockingStatus() As tpLockResult

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Function

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> Function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The result is a dispatch-interface object. In case there is no linkage the result can be NULL

id=97(Ele_dispidFunction)

Datatype

Function() As IRtFunction

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Interlocking

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Properties -> Interlocking

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The result is a dispatch-interface object. In case there is no linkage the result can be NULL

id=98(Ele_dispidInterlocking)

Datatype

Interlocking() As IInterlocking

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Element-Methods

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | AddVariable | Add a link to a zenOn-Variable | available | not used
IDispatch | AktiveX | Returns the linked Active-X control (Standard = Nothing) | not used | available
VARIANT_BOOL | CreateDynProperty | - | available | not used
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IVariable | ItemVariable | Returns the linked variable on the given position (depent of the type) | available | available
void | LeftClickDown | - | not used | available
void | LeftClickUp | - | not used | available
void | LeftDClick | - | not used | available
void | Move | Moves the element to the given position | not used | available
VARIANT_BOOL | RemoveVariable | Remove the link to the zenOn-variable on the position | available | not used
void | RightClickDown | - | not used | available
void | RightClickUp | - | not used | available
void | RightDClick | - | not used | available
void | SaveAktiveX | Saves the current ActiveX-settings into to picture (requires additional Save for the picture) | available | not used
void | Update | Updates the element | available | available
void | WPFProperty [PUT] | Get/Set a property of a certain WPF-Element. | available | not used
VARIANT | WPFProperty [GET] | Get/Set a property of a certain WPF-Element. | available | not used
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used
void | Move | Moves the element to the given position | not used | available
void | Move | Moves the element to the given position | not used | available

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

CreateDynProperty

WPFProperty [GET]

WPFProperty [PUT]

Move

Update

AktiveX

SaveAktiveX

ItemVariable

AddVariable

RemoveVariable

LeftClickUp

LeftClickDown

RightClickUp

RightClickDown

RightDClick

LeftDClick


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


CreateDynProperty

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> CreateDynProperty

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method is able to create SubItems of the actual object. The parameter has to be the name of the SubItem to be created.

Datatype

CreateDynProperty(String bsPath) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


WPFProperty [GET]

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> WPFProperty [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

WPFProperty(String bsElement,String bsProperty) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


WPFProperty [PUT]

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> WPFProperty [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

WPFProperty (String bsElement,String bsProperty,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Move

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> Move

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Move(long Left, long Top, long Right, long Bottom) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Update

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> Update

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method updates a dynamic element. After changes with VBA always use this method to actualize the display.

Datatype

Update() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


AktiveX

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> AktiveX

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns the object for the linked Active-X Control, if the dynamic element is an ActiveX element of the control system. If this is not the case, this method returns "Nothing".Hint: The returned object should be checked on "Nothing", as only the ActiveX element of the control system needs this method.

Datatype

AktiveX() As Dispatch

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SaveAktiveX

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> SaveAktiveX

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SaveAktiveX() As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ItemVariable

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> ItemVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the object Variable, which is identified by the parameter vID. Most of the dynamic elements can be linked to variables. The visualization of most elements depends on the linked variables.The parameter vID can have two values:<ul><li>Index: Access with an index mostly is used in combination with the property Count to find out the position of the variable object in the list.</li><li>Variable name: The variable can also be accessed with its unique name.</li></ul>

Datatype

ItemVariable(VARIANT vPv) As Variable

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


AddVariable

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> AddVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Assigns a variable to the object.

Datatype

AddVariable(LPDISPATCH lpVar) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RemoveVariable

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> RemoveVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Remove the link to the zenOn-variable on the position

Datatype

RemoveVariable(long nPosition) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


LeftClickUp

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> LeftClickUp

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method executes the action of the dynamic element for releasing the left mouse button. This action can be a set value action or the execution of a function depending of the type of dynamic element.Hint: This method should be used in combination with the VBA macro LeftClickUp.

Datatype

LeftClickUp() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


LeftClickDown

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> LeftClickDown

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method executes the action of the dynamic element for pressing the left mouse button. This action can be a set value action or the execution of a function depending of the type of dynamic element.Hint: This method should be used in combination with the VBA macro LeftClickDown.

Datatype

LeftClickDown() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RightClickUp

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> RightClickUp

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method executes the action of the dynamic element for releasing the right mouse button. This action can be a set value action or the execution of a function depending of the type of dynamic element.Hint: This method should be used in combination with the VBA macro RightClickUp.

Datatype

RightClickUp() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RightClickDown

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> RightClickDown

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method executes the action of the dynamic element for pressing the right mouse button. This action can be a set value action or the execution of a function depending of the type of dynamic element.Hint: This method should be used in combination with the VBA macro RightClickDown.

Datatype

RightClickDown() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RightDClick

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> RightDClick

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method executes the action of the dynamic element for doubleclicking the right mouse button. This action can be a set value action or the execution of a function depending of the type of dynamic element.Hint: This method should be used in combination with the VBA macro RightDClick.

Datatype

RightDClick() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


LeftDClick

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Methods -> LeftDClick

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method executes the action of the dynamic element for doubleclicking the left mouse button. This action can be a set value action or the execution of a function depending of the type of dynamic element.Hint: This method should be used in combination with the VBA macro LeftDClick.

Datatype

LeftDClick() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Element-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Frame polygon

Frame vector

Batch recipe editor control

MDI element

CControlDynCalendarCtrl

Window

Combobox

Dynamic window list control

Dynamic window batch parameter list

Listbox

Listcontrol

Dynamic window no header list control

CCtrlDynWndFPPicCont

ActiveX

Angle

Arc of circle

Segment of circle

Picture alarm

Bargraph

Command

Move

Binary

Bitmap

Text button

Circle

Combo Listbox

Basisklasse dynamische Bildelemente

Link text

Universal slider

Line

Message

EMF WMF

Multibin

Base class picture elements

Tube

Polygon

Polyline

Picture elements

Rectangle

Switch

Combi

Symbol

Linked symbol

Template

Static text

Trend curve

Clock

Base class vector elements

Invisible button

WPF element

Numerical value

Indicating instrument

Topological wire

Topological line

Other topics in this chapter

CDynEleVar

Frame polygon

Frame vector

Batch recipe editor control

MDI element

CControlDynCalendarCtrl

Window

Combobox

Dynamic window list control

Dynamic window batch parameter list

Listbox

Listcontrol

Dynamic window no header list control

CCtrlDynWndFPPicCont

CZenonGestureManipulation

ActiveX

Angle

Arc of circle

Segment of circle

Picture alarm

Bargraph

CDrawBefCommand

Command

Move

Binary

Bitmap

CDynEleFkt

Text button

Circle

CDynEleVarMulti

Combo Listbox

Basisklasse dynamische Bildelemente

Link text

Universal slider

Line

Message

EMF WMF

Multibin

Base class picture elements

Tube

Polygon

Polyline

Picture elements

Rectangle

Switch

CStatusElemZustand

Combi

CSymbLibProp

Symbol

Linked symbol

Template

Static text

CDynEleVarTrend

Trend curve

Clock

Base class vector elements

Invisible button

CWPFConnectionBase

WPF element

Numerical value

Indicating instrument

Topological wire

Topological line


CDynEleVar

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> CDynEleVar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
ZT_VARIABLE | ProjectVar | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
VT_BSTR | SymVarName | SymVarName | This property returns the name of a variable.
VT_BSTR | SymVarTagNr | SymVarTagNr | This property returns the identification of a variable.


Frame polygon

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Frame polygon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_I2

Combine

Area utilization

Define what effects the created element should have on the frame.

The following settings are available:

Cover: The surface of the element is used as the screen area.

Cut: The surface of the element is removed from the surfaces underneath

ORed: This is either cut out or covered according to whether a covering element is under the element or not

Note: The way the surface is used always relates to the surface under the element.

For newly created elements always the settings which was selected last is used.

More in the online help.

VT_BSTR

Coordinates

Coordinates

"With this property you can get/set the coordinates of the element via a string.
zElement.DynProperties(""Coordinates"") = ""197/118;260/200"""

VT_R4

SplineTension

Rounding

Only available if you have activated option Graphics quality in the project properties in node Graphical design/Screens.

Defines the rounding for the polylines, polygons and the pipes.

Values: 0,0 (no rounding) to 1,0. (maximum rounding)

Default: 0

More in the online help.

ZT_COLOR

LineColor

Line color

Line color of the element.

VT_UI2

Offset_H

Horiz. distance [pixels]

Horizontal distance of the end of the rounding of the actual corner in pixels.

More in the online help.

VT_UI2

Offset_V

Vertical distance [pixels]

Vertical distance of the end of the rounding of the actual corner in pixels.

More in the online help.

ZT_IMAGELIST

LineCapStart

Start type

Only available if you have activated project property Graphics quality.

Defines the symbol for the starting point of the line. Click on the field and a dialog opens to select an element.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

More in the online help.

ZT_IMAGELIST

LineCapEnd

End type

Only available if you have activated project property Graphics quality.

Defines the symbol for the end point of the line. Click on the field and a dialog opens to select an element.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

More in the online help.

VT_R4

LineCapScale

Size

Only available if you have activated project property Graphics quality.

Defines the magnifying factor for the line width of the arrow. The factor relates to the line width of the vector element as defined in the Line width [Pixel] property.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

Value: greater or equal 1

Default: 4

More in the online help.

ZT_IMAGELIST

FillPattern

Filling pattern

Selection of the filling pattern for the element from the list.

This property is only available if property With brightness values is inactive.

More in the online help.

ZT_COLOR

LineColorEx

Line color

Defines the line color of the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

AlphaLineColor

Transparency line color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_UI1

AlphaBackColor

Transparency of the fill color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor2

Gradient color

Only available if for property Filling pattern Color gradient is selected and the project property Graphics quality is active.

Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of Fill color.

More in the online help.

VT_UI1

AlphaBackColor2

Transparency gradient color [%]

Only available if Linear was selected in the Filling pattern property.

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable2

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BackColorVariable2Preview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_I2

Lightning

Color gradient

Only available if property Filling pattern was set to Color gradient.

Defines the color gradient for vector elements.

Linear: steady gradient
Defined point: Gradient from a defined point to the edges of the element

Starting from a defined point with beams: Gradient from a defined point to the edges of the element with beams

More in the online help.

VT_I2

Align

Alignment

Direction of color shift.
horizontal
vertical

VT_I2

Shifted

Shifted color gradient

Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein.

Mehr im Online-Handbuch

VT_I2

ColorGradientOffset

Offset [%]

Only available if at a vector element the property Color gradient or at the dynamic element Button property Filling was set. linear or Starting from a defined point or Starting from a defined point with beams.

Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.

Values: 0 equals the center of the element. 100 the edge.
Note: The value can also be outside of the element and is therefore not limited to 100.

More in the online help.

VT_I2

ColorGradientAngle

Angle [°]

Defines the direction of the color gradient starting in the center of the element.

Values: 0° to 360°.

Default: 0°

More in the online help.

VT_BOOL

Brightness

With brightness values

Only available if Filling pattern was selected as color gradient was selected.

Active: The brightness of the color gradient can be freely defined.
Inactive: The brightness of the color gradient is defined automatically.

Note: The filling pattern can no longer be changed if this property is active. It is also not possible to set rounded corners. If this option is activated for an element that uses rounded corners, the element is displayed with non-rounded corners.

More in the online help.

VT_UI1

OuterBrightness

Brightness outside

Only available if "via brightness value" is active:
Brightness at the outer side of the element.

More in the online help.

VT_UI1

InnerBrightness

Brightness inside

Only available if "via brightness value" is active:
Brightness in the middle of the element.

More in the online help.

VT_BOOL

ALCUseColor

Color from ALC

Only available if you have licensed Automatic Line Coloring (ALC):
Active: The automatic color of the linked source(s) is used.
Inactive: The standard color is used.
Default: inactive.

More in the online help.

VT_I2

ALCPrecedence

Priority for display

Only available if the Color from ALC property is active.

Defines the priority of the display when the element is connected to several active sources.
Multiple supply: The element is displayed according to the rules of the multiple supply.
secured supply: The element is displayed according to the rules of the secured supply.
No priority: The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.

Default: Multiple supply
More in the online help.

VT_I2

ALCMultiSource

display multiple supplies

Only available if the property Color from ALC is active.
Defines the display type if the element is connected to several sources:
most prior source: Only the color of the source with the highest priority is used.
two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line.
alternative color: Alternative color for the coloring at multiple supply.

Default: highest priority source

More in the online help

VT_I2

ALCDashLen

Dashing length supplied multiple times

Only available if property display multiple supplies has value two highest prior sources.

Defines the dash length in pixel for the dashed ALC coloring at multiply supply.

Minimal: 0 (automatic dash length)

Maximum: 32767

Default: 0

More in the online help.

ZT_COLOR

ALCAlternativeColor

Alternative color

Only available if property display multiple supplies has value alternative color.

Alternative color for the ALC coloring at multiple supply.

More in the online help.

VT_I2

ALCMSecuredSupply

display secured supply

Only available if Color from ALC was activated.

Definition of the display of the secured supply:

  • double width
  • double brightness
  • normal

Default: normal

More in the online help

VT_BOOL

ALCAlias

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

ALCAliasName

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_R8

ALCReact

Reactance value of the cable [Ohm]

Maximum permitted reactance value of the line in ohms.

More in the online help.

VT_R8

ALCResist

Resistance value of the electric line [Ohm]

Maximum permitted resistance value of the line in ohms.

More in the online help.

VT_R8

ALCLength

Length of the line [km]

ALC line: Length of the line.

More in the online help.

VT_I2

ALCMaxIType

Limit current carrying capacity

ALC switch: Limit value of current capacity [selection of fixed/variable].

More in the online help.

VT_R8

ALCMaxIVal

Limit fixed current carrying capacity [A]

ALC switch: Limit fixed current carrying capacity.

More in the online help.

ZT_VARIABLE_DYN

ALCVarMaxI

Limit variable current carrying capacity

More...

ALCVarMaxIEx

ALCVarMaxIEx

ZT_VARIABLE_DYN

ALCVarCalcI

Measuring value of the calculated current flow

ALC line: Measuring value of the calculated current flow.

More in the online help.

More...

ALCVarCalcIEx

ALCVarCalcIEx

ALC Leitung: Messwert des berechneten Stromflusses für Export.

Mehr in der Online-Hilfe.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Frame vector

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Frame vector

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_I2

Combine

Area utilization

Define what effects the created element should have on the frame.

The following settings are available:

Cover: The surface of the element is used as the screen area.

Cut: The surface of the element is removed from the surfaces underneath

ORed: This is either cut out or covered according to whether a covering element is under the element or not

Note: The way the surface is used always relates to the surface under the element.

For newly created elements always the settings which was selected last is used.

More in the online help.

VT_BOOL

CornerProportional

Proportional

Only available if property With brightness values is inactive.

Active: For creating a radiused corner only the x value can be entered. The y value is always the same.

The percentage entered at property All x [%] refers to the shorter side (width or height) of the element.

Inactive: The x and y values can be entered freely. The x value refers to the width of the element. The y value refers to the height of the element.

Default: active

More in the online help.

VT_I4

CornerAll_X

All x [%]

Only available if property With brightness values is inactive.

Defines the radius values of the X-axis in percent for all corners. This value is used for all corners whose values equals -1. Individual corners can therefore be defined independently.

If the radius value is changed, all corners automatically receive the value -1. With this all corners are set back to the pre-defined value.

Value range: 0 % to 100 %.

Default: 20

More in the online help.

VT_I4

CornerAll_Y

All y [%]

Only available if the property Proportional is active and the property With brightness values is inactive.

Defines the radius values of the Y-axis in percent for all corners. This value is used for all corners whose values equals -1. Individual corners can therefore be defined independently.

If the radius value is changed, all corners automatically receive the value -1. With this all corners are set back to the pre-defined value.

Value range: 0 % to 100 %.

Default: 20

More in the online help.

VT_I4

CornerLeftTop_X

Left/top x [%]

Only available if the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the X-axis for the top left corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All x [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerLeftTop_Y

Left/top y [%]

Only available if the property Proportional is active, the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the Y-axis for the top left corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All y [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerRightTop_X

Right/top x [%]

Only available if the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the X-axis for the top right corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All x [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerRightTop_Y

Right/top y [%]

Only available if the property Proportional is active, the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the Y-axis for the top right corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All y [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerRightBottom_X

Right/bottom x [%]

Only available if property With brightness values is inactive.

Defines the radius value of the X-axis for the bottom right corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All x [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerRightBottom_Y

Right/bottom y [%]

Only available if the property Proportional is active, the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the Y-axis for the bottom right corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All y [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerLeftBottom_X

Left/bottom x [%]

Only available if the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the X-axis for the bottom left corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All x [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerLeftBottom_Y

Left/bottom y [%]

Only available if the property Proportional is active, the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the Y-axis for the bottom left corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All y [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

ZT_COLOR

LineColor

Line color

Line color of the element.

VT_UI2

LineWidth

Line width [Pixel]

Width of the line (in pixels).
Minimum: 0
In this case the width of the line is 1 pixel.
Maximum: 40
Default: 1
Attention: If in the project settings in node Graphical design you set property Graphics quality to Windows basis, you can use line width >1 only with a line of type "continuous line".

More in the online help.

ZT_IMAGELIST

LineType

Line type

Selection of the line type for the element from the list.
Attention: If in the project settings in node Graphical design you deactivated property Graphics quality, you can use line width >1 only with a line of type "continuous line".
More in the online help.

ZT_IMAGELIST

LineCapStart

Start type

Only available if you have activated project property Graphics quality.

Defines the symbol for the starting point of the line. Click on the field and a dialog opens to select an element.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

More in the online help.

ZT_IMAGELIST

LineCapEnd

End type

Only available if you have activated project property Graphics quality.

Defines the symbol for the end point of the line. Click on the field and a dialog opens to select an element.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

More in the online help.

VT_R4

LineCapScale

Size

Only available if you have activated project property Graphics quality.

Defines the magnifying factor for the line width of the arrow. The factor relates to the line width of the vector element as defined in the Line width [Pixel] property.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

Value: greater or equal 1

Default: 4

More in the online help.

ZT_IMAGELIST

FillPattern

Filling pattern

Selection of the filling pattern for the element from the list.

This property is only available if property With brightness values is inactive.

More in the online help.

ZT_COLOR

LineColorEx

Line color

Defines the line color of the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

AlphaLineColor

Transparency line color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_UI1

AlphaBackColor

Transparency of the fill color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor2

Gradient color

Only available if for property Filling pattern Color gradient is selected and the project property Graphics quality is active.

Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of Fill color.

More in the online help.

VT_UI1

AlphaBackColor2

Transparency gradient color [%]

Only available if Linear was selected in the Filling pattern property.

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable2

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BackColorVariable2Preview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_I2

Lightning

Color gradient

Only available if property Filling pattern was set to Color gradient.

Defines the color gradient for vector elements.

Linear: steady gradient
Defined point: Gradient from a defined point to the edges of the element

Starting from a defined point with beams: Gradient from a defined point to the edges of the element with beams

More in the online help.

VT_I2

Align

Alignment

Direction of color shift.
horizontal
vertical

VT_I2

Shifted

Shifted color gradient

Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein.

Mehr im Online-Handbuch

VT_I2

ColorGradientOffset

Offset [%]

Only available if at a vector element the property Color gradient or at the dynamic element Button property Filling was set. linear or Starting from a defined point or Starting from a defined point with beams.

Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.

Values: 0 equals the center of the element. 100 the edge.
Note: The value can also be outside of the element and is therefore not limited to 100.

More in the online help.

VT_I2

ColorGradientAngle

Angle [°]

Defines the direction of the color gradient starting in the center of the element.

Values: 0° to 360°.

Default: 0°

More in the online help.

VT_BOOL

Brightness

With brightness values

Only available if Filling pattern was selected as color gradient was selected.

Active: The brightness of the color gradient can be freely defined.
Inactive: The brightness of the color gradient is defined automatically.

Note: The filling pattern can no longer be changed if this property is active. It is also not possible to set rounded corners. If this option is activated for an element that uses rounded corners, the element is displayed with non-rounded corners.

More in the online help.

VT_UI1

OuterBrightness

Brightness outside

Only available if "via brightness value" is active:
Brightness at the outer side of the element.

More in the online help.

VT_UI1

InnerBrightness

Brightness inside

Only available if "via brightness value" is active:
Brightness in the middle of the element.

More in the online help.

VT_BOOL

ALCUseColor

Color from ALC

Only available if you have licensed Automatic Line Coloring (ALC):
Active: The automatic color of the linked source(s) is used.
Inactive: The standard color is used.
Default: inactive.

More in the online help.

VT_I2

ALCPrecedence

Priority for display

Only available if the Color from ALC property is active.

Defines the priority of the display when the element is connected to several active sources.
Multiple supply: The element is displayed according to the rules of the multiple supply.
secured supply: The element is displayed according to the rules of the secured supply.
No priority: The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.

Default: Multiple supply
More in the online help.

VT_I2

ALCMultiSource

display multiple supplies

Only available if the property Color from ALC is active.
Defines the display type if the element is connected to several sources:
most prior source: Only the color of the source with the highest priority is used.
two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line.
alternative color: Alternative color for the coloring at multiple supply.

Default: highest priority source

More in the online help

VT_I2

ALCDashLen

Dashing length supplied multiple times

Only available if property display multiple supplies has value two highest prior sources.

Defines the dash length in pixel for the dashed ALC coloring at multiply supply.

Minimal: 0 (automatic dash length)

Maximum: 32767

Default: 0

More in the online help.

ZT_COLOR

ALCAlternativeColor

Alternative color

Only available if property display multiple supplies has value alternative color.

Alternative color for the ALC coloring at multiple supply.

More in the online help.

VT_I2

ALCMSecuredSupply

display secured supply

Only available if Color from ALC was activated.

Definition of the display of the secured supply:

  • double width
  • double brightness
  • normal

Default: normal

More in the online help

VT_BOOL

ALCAlias

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

ALCAliasName

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_R8

ALCReact

Reactance value of the cable [Ohm]

Maximum permitted reactance value of the line in ohms.

More in the online help.

VT_R8

ALCResist

Resistance value of the electric line [Ohm]

Maximum permitted resistance value of the line in ohms.

More in the online help.

VT_R8

ALCLength

Length of the line [km]

ALC line: Length of the line.

More in the online help.

VT_I2

ALCMaxIType

Limit current carrying capacity

ALC switch: Limit value of current capacity [selection of fixed/variable].

More in the online help.

VT_R8

ALCMaxIVal

Limit fixed current carrying capacity [A]

ALC switch: Limit fixed current carrying capacity.

More in the online help.

ZT_VARIABLE_DYN

ALCVarMaxI

Limit variable current carrying capacity

More...

ALCVarMaxIEx

ALCVarMaxIEx

ZT_VARIABLE_DYN

ALCVarCalcI

Measuring value of the calculated current flow

ALC line: Measuring value of the calculated current flow.

More in the online help.

More...

ALCVarCalcIEx

ALCVarCalcIEx

ALC Leitung: Messwert des berechneten Stromflusses für Export.

Mehr in der Online-Hilfe.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Batch recipe editor control

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Batch recipe editor control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

WithTBs

Toolbars

Active: Toolbars are displayed in the recipe editor.

Inactive: Toolbars are not displayed in the recipe editor. Recommended if the actions of the individual symbols are assigned to their own buttons.

Default: active

More in the online help.

VT_BOOL

WithPanes

Dockable windows

Active: The list of dockable windows is shown in the recipe editor.

Inactive: The list of dockable windows is not shown in the recipe editor.

Default: active

More in the online help.

VT_BOOL

ShowBorder

Show border lines

Makes it possible to display a frame around the element. The flags of the properties Style L and Style H are masked out.

active: The frame is displayed around the respective element.

(Default) Inactive:

More in the online help

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_BOOL

TranslateText

Translate displayed text

Active: The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.

Default: inactive

More in the online help.

VT_UI2

StyleL

Style L

Windows style of the element, for internal use only.

More in the online help.

VT_UI2

StyleH

Style H

Windows style of the element, for internal use only.

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BSTR

Legend

Text

Label of the element in the Editor.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

ZT_SHORTCUT

ShortCut

Key combination

Shortcuts support executing operable elements. For example:

- Executing control elements and functions which have an element assigned
- Write set value (e.g. for switches)
- Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)

A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly.

More in the online help.

VT_BOOL

KbdUsage

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


MDI element

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> MDI element

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_BOOL

TranslateText

Translate displayed text

Active: The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.

Default: inactive

More in the online help.

VT_UI2

StyleL

Style L

Windows style of the element, for internal use only.

More in the online help.

VT_UI2

StyleH

Style H

Windows style of the element, for internal use only.

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BSTR

Legend

Text

Label of the element in the Editor.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

ZT_SHORTCUT

ShortCut

Key combination

Shortcuts support executing operable elements. For example:

- Executing control elements and functions which have an element assigned
- Write set value (e.g. for switches)
- Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)

A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly.

More in the online help.

VT_BOOL

KbdUsage

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


CControlDynCalendarCtrl

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> CControlDynCalendarCtrl

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

ShowBorder

Show border lines

Makes it possible to display a frame around the element. The flags of the properties Style L and Style H are masked out.

active: The frame is displayed around the respective element.

(Default) Inactive:

More in the online help

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_BOOL

TranslateText

Translate displayed text

Active: The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.

Default: inactive

More in the online help.

VT_UI2

StyleL

Style L

Windows style of the element, for internal use only.

More in the online help.

VT_UI2

StyleH

Style H

Windows style of the element, for internal use only.

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BSTR

Legend

Text

Label of the element in the Editor.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

ZT_SHORTCUT

ShortCut

Key combination

Shortcuts support executing operable elements. For example:

- Executing control elements and functions which have an element assigned
- Write set value (e.g. for switches)
- Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)

A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly.

More in the online help.

VT_BOOL

KbdUsage

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Window

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Window

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

ShowBorder

Show border lines

Makes it possible to display a frame around the element. The flags of the properties Style L and Style H are masked out.

active: The frame is displayed around the respective element.

(Default) Inactive:

More in the online help

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_BOOL

TranslateText

Translate displayed text

Active: The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.

Default: inactive

More in the online help.

VT_UI2

StyleL

Style L

Windows style of the element, for internal use only.

More in the online help.

VT_UI2

StyleH

Style H

Windows style of the element, for internal use only.

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BSTR

Legend

Text

Label of the element in the Editor.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

ZT_SHORTCUT

ShortCut

Key combination

Shortcuts support executing operable elements. For example:

- Executing control elements and functions which have an element assigned
- Write set value (e.g. for switches)
- Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)

A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly.

More in the online help.

VT_BOOL

KbdUsage

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Combobox

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Combobox

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

ShowBorder

Show border lines

Makes it possible to display a frame around the element. The flags of the properties Style L and Style H are masked out.

active: The frame is displayed around the respective element.

(Default) Inactive:

More in the online help

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_BOOL

TranslateText

Translate displayed text

Active: The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.

Default: inactive

More in the online help.

VT_UI2

StyleL

Style L

Windows style of the element, for internal use only.

More in the online help.

VT_UI2

StyleH

Style H

Windows style of the element, for internal use only.

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BSTR

Legend

Text

Label of the element in the Editor.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

ZT_SHORTCUT

ShortCut

Key combination

Shortcuts support executing operable elements. For example:

- Executing control elements and functions which have an element assigned
- Write set value (e.g. for switches)
- Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)

A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly.

More in the online help.

VT_BOOL

KbdUsage

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Dynamic window list control

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Dynamic window list control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

ShowBoolAsNumber

Numerical display

Active: Binary values are displayed numerically in Runtime. If the list element allows it, binary values can also be entered numerically.

More in the online help.

ZT_FILE

CheckOnImage

On (inactive)

Selection of a graphic which displays status "value is 1 and property cannot be edited"
Only available if the Numerical display property is inactive.

More in the online help.

ZT_FILE

CheckOffImage

Off (inactive)

Selection of a graphic which displays status "value is 0 and property cannot be edited"
Only available if the Numerical display property is inactive.

More in the online help.

ZT_FILE

CheckOnImageInActive

On (inactive)

Selection of a graphic which displays status "value is 1 and property cannot be edited"
Only available if the Numerical display property is inactive.

More in the online help.

ZT_FILE

CheckOffImageInActive

Off (inactive)

Selection of a graphic which displays status "value is 0 and property cannot be edited"
Only available if the Numerical display property is inactive.

More in the online help.

VT_BOOL

ShowHeader

Show header
  • Active: The header is displayed in Runtime.
  • Inactive: The header is not shown in Runtime. The filter line is thus also not shown, but configured filters continue to be used.

More in the online help.

VT_BOOL

ShowFilter

Display filter line
  • Active: The filter line is displayed in Runtime.
  • Inactive: The filter line is not shown in Runtime.
    Note: Configured filters are also implemented if the filter line is not shown.

More in the online help.

VT_BOOL

HeaderStatic

Static header
  • Active: Columns can no longer be moved by dragging & dropping in Runtime and also cannot be sorted. The column width can be adjusted again.

More in the online help.

VT_UI4

HeaderHeight

Height of the header [in pixels]

Configuration of the height of the header in pixels.

Minimum: 0 - height is automatically determined using the font size.

Maximum: 255

Default: 0

More in the online help.

VT_BOOL

AdvancedStyleH

Scroll bars

Properties for the horizontal and the vertical scroll bars.

More in the online help for AML.

More in the online help for CEL.

More in the online help for ETM.

More in the online help for RGM.

VT_UI4

RowHeight

Line height [pixel]

Makes it possible to define the row height in pixels independent of the font size.

Maximum value: 255 px
Minimum value: 0 px - row height is adapted to font size.

Default: 0

Attention: If the row height

  • is selected is too large, nothing is displayed in Runtime in certain circumstances.
  • is selected as smaller than the font size, then graphical illustrations are cut off.

More in the online help.

VT_I2

BarStyleH

Display style

Only available if you activated property Extended graphical settings.

Define how the header of the list field should look like. Select on of the following options:

Color gradient: Uses a special color gradient for the header. You can customize the color gradient with the help of properties Fill color, Gradient color, Color gradient, Offset [%] and Angle [°].

Graphics file: Uses the selected graphics file for the individual areas. If no graphics file has been selected, the display Color gradient is used.

Standard: Uses the standard setting for the header. You can only change the font and the text color with the help of the respective setting.

Default: Standard.

More in the online help.

VT_I2

ButtonHeightH

Height scroll arrow [Pixel]

Define the height of the scroll arrow in pixel for the horizontal scroll bar. Adjust the value to your ideas.

Default: 12.

More in the online help.

VT_I2

ButtonWidthH

Width scroll arrow [Pixel]

Define the width of the scroll arrow in pixel for the horizontal scroll bar. Adjust the value to your ideas.

Default: 12.

More in the online help.

VT_I2

ThumbSizeH

Width scroll box [Pixel]

Define the width of the scroll box in pixel for the horizontal scroll bar. Adjust the value to your ideas.

Default: 20.

More in the online help.

ZT_COLOR

BackColorH

Fill color

Define the first filling color which is used for the color gradient for the horizontal scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

ZT_COLOR

BackColor2H

Gradient color

This property only has an effect if you have selected color gradient for the Display style property.

Define the second filling color which is used for the color gradient for the horizontal scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property Fill color.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

VT_I2

LightningH

Color gradient

Select the type of the color gradient for the horizontal scroll bar from the following options:

Linear: steady gradient

Defined point: Gradient from the defined point to the edges of the element

Starting from a defined point with beams: Gradient with beams from the defined point to the edges of the element

Default: Linear

More in the online help.

VT_I2

ColorGradientOffsetH

Offset [%]

Define the distance of the color gradient point from the center of the horizontal scroll bar to the left or the right in percent. 0 means the center of the horizontal scroll bar, 100 means the right edge of the horizontal scroll bar and -100 means the left edge of the horizontal scroll bar.

Minimum: -100

Maximum: 100

Default: 0

More in the online help.

VT_I2

ColorGradientAngleH

Angle [°]

Only available if you activated property Extended graphical settings.

This property only has an effect if you have selected color gradient for the Display style property.

Define the angle in whose direction the color gradient spreads. As starting point the point defined in property Offset [%] is used.

Minimum: 0

Maximum: 360

Default: 0

More in the online help.

ZT_FILE

BitmapLeftH

Scroll arrow left

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the left scroll arrow for the horizontal scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapRightH

Scroll arrow right

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the right scroll arrow for the horizontal scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapThumbH

Scroll box

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the scroll box for the horizontal scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapSpanH

Background graphics file

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field as background for the horizontal scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

VT_I2

BarStyleV

Display style

Only available if you activated property Extended graphical settings.

Define how the header of the list field should look like. Select on of the following options:

Color gradient: Uses a special color gradient for the header. You can customize the color gradient with the help of properties Fill color, Gradient color, Color gradient, Offset [%] and Angle [°].

Graphics file: Uses the selected graphics file for the individual areas. If no graphics file has been selected, the display Color gradient is used.

Standard: Uses the standard setting for the header. You can only change the font and the text color with the help of the respective setting.

Default: Standard.

More in the online help.

VT_I2

ButtonHeightV

Height scroll arrow [Pixel]

Define the height of the scroll arrow in pixel for the vertical scroll bar. Adjust the value to your ideas.

Default: 12.

More in the online help.

VT_I2

ButtonWidthV

Width scroll arrow [Pixel]

Define the width of the scroll arrow in pixel for the vertical scroll bar. Adjust the value to your ideas.

Default: 12.

More in the online help.

VT_I2

ThumbSizeV

Width scroll box [Pixel]

Define the width of the scroll box in pixel for the vertical scroll bar. Adjust the value to your ideas.

Default: 20.

More in the online help.

ZT_COLOR

BackColorV

Fill color

Define the first filling color which is used for the color gradient for the vertical scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

ZT_COLOR

BackColor2V

Gradient color

This property only has an effect if you have selected color gradient for the Display style property.

Define the second filling color which is used for the color gradient for the vertical scroll bar. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property Fill color.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

VT_I2

LightningV

Color gradient

Select the type of the color gradient for the vertical scroll bar from the following options:

Linear: steady gradient

Defined point: Gradient from the defined point to the edges of the element

Starting from a defined point with beams: Gradient with beams from the defined point to the edges of the element

Default: Linear

More in the online help.

VT_I2

ColorGradientOffsetV

Offset [%]

Define the distance of the color gradient point from the center of the vertical scroll bar to the left or the right in percent. 0 means the center of the vertical scroll bar, 100 means the right edge of the vertical scroll bar and -100 means the left edge of the vertical scroll bar.

Minimum: -100

Maximum: 100

Default: 0

More in the online help.

VT_I2

ColorGradientAngleV

Angle [°]

Only available if you activated property Extended graphical settings.

This property only has an effect if you have selected color gradient for the Display style property.

Define the angle in whose direction the color gradient spreads. As starting point the point defined in property Offset [%] is used.

Minimum: 0

Maximum: 360

Default: 0

More in the online help.

ZT_FILE

BitmapLeftV

Scroll arrow up

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the up scroll arrow for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapRightV

Scroll arrow down

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the down scroll arrow for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapThumbV

Scroll box

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the scroll box for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapSpanV

Background graphics file

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field as background for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

VT_BOOL

ShowHeader

Show header

Only available if you have selected operable header or fixed header in group in the project settings in the Alarm Message List group for the Header AML property or in the Chronological Event List group for the Header CEL property.
Availability for the cursor output list in the Extended Trend.

Displays the header for the respective list field. In group Header you can customize the look of the header.

active: The header is displayed.

Default: active

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

VT_BOOL

EnableHeader

Make header editable

Only available if you selected operable header in group Alarm Message List for property Header AML or in group Chronological Event List for property Header CEL.

Availability for the cursor output list in the Extended Trend.

Makes it possible to operate the header for the respective list field. In the Runtime you can move the individual columns and change their width. You can sort the display by any column.

active: The header can be operated.

Default: active

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

VT_I2

HeaderStyle

Display style

Only available if you have selected operable header or fixed header in group in the project settings in the Alarm Message List group for the Header AML property or in the Chronological Event List group for the Header CEL property. Furthermore, you must also activate the properties Extended graphical settings and Show header for the respective list field.

Availability for the cursor output list in the Extended Trend.

Define how the header of the list field should look like. Select on of the following options:

Color gradient: Uses a special color gradient for the header. You can customize the color gradient with the help of properties Fill color, Gradient color, Light effect, Offset and Angle.

Graphics file: Uses the selected graphics file for the individual areas. If no graphics file has been selected, the display Color gradient is used.

Default:: Uses the standard setting for the header. You can only change the Font and the Text color with the help of the respective setting.

Default: Standard.

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_SCHRIFT

HeaderFont

Text color

Define the color which should be used for the text in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_COLOR

HeaderBackColor

Fill color

Define the first filling color which is used for the color gradient in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_COLOR

HeaderBackColor2

Gradient color

Only available if you have selected operable header or fixed header in group in the project settings in the Alarm Message List group for the Header AML property or in the Chronological Event List group for the Header CEL property. Furthermore, you must also activate the properties Extended graphical settings and Show header for the respective list field.

Availability for the cursor output list in the Extended Trend.

This property only has an effect if you have selected color gradient for the Display style property.

Define the second fill color which is used for the color gradient in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property Fill color.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help AML

More in the online help CEL

More in the online help for ETM

ZT_COLOR

HeaderFontColor

Text color

Define the color which should be used for the text in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

VT_I2

HeaderLightning

Light effect

Select the type of the color gradient for the header from the following options:

Linear: steady gradient

Defined point: Gradient from the defined point to the edges of the element

Starting from a defined point with beams: Gradient with beams from the defined point to the edges of the element

Default: Linear

More in the online help AML

More in the online help CEL

More in the online help for ETM

VT_I2

HeaderColorGradientOffset

Offset

Define the distance of the color gradient from the center of the header to the left or the right in percent. 0 means the center of the header, 100 means the right edge of the header and -100 means the left edge of the header.

Minimum: -100

Maximum: 100

Default: 0

More in the online help AML

More in the online help CEL

More in the online help for ETM

VT_I2

HeaderColorGradientAngle

Angle

Only available if you have selected operable header or fixed header in group in the project settings in the Alarm Message List group for the Header AML property or in the Chronological Event List group for the Header CEL property. Furthermore, you must also activate the properties Extended graphical settings and Show header for the respective list field.

Availability for the cursor output list in the Extended Trend.

This property only has an effect if you have selected color gradient for the Display style property.

Define the angle in whose direction the color gradient spreads. As starting point the point defined in property Offset is used.

Minimum: 0

Maximum: 360

Default: 0

More in the online help AML

More in the online help CEL

More in the online help for ETM

ZT_FILE

AscSortImage

Sort ascending

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the header of the list field for ascending sort in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_FILE

DescDownImage

Sort descending

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the header of the list field for descending sort in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_FILE

HeaderBarImage

Background

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the header of the list field as background in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

VT_UI2

GridSizeH

Horizontal line width [Pixel]

Width of the horizontal grid line in pixel. Change this value in order to change the horizontal lines of the grid of the list view in the Runtime. If you enter 0, the horizontal lines are hidden.

Default: 1.

More in the online help.

ZT_IMAGELIST

GridTypeH

Horizontal line type

Defines the type of the horizontal grid lines in the list view in the Runtime. Click on the line and select the desired line type (solid line, broken line, dashed line etc.).

Default: solid line.

Attention: This property is available if the value for property Horizontal line width [Pixel] is 1. For values >1 a solid line is used.

Note: The grid is only shown if the grid is activated in the screen switching function or in the filter in Runtime.

More in the online help.

ZT_COLOR

GridColorH

Horizontal line color

Defines the line color of the horizontal grid lines in the list view in the Runtime. Left-clicking on the button opens the palette of the pre-defined colors. You can enter the desired color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

VT_UI2

GridSizeV

Vertical line width [Pixel]

Width of the vertical grid line in pixel. Change this value in order to change the vertical lines of the grid of the list view in the Runtime. If you enter 0, the vertical lines are hidden.

Default: 1.

More in the online help.

ZT_IMAGELIST

GridTypeV

Vertical line type

Defines the type of the vertical grid lines in the list view in the Runtime. Click on the line and select the desired line type (solid line, broken line, dashed line etc.).

Default: solid line.

Attention: This property is available if the value for property Vertical line width [Pixel] is 1. For values >1 a solid line is used.

Note: The grid is only shown if the grid is activated in the screen switching function or in the filter in Runtime.

More in the online help.

ZT_COLOR

GridColorV

Vertical line color

Defines the line color of the horizontal grid lines in the list view in the Runtime. Left-clicking on the button opens the palette of the pre-defined colors. You can enter the desired color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_BOOL

TranslateText

Translate displayed text

Active: The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.

Default: inactive

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BSTR

Legend

Text

Label of the element in the Editor.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

ZT_SHORTCUT

ShortCut

Key combination

Shortcuts support executing operable elements. For example:

- Executing control elements and functions which have an element assigned
- Write set value (e.g. for switches)
- Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)

A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly.

More in the online help.

VT_BOOL

KbdUsage

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Dynamic window batch parameter list

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Dynamic window batch parameter list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

IsSetValue

Setting values active

Active: Setting of variables for this dynamic element is allowed.
Inactive: The variable is write-protected in this element.

More in the online help.

VT_BOOL

ShowBoolAsNumber

Numerical display

Active: Binary values are displayed numerically in Runtime. If the list element allows it, binary values can also be entered numerically.

More in the online help.

ZT_FILE

CheckOnImage

On (inactive)

Selection of a graphic which displays status "value is 1 and property cannot be edited"
Only available if the Numerical display property is inactive.

More in the online help.

ZT_FILE

CheckOffImage

Off (inactive)

Selection of a graphic which displays status "value is 0 and property cannot be edited"
Only available if the Numerical display property is inactive.

More in the online help.

ZT_FILE

CheckOnImageInActive

On (inactive)

Selection of a graphic which displays status "value is 1 and property cannot be edited"
Only available if the Numerical display property is inactive.

More in the online help.

ZT_FILE

CheckOffImageInActive

Off (inactive)

Selection of a graphic which displays status "value is 0 and property cannot be edited"
Only available if the Numerical display property is inactive.

More in the online help.

VT_BOOL

ShowHeader

Show header
  • Active: The header is displayed in Runtime.
  • Inactive: The header is not shown in Runtime. The filter line is thus also not shown, but configured filters continue to be used.

More in the online help.

VT_BOOL

ShowFilter

Display filter line
  • Active: The filter line is displayed in Runtime.
  • Inactive: The filter line is not shown in Runtime.
    Note: Configured filters are also implemented if the filter line is not shown.

More in the online help.

VT_BOOL

HeaderStatic

Static header
  • Active: Columns can no longer be moved by dragging & dropping in Runtime and also cannot be sorted. The column width can be adjusted again.

More in the online help.

VT_UI4

HeaderHeight

Height of the header [in pixels]

Configuration of the height of the header in pixels.

Minimum: 0 - height is automatically determined using the font size.

Maximum: 255

Default: 0

More in the online help.

VT_BOOL

HideSelection

Do not mark selected row

With this you define whether the selected line is highlighted in the list field. If you activate this property, you do not see which entry you have selected. All lines of the list look the same.

Default: Inactive.

More in the online help for AML

More in the online help for CEL

VT_BOOL

AdvancedStyleH

Scroll bars

Properties for the horizontal and the vertical scroll bars.

More in the online help for AML.

More in the online help for CEL.

More in the online help for ETM.

More in the online help for RGM.

VT_UI4

RowHeight

Line height [pixel]

Makes it possible to define the row height in pixels independent of the font size.

Maximum value: 255 px
Minimum value: 0 px - row height is adapted to font size.

Default: 0

Attention: If the row height

  • is selected is too large, nothing is displayed in Runtime in certain circumstances.
  • is selected as smaller than the font size, then graphical illustrations are cut off.

More in the online help.

VT_I2

BarStyleH

Display style

Only available if you activated property Extended graphical settings.

Define how the header of the list field should look like. Select on of the following options:

Color gradient: Uses a special color gradient for the header. You can customize the color gradient with the help of properties Fill color, Gradient color, Color gradient, Offset [%] and Angle [°].

Graphics file: Uses the selected graphics file for the individual areas. If no graphics file has been selected, the display Color gradient is used.

Standard: Uses the standard setting for the header. You can only change the font and the text color with the help of the respective setting.

Default: Standard.

More in the online help.

VT_I2

ButtonHeightH

Height scroll arrow [Pixel]

Define the height of the scroll arrow in pixel for the horizontal scroll bar. Adjust the value to your ideas.

Default: 12.

More in the online help.

VT_I2

ButtonWidthH

Width scroll arrow [Pixel]

Define the width of the scroll arrow in pixel for the horizontal scroll bar. Adjust the value to your ideas.

Default: 12.

More in the online help.

VT_I2

ThumbSizeH

Width scroll box [Pixel]

Define the width of the scroll box in pixel for the horizontal scroll bar. Adjust the value to your ideas.

Default: 20.

More in the online help.

ZT_COLOR

BackColorH

Fill color

Define the first filling color which is used for the color gradient for the horizontal scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

ZT_COLOR

BackColor2H

Gradient color

This property only has an effect if you have selected color gradient for the Display style property.

Define the second filling color which is used for the color gradient for the horizontal scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property Fill color.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

VT_I2

LightningH

Color gradient

Select the type of the color gradient for the horizontal scroll bar from the following options:

Linear: steady gradient

Defined point: Gradient from the defined point to the edges of the element

Starting from a defined point with beams: Gradient with beams from the defined point to the edges of the element

Default: Linear

More in the online help.

VT_I2

ColorGradientOffsetH

Offset [%]

Define the distance of the color gradient point from the center of the horizontal scroll bar to the left or the right in percent. 0 means the center of the horizontal scroll bar, 100 means the right edge of the horizontal scroll bar and -100 means the left edge of the horizontal scroll bar.

Minimum: -100

Maximum: 100

Default: 0

More in the online help.

VT_I2

ColorGradientAngleH

Angle [°]

Only available if you activated property Extended graphical settings.

This property only has an effect if you have selected color gradient for the Display style property.

Define the angle in whose direction the color gradient spreads. As starting point the point defined in property Offset [%] is used.

Minimum: 0

Maximum: 360

Default: 0

More in the online help.

ZT_FILE

BitmapLeftH

Scroll arrow left

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the left scroll arrow for the horizontal scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapRightH

Scroll arrow right

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the right scroll arrow for the horizontal scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapThumbH

Scroll box

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the scroll box for the horizontal scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapSpanH

Background graphics file

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field as background for the horizontal scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

VT_I2

BarStyleV

Display style

Only available if you activated property Extended graphical settings.

Define how the header of the list field should look like. Select on of the following options:

Color gradient: Uses a special color gradient for the header. You can customize the color gradient with the help of properties Fill color, Gradient color, Color gradient, Offset [%] and Angle [°].

Graphics file: Uses the selected graphics file for the individual areas. If no graphics file has been selected, the display Color gradient is used.

Standard: Uses the standard setting for the header. You can only change the font and the text color with the help of the respective setting.

Default: Standard.

More in the online help.

VT_I2

ButtonHeightV

Height scroll arrow [Pixel]

Define the height of the scroll arrow in pixel for the vertical scroll bar. Adjust the value to your ideas.

Default: 12.

More in the online help.

VT_I2

ButtonWidthV

Width scroll arrow [Pixel]

Define the width of the scroll arrow in pixel for the vertical scroll bar. Adjust the value to your ideas.

Default: 12.

More in the online help.

VT_I2

ThumbSizeV

Width scroll box [Pixel]

Define the width of the scroll box in pixel for the vertical scroll bar. Adjust the value to your ideas.

Default: 20.

More in the online help.

ZT_COLOR

BackColorV

Fill color

Define the first filling color which is used for the color gradient for the vertical scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

ZT_COLOR

BackColor2V

Gradient color

This property only has an effect if you have selected color gradient for the Display style property.

Define the second filling color which is used for the color gradient for the vertical scroll bar. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property Fill color.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

VT_I2

LightningV

Color gradient

Select the type of the color gradient for the vertical scroll bar from the following options:

Linear: steady gradient

Defined point: Gradient from the defined point to the edges of the element

Starting from a defined point with beams: Gradient with beams from the defined point to the edges of the element

Default: Linear

More in the online help.

VT_I2

ColorGradientOffsetV

Offset [%]

Define the distance of the color gradient point from the center of the vertical scroll bar to the left or the right in percent. 0 means the center of the vertical scroll bar, 100 means the right edge of the vertical scroll bar and -100 means the left edge of the vertical scroll bar.

Minimum: -100

Maximum: 100

Default: 0

More in the online help.

VT_I2

ColorGradientAngleV

Angle [°]

Only available if you activated property Extended graphical settings.

This property only has an effect if you have selected color gradient for the Display style property.

Define the angle in whose direction the color gradient spreads. As starting point the point defined in property Offset [%] is used.

Minimum: 0

Maximum: 360

Default: 0

More in the online help.

ZT_FILE

BitmapLeftV

Scroll arrow up

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the up scroll arrow for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapRightV

Scroll arrow down

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the down scroll arrow for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapThumbV

Scroll box

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the scroll box for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapSpanV

Background graphics file

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field as background for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

VT_BOOL

ShowHeader

Show header

Only available if you have selected operable header or fixed header in group in the project settings in the Alarm Message List group for the Header AML property or in the Chronological Event List group for the Header CEL property.
Availability for the cursor output list in the Extended Trend.

Displays the header for the respective list field. In group Header you can customize the look of the header.

active: The header is displayed.

Default: active

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

VT_BOOL

EnableHeader

Make header editable

Only available if you selected operable header in group Alarm Message List for property Header AML or in group Chronological Event List for property Header CEL.

Availability for the cursor output list in the Extended Trend.

Makes it possible to operate the header for the respective list field. In the Runtime you can move the individual columns and change their width. You can sort the display by any column.

active: The header can be operated.

Default: active

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

VT_I2

HeaderStyle

Display style

Only available if you have selected operable header or fixed header in group in the project settings in the Alarm Message List group for the Header AML property or in the Chronological Event List group for the Header CEL property. Furthermore, you must also activate the properties Extended graphical settings and Show header for the respective list field.

Availability for the cursor output list in the Extended Trend.

Define how the header of the list field should look like. Select on of the following options:

Color gradient: Uses a special color gradient for the header. You can customize the color gradient with the help of properties Fill color, Gradient color, Light effect, Offset and Angle.

Graphics file: Uses the selected graphics file for the individual areas. If no graphics file has been selected, the display Color gradient is used.

Default:: Uses the standard setting for the header. You can only change the Font and the Text color with the help of the respective setting.

Default: Standard.

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_SCHRIFT

HeaderFont

Text color

Define the color which should be used for the text in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_COLOR

HeaderBackColor

Fill color

Define the first filling color which is used for the color gradient in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_COLOR

HeaderBackColor2

Gradient color

Only available if you have selected operable header or fixed header in group in the project settings in the Alarm Message List group for the Header AML property or in the Chronological Event List group for the Header CEL property. Furthermore, you must also activate the properties Extended graphical settings and Show header for the respective list field.

Availability for the cursor output list in the Extended Trend.

This property only has an effect if you have selected color gradient for the Display style property.

Define the second fill color which is used for the color gradient in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property Fill color.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help AML

More in the online help CEL

More in the online help for ETM

ZT_COLOR

HeaderFontColor

Text color

Define the color which should be used for the text in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

VT_I2

HeaderLightning

Light effect

Select the type of the color gradient for the header from the following options:

Linear: steady gradient

Defined point: Gradient from the defined point to the edges of the element

Starting from a defined point with beams: Gradient with beams from the defined point to the edges of the element

Default: Linear

More in the online help AML

More in the online help CEL

More in the online help for ETM

VT_I2

HeaderColorGradientOffset

Offset

Define the distance of the color gradient from the center of the header to the left or the right in percent. 0 means the center of the header, 100 means the right edge of the header and -100 means the left edge of the header.

Minimum: -100

Maximum: 100

Default: 0

More in the online help AML

More in the online help CEL

More in the online help for ETM

VT_I2

HeaderColorGradientAngle

Angle

Only available if you have selected operable header or fixed header in group in the project settings in the Alarm Message List group for the Header AML property or in the Chronological Event List group for the Header CEL property. Furthermore, you must also activate the properties Extended graphical settings and Show header for the respective list field.

Availability for the cursor output list in the Extended Trend.

This property only has an effect if you have selected color gradient for the Display style property.

Define the angle in whose direction the color gradient spreads. As starting point the point defined in property Offset is used.

Minimum: 0

Maximum: 360

Default: 0

More in the online help AML

More in the online help CEL

More in the online help for ETM

ZT_FILE

AscSortImage

Sort ascending

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the header of the list field for ascending sort in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_FILE

DescDownImage

Sort descending

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the header of the list field for descending sort in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_FILE

HeaderBarImage

Background

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the header of the list field as background in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

VT_UI2

GridSizeH

Horizontal line width [Pixel]

Width of the horizontal grid line in pixel. Change this value in order to change the horizontal lines of the grid of the list view in the Runtime. If you enter 0, the horizontal lines are hidden.

Default: 1.

More in the online help.

ZT_IMAGELIST

GridTypeH

Horizontal line type

Defines the type of the horizontal grid lines in the list view in the Runtime. Click on the line and select the desired line type (solid line, broken line, dashed line etc.).

Default: solid line.

Attention: This property is available if the value for property Horizontal line width [Pixel] is 1. For values >1 a solid line is used.

Note: The grid is only shown if the grid is activated in the screen switching function or in the filter in Runtime.

More in the online help.

ZT_COLOR

GridColorH

Horizontal line color

Defines the line color of the horizontal grid lines in the list view in the Runtime. Left-clicking on the button opens the palette of the pre-defined colors. You can enter the desired color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

VT_UI2

GridSizeV

Vertical line width [Pixel]

Width of the vertical grid line in pixel. Change this value in order to change the vertical lines of the grid of the list view in the Runtime. If you enter 0, the vertical lines are hidden.

Default: 1.

More in the online help.

ZT_IMAGELIST

GridTypeV

Vertical line type

Defines the type of the vertical grid lines in the list view in the Runtime. Click on the line and select the desired line type (solid line, broken line, dashed line etc.).

Default: solid line.

Attention: This property is available if the value for property Vertical line width [Pixel] is 1. For values >1 a solid line is used.

Note: The grid is only shown if the grid is activated in the screen switching function or in the filter in Runtime.

More in the online help.

ZT_COLOR

GridColorV

Vertical line color

Defines the line color of the horizontal grid lines in the list view in the Runtime. Left-clicking on the button opens the palette of the pre-defined colors. You can enter the desired color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

VT_BOOL

ShowBorder

Show border lines

Makes it possible to display a frame around the element. The flags of the properties Style L and Style H are masked out.

active: The frame is displayed around the respective element.

(Default) Inactive:

More in the online help

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_BOOL

TranslateText

Translate displayed text

Active: The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.

Default: inactive

More in the online help.

VT_UI2

StyleL

Style L

Windows style of the element, for internal use only.

More in the online help.

VT_UI2

StyleH

Style H

Windows style of the element, for internal use only.

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BSTR

Legend

Text

Label of the element in the Editor.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

ZT_SHORTCUT

ShortCut

Key combination

Shortcuts support executing operable elements. For example:

- Executing control elements and functions which have an element assigned
- Write set value (e.g. for switches)
- Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)

A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly.

More in the online help.

VT_BOOL

KbdUsage

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Listbox

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Listbox

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

ShowBorder

Show border lines

Makes it possible to display a frame around the element. The flags of the properties Style L and Style H are masked out.

active: The frame is displayed around the respective element.

(Default) Inactive:

More in the online help

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_BOOL

TranslateText

Translate displayed text

Active: The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.

Default: inactive

More in the online help.

VT_UI2

StyleL

Style L

Windows style of the element, for internal use only.

More in the online help.

VT_UI2

StyleH

Style H

Windows style of the element, for internal use only.

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BSTR

Legend

Text

Label of the element in the Editor.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

ZT_SHORTCUT

ShortCut

Key combination

Shortcuts support executing operable elements. For example:

- Executing control elements and functions which have an element assigned
- Write set value (e.g. for switches)
- Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)

A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly.

More in the online help.

VT_BOOL

KbdUsage

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Listcontrol

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Listcontrol

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

HideSelection

Do not mark selected row

With this you define whether the selected line is highlighted in the list field. If you activate this property, you do not see which entry you have selected. All lines of the list look the same.

Default: Inactive.

More in the online help for AML

More in the online help for CEL

VT_BOOL

AdvancedStyleH

Scroll bars

Properties for the horizontal and the vertical scroll bars.

More in the online help for AML.

More in the online help for CEL.

More in the online help for ETM.

More in the online help for RGM.

VT_UI4

RowHeight

Line height [pixel]

Makes it possible to define the row height in pixels independent of the font size.

Maximum value: 255 px
Minimum value: 0 px - row height is adapted to font size.

Default: 0

Attention: If the row height

  • is selected is too large, nothing is displayed in Runtime in certain circumstances.
  • is selected as smaller than the font size, then graphical illustrations are cut off.

More in the online help.

VT_I2

BarStyleH

Display style

Only available if you activated property Extended graphical settings.

Define how the header of the list field should look like. Select on of the following options:

Color gradient: Uses a special color gradient for the header. You can customize the color gradient with the help of properties Fill color, Gradient color, Color gradient, Offset [%] and Angle [°].

Graphics file: Uses the selected graphics file for the individual areas. If no graphics file has been selected, the display Color gradient is used.

Standard: Uses the standard setting for the header. You can only change the font and the text color with the help of the respective setting.

Default: Standard.

More in the online help.

VT_I2

ButtonHeightH

Height scroll arrow [Pixel]

Define the height of the scroll arrow in pixel for the horizontal scroll bar. Adjust the value to your ideas.

Default: 12.

More in the online help.

VT_I2

ButtonWidthH

Width scroll arrow [Pixel]

Define the width of the scroll arrow in pixel for the horizontal scroll bar. Adjust the value to your ideas.

Default: 12.

More in the online help.

VT_I2

ThumbSizeH

Width scroll box [Pixel]

Define the width of the scroll box in pixel for the horizontal scroll bar. Adjust the value to your ideas.

Default: 20.

More in the online help.

ZT_COLOR

BackColorH

Fill color

Define the first filling color which is used for the color gradient for the horizontal scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

ZT_COLOR

BackColor2H

Gradient color

This property only has an effect if you have selected color gradient for the Display style property.

Define the second filling color which is used for the color gradient for the horizontal scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property Fill color.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

VT_I2

LightningH

Color gradient

Select the type of the color gradient for the horizontal scroll bar from the following options:

Linear: steady gradient

Defined point: Gradient from the defined point to the edges of the element

Starting from a defined point with beams: Gradient with beams from the defined point to the edges of the element

Default: Linear

More in the online help.

VT_I2

ColorGradientOffsetH

Offset [%]

Define the distance of the color gradient point from the center of the horizontal scroll bar to the left or the right in percent. 0 means the center of the horizontal scroll bar, 100 means the right edge of the horizontal scroll bar and -100 means the left edge of the horizontal scroll bar.

Minimum: -100

Maximum: 100

Default: 0

More in the online help.

VT_I2

ColorGradientAngleH

Angle [°]

Only available if you activated property Extended graphical settings.

This property only has an effect if you have selected color gradient for the Display style property.

Define the angle in whose direction the color gradient spreads. As starting point the point defined in property Offset [%] is used.

Minimum: 0

Maximum: 360

Default: 0

More in the online help.

ZT_FILE

BitmapLeftH

Scroll arrow left

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the left scroll arrow for the horizontal scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapRightH

Scroll arrow right

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the right scroll arrow for the horizontal scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapThumbH

Scroll box

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the scroll box for the horizontal scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapSpanH

Background graphics file

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field as background for the horizontal scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

VT_I2

BarStyleV

Display style

Only available if you activated property Extended graphical settings.

Define how the header of the list field should look like. Select on of the following options:

Color gradient: Uses a special color gradient for the header. You can customize the color gradient with the help of properties Fill color, Gradient color, Color gradient, Offset [%] and Angle [°].

Graphics file: Uses the selected graphics file for the individual areas. If no graphics file has been selected, the display Color gradient is used.

Standard: Uses the standard setting for the header. You can only change the font and the text color with the help of the respective setting.

Default: Standard.

More in the online help.

VT_I2

ButtonHeightV

Height scroll arrow [Pixel]

Define the height of the scroll arrow in pixel for the vertical scroll bar. Adjust the value to your ideas.

Default: 12.

More in the online help.

VT_I2

ButtonWidthV

Width scroll arrow [Pixel]

Define the width of the scroll arrow in pixel for the vertical scroll bar. Adjust the value to your ideas.

Default: 12.

More in the online help.

VT_I2

ThumbSizeV

Width scroll box [Pixel]

Define the width of the scroll box in pixel for the vertical scroll bar. Adjust the value to your ideas.

Default: 20.

More in the online help.

ZT_COLOR

BackColorV

Fill color

Define the first filling color which is used for the color gradient for the vertical scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

ZT_COLOR

BackColor2V

Gradient color

This property only has an effect if you have selected color gradient for the Display style property.

Define the second filling color which is used for the color gradient for the vertical scroll bar. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property Fill color.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

VT_I2

LightningV

Color gradient

Select the type of the color gradient for the vertical scroll bar from the following options:

Linear: steady gradient

Defined point: Gradient from the defined point to the edges of the element

Starting from a defined point with beams: Gradient with beams from the defined point to the edges of the element

Default: Linear

More in the online help.

VT_I2

ColorGradientOffsetV

Offset [%]

Define the distance of the color gradient point from the center of the vertical scroll bar to the left or the right in percent. 0 means the center of the vertical scroll bar, 100 means the right edge of the vertical scroll bar and -100 means the left edge of the vertical scroll bar.

Minimum: -100

Maximum: 100

Default: 0

More in the online help.

VT_I2

ColorGradientAngleV

Angle [°]

Only available if you activated property Extended graphical settings.

This property only has an effect if you have selected color gradient for the Display style property.

Define the angle in whose direction the color gradient spreads. As starting point the point defined in property Offset [%] is used.

Minimum: 0

Maximum: 360

Default: 0

More in the online help.

ZT_FILE

BitmapLeftV

Scroll arrow up

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the up scroll arrow for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapRightV

Scroll arrow down

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the down scroll arrow for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapThumbV

Scroll box

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the scroll box for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapSpanV

Background graphics file

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field as background for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

VT_BOOL

ShowHeader

Show header

Only available if you have selected operable header or fixed header in group in the project settings in the Alarm Message List group for the Header AML property or in the Chronological Event List group for the Header CEL property.
Availability for the cursor output list in the Extended Trend.

Displays the header for the respective list field. In group Header you can customize the look of the header.

active: The header is displayed.

Default: active

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

VT_BOOL

EnableHeader

Make header editable

Only available if you selected operable header in group Alarm Message List for property Header AML or in group Chronological Event List for property Header CEL.

Availability for the cursor output list in the Extended Trend.

Makes it possible to operate the header for the respective list field. In the Runtime you can move the individual columns and change their width. You can sort the display by any column.

active: The header can be operated.

Default: active

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

VT_I2

HeaderStyle

Display style

Only available if you have selected operable header or fixed header in group in the project settings in the Alarm Message List group for the Header AML property or in the Chronological Event List group for the Header CEL property. Furthermore, you must also activate the properties Extended graphical settings and Show header for the respective list field.

Availability for the cursor output list in the Extended Trend.

Define how the header of the list field should look like. Select on of the following options:

Color gradient: Uses a special color gradient for the header. You can customize the color gradient with the help of properties Fill color, Gradient color, Light effect, Offset and Angle.

Graphics file: Uses the selected graphics file for the individual areas. If no graphics file has been selected, the display Color gradient is used.

Default:: Uses the standard setting for the header. You can only change the Font and the Text color with the help of the respective setting.

Default: Standard.

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_SCHRIFT

HeaderFont

Text color

Define the color which should be used for the text in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_COLOR

HeaderBackColor

Fill color

Define the first filling color which is used for the color gradient in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_COLOR

HeaderBackColor2

Gradient color

Only available if you have selected operable header or fixed header in group in the project settings in the Alarm Message List group for the Header AML property or in the Chronological Event List group for the Header CEL property. Furthermore, you must also activate the properties Extended graphical settings and Show header for the respective list field.

Availability for the cursor output list in the Extended Trend.

This property only has an effect if you have selected color gradient for the Display style property.

Define the second fill color which is used for the color gradient in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property Fill color.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help AML

More in the online help CEL

More in the online help for ETM

ZT_COLOR

HeaderFontColor

Text color

Define the color which should be used for the text in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

VT_I2

HeaderLightning

Light effect

Select the type of the color gradient for the header from the following options:

Linear: steady gradient

Defined point: Gradient from the defined point to the edges of the element

Starting from a defined point with beams: Gradient with beams from the defined point to the edges of the element

Default: Linear

More in the online help AML

More in the online help CEL

More in the online help for ETM

VT_I2

HeaderColorGradientOffset

Offset

Define the distance of the color gradient from the center of the header to the left or the right in percent. 0 means the center of the header, 100 means the right edge of the header and -100 means the left edge of the header.

Minimum: -100

Maximum: 100

Default: 0

More in the online help AML

More in the online help CEL

More in the online help for ETM

VT_I2

HeaderColorGradientAngle

Angle

Only available if you have selected operable header or fixed header in group in the project settings in the Alarm Message List group for the Header AML property or in the Chronological Event List group for the Header CEL property. Furthermore, you must also activate the properties Extended graphical settings and Show header for the respective list field.

Availability for the cursor output list in the Extended Trend.

This property only has an effect if you have selected color gradient for the Display style property.

Define the angle in whose direction the color gradient spreads. As starting point the point defined in property Offset is used.

Minimum: 0

Maximum: 360

Default: 0

More in the online help AML

More in the online help CEL

More in the online help for ETM

ZT_FILE

AscSortImage

Sort ascending

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the header of the list field for ascending sort in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_FILE

DescDownImage

Sort descending

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the header of the list field for descending sort in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_FILE

HeaderBarImage

Background

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the header of the list field as background in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

VT_UI2

GridSizeH

Horizontal line width [Pixel]

Width of the horizontal grid line in pixel. Change this value in order to change the horizontal lines of the grid of the list view in the Runtime. If you enter 0, the horizontal lines are hidden.

Default: 1.

More in the online help.

ZT_IMAGELIST

GridTypeH

Horizontal line type

Defines the type of the horizontal grid lines in the list view in the Runtime. Click on the line and select the desired line type (solid line, broken line, dashed line etc.).

Default: solid line.

Attention: This property is available if the value for property Horizontal line width [Pixel] is 1. For values >1 a solid line is used.

Note: The grid is only shown if the grid is activated in the screen switching function or in the filter in Runtime.

More in the online help.

ZT_COLOR

GridColorH

Horizontal line color

Defines the line color of the horizontal grid lines in the list view in the Runtime. Left-clicking on the button opens the palette of the pre-defined colors. You can enter the desired color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

VT_UI2

GridSizeV

Vertical line width [Pixel]

Width of the vertical grid line in pixel. Change this value in order to change the vertical lines of the grid of the list view in the Runtime. If you enter 0, the vertical lines are hidden.

Default: 1.

More in the online help.

ZT_IMAGELIST

GridTypeV

Vertical line type

Defines the type of the vertical grid lines in the list view in the Runtime. Click on the line and select the desired line type (solid line, broken line, dashed line etc.).

Default: solid line.

Attention: This property is available if the value for property Vertical line width [Pixel] is 1. For values >1 a solid line is used.

Note: The grid is only shown if the grid is activated in the screen switching function or in the filter in Runtime.

More in the online help.

ZT_COLOR

GridColorV

Vertical line color

Defines the line color of the horizontal grid lines in the list view in the Runtime. Left-clicking on the button opens the palette of the pre-defined colors. You can enter the desired color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

VT_BOOL

ShowBorder

Show border lines

Makes it possible to display a frame around the element. The flags of the properties Style L and Style H are masked out.

active: The frame is displayed around the respective element.

(Default) Inactive:

More in the online help

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_BOOL

TranslateText

Translate displayed text

Active: The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.

Default: inactive

More in the online help.

VT_UI2

StyleL

Style L

Windows style of the element, for internal use only.

More in the online help.

VT_UI2

StyleH

Style H

Windows style of the element, for internal use only.

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BSTR

Legend

Text

Label of the element in the Editor.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

ZT_SHORTCUT

ShortCut

Key combination

Shortcuts support executing operable elements. For example:

- Executing control elements and functions which have an element assigned
- Write set value (e.g. for switches)
- Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)

A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly.

More in the online help.

VT_BOOL

KbdUsage

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Dynamic window no header list control

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Dynamic window no header list control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

ZT_COLOR

TextColorSelectFocus

Text color on focus

Color for the text of a list entry if the focus is on the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

Default: Value of the operating system

More in the online help.

ZT_COLOR

BackColorSelectFocus

Background color on focus

Background color of a list entry if the focus is on the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

Default: Value of the operating system

More in the online help.

ZT_COLOR

TextColorSelectNoFocus

Text color without focus

Color for the text of a list entry if the focus is not on the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

Default: Value of the operating system

More in the online help.

ZT_COLOR

BackColorSelectNoFocus

Background color without focus

Background color of a list entry if the focus is not on the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

Default: Value of the operating system

More in the online help.

VT_BOOL

HideSelection

Do not mark selected row

With this you define whether the selected line is highlighted in the list field. If you activate this property, you do not see which entry you have selected. All lines of the list look the same.

Default: Inactive.

More in the online help for AML

More in the online help for CEL

VT_BOOL

AdvancedStyleH

Scroll bars

Properties for the horizontal and the vertical scroll bars.

More in the online help for AML.

More in the online help for CEL.

More in the online help for ETM.

More in the online help for RGM.

VT_UI4

RowHeight

Line height [pixel]

Makes it possible to define the row height in pixels independent of the font size.

Maximum value: 255 px
Minimum value: 0 px - row height is adapted to font size.

Default: 0

Attention: If the row height

  • is selected is too large, nothing is displayed in Runtime in certain circumstances.
  • is selected as smaller than the font size, then graphical illustrations are cut off.

More in the online help.

VT_I2

BarStyleH

Display style

Only available if you activated property Extended graphical settings.

Define how the header of the list field should look like. Select on of the following options:

Color gradient: Uses a special color gradient for the header. You can customize the color gradient with the help of properties Fill color, Gradient color, Color gradient, Offset [%] and Angle [°].

Graphics file: Uses the selected graphics file for the individual areas. If no graphics file has been selected, the display Color gradient is used.

Standard: Uses the standard setting for the header. You can only change the font and the text color with the help of the respective setting.

Default: Standard.

More in the online help.

VT_I2

ButtonHeightH

Height scroll arrow [Pixel]

Define the height of the scroll arrow in pixel for the horizontal scroll bar. Adjust the value to your ideas.

Default: 12.

More in the online help.

VT_I2

ButtonWidthH

Width scroll arrow [Pixel]

Define the width of the scroll arrow in pixel for the horizontal scroll bar. Adjust the value to your ideas.

Default: 12.

More in the online help.

VT_I2

ThumbSizeH

Width scroll box [Pixel]

Define the width of the scroll box in pixel for the horizontal scroll bar. Adjust the value to your ideas.

Default: 20.

More in the online help.

ZT_COLOR

BackColorH

Fill color

Define the first filling color which is used for the color gradient for the horizontal scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

ZT_COLOR

BackColor2H

Gradient color

This property only has an effect if you have selected color gradient for the Display style property.

Define the second filling color which is used for the color gradient for the horizontal scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property Fill color.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

VT_I2

LightningH

Color gradient

Select the type of the color gradient for the horizontal scroll bar from the following options:

Linear: steady gradient

Defined point: Gradient from the defined point to the edges of the element

Starting from a defined point with beams: Gradient with beams from the defined point to the edges of the element

Default: Linear

More in the online help.

VT_I2

ColorGradientOffsetH

Offset [%]

Define the distance of the color gradient point from the center of the horizontal scroll bar to the left or the right in percent. 0 means the center of the horizontal scroll bar, 100 means the right edge of the horizontal scroll bar and -100 means the left edge of the horizontal scroll bar.

Minimum: -100

Maximum: 100

Default: 0

More in the online help.

VT_I2

ColorGradientAngleH

Angle [°]

Only available if you activated property Extended graphical settings.

This property only has an effect if you have selected color gradient for the Display style property.

Define the angle in whose direction the color gradient spreads. As starting point the point defined in property Offset [%] is used.

Minimum: 0

Maximum: 360

Default: 0

More in the online help.

ZT_FILE

BitmapLeftH

Scroll arrow left

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the left scroll arrow for the horizontal scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapRightH

Scroll arrow right

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the right scroll arrow for the horizontal scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapThumbH

Scroll box

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the scroll box for the horizontal scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapSpanH

Background graphics file

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field as background for the horizontal scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

VT_I2

BarStyleV

Display style

Only available if you activated property Extended graphical settings.

Define how the header of the list field should look like. Select on of the following options:

Color gradient: Uses a special color gradient for the header. You can customize the color gradient with the help of properties Fill color, Gradient color, Color gradient, Offset [%] and Angle [°].

Graphics file: Uses the selected graphics file for the individual areas. If no graphics file has been selected, the display Color gradient is used.

Standard: Uses the standard setting for the header. You can only change the font and the text color with the help of the respective setting.

Default: Standard.

More in the online help.

VT_I2

ButtonHeightV

Height scroll arrow [Pixel]

Define the height of the scroll arrow in pixel for the vertical scroll bar. Adjust the value to your ideas.

Default: 12.

More in the online help.

VT_I2

ButtonWidthV

Width scroll arrow [Pixel]

Define the width of the scroll arrow in pixel for the vertical scroll bar. Adjust the value to your ideas.

Default: 12.

More in the online help.

VT_I2

ThumbSizeV

Width scroll box [Pixel]

Define the width of the scroll box in pixel for the vertical scroll bar. Adjust the value to your ideas.

Default: 20.

More in the online help.

ZT_COLOR

BackColorV

Fill color

Define the first filling color which is used for the color gradient for the vertical scroll bars. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

ZT_COLOR

BackColor2V

Gradient color

This property only has an effect if you have selected color gradient for the Display style property.

Define the second filling color which is used for the color gradient for the vertical scroll bar. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property Fill color.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

VT_I2

LightningV

Color gradient

Select the type of the color gradient for the vertical scroll bar from the following options:

Linear: steady gradient

Defined point: Gradient from the defined point to the edges of the element

Starting from a defined point with beams: Gradient with beams from the defined point to the edges of the element

Default: Linear

More in the online help.

VT_I2

ColorGradientOffsetV

Offset [%]

Define the distance of the color gradient point from the center of the vertical scroll bar to the left or the right in percent. 0 means the center of the vertical scroll bar, 100 means the right edge of the vertical scroll bar and -100 means the left edge of the vertical scroll bar.

Minimum: -100

Maximum: 100

Default: 0

More in the online help.

VT_I2

ColorGradientAngleV

Angle [°]

Only available if you activated property Extended graphical settings.

This property only has an effect if you have selected color gradient for the Display style property.

Define the angle in whose direction the color gradient spreads. As starting point the point defined in property Offset [%] is used.

Minimum: 0

Maximum: 360

Default: 0

More in the online help.

ZT_FILE

BitmapLeftV

Scroll arrow up

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the up scroll arrow for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapRightV

Scroll arrow down

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the down scroll arrow for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapThumbV

Scroll box

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field for the scroll box for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

ZT_FILE

BitmapSpanV

Background graphics file

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the list field as background for the vertical scroll bar in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help.

VT_BOOL

ShowHeader

Show header

Only available if you have selected operable header or fixed header in group in the project settings in the Alarm Message List group for the Header AML property or in the Chronological Event List group for the Header CEL property.
Availability for the cursor output list in the Extended Trend.

Displays the header for the respective list field. In group Header you can customize the look of the header.

active: The header is displayed.

Default: active

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

VT_BOOL

EnableHeader

Make header editable

Only available if you selected operable header in group Alarm Message List for property Header AML or in group Chronological Event List for property Header CEL.

Availability for the cursor output list in the Extended Trend.

Makes it possible to operate the header for the respective list field. In the Runtime you can move the individual columns and change their width. You can sort the display by any column.

active: The header can be operated.

Default: active

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

VT_I2

HeaderStyle

Display style

Only available if you have selected operable header or fixed header in group in the project settings in the Alarm Message List group for the Header AML property or in the Chronological Event List group for the Header CEL property. Furthermore, you must also activate the properties Extended graphical settings and Show header for the respective list field.

Availability for the cursor output list in the Extended Trend.

Define how the header of the list field should look like. Select on of the following options:

Color gradient: Uses a special color gradient for the header. You can customize the color gradient with the help of properties Fill color, Gradient color, Light effect, Offset and Angle.

Graphics file: Uses the selected graphics file for the individual areas. If no graphics file has been selected, the display Color gradient is used.

Default:: Uses the standard setting for the header. You can only change the Font and the Text color with the help of the respective setting.

Default: Standard.

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_SCHRIFT

HeaderFont

Text color

Define the color which should be used for the text in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_COLOR

HeaderBackColor

Fill color

Define the first filling color which is used for the color gradient in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_COLOR

HeaderBackColor2

Gradient color

Only available if you have selected operable header or fixed header in group in the project settings in the Alarm Message List group for the Header AML property or in the Chronological Event List group for the Header CEL property. Furthermore, you must also activate the properties Extended graphical settings and Show header for the respective list field.

Availability for the cursor output list in the Extended Trend.

This property only has an effect if you have selected color gradient for the Display style property.

Define the second fill color which is used for the color gradient in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. At selecting Automatical the color value changes depending on the value of property Fill color.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help AML

More in the online help CEL

More in the online help for ETM

ZT_COLOR

HeaderFontColor

Text color

Define the color which should be used for the text in the header. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

VT_I2

HeaderLightning

Light effect

Select the type of the color gradient for the header from the following options:

Linear: steady gradient

Defined point: Gradient from the defined point to the edges of the element

Starting from a defined point with beams: Gradient with beams from the defined point to the edges of the element

Default: Linear

More in the online help AML

More in the online help CEL

More in the online help for ETM

VT_I2

HeaderColorGradientOffset

Offset

Define the distance of the color gradient from the center of the header to the left or the right in percent. 0 means the center of the header, 100 means the right edge of the header and -100 means the left edge of the header.

Minimum: -100

Maximum: 100

Default: 0

More in the online help AML

More in the online help CEL

More in the online help for ETM

VT_I2

HeaderColorGradientAngle

Angle

Only available if you have selected operable header or fixed header in group in the project settings in the Alarm Message List group for the Header AML property or in the Chronological Event List group for the Header CEL property. Furthermore, you must also activate the properties Extended graphical settings and Show header for the respective list field.

Availability for the cursor output list in the Extended Trend.

This property only has an effect if you have selected color gradient for the Display style property.

Define the angle in whose direction the color gradient spreads. As starting point the point defined in property Offset is used.

Minimum: 0

Maximum: 360

Default: 0

More in the online help AML

More in the online help CEL

More in the online help for ETM

ZT_FILE

AscSortImage

Sort ascending

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the header of the list field for ascending sort in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_FILE

DescDownImage

Sort descending

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the header of the list field for descending sort in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

ZT_FILE

HeaderBarImage

Background

Only available if you activated property Extended graphical settings.

Select a graphics file which should be displayed in the header of the list field as background in the Runtime. This graphics file is used if you selected Graphics file at property Display style.

Default: no file

More in the online help for AML

More in the online help for CEL

More in the online help for ETM

VT_UI2

GridSizeH

Horizontal line width [Pixel]

Width of the horizontal grid line in pixel. Change this value in order to change the horizontal lines of the grid of the list view in the Runtime. If you enter 0, the horizontal lines are hidden.

Default: 1.

More in the online help.

ZT_IMAGELIST

GridTypeH

Horizontal line type

Defines the type of the horizontal grid lines in the list view in the Runtime. Click on the line and select the desired line type (solid line, broken line, dashed line etc.).

Default: solid line.

Attention: This property is available if the value for property Horizontal line width [Pixel] is 1. For values >1 a solid line is used.

Note: The grid is only shown if the grid is activated in the screen switching function or in the filter in Runtime.

More in the online help.

ZT_COLOR

GridColorH

Horizontal line color

Defines the line color of the horizontal grid lines in the list view in the Runtime. Left-clicking on the button opens the palette of the pre-defined colors. You can enter the desired color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

VT_UI2

GridSizeV

Vertical line width [Pixel]

Width of the vertical grid line in pixel. Change this value in order to change the vertical lines of the grid of the list view in the Runtime. If you enter 0, the vertical lines are hidden.

Default: 1.

More in the online help.

ZT_IMAGELIST

GridTypeV

Vertical line type

Defines the type of the vertical grid lines in the list view in the Runtime. Click on the line and select the desired line type (solid line, broken line, dashed line etc.).

Default: solid line.

Attention: This property is available if the value for property Vertical line width [Pixel] is 1. For values >1 a solid line is used.

Note: The grid is only shown if the grid is activated in the screen switching function or in the filter in Runtime.

More in the online help.

ZT_COLOR

GridColorV

Vertical line color

Defines the line color of the horizontal grid lines in the list view in the Runtime. Left-clicking on the button opens the palette of the pre-defined colors. You can enter the desired color as hex code (RGB) manually in the field.

As color for a newly created element the color which was used for the previous element of the same type is used.

More in the online help.

VT_BOOL

ShowBorder

Show border lines

Makes it possible to display a frame around the element. The flags of the properties Style L and Style H are masked out.

active: The frame is displayed around the respective element.

(Default) Inactive:

More in the online help

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_BOOL

TranslateText

Translate displayed text

Active: The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.

Default: inactive

More in the online help.

VT_UI2

StyleL

Style L

Windows style of the element, for internal use only.

More in the online help.

VT_UI2

StyleH

Style H

Windows style of the element, for internal use only.

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BSTR

Legend

Text

Label of the element in the Editor.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

ZT_SHORTCUT

ShortCut

Key combination

Shortcuts support executing operable elements. For example:

- Executing control elements and functions which have an element assigned
- Write set value (e.g. for switches)
- Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)

A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly.

More in the online help.

VT_BOOL

KbdUsage

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


CCtrlDynWndFPPicCont

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> CCtrlDynWndFPPicCont

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

ZT_PICTURE

PictureContainerPictureName

Screen

Linked screen that is displayed in the faceplate. Click the ... button and a dialog opens to select a screen.

Permitted screen types: AML, AML filter, equipment model, CEL, CEL filter, ETM, HTML, Report Generator, Report Viewer, standard, time filter

More in the online help.

VT_BOOL

ShowPreviewInEditor

Show preview in the Editor

Active: Preview of the linked screen is displayed in the Editor.
Deactivation is recommended in the event of performance problems.

Default:: active

More in the online help.

VT_BSTR

SubstituteSource

Source

Replacing variables and/or functions in a symbol or faceplate container.

Enter the source variable/source function. You can use wildcards (?,*). Several entries are separated by a semicolon (;).

You can define the target with the help of property Target.
Example: Variables in the symbol: Tank1.fill level and Tank1.position of the valve. These should be replaced by Tank2.fill level and Tank2.position of the valve.
For this enter the following at Source: *1* and at Target 2. In the Runtime the variables which contain 1 are replaced by the variables which contain 2.

More information is in the online manual in he Symbols and Faceplates sections.

VT_BSTR

SubstituteDestination

Target

Replacement of variables and/or functions in a symbol or faceplate container:
Enter the new variables/functions to be assigned. At this no wildcards are allowed. Several entries are separated by a semicolon (;).

You can define the sources with the help of property Source.
Example: Variables in the symbol: Tank1.fill level and Tank1.position of the valve. These should be replaced by Tank2.fill level and Tank2.position of the valve.
For this enter the following at Source: *1* and at Target 2. In the Runtime the variables which contain 1 are replaced by the variables which contain 2.

More information is in the online manual in he Symbols and Faceplates sections.

VT_BOOL

SubstituteOnName

via variable name

Replacement of variables in a symbol or faceplate container using variables:

  • Active: The replacement of links is implemented via the name of the variables.
  • Inactive The replacement of the links is implemented via the identification of the variables.

More information is in the online manual in he Symbols and Faceplates sections.

VT_BOOL

SubstituteMatchCase

Case sensitive

The capitalization in the inputs for the source and the target to replace variables and/or functions in a symbol or faceplate container.

  • Active: Capitalization is taken into account.
  • Inactive: Capitalization is not taken into account.

More information is in the online manual in he Symbols and Faceplates sections.

VT_BSTR

Preview

Preview

Opens the dialog to replace links. Changes in the preview are taken over and reversed in properties Source and Target.
Stands for symbols and faceplates available. Only active for symbols if there is already linking to the symbol; for faceplate containers, only if a screen is linked to a container.

More information is in the online manual in he Symbols and Faceplates sections.

VT_UI2

StyleL

Style L

Windows style of the element, for internal use only.

More in the online help.

VT_UI2

StyleH

Style H

Windows style of the element, for internal use only.

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BSTR

Legend

Text

Label of the element in the Editor.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

ZT_SHORTCUT

ShortCut

Key combination

Shortcuts support executing operable elements. For example:

- Executing control elements and functions which have an element assigned
- Write set value (e.g. for switches)
- Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)

A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly.

More in the online help.

VT_BOOL

KbdUsage

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


CZenonGestureManipulation

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> CZenonGestureManipulation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_UI4

GestureManipulationX

Move

Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured.

More in the online help.

VT_UI4

GestureManipulationY

Move vertically

Definition of the reaction to a gesture for vertical movement. The configurable reaction depends on the screen or screen element to be configured.

Interaction: The Move Frame via mouse property cannot be activated at the same time as the properties Move horizontally and Move vertically. Either movement of a frame with a mouse, or the horizontal/vertical movement by means of touch operation can be activated.

Note this special case: With the following scenario, both properties are set and remain unconfigurable after that:

  • The Move horizontally or Move vertically property is activated.
  • Recognition project property for Interaction is set to Windows 7 or deactivated.
  • Move Frame via mouse property is activated.
  • Recognition property is set to Windows 8 again.

Solution:

  • Set the Recognition property back to Windows 7 or deactivated.
  • Deactivate the Move Frame via mouse property.

More in the online help.

VT_UI4

GestureManipulationXY

Move

Definition of the reaction to different gestures. The configurable reaction depends on the screen or screen element to be configured.

More in the online help.

VT_UI4

GestureManipulationZoom

Zoom

Definition of the reaction to zoom gestures. The configurable reaction depends on the screen or screen element to be configured.

More in the online help.


ActiveX

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> ActiveX

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

ZT_AKTIVE_X

ActiveX

ActiveX settings

Selection of the ActiveX element and the linked variable.

More in the online help.

More...

DynEleVar

DynEleVar

"With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX
zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Angle

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Angle

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

ZT_COLOR

LineColor

Line color

Line color of the element.

VT_UI2

LineWidth

Line width [Pixel]

Width of the line (in pixels).
Minimum: 0
In this case the width of the line is 1 pixel.
Maximum: 40
Default: 1
Attention: If in the project settings in node Graphical design you set property Graphics quality to Windows basis, you can use line width >1 only with a line of type "continuous line".

More in the online help.

ZT_IMAGELIST

LineType

Line type

Selection of the line type for the element from the list.
Attention: If in the project settings in node Graphical design you deactivated property Graphics quality, you can use line width >1 only with a line of type "continuous line".
More in the online help.

ZT_IMAGELIST

FillPattern

Filling pattern

Selection of the filling pattern for the element from the list.

This property is only available if property With brightness values is inactive.

More in the online help.

ZT_COLOR

LineColorEx

Line color

Defines the line color of the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

AlphaLineColor

Transparency line color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_UI1

AlphaBackColor

Transparency of the fill color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor2

Gradient color

Only available if for property Filling pattern Color gradient is selected and the project property Graphics quality is active.

Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of Fill color.

More in the online help.

VT_UI1

AlphaBackColor2

Transparency gradient color [%]

Only available if Linear was selected in the Filling pattern property.

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable2

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BackColorVariable2Preview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_I2

Lightning

Color gradient

Only available if property Filling pattern was set to Color gradient.

Defines the color gradient for vector elements.

Linear: steady gradient
Defined point: Gradient from a defined point to the edges of the element

Starting from a defined point with beams: Gradient from a defined point to the edges of the element with beams

More in the online help.

VT_I2

Align

Alignment

Direction of color shift.
horizontal
vertical

VT_I2

ColorGradientOffset

Offset [%]

Only available if at a vector element the property Color gradient or at the dynamic element Button property Filling was set. linear or Starting from a defined point or Starting from a defined point with beams.

Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.

Values: 0 equals the center of the element. 100 the edge.
Note: The value can also be outside of the element and is therefore not limited to 100.

More in the online help.

VT_I2

ColorGradientAngle

Angle [°]

Defines the direction of the color gradient starting in the center of the element.

Values: 0° to 360°.

Default: 0°

More in the online help.

VT_UI1

OuterBrightness

Brightness outside

Only available if "via brightness value" is active:
Brightness at the outer side of the element.

More in the online help.

VT_UI1

InnerBrightness

Brightness inside

Only available if "via brightness value" is active:
Brightness in the middle of the element.

More in the online help.

VT_BOOL

ALCUseColor

Color from ALC

Only available if you have licensed Automatic Line Coloring (ALC):
Active: The automatic color of the linked source(s) is used.
Inactive: The standard color is used.
Default: inactive.

More in the online help.

VT_I2

ALCPrecedence

Priority for display

Only available if the Color from ALC property is active.

Defines the priority of the display when the element is connected to several active sources.
Multiple supply: The element is displayed according to the rules of the multiple supply.
secured supply: The element is displayed according to the rules of the secured supply.
No priority: The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.

Default: Multiple supply
More in the online help.

VT_I2

ALCMultiSource

display multiple supplies

Only available if the property Color from ALC is active.
Defines the display type if the element is connected to several sources:
most prior source: Only the color of the source with the highest priority is used.
two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line.
alternative color: Alternative color for the coloring at multiple supply.

Default: highest priority source

More in the online help

VT_I2

ALCDashLen

Dashing length supplied multiple times

Only available if property display multiple supplies has value two highest prior sources.

Defines the dash length in pixel for the dashed ALC coloring at multiply supply.

Minimal: 0 (automatic dash length)

Maximum: 32767

Default: 0

More in the online help.

ZT_COLOR

ALCAlternativeColor

Alternative color

Only available if property display multiple supplies has value alternative color.

Alternative color for the ALC coloring at multiple supply.

More in the online help.

VT_I2

ALCMSecuredSupply

display secured supply

Only available if Color from ALC was activated.

Definition of the display of the secured supply:

  • double width
  • double brightness
  • normal

Default: normal

More in the online help

VT_BOOL

ALCAlias

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

ALCAliasName

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_R8

ALCReact

Reactance value of the cable [Ohm]

Maximum permitted reactance value of the line in ohms.

More in the online help.

VT_R8

ALCResist

Resistance value of the electric line [Ohm]

Maximum permitted resistance value of the line in ohms.

More in the online help.

VT_R8

ALCLength

Length of the line [km]

ALC line: Length of the line.

More in the online help.

VT_I2

ALCMaxIType

Limit current carrying capacity

ALC switch: Limit value of current capacity [selection of fixed/variable].

More in the online help.

VT_R8

ALCMaxIVal

Limit fixed current carrying capacity [A]

ALC switch: Limit fixed current carrying capacity.

More in the online help.

ZT_VARIABLE_DYN

ALCVarMaxI

Limit variable current carrying capacity

More...

ALCVarMaxIEx

ALCVarMaxIEx

ZT_VARIABLE_DYN

ALCVarCalcI

Measuring value of the calculated current flow

ALC line: Measuring value of the calculated current flow.

More in the online help.

More...

ALCVarCalcIEx

ALCVarCalcIEx

ALC Leitung: Messwert des berechneten Stromflusses für Export.

Mehr in der Online-Hilfe.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Arc of circle

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Arc of circle

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

ZT_COLOR

LineColor

Line color

Line color of the element.

VT_UI2

LineWidth

Line width [Pixel]

Width of the line (in pixels).
Minimum: 0
In this case the width of the line is 1 pixel.
Maximum: 40
Default: 1
Attention: If in the project settings in node Graphical design you set property Graphics quality to Windows basis, you can use line width >1 only with a line of type "continuous line".

More in the online help.

ZT_IMAGELIST

LineType

Line type

Selection of the line type for the element from the list.
Attention: If in the project settings in node Graphical design you deactivated property Graphics quality, you can use line width >1 only with a line of type "continuous line".
More in the online help.

ZT_IMAGELIST

LineCapStart

Start type

Only available if you have activated project property Graphics quality.

Defines the symbol for the starting point of the line. Click on the field and a dialog opens to select an element.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

More in the online help.

ZT_IMAGELIST

LineCapEnd

End type

Only available if you have activated project property Graphics quality.

Defines the symbol for the end point of the line. Click on the field and a dialog opens to select an element.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

More in the online help.

VT_R4

LineCapScale

Size

Only available if you have activated project property Graphics quality.

Defines the magnifying factor for the line width of the arrow. The factor relates to the line width of the vector element as defined in the Line width [Pixel] property.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

Value: greater or equal 1

Default: 4

More in the online help.

ZT_IMAGELIST

FillPattern

Filling pattern

Selection of the filling pattern for the element from the list.

This property is only available if property With brightness values is inactive.

More in the online help.

ZT_COLOR

LineColorEx

Line color

Defines the line color of the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

AlphaLineColor

Transparency line color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_UI1

AlphaBackColor

Transparency of the fill color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor2

Gradient color

Only available if for property Filling pattern Color gradient is selected and the project property Graphics quality is active.

Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of Fill color.

More in the online help.

VT_UI1

AlphaBackColor2

Transparency gradient color [%]

Only available if Linear was selected in the Filling pattern property.

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

VT_I2

Lightning

Color gradient

Only available if property Filling pattern was set to Color gradient.

Defines the color gradient for vector elements.

Linear: steady gradient
Defined point: Gradient from a defined point to the edges of the element

Starting from a defined point with beams: Gradient from a defined point to the edges of the element with beams

More in the online help.

VT_I2

Align

Alignment

Direction of color shift.
horizontal
vertical

VT_I2

Shifted

Shifted color gradient

Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein.

Mehr im Online-Handbuch

VT_I2

ColorGradientOffset

Offset [%]

Only available if at a vector element the property Color gradient or at the dynamic element Button property Filling was set. linear or Starting from a defined point or Starting from a defined point with beams.

Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.

Values: 0 equals the center of the element. 100 the edge.
Note: The value can also be outside of the element and is therefore not limited to 100.

More in the online help.

VT_I2

ColorGradientAngle

Angle [°]

Defines the direction of the color gradient starting in the center of the element.

Values: 0° to 360°.

Default: 0°

More in the online help.

VT_BOOL

Brightness

With brightness values

Only available if Filling pattern was selected as color gradient was selected.

Active: The brightness of the color gradient can be freely defined.
Inactive: The brightness of the color gradient is defined automatically.

Note: The filling pattern can no longer be changed if this property is active. It is also not possible to set rounded corners. If this option is activated for an element that uses rounded corners, the element is displayed with non-rounded corners.

More in the online help.

VT_UI1

OuterBrightness

Brightness outside

Only available if "via brightness value" is active:
Brightness at the outer side of the element.

More in the online help.

VT_UI1

InnerBrightness

Brightness inside

Only available if "via brightness value" is active:
Brightness in the middle of the element.

More in the online help.

VT_BOOL

ALCUseColor

Color from ALC

Only available if you have licensed Automatic Line Coloring (ALC):
Active: The automatic color of the linked source(s) is used.
Inactive: The standard color is used.
Default: inactive.

More in the online help.

VT_I2

ALCPrecedence

Priority for display

Only available if the Color from ALC property is active.

Defines the priority of the display when the element is connected to several active sources.
Multiple supply: The element is displayed according to the rules of the multiple supply.
secured supply: The element is displayed according to the rules of the secured supply.
No priority: The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.

Default: Multiple supply
More in the online help.

VT_I2

ALCMultiSource

display multiple supplies

Only available if the property Color from ALC is active.
Defines the display type if the element is connected to several sources:
most prior source: Only the color of the source with the highest priority is used.
two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line.
alternative color: Alternative color for the coloring at multiple supply.

Default: highest priority source

More in the online help

VT_I2

ALCDashLen

Dashing length supplied multiple times

Only available if property display multiple supplies has value two highest prior sources.

Defines the dash length in pixel for the dashed ALC coloring at multiply supply.

Minimal: 0 (automatic dash length)

Maximum: 32767

Default: 0

More in the online help.

ZT_COLOR

ALCAlternativeColor

Alternative color

Only available if property display multiple supplies has value alternative color.

Alternative color for the ALC coloring at multiple supply.

More in the online help.

VT_I2

ALCMSecuredSupply

display secured supply

Only available if Color from ALC was activated.

Definition of the display of the secured supply:

  • double width
  • double brightness
  • normal

Default: normal

More in the online help

VT_BOOL

ALCAlias

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

ALCAliasName

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_R8

ALCReact

Reactance value of the cable [Ohm]

Maximum permitted reactance value of the line in ohms.

More in the online help.

VT_R8

ALCResist

Resistance value of the electric line [Ohm]

Maximum permitted resistance value of the line in ohms.

More in the online help.

VT_R8

ALCLength

Length of the line [km]

ALC line: Length of the line.

More in the online help.

VT_I2

ALCMaxIType

Limit current carrying capacity

ALC switch: Limit value of current capacity [selection of fixed/variable].

More in the online help.

VT_R8

ALCMaxIVal

Limit fixed current carrying capacity [A]

ALC switch: Limit fixed current carrying capacity.

More in the online help.

ZT_VARIABLE_DYN

ALCVarMaxI

Limit variable current carrying capacity

More...

ALCVarMaxIEx

ALCVarMaxIEx

ZT_VARIABLE_DYN

ALCVarCalcI

Measuring value of the calculated current flow

ALC line: Measuring value of the calculated current flow.

More in the online help.

More...

ALCVarCalcIEx

ALCVarCalcIEx

ALC Leitung: Messwert des berechneten Stromflusses für Export.

Mehr in der Online-Hilfe.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Segment of circle

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Segment of circle

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_I2

SegStartX

Start point X [pixels]

VT_I2

SegEndX

End point X [pixels]

VT_I2

SegStartY

Start point Y [pixels]

VT_I2

SegEndY

End point Y [pixels]

VT_R8

SegStartAngle

Start angle [°]

Start of the opening angle. The opening angle of the segment of the circle is displayed between the start angle and the end angle.

More in the online help.

VT_R8

SegEndAngle

End angle [°]

End of the opening angle. The opening angle of the segment of the circle is displayed between the start angle and the end angle.

More in the online help.

VT_BOOL

OffsetAdjustable

Adjustable segment thickness

Segment thickness for the segment of a circle. Not available for Graphics quality Windows Basis, for Windows CE project aktiv or for Color gradient With brightness values.

Active: The thickness of the segment of a circle can be configured individually.

More in the online help.

VT_BOOL

OffsetEndEqualsStart

End thickness equals start thickness

Active: Set the segment thickness for the end angle to the same value as the start angle. The Thickness end angles [pixel] property is deactivated. This means that the whole element is displayed with an even segment thickness. Only available if the Adjustable segment thickness property has been activated.

More in the online help.

VT_R4

StartOffset

Thick start angles [pixel]

Segment thickness at the start angle from the outer edge of the ellipse to the centrepoint in pixels. Only available if property Adjustable segment thickness is active.

Minimum: 0 pixels

Maximum: A value less than half the height or half the width of the element.

Default: 12:00 AM

More in the online help.

VT_R4

EndOffset

End thickness equals start thickness

Active: Set the segment thickness for the end angle to the same value as the start angle. The Thickness end angles [pixel] property is deactivated. This means that the whole element is displayed with an even segment thickness. Only available if the Adjustable segment thickness property has been activated.

More in the online help.

ZT_COLOR

LineColor

Line color

Line color of the element.

VT_UI2

Offset_H

Horiz. distance [pixels]

Horizontal distance of the end of the rounding of the actual corner in pixels.

More in the online help.

VT_UI2

Offset_V

Vertical distance [pixels]

Vertical distance of the end of the rounding of the actual corner in pixels.

More in the online help.

VT_UI2

LineWidth

Line width [Pixel]

Width of the line (in pixels).
Minimum: 0
In this case the width of the line is 1 pixel.
Maximum: 40
Default: 1
Attention: If in the project settings in node Graphical design you set property Graphics quality to Windows basis, you can use line width >1 only with a line of type "continuous line".

More in the online help.

ZT_IMAGELIST

LineType

Line type

Selection of the line type for the element from the list.
Attention: If in the project settings in node Graphical design you deactivated property Graphics quality, you can use line width >1 only with a line of type "continuous line".
More in the online help.

ZT_IMAGELIST

LineCapStart

Start type

Only available if you have activated project property Graphics quality.

Defines the symbol for the starting point of the line. Click on the field and a dialog opens to select an element.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

More in the online help.

ZT_IMAGELIST

LineCapEnd

End type

Only available if you have activated project property Graphics quality.

Defines the symbol for the end point of the line. Click on the field and a dialog opens to select an element.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

More in the online help.

VT_R4

LineCapScale

Size

Only available if you have activated project property Graphics quality.

Defines the magnifying factor for the line width of the arrow. The factor relates to the line width of the vector element as defined in the Line width [Pixel] property.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

Value: greater or equal 1

Default: 4

More in the online help.

ZT_IMAGELIST

FillPattern

Filling pattern

Selection of the filling pattern for the element from the list.

This property is only available if property With brightness values is inactive.

More in the online help.

ZT_COLOR

LineColorEx

Line color

Defines the line color of the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

AlphaLineColor

Transparency line color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_UI1

AlphaBackColor

Transparency of the fill color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor2

Gradient color

Only available if for property Filling pattern Color gradient is selected and the project property Graphics quality is active.

Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of Fill color.

More in the online help.

VT_UI1

AlphaBackColor2

Transparency gradient color [%]

Only available if Linear was selected in the Filling pattern property.

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable2

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BackColorVariable2Preview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_I2

Lightning

Color gradient

Only available if property Filling pattern was set to Color gradient.

Defines the color gradient for vector elements.

Linear: steady gradient
Defined point: Gradient from a defined point to the edges of the element

Starting from a defined point with beams: Gradient from a defined point to the edges of the element with beams

More in the online help.

VT_I2

Align

Alignment

Direction of color shift.
horizontal
vertical

VT_I2

Shifted

Shifted color gradient

Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein.

Mehr im Online-Handbuch

VT_I2

ColorGradientOffset

Offset [%]

Only available if at a vector element the property Color gradient or at the dynamic element Button property Filling was set. linear or Starting from a defined point or Starting from a defined point with beams.

Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.

Values: 0 equals the center of the element. 100 the edge.
Note: The value can also be outside of the element and is therefore not limited to 100.

More in the online help.

VT_I2

ColorGradientAngle

Angle [°]

Defines the direction of the color gradient starting in the center of the element.

Values: 0° to 360°.

Default: 0°

More in the online help.

VT_BOOL

Brightness

With brightness values

Only available if Filling pattern was selected as color gradient was selected.

Active: The brightness of the color gradient can be freely defined.
Inactive: The brightness of the color gradient is defined automatically.

Note: The filling pattern can no longer be changed if this property is active. It is also not possible to set rounded corners. If this option is activated for an element that uses rounded corners, the element is displayed with non-rounded corners.

More in the online help.

VT_UI1

OuterBrightness

Brightness outside

Only available if "via brightness value" is active:
Brightness at the outer side of the element.

More in the online help.

VT_UI1

InnerBrightness

Brightness inside

Only available if "via brightness value" is active:
Brightness in the middle of the element.

More in the online help.

VT_BOOL

ALCUseColor

Color from ALC

Only available if you have licensed Automatic Line Coloring (ALC):
Active: The automatic color of the linked source(s) is used.
Inactive: The standard color is used.
Default: inactive.

More in the online help.

VT_I2

ALCPrecedence

Priority for display

Only available if the Color from ALC property is active.

Defines the priority of the display when the element is connected to several active sources.
Multiple supply: The element is displayed according to the rules of the multiple supply.
secured supply: The element is displayed according to the rules of the secured supply.
No priority: The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.

Default: Multiple supply
More in the online help.

VT_I2

ALCMultiSource

display multiple supplies

Only available if the property Color from ALC is active.
Defines the display type if the element is connected to several sources:
most prior source: Only the color of the source with the highest priority is used.
two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line.
alternative color: Alternative color for the coloring at multiple supply.

Default: highest priority source

More in the online help

VT_I2

ALCDashLen

Dashing length supplied multiple times

Only available if property display multiple supplies has value two highest prior sources.

Defines the dash length in pixel for the dashed ALC coloring at multiply supply.

Minimal: 0 (automatic dash length)

Maximum: 32767

Default: 0

More in the online help.

ZT_COLOR

ALCAlternativeColor

Alternative color

Only available if property display multiple supplies has value alternative color.

Alternative color for the ALC coloring at multiple supply.

More in the online help.

VT_I2

ALCMSecuredSupply

display secured supply

Only available if Color from ALC was activated.

Definition of the display of the secured supply:

  • double width
  • double brightness
  • normal

Default: normal

More in the online help

VT_BOOL

ALCAlias

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

ALCAliasName

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_R8

ALCReact

Reactance value of the cable [Ohm]

Maximum permitted reactance value of the line in ohms.

More in the online help.

VT_R8

ALCResist

Resistance value of the electric line [Ohm]

Maximum permitted resistance value of the line in ohms.

More in the online help.

VT_R8

ALCLength

Length of the line [km]

ALC line: Length of the line.

More in the online help.

VT_I2

ALCMaxIType

Limit current carrying capacity

ALC switch: Limit value of current capacity [selection of fixed/variable].

More in the online help.

VT_R8

ALCMaxIVal

Limit fixed current carrying capacity [A]

ALC switch: Limit fixed current carrying capacity.

More in the online help.

ZT_VARIABLE_DYN

ALCVarMaxI

Limit variable current carrying capacity

More...

ALCVarMaxIEx

ALCVarMaxIEx

ZT_VARIABLE_DYN

ALCVarCalcI

Measuring value of the calculated current flow

ALC line: Measuring value of the calculated current flow.

More in the online help.

More...

ALCVarCalcIEx

ALCVarCalcIEx

ALC Leitung: Messwert des berechneten Stromflusses für Export.

Mehr in der Online-Hilfe.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Picture alarm

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Picture alarm

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

ZT_VARIABLE_DYN

Variable

Variable

Name of the linked variable. Click on button ... in order to open the dialog for selecting variables.
The value of this variable is displayed in this element and can also be set here.

Note: Only available for buttons if they are used as a switch.

Hint: If the variable value is to be toggled, we recommend activating the Permanently read variable property. Otherwise Runtime waits until the driver knows the value of the variables. If the value is not available due to a breakdown in communication with the control unit, the waiting time corresponds to the timeout time of the driver.

Only SICAM 230 and Screen Alarm element:
The description above only applies to the elements Text Button, Bitmap Button and Invisible Button.
Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).

  • Lower bit: Alarm active/inactive
  • Higher bit: Alarm acknowledged/not acknowledged

More in the online help.

ZT_FUNCTION_DYN

Function

Function

Name of the linked function.
Opens the function selection dialog.
This function will be executed when the button is clicked in the Runtime or when the assigned key shortcut is pressed.
If you wish to execute more than one function, you need to create a script with the required functions and specify the function for executing that script here.

SICAM 230 and screen alarming element only:

In addition to the standard screen switch property, the screen whose alarm states are supposed to be displayed will be determined by the linked function.
Obligatory (unless the Global setting is active)!

More in the online help.

ZT_SHORTCUT

ShortCut

Key combination

Shortcuts support executing operable elements. For example:

- Executing control elements and functions which have an element assigned
- Write set value (e.g. for switches)
- Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)

A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly.

More in the online help.

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_BSTR

Text1

Text line 1

First text line in button.
By using the & character, you can underline the following character in the Runtime. To display the character & itself, enter "&&".

With character string \n a line break can be forced.

Attention: To use \n, property Text line 2 must be empty.

More in the online help

VT_BSTR

Text2

Text line 2

Second text line in button.
By using the & character, you can underline the following character in the Runtime. To display the character & itself, enter &&.

Note: This property serves the compatibility with older version. In current versions: Use property Text line 1 and start new lines with \n.

Attention: This line must remain empty if the automatic line break should be used.

More in the online help.

VT_BSTR

DownText

Text when pressed

Label of the button which should be displayed when the button is clicked.

Character string \n forces a new line.

More in the online help.

VT_UI2

BtnStyleBorder

Button shape

Shape of the button:
angular: The button has pointed corners. With the help of the properties of group Rounded corners you can change the pointed corners to rounded corners.
round: The button is displayed round.

More in the online help.

VT_UI2

Frame

Element border

Drop-down list for the selection of the frame type. Available are:

Thin frame

3D

Default: Thin border

More in the online help.

VT_BOOL

ShowState

Display status of variable

Active: The status of the variables is indicated by a colored square at the element.

Color:
red square indicates that there a problems with the communication to the PLC.
Blue square at the client end indicates that the client lost the connection to the server.
Blue square at the station indicates that the value was not initialized.

Position of the square at the element at element form:

Round: top edge, in the middle
rounded: top right corner, slightly offset to the leftangular and all others:

Inactive: The status is not displayed.

More in the online help.

VT_UI2

BtnStyleFill

Filling

Filling of the button:
monochrome: No gradient
linear: steady gradient
radiant: From the bottom to the middle fill color 1, then gradient from the middle to the top
defined point: Gradient from a defined point to the edges of the element

Starting from a defined point with beams: Gradient from a defined point to the edges of the element with beams

More in the online help.

VT_BOOL

BtnStyleInvert

Invert color gradient

Only available if the button is not filled with one color.
Active: The brightness gradient is inverted.
Inactive: The brightness gradient is not inverted.
Default: inactive.

More in the online help.

VT_I2

ColorGradientOffset

Offset [%]

Only available if at a vector element the property Color gradient or at the dynamic element Button property Filling was set. linear or Starting from a defined point or Starting from a defined point with beams.

Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.

Values: 0 equals the center of the element. 100 the edge.
Note: The value can also be outside of the element and is therefore not limited to 100.

More in the online help.

VT_I2

ColorGradientAngle

Angle [°]

Defines the direction of the color gradient starting in the center of the element.

Values: 0° to 360°.

Default: 0°

More in the online help.

VT_BOOL

CornerProportional

Proportional

Only available if property With brightness values is inactive.

Active: For creating a radiused corner only the x value can be entered. The y value is always the same.

The percentage entered at property All x [%] refers to the shorter side (width or height) of the element.

Inactive: The x and y values can be entered freely. The x value refers to the width of the element. The y value refers to the height of the element.

Default: active

More in the online help.

VT_I4

CornerAll_X

All x [%]

Only available if property With brightness values is inactive.

Defines the radius values of the X-axis in percent for all corners. This value is used for all corners whose values equals -1. Individual corners can therefore be defined independently.

If the radius value is changed, all corners automatically receive the value -1. With this all corners are set back to the pre-defined value.

Value range: 0 % to 100 %.

Default: 20

More in the online help.

VT_I4

CornerAll_Y

All y [%]

Only available if the property Proportional is active and the property With brightness values is inactive.

Defines the radius values of the Y-axis in percent for all corners. This value is used for all corners whose values equals -1. Individual corners can therefore be defined independently.

If the radius value is changed, all corners automatically receive the value -1. With this all corners are set back to the pre-defined value.

Value range: 0 % to 100 %.

Default: 20

More in the online help.

VT_I4

CornerLeftTop_X

Left/top x [%]

Only available if the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the X-axis for the top left corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All x [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerLeftTop_Y

Left/top y [%]

Only available if the property Proportional is active, the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the Y-axis for the top left corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All y [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerRightTop_X

Right/top x [%]

Only available if the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the X-axis for the top right corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All x [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerRightTop_Y

Right/top y [%]

Only available if the property Proportional is active, the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the Y-axis for the top right corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All y [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerRightBottom_X

Right/bottom x [%]

Only available if property With brightness values is inactive.

Defines the radius value of the X-axis for the bottom right corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All x [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerRightBottom_Y

Right/bottom y [%]

Only available if the property Proportional is active, the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the Y-axis for the bottom right corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All y [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerLeftBottom_X

Left/bottom x [%]

Only available if the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the X-axis for the bottom left corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All x [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerLeftBottom_Y

Left/bottom y [%]

Only available if the property Proportional is active, the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the Y-axis for the bottom left corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All y [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

ZT_FILE

FileName

Graphics file

Graphics file which should be displayed on the button when the button is not pressed (*.bmp, *.wmf, *.jpg, *.gif, *.png). Click on button ... Opens the file selection dialog.

More in the online help.

ZT_FILE

FileNameDown

Graphics file for pressed

Graphics file which should be displayed on the button when the button is pressed (*.bmp, *.wmf, *.jpg, *.gif). Click on button ... Opens the file selection dialog.

More in the online help.

VT_UI2

GraphicSize

Graphic size

Definition of the graphics size.

  • Adjusted: The size of the graphics is adjusted to the size of the element.
  • Original size: The linked graphic is displayed in original size.
    When selecting this option, the properties Width [pixels] and Height [pixels] can no longer be individually configured for the elements multibin, combi-element, button and switch.

Default: Stretched

More in the online help.

VT_BOOL

Animate

Always

Active: The animation always runs.
Inactive: Then the animation is not executed. You can switch the animation on and off with an optional link to Variable.

More in the online help

ZT_VARIABLE_DYN

AnimateVar

Variable

Bit variable that switches the animation on and off.

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BorderColor

Border color

Define the frame color of the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front. At selecting Automatical the color value changes depending on the value of Fill color.

More in the online help.

VT_UI1

AlphaBorderColor

Transparency border color [%]

Only available if property With brightness values is inactive.

Only available if project property Graphics quality is active.

Defines the opacity of the color via a value between 0 and 100.

0: invisible

100: opaque

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_UI1

AlphaBackColor

Transparency of the fill color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor2

Gradient color

Only available if for property Filling pattern Color gradient is selected and the project property Graphics quality is active.

Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of Fill color.

More in the online help.

VT_UI1

AlphaBackColor2

Transparency gradient color [%]

Only available if Linear was selected in the Filling pattern property.

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

VT_BOOL

Transparent

Transparent

Active: Deactivates the background color of the element.

The effect of this option on a button is an Invisible button. It can be positioned above other elements as an invisible button.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable2

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BackColorVariable2Preview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_I2

HorizontalAlign

Alignment horizontal

Horizontal alignment of the output in the element for the display. Possible settings via the drop-down list:

centered
- left-adjusted
- right-adjusted

Default: centered

More in the online help.

VT_I2

VerticalAlign

Alignment vertical

Vertical alignment of the output in the element for the display. Possible settings via the drop-down list:

centered
- top
- bottom

Default: Centered

More in the online help.

VT_BOOL

Wordbreak

Automatic word wrap

Active: Automatic word wrap is used for the text in the element.
The length of the lines depends on the width of the element.
Inactive: The text is displayed in one line.
Default: inactive.

More in the online help.

VT_UI2

Passwordlevel

Authorization level

Password level for writing set values or executing functions with the selected dynamic element.
Minimum: 0.
Maximum: 127.
Default: 0.

More in the online help.

VT_UI4

Locking

Interlocking

Link to an existing interlocking to this element.

If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.

Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BOOL

BAGlobal

Global

Alarms will be considered system-wide.
Main use: Sum alarm of the global alarm list.
Active: Alarms will be considered independently of the linked screen.
The linked function will only be used for screen switching.

Inactive: Only alarms of the linked screen will be considered.

VT_BOOL

BAPriorit?t

Priority

Prioritization of the alarm/event classes.
Active: Even if more than one alarm/event classes were selected, only one of them will be displayed.
Priority rules:

  1. The lower the class number, the higher the priority.
  2. Not acknowledged has a higher priority than acknowledged.

Inactive: all selected classes will be displayed (side by side).

VT_BOOL

BAUnsichtbar

Invisible

The element will not be displayed during Runtime

Active: The element will not be hidden during Runtime
Will be applied if the element only actuates an image variable but is not supposed to be displayed itself.

Inactive: The element will be displayed as a button.

VT_UI2

BAProjekt

Project

Selection of a single project or of all projects.

Only available if Global is active.

Used for multi-hierarchic projects.

ZT_ALARMKLASSE

BAKlassen

Alarm/event classes

Selection of alarm/event groups which should be displayed.

Opens the class selection catalog.

VT_UI2

Offset

First alarm/event class to be displayed

Starting with this class, the class states will be written to the image variable.

VT_BOOL

AbbModus

Image of the selected alarm/event classes

Defines how the class states will be written to the image variable.

Active: The states of the selected alarm/event classes will be written to the image variable without gaps.
e.g. selected classes 1,3 -> class 1: bits 0,1; class 3: bits 2,3

Inactive: The states of the selected alarm/event classes will be written to the image variable with fixed position.
e.g. selected classes 1,3 -> class 1: bits 0,1;0 (class 2: bits 2.3); class 3: bits 4,5

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_BOOL

Signature

Signature necessary

Active: A signature is necessary to operate the element.

For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.

Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.

Inactive: No signature is required.

(Default) Inactive:

More in the online help.

VT_BSTR

SignatureText

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties.

More in the online help.

VT_I2

SignatureEditModus

Signature text editable

Defines whether the signature text can be edited. Selection from drop-down list:

  • Apply project settings: The settings of the Signature text editable project property are applicable.
  • Yes: Text can be edited.
  • No: Text cannot be edited.

Default: Apply project settings

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Bargraph

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Bargraph

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

DynEleVar

DynEleVar

"With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX
zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_UI2

Frame

Element border

Drop-down list for the selection of the frame type. Available are:

Thin frame

3D

Default: Thin border

More in the online help.

VT_BOOL

ShowState

Display status of variable

Active: The status of the variables is indicated by a colored square at the element.

Color:
red square indicates that there a problems with the communication to the PLC.
Blue square at the client end indicates that the client lost the connection to the server.
Blue square at the station indicates that the value was not initialized.

Position of the square at the element at element form:

Round: top edge, in the middle
rounded: top right corner, slightly offset to the leftangular and all others:

Inactive: The status is not displayed.

More in the online help.

VT_BOOL

FromZero

From zero

Only affects the display of values with a sign:
Active: The bar ranges from zero to the current value of the linked variable.
Inactive: The bar ranges from the lowest displayed value to the current value of the linked variable.
Default: inactive.

More in the online help.

VT_BOOL

Explicit

Explicit

This property affects only the display of values with defined limits from variables. Limits from reaction matrices are not considered.

  • Active: If a limit value of the linked variable is breached, only the part of the display that goes into the limit value breach is shown in the color of the respective limit value.
    If the variable has several defined limit values, the corresponding areas of the display are each shown in the color of the limit value.
  • Inactive: If a limit of the linked variable is violated, the complete display is displayed in the color of the violated limit.

Default: inactive

Note: Only available at element Pointer instrument if the display is activated as Ribbon or Arc of a circle.

More in the online help.

VT_UI2

Direction

Direction

Direction of the bar.
Up: Lowest value at the bottom, highest value at the top.
Move down: Lowest value at the top, highest value at the bottom.
Move left: Lowest value on the right, highest value on the left.
Move right: Highest value on the left, highest value on the right.

More in the online help.

VT_BOOL

Absolute

Absolute amount

For element Numeric value only available if property Display value in percent is inactive.

Active: Unsigned display of the variable value (-200 = 200).
Inactive: Normal display of the value.
Default: inactive.

Note: In this case, the set value is entered in percent.

More in the online help

VT_BOOL

ShowScale

Display scale

Active: A scale is shown in the element
inactive: No scale is displayed.

More in the online help.

ZT_VARIABLE_DYN

Variable

Variable

Name of the linked variable. Click on button ... in order to open the dialog for selecting variables.
The value of this variable is displayed in this element and can also be set here.

Note: Only available for buttons if they are used as a switch.

Hint: If the variable value is to be toggled, we recommend activating the Permanently read variable property. Otherwise Runtime waits until the driver knows the value of the variables. If the value is not available due to a breakdown in communication with the control unit, the waiting time corresponds to the timeout time of the driver.

Only SICAM 230 and Screen Alarm element:
The description above only applies to the elements Text Button, Bitmap Button and Invisible Button.
Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).

  • Lower bit: Alarm active/inactive
  • Higher bit: Alarm acknowledged/not acknowledged

More in the online help.

VT_BOOL

ViewLimitFromVar

Apply display range from variables

Takes over the display area of the linked variable. You can update this display area during replacement with a variable with a different values range.

More in the online help.

VT_R8

ViewMin

Minimum

Lowest variable value that is to be displayed in the element.

More in the online help.

VT_R8

ViewMax

Maximum

Highest variable value that is to be displayed in the element.

More in the online help.

ZT_VARIABLE_DYN

DynMinVar

Minimum

Variable that defines the minimum of the display range in Runtime.

More in the online help.

ZT_VARIABLE_DYN

DynMaxVar

Maximum

Variable that defines the maximum of the display range in Runtime.

More in the online help.

ZT_COLOR

TextColor

Bar color

Color for the bar of the bar chart. The set color is used if there has been no breach of the limit value.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BOOL

Transparent

Transparent

Active: Deactivates the background color of the element.

The effect of this option on a button is an Invisible button. It can be positioned above other elements as an invisible button.

More in the online help.

VT_BOOL

LimitColor

Use limit color

You can define whether the limit color which has been defined at the variable which is linked with the element should be displayed in the Runtime. Depending on the element the color affects the displayed text or for the universal slider its indicator.

Active: The defined limit color is displayed in the Runtime.

Default: active (in order to ensure compatibility)

More in the online help.

VT_BOOL

IsSetValue

Setting values active

Active: Setting of variables for this dynamic element is allowed.
Inactive: The variable is write-protected in this element.

More in the online help.

VT_BOOL

Preset

propose current value

Active: The current value of the variable is proposed as set value.
In this case, the value is added under "Set value / amend by" before setting the actual value (positive value) or subtracted from this (negative value).
Inactive: The value defined in "Set value / amend" is proposed.

More in the online help.

VT_BOOL

HWDirect

without dialog

Active: The value is sent to the hardware without a possibility to be changed in the Runtime.
Inactive: The user still has the possibility to amend the value in Runtime before writing to the hardware.

More in the online help.

VT_R8

SetValue

Set value / change by

Value that should be sent as the set value or as a default.
If "Propose current value" is active:: Value that is added to the current value.
In combination with the "without dialog" property, such an increment (positive value) or decrement (negative value) can be implemented.

More in the online help.

VT_UI1

SetValueWith

Write set value via

Send value with:
Command Processing: The new value is set using Set value input in the Command Processing.

Standard dialog box: The new value is entered using the standard dialog box. If a screen of type "Keyboard" with name "SETVALUEKBD" (for numeric values) or "SETSTRINGKBD" (for string variables) exists, it is used instead of the standard dialog box.

Element: The new value is directly entered in the element (only for the elements numeric value and text element).

Program: The new value is entered in an external program.

More in the online help.

VT_BSTR

SetProgram

External program

Only available if an external program was selected for Write set value:
The set value is written by an external program that must be selected in the dialog box that appears here.

This program is then started and gets the following parameters:
1) Name of the linked variable
2) Proposed value, as defined in the corresponding properties
3) Left coordinate of the element in pixels
4) Upper coordinate of the element in pixels
5) Right coordinate of the element in pixels
6) Lower coordinate of the element in pixels
7) Permitted minimum for the set value, as defined in the corresponding properties
8) Permitted maximum for the set value, as defined in the corresponding properties

More in the online help.

VT_BOOL

KbdUsage

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

ZT_PICTURE

KbdName

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

VT_BOOL

LimitFromVar

Take set value limits from variable

Active: The limitation of the range for which the set values can be written are not set via “Min” and “Max” but are taken from the variable definitions directly.
Inactive: The range can be limited directly in the "Minimum" and "Maximum".

More in the online help.

VT_R8

Min

Minimum

Only available if "Take set value limits from variable" is not active::
Bottom limit of the permitted range for the set value.

Attention: The value entered here is ignored if a variable is selected for the dynamic set value minimum.

More in the online help.

VT_R8

Max

Maximum

Only available if "Take set value limits from variable" is not active::
Upper limit of the permitted range for the set value.

Attention: The value entered here is ignored if a variable is selected for the dynamic set value maximum.

More in the online help.

VT_UI2

Passwordlevel

Authorization level

Password level for writing set values or executing functions with the selected dynamic element.
Minimum: 0.
Maximum: 127.
Default: 0.

More in the online help.

VT_UI4

Locking

Interlocking

Link to an existing interlocking to this element.

If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.

Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_BOOL

Signature

Signature necessary

Active: A signature is necessary to operate the element.

For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.

Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.

Inactive: No signature is required.

(Default) Inactive:

More in the online help.

VT_BSTR

SignatureText

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties.

More in the online help.

VT_I2

SignatureEditModus

Signature text editable

Defines whether the signature text can be edited. Selection from drop-down list:

  • Apply project settings: The settings of the Signature text editable project property are applicable.
  • Yes: Text can be edited.
  • No: Text cannot be edited.

Default: Apply project settings

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


CDrawBefCommand

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> CDrawBefCommand

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_UI2 | Mode | Mode | Used for selecting the intended purpose Input: Command element will be used for command input Function call: Command element will be used for executing functions. This option only exists for reasons of compatibility with older versions and should not be used any longer.
ZT_FUNCTION | Function | Function | Specifies the function to be executed for mode: Function . No longer used. Kept only for reasons of compatibility with older versions.
VT_I2 | ActivationGroup | Activation group | Specifies the activation group. Only required in combination with the pre-selection function.
VT_UI2 | Passwordlevel | Authorization level | Password level for writing set values or executing functions with the selected dynamic element. Minimum: 0. Maximum: 127. Default: 0. More in the online help.
More... | PictSwitch | PictSwitch |


Command

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Command

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

AlwaysSelectable

always available

Active: Command selection directly via left mouse click.

Inactive: Command selection only possible after previous selection function (Functions ->Application->Command activation)
After commands have been activated in Runtime, a border will be displayed around all elements that have been configured this way.

Create a new command action via right mouse click -> Action new.

Attention: only available in the left window in the dialog view.

More...

Action

Action

Properties for command actions

More in the online help.

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Move

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Move

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

DynEleVarX

DynEleVarX

"With this property you have the opportunity to get informations about the variable which is linked at the ""dynamic x position"" property.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""DynEleVarX.SymVarName"") 'Return the name of the ""x position dynamic"" variable
zElement.DynProperties (""DynEleVarX.SymVarTagNr"") 'Return the identification of the ""x position dynamic"" variable"

More...

DynEleVarY

DynEleVarY

"With this property you have the opportunity to get informations about the variable which is linked at the ""dynamic y position"" property.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""DynEleVarY.SymVarName"") 'Return the name of the ""y position dynamic"" variable
zElement.DynProperties (""DynEleVarY.SymVarTagNr"") 'Return the identification of the ""y position dynamic"" variable"

More...

DynEleVarXZoom

DynEleVarXZoom

"With this property you have the opportunity to get informations about the variable which is linked at the ""change width"" property.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""DynEleVarXZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""DynEleVarXZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

DynEleVarYZoom

DynEleVarYZoom

"With this property you have the opportunity to get informations about the variable which is linked at the ""change height"" property.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""DynEleVarYZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""DynEleVarYZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

VT_UI2

Symbol

Symbol

A symbol can be selected from the list of symbols present in the screen.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_BOOL

IsXActive

Change X direction active

Active: Horizontal movement of the linked element is available.
Inactive: Horizontal movement is not available.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_BOOL

IsYActive

Change Y direction active

Active: Vertical movement of the linked element is available.
Inactive: Vertical movement is not available.

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

VT_BOOL

IsXZoomActive

Change width active

Active: Zooming of the width of the linked element is available.
Inactive: Zooming of the width is not available.

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

VT_BOOL

IsYZoomActive

Change height active

Activate zooming of the height of the element.

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Binary

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Binary

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

DynEleVar

DynEleVar

"With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX
zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_UI2

Symbol

Symbol

A symbol can be selected from the list of symbols present in the screen.

More in the online help.

VT_BOOL

ShowState

Display status of variable

Active: The status of the variables is indicated by a colored square at the element.

Color:
red square indicates that there a problems with the communication to the PLC.
Blue square at the client end indicates that the client lost the connection to the server.
Blue square at the station indicates that the value was not initialized.

Position of the square at the element at element form:

Round: top edge, in the middle
rounded: top right corner, slightly offset to the leftangular and all others:

Inactive: The status is not displayed.

More in the online help.

VT_BOOL

ContitionText

Display limit text

Active: The status/limit value of the assigned variable is shown in the element.
Inactive: No text is displayed.

More in the online help.

VT_BOOL

FillArea

Color only filler area

Active: with circles, polygons and rectangles assigned to this linked symbol, only the fill color is changed according to the color definition of the variables. The color of the border is retained.
Inactive: The border is also colored accordingly.
Default: inactive.

More in the online help.

ZT_VARIABLE_DYN

Variable

Variable

Name of the linked variable. Click on button ... in order to open the dialog for selecting variables.
The value of this variable is displayed in this element and can also be set here.

Note: Only available for buttons if they are used as a switch.

Hint: If the variable value is to be toggled, we recommend activating the Permanently read variable property. Otherwise Runtime waits until the driver knows the value of the variables. If the value is not available due to a breakdown in communication with the control unit, the waiting time corresponds to the timeout time of the driver.

Only SICAM 230 and Screen Alarm element:
The description above only applies to the elements Text Button, Bitmap Button and Invisible Button.
Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).

  • Lower bit: Alarm active/inactive
  • Higher bit: Alarm acknowledged/not acknowledged

More in the online help.

VT_BOOL

IsSetValue

Setting values active

Active: Setting of variables for this dynamic element is allowed.
Inactive: The variable is write-protected in this element.

More in the online help.

VT_BOOL

Preset

propose current value

Active: The current value of the variable is proposed as set value.
In this case, the value is added under "Set value / amend by" before setting the actual value (positive value) or subtracted from this (negative value).
Inactive: The value defined in "Set value / amend" is proposed.

More in the online help.

VT_BOOL

HWDirect

without dialog

Active: The value is sent to the hardware without a possibility to be changed in the Runtime.
Inactive: The user still has the possibility to amend the value in Runtime before writing to the hardware.

More in the online help.

VT_R8

SetValue

Set value / change by

Value that should be sent as the set value or as a default.
If "Propose current value" is active:: Value that is added to the current value.
In combination with the "without dialog" property, such an increment (positive value) or decrement (negative value) can be implemented.

More in the online help.

VT_UI1

SetValueWith

Write set value via

Send value with:
Command Processing: The new value is set using Set value input in the Command Processing.

Standard dialog box: The new value is entered using the standard dialog box. If a screen of type "Keyboard" with name "SETVALUEKBD" (for numeric values) or "SETSTRINGKBD" (for string variables) exists, it is used instead of the standard dialog box.

Element: The new value is directly entered in the element (only for the elements numeric value and text element).

Program: The new value is entered in an external program.

More in the online help.

VT_BSTR

SetProgram

External program

Only available if an external program was selected for Write set value:
The set value is written by an external program that must be selected in the dialog box that appears here.

This program is then started and gets the following parameters:
1) Name of the linked variable
2) Proposed value, as defined in the corresponding properties
3) Left coordinate of the element in pixels
4) Upper coordinate of the element in pixels
5) Right coordinate of the element in pixels
6) Lower coordinate of the element in pixels
7) Permitted minimum for the set value, as defined in the corresponding properties
8) Permitted maximum for the set value, as defined in the corresponding properties

More in the online help.

VT_BOOL

LimitFromVar

Take set value limits from variable

Active: The limitation of the range for which the set values can be written are not set via “Min” and “Max” but are taken from the variable definitions directly.
Inactive: The range can be limited directly in the "Minimum" and "Maximum".

More in the online help.

VT_R8

Min

Minimum

Only available if "Take set value limits from variable" is not active::
Bottom limit of the permitted range for the set value.

Attention: The value entered here is ignored if a variable is selected for the dynamic set value minimum.

More in the online help.

VT_R8

Max

Maximum

Only available if "Take set value limits from variable" is not active::
Upper limit of the permitted range for the set value.

Attention: The value entered here is ignored if a variable is selected for the dynamic set value maximum.

More in the online help.

VT_UI2

Passwordlevel

Authorization level

Password level for writing set values or executing functions with the selected dynamic element.
Minimum: 0.
Maximum: 127.
Default: 0.

More in the online help.

VT_UI4

Locking

Interlocking

Link to an existing interlocking to this element.

If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.

Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_BOOL

Signature

Signature necessary

Active: A signature is necessary to operate the element.

For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.

Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.

Inactive: No signature is required.

(Default) Inactive:

More in the online help.

VT_BSTR

SignatureText

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties.

More in the online help.

VT_I2

SignatureEditModus

Signature text editable

Defines whether the signature text can be edited. Selection from drop-down list:

  • Apply project settings: The settings of the Signature text editable project property are applicable.
  • Yes: Text can be edited.
  • No: Text cannot be edited.

Default: Apply project settings

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Bitmap

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Bitmap

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_UI2

Passwordlevel

Authorization level

Password level for writing set values or executing functions with the selected dynamic element.
Minimum: 0.
Maximum: 127.
Default: 0.

More in the online help.

VT_UI4

Locking

Interlocking

Link to an existing interlocking to this element.

If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.

Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

ZT_FUNCTION_DYN

Function

Function

Name of the linked function.
Opens the function selection dialog.
This function will be executed when the button is clicked in the Runtime or when the assigned key shortcut is pressed.
If you wish to execute more than one function, you need to create a script with the required functions and specify the function for executing that script here.

SICAM 230 and screen alarming element only:

In addition to the standard screen switch property, the screen whose alarm states are supposed to be displayed will be determined by the linked function.
Obligatory (unless the Global setting is active)!

More in the online help.

ZT_MDIFUNKTION

MDIFunction

Screen type specific function

Only available in screens with a special screen type (screen type is not standard):
Linking to a screen-specific function. Clicking on the ... button opens the dialog for selecting a screen-specific function. This function is executed if the button is clicked with the mouse in Runtime or the linked key combination is pressed.

Attention: In addition to a screen-type specific function, it is also possible to link a general function with the button. In this case, note the sequence of execution when clicking on the button: The screen-type-specific function is executed first. Only once this has been ended is the general function executed. If VBA events are linked to the button in Runtime, these are executed before the functions.

More in the online help.

VT_BOOL

ThreeDimensional

3D

Active: The element is displayed threedimensionally.
Inactive: The element is displayed flat.

More in the online help.

VT_I2

GraphicSize

Graphic size

Definition of the graphics size.

  • Adjusted: The size of the graphics is adjusted to the size of the element.
  • Original size: The linked graphic is displayed in original size.
    When selecting this option, the properties Width [pixels] and Height [pixels] can no longer be individually configured for the elements multibin, combi-element, button and switch.

Default: Stretched

More in the online help.

ZT_FILE

FileName

Graphics file

Graphics file which should be displayed on the button when the button is not pressed (*.bmp, *.wmf, *.jpg, *.gif, *.png). Click on button ... Opens the file selection dialog.

More in the online help.

ZT_SHORTCUT

ShortCut

Key combination

Shortcuts support executing operable elements. For example:

- Executing control elements and functions which have an element assigned
- Write set value (e.g. for switches)
- Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)

A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly.

More in the online help.

VT_BOOL

Animate

Always

Active: The animation always runs.
Inactive: Then the animation is not executed. You can switch the animation on and off with an optional link to Variable.

More in the online help

ZT_VARIABLE_DYN

AnimateVar

Variable

Bit variable that switches the animation on and off.

More in the online help.

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_BOOL

Signature

Signature necessary

Active: A signature is necessary to operate the element.

For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.

Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.

Inactive: No signature is required.

(Default) Inactive:

More in the online help.

VT_BSTR

SignatureText

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties.

More in the online help.

VT_I2

SignatureEditModus

Signature text editable

Defines whether the signature text can be edited. Selection from drop-down list:

  • Apply project settings: The settings of the Signature text editable project property are applicable.
  • Yes: Text can be edited.
  • No: Text cannot be edited.

Default: Apply project settings

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


CDynEleFkt

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> CDynEleFkt

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
ZT_FUNCTION | ProjectFunction | ProjectFunction |
VT_BSTR | Name | Name |


Text button

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Text button

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

ThreeDimensional

3D

Active: The element is displayed threedimensionally.
Inactive: The element is displayed flat.

More in the online help.

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_BSTR

Text1

Text line 1

First text line in button.
By using the & character, you can underline the following character in the Runtime. To display the character & itself, enter "&&".

With character string \n a line break can be forced.

Attention: To use \n, property Text line 2 must be empty.

More in the online help

VT_BSTR

Text2

Text line 2

Second text line in button.
By using the & character, you can underline the following character in the Runtime. To display the character & itself, enter &&.

Note: This property serves the compatibility with older version. In current versions: Use property Text line 1 and start new lines with \n.

Attention: This line must remain empty if the automatic line break should be used.

More in the online help.

VT_BSTR

DownText

Text when pressed

Label of the button which should be displayed when the button is clicked.

Character string \n forces a new line.

More in the online help.

VT_UI2

BtnStyleBorder

Button shape

Shape of the button:
angular: The button has pointed corners. With the help of the properties of group Rounded corners you can change the pointed corners to rounded corners.
round: The button is displayed round.

More in the online help.

VT_UI2

Frame

Element border

Drop-down list for the selection of the frame type. Available are:

Thin frame

3D

Default: Thin border

More in the online help.

VT_BOOL

ShowState

Display status of variable

Active: The status of the variables is indicated by a colored square at the element.

Color:
red square indicates that there a problems with the communication to the PLC.
Blue square at the client end indicates that the client lost the connection to the server.
Blue square at the station indicates that the value was not initialized.

Position of the square at the element at element form:

Round: top edge, in the middle
rounded: top right corner, slightly offset to the leftangular and all others:

Inactive: The status is not displayed.

More in the online help.

VT_UI2

BtnStyleFill

Filling

Filling of the button:
monochrome: No gradient
linear: steady gradient
radiant: From the bottom to the middle fill color 1, then gradient from the middle to the top
defined point: Gradient from a defined point to the edges of the element

Starting from a defined point with beams: Gradient from a defined point to the edges of the element with beams

More in the online help.

VT_BOOL

BtnStyleInvert

Invert color gradient

Only available if the button is not filled with one color.
Active: The brightness gradient is inverted.
Inactive: The brightness gradient is not inverted.
Default: inactive.

More in the online help.

VT_I2

ColorGradientOffset

Offset [%]

Only available if at a vector element the property Color gradient or at the dynamic element Button property Filling was set. linear or Starting from a defined point or Starting from a defined point with beams.

Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.

Values: 0 equals the center of the element. 100 the edge.
Note: The value can also be outside of the element and is therefore not limited to 100.

More in the online help.

VT_I2

ColorGradientAngle

Angle [°]

Defines the direction of the color gradient starting in the center of the element.

Values: 0° to 360°.

Default: 0°

More in the online help.

VT_BOOL

CornerProportional

Proportional

Only available if property With brightness values is inactive.

Active: For creating a radiused corner only the x value can be entered. The y value is always the same.

The percentage entered at property All x [%] refers to the shorter side (width or height) of the element.

Inactive: The x and y values can be entered freely. The x value refers to the width of the element. The y value refers to the height of the element.

Default: active

More in the online help.

VT_I4

CornerAll_X

All x [%]

Only available if property With brightness values is inactive.

Defines the radius values of the X-axis in percent for all corners. This value is used for all corners whose values equals -1. Individual corners can therefore be defined independently.

If the radius value is changed, all corners automatically receive the value -1. With this all corners are set back to the pre-defined value.

Value range: 0 % to 100 %.

Default: 20

More in the online help.

VT_I4

CornerAll_Y

All y [%]

Only available if the property Proportional is active and the property With brightness values is inactive.

Defines the radius values of the Y-axis in percent for all corners. This value is used for all corners whose values equals -1. Individual corners can therefore be defined independently.

If the radius value is changed, all corners automatically receive the value -1. With this all corners are set back to the pre-defined value.

Value range: 0 % to 100 %.

Default: 20

More in the online help.

VT_I4

CornerLeftTop_X

Left/top x [%]

Only available if the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the X-axis for the top left corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All x [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerLeftTop_Y

Left/top y [%]

Only available if the property Proportional is active, the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the Y-axis for the top left corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All y [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerRightTop_X

Right/top x [%]

Only available if the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the X-axis for the top right corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All x [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerRightTop_Y

Right/top y [%]

Only available if the property Proportional is active, the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the Y-axis for the top right corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All y [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerRightBottom_X

Right/bottom x [%]

Only available if property With brightness values is inactive.

Defines the radius value of the X-axis for the bottom right corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All x [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerRightBottom_Y

Right/bottom y [%]

Only available if the property Proportional is active, the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the Y-axis for the bottom right corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All y [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerLeftBottom_X

Left/bottom x [%]

Only available if the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the X-axis for the bottom left corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All x [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerLeftBottom_Y

Left/bottom y [%]

Only available if the property Proportional is active, the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the Y-axis for the bottom left corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All y [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

ZT_FILE

FileName

Graphics file

Graphics file which should be displayed on the button when the button is not pressed (*.bmp, *.wmf, *.jpg, *.gif, *.png). Click on button ... Opens the file selection dialog.

More in the online help.

ZT_FILE

FileNameDown

Graphics file for pressed

Graphics file which should be displayed on the button when the button is pressed (*.bmp, *.wmf, *.jpg, *.gif). Click on button ... Opens the file selection dialog.

More in the online help.

VT_UI2

GraphicSize

Graphic size

Definition of the graphics size.

  • Adjusted: The size of the graphics is adjusted to the size of the element.
  • Original size: The linked graphic is displayed in original size.
    When selecting this option, the properties Width [pixels] and Height [pixels] can no longer be individually configured for the elements multibin, combi-element, button and switch.

Default: Stretched

More in the online help.

VT_BOOL

Animate

Always

Active: The animation always runs.
Inactive: Then the animation is not executed. You can switch the animation on and off with an optional link to Variable.

More in the online help

ZT_VARIABLE_DYN

AnimateVar

Variable

Bit variable that switches the animation on and off.

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BorderColor

Border color

Define the frame color of the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front. At selecting Automatical the color value changes depending on the value of Fill color.

More in the online help.

VT_UI1

AlphaBorderColor

Transparency border color [%]

Only available if property With brightness values is inactive.

Only available if project property Graphics quality is active.

Defines the opacity of the color via a value between 0 and 100.

0: invisible

100: opaque

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_UI1

AlphaBackColor

Transparency of the fill color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor2

Gradient color

Only available if for property Filling pattern Color gradient is selected and the project property Graphics quality is active.

Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of Fill color.

More in the online help.

VT_UI1

AlphaBackColor2

Transparency gradient color [%]

Only available if Linear was selected in the Filling pattern property.

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

VT_BOOL

Transparent

Transparent

Active: Deactivates the background color of the element.

The effect of this option on a button is an Invisible button. It can be positioned above other elements as an invisible button.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable2

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BackColorVariable2Preview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

VT_I2

HorizontalAlign

Alignment horizontal

Horizontal alignment of the output in the element for the display. Possible settings via the drop-down list:

centered
- left-adjusted
- right-adjusted

Default: centered

More in the online help.

VT_I2

VerticalAlign

Alignment vertical

Vertical alignment of the output in the element for the display. Possible settings via the drop-down list:

centered
- top
- bottom

Default: Centered

More in the online help.

VT_BOOL

Wordbreak

Automatic word wrap

Active: Automatic word wrap is used for the text in the element.
The length of the lines depends on the width of the element.
Inactive: The text is displayed in one line.
Default: inactive.

More in the online help.

VT_BOOL

ChangeText

Change text depending on control keys

Only available if you have activated Automatic labeling in the properties of the screen.

active: Use Text line 1 normal to Text line 2 with Ctrl+Alt (Alt Gr) for labelling the button. Inputs at Text line 1 and Text line 2 is no longer necessary.

Default: inactive

More in the online help.

VT_BSTR

Text1Normal

Text line 1 normal

Only available if property Change text depending on control keys is active.
Labels the first text line in the button without pressing a control key.
Notice: By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character.

More in the online help.

VT_BSTR

Text1Shift

Text line 1 with Shift

Only available if property Change text depending on control keys is active.
Labels the first text line in the button if the Shift key is pressed.
Note: By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character.

More in the online help.

VT_BSTR

Text1Ctrl

Text line 1 with Ctrl

Only available if property Change text depending on control keys is active.
Labeling of the first text line in the button if the Control key is pressed.
Note: By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character.

More in the online help.

VT_BSTR

Text1CtrlAlt

Text line 1 with Ctrl+Alt (Alt Gr)

Only available if property Change text depending on control keys is active.
Labels the first text line in the button when the CTRL key and the ALT GR key are pressed.
Note: By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character.

More in the online help.

VT_BSTR

Text2Normal

Text line 2 normal

Only available if property Change text depending on control keys is active.
Labels the second text line in the button without pressing a control key.
Note: By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character.

More in the online help

VT_BSTR

Text2Shift

Text line 2 with Shift

Only available if property Change text depending on control keys is active.
Labels the second text line in the button if the Shift key is pressed.
Note: By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character.

More in the online help.

VT_BSTR

Text2Ctrl

Text line 2 with Ctrl

Only available if property Change text depending on control keys is active.
Labels the second text line in the button if the CTRL key is pressed.
Note: By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character.

More in the online help.

VT_BSTR

Text2CtrlAlt

Text line 2 with Ctrl+Alt (Alt Gr)

Only available if property Change text depending on control keys is active.
Labels the second text line in the button when the CTRL key and the ALT GR key are pressed.
Note: By using the & character, you can underline the following character in the Runtime. Enter ”&&” to display the & character.

More in the online help.

More...

DynEleVar

DynEleVar

"With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX
zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"

More...

DynEleFkt

DynEleFkt

ZT_VARIABLE_DYN

Variable

Variable

Name of the linked variable. Click on button ... in order to open the dialog for selecting variables.
The value of this variable is displayed in this element and can also be set here.

Note: Only available for buttons if they are used as a switch.

Hint: If the variable value is to be toggled, we recommend activating the Permanently read variable property. Otherwise Runtime waits until the driver knows the value of the variables. If the value is not available due to a breakdown in communication with the control unit, the waiting time corresponds to the timeout time of the driver.

Only SICAM 230 and Screen Alarm element:
The description above only applies to the elements Text Button, Bitmap Button and Invisible Button.
Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).

  • Lower bit: Alarm active/inactive
  • Higher bit: Alarm acknowledged/not acknowledged

More in the online help.

ZT_FUNCTION_DYN

Function

Function

Name of the linked function.
Opens the function selection dialog.
This function will be executed when the button is clicked in the Runtime or when the assigned key shortcut is pressed.
If you wish to execute more than one function, you need to create a script with the required functions and specify the function for executing that script here.

SICAM 230 and screen alarming element only:

In addition to the standard screen switch property, the screen whose alarm states are supposed to be displayed will be determined by the linked function.
Obligatory (unless the Global setting is active)!

More in the online help.

VT_BSTR

FunctionParameter

Parameter for substitution

Entry of the character sequence for substitution via parameters. Replaces the key word {PARAM} in the substitution dialog of the screen switching.

Note: Avoid character sequences that are also used for parameter of the indexing variables, such as {X01}.

More in the online help.

ZT_MDIFUNKTION

MDIFunction

Screen type specific function

Only available in screens with a special screen type (screen type is not standard):
Linking to a screen-specific function. Clicking on the ... button opens the dialog for selecting a screen-specific function. This function is executed if the button is clicked with the mouse in Runtime or the linked key combination is pressed.

Attention: In addition to a screen-type specific function, it is also possible to link a general function with the button. In this case, note the sequence of execution when clicking on the button: The screen-type-specific function is executed first. Only once this has been ended is the general function executed. If VBA events are linked to the button in Runtime, these are executed before the functions.

More in the online help.

VT_BOOL

FktOnDown

Function execution on pressing

Active: The linked function is executed when the element is pressed.
Inactive: The linked function is executed when the element is released.
Default: inactive.

More in the online help.

VT_BOOL

Switch

Switch

Only available if property Setting values active is inactive.

Active: The element switches the value of a bit variable.
Inactive: The element carries out a function.
Default: inactive.

More in the online help.

VT_BOOL

Scanner

Momentary switch

Only available if property Switch is active. (Exception: always available in the switch dynamic element.)
Active: The target state - defined in property Momentary switch On - is only held as long as the left mouse button is pressed but at least as long as Holding time [ms].
Inactive: The target state remains even after the mouse button is released.
Default: inactive.

More in the online help.

VT_BOOL

ScannerOn

Momentary switch On

Only available if Momentary switch is active.
Active: Switch switches to ON.
Inactive: Switch switches to OFF.
Default: Inactive.

More in the online help.

VT_BOOL

ResetOnLeave

Reset on exit

Only available if property Momentary switch is active.
If you press and hold the mouse button and move the mouse pointer away from the button, this will automatically reset the value of the variable.

More in the online help

VT_BOOL

FastReaction

Fast reaction

Only available if Switch is active.
Active: The switch immediately changes its position in Runtime, regardless of whether the linked bit has actually been set in the PLC. In the next driver update cycle, the bit will be read from the PLC. Then the switch again ressembles the correct position of the bit in the PLC.
Attention: The switch will only be visibly operable after the value has been read from the PLC.

Inactive: The switch will change its position only after the bit has been sent to the PLC and then again read from the PLC.

(Default) Inactive:

More in the online help.

VT_UI2

ReactionTime

Holding time [ms]

Only available if Switch is active.
If Momentary switch is active: Time (in ms) which a state is held starting from the left click on the respective element.

If property Momentary switch is inactive: Delayed reaction to a left click.

More in the online help.

VT_BOOL

StayPressed

Keep pushed state

Only available if properties Switch, Momentary switch and Fast reaction are active.

Active: As long as you hold the mouse button pressed on this element, its graphical display does not change - independent of possible values changes in the PLC. At the element Switch property 3D must be active in order for this to happen.
Inactive: The element always displays the value of the variable from the PLC.

More in the online help.

VT_UI2

Passwordlevel

Authorization level

Password level for writing set values or executing functions with the selected dynamic element.
Minimum: 0.
Maximum: 127.
Default: 0.

More in the online help.

VT_UI4

Locking

Interlocking

Link to an existing interlocking to this element.

If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.

Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

ZT_SHORTCUT

ShortCut

Key combination

Shortcuts support executing operable elements. For example:

- Executing control elements and functions which have an element assigned
- Write set value (e.g. for switches)
- Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)

A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly.

More in the online help.

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_BOOL

Signature

Signature necessary

Active: A signature is necessary to operate the element.

For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.

Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.

Inactive: No signature is required.

(Default) Inactive:

More in the online help.

VT_BSTR

SignatureText

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties.

More in the online help.

VT_I2

SignatureEditModus

Signature text editable

Defines whether the signature text can be edited. Selection from drop-down list:

  • Apply project settings: The settings of the Signature text editable project property are applicable.
  • Yes: Text can be edited.
  • No: Text cannot be edited.

Default: Apply project settings

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Circle

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Circle

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

ZT_COLOR

LineColor

Line color

Line color of the element.

VT_UI2

LineWidth

Line width [Pixel]

Width of the line (in pixels).
Minimum: 0
In this case the width of the line is 1 pixel.
Maximum: 40
Default: 1
Attention: If in the project settings in node Graphical design you set property Graphics quality to Windows basis, you can use line width >1 only with a line of type "continuous line".

More in the online help.

ZT_IMAGELIST

LineType

Line type

Selection of the line type for the element from the list.
Attention: If in the project settings in node Graphical design you deactivated property Graphics quality, you can use line width >1 only with a line of type "continuous line".
More in the online help.

ZT_IMAGELIST

FillPattern

Filling pattern

Selection of the filling pattern for the element from the list.

This property is only available if property With brightness values is inactive.

More in the online help.

ZT_COLOR

LineColorEx

Line color

Defines the line color of the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

AlphaLineColor

Transparency line color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_UI1

AlphaBackColor

Transparency of the fill color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor2

Gradient color

Only available if for property Filling pattern Color gradient is selected and the project property Graphics quality is active.

Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of Fill color.

More in the online help.

VT_UI1

AlphaBackColor2

Transparency gradient color [%]

Only available if Linear was selected in the Filling pattern property.

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable2

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BackColorVariable2Preview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_I2

Lightning

Color gradient

Only available if property Filling pattern was set to Color gradient.

Defines the color gradient for vector elements.

Linear: steady gradient
Defined point: Gradient from a defined point to the edges of the element

Starting from a defined point with beams: Gradient from a defined point to the edges of the element with beams

More in the online help.

VT_I2

Align

Alignment

Direction of color shift.
horizontal
vertical

VT_I2

Shifted

Shifted color gradient

Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein.

Mehr im Online-Handbuch

VT_I2

ColorGradientOffset

Offset [%]

Only available if at a vector element the property Color gradient or at the dynamic element Button property Filling was set. linear or Starting from a defined point or Starting from a defined point with beams.

Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.

Values: 0 equals the center of the element. 100 the edge.
Note: The value can also be outside of the element and is therefore not limited to 100.

More in the online help.

VT_I2

ColorGradientAngle

Angle [°]

Defines the direction of the color gradient starting in the center of the element.

Values: 0° to 360°.

Default: 0°

More in the online help.

VT_BOOL

Brightness

With brightness values

Only available if Filling pattern was selected as color gradient was selected.

Active: The brightness of the color gradient can be freely defined.
Inactive: The brightness of the color gradient is defined automatically.

Note: The filling pattern can no longer be changed if this property is active. It is also not possible to set rounded corners. If this option is activated for an element that uses rounded corners, the element is displayed with non-rounded corners.

More in the online help.

VT_UI1

OuterBrightness

Brightness outside

Only available if "via brightness value" is active:
Brightness at the outer side of the element.

More in the online help.

VT_UI1

InnerBrightness

Brightness inside

Only available if "via brightness value" is active:
Brightness in the middle of the element.

More in the online help.

VT_BOOL

ALCUseColor

Color from ALC

Only available if you have licensed Automatic Line Coloring (ALC):
Active: The automatic color of the linked source(s) is used.
Inactive: The standard color is used.
Default: inactive.

More in the online help.

VT_I2

ALCPrecedence

Priority for display

Only available if the Color from ALC property is active.

Defines the priority of the display when the element is connected to several active sources.
Multiple supply: The element is displayed according to the rules of the multiple supply.
secured supply: The element is displayed according to the rules of the secured supply.
No priority: The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.

Default: Multiple supply
More in the online help.

VT_I2

ALCMultiSource

display multiple supplies

Only available if the property Color from ALC is active.
Defines the display type if the element is connected to several sources:
most prior source: Only the color of the source with the highest priority is used.
two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line.
alternative color: Alternative color for the coloring at multiple supply.

Default: highest priority source

More in the online help

VT_I2

ALCDashLen

Dashing length supplied multiple times

Only available if property display multiple supplies has value two highest prior sources.

Defines the dash length in pixel for the dashed ALC coloring at multiply supply.

Minimal: 0 (automatic dash length)

Maximum: 32767

Default: 0

More in the online help.

ZT_COLOR

ALCAlternativeColor

Alternative color

Only available if property display multiple supplies has value alternative color.

Alternative color for the ALC coloring at multiple supply.

More in the online help.

VT_I2

ALCMSecuredSupply

display secured supply

Only available if Color from ALC was activated.

Definition of the display of the secured supply:

  • double width
  • double brightness
  • normal

Default: normal

More in the online help

VT_BOOL

ALCAlias

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

ALCAliasName

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_R8

ALCReact

Reactance value of the cable [Ohm]

Maximum permitted reactance value of the line in ohms.

More in the online help.

VT_R8

ALCResist

Resistance value of the electric line [Ohm]

Maximum permitted resistance value of the line in ohms.

More in the online help.

VT_R8

ALCLength

Length of the line [km]

ALC line: Length of the line.

More in the online help.

VT_I2

ALCMaxIType

Limit current carrying capacity

ALC switch: Limit value of current capacity [selection of fixed/variable].

More in the online help.

VT_R8

ALCMaxIVal

Limit fixed current carrying capacity [A]

ALC switch: Limit fixed current carrying capacity.

More in the online help.

ZT_VARIABLE_DYN

ALCVarMaxI

Limit variable current carrying capacity

More...

ALCVarMaxIEx

ALCVarMaxIEx

ZT_VARIABLE_DYN

ALCVarCalcI

Measuring value of the calculated current flow

ALC line: Measuring value of the calculated current flow.

More in the online help.

More...

ALCVarCalcIEx

ALCVarCalcIEx

ALC Leitung: Messwert des berechneten Stromflusses für Export.

Mehr in der Online-Hilfe.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


CDynEleVarMulti

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> CDynEleVarMulti

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_UI2 | Symbol | Symbol | A symbol can be selected from the list of symbols present in the screen. More in the online help.
ZT_COLOR | ColorLow | ColorLow |
ZT_COLOR | ColorHigh | ColorHigh |
ZT_COLOR | BkColorLow | BkColorLow |
ZT_COLOR | BkColorHigh | BkColorHigh |
VT_BSTR | BitmapLow | BitmapLow | "With this item you have the opportunity to get/set the picture for the ""low"" state of a multibin element via a string."
VT_BSTR | BitmapHigh | BitmapHigh | "With this item you have the opportunity to get/set the picture for the ""high"" state of a multibin element via a string."
VT_BSTR | StateTextLow | StateTextLow | With this property you have the opportunity to get/set the text for the low state of the mulibin element.
VT_BSTR | StateTextHigh | StateTextHigh | With this property you have the opportunity to get/set the text for the high state of the mulibin element.
VT_UI4 | KeyFlags1 | KeyFlags1 | "A long value which sets the keys for the ""key combination"" property of the multibin element. This property is available when a bool variable is linked to the element. "
VT_UI4 | KeyFlags2 | KeyFlags2 | "A long value which sets the keys for the ""key combination"" property of the multibin element. This property is available when a bool variable is linked to the element. "
VT_I2 | KeyFlags3 | KeyFlags3 | "A long value which sets the keys for the ""key combination"" property of the multibin element. This property is available when a bool variable is linked to the element. "
VT_UI4 | Value | Value |
VT_BSTR | Bits | Bits |
ZT_VARIABLE | ProjectVar | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
VT_BSTR | SymVarName | SymVarName | This property returns the name of a variable.
VT_BSTR | SymVarTagNr | SymVarTagNr | This property returns the identification of a variable.


Combo Listbox

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Combo Listbox

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

DynEleVar

DynEleVar

"With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX
zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"

More...

States

States

With this property you have the opportunity to get/set some properties of the different statis. The settings can be handled via some subitems.

ZT_VARIABLE_DYN

Variable

Variable

Name of the linked variable. Click on button ... in order to open the dialog for selecting variables.
The value of this variable is displayed in this element and can also be set here.

Note: Only available for buttons if they are used as a switch.

Hint: If the variable value is to be toggled, we recommend activating the Permanently read variable property. Otherwise Runtime waits until the driver knows the value of the variables. If the value is not available due to a breakdown in communication with the control unit, the waiting time corresponds to the timeout time of the driver.

Only SICAM 230 and Screen Alarm element:
The description above only applies to the elements Text Button, Bitmap Button and Invisible Button.
Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).

  • Lower bit: Alarm active/inactive
  • Higher bit: Alarm acknowledged/not acknowledged

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

ZT_COLOR

TextColorSelected

Text color when selected

Defines the color of the text when an element is selected. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front. The color is static and does not use the linked variable.

More in the online help.

ZT_COLOR

BackColorSelected

Background color for selected entry

Defines the background color when an element is selected. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front. The color is static and does not use the linked variable.

More in the online help.

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_UI2

ControlType

Type

Drop-down list: This element is used as a drop-down list.
List box: This element is used as a list box.
Default: List box.

More in the online help.

VT_BSTR

Status

Entries

Only available if the Entries from string variable property is inactive.

Clicking on the ... button opens the dialog for defining the entries for a static list box / combo box.

More in the online help.

VT_BOOL

ShowState

Display status of variable

Active: The status of the variables is indicated by a colored square at the element.

Color:
red square indicates that there a problems with the communication to the PLC.
Blue square at the client end indicates that the client lost the connection to the server.
Blue square at the station indicates that the value was not initialized.

Position of the square at the element at element form:

Round: top edge, in the middle
rounded: top right corner, slightly offset to the leftangular and all others:

Inactive: The status is not displayed.

More in the online help.

VT_BOOL

InstantReaction

Fast reaction

Allows you to display a reaction as already happened, even if the response of a slowly reacting driver has not been received yet.

active: Displays the driver reaction as already happened in the visualization, even if it is still outstanding.

Default: active

Note: In case the driver does not react, the absence of the reaction will not be noticed.

More in the online help.

VT_BOOL

Signature

Signature necessary

Active: A signature is necessary to operate the element.

For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.

Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.

Inactive: No signature is required.

(Default) Inactive:

More in the online help.

VT_BSTR

SignatureText

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties.

More in the online help.

VT_I2

SignatureEditModus

Signature text editable

Defines whether the signature text can be edited. Selection from drop-down list:

  • Apply project settings: The settings of the Signature text editable project property are applicable.
  • Yes: Text can be edited.
  • No: Text cannot be edited.

Default: Apply project settings

More in the online help.

VT_UI2

Passwordlevel

Authorization level

Password level for writing set values or executing functions with the selected dynamic element.
Minimum: 0.
Maximum: 127.
Default: 0.

More in the online help.

VT_UI4

Locking

Interlocking

Link to an existing interlocking to this element.

If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.

Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_BOOL

UseDynContent

Entries from string variable

Active: Entries in combo-/listbox are defined via the selected string variable in property Variable.

Inactive: Entries are defined via the dialog of property Entries in the Editor.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

DynContentVariable

Variable

Only available if property Entries from string variable is active.

Selection of the string variable which contain the entries for the combo-/listbox. A click on the ... button opens the dialog for variable selection.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Basisklasse dynamische Bildelemente

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Basisklasse dynamische Bildelemente

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_BOOL

Signature

Signature necessary

Active: A signature is necessary to operate the element.

For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.

Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.

Inactive: No signature is required.

(Default) Inactive:

More in the online help.

VT_BSTR

SignatureText

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties.

More in the online help.

VT_I2

SignatureEditModus

Signature text editable

Defines whether the signature text can be edited. Selection from drop-down list:

  • Apply project settings: The settings of the Signature text editable project property are applicable.
  • Yes: Text can be edited.
  • No: Text cannot be edited.

Default: Apply project settings

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Link text

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Link text

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

DynEleVar

DynEleVar

"With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX
zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_UI2

Frame

Element border

Drop-down list for the selection of the frame type. Available are:

Thin frame

3D

Default: Thin border

More in the online help.

VT_BOOL

ShowState

Display status of variable

Active: The status of the variables is indicated by a colored square at the element.

Color:
red square indicates that there a problems with the communication to the PLC.
Blue square at the client end indicates that the client lost the connection to the server.
Blue square at the station indicates that the value was not initialized.

Position of the square at the element at element form:

Round: top edge, in the middle
rounded: top right corner, slightly offset to the leftangular and all others:

Inactive: The status is not displayed.

More in the online help.

VT_BSTR

DynText

Text

Only available if a numeric value has been linked and limit value text has been selected for the Display text property.

Input of the text that is displayed in Runtime if there is no limit value breach. If a limit value is breached, the limit value text configured for the variable is displayed.

More in the online help.

VT_UI2

TextSource

Display text

Selection of the content to be displayed in Runtime from a drop-down list:

  • Resources label: The content of the Resources label variable property is displayed.
  • Limit text: As long as no limit value has been breached, the content of the Text screen property is displayed. If a limit value is breached, the content of the Limit text variable property is displayed.
  • Measuring unit: The content of the Measuring unit variable property is displayed.
  • Variable identification: The content of the Identification variable property is displayed.
  • Variable name : The content of the Name variable property is displayed.
  • Variable value: The value of the variable is displayed.

Default: Limit text

More in the online help.

VT_BOOL

TranslateText

Translate displayed text

Active: The text which should be displayed are translated. If a text is edited, the draft is displayed with translation.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

Variable

Variable

Name of the linked variable. Click on button ... in order to open the dialog for selecting variables.
The value of this variable is displayed in this element and can also be set here.

Note: Only available for buttons if they are used as a switch.

Hint: If the variable value is to be toggled, we recommend activating the Permanently read variable property. Otherwise Runtime waits until the driver knows the value of the variables. If the value is not available due to a breakdown in communication with the control unit, the waiting time corresponds to the timeout time of the driver.

Only SICAM 230 and Screen Alarm element:
The description above only applies to the elements Text Button, Bitmap Button and Invisible Button.
Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).

  • Lower bit: Alarm active/inactive
  • Higher bit: Alarm acknowledged/not acknowledged

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BOOL

Transparent

Transparent

Active: Deactivates the background color of the element.

The effect of this option on a button is an Invisible button. It can be positioned above other elements as an invisible button.

More in the online help.

VT_BOOL

LimitColor

Use limit color

You can define whether the limit color which has been defined at the variable which is linked with the element should be displayed in the Runtime. Depending on the element the color affects the displayed text or for the universal slider its indicator.

Active: The defined limit color is displayed in the Runtime.

Default: active (in order to ensure compatibility)

More in the online help.

VT_BOOL

IsSetValue

Setting values active

Active: Setting of variables for this dynamic element is allowed.
Inactive: The variable is write-protected in this element.

More in the online help.

VT_BOOL

Preset

propose current value

Active: The current value of the variable is proposed as set value.
In this case, the value is added under "Set value / amend by" before setting the actual value (positive value) or subtracted from this (negative value).
Inactive: The value defined in "Set value / amend" is proposed.

More in the online help.

VT_BOOL

HWDirect

without dialog

Active: The value is sent to the hardware without a possibility to be changed in the Runtime.
Inactive: The user still has the possibility to amend the value in Runtime before writing to the hardware.

More in the online help.

VT_BSTR

SetValueText

Set value text

Set value text

VT_R8

SetValue

Set value / change by

Value that should be sent as the set value or as a default.
If "Propose current value" is active:: Value that is added to the current value.
In combination with the "without dialog" property, such an increment (positive value) or decrement (negative value) can be implemented.

More in the online help.

VT_UI1

SetValueWith

Write set value via

Send value with:
Command Processing: The new value is set using Set value input in the Command Processing.

Standard dialog box: The new value is entered using the standard dialog box. If a screen of type "Keyboard" with name "SETVALUEKBD" (for numeric values) or "SETSTRINGKBD" (for string variables) exists, it is used instead of the standard dialog box.

Element: The new value is directly entered in the element (only for the elements numeric value and text element).

Program: The new value is entered in an external program.

More in the online help.

VT_BSTR

SetProgram

External program

Only available if an external program was selected for Write set value:
The set value is written by an external program that must be selected in the dialog box that appears here.

This program is then started and gets the following parameters:
1) Name of the linked variable
2) Proposed value, as defined in the corresponding properties
3) Left coordinate of the element in pixels
4) Upper coordinate of the element in pixels
5) Right coordinate of the element in pixels
6) Lower coordinate of the element in pixels
7) Permitted minimum for the set value, as defined in the corresponding properties
8) Permitted maximum for the set value, as defined in the corresponding properties

More in the online help.

VT_BOOL

KbdUsage

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

ZT_PICTURE

KbdName

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

VT_BOOL

LimitFromVar

Take set value limits from variable

Active: The limitation of the range for which the set values can be written are not set via “Min” and “Max” but are taken from the variable definitions directly.
Inactive: The range can be limited directly in the "Minimum" and "Maximum".

More in the online help.

VT_R8

Min

Minimum

Only available if "Take set value limits from variable" is not active::
Bottom limit of the permitted range for the set value.

Attention: The value entered here is ignored if a variable is selected for the dynamic set value minimum.

More in the online help.

VT_R8

Max

Maximum

Only available if "Take set value limits from variable" is not active::
Upper limit of the permitted range for the set value.

Attention: The value entered here is ignored if a variable is selected for the dynamic set value maximum.

More in the online help.

VT_UI2

Passwordlevel

Authorization level

Password level for writing set values or executing functions with the selected dynamic element.
Minimum: 0.
Maximum: 127.
Default: 0.

More in the online help.

VT_UI4

Locking

Interlocking

Link to an existing interlocking to this element.

If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.

Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_I2

HorizontalAlign

Alignment horizontal

Horizontal alignment of the output in the element for the display. Possible settings via the drop-down list:

centered
- left-adjusted
- right-adjusted

Default: centered

More in the online help.

VT_I2

VerticalAlign

Alignment vertical

Vertical alignment of the output in the element for the display. Possible settings via the drop-down list:

centered
- top
- bottom

Default: Centered

More in the online help.

VT_BOOL

Wordbreak

Automatic word wrap

Active: Automatic word wrap is used for the text in the element.
The length of the lines depends on the width of the element.
Inactive: The text is displayed in one line.
Default: inactive.

More in the online help.

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_BOOL

Signature

Signature necessary

Active: A signature is necessary to operate the element.

For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.

Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.

Inactive: No signature is required.

(Default) Inactive:

More in the online help.

VT_BSTR

SignatureText

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties.

More in the online help.

VT_I2

SignatureEditModus

Signature text editable

Defines whether the signature text can be edited. Selection from drop-down list:

  • Apply project settings: The settings of the Signature text editable project property are applicable.
  • Yes: Text can be edited.
  • No: Text cannot be edited.

Default: Apply project settings

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Universal slider

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Universal slider

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

DynEleVar

DynEleVar

"With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX
zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_UI2

Frame

Element border

Drop-down list for the selection of the frame type. Available are:

Thin frame

3D

Default: Thin border

More in the online help.

VT_BOOL

ShowUnit

Display measuring unit

Only available:
General: If property Show value has been activated.
For the Clock element: if Time difference was selected in the property Type of display.
For the pointer instrument: if 3D property was activated.

Active: The unit of the linked variable is displayed to the right of the value.
If the value is displayed in percent, the percent character % is displayed instaed of the unit of the linked variable.
Inactive: The technical unit is not displayed.
Default: active.

Note:

More in the online help.

VT_BOOL

ShowState

Display status of variable

Active: The status of the variables is indicated by a colored square at the element.

Color:
red square indicates that there a problems with the communication to the PLC.
Blue square at the client end indicates that the client lost the connection to the server.
Blue square at the station indicates that the value was not initialized.

Position of the square at the element at element form:

Round: top edge, in the middle
rounded: top right corner, slightly offset to the leftangular and all others:

Inactive: The status is not displayed.

More in the online help.

VT_BOOL

Percentage

Display value in percent

Active: The value of the variable is displayed as 0-100%.
0% = minimum measurement range
100% = maximum measurement range
The conversion is linear. Setpoint inputs are also entered in percent.
Inactive: The value is displayed as usual.
Default: inactive.

More in the online help.

VT_BOOL

Absolute

Absolute amount

For element Numeric value only available if property Display value in percent is inactive.

Active: Unsigned display of the variable value (-200 = 200).
Inactive: Normal display of the value.
Default: inactive.

Note: In this case, the set value is entered in percent.

More in the online help

VT_BOOL

MouseMovement

Set value during mouse-move

Active: Continuous sending of new values whilst the mouse is moved.
Inactive: One-off sending of the new value if the mouse button is released.
(only if the “direct to hardware” option is activated on the in the “Set value” section)

More in the online help.

VT_BOOL

Discrete

Discrete

Setting of values only in defined steps.

More in the online help.

VT_I2

DiscreteSteps

Discrete steps

Number of steps for property Discrete steps.

Minimum: 2

Maximum: 20

Default: 5

More in the online help.

ZT_VARIABLE_DYN

Variable

Variable

Name of the linked variable. Click on button ... in order to open the dialog for selecting variables.
The value of this variable is displayed in this element and can also be set here.

Note: Only available for buttons if they are used as a switch.

Hint: If the variable value is to be toggled, we recommend activating the Permanently read variable property. Otherwise Runtime waits until the driver knows the value of the variables. If the value is not available due to a breakdown in communication with the control unit, the waiting time corresponds to the timeout time of the driver.

Only SICAM 230 and Screen Alarm element:
The description above only applies to the elements Text Button, Bitmap Button and Invisible Button.
Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).

  • Lower bit: Alarm active/inactive
  • Higher bit: Alarm acknowledged/not acknowledged

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BOOL

Transparent

Transparent

Active: Deactivates the background color of the element.

The effect of this option on a button is an Invisible button. It can be positioned above other elements as an invisible button.

More in the online help.

VT_BOOL

LimitColor

Use limit color

You can define whether the limit color which has been defined at the variable which is linked with the element should be displayed in the Runtime. Depending on the element the color affects the displayed text or for the universal slider its indicator.

Active: The defined limit color is displayed in the Runtime.

Default: active (in order to ensure compatibility)

More in the online help.

VT_BOOL

IsSetValue

Setting values active

Active: Setting of variables for this dynamic element is allowed.
Inactive: The variable is write-protected in this element.

More in the online help.

VT_BOOL

Preset

propose current value

Active: The current value of the variable is proposed as set value.
In this case, the value is added under "Set value / amend by" before setting the actual value (positive value) or subtracted from this (negative value).
Inactive: The value defined in "Set value / amend" is proposed.

More in the online help.

VT_BOOL

HWDirect

without dialog

Active: The value is sent to the hardware without a possibility to be changed in the Runtime.
Inactive: The user still has the possibility to amend the value in Runtime before writing to the hardware.

More in the online help.

VT_R8

SetValue

Set value / change by

Value that should be sent as the set value or as a default.
If "Propose current value" is active:: Value that is added to the current value.
In combination with the "without dialog" property, such an increment (positive value) or decrement (negative value) can be implemented.

More in the online help.

VT_UI1

SetValueWith

Write set value via

Send value with:
Command Processing: The new value is set using Set value input in the Command Processing.

Standard dialog box: The new value is entered using the standard dialog box. If a screen of type "Keyboard" with name "SETVALUEKBD" (for numeric values) or "SETSTRINGKBD" (for string variables) exists, it is used instead of the standard dialog box.

Element: The new value is directly entered in the element (only for the elements numeric value and text element).

Program: The new value is entered in an external program.

More in the online help.

VT_BSTR

SetProgram

External program

Only available if an external program was selected for Write set value:
The set value is written by an external program that must be selected in the dialog box that appears here.

This program is then started and gets the following parameters:
1) Name of the linked variable
2) Proposed value, as defined in the corresponding properties
3) Left coordinate of the element in pixels
4) Upper coordinate of the element in pixels
5) Right coordinate of the element in pixels
6) Lower coordinate of the element in pixels
7) Permitted minimum for the set value, as defined in the corresponding properties
8) Permitted maximum for the set value, as defined in the corresponding properties

More in the online help.

VT_BOOL

KbdUsage

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

ZT_PICTURE

KbdName

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

VT_BOOL

LimitFromVar

Take set value limits from variable

Active: The limitation of the range for which the set values can be written are not set via “Min” and “Max” but are taken from the variable definitions directly.
Inactive: The range can be limited directly in the "Minimum" and "Maximum".

More in the online help.

VT_R8

Min

Minimum

Only available if "Take set value limits from variable" is not active::
Bottom limit of the permitted range for the set value.

Attention: The value entered here is ignored if a variable is selected for the dynamic set value minimum.

More in the online help.

VT_R8

Max

Maximum

Only available if "Take set value limits from variable" is not active::
Upper limit of the permitted range for the set value.

Attention: The value entered here is ignored if a variable is selected for the dynamic set value maximum.

More in the online help.

VT_UI2

Passwordlevel

Authorization level

Password level for writing set values or executing functions with the selected dynamic element.
Minimum: 0.
Maximum: 127.
Default: 0.

More in the online help.

VT_UI4

Locking

Interlocking

Link to an existing interlocking to this element.

If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.

Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_BOOL

ShowValue

Show value

Additional display of the current value as number; Position in the element and font color can be defined

More in the online help.

ZT_COLOR

ValueColor

Value color

Color for the value to be displayed.

More in the online help.

VT_I2

ValuePos

Value position

Position for the value to be displayed.

More in the online help.

VT_UI2

ValueBase

Base for display

Set the base of the numbering for the display of the values. The following bases are available:

  • Binary: Binary display. This format is indicated with a "b" to the right of the value.
  • Decimal: Decimal display.
  • Exponential: Decimal display in exponential notation. Example: 1E+03 equals 1000 in decimal notation.
  • Hexadecimal: Hexadecimal display. This format is indicated with a "b" to the right of the value.
  • Octal: Octal display. This format is indicated with an "o" to the right of the value.

Default: Decimal.

More in the online help.

VT_BOOL

ShowValueBasis

Display base

Only available if you selected binary, hexadecimal or octal at property Base for display.

Shows an abbreviation of the base behind the value:

The following abbreviations are used:

- for binary: b

- for decimal: no abbreviation

- for decimal exponential: no abbreviation

- for hexadecimal: h

- for octal: o

Default: Active

More in the online help.

VT_BOOL

ShowLeadingZeros

Show leading zeros

Only available if you selected binary, decimal, hexadecimal or octal at property Base for display.

Decide whether you want to display leading zeros when displaying the numeric values.

  • Inactive: Leading zeros are suppressed.
  • Active: The numeric values are displayed with a different number of digits in accordance with their base. The digits which are not used by the numeric value are filled up with leading zeros.

Default: inactive

The following parameters are available for the different bases:

  • Binary: 32 digits
  • Decimal: 10 digits
  • Hexadecimal: 8 digits
  • Octal: 11 digits

More in the online help.

VT_BOOL

ViewLimitFromVar

Apply display range from variables

Takes over the display area of the linked variable. You can update this display area during replacement with a variable with a different values range.

More in the online help.

VT_R8

ViewMin

Minimum

Lowest variable value that is to be displayed in the element.

More in the online help.

VT_R8

ViewMax

Maximum

Highest variable value that is to be displayed in the element.

More in the online help.

ZT_VARIABLE_DYN

DynMinVar

Minimum

Variable that defines the minimum of the display range in Runtime.

More in the online help.

ZT_VARIABLE_DYN

DynMaxVar

Maximum

Variable that defines the maximum of the display range in Runtime.

More in the online help.

VT_I2

Shape

Shape

Linear: Display as bar or slider.
Round: Display as pointer instrument

More in the online help.

VT_I2

Align

Alignment

Only available for linear form:
Horizontal: Horizontal display of the bar or slider.
Vertical: Vertical display of the bar or slider.

More in the online help.

ZT_COLOR

PointerColor

Pointer/Bar color

Color for the pointer or bar.

More in the online help.

VT_I2

Style

Style

The following styles are available:
- Slider/Turn around
– Bar
– LED bar
– Moving scale

More in the online help.

VT_I2

Pointer

Pointer type

Graphical marking of the current value with
– Line
– Indicating instrument
– Triangle

More in the online help.

VT_BOOL

Explicit

Bar explicit

Only available if for property Style Bar, Moving scale or LED bar has been selected.

This property affects only the display of values with defined limits from variables. Limits from reaction matrices are not considered.

  • Active: If a limit value of the linked variable is breached, only the part of the display that goes into the limit value breach is shown in the color of the respective limit value.
    If the variable has several defined limit values, the corresponding areas of the display are each shown in the color of the limit value.
  • Inactive: If a limit of the linked variable is violated, the complete display is displayed in the color of the violated limit.

Default: inactive

More in the online help.

VT_BOOL

ReverseDirection

Reverse direction

Reverse display of minimum and maximum value

More in the online help.

VT_R8

Start

Start angle

Only available for round form:
Position of the pointer instrument for the minimum value (0° at the bottom).

More in the online help.

VT_R8

End

End angle

Only available for round form:
Position of the pointer instrument for the maximum value (0° at the bottom).

More in the online help.

VT_BOOL

MinMaxView

Display drag indicator

Activate minimum/maximum display.

More in the online help.

VT_I2

MinMaxShape

Type of display

Graphical marking (Schleppzeiger) for minimum and maximum value with:
– Line
– Indicating instrument
– Triangle

More in the online help.

ZT_COLOR

MinColor

Color minimum value

Color for displayed minimum.

More in the online help.

ZT_COLOR

MaxColor

Color maximum value

Color for displayed maximum.

More in the online help.

VT_BOOL

AutoReset

Reset automatically

Automatically reset drag indicator for minimum/maximum display after set time.

More in the online help.

VT_I2

AutoResetTime

Reset after [min]

Time for automatic resetting of the min./max. Advertisement.

More in the online help.

VT_BOOL

ShowScale

Display scale

Active: A scale is shown in the element
inactive: No scale is displayed.

More in the online help.

VT_BOOL

Logarithmic

Logarithmic

Active: Logarithmic scaling
Inactive: Linear scaling.

More in the online help.

VT_I2

ScaleDistance

Distance [pixels]

Distance between scale and element (in pixels).

More in the online help.

VT_I2

ScaleHeight

Height [pixels]

Height of the scale (in pixels).

More in the online help.

VT_I2

MainTicks

Main ticks

Range for the main ticks (number display) of the scaling.

Example: If you enter 50, a main tick is displayed every 50 units: 0 - 50 - 100 - 150 ...

More in the online help.

VT_I2

SmallTicks

Sub ticks

Range for the subsidiary ticks (no number display) of the scaling.
Example: The input 100 leads to the display of a subsidiary tick for each thousandth, starting with the smallest displayed value.

More in the online help.

ZT_COLOR

MainTickColor

Main tick color

Color of the main ticks (number display) of the scaling.

More in the online help.

ZT_COLOR

SmallTickColor

Sub tick color

Color of the main ticks (no numerical display) in the scale.

More in the online help.

VT_BOOL

ShowKnob

Show knob

An operating element is displayed with a button instead of the current value.

More in the online help.

ZT_COLOR

KnobColor

Knob color

Color of the knop.

More in the online help.

VT_I2

KnobStyle

Knob type

Select button shape from list. (flat, high, sunk)

More in the online help.

VT_BOOL

ShowLegend

Display legend

If activated, text (values) are displayed on the scale.

More in the online help.

VT_I2

LegendDistance

Distance [pixels]

Distance between key and the scale (in pixels).

More in the online help.

ZT_COLOR

LegendColor

Legend color

Color of the key.

More in the online help.

VT_I2

LeftFrame

Left [pixels]

Distance between the left edge of the element and the graphic display (in pixels).

More in the online help.

VT_I2

TopFrame

Top [pixels]

Distance between the upper edge of the element and the and the graphic display (in pixels).

More in the online help.

VT_I2

RightFrame

Right [pixels]

Distance between the right edge of the element and the graphic display (in pixels).

More in the online help.

VT_I2

BottomFrame

Bottom [pixels]

Distance between the lower edge of the element and the and the graphic display (in pixels).

More in the online help.

VT_BOOL

ShowTitle

Display title

Display title.

More in the online help.

VT_I2

ValueDistance

Distance [pixels]

Distance between title and value display (in pixels).

More in the online help.

VT_I2

TitlePos

Title position

Position for the title.

More in the online help.

ZT_COLOR

TitleColor

Title color

Text color for the title.

More in the online help.

VT_BSTR

TitleText

Title text

Text that is to be displayed as the title.

More in the online help.

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_BOOL

Signature

Signature necessary

Active: A signature is necessary to operate the element.

For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.

Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.

Inactive: No signature is required.

(Default) Inactive:

More in the online help.

VT_BSTR

SignatureText

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties.

More in the online help.

VT_I2

SignatureEditModus

Signature text editable

Defines whether the signature text can be edited. Selection from drop-down list:

  • Apply project settings: The settings of the Signature text editable project property are applicable.
  • Yes: Text can be edited.
  • No: Text cannot be edited.

Default: Apply project settings

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Line

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Line

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

ZT_COLOR

LineColor

Line color

Line color of the element.

VT_UI2

LineWidth

Line width [Pixel]

Width of the line (in pixels).
Minimum: 0
In this case the width of the line is 1 pixel.
Maximum: 40
Default: 1
Attention: If in the project settings in node Graphical design you set property Graphics quality to Windows basis, you can use line width >1 only with a line of type "continuous line".

More in the online help.

ZT_IMAGELIST

LineType

Line type

Selection of the line type for the element from the list.
Attention: If in the project settings in node Graphical design you deactivated property Graphics quality, you can use line width >1 only with a line of type "continuous line".
More in the online help.

ZT_IMAGELIST

LineCapStart

Start type

Only available if you have activated project property Graphics quality.

Defines the symbol for the starting point of the line. Click on the field and a dialog opens to select an element.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

More in the online help.

ZT_IMAGELIST

LineCapEnd

End type

Only available if you have activated project property Graphics quality.

Defines the symbol for the end point of the line. Click on the field and a dialog opens to select an element.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

More in the online help.

VT_R4

LineCapScale

Size

Only available if you have activated project property Graphics quality.

Defines the magnifying factor for the line width of the arrow. The factor relates to the line width of the vector element as defined in the Line width [Pixel] property.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

Value: greater or equal 1

Default: 4

More in the online help.

ZT_COLOR

LineColorEx

Line color

Defines the line color of the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

AlphaLineColor

Transparency line color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable2

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BackColorVariable2Preview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

ALCUseColor

Color from ALC

Only available if you have licensed Automatic Line Coloring (ALC):
Active: The automatic color of the linked source(s) is used.
Inactive: The standard color is used.
Default: inactive.

More in the online help.

VT_I2

ALCPrecedence

Priority for display

Only available if the Color from ALC property is active.

Defines the priority of the display when the element is connected to several active sources.
Multiple supply: The element is displayed according to the rules of the multiple supply.
secured supply: The element is displayed according to the rules of the secured supply.
No priority: The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.

Default: Multiple supply
More in the online help.

VT_I2

ALCMultiSource

display multiple supplies

Only available if the property Color from ALC is active.
Defines the display type if the element is connected to several sources:
most prior source: Only the color of the source with the highest priority is used.
two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line.
alternative color: Alternative color for the coloring at multiple supply.

Default: highest priority source

More in the online help

VT_I2

ALCDashLen

Dashing length supplied multiple times

Only available if property display multiple supplies has value two highest prior sources.

Defines the dash length in pixel for the dashed ALC coloring at multiply supply.

Minimal: 0 (automatic dash length)

Maximum: 32767

Default: 0

More in the online help.

ZT_COLOR

ALCAlternativeColor

Alternative color

Only available if property display multiple supplies has value alternative color.

Alternative color for the ALC coloring at multiple supply.

More in the online help.

VT_I2

ALCMSecuredSupply

display secured supply

Only available if Color from ALC was activated.

Definition of the display of the secured supply:

  • double width
  • double brightness
  • normal

Default: normal

More in the online help

VT_BOOL

ALCAlias

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

ALCAliasName

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_R8

ALCReact

Reactance value of the cable [Ohm]

Maximum permitted reactance value of the line in ohms.

More in the online help.

VT_R8

ALCResist

Resistance value of the electric line [Ohm]

Maximum permitted resistance value of the line in ohms.

More in the online help.

VT_R8

ALCLength

Length of the line [km]

ALC line: Length of the line.

More in the online help.

VT_I2

ALCMaxIType

Limit current carrying capacity

ALC switch: Limit value of current capacity [selection of fixed/variable].

More in the online help.

VT_R8

ALCMaxIVal

Limit fixed current carrying capacity [A]

ALC switch: Limit fixed current carrying capacity.

More in the online help.

ZT_VARIABLE_DYN

ALCVarMaxI

Limit variable current carrying capacity

More...

ALCVarMaxIEx

ALCVarMaxIEx

ZT_VARIABLE_DYN

ALCVarCalcI

Measuring value of the calculated current flow

ALC line: Measuring value of the calculated current flow.

More in the online help.

More...

ALCVarCalcIEx

ALCVarCalcIEx

ALC Leitung: Messwert des berechneten Stromflusses für Export.

Mehr in der Online-Hilfe.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Message

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Message

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_BOOL

ThreeDimensional

3D

Active: The element is displayed threedimensionally.
Inactive: The element is displayed flat.

More in the online help.

VT_UI4

TextChangeTime

Time for text change [s]

With several set bits of the line variables the changeover of the text occurs automatically within the configured time

More in the online help.

ZT_MELDETEXT

MessageText

Text file

Selection of the text file.

More in the online help.

VT_BSTR

Variable

Column selection

The column variable must be a word variable and defines the column position from which the text is taken.

ATTENTION: The column variable must be selected before the line variable.

More in the online help.

VT_BSTR

ColVars

Line activation

The line variables define the line position from which the text is taken.

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BOOL

Transparent

Transparent

Active: Deactivates the background color of the element.

The effect of this option on a button is an Invisible button. It can be positioned above other elements as an invisible button.

More in the online help.

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


EMF WMF

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> EMF WMF

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

ZT_COLOR

LineColor

Line color

Line color of the element.

VT_UI2

LineWidth

Line width [Pixel]

Width of the line (in pixels).
Minimum: 0
In this case the width of the line is 1 pixel.
Maximum: 40
Default: 1
Attention: If in the project settings in node Graphical design you set property Graphics quality to Windows basis, you can use line width >1 only with a line of type "continuous line".

More in the online help.

ZT_IMAGELIST

LineType

Line type

Selection of the line type for the element from the list.
Attention: If in the project settings in node Graphical design you deactivated property Graphics quality, you can use line width >1 only with a line of type "continuous line".
More in the online help.

ZT_IMAGELIST

LineCapStart

Start type

Only available if you have activated project property Graphics quality.

Defines the symbol for the starting point of the line. Click on the field and a dialog opens to select an element.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

More in the online help.

ZT_IMAGELIST

LineCapEnd

End type

Only available if you have activated project property Graphics quality.

Defines the symbol for the end point of the line. Click on the field and a dialog opens to select an element.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

More in the online help.

VT_R4

LineCapScale

Size

Only available if you have activated project property Graphics quality.

Defines the magnifying factor for the line width of the arrow. The factor relates to the line width of the vector element as defined in the Line width [Pixel] property.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

Value: greater or equal 1

Default: 4

More in the online help.

ZT_IMAGELIST

FillPattern

Filling pattern

Selection of the filling pattern for the element from the list.

This property is only available if property With brightness values is inactive.

More in the online help.

ZT_COLOR

LineColorEx

Line color

Defines the line color of the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

AlphaLineColor

Transparency line color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_UI1

AlphaBackColor

Transparency of the fill color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor2

Gradient color

Only available if for property Filling pattern Color gradient is selected and the project property Graphics quality is active.

Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of Fill color.

More in the online help.

VT_UI1

AlphaBackColor2

Transparency gradient color [%]

Only available if Linear was selected in the Filling pattern property.

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable2

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BackColorVariable2Preview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_I2

Lightning

Color gradient

Only available if property Filling pattern was set to Color gradient.

Defines the color gradient for vector elements.

Linear: steady gradient
Defined point: Gradient from a defined point to the edges of the element

Starting from a defined point with beams: Gradient from a defined point to the edges of the element with beams

More in the online help.

VT_I2

Align

Alignment

Direction of color shift.
horizontal
vertical

VT_I2

Shifted

Shifted color gradient

Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein.

Mehr im Online-Handbuch

VT_I2

ColorGradientOffset

Offset [%]

Only available if at a vector element the property Color gradient or at the dynamic element Button property Filling was set. linear or Starting from a defined point or Starting from a defined point with beams.

Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.

Values: 0 equals the center of the element. 100 the edge.
Note: The value can also be outside of the element and is therefore not limited to 100.

More in the online help.

VT_I2

ColorGradientAngle

Angle [°]

Defines the direction of the color gradient starting in the center of the element.

Values: 0° to 360°.

Default: 0°

More in the online help.

VT_BOOL

Brightness

With brightness values

Only available if Filling pattern was selected as color gradient was selected.

Active: The brightness of the color gradient can be freely defined.
Inactive: The brightness of the color gradient is defined automatically.

Note: The filling pattern can no longer be changed if this property is active. It is also not possible to set rounded corners. If this option is activated for an element that uses rounded corners, the element is displayed with non-rounded corners.

More in the online help.

VT_UI1

OuterBrightness

Brightness outside

Only available if "via brightness value" is active:
Brightness at the outer side of the element.

More in the online help.

VT_UI1

InnerBrightness

Brightness inside

Only available if "via brightness value" is active:
Brightness in the middle of the element.

More in the online help.

VT_BOOL

ALCUseColor

Color from ALC

Only available if you have licensed Automatic Line Coloring (ALC):
Active: The automatic color of the linked source(s) is used.
Inactive: The standard color is used.
Default: inactive.

More in the online help.

VT_I2

ALCPrecedence

Priority for display

Only available if the Color from ALC property is active.

Defines the priority of the display when the element is connected to several active sources.
Multiple supply: The element is displayed according to the rules of the multiple supply.
secured supply: The element is displayed according to the rules of the secured supply.
No priority: The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.

Default: Multiple supply
More in the online help.

VT_I2

ALCMultiSource

display multiple supplies

Only available if the property Color from ALC is active.
Defines the display type if the element is connected to several sources:
most prior source: Only the color of the source with the highest priority is used.
two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line.
alternative color: Alternative color for the coloring at multiple supply.

Default: highest priority source

More in the online help

VT_I2

ALCDashLen

Dashing length supplied multiple times

Only available if property display multiple supplies has value two highest prior sources.

Defines the dash length in pixel for the dashed ALC coloring at multiply supply.

Minimal: 0 (automatic dash length)

Maximum: 32767

Default: 0

More in the online help.

ZT_COLOR

ALCAlternativeColor

Alternative color

Only available if property display multiple supplies has value alternative color.

Alternative color for the ALC coloring at multiple supply.

More in the online help.

VT_I2

ALCMSecuredSupply

display secured supply

Only available if Color from ALC was activated.

Definition of the display of the secured supply:

  • double width
  • double brightness
  • normal

Default: normal

More in the online help

VT_BOOL

ALCAlias

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

ALCAliasName

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_R8

ALCReact

Reactance value of the cable [Ohm]

Maximum permitted reactance value of the line in ohms.

More in the online help.

VT_R8

ALCResist

Resistance value of the electric line [Ohm]

Maximum permitted resistance value of the line in ohms.

More in the online help.

VT_R8

ALCLength

Length of the line [km]

ALC line: Length of the line.

More in the online help.

VT_I2

ALCMaxIType

Limit current carrying capacity

ALC switch: Limit value of current capacity [selection of fixed/variable].

More in the online help.

VT_R8

ALCMaxIVal

Limit fixed current carrying capacity [A]

ALC switch: Limit fixed current carrying capacity.

More in the online help.

ZT_VARIABLE_DYN

ALCVarMaxI

Limit variable current carrying capacity

More...

ALCVarMaxIEx

ALCVarMaxIEx

ZT_VARIABLE_DYN

ALCVarCalcI

Measuring value of the calculated current flow

ALC line: Measuring value of the calculated current flow.

More in the online help.

More...

ALCVarCalcIEx

ALCVarCalcIEx

ALC Leitung: Messwert des berechneten Stromflusses für Export.

Mehr in der Online-Hilfe.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Multibin

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Multibin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

States

States

With this property you have the opportunity to get/set some properties of the different statis. The settings can be handled via some subitems.

VT_UI1

LinkType

LinkType

VT_BOOL

OriginalSize

OriginalSize

VT_BOOL

RegardAllVarBlinking

RegardAllVarBlinking

VT_BOOL

IsText

IsText

VT_BOOL

IsBackColor

IsBackColor

ZT_COLOR

BlinkBackColor

BlinkBackColor

VT_BOOL

FillOnly

FillOnly

VT_UI2

SwitchFunction

SwitchFunction

"With this property you get/set the different switch modes when a bool variable is linked at the element.
zElement.DynProperties(""SwitchFunction"") = 0 'Set to ""Read only""
zElement.DynProperties(""SwitchFunction"") = 1 'Set to ""TOOGLE""
zElement.DynProperties(""SwitchFunction"") = 2 'Set to ""Momentary switch On""
zElement.DynProperties(""SwitchFunction"") = 3 'Set to ""Momentary switch Off"""

VT_BOOL

ShowState

Display status of variable

Active: The status of the variables is indicated by a colored square at the element.

Color:
red square indicates that there a problems with the communication to the PLC.
Blue square at the client end indicates that the client lost the connection to the server.
Blue square at the station indicates that the value was not initialized.

Position of the square at the element at element form:

Round: top edge, in the middle
rounded: top right corner, slightly offset to the leftangular and all others:

Inactive: The status is not displayed.

More in the online help.

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

ZT_MULTI

Status

Configuration

Opens the dialog to define the states.

More in the online help.

VT_UI2

Passwordlevel

Authorization level

Password level for writing set values or executing functions with the selected dynamic element.
Minimum: 0.
Maximum: 127.
Default: 0.

More in the online help.

VT_UI4

Locking

Interlocking

Link to an existing interlocking to this element.

If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.

Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI2

ReactionTime

Holding time [ms]

Only available if Switch is active.
If Momentary switch is active: Time (in ms) which a state is held starting from the left click on the respective element.

If property Momentary switch is inactive: Delayed reaction to a left click.

More in the online help.

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_BOOL

Signature

Signature necessary

Active: A signature is necessary to operate the element.

For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.

Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.

Inactive: No signature is required.

(Default) Inactive:

More in the online help.

VT_BSTR

SignatureText

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties.

More in the online help.

VT_I2

SignatureEditModus

Signature text editable

Defines whether the signature text can be edited. Selection from drop-down list:

  • Apply project settings: The settings of the Signature text editable project property are applicable.
  • Yes: Text can be edited.
  • No: Text cannot be edited.

Default: Apply project settings

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Base class picture elements

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Base class picture elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Tube

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Tube

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BSTR

Coordinates

Coordinates

"With this property you can get/set the coordinates of the element via a string.
zElement.DynProperties(""Coordinates"") = ""197/118;260/200"""

VT_R4

SplineTension

Rounding

Only available if you have activated option Graphics quality in the project properties in node Graphical design/Screens.

Defines the rounding for the polylines, polygons and the pipes.

Values: 0,0 (no rounding) to 1,0. (maximum rounding)

Default: 0

More in the online help.

ZT_COLOR

LineColor

Line color

Line color of the element.

VT_UI2

Offset_H

Horiz. distance [pixels]

Horizontal distance of the end of the rounding of the actual corner in pixels.

More in the online help.

VT_UI2

Offset_V

Vertical distance [pixels]

Vertical distance of the end of the rounding of the actual corner in pixels.

More in the online help.

VT_UI2

LineWidth

Line width [Pixel]

Width of the line (in pixels).
Minimum: 0
In this case the width of the line is 1 pixel.
Maximum: 40
Default: 1
Attention: If in the project settings in node Graphical design you set property Graphics quality to Windows basis, you can use line width >1 only with a line of type "continuous line".

More in the online help.

ZT_IMAGELIST

LineType

Line type

Selection of the line type for the element from the list.
Attention: If in the project settings in node Graphical design you deactivated property Graphics quality, you can use line width >1 only with a line of type "continuous line".
More in the online help.

ZT_IMAGELIST

LineCapStart

Start type

Only available if you have activated project property Graphics quality.

Defines the symbol for the starting point of the line. Click on the field and a dialog opens to select an element.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

More in the online help.

ZT_IMAGELIST

LineCapEnd

End type

Only available if you have activated project property Graphics quality.

Defines the symbol for the end point of the line. Click on the field and a dialog opens to select an element.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

More in the online help.

VT_R4

LineCapScale

Size

Only available if you have activated project property Graphics quality.

Defines the magnifying factor for the line width of the arrow. The factor relates to the line width of the vector element as defined in the Line width [Pixel] property.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

Value: greater or equal 1

Default: 4

More in the online help.

ZT_IMAGELIST

FillPattern

Filling pattern

Selection of the filling pattern for the element from the list.

This property is only available if property With brightness values is inactive.

More in the online help.

ZT_COLOR

LineColorEx

Line color

Defines the line color of the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

ZT_COLOR

BackColor2

Gradient color

Only available if for property Filling pattern Color gradient is selected and the project property Graphics quality is active.

Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of Fill color.

More in the online help.

VT_UI1

AlphaBackColor2

Transparency gradient color [%]

Only available if Linear was selected in the Filling pattern property.

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

VT_I2

Lightning

Color gradient

Only available if property Filling pattern was set to Color gradient.

Defines the color gradient for vector elements.

Linear: steady gradient
Defined point: Gradient from a defined point to the edges of the element

Starting from a defined point with beams: Gradient from a defined point to the edges of the element with beams

More in the online help.

VT_I2

Align

Alignment

Direction of color shift.
horizontal
vertical

VT_I2

Shifted

Shifted color gradient

Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein.

Mehr im Online-Handbuch

VT_I2

ColorGradientOffset

Offset [%]

Only available if at a vector element the property Color gradient or at the dynamic element Button property Filling was set. linear or Starting from a defined point or Starting from a defined point with beams.

Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.

Values: 0 equals the center of the element. 100 the edge.
Note: The value can also be outside of the element and is therefore not limited to 100.

More in the online help.

VT_I2

ColorGradientAngle

Angle [°]

Defines the direction of the color gradient starting in the center of the element.

Values: 0° to 360°.

Default: 0°

More in the online help.

VT_BOOL

Brightness

With brightness values

Only available if Filling pattern was selected as color gradient was selected.

Active: The brightness of the color gradient can be freely defined.
Inactive: The brightness of the color gradient is defined automatically.

Note: The filling pattern can no longer be changed if this property is active. It is also not possible to set rounded corners. If this option is activated for an element that uses rounded corners, the element is displayed with non-rounded corners.

More in the online help.

VT_UI1

OuterBrightness

Brightness outside

Only available if "via brightness value" is active:
Brightness at the outer side of the element.

More in the online help.

VT_UI1

InnerBrightness

Brightness inside

Only available if "via brightness value" is active:
Brightness in the middle of the element.

More in the online help.

VT_BOOL

ALCUseColor

Color from ALC

Only available if you have licensed Automatic Line Coloring (ALC):
Active: The automatic color of the linked source(s) is used.
Inactive: The standard color is used.
Default: inactive.

More in the online help.

VT_I2

ALCPrecedence

Priority for display

Only available if the Color from ALC property is active.

Defines the priority of the display when the element is connected to several active sources.
Multiple supply: The element is displayed according to the rules of the multiple supply.
secured supply: The element is displayed according to the rules of the secured supply.
No priority: The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.

Default: Multiple supply
More in the online help.

VT_I2

ALCMultiSource

display multiple supplies

Only available if the property Color from ALC is active.
Defines the display type if the element is connected to several sources:
most prior source: Only the color of the source with the highest priority is used.
two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line.
alternative color: Alternative color for the coloring at multiple supply.

Default: highest priority source

More in the online help

VT_I2

ALCDashLen

Dashing length supplied multiple times

Only available if property display multiple supplies has value two highest prior sources.

Defines the dash length in pixel for the dashed ALC coloring at multiply supply.

Minimal: 0 (automatic dash length)

Maximum: 32767

Default: 0

More in the online help.

ZT_COLOR

ALCAlternativeColor

Alternative color

Only available if property display multiple supplies has value alternative color.

Alternative color for the ALC coloring at multiple supply.

More in the online help.

VT_I2

ALCMSecuredSupply

display secured supply

Only available if Color from ALC was activated.

Definition of the display of the secured supply:

  • double width
  • double brightness
  • normal

Default: normal

More in the online help

VT_BOOL

ALCAlias

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

ALCAliasName

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_R8

ALCReact

Reactance value of the cable [Ohm]

Maximum permitted reactance value of the line in ohms.

More in the online help.

VT_R8

ALCResist

Resistance value of the electric line [Ohm]

Maximum permitted resistance value of the line in ohms.

More in the online help.

VT_R8

ALCLength

Length of the line [km]

ALC line: Length of the line.

More in the online help.

VT_I2

ALCMaxIType

Limit current carrying capacity

ALC switch: Limit value of current capacity [selection of fixed/variable].

More in the online help.

VT_R8

ALCMaxIVal

Limit fixed current carrying capacity [A]

ALC switch: Limit fixed current carrying capacity.

More in the online help.

ZT_VARIABLE_DYN

ALCVarMaxI

Limit variable current carrying capacity

More...

ALCVarMaxIEx

ALCVarMaxIEx

ZT_VARIABLE_DYN

ALCVarCalcI

Measuring value of the calculated current flow

ALC line: Measuring value of the calculated current flow.

More in the online help.

More...

ALCVarCalcIEx

ALCVarCalcIEx

ALC Leitung: Messwert des berechneten Stromflusses für Export.

Mehr in der Online-Hilfe.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Polygon

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Polygon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BSTR

Coordinates

Coordinates

"With this property you can get/set the coordinates of the element via a string.
zElement.DynProperties(""Coordinates"") = ""197/118;260/200"""

VT_R4

SplineTension

Rounding

Only available if you have activated option Graphics quality in the project properties in node Graphical design/Screens.

Defines the rounding for the polylines, polygons and the pipes.

Values: 0,0 (no rounding) to 1,0. (maximum rounding)

Default: 0

More in the online help.

ZT_COLOR

LineColor

Line color

Line color of the element.

VT_UI2

LineWidth

Line width [Pixel]

Width of the line (in pixels).
Minimum: 0
In this case the width of the line is 1 pixel.
Maximum: 40
Default: 1
Attention: If in the project settings in node Graphical design you set property Graphics quality to Windows basis, you can use line width >1 only with a line of type "continuous line".

More in the online help.

ZT_IMAGELIST

LineType

Line type

Selection of the line type for the element from the list.
Attention: If in the project settings in node Graphical design you deactivated property Graphics quality, you can use line width >1 only with a line of type "continuous line".
More in the online help.

ZT_IMAGELIST

FillPattern

Filling pattern

Selection of the filling pattern for the element from the list.

This property is only available if property With brightness values is inactive.

More in the online help.

ZT_COLOR

LineColorEx

Line color

Defines the line color of the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

AlphaLineColor

Transparency line color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_UI1

AlphaBackColor

Transparency of the fill color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor2

Gradient color

Only available if for property Filling pattern Color gradient is selected and the project property Graphics quality is active.

Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of Fill color.

More in the online help.

VT_UI1

AlphaBackColor2

Transparency gradient color [%]

Only available if Linear was selected in the Filling pattern property.

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable2

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BackColorVariable2Preview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_I2

Lightning

Color gradient

Only available if property Filling pattern was set to Color gradient.

Defines the color gradient for vector elements.

Linear: steady gradient
Defined point: Gradient from a defined point to the edges of the element

Starting from a defined point with beams: Gradient from a defined point to the edges of the element with beams

More in the online help.

VT_I2

Align

Alignment

Direction of color shift.
horizontal
vertical

VT_I2

Shifted

Shifted color gradient

Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein.

Mehr im Online-Handbuch

VT_I2

ColorGradientOffset

Offset [%]

Only available if at a vector element the property Color gradient or at the dynamic element Button property Filling was set. linear or Starting from a defined point or Starting from a defined point with beams.

Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.

Values: 0 equals the center of the element. 100 the edge.
Note: The value can also be outside of the element and is therefore not limited to 100.

More in the online help.

VT_I2

ColorGradientAngle

Angle [°]

Defines the direction of the color gradient starting in the center of the element.

Values: 0° to 360°.

Default: 0°

More in the online help.

VT_BOOL

ALCUseColor

Color from ALC

Only available if you have licensed Automatic Line Coloring (ALC):
Active: The automatic color of the linked source(s) is used.
Inactive: The standard color is used.
Default: inactive.

More in the online help.

VT_I2

ALCPrecedence

Priority for display

Only available if the Color from ALC property is active.

Defines the priority of the display when the element is connected to several active sources.
Multiple supply: The element is displayed according to the rules of the multiple supply.
secured supply: The element is displayed according to the rules of the secured supply.
No priority: The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.

Default: Multiple supply
More in the online help.

VT_I2

ALCMultiSource

display multiple supplies

Only available if the property Color from ALC is active.
Defines the display type if the element is connected to several sources:
most prior source: Only the color of the source with the highest priority is used.
two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line.
alternative color: Alternative color for the coloring at multiple supply.

Default: highest priority source

More in the online help

VT_I2

ALCDashLen

Dashing length supplied multiple times

Only available if property display multiple supplies has value two highest prior sources.

Defines the dash length in pixel for the dashed ALC coloring at multiply supply.

Minimal: 0 (automatic dash length)

Maximum: 32767

Default: 0

More in the online help.

ZT_COLOR

ALCAlternativeColor

Alternative color

Only available if property display multiple supplies has value alternative color.

Alternative color for the ALC coloring at multiple supply.

More in the online help.

VT_I2

ALCMSecuredSupply

display secured supply

Only available if Color from ALC was activated.

Definition of the display of the secured supply:

  • double width
  • double brightness
  • normal

Default: normal

More in the online help

VT_BOOL

ALCAlias

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

ALCAliasName

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_R8

ALCReact

Reactance value of the cable [Ohm]

Maximum permitted reactance value of the line in ohms.

More in the online help.

VT_R8

ALCResist

Resistance value of the electric line [Ohm]

Maximum permitted resistance value of the line in ohms.

More in the online help.

VT_R8

ALCLength

Length of the line [km]

ALC line: Length of the line.

More in the online help.

VT_I2

ALCMaxIType

Limit current carrying capacity

ALC switch: Limit value of current capacity [selection of fixed/variable].

More in the online help.

VT_R8

ALCMaxIVal

Limit fixed current carrying capacity [A]

ALC switch: Limit fixed current carrying capacity.

More in the online help.

ZT_VARIABLE_DYN

ALCVarMaxI

Limit variable current carrying capacity

More...

ALCVarMaxIEx

ALCVarMaxIEx

ZT_VARIABLE_DYN

ALCVarCalcI

Measuring value of the calculated current flow

ALC line: Measuring value of the calculated current flow.

More in the online help.

More...

ALCVarCalcIEx

ALCVarCalcIEx

ALC Leitung: Messwert des berechneten Stromflusses für Export.

Mehr in der Online-Hilfe.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Polyline

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Polyline

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BSTR

Coordinates

Coordinates

"With this property you can get/set the coordinates of the element via a string.
zElement.DynProperties(""Coordinates"") = ""197/118;260/200"""

VT_R4

SplineTension

Rounding

Only available if you have activated option Graphics quality in the project properties in node Graphical design/Screens.

Defines the rounding for the polylines, polygons and the pipes.

Values: 0,0 (no rounding) to 1,0. (maximum rounding)

Default: 0

More in the online help.

ZT_COLOR

LineColor

Line color

Line color of the element.

VT_UI2

Offset_H

Horiz. distance [pixels]

Horizontal distance of the end of the rounding of the actual corner in pixels.

More in the online help.

VT_UI2

Offset_V

Vertical distance [pixels]

Vertical distance of the end of the rounding of the actual corner in pixels.

More in the online help.

VT_UI2

LineWidth

Line width [Pixel]

Width of the line (in pixels).
Minimum: 0
In this case the width of the line is 1 pixel.
Maximum: 40
Default: 1
Attention: If in the project settings in node Graphical design you set property Graphics quality to Windows basis, you can use line width >1 only with a line of type "continuous line".

More in the online help.

ZT_IMAGELIST

LineType

Line type

Selection of the line type for the element from the list.
Attention: If in the project settings in node Graphical design you deactivated property Graphics quality, you can use line width >1 only with a line of type "continuous line".
More in the online help.

ZT_IMAGELIST

LineCapStart

Start type

Only available if you have activated project property Graphics quality.

Defines the symbol for the starting point of the line. Click on the field and a dialog opens to select an element.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

More in the online help.

ZT_IMAGELIST

LineCapEnd

End type

Only available if you have activated project property Graphics quality.

Defines the symbol for the end point of the line. Click on the field and a dialog opens to select an element.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

More in the online help.

VT_R4

LineCapScale

Size

Only available if you have activated project property Graphics quality.

Defines the magnifying factor for the line width of the arrow. The factor relates to the line width of the vector element as defined in the Line width [Pixel] property.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

Value: greater or equal 1

Default: 4

More in the online help.

ZT_COLOR

LineColorEx

Line color

Defines the line color of the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

AlphaLineColor

Transparency line color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

VT_BOOL

ALCUseColor

Color from ALC

Only available if you have licensed Automatic Line Coloring (ALC):
Active: The automatic color of the linked source(s) is used.
Inactive: The standard color is used.
Default: inactive.

More in the online help.

VT_I2

ALCPrecedence

Priority for display

Only available if the Color from ALC property is active.

Defines the priority of the display when the element is connected to several active sources.
Multiple supply: The element is displayed according to the rules of the multiple supply.
secured supply: The element is displayed according to the rules of the secured supply.
No priority: The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.

Default: Multiple supply
More in the online help.

VT_I2

ALCMultiSource

display multiple supplies

Only available if the property Color from ALC is active.
Defines the display type if the element is connected to several sources:
most prior source: Only the color of the source with the highest priority is used.
two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line.
alternative color: Alternative color for the coloring at multiple supply.

Default: highest priority source

More in the online help

VT_I2

ALCDashLen

Dashing length supplied multiple times

Only available if property display multiple supplies has value two highest prior sources.

Defines the dash length in pixel for the dashed ALC coloring at multiply supply.

Minimal: 0 (automatic dash length)

Maximum: 32767

Default: 0

More in the online help.

ZT_COLOR

ALCAlternativeColor

Alternative color

Only available if property display multiple supplies has value alternative color.

Alternative color for the ALC coloring at multiple supply.

More in the online help.

VT_I2

ALCMSecuredSupply

display secured supply

Only available if Color from ALC was activated.

Definition of the display of the secured supply:

  • double width
  • double brightness
  • normal

Default: normal

More in the online help

VT_BOOL

ALCAlias

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

ALCAliasName

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_R8

ALCReact

Reactance value of the cable [Ohm]

Maximum permitted reactance value of the line in ohms.

More in the online help.

VT_R8

ALCResist

Resistance value of the electric line [Ohm]

Maximum permitted resistance value of the line in ohms.

More in the online help.

VT_R8

ALCLength

Length of the line [km]

ALC line: Length of the line.

More in the online help.

VT_I2

ALCMaxIType

Limit current carrying capacity

ALC switch: Limit value of current capacity [selection of fixed/variable].

More in the online help.

VT_R8

ALCMaxIVal

Limit fixed current carrying capacity [A]

ALC switch: Limit fixed current carrying capacity.

More in the online help.

ZT_VARIABLE_DYN

ALCVarMaxI

Limit variable current carrying capacity

More...

ALCVarMaxIEx

ALCVarMaxIEx

ZT_VARIABLE_DYN

ALCVarCalcI

Measuring value of the calculated current flow

ALC line: Measuring value of the calculated current flow.

More in the online help.

More...

ALCVarCalcIEx

ALCVarCalcIEx

ALC Leitung: Messwert des berechneten Stromflusses für Export.

Mehr in der Online-Hilfe.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Picture elements

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Picture elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Rectangle

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Rectangle

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

CornerProportional

Proportional

Only available if property With brightness values is inactive.

Active: For creating a radiused corner only the x value can be entered. The y value is always the same.

The percentage entered at property All x [%] refers to the shorter side (width or height) of the element.

Inactive: The x and y values can be entered freely. The x value refers to the width of the element. The y value refers to the height of the element.

Default: active

More in the online help.

VT_I4

CornerAll_X

All x [%]

Only available if property With brightness values is inactive.

Defines the radius values of the X-axis in percent for all corners. This value is used for all corners whose values equals -1. Individual corners can therefore be defined independently.

If the radius value is changed, all corners automatically receive the value -1. With this all corners are set back to the pre-defined value.

Value range: 0 % to 100 %.

Default: 20

More in the online help.

VT_I4

CornerAll_Y

All y [%]

Only available if the property Proportional is active and the property With brightness values is inactive.

Defines the radius values of the Y-axis in percent for all corners. This value is used for all corners whose values equals -1. Individual corners can therefore be defined independently.

If the radius value is changed, all corners automatically receive the value -1. With this all corners are set back to the pre-defined value.

Value range: 0 % to 100 %.

Default: 20

More in the online help.

VT_I4

CornerLeftTop_X

Left/top x [%]

Only available if the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the X-axis for the top left corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All x [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerLeftTop_Y

Left/top y [%]

Only available if the property Proportional is active, the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the Y-axis for the top left corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All y [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerRightTop_X

Right/top x [%]

Only available if the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the X-axis for the top right corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All x [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerRightTop_Y

Right/top y [%]

Only available if the property Proportional is active, the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the Y-axis for the top right corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All y [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerRightBottom_X

Right/bottom x [%]

Only available if property With brightness values is inactive.

Defines the radius value of the X-axis for the bottom right corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All x [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerRightBottom_Y

Right/bottom y [%]

Only available if the property Proportional is active, the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the Y-axis for the bottom right corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All y [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerLeftBottom_X

Left/bottom x [%]

Only available if the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the X-axis for the bottom left corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All x [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

VT_I4

CornerLeftBottom_Y

Left/bottom y [%]

Only available if the property Proportional is active, the property With brightness values is inactive and the project property Graphics quality is active.

Defines the radius value of the Y-axis for the bottom left corner. Click on button ... opens a slider with which you can set the radius. Possible values:

-1: The setting from All y [%] is used.

0 to 100: Radius in percent.

Default: -1

More in the online help.

ZT_COLOR

LineColor

Line color

Line color of the element.

VT_UI2

LineWidth

Line width [Pixel]

Width of the line (in pixels).
Minimum: 0
In this case the width of the line is 1 pixel.
Maximum: 40
Default: 1
Attention: If in the project settings in node Graphical design you set property Graphics quality to Windows basis, you can use line width >1 only with a line of type "continuous line".

More in the online help.

ZT_IMAGELIST

LineType

Line type

Selection of the line type for the element from the list.
Attention: If in the project settings in node Graphical design you deactivated property Graphics quality, you can use line width >1 only with a line of type "continuous line".
More in the online help.

ZT_IMAGELIST

FillPattern

Filling pattern

Selection of the filling pattern for the element from the list.

This property is only available if property With brightness values is inactive.

More in the online help.

ZT_COLOR

LineColorEx

Line color

Defines the line color of the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

AlphaLineColor

Transparency line color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_UI1

AlphaBackColor

Transparency of the fill color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor2

Gradient color

Only available if for property Filling pattern Color gradient is selected and the project property Graphics quality is active.

Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of Fill color.

More in the online help.

VT_UI1

AlphaBackColor2

Transparency gradient color [%]

Only available if Linear was selected in the Filling pattern property.

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable2

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BackColorVariable2Preview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_I2

Lightning

Color gradient

Only available if property Filling pattern was set to Color gradient.

Defines the color gradient for vector elements.

Linear: steady gradient
Defined point: Gradient from a defined point to the edges of the element

Starting from a defined point with beams: Gradient from a defined point to the edges of the element with beams

More in the online help.

VT_I2

Align

Alignment

Direction of color shift.
horizontal
vertical

VT_I2

Shifted

Shifted color gradient

Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein.

Mehr im Online-Handbuch

VT_I2

ColorGradientOffset

Offset [%]

Only available if at a vector element the property Color gradient or at the dynamic element Button property Filling was set. linear or Starting from a defined point or Starting from a defined point with beams.

Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.

Values: 0 equals the center of the element. 100 the edge.
Note: The value can also be outside of the element and is therefore not limited to 100.

More in the online help.

VT_I2

ColorGradientAngle

Angle [°]

Defines the direction of the color gradient starting in the center of the element.

Values: 0° to 360°.

Default: 0°

More in the online help.

VT_BOOL

Brightness

With brightness values

Only available if Filling pattern was selected as color gradient was selected.

Active: The brightness of the color gradient can be freely defined.
Inactive: The brightness of the color gradient is defined automatically.

Note: The filling pattern can no longer be changed if this property is active. It is also not possible to set rounded corners. If this option is activated for an element that uses rounded corners, the element is displayed with non-rounded corners.

More in the online help.

VT_UI1

OuterBrightness

Brightness outside

Only available if "via brightness value" is active:
Brightness at the outer side of the element.

More in the online help.

VT_UI1

InnerBrightness

Brightness inside

Only available if "via brightness value" is active:
Brightness in the middle of the element.

More in the online help.

VT_BOOL

ALCUseColor

Color from ALC

Only available if you have licensed Automatic Line Coloring (ALC):
Active: The automatic color of the linked source(s) is used.
Inactive: The standard color is used.
Default: inactive.

More in the online help.

VT_I2

ALCPrecedence

Priority for display

Only available if the Color from ALC property is active.

Defines the priority of the display when the element is connected to several active sources.
Multiple supply: The element is displayed according to the rules of the multiple supply.
secured supply: The element is displayed according to the rules of the secured supply.
No priority: The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.

Default: Multiple supply
More in the online help.

VT_I2

ALCMultiSource

display multiple supplies

Only available if the property Color from ALC is active.
Defines the display type if the element is connected to several sources:
most prior source: Only the color of the source with the highest priority is used.
two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line.
alternative color: Alternative color for the coloring at multiple supply.

Default: highest priority source

More in the online help

VT_I2

ALCDashLen

Dashing length supplied multiple times

Only available if property display multiple supplies has value two highest prior sources.

Defines the dash length in pixel for the dashed ALC coloring at multiply supply.

Minimal: 0 (automatic dash length)

Maximum: 32767

Default: 0

More in the online help.

ZT_COLOR

ALCAlternativeColor

Alternative color

Only available if property display multiple supplies has value alternative color.

Alternative color for the ALC coloring at multiple supply.

More in the online help.

VT_I2

ALCMSecuredSupply

display secured supply

Only available if Color from ALC was activated.

Definition of the display of the secured supply:

  • double width
  • double brightness
  • normal

Default: normal

More in the online help

VT_BOOL

ALCAlias

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

ALCAliasName

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_R8

ALCReact

Reactance value of the cable [Ohm]

Maximum permitted reactance value of the line in ohms.

More in the online help.

VT_R8

ALCResist

Resistance value of the electric line [Ohm]

Maximum permitted resistance value of the line in ohms.

More in the online help.

VT_R8

ALCLength

Length of the line [km]

ALC line: Length of the line.

More in the online help.

VT_I2

ALCMaxIType

Limit current carrying capacity

ALC switch: Limit value of current capacity [selection of fixed/variable].

More in the online help.

VT_R8

ALCMaxIVal

Limit fixed current carrying capacity [A]

ALC switch: Limit fixed current carrying capacity.

More in the online help.

ZT_VARIABLE_DYN

ALCVarMaxI

Limit variable current carrying capacity

More...

ALCVarMaxIEx

ALCVarMaxIEx

ZT_VARIABLE_DYN

ALCVarCalcI

Measuring value of the calculated current flow

ALC line: Measuring value of the calculated current flow.

More in the online help.

More...

ALCVarCalcIEx

ALCVarCalcIEx

ALC Leitung: Messwert des berechneten Stromflusses für Export.

Mehr in der Online-Hilfe.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Switch

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Switch

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

DynEleVar

DynEleVar

"With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX
zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"

ZT_VARIABLE_DYN

Variable

Variable

Name of the linked variable. Click on button ... in order to open the dialog for selecting variables.
The value of this variable is displayed in this element and can also be set here.

Note: Only available for buttons if they are used as a switch.

Hint: If the variable value is to be toggled, we recommend activating the Permanently read variable property. Otherwise Runtime waits until the driver knows the value of the variables. If the value is not available due to a breakdown in communication with the control unit, the waiting time corresponds to the timeout time of the driver.

Only SICAM 230 and Screen Alarm element:
The description above only applies to the elements Text Button, Bitmap Button and Invisible Button.
Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).

  • Lower bit: Alarm active/inactive
  • Higher bit: Alarm acknowledged/not acknowledged

More in the online help.

VT_BOOL

Scanner

Momentary switch

Only available if property Switch is active. (Exception: always available in the switch dynamic element.)
Active: The target state - defined in property Momentary switch On - is only held as long as the left mouse button is pressed but at least as long as Holding time [ms].
Inactive: The target state remains even after the mouse button is released.
Default: inactive.

More in the online help.

VT_BOOL

ScannerOn

Momentary switch On

Only available if Momentary switch is active.
Active: Switch switches to ON.
Inactive: Switch switches to OFF.
Default: Inactive.

More in the online help.

VT_BOOL

ResetOnLeave

Reset on exit

Only available if property Momentary switch is active.
If you press and hold the mouse button and move the mouse pointer away from the button, this will automatically reset the value of the variable.

More in the online help

VT_BOOL

FastReaction

Fast reaction

Only available if Switch is active.
Active: The switch immediately changes its position in Runtime, regardless of whether the linked bit has actually been set in the PLC. In the next driver update cycle, the bit will be read from the PLC. Then the switch again ressembles the correct position of the bit in the PLC.
Attention: The switch will only be visibly operable after the value has been read from the PLC.

Inactive: The switch will change its position only after the bit has been sent to the PLC and then again read from the PLC.

(Default) Inactive:

More in the online help.

VT_UI2

ReactionTime

Holding time [ms]

Only available if Switch is active.
If Momentary switch is active: Time (in ms) which a state is held starting from the left click on the respective element.

If property Momentary switch is inactive: Delayed reaction to a left click.

More in the online help.

VT_BOOL

StayPressed

Keep pushed state

Only available if properties Switch, Momentary switch and Fast reaction are active.

Active: As long as you hold the mouse button pressed on this element, its graphical display does not change - independent of possible values changes in the PLC. At the element Switch property 3D must be active in order for this to happen.
Inactive: The element always displays the value of the variable from the PLC.

More in the online help.

VT_BOOL

ThreeDimensional

3D

Active: The element is displayed threedimensionally.
Inactive: The element is displayed flat.

More in the online help.

VT_BOOL

ShowState

Display status of variable

Active: The status of the variables is indicated by a colored square at the element.

Color:
red square indicates that there a problems with the communication to the PLC.
Blue square at the client end indicates that the client lost the connection to the server.
Blue square at the station indicates that the value was not initialized.

Position of the square at the element at element form:

Round: top edge, in the middle
rounded: top right corner, slightly offset to the leftangular and all others:

Inactive: The status is not displayed.

More in the online help.

VT_UI2

GraphicSize

Graphic size

Definition of the graphics size.

  • Adjusted: The size of the graphics is adjusted to the size of the element.
  • Original size: The linked graphic is displayed in original size.
    When selecting this option, the properties Width [pixels] and Height [pixels] can no longer be individually configured for the elements multibin, combi-element, button and switch.

Default: Stretched

More in the online help.

ZT_IMAGELIST

PredefinedBitmaps

Predefined graphics

Pre-defined bitmaps for the LOW/HIGH state can be selected from the list.

More in the online help.

ZT_FILE

BitmapLow

Graphics file for Off (0)

Pre-defined or user-defined bitmap for the LOW status of the switch.

More in the online help.

ZT_FILE

BitmapHigh

Graphics file for On (1)

Pre-defined or user-defined bitmap for the HIGH status of the switch.

More in the online help.

VT_BOOL

Animate

Always

Active: The animation always runs.
Inactive: Then the animation is not executed. You can switch the animation on and off with an optional link to Variable.

More in the online help

ZT_VARIABLE_DYN

AnimateVar

Variable

Bit variable that switches the animation on and off.

More in the online help.

ZT_SHORTCUT

ShortCut

Key combination

Shortcuts support executing operable elements. For example:

- Executing control elements and functions which have an element assigned
- Write set value (e.g. for switches)
- Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)

A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly.

More in the online help.

VT_UI2

Passwordlevel

Authorization level

Password level for writing set values or executing functions with the selected dynamic element.
Minimum: 0.
Maximum: 127.
Default: 0.

More in the online help.

VT_UI4

Locking

Interlocking

Link to an existing interlocking to this element.

If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.

Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_BOOL

Signature

Signature necessary

Active: A signature is necessary to operate the element.

For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.

Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.

Inactive: No signature is required.

(Default) Inactive:

More in the online help.

VT_BSTR

SignatureText

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties.

More in the online help.

VT_I2

SignatureEditModus

Signature text editable

Defines whether the signature text can be edited. Selection from drop-down list:

  • Apply project settings: The settings of the Signature text editable project property are applicable.
  • Yes: Text can be edited.
  • No: Text cannot be edited.

Default: Apply project settings

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


CStatusElemZustand

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> CStatusElemZustand

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_UI4 | Value | Value |
VT_UI4 | ValueMask | ValueMask |
VT_UI8 | Status | Status |
VT_UI8 | StatusMask | StatusMask |
ZT_COLOR | Color | Color |
ZT_COLOR | BkColor | BkColor |
VT_BOOL | Blinking | Blinking |
VT_BOOL | BkTransparent | BkTransparent |
VT_BOOL | LayerTransparent | LayerTransparent |
VT_BOOL | IsSymbolColor | IsSymbolColor |
VT_BOOL | IsTopologyColor | IsTopologyColor |
VT_BOOL | IsTopologyBkColor | IsTopologyBkColor |
VT_UI4 | Additive | Additive |
VT_UI4 | AdditiveMask | AdditiveMask |
VT_BSTR | TextOrBitmap | TextOrBitmap |
VT_BSTR | SymbolName | SymbolName |
VT_BSTR | SymbolPath | SymbolPath |
VT_BSTR | Formula | Formula |
VT_BSTR | DownText | DownText |


Combi

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Combi

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

States

States

More...

DynEleVar

DynEleVar

"With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX
zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"

More...

DynEleFkt

DynEleFkt

ZT_VARIABLE_DYN

Variable

Variable

Name of the linked variable. Click on button ... in order to open the dialog for selecting variables.
The value of this variable is displayed in this element and can also be set here.

Note: Only available for buttons if they are used as a switch.

Hint: If the variable value is to be toggled, we recommend activating the Permanently read variable property. Otherwise Runtime waits until the driver knows the value of the variables. If the value is not available due to a breakdown in communication with the control unit, the waiting time corresponds to the timeout time of the driver.

Only SICAM 230 and Screen Alarm element:
The description above only applies to the elements Text Button, Bitmap Button and Invisible Button.
Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).

  • Lower bit: Alarm active/inactive
  • Higher bit: Alarm acknowledged/not acknowledged

More in the online help.

ZT_FUNCTION_DYN

Function

Function

Name of the linked function.
Opens the function selection dialog.
This function will be executed when the button is clicked in the Runtime or when the assigned key shortcut is pressed.
If you wish to execute more than one function, you need to create a script with the required functions and specify the function for executing that script here.

SICAM 230 and screen alarming element only:

In addition to the standard screen switch property, the screen whose alarm states are supposed to be displayed will be determined by the linked function.
Obligatory (unless the Global setting is active)!

More in the online help.

VT_BSTR

FunctionParameter

Parameter for substitution

Entry of the character sequence for substitution via parameters. Replaces the key word {PARAM} in the substitution dialog of the screen switching.

Note: Avoid character sequences that are also used for parameter of the indexing variables, such as {X01}.

More in the online help.

VT_BOOL

FktOnDown

Function execution on pressing

Active: The linked function is executed when the element is pressed.
Inactive: The linked function is executed when the element is released.
Default: inactive.

More in the online help.

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_BOOL

ThreeDimensional

3D

Active: The element is displayed threedimensionally.
Inactive: The element is displayed flat.

More in the online help.

VT_BOOL

ShowState

Display status of main variable

If the "Display status" option is highlighted, the current status bit assignment for the stored variable is displayed in online operation in addition to the variable display when the right mouse button is pressed.

More in the online help.

VT_BOOL

RedPoint

Display status with square

If an exception status (e.g. "disturbed") is present, a red marking is placed at the top right in the element area.

More in the online help.

VT_UI2

RepresentationStyle

Type of display

Selection of the display type from drop-down list:

  • Graphics file and screen symbol: You can define a graphics file or a screen symbol (symbol or elemt group) for each status.
    In addition, the color of a screen symbol can also be changed.
  • Only screen symbol: For every status, you can assign a color to a symbol that already exists in the screen.
  • Symbol from library: For each status a symbol from the library as well as a line and filling color can be selected
  • Sign: For every status, you can define a character (only SICAM 230).
  • Status text and screen symbol: You can define a text for every status.
    Additionally, you can also change the color of a screen symbol.

More in the online help.

ZT_COMBI

StateAndTest

Configuration and test

Opens the dialog to define the states.

More in the online help.

VT_BOOL

DisabledStyleAsButtons

Darstellung im gesperrten Zustand von Tasteneigenschaften des Projekts übernehmen

Setting for whether the key actions are taken from the project property. For this, the settings of the following project properties are taken into account:

  • Login and signature -> Locked buttons
  • Locked/Interlocked elements -> Interlocked buttons

Possible settings:

  • Active: The settings from the project properties are accepted.
    Note: The gray setting has no effect on symbols in the text.
  • Inactive: The settings are ignored.

Default: inactive

More in the online help.

ZT_COLOR

ButtonFillColor

Fill color

Background color of the element.

More in the online help.

VT_BOOL

FillColor

Transparent

Active: The symbol background is transparent.
Inactive: The symbol background can be defined individually for each state.
Default: inactive.

More in the online help.

VT_BOOL

ColorFromVariable

Take color of main variable

Active: The fill color at embedded symbols and symbols from the library is taken over from the main variable at status Default if there is a limit violation at this variable.
That means: As long as a limit violation of the main variable is active, the fill color is taken from the limit color. The color definition of the states is overwritten. Additional status attributes such as Flashing, Transparency or Original symbol color are however taken from the status definition. This property does not effect the bitmap notation.

Exception: If at status Default property Original symbol color is activated, the original symbol color is always used.
Inactive: The color of the main variable does not effect the displayed color of the combined element.
Default: Inactive.

More in the online help.

VT_BOOL

BlinkingFromVariable

Take flashing from main variable

Active: The flashing attribute of the main variables is taken and can be acknowledged on the element.
Inactive: No flashing occurs.

More in the online help.

VT_BOOL

BlinkingFromAllVariables

Recognize flashing of all variables

Only available if "Take flashing from main variable" is active:
Active: The flashing attributes of all variables are taken.
Inactive: Only the flashing attribute of the main variable is taken or there is no flashing (depending on the "Take flashing from main variable" option").

More in the online help.

VT_BOOL

BlinkingBackGroundTransparent

Flashing background transparent

Active: The symbol background is transparent when flashing (bitmap background cannot be displayed as transparent).
Inactive: The symbol background is not transparent.

More in the online help.

ZT_COLOR

BlinkingBackColor

Flashing color

Background color with option "flashing background transparent" not set.

More in the online help.

VT_BOOL

OriginalSize

In original size

Active: The bitmap file is displayed in its original size.
Inactive: The bitmap file is stretched to the size of the menu item.
Default: active.

More in the online help.

VT_BOOL

IsPictureSymbol

Screen symbol active

Only available if, for the Type of display property, Graphics file and screen symbol or Status text and screen symbol has been selected.

  • Active: In addition to the animated graphics file or the status text, a screen symbol can be displayed.
  • Inactive: No screen symbol is used.

More in the online help.

VT_BOOL

FillAreaOnly

Color only filling area

Active: The color switching only affects the fill area. The color switching also affects the lines.
Default: inactive.

More in the online help.

VT_UI2

PictureSymbol

Screen symbol

Only available if, for the Type of display property, Only Screen symbol has been selected or if the property Screen symbol active has been activated.
Selection of the screen symbol, whose color should be switched according to status. This can be a symbol or an element group.

More in the online help.

VT_BOOL

Overlapping

Overlapping

Only available for the "Symbol from library" display type:
Active: If several value assignments are active, the display is overlapping, i.e. all active states are displayed.
Inactive: Only the status with the highest priority is displayed.
Default: inactive.

More in the online help.

VT_BOOL

SeparateColors

Separate colors

Only available if "overlapping" is active.
Active: Each state is displayed in its defined color.
Inactive: The color of the active status with the highest priority will be used.
Default: inactive.

More in the online help.

VT_BOOL

SeparateBlinking

Separate flashing

Only available if "overlapping" is active.
Active: The flashing of each state is shown separately.
Inactive: The flashing of the active status with the highest priority will be used.
Default: inactive.

More in the online help.

VT_BOOL

SymbolFormClickArea

Symbol form defines the click area

Makes it possible to create a clickable button in any form. Is only available for option Symbol from library of the combined element.

Active: The symbol form is used as a click area. Each element in the symbol is considered individually for the click area.

Inactive: The form of the combined element (whole rectangle) is used as click area.

Default: inactive

Attention: Not available for Windows CE.

Property is available from version 6.51. For projects for earlier versions, the property is treated as inactive.

More in the online help.

VT_I2

HorizontalAlign

Alignment horizontal

Horizontal alignment of the output in the element for the display. Possible settings via the drop-down list:

centered
- left-adjusted
- right-adjusted

Default: centered

More in the online help.

VT_I2

VerticalAlign

Alignment vertical

Vertical alignment of the output in the element for the display. Possible settings via the drop-down list:

centered
- top
- bottom

Default: Centered

More in the online help.

VT_BOOL

Wordbreak

Automatic word wrap

Active: Automatic word wrap is used for the text in the element.
The length of the lines depends on the width of the element.
Inactive: The text is displayed in one line.
Default: inactive.

More in the online help.

VT_BOOL

Chained

Text chained

Only available for representation type "Status text":
Active: When several states apply, the individual status texts will displayed as a combined string.
Inactive: The text of the active status with the highest priority will be used.
Default: inactive.

More in the online help.

VT_I2

TopologyType

Topology type

Topology type

VT_UI1

TransformerSide

Transformer side

Transformer side

VT_UI1

SupplyNumber

Supply number

Supply number

VT_BOOL

TopologyLRChanged

Switch impact direction/mounting direction

Switches the left/right connection for topological elements which have a direction connection.

VT_BOOL

TopologyUseFrame

Use effects/borders for edging

If property is set: The framework configured under effects/frame (width/distance) is used to support the border, including for combined elements

VT_BOOL

TopologyBorderSV

Limit for power distribution calculation

VT_BOOL

TopologyBorderFOS

Limit for failure location from protection

VT_BOOL

TopologyBorderSHL

Limit for selfhealing

If property is set: The element is considered a limit for a self-healing region.

VT_BOOL

TopologyBorderWBR

Limit for wide range regulation

If property is set: The element is considered a limit for a wide-range-regulation region.

VT_UI4

TopologyResourceNr

Resource type

VT_I2

ALCType

Function type

Only available if you have licensed Automatic Line Coloring (ALC).

Selection of the function type of the element. Click the function type to open a drop-down list for selection:

  • Conclusion: For bus bar end; blocks the error message "Line only connected on one side" when being compiled in the Editor.
  • Generator: Element works as a generator (analog Source) - if active, the color is forwarded to the next line.
  • No function: The element has no function in the ALC.
  • Link: The ALC information is transferred from a source link to a target link.
  • Source: If source is active, the color is forwarded to the next line.
  • Switch: The color is forwarded to the next line if the switch is closed and if it is supplied by a source.
  • Valve: Works in the same way as a switch. The color is forwarded to the next line if the valve is open or partly open and if it is supplied by a source. For the values of the main variable: see the manual.
  • Drain: This function type has no effect on the coloring. With the help of VBA you can however poll if this device is supplied.
  • Transformer: If the element is supplied, it changes a source (color) into another.
  • Disconnector works in the same way as switch; contains however a topologic interlocking Disconnector under load. The color is forwarded to the next line if the disconnector is closed and if it is supplied by a source.

Default: No function

More in the online help

VT_I2

ALCSourceID

Source

Only active, if the function type source or transformer has been selected:
Selection of the linked source/transformers.

More in the online help.

VT_I2

ALCReverseSourceID

Source for reverse feed

Only available if you have selected Transformer at property Function type.

Selection of the linked transformers.

If you select another source as UNDEFINED [0], the transformer is capable of reverse feed. This means that the transformer behaves the same for both directions - from the input to the output (forward) and also from the output to the input (backward). The only difference is that the Source for reverse feed property and not the Source property is used for further distribution of the source number .

Note: Defective network statuses or missing configurations, such as a feed from the input and output at the same time or a short circuit from input and output are not specially colored. This means that the transformer capable of taking a reverse feed behaves like two transformers switched to run antiparallel that are not capable of taking a reverse feed.

More in the online help.

VT_BOOL

ALCExchangeInOut

Switch input/output

Only available if you selected Transformer, Switch, valve or Separator at option Function type.

Active: Moves the input of the ALC element to the right or to the bottom and the output to the left or to the top.

Default: inactive

More in the online help.

VT_I2

ALCLinkID

Link number

Only available if Link function type has been selected.
Identification number of the link. A different link on a different screen with the same information number will take over the data of the source link.

More in the online help.

VT_BOOL

ALCAlias

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

ALCAliasName

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_I2

ALCGroundFaultType

Type

Only available if you selected Switch at property Function type.

Defines the direction (leading/lagging) and the processing type of the message (none, Permanent message or Wiper):

none: normal switch

Permanent message: Message is considered as an earth fault triggering.

Wiper: Messages that are received during a current Search are suppressed

Lagging: you have to wait 2 seconds for the first rising flank of one direction

Leading: current status of the direction is used

Default: None

More in the online help .

ZT_VARIABLE_DYN

ALCGroundFaultVarTrg

Triggering

Only available if a Type has been selected.
Defines the variable which displays the detection of an earth fault. For directed earth fault detection devices the direction (Backwards or Forwards) must be defined additionally. Click on button ... in order to open the dialog for selecting a variable.

More in the online help.

More...

ALCGroundFaultVarTrgEx

ALCGroundFaultVarTrgEx

ZT_VARIABLE_DYN

ALCGroundFaultVarDisp

Display

Only available if a Type has been selected.
Defines the output variable of the error detection in order to display the status of the earth fault detection device. The variable which is linked there, should be a local variable in order to prevent problems in the network operation. Click on button ... in order to open the dialog for selecting a variable.

More in the online help.

More...

ALCGroundFaultVarDispEx

ALCGroundFaultVarDispEx

ZT_VARIABLE_DYN

ALCGroundFaultVarFwd

Forwards

Only available if a Type has been selected.
Defines the variable for the forward earth fault detection. Click on button ... in order to open the dialog for selecting a variable.

More in the online help.

More...

ALCGroundFaultVarFwdEx

ALCGroundFaultVarFwdEx

ZT_VARIABLE_DYN

ALCGroundFaultVarRev

Backwards

Only available if a Type has been selected.
Defines the variable for the backward earth fault detection. Click on button ... in order to open the dialog for selecting a variable.

More in the online help.

More...

ALCGroundFaultVarRevEx

ALCGroundFaultVarRevEx

VT_I2

ALCShortFaultType

Type

Only available if you selected Switch at property Function type.

Defines the processing of the message (none or Permanent message and its direction (leading/lagging).

none: normal switch

Permanent message: Message is considered as an earth fault triggering.

Lagging: you have to wait for the first rising flank of one direction

Leading: current status of the direction is used

Default: None

More in the online help.

ZT_VARIABLE_DYN

ALCShortFaultVarTrg

Triggering

Only available if a Type has been selected.

Defines the variable for the message of the short circuit detection device. For directed short circuit detection devices the direction (Forwards or Backwards) must be defined additionally. Click on button ... in order to open the dialog for selecting a variable.

More in the online help.

More...

ALCShortFaultVarTrgEx

ALCShortFaultVarTrgEx

ZT_VARIABLE_DYN

ALCShortFaultVarDisp

Display

Only available if a Type has been selected.

Defines the output variable of the error detection in order to display the status of the shirt circuit detection device. The variable which is linked there, should be a local variable in order to prevent problems in the network operation. Click on button ... in order to open the dialog for selecting a variable.

More in the online help.

More...

ALCShortFaultVarDispEx

ALCShortFaultVarDispEx

ZT_VARIABLE_DYN

ALCShortFaultVarFwd

Forwards

Only available if a Type has been selected.
Defines the variable for the forward short circuit detection. Click on button ... in order to open the dialog for selecting a variable.

More in the online help.

More...

ALCShortFaultVarFwdEx

ALCShortFaultVarFwdEx

ZT_VARIABLE_DYN

ALCShortFaultVarRev

Backwards

Only available if a Type has been selected.
Defines the variable for the backward short circuit detection. Click on button ... in order to open the dialog for selecting a variable.

More in the online help.

More...

ALCShortFaultVarRevEx

ALCShortFaultVarRevEx

ZT_VARIABLE_DYN

ALCVarProtReact

Reactance value from protection

More...

ALCVarProtReactEx

ALCVarProtReactEx

VT_I2

ALCMaxIType

Limit current carrying capacity

ALC switch: Limit value of current capacity [selection of fixed/variable].

More in the online help.

VT_R8

ALCMaxIVal

Limit fixed current carrying capacity [A]

ALC switch: Limit fixed current carrying capacity.

More in the online help.

ZT_VARIABLE_DYN

ALCVarMaxI

Limit variable current carrying capacity

More...

ALCVarMaxIEx

ALCVarMaxIEx

ZT_VARIABLE_DYN

ALCVarCurI

Measured value of the current current flow

More...

ALCVarCurIEx

ALCVarCurIEx

ZT_VARIABLE_DYN

ALCVarCalcI

Measuring value of the calculated current flow

ALC line: Measuring value of the calculated current flow.

More in the online help.

More...

ALCVarCalcIEx

ALCVarCalcIEx

ALC Leitung: Messwert des berechneten Stromflusses für Export.

Mehr in der Online-Hilfe.

ZT_VARIABLE_DYN

ALCVarCurP

Measured value of the current apparent power

More...

ALCVarCurPEx

ALCVarCurPEx

VT_I2

ALCLoadType

Load

VT_R8

ALCLoadVal

Load fixed [A]

ZT_VARIABLE_DYN

ALCVarLoad

Load variable

More...

ALCVarLoadEx

ALCVarLoadEx

VT_UI2

Passwordlevel

Authorization level

Password level for writing set values or executing functions with the selected dynamic element.
Minimum: 0.
Maximum: 127.
Default: 0.

More in the online help.

VT_UI4

Locking

Interlocking

Link to an existing interlocking to this element.

If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.

Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

ZT_SHORTCUT

ShortCut

Key combination

Shortcuts support executing operable elements. For example:

- Executing control elements and functions which have an element assigned
- Write set value (e.g. for switches)
- Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)

A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly.

More in the online help.

VT_BOOL

Switch

Switch

Only available if property Setting values active is inactive.

Active: The element switches the value of a bit variable.
Inactive: The element carries out a function.
Default: inactive.

More in the online help.

VT_BOOL

Scanner

Momentary switch

Only available if property Switch is active. (Exception: always available in the switch dynamic element.)
Active: The target state - defined in property Momentary switch On - is only held as long as the left mouse button is pressed but at least as long as Holding time [ms].
Inactive: The target state remains even after the mouse button is released.
Default: inactive.

More in the online help.

VT_BOOL

ScannerOn

Momentary switch On

Only available if Momentary switch is active.
Active: Switch switches to ON.
Inactive: Switch switches to OFF.
Default: Inactive.

More in the online help.

VT_BOOL

ResetOnLeave

Reset on exit

Only available if property Momentary switch is active.
If you press and hold the mouse button and move the mouse pointer away from the button, this will automatically reset the value of the variable.

More in the online help

VT_BOOL

FastReaction

Fast reaction

Only available if Switch is active.
Active: The switch immediately changes its position in Runtime, regardless of whether the linked bit has actually been set in the PLC. In the next driver update cycle, the bit will be read from the PLC. Then the switch again ressembles the correct position of the bit in the PLC.
Attention: The switch will only be visibly operable after the value has been read from the PLC.

Inactive: The switch will change its position only after the bit has been sent to the PLC and then again read from the PLC.

(Default) Inactive:

More in the online help.

VT_BOOL

StayPressed

Keep pushed state

Only available if properties Switch, Momentary switch and Fast reaction are active.

Active: As long as you hold the mouse button pressed on this element, its graphical display does not change - independent of possible values changes in the PLC. At the element Switch property 3D must be active in order for this to happen.
Inactive: The element always displays the value of the variable from the PLC.

More in the online help.

VT_UI2

ReactionTime

Holding time [ms]

Only available if Switch is active.
If Momentary switch is active: Time (in ms) which a state is held starting from the left click on the respective element.

If property Momentary switch is inactive: Delayed reaction to a left click.

More in the online help.

VT_BOOL

IsSetValue

Setting values active

Active: Setting of variables for this dynamic element is allowed.
Inactive: The variable is write-protected in this element.

More in the online help.

VT_BOOL

Preset

propose current value

Active: The current value of the variable is proposed as set value.
In this case, the value is added under "Set value / amend by" before setting the actual value (positive value) or subtracted from this (negative value).
Inactive: The value defined in "Set value / amend" is proposed.

More in the online help.

VT_BOOL

HWDirect

without dialog

Active: The value is sent to the hardware without a possibility to be changed in the Runtime.
Inactive: The user still has the possibility to amend the value in Runtime before writing to the hardware.

More in the online help.

VT_R8

SetValue

Set value / change by

Value that should be sent as the set value or as a default.
If "Propose current value" is active:: Value that is added to the current value.
In combination with the "without dialog" property, such an increment (positive value) or decrement (negative value) can be implemented.

More in the online help.

VT_UI1

SetValueWith

Write set value via

Send value with:
Command Processing: The new value is set using Set value input in the Command Processing.

Standard dialog box: The new value is entered using the standard dialog box. If a screen of type "Keyboard" with name "SETVALUEKBD" (for numeric values) or "SETSTRINGKBD" (for string variables) exists, it is used instead of the standard dialog box.

Element: The new value is directly entered in the element (only for the elements numeric value and text element).

Program: The new value is entered in an external program.

More in the online help.

VT_BSTR

SetProgram

External program

Only available if an external program was selected for Write set value:
The set value is written by an external program that must be selected in the dialog box that appears here.

This program is then started and gets the following parameters:
1) Name of the linked variable
2) Proposed value, as defined in the corresponding properties
3) Left coordinate of the element in pixels
4) Upper coordinate of the element in pixels
5) Right coordinate of the element in pixels
6) Lower coordinate of the element in pixels
7) Permitted minimum for the set value, as defined in the corresponding properties
8) Permitted maximum for the set value, as defined in the corresponding properties

More in the online help.

VT_BOOL

KbdUsage

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

ZT_PICTURE

KbdName

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

VT_BOOL

LimitFromVar

Take set value limits from variable

Active: The limitation of the range for which the set values can be written are not set via “Min” and “Max” but are taken from the variable definitions directly.
Inactive: The range can be limited directly in the "Minimum" and "Maximum".

More in the online help.

VT_R8

Min

Minimum

Only available if "Take set value limits from variable" is not active::
Bottom limit of the permitted range for the set value.

Attention: The value entered here is ignored if a variable is selected for the dynamic set value minimum.

More in the online help.

VT_R8

Max

Maximum

Only available if "Take set value limits from variable" is not active::
Upper limit of the permitted range for the set value.

Attention: The value entered here is ignored if a variable is selected for the dynamic set value maximum.

More in the online help.

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_BOOL

Signature

Signature necessary

Active: A signature is necessary to operate the element.

For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.

Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.

Inactive: No signature is required.

(Default) Inactive:

More in the online help.

VT_BSTR

SignatureText

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties.

More in the online help.

VT_I2

SignatureEditModus

Signature text editable

Defines whether the signature text can be edited. Selection from drop-down list:

  • Apply project settings: The settings of the Signature text editable project property are applicable.
  • Yes: Text can be edited.
  • No: Text cannot be edited.

Default: Apply project settings

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


CSymbLibProp

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> CSymbLibProp

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description


Symbol

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Symbol

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

ExpProps

ExpProps

VT_UI2

PropSymbolNumber

Screen symbol number

Unique number of the symbol or the element group.

More in the online help.

VT_BSTR

Category

Category

Concept for categorization. You can also filter or group by this property.

More in the online help.

VT_BSTR

Description

Description

More-detailed description of the symbol or the element group. You can also filter by this property.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Linked symbol

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Linked symbol

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_UI2

PropSymbolNumber

Screen symbol number

Unique number of the symbol or the element group.

More in the online help.

VT_UI2

GraphicSize

Graphic size

Definition of the graphics size.

  • Adjusted: The size of the graphics is adjusted to the size of the element.
  • Original size: The linked graphic is displayed in original size.
    When selecting this option, the properties Width [pixels] and Height [pixels] can no longer be individually configured for the elements multibin, combi-element, button and switch.

Default: Stretched

More in the online help.

VT_BSTR

LinkName

Symbol name

Name of the symbol.

More in the online help.

VT_BSTR

SubstituteSource

Source

Replacing variables and/or functions in a symbol or faceplate container.

Enter the source variable/source function. You can use wildcards (?,*). Several entries are separated by a semicolon (;).

You can define the target with the help of property Target.
Example: Variables in the symbol: Tank1.fill level and Tank1.position of the valve. These should be replaced by Tank2.fill level and Tank2.position of the valve.
For this enter the following at Source: *1* and at Target 2. In the Runtime the variables which contain 1 are replaced by the variables which contain 2.

More information is in the online manual in he Symbols and Faceplates sections.

VT_BSTR

SubstituteDestination

Target

Replacement of variables and/or functions in a symbol or faceplate container:
Enter the new variables/functions to be assigned. At this no wildcards are allowed. Several entries are separated by a semicolon (;).

You can define the sources with the help of property Source.
Example: Variables in the symbol: Tank1.fill level and Tank1.position of the valve. These should be replaced by Tank2.fill level and Tank2.position of the valve.
For this enter the following at Source: *1* and at Target 2. In the Runtime the variables which contain 1 are replaced by the variables which contain 2.

More information is in the online manual in he Symbols and Faceplates sections.

VT_BOOL

SubstituteOnName

via variable name

Replacement of variables in a symbol or faceplate container using variables:

  • Active: The replacement of links is implemented via the name of the variables.
  • Inactive The replacement of the links is implemented via the identification of the variables.

More information is in the online manual in he Symbols and Faceplates sections.

VT_BOOL

SubstituteMatchCase

Case sensitive

The capitalization in the inputs for the source and the target to replace variables and/or functions in a symbol or faceplate container.

  • Active: Capitalization is taken into account.
  • Inactive: Capitalization is not taken into account.

More information is in the online manual in he Symbols and Faceplates sections.

VT_BOOL

SubstituteCombinedName

Hierarchical names

Replacing variables in a symbol.

  • Active: The names of the linked variables are put together from the object name of the symbol and the variables defined in the symbol. The two names are separated by a dot: "Symbolname.Variable"
  • Inactive: The normal variable names are used.Default:

Default: inactive

Example:
Variable name: Motor.Speed
The symbol object name is "Motor". The dynamic element that is used in the symbol has the placeholder "Speed" as a linked variable.
The placeholder "Speed" can be typed in for the symbol property when creating the variable.
Combined names also work with nested symbols:
If you have a "Pump" symbol, which in turn contains a "Motor" symbol and a "Convertor" symbol with the variable placeholder "Output", then the linking works if there is a Pump.Motor.Output variable and a Pump.Convertor.Output variable.

More in the online help.

VT_BSTR

Preview

Preview

Opens the dialog to replace links. Changes in the preview are taken over and reversed in properties Source and Target.
Stands for symbols and faceplates available. Only active for symbols if there is already linking to the symbol; for faceplate containers, only if a screen is linked to a container.

More information is in the online manual in he Symbols and Faceplates sections.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Template

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Template

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Static text

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Static text

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

ZT_LOGSCHRIFT

Font

Font

Selection of the font with which the display happens.

ATTENTION: This option only works for embedded fonts.

More in the online help.

VT_BSTR

Text

Text

Text which should be displayed in the screen.

By using the & character, you can underline the following character in the Runtime. To display the character & itself, enter &&.

With character string \n a line break can be forced.

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BOOL

Transparent

Transparent

Active: Deactivates the background color of the element.

The effect of this option on a button is an Invisible button. It can be positioned above other elements as an invisible button.

More in the online help.

VT_I2

HorizontalAlign

Alignment horizontal

Horizontal alignment of the output in the element for the display. Possible settings via the drop-down list:

centered
- left-adjusted
- right-adjusted

Default: centered

More in the online help.

VT_I2

VerticalAlign

Alignment vertical

Vertical alignment of the output in the element for the display. Possible settings via the drop-down list:

centered
- top
- bottom

Default: Centered

More in the online help.

VT_BOOL

Wordbreak

Automatic word wrap

Active: Automatic word wrap is used for the text in the element.
The length of the lines depends on the width of the element.
Inactive: The text is displayed in one line.
Default: inactive.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


CDynEleVarTrend

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> CDynEleVarTrend

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
ZT_COLOR | LineColor | Line color | Normal color; the limit value color is used in the event of a limit violation More in the online help.
VT_UI2 | LineStyle | Line type | Unbroken line, dashes, dot-dash. More in the online help.
VT_BSTR | TrendText | Curve name | Display if the "Display curve info" option is set. If this property remains empty, the name of the variable is displayed. More in the online help.
VT_BOOL | ViewLimitFromVar | Apply display range from variables | Takes over the display area of the linked variable. You can update this display area during replacement with a variable with a different values range. More in the online help.
VT_R8 | ViewMin | Min. display range | Minimum of the technical display range for the curve (enlarged excerpt). Minimum: Minimum value of the variable. Maximum: Maximum value of the variable. Default: Minimum value of the variable. More in the online help.
VT_R8 | ViewMax | Max. display range | Maximum of the technical display range for the curve (enlarged excerpt). Minimum: Minimum value of the variable. Maximum: Maximum value of the variable. Default: Maximum value of the variable. More in the online help.
ZT_VARIABLE | ProjectVar | ProjectVar | This property returns a variable. It is also possible to link a new variable via this property.
VT_BSTR | SymVarName | SymVarName | This property returns the name of a variable.
VT_BSTR | SymVarTagNr | SymVarTagNr | This property returns the identification of a variable.


Trend curve

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Trend curve

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

Curves

Curves

Properties for the curves of the trend elements.

More in the online help.

VT_BOOL

ThreeDimensional

3D

Active: The element is displayed threedimensionally.
Inactive: The element is displayed flat.

More in the online help.

VT_I2

ScrollWidth

Scroll width [%]

This property defines the percentage by which the curve will be moved on reaching the display limit; values between 0 and 100% are possible.
0%: Remove the oldest entry for each new entry.
50%: In the event of an overrun, delete half of the screen range and continue to write.
100%: In the event of an overrun, delete all of the screen range and start again.
Default: 0.

More in the online help.

VT_UI2

Direction

Direction

This property defines the arrangement of the time axis to be displayed.
Right: oldest on the left, newest on the right.
Left: oldest on the right, newest on the left.
Up: oldest at the bottom, newest at the top.
Down: Oldest at the top, newest at the bottom.
If the axes are displayed, an arrow in the bottom corner of the element shows the direction.
Default: Right.

More in the online help.

VT_BOOL

Area

Display curves as areas

Active: Curves are displayed as function calls.
Inactive: Curves are displayed as lines.
Default: inactive.

More in the online help.

VT_BOOL

NumericalValues

Display values

Active: The values of the last refresh are displayed for all linked variables as figures.
Inactive: The Values are not displayed.
Default: active.

More in the online help.

VT_BOOL

Axes

Display axes

Active: The time and percent axis are displayed.
Inactive: No axes are displayed.
Default: inactive.

More in the online help.

VT_BOOL

Addresses

Display curve info

Active: The name or the amended source text and the measurement range of the linked variables are displayed in a key.
Inactive: No key is shown.
Default: active.

More in the online help.

VT_BOOL

NoInterpolation

Do not interpolate

Active: Values are linked without interpolation in stages.
Inactive: Values are linked with interpolation.
Default: inactive.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_UI4

RefreshHour

Hours

Hours of the updating time.
Minimum: 0.
Maximum: 119304.
Default: 0.

More in the online help.

VT_UI2

RefreshMinute

Min

Minutes of the updating time.
Minimum: 0.
Maximum: 59.
Default: 0.

More in the online help.

VT_UI2

RefreshSecond

Seconds

Seconds of the updating time.
Minimum: 0.
Maximum: 59.
Default: 1.

More in the online help.

VT_UI2

RefreshMilliSecond

Milliseconds

Milliseconds of the updating time.
Minimum: 0.
Maximum: 999.
Default: 0.

More in the online help.

VT_UI4

RepresentationHour

Hours

Hours of the period of representation.
Default: 0.

More in the online help.

VT_UI2

RepresentationMinute

Min

Minutes of the periof of representation.
Minimum: 0.
Maximum: 59.
Default: 0.

More in the online help.

VT_UI2

RepresentationSecond

Seconds

Seconds of the periof of representation.
Minimum: 0.
Maximum: 59.
Default: 0.

More in the online help.

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Clock

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Clock

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

DynEleVar

DynEleVar

"With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX
zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"

ZT_VARIABLE_DYN

Variable

Variable

Name of the linked variable. Click on button ... in order to open the dialog for selecting variables.
The value of this variable is displayed in this element and can also be set here.

Note: Only available for buttons if they are used as a switch.

Hint: If the variable value is to be toggled, we recommend activating the Permanently read variable property. Otherwise Runtime waits until the driver knows the value of the variables. If the value is not available due to a breakdown in communication with the control unit, the waiting time corresponds to the timeout time of the driver.

Only SICAM 230 and Screen Alarm element:
The description above only applies to the elements Text Button, Bitmap Button and Invisible Button.
Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).

  • Lower bit: Alarm active/inactive
  • Higher bit: Alarm acknowledged/not acknowledged

More in the online help.

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_I2

ViewType

Type of display

Absolute time: the time of the system clock is displayed in the chosen format.
Time difference: the value of a linked variable is displayed in the chosen time format.
Default: Absolute time period:

More in the online help.

VT_UI2

Format

Formating

Format of the time/date display.
A formatting string is selected from the list.

More in the online help.

VT_BOOL

TwoLines

Two-lined display

Only available with absolute time:
Aktive: In the simultaneous display of time and date the time is shown in the first line and the date is shown in the second line.
Inactive: Date and time are displayed in a line.
Default: active.

More in the online help.

VT_BSTR

Separator

Separator

Only available with time difference::
Separator for display of time/date.
(e.g. : in 10:15)

More in the online help.

VT_BOOL

ShowUnit

Display measuring unit

Only available:
General: If property Show value has been activated.
For the Clock element: if Time difference was selected in the property Type of display.
For the pointer instrument: if 3D property was activated.

Active: The unit of the linked variable is displayed to the right of the value.
If the value is displayed in percent, the percent character % is displayed instaed of the unit of the linked variable.
Inactive: The technical unit is not displayed.
Default: active.

Note:

More in the online help.

VT_BOOL

ShowState

Display status of variable

Active: The status of the variables is indicated by a colored square at the element.

Color:
red square indicates that there a problems with the communication to the PLC.
Blue square at the client end indicates that the client lost the connection to the server.
Blue square at the station indicates that the value was not initialized.

Position of the square at the element at element form:

Round: top edge, in the middle
rounded: top right corner, slightly offset to the leftangular and all others:

Inactive: The status is not displayed.

More in the online help.

VT_I2

HorizontalAlign

Alignment horizontal

Horizontal alignment of the output in the element for the display. Possible settings via the drop-down list:

centered
- left-adjusted
- right-adjusted

Default: centered

More in the online help.

VT_I2

VerticalAlign

Alignment vertical

Vertical alignment of the output in the element for the display. Possible settings via the drop-down list:

centered
- top
- bottom

Default: Centered

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BOOL

Transparent

Transparent

Active: Deactivates the background color of the element.

The effect of this option on a button is an Invisible button. It can be positioned above other elements as an invisible button.

More in the online help.

VT_BOOL

LimitColor

Use limit color

You can define whether the limit color which has been defined at the variable which is linked with the element should be displayed in the Runtime. Depending on the element the color affects the displayed text or for the universal slider its indicator.

Active: The defined limit color is displayed in the Runtime.

Default: active (in order to ensure compatibility)

More in the online help.

VT_BOOL

IsSetValue

Setting values active

Active: Setting of variables for this dynamic element is allowed.
Inactive: The variable is write-protected in this element.

More in the online help.

VT_BOOL

Preset

propose current value

Active: The current value of the variable is proposed as set value.
In this case, the value is added under "Set value / amend by" before setting the actual value (positive value) or subtracted from this (negative value).
Inactive: The value defined in "Set value / amend" is proposed.

More in the online help.

VT_BOOL

HWDirect

without dialog

Active: The value is sent to the hardware without a possibility to be changed in the Runtime.
Inactive: The user still has the possibility to amend the value in Runtime before writing to the hardware.

More in the online help.

VT_R8

SetValue

Set value / change by

Value that should be sent as the set value or as a default.
If "Propose current value" is active:: Value that is added to the current value.
In combination with the "without dialog" property, such an increment (positive value) or decrement (negative value) can be implemented.

More in the online help.

VT_UI1

SetValueWith

Write set value via

Send value with:
Command Processing: The new value is set using Set value input in the Command Processing.

Standard dialog box: The new value is entered using the standard dialog box. If a screen of type "Keyboard" with name "SETVALUEKBD" (for numeric values) or "SETSTRINGKBD" (for string variables) exists, it is used instead of the standard dialog box.

Element: The new value is directly entered in the element (only for the elements numeric value and text element).

Program: The new value is entered in an external program.

More in the online help.

VT_BSTR

SetProgram

External program

Only available if an external program was selected for Write set value:
The set value is written by an external program that must be selected in the dialog box that appears here.

This program is then started and gets the following parameters:
1) Name of the linked variable
2) Proposed value, as defined in the corresponding properties
3) Left coordinate of the element in pixels
4) Upper coordinate of the element in pixels
5) Right coordinate of the element in pixels
6) Lower coordinate of the element in pixels
7) Permitted minimum for the set value, as defined in the corresponding properties
8) Permitted maximum for the set value, as defined in the corresponding properties

More in the online help.

VT_BOOL

KbdUsage

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

ZT_PICTURE

KbdName

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

VT_BOOL

LimitFromVar

Take set value limits from variable

Active: The limitation of the range for which the set values can be written are not set via “Min” and “Max” but are taken from the variable definitions directly.
Inactive: The range can be limited directly in the "Minimum" and "Maximum".

More in the online help.

VT_R8

Min

Minimum

Only available if "Take set value limits from variable" is not active::
Bottom limit of the permitted range for the set value.

Attention: The value entered here is ignored if a variable is selected for the dynamic set value minimum.

More in the online help.

VT_R8

Max

Maximum

Only available if "Take set value limits from variable" is not active::
Upper limit of the permitted range for the set value.

Attention: The value entered here is ignored if a variable is selected for the dynamic set value maximum.

More in the online help.

VT_UI2

Passwordlevel

Authorization level

Password level for writing set values or executing functions with the selected dynamic element.
Minimum: 0.
Maximum: 127.
Default: 0.

More in the online help.

VT_UI4

Locking

Interlocking

Link to an existing interlocking to this element.

If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.

Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_BOOL

Signature

Signature necessary

Active: A signature is necessary to operate the element.

For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.

Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.

Inactive: No signature is required.

(Default) Inactive:

More in the online help.

VT_BSTR

SignatureText

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties.

More in the online help.

VT_I2

SignatureEditModus

Signature text editable

Defines whether the signature text can be edited. Selection from drop-down list:

  • Apply project settings: The settings of the Signature text editable project property are applicable.
  • Yes: Text can be edited.
  • No: Text cannot be edited.

Default: Apply project settings

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Base class vector elements

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Base class vector elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

ZT_COLOR

LineColor

Line color

Line color of the element.

VT_UI2

Offset_H

Horiz. distance [pixels]

Horizontal distance of the end of the rounding of the actual corner in pixels.

More in the online help.

VT_UI2

Offset_V

Vertical distance [pixels]

Vertical distance of the end of the rounding of the actual corner in pixels.

More in the online help.

VT_UI2

LineWidth

Line width [Pixel]

Width of the line (in pixels).
Minimum: 0
In this case the width of the line is 1 pixel.
Maximum: 40
Default: 1
Attention: If in the project settings in node Graphical design you set property Graphics quality to Windows basis, you can use line width >1 only with a line of type "continuous line".

More in the online help.

ZT_IMAGELIST

LineType

Line type

Selection of the line type for the element from the list.
Attention: If in the project settings in node Graphical design you deactivated property Graphics quality, you can use line width >1 only with a line of type "continuous line".
More in the online help.

ZT_IMAGELIST

LineCapStart

Start type

Only available if you have activated project property Graphics quality.

Defines the symbol for the starting point of the line. Click on the field and a dialog opens to select an element.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

More in the online help.

ZT_IMAGELIST

LineCapEnd

End type

Only available if you have activated project property Graphics quality.

Defines the symbol for the end point of the line. Click on the field and a dialog opens to select an element.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

More in the online help.

VT_R4

LineCapScale

Size

Only available if you have activated project property Graphics quality.

Defines the magnifying factor for the line width of the arrow. The factor relates to the line width of the vector element as defined in the Line width [Pixel] property.

For arc of circle and segment of circle only available if property Filling pattern was set to without.

Value: greater or equal 1

Default: 4

More in the online help.

ZT_IMAGELIST

FillPattern

Filling pattern

Selection of the filling pattern for the element from the list.

This property is only available if property With brightness values is inactive.

More in the online help.

ZT_COLOR

LineColorEx

Line color

Defines the line color of the element. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

AlphaLineColor

Transparency line color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_UI1

AlphaBackColor

Transparency of the fill color [%]

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_COLOR

BackColor2

Gradient color

Only available if for property Filling pattern Color gradient is selected and the project property Graphics quality is active.

Defines the second color for the color gradient. At selecting Automatical the color value changes depending on the value of Fill color.

More in the online help.

VT_UI1

AlphaBackColor2

Transparency gradient color [%]

Only available if Linear was selected in the Filling pattern property.

Only available if the With brightness values property is not active and, for the Graphics quality project property, Windows Basis has not been selected.

Defines the opacity of the color via a value between 0 and 100.

0: opaque

100: completely transparent

All values between this appear transparent according to how they are set.

Default: 0

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable2

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BackColorVariable2Preview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Gradient color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_I2

Lightning

Color gradient

Only available if property Filling pattern was set to Color gradient.

Defines the color gradient for vector elements.

Linear: steady gradient
Defined point: Gradient from a defined point to the edges of the element

Starting from a defined point with beams: Gradient from a defined point to the edges of the element with beams

More in the online help.

VT_I2

Align

Alignment

Direction of color shift.
horizontal
vertical

VT_I2

Shifted

Shifted color gradient

Wie weit soll der Lichteffekt von der Mitte des Elements versetzt sein.

Mehr im Online-Handbuch

VT_I2

ColorGradientOffset

Offset [%]

Only available if at a vector element the property Color gradient or at the dynamic element Button property Filling was set. linear or Starting from a defined point or Starting from a defined point with beams.

Defines the distance of the starting point for the color gradient from the center of the element. This is a percentage.

Values: 0 equals the center of the element. 100 the edge.
Note: The value can also be outside of the element and is therefore not limited to 100.

More in the online help.

VT_I2

ColorGradientAngle

Angle [°]

Defines the direction of the color gradient starting in the center of the element.

Values: 0° to 360°.

Default: 0°

More in the online help.

VT_BOOL

Brightness

With brightness values

Only available if Filling pattern was selected as color gradient was selected.

Active: The brightness of the color gradient can be freely defined.
Inactive: The brightness of the color gradient is defined automatically.

Note: The filling pattern can no longer be changed if this property is active. It is also not possible to set rounded corners. If this option is activated for an element that uses rounded corners, the element is displayed with non-rounded corners.

More in the online help.

VT_UI1

OuterBrightness

Brightness outside

Only available if "via brightness value" is active:
Brightness at the outer side of the element.

More in the online help.

VT_UI1

InnerBrightness

Brightness inside

Only available if "via brightness value" is active:
Brightness in the middle of the element.

More in the online help.

VT_BOOL

ALCUseColor

Color from ALC

Only available if you have licensed Automatic Line Coloring (ALC):
Active: The automatic color of the linked source(s) is used.
Inactive: The standard color is used.
Default: inactive.

More in the online help.

VT_I2

ALCPrecedence

Priority for display

Only available if the Color from ALC property is active.

Defines the priority of the display when the element is connected to several active sources.
Multiple supply: The element is displayed according to the rules of the multiple supply.
secured supply: The element is displayed according to the rules of the secured supply.
No priority: The coloring rules for multiple supply and for secured supply are applied at the same time if both criteria are met.

Default: Multiple supply
More in the online help.

VT_I2

ALCMultiSource

display multiple supplies

Only available if the property Color from ALC is active.
Defines the display type if the element is connected to several sources:
most prior source: Only the color of the source with the highest priority is used.
two most prior source The different colors of the two sources with the highest priority are displayed as a dashed line.
alternative color: Alternative color for the coloring at multiple supply.

Default: highest priority source

More in the online help

VT_I2

ALCDashLen

Dashing length supplied multiple times

Only available if property display multiple supplies has value two highest prior sources.

Defines the dash length in pixel for the dashed ALC coloring at multiply supply.

Minimal: 0 (automatic dash length)

Maximum: 32767

Default: 0

More in the online help.

ZT_COLOR

ALCAlternativeColor

Alternative color

Only available if property display multiple supplies has value alternative color.

Alternative color for the ALC coloring at multiple supply.

More in the online help.

VT_I2

ALCMSecuredSupply

display secured supply

Only available if Color from ALC was activated.

Definition of the display of the secured supply:

  • double width
  • double brightness
  • normal

Default: normal

More in the online help

VT_BOOL

ALCAlias

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

ALCAliasName

Alias

Only available if property Color from ALC is active.

Defined source element for property Use alias. Click on button ... in order to open the dialog for selecting an existing element.
Note: Aliases cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_R8

ALCReact

Reactance value of the cable [Ohm]

Maximum permitted reactance value of the line in ohms.

More in the online help.

VT_R8

ALCResist

Resistance value of the electric line [Ohm]

Maximum permitted resistance value of the line in ohms.

More in the online help.

VT_R8

ALCLength

Length of the line [km]

ALC line: Length of the line.

More in the online help.

VT_I2

ALCMaxIType

Limit current carrying capacity

ALC switch: Limit value of current capacity [selection of fixed/variable].

More in the online help.

VT_R8

ALCMaxIVal

Limit fixed current carrying capacity [A]

ALC switch: Limit fixed current carrying capacity.

More in the online help.

ZT_VARIABLE_DYN

ALCVarMaxI

Limit variable current carrying capacity

More...

ALCVarMaxIEx

ALCVarMaxIEx

ZT_VARIABLE_DYN

ALCVarCalcI

Measuring value of the calculated current flow

ALC line: Measuring value of the calculated current flow.

More in the online help.

More...

ALCVarCalcIEx

ALCVarCalcIEx

ALC Leitung: Messwert des berechneten Stromflusses für Export.

Mehr in der Online-Hilfe.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Invisible button

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Invisible button

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

DynEleVar

DynEleVar

"With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX
zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"

More...

DynEleFkt

DynEleFkt

ZT_VARIABLE_DYN

Variable

Variable

Name of the linked variable. Click on button ... in order to open the dialog for selecting variables.
The value of this variable is displayed in this element and can also be set here.

Note: Only available for buttons if they are used as a switch.

Hint: If the variable value is to be toggled, we recommend activating the Permanently read variable property. Otherwise Runtime waits until the driver knows the value of the variables. If the value is not available due to a breakdown in communication with the control unit, the waiting time corresponds to the timeout time of the driver.

Only SICAM 230 and Screen Alarm element:
The description above only applies to the elements Text Button, Bitmap Button and Invisible Button.
Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).

  • Lower bit: Alarm active/inactive
  • Higher bit: Alarm acknowledged/not acknowledged

More in the online help.

ZT_FUNCTION_DYN

Function

Function

Name of the linked function.
Opens the function selection dialog.
This function will be executed when the button is clicked in the Runtime or when the assigned key shortcut is pressed.
If you wish to execute more than one function, you need to create a script with the required functions and specify the function for executing that script here.

SICAM 230 and screen alarming element only:

In addition to the standard screen switch property, the screen whose alarm states are supposed to be displayed will be determined by the linked function.
Obligatory (unless the Global setting is active)!

More in the online help.

VT_BSTR

FunctionParameter

Parameter for substitution

Entry of the character sequence for substitution via parameters. Replaces the key word {PARAM} in the substitution dialog of the screen switching.

Note: Avoid character sequences that are also used for parameter of the indexing variables, such as {X01}.

More in the online help.

ZT_MDIFUNKTION

MDIFunction

Screen type specific function

Only available in screens with a special screen type (screen type is not standard):
Linking to a screen-specific function. Clicking on the ... button opens the dialog for selecting a screen-specific function. This function is executed if the button is clicked with the mouse in Runtime or the linked key combination is pressed.

Attention: In addition to a screen-type specific function, it is also possible to link a general function with the button. In this case, note the sequence of execution when clicking on the button: The screen-type-specific function is executed first. Only once this has been ended is the general function executed. If VBA events are linked to the button in Runtime, these are executed before the functions.

More in the online help.

VT_BOOL

FktOnDown

Function execution on pressing

Active: The linked function is executed when the element is pressed.
Inactive: The linked function is executed when the element is released.
Default: inactive.

More in the online help.

VT_BOOL

Switch

Switch

Only available if property Setting values active is inactive.

Active: The element switches the value of a bit variable.
Inactive: The element carries out a function.
Default: inactive.

More in the online help.

VT_BOOL

Scanner

Momentary switch

Only available if property Switch is active. (Exception: always available in the switch dynamic element.)
Active: The target state - defined in property Momentary switch On - is only held as long as the left mouse button is pressed but at least as long as Holding time [ms].
Inactive: The target state remains even after the mouse button is released.
Default: inactive.

More in the online help.

VT_BOOL

ScannerOn

Momentary switch On

Only available if Momentary switch is active.
Active: Switch switches to ON.
Inactive: Switch switches to OFF.
Default: Inactive.

More in the online help.

VT_BOOL

ResetOnLeave

Reset on exit

Only available if property Momentary switch is active.
If you press and hold the mouse button and move the mouse pointer away from the button, this will automatically reset the value of the variable.

More in the online help

VT_BOOL

FastReaction

Fast reaction

Only available if Switch is active.
Active: The switch immediately changes its position in Runtime, regardless of whether the linked bit has actually been set in the PLC. In the next driver update cycle, the bit will be read from the PLC. Then the switch again ressembles the correct position of the bit in the PLC.
Attention: The switch will only be visibly operable after the value has been read from the PLC.

Inactive: The switch will change its position only after the bit has been sent to the PLC and then again read from the PLC.

(Default) Inactive:

More in the online help.

VT_UI2

ReactionTime

Holding time [ms]

Only available if Switch is active.
If Momentary switch is active: Time (in ms) which a state is held starting from the left click on the respective element.

If property Momentary switch is inactive: Delayed reaction to a left click.

More in the online help.

VT_BOOL

StayPressed

Keep pushed state

Only available if properties Switch, Momentary switch and Fast reaction are active.

Active: As long as you hold the mouse button pressed on this element, its graphical display does not change - independent of possible values changes in the PLC. At the element Switch property 3D must be active in order for this to happen.
Inactive: The element always displays the value of the variable from the PLC.

More in the online help.

VT_UI2

Passwordlevel

Authorization level

Password level for writing set values or executing functions with the selected dynamic element.
Minimum: 0.
Maximum: 127.
Default: 0.

More in the online help.

VT_UI4

Locking

Interlocking

Link to an existing interlocking to this element.

If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.

Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

ZT_SHORTCUT

ShortCut

Key combination

Shortcuts support executing operable elements. For example:

- Executing control elements and functions which have an element assigned
- Write set value (e.g. for switches)
- Set focus for certain windows (e.g. curve list in the Extended Trend or combobox in the RGM)

A click on the input field button opens the dialog for defining key combinations. In the dialog enter the desired combination directly.

More in the online help.

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_BOOL

Signature

Signature necessary

Active: A signature is necessary to operate the element.

For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.

Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.

Inactive: No signature is required.

(Default) Inactive:

More in the online help.

VT_BSTR

SignatureText

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties.

More in the online help.

VT_I2

SignatureEditModus

Signature text editable

Defines whether the signature text can be edited. Selection from drop-down list:

  • Apply project settings: The settings of the Signature text editable project property are applicable.
  • Yes: Text can be edited.
  • No: Text cannot be edited.

Default: Apply project settings

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


CWPFConnectionBase

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> CWPFConnectionBase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Element | Element name |
VT_BSTR | Link | Element name |


WPF element

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> WPF element

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

Links

Links

ZT_FILE

FileName

XAML file

Selection of the XAML file for the WPF element. Click on ... Opens the dialog for selection. The file must already have been created in the project manager under File/Graphics or selected in the dialog with the help of the symbol Add file.

More in the online help.

VT_BSTR

LinksConfig

Configuration

Opens the dialog for configuring the XAML file. Properties, events, transformations and authorizations can be allocated.

More in the online help.

VT_UI2

Passwordlevel

Authorization level

Password level for writing set values or executing functions with the selected dynamic element.
Minimum: 0.
Maximum: 127.
Default: 0.

More in the online help.

VT_UI4

Locking

Interlocking

Link to an existing interlocking to this element.

If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.

Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Numerical value

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Numerical value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

DynEleVar

DynEleVar

"With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX
zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_UI2

Frame

Element border

Drop-down list for the selection of the frame type. Available are:

Thin frame

3D

Default: Thin border

More in the online help.

VT_BOOL

ShowState

Display status of variable

Active: The status of the variables is indicated by a colored square at the element.

Color:
red square indicates that there a problems with the communication to the PLC.
Blue square at the client end indicates that the client lost the connection to the server.
Blue square at the station indicates that the value was not initialized.

Position of the square at the element at element form:

Round: top edge, in the middle
rounded: top right corner, slightly offset to the leftangular and all others:

Inactive: The status is not displayed.

More in the online help.

VT_BOOL

ShowUnit

Display measuring unit

Only available:
General: If property Show value has been activated.
For the Clock element: if Time difference was selected in the property Type of display.
For the pointer instrument: if 3D property was activated.

Active: The unit of the linked variable is displayed to the right of the value.
If the value is displayed in percent, the percent character % is displayed instaed of the unit of the linked variable.
Inactive: The technical unit is not displayed.
Default: active.

Note:

More in the online help.

VT_UI2

UnitPos

Unit position [%]

Only available if property Display measuring unit is active.

Positions the display of the unit and makes it possible to adjust units with different widths to values which are listed one under the other. For positioning enter a percentage between 0 and 100.

The unit is always displayed to the right of the defined position. The corresponding value to the left depends on the set alignment.

Default: 0 - means no percentage alignment. Value and unit are always displayed together.

More in the online help.

VT_BOOL

Percentage

Display value in percent

Active: The value of the variable is displayed as 0-100%.
0% = minimum measurement range
100% = maximum measurement range
The conversion is linear. Setpoint inputs are also entered in percent.
Inactive: The value is displayed as usual.
Default: inactive.

More in the online help.

VT_BOOL

Absolute

Absolute amount

For element Numeric value only available if property Display value in percent is inactive.

Active: Unsigned display of the variable value (-200 = 200).
Inactive: Normal display of the value.
Default: inactive.

Note: In this case, the set value is entered in percent.

More in the online help

VT_UI2

ValueBase

Base for display

Set the base of the numbering for the display of the values. The following bases are available:

  • Binary: Binary display. This format is indicated with a "b" to the right of the value.
  • Decimal: Decimal display.
  • Exponential: Decimal display in exponential notation. Example: 1E+03 equals 1000 in decimal notation.
  • Hexadecimal: Hexadecimal display. This format is indicated with a "b" to the right of the value.
  • Octal: Octal display. This format is indicated with an "o" to the right of the value.

Default: Decimal.

More in the online help.

VT_BOOL

ShowValueBasis

Display base

Only available if you selected binary, hexadecimal or octal at property Base for display.

Shows an abbreviation of the base behind the value:

The following abbreviations are used:

- for binary: b

- for decimal: no abbreviation

- for decimal exponential: no abbreviation

- for hexadecimal: h

- for octal: o

Default: Active

More in the online help.

VT_BOOL

ShowLeadingZeros

Show leading zeros

Only available if you selected binary, decimal, hexadecimal or octal at property Base for display.

Decide whether you want to display leading zeros when displaying the numeric values.

  • Inactive: Leading zeros are suppressed.
  • Active: The numeric values are displayed with a different number of digits in accordance with their base. The digits which are not used by the numeric value are filled up with leading zeros.

Default: inactive

The following parameters are available for the different bases:

  • Binary: 32 digits
  • Decimal: 10 digits
  • Hexadecimal: 8 digits
  • Octal: 11 digits

More in the online help.

VT_I2

HorizontalAlign

Alignment horizontal

Horizontal alignment of the output in the element for the display. Possible settings via the drop-down list:

centered
- left-adjusted
- right-adjusted

Default: centered

More in the online help.

VT_I2

VerticalAlign

Alignment vertical

Vertical alignment of the output in the element for the display. Possible settings via the drop-down list:

centered
- top
- bottom

Default: Centered

More in the online help.

ZT_VARIABLE_DYN

Variable

Variable

Name of the linked variable. Click on button ... in order to open the dialog for selecting variables.
The value of this variable is displayed in this element and can also be set here.

Note: Only available for buttons if they are used as a switch.

Hint: If the variable value is to be toggled, we recommend activating the Permanently read variable property. Otherwise Runtime waits until the driver knows the value of the variables. If the value is not available due to a breakdown in communication with the control unit, the waiting time corresponds to the timeout time of the driver.

Only SICAM 230 and Screen Alarm element:
The description above only applies to the elements Text Button, Bitmap Button and Invisible Button.
Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).

  • Lower bit: Alarm active/inactive
  • Higher bit: Alarm acknowledged/not acknowledged

More in the online help.

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BOOL

Transparent

Transparent

Active: Deactivates the background color of the element.

The effect of this option on a button is an Invisible button. It can be positioned above other elements as an invisible button.

More in the online help.

VT_BOOL

LimitColor

Use limit color

You can define whether the limit color which has been defined at the variable which is linked with the element should be displayed in the Runtime. Depending on the element the color affects the displayed text or for the universal slider its indicator.

Active: The defined limit color is displayed in the Runtime.

Default: active (in order to ensure compatibility)

More in the online help.

VT_BOOL

IsSetValue

Setting values active

Active: Setting of variables for this dynamic element is allowed.
Inactive: The variable is write-protected in this element.

More in the online help.

VT_BOOL

Preset

propose current value

Active: The current value of the variable is proposed as set value.
In this case, the value is added under "Set value / amend by" before setting the actual value (positive value) or subtracted from this (negative value).
Inactive: The value defined in "Set value / amend" is proposed.

More in the online help.

VT_BOOL

HWDirect

without dialog

Active: The value is sent to the hardware without a possibility to be changed in the Runtime.
Inactive: The user still has the possibility to amend the value in Runtime before writing to the hardware.

More in the online help.

VT_R8

SetValue

Set value / change by

Value that should be sent as the set value or as a default.
If "Propose current value" is active:: Value that is added to the current value.
In combination with the "without dialog" property, such an increment (positive value) or decrement (negative value) can be implemented.

More in the online help.

VT_UI1

SetValueWith

Write set value via

Send value with:
Command Processing: The new value is set using Set value input in the Command Processing.

Standard dialog box: The new value is entered using the standard dialog box. If a screen of type "Keyboard" with name "SETVALUEKBD" (for numeric values) or "SETSTRINGKBD" (for string variables) exists, it is used instead of the standard dialog box.

Element: The new value is directly entered in the element (only for the elements numeric value and text element).

Program: The new value is entered in an external program.

More in the online help.

VT_BSTR

SetProgram

External program

Only available if an external program was selected for Write set value:
The set value is written by an external program that must be selected in the dialog box that appears here.

This program is then started and gets the following parameters:
1) Name of the linked variable
2) Proposed value, as defined in the corresponding properties
3) Left coordinate of the element in pixels
4) Upper coordinate of the element in pixels
5) Right coordinate of the element in pixels
6) Lower coordinate of the element in pixels
7) Permitted minimum for the set value, as defined in the corresponding properties
8) Permitted maximum for the set value, as defined in the corresponding properties

More in the online help.

VT_BOOL

KbdUsage

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

ZT_PICTURE

KbdName

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

VT_BOOL

LimitFromVar

Take set value limits from variable

Active: The limitation of the range for which the set values can be written are not set via “Min” and “Max” but are taken from the variable definitions directly.
Inactive: The range can be limited directly in the "Minimum" and "Maximum".

More in the online help.

VT_R8

Min

Minimum

Only available if "Take set value limits from variable" is not active::
Bottom limit of the permitted range for the set value.

Attention: The value entered here is ignored if a variable is selected for the dynamic set value minimum.

More in the online help.

VT_R8

Max

Maximum

Only available if "Take set value limits from variable" is not active::
Upper limit of the permitted range for the set value.

Attention: The value entered here is ignored if a variable is selected for the dynamic set value maximum.

More in the online help.

VT_UI2

Passwordlevel

Authorization level

Password level for writing set values or executing functions with the selected dynamic element.
Minimum: 0.
Maximum: 127.
Default: 0.

More in the online help.

VT_UI4

Locking

Interlocking

Link to an existing interlocking to this element.

If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.

Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_BOOL

Signature

Signature necessary

Active: A signature is necessary to operate the element.

For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.

Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.

Inactive: No signature is required.

(Default) Inactive:

More in the online help.

VT_BSTR

SignatureText

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties.

More in the online help.

VT_I2

SignatureEditModus

Signature text editable

Defines whether the signature text can be edited. Selection from drop-down list:

  • Apply project settings: The settings of the Signature text editable project property are applicable.
  • Yes: Text can be edited.
  • No: Text cannot be edited.

Default: Apply project settings

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Indicating instrument

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Indicating instrument

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

DynEleVar

DynEleVar

"With this property you have the opportunity to get informations about the variable (projected via ""Variable assignment"" in the ActiveX selection dialog) which is linked at an ActiveX element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""DynEleVar.SymVarName"") 'Return the name of the variable which is assigned to the ActiveX
zElement.DynProperties (""DynEleVar.SymVarTagNr"") 'Return the identification of the variable which is assigned to the ActiveX"

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

VT_BOOL

ThreeDimensional

3D

Active: The element is displayed threedimensionally.
Inactive: The element is displayed flat.

More in the online help.

VT_BOOL

ShowUnit

Display measuring unit

Only available:
General: If property Show value has been activated.
For the Clock element: if Time difference was selected in the property Type of display.
For the pointer instrument: if 3D property was activated.

Active: The unit of the linked variable is displayed to the right of the value.
If the value is displayed in percent, the percent character % is displayed instaed of the unit of the linked variable.
Inactive: The technical unit is not displayed.
Default: active.

Note:

More in the online help.

VT_BOOL

ShowState

Display status of variable

Active: The status of the variables is indicated by a colored square at the element.

Color:
red square indicates that there a problems with the communication to the PLC.
Blue square at the client end indicates that the client lost the connection to the server.
Blue square at the station indicates that the value was not initialized.

Position of the square at the element at element form:

Round: top edge, in the middle
rounded: top right corner, slightly offset to the leftangular and all others:

Inactive: The status is not displayed.

More in the online help.

VT_BOOL

Ribbon

Ribbon

Only available if property Arc of a circle is inactive.

Not available for Windows CE.

  • Active: The value is displayed via a bar from minimal value up to the current value.
  • Inactive: No bar is displayed.

More in the online help

VT_BOOL

Pie

Arc of a circle

Only available if property Ribbon is inactive.

  • Active: The value is displayed by means of a graduated circle from the minimum value up to the current value.
  • Inactive: No graduated circle is displayed.

More in the online help.

VT_BOOL

Explicit

Explicit

This property affects only the display of values with defined limits from variables. Limits from reaction matrices are not considered.

  • Active: If a limit value of the linked variable is breached, only the part of the display that goes into the limit value breach is shown in the color of the respective limit value.
    If the variable has several defined limit values, the corresponding areas of the display are each shown in the color of the limit value.
  • Inactive: If a limit of the linked variable is violated, the complete display is displayed in the color of the violated limit.

Default: inactive

Note: Only available at element Pointer instrument if the display is activated as Ribbon or Arc of a circle.

More in the online help.

VT_BOOL

Percentage

Percent display

Active: The value of the variable is displayed as 0-100%.
0% = minimum measurement range
100% = maximum measurement range
The conversion is linear. Setpoint inputs are also entered in percent.
Inactive: The value is displayed as usual.
Default: inactive.

More in the online help.

VT_UI2

StartAngle

Start angle

Definition of the initial angle (0°=bottom, continues further clockwise)

More in the online help.

VT_UI2

OpeningAngle

Opening angle

Opening angle of the travel of pointer (max. 360° - start angle).

More in the online help.

VT_UI2

ValueBase

Base for display

Set the base of the numbering for the display of the values. The following bases are available:

  • Binary: Binary display. This format is indicated with a "b" to the right of the value.
  • Decimal: Decimal display.
  • Exponential: Decimal display in exponential notation. Example: 1E+03 equals 1000 in decimal notation.
  • Hexadecimal: Hexadecimal display. This format is indicated with a "b" to the right of the value.
  • Octal: Octal display. This format is indicated with an "o" to the right of the value.

Default: Decimal.

More in the online help.

VT_BOOL

ShowValueBasis

Display base

Only available if you selected binary, hexadecimal or octal at property Base for display.

Shows an abbreviation of the base behind the value:

The following abbreviations are used:

- for binary: b

- for decimal: no abbreviation

- for decimal exponential: no abbreviation

- for hexadecimal: h

- for octal: o

Default: Active

More in the online help.

VT_BOOL

ShowLeadingZeros

Show leading zeros

Only available if you selected binary, decimal, hexadecimal or octal at property Base for display.

Decide whether you want to display leading zeros when displaying the numeric values.

  • Inactive: Leading zeros are suppressed.
  • Active: The numeric values are displayed with a different number of digits in accordance with their base. The digits which are not used by the numeric value are filled up with leading zeros.

Default: inactive

The following parameters are available for the different bases:

  • Binary: 32 digits
  • Decimal: 10 digits
  • Hexadecimal: 8 digits
  • Octal: 11 digits

More in the online help.

ZT_VARIABLE_DYN

Variable

Variable

Name of the linked variable. Click on button ... in order to open the dialog for selecting variables.
The value of this variable is displayed in this element and can also be set here.

Note: Only available for buttons if they are used as a switch.

Hint: If the variable value is to be toggled, we recommend activating the Permanently read variable property. Otherwise Runtime waits until the driver knows the value of the variables. If the value is not available due to a breakdown in communication with the control unit, the waiting time corresponds to the timeout time of the driver.

Only SICAM 230 and Screen Alarm element:
The description above only applies to the elements Text Button, Bitmap Button and Invisible Button.
Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).

  • Lower bit: Alarm active/inactive
  • Higher bit: Alarm acknowledged/not acknowledged

More in the online help.

VT_R8

ViewMin

Minimum

Lowest variable value that is to be displayed in the element.

More in the online help.

VT_R8

ViewMax

Maximum

Highest variable value that is to be displayed in the element.

More in the online help.

VT_R8

MainTicks

Main ticks

Defines main ticks of the scale.
Value defines the distance between the main ticks. Value must be larger or equal to the value of property Sub ticks. If it is the same value, no Sub ticks are displayed.

More in the online help

VT_R8

SmallTicks

Sub ticks

Defines the division of the scale between Main ticks.

Value defines the distance between the subsidiary ticks. Value must be smaller or equal to the value of property Main ticks. If it is the same value, no subsidiary ticks are displayed.

More in the online help

ZT_COLOR

TextColor

Text color

Text color of the element.

More in the online help.

ZT_COLOR

BackColor

Fill color

Only available if property Transparent is inactive.

Defines the fill color of the element. By clicking on the button, you open the palette of the pre-defined colors. Or enter the color as hex code (RGB) manually in the field. The fill color can be changed dynamically with the help of the property Fill color from group Colors dynamic.

Note: As color for a newly created element the color which was used for the previous element of the same type is used.

Attention: In the Worldview overview window color changes in the Editor have no effect in the Runtime.

More in the online help.

VT_BOOL

LimitColor

Use limit color

You can define whether the limit color which has been defined at the variable which is linked with the element should be displayed in the Runtime. Depending on the element the color affects the displayed text or for the universal slider its indicator.

Active: The defined limit color is displayed in the Runtime.

Default: active (in order to ensure compatibility)

More in the online help.

VT_BOOL

IsSetValue

Setting values active

Active: Setting of variables for this dynamic element is allowed.
Inactive: The variable is write-protected in this element.

More in the online help.

VT_BOOL

Preset

propose current value

Active: The current value of the variable is proposed as set value.
In this case, the value is added under "Set value / amend by" before setting the actual value (positive value) or subtracted from this (negative value).
Inactive: The value defined in "Set value / amend" is proposed.

More in the online help.

VT_BOOL

HWDirect

without dialog

Active: The value is sent to the hardware without a possibility to be changed in the Runtime.
Inactive: The user still has the possibility to amend the value in Runtime before writing to the hardware.

More in the online help.

VT_R8

SetValue

Set value / change by

Value that should be sent as the set value or as a default.
If "Propose current value" is active:: Value that is added to the current value.
In combination with the "without dialog" property, such an increment (positive value) or decrement (negative value) can be implemented.

More in the online help.

VT_UI1

SetValueWith

Write set value via

Send value with:
Command Processing: The new value is set using Set value input in the Command Processing.

Standard dialog box: The new value is entered using the standard dialog box. If a screen of type "Keyboard" with name "SETVALUEKBD" (for numeric values) or "SETSTRINGKBD" (for string variables) exists, it is used instead of the standard dialog box.

Element: The new value is directly entered in the element (only for the elements numeric value and text element).

Program: The new value is entered in an external program.

More in the online help.

VT_BSTR

SetProgram

External program

Only available if an external program was selected for Write set value:
The set value is written by an external program that must be selected in the dialog box that appears here.

This program is then started and gets the following parameters:
1) Name of the linked variable
2) Proposed value, as defined in the corresponding properties
3) Left coordinate of the element in pixels
4) Upper coordinate of the element in pixels
5) Right coordinate of the element in pixels
6) Lower coordinate of the element in pixels
7) Permitted minimum for the set value, as defined in the corresponding properties
8) Permitted maximum for the set value, as defined in the corresponding properties

More in the online help.

VT_BOOL

KbdUsage

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

ZT_PICTURE

KbdName

Screen Keyboard

Name of the linked keyboard screen.
Only available if a keyboard screen is used:

If no keyboard screen was entered here, SETSTRINGKBD appears for string variables, SETVALUEKBD for numeric values (no bit variables), or SETBOOLKBD for bit variables.

More in the online help.

VT_BOOL

LimitFromVar

Take set value limits from variable

Active: The limitation of the range for which the set values can be written are not set via “Min” and “Max” but are taken from the variable definitions directly.
Inactive: The range can be limited directly in the "Minimum" and "Maximum".

More in the online help.

VT_R8

Min

Minimum

Only available if "Take set value limits from variable" is not active::
Bottom limit of the permitted range for the set value.

Attention: The value entered here is ignored if a variable is selected for the dynamic set value minimum.

More in the online help.

VT_R8

Max

Maximum

Only available if "Take set value limits from variable" is not active::
Upper limit of the permitted range for the set value.

Attention: The value entered here is ignored if a variable is selected for the dynamic set value maximum.

More in the online help.

VT_UI2

Passwordlevel

Authorization level

Password level for writing set values or executing functions with the selected dynamic element.
Minimum: 0.
Maximum: 127.
Default: 0.

More in the online help.

VT_UI4

Locking

Interlocking

Link to an existing interlocking to this element.

If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible. If defined in the project properties, a lock symbol is displayed as long as the interlock is active.

Note: Interlockings cannot be used for symbols in the general symbol library or the symbol library in the global project.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_BOOL

Signature

Signature necessary

Active: A signature is necessary to operate the element.

For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.

Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.

Inactive: No signature is required.

(Default) Inactive:

More in the online help.

VT_BSTR

SignatureText

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties.

More in the online help.

VT_I2

SignatureEditModus

Signature text editable

Defines whether the signature text can be edited. Selection from drop-down list:

  • Apply project settings: The settings of the Signature text editable project property are applicable.
  • Yes: Text can be edited.
  • No: Text cannot be edited.

Default: Apply project settings

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Topological wire

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Topological wire

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

RTInvisible

invisible in Runtime

VT_BOOL

OBJNameLink

Object name as link

Object name as link

VT_UI4

DisplayMode

Display mode

Mode display

VT_UI4

BrokenLine1

Broken line color 1

Broken line color 1

VT_UI4

BrokenLine2

Broken line color 2

Broken line color 2

VT_UI4

LineWidth

Line width

Line width

VT_UI4

LineWidthFGES

Line width Protected

Line width Protected

VT_UI4

SaumWidth

Edge width

Edge width

VT_UI2

SymbolF1

Symbol F1

Symbol F1

VT_UI4

SymbolF1_Mode

Symbol F1 colors

Symbol F1 colors

VT_UI2

SymbolF2

Symbol F2

Symbol F2

VT_UI4

SymbolF2_Mode

Symbol F2 colors

Symbol F2 colors

VT_UI2

SymbolFGES

Symbol FGES

Symbol FGES

VT_UI4

SymbolFGES_Mode

Symbol FGES colors

Symbol FGES colors

VT_I2

NCType

Type

ZT_VARIABLE_DYN

NCMappingVarOut

NCMappingVarOutEx

Description

More...

NCMappingVarOutEx

NCMappingVarOutEx

Description

ZT_VARIABLE_DYN

NCMappingVarIn

NCMappingVarInEx

Description

More...

NCMappingVarInEx

NCMappingVarInEx

Description

ZT_VARIABLE_DYN

NCCurrentVar

NCCurrentVarEx

More...

NCCurrentVarEx

NCCurrentVarEx

ZT_VARIABLE_DYN

NCVoltageVar

NCVoltageVarEx

More...

NCVoltageVarEx

NCVoltageVarEx

VT_R4

NCCurrentVal

Load [A]

VT_R4

NCVoltageVal

Voltage level [V]

VT_R4

NCCurrentMax

Max. allocatable load

Maximal load which can be assigned.

VT_I2

NCCableType

Cable type

VT_R4

NCCLength

Length [m]

VT_R4

NCCReactance

Reactance [Ohm]

VT_R4

NCCResistance

Resistance [Ohm]

VT_R4

NCCCurrentMax

Current carrying capacity [A]

VT_BSTR

Coordinates

Coordinates

"With this property you can get/set the coordinates of the element via a string.
zElement.DynProperties(""Coordinates"") = ""197/118;260/200"""

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_BOOL

Signature

Signature necessary

Active: A signature is necessary to operate the element.

For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.

Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.

Inactive: No signature is required.

(Default) Inactive:

More in the online help.

VT_BSTR

SignatureText

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties.

More in the online help.

VT_I2

SignatureEditModus

Signature text editable

Defines whether the signature text can be edited. Selection from drop-down list:

  • Apply project settings: The settings of the Signature text editable project property are applicable.
  • Yes: Text can be edited.
  • No: Text cannot be edited.

Default: Apply project settings

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Topological line

Manual -> Programming interfaces -> Objectmodel -> Element -> Element-Dynamic properties -> Topological line

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_UI4

BrokenLine1

Broken line color 1

Broken line color 1

VT_UI4

BrokenLine2

Broken line color 2

Broken line color 2

VT_UI4

LineWidth

Line width

Line width

VT_UI4

DisplayMode

Display mode

Mode display

VT_UI4

LineWidthFGES

Line width Protected

Line width Protected

VT_UI4

SaumWidth

Edge width

Edge width

ZT_VARIABLE_DYN

Variable_SS_1_1

Variable SS_1_1

Variable SS_1_1

ZT_VARIABLE_DYN

Variable_SS_1_2

Variable SS_1_2

Variable SS_1_2

ZT_VARIABLE_DYN

Variable_SS_1_3

Variable SS_1_4

Variable SS_1_4

ZT_VARIABLE_DYN

Variable_SS_1_4

Variable SS_1_4

Variable SS_1_4

ZT_VARIABLE_DYN

Variable_Start1

Variable Start1

Variable Start1

ZT_VARIABLE_DYN

VariableStandardIsolatingPoint

Variable standard dividing point

Variable standard dividing point

ZT_VARIABLE_DYN

Variable_Start2

Variable Start2

Variable Start2

ZT_VARIABLE_DYN

Variable_SS_2_1

Variable SS_2_1

Variable SS_2_1

ZT_VARIABLE_DYN

Variable_SS_2_2

Variable SS_2_2

Variable SS_2_2

ZT_VARIABLE_DYN

Variable_SS_2_3

Variable SS_2_3

Variable SS_2_3

ZT_VARIABLE_DYN

Variable_SS_2_4

Variable SS_2_4

Variable SS_2_4

VT_BSTR

DistributionLineCharacter

Sign split elsewhere

Sign split elsewhere

ZT_SCHRIFT

Font

Font

Selection of the font with which the display happens.

More in the online help.

ZT_VARIABLE_DYN

Variable

Variable

Name of the linked variable. Click on button ... in order to open the dialog for selecting variables.
The value of this variable is displayed in this element and can also be set here.

Note: Only available for buttons if they are used as a switch.

Hint: If the variable value is to be toggled, we recommend activating the Permanently read variable property. Otherwise Runtime waits until the driver knows the value of the variables. If the value is not available due to a breakdown in communication with the control unit, the waiting time corresponds to the timeout time of the driver.

Only SICAM 230 and Screen Alarm element:
The description above only applies to the elements Text Button, Bitmap Button and Invisible Button.
Significance in SICAM 230: The states of the alarm/event classes will be mapped onto the selected variable (32 bit). For every class, 2 bits will be used (by class number in ascending order).

  • Lower bit: Alarm active/inactive
  • Higher bit: Alarm acknowledged/not acknowledged

More in the online help.

VT_BSTR

Coordinates

Coordinates

"With this property you can get/set the coordinates of the element via a string.
zElement.DynProperties(""Coordinates"") = ""197/118;260/200"""

VT_BSTR

ExtraPoints

Sign split (several times)

Sign (several times) interrupted

VT_BOOL

UnderCE

Visible under WinCE

Controls the visibility of elements in screens under Windows CE. Projects which are used under CE and on the PC can be created more flexible; the user handling is improved. For example buttons can be made invisible which lead to screens which cannot be displayed under CE (e.g. IPA).

Active: The screen/element is also visible under Windows CE.

Default: active

More in the online help.

ZT_VBAMAKRO

Init

Init

VBA macro that is to be executed when initializing the element.

More in the online help.

ZT_VBAMAKRO

SetFocus

SetFocus

VBA macro that is to be executed when the element is in focus.

More in the online help.

ZT_VBAMAKRO

KillFocus

KillFocus

VBA macro that is to be executed when the element is no longer in focus.

More in the online help.

ZT_VBAMAKRO

LeftClickDown

LeftClickDown

VBA macro that is to be executed when pressing the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightClickDown

RightClickDown

VBA macro that is to be executed when pressing the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

LeftClickUp

LeftClickUp

VBA macro that is to be executed when releasing the left mouse button from the element.

More in the online help.

ZT_VBAMAKRO

RightClickUp

RightClickUp

VBA macro that is to be executed when releasing the right mouse button from the element.

More in the online help.

ZT_VBAMAKRO

LeftDClick

LeftDoubleClick

VBA macro that is to be executed when double clicking the left mouse button on the element.

More in the online help.

ZT_VBAMAKRO

RightDClick

RightDoubleClick

VBA macro that is to be executed when double clicking the right mouse button on the element.

More in the online help.

ZT_VBAMAKRO

MouseOver

MouseOver

VBA macro that is to be executed if the cursor is moved over the element.

More in the online help.

ZT_VBAMAKRO

DragDrop

DragDrop

VBA macro that is to be executed when the mouse button is released.

More in the online help.

ZT_VBAMAKRO

DragOver

DragOver

VBA macro that is to be executed if the cursor is moved above the element whilst the left button is pressed.

More in the online help.

ZT_VBAMAKRO

DragBegin

DragBegin

VBA macro that is to be executed when dragging starts.

More in the online help.

VT_BSTR

Menu

Context menu

Context menu for the element.
A click on the element with the right mouse button opens the context menu in Runtime.

More in the online help.

VT_BSTR

Tooltip

Tool tip

Text that is to be displayed in Runtime as the tooltip for the element. A tooltip is automatically displayed in Runtime if the mouse pointer stays over the element for a while. Word wraps can be inserted with \n.

  • Maximum: 79 character
    Attention: The character combination \n is also counted in the limit of 79 characters.

More in the online help.

VT_BOOL

LassoSelect

selectable with lasso

Selection via the lasso in the Runtime makes it possible to identify dynamic elements for using them with VBA events.
Active: The element can be selected with the lasso in the Runtime.
Inactive: The element cannot be selected in the Runtime.
Default: active

Attention: For the element to be selectable in Runtime, you must activate the Runtime lasso property in the project settings!

Note for commands: If the Two-hand operation property issued, the lasso for the Execute 2nd stage must not be activated.

More in the online help.

More...

GestureManipulationGroup

Manipulation

Properties for the manipulation of screens and screen elements with touch operation.

More in the online help.

VT_BOOL

Tab

Focus is set to the element

Active: The dynamic element can be operated using the keyboard.
inactive: The dynamic element cannot be accessed using the keyboard.
Default: avtive.

More in the online help.

VT_I4

TABOrderH

Focus position left/right

Defines the horizontal position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

VT_I4

TABOrderV

Focus position top/bottom

Defines the vertical position for the operation via the keyboard in the Runtime. The position is defined via the context menu and mouse input in the main window and cannot be changed here.

More in the online help.

ZT_FILE

Helpfile

Help file

Help file (*.chm) which should be used for this element together with a context menu. Click on ... in order to open the file selection dialog.
Attention:. Only help files which have been added in node "files/help" are available.

More in the online help.

VT_BSTR

HelpCapture

Help chapter

Help chapter which should be used for this element together with a context menu. Name of the underlying HTML page.
Attention: This entry is case sensitive.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMin

Minimum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the lower set value limit for the element.

More in the online help.

ZT_VARIABLE_DYN

SetValueDynMax

Maximum

Only available if Take set value limits from variable is not active:
Variable, the current value of which is the upper set value limit for the element.

More in the online help.

VT_BOOL

GestureRecognitionActive

Gesture recognition active

Activates gesture evaluation. Gestures are defined using other properties.

Only available if, in the Interaction group in the project properties, the Recognition Windows 8 property was entered.

More in the online help.

VT_BOOL

Gestures_Manipulation

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_Exact

Exact

Active: Detection for Exact set.

More in the online help.

VT_BOOL

Gestures_TranslationX

Translation X

Active: Detection for Translation X set.

More in the online help.

VT_BOOL

Gestures_TranslationY

Translation Y

Active: Detection for Translation Y set.

More in the online help.

VT_BOOL

Gestures_RailsX

Rails X

Active: Detection for Rails X set.

More in the online help.

VT_BOOL

Gestures_RailsY

Rails Y

Active: Detection for Rails Y set.

More in the online help.

VT_BOOL

Gestures_TranslationInertia

Translation inertia

Active: Detection for Translation Inertia set.

More in the online help.

VT_BOOL

Gestures_Rotation

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_RotationInertia

Rotation inertia

Active: Detection for Rotation Inertia set.

More in the online help.

VT_BOOL

Gestures_Scaling

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_ScalingInertia

Scaling inertia

Active: Detection for Scaling Inertia set.

More in the online help.

VT_BOOL

Gestures_CrossSlide

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_CrossSlideHorizontal

Cross slide horizontal

Active: Detection for Cross Slide Horizontal set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSelect

Cross slide select

Active: Detection for Cross Slide Select set.

More in the online help.

VT_BOOL

Gestures_CrossSlideSpeedBump

Cross slide speed bump

Active: Detection for Cross Slide Speed Bump set.

More in the online help.

VT_BOOL

Gestures_CrossSlideRearrange

Cross slide rearrange

Active: Detection for Cross Slide Rearrange set.

More in the online help.

VT_BOOL

Gestures_CrossSlideExact

Cross slide exact

Active: Detection for Cross Slide Exact set.

More in the online help.

VT_BOOL

Gestures_Tap

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_TapDouble

Tap double

Active: Detection for Tap Double set.

More in the online help.

VT_BOOL

Gestures_SecondaryTap

Secondary tap

Active: Detection for Secondary Tap set.

More in the online help.

VT_BOOL

Gestures_Drag

Drag

Active: Detection for Drag set.

More in the online help.

VT_BOOL

Gestures_Hold

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

VT_BOOL

Gestures_HoldMouse

Hold (mouse)

Active: Detection for Hold (Mouse) set.

More in the online help.

More...

LnClVariable

LnClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""line/text color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""LnClVariable.SymVarName"") 'Return the name of the ""line/text color"" variable
zElement.DynProperties (""LnClVariable.SymVarTagNr"") 'Return the identification of the ""line/text color"" variable"

More...

BkClVariable

BkClVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""background/filling color"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""BkClVariable.SymVarName"") 'Return the name of the ""background/filling color"" variable
zElement.DynProperties (""BkClVariable.SymVarTagNr"") 'Return the identification of the ""background/filling color"" variable"

More...

BkCl2Variable

"BkCl2Variable"

More...

XVar

XVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic x position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVar.SymVarName"") 'Return the name of the ""dynamic x position"" variable
zElement.DynProperties (""XVar.SymVarTagNr"") 'Return the identification of the ""dynamic x position"" variable"

More...

YVar

YVar

"With this property you have the opportunity to get informations about the variable which is linked as ""dynamic y position"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVar.SymVarName"") 'Return the name of the ""dynamic y position"" variable
zElement.DynProperties (""YVar.SymVarTagNr"") 'Return the identification of the ""dynamic y position"" variable"

More...

XVarZoom

XVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change width"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""XVarZoom.SymVarName"") 'Return the name of the ""change width"" variable
zElement.DynProperties (""XVarZoom.SymVarTagNr"") 'Return the identification of the ""change width"" variable"

More...

YVarZoom

YVarZoom

"With this property you have the opportunity to get informations about the variable which is linked as ""change height"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarName"") 'Return the name of the ""change height"" variable
zElement.DynProperties (""YVarZoom.SymVarTagNr"") 'Return the identification of the ""change height"" variable"

More...

TwistVar

TwistVar

"With this property you have the opportunity to get informations about the variable which is linked as ""rotate"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""TwistVar.SymVarName"") 'Return the name of the ""rotate"" variable
zElement.DynProperties (""TwistVar.SymVarTagNr"") 'Return the identification of the ""rotate"" variable"

More...

VisVariable

VisVariable

"With this property you have the opportunity to get informations about the variable which is linked as ""visibility"" variable of the element.
The informations are provided via subitems: ProjectVar, SymVarName, SymVarTagNr.
zElement.DynProperties (""VisVariable.SymVarName"") 'Return the name of the ""visibility"" variable
zElement.DynProperties (""VisVariable.SymVarTagNr"") 'Return the identification of the ""visibility"" variable"

More...

BlinkVar

BlinkVar

More...

GlowEffectGlowColorVar

GlowEffectGlowColorVar

More...

GlowEffectVisibilityVar

GlowEffectVisibilityVar

More...

GlowEffectBlinkVar

GlowEffectBlinkVar

VT_BSTR

Name

Element name

Assign an element name.
This must not be empty.

Note: For screen containers, issue clearly distinguishable names for clear selection when configuring screen switching.
Caution: This property is not available for language switch.

More in the online help.

VT_UI1

Layer

Visibility level

Select one of the 16 visibility levels (0 to 15) from the dropdown list. With the help of the tool barVisibility level you decide which levels are to be displayed in the Editor. This guarantees that even complex screens can be engineered clearly. The levels can be used individually. The levels have no influence on the foreground or background information or the display in the Runtime.
Default: 0.

More in the online help.

VT_I4

StartX

Start point X [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndX

End point X [pixels]

X coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

StartY

Start point Y [pixels]

Y coordinates of the upper left corner points of the element (in pixels).

More in the online help.

VT_I4

EndY

End point Y [pixels]

Y coordinates of the lower right corner points of the element (in pixels).

More in the online help.

VT_I4

Width

Width [pixels]

Width of the elements in pixels.

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Height

Height [pixels]

Height of the elements (in pixels).

Note: Only available for the elements multibin, combi-element, button and switch if Adjusted was selected for the Graphic size property.

More in the online help.

VT_I4

Angle

Rotation angle [°]

Freely definable angle about which the element is rotate.
Positive values rotate anticlockwise, negative values rotate clockwise. Values greater than 360° are displayed difference to 360° (400° corresponds to 40°). You can only enter integers.

At rotated elements the following actions are no longer possible:

  • mirror
  • rotate by +/- 90°
  • scaling by means of arrow keys

Default: 0

Note: This setting is activated and reset when configuring for Windows CE.

More in the online help.

VT_I2

ZoomMin

Visible from

Lowest zoom steps in which the element is visible in the worldview.
Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_I2

ZoomMax

Visible to

Highest zoom steps in which the element is visible in the world view.

Default: -1
Whereas visible in zoom steps from -1 to -1 means that the element is displayed in all zoom steps.

The zoom levels that are displayed in the worldview are configured using the Graphical design -> Runtime general -> Zoom steps for world view project property.

Attention: This zoom level has an effect on all screen types and frames. If a zoom level is defined as greater than 0, the element is only displayed in the worldview, because other screen types are automatically called up with zoom level 0.

More in the online help.

VT_BSTR

Stationname

Name for object list

The element is entered in the station list of the worldview screen with the text entered here.

More in the online help.

ZT_VARIABLE_DYN

LineColorVariable

Text/line color

Name of the variable whose limit value colors should influence the line/text color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

LineColorVarPreview

Display color preview

Display of the limit value for the text or line color defined for the variable. Only available if, for the Text/line color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

BackColorVariable

Fill color

Name of the variable whose limit value colors should influence the background/fill color of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

BackColorVarPreview

Display color preview

Display of the limit value for the fill color defined for the variable. Only available if, for the Fill color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_UI1

HorizontalOrigin

Horizontal

Horizontal reference point of the element. Possible values are: left, centered, right.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Left

More in the online help.

VT_UI1

VerticalOrigin

Vertical

Vertical reference point of the element. Possible values are: top, centered, bottom.
This point is used as the base for the calculation of the start angle for the rotation (static and dynamic) and for the dynamic size change.

Default: Top

More in the online help.

VT_UI4

VisibilityType

Visibility

Selection from which the visibility of an element is determined:

  • From variable
  • From interlocking

Default: From variable

More in the online help.

ZT_VARIABLE_DYN

VisibilityVariable

Variable

Only available if, for the Visibility property, from variable has been configured.

Name of the variable whose value controls the visibility of the element. The visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.
The element is always visible if no variable is linked.

More in the online help.

VT_BSTR

VisVarPreview

Display visibility preview

Display of the limit value for visibility defined for the variable. Only available if, for the Variable property in the Visibility group, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

VisibilityFromLimit

take from limit

Only available after you have selected a variable:

  • Active: The visibility of the element is influenced by the limit property of the variable.

    Attention: The Invisible property must be active for at least one limit of the variable.

  • Inactive: The visibility is influenced by the properties of the element.

Default: active

More in the online help.

VT_R8

VisibilityFrom

from

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Lowest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: smallest possible value of the linked variable.

More in the online help.

VT_R8

VisibilityTo

to

Only available after a variable has been selected and if the visibility has not been taken on by the limit value:

Highest value of the variable where the element is visible.

  • Minimum: smallest possible value of the linked variable.
  • Maximum: highest possible value of the linked variable.

Default: highest possible value of the linked variable.

More in the online help.

VT_UI4

Interlocking

Interlocking

Only available if, for the Visibility property, from interlocking has been selected.

Name of the interlocking whose value controls the visibility of the element. Select from drop-down list. This contains all existing, usable interlockings. The element is always visible if no interlocking is linked.

More in the online help.

VT_BSTR

InterlockingName

InterlockingName

Description

VT_BOOL

VisibleWhenInterlocked

Visible if interlocked

Controls visibility of the element if interlocking is selected:

  • Active: Element is visible if it is interlocked.
  • Inactive: Element is visible if it is not interlocked.

Default: inactive

More in the online help.

ZT_VARIABLE_DYN

BlinkVariable

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BSTR

BlinkVarPreview

Display blinking preview

Display of the limit value for flashing defined for the variable. Only available if, for the Take over flashing from limit property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

UseBlinkColor

Flashing color from limit

Active: Takes over the background color of the flashing from the active limit of the variable for Take over flashing from limit. Element changes during flashing not to invisible but to the active background color.

Default: inactive

Note: The color is not taken into consideration if the background color Transparent is configured.

More in the online help.

ZT_VARIABLE_DYN

XVariable

Variable

Name of the variable for the horizontal movement of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XVarMin

Min. variable value

Minimum variable value for the horizontal movement of the element.

More in the online help.

VT_R8

XVarMax

Max. variable value

Maximum variable value for the horizontal movement of the element.

More in the online help.

VT_I4

XViewMin

Min. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

XViewMax

Max. movement [pixels]

Horizontal position of the element for minimum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

YVariable

Variable

Name of the variable for the vertical movement of the element.
Open the dialog for selecting variables.

More in the online help.

VT_R8

YVarMin

Min. variable value

Minimum variable value for the vertical movement of the element.

More in the online help.

VT_R8

YVarMax

Max. variable value

Maximum variable value for the vertical movement of the element.

More in the online help.

VT_I4

YViewMin

Min. movement [pixels]

Vertical position of the element for minimum variable value (in pixels).

More in the online help.

VT_I4

YViewMax

Max. movement [pixels]

Vertical position of the element for maximum variable value (in pixels).

More in the online help.

ZT_VARIABLE_DYN

XZoomVariable

Variable

Name of the variable for the zooming of the width of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

XZoomVarMin

Min. variable value

Minimum variable value for the zooming of the width of the element.

More in the online help.

VT_R8

XZoomVarMax

Max. variable value

Maximum variable value for the zooming of the width of the element.

More in the online help.

VT_I4

XZoomViewMin

Min. width [%]

Zoom factor of the width of the element for the minimum variable value (in %).

More in the online help.

VT_I4

XZoomViewMax

Max. width [%]

Zoom factor of the width of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

YZoomVariable

Variable

Name of the variable for the zooming of the height of the element.
Opens the dialog for selecting variables.

More in the online help.

VT_R8

YZoomVarMin

Min. variable value

Minimum variable value for the zooming of the height of the element.

More in the online help.

VT_R8

YZoomVarMax

Max. variable value

Maximum variable value for the zooming of the height of the element.

More in the online help.

VT_I4

YZoomViewMin

Min. height [%]

Zoom factor of the height of the element for the minimum variable value (in %).

More in the online help.

VT_I4

YZoomViewMax

Max. height [%]

Zoom factor of the height of the element for the maximum variable value (in %).

More in the online help.

ZT_VARIABLE_DYN

TwistVariable

Variable

Name of the variable for rotating the element.

More in the online help.

VT_R8

TwistVarMin

Min. variable value

Minimum variable value for rotating the element.

More in the online help.

VT_R8

TwistVarMax

Max. variable value

Maximum variable value for rotating the element.

More in the online help.

VT_I4

TwistViewMin

Min. rotation [°]

Rotation angle of the element for the minimum variable value (in °).

More in the online help.

VT_I4

TwistViewMax

Max. rotation [°]

Rotation angle of the element for the maximum variable value (in °).

More in the online help.

VT_UI1

PunchFrameType

Border type

Drop-down list for the selection of the frame type. Available are:

No frame/shadow: No frame and no shadow is displayed.
Frame: The element can be provided with a frame.
Shadow: The element can be provided with a shadowframe. (Only available if you have activated project property Graphics quality.)
Exception: Some elements cannot obtain shadows.

Default: No border/shadow

More in the online help.

VT_BOOL

EnablePunchFrame

Show border

A frame around the element can be displayed.
Default: inactive.

ZT_COLOR

PunchFrameColor

Border/shadow color

Only available if you selected Frame of Shadow at option Border type.

Definition of the color of frame or shadow. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

More in the online help.

VT_UI1

PunchFrameAlpha

Transparency [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

States the transparency of the shadow between 0 and 100%:

0: opaque

100: transparent

Default: 60

More in the online help.

VT_UI2

PunchFrameWidth

Line width [Pixel]

Definition of the line width of the frame in pixel.

Default: 1

More in the online help.

VT_UI1

PunchFrameSoftFocus

Blur

Only available when you select shadows for property Border type and activate project property Graphics quality.

Defines the level of diffusing in number of pixel which are used for the blur. The higher this value the softer the transition to the shadow. Click on button ... opens a slider with which you can set the value.

Values: 0 to 50

0: No blurring

50: Maximum blurring

Default: 0

Attention: If a value is irregularly set to 0 here, then the calculation can affect system performance. This is especially true in the Editor when moving the shadow or when placing other objects on the shadow. In the Runtime each screen switch is affected.

More in the online help.

VT_UI2

PunchFrameOffset

Distance [pixels]

Only available if you selected frames or shadow at property Border type.

Distance of the frame or shadow to the element in pixel. The direction of the distance at shadows is defined by property Angle [°]. The size of the range depends on the monitor resolution.

Default: 10

More in the online help.

VT_I2

PunchFrameAngle

Angle [°]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Angle in degrees in which the shadow is offset.

Values: 0° to 359°. 0° means the position on the right side (3 o' clock). It is persued anticlockwise.

Default: 0°

A click on button ... opens a slider.

More in the online help.

VT_I4

PunchFrameSize

Shadow size [%]

Only available when you select shadows for property Border type and activate project property Graphics quality.

Value in pixel which defines the size of the shadow independently.

The size of the range depends on the monitor resolution.

Positive value: Shadow is larger than the element

Negative value: Shadow is smaller than the element

Default: 0

More in the online help.

VT_BOOL

GlowEffectActive

Activate

Only available if project property Graphics quality is set to DirectX Hardware or DirectX Software and project property Windows CE project is not active. Availability also depends on the graphical element.

Active: Glow effect is used for the element.

Default: inactive

More in the online help.

VT_BOOL

GlowEffectEvent

Only active if clicked

Only available of property Activate is active and if the element is a button.

Active: The glow effect is displayed only if the button is clicked. During clicking the button, the glow effect can change the color, flash or be set to invisible.

Default: inactive

More in the online help.

VT_UI1

GlowEffectAlpha

Transparency [%]

Transparency value with which the glow effect is displayed on the value. Measuring unit: in percent. A click on button ... opens a slider.

Minimum: 0%, opaque

Maximum: 100%, fully opaque

Default: 20%

More in the online help.

VT_UI1

GlowEffectSpread

Spread [pixel]

Defines the expansion factor for the glow effect. It is defined as number of pixels which are taken into account in each direction for the expansion.

Minimum: 0, no expansion

Maximum: 50

Default: 15

More in the online help.

VT_BOOL

GlowEffectUseColor

Coloring

Only available if the Activate property is active.

Active: The glow effect for the element is colored. With this the whole glow effect is displayed with only one defined color. The color can be defined via property Color or via a variable defined in proeprty Variable for color. If both properties are active, the color from property Variable for color is used.

Inactive: The color of the element is used for the glow effect.

Default: inactive

More in the online help.

ZT_COLOR

GlowEffectColor

Color

Only available if the Activate property is active. The Coloring property must be activated.

Defines the color of the glow effect. A click on the ... button opens the palette for selecting the color. You can also enter the Hex value directly in the field.

Default: 0xFFFF90 (yellow)

More in the online help.

ZT_VARIABLE_DYN

GlowEffectGlowColorVariable

Variable for color

Only available if the Activate property is active. The Coloring property must be activated.

Name of the variable whose limit color should influence the glow color of the element. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field. If no variable is linked, the color defined in property Color is used.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectGlowColorVariablePreview

Display color preview

Display of the limit value defined for the color variable when glowing. Only available if, for the Variable for color property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectVisibilityVariable

Variable for visibility

Only available if the Activate property is active.

Name of the variable whose value influences the visibility of the glow effect. The visibility is either taken from the limit properties of this variable (property Take over visibility from limit active) or defined by the value range which is defined in properties Visible from and Visible to. Clicking on the button ... opens the dialog for selecting variables. You can also enter the name manually in the text field.

Note: If no variable is linked, the glow effect is always visible.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectVisibilityVariablePreview

Display visibility preview

Display of the limit value defined for the visibility variable when glowing. Only available if, for the Variable for visibility property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectVisibilityFromLimit

Take over visibility from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility.

Active: The visibility of the glow effect is influenced by the limit property of the variable.

Attention: At least for one limit of the variable property Invisible must be active.

Inactive: The visibility is influenced by the properties of the element.

More in the online help.

VT_R8

GlowEffectVisibilityFrom

Visible from

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value from which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: lowest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

VT_R8

GlowEffectVisibilityTo

Visible to

Only available if the Activate property is active. In addition you must define a variable in property Variable for visibility and property Take over visibility from limit must be inactive.

Defines the value until which the glow effect is visible.
Minimum: lowest possible value for the variable linked in Variable for visibility.
Maximum: highest possible value for the variable linked in Variable for visibility.
Default: highest possible value for the variable linked in Variable for visibility.

More in the online help.

ZT_VARIABLE_DYN

GlowEffectBlinkVariable

Variable for flashing

Variable from whose limit(s) the flashing for the glow effect should be taken over. Clicking on the button ... opens the dialog for selecting variables.

Default: no variable linked

More in the online help.

VT_BSTR

GlowEffectBlinkVariablePreview

Display blinking preview

Display of the limit value defined for the flash variable when glowing. Only available if, for the Variable for flashing property, a variable has been configured.

Clicking the ... button opens the dialog to configure the defined limit values. Limit values are only displayed; they cannot be changed. Changes must be made directly in the variable properties for Limits.

More in the online help.

VT_BOOL

GlowEffectUseBlinkColor

Take over flash color from limit

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing.

Active: Takes over the color for the glow effect from the flashing from the active limit of the variable defined in property Flashing color from limit. This property acts independent of property Coloring. At flashing the glow effect does not toggle to invisible but to the active glow effect.

Default: inactive

More in the online help.

VT_BOOL

GlowEffect2ndBlinkStateVisible

Make 2. flash state invisible

Only available if the Activate property is active. In addition you must define a variable in property Variable for flashing and property Take over flash color from limit must be inactive.

Active: At flashing the glow effect does not toggle to the active glow effect but to invisible. With this toggling between invisible and the flashing color from the limit is possible.

Default: inactive

More in the online help.


Elements

Manual -> Programming interfaces -> Objectmodel -> Elements

Remarks

This collection contains the defined dynamic elements of a Screen.The single dynamic elements contain the most important properties, e.g. type, position, colour, ...The single dynamic elements can be found in the collection by their unique name or by the index.Hint for older Versions:Giving a name to a dynamic element is optional.If a dynamic element has no name, it is not found under certain circumstances.So the result of the method Item should always be checked on Nothing.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Private Sub ImportMdiTemplate()
Dim Picture As DynPicture
Dim Res As Integer
Set Picture = MyWorkspace.ActiveDocument.DynPictures.Item("Bild 2")
If Not Picture Is Nothing Then
Res = Picture.ImportMdiElements("C:\ProgramData\COPA-DATA\zenon700\Templates\ ScreenTypes\Keyboard\6eeae916-0098-40ab-9dc9-a9ce1dcf4bb5.zip", True)
If Res = 0 Then Picture.Save
End If
End Sub

Other topics in this chapter

Elements-Properties

Elements-Methods


Elements-Properties

Manual -> Programming interfaces -> Objectmodel -> Elements -> Elements-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Returns count of the elements | read only | read only
IDynPicture | Parent | The parent object of the current object | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> Elements -> Elements-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As DynPicture

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> Elements -> Elements-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Elements-Methods

Manual -> Programming interfaces -> Objectmodel -> Elements -> Elements-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IElement | Create | Creates and returns a new Object | available | not used
VARIANT_BOOL | Delete | Deletes the objects from collection | available | not used
IElement | Item | Returns a object at a position or by a specified key | available | available
IElement | ItemById | Returns a object with the given Id | available | available

Other topics in this chapter

Item

ItemById

Create

Delete


Item

Manual -> Programming interfaces -> Objectmodel -> Elements -> Elements-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the object Element from the collection, which is identified by the parameter vID. The parameter vID can have two values:

  • Index: Access with an index is mostly used in combination with the property Count to find out the position of the variable object in the list.
  • Element name: The element can also be accessed with its unique name.

Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vIndex) As Element

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ItemById

Manual -> Programming interfaces -> Objectmodel -> Elements -> Elements-Methods -> ItemById

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ItemById(VARIANT vElementId) As Element

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Create

Manual -> Programming interfaces -> Objectmodel -> Elements -> Elements-Methods -> Create

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new "Element" object by its name as string and its "Element" type.

Datatype

Create(String bsName,tpElementTypes tpType) As Element

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Delete

Manual -> Programming interfaces -> Objectmodel -> Elements -> Elements-Methods -> Delete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deletes an existing "Element" object by its name as string.

Datatype

Delete(String nElemId) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


FileManager

Manual -> Programming interfaces -> Objectmodel -> FileManager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This collection represents the directories and files of the files node.

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub FileManager()

Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Object from type FileManagerFolder

'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager

'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Language_Tables\English.txt")
'Create a new folder in the language table list
zFileManagerFolder.CreateFolder ("MYOWNFOLDER")

End Sub

Other topics in this chapter

FileManager-Properties

FileManager-Methods


FileManager-Properties

Manual -> Programming interfaces -> Objectmodel -> FileManager -> FileManager-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IProject | Parent | Returns the parent of the FileManager Object. | read only | read only

Other topics in this chapter

Parent


Parent

Manual -> Programming interfaces -> Objectmodel -> FileManager -> FileManager-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


FileManager-Methods

Manual -> Programming interfaces -> Objectmodel -> FileManager -> FileManager-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IFileManagerFolder | FolderItem | Returns the folder object for the given folder. | available | not used

Other topics in this chapter

FolderItem


FolderItem

Manual -> Programming interfaces -> Objectmodel -> FileManager -> FileManager-Methods -> FolderItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

FolderItem(tpModulePaths lModule) As FileManagerFolder

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A constant which defines the specific folder.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

lModule As tpModulePaths

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub FolderItem()

Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Object from type FileManagerFolder

'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager

'Read the "language list"
Set zFileManagerFolder = zFileManager.FolderItem(9)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Language_Tables\English.txt")

'Read the "graphics list"
Set zFileManagerFolder = zFileManager.FolderItem(2)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Graphics\zenOn_Logo.jpg")

'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Help\help.chm")

'Read the "multimedia list"
Set zFileManagerFolder = zFileManager.FolderItem(5)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Media\intro.wav")

'Read the "lists list"
Set zFileManagerFolder = zFileManager.FolderItem(4)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Lists\List.doc")

'Read the "drivers list"
Set zFileManagerFolder = zFileManager.FolderItem(15)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Drivers\driver.exe")

'Read the "others list"
Set zFileManagerFolder = zFileManager.FolderItem(17)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Others\infos.pdf")

End Sub


FileManagerFileItem

Manual -> Programming interfaces -> Objectmodel -> FileManagerFileItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This collection makes it possible to manage the files in a list.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub FileItem()

Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type FileManager
Dim zFileManagerItem As FileManagerFileItem 'Child object from type FileManagerFolder

'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager

'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Read the first file in the list
Set zFileManagerItem = zFileManagerFolder.FileItem(0)
'Returns the filename of the file in the list
Debug.Print "Filename = " & zFileManagerItem.FileName

End Sub

Other topics in this chapter

FileManagerFileItem-Properties

FileManagerFileItem-Methods

FileManagerFileItem-Dynamic properties


FileManagerFileItem-Properties

Manual -> Programming interfaces -> Objectmodel -> FileManagerFileItem -> FileManagerFileItem-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
BSTR | FileName | Returns the name of the File. | available | read only

Other topics in this chapter

FileName


FileName

Manual -> Programming interfaces -> Objectmodel -> FileManagerFileItem -> FileManagerFileItem-Properties -> FileName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the filename of the selected file.

Datatype

FileName() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


FileManagerFileItem-Methods

Manual -> Programming interfaces -> Objectmodel -> FileManagerFileItem -> FileManagerFileItem-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CheckIn | Save module modifications to server (editor). | available | not used
VARIANT_BOOL | CheckOut | Allow module modifications (editor). | available | not used
VARIANT_BOOL | Get | Get the latest version from the server (editor). | available | not used
VARIANT_BOOL | IsCheckedOut | Returns true when the current module checked out by the current user (editor). | read only | not used
VARIANT_BOOL | IsDifferent | Return true when the local- and server version are different (editor). | read only | not used
VARIANT_BOOL | IsLocked | Returns true when the current module is Locked by another user (editor). | read only | not used
VARIANT_BOOL | UndoCheckOut | Undo module modifications (editor). | available | not used

Other topics in this chapter

Get

CheckOut

CheckIn

UndoCheckOut

IsLocked

IsCheckedOut

IsDifferent


Get

Manual -> Programming interfaces -> Objectmodel -> FileManagerFileItem -> FileManagerFileItem-Methods -> Get

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype

Get() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckOut

Manual -> Programming interfaces -> Objectmodel -> FileManagerFileItem -> FileManagerFileItem-Methods -> CheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype

CheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckIn

Manual -> Programming interfaces -> Objectmodel -> FileManagerFileItem -> FileManagerFileItem-Methods -> CheckIn

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype

CheckIn() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


UndoCheckOut

Manual -> Programming interfaces -> Objectmodel -> FileManagerFileItem -> FileManagerFileItem-Methods -> UndoCheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype

UndoCheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsLocked

Manual -> Programming interfaces -> Objectmodel -> FileManagerFileItem -> FileManagerFileItem-Methods -> IsLocked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype

IsLocked() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsCheckedOut

Manual -> Programming interfaces -> Objectmodel -> FileManagerFileItem -> FileManagerFileItem-Methods -> IsCheckedOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype

IsCheckedOut() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsDifferent

Manual -> Programming interfaces -> Objectmodel -> FileManagerFileItem -> FileManagerFileItem-Methods -> IsDifferent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype

IsDifferent() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


FileManagerFileItem-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> FileManagerFileItem -> FileManagerFileItem-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

File object

Other topics in this chapter

File object


File object

Manual -> Programming interfaces -> Objectmodel -> FileManagerFileItem -> FileManagerFileItem-Dynamic properties -> File object

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Name | File name | Name of the integrated file. External files which are integrated in this way are saved both in the Runtime directory and in the database directory of the project. Attention: Every time new Runtime files are created, the files in the Runtime folder are overwritten with the files from the database folder. This is why external files should be only changed via context menu of the respective file and not be changed externally so that the files are also changed in the database folder. More in the online help.


FileManagerFolder

Manual -> Programming interfaces -> Objectmodel -> FileManagerFolder

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This collection contains the folder object for the specified folder. The folder item object allows different methods for different tpModulepaths. Not all methods are supported for all tpModulepaths

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub AddItem()

Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type FileManager

'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager

'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Language_Tables\English.txt")

Call CreateFolder

End Sub

Sub CreateFolder()

Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type FileManager

'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager

'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Create a new folder in the list
zFileManagerFolder.CreateFolder ("My_Folder")

Call FolderItem

End Sub

Sub FolderItem()

Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type FileManager
Dim zFileManagerItem As FileManagerFileItem 'Child object from type FileManagerFolder
Dim zFolderItem As FileManagerFolder 'Child object from type FileManager

'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager

'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Read a sub folder item
Set zFolderItem = zFileManagerFolder.FolderItem(0)
'Add a file at the created sub-folder
zFolderItem.AddItem ("C:\Programme\COPA-DATA\Help\editor.chm")

End Sub

Other topics in this chapter

FileManagerFolder-Properties

FileManagerFolder-Methods


FileManagerFolder-Properties

Manual -> Programming interfaces -> Objectmodel -> FileManagerFolder -> FileManagerFolder-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | FileCount | Returns the amount of files located in the folder. | available | available
long | FolderCount | Returns the amount of folders located in the folder. | available | available
BSTR | Name | Name of the folder. | available | read only

Other topics in this chapter

FolderCount

FileCount

Name


FolderCount

Manual -> Programming interfaces -> Objectmodel -> FileManagerFolder -> FileManagerFolder-Properties -> FolderCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the number of sub-directories in this directory.

Datatype

FolderCount() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


FileCount

Manual -> Programming interfaces -> Objectmodel -> FileManagerFolder -> FileManagerFolder-Properties -> FileCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the number of files in a directory.

Datatype

FileCount() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> FileManagerFolder -> FileManagerFolder-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the name of the directory.

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


FileManagerFolder-Methods

Manual -> Programming interfaces -> Objectmodel -> FileManagerFolder -> FileManagerFolder-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | AddItem | Inserts the given file into the folder. | available | not used
VARIANT_BOOL | CreateFolder | Creates a subfolder. | available | not used
VARIANT_BOOL | DeleteFile | Deletes the file from the folder. | available | not used
VARIANT_BOOL | DeleteFolder | Deletes the folder. | available | not used
IFileManagerFileItem | FileItem | Returns the file, at given index, from the folder. | available | available
IFileManagerFolder | FolderItem | Returns the sub-folder, at given index, from the folder. | available | available

Other topics in this chapter

FolderItem

AddItem

CreateFolder

FileItem

DeleteFile

DeleteFolder


FolderItem

Manual -> Programming interfaces -> Objectmodel -> FileManagerFolder -> FileManagerFolder-Methods -> FolderItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns a sub-folder from type "FileManagerFolder".

Datatype

FolderItem(long lIndex) As FileManagerFolder

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

Defines the position of the sub folder.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

lIndex As Long

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub FolderItem()

Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type FileManager
Dim zFileManagerItem As FileManagerFileItem 'Child object from type FileManagerFolder
Dim zFolderItem As FileManagerFolder 'Child object from type FileManager

'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager

'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Read a sub folder item
Set zFolderItem = zFileManagerFolder.FolderItem(0)
'Add a file at the created sub-folder
zFolderItem.AddItem ("C:\Programme\COPA-DATA\Help\editor.chm")

End Sub


AddItem

Manual -> Programming interfaces -> Objectmodel -> FileManagerFolder -> FileManagerFolder-Methods -> AddItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method allows adding files to the directory.

Datatype

AddItem(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub AddItem()

Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type FileManager

'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager

'Read the "language list"
Set zFileManagerFolder = zFileManager.FolderItem(9)
'Add a new item into the list
zFileManagerFolder.AddItem ("C:\Language_Tables\English.txt")

End Sub


CreateFolder

Manual -> Programming interfaces -> Objectmodel -> FileManagerFolder -> FileManagerFolder-Methods -> CreateFolder

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method creates a new directory. It is not supported for all tpModulepaths directories. Returns True if successfull

Datatype

CreateFolder(String bsFolderName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

The folder name is defined by a string.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFolderName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub CreateFolder()

Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type FileManager

'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager

'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Create a new folder in the list
zFileManagerFolder.CreateFolder ("My_Folder")

End Sub


FileItem

Manual -> Programming interfaces -> Objectmodel -> FileManagerFolder -> FileManagerFolder-Methods -> FileItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns an object from type FileManagerFileItem.

Datatype

FileItem(long lIndex) As FileManagerFileItem

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

Defines the position of the file.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

lIndex As Long

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub FileItem()

Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type FileManager
Dim zFileManagerItem As FileManagerFileItem 'Child object from type FileManagerFolder

'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager

'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Read the first file in the list
Set zFileManagerItem = zFileManagerFolder.FileItem(0)
'Returns the filename of the file in the list
Debug.Print "Filename = " & zFileManagerItem.FileName

End Sub


DeleteFile

Manual -> Programming interfaces -> Objectmodel -> FileManagerFolder -> FileManagerFolder-Methods -> DeleteFile

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method allows the deletion of files. Returns true if successfull.

Datatype

DeleteFile(long lIndex) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Defines the position of the file.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

lIndex As Long

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub DeleteFile()

Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type FileManager

'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager

'Read the "language list"
Set zFileManagerFolder = zFileManager.FolderItem(9)
'Delete the first file in the list
zFileManagerFolder.DeleteFile (0)

End Sub


DeleteFolder

Manual -> Programming interfaces -> Objectmodel -> FileManagerFolder -> FileManagerFolder-Methods -> DeleteFolder

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this method a list folder can be deleted.

Datatype

DeleteFolder(long lIndex) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Defines the position of the folder.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

lIndex As Long

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub DeleteFolder()

Dim zFileManager As FileManager 'Object from type FileManager
Dim zFileManagerFolder As FileManagerFolder 'Child object from type FileManager

'Fill the object
Set zFileManager = MyWorkspace.ActiveDocument.FileManager

'Read the "help list"
Set zFileManagerFolder = zFileManager.FolderItem(10)
'Delete the first folder
zFileManagerFolder.DeleteFolder (0)

End Sub


FontItem

Manual -> Programming interfaces -> Objectmodel -> FontItem

Remarks

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

'Type definition of LOGFONT type (see MSDN)
Type LOGFONT
Height As Long
Width As Long
Escapement As Long
Orientation As Long
Weight As Long
Italic As Byte
Underline As Byte
StrikeOut As Byte
CharSet As Byte
OutPrecision As Byte
ClipPrecision As Byte
Quality As Byte
PitchAndFamily As Byte
FaceName As String * 32
End Type

Sub GetFontList()
Dim zPRJ As Project
Dim zFLs As FontLists
Dim zFL As FontList
Dim zFI As FontItem
Dim i As Integer
Dim n As Integer
Dim lf As LOGFONT

Set zPRJ = MyWorkspace.ActiveDocument
Set zFLs = zPRJ.FontLists
'enumerate all fontlists of the active project
For i = 0 To zFLs.Count - 1
Set zFL = zFLs.Item(i)
Debug.Print "Fontlist: " & zFL.DynProperties("Name")
'enumrate fonts of a fontlist
For n = 0 To zFL.Count - 1
Set zFI = zFL.Item(n)
Debug.Print zFI.DynProperties("Number")
Debug.Print zFI.DynProperties("Name")
Debug.Print zFI.DynProperties("Font")
'convert string to LOGFONT type in a function
lf = GetLogFontFromString(zFI.DynProperties("Font"))
Next n
Next i
End Sub

Sub CreateFontList()
Dim zPRJ As Project
Dim zFLs As FontLists
Dim zFL As FontList
Dim zFI As FontItem
Dim i As Integer
Dim lf As LOGFONT

Set zPRJ = MyWorkspace.ActiveDocument
Set zFLs = zPRJ.FontLists

'define font (LOGFONT)
lf.Height = 10
lf.Width = 0
lf.Escapement = 0
lf.Orientation = 0
lf.Weight = 400
lf.Italic = 0
lf.Underline = 0
lf.StrikeOut = 0
lf.CharSet = 0
lf.OutPrecision = 3
lf.ClipPrecision = 2
lf.Quality = 5
lf.PitchAndFamily = 34
lf.FaceName = String(25, " ") & "Courier" '32 - 7

'create new fontlist
Set zFL = zFLs.Create
With zFL
'set name of new fontlist
.DynProperties("Name") = "VBA_FontList3"
For i = 1 To 10
'create fonts in fontlist
Set zFI = zFL.Create(i)
zFI.DynProperties("Name") = "VBA_Font_" & Format(i, "00")
zFI.DynProperties("Font") = strFont
'modify LOGFONT definition
lf.Height = 10 + (i * 2)
'set font
zFI.DynProperties("Font") = GetStringFromLogFont(lf)
Next i
End With

End Sub

'CONVERT A STRING TO LOGFONT TYPE
Function GetLogFontFromString(strFont As String) As LOGFONT
Dim vSplit As Variant
Dim sFaceName As String
Dim i As Integer

vSplit = Split(strFont, " ")

GetLogFontFromString.Height = vSplit(0)
GetLogFontFromString.Width = vSplit(1)
GetLogFontFromString.Escapement = vSplit(2)
GetLogFontFromString.Orientation = vSplit(3)
GetLogFontFromString.Weight = vSplit(4)
GetLogFontFromString.Italic = vSplit(5)
GetLogFontFromString.Underline = vSplit(6)
GetLogFontFromString.StrikeOut = vSplit(7)
GetLogFontFromString.CharSet = vSplit(8)
GetLogFontFromString.OutPrecision = vSplit(9)
GetLogFontFromString.ClipPrecision = vSplit(10)
GetLogFontFromString.Quality = vSplit(11)
GetLogFontFromString.PitchAndFamily = vSplit(12)
For i = 13 To UBound(vSplit)
sFaceName = sFaceName & vSplit(i) & " "
Next i
sFaceName = RTrim(sFaceName)
sFaceName = String(32 - Len(sFaceName), " ") & sFaceName

GetLogFontFromString.FaceName = sFaceName
End Function

'CONVERT A LOGFONT TO STRING
Function GetStringFromLogFont(lfFont As LOGFONT) As String
GetStringFromLogFont = lfFont.Height & " " & _
lfFont.Width & " " & _
lfFont.Escapement & " " & _
lfFont.Orientation & " " & _
lfFont.Weight & " " & _
lfFont.Italic & " " & _
lfFont.Underline & " " & _
lfFont.StrikeOut & " " & _
lfFont.CharSet & " " & _
lfFont.OutPrecision & " " & _
lfFont.ClipPrecision & " " & _
lfFont.Quality & " " & _
lfFont.PitchAndFamily & " " & _
lfFont.FaceName
End Function

Other topics in this chapter

FontItem-Methods

FontItem-Dynamic properties


FontItem-Methods

Manual -> Programming interfaces -> Objectmodel -> FontItem -> FontItem-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | DynProperties [PUT] | - | available | not used
VARIANT | DynProperties [GET] | - | available | not used
VARIANT | DynPropertiesEnum [GET] | - | available | not used
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> FontItem -> FontItem-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> FontItem -> FontItem-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> FontItem -> FontItem-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> FontItem -> FontItem-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


FontItem-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> FontItem -> FontItem-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Font

Other topics in this chapter

Font


Font

Manual -> Programming interfaces -> Objectmodel -> FontItem -> FontItem-Dynamic properties -> Font

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Name | Name | Freely definable description; only for information Default: New font x (where x represents a consecutive number). Attention: This property is not available for language switch. More in the online help.
ZT_LOGSCHRIFT | Font | Font | Selection of the font type from the font types available on the computer. Attention: The dialog for selection of the font type is a Windows standard dialog. This also makes the selection of other properties such as font color possible. This additional settings however do not have any effect on the display in zenon. More in the online help.
VT_UI2 | Number | Number | Unique number of the font. The number is set by the system when the font is created. Numbers 1 and 2 are assigned fixedly and cannot be changed. All other font numbers can be changed afterwards as long as the newly assigned numbers are not already used for others fonts. Note: If there are same numbers in the global project and in the project, the project font is used. More in the online help.


FontList

Manual -> Programming interfaces -> Objectmodel -> FontList

Remarks

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

'Type definition of LOGFONT type (see MSDN)
Type LOGFONT
Height As Long
Width As Long
Escapement As Long
Orientation As Long
Weight As Long
Italic As Byte
Underline As Byte
StrikeOut As Byte
CharSet As Byte
OutPrecision As Byte
ClipPrecision As Byte
Quality As Byte
PitchAndFamily As Byte
FaceName As String * 32
End Type

Sub GetFontList()
Dim zPRJ As Project
Dim zFLs As FontLists
Dim zFL As FontList
Dim zFI As FontItem
Dim i As Integer
Dim n As Integer
Dim lf As LOGFONT

Set zPRJ = MyWorkspace.ActiveDocument
Set zFLs = zPRJ.FontLists
'enumerate all fontlists of the active project
For i = 0 To zFLs.Count - 1
Set zFL = zFLs.Item(i)
Debug.Print "Fontlist: " & zFL.DynProperties("Name")
'enumrate fonts of a fontlist
For n = 0 To zFL.Count - 1
Set zFI = zFL.Item(n)
Debug.Print zFI.DynProperties("Number")
Debug.Print zFI.DynProperties("Name")
Debug.Print zFI.DynProperties("Font")
'convert string to LOGFONT type in a function
lf = GetLogFontFromString(zFI.DynProperties("Font"))
Next n
Next i
End Sub

Sub CreateFontList()
Dim zPRJ As Project
Dim zFLs As FontLists
Dim zFL As FontList
Dim zFI As FontItem
Dim i As Integer
Dim lf As LOGFONT

Set zPRJ = MyWorkspace.ActiveDocument
Set zFLs = zPRJ.FontLists

'define font (LOGFONT)
lf.Height = 10
lf.Width = 0
lf.Escapement = 0
lf.Orientation = 0
lf.Weight = 400
lf.Italic = 0
lf.Underline = 0
lf.StrikeOut = 0
lf.CharSet = 0
lf.OutPrecision = 3
lf.ClipPrecision = 2
lf.Quality = 5
lf.PitchAndFamily = 34
lf.FaceName = String(25, " ") & "Courier" '32 - 7

'create new fontlist
Set zFL = zFLs.Create
With zFL
'set name of new fontlist
.DynProperties("Name") = "VBA_FontList3"
For i = 1 To 10
'create fonts in fontlist
Set zFI = zFL.Create(i)
zFI.DynProperties("Name") = "VBA_Font_" & Format(i, "00")
zFI.DynProperties("Font") = strFont
'modify LOGFONT definition
lf.Height = 10 + (i * 2)
'set font
zFI.DynProperties("Font") = GetStringFromLogFont(lf)
Next i
End With

End Sub

'CONVERT A STRING TO LOGFONT TYPE
Function GetLogFontFromString(strFont As String) As LOGFONT
Dim vSplit As Variant
Dim sFaceName As String
Dim i As Integer

vSplit = Split(strFont, " ")

GetLogFontFromString.Height = vSplit(0)
GetLogFontFromString.Width = vSplit(1)
GetLogFontFromString.Escapement = vSplit(2)
GetLogFontFromString.Orientation = vSplit(3)
GetLogFontFromString.Weight = vSplit(4)
GetLogFontFromString.Italic = vSplit(5)
GetLogFontFromString.Underline = vSplit(6)
GetLogFontFromString.StrikeOut = vSplit(7)
GetLogFontFromString.CharSet = vSplit(8)
GetLogFontFromString.OutPrecision = vSplit(9)
GetLogFontFromString.ClipPrecision = vSplit(10)
GetLogFontFromString.Quality = vSplit(11)
GetLogFontFromString.PitchAndFamily = vSplit(12)
For i = 13 To UBound(vSplit)
sFaceName = sFaceName & vSplit(i) & " "
Next i
sFaceName = RTrim(sFaceName)
sFaceName = String(32 - Len(sFaceName), " ") & sFaceName

GetLogFontFromString.FaceName = sFaceName
End Function

'CONVERT A LOGFONT TO STRING
Function GetStringFromLogFont(lfFont As LOGFONT) As String
GetStringFromLogFont = lfFont.Height & " " & _
lfFont.Width & " " & _
lfFont.Escapement & " " & _
lfFont.Orientation & " " & _
lfFont.Weight & " " & _
lfFont.Italic & " " & _
lfFont.Underline & " " & _
lfFont.StrikeOut & " " & _
lfFont.CharSet & " " & _
lfFont.OutPrecision & " " & _
lfFont.ClipPrecision & " " & _
lfFont.Quality & " " & _
lfFont.PitchAndFamily & " " & _
lfFont.FaceName
End Function

Other topics in this chapter

FontList-Properties

FontList-Methods

FontList-Dynamic properties


FontList-Properties

Manual -> Programming interfaces -> Objectmodel -> FontList -> FontList-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | Count | Returns the amount of Font objects. | available | not used | yes | yes

Other topics in this chapter

Count


Count

Manual -> Programming interfaces -> Objectmodel -> FontList -> FontList-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Count() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


FontList-Methods

Manual -> Programming interfaces -> Objectmodel -> FontList -> FontList-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IFontItem | Create | Create a new Font. | available | not used
void | DynProperties [PUT] | - | available | not used
VARIANT | DynProperties [GET] | - | available | not used
VARIANT | DynPropertiesEnum [GET] | - | available | not used
IFontItem | Item | Returns the Font at the given index. | available | not used
IFontItem | ItemById | Returns the Font with the given Id. | available | not used
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

Item

ItemById

Create

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


Item

Manual -> Programming interfaces -> Objectmodel -> FontList -> FontList-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Item(long lIndex) As FontItem

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ItemById

Manual -> Programming interfaces -> Objectmodel -> FontList -> FontList-Methods -> ItemById

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ItemById(long lId) As FontItem

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Create

Manual -> Programming interfaces -> Objectmodel -> FontList -> FontList-Methods -> Create

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Create(long lFontId) As FontItem

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> FontList -> FontList-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> FontList -> FontList-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> FontList -> FontList-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> FontList -> FontList-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


FontList-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> FontList -> FontList-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Fontlist

Other topics in this chapter

Fontlist


Fontlist

Manual -> Programming interfaces -> Objectmodel -> FontList -> FontList-Dynamic properties -> Fontlist

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Name | Name | Name of the font list. More in the online help.


FontLists

Manual -> Programming interfaces -> Objectmodel -> FontLists

Remarks

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

'Type definition of LOGFONT type (see MSDN)
Type LOGFONT
Height As Long
Width As Long
Escapement As Long
Orientation As Long
Weight As Long
Italic As Byte
Underline As Byte
StrikeOut As Byte
CharSet As Byte
OutPrecision As Byte
ClipPrecision As Byte
Quality As Byte
PitchAndFamily As Byte
FaceName As String * 32
End Type

Sub GetFontList()
Dim zPRJ As Project
Dim zFLs As FontLists
Dim zFL As FontList
Dim zFI As FontItem
Dim i As Integer
Dim n As Integer
Dim lf As LOGFONT

Set zPRJ = MyWorkspace.ActiveDocument
Set zFLs = zPRJ.FontLists
'enumerate all fontlists of the active project
For i = 0 To zFLs.Count - 1
Set zFL = zFLs.Item(i)
Debug.Print "Fontlist: " & zFL.DynProperties("Name")
'enumrate fonts of a fontlist
For n = 0 To zFL.Count - 1
Set zFI = zFL.Item(n)
Debug.Print zFI.DynProperties("Number")
Debug.Print zFI.DynProperties("Name")
Debug.Print zFI.DynProperties("Font")
'convert string to LOGFONT type in a function
lf = GetLogFontFromString(zFI.DynProperties("Font"))
Next n
Next i
End Sub

Sub CreateFontList()
Dim zPRJ As Project
Dim zFLs As FontLists
Dim zFL As FontList
Dim zFI As FontItem
Dim i As Integer
Dim lf As LOGFONT

Set zPRJ = MyWorkspace.ActiveDocument
Set zFLs = zPRJ.FontLists

'define font (LOGFONT)
lf.Height = 10
lf.Width = 0
lf.Escapement = 0
lf.Orientation = 0
lf.Weight = 400
lf.Italic = 0
lf.Underline = 0
lf.StrikeOut = 0
lf.CharSet = 0
lf.OutPrecision = 3
lf.ClipPrecision = 2
lf.Quality = 5
lf.PitchAndFamily = 34
lf.FaceName = String(25, " ") & "Courier" '32 - 7

'create new fontlist
Set zFL = zFLs.Create
With zFL
'set name of new fontlist
.DynProperties("Name") = "VBA_FontList3"
For i = 1 To 10
'create fonts in fontlist
Set zFI = zFL.Create(i)
zFI.DynProperties("Name") = "VBA_Font_" & Format(i, "00")
zFI.DynProperties("Font") = strFont
'modify LOGFONT definition
lf.Height = 10 + (i * 2)
'set font
zFI.DynProperties("Font") = GetStringFromLogFont(lf)
Next i
End With

End Sub

'CONVERT A STRING TO LOGFONT TYPE
Function GetLogFontFromString(strFont As String) As LOGFONT
Dim vSplit As Variant
Dim sFaceName As String
Dim i As Integer

vSplit = Split(strFont, " ")

GetLogFontFromString.Height = vSplit(0)
GetLogFontFromString.Width = vSplit(1)
GetLogFontFromString.Escapement = vSplit(2)
GetLogFontFromString.Orientation = vSplit(3)
GetLogFontFromString.Weight = vSplit(4)
GetLogFontFromString.Italic = vSplit(5)
GetLogFontFromString.Underline = vSplit(6)
GetLogFontFromString.StrikeOut = vSplit(7)
GetLogFontFromString.CharSet = vSplit(8)
GetLogFontFromString.OutPrecision = vSplit(9)
GetLogFontFromString.ClipPrecision = vSplit(10)
GetLogFontFromString.Quality = vSplit(11)
GetLogFontFromString.PitchAndFamily = vSplit(12)
For i = 13 To UBound(vSplit)
sFaceName = sFaceName & vSplit(i) & " "
Next i
sFaceName = RTrim(sFaceName)
sFaceName = String(32 - Len(sFaceName), " ") & sFaceName

GetLogFontFromString.FaceName = sFaceName
End Function

'CONVERT A LOGFONT TO STRING
Function GetStringFromLogFont(lfFont As LOGFONT) As String
GetStringFromLogFont = lfFont.Height & " " & _
lfFont.Width & " " & _
lfFont.Escapement & " " & _
lfFont.Orientation & " " & _
lfFont.Weight & " " & _
lfFont.Italic & " " & _
lfFont.Underline & " " & _
lfFont.StrikeOut & " " & _
lfFont.CharSet & " " & _
lfFont.OutPrecision & " " & _
lfFont.ClipPrecision & " " & _
lfFont.Quality & " " & _
lfFont.PitchAndFamily & " " & _
lfFont.FaceName
End Function

Other topics in this chapter

FontLists-Properties

FontLists-Methods


FontLists-Properties

Manual -> Programming interfaces -> Objectmodel -> FontLists -> FontLists-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | Count | Returns the amount of Fontlist objects. | available | not used | yes | yes

Other topics in this chapter

Count


Count

Manual -> Programming interfaces -> Objectmodel -> FontLists -> FontLists-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Count() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


FontLists-Methods

Manual -> Programming interfaces -> Objectmodel -> FontLists -> FontLists-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IFontList | Create | Create a new FontList. | available | not used
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | Import | Imports the selected XML file | available | not used
IFontList | Item | Returns the FontList at the given index. | available | not used
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used

Other topics in this chapter

Item

Create

SingleExport

Export

Import


Item

Manual -> Programming interfaces -> Objectmodel -> FontLists -> FontLists-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Item(long lIndex) As FontList

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Create

Manual -> Programming interfaces -> Objectmodel -> FontLists -> FontLists-Methods -> Create

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Create() As FontList

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SingleExport

Manual -> Programming interfaces -> Objectmodel -> FontLists -> FontLists-Methods -> SingleExport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SingleExport(VARIANT vIndexOrName,BSTR bsFileName) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Export

Manual -> Programming interfaces -> Objectmodel -> FontLists -> FontLists-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Export(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Import

Manual -> Programming interfaces -> Objectmodel -> FontLists -> FontLists-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Imports settings using a xml file. New settings are added, existing settings will be replaced.

Datatype

Import(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to import.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)

'Export settings to an xml file
zenOnObject.Export ("C:\zenOn_eXaMpLe.xml, False")

'Import settings from an xml file
zenOnObject.Import ("C:\zenOn_eXaMpLe.xml, False")

End Sub


Interlocking

Manual -> Programming interfaces -> Objectmodel -> Interlocking

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With the interlocking object you have the opportunity to edit standard interlockings and command interlockings (zenOn Energy edition)

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub Get_Interlocking_Information()

Dim zInterlockings As Interlockings 'Object from type Interlockings
Dim zInterlocking As Interlocking 'Child object from type Interlocking

'Load the available Interlockings
Set zInterlockings = thisProject.Interlockings
'Select a command interlocking called "switches"
Set zInterlocking = zInterlockings.Item("switches")

'Get all projected informations of the first action
'Get action type
Debug.Print "Action type = " & zInterlocking.DynProperties("Actions[0].Type")
'Get the linked variable
Debug.Print "Variable = " & zInterlocking.DynProperties("Actions[0].TTA")
'Get the "switching direction"
Debug.Print "Switching direction = " & zInterlocking.DynProperties("Actions[0].Direction")
'Get the "command setting status"
Debug.Print "Command setting status = " & zInterlocking.DynProperties("Actions[0].CommandState")
'Get state "CEL entries suppressed"
Debug.Print "CEL entries are suppressed = " & zInterlocking.DynProperties("Actions[0].CELBlock")
'Get the "timeout" in seconds
Debug.Print "Timeout (s) = " & zInterlocking.DynProperties("Actions[0].Timeout")
'Get the "edge delay" in milliseconds
Debug.Print "Edge delay (ms) = " & zInterlocking.DynProperties("Actions[0].EdgeDelay")
'Get the "modifyable stati"
Debug.Print "Modifyable stati = " & zInterlocking.DynProperties("Actions[0].State")
'Get state "nominal/actual value comparison"
Debug.Print "Nominal/actual value comparison is activated = " & zInterlocking.DynProperties("Actions[0].Actual")
'Get the "menu specific Screen"
Debug.Print "Menu specific picture = " & zInterlocking.DynProperties("Actions[0].Picture")
'Get state "close automatically"
Debug.Print "Close automatically is activated = " & zInterlocking.DynProperties("Actions[0].CloseMDIWnd")
'Get state "two-stage"
Debug.Print "Two-stage is activated = " & zInterlocking.DynProperties("Actions[0].TwoLevel")
'Get state "two-hand operation"
Debug.Print "Two-hand operation is activated = " & zInterlocking.DynProperties("Actions[0].TwoHand")

End Sub

Other topics in this chapter

Interlocking-Methods

Interlocking-Dynamic properties


Interlocking-Methods

Manual -> Programming interfaces -> Objectmodel -> Interlocking -> Interlocking-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CreateDynProperty | - | available | not used
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

CreateDynProperty

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


CreateDynProperty

Manual -> Programming interfaces -> Objectmodel -> Interlocking -> Interlocking-Methods -> CreateDynProperty

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With the DynProperties "Variables" and "Actions" you have the opportunity to create a variable at an interlocking and to create an action at a command interlocking (special interlockings for zenOn Energy).

Datatype

CreateDynProperty(String bsPath) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Name of DynProperty to be created as string

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub Command_Interlockings()

Dim zInterlockings As Interlockings 'Object from type Interlockings
Dim zInterlocking As Interlocking 'Child object from type Interlocking

'Load the available Interlockings
Set zInterlockings = thisProject.Interlockings
'Select a command interlocking
Set zInterlocking = zInterlockings.Item("Verriegelung 1")

'Create a "variable" at the command interlocking
zInterlocking.CreateDynProperty ("Variables")
'Allocate the first variable of the project variables list
zInterlocking.DynProperties("Variables[0].Name") = thisProject.Variables.Item(0)

'Create an "action" at the command interlocking
zInterlocking.CreateDynProperty ("Actions")
'The action should be from type "Double command"
zInterlocking.DynProperties("Actions[0].Type") = 1
'Set the "variable" via a string
zInterlocking.DynProperties("Actions[0].TTA") = "switch_1"
'Set the "switching direction" to ON
zInterlocking.DynProperties("Actions[0].Direction") = 1
'Set the "command setting status" to 1
zInterlocking.DynProperties("Actions[0].CommandState") = 1
'Set that CEL entries should be suppressed
zInterlocking.DynProperties("Actions[0].CELBlock") = True
'Set the "timeout" to 60 sec
zInterlocking.DynProperties("Actions[0].Timeout") = 60
'Set the edge "delay" to 2000 msec
zInterlocking.DynProperties("Actions[0].EdgeDelay") = 2000
'Read the "modifyable stati"
Debug.Print zInterlocking.DynProperties("Actions[0].State")
'Set the "nominal/actual value comparison" active
zInterlocking.DynProperties("Actions[0].Actual") = True
'Set the "menu specific picture" (menu type = commands) via a string
zInterlocking.DynProperties("Actions[0].Picture") = "Picture 1"
'Set the "close automatically" property active
zInterlocking.DynProperties("Actions[0].CloseMDIWnd") = True
'Set the "two-stage" property active
zInterlocking.DynProperties("Actions[0].TwoLevel") = True
'Set the "two-hand operation" property active
zInterlocking.DynProperties("Actions[0].TwoHand") = True

End Sub


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> Interlocking -> Interlocking-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> Interlocking -> Interlocking-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> Interlocking -> Interlocking-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> Interlocking -> Interlocking-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


Interlocking-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> Interlocking -> Interlocking-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Interlocking

Other topics in this chapter

CBefPara

CVerVar

Interlocking


CBefPara

Manual -> Programming interfaces -> Objectmodel -> Interlocking -> Interlocking-Dynamic properties -> CBefPara

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

LockingCondition

Interlocking conditions

Properties for the conditions.

ZT_VARIABLE_DYN

Name

Action variable

Name of the variable linked to the command group.
Opens the dialog for selecting variables.

More in the online help.

VT_BSTR

TTA

TTA Imp/Exp

VT_UI2

Type

Action type

Only available for the actionCommand:
Type of command.
Switching command: Writes the value of the Command property.
Pulse command: Writes the value of the Command property. The value 0 is written after the Edge delay. This rewrite is no longer runtime-monitored.

Note: Only available for the pulse command action. If other actions are selected in the command input, these are pre-entered in the Action type and are grayed out for further editing.

Default: Switching command.

More in the online help.

VT_UI2

Direction

Return state/switching direction

Defines the expected value or the status of the response variable after action execution.

The possible entries vary in accordance with the action.

  • AUS: The return state is deactivated - value will be 0
  • DIFF: Interim status between 0 and 1.
  • ON The return state is activated - value will be 1
  • none: The return state is ignored - value will not change
  • DIR: xx (only available for the setpoint input command)
  • Set value: xx (only available for the setpoint input command)
  • STÖR: Error.

Not available for the following actions: Block, Lock and Approve.

More in the online help.

VT_UI2

CommandState

Command

Only available for the 'Command' action:
Defines the value that is written as a value to the command variable for the action 'Command'.
Note: not active for the commands Block, Replace, Approve, Track, Revision, Setpoint input and Set status.

0: The command variable is reset to 0.
1: The command variable is reset to 1.
Default: 1.

More in the online help.

VT_UI4

EdgeDelay

Edge delay

Only available if, in the Action type property, Pulse command has been selected.
After this time in milliseconds expired, the value of the command variable is reset dependent of the switching direction to 0 or 1. The value is not reset, if you activated property Select Before Operate of the action variable.

Note: If, if the command input, the action Auto/Remote command or mandatory command has been selected, these are pre-entered in the Action type and are inactive for further editing.

Note:
Minimum: 0
Maximum: 4294967295
Default: 1000
Attention: The system does not wait until the watchdog timer is ended.

More in the online help.

VT_R8

ValueDirectly

Set value

Only available if property Return state/switching direction was set to DIR. This is, in turn, only possible for the commands Replace, Track and Setpoint input.

Defines the set values which should be written.

Default: 0

More in the online help.

ZT_ALARMKLASSE

State

Modifyable states

Only available for the 'Set status' command:

Default: none.

More in the online help.

VT_BOOL

CELBlock

Suppress CEL entry

Active: No entry is created in the Chronological Event List (CEL) when the action is executed.
Inactive: An entry is created in the Chronological Event List (CEL) when the action is executed.
Default: inaktiv.

More in the online help.

VT_UI4

Timeout

Timeout

Timeout for the runtime monitoring in seconds for switching command and pulse command actions.

This setting is also applicable as a timeout for selection of IO. Only available for the actions Command, Auto/remote command, Check response, Setpoint input and Forced command.

  • Minimum: 0
  • Maximum: 4294967295
  • Default: 30

More in the online help.

VT_BOOL

TimeoutAbortable

Timeout can be cancelled

Allows the cancellation of the timeouts in the runtime monitoring.

If the Execute- command has already been executed - after COT_actcon has been received - the Cancel button cancels runtime monitoring. Buttons are therefore active and operable again.
However: When canceling during execution, the module does not transfer any deactivations (Cancel) to the driver.
If this property is active during runtime monitoring, the Cancel button in the command screen becomes active. As a result, the user can end runtime monitoring by clicking on this button.

Default: inactive

Note: Only available for the command group command and Setpoint input. No timeout bit is set.

More in the online help.

VT_BOOL

UseQOC

Use Qualifier of Command

Only available if you have licensed the Energy Edition.

You can add additional information to commands (qualifier or command), if this is supported by the driver. Possible drivers: IEC850, IEC870 and DNP3.

active: Activates the input under Qualifier of command.

Note: Is only available for the command actions Auto/remote command, pulse command and mandatory command.

Default: inactive

VT_UI1

QOC

Qualifier of command

Enter a numerical value that will be sent to the driver as a command parameter. Depending on the driver, this parameter will have different effects.

  • IEC850: Values from 0 - 3 will be inserted in the Check field of commands; other values will be ignored.
  • IEC870: Values from 0 - 31 will be inserted in the QU field of commands; other values will be ignored.
  • DNP3: The value 1 means Pulse, all others mean Latch.

Minimum: 0
Maximum: 127
Default: 0

Note: This input possibility is only available if Use qualifier of command has been activated.

More in the online help.

VT_BSTR

Picture

Exp. menu spec. screen

VT_BOOL

Actual

Nominal/current value comparison

Active: A check is made to see if the value of the response variable already matches the switching direction to be carried out. If this is the case, an unlockable message is displayed in the command.
Inactive: The switching direction is not checked.
Note: Only active if the command group action pulse command has been selected

(Default) Inactive:

More in the online help

VT_BOOL

CloseMDIWnd

Close automatically

Active: The command screen is automatically closed after the action has been executed.
Inactive: The command screen is not automatically closed.
Not active if the auto/remote command action type is active.

(Default) Inactive:

More in the online help.

VT_BOOL

TwoLevel

two-stage

Active: The action will be executed after the control "Execute 2" has been confirmed.

Inactive: The action will be executed:

  • after unlocking the last interlocking
  • immediately, if no interlocking is active

Not active if the auto/remote command action type is active.

Default: active

More in the online help.

VT_BOOL

TwoHand

Two-hand operation

Only available for two-stage execution:

  • Active: The Execute 2 control element. Step can only be operated if the CTRL button is pressed at the same time.
    Attention: For the Execute 2nd step control element, the selectable with lasso property must not be active with two-hand operation.
  • Inactive: The control element can always be operated.

Default: inactive
Not active if the auto/remote command action type is active.

More in the online help.

VT_BSTR

CmdMenuID

Menu ID

Unique ID of the action. The menu ID is used for the creation of Context menus in the Runtime. If two actions are fitted with the same ID, they are tagged with a special symbol in the action tree. When compiling, there is also a check to see that the same command (value) per variable can only be used once.

More in the online help.

VT_UI2

PwlExecute

Authorization level for execution

Define the authorization level needed for locking. Click on level to open a drop-down list for selection.

More in the online help.

VT_UI2

PwlUnlock

Authorization level for unlocking

Defines the authorization level needed for unlocking. Click on level to open a drop-down list for selection.

Note: not active for mandatory command type commands

More in the online help.


CVerVar

Manual -> Programming interfaces -> Objectmodel -> Interlocking -> Interlocking-Dynamic properties -> CVerVar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
ZT_VARIABLE_DYN | Name | Interlocking variable | Variable which can be used for the interlocking condition. By clicking button ..., you can exchange the variable without having to adapt the formula. More in the online help.


Interlocking

Manual -> Programming interfaces -> Objectmodel -> Interlocking -> Interlocking-Dynamic properties -> Interlocking

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

Actions

Actions

More...

Variables

Variables

VT_BOOL

IsGeneral

IsGeneral

VT_BSTR

Name

Name

Distinct name of the interlocking or command input.
Default: Interlocking/command group x (where x represents a consecutive number).
Attention: This property is not available for language switch.

More in the online help about creating:

- Interlocking

- Command Processing

VT_BSTR

TTA

TTA Imp/Exp

ZT_VARIABLE_DYN

ValueVariable

Result variable

Shows the result of the interlocking condition on the selected variable.

A click on the button opens the dialog for selecting the variable. You can also enter the name of the variable directly in the input field.

More in the online help

ZT_VARIABLE_DYN

ReturnInformation

Variable name of response

Variable name or the mask for replacing the response variable.
The placeholder for the substitution text is the character '*’ within a name. Only one placeholder can be used in a name. When entering the mask, it is important to take care that this name results in an existing variable name after replacement.
If the variable that is used here (substituted or absolute) does not exist during the creation of the Runtime files, the command group will not be available in the Runtime. An according message announces this error during the creation of the Runtime files.
Direct entry or opening the dialog for selecting variables.

More in the online help

VT_UI1

WatchDogTimer

Watchdog timer

Determines the process of the watchdog timer.

Note: This runtime monitoring is only active for switching commands and pulse commands.

  • none: no watchdog timer
  • Only via response variable (RV): The value of the response variable is used to determine if the command was successful. The monitoring is activated only if the value to be written does not equal the current value of the action variable.
  • Only via cause of transmission (COT): COT (Cause of Transmission) is used to check whether the process was successful.
    For the 'Command' action, the status bits of the cause of transmission (COTx) are evaluated. The monitoring is concluded if COT_actterm (10) has been reached.
  • Via COT and RV: waits and reacts to COT and to value changes of the response variable. Combines the properties of Only on response variable (RV) and Only on cause of transmission (COT).

In general, the following applies: If runtime monitoring is not ended successfully within the Timeout configured for the action, the status bit TIMEOUT is set.

Default: none.

More in the online help.

VT_BOOL

DesiredDirection

Set status PROGRESS

Active: For actions Command and Manual corrections status bit In progress (PROGRESS) is set at the response variable if the actions are triggered in the Runtime.
The bit is used to implement a graphical display in order to show the user that an action is carried out at the moment. With the help of the combined element or a reaction matrix you can check the status bit and implement a graphical display.

Inactive: The status bit is not set.

Default: Inactive.

More in the online help

VT_BSTR

Picture

Exp. menu spec. screen

VT_BOOL

Modal

Screen modal

Active: The command is switched to modal regardless of the 'Modal dialog' property of the screen. This means that other screens can only be operated once the screen has been closed.
Inactive: The command screen is switched normally.
Default: inactive.

More in the online help.

VT_BOOL

RM-Titel

Screen title from response variable

Active: The identification of the response variable is used as screen title.
Inactive: The name of the screen is used as screen title.
Default: inactive.
Attention: For activating the screen title you must in addition activate property Title in the respective frame.

More in the online help.

VT_BOOL

CBTR_Act

Breaker tripping detection

Only available if property Set status PROGRESS is activated.

Active: Response variable is monitored for an unexpected change from <> 0 to 0.

Default: inactive

More in the online help.

VT_BSTR

CBTR_Formula

Suppress detection

Entering the formula with which the detection of a breaker tripping can be suppressed. A click on button ... opens the formula editor.

For the formula, all variables from the list of command groups can be used; name replacements with '*' are possible, as with the definition of the Interlocking conditions of an action.

Note: Variables that are used in the formula cannot be deleted from the list of the command group.

More in the online help.

ZT_AKZ

SystemModelGroup

Equipment groups

Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group.

More in the online help.


Interlockings

Manual -> Programming interfaces -> Objectmodel -> Interlockings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With the interlockings object you have the opportunity to create and edit interlockings in the list.

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub Interlockings()

Dim zInterlockings As Interlockings 'Object from type Interlockings
Dim zInterlocking As Interlocking 'Child object from type Interlockings

'Fill the objects
Set zInterlockings = MyWorkspace.ActiveDocument.Interlockings
'Creates an interlocking called "Interlocking" with an assignment
Set zInterlocking = zInterlockings.Create("Interlocking", False)
Call InterlockingsItem

End Sub

Sub InterlockingsItem()

Dim zInterlockings As Interlockings 'Object from type Interlockings
Dim zInterlocking As Interlocking 'Child object from type Interlockings

'Fill the objects
Set zInterlockings = MyWorkspace.ActiveDocument.Interlockings
'Returns an interlocking out of the list
Set zInterlocking = zInterlockings.Item("Interlocking")
'Rename the interlocking
zInterlocking.DynProperties("Name") = "My_Interlocking"

End Sub

Other topics in this chapter

Interlockings-Properties

Interlockings-Methods


Interlockings-Properties

Manual -> Programming interfaces -> Objectmodel -> Interlockings -> Interlockings-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Returns the amount of interlockings. | read only | read only
IProject | Parent | Returns the parent of the interlockings object. | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> Interlockings -> Interlockings-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object.

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> Interlockings -> Interlockings-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Interlockings-Methods

Manual -> Programming interfaces -> Objectmodel -> Interlockings -> Interlockings-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IInterlocking | Create | Creates a new interlocking. | available | not used
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | Import | Imports the selected XML file | available | not used
IInterlocking | Item | Returns the interlocking at the given index. | available | not used
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used

Other topics in this chapter

Item

Create

SingleExport

Export

Import


Item

Manual -> Programming interfaces -> Objectmodel -> Interlockings -> Interlockings-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the object "Interlocking" from the collection, which is identified by the parameter vItem.The parameter vItem can have two values:<ul><li>Index: Access with an index mostly is used in combination with the property Count to find out the position of the object in the list.</li><li>Name: The interlocking can also be accessed with its unique name.</li></ul>Hint:The returned object should always be checked on Nothing, for the case that no object was found for the search criteria.

Datatype

Item(VARIANT vItem) As Interlocking

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Index or name of the "Interlocking" object within the collection.

If the parameter is a numerical value, the object is searched by its index (>= 0 and <= Count-1).
If it is an alphanumerical value, the object is searched by its unique name.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vItem As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub InterlockingsItem()

Dim zInterlockings As Interlockings 'Object from type Interlockings
Dim zInterlocking As Interlocking 'Child object from type Interlockings

'Fill the objects
Set zInterlockings = MyWorkspace.ActiveDocument.Interlockings
'Returns an interlocking out of the list
Set zInterlocking = zInterlockings.Item("Interlocking 1")
'Rename the interlocking
zInterlocking.DynProperties("Name") = "My_Interlocking"

End Sub


Create

Manual -> Programming interfaces -> Objectmodel -> Interlockings -> Interlockings-Methods -> Create

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new Interlocking an returns this new object.

Datatype

Create(String bsName,Boolean bCommand) As Interlocking

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Name as string.

If this value is set to 'True' then a "Command" is created instead of an "Assignment".
"Commands" are only available within an "Energy Edition - License"!

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsName As String

bCommand As Boolean

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub Interlockings()

Dim zInterlockings As Interlockings 'Object from type Interlockings
Dim zInterlocking As Interlocking 'Object from type Interlocking

'Fill the objects
Set zInterlockings = MyWorkspace.ActiveDocument.Interlockings
'Creates an interlocking called "Interl_1" with an assignment
Set zInterlocking = zInterlockings.Create("Interl_1", False)
Debug.Print "Count = " & zInterlockings.Count

End Sub


SingleExport

Manual -> Programming interfaces -> Objectmodel -> Interlockings -> Interlockings-Methods -> SingleExport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SingleExport(VARIANT vIndexOrName,String bsFileName,Boolean bCommand) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Export

Manual -> Programming interfaces -> Objectmodel -> Interlockings -> Interlockings-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export settings to an xml file

Datatype

Export(String bsFileName, Boolean bCommand) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to export.

Interlocking | False
Command | True
C#
C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

bCommand As Boolean

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)

'Export settings to an xml file
zenOnObject.Export ("C:\zenOn_eXaMpLe.xml, False") 'Interlocking

'Import settings from an xml file
zenOnObject.Import ("C:\zenOn_eXaMpLe.xml, False") 'Interlocking

End Sub


Import

Manual -> Programming interfaces -> Objectmodel -> Interlockings -> Interlockings-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced.

Datatype

Import(String bsFileName, Boolean bCommand) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to export.

Interlocking | False
Command | True
C#
C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

bCommand As Boolean

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)

'Export settings to an xml file
zenOnObject.Export ("C:\zenOn_eXaMpLe.xml, False") 'Interlocking

'Import settings from an xml file
zenOnObject.Import ("C:\zenOn_eXaMpLe.xml, False") 'Interlocking

End Sub


LanguageTable

Manual -> Programming interfaces -> Objectmodel -> LanguageTable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Represents the language table of the project.

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Dim ILang As LanguageTable

Set ILang = MyWorkspace.ActiveDocument.LanguageTable

Other topics in this chapter

LanguageTable-Properties

LanguageTable-Methods


LanguageTable-Properties

Manual -> Programming interfaces -> Objectmodel -> LanguageTable -> LanguageTable-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Count of Files in the Language Table | available | not used
IProject | Parent | Parent-object | available | not used

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> LanguageTable -> LanguageTable-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The property „Parent" is a reference to the parent object, the project to which the language table corresponds.

Datatype

Parent() As Project

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> LanguageTable -> LanguageTable-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The property „Count" contains the number of all files from the language table.

Datatype

Count() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


LanguageTable-Methods

Manual -> Programming interfaces -> Objectmodel -> LanguageTable -> LanguageTable-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CreateFile | Creates a new File in the Language Table | available | not used
VARIANT_BOOL | DeleteFile | Deletes a File from the Language Table | available | not used
VARIANT_BOOL | DeleteKey | Deletes a Key from all Files of the Language Table | available | not used
BSTR | GetString | Returns a String from the Language Table | available | not used
VARIANT_BOOL | ImportFile | Imports (and merges) an existing File into the Language Table | available | not used
IFileManagerFileItem | Item | Returns the File by Name or Position | available | not used
VARIANT_BOOL | SetString | Sets a String in the Language Table | available | not used

Other topics in this chapter

Item

CreateFile

DeleteFile

SetString

GetString

DeleteKey

ImportFile


Item

Manual -> Programming interfaces -> Objectmodel -> LanguageTable -> LanguageTable-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method „Item" returns a language table file as „FileManagerFileItem" object. The file can be chosen either by the name or by the index.

The file can as well be renamed over the returned object FileManagerItem.

In case of multi user projects, the files have to be "checked out" (allow changes) in order to be editable.

Datatype

Item(VARIANT vID) As FileManagerFileItem

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub LangItem()
Dim ILang As LanguageTable
Dim IFile As FileManagerFileItem

Set ILang = MyWorkspace.ActiveDocument.LanguageTable
Set IFile = ILang.Item("ENGLISH.TXT")
Debug.Print IFile.FileName
Set IFile = ILang.Item(3)
Debug.Print IFile.FileName
End Sub

Private Sub LangRename()

Dim ILang As LanguageTable

Dim IFile As FileManagerFileItem

Set ILang = MyWorkspace.ActiveDocument.LanguageTable

Set IFile = ILang.Item("ENGLISH.TXT")

If Not IFile Is Nothing Then

IFile.FileName = "FRENCH.TXT"

End If

End Sub

Private Function CheckOutAll() As Boolean

Dim Ok As Boolean

Dim Cnt, i As Integer

Dim ILang As LanguageTable

Dim IFile As FileManagerFileItem

Set ILang = MyWorkspace.ActiveDocument.LanguageTable

CheckOutAll = True

Cnt = ILang.Count

For i = 0 To Cnt - 1

Set IFile = ILang.Item(i)

If Not IFile Is Nothing Then

If Not IFile.IsLocked And Not IFile.IsCheckedOut Then

CheckOutAll = CheckOutAll And IFile.CheckOut

End If

End If

Next

End Function


CreateFile

Manual -> Programming interfaces -> Objectmodel -> LanguageTable -> LanguageTable-Methods -> CreateFile

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method „CreateFile" creates a new, empty file in the language table.

Datatype

CreateFile(String Name) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub LangCreate()
Dim ILang As LanguageTable
Dim IFile As FileManagerFileItem
Set ILang = MyWorkspace.ActiveDocument.LanguageTable
'Create a new empty file
ILang.CreateFile("ENGLISH.TXT")
End Sub


DeleteFile

Manual -> Programming interfaces -> Objectmodel -> LanguageTable -> LanguageTable-Methods -> DeleteFile

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method „DeleteFile" removes a file from the language table.

Datatype

DeleteFile(String Name) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub LangDelete()
Dim ILang As LanguageTable
Set ILang = MyWorkspace.ActiveDocument.LanguageTable
ILang.DeleteFile("ENGLISH.TXT")
End Sub


SetString

Manual -> Programming interfaces -> Objectmodel -> LanguageTable -> LanguageTable-Methods -> SetString

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method "SetString" inserts a new key word/translation pair into the language table.

Datatype

SetString(String File, String Key, String Text) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub LangFill()
Dim i As Integer
Dim Ok As Boolean
Dim ILang As LanguageTable
Dim IFile As FileManagerFileItem
Set ILang = MyWorkspace.ActiveDocument.LanguageTable
Set IFile = ILang.Item("ENGLISH.TXT")
If Not IFile Is Nothing Then
If Not IFile.IsLocked And Not IFile.IsCheckedOut Then IFile.CheckOut
If IFile.IsCheckedOut Then
Ok = ILang.SetString("ENGLISH.TXT", "Motor", "Engine")
Ok = ILang.SetString("ENGLISH.TXT", "Schalter", "Switch")
End If
End If
End Sub


GetString

Manual -> Programming interfaces -> Objectmodel -> LanguageTable -> LanguageTable-Methods -> GetString

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method "GetString" returns the translation of a key text.

Datatype

GetString(String File, String Key) As String

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub GetKey()
Dim ILang As LanguageTable
Set ILang = MyWorkspace.ActiveDocument.LanguageTable
Debug.Print ILang.GetString("ENGLISH.TXT", "Motor")
End Sub


DeleteKey

Manual -> Programming interfaces -> Objectmodel -> LanguageTable -> LanguageTable-Methods -> DeleteKey

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method "DeleteKey" deletes a key text and all its translations from the language table.

Datatype

DeleteKey(String Key) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub KeyDelete()
Dim ILang As LanguageTable
Set ILang = MyWorkspace.ActiveDocument.LanguageTable
If CheckOutAll Then
ILang.DeleteKey("Motor")
End If
End Sub


ImportFile

Manual -> Programming interfaces -> Objectmodel -> LanguageTable -> LanguageTable-Methods -> ImportFile

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method „ImportFile" imports a file into the language table. The translations of the imported file are inserted to an already existing file with the same name (see above "import from text file") or if any other file with the same name exists, it will be inserted as a new file.

Datatype

ImportFile(String Name) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub LangImport()

Dim Ok As Boolean

Dim ILang As LanguageTable

Dim IFile As FileManagerFileItem

Set ILang = MyWorkspace.ActiveDocument.LanguageTable

Set IFile = ILang.Item("DEUTSCH.TXT")

If Not IFile Is Nothing Then

If Not IFile.IsLocked And Not IFile.IsCheckedOut Then IFile.CheckOut

End If

Ok = ILang.ImportFile("C:\DEUTSCH.TXT")

End Sub


Limit

Manual -> Programming interfaces -> Objectmodel -> Limit

Remarks

The collection Variables contains all defined limits of a variable.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public Sub zenOn_Limit()
Dim zVAR As Variable
Dim zLimit As Limit
Dim vDynProps As Variant
Dim strDynProp As String

'set variable object to get the limits collection
Set zVAR = thisProject.Variables.Item("WIZ_VAR_10")
'set limit object
Set zLimit = zVAR.Limits.Item(0)

'read all Default Properties from a limit
With zLimit
'generate some output information
Debug.Print "Text: " & .Text
Debug.Print "Value: " & .Value
Debug.Print "AlarmClass: " & .AlarmClass
Debug.Print "AlarmGroup: " & .AlarmGroup
End With

'read all DynProperties from a limit
vDynProps = zLimit.DynPropertiesEnum("")
For Each strItem In vDynProps
strDynProp = Mid(strItem, 1, InStr(1, strItem, ",") - 1)
Debug.Print "--------------------"
Debug.Print strItem
Debug.Print zLimit.DynProperties(strDynProp)
Next
End Sub

Other topics in this chapter

Limit-Properties

Limit-Methods


Limit-Properties

Manual -> Programming interfaces -> Objectmodel -> Limit -> Limit-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
short | AlarmClass | Alarmclass | not used | read only
short | AlarmGroup | Alarmgroup | not used | read only
Limits | Parent | Parent-object | read only | read only
BSTR | Text | Alarmtext | not used | read only
double | Value | Value | not used | read only

Other topics in this chapter

Parent

Value

Text

AlarmGroup

AlarmClass


Parent

Manual -> Programming interfaces -> Objectmodel -> Limit -> Limit-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Limits

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Value

Manual -> Programming interfaces -> Objectmodel -> Limit -> Limit-Properties -> Value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns/sets the limit, at which the current status occurs. The current status occurs – depending on the setting Min or Max – on violating this limit.The setting Min or Max cannot be changed via VBA. The methods IsMin and IsMax can check the type of the limit.

Datatype

Value() As double

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Text

Manual -> Programming interfaces -> Objectmodel -> Limit -> Limit-Properties -> Text

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns/sets the limit text. For reading operations the translated string – in the current language of the Runtime – is returned.Allocating a limit directly changes the key of the entry – i.e. different to reading access, where the string is translated to the current language of the project.

Datatype

Text() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


AlarmGroup

Manual -> Programming interfaces -> Objectmodel -> Limit -> Limit-Properties -> AlarmGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the ID of the defined alarm group for the actual limit.At the moment the alarm group is not available as an object.

Datatype

AlarmGroup() As short

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


AlarmClass

Manual -> Programming interfaces -> Objectmodel -> Limit -> Limit-Properties -> AlarmClass

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the ID of the defined alarm class for the actual limit.At the moment the alarm class is not available as an object.

Datatype

AlarmClass() As short

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Limit-Methods

Manual -> Programming interfaces -> Objectmodel -> Limit -> Limit-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
VARIANT_BOOL | IsMax | - | available | not used
VARIANT_BOOL | IsMin | - | available | not used
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

IsMin

IsMax


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> Limit -> Limit-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> Limit -> Limit-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> Limit -> Limit-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> Limit -> Limit-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


IsMin

Manual -> Programming interfaces -> Objectmodel -> Limit -> Limit-Methods -> IsMin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns 'True' if the type of the current limit is 'Min', violated as soon as the current value is lower. Otherwise it is a maximal limit.

Datatype

IsMin() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsMax

Manual -> Programming interfaces -> Objectmodel -> Limit -> Limit-Methods -> IsMax

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns 'True' if the type of the current limit is 'Max', violated as soon as the current value is higher. Otherwise it is a minimum limit.

Datatype

IsMax() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Limits

Manual -> Programming interfaces -> Objectmodel -> Limits

Remarks

The collection Limits contains the defined limits of a variable. With this collection you can access the defined limits.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public Sub zenOn_Limits()
Dim zVAR As Variable
Dim zLimit As Limit
Dim i As Integer

'set variable object to get the limits collection
Set zVAR = thisProject.Variables.Item("WIZ_VAR_10")

'enumerate all limits of the variable
For i = 0 To zVAR.Limits.Count - 1
Set zLimit = zVAR.Limits.Item(i)
Debug.Print "LIMIT " & (i + 1) & ":"
With zLimit
'generate some output information
Debug.Print "Text: " & .Text
Debug.Print "Value: " & .Value
Debug.Print "AlarmClass: " & .AlarmClass
Debug.Print "AlarmGroup: " & .AlarmGroup
Debug.Print "Status: " & .DynProperties("Status")
End With
Next i
End Sub

Other topics in this chapter

Limits-Properties

Limits-Methods


Limits-Properties

Manual -> Programming interfaces -> Objectmodel -> Limits -> Limits-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Count of defined limits | read only | read only
IVariable | Parent | Parent-object | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> Limits -> Limits-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Variable

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> Limits -> Limits-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Limits-Methods

Manual -> Programming interfaces -> Objectmodel -> Limits -> Limits-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
ILimit | Item | Returns limit on the given position | available | available

Other topics in this chapter

Item


Item

Manual -> Programming interfaces -> Objectmodel -> Limits -> Limits-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a "Limit" object by its position.

Datatype

Item(long iIndex) As Limit

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


MdiElement

Manual -> Programming interfaces -> Objectmodel -> MdiElement

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The availibility and functionality of MDI elements, also called control elements within zenOn, depend on the corresponding Screen type. This collection returns the default settings of the MDI elements.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_MdiElements()
'Declarations
Dim zPIC As DynPicture
Dim zMDIs As MdiElements
Dim i As Integer

'Initialize zPIC with the ALARM Screen
Set zPIC = MyWorkspace.ActiveDocument.DynPictures.Item("ALARM")
'Initialize zMDIs with the available MDI elements for the ALARM Screen
Set zMDIs = zPIC.MdiElements

'For every MDI element in the ALARM Screen...
For i = 0 To zMDIs.Count - 1
'... output the details
With zMDIs.Item(i)
Debug.Print "Caption: " & .Caption
Debug.Print "Position left: " & .Left
Debug.Print "Position top: " & .Top
Debug.Print "Width: " & .Width
Debug.Print "Height: " & .Height
End With
Next i
End Sub

Other topics in this chapter

MdiElement-Properties

MdiElement-Methods

MdiElement-Dynamic properties


MdiElement-Properties

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
long | Type | read only | available | yes | yes
OLE_COLOR | BackColor | available | read only | yes | yes
BSTR | Caption | available | not used | yes | yes
OLE_COLOR | ForeColor | available | read only | yes | yes
long | Height | available | read only | yes | yes
long | ID | available | not used | yes | yes
VARIANT_BOOL | IsDefault | available | not used | yes | yes
long | Left | available | read only | yes | yes
IMdiElements | Parent | read only | read only | yes | yes
long | Top | available | read only | yes | yes
tpElementTypes | Type | read only | available | yes | yes
long | Width | available | read only | yes | yes

Other topics in this chapter

Parent

IsDefault

Type

ID

Caption

ForeColor

BackColor

Left

Top

Width

Height


Parent

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As MdiElements

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


IsDefault

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Properties -> IsDefault

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns TRUE, if the "MdiElement" object belongs to the default elements.

Datatype

IsDefault() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Type

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Properties -> Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Type of the "Element" object.

Datatype

Type() As long

Availability

Environment | Available
Editor | read only
Runtime | available
VBA | yes
VSTA | yes


ID

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Properties -> ID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the unique ID of the "MdiElement" object.

Datatype

ID() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Caption

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Properties -> Caption

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Name of the linked picture type specific function.

Datatype

Caption() As String

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


ForeColor

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Properties -> ForeColor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ForeColor() As OLE_COLOR

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


BackColor

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Properties -> BackColor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

BackColor() As OLE_COLOR

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Left

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Properties -> Left

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the position of the left window border of the element in pixel. The value defines the distance from the top border of the screen.

Datatype

Left() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Top

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Properties -> Top

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the position of the top window border of the element in pixel. The value defines the distance from the top border of the screen.

Datatype

Top() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Width

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Properties -> Width

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Width of the element (in pixel).

Datatype

Width() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Height

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Properties -> Height

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Height of the element (in pixels).

Datatype

Height() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


MdiElement-Methods

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


MdiElement-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

MDI elements default list

Other topics in this chapter

MDI elements default list


MDI elements default list

Manual -> Programming interfaces -> Objectmodel -> MdiElement -> MdiElement-Dynamic properties -> MDI elements default list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_UI4 | MenuID | MenuID |
VT_BOOL | Default | Default |
VT_UI2 | Type | Type |
VT_I4 | ID | ID |
VT_BSTR | Text | Text | The dialog for the definition of the formula for the Mathematics variable is opened.
VT_UI4 | Style | Style |
VT_UI4 | StyleMask | StyleMask |
VT_UI4 | TextColor | TextColor |
VT_UI4 | BackColor | BackColor |
VT_UI4 | Info | Info |
VT_I4 | Top | Top |
VT_I4 | Left | Left |
VT_I4 | Height | Height |
VT_I4 | Width | Width | Name of the inserted file.


MdiElements

Manual -> Programming interfaces -> Objectmodel -> MdiElements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This object manages "MdiElement" objects.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_MdiElements()
'Declarations
Dim zPIC As DynPicture
Dim zMDIs As MdiElements
Dim i As Integer

'Initialize zPIC with the ALARM Screen
Set zPIC = MyWorkspace.ActiveDocument.DynPictures.Item("ALARM")
'Initialize zMDIs with the available MDI elements for the ALARM Screen
Set zMDIs = zPIC.MdiElements

'For every MDI element in the ALARM Screen...
For i = 0 To zMDIs.Count - 1
'... which is not a default element...
If Not zMDIs.Item(i).IsDefault Then
'... output the caption of the element.
Debug.Print zMDIs.Item(i).Caption
End If
Next i
End Sub

Other topics in this chapter

MdiElements-Properties

MdiElements-Methods


MdiElements-Properties

Manual -> Programming interfaces -> Objectmodel -> MdiElements -> MdiElements-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Returns count of the elements | read only | read only
IDynPicture | Parent | The parent object of the current object | read only | read only
VARIANT_BOOL | UseProfile | - | read only | not used

Other topics in this chapter

Parent

Count

UseProfile


Parent

Manual -> Programming interfaces -> Objectmodel -> MdiElements -> MdiElements-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As DynPicture

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> MdiElements -> MdiElements-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


UseProfile

Manual -> Programming interfaces -> Objectmodel -> MdiElements -> MdiElements-Properties -> UseProfile

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns TRUE, if profile elements are available for this type of object.

Datatype

UseProfile() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes


MdiElements-Methods

Manual -> Programming interfaces -> Objectmodel -> MdiElements -> MdiElements-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IMdiElement | Item | Returns a object at a position or by a specified key | available | available

Other topics in this chapter

Item


Item

Manual -> Programming interfaces -> Objectmodel -> MdiElements -> MdiElements-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the object Element from the collection, which is identified by the parameter vID. The parameter vID can have two values:

  • Index: Access with an index is mostly used in combination with the property Count to find out the position of the variable object in the list.
  • Element name: The element can also be accessed with its unique name.

Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vElementID) As MdiElement

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


MDITemplate

Manual -> Programming interfaces -> Objectmodel -> MDITemplate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Private Sub GetTemplates()
Dim IMDITemplates As MDITemplates
Dim IMDITemplate As MDITemplate
Dim Count As Integer
Dim Ok As Boolean
Dim i As Integer

' --- Selection by Name
Set IMDITemplates = MyWorkspace.GetMDiTemplates("Keyboard")
If Not IMDITemplates Is Nothing Then
Set IMDITemplate = IMDITemplates.Item("Test 3")
Ok = PrintTemplate(IMDITemplate)
End If

' --- Selection by index (zenon Constant)
Set IMDITemplates = MyWorkspace.GetMDiTemplates(tpKeyboard)
If Not IMDITemplates Is Nothing Then
Count = IMDITemplates.Count
For i = 0 To Count - 1
Set IMDITemplate = IMDITemplates.Item(i)
Ok = PrintTemplate(IMDITemplate)
Next
End If
End Sub

Private Function PrintTemplate(IMDITemplate As MDITemplate) As Boolean
If Not IMDITemplate Is Nothing Then
Debug.Print ("Name: " & IMDITemplate.DynProperties("Name"))
Debug.Print ("GUID: " & IMDITemplate.DynProperties("GUID"))
Debug.Print ("ImportPath: " & IMDITemplate.DynProperties("ImportPath"))
Debug.Print ("Folder: " & IMDITemplate.DynProperties("Folder"))
Debug.Print ("MDIType: " & IMDITemplate.DynProperties("MDIType"))
Debug.Print ("Language: " & IMDITemplate.DynProperties("Language"))
Debug.Print ("Description: " & IMDITemplate.DynProperties("Description"))
Debug.Print ("CopaDataTemplate: " & IMDITemplate.DynProperties("CopaDataTemplate"))
Debug.Print ("DefaultTemplate: " & IMDITemplate.DynProperties("DefaultTemplate"))
PrintTemplate = True
Else
PrintTemplate = False
End If
End Function

Other topics in this chapter

MDITemplate-Methods

MDITemplate-Dynamic properties


MDITemplate-Methods

Manual -> Programming interfaces -> Objectmodel -> MDITemplate -> MDITemplate-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT | DynProperties [GET] | - | read only | not used
VARIANT | DynPropertiesEnum [GET] | - | read only | not used
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> MDITemplate -> MDITemplate-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> MDITemplate -> MDITemplate-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> MDITemplate -> MDITemplate-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub GetTemplates()
Dim IMDITemplates As MDITemplates
Dim IMDITemplate As MDITemplate
Dim Count As Integer
Dim Ok As Boolean
Dim i As Integer

' --- Selection by Name
Set IMDITemplates = MyWorkspace.GetMDiTemplates("Keyboard")
If Not IMDITemplates Is Nothing Then
Set IMDITemplate = IMDITemplates.Item("Test 3")
Ok = PrintTemplate(IMDITemplate)
End If

' --- Selection by index (zenon Constant)
Set IMDITemplates = MyWorkspace.GetMDiTemplates(tpKeyboard)
If Not IMDITemplates Is Nothing Then
Count = IMDITemplates.Count
For i = 0 To Count - 1
Set IMDITemplate = IMDITemplates.Item(i)
Ok = PrintTemplate(IMDITemplate)
Next
End If
End Sub

Private Function PrintTemplate(IMDITemplate As MDITemplate) As Boolean
If Not IMDITemplate Is Nothing Then
Debug.Print ("Name: " & IMDITemplate.DynProperties("Name"))
Debug.Print ("GUID: " & IMDITemplate.DynProperties("GUID"))
Debug.Print ("ImportPath: " & IMDITemplate.DynProperties("ImportPath"))
Debug.Print ("Folder: " & IMDITemplate.DynProperties("Folder"))
Debug.Print ("MDIType: " & IMDITemplate.DynProperties("MDIType"))
Debug.Print ("Language: " & IMDITemplate.DynProperties("Language"))
Debug.Print ("Description: " & IMDITemplate.DynProperties("Description"))
Debug.Print ("CopaDataTemplate: " & IMDITemplate.DynProperties("CopaDataTemplate"))
Debug.Print ("DefaultTemplate: " & IMDITemplate.DynProperties("DefaultTemplate"))
PrintTemplate = True
Else
PrintTemplate = False
End If
End Function


MDITemplate-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> MDITemplate -> MDITemplate-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

MDI data template

Other topics in this chapter

MDI data template


MDI data template

Manual -> Programming interfaces -> Objectmodel -> MDITemplate -> MDITemplate-Dynamic properties -> MDI data template

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Name | Name | Given name of the template.
VT_BSTR | GUID | GUID | Guid of the Template. E.g. 5d1c2408-29b4-4cb9-95578-562jj458990
VT_BSTR | ImportPath | ImportPath | Import path of the template.
VT_BSTR | Folder | Folder | Path where the templates is stored. eg. C:\ProgramData\COPA-DATA\zenon700\Templates\ScreenTypes\ENGLISH\Alarm Message list\5d1c2408-29b4-4cb9-95578-562jj458990.zip
VT_UI4 | MDIType | MDIType | Type of the templates ( Constants tpDynPicturesTypes)
VT_BSTR | Language | Language | Language of the template.
VT_BSTR | Description | Description | Description of the template.
VT_BOOL | CopaDataTemplate | CopaDataTemplate | True=Copa Date template False= Customer created templated
VT_BOOL | DefaultTemplate | DefaultTemplate | TRUE= Default template FALSE= none default template
VT_UI4 | ScreenX | ScreenX | Screen width.
VT_UI4 | ScreenY | ScreenY | Screen height.
VT_UI4 | Width | Width | Widthof the template.
VT_UI4 | Height | Height | Heigth of the template.


MDITemplates

Manual -> Programming interfaces -> Objectmodel -> MDITemplates

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Private Sub GetTemplates()
Dim IMDITemplates As MDITemplates
Dim IMDITemplate As MDITemplate
Dim Count As Integer
Dim Ok As Boolean
Dim i As Integer

' --- Selection by Name
Set IMDITemplates = MyWorkspace.GetMDiTemplates("Keyboard")
If Not IMDITemplates Is Nothing Then
Set IMDITemplate = IMDITemplates.Item("Test 3")
Ok = PrintTemplate(IMDITemplate)
End If

' --- Selection by index (zenon Constant)
Set IMDITemplates = MyWorkspace.GetMDiTemplates(tpKeyboard)
If Not IMDITemplates Is Nothing Then
Count = IMDITemplates.Count
For i = 0 To Count - 1
Set IMDITemplate = IMDITemplates.Item(i)
Ok = PrintTemplate(IMDITemplate)
Next
End If
End Sub

Private Function PrintTemplate(IMDITemplate As MDITemplate) As Boolean
If Not IMDITemplate Is Nothing Then
Debug.Print ("Name: " & IMDITemplate.DynProperties("Name"))
Debug.Print ("GUID: " & IMDITemplate.DynProperties("GUID"))
Debug.Print ("ImportPath: " & IMDITemplate.DynProperties("ImportPath"))
Debug.Print ("Folder: " & IMDITemplate.DynProperties("Folder"))
Debug.Print ("MDIType: " & IMDITemplate.DynProperties("MDIType"))
Debug.Print ("Language: " & IMDITemplate.DynProperties("Language"))
Debug.Print ("Description: " & IMDITemplate.DynProperties("Description"))
Debug.Print ("CopaDataTemplate: " & IMDITemplate.DynProperties("CopaDataTemplate"))
Debug.Print ("DefaultTemplate: " & IMDITemplate.DynProperties("DefaultTemplate"))
PrintTemplate = True
Else
PrintTemplate = False
End If
End Function

Other topics in this chapter

MDITemplates-Properties

MDITemplates-Methods


MDITemplates-Properties

Manual -> Programming interfaces -> Objectmodel -> MDITemplates -> MDITemplates-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Count of MDI Templates in the Collection | available | not used

Other topics in this chapter

Count


Count

Manual -> Programming interfaces -> Objectmodel -> MDITemplates -> MDITemplates-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Count() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


MDITemplates-Methods

Manual -> Programming interfaces -> Objectmodel -> MDITemplates -> MDITemplates-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IMDITemplate | Item | Returns the MDI Template by Name or Position | available | not used

Other topics in this chapter

Item


Item

Manual -> Programming interfaces -> Objectmodel -> MDITemplates -> MDITemplates-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Item(VARIANT vPosOrName) As MDITemplate

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


MessageControl

Manual -> Programming interfaces -> Objectmodel -> MessageControl

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The collection Projects contains all projects loaded in the Runtime. The single projects of the Runtime are available as objects Project in VBA. It is not possible to create an object of this type with the attribute New.

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

'====================================================================================================
' MessageControl Workspace
'====================================================================================================
Private Sub MessageControl_Sample()
Dim zMessage As MessageControlMessage
Dim zMessageControl As MessageControl
Dim i As Integer
Dim count As Integer

On Error GoTo ErrorHandler
Stop
'Get Message Control Properties
Set zMessageControl = MyWorkspace.ActiveDocument.MessageControl
With zMessageControl
Debug.Print ("Message Control active during Runtime start: " & CStr(.ActiveAtStartup))
Debug.Print ("Max. number of attemtps: " & CStr(.Attempts))
Debug.Print ("Detail level for Log in CEL: " & CStr(.CelDetail))
Debug.Print ("Waiting period between two attempts[min] : " & CStr(.TimeToWait))
Debug.Print ("Log manuel deletion of messages in the CEL : " & CStr(.LogMessageDeleteActions));
'Set Message Control Properties
.ActiveAtStartup = False
.Attempts = 5
.CelDetail = tpCelDetailNone
.TimeToWait = 15
.LogMessageDeleteActions = True
End With
Exit Sub
ErrorHandler:
Debug.Print ("Error :" & Err.Description & " " & Err.Number)
End Sub

Other topics in this chapter

MessageControl-Properties

MessageControl-Methods

MessageControl-Events

MessageControl-Dynamic properties


MessageControl-Properties

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | ActiveAtStartup |  | available | read only
short | Attempts |  | available | read only
tpMsgCtrlCelDetail | CelDetail |  | available | read only
VARIANT | CurrentQueue |  | not used | read only
VARIANT_BOOL | LogMessageDeleteActions |  | available | read only
short | TimeToWait |  | available | read only

Other topics in this chapter

TimeToWait

ActiveAtStartup

Attempts

CelDetail

CurrentQueue

LogMessageDeleteActions


TimeToWait

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Properties -> TimeToWait

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

TimeToWait() As short

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'====================================================================================================
' MessageControl Workspace
'====================================================================================================
Private Sub MessageControl_Sample()
Dim zMessage As MessageControlMessage
Dim zMessageControl As MessageControl
Dim i As Integer
Dim count As Integer

On Error GoTo ErrorHandler
Stop
'Get Message Control Properties
Set zMessageControl = MyWorkspace.ActiveDocument.MessageControl
With zMessageControl
Debug.Print ("Message Control active during Runtime start: " & CStr(.ActiveAtStartup))
Debug.Print ("Max. number of attemtps: " & CStr(.Attempts))
Debug.Print ("Detail level for Log in CEL: " & CStr(.CelDetail))
Debug.Print ("Waiting period between two attempts[min] : " & CStr(.TimeToWait))
Debug.Print ("Log manuel deletion of messages in the CEL : " & CStr(.LogMessageDeleteActions));
'Set Message Control Properties
.ActiveAtStartup = False
.Attempts = 5
.CelDetail = tpCelDetailNone
.TimeToWait = 15
.LogMessageDeleteActions = True
End With
Exit Sub
ErrorHandler:
Debug.Print ("Error :" & Err.Description & " " & Err.Number)
End Sub


ActiveAtStartup

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Properties -> ActiveAtStartup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ActiveAtStartup() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Attempts

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Properties -> Attempts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Attempts() As short

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


CelDetail

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Properties -> CelDetail

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CelDetail() As tpMsgCtrlCelDetail

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'====================================================================================================
' MessageControl Workspace
'====================================================================================================
Private Sub MessageControl_Sample()
Dim zMessage As MessageControlMessage
Dim zMessageControl As MessageControl
Dim i As Integer
Dim count As Integer

On Error GoTo ErrorHandler
Stop
'Get Message Control Properties
Set zMessageControl = MyWorkspace.ActiveDocument.MessageControl
With zMessageControl
Debug.Print ("Message Control active during Runtime start: " & CStr(.ActiveAtStartup))
Debug.Print ("Max. number of attemtps: " & CStr(.Attempts))
Debug.Print ("Detail level for Log in CEL: " & CStr(.CelDetail))
Debug.Print ("Waiting period between two attempts[min] : " & CStr(.TimeToWait))
Debug.Print ("Log manuel deletion of messages in the CEL : " & CStr(.LogMessageDeleteActions));
'Set Message Control Properties
.ActiveAtStartup = False
.Attempts = 5
.CelDetail = tpCelDetailNone
.TimeToWait = 15
.LogMessageDeleteActions = True
End With
Exit Sub
ErrorHandler:
Debug.Print ("Error :" & Err.Description & " " & Err.Number)
End Sub


CurrentQueue

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Properties -> CurrentQueue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CurrentQueue() As VARIANT

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Dim WithEvents zMessageControl As MessageControl

Private Sub Project_Active()
Set zMessageControl = thisProject.MessageControl
End Sub

'====================================================================================================
' MessageControl Runtime
'====================================================================================================
Public Sub Macro_MessageControl()
Dim zMessageQueue As Variant
Dim zMessage As MessageControlMessage

Dim i As Integer
Dim count As Integer

On Error GoTo ErrorHandler
Stop
'Get Message Control Properties
Set zMessageControl = MyWorkspace.ActiveDocument.MessageControl
Debug.Print ("Message Control active druing Runtime start: " & CStr(zMessageControl.ActiveAtStartup))
Debug.Print ("Max. number of attemtps: " & CStr(zMessageControl.Attempts))
Debug.Print ("Detail level for Log in CEL: " & CStr(zMessageControl.CelDetail))
Debug.Print ("Waiting period between two attempts[min] : " & CStr(zMessageControl.TimeToWait))
Debug.Print ("Log manuel deletion of messages in the CEL : " & CStr(zMessageControl.LogMessageDeleteActions));

'Get Message Queue
zMessageQueue = zMessageControl.CurrentQueue
If zMessageQueue <> Empty Then
For i = 0 To UBound(zMessageQueue)
'Get Message Item informations (Read only)
Set zMessage = zMessageQueue(i)
Call ShowMessageInformation(zMessageQueue(i))
Next i
Else
Debug.Print ("No messages")
End If

Exit Sub
ErrorHandler:
Debug.Print ("Error :" & Err.Description & " " & Err.Number)
End Sub

Public Function ShowMessageInformation(ByVal obMessage As MessageControlMessage)
Debug.Print ("========================================================")
Debug.Print ("Message Guid: " & obMessage.Guid)
Debug.Print ("Numbers of attempt: " & CStr(obMessage.Attempts))
Debug.Print ("Max. number of attempts:" & CStr(obMessage.MaxAttempts))
Debug.Print ("Waiting period between two attempts [min]: " & CStr(obMessage.TimeToWait))
Debug.Print ("Used dispatcher type: " & CStr(obMessage.DispatcherType))
Debug.Print ("Destination: " & obMessage.Destination)
Debug.Print ("Customer identifier: " & obMessage.CustomIdentifier)
Debug.Print ("Title of the message: " & obMessage.Title)
Debug.Print ("Current message text: " & obMessage.MessageText)
Debug.Print ("Time stamp when message is sending: " & CStr(obMessage.Send))
Debug.Print ("Time stamp when message was sent: " & CStr(obMessage.Sent))
Debug.Print ("Acknowledge required: " & CStr(obMessage.AcknowledgeRequired))
Debug.Print ("Time limit when message must be acknowledged: " & CStr(obMessage.AcknowledgeTimeOut))
Debug.Print ("Dispatch type style: " & CStr(obMessage.TypeStyle)) 'User, Usergroup....
Debug.Print ("Destination type: " & CStr(obMessage.DestinationType))
Debug.Print ("Codes from function: " & CStr(obMessage.CodesFromFunction))
Debug.Print ("Cycle Counter: " & CStr(obMessage.CycleCounter))
Debug.Print ("========================================================")
End Function


LogMessageDeleteActions

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Properties -> LogMessageDeleteActions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

LogMessageDeleteActions() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'====================================================================================================
' MessageControl Workspace
'====================================================================================================
Private Sub MessageControl_Sample()
Dim zMessage As MessageControlMessage
Dim zMessageControl As MessageControl
Dim i As Integer
Dim count As Integer

On Error GoTo ErrorHandler
Stop
'Get Message Control Properties
Set zMessageControl = MyWorkspace.ActiveDocument.MessageControl
With zMessageControl
Debug.Print ("Message Control active during Runtime start: " & CStr(.ActiveAtStartup))
Debug.Print ("Max. number of attemtps: " & CStr(.Attempts))
Debug.Print ("Detail level for Log in CEL: " & CStr(.CelDetail))
Debug.Print ("Waiting period between two attempts[min] : " & CStr(.TimeToWait))
Debug.Print ("Log manuel deletion of messages in the CEL : " & Str(.LogMessageDeleteActions));
'Set Message Control Properties
.ActiveAtStartup = False
.Attempts = 5
.CelDetail = tpCelDetailNone
.TimeToWait = 15
.LogMessageDeleteActions = True
End With
Exit Sub
ErrorHandler:
Debug.Print ("Error :" & Err.Description & " " & Err.Number)
End Sub


MessageControl-Methods

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | DynProperties [PUT] | - | available | read only
VARIANT | DynProperties [GET] | - | available | read only
VARIANT | DynPropertiesEnum [GET] | - | available | read only
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


MessageControl-Events

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description |  | Editor | Runtime
void | MessageAcknowledged |  | not used |  | read only
void | MessageAcknowledgeTimeOut |  | not used |  | read only
void | MessageCreated |  | not used |  | available
void | MessageDeleted |  | not used |  | read only
void | MessageIn |  | not used |  | read only
void | MessageNegAcknowledged |  | not used |  | read only
void | MessageSendError |  | not used |  | read only
void | MessageSent |  | not used |  | read only
void | SelectionChanged |  | not used |  | read only

Other topics in this chapter

MessageCreated

MessageSent

MessageSendError

MessageAcknowledged

MessageNegAcknowledged

MessageAcknowledgeTimeOut

MessageDeleted

MessageIn

SelectionChanged


MessageCreated

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Events -> MessageCreated

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MessageCreated(AlarmItem obAlarmItem,IMessageControlMessage obMessage) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Dim WithEvents zMessageControl As MessageControl

Private Sub Project_Active()
Set zMessageControl = thisProject.MessageControl
End Sub

'====================================================================================================
' MessageControl Runtime
' It has been generates a new message in the system. The Message Control Message object
' corresponding to the actual message object which will be shipped later.
' Access to this object is only allowed within the event handler.
'====================================================================================================
Private Sub zMessageControl_MessageCreated(ByVal obAlarmItem As IAlarmItem, ByVal obMessage As IMessageControlMessage)
Stop
If Not obAlarmItem Is Nothing Then
Debug.Print (obAlarmItem.Name)
End If

If Not obMessage Is Nothing Then
Debug.Print ("Current message text: " & obMessage.MessageText)
' Only in this event it is possible to overrite the MessageControlMessage Object
obMessage.MessageText = "New message text"
End If
End Sub


MessageSent

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Events -> MessageSent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MessageSent(MessageControlMessage obMessage) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


MessageSendError

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Events -> MessageSendError

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MessageSendError(MessageControlMessage obMessage) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


MessageAcknowledged

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Events -> MessageAcknowledged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MessageAcknowledged(MessageControlMessage obMessage) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


MessageNegAcknowledged

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Events -> MessageNegAcknowledged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MessageNegAcknowledged(MessageControlMessage obMessage) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


MessageAcknowledgeTimeOut

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Events -> MessageAcknowledgeTimeOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MessageAcknowledgeTimeOut(MessageControlMessage obMessage) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


MessageDeleted

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Events -> MessageDeleted

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MessageDeleted(MessageControlMessage obMessage) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


MessageIn

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Events -> MessageIn

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MessageIn(String bsIdentifier,String bsMessage) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SelectionChanged

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Events -> SelectionChanged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SelectionChanged(LPVARIANT obSelection) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


MessageControl-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Message control

Other topics in this chapter

Message control


Message control

Manual -> Programming interfaces -> Objectmodel -> MessageControl -> MessageControl-Dynamic properties -> Message control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

ActiveAtStartup

Active during Runtime start

Active: Message Control is started together with the Runtime.

Default: active

More in the online help.

VT_BSTR

SubjectDyn

Dynamic part of the subject

Defines the project-specific part of the subject of incoming and outgoing messages. Is used together with properties E-mail message (Outlook)/Subject (ID) or E-mail message (SMTP)/Subject for outgoing e-mails in the global Message Control sending settings. Incoming messages are filtered for this content for forwarding to Message Control.

The text can contain wildcards.

  • Key from the language table
  • Name of a variable
  • compound entry in the language table

Syntax:

  • Text parts are separated by a semi colon (;),
  • $ marks text that contains the parameter
  • @ marks language switching
  • % marks variables
  • Text must end with a semicolon (;).

Example: $@Attention;%Var1;

You can find a list of the parameters in the Text from limit value and free text chapter.

More in the online help.

VT_I2

Attempts

Max. number of attempts

Maximum number of dispatch attempts in the event of a dispatch error that is recognized as a hardware error.
If the request from the called is canceled without confirmation or rejection, there is no repetition.

Maximum: 100

Minimum: 1

Default: 3

More in the online help.

VT_I2

TimeToWait

Waiting period between two attempts [min]

Waiting period in minutes for the repetition between two sending tries or forwarding of a message.

Default: 5

More in the online help.

VT_I2

CelDetail

Log in CEL

Defines which events are logged in the CEL. Selection from drop-down list:

  • Confirm all:
    All messages
  • No confirmations:
    No messages
  • Negative confirmations only:
    Only messages that are rejected or not responded to (including repetitions)
  • Positive confirmations only:
    Only messages that have already been acknowledged

More in the online help.

VT_BOOL

LogDeleteActions

Log manually deletion of messages in CEL.

Active: Manual deleting of entries from the CEL is logged in the CEL.

More in the online help.

ZT_FILE

SentImage

Message was sent

Defines a graphics file which is displayed in screen of type Message Control in column status as soon as the message was sent successfully. Click on button ... in order to open the dialog for selecting a graphics file.

More in the online help.

ZT_FILE

SendingImage

Message is sent

Defines a graphics file which is displayed in screen of type Message Control in column status as long as it is tried to send the message. Click on button ... in order to open the dialog for selecting a graphics file.

More in the online help.

ZT_FILE

ErrorImage

Error during sending

Defines a graphics file which is displayed in screen of type Message Control in column status if the sending try for a message failed. Click on button ... in order to open the dialog for selecting a graphics file.

More in the online help.

ZT_COLOR

SentColor

Message was sent

Defines the color with which the column status in screen of type Message Control is color-coded when the message was sent successfully. Click on button ... in order to open the dialog for selecting a color.

More in the online help.

ZT_COLOR

SendingColor

Message is sent

Defines the color with which the column status in screen of type Message Control is color-coded as long as the message is sent.. Click on button ... in order to open the dialog for selecting a color.

More in the online help.

ZT_COLOR

ErrorColor

Error during sending

Defines the color with which the column status in screen of type Message Control is color-coded if the sending of a message fails. Click on button ... in order to open the dialog for selecting a color.

More in the online help.


MessageControlMessage

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This object represents the user administration of the current project.With this object new users can be created and existing users can be edited/deleted during online operation. These changes can be imported into the Editor with decompiling. See the documentation of the control system for further information on decompiling.Users also can be logged in and out with this collection. Additionally this objects offers information on the currently logged in user.A user login executes the event UserChange with which you can execute user defined actions.Hint: For the event the object has to be defined with the attribute WithEvents in Visual Basic or VBA.

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Dim WithEvents zMessageControl As MessageControl

Private Sub Project_Active()
Set zMessageControl = thisProject.MessageControl
End Sub

'====================================================================================================
' MessageControl Runtime
' It has been generates a new message in the system. The Message Control Message object
' corresponding to the actual message object which will be shipped later.
' Access to this object is only allowed within the event handler.
'====================================================================================================
Private Sub zMessageControl_MessageCreated(ByVal obAlarmItem As IAlarmItem, ByVal obMessage As IMessageControlMessage)
Stop
If Not obAlarmItem Is Nothing Then
Debug.Print (obAlarmItem.Name)
End If

If Not obMessage Is Nothing Then
Debug.Print ("Current message text: " & obMessage.MessageText)
' Only in this event it is possible to overrite the MessageControlMessage Object
obMessage.MessageText = "New message text"
Call ShowMessageInformation(obMessage)
End If
End Sub

Public Function ShowMessageInformation(ByVal obMessage As MessageControlMessage)
Debug.Print ("========================================================")
Debug.Print ("Message Guid: " & obMessage.Guid)
Debug.Print ("Numbers of attempt: " & CStr(obMessage.Attempts))
Debug.Print ("Max. number of attempts:" & CStr(obMessage.MaxAttempts))
Debug.Print ("Waiting period between two attempts [min]: " & CStr(obMessage.TimeToWait))
Debug.Print ("Used dispatcher type: " & CStr(obMessage.DispatcherType))
Debug.Print ("Destination: " & obMessage.Destination)
Debug.Print ("Customer identifier: " & obMessage.CustomIdentifier)
Debug.Print ("Title of the message: " & obMessage.Title)
Debug.Print ("Current message text: " & obMessage.MessageText)
Debug.Print ("Time stamp when message is sending: " & CStr(obMessage.Send))
Debug.Print ("Time stamp when message was sent: " & CStr(obMessage.Sent))
Debug.Print ("Acknowledge required: " & CStr(obMessage.AcknowledgeRequired))
Debug.Print ("Time limit when message must be acknowledged: " & CStr(obMessage.AcknowledgeTimeOut))
Debug.Print ("Dispatch type style: " & CStr(obMessage.TypeStyle)) 'User, Usergroup....
Debug.Print ("Destination type: " & CStr(obMessage.DestinationType))
Debug.Print ("Codes from function: " & CStr(obMessage.CodesFromFunction))
Debug.Print ("Cycle Counter: " & CStr(obMessage.CycleCounter))
Debug.Print ("========================================================")
End Function

Other topics in this chapter

MessageControlMessage-Properties

MessageControlMessage-Methods

MessageControlMessage-Dynamic properties


MessageControlMessage-Properties

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | AcknowledgeRequired |  | not used | available
DATE | AcknowledgeTimeOut |  | not used | available
BSTR | Attachment |  | not used | available
short | Attempts |  | not used | available
VARIANT_BOOL | CodesFromFunction |  | not used | available
BSTR | CustomIdentifier |  | not used | available
long | CycleCounter |  | not used | available
BSTR | Destination |  | not used | available
short | DestinationType |  | not used | available
short | DispatcherType |  | not used | available
BSTR | Guid |  | not used | available
short | MaxAttempts |  | not used | read only
BSTR | MessageText |  | not used | available
DATE | Send |  | not used | available
DATE | Sent |  | not used | available
short | TimeToWait |  | not used | available
BSTR | Title |  | not used | available
short | TypeStyle |  | not used | available
BSTR | UserName | Return the name of the target User. | not used | available

Other topics in this chapter

Guid

UserName

Attempts

MaxAttempts

TimeToWait

DispatcherType

Destination

CustomIdentifier

Title

MessageText

Send

Sent

AcknowledgeTimeOut

AcknowledgeRequired

TypeStyle

DestinationType

Attachment

CodesFromFunction

CycleCounter


Guid

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> Guid

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Guid() As String

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


UserName

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> UserName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

UserName() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


Attempts

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> Attempts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Attempts() As short

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


MaxAttempts

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> MaxAttempts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MaxAttempts() As short

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


TimeToWait

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> TimeToWait

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

TimeToWait() As short

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


DispatcherType

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> DispatcherType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DispatcherType() As short

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


Destination

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> Destination

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Destination() As String

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


CustomIdentifier

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> CustomIdentifier

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CustomIdentifier() As String

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


Title

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> Title

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Title() As String

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


MessageText

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> MessageText

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MessageText() As String

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


Send

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> Send

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Send() As DATE

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


Sent

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> Sent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Sent() As DATE

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


AcknowledgeTimeOut

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> AcknowledgeTimeOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

AcknowledgeTimeOut() As DATE

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


AcknowledgeRequired

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> AcknowledgeRequired

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

AcknowledgeRequired() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


TypeStyle

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> TypeStyle

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

TypeStyle() As short

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


DestinationType

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> DestinationType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DestinationType() As short

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


Attachment

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> Attachment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Attachment() As String

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


CodesFromFunction

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> CodesFromFunction

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CodesFromFunction() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


CycleCounter

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Properties -> CycleCounter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CycleCounter() As long

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


MessageControlMessage-Methods

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | DynProperties [PUT] | - | not used | available
VARIANT | DynProperties [GET] | - | not used | available
VARIANT | DynPropertiesEnum [GET] | - | not used | available
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


MessageControlMessage-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Send parameter

Other topics in this chapter

Send parameter


Send parameter

Manual -> Programming interfaces -> Objectmodel -> MessageControlMessage -> MessageControlMessage-Dynamic properties -> Send parameter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Title | Subject |
VT_BSTR | MessageText | Message | Message text. More in the online help.
VT_I2 | Attempts | Tries | Number of tries. More in the online help.
VT_I2 | MaxAttempts | Maximum attempts | Maximum number of sending tries. More in the online help.
ZT_DATETIME | Sent | Created / last sent | Time at which the message was created or at which the last sending try took place. More in the online help.
ZT_DATETIME | Send | Next try | Time for the next sending try of the message. More in the online help.
VT_BSTR | Destination | Target | Destination address of the message (e-mail address, telephone number). More in the online help.
VT_I2 | DispatchType | Sending mode |
VT_UI4 | CycleCounter | Count of sent cycles | Number of forwards of this message. More in the online help.
VT_I2 | TimeToWait | Waiting period | Waiting time in minutes for the monitoring of time out and forwarding of messages. More in the online help.
VT_BOOL | AckReq | Acknowledgement mandatory | Message must be acknowledged at reception. More in the online help.
VT_UI2 | TypeStyle | Sending mode style |
VT_BSTR | Attachment | Attachment | Name of the attachment of the message. Only for e-mail via SMTP. More in the online help.
VT_BOOL | CodesFromFunction | Function-specific codes | Display whether an individual code is used for the acknowledgement. More in the online help.
ZT_DATETIME | AckTimeOut | Acknowledgement time-out | Time slot for the acknowledgment of the message. More in the online help.
VT_I2 | DestiType | Target type |
VT_BSTR | CustomIdentifier | Custom Identifier | Customized identifier. Can only be set via VBA/VSTA in Event MessageCreated. More in the online help.
VT_BSTR | GUID | GUID | Unique identifier (GUID) of the message. More in the online help.
VT_BSTR | UserName | Recipient name |


OnlineVariable

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The object OnlineVariable is a container for variables.The method Define of this object requests all variables, that are linked to that object. The same thing happens whenever a Screen is opened in the Runtime. On initializing the variable or changing the value an event is executed, in which the changed variable can be edited as a parameter.This object should always be used, if one or more variable(s) are needed, that perhaps are not yet requested. As the request for the value of a variable takes most time, the performance here is increased, as you can be sure, that the values of the linked variables always are requested because of the method Define.Hint: For the event the object Visual Basic has to be defined with the attribute WithEvents.Using online variables always needs the following procedure:· Linking the online variable to variables of the control system. For each variable the method Add has to be executed with the unique name of the variable. Alternatively you can also use the method AddBulk. In this case a dynamic string array is created, that contains the variables‘ names. This array then is passed to the method AddBulk.· Executing the method Define to activate monitoring the variables. A VBA event is executed, when a variable changes. The event contains the canges variable object as a parameter. In the routine the different actions are executed.· Executing the method Undefine of the object to stop monitoring the variables. From now on changes of the variables are no longer reported via the VBA event.

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub VariablesOfOLV()
Dim i As Integer
Dim obOLV As OnlineVariable
Dim obVAR As Variable
'get OnlineVariable
Set obOLV = thisProject.OnlineVariables.Item(0)
Debug.Print "Active: " & obOLV.Aktiv
'enum linked variables
For i = 0 To obOLV.Count - 1
Set obVAR = obOLV.Item(i)
Debug.Print obVAR.Name & " - " & obVAR.Tagname
Next i
End Sub

Note: Special characters such as ß-/\ are not permitted in zenon project names. Allowed are: Numbers, letters and the special underscore character (_). You can find more information about this in the Project administration and workspace manual, Create new project chapter.

Other topics in this chapter

OnlineVariable-Properties

OnlineVariable-Methods

OnlineVariable-Events


OnlineVariable-Properties

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | Aktiv |  | not used | available
long | Count |  | read only | read only
long | EventMode | Activated event mode | not used | read only
BSTR | Name | Name of the online-variable (unique) | not used | available
IOnlineVariables | Parent | Parent-object | read only | read only

Other topics in this chapter

Parent

Name

Aktiv

Count

EventMode


Parent

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As OnlineVariables

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the unique name of the current online variable. With this name the online variable can be accessed in the collection OnlineVariables of the current project.

Datatype

Name() As String

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


Aktiv

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Properties -> Aktiv

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the communication status of the online variable.The communication is set to True on executing the method Define. On deleting the object or executing the method Undefine the communication status is set to False.From this moment on the event VariableChange is no longer executed.

Datatype

Aktiv() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


EventMode

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Properties -> EventMode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

EventMode() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


OnlineVariable-Methods

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | ActivateBulkMode | Activate bulk event mode | not used | available
VARIANT_BOOL | Add | - | not used | available
VARIANT_BOOL | AddBulk | - | not used | available
VARIANT_BOOL | Define | - | not used | available
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IVariable | Item | - | available | not used
VARIANT_BOOL | Remove | - | not used | available
VARIANT_BOOL | SetMemCfg | - | not used | available
void | Undefine | - | not used | available
VARIANT_BOOL | WriteBack | - | not used | available
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used
VARIANT_BOOL | Add | - | not used | available
VARIANT_BOOL | AddBulk | - | not used | available
VARIANT_BOOL | Remove | - | not used | available
IVariable | Item | - | available | not used
VARIANT_BOOL | SetMemCfg | - | not used | available
VARIANT_BOOL | WriteBack | - | not used | available
VARIANT_BOOL | ActivateBulkMode | Activate bulk event mode | not used | available

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

Add

AddBulk

Remove

Item

Define

Undefine

SetMemCfg

WriteBack

ActivateBulkMode


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


Add

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Methods -> Add

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Add(BSTR szPvName) As VARIANT_BOOL

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


AddBulk

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Methods -> AddBulk

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

AddBulk() As VARIANT_BOOL

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Remove

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Methods -> Remove

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Remove(BSTR szPvName) As VARIANT_BOOL

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Item

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Item(VARIANT vID) As IVariable

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Define

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Methods -> Define

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method activates monitoring of all variables linked to this object.Before executing this method control system variables have to be linked to the object with the methods Add or AddBulk.Now on the initialization of a variable or on changing ist value a VBA event is executed, in which the linked variable is available as a parameter. In this event you can e.g. request the value, ...On executing this method the property Aktiv returns True. It is set to False, when the object is deleted or the methof Undefine is executed to stop monitoring.

Datatype

Define() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Undefine

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Methods -> Undefine

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method deactivates monitoring of the linked control system variables.The event VariableChange, usually executed on changing the value of a linked variable, is no longer executed.Hint: This is not necessary, if the online variables are used in combination with zenOn VBA and the events FireActive or FireInactive of the project, as the method Undefine is executed internally at the time of the FireInactive.

Datatype

Undefine() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SetMemCfg

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Methods -> SetMemCfg

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SetMemCfg() As VARIANT_BOOL

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


WriteBack

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Methods -> WriteBack

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

WriteBack() As VARIANT_BOOL

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


ActivateBulkMode

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Methods -> ActivateBulkMode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ActivateBulkMode() As VARIANT_BOOL

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


OnlineVariable-Events

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description |  | Editor | Runtime
void | VariableBulkChange | Event: Is fired to handle a bulk of changed variable values |  | not used | available
void | VariableChange | Event: Is fired by changing the value of a variable |  | not used | available
void | VariableChange | Event: Is fired by changing the value of a variable | not used |  | available
void | VariableBulkChange | Event: Is fired to handle a bulk of changed variable values | not used |  | available

Other topics in this chapter

VariableChange

VariableBulkChange


VariableChange

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Events -> VariableChange

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

VariableChange(IVariable obVar) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


VariableBulkChange

Manual -> Programming interfaces -> Objectmodel -> OnlineVariable -> OnlineVariable-Events -> VariableBulkChange

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

VariableBulkChange(LPVARIANT pvVars, LPVARIANT pvPvIDs, LPVARIANT pvValues, LPVARIANT pvStatesLo, LPVARIANT pvStatesHi, LPVARIANT pvTimes) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


OnlineVariables

Manual -> Programming interfaces -> Objectmodel -> OnlineVariables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This collection contains the single objects OnlineVariable. An online variable is an object, in which control system variables are linked, which on being initialized or changed execute a VBA event. In this VBA event user defined actions can be defined.The usage of online variables is recommended for the reading of variable values, as all variables linked to the online variable can be ordered with one action. This enhances the performance.An online variable can be compared to a container or – even better – a Screen of the control system without display. In such a Screen of the control system also all values are ordered from the driver when the Screen is opened.

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Dim WithEvents zOLV As OnlineVariable
Const strOLV As String = "MyOnlineVariableContainer"

'initialize event on runtime startup
Private Sub Project_Active()
'get object if already exists
Set zOLV = thisProject.OnlineVariables.Item(strOLV)
If zOLV Is Nothing Then
'if not exitst, create a new OnlineVariable container
Set zOLV = thisProject.OnlineVariables.CreateOnlineVariables(strOLV)
'add variables to the container
zOLV.Add "Variable1"
zOLV.Add "Variable2"
zOLV.Add "Variable3"
End If
'activate 'VariableChange' event
zOLV.Define
End Sub

'event is fired when a variable value changes
Private Sub zOLV_VariableChange(ByVal obVar As IVariable)
Dim vValue As Variant
vValue = obVar.Value
'ignore error values (i.e. on startup)
If IsError(vValue) Then Exit Sub
D ebug.Print obVar.Name & " = " & vValue
End Sub

'release objects on closing the runtime
Private Sub Project_Inactive()
'deactivate 'VariableChange' event
If Not zOLV Is Nothing Then zOLV.Undefine
Set zOLV = Nothing
End Sub

Note: Special characters such as ß-/\ are not permitted in zenon project names. Allowed are: Numbers, letters and the special underscore character (_). You can find more information about this in the Project administration and workspace manual, Create new project chapter.

Other topics in this chapter

OnlineVariables-Properties

OnlineVariables-Methods


OnlineVariables-Properties

Manual -> Programming interfaces -> Objectmodel -> OnlineVariables -> OnlineVariables-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Count of defined online-variables | read only | read only
IProject | Parent | Parent-object | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> OnlineVariables -> OnlineVariables-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> OnlineVariables -> OnlineVariables-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


OnlineVariables-Methods

Manual -> Programming interfaces -> Objectmodel -> OnlineVariables -> OnlineVariables-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IOnlineVariable | CreateOnlineVariables | Creates a new online-variable (unique name) | not used | available
VARIANT_BOOL | DeleteOnlineVariables | Deletes the given variable | not used | available
IOnlineVariable | Item | Returns the variable by name or position | available | available
IOnlineVariable | CreateOnlineVariables | Creates a new online-variable (unique name) | not used | available
VARIANT_BOOL | DeleteOnlineVariables | Deletes the given variable | not used | available

Other topics in this chapter

CreateOnlineVariables

DeleteOnlineVariables

Item


CreateOnlineVariables

Manual -> Programming interfaces -> Objectmodel -> OnlineVariables -> OnlineVariables-Methods -> CreateOnlineVariables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreateOnlineVariables(BSTR Name) As IOnlineVariable

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


DeleteOnlineVariables

Manual -> Programming interfaces -> Objectmodel -> OnlineVariables -> OnlineVariables-Methods -> DeleteOnlineVariables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DeleteOnlineVariables(BSTR Name) As VARIANT_BOOL

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Item

Manual -> Programming interfaces -> Objectmodel -> OnlineVariables -> OnlineVariables-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the object OnlineVariable from the collection, which is identified by the parameter vID.The parameter vID can have two values:· Index: Access with an index mostly is used in combination with the property Count to find out the position of the online variable object in the list.· Variable name: The online variable can also be accessed with its unique name.

Datatype

Item(VARIANT vID) As OnlineVariable

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

Index or name as Variant
If the parameter is a numerical value, the variable is searched by its index (>= 0 and <= Count-1). If it is an alphanumerical value, the variable is searched by its unique name.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vID As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'enumerate all OnlineVariables
Sub EnumOLVs()
Dim i As Integer
Dim obOLV As OnlineVariable
For i = 0 To thisProject.OnlineVariables.Count - 1
Set obOLV = thisProject.OnlineVariables.Item(i)
Debug.Print obOLV.Name & " (Vars: " & obOLV.Count & ")"
Next i
End Sub


Passwords

Manual -> Programming interfaces -> Objectmodel -> Passwords

Remarks

This object represents the user administration of the current project.With this object new users can be created and existing users can be edited/deleted during online operation. These changes can be imported into the Editor with decompiling. See the documentation of the control system for further information on decompiling.Users also can be logged in and out with this collection. Additionally this objects offers information on the currently logged in user.A user login executes the event UserChange with which you can execute user defined actions.Hint: For the event the object has to be defined with the attribute WithEvents in Visual Basic or VBA.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Dim WithEvents zUserAdministration As Passwords

'initialize event on runtime startup
Private Sub Project_Active()
Set zUserAdministration = thisProject.Passwords
End Sub

Private Sub zUserAdministration_UserChange()
Debug.Print zUserAdministration.LoggedUser; " is logged in!"
End Sub

'create a new user
Sub CreateUser()
Dim zUser As User
'12345 = Levels: 0,3,4,5,12,13
Set zUser = thisProject.Passwords.CreateUser("Full Name", "Username", "P@ssword", 12345)
With zUser
.Active = True
.Admin = True
.Locked = False
End With
End Sub

'change some user properties
Sub ChangeUser()
Dim zUser As User
Dim vResult As Variant

Set zUser = thisProject.Passwords.ItemUser(0)
Debug.Print zUser.Name & " will be changed"

'change the identification of the user
vResult = zUser.IdentificationChange("NewLogonName")

'change the password for the user
vResult = zUser.PasswordChange("P@ssword", "NewPassword")

End Sub

'login a user with its password...
Sub LoginUser()
Dim bResult As Boolean
bResult = zUserAdministration.LoginPassword("LogonName", "P@ssword")
End Sub

'release objects on closing the runtime
Private Sub Project_Inactive()
Set zUserAdministration = Nothing
End Sub

Other topics in this chapter

Passwords-Properties

Passwords-Methods

Passwords-Events


Passwords-Properties

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | CountUser | Count of defined users | available | available
long | CountUserGroup | Count of defined usergroups | read only | read only
BSTR | LoggedUser | Current logged on user | available | available
BSTR | LoggedUsername | TagName of the logged on user | available | available
IProject | Parent | Parent-object | read only | read only

Other topics in this chapter

Parent

LoggedUser

LoggedUsername

CountUser

CountUserGroup


Parent

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


LoggedUser

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Properties -> LoggedUser

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the identification of the user currently logged in.The identification can have up to 14 characters. The identification is the unique Id for the user, i.e. with this parameter the user can be identified.E.g. the identification for the user System is 0000.

Datatype

LoggedUser() As String

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


LoggedUsername

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Properties -> LoggedUsername

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the name of the currently logged in user.The name of the user is defined in the control system.

Datatype

LoggedUsername() As String

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


CountUser

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Properties -> CountUser

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the number of defined users, created in the user adminsitration of the control system.This method mostly is used for the iteration, i.e. to run through all the users in combination with the method ItemUser.

Datatype

CountUser() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


CountUserGroup

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Properties -> CountUserGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the number of defined usergroups, created in the user adminsitration of the control system.This method mostly is used for the iteration, i.e. to run through all the usergroups in combination with the method ItemUserGroup.

Datatype

CountUserGroup() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Passwords-Methods

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CheckIn | Save module modifications to server (editor). | available | not used
tpLoginResult | CheckLogin | Checks the Login of a user with given ID and password | not used | available
VARIANT_BOOL | CheckOut | Allow module modifications (editor). | available | not used
IUser | CreateUser | Creates a new user | available | available
IUser | CreateUserEx | Creates a new user | available | available
IUserGroup | CreateUserGroup | Creates a new usergroup | available | not used
VARIANT_BOOL | DeleteUser | Deletes the given user | available | available
VARIANT_BOOL | DeleteUserGroup | Deletes the given usergroup | available | not used
VARIANT_BOOL | Export | Exports the user list | available | not used
VARIANT_BOOL | ExportGroup | Exports the usergroup list | available | not used
VARIANT_BOOL | Get | Get the latest version from the server (editor). | available | not used
VARIANT_BOOL | Import | Imports the user list | available | not used
VARIANT_BOOL | ImportGroup | Imports the usergroup list | available | not used
VARIANT_BOOL | IsCheckedOut | Returns true when the current module checked out by the current user (editor). | read only | not used
VARIANT_BOOL | IsDifferent | Return true when the local- and server version are different (editor). | read only | not used
VARIANT_BOOL | IsLocked | Returns true when the current module is Locked by another user (editor). | read only | not used
IUser | ItemUser | Returns user by position or by name | available | available
IUserGroup | ItemUserGroup | Returns usergroup by position or by name | available | available
VARIANT_BOOL | Login | Logs in the user with the given ID | available | available
VARIANT_BOOL | LoginPassword | Logs in the user with the given ID and the given password | available | available
void | Logoff | Log out the current user | available | available
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | available
VARIANT_BOOL | SingleExportGroup | Exports the Item with given Name oder Index | available | available
VARIANT_BOOL | UndoCheckOut | Undo module modifications (editor). | available | not used

Other topics in this chapter

Login

LoginPassword

CheckLogin

Logoff

CreateUser

CreateUserEx

DeleteUser

ItemUser

SingleExport

Export

Import

CreateUserGroup

DeleteUserGroup

ItemUserGroup

ExportGroup

SingleExportGroup

ImportGroup

Get

CheckOut

CheckIn

UndoCheckOut

IsLocked

IsCheckedOut

IsDifferent


Login

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> Login

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Searches for the user with the identification szIdentification and tries to log him in, if he is not the currently logged in user.If a user with thie identification cannot be found, an entry in the CEL is generated.Otherwise the user is logged in and the following further actions are executed:·System variable for current user level is actualized·System variable for the name of the current user is actualized·Alarming is informed about user change·All opened MDI windows are informed about user change·CEL entry for user is generated·UserChange event for the object Passwords is executed

Datatype

Login(String szIdentification) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

Index or name as variant.
If the parameter is a numerical value, the user is searched by its index (>= 0 and <= Count-1).
If it is an alphanumerical value, the user is searched by its unique name.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vIndex As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'login a user...
Sub LoginUser()
Dim bResult As Boolean
bResult = zUserAdministration.Login("LogonName")
End Sub


LoginPassword

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> LoginPassword

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Searches for the user with the identification szIdentification and tries to log him in, if he is not the currently logged in user.In this case also the new password is compared to the current one.If a user with thie identification cannot be found, an entry in the CEL is generated.Otherwise the user is logged in and the following further actions are executed:·System variable for current user level is actualized·System variable for the name of the current user is actualized·Alarming is informed about user change·All opened MDI windows are informed about user change·CEL entry for user is generated·UserChange event for the object Passwords is executed

Datatype

LoginPassword(String szIdentification,String szPassword) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

Password of the user as string.

Identification of a user as string.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

szPassword As String

szIdentification As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'login a user with its password...
Sub LoginUser()
Dim bResult As Boolean
bResult = zUserAdministration.LoginPassword("LogonName", "P@ssword")
End Sub


CheckLogin

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> CheckLogin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Function CheckLogin(szUser As String, szPassword As String, vLevels) As tpLogin

Besides a new enumeration tpLogin with the following values:

tpDefaultError, tpLoginOk, tpPasswordExpired, tpSystemLocked, tpUserDeactivated, tpUserLocked, tpWrongPassword, tpWrongPasswordUserLocked, tpWrongUser, tpWrongUserSystemLocked

The committed user name and password are checked, the result is returned and a corresponding CEL entry is generated. Error entries on user name and password have the same consequences as on normal log in. (for ex. blocking the user or systems after a certain number). Is the user authenticated successfully, his authority levels are returned as an array of 4 longs (in the variant vLevels).

Datatype

CheckLogin(String szUser,String szPassword,LPVARIANT vLevels) As tpLoginResult

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Public Sub Macro_CheckLogin()
Dim zPassword As Passwords
Dim tpResult As tpLoginResult
Dim vLevels As Variant
Dim vUserLevel As Variant
Dim i As Integer
Dim j As Integer
Dim mask As Double
Dim userLevels As String

Set zPassword = thisProject.Passwords
'Get Login result
tpResult = zPassword.CheckLogin("John", "123456", vLevels)
' Show result
getTpResultInformaion (tpResult)

For i = 0 To UBound(vLevels) 'User levels split in 4 groups with 32 bits
j = 0
mask = 0

If vLevels(i) > 0 Then
For j = 0 To 31 - 1 ' iterate the 32 bits
mask = 2 ^ j ' 0,2,4,8,16,32,64....
If vLevels(i) And mask Then ' If bit is set the user has this level
userLevels = userLevels + CStr(j + (32 * i)) & " "
End If
Next j
End If
Next i
Debug.Print ("User Levels: " & userLevels)
End Sub

Private Function getTpResultInformaion(tpResult As tpLoginResult)

Select Case tpResult
Case tpLoginResult.tpLoginOk
Debug.Print ("Login Ok: " & tpLoginResult.tpLoginOk)
Case tpLoginResult.tpPasswordExpired
Debug.Print ("Password expired: " & tpLoginResult.tpPasswordExpired)
Case tpLoginResult.tpSystemLocked
Debug.Print ("System locked: " & tpLoginResult.tpSystemLocked)
Case tpLoginResult.tpUserDeactivated
Debug.Print ("User deactivated: " & tpLoginResult.tpUserDeactivated)
Case tpLoginResult.tpUserLocked
Debug.Print ("User locked: " & tpLoginResult.tpUserLocked)
Case tpLoginResult.tpWrongPassword
Debug.Print ("Wrong password: " & tpLoginResult.tpWrongPassword)
Case tpLoginResult.tpWrongPasswordUserLocked
Debug.Print ("Wrong password - User locked: " & tpLoginResult.tpWrongPasswordUserLocked)
Case tpLoginResult.tpWrongUser
Debug.Print ("Wrong user: " & tpLoginResult.tpWrongUser)
Case tpLoginResult.tpWrongUserSystemLocked
Debug.Print ("Wrong user- System locked: " & tpLoginResult.tpWrongUserSystemLocked)
Case tpLoginResult.tpDefaultError
Debug.Print ("Default Error: " & tpLoginResult.tpDefaultError)
End Select

End Function


Logoff

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> Logoff

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method logs out the current user and logs in the user SYSTEM.If the user SYSTEM is already active, no further steps are taken.

Datatype

Logoff() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateUser

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> CreateUser

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method creates new users during online operation. If the identification is an empty string or an user with the same identification already exists, this method returns Nothing.Hint: Therefore the returned object always should be checked on Nothing.If the identification is valid, a new object User is created and the defined parameters are transferred to the object. Then the object is handed over to the central user administration and the changes are saved.

Datatype

CreateUser(String szIdentification,String szUsername,String szPassword,long dwLevel) As User

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

Password level of the user as long.

Password of the user as string.

Unique name of the user as string.

Identification of a user as string.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

dwLevel As Long

szPassword As String

szUsername As String

szIdentification As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'create a new user
Sub CreateUser()
Dim zUser As User
'12345 = Levels: 0,3,4,5,12,13
Set zUser = thisProject.Passwords.CreateUser("Full Name", "Username", "P@ssword", 12345)
With zUser
.Active = True
.Admin = True
.Locked = False
End With
End Sub


CreateUserEx

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> CreateUserEx

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method creates new users during online operation. If the identification is an empty string or an user with the same identification already exists, this method returns Nothing.Hint: Therefore the returned object always should be checked on Nothing.If the identification is valid, a new object User is created and the defined parameters are transferred to the object. Then the object is handed over to the central user administration and the changes are saved.

Datatype

CreateUserEx(String szIdentification,String szUsername,String szPassword,long dwLevel1,long dwLevel2,long dwLevel3,long dwLevel4) As User

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

Password levels 0 to 31 of the user as long.

Password levels 32 to 63 of the user as long.

Password levels 64 to 95 of the user as long.

Password of the user as string.

Password levels 96 to 127 of the user as long.

Unique name of the user as string.

Identification of a user as string.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

dwLevel1 As Long

dwLevel2 As Long

dwLevel3 As Long

szPassword As String

dwLevel4 As Long

szUsername As String

szIdentification As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'create a new user
Sub CreateUser()
Dim zUser As User
'12345 = Levels: 0,3,4,5,12,13
' 4711 = Levels: 32,33,34,37,38,41,44
' 555 = Levels: 64,65,67,69,73
' 1234 = Levels: 97,100,102,103,106
Set zUser = thisProject.Passwords.CreateUserEx("LogonName", "Full Username", "P@ssword", 12345, 4711, 555, 1234)
With zUser
.Active = True
.Admin = True
.Locked = False
End With
End Sub


DeleteUser

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> DeleteUser

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method deletes the user with the identification szIdentification from the central user administration.This change is immediately saved, i.e. after deleting a user he is no longer available for the system.If no user with this identification can be found, the method returns False.

Datatype

DeleteUser(String szIdentification) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

Identification of a user as string.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

szIdentification As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'delete a user
Sub DeleteUSer()
Dim bResult As Boolean
bResult = thisProject.Passwords.DeleteUSer("LogonName")
End Sub


ItemUser

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> ItemUser

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the user from the collection, who is identified by the parameter vIndex.The parameter vIndex can have two values:· Index: Access with an index mostly is used in combination with the property Count to find out the position of the variable object in the list.· Identification: The user can also be accessed with his unique identification.Hint: The returned object should be checked on Nothing to find out, if no object for the search creteria was found.

Datatype

ItemUser(VARIANT vIndex) As User

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

Index or name as variant.
If the parameter is a numerical value, the user is searched by its index (>= 0 and <= Count-1).
If it is an alphanumerical value, the user is searched by its unique name.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vIndex As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'enumerate all users
Sub EnumUsers()
Dim zUser As User
Dim i As Integer

For i = 0 To thisProject.Passwords.CountUser - 1
'get user object
Set zUser = thisProject.Passwords.ItemUser(i)
Debug.Print zUser.Identification & " > " & zUser.Name
Next i
End Sub


SingleExport

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> SingleExport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SingleExport(VARIANT vIndexOrName,String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Export

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export settings to an xml file

Datatype

Export(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to import.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Import

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced.

Datatype

Import(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to import.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


CreateUserGroup

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> CreateUserGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreateUserGroup(String szName,long dwLevel) As UserGroup

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteUserGroup

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> DeleteUserGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DeleteUserGroup(String szName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ItemUserGroup

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> ItemUserGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ItemUserGroup(VARIANT vIndex) As UserGroup

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ExportGroup

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> ExportGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ExportGroup(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to export.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


SingleExportGroup

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> SingleExportGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SingleExportGroup(VARIANT vIndexOrName,String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ImportGroup

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> ImportGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ImportGroup(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to import.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Get

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> Get

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype

Get() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckOut

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> CheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype

CheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckIn

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> CheckIn

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype

CheckIn() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


UndoCheckOut

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> UndoCheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype

UndoCheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsLocked

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> IsLocked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype

IsLocked() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsCheckedOut

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> IsCheckedOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype

IsCheckedOut() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsDifferent

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Methods -> IsDifferent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype

IsDifferent() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Passwords-Events

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description |  | Editor | Runtime | VBA | VSTA
void | UserChange |  | available |  | available | yes |  | yes
void | ValidatePassword |  | not used |  | available | yes |  | yes

Other topics in this chapter

UserChange

ValidatePassword


UserChange

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Events -> UserChange

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is executed, when a user is logged into the system.In this event you can execute your user defined actions.With the property LoggedUser and the method ItemUser you can find out the newly logged in user.Hint: For the event the object has to be defined with the attribute WithEvents in Visual Basic or VBA.

Datatype

UserChange() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ValidatePassword

Manual -> Programming interfaces -> Objectmodel -> Passwords -> Passwords-Events -> ValidatePassword

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ValidatePassword(String bsIdentification, String bsPassword, Boolean bOK) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

Contains the Identification of the User who tries to change his password...

Contains the new password wich was entered by the actual user...

Defines if the new password is valid or not.
Set the "bOK" to "False" if the password is not valid.
Default value = True

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsIdentification As String

bsPassword As String

bOK As Boolean

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'The following Code is used in the "thisProject" classmodule...
Dim WithEvents zPWD As Passwords

Private Sub Project_Active()
Set zPWD = thisProject.Passwords
End Sub

Private Sub zPWD_ValidatePassword(ByVal bsIdentification As String, ByVal bsPassword As String, bOK As Boolean)
'check password length
If Len(bsPassword) < 8 Then
bOK = False
Else
'check if password contains username
If InStr(1, UCase(bsPassword), UCase(bsIdentification)) <> 0 Then
bOK = False
End If
End If

End Sub


PfsCalendar

Manual -> Programming interfaces -> Objectmodel -> PfsCalendar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

PfsCalendar-Methods


PfsCalendar-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsCalendar -> PfsCalendar-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
VARIANT | SchedulesForDay | Returns the linked schedules for the day | available | available | yes | yes
IPfsTimeModell | TimeModelForDay | Returns the linked time model for the day | available | available | yes | yes
IPfsSwitchingPointFilter | CreateSwitchingPointFilter | Creates a switching point filter that can be configured and then used to call the SwitchingPointPreview method | available | available | yes | yes

Other topics in this chapter

SchedulesForDay

TimeModelForDay

CreateSwitchingPointFilter


SchedulesForDay

Manual -> Programming interfaces -> Objectmodel -> PfsCalendar -> PfsCalendar-Methods -> SchedulesForDay

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get scheduals for a specific day.

Datatype

SchedulesForDay(DATE date, BSTR bstrGroup) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA

Public Sub ShowTodaysScheduleType()

Set PfsSchedule = thisProject.pfs.Groups.Item(0).Schedules.Item(0)

Dim link As tpPfsDayLink

link = PfsSchedule.IsOnDay(Date)

If link = tpPfsExecute Then

MsgBox "Einzeltag"

End If

If link = tpPfsSkip Then

MsgBox "Übersprungen"

End If

If link = tpPfsDefaultDay Then

MsgBox "Defaultbelegung"

End If

If link = tpPfsUnused Then

MsgBox "Nicht verwendet"

End If

End Sub

Public Sub SetTodaysSchedule()

Dim PfsSchedule As PfsSchedule

Set PfsSchedule = thisProject.pfs.Groups.Item(0).Schedules.Item(0)

Call PfsSchedule.AddToDay(Date, tpPfsExecute)

thisProject.pfs.Save

End Sub

Public Sub DeleteTodaysSchedule()

Dim PfsSchedule As PfsSchedule

Set PfsSchedule = thisProject.pfs.Groups.Item(0).Schedules.Item(0)

Call PfsSchedule.RemoveFromDay(Date, True)

thisProject.pfs.Save

End Sub

Public Sub GetCalendar()

Dim Engine As PfsEngine

Dim Calendar As PfsCalendar

Set Engine = thisProject.Pfs

Set Calendar = Engine.Calendar

End Sub

Public Sub GetSchedules()

Dim calendar As pfsCalendar

Dim schedules() As pfsSchedule

Set calendar = thisProject.Pfs.calendar

schedules = calendar.SchedulesForDay(Now, "ZMG1")

Dim text As String

For I = 0 To UBound(schedules)

text = text + schedules(I).Name + "/"

Next I

MsgBox text

End Sub


TimeModelForDay

Manual -> Programming interfaces -> Objectmodel -> PfsCalendar -> PfsCalendar-Methods -> TimeModelForDay

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Connect a timemodel to a single day.

Datatype

TimeModelForDay(DATE date, BSTR bstrGroup) As IPfsTimeModell

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA

Public Sub ConnectTimeModelToDay()

Dim pfsTM As PfsTimeModell

Set pfsTM = thisProject.Pfs.Groups.Item(0).TimeModells.Item(0)

Call pfsTM.AddToDay(Date, tpPfsExecute)

thisProject.Pfs.Save

End Sub

Public Sub Macro0()

Dim pfsTM As PfsTimeModell

Set pfsTM = thisProject.pfs.Groups.Item(0).TimeModells.Item(0)

Dim link As tpPfsDayLink

link = pfsTM.IsOnDay(Date)

If link = tpPfsExecute Then

MsgBox "Einzeltag"

End If

If link = tpPfsDefaultDay Then

MsgBox "Defaultbelegung"

End If

If link = tpPfsUnused Then

MsgBox "Nicht verwendet"

End If

End Sub

Public Sub GetTimeModel()

Dim calendar As pfsCalendar

Dim timemodel As PfsTimeModell

Set calendar = thisProject.Pfs.calendar

Set timemodel = calendar.TimeModelForDay(Now, "ZMG1")

If Not timemodel Is Nothing Then

MsgBox timemodel.Name

Else

MsgBox "Kein Zeitmodell verknüpft"

End If

End Sub


CreateSwitchingPointFilter

Manual -> Programming interfaces -> Objectmodel -> PfsCalendar -> PfsCalendar-Methods -> CreateSwitchingPointFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a switching point filter that can then be used to get a switching point preview.

Datatype

CreateSwitchingPointFilter() As IPfsSwitchingPointFilter

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

public void Macro_SwitchingPointPreview()

{

// create a switching point filter

var filter = Pfs().Calendar().CreateSwitchingPointFilter();

// configure the filter

filter.StartTime = System.DateTime.Now;

filter.EndTime = System.DateTime.Now + new System.TimeSpan(7, 0, 0, 0);

filter.TimeModelGroup = "z*";

filter.Schedule = "N*";

filter.Variable = "*";

filter.Function = "*";

filter.SearchData = zenOn.tpPfsData.tpPfsStoredData;

// get the preview for the configuration

string output = "";

object[] switchtingPoints = (object[])filter.SwitchingPointPreview();

foreach (object switchingPoint in switchtingPoints)

{

zenOn.IPfsSwitchingPoint p = (zenOn.IPfsSwitchingPoint)switchingPoint;

output = output + "Active: " + p.Active.ToString();

output = output + " TimeModelGroup: " + p.ScheduleValue.Parent.Parent.Parent.Parent.Parent.Parent.Name;

output = output + " Schedule: " + p.ScheduleValue.Parent.Parent.Parent.Parent.KeyNote;

output = output + " ExecTime: " + p.ExecutionTime.ToString();

output = output + " LinkedType: " + p.ScheduleValue.Type.ToString();

output = output + " LinkedObject: " + p.ScheduleValue.GetScheduleLink().Name;

if (p.ScheduleValue.Value != null)

{

output = output + " SetValue: " + p.ScheduleValue.Value.ToString();

}

output = output + " PasswordLevel: " + p.ScheduleValue.PasswordLevel.ToString();

output = output + " TriggerType: " + p.ScheduleValue.Parent.Parent.Type.ToString();

output = output + " EventId: " + p.ScheduleValue.Parent.Parent.EventId.ToString();

output = output + "\n\n";

}

// show output

System.Windows.Forms.MessageBox.Show(output);

}

VB.NET

VBA

Public Sub Preview()

'create a switching point filter

Dim filter As PfsSwitchingPointFilter

Set filter = thisProject.Pfs.Calendar.CreateSwitchingPointFilter

'configure the filter

filter.StartTime = Now

filter.EndTime = Now + 7

filter.TimeModelGroup = "z*"

filter.Schedule = "N*"

filter.Variable = "*"

filter.Function = "*"

filter.SearchData = tpPfsStoredData

'get the preview for the filter configuration

Dim points() As PfsSwitchingPoint

points = filter.SwitchingPointPreview

'build an output message

Dim output As String

Dim idx As Integer

For idx = 0 To UBound(points)

output = output & "Active: " & CStr(points(idx).Active)

output = output & " TimeModelGroup: " & points(idx).ScheduleValue.Parent.Parent.Parent.Parent.Parent.Parent.Name

output = output & " Schedule: " & points(idx).ScheduleValue.Parent.Parent.Parent.Parent.KeyNote

output = output & " ExecTime: " & CStr(points(idx).ExecutionTime)

output = output & " LinkedType: " & CStr(points(idx).ScheduleValue.Type)

output = output & " LinkedObject: " & CStr(points(idx).ScheduleValue.GetScheduleLink.Name)

output = output & " SetValue: " & CStr(points(idx).ScheduleValue.value)

output = output & " PasswordLevel: " & CStr(points(idx).ScheduleValue.PasswordLevel)

output = output & " TriggerType: " & CStr(points(idx).ScheduleValue.Parent.Parent.Type)

output = output & " EventId: " & CStr(points(idx).ScheduleValue.Parent.Parent.EventId)

output = output & vbNewLine & vbNewLine

Next idx

'show the output

MsgBox output

End Sub


PfsEngine

Manual -> Programming interfaces -> Objectmodel -> PfsEngine

Remarks

The PfsEngine object is the entry point into the Pfs object model.With the property CountryName you can define the country for the holiday definition. The method events returns a list of the user-defined events.The Groups method returns the definition of the existing PFS equipments.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

'''''''''''''''''''''''''''''''''''''''''''''
''''''Define PFS Engine with Events!'''''''''
'''''''''''''''''''''''''''''''''''''''''''''
Dim WithEvents myPFS As PfsEngine

'''''''''''''''''''''''''''''''''''''''''''''
''''''''Define Events for PFS Engine'''''''''
'''''''''''''''''''''''''''''''''''''''''''''
Private Sub myPFS_OnCreateGroup(ByVal obNewGroup As IPfsGroup)
Debug.Print "myPFS_OnCreateGroup " & " " & obNewGroup.Name & " was created!"
End Sub

Private Sub myPFS_OnCreateEvent(ByVal obNewEvent As IPfsEvent)
Debug.Print "myPFS_OnCreateEvent " & " " & obNewEvent.Name & " was created!"
End Sub

'''''''''''''''''''''''''''''''''''''''''''''
''''''''''Excecute the defined Events,'''''''
'''''''''''by creating new objects'''''''''''
'''''''''''''''''''''''''''''''''''''''''''''
Sub TestEvents()
Set myPFS = MyWorkspace.ActiveDocument.Pfs
myPFS.Groups.CreateGroup ("TestGroup1")
myPFS.Events.CreateEvent ("TestEvent1")
End Sub

'''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''Creation of a PFS Engine object'''''''''''''
'''''''''''''''Giving out Group Names''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub EnumGroups()
Dim i As Double
Dim myPFS As PfsEngine

Set myPFS = MyWorkspace.ActiveDocument.Pfs
For i = 0 To myPFS.Groups.Count - 1
Debug.Print myPFS.Groups.Item(i).Name
Next i
End Sub

Other topics in this chapter

PfsEngine-Properties

PfsEngine-Methods

PfsEngine-Events


PfsEngine-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
BSTR | CountryName |  | available | available
IProject | Parent |  | read only | read only

Other topics in this chapter

Parent

CountryName


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


CountryName

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Properties -> CountryName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property contains the value for the selected country. This is important because of the statutory holidays, which change automatically in the calendar, when a different country is selected.

Datatype

CountryName() As String

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


PfsEngine-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IPfsEvents | Events | - | available | available
IPfsGroups | Groups | - | available | available
IPfsHolidays | Holidays | - | available | available
VARIANT_BOOL | Save | - | available | available
IPfsCalendar | Calendar | Retrieves the object for the pfs calendar | available | available

Other topics in this chapter

Groups

Events

Holidays

Save

Calendar


Groups

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Methods -> Groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The "Groups" object manages the "Group" objects.

Datatype

Groups() As PfsGroups

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Events

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Methods -> Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The "Event" Object is a collection of all "Event" objects, which are created from the user.

Datatype

Events() As PfsEvents

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Holidays

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Methods -> Holidays

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

In the "Holidays" object all "Holiday" objects are managed.

Datatype

Holidays() As PfsHolidays

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Save

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Methods -> Save

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With the "Save" methode all changes made in the PFS module can be saved.

Datatype

Save() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Calendar

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Methods -> Calendar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Calendar() As IPfsCalendar

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


PfsEngine-Events

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description |  | Editor | Runtime
void | AfterUpdate |  | available |  | available
void | BeforeUpdate |  | available |  | available
void | OnCreateBreak |  | available |  | available
void | OnCreateEvent |  | available |  | available
void | OnCreateGroup |  | available |  | available
void | OnCreateSchedule |  | available |  | available
void | OnCreateScheduleTime |  | available |  | available
void | OnCreateScheduleValue |  | available |  | available
void | OnCreateShift |  | available |  | available
void | OnCreateTimeModell |  | available |  | available
void | OnDeleteBreak |  | available |  | available
void | OnDeleteEvent |  | available |  | available
void | OnDeleteGroup |  | available |  | available
void | OnDeleteSchedule |  | available |  | available
void | OnDeleteScheduleTime |  | available |  | available
void | OnDeleteScheduleValue |  | available |  | available
void | OnDeleteShift |  | available |  | available
void | OnDeleteTimeModell |  | available |  | available
void | OnRenameBreak |  | available |  | available
void | OnRenameEvent |  | available |  | available
void | OnRenameGroup |  | available |  | available
void | OnRenameSchedule |  | available |  | available
void | OnRenameShift |  | available |  | available
void | OnRenameTimeModell |  | available |  | available
void | OnSave |  | available |  | available

Other topics in this chapter

BeforeUpdate

AfterUpdate

OnSave

OnCreateGroup

OnDeleteGroup

OnRenameGroup

OnCreateSchedule

OnDeleteSchedule

OnRenameSchedule

OnCreateTimeModell

OnDeleteTimeModell

OnRenameTimeModell

OnCreateEvent

OnDeleteEvent

OnRenameEvent

OnCreateShift

OnDeleteShift

OnRenameShift

OnCreateBreak

OnDeleteBreak

OnRenameBreak

OnCreateScheduleTime

OnDeleteScheduleTime

OnCreateScheduleValue

OnDeleteScheduleValue


BeforeUpdate

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> BeforeUpdate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, before the Save methode has been excecuted.

Datatype

BeforeUpdate() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


AfterUpdate

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> AfterUpdate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, after the Save methode has been excecuted.

Datatype

AfterUpdate() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnSave

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnSave

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when the Save methode is excecuted.

Datatype

OnSave() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnCreateGroup

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnCreateGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a new group has been created.

Datatype

OnCreateGroup(PfsGroup obNewGroup) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnDeleteGroup

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnDeleteGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a group has been deleted.

Datatype

OnDeleteGroup(String strString) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnRenameGroup

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnRenameGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when the rename methode of a group is excecuted.

Datatype

OnRenameGroup(String strOld,String strNew) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnCreateSchedule

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnCreateSchedule

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a new schedule has been created.

Datatype

OnCreateSchedule(PfsSchedule obNewSchedule) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnDeleteSchedule

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnDeleteSchedule

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a schedule has been deleted.

Datatype

OnDeleteSchedule(String strString) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnRenameSchedule

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnRenameSchedule

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when the rename methode of a schedule is excecuted.

Datatype

OnRenameSchedule(String strOld,String strNew) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnCreateTimeModell

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnCreateTimeModell

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a new time model has been created.-ll--?????

Datatype

OnCreateTimeModell(PfsTimeModell obNewModell) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnDeleteTimeModell

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnDeleteTimeModell

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a time model has been deleted.

Datatype

OnDeleteTimeModell(String strString) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnRenameTimeModell

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnRenameTimeModell

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when the rename methode of a time model is excecuted.

Datatype

OnRenameTimeModell(String strOld,String strNew) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnCreateEvent

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnCreateEvent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a new event has been created.

Datatype

OnCreateEvent(PfsEvent obNewEvent) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnDeleteEvent

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnDeleteEvent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when an event has been deleted.

Datatype

OnDeleteEvent(String strString) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnRenameEvent

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnRenameEvent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when the Rename methode of an event has been excecuted.

Datatype

OnRenameEvent(String strOld,String strNew) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnCreateShift

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnCreateShift

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a new shift has been created.

Datatype

OnCreateShift(PfsModellShift obNewShift) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnDeleteShift

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnDeleteShift

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a shift has been deleted.

Datatype

OnDeleteShift(String strString) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnRenameShift

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnRenameShift

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when the rename methode of a shift is excecuted.

Datatype

OnRenameShift(String strOld,String strNew) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnCreateBreak

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnCreateBreak

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a new break has been created.

Datatype

OnCreateBreak(PfsModellBreak obNewBreak) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnDeleteBreak

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnDeleteBreak

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a break has been deleted.

Datatype

OnDeleteBreak(String strString) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnRenameBreak

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnRenameBreak

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when the rename methode of a break is excecuted.

Datatype

OnRenameBreak(String strOld,String strNew) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnCreateScheduleTime

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnCreateScheduleTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a new schedule time has been created.

Datatype

OnCreateScheduleTime(PfsScheduleTime obNewTime) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnDeleteScheduleTime

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnDeleteScheduleTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a schedule time has been deleted.

Datatype

OnDeleteScheduleTime(String strGuid) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnCreateScheduleValue

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnCreateScheduleValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a new schedule value has been created.

Datatype

OnCreateScheduleValue(PfsScheduleValue obNewValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnDeleteScheduleValue

Manual -> Programming interfaces -> Objectmodel -> PfsEngine -> PfsEngine-Events -> OnDeleteScheduleValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a schedule value has been deleted.

Datatype

OnDeleteScheduleValue(String strGuid) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PfsEvent

Manual -> Programming interfaces -> Objectmodel -> PfsEvent

Remarks

The PFSEvent object is an user defined event, which can be linked to the schedules as relative switching operations.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

'''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''Renaming of an event''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''

Private Sub test()

Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.Pfs

mypfs.Events.Item(0).Rename ("my event")
Debug.Print mypfs.Events.Item(0).Name

End Sub

Other topics in this chapter

PfsEvent-Properties

PfsEvent-Methods


PfsEvent-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsEvent -> PfsEvent-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
BSTR | Guid |  | read only | read only | yes | yes
long | ID |  | read only | read only | yes | yes
BSTR | Name |  | read only | read only | yes | yes
IPfsEvents | Parent |  | read only | read only | yes | yes
IProject | Session |  | read only | read only | yes | yes

Other topics in this chapter

Parent

Name

ID

Guid

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsEvent -> PfsEvent-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsEvents

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> PfsEvent -> PfsEvent-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

is the name of the event

Datatype

Name() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ID

Manual -> Programming interfaces -> Objectmodel -> PfsEvent -> PfsEvent-Properties -> ID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

is the ID of the event

Datatype

ID() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Guid

Manual -> Programming interfaces -> Objectmodel -> PfsEvent -> PfsEvent-Properties -> Guid

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the Guid of the event which is unique and can be used to identify the object.

Datatype

Guid() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsEvent -> PfsEvent-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsEvent-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsEvent -> PfsEvent-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | Execute | - | available | available
VARIANT_BOOL | Rename | - | available | available
IPfsSchedules | Schedules | - | available | available
void | SetModify | - | available | available

Other topics in this chapter

SetModify

Schedules

Execute

Rename


SetModify

Manual -> Programming interfaces -> Objectmodel -> PfsEvent -> PfsEvent-Methods -> SetModify

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can set the modify flag, so that the save option in the context menu of the PFS object is available.

Datatype

SetModify() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Schedules

Manual -> Programming interfaces -> Objectmodel -> PfsEvent -> PfsEvent-Methods -> Schedules

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the schedule objects.

Datatype

Schedules() As PfsSchedules

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Execute

Manual -> Programming interfaces -> Objectmodel -> PfsEvent -> PfsEvent-Methods -> Execute

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can manualy excecute an event.

Datatype

Execute() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Rename

Manual -> Programming interfaces -> Objectmodel -> PfsEvent -> PfsEvent-Methods -> Rename

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can rename the event.

Datatype

Rename(String bstrNewName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PfsEvents

Manual -> Programming interfaces -> Objectmodel -> PfsEvents

Remarks

The Events collection contains the user-defined events of the PFS.User-defined events can be linked to the schedules as relative switching operations.When execution the function Execute PFS event for an event, the linked switching operations in the schedule are executed.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

'''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''Reading out Event Names ''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''

Private Sub test()

Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.Pfs

Dim i As Double

For i = 0 To mypfs.Events.Count - 1
Debug.Print mypfs.Events.Item(i).Name
Next i

End Sub

Other topics in this chapter

PfsEvents-Properties

PfsEvents-Methods


PfsEvents-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsEvents -> PfsEvents-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | read only | read only
IPfsEngine | Parent |  | read only | read only
IProject | Session |  | read only | read only

Other topics in this chapter

Parent

Count

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsEvents -> PfsEvents-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsEngine

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> PfsEvents -> PfsEvents-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsEvents -> PfsEvents-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsEvents-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsEvents -> PfsEvents-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IPfsEvent | CreateEvent | - | available | available
VARIANT_BOOL | DeleteEvent | - | available | available
IPfsEvent | Item | - | available | available
IPfsEvent | ItemByID | - | available | available
IPfsEvent | ItemById | - | available | available

Other topics in this chapter

Item

CreateEvent

DeleteEvent

ItemById


Item

Manual -> Programming interfaces -> Objectmodel -> PfsEvents -> PfsEvents-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the object Event from the collection, which is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Index: Access with an index is mostly used in combination with the property Count to find out the position of the variable object in the list.
  • Event name: The element can also be accessed with its unique name.

Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vNameOrPos) As PfsEvent

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateEvent

Manual -> Programming interfaces -> Objectmodel -> PfsEvents -> PfsEvents-Methods -> CreateEvent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the methode to create a new event.

Datatype

CreateEvent(String bstrName) As PfsEvent

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteEvent

Manual -> Programming interfaces -> Objectmodel -> PfsEvents -> PfsEvents-Methods -> DeleteEvent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can delete an event.

Datatype

DeleteEvent(VARIANT vNameOrId) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ItemById

Manual -> Programming interfaces -> Objectmodel -> PfsEvents -> PfsEvents-Methods -> ItemById

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ItemById(VARIANT vPosition) As IPfsEvent

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


PfsGroup

Manual -> Programming interfaces -> Objectmodel -> PfsGroup

Remarks

The IPfsGroup object is an object which describes an equipment object in the PFS module.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

'''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''Giving out all group names''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''

Private Sub test()

Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.Pfs

Dim i As Double

For i = 0 To mypfs.Groups.Count - 1
Debug.Print mypfs.Groups.Item(i).Name
Next i

End Sub

Other topics in this chapter

PfsGroup-Properties

PfsGroup-Methods


PfsGroup-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsGroup -> PfsGroup-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | CycleEnd |  | available | available | yes | yes
long | CycleStart |  | available | available | yes | yes
BSTR | Guid |  | read only | read only | yes | yes
BSTR | Name |  | read only | read only | yes | yes
IPfsGroups | Parent |  | read only | read only | yes | yes
IProject | Session |  | read only | read only | yes | yes

Other topics in this chapter

Parent

Name

CycleStart

CycleEnd

Guid

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsGroup -> PfsGroup-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsGroups

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> PfsGroup -> PfsGroup-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the name of the group.

Datatype

Name() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


CycleStart

Manual -> Programming interfaces -> Objectmodel -> PfsGroup -> PfsGroup-Properties -> CycleStart

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the start time of the group in seconds.

Datatype

CycleStart() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


CycleEnd

Manual -> Programming interfaces -> Objectmodel -> PfsGroup -> PfsGroup-Properties -> CycleEnd

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the end time of the group in seconds.

Datatype

CycleEnd() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Guid

Manual -> Programming interfaces -> Objectmodel -> PfsGroup -> PfsGroup-Properties -> Guid

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the Guid of the group which is unique and can be used to identify the object.

Datatype

Guid() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsGroup -> PfsGroup-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsGroup-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsGroup -> PfsGroup-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | Rename | - | available | available
IPfsSchedules | Schedules | - | available | available
void | SetModify | - | available | available
ISystemModelGroup | SystemModelGroupAtIndex | - | available | available
long | SystemModelGroupCount | - | available | available
IPfsTimeModells | TimeModells | - | available | available

Other topics in this chapter

Schedules

TimeModells

SetModify

Rename

SystemModelGroupCount

SystemModelGroupAtIndex


Schedules

Manual -> Programming interfaces -> Objectmodel -> PfsGroup -> PfsGroup-Methods -> Schedules

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The "Schedules" object manages the "Schedule" objects.

Datatype

Schedules() As PfsSchedules

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


TimeModells

Manual -> Programming interfaces -> Objectmodel -> PfsGroup -> PfsGroup-Methods -> TimeModells

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The "TimeModels" object manages the "TimeModel" objects.

Datatype

TimeModells() As PfsTimeModells

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SetModify

Manual -> Programming interfaces -> Objectmodel -> PfsGroup -> PfsGroup-Methods -> SetModify

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can set the modify flag, so that the save option in the context menu of the PFS object is available.

Datatype

SetModify() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Rename

Manual -> Programming interfaces -> Objectmodel -> PfsGroup -> PfsGroup-Methods -> Rename

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can rename the group.

Datatype

Rename(String bstrNewName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SystemModelGroupCount

Manual -> Programming interfaces -> Objectmodel -> PfsGroup -> PfsGroup-Methods -> SystemModelGroupCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SystemModelGroupCount() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SystemModelGroupAtIndex

Manual -> Programming interfaces -> Objectmodel -> PfsGroup -> PfsGroup-Methods -> SystemModelGroupAtIndex

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SystemModelGroupAtIndex(long nIndex) As SystemModelGroup

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PfsGroups

Manual -> Programming interfaces -> Objectmodel -> PfsGroups

Remarks

The Groups collection contains the groups of the PFS module (in the editor also called "equipments).

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

'''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''Test Groups''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''
Private Sub TEST()

Dim myPFS As PfsEngine
Set myPFS = MyWorkspace.ActiveDocument.PFS

Call CreateGroups(myPFS)
Call ReadGroups(myPFS)

Call DeleteGroups(myPFS)
DoEvents

Call ReadGroups(myPFS)

End Sub
''''''''''''''''''''''''''''''''''''''''''''''
''''''''''Creates 5 Test Groups'''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Function CreateGroups(myPFS As PfsEngine)

Dim i As Integer
Dim myString As String

For i = 0 To 4
myString = "testgruppe " & i
myPFS.Groups.CreateGroup (myString)
Next i

Debug.Print "Groups were created!"

End Function
''''''''''''''''''''''''''''''''''''''''''''''
''''''''''Read out all Group names''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Function ReadGroups(myPFS As PfsEngine)

Dim i As Integer

For i = 0 To myPFS.Groups.Count - 1
Debug.Print myPFS.Groups.Item(i).Name
Next i

End Function
''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''Delete all Groups''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Function DeleteGroups(myPFS As PfsEngine)

Dim strTMP As String
Dim i As Double

Debug.Print myPFS.Groups.Count & " Groups to delete!"

For i = myPFS.Groups.Count - 1 To 0 Step -1
strTMP = myPFS.Groups.Item(i).Name
Debug.Print "Group deleted! - " & strTMP & " - " & myPFS.Groups.DeleteGroup(strTMP)
Next i

myPFS.Save

End Function

Other topics in this chapter

PfsGroups-Properties

PfsGroups-Methods


PfsGroups-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsGroups -> PfsGroups-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | read only | read only
IPfsEngine | Parent |  | read only | read only
IProject | Session |  | read only | read only

Other topics in this chapter

Parent

Count

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsGroups -> PfsGroups-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsEngine

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> PfsGroups -> PfsGroups-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsGroups -> PfsGroups-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsGroups-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsGroups -> PfsGroups-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IPfsGroup | CreateGroup | - | available | available
VARIANT_BOOL | DeleteGroup | - | available | available
IPfsGroup | Item | - | available | available

Other topics in this chapter

Item

CreateGroup

DeleteGroup


Item

Manual -> Programming interfaces -> Objectmodel -> PfsGroups -> PfsGroups-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the group object from the collection, which is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Index: Access with an index is mostly used in combination with the property Count to find out the position of the variable object in the list.
  • Group name: The group can also be accessed with its unique name.

Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vNameOrPos) As PfsGroup

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateGroup

Manual -> Programming interfaces -> Objectmodel -> PfsGroups -> PfsGroups-Methods -> CreateGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this method you can create a new group.

Datatype

CreateGroup(String bstrName) As PfsGroup

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteGroup

Manual -> Programming interfaces -> Objectmodel -> PfsGroups -> PfsGroups-Methods -> DeleteGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can delete a group.

Datatype

DeleteGroup(VARIANT vName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PfsHoliday

Manual -> Programming interfaces -> Objectmodel -> PfsHoliday

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The Holiday object contains information on a holiday from the feiertage.txt. This object contains a name and a date for the holiday.On loading the project only the holidays of the current year are acquired.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Other topics in this chapter

PfsHoliday-Properties


PfsHoliday-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsHoliday -> PfsHoliday-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
DATE | Date |  | read only | read only | yes | yes
BSTR | Name |  | read only | read only | yes | yes
IPfsHolidays | Parent |  | read only | read only | yes | yes
IProject | Session |  | read only | read only | yes | yes

Other topics in this chapter

Parent

Name

Date

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsHoliday -> PfsHoliday-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsHolidays

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> PfsHoliday -> PfsHoliday-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the unique name of the holiday.

Datatype

Name() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Date

Manual -> Programming interfaces -> Objectmodel -> PfsHoliday -> PfsHoliday-Properties -> Date

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the date of the current holiday.

Datatype

Date() As DATE

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsHoliday -> PfsHoliday-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsHolidays

Manual -> Programming interfaces -> Objectmodel -> PfsHolidays

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The Holidays collection contains all holiday definitions of the defined country for the current year. The holiday definition is saved in the Feiertage.txt.On activating a project these are acquired for the defined country.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

''''''''''''''''''''''''''''''''''''''''''''''
'''''''Giving out the Count of Holidays'''''''
''''''''''''''''''''''''''''''''''''''''''''''
Sub holidaytest()

Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.PFS
Dim i As Double

Debug.Print mypfs.Holidays.Count

End Sub

Other topics in this chapter

PfsHolidays-Properties

PfsHolidays-Methods


PfsHolidays-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsHolidays -> PfsHolidays-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | read only | read only
IPfsEngine | Parent |  | read only | read only
IProject | Session |  | read only | read only

Other topics in this chapter

Parent

Count

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsHolidays -> PfsHolidays-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsEngine

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> PfsHolidays -> PfsHolidays-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsHolidays -> PfsHolidays-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsHolidays-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsHolidays -> PfsHolidays-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IPfsHoliday | Item | - | available | available

Other topics in this chapter

Item


Item

Manual -> Programming interfaces -> Objectmodel -> PfsHolidays -> PfsHolidays-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the holiday object from the collection, which is identified by the parameter vPosition.The parameter vPosition is the index of the element you want to get.Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vPosition) As PfsHoliday

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PfsModellBreak

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreak

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The ModellBreak object is a break within a shift in a time model. During the defined period of time the production should be interrupted.The breaks consist of an unique name and an unique period of time.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Other topics in this chapter

PfsModellBreak-Properties

PfsModellBreak-Methods


PfsModellBreak-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreak -> PfsModellBreak-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
DATE | EndTime |  | available | available | yes | yes
BSTR | Guid |  | read only | read only | yes | yes
BSTR | KeyNote |  | read only | read only | yes | yes
BSTR | Name |  | read only | read only | yes | yes
BSTR | Notes |  | read only | read only | yes | yes
IPfsModellBreaks | Parent |  | read only | read only | yes | yes
IProject | Session |  | read only | read only | yes | yes
DATE | StartTime |  | available | available | yes | yes

Other topics in this chapter

Parent

Name

StartTime

EndTime

Notes

KeyNote

Guid

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreak -> PfsModellBreak-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsModellBreaks

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreak -> PfsModellBreak-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the name of the break.

Datatype

Name() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


StartTime

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreak -> PfsModellBreak-Properties -> StartTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the start time of the break.

Datatype

StartTime() As DATE

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


EndTime

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreak -> PfsModellBreak-Properties -> EndTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the end time of the break.

Datatype

EndTime() As DATE

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Notes

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreak -> PfsModellBreak-Properties -> Notes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Notes can be added and read out, this property contains the notes to a selected break.

Datatype

Notes() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


KeyNote

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreak -> PfsModellBreak-Properties -> KeyNote

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The Keynote returns the name of one or more main objects and of the current object sepperated with a dot. For instance "shift1.break1" is the keynote of the break1 which is an element of the shift1.

Datatype

KeyNote() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Guid

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreak -> PfsModellBreak-Properties -> Guid

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the Guid of the group which is unique and can be used to identify the object.

Datatype

Guid() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreak -> PfsModellBreak-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsModellBreak-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreak -> PfsModellBreak-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | Rename | - | available | available

Other topics in this chapter

Rename


Rename

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreak -> PfsModellBreak-Methods -> Rename

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this method you can rename a break.

Datatype

Rename(String bstrNewName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PfsModellBreaks

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreaks

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The ModellBreaks collection allows the access to the breaks of a shift. The breaks are the production-free times in a shift.The breaks consist of a unique name and a unique period of time.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''Creating some breaks'''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Sub holidaytest()

Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.PFS
Dim mystring As String
Dim i As Double

For i = 0 To 5

mystring = "testbreak" & i

mypfs.Groups.Item(0).TimeModells.Item(0).Shifts.Item(0).Breaks.CreateBreak (mystring)
Debug.Print mystring & " was created!"

Next i

End Sub

Other topics in this chapter

PfsModellBreaks-Properties

PfsModellBreaks-Methods


PfsModellBreaks-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreaks -> PfsModellBreaks-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | read only | read only
IPfsModellShift | Parent |  | read only | read only
IProject | Session |  | read only | read only

Other topics in this chapter

Parent

Count

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreaks -> PfsModellBreaks-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsModellShift

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreaks -> PfsModellBreaks-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreaks -> PfsModellBreaks-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsModellBreaks-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreaks -> PfsModellBreaks-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IPfsModellBreak | CreateBreak | - | available | available
VARIANT_BOOL | DeleteBreak | - | available | available
IPfsModellBreak | Item | - | available | available

Other topics in this chapter

Item

CreateBreak

DeleteBreak


Item

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreaks -> PfsModellBreaks-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the ModelBreak object from the collection, which is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Index: Access with an index is mostly used in combination with the property Count to find out the position of the variable object in the list.
  • ModelBreak name: The ModelBreak can also be accessed with its unique name.

Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vNameOrPos) As PfsModellBreak

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateBreak

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreaks -> PfsModellBreaks-Methods -> CreateBreak

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new break in the current shift and returns it.

Datatype

CreateBreak(LPCTSTR lpszName) As PfsModellBreak

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteBreak

Manual -> Programming interfaces -> Objectmodel -> PfsModellBreaks -> PfsModellBreaks-Methods -> DeleteBreak

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deletes the defined break from the current shift.

Datatype

DeleteBreak(VARIANT vNameOrId) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PfsModellShift

Manual -> Programming interfaces -> Objectmodel -> PfsModellShift

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The ModellShift object is a shift in a time model.Each shift consists of an unique name and a period of time (from/to). This period of time is the active production cycle.The defined period of time must be unique, i.e. you cannot define more than one shift for the same time.Each shift can contain any number of breaks, that interrupt the production cycle.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''Creating, Reading out''''''''''''
''''''''''and Deletion of some shifts'''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub shifttest()

Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.PFS

'''''''Creation''''''''
Dim i As Double
Dim mystring As String
Debug.Print "--Creation:"

For i = 0 To 5
mystring = "testshift " & i
mypfs.Groups.Item(0).TimeModells.Item(0).Shifts.CreateShift (mystring)
Debug.Print mystring & " was created!"
Next i

mypfs.Save

''''Reading Out''''''
Dim o As Double
Debug.Print "--Reading Out:"

For o = 0 To mypfs.Groups.Item(0).TimeModells.Item(0).Shifts.Count - 1
Debug.Print mypfs.Groups.Item(0).TimeModells.Item(0).Shifts.Item(o).Name
Next o

''''''Deletion''''''''
Dim f As Double
Debug.Print "--Deletion:"

For f = mypfs.Groups.Item(0).TimeModells.Item(0).Shifts.Count - 1 To f = 1 Step -1
mypfs.Groups.Item(0).TimeModells.Item(0).Shifts.DeleteShift (f)
Debug.Print "shift " & f; " was deleted!"
Next f

End Sub

Other topics in this chapter

PfsModellShift-Properties

PfsModellShift-Methods


PfsModellShift-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsModellShift -> PfsModellShift-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
DATE | EndTime |  | available | available | yes | yes
BSTR | Guid |  | read only | read only | yes | yes
BSTR | KeyNote |  | read only | read only | yes | yes
BSTR | Name |  | read only | read only | yes | yes
BSTR | Notes |  | read only | read only | yes | yes
IPfsModellShifts | Parent |  | read only | read only | yes | yes
IProject | Session |  | read only | read only | yes | yes
DATE | StartTime |  | available | available | yes | yes

Other topics in this chapter

Parent

Name

StartTime

EndTime

Notes

KeyNote

Guid

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsModellShift -> PfsModellShift-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsModellShifts

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> PfsModellShift -> PfsModellShift-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the name of the shift.

Datatype

Name() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


StartTime

Manual -> Programming interfaces -> Objectmodel -> PfsModellShift -> PfsModellShift-Properties -> StartTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the start time of the shift.

Datatype

StartTime() As DATE

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


EndTime

Manual -> Programming interfaces -> Objectmodel -> PfsModellShift -> PfsModellShift-Properties -> EndTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the end time of the shift.

Datatype

EndTime() As DATE

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Notes

Manual -> Programming interfaces -> Objectmodel -> PfsModellShift -> PfsModellShift-Properties -> Notes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Notes can be added and read out, this property contains the notes to a selected shift.

Datatype

Notes() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


KeyNote

Manual -> Programming interfaces -> Objectmodel -> PfsModellShift -> PfsModellShift-Properties -> KeyNote

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The Keynote returns the name of one or more main objects and of the current object sepperated with a dot. For instance "group1.timemodel1.shift1" is the keynote of the break1 which is an element of the shift1.

Datatype

KeyNote() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Guid

Manual -> Programming interfaces -> Objectmodel -> PfsModellShift -> PfsModellShift-Properties -> Guid

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the Guid of the ModelShift which is unique and can be used to identify the object.

Datatype

Guid() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsModellShift -> PfsModellShift-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsModellShift-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsModellShift -> PfsModellShift-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IPfsModellBreaks | Breaks | - | available | available
VARIANT_BOOL | Rename | - | available | available

Other topics in this chapter

Breaks

Rename


Breaks

Manual -> Programming interfaces -> Objectmodel -> PfsModellShift -> PfsModellShift-Methods -> Breaks

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The "Breaks" object manages the "Break" objects.

Datatype

Breaks() As PfsModellBreaks

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Rename

Manual -> Programming interfaces -> Objectmodel -> PfsModellShift -> PfsModellShift-Methods -> Rename

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode a shift can be renamed.

Datatype

Rename(String bstrName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PfsModellShifts

Manual -> Programming interfaces -> Objectmodel -> PfsModellShifts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The ModellShifts collection allows the access to the shifts of a time model. The single shifts consist of a number and a period of time (from/to), when the shift is active.Any number of breaks can be defined for each shift. The breaks interrupt the production and are inactive states.The period of time of a shift has to be unique, i.e. it is not possible to define a shift within a shift.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

''''''''''''''''''''''''''''''''''''''''''''''
'''''''''Reading out Count of shifts''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub shifttest()

Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.Pfs
Debug.Print mypfs.Groups.Item(0).TimeModells.Item(0).Shifts.Count

End Sub

Other topics in this chapter

PfsModellShifts-Properties

PfsModellShifts-Methods


PfsModellShifts-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsModellShifts -> PfsModellShifts-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | read only | read only
IPfsTimeModell | Parent |  | read only | read only
IProject | Session |  | read only | read only

Other topics in this chapter

Parent

Count

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsModellShifts -> PfsModellShifts-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsTimeModell

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> PfsModellShifts -> PfsModellShifts-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsModellShifts -> PfsModellShifts-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the current project reference.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsModellShifts-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsModellShifts -> PfsModellShifts-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IPfsModellShift | CreateShift | - | available | available
VARIANT_BOOL | DeleteShift | - | available | available
IPfsModellShift | Item | - | available | available

Other topics in this chapter

Item

CreateShift

DeleteShift


Item

Manual -> Programming interfaces -> Objectmodel -> PfsModellShifts -> PfsModellShifts-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the linked shift on the defined position or with the unique name.

Datatype

Item(VARIANT vNameOrPos) As PfsModellShift

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateShift

Manual -> Programming interfaces -> Objectmodel -> PfsModellShifts -> PfsModellShifts-Methods -> CreateShift

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new shift.

Datatype

CreateShift(String bstrName) As PfsModellShift

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteShift

Manual -> Programming interfaces -> Objectmodel -> PfsModellShifts -> PfsModellShifts-Methods -> DeleteShift

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deletes the defined shift.

Datatype

DeleteShift(VARIANT vNameOrId) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PfsSchedule

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

In a schedule object you can create absolute and relativ times and link them with switching points, so that a funktion is excecuted or a the value of a variable can be changed.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''Creation, Reading out''''''''''''
'''''''''''and Deletion of schedules''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub shifttest()

Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.PFS
Dim mystring As String

''''''Creation''''''''
Dim i As Double
Debug.Print "---Creation:"

For i = 0 To 5
mystring = "schedule" & i
mypfs.Groups.Item(0).Schedules.CreateSchedule (mystring)
Debug.Print mystring & " was created!"
Next i

''''''Reading out'''''
Dim f As Double
Debug.Print "---Reading Out:"

For f = 0 To mypfs.Groups.Item(0).Schedules.Count - 1
Debug.Print mypfs.Groups.Item(0).Schedules.Item(f).Name
Debug.Print mypfs.Groups.Item(0).Schedules.Item(f).GUID
Debug.Print mystring & " was created!"
Next f

''''''Deletion'''''
Dim t As Double
Debug.Print "---Deletion:"

For t = mypfs.Groups.Item(0).Schedules.Count - 1 To 1 Step -1
mystring = mypfs.Groups.Item(0).Schedules.Item(t).Name
mypfs.Groups.Item(0).Schedules.DeleteSchedule (t)
Debug.Print mystring & " was deleted!"
Next t

End Sub

Other topics in this chapter

PfsSchedule-Properties

PfsSchedule-Methods


PfsSchedule-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
VARIANT_BOOL | Active |  | available | available | yes | yes
BSTR | Guid |  | read only | read only | yes | yes
BSTR | KeyNote |  | read only | read only | yes | yes
BSTR | Name |  | read only | read only | yes | yes
IPfsSchedules | Parent |  | read only | read only | yes | yes
IProject | Session |  | read only | read only | yes | yes
VARIANT_BOOL | Structure |  | available | available | yes | yes

Other topics in this chapter

Parent

Name

Structure

Active

KeyNote

Guid

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsSchedules

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the name of the schedule.

Datatype

Name() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Structure

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Properties -> Structure

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The Structure property is true if the schedule is marked as "structured schedule".

Datatype

Structure() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Active

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Properties -> Active

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this property the schedule can be activated or deactivated.

Datatype

Active() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


KeyNote

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Properties -> KeyNote

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The Keynote returns the name of one or more main objects and of the current object sepperated with a dot. For instance "group1.schedule1" is the keynote of the schedule1.

Datatype

KeyNote() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Guid

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Properties -> Guid

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the Guid of the Schedule which is unique and can be used to identify the object.

Datatype

Guid() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsSchedule-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | AddToDay | - | available | available
IPfsScheduleDays | ExecutionDays | - | available | available
VARIANT_BOOL | IsDefaultDay | - | available | available
tpPfsDayLink | IsOnDay | - | available | available
VARIANT_BOOL | RemoveFromDay | - | available | available
VARIANT_BOOL | Rename | - | available | available
IPfsScheduleLinks | ScheduleLinks | - | available | available
IPfsSchedules | Schedules | - | available | available
IPfsScheduleTimes | ScheduleTimes | - | available | available
void | SetDefaultDay | - | available | available
IPfsScheduleDays | SkippedDays | - | available | available

Other topics in this chapter

Schedules

ScheduleTimes

ScheduleLinks

ExecutionDays

SkippedDays

IsOnDay

AddToDay

RemoveFromDay

IsDefaultDay

SetDefaultDay

Rename


Schedules

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Methods -> Schedules

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

A Schedule can also be a container for other schedules, with the "Schedules" collection you can access the sub schedules of a schedule.

Datatype

Schedules() As PfsSchedules

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ScheduleTimes

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Methods -> ScheduleTimes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This object manages the schedule times of the schedule.

Datatype

ScheduleTimes() As PfsScheduleTimes

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ScheduleLinks

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Methods -> ScheduleLinks

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This collecton manages the functions and variables which are linked to the schedule.

Datatype

ScheduleLinks() As PfsScheduleLinks

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ExecutionDays

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Methods -> ExecutionDays

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This Collection contains all days where a schedule is linked but not as default.

Datatype

ExecutionDays() As PfsScheduleDays

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SkippedDays

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Methods -> SkippedDays

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Manages the days which are manualy linked to a schedule for some specific dates as skipped days.

Datatype

SkippedDays() As PfsScheduleDays

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsOnDay

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Methods -> IsOnDay

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can check with which link type the schedule is linked on a specific date. The methode returns a tpPFSDayLink.

Datatype

IsOnDay(DATE vDay) As tpPfsDayLink

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


AddToDay

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Methods -> AddToDay

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode a schedule can be linked to a day. As parameters you have to give the methode the date and the type of the link.

Datatype

AddToDay(DATE vDay, tpPfsDayLink sType) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RemoveFromDay

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Methods -> RemoveFromDay

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode a schedule can be removed from a specific date.

Datatype

RemoveFromDay(DATE vDate, [optional] VARIANT bDayOnly) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

#region VSTA generated code (DO NOT MODIFY THIS REGION!)

private void InternalStartup()

{

//(DO NOT modify this event handler!)

this.Startup += new System.EventHandler(MyWorkspace_Startup);

this.Shutdown += new System.EventHandler(MyWorkspace_Shutdown);

}

#endregion

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsDefaultDay

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Methods -> IsDefaultDay

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can check if a schedule is linked as default schedule to a daytype. For instance IsDefaultDay(tppfsMonday) would be true if the schedule is linked to all mondays, instead it would be false.

Datatype

IsDefaultDay(tpPfsDefaultDays sDayOfWeek) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SetDefaultDay

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Methods -> SetDefaultDay

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can link a schedule as default to a day type.

Datatype

SetDefaultDay(tpPfsDefaultDays sDayOfWeek) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Rename

Manual -> Programming interfaces -> Objectmodel -> PfsSchedule -> PfsSchedule-Methods -> Rename

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can rename a schedule.

Datatype

Rename(String bstrNewName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PfsScheduleDay

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleDay

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

A Schedule day object is a specific date on which a schedule is excecuted or not.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''Reading out all Dates''''''''''''
'''''''of the ExecutionDays of a Schedule'''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub test23()

Dim pfs As PfsEngine
Dim i As Integer
Set pfs = MyWorkspace.ActiveDocument.pfs

''''''Giving out the Count of all Execution Days
Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ExecutionDays.Count

For i = 0 To pfs.Groups.Item(0).Schedules.Item(0).ExecutionDays.Count - 1
Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ExecutionDays.Item(i).Date
Next i

End Sub

Other topics in this chapter

PfsScheduleDay-Properties


PfsScheduleDay-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleDay -> PfsScheduleDay-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
DATE | Date |  | read only | read only | yes | yes
IPfsSchedule | Parent |  | read only | read only | yes | yes
IProject | Session |  | read only | read only | yes | yes
short | Type |  | read only | read only | yes | yes

Other topics in this chapter

Parent

Date

Type

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleDay -> PfsScheduleDay-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsSchedule

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Date

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleDay -> PfsScheduleDay-Properties -> Date

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the Date of the Schedule Day.

Datatype

Date() As DATE

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Type

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleDay -> PfsScheduleDay-Properties -> Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the type of the schedule day. Can contain the following values:

  • tpPfsExecute = 0x30,
  • tpPfsSkip = 0x31,
  • tpPfsDefaultDay = 0x32,
  • tpPfsDefaultHDay = 0x33,
  • tpPfsUnused = 0x34,

Datatype

Type() As short

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleDay -> PfsScheduleDay-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsScheduleDays

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleDays

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The ScheduleDay collection contains a date, on which the schedule should be executed or not.With the Type property you can find out, if the schadule should be executed or not on the given day.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''Reading out all Dates''''''''''''
'''''''of the ExecutionDays of a Schedule'''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub test23()

Dim pfs As PfsEngine
Dim i As Integer
Set pfs = MyWorkspace.ActiveDocument.pfs

''''''Giving out the Count of all Execution Days
Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ExecutionDays.Count

For i = 0 To pfs.Groups.Item(0).Schedules.Item(0).ExecutionDays.Count - 1
Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ExecutionDays.Item(i).Date
Next i

End Sub

Other topics in this chapter

PfsScheduleDays-Properties

PfsScheduleDays-Methods


PfsScheduleDays-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleDays -> PfsScheduleDays-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | read only | read only
IPfsSchedule | Parent |  | read only | read only
IProject | Session |  | read only | read only

Other topics in this chapter

Parent

Count

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleDays -> PfsScheduleDays-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsSchedule

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleDays -> PfsScheduleDays-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleDays -> PfsScheduleDays-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsScheduleDays-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleDays -> PfsScheduleDays-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IPfsScheduleDay | Item | - | available | available

Other topics in this chapter

Item


Item

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleDays -> PfsScheduleDays-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the ScheduleDay object from the collection, which is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Index: Access with an index is mostly used in combination with the property Count to find out the position of the variable object in the list.
  • ScheduleDay name: The ScheduleDay can also be accessed with its unique name.

Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vNameOrPos) As PfsScheduleDay

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PfsScheduleLink

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLink

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The ScheduleLink object is a link to the variable/function. Depending on the Type property you can access the linked variable/function with the methods ItemVariable resp. ItemRtFunction.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

'''''''''''''''''''''''''''''''''''''''''''''
''''''''Giving out all Names, function-''''''
'''''''or variable names of a schedule'''''''
'''''''''''''''''''''''''''''''''''''''''''''
Private Sub test()

Dim pfs As PfsEngine
Dim i As Integer
Set pfs = MyWorkspace.ActiveDocument.pfs
Dim mytype As Integer

Debug.Print pfs.Groups.Item(0).Schedules.Item(1).ScheduleLinks.Count - 1

For i = 0 To pfs.Groups.Item(0).Schedules.Item(1).ScheduleLinks.Count - 1
mytype = pfs.Groups.Item(0).Schedules.Item(1).ScheduleLinks.Item(i).Type
Debug.Print pfs.Groups.Item(0).Schedules.Item(1).ScheduleLinks.Item(i).Type
Debug.Print pfs.Groups.Item(0).Schedules.Item(1).ScheduleLinks.Item(i).Name
Debug.Print pfs.Groups.Item(0).Schedules.Item(1).ScheduleLinks.Item(i).GUID

If mytype = 32 Or mytype = 34 Then
Debug.Print pfs.Groups.Item(0).Schedules.Item(1).ScheduleLinks.Item(i).Variable.Driver.Name
Else
Debug.Print pfs.Groups.Item(0).Schedules.Item(1).ScheduleLinks.Item(i).RtFunction.Name
End If

Next i
End Sub

Other topics in this chapter

PfsScheduleLink-Properties

PfsScheduleLink-Methods


PfsScheduleLink-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLink -> PfsScheduleLink-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
BSTR | Guid |  | read only | read only | yes | yes
BSTR | Name |  | read only | read only | yes | yes
IPfsScheduleLinks | Parent |  | read only | read only | yes | yes
IProject | Session |  | read only | read only | yes | yes
tpPfsLinkTypes | Type |  | read only | read only | yes | yes

Other topics in this chapter

Parent

Name

Type

Guid

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLink -> PfsScheduleLink-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsScheduleLinks

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLink -> PfsScheduleLink-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the name of the ScheduleLink.

Datatype

Name() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Type

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLink -> PfsScheduleLink-Properties -> Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Type() As tpPfsLinkTypes

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Guid

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLink -> PfsScheduleLink-Properties -> Guid

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the Guid of the ScheduleLink which is unique and can be used to identify the object.

Datatype

Guid() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLink -> PfsScheduleLink-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsScheduleLink-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLink -> PfsScheduleLink-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IRtFunction | RtFunction | - | read only | read only
IVariable | Variable | - | read only | read only

Other topics in this chapter

RtFunction

Variable


RtFunction

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLink -> PfsScheduleLink-Methods -> RtFunction

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the function which is linked to the switching point. Is just available if the Type of the Link is correctly set.

Datatype

RtFunction() As RtFunction

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Variable

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLink -> PfsScheduleLink-Methods -> Variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the variable which is linked to the switching point. Is just available if the Type of the Link is correctly set.

Datatype

Variable() As Variable

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PfsScheduleLinks

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLinks

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The "IPfsScheduleLinks" object manages the collection of the "IPfsScheduleLink" objects.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub PFS_Sample()
Dim i As Integer
Dim zPFS As PfsEngine
Dim zPFS_GRP As PfsGroup
Dim zPFS_SCD As PfsSchedule
Dim zPFS_SCL As PfsScheduleLink
Dim zFCT As RtFunction
Dim zVAR As Variable

'get PFS Engine
Set zPFS = MyWorkspace.ActiveDocument.Pfs
'get 1st found group
Set zPFS_GRP = zPFS.Groups.Item(0)
'get 1st found schedule
Set zPFS_SCD = zPFS_GRP.Schedules.Item(0)
'get count of ScheduleLinks
Debug.Print "ScheduleLinks: " & zPFS_SCD.ScheduleLinks.Count
'create new FunctionLink
Set zFCT = MyWorkspace.ActiveDocument.RtFunctions.Item("myFunction")
Set zPFS_SCL = zPFS_SCD.ScheduleLinks.CreateFktLink(zFCT)
Debug.Print zPFS_SCL.Name
'create new VariableLink
Set zVAR = MyWorkspace.ActiveDocument.Variables.Item("myVAR")
Set zPFS_SCL = zPFS_SCD.ScheduleLinks.CreateVarLink(zVAR)
Debug.Print zPFS_SCL.Name
'enumerate ScheduleLinks
For i = 0 To zPFS_SCD.ScheduleLinks.Count - 1
Set zPFS_SCL = zPFS_SCD.ScheduleLinks.Item(i)
Debug.Print "Nr." & i & ": " & zPFS_SCL.Name & " [" & zPFS_SCL.Type & "]"
Next i
Set zPFS_SCL = Nothing
'delete ScheduleLinks
zPFS_SCD.ScheduleLinks.DeleteVarLink ("MyVAR")
'save changes
zPFS.Save
End Sub

Other topics in this chapter

PfsScheduleLinks-Properties

PfsScheduleLinks-Methods


PfsScheduleLinks-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLinks -> PfsScheduleLinks-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | read only | read only
IPfsSchedule | Parent |  | read only | read only
IProject | Session |  | read only | read only

Other topics in this chapter

Parent

Count

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLinks -> PfsScheduleLinks-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsSchedule

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLinks -> PfsScheduleLinks-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLinks -> PfsScheduleLinks-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsScheduleLinks-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLinks -> PfsScheduleLinks-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IPfsScheduleLink | CreateFktLink | - | available | available
IPfsScheduleLink | CreateVarLink | - | available | available
VARIANT_BOOL | DeleteFktLink | - | available | available
VARIANT_BOOL | DeleteVarLink | - | available | available
IPfsScheduleLink | Item | - | available | available

Other topics in this chapter

Item

CreateVarLink

CreateFktLink

DeleteVarLink

DeleteFktLink


Item

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLinks -> PfsScheduleLinks-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the ScheduleLink object at the specified position.

Datatype

Item(VARIANT vPosition) As PfsScheduleLink

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateVarLink

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLinks -> PfsScheduleLinks-Methods -> CreateVarLink

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can create a new variable link.

Datatype

CreateVarLink(IVariable pVariable) As PfsScheduleLink

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateFktLink

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLinks -> PfsScheduleLinks-Methods -> CreateFktLink

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can create a new function link.

Datatype

CreateFktLink(IRtFunction pFunction) As PfsScheduleLink

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteVarLink

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLinks -> PfsScheduleLinks-Methods -> DeleteVarLink

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode a variable link can be deleted.

Datatype

DeleteVarLink(VARIANT vNameOrPos) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteFktLink

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleLinks -> PfsScheduleLinks-Methods -> DeleteFktLink

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode a function link can be deleted.

Datatype

DeleteFktLink(VARIANT vNameOrPos) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PfsSchedules

Manual -> Programming interfaces -> Objectmodel -> PfsSchedules

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The Schedules collection contains the existing schedules of an equipment or a parent schedule. The single schedules contain the execution times and a pool of links, e.g. variables/functions. The times are linked to any number of switching points, that execute switching operations.With the Item method combined with the Count property you can iterate through the existing schedules.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

''''''''''''''''''''''''''''''''''''''''''''''
''''''''Reading out Count of schedules''''''''
''''''Creating and Deleting of Schedules''''''
''''''''''''''''''''''''''''''''''''''''''''''

Private Sub shifttest()

Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.pfs

Debug.Print mypfs.Groups.Item(0).Schedules.Count

mypfs.Groups.Item(0).Schedules.CreateSchedule ("myschedule1")
mypfs.Groups.Item(0).Schedules.CreateSchedule ("myschedule2")
mypfs.Groups.Item(0).Schedules.CreateSchedule ("myschedule3")

Debug.Print mypfs.Groups.Item(0).Schedules.Count

mypfs.Groups.Item(0).Schedules.DeleteSchedule ("myschedule1")
mypfs.Groups.Item(0).Schedules.DeleteSchedule ("myschedule2")
mypfs.Groups.Item(0).Schedules.DeleteSchedule ("myschedule3")

Debug.Print mypfs.Groups.Item(0).Schedules.Count

End Sub

Other topics in this chapter

PfsSchedules-Properties

PfsSchedules-Methods


PfsSchedules-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsSchedules -> PfsSchedules-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | read only | read only
IPfsGroup | Parent |  | read only | read only
IProject | Session |  | read only | read only

Other topics in this chapter

Parent

Count

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsSchedules -> PfsSchedules-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsGroup

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> PfsSchedules -> PfsSchedules-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsSchedules -> PfsSchedules-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsSchedules-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsSchedules -> PfsSchedules-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IPfsSchedule | CreateSchedule | - | available | available
VARIANT_BOOL | DeleteSchedule | - | available | available
IPfsSchedule | Item | - | available | available
IPfsSchedule | DuplicateSchedule |  | available | available

Other topics in this chapter

Item

CreateSchedule

DeleteSchedule

DuplicateSchedule


Item

Manual -> Programming interfaces -> Objectmodel -> PfsSchedules -> PfsSchedules-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the Schedule object from the collection, which is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Index: Access with an index is mostly used in combination with the property Count to find out the position of the variable object in the list.
  • Schedule name: The Schedule can also be accessed with its unique name.

Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vNameOrPos) As PfsSchedule

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateSchedule

Manual -> Programming interfaces -> Objectmodel -> PfsSchedules -> PfsSchedules-Methods -> CreateSchedule

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can create a new Schedule.

Datatype

CreateSchedule(String bstrName) As PfsSchedule

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteSchedule

Manual -> Programming interfaces -> Objectmodel -> PfsSchedules -> PfsSchedules-Methods -> DeleteSchedule

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can delete a Schedule.

Datatype

DeleteSchedule(VARIANT vNameOrPos) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DuplicateSchedule

Manual -> Programming interfaces -> Objectmodel -> PfsSchedules -> PfsSchedules-Methods -> DuplicateSchedule

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method will copy the schedule identified by bstrFullSourceName into the PfsSchedules collection. It will return a pointer to the newly created PfsSchedule.

Note: The name of the copy will be made unique the same way as over the GUI.

bstrFullSourceName: Name with all parent names of a PfsSchedule. May be found in the PfsSchedule.KeyNote Property

bCopyChildSchedules: If true, all Child Schedules of the Source Schedule will be copied as well. If false, the source Schedule will be copied without any children.

Datatype

DuplicateSchedule(BSTR bstrFullSourceName, BOOL bCopyChildSchedules) As IPfsSchedule

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

public void Macro_DuplicateSchedule()

{

// Get the Schedule we want to copy

var sourceSchedule = this.Pfs().Groups().Item("someGroupName").Schedules().Item("theScheduleIWantToCopy");

// Get the Collection into which we want to paste the new copy

var targetSchedules = this.Pfs().Groups().Item("theGroupIWantToCopyTheScheduleInto").Schedules();

// Create a Copy

var newSchedule = targetSchedules.DuplicateSchedule(sourceSchedule.KeyNote, 1);

this.Pfs().Save();

// Inspect the result

System.Windows.Forms.MessageBox.Show("newObject: " + newSchedule.KeyNote);

}

VB.NET

VBA

Public Sub SimpleDuplicate()

'Get the Schedule we want to copy

Dim sourceSchedule As PfsSchedule

Set sourceSchedule = thisProject.pfs.Groups.Item("someGroupName").schedules.Item("theScheduleIWantToCopy")

'Get the Collection into which we want to paste the new copy

Dim targetSchedules As PfsSchedules

Set targetSchedules = thisProject.pfs.Groups.Item("theGroupIWantToCopyTheScheduleInto").schedules

'Create a Copy

Set newSchedule = targetSchedules.DuplicateSchedule(sourceSchedule.KeyNote, True)

thisProject.pfs.save

'Inspect the result

Debug.Print "newObject: " + newSchedule.KeyNote

End Sub


PfsScheduleTime

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Schedule Times are the entries in a schedule which can contain switching points for functions or variables.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

''''''''''''''''''''''''''''''''''''''''''''''
''''''''Reading out Types and times of '''''''
''''''''''''''''all Schedule Times''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub mytest1()

Dim mypfs As PfsEngine
Set mypfs = MyWorkspace.ActiveDocument.pfs
Dim i As Integer

For i = 0 To mypfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Count - 1

Debug.Print mypfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).Type
Debug.Print mypfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).Time
Next i

End Sub

Public Sub TestMacro_UserEvent()

Dim pfsTime As PfsScheduleTime

Dim pfsEvent As pfsEvent

Set pfsTime = thisProject.Pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0)

Set pfsEvent = thisProject.Pfs.Events.Item(0)

pfsTime.UserEventId = pfsEvent.ID

thisProject.Pfs.Save

End Sub

Public Sub TestMacro_PredefniedEvent()

Dim pfsTime As PfsScheduleTime

Dim pfsEvent As pfsEvent

Set pfsTime = thisProject.Pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0)

pfsTime.EventId = tpPfsShiftStart

thisProject.Pfs.Save

End Sub

Other topics in this chapter

PfsScheduleTime-Properties

PfsScheduleTime-Methods


PfsScheduleTime-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTime -> PfsScheduleTime-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
tpPfsEventTypes | EventId |  | not used | not used | yes | yes
BSTR | Guid |  | read only | read only | yes | yes
double | Offset |  | available | available | yes | yes
IPfsScheduleTimes | Parent |  | read only | read only | yes | yes
IProject | Session |  | read only | read only | yes | yes
DATE | Time |  | available | available | yes | yes
tpPfsTimeTypes | Type |  | available | available | yes | yes
long | UserEventId |  | not used | not used | yes | yes

Other topics in this chapter

Parent

Time

Type

EventId

Offset

UserEventId

Guid

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTime -> PfsScheduleTime-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsScheduleTimes

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Time

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTime -> PfsScheduleTime-Properties -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the Time which is set to the Schedule Time.

Datatype

Time() As DATE

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Type

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTime -> PfsScheduleTime-Properties -> Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Type() As tpPfsTimeTypes

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


EventId

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTime -> PfsScheduleTime-Properties -> EventId

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Adds a pre-defined event to a relative switch point.

Datatype

EventId() As tpPfsEventTypes

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes


Offset

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTime -> PfsScheduleTime-Properties -> Offset

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the deviation of the set time.

Datatype

Offset() As double

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


UserEventId

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTime -> PfsScheduleTime-Properties -> UserEventId

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Adds a user defined event to a relative switch point.

Datatype

UserEventId() As long

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes


Guid

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTime -> PfsScheduleTime-Properties -> Guid

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the Guid of the ScheduleLink which is unique and can be used to identify the object.

Datatype

Guid() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTime -> PfsScheduleTime-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsScheduleTime-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTime -> PfsScheduleTime-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IPfsEvent | Event | - | not used | not used
IPfsScheduleValues | ScheduleValues | - | available | available

Other topics in this chapter

ScheduleValues

Event


ScheduleValues

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTime -> PfsScheduleTime-Methods -> ScheduleValues

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains all linked values of the schedule time.

Datatype

ScheduleValues() As PfsScheduleValues

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Event

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTime -> PfsScheduleTime-Methods -> Event

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

[MISSING DESCRIPTION]

Datatype

Event() As PfsEvent

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PfsScheduleTimes

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTimes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The ScheduleTimes collection contains the times of the schedule. As the times of a schedule are inherited to its children, this list contains all times of the schedule itself and all the times of parent schedules.Several switching operations can be executed at any time! With the Item method combined with the Count property you can iterate through the existing times.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

''''''''''''''''''''''''''''''''''''''''''''''
''''''''''Creating and Deletion of 5''''''''''
'''''''''''''''Schedule Times'''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub test()

Dim pfs As PfsEngine
Dim i As Integer
Dim g As Integer
Set pfs = MyWorkspace.ActiveDocument.pfs
Dim mytime As tpPfsTimeTypes

mytime = tpPfsRelativeTime
g = pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Count
Debug.Print g

Debug.Print "-------Creation-------"

For i = 0 To 4
Debug.Print g
pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.CreateTime (mytime)
pfs.Save
g = pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Count
Next i

Debug.Print "-------Deletion-------"

For i = g - 1 To 0 Step -1
pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.DeleteTime (i)
pfs.Save
g = pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Count
Debug.Print g
Next i

End Sub

Other topics in this chapter

PfsScheduleTimes-Properties

PfsScheduleTimes-Methods


PfsScheduleTimes-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTimes -> PfsScheduleTimes-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | read only | read only
IPfsSchedule | Parent |  | read only | read only
IProject | Session |  | read only | read only

Other topics in this chapter

Parent

Count

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTimes -> PfsScheduleTimes-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsSchedule

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTimes -> PfsScheduleTimes-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTimes -> PfsScheduleTimes-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsScheduleTimes-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTimes -> PfsScheduleTimes-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IPfsScheduleTime | CreateTime | - | available | available
VARIANT_BOOL | DeleteTime | - | available | available
IPfsScheduleTime | Item | - | available | available

Other topics in this chapter

Item

CreateTime

DeleteTime


Item

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTimes -> PfsScheduleTimes-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the ScheduleTime object from the collection, which is identified by the parameter vPosition.The parameter vPosition is the index of the element you want to get.Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vPosition) As PfsScheduleTime

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateTime

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTimes -> PfsScheduleTimes-Methods -> CreateTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can create a new ScheduleTime.

Datatype

CreateTime(tpPfsTimeTypes tpTimeType) As PfsScheduleTime

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteTime

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleTimes -> PfsScheduleTimes-Methods -> DeleteTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can delete a ScheduleTime.

Datatype

DeleteTime(long lIndex) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PfsScheduleValue

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

A ScheduleValue is a subelement of a ScheduleTime. One ScheduleTime can have many ScheduleValues. For Instance: An absolute ScheduleTime is configured at 12:00am. If you want to change the value of three variables and excecute two functions at 12:00am you need to add five ScheduleValues.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''Reading out Count, Value'''''''''''
''''''''''Active Status and type of'''''''''''
'''''''''''''''Schedule Values''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub test()

Dim pfs As PfsEngine
Dim i As Integer
Dim g As Integer
Set pfs = MyWorkspace.ActiveDocument.pfs

Debug.Print "------>Count:"
Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.Count

For i = 0 To pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.Count - 1
Debug.Print "--->Item " & i & ": "
Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.Item(i).value
Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.Item(i).Active
Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.Item(i).Type
Next i
End Sub

Other topics in this chapter

PfsScheduleValue-Properties

PfsScheduleValue-Methods


PfsScheduleValue-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValue -> PfsScheduleValue-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
VARIANT_BOOL | Active |  | available | available | yes | yes
BSTR | Guid |  | available | available | yes | yes
IPfsScheduleValues | Parent |  | read only | read only | yes | yes
IProject | Session |  | read only | read only | yes | yes
tpPfsLinkTypes | Type |  | read only | read only | yes | yes
VARIANT | Value |  | available | available | yes | yes
short | PasswordLevel |  | read only | read only | yes | yes

Other topics in this chapter

Parent

Active

Type

Value

Guid

Session

PasswordLevel


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValue -> PfsScheduleValue-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsScheduleValues

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Active

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValue -> PfsScheduleValue-Properties -> Active

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property gives you the possibility to activate or deactivate single ScheduleValues.

Datatype

Active() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Type

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValue -> PfsScheduleValue-Properties -> Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Type() As tpPfsLinkTypes

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Value

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValue -> PfsScheduleValue-Properties -> Value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the Value which is written to a variable when the ScheduleValue is executed.

Datatype

Value() As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Guid

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValue -> PfsScheduleValue-Properties -> Guid

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the Guid of the ScheduleValue which is unique and can be used to identify the object.

Datatype

Guid() As String

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValue -> PfsScheduleValue-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PasswordLevel

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValue -> PfsScheduleValue-Properties -> PasswordLevel

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

PasswordLevel() As short

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsScheduleValue-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValue -> PfsScheduleValue-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IPfsScheduleLink | GetScheduleLink | - | available | available
IPfsScheduleLink | ScheduleLink | For internal use only | available | available
VARIANT_BOOL | SetScheduleLink | - | available | available

Other topics in this chapter

ScheduleLink

GetScheduleLink

SetScheduleLink


ScheduleLink

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValue -> PfsScheduleValue-Methods -> ScheduleLink

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

-

Datatype

ScheduleLink() As PfsScheduleLink

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


GetScheduleLink

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValue -> PfsScheduleValue-Methods -> GetScheduleLink

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This methode returns the ScheduleLink object of the ScheduleValue.

Datatype

GetScheduleLink() As PfsScheduleLink

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SetScheduleLink

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValue -> PfsScheduleValue-Methods -> SetScheduleLink

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can manually set the ScheduleLink.

Datatype

SetScheduleLink(IPfsScheduleLink pLink) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PfsScheduleValues

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValues

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The ScheduleValues collection contains the switching points of a schedule. A switching point is linked to a point of time, a variable/function and a value or VBA macro.The execution of the switching point is defined with a status (in-/active). The linked point of time can also be taken from a parent schedule.With this Item method combined with the Count property you can iterate through the switching points of a schedule.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''Creation and Deletion''''''''''''''
'''''''''''of 5 Schedule Values''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
Private Sub test()
Dim pfs As PfsEngine
Dim i As Integer
Dim g As Integer
Set pfs = MyWorkspace.ActiveDocument.pfs

Dim mytype As tpPfsLinkTypes
mytype = tpPfsFunction

Debug.Print "---->Creation:"
For i = 0 To 4
Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.Count
pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.CreateValue (mytype)
Next i

Debug.Print "---->Deletion:"
For i = pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.Count - 1 To 0 Step -1
pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.DeleteValue (i)
Debug.Print pfs.Groups.Item(0).Schedules.Item(0).ScheduleTimes.Item(0).ScheduleValues.Count
Next i
End Sub

Other topics in this chapter

PfsScheduleValues-Properties

PfsScheduleValues-Methods


PfsScheduleValues-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValues -> PfsScheduleValues-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | read only | read only
IPfsScheduleTime | Parent |  | read only | read only
IProject | Session |  | read only | read only

Other topics in this chapter

Parent

Count

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValues -> PfsScheduleValues-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As IPfsScheduleTime

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValues -> PfsScheduleValues-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValues -> PfsScheduleValues-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsScheduleValues-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValues -> PfsScheduleValues-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IPfsScheduleValue | CreateValue | - | available | available
VARIANT_BOOL | DeleteValue | - | available | available
IPfsScheduleValue | Item | - | available | available

Other topics in this chapter

Item

CreateValue

DeleteValue


Item

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValues -> PfsScheduleValues-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the ScheduleValue object from the collection, which is identified by the parameter vPosition.The parameter vPosition is the index of the element you want to get.Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vPosition) As PfsScheduleValue

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateValue

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValues -> PfsScheduleValues-Methods -> CreateValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can create new Schedule Values at a specific ScheduleTime.

Datatype

CreateValue(tpPfsLinkTypes tpLinkType) As PfsScheduleValue

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteValue

Manual -> Programming interfaces -> Objectmodel -> PfsScheduleValues -> PfsScheduleValues-Methods -> DeleteValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can delete a ScheduleValue.

Datatype

DeleteValue(long lIndex) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PfsSwitchingPoint

Manual -> Programming interfaces -> Objectmodel -> PfsSwitchingPoint

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

public void Macro_SwitchingPointPreview()

{

// create a switching point filter

var filter = Pfs().Calendar().CreateSwitchingPointFilter();

// configure the filter

filter.StartTime = System.DateTime.Now;

filter.EndTime = System.DateTime.Now + new System.TimeSpan(7, 0, 0, 0);

filter.TimeModelGroup = "z*";

filter.Schedule = "N*";

filter.Variable = "*";

filter.Function = "*";

filter.SearchData = zenOn.tpPfsData.tpPfsStoredData;

// get the preview for the configuration

string output = "";

object[] switchtingPoints = (object[])filter.SwitchingPointPreview();

foreach (object switchingPoint in switchtingPoints)

{

zenOn.IPfsSwitchingPoint p = (zenOn.IPfsSwitchingPoint)switchingPoint;

output = output + "Active: " + p.Active.ToString();

output = output + " TimeModelGroup: " + p.ScheduleValue.Parent.Parent.Parent.Parent.Parent.Parent.Name;

output = output + " Schedule: " + p.ScheduleValue.Parent.Parent.Parent.Parent.KeyNote;

output = output + " ExecTime: " + p.ExecutionTime.ToString();

output = output + " LinkedType: " + p.ScheduleValue.Type.ToString();

output = output + " LinkedObject: " + p.ScheduleValue.GetScheduleLink().Name;

if (p.ScheduleValue.Value != null)

{

output = output + " SetValue: " + p.ScheduleValue.Value.ToString();

}

output = output + " PasswordLevel: " + p.ScheduleValue.PasswordLevel.ToString();

output = output + " TriggerType: " + p.ScheduleValue.Parent.Parent.Type.ToString();

output = output + " EventId: " + p.ScheduleValue.Parent.Parent.EventId.ToString();

output = output + "\n\n";

}

// show output

System.Windows.Forms.MessageBox.Show(output);

}

VB.NET

VBA

Public Sub Preview()

'create a switching point filter

Dim filter As PfsSwitchingPointFilter

Set filter = thisProject.Pfs.Calendar.CreateSwitchingPointFilter

'configure the filter

filter.StartTime = Now

filter.EndTime = Now + 7

filter.TimeModelGroup = "z*"

filter.Schedule = "N*"

filter.Variable = "*"

filter.Function = "*"

filter.SearchData = tpPfsStoredData

'get the preview for the filter configuration

Dim points() As PfsSwitchingPoint

points = filter.SwitchingPointPreview

'build an output message

Dim output As String

Dim idx As Integer

For idx = 0 To UBound(points)

output = output & "Active: " & CStr(points(idx).Active)

output = output & " TimeModelGroup: " & points(idx).ScheduleValue.Parent.Parent.Parent.Parent.Parent.Parent.Name

output = output & " Schedule: " & points(idx).ScheduleValue.Parent.Parent.Parent.Parent.KeyNote

output = output & " ExecTime: " & CStr(points(idx).ExecutionTime)

output = output & " LinkedType: " & CStr(points(idx).ScheduleValue.Type)

output = output & " LinkedObject: " & CStr(points(idx).ScheduleValue.GetScheduleLink.Name)

output = output & " SetValue: " & CStr(points(idx).ScheduleValue.value)

output = output & " PasswordLevel: " & CStr(points(idx).ScheduleValue.PasswordLevel)

output = output & " TriggerType: " & CStr(points(idx).ScheduleValue.Parent.Parent.Type)

output = output & " EventId: " & CStr(points(idx).ScheduleValue.Parent.Parent.EventId)

output = output & vbNewLine & vbNewLine

Next idx

'show the output

MsgBox output

End Sub

Other topics in this chapter

PfsSwitchingPoint-Properties


PfsSwitchingPoint-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsSwitchingPoint -> PfsSwitchingPoint-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
IPfsScheduleValue | ScheduleValue | Schedule value to be executed at the execution time | available | available | yes | yes
Date | ExecutionTime | Time on which the schedule value is executed | available | available | yes | yes
VARIANT_BOOL | Active | If the switching point is to be executed | available | available | yes | yes

Other topics in this chapter

ScheduleValue

ExecutionTime

Active


ScheduleValue

Manual -> Programming interfaces -> Objectmodel -> PfsSwitchingPoint -> PfsSwitchingPoint-Properties -> ScheduleValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

short PasswordLevel.

Datatype

ScheduleValue() As IPfsScheduleValue

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


ExecutionTime

Manual -> Programming interfaces -> Objectmodel -> PfsSwitchingPoint -> PfsSwitchingPoint-Properties -> ExecutionTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Time when this particular switching point is executed.

Datatype

ExecutionTime() As Date

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Active

Manual -> Programming interfaces -> Objectmodel -> PfsSwitchingPoint -> PfsSwitchingPoint-Properties -> Active

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

true, when the switching point is Active and will be executed.

Datatype

Active() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


PfsSwitchingPointFilter

Manual -> Programming interfaces -> Objectmodel -> PfsSwitchingPointFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The object that is used to get a filtered subset of the switching points that are to be executed in a defined timeframe. To use this class first define the filteroptions in the properties of the object, and then call the SwitchingPointPreview() method to get the results for your current filter as an array. Note that the objects in this array are only allowed to be used while the IPfsSwitchingPointFilter object is still alive or until the next call of SwitchingPointPreview().

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

PfsSwitchingPointFilter-Properties

PfsSwitchingPointFilter-Methods


PfsSwitchingPointFilter-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsSwitchingPointFilter -> PfsSwitchingPointFilter-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
BSTR | TimeModelGroup | Filter string for the names of the time model groups that are to be searched | available | available | yes | yes
BSTR | Schedule | Filter string for the names of the schedules that are to be searched | available | available | yes | yes
BSTR | Variable | Filter string for the names of variables that are set by the schedule values | available | available | yes | yes
BSTR | Function | Filter string for the names of the functions that are triggered by the schedule values | available | available | yes | yes
tpPfsData | SearchData | Data that is to be searched. The locally edited version or the stored one | available | available | yes | yes
DATE | StartTime | Start of the time frame in which we search | available | available | yes | yes
DATE | EndTime | End of the timeframe in which we search | available | available | yes | yes

Other topics in this chapter

TimeModelGroup

Schedule

Variable

Function

SearchData

StartTime

EndTime


TimeModelGroup

Manual -> Programming interfaces -> Objectmodel -> PfsSwitchingPointFilter -> PfsSwitchingPointFilter-Properties -> TimeModelGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Filter string for the names of the time model groups that are to be considered.text.

Datatype

TimeModelGroup() As BSTR

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Schedule

Manual -> Programming interfaces -> Objectmodel -> PfsSwitchingPointFilter -> PfsSwitchingPointFilter-Properties -> Schedule

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Filter string for the names of the schedules that are to be considered.

Datatype

Schedule() As BSTR

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Variable

Manual -> Programming interfaces -> Objectmodel -> PfsSwitchingPointFilter -> PfsSwitchingPointFilter-Properties -> Variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Filter string for the names of the variables that will be set by the switching point.

Datatype

Variable() As BSTR

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Function

Manual -> Programming interfaces -> Objectmodel -> PfsSwitchingPointFilter -> PfsSwitchingPointFilter-Properties -> Function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Filter string for the names of the functions that are to be executed by the switching point.

Datatype

Function() As BSTR

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


SearchData

Manual -> Programming interfaces -> Objectmodel -> PfsSwitchingPointFilter -> PfsSwitchingPointFilter-Properties -> SearchData

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

use tpPfsStoredData to only check the saved configuration or tpPfsEditData to consider the unsaved changes as well.

Datatype

SearchData() As tpPfsData

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


StartTime

Manual -> Programming interfaces -> Objectmodel -> PfsSwitchingPointFilter -> PfsSwitchingPointFilter-Properties -> StartTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Start time of your filter timeframe.

Datatype

StartTime() As DATE

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


EndTime

Manual -> Programming interfaces -> Objectmodel -> PfsSwitchingPointFilter -> PfsSwitchingPointFilter-Properties -> EndTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

End time of your filter timeframe.

Datatype

EndTime() As DATE

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


PfsSwitchingPointFilter-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsSwitchingPointFilter -> PfsSwitchingPointFilter-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
VARIANT | SwitchingPointPreview | Returns an array of switching points that match the filter | available | available | yes | yes

Other topics in this chapter

SwitchingPointPreview


SwitchingPointPreview

Manual -> Programming interfaces -> Objectmodel -> PfsSwitchingPointFilter -> PfsSwitchingPointFilter-Methods -> SwitchingPointPreview

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns an array of switching points that match the filtering set in its properties. Note that the objects in this array are only valid until you next call SwitchingPointPreview() or the IPfsSwitchingPointFilter is destroyed.

Datatype

SwitchingPointPreview() As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

public void Macro_SwitchingPointPreview()

{

// create a switching point filter

var filter = Pfs().Calendar().CreateSwitchingPointFilter();

// configure the filter

filter.StartTime = System.DateTime.Now;

filter.EndTime = System.DateTime.Now + new System.TimeSpan(7, 0, 0, 0);

filter.TimeModelGroup = "z*";

filter.Schedule = "N*";

filter.Variable = "*";

filter.Function = "*";

filter.SearchData = zenOn.tpPfsData.tpPfsStoredData;

// get the preview for the configuration

string output = "";

object[] switchtingPoints = (object[])filter.SwitchingPointPreview();

foreach (object switchingPoint in switchtingPoints)

{

zenOn.IPfsSwitchingPoint p = (zenOn.IPfsSwitchingPoint)switchingPoint;

output = output + "Active: " + p.Active.ToString();

output = output + " TimeModelGroup: " + p.ScheduleValue.Parent.Parent.Parent.Parent.Parent.Parent.Name;

output = output + " Schedule: " + p.ScheduleValue.Parent.Parent.Parent.Parent.KeyNote;

output = output + " ExecTime: " + p.ExecutionTime.ToString();

output = output + " LinkedType: " + p.ScheduleValue.Type.ToString();

output = output + " LinkedObject: " + p.ScheduleValue.GetScheduleLink().Name;

if (p.ScheduleValue.Value != null)

{

output = output + " SetValue: " + p.ScheduleValue.Value.ToString();

}

output = output + " PasswordLevel: " + p.ScheduleValue.PasswordLevel.ToString();

output = output + " TriggerType: " + p.ScheduleValue.Parent.Parent.Type.ToString();

output = output + " EventId: " + p.ScheduleValue.Parent.Parent.EventId.ToString();

output = output + "\n\n";

}

// show output

System.Windows.Forms.MessageBox.Show(output);

}

VB.NET

VBA

Public Sub Preview()

'create a switching point filter

Dim filter As PfsSwitchingPointFilter

Set filter = thisProject.Pfs.Calendar.CreateSwitchingPointFilter

'configure the filter

filter.StartTime = Now

filter.EndTime = Now + 7

filter.TimeModelGroup = "z*"

filter.Schedule = "N*"

filter.Variable = "*"

filter.Function = "*"

filter.SearchData = tpPfsStoredData

'get the preview for the filter configuration

Dim points() As PfsSwitchingPoint

points = filter.SwitchingPointPreview

'build an output message

Dim output As String

Dim idx As Integer

For idx = 0 To UBound(points)

output = output & "Active: " & CStr(points(idx).Active)

output = output & " TimeModelGroup: " & points(idx).ScheduleValue.Parent.Parent.Parent.Parent.Parent.Parent.Name

output = output & " Schedule: " & points(idx).ScheduleValue.Parent.Parent.Parent.Parent.KeyNote

output = output & " ExecTime: " & CStr(points(idx).ExecutionTime)

output = output & " LinkedType: " & CStr(points(idx).ScheduleValue.Type)

output = output & " LinkedObject: " & CStr(points(idx).ScheduleValue.GetScheduleLink.Name)

output = output & " SetValue: " & CStr(points(idx).ScheduleValue.value)

output = output & " PasswordLevel: " & CStr(points(idx).ScheduleValue.PasswordLevel)

output = output & " TriggerType: " & CStr(points(idx).ScheduleValue.Parent.Parent.Type)

output = output & " EventId: " & CStr(points(idx).ScheduleValue.Parent.Parent.EventId)

output = output & vbNewLine & vbNewLine

Next idx

'show the output

MsgBox output

End Sub


PfsTimeModell

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModell

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

A TimeModell contains shifts and breaks and defines the operating time of an equipment.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub PFS_Sample()
Dim i As Integer
Dim zPFS As PfsEngine
Dim zPFS_GRP As PfsGroup
Dim zPFS_TML As PfsTimeModell
'get PFS Engine
Set zPFS = MyWorkspace.ActiveDocument.Pfs
'get 1st found group
Set zPFS_GRP = zPFS.Groups.Item(0)
'get count of TimeModels
Debug.Print "TimeModels: " & zPFS_GRP.TimeModells.Count
'enumerate TimeModels
For i = 0 To zPFS_GRP.TimeModells.Count - 1
Set zPFS_TML = zPFS_GRP.TimeModells.Item(i)
Debug.Print "Nr." & i & ": " & zPFS_TML.Name
'check actual day...
Select Case zPFS_TML.IsOnDay(Now)
Case tpPfsDefaultDay
Debug.Print " tpPfsDefaultDay"
Case tpPfsDefaultHDay
Debug.Print " tpPfsDefaultHDay"
Case tpPfsExecute
Debug.Print " tpPfsExecute"
Case tpPfsSkip
Debug.Print " tpPfsSkip"
Case tpPfsUnused
Debug.Print " tpPfsUnused"
End Select
Next i
End Sub

Other topics in this chapter

PfsTimeModell-Properties

PfsTimeModell-Methods


PfsTimeModell-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModell -> PfsTimeModell-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
BSTR | Guid |  | read only | read only | yes | yes
BSTR | KeyNote |  | read only | read only | yes | yes
BSTR | Name |  | read only | read only | yes | yes
IPfsTimeModells | Parent |  | read only | read only | yes | yes
IProject | Session |  | read only | read only | yes | yes

Other topics in this chapter

Parent

Name

KeyNote

Guid

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModell -> PfsTimeModell-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsTimeModells

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModell -> PfsTimeModell-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the name of the Time Model.

Datatype

Name() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


KeyNote

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModell -> PfsTimeModell-Properties -> KeyNote

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The Keynote returns the path from the equipment to the TimeModell seperated with dots.. For instance "group1.timemodel1" is the keynote of the timemodel1.

Datatype

KeyNote() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Guid

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModell -> PfsTimeModell-Properties -> Guid

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is the Guid of the TimeMoedel which is unique and can be used to identify the object.

Datatype

Guid() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModell -> PfsTimeModell-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsTimeModell-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModell -> PfsTimeModell-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | AddToDay | - | available | available
tpPfsDayLink | IsDefaultDay | - | available | available
tpPfsDayLink | IsOnDay | - | available | available
VARIANT_BOOL | RemoveFromDay | - | not used | not used
VARIANT_BOOL | Rename | - | available | available
void | SetDefaultDay | - | not used | not used
IPfsModellShifts | Shifts | - | available | available

Other topics in this chapter

Shifts

IsOnDay

AddToDay

RemoveFromDay

IsDefaultDay

SetDefaultDay

Rename


Shifts

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModell -> PfsTimeModell-Methods -> Shifts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This collection contains the shifts of the time model.

Datatype

Shifts() As PfsModellShifts

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsOnDay

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModell -> PfsTimeModell-Methods -> IsOnDay

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can check how a time model is linked to a day.

The methode returns a tpPfsDayLink.

Datatype

IsOnDay(DATE vDate) As tpPfsDayLink

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

vDate As Date

This parameter is of type Date like 'Now' or 'CDate("24.11.2007")'.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


AddToDay

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModell -> PfsTimeModell-Methods -> AddToDay

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode a TimeModel can be linked to a Day. As parameters you have to hand over the Date of the day and a Boolean, which defines if the Schedule should be linked to all types of this day or just to this Date.

Datatype

AddToDay(DATE vDay, tpPfsDayLink sType) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RemoveFromDay

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModell -> PfsTimeModell-Methods -> RemoveFromDay

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

[MISSING DESCRIPTION]

Datatype

RemoveFromDay(DATE vDay) As Boolean

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsDefaultDay

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModell -> PfsTimeModell-Methods -> IsDefaultDay

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can check the tpPfsDefaultDays.

Datatype

IsDefaultDay(tpPfsDefaultDays sDayOfWeek) As tpPfsDayLink

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

sDayOfWeek As tpPfsDefaultDays

see tpPfsDefaultDays

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SetDefaultDay

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModell -> PfsTimeModell-Methods -> SetDefaultDay

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

[MISSING DESCRIPTION]

Datatype

SetDefaultDay(tpPfsDefaultDays nDayOfWeek) As void

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Rename

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModell -> PfsTimeModell-Methods -> Rename

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode a Time Model can be renamed.

Datatype

Rename(String bstrNewName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PfsTimeModells

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModells

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The TimeModells collection contains the existing time models of a PFS equipment. The time models contain the shift/break times of an equipment. Any number of time models can exist in an equipment.Time models have to be unique within an equipment.With the Item method you can access a time model. With the Item method combined with the Count property you can iterate through the existing models.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub PFS_Sample()
Dim i As Integer
Dim zPFS As PfsEngine
Dim zPFS_GRP As PfsGroup
Dim zPFS_TML As PfsTimeModell
'get PFS Engine
Set zPFS = MyWorkspace.ActiveDocument.Pfs
'get 1st found group
Set zPFS_GRP = zPFS.Groups.Item(0)
'get count of TimeModels
Debug.Print "TimeModels: " & zPFS_GRP.TimeModells.Count
'create new TimeModel
Set zPFS_TML = zPFS_GRP.TimeModells.CreateModell("Temporary")
'enumerate TimeModels
For i = 0 To zPFS_GRP.TimeModells.Count - 1
Set zPFS_TML = zPFS_GRP.TimeModells.Item(i)
Debug.Print "Nr." & i & ": " & zPFS_TML.Name
Next i
Set zPFS_TML = Nothing
'delete TimeModel
zPFS_GRP.TimeModells.DeleteModell ("Temporary")
'save changes
zPFS.Save
End Sub

Other topics in this chapter

PfsTimeModells-Properties

PfsTimeModells-Methods


PfsTimeModells-Properties

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModells -> PfsTimeModells-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | read only | read only
IPfsGroup | Parent |  | read only | read only
IProject | Session |  | read only | read only

Other topics in this chapter

Parent

Count

Session


Parent

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModells -> PfsTimeModells-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As PfsGroup

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModells -> PfsTimeModells-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Session

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModells -> PfsTimeModells-Properties -> Session

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains the "Project" object.

Datatype

Session() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PfsTimeModells-Methods

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModells -> PfsTimeModells-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IPfsTimeModell | CreateModell | - | available | available
VARIANT_BOOL | DeleteModell | - | available | available
IPfsTimeModell | Item | - | available | available

Other topics in this chapter

Item

CreateModell

DeleteModell


Item

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModells -> PfsTimeModells-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the TimeModel object from the collection, which is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Index: Access with an index is mostly used in combination with the property Count to find out the position of the variable object in the list.
  • ModelBreak name: The TimeModel can also be accessed with its unique name.

Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vNameOrPos) As PfsTimeModell

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateModell

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModells -> PfsTimeModells-Methods -> CreateModell

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can create a Time Model.

Datatype

CreateModell(String bstrName) As PfsTimeModell

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteModell

Manual -> Programming interfaces -> Objectmodel -> PfsTimeModells -> PfsTimeModells-Methods -> DeleteModell

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this methode you can delete a Time Model.

Datatype

DeleteModell(VARIANT vName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


PictureFilter

Manual -> Programming interfaces -> Objectmodel -> PictureFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public Sub ShowAlarms()
Dim zPicCEL As DynPicture
Dim zPicFilter As PictureFilter
Dim zFctAML As RtFunction

'Name of the CEL Screen
Const strCELPicture As String = "EVENTS"
'Name of the PictureSwitch Funktion to open the AML Screen
Const strAMLFunction As String = "picALARM"

'get CEL Screen objects
Set zPicCEL = thisProject.DynPictures.Item(strCELPicture)
'get AML function object
Set zFctAML = thisProject.RtFunctions.Item(strAMLFunction)

'check if Screen and Function exists
If Not zPicCEL Is Nothing And Not zFctAML Is Nothing Then
'if picture is not opened, then exit...
If zPicCEL.Online = False Then Exit Sub

'get actual PictureFilter
Set zPicFilter = zPicCEL.PictureFilter

'change Filter Settings in 'Picture Switch' function...
zFctAML.DynProperties("PictFilter.TimeFilter.ARVTime1") = zPicFilter.DynProperties("TimeFilter.ARVTime1")
zFctAML.DynProperties("PictFilter.TimeFilter.ARVTime2") = zPicFilter.DynProperties("TimeFilter.ARVTime2")
'execute function
zFctAML.Start
End If
End Sub

Other topics in this chapter

PictureFilter-Methods


PictureFilter-Methods

Manual -> Programming interfaces -> Objectmodel -> PictureFilter -> PictureFilter-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CreateDynProperty | - | read only | read only
void | DynProperties [PUT] | - | not used | available
VARIANT | DynProperties [GET] | - | not used | available
VARIANT | DynPropertiesEnum [GET] | - | not used | available
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

CreateDynProperty


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> PictureFilter -> PictureFilter-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> PictureFilter -> PictureFilter-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.
Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> PictureFilter -> PictureFilter-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.
Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> PictureFilter -> PictureFilter-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.
Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


CreateDynProperty

Manual -> Programming interfaces -> Objectmodel -> PictureFilter -> PictureFilter-Methods -> CreateDynProperty

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreateDynProperty(String bsPath) As Boolean

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Project

Manual -> Programming interfaces -> Objectmodel -> Project

Remarks

The object Project is the most central VBA object, as it contains the single modules, as e.g. variables, drivers, ....The single objects of Project can be found in the collection Projects of the object Application. This way is needed for external applications, that are written e.g. in VB or VC++ and access the COM interface of the control system.In Visual Basic for Applications (VBA) the current project always is available via thisProject. The validity in ths case is restricted to the current project. If you need to access a project from within another project, then you have to get the appropriate project from the central collection Projects.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub ProjectExample()

'Return the name of the actual project
MsgBox "Name of the actual project = " & thisProject.Name
'Return the SQL path of the project
MsgBox "Project path = " & thisProject.Path
'Return the unique GUID of the project
MsgBox "GUID of the project = " & thisProject.DynProperties("GUID")
'Return the number of pictures in the project
MsgBox "Number of pictures = " & thisProject.DynPictures.Count
'Return the number of variables in the project
MsgBox "Number of variables = " & thisProject.Variables.Count
'Return the number of templates in the project
MsgBox "Number of templates = " & thisProject.Templates.Count
'Return the number of functions in the project
MsgBox "Number of functions = " & thisProject.RtFunctions.Count

End Sub

Other topics in this chapter

Project-Properties

Project-Methods

Project-Events


Project-Properties

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
IFontLists | FontLists | Returns the FontList object. | available | not used | yes | yes
BSTR | Guid | Returns the unique Project guid(Read Only). | read only | read only | yes | yes
VARIANT_BOOL | IsGlobal |  | read only | read only | yes | yes
VARIANT_BOOL | IsNet |  | available | read only | yes | yes
ILanguageTable | LanguageTable | Returns the Language Table | available | not used | yes | yes
IMessageControl | MessageControl | Returns the MessageControl object. | available | not used | yes | yes
BSTR | Name |  | read only | read only | yes | yes
tpProjectNetTypes | NetType |  | not used | read only | yes | yes
IProjects | Parent |  | read only | read only | yes | yes
BSTR | Path |  | read only | read only | yes | yes
IRemoteTransport | RemoteTransport | Returns the remote transport object. | available | not used | yes | yes
long | ScreenHeight | Sets the height of the screen (Editor Only). | available | not used | yes | yes
long | ScreenWidth | Sets the width of the screen (Editor Only). | available | not used | yes | yes
ISymbols | Symbols | Returns the Symbols object. | read only | not used | yes | yes
IUnits | Units | Returns the Units object. | available | not used | yes | yes

Other topics in this chapter

Parent

Name

Guid

Path

IsNet

IsGlobal

NetType

ScreenWidth

ScreenHeight

Symbols

Units

RemoteTransport

FontLists

MessageControl

LanguageTable


Parent

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Projects

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the name of the project. The project name has to be unique within a workspace. Otherwise it cannot be loaded in the Editor.

Datatype

Name() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Guid

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Properties -> Guid

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Guid() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Path

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Properties -> Path

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the path of the project.

Datatype

Path() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


IsNet

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Properties -> IsNet

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if the project is a network project and false if its not.

Datatype

IsNet() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


IsGlobal

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Properties -> IsGlobal

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if it is a global project and false if its not.

Datatype

IsGlobal() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


NetType

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Properties -> NetType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

NetType() As tpProjectNetTypes

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ScreenWidth

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Properties -> ScreenWidth

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the resolution (width) of the project.

Datatype

ScreenWidth() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


ScreenHeight

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Properties -> ScreenHeight

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the resolution (height) of the project.

Datatype

ScreenHeight() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Symbols

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Properties -> Symbols

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Symbols() As Symbols

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes


Units

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Properties -> Units

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Units() As Units

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


RemoteTransport

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Properties -> RemoteTransport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

RemoteTransport() As RemoteTransport

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


FontLists

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Properties -> FontLists

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

FontLists() As FontLists

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


MessageControl

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Properties -> MessageControl

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MessageControl() As MessageControl

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


LanguageTable

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Properties -> LanguageTable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

LanguageTable() As LanguageTable

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Project-Methods

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IAlarm | Alarm | - | not used | available
IALCEngine | ALCEngine | - | available | available
IArchives | Archives | - | not used | available
IArchivesED | ArchivesED | - | available | not used
VARIANT_BOOL | Build | - | available | not used
ICel | Cel | - | not used | available
VARIANT_BOOL | CheckIn | Save module modifications to server (editor). | available | not used
VARIANT_BOOL | CheckOut | Allow module modifications (editor). | available | not used
IColorPalettes | ColorPalettes | Return the ColorPalettes object. | available | not used
VARIANT_BOOL | CreateDynProperty | - | available | not used
void | Decompile | - | available | not used
IDrivers | Drivers | - | available | available
IDynPictures | DynPictures | - | available | available
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IFileManager | FileManager | - | available | available
VARIANT_BOOL | Get | Get the latest version from the server (editor). | available | not used
IInterlockings | Interlockings | Returns the Interlockings object. | available | not used
VARIANT_BOOL | IsCheckedOut | Returns true when the current module checked out by the current user (editor). | read only | not used
VARIANT_BOOL | IsDifferent | Return true when the local- and server version are different (editor). | read only | not used
VARIANT_BOOL | IsLocked | Returns true when the current module is Locked by another user (editor). | read only | not used
void | ModulePath [PUT] | - | available | not used
BSTR | ModulePath [GET] | - | available | not used
VARIANT_BOOL | NetSend | By use of this methode, VBA-Data can be send to another System | not used | available
IOnlineVariables | OnlineVariables | - | not used | available
VARIANT_BOOL | ParentProject | Sets the parent project of the current project. | available | not used
IPasswords | Passwords | - | available | available
IPfsEngine | Pfs | - | available | available
IRecipes | Recipes | - | available | available
void | Reload | - | not used | available
IRemas | Remas | - | available | available
VARIANT_BOOL | ReplaceLinks | Replaces project links to 'bsSource' with 'bsTarget'. | not used | available
IRGMRecipeGroups | RGMGroups | - | available | available
IRtFunctions | RtFunctions | - | available | available
ISapFunctions | SapFunctions | - | not used | available
IScripts | Scripts | - | available | read only
VARIANT_BOOL | SetUserPropertyStrings | With this methode the Strings for the UserProperties (Rema and Limits) can be set | available | not used
BSTR | String | - | not used | available
ISystemModelManager | SystemModelManager | Return the SystemModelManager object. | available | not used
ITasks | Tasks | - | available | available
ITemplates | Templates | - | available | available
ITimeFunctions | TimeFunctions | - | available | available
VARIANT_BOOL | UndoCheckOut | Undo module modifications (editor). | available | not used
IVarAssignments | VarAssignments | - | available | available
IVariables | Variables | - | available | available
IVarTypes | VarTypes | - | available | available
IZenMenus | ZenMenus | - | available | available
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used
IBatchManager | BatchManager | Returns the BatchManager object | not used | read only
void | Reload | - | not used | available
void | Reload | - | not used | available
IScripts | Scripts | - | available | read only
void | Reload | - | not used | available
IScripts | Scripts | - | available | read only
IScripts | Scripts | - | available | read only

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

CreateDynProperty

Reload

ModulePath [GET]

ModulePath [PUT]

Drivers

Variables

OnlineVariables

RtFunctions

Templates

DynPictures

Passwords

String

Alarm

Cel

Remas

Pfs

Archives

Tasks

VarTypes

Scripts

ZenMenus

TimeFunctions

VarAssignments

Recipes

RGMGroups

ArchivesED

FileManager

Build

Decompile

Get

CheckOut

CheckIn

UndoCheckOut

IsLocked

IsCheckedOut

IsDifferent

ALCEngine

NetSend

SetUserPropertyStrings

Interlockings

ParentProject

ReplaceLinks

SystemModelManager

ColorPalettes

SapFunctions

BatchManager


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


CreateDynProperty

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> CreateDynProperty

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

New Items like AlarmClasses can be created.

Datatype

CreateDynProperty(String bsPath) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

DynProperty as String to be created.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'Create/Change 3 AlarmClasses...
Sub CreateAlarmClasses()
Dim zPRJ As Project
Dim i As Integer
Dim bResult As Boolean

Set zPRJ = MyWorkspace.ActiveDocument
For i = 1 To 3
'check if AlarmClass exists
If CInt(zPRJ.DynProperties("AlarmClasses[-1]")) < i Then
'Create new AlarmClass
bResult = zPRJ.CreateDynProperty("AlarmClasses")
If bResult Then
zPRJ.DynProperties("AlarmClasses[" & i - 1 & "].Name") = "Class_" & i
zPRJ.DynProperties("AlarmClasses[" & i - 1 & "].Color") = RGB(120 + ((i - 1) * 63), 0, 0)
zPRJ.DynProperties("AlarmClasses[" & i - 1 & "].Description") = "created by VBA"
End If
Else
'change existing classes
zPRJ.DynProperties("AlarmClasses[" & i - 1 & "].Name") = "Class_" & i
zPRJ.DynProperties("AlarmClasses[" & i - 1 & "].Color") = RGB(120 + ((i - 1) * 63), 0, 0)
zPRJ.DynProperties("AlarmClasses[" & i - 1 & "].Description") = "created by VBA"
End If
Next i
End Sub


Reload

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> Reload

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Reload(VARIANT_BOOL bMody) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


ModulePath [GET]

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> ModulePath [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ModulePath(tpModulePaths lModule) As String

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ModulePath [PUT]

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> ModulePath [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ModulePath (tpModulePaths lModule, String szNewValue) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Drivers

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> Drivers

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the VBA object for the driver administration. In the driver administration all defined drivers are available. The single driver objects offer important information, e.g. status, driver name, ...

Datatype

Drivers() As Drivers

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Variables

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> Variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns the variables list. The single variables contain on the one hand most of their defined properties, e.g. signal resolution, limits, name, .... and on the other hand Runtime data, e.g. current value, status, ...

Datatype

Variables() As Variables

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnlineVariables

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> OnlineVariables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the VBA object for the online variables administration. The online variables enable a very performant access on changed variables values. With this object you can create an online variable dynamically and link it with a control system variable. The variable is identified with an unique name.With the method Define of the online variable checking the variable is activated.On initializing/changing a variable, that was linked to the online variable, in VBA a Event is executed. In the event handler you now can react on the changed value.

Datatype

OnlineVariables() As OnlineVariables

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RtFunctions

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> RtFunctions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the functions administration, containing all defined functions. The single functions contain general information on type, name and can be executed in the Runtime with the method Start.

Datatype

RtFunctions() As RtFunctions

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Templates

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> Templates

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns the list of defined Frames. The single Frames contain information an position, colour, size, ...

Datatype

Templates() As Templates

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPictures

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> DynPictures

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the VBA object for the defined pictures (*.zp). With the name or the index a picture can be accessed. The different elements DynPicture contain information on the display (position, colour, status, ... ), the linked Frame and a list of the dynamic elements of the picture.

Datatype

DynPictures() As DynPictures

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Passwords

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> Passwords

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the object of the user administration. This object contains the defined users of the project. You also have the possibility to create new users or edit/delete existing users.Additionally you can use this object to find out the currently logged in user.

Datatype

Passwords() As Passwords

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


String

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> String

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this method texts from the language table can be translated. The key of a string has to be given with strKeyId. The translated string in the language of the Runtime is returned. Keyword in Language table: PlantAt table ZENONSTR.TXT: PlantAt table GERMAN.TXT: Anlage

Datatype

String(String strKeyId) As String

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

A string which defines the key word. For example: "@Plant"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

strKeyId As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadLanguageString()

'Reads the keyyword "@Plant" and shows the translation in the selected language
'Returns "Anlage" when the GERMAN.TXT is selected
MsgBox thisProject.String("@Plant")

End Sub


Alarm

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> Alarm

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the object for alarming.With this object the single alarms can be accessed and the properties of the alarms can be read.With Events you have the possibility, to execute actions on the occurance of events.

Datatype

Alarm() As Alarm

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Cel

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> Cel

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the 'Cel' object for the Chronologic Event List. With this object CEL entries can be created or inherited.

Datatype

Cel() As Cel

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Remas

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> Remas

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns the remas object. With this object you have the opportunity to handle reaction matrixes.

Datatype

Remas() As Remas

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Pfs

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> Pfs

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns the PfsEngine object. With this object you have the opportunity to handle the hole production and facility scheduler.

Datatype

Pfs() As PfsEngine

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Archives

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> Archives

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the 'Archives' object to read and write archive values.

Datatype

Archives() As Archives

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Tasks

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> Tasks

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a object for the tasks. This object contains a collection of tasks, tasks can be defined with the 'Process Control Engine' (PCE).A task is a VisualBasicScript file and can be executed over the Tasks/Task object model.

Datatype

Tasks() As Tasks

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


VarTypes

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> VarTypes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns an object for the datatypes. With this object datatypes can be created, edited and deleted.

Datatype

VarTypes() As VarTypes

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Scripts

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> Scripts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Scripts() As IScripts

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


ZenMenus

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> ZenMenus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns an object for the menus. With this object menus can be created, edited and deleted.

Datatype

ZenMenus() As ZenMenus

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


TimeFunctions

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> TimeFunctions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns the list of defined time functions. With this object time functions can be created, edited and deleted.

Datatype

TimeFunctions() As TimeFunctions

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


VarAssignments

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> VarAssignments

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns an object for the VarAssignments. The VarAssignments collection contains all existing allocations of the current project. With this collection you can access all or certain allocations.

Datatype

VarAssignments() As VarAssignments

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Recipes

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> Recipes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns the recipes object. With this object you have the opportunity to handle standard recipes.

Datatype

Recipes() As Recipes

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RGMGroups

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> RGMGroups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns the RGMRecipeGroups object. With this object you have the opportunity to handle recipes from the RGM.

Datatype

RGMGroups() As RGMRecipeGroups

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ArchivesED

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> ArchivesED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the 'ArchivesED' object to create archives in the editor.

Datatype

ArchivesED() As ArchivesED

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


FileManager

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> FileManager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the VBA object for the file manager. With this object graphics, language, help, multimedia, lists, driver and other files can be managed.

Datatype

FileManager() As FileManager

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Build

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> Build

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method starts an rebuild of the runtime files, depending to given parameter all or only the changed files are created.

Datatype

Build(tpBuildMethod lMethod) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A constant which defines the kind of compilation. tpAll = 0, tpIncremental = 1

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

lMethod As tpBuildMethod

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub BuildRtFiles()
'build only changed
MyWorkspace.ActiveDocument.Build tpIncremental
'build all
MyWorkspace.ActiveDocument.Build tpAll
End Sub


Decompile

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> Decompile

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method starts an import of the runtime files, depending to given parameter there will be a warning message or not.

Datatype

Decompile(Boolean bPromptForOverwrite) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

True for a message in the editor which asks you if the projected files should be replaced by the runtime files. False if no message should appear.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bPromptForOverwrite As Boolean

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub DeCompileRTFiles()
'Runtime files will be imported with warning message
MyWorkspace.ActiveDocument.Decompile True
End Sub


Get

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> Get

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype

Get() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckOut

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> CheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype

CheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckIn

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> CheckIn

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype

CheckIn() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


UndoCheckOut

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> UndoCheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype

UndoCheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsLocked

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> IsLocked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype

IsLocked() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsCheckedOut

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> IsCheckedOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype

IsCheckedOut() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsDifferent

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> IsDifferent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype

IsDifferent() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ALCEngine

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> ALCEngine

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the 'ALCEngine' object of the automatic line coloring mechanism.

Datatype

ALCEngine() As ALCEngine

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


NetSend

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> NetSend

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

NetSend(tpNetSendType NetSendType, String strDestination, long lId, VARIANT pvData) As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

A string wich defines the destination computer. For example: "Workstation_1". This parameter is only evaluated when tpNetSendType = tpToSpecificClient is used.

Defines the data which should be sent with the message.

Hint: No zenOn objects can be sent!

A constant which defines the different sending types.

This ID specifies a message and makes it possible to differ it from other messages.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

strDestination As String

pvData As Variant

NetSendType As tpNetSendType

lId As Long

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ServerNetSend()

'Server should send to all clients whith an ID = 99 and data = "This is a test"
Debug.Print thisProject.NetSend(2, "", 99, "This is a test")

End Sub


SetUserPropertyStrings

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> SetUserPropertyStrings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Sets the 'UserProperty' strings for Remas/Limits.

Datatype

SetUserPropertyStrings(String strProperty, VARIANT vStrings) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Array of texts as variant.

Defines on wich UserProperty the array of string are imported.

Possible parameters:

  • UserProperty1
  • UserProperty2

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vStrings As Variant

strProperty As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'insert UserProperties when project is loaded in the editor.
Private Sub ZenWorkspace_OnProjectLoaded(ByVal obProject As IProject)
Dim arrProps(4) As String
Dim arrTexts As Variant
'insert UserPropertyStrings for Remas/Limits
Stop
arrProps(0) = "Property 1"
arrProps(1) = "Property 2"
arrProps(2) = "Property 3"
arrProps(3) = "Property 4"
arrProps(4) = "Property 5"
arrTexts = arrProps

'insert texts into "UserProperty1"
Call obProject.SetUserPropertyStrings("UserProperty1", arrTexts)
'insert texts into "UserProperty2"
Call obProject.SetUserPropertyStrings("UserProperty2", arrTexts)
End Sub

Sub ReadUserProps()
'returns the UserProperty1 as string from the specific limit
Debug.Print thisProject.Variables.Item("WIZ_VAR_10").Limits.Item(0).DynProperties("UserProperty1")
'it works also with remas...
End Sub


Interlockings

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> Interlockings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the VBA object for the interlockings. With this object you have the opportunity to edit interlockings.

Datatype

Interlockings() As Interlockings

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ParentProject

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> ParentProject

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ParentProject(String bsProjectName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ReplaceLinks

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> ReplaceLinks

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ReplaceLinks(String bsSourcePrjName,String bsTargetPrjName) As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SystemModelManager

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> SystemModelManager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SystemModelManager() As SystemModelManager

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ColorPalettes

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> ColorPalettes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ColorPalettes() As ColorPalettes

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SapFunctions

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> SapFunctions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SapFunctions() As SapFunctions

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


BatchManager

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Methods -> BatchManager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

BatchManager() As IBatchManager

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Project-Events

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description |  | Editor | Runtime | VBA | VSTA
void | Active |  | available |  | available | yes |  | yes
void | FirePostReload |  | not used |  | available | yes |  | yes
void | FirePreReload |  | not used |  | available | yes |  | yes
void | Inactive |  | not used |  | available | yes |  | yes
void | OnMessageSetDestination | Fired before a message is send. |  | not used | available | yes | yes
void | OnNetReceive | This event is fired when NetData is received, it contains the Data-Source, an Id and the actual Data |  | not used | available | yes | yes
void | OnPostVSTAUpdate | For internal use only | not used |  | available | yes |  | yes
void | OnPreVSTADebugStart | For internal use only | not used |  | available | yes |  | yes
void | OnPreVSTADebugStop | For internal use only | not used |  | available | yes |  | yes
void | OnPreVSTAUpdate | For internal use only | not used |  | available | yes |  | yes
void | OnVSTADebugStart | For internal use only | not used |  | available | yes |  | yes
void | OnVSTADebugStopped | For internal use only | not used |  | available | yes |  | yes
void | SbToServer |  | not used |  | available | yes |  | yes
void | ServerToSb |  | not used |  | available | yes |  | yes

Other topics in this chapter

Active

Inactive

ServerToSb

SbToServer

FirePreReload

FirePostReload

OnNetReceive

OnPreVSTADebugStart

OnVSTADebugStart

OnPreVSTADebugStop

OnVSTADebugStopped

OnPreVSTAUpdate

OnPostVSTAUpdate

OnMessageSetDestination


Active

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Events -> Active

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is executed on activating the project in the Runtime.A project is activated at the following actions:· Starting the Runtime· Reloading· Redundancy update

Datatype

Active() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Inactive

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Events -> Inactive

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is executed on deactivating the project in the Runtime. A project is deactivated at the following actions:· Closing the Runtime · Reloading · Redundancy update

Datatype

Inactive() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ServerToSb

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Events -> ServerToSb

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is executed when a standby which has been uplevelled to server is downlevelled to standby again. The event occurs on the standby server.

Datatype

ServerToSb() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SbToServer

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Events -> SbToServer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is executed when the server crashes and so the standby gets server. It is also executed when the server restarts and the standby is downlevelled.

Datatype

SbToServer() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


FirePreReload

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Events -> FirePreReload

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This action is fired on client or standby-server when a reload of the project is started.

Datatype

FirePreReload() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


FirePostReload

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Events -> FirePostReload

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This action is fired after the FirePreReload on client or standby-server when a reload of the project is started.

Datatype

FirePostReload() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnNetReceive

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Events -> OnNetReceive

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event reacts on receiving a NetSend message.

Datatype

OnNetReceive(String strSource, long lId, LPVARIANT pvData) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

This parameter reads out the data of the NetSend message.

This string provides the name of the sending computer.

This parameter reads out the ID of the NetSend message.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

pvData As Variant

strSource As String

lId As Long

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'This event will be executed when the client receives the NetSend message
Private Sub Project_OnNetReceive(ByVal strSource As String, ByVal lID As Long, pvData As Variant)

MsgBox "Source string = " & strSource
MsgBox "lID = " & lID
MsgBox "Data = " & pvData

End Sub


OnPreVSTADebugStart

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Events -> OnPreVSTADebugStart

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnPreVSTADebugStart() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnVSTADebugStart

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Events -> OnVSTADebugStart

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnVSTADebugStart() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnPreVSTADebugStop

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Events -> OnPreVSTADebugStop

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnPreVSTADebugStop() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnVSTADebugStopped

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Events -> OnVSTADebugStopped

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnVSTADebugStopped() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnPreVSTAUpdate

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Events -> OnPreVSTAUpdate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnPreVSTAUpdate() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnPostVSTAUpdate

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Events -> OnPostVSTAUpdate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnPostVSTAUpdate() As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnMessageSetDestination

Manual -> Programming interfaces -> Objectmodel -> Project -> Project-Events -> OnMessageSetDestination

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnMessageSetDestination(String bsDestinationGuid, String bsDestination) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub Project_OnMessageSetDestination(ByVal bsDestinationGuid As String, bsDestination As String)
Dim strGuid As String
Dim strNewDestination

strGuid = "cdd44b4a-5951-43bb-a9d9-e0810dfb9bc3"
If bsDestinationGuid = strGuid Then
'Now we change the destination before a message is send!
strNewDestination = ""
bsDestination = strNewDestination
End If
End Sub


Projects

Manual -> Programming interfaces -> Objectmodel -> Projects

Remarks

The collection Projects contains all projects loaded in the Runtime. The single projects of the Runtime are available as objects Project in VBA. It is not possible to create an object of this type with the attribute New.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub GetProjects()
Dim i As Integer
'enumerate all projects
'"Application" instead of "ApplicationED" at runtime!
For i = 0 To ApplicationED.Projects.Count - 1
Debug.Print ApplicationED.Projects.Item(i).Name & _
ApplicationED.Projects.Item(i).DynProperties("GUID")
Next i
End Sub

Sub CreateProject()
'create a new project
ApplicationED.Projects.Create
End Sub

Other topics in this chapter

Projects-Properties

Projects-Methods


Projects-Properties

Manual -> Programming interfaces -> Objectmodel -> Projects -> Projects-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | read only | read only
long | CountHidden | For internal use only | not used | not used
IApplication | Parent |  | read only | read only

Other topics in this chapter

Parent

Count

CountHidden


Parent

Manual -> Programming interfaces -> Objectmodel -> Projects -> Projects-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Application

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> Projects -> Projects-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


CountHidden

Manual -> Programming interfaces -> Objectmodel -> Projects -> Projects-Properties -> CountHidden

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CountHidden() As long

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes


Projects-Methods

Manual -> Programming interfaces -> Objectmodel -> Projects -> Projects-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | Create | Shows the dialog to create a new project and/or workspace. | available | not used
VARIANT_BOOL | CreateEx | Creates a new project without dialog. | available | not used
IProject | Item | - | available | not used
IProject | ItemHidden | For internal use only | not used | not used

Other topics in this chapter

Item

ItemHidden

Create

CreateEx


Item

Manual -> Programming interfaces -> Objectmodel -> Projects -> Projects-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the object Project from the collection, identified by the parameter vID.The parameter vID can have two values:- Index: The access with the index is often used in combination with the property Count to find an object Project by its position in the list. For „simple“ (not hierarchical) projects the index 0 always is the current project.- Project name: The project can be found by its name.

Datatype

Item(VARIANT vID) As Project

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ItemHidden

Manual -> Programming interfaces -> Objectmodel -> Projects -> Projects-Methods -> ItemHidden

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ItemHidden(VARIANT vID) As Project

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Create

Manual -> Programming interfaces -> Objectmodel -> Projects -> Projects-Methods -> Create

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Opens the dialog to create a new project.

Datatype

Create() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateEx

Manual -> Programming interfaces -> Objectmodel -> Projects -> Projects-Methods -> CreateEx

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The Projects-Collection has received a new method CreateEx(), in order to generate projects without dialogs:

Project name and project basis path can be specified as parameter, in order to define whether it is a global project or a multi user project and in the last case its server name. The new project is basically attached to the open workspace and no error messages or queries will be displayed as dialogs or message boxes.

Datatype

CreateEx(String bsName, String bsPath, Boolean bGlobal, Boolean bMultiUser, String bsServer) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Call MyWorkspace.Application.Projects.CreateEx("Hugo", "D:\TEMP\HUGO", False, False, "")


PropParam

Manual -> Programming interfaces -> Objectmodel -> PropParam

PropParam

Possibility to determine PropertyOptions and read,write status for properties.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

public void Macronew()

{

zenOn.IPropParam Param = this.ActiveDocument.get_DynPropertyParam("MultitouchMode");

if (Param.OptionCount > 0)

{

for (int i = 0; i < Param.OptionCount; i++)

{

this.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);

this.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);

}

}

}

VB.NET

Public Sub Macronew()

Dim Param As zenOn.IPropParam = Me.ActiveDocument.get_DynPropertyParam("MultitouchMode")

If Param.OptionCount > 0 Then

For i As Integer = 0 To Param.OptionCount - 1

Me.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)

Me.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)

Next

End If

End Sub

VBA

Public Sub VBAMacro()

Dim obparm As PropParam

Dim n As Integer

Set obparm = thisProject.DynPropertyParam("MultitouchMode")

If (Not obparm Is Nothing) Then

If obparm.OptionCount > 0 Then

For n = 0 To obparm.OptionCount - 1

Debug.Print "Option:" & obparm.OptionText(n)

Debug.Print "Option:" & obparm.OptionValue(n)

Next

End If

End If

End Sub

Other topics in this chapter

PropParam-Properties

PropParam-Methods


PropParam-Properties

Manual -> Programming interfaces -> Objectmodel -> PropParam -> PropParam-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
VARIANT_BOOL | Enabled | Returns whether or not the property is enabled. | read only | read only | yes | yes
long | OptionCount | Returns the amount of options. | read only | read only | yes | yes

Other topics in this chapter

OptionCount

Enabled


OptionCount

Manual -> Programming interfaces -> Objectmodel -> PropParam -> PropParam-Properties -> OptionCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the amount of available Options, in case there are no Options this value will be: 0.

Datatype

OptionCount() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Enabled

Manual -> Programming interfaces -> Objectmodel -> PropParam -> PropParam-Properties -> Enabled

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a value that determines if the property is usable or not.

Datatype

Enabled() As VARIANT_BOOL

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PropParam-Methods

Manual -> Programming interfaces -> Objectmodel -> PropParam -> PropParam-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
BSTR | OptionText | Returns the text of the option at the given index | read only | read only | yes | yes
VARIANT | OptionValue | Returns the value of the option at the given index | read only | read only | yes | yes

Other topics in this chapter

OptionText

OptionValue


OptionText

Manual -> Programming interfaces -> Objectmodel -> PropParam -> PropParam-Methods -> OptionText

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the text of Option lIndex

Datatype

OptionText(long lIndex) As BSTR

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

long lIndex

VB.NET

Dim lIndex As Long

VBA

Dim lIndex As Long

Examples

C#

public void Macronew()

{

zenOn.IPropParam Param = this.ActiveDocument.get_DynPropertyParam("MultitouchMode");

if (Param.OptionCount > 0)

{

for (int i = 0; i < Param.OptionCount; i++)

{

this.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);

this.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);

}

}

}

VB.NET

Public Sub Macronew()

Dim Param As zenOn.IPropParam = Me.ActiveDocument.get_DynPropertyParam("MultitouchMode")

If Param.OptionCount > 0 Then

For i As Integer = 0 To Param.OptionCount - 1

Me.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)

Me.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)

Next

End If

End Sub

VBA

Public Sub VBAMacro()

Dim obparm As PropParam

Dim n As Integer

Set obparm = thisProject.DynPropertyParam("MultitouchMode")

If (Not obparm Is Nothing) Then

If obparm.OptionCount > 0 Then

For n = 0 To obparm.OptionCount - 1

Debug.Print "Option:" & obparm.OptionText(n)

Debug.Print "Option:" & obparm.OptionValue(n)

Next

End If

End If

End Sub


OptionValue

Manual -> Programming interfaces -> Objectmodel -> PropParam -> PropParam-Methods -> OptionValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the value of Option lIndex.

Datatype

OptionValue(long lIndex) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

long lIndex

VB.NET

Dim lIndex As Long

VBA

Dim lIndex As Long

Examples

C#

public void Macronew()

{

zenOn.IPropParam Param = this.ActiveDocument.get_DynPropertyParam("MultitouchMode");

if (Param.OptionCount > 0)

{

for (int i = 0; i < Param.OptionCount; i++)

{

this.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);

this.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);

}

}

}

VB.NET

Public Sub Macronew()

Dim Param As zenOn.IPropParam = Me.ActiveDocument.get_DynPropertyParam("MultitouchMode")

If Param.OptionCount > 0 Then

For i As Integer = 0 To Param.OptionCount - 1

Me.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)

Me.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)

Next

End If

End Sub

VBA

Public Sub VBAMacro()

Dim obparm As PropParam

Dim n As Integer

Set obparm = thisProject.DynPropertyParam("MultitouchMode")

If (Not obparm Is Nothing) Then

If obparm.OptionCount > 0 Then

For n = 0 To obparm.OptionCount - 1

Debug.Print "Option:" & obparm.OptionText(n)

Debug.Print "Option:" & obparm.OptionValue(n)

Next

End If

End If

End Sub


Recipe

Manual -> Programming interfaces -> Objectmodel -> Recipe

Remarks

Recipes serve for the assembling of input lists for setpoint values and commands which in online operation are executed with a function call.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_Recipe(ByRef zRecipes As Recipes)
'Declarations
Dim zRecipe As recipe
Dim zVariable As Variable
Dim i As Integer

'Initialization of zRecipe with the first element in the "zRecipes" object
Set zRecipe = zRecipes.Item(0)
'Initialization of zVariable with the first element in the "Variables" object
Set zVariable = thisProject.Variables.Item(0)

'Create new "RecipeValue" object
'Assign zVariable with a default value of 50
zRecipe.Create zVariable.PvID, 50

'For every "RecipeValue" object in zRecipe,...
For i = 0 To zRecipe.Count - 1
'... output the name
Debug.Print "Name: " & zRecipe.Item(i).ItemVariable.Name
'and value
Debug.Print "Value: " & zRecipe.Item(i).Value
Next i

'Delete the former created "RecipeValue" object
zRecipe.Delete (zVariable.PvID)

End Sub

Other topics in this chapter

Recipe-Properties

Recipe-Methods

Recipe-Dynamic properties


Recipe-Properties

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | Count |  | read only | read only | yes | yes
BSTR | Name |  | available | available | yes | yes
IRecipes | Parent |  | read only | read only | yes | yes

Other topics in this chapter

Parent

Name

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Recipes

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the name of the recipe.

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Recipe-Methods

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IRecipeValue | Create | Creates and returns a new Object | available | available
VARIANT_BOOL | Delete | Deletes the objects from collection | available | available
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
VARIANT_BOOL | ExecuteValues | - | not used | available
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | available
VARIANT_BOOL | ExportXML | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | ImportXML | Imports the selected XML file | available | not used
IRecipeValue | Item | Returns a object at a position or by a specified key | available | not used
VARIANT_BOOL | ReadValues | - | not used | available
VARIANT_BOOL | Save | - | available | available
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

Item

Create

Delete

Export

ExecuteValues

ReadValues

Save

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

ExportXML

ImportXML


Item

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a "RecipeValue"object at a position or by a specified key.

Datatype

Item(VARIANT vID) As RecipeValue

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Create

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Methods -> Create

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new "RecipeValue" object.

Datatype

Create(long PvID,double dfValue,[optional]VARIANT vProjekt) As RecipeValue

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

PvID from the "Variable" object that should be assigned.

Default value of the assigned variable.

Defines the project, where the "RecipeValue" object should be created. If this value is not specified, the current project will be selected.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

PvID As Long

dfValue As double

vProjekt As [optional]Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub CreateRecipeValue(ByRef zRecipe As recipe)
'Declarations
Dim zVariable As Variable
Dim i As Integer

'Initialization of zVariable with the first "Variable" object within the "Variables" object
Set zVariable = thisProject.Variables.Item(0)

'Create new "RecipeValue" object within zRecipe
'zVariable.PvID assigns zVariable to the recipe
'22 will be the default value of zVariable
zRecipe.Create zVariable.PvID, 22

'For every "RecipeValue" object within zRecipe...
For i = 0 To zRecipe.Count - 1
'...output the value
Debug.Print i + 1 & ". value: " & zRecipe.Item(i).Value
Next i

End Sub


Delete

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Methods -> Delete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deletes a "RecipeValue" object from the collection by the PvID of the "Variable" object that was assigned to the "RecipeValue" object.

Datatype

Delete(long PvID,[optional]VARIANT vProjekt) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

PvID from the "Variable" object that should be deleted.

Defines the project, where the "RecipeValue" object should be deleted. If this value is not specified the current project will be selected.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

PvID As Long

vProjekt As [optional]Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub DeleteRecipeValue(ByRef zRecipe As recipe)

'Declarations
Dim zVariable As Variable
Dim i As Integer

'Initialization of zVariable with the variable that is named "zenOn_Test"
Set zVariable = thisProject.Variables.Item("zenOn_Test")

'Deletes the variable "zenOn_Test" from the recipe
zRecipe.Delete zVariable.PvID

'For every "RecipeValue" object within zRecipe...
For i = 0 To zRecipe.Count - 1
'...output the value
Debug.Print i + 1 & ". value: " & zRecipe.Item(i).Value
Next i

End Sub


Export

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Exports the recipe into a textfile.

Datatype

Export(String strFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ExecuteValues

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Methods -> ExecuteValues

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Overwrites the current values of the variables in the recipe with the recipe values.

Datatype

ExecuteValues() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ReadValues

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Methods -> ReadValues

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Reads the current values.

Datatype

ReadValues() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Save

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Methods -> Save

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Saves the current values as the new recipe values.

Datatype

Save() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


ExportXML

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Methods -> ExportXML

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export settings to an xml file

Datatype

ExportXML(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to export.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


ImportXML

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Methods -> ImportXML

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import settings from an xml file. New settings are added, existing settings will be merged.

Datatype

ImportXML(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to import.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Recipe-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Formulation

Other topics in this chapter

Formulation


Formulation

Manual -> Programming interfaces -> Objectmodel -> Recipe -> Recipe-Dynamic properties -> Formulation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | RecipeName | Name | Distinct name of the recipe. Default: Recipe_x ( x means a successive number). More in the online help.
VT_UI2 | PasswordLevel | Authorization level | Authorization groups required to change the recipe in Runtime. A user can only change recipe values (read, manual changing, deleting), if they fulfill the password level. Minimum: 0. Maximum: 127. Default: 0. More in the online help.
VT_BOOL | SyncWrite | Timeout [ms] | If synchronous writing has been activated, a timeout can be entered here. If 0 is entered here, the control system calculates the waiting time as follows: 3000+(100*number of data points) Minimum: 0. Maximum: 4294967295. Default: 0. More in the online help.
VT_UI4 | SyncWriteTimeout | Timeout [ms] | If synchronous writing has been activated, a timeout can be entered here. If 0 is entered here, the control system calculates the waiting time as follows: 3000+(100*number of data points) Minimum: 0. Maximum: 4294967295. Default: 0. More in the online help.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Recipes

Manual -> Programming interfaces -> Objectmodel -> Recipes

Remarks

This object manages "Recipe" objects.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public Sub zenOn_Recipes()
'Declarations
Dim zWork As Project
Dim zRecipes As Recipes
Dim zRecipe As recipe
Dim zRecipeValue As RecipeValue
Dim zVariable As Variable

'Initialization of zWork with current project
Set zWork = thisProject
'Initialization of zRecipes with the recipe list of the project
Set zRecipes = zWork.Recipes
'Initialization of zRecipe with the new "Recipe" object
Set zRecipe = zRecipes.Create("zenOn_Recipe")
'Initialization of zVariable with the first element in the "Variables" object
Set zVariable = zWork.Variables.Item(0)
'Initialization of zRecipeValue with the new assigned variable. Default-Value = 5
Set zRecipeValue = zRecipe.Create(zVariable.PvID, 5)

'Deletes the recipe "zenOn_Recipe"
zRecipes.Delete (zRecipe.Name)

End Sub

Other topics in this chapter

Recipes-Properties

Recipes-Methods


Recipes-Properties

Manual -> Programming interfaces -> Objectmodel -> Recipes -> Recipes-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | read only | read only
IProject | Parent |  | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> Recipes -> Recipes-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> Recipes -> Recipes-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Recipes-Methods

Manual -> Programming interfaces -> Objectmodel -> Recipes -> Recipes-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IRecipe | Create | Creates and returns a new Object | available | available
VARIANT_BOOL | Delete | Deletes the objects from collection | available | available
VARIANT_BOOL | ExportXML | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | Import | Imports the selected XML file | not used | available
VARIANT_BOOL | ImportXML | Imports the selected XML file | available | not used
IRecipe | Item | Returns a object at a position or by a specified key | available | available
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | available
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | available
VARIANT_BOOL | Get | Get the latest version from the server (editor). | available | not used
VARIANT_BOOL | CheckOut | Allow module modifications (editor). | available | not used
VARIANT_BOOL | CheckIn | Save module modifications to server (editor). | available | not used
VARIANT_BOOL | UndoCheckOut | Undo module modifications (editor). | available | not used
VARIANT_BOOL | IsLocked | Returns true when the current module is Locked by another user (editor). | read only | not used
VARIANT_BOOL | IsCheckedOut | Returns true when the current module checked out by the current user (editor). | read only | not used
VARIANT_BOOL | IsDifferent | Return true when the local- and server version are different (editor). | read only | not used

Other topics in this chapter

Item

Create

Delete

Import

ExportXML

SingleExport

ImportXML

Get

CheckOut

CheckIn

UndoCheckOut

IsLocked

IsCheckedOut

IsDifferent


Item

Manual -> Programming interfaces -> Objectmodel -> Recipes -> Recipes-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a "Recipe" object at a position or by a specified key.

Datatype

Item(VARIANT vID) As Recipe

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Create

Manual -> Programming interfaces -> Objectmodel -> Recipes -> Recipes-Methods -> Create

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new "Recipe" object by name as string parameter.

Datatype

Create(String strName) As Recipe

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

Name of the new "Recipe" object as string.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

strName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub CreateNewRecipe()
'Declarations
Dim zRecipes As Recipes
Dim zRecipe As recipe

'Initialization of zRecipes with the recipes list of the current project
Set zRecipes = thisProject.Recipes
'Initialization of zRecipe with the new "Recipe" object
Set zRecipe = zRecipes.Create("zenOn_Recipe")

End Sub


Delete

Manual -> Programming interfaces -> Objectmodel -> Recipes -> Recipes-Methods -> Delete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deletes a "Recipe" object from the collection.

Datatype

Delete(String strName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

Name of the former created "Recipe" object as string.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

strName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub DeleteRecipe()
'Declarations
Dim zRecipes As Recipes

'Initialization of zRecipes with the recipes list of the current project
Set zRecipes = thisProject.Recipes

'Deletes the recipe with the name "zenOn_Recipe"
zRecipes.Delete ("zenOn_Recipe")
End Sub


Import

Manual -> Programming interfaces -> Objectmodel -> Recipes -> Recipes-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Imports a recipe from a textfile.

Datatype

Import(String strFileName) As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ExportXML

Manual -> Programming interfaces -> Objectmodel -> Recipes -> Recipes-Methods -> ExportXML

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export settings to an xml file.

Datatype

ExportXML(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to export.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


SingleExport

Manual -> Programming interfaces -> Objectmodel -> Recipes -> Recipes-Methods -> SingleExport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SingleExport(VARIANT vIndexOrName,BSTR bsFileName) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


ImportXML

Manual -> Programming interfaces -> Objectmodel -> Recipes -> Recipes-Methods -> ImportXML

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import settings from an xml file. New settings are added, existing settings will be merged.

Datatype

ImportXML(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to import.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Get

Manual -> Programming interfaces -> Objectmodel -> Recipes -> Recipes-Methods -> Get

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Get() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


CheckOut

Manual -> Programming interfaces -> Objectmodel -> Recipes -> Recipes-Methods -> CheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CheckOut() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


CheckIn

Manual -> Programming interfaces -> Objectmodel -> Recipes -> Recipes-Methods -> CheckIn

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CheckIn() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


UndoCheckOut

Manual -> Programming interfaces -> Objectmodel -> Recipes -> Recipes-Methods -> UndoCheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

UndoCheckOut() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


IsLocked

Manual -> Programming interfaces -> Objectmodel -> Recipes -> Recipes-Methods -> IsLocked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

IsLocked() As VARIANT_BOOL

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


IsCheckedOut

Manual -> Programming interfaces -> Objectmodel -> Recipes -> Recipes-Methods -> IsCheckedOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

IsCheckedOut() As VARIANT_BOOL

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


IsDifferent

Manual -> Programming interfaces -> Objectmodel -> Recipes -> Recipes-Methods -> IsDifferent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

IsDifferent() As VARIANT_BOOL

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


RecipeValue

Manual -> Programming interfaces -> Objectmodel -> RecipeValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The "RecipeValue" object is utilized by the "Recipe" object, in order to define the characteristics.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_RecipeValue(ByRef zRecipe As recipe)
'Declarations
Dim zRecipeValue As RecipeValue
Dim zVariable As Variable

'Initialization of zVariable with the first element in the "Variables" object
Set zVariable = thisProject.Variables.Item(0)

'Initialization of zRecipeValue by creating a new "RecipeValue" object
'Assigns zVariable with a default value of 50
Set zRecipeValue = zRecipe.Create(zVariable.PvID, 50)

'Delete the former created "RecipeValue" object
zRecipe.Delete (zVariable.PvID)
End Sub

Other topics in this chapter

RecipeValue-Properties

RecipeValue-Methods

RecipeValue-Dynamic properties


RecipeValue-Properties

Manual -> Programming interfaces -> Objectmodel -> RecipeValue -> RecipeValue-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
IRecipe | Parent |  | read only | read only | yes | yes
long | Type |  | read only | read only | yes | yes
double | Value |  | available | available | yes | yes

Other topics in this chapter

Parent

Type

Value


Parent

Manual -> Programming interfaces -> Objectmodel -> RecipeValue -> RecipeValue-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Recipe

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Type

Manual -> Programming interfaces -> Objectmodel -> RecipeValue -> RecipeValue-Properties -> Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the type of the "RecipeValue" object.

Datatype

Type() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Value

Manual -> Programming interfaces -> Objectmodel -> RecipeValue -> RecipeValue-Properties -> Value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the value of the "RecipeValue" object.

Datatype

Value() As double

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


RecipeValue-Methods

Manual -> Programming interfaces -> Objectmodel -> RecipeValue -> RecipeValue-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IVariable | ItemVariable | - | available | available
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

ItemVariable

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


ItemVariable

Manual -> Programming interfaces -> Objectmodel -> RecipeValue -> RecipeValue-Methods -> ItemVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets, sets or modifies the assigend "Variable" object. For further information, please have a look at the "Variable" object part.

Datatype

ItemVariable() As Variable

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> RecipeValue -> RecipeValue-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> RecipeValue -> RecipeValue-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> RecipeValue -> RecipeValue-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> RecipeValue -> RecipeValue-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


RecipeValue-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> RecipeValue -> RecipeValue-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Recipe set value

Other topics in this chapter

Recipe set value


Recipe set value

Manual -> Programming interfaces -> Objectmodel -> RecipeValue -> RecipeValue-Dynamic properties -> Recipe set value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | VarName | Variable | Variable
VT_BSTR | VarTagName | Identification | Identification
VT_BSTR | VarUnit | Measuring unit | Unit
VT_R8 | Minimum | Minimum | Minimum
VT_R8 | SetValue | Set value | Set value
VT_R8 | Maximum | Maximum | Maximum


Rema

Manual -> Programming interfaces -> Objectmodel -> Rema

Remarks

The Reaction Matrices are the most sophisticated way to deal with stati.Here single stati can be evaluated and cause alarms. Basically a status can be treated like a value. As with a value it is also possible with a status to cause certain actions.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public Sub zenOn_CreateAnalogRema()
'*************** Use this code in the editor ***************

'Declaration zRema
Dim zRema As Rema

'Initialize zRema by creating a new analog rema with the name "zenOn_AnalogRemaExample"
Set zRema = MyWorkspace.ActiveDocument.Remas.Create(tpAnalog, "zenOn_AnalogRemaExample")

'Create a new state...
zRema.CreateState

'... and intialize the state by handing the rema over to the initialization example for state objects
Call zenOn_SetStateForAnalogRema(zRema)

End Sub

Private Sub zenOn_SetStateForAnalogRema(ByRef zRema As Rema)

'Declaration zState
Dim zState As State

'Intialize zState with the first state inside the passed analog rema
Set zState = zRema.StateItem(1)

'Sets the comparision mode to "greater"
zState.CheckArt = 1

'This definition constitutes the threshold value, where the alarm will be triggered
zState.ReaAlarm = 11

'This definition means that the system will be set back to its normal configuration, when "ReaAlarm" goes below 10 (hysteresis)
zState.Hysterese = 1

'User message that will be displayed when the event occurs
zState.Text = "Limit is reached!"

'Moreover, the first defined function will be called when the event occurs
zState.Function = MyWorkspace.ActiveDocument.RtFunctions.Item(0).ID
'The function will only be executed when the tpBitFkt is set. Additionaly the tpBitAlarm flag is set too.
zState.Status = tpBitFkt Or tpBitAlarm

End Sub

Other topics in this chapter

Rema-Properties

Rema-Methods


Rema-Properties

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
VARIANT_BOOL | IsAlarm |  | read only | read only | yes | yes
VARIANT_BOOL | IsBTB |  | read only | read only | yes | yes
VARIANT_BOOL | IsFunction |  | read only | read only | yes | yes
VARIANT_BOOL | IsFunctionClient |  | read only | read only | yes | yes
VARIANT_BOOL | IsFunctionServer |  | read only | read only | yes | yes
VARIANT_BOOL | IsStateBlinking |  | read only | read only | yes | yes
BSTR | Name |  | available | read only | yes | yes
IRemas | Parent |  | read only | read only | yes | yes
long | StateCount |  | read only | read only | yes | yes
tpStateBit | Status |  | read only | read only | yes | yes
tpRema | Type |  | read only | read only | yes | yes

Other topics in this chapter

Parent

Name

Type

Status

IsAlarm

IsBTB

IsFunction

IsFunctionServer

IsFunctionClient

IsStateBlinking

StateCount


Parent

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Remas

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the name of the Reaction Matrix.

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Type

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Properties -> Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Type() As tpRema

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Status

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Properties -> Status

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Status() As tpStateBit

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


IsAlarm

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Properties -> IsAlarm

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

At least one status of the reaction matrix is defined as an alarm.

Datatype

IsAlarm() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


IsBTB

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Properties -> IsBTB

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

At least one status of the reaction matrix is also logged in the Chronologic Event List (CEL).

Datatype

IsBTB() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


IsFunction

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Properties -> IsFunction

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

At least one status of the reaction matrix is linked to a function.

Datatype

IsFunction() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


IsFunctionServer

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Properties -> IsFunctionServer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

At least one status of the reaction matrix is linked to a function that runs on the server.

Datatype

IsFunctionServer() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


IsFunctionClient

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Properties -> IsFunctionClient

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

At least one status of the reaction matrix is linked to a function that runs on the client.

Datatype

IsFunctionClient() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


IsStateBlinking

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Properties -> IsStateBlinking

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

At least for one status of the reaction matrix the property "flashing" is activated.

Datatype

IsStateBlinking() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


StateCount

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Properties -> StateCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the amount of states within the Reaction Matrix.

Datatype

StateCount() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Rema-Methods

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CreateDynProperty | - | available | not used
IState | CreateState | - | available | not used
void | DeleteState | - | available | not used
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
long | GetColor | - | available | read only
long | GetDelayZeit | For internal use only | available | available
tpStateBit | GetStatus | - | available | available
BSTR | GetText | - | available | available
VARIANT_BOOL | StateIsAlarm | - | read only | read only
VARIANT_BOOL | StateIsBTB | - | read only | read only
VARIANT_BOOL | StateIsFunction | - | read only | read only
VARIANT_BOOL | StateIsFunctionClient | - | read only | read only
VARIANT_BOOL | StateIsFunctionServer | - | read only | read only
VARIANT_BOOL | StateIsStateBlinking | - | read only | read only
IState | StateItem | - | available | read only
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

CreateDynProperty

GetColor

GetStatus

GetDelayZeit

GetText

StateIsAlarm

StateIsBTB

StateIsFunction

StateIsFunctionServer

StateIsFunctionClient

StateIsStateBlinking

CreateState

DeleteState

StateItem


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


CreateDynProperty

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods -> CreateDynProperty

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This Method is able to create SubItems of the actual object, the Parameter has to be the Name of the SubItem to be created.

Datatype

CreateDynProperty(String bsPath) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Name of Subitem as String

Example: "State"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub Base()
Dim zProject As Project
Dim zRema As Rema
Dim bResult As Boolean

'get Project and Rema object
Set zProject = MyWorkspace.ActiveDocument
Set zRema = zProject.Remas.Item("MyRema")

'create SubItem States....
bResult = CreateSubItem(zRema, "State")

If bResult Then
MsgBox "SubItem 'State' was created successfully!"
Else
MsgBox "SubItem 'State' already exists or could not be created!"
End If

End Sub

Function CreateSubItem(zenOnObject As Object, strDynProperty As String) As Boolean
Dim nCount As Integer
'get count of given DynProperty
nCount = zenOnObject.DynProperties(strDynProperty & "[-1]")
If nCount = 0 Then '0 = DynProperty-SubItem not found
'create SubItem with given parameters...
CreateSubItem = zenOnObject.CreateDynProperty(strDynProperty)
Exit Function
End If
CreateSubItem = False
End Function


GetColor

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods -> GetColor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the Color of the corresponding state object.

Datatype

GetColor(long iIndex) As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


GetStatus

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods -> GetStatus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the "Status" flags from the corresponding state object. For further information have a look at the "Status" description in the "State" object part.

Datatype

GetStatus(long iIndex) As tpStateBit

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


GetDelayZeit

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods -> GetDelayZeit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

HIDDEN

Datatype

GetDelayZeit(long iIndex) As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


GetText

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods -> GetText

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the set text that will be displayed, if the defined limit is reached.

Datatype

GetText(long iIndex) As String

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


StateIsAlarm

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods -> StateIsAlarm

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns TRUE, if inside the "Status" DWORD of the corresponding "State" object the "tpBitAlarm" is set TRUE.

Datatype

StateIsAlarm(long iIndex) As Boolean

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


StateIsBTB

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods -> StateIsBTB

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns TRUE, if inside the "Status" DWORD of the corresponding "State" object the "tpBitBtb" is set TRUE.

Datatype

StateIsBTB(long iIndex) As Boolean

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


StateIsFunction

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods -> StateIsFunction

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns TRUE, if inside the "Status" DWORD of the corresponding "State" object the "tpBitFkt" is set TRUE.

Datatype

StateIsFunction(long iIndex) As Boolean

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


StateIsFunctionServer

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods -> StateIsFunctionServer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns TRUE, if inside the "Status" DWORD of the corresponding "State" object the "tpBitFktServer" is set TRUE.

Datatype

StateIsFunctionServer(long iIndex) As Boolean

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


StateIsFunctionClient

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods -> StateIsFunctionClient

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns TRUE, if inside the "Status" DWORD of the corresponding "State" object the "tpBitFktClient" is set TRUE.

Datatype

StateIsFunctionClient(long iIndex) As Boolean

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


StateIsStateBlinking

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods -> StateIsStateBlinking

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns TRUE, if inside the "Status" DWORD of the corresponding "State" object the "tpBitBlink" is set TRUE.

Datatype

StateIsStateBlinking(long iIndex) As Boolean

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateState

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods -> CreateState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new state within the Reaction matrix.

Datatype

CreateState() As State

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteState

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods -> DeleteState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deletes an existing state within the Reaction Matrix.

Datatype

DeleteState(VARIANT vPos) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


StateItem

Manual -> Programming interfaces -> Objectmodel -> Rema -> Rema-Methods -> StateItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a "State" object with the selected state from the Reaction Matrix.

Datatype

StateItem(VARIANT vPos) As State

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Remas

Manual -> Programming interfaces -> Objectmodel -> Remas

Remarks

This object manages "Rema" objects.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public Sub zenOn_RemasExample()

'Declarations
Dim zRemas As Remas
Dim zBinRema As Rema
Dim zAnaRema As Rema
Dim i As Integer

'Initialization of zRemas
Set zRemas = MyWorkspace.ActiveDocument.Remas
'Intialization of zBinRema by creating a new binary rema
Set zBinRema = zRemas.Create(tpBinaer, "zenOn_BinaryRema")
'Intialization of zAnaRema by creating a new analog rema
Set zAnaRema = zRemas.Create(tpAnalog, "zenOn_AnalogRema")

'Output some details on the remas
For i = 0 To zRemas.Count - 1
'Display name
Debug.Print "Name: " & zRemas.Item(i).Name
'Show type of Reaction Matrix
Select Case zRemas.Item(i).Type
Case Is = 1
Debug.Print "Type: Binary"
Case Is = 2
Debug.Print "Type: Analog"
Case Is = 3
Debug.Print "Type: MultiBinary"
Case Is = 4
Debug.Print "Type: MultiAnalog"
Case Is = 5
Debug.Print "Type: String"
End Select
Next i

'Delete the binary rema by its position
Debug.Print zRemas.Delete(1)
'Delete the analog rema by its name
Debug.Print zRemas.Delete("zenOn_AnalogRema")

End Sub

Other topics in this chapter

Remas-Properties

Remas-Methods


Remas-Properties

Manual -> Programming interfaces -> Objectmodel -> Remas -> Remas-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Count of remas | read only | read only
IProject | Parent | Parent-object | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> Remas -> Remas-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> Remas -> Remas-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Remas-Methods

Manual -> Programming interfaces -> Objectmodel -> Remas -> Remas-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CheckIn | Save module modifications to server (editor). | available | not used
VARIANT_BOOL | CheckOut | Allow module modifications (editor). | available | not used
IRema | Create | Creates a new rema (unique name) | available | not used
VARIANT_BOOL | Delete | Delete the given rema | available | not used
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | Get | Get the latest version from the server (editor). | available | not used
VARIANT_BOOL | Import | Imports the selected XML file | available | not used
VARIANT_BOOL | IsCheckedOut | Returns true when the current module checked out by the current user (editor). | read only | not used
VARIANT_BOOL | IsDifferent | Return true when the local- and server version are different (editor). | read only | not used
VARIANT_BOOL | IsLocked | Returns true when the current module is Locked by another user (editor). | read only | not used
IRema | Item | Returns the rema on the given position or name | available | available
IRema | ItemById | Returns the rema with the given id | available | available
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used
VARIANT_BOOL | UndoCheckOut | Undo module modifications (editor). | available | not used
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used

Other topics in this chapter

Item

ItemById

Create

Delete

SingleExport

Export

Import

Get

CheckOut

CheckIn

UndoCheckOut

IsLocked

IsCheckedOut

IsDifferent


Item

Manual -> Programming interfaces -> Objectmodel -> Remas -> Remas-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a "Rema" object with the Reaction Matrix at the given position.

Datatype

Item(VARIANT vNamePos) As Rema

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ItemById

Manual -> Programming interfaces -> Objectmodel -> Remas -> Remas-Methods -> ItemById

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a "Rema" object with the Reaction Matrix with the given ID.

Datatype

ItemById(VARIANT vID) As Rema

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Create

Manual -> Programming interfaces -> Objectmodel -> Remas -> Remas-Methods -> Create

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Create(tpRema rID, String strName) As Rema

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Delete

Manual -> Programming interfaces -> Objectmodel -> Remas -> Remas-Methods -> Delete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deletes an existing Reaction Matrix by its position or by name.

Datatype

Delete(VARIANT vID) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SingleExport

Manual -> Programming interfaces -> Objectmodel -> Remas -> Remas-Methods -> SingleExport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SingleExport(VARIANT vIndexOrName,BSTR bsFileName) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Export

Manual -> Programming interfaces -> Objectmodel -> Remas -> Remas-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export settings to an xml file

Datatype

Export(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to export.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Import

Manual -> Programming interfaces -> Objectmodel -> Remas -> Remas-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import settings from an xml file. New settings are added, existing settings will not be replaced.

Datatype

Import(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to import.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Get

Manual -> Programming interfaces -> Objectmodel -> Remas -> Remas-Methods -> Get

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype

Get() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckOut

Manual -> Programming interfaces -> Objectmodel -> Remas -> Remas-Methods -> CheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype

CheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckIn

Manual -> Programming interfaces -> Objectmodel -> Remas -> Remas-Methods -> CheckIn

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype

CheckIn() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


UndoCheckOut

Manual -> Programming interfaces -> Objectmodel -> Remas -> Remas-Methods -> UndoCheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype

UndoCheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsLocked

Manual -> Programming interfaces -> Objectmodel -> Remas -> Remas-Methods -> IsLocked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype

IsLocked() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsCheckedOut

Manual -> Programming interfaces -> Objectmodel -> Remas -> Remas-Methods -> IsCheckedOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype

IsCheckedOut() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsDifferent

Manual -> Programming interfaces -> Objectmodel -> Remas -> Remas-Methods -> IsDifferent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype

IsDifferent() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RemoteTransport

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Private Sub CreateCustomOption()
Dim obRemoteTP As RemoteTransport

Set obRemoteTP = MyWorkspace.ActiveDocument.RemoteTransport
'define basic remote transport settings
obRemoteTP.HidePasswordDialog = True
obRemoteTP.TransportType = tpTCP
obRemoteTP.TcpByIp = False
obRemoteTP.TcpIpName = "COMPUTERNAME"
'create custom options for the remote transport
obRemoteTP.CreateCustom
obRemoteTP.CustomItem(0).Comment = "TEST: Copy - Execute"
obRemoteTP.CustomItem(0).ActionType = tpCopyExecute
obRemoteTP.CustomItem(0).Active = True
obRemoteTP.CustomItem(0).SourcePath = "source"
obRemoteTP.CustomItem(0).TargetPath = "target"
obRemoteTP.CreateCustom
obRemoteTP.CustomItem(1).Comment = "TEST: Copy"
obRemoteTP.CustomItem(1).ActionType = tpCopy
obRemoteTP.CustomItem(1).Active = False
obRemoteTP.CustomItem(1).SourcePath = "source1"
obRemoteTP.CustomItem(1).TargetPath = "target1"
obRemoteTP.CreateCustom
obRemoteTP.CustomItem(2).Comment = "TEST: Copy - Register"
obRemoteTP.CustomItem(2).ActionType = tpCopyRegister
obRemoteTP.CustomItem(2).Active = True
obRemoteTP.CustomItem(2).SourcePath = "source2"
obRemoteTP.CustomItem(2).TargetPath = "target2"
'save the changes...
obRemoteTP.Save
End Sub

Other topics in this chapter

RemoteTransport-Properties

RemoteTransport-Methods


RemoteTransport-Properties

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | CustomCount | Returns the amount of custom entries. | available | not used
BSTR | CEFolder | Get/Set the CE folder. | available | not used
VARIANT_BOOL | HidePasswordDialog | Get/Set whether the password dialog is shown. | available | not used
VARIANT_BOOL | IncludeAdditional | Get/Set whether the Additional folder is to be transported. | available | not used
VARIANT_BOOL | IncludeDrivers | Get/Set whether the Drivers folder is to be transported. | available | not used
VARIANT_BOOL | IncludeGraphics | Get/Set whether the Graphic folder is to be transported. | available | not used
VARIANT_BOOL | IncludeHelp | Get/Set whether the Help folder is to be transported. | available | not used
VARIANT_BOOL | IncludeLists | Get/Set whether the Lists folder is to be transported. | available | not used
VARIANT_BOOL | IncludeMedia | Get/Set whether the Media folder is to be transported. | available | not used
VARIANT_BOOL | IncludeReports | Get/Set whether the Reports folder is to be transported. | available | not used
VARIANT_BOOL | IncludeStraton | Get/Set whether the Straton folder is to be transported. | available | not used
BSTR | Password | Get/Set the connection password. | available | not used
BSTR | ProjectBase | Get/Set the project base. | available | not used
BSTR | SerialName | Get/Set the Serial connection address. | available | not used
BSTR | TcpIpName | Get/Set the TCP Name. | available | not used
tpRemoteTransportType | TransportType | Get/Set the connection type. | available | not used
VARIANT_BOOL | UseCEFolderSetting | Get/Set whether the CE folder setting is to be used. | available | not used

Other topics in this chapter

ProjectBase

UseCEFolderSetting

CEFolder

IncludeGraphics

IncludeLists

IncludeMedia

IncludeReports

IncludeHelp

IncludeAdditional

IncludeDrivers

IncludeStraton

TcpIpName

SerialName

TransportType

CustomCount

Password

HidePasswordDialog


ProjectBase

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Properties -> ProjectBase

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ProjectBase() As BSTR

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


UseCEFolderSetting

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Properties -> UseCEFolderSetting

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

UseCEFolderSetting() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


CEFolder

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Properties -> CEFolder

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CEFolder() As BSTR

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


IncludeGraphics

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Properties -> IncludeGraphics

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

IncludeGraphics() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


IncludeLists

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Properties -> IncludeLists

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

IncludeLists() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


IncludeMedia

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Properties -> IncludeMedia

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

IncludeMedia() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


IncludeReports

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Properties -> IncludeReports

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

IncludeReports() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


IncludeHelp

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Properties -> IncludeHelp

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

IncludeHelp() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


IncludeAdditional

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Properties -> IncludeAdditional

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

IncludeAdditional() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


IncludeDrivers

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Properties -> IncludeDrivers

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

IncludeDrivers() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


IncludeStraton

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Properties -> IncludeStraton

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

IncludeStraton() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


TcpIpName

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Properties -> TcpIpName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

TcpIpName() As BSTR

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


SerialName

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Properties -> SerialName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SerialName() As BSTR

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


TransportType

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Properties -> TransportType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

TransportType() As tpRemoteTransportType

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


CustomCount

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Properties -> CustomCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CustomCount() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Password

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Properties -> Password

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Password() As BSTR

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


HidePasswordDialog

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Properties -> HidePasswordDialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

HidePasswordDialog() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


RemoteTransport-Methods

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | Connect | Start a remote transport connection. | available | not used
IRemoteTransportCustom | CreateCustom | Adds a new custom entry. | available | not used
IRemoteTransportCustom | CustomItem | Returns the custom entry at the given index. | available | not used
BOOL | DeleteCustom | Deletes the custom entry at the given index. | available | not used
void | Disconnect | Stop the current remote transport connection. | available | not used
void | RebootOS | Reboots the remote OS. | available | not used
void | ReloadRT | Reload the remote runtime. | available | not used
void | Retrieve | Retrieve all. | available | not used
BOOL | Save | Saves current remote transport setting. | available | not used
void | SetStartProject | Set start project. | available | not used
void | StartRT | Start the remote runtime. | available | not used
void | StopRT | Stop the remote runtime. | available | not used
void | TransferAll | Transfer all. | available | not used
void | TransferChanged | Transfer changes. | available | not used

Other topics in this chapter

CustomItem

CreateCustom

DeleteCustom

Save

Connect

Disconnect

TransferAll

TransferChanged

Retrieve

SetStartProject

StartRT

StopRT

ReloadRT

RebootOS


CustomItem

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Methods -> CustomItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CustomItem(long lIndex) As RemoteTransportCustom

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateCustom

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Methods -> CreateCustom

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreateCustom() As RemoteTransportCustom

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteCustom

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Methods -> DeleteCustom

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DeleteCustom(long lIndex) As BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Save

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Methods -> Save

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Save() As BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Connect

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Methods -> Connect

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Connect() As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Disconnect

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Methods -> Disconnect

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Disconnect() As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


TransferAll

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Methods -> TransferAll

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

TransferAll() As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


TransferChanged

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Methods -> TransferChanged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

TransferChanged() As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Retrieve

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Methods -> Retrieve

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Retrieve() As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SetStartProject

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Methods -> SetStartProject

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SetStartProject() As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


StartRT

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Methods -> StartRT

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

StartRT() As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


StopRT

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Methods -> StopRT

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

StopRT() As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ReloadRT

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Methods -> ReloadRT

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ReloadRT() As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RebootOS

Manual -> Programming interfaces -> Objectmodel -> RemoteTransport -> RemoteTransport-Methods -> RebootOS

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

RebootOS() As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RemoteTransportCustom

Manual -> Programming interfaces -> Objectmodel -> RemoteTransportCustom

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Private Sub CreateCustomOption()
Dim obRemoteTP As RemoteTransport

Set obRemoteTP = MyWorkspace.ActiveDocument.RemoteTransport
'define basic remote transport settings
obRemoteTP.HidePasswordDialog = True
obRemoteTP.TransportType = tpTCP
obRemoteTP.TcpByIp = False
obRemoteTP.TcpIpName = "COMPUTERNAME"
'create custom options for the remote transport
obRemoteTP.CreateCustom
obRemoteTP.CustomItem(0).Comment = "TEST: Copy - Execute"
obRemoteTP.CustomItem(0).ActionType = tpCopyExecute
obRemoteTP.CustomItem(0).Active = True
obRemoteTP.CustomItem(0).SourcePath = "source"
obRemoteTP.CustomItem(0).TargetPath = "target"
obRemoteTP.CreateCustom
obRemoteTP.CustomItem(1).Comment = "TEST: Copy"
obRemoteTP.CustomItem(1).ActionType = tpCopy
obRemoteTP.CustomItem(1).Active = False
obRemoteTP.CustomItem(1).SourcePath = "source1"
obRemoteTP.CustomItem(1).TargetPath = "target1"
obRemoteTP.CreateCustom
obRemoteTP.CustomItem(2).Comment = "TEST: Copy - Register"
obRemoteTP.CustomItem(2).ActionType = tpCopyRegister
obRemoteTP.CustomItem(2).Active = True
obRemoteTP.CustomItem(2).SourcePath = "source2"
obRemoteTP.CustomItem(2).TargetPath = "target2"
'save the changes...
obRemoteTP.Save
End Sub

Other topics in this chapter

RemoteTransportCustom-Properties


RemoteTransportCustom-Properties

Manual -> Programming interfaces -> Objectmodel -> RemoteTransportCustom -> RemoteTransportCustom-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
tpRTCustomAction | ActionType | Get/Set the action type. | available | not used
VARIANT_BOOL | Active | Activate/deactivate the custom entry. | available | not used
BSTR | Comment | Get/Set the comment of the custom entry. | available | not used
BSTR | SourcePath | Get/Set the source path. | available | not used
BSTR | TargetPath | Get/Set the target path. | available | not used

Other topics in this chapter

SourcePath

TargetPath

Active

ActionType

Comment


SourcePath

Manual -> Programming interfaces -> Objectmodel -> RemoteTransportCustom -> RemoteTransportCustom-Properties -> SourcePath

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SourcePath() As String

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


TargetPath

Manual -> Programming interfaces -> Objectmodel -> RemoteTransportCustom -> RemoteTransportCustom-Properties -> TargetPath

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

TargetPath() As String

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Active

Manual -> Programming interfaces -> Objectmodel -> RemoteTransportCustom -> RemoteTransportCustom-Properties -> Active

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Active() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


ActionType

Manual -> Programming interfaces -> Objectmodel -> RemoteTransportCustom -> RemoteTransportCustom-Properties -> ActionType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ActionType() As tpRTCustomAction

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


Comment

Manual -> Programming interfaces -> Objectmodel -> RemoteTransportCustom -> RemoteTransportCustom-Properties -> Comment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Comment() As String

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


RGMRecipe

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe

Remarks

Recipes serve for the assembling of input lists for setpoint values and commands which in online operation are executed with a function call.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public Sub zenOn_RGMRecipe()
'Declarations
Dim zRGM_Recipe As RGMRecipe

'Initialization of zRGM_Recipe with the first recipe within the first recipe group
Set zRGM_Recipe = MyWorkspace.ActiveDocument.RGMGroups.Item(0).RecipeItem(0)

'Modify a Recipe:
Call Modify_RGMRecipe(zRGM_Recipe)

'Write Values from Recipe to variables
Call Write_RGMRecipe(zRGM_Recipe)

'Read from Variables and save as raceipe
Call Read_RGMRecipe(zRGM_Recipe)
End Sub

Sub Modify_RGMRecipe(zRGM_Recipe As RGMRecipe)
'Declarations
Dim i As Integer

For i = 0 To zRGM_Recipe.ValueCount - 1
'Set action type to "Modify spontaneous value"
zRGM_Recipe.ValueItem(i).DynProperties("Type") = 2
'Set value...
zRGM_Recipe.ValueItem(i).DynProperties("Value") = (i + 1) * 25
Next i
'Save the current value to the recipe
zRGM_Recipe.Save
End Sub

Sub Read_RGMRecipe(zRGM_Recipe As RGMRecipe)
'Read the current variable value and output the result
zRGM_Recipe.Read
'Save the current value to the recipe
zRGM_Recipe.Save
End Sub

Sub Write_RGMRecipe(zRGM_Recipe As RGMRecipe)
'Read the current variable value and output the result
zRGM_Recipe.Execute
'Save the current value to the recipe
zRGM_Recipe.Save
End Sub

Other topics in this chapter

RGMRecipe-Properties

RGMRecipe-Methods

RGMRecipe-Dynamic properties


RGMRecipe-Properties

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Number | The identification number of the recipe | available | available
IRGMRecipeGroup | Parent | Parent of object | read only | read only
long | Status | The numeric status value of the recipe | available | available
long | ValueCount |  | read only | read only
long | Version | The version of the recipe | available | available
BSTR | Name | The name of the recipe | available | available

Other topics in this chapter

Parent

ValueCount

Name

Number

Status

Version


Parent

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As RGMRecipeGroup

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ValueCount

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Properties -> ValueCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the amount of "RGMRecipeValue" objects within the "RGMRecipe" object, i.e. the amount of variables assigned to the recipe.

Datatype

ValueCount() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Name() As BSTR

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Number

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Properties -> Number

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Number() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Status

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Properties -> Status

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Status() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Version

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Properties -> Version

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Version() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


RGMRecipe-Methods

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Check | Get differences between recipe and actual values | not used | available
VARIANT_BOOL | Duplicate | Duplicate this recipe | available | available
VARIANT_BOOL | DuplicateAsVersion | Duplicate this recipe into a new version | available | available
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
VARIANT_BOOL | Execute | - | available | available
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | available
VARIANT_BOOL | ExportXML | Export the data of this recipe to a xml file for documentation purpose | not used | available
VARIANT_BOOL | Read | - | available | available
VARIANT_BOOL | Save | - | available | available
IRGMRecipeValue | ValueItem | - | available | available
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

ValueItem

Execute

Read

Save

Check

ExportXML

Duplicate

DuplicateAsVersion

Export

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


ValueItem

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Methods -> ValueItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ValueItem(VARIANT vPosOrName) As RGMRecipeValue

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Execute

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Methods -> Execute

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Overwrites the current values of the variables in the recipe with the recipe values.

Datatype

Execute() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Read

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Methods -> Read

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Reads the current values.

Datatype

Read() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Save

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Methods -> Save

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Saves the current values as the new recipe values.

Datatype

Save() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Check

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Methods -> Check

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Check(LPVARIANT pDifferences) As long

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ExportXML

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Methods -> ExportXML

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export the RGMRecipe to an XML File.

Datatype

ExportXML(String strExportPath) As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Duplicate

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Methods -> Duplicate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Method to create a duplicate of the actual RGMRecipe.The given string parameter represents the duplicates name.A boolean result will be returned.

Datatype

Duplicate(String bsDuplicate) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DuplicateAsVersion

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Methods -> DuplicateAsVersion

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DuplicateAsVersion() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Export

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Export(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


RGMRecipe-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Object recipe

Other topics in this chapter

Object recipe


Object recipe

Manual -> Programming interfaces -> Objectmodel -> RGMRecipe -> RGMRecipe-Dynamic properties -> Object recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BSTR

RecipeName

Recipe name

Name for recipe. The recipe name must be unique. If you selected binary files for property DataSource, the name must only contain alphanumeric characters.

More in the online help.

VT_UI4

RecipeNumber

Recipe number

Number of the recipe

More in the online help.

VT_UI4

RecipeVersion

Recipe version

Displays the version number of the selected recipe. Display only, cannot be changed. The version number is automatically set by the system. A maximum of 89999 recipe versions can be created.

More in the online help.

VT_UI2

Status

State

Selection of the recipe status from the drop-down list. (Configuration of the status in property Recipegroup Manager /Identifier recipe state.) The recipe status can be set differently for each Recipe version. This property can also be changed in the Runtime.

More in the online help.

VT_R8

TimeChange

TimeChange

"this property returns the time the recipe was saved last. When editing the recipe via the automation interface, this property must be set manually by the user"

VT_BSTR

UserChange

User for last change

"This property returns the name of the user who has created / modified the recipe. When editing the recipe via the automation interface, this property must be set manually by the user "

VT_R8

TimeSent

TimeSent

for compatibility reasons only

VT_BSTR

UserSent

User for last writing

for compatibility reasons only

VT_BOOL

WriteSync

Write synchronously

Is set at recipe group for all recipes of this recipe group and can be overwritten at each recipe.

Active: When writing a recipe, all control elements are locked in the Recipe Group Manager screen until the driver confirms that all values have been written successfully or the defined Timeout [ms] has expired.

Inactive: The values of the recipe are written without waiting for a confirmation. The control elements can be used again immediately. The confirmation of the driver is done with the status bit WR-SUC, which is set to 1, when values have been written successfully.

More in the online help.

VT_BOOL

WriteSync_IsLocal

WriteSync_IsLocal

VT_UI4

WriteTimeout

Timeout [ms]

Is set at recipe group for all recipes of this recipe group and can be overwritten at each recipe.

If you activated Write synchronously, you can enter a timeout here. The control elements of the Recipe Group Manager screen can be operated once again after this time at the latest. If, in Timeout, the value 0 is entered, zenon calculates the timeout in the following way: 30000+(100*number of datapoints)

More in the online help.

VT_BOOL

WriteTimeout_IsLocal

WriteTimeout_IsLocal

VT_UI2

PWLevel

Authorization level

Selection of authorization level from drop-down list.

More in the online help.

VT_BSTR

Comment1

Comment 1

Comment line 1 for the current recipe.

More in the online help.

VT_BSTR

Comment2

Comment 2

Comment line 2 for the current recipe.

More in the online help.

VT_BSTR

Comment3

Comment 3

Comment line 3 for the current recipe.

More in the online help.

VT_BSTR

Comment4

Comment 4

Comment line 4 for the current recipe.

More in the online help.

VT_BSTR

Comment5

Comment 5

Comment line 5 for the current recipe.

More in the online help.

VT_BSTR

Comment6

Comment 6

Comment line 6 for the current recipe.

More in the online help.

VT_BSTR

Comment7

Comment 7

Comment line 7 for the current recipe.

More in the online help.

VT_BSTR

Comment8

Comment 8

Comment line 8 for the current recipe.

More in the online help.


RGMRecipeGroup

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The "RGMRecipeGroup" object manages the "RGMRecipe" collection and the utilized "RGMRecipeVar" variables.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public Sub zenOn_RGMGroup()

'Declarations
Dim zRGM_Group As RGMRecipeGroup
Dim zVariable As Variable
Dim zRGMGroup_Name As String

'Initialization of zRGMGroup_Name with the name of the created group
'zRGMGroup_Name = "zenOn_RGMGroup"
zRGMGroup_Name = MyWorkspace.ActiveDocument.RGMGroups.CreateGroup("zenOn_RGMGroup").DynProperties("Name")
'Initialization of zRGM_Group with the former created group
Set zRGM_Group = MyWorkspace.ActiveDocument.RGMGroups.Item(zRGMGroup_Name)

'Initialization of zVariable with the first element in the "Variables" object of the current project
Set zVariable = MyWorkspace.ActiveDocument.Variables.Item(0)

'Add variable to the recipe group
zRGM_Group.AddVariable zVariable
'Create a new recipe in the recipe group
zRGM_Group.CreateRecipe ("zenOn_RGMRecipe")

'Output the number of variables and recipes in the group
Debug.Print "Number of variables: " & zRGM_Group.VariableCount
Debug.Print "Number of recipes: " & zRGM_Group.RecipeCount & vbNewLine

'Rename the recipe
zRGM_Group.RenameRecipe "zenOn_RGMRecipe", "zenOn_RGMRecipeRenamed"

'Delete the whole recipe group
zRGM_Group.Parent.DeleteGroup (zRGM_Group.DynProperties("Name"))

End Sub

Other topics in this chapter

RGMRecipeGroup-Properties

RGMRecipeGroup-Methods

RGMRecipeGroup-Dynamic properties


RGMRecipeGroup-Properties

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
BSTR | Name |  | available | available | yes | yes
IRGMRecipeGroups | Parent | Parent of object | read only | read only | yes | yes
long | VariableCount |  | available | available | yes | yes
long | RecipeCount |  | available | available | yes | yes

Other topics in this chapter

Parent

VariableCount

RecipeCount

Name


Parent

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As RGMRecipeGroups

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


VariableCount

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Properties -> VariableCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the amount of "RGMVar" objects within the collection, i.e. the amount of variables that are assigned.

Datatype

VariableCount() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


RecipeCount

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Properties -> RecipeCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

RecipeCount() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


RGMRecipeGroup-Methods

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | AddVariable | - | available | available
LPDISPATCH | CreateRecipe | - | available | available
LPDISPATCH | CreateRecipeVersion | Creates a new recipe version for the given recipe name | available | available
VARIANT_BOOL | DeleteRecipe | Delete a recipe object by name OR by nummeric index (for name all recipe versions are deleted) | available | available
VARIANT_BOOL | DeleteRecipeVersion | Delete a recipe object by name and version OR by nummeric index (for indexes the version is ignored) | available | available
VARIANT_BOOL | DeleteVariable | - | available | available
VARIANT_BOOL | Duplicate | Duplicate this recipe group | available | available
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | available
VARIANT_BOOL | Import | Imports the selected XML file | available | available
VARIANT | ListRecipesName | Passes an array with all recipes name of this group | available | available
VARIANT | ListRecipeVersions | Passes an array with all versions of a specified recipe | available | available
VARIANT | ListVariablesName | List all variable names from this group | available | available
IRGMRecipe | RecipeItem | Get a recipe object by name OR by nummeric index (for name the lowest version is returned) | available | available
IRGMRecipe | RecipeItemVersion | Get a recipe object by name and version OR by nummeric index (for indexes the version is ignored) | available | available
VARIANT_BOOL | RenameRecipe | - | available | available
VARIANT_BOOL | ReorderVariables | Reorders the variables in the group | available | available
VARIANT_BOOL | Save | Save the Recipegroup and all Recipegroup Variables | available | available
IRGMRecipeVar | VariableItem | - | available | available
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

RecipeItem

RecipeItemVersion

VariableItem

DeleteVariable

DeleteRecipe

DeleteRecipeVersion

AddVariable

CreateRecipe

CreateRecipeVersion

RenameRecipe

Save

Duplicate

ListRecipesName

ListRecipeVersions

ReorderVariables

ListVariablesName

Export

Import

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


RecipeItem

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> RecipeItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The function was extended by the parameter nversion.

For nVersion, the desired version number of the recipe is specified.

Hint: You can get a list with all possible recipe versions through the method RGMRecipeGroup.ListRecipeVersions.

Datatype

RecipeItem(VARIANT vPosOrName) As RGMRecipe

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RecipeItemVersion

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> RecipeItemVersion

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

RecipeItemVersion(VARIANT vPosOrName, long nVersion) As RGMRecipe

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


VariableItem

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> VariableItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a "RGMRecipeVar" object from the collection, selected by its name as string or position within the collection.

Datatype

VariableItem(VARIANT vPosOrName) As RGMRecipeVar

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteVariable

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> DeleteVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deletes an existing "RGMRecipeVar" object from the collection by its name as string or position.

Datatype

DeleteVariable(VARIANT vPosOrName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteRecipe

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> DeleteRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The function for deleting recipes was extended by the parameter nversion.

For nVersion, either the recipe version to be deleted is specified or 0 if the whole recipe with all its versions should be deleted.

Datatype

DeleteRecipe(VARIANT vPosOrName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteRecipeVersion

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> DeleteRecipeVersion

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DeleteRecipeVersion(VARIANT vPosOrName, long nVersion) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


AddVariable

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> AddVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Adds a "Variable" object to the collection.

Datatype

AddVariable(LPDISPATCH lpVariable) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

"Variable" object that should be passed.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

lpVariable As LPDISPATCH

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub AddRemoveVariable(ByRef zRGMGroup As RGMRecipeGroup)
'Declarations
Dim zVariable As Variable

'Initialization of zVariable with the first element of collection within the "Variables" object
Set zVariable = MyWorkspace.ActiveDocument.Variables.Item(0)

'Add the variable to the recipe group
zRGMGroup.AddVariable zVariable

'Remove the variable from the recipe group by its name
zRGMGroup.DeleteVariable (zVariable.Name)

End Sub


CreateRecipe

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> CreateRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new recipe by its name as a string.

Datatype

CreateRecipe(String bstrName) As LPDISPATCH

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateRecipeVersion

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> CreateRecipeVersion

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new version of a recipe.

bstrName The recipe name of a recipe fo which has to be created a new version.

Return value The new created recipe version as RGMRecipe.

Datatype

CreateRecipeVersion(String bstrName) As LPDISPATCH

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Public Sub Macro_Recipes()
Dim zRecipeGroups As RGMRecipeGroups
Dim zRecipeGroup As RGMRecipeGroup
Dim zRecipe As RGMRecipe

Set zRecipeGroups = thisProject.RGMGroups

If zRecipeGroups.count > 0 Then
Set zRecipeGroup = zRecipeGroups.Item(0)
Set zRecipe = zRecipeGroup.CreateRecipeVersion("Recipe_A")
If Not zRecipe Is Nothing Then
Debug.Print ("Created new recipe version")
Debug.Print ("Version: " & zRecipe.Version)
End If
End If
End Sub


RenameRecipe

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> RenameRecipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Renames a recipe by passing the old and new name as string.

Datatype

RenameRecipe(String bstrOldName,String bstrNewName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Save

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> Save

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Save() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Duplicate

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> Duplicate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Method to create a duplicate of the actual RGMRecipeGroup.The given string parameter represents the duplicates name.A boolean result will be returned.

Datatype

Duplicate(String bsDuplicate) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ListRecipesName

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> ListRecipesName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Generates an array with all recipe names of this group.

Return value An array with all recipe names as variant.

Datatype

ListRecipesName() As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Public Sub Macro_RecipesList()
Dim zRecipeGroups As RGMRecipeGroups
Dim zRecipeGroup As RGMRecipeGroup
Dim vRecipeList As Variant
Dim i As Integer

Set zRecipeGroups = MyWorkspace.ActiveDocument.RGMGroups

If zRecipeGroups.Count > 0 Then
Set zRecipeGroup = zRecipeGroups.Item(0)
vRecipeList = zRecipeGroup.ListRecipesName()
For i = 0 To UBound(vRecipeList)
Debug.Print (vRecipeList(i))
Next i
End If
End Sub


ListRecipeVersions

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> ListRecipeVersions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Generates an array with all recipe versions of a recipe of this group.

bsRecipeName The recipe name of the recipe for which the array has to be created.

Return value An array with all recipe version numbers as variant.

Datatype

ListRecipeVersions(String bsRecipeName) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Public Sub Macro_RecipesVersionList()
Dim zRecipeGroups As RGMRecipeGroups
Dim zRecipeGroup As RGMRecipeGroup
Dim vRecipeList As Variant
Dim i As Integer

Set zRecipeGroups = MyWorkspace.ActiveDocument.RGMGroups

If zRecipeGroups.Count > 0 Then
Set zRecipeGroup = zRecipeGroups.Item(0)
If Not zRecipeGroup.RecipeItem("Recipe_A") Is Nothing Then
Debug.Print ("Show Version of Recipe: " & zRecipeGroup.RecipeItem("Recipe_A").name)
' Get an array of the RecipeVersion
vRecipeList = zRecipeGroup.ListRecipeVersions("Recipe_A")

For i = 0 To UBound(vRecipeList)
Debug.Print ("Version: " & vRecipeList(i))
Next i
End If
Set zRecipeGroup = Nothing
End If
Set zRecipeGroups = Nothing
End Sub


ReorderVariables

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> ReorderVariables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ReorderVariables(VARIANT vNamesInNewOrder) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub Macro_SortVars()
Dim zRecipeGroup As RGMRecipeGroup
Dim sVars1() As String
Dim sVars2() As String
Dim i As Integer

Set zRecipeGroup = MyWorkspace.ActiveDocument.RGMGroups.Item(0)

'Get list of variable names
sVars1 = zRecipeGroup.ListVariablesName
Debug.Print ("Before reorder")
For i = 0 To UBound(sVars1)
Debug.Print (i & ": " & sVars1(i))
Next i
' Move first variable down
ReDim sVars2(UBound(sVars1, 1))
Dim length As Integer
length = UBound(sVars1)
For i = 0 To length
If (i < length) Then
sVars2(i) = sVars1((i + 1)) ' set variable to next index
Else
sVars2(i) = sVars1(0) ' set last variable to first position
End If
Next i
' set new order
Dim b As Boolean
b = zRecipeGroup.ReorderVariables(sVars2)
Debug.Print ("After reorder")
'Get list of variable names
sVars1 = zRecipeGroup.ListVariablesName
For i = 0 To UBound(sVars1)
Debug.Print (i & ": " & sVars1(i))
Next i
End Sub


ListVariablesName

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> ListVariablesName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ListVariablesName() As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Public Sub Macro_RecipesVariableList()
Dim zRecipeGroups As RGMRecipeGroups
Dim zRecipeGroup As RGMRecipeGroup
Dim vVariableList As Variant
Dim i As Integer

Set zRecipeGroups = MyWorkspace.ActiveDocument.RGMGroups

If zRecipeGroups.Count > 0 Then
Set zRecipeGroup = zRecipeGroups.Item(0)
If Not zRecipeGroup.RecipeItem("Recipe_A") Is Nothing Then
Debug.Print ("Show Version of Recipe: " & zRecipeGroup.RecipeItem("Recipe_A").name)
' Get an array with the variable names
vVariableList = zRecipeGroup.ListVariablesName()

For i = 0 To UBound(vVariableList)
Debug.Print ("Variable name: " & vVariableList(i))
Next i
End If
Set zRecipeGroup = Nothing
End If
Set zRecipeGroups = Nothing
End Sub


Export

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Export(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Public Sub Macro_ExportRecipeGroup()
Dim zRGMGroups As RGMRecipeGroups
Dim zRGMGroup As RGMRecipeGroup
Dim zFile As String
Dim i As Integer

Set zRGMGroups = thisProject.RGMGroups ' Get all recipe groups
zFile = zRGMGroups.Parent.ModulePath(tpModulePaths.tpPathExport)

For i = 0 To zRGMGroups.count - 1
Set zRGMGroup = zRGMGroups.Item(i) ' Get a recipe group
With zRGMGroup
Debug.Print ("Export: " & .Name & " To '" & zFile & .Name & ".XML'")
If Dir(zFile & .Name & ".XML") <> "" Then 'Check if file exist
Debug.Print ("File exist!")
Else
If zRGMGroups.Item(i).Export(.Name & ".XML") Then ' Export with relative path
Debug.Print ("Exported!")
Else
Debug.Print ("ERROR!")
End If
End If
End With
Set zRGMGroup = Nothing
Next i

End Sub


Import

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import settings from an xml file. Existing settings will be replaced.

Datatype

Import(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Public Sub Macro_ImportRecipeGroup()
Dim zRGMGroups As RGMRecipeGroups
Dim zRGMGroup As RGMRecipeGroup
Dim zFile As String
Dim i As Integer

Set zRGMGroups = thisProject.RGMGroups 'Get all recipe groups
zFile = zRGMGroups.Parent.ModulePath(tpModulePaths.tpPathExport) & "Group_B.XML" 'RuntimeFolder\Export\Group_B.XML

Debug.Print ("Import: " & zFile)
If Dir(zFile) <> "" Then 'Check if file exist
Debug.Print ("File exist!")
If zRGMGroups.Item("Group_B") Is Nothing Then
Set zRGMGroup = zRGMGroups.CreateGroup("Group_B") 'Create new RGMGroup
If zRGMGroup.Import(zFile) Then 'Import recipes with relative path
Debug.Print ("Imported!")
Else
Debug.Print ("Error!")
End If
Set zRGMGroup = Nothing
End If
End If

End Sub


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


RGMRecipeGroup-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Object recipes

Other topics in this chapter

Object recipes


Object recipes

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroup -> RGMRecipeGroup-Dynamic properties -> Object recipes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BSTR

Name

Group name

Name of the recipe group.

When you set binary files for property DataSource, only alphanumeric characters are allowed.

More in the online help.

ZT_AKZ

SystemModelGroup

Equipment groups

Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group.

More in the online help.

VT_BOOL

WriteSync

Write synchronously

Is set at recipe group for all recipes of this recipe group and can be overwritten at each recipe.

Active: When writing a recipe, all control elements are locked in the Recipe Group Manager screen until the driver confirms that all values have been written successfully or the defined Timeout [ms] has expired.

Inactive: The values of the recipe are written without waiting for a confirmation. The control elements can be used again immediately. The confirmation of the driver is done with the status bit WR-SUC, which is set to 1, when values have been written successfully.

More in the online help.

VT_UI4

WriteTimeout

Timeout [ms]

Is set at recipe group for all recipes of this recipe group and can be overwritten at each recipe.

If you activated Write synchronously, you can enter a timeout here. The control elements of the Recipe Group Manager screen can be operated once again after this time at the latest. If, in Timeout, the value 0 is entered, zenon calculates the timeout in the following way: 30000+(100*number of datapoints)

More in the online help.

VT_BSTR

Feedback_Write_Result

Recipe writing complete

Result of the writing of the recipe as numeric value.

VT_BSTR

Feedback_Write_Name

Recipe name

Name of the recipe written last.

VT_BSTR

Feedback_Write_Number

Recipe number

Number of the recipe written last.

VT_BSTR

Feedback_Write_Version

Recipe version

Version of the last recipe written.

VT_BSTR

Feedback_Write_Rights

Authorization level

Authorization level of the last recipe written.

VT_BSTR

Feedback_Write_Status_Txt

Recipe state text

Status of the last recipe written. The text has the following format: 1 - @Text
This text is written as raw text to the variable. To display the text translated, you must activate property Translate displayed text for the display element (dynamic text).

A click on the ... button opens the dialog for variable selection.

Values: See system driver variables - Recipes, standard and RGM.

More in the online help.

VT_BSTR

Feedback_Write_Status_Nr

Recipe state number

Status of the last recipe written as a number.

VT_BSTR

Feedback_Write_Userchange

Change user

Name of the user who was logged in when the last change was made to the last recipe written.

VT_BSTR

Feedback_Write_Timechange

Change time

Time of the last recipe change of the last recipe written.

VT_BSTR

Feedback_Write_Comment1

Comment 1

Comment 1 of the recipe written last.

VT_BSTR

Feedback_Write_Comment2

Comment 2

Comment 2 of the recipe written last.

VT_BSTR

Feedback_Write_Comment3

Comment 3

Comment 3 of the recipe written last.

VT_BSTR

Feedback_Write_Comment4

Comment 4

Comment 4 of the recipe written last.

VT_BSTR

Feedback_Write_Comment5

Comment 5

Comment 5 of the recipe written last.

VT_BSTR

Feedback_Write_Comment6

Comment 6

Comment 6 of the recipe written last.

VT_BSTR

Feedback_Write_Comment7

Comment 7

Comment 7 of the recipe written last.

VT_BSTR

Feedback_Write_Comment8

Comment 8

Comment 8 of the recipe written last.

VT_BSTR

Feedback_Read_Result

Recipe reading complete

Result of the recipe read as numeric value.

VT_BSTR

Feedback_Read_Name

Recipe name

Name of the recipe read last.

VT_BSTR

Feedback_Read_Number

Recipe number

Number of the recipe read last.

VT_BSTR

Feedback_Read_Version

Recipe version

Version of the last recipe read.

VT_BSTR

Feedback_Read_Rights

Authorization level

Level of authorization of the last recipe read.

VT_BSTR

Feedback_Read_Status_Txt

Recipe state text

Status of the last recipe read. The text has the following format: 1 - @Text
This text is written as raw text to the variable. To display the text translated, you must activate property Translate displayed text for the display element (dynamic text).

A click on the ... button opens the dialog for variable selection.

Values: See system driver variables - Recipes, standard and RGM.

More in the online help.

VT_BSTR

Feedback_Read_Status_Nr

Recipe state number

Status of the last recipe read as a number.

VT_BSTR

Feedback_Read_Userchange

Change user

Name of the user who was logged in when the last change was made to the last recipe read.

VT_BSTR

Feedback_Read_Timechange

Change time

Time of the last recipe change of the last recipe read.

VT_BSTR

Feedback_Read_Comment1

Comment 1

Comment 1 of the recipe read last.

VT_BSTR

Feedback_Read_Comment2

Comment 2

Comment 2 of the recipe read last.

VT_BSTR

Feedback_Read_Comment3

Comment 3

Comment 3 of the recipe read last.

VT_BSTR

Feedback_Read_Comment4

Comment 4

Comment 4 of the recipe read last.

VT_BSTR

Feedback_Read_Comment5

Comment 5

Comment 5 of the recipe read last.

VT_BSTR

Feedback_Read_Comment6

Comment 6

Comment 6 of the recipe read last.

VT_BSTR

Feedback_Read_Comment7

Comment 7

Comment 7 of the recipe read last.

VT_BSTR

Feedback_Read_Comment8

Comment 8

Comment 8 of the recipe read last.

VT_BSTR

Feedback_Check_Result

Check recipe value - result

Result of the checking of the recipe as numeric value.

VT_BSTR

Feedback_Check_Different

Check recipe value - deviation

Deviances at the result of the check of the recipe as text.

VT_BSTR

Feedback_Check_Name

Recipe name

Name of the recipe checked last.

VT_BSTR

Feedback_Check_Number

Recipe number

Number of the recipe checked last.

VT_BSTR

Feedback_Check_Version

Recipe version

Version of the last recipe checked.

VT_BSTR

Feedback_Check_Rights

Authorization level

Authorization level of the last recipe checked.

VT_BSTR

Feedback_Check_Status_Txt

Recipe state text

Status of the recipe checked last. The text has the following format: 1 - @Text
This text is written as raw text to the variable. To display the text translated, you must activate property Translate displayed text for the display element (dynamic text).

A click on the ... button opens the dialog for variable selection.

Values: See system driver variables - Recipes, standard and RGM.

More in the online help.

VT_BSTR

Feedback_Check_Status_Nr

Recipe state number

Status of the last recipe checked as a number.

VT_BSTR

Feedback_Check_Userchange

Change user

Name of the user who was logged in when the last change was made to the last recipe checked.

VT_BSTR

Feedback_Check_Timechange

Change time

Time of the last recipe change of the last recipe checked.

VT_BSTR

Feedback_Check_Comment1

Comment 1

Comment 1 of the recipe checked last.

VT_BSTR

Feedback_Check_Comment2

Comment 2

Comment 2 of the recipe checked last.

VT_BSTR

Feedback_Check_Comment3

Comment 3

Comment 3 of the recipe checked last.

VT_BSTR

Feedback_Check_Comment4

Comment 4

Comment 4 of the recipe checked last.

VT_BSTR

Feedback_Check_Comment5

Comment 5

Comment 5 of the recipe checked last.

VT_BSTR

Feedback_Check_Comment6

Comment 6

Comment 6 of the recipe checked last.

VT_BSTR

Feedback_Check_Comment7

Comment 7

Comment 7 of the recipe checked last.

VT_BSTR

Feedback_Check_Comment8

Comment 8

Comment 8 of the recipe checked last.

VT_BSTR

Feedback_XMLImport_Result

Result of the import

Success of the XML import.


RGMRecipeGroups

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This object manages "RGMRecipeGroup" objects.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public Sub zenOn_RGMGroups()
'Declarations
Dim zRGM_Groups As RGMRecipeGroups
Dim zRGM_Group As RGMRecipeGroup
Dim i As Integer

'Initialize zRGM_Groups with the "RGMGroups" object of the current project
Set zRGM_Groups = MyWorkspace.ActiveDocument.RGMGroups

'Create a new group called "zenOn_RGMGroup"
zRGM_Groups.CreateGroup ("zenOn_RGMGroup")

'Enumerate all recipe groups
For i = 0 To zRGM_Groups.Count - 1
'Assign the current item to zRGM_Group
Set zRGM_Group = zRGM_Groups.Item(i)

'Enumerate the groups
Debug.Print i + 1 & ". Group: "
'Output name of the group
Debug.Print " Name: " & zRGM_Group.DynProperties("Name")
'Output amount of recipes within the collection
Debug.Print " Recipes: " & zRGM_Group.RecipeCount
'Output amount of variables within the collection
Debug.Print " Variables: " & zRGM_Group.VariableCount
'Output a blank line
Debug.Print ""

'If there are recipes available, then output them
If zRGM_Group.RecipeCount > 0 Then
Call GetRecipesOfGroup(zRGM_Group)
End If

'If there are variables available, then output them
If zRGM_Group.VariableCount > 0 Then
Call GetVariablesOfGroup(zRGM_Group)
End If

Next i

'Delete the former created group
zRGM_Groups.DeleteGroup ("zenOn_RGMGroup")

Debug.Print ""
End Sub

Sub GetRecipesOfGroup(myRGMGroup As RGMRecipeGroup)
'Declarations
Dim zRGM_Recipe As RGMRecipe
Dim i As Integer

Debug.Print "Recipes"
'Enumerate all recipes in the group
For i = 0 To myRGMGroup.RecipeCount - 1
'Assign the current recipe item to zRGM_Recipe
Set zRGM_Recipe = myRGMGroup.RecipeItem(i)
'Output the recipe
Debug.Print " Recipe" & i + 1 & ": " & zRGM_Recipe.DynProperties("RecipeName")
Next i
'Output a blank line
Debug.Print ""
End Sub

Sub GetVariablesOfGroup(myRGMGroup As RGMRecipeGroup)
'Declarations
Dim zRGM_Variable As RGMRecipeVar
Dim i As Integer

'Enumerate all variables of the group
Debug.Print "Variables"
For i = 0 To myRGMGroup.VariableCount - 1
'Assign the current variable item to zRGM_Variable
Set zRGM_Variable = myRGMGroup.VariableItem(i)
'Output the variable
Debug.Print " Var" & i + 1 & ": " & zRGM_Variable.Name
Next i
'Output a blank line
Debug.Print ""
End Sub

Other topics in this chapter

RGMRecipeGroups-Properties

RGMRecipeGroups-Methods

RGMRecipeGroups-Events

RGMRecipeGroups-Dynamic properties


RGMRecipeGroups-Properties

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | read only | read only
IProject | Parent | Parent of object | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


RGMRecipeGroups-Methods

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CheckIn | Save module modifications to server (editor). | available | not used
VARIANT_BOOL | CheckOut | Allow module modifications (editor). | available | not used
IRGMRecipeGroup | CreateGroup | - | available | available
VARIANT_BOOL | DeleteGroup | - | available | available
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | Get | Get the latest version from the server (editor). | available | not used
VARIANT_BOOL | Import | Imports the selected XML file | available | available
VARIANT_BOOL | IsCheckedOut | Returns true when the current module checked out by the current user (editor). | read only | not used
VARIANT_BOOL | IsDifferent | Return true when the local- and server version are different (editor). | read only | not used
VARIANT_BOOL | IsLocked | Returns true when the current module is Locked by another user (editor). | read only | not used
IRGMRecipeGroup | Item | - | available | available
VARIANT_BOOL | RenameGroup | - | available | available
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | available
VARIANT_BOOL | UndoCheckOut | Undo module modifications (editor). | available | not used
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | available

Other topics in this chapter

Item

CreateGroup

DeleteGroup

RenameGroup

Get

CheckOut

CheckIn

UndoCheckOut

IsLocked

IsCheckedOut

IsDifferent

SingleExport

Export

Import


Item

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a "RGMRecipeGroup" object by its name as a string or by its position.

Datatype

Item(VARIANT vPosOrName) As RGMRecipeGroup

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateGroup

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Methods -> CreateGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new group by its name as string.

Datatype

CreateGroup(String bstrName) As RGMRecipeGroup

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteGroup

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Methods -> DeleteGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deletes a group by its name as string.

Datatype

DeleteGroup(String bstrName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RenameGroup

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Methods -> RenameGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Renames a group by passing the old and new name as string.

Datatype

RenameGroup(String bstrOldName,String bstrNewName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Get

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Methods -> Get

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype

Get() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckOut

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Methods -> CheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype

CheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckIn

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Methods -> CheckIn

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype

CheckIn() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


UndoCheckOut

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Methods -> UndoCheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype

UndoCheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsLocked

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Methods -> IsLocked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype

IsLocked() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsCheckedOut

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Methods -> IsCheckedOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype

IsCheckedOut() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsDifferent

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Methods -> IsDifferent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype

IsDifferent() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SingleExport

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Methods -> SingleExport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SingleExport(VARIANT vIndexOrName,BSTR bsFileName) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Export

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export settings to an xml file

Datatype

Export(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to export.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Import

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced.

Datatype

Import(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to import.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


RGMRecipeGroups-Events

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | RecipeCreate | A new recipe is going to be created | available | available
void | RecipeCreated | A new recipe was created | available | available
void | RecipeDelete | A recipe is going to be deleted | available | available
void | RecipeDuplicate | A recipe is going to be created as a duplicate | available | available
void | RecipeDuplicated | A recipe was created as a duplicate | available | available
void | RecipeRename | A recipe is going to be renamed | available | available
void | RecipeXMLImport | A recipe is going to be imported from a XML file. | available | available
void | StatusChange | A recipe status is going to be changed | available | available
void | VersionCreate | A new recipe version is going to be created | available | available
void | VersionCreated | A new recipe version was created | available | available
void | VersionDelete | A recipe version is going to be deleted | available | available
void | VersionDuplicate | A recipe version is going to be created as a duplicate | available | available
void | VersionDuplicated | A recipe version was created as a duplicate | available | available
void | VersionDuplicatedRead | A recipe version was created as a duplicate and read from the PLC | available | available
void | VersionDuplicateRead | A recipe version is going to be created as a duplicate and read | available | available

Other topics in this chapter

StatusChange

RecipeCreate

VersionCreate

RecipeDuplicate

VersionDuplicate

VersionDuplicateRead

RecipeCreated

VersionCreated

RecipeDuplicated

VersionDuplicated

VersionDuplicatedRead

RecipeRename

RecipeDelete

VersionDelete

RecipeXMLImport


StatusChange

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Events -> StatusChange

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is requested before changing the status.

obRecipe The concerned recipe.

nStatusNew [ByRef]The wanted status in the way how the operater would like to change it.

bCancel [ByRef]Flag to cancel this action. If true, the action will be canceled.

Datatype

StatusChange(RGMRecipe obRecipe, long nStatusNew, Boolean bCancel) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RecipeCreate

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Events -> RecipeCreate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is requested for validation before creating a recipe.

obRecipeGroup The concerned recipe group which the recipe is added to.

strNewName [ByRef]The recipe name to be assigned.

nNewNumber [ByRef]The recipe number to be assigned.

bCancel [ByRef]Flag to cancel this action. If true, the action will be canceled.

Datatype

RecipeCreate(RGMRecipeGroup obRecipeGroup, String strNewName, long nNewNumber, Boolean bCancel) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


VersionCreate

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Events -> VersionCreate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is requested for validation before creating a recipe version.

obRecipeGroup The concerned recipe group which the recipe is added to.

strNewName The recipe name.

nNewNumber [ByRef]The recipe number to be assigned.

bCancel [ByRef]Flag to cancel this action. If true, the action will be canceled.

Datatype

VersionCreate(RGMRecipeGroup obRecipeGroup, String strName, long nNewNumber, Boolean bCancel) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RecipeDuplicate

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Events -> RecipeDuplicate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is requested for validation before duplicating (save recipe under) a recipe.

obRecipeGroup The concerned recipe group which the recipe is added to.

strNewName [ByRef]The recipe name to be assigned.

nNewNumber [ByRef]The recipe number to be assigned.

bCancel [ByRef]Flag to cancel this action. If true, the action will be canceled.

Datatype

RecipeDuplicate(RGMRecipeGroup obRecipeGroup, String strNewName, long nNewNumber, Boolean bCancel) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


VersionDuplicate

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Events -> VersionDuplicate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Wird zur Validierung vor dem Anlegen der Rezeptversion beim Duplizieren aufgerufen.

obRecipeGroup Die betroffene Rezeptgruppe zu welcher das Rezept hinzugefügt wird.

strNewName Der Rezeptname.

nNewNumber [ByRef]Die zu vergebende Rezeptnummer.

bCancel [ByRef]Das Flag um diese Aktion abzubrechen. Bei True wird die Aktion abgebrochen.

Datatype

VersionDuplicate(RGMRecipeGroup obRecipeGroup, String strName, long nNewNumber, Boolean bCancel) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


VersionDuplicateRead

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Events -> VersionDuplicateRead

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

It is requested for validation before creating a recipe version on "duplicate and read".

obRecipeGroup The concerned recipe group which the recipe is added to.

strNewName The recipe name.

nNewNumber [ByRef]The recipe number to be assigned.

bCancel [ByRef]The Flag to cancel the action. If true, the action will be canceled.

Datatype

VersionDuplicateRead(RGMRecipeGroup obRecipeGroup, String strName, long nNewNumber, Boolean bCancel) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RecipeCreated

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Events -> RecipeCreated

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

RecipeCreated(RGMRecipe obRecipe) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


VersionCreated

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Events -> VersionCreated

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

VersionCreated(RGMRecipe obRecipe) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RecipeDuplicated

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Events -> RecipeDuplicated

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is requested after duplicating a recipe.

obRecipe [ByRef] The new created recipe.

Datatype

RecipeDuplicated(RGMRecipe obRecipe) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


VersionDuplicated

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Events -> VersionDuplicated

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is requested after duplicating a recipe version.

obRecipe [ByRef]The new recipe version which has been created.

Datatype

VersionDuplicated(RGMRecipe obRecipe) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


VersionDuplicatedRead

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Events -> VersionDuplicatedRead

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is requested after „duplicate and read" of a recipe version.

obRecipe [ByRef]The recipe version which has been created new.

Datatype

VersionDuplicatedRead(RGMRecipe obRecipe) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RecipeRename

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Events -> RecipeRename

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is requested for validation before renaming a recipe.

obRecipe The lowest version of the concerned recipe.

strNewName [ByRef]The new recipe name.

bCancel [ByRef]Flag to cancel this action. If true, the action will be canceled.

Datatype

RecipeRename(RGMRecipe obRecipe, String strNewName, Boolean bCancel) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RecipeDelete

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Events -> RecipeDelete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is requested for validation before deleting a recipe (with all its versions).

obRecipe The lowest version of the concerned recipe.

bCancel [ByRef]Flag to cancel this action. If true, the action will be canceled.

Datatype

RecipeDelete(RGMRecipe obRecipe, Boolean bCancel) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


VersionDelete

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Events -> VersionDelete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Is requested for validation before deleting a recipe version.

obRecipe The recipe version to be deleted.

bCancel [ByRef]Flag to cancel this action. If true, the action is canceled.

Datatype

VersionDelete(RGMRecipe obRecipe, Boolean bCancel) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RecipeXMLImport

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Events -> RecipeXMLImport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

RecipeXMLImport(tpRGMRecipeImport nEventTopic, IRGMRecipeGroup obRecipeGroup, String strRecipeName, long nRecipeVersion, long lCancel) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Dim WithEvents zRGMRecipeGroups As RGMRecipeGroups

Private Sub Project_Active()
Set zRGMRecipeGroups = thisProject.RGMGroups
End Sub

Public Sub zRGMRecipeGroups_RecipeXMLImport(ByVal nEventTopic As tpRGMRecipeImport, _
ByVal obRecipeGroup As IRGMRecipeGroup, _
ByVal strRecipeName As String, _
ByVal nRecipeVersion As Long, _
lCancel As Long)
Select Case nEventTopic
Case tpRGMRecipeImport.tpOverwriteRecipe
Debug.Print ("Overwrite recipe: " & tpRGMRecipeImport.tpOverwriteRecipe)
Case tpRGMRecipeImport.tpCreateNewRecipe
Debug.Print ("Create new recipe: " & tpRGMRecipeImport.tpCreateNewRecipe)
Case tpRGMRecipeImport.tpValuesDiffer
Debug.Print ("Values differ: " & tpRGMRecipeImport.tpValuesDiffer)
End Select
Debug.Print ("=======================================")
Debug.Print ("Recipe Group: " & obRecipeGroup.Name)
Debug.Print ("Recipe Name: " & strRecipeName)
Debug.Print ("Recipe Count: " & obRecipeGroup.RecipeCount)
Debug.Print ("Recipe Version: " & nRecipeVersion)

If (obRecipeGroup.RecipeCount = 1) Then
'Continue import
lCancel = 0
ElseIf (obRecipeGroup.RecipeCount = 2) Then
'Cancel the import for the current recipe and proceed with the next recipe.
lCancel = 1
ElseIf obRecipeGroup.RecipeCount > 2 Then
'Cancel the import for the current recipe and proceed with the next recipegroup
lCancel = 2
End If
End Sub


RGMRecipeGroups-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Base recipes

Other topics in this chapter

Base recipes


Base recipes

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeGroups -> RGMRecipeGroups-Dynamic properties -> Base recipes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
ZT_MEMFILE | StatusList | Identifier recipe state | Configuration of the status identifier. Click on property in order to open the configuration dialog. A list of the states is used at the status selection in the recipe. More in the online help.
ZT_PICTURE | BoolKbd | Binary tags | Selection of a keyboard for binary inputs. Clicking on the ... button opens the dialog to select a keyboard screen. More in the online help.
ZT_PICTURE | NumKbd | Numeric tags | Selection of a keyboard for numerical inputs. Clicking on the ... button opens the dialog to select a keyboard screen. More in the online help.
ZT_PICTURE | StringKbd | String tags | Selection of a keyboard for string inputs. Clicking on the ... button opens the dialog to select a keyboard screen. More in the online help.
ZT_COLOR | TextColorInvalidValue | Text color for invalid recipe values | Selection of the text color for cells with invalid values. This highlights parameters that are outside the defined minimum/maximum value or whose action relates to a variable that is not present or cannot be accessed. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front. Default: White (#FFFFFF) More in the online help.
ZT_COLOR | BackColorInvalidValue | Background color for invalid recipe values | Selection of the background color for cells with invalid values. This highlights parameters that are outside the defined minimum/maximum value or whose action relates to a variable that is not present or cannot be accessed. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front. Default: red (#DD4814) More in the online help.
ZT_COLOR | TextColorMatchPLC | Text color if recipe value is equal to PLC value | Selection of the text color for corresponding values. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front. Default: White (#FFFFFF) More in the online help.
ZT_COLOR | BackColorMatchPLC | Background color if recipe value is equal to PLC value | Selection of the background color for corresponding values. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front. Default: green (#96BD33) More in the online help.
ZT_COLOR | TextColorNoMatchPLC | Text color if recipe value is different to PLC value | Selection of the text color for different PLC values. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front. Default: White (#FFFFFF) More in the online help.
ZT_COLOR | BackColorNoMatchPLC | Background color if recipe value is different to PLC value | Selection of the background color for different PLC values. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front. Default: red (#DD4814) More in the online help.
ZT_COLOR | TextColorInvalidPLC | Text color for invalid PLC values | Selection of the text color for invalid PLC values. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front. Default: White (#FFFFFF) More in the online help.
ZT_COLOR | BackColorInvalidPLC | Background color for invalid PLC values | Selection of the background color for invalid PLC values. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front. Default: blue (#3D6894) More in the online help.
ZT_COLOR | TextColorInterlockedParameter | Text color for interlocked recipe parameters | Selection of the text color for interlocked recipe parameters.Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front. Default: Black (#000000) More in the online help.
ZT_COLOR | BackColorInterlockedParameter | Background color for locked recipe parameters | Selection of the background color for interlocked recipe parameters. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front. Default: Grey (#D3D3D3) More in the online help.


RGMRecipeValue

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The "RGMRecipeValue" object is utilized by the "RGMRecipe" object, in order to define the characteristics.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub GetValuesOfRecipe(myRGMRecipe As RGMRecipe)
'Declarations
Dim zRGM_Value As RGMRecipeValue
Dim i As Integer

'enum all values of the recipe
For i = 0 To myRGMRecipe.ValueCount - 1
Set zRGM_Value = myRGMRecipe.ValueItem(i)
Debug.Print "Value: " & zRGM_Value.VarName & " = " & zRGM_Value.DynProperties("Value")
Next i

End Sub

Other topics in this chapter

RGMRecipeValue-Properties

RGMRecipeValue-Methods

RGMRecipeValue-Dynamic properties


RGMRecipeValue-Properties

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeValue -> RGMRecipeValue-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IRGMRecipe | Parent | Parent of object | read only | read only
BSTR | VarName | Name of the Variable | read only | read only

Other topics in this chapter

Parent

VarName


Parent

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeValue -> RGMRecipeValue-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As RGMRecipe

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


VarName

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeValue -> RGMRecipeValue-Properties -> VarName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the name of the assigned variable.

Datatype

VarName() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


RGMRecipeValue-Methods

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeValue -> RGMRecipeValue-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeValue -> RGMRecipeValue-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeValue -> RGMRecipeValue-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeValue -> RGMRecipeValue-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeValue -> RGMRecipeValue-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


RGMRecipeValue-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeValue -> RGMRecipeValue-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Object value

Other topics in this chapter

Object value


Object value

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeValue -> RGMRecipeValue-Dynamic properties -> Object value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_UI4 | Type | Action | This property defines the action type on a recipe variable.
ZT_VARIABLE | Variable | Variable | This property returns the recipe variable.
VT_I4 | Offset | Offset | "This property returns the offset for variables with an old-style array. It returns ""-1"" when a normal variable is used. ""0"" is the first element in the old style array."
ZT_VARIABLE | SourceVar | SourceVar | "This property returns the variable which is linked to the recipe variable when action type ""Link to PV"" is used."
VT_I4 | SourceOffset | SourceOffset | "this property returns the index of the old array when ""link with PV"" is used and the source variable has an old-style array. It returns ""-1"" in normal cases, where the source variable is a normal variable."
VT_R8 | Value | Value or variable | "This property returns the projected value when action type: ""Modify spontaneous value"", ""Switch to and modify spontaneous value"", ""modify substitute value"" or Switch to and modify alternate value is projected."
VT_BSTR | StringValue | StringValue | "This property returns the project string when action type ""user status"" is used."


RGMRecipeVar

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeVar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This object is utilized by the "RGMRecipeGroup" object, in order to define which Variable is assigned to it.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub GetVariablesOfGroup(myRGMGroup As RGMRecipeGroup)
'Declarations
Dim zRGM_Variable As RGMRecipeVar
Dim i As Integer

'enum all variables of the group
For i = 0 To myRGMGroup.VariableCount - 1
Set zRGM_Variable = myRGMGroup.VariableItem(i)
Debug.Print "Variable: " & zRGM_Variable.Name
Next i

End Sub

Other topics in this chapter

RGMRecipeVar-Properties

RGMRecipeVar-Methods

RGMRecipeVar-Dynamic properties


RGMRecipeVar-Properties

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeVar -> RGMRecipeVar-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
BSTR | Name | Name of the Variable | read only | read only
IRGMRecipeGroup | Parent | Parent of object | read only | read only

Other topics in this chapter

Parent

Name


Parent

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeVar -> RGMRecipeVar-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As RGMRecipeGroup

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeVar -> RGMRecipeVar-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the name of the assigned variable.

Datatype

Name() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


RGMRecipeVar-Methods

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeVar -> RGMRecipeVar-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeVar -> RGMRecipeVar-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeVar -> RGMRecipeVar-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeVar -> RGMRecipeVar-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeVar -> RGMRecipeVar-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


RGMRecipeVar-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeVar -> RGMRecipeVar-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Object channell

Other topics in this chapter

Object channell


Object channell

Manual -> Programming interfaces -> Objectmodel -> RGMRecipeVar -> RGMRecipeVar-Dynamic properties -> Object channell

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

RangeFromVar

Take set value limits from variable

Active: The set value limits are fetched dynamically from the variable and are not fixedly defined in the recipe group.

More in the online help.

VT_R8

Min

min. value

Only available if property Take set value limits from variable was not activated.

Minimum value of the variable.

More in the online help.

VT_R8

Max

max. value

Only available if property Take set value limits from variable was not activated.

Maximum value of the variable.

More in the online help.

VT_BSTR

Interlocking

Interlocking

Allocation of an interlocking to a variable. Select from drop-down list.

More in the online help.

ZT_VARIABLE

VisibilityVar

Visibility variable

Select a variable in order to control the visibility. A click on the ... button opens the selection dialog.

More in the online help.

VT_BSTR

Filter

ColOrderAll

ZT_PICTURE

Keyboard

Screen Keyboard

Link of a screen of type keyboard which should be called up via a left click on the variable in order to enter a value in the Runtime. A click on the button opens the selection dialog.

More in the online help.

ZT_VARIABLE

ShadowVariable

Graphic recipe variable

Graphic recipe variables make it possible to change an RGM recipe value via a screen in Runtime. A graphic recipe variable can be defined for each variable in a recipe group. In Runtime, the RGM variable is replaced by a graphic recipe variable using the Recipegroup Manager function with the help of the Write recipe value to shadow variable action and written back after a change to the RGM with the help of the Write shadow variable to recipe value action.

Click the button and a dialog opens to select the shadow variable. Each graphic recipe variable can be only used once per recipe group.

More in the online help.

ZT_VARIABLE

Variable

Variable name

This property returns the recipe variable.

VT_I4

Offset

Offset

"This property returns the offset for variables with an old-style array. It returns ""-1"" when a normal variable is used. ""0"" is the first element in the old style array."


RtFunction

Manual -> Programming interfaces -> Objectmodel -> RtFunction

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This object is a zenOn function and contains the most important information about the function.A function can be accessed by a unique name, that has to be defined for it, or you can run through all functions by its index.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

'########################################################################'
'# Procedure to change the properties of a function with replacing... #'
'# -------------------------------------------------------------------- #'
'# In the picture to show there are several linked variables, #'
'# beginning with 'Dummy/Dummy' this string will be replaced with the #'
'# given parameter 'strDest' and the function will be executed. #'
'########################################################################'
Sub ChangeFunction(strName As String, strDest As String)
Dim zFCT As RtFunction
Dim strTemp As String
Dim i As Integer

Set zFCT = thisProject.RtFunctions.Item(strName)
If zFCT Is Nothing Then
MsgBox "A function called: " & strName & " is missing!"
Exit Sub
End If
With zFCT
For i = 0 To CLng(.DynProperties("PictSwitch.SubstiVar")) - 1
strTemp = .DynProperties("PictSwitch.SubstiVar[" & i & "].Source")
strTemp = Replace(strTemp, "Dummy/Dummy", strDest)
.DynProperties("PictSwitch.SubstiVar[" & i & "].Destination") = strTemp
Next i
For i = 0 To CLng(.DynProperties("PictSwitch.SubstiFkt")) - 1
strTemp = .DynProperties("PictSwitch.SubstiFkt[" & i & "].Source")
strTemp = Replace(strTemp, "Dummy/Dummy", strDest)
.DynProperties("PictSwitch.SubstiFkt[" & i & "].Destination") = strTemp
Next i
End With
End Sub

Other topics in this chapter

RtFunction-Properties

RtFunction-Methods

RtFunction-Dynamic properties


RtFunction-Properties

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
VARIANT_BOOL | Actual |  | available | read only | yes | yes
VARIANT_BOOL | Client |  | available | read only | yes | yes
BSTR | Name |  | available | read only | yes | yes
BSTR | ParamString |  | read only | read only | yes | yes
IRtFunctions | Parent |  | read only | read only | yes | yes
VARIANT_BOOL | Server |  | available | read only | yes | yes
VARIANT_BOOL | StandBy |  | available | read only | yes | yes
long | Type |  | read only | read only | yes | yes
long | ID |  | read only | read only | yes | yes

Other topics in this chapter

Parent

Name

ParamString

Type

Actual

Server

StandBy

Client

ID


Parent

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As RtFunctions

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property returns the name to identify the function. This name can be (but may not in earlier version) defined in the Editor on creating the function. The user has to define the name explicitely.This name has to be unique.

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ParamString

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Properties -> ParamString

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the string wich is shown in the editor.

Datatype

ParamString() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Type

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Properties -> Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Type() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Actual

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Properties -> Actual

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The function will be executed on the PC on which it was started. Only available in network projects!

Datatype

Actual() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Server

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Properties -> Server

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The function will be executed on the server of the project. Only available in network projects!

Datatype

Server() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


StandBy

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Properties -> StandBy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The function will be executed on the standby server of the project. Only available in network projects!

Datatype

StandBy() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Client

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Properties -> Client

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The function will be executed on all clients of the project. Only available in network projects!

Datatype

Client() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ID

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Properties -> ID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ID() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


RtFunction-Methods

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CheckIn | Save module modifications to server (editor). | available | not used
VARIANT_BOOL | CheckOut | Allow module modifications (editor). | available | not used
VARIANT_BOOL | Copy | - | available | not used
VARIANT_BOOL | CreateDynProperty | - | available | available
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
VARIANT_BOOL | Get | Get the latest version from the server (editor). | available | not used
VARIANT_BOOL | IsCheckedOut | Returns true when the current module checked out by the current user (editor). | read only | not used
VARIANT_BOOL | IsDifferent | Return true when the local- and server version are different (editor). | read only | not used
VARIANT_BOOL | IsLocked | Returns true when the current module is Locked by another user (editor). | read only | not used
VARIANT_BOOL | Parameter | - | available | not used
VARIANT_BOOL | Start | - | not used | available
VARIANT_BOOL | UndoCheckOut | Undo module modifications (editor). | available | not used
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

CreateDynProperty

Start

Parameter

Copy

Get

CheckOut

CheckIn

UndoCheckOut

IsLocked

IsCheckedOut

IsDifferent


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


CreateDynProperty

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Methods -> CreateDynProperty

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

A new Subitem of the Function (i.e. Filter settings) can be created.

Datatype

CreateDynProperty(String bsPath) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

DynProperty as String to be created.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'Create Function for TREND - PICTURE
Sub TrendFunction()
Dim zFCT As RtFunction
Dim i As Integer

'Get function
Set zFCT = MyWorkspace.ActiveDocument.RtFunctions.Item("picTREND")
'function settings...
With zFCT
'check amount of 'PictFilter' subitems (normaly 1)
i = .DynProperties("PictFilter[-1]")
'if 0 (not exists) then create it...
If i = 0 Then .CreateDynProperty "PictFilter"
'change some settings
.DynProperties("PictFilter[0].RefreshRate") = 1

'enum CURVES
For i = 0 To CInt(.DynProperties("PictFilter[0].Curve[-1]")) - 1
'print curve settings
Debug.Print .DynProperties("PictFilter[0].Curve[" & i & "].GraphName")
Debug.Print .DynProperties("PictFilter[0].Curve[" & i & "].VarInfo.VarName")
Debug.Print .DynProperties("PictFilter[0].Curve[" & i & "].YAxe.Scale.ScaleTop")
Debug.Print .DynProperties("PictFilter[0].Curve[" & i & "].YAxe.Scale.ScaleBotton")
Next i
End With
End Sub


Start

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Methods -> Start

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method executes the function with its defined parameters (also the parameter 'with filter dialog').The parameters cannot be changed with VBA.

Datatype

Start() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Parameter

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Methods -> Parameter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Opens the dialog in the editor to configure the actual function.

Datatype

Parameter() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Copy

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Methods -> Copy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Copies the settings of an existing function to the function object.

Datatype

Copy(IRtFunction pSource) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Existing function to be copied as object

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

pSource As RtFunction

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub CopyFunction()
Dim zFct As RtFunction
Dim zFctCopy As RtFunction
'get existing function
Set zFct = MyWorkspace.ActiveDocument.RtFunctions.Item("picSTART")
'create new function
Set zFctCopy = MyWorkspace.ActiveDocument.RtFunctions.Create("TESTING", tpPicture)
'copy existing function settings to new one...
Debug.Print zFctCopy.Copy(zFct)
End Sub


Get

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Methods -> Get

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype

Get() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckOut

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Methods -> CheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype

CheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckIn

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Methods -> CheckIn

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype

CheckIn() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


UndoCheckOut

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Methods -> UndoCheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype

UndoCheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsLocked

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Methods -> IsLocked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype

IsLocked() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsCheckedOut

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Methods -> IsCheckedOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype

IsCheckedOut() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsDifferent

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Methods -> IsDifferent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype

IsDifferent() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RtFunction-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

CAnalyzerReportFunction

Batch create function

Batch command function state

Alarming

Alarms flashing'

Alarms Groups Classes

Alarmgroup connection

Simulation image

Print alarm or CEL list

Export alarms

Open help

Reload

Switch palette

Language change

Index archive

List of active archives

Export archive

Base function

Screen switch function

Focus set

Show menu

Screen.center

Monitor assign

Overview window function

Screen with index

Screen return

Call SAP function

Check maintanances

Print trend

EMS

Fault location

Graph7 Heuristics

Create IPA document

Send message

Suppress message function

Client simulatio'

Authorization in network

CFktNetzRudundanzUmschaltung

Toggle online printing

Switch online printer

PFS event

Login without password

Print report function

Recipegroup

Recipegroup manager

Standard recipe

Runtime profiles

SAT command activation

Save remanent data

Script execute select online

Start SEA

Setpoint

Report execute

Earth fault topology

Shedding load topology

Unit switch

Export data function

Read dBase file

Print actual values function

Send value to hardware

Driver commands

Read Write time variable

VBA execute macro

VSTA execute macro

Play sound file

File operations

Print a hard copy function

Other topics in this chapter

CAnalyzerReportFilter

CAnalyzerReportFunction

CBatchCrCreateFunctionFilter

Batch create function

CBatchCmdFuncFilter

Batch command function state

CD_CAmlCelFilter

Alarming

CD_CBildumschaltung

Alarms flashing

Alarms Groups Classes

Alarmgroup connection

CDrvProperty

Simulation image

Print alarm or CEL list

Export alarms

Open help

Reload

Switch palette

Language change

Index archive

List of active archives

CD_CArchivExportFilter

Export archive

Base function

Screen switch function

CD_CSetFocus

Focus set

Show menu

CDBildMittelPunktPara

Screen.center

Monitor assign

COverviewInfo

Overview window function

Screen with index

Screen return

Call SAP function

CPlantStatusVar

Check maintanances

CDiagram

Print trend

EMS

CProjektVariableProp

Fault location

Graph7 Heuristics

CD_CAsmFilter

Create IPA document

CD_CMessageFilter

Send message

CSystemModelFilter

Suppress message function

Client simulatio

CD_CFktToken

Authorization in network

CFktNetzRudundanzUmschaltung

Toggle online printing

Switch online printer

CFPUserEventFilter

PFS event

Login without password

CReportViewerFilter

Print report function

Recipegroup

CRezeptFilter

Recipegroup manager

Standard recipe

Runtime profiles

SAT command activation

Save remanent data

Script execute select online

Start SEA

Setpoint

CD_CTabellenFilter

Report execute

Earth fault topology

CLoadSheddingVerbraucher

Shedding load topology

Unit switch

CExportInitStrukt

Export data function

Read dBase file

CFormatInfo

Print actual values function

CFktSwNeu

Send value to hardware

CTreiberCommand

Driver commands

CUhrzeit

Read Write time variable

CD_CVbaMacroFilter

VBA execute macro

VSTA execute macro

Play sound file

CDateiOperationParameter

File operations

CHardCopyPrintInfo

Print a hard copy function


CAnalyzerReportFilter

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CAnalyzerReportFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | ParameterList | ParameterListCfg | Provides access to the column settings of the GFX list. Typ = ZT_KNOTEN Array-Members = CAnalyzerParamListCfg
VT_UI2 | ServerVersion | ServerVersion | Provides access to the server version. Typ = VT_UI2
VT_BSTR | ServerName | ServerName | Provides access to the server name. Type = VT_BSTR
VT_BOOL | UseRuntimeUser | UseRuntimeUser | Provides access to the windows authentification flag. Type = VT_BOOL
VT_BSTR | UserName | UserName | Provides access to the username used for the authentification. Type = VT_BSTR
VT_BSTR | CryptedPassword | CryptedPassword | Provides access to the crypted password used for the authentification. Type = VT_BSTR
VT_BSTR | SelectedReport | SelectedReport | Provides access to the selected report. Type = VT_BSTR
VT_BSTR | RenderingEngine | RenderingEngine | Provides access to the selected rendering extension. Type = VT_BSTR
VT_BOOL | IncludeTimestamp | IncludeTimestamp | Provides access to the timestamp flag. Type = VT_BOOL
ZT_VARIABLE | VariableForOutputFilePath | VariableForOutputFilePath | Provides access to the variable which includes the path of the file. Type = ZT_VARIABLE


CAnalyzerReportFunction

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CAnalyzerReportFunction

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | ReportFilter | ReportFilter | Provides access to the filter function. Typ = ZT_KNOTEN Array-Members = CAnalyzerReportFilter
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CBatchCrCreateFunctionFilter

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CBatchCrCreateFunctionFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_I4 | CrNameCreation | CrNameCreation | Description as text.
ZT_VARIABLE | CrNameCreationVar | CrNameCreationVar | Description as text.
VT_BOOL | LinkJobId | LinkJobId | Description as text.
ZT_VARIABLE | IndividualJobVariable | IndividualJobVariable | Description as text.
VT_I4 | IndividualJobIdLinkType | IndividualJobIdLinkType | Description as text.
VT_I4 | SettingMR | SettingMR | Description as text.
VT_BSTR | MRTextFilter | MRTextFilter | Description as text.
ZT_VARIABLE | PV_MR | PV_MR | Description as text.
VT_I4 | MrCurrentness | MrCurrentness | Description as text.
VT_I4 | MrState | MrState | Description as text.
VT_I4 | VersionSearchType | VersionSearchType | Description as text.
ZT_VARIABLE | VersionVar | VersionVar | Description as text.
VT_UI4 | VersionNum | VersionNum | Description as text.


Batch create function

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Batch create function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | CrCreateFilter | CrCreateFilter | Description as text.
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CBatchCmdFuncFilter

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CBatchCmdFuncFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_I4 | StateCmd | StateCmd | Description as text.
VT_I4 | StateCmdMode | StateCmdMode | Description as text.
VT_I4 | FilterForRecipeType | FilterForRecipeType | Description as text.
VT_I4 | SettingCR | SettingCR | Description as text.
VT_BSTR | CRTextFilter | CRTextFilter | Description as text.
ZT_VARIABLE | PV_CR | PV_CR | Description as text.
VT_I4 | CrCurrentness | CrCurrentness | Description as text.
VT_I4 | CrState | CrState | Description as text.
VT_I4 | SettingMR | SettingMR | Description as text.
VT_BSTR | MRTextFilter | MRTextFilter | Description as text.
ZT_VARIABLE | PV_MR | PV_MR | Description as text.
VT_I4 | MrCurrentness | MrCurrentness | Description as text.
VT_I4 | MrState | MrState | Description as text.
VT_I4 | VersionSearchType | VersionSearchType | Description as text.
ZT_VARIABLE | VersionVar | VersionVar | Description as text.
VT_UI4 | VersionNum | VersionNum | Description as text.


Batch command function state

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Batch command function state

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | StateCmdFilter | StateCmdFilter | Description as text.
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CD_CAmlCelFilter

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CD_CAmlCelFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | FileName | FileName | With this property you get/set the file name for the different export mechanism.
VT_BSTR | VarFilter | VarFilter | "Filters for variable names, where system messages are masked out, as they are not linked to a variable. Wildcards can be used here. Default = ""*"" (All variables)"
VT_BSTR | FilterTitel | FilterTitel | "Filters for the identifictaion of variables, where system messages are masked out, as they are not linked to a variable. Wildcards can be used here. Default = ""*"""
VT_BOOL | IsFilterRT | IsFilterRT | "Displays the configuration dialog within the runtime, if set TRUE."
VT_BOOL | IsMatchCase | IsMatchCase | "Filter is case sensitive, if set TRUE. Otherwise the case sensitivity is ignored."
VT_BOOL | IsFromFiles | IsFromFiles | "Filter is applied to file entries, if set TRUE. Otherwise, the filter is applied to the entries from the memory. Hint: The maximum amount of entries which should be filtered from the file is specified by the ""EntriesCount"" DynProperty."
VT_BOOL | IsReadAll | IsReadAll |
VT_BOOL | IsAutoName | IsAutoName |
VT_BOOL | IsAML | IsAML | "Prints the alarm list, if set TRUE. Otherwise the CEL list will be printed."
VT_BOOL | IsDBASE | IsDBASE |
VT_BOOL | IsXML | IsXML |
VT_BOOL | IsRelationTime | IsRelationTime | "Display of relative times (relative to selected entries), if set TRUE."
VT_BOOL | IsUnicode | IsUnicode |
VT_BOOL | IsIncremental | IsIncremental |
VT_BOOL | IsFilterExp | IsFilterExp | "Opens the list stopped, if set TRUE. "
VT_BOOL | IsAcknowledged | IsAcknowledged | "Filters unacknowledged alarms, if set TRUE."
VT_BOOL | IsAscentOnly | IsAscentOnly | "Prints only current alarms, if set TRUE."
VT_UI2 | EntriesCount | EntriesCount | "Specifies the maximum amount of entries that should be filtered from a file. Hint: Only available, if the DynProperty ""IsFromFiles"" is set TRUE."
ZT_SCHRIFT | Font | Font | "Specifies the font that should be used. The parameter that is passed, is the index of the font within the specified font list. 0 = Standard font 1 = Default font 1 ... 5 = Default font 5 6 = User specified font 1 ... = etc. "
VT_BSTR | Classes | Classes | "Filters for alarm classes, where system messages are marked out, as they are not linked to a variable. Multiple class numbers have to be seperated with a semicolon. zFct.DynProperties(""PictFilter.Classes"") = ""1;2;"""
VT_BSTR | Groups | Groups | "Filters for alarm groups, where system messages are marked out, as they are not linked to a variable. Multiple group numbers have to be seperated with a semicolon. zFct.DynProperties(""PictFilter.Groups"") = ""1;2;"""
VT_BSTR | ResString | ResString |
ZT_ZEIT | IncTime | IncTime | "Gets or sets the minimal time for current alarms in seconds. Hint: Milliseconds can be specified with the ""mSeconds"" DynProperty."
VT_UI2 | mSeconds | mSeconds | "Gets or sets the milliseconds in addition to the ""IncTime"" DynProperty."
More... | TimeFilter | TimeFilter |
More... | ListInfo | ListInfo |
VT_BSTR | ProjectNames | ProjectNames | "Specifies the names of the projects. Multiple project names are seperated with a semicolon. zFct.DynProperties(""PictFilter.ProjectNames"") = ""PROJECT1;PROJECT2;"""
More... | TextFilter | TextFilter |
More... | StatusFilter | StatusFilter |
VT_BOOL | IsSQL | SQLBase |
VT_BSTR | SQLBase | SQLBase |
VT_BSTR | SQLTable | SQLTable |
More... | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.
More... | RTMDIFilterScreen | RTMDIFilterScreen |
VT_BSTR | Areas | Areas |
VT_BOOL | IsGoneOnly | IsGoneOnly |
VT_BOOL | NeedComment | NeedComment |
ZT_GUID | FilterPartGUID | FilterPartGUID | Description as text.
VT_BOOL | EditableInRT | EditableInRT | Description as text.


Alarming

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Alarming

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Filter | Filter |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CD_CBildumschaltung

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CD_CBildumschaltung

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BSTR

ProjectName

ProjectName

"Gets or sets the project name where the picture is defined.
Hint: The current project will be used, if this property is not specified."

VT_BSTR

Picture

Picture

Gets or sets the name of the switching picture.

VT_I2

Monitor

Monitor

Defines on which monitor the picture is displayed.
-2 = Relative to caller
0 = Display 0 (default display)
1 = Display 1 (only for multi-monitor projects)
... = etc.

VT_BOOL

IsFilterRT

IsFilterRT

"Displays the picture selection dialog within the runtime, if set TRUE."

VT_BOOL

IsMonScroll

IsMonScroll

"Scrolls to the corresponding monitor on picture switch, if set TRUE."

VT_UI4

WndType

WndType

Only users with the appropriate user authorization can edit entries in the database of the Industrial Performance Analyzer (IPA).

More...

SubstiVar

SubstiVar

"Variable substitution
Debug.Print zFct.DynProperties(""PictSwitch.SubstiVar[-1]"") 'Outputs the amount of substituted variables
Debug.Print zFct.DynProperties(""PictSwitch.SubstiVar[0].Source"") 'Access the name of the first source variable
Debug.Print zFct.DynProperties(""PictSwitch.SubstiVar[0].Destination"") 'Name of the corresponding substitution variable"

More...

SubstiFkt

SubstiFkt

"Function substitution
Debug.Print zFct.DynProperties(""PictSwitch.SubstiFkt[-1]"") 'Outputs the amount of substituted functions
Debug.Print zFct.DynProperties(""PictSwitch.SubstiFkt[0].Source"") 'Access the name of the first source function
Debug.Print zFct.DynProperties(""PictSwitch.SubstiFkt[0].Destination"") 'Name of the corresponding substitution function"

VT_BOOL

CaseSensitive

CaseSensitive

"Indices substitution is case sensitive, if set TRUE."

More...

IndexVar

IndexVar

"Accesses the assigned variables for the index substitution.
Debug.Print zFct.DynProperties(""PictSwitch.IndexVar[-1]"") 'Amount of assigned variables
Debug.Print zFct.DynProperties(""PictSwitch.IndexVar[0].Title"").Name 'Name of first variable"

More...

IndexSubstitution

IndexSubstitution

"Replaces the indices
Debug.Print zFct.DynProperties(""PictSwitch.IndexSubstitution[-1]"") 'Output the amount of substituted indices
Debug.Print zFct.DynProperties(""PictSwitch.IndexSubstitution[0].Source"") 'Access the name of the first variable
Debug.Print zFct.DynProperties(""PictSwitch.IndexSubstitution[0].Destination"") 'Name of the corresponding substitution variable"

More...

ALCSubstitution

ALCSubstitution

VT_BOOL

IsCallingPic

IsCallingPic

Specifies the variable unit.


Alarms flashing

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Alarms flashing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | PictSwitch | PictSwitch |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Alarms Groups Classes

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Alarms Groups Classes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_UI2 | ActionType | ActionType | Gets or sets the type of alarm selection. 0 = Total alarm administration 1 = Alarms of group 2 = Alarms of class
VT_UI2 | Action | Action | Gets or sets the action that should be executed. 0 = Activate alarms/groups/classes 1 = Deactivate 2 = Toggle
VT_UI2 | Index | Index | With this property you have the opportunity to get/set the alarm group or class.
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Alarmgroup connection

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Alarmgroup connection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BOOL | IsAdvise | IsAdvise | With this property you have the opportunity to activate/deactivate the alarm group connection.
VT_I2 | GroupNr | GroupNr | With this property you have the opportunity to get/set the alarm group via an index.
VT_BSTR | GroupName | GroupName | With this property you have the opportunity to get/set the alarm group.
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CDrvProperty

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CDrvProperty

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | FileName | FileName |
VT_BSTR | Description | Description |


Simulation image

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Simulation image

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Drivers | Description |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Print alarm or CEL list

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Print alarm or CEL list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Filter | Filter |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Export alarms

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Export alarms

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Filter | Filter |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Open help

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Open help

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | CHMFile | CHMFile |
VT_BSTR | HTMFile | HTMFile |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Reload

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Reload

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BOOL | IsAll | IsAll |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Switch palette

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Switch palette

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | PaletteName | Palette name | Name der Farbpalette. Default: Color palette plus Indexnummer, z. B.: Color palette 1 Mehr im Online-Handbuch.
VT_BOOL | IsDialogRT | IsDialogRT | "Displays the printer selection dialog in the runtime, if set TRUE."
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Language change

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Language change

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | FileName | FileName |
VT_BSTR | FontList | FontList |
VT_BSTR | FileDirectory | FileDirectory |
VT_BSTR | MediaDirectory | MediaDirectory |
VT_BSTR | HelpDirectory | HelpDirectory |
VT_BSTR | GraphicsDirectory | GraphicsDirectory |
VT_BSTR | RDLDirectory | RDLDirectory |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Index archive

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Index archive

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | ArvName | ArvName |
VT_BOOL | ArvBackup | @Use backup folder@ |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


List of active archives

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> List of active archives

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | ArvName | ArvName |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


CD_CArchivExportFilter

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CD_CArchivExportFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BOOL | IsUnicode | IsUnicode |
VT_BSTR | Name | Name |
VT_BSTR | ArvName | ArvName |
VT_BSTR | Format | Format |
VT_BOOL | IsFilterRT | IsFilterRT |
VT_BOOL | IsMatchCase | IsMatchCase |
VT_UI1 | Backup | Backup |
VT_BSTR | ResString | ResString |
VT_BSTR | Database | Database |
VT_BSTR | DBTable | DBTable |
More... | TimeFilter | TimeFilter |


Export archive

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Export archive

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Filter | Filter |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.


Base function

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Base function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Screen switch function

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Screen switch function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | PictSwitch | PictSwitch |
VT_BSTR | Picture | Picture | Gets or sets the name of the switching picture.
VT_UI4 | WndType | WndType | Only users with the appropriate user authorization can edit entries in the database of the Industrial Performance Analyzer (IPA).
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CD_CSetFocus

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CD_CSetFocus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_I2 | Direction | Direction |
VT_BOOL | IsOnElement | IsOnElement |
VT_BSTR | IsElementName | IsElementName |


Focus set

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Focus set

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Focus | Focus |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Show menu

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Show menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_I2 | ActionType | ActionType | "Gets or sets the action that should be executed. 0 = Show menu (specified by ""MenuName"") 1 = Hide menu 2 = Change menu (specified by ""MenuName"") 3 = If no menu exists, then show menu specified by ""MenuName"""
VT_BOOL | FilterInRT | FilterInRT | "Shows the dialog in the runtime, if set TRUE."
VT_BSTR | MenuName | MenuName | Gets or sets the name of the menu as string.
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CDBildMittelPunktPara

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CDBildMittelPunktPara

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_I2 | Type | Type | "Specifies the centering method: 0 = Centering deactivated 1 = Set desired center via an object (DynProperty ""Station"") 3 = Set desired center via coordinates (DynProperties ""X"" and ""Y"") "
VT_BSTR | Station | Station | "Name of the object, which should be the reference for the new center. Hint: Only available, if DynProperty ""Type"" is set to 1."
VT_I2 | X | X | "X coordinate of the new center. Hint: Only available, if DynProperty ""Type"" is set to 3."
VT_I2 | Y | Y | "Y coordinate of the new center. Hint: Only available, if DynProperty ""Type"" is set to 3."
VT_I2 | ZoomType | ZoomType | "Specifies the zoom method: 0 = Zoom deactivated 1 = Set desired zoom factor in percent (DynProperty ""ZoomPercent"") 3 = Set desired zoom factor via the defined zoom steps (DynProperty ""ZoomLevel"") "
VT_I2 | ZoomPercent | ZoomPercent | "Specifies the zoom factor in percent. Hint: Only available, if DynProperty ""ZoomType"" is set to 1."
VT_I2 | ZoomLevel | ZoomLevel | "Specifies the zoom steps. Hint: Only available, if DynProperty ""ZoomType"" is set to 3."


Screen.center

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Screen.center

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | PictSwitch | PictSwitch |
More... | MidParameter | MidParameter | Parameters for centering and zooming
VT_BSTR | Picture | Picture | Specifies the GUID of the picture that should be centered and/or zoomed.
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Monitor assign

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Monitor assign

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_I2 | SrcNum | SrcNum |
VT_I2 | DstNum | DstNum |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


COverviewInfo

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> COverviewInfo

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_I2 | Type | Type | "Selects, if monitors or templates are shown as frames in the overview window: 0 = Templates 1 = Montiors "
VT_I2 | Action | Action | "The function can display, toggle or close the overview window: 0 = Display 1 = Toggle 2 = Close "
VT_UI4 | Style | Style | Specifies the style settings for the overview window: Hint: Multiple style settings have to be combined by ORing (Logical OR).
VT_UI4 | Color1 | Color1 | Specifies the background color of the overview picture.
VT_UI4 | Color2 | Color2 | Specifies the color of the current view.
VT_UI4 | Color3 | Color3 | Specifies the frame color.
VT_UI4 | Color4 | Color4 | Specifies the selection color.
VT_I4 | PosLeft | PosLeft | Specifies the left position of the overview window on the screen (in pixel).
VT_I4 | PosTop | PosTop | Specifies the top position of the overview window on the screen (in pixel).
VT_I4 | PosRight | PosRight | Specifies the right position of the overview window on the screen (in pixel).
VT_I4 | PosBottom | PosBottom | Specifies the bottom position of the overview window on the screen (in pixel).


Overview window function

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Overview window function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | OverviewInfo | OverviewInfo | Properties for the overview window
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Screen with index

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Screen with index

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Variable | Variable |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Screen return

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Screen return

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Templates | Templates |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Call SAP function

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Call SAP function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_UI4 | FunctionId | Function number |
VT_BOOL | IsDialogRT | IsDialogRT | "Displays the printer selection dialog in the runtime, if set TRUE."
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CPlantStatusVar

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CPlantStatusVar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Plants | Plants |
ZT_VARIABLE | ProjectVar | ProjectVar |


Check maintanances

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Check maintanances

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_UI4 | TimeSpan | TimeSpan |
More... | VarList | VarList |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CDiagram

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CDiagram

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_UI4 | DelayRefresh | DelayRefresh |
VT_UI4 | XYStart | XYStart |
VT_I4 | BordLeft | BordLeft | Distance between the lower edge of the control element and the X-axis (Origin 0%-Y-axis) ATTENTION: Room for the left-hand side labelling of the Y-axis for the configured user defined font.
VT_I4 | BordTop | BordTop | Distance between the upper edge of the control element and the trend curves represented inside it. ATTENTION: Room for later optional showing of stored details with active pointer.
VT_I4 | BordRight | BordRight | Distance between the lower edge of the control element and the X-axis (Origin 100%-Y-axis) ATTENTION: Room for the right-hand side labelling of the Y-axis for the configured user defined font.
VT_I4 | BordBottom | BordBottom | Distance between the lower edge of the control element and the X-axis (Origin 0%-Y-axis) ATTENTION: Room for two-line labelling of the X-axis for the configured user defined font.
VT_I2 | ScrollWidth | ScrollWidth | "Specifies the screen scrolling, if the right edge of the diagram has been reached. ATTENTION: Only for diagrams with online values."
VT_R4 | RefreshRate | RefreshRate | Definition of the screen updating in seconds. Minimum: 0.1
VT_UI4 | HGColor | HGColor | Background colour of the displayed graphics.
VT_UI4 | GridColor | GridColor | Color of the overlaying grid.
VT_I2 | DateWidth | DateWidth | Column width for the time stamp in the legend.
VT_I2 | VarWidth | VarWidth | Column width for the variable name in the legend.
VT_I2 | ValueWidth | ValueWidth | Column width for the variable value in the legend.
VT_I2 | UnitsWidth | UnitsWidth | Column width for the unit in the legend.
VT_I2 | StateWidth | StateWidth | "Column width for the condition in the legend. Hint: Activation/deactivation of the condition with ""IsStateAct""."
VT_I2 | StatusWidth | StatusWidth | "Column width for the status in the legend. Hint: Activation/deactivation of the status with DynProperty ""IsStatusAct""."
VT_I2 | MinWidth | MinWidth | "Column width for the minimum of the variable value in the displayed time period in the legend. Hint: Activation/deactivation of the minimum with DynProperty ""IsMinAct""."
VT_I2 | MWWidth | MWWidth | "Column width for the mean value of the variable value in the displayed time period in the legend. Hint: Activation/deactivation of the mean value with DynProperty ""IsMWAct"". "
VT_I2 | MaxWidth | MaxWidth | "Column width for the maximum of the variable value in the displayed time period in the legend. Hint: Activation/deactivation of the maximum with DynProperty ""IsMaxAct""."
VT_BOOL | IsStateAct | IsStateAct | "Activation (TRUE) / deactivation (FALSE) of DynProperty ""StateWidth""."
VT_BOOL | IsStatusAct | IsStatusAct | "Activation (TRUE) / deactivation (FALSE) of DynProperty ""StatusWidth""."
VT_BOOL | IsMinAct | IsMinAct | "Activation (TRUE) / deactivation (FALSE) of DynProperty ""MinWidth""."
VT_BOOL | IsMWAct | IsMWAct | "Activation (TRUE) / deactivation (FALSE) of DynProperty ""MWWidth""."
VT_BOOL | IsMaxAct | IsMaxAct | "Activation (TRUE) / deactivation (FALSE) of DynProperty ""MaxWidth""."
VT_UI2 | Font | Font | Selection or setting of the user defined font for the axis labels and the value indicators.
VT_BOOL | IsArchive | IsArchive |
VT_I2 | DataSource | DataSource |
VT_BOOL | IsBorder | IsBorder |
VT_BOOL | IsExponent | IsExponent |
VT_BOOL | IsBackup | IsBackup | "Use of historic archives from the backup path, if set TRUE. Hint: Only available, if DynProperty ""IsArchive"" is set TRUE."
VT_BOOL | IsXAxis | IsXAxis | "If set TRUE, the XY (X-Axis) diagram style is used. Otherwise (FALSE) the standard XT (Time axis) representation is utilized."
VT_BSTR | Name | Name | "Freely configurable diagram name. Can be shown in the control element. If the string in the diagram name contains the character combination %c, this combination is replaced by the name of the batch(es) reaching into the defined filter during online operation. e.g. Diagram name = ""Diagram1_%C%_End"" = ""Diagram1_Batch1_End"" in the runtime"
ZT_VARIABLE | FirstCursorVar | FirstCursorVar | Description
ZT_VARIABLE | SecondCursorVar | SecondCursorVar | Description
More... | PrintData | PrintData |
More... | TimeAxe | TimeAxe |
More... | Curve | Curve |
More... | XAxe | XAxe |
VT_BOOL | IsDateAct | IsDateAct |
VT_BOOL | IsVarAct | IsVarAct |
VT_BOOL | IsValueAct | IsValueAct |
VT_BOOL | IsUnitsAct | IsUnitsAct |
VT_I2 | TimeDiffWidth | TimeDiffWidth |
VT_BOOL | IsTimeDiffAct | IsTimeDiffAct |
VT_I2 | ValueDiffWidth | ValueDiffWidth |
VT_BOOL | IsValueDiffAct | IsValueDiffAct |
VT_I2 | SumWidth | SumWidth |
VT_BOOL | IsSumAct | IsSumAct |
VT_I2 | StdDevWidth | StdDevWidth |
VT_BOOL | IsStdDevAct | IsStdDevAct |
VT_I2 | QuantityWidth | QuantityWidth |
VT_BOOL | IsQuantityAct | IsQuantityAct |
VT_BOOL | IsHeaderAct | IsHeaderAct |
VT_BOOL | IsDeltaData | IsDeltaData | Description as text.
VT_BOOL | IsSortData | IsSortData | Description as text.
VT_BOOL | IsSmartArchive | "IsSmartArchive" |
VT_BOOL | IsShowXYCross | IsShowXYCross | Description
ZT_GUID | FilterPartGUID | FilterPartGUID | Description as text.
VT_BOOL | EditableInRT | EditableInRT | Description as text.


Print trend

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Print trend

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Diagram | FileName |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


EMS

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> EMS

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | EMSNet | EMSNet |
VT_BSTR | EMSArea | EMSArea |
VT_BOOL | EMSIsGas | EMSIsGas |
VT_BSTR | EMSAlgo | EMSAlgo |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CProjektVariableProp

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CProjektVariableProp

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
ZT_VARIABLE | Title | Title | Gets or sets a variable object.


Fault location

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Fault location

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Vars | Vars |
VT_I2 | SourceID | SourceID |
ZT_COLOR | SourceColor | SourceColor |
ZT_COLOR | SourceBackground | SourceBackground |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Graph7 Heuristics

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Graph7 Heuristics

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
ZT_VARIABLE | ComBlock | ComBlock |
ZT_VARIABLE | DestVar | DestVar |
VT_BSTR | G7File | G7File |
VT_BSTR | ZuliFile | ZuliFile |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CD_CAsmFilter

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CD_CAsmFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BOOL | ShowFilter | ShowFilter |
VT_BOOL | ShowRaster | ShowRaster |
More... | DBConnection | DBConnection |
More... | SubFilter | SubFilter |
More... | ListConfig | ListConfig |
ZT_GUID | FilterPartGUID | FilterPartGUID | Description as text.
VT_BOOL | EditableInRT | EditableInRT | Description as text.


Create IPA document

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Create IPA document

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Filter | Filter |
VT_BOOL | ToFile | ToFile |
VT_BSTR | Filename | Filename |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CD_CMessageFilter

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CD_CMessageFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_UI2 | MsgType | MsgType | Defines the transfer medium for sending messages. Following message types are supported: 1 = E-Mail 3 = Telephone 4 = Paging / SMS 5 = GSM-SMS 6 = Telephone (speech)
VT_UI2 | UserType | UserType | Specifies to whom the message should be sent: 2 = Group 3 = Recipient 6 = Current shift
VT_BSTR | GUID | GUID | "Gets or sets the GUID of the group or recipient (depending on DynProperty ""UserType"") that should be informed."
ZT_VARIABLE | Var | Var | "Gets or sets a ""Variable"" object that contains the limit text, which will be added to the constant text. Hint: Only available, if DynProperty ""IsVar"" is set TRUE."
VT_BOOL | IsTextDlg | IsTextDlg | "Displays the message control dialog within the runtime, if set TRUE."
VT_BOOL | IsDynLimits | IsDynLimits | "Adds information about the violated variable to the constant text, if set TRUE. Hint: Only available, if DynProperty ""IsVar"" is set FALSE and DynProperty ""IsUseVariable"" is set TRUE."
VT_BOOL | IsUseVariable | IsUseVariable | "With this option the limit text of a defined variable or a violated variable can be added to the message, if set TRUE. Hint: Available for all message types, except option ""Telephone"" within DynProperty ""MsgType""."
VT_BSTR | ConstText | ConstText | "Specifies the constant text that will be sent or played (if option ""Telephone speech"" is selected within DynProperty ""MsgType""). ATTENTION: This property always requires an entry, except option ""Telephone"" (not ""Telephone speech"") within DynProperty ""MsgType""."
VT_BSTR | HeaderFile | HeaderFile | "Specifies the text (""Telephone speech"") or the name of the soundfile (""Telephone"") that will be played, after getting connection to the phone of the recipient. This file should ask the recipient to enter his PIN code. If the pin is correct, the specified text within DynProperty ""ConstText"" (option ""Telephone speech"") or the soundfile specified within DynProperty ""WaveFile"" (option ""Telephone"") is played. Otherwise, the text or file specified within ""ErrorFile"" (both options ""Telephone speech"" and ""Telephone"") is played. Hint: This property is only available for the options ""Telephone"" and ""Telephone speech"" within DynProperty ""MsgType""."
VT_BSTR | WaveFile | WaveFile | "Specifies the name of the soundfile that will be played, if the correct pin was entered. Hint: This property is only available for the option ""Telephone"" within DynProperty ""MsgType""."
VT_BSTR | ErrorFile | ErrorFile | "Specifies the text (""Telephone speech"") or the name of the soundfile (""Telephone"") that will be played, if the wrong pin was entered. Hint: This property is only available for the options ""Telephone"" and ""Telephone speech"" within DynProperty ""MsgType""."
VT_BOOL | IsResign | IsResign | "For security purposes, it is often necessary to acknowledge sent messages. If this property is set true, acknowledging will be activated. ATTENTION: For options ""Telephone"" and ""Telephone speech"" (see DynProperty ""MsgType""), this property has always to be activated."
VT_I2 | ResignTime | ResignTime | "The property defines, how long the Message Control waits for the acknowledging of the recipient, before his replacement is informed. If no replacement is entered, an corresponding entry in the CEL is generated. "
VT_I4 | OldUserId | OldUserId |
VT_BSTR | AcknowledgeFunctions | AcknowledgeFunctions |
VT_BSTR | NegativeAcknowledgeFunctions | NegativeAcknowledgeFunctions |
VT_BSTR | AcknowledgeTimeOutFunctions | AcknowledgeTimeOutFunctions |
VT_UI2 | MsgTypeStyle | MsgTypeStyle |
VT_BOOL | DestinationFromVariable | DestinationFromVariable |
ZT_VARIABLE | DestinationVar | DestinationVar |
VT_BSTR | AckCode | AckCode |
VT_BSTR | NackCode | NackCode |
VT_BOOL | UseFuncCodes | UseFuncCodes |
ZT_VARIABLE | AttachmentVar | AttachmentVar |
VT_BOOL | AttachmentFromVar | AttachmentFromVar |
VT_BSTR | AttachmentName | AttachmentName |
VT_BSTR | MessageContent | MessageContent |


Send message

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Send message

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Filter | Filter | Message control settings
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CSystemModelFilter

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CSystemModelFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Suppress message function

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Suppress message function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Classes | Classes |
VT_BSTR | Groups | Groups |
VT_BSTR | Areas | Areas |
More... | SystemModelGroupFilter | SystemModelGroupFilter |
VT_BOOL | Activate | Activate |
VT_BOOL | IsFilterRT | IsFilterRT |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Client simulatio

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Client simulatio

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_I4 | SimulCmd | Type of simulation |
VT_BSTR | SimulName | Simulation image name |
VT_BOOL | SimulRtDlg | Show this dialog in Runtime |
VT_BOOL | SimulErrMsg | Show error message in the Runtime |
VT_BOOL | SimulWait4All | Wait for all variables | Description as text.
VT_I4 | SimulMaxWait | Maximum waiting time |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CD_CFktToken

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CD_CFktToken

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_I2 | Token | Token |


Authorization in network

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Authorization in network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Token | Token |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CFktNetzRudundanzUmschaltung

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CFktNetzRudundanzUmschaltung

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_I2 | SwitchDirection | "SwitchDirection" |
VT_UI2 | DetectionOffTime | "DetectionOffTime" |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Toggle online printing

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Toggle online printing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_UI1 | Action | Action | "Sets online printing (e.g. for unmanned stations) to a processing status (switch on, switch off, active/inactive). 0 = Active/Inactive 1 = On 2 = Off "
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Switch online printer

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Switch online printer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BOOL | IsDialogRT | IsDialogRT | "Displays the printer selection dialog in the runtime, if set TRUE."
VT_BSTR | Printer | Printer | Gets or sets the name of the printer.
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CFPUserEventFilter

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CFPUserEventFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | EventID | EventID |


PFS event

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> PFS event

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Filter | Filter |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Login without password

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Login without password

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Alias | Alias | Sets or returns the name of the user for the login.
VT_BOOL | Userflag | Userflag |
ZT_VARIABLE | Variable | Variable |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CReportViewerFilter

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CReportViewerFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | RDLFile | RDLFile |
More... | TimeFilter | TimeFilterIdx |
More... | DataSet | DataSet |
More... | RTMDIFilterScreen | RTMDIFilterScreen | Description as text.
More... | BatchFilter | BatchFilter | Description as text.
VT_I4 | Fct_RenderDo | Fct_RenderDo | Description as text.
VT_BOOL | Fct_NameFromVar | Fct_NameFromVar | Description as text.
VT_BSTR | Fct_Filename | Fct_Filename | Description as text.
ZT_VARIABLE | Fct_Variable | Fct_Variable | Description as text.
VT_BOOL | Fct_OverwriteFile | Fct_OverwriteFile | Description as text.
ZT_GUID | FilterPartGUID | FilterPartGUID | Description as text.
VT_BOOL | EditableInRT | EditableInRT | Description as text.


Print report function

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Print report function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Filter | Filter | Description as text.
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Recipegroup

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Recipegroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | RecipeName | RecipeName | Gets or sets the name of the recipe that should be executed.
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CRezeptFilter

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CRezeptFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | StrPar1 | StrPar1 |
VT_BSTR | StrPar2 | StrPar2 |
VT_BSTR | StrPar3 | StrPar3 |
VT_BSTR | StrPar4 | StrPar4 |
VT_BSTR | StrPar5 | StrPar5 |
VT_UI4 | DWPar1 | DWPar1 |
VT_UI4 | DWPar2 | DWPar2 |
VT_UI4 | DWPar3 | DWPar3 |
VT_UI4 | DWPar4 | DWPar4 |
VT_UI4 | DWPar5 | DWPar5 |
VT_UI4 | ExportExt | ExportExt | Defines the import/export format for the recipe file. 0 = Text file (TXT)
ZT_VARIABLE | FileNameVar | FileNameVar | "Defines the name of the variable which contains the name for the import/export (DynProperty ""Modus"" options 3 and 4)."
VT_BSTR | ExportFile | ExportFile | Defines the path and the name of the import/export file.
VT_I2 | IsAutoName | IsAutoName | "If set TRUE, a name for the export file (DynProperty ""Modus"" option 3) will be automatically generated."
VT_BOOL | IsWithFormat | IsWithFormat |
VT_BSTR | FormatFile | FormatFile |
VT_BSTR | PictName | PictName |
VT_UI4 | Modus | Modus | Defines the recipe mode. 0 = Execute recipe 1 = Duplicate and teach 2 = Read recipe 3 = Export recipe 4 = Import recipe 5 = Duplicate
VT_BSTR | ProjectName | ProjectName | Description as text.
VT_BSTR | RecGroup | RecGroup | Specifies the name of the recipe group which contains the utilized RGM recipe.
VT_BOOL | WithGrpVar | WithGrpVar |
VT_BOOL | ImportGroupName | ImportGroupName | Description as text.
ZT_VARIABLE | GrpVar | GrpVar |
VT_BSTR | Recipe | Recipe | Specifies the name of the recipe that should be operated. ATTENTION: The name of the recipe has to be the exact name of an existing RGM recipe.
VT_UI4 | RecNumber | RecNumber |
VT_UI4 | WithNumber | WithNumber | Specifies it the recipe should be selected with a variable. 0 = No recipe selection 1 = Recipe selection with variable
ZT_VARIABLE | RecVar | RecVar | "Gets or sets a variable (""Variable"" object) that should be used, in order to select the recipe by name or number. "
VT_BOOL | IsRecNumName | IsRecNumName | "Specifies if the assigned variable contains the number (FALSE) or the name (TRUE) of the recipe. Hint: This property is only available, if DynProperty ""WithNumber"" specifies that the recipe selection is done via a variable."
VT_BOOL | VersionVarOn | VersionVarOn | Description as text.
ZT_VARIABLE | VersionVar | VersionVarOn | Description as text.
VT_UI4 | Version | Version |
VT_BOOL | StatusVarOn | StatusVarOn | Description as text.
ZT_VARIABLE | StatusVar | StatusVarOn | Description as text.
VT_UI4 | Status | Status |
VT_BOOL | TargetRecipeVarOn | TargetRecipeVarOn | Description as text.
VT_BSTR | TargetRecipe | TargetRecipe | "Defines the name of the target recipe to which should be copied. Hint: Only available for DynProperty ""Modus"" option 5 (""Duplicate"")."
ZT_VARIABLE | TargetRecipeVar | TargetRecipeVar |
VT_BOOL | TargetVersionVarOn | TargetVersionVarOn | Description as text.
VT_UI4 | TargetVersion | TargetVersionVarOn | Description as text.
ZT_VARIABLE | TargetVersionVar | TargetVersionVar |
VT_BOOL | TargetStatusVarOn | TargetStatusVarOn | Description as text.
VT_UI4 | TargetStatus | TargetStatusVarOn | Description as text.
ZT_VARIABLE | TargetStatusVar | TargetStatusVar |
VT_BOOL | FilterVarOn | FilterVarOn | Description as text.
VT_BSTR | FilterText | FilterText | this property defines the filter to open the RGM picture with in the runtime. Only variables with this Filtertext set will be shown.
ZT_VARIABLE | FilterVar | FilterVar | This property defines which string variable will be used to open the RGM picture. The string in this variable will be used to show only the variables with this Filtertext.
VT_BOOL | IsFilterRT | IsFilterRT | "Displays the recipe configuration dialog within the runtime, if set TRUE."
VT_BOOL | IsReadOnly | IsReadOnly | "If set TRUE, this property only allows the selection of a recipe within the runtime, but unlike ""IsRecOnly"" no recipe configuration is allowed. Hint: Only available, if DynProperty ""IsFilterRT"" is set TRUE."
VT_BOOL | IsRecOnly | IsRecOnly | "If set TRUE, this property only allows the selection of a recipe within the runtime. Hint: Only available, if DynProperty ""IsFilterRT"" is set TRUE."
VT_I4 | ColWidth_VarName | ColWidth_VarName |
VT_BSTR | ColText_VarName | ColText_VarName |
VT_I4 | ColWidth_Min | ColWidth_Min |
VT_BSTR | ColText_Min | ColText_Min |
VT_I4 | ColWidth_Max | ColWidth_Max |
VT_BSTR | ColText_Max | ColText_Max |
VT_I4 | ColWidth_Mode | ColWidth_Mode |
VT_BSTR | ColText_Mode | ColText_Mode |
VT_I4 | ColWidth_Value | ColWidth_Value |
VT_BSTR | ColText_Value | ColText_Value |
VT_I4 | ColWidth_Unit | ColWidth_Unit |
VT_BSTR | ColText_Unit | ColText_Unit |
VT_I4 | ColWidth_Symbolism | ColWidth_Symbolism |
VT_BSTR | ColText_Symbolism | ColText_Symbolism |
VT_I4 | ColWidth_ActVal | ColWidth_ActVal |
VT_BSTR | ColText_ActVal | ColText_ActVal |
VT_I4 | ColWidth_ResLabel | ColWidth_ResLabel |
VT_BSTR | ColText_ResLabel | ColText_ResLabel |
VT_I4 | ColWidth_Identifier | ColWidth_Identifier |
VT_BSTR | ColText_Identifier | ColText_Identifier |
VT_I4 | ColWidth_Filter | ColWidth_Filter |
VT_BSTR | ColText_Filter | ColText_Filter |
VT_BSTR | ColOrder | ColOrderAll |
VT_BSTR | ColOrderAll | ColOrderAll |
VT_BOOL | ShowRowNr | ShowRowNr |
VT_BOOL | XMLExpOverwriteFile | XMLExpOverwriteFile |
VT_BOOL | XMLImpOverwriteRecipe | XMLImpOverwriteRecipe |
More... | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.
More... | TextFilter | TextFilter |


Recipegroup manager

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Recipegroup manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Filter | Filter |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Standard recipe

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Standard recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Filter | Filter |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Runtime profiles

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Runtime profiles

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_I4 | Modus | Modus |
VT_I4 | LoadModus | LoadModus |
VT_I4 | SaveModus | SaveModus |
VT_BSTR | LoadName | LoadName |
VT_BSTR | SaveName | SaveName |
ZT_VARIABLE | LoadVar | LoadVar |
ZT_VARIABLE | SaveVar | SaveVar |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


SAT command activation

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> SAT command activation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_I2 | Mode | Mode |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Save remanent data

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Save remanent data

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BOOL | SaveCEL | SaveCEL |
VT_BOOL | SaveAML | SaveAML |
VT_BOOL | SaveSYMA | SaveSYMA |
VT_BOOL | SaveIDrv | SaveIDrv |
VT_BOOL | SaveZDrv | SaveZDrv |
VT_BOOL | SaveEnergy | SaveEnergy |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Script execute select online

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Script execute select online

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Script | Script | Gets or sets the name of the script that should be executed.
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Start SEA

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Start SEA

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | SwitchingSequence | SwitchingSequence |
VT_BSTR | SEAParams | SEAParams |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Setpoint

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Setpoint

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_UI2 | SubmitAndCloseWnd | SubmitAndCloseWnd |
VT_BSTR | SetpointSetting | SetpointSetting |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CD_CTabellenFilter

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CD_CTabellenFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | TableFile | TableFile | Specifies the name of the report file.
VT_BSTR | ExportFile | ExportFile |
VT_BOOL | IsFilterRT | IsFilterRT | "Displays the report filter configuration dialog within the runtime, if set TRUE."
VT_BOOL | IsReadOnly | IsReadOnly | "Allows no modifications to the file, if set TRUE."
VT_BOOL | IsCancel | IsCancel |
VT_BOOL | IsAutoName | IsAutoName |
VT_BOOL | IsBackup | IsBackup | "Reads archive from backup path, if set TRUE."
VT_UI2 | Extension | Extension |
VT_BSTR | StrPar1 | StrPar1 | First string transfer parameter for text markers.
VT_BSTR | StrPar2 | StrPar2 | Second string transfer parameter for text markers.
VT_BSTR | StrPar3 | StrPar3 | Third string transfer parameter for text markers.
VT_BSTR | StrPar4 | StrPar4 | Fourth string transfer parameter for text markers.
VT_BSTR | StrPar5 | StrPar5 | Fifth string transfer parameter for text markers.
VT_UI4 | DWPar1 | DWPar1 | First doubleword transfer parameter for value markers.
VT_UI4 | DWPar2 | DWPar2 | Second doubleword transfer parameter for value markers.
VT_UI4 | DWPar3 | DWPar3 | Third doubleword transfer parameter for value markers.
VT_UI4 | DWPar4 | DWPar4 | Fourth doubleword transfer parameter for value markers.
VT_UI4 | DWPar5 | DWPar5 | Fifth doubleword transfer parameter for value markers.
VT_BSTR | ResString | ResString |
More... | TimeFilter | TimeFilter | Time filter settings
ZT_GUID | FilterPartGUID | FilterPartGUID | Description as text.
VT_BOOL | EditableInRT | EditableInRT | Description as text.


Report execute

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Report execute

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Filter | Filter |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Earth fault topology

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Earth fault topology

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CLoadSheddingVerbraucher

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CLoadSheddingVerbraucher

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
ZT_VARIABLE | ConsumerVar | ConsumerVar | Description as text.
ZT_VARIABLE | ValueVar | ValueVar | Description as text.
ZT_VARIABLE | IBitVar | IBitVar | Description as text.


Shedding load topology

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Shedding load topology

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | SourceVar | SourceVar | Description as text.
More... | Consumer | Consumer | Description as text.
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Unit switch

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Unit switch

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | PrimaryUnits | PrimaryUnits |
VT_BSTR | ActiveSecondaryUnits | ActiveSecondaryUnits |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CExportInitStrukt

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CExportInitStrukt

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BOOL | IsUniText | IsUniText | "Exports the file in unicode characters if set TRUE. Hint: Only available for the ASCII export option specified by the ""Format"" DynProperty."
VT_I2 | Format | Format | Specifies the output format. 0 = dBase IV (*.DBF) 1 = XML (*.xml) 2 = ASCII (*.TXT)
VT_I2 | InitVal | InitVal | "For the HD values, a ring buffer is filled and stored. Active (TRUE): The ring buffer is initialised for the export Inactive (FALSE): The ring buffer is kept for the export"
VT_I2 | Type | Type |
VT_BSTR | AppName | AppName | Specifies the name of the project.
VT_BSTR | FileName | FileName | Specifies the name of the file that should be exported. ATTENTION: Only filnames with up to 8 characters are allowed.
More... | Vars | Vars | "Creates, accesses and modifies the variables which should be exported. Returns a ""Variable"" object. Hint: ""ExportStruct.Vars[-1]"" returns the amount of variables."


Export data function

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Export data function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | ExportStruct | ExportStruct | Defines the export settings
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Read dBase file

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Read dBase file

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | FileName | FileName | Gets or sets the path of the database file that should be read.
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CFormatInfo

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CFormatInfo

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | FormatFile | FormatFile | Defines the path and name of the format file for the print.
VT_UI4 | Font | Font | "Defines the font that is utilized for the print. The parameter that is passed, is the index of the font within the specified font list. 0 = Standard font 1 = Default font 1 5 = Default font 5 6 = User defined font 1 "
VT_BOOL | IsCancel | IsCancel | "Displays the cancel dialog, if set true. Otherwise the dialog is hidden and the print can't be stopped by means of the program."


Print actual values function

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Print actual values function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | FormatInfo | FormatInfo | Defines the parameters for the print
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CFktSwNeu

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CFktSwNeu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_R8 | NumValue | NumValue | Value of numerical variables which will be issued. ATTENTION: For boolean variables only following values can be set ... 0 = LOW (0) 1 = HIGH (0) 2 = TOGGLE (Value of variable is switched to complementary status)
VT_BSTR | StrValue | StrValue | Value of alphanumerical variables which will be issued.
VT_R8 | Minimum | Minimum | "Specifies the minimum limit of the value. Hint: Only available, if DynProperty ""IsVarLimit"" is set to FALSE."
VT_R8 | Maximum | Maximum | "Specifies the maximum limit of the value. Hint: Only available, if DynProperty ""IsVarLimit"" is set to FALSE."
VT_UI2 | Command | Command |
VT_BOOL | IsDirect | IsDirect | "Active (TRUE): After activating the function, the value is directly sent to the hardware, not asking for a further confirmation. Inactive (FALSE): Before sending the value to the hardware, the set value dialog is opened and the user can change the settings within the Runtime."
VT_BOOL | IsVarLimit | IsVarLimit | "If this property is TRUE, the set value limits are taken from the variable definition. Otherwise (FALSE), the value limits can be defined directly by means of the DynProperties ""Minimum"" and ""Maximum""."
VT_BOOL | IsCurValue | IsCurValue | "Active (TRUE): The value is read from the hardware and then is proposed as a default or directly sent to the hardware. Additionally for numerical variables, the DynProperty ""NumValue"" becomes a new function, as the value entered there is added to the default (subtracted if negative value). Inactive (FALSE): The value defined under DynProperty ""NumValue"" is proposed as a default or directly sent to the hardware."
VT_UI1 | Setting | Setting | "Send value with (in online operation): 0 = Standard dialog box of the control system 1 = External program provided by the user Hint: This property is only available, if DynProperty ""IsDirect"" is set to FALSE."
ZT_VARIABLE | Variable | Variable | "Gets or sets the ""Variable"" object which should be (or is already) linked to the function."
VT_BSTR | PrgName | PrgName | "Specifies the path and the name of the program (plus its file extension) which should be executed, if option 1 within DynProperty ""Setting"" is set."
VT_BOOL | IsWriteSync | IsWriteSync | "Active (TRUE): Executing the function is not finished, before a positive confirmation of the writing action is received or the fixly defined timeout of 30 seconds is over. In scripts this can make sure, that the following function is not started, before this one is finished. The confirmation can also be evaluated with the status bit WR-SUC . Inactive (FALSE): Do not wait for the writing confirmation. "


Send value to hardware

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Send value to hardware

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | SetValue | SetValue |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CTreiberCommand

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CTreiberCommand

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BOOL | IsFilterRT | IsFilterRT |
VT_UI4 | DrvIndex | DrvIndex |
VT_UI2 | Command | Command |
VT_BSTR | UsrCommand | UsrCommand |
VT_BSTR | ResString | ResString |


Driver commands

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Driver commands

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Command | Command |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CUhrzeit

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CUhrzeit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
ZT_VARIABLE | Variable | Variable |


Read Write time variable

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Read Write time variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Time | Time |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CD_CVbaMacroFilter

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CD_CVbaMacroFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | MacroName | MacroName | Specifies the name of the macro that should be executed.
VT_BOOL | IsBreakOnError | IsBreakOnError |
VT_UI2 | Info | Info |
VT_BSTR | ProjectName | ProjectName |
More... | Parameters | Parameters |


VBA execute macro

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> VBA execute macro

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Filter | Filter |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


VSTA execute macro

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> VSTA execute macro

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | MacroName | MacroName |
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Play sound file

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Play sound file

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | FileName | FileName | "Gets or sets the path of the program that should be executed. Hint: Addtitional parameters can be passed with the ""FilePar"" DynProperty."
VT_BSTR | FilePar | FilePar | "Gets or sets the parameters for the program that is executed (specified by the ""FileName"" DynProperty)."
VT_BOOL | IsDialogRT | IsDialogRT | "Displays the program and parameter selection dialog within the runtime, if set TRUE."
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CDateiOperationParameter

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CDateiOperationParameter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_UI2 | Modus | Modus | sets the mode for the file-operation function 0 = Copy 1 = Move 2 = Delete
VT_I2 | Days | Days | "Sets the number of ""not older than""-days x for the time-filter of the file operation function."
VT_I2 | Hours | Hours | "Sets the number of ""not older than""-hours x for the time-filter of the file operation function."
VT_BOOL | IsYounger | IsYounger | "sets the ""not older than"" option for the time filter at the file operation function active (TRUE) or not (False)"
VT_BOOL | IsOverwrite | IsOverwrite | should files be overwritten at the file-operation function (move and copy mode) (TRUE) or not (FALSE). Read-only files are not overwritten regardless of this checkbox.
VT_BOOL | IsErrorMsg | IsErrorMsg | should an error message be displayed in the runtime if the file-operation function could not be executed successfully (TRUE) or not (FALSE)
VT_BOOL | IsTimeCond | IsTimeCond | should the file-operation function be executed regardless of the filedate (FALSE) or consider the filedate set at the time-filter (TRUE)
VT_BOOL | IsFilterRT | IsFilterRT | should the dialog for the file operation function be displayed in the runtime prior to execution (TRUE) or not (FALSE)
VT_BSTR | Source | Source | "sets the source path and / or filename for the file-operation function. Depending on the ""Parameter.Modus"", either: an absolute path (Modus=0, e.g. ""c:\hugo.txt"") or a relative path / filename (Modus=1 / Modus = 2, e.g. ""\hugo.txt"") should be used"
VT_BSTR | Destination | Destination | "sets the destination path and / or filename for the file-operation function. Depending on the ""Parameter.Modus"", either: an absolute path (Modus=0, e.g. ""c:\hugo.txt"") or a relative path / filename (Modus=1 / Modus = 2, e.g. ""\hugo.txt"") should be used"
VT_BOOL | Recursive | Recursive | should also subdirectories be taken in account at the file-operation function (TRUE) or not (FALSE)
VT_BOOL | IsOlder | IsOlder | "sets the ""not younger than"" option for the time filter at the file operation function active (TRUE) or not (False)"
VT_UI2 | SrcPathModus | SrcPathModus | sets the source-path mode for the file-operation function. 0 = absolute path 1 = relative path starting from the project runtime directory 2 = relative path starting from the project runtime data directory (directoryname equal to the PC name)
VT_UI2 | DstPathModus | DstPathModus | sets the destination-path mode for the file-operation function. 0 = absolute path 1 = relative path starting from the project runtime directory 2 = relative path starting from the project runtime data directory (directoryname equal to the PC name)
VT_I2 | OlderDays | OlderDays | "Sets the number of ""not younger than""-days x for the time-filter of the file operation function."
VT_I2 | OlderHours | OlderHours | "Sets the number of ""not younger than""-hours x for the time-filter of the file operation function."


File operations

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> File operations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Parameter | Parameter | Specifies parameters for the file operations
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CHardCopyPrintInfo

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> CHardCopyPrintInfo

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Picture | Picture | "Specifies the template that is utilized for the hardcopy. Hint: This property is only considered, if the ""IsScreen"" DynProperty is set to FALSE."
VT_BOOL | IsScreen | IsScreen | "If set TRUE the whole screen will be incorporated for the hardcopy. Otherwise (FALSE) the template specified in the ""Picture"" DynProperty will be consulted for the hardcopy."
VT_BOOL | IsOffset | IsOffset | "If set TRUE, the hardcopy will be printed with a margin."
VT_BOOL | IsInvert | IsInvert | "If set TRUE, the hardcopy will be inverted."
VT_BOOL | IsFax | IsFax | "If set TRUE, the hardcopy will routed to a facsimile."
VT_I2 | Monitor | Monitor | "Monitor Id, only relevant if multi monitor solutions are used."


Print a hard copy function

Manual -> Programming interfaces -> Objectmodel -> RtFunction -> RtFunction-Dynamic properties -> Print a hard copy function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Info | Info | Specifies parameters for the hardcopy
VT_BSTR | Name | Name | Unique description of the function. The description is issued when a function is created by the system, but can be subsequently amended if the new description is not already being used for another function. Maximum: 128 character. Default: Function_x ( x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_FKTPARAM | Parameters | Parameter | Transfer parameters of the function; depends on the type of function. Click on the ... button Opens the dialog to select the switching direction and the suppression time. The corresponding parameter dialog is opened depending on the type of the function. More in the online help.
VT_BOOL | IsActual | Current computer | Only available in network projects: The function is executed on the computer on which it was instigated. More in the online help.
VT_BOOL | IsClient | Client | Only available in network projects: The function is carried out on all Clients of the project. More in the online help.
VT_BOOL | IsServer | Primary Server | Only available in network projects: The function is carried out on the primary server of the project. More in the online help.
VT_BOOL | IsStandBy | Standby Server | Only available for network projects: The function is carried out on the Standby Server of the project. More in the online help.
VT_UI4 | ID | ID | Internal unique ID of the function.
VT_UI4 | Type | Type | With this property you have the opportunity to get/set the source bit in the status routing list.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


RtFunctions

Manual -> Programming interfaces -> Objectmodel -> RtFunctions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This collection contains the defined functions. The single functions can be executed at Runtime via VBA.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

'Create Function for TREND - PICTURE
Sub CreateTrendFunction()
Dim zPIC As DynPicture
Dim zFCT As RtFunction
Dim i As Integer

Set zPIC = MyWorkspace.ActiveDocument.DynPictures.Item("TREND")
'Create new function
Set zFCT = MyWorkspace.ActiveDocument.RtFunctions.Create("picTREND", tpPicture)
'function settings...
With zFCT
.DynProperties("Picture") = zPIC.Name
i = .DynProperties("PictFilter[-1]")
If i = 0 Then .CreateDynProperty "PictFilter"
.DynProperties("PictFilter[0].RefreshRate") = 1
.DynProperties("PictFilter[0].Name") = "WIZARD TREND"
.DynProperties("PictFilter[0].IsArchive") = False
.DynProperties("PictFilter[0].IsXAxis") = False
'Add 3 CURVES
For i = 0 To 2
n = .DynProperties("PictFilter[0].Curve[-1]")
If n <= i Then
'create CURVE SubItem if needed
.CreateDynProperty ("PictFilter[0].Curve")
.CreateDynProperty ("PictFilter[0].Curve[" & i & "].VarInfo")
.CreateDynProperty ("PictFilter[0].Curve[" & i & "].YAxe")
.CreateDynProperty ("PictFilter[0].Curve[" & i & "].YAxe[0].Scale")
End If
'change curve settings
.DynProperties("PictFilter[0].Curve[" & i & "].GraphName") = "MyVariable_" & i
.DynProperties("PictFilter[0].Curve[" & i & "].HasYAxis") = True
.DynProperties("PictFilter[0].Curve[" & i & "].IsShow") = True
.DynProperties("PictFilter[0].Curve[" & i & "].IsInterpolation") = True
.DynProperties("PictFilter[0].Curve[" & i & "].VarInfo.VarName") = "MyVariable_" & i
.DynProperties("PictFilter[0].Curve[" & i & "].VarInfo.Channel") = "MyVariable_" & i
.DynProperties("PictFilter[0].Curve[" & i & "].VarInfo.Variable") = "MyVariable_" & i
.DynProperties("PictFilter[0].Curve[" & i & "].VarInfo.VarMaxValue") = 1000
.DynProperties("PictFilter[0].Curve[" & i & "].VarInfo.VarMinValue") = 0
.DynProperties("PictFilter[0].Curve[" & i & "].YAxe.IsAutoScale") = False
.DynProperties("PictFilter[0].Curve[" & i & "].YAxe.Color") = vbBlack
.DynProperties("PictFilter[0].Curve[" & i & "].YAxe.Scale.ScaleTop") = 1000
.DynProperties("PictFilter[0].Curve[" & i & "].YAxe.Scale.ScaleBotton") = 0
Next i
'filter settings (relative time 5 minutes)
.CreateDynProperty ("PictFilter[0].TimeAxe")
.DynProperties("PictFilter[0].TimeAxe.OldDiff") = 3600
.DynProperties("PictFilter[0].TimeAxe.TimeFilter.Options") = 65535
.DynProperties("PictFilter[0].TimeAxe.TimeFilter.ARVTime1") = CDate(25569.0451388889) '("01.01.1970 01:05:00")
.DynProperties("PictFilter[0].TimeAxe.TimeFilter.ARVTime2") = CDate(25569.0416666667) '("01.01.1970 01:00:00")
End With
End Sub

'Create Function for ALARM - PICTURE
Sub CreateAlarmFunction()
Dim zPIC As DynPicture
Dim zFCT As RtFunction
Dim i As Integer

Set zPIC = MyWorkspace.ActiveDocument.DynPictures.Item("ALARM")
'Create new function
Set zFCT = MyWorkspace.ActiveDocument.RtFunctions.Create("picALARM", tpPicture)
'function and filter settings...
With zFCT
.DynProperties("Picture") = zPIC.Name
i = .DynProperties("PictFilter[-1]")
If i = 0 Then .CreateDynProperty "PictFilter"
.DynProperties("PictFilter[0].VarFilter") = "*"
.DynProperties("PictFilter[0].FilterTitel") = "*"
i = .DynProperties("PictFilter[0].TimeFilter[-1]")
If i = 0 Then .CreateDynProperty "PictFilter[0].TimeFilter"
.DynProperties("PictFilter[0].TimeFilter[0].TimeFormat") = 10
.DynProperties("PictFilter[0].TimeFilter[0].Options") = 65535
.DynProperties("PictFilter[0].TimeFilter[0].ARVTime1") = CDate(25570.0416666667) '("02.01.1970 01:00:00")
.DynProperties("PictFilter[0].TimeFilter[0].ARVTime2") = CDate(25569.0416666667) '("01.01.1970 01:00:00")
i = .DynProperties("PictFilter[0].TimeFilter[0].ChargeFilter[-1]")
If i = 0 Then .CreateDynProperty "PictFilter[0].TimeFilter[0].ChargeFilter"
i = .DynProperties("PictFilter[0].TextFilter[-1]")
If i = 0 Then .CreateDynProperty "PictFilter[0].TextFilter"
i = .DynProperties("PictFilter[0].ListInfo[-1]")
If i = 0 Then .CreateDynProperty "PictFilter[0].ListInfo"
End With
End Sub

Other topics in this chapter

RtFunctions-Properties

RtFunctions-Methods

RtFunctions-Events


RtFunctions-Properties

Manual -> Programming interfaces -> Objectmodel -> RtFunctions -> RtFunctions-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Returns count of the elements | read only | read only
IProject | Parent | The parent object of the current object | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> RtFunctions -> RtFunctions-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> RtFunctions -> RtFunctions-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


RtFunctions-Methods

Manual -> Programming interfaces -> Objectmodel -> RtFunctions -> RtFunctions-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IRtFunction | Create | Creates and returns a new Object | available | not used
VARIANT_BOOL | Delete | Deletes the objects from collection | available | not used
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | Import | Imports the selected XML file | available | not used
IRtFunction | Item | Returns a object at a position or by a specified key | available | not used
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used

Other topics in this chapter

Item

Create

Delete

Export

SingleExport

Import


Item

Manual -> Programming interfaces -> Objectmodel -> RtFunctions -> RtFunctions-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the object Function from the collection, which is identified by the parameter vNameOrPos.

Datatype

Item(VARIANT vNameOrPos) As RtFunction

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

If the parameter is a numerical value, the function is searched by its index (>= 0 and <= Count-1).
If it is an alphanumerical value, the function is searched by its unique name.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vNameOrPos As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Create

Manual -> Programming interfaces -> Objectmodel -> RtFunctions -> RtFunctions-Methods -> Create

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new function and returns the new RtFunction object.

Datatype

Create(String bsName,tpFunctionTypes tpFuncType) As RtFunction

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Delete

Manual -> Programming interfaces -> Objectmodel -> RtFunctions -> RtFunctions-Methods -> Delete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deletes the RtFunjction objects from the collection.

Datatype

Delete(VARIANT vNameOrPos) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Export

Manual -> Programming interfaces -> Objectmodel -> RtFunctions -> RtFunctions-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export settings to an xml file

Datatype

Export(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to import.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


SingleExport

Manual -> Programming interfaces -> Objectmodel -> RtFunctions -> RtFunctions-Methods -> SingleExport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SingleExport(VARIANT vIndexOrName,BSTR bsFileName) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Import

Manual -> Programming interfaces -> Objectmodel -> RtFunctions -> RtFunctions-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced.

Datatype

Import(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to export.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


RtFunctions-Events

Manual -> Programming interfaces -> Objectmodel -> RtFunctions -> RtFunctions-Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
void | PreFunctionExecute | This event is fired when a function is executed and containes a copy of the function. | not used | available | yes | yes

Other topics in this chapter

PreFunctionExecute


PreFunctionExecute

Manual -> Programming interfaces -> Objectmodel -> RtFunctions -> RtFunctions-Events -> PreFunctionExecute

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event will be fired if a zenon function is called via the function list (function call via dynamic element, script, limit violation, reaction matrix, API).

This event contains a temporary copy of the called function object as a parameter (containing all information of the function), not the object from the function list itself. To get the "original" function object the .Parent method of the temporary object could be used.

Like for all other events, the parameter object is only valid in the scope of the event itself and therefore it must not be stored.

Datatype

PreFunctionExecute(IRtFunction* obFunction) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

//RtFunctions object
public zenOn.IRtFunctions myRtFcts;
//...

//Init object, create eventhandler
void ThisProject_Active()

{

myRtFcts = this.RtFunctions();

myRtFcts.PreFunctionExecute += new
zenOn.PreFunctionExecuteEventHandler(myRtFcts_PreFunctionExecute);

//...

}

//Event method

void myRtFcts_PreFunctionExecute(zenOn.IRtFunction obFunction)

{
//Output debug information

System.Diagnostics.Debug.Print("Function: \"" + obFunction.Name + "\"

executes - Function type: " + obFunction.Type.ToString());

//Do something with the object –

//Note: Object obFunction is valid only in this scope!
//...

}

//Delete eventhandler, release object
void ThisProject_Inactive()

{

myRtFcts.PreFunctionExecute -= new

zenOn.PreFunctionExecuteEventHandler(myRtFcts_PreFunctionExecute);

myRtFcts = null;

//...

}

VB.NET

VBA


SapFunction

Manual -> Programming interfaces -> Objectmodel -> SapFunction

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public WithEvents obFunReadTable As SapFunction

Public Sub ReadTable()
Dim obFunctions As SapFunctions

'Parameters
Dim obParQueryTable As SapParameter 'Input, Tablename
Dim obParDelimiter As SapParameter 'Input, Optional, Delimiter in DATA
Dim obParRowCount As SapParameter 'Input, Optional, 0 = all Rows
Dim obParRowSkip As SapParameter 'Input, Optional, 0 = from beginning
Dim obParNoData As SapParameter 'Input, Optional, "X" = read only Fielddefinitions (FIELDS)

'Tables
Dim obTabOptions As SapTable 'Input, WHERE-Clause
Dim obTabFields As SapTable 'Input/Output, Fielddefinitions
Dim obTabData As SapTable 'Output, Tabledata

Dim obRow As SapRow

Dim Error As tpSapError

' === Get Collection of Functionblocks
Set obFunctions = thisProject.SapFunctions

' === Create Functionblock "RFC_READ_TABLE" if not exists
Set obFunReadTable = obFunctions.Item("RFC_READ_TABLE")
If obFunReadTable Is Nothing Then
Set obFunReadTable = obFunctions.CreateSapFunction("RFC_READ_TABLE")
End If

' === Create Parameter if not exist
Set obParameters = obFunReadTable.Parameters 'Get Collection of Parameters
If Not obParameters Is Nothing Then

'Tablename
Set obParQueryTable = obParameters.Item("QUERY_TABLE")
If obParQueryTable Is Nothing Then
Set obParQueryTable = obParameters.CreateSapParameter("QUERY_TABLE")
End If
obParQueryTable.Value = thisProject.Variables.Item("QueryTable").Value

'Delimiter
Set obParDelimiter = obParameters.Item("DELIMITER")
If obParDelimiter Is Nothing Then
Set obParDelimiter = obParameters.CreateSapParameter("DELIMITER")
End If
obParDelimiter.Value = thisProject.Variables.Item("Delimiter").Value

'Count of Rows
Set obParRowCount = obParameters.Item("ROWCOUNT")
If obParRowCount Is Nothing Then
Set obParRowCount = obParameters.CreateSapParameter("ROWCOUNT")
End If
obParRowCount.Value = thisProject.Variables.Item("RowCount").Value

'StartRow
Set obParRowSkip = obParameters.Item("ROWSKIPS")
If obParRowSkip Is Nothing Then
Set obParRowSkip = obParameters.CreateSapParameter("ROWSKIPS")
End If
obParRowSkip.Value = thisProject.Variables.Item("RowSkips").Value

'Fields only
Set obParNoData = obParameters.Item("NO_DATA")
If obParNoData Is Nothing Then
Set obParNoData = obParameters.CreateSapParameter("NO_DATA")
End If
obParNoData.Value = thisProject.Variables.Item("NoData").Value
End If

' === Create Table if exits, either clear
Set obTables = obFunReadTable.Tables 'Get Collectin of Tables
If Not obTables Is Nothing Then

'Selections , "WHERE-Clause" (in)
Set obTabOptions = obTables.Item("OPTIONS")
If obTabOptions Is Nothing Then
Set obTabOptions = obTables.CreateSapTable("OPTIONS", False) 'Input
Else
obTabOptions.Clear
End If

'Names (in) and Structure (out) of read fields
Set obTabFields = obTables.Item("FIELDS")
If obTabFields Is Nothing Then
Set obTabFields = obTables.CreateSapTable("FIELDS", False) 'Input
Else
obTabFields.Clear
End If

'read Data (out)
Set obTabData = obTables.Item("DATA")
If obTabData Is Nothing Then
Set obTabData = obTables.CreateSapTable("DATA", False) 'Output
Else
obTabData.Clear
End If
End If

' === Call Function (asynchron), keeps the connection to the SAP-System afterwards
Error = obFunReadTable.CallAsync(True)

'>>> some zenon internals are used now in deep
'it comes back up again in "obFunReadTable_CallFinished"...

End Sub

' |
' |
' V

Private Sub obFunReadTable_CallFinished(ByVal obFunction As ISapFunction, ByVal Error As tpSapError)

'Back from zenon internals.
'This is used to avoid blocking the zenon Runtime during the Function call,
'because a function call may need some seconds to proceed...

' === Errorhandling
Call PrintError(Error, obFunReadTable.LastError)

' === check result
If Error = tpSapError_Ok Then 'no error
Dim obParameters As SapParameters
Dim obParameter As SapParameter
Dim obTables As SapTables
Dim obTable As SapTable

Dim obTabFields As SapTable 'Input
Dim obTabData As SapTable 'Output

Dim Count As Integer
Dim RowData As String

' === check Parameter and Tables
Set obTables = obFunReadTable.Tables

' === check Table "FIELDS"
Set obTabFields = obTables.Item("FIELDS")

Count = obTabFields.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1
RowData = obTabFields.Rows.Item(i).RawData
'FIELDNAME = Name of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDNAME").Value = GetNextField(RowData)
'OFFSET = Start of the Field in the Row
thisProject.Variables.Item("FIELDS_Row[" & i & "].OFFSET").Value = CInt(GetNextField(RowData))
'LENGTH = Length of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].LENGTH").Value = CInt(GetNextField(RowData))
'TYPE = Datatype of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].TYPE").Value = GetNextField(RowData)
'FIELDTEXT = description of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDTEXT").Value = GetNextField(RowData)
Next

' === check Table "DATA"
Set obTabData = obTables.Item("DATA")

Count = obTabData.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1
'One row of the table "DATA" contains only one filed with 512 characters
RowData = obTabData.Rows.Item(i).RawData
thisProject.Variables.Item("DATA_Row[" & i & "]").Value = RowData
Next
End If
End Sub

Public Sub PrintError(Error As tpSapError, LastError As String)
Dim ShortError As String

Select Case Error
Case tpSapError_No_Connection ' No connection to SAP system
ShortError = "No connection to SAP system"
Case tpSapError_Ok ' OK.
ShortError = "No Error"
Case tpSapError_Failure ' Error occurred
ShortError = "Error occurred"
Case tpSapError_Exception ' Exception raised
ShortError = "Exception raised"
Case tpSapError_Sys_Exception ' System exception raised, connection closed
ShortError = "System exception raised, connection closed"
Case tpSapError_Call ' Call received
ShortError = "Call received"
Case tpSapError_Internal_Com ' Internal communication, repeat (internal use only
ShortError = "Internal communication, repeat (internal use only)"
Case tpSapError_Closed ' Connection closed by the other side
ShortError = "Connection closed by the other side"
Case tpSapError_Retry ' No data yet (RfcListen or RfcWaitForRequest only)
ShortError = "No data yet (RfcListen or RfcWaitForRequest only)"
Case tpSapError_No_Tid ' No Transaction ID available
DError = "No Transaction ID available"
Case tpSapError_Executed ' Function already executed
ShortError = "Function already executed"
Case tpSapError_Synchronize ' Synchronous Call in Progress (only for Windows)
ShortError = "Synchronous Call in Progress (only for Windows)"
Case tpSapError_Memory_Insufficient ' Memory insufficient
ShortError = "Memory insufficient"
Case tpSapError_Version_Mismatch ' Version mismatch
ShortError = "Version mismatch"
Case tpSapError_Not_found ' Function not found (internal use only)
ShortError = "Function not found (internal use only)"
Case tpSapError_Call_Not_Supported ' This call is not supported
ShortError = "This call is not supported"
Case tpSapError_Not_Owner ' Caller does not own the specified handle
ShortError = "Caller does not own the specified handle"
Case tpSapError_Not_Initialized ' RFC not yet initialized
ShortError = "RFC not yet initialized"
Case tpSapError_System_Called ' A system call such as RFC_PING for connection test is executed
ShortError = "A system call such as RFC_PING for connection test is executed"
Case tpSapError_Invalid_Handle ' An invalid handle was passed to an API call
ShortError = "An invalid handle was passed to an API call"
Case tpSapError_Invalid_Parameter ' An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected.
ShortError = "An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected."
Case tpSapError_Canceled ' An rfc call has been canceled by user
ShortError = "An rfc call has been canceled by user"
Case tpSapError_Conversion ' An error during conversion has been d etected
ShortError = "An error during conversion has been detected"
Case tpSapError_Invalid_Protocol ' The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format
ShortError = "The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format"
Case tpSapError_Timeout ' Timeout
ShortError = "Timeout"
End Select

'Errorcode
thisProject.Variables.Item("ErrorCode").Value = Error
'Description of the Error
thisProject.Variables.Item("ShortError").Value = ShortError
'More detailed description of the last error
thisProject.Variables.Item("LastError").Value = LastError
End Sub

Public Function GetNextField(ByRef Text As String)
'Function to extract FieldValues out of a RawData string...

pos = InStr(Text, Chr$(10)) 'search for delimiter
If pos > 0 Then 'delimiter exists?
GetNextField = Left$(Text, pos - 1) 'return text until delimiter
Else 'no more delimiters
GetNextField = Text 'return string
End If
Text = Right$(Text, Len(Text) - pos) 'return text until delimiter or end - cut
End Function

Private Sub Project_Inactive()
'release object to avoid memory leaks...
thisProject.SapFunctions.DeleteSapFunction ("RFC_READ_TABLE")
End Sub

Other topics in this chapter

SapFunction-Properties

SapFunction-Methods

SapFunction-Events

SapFunction-Dynamic properties


SapFunction-Properties

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
tpSapActivity | Activity | Activity state of the function call (0 = inactive, 1 = in queue, 2 = call in progress) | available | available
tpSapError | ErrorCode | Code for result of last call | not used | read only
BSTR | ErrorText | Short text for result of last call | not used | read only
BSTR | LastError | Last Error | read only | read only
BSTR | Name | Name of the SAP function | available | available
ISapFunctions | Parent | Parent-object | available | available

Other topics in this chapter

Parent

Name

ErrorCode

ErrorText

LastError

Activity


Parent

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Parent() As SapFunctions

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


ErrorCode

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Properties -> ErrorCode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ErrorCode() As tpSapError

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


ErrorText

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Properties -> ErrorText

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ErrorText() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


LastError

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Properties -> LastError

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

LastError() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Activity

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Properties -> Activity

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the actuial activity state of the SAP function.

Datatype

Activity() As tpSapActivity

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


SapFunction-Methods

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
tpSapError | Call | Calls the SAP function synchronously | available | available
tpSapError | CallAsync | Calls the SAP function asynchronously | available | available
ISapParameters | Parameters | Returns the SAP parameters collection | available | available
ISapTables | Tables | Returns the SAP tables collection | available | available
VARIANT_BOOL | StartServer | Starts the SAP function as server program to be called from SAP | available | available
void | StopServer | Stops the server program | available | available

Other topics in this chapter

Parameters

Tables

Call

CallAsync

StartServer

StopServer


Parameters

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Methods -> Parameters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Parameters() As SapParameters

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Tables

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Methods -> Tables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Tables() As SapTables

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Call

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Methods -> Call

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Call([optional] VARIANT bReuseConnection) As tpSapError

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CallAsync

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Methods -> CallAsync

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CallAsync([optional] VARIANT bReuseConnection) As tpSapError

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


StartServer

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Methods -> StartServer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

StartServer() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


StopServer

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Methods -> StopServer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

StopServer() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


SapFunction-Events

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description |  | Editor | Runtime
void | ActivityChanged | Activity state of the function call has changed |  | not used | read only
void | CallFinished | SAP function returns from asynchronous call |  | read only | read only
void | ServerCall | Server program called by SAP | not used |  | read only

Other topics in this chapter

CallFinished

ActivityChanged

ServerCall


CallFinished

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Events -> CallFinished

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CallFinished(SapFunction obFunction, tpSapError Error) As void

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ActivityChanged

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Events -> ActivityChanged

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This events reacts on a change of the activity state of an SAP function.The Function object and the State-Value will be delivered from the event.

Datatype

ActivityChanged(SapFunction obFunction, tpSapActivity Activity) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

SAP Function as 'SapFunction' object.

Value of SAP Activity (for more details see property 'Activity')

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

obFunction As SapFunction

Activity As tpSapActivity

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub obFunReadTable_ActivityChanged(ByVal obFunction As ISapFunction,_
ByVal Activity As tpSapActivity)
thisProject.Variables.Item("ReadTableActive").Value = obFunction.Activity
End Sub


ServerCall

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Events -> ServerCall

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ServerCall(ISapFunction obFunction, tpSapError Error) As void

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


SapFunction-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

SAP function

Other topics in this chapter

SAP function


SAP function

Manual -> Programming interfaces -> Objectmodel -> SapFunction -> SapFunction-Dynamic properties -> SAP function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BSTR

Label

Function name

Freely definable label for the SAP function.

More in the online help.

VT_BSTR

Name

RFC function block

Name of the function block that was called up in the SAP system

More in the online help.

VT_BSTR

Info

Information

Freely definable short text. Only used for information. If available, it is set when a SAP function is created via the Wizard in accordance with the interface description in the SAP system.

More in the online help.

VT_BOOL

ServerPgm

Server program

Properties for the configuration of SAP functions as server programs.

More in the online help.

ZT_FUNCTION

ServerFunction

Function

Selection of a zenon function that is to be called up by the server program. Clicking on the ... button opens the dialog for Function selection.

Note: If the function is called up by another project, ensure that this project is running in Runtime.

More in the online help.

VT_UI4

Wait

Waiting period

Stipulation of a time period in milliseconds that is waited for before and after calling the linked function, so that variables can be written or read with certainty. Recommended most of all for variables on controllers with slow communication and/or slow read cycles.

  • Minimum: 0
  • Maximum: 4294967295
  • Default: 0

Recommendation:

  • Variables of the internal driver or system driver: Low values by 0 ms.
  • Mathematics driver: Values between 100 – 200 ms. (this driver is, depending on the system load, updated approximately every 100 ms.)
  • Other drivers and controllers: Values that are above the update time of the driver. Correspondingly higher if the number of variables is higher.

More in the online help.

ZT_VARIABLE

ActivityVar

Activity

Numeric variable for activity monitoring of the SAP function. Can e.g. be used for interlockings in order to prevent overlapping calls.

Possible values: 0, 1, 2

  • 0: inactive
  • 1: queued in the call queue
  • 2: call active

More in the online help.

ZT_VARIABLE

ErrorVar

Error code

Numeric variable for the error code of the function call.

More in the online help.

ZT_VARIABLE

ErrorTextVar

Error text

String variable for short description of the error which occurred lastly.

More in the online help.

ZT_VARIABLE

LastErrorVar

Error description

String variable for extensive description of the error which occurred last.

More in the online help.


SapFunctions

Manual -> Programming interfaces -> Objectmodel -> SapFunctions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public WithEvents obFunReadTable As SapFunction

Public Sub ReadTable()
Dim obFunctions As SapFunctions

'Parameters
Dim obParQueryTable As SapParameter 'Input, Tablename
Dim obParDelimiter As SapParameter 'Input, Optional, Delimiter in DATA
Dim obParRowCount As SapParameter 'Input, Optional, 0 = all Rows
Dim obParRowSkip As SapParameter 'Input, Optional, 0 = from beginning
Dim obParNoData As SapParameter 'Input, Optional, "X" = read only Fielddefinitions (FIELDS)

'Tables
Dim obTabOptions As SapTable 'Input, WHERE-Clause
Dim obTabFields As SapTable 'Input/Output, Fielddefinitions
Dim obTabData As SapTable 'Output, Tabledata

Dim obRow As SapRow

Dim Error As tpSapError

' === Get Collection of Functionblocks
Set obFunctions = thisProject.SapFunctions

' === Create Functionblock "RFC_READ_TABLE" if not exists
Set obFunReadTable = obFunctions.Item("RFC_READ_TABLE")
If obFunReadTable Is Nothing Then
Set obFunReadTable = obFunctions.CreateSapFunction("RFC_READ_TABLE")
End If

' === Create Parameter if not exist
Set obParameters = obFunReadTable.Parameters 'Get Collection of Parameters
If Not obParameters Is Nothing Then

'Tablename
Set obParQueryTable = obParameters.Item("QUERY_TABLE")
If obParQueryTable Is Nothing Then
Set obParQueryTable = obParameters.CreateSapParameter("QUERY_TABLE")
End If
obParQueryTable.Value = thisProject.Variables.Item("QueryTable").Value

'Delimiter
Set obParDelimiter = obParameters.Item("DELIMITER")
If obParDelimiter Is Nothing Then
Set obParDelimiter = obParameters.CreateSapParameter("DELIMITER")
End If
obParDelimiter.Value = thisProject.Variables.Item("Delimiter").Value

'Count of Rows
Set obParRowCount = obParameters.Item("ROWCOUNT")
If obParRowCount Is Nothing Then
Set obParRowCount = obParameters.CreateSapParameter("ROWCOUNT")
End If
obParRowCount.Value = thisProject.Variables.Item("RowCount").Value

'StartRow
Set obParRowSkip = obParameters.Item("ROWSKIPS")
If obParRowSkip Is Nothing Then
Set obParRowSkip = obParameters.CreateSapParameter("ROWSKIPS")
End If
obParRowSkip.Value = thisProject.Variables.Item("RowSkips").Value

'Fields only
Set obParNoData = obParameters.Item("NO_DATA")
If obParNoData Is Nothing Then
Set obParNoData = obParameters.CreateSapParameter("NO_DATA")
End If
obParNoData.Value = thisProject.Variables.Item("NoData").Value
End If

' === Create Table if exits, either clear
Set obTables = obFunReadTable.Tables 'Get Collectin of Tables
If Not obTables Is Nothing Then

'Selections , "WHERE-Clause" (in)
Set obTabOptions = obTables.Item("OPTIONS")
If obTabOptions Is Nothing Then
Set obTabOptions = obTables.CreateSapTable("OPTIONS", False) 'Input
Else
obTabOptions.Clear
End If

'Names (in) and Structure (out) of read fields
Set obTabFields = obTables.Item("FIELDS")
If obTabFields Is Nothing Then
Set obTabFields = obTables.CreateSapTable("FIELDS", False) 'Input
Else
obTabFields.Clear
End If

'read Data (out)
Set obTabData = obTables.Item("DATA")
If obTabData Is Nothing Then
Set obTabData = obTables.CreateSapTable("DATA", False) 'Output
Else
obTabData.Clear
End If
End If

' === Call Function (asynchron), keeps the connection to the SAP-System afterwards
Error = obFunReadTable.CallAsync(True)

'>>> some zenon internals are used now in deep
'it comes back up again in "obFunReadTable_CallFinished"...

End Sub

' |
' |
' V

Private Sub obFunReadTable_CallFinished(ByVal obFunction As ISapFunction, ByVal Error As tpSapError)

'Back from zenon internals.
'This is used to avoid blocking the zenon Runtime during the Function call,
'because a function call may need some seconds to proceed...

' === Errorhandling
Call PrintError(Error, obFunReadTable.LastError)

' === check result
If Error = tpSapError_Ok Then 'no error
Dim obParameters As SapParameters
Dim obParameter As SapParameter
Dim obTables As SapTables
Dim obTable As SapTable

Dim obTabFields As SapTable 'Input
Dim obTabData As SapTable 'Output

Dim Count As Integer
Dim RowData As String

' === check Parameter and Tables
Set obTables = obFunReadTable.Tables

' === check Table "FIELDS"
Set obTabFields = obTables.Item("FIELDS")

Count = obTabFields.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1
RowData = obTabFields.Rows.Item(i).RawData
'FIELDNAME = Name of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDNAME").Value = GetNextField(RowData)
'OFFSET = Start of the Field in the Row
thisProject.Variables.Item("FIELDS_Row[" & i & "].OFFSET").Value = CInt(GetNextField(RowData))
'LENGTH = Length of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].LENGTH").Value = CInt(GetNextField(RowData))
'TYPE = Datatype of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].TYPE").Value = GetNextField(RowData)
'FIELDTEXT = description of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDTEXT").Value = GetNextField(RowData)
Next

' === check Table "DATA"
Set obTabData = obTables.Item("DATA")

Count = obTabData.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1
'One row of the table "DATA" contains only one filed with 512 characters
RowData = obTabData.Rows.Item(i).RawData
thisProject.Variables.Item("DATA_Row[" & i & "]").Value = RowData
Next
End If
End Sub

Public Sub PrintError(Error As tpSapError, LastError As String)
Dim ShortError As String

Select Case Error
Case tpSapError_No_Connection ' No connection to SAP system
ShortError = "No connection to SAP system"
Case tpSapError_Ok ' OK.
ShortError = "No Error"
Case tpSapError_Failure ' Error occurred
ShortError = "Error occurred"
Case tpSapError_Exception ' Exception raised
ShortError = "Exception raised"
Case tpSapError_Sys_Exception ' System exception raised, connection closed
ShortError = "System exception raised, connection closed"
Case tpSapError_Call ' Call received
ShortError = "Call received"
Case tpSapError_Internal_Com ' Internal communication, repeat (internal use only
ShortError = "Internal communication, repeat (internal use only)"
Case tpSapError_Closed ' Connection closed by the other side
ShortError = "Connection closed by the other side"
Case tpSapError_Retry ' No data yet (RfcListen or RfcWaitForRequest only)
ShortError = "No data yet (RfcListen or RfcWaitForRequest only)"
Case tpSapError_No_Tid ' No Transaction ID available
DError = "No Transaction ID available"
Case tpSapError_Executed ' Function already executed
ShortError = "Function already executed"
Case tpSapError_Synchronize ' Synchronous Call in Progress (only for Windows)
ShortError = "Synchronous Call in Progress (only for Windows)"
Case tpSapError_Memory_Insufficient ' Memory insufficient
ShortError = "Memory insufficient"
Case tpSapError_Version_Mismatch ' Version mismatch
ShortError = "Version mismatch"
Case tpSapError_Not_found ' Function not found (internal use only)
ShortError = "Function not found (internal use only)"
Case tpSapError_Call_Not_Supported ' This call is not supported
ShortError = "This call is not supported"
Case tpSapError_Not_Owner ' Caller does not own the specified handle
ShortError = "Caller does not own the specified handle"
Case tpSapError_Not_Initialized ' RFC not yet initialized
ShortError = "RFC not yet initialized"
Case tpSapError_System_Called ' A system call such as RFC_PING for connection test is executed
ShortError = "A system call such as RFC_PING for connection test is executed"
Case tpSapError_Invalid_Handle ' An invalid handle was passed to an API call
ShortError = "An invalid handle was passed to an API call"
Case tpSapError_Invalid_Parameter ' An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected.
ShortError = "An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected."
Case tpSapError_Canceled ' An rfc call has been canceled by user
ShortError = "An rfc call has been canceled by user"
Case tpSapError_Conversion ' An error during conversion has been detected
ShortError = "An error during conversion has been detected"
Case tpSapError_Invalid_Protocol ' The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format
ShortError = "The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format"
Case tpSapError_Timeout ' Timeout
ShortError = "Timeout"
End Select

'Errorcode
thisProject.Variables.Item("ErrorCode").Value = Error
'Description of the Error
thisProject.Variables.Item("ShortError").Value = ShortError
'More detailed description of the last error
thisProject.Variables.Item("LastError").Value = LastError
End Sub

Public Function GetNextField(ByRef Text As String)
'Function to extract FieldValues out of a RawData string...

pos = InStr(Text, Chr$(10)) 'search for delimiter
If pos > 0 Then 'delimiter exists?
GetNextField = Left$(Text, pos - 1) 'return text until delimiter
Else 'no more delimiters
GetNextField = Text 'return string
End If
Text = Right$(Text, Len(Text) - pos) 'return text until delimiter or end - cut
End Function

Private Sub Project_Inactive()
'release object to avoid memory leaks...
thisProject.SapFunctions.DeleteSapFunction ("RFC_READ_TABLE")
End Sub

Other topics in this chapter

SapFunctions-Properties

SapFunctions-Methods


SapFunctions-Properties

Manual -> Programming interfaces -> Objectmodel -> SapFunctions -> SapFunctions-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Count of defined SAP functions | available | available
IProject | Parent | Parent-object | available | available

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> SapFunctions -> SapFunctions-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Parent() As Project

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> SapFunctions -> SapFunctions-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Count() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


SapFunctions-Methods

Manual -> Programming interfaces -> Objectmodel -> SapFunctions -> SapFunctions-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
ISapFunction | CreateSapFunction | Creates a new SAP function (unique name) | available | available
VARIANT_BOOL | DeleteSapFunction | Deletes the given SAP function | available | available
ISapFunction | Item | Returns the SAP function by name or position | available | available

Other topics in this chapter

CreateSapFunction

DeleteSapFunction

Item


CreateSapFunction

Manual -> Programming interfaces -> Objectmodel -> SapFunctions -> SapFunctions-Methods -> CreateSapFunction

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreateSapFunction(String Name) As SapFunction

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteSapFunction

Manual -> Programming interfaces -> Objectmodel -> SapFunctions -> SapFunctions-Methods -> DeleteSapFunction

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DeleteSapFunction(String Name) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Item

Manual -> Programming interfaces -> Objectmodel -> SapFunctions -> SapFunctions-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Item(VARIANT vID) As SapFunction

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

Index or name.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vID As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SapParameter

Manual -> Programming interfaces -> Objectmodel -> SapParameter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public WithEvents obFunReadTable As SapFunction

Public Sub ReadTable()
Dim obFunctions As SapFunctions

'Parameters
Dim obParQueryTable As SapParameter 'Input, Tablename
Dim obParDelimiter As SapParameter 'Input, Optional, Delimiter in DATA
Dim obParRowCount As SapParameter 'Input, Optional, 0 = all Rows
Dim obParRowSkip As SapParameter 'Input, Optional, 0 = from beginning
Dim obParNoData As SapParameter 'Input, Optional, "X" = read only Fielddefinitions (FIELDS)

'Tables
Dim obTabOptions As SapTable 'Input, WHERE-Clause
Dim obTabFields As SapTable 'Input/Output, Fielddefinitions
Dim obTabData As SapTable 'Output, Tabledata

Dim obRow As SapRow

Dim Error As tpSapError

' === Get Collection of Functionblocks
Set obFunctions = thisProject.SapFunctions

' === Create Functionblock "RFC_READ_TABLE" if not exists
Set obFunReadTable = obFunctions.Item("RFC_READ_TABLE")
If obFunReadTable Is Nothing Then
Set obFunReadTable = obFunctions.CreateSapFunction("RFC_READ_TABLE")
End If

' === Create Parameter if not exist
Set obParameters = obFunReadTable.Parameters 'Get Collection of Parameters
If Not obParameters Is Nothing Then

'Tablename
Set obParQueryTable = obParameters.Item("QUERY_TABLE")
If obParQueryTable Is Nothing Then
Set obParQueryTable = obParameters.CreateSapParameter("QUERY_TABLE")
End If
obParQueryTable.Value = thisProject.Variables.Item("QueryTable").Value

'Delimiter
Set obParDelimiter = obParameters.Item("DELIMITER")
If obParDelimiter Is Nothing Then
Set obParDelimiter = obParameters.CreateSapParameter("DELIMITER")
End If
obParDelimiter.Value = thisProject.Variables.Item("Delimiter").Value

'Count of Rows
Set obParRowCount = obParameters.Item("ROWCOUNT")
If obParRowCount Is Nothing Then
Set obParRowCount = obParameters.CreateSapParameter("ROWCOUNT")
End If
obParRowCount.Value = thisProject.Variables.Item("RowCount").Value

'StartRow
Set obParRowSkip = obParameters.Item("ROWSKIPS")
If obParRowSkip Is Nothing Then
Set obParRowSkip = obParameters.CreateSapParameter("ROWSKIPS")
End If
obParRowSkip.Value = thisProject.Variables.Item("RowSkips").Value

'Fields only
S et obParNoData = obParameters.Item("NO_DATA")
If obParNoData Is Nothing Then
Set obParNoData = obParameters.CreateSapParameter("NO_DATA")
End If
obParNoData.Value = thisProject.Variables.Item("NoData").Value
End If

' === Create Table if exits, either clear
Set obTables = obFunReadTable.Tables 'Get Collectin of Tables
If Not obTables Is Nothing Then

'Selections , "WHERE-Clause" (in)
Set obTabOptions = obTables.Item("OPTIONS")
If obTabOptions Is Nothing Then
Set obTabOptions = obTables.CreateSapTable("OPTIONS", False) 'Input
Else
obTabOptions.Clear
End If

'Names (in) and Structure (out) of read fields
Set obTabFields = obTables.Item("FIELDS")
If obTabFields Is Nothing Then
Set obTabFields = obTables.CreateSapTable("FIELDS", False) 'Input
Else
obTabFields.Clear
End If

'read Data (out)
Set obTabData = obTables.Item("DATA")
If obTabData Is Nothing Then
Set obTabData = obTables.CreateSapTable("DATA", False) 'Output
Else
obTabData.Clear
End If
End If

' === Call Function (asynchron), keeps the connection to the SAP-System afterwards
Error = obFunReadTable.CallAsync(True)

'>>> some zenon internals are used now in deep
'it comes back up again in "obFunReadTable_CallFinished"...

End Sub

' |
' |
' V

Private Sub obFunReadTable_CallFinished(ByVal obFunction As ISapFunction, ByVal Error As tpSapError)

'Back from zenon internals.
'This is used to avoid blocking the zenon Runtime during the Function call,
'because a function call may need some seconds to proceed...

' === Errorhandling
Call PrintError(Error, obFunReadTable.LastError)

' === check result
If Error = tpSapError_Ok Then 'no error
Dim obParameters As SapParameters
Dim obParameter As SapParameter
Dim obTables As SapTables
Dim obTable As SapTable

Dim obTabFields As SapTable 'Input
Dim obTabData As SapTable 'Output

Dim Count As Integer
Dim RowData As String

' === check Parameter and Tables
Set obTables = obFunReadTable.Tables

' === check Table "FIELDS"
Set obTabFields = obTables.Item("FIELDS")

Count = obTabFields.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1
RowData = obTabFields.Rows.Item(i).RawData
'FIELDNAME = Name of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDNAME").Value = GetNextField(RowData)
'OFFSET = Start of the Field in the Row
thisProject.Variables.Item("FIELDS_Row[" & i & "].OFFSET").Value = CInt(GetNextField(RowData))
'LENGTH = Length of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].LENGTH").Value = CInt(GetNextField(RowData))
'TYPE = Datatype of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].TYPE").Value = GetNextField(RowData)
'FIELDTEXT = description of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDTEXT").Value = GetNextField(RowData)
Next

' === check Table "DATA"
Set obTabData = obTables.Item("DATA")

Count = obTabData.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1
'One row of the table "DATA" contains only one filed with 512 characters
RowData = obTabData.Rows.Item(i).RawData
thisProject.Variables.Item("DATA_Row[" & i & "]").Value = RowData
Next
End If
End Sub

Public Sub PrintError(Error As tpSapError, LastError As String)
Dim ShortError As String

Select Case Error
Case tpSapError_No_Connection ' No connection to SAP system
ShortError = "No connection to SAP system"
Case tpSapError_Ok ' OK.
ShortError = "No Error"
Case tpSapError_Failure ' Error occurred
ShortError = "Error occurred"
Case tpSapError_Exception ' Exception raised
ShortError = "Exception raised"
Case tpSapError_Sys_Exception ' System exception raised, connection closed
ShortError = "System exception raised, connection closed"
Case tpSapError_Call ' Call received
ShortError = "Call received"
Case tpSapError_Internal_Com ' Internal communication, repeat (internal use only
ShortError = "Internal communication, repeat (internal use only)"
Case tpSapError_Closed ' Connection closed by the other side
ShortError = "Connection closed by the other side"
Case tpSapError_Retry ' No data yet (RfcListen or RfcWaitForRequest only)
ShortError = "No data yet (RfcListen or RfcWaitForRequest only)"
Case tpSapError_No_Tid ' No Transaction ID available
DError = "No Transaction ID available"
Case tpSapError_Executed ' Function already executed
ShortError = "Function already executed"
Case tpSapError_Synchronize ' Synchronous Call in Progress (only for Windows)
ShortError = "Synchronous Call in Progress (only for Windows)"
Case tpSapError_Memory_Insufficient ' Memory insufficient
ShortError = "Memory insufficient"
Case tpSapError_Version_Mismatch ' Version mismatch
ShortError = "Version mismatch"
Case tpSapError_Not_found ' Function not found (internal use only)
ShortError = "Function not found (internal use only)"
Case tpSapError_Call_Not_Supported ' This call is not supported
ShortError = "This call is not supported"
Case tpSapError_Not_Owner ' Caller does not own the specified handle
ShortError = "Caller does not own the specified handle"
Case tpSapError_Not_Initialized ' RFC not yet initialized
ShortError = "RFC not yet initialized"
Case tpSapError_System_Called ' A system call such as RFC_PING for connection test is executed
ShortError = "A system call such as RFC_PING for connection test is executed"
Case tpSapError_Invalid_Handle ' An invalid handle was passed to an API call
ShortError = "An invalid handle was passed to an API call"
Case tpSapError_Invalid_Parameter ' An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected.
ShortError = "An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected."
Case tpSapError_Canceled ' An rfc call has been canceled by user
ShortError = "An rfc call has been canceled by user"
Case tpSapError_Conversion ' An error during conversion has been detected
ShortError = "An error during conversion has been detected"
Case tpSapError_Invalid_Protocol ' The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format
ShortError = "The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format"
Case tpSapError_Timeout ' Timeout
ShortError = "Timeout"
End Select

'Errorcode
thisProject.Variables.Item("ErrorCode").Value = Error
'Description of the Error
thisProject.Variables.Item("ShortError").Value = ShortError
'More detailed description of the last error
thisProject.Variables.Item("LastError").Value = LastError
End Sub

Public Function GetNextField(ByRef Text As String)
'Function to extract FieldValues out of a RawData string...

pos = InStr(Text, Chr$(10)) 'search for delimiter
If pos > 0 Then 'delimiter exists?
GetNextField = Left$(Text, pos - 1) 'return text until delimiter
Else 'no more delimiters
GetNextField = Text 'return string
End If
Text = Right$(Text, Len(Text) - pos) 'return text until delimiter or end - cut
End Function

Private Sub Project_Inactive()
'release object to avoid memory leaks...
thisProject.SapFunctions.DeleteSapFunction ("RFC_READ_TABLE")
End Sub

Other topics in this chapter

SapParameter-Properties

SapParameter-Methods

SapParameter-Dynamic properties


SapParameter-Properties

Manual -> Programming interfaces -> Objectmodel -> SapParameter -> SapParameter-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | Default | SAP parameter has a default value (TRUE/FALSE) | available | available
BSTR | Name | Name of the SAP parameter | available | available
VARIANT_BOOL | Optional | SAP parameter is optional (TRUE/FALSE) | available | available
ISapParameters | Parent | Parent-object | available | available
BSTR | RawData | Returns the raw Data of the SAP parameter in a delimited string | not used | read only

Other topics in this chapter

Parent

Name

Optional

Default

RawData


Parent

Manual -> Programming interfaces -> Objectmodel -> SapParameter -> SapParameter-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Parent() As SapParameters

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> SapParameter -> SapParameter-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Optional

Manual -> Programming interfaces -> Objectmodel -> SapParameter -> SapParameter-Properties -> Optional

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Optional() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Default

Manual -> Programming interfaces -> Objectmodel -> SapParameter -> SapParameter-Properties -> Default

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Default() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


RawData

Manual -> Programming interfaces -> Objectmodel -> SapParameter -> SapParameter-Properties -> RawData

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

returns the data of the Parameter as one line, the values are separated by a Line-Feed character...

Datatype

RawData() As String

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


SapParameter-Methods

Manual -> Programming interfaces -> Objectmodel -> SapParameter -> SapParameter-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
VARIANT | Value [GET] | Value of the SAP parameter | available | available | yes | yes
void | Value [PUT] | Value of the SAP parameter | available | available | yes | yes

Other topics in this chapter

Value [GET]

Value [PUT]


Value [GET]

Manual -> Programming interfaces -> Objectmodel -> SapParameter -> SapParameter-Methods -> Value [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Value [GET]([optional]VARIANT vIndex) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Value [PUT]

Manual -> Programming interfaces -> Objectmodel -> SapParameter -> SapParameter-Methods -> Value [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Value [PUT]([optional]VARIANT vIndex, VARIANT newValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SapParameter-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> SapParameter -> SapParameter-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

SAP Parameter

Other topics in this chapter

SAP Parameter


SAP Parameter

Manual -> Programming interfaces -> Objectmodel -> SapParameter -> SapParameter-Dynamic properties -> SAP Parameter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_UI1

Type

Type

Type of the parameter. Dependent of the function type. Serves only informational purposes and it is set when a SAP function is created via the wizard in accordance with the interface description in the SAP system.

Import: the value of the parameter is transferred to the function block when called up.

Export: The value of the parameter is returned by the function call.

Changing: both input and return parameter.

Table: Function type table. Cannot be changed.

More in the online help.

VT_BSTR

Name

Name in SAP system

Name of the parameter, the table or the structure field in the SAP system.

More in the online help.

ZT_VARIABLE

Variable

Variable

zenon variable linked with the parameter, the table or the structure field. For tables it is normally an array variable.

More in the online help.

VT_BOOL

Optional

Optional

States whether der parameter or table is optional. Optional parameters and tables can be left out when a function block is called.

Serves only informational purposes and it is set when a SAP function is created via the wizard in accordance with the interface description in the SAP system.

More in the online help.

VT_BSTR

Info

Information

Freely definable short text. Serves only informational purposes and if available, it is set when a SAP function is created via the wizard in accordance with the interface description in the SAP system.

More in the online help.


SapParameters

Manual -> Programming interfaces -> Objectmodel -> SapParameters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public WithEvents obFunReadTable As SapFunction

Public Sub ReadTable()
Dim obFunctions As SapFunctions

'Parameters
Dim obParQueryTable As SapParameter 'Input, Tablename
Dim obParDelimiter As SapParameter 'Input, Optional, Delimiter in DATA
Dim obParRowCount As SapParameter 'Input, Optional, 0 = all Rows
Dim obParRowSkip As SapParameter 'Input, Optional, 0 = from beginning
Dim obParNoData As SapParameter 'Input, Optional, "X" = read only Fielddefinitions (FIELDS)

'Tables
Dim obTabOptions As SapTable 'Input, WHERE-Clause
Dim obTabFields As SapTable 'Input/Output, Fielddefinitions
Dim obTabData As SapTable 'Output, Tabledata

Dim obRow As SapRow

Dim Error As tpSapError

' === Get Collection of Functionblocks
Set obFunctions = thisProject.SapFunctions

' === Create Functionblock "RFC_READ_TABLE" if not exists
Set obFunReadTable = obFunctions.Item("RFC_READ_TABLE")
If obFunReadTable Is Nothing Then
Set obFunReadTable = obFunctions.CreateSapFunction("RFC_READ_TABLE")
End If

' === Create Parameter if not exist
Set obParameters = obFunReadTable.Parameters 'Get Collection of Parameters
If Not obParameters Is Nothing Then

'Tablename
Set obParQueryTable = obParameters.Item("QUERY_TABLE")
If obParQueryTable Is Nothing Then
Set obParQueryTable = obParameters.CreateSapParameter("QUERY_TABLE")
End If
obParQueryTable.Value = thisProject.Variables.Item("QueryTable").Value

'Delimiter
Set obParDelimiter = obParameters.Item("DELIMITER")
If obParDelimiter Is Nothing Then
Set obParDelimiter = obParameters.CreateSapParameter("DELIMITER")
End If
obParDelimiter.Value = thisProject.Variables.Item("Delimiter").Value

'Count of Rows
Set obParRowCount = obParameters.Item("ROWCOUNT")
If obParRowCount Is Nothing Then
Set obParRowCount = obParameters.CreateSapParameter("ROWCOUNT")
End If
obParRowCount.Value = thisProject.Variables.Item("RowCount").Value

'StartRow
Set obParRowSkip = obParameters.Item("ROWSKIPS")
If obParRowSkip Is Nothing Then
Set obParRowSkip = obParameters.CreateSapParameter("ROWSKIPS")
End If
obParRowSkip.Value = thisProject.Variables.Item("RowSkips").Value

'Fields only
Set obParNoData = obParameters.Item("NO_DATA")
If obParNoData Is Nothing Then
Set obParNoData = obParameters.CreateSapParameter("NO_DATA")
End If
obParNoData.Value = thisProject.Variables.Item("NoData").Value
End If

' === Create Table if exits, either clear
Set obTables = obFunReadTable.Tables 'Get Collectin of Tables
If Not obTables Is Nothing Then

'Selections , "WHERE-Clause" (in)
Set obTabOptions = obTables.Item("OPTIONS")
If obTabOptions Is Nothing Then
Set obTabOptions = obTables.CreateSapTable("OPTIONS", False) 'Input
Else
obTabOptions.Clear
End If

'Names (in) and Structure (out) of read fields
Set obTabFields = obTables.Item("FIELDS")
If obTabFields Is Nothing Then
Set obTabFields = obTables.CreateSapTable("FIELDS", False) 'Input
Else
obTabFields.Clear
End If

'read Data (out)
Set obTabData = obTables.Item("DATA")
If obTabData Is Nothing Then
Set obTabData = obTables.CreateSapTable("DATA", False) 'Output
Else
obTabData.Clear
End If
End If

' === Call Function (asynchron), keeps the connection to the SAP-System afterwards
Error = obFunReadTable.CallAsync(True)

'>>> some zenon internals are used now in deep
'it comes back up again in "obFunReadTable_CallFinished"...

End Sub

' |
' |
' V

Private Sub obFunReadTable_CallFinished(ByVal obFunction As ISapFunction, ByVal Error As tpSapError)

'Back from zenon internals.
'This is used to avoid blocking the zenon Runtime during the Function call,
'because a function call may need some seconds to proceed...

' === Errorhandling
Call PrintError(Error, obFunReadTable.LastError)

' === check result
If Error = tpSapError_Ok Then 'no error
Dim obParameters As SapParameters
Dim obParameter As SapParameter
Dim obTables As SapTables
Dim obTable As SapTable

Dim obTabFields As SapTable 'Input
Dim obTabData As SapTable 'Output

Dim Count As Integer
Dim RowData As String

' === check Parameter and Tables
Set obTables = obFunReadTable.Tables

' === check Table "FIELDS"
Set obTabFields = obTables.Item("FIELDS")

Count = obTabFields.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1
RowData = obTabFields.Rows.Item(i).RawData
'FIELDNAME = Name of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDNAME").Value = GetNextField(RowData)
'OFFSET = Start of the Field in the Row
thisProject.Variables.Item("FIELDS_Row[" & i & "].OFFSET").Value = CInt(GetNextField(RowData))
'LENGTH = Length of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].LENGTH").Value = CInt(GetNextField(RowData))
'TYPE = Datatype of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].TYPE").Value = GetNextField(RowData)
'FIELDTEXT = description of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDTEXT").Value = GetNextField(RowData)
Next

' === check Table "DATA"
Set obTabData = obTables.Item("DATA")

Count = obTabData.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1
'One row of the table "DATA" contains only one filed with 512 characters
RowData = obTabData.Rows.Item(i).RawData
thisProject.Variables.Item("DATA_Row[" & i & "]").Value = RowData
Next
End If
End Sub

Public Sub PrintError(Error As tpSapError, LastError As String)
Dim ShortError As String

Select Case Error
Case tpSapError_No_Connection ' No connection to SAP system
ShortError = "No connection to SAP system"
Case tpSapError_Ok ' OK.
ShortError = "No Error"
Case tpSapError_Failure ' Error occurred
ShortError = "Error occurred"
Case tpSapError_Exception ' Exception raised
ShortError = "Exception raised"
Case tpSapError_Sys_Exception ' System exception raised, connection closed
ShortError = "System exception raised, connection closed"
Case tpSapError_Call ' Call received
ShortError = "Call received"
Case tpSapError_Internal_Com ' Internal communication, repeat (internal use only
ShortError = "Internal communication, repeat (internal use only)"
Case tpSapError_Closed ' Connection closed by the other side
ShortError = "Connection closed by the other side"
Case tpSapError_Retry ' No data yet (RfcListen or RfcWaitForRequest only)
ShortError = "No data yet (RfcListen or RfcWaitForRequest only)"
Case tpSapError_No_Tid ' No Transaction ID available
DError = "No Transaction ID available"
Case tpSapError_Executed ' Function already executed
ShortError = "Function already executed"
Case tpSapError_Synchronize ' Synchronous Call in Progress (only for Windows)
ShortError = "Synchronous Call in Progress (only for Windows)"
Case tpSapError_Memory_Insufficient ' Memory insufficient
ShortError = "Memory insufficient"
Case tpSapError_Version_Mismatch ' Version mismatch
ShortError = "Version mismatch"
Case tpSapError_Not_found ' Function not found (internal use only)
ShortError = "Function not found (internal use only)"
Case tpSapError_Call_Not_Supported ' This call is not supported
ShortError = "This call is not supported"
Case tpSapError_Not_Owner ' Caller does not own the specified handle
ShortError = "Caller does not own the specified handle"
Case tpSapError_Not_Initialized ' RFC not yet initialized
ShortError = "RFC not yet initialized"
Case tpSapError_System_Called ' A system call such as RFC_PING for connection test is executed
ShortError = "A system call such as RFC_PING for connection test is executed"
Case tpSapError_Invalid_Handle ' An invalid handle was passed to an API call
ShortError = "An invalid handle was passed to an API call"
Case tpSapError_Invalid_Parameter ' An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected.
ShortError = "An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected."
Case tpSapError_Canceled ' An rfc call has been canceled by user
ShortError = "An rfc call has been canceled by user"
Case tpSapError_Conversion ' An error during conversion has been detected
ShortError = "An error during conversion has been detected"
Case tpSapError_Invalid_Protocol ' The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format
ShortError = "The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format"
Case tpSapError_Timeout ' Timeout
ShortError = "Timeout"
End Select

'Errorcode
thisProject.Variables.Item("ErrorCode").Value = Error
'Description of the Error
thisProject.Variables.Item("ShortError").Value = ShortError
'More detailed description of the last error
thisProject.Variables.Item("LastError").Value = LastError
End Sub

Public Function GetNextField(ByRef Text As String)
'Function to extract FieldValues out of a RawData string...

pos = InStr(Text, Chr$(10)) 'search for delimiter
If pos > 0 Then 'delimiter exists?
GetNextField = Left$(Text, pos - 1) 'return text until delimiter
Else 'no more delimiters
GetNextField = Text 'return string
End If
Text = Right$(Text, Len(Text) - pos) 'return text until delimiter or end - cut
End Function

Private Sub Project_Inactive()
'release object to avoid memory leaks...
thisProject.SapFunctions.DeleteSapFunction ("RFC_READ_TABLE")
End Sub

Other topics in this chapter

SapParameters-Properties

SapParameters-Methods


SapParameters-Properties

Manual -> Programming interfaces -> Objectmodel -> SapParameters -> SapParameters-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Count of defined SAP parameters | available | available
ISapFunction | Parent | Parent-object | available | available

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> SapParameters -> SapParameters-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Parent() As SapFunction

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> SapParameters -> SapParameters-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Count() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


SapParameters-Methods

Manual -> Programming interfaces -> Objectmodel -> SapParameters -> SapParameters-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
ISapParameter | CreateSapParameter | Creates a new SAP parameter (unique name) | available | available
VARIANT_BOOL | DeleteSapParameter | Deletes the given SAP parameter | available | available
ISapParameter | Item | Returns the SAP parameter by name or position | available | available

Other topics in this chapter

CreateSapParameter

DeleteSapParameter

Item


CreateSapParameter

Manual -> Programming interfaces -> Objectmodel -> SapParameters -> SapParameters-Methods -> CreateSapParameter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreateSapParameter(String Name, [optional] VARIANT bOptional, [optional] VARIANT bDefault) As SapParameter

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteSapParameter

Manual -> Programming interfaces -> Objectmodel -> SapParameters -> SapParameters-Methods -> DeleteSapParameter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DeleteSapParameter(String Name) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Item

Manual -> Programming interfaces -> Objectmodel -> SapParameters -> SapParameters-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Item(VARIANT vID) As SapParameter

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

Index or name.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vID As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SapRow

Manual -> Programming interfaces -> Objectmodel -> SapRow

Remarks

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public WithEvents obFunReadTable As SapFunction

Public Sub ReadTable()
Dim obFunctions As SapFunctions

'Parameters
Dim obParQueryTable As SapParameter 'Input, Tablename
Dim obParDelimiter As SapParameter 'Input, Optional, Delimiter in DATA
Dim obParRowCount As SapParameter 'Input, Optional, 0 = all Rows
Dim obParRowSkip As SapParameter 'Input, Optional, 0 = from beginning
Dim obParNoData As SapParameter 'Input, Optional, "X" = read only Fielddefinitions (FIELDS)

'Tables
Dim obTabOptions As SapTable 'Input, WHERE-Clause
Dim obTabFields As SapTable 'Input/Output, Fielddefinitions
Dim obTabData As SapTable 'Output, Tabledata

Dim obRow As SapRow

Dim Error As tpSapError

' === Get Collection of Functionblocks
Set obFunctions = thisProject.SapFunctions

' === Create Functionblock "RFC_READ_TABLE" if not exists
Set obFunReadTable = obFunctions.Item("RFC_READ_TABLE")
I f obFunReadTable Is Nothing Then
Set obFunReadTable = obFunctions.CreateSapFunction("RFC_READ_TABLE")
End If

' === Create Parameter if not exist
Set obParameters = obFunReadTable.Parameters 'Get Collection of Parameters
If Not obParameters Is Nothing Then

'Tablename
Set obParQueryTable = obParameters.Item("QUERY_TABLE")
If obParQueryTable Is Nothing Then
Set obParQueryTable = obParameters.CreateSapParameter("QUERY_TABLE")
End If
obParQueryTable.Value = thisProject.Variables.Item("QueryTable").Value

'Delimiter
Set obParDelimiter = obParameters.Item("DELIMITER")
If obParDelimiter Is Nothing Then
Set obParDelimiter = obParameters.CreateSapParameter("DELIMITER")
End If
obParDelimiter.Value = thisProject.Variables.Item("Delimiter").Value

'Count of Rows
Set obParRowCount = obParameters.Item("ROWCOUNT")
If obParRowCount Is Nothing Then
Set obParRowCount = obParameters.CreateSapParameter("ROWCOUNT")
End If
obParRowCount.Value = thisProject.Variables.Item("RowCount").Value

'StartRow
Set obParRowSkip = obParameters.Item("ROWSKIPS")
If obParRowSkip Is Nothing Then
Set obParRowSkip = obParameters.CreateSapParameter("ROWSKIPS")
End If
obParRowSkip.Value = thisProject.Variables.Item("RowSkips").Value

'Fields only
Set obParNoData = obParameters.Item("NO_DATA")
If obParNoData Is Nothing Then
Set obParNoData = obParameters.CreateSapParameter("NO_DATA")
End If
obParNoData.Value = thisProject.Variables.Item("NoData").Value
End If

' === Create Table if exits, either clear
Set obTables = obFunReadTable.Tables 'Get Collectin of Tables
If Not obTables Is Nothing Then

'Selections , "WHERE-Clause" (in)
Set obTabOptions = obTables.Item("OPTIONS")
If obTabOptions Is Nothing Then
Set obTabOptions = obTables.CreateSapTable("OPTIONS", False) 'Input
Else
obTabOptions.Clear
End If

'Names (in) and Structure (out) of read fields
Set obTabFields = obTables.Item("FIELDS")
If obTabFields Is Nothing Then
Set obTabFields = obTables.CreateSapTable("FIELDS", False) 'Input
Else
obTabFields.Clear
End If

'read Data (out)
Set obTabData = obTables.Item("DATA")
If obTabData Is Nothing Then
Set obTabData = obTables.CreateSapTable("DATA", False) 'Output
Else
obTabData.Clear
End If
End If

' === Call Function (asynchron), keeps the connection to the SAP-System afterwards
Error = obFunReadTable.CallAsync(True)

'>>> some zenon internals are used now in deep
'it comes back up again in "obFunReadTable_CallFinished"...

End Sub

' |
' |
' V

Private Sub obFunReadTable_CallFinished(ByVal obFunction As ISapFunction, ByVal Error As tpSapError)

'Back from zenon internals.
'This is used to avoid blocking the zenon Runtime during the Function call,
'because a function call may need some seconds to proceed...

' === Errorhandling
Call PrintError(Error, obFunReadTable.LastError)

' === check result
If Error = tpSapError_Ok Then 'no error
Dim obParameters As SapParameters
Dim obParameter As SapParameter
Dim obTables As SapTables
Dim obTable As SapTable

Dim obTabFields As SapTable 'Input
Dim obTabData As SapTable 'Output

Dim Count As Integer
Dim RowData As String

' === check Parameter and Tables
Set obTables = obFunReadTable.Tables

' === check Table "FIELDS"
Set obTabFields = obTables.Item("FIELDS")

Count = obTabFields.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1
RowData = obTabFields.Rows.Item(i).RawData
'FIELDNAME = Name of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDNAME").Value = GetNextField(RowData)
'OFFSET = Start of the Field in the Row
thisProject.Variables.Item("FIELDS_Row[" & i & "].OFFSET").Value = CInt(GetNextField(RowData))
'LENGTH = Length of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].LENGTH").Value = CInt(GetNextField(RowData))
'TYPE = Datatype of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].TYPE").Value = GetNextField(RowData)
'FIELDTEXT = description of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDTEXT").Value
Next

' === check Table "DATA"
Set obTabData = obTables.Item("DATA")

Count = obTabData.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1
'One row of the table "DATA" contains only one filed with 512 characters
RowData = obTabData.Rows.Item(i).RawData
thisProject.Variables.Item("DATA_Row[" & i & "]").Value = RowData
Next
End If
End Sub

Public Sub PrintError(Error As tpSapError, LastError As String)
Dim ShortError As String

Select Case Error
Case tpSapError_No_Connection ' No connection to SAP system
ShortError = "No connection to SAP system"
Case tpSapError_Ok ' OK.
ShortError = "No Error"
Case tpSapError_Failure ' Error occurred
ShortError = "Error occurred"
Case tpSapError_Exception ' Exception raised
ShortError = "Exception raised"
Case tpSapError_Sys_Exception ' System exception raised, connection closed
ShortError = "System exception raised, connection closed"
Case tpSapError_Call ' Call received
ShortError = "Call received"
Case tpSapError_Internal_Com ' Internal communication, repeat (internal use only
ShortError = "Internal communication, repeat (internal use only)"
Case tpSapError_Closed ' Connection closed by the other side
ShortError = "Connection closed by the other side"
Case tpSapError_Retry ' No data yet (RfcListen or RfcWaitForRequest only)
ShortError = "No data yet (RfcListen or RfcWaitForRequest only)"
Case tpSapError_No_Tid ' No Transaction ID available
DError = "No Transaction ID available"
Case tpSapError_Executed ' Function already executed
ShortError = "Function already executed"
Case tpSapError_Synchronize ' Synchronous Call in Progress (only for Windows)
ShortError = "Synchronous Call in Progress (only for Windows)"
Case tpSapError_Memory_Insufficient ' Memory insufficient
ShortError = "Memory insufficient"
Case tpSapError_Version_Mismatch ' Version mismatch
ShortError = "Version mismatch"
Case tpSapError_Not_found ' Function not found (internal use only)
ShortError = "Function not found (internal use only)"
Case tpSapError_Call_Not_Supported ' This call is not supported
ShortError = "This call is not supported"
Case tpSapError_Not_Owner ' Caller does not own the specified handle
ShortError = "Caller does not own the specified handle"
Case tpSapError_Not_Initialized ' RFC not yet initialized
ShortError = "RFC not yet initialized"
Case tpSapError_System_Called ' A system call such as RFC_PING for connection test is executed
ShortError = "A system call such as RFC_PING for connection test is executed"
Case tpSapError_Invalid_Handle ' An invalid handle was passed to an API call
ShortError = "An invalid handle was passed to an API call"
Case tpSapError_Invalid_Parameter ' An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected.
ShortError = "An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected."
Case tpSapError_Canceled ' An rfc call has been canceled by user
ShortError = "An rfc call has been canceled by user"
Case tpSapError_Conversion ' An error during conversion has been detected
ShortError = "An error during conversion has been detected"
Case tpSapError_Invalid_Protocol ' The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format
ShortError = "The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format"
Case tpSapError_Timeout ' Timeout
ShortError = "Timeout"
End Select

'Errorcode
thisProject.Variables.Item("ErrorCode").Value = Error
'Description of the Error
thisProject.Variables.Item("ShortError").Value = ShortError
'More detailed description of the last error
thisProject.Variables.Item("LastError").Value = LastError
End Sub

Public Function GetNextField(ByRef Text As String)
'Function to extract FieldValues out of a RawData string...

pos = InStr(Text, Chr$(10)) 'search for delimiter
If pos > 0 Then 'delimiter exists?
GetNextField = Left$(Text, pos - 1) 'return text until delimiter
Else 'no more delimiters
GetNextField = Text 'return string
End If
Text = Right$(Text, Len(Text) - pos) 'return text until delimiter or end - cut
End Function

Private Sub Project_Inactive()
'release object to avoid memory leaks...
thisProject.SapFunctions.DeleteSapFunction ("RFC_READ_TABLE")
End Sub

Other topics in this chapter

SapRow-Properties

SapRow-Methods


SapRow-Properties

Manual -> Programming interfaces -> Objectmodel -> SapRow -> SapRow-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
ISapRows | Parent | Parent-object | available | available
BSTR | RawData | Returns the raw Data of the SAP row in a delimited string | available | not used

Other topics in this chapter

Parent

RawData


Parent

Manual -> Programming interfaces -> Objectmodel -> SapRow -> SapRow-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Parent() As SapRows

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


RawData

Manual -> Programming interfaces -> Objectmodel -> SapRow -> SapRow-Properties -> RawData

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

RawData() As String

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


SapRow-Methods

Manual -> Programming interfaces -> Objectmodel -> SapRow -> SapRow-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
VARIANT | Value [GET] | Value of the SAP row / column | available | available | yes | yes
void | Value [PUT] | Value of the SAP row / column | available | available | yes | yes

Other topics in this chapter

Value [GET]

Value [PUT]


Value [GET]

Manual -> Programming interfaces -> Objectmodel -> SapRow -> SapRow-Methods -> Value [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Value [GET]([optional]VARIANT vIndex) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Value [PUT]

Manual -> Programming interfaces -> Objectmodel -> SapRow -> SapRow-Methods -> Value [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Value [PUT]([optional]VARIANT vIndex, VARIANT newValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SapRows

Manual -> Programming interfaces -> Objectmodel -> SapRows

Remarks

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public WithEvents obFunReadTable As SapFunction

Public Sub ReadTable()
Dim obFunctions As SapFunctions

'Parameters
Dim obParQueryTable As SapParameter 'Input, Tablename
Dim obParDelimiter As SapParameter 'Input, Optional, Delimiter in DATA
Dim obParRowCount As SapParameter 'Input, Optional, 0 = all Rows
Dim obParRowSkip As SapParameter 'Input, Optional, 0 = from beginning
Dim obParNoData As SapParameter 'Input, Optional, "X" = read only Fielddefinitions (FIELDS)

'Tables
Dim obTabOptions As SapTable 'Input, WHERE-Clause
Dim obTabFields As SapTable 'Input/Output, Fielddefinitions
Dim obTabData As SapTable 'Output, Tabledata

Dim obRow As SapRow

Dim Error As tpSapError

' === Get Collection of Functionblocks
Set obFunctions = thisProject.SapFunctions

' === Create Functionblock "RFC_READ_TABLE" if not exists
Set obFunReadTable = obFunctions.Item("RFC_READ_TABLE")
If obFunReadTable Is Nothing Then
Set obFunReadTable = obFunctions.CreateSapFunction("RFC_READ_TABLE")
End If

' === Create Parameter if not exist
Set obParameters = obFunReadTable.Parameters 'Get Collection of Parameters
If Not obParameters Is Nothing Then

'Tablename
Set obParQueryTable = obParameters.Item("QUERY_TABLE")
If obParQueryTable Is Nothing Then
Set obParQueryTable = obParameters.CreateSapParameter("QUERY_TABLE")
End If
obParQueryTable.Value = thisProject.Variables.Item("QueryTable").Value

'Delimiter
Set obParDelimiter = obParameters.Item("DELIMITER")
If obParDelimiter Is Nothing Then
Set obParDelimiter = obParameters.CreateSapParameter("DELIMITER")
End If
obParDelimiter.Value = thisProject.Variables.Item("Delimiter").Value

'Count of Rows
Set obParRowCount = obParameters.Item("ROWCOUNT")
If obParRowCount Is Nothing Then
Set obParRowCount = obParameters.CreateSapParameter("ROWCOUNT")
End If
obParRowCount.Value = thisProject.Variables.Item("RowCount").Value

'StartRow
Set obParRowSkip = obParameters.Item("ROWSKIPS")
If obParRowSkip Is Nothing Then
Set obParRowSkip = obParameters.CreateSapParameter("ROWSKIPS")
End If
obParRowSkip.Value = thisProject.Variables.Item("RowSkips").Value

'Fields only
Set obParNoData = obParameters.Item("NO_DATA")
If obParNoData Is Nothing Then
Set obParNoData = obParameters.CreateSapParameter("NO_DATA")
End If
obParNoData.Value = thisProject.Variables.Item("NoData").Value
End If

' === Create Table if exits, either clear
Set obTables = obFunReadTable.Tables 'Get Collectin of Tables
If Not obTables Is Nothing Then

'Selections , "WHERE-Clause" (in)
Set obTabOptions = obTables.Item("OPTIONS")
If obTabOptions Is Nothing Then
Set obTabOptions = obTables.CreateSapTable("OPTIONS", False) 'Input
Else
obTabOptions.Clear
End If

'Names (in) and Structure (out) of read fields
Set obTabFields = obTables.Item("FIELDS")
If obTabFields Is Nothing Then
Set obTabFields = obTables.CreateSapTable("FIELDS", False) 'Input
Else
obTabFields.Clear
End If

'read Data (out)
Set obTabData = obTables.Item("DATA")
If obTabData Is Nothing Then
Set obTabData = obTables.CreateSapTable("DATA", False) 'Output
Else
obTabData.Clear
End If
End If

' === Call Function (asynchron), keeps the connection to the SAP-System afterwards
Error = obFunReadTable.CallAsync(True)

'>>> some zenon internals are used now in deep
'it comes back up again in "obFunReadTable_CallFinished"...

End Sub

' |
' |
' V

Private Sub obFunReadTable_CallFinished(ByVal obFunction As ISapFunction, ByVal Error As tpSapError)

'Back from zenon internals.
'This is used to avoid blocking the zenon Runtime during the Function call,
'because a function call may need some seconds to proceed...

' === Errorhandling
Call PrintError(Error, obFunReadTable.LastError)

' === check result
If Error = tpSapError_Ok Then 'no error
Dim obParameters As SapParameters
Dim obParameter As SapParameter
Dim obTables As SapTables
Dim obTable As SapTable

Dim obTabFields As SapTable 'Input
Dim obTabData As SapTable 'Output

Dim Count As Integer
Dim RowData As String

' === check Parameter and Tables
Set obTables = obFunReadTable.Tables

' === check Table "FIELDS"
Set obTabFields = obTables.Item("FIELDS")

Count = obTabFields.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1
RowData = obTabFields.Rows.Item(i).RawData
'FIELDNAME = Name of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDNAME").Value = GetNextField(RowData)
'OFFSET = Start of the Field in the Row
thisProject.Variables.Item("FIELDS_Row[" & i & "].OFFSET").Value = CInt(GetNextField(RowData))
'LENGTH = Length of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].LENGTH").Value = CInt(GetNextField(RowData))
'TYPE = Datatype of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].TYPE").Value = GetNextField(RowData)
'FIELDTEXT = description of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDTEXT").Value = GetNextField(RowData)
Next

' === check Table "DATA"
Set obTabData = obTables.Item("DATA")

Count = obTabData.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1
'One row of the table "DATA" contains only one filed with 512 characters
RowData = obTabData.Rows.Item(i).RawData
thisProject.Variables.Item("DATA_Row[" & i & "]").Value = RowData
Next
End If
End Sub

Public Sub PrintError(Error As tpSapError, LastError As String)
Dim ShortError As String

Select Case Error
Case tpSapError_No_Connection ' No connection to SAP system
ShortError = "No connection to SAP system"
Case tpSapError_Ok ' OK.
ShortError = "No Error"
Case tpSapError_Failure ' Error occurred
ShortError = "Error occurred"
Case tpSapError_Exception ' Exception raised
ShortError = "Exception raised"
Case tpSapError_Sys_Exception ' System exception raised, connection closed
ShortError = "System exception raised, connection closed"
Case tpSapError_Call ' Call received
ShortError = "Call received"
Case tpSapError_Internal_Com ' Internal communication, repeat (internal use only
ShortError = "Internal communication, repeat (internal use only)"
Case tpSapError_Closed ' Connection closed by the other side
ShortError = "Connection closed by the other side"
Case tpSapError_Retry ' No data yet (RfcListen or RfcWaitForRequest only)
ShortError = "No data yet (RfcListen or RfcWaitForRequest only)"
Case tpSapError_No_Tid ' No Transaction ID available
DError = "No Transaction ID available"
Case tpSapError_Executed ' Function already executed
ShortError = "Function already executed"
Case tpSapError_Synchronize ' Synchronous Call in Progress (only for Windows)
ShortError = "Synchronous Call in Progress (only for Windows)"
Case tpSapError_Memory_Insufficient ' Memory insufficient
ShortError = "Memory insufficient"
Case tpSapError_Version_Mismatch ' Version mismatch
ShortError = "Version mismatch"
Case tpSapError_Not_found ' Function not found (internal use only)
ShortError = "Function not found (internal use only)"
Case tpSapError_Call_Not_Supported ' This call is not supported
ShortError = "This call is not supported"
Case tpSapError_Not_Owner ' Caller does not own the specified handle
ShortError = "Caller does not own the specified handle"
Case tpSapError_Not_Initialized ' RFC not yet initialized
ShortError = "RFC not yet initialized"
Case tpSapError_System_Called ' A system call such as RFC_PING for connection test is executed
ShortError = "A system call such as RFC_PING for connection test is executed"
Case tpSapError_Invalid_Handle ' An invalid handle was passed to an API call
ShortError = "An invalid handle was passed to an API call"
Case tpSapError_Invalid_Parameter ' An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected.
ShortError = "An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected."
Case tpSapError_Canceled ' An rfc call has been canceled by user
ShortError = "An rfc call has been canceled by user"
Case tpSapError_Conversion ' An error during conversion has been detected
ShortError = "An error during conversion has been detected"
Case tpSapError_Invalid_Protocol ' The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format
ShortError = "The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format"
Case tpSapError_Timeout ' Timeout
ShortError = "Timeout"
End Select

'Errorcode
thisProject.Variables.Item("ErrorCode").Value = Error
'Description of the Error
thisProject.Variables.Item("ShortError").Value = ShortError
'More detailed description of the last error
thisProject.Variables.Item("LastError").Value = LastError
End Sub

Public Function GetNextField(ByRef Text As String)
'Function to extract FieldValues out of a RawData string...

pos = InStr(Text, Chr$(10)) 'search for delimiter
If pos > 0 Then 'delimiter exists?
GetNextField = Left$(Text, pos - 1) 'return text until delimiter
Else 'no more delimiters
GetNextField = Text 'return string
End If
Text = Right$(Text, Len(Text) - pos) 'return text until delimiter or end - cut
End Function

Private Sub Project_Inactive()
'release object to avoid memory leaks...
thisProject.SapFunctions.DeleteSapFunction ("RFC_READ_TABLE")
End Sub

Other topics in this chapter

SapRows-Properties

SapRows-Methods


SapRows-Properties

Manual -> Programming interfaces -> Objectmodel -> SapRows -> SapRows-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Count of defined SAP rows in the table | available | available
ISapTable | Parent | Parent-object | available | available

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> SapRows -> SapRows-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Parent() As SapTable

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> SapRows -> SapRows-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Count() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


SapRows-Methods

Manual -> Programming interfaces -> Objectmodel -> SapRows -> SapRows-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
ISapRow | AppendSapRow | Appends a new SAP row at the end of the table | available | not used
VARIANT_BOOL | DeleteSapRow | Deletes the SAP row at the given index | available | not used
ISapRow | InsertSapRow | Inserts a new SAP row at the given index | available | not used
ISapRow | Item | Returns the SAP row at the given index | available | not used

Other topics in this chapter

AppendSapRow

InsertSapRow

DeleteSapRow

Item


AppendSapRow

Manual -> Programming interfaces -> Objectmodel -> SapRows -> SapRows-Methods -> AppendSapRow

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

AppendSapRow() As SapRow

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


InsertSapRow

Manual -> Programming interfaces -> Objectmodel -> SapRows -> SapRows-Methods -> InsertSapRow

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

InsertSapRow(long Index) As SapRow

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteSapRow

Manual -> Programming interfaces -> Objectmodel -> SapRows -> SapRows-Methods -> DeleteSapRow

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DeleteSapRow(String Name) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Item

Manual -> Programming interfaces -> Objectmodel -> SapRows -> SapRows-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Item(VARIANT vID) As SapRow

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SapTable

Manual -> Programming interfaces -> Objectmodel -> SapTable

Remarks

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public WithEvents obFunReadTable As SapFunction

Public Sub ReadTable()
Dim obFunctions As SapFunctions

'Parameters
Dim obParQueryTable As SapParameter 'Input, Tablename
Dim obParDelimiter As SapParameter 'Input, Optional, Delimiter in DATA
Dim obParRowCount As SapParameter 'Input, Optional, 0 = all Rows
Dim obParRowSkip As SapParameter 'Input, Optional, 0 = from beginning
Dim obParNoData As SapParameter 'Input, Optional, "X" = read only Fielddefinitions (FIELDS)

'Tables
Dim obTabOptions As SapTable 'Input, WHERE-Clause
Dim obTabFields As SapTable 'Input/Output, Fielddefinitions
Dim obTabData As SapTable 'Output, Tabledata

Dim obRow As SapRow

Dim Error As tpSapError

' === Get Collection of Functionblocks
Set obFunctions = thisProject.SapFunctions

' === Create Functionblock "RFC_READ_TABLE" if not exists
Set obFunReadTable = obFunctions.Item("RFC_READ_TABLE")
If obFunReadTable Is Nothing Then
Set obFunReadTable = obFunctions.CreateSapFunction("RFC_READ_TABLE")
End If

' === Create Parameter if not exist
Set obParameters = obFunReadTable.Parameters 'Get Collection of Parameters
If Not obParameters Is Nothing Then

'Tablename
Set obParQueryTable = obParameters.Item("QUERY_TABLE")
If obParQueryTable Is Nothing Then
Set obParQueryTable = obParameters.CreateSapParameter("QUERY_TABLE")
End If
obParQueryTable.Value = thisProject.Variables.Item("QueryTable").Value

'Delimiter
Set obParDelimiter = obParameters.Item("DELIMITER")
If obParDelimiter Is Nothing Then
Set obParDelimiter = obParameters.CreateSapParameter("DELIMITER")
End If
obParDelimiter.Value = thisProject.Variables.Item("Delimiter").Value

'Count of Rows
Set obParRowCount = obParameters.Item("ROWCOUNT")
If obParRowCount Is Nothing Then
Set obParRowCount = obParameters.CreateSapParameter("ROWCOUNT")
End If
obParRowCount.Value = thisProject.Variables.Item("RowCount").Value

'StartRow
Set obParRowSkip = obParameters.Item("ROWSKIPS")
If obParRowSkip Is Nothing Then
Set obParRowSkip = obParameters.CreateSapParameter("ROWSKIPS")
End If
obParRowSkip.Value = thisProject.Variables.Item("RowSkips").Value

'Fields only
Set obParNoData = obParameters.Item("NO_DATA")
If obParNoData Is Nothing Then
Set obParNoData = obParameters.CreateSapParameter("NO_DATA")
End If
obParNoData.Value = thisProject.Variables.Item("NoData").Value
End If

' === Create Table if exits, either clear
Set obTables = obFunReadTable.Tables 'Get Collectin of Tables
If Not obTables Is Nothing Then

'Selections , "WHERE-Clause" (in)
Set obTabOptions = obTables.Item("OPTIONS")
If obTabOptions Is Nothing Then
Set obTabOptions = obTables.CreateSapTable("OPTIONS", False) 'Input
Else
obTabOptions.Clear
End If

'Names (in) and Structure (out) of read fields
Set obTabFields = obTables.Item("FIELDS")
If obTabFields Is Nothing Then
Set obTabFields = obTables.CreateSapTable("FIELDS", False) 'Input
Else
obTabFields.Clear
End If

'read Data (out)
Set obTabData = obTables.Item("DATA")
If obTabData Is Nothing Then
Set obTabData = obTables.CreateSapTable("DATA", False) 'Output
Else
obTabData.Clear
End If
End If

' === Call Function (asynchron), keeps the connection to the SAP-System afterwards
Error = obFunReadTable.CallAsync(True)

'>>> some zenon internals are used now in deep
'it comes back up again in "obFunReadTable_CallFinished"...

End Sub

' |
' |
' V

Private Sub obFunReadTable_CallFinished(ByVal obFunction As ISapFunction, ByVal Error As tpSapError)

'Back from zenon internals.
'This is used to avoid blocking the zenon Runtime during the Function call,
'because a function call may need some seconds to proceed...

' === Errorhandling
Call PrintError(Error, obFunReadTable.LastError)

' === check result
If Error = tpSapError_Ok Then 'no error
Dim obParameters As SapParameters
Dim obParameter As SapParameter
Dim obTables As SapTables
Dim obTable As SapTable

Dim obTabFields As SapTable 'Input
Dim obTabData As SapTable 'Output

Dim Count As Integer
Dim RowData As String

' === check Parameter and Tables
Set obTables = obFunReadTable.Tables

' === check Table "FIELDS"
Set obTabFields = obTables.Item("FIELDS")

Count = obTabFields.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1
RowData = obTabFields.Rows.Item(i).RawData
'FIELDNAME = Name of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDNAME").Value = GetNextField(RowData)
'OFFSET = Start of the Field in the Row
thisProject.Variables.Item("FIELDS_Row[" & i & "].OFFSET").Value = CInt(GetNextField(RowData))
'LENGTH = Length of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].LENGTH").Value = CInt(GetNextField(RowData))
'TYPE = Datatype of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].TYPE").Value = GetNextField(RowData)
'FIELDTEXT = description of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDTEXT").Value = GetNextField(RowData)
Next

' === check Table "DATA"
Set obTabData = obTables.Item("DATA")

Count = obTabData.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1
'One row of the table "DATA" contains only one filed with 512 characters
RowData = obTabData.Rows.Item(i).RawData
thisProject.Variables.Item("DATA_Row[" & i & "]").Value = RowData
Next
End If
End Sub

Public Sub PrintError(Error As tpSapError, LastError As String)
Dim ShortError As String

Select Case Error
Case tpSapError_No_Connection ' No connection to SAP system
ShortError = "No connection to SAP system"
Case tpSapError_Ok ' OK.
ShortError = "No Error"
Case tpSapError_Failure ' Error occurred
ShortError = "Error occurred"
Case tpSapError_Exception ' Exception raised
ShortError = "Exception raised"
Case tpSapError_Sys_Exception ' System exception raised, connection closed
ShortError = "System exception raised, connection closed"
Case tpSapError_Call ' Call received
ShortError = "Call received"
Case tpSapError_Internal_Com ' Internal communication, repeat (internal use only
ShortError = "Internal communication, repeat (internal use only)"
Case tpSapError_Closed ' Connection closed by the other side
ShortError = "Connection closed by the other side"
Case tpSapError_Retry ' No data yet (RfcListen or RfcWaitForRequest only)
ShortError = "No data yet (RfcListen or RfcWaitForRequest only)"
Case tpSapError_No_Tid ' No Transaction ID available
DError = "No Transaction ID available"
Case tpSapError_Executed ' Function already executed
ShortError = "Function already executed"
Case tpSapError_Synchronize ' Synchronous Call in Progress (only for Windows)
ShortError = "Synchronous Call in Progress (only for Windows)"
Case tpSapError_Memory_Insufficient ' Memory insufficient
ShortError = "Memory insufficient"
Case tpSapError_Version_Mismatch ' Version mismatch
ShortError = "Version mismatch"
Case tpSapError_Not_found ' Function not found (internal use only)
ShortError = "Function not found (internal use only)"
Case tpSapError_Call_Not_Supported ' This call is not supported
ShortError = "This call is not supported"
Case tpSapError_Not_Owner ' Caller does not own the specified handle
ShortError = "Caller does not own the specified handle"
Case tpSapError_Not_Initialized ' RFC not yet initialized
ShortError = "RFC not yet initialized"
Case tpSapError_System_Called ' A system call such as RFC_PING for connection test is executed
ShortError = "A system call such as RFC_PING for connection test is executed"
Case tpSapError_Invalid_Handle ' An invalid handle was passed to an API call
ShortError = "An invalid handle was passed to an API call"
Case tpSapError_Invalid_Parameter ' An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected.
ShortError = "An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected."
Case tpSapError_Canceled ' An rfc call has been canceled by user
ShortError = "An rfc call has been canceled by user"
Case tpSapError_Conversion ' An error during conversion has been detected
ShortError = "An error during conversion has been detected"
Case tpSapError_Invalid_Protocol ' The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format
ShortError = "The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format"
Case tpSapError_Timeout ' Timeout
ShortError = "Timeout"
End Select

'Errorcode
thisProject.Variables.Item("ErrorCode").Value = Error
'Description of the Error
thisProject.Variables.Item("ShortError").Value = ShortError
'More detailed description of the last error
thisProject.Variables.Item("LastError").Value = LastError
End Sub

Public Function GetNextField(ByRef Text As String)
'Function to extract FieldValues out of a RawData string...

pos = InStr(Text, Chr$(10)) 'search for delimiter
If pos > 0 Then 'delimiter exists?
GetNextField = Left$(Text, pos - 1) 'return text until delimiter
Else 'no more delimiters
GetNextField = Text 'return string
End If
Text = Right$(Text, Len(Text) - pos) 'return text until delimiter or end - cut
End Function

Private Sub Project_Inactive()
'release object to avoid memory leaks...
thisProject.SapFunctions.DeleteSapFunction ("RFC_READ_TABLE")
End Sub

Other topics in this chapter

SapTable-Properties

SapTable-Methods

SapTable-Dynamic properties


SapTable-Properties

Manual -> Programming interfaces -> Objectmodel -> SapTable -> SapTable-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
BSTR | Name | Name of the SAP table | available | available
VARIANT_BOOL | Optional | SAP table is optional (TRUE/FALSE) | available | available
ISapFunctions | Parent | Parent-object | available | available

Other topics in this chapter

Parent

Name

Optional


Parent

Manual -> Programming interfaces -> Objectmodel -> SapTable -> SapTable-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Parent() As SapFunctions

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> SapTable -> SapTable-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Optional

Manual -> Programming interfaces -> Objectmodel -> SapTable -> SapTable-Properties -> Optional

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Optional() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


SapTable-Methods

Manual -> Programming interfaces -> Objectmodel -> SapTable -> SapTable-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | Clear | Deletes all rows in the table | available | available
ISapRows | Rows | Returns the collection of the rows in the table | available | not used

Other topics in this chapter

Rows

Clear


Rows

Manual -> Programming interfaces -> Objectmodel -> SapTable -> SapTable-Methods -> Rows

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Rows() As SapRows

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Clear

Manual -> Programming interfaces -> Objectmodel -> SapTable -> SapTable-Methods -> Clear

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Clear() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SapTable-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> SapTable -> SapTable-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

SAP table

Other topics in this chapter

SAP table


SAP table

Manual -> Programming interfaces -> Objectmodel -> SapTable -> SapTable-Dynamic properties -> SAP table

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_UI1

Type

Type

Type of the parameter. Dependent of the function type. Serves only informational purposes and it is set when a SAP function is created via the wizard in accordance with the interface description in the SAP system.

Import: the value of the parameter is transferred to the function block when called up.

Export: The value of the parameter is returned by the function call.

Changing: both input and return parameter.

Table: Function type table. Cannot be changed.

More in the online help.

VT_BSTR

Name

Name in SAP system

Name of the parameter, the table or the structure field in the SAP system.

More in the online help.

ZT_VARIABLE

Variable

Variable

zenon variable linked with the parameter, the table or the structure field. For tables it is normally an array variable.

More in the online help.

ZT_VARIABLE

RowCountVar

Number of lines

Numeric variables for the number of lines which should be taken from the variable linked with the table respectively the number of lines read when a SAP function is called.

More in the online help.

VT_BOOL

Optional

Optional

States whether der parameter or table is optional. Optional parameters and tables can be left out when a function block is called.

Serves only informational purposes and it is set when a SAP function is created via the wizard in accordance with the interface description in the SAP system.

More in the online help.

VT_BSTR

Info

Information

Freely definable short text. Serves only informational purposes and if available, it is set when a SAP function is created via the wizard in accordance with the interface description in the SAP system.

More in the online help.


SapTables

Manual -> Programming interfaces -> Objectmodel -> SapTables

Remarks

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public WithEvents obFunReadTable As SapFunction

Public Sub ReadTable()
Dim obFunctions As SapFunctions

'Parameters
Dim obParQueryTable As SapParameter 'Input, Tablename
Dim obParDelimiter As SapParameter 'Input, Optional, Delimiter in DATA
Dim obParRowCount As SapParameter 'Input, Optional, 0 = all Rows
Dim obParRowSkip As SapParameter 'Input, Optional, 0 = from beginning
Dim obParNoData As SapParameter 'Input, Optional, "X" = read only Fielddefinitions (FIELDS)

'Tables
Dim obTabOptions As SapTable 'Input, WHERE-Clause
Dim obTabFields As SapTable 'Input/Output, Fielddefinitions
Dim obTabData As SapTable 'Output, Tabledata

Dim obRow As SapRow

Dim Error As tpSapError

' === Get Collection of Functionblocks
Set obFunctions = thisProject.SapFunctions

' === Create Functionblock "RFC_READ_TABLE" if not exists
Set obFunReadTable = obFunctions.Item("RFC_READ_TABLE")
If obFunReadTable Is Nothing Then
Set obFunReadTable = obFunctions.CreateSapFunction("RFC_READ_TABLE")
End If

' === Create Parameter if not exist
Set obParameters = obFunReadTable.Parameters 'Get Collection of Parameters
If Not obParameters Is Nothing Then

'Tablename
Set obParQueryTable = obParameters.Item("QUERY_TABLE")
If obParQueryTable Is Nothing Then
Set obParQueryTable = obParameters.CreateSapParameter("QUERY_TABLE")
End If
obParQueryTable.Value = thisProject.Variables.Item("QueryTable").Value

'Delimiter
Set obParDelimiter = obParameters.Item("DELIMITER")
If obParDelimiter Is Nothing Then
Set obParDelimiter = obParameters.CreateSapParameter("DELIMITER")
End If
obParDelimiter.Value = thisProject.Variables.Item("Delimiter").Value

'Count of Rows
Set obParRowCount = obParameters.Item("ROWCOUNT")
If obParRowCount Is Nothing Then
Set obParRowCount = obParameters.CreateSapParameter("ROWCOUNT")
End If
obParRowCount.Value = thisProject.Variables.Item("RowCount").Value

'StartRow
Set obParRowSkip = obParameters.Item("ROWSKIPS")
If obParRowSkip Is Nothing Then
Set obParRowSkip = obParameters.CreateSapParameter("ROWSKIPS")
End If
obParRowSkip.Value = thisProject.Variables.Item("RowSkips").Value

'Fields only
Set obParNoData = obParameters.Item("NO_DATA")
If obParNoData Is Nothing Then
Set obParNoData = obParameters.CreateSapParameter("NO_DATA")
End If
obParNoData.Value = thisProject.Variables.Item("NoData").Value
End If

' === Create Table if exits, either clear
Set obTables = obFunReadTable.Tables 'Get Collectin of Tables
If Not obTables Is Nothing Then

'Selections , "WHERE-Clause" (in)
Set obTabOptions = obTables.Item("OPTIONS")
If obTabOptions Is Nothing Then
Set obTabOptions = obTables.CreateSapTable("OPTIONS", False) 'Input
Else
obTabOptions.Clear
End If

'Names (in) and Structure (out) of read fields
Set obTabFields = obTables.Item("FIELDS")
If obTabFields Is Nothing Then
Set obTabFields = obTables.CreateSapTable("FIELDS", False) 'Input
Else
obTabFields.Clear
End If

'read Data (out)
Set obTabData = obTables.Item("DATA")
If obTabData Is Nothing Then
Set obTabData = obTables.CreateSapTable("DATA", False) 'Output
Else
obTabData.Clear
End If
End If

' === Call Function (asynchron), keeps the connection to the SAP-System afterwards
Error = obFunReadTable.CallAsync(True)

'>>> some zenon internals are used now in deep
'it comes back up again in "obFunReadTable_CallFinished"...

End Sub

' |
' |
' V

Private Sub obFunReadTable_CallFinished(ByVal obFunction As ISapFunction, ByVal Error As tpSapError)

'Back from zenon internals.
'This is used to avoid blocking the zenon Runtime during the Function call,
'because a function call may need some seconds to proceed...

' === Errorhandling
Call PrintError(Error, obFunReadTable.LastError)

' === check result
If Error = tpSapError_Ok Then 'no error
Dim obParameters As SapParameters
Dim obParameter As SapParameter
Dim obTables As SapTables
Dim obTable As SapTable

Dim obTabFields As SapTable 'Input
Dim obTabData As SapTable 'Output

Dim Count As Integer
Dim RowData As String

' === check Parameter and Tables
Set obTables = obFunReadTable.Tables

' === check Table "FIELDS"
Set obTabFields = obTables.Item("FIELDS")

Count = obTabFields.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1
RowData = obTabFields.Rows.Item(i).RawData
'FIELDNAME = Name of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDNAME").Value = GetNextField(RowData)
'OFFSET = Start of the Field in the Row
thisProject.Variables.Item("FIELDS_Row[" & i & "].OFFSET").Value = CInt(GetNextField(RowData))
'LENGTH = Length of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].LENGTH").Value = CInt(GetNextField(RowData))
'TYPE = Datatype of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].TYPE").Value = GetNextField(RowData)
'FIELDTEXT = description of the Field
thisProject.Variables.Item("FIELDS_Row[" & i & "].FIELDTEXT").Value = GetNextField(RowData)
Next

' === check Table "DATA"
Set obTabData = obTables.Item("DATA")

Count = obTabData.Rows.Count
If Count > 5 Then Count = 5 'only the first 5 rows

For i = 0 To Count - 1
'One row of the table "DATA" contains only one filed with 512 characters
RowData = obTabData.Rows.Item(i).RawData
thisProject.Variables.Item("DATA_Row[" & i & "]").Value = RowData
Next
End If
End Sub

Public Sub PrintError(Error As tpSapError, LastError As String)
Dim ShortError As String

Select Case Error
Case tpSapError_No_Connection ' No connection to SAP system
ShortError = "No connection to SAP system"
Case tpSapError_Ok ' OK.
StError = "No Error"
Case tpSapError_Failure ' Error occurred
ShortError = "Error occurred"
Case tpSapError_Exception ' Exception raised
ShortError = "Exception raised"
Case tpSapError_Sys_Exception ' System exception raised, connection closed
ShortError = "System exception raised, connection closed"
Case tpSapError_Call ' Call received
ShortError = "Call received"
Case tpSapError_Internal_Com ' Internal communication, repeat (internal use only
ShortError = "Internal communication, repeat (internal use only)"
Case tpSapError_Closed ' Connection closed by the other side
ShortError = "Connection closed by the other side"
Case tpSapError_Retry ' No data yet (RfcListen or RfcWaitForRequest only)
ShortError = "No data yet (RfcListen or RfcWaitForRequest only)"
Case tpSapError_No_Tid ' No Transaction ID available
DError = "No Transaction ID available"
Case tpSapError_Executed ' Function already executed
ShortError = "Function already executed"
Case tpSapError_Synchronize ' Synchronous Call in Progress (only for Windows)
ShortError = "Synchronous Call in Progress (only for Windows)"
Case tpSapError_Memory_Insufficient ' Memory insufficient
ShortError = "Memory insufficient"
Case tpSapError_Version_Mismatch ' Version mismatch
ShortError = "Version mismatch"
Case tpSapError_Not_found ' Function not found (internal use only)
ShortError = "Function not found (internal use only)"
Case tpSapError_Call_Not_Supported ' This call is not supported
ShortError = "This call is not supported"
Case tpSapError_Not_Owner ' Caller does not own the specified handle
ShortError = "Caller does not own the specified handle"
Case tpSapError_Not_Initialized ' RFC not yet initialized
ShortError = "RFC not yet initialized"
Case tpSapError_System_Called ' A system call such as RFC_PING for connection test is executed
ShortError = "A system call such as RFC_PING for connection test is executed"
Case tpSapError_Invalid_Handle ' An invalid handle was passed to an API call
ShortError = "An invalid handle was passed to an API call"
Case tpSapError_Invalid_Parameter ' An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected.
ShortError = "An invalid parameter was passed to an API call or parameter length mismatch (expected and received) has been detected."
Case tpSapError_Canceled ' An rfc call has been canceled by user
ShortError = "An rfc call has been canceled by user"
Case tpSapError_Conversion ' An error during conversion has been detected
ShortError = "An error during conversion has been detected"
Case tpSapError_Invalid_Protocol ' The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format
ShortError = "The received data has an unsupported format. e.g.: non unicode application receives data sent in unicode format"
Case tpSapError_Timeout ' Timeout
ShortError = "Timeout"
End Select

'Errorcode
thisProject.Variables.Item("ErrorCode").Value = Error
'Description of the Error
thisProject.Variables.Item("ShortError").Value = ShortError
'More detailed description of the last error
thisProject.Variables.Item("LastError").Value = LastError
End Sub

Public Function GetNextField(ByRef Text As String)
'Function to extract FieldValues out of a RawData string...

pos = InStr(Text, Chr$(10)) 'search for delimiter
If pos > 0 Then 'delimiter exists?
GetNextField = Left$(Text, pos - 1) 'return text until delimiter
Else 'no more delimiters
GetNextField = Text 'return string
End If
Text = Right$(Text, Len(Text) - pos) 'return text until delimiter or end - cut
End Function

Private Sub Project_Inactive()
'release object to avoid memory leaks...
thisProject.SapFunctions.DeleteSapFunction ("RFC_READ_TABLE")
End Sub

Other topics in this chapter

SapTables-Properties

SapTables-Methods


SapTables-Properties

Manual -> Programming interfaces -> Objectmodel -> SapTables -> SapTables-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Count of defined SAP tables | available | available
ISapFunctions | Parent | Parent-object | available | available

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> SapTables -> SapTables-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Parent() As SapFunctions

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> SapTables -> SapTables-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Count() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


SapTables-Methods

Manual -> Programming interfaces -> Objectmodel -> SapTables -> SapTables-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
ISapParameter | CreateSapTable | Creates a new SAP table (unique name) | available | available
VARIANT_BOOL | DeleteSapTable | Deletes the given SAP table | available | available
ISapTable | Item | Returns the SAP table by name or position | available | available

Other topics in this chapter

CreateSapTable

DeleteSapTable

Item


CreateSapTable

Manual -> Programming interfaces -> Objectmodel -> SapTables -> SapTables-Methods -> CreateSapTable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreateSapTable(String Name, [optional] VARIANT bOptional) As SapParameter

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DeleteSapTable

Manual -> Programming interfaces -> Objectmodel -> SapTables -> SapTables-Methods -> DeleteSapTable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DeleteSapTable(String Name) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Item

Manual -> Programming interfaces -> Objectmodel -> SapTables -> SapTables-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Item(VARIANT vID) As SapTable

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

Index or name.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vID As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Script

Manual -> Programming interfaces -> Objectmodel -> Script

Remarks

If several functions should be combined and be executed in the defined order (similar to a batch file), they can be entered into a script.

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_ScriptExample()
'**************** Use this code in the editor ****************

Dim zScript As Script
Dim i As Integer

'Initialize the script object with the first script in the scripts object (list)
Set zScript = MyWorkspace.ActiveDocument.Scripts.Item(0)

'If there is no script available (no script in the scripts object),...
If zScript Is Nothing Then
'...then inform the user
MsgBox ("No Script available")
'otherwise:
Else
'Output the name of the script
Debug.Print "Scriptname: " & zScript.Name

'For every function in the script...
For i = 0 To zScript.Count - 1
'...output the name of the function
Debug.Print i + 1 & ". Function: " & zScript.Item(i).Name
Next i

'Add the picSTART function to the script
zScript.Add (MyWorkspace.ActiveDocument.RtFunctions.Item("picSTART").ID)

'Remove the picSTART function from the script
zScript.Remove (MyWorkspace.ActiveDocument.RtFunctions.Item("picSTART").ID)
End If
End Sub

Other topics in this chapter

Script-Properties

Script-Methods

Script-Dynamic properties


Script-Properties

Manual -> Programming interfaces -> Objectmodel -> Script -> Script-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | Count |  | read only | read only | yes | yes
BSTR | Name |  | available | read only | yes | yes
IScripts | Parent |  | read only | read only | yes | yes

Other topics in this chapter

Parent

Name

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> Script -> Script-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Scripts

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> Script -> Script-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the name of the script.

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> Script -> Script-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Script-Methods

Manual -> Programming interfaces -> Objectmodel -> Script -> Script-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | Add | - | available | not used
void | DynProperties [PUT] | - | available | read only
VARIANT | DynProperties [GET] | - | available | read only
VARIANT | DynPropertiesEnum [GET] | - | available | read only
IRtFunction | Item | - | available | available
VARIANT_BOOL | Remove | - | available | read only
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

Add

Remove

Item

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


Add

Manual -> Programming interfaces -> Objectmodel -> Script -> Script-Methods -> Add

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The Method adds a function to the script package by the corresponding function ID.

Datatype

Add(long nFuncID) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Function ID

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

nFuncID As Long

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_ManageScriptFunctions()
Dim zScript As Script

'Initialize the script object with the first script in the scripts object (list)
Set zScript = MyWorkspace.ActiveDocument.Scripts.Item(0)

'Add the picSTART function to the script
zScript.Add (MyWorkspace.ActiveDocument.RtFunctions.Item("picSTART").ID)

'Remove the picSTART function from the script
zScript.Remove (MyWorkspace.ActiveDocument.RtFunctions.Item("picSTART").ID)
End Sub


Remove

Manual -> Programming interfaces -> Objectmodel -> Script -> Script-Methods -> Remove

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The Method removes a function from the script package by the corresponding function ID.

Datatype

Remove(long nFuncID) As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Parameters

Function ID

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

nFuncID As Long

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_ManageScriptFunctions()
Dim zScript As Script

'Initialize the script object with the first script in the scripts object (list)
Set zScript = MyWorkspace.ActiveDocument.Scripts.Item(0)

'Add the picSTART function to the script
zScript.Add (MyWorkspace.ActiveDocument.RtFunctions.Item("picSTART").ID)

'Remove the picSTART function from the script
zScript.Remove (MyWorkspace.ActiveDocument.RtFunctions.Item("picSTART").ID)
End Sub


Item

Manual -> Programming interfaces -> Objectmodel -> Script -> Script-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the script function at the position vPosition. This method Item only allows accessing with the index.Hint: Check the returned object on Nothing, if no object for the search creteria was found.

Datatype

Item(VARIANT vPosition) As RtFunction

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> Script -> Script-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> Script -> Script-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> Script -> Script-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> Script -> Script-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Script-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> Script -> Script-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Script

Other topics in this chapter

Script


Script

Manual -> Programming interfaces -> Objectmodel -> Script -> Script-Dynamic properties -> Script

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BSTR

Name

Name

Distinct name of the script.

Default: Script_x ( x means a successive number).

Your own scripts can be defined and pre-completed scripts can be selected. Entry of a name in the combobox for your own scripts or selection from a drop-down list:

  • AUTOSTART: The script will be executed automatically at start of the Runtime (individual workplace or server) and after activation of start display (at individual workplace or server) if the project is the Runtime start project.
  • AUTOEND: The script will be executed automatically at end of the Runtime (individual workplace or server) if the project is the Runtime start project.
    Warning: VBA macros which should be carried out in AUTOEND must be called via Project.Inactive. Cyclical archives must not be given in the AUTOEND script.
  • AUTOSTART_CLIENT: The script will be executed automatically at start of the Runtime on a client and before activation of start display on a client if the project is the Runtime start project.
  • AUTOEND_CLIENT: The script will be executed automatically at end of the Runtime on a client if the project is the Runtime start project.
  • AUTOSTART_SRVPRJ: The script will be executed automatically at start of the Runtime on the PC which is the server of the project, before activation of the start display if the project is not the Runtime start project.
  • AUTOEND_SRVPRJ: The script will be executed automatically at end of the Runtime on the PC which is the server of the project if the project is not the Runtime start project.

Attention: This property is not available for language switch.

Hint multi-user projects: When you change the name of scripts, the parameters of the linked functions are adjusted automatically after a control question for Enable changes. After the name has been changed successfully, the script is changed.

More in the online help

ZT_AKZ

SystemModelGroup

Equipment groups

Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group.

More in the online help.


Scripts

Manual -> Programming interfaces -> Objectmodel -> Scripts

Remarks

This object manages scripts.

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_ScriptsExample()
'************ Use this script in the editor ************

Dim zScripts As Scripts
Dim i As Integer

'Initialize the scripts object with the current scripts
Set zScripts = MyWorkspace.ActiveDocument.Scripts

'For every script available in the scripts object...
For i = 0 To zScripts.Count - 1
'...output the name
Debug.Print i + 1 & ". Script: " & zScripts.Item(i).Name
Next i

End Sub

Other topics in this chapter

Scripts-Properties

Scripts-Methods

Scripts-Dynamic properties


Scripts-Properties

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | - | read only | read only
IProject | Parent | - | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Scripts-Methods

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CheckIn | Save module modifications to server (editor). | available | not used
VARIANT_BOOL | CheckOut | Allow module modifications (editor). | available | not used
IScript | Create | - | available | not used
VARIANT_BOOL | Delete | - | available | not used
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | Get | Get the latest version from the server (editor). | available | not used
VARIANT_BOOL | Import | Imports the selected XML file | available | not used
VARIANT_BOOL | IsCheckedOut | Returns true when the current module checked out by the current user (editor). | read only | not used
VARIANT_BOOL | IsDifferent | Return true when the local- and server version are different (editor). | read only | not used
VARIANT_BOOL | IsLocked | Returns true when the current module is Locked by another user (editor). | read only | not used
IScript | Item | - | available | available
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used
VARIANT_BOOL | UndoCheckOut | Undo module modifications (editor). | available | not used
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used

Other topics in this chapter

Item

Create

Delete

Export

SingleExport

Import

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

Get

CheckOut

CheckIn

UndoCheckOut

IsLocked

IsCheckedOut

IsDifferent


Item

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the corresponding script at the position vPosition. This method Item only allows accessing with the index.Hint: Check the returned object on "Nothing", if no object for the search criteria was found.

Datatype

Item(VARIANT vPosition) As Script

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Create

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Methods -> Create

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Create a new script by name as string parameter

Datatype

Create(String bsName) As Script

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Name of the new script as string

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_CreateDeleteScript()
Dim zScripts As Scripts
Dim i As Integer

'Initialize the scripts object with the current scripts
Set zScripts = MyWorkspace.ActiveDocument.Scripts

'Create a new script inside the scripts object
zScripts.Create ("zenOn_ScriptTest")

'Delete a script inside the scripts object
zScripts.Delete ("zenOn_ScriptTest")

End Sub


Delete

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Methods -> Delete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Delete an existing script by name

Datatype

Delete(String bsName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Name of the script as string

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_CreateDeleteScript()
Dim zScripts As Scripts
Dim i As Integer

'Initialize the scripts object with the current scripts
Set zScripts = MyWorkspace.ActiveDocument.Scripts

'Create a new script inside the scripts object
zScripts.Create ("zenOn_ScriptTest")

'Delete a script inside the scripts object
zScripts.Delete ("zenOn_ScriptTest")

End Sub


Export

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export settings to an xml file

Datatype

Export(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SingleExport

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Methods -> SingleExport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SingleExport(VARIANT vIndexOrName,BSTR bsFileName) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Import

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced.

Datatype

Import(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


Get

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Methods -> Get

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype

Get() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckOut

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Methods -> CheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype

CheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckIn

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Methods -> CheckIn

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype

CheckIn() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


UndoCheckOut

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Methods -> UndoCheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype

UndoCheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsLocked

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Methods -> IsLocked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype

IsLocked() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsCheckedOut

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Methods -> IsCheckedOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype

IsCheckedOut() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsDifferent

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Methods -> IsDifferent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype

IsDifferent() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Scripts-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Scripts

Other topics in this chapter

Scripts


Scripts

Manual -> Programming interfaces -> Objectmodel -> Scripts -> Scripts-Dynamic properties -> Scripts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description


State

Manual -> Programming interfaces -> Objectmodel -> State

Remarks

States are utilized by Reaction Matrices, in order to define the characteristics.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_SetStateForBinaryRema(ByRef zRema As Rema)

'Declaration zState
Dim zState As State

'Intialize zState with the first state inside the passed binary rema
Set zState = zRema.StateItem(1)

'Defines the matching bit combination
zState.ReaWert = &H89 'Sets Bit0, Bit3 and Bit7 TRUE
zState.ReaWertMaske = &H81 'Defines that Bit0 and Bit7 will be checked (Bit3 is ignored)

'User message that will be displayed when the event occurs
zState.Text = "Bit combination is matched!"

'Moreover, the first defined function will be called when the event occurs
zState.Function = MyWorkspace.ActiveDocument.RtFunctions.Item(0)
'The function will only be executed when the tpBitFkt is set. Additionaly the tpBitAlarm flag is set too.
zState.Status = tpBitFkt Or tpBitAlarm

End Sub

Private Sub zenOn_SetStateForAnalogRema(ByRef zRema As rema)

'Declaration zState
Dim zState As State

'Intialize zState with the first state inside the passed analog rema
Set zState = zRema.StateItem(1)

'Sets the comparision mode to "greater"
zState.CheckArt = 1

'This definition constitutes the threshold value, where the alarm will be triggered
zState.ReaAlarm = 11

'This definition means that the system will be set back to its normal configuration, when "ReaAlarm" goes below 10 (hysteresis)
zState.Hysterese = 1

'User message that will be displayed when the event occurs
zState.Text = "Limit is reached!"

'Moreover, the first defined function will be called when the event occurs
zState.Function = MyWorkspace.ActiveDocument.RtFunctions.Item(0)
'The function will only be executed when the tpBitFkt is set. Additionaly the tpBitAlarm flag is set too.
zState.Status = tpBitFkt Or tpBitAlarm

End Sub

Other topics in this chapter

State-Properties

State-Methods


State-Properties

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | AllValues |  | available | read only
unsigned | char |  | available | read only
long | CheckArt |  | available | read only
long | ClassIdx |  | available | read only
long | Color |  | available | read only
long | DelayTime | For internal use only | available | available
long | Function |  | available | read only
long | GroupIdx |  | available | read only
double | Hysterese |  | available | available
IRema | Parent |  | read only | read only
long | ReaAlarm |  | available | read only
double | ReaAlarmBis |  | available | read only
long | ReaStatusExt |  | available | read only
long | ReaStatusFlankeExt |  | available | read only
long | ReaStatusFlankeStd |  | available | read only
long | ReaStatusMaskeExt |  | available | read only
long | ReaStatusMaskeStd |  | available | read only
long | ReaStatusStd |  | available | read only
long | ReaWert |  | available | read only
long | ReaWertFlanke |  | available | read only
long | ReaWertMaske |  | available | read only
tpStateBit | Status |  | available | available
BSTR | Text |  | available | read only

Other topics in this chapter

Parent

Text

Status

GroupIdx

ClassIdx

Function

Color

DelayTime

CheckArt

ReaAlarm

ReaWert

ReaWertMaske

ReaWertFlanke

ReaStatusStd

ReaStatusExt

ReaStatusMaskeStd

ReaStatusMaskeExt

ReaStatusFlankeStd

ReaStatusFlankeExt

ReaAlarmBis

AllValues

char

Hysterese


Parent

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Rema

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Text

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> Text

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the text that will be displayed, if the defined limit is reached.

Datatype

Text() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Status

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> Status

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Status() As tpStateBit

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


GroupIdx

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> GroupIdx

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the group index

Datatype

GroupIdx() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ClassIdx

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> ClassIdx

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the class index.

Datatype

ClassIdx() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Function

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> Function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Assigns a function which will be called, when the Reaction Matrix matches.

Datatype

Function() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Color

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> Color

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the color.

Datatype

Color() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


DelayTime

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> DelayTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

HIDDEN

Datatype

DelayTime() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


CheckArt

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> CheckArt

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the comparision method for "ReaAlarm"<ul style="list-style-type:none;"><li>0 &amp;rarr; any</li><li>1 &amp;rarr; greater</li><li>2 &amp;rarr; less</li><li>3 &amp;rarr; equal</li><li>4 &amp;rarr; Area</li></ul>Option 4 (Area) requires "ReaAlarm" as the lower limit and "ReaAlarmBis" as the upper limit to be set.

Datatype

CheckArt() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ReaAlarm

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> ReaAlarm

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the limit value.Hint: The comparision method is selected with the "CheckArt" property.This value constitutes the lower limit of the area, if "CheckArt" option 4 (Area) is selected.

Datatype

ReaAlarm() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ReaWert

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> ReaWert

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The ReaWert DWORD specifies which bit combination (value) should be matched by the binary Reaction Matrices.Hint: Depending on the ReaWertMaske the bits of the DWORD will be checked or ignored.

Datatype

ReaWert() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ReaWertMaske

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> ReaWertMaske

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Has to be set properly, if the bit combination in the ReaWert DWORD should be adhered. Otherwise it will be ingored.

Datatype

ReaWertMaske() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ReaWertFlanke

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> ReaWertFlanke

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Specifies, if the bit combination of the "ReaWert" used by a MultiBinary Rema trigger on edges.

Datatype

ReaWertFlanke() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ReaStatusStd

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> ReaStatusStd

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The ReaStatusStd DWORD specifiecs which state bits are set.

e.g. ReaStatusStd = &H40000 (Hex-Value) means that the I-BIT is set TRUE.
Hint: Depending on the ReaStatusMaskeStd the bits will be checked or ignored.

In order to use state driven trigger (no triggering on edges) for the MultiBinary Rema, the ReaStatusFlankeStd has to be set to &h0.

To set more than one state bit, ORing (logical OR) have to be applied.

e.g. ReaStatusStd = &H100 Or &H4 'SELEC + ST_M3 are set TRUE

The following table gives an overview of common state bits.

Name | Description | Bit Number | Hex Value
ST_M1 | User status bit 1 | 0 | 0x00000001
ST_M2 | available | 1 | 0x00000002
ST_M3 | read only | 2 | 0x00000004
ST_M4 | yes | 3 | 0x00000008
ST_M5 | yes | 4 | 0x00000010
ST_M6 | User status bit 6 | 5 | 0x00000020
ST_M7 | User status bit 7 | 6 | 0x00000040
ST_M8 | User status bit 8 | 7 | 0x00000080
SELEC | Select bit | 8 | 0x00000100
REV | Revision bit | 9 | 0x00000200
DIREC | Desired direction bit | 10 | 0x00000400
RTE | Runtime exceeded bit | 11 | 0x00000800
I-BIT | Invalid bit | 18 | 0x00040000
N_UPDATE | Switched off bit | 20 | 0x00800000
DM_TR | Default message trafo value bit | 24 | 0x01000000
RM_TR | Run message trafo value bit | 25 | 0x02000000
AVALUE | Alternative value bit | 27 | 0x08000000

Datatype

ReaStatusStd() As long
VBA | yes | 0 | 0x00000001
VSTA | yes | 0 | 0x00000001

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_CreateAnalogRema()
Dim zRema As Rema
Dim zState As State

'Create a new analog Rema
Set zRema = MyWorkspace.ActiveDocument.Remas.Create(tpAnalog, "zenOn_TestRema")
'Create a new state
Set zState = zRema.CreateState

'***************************************************************
'* Set the I-Bit TRUE *
'* I-Bit Bit18 *
'* Hint: I-Bit TRUE -> Hex-Value 0x00|04|0000 *
'* / \ *
'* Binary ..0|00000100|0.. *
'* *
'* I-Bit FALSE -> Hex-Value 0x00000000 *
'***************************************************************

'Set the I-Bit TRUE
zState.ReaStatusStd = &H40000
'Set the StateMask for the I-Bit
'Hint: Hex-Value: 0x00040000 -> only I-Bit will be checked
zState.ReaStatusMaskeStd = &H40000

'***************************************************************
'* Check if the ST_M1 is FALSE *
'* ST_M1 Bit0 *
'* Hint: ST_M1 TRUE -> Hex-Value 0x000000| 01 *
'* / \ *
'* Binary ..0|00000001 *
'* ST_M1 FALSE -> Hex-Value 0x00000000 *
'***************************************************************

'Set the ST_M1 FALSE
zState.ReaStatusStd = &H0

'Set the StateMask for the ST_M1 bit
'Hint: Hex-Value: 0x00000001 -> only ST_M1 will be checked
zState.ReaStatusMaskeStd = &H1

'***************************************************************
'* Check both state bits *
'* Combining with ORing (logical OR) *
'***************************************************************

'Set the I-Bit TRUE + the ST_M1 bit FALSE
zState.ReaStatusStd = &H40000 Or &H0
'zState.ReaStatusStd = &H40000 // because ORing with &H0 will not change any bits

'Check the I-Bit + the ST_M1 bit, ignore all other bits
zState.ReaStatusMaskeStd = &H40000 Or &H1 '=&H40001

End Sub


ReaStatusExt

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> ReaStatusExt

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ReaStatusExt() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ReaStatusMaskeStd

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> ReaStatusMaskeStd

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Has to be set properly, if the bit in the ReaStatusStd DWORD should be adhered. Otherwise it will be ingored.<div style="margin-left: 10px;">e.g. I-BIT should be checked &amp;rarr; <span style = "font-family: Courier New;">ReaStatusMaskeStd = &amp;H40000</span></div>Hint: If a state bit should be checked, the corresponding mask is always the hex value of the state bit.The table with the state bits and the hex values can be found in the ReaStatusStd part.<span style="color: #FF0000">In order to check several state bits, the single masks have to be combined by ORing (logical OR).</span><div style="margin-left: 10px;">e.g. <span style = "font-family: Courier New;">ReaStatusMaskeStd = &amp;H4 <SPAN CLASS='KW'>Or</SPAN> &amp;H10 <SPAN CLASS='RM'>'ST_M3 + ST_M5 will be checked</SPAN></span></div>

Datatype

ReaStatusMaskeStd() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ReaStatusMaskeExt

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> ReaStatusMaskeExt

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Has to be set properly, if the bit in the ReaStatusExt DWORD should be adhered. Otherwise it will be ingored.<div style="margin-left: 10px;">e.g. PN_BIT should be checked &amp;rarr; <span style = "font-family: Courier New;">ReaStatusMaskeExt = &amp;H40</span></div>Hint: If a state bit should be checked, the corresponding mask is always the hex value of the state bit.The table with the state bits and the hex values can be found in the ReaStatusExt part.<span style="color: #FF0000">In order to check several state bits, the single masks have to be combined by ORing (logical OR).</span><div style="margin-left: 10px;">e.g. <span style = "font-family: Courier New;">ReaStatusMaskeExt = &amp;H40 <SPAN CLASS='KW'>Or</SPAN> &amp;H1000 <SPAN CLASS='RM'>'PN_BIT + BL_BIT are checked</SPAN></span></div>

Datatype

ReaStatusMaskeExt() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ReaStatusFlankeStd

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> ReaStatusFlankeStd

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ReaStatusFlankeStd() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_CreateMultiBinaryRema()
Dim zRema As Rema
Dim zState As State

'Create a new analog Rema
Set zRema = MyWorkspace.ActiveDocument.Remas.Create(tpMultiBinaer, "zenOn_TestRema")
'Create a new state
Set zState = zRema.CreateState

'Set the I-Bit to trigger on both edges + the ST_M1 on negative edges
zState.ReaStatusFlankeStd = &H40000 Or &H1
zState.ReaStatusMaskeStd = &H0 Or &H1
zState.ReaStatusStd = &H0 Or &H0

End Sub


ReaStatusFlankeExt

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> ReaStatusFlankeExt

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ReaStatusFlankeExt() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ReaAlarmBis

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> ReaAlarmBis

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This value constitutes the upper limit of the area, if "CheckArt" option 4 (Area) is selected. The lower limit is the "ReaAlarm" property.

Datatype

ReaAlarmBis() As double

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


AllValues

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> AllValues

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This Represents the checkbox 'Treat each change of value as new limit violation'

Datatype

AllValues() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


char

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> char

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

char() As unsigned

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Hysterese

Manual -> Programming interfaces -> Objectmodel -> State -> State-Properties -> Hysterese

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the value when the system will be set back to the normal configuration. (Systems leaves triggered state)

Datatype

Hysterese() As double

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


State-Methods

Manual -> Programming interfaces -> Objectmodel -> State -> State-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IState | CreateSubState | - | available | not used
void | DeleteSubState | For internal use only | not used | not used
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
long | GetSubStateCount | - | read only | read only
BOOL | MoveSubState | - | available | not used
IState | SubStateItem | - | available | available
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

GetSubStateCount

CreateSubState

DeleteSubState

SubStateItem

MoveSubState


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> State -> State-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> State -> State-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> State -> State-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> State -> State-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


GetSubStateCount

Manual -> Programming interfaces -> Objectmodel -> State -> State-Methods -> GetSubStateCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get the amount of substates.

Datatype

GetSubStateCount() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateSubState

Manual -> Programming interfaces -> Objectmodel -> State -> State-Methods -> CreateSubState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new substate.

Datatype

CreateSubState() As State

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_CreateSubStateExample(ByRef zState As State)

Dim zSubState As State

'Initialize the zSubState by creating a new substate
Set zSubState = zState.CreateSubState

'e.g. change the color of the substate
zSubState.Color = RGB(0, 128, 128)

End Sub


DeleteSubState

Manual -> Programming interfaces -> Objectmodel -> State -> State-Methods -> DeleteSubState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deltes a SubState object

Datatype

DeleteSubState(VARIANT vID) As void

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SubStateItem

Manual -> Programming interfaces -> Objectmodel -> State -> State-Methods -> SubStateItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a state object, containing the selected substate of the current state.

Datatype

SubStateItem(VARIANT vID) As State

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

Index of the substate.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vID As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_SubStateExample(ByRef zState As State)

Dim zSubState As State

'Initialize the zSubState with the first substate of zState
Set zSubState = zState.SubStateItem(1)

'e.g. change the color of the substate
zSubState.Color = RGB(0, 128, 128)

End Sub


MoveSubState

Manual -> Programming interfaces -> Objectmodel -> State -> State-Methods -> MoveSubState

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Moves the substate within the state one position up- or downwards.<ul style="list-style-type:none;"><li>-1 &amp;rarr; upward</li><li>1 &amp;rarr; downward</li></ul>

Datatype

MoveSubState(VARIANT vID, BOOL bDirection) As BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Index of the substate.

Defines the direction:

-1 Ã¢â€ â€™ upward

1 Ã¢â€ â€™ downward

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vID As Variant

bDirection As BOOL

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_MoveSubStateExample()

Dim zRema As Rema
Dim zState As State
Dim i As Integer

Set zRema = MyWorkspace.ActiveDocument.Remas.Item(0)
Set zState = zRema.StateItem(1)

zState.MoveSubState 2, 0

For i = 0 To zState.GetSubStateCount - 1
Debug.Print zState.SubStateItem(i).Color
Next i

End Sub


SymbolElements

Manual -> Programming interfaces -> Objectmodel -> SymbolElements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This collection contains the 'Element' objects within a symbol. It is possible, that there are symbols in symbols and so on, so it could be neccessary to enumerate the object recursive.

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub SymbolElem()
Dim zPIC As DynPicture
Dim zSymbol As Element
Dim zText As Element
Dim zCircle As Element

Set zPIC = MyWorkspace.ActiveDocument.DynPictures.Item("START")

'create static text element
Set zText = zPIC.Elements.Create("MyStaticText", tpText)
zText.Top = 100
zText.Left = 100

'create circle
Set zCircle = zPIC.Elements.Create("MyStaticCircle", tpCircle)
zCircle.Top = 150
zCircle.Left = 150

'create symbol
Set zSymbol = zPIC.Elements.Create("MyNewSymbol", tpSymbol)
zSymbol.Elements.Add zText
zSymbol.Elements.Add zCircle
zPIC.Save
End Sub

Sub EnumSymbolElements()
Dim zPicture As DynPicture
Dim zSymbol As Element
Dim zSymElements As SymbolElements
Dim i As Integer

'get Picture,(embedded) Symbol, SymbolElements collection...
Set zPicture = MyWorkspace.ActiveDocument.DynPictures.Item("START")
Set zSymbol = zPicture.Elements.Item("MyNewSymbol")
Set zSymElements = zSymbol.Elements

'enumerate all elements within a (embedded) symbol
For i = 0 To zSymElements.Count - 1
Debug.Print zSymElements.Item(i).Name & " [" & zSymElements.Item(i).Top & "/" & zSymElements.Item(i).Left & "]"
Next

End Sub

Other topics in this chapter

SymbolElements-Properties

SymbolElements-Methods


SymbolElements-Properties

Manual -> Programming interfaces -> Objectmodel -> SymbolElements -> SymbolElements-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Returns count of the elements | read only | read only
IElement | Parent | The parent object of the current object | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> SymbolElements -> SymbolElements-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Element

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> SymbolElements -> SymbolElements-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


SymbolElements-Methods

Manual -> Programming interfaces -> Objectmodel -> SymbolElements -> SymbolElements-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | Add | Creates and returns a new Object | available | not used
IElement | Item | Returns a object at a position or by a specified key | available | available
VARIANT_BOOL | Remove | Deletes the objects from collection | available | not used

Other topics in this chapter

Item

Add

Remove


Item

Manual -> Programming interfaces -> Objectmodel -> SymbolElements -> SymbolElements-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a 'Element' object at a position or by name

Datatype

Item(VARIANT vElementID) As Element

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Add

Manual -> Programming interfaces -> Objectmodel -> SymbolElements -> SymbolElements-Methods -> Add

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method will add an exisiting 'Element' object from the picture into the symbol.

Datatype

Add(IElement pElement) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Remove

Manual -> Programming interfaces -> Objectmodel -> SymbolElements -> SymbolElements-Methods -> Remove

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deletes an Element objects from the Symbol.

Datatype

Remove(String nElemId) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Symbols

Manual -> Programming interfaces -> Objectmodel -> Symbols

Remarks

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Other topics in this chapter

Symbols-Properties

Symbols-Methods


Symbols-Properties

Manual -> Programming interfaces -> Objectmodel -> Symbols -> Symbols-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT | SymbolList | Returns a list of available symbols | read only | not used

Other topics in this chapter

SymbolList


SymbolList

Manual -> Programming interfaces -> Objectmodel -> Symbols -> Symbols-Properties -> SymbolList

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SymbolList() As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes


Symbols-Methods

Manual -> Programming interfaces -> Objectmodel -> Symbols -> Symbols-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | Import | Imports the selected XML file | available | not used
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used

Other topics in this chapter

Export

SingleExport

Import


Export

Manual -> Programming interfaces -> Objectmodel -> Symbols -> Symbols-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export a symbol library into a file.

Datatype

Export(String bsLibName,String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Name of Global Symbol Library as string or "" if Projectlibrary is used.

Filename (path) as string of the xml file to export.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsLibName As String

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub Symbol_IMEX()

'export project library
MyWorkspace.ActiveDocument.Symbols.Export "", "C:\TEMP\ProjectLib.xml"

'export specific global library
MyWorkspace.Symbols.Export "Symbolgroup 1", "C:\TEMP\GlobalLib_S1.xml"

'export single symbol
MyWorkspace.ActiveDocument.Symbols.SingleExport "Symbol 2", "", "C:\TEMP\Symbol2.xml"

'import from file
MyWorkspace.ActiveDocument.Symbols.Import "", "C:\TEMP\ProjectLib.xml"

End Sub


SingleExport

Manual -> Programming interfaces -> Objectmodel -> Symbols -> Symbols-Methods -> SingleExport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SingleExport(VARIANT vName,BSTR bsLibName,BSTR bsFileName) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Import

Manual -> Programming interfaces -> Objectmodel -> Symbols -> Symbols-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import a symbol library from file. New settings are added, existing settings will be replaced.

Datatype

Import(String bsLibName,String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Name of Global Symbol Library as string or "" if Projectlibrary is used.

Filename (path) as string of the xml file to import.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsLibName As String

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub Symbol_IMEX()

'export project library
MyWorkspace.ActiveDocument.Symbols.Export "", "C:\TEMP\ProjectLib.xml"

'export specific global library
MyWorkspace.Symbols.Export "Symbolgroup 1", "C:\TEMP\GlobalLib_S1.xml"

'export single symbol
MyWorkspace.ActiveDocument.Symbols.SingleExport "Symbol 2", "", "C:\TEMP\Symbol2.xml"

'import from file
MyWorkspace.ActiveDocument.Symbols.Import "", "C:\TEMP\ProjectLib.xml"

End Sub


SystemModel

Manual -> Programming interfaces -> Objectmodel -> SystemModel

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Create or edit Equipment modeling (SystemModel) .

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Private Sub SystemModel()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim i As Integer
Dim j As Integer
Dim zSystemModel As SystemModel
Dim zSystemModelGroup As SystemModelGroup

Set zProject = MyWorkspace.ActiveDocument

'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then
Exit Sub
End If

'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager

For i = 0 To zSystemModelManager.count - 1
'Get SystemModel
Set zSystemModel = zSystemModelManager.Item(i)
For j = 0 To zSystemModel.count - 1
'Get SystemModelGroup
Set zSystemModelGroup = zSystemModel.Item(j)
Debug.Print (zSystemModelGroup.DynProperties("Name"))
Next j
Next i
End Sub

Other topics in this chapter

SystemModel-Properties

SystemModel-Methods

SystemModel-Dynamic properties


SystemModel-Properties

Manual -> Programming interfaces -> Objectmodel -> SystemModel -> SystemModel-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Count of system groups. | available | not used

Other topics in this chapter

Count


Count

Manual -> Programming interfaces -> Objectmodel -> SystemModel -> SystemModel-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the number of Equipment models(SystemModel) .

Datatype

Count() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub SystemModel()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim i As Integer
Dim j As Integer
Dim zSystemModel As SystemModel
Dim zSystemModelGroup As SystemModelGroup

Set zProject = MyWorkspace.ActiveDocument

'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then
Exit Sub
End If

'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager

For i = 0 To zSystemModelManager.count - 1
'Get SystemModel
Set zSystemModel = zSystemModelManager.Item(i)
For j = 0 To zSystemModel.count - 1
'Get SystemModelGroup
Set zSystemModelGroup = zSystemModel.Item(j)
Debug.Print (zSystemModelGroup.DynProperties("Name"))
Next j
Next i
End Sub


SystemModel-Methods

Manual -> Programming interfaces -> Objectmodel -> SystemModel -> SystemModel-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CreateDynProperty | - | not used | available
void | DynProperties [PUT] | - | available | not used
VARIANT | DynProperties [GET] | - | available | not used
VARIANT | DynPropertiesEnum [GET] | - | available | not used
ISystemModelGroup | Item | Returns the system group at the given index. | available | not used
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

Item

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

CreateDynProperty


Item

Manual -> Programming interfaces -> Objectmodel -> SystemModel -> SystemModel-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get Equipment models group (SystemModelGroup) by index.

Datatype

Item(VARIANT vIndex) As SystemModelGroup

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

object vIndex

Index of the SystemModelGroup.

VB.NET

Dim vIndex As Variant

Index of the SystemModelGroup.

VBA

vIndex As Variant

Index of the SystemModelGroup.

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub SystemModel()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim i As Integer
Dim j As Integer
Dim zSystemModel As SystemModel
Dim zSystemModelGroup As SystemModelGroup

Set zProject = MyWorkspace.ActiveDocument

'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then
Exit Sub
End If

'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager

For i = 0 To zSystemModelManager.count - 1
'Get SystemModel
Set zSystemModel = zSystemModelManager.Item(i)
For j = 0 To zSystemModel.count - 1
'Get SystemModelGroup
Set zSystemModelGroup = zSystemModel.Item(j)
Debug.Print (zSystemModelGroup.DynProperties("Name"))
Next j
Next i
End Sub


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> SystemModel -> SystemModel-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the property parameter as PropParam

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

string bsPath

VB.NET

Dim bsPath As String

VBA

bsPath As String

Examples

C#

public void Macronew()

{

zenOn.IPropParam Param = this.ActiveDocument.get_DynPropertyParam("MultitouchMode");

if (Param.OptionCount > 0)

{

for (int i = 0; i < Param.OptionCount; i++)

{

this.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);

this.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);

}

}

}

VB.NET

Public Sub Macronew()

Dim Param As zenOn.IPropParam = Me.ActiveDocument.get_DynPropertyParam("MultitouchMode")

If Param.OptionCount > 0 Then

For i As Integer = 0 To Param.OptionCount - 1

Me.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)

Me.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)

Next

End If

End Sub

VBA

Public Sub VBAMacro()

Dim obparm As PropParam

Dim n As Integer

Set obparm = thisProject.DynPropertyParam("MultitouchMode")

If (Not obparm Is Nothing) Then

If obparm.OptionCount > 0 Then

For n = 0 To obparm.OptionCount - 1

Debug.Print "Option:" & obparm.OptionText(n)

Debug.Print "Option:" & obparm.OptionValue(n)

Next

End If

End If

End Sub


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> SystemModel -> SystemModel-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Enumerate the Properties of the SystemModelManager collection.

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

string bsPath

A String which defines the entry point to get out all available properties of the object.
A blank String like that returns the first layer of properties ("")...

VB.NET

Dim bsPath As String

A String which defines the entry point to get out all available properties of the object.
A blank String like that returns the first layer of properties ("")...

VBA

bsPath As String

A String which defines the entry point to get out all available properties of the object.
A blank String like that returns the first layer of properties ("")...

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()

Dim vProps As Variant

Dim i As Integer

'get all DynProperties of the actual object (DynPicture, Element, ...) vProps = zenOnObject.DynPropertiesEnum("") 'Print informations of DynProperties into output window

For i = 0 To UBound(vProps) Debug.Print vProps(i)

Next i

End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> SystemModel -> SystemModel-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this Methode its possible to get DynProperties.

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub CreateSystemModel()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zSystemModel As SystemModel

Set zProject = MyWorkspace.ActiveDocument

'Equipment Model ( SystemModel) only exist in the global project.
If Not zProject.IsGlobal Then
Exit Sub
End If

'Get the EquipmentModel (SystemModel)
Set zSystemModelManager = zProject.SystemModelManager

'Get the name of the SystemModel
Debug.Print(zSystemModelManager.DynProperties("Modules[" & (zSystemModelManager.count - 1) & "].Name"))

End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> SystemModel -> SystemModel-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

string bsPath

A String which defines the Property.

object vValue

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

VB.NET

Dim bsPath As String

A String which defines the Property.

Dim vValue As Variant

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

VBA

bsPath As String

A String which defines the Property.

vValue As Variant

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub CreateSystemModel()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zSystemModel As SystemModel

Set zProject = MyWorkspace.ActiveDocument

'Equipment Model ( SystemModel) only exist in the global project.
If Not zProject.IsGlobal Then
Exit Sub
End If

'Get the EquipmentModel (SystemModel)
Set zSystemModelManager = zProject.SystemModelManager
Stop
'Now we create a new SystemModel
zSystemModelManager.CreateDynProperty ("Modules[" & zSystemModelManager.count & "]")
'Set the name of the SystemModel
zSystemModelManager.DynProperties("Modules[" & (zSystemModelManager.count - 1) & "].Name") = "Test"
End Sub


CreateDynProperty

Manual -> Programming interfaces -> Objectmodel -> SystemModel -> SystemModel-Methods -> CreateDynProperty

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this Methode it is possible to create a new Equipment Model (SystemModel).

Datatype

CreateDynProperty(String bsPath) As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub CreateSystemModel()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zSystemModel As SystemModel

Set zProject = MyWorkspace.ActiveDocument

'Equipment Model ( SystemModel) only exist in the global project.
If Not zProject.IsGlobal Then
Exit Sub
End If

'Get the EquipmentModel (SystemModel)
Set zSystemModelManager = zProject.SystemModelManager
Stop
'Now we create a new SystemModel
zSystemModelManager.CreateDynProperty ("Modules[" & zSystemModelManager.count & "]")
'Set the name of the SystemModel
zSystemModelManager.DynProperties("Modules[" & (zSystemModelManager.count - 1) & "].Name") = "Test"
End Sub


SystemModel-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> SystemModel -> SystemModel-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

System model

Other topics in this chapter

System model


System model

Manual -> Programming interfaces -> Objectmodel -> SystemModel -> SystemModel-Dynamic properties -> System model

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Name | Name | Name of the model. Is assigned automatically with successive number during creation and can be changed at will. Default: ModelX (X stands for a successive number) More in the online help
VT_BSTR | Guid | Guid |


SystemModelGroup

Manual -> Programming interfaces -> Objectmodel -> SystemModelGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Create or edit Equipment modeling group(SystemModelGroup) .

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Private Sub SystemModelGroups()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zName As String
Dim zGuid As String
Dim i As Integer
Dim zSymModGuid As SystemModel
Dim zSymModGroupChild As SystemModelGroup
Dim zSymModGroup As SystemModelGroup

Set zProject = MyWorkspace.ActiveDocument

'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then
Exit Sub
End If

'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager

'Get SystemModelGroup (Equipment Group)by guid
Set zSymModGroup = zSystemModelManager.Item(0).Item(0)
If Not zSymModGroup Is Nothing Then
'Show SystemModelGroup
Debug.Print (zSymModGroup.DynProperties("Name"))
If zSymModGroup.count > 0 Then
Set zSymModGroupChild = zSymModGroup.Item(0)
'Show child SystemModelGroup
Debug.Print (zSymModGroupChild.DynProperties("Name"))
End If
Else
Debug.Print ("NOTHING")
End If
End Sub

Other topics in this chapter

SystemModelGroup-Properties

SystemModelGroup-Methods

SystemModelGroup-Dynamic properties


SystemModelGroup-Properties

Manual -> Programming interfaces -> Objectmodel -> SystemModelGroup -> SystemModelGroup-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Count of system groups. | available | not used

Other topics in this chapter

Count


Count

Manual -> Programming interfaces -> Objectmodel -> SystemModelGroup -> SystemModelGroup-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the number of SystemModelGroup item.

Datatype

Count() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub SystemModelGroups()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zName As String
Dim zGuid As String
Dim i As Integer
Dim zSymModGuid As SystemModel
Dim zSymModGroupChild As SystemModelGroup
Dim zSymModGroup As SystemModelGroup

Set zProject = MyWorkspace.ActiveDocument

'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then
Exit Sub
End If

'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager

'Get SystemModelGroup (Equipment Group)by guid
Set zSymModGroup = zSystemModelManager.Item(0).Item(0)
If Not zSymModGroup Is Nothing Then
'Show SystemModelGroup
Debug.Print (zSymModGroup.DynProperties("Name"))
If zSymModGroup.count > 0 Then
Set zSymModGroupChild = zSymModGroup.Item(0)
'Show child SystemModelGroup
Debug.Print (zSymModGroupChild.DynProperties("Name"))
End If
Else
Debug.Print ("NOTHING")
End If
End Sub


SystemModelGroup-Methods

Manual -> Programming interfaces -> Objectmodel -> SystemModelGroup -> SystemModelGroup-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CreateDynProperty | - | not used | available
void | DynProperties [PUT] | - | available | not used
VARIANT | DynProperties [GET] | - | available | not used
VARIANT | DynPropertiesEnum [GET] | - | available | not used
ISystemModelGroup | Item | Returns the system group at the given index. | available | not used
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

Item

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

CreateDynProperty


Item

Manual -> Programming interfaces -> Objectmodel -> SystemModelGroup -> SystemModelGroup-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Child SystemModelGroup.

Datatype

Item(VARIANT vIndex) As SystemModelGroup

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

object vIndex

Index of the child SystemModelGroup.

VB.NET

Dim vIndex As Variant

Index of the child SystemModelGroup.

VBA

vIndex As Variant

Index of the child SystemModelGroup.

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub SystemModelGroups()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zName As String
Dim zGuid As String
Dim i As Integer
Dim zSymModGuid As SystemModel
Dim zSymModGroupChild As SystemModelGroup
Dim zSymModGroup As SystemModelGroup

Set zProject = MyWorkspace.ActiveDocument

'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then
Exit Sub
End If

'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager

'Get SystemModelGroup (Equipment Group)by guid
Set zSymModGroup = zSystemModelManager.Item(0).Item(0)
If Not zSymModGroup Is Nothing Then
'Show SystemModelGroup
Debug.Print (zSymModGroup.DynProperties("Name"))
If zSymModGroup.count > 0 Then
Set zSymModGroupChild = zSymModGroup.Item(0)
'Show child SystemModelGroup
Debug.Print (zSymModGroupChild.DynProperties("Name"))
End If
Else
Debug.Print ("NOTHING")
End If
End Sub


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> SystemModelGroup -> SystemModelGroup-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the property parameter as PropParam

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

string bsPath

VB.NET

Dim bsPath As String

VBA

bsPath As String

Examples

C#

public void Macronew()

{

zenOn.IPropParam Param = this.ActiveDocument.get_DynPropertyParam("MultitouchMode");

if (Param.OptionCount > 0)

{

for (int i = 0; i < Param.OptionCount; i++)

{

this.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);

this.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);

}

}

}

VB.NET

Public Sub Macronew()

Dim Param As zenOn.IPropParam = Me.ActiveDocument.get_DynPropertyParam("MultitouchMode")

If Param.OptionCount > 0 Then

For i As Integer = 0 To Param.OptionCount - 1

Me.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)

Me.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)

Next

End If

End Sub

VBA

Public Sub VBAMacro()

Dim obparm As PropParam

Dim n As Integer

Set obparm = thisProject.DynPropertyParam("MultitouchMode")

If (Not obparm Is Nothing) Then

If obparm.OptionCount > 0 Then

For n = 0 To obparm.OptionCount - 1

Debug.Print "Option:" & obparm.OptionText(n)

Debug.Print "Option:" & obparm.OptionValue(n)

Next

End If

End If

End Sub


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> SystemModelGroup -> SystemModelGroup-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Enumerate the Properties of the SystemModelGroup collection.

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

string bsPath

A String which defines the entry point to get out all available properties of the object.
A blank String like that returns the first layer of properties ("")...

VB.NET

Dim bsPath As String

A String which defines the entry point to get out all available properties of the object.
A blank String like that returns the first layer of properties ("")...

VBA

bsPath As String

A String which defines the entry point to get out all available properties of the object.
A blank String like that returns the first layer of properties ("")...

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()

Dim vProps As Variant

Dim i As Integer

'get all DynProperties of the actual object (DynPicture, Element, ...) vProps = zenOnObject.DynPropertiesEnum("") 'Print informations of DynProperties into output window

For i = 0 To UBound(vProps) Debug.Print vProps(i)

Next i

End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> SystemModelGroup -> SystemModelGroup-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this Methode its possible to get DynProperties.

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

string bsPath

A String which defines the Property.

VB.NET

Dim bsPath As String

A String which defines the Property.

VBA

bsPath As String

A String which defines the Property.

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Dim zSystemModelManager As SystemModelManager

Dim zProject As Project

Dim zName As String

Dim zGuid As String

Dim i As Integer

Dim zSymModGuid As SystemModel

Dim zSymModGroupChild As SystemModelGroup

Dim zSymModGroup As SystemModelGroup

Set zProject = MyWorkspace.ActiveDocument

'Equipment Model ( System Model) only exist in the global project.

If Not zProject.IsGlobal Then

Exit Sub

End If

'Get the Equipment Model

Set zSystemModelManager = zProject.SystemModelManager

'Get SystemModelGroup (Equipment Group)by guid

Set zSymModGroup = zSystemModelManager.Item(0).Item(0)

If Not zSymModGroup Is Nothing Then

'Show SystemModelGroup Debug.Print (zSymModGroup.DynProperties("Name"))

If zSymModGroup.count > 0 Then

Set zSymModGroupChild = zSymModGroup.Item(0) 'Create a new child SystemModelGrou zSymModGroupChild.CreateDynProperty ("SystemModelGroup[" & zSymModGroup.count & "]") 'Set Name 'Set the name of the SystemModelGroup zSymModGroupChild.DynProperties("SystemModelGroup[" & (zSymModGroup.count - 1) & "].Name") = "Test" 'Show the new child SystemModelGroup Debug.Print (zSymModGroupChild.DynProperties("SystemModelGroup[" & (zSymModGroup.count - 1) & "].Name"))

End If

Else

Debug.Print ("NOTHING")

End If

End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> SystemModelGroup -> SystemModelGroup-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this Methode its possible to set DynProperties.

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

string bsPath

A String which defines the Property.

object vValue

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

VB.NET

Dim bsPath As String

A String which defines the Property.

Dim vValue As Variant

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

VBA

bsPath As String

A String which defines the Property.

vValue As Variant

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Dim zSystemModelManager As SystemModelManager

Dim zProject As Project

Dim zName As String

Dim zGuid As String

Dim i As Integer

Dim zSymModGuid As SystemModel

Dim zSymModGroupChild As SystemModelGroup

Dim zSymModGroup As SystemModelGroup

Set zProject = MyWorkspace.ActiveDocument

'Equipment Model ( System Model) only exist in the global project.

If Not zProject.IsGlobal Then

Exit Sub

End If

'Get the Equipment Model

Set zSystemModelManager = zProject.SystemModelManager

'Get SystemModelGroup (Equipment Group)by guid

Set zSymModGroup = zSystemModelManager.Item(0).Item(0)

If Not zSymModGroup Is Nothing Then

'Show SystemModelGroup Debug.Print (zSymModGroup.DynProperties("Name"))

If zSymModGroup.count > 0 Then

Set zSymModGroupChild = zSymModGroup.Item(0) 'Create a new child SystemModelGrou zSymModGroupChild.CreateDynProperty ("SystemModelGroup[" & zSymModGroup.count & "]") 'Set Name 'Set the name of the SystemModelGroup zSymModGroupChild.DynProperties("SystemModelGroup[" & (zSymModGroup.count - 1) & "].Name") = "Test" 'Show the new child SystemModelGroup Debug.Print (zSymModGroupChild.DynProperties("SystemModelGroup[" & (zSymModGroup.count - 1) & "].Name"))

End If

Else

Debug.Print ("NOTHING")

End If

End Sub


CreateDynProperty

Manual -> Programming interfaces -> Objectmodel -> SystemModelGroup -> SystemModelGroup-Methods -> CreateDynProperty

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this Methode it is possible to create a new Equipment Model groups (SystemModelGroup).

Datatype

CreateDynProperty(String bsPath) As Boolean

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

string bsPath

DynProperty as String to be created.

VB.NET

Dim bsPath As String

DynProperty as String to be created.

VBA

bsPath As String

DynProperty as String to be created.

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Dim zSystemModelManager As SystemModelManager

Dim zProject As Project

Dim zName As String

Dim zGuid As String

Dim i As Integer

Dim zSymModGuid As SystemModel

Dim zSymModGroupChild As SystemModelGroup

Dim zSymModGroup As SystemModelGroup

Set zProject = MyWorkspace.ActiveDocument

'Equipment Model ( System Model) only exist in the global project.

If Not zProject.IsGlobal Then

Exit Sub End If

'Get the Equipment Model

Set zSystemModelManager = zProject.SystemModelManager

'Get SystemModelGroup (Equipment Group)by guid

Set zSymModGroup = zSystemModelManager.Item(0).Item(0)

If Not zSymModGroup Is Nothing Then

'Show SystemModelGroup Debug.Print (zSymModGroup.DynProperties("Name"))

If zSymModGroup.count > 0 Then

Set zSymModGroupChild = zSymModGroup.Item(0)

'Create a new child SystemModelGrou

zSymModGroupChild.CreateDynProperty ("SystemModelGroup[" & zSymModGroup.count & "]")

'Set Name 'Set the name of the SystemModelGroup zSymModGroupChild.DynProperties("SystemModelGroup[" & (zSymModGroup.count - 1) & "].Name") = "Test" 'Show the new child SystemModelGroup Debug.Print (zSymModGroupChild.DynProperties("SystemModelGroup[" & (zSymModGroup.count - 1) & "].Name"))

End If

Else

Debug.Print ("NOTHING")

End If

End Sub


SystemModelGroup-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> SystemModelGroup -> SystemModelGroup-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

System model group

Other topics in this chapter

System model group


System model group

Manual -> Programming interfaces -> Objectmodel -> SystemModelGroup -> SystemModelGroup-Dynamic properties -> System model group

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Name | Name | Name of the group. Is assigned automatically with successive number during creation and can be changed at will. Default: GroupX (X stands for a successive number) More in the online help
VT_BSTR | Guid | Guid |


SystemModelManager

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The SystemModelManager represent the project node Equipment modeling from a global project.
Create or edit Equipment modeling (SystemModel) and Equipment group (SystemModelGroup) are possible.

A global project is needed!

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Private Sub SystemModelManager()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zName As String
Dim zGuid As String
Dim i As Integer
Dim zSymModGuid As SystemModel
Dim zSymModGroupChild As SystemModelGroup
Dim zSymModGroup As SystemModelGroup

Stop
Set zProject = MyWorkspace.ActiveDocument

'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then
Exit Sub
End If

'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager

Debug.Print ("Number of System Models : " & zSystemModelManager.count)

'SystemModel (First node in the Equipment Model)
Debug.Print (zSystemModelManager.Item(0).DynProperties("Name"))
Debug.Print (zSystemModelManager.Item(0).DynProperties("Guid"))
zName = zSystemModelManager.Item(0).DynProperties("Name")

'Get the SystemModel by Name
Set zSymModGuid = zSystemModelManager.ModelByName(zName)
If Not zSymModGuid Is Nothing Then
Debug.Print (zSymModGuid.DynProperties("Name"))
Else
Debug.Print ("NOTHING")
End If

'SystemModelGroup (Equipment Group)
Debug.Print (zSystemModelManager.Item(0).Item(0).DynProperties("Name"))
Debug.Print (zSystemModelManager.Item(0).Item(0).DynProperties("Guid"))
zGuid = zSystemModelManager.Item(0).Item(0).DynProperties("Guid")

'Get SystemModelGroup (Equipment Group)by guid
Set zSymModGroup = zSystemModelManager.GroupByGuid(zGuid)
If Not zSymModGroup Is Nothing Then
Debug.Print (zSymModGroup.DynProperties("Name"))
If zSymModGroup.count > 0 Then
Set zSymModGroupChild = zSymModGroup.Item(0)
Debug.Print (zSymModGroupChild.DynProperties("Name"))
End If
Else
Debug.Print ("NOTHING")
End If
End Sub

Other topics in this chapter

SystemModelManager-Properties

SystemModelManager-Methods

SystemModelManager-Events

SystemModelManager-Dynamic properties


SystemModelManager-Properties

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager -> SystemModelManager-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | - | available | not used

Other topics in this chapter

Count


Count

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager -> SystemModelManager-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Number of Equipment Models (SystemModel)

Datatype

Count() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub SystemModelManagerItem()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim i As Integer

Set zProject = MyWorkspace.ActiveDocument

'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then
Exit Sub
End If

'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager

For i = 0 To zSystemModelManager.count - 1
'Show the name of the SystemModel
Debug.Print (zSystemModelManager.Item(i).DynProperties("Name"))
Next i
End Sub


SystemModelManager-Methods

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager -> SystemModelManager-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
VARIANT_BOOL | CreateDynProperty | - | available | not used | yes | yes
void | DynProperties [PUT] | - | available | not used | yes | yes
VARIANT | DynProperties [GET] | - | available | not used | yes | yes
VARIANT | DynPropertiesEnum [GET] | - | available | not used | yes | yes
ISystemModelGroup | GroupByGuid | Returns the system group with the given id (guid). | available | not used | yes | yes
ISystemModel | Item | Returns the system model at the given index. | available | not used | yes | yes
ISystemModel | ModelByName | Returns the system model with the given id (guid). | available | not used | yes | yes
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used | yes | yes
VARIANT_BOOL | Export | Exports system model list | available | not used | yes | yes
VARIANT_BOOL | Import | Imports system model list | available | not used | yes | yes

Other topics in this chapter

Item

ModelByName

GroupByGuid

Export

Import

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

CreateDynProperty


Item

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager -> SystemModelManager-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the Equipment Model (SystemModel) by index.

Datatype

Item(VARIANT vIndex) As SystemModel

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

object vIndex

VB.NET

Dim vIndex As Variant

VBA

vIndex As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub SystemModelManagerItem()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim i As Integer

Set zProject = MyWorkspace.ActiveDocument

'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then
Exit Sub
End If

'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager

For i = 0 To zSystemModelManager.count - 1
'Show the name of the SystemModel
Debug.Print (zSystemModelManager.Item(i).DynProperties("Name"))
Next i
End Sub


ModelByName

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager -> SystemModelManager-Methods -> ModelByName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the Name of the Equipment Model (SystemModel).

Datatype

ModelByName(String bsName) As SystemModel

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

string bsName

VB.NET

Dim bsName As String

VBA

bsName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub SystemModelManager()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zName As String
Dim zSymModGuid As SystemModel

Stop
Set zProject = MyWorkspace.ActiveDocument

'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then
Exit Sub
End If

'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager

Debug.Print ("Number of System Models : " & zSystemModelManager.count)

'SystemModel (First node in the Equipment Model)
Debug.Print (zSystemModelManager.Item(0).DynProperties("Name"))
Debug.Print (zSystemModelManager.Item(0).DynProperties("Guid"))
zName = zSystemModelManager.Item(0).DynProperties("Name")

'Get the SystemModel by Name
Set zSymModGuid = zSystemModelManager.ModelByName(zName)
If Not zSymModGuid Is Nothing Then
Debug.Print (zSymModGuid.DynProperties("Name"))
Else
Debug.Print ("NOTHING")
End If

End Sub


GroupByGuid

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager -> SystemModelManager-Methods -> GroupByGuid

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the Guid of the Equipment Model Group (SystemModelGroup).

Datatype

GroupByGuid(String bsGuid) As SystemModelGroup

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

string bsGuid

VB.NET

Dim bsGuid As String

VBA

bsGuid As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub SystemModelManager()
Dim zSystemModelManager As SystemModelManager
Dim zProject As Project
Dim zGuid As String
Dim i As Integer
Dim zSymModGuid As SystemModel
Dim zSymModGroup As SystemModelGroup

Stop
Set zProject = MyWorkspace.ActiveDocument

'Equipment Model ( System Model) only exist in the global project.
If Not zProject.IsGlobal Then
Exit Sub
End If

'Get the Equipment Model
Set zSystemModelManager = zProject.SystemModelManager

'Get guid of any SystemModelGroup (Equipment Group)
zGuid = zSystemModelManager.Item(0).Item(0).DynProperties("Guid")

'Get SystemModelGroup (Equipment Group)by guid
Set zSymModGroup = zSystemModelManager.GroupByGuid(zGuid)
If Not zSymModGroup Is Nothing Then
Debug.Print (zSymModGroup.DynProperties("Name"))
Else
Debug.Print ("NOTHING")
End If
End Sub


Export

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager -> SystemModelManager-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export settings to an xml file

Datatype

Export(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to export.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub Project Active()

Set mypicevents = thisProject.Dynpictures

Stop

thisProject.SystemModelManager.Export("AnlagenmodellEditorB.xml")

thisProject.SystemModelManager.Import("AnlagenmodellEditorB.xml")
End Sub


Import

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager -> SystemModelManager-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import settings from an xml file. Existing settings will be replaced/merged.

Datatype

Import(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to import.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub Project Active()

Set mypicevents = thisProject.Dynpictures

Stop

thisProject.SystemModelManager.Export("AnlagenmodellEditorB.xml")

thisProject.SystemModelManager.Import("AnlagenmodellEditorB.xml")
End Sub


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager -> SystemModelManager-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the property parameter as PropParam

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

string bsPath

VB.NET

Dim bsPath As String

VBA

bsPath As String

Examples

C#

public void Macronew()

{

zenOn.IPropParam Param = this.ActiveDocument.get_DynPropertyParam("MultitouchMode");

if (Param.OptionCount > 0)

{

for (int i = 0; i < Param.OptionCount; i++)

{

this.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);

this.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr);

}

}

}

VB.NET

Public Sub Macronew()

Dim Param As zenOn.IPropParam = Me.ActiveDocument.get_DynPropertyParam("MultitouchMode")

If Param.OptionCount > 0 Then

For i As Integer = 0 To Param.OptionCount - 1

Me.Application.DebugPrint(Param.OptionText(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)

Me.Application.DebugPrint(Param.OptionValue(i).ToString(), zenOn.tpDebugPrintStyle.tpErr)

Next

End If

End Sub

VBA

Public Sub VBAMacro()

Dim obparm As PropParam

Dim n As Integer

Set obparm = thisProject.DynPropertyParam("MultitouchMode")

If (Not obparm Is Nothing) Then

If obparm.OptionCount > 0 Then

For n = 0 To obparm.OptionCount - 1

Debug.Print "Option:" & obparm.OptionText(n)

Debug.Print "Option:" & obparm.OptionValue(n)

Next

End If

End If

End Sub


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager -> SystemModelManager-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Enumerate the Properties of the SystemModelManager collection.

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.
A blank String like that returns the first layer of properties ("")...

C#

string bsPath

VB.NET

Dim bsPath As String

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()

Dim vProps As Variant

Dim i As Integer

'get all DynProperties of the actual object (DynPicture, Element, ...) vProps = zenOnObject.DynPropertiesEnum("") 'Print informations of DynProperties into output window

For i = 0 To UBound(vProps) Debug.Print vProps(i)

Next i

End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager -> SystemModelManager-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Read and/or change the Properties of the SystemModelManager collection. See: SystemModelManager

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager -> SystemModelManager-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Set the Properties of the SystemModelManager collection. See: SystemModelManager

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


CreateDynProperty

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager -> SystemModelManager-Methods -> CreateDynProperty

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Create Subitems of the SystemModelManager collection. See: SystemModelManager

Datatype

CreateDynProperty(String bsPath) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


SystemModelManager-Events

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager -> SystemModelManager-Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
void | ModelGroupSelected |  | not used | available | yes | yes

Other topics in this chapter

ModelGroupSelected


ModelGroupSelected

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager -> SystemModelManager-Events -> ModelGroupSelected

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ModelGroupSelected(BSTR bsGuid, BSTR bsName) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


SystemModelManager-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager -> SystemModelManager-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

System model manager

Other topics in this chapter

CSystemModelFilter

System model manager


CSystemModelFilter

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager -> SystemModelManager-Dynamic properties -> CSystemModelFilter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


System model manager

Manual -> Programming interfaces -> Objectmodel -> SystemModelManager -> SystemModelManager-Dynamic properties -> System model manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description


Task

Manual -> Programming interfaces -> Objectmodel -> Task

Remarks

A task is a VisualBasicScript file and can be executed over the Tasks/Task object model.Here is a sample how to configure a task to run only once and starts event triggered:<img src="../../../private/task_settings.jpg"></img>Tasks can also be configured cyclic, then VBA is not needed to use them...

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public Sub StartTask()
Dim zTask As Task

'get task by its name...
Set zTask = thisProject.Tasks.Item("Task1")

'get task properties...
Debug.Print "CountVariable: " & zTask.CountVariable
Debug.Print "ActualCycleTime: " & zTask.ActualCycleTime
Debug.Print "CycleTime: " & zTask.CycleTime
Debug.Print "ErrorNumber: " & zTask.ErrorNumber
Debug.Print "ErrorString: " & zTask.ErrorString
Debug.Print "Priority: " & zTask.Priority
Debug.Print "Status: " & zTask.Status

'run task
zTask.Run

End Sub

Other topics in this chapter

Task-Properties

Task-Methods

Task-Events


Task-Properties

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | ActualCycleTime |  | available | read only | yes | yes
long | CountVariable |  | available | read only | yes | yes
long | CycleTime |  | available | read only | yes | yes
long | ErrorNumber |  | available | available | yes | yes
BSTR | ErrorString |  | available | available | yes | yes
BSTR | Name |  | available | read only | yes | yes
ITasks | Parent |  | read only | read only | yes | yes
long | Priority |  | available | read only | yes | yes
tpTaskStatus | Status |  | read only | read only | yes | yes
tpTaskTyp | Type |  | available | read only | yes | yes

Other topics in this chapter

Parent

Name

Type

Priority

CycleTime

ActualCycleTime

Status

ErrorNumber

ErrorString

CountVariable


Parent

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Tasks

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Unique name of the task.

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Type

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Properties -> Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Tasks can be executed "cyclic" or "once".

Datatype

Type() As tpTaskTyp

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Priority

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Properties -> Priority

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Process priority for the operating system multi-threading (idle, low, normal, high, highest, time critical)Default: normalMain process: the task runs in the same thread as the Runtime. If the task gets into a waiting loop or crashes, that also influences the Runtime.

Datatype

Priority() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


CycleTime

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Properties -> CycleTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Defined cycle time of the task

Datatype

CycleTime() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ActualCycleTime

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Properties -> ActualCycleTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Currently achieved cycle time of the task

Datatype

ActualCycleTime() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Status

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Properties -> Status

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the status of a task.

Datatype

Status() As tpTaskStatus

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ErrorNumber

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Properties -> ErrorNumber

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains an error number.

Datatype

ErrorNumber() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


ErrorString

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Properties -> ErrorString

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Contains an error message as string.

Datatype

ErrorString() As String

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


CountVariable

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Properties -> CountVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Number of variables linked to the task

Datatype

CountVariable() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Task-Methods

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IVariable | ItemVariable | - | available | available
void | MemValue [PUT] | - | available | available
VARIANT | MemValue [GET] | - | available | available
void | Run | - | available | available
void | Sleep | - | available | available
VARIANT_BOOL | StartTimer | - | available | available
void | Stop | - | available | available
VARIANT_BOOL | StopTimer | - | available | available
void | Value [PUT] | - | available | available
VARIANT | Value [GET] | - | available | available
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used
VARIANT_BOOL | StartTimer | - | available | available
VARIANT_BOOL | StopTimer | - | available | available
void | Sleep | - | available | available
void | Run | - | available | available
void | Stop | - | available | available
VARIANT | Value [GET] | - | available | available
void | Value [PUT] | - | available | available

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

StartTimer

StopTimer

Sleep

Run

Stop

MemValue [GET]

MemValue [PUT]

Value [GET]

Value [PUT]

ItemVariable


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


StartTimer

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Methods -> StartTimer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

StartTimer(long lID,long msTime) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


StopTimer

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Methods -> StopTimer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

StopTimer(long lID) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Sleep

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Methods -> Sleep

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Sleep(long msTime) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Run

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Methods -> Run

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Run() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Stop

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Methods -> Stop

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Stop() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


MemValue [GET]

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Methods -> MemValue [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MemValue(String Name) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


MemValue [PUT]

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Methods -> MemValue [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

MemValue (String Name,VARIANT newValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Value [GET]

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Methods -> Value [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Value [GET](BSTR Name,|optional|VARIANT vIndex) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Value [PUT]

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Methods -> Value [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Value [PUT](BSTR Name,|optional|VARIANT vIndex,VARIANT newValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


ItemVariable

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Methods -> ItemVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a variable object.

Datatype

ItemVariable(VARIANT vPv) As Variable

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Task-Events

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description |  | Editor | Runtime
void | Exit |  | available |  | available
void | Init |  | available |  | available
void | Main |  | available |  | available
void | Timer |  | available |  | available

Other topics in this chapter

Init

Main

Timer

Exit


Init

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Events -> Init

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is automatically executed when starting the task.

Datatype

Init() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Main

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Events -> Main

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is either executed once (type once) or cyclically (type cyclic).

Datatype

Main() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Timer

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Events -> Timer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is executed cyclically, as long as the according time is running. The cycle time is defined as a parameter with the starting of the timer.

Datatype

Timer(long lID) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Exit

Manual -> Programming interfaces -> Objectmodel -> Task -> Task-Events -> Exit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is automatically executed when stopping the task.

Datatype

Exit() As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Tasks

Manual -> Programming interfaces -> Objectmodel -> Tasks

Remarks

This object contains a collection of tasks, tasks can be defined with the 'Process Control Engine' (PCE).A task is a VisualBasicScript file and can be executed over the Tasks/Task object model.Here is a sample how to configure a task to run only once and starts event triggered:<img src="../../../private/task_settings.jpg"></img>Tasks can also be configured cyclic, then VBA is not needed to use them...

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public Sub StartTask()
Dim zTask As Task

'get task by its name...
Set zTask = thisProject.Tasks.Item("Task1")

'get task properties...
Debug.Print "CountVariable: " & zTask.CountVariable
Debug.Print "ActualCycleTime: " & zTask.ActualCycleTime
Debug.Print "CycleTime: " & zTask.CycleTime
Debug.Print "ErrorNumber: " & zTask.ErrorNumber
Debug.Print "ErrorString: " & zTask.ErrorString
Debug.Print "Priority: " & zTask.Priority
Debug.Print "Status: " & zTask.Status

'run task
zTask.Run

End Sub

Other topics in this chapter

Tasks-Properties

Tasks-Methods


Tasks-Properties

Manual -> Programming interfaces -> Objectmodel -> Tasks -> Tasks-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | read only | read only
IProject | Parent |  | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> Tasks -> Tasks-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> Tasks -> Tasks-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Tasks-Methods

Manual -> Programming interfaces -> Objectmodel -> Tasks -> Tasks-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
ITask | Item | - | available | available

Other topics in this chapter

Item


Item

Manual -> Programming interfaces -> Objectmodel -> Tasks -> Tasks-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Single Task Item represents a vbs file.

Datatype

Item(String Name) As Task

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Template

Manual -> Programming interfaces -> Objectmodel -> Template

Remarks

The Frame contains general information on the outer appearance of the Screens. Each Screen is linked to a Frame. The VBA object for the Frames contains the most important information, e.g. name and position on the screen.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Private Sub GetTemplates()
Dim IMDITemplates As MDITemplates
Dim IMDITemplate As MDITemplate
Dim Count As Integer
Dim Ok As Boolean
Dim i As Integer

' --- Selection by Name
Set IMDITemplates = MyWorkspace.GetMDiTemplates("Keyboard")
If Not IMDITemplates Is Nothing Then
Set IMDITemplate = IMDITemplates.Item("Test 3")
Ok = PrintTemplate(IMDITemplate)
End If

' --- Selection by index (zenon Constant)
Set IMDITemplates = MyWorkspace.GetMDiTemplates(tpKeyboard)
If Not IMDITemplates Is Nothing Then
Count = IMDITemplates.Count
For i = 0 To Count - 1
Set IMDITemplate = IMDITemplates.Item(i)
Ok = PrintTemplate(IMDITemplate)
Next
End If
End Sub

Private Function PrintTemplate(IMDITemplate As MDITemplate) As Boolean
If Not IMDITemplate Is Nothing Then
Debug.Print ("Name: " & IMDITemplate.DynProperties("Name"))
Debug.Print ("GUID: " & IMDITemplate.DynProperties("GUID"))
Debug.Print ("ImportPath: " & IMDITemplate.DynProperties("ImportPath"))
Debug.Print ("Folder: " & IMDITemplate.DynProperties("Folder"))
Debug.Print ("MDIType: " & IMDITemplate.DynProperties("MDIType"))
Debug.Print ("Language: " & IMDITemplate.DynProperties("Language"))
Debug.Print ("Description: " & IMDITemplate.DynProperties("Description"))
Debug.Print ("CopaDataTemplate: " & IMDITemplate.DynProperties("CopaDataTemplate"))
Debug.Print ("DefaultTemplate: " & IMDITemplate.DynProperties("DefaultTemplate"))
PrintTemplate = True
Else
PrintTemplate = False
End If
End Function

Other topics in this chapter

Template-Properties

Template-Methods

Template-Dynamic properties


Template-Properties

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
BSTR | BackgroundImage | Image for the Template | available | read only
short | BackgroundImageStyle | Style for the Image | available | read only
short | BorderStyle | Style of the template-border (for resizing) | available | read only
long | Bottom | Bottom-coordinate of the template | available | read only
long | Left | Left-coordinate of the template | available | read only
BSTR | Name | Name of the template (unique) | available | read only
ITemplates | Parent | Returns the parent object | read only | read only
long | Right | Right-coordinate of the template | available | read only
VARIANT_BOOL | ShowForeground | Shows template always in the foreground | available | read only
VARIANT_BOOL | ShowMinimize | Shows the windows minimize button | available | read only
VARIANT_BOOL | ShowSysMenu | Shows the windows system menu | available | read only
VARIANT_BOOL | ShowTitle | Shows titlebar for the template | available | read only
long | Style | Style of the template-window | available | read only
long | Top | Top-coordinate of the template | available | read only
long | BackgroundColor | BackColor | available | read only
long | Width | Width of the template | available | read only
long | Height | Height of the template | available | read only
VARIANT_BOOL | OpenMultiple | Open a template multiple times | available | read only

Other topics in this chapter

Parent

Name

Top

Left

Bottom

Right

Width

Height

BackgroundColor

BackgroundImage

BackgroundImageStyle

Style

ShowForeground

OpenMultiple

ShowTitle

ShowSysMenu

ShowMinimize

BorderStyle


Parent

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Templates

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the unique name of the Frame. With this name the Frame can be found in the central Frame list of the project. This name is always unique.

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Top

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties -> Top

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the position of the top Frame border in pixel. The value defines the distance from the top border of the screen. If this value is 0, then the Frame starts at the top border of the screen.

Datatype

Top() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Left

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties -> Left

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the position of the left Frame border in pixel. The value defines the distance from the left border of the screen. If this value is 0, then the Frame starts at the left border of the screen.

Datatype

Left() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Bottom

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties -> Bottom

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the position of the bottom Frame border in pixel. The value defines the distance from the top border of the screen.

Datatype

Bottom() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Right

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties -> Right

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the position of the right Frame border in pixel. The value defines the distance from the left border of the screen.

Datatype

Right() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Width

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties -> Width

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The width of the template.

Datatype

Width() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Height

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties -> Height

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The height of the template.

Datatype

Height() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


BackgroundColor

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties -> BackgroundColor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

BackgroundColor() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


BackgroundImage

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties -> BackgroundImage

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the path to the background image for the Frame.

Datatype

BackgroundImage() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


BackgroundImageStyle

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties -> BackgroundImageStyle

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

BackgroundImageStyle() As short

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Style

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties -> Style

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the style of the Frame window. The returned value comprises all style settings.

Datatype

Style() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ShowForeground

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties -> ShowForeground

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Shows the Frame always in the foreground, if set TRUE.

Datatype

ShowForeground() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


OpenMultiple

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties -> OpenMultiple

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OpenMultiple() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ShowTitle

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties -> ShowTitle

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Shows the titlebar for the Frame, if set TRUE.<span style="color:red">Only available, if property "BorderStyle" is set other than 0 (No frame).</span>

Datatype

ShowTitle() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ShowSysMenu

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties -> ShowSysMenu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Shows the Windows system menu, if set TRUE.<span style="color:red">Only available, if property "ShowTitle" is set TRUE.</span>

Datatype

ShowSysMenu() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ShowMinimize

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties -> ShowMinimize

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Shows the Windows minimize/maximize button, if set TRUE.<span style="color:red">Only available, if property "ShowSysMenu" is set TRUE.</span>

Datatype

ShowMinimize() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


BorderStyle

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Properties -> BorderStyle

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

BorderStyle() As short

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Template-Methods

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CheckIn | Save module modifications to server (editor). | available | not used
VARIANT_BOOL | CheckOut | Allow module modifications (editor). | available | not used
VARIANT_BOOL | Copy | Copies the template | available | not used
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
VARIANT_BOOL | Export | Export the given template | available | not used
VARIANT_BOOL | Get | Get the latest version from the server (editor). | available | not used
VARIANT_BOOL | Import | Import a template | available | not used
VARIANT_BOOL | IsCheckedOut | Returns true when the current module checked out by the current user (editor). | read only | not used
VARIANT_BOOL | IsDifferent | Return true when the local- and server version are different (editor). | read only | not used
VARIANT_BOOL | IsLocked | Returns true when the current module is Locked by another user (editor). | read only | not used
VARIANT_BOOL | Save | Save changes | available | not used
VARIANT_BOOL | UndoCheckOut | Undo module modifications (editor). | available | not used
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

Copy

Save

Import

Export

Get

CheckOut

CheckIn

UndoCheckOut

IsLocked

IsCheckedOut

IsDifferent


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


Copy

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Methods -> Copy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Copies the settings from an existing Frame to the own Frame.

Datatype

Copy(ITemplate pSource) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Source Frame object, from which the settings should be copied.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

pSource As Template

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Save

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Methods -> Save

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Save changes.

Datatype

Save() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Import

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import settings from an xml file

Datatype

Import(String szFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Path and Filename where the XML file for import is located.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

szFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Export

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export settings to an xml file

Datatype

Export(String szFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Path and Filename whre the XML file should be stored.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

szFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Get

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Methods -> Get

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype

Get() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckOut

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Methods -> CheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype

CheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckIn

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Methods -> CheckIn

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype

CheckIn() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


UndoCheckOut

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Methods -> UndoCheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype

UndoCheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsLocked

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Methods -> IsLocked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype

IsLocked() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsCheckedOut

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Methods -> IsCheckedOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype

IsCheckedOut() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsDifferent

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Methods -> IsDifferent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype

IsDifferent() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Template-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Alarm template

Frame template

Other topics in this chapter

Alarm template

Frame template


Alarm template

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Dynamic properties -> Alarm template

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

StandardPosition

Use standard position

active: Places the frame for the alarm status line on the top border of the screen.

Default: active

More in the online help.

VT_UI4

Style

Window style

Window style

VT_BSTR

TemplateName

Name

Distinct name of the template.

  • Maximum: 28 characters in the project, 27 characters in the global project.

Default: Template_x (x means a successive number).
Note: If the name is changed, this must be entered again if required in the Main frames property. Otherwise the Last screen open system driver variable can no longer identify screens based on this frame.
Attention: This property is not available for language switch.

More in the online help.

ZT_COLOR

BackgroundColor

Background color

Proposed background color for all screens that are newly defined on this frame

More in the online help.

VT_BOOL

ShowForeground

Always in the foreground

Active: No other screen overlaps this area in on-line operation Screens in the background can be operated however.
Inactive: Screens of this template can be covered by other screens.
Default: inactive.

More in the online help.

VT_BOOL

OpenMultiple

Frame can be opened multiple times

Active: Multiple frames can be switched in runtime: Screens that are based on this frame are loaded when called up with a new frame instead of the same one. If it is the same screen, the screen is also loaded once again.

Default: inactive

More in the online help.

VT_BOOL

CloseOnClickOutside

Close after losing focus

Controls the behavior of the frame when losing focus.

Active: When you make a left click outside of a frame, it is closed automatically when you click on an area of the monitor which is part of the zenon Runtime but neither part of the frame nor part of a frame for which property Do not close after losing focus is active.

Default: inactive

More in the online help.

VT_BOOL

IgnoreCloseOnClick

Do not close after losing focus

Active: The frame stays open when the focus is moved from the frame. The closing of another frame on losing focus is suppressed if you click in this frame. Thus you can define areas on the monitor in which a click does not close opened frames which were engineered with property Close after losing focus.

More in the online help.

ZT_MEMFILE

DefineFreeForm

Define free frame shape

Only available if you activated property Freely defineable frame shape.

Define the form for the selected frame. Left-click the button in order to open the respective frame in the frame form editor. There you can define the form of the frame with the help of circles, rectangles, rounded rectangles and polygons.

More in the online help.

VT_I4

PosLeft

Left [pixels]

X coordinates of the upper left corner point of the template in pixels (based on the set resolution).
Minimum: -2147483648.
Maximum: 2147483647.
Default: 0.

ATTENTION: We recommend defining templates no greater than 32000 x 32000 pixels in order to avoid blurring.

More in the online help.

VT_I4

PosRight

Right [pixels]

X coordinates of the lower right corner point of the template in pixels (based on the set monitor resolution).
Minimum: -2147483648.
Maximum: 2147483647.
Default: Maximum current screen resolution.

ATTENTION: We recommend defining templates no greater than 32000 x 32000 pixels in order to avoid blurring.

More in the online help.

VT_I4

PosTop

Top [pixels]

Y coordinates of the upper left corner point of the template in pixels (based on the set resolution).
Minimum: -2147483648.
Maximum: 2147483647.
Default: 0.

ATTENTION: We recommend defining templates no greater than 32000 x 32000 pixels in order to avoid blurring.

More in the online help.

VT_I4

PosBottom

Bottom [pixels]

Y coordinates of the lower right corner point of the template in pixels (based on the set monitor resolution).
Minimum: -2147483648.
Maximum: 2147483647.
Default: Maximum current screen resolution.

ATTENTION: We recommend defining templates no greater than 32000 x 32000 pixels in order to avoid blurring.

More in the online help.

VT_I4

PosWidth

Width (maximum) [pixels]

Defines the maximum width of the frame in pixels, starting from the left anchor point.

  • Maximum: 10000
    Not present under CE

More in the online help.

VT_I4

PosHeight

Height (maximum) [pixels]

Defines the maximum height of the frame in pixels, starting from the top anchor point.

  • Maximum: 10000
    Not present under CE

More in the online help.

VT_UI4

OpeningSizeType

Opening size

Defines the size with with which a screen based on this frame is called up in Runtime.

  • Frame size. Size as defined in Width (maximum) [pixels] and Height (maximum) [pixels].
    If a different value is selected, the size in Runtime is displayed with a dotted line in the frame window.
  • Width [px]. Width as defined in Value (Opening size), height is amended accordingly.
  • Height [px]. Size as defined in Value (Opening size), width is amended accordingly.
  • Relative [%]. The size defined in Width (maximum) [pixels] and Height (maximum) [pixels] is amended to the percentage value defined in Value (Opening size).

The corresponding values are defined with the Value (Opening size) property.

Default: Frame size

More in the online help.

VT_UI4

OpeningSizeValue

Value (Opening size)

Value for the size setting when called up in Runtime in the Opening size property.

More in the online help.

VT_UI4

MinSizeType

Limitation Minimum

Type of limit for the minimum value:

  • Without. No limitation
    If a different value is selected, the selected limit in Runtime is displayed with a dotted line in the frame window.
  • Width: Width limitation.
  • Height. Height limitation.
  • Relative: Limitation to a percentage value of the set screen size.

Only has an effect on Multi-Touch gestures. The corresponding values are defined with the Value (minimum) property.

Default: Without

More in the online help.

VT_UI4

MinSizeValue

Value (minimum)

Value for the setting selected in the property.

More in the online help.

VT_UI4

LimitationType

Move

Defines possible settings when moving the object:

  • without restriction
  • restrict to display borders
    Note: The type of limitation is defined using the Limitation property

Not available under Windows CE.

More in the online help.

VT_UI4

LimitationArea

Minimum frame margin

Only available if the value for the Move property has been set to Limit to monitor size and the Limitation property has been set to Frame border area.

Defines the size of the frame border area in pixels. This area cannot be moved beyond the edge of the monitor. The defined range thus remains as an area to grab and move the frame in the visible area.

  • Minimum: 0
  • Maximum: not defined
    If this area is defined as larger than the screen size or zoomed accordingly in Runtime, the screen acts as a limit on the frame border.

Default: 30

More in the online help.

VT_UI4

LimitationContactPointSize

Minimum frame margin

Only available if the value for the Move property has been set to Limit to monitor size and the Limitation property has been set to Frame border area.

Defines the size of the frame border area in pixels. This area cannot be moved beyond the edge of the monitor. The defined range thus remains as an area to grab and move the frame in the visible area.

  • Minimum: 0
  • Maximum: not defined
    If this area is defined as larger than the screen size or zoomed accordingly in Runtime, the screen acts as a limit on the frame border.

Default: 30

More in the online help.

VT_I2

PosType

Positioning

Determines the position of the frame and of the screens, which are based on it, in the Runtime.

use absolute position: Positions the frame at the coordinates defined in property Position.

relative to the element: Positions the reference point of the frame relatively to the element from which the screen switch was triggered. Here you can define both the reference point of the frame (in Reference point of frame) and the reference point of the element (in Reference point of element) including the distances to the element. The frame's reference point is then always placed on the element's calculated reference point. If the frame cannot be switched off in this position because the screen would then be outside the visible screen area, the alternative reference points are used. You can configure alternative reference points for the frame in Reference point of frame and for the element in Alternative reference point of element.

relative to the mouse pointer: The screen is placed in relation to the reference point of the frame. This means the current position of the mouse pointer. You can define the reference point in Reference point of frame. It is displayed as red dot in the frame editor. Example: If the reference point is at the top left side, the frame will be loaded to the bottom right side of the reference point.
If the screen cannot be displayed completely at the configured position, the position will be moved until the complete screen is inside the displayed area of the screen.

Default: use absolute position

More in the online help.

VT_BOOL

NoMoveOnReopen

Keep position and size on reopening

Active: A frame which was moved manually in the Runtime is not reset to the engineered position when a new screen is displayed if the frame is already opened on the same client. Their position and size are retained.

Note: This option must be active in order for the frame position to be saved before reloading and for the frame to be called up at the saved position again after reloading.

More in the online help.

VT_I2

RefVert

Vertical

Only active if you select relative to element or relative to mouse pointer at Positioning.

Select the desired reference point for the frame from the dropdown list. Choose between top, bottom or centered.

Default: top

More in the online help.

VT_I2

RefHorz

Horizontal

Only active if you select relative to element or relative to mouse pointer at Positioning.

Select the desired reference point for the frame from the dropdown list. Choose between left, right or centered.

Default: Left

More in the online help.

VT_I2

AltRefVert

Alternative vertical

Only active if you selected relative to the element at Positioning.

Select the desired alternative reference point for the frame from the dropdown list. The alternative reference point will be used if it is not possible to position the frame at the preferred reference point when loading the frame. Choose between top, bottom or centered.

Default: top

More in the online help.

VT_I2

AltRefHorz

Alternative horizontal

Only active if you selected relative to the element at Positioning.

Select the desired alternative reference point for the frame from the dropdown list. The alternative reference point will be used if it is not possible to position the frame at the preferred reference point when loading the frame. Choose between left, right or centered.

Default: Left

More in the online help.

VT_I2

PosVert

Vertical

Only active if you selected relative to the element at Positioning.

Select the desired reference point at the element from the dropdown list. When the frame is loaded, this reference point will be considered. Choose between top or bottom.

Default: top

More in the online help.

VT_I2

PosHorz

Horizontal

Only active if you selected relative to the element at Positioning.

Select the desired reference point at the element from the dropdown list. When the frame is loaded, this reference point will be considered. Choose between left or right.

Default: Left

More in the online help.

VT_I4

PixelVert

Vertical offset [pixel]

Only active if you selected relative to the element at Positioning.

By entering a positive or negative numerical value, you can move the reference point vertically.

Default: 2

More in the online help.

VT_I4

PixelHorz

Horizontal offset [pixel]

Only active if you selected relative to the element at Positioning.

By entering a positive or negative numerical value, you can move the reference point horizontally.

Default: 2

More in the online help.

VT_I2

AltPosVert

Vertical

Only active if you selected relative to the element at Positioning.

Select the desired alternative reference point at the element from the dropdown list. The alternative reference point will be used if it is not possible to position the frame at the preferred reference point when loading the frame. Choose between top or bottom.

Default: top

More in the online help.

VT_I2

AltPosHorz

Horizontal

Only active if you select relative to the element at Positioning.

Select the desired alternative reference point at the element from the dropdown list. The alternative reference point will be used if it is not possible to position the frame at the preferred reference point when loading the frame. Choose between left or right.

Default: Left

More in the online help.

VT_I4

AltPixelVert

Vertical offset [pixel]

Only active if you selected relative to the element at Positioning.

By entering a positive or negative numerical value, you can move the alternative reference point vertically.

Default: 2

More in the online help.

VT_I4

AltPixelHorz

Horizontal offset [pixel]

Only active if you selected relative to the element at Positioning.

By entering a positive or negative numerical value, you can move the alternative reference point horizontally.

Default: 2

More in the online help.

ZT_FILE

BackgroundPicture

Graphics file

Selection of the background graphics file for all screens which are newly based on this frame.
Note: A change of the graphics file does not affect already existing screens which are based on this frame.

More in the online help.

VT_I2

BackgroundPictureStyle

Alignment

Only available after you have selected a Graphics file.

Possible display types:
tiled: Original size in tiles side by side.

stretched: stretched to fill the whole screen.

normal: Original size positioned in the top left corner.
Centered: Original size, centered in the middle of the screen.

Default: normal.

You cannot move it freely.

Note: A change of the orientation does not affect already existing screens which are based on this frame.

More in the online help

VT_I2

BorderStyle

Border type

Setting the type of frame. This also defines whether the size of the frame can be changed in Runtime.

  • Size adjustable: The size of the frame can be changed in Runtime. A thick border is displayed around the frame.
  • Size fixed: The size cannot be changed. A thin border is displayed around the frame.
  • No border: The size cannot be changed. No border is displayed around the screen.

Default: No border

More in the online help.

VT_BOOL

ShowTitle

Title

Only available if a border has been selected for the template:
Active: Use Windows title bars for the screens of this template. The screens can be moved in Runtime.
Inactive: Do not use a title bar.
Default: inactive.

More in the online help.

VT_BOOL

ShowSysMenu

System menu

Only available if the title is active.
Active: Show Windows system menu in the title bar.
Inactive: Do not show the system menu.
Default: inactive.

More in the online help.

VT_BOOL

ShowMinimize

Min./Max. buttons

Only available if the title is active.
Active: Show Windows symbol field in the title bar.
Inactive: Do not show the symbol field.
Default: inactive.

More in the online help.


Frame template

Manual -> Programming interfaces -> Objectmodel -> Template -> Template-Dynamic properties -> Frame template

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_UI4

Style

Window style

Window style

VT_BSTR

TemplateName

Name

Distinct name of the template.

  • Maximum: 28 characters in the project, 27 characters in the global project.

Default: Template_x (x means a successive number).
Note: If the name is changed, this must be entered again if required in the Main frames property. Otherwise the Last screen open system driver variable can no longer identify screens based on this frame.
Attention: This property is not available for language switch.

More in the online help.

ZT_COLOR

BackgroundColor

Background color

Proposed background color for all screens that are newly defined on this frame

More in the online help.

VT_BOOL

ShowForeground

Always in the foreground

Active: No other screen overlaps this area in on-line operation Screens in the background can be operated however.
Inactive: Screens of this template can be covered by other screens.
Default: inactive.

More in the online help.

VT_BOOL

OpenMultiple

Frame can be opened multiple times

Active: Multiple frames can be switched in runtime: Screens that are based on this frame are loaded when called up with a new frame instead of the same one. If it is the same screen, the screen is also loaded once again.

Default: inactive

More in the online help.

VT_BOOL

CloseOnClickOutside

Close after losing focus

Controls the behavior of the frame when losing focus.

Active: When you make a left click outside of a frame, it is closed automatically when you click on an area of the monitor which is part of the zenon Runtime but neither part of the frame nor part of a frame for which property Do not close after losing focus is active.

Default: inactive

More in the online help.

VT_BOOL

IgnoreCloseOnClick

Do not close after losing focus

Active: The frame stays open when the focus is moved from the frame. The closing of another frame on losing focus is suppressed if you click in this frame. Thus you can define areas on the monitor in which a click does not close opened frames which were engineered with property Close after losing focus.

More in the online help.

VT_BOOL

UseFreeForming

Freely defineable frame shape

Makes it possible to use the freely definable frame for the selected frame. With this it is possible to define frames with for example rounded corners, holes etc.

  • Active: The freely definable frame form is used for this frame and for the screens which are linked to the frame.
  • Inactive: Freely definable frame shape is not available. An already existing freely definable frame shape is displayed in the frame and screen editor.

Default: inactive

Note:

  • Not available for the alarm status line frame and Windows CE.
  • Cannot be combined with the properties of the Border group.

More in the online help.

ZT_MEMFILE

DefineFreeForm

Define free frame shape

Only available if you activated property Freely defineable frame shape.

Define the form for the selected frame. Left-click the button in order to open the respective frame in the frame form editor. There you can define the form of the frame with the help of circles, rectangles, rounded rectangles and polygons.

More in the online help.

VT_I4

PosLeft

Left [pixels]

X coordinates of the upper left corner point of the template in pixels (based on the set resolution).
Minimum: -2147483648.
Maximum: 2147483647.
Default: 0.

ATTENTION: We recommend defining templates no greater than 32000 x 32000 pixels in order to avoid blurring.

More in the online help.

VT_I4

PosRight

Right [pixels]

X coordinates of the lower right corner point of the template in pixels (based on the set monitor resolution).
Minimum: -2147483648.
Maximum: 2147483647.
Default: Maximum current screen resolution.

ATTENTION: We recommend defining templates no greater than 32000 x 32000 pixels in order to avoid blurring.

More in the online help.

VT_I4

PosTop

Top [pixels]

Y coordinates of the upper left corner point of the template in pixels (based on the set resolution).
Minimum: -2147483648.
Maximum: 2147483647.
Default: 0.

ATTENTION: We recommend defining templates no greater than 32000 x 32000 pixels in order to avoid blurring.

More in the online help.

VT_I4

PosBottom

Bottom [pixels]

Y coordinates of the lower right corner point of the template in pixels (based on the set monitor resolution).
Minimum: -2147483648.
Maximum: 2147483647.
Default: Maximum current screen resolution.

ATTENTION: We recommend defining templates no greater than 32000 x 32000 pixels in order to avoid blurring.

More in the online help.

VT_I4

PosWidth

Width (maximum) [pixels]

Defines the maximum width of the frame in pixels, starting from the left anchor point.

  • Maximum: 10000
    Not present under CE

More in the online help.

VT_I4

PosHeight

Height (maximum) [pixels]

Defines the maximum height of the frame in pixels, starting from the top anchor point.

  • Maximum: 10000
    Not present under CE

More in the online help.

VT_UI4

OpeningSizeType

Opening size

Defines the size with with which a screen based on this frame is called up in Runtime.

  • Frame size. Size as defined in Width (maximum) [pixels] and Height (maximum) [pixels].
    If a different value is selected, the size in Runtime is displayed with a dotted line in the frame window.
  • Width [px]. Width as defined in Value (Opening size), height is amended accordingly.
  • Height [px]. Size as defined in Value (Opening size), width is amended accordingly.
  • Relative [%]. The size defined in Width (maximum) [pixels] and Height (maximum) [pixels] is amended to the percentage value defined in Value (Opening size).

The corresponding values are defined with the Value (Opening size) property.

Default: Frame size

More in the online help.

VT_UI4

OpeningSizeValue

Value (Opening size)

Value for the size setting when called up in Runtime in the Opening size property.

More in the online help.

VT_UI4

MinSizeType

Limitation Minimum

Type of limit for the minimum value:

  • Without. No limitation
    If a different value is selected, the selected limit in Runtime is displayed with a dotted line in the frame window.
  • Width: Width limitation.
  • Height. Height limitation.
  • Relative: Limitation to a percentage value of the set screen size.

Only has an effect on Multi-Touch gestures. The corresponding values are defined with the Value (minimum) property.

Default: Without

More in the online help.

VT_UI4

MinSizeValue

Value (minimum)

Value for the setting selected in the property.

More in the online help.

VT_UI4

LimitationType

Move

Defines possible settings when moving the object:

  • without restriction
  • restrict to display borders
    Note: The type of limitation is defined using the Limitation property

Not available under Windows CE.

More in the online help.

VT_UI4

LimitationArea

Minimum frame margin

Only available if the value for the Move property has been set to Limit to monitor size and the Limitation property has been set to Frame border area.

Defines the size of the frame border area in pixels. This area cannot be moved beyond the edge of the monitor. The defined range thus remains as an area to grab and move the frame in the visible area.

  • Minimum: 0
  • Maximum: not defined
    If this area is defined as larger than the screen size or zoomed accordingly in Runtime, the screen acts as a limit on the frame border.

Default: 30

More in the online help.

VT_UI4

LimitationContactPointSize

Minimum frame margin

Only available if the value for the Move property has been set to Limit to monitor size and the Limitation property has been set to Frame border area.

Defines the size of the frame border area in pixels. This area cannot be moved beyond the edge of the monitor. The defined range thus remains as an area to grab and move the frame in the visible area.

  • Minimum: 0
  • Maximum: not defined
    If this area is defined as larger than the screen size or zoomed accordingly in Runtime, the screen acts as a limit on the frame border.

Default: 30

More in the online help.

VT_I2

PosType

Positioning

Determines the position of the frame and of the screens, which are based on it, in the Runtime.

use absolute position: Positions the frame at the coordinates defined in property Position.

relative to the element: Positions the reference point of the frame relatively to the element from which the screen switch was triggered. Here you can define both the reference point of the frame (in Reference point of frame) and the reference point of the element (in Reference point of element) including the distances to the element. The frame's reference point is then always placed on the element's calculated reference point. If the frame cannot be switched off in this position because the screen would then be outside the visible screen area, the alternative reference points are used. You can configure alternative reference points for the frame in Reference point of frame and for the element in Alternative reference point of element.

relative to the mouse pointer: The screen is placed in relation to the reference point of the frame. This means the current position of the mouse pointer. You can define the reference point in Reference point of frame. It is displayed as red dot in the frame editor. Example: If the reference point is at the top left side, the frame will be loaded to the bottom right side of the reference point.
If the screen cannot be displayed completely at the configured position, the position will be moved until the complete screen is inside the displayed area of the screen.

Default: use absolute position

More in the online help.

VT_BOOL

NoMoveOnReopen

Keep position and size on reopening

Active: A frame which was moved manually in the Runtime is not reset to the engineered position when a new screen is displayed if the frame is already opened on the same client. Their position and size are retained.

Note: This option must be active in order for the frame position to be saved before reloading and for the frame to be called up at the saved position again after reloading.

More in the online help.

VT_I2

RefVert

Vertical

Only active if you select relative to element or relative to mouse pointer at Positioning.

Select the desired reference point for the frame from the dropdown list. Choose between top, bottom or centered.

Default: top

More in the online help.

VT_I2

RefHorz

Horizontal

Only active if you select relative to element or relative to mouse pointer at Positioning.

Select the desired reference point for the frame from the dropdown list. Choose between left, right or centered.

Default: Left

More in the online help.

VT_I2

AltRefVert

Alternative vertical

Only active if you selected relative to the element at Positioning.

Select the desired alternative reference point for the frame from the dropdown list. The alternative reference point will be used if it is not possible to position the frame at the preferred reference point when loading the frame. Choose between top, bottom or centered.

Default: top

More in the online help.

VT_I2

AltRefHorz

Alternative horizontal

Only active if you selected relative to the element at Positioning.

Select the desired alternative reference point for the frame from the dropdown list. The alternative reference point will be used if it is not possible to position the frame at the preferred reference point when loading the frame. Choose between left, right or centered.

Default: Left

More in the online help.

VT_I2

PosVert

Vertical

Only active if you selected relative to the element at Positioning.

Select the desired reference point at the element from the dropdown list. When the frame is loaded, this reference point will be considered. Choose between top or bottom.

Default: top

More in the online help.

VT_I2

PosHorz

Horizontal

Only active if you selected relative to the element at Positioning.

Select the desired reference point at the element from the dropdown list. When the frame is loaded, this reference point will be considered. Choose between left or right.

Default: Left

More in the online help.

VT_I4

PixelVert

Vertical offset [pixel]

Only active if you selected relative to the element at Positioning.

By entering a positive or negative numerical value, you can move the reference point vertically.

Default: 2

More in the online help.

VT_I4

PixelHorz

Horizontal offset [pixel]

Only active if you selected relative to the element at Positioning.

By entering a positive or negative numerical value, you can move the reference point horizontally.

Default: 2

More in the online help.

VT_I2

AltPosVert

Vertical

Only active if you selected relative to the element at Positioning.

Select the desired alternative reference point at the element from the dropdown list. The alternative reference point will be used if it is not possible to position the frame at the preferred reference point when loading the frame. Choose between top or bottom.

Default: top

More in the online help.

VT_I2

AltPosHorz

Horizontal

Only active if you select relative to the element at Positioning.

Select the desired alternative reference point at the element from the dropdown list. The alternative reference point will be used if it is not possible to position the frame at the preferred reference point when loading the frame. Choose between left or right.

Default: Left

More in the online help.

VT_I4

AltPixelVert

Vertical offset [pixel]

Only active if you selected relative to the element at Positioning.

By entering a positive or negative numerical value, you can move the alternative reference point vertically.

Default: 2

More in the online help.

VT_I4

AltPixelHorz

Horizontal offset [pixel]

Only active if you selected relative to the element at Positioning.

By entering a positive or negative numerical value, you can move the alternative reference point horizontally.

Default: 2

More in the online help.

ZT_FILE

BackgroundPicture

Graphics file

Selection of the background graphics file for all screens which are newly based on this frame.
Note: A change of the graphics file does not affect already existing screens which are based on this frame.

More in the online help.

VT_I2

BackgroundPictureStyle

Alignment

Only available after you have selected a Graphics file.

Possible display types:
tiled: Original size in tiles side by side.

stretched: stretched to fill the whole screen.

normal: Original size positioned in the top left corner.
Centered: Original size, centered in the middle of the screen.

Default: normal.

You cannot move it freely.

Note: A change of the orientation does not affect already existing screens which are based on this frame.

More in the online help

VT_I2

BorderStyle

Border type

Setting the type of frame. This also defines whether the size of the frame can be changed in Runtime.

  • Size adjustable: The size of the frame can be changed in Runtime. A thick border is displayed around the frame.
  • Size fixed: The size cannot be changed. A thin border is displayed around the frame.
  • No border: The size cannot be changed. No border is displayed around the screen.

Default: No border

More in the online help.

VT_BOOL

ShowTitle

Title

Only available if a border has been selected for the template:
Active: Use Windows title bars for the screens of this template. The screens can be moved in Runtime.
Inactive: Do not use a title bar.
Default: inactive.

More in the online help.

VT_BOOL

ShowSysMenu

System menu

Only available if the title is active.
Active: Show Windows system menu in the title bar.
Inactive: Do not show the system menu.
Default: inactive.

More in the online help.

VT_BOOL

ShowMinimize

Min./Max. buttons

Only available if the title is active.
Active: Show Windows symbol field in the title bar.
Inactive: Do not show the symbol field.
Default: inactive.

More in the online help.

ZT_AKZ

SystemModelGroup

Equipment groups

Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group.

More in the online help.


Templates

Manual -> Programming interfaces -> Objectmodel -> Templates

Remarks

This collection contains the defined Frames. Each Screen is linked to a Frame, which holds general settings as the position, the name, ...The Frames of the global project are also available in this collection.The single Frames can be found in the collection by their unique names or their indices. Each Frame has to have a unique name.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Private Sub GetTemplates()
Dim IMDITemplates As MDITemplates
Dim IMDITemplate As MDITemplate
Dim Count As Integer
Dim Ok As Boolean
Dim i As Integer

' --- Selection by Name
Set IMDITemplates = MyWorkspace.GetMDiTemplates("Keyboard")
If Not IMDITemplates Is Nothing Then
Set IMDITemplate = IMDITemplates.Item("Test 3")
Ok = PrintTemplate(IMDITemplate)
End If

' --- Selection by index (zenon Constant)
Set IMDITemplates = MyWorkspace.GetMDiTemplates(tpKeyboard)
If Not IMDITemplates Is Nothing Then
Count = IMDITemplates.Count
For i = 0 To Count - 1
Set IMDITemplate = IMDITemplates.Item(i)
Ok = PrintTemplate(IMDITemplate)
Next
End If
End Sub

Private Function PrintTemplate(IMDITemplate As MDITemplate) As Boolean
If Not IMDITemplate Is Nothing Then
Debug.Print ("Name: " & IMDITemplate.DynProperties("Name"))
Debug.Print ("GUID: " & IMDITemplate.DynProperties("GUID"))
Debug.Print ("ImportPath: " & IMDITemplate.DynProperties("ImportPath"))
Debug.Print ("Folder: " & IMDITemplate.DynProperties("Folder"))
Debug.Print ("MDIType: " & IMDITemplate.DynProperties("MDIType"))
Debug.Print ("Language: " & IMDITemplate.DynProperties("Language"))
Debug.Print ("Description: " & IMDITemplate.DynProperties("Description"))
Debug.Print ("CopaDataTemplate: " & IMDITemplate.DynProperties("CopaDataTemplate"))
Debug.Print ("DefaultTemplate: " & IMDITemplate.DynProperties("DefaultTemplate"))
PrintTemplate = True
Else
PrintTemplate = False
End If
End Function

Other topics in this chapter

Templates-Properties

Templates-Methods


Templates-Properties

Manual -> Programming interfaces -> Objectmodel -> Templates -> Templates-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Returns count of the elements | read only | read only
IProject | Parent | The parent object of the current object | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> Templates -> Templates-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> Templates -> Templates-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Templates-Methods

Manual -> Programming interfaces -> Objectmodel -> Templates -> Templates-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
ITemplate | Create | Creates and returns a new Object | available | not used
VARIANT_BOOL | Delete | Deletes the objects from collection | available | not used
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | Import | Imports the selected XML file | available | not used
ITemplate | Item | Returns a object at a position or by a specified key | available | available
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

Create

Item

Delete

Export

Import

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


Create

Manual -> Programming interfaces -> Objectmodel -> Templates -> Templates-Methods -> Create

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new Frame and returns 'Template' object.

Datatype

Create(String szFileName,[optional] VARIANT bAddToCollection) As Template

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Item

Manual -> Programming interfaces -> Objectmodel -> Templates -> Templates-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the object Template from the collection, which is identified by the parameter vID.Hint: The Frames defined in the global project are added to the Frames of the current project. On accessing a Frame with its name it is first searched for in the current project. If it cannot be found there, it is searched for in the global project.The parameter vID can have two values:<ul><li>Index: Access with an index mostly is used in combination with the property "Count" to find out the position of the variable object in the list.</li><li>Frame name: The Frame can also be accessed with its unique name.</li></ul>Hint: The returned object should be checked on Nothing, for the case that no object was found with the search criteria.

Datatype

Item(VARIANT vID) As Template

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Delete

Manual -> Programming interfaces -> Objectmodel -> Templates -> Templates-Methods -> Delete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deletes the 'Template' object from the 'Templates' collection.

Datatype

Delete(String szIdentification) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Export

Manual -> Programming interfaces -> Objectmodel -> Templates -> Templates-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export settings to an xml file

Datatype

Export(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Path and Filename whre the XML file should be stored.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

szFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Import

Manual -> Programming interfaces -> Objectmodel -> Templates -> Templates-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced.

Datatype

Import(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Path and Filename where the XML file for import is located.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

szFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> Templates -> Templates-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> Templates -> Templates-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> Templates -> Templates-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> Templates -> Templates-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


TimeFunction

Manual -> Programming interfaces -> Objectmodel -> TimeFunction

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The "TimeFunction" object, also called "Time control" in zenOn, enables the user to define function calls which should be executed at a defined (fixed) time or cyclically.When defining the time control functions for the month or year changes it is important to define the date correctly because this lays down the day after the month or year change on which the function is executed.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub CreateTimeFunction()
End Sub

Other topics in this chapter

TimeFunction-Properties

TimeFunction-Methods

TimeFunction-Dynamic properties


TimeFunction-Properties

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | Active |  | available | read only
VARIANT_BOOL | Cycled |  | available | read only
long | ID | Returns count of contained objects | read only | read only
long | IntervalTime | Returns count of contained objects | available | read only
VARIANT_BOOL | MonthSwitch | Returns time-function by position or ID | available | read only
BSTR | Name | Returns time-function by position or ID | available | read only
ITimeFunctions | Parent | Parent of object | read only | read only
DATE | StartTime | Parent of object | available | read only
VARIANT_BOOL | YearSwitch |  | available | read only

Other topics in this chapter

Parent

ID

Name

Active

Cycled

StartTime

IntervalTime

MonthSwitch

YearSwitch


Parent

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As TimeFunctions

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ID

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Properties -> ID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the unique ID for the "TimeFunction" object.

Datatype

ID() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the name of the "TimeFunction" object as string.

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Active

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Properties -> Active

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

If set TRUE, the time-function will be executed in the Runtime. Otherwise, the time-function is not executed in the Runtime.Hint: Time specific properties of the "TimeFunction" object can only be set if this property is set TRUE.

Datatype

Active() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Cycled

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Properties -> Cycled

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets if the execution of the function is done cyclic.Hint: In combination with the property "Cycled" the execution type for the "TimeFunction" object can be set. For further information please have a look at the "SetDaySelected" method.

Datatype

Cycled() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


StartTime

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Properties -> StartTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Gets or sets the start time when the function should be executed.

Datatype

StartTime() As DATE

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_TimeFunction_SetStartTime(ByRef zTime As TimeFunction)

'Set new start time: 2007-08-21 14:30:30
zTime.StartTime = DateSerial(2007, 8, 21) + TimeSerial(14, 30, 30)

'Output new start time
Debug.Print zTime.StartTime

End Sub


IntervalTime

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Properties -> IntervalTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Time interval, in which the function should be executed. The interval is defined in seconds.Hint: This property is only available, if the property "Cycled" is set to TRUE and the properties "MonthSwitch" and "YearSwitch" are deactivated.

Datatype

IntervalTime() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


MonthSwitch

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Properties -> MonthSwitch

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

If set TRUE, the function will only be executed on the turn of a month (Length of interval: 1 month). Otherwise, the setting from the property "IntervalTime" is used for the execution of the function.Hint: This property is only available, if the property "Cycled" is set to TRUE and property "YearSwitch" is deactivated.

Datatype

MonthSwitch() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


YearSwitch

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Properties -> YearSwitch

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

If set TRUE, the function will only be executed at the turn of a year (Length of interval: 1 year). Otherwise, the setting from the property "IntervalTime" is used for the execution of the function.Hint: This property is only available, if the property "Cycled" is set to TRUE and property "MonthSwitch" is deactivated.

Datatype

YearSwitch() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


TimeFunction-Methods

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CheckIn | Save module modifications to server (editor). | available | not used
VARIANT_BOOL | CheckOut | Allow module modifications (editor). | available | not used
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
VARIANT_BOOL | Get | Get the latest version from the server (editor). | available | not used
VARIANT_BOOL | IsCheckedOut | Returns true when the current module checked out by the current user (editor). | read only | not used
VARIANT_BOOL | IsDaySelected | - | available | available
VARIANT_BOOL | IsDifferent | Return true when the local- and server version are different (editor). | read only | not used
VARIANT_BOOL | IsLocked | Returns true when the current module is Locked by another user (editor). | read only | not used
IRtFunction | ItemRtFunction | - | read only | read only
void | SetDaySelected | - | available | available
VARIANT_BOOL | UndoCheckOut | Undo module modifications (editor). | available | not used
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

ItemRtFunction

IsDaySelected

SetDaySelected

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

Get

CheckOut

CheckIn

UndoCheckOut

IsLocked

IsCheckedOut

IsDifferent


ItemRtFunction

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Methods -> ItemRtFunction

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a "RtFunction" object with the function that was assigned by the creation of the "TimeFunction" object.

Datatype

ItemRtFunction() As RtFunction

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsDaySelected

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Methods -> IsDaySelected

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

IsDaySelected(long lDay) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SetDaySelected

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Methods -> SetDaySelected

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SetDaySelected(long lDay,Boolean bValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

State of the day for the execution of the function. If set TRUE, then the function will be executed on this day. Otherwise it will not be executed.

Day that should be checked.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bValue As Boolean

lDay As Long

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_TimeFunction_SetExecutionType(ByRef zTime As TimeFunction)

'Set execution type: "cyclic only on that day"
zTime.SetDaySelected 8, True
zTime.Cycled = True

'Set execution type: "only on that day"
zTime.SetDaySelected 8, True
zTime.Cycled = False

'Set execution type: "cyclic from that day"
zTime.SetDaySelected 8, False
zTime.Cycled = True

'Set execution type: "from that day"
zTime.SetDaySelected 8, False
zTime.Cycled = False

End Sub


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


Get

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Methods -> Get

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype

Get() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckOut

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Methods -> CheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype

CheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckIn

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Methods -> CheckIn

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype

CheckIn() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


UndoCheckOut

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Methods -> UndoCheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype

UndoCheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsLocked

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Methods -> IsLocked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype

IsLocked() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsCheckedOut

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Methods -> IsCheckedOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype

IsCheckedOut() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsDifferent

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Methods -> IsDifferent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype

IsDifferent() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


TimeFunction-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Time function entry

Other topics in this chapter

Time function entry


Time function entry

Manual -> Programming interfaces -> Objectmodel -> TimeFunction -> TimeFunction-Dynamic properties -> Time function entry

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

Active

Active

Active: The time function is active in Runtime.
Inactive: The time function will not be displayed in Runtime
Default: active.

More in the online help.

VT_BSTR

Name

Name

Name of the time function.
Default: Time function x (whereby x is a successive number).

Attention: This property is not available for language switch.

More in the online help.

ZT_FUNCTION

Function

Function

Function that is to be carried out as time-controlled.
Opens the function selection dialog.
If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here.

More in the online help.

VT_I4

Type

Execution type

from that day: The function is executed from the set day, at the set time.
only on that day: The function is only executed once on the set day, at the set time.
cyclic from that day on: The function is executed from the set day, cyclically at the defined interval.
cyclic only on that day: The function is only executed on the set working day, cyclically at the defined interval.

More in the online help

ZT_DATETIME

ExecuteDate

Start time

Date on with or from which the time function should be carried out.

More in the online help.

ZT_ZEIT

Interval

interval

Time interval in which the function is to be executed.
Default: 12:15:00 AM

More in the online help.

VT_BOOL

Monthly

Interval one month

Only available if the property Execution typethe value cyclic was selected.
Active: The function is executed after an interval of a month at the turn of the month.
Inactive: The other settings for executing the function are used.
Default: inactive

Note: Turn of the month and turn of the year refers to the set execution date and not to the turn of the month/year on 01. 01. 00:00 a.m. If the change should be executed at exact this point in time, the engineering must be doen for this point in time; e.g. 01. 01. 2012 00:00:00 o'clock.

More in the online help.

VT_BOOL

Yearly

Interval one year

Only available if the property Execution typethe value cyclic was selected.
Active: The function is executed after an interval of a year at the turn of the year.
Inactive: The other settings for executing the function are used.
Default: inactive

Note: Turn of the month and turn of the year refers to the set execution date and not to the turn of the month/year on 01. 01. 00:00 a.m. If the change should be executed at exact this point in time, the engineering must be doen for this point in time; e.g. 01. 01. 2012 00:00:00 o'clock.

More in the online help.

VT_BOOL

Monday

Monday

Active: Function is (also) executed on Mondays.
Inactive: Function is not executed on Mondays.
Default: active.

More in the online help.

VT_BOOL

Tuesday

Tuesday

Active: Function is (also) executed on Tuesdays.
Inactive: Function is not executed on Tuesdays.
Default: active.

More in the online help.

VT_BOOL

Wednesday

Wednesday

Active: Function is (also) executed on Wednesdays.
Inactive: Function is not executed on Wednesdays.
Default: active.

More in the online help.

VT_BOOL

Thursday

Thursday

Active: Function is (also) executed on Thursdays.
Inactive: Function is not executed on Thursdays.
Default: active.

More in the online help.

VT_BOOL

Friday

Friday

Active: Function is (also) executed on Fridays.
Inactive: Function is not executed on Fridays.
Default: active.

More in the online help.

VT_BOOL

Saturday

Saturday

Active: Function is (also) executed on Saturdays.
Inactive: Function is not executed on Saturdays.
Default: active.

More in the online help.

VT_BOOL

Sunday

Sunday

Active: Function is (also) executed on Sundays.
Inactive: Function is not executed on Sundays.
Default: active.

More in the online help.

ZT_AKZ

SystemModelGroup

Equipment groups

Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group.

More in the online help.


TimeFunctions

Manual -> Programming interfaces -> Objectmodel -> TimeFunctions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This object manages "TimeFunction" objects.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub zenOn_TimeFunctions()
'Declarations
Dim zProject As Project
Dim zTimeFcts As TimeFunctions
Dim i As Integer

'Initialize zProject with the current project
Set zProject = MyWorkspace.ActiveDocument
'Initialize zTimeFcts with the "TimeFunction" object collection of the project
Set zTimeFcts = zProject.TimeFunctions

'Create a new "TimeFunction" object and assign the first available function to it
zTimeFcts.Create "zenOn_TimeFunction", zProject.RtFunctions.Item(0).ID

'For every "TimeFunction" object within the collection...
For i = 0 To zTimeFcts.Count - 1
'... output the name
Debug.Print zTimeFcts.Item(i).Name

Next i

'Delete the former created "TimeFunction" object
zTimeFcts.Delete "zenOn_TimeFunction"

End Sub

Other topics in this chapter

TimeFunctions-Properties

TimeFunctions-Methods


TimeFunctions-Properties

Manual -> Programming interfaces -> Objectmodel -> TimeFunctions -> TimeFunctions-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Returns count of contained objects | read only | read only
IProject | Parent | Parent of object | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> TimeFunctions -> TimeFunctions-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> TimeFunctions -> TimeFunctions-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


TimeFunctions-Methods

Manual -> Programming interfaces -> Objectmodel -> TimeFunctions -> TimeFunctions-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
ITimeFunction | Create | Creates and returns a new Object | available | not used
VARIANT_BOOL | Delete | Deletes the objects from collection | available | not used
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | Import | Imports the selected XML file | available | not used
ITimeFunction | Item | Returns a object at a position or by a specified key | available | available
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used

Other topics in this chapter

Item

Create

Delete

Export

SingleExport

Import


Item

Manual -> Programming interfaces -> Objectmodel -> TimeFunctions -> TimeFunctions-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the "TimeFunction" object from the collection, which is identified by the parameter vNameOrPos. The parameter vNameOrPos can have two values:

  • Element name: The element can be accessed with its unique name.
  • Index: Access with an index is mostly used in combination with the property "Count" to find out the position of the "TimeFunction" object in the list.

Hint:The returned object should be checked on Nothing, if no object for the search criteria was found.

Datatype

Item(VARIANT vNameOrPos) As TimeFunction

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Create

Manual -> Programming interfaces -> Objectmodel -> TimeFunctions -> TimeFunctions-Methods -> Create

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a new "TimeFunction" object by its name as string and the unique ID of the function that should be assigned to the object.

Datatype

Create(String bsName,long nFunctionID) As TimeFunction

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Delete

Manual -> Programming interfaces -> Objectmodel -> TimeFunctions -> TimeFunctions-Methods -> Delete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deletes an existing "TimeFunction" object by its name as string.

Datatype

Delete(String bsName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Export

Manual -> Programming interfaces -> Objectmodel -> TimeFunctions -> TimeFunctions-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export settings to an xml file

Datatype

Export(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to export.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


SingleExport

Manual -> Programming interfaces -> Objectmodel -> TimeFunctions -> TimeFunctions-Methods -> SingleExport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SingleExport(VARIANT vIndexOrName,BSTR bsFileName) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Import

Manual -> Programming interfaces -> Objectmodel -> TimeFunctions -> TimeFunctions-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced.

Datatype

Import(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to import.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Units

Manual -> Programming interfaces -> Objectmodel -> Units

Remarks

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Other topics in this chapter

Units-Methods

Units-Dynamic properties


Units-Methods

Manual -> Programming interfaces -> Objectmodel -> Units -> Units-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CreateDynProperty | - | available | not used
void | DynProperties [PUT] | - | available | not used
VARIANT | DynProperties [GET] | - | available | not used
VARIANT | DynPropertiesEnum [GET] | - | available | not used
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | Import | Imports the selected XML file | available | not used
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

Export

Import

DynPropertyParam [GET]

DynPropertiesEnum [GET]

CreateDynProperty

DynProperties [GET]

DynProperties [PUT]


Export

Manual -> Programming interfaces -> Objectmodel -> Units -> Units-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Export(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file for export.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Import

Manual -> Programming interfaces -> Objectmodel -> Units -> Units-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import setting using a xml file. New settings are added, existing settings will be replaced.

Datatype

Import(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to import.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> Units -> Units-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> Units -> Units-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateDynProperty

Manual -> Programming interfaces -> Objectmodel -> Units -> Units-Methods -> CreateDynProperty

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreateDynProperty(String bsPath) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> Units -> Units-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> Units -> Units-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Units-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> Units -> Units-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Unit manager

Other topics in this chapter

CPrimaryUnit

Unit manager


CPrimaryUnit

Manual -> Programming interfaces -> Objectmodel -> Units -> Units-Dynamic properties -> CPrimaryUnit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Units | Measuring units |
VT_BSTR | Name | Measuring unit | Statement of the base unit from which the conversion is carried out or the conversion unit in which the conversion carried out. For example C°, K, m, y, Celsius, Kelvin, meter, yard etc. You can use up to 50 characters. More in the online help.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


Unit manager

Manual -> Programming interfaces -> Objectmodel -> Units -> Units-Dynamic properties -> Unit manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | Units | Measuring units |


User

Manual -> Programming interfaces -> Objectmodel -> User

Remarks

This object represents an user from the central user administration of the current project. The most important settings of the single users are available with this object.All available settings can be edited with VBA.The critical properties Identification and Password can only be edited with a method, whereas the properties Name and Level can be edited directly in the property.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub ChangeUser()
Dim zUser As User
Dim vResult As Variant

Set zUser = thisProject.Passwords.ItemUser(0)
Debug.Print zUser.Name & " will be changed"

'change the identification of the user
vResult = zUser.IdentificationChange("NewLogonName")

'change the password for the user
vResult = zUser.PasswordChange("P@ssword", "NewPassword")

End Sub

Other topics in this chapter

User-Properties

User-Methods

User-Dynamic properties


User-Properties

Manual -> Programming interfaces -> Objectmodel -> User -> User-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | Active | Activate/Deactivate user | available | available
VARIANT_BOOL | Admin | User has admin rights | available | read only
BSTR | Identification | TagName | read only | read only
long | Level | Rights/Password-Levels 0 | available | available
long | Level1 | Rights/Password-Levels 1 | available | available
long | Level2 | Rights/Password-Levels 2 | available | available
long | Level3 | Rights/Password-Levels 3 | available | available
VARIANT_BOOL | Locked | Lock/Unlock user | available | read only
BSTR | Name | Name | available | available
IPasswords | Parent | Parent-object | read only | read only

Other topics in this chapter

Parent

Identification

Name

Level

Level1

Level2

Level3

Active

Locked

Admin


Parent

Manual -> Programming interfaces -> Objectmodel -> User -> User-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Passwords

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Identification

Manual -> Programming interfaces -> Objectmodel -> User -> User-Properties -> Identification

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the unique identification of the user. With this identification the user can be found in the central user administration.This property cannot be written directly – instead the method IdentificationChange is available, with which the identification of a user can be changed.

Datatype

Identification() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> User -> User-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property operates the name of the user. The name can be read as well as written. But be aware, that the name cannot have more than 30 characters.

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Level

Manual -> Programming interfaces -> Objectmodel -> User -> User-Properties -> Level

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Level() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Level1

Manual -> Programming interfaces -> Objectmodel -> User -> User-Properties -> Level1

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Level1() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Level2

Manual -> Programming interfaces -> Objectmodel -> User -> User-Properties -> Level2

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Level2() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Level3

Manual -> Programming interfaces -> Objectmodel -> User -> User-Properties -> Level3

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Level3() As long

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Active

Manual -> Programming interfaces -> Objectmodel -> User -> User-Properties -> Active

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Activate/Deactivate user

Datatype

Active() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Locked

Manual -> Programming interfaces -> Objectmodel -> User -> User-Properties -> Locked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Lock/Unlock user

Datatype

Locked() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Admin

Manual -> Programming interfaces -> Objectmodel -> User -> User-Properties -> Admin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

User has admin rights

Datatype

Admin() As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


User-Methods

Manual -> Programming interfaces -> Objectmodel -> User -> User-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
void | DynProperties [PUT] | - | available | available | yes | yes
VARIANT | DynProperties [GET] | - | available | available | yes | yes
VARIANT | DynPropertiesEnum [GET] | - | read only | read only | yes | yes
VARIANT_BOOL | IdentificationChange | Changes the TagName | available | not used | yes | yes
VARIANT_BOOL | PasswordChange | Changes the password | available | available | yes | yes
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used | yes | yes

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

PasswordChange

IdentificationChange


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> User -> User-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> User -> User-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> User -> User-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> User -> User-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


PasswordChange

Manual -> Programming interfaces -> Objectmodel -> User -> User-Methods -> PasswordChange

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method changes the password of the current user. If the parameter szOld is not true for the current password, False is returned.Otherwise the new password is confirmed and the cange is saved.

Datatype

PasswordChange(String szOld,String szNew) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IdentificationChange

Manual -> Programming interfaces -> Objectmodel -> User -> User-Methods -> IdentificationChange

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method changes the unique identification of the user. If the same identification already exists, False is returned.If the identification does not exist yet, it is linked to the current user and saved. In this case the method returns True.

Datatype

IdentificationChange(String szIdentification) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


User-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> User -> User-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

User

CUserForList

Other topics in this chapter

User

CUserForList


User

Manual -> Programming interfaces -> Objectmodel -> User -> User-Dynamic properties -> User

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BOOL | UserActive | User active | Active: The user is accepted in Runtime. Inactive: The user is not accepted in Runtime Default: active. More in the online help.
VT_BSTR | UserName | Complete name | Name of the user. For several user actions, the character string can be displayed in the Chronological Event List (CEL). It should be the full name of the user. In the CEL there is a column for the display of this information. In addition, this information can be displayed with the help of a system driver variable. More in the online manual.
VT_BOOL | Admin | Administrator | Active: This user is an administrator. This means he can edit other users in the Runtime and unlock the system. Inactive: This user is not an administrator. Default: inactive. ATTENTION: An administrator can only unlock authorization groups, which he also owns, for other users. More in the online help.
VT_BOOL | UserLocked | Locked | Active: The user is blocked. Inactive: The user is not blocked. Default: inactive. A user is automatically blocked after a defined number of incorrect password entries. The block can be lifted here. Only an administrator can unblock a user, because only an administrator can edit a user. More in the online help.
VT_BSTR | LockCode | Lock code | Four-digit PIN code. This code is used by the user to lock and unlock different areas. Using this code for locking avoids unintentionally unlocking a lock and therefore unnecessary accidents.
VT_UI4 | UserLevel0 | UserLevel0 | "With the UserLevel properties you have the opportunity to get/set selected authorization groups via a long value. The value for the selected authorization groups is splitted over four properties. For example: Selected authorization levels 0,1,2 have an UserLevel0 value of 7 (1+2+4)."
VT_UI4 | UserLevel1 | UserLevel1 | "With the UserLevel properties you have the opportunity to get/set selected authorization groups via a long value. The value for the selected authorization groups is splitted over four properties. For example: Selected authorization levels 0,1,2 have an UserLevel0 value of 7 (1+2+4)."
VT_UI4 | UserLevel2 | UserLevel2 | "With the UserLevel properties you have the opportunity to get/set selected authorization groups via a long value. The value for the selected authorization groups is splitted over four properties. For example: Selected authorization levels 0,1,2 have an UserLevel0 value of 7 (1+2+4)."
VT_UI4 | UserLevel3 | UserLevel3 | "With the UserLevel properties you have the opportunity to get/set selected authorization groups via a long value. The value for the selected authorization groups is splitted over four properties. For example: Selected authorization levels 0,1,2 have an UserLevel0 value of 7 (1+2+4)."
VT_I4 | LoginRTP | Runtime profile | Selection of the Runtime profile which should be allocated to the user at log in. Possible profiles: none: No profile is allocated DEFAULT: Profile DEFAULT is allocated LAST: Profile LAST is allocated Default: none More in the online help.
VT_BOOL | IsMsgCtrlUser | Message Control user | Active: User is used by Message Control. More in the online help.
VT_BSTR | MsgPinCode | PIN code | PIN code with which the user confirms the receipt of the message. Note: This code should differ considerably from the code of property NA code. More in the online help.
VT_BSTR | MsgNACKCode | NA code | Not-available code with which the user rejects the receipt of the message. Note: This code should differ considerably from the code of property PIN code. More in the online help.
VT_BSTR | MsgErsatzUser | Substitute person | Person which replaces the user if he cannot be reached. Click the ... button and a dialog opens to select a user. More in the online help.
VT_BSTR | MsgGSM | GSM | Mobile phone number of the user. Used for messages via GSM and SMS (text messages). Enter numbers, the prefix + abbreviating 00 of the international area code is permitted. More in the online help.
VT_BSTR | MsgPhone | Telephone | Fixed network telephone number of the user. Used for voice to speech. Enter numbers, the prefix + abbreviating 00 of the international area code is permitted. More in the online help.
VT_BSTR | MsgEmail | E-mail | E-mail address of the user More in the online help.
VT_BSTR | GUID | GUID |
VT_BSTR | UserGroupsOrderImExpo | UserGroupsOrderImExpo |
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


CUserForList

Manual -> Programming interfaces -> Objectmodel -> User -> User-Dynamic properties -> CUserForList

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BOOL | UserActive | User active | Active: The user is accepted in Runtime. Inactive: The user is not accepted in Runtime Default: active. More in the online help.
VT_BSTR | UserName | Complete name | Name of the user. For several user actions, the character string can be displayed in the Chronological Event List (CEL). It should be the full name of the user. In the CEL there is a column for the display of this information. In addition, this information can be displayed with the help of a system driver variable. More in the online manual.
VT_BOOL | Admin | Administrator | Active: This user is an administrator. This means he can edit other users in the Runtime and unlock the system. Inactive: This user is not an administrator. Default: inactive. ATTENTION: An administrator can only unlock authorization groups, which he also owns, for other users. More in the online help.
VT_BOOL | UserLocked | Locked | Active: The user is blocked. Inactive: The user is not blocked. Default: inactive. A user is automatically blocked after a defined number of incorrect password entries. The block can be lifted here. Only an administrator can unblock a user, because only an administrator can edit a user. More in the online help.
VT_UI4 | UserLevel0 | UserLevel0 | "With the UserLevel properties you have the opportunity to get/set selected authorization groups via a long value. The value for the selected authorization groups is splitted over four properties. For example: Selected authorization levels 0,1,2 have an UserLevel0 value of 7 (1+2+4)."
VT_UI4 | UserLevel1 | UserLevel1 | "With the UserLevel properties you have the opportunity to get/set selected authorization groups via a long value. The value for the selected authorization groups is splitted over four properties. For example: Selected authorization levels 0,1,2 have an UserLevel0 value of 7 (1+2+4)."
VT_UI4 | UserLevel2 | UserLevel2 | "With the UserLevel properties you have the opportunity to get/set selected authorization groups via a long value. The value for the selected authorization groups is splitted over four properties. For example: Selected authorization levels 0,1,2 have an UserLevel0 value of 7 (1+2+4)."
VT_UI4 | UserLevel3 | UserLevel3 | "With the UserLevel properties you have the opportunity to get/set selected authorization groups via a long value. The value for the selected authorization groups is splitted over four properties. For example: Selected authorization levels 0,1,2 have an UserLevel0 value of 7 (1+2+4)."
VT_I4 | LoginRTP | Runtime profile | Selection of the Runtime profile which should be allocated to the user at log in. Possible profiles: none: No profile is allocated DEFAULT: Profile DEFAULT is allocated LAST: Profile LAST is allocated Default: none More in the online help.
VT_BOOL | IsMsgCtrlUser | Message Control user | Active: User is used by Message Control. More in the online help.
VT_BSTR | MsgErsatzUser | Substitute person | Person which replaces the user if he cannot be reached. Click the ... button and a dialog opens to select a user. More in the online help.
VT_BSTR | MsgGSM | GSM | Mobile phone number of the user. Used for messages via GSM and SMS (text messages). Enter numbers, the prefix + abbreviating 00 of the international area code is permitted. More in the online help.
VT_BSTR | MsgPhone | Telephone | Fixed network telephone number of the user. Used for voice to speech. Enter numbers, the prefix + abbreviating 00 of the international area code is permitted. More in the online help.
VT_BSTR | MsgEmail | E-mail | E-mail address of the user More in the online help.
VT_BSTR | GUID | GUID |
VT_BSTR | UserGroupsOrderImExpo | UserGroupsOrderImExpo |
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


UserGroup

Manual -> Programming interfaces -> Objectmodel -> UserGroup

Remarks

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Public Sub EnumUserGroup()
Dim zPRJ As Project
Dim zUGP As UserGroup
Dim i As Integer

Set zPRJ = MyWorkspace.ActiveDocument

For i = 0 To zPRJ.Passwords.CountUserGroup - 1
Set zUGP = zPRJ.Passwords.ItemUserGroup(i)
Debug.Print "Usergroup >>> " & zUGP.DynProperties("UserGroupName")
Debug.Print " Level 0-31 : " & zUGP.DynProperties("UserGroupLevel0")
Debug.Print " Level 32-63 : " & zUGP.DynProperties("UserGroupLevel1")
Debug.Print " Level 64-91 : " & zUGP.DynProperties("UserGroupLevel2")
Debug.Print " Level 92-127: " & zUGP.DynProperties("UserGroupLevel3")
Next i
End Sub

Public Sub CreateUserGroup()
Dim zPRJ As Project
Dim zUGP As UserGroup

Set zPRJ = MyWorkspace.ActiveDocument

Set zUGP = zPRJ.Passwords.CreateUserGroup("MyGroup", 255) 'Level 0-7

With zUGP
.DynProperties("UserGroupLevel0") = 255 'Level 0-7
.DynProperties("UserGroupLevel1") = 255 'Level 32-39
.DynProperties("UserGroupLevel2") = 255 'Level 64-71
.DynProperties("UserGroupLevel3") = 255 'Level 96-103
End With
End Sub

Other topics in this chapter

UserGroup-Methods

UserGroup-Dynamic properties


UserGroup-Methods

Manual -> Programming interfaces -> Objectmodel -> UserGroup -> UserGroup-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CreateDynProperty | - | available | not used
void | DynProperties [PUT] | - | available | not used
VARIANT | DynProperties [GET] | - | available | not used
VARIANT | DynPropertiesEnum [GET] | - | available | not used
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

CreateDynProperty


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> UserGroup -> UserGroup-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> UserGroup -> UserGroup-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> UserGroup -> UserGroup-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> UserGroup -> UserGroup-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateDynProperty

Manual -> Programming interfaces -> Objectmodel -> UserGroup -> UserGroup-Methods -> CreateDynProperty

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreateDynProperty(String bsPath) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


UserGroup-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> UserGroup -> UserGroup-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

UserGroup

Other topics in this chapter

UserGroup


UserGroup

Manual -> Programming interfaces -> Objectmodel -> UserGroup -> UserGroup-Dynamic properties -> UserGroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | UserGroupName | Name | Name of the selected user group. Click in the input filed in order to change the name. Note: @ is not a valid character for a user group. More in the online help.
VT_UI4 | UserGroupLevel0 | UserGroupLevel0 |
VT_UI4 | UserGroupLevel1 | UserGroupLevel1 |
VT_UI4 | UserGroupLevel2 | UserGroupLevel2 |
VT_UI4 | UserGroupLevel3 | UserGroupLevel3 |
VT_BSTR | GUID | GUID |
VT_BOOL | IsMsgCtrlGroup | Message Control group | Active: User group is used by Message Control. More in the online help.


VarAssignment

Manual -> Programming interfaces -> Objectmodel -> VarAssignment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

'Create a new VarAssignment (Allocation)
Sub CreateAssignment()
Dim zVarAssign As VarAssignment
'create by NAME
Set zVarAssign = MyWorkspace.ActiveDocument.VarAssignments.Create("MyAssignment3", "WIZ_VAR_10", "WIZ_VAR_11")
'change settings
With zVarAssign
'set trigger type
.DynProperties("TriggerType") = 1
'set trigger variable by Name
.DynProperties("TriggerVariable") = "MyTrigger"
End With
End Sub

Other topics in this chapter

VarAssignment-Properties

VarAssignment-Methods

VarAssignment-Dynamic properties


VarAssignment-Properties

Manual -> Programming interfaces -> Objectmodel -> VarAssignment -> VarAssignment-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | ID | Set/Get unique ID for the object | read only | read only
BSTR | Name | Set/Get the user-defined name | available | read only
IVarAssignments | Parent | Parent of object | read only | read only

Other topics in this chapter

Parent

ID

Name


Parent

Manual -> Programming interfaces -> Objectmodel -> VarAssignment -> VarAssignment-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As VarAssignments

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ID

Manual -> Programming interfaces -> Objectmodel -> VarAssignment -> VarAssignment-Properties -> ID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get unique ID for the object

Datatype

ID() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> VarAssignment -> VarAssignment-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Set/Get the user-defined name

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


VarAssignment-Methods

Manual -> Programming interfaces -> Objectmodel -> VarAssignment -> VarAssignment-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | ChangeSourceVariable | Change source (can be member of another project) | available | not used
VARIANT_BOOL | ChangeTargetVariable | Change target (can be member of another project) | available | not used
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IVariable | ItemSourceVariable | Get the linked source variable | read only | read only
IVariable | ItemTargetVariable | Get the linked target variable | read only | read only
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used
IVariable | ItemSourceVariable | Get the linked source variable | read only | read only
IVariable | ItemTargetVariable | Get the linked target variable | read only | read only

Other topics in this chapter

ItemSourceVariable

ItemTargetVariable

ChangeSourceVariable

ChangeTargetVariable

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


ItemSourceVariable

Manual -> Programming interfaces -> Objectmodel -> VarAssignment -> VarAssignment-Methods -> ItemSourceVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ItemSourceVariable() As IVariable

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


ItemTargetVariable

Manual -> Programming interfaces -> Objectmodel -> VarAssignment -> VarAssignment-Methods -> ItemTargetVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ItemTargetVariable() As IVariable

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


ChangeSourceVariable

Manual -> Programming interfaces -> Objectmodel -> VarAssignment -> VarAssignment-Methods -> ChangeSourceVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Change source (can be member of another project).

Datatype

ChangeSourceVariable(String bsProject,long nNewSourceID) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Projectname as string.

PvID of new source variable as string.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsProject As String

nNewSourceID As Long

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub CallChange()
ChangeAssignment MyWorkspace.ActiveDocument.VarAssignments.Item("MyAssignment")
End Sub

Sub ChangeAssignment(zVarAssign As VarAssignment)
Dim zSrcVar As Variable
Dim zDstVar As Variable
Dim strProject As String

Set zSrcVar = MyWorkspace.ActiveDocument.Variables.Item("WIZ_VAR_11")
Set zDstVar = MyWorkspace.ActiveDocument.Variables.Item("WIZ_VAR_12")
strProject = MyWorkspace.ActiveDocument.Name
'change the source and target variable
With zVarAssign
.ChangeSourceVariable strProject, zSrcVar.PvID
.ChangeTargetVariable strProject, zDstVar.PvID
End With
End Sub


ChangeTargetVariable

Manual -> Programming interfaces -> Objectmodel -> VarAssignment -> VarAssignment-Methods -> ChangeTargetVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Change target (can be member of another project).

Datatype

ChangeTargetVariable(String bsProject,long nNewTargetID) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

PvID of new target variable as string.

Projectname as string.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

nNewTargetID As Long

bsProject As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub CallChange()
ChangeAssignment MyWorkspace.ActiveDocument.VarAssignments.Item("MyAssignment")
End Sub

Sub ChangeAssignment(zVarAssign As VarAssignment)
Dim zSrcVar As Variable
Dim zDstVar As Variable
Dim strProject As String

Set zSrcVar = MyWorkspace.ActiveDocument.Variables.Item("WIZ_VAR_11")
Set zDstVar = MyWorkspace.ActiveDocument.Variables.Item("WIZ_VAR_12")
strProject = MyWorkspace.ActiveDocument.Name
'change the source and target variable
With zVarAssign
.ChangeSourceVariable strProject, zSrcVar.PvID
.ChangeTargetVariable strProject, zDstVar.PvID
End With
End Sub


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> VarAssignment -> VarAssignment-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> VarAssignment -> VarAssignment-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> VarAssignment -> VarAssignment-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> VarAssignment -> VarAssignment-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


VarAssignment-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> VarAssignment -> VarAssignment-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Allocation entry

Other topics in this chapter

Allocation entry


Allocation entry

Manual -> Programming interfaces -> Objectmodel -> VarAssignment -> VarAssignment-Dynamic properties -> Allocation entry

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BSTR | Name | Name | Distinct name of the allocation. Default: Allocation x (where x means a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_VARIABLE | SourceVariable | Source variable | Name of the variable whose value should be allocated to the target variable. Opens the dialog for selecting variables. More in the online help.
ZT_VARIABLE | TargetVariable | Target variable | Name of the variable whose value should be allocated to the source variable. Opens the dialog for selecting variables. More in the online help.
ZT_VARIABLE | TriggerVariable | Trigger variable | The bit variable linked here triggers the allocation. If no variable is linked, the allocation is spontaneous. This means that whenever the value of the source variable changes, it is automatically written to the target variable. Opens the variable selection dialog, filtered for bit variables. More in the online help.
VT_UI2 | TriggerType | Trigger type | Edge: The allocation is carried out if the value of the linked trigger variable changes from 0 to 1. Gage: The allocation is carried out as long as the value of the linked trigger variable is 1. Default: Edge. More in the online help.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


VarAssignments

Manual -> Programming interfaces -> Objectmodel -> VarAssignments

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The VarAssignments collection contains all existing allocations of the current project. With this collection you can access all or certain allocations.Additional to the access via the index the allocations can also be accessed via the unique name or the position.

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

'Create a new VarAssignment (Allocation)
Sub CreateAssignment()
Dim zVarAssign As VarAssignment
Dim zSrcVar As Variable
Dim zDstVar As Variable
'by NAME
Set zVarAssign = MyWorkspace.ActiveDocument.VarAssignments.Create("MyAssignment", "WIZ_VAR_10", "WIZ_VAR_11")
'OR by ID
Set zSrcVar = MyWorkspace.ActiveDocument.Variables.Item("WIZ_VAR_10")
Set zDstVar = MyWorkspace.ActiveDocument.Variables.Item("WIZ_VAR_11")
Set zVarAssign = MyWorkspace.ActiveDocument.VarAssignments.CreateByID("MyAssignment", zSrcVar.PvID, zDstVar.PvID)
End Sub

'Delete an VarAssignment (Allocation)
Sub DeleteAssignment()
Dim bResult As Boolean
'by NAME
bResult = MyWorkspace.ActiveDocument.VarAssignments.Delete("MyAssignment")
End Sub

'Enumerate all Assignements of the active project
Sub EnumAssignments()
Dim zVarAssign As VarAssignment
Dim zVarAssigns As VarAssignments
Dim i As Integer
'get collection of VarAssignements
Set zVarAssigns = MyWorkspace.ActiveDocument.VarAssignments
'enum all VarAssignments
For i = 0 To zVarAssigns.Count - 1
'get VarAssignment
Set zVarAssign = zVarAssigns.Item(i)
Debug.Print zVarAssign.Name & " [" & _
zVarAssign.DynProperties("SourceVariable").Name & " > " & _
zVarAssign.DynProperties("TargetVariable").Name & "]"
Next i
End Sub

Other topics in this chapter

VarAssignments-Properties

VarAssignments-Methods


VarAssignments-Properties

Manual -> Programming interfaces -> Objectmodel -> VarAssignments -> VarAssignments-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Returns count of contained objects | read only | read only
IProject | Parent | Parent of object | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> VarAssignments -> VarAssignments-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> VarAssignments -> VarAssignments-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


VarAssignments-Methods

Manual -> Programming interfaces -> Objectmodel -> VarAssignments -> VarAssignments-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CheckIn | Save module modifications to server (editor). | available | not used
VARIANT_BOOL | CheckOut | Allow module modifications (editor). | available | not used
IVarAssignment | Create | Creates and returns a new Object | available | not used
IVarAssignment | CreateByID | Creates and returns a new Object | available | not used
VARIANT_BOOL | Delete | Deletes the objects from collection | available | not used
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | Get | Get the latest version from the server (editor). | available | not used
VARIANT_BOOL | Import | Imports the selected XML file | available | not used
VARIANT_BOOL | IsCheckedOut | Returns true when the current module checked out by the current user (editor). | read only | not used
VARIANT_BOOL | IsDifferent | Return true when the local- and server version are different (editor). | read only | not used
VARIANT_BOOL | IsLocked | Returns true when the current module is Locked by another user (editor). | read only | not used
IVarAssignment | Item | Returns a object at a position or by a specified key | available | not used
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used
VARIANT_BOOL | UndoCheckOut | Undo module modifications (editor). | available | not used
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used

Other topics in this chapter

Item

Create

CreateByID

Delete

SingleExport

Export

Import

Get

CheckOut

CheckIn

UndoCheckOut

IsLocked

IsCheckedOut

IsDifferent


Item

Manual -> Programming interfaces -> Objectmodel -> VarAssignments -> VarAssignments-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a object at a position or by a specified key

Datatype

Item(VARIANT vID) As VarAssignment

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Index or name. If the parameter is a numerical value, the Frame is searched by its index (>= 0 and <= Count-1). If it is an alphanumerical value, the Frame is searched by its unique name.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vID As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'Enumerate all Assignements of the active project
Sub EnumAssignments()
Dim zVarAssign As VarAssignment
Dim zVarAssigns As VarAssignments
Dim i As Integer

Set zVarAssigns = MyWorkspace.ActiveDocument.VarAssignments
For i = 0 To zVarAssigns.Count - 1
Set zVarAssign = zVarAssigns.Item(i)
Debug.Print zVarAssign.Name & " [" & _
zVarAssign.DynProperties("SourceVariable").Name & " > " & _
zVarAssign.DynProperties("TargetVariable").Name & "]"
Next i
End Sub


Create

Manual -> Programming interfaces -> Objectmodel -> VarAssignments -> VarAssignments-Methods -> Create

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates and returns a new Object

Datatype

Create(String bsName,String bsSource,String bsTarget) As VarAssignment

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Name of Assignment as string

Name of source variable as string.

Name of target variable as string

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsName As String

bsSource As String

bsTarget As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'Create a new VarAssignment (Allocation)
Sub CreateAssignment()
Dim zVarAssign As VarAssignment
'by NAME
Set zVarAssign = MyWorkspace.ActiveDocument.VarAssignments.Create("MyAssignment", "WIZ_VAR_10", "WIZ_VAR_11")
End Sub


CreateByID

Manual -> Programming interfaces -> Objectmodel -> VarAssignments -> VarAssignments-Methods -> CreateByID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates and returns a new Object.

Datatype

CreateByID(String bsName,long nSourceID,long nTargetID) As VarAssignment

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Name of Assignment as string.

PvID of source variable as string.

PvID of target variable as string

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsName As String

nSourceID As Long

nTargetID As Long

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'Create a new VarAssignment (Allocation)
Sub CreateAssignment()
Dim zVarAssign As VarAssignment
Dim zSrcVar As Variable
Dim zDstVar As Variable
'OR by ID
Set zSrcVar = MyWorkspace.ActiveDocument.Variables.Item("WIZ_VAR_10")
Set zDstVar = MyWorkspace.ActiveDocument.Variables.Item("WIZ_VAR_11")
Set zVarAssign = MyWorkspace.ActiveDocument.VarAssignments.CreateByID("MyAssignment", zSrcVar.PvID, zDstVar.PvID)
End Sub


Delete

Manual -> Programming interfaces -> Objectmodel -> VarAssignments -> VarAssignments-Methods -> Delete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Deletes the objects from collection

Datatype

Delete(String bsName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Name of Assignment as string

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

'Delete an VarAssignment (Allocation)
Sub DeleteAssignment()
Dim bResult As Boolean
'by NAME
bResult = MyWorkspace.ActiveDocument.VarAssignments.Delete("MyAssignment")
End Sub


SingleExport

Manual -> Programming interfaces -> Objectmodel -> VarAssignments -> VarAssignments-Methods -> SingleExport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SingleExport(VARIANT vIndexOrName,BSTR bsFileName) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Export

Manual -> Programming interfaces -> Objectmodel -> VarAssignments -> VarAssignments-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export settings to an xml file

Datatype

Export(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to export.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Import

Manual -> Programming interfaces -> Objectmodel -> VarAssignments -> VarAssignments-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced.

Datatype

Import(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to import.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


Get

Manual -> Programming interfaces -> Objectmodel -> VarAssignments -> VarAssignments-Methods -> Get

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype

Get() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckOut

Manual -> Programming interfaces -> Objectmodel -> VarAssignments -> VarAssignments-Methods -> CheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype

CheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckIn

Manual -> Programming interfaces -> Objectmodel -> VarAssignments -> VarAssignments-Methods -> CheckIn

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype

CheckIn() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


UndoCheckOut

Manual -> Programming interfaces -> Objectmodel -> VarAssignments -> VarAssignments-Methods -> UndoCheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype

UndoCheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsLocked

Manual -> Programming interfaces -> Objectmodel -> VarAssignments -> VarAssignments-Methods -> IsLocked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype

IsLocked() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsCheckedOut

Manual -> Programming interfaces -> Objectmodel -> VarAssignments -> VarAssignments-Methods -> IsCheckedOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype

IsCheckedOut() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsDifferent

Manual -> Programming interfaces -> Objectmodel -> VarAssignments -> VarAssignments-Methods -> IsDifferent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype

IsDifferent() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Variable

Manual -> Programming interfaces -> Objectmodel -> Variable

Remarks

The collection Variables contains all defined variables of the current project. With this collection you can access all or selected variables.Beside the access via the index a variable also can be found with its unique name or the unique channel Id.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub CreateVariable()

Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim zDrivers As Drivers 'Object from type Drivers
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zEdLimit As EdLimit 'Object from type EdLimit

'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
Set zDrivers = MyWorkspace.ActiveDocument.Drivers
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes

'Create a "intern driver" variable called "TestVariable" with object type "internal variable" and datatype "INT"
Set zVariable = zVariables.CreateVar("TestVariable", zDrivers.Item(0), 33, zVarTypes.Item("INT"))
'Create a limit at the "TestVariable"
zVariable.CreateEdLimit

'Select the first limit of the variable
Set zEdLimit = zVariable.EDLimitItem(0)
'Set the limit active
zEdLimit.Active = True
'Set limit text
zEdLimit.Text = "Limit reached"
'Set limit value to 10
zEdLimit.LimitValue = 10
'Set the limit as maximum
zEdLimit.IsMax = True
'Set the limit as alarm
zEdLimit.Alarm = True
'Limit should be recognized in the CEL
zEdLimit.Cel = True

Call CreateArrayVariable

End Sub

Sub CreateArrayVariable()

Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim zArrEl As Variable 'Object from type Variables
Dim zEdLimit As EdLimit 'Object from type EdLimit
Dim i As Integer

'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
Set zDrivers = MyWorkspace.ActiveDocument.Drivers
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes

'Create a "intern driver" array variable called "ArrayVar" from object type "internal variable", datatype "INT", start at index 1,
'dimension of 5 and automatic addressing
Set zVariable = zVariables.CreateArrayVar("ArrayVar", zDrivers.Item(0), 33, zVarTypes.Item("INT"), 1, 5, 0, 0, True, False, False)

'Activate all array elements
For i = 0 To 4
zVariable.ActivateSubItem (i)
Next i

'Read the first array element
Set zArrEl = zVariable.SubItem(0)
'Create a limit at the array element
zArrEl.CreateEdLimit

'Select the first limit of the variable
Set zEdLimit = zArrEl.EDLimitItem(0)
'Set the limit active
zEdLimit.Active = True
'Set limit text
zEdLimit.Text = "Limit reached"
'Set limit value to 10
zEdLimit.LimitValue = 10
'Set the limit as maximum
zEdLimit.IsMax = True
'Set the limit as alarm
zEdLimit.Alarm = True
'Limit should be recognized in the CEL
zEdLimit.Cel = True

End Sub

Other topics in this chapter

Variable-Properties

Variable-Methods

Variable-Dynamic properties


Variable-Properties

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | Alignment |  | available | read only | yes | yes
VARIANT | AlternateArchiveValue |  | available | read only | yes | yes
VARIANT | AlternateValue | For internal use only | available | read only | yes | yes
long | ArraySize |  | available | read only | yes | yes
IVarType | BaseType |  | read only | read only | yes | yes
long | BitAddr |  | available | read only | yes | yes
long | DataBlock |  | available | read only | yes | yes
IEC_TYPES | DataType |  | read only | read only | yes | yes
short | Digits |  | available | available | yes | yes
VARIANT_BOOL | IsArray |  | read only | read only | yes | yes
DATE | LastUpdateTime |  | read only | read only | yes | yes
short | LastUpdateTimeMilliSeconds |  | read only | read only | yes | yes
BSTR | Name |  | available | read only | yes | yes
long | NetAddr |  | available | read only | yes | yes
long | Offset |  | available | read only | yes | yes
IVariables | Parent |  | read only | read only | yes | yes
long | PvID |  | read only | read only | yes | yes
VARIANT | RangeMax |  | available | available | yes | yes
VARIANT | RangeMin |  | available | available | yes | yes
VARIANT_BOOL | ReadOnly |  | available | read only | yes | yes
BSTR | Recourceslabel |  | available | read only | yes | yes
VARIANT | SignalMax |  | available | read only | yes | yes
VARIANT | SignalMin |  | available | read only | yes | yes
long | StatusExtValue |  | not used | read only | yes | yes
BSTR | StatusString |  | not used | available | yes | yes
long | StatusValue |  | not used | read only | yes | yes
long | StringLength |  | available | read only | yes | yes
BSTR | Tagname |  | available | read only | yes | yes
BSTR | Unit |  | available | available | yes | yes
VARIANT | UserValue |  | available | available | yes | yes

Other topics in this chapter

Parent

PvID

Name

Tagname

Recourceslabel

DataType

BaseType

Digits

Unit

SignalMax

SignalMin

RangeMin

RangeMax

UserValue

AlternateValue

AlternateArchiveValue

StatusValue

StatusExtValue

StatusString

LastUpdateTime

LastUpdateTimeMilliSeconds

ReadOnly

IsArray

ArraySize

NetAddr

DataBlock

Offset

BitAddr

Alignment

StringLength


Parent

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Variables

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


PvID

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> PvID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the unique variable ID (per project). With this ID a variable can be found in the central variables list of the project.

Datatype

PvID() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the name of a variable.

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Tagname

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> Tagname

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the identification of the variable.

Datatype

Tagname() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Recourceslabel

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> Recourceslabel

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the resources label of the variable.

Datatype

Recourceslabel() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


DataType

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> DataType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the defined data type of the variable as a constant.

Datatype

DataType() As EC_TYPES

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


BaseType

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> BaseType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns informations about the datatype which is used at the variable.

Datatype

BaseType() As VarType

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Digits

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> Digits

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the number of digits from a real or lreal variable.

Datatype

Digits() As short

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


Unit

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> Unit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the defined unit of the variable. The unit specifies the value of the variable, e.g. degrees Celcius, .... The configuration of most modules allows the display of the unit, e.g. numerical value, archive picture, ...This property can be changed in the Runtime.

Datatype

Unit() As String

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


SignalMax

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> SignalMax

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the maximal signal range of a variable.

Datatype

SignalMax() As VARIANT

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


SignalMin

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> SignalMin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the minimal signal range of a variable.

Datatype

SignalMin() As VARIANT

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


RangeMin

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> RangeMin

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the minimal measuring range of a variable.

Datatype

RangeMin() As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


RangeMax

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> RangeMax

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the maximal measuring range of a variable.

Datatype

RangeMax() As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


UserValue

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> UserValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This property can get a user defined value and is not used for the Runtime. In VBA a variant can be linked with the variable, that is needed at a later moment.This variant could e.g. be the Id for a record in a SQL database, that contains further information on the variable.

Datatype

UserValue() As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


AlternateValue

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> AlternateValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the alternate value of the variable. The alternate value of a variable is used in archives and the recipe group manager, if the current value is needed but not available, e.g. automatic filling of archives, no connection to the PLC, ...

Datatype

AlternateValue() As VARIANT

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


AlternateArchiveValue

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> AlternateArchiveValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the alternate value of the variable. The alternate value of a variable is used in archives and the recipe group manager, if the current value is needed but not available, e.g. automatic filling of archives, no connection to the PLC, ...

Datatype

AlternateArchiveValue() As VARIANT

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


StatusValue

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> StatusValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The returned value corresponds to the status of a variable.

Status | Abbreviations in editor | Value (hex)
Invalid | I-BIT | 0x00040000
Not updated | not used | 0x20000000
Alternative value | read only | 0x08000000
General request | yes | 0x00010000
Spontaneous | yes | 0x00020000
Summer/winter time announcement | SU/WI | 0x00080000
Switched off | N_UPDATE | 0x00080000
Realtime external | RT_E | 0x00200000
Realtime internal | RT_I | 0x00400000
Winter time | WINTER | 0x80000000
Manual value | MVALUE | 0x00001000
User status 1 .. 8 | ST_M1 .. ST_M8 | 0x00000001- 0x00000080
Select | SELEC | 0x00000100
Revision | REV | 0x00000200
Desired direction | DIREC | 0x00000400
Runtime exceeded | RTE | 0x00000800
Default message trafo value | DM_TR | 0x01000000
Not sortable | NSORT | 0x00800000
Info for variable | INFO | 0x04000000
Transmission cause | TCBx | 0x0000003F00000000
P/N bit | PN_BIT | 0x0000004000000000
Test bit | T_BIT | 0x0000008000000000
Normal status | NORM | 0x0000040000000000
Deviation normal status | ABNORM | 0x0000080000000000

NOTE:
Check the property IsOnline to make sure that the variable is advised, when you want to read this property to avoid errors! (> 6.21)

Datatype

StatusValue() As long
VBA | yes | 0x00040000
VSTA | yes | 0x00040000

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


StatusExtValue

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> StatusExtValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the status value for states where the higher 32 bits are set.For definition of Statis see StatusValue

NOTE:
Check the property IsOnline to make sure that the variable is advised, when you want to read this property to avoid errors! (> 6.21)

Datatype

StatusExtValue() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


StatusString

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> StatusString

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the status of a variable.

For definition of Statis see StatusValue

NOTE:
Check the property IsOnline to make sure that the variable is advised, when you want to read this property to avoid errors! (> 6.21)

Datatype

StatusString() As String

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes


LastUpdateTime

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> LastUpdateTime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the time of the last update of the value.

NOTE:
Check the property IsOnline to make sure that the variable is advised, when you want to read this property to avoid errors! (> 6.21)

Datatype

LastUpdateTime() As DATE

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


LastUpdateTimeMilliSeconds

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> LastUpdateTimeMilliSeconds

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the milliseconds since the last update time.

NOTE:
Check the property IsOnline to make sure that the variable is advised, when you want to read this property to avoid errors! (> 6.21)

Datatype

LastUpdateTimeMilliSeconds() As short

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ReadOnly

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> ReadOnly

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if the variable is read only and false if it is readable+writeable.

Datatype

ReadOnly() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


IsArray

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> IsArray

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if the variable is an array (ArraySize > 1).

Datatype

IsArray() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ArraySize

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> ArraySize

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the number of indices of the variable. A standard variable has no index. With array variables this property returns the defined size of the array.

Datatype

ArraySize() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


NetAddr

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> NetAddr

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the net address of a variable.

Datatype

NetAddr() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


DataBlock

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> DataBlock

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the number of the used data block.

Datatype

DataBlock() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Offset

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> Offset

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the offset of a variable.

Datatype

Offset() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


BitAddr

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> BitAddr

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the bit number of a variable.

Datatype

BitAddr() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Alignment

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> Alignment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the alignment item of the addressing settings.

Datatype

Alignment() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


StringLength

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Properties -> StringLength

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the length of a string variable.

Datatype

StringLength() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Variable-Methods

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | ActivateSubItem | - | available | not used
VARIANT_BOOL | CheckIn | Save module modifications to server (editor). | available | not used
VARIANT_BOOL | CheckOut | Allow module modifications (editor). | available | not used
VARIANT_BOOL | CreateDynProperty | - | available | not used
IEdLimit | CreateEdLimit | - | available | not used
VARIANT_BOOL | DeactivateSubItem | - | available | not used
VARIANT_BOOL | DeleteEdLimit | - | available | not used
IDriver | Driver | - | available | available
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
long | EdLimitCount | - | read only | not used
IEdLimit | EdLimitItem | - | available | not used
VARIANT_BOOL | Get | Get the latest version from the server (editor). | available | not used
VARIANT_BOOL | IsCheckedOut | Returns true when the current module checked out by the current user (editor). | read only | not used
VARIANT_BOOL | IsDifferent | Return true when the local- and server version are different (editor). | read only | not used
VARIANT_BOOL | IsLimitActiv | - | available | available
VARIANT_BOOL | IsLocked | Returns true when the current module is Locked by another user (editor). | read only | not used
VARIANT_BOOL | IsOnline | - | not used | read only
VARIANT_BOOL | IsRDAActiv | - | read only | read only
VARIANT_BOOL | IsRemaActiv | - | read only | read only
ILimits | Limits | - | not used | available
BSTR | SecondaryUnitName [GET] | - | not used | available
void | SetValueWithStatus | - | not used | available
SCODE | SetValueWithStatusEx | - | not used | available
IVariable | SubItem | - | available | read only
long | SubItemCount | - | read only | read only
BSTR | SubItemName | - | available | read only
VARIANT_BOOL | UndoCheckOut | Undo module modifications (editor). | available | not used
double | CalcPrimaryUnitValue | - | not used | available
double | CalcSecondaryUnitValue | - | not used | available
void | ModifyAlternateValue | - | available | available
short | SecondaryUnitDigits [GET] | - | not used | available
VARIANT | Value [GET] | - | not used | available
void | Value [PUT] | - | not used | available
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used
IDriver | Driver | - | available | available
IDriver | Driver | - | available | available
IDriver | Driver |  | available | available

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

CreateDynProperty

Value [GET]

Value [PUT]

ModifyAlternateValue

SecondaryUnitName [GET]

SecondaryUnitDigits [GET]

IsRDAActiv

IsLimitActiv

IsRemaActiv

IsOnline

Driver

Limits

SetValueWithStatus

SetValueWithStatusEx

CalcSecondaryUnitValue

CalcPrimaryUnitValue

EdLimitCount

EdLimitItem

CreateEdLimit

DeleteEdLimit

SubItemCount

SubItem

SubItemName

ActivateSubItem

DeactivateSubItem

Get

CheckOut

CheckIn

UndoCheckOut

IsLocked

IsCheckedOut

IsDifferent


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


CreateDynProperty

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> CreateDynProperty

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method creates a dynamic property.

Datatype

CreateDynProperty(String bsPath) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

String for the dynamic property to be created.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub EdLimDynProp()

Dim zVariable As Variable 'Child object from type Variables

'Take the first variable from the variables list
Set zVariable = MyWorkspace.ActiveDocument.Variables.Item(0)

'Create a limit
zVariable.CreateDynProperty ("Limits")
'Set the limit text
zVariable.DynProperties("Limits[0].Text") = "Limit reached"
'Set the limit value
zVariable.DynProperties("Limits[0].LimitValue") = 10
'Set the value as maximum
zVariable.DynProperties("Limits[0].IsMax") = True

End Sub


Value [GET]

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> Value [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Value [GET]([optional]VARIANT vIndex) As VARIANT

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Value [PUT]

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> Value [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Value [PUT]([optional]VARIANT vIndex,VARIANT newValue) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ModifyAlternateValue

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> ModifyAlternateValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ModifyAlternateValue(VARIANT newValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SecondaryUnitName [GET]

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> SecondaryUnitName [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SecondaryUnitName() As String

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SecondaryUnitDigits [GET]

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> SecondaryUnitDigits [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SecondaryUnitDigits [GET]() As short

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsRDAActiv

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> IsRDAActiv

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns true if RDA is activated at a variable.

Datatype

IsRDAActiv() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsLimitActiv

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> IsLimitActiv

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns true for limits activated and false for reaction matrix activated.

Datatype

IsLimitActiv() As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsRemaActiv

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> IsRemaActiv

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns true if a variable is linked to a reaction matrix.

Datatype

IsRemaActiv() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsOnline

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> IsOnline

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method checks, if the current variable is advised and has a valid value.

A variable will be advised when:

- the variable is actually displayed in a picture...

- the variable has defined alarms...

- the variable is used within VBA (OnlineVariable)...

- the variable has set the option "DDE"...

- ...

Datatype

IsOnline() As Boolean

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Driver

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> Driver

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Driver() As IDriver

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Limits

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> Limits

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the limit administration of the variable. In the limit administration you can access the single limits with their most important information.

Datatype

Limits() As Limits

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub Limit()

Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim zLimit As Limit 'Object from type Limit

'Fill the objects
Set zVariables = thisProject.Variables
'Read the "TestVariable" variable
Set zVariable = zVariables.Item("TestVariable")

'Read the first limit of the variable
Set zLimit = zVariable.Limits.Item(0)
'Show the alarm class
Debug.Print "AlarmClass = " & zLimit.AlarmClass
'Show the limit text
Debug.Print "Limit text = " & zLimit.Text
'Show the limit value
Debug.Print "Limit value = " & zLimit.Value
'Show if the value is the maximum
Debug.Print "Acts on maximum = " & zLimit.IsMax

End Sub


SetValueWithStatus

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> SetValueWithStatus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method sets a value in combination with a status and a timestamp.

Datatype

SetValueWithStatus(VARIANT Value,long Status,long Time,short TimeMilliSec) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

Milliseconds of time stamp for set value.

Lower 32 status bits.
For definition of Statis see StatusValue.

Time stamp for set value.

Set value as Variant.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

TimeMilliSec As short

Status As Long

Time As Long

Value As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetValue()

Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables

'Fill the objects
Set zVariables = thisProject.Variables
'Take the first variable
Set zVariable = zVariables.Item(0)
'Write value 10, status I-BIT, with the actual time and 333 ms onto the variable
zVariable.SetValueWithStatus 10, 262144, Now, 333

End Sub


SetValueWithStatusEx

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> SetValueWithStatusEx

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method sets a value in combination with a status and a timestamp. The difference to the "SetValueWithStatus" method is that you have the opportunity to set statis which also use the higher 32 bits.

Datatype

SetValueWithStatusEx(VARIANT Value,long Status,long StatusExt,long Time,short TimeMilliSec) As void

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

Milliseconds of time stamp for set value.

Lower 32 status bits.
For definition of Statis see StatusValue.

Higher 32 status bits.
For definition of Statis see StatusValue.

Time stamp for set value.

Set value as Variant.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

TimeMilliSec As short

Status As Long

StatusExt As Long

Time As Long

Value As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetValueEx()

Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables

'Fill the objects
Set zVariables = thisProject.Variables
'Take the first variable
Set zVariable = zVariables.Item(0)
'Write value 10, set the lower 32 Bit 0, set the higher 32 Bit with 128 (State: Test bit), with the actual time and 333 ms onto the variable
zVariable.SetValueWithStatusEx 10, 0, 128, Now, 333

End Sub


CalcSecondaryUnitValue

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> CalcSecondaryUnitValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CalcSecondaryUnitValue(double dfPrimaryValue) As double

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CalcPrimaryUnitValue

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> CalcPrimaryUnitValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CalcPrimaryUnitValue(double dfSecondaryValue) As double

Availability

Environment | Available
Editor | not used
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


EdLimitCount

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> EdLimitCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns the number of limits from a variable.

Datatype

EdLimitCount() As long

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


EdLimitItem

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> EdLimitItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns an "EdLimit" object from a variable.

Datatype

EdLimitItem(VARIANT vIndex) As EdLimit

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

The limit can be selected via a number (counting starts at 0) or via a string (name of the limit).

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vIndex As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub EDLimitItem()

Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim zDrivers As Drivers 'Object from type Drivers
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zEdLimit As EdLimit 'Object from type EdLimit
Dim i As Integer

'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
Set zDrivers = MyWorkspace.ActiveDocument.Drivers
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes

'Create a "intern driver" variable called "TestVariable" with object type "internal variable" and datatype "INT"
Set zVariable = zVariables.CreateVar("TestVariable", zDrivers.Item(0), 33, zVarTypes.Item("INT"))
'Create 5 editor limits at the "TestVariable"
For i = 0 To 4
zVariable.CreateEdLimit
Next i

'Select the first limit of the variable
Set zEdLimit = zVariable.EDLimitItem(0)
'Set the limit active
zEdLimit.Active = True
'Set limit text
zEdLimit.Text = "Limit reached"
'Set limit value to 10
zEdLimit.LimitValue = 10
'Set the limit as maximum
zEdLimit.IsMax = True
'Set the limit as alarm
zEdLimit.Alarm = True
'Limit should be recognized in the CEL
zEdLimit.Cel = True

End Sub


CreateEdLimit

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> CreateEdLimit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method creates a limit at a variable.

Datatype

CreateEdLimit() As EdLimit

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub CreateEDLimit()

Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim zDrivers As Drivers 'Object from type Drivers
Dim zVarTypes As VarTypes 'Object from type VarTypes

'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
Set zDrivers = MyWorkspace.ActiveDocument.Drivers
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes

'Create a "intern driver" variable called "TestVariable" with object type "internal variable" and datatype "INT"
Set zVariable = zVariables.CreateVar("TestVariable", zDrivers.Item(0), 33, zVarTypes.Item("INT"))
'Create a editor limit at the "TestVariable"
zVariable.CreateEdLimit

End Sub


DeleteEdLimit

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> DeleteEdLimit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method deletes selected limits of a variable.

Datatype

DeleteEdLimit(VARIANT vIndex) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

The limit can be selected via its name (string) or via a number (counting starts at 0).

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vIndex As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub DeleteEDLimit()

Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim zDrivers As Drivers 'Object from type Drivers
Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim i As Integer

'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
Set zDrivers = MyWorkspace.ActiveDocument.Drivers
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes

'Create a "intern driver" variable called "TestVariable" with object type "internal variable" and datatype "INT"
Set zVariable = zVariables.CreateVar("TestVariable", zDrivers.Item(0), 33, zVarTypes.Item("INT"))
'Create 5 editor limits at the "TestVariable"
For i = 0 To 4
zVariable.CreateEdLimit
Next i
'Delete the 2nd limit
zVariable.DeleteEDLimit (1)

End Sub


SubItemCount

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> SubItemCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns the number of sub items in an array or structure.

Datatype

SubItemCount() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub CountItems()

Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim zDrivers As Drivers 'Object from type Drivers
Dim zVarTypes As VarTypes 'Object from type VarTypes

'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
Set zDrivers = MyWorkspace.ActiveDocument.Drivers
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes

'Create a "intern driver" array variable called "array" from object type "internal variable", datatype "INT", start at index 1,
'dimension of 5 and automatic addressing
Set zVariable = zVariables.CreateArrayVar("array", zDrivers.Item(0), 33, zVarTypes.Item("INT"), 1, 5, 0, 0, True, False, False)

'Activate all array elements
For i = 0 To 4
zVariable.ActivateSubItem (i)
Next i

Debug.Print "Count items = " & zVariable.SubItemCount

End Sub


SubItem

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> SubItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this method you get array and structure elements by index.

Datatype

SubItem(long lIndex) As Variable

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Parameters

Position of the element in the array or structure.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

lIndex As Long

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SubItem()

Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim cacheElement As Variable 'Child object from type Variables
Dim zEdLimit As EdLimit 'Object form type EdLimit
Dim zDrivers As Drivers 'Object from type Drivers
Dim zVarTypes As VarTypes 'Object from type VarTypes

'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
Set zDrivers = MyWorkspace.ActiveDocument.Drivers
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes

'Create a "intern driver" array variable called "array" from object type "internal variable", datatype "INT", start at index 1,
'dimension of 5 and automatic addressing
Set zVariable = zVariables.CreateArrayVar("array", zDrivers.Item(0), 33, zVarTypes.Item("INT"), 1, 5, 0, 0, True, False, False)

'Activate all array elements
For i = 0 To 4
zVariable.ActivateSubItem (i)
Next i

'Read the first element from the array
Set cacheElement = zVariable.SubItem(0)
'Create a limit at the array element
cacheElement.CreateEdLimit

'Select the first limit of the variable
Set zEdLimit = cacheElement.EDLimitItem(0)
'Set the limit active
zEdLimit.Active = True
'Set limit text
zEdLimit.Text = "Limit reached"
'Set limit value to 10
zEdLimit.LimitValue = 10
'Set the limit as maximum
zEdLimit.IsMax = True
'Set the limit as alarm
zEdLimit.Alarm = True
'Limit should be recognized in the CEL
zEdLimit.Cel = True

End Sub


SubItemName

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> SubItemName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns the name of an array or structure item.

Datatype

SubItemName(long lIndex) As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Parameters

Position of the element in the array or structure (starts at 0).

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

lIndex As Long

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SubItemNames()

Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim zDrivers As Drivers 'Object from type Drivers
Dim zVarTypes As VarTypes 'Object from type VarTypes

'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
Set zDrivers = MyWorkspace.ActiveDocument.Drivers
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes

'Create a "intern driver" array variable called "array" from object type "internal variable", datatype "INT", start at index 1,
'dimension of 5 and automatic addressing
Set zVariable = zVariables.CreateArrayVar("array", zDrivers.Item(0), 33, zVarTypes.Item("INT"), 1, 5, 0, 0, True, False, False)

'Activate all array elements
For i = 0 To 4
zVariable.ActivateSubItem (i)
Next i

'Show the name of all array elements
For i = 0 To zVariable.SubItemCount - 1
Debug.Print "Name of first sub item = " & zVariable.SubItemName(i)
Next i

End Sub


ActivateSubItem

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> ActivateSubItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method activates an array or a structure element. Returns true when element has been activated, false if no change has been done.

Datatype

ActivateSubItem(VARIANT vSubItem) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Array or structure element can be selected via name (string) or via number (counting starts at 0).

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vSubItem As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ActiveSubItem()

Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim actSubItem As Boolean 'Status variable

'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
'Array variable called "array" with some elements should be available
Set zVariable = zVariables.Item("array")
'Element "array[2]" is activated
actSubItem = zVariable.ActivateSubItem("array[2]")
Debug.Print "Activated = " & actSubItem

End Sub


DeactivateSubItem

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> DeactivateSubItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method deactivates array or structure elements.

Datatype

DeactivateSubItem(VARIANT vSubItem) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Array or structure element can be selected via name (string) or via number (counting starts at 0).

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vSubItem As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub DeActivateSubItem()

Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables
Dim actSubItem As Boolean 'Status variable

'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
'Array variable called "array" with some elements should be available
Set zVariable = zVariables.Item("array")
'Element "array[2]" is deactivated
actSubItem = zVariable.DeActivateSubItem("array[2]")
Debug.Print "Activated = " & actSubItem

End Sub


Get

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> Get

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype

Get() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckOut

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> CheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype

CheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckIn

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> CheckIn

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype

CheckIn() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


UndoCheckOut

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> UndoCheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype

UndoCheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsLocked

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> IsLocked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype

IsLocked() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsCheckedOut

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> IsCheckedOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype

IsCheckedOut() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsDifferent

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Methods -> IsDifferent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype

IsDifferent() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Variable-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

C$$DrvName$$VarED

3S_Arti_NG variable ED

AKDrv variable ED

CAMISTSVarED

BACnetNG variable ED

BeckhoffNG variable ED

Biffi variable ED

BURPVI variable ED

CTI variable ED

CDNP3_TGVarED

DNP3 variable ED

EibV2 variable ED

Elrest variable ED

IEC61850 variable ED

IEC62056 variable ED

IEC870_103 variable ED

IEC870 variable ED

iLon100 variable ED

Internal variable ED

Internal variable RT

Lon32 - Variable ED

MathDr32 - Variable ED

Mathematical variable RT

NWMDRV32 - Variable ED

OPCUA variable ED

Sample32 variable ED

SE_32 variable ED function

SE_32 variable ED

SPRECON870 variable ED

Sys2000 variable ED

Syskron variable ED

SysDrv variable ED

Base class variable

Variable ED

Variable RT

Other topics in this chapter

CVarGrenze

C$$DrvName$$VarED

3S_Arti_NG variable ED

AKDrv variable ED

CAMISTSVarED

BACnetNG variable ED

BeckhoffNG variable ED

Biffi variable ED

BURPVI variable ED

CTI variable ED

CDNP3_TGVarED

DNP3 variable ED

EibV2 variable ED

Elrest variable ED

IEC61850 variable ED

IEC62056 variable ED

IEC870_103 variable ED

IEC870 variable ED

iLon100 variable ED

Internal variable ED

Internal variable RT

Lon32 - Variable ED

CMathInfo

MathDr32 - Variable ED

Mathematical variable RT

NWMDRV32 - Variable ED

OPCUA variable ED

Sample32 variable ED

SE_32 variable ED function

SE_32 variable ED

SPRECON870 variable ED

Sys2000 variable ED

Syskron variable ED

SysDrv variable ED

Base class variable

Variable ED

Variable RT


CVarGrenze

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> CVarGrenze

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

Active

Limit active

Active: The limit value is taken into account in Runtime.
Inactive: The limit value is ignored in Runtime.
Default: active.

More in the online help.

VT_BSTR

Text

Limit text

This text will be shown in the Alarm Message List, the Chronological Event List and/or the alarm status line (depending on the configuration) after a limit violation.

Dynamic limit text: allows to include the current values of other variables in the limit text of a variable and in the limit text of reaction matrices. You can also link a fixed text with keywords from a language table via an index. This leads to some limitations:
static text will be stored in the memory area of the limit text, which is limited to 1024 characters. The values of the linked variables are stored in the memory area of the comment text, which is limited to 80 characters.

These limitations can be circumvented by the extension for long dynamic limit texts. For this, you need to activate Long dynamic limit texts CEL and Long dynamic limit texts AML. Variable values for dynamic limit texts will then be stored in a separate file. Attention: When using dynamic limit texts, you cannot enter comments.

More in the online help.

VT_R8

LimitValue

Limit

Not available if no dynamic limit value is defined:
Defines the value from which the limit value is breached.
Whether values above this or below this trigger a breach is defined by the "Minimum / Maximum" property.

More in the online help.

VT_BOOL

IsMax

Minimum/Maximum

Minimum: Limit value breach when reaching or going below the defined limit value.
Maximum: Limit value breach when reaching or exceeding the defined limit value.
Default: Minimum.

More in the online help.

VT_R8

ThresholdValue

Threshold value

A threshold value can be defined that will be used for clearing a limit violation. This avoids unwanted reactions due to osciallating numerical values.
Example 1: a maximum value of 900 and a threshold of 10 result in 890
The limit will be violated when exceeding 900 and the critical area will be left when falling under 890.
Example 2: a minimum value of 900 and a threshold of 10 result in 910
The limit will be violated when falling below 900 and the critical area will be left when exceeding 910.
As opposed to the hysteresis, this property will only affect the alarm behavior and not the representation of the value.

More in the online help.

VT_UI4

Delay

Delay time [s]

Duration (in seconds) that the limit violation must be active. The value must be active for the defined duration (without interruption), in order to trigger the configured actions of the limit violation.
AML/CEL:

  • The time of the first violation is used as the time stamp for the limit violation in the AML and/or the CEL.
  • The first value after the delay time is entered as value, not the value that triggers the alarm.

Attention: In combination with the Flashing property, this property has the following effect in the network:

  • Limit value with flashing and without delay: linked elements will flash on the server and on the clients.
  • Limit value with flashing and delay: Linked elements will only flash on the server, not on the clients.
  • Alarm with flashing and without delay: linked elements will flash on the server and on the clients.
  • Alarm with flashing and delay: linked elements will flash on the server and on the clients.

Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_BOOL

IsVariable

Dynamic limit active

Specifies whether the limit text is fixed or whether it is dynamically determined via a variable.

  • Inactive: The limit value is defined using a fixed value assignment.
  • Active: The limit value is defined using the value of a different variable.
    AML/CEL: The latest time stamp of both of the variables is used as the time stamp for the limit violation in the AML and/or the CEL.

Default: inactive

Attention: If the variable limit changes, so that the current value of the variable is suddenly in the critical range without changing, there will also be a limit violation.

More in the online help.

ZT_VARIABLE

Variable

Variable

Only available if the dynamic limit value is active:
Variable that is to be used as a dynamic limit value.

More in the online help.

ZT_FUNCTION

Function

Function

Function that is to be automatically executed in Runtime if the limit value is breached.
If the status is defined as an alarm, spontaneous execution of the function can be suppressed. To do this, select the Call via button in screen Alarm Message List option.
If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here.

More in the online help.

VT_BOOL

AML_Call

Call via button in screen Alarm Message List

Only available if the limit value is an alarm:

  • Active: The linked function is not carried out spontaneously in online operation, but only after pressing the Function button in the alarm list.
  • Inactive: The function is carried out spontaneously as soon as the alarm occurs.

(Default) Inactive:

More in the online help.

ZT_COLOR

Color

Limit color

Color information for the layer coloring and the status color when using the variables in the binary element; the color definition of the alarm texts in the Alarm Message List occurs in the alarm/event class definition:

More in the online help.

VT_BOOL

Invisible

Invisible

Active: Status is not displayed in the "status element" dynamic element or elements are not displayed if their visibility is controlled by this variable.
Inactive: The visibility is not influenced by the breach of the limit value.
Default: inactive.

More in the online help.

VT_BOOL

Blinking

Flashing

Active: Dynamic elements which are linked to this variable start to flash as soon as this limit is violated.
You can acknowledge the flashing with a right double click.
Inactive: The limit does not cause flashing.
Default: inactive.
Attention: If combined with property Delay time [s], this property has the following effects in the network:
Limit with flashing and without delay: linked elements will flash on the server and on the clients.
Limit with flashing and with delay: Linked elements will only flash on the Server not on the clients.
Alarm with flashing and without delay: linked elements will flash on the server and on the clients.
Alarm with flashing and with delay: linked elements will flash on the server and on the clients.

More in the online help.

VT_BSTR

UserProperty1

Additional information 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.

Mehr im Online-Handbuch

VT_BSTR

UserProperty2

Additional information 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.

Mehr im Online-Handbuch

VT_BOOL

Alarm

In Alarm Message List

Active: At a limit violation an entry is created in the Alarm Message List.
Inactive: In the Alarm Message list no entry is created.
Default: inactive

More in the online help.

VT_BOOL

Cel

In Chronological Event List

Active: In the event that a limit is breached, an entry is made in the Chronological Event List (CEL).
Inactive: No entry is made in the Chronological Event List.
Default: inactive.

More in the online help.

VT_BOOL

AlarmAcknowledge

To acknowledge

Only available for alarms.
Active: The alarm must be acknowledged before it is removed from the ring buffer.
Inactive: Acknowledging not necessary.
Default for alarms: active, otherwise inactive

More in the online help.

VT_BOOL

AlarmComment

Comment required

Only available if property To acknowledge is active.

Active: Before you can acknowledge an alarm, you must enter a comment. For this the user must have function authority Enter alarm comment.

Default: inactive

More in the online help.

VT_BOOL

AlarmDelete

To delete

Only available if property To acknowledge is active.
Active: The alarm must be acknowledged and deleted before it is removed from the ring buffer.
Inactive: No deleting necessary.
Default: inactive

More in the online help.

VT_BOOL

Print

Print

Active: Alarm or limit violation is online printed for this variable depending on the setting in property Printing for in group AML and CEL in the project settings.
Inactive: No online printing.
Default: inactive

More in the online help

VT_UI2

Group

Alarm/event group

Assigning an alarm/event group (max. 65535) for the limit when using it as alarm.
The assigning to an alarm/event group is carried out via selection in the list.
Default: 0 - (not used).

More in the online help.

ZT_BSTR_REF

GroupName

GroupName

Gets/Sets the alarm group of a limit.

VT_UI2

Class

Alarm/event class

Assigning an alarm/event class (max. 65535) for the limit when using it as alarm.
The alarm/event class assigning is carried out via selection in the list.
Default: 0 - (not used).

More in the online help.

ZT_BSTR_REF

ClassName

ClassName

Gets/Sets the alarm class which is linked to a limit.

ZT_FILE

HelpFile

Help file

Only available if the limit value is an alarm.

File (*.chm), from which a help chapter for this alarm is to be displayed in the Alarm Information List.

More about the help file in the online help.

Engineering for EPLAN:
It is possible to call up a page from EPLAN. To do this, the Eplan connection must be licensed and the path to the Eplan program must be defined in the zenon6.ini file.
Configuration:

  • Input of the character sequence $PRG:xxxxxx
  • xxxxxx is the placeholder for the parameters to be given
  • the Help chapter property is ignored, but must not be empty

More about EPLAN in the online help.

VT_BSTR

HelpCapture

Help chapter

Only available if the limit value is an alarm:
Help chapter that is to be displayed for this alarm in the alarm list.

More in the online help.


C$$DrvName$$VarED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> C$$DrvName$$VarED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


3S_Arti_NG variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> 3S_Arti_NG variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


AKDrv variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> AKDrv variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_UI2

DP_TYPE

Telegram Identifier

Telegram type, Message type

VT_UI2

DP_TYPE

Telegram Identifier

Telegram type, Message type

VT_UI1

R_NR

O1/Region number

Region number or Octet 1 (CASDU1)

VT_UI1

R_NR

O1/Region number

Region number or Octet 1 (CASDU1)

VT_UI1

K_NR

O2/Component

Component number or Octet 2 (CASDU2)

VT_UI1

K_NR

O2/Component

Component number or Octet 2 (CASDU2)

VT_UI1

B_NR

O3/Board

Board number or Octet 3 (IOA1)

VT_UI1

B_NR

O3/Board

Board number or Octet 3 (IOA1)

VT_UI1

W_NR

O4/Value number

Value number or Octet 4 (IOA2)

VT_UI1

W_NR

O4/Value number

Value number or Octet 4 (IOA2)

VT_UI1

DA

O5/Subaddress

Data type or Octet 5 (IOA3)

VT_UI1

DA

O5/Subaddress

Data type or Octet 5 (IOA3)

VT_UI1

PT

Point

Point number or Octet 6

VT_UI1

PT

Point

Point number or Octet 6

VT_BOOL

Send

Prozess direction

Process direction

Receive: Datapoint will be received only (e.g. messages, measuring values)

Send: Datapoint will be sent (e.g. commands, setpoints).

To be able to be sent, the datapoint has to have also the Set value active property active (see "Set value").

VT_BOOL

Send

Prozess direction

Process direction

Receive: Datapoint will be received only (e.g. messages, measuring values)

Send: Datapoint will be sent (e.g. commands, setpoints).

To be able to be sent, the datapoint has to have also the Set value active property active (see "Set value").

VT_BOOL

Z_TYP

Destination typ

Selection of LAN station or LAN group

VT_BOOL

Z_TYP

Destination typ

Selection of LAN station or LAN group

VT_UI1

Z_NR

Destination number

LAN station or LAN group number

Link address if serial connection

VT_UI1

Z_NR

Destination number

LAN station or LAN group number

Link address if serial connection

VT_BOOL

VTA

Typ of addressing

Address type

In accordance to parameterization of GW1703.ini and remote station.

STA: System technical

VTA: Process technical (PTA in GW1703.ini)

VT_BOOL

VTA

Typ of addressing

Address type

In accordance to parameterization of GW1703.ini and remote station.

STA: System technical

VTA: Process technical (PTA in GW1703.ini)

VT_BOOL

MERKER

Marker

Active: Datapoint will not be updated by process value (can be used as internal variable, doesn't need a datapoint address)

Inactive: Datapoint will be updated by process value

see also Driver Intern

VT_BOOL

MERKER

Marker

Active: Datapoint will not be updated by process value (can be used as internal variable, doesn't need a datapoint address)

Inactive: Datapoint will be updated by process value

see also Driver Intern

VT_BOOL

EWB

Toggle to substitute value

Switch to substitute value

Active: Substitute value will be used

Inactive: Substitute value will not be used

VT_BOOL

EWB

Toggle to substitute value

Switch to substitute value

Active: Substitute value will be used

Inactive: Substitute value will not be used

VT_BOOL

EW_INI

Inititialize substitute value/normal state

Initialization of substitute value

Active: Substitute value will be overwritten in runtime by normal state

Inactive: Substitute value will be kept

VT_BOOL

EW_INI

Inititialize substitute value/normal state

Initialization of substitute value

Active: Substitute value will be overwritten in runtime by normal state

Inactive: Substitute value will be kept

VT_R8

EW

Substitute value

Substitute value to be switched on

VT_R8

EW

Substitute value

Substitute value to be switched on

VT_BOOL

RED

Redundancy Peripheral address

Redundant address

Active: Use redundant address

Inactive: No redundant address

VT_BOOL

RED

Redundancy Peripheral address

Redundant address

Active: Use redundant address

Inactive: No redundant address

VT_UI1

R_2

Red. O1/Region number

Redundant datapoint address

Region number or Octet 1 (CASDU1)

VT_UI1

R_2

Red. O1/Region number

Redundant datapoint address

Region number or Octet 1 (CASDU1)

VT_UI1

K_2

Red. O2/Component

Redundant datapoint address

Region number or Octet 2 (CASDU2)

VT_UI1

K_2

Red. O2/Component

Redundant datapoint address

Region number or Octet 2 (CASDU2)

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


CAMISTSVarED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> CAMISTSVarED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


BACnetNG variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> BACnetNG variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_I4

BACnetPropertyID

BACnet property ID

Set the Property ID for user-specific properties or if you do not want to state the property in the name of identification.

Note: Only if you set -1, the property is determined via the name or identification.

More in the online help.

VT_UI4

BACnetDataType

BACnet data type

Define how a numeric variable or a string variable is mapped onto a BACnet property. Select the desired data type from the drop-down list. You can find the description of the possible data types in the online manual.

More in the online help.

VT_I1

BACnetWritePriority

BACnet write priority

Enter the writing priority with which the variable is written. If you enter 0, the variable is written without a writing priority.

Possible values are 0 - 16.

Lowest priority: 16

Highest priority: 1

Default: 0

More in the online help.

VT_UI4

BACnetStringLength

BACnet string length

Only available if you have selected the data type BITSTRING at property BACnet data type.

Define the length of the bit strings in bit.

More in the online help.

VT_I4

BACnetEventState

BACnet event state

Display state of the event state as number. In this case you can freely define the text for the event state.

Values:

-1: Text is used

0: Normal

1: Fault

2: Off-normal

3: High-limit

4: Low-limit

5: Life-safety-alarm

Default: -1

More in the online help.

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


BeckhoffNG variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> BeckhoffNG variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


Biffi variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> Biffi variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_I2

NV-Index

NV-Index

The NV index is only relevant for node data.

Enter the network variable index (NVI/NVO) of the variable here.

More in the online help.

VT_BOOL

Transient

Transient command

This setting is only relevant for node data.

Here you can specifiy whether an actual value received via a command event will automatically be reset to 0 by the driver (transient information, e.g. ICON2K Open, Close, Stop)

More in the online help.

VT_BOOL

Send_direct

Send directly

This setting is only relevant for node data.

Here you can specify whether a set value will be transfered to the DCM directly or via a buffer.

More in the online help.

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


BURPVI variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> BURPVI variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BSTR

BURPVI_ADDRESS

PVI Name

The name of the PLC variable. The name is created from Task name/variable name. For global variables: Only Variable name:

More in the online help.

VT_BSTR

BURPVI_VT_TYPE

PVI Type (VT)

Variable type in the PLC. The possible values are described in the online manual. By using a deviant data type in zenon a type casting can ensue.

More in the online help.

VT_UI4

BURPVI_VN_ELEMENTS

PVI Number of Elements (VN)

Number of elements at field variables.
For multi-dimensional field variables the number of the elements of all field dimensions is quoted (Example: var[10][5] => VN =50).

More in the online help.

VT_UI4

BURPVI_VL_LENGTH

PVI Length (VL)

Variable length in bytes.
For single variables the variable length equals the process data length. For field variables the variable length defines the element length.

More in the online help.

VT_BSTR

BURPVI_OD

PVI Additional (OD)

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


CTI variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> CTI variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_UI4

SecondaryObject

Secondary object

States the secondary object type for

- Time/Counter

- Drum

- Loop variable

- Alarm variable

More in the online help.

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


CDNP3_TGVarED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> CDNP3_TGVarED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_UI2

Command_Mode

Command Mode

Selection of the command mode from drop-down list:

  • Automatic SBO: A Select is carried out when writing. Once the Selects has been confirmed by the outstation, an Operate follows. The status of the variables is set to CoT_actterm. This applies for binary Outputs and analog Outputs. A BOOL binary Output can also be used for Close and Trip via command input, by setting the QoC to 2.
  • Direct Operate: Function Code 0x5 - Direct Operate is used for writing binary Outputs and analog Outputs.

More in the online help.

VT_BOOL

Classless_Read

Classless read

Assignment of the values to the variable with explicit read queries:

  • Inactive: Values that are received from an Integrity-Poll, Event-Poll oder unsolicited responses are assigned to the variable.
    Values that are received as a response to an explicit read request are not assigned
  • Active: The variables are only assigned values that are received as a response to an explicit read query.

More in the online driver help.

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


DNP3 variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> DNP3 variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_UI2

Variation

Variation

Selection of the variation from drop-down list.

  • Default: The variation that was sent from the outstation is used for variables.
    If a different variation from that of the outstation is used, or one for variables that do not belong to a class but should nevertheless be read, an alternative variation can be defined. Select from the drop-down list. The alternatives offered depend on the driver object type of the variables. Numerical values correspond to the permitted values of variation for this data type.

The driver will demand manual reading with the defined variation after each Class 0 poll or when triggered by a class poll variable. If a different variation than Default is selected, the Permanently read variable property is always activated.

Note: The outstation must support the reading of the variation.

More in the online help.

VT_UI2

Scangroup

Scangroup

More in the online help.

VT_UI2

Command_Mode

Command Mode

Selection of the command mode from drop-down list:

  • Automatic SBO: A Select is carried out when writing. Once the Selects has been confirmed by the outstation, an Operate follows. The status of the variables is set to CoT_actterm. This applies for binary Outputs and analog Outputs. A BOOL binary Output can also be used for Close and Trip via command input, by setting the QoC to 2.
  • Direct Operate: Function Code 0x5 - Direct Operate is used for writing binary Outputs and analog Outputs.

More in the online help.

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


EibV2 variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> EibV2 variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_UI2

MainGroup

Main group

Enter the number of the desired main group.

Minimum: 0

Maximum: 15

Default: 0

More in the online help.

VT_UI2

MiddleGroup

Middle group

Enter the number of the desired middle group.

Minimum: 0

Maximum: 7

Default: 0

More in the online help.

VT_UI2

SubGroup

Sub group

Enter the number of the desired subgroup.

Minimum: 0

Maximum: 255

Default: 0

More in the online help.

VT_BSTR

ETS2Database

ETS Database

Define the desired database here. Clicking on the button opens a dialog for selecting the database. Alternatively, you can manually enter the name of the database in the text field.

More in the online help.

VT_BOOL

CyclicReading

Read cyclical

Specifies how the value will be acquired from the PLC.

active: The value will be acquired from the PLC cyclically.

Default: inactive

Note: This option should be selected with care, as it increases the bus load enormously.

More in the online help.

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


Elrest variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> Elrest variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BSTR

Deviceparameter

Device parameter

The following properties are used for addressing the ELREST32 driver.

More in the online help

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


IEC61850 variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> IEC61850 variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BSTR

I61850_ADR

IEC61850-Address

IEC 61850-address

VT_UI2

I61850_LAN

IEC61850-Stationnumber

IEC61850 station number

VT_UI2

I61850_VAL

IEC61850-Value

IEC61850 value

This value defines which single message/single command will be processed for the CDCs INS, INC, SGCB and ACD.

VT_UI1

I61850_CDC

CDC

CDC

Specifies the CDC for the extension "Logical node"

Default: Default

VT_UI1

I_BIT

Invalid treatment

invalid handling

None: no handling

last valid value: Switch to alternate value image with the last valid value

Switch to alternate value: Switch to alternate value image; value of parameterized alternate value.

Switch to alternate PV: Switch to alternate value image; value of substitute PV.

Manual correction of alternate value: Switch to alternate value image; value must be updated manually

VT_BOOL

EWB

Inititialize substitute value

Initialize alternate value/normal state

Active: alternate value in the Runtime will be overwritten by process state.

Inactive: alternate value will be retained.

VT_BOOL

EW_INI

Inititialize substitute value

Initialize alternate value/normal state

Active: alternate value in the Runtime will be overwritten by process state.

Inactive: alternate value will be retained.

VT_BOOL

MERKER

Marker

Marker

Active: Variable without process reference (address will not be checked; for internal use)

Inactive: variable will be updated by the process

VT_BOOL

ST_SAVE

Save state

Save status

Active: The status of the variables will be stored on the hard disk

It will be loaded after restarting the Runtime.

Inactive: The status will not be stored.

Default: Inactive

VT_BOOL

VAL_SLAVE

Save value

Save value

Active: The value of the variables will be stored on the hard disk

It will be loaded after restarting the Runtime.

Inactive: The value will not be stored.

Default: Inactive

VT_R8

EW

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_UI1

GOOSE_INDEX

GOOSE Index

VT_UI1

GOOSE_ATTR1

GOOSE Attr1 dataset position

VT_UI1

GOOSE_ATTR2

GOOSE Attr2 dataset position

VT_UI1

GOOSE_ATTR3

GOOSE Attr3 dataset position

VT_UI1

GOOSE_ATTR4

GOOSE Attr4 dataset position

VT_UI1

GOOSE_ATTR5

GOOSE Attr5 dataset position

VT_UI1

GOOSE_ATTR1_POS

GOOSE Attr1 dataset position

VT_UI1

GOOSE_ATTR2_POS

GOOSE Attr2 dataset position

VT_UI1

GOOSE_ATTR3_POS

GOOSE Attr3 dataset position

VT_UI1

GOOSE_ATTR4_POS

GOOSE Attr4 dataset position

VT_UI1

GOOSE_ATTR5_POS

GOOSE Attr5 dataset position

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


IEC62056 variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> IEC62056 variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BSTR

IEC62056_ADDRESS

IEC62056 Address

Entry of the OBIS address.

VT_UI1

IEC62056_TIMEADJUST

IEC62056 Time Adjustment

Correction of the time stamp. Selection of the type of time adjustment from a drop-down list.

  • None: There is no correction.
  • Begin of interval: Correction has an effect on the start time stamp.
  • End of interval: Correction has an effect on the end time stamp.

Default: None

The interval that is applicable for changes is configured with the IEC62056 Time Interval property.

VT_UI2

IEC62056_TIMEINTERVAL

IEC62056 Time Interval

Entry of the time interval in minutes.

Only available if, for the IEC62056 Time Adjustment property, none has been selected.

Maximum: 65535

Default: 15

Example: With interval 15 and End of interval for IEC62056 Time Adjustment, the time stamp is always set to the end of a quarter of an hour.

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


IEC870_103 variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> IEC870_103 variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_UI4

IEC870_103_FktType

IEC870-103 FUNCTION TYPE

Enter a value. Matches FUN considering the standard.

More in the online help.

VT_UI4

IEC870_103_InfNo

IEC870-103 INFORMATION NUMBER

Enter a value. Matches INF considering the standard.

More in the online help.

VT_UI4

IEC870_103_Index

IEC870-103 Index

Enter a value. Matches the sequence of MEA in ASDU 3 or 9.

More in the online help.

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


IEC870 variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> IEC870 variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_UI1

IEC870_TYPE

IEC870 Type identification

Choose the ASDU type of the data point from the drop-down list.

default: T00 internal state

More in the online help.

VT_UI2

IEC870_COA1

IEC870 COA

Enter the Common Object Address (COA). The limits of the available value range are determined by the driver settings.

More in the online help.

VT_UI4

IEC870_IOA1

IEC870 IOA

Enter the Information Object Address (IOA). The limits of the available value range are determined by the driver settings.

More in the online help.

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


iLon100 variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> iLon100 variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


Internal variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> Internal variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

Local

Calculation

Local: For the network projects the internal variable is assessed and administrated locally i.e. on the client.
This means the value of the variable can be different on each client and the limits are assessed locally.
Network: With network projects, the internal variables are evaluated and administered on the project server. It has the same value on the server and all clients.
Default: local.

More in the online help.

VT_UI1

Remanenz

Remanence

Off: When starting Runtime, the alternate value of the variable or an empty string for string variables is used as the current value.
Initial value: The current value is the value entered in the property “Initial value”.
Remanent: The last value of the variable is used as the current value when restarting the Runtime.
Default: off.

More in the online help.

VT_BSTR

Initial_value

Initial value

The value defined here is used as the current value of the variable when Runtime is started if the "Remanance" property is to "initial value".

More in the online help.

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


Internal variable RT

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> Internal variable RT

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

Local

Calculation

Local: For the network projects the internal variable is assessed and administrated locally i.e. on the client.
This means the value of the variable can be different on each client and the limits are assessed locally.
Network: With network projects, the internal variables are evaluated and administered on the project server. It has the same value on the server and all clients.
Default: local.

More in the online help.

VT_UI1

Remanenz

Remanence

Off: When starting Runtime, the alternate value of the variable or an empty string for string variables is used as the current value.
Initial value: The current value is the value entered in the property “Initial value”.
Remanent: The last value of the variable is used as the current value when restarting the Runtime.
Default: off.

More in the online help.

VT_BSTR

Initial_value

Initial value

The value defined here is used as the current value of the variable when Runtime is started if the "Remanance" property is to "initial value".

More in the online help.

VT_VARIANT

Value

Value

VT_VARIANT

UserValue

UserValue

VT_UI8

StatusValue

StatusValue

This property returns the status of a variable as a value.

VT_BSTR

StatusString

StatusString

This property returns the status of a variable.

ZT_DATETIME

LastUpdateTime

LastUpdateTimeMilliSeconds

This property returns the update time in milliseconds.

VT_UI2

LastUpdateTimeMilliSeconds

LastUpdateTimeMilliSeconds

This property returns the update time in milliseconds.

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


Lon32 - Variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> Lon32 - Variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


CMathInfo

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> CMathInfo

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
More... | SourceVars | SourceVars |
VT_UI2 | Type | Type |
VT_BSTR | Formula | Formula | Opens the dialog to enter the formula for calculation of the variables. More in the online help.
ZT_MEMFILE | MathInfo | MathInfo |
ZT_VARIABLE | EnableCalc | Calculaton active | Assigns a variable to the mathematics variable. The value of the variable controls whether the calculation is carried out. The property is activated when a variable is assigned. A click on button ... or in the field with the variable opens the dialog for selecting a variable. Default: deactivated, no variable assigned. More in the online help.


MathDr32 - Variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> MathDr32 - Variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

MathInfo

MathInfo

Contains information if e.g. var is used to determine a sum (as in data reduction)

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


Mathematical variable RT

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> Mathematical variable RT

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

MathInfo

MathInfo

Contains information if e.g. var is used to determine a sum (as in data reduction)

VT_VARIANT

Value

Value

VT_VARIANT

UserValue

UserValue

VT_UI8

StatusValue

StatusValue

This property returns the status of a variable as a value.

VT_BSTR

StatusString

StatusString

This property returns the status of a variable.

ZT_DATETIME

LastUpdateTime

LastUpdateTimeMilliSeconds

This property returns the update time in milliseconds.

VT_UI2

LastUpdateTimeMilliSeconds

LastUpdateTimeMilliSeconds

This property returns the update time in milliseconds.

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


NWMDRV32 - Variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> NWMDRV32 - Variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


OPCUA variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> OPCUA variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BSTR

BrowseName

Browse name

Equals the Browse name of the OPC UA specification.

Only hierarchic references (forward) starting from the object folder are allowed.

More in the online help.

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


Sample32 variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> Sample32 variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BSTR

SampleTest

Sample Additional

Examples for sample driver.

VT_BSTR

SampleButton

Auswahl

Examples for sample driver.

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


SE_32 variable ED function

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> SE_32 variable ED function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


SE_32 variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> SE_32 variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


SPRECON870 variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> SPRECON870 variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_UI1

IEC870_TYPE

IEC870 Type identification

Choose the ASDU type of the data point from the drop-down list.

default: T00 internal state

More in the online help.

VT_UI2

IEC870_COA1

IEC870 COA

Enter the Common Object Address (COA). The limits of the available value range are determined by the driver settings.

More in the online help.

VT_UI4

IEC870_IOA1

IEC870 IOA

Enter the Information Object Address (IOA). The limits of the available value range are determined by the driver settings.

More in the online help.

VT_BOOL

SPRECON870_CounterActive

Counter value handling

Only available if a group has been created in the driver configuration.

Activated: The counter processing is used by the driver.

More in the online help.

VT_UI4

SPRECON870_CounterGroupID

Counter group

Only available if property Counter value handling is active.

Name for identifying counter group as defined in the driver.

Via the allocation of the variable to a counter group, the behavior of the variable is defined. The counter group represents a kind of reaction matrix which controls the counter processing (e.g. changing absolute value to relative value).

Default: < No group >

More in the online help.

VT_UI2

SPRECON870_MaxCounterDifference

Maximum counter difference

Only available if property Counter value handling is active.

Defines the maximal difference between two transferred counting values. The maximum change refers to the normalized counter value (value calculation). If the maximum counting value difference is exceeded, the setting of property Max. counter diff. exceeded is executed.

Minimum: 0 - deactivated; maximum change is not monitored.

Maximum: 65535

Default: 0

More in the online help.

VT_UI1

SPRECON870_OnMaxCounterDifference

Max. counter diff. exceeded

Only available if property Counter value handling is active.

Treatment of counter values (relative/absolute) for which the monitoring from Maximum counter difference reacts.

Selection from drop-down list:

- Disabled

- Set INVALID state: Status is set and thus - if configured - property Replacement value handling is activated. This treatment is also true for the counter overflow of absolute values. If the error state is reached, the status INVALID is set and the current counting value is discarded. The last received counter value is highlighted as invalid. Calculations which need a previous counting value can only be carried out again after two counter values have been received. The status INVALID is reset as soon as a new counting value with difference smaller than the settings for property Replacement value handling is received.

Default: Disabled

More in the online help.

VT_UI1

SPRECON870_OnNoUpdate

Not updated in time

Only available if property Counter value handling is active.

Defines the behavior for counting values which are not updated within the time window or the alternate value handling is activated. Select from drop-down list:
- Disabled: Settings from property Replacement value handling are used.

- Set INVALID state: Status INVALID is set.

Default: Disabled

More in the online help.

VT_UI1

SPRECON870_ReplacementType

Replacement value handling

Selection for alternate value handling if variable has status INALVID or NT_870. Selection from drop-down list:

- Disabled: No alternate value handling.

- Last valid value: Switch to last value which was not interrupted. For this a process image must be saved from this value. If there is nor such value, the value available is used (e.g. 0 + INVALID).

- Use replacement value: Value of property Replacement value is written to the variable.

- Use replacement variable: The value and the status from property Replacement variable are written to the variable.
Exception: If the alternate value variable itself has status INVALID or status NT_870, it is not switched to this variable but the own variable is kept with its value and status.
Special case status GI: As during a General Interrogation the alternate value must not yet be available, a variable can go to INVALID for a short time until the alternate value is received.

All settings except for Disabled set the status bit ALT_VAL. As soon as the reason for the alternate value handling (INVALID or NT_870) disappears, the variable takes over the process value again and the status bit ALT_VAL is set back.

Default: Disabled

More in the online help.

VT_UI4

SPRECON870_ReplacementValue

Replacement value

Value which should be written on the variable if you selected Use replacement value for property Replacement value handling.

Minimum: 4294967295

Maximum: 0

Default: 0

More in the online help.

ZT_VARIABLE

SPRECON870_ReplacementVariable

Replacement variable

Variable whose value and state are taken over if you selected Use replacement value for property Replacement value handling. Each value change of the alternate value variable is depicted on the interrupted variable. A click on the ... button opens the variable selection dialog.

Attention: As a variable you may only chose a variable of the same driver. If you select a variable of another driver in the dialog, the dialog is closed but the setting is not applied.

Default: empty

More in the online help.

VT_BOOL

SPRECON870_ReverseDirectionEnable

Reverse direction enable

Activation of Reverse-direction.

Active: Variable is sent in Reverse-direction after a corresponding general query.

VT_BOOL

SPRECON870_ReverseDirectionOnly

Reverse direction only

Only available if the Reverse direction enable property has been activated.
Active This variable is never assigned a value received from the PLC. After starting Runtime, the variable of the configured initial value or a value from the remanent image is assigned. After this, the variable can only be changed by writing a set value.

VT_BOOL

SPRECON870_ReverseDirectionRemanent

Remanent

Only available if property Reverse direction enable is active. Last value, time stamp and status of the variable are saved in the remanent image. After restarting, the value, time stamp and status are read from the remanent image and assigned to the variable.

VT_R8

SPRECON870_ReverseDirectionInitialValue

Initial value

The initial value is only used if the Reverse direction only property has been activated or the network address of the variable refers to a connection that has been highlighted as an Internal connection. For String data variables, no initial value can be established.
If Runtime is started and no value from the remanant image has been assigned to the variable, the initial value and the status NT is written to this variable.

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


Sys2000 variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> Sys2000 variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_UI4

Node

Node

Enter the node address of the PLC.

More in the online help.

VT_UI4

LogID

Log ID

Enter the address of the log (log ID) in the PLC.

More in the online help.

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


Syskron variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> Syskron variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_I4

Syskron_LDS_FKT_RD

Syskron_LDS Function Read

Define the access function for reading here. Clicking on the button opens a dialog for selecting the access function. Alternatively, you can manually enter the name of the access function in the text field.

More in the online help.

VT_I4

Syskron_LDS_FKT_WR

Syskron_LDS Function Write

Define the access function for writing here. Clicking on the button opens a dialog for selecting the access function. Alternatively, you can manually enter the name of the access function in the text field.

More in the online help.

VT_BSTR

Syskron_LDS_PARAM_RD

Syskron_LDS Parameters Read

Define all parameters of the function here. Click on the button to open the dialog for entering all parameters that will be passed to the function for reading during Runtime.

More in the online help.

VT_BSTR

Syskron_LDS_PARAM_WR

Syskron_LDS Parameters Write

Define all parameters of the function here. Click on the button to open the dialog for entering all parameters that will be passed to the function for writing during Runtime. The last parameter is always the set value sent by zenon.

More in the online help.

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


SysDrv variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> SysDrv variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.


Base class variable

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> Base class variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.

ZT_AKZ

SystemModelGroup

Equipment groups

Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group.

More in the online help.


Variable ED

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> Variable ED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_BOOL

IsLocalDigits

IsLocalDigits

"With this property you have the opportunity to decide whether the ""Decimals"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMin

IsLocalSignalMin

"With this property you have the opportunity to decide whether the ""Minimum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSignalMax

IsLocalSignalMax

"With this property you have the opportunity to decide whether the ""Maximum signal resolution"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMin

IsLocalRangeMin

"With this property you have the opportunity to decide whether the ""Minimum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRangeMax

IsLocalRangeMax

"With this property you have the opportunity to decide whether the ""Maximum measuring range"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlternateValue

IsLocalAlternateValue

"With this property you have the opportunity to decide whether the ""Alternate value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMin

IsLocalValueMin

"With this property you have the opportunity to decide whether the ""Minimum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalValueMax

IsLocalValueMax

"With this property you have the opportunity to decide whether the ""Maximum set value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUseMacro

IsLocalUseMacro

"With this property you have the opportunity to decide whether the ""Non linear value adjustment with macros"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalInOut

IsLocalInOut

"With this property you have the opportunity to decide whether the ""Setting values active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystNeg

IsLocalHystNeg

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHystPos

IsLocalHystPos

"With this property you have the opportunity to decide whether the ""negative hysteresis"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArchHystNeg

IsLocalArchHystNeg

VT_BOOL

IsLocalArchHystPos

IsLocalArchHystPos

VT_BOOL

IsLocalUpdatePriority

IsLocalUpdatePriority

"With this property you have the opportunity to decide whether the ""Priority of the driver connection"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalDDEaktiv

IsLocalDDEaktiv

"With this property you have the opportunity to decide whether the ""DDE active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStandby

IsLocalStandby

"With this property you have the opportunity to decide whether the ""Only read from standby"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRemaActiv

IsLocalRemaActiv

"With this property you have the opportunity to decide whether the ""Reaction matrix active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRema

IsLocalRema

"With this property you have the opportunity to decide whether the ""Reaction matrix"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDActive

IsLocalHDActive

"With this property you have the opportunity to decide whether the ""HD active"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDUpdate

IsLocalHDUpdate

"With this property you have the opportunity to decide whether the ""HD scan rate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalHDSize

IsLocalHDSize

"With this property you have the opportunity to decide whether the ""Number of HD values"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalKDAActiv

IsLocalKDAActiv

"With this property you have the opportunity to decide whether the ""Recording type"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalStingLength

IsLocalStingLength

"With this property you have the opportunity to decide whether the ""String length"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalQuitPV

IsLocalQuitPV

"With this property you have the opportunity to decide whether the ""Acknowledgement variable"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalViewQuitPV

IsLocalViewQuitPV

Description as text.

VT_BOOL

IsLocalQuitValue

IsLocalQuitValue

"With this property you have the opportunity to decide whether the ""Acknowledgement value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalTagname

IsLocalTagname

"With this property you have the opportunity to decide whether the ""Identification"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalUnit

IsLocalUnit

"With this property you have the opportunity to decide whether the ""Unit"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAltValString

IsLocalAltValString

"With this property you have the opportunity to decide whether the ""String alternative value"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalRecLabel

IsLocalRecLabel

"With this property you have the opportunity to decide whether the ""Ressources label"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustHW

IsLocalAdjustHW

"With this property you have the opportunity to decide whether the ""AdjustHardwareValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAdjustZenon

IsLocalAdjustZenon

"With this property you have the opportunity to decide whether the ""AdjustZenOnValue"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalArraySize

IsLocalArraySize

"With this property you have the opportunity to decide whether the ""Array size"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCounterGroup

IsLocalCounterGroup

VT_BOOL

IsLocalMaxGradient

IsLocalMaxGradient

VT_BOOL

IsLocalNormalStateActive

IsLocalNormalStateActive

VT_BOOL

IsLocalNormalState

IsLocalNormalState

VT_BOOL

IsLocalAlarmPV0

IsLocalAlarmPV0

"With this property you have the opportunity to decide whether the ""Alarm Variable 1"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV1

IsLocalAlarmPV1

"With this property you have the opportunity to decide whether the ""Alarm Variable 2"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmPV2

IsLocalAlarmPV2

"With this property you have the opportunity to decide whether the ""Alarm Variable 3"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalVarInASM

IsLocalVarInASM

"With this property you have the opportunity to decide whether the ""Save in IPA database"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain

IsLocalAlarmDomain

"With this property you have the opportunity to decide whether the ""Alarm area"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalAlarmDomain2

IsLocalAlarmDomain2

Description as text.

VT_BOOL

IsLocalAlarmDomain3

IsLocalAlarmDomain3

Description as text.

VT_BOOL

IsLocalAlarmDomain4

IsLocalAlarmDomain4

Description as text.

VT_BOOL

IsLocalLocking

IsLocalLocking

"With this property you have the opportunity to decide whether the ""Interlocking"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalSBO

IsLocalSBO

"With this property you have the opportunity to decide whether the ""Select before operate"" should be linked to the datatype or not.
FALSE = It should be linked, TRUE = It shouldn't be linked."

VT_BOOL

IsLocalCancelOperate

IsLocalCancelOperate

Description

VT_UI1

IsSWProtokol

IsSWProtokol

VT_BOOL

IsSW_Akt

IsSW_Akt

VT_BOOL

IsSW_VBA

IsSW_VBA

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.

ZT_AKZ

SystemModelGroup

Equipment groups

Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group.

More in the online help.


Variable RT

Manual -> Programming interfaces -> Objectmodel -> Variable -> Variable-Dynamic properties -> Variable RT

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_VARIANT

Value

Value

VT_VARIANT

UserValue

UserValue

VT_UI8

StatusValue

StatusValue

This property returns the status of a variable as a value.

VT_BSTR

StatusString

StatusString

This property returns the status of a variable.

ZT_DATETIME

LastUpdateTime

LastUpdateTimeMilliSeconds

This property returns the update time in milliseconds.

VT_UI2

LastUpdateTimeMilliSeconds

LastUpdateTimeMilliSeconds

This property returns the update time in milliseconds.

More...

Limits

Limits

Properties about the limit handling or alarm handling of the variable.

Properties of this group are only available if you activated property Reaction matrix active.

More in the online help.

VT_UI4

ID_ComplexVariable

ID_ComplexVariable

With this property you have the opportunity to get/set the ID of a variable from a structure element. This ID is 0 when the variable has no structure datatype.

VT_BSTR

Name

Name

Distinct name of the variable. The following is applicable for naming:

  • Maximum length: 128 characters
  • the characters # and @ are not permitted in variable names.

Note: For drivers which are based on zenon Logic connection you most take care for a prefix. For details see chapter Creating O and M variables in zenon Logic in the manual.
Changes of the variable name must also be made in the programming environment (VBA, VSTA, PCE).

Attention: This property is not available for language switch.

More in the online help

VT_BSTR

Tagname

Identification

Freely-definable string for the identification of the variable or the data type.
Can be used with online language switching instead of the variable name, because the language of this cannot be switched later.

Maximum length: 128 characters

More in the online help.

VT_BSTR

Unit

Measuring unit

Technical unit of the variable for display in the Runtime. If you have already created measuring units in the base units module, they are available in a drop-down list.
Maximum: 50 characters
Default: empty

More in the online help.

VT_R8

AlternateValue

Archivfüllwert

This value is used in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

More in the online help.

VT_BSTR

AlternateValueString

String archive filler value

This value is used for string variables in order to fill up cyclic archives. If there are intervals in which there were no connections to the hardware, this value is used as long as no value is transferred from the hardware. Otherwise the value which was valid lastly is used for filling up.

Maximum length: 128 character
ATTENTION: This property is not available for language switch.

More in the online help.

VT_BSTR

Recourceslabel

Resources label

Any desired string.
Is not used internally in zenon but is available when exporting values in order to allow assignment of the exported values for management systems (such as ERP).

Maximum length: 255 characters

More in the online help.

VT_UI4

NetAddr

Net address

Bus address or net address of the variables.
Minimum: 0
Maximum: 4294967295
Default: 0

More in the online help.

VT_UI4

DataBlock

Data block

Number of the data block.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI4

Offset

Offset

Offset of the variable.
For linearly-addressed control units: the memory range.
For name-resolved control units: the assignment address.
Minimum: 0.
Maximum: 4294967295.
Default: 0.

More in the online help.

VT_UI2

BitAddr

Bit number

Number of the bit within the configured offset.
Minimum: 0.
Maximum: 65535.
Default: 0.

More in the online help.

VT_UI2

Alignment

Alignment

Depending on the granularity of the driver, the position of the variable within the defined offset.

For byte variables:
HiByte: High byte in the word offset.
LoByte: Low byte in the word offset.
HiWord-HiByte High byte in the high word in the double-word offset.
HiWord-LoByte: Low byte in the high word in the double-word offset.
LoWord-HiByte: High byte in the low word in the double-word offset.
LoWord-LoByte: Low byte in the low word in the double-word offset.

For word variables:
HiWord: High word in the double-word offset.
LoWord: Low word in the double-word offset.

More in the online help.

VT_UI2

StringLength

String length

Only available for String variables.
Maximum number of characters that the variable can take.
Minimum: 0 character
Maximum: 65535 characters.
Default: 5 characters

More in the online help.

VT_BSTR

SymbAddr

Symbolic address

Character sequence for symbolic address of the variable.

Maximum length: 128 characters.

More in the online help.

VT_UI4

Driver

Driver

VT_UI4

ID_DataTyp

Data type

Data type of the variable. It is selected during the creation of the variable and can be changed here later.
Note: For structure variables, the data type can no longer be changed after the creation of the variables.
Warning: If you change the data type later, all other properties of the variable must be checked and adjusted, if necessary.

More in the online help

VT_UI4

ID_DriverTyp

Driver object type

Depending on the driver used, an object type is selected when the variable is created and can be changed here later.
Siemens: Data block, marker, input/output.
Modbus: Coil and holding register.

More in the online help.

VT_UI1

UpdatePriority

Priority

If the global update time in the driver configuration is not used, update rates for the different priority levels can be set there. Here a priority level is linked to the variable.

More in the online help.

VT_BOOL

Standby

Only read from Standby Server

Active: The value of the variable from the standby server is displayed.
Inactive: The value of the variable from the server is displayed.
(hardware drivers only)

More in the online help.

VT_UI2

Digits

Decimals

Number of decimal places of the variable values for the display in the control system.
Minimum: 0
Maximum: 10
Default: 0

More in the online help.

VT_R8

SignalMin

Signal area min.

Minimum value of the variable in the PLC.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for the use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

SignalMax

Signal area max.

Maximum value of the variable in the PLC.Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMin

Measuring range min.

Minimum value of the variables zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_R8

RangeMax

Measuring range max.

Maximum value of the variables in zenon.
Unless defined differently in Value adjustment non-linear, the raw value of the variables (signal resolution) will always be converted to the measuring range on a linear basis (for use in the control system). All further numerical value inputs for the variable in the Editor and the Runtime will relate to the measuring range (e.g. definition of limits, set value limits, representation area, setpoint inputs, ...).

More in the online help.

VT_BOOL

UseMacro

Non linear value adjustment with macros

The non-linear value adjustment is used for variables whose original value (PLC) cannot be scaled to the measured value (control system) in a linear way.
Active: Raw values are scaled to control system values in a linear manner (with VBA macros).
Once the "non-linear value adjustment" option has been activated, the VBA macros for the conversion are to be entered in "AdjustHardwareValue" and "AdjustZenOnValue".
Inactive: Raw values are scaled to the control system values on a linear basis.
Default: inactive

More in the online help.

ZT_VBAMAKRO

AdjustHardware

AdjustHardwareValue

Only available if the non-linear value adjustment is active:
The macro is called up each time the raw value (PLC) changes in order to update the value in zenon.

More in the online help.

ZT_VBAMAKRO

AdjustZenon

AdjustScadaValue

Only available if the non-linear value adjustment is active:
The macro is called up if a control system value is set in order to update the raw value (PLC).

More in the online help.

VT_R8

HystNeg

Negative for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at declining value change. Values are only interpreted as limit violations if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

HystPos

Positive for signal

Hysteresis for limits based on the signal area.

Hysteresis area for entry at increasing value change. Values are only interpreted as limit violations if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystNeg

Negative for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at declining value change. Values are only entered in the archive if the change is below the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_R8

ArchHystPos

Positive for archive

Hysteresis for archiving on change applied to the measuring range.

Hysteresis area for entry at increasing value change. Values are only entered in the archive if the change is above the hysteresis area defined here.
Default: 0 (no hysteresis)

More in the online help.

VT_BOOL

DDEActive

Permanently read variable
  • Active: The variable is always logged on with the driver. This means it is continually read by the driver, even if it is not needed in the project at that particular time. The driver thus always has current values and the current status of the variables and can provide these immediately if necessary. The variable is also available for other Windows applications (such as Excel, Visual Basic etc.). Windows applications with DDE client functionality can thus use the variable values. Update time: 0,5 s
    Activation of this option has the advantages that, for example, variable values in the Write set value function or in the Switch screen element are toggled more quickly, because the variable does not need to be queried specially before switching. A disadvantage is the higher load placed on communication with the control unit.
  • Inactive: The variable is not permanently queried by the driver, but only if values or the status is requested by Runtime. It is therefore not available to other Windows applications via DDE.

Default: inactive

More in the online help.

VT_UI4

ArraySizeOld

Block array size

Definition of the block array size. The set size is read or written by the driver with a read/write request. This ensures that the data in the text is consistent. The data can only be edited in the Recipe Group Manager or via the programming interface.
Attention: Can be set in the Internal driver but with no function in the Runtime (value always 0).

More in the online help

VT_UI4

CounterGroup

Counter group

Only available in SICAM 230.

VT_UI4

MaxGradient

Maximum gradient

Only available in SICAM 230.

VT_BOOL

NormalStateActive

Active

Allows the definition of a normal status for variables and data types of the type BOOL, UINT and WORD for all drivers.

Active: A normal status can be defined.

Default: inactive

More in the online help.

VT_BOOL

NormalState

Normal value

In the drop-down list, select whether the normal value for this variable or data type should be On or Off. Available for variables and data types of the type BOOL, UINT and WORD for all drivers.

Default: Off

More in the online help.

ZT_VARIABLE

AlarmPV0

Alarm variable 1

Only available in SICAM 230.
First variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV1

Alarm variable 2

Only available in SICAM 230.
Second variable for screen alarming

More in the online help.

ZT_VARIABLE

AlarmPV2

Alarm variable 3

Only available in SICAM 230.
Third variable for screen alarming

More in the online help.

VT_BOOL

HDActive

Harddisk data storage active

Active: Variable values are saved on the hard disk (ring storage) for the evaluation in the dynamic element 'Trend element' or the export/import of the values.

Inactive: No variable values are saved.

(Default) Inactive:

HD data need 24 bytes of storage place per value, independent of the variable type. In addition to the value, the following information is also saved:
- Time at which measurement was taken.
- milliseconds when reading the value.
- Amend status of the value to elements accordingly.
- Counter for unique identification of the value (spontaneous driver).

Note: The data storage is also activated at the screen switch to a screen of type Extended Trend if online data are analyzed.
Variables of type string are not supported by the hard disk data storage.

More in the online help.

VT_R4

HDUpdate

Cycle time [s]

Only available if the Harddisk data storage active property is active:
Interval time [in seconds] for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of the values.

More in the online help.

VT_UI4

HDSize

Number of values

Value number for storing online values on the hard disk (ring buffer) for the analysis in the dynamic element trend, for online data in the Extended Trend or the export/import of values.

More in the online help.

VT_BOOL

IsKDAActiv

Recording type

Only available if property Harddisk data storage active is active:
Hard disk data (zyklisch): Cyclical writing of values to the hard disk.
Postsorted values (RDA): The values are written on to the hard disk block-by-block by the driver. (Suitable for post mortem analysis for errors on the control.)

More in the online help.

VT_BOOL

ExternVisible

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BSTR

ExternVisibleFor

Externally visible for

Only available if property Externally visible is active.

Decide explicitly for which zenon Logic projects the variable should be visible. If you leave the input field empty, the variable is visible for all zenon Logic projects. You can also enter individual zenon Logic projects explicitly. Separate the names of the individual projects with a semicolon (";"). You can also use wildcards. For example P1* stands for all zenon Logic projects which start with P1. (Notice: Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.

The number of characters is limited to 64 characters.

Default: -

More in the online help.

VT_BOOL

ReadWrite

Set external SW active

External property for zenon Logic. Only affects variables that are not of the straton driver.
Active: The value of the variable can be changed in zenon Logic. The variable definition cannot be changed in zenon Logic.
Inactive: The variable cannot be changed in zenon Logic.
Default: active.

More in the online help.

VT_BSTR

InitialValue

External init value

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Initial value of the variable in zenon Logic during a cold start or warm start.
The permitted input here depends on the data type of the variable. For example, you can only use values without decimal places for whole-number variables. For floating point variables, a point must be used as a decimal separator; a comma does not work.
The control system does not check the validity of the input here. This can lead to an error message in zenon Logic.

ATTENTION: When using variables of the internal driver, this property must have the same value as the initial value in the settings for internal variables.

More in the online help.

VT_BSTR

Profilename

External profile name

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Name of the profile set in zenon Logic (STRATON, ProfDP, for example).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Adressparam

External address parameter

External property for zenon Logic. Only affects variables that are not variables of the straton driver.
Profile properties in zenon Logic (like "embedded" or address parameters for Profibus).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BSTR

Vargroup

External variable group

External property for zenon Logic. Only affects variables that are not straton 32 driver variables.
Variable groups in zenon Logic ("Global", "Retain" or empty).

Property is only displayed for information. Editing with zenon Logic only.

More in the online help.

VT_BOOL

IsRemaActiv

Reaction matrix active

Active: A reaction matrix is used instead of the limit values.
Inactive: Limit values can be defined for the variable.
Default: inactive.

More in the online help.

VT_UI4

Rema

Reaction matrix

Properties for the use of a reaction matrix for the variable.

More in the online help.

ZT_VARIABLE

AlarmQuitPV

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

ZT_VARIABLE

AlarmViewQuitPV

Visual acknowledgment variable

If an alarm of the controlling variable is visually acknowledged, the value of this visual acknowledgment variable is set to the value defined under Acknowledgement value.

Click on the ... button to open the dialog to select a binary variable.

More in the online help.

VT_UI4

AlarmQuitPVValue

Acknowledgement value

If an alarm of this variable is visually acknowledged or acknowledged, the variable selected under Visual acknowledgment variable or Acknowledgement variable is set to this value.

Selection 0 or 1.

More in the online help

VT_BOOL

VarInASM

Save in IPA database

Active: The alarms of this variable are available for analysis in the Industrial Performance Analyzer (IPA).
Inactive: The alarms of this variable are not considered for analysis in the Industrial Performance Analyzer (IPA).
Default: inactive

Attention: The Industrial Performance Analyzer is an optional module and must be licensed in order to be used here.

More in the online help.

ZT_BSTR_REF

AreaName

AreaName

Description as text.

ZT_BSTR_REF

AreaName2

AreaName2

Description as text.

ZT_BSTR_REF

AreaName3

AreaName3

Description as text.

ZT_BSTR_REF

AreaName4

AreaName4

Description as text.

VT_BOOL

InOut

Setting values active

Active: Release this variable for action "Write set value".
Inactive: This variable is write-protected.
Default: Active

More in the online help.

VT_BOOL

SBO

Select Before Operate

Attention: This functionality is only supported by the drivers IEC870 and IEC850, and only if switching command was selected for the action type property in Command. Do not use this function for the DNP3_NG driver; Auto-SBO can be configured for the variable directly in this case.

Active: Before the value of the variable is written to the hardware, zenon checks whether the variable in the hardware is ready for this action =Select before Operate (SBO).
Attention: For pulse commands, the automatic resetting of the variable values is not carried out according to the time span defined in the edge delay property.

Inactive: The value of the variable is written to the hardware without a previous check =Direct execute.
Default: inactive
More in the online help.

VT_BOOL

CancelOperate

Cancel Operate

If activated, it is also possible to send a Cancel after an Operate .

Note: The property is only available in the Energy Edition.

Default: inactive

More in the online help.

VT_R8

ValueMin

Min. set value

The minimum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_R8

ValueMax

Max. set value

The maximum for "Write set value" that has been set here can be accepted by dynamic elements instead of them being set here separately.
This is recommended most of all if the measurement range of the variable might subsequently change, because these changes can be made here once and not amended separately in each element.

More in the online help.

VT_BSTR

LockingName

LockingName

"With this property you have the opportunity to assign an interlocking via its name.
zElement.DynProperties(""LockingName"") = ""Interlocking 1"""

VT_UI1

SetValueProtocol

Logging

Defines how write set value should be logged in the CEL.

  • All: All "write set value" actions of this variable via dynamic elements and "write set value" functions are logged in the Chronological Event List (CEL).
  • Nothing: No "write set value" actions are logged in the CEL.
  • Only via dynamic element: Only actions via dynamic elements are logged in the CEL.

Default: Only via dynamic element

More in the online help.

VT_BOOL

SV_Act

Old and new value
  • Active: When changing the set value of this variable the old and the new value are logged in the Chronological Event List (CEL).
  • Inactive: Only the new value is logged.

Default: inactive

Recommendation: Activate the Permanently read variable property. This ensures that the value is always available and does not need to be specially queried.

More in the online help.

VT_BOOL

SV_VBA

Setting values with VBA

Active: Write set value of this variable via a VBA macro is logged in the Chronological Event List (CEL).
inactive: Write set value of this variable via VBA macro is not logged.
Default: Active

Note: For variables that are configured in the IEC870 Process Gateway as command variables, each command is logged as Write set value via the COM interface in the CEL if the property is activated.

More in the online help.

VT_BSTR

VisualName

Visual name

Entry of a display name for the variable in zenon Analyzer. This must be unique in the project, but this is not checked in zenon. This check is made when importing into zenon Analyzer.

This property provides information that is used for the report configuration in zenon Analyzer. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Attention: If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.

More in the online help.

VT_BSTR

Meaning

Meaning

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Entry of the meaning of a variable in the zenon Analyzer. Several meanings are separated by a comma.
Syntax: [Meaning1],[Meaning2],…,[MeaningN]

More in the online help.

VT_BSTR

WaterfallParam

Parameter for waterfall diagram

This property provides information that is used for the report configuration in zenon Analyzer.
Data can be set manually or by means of the Meaning and Waterfall Chart Wizard. The export from zenon into zenon Analyzer is carried out with the Analyzer Export Wizard.

Parameters of a variable for a waterfall diagram in zenon Analyzer. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
Syntax: [model name],[row index],[index in row],[color code];

More in the online help.

ZT_AKZ

SystemModelGroup

Equipment groups

Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group.

More in the online help.


Variables

Manual -> Programming interfaces -> Objectmodel -> Variables

Remarks

The collection Variables contains all defined variables of the current project. With this collection you can access, create and delete variables.Beside the access via the index a variable also can be found with its unique name or the unique channel Id.

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub CreateVars()
Dim zPRJ As Project
Dim zDRV As Driver
Dim zVTp As VarType
Dim i
'part of the Variablename...
Const VarNamePart As String = "TEST_"

Set zPRJ = MyWorkspace.ActiveDocument
'set first created driver....
Set zDRV = zPRJ.Drivers.Item(0)
'check if driver is the "INTERNAL" driver
If InStr(1, zDRV.Name, "Intern", vbTextCompare) = 0 Then Exit Sub
'set vartype (UINT)
Set zVTp = zPRJ.VarTypes.Item("UINT")
For i = 0 To 9
zPRJ.Variables.CreateVar VarNamePart & i, zDRV, tpSystemVariable, zVTp
Next i
End Sub

Sub DeleteVars()
Dim zPRJ As Project
Dim i
'part of the Variablename...
Const VarNamePart As String = "TEST"

Set zPRJ = MyWorkspace.ActiveDocument
'run trough all variables of the active project
For i = zPRJ.Variables.Count - 1 To 0 Step -1 'reverse loop!
'search part of the varname
If InStr(1, zPRJ.Variables.Item(i).Name, VarNamePart) <> 0 Then
'delete variable
If zPRJ.Variables.DeleteVar(zPRJ.Variables.Item(i).Name) = False Then
Debug.Print "ERROR deleting: " & zPRJ.Variables.Item(i).Name
End If
End If
Next i
End Sub

Other topics in this chapter

Variables-Properties

Variables-Methods


Variables-Properties

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | read only | read only
IProject | Parent |  | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Variables-Methods

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CheckInModule | Imports the selected XML file | available | not used
VARIANT_BOOL | CheckOutModule | Imports the selected XML file | available | not used
IVariable | CreateArrayVar | - | available | not used
IVariable | CreateArrayVarEx | - | available | not used
IVariable | CreateVar | - | available | not used
VARIANT_BOOL | DeleteVar | - | available | not used
void | DoAutoSave | - | available | not used
VARIANT_BOOL | Export | - | available | not used
VARIANT_BOOL | Import | - | available | not used
VARIANT_BOOL | ImportDirect | Imports the selected XML file | available | not used
IVariable | Item | - | available | available
IVariable | ItemPvID | - | available | available
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used
IVariable | CreateVar | - | available | not used
IVariable | CreateArrayVar | - | available | not used
IVariable | CreateArrayVarEx | - | available | not used
VARIANT_BOOL | DeleteVar | - | available | not used
VARIANT_BOOL | Export | - | available | not used
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used
VARIANT_BOOL | Import | - | available | not used
VARIANT_BOOL | ImportDirect | Imports the selected XML file | available | not used
VARIANT_BOOL | ModifyVariable | Modify the given variable to match the new configuration. | available | not used
VARIANT_BOOL | ModifyArrayVariable | Modify the given array variable to match the new configuration. | available | not used

Other topics in this chapter

Item

ItemPvID

DoAutoSave

CreateVar

ModifyVariable

ModifyArrayVariable

CreateArrayVar

CreateArrayVarEx

DeleteVar

Export

SingleExport

Import

ImportDirect

CheckOutModule

CheckInModule


Item

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the object Variable from the collection, which is identified by the parameter vID.The parameter vID can have two values:

Datatype

Item(VARIANT vPv) As Variable

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

vID As Variant
Index or name.

If the parameter is a numerical value, the variable is searched by its index (>= 0 and <= Count-1).
If it is an alphanumerical value, the variable is searched by its unique name.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vPv As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ItemPvID

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Methods -> ItemPvID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the object Variable from the collection, identified with the parameter vID.The parameter vID contains the unique channel Id of the variable.The returned object should be checked on Nothing.

Datatype

ItemPvID(VARIANT vPvID) As Variable

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DoAutoSave

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Methods -> DoAutoSave

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this method you have the opportunity to stop writting changes on properties into the database. This should bring up performance improvements. Hint: Don't forget to make a .DoAutoSave(True) after a .DoAutoSave(False) otherwise data which has been typed in VBA won't be saved. The function doesn't work when the editor loses his focus (for example when the VBA code gets debugged).

Datatype

DoAutoSave(Boolean bSave) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

False = Stop writting into database. True = Start writting into database.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bSave As Boolean

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub DoAutoSave()

Dim zVariables As Variables 'Object from type Variables
Dim zVariable As Variable 'Child object from type Variables

'Fill the objects
Set zVariables = MyWorkspace.ActiveDocument.Variables
'Changes on properties should not be written into the database
zVariables.DoAutoSave (False)
'Read the first variable in list
Set zVariable = zVariables.Item(0)
'Changes on properties
zVariable.DynProperties("Unit") = "Volt"
zVariable.DynProperties("Name") = "Var_1"
'Now changes should be written into the database
zVariables.DoAutoSave (True)

End Sub


CreateVar

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Methods -> CreateVar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreateVar(BSTR strName, LPDISPATCH lpDriver, tpKanaltypes kTypes, LPDISPATCH lpVarType) As IVariable

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


ModifyVariable

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Methods -> ModifyVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Can be used to modify driver, channeltypes, datatypes, adressmode, and the settings of a non array variable.

Datatype

ModifyVariable(BSTR strName, LPDISPATCH lpDriver, tpKanaltypes kTypes, LPDISPATCH lpVarType,tpAdrMode lAdrMode,VARIANT_BOOL bStartAtNewOffset) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


ModifyArrayVariable

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Methods -> ModifyArrayVariable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Can be used to modify the dimension of the array. Also driver, channeltypes, datatypes, adressmode, offset calculation and lower bound (0 or 1) can be modified.

Datatype

ModifyArrayVariable(BSTR strName, LPDISPATCH lpDriver, tpKanaltypes kTypes, LPDISPATCH lpVarType, long lLBound, long lDimension1,long lDimension2,long Dimension3,tpAdrMode lAdrMode,VARIANT_BOOL bStartAtNewOffset) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


CreateArrayVar

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Methods -> CreateArrayVar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreateArrayVar(BSTR strName, LPDISPATCH lpDriver, tpKanaltypes kTypes, LPDISPATCH lpVarType, long lLBound, long lDimension1,long lDimension2,long Dimension3,VARIANT_BOOL bPacked,VARIANT_BOOL bStartAtNewOffset,VARIANT_BOOL bReserved) As IVariable

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


CreateArrayVarEx

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Methods -> CreateArrayVarEx

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreateArrayVarEx(BSTR strName, LPDISPATCH lpDriver, tpKanaltypes kTypes, LPDISPATCH lpVarType, long lLBound, long lDimension1,long lDimension2,long Dimension3,tpAdrMode lAdrMode,VARIANT_BOOL bStartAtNewOffset) As IVariable

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


DeleteVar

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Methods -> DeleteVar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DeleteVar(BSTR Name) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Export

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Export(BSTR bsFileName) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


SingleExport

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Methods -> SingleExport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SingleExport(VARIANT vIndexOrName,BSTR bsFileName) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Import

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Import(BSTR bsFileName) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


ImportDirect

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Methods -> ImportDirect

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ImportDirect(BSTR bsFileName, VARIANT_BOOL bIECDTOvw, VARIANT_BOOL bUDTOvw) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


CheckOutModule

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Methods -> CheckOutModule

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This function executes a check out of the whole variable administration at a multiuser project.

Datatype

CheckOutModule() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckInModule

Manual -> Programming interfaces -> Objectmodel -> Variables -> Variables-Methods -> CheckInModule

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This function executes a check in at a multiuser project when a variable is checked out or the variable administration is completely checked out.

Datatype

CheckInModule() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


VariableValue

Manual -> Programming interfaces -> Objectmodel -> VariableValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VBA

Other topics in this chapter

VariableValue-Properties


VariableValue-Properties

Manual -> Programming interfaces -> Objectmodel -> VariableValue -> VariableValue-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
VARIANT | Value | Value of the variable | not used | read only | yes | yes
long | Status | First 32 bits of the variable state | not used | read only | yes | yes
long | StatusExt | Last 32 bits of the variable state | not used | read only | yes | yes
DATE | Time | Timestamp of the value | not used | read only | yes | yes
short | TimeMilliseconds | Milliseconds of the timestamp | not used | read only | yes | yes

Other topics in this chapter

Value

Status

StatusExt

Time

TimeMilliseconds


Value

Manual -> Programming interfaces -> Objectmodel -> VariableValue -> VariableValue-Properties -> Value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Value for the Variable

Datatype

Value() As VARIANT

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Status

Manual -> Programming interfaces -> Objectmodel -> VariableValue -> VariableValue-Properties -> Status

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

First 32 Bits of the variable state.

Datatype

Status() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


StatusExt

Manual -> Programming interfaces -> Objectmodel -> VariableValue -> VariableValue-Properties -> StatusExt

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

last 32 Bits for the variable state.

Datatype

StatusExt() As long

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


Time

Manual -> Programming interfaces -> Objectmodel -> VariableValue -> VariableValue-Properties -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Timestamp of the value

Datatype

Time() As DATE

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


TimeMilliseconds

Manual -> Programming interfaces -> Objectmodel -> VariableValue -> VariableValue-Properties -> TimeMilliseconds

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Milliseconds for the timestamp.

Datatype

TimeMilliseconds() As short

Availability

Environment | Available
Editor | not used
Runtime | read only
VBA | yes
VSTA | yes


VarType

Manual -> Programming interfaces -> Objectmodel -> VarType

Remarks

With the object VarType you have the opportunity to edit selected datatypes.

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub CreateComplexType()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes

'Create a structure datatype called "Structure_1"
Set zVarType = zVarTypes.CreateComplexType("Structure_1")
Call NewSubItem

End Sub

Sub NewSubItem()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
Dim zVarType_1 As VarType 'Child object from type VarTypes
Dim zDrivers As Drivers 'Object from type Drivers
Dim zComplexItem As ComplexItem 'Child object from type ComplexItem
Dim i As Integer

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes

'Read the own created structure datatype "struct"
Set zVarType = zVarTypes.Item("Structure_1")
'Read the INT datatype as base type for the structure element
Set zVarType_1 = zVarTypes.Item("INT")
'Create 5 structure elements called "Element_" from type INT which should be embedded
For i = 1 To 5
Set zComplexItem = zVarType.NewSubItem("Element_" & i, zVarType_1, False, 1, 0, 0, 0)
Next i

End Sub

Other topics in this chapter

VarType-Properties

VarType-Methods


VarType-Properties

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
long | ID |  | read only | read only | yes | yes
BSTR | Name |  | read only | read only | yes | yes
IVarTypes | Parent |  | read only | read only | yes | yes

Other topics in this chapter

Parent

Name

ID


Parent

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As VarTypes

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the name of the datatype.

Datatype

Name() As String

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ID

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Properties -> ID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

internal uniqe ID as long

Datatype

ID() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


VarType-Methods

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CanDeleteType | - | available | not used
VARIANT_BOOL | CheckIn | Save module modifications to server (editor). | available | not used
VARIANT_BOOL | CheckOut | Allow module modifications (editor). | available | not used
IEdLimit | CreateEdLimit | - | available | not used
VARIANT_BOOL | DeleteEdLimit | - | available | not used
VARIANT_BOOL | DeleteSubItem | - | available | not used
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
long | EdLimitCount | - | available | not used
IEdLimit | EdLimitItem | - | available | not used
VARIANT_BOOL | Get | Get the latest version from the server (editor). | available | not used
long | GetDataType | - | available | not used
BOOL | IsAllowed | - | available | available
VARIANT_BOOL | IsCheckedOut | Returns true when the current module checked out by the current user (editor). | read only | not used
VARIANT_BOOL | IsDifferent | Return true when the local- and server version are different (editor). | read only | not used
VARIANT_BOOL | IsLocked | Returns true when the current module is Locked by another user (editor). | read only | not used
BOOL | IsSimple | - | available | available
IComplexItem | NewSubItem | - | available | not used
IComplexItem | SubItem | - | available | not used
long | SubItemCount | - | available | not used
VARIANT_BOOL | UndoCheckOut | Undo module modifications (editor). | available | not used
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used
BOOL | IsAllowed | - | available | available

Other topics in this chapter

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]

IsAllowed

IsSimple

GetDataType

SubItemCount

SubItem

CanDeleteType

NewSubItem

DeleteSubItem

EdLimitCount

EdLimitItem

CreateEdLimit

DeleteEdLimit

Get

CheckOut

CheckIn

UndoCheckOut

IsLocked

IsCheckedOut

IsDifferent


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


IsAllowed

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> IsAllowed

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

IsAllowed(LPDISPATCH lpDriver, tpKanaltypes kTypes) As BOOL

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


IsSimple

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> IsSimple

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns -1 when the datatype is a simple datatype and 0 when it is a complex datatype.

Datatype

IsSimple() As BOOL

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub IsSimple()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
Dim zDrivers As Drivers 'Object from type Drivers

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
Set zDrivers = MyWorkspace.ActiveDocument.Drivers

'Read the datatype INT from the list.
Set zVarType = zVarTypes.Item("INT")
'Check if it is a simple or a complex datatype
Debug.Print "Is Simple = " & zVarType.IsSimple

End Sub


GetDataType

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> GetDataType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns the number of the datatype.

Datatype

GetDataType() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDataType()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read the datatype INT from the list.
Set zVarType = zVarTypes.Item("INT")
'Get the number of the datatype
Debug.Print "Datatype = " & zVarType.GetDataType

End Sub


SubItemCount

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> SubItemCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns the number of items in a structure datatype.

Datatype

SubItemCount() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SubItem

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> SubItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns a sub item of a structure datatype.

Datatype

SubItem(long lIndex) As ComplexItem

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A long variable which defines the position of the structure element (counting starts at 0).

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

lIndex As Long

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SubItem()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
Dim zComplexItem As ComplexItem 'Child object from type ComplexItem

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read the own created structure datatype "struct"
Set zVarType = zVarTypes.Item("struct")
'Read the first item of this structure datatype
Set zComplexItem = zVarType.SubItem(0)
'Move the first item one position downwards
zComplexItem.MoveItemDown

End Sub


CanDeleteType

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> CanDeleteType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns true if a selected datatype can be deleted and false if it can't be deleted.

Datatype

CanDeleteType() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub CanDeleteType()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read the INT datatype from the list
Set zVarType = zVarTypes.Item("INT")
'Check if the selected datatype can be deleted
Debug.Print "Can delete type = " & zVarType.CanDeleteType

End Sub


NewSubItem

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> NewSubItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this method you can create new sub items for a structure datatype.

Datatype

NewSubItem(String bstrTypeName, IVarType pBaseType, Boolean bReferenz, long lLBound, long lDim1, long lDim2, long lDim3) As ComplexItem

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Set false for a embedded datatype and true for a linked one.

A VarType object which defines the basic type of the element.

A string which defines the name of the element.

Set the number of elements for the first array dimension.

Set the number of elements for the second array dimension.

Set the number of elements for the third array dimension.

Set the array start index (0 or 1).

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bReferenz As Boolean

pBaseType As VarType

bstrTypeName As String

lDim1 As Long

lDim2 As Long

lDim3 As Long

lLBound As Long

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub NewSubItem()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
Dim zVarType_1 As VarType 'Child object from type VarTypes
Dim zDrivers As Drivers 'Object from type Drivers
Dim zComplexItem As ComplexItem 'Child object from type ComplexItem

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes

'Read the own created structure datatype "struct"
Set zVarType = zVarTypes.Item("struct")
'Read the INT datatype as base type for the structure element
Set zVarType_1 = zVarTypes.Item("INT")
'Create a new structure element called "Element_1" from type INT which should be embedded
Set zComplexItem = zVarType.NewSubItem("Element_1", zVarType_1, False, 0, 0, 0, 0)

End Sub


DeleteSubItem

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> DeleteSubItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this method you can delete an item from a structure datatype.

Datatype

DeleteSubItem(VARIANT vNameOrIndex) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

The structure item can be selected via a string (name) or via a index number.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vNameOrIndex As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub DeleteSubItem()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read the own created structure datatype "structure" from the list
Set zVarType = zVarTypes.Item("structure")
'Delete an item called "element_1" from the structure datatype
Debug.Print "Sub item has been deleted = " & zVarType.DeleteSubItem("element_1")
End Sub


EdLimitCount

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> EdLimitCount

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns the number of limits from a datatype.

Datatype

EdLimitCount() As long

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub CountEdLimits()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read the datatype INT from the list.Project some limits at the datatype.
Set zVarType = zVarTypes.Item("INT")
'Count the number of limits from a datatype
Debug.Print "Number of limits at the datatype = " & zVarType.EdLimitCount

End Sub


EdLimitItem

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> EdLimitItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns an "EdLimit" object from a datatype.

Datatype

EdLimitItem(VARIANT vIndex) As EdLimit

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

The limit can be selected via a number (counting starts at 0) or via a string (name of the limit).

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vIndex As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub EdLimitItem()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
Dim zEdLimit As EdLimit 'Object from type EdLimit

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read the datatype INT from the list.Project some limits at the datatype.
Set zVarType = zVarTypes.Item("INT")
'Create a Limit at the INT datatype
zVarType.CreateEdLimit
'Returns a EdLimit object from the first limit
Set zEdLimit = zVarType.EdLimitItem(0)

'Set the limit active
zEdLimit.Active = True
'Set limit text
zEdLimit.Text = "Limit reached"
'Set limit value to 10
zEdLimit.LimitValue = 10
'Set the limit as maximum
zEdLimit.IsMax = True
'Set the limit as alarm
zEdLimit.Alarm = True
'Limit should be recognized in the CEL
zEdLimit.Cel = True

End Sub


CreateEdLimit

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> CreateEdLimit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method creates a limit at a datatype.

Datatype

CreateEdLimit() As EdLimit

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub CreateEdLimit()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read the INT datatype from the list
Set zVarType = zVarTypes.Item("INT")
'Creates a limit at the INT datatype
zVarType.CreateEdLimit

End Sub


DeleteEdLimit

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> DeleteEdLimit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method deletes a selected limit from a datatype.

Datatype

DeleteEdLimit(VARIANT vIndex) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

The limit can be selected via its name (string) or via a number (counting starts at 0).

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vIndex As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub DeleteEdLimit()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Read the INT datatype from the list.Some limits should be projected at the datatype
Set zVarType = zVarTypes.Item("INT")
'Delete "Limit[1]" at the INT datatype
zVarType.DeleteEdLimit ("Limit[1]")

End Sub


Get

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> Get

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype

Get() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckOut

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> CheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype

CheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckIn

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> CheckIn

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype

CheckIn() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


UndoCheckOut

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> UndoCheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype

UndoCheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsLocked

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> IsLocked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype

IsLocked() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsCheckedOut

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> IsCheckedOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype

IsCheckedOut() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsDifferent

Manual -> Programming interfaces -> Objectmodel -> VarType -> VarType-Methods -> IsDifferent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype

IsDifferent() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


VarTypes

Manual -> Programming interfaces -> Objectmodel -> VarTypes

Remarks

With the object VarTypes you have the opportunity to create, delete and edit datatypes from the list of datatypes.

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub CreateComplexType()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes

'Create a structure datatype called "Structure_1"
Set zVarType = zVarTypes.CreateComplexType("Structure_1")
Call CreateSimpleType

End Sub

Sub CreateSimpleType()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
Dim zVarTypes_1 As VarTypes
Dim zVarType_1 As VarType

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
Set zVarTypes_1 = MyWorkspace.ActiveDocument.VarTypes

'Read datatype "UINT"
Set zVarType_1 = zVarTypes_1.Item(1)

'Create a simple datatype from type "UINT" called "SimpleType_1"
Set zVarType = zVarTypes.CreateSimpleType("SimpleType_1", zVarType_1)

End Sub

Other topics in this chapter

VarTypes-Properties

VarTypes-Methods


VarTypes-Properties

Manual -> Programming interfaces -> Objectmodel -> VarTypes -> VarTypes-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count |  | read only | read only
IProject | Parent |  | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> VarTypes -> VarTypes-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> VarTypes -> VarTypes-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


VarTypes-Methods

Manual -> Programming interfaces -> Objectmodel -> VarTypes -> VarTypes-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CanDeleteType | - | available | available
IVarType | CreateComplexType | - | available | not used
IVarType | CreateSimpleType | - | available | not used
VARIANT_BOOL | DeleteType | - | available | not used
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | Import | Imports the selected XML file | available | not used
VARIANT_BOOL | ImportDirect | - |  |
IVarType | Item | - | available | available
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | available
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | available
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | Import | Imports the selected XML file | available | not used
VARIANT_BOOL | ImportDirect | - | available | not used

Other topics in this chapter

Item

CreateSimpleType

CreateComplexType

DeleteType

CanDeleteType

SingleExport

Export

Import

ImportDirect


Item

Manual -> Programming interfaces -> Objectmodel -> VarTypes -> VarTypes-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this method you can access datatypes out of the list.

Datatype

Item(VARIANT vNameOrID) As VarType

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

The datatype can be selected via its name (string) or via an ID (number).

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vNameOrID As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub Item()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes

'Read all settings from the "INT" datatype
Set zVarType = zVarTypes.Item("INT")

Debug.Print "Name of item = " & zVarType.Name

End Sub


CreateSimpleType

Manual -> Programming interfaces -> Objectmodel -> VarTypes -> VarTypes-Methods -> CreateSimpleType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this method a simple datatype can be created.

Datatype

CreateSimpleType(String bstrTypeName, IVarType pBaseType) As VarType

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Needs an item from type VarType to set the base type of the own created datatype.

A string which defines the name of the simple datatype.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

pBaseType As VarType

bstrTypeName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub CreateSimpleType()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes
Dim zVarTypes_1 As VarTypes
Dim zVarType_1 As VarType

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
Set zVarTypes_1 = MyWorkspace.ActiveDocument.VarTypes

'Read datatype "UINT"
Set zVarType_1 = zVarTypes_1.Item(1)

'Create a simple datatype from type "UINT" called "SimpleType_1"
Set zVarType = zVarTypes.CreateSimpleType("SimpleType_1", zVarType_1)

End Sub


CreateComplexType

Manual -> Programming interfaces -> Objectmodel -> VarTypes -> VarTypes-Methods -> CreateComplexType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this method a structure datatype can be created.

Datatype

CreateComplexType(String bstrTypeName) As VarType

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A string which defines the name of the structure datatype.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bstrTypeName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub CreateComplexType()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes

'Create a structure datatype called "Structure_1"
Set zVarType = zVarTypes.CreateComplexType("Structure_1")

End Sub


DeleteType

Manual -> Programming interfaces -> Objectmodel -> VarTypes -> VarTypes-Methods -> DeleteType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this method an own created datatype can be deleted.

Datatype

DeleteType(VARIANT vNameOrIndex) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

The datatype can be selected via position (number) or via its name (string).

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vNameOrIndex As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub DeleteType()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes

'Delete an own created datatype called "own_simple"
zVarTypes.DeleteType ("own_simple")

End Sub


CanDeleteType

Manual -> Programming interfaces -> Objectmodel -> VarTypes -> VarTypes-Methods -> CanDeleteType

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This method returns true if a selected datatype can be deleted and false if it can't be deleted.

Datatype

CanDeleteType(VARIANT vNameOrIndex) As Boolean

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub CanDeleteTypes()

Dim zVarTypes As VarTypes 'Object from type VarTypes
Dim zVarType As VarType 'Child object from type VarTypes

'Fill the objects
Set zVarTypes = MyWorkspace.ActiveDocument.VarTypes
'Try if this datatype can be deleted
Debug.Print "Can this type be deleted = " & zVarTypes.CanDeleteType("INT")

End Sub


SingleExport

Manual -> Programming interfaces -> Objectmodel -> VarTypes -> VarTypes-Methods -> SingleExport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SingleExport(VARIANT vIndexOrName,BSTR bsFileName) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Export

Manual -> Programming interfaces -> Objectmodel -> VarTypes -> VarTypes-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Export(BSTR bsFileName) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


Import

Manual -> Programming interfaces -> Objectmodel -> VarTypes -> VarTypes-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Import(BSTR bsFileName) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


ImportDirect

Manual -> Programming interfaces -> Objectmodel -> VarTypes -> VarTypes-Methods -> ImportDirect

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ImportDirect(BSTR bsFileName, VARIANT_BOOL bIECDTOvw, VARIANT_BOOL bUDTOvw) As VARIANT_BOOL

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA


ZenMenu

Manual -> Programming interfaces -> Objectmodel -> ZenMenu

Remarks

With an object of this type a context or main menu item can be edited, deleted, created,...

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

'This sample creates a main menu with 5 items and sets the backcolor of the menu.
Sub ZenMenu()

Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object of ZenMenus
Dim zMenuItem As ZenMenuItem 'Child object of ZenMenu
Dim i As Integer 'Loop variable

Set zMenus = MyWorkspace.ActiveDocument.ZenMenus

'Create a main menu
Set zMenu = zMenus.Create("Main_1")
'Is true for main menu and false for context menu
zMenu.IsPulldown = True

'Create 5 main menu items
For i = 0 To 4
Set zMenuItem = zMenu.Create("ID_" & i, False)
'Set the text of the main menu item
zMenuItem.Caption = "Item_" & i
Next i

'Set Background color of the main menu
zMenu.BackColor = 12345678

'Check how many items are available in this main menu
Debug.Print "Count = " & zMenu.Count

End Sub

Other topics in this chapter

ZenMenu-Properties

ZenMenu-Methods

ZenMenu-Dynamic properties


ZenMenu-Properties

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
OLE_COLOR | BackColor | BackColor | available | available
long | Count | Count of defined menu-items | read only | read only
long | ID | Returns the unique ID for the menu | read only | read only
VARIANT_BOOL | IsPulldown | Is the menu a pulldown menu (true) or a popup menu (false) | available | read only
BSTR | Name | Name of the menu | available | read only
BSTR | Notes | Notes to the menu | available | available
IZenMenus | Parent | Parent-object | read only | read only
OLE_COLOR | TextColor | TextColor | available | read only

Other topics in this chapter

Parent

Count

ID

Name

Notes

BackColor

TextColor

IsPulldown


Parent

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As ZenMenus

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ID

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Properties -> ID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the unique ID for the menu item.

Datatype

ID() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the name of the context or main menu.

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Notes

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Properties -> Notes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a string with some notes. This property is not visible in zenOn.

Datatype

Notes() As String

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


BackColor

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Properties -> BackColor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this property you can set the back color of the menu.

Datatype

BackColor() As OLE_COLOR

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes


TextColor

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Properties -> TextColor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this property you can set the text color of a menu.

Datatype

TextColor() As OLE_COLOR

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


IsPulldown

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Properties -> IsPulldown

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true for a main menu and false for a context menu. It can also be used to change a main menu to a context menu and vice versa.

Datatype

IsPulldown() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ZenMenu-Methods

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IZenMenuItem | Create | Creates a new menu-item | available | not used
VARIANT_BOOL | Delete | Deletes the given menu-item | available | not used
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IZenMenuItem | Item | Returns a menu-item by position or name | available | available
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

Item

Create

Delete

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


Item

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns a menu item by position or name of item.

Datatype

Item(VARIANT vPosition) As ZenMenuItem

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

This parameter can either be a numerical value or a string.
Example: 0,1,2,... or "ID_FIRST", "ID_SECOND",...

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vPosition As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ItemMenus()

Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object of ZenMenus
Dim zMenuItem As ZenMenuItem 'Child object of ZenMenu

Set zMenus = MyWorkspace.ActiveDocument.ZenMenus

'Select a main menu
Set zMenu = zMenus.Item(1)

'Select the first item of the main menu
Set zMenuItem = zMenu.Item(0)
Debug.Print "Name of menu item = " & zMenuItem.Name

End Sub


Create

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Methods -> Create

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this function new context and main menu items can be created.

Datatype

Create(String bsName,Boolean bPulldown) As ZenMenuItem

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A string which defines the name of the menu item.

Example: "Test"

This parameter can be set true or false without any effect.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsName As String

bPulldown As Boolean

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub CreateMenuItem()

Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object of ZenMenus
Dim zMenuItem As ZenMenuItem 'Child object of ZenMenu

Set zMenus = MyWorkspace.ActiveDocument.ZenMenus

'Select a context or main menu
Set zMenu = zMenus.Item(0)

'Create an item with the name "Test" in the selected menu
Set zMenuItem = zMenu.Create("Test", True)

End Sub


Delete

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Methods -> Delete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With this function a menu item can be deleted.

Datatype

Delete(String bsName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A string which defines the name of the menu item.

Example: "ID_FIRST"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub DeleteMenuItem()

Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object of ZenMenus
Dim deleted As Boolean

Set zMenus = MyWorkspace.ActiveDocument.ZenMenus

'Select a context or main menu
Set zMenu = zMenus.Item(1)

'Delete a main menu item and return true or false for deleted or not deleted
deleted = zMenu.Delete("ID_FIRST")
Debug.Print "Deleted = " & deleted

End Sub


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


ZenMenu-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Menu

Other topics in this chapter

Menu


Menu

Manual -> Programming interfaces -> Objectmodel -> ZenMenu -> ZenMenu-Dynamic properties -> Menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | VBA/VSTA Name | Display Name | Description
VT_BOOL | Pulldown | Pulldown | "With this property you have the opportunity to select wheter the menu is a main or a context menu. TRUE = It's a main menu, FALSE = It's a context menu. "
VT_BSTR | Notes | Notes | With this property you have the opportunity to get/set notes from a menu.
VT_BSTR | Name | Name | Distinct name of the menu. Default: New main menu x or new context menu x (whereby x is a successive number). Attention: This property is not available for language switch. More in the online help.
ZT_SCHRIFT | Font | Font | Font type of the menus. Is valid for all menu entries. More in the online help.
ZT_COLOR | TextColor | Text color | Text color for the selected menu. More in the online help.
ZT_COLOR | BackColor | Background color | Background color for the selected menu. More in the online help.
ZT_AKZ | SystemModelGroup | Equipment groups | Links element with an equipment model. Click on button ... in order to open the dialog for selecting an equipment group. More in the online help.


ZenMenuItem

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

With an object of this type items of a context menu and main menu submenus can be edited, deleted, created,...

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

'This sample creates a context and a main menu with one item each.
'The main menu item can execute a set value function.
'The context menu item can execute a vba makro.
'Preparation: A variable and a makro have to be available
Sub ZenMenuItem()

Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object of ZenMenus
Dim zMenuItem As ZenMenuItem 'Child object of ZenMenu

Set zMenus = MyWorkspace.ActiveDocument.ZenMenus

'Create a main menu
Set zMenu = zMenus.Create("Main_1")
zMenu.IsPulldown = True
'Create a main menu item
Set zMenuItem = zMenu.Create("ID_1", True)
'Set text of menu item
zMenuItem.Caption = "First"

'Create a context menu
Set zMenu = zMenus.Create("Context_1")
zMenu.IsPulldown = False
'Create a context menu item
Set zMenuItem = zMenu.Create("id_1", True)
'Set text of menu item
zMenuItem.Caption = "first"

'Projects the set value action at the main menu item
Call setValue(zMenus)
'Projects the makro action at the context menu item
Call setMakro(zMenus)

End Sub

Sub setValue(Menus As ZenMenus)

Dim zVar As Variable 'Variable for the set value function
Dim Menu As ZenMenu 'Child object of ZenMenus
Dim MenuItem As ZenMenuItem 'Child object of ZenMenu

'Select the main menu
Set Menu = Menus.Item(0)
'Select the first main menu item
Set MenuItem = Menu.Item(0)

'Object of variable "test" is assigned
Set zVar = MyWorkspace.ActiveDocument.Variables.Item("test")
'Deactivate the submenus
MenuItem.Popup = False
'Select set value as the action type of the menu item
MenuItem.Type = tpVariable
'The variable of the set value function is assigned via Ids
MenuItem.ActionID = zVar.PvID
'Set the "change by" value to 5
MenuItem.setValue = 5

End Sub

Sub setMakro(Menus As ZenMenus)

Dim zVar As Variable 'Variable for the set value function
Dim Menu As ZenMenu
Dim MenuItem As ZenMenuItem

'Select the context menu
Set Menu = Menus.Item(1)
'Select the first context menu item
Set MenuItem = Menu.Item(0)
'Deactivate the submenus
MenuItem.Popup = False
'Select set value as the action type of the menu item
MenuItem.Type = tpVbaMacro
'Set the Macro via the dynProperties
MenuItem.DynProperties("VBA-Macro") = "Init_Default"

End Sub

Other topics in this chapter

ZenMenuItem-Properties

ZenMenuItem-Methods

ZenMenuItem-Dynamic properties


ZenMenuItem-Properties

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | ActionID | ID of the variable/rt-function/macro/help-ID | available | read only
BSTR | Caption | Caption of the menu-item | available | read only
VARIANT_BOOL | Checked | Menu-item has checkbox | available | read only
long | Count | Count of defined menu-items | read only | read only
VARIANT_BOOL | Enabled | Enables/Disables the menu-item | available | read only
BSTR | Guid | Project-GUID by variables of a other project | not used | not used
BSTR | HelpFile | Helpfile for execution (Type = tpZenHelp) | available | read only
BSTR | HelpTopic | Help-ID for execution (Type = tpZenHelp) | available | read only
long | ID | Returns the unique ID for the menu-item | read only | read only
long | MenuID | Returns the unique ID for the zenOn-menu | read only | read only
BSTR | Name | Unique Name of the menu-item | available | read only
IZenMenuItem | Parent | Parent-object | read only | read only
long | ParentID | Returns the unique ID for the parent menu-item | read only | read only
short | Password | Password-level for execution | available | read only
BSTR | Picture | Bitmap-file of the menu-item | available | read only
VARIANT_BOOL | Popup | Menu-item contains sub-items | available | read only
VARIANT_BOOL | Seperator | Menu-item is a seperator (no execution) | available | read only
double | SetValue | Defined SetValue (Type = tpVariable) | available | read only
VARIANT_BOOL | ShowSetValueDlg | Show set-value dialog (Type = tpVariable) | available | read only
BSTR | Tooltip | Tooltip-Text for the menu-item | not used | not used
tpZenMenus | Type | Type of the menu-item (Variable/RtFunction/Help/Macro) | available | read only
VARIANT_BOOL | UseCurValue | Use current set-value of the variable (Type = tpVariable) | available | read only
VARIANT_BOOL | VarFromElement | Use Variable from the linked element (Type = tpVariable) | available | read only
VARIANT_BOOL | Visible | Shows/hides the menu-item | available | read only
BSTR | ToolTip | Tooltip-Text for the menu-item | not used | not used

Other topics in this chapter

Parent

Count

ID

MenuID

ParentID

Name

Caption

ToolTip

HelpFile

Picture

HelpTopic

Seperator

Enabled

Visible

Checked

Popup

Type

Password

Guid

VarFromElement

UseCurValue

ShowSetValueDlg

ActionID

SetValue


Parent

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As ZenMenuItem

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ID

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> ID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the unique ID for the submenu item.

Datatype

ID() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


MenuID

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> MenuID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the unique ID for the menu.

Datatype

MenuID() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ParentID

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> ParentID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the unique ID for the parent menu item.

Datatype

ParentID() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the name of a menu item.

Datatype

Name() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Caption

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> Caption

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the text of a menu item.

Datatype

Caption() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ToolTip

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> ToolTip

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

ToolTip() As BSTR

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes


HelpFile

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> HelpFile

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

A helpfile can be set via a case sensitive string (directory + file).Hint: To set this property the action typ of the menu item should be set to help.

Datatype

HelpFile() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Picture

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> Picture

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

A bitmap can be set via a string (directory + file).Hint: A bitmap can only be set at a context menu.

Datatype

Picture() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


HelpTopic

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> HelpTopic

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns or sets the selected chapter for the helpfile. The given parameter is case sensitive!

Datatype

HelpTopic() As String

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Seperator

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> Seperator

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns if the "seperator" item is set or not.

Datatype

Seperator() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Enabled

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> Enabled

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns if the menu item is set active or not in the runtime.

Datatype

Enabled() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Visible

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> Visible

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the state of the "visible" item of a menu.

Datatype

Visible() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Checked

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> Checked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns if the "check mark" item is set or not.

Datatype

Checked() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Popup

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> Popup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Submenus for a menu item can be set active or inactive.

Datatype

Popup() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Type

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> Type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns action type of menu item. Following numbers are allocated to the parameters: tpRtFunction = 1; tpVariable = 2; tpVbaMacro = 3; tpZenHelp = 6.

Datatype

Type() As tpZenMenus

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Password

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> Password

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the password level of the menu item.Hint: This value can only be set when an action typ is active.

Datatype

Password() As short

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


Guid

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> Guid

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Not in use.

Datatype

Guid() As String

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes


VarFromElement

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> VarFromElement

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the state of the set value "Variable from element" item.Hint: The action type set value has to be activated. This option is only available at context menus.

Datatype

VarFromElement() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


UseCurValue

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> UseCurValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the state of the set value "Propose current value" item.Hint: The action type set value has to be activated.

Datatype

UseCurValue() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ShowSetValueDlg

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> ShowSetValueDlg

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the state of the set value "dialog" item.

Datatype

ShowSetValueDlg() As Boolean

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ActionID

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> ActionID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the ID of the chosen action. Depending on the chosen action type the ID of the variable, of the function or of the help chapter (if a string is used it is set to -1) is returned. Assign variable: zMenuItem.ActionID = zVar.PvIDAssign function: zMenuItem.ActionID = zFunc.ID

Datatype

ActionID() As long

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


SetValue

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Properties -> SetValue

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the "change by" value of a change value action. Hint: The action type set value has to be activated.

Datatype

SetValue() As double

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes


ZenMenuItem-Methods

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
IZenMenuItem | Create | Creates a new menu-item | available | not used
VARIANT_BOOL | Delete | Deletes the given menu-item | available | not used
void | DynProperties [PUT] | - | available | available
VARIANT | DynProperties [GET] | - | available | available
VARIANT | DynPropertiesEnum [GET] | - | read only | read only
IZenMenuItem | Item | Returns a menu-item by position or name | available | available
IPropParam | DynPropertyParam [GET] | Returns the PropParam objekt of the given DynProperty | read only | not used

Other topics in this chapter

Item

Create

Delete

DynPropertyParam [GET]

DynPropertiesEnum [GET]

DynProperties [GET]

DynProperties [PUT]


Item

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This function returns a submenu object via position or name.

Datatype

Item(VARIANT vPosition) As ZenMenuItem

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

This parameter can either be a numerical value or a string.
Example: 0,1,2,... or "ID_FIRST", "ID_SECOND",...

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

vPosition As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ItemMenus()

Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object of ZenMenus
Dim zMenuItem As ZenMenuItem 'Child object of ZenMenu
Dim zMenuItem_1 As ZenMenuItem 'Child object of ZenMenu

Set zMenus = MyWorkspace.ActiveDocument.ZenMenus

'Select a menu
Set zMenu = zMenus.Item(1)
'Select the first menu item in the main menu
Set zMenuItem = zMenu.Item(0)
'Select the first submenu
Set zMenuItem_1 = zMenuItem.Item(0)
Debug.Print "Name = " & zMenuItem_1.Name

End Sub


Create

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Methods -> Create

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This function creates a new submenu item.

Datatype

Create(String bsName,Boolean bPulldown) As ZenMenuItem

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A string which defines the name of the submenu item.

Example: "Sub_1"

This parameter can be set true or false without any effect.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsName As String

bPulldown As Boolean

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub CreateSubmenu()

Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object of ZenMenus
Dim zMenuItem As ZenMenuItem 'Child object of ZenMenu
Dim zMenuItem_1 As ZenMenuItem 'Child object of ZenMenu

Set zMenus = MyWorkspace.ActiveDocument.ZenMenus

'Select a context or main menu
Set zMenu = zMenus.Item(0)
'Select the first menu item in the main menu
Set zMenuItem = zMenu.Item(0)
'Create a new submenu
Set zMenuItem_1 = zMenuItem.Create("Test", False)

End Sub


Delete

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Methods -> Delete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The function deletes a submenu.

Datatype

Delete(String bsName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A string which defines the name of the submenu item.

Example: "Sub_1"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub DeleteSubMenus()

Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object of ZenMenus
Dim zMenuItem As ZenMenuItem 'Child object of ZenMenu
Dim deleted As Boolean

Set zMenus = MyWorkspace.ActiveDocument.ZenMenus

'Select a menu
Set zMenu = zMenus.Item(1)
'Select the first menu item in the main menu
Set zMenuItem = zMenu.Item(0)
'Deletes a submenu
deleted = zMenuItem.Delete("ID_1")
Debug.Print "Deleted = " & deleted

End Sub


DynPropertyParam [GET]

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Methods -> DynPropertyParam [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertyParam [GET](BSTR bsPath) As PropParam

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


DynPropertiesEnum [GET]

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Methods -> DynPropertiesEnum [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynPropertiesEnum(String bsPath) As VARIANT

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes

Parameters

A String which defines the entry point to get out all available properties of the object.

A blank String like that returns the first layer of properties:

DynPropertiesEnum("")

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub ReadDynProps()
End Sub


DynProperties [GET]

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Methods -> DynProperties [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties(String bsPath) As VARIANT

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub GetDynProp()
'Sample: GSet the Network Aktive Flag of the Project.
If MyWorkspace.ActiveDocument.DynProperties("NetActive") = True Then
'read the server - computername...
Debug.Print "Server: " & MyWorkspace.ActiveDocument.DynProperties("NetServer")
End If
End Sub


DynProperties [PUT]

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Methods -> DynProperties [PUT]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

DynProperties (String bsPath,VARIANT vValue) As void

Availability

Environment | Available
Editor | available
Runtime | available
VBA | yes
VSTA | yes

Parameters

A String which defines the Property.

Example: "NetAktive"

Returns a variant value depending to the property, it can be a boolean, a long, or a whole object.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsPath As String

vValue As Variant

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub SetDynProp()
End Sub


ZenMenuItem-Dynamic properties

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Dynamic properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynproperties

Base menu item

Other topics in this chapter

Base menu item


Base menu item

Manual -> Programming interfaces -> Objectmodel -> ZenMenuItem -> ZenMenuItem-Dynamic properties -> Base menu item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Type

VBA/VSTA Name

Display Name

Description

VT_I2

Password

Authorization level

Password level for the execution of this menu entry.

More in the online help.

VT_UI4

Locking

Interlocking

Selection of an interlocking for the menu entry.

More in the online help.

VT_BOOL

Signature

Signature necessary

Active: A signature is necessary to operate the element.

For security reasons, the user's password will be requested, even if the user is already logged in. The signature text is logged in the Chronological Event List (CEL) after the successful use of the element.

Attention: Only users who are logged in can sign an action. Signing actions with temporary login is no longer possible.

Inactive: No signature is required.

(Default) Inactive:

More in the online help.

VT_BSTR

SignatureText

Signature text

This text is also logged when signing in the Chronological Event List (CEL) or is proposed in Runtime as a default if the signature is defined as editable in the project properties.

More in the online help.

VT_I2

SignatureEditModus

Signature text editable

Defines whether the signature text can be edited. Selection from drop-down list:

  • Apply project settings: The settings of the Signature text editable project property are applicable.
  • Yes: Text can be edited.
  • No: Text cannot be edited.

Default: Apply project settings

More in the online help.

VT_BSTR

Caption

Text

Label of the menu entry in the menu. The entry name must be unique. If there are several entries with the same text, only the first menu entry is displayed in the Runtime.

Note: If, in the Action type property, the value Command is selected with the drop-down list, the value of the Text: property is pre-filled with $ALL$.

More in the online help.

VT_BSTR

Name

Menu ID

Name of the menu entry.

At Action type Command processing you can select the already defined actions from a drop-down list.

More in the online help.

ZT_FILE

Picture

Graphics file

Graphics file which is displayed in the left-most area.

More in the online help.

VT_BOOL

Enabled

Active

Active: The menu entry is normally displayed and the action linked to this is executed when this entry is selected.
Inactive: The entry is normally shown as grayed out and the action linked to this is not executed.

More in the online help.

VT_I2

Type

Action type

The following action types are available in main and context menu:

Function: A function is carried out.
Help: An entry from the help is displayed.
No action: No action is carried out.
Write set value: A set value is written to a variable.

The following action types can only be carried out in the context menu:

Alarms: Acknowledge: Acknowledges all alarms for variables which are linked to the dynamic element to which the context menu relates.
Acknowledge flashing: Switches off the blinking of all alarms for variables that are linked to the dynamic element, which the context menu relates to. With this the alarm is not acknowledged.
Commands: Carries out a command input.
VBA Makro: A VBA macro is carried out.

More in the online help

VT_BOOL

Visible

visible

Defines whether the menu item is displayed in the Runtime.

Default: active

More in the online help.

VT_BOOL

Checked

Check mark

Left to the menu item a tick mark is displayed. This only serves the graphic display.

Default: Inactive.

More in the online help.

VT_BOOL

Popup-Menu

Submenu

The menu item does not carry out a function but opens a sub-menu.

Default: Inactive.

More in the online help.

VT_BOOL

Seperator

Separator active

Active: Instead of a menu entry a horizontal separator is added. Width and color of the line can be defined.

Default: inactive

More in the online help.

VT_UI1

SeparatorWidth

Width

Defines the width of the separator in pixels.

Default: 0

More in the online help.

ZT_COLOR

SeparatorColor

Color

Defines the fill color of the separator. Clicking on the ... button opens the dialog for selecting a color or color palette. The entry can also be made in the field directly as a hexadecimal value with # placed in front.

Default: black

More in the online help.

ZT_FILE

BackgroundPicture

Graphics file

Background graphics file for the menu item.

More in the online help.

VT_I2

BackgroundPicRepres

Alignment

Size of the background graphics file for the menu item.
Original size: The graphics file is displayed in its original size. The menu item is adjusted to the size of the graphics file.
Stretched: The graphics file is stretched to the size of the menu item.
Default: Original size.

Example: Menus should be used in a touch screen project. As a default for the size of the single menu items, the settings of the operation system are used. With a background graphics file in original size however you can define the size of the menu item individually.

More in the online help.

ZT_FILE

HelpFile

File

Only available for the "help" action type:
Help file from which a chapter should be displayed
The help pages of the linked elements are normally displayed. If a linked element does not have a help page, the one specified here is displayed.

More in the online help.

VT_BSTR

HelpCapture

Chapter

Only available for the "help" action type:
Help chapter that is to be displayed.

Attention: This entry is case sensitive.
The help pages of the linked elements are normally displayed. If a linked element does not have a help page, the one specified here is displayed.

More in the online help.

ZT_FUNCTION

Function

Function

Only available for "function" action
Function that is executed by means of the selected menu entry.
If more than one function is to be executed, a script with the desired functions is created and the function to execute the script is linked here.

More in the online help.

ZT_VBAMAKRO

VBA-Macro

VBA macro

Only available for action type "VBA macro":
VBA macro that is to be executed via the selected menu entry.

More in the online help.

VT_BOOL

FromElem

Variable from element

Only available for "write set value" and context menu action type:
Active: The variable for writing the set value is taken from the dynamic element.
Inactive: Set variable for set value is given in the properties of the menu entry.
Default: inactive.

More in the online help.

ZT_VARIABLE

Variable

Variable

Only available for action type "Write set value":
Variable to which a set value is to be written via the selected menu entry.

More in the online help.

VT_BOOL

SWDialog

Dialog

Only available for action type "Write set value":
Active: When executing the action, a dialog box is opened before setting the set value, which makes it possible for the user to change the set value before writing.
If there are screen keyboards (such as SETVALUEKBD, SETSTRINGKBD or SETBOOLKBD), these are automatically called up instead of the dialog box.
Inactive: The value defined in the properties of the menu entry is dent directly to the hardware.
Default: inactive.

More in the online help.

VT_BOOL

ActValue

Propose current value

Only available for action type "Write set value":
Active: The current value of the variable is proposed as the set value.
Inactive: The set is provided directly in the properties of the menu entry.
Default: inactive.

More in the online help.

VT_R8

Sollwert

Set value/Change by

Only available for action type "Write set value":
Numeric value which should be written as set value to the variable. Only numeric values are expected and accepted. The values are taken over with up to 6 decimal places.
If property Propose current value is activated, the current value of the variable is increased (positive value) or decreased (negative value) by this amount.

More in the online help.


ZenMenus

Manual -> Programming interfaces -> Objectmodel -> ZenMenus

Remarks

This object manages context and main menus.

Availability

Environment | Available
Editor | available
Runtime | read only
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Sub zenOnMenus()

Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object
Dim i As Integer 'Loop variable

Set zMenus = MyWorkspace.ActiveDocument.ZenMenus

'Loop creates five context and five main menus
For i = 1 To 5
'Creates a context menu
Set zMenu = zMenus.Create("context_" & i)
'False for context menu
zMenu.IsPulldown = False

'Creates a main menu
Set zMenu = zMenus.Create("main_" & i)
'True for main menu
zMenu.IsPulldown = True
Next i

'Check if all items have been created (Hint: counting starts at 0 until .count-1)
For i = 0 To zMenus.Count - 1
Debug.Print "Item " & i & " = " & zMenus.Item(i).Name
Next i

End Sub

Other topics in this chapter

ZenMenus-Properties

ZenMenus-Methods


ZenMenus-Properties

Manual -> Programming interfaces -> Objectmodel -> ZenMenus -> ZenMenus-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
long | Count | Count of defined menus | read only | read only
IProject | Parent | Parent-object | read only | read only

Other topics in this chapter

Parent

Count


Parent

Manual -> Programming interfaces -> Objectmodel -> ZenMenus -> ZenMenus-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Project

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


Count

Manual -> Programming interfaces -> Objectmodel -> ZenMenus -> ZenMenus-Properties -> Count

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The method returns the number of available objects. This property is mostly used for the method Item to run through each single object.Hint: For running through entries care, that the minimum is 0 and the maximum is Count-1.

Datatype

Count() As long

Availability

Environment | Available
Editor | read only
Runtime | read only
VBA | yes
VSTA | yes


ZenMenus-Methods

Manual -> Programming interfaces -> Objectmodel -> ZenMenus -> ZenMenus-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | CheckIn | Save module modifications to server (editor). | available | not used
VARIANT_BOOL | CheckOut | Allow module modifications (editor). | available | not used
IZenMenu | Create | Creates a new menu | available | not used
VARIANT_BOOL | Delete | Deletes the given menu | available | not used
VARIANT_BOOL | Export | Exports the selected object to a XML file | available | not used
VARIANT_BOOL | Get | Get the latest version from the server (editor). | available | not used
VARIANT_BOOL | Import | Imports the selected XML file | available | not used
VARIANT_BOOL | IsCheckedOut | Returns true when the current module checked out by the current user (editor). | read only | not used
VARIANT_BOOL | IsDifferent | Return true when the local- and server version are different (editor). | read only | not used
VARIANT_BOOL | IsLocked | Returns true when the current module is Locked by another user (editor). | read only | not used
IZenMenu | Item | Returns the menu by name or position | available | not used
VARIANT_BOOL | SingleExport | Exports the Item with given Name oder Index | available | not used
VARIANT_BOOL | UndoCheckOut | Undo module modifications (editor). | available | not used

Other topics in this chapter

Item

Create

Delete

Get

CheckOut

CheckIn

UndoCheckOut

IsLocked

IsCheckedOut

IsDifferent

Export

SingleExport

Import


Item

Manual -> Programming interfaces -> Objectmodel -> ZenMenus -> ZenMenus-Methods -> Item

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This function returns a ZenMenu item. If there are more context and main menu items available the counting works like this: Item(0) = "Main_1", Item(1) = "Context_1", Item(2) = "Main_2", …

Datatype

Item(VARIANT vPosition) As ZenMenu

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Create

Manual -> Programming interfaces -> Objectmodel -> ZenMenus -> ZenMenus-Methods -> Create

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Creates a context menu or a main menu depending on the "IsPulldown" property of the zMenu object (False = context menu, True = main menu).

Datatype

Create(String bsName) As ZenMenu

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

A string which defines the name of the menu.

Example: "menu_1"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub CreateMenus()

Dim zMenus As ZenMenus 'Parent object
Dim zMenu As ZenMenu 'Child object

Set zMenus = MyWorkspace.ActiveDocument.ZenMenus

'Creates a context menu
Set zMenu = zMenus.Create("menu_1")
zMenu.IsPulldown = False

'Creates a main menu
Set zMenu = zMenus.Create("menu_2")
zMenu.IsPulldown = True

End Sub


Delete

Manual -> Programming interfaces -> Objectmodel -> ZenMenus -> ZenMenus-Methods -> Delete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

The defined menu will be deleted. As this function works via names there are no seperated properties for context or main menu selection. (context and main menu can not have the same names)

Datatype

Delete(String bsName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

The string defines the name of the menu which should be deleted.

Example: "main_menu"

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Sub DeleteMenus()

Dim zMenus As ZenMenus 'Parent object

Set zMenus = MyWorkspace.ActiveDocument.ZenMenus

'Delete context and main menus via their name
zMenus.Delete ("main_menu")
zMenus.Delete ("context_menu")

End Sub


Get

Manual -> Programming interfaces -> Objectmodel -> ZenMenus -> ZenMenus-Methods -> Get

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Get the latest version from the server (editor). This option is only working for multi-user projects.

Datatype

Get() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckOut

Manual -> Programming interfaces -> Objectmodel -> ZenMenus -> ZenMenus-Methods -> CheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Allow module modifications (editor). This option is only working for multi-user projects.

Datatype

CheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CheckIn

Manual -> Programming interfaces -> Objectmodel -> ZenMenus -> ZenMenus-Methods -> CheckIn

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Save module modifications to server (editor). This option is only working for multi-user projects.

Datatype

CheckIn() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


UndoCheckOut

Manual -> Programming interfaces -> Objectmodel -> ZenMenus -> ZenMenus-Methods -> UndoCheckOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Undo module modifications (editor). This option is only working for multi-user projects.

Datatype

UndoCheckOut() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsLocked

Manual -> Programming interfaces -> Objectmodel -> ZenMenus -> ZenMenus-Methods -> IsLocked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if modification changes are locked due to a checkout. This option is only working for multi-user projects.

Datatype

IsLocked() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsCheckedOut

Manual -> Programming interfaces -> Objectmodel -> ZenMenus -> ZenMenus-Methods -> IsCheckedOut

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if scripts are checked out. This option is only working for multi-user projects.

Datatype

IsCheckedOut() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


IsDifferent

Manual -> Programming interfaces -> Objectmodel -> ZenMenus -> ZenMenus-Methods -> IsDifferent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns true if local version differs from server (editor) version. This option is only working for multi-user projects.

Datatype

IsDifferent() As Boolean

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Export

Manual -> Programming interfaces -> Objectmodel -> ZenMenus -> ZenMenus-Methods -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Export settings to an xml file

Datatype

Export(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to export.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


SingleExport

Manual -> Programming interfaces -> Objectmodel -> ZenMenus -> ZenMenus-Methods -> SingleExport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SingleExport(VARIANT vIndexOrName,String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Import

Manual -> Programming interfaces -> Objectmodel -> ZenMenus -> ZenMenus-Methods -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Import settings from an xml file. New settings are added, existing settings will be replaced.

Datatype

Import(String bsFileName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Filename (path) as string of the xml file to import.

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bsFileName As String

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub zenOn_ExportImportSettings(ByRef zenOnObject As Object)
End Sub


ZenWorkspace

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This ClassModule represents the actual workspace in the editor.There are several events to react on actions of the projects within the workspace.

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Examples

C#

VB.NET

VB.NET-Syntax

VBA

Option Explicit
Private Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer
Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Private Const VK_LSHIFT = &HA0
Private Const VK_RSHIFT = &HA1

Private Sub ZenWorkspace_OnPostBuild(ByVal obProject As IProject)
Debug.Print "Runtimefiles for project '" & obProject.Name & "' are created!"
End Sub

Private Sub ZenWorkspace_OnPostTransport(ByVal obProject As IProject, ByVal bSuccess As Boolean)
Debug.Print "Runtimefiles for project '" & obProject.Name & "' were transported succesfully (" & bSuccess & ")!"
End Sub

Private Sub ZenWorkspace_OnPreBuild(ByVal obProject As IProject)
Debug.Print "Runtimefiles for project '" & obProject.Name & "' will be created!"
End Sub

Private Sub ZenWorkspace_OnPreTransport(ByVal obProject As IProject)
Debug.Print "Runtimefiles for project '" & obProject.Name & "' will be transported!"
End Sub

Private Sub ZenWorkspace_OnProjectLoaded(ByVal obProject As IProject)
Debug.Print "Project '" & obProject.Name & "' is loaded!"
End Sub

Private Sub ZenWorkspace_Startup()
If GetAsyncKeyState(VK_LSHIFT) <> 0 Then
SaveSetting "zenOn", "StartupScreen", "ShowOnStartup", "YES"
End If
If GetAsyncKeyState(VK_RSHIFT) <> 0 Then
SaveSetting "zenOn", "StartupScreen", "ShowOnStartup", "YES"
End If
If GetSetting("zenOn", "StartupScreen", "ShowOnStartup", "YES") = "YES" Then
frmStartup.Show
End If
'check vba references...
Call CheckVBAReferences
End Sub

Private Sub ZenWorkspace_OnElementCreated(ByVal obElement As Element)
Dim obMpElem As CD_ManipulationElement

Set obMpElem = New CD_ManipulationElement
Set obMpElem.Parent = Me
Debug.Print "Element of Type " & obElement.Type & " created."

''>> The codeline below will set defaults to elements when they are created.
'obMpElem.SetDefault obElement
''>> The Defaultsettings are located in the classmodule "CD_ManipulationElement"
End Sub

Private Sub ZenWorkspace_OnElementDoubleClicked(ByVal obElement As Element)
'Show Symbol Wizard for linked Symbols,
'if the symbol has outlined properties.
If obElement.Type = 130 Then
'symbol...
If SymbolHasProps(obElement) = True Then
'start wizard...
frmSymbol.InitWizard obElement
frmSymbol.Show
End If
End If
End Sub

Function SymbolHasProps(zELE As Element) As Boolean
Dim v As Variant
Dim i As Integer
Dim s As String
'check DynProperties of Symbol...
v = zELE.DynPropertiesEnum("")
For i = 0 To UBound(v)
s = v(i)
s = Mid(s, 1, InStr(1, s, ",") - 1)
If InStr(1, s, "\") <> 0 Then
SymbolHasProps = True
Exit Function
End If
Next i
End Function

Private Sub ZenWorkspace_OnObjectCreated(ByVal obObject As Object)
'this Event is fired, when a new object is created within a project...
Dim strObjectType As String
Dim obTemplate As Template
Dim obPicture As DynPicture
Dim obFunction As RtFunction
Dim obElement As Element
Dim obUser As User
Dim obRema As Rema
Dim obScript As Script
Dim obEdLimit As EdLimit
Dim obRGMRecipe As RGMRecipe
Dim obRecipe As Recipe
Dim obVarAssignment As VarAssignment
Dim obVariable As Variable
Dim obTimeFunction As TimeFunction
Dim ErrH As Label
On Error GoTo ErrH
'depending to the type of the created object, different actions can be done...
strObjectType = TypeName(obObject)
Select Case strObjectType
Case "ITemplate"
Set obTemplate = obObject
Debug.Print "Template created......> " & obTemplate.Name
Debug.Print "----- in Project......> " & obTemplate.Parent.Parent.Name
Case "IDynPicture"
Set obPicture = obObject
Debug.Print "Picture created.......> " & obPicture.Name
Debug.Print "---- in Project.......> " & obPicture.Parent.Parent.Name
Case "IRtFunction"
Set obFunction = obObject
Debug.Print "Function created......> " & obFunction.Name
Debug.Print "----- in Project......> " & obFunction.Parent.Parent.Name
Case "IElement"
Set obElement = obObject
Debug.Print "Element created.......> " & obElement.Name
Debug.Print "---- in Picture.......> " & obElement.Parent.Parent.Name
Debug.Print "---- in Project.......> " & obElement.Parent.Parent.Parent.Parent.Name
Case "IScript"
Set obScript = obObject
Debug.Print "Script created........> " & obScript.Name
Debug.Print "--- in Project........> " & obScript.Parent.Parent.Name
Case "IRema"
Set obRema = obObject
Debug.Print "REMA created..........> " & obRema.Name
Debug.Print "- in Project..........> " & obRema.Parent.Parent.Name
Case "IUser"
Set obUser = obObject
Debug.Print "User created..........> " & obUser.Name
Debug.Print "- in Project..........> " & obUser.Parent.Parent.Name
Case "IEdLimit"
Set obEdLimit = obObject
Debug.Print "Limit created.........> "
Debug.Print "---- Variable.........> " & obEdLimit.Parent.Name
Debug.Print "-- in Project.........> " & obEdLimit.Parent.Parent.Parent.Name
Case "IRGMRecipe"
Set obRGMRecipe = obObject
Debug.Print "RMG Recipe created....> " & obRGMRecipe.DynProperties("RecipeName")
Debug.Print "----- in RGM Group....> " & obRGMRecipe.Parent.DynProperties("Name")
Debug.Print "------- in Project....> " & obRGMRecipe.Parent.Parent.Parent.Name
Case "IRecipe"
Set obRecipe = obObject
Debug.Print "Recipe created........> " & obRecipe.Name
Debug.Print "--- in Project........> " & obRecipe.Parent.Parent.Name
Case "ITimeFunction"
Set obTimeFunction = obObject
Debug.Print "TimeFunction created..> " & obTimeFunction.Name
Debug.Print "--------- in Project..> " & obTimeFunction.Parent.Parent.Name
Case "IVarAssignment"
Set obVarAssignment = obObject
Debug.Print "VarAssignment created.> " & obVarAssignment.Name
Debug.Print "---------- in Project.> " & obVarAssignment.Parent.Parent.Name
Case "IVariable"
Set obVariable = obObject
Debug.Print "Variable created......> " & obVariable.Name
Debug.Print "----- in Project......> " & obVariable.Parent.Parent.Name
Case Else
Debug.Print strObjectType
End Select
Exit Sub
ErrH:
Debug.Print "[ERROR] " & Err.Number & " - " & Err.Description
Resume Next
End Sub

Other topics in this chapter

ZenWorkspace-Properties

ZenWorkspace-Methods

ZenWorkspace-Events


ZenWorkspace-Properties

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime | VBA | VSTA
IProject | ActiveDocument |  | read only | not used | yes | yes
IApplication | Application |  | read only | not used | yes | yes
BSTR | Name |  | read only | not used | yes | yes
IApplication | Parent |  | read only | not used | yes | yes
ISymbols | Symbols | Returns the Symbols object | read only | not used | yes | yes
IDispatch | VBE | Returns the VBE-extensibility object | available | not used | yes | yes

Other topics in this chapter

Application

Parent

ActiveDocument

Symbols

Name

VBE


Application

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Properties -> Application

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the Application object of the editor...

Datatype

Application() As Application

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes


Parent

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Properties -> Parent

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the parent object

Datatype

Parent() As Application

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes


ActiveDocument

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Properties -> ActiveDocument

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the activated project in the workspace as a project object.

Datatype

ActiveDocument() As Project

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes


Symbols

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Properties -> Symbols

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

Symbols() As Symbols

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes


Name

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Properties -> Name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the name of the ClassModule 'MyWorkspace'Always 'MyWorkspace'

Datatype

Name() As String

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes


VBE

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Properties -> VBE

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Returns the VBE-extensibility object

Datatype

VBE() As Dispatch

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes


ZenWorkspace-Methods

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description | Editor | Runtime
VARIANT_BOOL | ActivateProject | - | available | not used
VARIANT_BOOL | CloseWorkspace | Closes the workspace. | available | not used
VARIANT_BOOL | CopyProject | Creates a copy of the given Project at the given location. | available | not used
VARIANT_BOOL | CreateBackup | Creates a backup of the currently workspace. | available | not used
VARIANT_BOOL | CreateProjectBackup | Create a backup of the given project. | available | not used
VARIANT_BOOL | CreateWorkspace | Creates a new workspace with the given name at the given location. | available | not used
IMDITemplates | GetMDiTemplates | Returns a collection of MDI templates of the specified type (either by name or by index). | available | not used
VARIANT_BOOL | InsertProject | Inserts the given project into the workspace. | available | not used
VARIANT_BOOL | LoadProject | - | available | not used
VARIANT_BOOL | LoadProjectByName | Loads the given project by Name. | available | not used
VARIANT_BOOL | LoadWorkspace | Loads the given workspace file. | available | not used
VARIANT_BOOL | RemoveProject | Removes the given project from the workspace. | available | not used
VARIANT_BOOL | RestoreBackup | Restores the given workspace backup. | available | not used
VARIANT_BOOL | RestoreProjectBackup | Restores the given backup. | available | not used
VARIANT_BOOL | SaveWorkspace | Saves the current workspace. | available | not used
VARIANT_BOOL | SetStartProject | - | available | not used
VARIANT | UnloadedProjects [GET] | Returns a list of all unloaded projects available in the current workspace. | available | not used
VARIANT_BOOL | UnloadProject | - | available | not used
IArvTemplates | GetArvTemplates | Returns a collection of Archive templates (either by name or by index). | available | not used

Other topics in this chapter

LoadProject

LoadProjectByName

UnloadProject

ActivateProject

SetStartProject

CreateWorkspace

LoadWorkspace

SaveWorkspace

CloseWorkspace

CreateBackup

RestoreBackup

InsertProject

CreateProjectBackup

RestoreProjectBackup

RemoveProject

CopyProject

UnloadedProjects [GET]

GetMDiTemplates

GetArvTemplates


LoadProject

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> LoadProject

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Loads a project in the workspace over its uniqe GUID.

Datatype

LoadProject(String bsGuid) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


LoadProjectByName

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> LoadProjectByName

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

LoadProjectByName(String bsProjectName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


UnloadProject

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> UnloadProject

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Unloads a project in the workspace over its uniqe GUID.

Datatype

UnloadProject(String bsGuid) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


ActivateProject

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> ActivateProject

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Activates a project in the workspace over its uniqe GUID.

Datatype

ActivateProject(String bsGuid) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SetStartProject

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> SetStartProject

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SetStartProject(String bsGuid) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateWorkspace

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> CreateWorkspace

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreateWorkspace(String bsFileAndLocation) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


LoadWorkspace

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> LoadWorkspace

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

LoadWorkspace(String bsFileAndLocation) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


SaveWorkspace

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> SaveWorkspace

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

SaveWorkspace() As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CloseWorkspace

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> CloseWorkspace

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CloseWorkspace(Boolean bHideCompileDialog) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateBackup

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> CreateBackup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreateBackup(String bsFileAndLocation) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RestoreBackup

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> RestoreBackup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

RestoreBackup(String bsFileAndLocation, String bsWorkspaceLocation) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


InsertProject

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> InsertProject

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

InsertProject(String bsGuid, String bsName, String bsHost) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CreateProjectBackup

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> CreateProjectBackup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CreateProjectBackup(String bsProjectName, String bsFileAndLocation, String bsDescription, Boolean bOverWrite) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RestoreProjectBackup

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> RestoreProjectBackup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

RestoreProjectBackup(String bsFileAndLocation) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


RemoveProject

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> RemoveProject

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

RemoveProject(String bsProjectName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


CopyProject

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> CopyProject

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

CopyProject(String bsSource, String bsDestinationName) As Boolean

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


UnloadedProjects [GET]

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> UnloadedProjects [GET]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

UnloadedProjects() As VARIANT

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


GetMDiTemplates

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> GetMDiTemplates

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

GetMDiTemplates(VARIANT vType) As MDITemplates

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


GetArvTemplates

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Methods -> GetArvTemplates

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Return a ArvTemplate collection.

Datatype

GetArvTemplates() As IArvTemplates

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

VB.NET

VBA

Examples

C#

VB.NET

VBA

Private Sub GetTemplates()

Dim IArvTemplates As ArvTemplates

Dim IArvTemplate As ArvTemplate

Dim Count As Integer

Dim Ok As Boolean

' --- Auswahl über den Namen

Set IArvTemplates = MyWorkspace.GetArvTemplates()

If Not IArvTemplates Is Nothing Then

Set IArvTemplate = IArvTemplates.Item("Test 3")

Ok = PrintTemplate(IArvTemplate)

End If

' --- Auswahl über den Index

Set IArvTemplates = MyWorkspace.GetArvTemplates()

If Not IArvTemplates Is Nothing Then

Count = IArvTemplates.Count

For i = 0 To Count - 1

Set IArvTemplate = IArvTemplates.Item(i)

Ok = PrintTemplate(IArvTemplate)

Next

End If

End Sub

Private Function PrintTemplate(IArvTemplate As ArvTemplate) As Boolean

If Not IArvTemplate Is Nothing Then

Debug.Print ("Name: " & IArvTemplate.DynProperties("Name"))

Debug.Print ("GUID: " & IArvTemplate.DynProperties("GUID"))

Debug.Print ("ImportPath: " & IArvTemplate.DynProperties("ImportPath"))

Debug.Print ("Folder: " & IArvTemplate.DynProperties("Folder"))

Debug.Print ("Language: " & IArvTemplate.DynProperties("Language"))

Debug.Print ("Description: " & IArvTemplate.DynProperties("Description"))

Debug.Print ("CopaDataTemplate: " & IArvTemplate.DynProperties("CopaDataTemplate"))

PrintTemplate = True

Else

PrintTemplate = False

End If

End Function


ZenWorkspace-Events

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Type | Name | Description |  | Editor | Runtime | VBA | VSTA
void | OnElementCreated |  | read only |  | not used | yes |  | yes
void | OnElementDeleted |  | available |  | not used | yes |  | yes
void | OnElementDoubleClicked |  | available |  | not used | yes |  | yes
void | OnObjectCreated |  | available |  | not used | yes |  | yes
void | OnPostBackupProject | Event is fired after a project backup has been created. |  | available | not used | yes | yes
void | OnPostBuild | Event is fired after a project is compiled |  | available | not used | yes | yes
void | OnPostRestoreProject | Event is fired after a project backup has been restored. |  | available | not used | yes | yes
void | OnPostTransport | Event is fired after a project is transported |  | available | not used | yes | yes
void | OnPostVSTAUpdate | For internal use only | not used |  | not used | yes |  | yes
void | OnPreBackupProject | Event is fired before a project backup is about to be created. |  | available | not used | yes | yes
void | OnPreBuild | Event is fired before a project is compiled |  | available | not used | yes | yes
void | OnPreProjectUnload | Event is fired when a project is about to be unloaded (editor only). |  | available | not used | yes | yes
void | OnPreRestoreProject | Event is fired before a project backup is about to be restored. |  | available | not used | yes | yes
void | OnPreTransport | Event is fired before a project is transported |  | available | not used | yes | yes
void | OnPreVSTADebugStart | For internal use only | not used |  | not used | yes |  | yes
void | OnPreVSTADebugStop | For internal use only | not used |  | not used | yes |  | yes
void | OnPreVSTAUpdate | For internal use only | not used |  | not used | yes |  | yes
void | OnProjectLoaded | Event is fired when a project has been loaded (editor only). |  | available | not used | yes | yes
void | OnRTConnect | Event is fired when a remote transport connection has been established. |  | available | not used | yes | yes
void | OnRTConnectionFailed | Event is fired when a connection timeout has occured, and a remote transport connection could not be established. |  | available | not used | yes | yes
void | OnRTConnectionTerminated | Event is fired when a remote transport connection has been terminated. |  | available | not used | yes | yes
void | OnVSTADebugStart | For internal use only | not used |  | not used | yes |  | yes
void | OnVSTADebugStopped | For internal use only | not used |  | not used | yes |  | yes
void | OnWorkspaceExit |  | available |  | not used | yes |  | yes
void | OnWorkspaceStartup |  | available |  | not used | yes |  | yes

Other topics in this chapter

OnWorkspaceStartup

OnWorkspaceExit

OnElementCreated

OnElementDeleted

OnElementDoubleClicked

OnPreBuild

OnPostBuild

OnPreTransport

OnPostTransport

OnProjectLoaded

OnPreProjectUnload

OnObjectCreated

OnRTConnect

OnRTConnectionFailed

OnRTConnectionTerminated

OnPreRestoreProject

OnPostRestoreProject

OnPreBackupProject

OnPostBackupProject

OnPreVSTADebugStart

OnVSTADebugStart

OnPreVSTADebugStop

OnVSTADebugStopped

OnPreVSTAUpdate

OnPostVSTAUpdate


OnWorkspaceStartup

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnWorkspaceStartup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnWorkspaceStartup() As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub ZenWorkspace_OnWorkspaceStartup()
If GetAsyncKeyState(VK_LSHIFT) <> 0 Then
SaveSetting "zenOn", "StartupScreen", "ShowOnStartup", "YES"
End If
If GetAsyncKeyState(VK_RSHIFT) <> 0 Then
SaveSetting "zenOn", "StartupScreen", "ShowOnStartup", "YES"
End If
If GetSetting("zenOn", "StartupScreen", "ShowOnStartup", "YES") = "YES" Then
frmStartup.Show
End If
'check vba references...
Call CheckVBAReferences
End Sub


OnWorkspaceExit

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnWorkspaceExit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnWorkspaceExit() As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnElementCreated

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnElementCreated

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a new element is created within a picture.

Datatype

OnElementCreated(Element obElement) As void

Availability

Environment | Available
Editor | read only
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Returns an object of type Element

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

obElement As Element

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub ZenWorkspace_OnElementCreated(ByVal obElement As Element)
Dim obMpElem As CD_ManipulationElement

Set obMpElem = New CD_ManipulationElement
Set obMpElem.Parent = Me
Debug.Print "Element of Type " & obElement.Type & " created."

''>> The codeline below will set defaults to elements when they are created.
'obMpElem.SetDefault obElement
''>> The Defaultsettings are located in the classmodule "CD_ManipulationElement"
End Sub


OnElementDeleted

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnElementDeleted

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a element is deleted within a picture.

Datatype

OnElementDeleted(Element obElement) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnElementDoubleClicked

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnElementDoubleClicked

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a element has been double-clicked.

Datatype

OnElementDoubleClicked(Element obElement) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnPreBuild

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnPreBuild

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when the runtimefiles for a project will be built.

Datatype

OnPreBuild(Project obProject) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Returns an object of type Project

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

obProject As Project

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub ZenWorkspace_OnPreBuild(ByVal obProject As IProject)
Debug.Print "Runtimefiles for project '" & obProject.Name & "' will be created!"
End Sub


OnPostBuild

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnPostBuild

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when the runtimefiles for a project were built.

Datatype

OnPostBuild(Project obProject) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Returns an object of type Project

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

obProject As Project

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub ZenWorkspace_OnPostBuild(ByVal obProject As IProject)
Debug.Print "Runtimefiles for project '" & obProject.Name & "' are created!"
End Sub


OnPreTransport

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnPreTransport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when the runtimefiles should be transported to a remote pc.

Datatype

OnPreTransport(Project obProject) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Returns an object of type Project

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

obProject As Project

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub ZenWorkspace_OnPreTransport(ByVal obProject As IProject)
Debug.Print "Runtimefiles for project '" & obProject.Name & "' will be transported!"
End Sub


OnPostTransport

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnPostTransport

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when the runtimefiles have been transported to a remote pc.

Datatype

OnPostTransport(Project obProject, Boolean bSuccess) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Boolean return value, returns true if the transport was successfully.

Returns an object of type Project

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

bSuccess As Boolean

obProject As Project

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub ZenWorkspace_OnPostTransport(ByVal obProject As IProject, ByVal bSuccess As Boolean)
Debug.Print "Runtimefiles for project '" & obProject.Name & "' were transported succesfully (" & bSuccess & ")!"
End Sub


OnProjectLoaded

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnProjectLoaded

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired, when a project was loaded.

Datatype

OnProjectLoaded(Project obProject) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnPreProjectUnload

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnPreProjectUnload

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnPreProjectUnload(Project obProject) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnObjectCreated

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnObjectCreated

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

This event is fired when a new object is created.A new object could be:

Datatype

OnObjectCreated(Dispatch obObject) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

Object, the type depends to the created object (Variable,Screen,...)

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

obObject As Dispatch

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

Private Sub ZenWorkspace_OnObjectCreated(ByVal obObject As Object)
'this Event is fired, when a new object is created within a project...
Dim strObjectType As String
Dim obTemplate As Template
Dim obPicture As DynPicture
Dim obFunction As RtFunction
Dim obElement As Element
Dim obUser As User
Dim obRema As Rema
Dim obScript As Script
Dim obEdLimit As EdLimit
Dim obRGMRecipe As RGMRecipe
Dim obRecipe As Recipe
Dim obVarAssignment As VarAssignment
Dim obVariable As Variable
Dim obTimeFunction As TimeFunction
Dim ErrH As Label
On Error GoTo ErrH
'depending to the type of the created object, different actions can be done...
strObjectType = TypeName(obObject)
Select Case strObjectType
Case "ITemplate"
Set obTemplate = obObject
Debug.Print "Template created......> " & obTemplate.Name
Debug.Print "----- in Project......> " & obTemplate.Parent.Parent.Name
Case "IDynPicture"
Set obPicture = obObject
Debug.Print "Picture created.......> " & obPicture.Name
Debug.Print "---- in Project.......> " & obPicture.Parent.Parent.Name
Case "IRtFunction"
Set obFunction = obObject
Debug.Print "Function created......> " & obFunction.Name
Debug.Print "----- in Project......> " & obFunction.Parent.Parent.Name
Case "IElement"
Set obElement = obObject
Debug.Print "Element created.......> " & obElement.Name
Debug.Print "---- in Picture.......> " & obElement.Parent.Parent.Name
Debug.Print "---- in Project.......> " & obElement.Parent.Parent.Parent.Parent.Name
Case "IScript"
Set obScript = obObject
Debug.Print "Script created........> " & obScript.Name
Debug.Print "--- in Project........> " & obScript.Parent.Parent.Name
Case "IRema"
Set obRema = obObject
Debug.Print "REMA created..........> " & obRema.Name
Debug.Print "- in Project..........> " & obRema.Parent.Parent.Name
Case "IUser"
Set obUser = obObject
Debug.Print "User created..........> " & obUser.Name
Debug.Print "- in Project..........> " & obUser.Parent.Parent.Name
Case "IEdLimit"
Set obEdLimit = obObject
Debug.Print "Limit created.........> "
Debug.Print "---- Variable.........> " & obEdLimit.Parent.Name
Debug.Print "-- in Project.........> " & obEdLimit.Parent.Parent.Parent.Name
Case "IRGMRecipe"
Set obRGMRecipe = obObject
Debug.Print "RMG Recipe created....> " & obRGMRecipe.DynProperties("RecipeName")
Debug.Print "----- in RGM Group....> " & obRGMRecipe.Parent.DynProperties("Name")
Debug.Print "------- in Project....> " & obRGMRecipe.Parent.Parent.Parent.Name
Case "IRecipe"
Set obRecipe = obObject
Debug.Print "Recipe created........> " & obRecipe.Name
Debug.Print "--- in Project........> " & obRecipe.Parent.Parent.Name
Case "ITimeFunction"
Set obTimeFunction = obObject
Debug.Print "TimeFunction created..> " & obTimeFunction.Name
Debug.Print "--------- in Project..> " & obTimeFunction.Parent.Parent.Name
Case "IVarAssignment"
Set obVarAssignment = obObject
Debug.Print "VarAssignment created.> " & obVarAssignment.Name
Debug.Print "---------- in Project.> " & obVarAssignment.Parent.Parent.Name
Case "IVariable"
Set obVariable = obObject
Debug.Print "Variable created......> " & obVariable.Name
Debug.Print "----- in Project......> " & obVariable.Parent.Parent.Name
Case Else
Debug.Print strObjectType
End Select
Exit Sub
ErrH:
Debug.Print "[ERROR] " & Err.Number & " - " & Err.Description
Resume Next
End Sub


OnRTConnect

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnRTConnect

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnRTConnect(Project obProject) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnRTConnectionFailed

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnRTConnectionFailed

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnRTConnectionFailed(Project obProject) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnRTConnectionTerminated

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnRTConnectionTerminated

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnRTConnectionTerminated(Project obProject) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnPreRestoreProject

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnPreRestoreProject

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnPreRestoreProject(String bsGuid, String bsName,String bsFile) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnPostRestoreProject

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnPostRestoreProject

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnPostRestoreProject(String bsGuid, String bsName,String bsFile,Boolean bSuccess) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnPreBackupProject

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnPreBackupProject

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnPreBackupProject(String bsGuid, String bsName,String bsFile) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnPostBackupProject

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnPostBackupProject

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnPostBackupProject(String bsGuid, String bsName,String bsFile,Boolean bSuccess) As void

Availability

Environment | Available
Editor | available
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnPreVSTADebugStart

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnPreVSTADebugStart

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnPreVSTADebugStart() As void

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnVSTADebugStart

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnVSTADebugStart

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnVSTADebugStart() As void

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnPreVSTADebugStop

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnPreVSTADebugStop

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnPreVSTADebugStop() As void

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnVSTADebugStopped

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnVSTADebugStopped

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnVSTADebugStopped() As void

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnPreVSTAUpdate

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnPreVSTAUpdate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnPreVSTAUpdate() As void

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


OnPostVSTAUpdate

Manual -> Programming interfaces -> Objectmodel -> ZenWorkspace -> ZenWorkspace-Events -> OnPostVSTAUpdate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Remarks

Datatype

OnPostVSTAUpdate() As void

Availability

Environment | Available
Editor | not used
Runtime | not used
VBA | yes
VSTA | yes

Parameters

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax

Examples

C#

C#-Syntax

VB.NET

VB.NET-Syntax

VBA

VBA-Syntax


Project backup

Manual -> Project backup

A project consits of Editor and Runtime files. A transfer of the Runtime files is e.g. possible with Remote Transport. This chapter deals with backing up and restoring the Editor files of a project.

The project backup creates a ZIP file with the saved project. This backup then can be restored to the same or another computer. Project backups can also be versioned.

In the Project Manager there is an own node 'Project backup'. Also see chapter Project Manager. In the context menu of this entry you can select between 'Create backup' and 'Restore backup'.

attention Attention

Project backups created with zenon and SQL Server Express (SQL Server 2005) cannot be restored to a MSDE database server (or SQL Server 2000)!

attention Attention

Symbols from the General symbol library are saved locally in their own file (*.sym) in the zenon program folder. These files must always be added manually to back-up the project with multi-user projects and when forwarding projects. Symbols from the symbol library in the local project and the global project are automatically included in the respective project backup.

Hint: Always save symbols locally.

Project manager context menu

Menu item | Action
Create backup | Opens the dialog for creating a project backup.
Import backup | Opens the file manager for selecting a backup file and importing this file in the list.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.

tutorial License information

Part of the standard license of the Editor and Runtime.


Engineering in the Editor

Manual -> Project backup -> Engineering in the Editor

Project backups are created administered and restored in the Project backups node.

You can:

  • Create and export project backups
  • Restore project backups
  • Backup and restore workspaces
  • Delete projects

If the Project backup node is selected in the Project Manager, all existing backup files are displayed in the Detail view of the project manager.


Project backup detail view toolbar and context menu

Manual -> Project backup -> Engineering in the Editor -> Project backup detail view toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu

Menu item | Action
Create backup | Opens the dialog for creating a project backup.
Load backup | Restore the project to the condition saved in the backup file.
Restore project backup as new project | Created a new project with the data auf the backup.
Delete | Deletes selected entries after a confirmation from list.
Export backup | Opens the dialog for selecting the folder for the backup file and exports the backup file.
Import backup | Opens the file manager for selecting a backup file and importing this file in the list.
Compare selected backup in the history of changes | Only active for multi-selection. The oldest and the latest version are determined. From this a time filter is created with which you change to the history of changes where differences of the selected project backup are compared.
Remove all filters | Removes all filter settings.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Properties | Opens the Properties window for the selected entry.
Help | Opens online help.


Project backup and export

Manual -> Project backup -> Engineering in the Editor -> Project backup and export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Backup project

In order to create a project backup, right-click onProject backup in the Project manager and select Create backup .

The dialog for project backup is opened:

Parameters | Description
File name | Name of the ZIP file for the project backup
Description | Free text as comment.
OK | Accepts inputs and creates project backup.
Cancel | Cancels the backup.
Help | Opens online help.

attention Attention

As the service zenDbSrv.exe only runs with local rights and not with the rights of the logged in user, a backup to a network drive is not possible!

zenon puts the project backup in its own predefined database folder (SQL):

%ProgramData%\COPA-DATA\[SQL-folder]\UID]\BACKUP

info Information

At the backup of the workspace, all projects of the workspace are backed up, too. They are however not contained in the project back up and cannot be restored individually.

Export project

You can export your backups at any time form zenon (e.g. for sending it or transporting it to another computer). Right click the desired project backup and select Export backup in the context menu. In the following dialog, choose the folder and confirm with OK.

If the project backup takes more than 1 second, a progress display appears.
Informations about the backup (e.g. failure/success) can be found in the output window.

You can display all the backups of a project in the detail view by clicking on Project backups in the Project manager.

(See also Project manager, Detail view of the Project manager)


Restore project backup

Manual -> Project backup -> Engineering in the Editor -> Restore project backup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Project backup can be read back via:

  • the workspace
  • the node project backup

attention Attention

zenon projects in version 6.20 or older can no longer be directly read back in zenon 7.10 or higher.

Background: Versions that are based on the MSDE (SQL Server 2000) are not compatible with the SQL Server 2012 used in zenon.

Solution: First convert in zenon 7.0 and then in 7.10 or higher.

Workspace

  1. in the context menu of the workspace select command Read back project backup...
  2. the selection dialog for selecting the project backup is opened

Parameters

Description

Backup file

Selection of the file which is to be read back.

A click on the ... button opens the file selection dialog.

create a new project

Active: a new project is created in the database.

Backup details

Information about the project which should be read back:

  • Name
  • Project ID
  • Editor version
  • Project version (only if Versioning is active)
  • Description

All data are taken from the project which should be read back and serve only informational purposes. You cannot change them in this dialog.

OK

Data are taken over and the selected project is read in.

Cancel

Discards all data and closes dialog.

Help

Opens online help.

Node project backup

  1. navigate to the Project backup node
  2. Select the desired project backup
    Note: If the desired backup is not available, import it.
  3. select Restore backup... in the context menu or in the tool bar
  4. the project backup is read back after a confirmation request and is activated automatically

attention Attention

Projects

  • created with SQL Server 2005 Express can not be used with SQL Server 2000 (MSDE)
  • created with SQL Server 2008 R2 can not be used with SQL Server 2005 Express

Import project backup

In node Project backup of the project manager select Import backup from the context menu. First the project is imported and then restored in the next step.

At first there is a check whether the desired backup file of the project already exists. If the backup does not exist, the imported file is added to the list of backups. All projects, which have been imported but not yet restored, are added to the list of backups in the detailview of the project manager.

This is where you will find a list of all backups created for the project. The comments can be changed in the list.

Export and import the project backup

It can be necessary to export or import a project backup if the Editor files of a project should be used on another PC. In case of an export the backup file from folder %ProgramData%\COPA-DATA\[SQL folder]\Projectname is copied to another device (e.g. USB stick). Both export and import are copy actions and not move actions.

Delete project backup

The backup files are deleted from folder %ProgramData%\COPA-DATA\[SQL folder]\Projectname.

Troubleshooting

Errors | Solution
Project backup is not displayed. | Node project backup lists only the projects which are contained in the default SQL/backup folder. Projects from other folders can be imported manually.
Button OK cannot be operated in read back dialog. | The selected ZIP file contains invalid data. Maybe a workspace backup or another ZIP file has been selected.
History of the project backup is no longer available. | The project was renamed and therefore the history is no longer available. The backup file is however still available and can be imported manually or can be read back via the context menu of the workspace.


Backup and restore of workspaces

Manual -> Project backup -> Engineering in the Editor -> Backup and restore of workspaces

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Creating a backup of a workspace

Select the entry Workspace -> Create backup from the context menu of the workspace. Backups of workspaces are saved as *.wsb files. The name can freely be defined.

Note: Together with the workspace all projects of the workspace are backed up. They are however not contained in the project back up and cannot be restored individually.

Load backup

With opened/closed workspace:

Select the entry Workspace / Restore backup from the context menu of the workspace. You now can select a backup and define the folder, to which the workspace should be restored.


Delete project

Manual -> Project backup -> Engineering in the Editor -> Delete project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To delete a project, choose the entry project / delete in the context menu of the project.

attention Attention

When a project is deleted, all open database connections are closed. When an existing project is reloaded, this is not the case.


Versioning

Manual -> Project backup -> Versioning

Project backups can also be versioned. Versions are identified and sorted according to numbering and date/time of their creation.

To activate versioning:

  1. navigate to the General node in properties
  2. navigate to area Versioning
  3. Activate the Versioning active property
  4. Assign a main number to property Main version

With this for each project backup a number for the project version is created. It consists of the Main version and an internally assigned detail number separated by a point. This detail number is incremented for each project backup. The version of a project backup is displayed in:

  • the detail view of node project backup
  • in the dialog for restoring a backup in the workspace

The number of the Project version is checked at the transfer of the Runtime files with Remote Transport or via the network topology and can be read via VBA or a system driver variable. If another version is loaded in the Editor, a warning is displayed. If there is a conflict during transfer of the Runtime files via the network, you accept or decline the transfer for all projects which are transferred to the computer and at which conflicts exist.

The current project can also be added to the project backup as XML export.

info Information

Versioning also works with distributed engineering. At this file project.ini must be locked for changes for a backup at the server. XML files are only saved for local backups.

Backup of the correct sorting order.

In versioning you can release the Main version. Based on this main number the detail number is automatically incremented from 0 for each backup. If Main version is changed, distributing the detail number starts again from 0.

Pay attention to consistent Main version and consistent versioning. As user can freely change the Main version, there is the possibility:

  • of a random order

    e.g. 2.1 is followed bei 1.0

  • of using the same number several time

    e.g. 1.0, 1.1, 1.2, 1.0

  • of temporarily turning of the versioning

    That means: Project backups without version number are mixed with versioned backups

To provide an overview over the order of the individual project backups, the creation time of a backup is also saved in the project.ini.

XML export

If property XML export active is active, a compressed file VERSION.ZIP is created within the project backup. As XML export it contains data from:

  • Variables
  • Data types
  • Reaction matrices
  • Allocations
  • Alarms
  • Units
  • Screens
  • Frames
  • Font lists
  • Color palettes
  • Project Symbol Library
  • Functions
  • Historian
  • Recipes
  • Recipegroup Manager
  • Time control
  • VBA macros
  • Interlockings
  • Command input
  • EMS
  • Menus
  • User administration
  • User groups
  • SAP interface

The content of the file equals the content of the manually exported XML.

The content of this XML file matches the content of the common XML export. For multi-user project XML exports are only created for local backups.

System driver variable

Similar to the Project version property, there is a project version system driver variable in the System info chapter.


Troubleshooting

Manual -> Project backup -> Versioning -> Troubleshooting

Errors at versioning are displayed and processed in the log file, in the output window and in pop-up messages.

Diagnosis Viewer

Entries in log files:

Entry | Description
Error BackupDatabase: Skip on an Error in BackupXml: [Path] | Error on creating VERSION.ZIP with the XML export files during project back up. The back up was created but the XML files are missing.
GetDBBackupStatus: BINARY.ZIP not exists: [Path] | When reading the versioning of a project back up, file BINARY.ZIP was not found. The back up is damaged.
GetDBBackupStatus: project.ini not exists: [Path] | When reading the versioning of a project back up, file project.ini was not found. The back up is damaged.

Output window

Entries in the output window:

Output window entry

Explanation; what does it mean?

The transfer of project '%s' was declined

Two possible reasons:

  • At version checking a conflict occurred and the user declined the transfer.
  • At version checking an error occurred.

No project directory defined

Error during version check.

Pop-up message

Error messages in pop-ups:

Error message

Description

The version %d.%d of the project at the target computer do not match: Should it be transferred anyway?

At transporting the Runtime files with Remote Transport:

For the project the versioning was activated and the version number of the project in the Editor does not match with the version number in file project.ini at the target computer.

Available reactions:

  • Yes:
  • No: no transfer

At computer %s the version %d.%d of the project does not concur: Should it be transferred anyway?

At transporting the Runtime files with network topology:

For one or more projects the versioning was activated and the version number of the project in the Editor does not match with the version number in file project.ini at the target computer.

Available reactions:

  • Yes: Transfer is continued
  • No: no transfer
  • Yes, all: Transfer is continued without further request for all projects concerned
  • No, all: Transfer is canceled without further request for all projects concerned

This dialog is again displayed if during the transfer to another target computer, a version conflict occurrs again.

The project cannot be saved because 'project.ini' is locked!

At creating a project backup for multi-user projects with versioning, the version number in file project.ini must be incremented. This is not possible because file project.ini is locked.


Project conversion

Manual -> Project conversion

When using new version of zenon projects which were created with earlier versions must be converted to the new version. If certain properties or changes bust be considered at converting, they are described in the hints for converting in this manual.

tutorial License information

Part of the standard license of the Editor and Runtime.

Converting at update and downgrade

If you want to update zenon to a higher version, projects are converted automatically to the higher version when opened in the new version. From this time you cannot edit the project with earlier versions of the Editor. However a project backup is created automatically of the converted project in the original version.

Converting a project to an earlier version which was created with a older version (downgrade) is not possible.

Backward compatibility

As of version 6.21 projects are downward compatible for the Runtime. You can work in an Editor with a higher version number. This Runtime backwards compatibility is particularly suited for use of mixed versions such as: A project which was engineered with version 6.50 can be used in a Runtime with version 6.22.

attention Attention

If, in a project with a later version of the Editor, properties are shown that are not available in the earlier version, it can lead to undesired results in the Runtime.


Recommended procedure for converting Runtime files

Manual -> Project conversion -> Recommended procedure for converting Runtime files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

At the project conversion take care that the Runtime changeable files are also converted correctly.

To convert the Runtime changeable files:

  1. Import the files from the Runtime to the original version of the Editor.
  2. Carry out the update to the new version.
  3. Navigate to the General section in project properties.
  4. Click on the RT changeable data property.
  5. The dialog for the settings of the Runtime changeable files is opened.

  6. Deactivate all check boxes in column Do not generate and transfer
  7. Compile the project (Create all Runtime files)
  8. Change the check box in the RT changeable data property back to the status before the conversion


Converting from version 2.20 to 3.04

Manual -> Project conversion -> Converting from version 2.20 to 3.04

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


Restructuring the database

Manual -> Project conversion -> Converting from version 2.20 to 3.04 -> Restructuring the database

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
  1. Create a temporary directory and a subdirectory. Name of the subdirectory: XX. For example: C:\\TEMP\\XX where C:\\TEMP is the path of the original database and C:\\TEMP\\XX is the path for the restructured database. Do not forget to make a backup of your original database.
  2. Copy the original database and REV.BAT and DATAMGR.RDL to C:\\TEMP.
  3. Copy the new DBD files (of the new database) and the file DBAREORG.EXE to the XX directory.
  4. Set the paths to the folder, where DBREV.EXE and INITDB.EXE are, or copy these files to C:\\TEMP and also to C:\\TEMP\\XX. Check if these two programs can be started in the DOS window without entering their path.
  5. Make sure, that enough space (min. 500 K) is available in the DOS memory area.
  6. Execute the batch file REV.BAT in the DOS window:

    Contents:

    del *.taf

    del *.log

    cd xx

    del *.taf

    del *.log

    initdb datamgr

    cd..

    dbrev -r -v -q -s datamgr.rdl datamgr xx/datamgr
  7. Start DBAREORG.EXE in the directory zenon directly from Windows (execute file).
  8. Define the directory where the database is (XX) with CONVERT 2xx -> 3xx and PATH SETTINGS.
  9. Start restructuring with CONVERT 2xx -> 3xx and CONVERT.
  10. Restructuring is finished. The new database is in the XX path. If existing please delete the TAF files from the XX directory. The original database still is in the TEMP directory.
  11. If restructuring is not successful on the first attempt, you have to restart with step 1. Otherwise the restructured database would be converted another time.

Result of restructuring | all screens are converted
 | all variables are converted
 | all functions are converted, but the functions have to be relinked. Exception: the “Switch to screen” function no longer needs to be relinked.
 | a log file (DBAREORG.LOG) is created in the folder from which DBAREORG.EXE has been started. There you can find information on the unlinked functions.


Restructuring the database when the structures changed

Manual -> Project conversion -> Converting from version 2.20 to 3.04 -> Restructuring the database -> Restructuring the database when the structures changed

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
  1. Create a temporary subdirectory. Name of the subdirectory: XX
  2. Copy the new DBD files to the XX directory.
  3. Execute the batch file REV.BAT:

    Contents:

    del *.taf

    del *.log

    cd xx

    del *.taf

    del *.log

    initdb datamgr

    cd..

    dbrev -r -v -q datamgr xx/datamgr


Converting from version 3.4, 3.50 to 3.52

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


Operating system

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52 -> Operating system

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Version 3.52 only runs under Windows NT 4.0 and WIN 95.


AML/CEL-Export

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52 -> AML/CEL-Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The export name of alarm and CEL entries has changed. Now Ayymmdd.TXT or Cyymmdd.TXT. For the export there is a new function, which can be executed e.g. with time control. The old settings are omitted.


AML / CEL, Archives

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52 -> AML / CEL, Archives

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Now archives for alarm list and CEL are stored as a default. These day archives have no file limitations. For this reason you should engineer a delete function. With this you make sure that not the whole storage capacity of the hard-disk is filled with archives (see function file operations). The available memory for reading archives is limited with the following entry in the zenon6.ini.

[ARCHIV]

...

SPEICHER=1000 (default=1000, that is 1MB)


Network operation

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52 -> Network operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The drivers have to be set to local. In the section [Befehlsgabe] of the zenon6.ini the entry Treiber= has to be deleted.


Archives

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52 -> Archives

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Archives now are stored in a subdirectory of the project path. On the first start existing ARV files are moved there.


Layer

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52 -> Layer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In DXF import layers are no longer supported. Layers now are called symbols.


Arcs

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52 -> Arcs

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Arcs have been replaced by segments of circles. Existing arcs retained until changes are made.


Backward compatibility

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52 -> Backward compatibility

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Version 3.52 is not downwards compatible. (Concerns e.g. zenon.ini, symbols and functions administration)


Database

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52 -> Database

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A new database structure file is delivered. (DATAMGR.DBD,20.11.1996,14.759 byte)

This file is needed for lot archives and has to be copied to the project directory.

Delete *.TAF and *.LOG files in the project directory.


Backup documentation (QRF inquiries)

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52 -> Backup documentation (QRF inquiries)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the QRF files the inquiries for VARIABLE and LANGTEXT have been changed.

  • field VARIABLE = dwkanalNr translate using 1 display as left (30);
  • field LANGTEXT = dwkanalNr translate using 6 display as left (39);


American time formats

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52 -> American time formats

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As a time format AM/PM is not supported.


Alarm printer

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52 -> Alarm printer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If the alarm printer fails, the control system now automatically switches to the Windows standard printer. If no print out should happen, the alarm printer in the Editor has to be deleted.


Symbols

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52 -> Symbols

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

After rescaling symbols have to be resolved and relinked before storing them in the symbol library. Bitmaps in symbols have to be stored separately. Symbol files are saved in folder ../zenon.


Zoom function

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52 -> Zoom function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zoom function may be used to check or edit elements.


Project backup

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52 -> Project backup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A database now consists of the following files:

*.vbf

*.idx

*.DAT

*.BIN

*.dbd

*.INI

*.mdb

*.MIB (for NWM III)

*.NWM (for NWM III)

*.EMS (for 230 EMS)

For saving the archives (*.ARV, *.CEL, *.AML) the according subdirectory has to be regarded.

attention Attention

The file ALARM.BIN in the archive directory saves the last contents of the alarm list when closing the Runtime and should not be saved.


Filter for system windows

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52 -> Filter for system windows

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

We recommend checking the filters for the system screens with the new functionalities (e.g. scheduler, archives for AML/CEL).


Export variable

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52 -> Export variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For usingthe export file under dBase, Foxpro the max. column width for variable name and identification (long text) has to be limited from 128 characters to max. 100 characters.

Therefore the following zenon6.ini entry is necessary:

[EXPORT]

MAX_LAENGE= z. B. 40


Element Link text

Manual -> Project conversion -> Converting from version 3.4, 3.50 to 3.52 -> Element Link text

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In old projects texts are no longer centered but left aligned. This can be changed in the element parameters. If this leads to extensive changes in existing projects, please proceed in the following way:

  1. enter [Editor] Konvert=1 in the zenon6.ini
  2. Set the option old text elements in the Editor under Open screen; then open the according screen and save it. Repeat this procedure for each screen concerned.
  3. delete [Editor] Konvert=1 in the zenon6.ini


Converting from version 3.52 to 5.11

Manual -> Project conversion -> Converting from version 3.52 to 5.11

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


Things to be done in version 3.52

Manual -> Project conversion -> Converting from version 3.52 to 5.11 -> Things to be done in version 3.52

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


Preparatory works

Manual -> Project conversion -> Converting from version 3.52 to 5.11 -> Things to be done in version 3.52 -> Preparatory works

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

We recommend to create a backup of the project in the old version.

The project database should be checked with the provided tool DBCHECK in version 3.52. If any errors occur during the check, they can be fixed with the also provided tool DBFIX in version 3.52.


Rotated texts

Manual -> Project conversion -> Converting from version 3.52 to 5.11 -> Things to be done in version 3.52 -> Rotated texts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Rotated texts behave differently in version 3.52 and version 5.50 – as far as positioning is concerned – and have to be edited.

In order to get a display compatible to version 3.52, the following entry in the project.ini has to be set:

[VERSION]

TEXT352=1


Screen names with special characters

Manual -> Project conversion -> Converting from version 3.52 to 5.11 -> Things to be done in version 3.52 -> Screen names with special characters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Screen names must not contain special characters such as / / : * ? < > | Ä Ö Ü because the screens are saved as files. The Windows operating system does not allow such special characters.

If existing screen names contain such special characters, these screen names have to be changed in the old version e.g. 3.52, before the screens can be converted to version 5.x.

attention Attention

Additionally all functions containing invalid screen names have to be changed.

If these changes are not done, the according screens are not converted and are not available in version 5.x.

attention Attention

If in a 3.5x project there are missing frames or empty allocations, the following error message opens on starting the Runtime 5.11: It was tried to access a file behind the end of the file and the Runtime crashed.

So before conversion old 3.5x projects have to be checked on missing frames or empty allocations.


Things to be done in version 5.11

Manual -> Project conversion -> Converting from version 3.52 to 5.11 -> Things to be done in version 5.11

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon version 5.11 must be installed.


Licensing

Manual -> Project conversion -> Converting from version 3.52 to 5.11 -> Things to be done in version 5.11 -> Licensing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The license numbers of version 5.x are not compatible with the license numbers of previous versions. For updates new license numbers have to be ordered and entered in the Editor. Licenses for all versions up to 3.52 stay untouched, as the new serial numbers are stored in new entries in the zenon.ini.

[DEFAULT]

SERIAL5=xxx

ACTIVATIONKEY5=xxx

No login name can be stored in the start buttons any more.

An existing Project has to be inserted into a new workspace.

The simulation driver now works with the same driver model as all other drivers. Under Driver/Configuration Hardware has to be selected.

After loading the 3.52 project and converting the screens the correct monitor profile has to be selected and the Editor has to be restarted.

In the zenon.ini there is an entry defining the size of the driver buffer. As a rule of thumb we recommend Number of variables * 10.

[RT]

DRIVER_QUE =50000

If the value is too small, this can result in update problems in the visualization.

We recommend to alarm an overflow. There is a system driver variable for this: Project info/Driver queue.


Converting from version 3.52 to 5.x or 6.x

Manual -> Project conversion -> Converting from version 3.52 to 5.x or 6.x

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


Convert dynamic element switch

Manual -> Project conversion -> Converting from version 3.52 to 5.x or 6.x -> Convert dynamic element switch

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Switches which were created in a project of version 3.52 must be converted via XML export when switching to a higher zenon version.

Procedure in the new zenon version:

  1. Context menu screens -> XML export all
  2. Export screens in new file
  3. Context menu screens ->Import XML
  4. select exported file and import it


Converting from version 5.11 to 5.50

Manual -> Project conversion -> Converting from version 5.11 to 5.50

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


Things to be done in version 5.11

Manual -> Project conversion -> Converting from version 5.11 to 5.50 -> Things to be done in version 5.11

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

We recommend to create a backup of the project before converting it. The Editor data and the Runtime changeable data have to be saved.

The project database should be checked and repaired if necessary. You will find more information on this on the installation CD under Software\\TOOLS\\DB_TOOLS\\DB_DOKU.DOC.


Things to be done in version 5.50

Manual -> Project conversion -> Converting from version 5.11 to 5.50 -> Things to be done in version 5.50

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon version 5.50 must be installed.

After starting the Editor the old workspace can be opened. The projects then are converted automatically.

After creating the Runtime files the Runtime can be started.


Converting from version 5.50 to 6.01

Manual -> Project conversion -> Converting from version 5.50 to 6.01

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

attention Attention

Not translated keywords in the language table are deleted during the conversion process.


Things to be done in version 5.50

Manual -> Project conversion -> Converting from version 5.50 to 6.01 -> Things to be done in version 5.50

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Before the converting can be carried out, the data must be read back to the engineering computer. After that the converting may be started.

In the properties window of the project under 'General' you can find the dialog 'RT changeable data'. Here you determine which data should be changed. For more information refer to chapter RT changeable data.


Function names

Manual -> Project conversion -> Converting from version 5.50 to 6.01 -> Things to be done in version 5.50 -> Function names

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You have to care, that the functions names are unique. As no function names have to be defined in version 5.50, zenon does not check the uniqueness. This is not necessary for version 5.50. In version 6.x however the functions are identified by their names.


Projects

Manual -> Project conversion -> Converting from version 5.50 to 6.01 -> Things to be done in version 5.50 -> Projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Before a 5.50 project can be opened in the Editor version 6, it has to be converted. (File - Insert project 5.50...). The old project stays unaffected and a copy of it is created in the SQL server. Please be aware, that some external files and directories are not automatically added to the new Editor and Runtime directory structure. These files/directories have to be adapted or inserted into the project manually (in the project tree / Files)

This is true for e.g.: user-defined subdirectories in the project directory, extended list directories, databases, export folders, etc….


Runtime changeable project data (users, recipes, etc.)

Manual -> Project conversion -> Converting from version 5.50 to 6.01 -> Things to be done in version 5.50 -> Runtime changeable project data (users, recipes, etc.)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Have to be read back to the Editor before the conversion, so that no changes done in the Runtime get lost.


Data

Manual -> Project conversion -> Converting from version 5.50 to 6.01 -> Things to be done in version 5.50 -> Data

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The files created by the Runtime such as AML files, CEL files, HD data, bin files etc. are compatible. These have to be copied to the corresponding Runtime directories of version 6 by hand. Please be aware, that these files are converted on the first start of the Runtime. This may take some time for large amounts of data.


Profiles

Manual -> Project conversion -> Converting from version 5.50 to 6.01 -> Things to be done in version 5.50 -> Profiles

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In version 5.50 the profiles for alarming, Extended Trend, etc. are saved in the file with the name of the project and the extension zrt. Example: For the project Project1 this file is named Project1.zrt. This file has to be renamed to project.zrt after having converted the project. Then the file has to be moved to the same folder in the RT path, where also the project.ini is saved.


3S Arti driver (since SP2)

Manual -> Project conversion -> Converting from version 5.50 to 6.01 -> Things to be done in version 5.50 -> 3S Arti driver (since SP2)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The name of the variable allocation file for the 3S Arti driver has changed. So the file has to be renamed, before new variables can be browsed from the PLC. You will find more information in the driver documentation.


Things to be done in version 6.01

Manual -> Project conversion -> Converting from version 5.50 to 6.01 -> Things to be done in version 6.01

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon version 6.01 must be installed.


Licensing

Manual -> Project conversion -> Converting from version 5.50 to 6.01 -> Things to be done in version 6.01 -> Licensing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The license numbers of version 6.x are not compatible with the license numbers of previous versions. For updates new license numbers have to be ordered and entered in the Editor. Licenses for all versions up to 5.x stay untouched, as the new serial numbers are stored in new entries in the zenon6.ini instead of the zenon.ini.


User administration / password system

Manual -> Project conversion -> Converting from version 5.50 to 6.01 -> Things to be done in version 6.01 -> User administration / password system

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the user administration of version 6.x there is the new property Administrator. Now only administrators are allowed to edit user data in the Runtime. As this property did not exist in older versions, as a default it is inactive for the existing users. If users still should be able to edit user data in the Runtime, this has to be defined accordingly in version 6.x.


Configuration settings

Manual -> Project conversion -> Converting from version 5.50 to 6.01 -> Things to be done in version 6.01 -> Configuration settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Additionally all properties of the projects as well as all settings under Options/Settings have to be checked.

As the zenon.ini has been replaced by the zenon6.ini, probable manual changes (e.g. the entry SPEICHER= for archiving) have to be copied from the zenon.ini to the zenon6.ini manually.


the Simulator driver

Manual -> Project conversion -> Converting from version 5.50 to 6.01 -> Things to be done in version 6.01 -> the Simulator driver

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As also the current settings for the simulation driver are stored in the zenon.ini, they now are taken from the zenon6.ini. After the new installation there are the default settings. So after the installation they have to be edited according to the old zenon.ini.

After creating the Runtime files the Runtime can be started.


Screen functions

Manual -> Project conversion -> Converting from version 5.50 to 6.01 -> Things to be done in version 6.01 -> Screen functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In version 5.50 and lower, only scripts (but not functions) could be linked to screens. These scripts which were executed automatically when a screen was closed or opened.

In version 6.01 and above, only functions can be linked screens, so all links to scripts are lost. The screens have to be relinked with the desired functions.


Converting from version 5.50 to S7 dBase export

Manual -> Project conversion -> Converting from version 5.50 to S7 dBase export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When converting a 5.50 project, a converting error may occur. Typical error message:
"Error driver 'SIMUL32 - SIMULATORDRIVER' variable 'Sub_VISU_E1_IGEF' type for primitive object '34' data type 8 not defined."

Reason:

The variables were

  • created on a S7 driver
  • exported as dBase
  • and then imported on the simulator driver

Solution

  • Export variables with zenon 5.50 as dBase
  • in the dBase file, check Driver object type and Data type and adapt the driver correspondingly


Conversion from version 6.01 to 6.20

Manual -> Project conversion -> Conversion from version 6.01 to 6.20

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Projects of the version 6.01 have to be converted when loaded in the current Editor for the first time. A backup of the project is automatically created in the directory \SQL\Backup.

attention Attention

Not translated keywords in the language table are deleted during the conversion process.


Archive files

Manual -> Project conversion -> Conversion from version 6.01 to 6.20 -> Archive files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

From version 6.20 SP0, archive files are stored in ARX format; before that, the ARV format was used. If a project is converted, a check is made when Runtime is started to see whether there are archive files in ARV format in the Runtime folder. After confirmation of the conversion, the files are converted into ARX format. This conversion is done for all projects, before the projects start. The ARV files are deleted during the conversion. For evacuation to SQL, further columns must be added to the table.

Recommendation: Back up the ARV files before conversion.


Evacuating archives to SQL database

Manual -> Project conversion -> Conversion from version 6.01 to 6.20 -> Evacuating archives to SQL database

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The database table <Project name>_<shortcut> gained two columns.

  • GUID: char 36. Contains the project GUID of the variable from another project or is ZERO if in the own project.
  • STRVALUE: varchar. Contains the archived string values. For numerical variables this field has the value ZERO.
    The length of the varchar datafield depends on the longest string variable to be archived. The length of the string variable is defined in the variable properties.

The database table <project name>_VARIABLES has one more column.

  • GUID: char 36. Contains the project GUID of the variable from another project or is ZERO if in the own project.

These new columns either have to be added to the SQL database by hand, or they are added from the Editor. In the Editor you have to switch to the to the property page Save in all concerned archives. There you open the connection string to the database and confirm the dialog. On closing the dialog the changes in the database are done.

attention Attention

If these changes are not done, no archive data will be evacuated to the SQL database.


Conversion for multi-user projects with different SQL database versions

Manual -> Project conversion -> Conversion for multi-user projects with different SQL database versions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If multi-user projects are converted to a zenon version with a more recent version of the SQL server, the following process must be noted.

Attention: Multi-user projects can only be converted if no elements are checked out. This means that all engineers have to check in their changes first. If this is not possible for any reason, first a project backup of the project on the project SQL Server has to be done and to be restored immediately. This resets all the Under construction information.

attention Attention

All changes in the local project versions are lost.

The conversion can only be done on the PC, on which the central project database resides. If this is on a computer in which no Editor is installed (standalone database server), the Editor of the older version must be installed on it first. Only after that can the conversion be done on this PC.

Instructions on the update to the new version with a new database

With this procedure, we assume that the old database is no longer used. In doing so:

  • Files that can be amended in Runtime are taken into account
  • Multi-user clients are removed before the project is backed up

Tasks in previous zenon version

The following steps are carried out on all client computers for multi-user projects:

  1. On all clients, for all objects with the status Check out, either Check in or Undo check out. No object can have the status Check out.
  2. Delete the respective local projects in the Editor.

The following steps are carried out on the computer with the database for multi-user projects:

  1. Optional: Import all changes that have been made in Runtime:
    1. For all modules: Set the status Allow changes
    2. Navigate to the project properties General -> RT changeable data and set all check boxes for Do not decompile to inactive.
    3. Read all files from Runtime back into the Editor via Remote Transport.
    4. Set the check boxes in RT changeable data back to the desired status.
    5. For all modules: Set the status Accept changes.
    6. Repeat these steps for all projects.
  2. in the context menu of the workspace, select the Add existing project command.
  3. Navigate to the project, expand the subnode Connected local project copies.
  4. Carry out the following step for all listed computers, with the exception of the computer with the role of database server:
    • Right click on the connected computer and select Disconnect connection.
  5. Repeat steps 2 and 4 for all projects.
  6. Create a backup of the workspace and a project backup for each project.

Tasks in new zenon version

The following steps are carried out on the computer with the database for multi-user projects:

  1. Install the new Editor
  2. Restart the computer
    Note: From this moment, the old database is no longer used.
  3. Read back the workspace backup:
    1. Select the same folder as that in which the workspace of the version was located.
    2. Select Yes to overwrite the existing workspace.
    3. Select Yes to convert all projects.
  4. Ensure that port 1433 is not blocked by a firewall or add the SQL Browser to the exceptions for the firewall rules.
  5. Ensure that the new SQL server allows remote connections.
    To do this, connect to SQL Server Management Studio and check the properties in the Connections section.

The following steps are carried out on all client computers for multi-user projects:

  1. Install the new Editor
  2. Restart the computer
  3. Open the existing workspace.
    In the process, error messages are displayed in the output window.
  4. In the context menu of the workspace, select the Add existing project command
  5. Enter the name of the computer with the database for multi-user projects.
  6. Select Refresh.
  7. Select the project that is to be added.
    1. Start with the global project.
    2. Then add, if applicable, the integration project.
    3. Then add all other desired projects.

The projects should now be in the workspace and synchronized.


Converting from version 5.50 to version > 6.22SP1

Manual -> Project conversion -> Converting from version 5.50 to version > 6.22SP1

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When converting a project from version 5.50 to a later version, note the following:

General

  • Writing the set value and combined element:

    After conversion, the Write set value property is activated for all combined elements. Because this property does not exist in version 5.50, the conversion must be manually deactivated again for each combined element after conversion.

  • Copying projects:

    When copying projects in version 5.50, the same GUID are in the project.ini file. The first project here would be overwritten in the conversion.

    Solution: Delete the INI entry before conversion. This ensures that another GUID number is not issued during conversion.

  • Switch graphics files to invisible:

    If a graphics file in a combined element is to be invisible in a certain status, no graphics file was selected in version 5.50. After conversion, a rectangle is displayed in the combined element, because the Transparent property was not activated.

    Solution: Activate the Transparent property for the graphics file. This enables you to have the same functionality.

  • Names for screens:

    Allowed are: numbers, letters and the following special characters: $, -, @, _, {}, ~, !, (),
    umlauts and all other special characters in screen names must be removed before conversion.

Recipegroups and Windows CE

When converting a project of version 5.50 with active property Windows CE project to a version higher than 6.22SP1, recipe groups are not converted to the higher version.

Background: With active property Windows CE project the saving type is set to binary before the RGM database is converted. Thus no new recipe groups can be created in the new version.

Solution: Deactivate property Windows CE project before the conversion.

For this you can either:

  • open the project in the Editor of version 5.50 and deactivate the property
    or
  • change the respective entry in the INI file of the project. To do this:
    • open the projectname.ini of the project
    • go to area [RT]
    • set entry WIN_CE=0


Converting from version x to 6.21

Manual -> Project conversion -> Converting from version x to 6.21

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


zenon web client CAB files are no longer available

Manual -> Project conversion -> Converting from version x to 6.21 -> zenon web client CAB files are no longer available

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The automatic installation of the zenon web clients via CAB file is no longer possible due to security restrictions by Windows 7.


Converting from version x to 6.22

Manual -> Project conversion -> Converting from version x to 6.22

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


Function authorizations for Acknowledging Alarms

Manual -> Project conversion -> Converting from version x to 6.22 -> Function authorizations for Acknowledging Alarms

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Since zenon version 6.22, the existing function authorizations for acknowledging alarms in the project properties are replaced by three new authorizations. The old function authorization 'Acknowledge alarms' no longer exists.

When converting from existing projects, the new function authorizations are configured according to the old single authorization. For example, if the authorization group 15 used to be necessary for the function authorization 'Acknowledge alarms', it is now also necessary for the three new functions.

For the Editor backward compatibility it may be necessary to transfer the authorization group from the three new function authorizations to the old function. The highest authorization group will be used for that. This means, if the function 'Acknowledge alarm via alarm status line' has authorization group 5, 'Acknowledge alarm via screens' has authorization group 2 and 'Acknowledge alarm via function' has authorization group 12, the function 'Acknowledge alarm' of older versions will receive the authorization group 12.

info Information

Notice regarding online compatibility in the Runtime: If you start a project older than zenon version 6.22 with the current version, the system will offer you the three new functions for configuration. However, only the highest authorization group will be used for processing, according to the mechanism described above. The old project will not be able to use the new functionality.


Report Generator function fixed

Manual -> Project conversion -> Converting from version x to 6.22 -> Report Generator function fixed

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The function fixed() also has the argument no_seps in versions up to 5.50. The argument is optional and controls the display of thousand separators.

This argument has no longer an effect on the display as thousands separators are no longer used in zenon.


VBA - Direct variable access via request is no longer possible

Manual -> Project conversion -> Converting from version x to 6.22 -> VBA - Direct variable access via request is no longer possible

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

VBA gives our customers a powerful tool for project design. Practical experience has shown that access on variables via VBA often leads to mix-ups in the use of the methods “Advise” via an online container and “Request” with direct call. Too many requests can slow down communication significantly.

We have therefore decided to meet the demands of our customers by closing this error source. From now on, variables can only be addressed via “Advise” in VBA.

For existing projects, this leads to certain incompatibilities. You will be affected if you address variables via “Request” in VBA. In this case you will have to change these projects. After making these adjustments you will profit from an increased communication performance.

New:

Direct VBA read access on variables is only possible if the variable has been registered in the driver (advised) and if it has a value, i.e. if IsOnline() is true . Simple spontaneous queries (requests) are no longer possible.

The following functions of the “Variable” object return an error if this is not the case:

  • Value
  • StatusValue
  • StatusExtValue
  • StatusString
  • LastUpdateTime
  • LastUpdateTimeMilliSeconds

This means that existing projects will no longer run in the Runtime after the conversion, as the functions mentioned above will fail.

Possible solutions:

  • Define an online container for all affected variable accesses.
    Advantage: The variables will only be requested if you really need them.
    Disadvantage: Increased programming effort.
  • Set the option “DDE active” in the group “Additional settings” of the variable properties for all affected variables.
    Advantage: Easy to perform.
    Disadvantage: The driver continuously requests all variables.

attention Attention

Limited compatibility!

After a project conversion to the current version, please check whether there is direct access on variables in any Runtime VBA macro. If this is the case, you must perform the measures mentioned above!


RGM - database changed

Manual -> Project conversion -> Converting from version x to 6.22 -> RGM - database changed

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In 6.22 SP1 the format of the used databases for data storage was modified. This means that when converting a project in the Editor the database is modified automatically.

If you changed data of the RGM in the Runtime, you must carry out the following steps:

  1. Start the Editor in the original version before you convert the project.
  2. In the project properties RT changeable data make sure that the data of the RGM can be read back and decompiled.
  3. If you use the Runtime on a remote system: Establish a connection to the remote system and read the Runtime files back. You can find this function in the Remote Transport toolbar.
  4. Read the Runtime data back to the Editor. Use command Import Runtime Data in the toolbar Runtime files in order to do so.
  5. Close the old Editor and open the new Editor. Now you can convert the project to the new version safely. All data are available in the new version.

attention Attention

Older RGM database from lower versions than 6.22 SP1 cannot be read in Runtime 6.22 SP1 or higher! If you do not convert the data as described using the Editor, you will lose all changes you made to recipes and recipe groups in the Runtime.

Windows CE

If you convert a project with activated option Windows CE project, the data are saved automatically binary in zenon 6.22. This means that when opening the RGM it looks like all recipes are gone.


Template - maximum name length

Manual -> Project conversion -> Converting from version x to 6.22 -> Template - maximum name length

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Template names may have a maximum of 29 characters. In a previous version, it was possible to create names with 30 characters. Before converting a project, all template names with 30 characters must be reduced to 29 characters.


Converting from version X to version 6.50

Manual -> Project conversion -> Converting from version X to version 6.50

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Projects from older versions are automatically converted when loaded into the current editor. A backup of the project is automatically created in the directory \SQL\Backup.

attention Attention

Before converting the editable data into Runtime editor, read it back into the old version. Otherwise it will be lost!


zenon Logic

Manual -> Project conversion -> Converting from version X to version 6.50 -> zenon Logic

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When converting from zenon Logic projects, the following must be taken into account:

attention Attention

The following applies for zenon Logic:

  • All projects must be recompiled after conversion into Workbench, so that they work in zenon Logic Runtime.
  • Projects from an older version which have not been converted to version 6.50 cannot be started with Runtime version 6.50.


Extended graphical settings for AML and CEL

Manual -> Project conversion -> Converting from version X to version 6.50 -> Extended graphical settings for AML and CEL

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As of version 6.50 property Extended graphical settings is available for control element alarm message list in screen Alarm Message List (AML) and control element event list for screen Chronological Event List (CEL).

It activates the use and the customization of the horizontal and vertical scroll bars, the header and the grid for the control element via the corresponding properties in group Header and grid.

If projects from earlier version are converted to version 6.5x, property Extended graphical settings is missing. To access the property, you must delete control element Alarm Message List or Event Listfrom the screen and create it again.


Status bits - new short name

Manual -> Project conversion -> Converting from version X to version 6.50 -> Status bits - new short name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Short names for status bits differ since version 6.20 in the different languages. With zenon version 6.50, common short names were introduced. To ensure compatibility with earlier versions, the short names can be changed to the previous ones in project.ini. In this chapter, you will find:

  1. List of new short names including comparison to previous short names
  2. List of short names with long name
  3. Instruction to reactivate the old short names in project.ini

1. New short name status

Bit no. | From 6.50 All | Up to 6.50 German | Up to 6.50 English | Up to 6.50 French | Up to 6.50 Italian | Up to 6.50 Spanish | Up to 6.50 Russian
0 | M1 | ST_M1 | ST_M1 | ST_M1 | ST_M1 | ST_M1 | ST_M1
1 | M2 | ST_M2 | ST_M2 | ST_M2 | ST_M2 | ST_M2 | ST_M2
2 | M3 | ST_M3 | ST_M3 | ST_M3 | ST_M3 | ST_M3 | ST_M3
3 | M4 | ST_M4 | ST_M4 | ST_M4 | ST_M4 | ST_M4 | ST_M4
4 | M5 | ST_M5 | ST_M5 | ST_M5 | ST_M5 | ST_M5 | ST_M5
5 | M6 | ST_M6 | ST_M6 | ST_M6 | ST_M6 | ST_M6 | ST_M6
6 | M7 | ST_M7 | ST_M7 | ST_M7 | ST_M7 | ST_M7 | ST_M7
7 | M8 | ST_M8 | ST_M8 | ST_M8 | ST_M8 | ST_M8 | ST_M8
8 | NET_SEL | SELEC | SELEC | SELEC | SELEC | SELEC | ?????
9 | REVISION | REV | REV | REV | REV | REV | ???
10* | PROGRESS | LAUF | DIREC | DIREC | RUN | LAUF | ???
11 | TIMEOUT | LZÜ | RTE | DRT | RTE | LZÜ | ???
12 | MAN_VAL | HWERT | MVALUE | VAL_M | V_MAN | VWERT | ?????
13 | M14 | ST_14 | ST_14 | ST_14 | ST_14 | ST_14 | ST_14
14 | M15 | ST_15 | ST_15 | ST_15 | ST_15 | ST_15 | ST_15
15 | M16 | ST_16 | ST_16 | ST_16 | ST_16 | ST_16 | ST_16
16 | GI | GA | GI | RG | IG | CG | ??
17 | SPONT | SPONT | SPONT | SPONT | SPONT | SPONT | SPONT
18 | INVALID | I-BIT | I-BIT | I-BIT | NV-BIT | I-BIT | I-Bit
19 | T_CHG_A | SO/WI | SU/WI | ET/HI | ES/IN | VE/IN | ??/??
20 | OFF | N_AKT | N_UPD | N_RAF | N_UPD | N_AKT | N_AKT
21 | T_EXTERN | EZ_E | RT_E | HR_E | RT_E | EZ_E | EZ_E
22 | T_INTERN | EZ_I | RT_I | HR_E | RT_I | EZ_E | EZ_E
23 | N_SORTAB | NSORT | NSORT | NTRI | NORD | NSORT | ??????
24 | FM_TR | SM_TR | DM_TR | MD_TR | SM_TR | SM_TR | SM_TR
25 | RM_TR | LM_TR | RM_TR | MM_TR | RM_TR | LM_TR | ??_??
26 | INFO | INFO | INFO | INFO | INFO | INFO | INFO
27 | ALT_VAL | EWERT | AVALUE | VALR | RVAL | EWERT | ?????
28 | RES28 | RES13 | RES13 | RES13 | RES13 | RES13 | RES13
29 | N_UPDATE | !AKTUAL | !AKTUAL | !AKTUAL | !ATTUALE | !ACTUAL | !?????????
30 | T_STD | WINTER | WINTER | HIVER | INVERNO | INVIERNO | ????
31 | RES31 | RES16 | RES16 | RES16 | RES16 | RES16 | RES16
32 | COT0 | UEK0 | TCB0 | CTB0 | CTB0 | TCB0 | ???0
33 | COT1 | UEK1 | TCB1 | CTB1 | CTB1 | TCB1 | ???1
34 | COT2 | UEK2 | TCB2 | CTB2 | CTB2 | TCB2 | ???2
35 | COT3 | UEK3 | TCB3 | CTB3 | CTB3 | TCB3 | ???3
36 | COT4 | UEK4 | TCB4 | CTB4 | CTB4 | TCB4 | ???4
37 | COT5 | UEK5 | TCB5 | CTB5 | CTB5 | TCB5 | ???5
38 | N_CONF | PN_BIT | PN_BIT | PN_BIT | PN_BIT | PN_BIT | PN_BIT
39 | TEST | T_BIT | T_BIT | T_BIT | T_BIT | T_BIT | T_BIT
40 | WR_ACK | WR-ACK | WR-ACK | ECR-ACK | WR-ACK | WR-ACK | WR-ACK
41 | WR_SUC | WR-SUC | WR-SUC | ECR-OK | WR-SUC | WR-SUC | WR-SUC
42 | NORM | NORM | NORM | NORM | NORM | NORM | ????
43 | N_NORM | ABNORM | DEVNORM | DEVNORM | Fuori norma | DEVNORM | ???????
44 | BL_870 | BL_BIT | BL_BIT | BL_BIT | BL_BIT | BL_BIT | BL_BIT
45 | SB_870 | SB_BIT | SB_BIT | SB_BIT | SB_BIT | SB_BIT | SB_BIT
46 | NT_870 | NT_BIT | NT_BIT | NT_BIT | NT_BIT | NT_BIT | NT_BIT
47 | OV_870 | OV_BIT | OV_BIT | OV_BIT | OV_BIT | OV_BIT | OV_BIT
48 | SE_870 | SE_BIT | SE_BIT | SE_BIT | SE_BIT | SE_BIT | SE_BIT
49 | T_INVAL | TIME_INVAL | TIME_INVAL | TIME_INVAL | TIME_INVAL | TIME_INVAL | TIME_INVAL
50 | RES50 | RES50 | RES50 | RES50 | RES50 | RES50 | RES50
51 | RES51 | RES51 | RES51 | RES51 | RES51 | RES51 | RES51
52 | RES52 | RES52 | RES52 | RES52 | RES52 | RES52 | RES52
53 | RES53 | RES53 | RES53 | RES53 | RES53 | RES53 | RES53
54 | RES54 | RES54 | RES54 | RES54 | RES54 | RES54 | RES54
55 | RES55 | RES55 | RES55 | RES55 | RES55 | RES55 | RES55
56 | RES56 | RES56 | RES56 | RES56 | RES56 | RES56 | RES56
57 | RES57 | RES57 | RES57 | RES57 | RES57 | RES57 | RES57
58 | RES58 | RES58 | RES58 | RES58 | RES58 | RES58 | RES58
59 | RES59 | RES59 | RES59 | RES59 | RES59 | RES59 | RES59
60 | RES60 | RES60 | RES60 | RES60 | RES60 | RES60 | RES60
61 | RES61 | RES61 | RES61 | RES61 | RES61 | RES61 | RES61
62 | RES62 | RES62 | RES62 | RES62 | RES62 | RES62 | RES62
63 | RES63 | RES63 | RES63 | RES63 | RES63 | RES63 | RES63

* Note: Status Nr. 10 was renamed to D_DIREC in version 6.50 and to PROGRESS as of version 6.51.

2. Short name - long name

The short names are the same in all languages from version 6.50. The long names remain language-dependent:

Bit number | Short term | Long name | zenon Logic label
0 | M1 | User status 1 | _VSB_ST_M1
1 | M2 | User status 2 | _VSB_ST_M2
2 | M3 | User status 3 | _VSB_ST_M3
3 | M4 | User status 4 | _VSB_ST_M4
4 | M5 | User status 5 | _VSB_ST_M5
5 | M6 | User status 6 | _VSB_ST_M6
6 | M7 | User status 7 | _VSB_ST_M7
7 | M8 | User status 8 | _VSB_ST_M8
8 | NET_SEL | Select in the network | _VSB_SELEC
9 | REVISION | Revision | _VSB_REV
10 | PROGRESS | In operation | _VSB_DIREC
11 | TIMEOUT | Runtime exceedance | _VSB_RTE
12 | MAN_VAL | Manual value | _VSB_MVALUE
13 | M14 | User status 14 | _VSB_ST_14
14 | M15 | User status 15 | _VSB_ST_15
15 | M16 | User status 16 | _VSB_ST_16
16 | GI | General interrogation | _VSB_GR
17 | SPONT | Spontaneous | _VSB_SPONT
18 | INVALID | Invalid | _VSB_I_BIT
19 | T_CHG_A | Daylight saving time/winter time announcement | _VSB_SUWI
20 | OFF | Switched off | _VSB_N_UPD
21 | T_EXTERN | Real time external | _VSB_RT_E
22 | T_INTERN | Realtime internal | _VSB_RT_I
23 | N_SORTAB | Not sortable | _VSB_NSORT
24 | FM_TR | Error message transformer value | _VSB_DM_TR
25 | RM_TR | Working message transformer value | _VSB_RM_TR
26 | INFO | Information for the variable | _VSB_INFO
27 | ALT_VAL | Alternate value If no value was transferred, the defined alternate value is used otherwise the last valid value is used. | _VSB_AVALUE
28 | RES28 | Reserved for internal use (alarm flashing) | _VSB_RES28
29 | N_UPDATE | Not updated | _VSB_ACTUAL
30 | T_STD | Standard time | _VSB_WINTER
31 | RES31 | Reserved for internal use (alarm flashing) | _VSB_RES31
32 | COT0 | Cause of transmission bit 1 | _VSB_TCB0
33 | COT1 | Cause of transmission bit 2 | _VSB_TCB1
34 | COT2 | Cause of transmission bit 3 | _VSB_TCB2
35 | COT3 | Cause of transmission bit 4 | _VSB_TCB3
36 | COT4 | Cause of transmission bit 5 | _VSB_TCB4
37 | COT5 | Cause of transmission bit 6 | _VSB_TCB5
38 | N_CONF | Negative acceptance of Select by device (IEC 60870) | _VSB_PN_BIT
39 | TEST | Test bit (IEC870 [T]) | _VSB_T_BIT
40 | WR_ACK | Writing acknowledged | _VSB_WR_ACK
41 | WR_SUC | Writing successful | _VSB_WR_SUC
42 | NORM | Normal status | _VSB_NORM
43 | N_NORM | Deviation normal status | _VSB_ABNORM
44 | BL_870 | IEC 60870 Status: blocked | _VSB_BL_BIT
45 | SB_870 | IEC 60870 Status: substituted | _VSB_SP_BIT
46 | NT_870 | IEC 60870 Status: not topical | _VSB_NT_BIT
47 | OV_870 | IEC 60870 Status: overflow | _VSB_OV_BIT
48 | SE_870 | IEC 60870 Status: select | _VSB_SE_BIT
49 | T_INVAL | Time invalid | not defined
50 | CB_TRIP | Breaker tripping detected | not defined
51 | CB_TR_I | Breaker tripping detection inactive | not defined
52 | RES52 | reserved | not defined
53 | RES53 | reserved | not defined
54 | RES54 | reserved | not defined
55 | RES55 | reserved | not defined
56 | RES56 | reserved | not defined
57 | RES57 | reserved | not defined
58 | RES58 | reserved | not defined
59 | RES59 | reserved | not defined
60 | RES60 | reserved | not defined
61 | RES61 | reserved | not defined
62 | RES62 | reserved | not defined
63 | RES63 | reserved | not defined

info Information

In formulas all status bits are available. For other use the availability can be reduced.

3. Activation of old short names

If you wish to use the language-dependent short names as in versions before 6.50, you can enable this with an entry in project.ini. The first short names apply for:

  • VBA
  • Recipegroup Manager
  • Combined element dialog
  • Reaction matrix dialog

Note: The short name must be entered in capital letters, must not contain any spaces and must contain a maximum of 7 characters.

This is how you open project.ini

  1. select the project in Project Manager
  2. press shortcut Ctrl+Alt+E
  3. the SQL folder of zenon opens in the Windows Explorer

    C:\ProgramData\COPA-DATA\[SQL folder]\[UID]}FILES

  4. navigate to \zenon\system\
  5. open the file project.ini with a text editor.

Assignment of new language dependent short names

Copy the entry of the desired language from [STATUS] up to and including STATUS63=RES63 and paste this into project.ini.

German | English | French
[STATUS] STATUS0=ST_M1 STATUS1=ST_M2 STATUS2=ST_M3 STATUS3=ST_M4 STATUS4=ST_M5 STATUS5=ST_M6 STATUS6=ST_M7 STATUS7=ST_M8 STATUS8=SELEC STATUS9=REV STATUS10=LAUF STATUS11=LZÜ STATUS12=HWERT STATUS13=ST_14 STATUS14=ST_15 STATUS15=ST_16 STATUS16=GA STATUS17=SPONT STATUS18=I-BIT STATUS19=SO/WI STATUS20=N_AKT STATUS21=EZ_E STATUS22=EZ_I STATUS23=NSORT STATUS24=SM_TR STATUS25=LM_TR STATUS26=INFO STATUS27=EWERT STATUS28=RES13 STATUS29=!AKTUAL STATUS30=WINTER STATUS31=RES16 STATUS32=UEK0 STATUS33=UEK1 STATUS34=UEK2 STATUS35=UEK3 STATUS36=UEK4 STATUS37=UEK5 STATUS38=PN_BIT STATUS39=T_BIT STATUS40=WR-ACK STATUS41=WR-SUC STATUS42=NORM STATUS43=ABNORM STATUS44=BL_BIT STATUS45=SB_BIT STATUS46=NT_BIT STATUS47=OV_BIT STATUS48=SE_BIT STATUS49=TIME_INVAL STATUS50=RES50 STATUS51=RES51 STATUS52=RES52 STATUS53=RES53 STATUS54=RES54 STATUS55=RES55 STATUS56=RES56 STATUS57=RES57 STATUS58=RES58 STATUS59=RES59 STATUS60=RES60 STATUS61=RES61 STATUS62=RES62 STATUS63=RES63 | [STATUS] STATUS0=ST_M1 STATUS1=ST_M2 STATUS2=ST_M3 STATUS3=ST_M4 STATUS4=ST_M5 STATUS5=ST_M6 STATUS6=ST_M7 STATUS7=ST_M8 STATUS8=SELEC STATUS9=REV STATUS10=DIREC STATUS11=RTE STATUS12=MVALUE STATUS13=ST_14 STATUS14=ST_15 STATUS15=ST_16 STATUS16=GI STATUS17=SPONT STATUS18=I-BIT STATUS19=SU/WI STATUS20=N_UPD STATUS21=RT_E STATUS22=RT_I STATUS23=NSORT STATUS24=DM_TR STATUS25=RM_TR STATUS26=INFO STATUS27=AVALUE STATUS28=RES13 STATUS29=!AKTUAL STATUS30=WINTER STATUS31=RES16 STATUS32=TCB0 STATUS33=TCB1 STATUS34=TCB2 STATUS35=TCB3 STATUS36=TCB4 STATUS37=TCB5 STATUS38=PN_BIT STATUS39=T_BIT STATUS40=WR-ACK STATUS41=WR-SUC STATUS42=NORM STATUS43=DEVNORM STATUS44=BL_BIT STATUS45=SB_BIT STATUS46=NT_BIT STATUS47=OV_BIT STATUS48=SE_BIT STATUS49=TIME_INVAL STATUS50=RES50 STATUS51=RES51 STATUS52=RES52 STATUS53=RES53 STATUS54=RES54 STATUS55=RES55 STATUS56=RES56 STATUS57=RES57 STATUS58=RES58 STATUS59=RES59 STATUS60=RES60 STATUS61=RES61 STATUS62=RES62 STATUS63=RES63 | [STATUS] STATUS0=ST_M1 STATUS1=ST_M2 STATUS2=ST_M3 STATUS3=ST_M4 STATUS4=ST_M5 STATUS5=ST_M6 STATUS6=ST_M7 STATUS7=ST_M8 STATUS8=SELEC STATUS9=REV STATUS10=DIREC STATUS11=DRT STATUS12=VAL_M STATUS13=ST_14 STATUS14=ST_15 STATUS15=ST_16 STATUS16=RG STATUS17=SPONT STATUS18=I-BIT STATUS19=ET/HI STATUS20=N_RAF STATUS21=HR_E STATUS22=HR_E STATUS23=NTRI STATUS24=MD_TR STATUS25=MM_TR STATUS26=INFO STATUS27=VALR STATUS28=RES13 STATUS29=!AKTUAL STATUS30=HIVER STATUS31=RES16 STATUS32=CTB0 STATUS33=CTB1 STATUS34=CTB2 STATUS35=CTB3 STATUS36=CTB4 STATUS37=CTB5 STATUS38=PN_BIT STATUS39=T_BIT STATUS40=ECR-ACK STATUS41=ECR-OK STATUS42=NORM STATUS43=DEVNORM STATUS44=BL_BIT STATUS45=SB_BIT STATUS46=NT_BIT STATUS47=OV_BIT STATUS48=SE_BIT STATUS49=TIME_INVAL STATUS50=RES50 STATUS51=RES51 STATUS52=RES52 STATUS53=RES53 STATUS54=RES54 STATUS55=RES55 STATUS56=RES56 STATUS57=RES57 STATUS58=RES58 STATUS59=RES59 STATUS60=RES60 STATUS61=RES61 STATUS62=RES62 STATUS63=RES63

Italian | Spanish | Russian
[STATUS] STATUS0=ST_M1 STATUS1=ST_M2 STATUS2=ST_M3 STATUS3=ST_M4 STATUS4=ST_M5 STATUS5=ST_M6 STATUS6=ST_M7 STATUS7=ST_M8 STATUS8=SELEC STATUS9=REV STATUS10=RUN STATUS11=RTE STATUS12=V_MAN STATUS13=ST_14 STATUS14=ST_15 STATUS15=ST_16 STATUS16=IG STATUS17=SPONT STATUS18=NV-BIT STATUS19=ES/IN STATUS20=N_UPD STATUS21=RT_E STATUS22=RT_I STATUS23=NORD STATUS24=SM_TR STATUS25=RM_TR STATUS26=INFO STATUS27=RVAL STATUS28=RES13 STATUS29=!ATTUALE STATUS30=INVERNO STATUS31=RES16 STATUS32=CTB0 STATUS33=CTB1 STATUS34=CTB2 STATUS35=CTB3 STATUS36=CTB4 STATUS37=CTB5 STATUS38=PN_BIT STATUS39=T_BIT STATUS40=WR-ACK STATUS41=WR-SUC STATUS42=NORM STATUS43=Fuori norma STATUS44=BL_BIT STATUS45=SB_BIT STATUS46=NT_BIT STATUS47=OV_BIT STATUS48=SE_BIT STATUS49=TIME_INVAL STATUS50=RES50 STATUS51=RES51 STATUS52=RES52 STATUS53=RES53 STATUS54=RES54 STATUS55=RES55 STATUS56=RES56 STATUS57=RES57 STATUS58=RES58 STATUS59=RES59 STATUS60=RES60 STATUS61=RES61 STATUS62=RES62 STATUS63=RES63 | [STATUS] STATUS0=ST_M1 STATUS1=ST_M2 STATUS2=ST_M3 STATUS3=ST_M4 STATUS4=ST_M5 STATUS5=ST_M6 STATUS6=ST_M7 STATUS7=ST_M8 STATUS8=SELEC STATUS9=REV STATUS10=LAUF STATUS11=LZÜ STATUS12=VWERT STATUS13=ST_14 STATUS14=ST_15 STATUS15=ST_16 STATUS16=CG STATUS17=SPONT STATUS18=I-BIT STATUS19=VE/IN STATUS20=N_AKT STATUS21=EZ_E STATUS22=EZ_E STATUS23=NSORT STATUS24=SM_TR STATUS25=LM_TR STATUS26=INFO STATUS27=EWERT STATUS28=RES13 STATUS29=!ACTUAL STATUS30=INVIERNO STATUS31=RES16 STATUS32=TCB0 STATUS33=TCB1 STATUS34=TCB2 STATUS35=TCB3 STATUS36=TCB4 STATUS37=TCB5 STATUS38=PN_BIT STATUS39=T_BIT STATUS40=WR-ACK STATUS41=WR-SUC STATUS42=NORM STATUS43=DEVNORM STATUS44=BL_BIT STATUS45=SB_BIT STATUS46=NT_BIT STATUS47=OV_BIT STATUS48=SE_BIT STATUS49=TIME_INVAL STATUS50=RES50 STATUS51=RES51 STATUS52=RES52 STATUS53=RES53 STATUS54=RES54 STATUS55=RES55 STATUS56=RES56 STATUS57=RES57 STATUS58=RES58 STATUS59=RES59 STATUS60=RES60 STATUS61=RES61 STATUS62=RES62 STATUS63=RES63 | [STATUS] STATUS0=ST_M1 STATUS1=ST_M2 STATUS2=ST_M3 STATUS3=ST_M4 STATUS4=ST_M5 STATUS5=ST_M6 STATUS6=ST_M7 STATUS7=ST_M8 STATUS8=????? STATUS9=??? STATUS10=??? STATUS11=??? STATUS12=????? STATUS13=ST_14 STATUS14=ST_15 STATUS15=ST_16 STATUS16=?? STATUS17=SPONT STATUS18=I-Bit STATUS19=??/?? STATUS20=N_AKT STATUS21=EZ_E STATUS22=EZ_E STATUS23=?????? STATUS24=SM_TR STATUS25=??_?? STATUS26=INFO STATUS27=????? STATUS28=RES13 STATUS29=!????????? STATUS30=???? STATUS31=RES16 STATUS32=???0 STATUS33=???1 STATUS34=???2 STATUS35=???3 STATUS36=???4 STATUS37=???5 STATUS38=PN_BIT STATUS39=T_BIT STATUS40=WR-ACK STATUS41=WR-SUC STATUS42=???? STATUS43=??????? STATUS44=BL_BIT STATUS45=SB_BIT STATUS46=NT_BIT STATUS47=OV_BIT STATUS48=SE_BIT STATUS49=TIME_INVAL STATUS50=RES50 STATUS51=RES51 STATUS52=RES52 STATUS53=RES53 STATUS54=RES54 STATUS55=RES55 STATUS56=RES56 STATUS57=RES57 STATUS58=RES58 STATUS59=RES59 STATUS60=RES60 STATUS61=RES61 STATUS62=RES62 STATUS63=RES63


Structures for UDFBs in zenon Logic

Manual -> Project conversion -> Converting from version X to version 6.50 -> Structures for UDFBs in zenon Logic

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As of version 6.50 in zenon the zenon Logic UDFB data types are no longer available. To preserve the compatibility with version 6.22, you can create them in zenon with a project prefix: "PROJEKTNAME/UDFBName". For this to work you must add an entry in file K5DBXS.ini:

  1. open file K5DBXS.ini
  2. go to area [XS]
  3. create entry UseUDFBPrefix=1

When you have questions concerning the adaption of invisible UDFBs please contact support@copadata.com or the hotline mentioned in your support contract.


VSTA and VBA - naming of objects

Manual -> Project conversion -> Converting from version X to version 6.50 -> VSTA and VBA - naming of objects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Some changes to the object model have been made due to limitations in naming VSTA objects. These changes have an effect on VBA code because this continues to access the old name and therefore no longer work.

The following changes have been implemented:

  • IDriver
    • Name -> Identification:

      The Name property does not receive the name returned, but the driver identification. It was renamed in Identification.

    • Driver -> Name:

      Driver is incompatible with VSTA, because this property returns the name of the driver. It is renamed in Name.

  • IApplication
    • Close -> Method: Close / Event: OnClose:

      IApplication has both a method as well as event with the name Close. This is not compatible with VSTA. The event was renamed in OnClose.

  • IZenWorkspace
    • Startup -> OnWorkspaceStartup
    • Exit -> OnWorkspaceExit

      Because both these names are used for VSTA internal events, they were changed to OnWorkspaceStartup and OnWorkspaceExit.

attention Attention

Check the VBA code for changed names and adapt it to the new model accordingly.


Converting from version X to version 6.51

Manual -> Project conversion -> Converting from version X to version 6.51

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Projects from older versions are automatically converted when loaded into the current editor. A backup of the project is automatically created in the directory \SQL\Backup.

attention Attention

Measures to carry out before conversion:

Before converting the editable data into Runtime editor, read it back into the old version. Otherwise it will be lost!


Calculation column width

Manual -> Project conversion -> Converting from version X to version 6.51 -> Calculation column width

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As of version 6.51 the average character width of the selected font is used to calculate the column width (e.g. Alarm Message List or CEL). Before that a default value was used. This may cause columns to be displayed in other widths than expected after the conversion.


Settings SQL database

Manual -> Project conversion -> Converting from version X to version 6.51 -> Settings SQL database

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As of version 6.51 the SQL instance can be defined and the password is saved in an encrypted form in the Startup Tool.

For this the Dialog for setting database properties was changed. New entries have a higher priority than existing entries. The display of the dialog is automatically adopted to the selected version (previous 6.51, as of 6.51).

New entries

zenondb.ini contains new entries as of version 6.51:

CONNECTION_SQL2005]

USER=zenOnSrv

PW=0x9C 0x94 0xC6 0x50 0x15 0x80 0x79 0x06 0x32 0xED 0x4E 0xE1 0x15 0xDD 0x7C 0x90

SQLINSTANCE=COMPUTERNAME\ZENON_DEV

These entries replace entry:

[CONFIG]

PROVIDER_SQL2005

If the new entries are not available or empty, this entry is still used.

Compatibility

As long as no property is changed, the existing entries remain valid. If you change an entry for version 6.51 or higher, the new entries are valid. Older versions must be maintained separately. You can find the settings for version previous to 6.51 in chapter Database previous version 6.51.

Attention: As the encrypting of the user password is now taking place in the new dialog in the Startup Tool, as of version 6.51 all settings must be made via the Startup Tool.


Extended Trend XY axis

Manual -> Project conversion -> Converting from version X to version 6.51 -> Extended Trend XY axis

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Due to performance reasons archive data for the X axis are no longer loaded automatically in the Extended Trend diagram as of version 6.51. To display the X-axis in the diagram anyway:

  • Add the variable selected for the variable for X-axis as well as the curve in the diagram
  • Deactivate the display for this curve


GUID for project conversion for version 5.50

Manual -> Project conversion -> Converting from version X to version 6.51 -> GUID for project conversion for version 5.50

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

At the conversion of projects of version 5.50 take care that when converting several projects an individual GUID is created for each project.

Reason

In the project.ini of version 5.50 there is the entry GUID which contains a project GUID. If you convert a project to version 6.x, this GUID is used.

In zenon 5.50 it was possible to copy folders on file level, then open the project in the Editor and rename it. This project copy still contained the original GUID in the INI file which was no problem for 5.50.

If you convert two such projects in version 6.x, the conversion for the second project is canceled with the note that the GUID already exists.

Solution

For converting several copied projects from 5.50 there are three possibilities:

  1. Save as
    • Convert project A
    • execute "Save project as" in version 6.x
    • a new GUID is created
    • delete original project
    • convert project B

    Attention: This method is not suitable for global projects.

  2. Project backup
    • Convert project A
    • create project backup in version 6.x
    • delete original project
    • Restore backup via "Restore project backup" and at that activate property "Create new project".

    Note: This method is also suitable for global projects.

  3. editing project.ini
    • open project.ini of version 5.50 In this version "project.ini" is called projectname.ini
    • delete the entry with the GUID
    • convert
    • a new GUID is created

    Note: If this project is opened again with version 5.50, a new GUID is also created and entered in the INI file.


Clickable buttons combined element

Manual -> Project conversion -> Converting from version X to version 6.51 -> Clickable buttons combined element

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As of version 6.51 you can create clickable buttons in the combined element for option Symbol from library in any from.

For projects for earlier versions, the property Symbol form defines the click area (node: Display) is treated as inactive.


Context menus command processing

Manual -> Project conversion -> Converting from version X to version 6.51 -> Context menus command processing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Previous to version 6.51 text at automatic menu items was ignored. At converting projects which were created with earlier versions than 6.51 Macros $ALL$$NOTE$ are automatically inserted before the engineered text. Therefore the menu items behave as before.


Record shift times in the PFS

Manual -> Project conversion -> Converting from version X to version 6.51 -> Record shift times in the PFS

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

At recording shift times in the Production & Facility Scheduler the table name for the recording was fixed to PFSSHIFTHISTORY in version 6.50.

As of version 6.51 it is created after the following pattern: ProjectGUID_SHIFT_GUID of the equipment group
For example: 292af0ac-d33d-4123-8484-e359cd0a6ae3_SHIFT_989ef705-d6a6-4b81-9eb5-f76483ecaac1.


Convert symbol colors of the general symbol library from color palette to absolute color

Manual -> Project conversion -> Converting from version X to version 6.51 -> Convert symbol colors of the general symbol library from color palette to absolute color

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When using palettes, only the palette index is saved. The actual color is assigned in Runtime.

Problem

If you define colors for symbols of the general symbol library via palettes (similar to function as palette as of 6.51) in versions earlier than zenon 6.51 and the colors of a symbol are changed in version 6.51, all user-defined colors of the symbols are adapted to the change when the Editor is restarted. This action is correct from compatibility's point of view. However absolute colors can be necessary.

Solution

If the symbol library is saved again in zenon 6.51, the palette indices are saved as absolute colors.

Procedure:

  1. Activate and open the project with the correct palette in zenon 6.51.
  2. Add a new symbol to the general symbol library.
  3. Save the general symbol library. It is saved in the new format.
  4. Close the Editor and restart it.
  5. Rename the newly created symbol and save it.
  6. In the global symbol library the palette colors are replaced by the absolute colors.


Wizards - remove VBA/VSTA properties

Manual -> Project conversion -> Converting from version X to version 6.51 -> Wizards - remove VBA/VSTA properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

At filtering for screen switch functions to a screen of type Extended Trend, the following dynamic properties were removed as they no longer have a function:

  • PictFilter[0].Curve["0 "].VarInfo.Channel
  • and ArvName, Titel, Group and Amplitude of the same object

If you use these properties in a wizard, you must remove them.


Character # not valid in the object name

Manual -> Project conversion -> Converting from version X to version 6.51 -> Character # not valid in the object name

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As of version 6.51 character # is no longer valid for object names such as variables or functions. The character cannot be entered when giving the name via the user interface.

Background: A # in the name may for example cause problems during the import.


Converting from version X to version 7.00

Manual -> Project conversion -> Converting from version X to version 7.00

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

AttentionProjects from older versions are automatically converted when loaded into the current editor. A backup of the project is automatically created in the directory \SQL\Backup. The automatically-generated backups have the SQL Server used in the filename from version 7.00 onwards, for example:
before converted to 7.00 SP0 (sql server 2008 r2).zip

Attention

Measures to carry out before conversion:

Before converting the editable data into Runtime editor, read it back into the old version. Otherwise it will be lost!

Note: Special characters such as ß-/\ are not permitted in zenon project names. Allowed are: Numbers, letters and the special underscore character (_). You can find more information about this in the Project administration and workspace manual, Create new project chapter.


User administration with Active Directory

Manual -> Project conversion -> Converting from version X to version 7.00 -> User administration with Active Directory

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

From version 7.00 SP0 on Active Directory is only available for the user administration in the zenon Runtime. This means for the zenon Editor:

  • AD users are not used for the Editor.
  • AD users are no longer validated in the Editor.
  • Via AD log in to the Editor is not possible.

Attention: If you implemented the log in to the zenon Editor via Active Directory in a project, you must create a zenon user with all necessary rights before you convert the project.


Installation of version 7.x and version 6.51 on the same computer

Manual -> Project conversion -> Converting from version X to version 7.00 -> Installation of version 7.x and version 6.51 on the same computer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If a version 7.x is installed on a system that already has zenon 6.51 installed, the Multiple Network Protocol Driver must be reinstalled after a reboot.

For that

  1. Restart the system
  2. On the installation medium, open the path Additional_Software\COPA-DATA Multiple Network Protocol Driver x64
  3. Execute the file setup64.exe (setup32.exe on 32 -bit systems from the path Additional_Software\COPA-DATA Multiple Network Protocol Driver x86)

This means that the driver is reinstalled and properly linked to the network card.


Diagnosis Server with new service

Manual -> Project conversion -> Converting from version X to version 7.00 -> Diagnosis Server with new service

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With zenon 7.00 SP0 the diagnosis system adapted. From this version on all logging tasks are carried out by service zenLogSrv. The service zenSysServ is now only responsible for Remote Transport activities. The maximum number of modules per Diagnosis Client was increased from 32 to 64.

That means:

  • Diagnosis systems up to version 6.51 and from version 7.00 are each compatible among themselves.
  • The diagnosis mechanism of zenon 6.51 SP0 and zenon 7.00 SP0 are not compatible.
Compatibility | Diagnosis Server 6.51 SP0 and earlier | Diagnosis Server 7.00 SP0 and higher
Diagnosis Client 6.51 SP0 and earlier | compatible | incompatible
Diagnosis Viewer 6.51 SP0 and earlier | compatible | incompatible
Diagnosis Client 7.00 SP0 and higher | incompatible | compatible
Diagnosis Viewer 7.00 SP0 and higher | incompatible | compatible

With the Diagnosis Viewer version 7.00 SP0 and higher you can open log files which were created by Diagnosis Server version 6.51 SP0 (or earlier). It does not work the other way round.


Dynamic Combo/List Box

Manual -> Project conversion -> Converting from version X to version 7.00 -> Dynamic Combo/List Box

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As of version 7, combo-/listboxes can also be created dynamically. Via property Entries from string variable you define whether the entries in the box are created in the Editor or via a linked string variable.

At converting projects from a version older than zenon 7, the new properties are assigned with valid values:

  • static combo/listbox (property Entries from string variable inactive)
  • no visibility variable (property Variable empty)

If files for an older version are created or saved, the properties for the dynamic comb/listbox are not loaded in order to ensure backward compatibility.


IPv6

Manual -> Project conversion -> Converting from version X to version 7.00 -> IPv6

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As of zenon version 7 you can use IPv6 in the network.

info Information

With IPv6, more users and devices can communicate via the Internet in that they use greater numbers to create IP addresses. With IPv4, each IP address is 32- bits long, as a result of which 4.3 billion unique addresses can be formed. Example for an IPv4 address:

172.16.254.1

For comparison: IPv6 addresses are 128- bits long, which allows formation of approximately 340 sextillion (3,4e+38) unique IP addresses. Example of an IPv6 address:

2001:db8:ffff:1:201:02ff:fe03:0405

However IPv6 offers other advantages for network traffic. In most cases, computers and programs recognize IPv6-compatible networks and use the corresponding advantages without the user having to do anything more. IPv6 also frees other network problems that can occur due to the limited addressing area of IPv4. Example: IPv6 reduces the necessity of network address translations (NAT), a service that allows several clients to use a joint IP address, but which does not always work reliably.

The zenon network allows the choice of using IPv6 or IPv4. Dual operation is not possible. The setting is made via:

  • Network configuration in the Startup Tool
    or
  • In zenon6.ini

Attention: IPv6 only works with version 7 onwards.
No versions prior to version 7 can be started if this is active. This concerns zenAdminSrv, zenSysSrv, zenLogSrv and zenDBSrv in particular.

The following components are not affected by the setting; they always use IPv4:

  • Driver communication with the PLCs
  • Protocol communication in the Process Gateway plug-ins
  • Workbench and Runtime communication in zenon Logic

Diagnosis Viewer

The Diagnosis Server also works with Diagnosis Clients which addresses via IPv6 addresses. For this the format of the log file has been adapted. The Diagnosis Viewer only reads the new format of the log files. If files from older zenon versions are opened (or vice versa), the IP address of the Diagnosis Client is not displayed correctly.


Licensing

Manual -> Project conversion -> Converting from version X to version 7.00 -> Licensing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With version 7.00 licensing is adapted. To adapt existing zenon version to version 7.00, you must purchase a license for version 7.00 and enter the new activation number. The serial number remains the same.

The entries in zenon6.ini are now:

[DEFAULT]

SERIAL7=

ACTIVATIONKEY7=


Message Control

Manual -> Project conversion -> Converting from version X to version 7.00 -> Message Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As of version zenon 7.00 SP0 module Message Control differs basically from earlier versions in terms of technology and configuration.

Important technical changes:

  • COM Server is no longer used
  • the additional component of company DerDack is no longer used
  • the ZenMsgQueue is replaced by an own screen of type Message Control
  • the configuration is carried out in property Message Control of the workspace (sending) and properties Project-specific settings for module Message Control in the project (project-specific)
  • there is no detail view anymore
  • the shift model and the calendar functionality has been removed
  • there are no Runtime changeable files anymore
  • Sending e-mails is possible via Outlook or a SMTP Server whereas SMTP allows the sending of attachments
  • the configuration of the sending type is no longer saved in file message32.ini but in file zenon6.ini
  • Evaluating the limit texts: Up to now the evaluation of compound texts in module Message Control differed from the evaluation of standard limit texts. From version 7.00 on both are evaluated in the same way. @StringTabelle+%var1

You can find details about the configuration in chapter Configure Message Control.

attention Attention

Only projects from version 5.50 SP7 on can be converted to version 7.

Conversion

Due to the profound changes a 100% compatibility cannot be guaranteed for the conversion. This is also true for compiling RT files for older versions. At converting especially take care for:

  • User:
    • Users with the same name (first name, last name) existing: User is used and information is added.
    • No according user available: A new user is created. The link to the replacement and to the user group is resolved. The user is added to the existing or at the conversion to the created group.
  • User groups:
    • User group with same name exists: User group is used and information is added.
    • No according user group available: A new user group is created.
  • Functions:

    Show recipient-database function was removed.
    This function can no longer be created with the Editor. At the conversion it is not deleted however. Its call up in the Runtime has no effect and creates a log entry.

  • Paging:
    Paging is no longer available as sending type. Existing functions with sending type Paging are changed to sending type GSM at the conversion. A message in the output window indicates this. After the conversion you must check the settings of the function.
  • RT changeable files:
    Because the user administration was changed, RT changeable files are no longer required for Message Control. There is no possibility in version 7 to read back old Runtime data. If the Runtime files of a project prior to version 7 are needed, you must read them back in an Editor prior to zenon 7 and then converted.
  • Shifts and calendars:
    The functionality for shifts and calendars was removed. Existing functions with target type Shift are changed to target type Group at the conversion. However no group is linked. A message in the output window indicates this. After the conversion you must check the settings of the function.
  • SMS-Gateway:
    As the simple interface does not offer a technical possibility to assign messages distinctly, from version 7 on only the enhanced interface is supported. At conversion you must make sure that the SMS Server from company Dialogs is configured correspondingly. Otherwise the sending fails.


RGM - error behavior at screen switch

Manual -> Project conversion -> Converting from version X to version 7.00 -> RGM - error behavior at screen switch

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If for the screen switch of the RGM a recipe is selected faulty by:

  • recipe not available in the Runtime
  • no selection made
  • recipe not included in the filter

then the behavior of the drop-down list recipe changes in the Runtime:

  • up to version 6.51 SP0 the first recipe in the list is offered
  • as of version 7.00 SP0 the selection remains empty.


Read RGM recipe - new operation

Manual -> Project conversion -> Converting from version X to version 7.00 -> Read RGM recipe - new operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As of version 7.00 SP0 at reading in variable values to recipes (teaching) it is checked:

  • whether the values of the properties min. value and max. value have been adhered to.
  • which status the variable has.

If the values are gone below or exceeded, or the variable has the status INVALID, the values are no longer written to the recipe and no longer saved.

Additional system variables are analyzed. As of version 7.00 possible variable values:

  • 0: Set before the reading and only changes when the reading process is done.
  • 1: Finished reading successfully.
  • 2: During reading an error not defined in greater detail has occurred.
  • 3: During readnig at least one variable hat status INVALID.
  • 4: At least on value is not within the min-max limits.
  • 5: During reading a timeout (30000 + 100*VarCount in [ms]) occurred.


Driver Allan Bradley RS-Linx

Manual -> Project conversion -> Converting from version X to version 7.00 -> Driver Allan Bradley RS-Linx

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

From version 7.00 SP0 the driver supports Unsolicited Messages. With this the configuration of the driver changes. It is now done on the tab.

  • General: Unchanged
    Note: If you use Unsolicited Messages, you should deactivate Update time global
  • Configuration: The previous KT number is replaced by the label of the RS-LINX driver.
  • Unsolicited Messages configuration: New. Setting for Unsolicited Messages.

attention Attention

In existing projects the driver configuration must be adapted.


SQL Server change

Manual -> Project conversion -> Converting from version X to version 7.00 -> SQL Server change

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With zenon 7.00 SP0, the Microsoft SQL Server 2008 R2 Express is installed and used for zenon projects. The zenon Editor only connects to SQL Server 2008 R2 by default from version 7.00 onwards. Projects that have their databases in a different SQL server instance (such as ZENON_DEV with SQL Server 2005), cannot be opened.

The SQL Server instance that zenDBSrv connects to can be changed using the startup tool. The startup tool sets, in zenDB.ini, the corresponding entries for the respective zenon Version:

  • Before 6.00: no database
  • 6.00 to 6.20: Entries for SQL Server 2000 (MSDE)
  • 6.21 to 6.51: Entries for SQL Server 2005 Express Edition
    The password is stored in encrypted form with 6.51
  • Version 7.00 and later: Entries for the SQL Server 2008 R2 Express Edition with encrypted password

Dual operation of SQL Server 2005 instance "ZENON_DEV" and SQL Server 2008 R2 instance "ZENON_2008R2" is not possible.

attention Attention

Projects from previous versions of zenon must be imported in the original version an then restored in zenon 7.00.

Hint: If no export has been made and the applicable version is no longer available, the transfer can be made manually:

  • Copy the complete folder, including the GUID, to a new location
  • Establish the database connection manually

Project conversion

The following procedure is recommended for the conversion of projects from versions prior to version 7.00:

  1. Create project backups in the version from which they are to be converted.
  2. Export project backups to the hard drive.
  3. zenon Editor 7.00 Editor.
  4. Create new workspace.
  5. Read the project backups into the new workspace.

The project backups can also be read back into the same workspace in the 7.00 Editor. Because the GUID remains the same when a project backup is read back, the workspace in zenon 7.00 and in versions between 6.21 and 6.51 can be opened.

info Information

Although the projects have the same name and the same GUID, projects from zenon 7.00 are independent from projects from zenon 6.21 to 6.51 due to the different SQL server instance. Backups in zenon 7.00 do not appear in versions 6.21 to 6.51 of the Editor. It is therefore recommended that these are stored in a new workspace.


Converting from version X to version 7.00

Manual -> Project conversion -> Converting from version X to version 7.00

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Note: Special characters such as ß-/\ are not permitted in zenon project names. Allowed are: Numbers, letters and the special underscore character (_). You can find more information about this in the Project administration and workspace manual, Create new project chapter.


32 and 64-bit version

Manual -> Project conversion -> Converting from version X to version 7.00 -> 32 and 64-bit version

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon is now available for Editor and Runtime as a 32-bit and 64-bit version. A 32-bit and a 64-bit zenon Editor and a 32-bit and a 64-bit zenon Runtime are installed on 64-bit operating systems. The file names of the executable files are identical for 32-bit and 64-bit.

On 64-bit systems, all services present in 64-bit are registered and used in the 64-bit version. Editor and Runtime can be started alternately. Projects can be executed in both Editors and in both Runtimes.

Components such as, for example, zenon Logic Runtime, zenon Logic Workbench, drivers, Process Gateway and other tools are always only used in the 32-bit version.

General limitations

The basic limitation of only 64-bit DLLs being able to be loaded in 64-bit processes also means that there are certain limitations when operating zenon. This mostly affects external components that are loaded in the Editor or Runtime. DLLs that are loaded using VBA/VSTA code and ActiveX controls are directly affected. These DLLs must be present as a 64-bit version for use in the 64-bit Editor or Runtime. ActiveX controls supplied by COPA-DATA are always available in 32-bit and 64-bit versions.

Conversion of zenon 5.50 projects

No zenon 5.50 projects can be converted with the 64-bit editor. These must be converted beforehand with the 32-bit Editor.

RGM limitation

The Access database is no longer supported in the RGM. In order to be able to use MS Access data from previous versions under 64-bit, the project must first be converted in the 32-bit Editor. The DataSource property is no longer available from version 7.10. For details, see the Converting Recipegroup manager database chapter.

VBA

VBA was converted to VBA version 7.1. Therefore VBA is also available in zenon 64-bit. If, in the VBA code, Windows API or other imported DLL functions are accessed, these calls must be adapted to 64-bit. In general, the following applies: A VBA file created with a 32-bit version cannot be used without changes in a 64-‑bit version.

There are some defines/functions available in VBA in order to write 32-bit and 64-bit compatible code. For example:

#if Win64 then

Declare PtrSafe Function MyMathFunc Lib "User32" (ByVal N As LongLong) As LongLong

#else

Declare Function MyMathFunc Lib "User32" (ByVal N As Long) As Long

#end if

#if VBA7 then

Declare PtrSafe Sub MessageBeep Lib "User32" (ByVal N AS Long)

#else

Declare Sub MessageBeep Lib "User32" (ByVal N AS Long)

#end if

You can also obtain some useful notes on the porting of VBA 32-bit code to VBA 64-bit from Microsoft:

  • Microsoft Office 2010, notes on porting: http://msdn.microsoft.com/en-us/library/ee691831.aspx
  • 32-bit and 64-bit declares for API calls: http://www.jkp-ads.com/articles/apideclarations.asp

Components in 32-bit only

The following components are also only available as 32-bit versions on 64-bit computers:

  • Some programs, such as SIC.exe and DiagViewer.exe
  • Licensing
  • Process Gateway
  • Startup Tool
  • Windows CE
  • Driver
  • zenon Logic Runtime and Workbench


Installation

Manual -> Project conversion -> Converting from version X to version 7.00 -> Installation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon 7.10 cannot be installed on systems on which the Microsoft SQL Server Data Engine (MSDE) is already installed. This affects all systems on which zenon 6.20 or an earlier version has been installed.


Batch Control

Manual -> Project conversion -> Converting from version X to version 7.00 -> Batch Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Before converting a project to the new zenon version, all recipes must be ended. Recipes that are running continue to be executed after a restart. The restart only functions within the same zenon version.


Conversion of projects in versions up to zenon 6.21

Manual -> Project conversion -> Converting from version X to version 7.00 -> Conversion of projects in versions up to zenon 6.21

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon projects in version 6.20 or older can no longer be directly read back in zenon 7.10 or higher.

Background: Versions that are based on the MSDE (SQL Server 2000) are not compatible with the SQL Server 2012 used in zenon.

Solution: First convert in zenon 7.0 and then in 7.10 or higher.


Converting Recipegroup Manager database

Manual -> Project conversion -> Converting from version X to version 7.00 -> Converting Recipegroup Manager database

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

From version 7.10, the MS Access database is no longer supported in the Recipegroup Manager. When opening an existing project, the data storage is automatically converted to binary data. A project backup is created in the process. This makes it possible for you to open the project with the version in which it was created.

Conversion with 64-bit Editor

The 64-bit Editor cannot access the MS Access database. To convert this, open the project in the 32-bit Editor first. There is a mechanism available that with the RGM setting DataSource: MS AccessDB automatically transfers the data to binary files. The property DataSource is no longer available from version 7.10. If the data storage has already been set to binary files, the database data is rejected. For this, the following applies:

  • Copying the data from the Access database to binary data storage only occurs with conversion in the 32-bit Editor. The data from the Access database is always rejected with 64-bit.
  • When converting under 64-bit, a check is made to see if the data storage of the RGM is set to MS Access. In this case, corresponding information with notification of conversion is displayed in the 32-bit Editor.
  • If, when copying over in the 32-bit Editor, it is established that at the target (binary files) data has already been configured, the user is asked which data is to be kept (MS Access or binary). MS Access and binary data cannot be combined.

After conversion, you can also open and edit the project with the 64-bit Editor.

If you want to convert the project again, use automatically-created backup during the conversion.

Amendment of recipegroup names and recipe names for 32-bit zenon

Recipegroup names and recipe names that contain invalid characters for "binary data" are automatically renamed when converting a project to the 32-bit version of zenon 7.1x. The renamed elements are shown in the output window. Check the output window for corresponding messages after conversion.

Attention: If recipe groups or recipes are renamed, the following elements must be checked and amended manually in the project:

  • All RGM functions
  • Variables that could contain recipegroup names or recipe names
  • VBA code that could contain recipegroup names or recipe names


SQL Server 2012

Manual -> Project conversion -> Converting from version X to version 7.00 -> SQL Server 2012

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The SQL Server is switched to 2012 Express Edition version with zenon 7.10 SP0. The settings are defined with the Startup Tool.

The correct entry for the zenDB.ini can be found in the zenDB.ini chapter.

attention Attention

Projects from other versions cannot be opened directly in zenon 7.10. Projects which should be edited in zenon 7.10 must first be edited in the version in which they were created. The project backup can then be converted in zenon 7.10.

If numerous versions are installed in parallel, the various SQL servers must have different paths.


Report Viewer

Manual -> Project conversion -> Converting from version X to version 7.00 -> Report Viewer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Time domains

The Report Viewer can use several time domains from version 7.10 and up. For upwards compatibility the first two configured time filters on the list are used.

Data sets

The datasets for AM, CEL, ARCHIVE and ONLINE were supplemented with the RESOURCESLABEL entry.


DirectDraw removed from VBA

Manual -> Project conversion -> Converting from version X to version 7.00 -> DirectDraw removed from VBA

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

All classes, methods and events that are used for direct drawing in zenon screens using the zenon API (VBA/VSTA) were removed for performance reasons. This concerns:

  • Draw class
  • DrawAPI method
  • Draw event


WPF

Manual -> Project conversion -> Converting from version X to version 7.00 -> WPF

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The WPF element CircularGauge was expanded from 3 to 6 display areas. Backward compatibility is not guaranteed here.

Note: If two versions of a group file are available in a project, the user is asked which version is to be used. No further actions are needed for the maintenance of the versions used up until now. If a newer version is chosen, all corresponding CDWPF files in all symbols and images in all projects must be adapted.


Time filter

Manual -> Project conversion -> Converting from version X to version 7.00 -> Time filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The configuration and display of the time filter and the filter results have been revised, optimized and harmonized.

The combination of the new Modify time range option and the new filter behavior can lead to the filter results being different in versions 7.10 from previous versions.


Converting from version x to 7.11

Manual -> Project conversion -> Converting from version x to 7.11

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Note: Special characters such as ß-/\ are not permitted in zenon project names. Allowed are: Numbers, letters and the special underscore character (_). You can find more information about this in the Project administration and workspace manual, Create new project chapter.


API - change to data type

Manual -> Project conversion -> Converting from version x to 7.11 -> API - change to data type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the CreateArrayVarEx method for the variables object, the data type for lAdrMode has been changed from int to zenOn.tpAdrMode

Existing code must be amended accordingly.

Up to zenon 7.10:

public virtual zenOn.IVariable CreateArrayVarEx(string strName, object lpDriver, zenOn.tpKanaltypes kTypes, object lpVarType, int lLBound, int lDimension1, int lDimension2, int Dimension3, int lAdrMode, bool bStartAtNewOffset)

From zenon 7.11

public virtual zenOn.IVariable CreateArrayVarEx(string strName, object lpDriver, zenOn.tpKanaltypes kTypes, object lpVarType, int lLBound, int lDimension1, int lDimension2, int Dimension3, zenOn.tpAdrMode lAdrMode, bool bStartAtNewOffset)


Batch Control

Manual -> Project conversion -> Converting from version x to 7.11 -> Batch Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Display command tags

With version 7.11, in the Parameter list settings tab in screen switching, the options for Display command parameters have been enhanced and switched to radio buttons with as many combinable check boxes as desired.

In terms of backwards-compatibility, this means that backward-compatible writing is only possible if:

  • Only one checkbox is set for the changeable parameters
  • or the combination of all checkboxes lets all parameters through

If the combination of the checkboxes results in a setting that was not previously configurable with zenon 7.10 or earlier, no parameters are displayed in the list.

Restarting Runtime

When restarting after Runtime has been restarted, the respective status is stored with the information in the recipes. The execution status is also displayed in the unit information. The execution status (numerical and text) in the unit information contains a number and text that corresponds to that of the variables in the screen. Including information on whether triggered by a restart, information on objects with a different status and objects that delay a status change.
Caution: The content of these variables is not compatible between zenon 7.10 and 7.11.

RDL files

The default.rdl from zenon 7.10 can have configuration errors. If RDL files are used based on default.rdl for Batch Control in zenon 7.11, it can lead to errors on output. If you want to use the correspondent RDL files with zenon 7.11, make the following changes before use:

  • Data set for BatchOperationInstances
    • The field OpertionType must be renamed as OperationType.
  • BatchMasterRecipes and BatchControlRecipes:
    • The field OpertionType must be renamed as OperationType.
    • Add the data field MrVersion with the data type Integer
  • BatchPhases1

    Add the following data fields:

    • CondPlcError (data type: String)
    • CSName (data type: String)
    • CSDescription (data type: String)
    • CSTag (data type: String)
    • ActiveCSNumber (data type: Integer)


Command Processing

Manual -> Project conversion -> Converting from version x to 7.11 -> Command Processing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When creating the Runtime files - via Create all Runtime files - all auto/remote command and mandatory command actions are filtered out.

These actions are only available in zenon from version 7.11. The Editor compilation validation checks whether, for a variable (or variables when using wildcards) the same command or the same switching direction has been configured twice. If this is the case, a corresponding error message appears in the output window.

info Information

The auto/remote command and mandatory command actions are not available in Runtime versions before version 7.11.


IMM table names

Manual -> Project conversion -> Converting from version x to 7.11 -> IMM table names

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tables names are now fixed and issued as follows:

  • Table for devices: Devices
  • Table for maint. works: MaintenanceWorks
  • Table for history: MaintenanceHistory
  • Table for documents: Documents

These tables have fixed table names as standard.

Different table names are retained when projects are converted. New projects use the fixed, prescribed table names.


Modify variables via API

Manual -> Project conversion -> Converting from version x to 7.11 -> Modify variables via API

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the zenon object model, the variable object has been supplemented with the ModifyVariable and ModifyArrayVariable functions. Properties of simple variables, structure variables and arrays can therefore be edited via the API. All dynamic properties that cannot be changed via the API have been set to "read only".

  • ModifyVariable function:
    For simple variables. Allows the modification of:
    • Driver
    • Channel type
    • Data type
    • Addressing mode
    • Each data type starts with new offset setting
  • ModifyArrayVariable function:
    For array variables. Allows the modification of:
    • Driver
    • Channel type
    • Data type
    • Addressing mode
    • Calculation of offset
    • Lower bound (0 or 1) and dimensions of the array

Attention: In addition, the following properties have been set to READ-ONLY for the API:

  • LBound
  • Dim1
  • Dim2
  • Dim3
  • OfsAccordingType
  • IsOffsetManuell
  • IsStartAtNewOffset
  • Driver
  • ID_DataTyp

ID_DriverTyp


Lot filter

Manual -> Project conversion -> Converting from version x to 7.11 -> Lot filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Filtering for lots has been enhanced and the configuration has been harmonized.

Compatibility

  • The Lots setting in the Time tab is now in the Lots tab and is called Display lot selection dialog.
    Difference: Up to version 7.11, the dialog could be configured in the time filter with the Lot selection and the filter could be switched in the Lot tab of the filter.
    From version 7.11, only one of the two is possible. When converting a project, the Display lot selection dialog option is selected and the time filter is set to its fixed default value of Relative time filter with one hour.
    • Note on XML import: When converting a project from version 7.10 to version 7.11 via an XML export and XML import, there is a visual error. The conversion is carried out for the XML import with absolute time filter with one hour instead of with relative time filter with one hour. This has no effect in Runtime because the setting is not evaluated when the dialog is called up. However when the filter is opened in Runtime or in the Editor, an error message is displayed, because the start time is later than the end time.
  • The possibilities for last lots have been expanded. Completed and ongoing lots can be displayed and both can be combined. If the current lots or the combination of current and completed lots are selected and the project is compiled for a version before 7.11, the completed lots are shown in Runtime.
  • The following options are available when filtering for archives and lot names:
    • No filter: Corresponds to the earlier setting * as filter
    • Static:
    • From variable: new setting

    When converting from projects created in version 7.10 or earlier, the "*" or empty string setting is converted up as No filter.

  • If Runtime files are created for versions before 7.11, only the options no filter and static can be converted correctly. With static, the string is written as it is; with no filter "*" is saved as a filter. The From variable option is ignored; no filter is set.


Network

Manual -> Project conversion -> Converting from version x to 7.11 -> Network

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Validation during compilation

The following validation for an evaluated network is undertaken during project compilation:

  • Used variables still exist
  • Used variable is not a string variable and not a structure variable
  • Hysteresis is within the sum of all weightings
  • Used variable is not read by standby server.
  • Variables are only checked if the redundancy mode is evaluated.

info Information

A configuration entry is only checked it it is also active.

Backward compatibility

  • COPA-DATA Runtime can connect to a server with version < 7.11.
  • The COPA-DATA Editor can create a project for COPA-DATA Runtime version < 7.11.


OPC UA server multi-project compatible

Manual -> Project conversion -> Converting from version x to 7.11 -> OPC UA server multi-project compatible

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The OPC UA server is multi-project compatible from zenon 7.11 onwards. Variable from the Runtime project and all its subprojects can be selected. In doing so, the object name from the variable name and the project name are combined. Configurations for OPC UA clients that were created before zenon 7.11 are thus not compatible. These must be amended when using zenon 7.11 or higher.


VBA functions for frame list changed

Manual -> Project conversion -> Converting from version x to 7.11 -> VBA functions for frame list changed

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The functions to query the number of frames has been changed. Up to version 7.10 inclusive, all frames of the local project and the global project have been counted together. From version 7.11, only the frames of the local project or the global project are counted.

The following VBA functions have been changed:

  • CSchabliste::vba_Count(): As of version 7.11, only provides the number of local or global frames.
  • CSchabliste::vba_Item(const VARIANT FAR& vID): As of version 7.11, only iterates the global frame list

These changes can lead to incompatibilities with existing projects. If frames are queried in a project using said VBA functions, these must be adapted.

Example

There are frames in local project 5 and global project 10. Then:

  • Previously 15 frames were counted and iterated
  • From version 7.11, either 5 or 10 frames are counted and iterated
  • If the iteration goes beyond the respective size, for example 11, this leads to an error
  • Separate queries must be created for the local project and the global project


Converting from version x to 7.20

Manual -> Project conversion -> Converting from version x to 7.20

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Note: Special characters such as ß-/\ are not permitted in zenon project names. Allowed are: Numbers, letters and the special underscore character (_). You can find more information about this in the Project administration and workspace manual, Create new project chapter.


BACnetNG

Manual -> Project conversion -> Converting from version x to 7.20 -> BACnetNG

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The driver was amended for version 7.20.

Separator

For the Property seperator option, the use of the @ or # as a separator is now not permitted. The characters are left in converted projects, but cannot be reentered.

Attention: If one of the two characters is used, no communication takes place.

Addressing

Selection of address

The Use identification to define object name and property check box in the Settings configuration dialog has been replaced with the Property used for adressing drop-down list. Addressing using the following methods can be selected:

  • Variable name
  • Identification
  • Symbolic address

The corresponding entry from the drop-down list is set during project conversion.

new check box for status extraction

The new Do not read property/event state from address string check box makes it possible to not extract the Property-ID and Event State from the selected address.

If this option is activated:

  • The Property-ID or Event State must be set using the driver-specific properties envisaged for this. This configuration is carried out automatically with online import.
  • Individual elements of BACnet Arrays/lists can no longer be addressed.
  • The variable name cannot be used for addressing, because this must be unique. Addressing must be either by means of identification or symbolic address.
  • The Property seperator is not always searched for in the address field. The address thus now only consists of: <Device name>.<object name>.
    The following is applicable in the process:
    • The device name must not include a period (.).
    • No restrictions for object names.


Batch Control: No more grouped CEL entries with a value change in the control recipe

Manual -> Project conversion -> Converting from version x to 7.20 -> Batch Control: No more grouped CEL entries with a value change in the control recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There is no longer a grouped CEL message any more when values change in a control recipe. Instead, each message has all information that concerns the recipe. The header entries have been removed and all changes of parameter values now use the same entries as for editing via the parameter list. The entries for changes were also adapted to the minimum execution time. New entries were added for this.

The following entries were removed:

  • IDS_STRING2460 "@Engineering of the phase@ %s""%s/%s"" @(column@ %i - @row@ %i@) changed, control recipe@ ""%s""@, master recipe@ ""%s"""
  • IDS_STRING2627 "@Reason:@ ""%s"""
  • IDS_STRING2624 "  @Value of the parameter@ ""%s"" @was changed. Old value@ ""%s"", @new value@ ""%s""
  • IDS_STRING2628 "  @Minimum duration of execution was changed. Old value@ ""%s"", @new value@ ""%s""

The following entries were added:

  • IDS_STRING2624 "@Minimal processing duration of the phase@ %s""%s/%s"" @(column@ %i - @row@ %i@) changed. Old value@ ""%s"", @new value@ ""%s""@, control recipe@ ""%s""@, master recipe@ ""%s""
  • IDS_STRING2627 "@Minimal processing duration of the phase@ %s""%s/%s"" @(column@ %i - @row@ %i@) changed. Old value@ ""%s"", @new value@ ""%s""@, control recipe@ ""%s""@, master recipe@ ""%s"" @reason@ ""%s""


Screen type specific functions

Manual -> Project conversion -> Converting from version x to 7.20 -> Screen type specific functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If screen-type specific functions are invalid, for example as a result of copying a button to a screen of a different type, then the invalid linking is pointed out and this can be replaced. Invalid functions are removed during compiling.

When converting projects, these can contain screen-type specific functions that are still invalid in Runtime.


Display sequence of the elements

Manual -> Project conversion -> Converting from version x to 7.20 -> Display sequence of the elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The display sequence of the individual element components was made the same.


DirectX 11.1

Manual -> Project conversion -> Converting from version x to 7.20 -> DirectX 11.1

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following applies when using DirectX 11.1:

  • DirectX 11.1 is available natively under Windows 8 and later versions of the operating system.
  • DirectX 11.1 cannot be used under Windows 7 and Server 200R2 without a Service Pack and versions earlier than this.
  • For Windows 7 SP1 and Server 2008 R2 SP1, a Windows Service Pack must be installed

To install the Service Pack:

  1. Download the platform update KB2670838 from the Microsoft support website.
  2. Select the version that corresponds to your operating system:
    • 32-Bit
    • 64-Bit
  3. Select the corresponding installation file.

Note: This only concerns Windows 7 SP1 and Server 2008 R2 SP1. DirectX 11.1 is already present on more recent versions. The update cannot be installed on older versions.


DirectX in the Editor

Manual -> Project conversion -> Converting from version x to 7.20 -> DirectX in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The native DirectX dsplay is available in the Editor through the settings of the Graphics quality property.

There is no dotted line for the grid. It is replaced by a solid line during project conversion.

When a new project is created, the Graphics quality is DirectX hardware by default. This can be changed manually to Windows basic or DirectX software. During project conversion, the previous value Windows Enhanced is changed to DirectX hardware. If a project that was configured with Windows Enhanced is started in Runtime, it is loaded with DirectX hardware.

Note: The graphic display of DirectX is different from Windows Enhanced. You can read details in the Differences between the graphics qualities of "Windows Enhanced" and "DirectX".

If, from version 7.00 a different graphics quality to Windows Basic is set for a project (including the corresponding setting for the Create RT files for), Runtime up to zenon version 6.51 loads the Windows extended graphics quality. If the Windows basic graphics quality is set, this is retained.


DirectX: Graphic display when screen switching

Manual -> Project conversion -> Converting from version x to 7.20 -> DirectX: Graphic display when screen switching

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When switching, closing or calling up a screen, the behavior in Runtime when using DirectX has changed. As of now, only the background color of a screen is shown up to the point where it is shown in full or after it is closed.


DNP3_TG driver replaces DNP3_NG

Manual -> Project conversion -> Converting from version x to 7.20 -> DNP3_TG driver replaces DNP3_NG

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With version 7.20, the DNP3_TG driver replaces the DNP3_NG driver. The DNP3_NG driver is no longer automatically offered for driver selection. However it can be added manually. (for details, see the driver manual)

When converting projects that use the DNP3_NG driver, this driver list is added to the driver list again.


Dynamic text: "Text from variable" property replaced

Manual -> Project conversion -> Converting from version x to 7.20 -> Dynamic text: "Text from variable" property replaced

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For the configuration of the Dynamic Text screen element, the Text from variable check box has been replaced by the new Display text drop-down selection.

This allows the selection of the content to be displayed in Runtime from a drop-down list:

  • Resources label: The content of the Resources label variable property is displayed.
  • Limit text: As long as no limit value has been breached, the content of the Text screen property is displayed. If a limit value is breached, the content of the Limit text variable property is displayed.
  • Measuring unit: The content of the Measuring unit variable property is displayed.
  • Variable identification: The content of the Identification variable property is displayed.
  • Variable name : The content of the Name variable property is displayed.
  • Variable value: The value of the variable is displayed.

When converting projects to version 7.20, the property is set according to the status of the check box:

Check box in projects before 7.20 | Selection in drop-down list in 7.20
inactive | Limit text
active (variable is numerical) | Variable value
active (variable is not numerical) | Limit text

When compiling Runtime files in version 7.20 for version or 7.11 or lower, the value for the check box is set in the compiled version:

  • active: Selection for drop-down selection is variable value
  • Inactive: for all other setups


Antialiasing property removed

Manual -> Project conversion -> Converting from version x to 7.20 -> Antialiasing property removed

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Use antialiasing property was removed from the project properties. Antialiasing is now always used if the set graphics quality supports it.


Text angle and letter slant properties removed

Manual -> Project conversion -> Converting from version x to 7.20 -> Text angle and letter slant properties removed

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The text angle and letter slant properties have been removed. These were used with the static text element if the script was embedded. Text angle can be implemented by rotating the complete element. There is no replacement for letter slant.


Entries in zenon6.ini amended for [AlarmFilterDialog]

Manual -> Project conversion -> Converting from version x to 7.20 -> Entries in zenon6.ini amended for [AlarmFilterDialog]

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In zenon6.ini, an entry in the [AlarmFilterDialog] section can be used to predefine filter screens for variable name and identification in the filter dialogs for AML, CEL and filter screens. These entries were amended with version 7.20. Entries that have already been defined thus no longer work.

Because all entered filters are automatically saved on the local computer using this entry in zenon6.ini, configuration via the INI file is not necessary. You can find details on the entries that are currently valid in the documentation for zenon6.ini.


Extended Trend: Cross-hair, XY-view

Manual -> Project conversion -> Converting from version x to 7.20 -> Extended Trend: Cross-hair, XY-view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The cross-hair in Runtime for the XY-view is configured in screen switching from zenon 7.20. To do this, activate the Show cross-hair in XY diagram option.

Configuration was previously carried out by means of the SHOW_XY_CROSS= entry in project.ini. When converting a project from a version before zenon 7.20, the setting is read from project.ini and entered. From now on, the entry in project.ini is ignored.


Format database table Aggregated archive

Manual -> Project conversion -> Converting from version x to 7.20 -> Format database table Aggregated archive

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

From zenon 7.20, the GUID is contained in the index when evacuating archives into an SQL database. The following applies for these: It must be NOT zero. From zenon version 7.20, an empty string is entered instead of ZERO for the evacuation of variables of your own project for the GUID.

If Runtime files for version 7.11 or earlier are compiled, there is a compatibility problem as a result: Because ZERO is written in the GUID column here, the evacuation does not work.

Solution: The table in the SQL Server must be created manually without GUID in the primary key or completely without a primary key.

For example, with the following syntax:

CREATE TABLE [$projectname$_$archivename$]

(

[VARIABLE] int,

[CALCULATION] int,

[TIMESTAMP_S] int,

[TIMESTAMP_MS] int,

[VALUE] float,

[STATUS] int,

[GUID] varchar(36),

[STRVALUE] varchar(?),

CONSTRAINT [PK_$projectname$_$archivename$] PRIMARY KEY CLUSTERED

(

[TIMESTAMP_S] ASC,

[TIMESTAMP_MS] ASC,

[VARIABLE] ASC,

[CALCULATION] ASC

)

)


"Windows Enhanced" removed

Manual -> Project conversion -> Converting from version x to 7.20 -> "Windows Enhanced" removed

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Windows Enhanced graphics quality option was removed from zenon. When a new project is created, the Graphics quality is DirectX hardware by default. This can be changed manually to Windows basic or DirectX software. During project conversion, the previous value Windows Enhanced is changed to DirectX hardware. If a project that was configured with Windows Enhanced is started in Runtime, it is loaded with DirectX hardware.

Note: The graphic display of DirectX is different from Windows Enhanced. You can read details in the Differences between the graphics qualities of "Windows Enhanced" and "DirectX".

If, from version 7.00 a different graphics quality to Windows Basic is set for a project (including the corresponding setting for the Create RT files for), Runtime up to zenon version 6.51 loads the Windows extended graphics quality. If the Windows basic graphics quality is set, this is retained.


Limit text

Manual -> Project conversion -> Converting from version x to 7.20 -> Limit text

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The limit value text and the status text of a reaction matrix can now be up to 1024 characters long. In the table format for the SQL export of alarms, the TEXT column has been extended to 1024 characters.

The buffer for the dynamic parts of the dynamic limit value texts when using long dynamic limit value texts (D*.AML and D*.CEL) can now vary, with a maximum size of 1024 bytes. The save format of D*.AML and D*.CEL files has been changed for this.

Existing files remain unchanged as a fixed-length record format with 264 bytes and are not converted. Newly-created files are created with a variable record length in the new format version.


IMM table names

Manual -> Project conversion -> Converting from version x to 7.20 -> IMM table names

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tables names are now fixed and issued as follows:

  • Table for devices: Devices
  • Table for maint. works: MaintenanceWorks
  • Table for history: MaintenanceHistory
  • Table for documents: Documents

These tables have fixed table names as standard. These correspond to the naming in the metering point administration.

Different table names are retained when projects are converted. New projects use the fixed, prescribed table names. If tables are used together in IMM and metering point administration, they must correspond to this convention. Different names in IMM can be amended using a dialog.


Navigation with Multi-Touch in the worldview

Manual -> Project conversion -> Converting from version x to 7.20 -> Navigation with Multi-Touch in the worldview

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When converting to zenon 7.20 from an earlier versions, the following values are set for the Move horizontally and Move vertically properties:

  • Screen is bigger than the frame: Move
  • Screen is the same size or smaller than the frame: No reaction


Process Control Engine (PCE) removed

Manual -> Project conversion -> Converting from version x to 7.20 -> Process Control Engine (PCE) removed

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Starting from version 7.20, PCE will not be supported anymore and it will not be shown in the module tree of zenon anymore. PCE will not further be developed and documented.

While converting projects from versions lower than 7.20, which contain PCE tasks, the node PCE will be shown for these projects again. PCE can continue to be used for converted projects.

Recommendation: Please use zenon Logic instead of PCE.


Remote Transport: Save password in encrypted form

Manual -> Project conversion -> Converting from version x to 7.20 -> Remote Transport: Save password in encrypted form

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The password for the Remote Transport connection can be stored in encrypted form in zenon6.inifrom version 7.20.

Note the following for project conversion:

  • In the Editor (source system), when converting the project from version X to 7.20, the KEY= entry is replaced by KEYCRYPT= and the password is saved in encrypted form here.
  • On the target system, there is a query to see whether KEY= in zenon6.ini has an entry.
    Yes: This entry has priority. For conversion, the entry on the target system must be deleted manually.

For details, see the Remote Transport manual, Encryption chapter.

Remote Transport communication can also be encrypted. To do this, the encryption of the zenon network need only be activated in the Startup Tool.


Frame properties

Manual -> Project conversion -> Converting from version x to 7.20 -> Frame properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The frames have new properties. The new properties make it possible to configure the size of a screen when it is called up, as well as the movement of screens on the monitor. In addition, two existing properties have been renamed.

New properties

Property | Description
Opening size: | Defines the size with with which a screen based on this frame is called up in Runtime.
Value (Opening size) | Value for the selected type of size setting.
Limitation Minimum: | Defines limits for minimum.
Value (minimum): | Value for the selected type of limit.
Move: | Defines possible settings when moving the object.
Limitation: | Defines the type of limit when moving.
Minimum frame margin: | Defines the area that must remain on the monitor if an object is moved beyond the border of the monitor.

When converting a project, the values for the new properties are set to the default values.

Renamed properties

zenon 7.11 | zenon 7.20
Width [pixels]: | Width (maximum) [pixels]: Defines the maximum width.
Height [pixels]: | Height (maximum) [pixels]: Defines the maximum height.

The values are applied during project conversion.


Frames: "Border type" property changed

Manual -> Project conversion -> Converting from version x to 7.20 -> Frames: "Border type" property changed

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The possible settings for the Border type were changed for frames:

Up to 7.11 | From version 7.20
Bold border | Size adjustable
Thin border | Size fixed
No border | No border

The display in the Editor and Runtime is thus changed. In the Editor, the border of the frame is now shown as it would look in Runtime on the same PC with the same settings in the operating system. The appearance of the frame in converted projects can thus change.


Frame background color

Manual -> Project conversion -> Converting from version x to 7.20 -> Frame background color

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The background of the frames is now shown in Runtime by the color of the screen that is called up.


Shading in a combined element

Manual -> Project conversion -> Converting from version x to 7.20 -> Shading in a combined element

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In a combined element, the shading effects act in the same way as for other elements or symbols. Rotations have effects on the actual angle of the shade.


Differences between the graphics qualities "Windows Enhanced" and "DirectX"

Manual -> Project conversion -> Converting from version x to 7.20 -> Differences between the graphics qualities "Windows Enhanced" and "DirectX"

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Windows Enhanced graphics quality was removed from zenon, see the "Windows Enhanced" graphics quality removed. There is the possibility of pixel differences, and things being displayed differently in the graphics output, as a result of the project conversion.

If the project needs to be amended after project version, note the following differences between the graphics qualities Windows Enhanced and DirectX:

Differences can occur in the following areas:

  • ClearType of fonts
  • Antialiasing
  • Positioning of displays within elements

    In doing so, note:

    • The dynamic elements and
    • all areas in which text occurs.
  • Dynamics/symbols:
    • Rotate
    • Scaling
    • Move

Also possible differences in:

  • Color gradient
  • Rounding
  • Effects, such as shading
  • Rounded corners
  • End of line
  • Line type
  • Graphics file
  • Zoom in zenon Editor
  • Worldview in zenon Runtime

Note: Differences that are not listed here can also occur in other areas.


Unlinked elements

Manual -> Project conversion -> Converting from version x to 7.20 -> Unlinked elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Combined element:

If the main variable is linked, the combined element is no longer displayed in Runtime.

Trend element:

If no curves have been defined in the Editor, the trend element is not shown in Runtime.

Clock element:

If the clock element is configured with the time difference setting, but no variable is linked, it is no longer shown in Runtime.

WPF element:

A WPF element for which no valid XAML file has been linked is not available in Runtime.


Variable properties for zenon Analyzer

Manual -> Project conversion -> Converting from version x to 7.20 -> Variable properties for zenon Analyzer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For use in the COPA-DATA product zenon Analyzer, a new group was added to the variable properties:

The following properties in the zenon Analyzer variable properties group provide information for reports in the zenon Analyzer:

  • Visual name: Entry of a display name of the variable in zenon Analyzer. This must be unique in the project. The check is not carried out when issued in zenon, but when imported into zenon Analyzer. If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.
  • Meaning: Entry of the (Meaning) of a variable in the zenon Analyzer. Entry is manual or by means of the Meaning and Waterfall Chart Wizard. Several meanings are separated by a comma.
    Syntax:[Meaning1],[Meaning2],…,[MeaningN]
  • Parameter for waterfall diagram: Parameters of a variable for a waterfall diagram in zenon Analyzer. Entry is manual or by means of the Meaning and Waterfall Chart Wizard. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
    Syntax: [model name],[row index],[index in row],[color code];

Up to version 7.11, the entries of the new Meaning and Parameter for waterfall diagram properties were entered into the Resources label property.

When converting a project to version 7.20, the entries are kept in the Resources label property. When exporting to zenon Analyzer, both the previous property and the new one are checked. If both are assigned, the entries of the new properties are taken on. Entries that are created using the Meaning and Waterfall Chart Wizard are always entered into the new properties.


Create zenon Logic projects

Manual -> Project conversion -> Converting from version x to 7.20 -> Create zenon Logic projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the zenon Editor, no zenon Logic projects with the name __Global can be created.
Attention: If there are already projects with the name __Global, these are no longer shown.


Project and workspace

Manual -> Project and workspace

A workspace is assigned to every project.

The workspaces and projects are displayed in the project manager.

tutorial License information

Part of the standard license of the Editor and Runtime.


Workspace

Manual -> Project and workspace -> Workspace

Workspaces are stored in a file with the file suffix .wsp6. Double-clicking on this file starts the 32-bit version of the zenon Editor.

Within one workspace, several projects can be created and managed. All data which are defined and stored for a project are a component of the internal database of zenon.

The managing of several projects in one workspace recommends itself if the same plant parameters are present (screens etc.) and copying of the data makes the configuration significantly easier or if several projects in one plant are connected via a network. Several projects can be processed at the same time.

Alternatively, another workspace can be generated in another folder for the creation of projects.

Example Example

/CUSTOMER1/PROJECT (one or more projects in the database)

/CUSTOMER2/PROJECT (one or more projects in the database)

The structure of the database is defined by schema files. They are the basis for the completely new creation of a project database. An additional database file in MS-ACCES format (MDB) exists for the Recipegroup Manager.

attention Attention

No preconfigured data are present!


Create new workspace

Manual -> Project and workspace -> Workspace -> Create new workspace

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There are two methods for creating a new workspace:

  • Drop-down list > File -> Workspace -> New or
  • Context menu of entry workspace in the project tree / entry Workspace / New

Parameters | Description
Name | Choose a name for your new workspace. The default name <Workspace> is invalid and must be replaced. Allowed are: Numbers, letters and the special underscore character (_). Prohibited are: Umlauts as well as special characters such as ß-/\.
Storage location | Select a folder for saving the new workspace. The user directory is suggested as a default save location.
Workspace file | The path is created automatically from your input.


Save workspace

Manual -> Project and workspace -> Workspace -> Save workspace

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There are two methods for saving a workspace:

  • Drop-down list / File / Workspace / Save or Save as or
  • Context menu of the entry workspace in the project tree / entry Workspace / Save orSave as

If you choose the entry Save as you can choose the storage location yourself. In this case, an existing workspace is saved under a new name.

Parameters

Description

Name

Choose any name you like for your workspace. The default name <Workspace> is invalid and must be replaced.

Allowed are: Numbers, letters and the special underscore character (_). Prohibited are: Umlauts as well as special characters such as ß-/\.

Storage location

Select a folder for saving the new workspace. The user folder is suggested as a default save location.

Workspace file

The path is created automatically from your input.

The workspaces are saved a *.WSP files.

info Information

If a project with a lower version number than the Editor exists in the workspace, you cannot select menu item "Workspace/save as ...". These projects must first be converted to the Editor version before the workspace can be saved.


Edit existing workspace

Manual -> Project and workspace -> Workspace -> Edit existing workspace

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There are two methods for opening an existing workspace:

  • Drop-down list File-> Workspace-> Open or
  • Context menu of the Workspace node in the project tree -> Command Workspace-> Open


Backup and restore of workspaces

Manual -> Project and workspace -> Workspace -> Backup and restore of workspaces

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Information on the backup and restore of existing workspace can be found in the chapter Project backups / Section Backup and restore of workspaces.


Project

Manual -> Project and workspace -> Project

Once the Workspace is open, one or more projects can be edited or selected in the Project manager. An existing project can be inserted into the current workspace.


Create new project

Manual -> Project and workspace -> Project -> Create new project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There are two methods for creating a new project:

  • Drop-down list -> File ->New project or
  • Context menu of the entry workspace in the project tree / entry Project new

Parameters

Description

Project type

Choose between standard project and global project.

Project name

Choose a name for the project.

Allowed are: Numbers, letters and the special underscore character (_). Prohibited are: Umlauts as well as special characters such as ß-/\.

Note: The default name <Project> is invalid and must be replaced.

Base folder

Folder in which the new project should be saved.

Workspace

Selection of the workspace:

  • Add to active workspace:
    The new project is added to the workspace which is currently active. As default saving location, the workspace folder is suggested.
  • Create new workspace:
    Together with the project a new workspace so created. The name of the workspace is automatically added in field Runtime folder.

Name of the workspace

Choose a name for your new workspace.

Allowed are: Numbers, letters and the special underscore character (_). Prohibited are: Umlauts as well as special characters such as ß-/\.

Note: The default name <Workspace> is invalid and must be replaced.

Runtime folder

The default storage space for the Runtime folder is already preset. The object type can be changed here.

Note: Below the Runtime folder the data folder for the Runtime files is automatically created. The folder can be individually changed via the General/Data folder property. Pay attention that the folder can always be reached. Otherwise the Runtime data cannot be written anymore.

Options

Multiuser project

Active: Several users can work on the same project at the same time (for details see distributed engineering).

Project server

Selection of the project server for multi-user projects.


Save project

Manual -> Project and workspace -> Project -> Save project

In order to save a project under a new name, select the Project / Save as entry from the context menu of the project. You can enter the new project name in the following dialog.

If you want to use an already existing name, you will receive an according message.

info Information

With this functionality e.g. it is possible to create a copy of the existing project, which the can be edited independently.

For this Project A is copied with Save as from the context menu and then can be edited. Then it is saved and Project B (again context menu - Save as).

Depending on how much the two projects differ, this can save mor time than exportint/importing project parts.


Insert project into workspace

Manual -> Project and workspace -> Project -> Insert project into workspace

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To insert an existing project into a workspace:

  • right-click on the workspace
  • Select the Insert existing project command
  • the dialog for selecting projects will be opened

To obtain detailed information on the individual projects, in particular in respect of type, open the project nodes in the selection window. You receive information on:

Information

Description

Multiuser project

Only displayed if the project is capable of distributed engineering.

Project ID

Unique project ID.

System database version

Version of system database

System report version

Version of system table

Connected local project copies

Display of project copies on other computers.

Only for multi-user projects (labeled with the letter M in the symbol).

Editor version

Version of the Editor with which the project was created or last edited.

Type:

Displays project type:

  • Standard project
  • Global project


Edit existing project

Manual -> Project and workspace -> Project -> Edit existing project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Selection of an existing project is done by selecting the project in the Project Manager by clicking on it with the left mouse button. The right mouse button opens the following context menu.

The following commands are available

Parameters | Description
Runtime Files |
- Create changed | creates changed Runtime files for the active project
- Create all | creates all Runtime files for the active project
- Import | Files that can be edited in the Runtime are read back to the Editor path -Standard recipes - Recipes of the Recipegroup Manager - User administration - Schedules and profiles
Project as start project | sets the Runtime Startproject for the current computer
Start Runtime | Runtime is started with the project defined as start project
Project active | set active project for the toolbars of the Editor and the cross reference list. All other projects, not marked as "Keep project in memory", are deactivated
Keep project in memory | the project stays in the memory, even if another project is activated
Project |
- Rename | Rename selected project
- Save project as ... | saves the project under a new name in a new directory
- Properties | opens the properties window with the project properties
- Remove from workspace | removes the project from the current workspace, but does not delete it physically
- Delete | Deletes the project physically
- Create backup | creates a backup of the project
- Load backup | loads a saved project to the current workspace
Project Remote Transport | opens the submenu Project Remote Transport. The submenu Project Remote Transport has the following functions:
- Establish connection | Initiates remote connection
- Transport changed Runtime files | Transports only changed runtime files to target station
- Transport all Runtime files | Transports all runtime files to target station
- Transport all Runtime files | files which can be edited in the Runtime (e.g. recipes, user administration etc.) are read back to the Editor files
Project as start project | Set start project for target station
- Start Runtime | Starts Runtime on target station
- Stop Runtime | Stops Runtime on target station
- Project reload | Executes function Reload on target station (Runtime device)
- Get error file | Get error file from target station
- Restart OS | Restarts operating system on target station
- Get system status | Get system status of target station
- Remote password change | the password for the remote access to the project computer is changed
Profile | Opens a submenu, where a profile can be selected (see chapter Editor)
Help | Opens online-help

Password protection

Each project can be protected with a password. To do this:

  • Create the required users in the user administration
  • In User administration in project properties, in the Function authorizations property, set the Load project entry to an authorization level greater than 0
  • Assign this authorization level to all authorized users

This enables the project to only be opened by an existing user with the defined authorization level.


Replace project links

Manual -> Project and workspace -> Project -> Replace project links

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If projects are copied, their links to higher-ranked projects must be assigned newly if necessary. The assistant replace project links supports the automatic replacing of project links to screens, variables and functions. The control system searches for all project links, which then are replaced by the screens, variables and functions of another selected project.

To replace project links:

  1. workspace and sub-projects must be saved
  2. in the context menu of integration project select command replace project links
  3. the dialog for selecting a project is opened
  4. select the desired allocations
  5. confirm the dialog by clicking OK

Parameters

Description

Replacement list

List of project allocations for replacing links:

  • Old project:
    Automatically contains all source projects. If this list is empty, there are no superior projects with links to sub-projects in the workspace.
  • New project:
    Project in which the links should be adopted. Selection from list of possible projects by clicking on the arrow button .

possible projects

Projects with which source projects should be replaced. Selection:

  • highlight desired old project
  • highlight desired new project
  • click on button with arrow to the left

Cancel allocation:

  • highlight desired allocation in the replacement list
  • click on button with arrow to the right

OK

Take over allocation and carries out replacement.

Number of replaced project links is displayed in the ouput window.

Cancel

Discards settings and closes the dialog.

Help

Opens online help.


Save and reload project

Manual -> Project and workspace -> Project -> Save and reload project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Information about saving and reloading projects can be found in the chapter project backups.


Remove project from workspace

Manual -> Project and workspace -> Project -> Remove project from workspace

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To remove a project from the workspace, choose the entry Project / remove from workspace in the context menu of the project.

The project is not deleted after that. See chapter Delete project.


Delete project

Manual -> Project and workspace -> Project -> Delete project

You can find more information about deleting projects in the chapter project backups / Deleting projects.


Integration project

Manual -> Project and workspace -> Integration project

zenon offers the possibility of a multi-hierarchical project structure. In such a case an integration project with several sub-projects is realized.

As a central station the integration project contains overview screens, where process values of sub-projects can be displayed.

Details: see the Multi-project administration chapter in the Network manual.

Example Example

With the recipes in the integration project set values can be administered centrally in order to control the single projects in the best way.

With project overlapping archives in the integration project data from the sub-projects can be collected at a central location.

It is possible to use variables from sub-projects in the integration project.

You can find more information on Replacing project links in the chapter Replacing project links.

attention Attention

Naming templates: Avoid using the same name for templates in integration and subprojects. Because:

  • If a template with the same name is already opened, this is then used when the new screen is called up - regardless of which project it belongs to.
  • If there is still not a template open with a suitable name, the name of the screen's project is used.

File folders

Sub-project which are located at the same folder node as the integration project during creation, always use the same structure as the integration project. Every sub project is entered into the project.ini with relative path to the integration project. If the Runtime path for the integration project is changed, the paths for the sub-projects also change. This guarantees that the Runtime can find the needed paths.

Note: You can find more information about this topic in the Network manual in the chapter titled The integration project.


Copying sub-projects

Manual -> Project and workspace -> Integration project -> Copying sub-projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to avoid, that after copying the sub-projects the links of the integration project link to the wrong sub-projects, zenon offers the possibility to replace project links or to copy entire workspaces.

The links from an integration project to a sub-project can also be replaced with links to another sub-project without having to create a copy of the integration project.


Copying the complete workspace

Manual -> Project and workspace -> Integration project -> Copying sub-projects -> Copying the complete workspace

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A copy of the entire workspace is created. For each project a 'Speichern unter' is executed and a new GUID is generated. But the projects keep their original names. The workspace is autoimatically loaded with the new projects. In this solution the entire integration project is searched for variable and function links, which point to other projects. In these links the GUID of the original project is replaced by that of the copied sub-project. With this solution the sub-project can be adopted and immediately will run with the new integration project.


Authorization

Manual -> Project and workspace -> Integration project -> Authorization

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Operating authorizations can be implemented in zenon for projects in the network and for integration projects without a network.

Authorization in the network

To activate operating authorization in the network:

  1. navigate to the Network group in Project Properties.
  2. Activate the Authorization in network active property.
  3. Define the Timeout for request [s]:
  4. Define the Timeout for authorization [s]:
  5. Attention: Select a time period shorter than the network time-out in the Timeout [s] property
  6. Configure the functions in order to get the operating authorization or to approve this.

For details see the Operating authorization in the network chapter in the Historian manual.

Authorization in the integration project

To use operating authorizations in an integration project:

  1. Configure a binary variable for the project properties of the Interaction group for the Operation lock property
  2. Evaluate its response values

Response value:

  • >0: No operating authorization available Runtime reacts as in a network project if the operating authorization is not present.
  • 0: Authorization available Runtime reacts as in a network project if the operating authorization is present.


Global project

Manual -> Project and workspace -> Global project

A global project is a project that is not connected to a process.

info Information

For each workspace you can only create and use one global project.

The global project has a number of modules which are available for all projects in the workspace. If objects exist in the global and in the local project, the objects in the local project take priority.

Module

Description

Variables -> Alarm

Grouping of alarms in groups, classes and areas.

Frames

Frames, that do not exist in local projects are taken over by the Global project. The identification is the name.

Font lists

Font lists which do not exist locally are take over from the global project. The identification is the name. Pay attention to the consequences of same names in the global and local project.

Color palettes

All palettes of a project must always contain the same amount of colors; the number of colors can therefore differ between a global project and a local project.

Attention: In the event of conflicts in the Runtime, the local project's color palettes take priority.

Language file

Language files are managed in language tables and are merged on the level of keywords and file names. Keywords which do not exist in local projects are taken over from the global project.

User administration

Users are merged by the identification. Users which do not exist in local projects are taken over from the global project.

Attention: Users form global projects are displayed in the Runtime in all sub-projects but they cannot by changed via the Runtime user administration.

Files

Files which do not exist in local projects are taken over from the global project.

History of changes

Documents all changes in the global project.

Equipment modeling

Depicts all levels of a company according to ISA S88 and S95. Is created in the global project and used in the local project.

Project backups

For backups of the global project.

info Information

It is not possible to open the VBA Editor in a global project.


Definition of the project filter

Manual -> Project and workspace -> Definition of the project filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A project filter is used in a number of different functions (screen switch, exporting, printing, lists, etc.). It allows the selection of individual projects in multi-project administration.

attention Attention

This filter is only available if several projects are available in an integration project.

Exception: With the filter configuration for faceplates, the project filter is also offered for individual projects.

the selection from the integration project and all sub-projects is carried out via multi-select by pressing and holding key Ctrl and mouse click on the desired projects.


Configuration

Manual -> Project and workspace -> Configuration

The configuration is carried out via:

Parameters | Description
Standard Configuration | License product Standard Control Panel
Project Configuration | Project Alarm List Chronological Event List Monitor administration User administration Project backup Rename Project Save Project as...


Standard

Manual -> Project and workspace -> Configuration -> Standard

After selecting the menu entry File/Standard configuration/Standard the following not project-specific settings are available:

Parameters | Description
Printer | Global printer settings for all database projects
Directories | Definitions for projects being newly created


Printer

Manual -> Project and workspace -> Configuration -> Standard -> Printer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Printers can be assigned for the following functions:

Parameters | Description
for online printing AML or CEL | Online printer for Alarm Message List or Chronological Event List in the runtime. Selection if AML or CEL in the project properties in the group AML and CEL or over the files ALAR.FRM and/or BTB.FRM.
for offline printing AML or CEL | Offline printer for Alarm Message List or Chronological Event List by clicking the button print in the respective screen. Format configuration in the files ALARM_G.FRM or BTB_G.FRM.
Values and protocols for output | Printer for reports and if the function print the current value (output of the current values and tables) was selected.
for screenshots | Printer for screenshots
for notepad | Printer for general lists.

To select a printer:

  1. click in the drop-down list
  2. all printers installed on the computer are displayed

In order to configure the page view:

  1. click on button ... next to the printer
  2. the dialog for the page setting will be opened

Printer

Parameters | Description
Printer | Settings for the printer.
Name | Selection of the printer from the drop-down list. The list contains all printers configured in the operating system.
Properties... | Opens printer configuration dialog.
Status: | Display printer state. For information only.
Type: | Display printer type. For information only
Location: | Display the location of the printer if configured. For information only.
Comment: | Display comment about printer if configured. For information only.

Paper

Parameters | Description
Paper | Configuration of the printout.
Size | Select paper format from drop-down list.
Source | Select paper feed from drop-down list.

Alignment

Parameters

Description

Alignment

Select paper alignment. Possible parameter:

  • Portrait Format
  • Landscape

Network

Opens dialog for selecting a printer in the network.

OK

Applies configuration and closes the dialog. With this printing is started in the Runtime.

Cancel

Discards configuration and closes the dialog. In the Runtime this also cancels the printout.

info Information

For different printer interfaces the same printers can be used with different parameters.


General folder

Manual -> Project and workspace -> Configuration -> Standard -> General folder

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In tab folders you define the default folders for the categories described below. Click on button ... to open the Explorer in order to define the storage location for the selected file type. The storage locations defined here are taken over as default for new projects and can be changed in the project settings via option File storage. The storage locations are created relative to the Runtime folder.

Parameters | Description
Graphics | Graphics files Default: \Graphics
Exported files | Path for exported archives, reports, Chronological Event List, Alarm Message List. Default: \Export
Allocations | Path for project backups. Default: \Allocation
Read-back folder for archives | Folder for reading back the archive backup files. When loading archive data from the readback folder, the archive data from the Runtime path and from all subfolders of the readback folder is also read. Default: \Backup
Evacuated archives | Folder in which evacuated archives were saved. Default: \ExportArv
Online help | Folder for online help. Default: \ONLINE_HELP


Project manager

Manual -> Project and workspace -> Configuration -> Project manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the project project properties all details of a project are configured. To configure the properties you must:

  • highlight the project in the project tree
  • open the property window

    (Open it via context menu of the project or menu options)


Project info

Manual -> Project and workspace -> Configuration -> Project manager -> Project info

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following information on the project can be defined:

Parameters | Description
Author | Author of the project
Manager | Manager of the project
Company | Company for the project
Comment | Free comment for the project


Project-related folder

Manual -> Project and workspace -> Configuration -> Project manager -> Project-related folder

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

By selecting property File storage in project settings General, the dialog for defining the storage location is opened. The already existing locations were taken over from general settings for folders. Click on button ... to open the Explorer in order to define the storage location for the selected file type. The storage locations are created relative to the Runtime folder.

Parameters | Description
Graphics | Graphics files Default: \Graphics
Exported files | Path for exported archives, reports, Chronological Event List, Alarm Message List. Default: \Export
Allocations | Path for project backups. Default: \Allocation
Read-back folder for archives | Folder for reading back the archive backup files. When loading archive data from the readback folder, the archive data from the Runtime path and from all subfolders of the readback folder is also read. Default: \Backup
Evacuated archives | Folder in which evacuated archives were saved. Default: \ExportArv
Online help | Folder for online help. Default: \ONLINE_HELP


Graphics quality

Manual -> Project and workspace -> Configuration -> Project manager -> Graphics quality

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In zenon the quality of the displayed graphics can be tuned to the resources for the system. This setting is made using the project setting Graphics quality in group Graphical design. These settings only have an effect on Runtime. DirectX is always used in the Editor.

Possible options are:

  • Windows Basic: Basic graphics settings. Recommended for resource-weak hardware.
  • DirectX Software: Graphics calculations are done by the CPU. Depending on the graphic you can use more than one CPU. Using DirectX Software may cause a high CPU workload.
  • DirectX Hardware: A part of the graphic calculation is done by the graphics card by which the performance is increased. If this setting is not supported by the used system, zenon automatically switches to DirectX Software. Generally speaking DirectX Hardware is preferable and DirectX Software should only be used if necessary.

attention Attention
  • DirectX is not available under Windows CE.
  • DirectX cannot be used for OCX.

DirectX

DirectX allows a higher quality of graphics than than Windows Basic.

To use DirectX, several requirements must be fulfilled:

Requirement

Description

DirectX Hardware or DirectX Software must be activated.

In the project settings you must select DirectX Hardware or DirectX Software for property Graphical design.

The operating system must support DirectX 11.1.

DirectX hardware and DirectX software only works on operating systems that support DirectX11.1.

If the system does not support DirectX 11.1, it automatically switches to Windows Enhanced.

The current DirectX- Runtime must be installed. For zenon it is installed together with the setup. For the Web Client it must be installed manually.

The screen or element must support DirectX.

Only supported elements or screens can be displayed with DirectX.

For DirectX Hardware the minimum requirements must be fulfilled.

You can find details on the minimum requirements in the System requirements when using DirectX chapter. If they are not met, it automatically switches to DirectX Software.

If the operating system does not provide any hardware acceleration (e.g. Remote Desktop), it may not be possible to use DirectX Hardware.

DirectX 11.1

The following applies when using DirectX 11.1:

  • DirectX 11.1 is available natively under Windows 8 and later versions of the operating system.
  • DirectX 11.1 cannot be used under Windows 7 and Server 200R2 without a Service Pack and versions earlier than this.
  • For Windows 7 SP1 and Server 2008 R2 SP1, a Windows Service Pack must be installed

Install Service Pack for Windows 7 SP1 and Server 2008 R2 SP1

To install the Service Pack:

  1. Download the platform update KB2670838 from the Microsoft support website.
  2. Select the version that corresponds to your operating system:
    • 32-Bit
    • 64-Bit
  3. Select the corresponding installation file.

Note: This only concerns Windows 7 SP1 and Server 2008 R2 SP1. DirectX 11.1 is already present on more recent versions. The update cannot be installed on older versions.


DirectX: Error treatment

Manual -> Project and workspace -> Configuration -> Project manager -> Graphics quality -> DirectX: Error treatment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Errors are displayed in the Diagnosis Viewer.

DirectX is not initialized.

If DirectX cannot be initialized during the call up of a screen or in continuous operation, an attempt is made to initialize DirectX again. During this process, zenon Editor and Runtime continue to run normally. You can attempt to rectify the problem in this time. Possible causes and solutions can be found out with the Diagnosis Viewer.

A progress bar appears during reinitialization. To cancel the reinitialization:

  1. Click on the Cancel button.
  2. Confirm the error message that is shown to you.
  3. Depending on whether you have canceled the process, either the editor or Runtime is ended.

Note: Errors that make reinitialization of DirectX impossible are announced by means of an error message.

Diagnosis Viewer

DirectX provides individual messages in the Diagnosis Viewer with:

  • an error message.
  • possible reasons for the error,
  • error codes.

The display take place in an own module DirectX. For errors, the error text is displayed in the Error text field; for warnings and debug information, the corresponding messages are displayed in the General text field:

  • For the successful call up of a screen at least one DEBUG success message is displayed.
  • Warning point out events which can influence the operation.
  • If an error occurs which cannot be fixed, an error message is displayed.

info Information

If a message is not completely displayed in the table in the Diagnosis Viewer, open the entry via double click to display the whole message.

Check list for error checking

A check to see whether DirectX is working can be carried out by activating the debug messages in the Diagnosis Viewer. A corresponding message is shown if the check is successful.

  • Are DirectX-specific warnings or error messages displayed in the Diagnosis Viewer?
  • Is property DirectX Hardware or DirectX Software activated in project setting Graphics quality?
  • Are the minimum requirements for DirectX met? You can find details on the minimum requirements in the System requirements when using DirectX.
  • Is DirectX supported by the screen or the element?
  • Does the display with Windows Basic work properly?
  • Does the display work with another driver?
  • Does the display work with a graphics card of another manufacturer?


Runtime changeable data

Manual -> Project and workspace -> Configuration -> Project manager -> Runtime changeable data

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There are different data which can be changed in the zenon Editor as well as in the Runtime. These are files for:

  • Recipegroup Manager
  • Standard recipes
  • User administration
  • Scheduler

Protect Runtime files from overwriting

If all Runtime files are created or transported, the files meanwhile changed in the Runtime would be overwritten. In order to avoid unwanted overwriting the files, that should not be created or transported, can be selected here in the section Do not generate and transfer.

Protect Editor files from overwriting

Data changed in the Runtime can be read back. In this case the corresponding Editor data are overwritten. In order to avoid unwanted overwriting the files, that should not be read beack, can be selected here in the section Do not decompile.

Dialog RT changeable files

You can reach the dialog for configuring the Runtime changeable files via project settings General/RT changeable data:

The following file types can be selected:

TAGs | Description
Recipegroup Manager | Recipe groups and recipes of the Recipegroup Manager. At the transfer new files are transferred and new sub-folders are created, deleted files and sub-folders are also deleted on the target system.
Standard recipes | Standard recipes.
User administration | User administration for login and rights administration in the Runtime.
Scheduler | Changes in the time models and schedules of the PFS.

attention Attention

At the project conversion take care that Runtime changeable files are also converted. For this Runtime files must be imported to the Editor and after the Update copied back to the Runtime. For details see chapter Recommended procedure for converting Runtime files in manual project conversion.

Transferring the files

In the Runtime

To transfer files to the Runtime:

  1. all files can be transferred
  2. only changed files can be transferred

Both possibilities consider the files defined in property RT changeable data.

From the Runtime

To read files from the Runtime, there are two processes available:

  1. Restore all Runtime files:
    1. reads back all Runtime files in the folder which was defined in property Runtime folder
    2. regardless of the settings of property RT changeable data
  2. Import Runtime files:
    1. imports the files defined in property RT changeable data and
    2. replaces the engineering in the Editor by these Runtime files
    3. is suitable for taking over data from a remote system in the Editor

Connection error

During the transfer existing data are overwritten in accordance with the settings.

If errors occur at the transfer to or from the Runtime or if the connection is disrupted, the files must be completely transferred again.


Project simulation

Manual -> Project simulation

With the help of the project simulation, you have the possibility of switching between simulation mode and hardware mode. You can simulate processes for test purposes in simulation mode. In this mode, switching actions are executed, recipes are sent, set values are defined etc. without these operations actually being sent to the process (such as to a PLC for example).

tutorial License information

Must be licensed for Editor and Runtime (single-user, Server, Standby and Client).

All projects must have a license. For single-user projects a license for the client is needed. With server projects, the license must be present on the Server/Standby or locally.

If the licensing is changed at the server, the clients must be restarted for the license to be applied.

Simulation operation

In simulation mode:

  • all drivers are started in mode Driver simulation programmed
  • no data is saved externally
    • SQL evacuation is not executed
    • Entries for IPA database are not created
    • existing IPA entries cannot be deleted, edited or commented
  • PFS shift data are not saved in the database
    (After starting the Runtime in hardware mode the saving is done.)

info Information

Project simulation is not available for clients at the terminal server.


General

Manual -> Project simulation -> General

You can only switch to the project simulation if all projects in Runtime are either single user or client projects. The simulation mode "separates" the computer and Runtime from the network. Furthermore all drivers are started in mode Driver simulation programmed. After this, no more drivers are connected to a process.

After switching to simulation mode, Runtime is restarted and acts as though all projects were configured as a single user project.


Switching to simulation mode

Manual -> Project simulation -> General -> Switching to simulation mode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following steps are carried out if you switch to simulation mode:

  1. Call up the function to switch to simulation mode.
  2. A check is made to ensure that all projects in simulation mode may be switched or are already in simulation mode.
  3. The steps from create simulation mode are carried out.
  4. For each project, an entry in the respective chronological event list is created, which notes the switch to simulation mode.
  5. Runtime ends and starts the zenProcess with additional parametering.
  6. zenProcess waits until Runtime has ended and then starts in simulation mode.
  7. Runtime recognizes the command line parameter and starts all projects as single user projects.
  8. The directory for Runtime data is now the simulation directory. The directory of Runtime data for hardware mode is not changed.
  9. The projects are started. The drivers are programmed in driver simulation mode and are loaded with the simulation image from the simulation directory. Local variables obtain their value from the local image. The variable image is applied on the programmed simulation. If in the programmed driver simulation the variable is changed at once in the first cycle of a program, in the zenon Runtime the variable does not have its original value as in the Runtime in hardware mode as first value but the value which was changed in the simulation.
  10. The image for the internal drivers is loaded.
  11. For each project, an entry in the respective chronological event list is created, which notes the switch to simulation mode.
  12. The system driver variable obtains the value for the simulation mode.

These points are executed for all projects in Runtime unless you have explicitly stated otherwise.


Switching in hardware mode

Manual -> Project simulation -> General -> Switching in hardware mode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The hardware mode is available each time Runtime is started, even if hardware mode was not switched into in simulation mode. The following steps are carried out:

  1. Call up the function to switch to hardware mode.
  2. The driver image (process driver and internal driver) and the image of zenon Logic simulation are saved.
  3. Runtime ends and starts the zenProcess with additional parametering.
  4. zenProcess waits until Runtime has ended and then starts with the start parameters for process connection.
  5. Runtime starts and load the projects and Runtime data - from the server if necessary.
  6. The drivers are initialized with the data from the local variables before simulation.
  7. If necessary, the simulation image is transferred to the server. You can activate this with appropriate command line parametering.


Create simulation image

Manual -> Project simulation -> General -> Create simulation image

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

All files and variables that can be changed by Runtime are combined in the simulation image. If you wish to create a simulation image, the following steps are carried out:

  1. All data points from all projects are requested in order to supply them with current data.
  2. Data that is not required is deleted in the simulation image, according to the mode selected (Exception: Initialize with existing simulation image):
    1. Initialize with process image and Runtime data (without archive data): The local simulation project is completely deleted.
    2. Initialize with process image and Runtime data (with archive data): All archive files (*.ARX und *.ARS) are deleted in the local simulation directory.
  3. Depending on the settings you have made for the Switch on/off simulation function, the corresponding project data, Runtime data and variable data is obtained from all projects. For AML, CEL and HDD, the current status is saved locally for a single user project and on the server for a server project (Exception: Initialize with existing simulation image).
  4. The project files that can be changed in Runtime (for example, data for PFS, users etc.) will be copied to the corresponding file in the project directory (exception: Initialize with existing simulation image).
  5. It waits until all data points have received a value. The progress bar displays the names of the data points. The display is limited to 60 characters and displays the attendant value. The waiting time is not limited.
    Hint: If, in the Activate/deactivate project simulation function, the option Wait for all variables is deactivated, only the time that is configured in the Maximum waiting time property is waited. With a maximum waiting time of 0, the progress bar is not displayed.

  6. A variable image of all drivers is created and the internal drivers save their data. These images are copied in the computer directory. If you create the image in the simulation, it also contains the image of the driver simulation programmed.
  7. New transfer of files changed as in point 3 to point 6.
  8. The variable image is compared to the local simulation directory.
  9. This is because the variable image for local variables is saved except if an image is created in the simulation.

These points are executed for all projects in Runtime unless you have explicitly stated otherwise.


Activate/deactivate project simulation function

Manual -> Project simulation -> General -> Activate/deactivate project simulation function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You switch between simulation mode and hardware mode using the Switch on/off simulation function.

The two modes can be started under different prerequisites. These are explained in the following chapters:

  • Simulation mode active:
    • Initialize with process image
    • Initialize with process image and Runtime files (without archive files)
    • Initialize with process image and Runtime files (with archive files)
    • Initialize with existing simulation image
  • Hardware mode active:
    • Activate process connection
    • Activate process connection and transfer simulation image to the server
  • Create/transfer simulation image
    • Create simulation image (RT in simulation mode) Transfer simulation image to server (RT in hardware mode)

Furthermore, the following general options are available:

Parameters

Description

Name of simulation image (computer name if empty)

Enter the name of the simulation image here.

Note: Only the name of the directory is saved.

If you do not explicitly give a name, the name of the computer is used.

Wait for all variables

Deactivate this checkbox if you then also want to switch to simulation mode, if not all variables have a value or are invalid (not recommended!)

Not active if Activate process connection is active (activate hardware mode)

Default: active

Maximum waiting time [s]

Enter the time that is waited when switching to valid values of the variables.

As a result of this, switching to simulation mode is then also possible if not all variables have a value or are invalid.

If this timeout is activated, the waiting time is displayed in Runtime in the title of the status dialog. The status display shows the progress of time. Missing variables are always shown. If the time has expired, the simulation is switched to despite missing variables.

If a maximum maximum waiting time of 0 seconds is set, the progress dialog is not displayed.

Default: 30 seconds
Input range: 0 - 3600

Note: only active if Wait for all variables is not active.

Show error message in the Runtime

Activate this checkbox if you wish to receive an error message in Runtime if the functions was not executed correctly.

Show this dialog in the Runtime

Activate this checkbox if you you would also like to have this dialog displayed during Runtime.

Note: settings for mode selection are locked in Runtime. If you have selected Activate process connection, entering a name for the process screen is also locked.

info Information

If a project in Runtime is, currently in the process of reloading or is to be reloaded or a dialog is opened in VBA for example, the Switch on/off simulation function is not executed immediately. The function is carried out immediately as soon as there is no further reason for delay.

If the mode is not Activate process connection and the checkbox "Wait for all variables" has not been activated, the parameter text is supplemented with {wait time xxx seconds}.

Diagnosis Viewer

If there are still variable(s) without value(s) after the timeout, a LOG entry for each connection is created for the Diagnosis Viewer. "simulation image has variables with missing values!" is written in the general text, followed by a list of all variables without a valid value.

Note on compatibility:

The complete functionality of Wait for variables was brought in after zenon 7.10 and 7.00. The creation of Runtime files for earlier versions is also possible. However in earlier versions, the new function of Wait for variables is not available.


Initialize with process image

Manual -> Project simulation -> General -> Activate/deactivate project simulation function -> Initialize with process image

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Here, an image of local variables is created and the project data that can be modified in Runtime is saved. After this, Runtime is restarted in simulation mode.

Is only executed is the project is not already in simulation mode.

info Information

All existing data in the image is deleted. Only the current variable values are obtained for initialization.


Initialize with process image and Runtime files (without archive files)

Manual -> Project simulation -> General -> Activate/deactivate project simulation function -> Initialize with process image and Runtime files (without archive files)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Here, an image of all local variables and all files from the computer folder (Exception: archive data) is created and the project data modified in Runtime is saved. After this, Runtime is restarted in simulation mode.

info Information

All existing data in the image is deleted. Only the current variable values are obtained for initialization

info Information

Ensure that all historical alarms and CEL files are copied. This procedure can take some time depending on the extent of the files involved.


Initialize with process image and Runtime files (with archive files)

Manual -> Project simulation -> General -> Activate/deactivate project simulation function -> Initialize with process image and Runtime files (with archive files)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Here, an image of all local variables and all files from the computer directory are created - any archive data that may be present locally in the image is not deleted - and project data modified in Runtime is saved. After this, Runtime is restarted in simulation mode.

info Info

All existing data in the image is deleted. Only the current variable values are obtained for initialization

info Info

Ensure that all historical alarms, CEL files and archive data are copied. This procedure can take some time depending on the extent of the files involved.

info Information

Here, the archive is kept. Archiving starts filling the missing archives when Runtime is first started if you have configured it to do so. This procedure can take some time depending on the size of the files involved.


Initialize with existing simulation image

Manual -> Project simulation -> General -> Activate/deactivate project simulation function -> Initialize with existing simulation image

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Here, an existing simulation image is transferred from the server to the client. No transfer takes place for a single user project. The respective status of local variables is saved and Runtime is restarted on the basis of the simulation image. Runtime is also restarted if it is already in simulation mode. If this was the case, no driver image is saved for the local variables to start in hardware mode.

info Information

As a result of the possibility to create a simulation image (with the help of create simulation image), you can always start a simulation from precisely the same place and under the same prerequisites. Not only are the variables saved in the screen, but the respective status of the driver simulation is also programmed. Because the server image (if present) is transferred, you also have the possibility of having several clients with the same screen. When Runtime is started, the image from the server is copied across. In doing so, only the changes are transferred.


Activate process connection

Manual -> Project simulation -> General -> Activate/deactivate project simulation function -> Activate process connection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Here, you switch from simulation mode to hardware mode. The image of local variables is used for this.

When ending the simulation mode, the simulation mode is saved, so that the last status of the simulation mode can be recreated if necessary. If there is a connection to the server, the simulation image is transferred to the server and saved there.

attention Attention

If the same simulation image is transferred from several clients at the same time, it cannot be guaranteed that the simulation image copied is functional.


Activate process connection and transfer simulation image to the server

Manual -> Project simulation -> General -> Activate/deactivate project simulation function -> Activate process connection and transfer simulation image to the server

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the help of the project simulation, you have the possibility of switching between simulation mode and hardware mode. You can simulate processes for test purposes in simulation mode. In this mode, switching actions are executed, recipes are sent, set values are defined etc. without these operations actually being sent to the process (such as to a PLC for example).

tutorial License information

Must be licensed for Editor and Runtime (single-user, Server, Standby and Client).

All projects must have a license. For single-user projects a license for the client is needed. With server projects, the license must be present on the Server/Standby or locally.

If the licensing is changed at the server, the clients must be restarted for the license to be applied.

Simulation operation

In simulation mode:

  • all drivers are started in mode Driver simulation programmed
  • no data is saved externally
    • SQL evacuation is not executed
    • Entries for IPA database are not created
    • existing IPA entries cannot be deleted, edited or commented
  • PFS shift data are not saved in the database
    (After starting the Runtime in hardware mode the saving is done.)

info Information

Project simulation is not available for clients at the terminal server.

In addition, the simulation image is transferred to the server and is therefore also available to other clients.


Create simulation image (RT in simulation mode) Transfer simulation image to server (RT in hardware mode)

Manual -> Project simulation -> General -> Activate/deactivate project simulation function -> Create simulation image (RT in simulation mode) Transfer simulation image to server (RT in hardware mode)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Here you create a simulation image and save it locally under the given name if you are in simulation mode.

The simulation image is transferred to the server in hardware mode if present and saved there under the given name.

info Information

Here you can create an image of the current statuses and save these. You can then continue at this point with exactly the same requirements.


System driver variable - Runtime status (simulation)

Manual -> Project simulation -> System driver variable - Runtime status (simulation)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Runtime status (simulation) system driver variable indicates the status that Runtime is currently in. You can find the variables under the system info topic. The following statuses are present:

Status | Description
0 | Process connection - Runtime is in hardware mode.
1 | Switch to process connection in simulation
2 | Change to simulation with process connection
3 | In simulation - Runtime is in simulation mode


Scripts

Manual -> Project simulation -> Scripts

The following scripts are available for simulation mode; they are executed automatically:

Script | Description
AUTOSTART_SIMUL | If Runtime is started in simulation mode, the script with the name AUTOSTART_SIMUL is executed automatically if it is available.
AUTOEND_SIMUL | If Runtime is ended in simulation mode, the script with the name AUTOEND_SIMUL is executed automatically if it is available.


Features specific to simulation mode

Manual -> Project simulation -> Features specific to simulation mode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The differences between hardware mode and simulation mode are as follows:

  • The backup directory is not used
  • Archives are not evacuated
  • Archives are only stored in zenon format
  • The Export archive function cannot be executed
  • SQL data evacuation is deactivated for various modules
  • Message Control is deactivated
  • zenon Logic Runtimes are not started
  • No data is exchanged with zenon Logic Runtime by means of zenon drivers
  • No simulation at the zenon web client and under Windows CE.
  • Variables from SB remain without value
  • The driver is not switched between hardware and simulation
  • A script may not be executed fully if a function that requires the Runtime to be restarted is executed in the script.
  • The simulation program which is contained in the driver simulation programmed is also used for the project simulation.
  • In the simulation mode function Save remanent data does not save values for the following drivers:
    • internal driver
    • mathematics driver
    • system driver


Online language translation

Manual -> Project simulation -> Online language translation

Define the texts for language translation for all projects in the start project. You define the function in the start project in the same way. This ensures that you have online text in the correct project. Any possible error messages are also entered into the corresponding project.


Simulation image

Manual -> Project simulation -> Simulation image

to ensure that these are recreated, the values of the driver variables must be saved in the following files:

File name | Description
Drv'Treiber-ID'.sim | In this file, all values of a data point are saved in the respective driver. The files are necessary to recreate all current values in the simulation after Runtime is restarted. If the files were created during simulation mode, an image of the programmable simulation is also contained.
Drv'Treiber-ID'.sim | In this file, the values of the local variables are saved for the respective drivers. If Runtime starts with process coupling and these files were found, the local variables obtain the values from the files. The files are deleted after this. This also happens if Runtime is started manually.
Drv'Treiber-ID'.lssim | saves an image of the local variables that is incorporated into the simulation image.


Files in the simulation image

Manual -> Project simulation -> Files in the simulation image

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If an process image is created for the simulation, files and directories are transferred to the image from various sources. During active simulation, this data is then accessed and no longer on the originals, such as those that are on the computer directory for instance.

The following files are copied to the process image's system directory from the project's system directory:

  • project.mdb
  • rezepturen.cmp
  • rezepturenrt.cmp
  • fpm.cmp
  • password.cmp
  • passwordrt.cmp

and the following directories:

  • system\rgm_fb
  • system\rt_profiles
  • system\reports

All files up to those with the ending *.lsim are taken from the computer directory. For the simulation without image mode, the files *.sim, internvar.bin, sy_ma32.bin and uservar.bin are transferred. For the simulation without archive mode, all files up to those with the ending *.arx and *.ars are transferred.


Runtime Command Line parameters

Manual -> Project simulation -> Runtime Command Line parameters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Runtime recognizes whether it should be started in simulation mode or in hardware mode. If no parameter has been given, Runtime starts in hardware mode. These parameters can also be given for a manual start.

Command line parameters

zenProcess

The zenProcess.exe application is used to restart zenon Runtime when switching between the two modes - simulation mode and hardware mode.

Syntax

zenProcess.exe is called up with the following syntax:

zenprocess.exe parameter1 parameter2 parameter3

  • Parameter 1: SIM or empty:
  • Parameter 2: RESTART=
  • Parameter 3: RTPAR=

Parameters

Parameters

Description

SIM

Display in dialog title.
If this parameter is:

  • set: Dialog title shows "Switch in simulation mode".
  • not set: Dialog title shows "Switch in online mode".

RESTART=

Runtime restart. The path to zenrt32.exe must be provided.

Procedure:

The parameter only has an effect after restarting once Runtime has ended. Runtime itself is not ended by this parameter; to do this, a function must be called up in Runtime. There is a wait until all processes have been ended normally. The number and the names of a maximum of 5 ongoing processes, the end of which is being waited for, are displayed this long. Runtime is restarted after this.

Example: RESTART="d:\zversionen\720_inst\zenrt32.exe"

RTPAR=

Restart in simulation mode or in hardware mode.

  • SIMUL: Runtime is started in simulation mode with the given image name. The computer name is used if no image name is given.
    Syntax: SIMUL="name of the simulation image"
  • REALMODE: Runtime is started in hardware mode with the given image name. There is no transfer in no image name is given.
    Syntax: REALMODE="Abbildname"

Example:

RTPAR="SIMUL=TEST.SIM"

CANCEL

You cancel the switching process with this parameter. Runtime is ended but not restarted.

Example

Start Runtime in simulation modus with an existing image:

zenprocess.exe SIM RESTART="d:\zversionen\720_inst\zenrt32.exe" RTPAR="SIMUL=TEST.SIM"


Limitations

Manual -> Project simulation -> Limitations

The following restrictions are known:

  • Module Batch Control is not supported in the simulation.


Recipegroup Manager

Manual -> Recipegroup Manager

Additionally to the Recipes the Recipegroup Manager offers further functionality:

Tabular layout design (standard format or freely definable format with the Report Generator), free layout design with dynamic elements, recipes accessible via OLE, indirect recipe execution (e.g. depending on a process variable on opening a screen), free grouping.

tutorial License information

Must be licensed for Editor and Runtime (single-user, Server, Standby and Client).

File storage

Up to and including version 7.0, MS Access or binary data could be selected for the RGM as a file storage location. From version 7.10 the MS Access database is no longer supported in the Recipegroup Manager. When opening an existing project the filing is automatically converted to Binary data. You can find details on this in the project conversion handbook in the Converting recipegroup manager database chapter.

For versions before 7.10 with data storage in MS Access active, please note:

  • The maximum text length for response variables is 300 characters
  • In the network, the use of MS Access when using CE devices as a client or server can lead to errors in the Runtime; the binary data format must be used
  • The use of Unicode characters in recipe names, the recipe group or a comment are not supported.


Engineering in the Editor

Manual -> Recipegroup Manager -> Engineering in the Editor

To engineer the RGM, you generally need:

  • a screen of type Recipegroup Manager
  • Recipe groups and Recipes
  • Functions for the operation of the recipegroup manager in the Runtime

Note for the name convention: For recipes alphanumeric characters are allowed. Invalid characters are (\"'./*?<>!|).


Context menu Project manager

Manual -> Recipegroup Manager -> Engineering in the Editor -> Context menu Project manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Menu item | Action
New recipe group | Creates a new recipegroup in the list and opens the name for editing.
Export XML all... | Exports all entries as an XML file.
Import XML | Imports from an XML file.
Profile | Opens the drop-down list in which you can allocate an Editor profile.
Help | Opens online help.


Context menu detail view

Manual -> Recipegroup Manager -> Engineering in the Editor -> Context menu detail view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Toolbar

Parameters | Description
New recipe group | Creates a new recipegroup in the list and opens the name for editing.
Recipe new | Creates a new recipe in the list and opens the cell with the name for editing.
Edit recipe | Opens the dialog with the recipes.
Change variable parameters | Opens the dialog with the recipes.
Create standard function | Opens the dialog for selecting a recipe and defining an action.
Add variable | Opens the dialog for selecting variables.
Remove variable | Deletes selected variables from the list.
Move upwards | Moves the selected variable up.
Move downwards | Moves the selected variable down.
Duplicate | Creates a new recipegroup with the content of the selected recipegroup and assigns a name following this pattern automatically: original name+0, Default10 becomes Default100.
Delete | Deletes selected entry.
Export selected recipegroup XML | Exports selected recipegroup as an XML file.
Import XML | Imports from an XML file.
Import ASCII | Imports from an ASCII file.
Rename | Makes it possible to rename the selected objects.
Help | Opens online help.

Context menu recipegroup

Menu item | Action
New recipe group | Creates a new recipegroup in the list and opens the name for editing.
Export XML all... | Exports all entries as an XML file.
Import XML | Imports recipes and recipe groups from an XML file.
Help | Opens online help.

Context menu selected recipegroup

Menu item

Action

Duplicate

Creates a new recipe group with the content of the selected recipe group and assigns a name following the pattern original name+[consecutive number]:
Default10 becomes Default100, and Default101 if it is duplicated again ...

Note: with the group of linked recipe variables, replacement can take place in a rule-based manner during duplication.

Delete

Deletes the selected recipegroup after a confirmation message.

Equipment groups...

Opens the dialog for selecting an Equipment group.

Export selected recipegroup XML

Exports selected recipegroup as an XML file.

Import XML

Imports from an XML file.

Rename

Opens the cell with the name of the recipegroup for editing.

Help

Opens online help.

Context menu variable

Menu item | Action
Add variable | Opens the dialog for selecting variables.
Change variable parameters | Opens the dialog with the recipes.
Help | Opens online help.

Context menu selected variable

Menu item | Action
Remove variable | Deletes variable from the list.
Move upwards | Moves variable in a list up one place.
Move downwards | Moves variable in a list down one place.
Help | Opens online help.

Context menu Recipes

Menu item | Action
Recipe new | Creates a new recipe in the list and opens the cell with the name for editing.
Import ASCII | Imports from an ASCII file.
Help | Opens online help.

Context menu selected recipe

Menu item | Action
Edit recipe | Opens the dialog with the recipes.
Create new recipe version | Creates a new version of the recipe.
Create standard function | Opens the dialog for selecting a recipe and defining an action.
Duplicate as recipe version | Creates a new version of the selected recipe.
Duplicate | Creates a new recipe group with the content of the selected recipe group and assigns a name following the pattern original name+[consecutive number]: Default10 becomes Default100, and Default101 if it is duplicated again ... Note: Source variables for the Link to variable action can be replaced when the recipe is duplicated.
Delete | Deletes selected recipe after a confirmation message.
Export selected recipe XML | Exports the selected recipe as an XML file.
Rename | Opens the cell with the name of the recipe for editing.
Help | Opens online help.


Create screen of type Recipegroup manager

Manual -> Recipegroup Manager -> Engineering in the Editor -> Create screen of type Recipegroup manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Individual recipes and grouped recipes in Runtime are administered by using a screen for the Recipe Group Manager.

You create a screen of type Recipegroup Manager in the Editor by creating a new screen and choosing the type Recipegroup Manager.(For more information about pre-defined screen types see chapter Screens->Kinds of screen types.) In order to create screen Recipegroup Manager:

  • create a new screen
  • select as screen type Recipegroup Manager from the drop-down list.
  • open the screen
  • select menu item Add template from menu Control elements or select individual control element.
  • configure the screen

With the help of the control elements you can carry out actions in the Runtime.

info Information

During reading, exporting, importing and saving of recipes in the Runtime, a progress bar informs you about the progress of the action. For details see chapter Creation of system driver variables for standard recipes and Recipegroup Manager

Control elements

Control element

Description

Insert template

Opens the dialog for selecting a template for the screen type.

Templates are shipped together with zenon and can also be created by the user.

Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.

Information

Information on recipes, users and changes

Recipegroup name

Name or selection of the current recipe group.

Recipe list

Displays all recipe/recipe versions as a list. The selection only contains recipes which are included in the recipe filter of function screen switch at the call up of the screen.

One respective entry can be selected in Runtime. The selected recipe is displayed on the screen and can be edited.

If the Recipe name and/or Recipe version control elements are used, the selection is always synchronized. If the selection in the control element is changed, the selection in the recipe list changes and vice versa. If a filter criterion excludes the selected entry in the list, nothing is selected in the list.

Note:

  • New recipes are added to the bottom of the list, regardless of the filter criteria.
  • Changes to recipe data are only displayed once the recipe is saved.
  • The language can be switched with the following list contents:
    - Headings in the header
    - Comment text
    - Recipe status texts

Recipe name

Drop-down list with recipe names to select the the recipe to be displayed.

Recipe number

Recipe number that is searched for after pressing the Find recipe number button

Recipe version

Creates a drop-down list that contains all version numbers of the selected recipe in Runtime.

Recipe state

Creates a drop-down list that contains all configures statuses in Runtime. The current status of the selected recipe version is displayed.

The status can be changed here in Runtime. It is only accepted after the recipe is saved.

Hint: The change of status in Runtime can be monitored and/or cancelled in Runtime with the StatusChange VBA event.

Recipe Value List

Display of the current recipe in a table The table can be configured directly in Runtime.

Note: Not available under Windows CE. Is replaced by the Recipe value table (outdated) there.

Column selection (recipe value table)

Opens the dialog for selecting the columns which should be displayed.

Is not available for CE recipe value table.

Column selection (recipe value table)

Opens the dialog to format the columns..

Is not available for CE recipe value table.

Recipe Value List CE

Display of the selected recipe in fixed table form. Replaces the recipe value table under Windows CE.

Column selection

Opens the dialog for selecting the columns of the recipe value table to be displayed.

Note: Not available for CE recipe value table.

Column Format

Opens the dialog to format the columns of the recipe value table.

Note: Not available for CE recipe value table.

Recipe Filter

Drop-down list with recipe filter.

User name

Name of user who last changed the current recipe

Last modified time

Date and time the current recipe was last changed

Writing progress

Graphic display of the duration for which a recipe is sent.

Edit

Control elements to edit the information.

Filter

Define filter options for the recipe window.

In the Runtime you can use the drop-down list to filter the displayed variables according to the Filter texts defined beforehand.

Read selected values

The values of the variables selected in the table are read from the process and entered into the table. Changes have to be saved!

Write selected values

The values of the variables selected in the table are written to the process as displayed in the table.

Read all values

The values of the variables of the selected recipe are read from the process and entered into the table. Changes have to be saved!

Read & save all values

Write the values of the process directly to the current recipe and save it immediately

Write all values

The values of the variables of the selected recipe are written to the process as displayed in the table.

All values ++

All values of the selected recipe are increased by 1

All value - -

All values of the selected recipe are decreased by 1

Change all values %

When the button is pressed in Runtime, all values of the selected recipe are changed by the percentage value given in the Value % change editing window, depending on the prefix:

  • Plus prefix (+): Value is increased accordingly
    Example: +20% -> 100 becomes 120
  • Minus prefix (-): Value is reduced accordingly
    Example: -20% -> 100 becomes 80
  • No prefix: Percentage value of the current value becomes new value
    Example: 20% -> 100 becomes 20

% (input field)

All values of the selected recipe are increased (+) or decreased (-) by the percentage entered here after the button ”all values %” is pressed

Change all values with formula

All values of the selected recipe are changed by the mathematical operation entered in the element value math.

Exactly one operation can be carried out. This affects all numerical variables.

Addition (+), subtraction (-), multiplication (*) and division (/) are possible.

The value in the recipe corresponds to the left operand, the user defines the operation in the Formula field and the right operands.
This means: $NewValue = $CurrentValue $Formula field.
$Formula field must contain an operator.

Example:

  • Entry in field Formula +100
  • Result: All values are increased by 100.

Attention: Only one operator can be entered. Several operations lead to unforeseen results. For example, the entry /250+5 would increase all values by 2505.

Formula (input field)

All values of the selected recipe are changed by the mathematical operation entered here after the button Change all values math formula is pressed

Print list

Prints out the table on the defined printer.

Only available for CE recipe value table.
The recipe value table can be printed using the Report Viewer.

Export/Import

Control elements for export and import.

Export recipe group (XML)

Exports recipe group to an XML file.

Export recipe (TXT)

Exports current recipe to a TXT file.

Import recipe (TXT)

Imports current recipe from a TXT file.

Export recipe (XML)

Exports current recipe to an XML file.

Importing an XML file

Imports recipe or recipe group from an XML file.

If the file has individual recipes, a recipe group must be selected for import.

Administering recipes

Control elements for recipe management.

New Recipe

Create a new recipe

Rename recipe

Rename current recipe

Save recipe

Save current recipe under the same name

Recipe save as

Save current recipe under a different name The new recipe only contains the properties saved in the original recipe.

Delete recipe

Delete current recipe

New recipe version

Creates a new version of the recipe. The values of the newly created recipe version are filled with the values of the replacement values.

Hint: This action can be checked with the VersionCreate VBA event.

Duplicate recipe version

Duplicates selected recipe version. A new version is created and the recipe values are filled with the values of the previously selected version.

Hint: This action can be checked with the VersionDuplicate VBA event.

Duplicate and read recipe version

Duplicates selected recipe version and then reads it in.

Firstly, a new version of the selected recipe is set up. The recipe values are filled with the values of the selected version. The values for the new version are then read in by the PLC.

Hint: This action can be checked with the VersionDuplicateRead VBA event.

Delete recipe version

Deletes selected recipe version. If the selected recipe version is the last remaining version of this recipe, the whole recipe is thus deleted.

Hint: This action can be checked with the VersionDelete VBA event.

Set status 1 - 10

Sets one of ten possible statuses.

The function sets the status value (1 - 10) to the recipe currently selected in the screen. To accept the status in the recipe, the recipe must then be saved.

Only statuses that were also configured in the Recipe Group Manager are set. If a status value that is not available is set, the system driver variable for RGM recipe function in processing is set to an error and a CEL entry is generated.

Note: The status selected with this button is displayed in the Recipe status drop-down list. The list of recipes, in contrast, always displays the status of the recipe as in the data storage. The change of status is only actually accepted after the change of status and is then displayed in the list of recipes.

Check recipe values

To test the recipe values, all variables that are linked to the recipe are read and the current recipe values are compared.
The results are displayed in the Actual value column in color.

  • Green: Results correspond.
  • Red: There are deviations.
  • Violet: No connection to the PLC.

Attention: The function of the control element uses decimal points for synchronization with the PLC. If, for variables with the REAL data type, the Decimals property is not configured along the lines of the PLC settings and the values in the decimal point area are different, the function displays different values.

Recipe group

Control elements for the recipe group.

New recipe group

Create a new recipe group

Recipe group edit

Edit current recipe group

Rename recipe group

Rename current recipe group

Recipe group save

Save current recipe group under the same name

Recipe group save as

Save current recipe group under a different name

Recipe group delete

Delete current recipe group

Comment

Control elements for comments.

Comment 1 - 8

Comment lines for the current recipe.

Up to 8 comments are possible.

The comment fields have a Representation/Translate displayed text property.

Comment fields are also written during XML export and import.

In VBA, the comment fields can be read and written to using the DynProperties (name "Commentn", n=1 to 8) in the "Recipes" object

Navigation recipe list

Recipe group <

Move to the previous recipe group

Recipe group >

Move to the next recipe group

First recipe groups

Move to the first recipe group

Last recipe groups

Move to the last recipe group

Recipe <

Move to the previous recipe in the current recipe group

Recipe >

Move to the next recipe in the current recipe group

Recipe <<

Move to the first recipe in the current recipe group

Last recipe

Move to the last recipe in the current recipe group

Recipe number

Move to the recipe with the number entered.

Find recipe number

Display the first recipe with the number entered in the element ”source recipe number”

Previous version

On the previous version.

Next version

On the next version.

Version <<

On the first version.

Version >>

On the last version.

Navigation recipe value list CE

Line up

Move one line up in the table

Line down

Move one line down in the table

Column right

Move one column right in the table

Column left

Move one column left in the table

Page up

Move one page up in the table

Page down

Move one page down in the table

Page right

Move one page right in the table

Page left

Move one page left in the table

info Information

A decimal value can be entered with either a comma or a point as a decimal separator, it will automatically be changed to a point.


Appearance of the recipe list

Manual -> Recipegroup Manager -> Engineering in the Editor -> Create screen of type Recipegroup manager -> Appearance of the recipe list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The table view of the recipe list can be adapted to individual requirements:

Column settings

The column settings for display in Runtime are set during configuration of screen switching. For details, see the Recipe list column settings section.

Scroll bars

To define the size and appearance of scroll bars for the table:

  1. Activate, in the Representation group, the Extended graphical settings property
  2. Define the desired properties in the groups Scroll bars and Header and grid

info Information

If the Graphics file property is selected for the Display style property, then all elements for which no graphics file has been selected are shown with a color gradient. Transparent graphics cannot be used for control elements for lists.

Row height

The row height can be adjusted, regardless of the font size, using the Representation/Line height [pixel] property.

The default value is 0 pixels. The row height is thus set regardless of the font size. Each value above 0 defines a fixed value in pixels for the row height. If a line height is defined, then graphical illustrations are not scaled according to the line height but adapted to the font size.

Attention: If the row height

  • is selected is too large, nothing is displayed in Runtime in certain circumstances.
  • is selected as smaller than the font size, then graphical illustrations are cut off.

Preview

By activating the Representation/Extended graphical settings property in the Editor, the header and scroll bars can be previewed. This way, details such as color fill effects, light effects or grids can be configured more easily.

Attention: As the size of the scroll bars equals their size in the Runtime, the total size of the list in the Editor can vary from the size in the Runtime. This is also true for the size of the header and the font of the header.


Creating a Recipegroup

Manual -> Recipegroup Manager -> Engineering in the Editor -> Creating a Recipegroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a new recipe group:

  1. If you select the Recipes/Recipegroup manager node or the New recipe group command in the detail view.
  2. A new recipe group with a standard name is created. The name is already highlighted for further editing.
    Attention: If the recipe group is to be used as binary data, the name may only contain alphanumerical characters.
  3. Variables and recipes must be added to each recipe group.
    Note: A maximum of 32,000 variables can be added to a recipe group.


Variables for recipe groups

Manual -> Recipegroup Manager -> Engineering in the Editor -> Variables for recipe groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A recipe group consists of the assigned process variables and the recipes. All process variables required in the recipes must first be inserted in the Variable submenu using the context menu.

To set up variables:

  1. Right-click on Variable
  2. Select the Insert variable entry in the context menu
  3. The dialog for selecting several variables is opened
  4. Select the desired variables
    Note: Variables from other projects that have been loaded can also be selected. Ensure that these projects are also available in Runtime. A maximum total of 32,000 variables per recipe group can be configured.
  5. Confirm the configuration by clicking on the button OK.

It is possible to configure separate corresponding limits for minimum and maximum values for the individual variables.

info Information

Archivfüllwert is used as a standard value:

  • For variables of new recipes
  • When adding variables to a recipe group in new recipes

info Information

Either a comma or a decimal point can be used as a decimal separator. The decimal separator is automatically changed to a decimal point.

Sorting variables

You can sort variables in the Recipegroup Manager as you wish.

Select the variable that you want to change the sequence of and choose one of the following actions:

- choose up or down in the context menu
- move variables via drag&drop

Alternatively, you can move variables in the variable selection dialog with the arrow buttons in the lower right corner.

Deleting variables

To remove variables:

  1. Highlight the desired variables
    (multiple selection is possible)
  2. Right-click on the highlighted variables
  3. Select the Remove variable command in the context menu
  4. The variables are removed after a request to confirm this
    Note: The variables are only removed from the recipe group, but remain in the project.


Change variable parameters

Manual -> Recipegroup Manager -> Engineering in the Editor -> Variables for recipe groups -> Change variable parameters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Select menu item Change variable parameter in the context menu of Variables.

In the dialog you can make the following settings.

Parameters

Description

Variable name

In this column all variables are displayed which are used in this recipe group.

min. value

Define the minimal value of the variable.

Note: Binary variables have 0 as a minimum value. This value cannot be changed.

max. value

Define the maximal value of the variable.

Note: Binary variables have 1 as a maximum value. This value cannot be changed.

Set value limit of the variables

Taking into account the set value limit of variables.

Interlocking

Select the desired interlocking from the drop-down list. (See also Interlocking and visibility)

Visibility

Choose a fitting variable by right clicking and selecting menu item Variable selection. As an alternative you can enter the name of the variable directly. (See also Interlocking and visibility)

Filter

Enter a filter text. (See also Filter.)

Keyboard

You can link a screen of type Keyboard for each variable in this column. Choose a fitting screen by right clicking and selecting menu item Screen selection. As an alternative you can enter the name of the screen directly.

In the Runtime the linked screen keyboard is called up when you click on the value of the variable. It is no longer possible to enter values directly. After you leave the screen keyboard with OK, the new value is entered in the recipe value list. In addition, the 'Setpoint input' screen function is available. With one click you can transfer a setpoint which you defined beforehand.

Graphic recipe variable

Linking of a graphic recipe variable.

info Information

Controlling the visibility of variables

You have the following available to control the visibility and operation of variables:

  • Filter: Defines terms according to which variables can be filtered. Variables that do not fit in the filter are not displayed. Filters are controlled by the user.
  • Visibility: Controls the display of variables in the list using the limit value of a variable. Variables that were set to "not visible" are not displayed. Visibility is controlled by the process.
  • Authorization: Defines the permissions with which a variable can be changed. Variables for which the user does not have permission are displayed but cannot be operated. Permissions are controlled by the person that configures the project and the administrator.


Interlocking and visibility

Manual -> Recipegroup Manager -> Engineering in the Editor -> Variables for recipe groups -> Change variable parameters -> Interlocking and visibility

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can forbid users the access to certain areas of the recipe table by using either interlocking or visibility. The difference is that with interlocking the corresponding area is grayed out and with visibility it is not displayed at all.

Interlocking

You allocate an interlocking to each variable in the column or by means of the Interlocking property. Select the desired interlocking from the drop-down list. Additional interlockings can be configured in the Interlockings module.

In Runtime, the line is displayed as normal or grayed out depending on the status of the interlocking. The colors for text and background can be defined individually using the properties of the RGM (Colors/Interlocking group).

You can find more information in chapter Interlocking.

info Information

Display with report functions of the Report Generator:

The name of the interlocking is not available in Runtime. This means that interlocking IDs are displayed in the recipe list only when the interlocking is displayed with the help of functions recipew or recipef.

VBA and XML import

The following is applicable for XML import of interlockings:

  • Name of the interlocking exists in the project: Interlocking for the recipe variable from the import file replaces the existing one for the interlocking configured for the recipe variable.
  • Name of the interlocking does not exist in the project: The interlocking is removed.
    An empty string in the import file can be used so that interlockings that are configured for the recipe variable can be removed as a parameter for the recipe variable.

This applies along the same lines as for the editing of recipe variables using VBA.

Visibility

You allocate a visibility to each variable in the column visibility. To do this:

  1. Right-click in the cell and select the variable that is to control the visibility or enter the name directly into the cell
  2. Define a limit value for the variable

As soon as the controlling variable exceeds the defined limit value, the assigned variable in the recipe table is hidden.

info Information

The recipe value list CE is refreshed after every change of an allocated state. When configuring, keep in mind that changing the allocated states too frequently can lead to performance problems during operation.

This does not affect the Recipe value list. This only edits the entries that have changed.


Filter

Manual -> Recipegroup Manager -> Engineering in the Editor -> Variables for recipe groups -> Change variable parameters -> Filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Filters make it possible to hide recipes at user level.

Filters are defined using the Filter text property for the variables in the detail view of the RGM. The variables are assigned a freely selectable filter term. This filter text is used in the screen Recipegroup Manager in order to reduce the display of variables. This filter can be set:

  • This is carried out in Runtime in the Recipe Group Manager screen using the Recipe filter drop-down list
  • When screen switching to the Recipe Group Manager screen

If no filter has been explicitly selected, all variables that have been set to invisible are displayed.

info Information

The filtering is only related to the display of the recipe value list. If a recipe is sent to the control, for example, all values of the recipe are written.


Acknowledgement variables

Manual -> Recipegroup Manager -> Engineering in the Editor -> Variables for recipe groups -> Acknowledgement variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Variables can be linked to each recipe group, which are provided with recipe data for the actions of writing, reading, checking and XML import. These RGM-specific acknowledgement variables act like the global system driver variables, but are assigned to individual recipe groups. Therefore several recipe groups can be evaluated in parallel.

It is possible to link as many variables as you want.
Note for versions before zenon 7.10 SP0: If the DataSource property is set to MS Access, the text length is a maximum of 300 characters. The binary file storage is used automatically from version 7.10.

The following recipe data can be set to variables:

  • Recipe name
  • Recipe number
  • Recipe version
  • Recipe status as text
    (in the form "1 - Text", whereby the text is not translated, which can however be released via the display element)
  • Recipe status as number
  • Recipe authorization level
  • Time of the last change
  • User that made the last change
  • Comments 1 - 8

Creating an acknowledgement variable

To create an acknowledgement variable:

  1. Highlight the recipe group
  2. Navigate to the desired node
    • Write feedback recipe
    • Read feedback recipe
    • Check feedback recipe value
    • Feedback XML import
  3. Click on the ... button next to the desired property
  4. The dialog for linking variables is opened

You can find notes on the individual properties in the help for the respective property. The result is provided locally and to the network for all actions by means of system driver variables.

info Information

Changes made via VBA are only visible after the after the RGM has been opened again.


Adding recipes to a recipegroup

Manual -> Recipegroup Manager -> Engineering in the Editor -> Adding recipes to a recipegroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To add a recipe to a recipe group:

  1. Right-click on the Recipe node in the desired recipe group
  2. Select New recipe in the context menu.
  3. A new recipe with a standard name is created; the name is already highlighted for further processing
  4. assign the desired properties to name, number, version, authorization and comment

info Information

If the recipe is to be used as binary file, the name may only contain alphanumerical characters.

Issuing a name during creation

New recipes are created with a default name, e.g. recipe_0. In addition a recipe number is assigned to each new recipe. For each new recipe the recipe number is increased incrementally.

The recipe name must be unique. The recipe number is not checked for uniqueness. It is only used in order to call a recipe via a variable with the help of function Recipegroup Manager. If several recipes with the same number exist, zenon uses the recipe it finds first.

Example Example

There is already a Recipe_0 with the recipe number 0 and a Recipe_2 with the recipe number 2. When being newly created, a recipe with the name Recipe_1 and the recipe number 3 is created.


Editing a recipe from a recipegroup

Manual -> Recipegroup Manager -> Engineering in the Editor -> Adding recipes to a recipegroup -> Editing a recipe from a recipegroup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to edit a recipe from a recipe group:

  • right-click on a recipe
  • select the command edit recipe
  • The dialog Recipe groups is opened

Entry

Description

General

Recipe number

Number of the recipe

Write synchronously

Active: When writing a recipe, all control elements are locked in the Recipe Group Manager screen until the driver confirms that all values have been written successfully or the defined time-out has expired.

Inactive: The values of the recipe are written without waiting for a confirmation. The control elements can be used again immediately. The confirmation of the driver is done with the status bit WR-SUC, which is set to 1, when values have been written successfully.
Note:

  • This setting can be changed in the Runtime in the screen of the recipegroup manager with the button Rename recipe.
  • The progress bar only works if this property is active.

Timeout [ms]

If Write synchronously is activated in a recipe, here the timeout can be defined. The control elements of the Recipe Group Manager screen can be operated once again after this time at the latest.
If, in Timeout, the value 0 is entered, zenon calculates the timeout in the following way:
30000+(100*number of datapoints)
Hint: This setting can be changed in the Runtime in the screen of the recipegroup manager with the button Rename recipe.

Authorization level

Only users with the authorization level entered here are allowed to change the recipe in the Runtime. This not only means manually editing the recipe in the screen of the recipe group manager but also renaming and deleting the recipe as well as reading its values from the hardware.
Note: Recipe groups can only be changed by users, which have the authorization for all recipes of the according recipe group.

Lists entries

Variable name

Name of a variable.

Display only, cannot be changed.

min. value

Minimum value of variable

Display only, cannot be changed.

max. value

Maximum value of variable

Display only, cannot be changed.

Action

Function which is carried out on variables.

Entry can be edited in the list. For details, see the Actions chapter.

Value or variable

Value which is transferred to the control when the recipe is written.

Value dependent on action, can be edited in the list.

Measuring unit

Unit of a variable.

Display only, cannot be changed.

Editing in Runtime: For details see Operation in Runtime chapter.

info Information

The following is applicable for recipes in the RGM:

  • The recipe name must be unique.
  • The recipe number is not checked for uniqueness. It is only used in order to call a recipe via a variable with the help of function Recipegroup Manager. If several recipes with the same number exist, zenon uses the recipe it finds first.
  • The length of a string for an RGM recipe is limited to 249 characters.


Actions

Manual -> Recipegroup Manager -> Engineering in the Editor -> Adding recipes to a recipegroup -> Editing a recipe from a recipegroup -> Actions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To define an action, click on the respective variable in line Action. Click on the symbol with the arrow and select the desired action from the drop-down list. If you need entries in cell Value or variable, click in the cell and enter a value. For a variable selection right click in the cell in order to open the selection dialog.

Action

Description

Entry in Value or variable

No action

Deactivates a variable in this recipe

No input.

User status

Status information. Sets the according status bit of the variable.

Note: You can only set status bits which were tagged as set by the user. Status bits which were automatically set by the system cannot be changed.

Attention: In order to be able to call up a keyboard in Runtime, a keyboard must be linked in the Keyboards properties group for the String tags property.

Enter status short label:
=1 to set
=0 to reset

You can enter more states separating them by semicolon (;). For example:
M1=1; M5=0

Modify alternate value

Sets the Alternate value to the value stated under Value or variable.

Enter Alternate value.

Modify spontaneous value

Sets the Spontaneous value to the value stated under Value or variable.

Enter set value.

Switch off spontaneous value

Switches off the spontaneous value by setting status bit OFF (Bit 20).

No input.

Switch on spontaneous value

Switches on spontaneous value by resetting OFF bit.

No input.

Switch to alternate value

Switches from Spontaneous value to Alternate value

No input.

Switch to spontaneous value

Switches from Alternate value to Spontaneous value

No input.

Switch to and modify Alternate value

Switches from Spontaneous value to Alternate value and sets the alternate value to the value stated under Value or variable.

Enter Alternate value.

Switch and modified spontaneous value

Switches from Alternate value to Spontaneous value and sets the spontaneous value to the value stated under Value or variable.

Enter set value.

Link with variable

Links a variable with another variable.

Name of a variable.

Right-click the field in order to open the context menu in which you can open the dialog for selecting variables. The value of the variable is transferred to the selected recipe variable. It is also possible to use variables of other loaded projects.

attention Attention

If the Read all values function is used with the Link with variable action for a recipe, neither user authorization is checked nor is the action logged. If you want a logging, you must create it manually, e.g. using a VBA macro.

Note for FDA regulations: As a consequence, this functionality is not allowed to be used for projects with a strict FDA standard!


Check write set value

Manual -> Recipegroup Manager -> Engineering in the Editor -> Adding recipes to a recipegroup -> Editing a recipe from a recipegroup -> Actions -> Check write set value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Check write set value

When writing values, the value receives a status bit that is has been written. If the writting process is successful, the corresponding status bit is set:

  • WR-ACK

    The driver received a value for writing.

  • WR-SUC

    Value 1: Writing successful.

    Value 0: Writing not successful. The value could not be written.

info Information

In case of reload or Server-Standby switch, the currently active responses or writing affirmations are discarded.

This status combination are active until the next value change is triggered. Then both states are set to 0 until the writing action is finished. For evaluation the following bit combination must be requested in the reaction matrix:

WR-ACK, WR-SUC

Result:

  • WR-ACK 1, WR-SUC 1: Writing action successful.
  • WR-ACK 1, WR-SUC 0: Writing action not successful.

attention Attention

The mechanism only shows, that the writing action was successful (or not successful) to the PLC. This does not mean, that the value has indeed been changed in the PLC, since the PLC can reset/overwrite the value immediately. (For example for writing the outputs or the transient bits which are only set for a short time.)

Modules

This mechanism can be used in the following modules:

  • function Write set value: Activate option Wait for writing confirmation in the configuration dialog of the function.
  • Standard recipes: Activate property Write synchronously.
  • Recipegroup Manager: Activate property Write synchronously.
  • Command Processing

Entry in CEL

  • Function Write set value

    For the entry in the CEL you must activate property Function Set SV in node Chronological Event List in the project settings. After this the positive or negative response the execution of the function is written to the CEL.

  • Standard recipes and Recipegroup Manager

    For the entry in the CEL a system driver variable is used which is set to 1 when a recipe is written successfully. A global variable is evaluated on the Server, a local variable on every Client in order to determine when the recipe executed last was written completely.
    With this variables a CEL entry can be created via limit or reaction matrix. The query is carried out via a multi analog or a multi binary reaction matrix.


Recipe version

Manual -> Recipegroup Manager -> Engineering in the Editor -> Recipe version

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Recipes can be versioned. The versions can be administered in Runtime using the settings in the Editor and functions and control elements in Runtime.

To create a new recipe version in the Editor, you have two possibilities:

  1. New recipe version: Creates a new version of the selected recipe.
    To do this:
    1. Highlight the recipe in the detail view of the Recipe Group Manager
    2. Select the Create new recipe version command in the context menu

    or

  2. Duplicating a recipe version: Creates a copy of the selected recipe version as new version.
    To do this:
    1. highlight the recipe version in the detail view of the RGM
    2. select the Duplicate as recipe version command in the context menu

A new version of the recipe is created and inserted below the recipe. The version number is automatically issued in the Recipe version property. The number of available versions is displayed to the right of the original recipe.

To create a new recipe version in Runtime, use the Create new recipe version function.

info Information

A maximum of 89999 recipe versions can be created.


Recipe state

Manual -> Recipegroup Manager -> Engineering in the Editor -> Recipe state

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The recipe status is used for identifying and filtering a recipe with:

  • State property for recipe
  • RGM screen
  • Screen switching to RGM function
  • Recipegroup Manager function

It consists of an index given by zenon and an individual status text. The recipe status can be set differently for each recipe version. This property can be changed using functions and control elements in the screen in Runtime.

To create a recipe status:

  1. Highlight the name 'Recipe Groups' in the detail view of the Recipe Group Manager
  2. click on property Identifier recipe state
  3. The dialog for configuring the recipe status is opened

Parameters

Description

Identifier recipe state

Creating and administering the name for the recipe status.

#

Status index. This is issued automatically.

Status text

Status text is defined as in this dialog:

  • Creation: Click on New button.
  • Edit: A mouse click in the text allows editing.

This text can also contain keywords (with a prefix of @) for language switching.

New

Creates new status at the end of the list.

Delete

Deletes highlighted status text.

If the status to be deleted is at the end of the list, the status text and index number are deleted.

If the status to be deleted is not at the end of the list, the text is deleted but the index is left. This way the gaps can be refilled again later.

OK

Accepts input and closes dialog.

Cancel

Discards all changes and closes the dialog.

Help

Opens online help.


List of status bits

Manual -> Recipegroup Manager -> Engineering in the Editor -> List of status bits

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Short term | Long name | zenon Logic label
0 | M1 | User status 1 | _VSB_ST_M1
1 | M2 | User status 2 | _VSB_ST_M2
2 | M3 | User status 3 | _VSB_ST_M3
3 | M4 | User status 4 | _VSB_ST_M4
4 | M5 | User status 5 | _VSB_ST_M5
5 | M6 | User status 6 | _VSB_ST_M6
6 | M7 | User status 7 | _VSB_ST_M7
7 | M8 | User status 8 | _VSB_ST_M8
8 | NET_SEL | Select in the network | _VSB_SELEC
9 | REVISION | Revision | _VSB_REV
10 | PROGRESS | In operation | _VSB_DIREC
11 | TIMEOUT | Runtime exceedance | _VSB_RTE
12 | MAN_VAL | Manual value | _VSB_MVALUE
13 | M14 | User status 14 | _VSB_ST_14
14 | M15 | User status 15 | _VSB_ST_15
15 | M16 | User status 16 | _VSB_ST_16
16 | GI | General interrogation | _VSB_GR
17 | SPONT | Spontaneous | _VSB_SPONT
18 | INVALID | Invalid | _VSB_I_BIT
19 | T_CHG_A | Daylight saving time/winter time announcement | _VSB_SUWI
20 | OFF | Switched off | _VSB_N_UPD
21 | T_EXTERN | Real time external | _VSB_RT_E
22 | T_INTERN | Realtime internal | _VSB_RT_I
23 | N_SORTAB | Not sortable | _VSB_NSORT
24 | FM_TR | Error message transformer value | _VSB_DM_TR
25 | RM_TR | Working message transformer value | _VSB_RM_TR
26 | INFO | Information for the variable | _VSB_INFO
27 | ALT_VAL | Alternate value If no value was transferred, the defined alternate value is used otherwise the last valid value is used. | _VSB_AVALUE
28 | RES28 | Reserved for internal use (alarm flashing) | _VSB_RES28
29 | N_UPDATE | Not updated | _VSB_ACTUAL
30 | T_STD | Standard time | _VSB_WINTER
31 | RES31 | Reserved for internal use (alarm flashing) | _VSB_RES31
32 | COT0 | Cause of transmission bit 1 | _VSB_TCB0
33 | COT1 | Cause of transmission bit 2 | _VSB_TCB1
34 | COT2 | Cause of transmission bit 3 | _VSB_TCB2
35 | COT3 | Cause of transmission bit 4 | _VSB_TCB3
36 | COT4 | Cause of transmission bit 5 | _VSB_TCB4
37 | COT5 | Cause of transmission bit 6 | _VSB_TCB5
38 | N_CONF | Negative acceptance of Select by device (IEC 60870) | _VSB_PN_BIT
39 | TEST | Test bit (IEC870 [T]) | _VSB_T_BIT
40 | WR_ACK | Writing acknowledged | _VSB_WR_ACK
41 | WR_SUC | Writing successful | _VSB_WR_SUC
42 | NORM | Normal status | _VSB_NORM
43 | N_NORM | Deviation normal status | _VSB_ABNORM
44 | BL_870 | IEC 60870 Status: blocked | _VSB_BL_BIT
45 | SB_870 | IEC 60870 Status: substituted | _VSB_SP_BIT
46 | NT_870 | IEC 60870 Status: not topical | _VSB_NT_BIT
47 | OV_870 | IEC 60870 Status: overflow | _VSB_OV_BIT
48 | SE_870 | IEC 60870 Status: select | _VSB_SE_BIT
49 | T_INVAL | Time invalid | not defined
50 | CB_TRIP | Breaker tripping detected | not defined
51 | CB_TR_I | Breaker tripping detection inactive | not defined
52 | RES52 | reserved | not defined
53 | RES53 | reserved | not defined
54 | RES54 | reserved | not defined
55 | RES55 | reserved | not defined
56 | RES56 | reserved | not defined
57 | RES57 | reserved | not defined
58 | RES58 | reserved | not defined
59 | RES59 | reserved | not defined
60 | RES60 | reserved | not defined
61 | RES61 | reserved | not defined
62 | RES62 | reserved | not defined
63 | RES63 | reserved | not defined

info Information

In formulas all status bits are available. For other use the availability can be reduced.

You can read details on status processing in the Status processing chapter.


Windows CE

Manual -> Recipegroup Manager -> Engineering in the Editor -> Windows CE

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Filter dialog in the Runtime

If you activate property Show dialog in the Runtime at the options of the Recipe value list in the screen switch, there are only restricted options available in Windows CE:

  • Recipe Filter
  • Column settings (for recipe table)

Recipe selection, Equipment modeling and column settings for the recipe list are not available.


Functions

Manual -> Recipegroup Manager -> Functions

When the standard function is created from the context menu in the detail view, zenon automatically creates a function Recipegroup manager for the selected recipe.


Function screen switch Recipegroup Manager

Manual -> Recipegroup Manager -> Functions -> Function screen switch Recipegroup Manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With screen switching to a Recipe Group Manager screen, you define a recipe that is to be sent when switching. These settings can also be made in Runtime, if the Offer dialog in Runtime option is active.

To configure screen switching:

  1. create a new function
  2. select Screen switch
  3. Select the Recipe Group Manager screen
  4. Select your settings in the individual tabs
    • Recipe value table: Settings for the recipe.
    • Recipe value table column setting: Settings for display in Runtime.
    • Recipe filter: Definition of recipes of a recipe group that should be displayed in a Recipe Group Manager screen.
    • Recipe list column settings: Settings for the display of the recipe lists.
    • Equipment modeling: Selection of equipment models.

info Information

You can find the settings for visibility of variables in Runtime in:

  • Changing variable parameters: Filter, Visibility
  • Editing recipe from a recipe group: Authorization levels

These settings only relate to the display in the recipe table. If a recipe is sent to the control, for example, all values of the recipe are written.


Recipe Value List

Manual -> Recipegroup Manager -> Functions -> Function screen switch Recipegroup Manager -> Recipe Value List

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab, the recipe that is displayed in the recipe value table is selected. The recipe value table is available in two versions:

  • Recipe value table: Table that can be configured in Runtime directly. Not available for Windows CE.
  • Recipe Value List CE: Display of the selected recipe in fixed table form. Replaces the recipe value table under Windows CE.

Both tables can be configured in the Editor. However only one of the two tables can be inserted into a screen. The recipe value table is recommended for all tables with the exception of Windows CE. The configuration of the screen switching can be different for both tables. If a recipe value table is automatically replaced by a recipe value table (CE) under Windows CE, the settings of the original screen switching are applied.

Configuration

Recipe groups selection/recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables
  • From a file

Clicking on Property opens a drop-down list to select the method.

Parameters

Description

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Note: If the recipe selection leads to an error in Runtime (recipe not present in Runtime, no selection made, recipe not contained in the filter), then no recipe is selected and the display of the drop-down list Recipe remains empty.

Static recipe:

Selection of a recipe that has already been created.

Recipe name from variable:

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe number from variable:

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first. If the variable values are invalid, no recipes are opened.

Recipe version

Selection of recipe version from existing versions or using a variable.

Static recipe version:

Selection of an existing recipe version from drop-down list. Possible selection:

  • Pre-existing recipe version
  • Smallest version;
    additional selection of a recipe status possible
  • Largest version;
    additional selection of a recipe status possible

Recipe version from variable:

Recipe version is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe version is obtained from a numerical variable, the following applies:

  • Value 90000 corresponds to static lowest recipe version
  • Value 90001 corresponds to static highest recipe version

Recipe state

Selection of recipe status from existing status or using a variable.

Recipe status:

The recipe status is evaluated in combination with the version. Only available if the recipe version has the value largest version or smallest version or is taken from a variable.
Example: Largest version with status released.

Selection of a recipe status from drop-down list:

  • Existing status
  • All

Recipe status from variable:

Recipe status is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe status is obtained from a numerical variable, the following applies:

  • Value 0 is valued as all
  • The action is cancelled if the status cannot be found in the recipe

Formatting of the recipe value table

Settings for the formatting of the recipe value table.

Parameters

Description

Table

Selection of report file. Click the button to open a drop-down list for selection:

  • Use standard table
  • Using the format file for table

Use standard table:

The recipe value are displayed in a recipe value table or CE recipe value table in Runtime.

Using the format file for table:

The recipe values can be displayed in a report file (*.xrs). This file must have been created in the Report Generator beforehand. Click on button ... in order to open the dialog for selecting a XRS file.

Note: When a format file is used, the CE recipe value is shown in Runtime.

Filter for value display

Selection of the filter that is to be active when switching in order to limit the list of displayed recipe values.

Parameters

Description

Filter criterion

Selection of the filter. Clicking on text opens a drop-down list to select a filter:

  • Filter criterion static
  • Filter criterion as variable

Static filter criterion:

Selection of a filter from the drop-down list that was defined at the Filter text variable property.

Filter criterion as variable:

Filter criterion is is taken from a STRING variable in Runtime.

Runtime settings

Settings for operation in Runtime.

Parameters

Description

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Note: Only limited functions are available under Windows CE and when called up using the Filterbutton in the Recipe Group Manager screen:

  • Recipe Filter
  • Column settings (for recipe table)

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

Block editing in the screen

Blocks all control elements in the RGM screen. The user cannot make any changes to the RGM.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

info Information

The recipe name must be unique. The recipe number is not checked for uniqueness. It is only used in order to call a recipe via a variable with the help of function Recipegroup Manager. If several recipes with the same number exist, zenon uses the recipe it finds first.


Recipe value table column setting

Manual -> Recipegroup Manager -> Functions -> Function screen switch Recipegroup Manager -> Recipe value table column setting

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Note: Is not available if, for screen switching in the recipe value table, the recipe value table Format file for table: has been selected.

All columns of the recipe value list are freely configurable. The columns can be made visible, sorted and labeled as you wish. In addition you can blank out the line numbering.

In this tab, the columns for the CE recipe value table and the recipe value table can be configured. There are two tools available for this:

  • Column Settings for CE: Configures the settings for the CE recipe value table.
  • Column settings: Configures the settings for the recipe value table.

Column Settings for CE

These settings related to the CE recipe value table. They are used for the display of the fixed recipe value tables under Windows CE. The recipe value table is always configured in the lower area of the dialog.

Parameters | Description
Column type | Type of the column. Cannot be edited. The display in the Runtime is activated or deactivated with the help of a checkbox.
Description | Defines the header of the respective column. You can configure it as language switchable. The value can be edited.
Width | Defines the width of the column in characters. You can also define the width of the column by clicking and dragging the column with the mouse in the list with the horizontal display of the column names. The value can be edited.
Move selected entry up | Moves selected row up. You can also move the columns with drag&drop.
Move selected entry down | Moves selected row down. You can also move the columns with drag&drop.
Field with horizontal display of the column names | Shows the columns which are active in the list. You can define the size of the columns by clicking and dragging the column borders with the mouse.
Display numbering column | Active: The first column of the report is displayed with line numbers.

Column settings

Configuration of the recipe value table.

Parameters | Description
Table | Columns of the table are selected by clicking on the column selection button. They are arranged by clicking on the column title and using drag&drop with the mouse. When arranging them, two red arrows show where the column to be moved is placed.
Column selection | Clicking on the button opens the dialog to select the columns to be displayed.
Column Format | Clicking on the button opens the dialog to format the columns.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog. The function is nevertheless created the first time screen switching is configured, however without a target.
Help | Opens online help.


Recipe Filter

Manual -> Recipegroup Manager -> Functions -> Function screen switch Recipegroup Manager -> Recipe Filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab you define which recipes of a recipe group should be displayed in a Recipegroup Manager screen. Only recipes are displayed which are allowed by the recipe filter of the screen switch function. The filtering is based on the recipe names.

info Information

If the recipe selection leads to an error in Runtime (recipe not present in Runtime, no selection made, recipe not contained in the filter), then no recipe is selected and the display of the drop-down list Recipe remains empty.

Parameters

Description

Text filter

Defines filter criteria.

No text filter

Active: The text filter is not used.

Search for (words separated by spaces)

Active: The recipe filter is used. The additional settings are activated.

Input field

Enter the corresponding words or character strings.

Case sensitive

Active: Capitalization is taken into account when filtering.

Words do not have to appear in the recipe name in full

Active: The expressions entered in the input field are also taken into account if they only appear in the recipe name as part of a word.

At least one word must be present in the recipe name

Active: At least one word of the search string must appear in the recipe name.

All words must be present in the recipe name

Active: All words of the search string must be present in the recipe name but the order does not matter.

Filter text must appear in the recipe name exactly

Active: All words of the search string must be present in the recipe name in the same order.

Extended filter

Filter settings for version and status.

Version

Version filter: Selection from drop-down list or direct input.

Drop-down list:

  • Smallest version
  • Largest version
  • All

These settings are always combined with the status.

Direct input:

  • Numerical input, separated by a comma. For example: 1.2.6

Entries may consist of numbers, commas or spaces and are checked to see if they are valid. Erroneous inputs are noticed when the dialog is confirmed with OK or the tab is changed. The dialog remains open and the focus is placed on the erroneous input.

Status

Filter criterion for status. Selection:

Drop-down list:

  • All
  • Already configured status

Direct input:

  • Numerical input, separated by a comma. For example: 1.2.6

The language of status texts can be switched.

Entries may consist of numbers, commas or spaces and are checked to see if they are valid. Erroneous inputs (such as letters) are noticed when the dialog is confirmed with OK. The dialog remains open and the focus is placed on the erroneous input.

OK

Accepts settings in all tabs and closes dialog.

Cancel

Discards changes for all tabs and closes dialog. The function is created the first time screen switching is configured, however without a target.

Help

Opens online help.

Possible combinations of the version filter with the status filter

Version filter | Status filter | Result
Smallest version | All | Only the smallest respective versions of all recipes are shown.
Smallest version | 1.2 | Only the smallest respective versions of all recipe versions with status 1 or 2 are displayed.
Largest version | All | Only the largest respective versions of all recipes are shown.
Largest version | 1.2 | Only the largest respective versions of all recipe versions with status 1 or 2 are displayed.
All | All | All recipe versions are displayed.
All | 1.2 | All recipe versions with the status 1 or 2 are displayed.
2.3 | All | All recipe versions 2 and 3 are displayed regardless of status.
2.3 | 1.2 | The respective recipe version 2 and 3 is displayed if these have either the status 1 or 2.


Column settings recipe list

Manual -> Recipegroup Manager -> Functions -> Function screen switch Recipegroup Manager -> Column settings recipe list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab, the column settings for the display of the recipe list in Runtime is configured.

Attention: The column settings for the recipe list are not available for CE projects.

Parameters | Description
List field | Display of the configured columns.
Column selection | Opens dialog to select the columns.
Column Format | Opens dialog to format the columns.
OK | Applies all changes and closes dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.

Other settings, such as scroll bars, are configured in the list field properties. For details, see Appearance of recipe list section.


Equipment Modeling

Manual -> Recipegroup Manager -> Functions -> Function screen switch Recipegroup Manager -> Equipment Modeling

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Here you allocate equipment models and levels:

Property

Description

Toolbar

Symbols to:

  • Edit local equipment models
  • Expand or collapse the display
  • Display of information

List of equipment models

provides models and groups for selection The list separates the display into equipment models from the global project and from local projects.

Local equipment models can be created, edited or deleted.

Add

Adds the selected group to the filter list.

Remove

Removes all selected groups from the filter list.

Filter list

Shows all equipment groups that are to be filtered.

OK

Applies settings and closes the dialog.

Cancel

Discards the selection and closes the dialog.

Attention: Any changes that have been made to the structure of local equipment models are retained.

Help

Opens online help.

Add groups

  • select the desired equipment model
    Attention: If there are naming conflicts between global and local equipment models, the local equipment models are displayed and the global ones are ignored. You can get information on possible conflicts by clicking on the corresponding symbol (triangle with exclamation mark) in the tool bar.
  • Select an equipment group or level.
  • Add the new group to the list with the Add button in the lower area of the dialog
  • Subgroups are not automatically added.
  • it is possible to link as many groups as you want.

Delete groups

  • Select the desired elements in the list in the lower area of the dialog (multiple selection is possible)
  • Click the Delete button

Note: Changes in a tree element remain preserved independent of clicking button Cancel. Cancel only means that no element was selected.


Recipe list and recipe value table column selection

Manual -> Recipegroup Manager -> Functions -> Function screen switch Recipegroup Manager -> Recipe list and recipe value table column selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You configure the columns for the recipe list and recipe value table to be displayed in Runtime here. The following illustration shows an example of a recipe list. The columns for the recipe value table are configured along the same lines.

Button | Function
Available columns | List of columns that can be displayed in the table.
Selected columns | Columns that are displayed in the table.
Add | Moves the selected column from the available ones to the selected items. After you confirm the dialog with OK, they are shown in the detail view.
Add all | Moves all available columns to the selected columns.
Remove | Removes the marked columns from the selected items and shows them in the list of available columns. After you confirm the dialog with OK, they are removed from the detail view.
Remove all | All columns are removed from the list of the selected columns.
Up | Moves the selected entry upward. This function is only available for unique entries, multiple selection is not possible.
Down | Moves the selected entry downward. This function is only available for unique entries, multiple selection is not possible.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Recipe list and recipe value table column format

Manual -> Recipegroup Manager -> Functions -> Function screen switch Recipegroup Manager -> Recipe list and recipe value table column format

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You format the columns for the recipe list and recipe value table here.

Configuration of the properties of the columns for configurable lists. The settings have an effect on the respective list in the Editor or - when configuring screen switching - in Runtime.

Available columns

Parameters | Description
Available columns | List of the available columns via Column selection. The highlighted column is configured via the options in the Settings area.

Settings

Parameters

Description

Settings

Settings for selected column.

Labeling

Name for column title.

The column title is online language switchable. To do this, the @ character must be entered in front of the name.

Width

Width of the column in characters.
Calculation: Number time average character width of the selected font.

Alignment

Alignment. Selection by means of radio buttons.

Possible settings:

  • Left-justified: Text is justified on the left edge of the column.
  • Centered: Text is displayed centered in the column.
  • Right: Text is justified on the right edge of the column.

Deactivate column filter in the Runtime

Active: The filter for this column cannot be changed in Runtime.

Note: Only available for:

  • Batch Control
  • Extended Trend
  • Filter screens
  • Message Control
  • Recipegroup Manager

User defined colors

Properties in order to define user-defined colors for text and background. The settings have an effect on the Editor and Runtime.

Note:

  • These settings are only available for configurable lists.
  • In addition, the respective focus in the list can be signalized in Runtime by means of different text and background colors. These are configured using the project properties.

User defined colors

Active: User-defined colors are used.

Text color

Color for text display. Clicking on the color opens the palette to select a color.

Background color

Color for the display of the cell background. Clicking on the color opens the palette to select a color.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Recipegroup Manager function

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function carries out defined actions for a selected recipe of the Recipegroup Manager in the Runtime.

To configure the function:

  1. create a new function
  2. go to group Recipes
  3. Select the Recipegroup Manager function.

The dialog for configuring the function is opened:

Parameters

Description

Action

Selection of desired function from drop-down list. Selection can be subsequently changed. Possible functions:

  • Write recipe
  • Read recipe
  • Check recipe value
  • Rename recipe
  • Change recipe status
  • Create new recipe
  • Delete recipe
  • Duplicate
  • Duplicate and teach
  • Create new recipe version
  • Delete recipe version
  • Duplicate as new recipe version
  • Duplicating and reading as a new recipe version
  • Write recipe value to shadow variable
  • Write shadow variable to recipe value
  • Export XML all
  • Export recipe group XML
  • Export recipe XML
  • Import XML
  • Detailed recipe data on saving documentation in XML
  • Export recipe to text file
  • Import recipe of text file

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

The function is created, however without an action.

Help

Opens online help.

info Information

The recipe name of all functions must be unambiguous. The recipe number is not checked for uniqueness. It is only used in order to call a recipe via a variable with the help of function Recipegroup Manager. If several recipes with the same number exist, zenon uses the recipe it finds first.


Write recipe

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Write recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function sends the selected recipe in Runtime.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Static recipe:

Selection of a recipe that has already been created.

Recipe name from variable name:

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe number from variable no.:

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first. If the variable values are invalid, no recipes are opened.

Recipe version

Selection of recipe version from existing versions or using a variable.

Static recipe version:

Selection of an existing recipe version from drop-down list. Possible selection:

  • Pre-existing recipe version
  • Smallest version;
    additional selection of a recipe status possible
  • Largest version;
    additional selection of a recipe status possible

Recipe version from variable:

Recipe version is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe version is obtained from a numerical variable, the following applies:

  • Value 90000 matches the statistical smallest version
  • Value 90001 matches the statistical largest version

Recipe state

Selection of recipe status from existing status or using a variable.

Recipe status:

The recipe status is evaluated in combination with the version. Only available if the recipe version has the value smallest version or largest version or is taken from a variable.
Example: Largest version with status start.

Selection of a recipe status from drop-down list:

  • Existing status
  • All

Recipe status from variable:

Recipe status is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe status is obtained from a numerical variable, the following applies:

  • Value 0 is valued as all
  • The action is cancelled if the status cannot be found in the recipe

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.


Read recipe

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Read recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The values of the corresponding variables are read off and written to the selected recipe (teaching).

When reading, a check is carried out to see if the values of the properties minimum value and max. value have been adhered to. If the values are gone below or exceeded, or the variable has the status INVALID, the values are not written to the recipe. Errors can be evaluated using the system variables.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Static recipe:

Selection of a recipe that has already been created.

Recipe name from variable name:

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe number from variable no.:

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first. If the variable values are invalid, no recipes are opened.

Recipe version

Selection of recipe version from existing versions or using a variable.

Static recipe version:

Selection of an existing recipe version from drop-down list. Possible selection:

  • Pre-existing recipe version
  • Smallest version;
    additional selection of a recipe status possible
  • Largest version;
    additional selection of a recipe status possible

Recipe version from variable:

Recipe version is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe version is obtained from a numerical variable, the following applies:

  • Value 90000 matches the statistical smallest version
  • Value 90001 matches the statistical largest version

Recipe state

Selection of recipe status from existing status or using a variable.

Recipe status:

The recipe status is evaluated in combination with the version. Only available if the recipe version has the value smallest version or largest version or is taken from a variable.
Example: Largest version with status start.

Selection of a recipe status from drop-down list:

  • Existing status
  • All

Recipe status from variable:

Recipe status is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe status is obtained from a numerical variable, the following applies:

  • Value 0 is valued as all
  • The action is cancelled if the status cannot be found in the recipe

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.


Check recipe value

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Check recipe value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function carries out a recipe check. At this recipe value and actual value are compared and the result is transferred to the corresponding system variable.

Recipe values can be checked using the Recipegroup Manager function or by means of the VBA.

Recipegroup Manager

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Static recipe:

Selection of a recipe that has already been created.

Recipe name from variable name:

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe number from variable no.:

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first. If the variable values are invalid, no recipes are opened.

Recipe version

Selection of recipe version from existing versions or using a variable.

Static recipe version:

Selection of an existing recipe version from drop-down list. Possible selection:

  • Pre-existing recipe version
  • Smallest version;
    additional selection of a recipe status possible
  • Largest version;
    additional selection of a recipe status possible

Recipe version from variable:

Recipe version is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe version is obtained from a numerical variable, the following applies:

  • Value 90000 matches the statistical smallest version
  • Value 90001 matches the statistical largest version

Recipe state

Selection of recipe status from existing status or using a variable.

Recipe status:

The recipe status is evaluated in combination with the version. Only available if the recipe version has the value smallest version or largest version or is taken from a variable.
Example: Largest version with status start.

Selection of a recipe status from drop-down list:

  • Existing status
  • All

Recipe status from variable:

Recipe status is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe status is obtained from a numerical variable, the following applies:

  • Value 0 is valued as all
  • The action is cancelled if the status cannot be found in the recipe

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.

attention Attention

The function uses decimal points for synchronization with the PLC. If, for variables with the REAL data type, the Decimals property is not configured along the lines of the PLC settings and the values in the decimal point area are different, the function displays different values.

Screen

Recipe values can also be checked with a control element in the RGM screen. For details see the Create recipegroup manager screen chapter.

VBA

Recipe values can be carried out automatically via VBA: For this function (Check()) is used. It takes over the following parameters or delivers the following return values:

Check(ByRef vList As Variant)as Long

  • Return value: matches the values of the system variable RGM recipe value check - result.
  • vList: matches the values of the system variable RGM recipe value check - deviations.
    At this a new entry is used for every array index (no line feed).

System variables

The function carries out a recipe check. At this recipe value and actual value are compared and the result is transferred to the corresponding system variable. The variable can be selected and checked locally or globally. Variables that cannot be checked due to erroneous communication with the PLC (INVALID status) are marked by a colored background (red).

Variable

Data type

Description

RGM recipe values check - deviations (global/local)

STRING

List all variable differences in the following order:

[Variable name; recipe value; variable value; unit]

each entry is written in a new line.

Requirement: Variable RGM recipe value check - result has a value = 1.

Attention: Variable can either be created and evaluated globally or locally.

Check RGM recipe values - authorization (global/local)

DINT

Authorization level of the last recipe checked.

Check RGM recipe values - last user change (global/local)

STRING

Name of the user who was logged in when the last change was made to the last recipe checked.

RGM recipe values check - result (global/local)

DINT

Result of the check:

  • 0: All value match.
  • 1: At least one variable value deviates from the recipe value.
  • 2: At least one variable is faulty (INVALID).
  • 3: Checking is not possible, because the column for the current value is not displayed. System driver variable is reset.

Error messages:

  • -1: En error while reading the variable value occurred.
  • -2: The recipe group could not be opened.
  • -3: The recipe could not be changed.

Attention: Variable can either be created and evaluated globally or locally.

Check RGM recipe values - comment 1 to 8 (global/local)

STRING

Eight comments can be added to a recipe. The variable contains the comment of the respective number for the last recipe checked.

Check RGM recipe values - recipe group name (global/local)

STRING

Name of the recipe group of the recipe checked last.

Requirement: Variable RGM recipe value check - result has a value >= -1.

Attention: Variable can either be created and evaluated globally or locally.

RGM recipe values check - recipe name (global/local)

STRING

Name of the recipe checked last.

Requirement: Variable RGM recipe value check - result has a value >= -1.

Attention: Variable can either be created and evaluated globally or locally.

RGM recipe values check - recipe number (global/local)

UDINT

Number of the recipe checked last.

Requirement: Variable RGM recipe value check - result has a value >= -1.

Attention: Variable can either be created and evaluated globally or locally.

Check RGM recipe values - recipe status (global/local)

DINT

Status of the last recipe checked as a number.

Check RGM recipe values - recipe status text (global/local)

STRING

Status of the last recipe checked as text in the format: 1 - @Text

Check RGM recipe values - recipe version (global/local)

DINT

Version of the last recipe checked.

Check RGM recipe values - time of last user change (global/local)

STRING

Time of the last recipe change of the last recipe checked.


Rename recipe

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Rename recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function renames the selected recipe and all its versions.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Static recipe:

Selection of a recipe that has already been created.

Recipe name from variable name:

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe number from variable no.:

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first. If the variable values are invalid, no recipes are opened.

Target recipe

Select how the target recipe of the renaming is created:

  • Target recipe name static
  • Create new target recipe
  • Target recipe name from variable

Static target recipe name:

Selection of an existing recipe from drop-down list.

Create new target recipe name

A new recipe with an automatically-generated name is created.

Target recipe name from variable:

Name of the target recipe is taken from a variable. Click on button ... opens the dialog for selecting variables.

The recipe is not renamed if the values of the variables are invalid.

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.


Change recipe status

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Change recipe status

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function changes the status of a recipe.

An attempt is made to set the status value to the selected recipe and the recipe is then saved. If the given status value is not valid, (0 or a non-configured status value) the recipe remains unchanged and a CEL entry is generated. The RGM recipe function being processed variable displays an error in this case (4).

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Static recipe:

Selection of a recipe that has already been created.

Recipe name from variable name:

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe number from variable no.:

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first. If the variable values are invalid, no recipes are opened.

Recipe version

Selection of recipe version from existing versions or using a variable.

Static recipe version:

Selection of an existing recipe version from drop-down list. Possible selection:

  • Pre-existing recipe version
  • Smallest version;
    additional selection of a recipe status possible
  • Largest version;
    additional selection of a recipe status possible

Recipe version from variable:

Recipe version is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe version is obtained from a numerical variable, the following applies:

  • Value 90000 matches the statistical smallest version
  • Value 90001 matches the statistical largest version

Recipe state

Selection of recipe status from existing status or using a variable.

Recipe status:

The recipe status is evaluated in combination with the version. Only available if the recipe version has the value smallest version or largest version or is taken from a variable.
Example: Largest version with status start.

Selection of a recipe status from drop-down list:

  • Existing status
  • All

Recipe status from variable:

Recipe status is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe status is obtained from a numerical variable, the following applies:

  • Value 0 is valued as all
  • The action is cancelled if the status cannot be found in the recipe

Target recipe

Status definition for target recipe.

Target recipe status

Selection of new recipe status from existing status or using a variable.

Static target recipe list:

Selection of an existing status from drop-down list.

Target recipe status from variable:

Recipe status is taken from a variable as a numerical value. Click on button ... opens the dialog for selecting variables.

The action is cancelled if the status cannot be found in the recipe

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.


Create new recipe

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Create new recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function creates a new recipe in the selected recipe group.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Static recipe:

Selection of a recipe that has already been created.

Recipe name from variable name:

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe number from variable no.:

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first. If the variable values are invalid, no recipes are opened.

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.


Delete recipe

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Delete recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function deletes the selected recipe with all its versions.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Static recipe:

Selection of a recipe that has already been created.

Recipe name from variable name:

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe number from variable no.:

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first. If the variable values are invalid, no recipes are opened.

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.


Duplicate

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Duplicate

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function duplicates the selected recipe. The values of the corresponding variables are written to the new recipe.

Note: Duplication can lead to Runtime only being executed if the user who is logged in has the corresponding rights to edit the recipe further. If the user rights are not available, the dialog for temporary login is called up.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Recipe group static

Selection of a recipe group that already exists.

Recipe group name from variable

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Attention: Must not be configured for versions before zenon 7.00.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Recipe static

Selection of a recipe that already exists.

Recipe name from variable

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Attention: Must not be configured for versions before zenon 7.00.

Recipe number from variable

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first. If the variable values are invalid, no recipes are opened.

Recipe version

Selection of recipe version from existing versions or using a variable.

Recipe version static

Selection of an existing recipe version from drop-down list. Possible selection:

  • Pre-existing recipe version
  • Smallest version;
    additional selection of a recipe status possible
  • Largest version;
    additional selection of a recipe status possible

Recipe version from variable

Recipe version is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe version is obtained from a numerical variable, the following applies:

  • Value 90000 matches the statistical smallest version
  • Value 90001 matches the statistical largest version

Recipe state

Selection of recipe status from existing status or using a variable.

Recipe state static

The recipe status is evaluated in combination with the version. Only available if the recipe version has the value smallest version or largest version or is taken from a variable.
Example: Largest version with status start.

Selection of a recipe status from drop-down list:

  • Existing status
  • All

Recipe status from variable

Recipe status is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe status is obtained from a numerical variable, the following applies:

  • Value 0 is valued as all
  • The action is cancelled if the status cannot be found in the recipe

Target recipe

Status definition for target recipe.

Create target recipe

Settings for recipe naming. Click on the text to open a drop-down list for selection:

  • Target recipe name static
  • Create new target recipe
  • Target recipe name from variable

Target recipe name static

Assumption of an existing name from drop-down list.

Create new target recipe

The name is created and issued by the system.

Target recipe name from variable

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Target recipe version

Selection of target recipe version from existing versions or using a variable.

Target recipe version static

Selection of an existing recipe version from drop-down list. Possible selection:

  • Pre-existing recipe version
  • Smallest version;
    additional selection of a recipe status possible
  • Largest version;
    additional selection of a recipe status possible

Target recipe version from variable

Recipe version is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe version is obtained from a numerical variable, the following applies:

  • Value 90000 matches the statistical smallest version
  • Value 90001 matches the statistical largest version

Target recipe status

Selection of new recipe status from existing status or using a variable.

Static target recipe list:

Selection of an existing status from drop-down list.

Target recipe state from variable

Recipe status is taken from a variable. Click on button ... opens the dialog for selecting variables.

The action is cancelled if the status cannot be found in the recipe

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Help

Opens online help.

Procedure when duplicating

When duplicating, an existing source recipe with its properties is:

  • Transferred to an existing recipe and this is overwritten with all settings of the source recipe
    or
  • A new recipe with all settings of the source recipe is created in the same recipe group

The recipe status is always taken from the source recipe (and its recipe version).

The recipe version is not transferred, because this is not a property of the recipe, but the name is further specified.

The following is applicable when stating the recipe version and recipe status:

  • The specified recipe version for the specified recipe name and/or for the specified recipe names with the specified recipe status must exist
  • If there is still no recipe with the specified name, a new version 1 is created with the specified name and the status is set as in the source recipe.

Specification using variables

If, during configuration, the target recipe version or the target recipe status are specified using variables, the target recipe is only created or overwritten under the following conditions:

  • The target version defined by the variable value with the status defined by the variable value already exists:
    • The defined target recipe is overwritten with the source recipe.
    • The number of the recipe version remains the same.
    • The recipe status is taken from the source recipe.
  • There is not yet a recipe version with this name:
    • A recipe version 1 is created, regardless of what value the variable has for the target version.
    • The recipe status is taken from the source recipe.
  • There is a recipe with the target name but no recipe version that corresponds to the variable value for the target version:
    • No new version is created.
      This also applies if no recipe version 1 exists any more.


Duplicate and teach

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Duplicate and teach

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function duplicates the selected recipe. The values of the corresponding variables are written to the new recipe. The values from the PLC are then read in. If the values cannot be read in, then the values of the duplicate no no longer come from the PLC, but are only copied from the original recipe.

Note: Duplication can lead to Runtime only being executed if the user who is logged in has the corresponding rights to edit the recipe further. If the user rights are not available, the dialog for temporary login is called up.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Recipe group static

Selection of a recipe group that has already been created.

Recipe group name from variable

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Attention: Must not be configured for versions before zenon 7.00.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Recipe static

Selection of a recipe that has already been created.

Recipe name from variable

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Attention: Must not be configured for versions before zenon 7.00.

Recipe number from variable

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first. If the variable values are invalid, no recipes are opened.

Recipe version

Selection of recipe version from existing versions or using a variable.

Recipe version static

Selection of an existing recipe version from drop-down list. Possible selection:

  • pre-existing version
  • Smallest version;
    additional selection of a recipe status possible
  • Largest version;
    additional selection of a recipe status possible

Recipe version from variable

Recipe version is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe version is obtained from a numerical variable, the following applies:

  • Value 90000 matches the statistical smallest version
  • Value 90001 matches the statistical largest version

Recipe state

Selection of recipe status from existing status or using a variable.

Recipe state static

The recipe status is evaluated in combination with the version. Only available if the recipe version has the value smallest version or largest version or is taken from a variable.
Example: Largest version with status start.

Selection of a recipe status from drop-down list:

  • Existing status
  • All

Recipe status from variable

Recipe status is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe status is obtained from a numerical variable, the following applies:

  • Value 0 is valued as all
  • The action is cancelled if the status cannot be found in the recipe

Target recipe

Status definition for target recipe.

Create target recipe

Settings for recipe naming. Click on the text to open a drop-down list for selection:

  • Target recipe name static
  • Create new target recipe
  • Target recipe name from variable

Target recipe name static

Assumption of an existing name from drop-down list.

Create new target recipe

The name is created and issued by the system.

Target recipe name from variable

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Target recipe version

Selection of target recipe version from existing versions or using a variable.

Static target recipe version:

Selection of an existing recipe version from drop-down list. Possible selection:

  • Pre-existing recipe version
  • Smallest version;
    additional selection of a recipe status possible
  • Largest version;
    additional selection of a recipe status possible

Target recipe version from variable

Recipe version is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe version is obtained from a numerical variable, the following applies:

  • Value 90000 matches the statistical smallest version
  • Value 90001 matches the statistical largest version

Target recipe status

Selection of new recipe status from existing status or using a variable.

Target recipe state static

Selection of an existing status from drop-down list.

Target recipe state from variable

Recipe status is taken from a variable. Click on button ... opens the dialog for selecting variables.

The action is cancelled if the status cannot be found in the recipe

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Help

Opens online help.

Procedure when duplicating

When duplicating, an existing source recipe with its properties is:

  • Transferred to an existing recipe and this is overwritten with all settings of the source recipe
    or
  • A new recipe with all settings of the source recipe is created in the same recipe group

The recipe status is always taken from the source recipe (and its recipe version).

The recipe version is not transferred, because this is not a property of the recipe, but the name is further specified.

The following is applicable when stating the recipe version and recipe status:

  • The specified recipe version for the specified recipe name and/or for the specified recipe names with the specified recipe status must exist
  • If there is still no recipe with the specified name, a new version 1 is created with the specified name and the status is set as in the source recipe.

Specification using variables

If, during configuration, the target recipe version or the target recipe status are specified using variables, the target recipe is only created or overwritten under the following conditions:

  • The target version defined by the variable value with the status defined by the variable value already exists:
    • The defined target recipe is overwritten with the source recipe.
    • The number of the recipe version remains the same.
    • The recipe status is taken from the source recipe.
  • There is not yet a recipe version with this name:
    • A recipe version 1 is created, regardless of what value the variable has for the target version.
    • The recipe status is taken from the source recipe.
  • There is a recipe with the target name but no recipe version that corresponds to the variable value for the target version:
  • No new version is created.
    This also applies if no recipe version 1 exists any more.


Create new recipe version

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Create new recipe version

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function creates a new recipe version for the selected recipe. The recipe values are filled with the replacement values of the selected variables. A maximum of 89999 recipe versions can be created.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Static recipe:

Selection of a recipe that has already been created.

Recipe name from variable name:

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe number from variable no.:

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first. If the variable values are invalid, no recipes are opened.

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.


Delete recipe version

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Delete recipe version

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function deletes the selected recipe version. The whole recipe is deleted if there is only one recipe version.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Static recipe:

Selection of a recipe that has already been created.

Recipe name from variable name:

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe number from variable no.:

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first. If the variable values are invalid, no recipes are opened.

Recipe version

Selection of recipe version from existing versions or using a variable.

Static recipe version:

Selection of an existing recipe version from drop-down list. Possible selection:

  • Pre-existing recipe version
  • Smallest version;
    additional selection of a recipe status possible
  • Largest version;
    additional selection of a recipe status possible

Recipe version from variable:

Recipe version is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe version is obtained from a numerical variable, the following applies:

  • Value 90000 matches the statistical smallest version
  • Value 90001 matches the statistical largest version

Recipe state

Selection of recipe status from existing status or using a variable.

Recipe status:

The recipe status is evaluated in combination with the version. Only available if the recipe version has the value smallest version or largest version or is taken from a variable.
Example: Largest version with status start.

Selection of a recipe status from drop-down list:

  • Existing status
  • All

Recipe status from variable:

Recipe status is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe status is obtained from a numerical variable, the following applies:

  • Value 0 is valued as all
  • The action is cancelled if the status cannot be found in the recipe

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.


Duplicate as new recipe version

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Duplicate as new recipe version

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function creates a new recipe version for the selected recipe. The recipe values are filled with the values of the selected recipe.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Static recipe:

Selection of a recipe that has already been created.

Recipe name from variable name:

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe number from variable no.:

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first. If the variable values are invalid, no recipes are opened.

Recipe version

Selection of recipe version from existing versions or using a variable.

Static recipe version:

Selection of an existing recipe version from drop-down list. Possible selection:

  • Pre-existing recipe version
  • Smallest version;
    additional selection of a recipe status possible
  • Largest version;
    additional selection of a recipe status possible

Recipe version from variable:

Recipe version is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe version is obtained from a numerical variable, the following applies:

  • Value 90000 matches the statistical smallest version
  • Value 90001 matches the statistical largest version

Recipe state

Selection of recipe status from existing status or using a variable.

Recipe status:

The recipe status is evaluated in combination with the version. Only available if the recipe version has the value smallest version or largest version or is taken from a variable.
Example: Largest version with status start.

Selection of a recipe status from drop-down list:

  • Existing status
  • All

Recipe status from variable:

Recipe status is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe status is obtained from a numerical variable, the following applies:

  • Value 0 is valued as all
  • The action is cancelled if the status cannot be found in the recipe

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.


Duplicating and reading as a new recipe version

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Duplicating and reading as a new recipe version

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function creates a new recipe version for the selected recipe. The recipe values are filled with the values of the selected recipe. The values from the PLC are then read in. If the values cannot be read in, then the values of the duplicate no no longer come from the PLC, but are only copied from the original recipe.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Static recipe:

Selection of a recipe that has already been created.

Recipe name from variable name:

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe number from variable no.:

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first. If the variable values are invalid, no recipes are opened.

Recipe version

Selection of recipe version from existing versions or using a variable.

Static recipe version:

Selection of an existing recipe version from drop-down list. Possible selection:

  • Pre-existing recipe version
  • Smallest version;
    additional selection of a recipe status possible
  • Largest version;
    additional selection of a recipe status possible

Recipe version from variable:

Recipe version is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe version is obtained from a numerical variable, the following applies:

  • Value 90000 matches the statistical smallest version
  • Value 90001 matches the statistical largest version

Recipe state

Selection of recipe status from existing status or using a variable.

Recipe status:

The recipe status is evaluated in combination with the version. Only available if the recipe version has the value smallest version or largest version or is taken from a variable.
Example: Largest version with status start.

Selection of a recipe status from drop-down list:

  • Existing status
  • All

Recipe status from variable:

Recipe status is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe status is obtained from a numerical variable, the following applies:

  • Value 0 is valued as all
  • The action is cancelled if the status cannot be found in the recipe

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.


Write recipe value to shadow variable

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Write recipe value to shadow variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function writes recipe values to a graphic recipe variable.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Static recipe:

Selection of a recipe that has already been created.

Recipe name from variable name:

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe number from variable no.:

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first. If the variable values are invalid, no recipes are opened.

Recipe version

Selection of recipe version from existing versions or using a variable.

Static recipe version:

Selection of an existing recipe version from drop-down list. Possible selection:

  • Pre-existing recipe version
  • Smallest version;
    additional selection of a recipe status possible
  • Largest version;
    additional selection of a recipe status possible

Recipe version from variable:

Recipe version is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe version is obtained from a numerical variable, the following applies:

  • Value 90000 matches the statistical smallest version
  • Value 90001 matches the statistical largest version

Recipe state

Selection of recipe status from existing status or using a variable.

Recipe status:

The recipe status is evaluated in combination with the version. Only available if the recipe version has the value smallest version or largest version or is taken from a variable.
Example: Largest version with status start.

Selection of a recipe status from drop-down list:

  • Existing status
  • All

Recipe status from variable:

Recipe status is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe status is obtained from a numerical variable, the following applies:

  • Value 0 is valued as all
  • The action is cancelled if the status cannot be found in the recipe

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.


Write shadow variable to recipe value

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Write shadow variable to recipe value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function writes graphic recipe variable values to recipe values.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Static recipe:

Selection of a recipe that has already been created.

Recipe name from variable name:

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If the variable values are invalid, no recipes are opened.

Recipe number from variable no.:

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first. If the variable values are invalid, no recipes are opened.

Recipe version

Selection of recipe version from existing versions or using a variable.

Static recipe version:

Selection of an existing recipe version from drop-down list. Possible selection:

  • Pre-existing recipe version
  • Smallest version;
    additional selection of a recipe status possible
  • Largest version;
    additional selection of a recipe status possible

Recipe version from variable:

Recipe version is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe version is obtained from a numerical variable, the following applies:

  • Value 90000 matches the statistical smallest version
  • Value 90001 matches the statistical largest version

Recipe state

Selection of recipe status from existing status or using a variable.

Recipe status:

The recipe status is evaluated in combination with the version. Only available if the recipe version has the value smallest version or largest version or is taken from a variable.
Example: Largest version with status start.

Selection of a recipe status from drop-down list:

  • Existing status
  • All

Recipe status from variable:

Recipe status is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe status is obtained from a numerical variable, the following applies:

  • Value 0 is valued as all
  • The action is cancelled if the status cannot be found in the recipe

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.


Export XML all

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Export XML all

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The function exports the complete content of an RGM to an XML file.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

File selection

Settings for issuing the filename of the export file. Click on the text to open a drop-down list for selection:

  • File name static
  • File name from variable
  • Generate file name automatically

If no other folder is stipulated, the export file is stored in the project's export folder:

%CD_USERDATA%\[Project]\Export

File name static:

The name of the export file is directly defined by the user. The file name can be given with the path stated or the export path that has been set can be used. In addition, there is the possibility to generate file names dynamically by means of placeholders.

Click on the ... button to open the dialog to select a folder and give it a name.

If name is given without a path, the export file in the Runtime folder is written to.

File name from variable:

The name of the export file is defined by the contents of a string variable. A click on the ... button opens the selection dialog for variable. The variables can also issue the file names with absolute path, relative path and with placeholders.

Generate file name automatically:

The name of the export file is created automatically. It comprises the prefix RGM plus theplaceholder <DateTime>.

For example: RGM 10_11_2011 10_42_29.xml

Overwrite existing file

Active: An file with the same name that already exists in the folder is overwritten.

Inactive The export is canceled if a file with the same name is present.

Default: Inactive

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.


Placeholders for dynamic paths

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Export XML all -> Placeholders for dynamic paths

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Placeholder

Condition

Result

<ProjectName>
  • Always

Project name

<DateTime>
  • Always

Date and time in the format according to the system settings.

All characters that are invalid and unwanted for file names are replaced with an underscore (_).

For German (Germany) for example, the date 24/12/2001, at 16:04 and 59 seconds, becomes: 24_12_2011 16_04_59

<RGMGroupName>
  • Export of a group
  • Export of a recipe
  • Import with group selection

Name of the selected recipe group.

<RGMRecipeName>
  • Export of a recipe

Name of the selected recipe.

<RGMRecipeVersion>
  • Export of a recipe

Version number of the selected recipe.


Export recipe group XML

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Export recipe group XML

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function exports the selected recipe group including its contents to an XML file.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

File selection

Settings for issuing the filename of the export file. Click on the text to open a drop-down list for selection:

  • File name static
  • File name from variable
  • Generate file name automatically

If no other folder is stipulated, the export file is stored in the project's export folder:

%CD_USERDATA%\[Project]\Export

File name static:

The name of the export file is directly defined by the user. The file name can be given with the path stated or the export path that has been set can be used. In addition, there is the possibility to generate file names dynamically by means of placeholders.

Click on the ... button to open the dialog to select a folder and give it a name.

If name is given without a path, the export file in the Runtime folder is written to.

File name from variable:

The name of the export file is defined by the contents of a string variable. A click on the ... button opens the selection dialog for variable. The variables can also issue the file names with absolute path, relative path and with placeholders.

Generate file name automatically:

The name of the export file is created automatically. It comprises the prefix RGM plus the placeholder <RGMGroupName>.

For example: <RGM GroupName>.xml results in, for Group 1: Group 1.xml.

Overwrite existing file

Active: An file with the same name that already exists in the folder is overwritten.

Inactive The export is cancelled if a file with the same name is present.

Default: inactive

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.

Placeholders for dynamic paths

Placeholder

Condition

Result

<ProjectName>
  • Always

Project name

<DateTime>
  • Always

Date and time in the format according to the system settings.

All characters that are invalid and unwanted for file names are replaced with an underscore (_).

For German (Germany) for example, the date 24/12/2001, at 16:04 and 59 seconds, becomes: 24_12_2011 16_04_59

<RGMGroupName>
  • Export of a group
  • Export of a recipe
  • Import with group selection

Name of the selected recipe group.

<RGMRecipeName>
  • Export of a recipe

Name of the selected recipe.

<RGMRecipeVersion>
  • Export of a recipe

Version number of the selected recipe.


Export recipe XML

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Export recipe XML

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function exports the selected recipe to an XML file. The name of the recipe group is also exported with it. If recipe groups are renamed after export, this assignment is lost during import.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Static recipe:

Selection of a recipe that has already been created.

Recipe name from variable name:

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Recipe number from variable no.:

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first.

Recipe version

Selection of recipe version from existing versions or using a variable.

Static recipe version:

Selection of an existing recipe version from drop-down list. Possible selection:

  • Pre-existing recipe version
  • Smallest version;
    additional selection of a recipe status possible
  • Largest version;
    additional selection of a recipe status possible

Recipe version from variable:

Recipe version is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe version is obtained from a numerical variable, the following applies:

  • Value 90000 matches the statistical smallest version
  • Value 90001 matches the statistical largest version

Recipe state

Selection of recipe status from existing status or using a variable.

Recipe status:

The recipe status is evaluated in combination with the version. Only available if the recipe version has the value smallest version or largest version or is taken from a variable.
Example: Largest version with status start.

Selection of a recipe status from drop-down list:

  • Existing status
  • All

Recipe status from variable:

Recipe status is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe status is obtained from a numerical variable, the following applies:

  • Value 0 is valued as all
  • The action is cancelled if the status cannot be found in the recipe

File selection

Settings for issuing the filename of the export file. Click on the text to open a drop-down list for selection:

  • File name static
  • File name from variable
  • Generate file name automatically

If no other folder is stipulated, the export file is stored in the project's export folder:

%CD_USERDATA%\[Project]\Export

File name static:

The name of the export file is directly defined by the user. The file name can be given with the path stated or the export path that has been set can be used. In addition, there is the possibility to generate file names dynamically by means of placeholders.

Click on the ... button to open the dialog to select a folder and give it a name.

If name is given without a path, the export file in the Runtime folder is written to.

File name from variable:

The name of the export file is defined by the contents of a string variable. A click on the ... button opens the selection dialog for variable. The variables can also issue the file names with absolute path, relative path and with placeholders.

Generate file name automatically:

The name of the export file is created automatically. It comprises the prefix RGM plus the placeholder <RGMRecipeName>.<RGMRecipeVersion>.

For example: <RGMRecipeName>.<RGMRecipeVersion> results in, for the recipe Recipe 1 with version 3: Recipe 1.3.xml.

Overwrite existing file

Active: An file with the same name that already exists in the folder is overwritten.

Inactive The export is cancelled if a file with the same name is present.

Default: inactive

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.


Import XML

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Import XML

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function imports the content of the stated XML file. If there are individual groups therein that do not belong to a group, these recipes are imported into the selected group, otherwise the group selection is ignored:

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group into which unassigned recipes are to be imported. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables
  • Using an import file

Clicking on Property opens a drop-down list to select the method.

This setting is ignored if there are already recipe groups in the XML file.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Recipe group name from file.

The name of the recipe group is taken from the file to be imported.

File selection

Settings for the selection of the file from which importing is to take place. Click on the text to open a drop-down list for selection:

  • File name static
  • File name from variable

The standard folder for exported data is the project's export folder:

%CD_USERDATA%\[Project]\Export

File name static:

The name of the import file is defined by the user. The file name can be given with the path stated or the export path that has been set can be used. In addition, there is the possibility to generate file names dynamically by means of placeholders.

Click on the ... button to open the dialog to select a folder and a file.

File name from variable:

The name of the import file is defined by the contents of a string variable. A click on the ... button opens the selection dialog for variable. The variables can also issue the file names with absolute path, relative path and with placeholders.

Overwrite existing recipes

Active: Existing recipes with the same name are overwritten during import.

Inactive: Existing recipes are not overwritten. Only new recipes are created.

Default: inactive

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.

Notes on exporting with different variables

If a recipe is imported from an XML file and its variables are different to the variables of the original recipe, then:

  1. The recipe is imported
  2. Variables that exist in the XML file and in Runtime are overwritten in the original recipe
  3. All other variables are ignored
  4. The system driver variable returns the value 2 (import was completed without errors)

Note on block arrays: If the size of a block array is changed between import and re-Import of a recipe group, then the following is applicable for:

  • Enlarging the array size (group already exists): the new variables are not added to recipe groups
  • Enlarging the array group (group not present): the new variables are added to the recipe group; there is a message in the output window
  • Reducing the array size: the missing variables are removed from the recipe group


Detailed recipe data on saving documentation in XML

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Detailed recipe data on saving documentation in XML

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function exports detailed recipe data to documentation in an XML file.

Note: This data can no longer be imported. It is intended as the basis for the exact documentation.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Static recipe:

Selection of a recipe that has already been created.

Recipe name from variable name:

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Recipe number from variable no.:

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first.

Recipe version

Selection of recipe version from existing versions or using a variable.

Static recipe version:

Selection of an existing recipe version from drop-down list. Possible selection:

  • Pre-existing recipe version
  • Smallest version;
    additional selection of a recipe status possible
  • Largest version;
    additional selection of a recipe status possible

Recipe version from variable:

Recipe version is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe version is obtained from a numerical variable, the following applies:

  • Value 90000 matches the statistical smallest version
  • Value 90001 matches the statistical largest version

Recipe state

Selection of recipe status from existing status or using a variable.

Recipe status:

The recipe status is evaluated in combination with the version. Only available if the recipe version has the value smallest version or largest version or is taken from a variable.
Example: Largest version with status start.

Selection of a recipe status from drop-down list:

  • Existing status
  • All

Recipe status from variable:

Recipe status is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe status is obtained from a numerical variable, the following applies:

  • Value 0 is valued as all
  • The action is cancelled if the status cannot be found in the recipe


Export recipe to text file

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Export recipe to text file

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function exports the selected recipe to a text file.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group and the recipe. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Recipe

Settings for recipe selection. Click on the text to open a drop-down list for selection:

  • Recipe static
  • Recipe name from variable name
  • Recipe name from variable no.

Static recipe:

Selection of a recipe that has already been created.

Recipe name from variable name:

Recipe name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Recipe number from variable no.:

Recipe number is is taken from a variable. Click on button ... opens the dialog for selecting variables.

If several recipes with the same number exist, zenon uses the recipe it finds first.

Recipe version

Selection of recipe version from existing versions or using a variable.

Static recipe version:

Selection of an existing recipe version from drop-down list. Possible selection:

  • Pre-existing recipe version
  • Smallest version;
    additional selection of a recipe status possible
  • Largest version;
    additional selection of a recipe status possible

Recipe version from variable:

Recipe version is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe version is obtained from a numerical variable, the following applies:

  • Value 90000 matches the statistical smallest version
  • Value 90001 matches the statistical largest version

Recipe state

Selection of recipe status from existing status or using a variable.

Recipe status:

The recipe status is evaluated in combination with the version. Only available if the recipe version has the value smallest version or largest version or is taken from a variable.
Example: Largest version with status start.

Selection of a recipe status from drop-down list:

  • Existing status
  • All

Recipe status from variable:

Recipe status is taken from a variable. Click on button ... opens the dialog for selecting variables.

Note: If the recipe status is obtained from a numerical variable, the following applies:

  • Value 0 is valued as all
  • The action is cancelled if the status cannot be found in the recipe

File selection

Settings for issuing the filename of the export file. Click on the text to open a drop-down list for selection:

  • File name static
  • File name from variable
  • Generate file name automatically

If no other folder is stipulated, the export file is stored in the project's export folder:

%CD_USERDATA%\[Project]\Export

File name static:

The name of the export file is directly defined by the user. Click on the ... button to open the dialog to select a folder and give it a name.

If name is given without a path, the export file in the Runtime folder is written to.

File name from variable:

The name of the export file is defined by the contents of a string variable. A click on the ... button opens the selection dialog for variable.

Generate file name automatically:

The name of the export file is created automatically. It comprises the prefix RGM plus the date and time.

For example: RGM 10_11_2011 10_42_29.txt

Overwrite existing file

Active: An file with the same name that already exists in the folder is overwritten.

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.


Import recipe of text file

Manual -> Recipegroup Manager -> Functions -> Recipegroup Manager function -> Import recipe of text file

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function imports data from a text file.

Parameters

Description

Action

Displays the action selected in the Recipe Group Manager function dialog. Display only, cannot be selected.

Recipe groups-/
Recipe selection

Selection of the recipe group that is to be imported. The selection can take place:

  • Statically from pre-defined entries
  • Dynamically using variables
  • Using an import file

Clicking on Property opens a drop-down list to select the method.

Recipe group

Settings for recipe group selection. Click on the text to open a drop-down list for selection:

  • Recipe group static
  • Recipe group name from variable

Static recipe group:

Selection of a recipe group that has already been created.

Recipe group name from variable:

Recipe group name is is taken from a variable. Click on button ... opens the dialog for selecting variables.

Recipe group name from file.

The name of the recipe group is taken from the file to be imported.

File selection

Settings for the selection of the file from which importing is to take place. Click on the text to open a drop-down list for selection:

  • File name static
  • File name from variable

The standard folder for exported data is the project's export folder:

%CD_USERDATA%\[Project]\Export

File name static:

The name of the import file is defined by the user. Click on the ... button to open the dialog to select a folder and a file.

File name from variable:

The name of the import file is defined by the contents of a string variable. A click on the ... button opens the selection dialog for variable.

Overwrite existing recipes

Active: Existing recipes with the same name are overwritten during import.

Runtime settings

Settings for operation in Runtime.

Show dialog in the Runtime

Active: The dialog is shown in Runtime so that changes can be made.

Block recipe group selection in Runtime

Active: Selection of recipe group is blocked in Runtime.

Only available if Offer dialog in Runtime is active.

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog. The function is created, however without a target.

Help

Opens online help.


Operating during Runtime

Manual -> Recipegroup Manager -> Operating during Runtime

The screen configured in the Editor is available in Runtime via screen switching.

Engineering: See Creating a Recipe Group Manager screen section.

Note: Buttons are only active if the corresponding list/table is present.

Edit recipe and save under

A recipe that is edited is only saved if one of the following buttons is clicked on:

  • Save recipe
  • Write all values
  • Write selected values

Clicking on the Save recipe as button saves the recipe that is currently being edited under a new name. Changes to the original recipe that have not yet been saved there are also not present in the new recipe.

Change recipe name or recipe number

The recipe name must be unique. The recipe number is not checked for uniqueness. It is only used in order to call a recipe via a variable with the help of function Recipegroup Manager. If several recipes with the same number exist, zenon uses the recipe it finds first.

Rename or delete recipes

In order for a user to rename or delete a recipe, they must have the operating authorization for all existing versions of the recipe.

Currentness of the displayed information

The Recipe Group manager screen works with a copy of the Recipe Group Manager database in Runtime. The current information from the database is displayed in Runtime when the RGM screen is displayed. This display is not updated automatically.

Changes are updated as follows:

  • If the content is changed due to execution of a function or due editing the screen in a client, the change is not shown in the screen that is currently displayed. To display changes, the screen must be closed and reopened. The database is therefore read in again and the updated status is shown.
  • New recipe groups are displayed immediately once the screen has been opened again; variables are only displayed after Runtime is reloaded.
  • Recipes or recipe groups that are amended in the Editor are only displayed after Runtime is reloaded.

attention Attention

If the variable for visibility (Visibility/Variable property) changes its value whilst a Recipe Group Manager screen that contains this variable is opened, the Recipe Group Manager screen is reopened. Changes to the screen that are not saved are lost in the process.

Queuing in the network

From version 7.10, the RGM supports queuing for communication in the network. RGM queries receive a unique ID and are processed in sequence. Versions before zenon 7.10 do not support queuing. This means that queries that reach the server whilst it is processing another query are discarded.


Recipe list

Manual -> Recipegroup Manager -> Operating during Runtime -> Recipe list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

An individual entry in the recipe list can be selected. The selected recipe is displayed in the recipe value table and can then be edited with the buttons (rename, delete, etc.). The columns can be allocated arranged by means of drag&drop (with the exception of Windows CE).

If the list is used together with the Recipe name and/or Recipe version drop-down lists, the selection is synchronized. If the selection in the drop-down list is changed, the selection in the recipe list changes and vice versa. If the selected entry is not visible due to a filter criteria, nothing in the list is selected.

New recipes and recipe versions are added at the end of the list regardless of the filter criteria. Amended recipe data, for example the text of a comment or the status, are displayed after the recipe is saved. Texts (the language) of the comments and column headings are translated.

Design of the recipe list: See Editing the recipe list section.


Recipe Value List

Manual -> Recipegroup Manager -> Operating during Runtime -> Recipe Value List

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the recipe value table, the values and actions are displayed for the selected recipe. The recipe value table is available in two versions:

  • Recipe Value List
  • Recipe Value List CE

Differences between the recipe value tables

Recipe Value List

The table columns can be arranged by means of drag&drop and sorted by clicking on the column header. The columns can be selected and formatted using the Recipe value table column selection and Recipe value table column format buttons.

Available are:

  • Writing order: Display only
  • Action: Display only
  • Resources label: Display only
  • Filter text: Display only
  • Actual value: Display only
  • Identification: Display only
  • Measuring unit: Display only
  • Maximum value: Display only
  • Minimum value: Display only
  • Variable name: Display only
  • Value or variable: can be edited depending on the entry in the Action column
  • Value display as a text: can be edited depending on the entry in the Action column (only via Keyboard screen)

Recipe Value List CE

The table is configured in screen switching.

Use in Runtime

Recipe value table is used if this condition is applicable:

  • The recipe value table has been configured in the screen and Use standard table has been selected for the Formatting of the recipe value table option.

CE recipe value table is used if one of the following conditions is applicable:

  • The CE recipe value table has been configured in the screen.
  • The recipe value table has been configured in the screen and Use format file for table has been selected for the Formatting of the recipe value table option.
  • The Windows CE project property must be activated in the project properties.


Recipe value table column selection

Manual -> Recipegroup Manager -> Operating during Runtime -> Recipe Value List -> Recipe value table column selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Clicking on the Column selection button opens the dialog to configure the columns to be displayed in the list. This button must be configured in the Editor.

Note: Is not available if, for screen switching in the recipe value table, the recipe value table Format file for table: has been selected.

Button | Function
Available columns | List of columns that can be displayed in the table.
Selected columns | Columns that are displayed in the table.
Add | Moves the selected column from the available ones to the selected items. After you confirm the dialog with OK, they are shown in the detail view.
Add all | Moves all available columns to the selected columns.
Remove | Removes the marked columns from the selected items and shows them in the list of available columns. After you confirm the dialog with OK, they are removed from the detail view.
Remove all | All columns are removed from the list of the selected columns.
Up | Moves the selected entry upward. This function is only available for unique entries, multiple selection is not possible.
Down | Moves the selected entry downward. This function is only available for unique entries, multiple selection is not possible.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.


Column format recipe value table

Manual -> Recipegroup Manager -> Operating during Runtime -> Recipe Value List -> Column format recipe value table

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Clicking on the Column format button opens the dialog to configure the columns. This button must be configured in the Editor.

Note: Is not available if, for screen switching in the recipe value table, the recipe value table Format file for table: has been selected.

Available columns

Parameters | Description
Available columns | List of the available columns via Column selection. The highlighted column is configured via the options in the Settings area.

Settings

Parameters

Description

Settings

Settings for selected column.

Labeling

Name for column title.

The column title is online language switchable. To do this, the @ character must be entered in front of the name.

Width

Width of the column in characters.
Calculation: Number time average character width of the selected font.

Alignment

Alignment. Selection by means of radio buttons.

Possible settings:

  • Left-justified: Text is justified on the left edge of the column.
  • Centered: Text is displayed centered in the column.
  • Right: Text is justified on the right edge of the column.

Deactivate column filter in the Runtime

Active: The filter for this column cannot be changed in Runtime.

Note: Only available for:

  • Batch Control
  • Extended Trend
  • Filter screens
  • Message Control
  • Recipegroup Manager

User defined colors

Properties in order to define user-defined colors for text and background. The settings have an effect on the Editor and Runtime.

Note:

  • These settings are only available for configurable lists.
  • In addition, the respective focus in the list can be signalized in Runtime by means of different text and background colors. These are configured using the project properties.

User defined colors

Active: User-defined colors are used.

Text color

Color for text display. Clicking on the color opens the palette to select a color.

Background color

Color for the display of the cell background. Clicking on the color opens the palette to select a color.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Display, export or print recipe value table with Report Viewer

Manual -> Recipegroup Manager -> Operating during Runtime -> Recipe Value List -> Display, export or print recipe value table with Report Viewer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To display a recipe value table as a report and print it:

  1. Create the corresponding system driver variables.
  2. Create the corresponding report:
  3. Display the report in Runtime, or print or export the report.

Create system driver variables

Create the system driver variables from the Recipegroup Manager group. To do this:

Create a new variable.

  1. Select SYSDRV as the driver.
  2. Select system variable as the object type.

  3. Click on Next.
  4. Add the following system driver variables:
    • RGM lastly selected recipe - group name (local)
    • RGM lastly selected recipe - recipe name (local)
    • RGM lastly selected recipe - recipe version (local)
    • RGM lastly selected recipe - recipe state (local)

  5. Click on Finish.

Configure Report Viewer

Create a new RGMReport.rdl report with the recipe data and recipe values.
To do this:

  1. Create a new report.
  2. Select the Recipe data and Recipe values data sets.

  3. Confirm your selection by clicking OK.
  4. Save the file in the Report Builder under the name RGMReport.rdl or rename it in zenon.

Display report, export it directly or print it

Displaying the report in Runtime

To display the report in Runtime:

  1. Create a Report Viewer screen if there is not one in the project.
  2. Create a screen switching function on the Report Viewer screen.
  3. Select, as a report definition file, the previously-created RGMReport.rdl file.
  4. Click on the Read data sets from file button.
  5. The data sets are displayed.

  6. Select the first data set, for example recipe data.
  7. Click on Edit.
  8. The dialog for configuration is opened.
    Switch to the Recipe filter tab.
  9. Switch the four drop-down lists for Recipe group/recipe selection
    from [...] Static
    to[...] from variable.
  10. Assign one of the previously-created system driver variables to each entry.

  11. Repeat this step for the second data set (recipe values).
  12. Close the dialog and and functions and give the function a name.
  13. Assign this function to a button in the RGM screen to use it in Runtime.

Print or export report

To print the report directly or to export it:

  1. Create a new function.
  2. Go to the Report Generator / Report Viewer / Analyzer function group.
  3. Select the Report Viewer: export / print function.

  4. Select the desired action for the Issue report option:
    • Output as PDF: Creates a PDF document.
      Configure the file name and save location as well as the Overwrite existing data option.
    • Output on printer: Prints the table on the configured printer.
  5. Switch to the report definition tab.
  6. Configure this in the same way as the documentation for Show report in Runtime.
  7. Close the dialog and and functions and give the function a name.
  8. Assign this function to a button in the RGM screen to use it in Runtime.


Values and actions

Manual -> Recipegroup Manager -> Operating during Runtime -> Recipe Value List -> Values and actions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Values and actions can be edited in Runtime in the recipe value table directly.

Note: In the Editor, actions and values are defined when editing a recipe. See Editing a recipe from the recipe group/Actions.

info Information

If there are invalid values/actions in a recipe, these are not saved. If, for example the action type is changed, but the value for the action is not amended, the Save recipe command can be executed but the amended, invalid values are not applied.

Enter values

Values in the Value or variable column and in the Value display as text column can be amended in Runtime directly or by means of a keyboard screen.

To enter values in cells:

  1. Double click in the cell.
  2. Enter the value.

Note:

  • Only values that are within the Value limit for min. value and max. value defined for the recipe values can be entered.
  • The editing of a value or a variable is only possible if the attendant action is one of the following types:
    • Modify spontaneous value
    • Switch to and modify spontaneous value:
    • Modify alternate value
    • Switch to and modify alternate value:
    • User status
    • Link with variable
  • If a keyboard is to be called up for input, this must be linked to the variable or configured for the data type.

Note: Recipe values can be switched using invisible variables.

Filtering of values

Values can be filtered or displayed using filter control elements. If a filter is selected in the combo box, the corresponding values are switched to invisible or displayed. If no filter is selected, all values are shown with the exception of variables that have been switched to invisible.

Define actions

Values in the Action column can be amended in Runtime directly by means of selection from a drop-down list.

To define an action:

Double click in the Action cell of the corresponding variables.

  1. Click on the symbol with the arrow.
  2. Select the desired action from the drop-down list.
  3. The action is applied to the recipe value table with the selection.

Available actions:

Action

Description

Entry in Value or variable

No action

Deactivates a variable in this recipe

No input.

User status

Status information. Sets the according status bit of the variable.

Note: You can only set status bits which were tagged as set by the user. Status bits which were automatically set by the system cannot be changed.

Attention: In order to be able to call up a keyboard in Runtime, a keyboard must be linked in the Keyboards properties group for the String tags property.

Enter status short label:
=1 to set
=0 to reset

You can enter more states separating them by semicolon (;). For example:
M1=1; M5=0

Modify alternate value

Sets the Alternate value to the value stated under Value or variable.

Enter Alternate value.

Modify spontaneous value

Sets the Spontaneous value to the value stated under Value or variable.

Enter set value.

Switch off spontaneous value

Switches off the spontaneous value by setting status bit OFF (Bit 20).

No input.

Switch on spontaneous value

Switches on spontaneous value by resetting OFF bit.

No input.

Switch to alternate value

Switches from Spontaneous value to Alternate value

No input.

Switch to spontaneous value

Switches from Alternate value to Spontaneous value

No input.

Switch to and modify Alternate value

Switches from Spontaneous value to Alternate value and sets the alternate value to the value stated under Value or variable.

Enter Alternate value.

Switch and modified spontaneous value

Switches from Alternate value to Spontaneous value and sets the spontaneous value to the value stated under Value or variable.

Enter set value.

Link with variable

Links a variable with another variable.

Name of a variable.

Right-click the field in order to open the context menu in which you can open the dialog for selecting variables. The value of the variable is transferred to the selected recipe variable. It is also possible to use variables of other loaded projects.

Note: The Value display as text column can also be edited. To do this, a Keyboard must be linked. Your settings correspond to those of the Value or variablecolumn.
The following actions are exceptions:

  • User status: can only be edited with an RGM keyboard.
  • Link to variable: cannot be edited

attention Attention

If the Read all values function is used with the Link with variable action for a recipe, neither user authorization is checked nor is the action logged. If you want a logging, you must create it manually, e.g. using a VBA macro.

Note for FDA regulations: As a consequence, this functionality is not allowed to be used for projects with a strict FDA standard!

Identification of errors and interlockings

The values displayed in the recipe value tables are checked automatically and highlighted in the event of errors. The following cells are marked.

  • Error:
    • Values that are outside the defined minimum/maximum value
    • Values that relate to a variable that is not present or not contactable

    Default: red background color.
    This error labeling is not available for the CE recipe value table.

  • Cells that show interlocked parameters.
    Default: gray background color.

The matching of values from the PLC and recipe and be checked and displayed using the function or the Check recipe value.

Colors for texts and background can each be amended individually using the properties of the Colors group (not available for CE recipe value table).

Priority of the color markings

If several colors are applied on a list, the following priorities apply:

  1. General: Selection colors for the object lists
  2. RGM: Recipe value validation
  3. RGM: Online validation
  4. RGM: Interlocking
  5. List: Column color


Recipe value validation

Manual -> Recipegroup Manager -> Operating during Runtime -> Recipe Value List -> Recipe value validation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When checking the recipe, the recipe value and actual value are compared. The result of the check can be displayed in the recipe value table or transferred to system variables.

Recipe values can be checked:

  • Automatically on loading, saving and reading values from the PLC.
  • With the Check recipe value.
  • Using the Recipegroup Manager function.
  • By means of VBA.

A value is invalid if:

  • An action refers to a variable but no variable is linked.
  • A certain action refers to values outside of the permitted range (min./max.). This applies for:
    • Modify alternate value
    • Modify spontaneous value
    • Switch to and modify spontaneous value:
    • Switch to and modify alternate value:

Coloring

The results are displayed in the Current Value column in color. The colors can be amended using the properties of the group Colors/Recipe value validation. The amendment is not available for the CE recipe value table. Individual colors can also be configured for interlockings. In the event of errors, the table for the first place of finding (red or violet) is scrolled through.
Coloring of default values:

  • Green: Results correspond.
  • Red: PLC value different from the recipe value.
  • Blue: No connection to the PLC.

"Check recipe value" button

To check recipe values in Runtime immediately in the recipe value table:

  1. Configure the Check recipe values button in the screen.
  2. Click on the button in Runtime.
  3. All variables linked to the recipe are read and the current actual values are compared to the recipe values.

Attention: The function of the control element uses decimal points for synchronization with the PLC. If, for variables with the REAL data type, the Decimals property is not configured along the lines of the PLC settings and the values in the decimal point area are different, the function displays different values.

Function Recipegroup Manager

To check recipe values in Runtime and to output the result with system driver variables:

  1. Configure a function Recipegroup Manager.
  2. If the function is triggered in Runtime, then:
    1. The recipe values are checked
    2. The results are transferred to the corresponding system variables


Show value as text

Manual -> Recipegroup Manager -> Operating during Runtime -> Recipe Value List -> Show value as text

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The value display as text column can only be defined if a Keyboard is linked. No entry is possible for the Link to variable action.

If, for a value, you also want to display the meaning of the value within a recipe in Runtime:

  1. Create a reaction matrix of the type numeric or String for the variable you use in the recipe.

    The type of reaction matrix must correspond to the type of variable used.

  2. In the reaction matrix, you defined the "equals" states and enter the desired meaning - the text to be displayed.

Alternatively: To have text displayed, you can also use limit values or binary reaction matrices with states other than "equals". However in this case, you cannot use the functions from keyboard screens.

Display in the Runtime

The Recipe value list in screen of type Recipegroup Manager shows in the Show value as text columng the linked limit texts either from the reaction matrix or from the limit which was violated by the recipe value. If no limit value texts are linked, the recipe value is displayed.

In selft-engineered Report Generator lists you can achieve the same functionality with the help of functions recipew and recipef with parameter symbolic.

If a recipe value is changed and a state of limit is violated, the displayed limit text is updated immediately. Values can be be amended in Runtime in the recipe value table using a Keyboard screen.

Entries into the Chronological Event List

With changes of recipe values and with writing a recipe (recipe value) not only the values but also the respective limit texts are written in the CEL entry. If no state or limit is violated, only the value is entered.


Keyboards

Manual -> Recipegroup Manager -> Operating during Runtime -> Keyboards

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Keyboards serve with zenon as virtual keyboards that allow inputs on devices without a hardware keyboard in the Runtime. Keyboards are projected with a screen type keyboard. zenon provides automatically generated keyboards that can be engineered by the user. Keyboards can be defined for entries in the recipe value table. When clicking on a cell in the Value or variable column, the corresponding keyboard is called up.
Requirement: The keyboard was, in the Editor,

  • either configured for the corresponding data type
  • or linked to the variable

The following keyboards are available in the Keyboards group:

  • Binary tags
  • Numeric tags
  • String tags

attention Attention

A string keyboard is required for the User status action type. This must be configured as a global string keyboard.

Reason: To edit a variable, the keyboard that is linked to the variable and that belongs to its data type is always called up. A string keyboard is required for the User status action type. This is not linked with a numerical variable and must therefore be additionally configured.

Engineering: Configure the keyboard using the String tags property in the RGM Keyboards property group.

Keys for RGM keyboard

For the RGM, there are the following special control elements available under Control elements -> Recipegroup Manager specific when configuring the keyboard screen:

Control element

Description

Send value

The set value is written to the variable, updated in the recipe and the keyboard is closed.

Save recipe

The recipe is saved

Send value and save recipe

The set value is written to the variable, updated in the recipe, the recipe is saved and the keyboard is closed.

Value displays as Text 1
to
Value displays as Text 32

Keys can be linked with limits from a reaction matrix. To do this, the variable of the recipe parameter

  • must be linked with Numeric reaction matrix or String reaction matrix and
  • "equals" states must be included

Assigned keys are shown in runtime and labeled with the text from the reaction matrix.

Clicking the button writes the linked value in the reaction matrix as a proposal for the recipe value in the Set value input control element.


Status information for recipes and recipegroup manager

Manual -> Recipegroup Manager -> Operating during Runtime -> Status information for recipes and recipegroup manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Runtime status information is provided at

  • Read/write
  • Export/Import
  • Saving

If a recipe written, this variable contains the result of the writing operation.

Values

Write recipe

System driver variable Standard recipe/RGM recipe completely written

Value | Result
0 | Send initialization value before the recipe
1 | Write completed successfully
2 | Write not executed because of a parameter error
3 | Write not completed successfully
5 | Write terminated because RT is being ended
6 | Timeout occurred

Note: If the network functionality is active in the project, the system driver variable Standar recipe/RGM recipe completely written (local) is relevant for the function executed on the local computer.

info Information

Writing means writing to the driver. The driver then transfers the recipe to the control. That means:

  • Property Write synchronously inactive: Value 1 for Standard recipe/RGM recipe written completely does not mean that the values are available in the control. They are written on the driver.
  • Write synchronously property active: The value change take place when all values on the control are topical.

Note: The progress display at writing is only display if property Write synchronously is active.

Recipe in progress

System driver variable Standard recipe/RGM recipe function in progress

Value

Result

-1

is being executed

0

Initialization value read successfully

1

User has no authorization

2

no authorization in the network

3

chancel by user

4

Error - could not read everything successfully, e.g.

  • Communication with the hardware is interrupted before read was started
  • a data block is not available on the PLC
  • Error during transmission

5

Error during save of the recipe file

6

Function cancelled via VBA

Screen type specific functions

During

  • reading (system driver variable: Standard recipe/RGM recipe reading all values finished
  • Exporting/Importing and
  • Saving

of a recipe via screen specific function - the following values are available:

Value

Result

0

Initialization value waits for response from driver

1

read successfully

2

Error during Read, Export/Import or Save:

  • Communication with the hardware is interrupted before read was started
  • a data block is not available on the PLC
  • Error during transmission


Writing values to a recipe using a screen (graphic recipe variables)

Manual -> Recipegroup Manager -> Operating during Runtime -> Writing values to a recipe using a screen (graphic recipe variables)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Values in recipes can be changed directly in Runtime using screens. To do this, graphic recipe variables are used, which can be read and written in the RGM using the Recipegroup Manager function.

Defining a graphic recipe variable

A graphic recipe variable can be defined for each variable in a recipe group. Each graphic recipe variable can be only used once per recipe group. Not every variable of the recipe group must have a graphic recipe variable. to define a graphic recipe variable:

  1. Highlight the variable of the recipe group.
  2. Navigate to the properties in the General group.
  3. Click on the Graphic recipe variable property
  4. The dialog for selecting a variable is opened
  5. Select the desired graphic recipe variable.
  6. Confirm the dialog with OK.

Configuration procedure

  1. Define, during configuration, a graphic recipe variable for each variable that has values that can be changed in Runtime using a screen.
    You define these using the General/Graphic recipe variable property.
  2. Configure a screen that displays changeable recipe values, such as a tank.
  3. Link the screen to the function Recipegroup Manager and select the Write recipe value to graphic recipe variables action.
  4. Configure a button in the screen.
  5. Link the button to the Recipegroup Manager function and select the Write graphic recipe variables to recipe values action.

Procedure in Runtime

  1. The screen for setting the values for the RGM is called up.
  2. In doing so, the variables are substituted by the graphic recipe variables.
  3. When the screen is opened, the Recipegroup Manager function is called up with the Write recipe values to graphic recipe variables action.
  4. The recipe values are displayed in the screen and can be changed.
  5. Amended values are written to the recipe in the RGM by means of the button with the Recipegroup Manager/Write graphic recipe variables to recipe values function.
  6. If an error should occur, this can be evaluated using the system driver variables and the entries in the LOG files.


Error treatment

Manual -> Recipegroup Manager -> Error treatment

Errors can be evaluated using system driver variables and error messages. You can find messages from system driver variables in the System driver variables manual, Recipe Group Manager section chapter.

Log files

Entry

Level

Meaning

COM events

COM Event "RecipeCreate" returned with "bCancel == TRUE"

logLe_DEBUG

Message for COM events if the respective action is cancelled using the bCancel function parameter:

  • RecipeCreate
  • VersionCreate
  • RecipeDuplicate
  • VersionDuplicate
  • VersionDuplicateRead
  • RecipeRename
  • RecipeDelete
  • VersionDelete

No special logging entry appears if the action is not cancelled in the event function.

Graphic recipe variable

RGM: Teached value out of Minimum max range. Variable: "x1", Value: x2, FromShadow: x3

FAILED

A value that was read in breaches the minimum value or the max. value of the target value limit of the recipe.

  • x1: Name of the variable
  • x2: Standardized value of the variable
  • x3: Note on process value or value of a graphic recipe variable

Error while reading current value for CEL logging.

INTERNAL

An error occurred when the current value for CEL logging (set recipe) was read in. Possible reasons:

  • A value is outside the limits for minimum value and max. value
    -> additional entry RGM: Teached value out of Minimum max range. Variable: "x1", Value: x2, FromShadow: x3
  • A value has the status INVALID
  • Time-out was reached

Pop-up messages

Message | Meaning
The name "Recipe\Test" contains invalid characters (\"'./*?<>!|). | The recipe group name or recipe name that was entered does not correspond to the guidelines for issuing names. Expression in brackets contains characters that are not approved.
Delete version "7" of recipe "Recipe1"? | Confirmation request before a recipe version in deleted in the RGM screen in Runtime.


Examples

Manual -> Recipegroup Manager -> Examples

Here you can find examples of configuration:

Other topics in this chapter

Writing the highest recipe version with the status released to the PLC

Switching the language of the display text in the dynamic text element


Writing the highest recipe version with the status released to the PLC

Manual -> Recipegroup Manager -> Examples -> Writing the highest recipe version with the status released to the PLC

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To write the highest recipe version with released status to the PLC in Runtime:

  1. Creation of status texts for the recipe status:
    1. Open the Identifier recipe state property in the Recipegroup Manager
    2. Create, in the dialog, the status:

      - 1 draft

      - 2 checked

      - 3 unlocked

      - 4 blocked

      - 5 deleted

    Hint: Here, you can also define the status texts by a prefixed @, as well as the key words for language switching (for example: @Released

  2. Creating several recipe versions:
    1. Create a new recipe group using the context menu
    2. Link variables to the recipe group
    3. Creating a new recipe
    4. Create a new version for the recipe
    5. Change the status in the second version of the recipe to 3 unlocked
  3. Creating the function:
    1. Highlight the recipe and select Create standard function in the context menu or in the toolbar
    2. The dialog for configuration is opened
    3. Select Write recipe
    4. Set Recipe version to >
    5. Select, at Static recipe, the entry 3 unlocked

If the function is executed in Runtime, then the highest existing version of the recipe with the status 3 - unlocked is written to the PLC. If now, for example, a new recipe version is created and this contains the status 3 - unlocked, then this new version is written to the PLC the next time the function is called up.


Switching the language of the display text in the dynamic text element

Manual -> Recipegroup Manager -> Examples -> Switching the language of the display text in the dynamic text element

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use language switching for a dynamic text element, create this in the Editor and switch it in Runtime.

In the editor

To create a dynamic element of dynamic text text type and configure it:

  1. Click on the symbol for dynamic text in the toolbar for the element and drag the element onto the screen.
  2. Select a string variable.
  3. Activate the Translate displayed text property.

In Runtime

The set point default displays the text as a raw value. The text can be edited:

The text is modified by the language switching when displayed:


Remote Transport

Manual -> Remote Transport

The Remote Transport is used to transport Runtime files to a target system. Information about saving and reloading Editor files can be found in the chapter project backups.

tutorial License information

Part of the standard license of the Editor and Runtime.

General information

If Runtime and the Editor are on the same PC, the Runtime files now are directly available to the Runtime. If Runtime is on a different computer, the Runtime files are transferred via Remote Transport to provide them locally there.

With Remote Transport:

  • Only the respective necessary files are transferred in the network
  • Other desired files can also be transported (ActiveX controls, fonts, etc.)
  • Automatic upload to Server 1 and Server 2 can be instigated
  • Many other functions can be used

Hint: Use the network topology view in the Editor to configure all Runtime computers and the transport of Runtime files.

Note: Note, with multi-project administration, the correct transfer of the individual projects.

attention Attention

PNG graphics files cannot be overwritten if they are currently being displayed in Runtime.

Background: The Runtime protects opened .png files against overwriting.

Solution: Before Remote Transport is instigated, it must be ensured that screens with *.png files:

  • Are not called up in Runtime
  • Are not being used by another program

This also applies for the reloading of amended Runtime files. The Runtime sync in the network does not work for a *.png screen if this is switched on a zenon computer that is involved in the process (standby server, client).

Functionalities

In addition to the pure copy function, Remote Transport also offers a range of other functionalities:

Parameters | Description
Incremental copy | The Editor automatically recognizes which files on the target system differs from the files which should be transferred and transfers only the changed files.
Set start project | With the Remote Transport the start project on the remote station can be set.
Starting and stopping the Runtime | The Runtime can be started and closed in the remote computer.
Transfer the system status | The current status of the remote PC (operating system, zenon version, existing drives etc.) can be found out.
PC reboot | A remote PC can be rebooted.
Online reload | Remote Runtime is updated online in the process
Start Remote desktop connection | Creates a Remote desktop connection
Copy back project data | An entire project can be copied back from the remote system.
Copy and register data | Files are not only copied, but also registered on the target system. Particularly interesting for fonts and ActiveX elements.
Copy and execute data | Executable files are copied and started.

attention Attention

Note the following when starting Runtime via Remote Transport:

  • The 32-bit zensyssrv.exe starts the 32-bit Runtime
  • The 64-bit zensyssrv.exe starts the 64-bit Runtime

info Information

In theory, transfer via Windows Explorer or the approval of network drives is possible. We expressly advise against this procedure. Transfer via Remote Transport is more secure and systematic and reduces the load on the network connection. When connecting as a network device, whether Runtime works or not depends on the drive being available and that it offers sufficient performance.


Toolbar Remote Transport

Manual -> Remote Transport -> Toolbar Remote Transport

A development computer can set up remote connections to other stations. The Remote transport toolbar provides functions for the transfer and request of data.

Symbol

(from left to right)

Function

Remote Transport: Connection settings

Opens the configuration dialog of the remote transport for setting the target system and the target folder.

Remote Transport: Establish connection

Establishes a Remote Transport connection to the remote system.

Remote: Transfer changed Runtime files

Transfers all Runtime files that were changed on the development computer to the target computer since the last change.

Remote: Read back all Runtime files

Restores all files that can be edited in Runtime (such as recipes or user administration) from the remote system back to the local Runtime folder.

Remote: Set start project

Sets the active project as the start project on the remote system.

Remote: Start Runtime

Starts Runtime on the remote system.

Remote: Exit Runtime

Stops Runtime on the remote system.

Remote: Reload project

Executes the reload function on the remote system.

Remote Desktop: Start connection

Starts a connection to operate the target computer using zenon Remote Desktop. This allows visual operation.

Options for symbol bar

Clicking on the arrow opens the submenu:

Active: Tool bar is displayed

If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar.

Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.

Further symbols can be added using the toolbar options:

Transfer all Runtime files

Transfers all Runtime files to the target system.

Restart OS

Starts the operating system of the target computer after confirmation. Under Windows CE this option is not supported.

Get system status

Determines system status of the target computer and writes data to the output window. The following are determined:

  • Computer name
  • Operating system
  • Runtime active/not active
  • Start project
  • Real memory
  • Drives
  • Remote serial number
  • Remote activation number
  • Remote zenon version

Change password and display licensing

Opens dialog for connection establishing.

Enables:

  • Changing the password for the connection establishment
  • Display and change of the licensing of the target computer
  • Configuration of the encryption at the target computer

Note: All commands for Remote Transport are available in the project's context menu.


Context menu Remote Transport

Manual -> Remote Transport -> Context menu Remote Transport

You can reach the commands for the Remote Transport via the tool bar or the context menu of the project:

  1. Right-click the project in the project manager
  2. in the context menu select node Remote Transport
  3. select the desired command from the drop-down list

Command

Function

Establish connection

Sets up a connection with the target computer.

Connection settings

Opens dialog to configure the connection.

Transfer changed Runtime files

Transports all Runtime files that were changed on the development computer to the target computer.

Transfer all Runtime files

Transports all Runtime files from the development computer to the target computer.

Read back all Runtime files

Loads all files that can be edited in the Runtime (like recipes or user administration) to the development computer.

Define project as start project

Set start project for target station.

Start Runtime

Starts the Runtime on the target station

Exit Runtime

Stops the Runtime on the target station.

Reload project

Executes the function reload on the target computer.

Restart OS

Starts the operating system of the target computer after confirmation. Under Windows CE this option is not supported.

Get system status

Determines system status of the target computer and writes data to the output window. The following are determined:

  • Computer name
  • Operating system
  • Runtime active/not active
  • Start project
  • Real memory
  • Drives
  • Remote serial number
  • Remote activation number
  • Remote zenon version

Change password and display licensing

Opens dialog for connection establishing.

Enables:

  • Changing the password for the connection establishment
  • Display and change of the licensing of the target computer
  • Configuration of the encryption at the target computer

Remote: Start desktop connection

Starts a connection to operate the target computer using zenon Remote Desktop.


Engineering in the Editor

Manual -> Remote Transport -> Engineering in the Editor

The Remote Transport is configured in the project properties under General/Remote transport and controlled via the tool bar Remote Transport.

To configure the Remote Transport:

  1. navigate to the General node in properties
  2. Click on the Remote transport property
  3. The dialog for the configuration of the connection properties and the files to be transferred is opened.
    Note: the screenshot shows the configuration for the transport medium TCP/IP with the network activated.

Parameters

Description

Transport medium

Serial

Transfer via a serial connection, e.g. to a CE Terminal.
  • Port

Selecting the COM ports for the serial connection.

Note: Only visible if serial has been selected as the transport medium.

TCP/IP

Transfer via TCP/IP in a network or via a modem.

Upload to Server 1 and Server 2

If the checkbox has been activated, the Runtime files are also transferred to the computers entered as Server 1 and Server 2 in the network in addition to the computer entered when a download takes place.

Attention: Data is only transferred to Server 2 if a computer name has been entered for Server 2.

Default: not active

Note: Only visible if the network has been activated in the project settings and the transport medium TCP/IP has been selected.
  • Computer name or IP address

The computer name or the TCP/IP address is entered as target:

  • Enter the computer name manually or via clicking button ...
  • Enter the IP address manually

The IP address must have conform the defined IP version (IPv4 or IPv6).

Source / target

List of connections.

In the first line you can define a target for the top most folder of the structure. Right click in the cell in order to open a context menu for selection.

The path can also be entered manually. For this, the following applies:

  • Backslash in front (\): Path relative to the project.
  • Drive letter in front: Absolute path.
    Note for Windows CE: With zenon, a drive letter can also be entered for Windows CE. This only signalizes that it is an absolute path, and is ignored during the transfer.
  • Attention: This path must be permanently available on the target system. Do not configure an integrated network drive, USB device or removable media!

Note: Note, with multi-project administration, the correct transfer of the individual projects.

The column width in the list can be amended with the mouse.

active

Defines files which should be transferred optionally.

Project base path cannot be deselected.

Source

Folder for files which should be transferred.

Objective

Target folder.

Defines the root folder. New entries can be defined.

Sub-folders cannot be changed. This ensures that all files are found on the target system in Runtime.

Note: The default folder is the Runtime folder defined in the project properties. If the target folder is entered manually, take care that it ends with the project name. This is important for the multi-user administration.

For example:
C:\Users\Public\Documents\zenon_Projects\MY_PROJECT

Revision

Type of transfer. Can be selected freely for the root folder and new entries. Clicking on the word (Copy) opens a drop-down list:

  • Copy:
    Copies files (default)
  • Copy and register:
    copies files and registerd them in the system. Helpful for ActiveX elements and for fonts (ttf files).
  • Copy and execute:
    copies files and then executes them

Note: The type of transfer is only available for freely-definable entries. Files necessary for the functionality of Runtime are automatically created in the list and the type of transfer cannot be changed.

Description

Optional text input for new entries for describing the files which should be transferred.

attention Attention

For redundant projects: If drivers are used which need a configuration file, you must deactivate entry \zenon\custom\drivers .

Remote control in the network

In the context menu select projects -> Remote Transport -> <Command>:

Parameters

Description

Establishing a connection

With the service zenSysSvr a connection to the target device is established. On both devices the service zenSysSvr.exe or on the CE device the service SysSrvCE.exe has to be started. The versions have to be identical.

Transport changed Runtime files

If this setting is selected, the Runtime changed since the last transport are transported. If no Runtime files exist on the target device, all Runtime files are transported.

Transport all Runtime files

If this entry is activated, all Runtime files are transported. The only exception are files like e.g. standard recipes or Message Control, which are defined in the setting: 'RT changeable data'.

Read all Runtime files

If this setting is selected, all Runtime files of the modules Recipes, Recipegroup Manager, Message Control , User administration and Production & Facility Scheduler (PFS) are transported from the target system to the local Runtime directory. Then the changes in the Runtime can be read to the Editor with the option 'Import Runtime files'.

Define project as start project

The selected project is defined as the start project. This project is loaded on each Runtime start.

Start Runtime

Starts the Runtime.

Exit Runtime

The Runtime is closed.

Reload project

The project is reloaded. Changes Runtime files are read.

Restart OS

The device with which the connection exists is restarted after a confirmation message. If necessary, it must be logged on to the operating system again. Under Windows CE this option is not supported.

Get system status

It is checked, if the Runtime is running on the target system and with which status. Also the installed zenon version is checked. The following are determined:

  • Computer name
  • Operating system
  • Runtime active/not active
  • Start project
  • Real memory
  • Drives
  • Remote serial number
  • Remote activation number
  • Remote zenon version

Change password and display licensing.

Opens dialog for connection establishing.

Enables:

  • Changing of the password
  • Display and change of the licensing
  • Configuration of the encryption

Start remote desktop connection

Starts a connection to operate the target computer using zenon Remote Desktop.


TCP/IP

Manual -> Remote Transport -> Engineering in the Editor -> TCP/IP

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Remote Transport configuration the name of the target system or the IP address is entered. The IP address must conform to the defined IP version, i.e. IPv4 compliant when using IPv4 and IPv6 when using IPv6.

When using the name, the names used recently are saved and can be selected via the drop-down list. Using port number is only possible together with names.

attention Attention

As a default the Remote Transport always uses the TCP port 1101. This port must not be blocked by other applications.


Automatic setting in network projects

Manual -> Remote Transport -> Engineering in the Editor -> TCP/IP -> Automatic setting in network projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If the project to be transferred is configured as a network project, no other settings need to be made in the Computer name or IP address input field in the Remote Transport connection setting. In this case, Remote Transport always uses the computer entered in the network configuration as Server 1 in the properties field. It is therefore guaranteed that the changes are always transferred to the server, which then automatically transfers them to all clients!

If the checkbox Upload to Server 1 and Server 2 has been activated, not only the computer to which there is a connection is updated. The servers that have been entered are also updated.

The requirements for this are:

  • Checkbox active
  • Network active
  • Server 1 entered

Server 2 is only entered if a computer name has been entered for Server 1.

If the connected computer is one of the servers (regardless of whether it is connected via name or IP) no additional upload is carried out on this computer any more. This additional upload would be redundant in this case, because the update has already taken place via Remote Transport.

info Information

You can find further information on the zenon network in the Network chapter.


Serial

Manual -> Remote Transport -> Engineering in the Editor -> Serial

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As default the communication in the Remote Transport is carried out via TCP/IP. You can however change it to serial communication. So you can connect for example to Windows CE devices. For this:

  • change the communication type of the transport service at the remote device via zenon6.ini
  • configure the Remote Transport in the Editor

attention Attention

If the zeno6.ini is edited, the changes become effective after a restart of the transport service.

zenon6.ini entries

If the transport service should be used for serial transport, the following entries have to be made in the zenon6.ini on the target system by hand: Note: Under Windows CE these entries are automatically generated in the zenon6.ini with the help of the user interface of the transport service.

[SYS_REMOTE]

; SysService attached to the COM interface:

CONFIG=DEVICE=COM;

PORT=COM2;

attention Attention

Do not forget the ; (semi-colon) at the end.

With this setting the Remote Transport works with the baudrate 115200 bits/second. As a default the Editor is also set to this baudrate.

Settings Editor

In the Editor select:

  1. Serial as Transport medium
  2. in the drop-down list the COM port of the source computer


Define files

Manual -> Remote Transport -> Engineering in the Editor -> Define files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You define which files are transferred in the configuration dialog via the check box in column active. The line with the project base path cannot be deactivated. The project files always are transported.

Note: Source paths are always created relative to the project base path.

attention Attention

Note the effects of settings if the project is used in the network.

For example:

Transport of graphics is deactivated, because these are already on the server. Then a client is started. The client finds out that the graphics should not be transported and thus does not transport them to itself. No graphics are then displayed on the client.

Or vice-versa, files are transferred to the client and the files there are overwritten.

Files for transfer

With Remote Transport, all files required for the project are transferred to the target system.

In doing so, all files are always transferred to the folder:

  • Standard

    All files that are in the project's Runtime folder (...\RT\FILES\zenon\system\).
    These files determine the appearance and behavior of the project and are transferred as standard:

info Info

Files with the following suffixes are not transferred by default:

  • .hot
  • .ho
  • .ret
  • .re
  • Optional

    In addition, all files that are embedded into the project must be transferred. They are selected using the Active checkbox of the Remote Transport settings. These files are in the following subfolders of the project directory:

    • \zenon\custom\graphics: for graphics
    • \zenon\custom\lists: for language tables
    • \zenon\custom\media: for all media files
    • \zenon\custom\reports: for the reports of the Report Generator
    • \zenon\custom\help: for help files
    • \zenon\custom\additional: for additional files
    • \zenon\custom\additional: for Report Viewer files
    • \zenon\custom\drivers:for drivers
    • \straton: for zenon Logic

    Recommendation: Project basis path, graphics, language tables, report tables and media files are always transferred.
    The following are transferred from the basis path by default: The files project.ini, Projekt.vba, Monitor.mon and the Projekt folder.

    As a default zenon always uses relative paths and not absolute paths, so that the files can easily be found on the target system.

    For the files that can be transferred optionally, the original paths should be used (empty field under target), so that zenon can find them on the target system.

Global project

If there is a global project in the workspace, this is automatically transferred. No additional settings need to be made. Always all files necessary for the global project will be transported.

Set start project

For Runtime, the start project must always be entered in zenon6.ini. To do this, click on the Set remote Runtime start project in the Remote Transport toolbar. In doing so, the following entries are set:

[PATH]

VBF30=project path

[DEFAULT]

DEFANWENDUNG30=project name

Selecting individual files

To transfer own individual files:

  1. right click in the first empty cell in column Source
  2. in the context menu select File selection or Folder selection
  3. the explorer is opened for selection
  4. select the desired file or the desired folder
  5. activate the checkbox in column active
  6. right click in the cell in column Target
  7. define the target folder
    If the target remains empty the files are transferred in the same directory structure as defined under source.

attention Attention

Specify paths relatively!

Enter the paths for your individual files relative to the project base path. With this the target system also has the correct folder structure.
Example:

Specification at Source: enter /default.iso.
The Remote Transport now automatically knows that the file is in the project basis path.
Folders are entered the same way.

Windows CE:

If the target system is a Windows CE terminal and no explicit destination is entered for the project basis path, the destination /Storage Card/Data is used as a default.

Action at transfer

In newly added lines the entry of the column Revision defines, how to proceed with the according files during Remote Transport. Three possibilities are available here:

Action | Description
Copy | The file is copied to the remote system.
Copy&register | The file is copied to the remote system and entered in the registry. Hint: Helpful for ActiveX elements and for fonts (ttf files).
Copy&execute | The file is copied to the remote system and executed there.


Runtime changeable data

Manual -> Remote Transport -> Engineering in the Editor -> Runtime changeable data

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There are different data which can be changed in the zenon Editor as well as in the Runtime. These are files for:

  • Recipegroup Manager
  • Standard recipes
  • User administration
  • Scheduler

Protect Runtime files from overwriting

If all Runtime files are created or transported, the files meanwhile changed in the Runtime would be overwritten. In order to avoid unwanted overwriting the files, that should not be created or transported, can be selected here in the section Do not generate and transfer.

Protect Editor files from overwriting

Data changed in the Runtime can be read back. In this case the corresponding Editor data are overwritten. In order to avoid unwanted overwriting the files, that should not be read beack, can be selected here in the section Do not decompile.

Dialog RT changeable files

You can reach the dialog for configuring the Runtime changeable files via project settings General/RT changeable data:

The following file types can be selected:

TAGs | Description
Recipegroup Manager | Recipe groups and recipes of the Recipegroup Manager. At the transfer new files are transferred and new sub-folders are created, deleted files and sub-folders are also deleted on the target system.
Standard recipes | Standard recipes.
User administration | User administration for login and rights administration in the Runtime.
Scheduler | Changes in the time models and schedules of the PFS.

attention Attention

At the project conversion take care that Runtime changeable files are also converted. For this Runtime files must be imported to the Editor and after the Update copied back to the Runtime. For details see chapter Recommended procedure for converting Runtime files in manual project conversion.

Transferring the files

In the Runtime

To transfer files to the Runtime:

  1. all files can be transferred
  2. only changed files can be transferred

Both possibilities consider the files defined in property RT changeable data.

From the Runtime

To read files from the Runtime, there are two processes available:

  1. Restore all Runtime files:
    1. reads back all Runtime files in the folder which was defined in property Runtime folder
    2. regardless of the settings of property RT changeable data
  2. Import Runtime files:
    1. imports the files defined in property RT changeable data and
    2. replaces the engineering in the Editor by these Runtime files
    3. is suitable for taking over data from a remote system in the Editor

Connection error

During the transfer existing data are overwritten in accordance with the settings.

If errors occur at the transfer to or from the Runtime or if the connection is disrupted, the files must be completely transferred again.


Windows CE

Manual -> Remote Transport -> Engineering in the Editor -> Windows CE

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Transfer to Windows CE systems can be effected via a TCP connection, a serial connection or via memory cards.

Configuration

Serial or TCP/IP

  1. Ensure that in the project properties the General property in node Windows CE project is activated.
  2. Select the connection type
    • TCP/IP
    • Serial
  3. The configuration dialog now contains nine entries; C:\Storage Card\Data is pre-set as a target directory.
    The C:\ is automatically removed by Remote Transport, because communication with CE systems is carried out without drive letters.

Memory card

The Remote Transport supports a special transport type, where the project is transported directly to a storage card instead of using a serial or TCP/IP connection. To do this a computer which can directly access a memory card (PCMCIA, ATA card, Compact Flash, etc.) is necessary.

attention Attention

It has to be guaranteed that the CE Runtime and the zenon6.ini are in the root of the card!

Insert the card in the according slot and check which drive letter is assigned to the card by the operating system. (e.g.: D:, or E:, ...)
  1. Activate check box Use local card reading device
  2. Define the Runtime folder at the target device,.

    Example: if the memory card is listed as \Storage Card under CE, the Runtime folder on the target system must be C:/Storage Card/project path! C:\ will then automatically be removed by the Remote Transport!

  3. Establish a connection to your own PC and transfer the files to the local memory card.
  4. Write the Runtime folder at the target device with the help of function Set remote start project (Tool bar Remote Transport) in file zenon6.ini on the memory card.
  5. Put the memory card in the CE terminal and start the Runtime.


Establish connection

Manual -> Remote Transport -> Establish connection

To establish a Remote connection:

  1. Click on the corresponding button in the Remote Transport toolbar

    or select, in the project's context menu: Set up Remote Transport> connection

  2. the dialog for setting up the connection is opened

Parameters |  | Description
Connection password |  | Setting for the password for the remote connection.
Password |  | Enter the password for the connection establishment (optional).
Change connection password |  | Opens the dialog for changing the password.
Configuration of the target system |  | Settings for the target system.
Configure serial number and activation number |  | Active: The licensing of the remote computer is displayed after establishing the connection and can be changed. Default: Inactive
Configure the encryption of the network communication | Active: After the connection has been established you can activate or deactivate the encryption of the network communication at the target system. Note: For this the connection of the Remote Transport must be protected by a password. Default: Inactive
Do not display this dialog |  | Active: This dialog is not opened at the establishing of the connection. Note: To display the dialog again, in the context menu of the project select Remote Transport -> Change password and display license Default: Inactive
OK |  | Applies settings and establishes the connection.
Cancel |  | Discards changes and closes the dialog without establishing a connection.
Help |  | Opens online help.


Encryption

Manual -> Remote Transport -> Establish connection -> Encryption

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Remote Transport connection can be encrypted via SysSrv. To do this, enter a password into Remote Transport. Form version 7.20, the password is saved in encrypted form:

  • At the source (Editor) in project.ini, TRANSPASS section.
  • At the destination (Runtime) in zenon6.ini, TRANSPASS section.

Remote Transport communication can also be encrypted. To do this, the encryption of the zenon network need only be activated in the Startup Tool.

Store password in encrypted form

The password for the Remote Transport transfer is stored by default in the project.ini file in the [TRANSPASS] section in the KEYCRYPT= key. The password can be stored as plain text in the KEY= key. This method has been used up to and including version 7.11. With the conversion of a project to version 7.20, the value for the KEY= key is deleted and the password is stored in encrypted form in the KEYCRYPT= key.

The following is applicable for the transfer:

  • If there is a value for KEY=, SysSrv uses the unencrypted password. This also applies if an encrypted password is entered in KEYCRYPT=.
  • If KEY= is not present and KEYCRYPT= is present, SysSrv uses the encrypted password.
  • Entering or changing the password: If KEY= is present, this entry is updated. If it is not present and it is version 7.20 or higher, an entry is created in KEYCRYPT=.
  • Project conversion: If, in the project.ini file, KEY= exists, its value is deleted and a new entry KEYCRYPT= is created and filled.

Behavior

Local editor | Remote PC | Remote password | Result | Condition
<7.20 | <7.20 | no | Connection OK | With empty password.
<7.20 | <7.20 | Unencrypted | Connection OK | With correct password.
<7.20 | <7.20 | Encrypted (no) | Connection OK | Remotely encrypted password is ignored.
>=7.20 | <7.20 | no | Connection OK | With empty password.
>=7.20 | <7.20 | Unencrypted | Connection OK | With correct password.
>=7.20 | <7.20 | Encrypted (no) | Connection OK | Remotely encrypted password is ignored.
>=7.20 | >=7.20 | no | Connection OK | With empty password.
>=7.20 | >=7.20 | Unencrypted | Connection OK | With correct password.
>=7.20 | >=7.20 | Encrypted | Connection OK | With correct password.
>=7.20 | >=7.20 | Encrypted + unencrypted | Connection OK | With correct password.
<7.20 | >=7.20 | no | Connection OK | With empty password.
<7.20 | >=7.20 | Unencrypted | Connection OK | With correct password.
<7.20 | >=7.20 | Encrypted | Connection OK | With correct password.
<7.20 | >=7.20 | Encrypted + unencrypted | Connection OK | With correct password.

Conversion

  • In the Editor (source system), when converting the project from version X to 7.20, the KEY= entry is replaced by KEYCRYPT= and the password is saved in encrypted form here.
  • On the target system, there is a query to see whether KEY= in zenon6.ini has an entry.
    Yes: This entry has priority. For conversion, the entry on the target system must be deleted manually.

Encrypting all communication in the network

The complete communication can be encrypted by activating the encryption of the zenon network traffic.

Behavior

Source version (Editor) | Target version (Runtime) | Network Source encryption | Network Target encryption | Connection possible
<7.20 | <7.20 | Any | Any | Yes
<7.20 | >= 7.20 | Any | Active | No
<7.20 | >= 7.20 | Any | Inactive | Yes, unencrypted
>= 7.20 | <7.20 | Inactive | Any | Yes
>= 7.20 | <7.20 | Active | Any | No
>= 7.20 | >= 7.20 | Inactive | Inactive | Yes, unencrypted
>= 7.20 | >= 7.20 | Inactive | Active | No
>= 7.20 | >= 7.20 | Active | Inactive | No
>= 7.20 | >= 7.20 | Active, password "abc" | Active, password "def" | No
>= 7.20 | >= 7.20 | Active, password "xyz" | Active, password "xyz" | Yes, encrypted

Activation of the network encryption via Remote Transport

If the network encryption is activated via Remote Transport, the following is applicable:

  • Until a restart, Remote Transport also runs without encryption after a password has been set for network encryption.
  • After restarting the target, it demands an encrypted connection with the correct password.


Change connection password

Manual -> Remote Transport -> Establish connection -> Encryption -> Change connection password

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To change the connection password:

  1. in the context menu of the project select Remote Transport -> Establish connections or Change password and display license
  2. in the dialog click button Change connection password
  3. the dialog for changing the password is opened

Parameters | Description
old password | Enter existing password.
New password | Enter new password.
Confirm password | Enter new password again and confirm it by doing so.


Configure the encryption of the network connection

Manual -> Remote Transport -> Establish connection -> Encryption -> Configure the encryption of the network connection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The network communication can be protected by serious encryption. Encryption is either activated locally using the zenon Startup Tool, using a tool for the zenon Web Client or via Remote Transport in the Establish connection dialog:

Parameters | Description
Read local configuration | Reads in the encryption parameter of the local computer.
Encrypt network communication | Active: The encryption of the network is activated at the remote computer. Default: Inactive
Password | Enter password. For the criteria, see the "Network encryption password" section in the Strong encryption of network communication chapter. The displayed length is always set at 20 characters, in order to hide the actual length.
Confirm password | Enter the password for verification again.
OK | Saves changes and closes dialog.
Cancel | Discards changes and closes the dialog.
Help | Opens online help

The password defined here is stored encrypted in the zenon6.ini of the remote computer.

info Information

You can find notes on error messages from strong encryption in:

Network handbook -> Strong encryption of network communication chapter -> Error messages section.


Batch processing Transfer to several computers at the same time

Manual -> Remote Transport -> Batch processing Transfer to several computers at the same time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Several computers can be addressed at the same time with the help of status processing.

Configuration of Remote Transport status processing:

  1. Create a file named hosts.txt.A-Z
  2. Enter the IP address or the computer name of each computer on a separate line

    Example:

    HOST=192.168.0.24;
    HOST=192.168.0.15;

  3. Place hosts.txt in the \zenon\custom\additional folder.


Reporting

Manual -> Reporting

The integrated reporting in zenon serves as documentation, evaluation and presentation of process data on the basis of online and archive data from zenon. Reporting is divided into:

  • Report Generator
  • Report Viewer

Neither reporting variant is available with Windows CE.

tutorial License information
  • In the Editor: Both must be licensed.
  • In Runtime:
    Report Viewer:
    In the Runtime always included in the standard package.Report Generator: Integrated as standard for display of reports only. If you want to write archive values or set values with the Report Generator, you also need a license in the Runtime.

zenon Analyzer is available for comprehensive, platform-independent reporting of the process level through to ERP. Your COPA-DATA sales partner would be happy to inform you about this.


Report Generator

Manual -> Reporting -> Report Generator

The Report Generator documents, evaluates and presents process data on the basis of online and archive data. The report generator works on a cell-orientated basis. Each cell can be assigned certain functions and formats.

Reports are configured using the Report screen. The data is filtered, calculated, issued and displayed via report functions. These are entered using dialogs or manually. Values can be read and - if permitted on the screen - also edited. The report generator meets the requirements of rule sheet and ATV H260.

Context menu Project manager

Menu item | Action
New report | Creates a new report in the list in detail view.
Import existing report... | Opens the File Manager to select an existing file.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.

info Information

The status bits NORM and N_NORM are not displayed in the report. The status bit NORM cannot be changed using the report.


Engineering in the Editor

Manual -> Reporting -> Report Generator -> Engineering in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To be able to use reports in Runtime, the following must be carried out in the editor:

  • A report type screen is created
  • A report is created and configured
  • A switching function is configured in Runtime

Recommended procedure for planning the report:

  • Create report
  • Format report
  • Create archive filter
  • Configure report functions


Create screen of type Report Generator

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Create screen of type Report Generator

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the type report screen, the reports created with the report generator are displayed in Runtime and configured with the corresponding rights. The display size depends on the template size selected. The report that is displayed can be determined in screen switching or in Runtime.

In order to create a report screen:

  1. Select the New screen command in the Screens node
  2. In the Screen type column, select the Report drop-down list
  3. in the menu bar, select Control elements -> Add template
  4. A report with standard settings is created
  5. If necessary, add further control elements from the Control elements menu
  6. Create a screen switch, to select the screen in Runtime

Parameters

Description

Add template...

Opens the dialog for selecting a template for the screen type.

Templates are shipped together with zenon and can also be created by the user.

Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.

Windows

Control elements for window display.

Report

Report window to display the report.

Set filter

Displays the currently-configured time filter in Runtime.

Functions

Buttons for controlling in the Runtime.

Filter

Select report file and change filter conditions.

Refresh

Recreate build report completely (values and display).

Print

Print report in Runtime.

Export

Export report.

Save archive

Write changed values to the archive.

Save report

Report is saved in Runtime (*.xrs).

Attention: When saving, formulas and functions are replaced by the current values. The functions in these reports (.xrs files) are no longer available. These reports can also not be edited in the editor anymore.

Recommendation: Set original report files to "write-protected" status and save changes with Save as in a new file.

Save report as

Report is saved under a new name during Runtime (*.xrs), formulas and functions are replaced by current values.

Read selected values

Selected values are read in again from the driver.

Write selected values

Selected values are sent to the driver.

Read all values

All values are read in again from the driver.

Write all values

All values are sent to the driver.

Navigation

Control elements for navigation.

Line up

Scroll text in list element up

Line down

Scroll text in list element down

Column right

Scroll text in list element to the right

Column left

Scroll text in list element to the left

Page up

Scroll text in list element up

Page down

Scroll text in list element down

Page right

Scroll text in list element to the right

Page left

Scroll text in list element to the left

Filter profiles

Buttons for filter settings in Runtime.

Profile selection

Select profile from list.

Save

Saves current setting as a profile.

Delete

Deletes selected profile.

Import

Imports filter profiles from export file.

Export

Exports filter profiles in the file.


Create a new report

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Create a new report

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Before a report is created, the report printer should be defined because the page formatting of a report depends on the printer that has been set. Subsequent changing of the printer can necessitate reformatting of the existing table.

In order to create a new report:

  • Navigate to the report generator node in the project manager
  • Select the New report command in the context menu
  • a new report is created in the detail view
  • An empty worksheet is created in the main window

Functionalities of the worksheet:

  • Assignment of process information using report functions
  • Formatted display of content of cells, columns and rows
  • Subtotals
  • Assignment of editing blocks

info Information

The following applies for the input in cells: A decimal value can be entered with a comma as well as with a period as a separator. The decimal separator is automatically changed to a period.

seealso See also


Report menu

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Create a new report -> Report menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Report menu is shown when a report is selected:

Parameters

Description

Save report

Saves all changes in the active report. Changes in other reports are not saved.

Export report functions

Exports all report functions from the active report to a text file.

Structure: Column / row =function(parameter)

Redraw report

Draws a new report.

Calculate report

Calculates a new report.

Set up page

Opens the dialog to set up the print page.

Print report

Prints the report using the printer defined in the standard settings..

Print area

Defines printed areas or cancels them:

  • Define printing area: Defines marked areas of the table as a print area.
  • Release printing area: Cancels defined print area

Report - Page view

Switches from layout view to page view. The view can be zoomed using the left mouse button.

Leaving page view: Press Esc key.

Report file Info

Opens the dialog to administer the report file information.


Menu Edit

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Create a new report -> Menu Edit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When a report is selected, the Edit menu offers special functions for reports:

Command

Description

Cut

Cuts out highlighted area and copies it to the clipboard.

Copy

Pastes the contents of the clipboard.

Paste

Copies highlighted areas to the clipboard.

Paste enhanced

Provides advanced paste options for cell operations:
  • All

Inserts everything from the clipboard.
  • Formulas

Only inserts formulas
  • Value

Only inserts values. The relationship to formulas is lost.
  • Format

Only accepts the format.

Fill

Copies the content of the first cell of a marking and transfers it to all further marked cells.

  • Down

Filling is carried out in a downward direction.
  • to the right

Filling is carried out from left to right.

Delete

Removes from highlighted cells:
  • All

Everything.
  • Contents

Contents only.
  • Format

Formats only.

Delete column/row

Deletes highlighted columns or rows.

Insert column/row

Inserts new columns or rows. Insertion is carried out above the row or to the left of the column. As many rows/columns are inserted as are highlighted in the worksheet.

Search/replace

Opens the dialog for searching and replacing in a worksheet.


Format menu

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Create a new report -> Format menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Format menu provides properties and functions for formatting the report table:

Parameters

Description

Cells

Formatting options for cells:

  • Font
  • Pattern
  • Border
  • Alignment
  • Numbers
  • Lists

Row

Formatting options for rows:

  • Row height: Opens dialog to define the row height
  • Row format: Opens dialog for all row properties

Column

Formatting options for columns:

  • Column width: Opens dialog to define the column width:
  • Column format: Opens dialog for all column properties

Report

Opens the dialog to format the report.

Function wizard

Opens assistant to create report functions.

Filter

Opens report filter to select archives.


Toolbar Report Generator

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Create a new report -> Toolbar Report Generator

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A toolbar is available in the Editor for the Report Generator. If it is not displayed yet, you can load it:

  1. Open the menu Options -> Settings -> Tab: Toolbar
  2. Tick the checkbox next to Report Generator
  3. confirm this with OK.

Symbol (from left to right) | Function
Print report | Prints the report on the default printer.
Report - Page view | Opens the report in a preview. The report can be enlarged or minimized in the preview (zoom), you can leaf through it and it is printable.
Refresh report | Refreshes the display.
Recalculate functions | Recalculates the formulas in the report.
Function wizard | Opens a dialog that helps with the configuration of functions.
Font | Opens the dialog for cell formatting - focused on the Font tab.
Text alignment | Opens the dialog for cell formatting - focused on the Alignment tab.
Border | Opens the dialog for cell formatting, with focus on the tab Frames.
Pattern | Opens the dialog for cell formatting - focused on the Pattern tab.
Options for symbol bar | Clicking on the arrow opens the submenu: Active: Tool bar is displayed If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar. Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.


Detail view of context menu and toolbar

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Create a new report -> Detail view of context menu and toolbar

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Menu item | Action
New report | Creates a new report in the list in detail view.
Open report | Opens the selected report or focuses on the one that is already open.
Create standard function | Creates a zenon function for report generator. The action is documented in the output window.
Jump back to starting element | If you entered the list via function linked elements, the symbol leads back to the start element. Only available in the context menu when all linked elements are opened.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Import existing report... | Opens the File Manager to select an existing file.
Remove all filters | Removes all filter settings.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Help | Opens online help.


Creation of table window

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Create a new report -> Creation of table window

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Reports are displayed in two parts when being edited in the Editor in the main window:

  • The left area contains the table for the draft
  • The right part displays a preview of the output

The size of the areas can be amended individually. To do this, move the mouse to the right edge of the table scroll bar until the mouse pointer becomes a moving tool and move the scroll bar to the desired position.

Input row

The table has an input row at the upper edge. If, in the report Properties, the Edit in the cell property is activated, this row is not displayed. Input must then be made in the row itself.


Data sheet context menu

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Create a new report -> Data sheet context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Menu item

Action

Cut

Deletes highlighted entries and places them on the clipboard.

Copy

Copies the selected entries to the clipboard.

Paste

Pastes the contents of the clipboard.

Expand insert

Enables the contents of the clipboard that are to be inserted to be selected:

  • All: transfers complete contents
  • Formula: Transfers only formulas
  • Value: Transfers only the value
  • Format: Transfers only the format

Fill

Copies the content of the first cell of a marking and transfers it to all further marked cells. It is possible to select if they are filled downwards or to the right.

Delete

Makes it possible to select the content of a cell to be deleted:

  • All: Deletes the complete contents with format
  • Content: Removes the content, but leaves the format
  • Format: Deletes only the format, but leaves the content

Insert column row

Inserts a new row above a highlighted row or a new column to the left of a highlighted column. If several rows/columns are highlighted, the number of highlighted rows/columns is inserted.

Delete column row

Deletes the highlighted rows or columns

Report...

Opens the dialog to format the report.

Cell...

Opens the dialog to format the a cell.

Column...

Opens the dialog to format the columns.

Row...

Opens the dialog to format the rows.

Functions...

Opens the assistant to create report functions.

Note: The assistant offers a selection of over 150 functions. Further functions can be entered manually into the input line of the data sheet.


Printer settings

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Printer settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The report layout (side margins, page sizes) depends on the printer configured. You can find the settings for the report printer via File -> General configuration -> Standard -> Printer for values to be given and protocols.

Here you define

  • the printer and
    • Paper format of the print
    • Paper source of the printer
    • Direction of print

attention Attention

The desired printer must be selected before creating the report, because the page formatting of a report depends on the printer that has been set. Subsequent changing of the printer can necessitate reformatting of the existing table.

Printer configuration

Printer

Parameters | Description
Printer | Settings for the printer.
Name | Selection of the printer from the drop-down list. The list contains all printers configured in the operating system.
Properties... | Opens printer configuration dialog.
Status: | Display printer state. For information only.
Type: | Display printer type. For information only
Location: | Display the location of the printer if configured. For information only.
Comment: | Display comment about printer if configured. For information only.

Paper

Parameters | Description
Paper | Configuration of the printout.
Size | Select paper format from drop-down list.
Source | Select paper feed from drop-down list.

Alignment

Parameters

Description

Alignment

Select paper alignment. Possible parameter:

  • Portrait Format
  • Landscape

Network

Opens dialog for selecting a printer in the network.

OK

Applies configuration and closes the dialog. With this printing is started in the Runtime.

Cancel

Discards configuration and closes the dialog. In the Runtime this also cancels the printout.


File info

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> File info

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Report -> Report file info dialog, information on the respective report file can be saved.

Parameters | Description
File name | Name of the report file. Information only; cannot be changed here. Can be changed in the detail view.
Folder | Save location of the report file. Information only; cannot be changed here.
Title | Free text input
Theme | Free text input
Author | Free text input
Comment | Free text input


Finding and replacing in the report

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Finding and replacing in the report

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To find formulas, character strings or values and replace these:

  1. Activate the desired report
  2. Select Find/replace in the Edit menu.
  3. The dialog to find and replace is opened

Parameters

Description

Enter expressions

Input of character string for finding and replacing.

Search for

Character string that is being searched for.

Replace by

Character string that replaces the one that is found.

Replace

Replaces currently displayed finding with sequence from Replace with.

Replace all

Replaces all currently displayed findings with sequence from Replace with.

Continue search

Looks for next instance of the character string being searched for.

Search options

Search options

Search in

Select from drop-down list:

  • Formulas: Searches in formulas
  • String: Searches in character strings
  • Value: Searches in values

Find substring

Also searches partial areas of cells.

Case sensitive

Note capitalization during the search.

Close

Closes the dialog.

Help

Opens online help


Formatting

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Formatting

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Before creating a report, the necessary formatting should be carried out:

  • Page: Set up print properties for the page
  • Report: Set up report properties
  • Cell: Define the formatting of the cells (direction, border, font, pattern, type, lists)
  • Columns and cells: Formatting for selected columns or cells

You can find the settings in the Report and Format drop-down lists in the menu bar or in the context menu of the worksheet.

Hint: Ensure that reports with large amounts of data have sufficient lines/columns for output.


Set up page

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Formatting -> Set up page

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Set up page... command in the Report menu opens the dialog to configure the report page. This contains the two tabs:

  • Border
  • Headers and footers


Border

Border

Parameters

Description

Set margins

Define print margin independently of the printer setting

top

Distance of the report from the upper edge.

bottom

Distance of the report from the lower edge.

Left

Distance of the report from the left edge.

Right

Distance of the report from the right edge.

Header

Distance of the header from the text.

Possible values: 0 to 20; 0 = hidden.

The value selected must be large enough to be able to display the selected font size under header and footer.

Footer

Distance of the footer from the text.

Possible values: 0 to 20; 0 = hidden.

The value selected must be large enough to be able to display the selected font size under header and footer.

General

Print area

Defines the print area based on the cell A1. Input in the text field: Coordinates of the end value of the range.

Example: D5 defines the print area of the cells A1 to D5.

Note: The print area must be at least 2 lines and 2 columns All instructions with A or 1 are thus invalid and are not executed.
Examples: A7: invalid; D1: invalid; B2: valid.

Printer

selection of the printer for the report. Clicking on the drop-down list opens the list of all defined printers available in zenon printer settings.

Default: Values and protocols

Adjust printing area to printer

Active: The printing area of the report is adjusted to the settings of the selected printer.

Note: The print area must be at least 2 lines and 2 columns All instructions with A or 1 are thus invalid and are not executed.
Examples: A7: invalid; D1: invalid; B2: valid.

Static lines/columns for printing

Active: Static lines and columns are also printed.

Centered

Orientation of the report on the print page

vertical

Centers the report vertically.

horizontal

Centers the report horizontally.

Alignment

Settings of page format

Portrait

Prints in portrait format.

Landscape

Prints in landscape format.

Printway

Sequence of the page print out for multiple pages

From left to right

Print out several pages from left to right.

From top to bottom

Print out several pages from top to bottom.


Headers and footers

Headers and footers

Parameters | Description
Header | Definition of the header area
Left section | Left text for the left third of the header.
Middle section | Centered text for the center of the header.
Right section | Right text for the right third of the header.
Font | Opens the dialog to select the font, font size and emphasis of the footer text.
Footer | Definition of the footer area
Left section | Left text for the left third of the footer.
Middle section | Centered text for the center of the footer.
Right section | Right text for the right third of the footer.
Font | Opens the dialog to select the font, font size and emphasis of the footer text. Note that the settings for the header/footer can be selected in borders in such a way that the font size can be displayed in full.
Keywords | Key words for headers and footers
&[Page] | Page number
&[Pages] | Total number of pages
&[Date] | Printing date
&[Time] | Printing time
&[File] | File name


Format report

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Formatting -> Format report

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For formatting the whole report, there are settings for:

  • General: General settings for the report
  • Columns: General settings for columns, such as number etc.
  • Rows: general settings for rows, such as number etc.

To format, select either the Report command in the Format menu or the Format report command in the context menu of the report sheet.


General

General

Parameters | Description
Title | Table heading
Selection | Defines selection behavior when clicked.
whole row | Active: The whole row is selected.
one cell | Active: Only the cell that has been clicked on is selected; multiple selection of cells is not possible.
Options |
Automatic calculation | Active: Calculations are automatically updated when input values are changed.
Display grid | Active: Shows grid network lines in the editor.
Edit in cell | Active: Entries are made in the cell directly; the input cell in the report window is shaded out.
Click references | Active: The cell that has been clicked is accepted as the report coordinate when formulas are entered. For example: Instead of entering A12, the A12 cell is clicked.


Columns

Columns

Parameters | Description
Column settings |
Number of columns | Defines the maximum number of columns. Valid value: 0 to 31000.
Static columns | Number of columns that are always shown. Scrolling only takes place after the static columns.
Show buttons above each column | Active: Shows target numbers.
Enable column formatting | Active: The column width can be adjusted using the mouse by dragging the borders of the header.


Lines

Lines

Configurable features of the rows are:

Parameters | Description
Number of rows | Defines the maximum number of rows. Valid value: 0 to 31000.
Static rows | Number of rows that are always shown. Scrolling only takes place after the static columns.
Show buttons to the left of each row | Active: Shows column header >(A, B, C, ...).
Enable row formatting | Active: The row width can be adjusted using the mouse by dragging the borders of the row numbering.


Format cell

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Formatting -> Format cell

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For formatting the cells of the report sheet, there are settings for:

Alignment

Border

Font

Pattern

Cell type

Lists

For formatting, select:

  • The Format cell command in the context menu of the report sheet to open the dialog
  • or the desired sub-menu in Report -> Format cells, to open the dialog with the corresponding tab


Alignment

Alignment

The display of cell contents is defined in the Orientation tab.

The following are available for vertical positioning:

  • General
  • Top
  • Center
  • Bottom
  • Wrap

The following are available for horizontal positioning:

  • General
  • Left
  • Center
  • Right

info Information

If text is to be displayed vertically, select the vertical property in the Font property.


Border

Border

In the Frame tab, you define if a frame is displayed around a cell and if so, in what form. You can define each side of the frame (top, bottom, left, right) in terms of type and color:

  1. Define the type and color.
  2. Allocate these by clicking the whole frame or an individual page.

Parameters | Description
Border selection | Clicking in the center activates all our frame sides. Clicking on the frame side activates these.
Line type | Selection of line type from drop-down list.
Line color | Selection of line color from drop-down list.


Font

Font

The standard Windows settings are available for fonts.

Parameters | Description
Font family | Selection of the font.
Font style | Selection of the aspect.
Font size | Selection of aspect in point.
Effects |
Struck out | Active: Text is displayed as strike-through in the cell.
Underline | Active: Text in the cell is underlined.
Color | Is not taken into account! The color must, for example, be set in a dynamic element when using the font
Script | Is not taken into account! Unicode display is used throughout.
Example | Shows effects of the selection on the text in cells.


Pattern

Pattern

You define the color and pattern of the cell in the pattern tab.

Parameters | Description
Pattern | Selection of cell pattern from the drop-down list.
Foreground | Selection of foreground color from drop-down list.
Background | Selection of background color from drop-down list.


Cell type

Cell type

Define the output format in the cell type tab. You have the choice between:

  • General: Output of values, data and binary data
  • Combo box: Create lists
  • Data type: Definition of data types
  • Graphics file: Inserting graphics

The respective format key is described in the Formatting key chapter.

General

Parameters

Description

Format strings

Selection of the output format
  • Value

Numerical value. For details, see the Numerical data types chapter.
  • Date

Date information. For details, see the Data types for date and time chapter.
  • Time

Time information. For details, see the Data types for date and time chapter.
  • Binary value

binary value. For details, see the Logical data types chapter.

Locked

Active: Locks the cell for editing in the editor and locks entries in the online report.

Example Example

Format string for value output:
*0.00 = any desired value with two decimal points

dd/mm/yy hh:mm = 01/01/10 12:30 (corresponding to the settings in the operating system

Combobox

The combobox cell type offers drop-down lists to select pre-defined inputs. Before this cell type can be used, a list must be created in the combobox lists tab.

Parameters

Description

Combobox lists name

Name of the list file. This must already be defined in the Combobox lists tab.

Drop height

Display height

Drop width

Display width

Locked

Active: Locks the cell for editing in the editor and locks entries in the online report.

Display mode

Type of display
  • with text

Alphabetically sorted according to text
  • with code

Sorted according to code
  • with index

Sorted according to the order of input of the list entries

Data type

An input template is created in the report with the data type. Existing functions are removed from this cell. The user receives instructions on how data is to be entered into the cell.

Parameters

Description

Format string

Input of format, depending on data type.

Data type

  • Date/Time

Input of a date/time value.

For format string details, see the Data types for date and time chapter.
  • Float

Input of a float value.

For format string details, see the Numerical data types chapter.
  • Integer

Input of an integer value.

For format string details, see the Numerical data types chapter.
  • Logical

Input of a binary value.

For format string details, see the Logical data types chapter.

Configurable: Yes/no; right/wrong.
  • Text

Input of text.
  • Undefined

No data type defined.

Locked

Active: Locks the cell for editing in the editor and locks entries in the online report.

Graphics file

Graphics files must be created before they are selected in the project manager: File nodes -> Graphics -> [context menu] Add files.

Parameters | Description
Graphics file | Selection of graphics file. BMP, JPG, GIF, PNG and WMF formats are supported.
Original size | Active: The graphics are displayed in original size. Inactive: The graphics are adapted to the size of the cell. Default: inactive.
Locked | Active: Locks the cell for editing in the editor and locks entries in the online report.


Combobox lists

Combobox lists

In the Combobox lists tab, lists for the cell type Combobox are defined.

Parameters

Description

Combobox lists

Drop-down list to select existing lists.

New

Opens the dialog to create a new list.

Delete

Deletes selected list.

Contents of selected list

Shows contents of the selected lists

Current entry

Configuration of the entry.

Text

Input of the text, as it should appear in the list in the Runtime.

Code

Input of a number for sorting the lists.

0: no sorting according to code. There is a choice of sorting lists in Runtime alphabetically or in the order of input.

Minimum value: 0

Maximum value: 9999999999

Add

The new entry is inserted depending on the settings in Content of selected lists that were selected when the list was created.

  • Not: Entry is inserted at the end of the list.
  • According to text: Alphabetic sequence.
  • According to codes: Code number determines the sequence (increasing) in lists.

Insert

The new entry is added above the entry selected in the Content of selected lists:

Delete

Deletes the entry selected in Content of selected lists.

Create new list

Parameters | Description
List name | Name of list
Sort | Sorting criteria for display in Content of selected lists and in Runtime
not | Entry is inserted at the end of the list.
According to text (default) | Alphabetic sequence
By codes | Code number determines the sequence (increasing) in lists.


Format columns and cells

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Formatting -> Format columns and cells

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If an entire row or an entire column is highlighted, the additional commands Format column and/or Format row are available in the context menu.

As with Format cell, tabs are available for:

Alignment

Border

Font

Pattern

Note: These settings always only concern the column heading and/or the row heading. They have no effect on the other cells of a column or row. These must always be formatted using the Format cells dialog.

There is also a further Column or Row tab available in this dialog.


Column

Column

In the Column tab, properties that concern the whole column are defined:

Parameters

Description

Definition

Title

Defines column heading.

$C: Letters in a rising sequence of column numbers

E: The column automatically expands to the correct number of columns if an archive*, aml or cel is present in one of the cells. If other report functions are used, "E" may not be used. "E" can be used in a report several times.
Default: $C

Width in pixels

Width of the column in pixels

Options

Hide

Active: The column is hidden.
Inactive: The column is shown.

To show a column that has been hidden: Highlight the two neighboring columns and set the Hide property to inactive.

Attention: Functions that are in the hidden cells are not executed. To execute a function without it being shown: Set the row height or column width to 0.

Protection

Active: The cells in the column are protected from changes of formatting.
Inactive: The cells of this column can be formatted.


Row

Row

This dialog allows defining the properties of the entire selected row.

Parameters

Description

Definition

Title

Defines row heading.

$R: Numbers in reverse order of column number

E: The row automatically expands to the correct number of rows if an archive*, aml or cel is present in one of the cells. If other report functions are used, "E" may not be used. "E" can be used in a report several times.

Default: $R

Width in pixels

Height of the row in pixels.

Options

Hide

Active: The row is hidden.
Inactive: The row is displayed.

To show a row that has been hidden: Highlight the two neighboring rows and set the Hide property to inactive.

Attention: Functions that are in the hidden cells are not executed. To execute a function without it being shown: Set the row height or column width to 0.

Protection

Active: The cells in the row are protected from changes of formatting.
Inactive: The cells of this row can be formatted.


Set up archive filter

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Set up archive filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Should archive values be used in the report then these are to be defined before activating the report functions. To set up the archive filter:

  • Select Filter in the Format menu.

Parameters | Description
Parameters | List of variables selected from the archives. The numbers in front of the variables are used in the archive and protocol functions for classification.
New | Opens the dialog for selecting variables.
Change | Opens the dialog for selecting variables.
Delete | Deletes selected variable from the Parameters list.
Archives | Definition of a variable filter. Wildcards * and ? are permitted at the start of an expression.
Replace by | Enter the expression that is to replace the string that is being searched for
Replace | Carries out a search and replace. The result is displayed in a message box.

"New filter" or "Change filter"

Clicking on the New or Change buttons opens the dialog to select the variables:

Parameters

Description

Parameters

Display of the archives present. It is possible to select a complete archive or individual variables.

Each variable automatically receives an increasing number, which is addressed in the report functions for archive. A report can therefore also be used throughout projects.

Save

Provides selected archives/variables for the report.

Cancel

Leaves dialog without selection.

Each variable automatically receives an increasing number, which is addressed in the report functions for archive.


Report functions

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Report functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For the formation of the report, different formatting and calculation functions are available.

  • Processing functions:

    Defined access to selected zenon data (online and archive values, user, computer names etc.)

  • Report functions
    • formatting functions
    • calculating functions

The following groups of functions are available:

  • Database functions
  • Date and time functions
  • Logical functions
  • Archive and protocol functions
  • Statistical functions
  • Mathematical and trigonometric functions
  • Text functions
  • Recipegroup Manager functions
  • Other functions

The functions that are used most often can be configured using the function assistant.

Input

The input of the functions is done in the input row of the report.

If several cells are to receive the same input/function:

  1. Highlight the starting cell and the target cell
  2. Select the Fill command in the context menu and the desired direction (right or down)

    References to cell co-ordinates in the function are automatically adjusted.

Example for inputs

Parameters | Description
=archiv(1,value,downwards) | All values of the archive variable 1 are displayed downwards from the cell.
=sum(A4:D4) | The contents of cells A4 to D4 are added together. The cell must be formatted as a value.
=now() | Provides the current date/the current time.

info Information

Report functions can lead to error messages in the editor if not all data required to calculate the required data is properly available. To check to see that the configuration is correct, test the report in Runtime.

Direction

Options

Meaning

Right

Value is entered to the right (row).

There must be sufficient cells left free for expected entries from further report creation.

Attention: If an archivesp function is created with only one column, the value is entered downwards (in the column).

bottom

Value is entered downwards (column).

There must be sufficient cells left free for expected entries from further report creation.

Attention: If an archivesp function is created with only one row, the value is entered to the right (in the row).

info Info

The Report Generator module has to be licensed in the development environment and in the Runtime (standalone, server/standby and clients).

If the module is not licensed in the Runtime, the following functions are not available:

  • Save archives (for manual inputs)
  • and writing set values

Read access is possible.


Conventions

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Report functions -> Conventions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following conventions are valid:

Parameters | Description
Number: | (num); divider for decimal points depends on the settings in the operating system (1,0 or 1.0).
Range | (A1:A10)
String: | Character sequence is separated by a dual apostrophe ("), for example "ABC".
Radians: | The input of goniometric functions is done in radians.

Conversion of degrees into radians

degrees | arc measurement | radians
0,00 | 0 | 0
45,00 | p/4 | 0,78539816339744828
90,00 | p/2 | 1,5707963267948966
135,00 | 3p/4 | 2,3561944901923448
180,00 | p | 3,1415926535897931
225,00 | 5p/4 | 3,9269908169872414
270,00 | 3p/2 | 4,7123889803846897
315,00 | 7p/4 | 5,497787143782138
360,00 | 2p | 6,2831853071795862


Function wizard

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Report functions -> Function wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The function assistant supports the planning of report functions. It makes the most frequently used functions available. All other functions are manually entered into the input cell.

To open the function assistant:

  1. Click in the desired cell
  2. in the context menu, select the Functions command
  3. The assistant is opened
  4. The selection on the assistant is transferred to the input cell;
    any quotation marks that are open may need to be closed manually

Parameters | Description
Syntax | Result of the selection of function and parameter.
Function | Selection of the function.
Parameters | Selection of parameter that is available for the selected function.


Archive and logging functions

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Report functions -> Archive and logging functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Basics

All archive functions build on the basic archive(FILTERINDEX,PARAMETER,RICHTUNG) function.

The expansions are distinguishable by additional letters in function names.

Code | Meaning | Comment
r | read only | There is only read access to the archive. Changed values cannot be saved.
sp | Columns | Provides special formatting to define cells to be used.
min | Mathematics | Only has an effect on value and time.
ex | extended | provides special treatments.
w | write | Writing is possible.

Filter index

The filter index creates a distinction between archive filter numbers used in the report functions and variables from the archives.

Example Example

=archive(5,"value","downwards")

FILTERINDEX = 5

The entry present in the filter under no. 5 is used for the report function.

Parameters

Options | Possible value
value | [1-n]
status | [1-n]
time | [1-n]
number | [1]

Direction

Options | Meaning
Right | Value is entered to the right (row). There must be sufficient cells left free for expected entries from further report creation. Attention: If an archivesp function is created with only one column, the value is entered downwards (in the column).
bottom | Value is entered downwards (column). There must be sufficient cells left free for expected entries from further report creation. Attention: If an archivesp function is created with only one row, the value is entered to the right (in the row).

All archive functions can be created with the function assistant.

On outputting the status information, the settings from the project.ini file in the [STATUS] section or the settings from the internally defined allocation are used. If the status labeling was changed in project.ini, the changed name is given. (Tip: makes it possible to keep the project compatible with old status labels.)

In online operation, the query time is either defined in the function query or given in Runtime when a report file is opened.

Change archive entries

If permitted by user authorizations, archive values can also be changed in Runtime. Changes are either saved manually via the Save control element or automatically saved when saving a report file. The status of an amended entry is automatically set to manual value.

info Information

Changing string fields in the report: If a text consists only of numbers, spaces are removed by default when it is saved. Spaces that are desired must be displayed by ASCII character 255 (Alt+255).


Handling of archive entries

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Report functions -> Archive and logging functions -> Handling of archive entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Handling of archive entries

Archive entries can be displayed in a report and also be changed and saved in the archive again with sufficient user authorizations. There is a function assistant available to create the report functions.

Reading and writing archive entries

The following contents of an archive entry can be read for display in a report:

  • Value
  • Status
  • Time

The following archive entries can be changed and saved via calculations and new entries in the report:

  • Value
  • Status

Amended archive entries are saved in Runtime using the Save archive button. Saving changes can be stopped by:

  • Activating the Read only option in the zenon Screen switching function for the report screen
  • Activating the Locked option in the format dialog cell

If the value of an archive entry is changed, the status is set as MAN_VAL when it is saved in the archive.

Exception: If the status of the archive entry is changed, only the changed status is entered. If safety regulations such as those of the FDA are to be met, no status change may be permitted as a result of the report when configuring. Archive entries with MAN_VAL status are displayed in blue in a report.

Representation

Archive entries can be represented as archive value rows or as row-formatted archive value rows. The archive entries which lie in the time range of the opened log are represented rightwards or downwards from the cell in which the archive function is configured. If no archive entry is found then a - is output in the cell in which the archive function is defined.

Archive value rows

The read-in archive entries are shown as a row, one after the other, without blank spaces.

Row-formatted archive value rows

The read-in archive entries are shown with a defined number of:

  • Archive entries per row
  • Blank spaces between two entries
  • Empty rows between the rows.

.

Control cells

The parameters P1, P2 and P3 set out which cells of the report can be filled:

  • P1: Number
  • P2: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns
  • P3: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns

All entries of the time range of the report are shown in the report, going downwards or to the right from the cell in which the function was given, with the row format defined by the parameters P1-P3.

When selecting down, the following applies:

  • P1 = number of rows to be filled with values
  • P2 = empty rows between the values
  • P3 = empty columns

When selecting right, the following applies:

  • P1 = number of columns to be filled
  • P2 = empty rows between the values
  • P3 = empty rows between the values


Configuration with function assistant

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Report functions -> Archive and logging functions -> Configuration with function assistant

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Configuration with function assistant

You can configure report functions for the archive with the function assistant:

  1. Select the desired cell in the context menu with the Functions command.
  2. The assistant is opened.
  3. Select the desired archive function.

  4. The archive function is entered into the syntax.
  5. Clicking on archive opens the archive filter.

  6. Select the desired entry.

  7. The reference number of the entry (for example 4) is transferred to the string of the syntax.
  8. Select the desired parameter, for example value).

  9. The parameter is transferred into the string.
  10. Select the desired direction of the entry in the table:
    • below: The function fills the column
    • right: The function fills the row
      Attention: When using the archivesp function, corresponding columns/rows are envisaged! If for example, to the right is selected, but there is only one column available, then the values are entered downwards (in the only column available).

  11. The direction is transferred into the string.
  12. The brackets are closed.

  13. The function is transferred to the cell by clicking on OK.


archive

archive

Value, Status or time of the archive entry can be read. Changes are either saved manually via the Save control element or automatically saved when saving a report file. The status of an amended entry is automatically set to manual value.

Syntax: =archive(FILTERINDEX,PARAMETER,DIRECTION)

Transfer parameters | Valid range | Comment
FILTERINDEX |  | Corresponding entry from the archive filter.
PARAMETER | value, status, time, count | The selected parameter is read from the archive and displayed.
DIRECTION | bottom, right | Defines the direction in which filling is to take place, starting from the cell in which the function was created.

Example Example

In a report, all archive values from the archive variable 1 should be given downwards.

=archive(1,"value","downwards")


archiveex

archiveex

Syntax: =archiveex(FILTERINDEX,PARAMETER,DIRECTION,STATUS,SUBSTITUTETEXT,NN_TEXT,NN_SUBSTITUTEVALUE,CYCLEOFFSET)

Transfer parameters

Valid range

Comment

FILTERINDEX

[1-n]

Corresponding entry from the archive filter.

PARAMETER

value, status, time, count

The selected parameter is read from the archive and displayed

DIRECTION

bottom, right

Filling in the corresponding direction.

STATUS

SPONT, MAN_VAL, INVALID

Status of the values to be displayed.

ALTERNATETEXT

Text to be displayed if the status of the archive variables does not correspond to the STATUS.

ND_TEXT

Text for the "non-detectability limit"; not case-sensitive.

ND_ALTERNATEVALUE

Cell reference or entered value are possible. If the ALTERNATETEXT is entered into the cell and then the table is saved, the NN_ALTERNATEVALUE is written to the archive.

CYCLEOFFSET

Is only taken into account for filter type:

  • Time, day
  • Time, month
  • Time, year
  • Time, week
  • Time, 2week
  • Time, 15min.
  • Time, 30min.
  • Time, 60min.

Example Example

=archiveex(1,"time","downwards",SPONT,MAN_VAL,"-","NN",G2,-2)


archiveexr

archiveexr

Syntax: =archiveexr(FILTERINDEX,PARAMETER,DIRECTION,STATUS,SUBSTITUTETEXT,NN_TEXT,NN_SUBSTITUTEVALUE,CYCLEOFFSET)

Transfer parameters

Valid range

Comment

FILTERINDEX

[1-n]

Corresponding entry from the archive filter.

PARAMETER

value, status, time, count

The selected parameter is read from the archive and displayed

DIRECTION

bottom, right

Filling in the corresponding direction.

STATUS

SPONT,MAN_VAL, INVALID

Status of the values to be displayed.

ALTERNATETEXT

Text to be displayed, if the status of the archive variables does not correspond to the STATUS.

ND_TEXT

Text for the "non-detectability limit"; not case-sensitive.

ND_ALTERNATEVALUE

Cell reference or entered value are possible. If the ALTERNATETEXT is entered into the cell and then the table is saved, the NN_ALTERNATEVALUE is written to the archive.

CYCLEOFFSET

Is only taken into account for filter type:

  • Time, day
  • Time, month
  • Time, year
  • Time, week
  • Time, 2week
  • Time, 15min.
  • Time, 30min.
  • Time, 60min.


archivem

archivem

This function makes it possible to automatically change values or times of an archive entry by adding a constant to a value. Changes are either saved manually via the Save control element or automatically saved when saving a report file. The status of an amended entry is automatically set to manual value.

Syntax: =archivem(FILTERINDEX,PARAMETER,DIRECTION,MATH)

Transfer parameters

Valid range

Comment

FILTERINDEX

[1-n]

Corresponding entry from the archive filter.

PARAMETER

value, status, time, count

The selected parameter is read from the archive and displayed

DIRECTION

bottom, right

Filling in the corresponding direction.

MATH

  • Constant: signed
  • Decimal points: Point separator (.)
  • Correction of a time: In minutes

The value is read-in and shown in the report with the appropriate manipulation. The corrected values can be saved using Save archive.

attention Attention

Every time the archive is saved, the values are corrected by the defined constant!


archivemr

archivemr

This function makes it possible to automatically change values or times of an archive entry by adding a constant to a value.

Syntax: =archivemr(FILTERINDEX,PARAMETER,DIRECTION)

Transfer parameters

Valid range

Comment

FILTERINDEX

[1-n]

Corresponding entry from the archive filter.

PARAMETER

value, status, time, count

The selected parameter is read from the archive and displayed

DIRECTION

bottom, right

Filling in the corresponding direction.

MATH

  • Constant: signed
  • Decimal points: Point separator (.)
  • Correction of a time: In minutes

attention Attention

Changed values cannot be saved in the archive.

The value is read-in and shown in the report with the appropriate manipulation. Only time and value are possible as parameters.=archivemr(4,value,right,6.5)

All archive values read are increased by 6.50 for the display in the report.

=archivemr(4,time,right,-1)

The time stamps of the archive entries are corrected back by 1 minute for display in the report.

Possibility for use: For example, for a calculated monthly value that is only available after the end of the month (time stamp, for example. 00:01:00).


archivemsp

archivemsp

This function makes it possible to automatically change the value or times of an archive entry by adding a constant to the value as well as establishing the cells for the entries. The value is read-in and shown in the report with the appropriate manipulation. Changes are either saved manually via the Save control element or automatically saved when saving a report file. The status of an amended entry is automatically set to manual value.

Syntax: =archivemsp(FILTERINDEX,PARAMETER,DIRECTION)

Transfer parameters

Valid range

Comment

FILTERINDEX

[1-n]

Corresponding entry from the archive filter.

PARAMETER

value, status, time, count

The selected parameter is read from the archive and displayed

DIRECTION

bottom, right

Filling in the corresponding direction.

P1

Number of archive values in the first row.

P2

Empty cells between two value outputs.

P3

Empty cells until the next value row.

MATH

  • Signed constant, Constant: signed
  • Decimal points: Point separator (.)
  • Correction of a time: In minutes

attention Attention

The values are corrected by the defined constant with every Save archive.

Control cells

The parameters P1, P2 and P3 set out which cells of the report can be filled:

  • P1: Number
  • P2: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns
  • P3: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns

All entries of the time range of the report are shown in the report, going downwards or to the right from the cell in which the function was given, with the row format defined by the parameters P1-P3.

When selecting down, the following applies:

  • P1 = number of rows to be filled with values
  • P2 = empty rows between the values
  • P3 = empty columns

When selecting right, the following applies:

  • P1 = number of columns to be filled
  • P2 = empty rows between the values
  • P3 = empty rows between the values

Example Example

=archivemsp(4,"time","right",16,1,0,-0.5)

All time entries of the archive entry with the filter number 4 are retarded 30 seconds; 16 entries are envisaged with an empty column and no space.


archivemspr

archivemspr

This function makes it possible to automatically change values or times of an archive entry for display in a report by adding a constant to a value. The value is read-in and shown in the report with the appropriate manipulation. Only time and value are possible as parameters.

attention Attention

Changed values cannot be saved in the archive.

Syntax: =archivemspr(FILTERINDEX,PARAMETER,DIRECTION)

Transfer parameters

Valid range

Comment

FILTERINDEX

[1-n]

Corresponding entry from the archive filter.

PARAMETER

value, status, time, count

The selected parameter is read from the archive and displayed

DIRECTION

bottom, right

Filling in the corresponding direction.

P1

Number of archive values in the first row.

P2

Empty cells between two value outputs.

P3

Empty cells until the next value row.

MATH

  • Signed constant, Constant: signed
  • Decimal points: Point separator (.)
  • Correction of a time: In minutes

Control cells

The parameters P1, P2 and P3 set out which cells of the report can be filled:

  • P1: Number
  • P2: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns
  • P3: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns

All entries of the time range of the report are shown in the report, going downwards or to the right from the cell in which the function was given, with the row format defined by the parameters P1-P3.

When selecting down, the following applies:

  • P1 = number of rows to be filled with values
  • P2 = empty rows between the values
  • P3 = empty columns

When selecting right, the following applies:

  • P1 = number of columns to be filled
  • P2 = empty rows between the values
  • P3 = empty rows between the values

Example Example

=archivemsp(4,"time","right",16,1,0,-0.5)

All time entries of the archive entry with the filter number 4 are retarded 30 seconds; 16 entries are envisaged with 1 empty column and 0 spaces.


archiver

archiver

This function makes it possible to read the value, status and time of an archive entry. No changes are possible.

Syntax: =archiver(FILTERINDEX,PARAMETER,DIRECTION)

Transfer parameters | Valid range | Comment
FILTERINDEX | [1-n] | Corresponding entry from the archive filter.
PARAMETER | value, status, time, count | The selected parameter is read from the archive and displayed
DIRECTION | bottom, right | Filling in the corresponding direction.

This differs from the archive function in that no manual entries can be made in Runtime.

Area of application: These functions are employed, for example, if an entry in a report must be shown several times and may only be edited at one place. All entries of the time range of the report are shown in the report going downwards or to the right from the cell in which the function was created.


archivesp

archivesp

Value, Status or time of the archive entry can be read. Changes are either saved manually via the Save control element or automatically saved when saving a report file. The status of an amended entry is automatically set to manual value.

Syntax: =archivesp(FILTERINDEX,PARAMETER,DIRECTION,P1,P2,P3)

Transfer parameters | Valid range | Comment
FILTERINDEX | [ 1-n] | Corresponding entry from the archive filter.
PARAMETER | value, status, time, count | The selected parameter is read from the archive and displayed
DIRECTION | bottom, right | Filling in the corresponding direction
P1 |  | Number of archive values in the first row
P2 |  | Empty cells between two value outputs
P3 |  | Empty cells until the next value row

Control cells

The parameters P1, P2 and P3 set out which cells of the report can be filled:

  • P1: Number
  • P2: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns
  • P3: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns

All entries of the time range of the report are shown in the report, going downwards or to the right from the cell in which the function was given, with the row format defined by the parameters P1-P3.

When selecting down, the following applies:

  • P1 = number of rows to be filled with values
  • P2 = empty rows between the values
  • P3 = empty columns

When selecting right, the following applies:

  • P1 = number of columns to be filled
  • P2 = empty rows between the values
  • P3 = empty rows between the values

When outputting the status information, the settings from the project.ini file in the [STATUS] section or the settings from the internally defined allocation are used. If the status labeling was changed in project.ini, the changed name is given. (Tip: makes it possible to keep the project compatible with old status labels.)


archivespr

archivespr

Value, Status or time of the archive entry can be read.

Syntax: =archivespr(FILTERINDEX,PARAMETER,DIRECTION,P1,P2,P3)

Transfer parameters | Valid range | Comment
FILTERINDEX |  | Corresponding entry from the archive filter.
PARAMETER | value, status, time, count | The selected parameter is read from the archive and displayed
DIRECTION | bottom, right | Filling in the corresponding direction
P1 |  | Number of archive values in the first row
P2 |  | Empty cells between two value outputs
P3 |  | Empty cells until the next value row

Control cells

The parameters P1, P2 and P3 set out which cells of the report can be filled:

  • P1: Number
  • P2: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns
  • P3: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns

All entries of the time range of the report are shown in the report, going downwards or to the right from the cell in which the function was given, with the row format defined by the parameters P1-P3.

When selecting down, the following applies:

  • P1 = number of rows to be filled with values
  • P2 = empty rows between the values
  • P3 = empty columns

When selecting right, the following applies:

  • P1 = number of columns to be filled
  • P2 = empty rows between the values
  • P3 = empty rows between the values

Unlike the archivesp function, no manual presettings can be set on the cells. These functions are employed, for example, if an entry in a log must be shown several times and may only be edited at one place. All entries of the time range of the report are shown in the report going downwards or to the right from the cell in which the function was created

Example Example

=archivespr(1,"value","downwards",12,1,3)

All values of the archive entry with the filter number 1 are written downwards; 12 entries are envisaged with 1 empty row and 3 empty columns.


archivespw

archivespw

This function suppresses the displays of read-in archive entries and makes it possible to define the cells to be used. When saving, the archive entries are overwritten with values and statuses existing at other places (e.g. calculated).

Syntax: =archivespw(FILTERINDEX,PARAMETER,DIRECTION,P1,P2,P3,SZ_WERT,SZ_STATUS)

Transfer parameters | Valid range | Comment
FILTERINDEX | [1-n] | Corresponding entry from the archive filter.
PARAMETER | value, status, time, count | The selected parameter is read from the archive and displayed
DIRECTION | bottom, right | Filling in the corresponding direction.
P1 |  | Number of archive values in the first row.
P2 |  | Empty cells between two value outputs.
P3 |  | Empty cells until the next value row.
SZ_VALUE | Start-cell values | Cell from which calculated values start to appear.
SZ_STATUS | Start cell status | Defining a fixed status text (for example MAN_VAL), or stating the starting cell from which the status text should be taken.

Control cells

The parameters P1, P2 and P3 set out which cells of the report can be filled:

  • P1: Number
  • P2: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns
  • P3: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns

All entries of the time range of the report are shown in the report, going downwards or to the right from the cell in which the function was given, with the row format defined by the parameters P1-P3.

When selecting down, the following applies:

  • P1 = number of rows to be filled with values
  • P2 = empty rows between the values
  • P3 = empty columns

When selecting right, the following applies:

  • P1 = number of columns to be filled
  • P2 = empty rows between the values
  • P3 = empty rows between the values

Status texts

The configuring is not done via the input help but directly in the cell. For this, the following applies:

  • When entering the status texts, the defined short texts from the project.ini file or from the system-internal default configuration must be used. This applies regardless of whether the statues are input as fixed or read in from another cell.
  • Several statuses are separated by a comma (,).
  • The calculated values are updated regardless of whether the newly calculated value has changed in comparison to the read-in value.
  • The status is changed to manual value (MAN_VAL).


archivew

archivew

This function suppresses the display of the archive entries that have been read in for the report. When saving, the archive entries are overwritten with values and statuses existing at other places (e.g. calculated). This report function can be used as an example for reduction of monthly values to annual values as an archive value.

Syntax: =archivew(FILTERINDEX,PARAMETER,DIRECTION,P1,P2,P3,SZ_WERT,SZ_STATUS)

Transfer parameters | Valid range | Comment
FILTERINDEX | [1-n] | Corresponding entry from the archive filter.
PARAMETER | value, status, time, count | The selected parameter is read from the archive and displayed
DIRECTION | bottom, right | Filling in the corresponding direction.
SZ_VALUE | Start-cell values | Cell from which calculated values start to appear.
SZ_STATUS | Start cell status | Defining a fixed status text (for example MAN_VAL), or stating the starting cell from which the status text should be taken.

Control cells

The parameters P1, P2 and P3 set out which cells of the report can be filled:

  • P1: Number
  • P2: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns
  • P3: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns

All entries of the time range of the report are shown in the report, going downwards or to the right from the cell in which the function was given, with the row format defined by the parameters P1-P3.

When selecting down, the following applies:

  • P1 = number of rows to be filled with values
  • P2 = empty rows between the values
  • P3 = empty columns

When selecting right, the following applies:

  • P1 = number of columns to be filled
  • P2 = empty rows between the values
  • P3 = empty rows between the values

Status texts

The configuring is not done via the input help but directly in the cell. For this, the following applies:

  • When entering the status texts, the defined short texts from the project.ini file or from the system-internal default configuration must be used. This applies regardless of whether the statues are input as fixed or read in from another cell.
  • Several statuses are separated by a comma (,).
  • The calculated values are updated regardless of whether the newly calculated value has changed in comparison to the read-in value.
  • The status is changed to manual value (MAN_VAL).

Example Example

Reductions from monthly values to annual values as an archive value:

In a monthly report with daily values, the amount of days on which a limit x was exceeded is calculated. The sum of the limit violations is written into a cell of the report.

  • In an archive, a value was defined that gets one entry per month.
  • This entry is read in via archivew in the report.
  • =archivew(4,"value","downwards",B12,C12)
    • 4: Variable from archive filter
    • value: Parameter of variables that are to be displayed
    • bottom: Direction in which values are written
    • B12: Start cell, corresponds to the calculated cell
    • C12: Defines status text to be given
  • The sum is written to the archive value when the archive values are saved.


archivetime

archivetime

The archivetime function supplies, depending on the time filter that has been set, the time information for the start and end of the archive interrogation in online operation.

Syntax: =archivetime(FILTERINDEX,PARAMETER)

Transfer parameters | Valid range | Comment
FILTERINDEX | [1-n] | Corresponding entry from the archive filter.
PARAMETER | absolutetimefrom, absolutetimeto | Start time or end time of the archive request.


batch

batch

This function outputs the first lot names for the archive selected in the filter area of the report.

Syntax: =batch(FILTERINDEX)

Transfer parameters | Valid range | Comment
FILTERINDEX | [1-n] | Corresponding entry from the archive filter.

Example Example

=batch(1)

First lot name for the archive of the variables placed at position 1 of the archive filter.


batch no.

batch no.

This function displays different information about lots. The output is displayed as a list which is evaluated from top to bottom or from left to right. The following are displayed:

  • Name of the lots
  • Start time stamp
  • End point

Syntax: =batchnr(FILTERINDEX,PARAMETER,DIRECTION)

Transfer parameters | Valid range | Comment
FILTERINDEX | [1-n] | Corresponding entry from the archive filter.
PARAMETER | name, time from, time to | The selected parameter is read from the archive and displayed
DIRECTION | bottom, left | Filling in the corresponding direction.


wmz

wmz

The =wmz function provides the result of the heat counter archive. Counter overflow is not automatically checked.

Syntax: =wmz(FILTERINDEX,ACTIVATED,OVERFLOW,STARTVALUE,ENDVALUE,COUNTERINFO,ERRORCOUNTER)

Transfer parameters

Valid range

Comment

FILTERINDEX

[1-n]

Corresponding entry from the archive filter.

ACTIVATED

0 = deactivated
>1 = activated

The function is not executed with 0.

OVERFLOW

Value or cell reference

With an overflow of 1000, an error is recognized with an archive value of 1000 or higher.

STARTVALUE

Cell reference

First valid value from the archive.

ENDVALUE

Cell reference

Last valid value from the archive.

COUNTERINFO

Cell reference

Start of the counter change. Right direction from the cell reference.

Consists of four cell entries:

  • Date and time of the first value after a counter change
  • Value before the counter change
  • Value after the counter change
  • Empty cell

ERRORCOUNTER

Cell reference

States the number of errors found in a cell.

Causes of the error:

  • Value >= as defined in OVERFLOW
  • Values <= 0
  • With two consecutive archive values, the first value is greater than the subsequent value.

The sum of all valid values is written in the cell of the function.


wmzz

wmzz

The wmzz function (filter index, direction, P1, P2, P3, activated, overflow) provides the result of the heat counter archive in pairs, i.e. the difference between two consecutive archive values is given.

The output 0 is given if

  • The first value is >= the subsequent value.
  • One of the two values is >= OVERFLOW.
  • One of the two values is = 0.

Syntax: =wmzz(filter index, direction, P1, P2, P3, activated, overflow)

Transfer parameters | Valid range | Comment
FILTERINDEX | [1-n] | Corresponding entry from the archive filter.
DIRECTION | bottom, right | Filling in the corresponding direction.
P1 |  | Number of archive values in the first row
P2 |  | Empty cells between two value outputs
P3 |  | Empty cells until the next value row
ACTIVATED | 0 = deactivated 1 = activated | The function is not executed with 0.
OVERFLOW | Value or cell reference | With an overflow of 1000, an error is recognized with an archive value of 1000 or higher.

Control cells

The parameters P1, P2 and P3 set out which cells of the report can be filled:

  • P1: Number
  • P2: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns
  • P3: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns

All entries of the time range of the report are shown in the report, going downwards or to the right from the cell in which the function was given, with the row format defined by the parameters P1-P3.

When selecting down, the following applies:

  • P1 = number of rows to be filled with values
  • P2 = empty rows between the values
  • P3 = empty columns

When selecting right, the following applies:

  • P1 = number of columns to be filled
  • P2 = empty rows between the values
  • P3 = empty rows between the values


Database functions

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Report functions -> Database functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function enables data from Access or SQL databases to be read off.

Syntax: =sqldao (DATABASE,SQL-QUERY,PARA1,PARA2)

attention Attention

SQLDAO does not work with:

  • ntext
  • sql_variant
  • nvarchar(MAX)
  • nchar(MAX)

Transfer parameters | Comment
DATABASE | Name of the *.mdb database or the OLEDB provider.
SQL query | Standard 'SELECT', 'INSERT', 'UPDATE', 'DELETE' and 'EXECUTE' database queries can be used here. Two-integer parameters can be transferred with %d %d, and two-string parameters can be transferred with %s %s
PARA1 | parameters for SQL query
PARA2 | parameters for SQL query

Configuration with function assistant

You can use MS Access databases and databases with OLEDB provider. For this, use the following syntax:

Database

Syntax

MS Access database

=sqldao (database,SQL query,Para1,Para2)

Databases with OLEDB provider

Replace the reference to a database with an OLEDB initialization string. This string can be

  • entered manually or
  • created by clicking on the OLEDB provider button.

Databases with OLEDB provider

Clicking on the OLEDB provider button opens the dialog for data linking properties:

Here, you define the connection to the desired database:

  • OLEDB provider type
  • Data source
  • Registration information
  • etc.

After confirmation of the dialog by clicking on OK, the initialization string is generated and inserted into the Syntax field.

Syntax: =sqldao (Provider,SQL query,Para1,Para2)

attention Attention

The initialization string must always start with the character sequence Provider=. Note upper case and lower case letters, because the string is case sensitive.

Settings for MS Access and OLEDB

Transfer parameters

Description

Database

Name of the *.mdb database.
Storage directory: Project folder which is superordinate to the Runtime folder.
For example:
Runtime storage location: Subfolder of C:\Users\Public\Documents\zenon_Projects\Multi\TEST_PROJEKT

Save location *.mdb: saved directly in the folderC:\Users\Public\Documents\zenon_Projects\Multi\TEST_PROJEKT

The project folder is defined in the project properties.

Provider

OLEDB provider; the initialization string must always begin with Provider= (case sensitive).

SQL query

You can use standard 'select' database queries here.

Two-integer parameters can be transferred with %d %d and two-string parameters can be transferred with %s %s

Para1, Para2

Parameters for SQL query.


Example of access

Example of access

Examples for MS Access

Example database: Address.mdb

Name | First name | Street | City | Telephone | CanAddress
Müllner | Egon | Am Rheinberg 22 | 5020 Salzburg | 0662/329354 | 1
Roider | Jürgen | Mozartgasse 7 | 5020 Salzburg | 0662/329354 | 2
Leitner | Hans | Strubergasse 6 | 5020 Salzburg | 0662/329354 | 3
Müller | Peter | Blumengasse 6 | 80003 München | 089/234243 | 5
Weinberger | ww | Hafnergasse 5 | 7020 Klagenfurt | 0222/2222 | 6

Example 1

All entries from the Addresses table with Name field names are to be given.

Function: =sqldao(Adress.mdb,SELECT Adressen.name FROM Adressen ;,1,1)

Address.mdb | Access database (must be in the project database path)
SELECT | Tells the Microsoft Jet database module to return information from the database as a group of records
Address.name | table.field name
FROM | states the table of query in which to find the fields stated in the SELECT statement
Addresses | Table

Result:

Müllner

Roider

Leitner

Müller

Weinberger

Example 2

  • Lower limit: Contents of cell E1
  • Upper limit: Contents of cell E2
  • Field name for evaluation: CanAddress
  • Entries from the Addresses table with Name and First name field names are to be given.
  • The CanAddress condition must be higher than contents of cell E1 and lower than contents of cell E2.

Function: =sqldao(Adress.mdb,SELECT Address.name,Address.first name FROM Address WHERE (((Adressen.CanAdresse)>%d) AND ((Address.CanAdresse)<%d)) ;,E1,E2)

Address.mdb | Access database (must be in the project database path)
SELECT | Tells the Microsoft Jet database module to return information from the database as a group of records
Address.name | table.field name
, | SQL separator
Address.first name | table.field name
FROM | states the table of query in which to find the fields stated in the SELECT statement
Addresses | Table
WHERE | States which records of the table defined in the FROM section are affected by a SELECT, UPDATE or DELETE statement
(((Address.CanAddress)>%d) | Condition: table.field name
AND | Connection
((Address.CanAddress)<%d)) | Condition: table.field name
; | SQL statement end
E1, E2: | Cell references (integer)

Result for E1 = 1, E2 = 6

Roider | Jürgen | 2
Leitner | Hans | 3
Müller | Peter | 5

info Information

For further information on SQL statements refer to the Online-Help of Access.


SQL example

SQL example

Example for databases with OLEDB provider

=sqldao("Provider=SQLNCLI.1;Integrated Security=SSPI;Persist Security Info=False;Initial Catalog=<databasename>;Data Source=<database instance>;Use Procedure for Prepare=1;Auto Translate=True;Packet Size=4096;Workstation ID=<PCNAME>;Use Encryption for Data=False;Tag with column collation when possible=False","SELECT <tablename>.<columnname> FROM <tablename>;",0,0)

Transfer parameters | Comment
DATABASE | "Provider=SQLNCLI.1;Integrated Security=SSPI;Persist Security Info=False;Initial Catalog=<databasename>;Data Source=<database instance>;Use Procedure for Prepare=1;Auto Translate=True;Packet Size=4096;Workstation ID=<PCNAME>;Use Encryption for Data=False;Tag with column collation when possible=False"
SQL query | "SELECT <tablename>.<columnname> FROM <tablename>;"
PARA1 | 0
PARA2 | 0

Values for example

Database: "AdventureWorks"

Installation: AdventureWorksDB.msi

Source: http://msftdbprodsamples.codeplex.com/releases/view/4004

Computer name: "PC1"

Authentication: "Windows NT"

SQL server instance: "SQLEXPRESS"

SELECT

SELECT

=sqldao("Provider=SQLOLEDB.1;Integrated Security=SSPI;Persist Security Info=False;Initial Catalog=AdventureWorks;Data Source=.\SQLEXPRESS;Use Procedure for Prepare=1;Auto Translate=True;Packet Size=4096;Workstation ID=PC1;Use Encryption for Data=False;Tag with column collation when possible=False","SELECT TOP 100 [AddressID],[AddressLine1],[AddressLine2],[City],[StateProvinceID],[PostalCode] FROM [AdventureWorks].[Person].[Address] ORDER BY AddressID;",0,0)

SELECT with string parameter (cell H2)

=sqldao("Provider=SQLOLEDB.1;Integrated Security=SSPI;Persist Security Info=False;Initial Catalog=AdventureWorks;Data Source=.\SQLEXPRESS;Use Procedure for Prepare=1;Auto Translate=True;Packet Size=4096;Workstation ID=PC1;Use Encryption for Data=False;Tag with column collation when possible=False","SELECT TOP 100 [AddressID],[AddressLine1],[AddressLine2],[City],[StateProvinceID],[PostalCode] FROM [AdventureWorks].[Person].[Address] WHERE (City = N'%s') ORDER BY AddressID;",H2,0)

SELECT with numerical parameter (cell H2)

=sqldao("Provider=SQLOLEDB.1;Integrated Security=SSPI;Persist Security Info=False;Initial Catalog=AdventureWorks;Data Source=.\SQLEXPRESS;Use Procedure for Prepare=1;Auto Translate=True;Packet Size=4096;Workstation ID=PC1;Use Encryption for Data=False;Tag with column collation when possible=False","SELECT TOP 100 [AddressID],[AddressLine1],[AddressLine2],[City],[StateProvinceID],[PostalCode] FROM [AdventureWorks].[Person].[Address] WHERE (StateProvinceID = %d) ORDER BY AddressID;",H2,0)

INSERT

=sqldao("Provider=SQLOLEDB.1;Integrated Security=SSPI;Persist Security Info=False;Initial Catalog=AdventureWorks;Data Source=.\SQLEXPRESS;Use Procedure for Prepare=1;Auto Translate=True;Packet Size=4096;Workstation ID=PC1;Use Encryption for Data=False;Tag with column collation when possible=False","INSERT INTO [AdventureWorks].[Sales].[Currency] (CurrencyCode,Name,ModifiedDate) VALUES ('AAA','NewValue','');",0,0)

UPDATE

=sqldao("Provider=SQLOLEDB.1;Integrated Security=SSPI;Persist Security Info=False;Initial Catalog=AdventureWorks;Data Source=.\SQLEXPRESS;Use Procedure for Prepare=1;Auto Translate=True;Packet Size=4096;Workstation ID=PC1;Use Encryption for Data=False;Tag with column collation when possible=False","UPDATE Sales.Currency SET Name = 'ModifiedValue' WHERE CurrencyCode = 'AAA';",0,0)

DELETE

=sqldao("Provider=SQLOLEDB.1;Integrated Security=SSPI;Persist Security Info=False;Initial Catalog=AdventureWorks;Data Source=.\SQLEXPRESS;Use Procedure for Prepare=1;Auto Translate=True;Packet Size=4096;Workstation ID=PC1;Use Encryption for Data=False;Tag with column collation when possible=False","DELETE Sales.Currency WHERE CurrencyCode = 'AAA';",0,0)

EXECUTE

EXECUTE with numerical parameter (cell J2)

=sqldao("Provider=SQLOLEDB.1;Integrated Security=SSPI;Persist Security Info=False;Initial Catalog=AdventureWorks;Data Source=.\SQLEXPRESS;Use Procedure for Prepare=1;Auto Translate=True;Packet Size=4096;Workstation ID=PC1;Use Encryption for Data=False;Tag with column collation when possible=False","EXECUTE dbo.uspGetBillOfMaterials %d, '2001-05-08 12:35:29.123';",J2,0)


Date and time functions

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Report functions -> Date and time functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function gives date and time values.

You can find the formatting keys in the Data types for date and time chapter.


date

date

The date (iYear, iMonth, iDay) function date calculates the date from the numerical values for year (iYear), month (iMonth) and day (iDay).

Syntax: =date(iYear,iMonth,iDay)

Transfer parameters | Valid range | Comment
iYear | [0100-2200] |
iMonth | [1-12] | Values out of the valid range are set to the upper or lower limit
iDay | [1-(28,29,30,31)] | Values out of the valid range are set to the upper or lower limit

Result format: date

Standard format: dd/mm/yyyy

Example Example

=date(2010,5,12) is 12.05.2010

Cell A1=2010, cell A2=5, cell A3=12, cell A4=date(A1,A2,A3) is 12.05.2010


datevalue

datevalue

The datevalue(date_text) function calculates the date from the date text (date_text).

Syntax: =datevalue(date_text)


day

day

The day(date) function calculates the day from a date value.

Syntax: =day(date)

Result format: Integer

Example Example

=now() with format string hh:mm:ss dd/mm/yy is 12:46:24 05.06.10
Cell A2=day(A1) is 5


hour

hour

The hour(time) function calculates the hour from a time value.

Syntax: =hour(time)

Result format: Integer

Example Example

=now() with format string hh:mm:ss dd/mm/yy is 12:46:24 05.06.10
Cell A2=hour(A1) is 12


minute

minute

The minute(time) function calculates the minutes from a time value.

Syntax: =minute(time)

Result format: Integer

Example Example

=now() with format string hh:mm:ss dd/mm/yy is 12:46:24 05.06.10
cell A2=minute(A1) is 46


month

month

The month(date) function calculates the month from the date value.

Syntax: =month(date)

Result format: Integer

Example Example

=now() with format string hh:mm:ss dd/mm/yy is 12:46:24 05.06.10
Cell A2=month(A1) is 6


now

now

The now() function displays the current date and time.

The cell automatically gets the format string dd/mm/yy.

Syntax: =now()

Example Example

=now() is 05.06.2010
=now() with format string hh:mm:ss dd/mm/yy is 12:46:24 05.06.10


second

second

The second(time) function calculates the seconds from a time value.

Syntax: =second(time)

Result format: Integer

Example Example

=now() with format string hh:mm:ss dd/mm/yy is 12:46:24 05.06.10
Cell A2=second(A1) is 24


time

time

The time(iHour, iMinute, iSecond) function provides the time from the numerical values for hour (iHour), minute (iMinute) and seconds (iSecond).

The cell automatically gets the format string hh:mm:ss.

Syntax: =time(iHour,iMinute,iSecond)

Transfer parameters | Valid range | Comment
iHour | [0-23] | Values out of the valid range are set to the upper or lower limit
iMinute | [0-59] | Values out of the valid range are set to the upper or lower limit
iSecond | [0-59] | Values out of the valid range are set to the upper or lower limit

Result format: time

Example Example

=time(12,24,48) is 12:24:48

Cell A1=12, cell A2=24, cell A3=48 , cell A4=time(A1,A2,A3) is 12:24:48


today

today

The today() function displays the current date.

The cell automatically gets the format string dd/mm/yy.

Syntax: =today()

Example Example

=today() is 05.06.2010
=today() with format string hh:mm:ss dd/mm/yy is 12:00:00 AM 05.06.10


weekday

weekday

The weekday(date) function calculates the weekday from the date value.

Syntax: =weekday(date)

value | Weekday
1 | Sunday
2 | Monday
3 | Tuesday
4 | Wednesday
5 | Thursday
6 | Friday
7 | Saturday

Result format: Integer

Example Example

=now() with format string hh:mm:ss dd/mm/yy is 12:46:24 05.06.10
Cell A2=weekday(A1) is 3


year

year

The year(date) function calculates the year from the date value.

Syntax: =year(date)

Result format: Integer

Example Example

=now()with format string hh:mm:ss dd/mm/yy is 12:46:24 05.06.10
Cell A2=year(A1) is 2010


Logical functions

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Report functions -> Logical functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This section summarizes all logical functions of the report generator


and

and

The and(logical,logical) function provides the TRUE value if both arguments are TRUE.

The cell automatically gets the format string True;False.

Syntax: =and(logical,logical)

Example

Cell A1 | Cell A2 | Cell A3=and(A1,A2)
false | false | false
false | true | false
true | false | false
true | true | true


exact

exact

The exact(string1,string2) function returns the value TRUE, if both text strings are identical (case-sensitive).

Syntax: =exact(string1,string2)


false

false

The false() function returns the value FALSE.

The cell automatically gets the format string True;False.

Syntax: =false()

Example Example

The entry in cell A1=false() is False


if

if

The if(exprTest,valTrue,valFalse) function provides the content of valTrue (value or string), if the argument is exprTest TRUE, otherwise the content of valFalse. It is possible to nest if functions, for example by implementing and-links.

Syntax: =if(exprTest,valTrue,valFalse)


isblank

isblank

The isblank(ref) function has the logical value TRUE, if the reference cell is empty.

Syntax: =isblank(ref)

Example

ContentA1 | A1 | Result
Logical expression | No | False
Text | This is a text | False
empty |  | True
Number | 123.00 | False
Error | #ARG! | False


iserror

iserror

The iserror(ref) function has the logical value TRUE if the reference cell contains an error.

Syntax: =iserror(ref)

Example

ContentA1 | A1 | Result
Logical expression | No | False
Text | This is a text | False
empty |  | False
Number | 123.00 | False
Error | #ARG! | True


islogical

islogical

The islogical(ref) function has the logical value TRUE if the reference cell contains a logical value.

Syntax: =islogical(ref)

Example

ContentA1 | A1 | Result
Logical expression | No | True
Text | This is a text | False
empty |  | False
Number | 123.00 | False
Error | #ARG! | False


isnontext

isnontext

The isnontext(ref) function has the logical value TRUE if the reference cell does not contain a text string.

Syntax: =isnontext(ref)

Example

ContentA1 | A1 | Result
Logical expression | No | True
Text | This is a text | False
empty |  | True
Number | 123.00 | True
Error | #ARG! | False


isnumber

isnumber

The isnumber(ref) function has the logical value TRUE if the reference cell contains a numerical value.

Syntax: =isnumber(ref)

Example

ContentA1 | A1 | Result
Logical Link | No | False
Text | This is a text | False
empty |  | False
Number | 123.00 | True
Error | #ARG! | False


isref

isref

The isref(ref) function has the logical value TRUE if the reference cell contains a reference to another cell.

Syntax: =isref(ref)

Example

ContentA1 | A1 | Result
Logical expression | No | False
Text | This is a text | False
empty |  | False
Number | 123.00 | False
Error | #ARG! | False
Reference | =B1 | True


istext

istext

The istext(ref) function has the logical value TRUE if the reference cell contains a text string.

Syntax: =istext(ref)

Example

ContentA1 | A1 | Result
Logical link | No | False
Text | This is a text | True
empty |  | False
Number | 123.00 | False
Error | #ARG! | False


not

not

The not(logical) function returns the logical opposite of the argument.

The cell automatically gets the format string True;False.

Syntax: =not(logical)

Example

Cell A1 | Cell A2=not(A1)
false | True
true | False


or

or

The or(logical,logical) function provides the TRUE logical value if both arguments are TRUE.

The cell automatically gets the format string True;False.

Syntax: =or(logical,logical)

Example

Cell A1 | Cell A2 | Cell A3=or(A1,A2)
false | false | false
false | true | true
true | false | true
true | true | true


true

true

The true() function returns the logical value TRUE.

The cell automatically gets the format string True;False.

Syntax: =true()

Example Example

The entry in cell A1=true() is True


Mathematical and trigonometric functions

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Report functions -> Mathematical and trigonometric functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Common mathematical functions are available for reports. These can not only be planned using the function assistant, but can also be directly entered into the input row.


abs

abs

The abs (num) function returns the absolute value of a number as a result. The absolute value of a number is the value without sign.

Syntax: =abs(num)

num: is the real number, that is the basis for the absolute value

Example Example

=abs(2,2) is 2

=abs(-2,2) is 2


acos

acos

The acos (num) function provides the arc cosine of a number.

Syntax: =acos(num)


acosh

acosh

The acosh (num) function provides the inverse hyperbolic cosine of a number.

Syntax: =acosh(num)


asin

asin

The asin (num) function provides the arc cosine of a number.

Syntax: =asin(num)


asinh

asinh

The asinh (num)) function provides the inverted hyperbolic sine of a number.

Syntax: =asinh(num)


atan

atan

The atan (num) function provides the arc tangent of a number.

Syntax: =atan(num)


atanh

atanh

The atanh (num) function provides the inverted hyperbolic tangent of a number.

Syntax: =atanh(num)


atan2

atan2

The atan2 (x,y) function provides the arc tangent based on an x and y coordinate.

Syntax: =atan2(x, y)


ceil

ceil

The ceil (num) function returns the next higher whole-numbered value of the value, rounded up.

Syntax: =ceil(num)

Example Example

=ceil(2.2) is 3

=ceil(-2.2) is -3


column

column

The column (ref) function provides the column number of a connection (for example C3=2) in the value range of 0 to n.

Syntax: =column(ref)


columns

columns

The columns (range) function returns the numbers of columns in the stated range.

Syntax: =columns(range)


cos

cos

The cos(num) function provides the cosine of a number.

Syntax: =cos(num)

Example

=cos(Input)

 | Input | Result
degrees | radians() | cosine
0.00 | 0 | 1,000
45,00 | 0,78539816339744828 | 0,707
90,00 | 1,5707963267948966 | 0,000
135,00 | 2,3561944901923448 | -0,707
180,00 | 3,1415926535897931 | -1,000
225,00 | 3,9269908169872414 | -0,707
270,00 | 4,7123889803846897 | -0,000
315,00 | 5,497787143782138 | 0,707
360,00 | 6,2831853071795862 | 1,000


cosh

cosh

The cosh(num) function provides the hyperbolic cosine of a number.

Syntax: =cosh(num)


degree

degree

The degree(num) function converts radians to degrees.

Syntax: =degree(num)

Example

=degree(Input)

Input | Result
Radians() | Degree()
0 | 0
0,78539816339744828 | 45
1,5707963267948966 | 90
2,3561944901923448 | 135
3,1415926535897931 | 180
3,9269908169872414 | 225
4,7123889803846897 | 270
5,497787143782138 | 315
6,2831853071795862 | 360


even

even

The even(num) function returns the next higher even whole-numbered value. Negative values are rounded from 0 away.

Syntax: =even(num)

Example Example

=even(2.2) is 4

=even(-2.2) is -4


exp

exp

The exp(num) function potentializes the basis e with the number stated as argument.

Syntax: =exp(num)

Example Example

=exp(0) is 1

=exp(1) is 2.718282

=exp(10) is 22026.465795


fact

fact

The fact(int) function provides the factorial of a number.

Syntax: =fact(int)

Example Example

=fact(0) is 1 (1)

=fact(1) is 1 (1)

=fact(2) is 2 (1*2)

=fact(3) is 6 (1*2*3)

=fact(4) is 24 (1*2*3*4)

=fact(5) is 120 (1*2*3*4*5)


factdouble

factdouble

The factdouble(num) function provides the double factorial of a number. In doing so, only the product of each second number is formed.

Syntax: =factdouble(num)

Example Example

=factdouble(0) is 0 (0)

=factdouble(1) is 1 (1)

=factdouble(2) is 2 (2)

=factdouble(3) is 3 (1*3)

=factdouble(4) is 8 (2*4)

=factdouble(5) is 15 (1*3*5)


floor

floor

The floor(num) function returns the next lower whole-numbered value of the value, rounded down. Negative values are rounded in direction to 0.

Syntax: =floor(num)

Example Example

=floor(2.2) is 2

=floor(-2.2) is -2


int

int

The int(num) function returns the next lower whole-numbered value of the value, rounded down. Negative values are rounded from 0 away.

Syntax: =int(num)

Example Example

=int(2.2) is 2

=int(-2.2) is -3


ln

ln

The ln(num) function provides the natural logarithm of a number.

Syntax: =ln(num)

Example Example

=ln(1) is 0

=ln(2.718282) is 1

=ln(22026.465795) is 10


log10

log10

The log10(num) function calculates the logarithm of a value on the basis of 10.

Syntax: =log10(num)

Example Example

=log10(1) is 0

=log10(10) is 1

=log10(100) is 2

=log10(1000) is 3


mod

mod

The mod(num, divisor) function returns the rest of the division of a value (num) by the divisor (divisor).

Syntax: =mod(num,divisor)

Example Example

=mod(0.3) is 0

=mod(1.3) is 1

=mod(2.3) is 2

=mod(3.3) is 0

=mod(4.3) is 1


odd

odd

The function odd(num) returns the next higher odd whole-numbered value. Negative values are rounded from 0 away.

Syntax: =odd(num)

Example Example

=odd(2.2) is 3

=odd(-2,2) is -3


pi

pi

The pi() function pi returns the value for pi: 3.1415926535897931

Syntax: =pi()

Standard format: *0.######

Example Example

=pi() is with standard formatting 3.141593


product

product

The product (range) function calculates the product of the values in the stated area.

Syntax: =product(range)

Example

Cells A1 to A10: any numbers

Cell B1=product(A1:A10)

Cell/column | A | B
1 | 1 | 3628800
2 | 2 |
3 | 3 |
4 | 4 |
5 | 5 |
6 | 6 |
7 | 7 |
8 | 8 |
9 | 9 |
10 | 10 |

The result for the range A1 to A10 is 3628800.


quotient

quotient

The quotient(num,divisor) function returns the whole-numbered part of a division.

Syntax: =quotient(num,divisor)

Example Example

=quotient(0.3) is 0

=quotient(1.3) is 0

=quotient(2.3) is 0

=quotient(3.3) is 1

=quotient(4.3) is 1


radians

radians

The radians(num) function converts degrees into radians.

Syntax: =radians(num)

num: input in degrees

Example

=radians(Input)

Input | Result
0,00 | 0
45,00 | 0,78539816339744828
90,00 | 1,5707963267948966
135,00 | 2,3561944901923448
180,00 | 3,1415926535897931
225,00 | 3,9269908169872414
270,00 | 4,7123889803846897
315,00 | 5,497787143782138
360,00 | 6,2831853071795862


rand

rand

The rand() function returns a new random value between 0.000 and 1,000 every time the report is calculated.

Syntax: =rand()


randbetween

randbetween

The randbetween(min,max) function returns a new random value between min and max every time the report is calculated.

Syntax: =randbetween(min,max)


round

round

The round(num,digits) function rounds a value (num) to a stated number of decimals (digits).

Syntax: =round(num,digits)


row

row

The row(ref) function returns the row number of a reference (e.g. C3=3) in the value range from 0 to n.

Syntax: =row(ref)


rows

rows

The rows(range) function calculates the number of empty cells in the defined range.

Syntax: =rows(range)


sign

sign

The sign(num) function provides the value

  • 1, if the number (num) is positive
  • -1 if the number is negative
  • 0 if the number is 0

Syntax: =sign(num)

Example Example

=sign(2.2) is 1

=sign(-2.2) is -1

=sign(0.0) is 0


sin

sin

The sin(num) function provides the sine of a number.

Syntax: =sin(num)

num: input in radians

Example

=sin(Input)

 | Input | Result
degrees | radians() | sine
0.00 | 0 | 0,000
45,00 | 0,78539816339744828 | 0,707
90,00 | 1,5707963267948966 | 1,000
135,00 | 2,3561944901923448 | 0,707
180,00 | 3,1415926535897931 | 0,000
225,00 | 3,9269908169872414 | -0,707
270,00 | 4,7123889803846897 | -1,000
315,00 | 5,497787143782138 | -0,707
360,00 | 6,2831853071795862 | -0,000


sinh

sinh

The sinh(num) function provides the hyperbolic sine of a number.

Syntax: =sinh(num)


sqrt

sqrt

The sqrt(num) function provides the square root of a number.

Syntax: =sqrt(num)

Example Example

=sqrt(1) is 1

=sqrt(2) is 1.414214

=sqrt(3) is 1.732051

=sqrt(4) is 2


sqrtpi

sqrtpi

The sqrtpi(num) function provides the square root of a pi value.

Syntax: =sqrtpi()

Example Example

=sqrtpi(1) is 3.141593 = 1*pi

=sqrtpi(2) is 4.442883 = sqrt(2)*pi

=sqrtpi(3) is 5.441398 = sqrt(3)*pi

=sqrtpi(4) is 6.283185 = sqrt(4)*pi


tan

tan

The tan(num) function provides the tangent of a number.

Syntax: =tan(num)


tanh

tanh

The tanh(num) function provides the hyperbolic tangent of a number.

Syntax: =tanh(num)


trunc

trunc

The trunc(num) function returns the next lower whole-numbered value of the value, rounded down. Negative values are rounded in direction to 0.

Syntax: =trunc(num)

Example Example

=trunc(2.2) is 2

=trunc(-2.2) is -2


Recipegroup Manager functions

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Report functions -> Recipegroup Manager functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Variables from other loaded projects that are used in recipes can also be displayed with the report functions for the recipe group manager. These functions can only be used with screens of the recipegroup manager type.

The function assistant is available for configuration.


recipea

recipea

The =recipeaInhalt) function displays general data of a recipe of the recipe group manager.

Syntax: =recipea(Inhalt)

Contents | Description
muser | User who last edited the recipe.
mzeit | Time of the last change.
rez | Name of the recipe.
rezg | Name of the recipe group to which the recipe belongs.
reznum | Number of the recipe
text1 to text 8 | User comments 1 to 8 of the recipe.
text2 | User comment 2 for the recipe.
version | Version number of the recipe.
status | Status of the recipe as text. For example: 1 - sample recipe

Example Example

=recipea(recnum)


recipef

recipef

The =recipef(content,variable) function displays variable-orientated data of a recipe of the recipe group manager. These data can freely be positioned in the report.

Syntax: =recipef(content,variable)

Contents | Description
name | Name of the variable.
identification | Identification of the variable.
type | Source type.
unit | Technical unit of measurement the variables.
value | Value for the variable in the recipe.
symbols | Display of limit value texts from the reaction matrix or limit value as text.
min | Minimum of the permitted value range for the variable in this recipe.
max | Maximum of the permitted value range for the variable in this recipe.
actual_value | If the defined variable does not exist in the selected recipe, the cell is marked with -.
Interlocking | Display of Interlocking. Because the names are not available in Runtime, only the IDs of the interlockings selected in the recipe group manager are displayed.
visibility | Shows visibility of the variables.
Graphical recipe variable | Shows the name of the linked Graphical recipe variable. Only display in the Runtime. Configuration in the Editor.
filter | Filter text that was selected in the RGM.
Keyboard | Shows linked keyboard keyboard.
Set value limit | Yes: Takes over set value limit to the variable. Only display in the Runtime. Configuration in the Editor.

Example Example

=recipef("value","temperature")


recipew

recipew

The =recipew(content,direction) function displays variable-orientated data of a recipe of the recipe group manager in table form.

Syntax: =recipew(content,direction)

Contents | Description
name | Name of the variable.
identification | Identification of the variable.
type | Source type.
unit | Technical unit of measurement the variables.
value | Value for the variable in the recipe.
symbols | Display of values as text.
min | Minimum of the permitted value range for the variable in this recipe.
max | Maximum of the permitted value range for the variable in this recipe.
actual_value | If the defined variable does not exist in the selected recipe, the cell is marked with -.
Interlocking | Display of Interlocking. Because the names are not available in Runtime, only the IDs of the interlockings selected in the recipe group manager are displayed.
visibility | Shows visibility of the variables.
Graphical recipe variable | Shows the name of the linked Graphical recipe variable. Only display in the Runtime. Configuration in the Editor.
filter | Filter text that was selected in the RGM.
Keyboard | Shows linked keyboard keyboard.
Set value limit | Yes: Takes over set value limit to the variable. Only display in the Runtime. Configuration in the Editor.

Example Example

=recipew(name,bottom)


Statistical functions

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Report functions -> Statistical functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Common statistical functions are available for reports. These can not only be planned using the function assistant, but can also be directly entered into the input row.


avg

avg

The avg (range) function calculates the average of the values within the range.

Syntax: =avg(range)

Example

Cell A4= avg(A1:A3)

Row/column | A
1 | 1
2 | 3
3 | 5
4 | 3

The average of the cells A1 to A3 is 3


count

count

The count (range) function returns the number of numerical values in the stated range.

Syntax: =count(range)

Example

Cell A5= count(A1:A4)

Row/column | A
1 | 1
2 | Text
3 |
4 | 3
5 | 2

The number of numerical values in the cells A1 to A4 is 2.


counta

counta

The counta (range) function calculates the number of non-empty cells in a given range.

Syntax: =counta(range)

Example

Cell A5=counta(A1:A4)

Row/column | A
1 | 1
2 | text
3 |
4 | 3
5 | 3

The number of non-empty cells in the rangeA1 to A4 is 3.


countblank

countblank

The countblank (range) function calculates the number of empty cells in a given range.

Syntax: =countblank(range)

Example

CellA5 = countblank(A1:A4)

Row/column | A
1 | 1
2 | Text
3 |
4 | 3
5 | 1

The number of empty cells in the range A1 to A4 is 1.


max

max

The max (range) function calculates the highest value in a range.

Syntax: =max(range)

Example

Cells A1 to A10: any numbers

Cell B1=max(A1:A10)

Row/column | A | B
1 | 1 | 10
2 | 2 |
3 | 3 |
4 | 4 |
5 | 5 |
6 | 6 |
7 | 7 |
8 | 8 |
9 | 9 |
10 | 10 |

The highest value in range A1 to A10 is in cell A10 and is 10.


min

min

The min (range) function calculates the lowest value in a range.

Syntax: =min(range)

Example

Cells A1 to A10: any numbers

Cell B1=min(A1:A10)

Row/column | A | B
1 | 1 | 1
2 | 2 |
3 | 3 |
4 | 4 |
5 | 5 |
6 | 6 |
7 | 7 |
8 | 8 |
9 | 9 |
10 | 10 |

The lowest value in range A1 to A10 is in cell A1 and is 1.


percentile

percentile

The percentile (range,num) function returns as result a threshold value, from which the values are accepted.

Syntax: =percentile(range,num)

Range: Is a matrix or a data range that describes the relative position of the data.

Num: Integer from 0-100

Example

Cells A1 to A10: any numbers

Cell B1=percentile(A1:A10,90)

Row/column | A | B
1 | 1 | 9,1
2 | 2 |
3 | 3 |
4 | 4 |
5 | 5 |
6 | 6 |
7 | 7 |
8 | 8 |
9 | 9 |
10 | 10 |

The threshold value for the range A1 to A10 is 9.1.


stdev

stdev

The stdev (range) function returns an estimation of the standard deviation based on a random sample of the values in the defined area.

Formula:

Syntax: =stdev(range)

Example

Cells A1 to A10: any numbers

Cell A11=stdev(A1:A10)

Row/column | A
1 | 745,00
2 | 730,00
3 | 732,00
4 | 768,00
5 | 769,00
6 | 747,00
7 | 718,00
8 | 723,00
9 | 766,00
10 | 739,00
11 | 18,785633

The standard deviation for the area A1 to A10 is estimated using on the sample on 18,85633 as a basis.


stdevp

stdevp

The stdevp (range) function returns an estimation of the standard deviation based on the total of the values in the defined area.

Formula:

Syntax: =stdevp(range)

Example

Cells A1 to A10: any numbers

Cell A11= stdevp(A1:A10)

Row/column | A
1 | 745,00
2 | 730,00
3 | 732,00
4 | 768,00
5 | 769,00
6 | 747,00
7 | 718,00
8 | 723,00
9 | 766,00
10 | 739,00
11 | 17,821616

The standard deviation for the range A1 to A10 is estimated at 17.821616.


sum

sum

The sum (range) function calculates the sum of the values in the defined area.

Syntax: =sum(range)

Example

Cells A1 to A10: any numbers

Cell B1=sum(A1:A10)

Row/column | A | B
1 | 1 | 55
2 | 2 |
3 | 3 |
4 | 4 |
5 | 5 |
6 | 6 |
7 | 7 |
8 | 8 |
9 | 9 |
10 | 10 |

The sum of all values in the A1 to A10 range is 55.


sumsq

sumsq

The sumsq (range) function calculates the sum of the squares of the values within a range.

Syntax: =sumsq(range)

Example

Cells A1 to A10: any numbers

Cell A11=sumsq(A1:A10)

Row/column | A | B
1 | 1 | 1
2 | 2 | 4
3 | 3 | 9
4 | 4 | 16
5 | 5 | 25
6 | 6 | 36
7 | 7 | 49
8 | 8 | 56
9 | 9 | 81
10 | 10 | 100
11 | 385 | 385

Supervision

Cell B1 to B10: Squares of A1 to A10

Cell B11= sum(B1:B10)


var

var

The var (range) function returns an estimation of the variance based on a random sample of the values in the defined area.

Formula:

Syntax: =var(range)

Example

Cells A1 to A10: any numbers

Cell A11=var(A1:A10)

Row/column | A
1 | 745,00
2 | 730,00
3 | 732,00
4 | 768,00
5 | 769,00
6 | 747,00
7 | 718,00
8 | 723,00
9 | 766,00
10 | 739,00
11 | 352,9

The variance for the area A1 to A10 is estimated using on the sample on 352.9 as a basis.


varp

varp

The varp (range) function returns an estimation of the variation based on the total of the values in the defined area.

Formula:

Syntax: =varp(range)

Example

Cells A1 to A10: any numbers

Cell A11=varp(A1:A10)

Row/column | A
1 | 745,00
2 | 730,00
3 | 732,00
4 | 768,00
5 | 769,00
6 | 747,00
7 | 718,00
8 | 723,00
9 | 766,00
10 | 739,00
11 | 317,61

The variance for the range A1 to A10 is estimated at 317.61.


Text functions

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Report functions -> Text functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Different text functions are available for reports. These can not only be planned using the function assistant, but can also be directly entered into the input row. Exception: paint


char

char

The function char(code) returns the ASCII character that is defined under code.

Syntax: =char(code)

code: number between 1 and 255.

Example Example

=char(88) is X

If the cell A1 contains the value 35, the =char (A1) function gives the character # as a result.

To determine the ASCII code for a character, use the code function.


clean

clean

The clean(string) function deletes all control characters from a text character chain.

Syntax: =clean(string)


code

code

The code(string) function provides the ASCII code for the first character in a text character chain.

If the string is in the brackets of the text to be coded, it is put in quotation marks. If it refers to another row, this is entered.

Syntax: =code(string)

Example Example

=code("z") is 122.

Cell A1 contains the text zoom:

=code(A1) is 122.

To determine the character corresponding to an ASCII code, use the char function.

attention Attention

The code(string) function only provides the ASCII code for the first character in a text string.


find

find

The find(keystring,string,start) function provides the position of a character sequence (keystring) within a text string (string). The position is found in the text string starting at the start character (start) with case-sensitivity.

Syntax: =find(keystring,string,start)

Example Example

Cell A1: cd

Cell A2: ABCDabcd

Cell A3: 1

Cell A4=find(A1,A2,A3): Result =7


fixed

fixed

The fixed(num,decimals) function formats a number and converts it into a defined character string.

Syntax: =fixed(num,decimals)

  • num: Numerical value or cell reference
  • decimals: Number of decimals

Example Example

Cell A1 = 12345.672

=fixed(A1,2) is 12345.67

=fixed(A1,1) is 12345,6

The separator and the display also depend on the regional settings and formatting settings in cell.

Note: The fixed() function cannot be combined with a format string such as the stating of units.

Difference to zenon 5.50 and earlier versions

Thefixed() function also has the argument no_seps in versions up to 5.50. The argument is optional and controls the display of thousand separators.

Syntax: =fixed(num,decimals,no_seps)

  • no-seps:
    • 0: A separator is inserted
    • 1: A separator is left out

Figures are generally shown without thousand separators in later versions.


left

left

The left(string,num) function provides the number of characters from a character string defined in (num), starting with the first character.

Syntax: =left(string,num)

  • string: Character string in quotation marks or reference to a cell with a character string
  • num: Number of characters that are to be read off, starting with the first

Example Example

Cell A1 = abcdefgh

=left(A1,3) is abc

=left(A1,5) is abcde

To read off characters beginning with the last character of a character string, use the right function.


len

len

The len(string) function provides the number of characters in a character string.

Syntax: =len(string)

Example Example

Cell A1 = abc
=len(A1) is 3

Cell A1 = abcdefgh
=len(A1) is 8


lower

lower

The lower(string) function replaces all upper case letters of a text character string with lower case letters.

Syntax: =lower(string)

Example Example

Cell A1 = AbCdEf
=lower(A1) is abcdef

To replace lower case letters with upper case letters, use the upper function.


mid

mid

The mid(string,numStart,numLen) function extracted

  • From the defined character string string
  • A new character string
  • With a number of characters defined by the numLen argument
  • From the start position defined by numStart.

Syntax: =mid(string,numStart,numLen)

Example Example

Cell A1 = abcdefgh
=mid(A1,2,4) is bcde


paint

paint

The =paint(referenz) function continues the character string given in the referenced cell, if there is not enough space for this in the referenced cell. Thus long character strings can be well displayed by being divided into several cells.

Syntax: =paint(referenz)

Example Example

Cell A1 contains the characters: abcdefghijklmn

In cell A1, the following is displayed due to the width of the cell: abcdefg

=paint(A1) in cell A2 leads to this display:

A1: abcdefg

A2: hijklmn

This text function can be configured with the function assistant.


proper

proper

The proper(string) function transforms the first character of a word into upper case letters and all subsequent characters into lower case letters. The start of the word is the first alphabetical character of a character string. If the character string contains several non-alphabetic characters, a new word is started after each non-alphabetic character.

Syntax: = proper (string)

Example Example

Cell A1 = AbCdEf
=proper(A1) is Abcdef

Cell A1 = aBcDeF
=proper(A1) is Abcdef

Cell A1 = 1aBcD2eF
=proper(A1) is 1Abcd2Ef


replace

replace

The function replace(string,numStart,numLen,stringNew)

  • replaces, in the text character string , string
  • from the start position defined bynumStart,
  • a number of characters defined by numLen
  • with characters from the new text character string, stringNew

Syntax: =replace(string,numStart,numLen,stringNew)

Example Example

Cell A1 = abcdefgh
Zelle A2 = xyz
=replace(A1,3,2,A2) is abxyzefgh

In this example, in the string abcdefgh, the characters cd (3rd position in the string, 2 characters) are replaced with xyz.


rept

rept

The rept(string,num) function repeats the character string string for as many times as is defined in num.

Syntax: =rept(string,num)

Example Example

Cell A1 = abc
Cell A2 = 3
=rept(A1,A2) is abcabcabc


right

right

The right(string,num) function provides the number of characters from a character string defined in (num), starting with the last character.

Syntax: =right(string,num)

  • string: Character string in quotation marks or reference to a cell with a character string
  • num: Number of characters that are to be read off, starting with the last

Example Example

Cell A1 = abcdefgh

=right(A1,3) is fgh

=right(A1,5) is defgh

To read off characters beginning with the first character of a character string, use the left function.


search

search

The search(keystring,string,start) function provides

  • the position of a search text keystring
  • within a character string string
  • from the start character position start

Syntax: =search(string,keystring,start)

Example

Cell A4=search(A1,A2,A3)

Cell/column | A
1 | abcdeABCDEabcde
2 | cd
3 | 1
4 | 3

The function in cell A4 finds the text being searched for cd in cell A1 at position 3.


substitute

substitute

The function substitute(string,oldstring,newstring,instance)

  • replaces, in the character string , string
  • an oldstring character sequence
  • with a new character sequence newstring
  • whereby instance determines the position of
    • instance=0 replaces all character strings found

The function is case sensitive.

Syntax: =substitute(string, oldstring, newstring, instance)

Example Example

Cell A1 = abcdef ABCDEF abcdef ABCDEF abcdef ABCDEF
Cell A2 = XYZ

Example 1:

=substitute(A1,"ABCDEF",A2,0) is abcdef XYZ abcdef XYZ abcdef XYZ

In this example, the whole character sequence ABCDEF in the entire string abcdef ABCDEF abcdef ABCDEF abcdef ABCDEF is replaced by XYZ

Example 2:

=substitute(A1,"abcdef",A2,2) is abcdef ABCDEF XYZ ABCDEF abcdef ABCDEF

In this example, the second character sequence abcdef found in the string abcdef ABCDEF abcdef ABCDEF abcdef ABCDEF is replaced by XYZ.

Note: Character string within the function are put into quotation marks ("character string").


trim

trim

The trim(string) function allows a maximum of one space between two characters. All other spaces are removed.

Syntax: =trim(string)

Example Example

Cell A1 = Too many spaces are reduced to one.
=trim (A1) is: Too many spaces are reduced to one.


upper

upper

The upper(string) function replaces all lower case letters of a text character string with upper case letters.

Syntax: =upper(string)

Example Example

Cell A1 = AbCdEf
=upper(A1) is ABCDEF

To replace upper case letters with lower case letters, use the lower function.


Other functions

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Report functions -> Other functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Other functions group together report functions that cannot be allocated to a sub-group.

The function assistant is available for configuration.


Alarm

Alarm

This function shows information from the alarm administration as a formatted list in a report form.

Syntax: =alarm(FILTER,PARAMETER,DIRECTION)

Transfer parameters

Valid range

Comment

FILTER

Configuration via AML filter.

PARAMETER
  • name
  • identification
  • text
  • status
  • value
  • time received
  • time sent
  • time acknowledged
  • time reactivated
  • status reactivated
  • number reactivated
  • active
  • number_h
  • number_t
  • number_m
  • user
  • computer
  • note
  • class
  • group
  • project
  • number

Selection of the filter column to be read.

Note:

  • project: Only present in the AML filter with multi-user projects
  • number: only for one project
  • number_h: only for one project
  • number_t: only for one project
  • number_m: only for one project

DIRECTION
  • bottom
  • Left

Filling in the corresponding direction.

The time filter results from the definition in Screen switching filter report.

Direction

Options | Meaning
Right | Value is entered to the right (row). There must be sufficient cells left free for expected entries from further report creation. Attention: If an archivesp function is created with only one column, the value is entered downwards (in the column).
bottom | Value is entered downwards (column). There must be sufficient cells left free for expected entries from further report creation. Attention: If an archivesp function is created with only one row, the value is entered to the right (in the row).
info Information
To ensure that the function can dynamically insert lines or columns without overwriting other lines/columns, the labeling of the corresponding row or column must be set to E (for "Expand").


cel

cel

This function shows information from the chronological event list (CEL) as a formatted list in a report. Configuration with the function assistant works along the lines of configuration of the aml function.

Syntax: =cel(FILTER,PARAMETER,DIRECTION)

Transfer parameters

Valid range

Comment

FILTER

Configuration via CEL filter.

PARAMETER
  • name
  • identification
  • text
  • status
  • value
  • time received
  • user
  • computer
  • note
  • class
  • group
  • project
  • number

Selection of the filter column to be read.

Note:

  • project: Only present in the CEL filter with multi-user projects
  • number: only for one project

DIRECTION

bottom, left

Filling in the corresponding direction.

The time filter results from the definition in Screen switching filter report.

Direction

Options | Meaning
Right | Value is entered to the right (row). There must be sufficient cells left free for expected entries from further report creation. Attention: If an archivesp function is created with only one column, the value is entered downwards (in the column).
bottom | Value is entered downwards (column). There must be sufficient cells left free for expected entries from further report creation. Attention: If an archivesp function is created with only one row, the value is entered to the right (in the row).
info Information
To ensure that the function can dynamically insert lines or columns without overwriting other lines/columns, the labeling of the corresponding row or column must be set to E (for "Expand").


Configuring the alarm and CEL with the function assistant

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Report functions -> Other functions -> Configuring the alarm and CEL with the function assistant

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Configuring the alarm and CEL with the function assistant

You can configure functions for AML and CEL with the function assistant. This example is carried out with aml and works along the lines of cel:

  1. Select the desired cell in the context menu with the Report functions command.
  2. The assistant is opened.
  3. Select Alarm.

  4. The alarm report function is entered into the syntax.
  5. Clicking on Variable opens the Filter for AML. (cel: Filter for CEL.)
  6. Configure the filter.
  7. Select the desired parameter by double clicking, for example identification).

  8. The parameter is transferred into the string.
  9. Select the desired direction of the entry in the table by double clicking:
    • below: The function fills the column
    • right: The function fills the row

  10. The direction is transferred into the string.
  11. The brackets are closed.
  12. The function is transferred to the cell by clicking on OK.


compare

compare

The compare(range,"condition") function compares values in the stated range with a condition and returns the number of hits.

Syntax: =compare(range,"condition")

Range cells that are used for the comparison

Condition: Content for which the examination is relevant (information always in quotation marks)

Example Example

=compare(A1:A10,6>"=5")

Compares cells 1 to 10 in column A and gives the number of values that are greater than or equal to 5.


comparesp

comparesp

The comparesp(start cell,direction,P1,P2,P3,P4,"condition") function compares values in a given area in a special format with a condition and returns the number of the hits from a reference area.

Syntax: =comparesp(start cell,direction,P1,P2,P3,P4,"condition")

Parameters | Description
Start cell | Cell with the first value.
Direction | "right" or "bottom"
P1 | Number of values in the first row.
P2 | Empty cells between two value outputs.
P3 | Empty cells until the next value row.
P4 | Maximum number of values to compare.
Condition | condition. Information always in quotation marks.

Control cells

The parameters P1, P2 and P3 set out which cells of the report can be filled:

  • P1: Number
  • P2: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns
  • P3: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns

All entries of the time range of the report are shown in the report, going downwards or to the right from the cell in which the function was given, with the row format defined by the parameters P1-P3.

When selecting down, the following applies:

  • P1 = number of rows to be filled with values
  • P2 = empty rows between the values
  • P3 = empty columns

When selecting right, the following applies:

  • P1 = number of columns to be filled
  • P2 = empty rows between the values
  • P3 = empty rows between the values

Example Example

=comparesp(A1,downwards,12,0,0,12,"=5")


comparespsum

comparespsum

The comparespsum(start cell,direction,P1,P2,P3,P4,"condition") function compares values in a given area in a special format with a condition and returns the sum of the hits from a reference area.

Syntax: =comparespsum(start cell,direction,P1,P2,P3,P4,"condition")

Parameters | Description
Start cell | Cell with the first value.
Direction | "right" or "bottom"
P1 | Number of values in the first row.
P2 | Empty cells between two value outputs.
P3 | Empty cells until the next value row.
P4 | Maximum number of values to compare.
Condition | condition. Information always in quotation marks.

Control cells

The parameters P1, P2 and P3 set out which cells of the report can be filled:

  • P1: Number
  • P2: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns
  • P3: Empty cells between two value outputs, depending on DIRECTION (down, right) either empty rows or empty columns

All entries of the time range of the report are shown in the report, going downwards or to the right from the cell in which the function was given, with the row format defined by the parameters P1-P3.

When selecting down, the following applies:

  • P1 = number of rows to be filled with values
  • P2 = empty rows between the values
  • P3 = empty columns

When selecting right, the following applies:

  • P1 = number of columns to be filled
  • P2 = empty rows between the values
  • P3 = empty rows between the values

Example Example

=comparespsum(A1,downwards,12,0,0,12,"=5")


comparesum

comparesum

The comparesum( comparison range,sum reference,"condition") function compares values in the stated area with a condition and returns the sum of the hits from a reference area.

Syntax: =comparesum(comparison range,sum reference,"condition")

  • Range cells that are used for the comparison
  • Sum reference: value that is given if the condition is met

Condition: Content for which the examination is relevant (information always in quotation marks)

Example Example

=comparesum(B2:B11,A2,"=5")

Cells B2 to B11 are checked for =5. In the lines where this is true, the values of the cell are added to column A.


computername

computername

The computername() function provides the computer names of the computers on which the report is executed.

Syntax: =computername()

No transfer parameters are needed.


maxsp

maxsp

The maxsp function determines the highest value in a range und displays it. The format can be a color or underlined.

Syntax: =maxsp(range,num)

Transfer parameters | Valid range | Comment
range | A1-ATWH31000 | Maximum number of columns: 31000 Maximum number of rows: 31000
num | -1 0-15 | -1 : underlined 0 ... 15: Color according to the font color in the Create new font dialog (screens/fonts). You can find the allocation list under this table.

Allocation of font colors

The font colors are taken from the operating system. To make it easier for you, you can find a list of colors as they are used in Windows:

Note: If colors are rearranged or redefined in the operating system, the colors defined for maxsp also change.

Example

The highest value is to be displayed as underlined in report A1 to B4.

Input in the editor:

Row/column | A | B | C
1 | 8 | 5 | =maxsp(A1:B4,-1)
2 | 20 | 2 |
3 | 12 | 10 |
4 | 32 | 14 |

Result in Runtime


minsp

minsp

The minsp(range,num) functions determine the highest value in a range und displays it. The format can be a color or underlined.

Syntax: =minsp(range,num)

Transfer parameters | Valid range | Comment
range | A1-ATWH31000 |
num | -1 0-15 | -1: underlined 0 ... 15: Color according to the font color in the Create new font dialog (screens/fonts). You can find the allocation list under this table.

Allocation of font colors

The font colors are taken from the operating system. To make it easier for you, you can find a list of colors as they are used in Windows:

Note: If colors are rearranged or redefined in the operating system, the colors defined for minsp also change.

Example Example

Cell C1=minsp(A1:B4,-1)


Parameters

Parameters

Parameters make it possible to define a report that is executed via the zenon Execute report function and different transfer parameters used in the process perform different tasks. For example, a single report can be used to display the archives of several controls. Or a report displays values in different units of measurement.Syntax: =parameter(Number)

Ten parameters are available:

  • 1 - 5: String type
  • 6 - 10: DWord type

Engineering

  1. Allocate the desired parameters to the appropriate cells in the report

  2. Supplement the parameters with any computer operations that may be required or reference them
  3. In Runtime, select values for the parameters using the Execute report function or the Open file button and the Parameters tab

Hint: If you would like to display data from different archives in a report, for example five PLCs, then define a joint report. You control the display via five zenon functions that provide the parameters. You can simply copy these functions, however you must always only change the transfer values in the Parameters tab.

Examples of parameters

  • =parameter(1): allocates parameter (1) to the cell
  • =parameter(6)*A1/100: allocates parameter (6) to the cell, multiplies the value that was set in the Parameter tab by the value from cell A1 and divides this by 100


select

select

The =select(cell address) function defines the cell that should be selected on opening the report. As a parameter the cell reference has to be stated.

Syntax: =select(cell address)

Example Example

=select(B3)


selectmode

selectmode

The selectmode(selection mode) function defines the selection mode.

Syntax: =selectmode(selection mode)

Example Example

=selectmode(3)


user name

user name

The username function username returns the user names that are currently logged in to zenon.

Syntax: =username()

No transfer parameters are needed.


variabler

variabler

The =variabler(variable name,property) function provides information on a variable.

Syntax: =variabler(variable name,property)

Parameters | Description
name | Variable name.
text | Current limit text in the event of a limit being exceeded.
value | Current value of the variable.
unit | Unit of the variable.
identification | Identification of the variable.
mmin | Minimum measuring range of the variable.
mmax | Maximum measuring range of the variable
status | Current status of the variable.
gw1 | Limit 1 of the variable.
gw2 | Limit 2 of the variable.
gw3 | Limit 3 of the variable.
gw4 | Limit 4 of the variable.

info Information

The report is created more quickly if the variables called up are advised.

Configuration with the function assistant

  1. Select the Report functions report table in the context menu
  2. Select variabler
  3. click on the Variable button
  4. Select the desired variable:
    Several variables can be selected; these are entered in a downward direction, starting from the cell in which the report function is defined
  5. select the property to be displayed

Example Example

=variabler("WIZ_VAR_10","name")


variablerw

variablerw

The variablerw(variablename,property,action) function provides information on variables and writes values in variables.

Syntax: =variablerw(variable name,property,action)

Property | Description
name | Variable name.
text | Current limit text in the event of a limit being exceeded.
value | Current value of the variable.
unit | Unit of the variable. Note: may not be used together with unit conversion. Only for use with older projects. If a unit of a variable defined in the unit conversion is changed with this report command in Runtime, configuration must be carried out again in unit switching.
identification | Identification of the variable
mmin | Minimum measuring range of the variable. Note: may not be used together with unit shift.
mmax | Maximum measuring range of the variable Note: may not be used together with unit shift.
status | Current status of the variable.
gw1 | Limit 1 of the variable.
gw2 | Limit 2 of the variable.
gw3 | Limit 3 of the variable.
gw4 | Limit 4 of the variable.

info Information

The report is created more quickly if the variables called up are advised.

Configuration with the function assistant

  1. Select the Report functions report table in the context menu
  2. Select variabler
  3. click on the Variable button
  4. Select the desired variable:
    Several variables can be selected; these are entered in a downward direction, starting from the cell in which the report function is defined
  5. select the property to be displayed
  6. Enter the desired action

Example Example

=variablerw("WIZ_VAR_10","value","read")

Write value to variable

To write a value from the Report Generator to a variable, enter the variable name, the "value" property and the cell that contains the value to:

=variablerw(variable name,"value",cell)

Example: =variablerw("internal variable","value",A2)


Formatting keys

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> Report functions -> Formatting keys

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The formatting keys define the formatted output of cell details depending on the cell contents (data types).

The definition is made:

  • In the drop-down list Format -> Cells -> Numbers -> Cell type tab -> General/format string

    or

  • In the context menu Report table -> Cell -> Cell type tab -> General/format string


Numerical data types

Numerical data types

Format keys for numerical data types are symbolic dummies that are replaced by the formatted value.

  • The comma is used as a thousand-divider; a period is used for decimal points.
  • Each character which does not represent a format key is transferred into the output as a text character.
  • If no format key is given, the format *0.* is used as a standard setting.

    Note: A maximum of 15 decimal digits are permitted with the standard setting.

Format key | Description
, (comma) | Inserts the thousand-separator three digits after the decimal separator.
. (period) | Inserts the decimal separator.
; (semicolon) | Separates the format key for positive and negative value ranges.
# | Is only replaced if the corresponding place is also available.
* | All places before and after the decimal point are displayed.
0 (Cero) | If the position in the value does not exist then it is filled with zero.
/ | The following character is treated as a text character string.

Examples

Data | Format key | Formatted text | Description
-0.2 | *0.00 | -0.20 | Two decimal places are always output.
123 | *00000 | 00123 | The first 5 places are output with leading zeros.
104 | ->*<- | ->104<- | Numbers are basically output between the ->...<- characters.
0.2500 | *0.* | 12:25 AM | For values between -1.0 and 1.0, a leading zero is always output.
12 | +*0.00;-*0.00 | +12.00 | Positive values are indicated with + and negative values with -.


Logical data types

Logical data types

Yes/No information can be displayed in different ways with logical data types. The output text is determined using the formatting key.

  • Format: Text1;Text2
  • Output:
    • Positive values including zero = Text 1
    • Negative values = Text 2

Output information can be described independently of the cell formatting with the if(exprTest,valTrue,valFalse) function.

Example

Data | Format key | Formatted text | Description
1 |  | Yes | If no formatting key is given, true/false is used as a default.
-1 | Yes;No | No |


Data types for date and time

Data types for date and time

A variety of formatting keys are available for the output of date and time details. In input mode and for output without formatting keys, the output format defined under the windows country settings is used.

info Information

Descriptions for days and months can be configured as language switchable in Runtime.

Each character which does not represent a format key is transferred into the output as a text character.

Format key | Value | Description
m | 1 - 12 | Month numerical short
mm | 01 - 12 | Month numerical long
mmm | Jan - Dec | Month short
mmmm | January - December | Month long
d | 1 - 31 | Day short
dd | 01 - 31 | Day long
ddd | Sun - Sat | Weekday short
dddd | Sunday - Saturday | Weekday long
yy | 00 - 99 | Year short
yyyy | 1700 - 2900 | Year long (0x is interpreted as 190x)
/ |  | International date separator
h | 0 - 23 or 1 - 12 | Hour short, either 24 h or 12 h with ap
hh | 00 - 23 or 01 - 12 | Hour long, either 24 h or 12 h with ap
mm | 00-59 | Minutes, only after h or hh
ss | 00-59 | Seconds
ff | 000-999 | Milliseconds
ap | am, pm (or international equivalent) | am or pm
: (colon) |  | International time separator

Example

Data | Format key | Formatted text
22.09.95 2:05 PM | dddd dd/mm/yyyy | Friday 22.09.1995
22.09.95 2:05 PM | dd/mmmm yyyy | 22 September 1995
22.09.95 2:05 PM | dd/mm/yy hh:mm | 22.09.95 2:05 PM
22.09.95 2:05 PM | hh:mm:ff | 2:05:000 PM


zenon functions for Report Generator

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> zenon functions for Report Generator

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon provides functions to control the Report Generator in Runtime.

The screen switching function switches to the report screen and makes it possible to define filters.

Special functions make it possible to print, export, and execute a report in Runtime. To create zenon functions for the report generator:

  1. In the functions context menu, navigate to: New function -> Report generator
  2. select the desired function:
    • Print report
    • Export report
    • Execute report


Report screen switching

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> zenon functions for Report Generator -> Report screen switching

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use a report in Runtime, configure screen switching to a report screen type:

  1. Create a new Report screen type
  2. Select the New function command in the Functions node
  3. select the Screen switching function
  4. select the Report screen
  5. The report filter is displayed
  6. select the desired properties
  7. Link the functions with a button in the screen, in order to switch in Runtime


Report filter

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> zenon functions for Report Generator -> Report filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Displayed when creating zenon functions for configuring reports:

  • File: Selection of report file and conditions in Runtime
  • Tag: Transfer parameters
  • Time: Time period
  • Lots: Filtering on batches
  • Links: Replace functions
  • Indices: Replace indices


File

File

In the 'File' tab, you define which report is called up with screen switching or if this is to be decided in Runtime.

Parameters

Description

Format file

selection of the report file configured in the editor (*.xrs)

Show this dialog in the Runtime

Active: Before every call of the screen the filter dialog is opened. The filter settings can be modified. This option is not available with Windows CE.
Note: If, in the Lots tab, the Show lot selection dialog option is also selected, then the lot selection dialog is called up in Runtime. This is no longer displayed after reloading.

Notes for time range filters:

Show this dialog in the Runtimeactive:

  • The filter is opened in Runtime in screen switching. The filter is no longer offered on reloading. This behavior can differ for individual screen types if the dialog was displayed in screen switching and canceled.
  • The last-concluded time period is always used.

Show this dialog in the Runtimenot active:

  • Use last finished time rangeactive: The last-concluded time period is used
  • Use last finished time rangenot active: The current time period is used.

Read only

Active: Entries can only be read. It is not possible to change or save them.

Reading archives from the read-back folder

Active: Stored archives are read in from the read-back folder defined in project configuration.

When loading archive data from the readback folder, the archive data from the Runtime path and from all subfolders of the readback folder is also read.

The file configuration is different for:

  • Print report
  • Export Report
  • Report: execute


Parameters

Parameters

Parameters make it possible to use a report for different archives. To do this, the fields to be used flexibly are defined with the parameter ( Number ) report function. The parameters to be used are set in the 'Parameters' tab of the screen switching function. For example, a single report can be used to display the archives of several controls. Or a report displays values in different units of measurement.

Ten parameters are available:

  • 1 - 5: String type
  • 6 - 10: DWord type

If, for example, the archive data of five PLCs is to be displayed, a report is created and the five parameters for the PLCs are transferred via the five switching functions.


Time

Time

Time filters make it possible to limit the data to be displayed or exported. The time filters are very flexible to implement and can be pre-set in the editor or adjusted in Runtime.

Note: Time is saved in UTC. For details see chapter Handling of date and time in chapter Runtime.

Time filters can be pre-set in both the Editor and in Runtime for:

  • Absolute period of time
  • Relative period of time
  • From
  • Time period

Time filtering can be carried out in two ways:

  1. Define time period in the Editor
    Fixed time areas are used. A time period is given in the editor. It is only possible to filter according to this time period in Runtime. Other filters - such as filtering according to variable name, alarm/event groups and alarm/event classes etc. can no longer be amended in Runtime.
  2. Time filter amendable in Runtime
    Pre-defined times are used. The time filter is defined in the Editor and can be changed in Runtime as desired.

Time filter

Filter

Selection of the filter.

Parameters

Description

No time filter

Active: No time filter is used.

Note: all Runtime entries since 1. 1. 1990 are displayed.

Absolute filter

Active: A fixed period of time is entered in the editor. When the function is executed, the defined absolute time period is exactly used.

In the settings section, the corresponding options can be shown and configured there.

Note: Time is saved in UTC. For details see chapter Handling of date and time in chapter Runtime.

Relative period of time

Active: A relative time period is entered.

In the settings section, the corresponding options can be shown and configured there.

Attention: this filter is constantly updated.

From

Active: A time from which the filter is effective is stated. If the time is not reached on the current day, filtering takes place from the corresponding time the previous day.

Selection of the area mode from drop-down list:

  • From HH:MM:SS o'clock
  • From day - HH:MM:SS o'clock
  • Starting on day, month at HH:MM:SS

In the settings section, the corresponding options can be shown and configured there.

Attention: The start point of this filter is not updated automatically. Only the existing times are used when shown.
The end time point is not defined with this filter, it is carried over.

Time period

Active: A fixed time period is entered. Selection of the area mode from drop-down list:

  • One day
  • One week
  • Two weeks
  • One month
  • One Year
  • 15 minutes
  • 30 minutes
  • 60 minutes

In the settings section, the corresponding options can be shown and configured there.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

Note: A time filter must be configured for screen switching to a Report Generator screen. The No time filter option is not available.


Absolute period of time

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> zenon functions for Report Generator -> Report filter -> Time -> Absolute period of time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Absolute period of time

You define a fixed time period with the absolute filter. When the function is executed, the defined absolute time period is exactly used. To set the filter:

  1. Select, in the Filter section, the Absolute time period option
  2. Configure the desired time in the Settings section

Parameters | Description
Settings | Configuration of the time filter.
Propose current date/time | Active: Time filter is displayed in Runtime.
Preset | Active: The time filter is prescribed in the Editor. Only the start time can still be configured in Runtime.
From | Start time of the filter. Selection of day, month, year, hour, minute and second
To | End time of the filter. Selection of day, month, year, hour, minute and second

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Relative period of time

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> zenon functions for Report Generator -> Report filter -> Time -> Relative period of time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Relative period of time

A relative time period is entered.

Attention: This filter is updated constantly and continues to run.
Example: You set a relative time of 10 minutes and switch to a screen with this time filter at 12:00. You are then shown the data from 11:50 to 12:00 when switching. If the screen stays open, the filter is automatically updated. At 12:01, you see the data from 11:51 - 12:01 etc.

To set the filter:

  1. Select, in the Filter section, the Relative period of time option
  2. Configure the desired time in the Settings section

Parameters | Description
Settings | Configuration of the time filter.
Propose current date/time | Active: Time filter is displayed in Runtime.
Preset | Active: The time filter is prescribed in the Editor. Only the start time can still be configured in Runtime. Selection of the relative time period in days, hours, minutes and seconds.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Specify time period in the Editor

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> zenon functions for Report Generator -> Report filter -> Time -> Specify time period in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Specify time period in the Editor

With this method, you enter a fixed time period into the editor, which is applied when the function is carried out in Runtime. You can then only define the start time in Runtime, but no further filter settings.

For example: You set a 30 minute time filter. In Runtime, you can now only set when this 30 minute time period is to start. However, you cannot change the filter to a day filter.

attention Attention

When using this type of filter, you can also no longer amend all other filters in Runtime that are available in the General tab. It is still possible to filter for text, status and equipment.

To create the filter:

  1. The screen must have the Filter button to start the filter in Runtime
  2. select the desired filter
  3. Configure the selected time period

Tip for time period: Activate the Offer this dialog in Runtime option in the filter dialog. This way you can amend the start time before the function is carried out. Do not have the filter displayed in Runtime when the function is turned on; this way the current time period is always used. If you have activated the Use last closed time period option, the previous time period is shown.
For example: You have set a 30 minute filter. It is 10.45 when the function is activated. If the Use last closed time period option is deactivated, the filter is set to the current time period 10:30:00 to 10:59:59. If the option is activated, the filter is set to the previous time period of 10:00:00 to 10:29:59.


Time filter can be configured in Runtime

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> zenon functions for Report Generator -> Report filter -> Time -> Time filter can be configured in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Time filter can be configured in Runtime

With this method, you stipulate a time filter in the Editor. This can be amended in Runtime before execution. To create the filter:

  1. The screen must have Filter and Display filter buttons
  2. select the desired filter:
    • Absolute period of time
    • Relative period of time
  3. Select, in the Settings section, the option Propose current date/time
  4. The filter dialog is opened in Runtime with the current date and time


Lots

Lots

You configure the limitation of the display to certain lots in this tab. Lot filtering corresponds to filtering in the archives:

Filter

Settings for the application of the lot filter. Selection of one of the options:

  • No lot filter
  • Apply lot filter directly
  • Display lot selection dialog

Parameters

Description

No lot filter

Active: The lot filter is deactivated and cannot be configured. Filtering for lots is not carried out in Runtime.

Apply lot filter directly

Active: The filter configured here is applied in Runtime directly.

Display lot selection dialog

Active: The dialog for lot selection is shown in Runtime when:

  • Clicking on Filter or
  • screen switching, if the Offer this dialog in Runtime option has been activated (not available for each function/screen type)
    Note: The dialog is not shown on reloading.

Options can be pre-selected in the Editor.

Replace dialog in Runtime with screen

Not available if the Show lot selection dialog option has been selected.

Definition of a screen that is to be called up in Runtime instead of the lot selection dialog. Only time/lot filter screens are offered.

Click the ... button and the dialog opens to select a screen.

If the linked screen is not found in Runtime, a search is made for corresponding screens with specific names.

Relative lot selection

Only available for Extended Trend and faceplates and only if the option Display lot selection dialog has been activated. The Windows CE project property must be deactivated in the project properties.

  • Active: Enables several lots to be compared directly. Display always starts from the zero point.

Time

Configuration of the time filter for lot selection. Selection of one of the options:

  • No filter
  • Last lots
  • Use time filter from "Time" tab

Parameters

Description

No filter

Active: The time range set in the Time tab is not taken into account. All completed and current lots are displayed.

Last lots

Active: Input of the number of lots last concluded, according to what they should be filtered for. Input of the number in the number field or configuration via cursor keys.

The option allows the combination of both options Display current lots and Display completed lots.
Example: 3 lots are to be displayed, 2 are running and 10 have been completed. The following is shown: the two that are current and one that has been completed.

Attention: At least one of the two options Display current lots or Display completed lots must be activated. If both options have been deactivated, this corresponds to the No filter setting.

Note on compatibility: If the current lots or the combination of current and completed lots are selected and the project is compiled for a version before 7.11, the completed lots are shown in Runtime.

Display current lots

Active: The current lots are displayed.

Note: If the number of lots to be displayed is greater than the number of current lots, lots that have been completed are also shown until the set limit has been reached.
Example: 3 lots are to be displayed. 1 lot is running, 5 have been completed. The one current lot and two completed lots are displayed.

Display completed lots

Active: The completed lots are displayed.

Note: If the number of lots to be displayed is greater than the number of completed lots, lots that have been completed are also shown until the set limit has been reached.

Use time filter from "Time" tab

Active: Pre-filtering is carried out with the settings of the Time tab. The effective range of the filter can be amended within this time range. Select from drop-down list:

  • Start and end also outside filter limits: (Default)
    Lots can start before the start time configured in the Time filter and end after the configured end time.
  • Start and end only outside filter limits:
    Lots must start and end within the time points configured in the Time filter for the start and end.
  • Start also before filter limit:
    Lots can start before the start time configured in the Time filter and end after the configured end time.
  • End also after the filter limit:
    Lots can also end after the end time set in the time filter, but must start at or after the configured start time.
  • Adjust start and end to filter limits:
    Lots are cut to the time points configured in the Time filter for the start and end.

Archives

Configuration of filtering for archives. Selection of one of the options:

  • No filter
  • Static
  • From variable

Note: Only available for the following modules if the Apply lot filter directly option has been selected:

  • Archive revision
  • ETM
  • Report Generator
  • Report Viewer

Parameters

Description

No filter

Active: Filtering for archive names is not carried out.

Static

Active: Archives whose identification corresponds to the character string entered in the input field are filtered for.

Input of the archive identifications in the input field:

  • Several identifications are separated by a comma (,).
  • * or empty: All archives, no filter.

From variable

Active: The value of the variables linked here is applied as a filter for archive names in Runtime.

Click on button ... in order to open the dialog for selecting a variable.

Only available for all modules if the Apply lot filter directly option has been selected:

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.

If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for archive names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Names

Configuration of the filtering to names. Selection of one of the options:

  • No filter
  • Static
  • From variable

Parameters

Description

No filter

Active: Filtering for lot names is not carried out.

Static

Active: Lot names that correspond to the character string entered in the input field are filtered for.

Input of the lot name in the input field:

  • Several entries are separated by a pipe character (|).
  • * or empty: All lots of all displayed archives, no filter.

From variable

Active: The value of the variable linked here is applied as a filter for lot names in Runtime.

Click on the ... button to open the dialog for selecting a variable.

Not available if the option Apply lot filter directly has been selected.

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.
  • If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for lot names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Replacing links

Replacing links

Linked variables or functions can be permanently replaced in the Editor in a rule-based manner. The replacement is not limited to the functions or variables defined in the properties of the Variable / function group. All other variables used the screen can, such as variables for Visibility, Flashing, Size and rotation dynamic and others.

To replace variables or functions in a rule-based manner in the element directly:

  1. Highlight the desired element and open it by right clicking the element in the context menu
  2. select Replace Links
  3. The dialog for the replacement of links opens

Property | Description
Source | Enter the partial string to be searched for. Place holder * and ? can be used. Placeholders are only permitted as prefix or suffix; e.g. *xxx or xxx*.
Objective | Entry of the partial string
Name | Swaps information in process variable names.
Identification | Exchanges information in the identification
Note capitalization | When swapping, be sure that any capitalization is an exact match.
Accept | Swaps target strings from the source for those defined in the target.
Variable/function | Opens the selection list for variables/functions in relation to the selected line in the list. Clicking on the variable in the list defines new target variables. Alternative: Double-click on the source variable in question.

Replace

a) Replace by manual selection

  • select the element from the list that you would like as the source
  • select a target element via the variable/function button
  • the previous element is replaced by the new one

b) automated replacement with rules

  • In the source input field, define the parameters for the element that you wish to replace
  • define the parameter for the new variable/function in the target input field
  • specify what is to be replaced via Name/Identification
  • Click on Accept

info Information

The target variable or target function can also be in a different project as the source variable or source function. In doing so, all projects concerned must be started and available on the same computer in Runtime.

attention Attention

When replacing variables, be aware of the type and signal resolution. If you replace a variable with one of an incompatible type, this can lead to errors during execution. You will be warned when making the substitution; the substitution will however be carried out.

info Information

Replace via Drag&Drop: Elements that can only contain one variable or function can be swapped by dragging & dropping. Drag the new variable or function to the element using the mouse. It automatically replaces the previous one.

Example

All variables with Tank1 in the name are to be replaced by Tank4.

  1. Enter, into the Source text field, Tank1. With the * character, you can include all variables that start with Tank1.
  2. Enter, in the Ziel text field, Tank4.
  3. Click on Accept.
  4. The variables Tank1_max and Tank1_min are replaced by the variables Tank4_max and Tank4_min.


Replace indices

Replace indices

When switching screens in Runtime, variables can be replaced dynamically using indexing rules and functions via parameters.

Key words in the substitution rule:

  • Values via indexing variables: for example {X01}
  • Parameters: {PARAM}

attention Attention

Because the names are replaced, variables and functions must always be given different names. Variables and functions are replaced if the names are the same.

Example: If there is a test variable and a test function and the test variable is to be replaced, the test function is also replaced at the same time.

Hint: Name variables and functions each with a prefix (for example var_ and func_). You therefore always have a overview in lists too.

Create parameters for indexing variables and functions

Parameters for indexing variables

Indexing variables can be selected in the dialog to replace indexes. Each variable is defined using its own parameters. This is displayed in the list of indexing variables.

Parameters for functions

Parameters for functions are used in the substitution dialog for indexes of screen switching. In doing so, the key word {PARAM} is replaced by the content of the parameter entry in the substitution rule.

Note: Avoid character sequences that are also used for parameter of the indexing variables, such as {X01}.

Functions that are linked to the following screen elements can be replaced using parameters:

  • Button
  • Combo-/Listbox
  • Combined element

To set a parameter, enter the character sequence for the parameter into the corresponding property:

  • Button and combined element: Parameter for substitution property in the Variable / function group
  • Combo / list box Parameter for substitution option in the configuration dialog of the static combo box or list box

When executing a function in Runtime that uses substitution, the key word {PARAM} is replaced by its respective entry. If the entry does not provide a meaningful result, the original value is displayed.

Examples:

  • If the result of the replacement is motor[13], but index 13 does not exist, the original value is displayed.
  • If the parameter is 1 and the rule is to replace motor[3] with motor[1] and both parameters exist, the element that previously displayed motor[3] will now display motor[1].

Replace indexes dialog

Indexing rules

Parameters

Description

Indexing rules

Configuration of the rules for the replacement of variables and functions.

Source

Entry of the source that is to be substituted.

Target

Entry of the target. Parameters for values from indexing values such as ({X1} and parameters {PARAM} for functions can also be used.

Case sensitive
  • Active: The replacement is case-sensitive.

List of rules

List of defined rules.

Add rule

Clicking on the button adds the defined rule available via Source and Target to the list.

Remove rule

Clicking on the button deletes the selected rule from the list.

Arrow upwards

Clicking on the button arranges the selected rule in the list one position up.

Arrow downwards

Clicking on the button arranges the selected rule in the list one position down.

Indexing variables

Parameters | Description
Indexing variables | Configuration of the indexing variables.
List of rules | Shows the selected indexing variables.
Add | Clicking on the button opens the dialog to add and remove indexing variables. Selected variables are added in sequence and given a parameter. This can be used in the replacement rules for the respective indexing variable. The values of these variables are genereally used during replacement.

Replacement preview

Parameters | Description
Replacement preview | Displays the configured replacements.
List of planned replacements | Lists all configured substitutions. Clicking on an entry also fills the Source and Target options in the indexing rules section.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

attention Attention

If index variables are used in a network project, the Client must first fetch the value from the Server. Then the calculation is executed. On devices with outdated hardware, this may cause delays when screen switching.
Therefore index variables should always be set to Harddisk data storage active in a network project.


Report Generator: execute

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> zenon functions for Report Generator -> Report Generator: execute

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Report Generator: execute function makes it possible to execute a report automatically in the background in Runtime. If a writing function is configured in the report, values calculated in the report can automatically be written to archives or to the process image.

To configure the function:

  1. Create a new function
  2. Select, in the Report generator section, the Execute report entry
  3. The dialog for the report filter is opened

    Note: The File tab settings are different. The settings that are valid for Execute report are clarified in this chapter; you can find all further settings in the report filter chapter.

    • Parameters
    • Time
    • Lots
  4. select the desired properties
  5. Link the functions with a button in the screen, in order to switch in Runtime

Configuration of File tab

The configuration of the File tab is slightly different to the configuration for screen switching.

Parameters | Description
Format file | selection of the report file configured in the editor (*.xrs)
Show this dialog in the Runtime | Active: This filter dialog is offered before being called up in Runtime.
Reading archives from the read-back folder | Active: Stored archives are read in from the read-back folder defined in project configuration. When loading archive data from the readback folder, the archive data from the Runtime path and from all subfolders of the readback folder is also read.

info Information

With this function, all write actions are carried out in the report.


Print Report Generator

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> zenon functions for Report Generator -> Print Report Generator

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Report Generator: execute function makes it possible to print out a report without calling it up beforehand. To configure the function:

  1. Create a new function
  2. Select, in the Report generator section, the Execute report entry
  3. The dialog for the report filter is opened
  4. Note: The File tab settings are different. The settings that are valid for Print report are clarified in this chapter; you can find all further settings in the report filter chapter.
    • Parameters
    • Time
    • Lots
  5. select the desired properties
  6. Link the functions with a button in the screen, in order to switch in Runtime

Configuration of File tab

Parameters | Description
Format file | selection of the report file configured in the editor (*.xrs)
Show this dialog in the Runtime | Active: This filter dialog is offered before being called up in Runtime.
With dialog cancel | Active: A button to cancel printing is shown whilst the report is being prepared for print.
Reading archives from the read-back folder | Active: Stored archives are read in from the read-back folder defined in project configuration. When loading archive data from the readback folder, the archive data from the Runtime path and from all subfolders of the readback folder is also read.

info Information

Archive entries can only be read with the Print report function. Write actions are not possible.


Export Report Generator

Manual -> Reporting -> Report Generator -> Engineering in the Editor -> zenon functions for Report Generator -> Export Report Generator

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Export Report Generator function is used to write a report in the background to a file during online operation. The export file is stored in the \Export sub-folder of the project folder. (open from zenon: highlight project, press ctrl+alt+D.) Provide the file parameters, the filter and the time as the transfer parameters.

The Export report function makes it possible to export a report without calling it up beforehand. To configure the function:

  1. Create a new function
  2. Select, in the Report generator section, the Export report entry
  3. The dialog for the report filter is opened
  4. Note: The File tab settings are different. The settings that are valid for Export report are clarified in this chapter; you can find all further settings in the report filter chapter.
    • Parameters
    • Time
    • Lots
  5. select the desired properties
  6. Link the functions with a button in the screen, in order to switch in Runtime

info Information

When exporting a report using the Export report function, the converted units are exported at units of measurement. The basic units are not a part of the export.

Configuration of File tab

Parameters

Description

Format file

selection of the report file configured in the editor (*.xrs)

Show this dialog in the Runtime

Active: This filter dialog is offered before being called up in Runtime.

Reading archives from the read-back folder

Active: Stored archives are read in from the read-back folder defined in project configuration.

When loading archive data from the readback folder, the archive data from the Runtime path and from all subfolders of the readback folder is also read.

Export file

Properties of the file that is exported in the report.

Name

Name of the file.
Maximum of eight alphanumeric characters. If no name is given and automatic naming is switched off, the name dummy is used.

Attention: The use of special characters may lead to a loss of data.

Format

Format of the export file.
  • TXT

Text file
  • XRS

zenon Report file
  • XML

XML-File

Generate name automatically

Active: The filename is created automatically. It consists of the short identifier and the coded date and the chosen file ending.

Coding name for automatic naming

Code | Meaning
xx | Short identifier: 2 characters The first two characters of the name given under 'Name' or the name issued by the system, du.
YY | Year: two-digits
MM | Month: two-digits
DD | Day: two-digits
HH | Hour: two-digits
MM | Minute: two-digits
SS | Second: two-digits

Example

  • The Report report file is exported on 9. 6. 2010 at 11:52 in XRS format
  • Automatic filename: re100506091152.xrs

info Information

Archive entries can only be read with the Export report function. Write actions are not possible.


Operating during Runtime

Manual -> Reporting -> Report Generator -> Operating during Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The reports on the configured buttons are displayed, configured and administered in Runtime. The following user elements are available in Runtime:

Parameters

Description

Add template...

Opens the dialog for selecting a template for the screen type.

Templates are shipped together with zenon and can also be created by the user.

Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.

Windows

Control elements for window display.

Report

Report window to display the report.

Set filter

Displays the currently-configured time filter in Runtime.

Functions

Buttons for controlling in the Runtime.

Filter

Select report file and change filter conditions.

Refresh

Recreate build report completely (values and display).

Print

Print report in Runtime.

Export

Export report.

Save archive

Write changed values to the archive.

Save report

Report is saved in Runtime (*.xrs).

Attention: When saving, formulas and functions are replaced by the current values. The functions in these reports (.xrs files) are no longer available. These reports can also not be edited in the editor anymore.

Recommendation: Set original report files to "write-protected" status and save changes with Save as in a new file.

Save report as

Report is saved under a new name during Runtime (*.xrs), formulas and functions are replaced by current values.

Read selected values

Selected values are read in again from the driver.

Write selected values

Selected values are sent to the driver.

Read all values

All values are read in again from the driver.

Write all values

All values are sent to the driver.

Navigation

Control elements for navigation.

Line up

Scroll text in list element up

Line down

Scroll text in list element down

Column right

Scroll text in list element to the right

Column left

Scroll text in list element to the left

Page up

Scroll text in list element up

Page down

Scroll text in list element down

Page right

Scroll text in list element to the right

Page left

Scroll text in list element to the left

Filter profiles

Buttons for filter settings in Runtime.

Profile selection

Select profile from list.

Save

Saves current setting as a profile.

Delete

Deletes selected profile.

Import

Imports filter profiles from export file.

Export

Exports filter profiles in the file.

info Information

A period is used as a decimal separator. When inputting, both a period or a comma can be used. The separator is automatically converted by the system.

Example: 10,5 is turned into 10.5


Lot filter for screen switching

Manual -> Reporting -> Report Generator -> Operating during Runtime -> Lot filter for screen switching

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If you switch to a report screen that filters for lots, the following filter is displayed.

Parameters

Description

Lot filter

Selection of the recipe group that is to be imported. The filter consists of the two lists:

  • List of archives: a list of the archives
  • List of lots: List of lots allocated to the selected archive.

List of archives

Selection of the desired archive

node *:

  • Collects all lots of the displayed archive.
  • The key is the lot name.
  • The start time is the start time of the earliest lot.
  • The end time is the latest end time of all lots.

List of lots

Display of the lots allocated to the selected archive.

Filtering through entry of text, date, time or rime range - depending on type.

Sort by clicking on the header.

Lot name

Displays the name of all available lots.

Filter: Entry of a character sequence. Only lots matching the respective character string will be displayed.

Start date

Shows the start date of all available lots.

Filter: Entry of a start date or selection from a calendar.

Start time

Only available if you entered a start date.

Display of the start time of all available lots.

Filter: Entry of a start time. * means 12:00:00 AM o' clock.

End date

Shows the start date of all available lots.

Filter: Entry of an end date or selection from a calendar.

End time

Only available if you entered an end date.

Display of the start time of all available lots.

Filter: Entry of a start time. * means 11:59:59 PM o' clock.

Duration

This column displays the duration for each available lot.

Display only.

info Information

Still open lots are also displayed if they match the set filter criteria.

info Information

The value of the lot variable is written in the index file and in the header of the ARX file at the start of the lot. These entries are adjusted with every change of the variable. When the lot is closed, the value of the lot variable at this moment is finally written in the index file and in the header.

Thus the lot name is final when the lot is closed.


Example of archive data in reports

Manual -> Reporting -> Report Generator -> Example of archive data in reports

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this example, you create archive data in a report. To do this:

  1. Open a new report using the context menu and the New report entry.
  2. Design the Title area
  3. Fill the data area
  4. Set up a report screen and create a function

Other topics in this chapter

Title area

Data area

Displaying the report in Runtime


Title area

Manual -> Reporting -> Report Generator -> Example of archive data in reports -> Title area

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The title area contains, in the first four rows:

  • Texts as headings for the data
  • Date and time
  • Company logo

The title area is formatted in such a way that it is fixed for longer reports and does not disappear from view during scrolling.

Other topics in this chapter

Texts

Date and time

Screens as a company logo

Fixed title area for multipage reports


Texts

Manual -> Reporting -> Report Generator -> Example of archive data in reports -> Title area -> Texts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Enter the following texts as headings for the report:

  • Time
  • Hall 1
    • Tank 1
    • Tank 2
  • Hall 2
    • Tank 1
    • Tank 2


Date and time

Manual -> Reporting -> Report Generator -> Example of archive data in reports -> Title area -> Date and time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The date and time of the report are configured for the for cells A1 and E1 with report functions. To do this:

  1. Enter the function =now() into the cells A1 and E1.
  2. The current date is now displayed in both cells.
  3. In order to get the time in cell E1 instead, you have to change the formatting of this cell.
    1. Highlight cell E1
    2. Open the format dialog using the Format/Cells/Editing menu.
    3. Select the formatting string as shown in the illustration below

  4. The result:


Screens as a company logo

Manual -> Reporting -> Report Generator -> Example of archive data in reports -> Title area -> Screens as a company logo

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Screens in cells are not treated as cell contents by the Report Generator, but as formatting. Configuration is therefore carried out using cell formatting:

  1. Import the desired screen in the Project Manager into the Files/graphics nodes
  2. Select cell E2 with the left mouse button.
  3. Open the context menu of the report with the right mouse button and select the Cell command.
  4. In the dialog box, change to the Cell type page.
  5. Change the cell type to Graphics file
  6. Select the desired screen from the drop-down list on the right side

  7. The result:


Fixed title area for multipage reports

Manual -> Reporting -> Report Generator -> Example of archive data in reports -> Title area -> Fixed title area for multipage reports

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To always have the row and column titles in view in multi-page reports, you must prevent these also being moved when the report is scrolled. To do this, define fixed title areas.

To fix the row title:

  1. Select the Report command in the Format menu.
  2. The configuration dialog is opened
  3. Open the Columns tab

    Next to the number of columns you also can define the number of Non-scrolling columns here. The stipulated number of fixed columns is then no longer scrolled out of the visible screen area.

  4. Enter 1 for the Non-scrolling columns.
  5. Change to the Rows: tab

    Our column headings are in rows 1 to 4 for the lines:

  6. Enter 4 for the Non-scrolling rows.
  7. Confirm all changes by clicking on the OK button


Data area

Manual -> Reporting -> Report Generator -> Example of archive data in reports -> Data area

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the data area:

  • Configure the display of time and values
  • Have the sum and average displayed

Other topics in this chapter

Time

Values

Sum and average


Time

Manual -> Reporting -> Report Generator -> Example of archive data in reports -> Data area -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The time of the displayed archive values is displayed in column A.

info Information

We select a cyclical archive as a basis. The entries of all variables are therefore made at the same time and a time column is sufficient for all entries.

To configure the time:

  1. Select cell A5.
  2. Select the Function assistant command in the Format menu
  3. The function assistant is opened

  4. Select the Archive function with a double-click.
  5. The Archive button is always displayed in the lower area of the dialog

  6. Click on Archive
  7. The dialog for archive selection is opened:

  8. Click on New
  9. The archives stored in the archive server node are displayed
  10. Select the variables as shown in the screenshot

  11. Click on Save
  12. Select the variable "H1_Tank1"

  13. Confirm the selection by clicking on OK
  14. The function assistant is displayed again
  15. Select time as the parameter with a double-click.

  16. Select the parameter downwith a double-click.
  17. Configuration of the function is complete (=archive(1,"time","down")

  18. Close the assistant by clicking on the OK button

The time of variable archiving is thus continued downwards from row 5 in column A.

info Information

The parameters always have to be selected with a double-click. All parameters have been set up once the function in the preview is closed with a bracket and no further parameters are offered. If the OK button is clicked on before all parameters have been selected, the assistant is closed before all parameters for the function have been set up.


Values

Manual -> Reporting -> Report Generator -> Example of archive data in reports -> Data area -> Values

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You configure the values for the tanks in hall 1 and 2 in the same manner as the configuration for the time. Pay attention to the following differences:

  • The archive variables no longer need to be set up. They already exist and can be selected immediately. Assign each tank the corresponding variable.
  • Instead of the time parameter, select the value parameter.

Copying a function

As soon as you have created a function, you can copy it to other cells and then edit it accordingly:

To do this:

  1. Highlight the cell to be changed
  2. Then click in the editing cell
  3. In the function that is now displayed, the reference numbers refer to the corresponding archive variables as they are automatically issued during archive selection when the function is first created
  4. Therefore replace the 1 as the first parameter in column C by a 2
    in column D with a 3
    and in column E with a 4


Sum and average

Manual -> Reporting -> Report Generator -> Example of archive data in reports -> Data area -> Sum and average

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For this report, you now configure the display of sum and average.

To do this, you must determine how many cells are needed for archive entries. You define these in the Report Generator. The number of entries in the list depends on the filter settings that are used to subsequently call up the report (Execute report, Print report, Export report functions).

In our example, we will select a time range of two minutes. As our archive records values every five seconds, this will make 24 entries for the report. Therefore:

  1. Enter the text Sum into cell A29.
  2. Enter the text Average: into cell A30 on
  3. Enter the function =sum(B5:B25) into cell B29.
  4. Enter the function =sum(B5:B25) into cell B30.
  5. Copy the cell B29 to C29, D29 and E29
  6. Copy the cell B30 to C30, D30 and E30
  7. Save the report under the name Archiv.xrs

info Information

When entering the functions, you can either type in cell names or click on the corresponding cell with the mouse.

If you copy functions with cell addresses in the Report Generator, the cell addresses are automatically adapted.


Displaying the report in Runtime

Manual -> Reporting -> Report Generator -> Example of archive data in reports -> Displaying the report in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To be able to look at the report in Runtime, you need:

  • A report screen
  • A screen switching function

Create screen of type Report

In order to create a Report screen:

  1. Create a new screen named Report.
  2. Select Report as screen type
  3. Select the frame MAIN
  4. Click in the new screen
  5. Select the "Default" command from the "Control elements" menu
  6. Add any other required control elements there may be

Create function

Create a screen switch function to select the screen in Runtime. To do this:

  1. Add a new button to the start screen
  2. Label it with Report
  3. Change to the Functions node

    create a new function

  4. select Screen switching
  5. Select the Report screen
  6. The report filter is opened

  7. Click on the Format file button
  8. Select Archiv.xrs
  9. Open the Time tab

  10. Set, for our example
    1. The time format to Relative time period and
    2. Set the time to 2 minutes.

    You can read more about the time filter in the Alarm Message List manual in the time filter chapter

  11. Close the filter by clicking on OK
  12. Allocate a the configured button to the function
  13. Start the function in Runtime


Report Viewer

Manual -> Reporting -> Report Viewer

The Report Viewer can be used to display RDL reports of archive data, AML data, and CEL data as well as online values. Two historical time ranges can also be compared using two configurable time ranges.

RDL files that display the report template for Runtime are created and edited in the Editor. There are already 7 pre-defined datasets available. Further datasets can be created freely; only the table scheme for the four data categories is stipulated.

The source data that supplies the datasets created in the RDL file in Runtime is defined in the screen switching function on the Report Viewer screen. For each dataset used in the RDL file, a dataset with the same name and data origin must be created. The source variables and filter criteria can be prescribed for these depending on their type.

Typical configuration steps:

  1. Create a new report definition file or import one
  2. Create Report Viewer screen
  3. Create screen switching function and configure datasets
  4. Configure output as a PDF or output to the printer
  5. Configuring an RDL file
  6. Call up the function in Runtime using a button or menu

Limitations

Reports cannot be as large as you want, because the processing of quantities of data that are too large in a dataset can influence the performance of Runtime. The size of a report is limited to the issue of 5,000 value/lines per dataset.

Note: For datasets with archive files, 5,000 values are issued for each variable contained in the archive.

attention Attention

If several Report Viewer functions (print, export) are executed at the same time, this can lead to Runtime being placed under load.


Engineering in the Editor

Manual -> Reporting -> Report Viewer -> Engineering in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To be able to use the Report Viewer in Runtime, the following must be carried out in the Editor:

  1. Create a Report Viewer screen
  2. Create or import an RDL file, if none is present
  3. Set up a screen switching function on the Report Viewer screen
  4. Configure the datasets in the screen switching
  5. Amend the report definition file (RDL) to suit the datasets defined in zenon.
  6. Add a button to call up the Report Viewer in Runtime in the start screen or the menu screen

Folder for report definition files (RDL)

RDL files are stored in the project tree in the Files/Report Viewer node. Existing RDL files can be imported and edited here or new files can be created.

Report template context menu

Menu item | Action
New report definition file | Open the dialog to create a new RDL file on the basis of the previously-defined data sets.
Open report definition file | Opens the program linked to the RFL files to edit an existing definition file. zenon first looks for MS Report Builder, then for MS Report Designer by default.
Create standard function | Only available in the toolbar. Create a screen switch to a Report Viewer screen to be selected and enters the selected RDL file into the Report definition file.
Jump back to starting element | With linked elements, jumps back to the element from which the report template was jumped to. Only present in the context menu if linked elements are present.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Import existing report definition file | Opens dialog to import existing report definition files. These must be of RDL 2.0 type.
Remove all filters | Removes all filter settings.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Help | Opens online help.


Create Report Viewer screen

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Create Report Viewer screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to create a Report Viewer screen:

  1. Create a new screen
  2. Select the Report Viewer special screen type in the drop-down list
  3. Name the screen
  4. select Add template in the control element menu
  5. The standard elements are created and placed automatically

Parameters | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.
Report | Functions and profiles for the report.
Set filter | Displays the currently-configured time filter in Runtime.
Refresh | Reloads the report definition and the data and displays the report with the updated data.
Print | Prints the report on the printer defined for values and logs.
Create PDF | Saves the report currently being displayed as a PDF file in the folder defined for export.


Screen switching to a Report Viewer screen

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use the Report Viewer in Runtime, configure screen switching to a Report Viewer screen type:

  1. Create a new Report Viewer screen
  2. Select the New function command in the Functions node
  3. select the Screen switching function
  4. Select the Report Viewer screen
  5. The report filter is displayed
  6. Configure, if you want, the replacement of the time filter in the Runtime tab
  7. Switch to the Report definition tab
  8. Select the RDL file
  9. Define the module filter and/or time filter
  10. Create the desired datasets
  11. Link the functions with a button in the screen, in order to switch in Runtime
  12. Edit the datasets in the RDL file according to their settings in screen switching


Report definition

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Report definition

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You configure the data sets and filters to be displayed in this tab.

Parameters

Description

Report definition file

RDL file that is used for report definition. This file must be present in the File/report templates node. A click on the ... button opens the file selection dialog.

Reading data sets from a file

Clicking on the button reads the data sets from the RDL file defined in the Report definition file and enters them into the Datasets list.

For this, the following applies:

  • All datasets that can be assigned to an existing dataset type in zenon in terms of column number and naming are created automatically.
  • Unknown data sets are ignored.
  • If a time filter is needed, the first (time filter 1) is linked.
    If there is not yet a time filter present, a time filter with standard settings (relative, last hour) is displayed and linked.

Note: The Datasets list must be empty so that datasets from an RDL file can be inserted automatically. Existing data sets must be deleted before the function is used.

Filter

List of the available filters with a display of names and filter type. The following is available:

  • Module-specific filter:
    Batch Control recipe filter
  • Time filter

Configuration:

  • Clicking on the Module-specific filter opens the dialog to configure a batch filter.
  • Clicking on the New time filter ... button opens the dialog to configure a time filter.

Double-clicking on the group overview opens the first configured filter of the group.

New time filter

Opens the dialog for configuring a new time filter.

Edit

Opens the list of the time filters highlighted in the list for editing.

Delete

Deletes the time filter highlighted in the list.

Data sets

Display of datasets created. The list contains:

  • Dataset name
  • Origin of the data
  • Time filter

New

Opens the dialog to create a new report definition.

Edit

Opens the dialog to edit the definition of the selected element.

Delete

Deletes the selected element and its definition from the list.

OK

Applies all changes in all tabs and closes the dialog.

Cancel

Discards all changes in all tabs and closes the dialog.

Help

Opens online help.

info Information

If a data source is created in the RDL file that cannot be configured in the filter of a Report Viewer function, the missing data sets are replaced by blank entries. The report is therefore also displayed correctly in this case.


Runtime

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab, you configure the replacement of the first time filter by a time/lot filter screen. With this, you can, when switching a separate screen for example, use time filters instead of the filter configured in screen switching.

Parameters

Description

Runtime settings

Settings for actions in Runtime.

Replacing time filter 1 with a screen in Runtime

Replaces the first-configured time filter with a time/lot filter screen in Runtime. The currently-linked screen is displayed.

Click the ... button and the dialog opens to select a screen. Only screens from the project calling them up and time/lot filter screens are offered.

When selecting a filter screen, the BOX SCREEN information is also shown in the detail view of the function in the Parameter column; without a linked screen, only BOX is displayed.

OK

Accepts changes in all tabs and closes dialog.

Cancel

Discards all changes and closes the dialog.

Help

Opens online help.


Batch Control recipe filter

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Batch Control recipe filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When screen switching to a report viewer type screen, a filter can be set for recipes from the Batch Control module. To filter according to recipes:

  1. Open the Report definition tab for screen switching
  2. go to area Filter
  3. In the Module-specific filter tab, click on Batch Control: Recipe Filter
  4. the dialog for configuring the filter is opened

Use recipe filter for

Parameters

Description

Use recipe filter for

Selection of the recipe type that is applied to the filter:

  • Master recipe
  • Control recipe

Master recipe

Active: It is filtered on Master recipes.

Control recipe

Active: It is filtered on control recipes.

Note: The attendant master recipes must also be selected. If no master recipe has been selected for the control recipe, th filer cannot find the recipe being searched for in Runtime.

Hint: If the master recipe is not known, filtering of all master recipes with a placeholder is recommended.

Recipe filter settings

Parameters

Description

Recipe filter settings

Options for the recipe filter

Apply selection from recipe list from calling Batch Control screen

Active: In Runtime, the first selected recipe of the batch screen from which the report viewer screen is called up is used. Individual settings in this dialog are then not available.

Inactive: The filter settings are changed individually using this dialog.

Master recipe

Parameters for the selection of the master recipe. Selection from drop-down list:

  • Name with wildcards:
    A name with placeholder can be entered into the input field. Filtering according to this name is carried out.
  • Name from variable:
    The name of the master recipe is defined by a variable in Runtime. A click on button ... opens the dialog for selecting variables.
  • ID from variable:
    The ID of the master recipe is defined by a variable in Runtime. A click on button ... opens the dialog for selecting variables.

Version

Selection of the version from the drop-down list:

  • All:
    The version stated is ignored and each version found is used.
  • Fixed version:
    This filters for versions that are entered in this field.
    Highest possible version: 4294967295
  • Version from variable:
    The recipe that was in the linked variables at the time of execution is filtered for. Click on button ... in order to open the dialog for selecting a variable.
  • Only oldest version:
    Only the recipe with the oldest version number is used.

Only newest version:
Only the recipe with the newest version number is used.

State master recipe

Status of the recipe Select from drop-down list:

  • Released or outdated
  • Released
  • Outdated

Filter result for

Define which ID is to be selected when filtering for names by selecting from the drop-down list:

  • Only oldest ID
  • Only newest ID

Because a report can only be used for one recipe, it is not possible to filter for "all recipes".

Control recipe

Parameters for the selection of the control recipe. Selection from drop-down list:

  • Name with wildcards:
    A name with placeholder can be entered into the input field. Filtering according to this name is carried out.
  • Name from variable:
    The name of the control recipe is defined by a variable in Runtime. A click on button ... opens the dialog for selecting variables.
  • ID from variable:
    The ID of the master recipe is defined by a variable in Runtime. A click on button ... opens the dialog for selecting variables.
    Precisely one recipe can be found if the variable value at the time of execution is a valid ID of a control recipe.
  • Job ID from variable:
    Finds control recipes that belong to the master recipes already found and which have the given job ID. Any type of variable can be linked. The value is automatically converted into STRING.
    Note: If the variable does not have a value, no recipe is sent to the Report Viewer.

State control recipe

Selection of the recipe status from the drop-down list:

  • All
  • Prepared
  • Running
  • Executed
  • Terminated with error
  • Outdated

Filter result for

Define which ID is to be selected when filtering for names or job ID by selecting from the drop-down list:

  • Only oldest ID
  • Only newest ID

OK

Applies all changes, creates filter and closes the dialog.

Cancel

Discards all changes in all tabs and closes the dialog.

Help

Opens online help.

Note for variable selection using name or ID: For the selection of variables according to name or ID, numerical variables and string variables can be selected respectively. The data types are converted to the respective correct form.


Time filter

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Time filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Time filters make it possible to limit the data to be displayed or exported. The time filters are very flexible to implement and can be pre-set in the editor or adjusted in Runtime.

Note: Time is saved in UTC. For details see chapter Handling of date and time in chapter Runtime.

Clicking on the New button or Edit button in the Time filter section of the Report definition tab opens the dialog to configure a time filter. Any number of time filters can be used.

Time filters can be pre-set in both the Editor and in Runtime for:

  • Absolute period of time
  • Relative period of time
  • From
  • Time period

Time filtering can be carried out in two ways:

  1. Define time period in the Editor
    Fixed time areas are used. A time period is given in the editor. It is only possible to filter according to this time period in Runtime. Other filters - such as filtering according to variable name, alarm/event groups and alarm/event classes etc. can no longer be amended in Runtime.
  2. Time filter configurable in Runtime
    Pre-configured times are used. The time filter is defined in the Editor and can be changed in Runtime as desired.

Time filter

Filter

Selection of the filter.

Parameters

Description

No time filter

Active: No time filter is used.

Note: all Runtime entries since 1. 1. 1990 are displayed.

Absolute filter

Active: A fixed period of time is entered in the editor. When the function is executed, the defined absolute time period is exactly used.

In the settings section, the corresponding options can be shown and configured there.

Note: Time is saved in UTC. For details see chapter Handling of date and time in chapter Runtime.

Relative period of time

Active: A relative time period is entered.

In the settings section, the corresponding options can be shown and configured there.

Attention: this filter is constantly updated.

From

Active: A time from which the filter is effective is stated. If the time is not reached on the current day, filtering takes place from the corresponding time the previous day.

Selection of the area mode from drop-down list:

  • From HH:MM:SS o'clock
  • From day - HH:MM:SS o'clock
  • Starting on day, month at HH:MM:SS

In the settings section, the corresponding options can be shown and configured there.

Attention: The start point of this filter is not updated automatically. Only the existing times are used when shown.
The end time point is not defined with this filter, it is carried over.

Time period

Active: A fixed time period is entered. Selection of the area mode from drop-down list:

  • One day
  • One week
  • Two weeks
  • One month
  • One Year
  • 15 minutes
  • 30 minutes
  • 60 minutes

In the settings section, the corresponding options can be shown and configured there.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

Note: If the no time filter option is set as time filter type, all Runtime entries since 1. 1. 2000 are displayed.

attention Attention

A Report Viewer type screen can have several time filters. If, in the Runtime tab, a filter is set to a Report Viewer type screen using a time filter screen, then only the first time filter is replaced with the settings of the filter screen. Other filter types of the time filter are automatically set to no time filter.


Absolute period of time

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Time filter -> Absolute period of time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Absolute period of time

You define a fixed time period with the absolute filter. When the function is executed, the defined absolute time period is exactly used. To set the filter:

  1. Select, in the Filter section, the Absolute time period option
  2. Configure the desired time in the Settings section

Parameters | Description
Settings | Configuration of the time filter.
Propose current date/time | Active: Time filter is displayed in Runtime.
Preset | Active: The time filter is prescribed in the Editor. Only the start time can still be configured in Runtime.
From | Start time of the filter. Selection of day, month, year, hour, minute and second
To | End time of the filter. Selection of day, month, year, hour, minute and second

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Relative period of time

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Time filter -> Relative period of time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Relative period of time

A relative time period is entered.

Attention: This filter is updated constantly and continues to run.
Example: You set a relative time of 10 minutes and switch to a screen with this time filter at 12:00. You are then shown the data from 11:50 to 12:00 when switching. If the screen stays open, the filter is automatically updated. At 12:01, you see the data from 11:51 - 12:01 etc.

To set the filter:

  1. Select, in the Filter section, the Relative period of time option
  2. Configure the desired time in the Settings section

Parameters | Description
Settings | Configuration of the time filter.
Propose current date/time | Active: Time filter is displayed in Runtime.
Preset | Active: The time filter is prescribed in the Editor. Only the start time can still be configured in Runtime. Selection of the relative time period in days, hours, minutes and seconds.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Specify time period in the Editor

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Time filter -> Specify time period in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Specify time period in the Editor

With this method, you enter a fixed time period into the editor, which is applied when the function is carried out in Runtime. You can then only define the start time in Runtime, but no further filter settings.

For example: You set a 30 minute time filter. In Runtime, you can now only set when this 30 minute time period is to start. However, you cannot change the filter to a day filter.

attention Attention

When using this type of filter, you can also no longer amend all other filters in Runtime that are available in the General tab. It is still possible to filter for text, status and equipment.

To create the filter:

  1. The screen must have the Filter button to start the filter in Runtime
  2. select the desired filter
  3. Configure the selected time period

Tip for time period: Activate the Offer this dialog in Runtime option in the filter dialog. This way you can amend the start time before the function is carried out. Do not have the filter displayed in Runtime when the function is turned on; this way the current time period is always used. If you have activated the Use last closed time period option, the previous time period is shown.
For example: You have set a 30 minute filter. It is 10.45 when the function is activated. If the Use last closed time period option is deactivated, the filter is set to the current time period 10:30:00 to 10:59:59. If the option is activated, the filter is set to the previous time period of 10:00:00 to 10:29:59.


Time filter can be configured in Runtime

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Time filter -> Time filter can be configured in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Time filter can be configured in Runtime

With this method, you stipulate a time filter in the Editor. This can be amended in Runtime before execution. To create the filter:

  1. The screen must have Filter and Display filter buttons
  2. select the desired filter:
    • Absolute period of time
    • Relative period of time
  3. Select, in the Settings section, the option Propose current date/time
  4. The filter dialog is opened in Runtime with the current date and time


Lots

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Lots

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You configure the limitation of the display to certain lots in this tab.

The lot information is also applied to the existing time filter. If the lot filter is activated, a list of all configured lots that correspond to the configured time period is obtained from the archive server in Runtime in advance.

Filter

Settings for the application of the lot filter. Selection of one of the options:

  • No lot filter
  • Apply lot filter directly
  • Display lot selection dialog

Parameters

Description

No lot filter

Active: The lot filter is deactivated and cannot be configured. Filtering for lots is not carried out in Runtime.

Apply lot filter directly

Active: The filter configured here is applied in Runtime directly.

Display lot selection dialog

Active: The dialog for lot selection is shown in Runtime when:

  • Clicking on Filter or
  • screen switching, if the Offer this dialog in Runtime option has been activated (not available for each function/screen type)
    Note: The dialog is not shown on reloading.

Options can be pre-selected in the Editor.

Replace dialog in Runtime with screen

Not available if the Show lot selection dialog option has been selected.

Definition of a screen that is to be called up in Runtime instead of the lot selection dialog. Only time/lot filter screens are offered.

Click the ... button and the dialog opens to select a screen.

If the linked screen is not found in Runtime, a search is made for corresponding screens with specific names.

Relative lot selection

Only available for Extended Trend and faceplates and only if the option Display lot selection dialog has been activated. The Windows CE project property must be deactivated in the project properties.

  • Active: Enables several lots to be compared directly. Display always starts from the zero point.

Time

Configuration of the time filter for lot selection. Selection of one of the options:

  • No filter
  • Last lots
  • Use time filter from "Time" tab

Parameters

Description

No filter

Active: The time range set in the Time tab is not taken into account. All completed and current lots are displayed.

Last lots

Active: Input of the number of lots last concluded, according to what they should be filtered for. Input of the number in the number field or configuration via cursor keys.

The option allows the combination of both options Display current lots and Display completed lots.
Example: 3 lots are to be displayed, 2 are running and 10 have been completed. The following is shown: the two that are current and one that has been completed.

Attention: At least one of the two options Display current lots or Display completed lots must be activated. If both options have been deactivated, this corresponds to the No filter setting.

Note on compatibility: If the current lots or the combination of current and completed lots are selected and the project is compiled for a version before 7.11, the completed lots are shown in Runtime.

Display current lots

Active: The current lots are displayed.

Note: If the number of lots to be displayed is greater than the number of current lots, lots that have been completed are also shown until the set limit has been reached.
Example: 3 lots are to be displayed. 1 lot is running, 5 have been completed. The one current lot and two completed lots are displayed.

Display completed lots

Active: The completed lots are displayed.

Note: If the number of lots to be displayed is greater than the number of completed lots, lots that have been completed are also shown until the set limit has been reached.

Use time filter from "Time" tab

Active: Pre-filtering is carried out with the settings of the Time tab. The effective range of the filter can be amended within this time range. Select from drop-down list:

  • Start and end also outside filter limits: (Default)
    Lots can start before the start time configured in the Time filter and end after the configured end time.
  • Start and end only outside filter limits:
    Lots must start and end within the time points configured in the Time filter for the start and end.
  • Start also before filter limit:
    Lots can start before the start time configured in the Time filter and end after the configured end time.
  • End also after the filter limit:
    Lots can also end after the end time set in the time filter, but must start at or after the configured start time.
  • Adjust start and end to filter limits:
    Lots are cut to the time points configured in the Time filter for the start and end.

Archives

Configuration of filtering for archives. Selection of one of the options:

  • No filter
  • Static
  • From variable

Note: Only available for the following modules if the Apply lot filter directly option has been selected:

  • Archive revision
  • ETM
  • Report Generator
  • Report Viewer

Parameters

Description

No filter

Active: Filtering for archive names is not carried out.

Static

Active: Archives whose identification corresponds to the character string entered in the input field are filtered for.

Input of the archive identifications in the input field:

  • Several identifications are separated by a comma (,).
  • * or empty: All archives, no filter.

From variable

Active: The value of the variables linked here is applied as a filter for archive names in Runtime.

Click on button ... in order to open the dialog for selecting a variable.

Only available for all modules if the Apply lot filter directly option has been selected:

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.

If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for archive names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Names

Configuration of the filtering to names. Selection of one of the options:

  • No filter
  • Static
  • From variable

Parameters

Description

No filter

Active: Filtering for lot names is not carried out.

Static

Active: Lot names that correspond to the character string entered in the input field are filtered for.

Input of the lot name in the input field:

  • Several entries are separated by a pipe character (|).
  • * or empty: All lots of all displayed archives, no filter.

From variable

Active: The value of the variable linked here is applied as a filter for lot names in Runtime.

Click on the ... button to open the dialog for selecting a variable.

Not available if the option Apply lot filter directly has been selected.

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.
  • If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for lot names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


New dataset dialog

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> New dataset dialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To define a new data set:

  1. Define, in the screen switching, the RDL file on which it is based on a Report Viewer screen
  2. Click, in the Datasets section, on the New button
  3. The dialog to create the datasets is opened
  4. Select the data origin you want to assign
  5. Confirm the selection by clicking OK
  6. the dialog for configuring the defined type is opened

Parameters

Description

Data source

Selection of the data origin:

General

  • Alarm Message List
  • Chronological Event List
  • Archive values
  • Online values
  • Filter settings

Recipegroup Manager

  • RGM recipe data
  • RGM recipe value

Batch Control

  • Master recipe
  • Control recipe
  • Recipe screens
  • Matrix cells
  • PFC structure
  • Phases
  • Parameters
  • Transitions
  • Unit allocations
  • Operation instance

OK

Confirms selection and opens dialog for configuration of the type.

Cancel

Closes dialog without further configuration.

Help

Opens online help.


Datasets in the Report Viewer

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The settings for the different datasets depend on the type of data origin to be configured:

  • General
    • AML data
    • CEL data
    • Archive data
    • Online values
    • Filter settings
  • RGM
    • RGM recipe data
    • RGM recipe value
  • Batch Control
    • Master recipe
    • Control recipe
    • Recipe screens
    • Matrix cells
    • PFC structure
    • Phases
    • Parameters
    • Transitions
    • Unit allocations
    • Operation instance


AML data

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer -> AML data

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
AML data

Configuration of the AML file:

Parameters

Description

Dataset name

Name of the data set:

  • must not be empty
  • Must correspond exactly to the name of the data set in the RDL file
  • Must not contain any spaces or special characters

Maximum number

Maximum number of lines for the report.
If the report has more lines than defined here due to its filter criteria, the first n lines are output. n corresponds to the value entered.

Allowed values: 1 - 2000

Default: 1000

Time filter

Selection of the time filter from the drop-down list. Contains the time filter defined in the Report definition tab.

General tab

Settings for:

  • Variable filter
  • Type of alarms
  • Data origin
  • Alarm/event groups, alarm/event classes and alarm areas

For details see the Alarm administration manual, General chapter.

Text tab

Settings for the text filter.

For details see the Alarm administration manual, Text chapter.

Status tab

Data for evaluation of status bits.

For details see the Alarm administration manual, Status chapter.

Equipment modeling tab

Selection of the equipment model.

For details see the Equipment modeling manual, Equipment modeling dialog chapter.

OK

Applies settings and closes the dialog.

Cancel

Discards changes and closes the dialog.

Help

Opens online help.


CEL data

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer -> CEL data

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
CEL data

Configuration of the CEL files:

Parameters

Description

Dataset name

Name of the data set:

  • must not be empty
  • Must correspond exactly to the name of the data set in the RDL file
  • Must not contain any spaces or special characters

Maximum number

Maximum number of lines for the report.
If the report has more lines than defined here due to its filter criteria, the first n lines are output. n corresponds to the value entered.

Allowed values: 1 - 2000

Default: 1000

Time filter

Selection of the time filter from the drop-down list. Contains the time filter defined in the Report definition tab.

General tab

Settings for:

  • Variable filter
  • Data origin
  • Alarm/event groups, alarm/event classes and alarm areas

For details see the Chronological Event List manual, General chapter.

Text tab

Settings for the text filter.

For details see the Alarm administration manual, Text chapter.

Status tab

Data for evaluation of status bits.

For details see the Alarm administration manual, Status chapter.

Equipment modeling tab

Selection of the equipment model.

For details see the Equipment modeling manual, Equipment modeling dialog chapter.

OK

Applies settings and closes the dialog.

Cancel

Discards changes and closes the dialog.

Help

Opens online help.


Archive values

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer -> Archive values

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Archive values

Parameters

Description

Dataset name

Name of the data set:

  • must not be empty
  • Must correspond exactly to the name of the data set in the RDL file
  • Must not contain any spaces or special characters

Maximum number

Maximum number of lines for the report.
If the report has more lines than defined here due to its filter criteria, the first n lines are output. n corresponds to the value entered.

Allowed values: 1 - 2000

Default: 1000

Aggregation

type of aggregation:

  • limit Outputs the first n values per archive if the filter criteria would provide more entries than this number.
  • Sum: Time range is divided into n equidistant time intervals and the archive values in these are added up. Status values are ORed.
  • Average: Time range is divided into n equidistant time intervals and an average of the archive values in these is calculated. Status values are ORed.
  • Minimum: Time range is divided into n equidistant time intervals and the archive values in these are minimized.
  • Maximum: Time range is divided into n equidistant time intervals and the archive values in these are maximized.

The time stamp corresponds to the respective start time of the interval.

Time filter

Selection of the time filter from the drop-down list. Contains the time filter defined in the Report definition tab.

Archive - variable names

List of selected variables.

Add

Opens the dialog for selecting several variables.

Delete

Deletes selected variable from the list.

OK

Applies settings and closes the dialog.

Cancel

Discards changes and closes the dialog.

Help

Opens online help.


Online values

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer -> Online values

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Online values

Parameters

Description

Dataset name

Name of the data set:

  • must not be empty
  • Must correspond exactly to the name of the data set in the RDL file
  • Must not contain any spaces or special characters

Variables

List of selected variables with:

  • Name
  • Identification
  • Address
  • Project

Add

Opens the dialog for selecting several variables.

Delete

Deletes selected variable from the list.

OK

Applies settings and closes the dialog.

Cancel

Discards changes and closes the dialog.

Help

Opens online help.


Filter settings

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer -> Filter settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Filter settings

The data set displays the defined time filter and their use by other data sets. The following are displayed in the report:

  • Data set
  • Set filter
  • Filter conditions

Parameters

Description

Dataset name

Name of the data set:

  • must not be empty
  • Must correspond exactly to the name of the data set in the RDL file
  • Must not contain any spaces or special characters

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Help

Opens online help.


RGM recipe data

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer -> RGM recipe data

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
RGM recipe data

Configuration of the RGM recipe data:

Parameters

Description

Dataset name

Name of the data set:

  • must not be empty
  • Must correspond exactly to the name of the data set in the RDL file
  • Must not contain any spaces or special characters

OK

Applies settings and closes the dialog.

Cancel

Discards changes and closes the dialog.

Help

Opens online help.

Recipe filter

Configuration of the recipe filter

Parameters

Description

Project selection

Selection of the project for the recipe data from the drop-down list.

Recipe group

Selection of the recipe group.

The selection can take place:

  • Static from pre-defined entries (Static recipe group)
  • Dynamic via variable (Recipegroup name from variable)

Clicking on Property opens a drop-down list to select the method.

Selection of the group:

  • from drop-down list
  • Input of a filter text with wildcards (? for exactly one character and * for 0 to as many characters as desired)
  • Via a string variable: The text value of the variable is then interpreted as a group name or filter text with wildcards

Recipe

Selection of the recipe from the selected recipegroup.

The selection can take place:

  • Static from pre-defined entries (Static recipe)
  • Dynamic via variable (Recipe name from variable)

Clicking on Property opens a drop-down list to select the method.

Selection of the name:

  • from drop-down list
  • Input of a filter text with wildcards (? for exactly one character and * for 0 to as many characters as desired)
  • Via a string variable: The text value of the variable is then interpreted as a recipe name or filter text with wildcards

Recipe version static

Selection of the recipe version from the selected recipegroup.

The selection can take place:

  • Static from pre-defined entries (Static recipe version)
  • Dynamic via variable (Recipe version from variable)

Clicking on Property opens a drop-down list to select the method.

Select version:

  • Entry from the drop-down list:
    - Largest version
    - Smallest version
    - All
    - recipe versions (only available if the group and recipe selection results in an individual recipe; selection without wildcards)
  • Entering of a list of recipe versions, with the versions separated by commas (,), for example "1, 3, 5"
  • A string variable that provides a list of version numbers as a text separated by a comma (,)
  • A numerical variable with a version number (1 - 89999) or the values:
    - 90000 for "Smallest version"
    - 90001 for "Largest version"
    - 90002 for "all versions"

Recipe state static

Selection of the recipe status from the selected recipegroup.

The selection can take place:

  • Static from pre-defined entries (Static recipe status)
  • Dynamic via variable (Recipe status from variable)

Clicking on Property opens a drop-down list to select the method.

Selection of the status:

  • Entry from drop-down list:
    - All
    - individual recipe status
  • List of recipe status separated by comma (,) for example "1, 2, 7"
  • A string variable that provides a list of status numbers as a text separated by a comma (,)
  • A numeric value with a status number (1 - 4294967294; 0xFFFFFFFE) or the value
  • 0 for All

OK

Applies settings and closes the dialog.

Cancel

Discards changes and closes the dialog.

Help

Opens online help.

Possible combinations of recipe version and recipe status:

Version filter | Status filter | Result
Smallest version | All | Only the smallest respective versions of all recipes are shown.
Smallest version | 1,2 | Only the recipe versions that have the status 1 or 2 have the smallest versions shown.
Largest version | All | Only the largest respective versions of all recipes are shown.
Largest version | 1,2 | Only the recipe versions that have the status 1 or 2 have the largest versions shown.
All | All | All recipe versions are displayed.
All | 1,2 | All recipe versions with the status 1 or 2 are displayed.
2,3 | All | All recipe versions 2 and 3 are displayed regardless of status.
2,3 | 1,2 | The respective recipe version 2 and 3 is displayed if these have either the status 1 or 2.

You can read more about the RGM in the Recipegroup Manager manual.

Equipment modeling

Selection of an Equipment model.

Select the desired equipment model from the list or create a new equipment model.

Note: Equipment models are managed in the global project. A global project must be present here in order to be able to create a new equipment model.


RGM recipe value

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer -> RGM recipe value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
RGM recipe value

Configuration of the RGM recipe values. The visibility variables are evaluated for the output of recipe values. Only recipe values with the status visible are displayed in the Report Viewer:

Parameters

Description

Dataset name

Name of the data set:

  • must not be empty
  • Must correspond exactly to the name of the data set in the RDL file
  • Must not contain any spaces or special characters

OK

Applies settings and closes the dialog.

Cancel

Discards changes and closes the dialog.

Help

Opens online help.

Recipe filter

Configuration of the recipe filter

Parameters

Description

Project selection

Selection of the project for the recipe data from the drop-down list.

Recipe group

Selection of the recipe group.

The selection can take place:

  • Static from pre-defined entries (Static recipe group)
  • Dynamic via variable (Recipegroup name from variable)

Clicking on Property opens a drop-down list to select the method.

Selection of the group:

  • from drop-down list
  • Input of a filter text with wildcards (? for exactly one character and * for 0 to as many characters as desired)
  • Via a string variable: The text value of the variable is then interpreted as a group name or filter text with wildcards

Recipe

Selection of the recipe from the selected recipegroup.

The selection can take place:

  • Static from pre-defined entries (Static recipe)
  • Dynamic via variable (Recipe name from variable)

Clicking on Property opens a drop-down list to select the method.

Selection of the name:

  • from drop-down list
  • Input of a filter text with wildcards (? for exactly one character and * for 0 to as many characters as desired)
  • Via a string variable: The text value of the variable is then interpreted as a recipe name or filter text with wildcards

Recipe version static

Selection of the recipe version from the selected recipegroup.

The selection can take place:

  • Static from pre-defined entries (Static recipe version)
  • Dynamic via variable (Recipe version from variable)

Clicking on Property opens a drop-down list to select the method.

Select version:

  • Entry from the drop-down list:
    - Largest version
    - Smallest version
    - All
    - recipe versions (only available if the group and recipe selection results in an individual recipe; selection without wildcards)
  • Entering of a list of recipe versions, with the versions separated by commas (,), for example "1, 3, 5"
  • A string variable that provides a list of version numbers as a text separated by a comma (,)
  • A numerical variable with a version number (1 - 89999) or the values:
    - 90000 for "Smallest version"
    - 90001 for "Largest version"
    - 90002 for "all versions"

Recipe state static

Selection of the recipe status from the selected recipegroup.

The selection can take place:

  • Static from pre-defined entries (Static recipe status)
  • Dynamic via variable (Recipe status from variable)

Clicking on Property opens a drop-down list to select the method.

Selection of the status:

  • Entry from drop-down list:
    - All
    - individual recipe status
  • List of recipe status separated by comma (,) for example "1, 2, 7"
  • A string variable that provides a list of status numbers as a text separated by a comma (,)
  • A numeric value with a status number (1 - 4294967294; 0xFFFFFFFE) or the value
  • 0 for All

OK

Applies settings and closes the dialog.

Cancel

Discards changes and closes the dialog.

Help

Opens online help.

Possible combinations of recipe version and recipe status:

Version filter | Status filter | Result
Smallest version | All | Only the smallest respective versions of all recipes are shown.
Smallest version | 1,2 | Only the recipe versions that have the status 1 or 2 have the smallest versions shown.
Largest version | All | Only the largest respective versions of all recipes are shown.
Largest version | 1,2 | Only the recipe versions that have the status 1 or 2 have the largest versions shown.
All | All | All recipe versions are displayed.
All | 1,2 | All recipe versions with the status 1 or 2 are displayed.
2,3 | All | All recipe versions 2 and 3 are displayed regardless of status.
2,3 | 1,2 | The respective recipe version 2 and 3 is displayed if these have either the status 1 or 2.

You can read more about the RGM in the Recipegroup Manager manual.

Equipment modeling

Selection of an Equipment model.

Select the desired equipment model from the list or create a new equipment model.

Note: Equipment models are managed in the global project. A global project must be present here in order to be able to create a new equipment model.


datasets for Batch Control:

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer -> datasets for Batch Control:

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
datasets for Batch Control:

The following datasets are available for the Batch Control module:

  • Master recipe
  • Control recipe
  • Recipe screens
  • Matrix cells
  • PFC structure
  • Phases
  • Parameters
  • Transitions
  • Unit allocations
  • Operation instance


Master recipe

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer -> Master recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Master recipe

Configuration of a data set for a master recipe in the Batch Control module.

Parameters

Description

Data set name

Name of the data set:

  • must not be empty
  • Must correspond exactly to the name of the data set in the RDL file
  • Must not contain any spaces or special characters

OK

Applies settings and closes the dialog.

Cancel

Discards changes and closes the dialog.

Help

Opens online help.


Control recipe

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer -> Control recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Control recipe

Configuration of a data set for a control recipe in the Batch Control module.

Parameters

Description

Data set name

Name of the data set:

  • must not be empty
  • Must correspond exactly to the name of the data set in the RDL file
  • Must not contain any spaces or special characters

OK

Applies settings and closes the dialog.

Cancel

Discards changes and closes the dialog.

Help

Opens online help.


Recipe screens

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer -> Recipe screens

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Recipe screens

Configuration of a data set for recipe screens in the Batch Control module. For screens, in addition to the report detail, it is also possible to prescribe the display in Runtime.

General

Parameters

Description

Data set name

Name of the data set:

  • must not be empty
  • Must correspond exactly to the name of the data set in the RDL file
  • Must not contain any spaces or special characters

Profoundness of the report

Configuration of the report detail:

  • Complete: Report contains data from the whole recipe, including its operations.
  • Only main recipe levels: Report only contains data from the main recipe.
  • Only partial recipe levels: Report only contains data from the operations contained in the recipe

OK

Applies settings and closes the dialog.

Cancel

Discards changes and closes the dialog.

Help

Opens online help.

Representation

Parameters | Description
PFC view | Display for PFC recipes
Background color | Definition for the background color. Click on the color and a dialog opens to select a color or a palette.
Opacity | Setting of the opacity using a slider.
Display grid | Active: Grid is displayed.
Grid color | Definition for the grid color. Click on the color and a dialog opens to select a color or a palette.
Matrix view | Display for matrix recipes
Background color | Definition for the background color. Click on the color and a dialog opens to select a color or a palette.
Opacity | Setting of the opacity using a slider.
Grid color | Definition for the grid color. Click on the color and a dialog opens to select a color or a palette.
OK | Applies settings and closes the dialog.
Cancel | Discards changes and closes the dialog.
Help | Opens online help.


Matrix cells

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer -> Matrix cells

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Matrix cells

Configuration of a data set for the structure of a matrix recipe in the Batch Control module.

Parameters

Description

Date set name

Name of the data set:

  • must not be empty
  • Must correspond exactly to the name of the data set in the RDL file
  • Must not contain any spaces or special characters

Profoundness of the report

Configuration of the report detail:

  • Complete: Report contains data from the whole recipe, including its operations.
  • Only main recipe levels: Report only contains data from the main recipe.
  • Only partial recipe levels: Report only contains data from the operations contained in the recipe

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Help

Opens online help.


PFC structure

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer -> PFC structure

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
PFC structure

Configuration of a data set for the structure of a PFC recipe in the Batch Control module.

Parameters

Description

Data set name

Name of the data set:

  • must not be empty
  • Must correspond exactly to the name of the data set in the RDL file
  • Must not contain any spaces or special characters

Profoundness of the report

Configuration of the report detail:

  • Complete: Report contains data from the whole recipe, including its operations.
  • Only main recipe levels: Report only contains data from the main recipe.
  • Only partial recipe levels: Report only contains data from the operations contained in the recipe

OK

Applies settings and closes the dialog.

Cancel

Discards changes and closes the dialog.

Help

Opens online help.


Phases

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer -> Phases

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Phases

Configuration of a data set for phases in the Batch Control module.

Parameters

Description

Data set name

Name of the data set:

  • must not be empty
  • Must correspond exactly to the name of the data set in the RDL file
  • Must not contain any spaces or special characters

Profoundness of the report

Configuration of the report detail:

  • Complete: Report contains data from the whole recipe, including its operations.
  • Only main recipe levels: Report only contains data from the main recipe.
  • Only partial recipe levels: Report only contains data from the operations contained in the recipe

OK

Applies settings and closes the dialog.

Cancel

Discards changes and closes the dialog.

Help

Opens online help.


Parameters

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer -> Parameters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Parameters

Configuration of a data set for parameters in the Batch Control module.

Parameters

Description

Data set name

Name of the data set:

  • must not be empty
  • Must correspond exactly to the name of the data set in the RDL file
  • Must not contain any spaces or special characters

Profoundness of the report

Configuration of the report detail:

  • Complete: Report contains data from the whole recipe, including its operations.
  • Only main recipe levels: Report only contains data from the main recipe.
  • Only partial recipe levels: Report only contains data from the operations contained in the recipe

OK

Applies settings and closes the dialog.

Cancel

Discards changes and closes the dialog.

Help

Opens online help.


Transitions

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer -> Transitions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Transitions

Configuration of a data set for transitions in the Batch Control module.

Parameters

Description

Data set name

Name of the data set:

  • must not be empty
  • Must correspond exactly to the name of the data set in the RDL file
  • Must not contain any spaces or special characters

Profoundness of the report

Configuration of the report detail:

  • Complete: Report contains data from the whole recipe, including its operations.
  • Only main recipe levels: Report only contains data from the main recipe.
  • Only partial recipe levels: Report only contains data from the operations contained in the recipe

OK

Applies settings and closes the dialog.

Cancel

Discards changes and closes the dialog.

Help

Opens online help.


Unit allocations

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer -> Unit allocations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Unit allocations

Configuration of a data set for unit allocation in the Batch Control module.

Parameters

Description

Data set name

Name of the data set:

  • must not be empty
  • Must correspond exactly to the name of the data set in the RDL file
  • Must not contain any spaces or special characters

Configuration of the report detail:

  • Complete: Report contains data from the whole recipe, including its operations.
  • Only main recipe levels: Report only contains data from the main recipe.
  • Only partial recipe levels: Report only contains data from the operations contained in the recipe

OK

Applies settings and closes the dialog.

Cancel

Discards changes and closes the dialog.

Help

Opens online help.


Operation instance

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Screen switching to a Report Viewer screen -> Datasets in the Report Viewer -> Operation instance

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Operation instance

Configuration of a data set for operation instances in the Batch Control module.

Parameters

Description

Data set name

Name of the data set:

  • must not be empty
  • Must correspond exactly to the name of the data set in the RDL file
  • Must not contain any spaces or special characters

OK

Applies settings and closes the dialog.

Cancel

Discards changes and closes the dialog.

Help

Opens online help.


Export or print function report

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Export or print function report

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the Report Viewer: export / print function, reports can be evacuated in Runtime, to their own thread as a PDF or as an online-printout. Because the rendering of the file is asynchronous, it ensures that Runtime can continue to be operated during rendering. The execution of functions of a low priority is however blocked until the Report Viewer has completed rendering. Output as a PDF or printout can alternatively be carried out by means of control elements in the screen, whereby the operability of Runtime can be restricted until the end of the output.

To create the function:

  1. Select the New function... command in the Functions node
  2. The function selection is opened.

  3. navigate to node Report Generator / Report Viewer / Analyzer
  4. Select the Report Viewer: export / print function
  5. The dialog for configuration is opened
  6. Details on the configuration of the dialog:
    • As a PDF: see Configure output as a PDF section
    • To the printer: see Configure output to the printer section
    • Report definition: see Report definition chapter, Screen switching to Report Viewer type screen


Configure output as PDF

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Export or print function report -> Configure output as PDF

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To output the report as a PDF:

  1. For the Report output option, select Output as PDF
  2. Define a fixed filename or select a variable that defines the filename in Runtime.
  3. Decide whether the existing data is to be overwritten
  4. Confirm your configuration by clicking on the OK button

Parameters

Description

Put out report

Selection of how the report is to be output from a drop-down list:

  • Output as PDF: Creates PDF according to the configuration
  • Output on printer: Outputs the report via the defined printer.

Save PDF as

Selection of the issuing of the file name from a drop-down list:

  • File name static: Name is entered in the text field and selected from the file Explorer after clicking on the ... button.
  • File name from variable: Clicking on the ... button opens the dialog to select a variable that sends the filename for the report in Runtime.

Composition of the static filename:

For static file names, the components of the name are compiled using placeholders:

  • <ProjectName>: Name of the project
  • <DateTime>: Date and time in accordance with system settings
  • <Date>: Date in accordance with system settings
  • <Time>: Time in accordance with system settings

The placeholders can also be inserted into the text field by right-clicking on the text field above the context menu at the current cursor position.

The file name can be given as either an absolute path or as a relative path (relative to the export folder of the project).

Save location for PDFs:

As in the folder defined for export.
Standard path: %PUBLIC%\Documents\zenon_Projects\[PROJECTNAME]>\Export

Overwrite existing file

Active: Existing files in the save location are overwritten.

OK

Accepts changes in all tabs and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Help

Opens online help.


Configure output to the printer

Manual -> Reporting -> Report Viewer -> Engineering in the Editor -> Export or print function report -> Configure output to the printer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure the report for a printer:

  1. For the Report output option, select Output to printer
  2. Confirm your configuration by clicking on the OK button

Parameters

Description

Put out report

Selection of how the report is to be output from a drop-down list:

  • Output as PDF: Creates PDF according to the configuration
  • Output on printer: Outputs the report via the defined printer.

OK

Accepts changes in all tabs and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Help

Opens online help.


Report definition files

Manual -> Reporting -> Report Viewer -> Report definition files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Report definition files (RDL) must be type 2 files in order to be able to be used in the zenon Report Viewer. Type 3 RDL files can be displayed, however features that are not present in version 2 are displayed as an empty space.

To create your own datasets or edit existing ones, you need appropriate software to render the RDL files. You have the following options for this:

  • SQL Server Data Tool (SSDT):

    Is supplied by COPA-DATA from zenon 7.10 and also installed when installing zenon.

    SSDT consists of Microsoft Visual Studio 2010 with other project types that are only available for SQL Server Business Intelligence and is the primary environment for business services projects such as reporting. Templates for creating objects necessary for the Business Intelligence solution are provided as well as designer, tools and assistants for processing these objects.

    When calling up an RDL file to edit with SSDT, a selection window to set the environment setting for Visual Studio 2010 may be shown:

    Select the Business Intelligence Settings options and click on the Start Visual Studio button.

  • Microsoft Report Builder 2.0:

    Is available on the Microsoft download page as a download. It provides a wizard for the configuration of datasets and is recommended for users without special knowledge for the configuration of RDL files.
    Attention: Note the licensing conditions before downloading.
    Users of the zenon Analyzer already have Report Builder 3 and the SQL license required for the Report Builder. However, Report Builder 2 must be installed and used for editing the datasets of the Report Viewer.

  • Software from other suppliers:

    Software from other manufacturers can also be used to edit report definition files.

If both the MS Report Builder and the Microsoft SQL Server Data Tools are installed, you can select the desired tool in a dialog.

attention Attention

Note:

  • RDL files should always be created and edited with the same tool.
  • RDL versions 2 and 3 must not be mixed.
  • If an RDL file was saved with SSDT, it can no longer be edited with the MS Report Builder 2.0.

Data source

The properties for the data source (superordinate to the datasets) must not be changed.

The standard settings are:

Parameters | Description
Name | DataSource1
Connection | Use a connection embedded in my report
Select connection type | XML

Editing of RDL files in projects with distributed engineering

Note, when editing RDL files with distributed engineering, that files are not automatically set to "Allow changes" (checkout) when opened.

  • It is possible to open RDL files with the SSDT or the MS Report Builder, to edit these and save changes locally, without the file being set to "Check out". These changes can however be accepted on the server and are thus lost again when synchronizing or with Check out. The older version of the server is automatically adopted.
  • It is also possible to open an RDL file that has been set to "Check out" on another computer, to edit this and to save changes locally. The file is not write protected when setting "Check out". These local changes are also overwritten again when synchronizing.

To save changes on a lasting basis, the RDL file must be set to "Check out" before opening.

attention Attention

RDL files may only be renamed in the zenon Editor.

If RDL files are renamed in SSDT or MS Report Builder, the new name is not taken on in projects with distributed engineering and changes are lost.


Configuring data sets for a new report

Manual -> Reporting -> Report Viewer -> Report definition files -> Configuring data sets for a new report

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a new RDL file with the previously-defined data sets:

  1. Navigate to the Files/Report Viewer node.
  2. Select the New report definition file command in the context menu or in the toolbar of the detail view.
  3. The dialog to select and configure the datasets for the report is opened
  4. Configure the desired datasets,
  5. Close the dialog and start MS Report Builder by clicking on the OK button.
  6. Configure the RDL files in the Report Builder and save them.

Select Data sets dialog for report

Parameters | Description
Available datasets | Lists all datasets available. Click on the > button or double click on a data set to insert a new data set of the selected type into the Selected datasets list.
Button > | Inserts a new dataset of the selected type into the Selected datasets list.
Selected datasets | Lists all configured datasets. Keyboard operation: F2 … rename the selected dataset Del … delete the selected dataset
Rename | Makes it possible to rename the selected data set (keyboard: F2). The name of the data set must be unique. A change is only accepted if the name remains unique.
Remove | The selected dataset is deleted (keyboard: Del).
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Creating and editing RDL files with MS Report Builder 2.0

Manual -> Reporting -> Report Viewer -> Report definition files -> Creating and editing RDL files with MS Report Builder 2.0

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

MS Report Builder is available on the Microsoft download page as a free download.
Attention: Note the licensing conditions before downloading.
Users of the zenon Analyzer already have Report Builder 3 and the SQL license required for the Report Builder. However, Report Builder 2 must be installed and used for editing the datasets of the Report Viewer.

Install the Report Builder and check if it is correctly linked to zenon.

Creating an RDL file

To create an RDL file:

  1. Select, in the zenon Editor, in the File/Report Viewer node in the context menu or the New report definition file command in the toolbar. The dialog to configure the desired data sets is opened.
  2. MS Report Builder is started as soon as you confirm the dialog with OK:

  3. Adapt the datasets to the configuration in the screen switching function by:
    • Rename: Datasets must be identical with the dataset names in screen switching
    • Delete: Datasets that do not have any corresponding linking in the screen switching and are thus not supplied with data lead to an error message in Runtime
    • Create new: Datasets that are configured in the screen switching but do not have any corresponding entries in the RDL file lead to an error message in Runtime.
  4. Select, in the Insert menu, the command Table -> Table Wizard.
  5. The wizard is started.
  6. Select the desired dataset.

  7. Locate the fields as desired.

  8. Click on Next and select the layout.

  9. Click on Next and select the style of the display.

  10. Click on Finish.
    The dataset is displayed with the finished table

  11. Delete the sample table.
  12. Place the newly created table at the desired location.
  13. Adapt the heading as desired.

  14. Repeat the process for all datasets to be configured.
  15. Save the RDL file.

Result in Runtime:

Editing an RDL file

To edit an RDL file, double click the file or select the Open report definition file command. Use the same process as creation for editing.


Administering datasets

Manual -> Reporting -> Report Viewer -> Report definition files -> Creating and editing RDL files with MS Report Builder 2.0 -> Administering datasets

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can do the following with datasets in the Report Builder:

  • Rename
  • delete
  • create new

Number and name of the dataset of an RDL file must always correspond to that of the dataset defined in screen switching.

attention Attention

Note:

  • The data source must not be edited.
  • The data sets must not be edited.

Renaming a dataset

To rename a data set:

  1. Right-click on the data set
  2. Select the Properties command in the context menu
  3. The dialog for setting the properties of the data set is opened
  4. Give it the desired name in the Name property

    Note: the name must correspond to the name in the screen switching. It must not contain any spaces or special characters.

  5. Leave the other settings unchanged
  6. Close the dialog by clicking on OK.

Deleting the data set

To delete a data set:

  1. Highlight the data set to be deleted in the report data window below the data source

  2. Select the Delete command in the context menu
  3. the data set is deleted after confirmation is requested

Creating a new data set

To create a new data set:

  1. Right-click on the data source
  2. Select Add dataset in the context menu

  3. A new data set is created and the properties window is opened

  4. name it as you wish

    Note: the name must correspond to the name in the screen switching. It must not contain any spaces or special characters.

  5. Insert the appropriate query; you have three options for doing this:
    1. Query Designer: Opens the dialog for manual input of the query
    2. Import: Import from an existing RDL file
    3. Copying manually from an existing dataset: First open the corresponding source dataset, copy the content of the query and paste the content of the query in the Query field in the new dataset
  6. Close the dialog by clicking on OK.

Importing a query

To import a query from an existing RDL file:

  1. Click on the Import bin the dataset properties dialog
  2. The file selection assistant is opened
  3. Search for and open the desired RDL file
  4. The import dialog is displayed

  5. Highlight the desired dataset

  6. click on Import
  7. The query of the source data set is pasted to the dataset that is currently open


Create and edit RDL files with the help of the Microsoft Business Intelligence Development Studio

Manual -> Reporting -> Report Viewer -> Report definition files -> Create and edit RDL files with the help of the Microsoft Business Intelligence Development Studio

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Microsoft Business Intelligence Development Studio is shipped and installed together with zenon.

To create and edit RDL files with the help of the Microsoft Business Intelligence Development Studio, you basically act the same way as with the Report Builder 2.0.

The differences are primarily:

  • For the report to be edited, you must first create a new project of type Report Server Project - Solution - in the Microsoft Business Intelligence Development Studio.
    They are created automatically when you open the RDL file via double click. When closing the Business Intelligence Development Studios you can save the project and the solution in the temporary folder. If you do this, you are no longer requested to do so.
    The datasets and the report can now be edited in Microsoft Business Intelligence Development Studio.
  • There is no table wizard in the Microsoft Business Intelligence Development Studio; the tables of the datasets must be configured manually.
  • The version is not checked:
    This way, features from version 3 can be added to RDL files from version 2. These are not displayed in Runtime however.
  • In the Microsoft Business Intelligence Development Studio the datasets are separated from the data sources. The data source must not be changed.

Instruction

For a comprehensive guide about the use of the Microsoft Business Intelligence Development Studios see the Microsoft website in several languages:

Language | Link
English: | http://msdn.microsoft.com/en-en/library/ms173767.aspx
German: | http://msdn.microsoft.com/de-de/library/ms173767.aspx
French: | http://msdn.microsoft.com/fr-fr/library/ms173767.aspx
Italian: | http://msdn.microsoft.com/it-it/library/ms173767.aspx

Delete datasets

Unused datasets must be deleted in the Microsoft Business Intelligence Development Studio as they may cause errors in the Runtime.

To delete datasets:

  1. click on View
  2. select Report Data
  3. navigate to Datasets
  4. delete all unused datasets

Display dataset window

If the Dataset window is not displayed, it can be called up with the following steps:

  • Select report
  • Click on the View menu in the main menu
  • Scroll to the end of the list
  • Select Report Data
    Note: If the menu item is not displayed, then no report was selected.

Alternatively, the key combination Ctrl+ALT+D can be pressed after selecting the report.


Definition of datasets

Manual -> Reporting -> Report Viewer -> Report definition files -> Definition of datasets

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The columns of the dataset types are stipulated.

Definition of datasets for:

  • AML
  • CEL
  • Archive
  • Online
  • Filter settings
  • RGM
    • RGM recipe data
    • RGM recipe value
  • Batch Control
    • Master recipe
    • Control recipe
    • Recipe screens
    • Matrix cells
    • PFC structure
    • Phases
    • Parameters
    • Transitions
    • Unit allocations
    • Operation instance

Note: If zenon Analyzer reports are to be reused in the Report Viewer, the following applies:

  • Language-switchable texts have already had the language switched
  • Unit-switchable values are given in conversion units
  • Time stamps correspond to the local time of the executing computer

info Information

When the report is created for the first time, the sequence of data fields is checked using the naming. This establishes which dataset it might be. However the number of data fields may vary. This can lead to a dataset being interpreted incorrectly.

For example: A data set with just one field with the name PROJECT can be interpreted as a data set for AML, CEL, archive or online data, because all these data sets start with a field called PROJECT.


AML

Manual -> Reporting -> Report Viewer -> Report definition files -> Definition of datasets -> AML

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column name | Data type | Description
PROJECT | STRING | Name of the project.
VARIABLE | STRING | Name of the variable.
IDENTIFICATION | STRING | Identification of the variable.
TEXT | STRING | Entry text.
TIMECOMES | DATE | Time when the alarm occurs.
TIMEGOES | DATE | Time.
TIMEACKN | DATE | Time of acknowledgement.
TIMEREACT | DATE | Time of reactivation.
COUNTREACT | INTEGER | Number of reactivations.
STATEREACT | INTEGER | Status of reactivation.
STATUSFLAGS | INTEGER | Status bits.
VALUE | FLOAT | Value of the variables.
UNIT | STRING | Unit.
COMMENT | STRING | User comments.
CLASS | STRING | Alarm/Event class
GROUP | STRING | Alarm/Event group...
USER | STRING | name of the user.
COMPUTER | STRING | Name of the computer.
RESSOURCESLABEL | STRING | Resources label.


CEL

Manual -> Reporting -> Report Viewer -> Report definition files -> Definition of datasets -> CEL

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column name | Data type | Description
PROJECT | STRING | Name of the project.
VARIABLE | STRING | Name of the variable.
IDENTIFICATION | STRING | Identification of the variable.
TEXT | STRING | Entry text.
TIMECOMES | STRING | Time when the event occurs.
STATUSFLAGS | INTEGER | Status bits.
VALUE | FLOAT | Value of the variables.
UNIT | STRING | Unit.
COMMENT | STRING | User comments.
CLASS | STRING | Alarm/Event class
GROUP | STRING | Alarm/Event group...
USER | STRING | name of the user.
COMPUTER | STRING | Name of the computer.
RESSOURCESLABEL | STRING | Resources label.


Archive

Manual -> Reporting -> Report Viewer -> Report definition files -> Definition of datasets -> Archive

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column name | Data type | Description
PROJECT | STRING | Name of the project.
ARCHIVE | STRING | Name of the archive.
VARIABLE | STRING | Name of the variable.
IDENTIFICATION | STRING | Identification of the variable.
CHANNELSPEC | STRING | Variable including type of data reduction.
TIMESTAMP | STRING | Time stamp.
STATUSFLAGS | INTEGER | Status bits.
VALUE | FLOAT | Value of the variables.
UNIT | STRING | Unit.
STRVALUE | STRING | Value as string.
RESSOURCESLABEL | STRING | Resources label.


Online

Manual -> Reporting -> Report Viewer -> Report definition files -> Definition of datasets -> Online

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column name | Data type | Description
PROJECT | STRING | Name of the project.
VARIABLE | STRING | Name of the variable.
IDENTIFICATION | STRING | Identification of the variable.
TIMESTAMP | STRING | Time stamp.
STATUSFLAGS | INTEGER | Status bits.
VALUE | FLOAT | Value of the variables.
UNIT | STRING | Unit.
STRVALUE | STRING | Value as string.
RESSOURCESLABEL | STRING | Resources label.


Filter settings

Manual -> Reporting -> Report Viewer -> Report definition files -> Definition of datasets -> Filter settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column name | Data type | Description
DataSet | STRING | Data set used, such as AML.
FilterType | STRING | Type of filter, such as time.
FilterData | STRING | Filter setting, such as T: Rel:0d, 1h, 0m, 0s;


RGM recipe data

Manual -> Reporting -> Report Viewer -> Report definition files -> Definition of datasets -> RGM recipe data

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column name | Data type | Description
PROJECTNAME | STRING | Name of the project.
GROUPNAME | STRING | Name of the recipe group.
NAME | STRING | Recipe name.
NUMBER | UINT | Recipe number.
STATUSNUMBER | UINT | Status number
STATUSTEXT | STRING | Status text.
VERSION | UINT | Version.
COMMENT1 | STRING | Comment 1
COMMENT2 | STRING | Comment 2
COMMENT3 | STRING | Comment 3
COMMENT4 | STRING | Comment 4
COMMENT5 | STRING | Comment 5
COMMENT6 | STRING | Comment 6
COMMENT7 | STRING | Comment 7
COMMENT8 | STRING | Comment 8
USERLEVEL | UINT | User authorization.
CHANGETIME | DATETIME | Time of the change.
CHANGEUSER | STRING | User that was logged in when the change was made.


RGM recipe value

Manual -> Reporting -> Report Viewer -> Report definition files -> Definition of datasets -> RGM recipe value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column name | Data type | Description
PROJECTNAME | STRING | Name of the project.
GROUPNAME | STRING | Name of the recipe group.
NAME | STRING | Recipe name.
VERSION | UINT | Version.
RESSOURCESLABEL | STRING | Resources label.
VARIABLENAME | STRING | Variable name.
VARIABLETAG | STRING | Variable identification.
SYMBOLVALUE | STRING | Symbolic address for variable.
VALUE | STRING | value.
UNIT | STRING | Unit.
MIN | DOUBLEWORD | Minimum value.
MAX | DOUBELWORD | Maximum value.
ACTION | STRING | RGM recipe action to be executed.
FILTER | STRING | Recipe variable filter.


Master recipe

Manual -> Reporting -> Report Viewer -> Report definition files -> Definition of datasets -> Master recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column name | Data type | Description
MrId | INTEGER | ID of the recipe.
MrName | STRING | Name of the recipe.
MrDescription | STRING | Description of the recipe.
MrStatus | STRING | Status of the recipe
RecipeType | STRING | Type of the recipe.
ReeStatus | STRING | Status of the REE.
ReeModus | STRING | Mode of the REE.
ApprovalTime | DATE | Time when the recipe was approved.
ApprovalUserID | STRING | ID of the user who approved the master recipe.
ApprovalUserName | STRING | Name of the user who approved the master recipe.
OutdatedTime | DATE | Time when the recipe was set to "obsolete".
OutdatedUserID | STRING | ID of the user who set the recipe to "obsolete".
OutdatedUserName | STRING | Name of the user who set the recipe to "obsolete".
MrVersion | STRING | Version of the master recipe.
MrSourceVersion | STRING | Version of the template source recipe.


Control recipe

Manual -> Reporting -> Report Viewer -> Report definition files -> Definition of datasets -> Control recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column name | Data type | Description
CrId | INTEGER | ID of the control recipe.
CrName | STRING | Name of the control recipe.
CrDescription | STRING | Description of the control recipe.
CrStatus | STRING | Status of the control recipe.
MrId | INTEGER | ID of the master recipe.
MrName | STRING | Name of the master recipe.
MrDescription | STRING | Description of the master recipe.
MrStatus | STRING | Status of the master recipe.
RecipeType | STRING | Type of the recipe.
ReeStatus | STRING | Status of the REE.
ReeModus | STRING | Mode of the REE.
CrJobID | STRING | Job ID of the control recipe
ApprovalTime | DATE | Time when the master recipe was approved
ApprovalUserID | STRING | ID of the user who approved the master recipe.
ApprovalUserName | STRING | Name of the user who approved the master recipe.
CreationTime | DATE | Time of creation of the control recipe.
CreationUserID | STRING | ID of the user who created the master recipe.
CreationUserName | STRING | Name of the user who created the master recipe.
StartingTime | DATE | Time when the recipe was started
StartingUserID | STRING | ID of the user who started the master recipe.
StartingUserName | STRING | Name of the user who started the recipe.
OutdatedTime | DATE | Time when the master recipe was set to "obsolete".
OutdatedUserID | STRING | ID of the user who set the master recipe to "obsolete".
OutdatedUserName | STRING | Name of the user who set the master recipe to "obsolete".
MrVersion | STRING | Version of the master recipe.
MrSourceVersion | STRING | Version of the template source recipe.


Recipe screens

Manual -> Reporting -> Report Viewer -> Report definition files -> Definition of datasets -> Recipe screens

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column name | Data type | Description
Name | STRING | Name of the recipe.
Description | STRING | Description of the recipe.
RecipePart | STRING | Master recipe, control recipe or operation instance
OperationTemplateID | INTEGER | ID of the Operation template.
Type | STRING | Type of the recipe: PFC recipe or matrix recipe.
ImagePNG | STRING | Screenshot of the recipe Must be created especially.

Creating a screen

  1. Insert a new screen in the Report Builder.
  2. Set the source to Database.
  3. Enter, for the Use this field: property, ImagePNG.
  4. Enter, for the MIME type property: image/png.
  5. Insert the screen using the Insert option or by dragging & dropping in the report.
  6. In the Size property, adjust the size to Original Size.
  7. If necessary, amend the Padding property for the distance from the screen to the cell borders.


Matrix cells

Manual -> Reporting -> Report Viewer -> Report definition files -> Definition of datasets -> Matrix cells

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column name | Data type | Description
StepNr | INTEGER | Number of the Step.
StepDescr | STRING | Description of the Step.
ObjectID | INTEGER | ID of the object in the recipe.
ObjectName | STRING | Name of the object in the recipe.
ObjectDescr | STRING | Description of the object in the recipe.
ObjectType | STRING | Type of object in the recipe. (phase, transition, ...)
ObjectUnit | STRING | Unit of the object.
OperationTemplateID | INTEGER | ID of the Operation template. 0 = main recipe.
OperationTemplateName | STRING | Name of the Operation template. empty = main recipe.


PFC structure

Manual -> Reporting -> Report Viewer -> Report definition files -> Definition of datasets -> PFC structure

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column name | Data type | Description
ChartRow | INTEGER | Rung in the recipe.
ChartCol | INTEGER | Column in the recipe.
ObjectID | INTEGER | ID of the object in the recipe.
ObjectName | STRING | Name of the object in the recipe.
ObjectDescr | STRING | Description of the object in the recipe.
ObjectType | STRING | Type of object in the recipe. (phase, transition, ...)
ObjectUnit | STRING | Unit of the object.
PrevIds | STRING | IDs of the previous objects.
NextIds | STRING | IDs of the following objects.
PrevNames | STRING | Names of the previous objects.
NextNames | STRING | Names of the following objects.
PrevTypes | STRING | Types of the previous objects.
NextTypes | STRING | Types of the following objects.
CellsSpan | STRING | Number of columns used (width of the object).
OperationTemplateID | INTEGER | ID of the Operation template. 0 = main recipe.
OperationTemplateName | STRING | Name of the Operation template. empty = main recipe.


Phases

Manual -> Reporting -> Report Viewer -> Report definition files -> Definition of datasets -> Phases

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column name | Data type | Description
ObjectID | INTEGER | ID of the object in the recipe.
ChartRow | INTEGER | Lines in which the phase is located in the recipe.
ChartCol | INTEGER | Column in which the phase is located in the recipe.
PhaseName | STRING | Name of the phase.
PhaseDescr | STRING | Description of the phase.
UnitID | INTEGER | ID of the unit.
UnitName | STRING | Name of the unit.
UnitDescr | INTEGERSTRING | Description of the unit.
OperationInstID | INTEGER | ID of the operation instance in which the phase is located in the recipe.
OperationInstName | STRING | Name of the operation instance in which the phase is located in the recipe.
TOAllocation | STRING | Waiting period unit allocation.
TOInterlocking | STRING | Waiting period of the interlocking.
MinExecTime | STRING | Minimum execution time.
ExplanationMinExecTimeNeeded | BOOL | Reason for changing the minimum execution time necessary.
MaxExecTime | STRING | Maximum execution time.
TOFollowingCond | STRING | Waiting period for Following condition.
CondInterlocking | STRING | Interlocking condition.
CondDone | STRING | Condition for ended.
CondFailure | STRING | Condition for loss of communication.
CondPausing | STRING | Condition for pause.
CondHolding | STRING | Condition for holding.
CondStopping | STRING | Condition for stop.
CondAborting | STRING | Condition for abort.
CondRestarting | STRING | Condition for restart.
CondEscaping | STRING | Escape condition.
CondConnReconnect | STRING | Condition for communication reestablished.
CondPlcError | STRING | Condition for PLC error.
CSName | STRING | Name of the control strategy.
CSDescription | STRING | Description of the control strategy.
CSTag | STRING | Parameter of the control strategy.
ActiveCSNumber | INTEGER | Number of active control strategies.


Parameters

Manual -> Reporting -> Report Viewer -> Report definition files -> Definition of datasets -> Parameters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column name | Data type | Description
TagName | STRING | Name of the TAG.
TagDescr | STRING | Description of the tag.
TagType | STRING | Type of the tag.
TagValue | STRING | Name of the tag.
MeasUnit | STRING | Measuring unit
ValueMin | STRING | Minimum value.
ValueMax | STRING | Maximum value.
EditableInRecipe | BOOL | States if editable in the recipe.
EditableInCr | BOOL | States if editable in the control recipe.
ExplanationNeeded | BOOL | States if a reason for change is necessary.
TagModified | BOOL | States if a parameter was changed.
Variable | STRING | Name of the tag.
DataType | STRING | Data type of the variable.
PhaseID | INTEGER | ID of the phase.
PhaseName | STRING | Name of the phase.
OperationInstID | INTEGER | ID of the operation instance.
OperationInstName | STRING | Name of the operation instance.


Transitions

Manual -> Reporting -> Report Viewer -> Report definition files -> Definition of datasets -> Transitions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column name | Data type | Description
ObjectID | INTEGER | ID of the transition in the recipe.
ChartRow | INTEGER | Row of the recipe.
ChartCol | INTEGER | Column of the recipe.
Condition | STRING | Condition for the transition.
OperationInstID | INTEGER | ID of the operation instance in which the transition is located.
OperationInstName | STRING | name of the operation instance in which the transition is located.


Unit allocations

Manual -> Reporting -> Report Viewer -> Report definition files -> Definition of datasets -> Unit allocations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column name | Data type | Description
ObjectID | INTEGER | ID of the unit allocation in the recipe.
ChartRow | INTEGER | Row of the recipe.
ChartCol | INTEGER | Column of the recipe.
AllocationData | STRING | Unit allocation and number of the units allocated.
OperationInstID | INTEGER | ID of the operation instance in which the unit allocation is located.
OperationInstName | STRING | Name of the operation instance in which the unit allocation is located.


Operation instance

Manual -> Reporting -> Report Viewer -> Report definition files -> Definition of datasets -> Operation instance

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column name | Data type | Description
ObjectID | INTEGER | ID of the operation instance in the recipe.
ChartRow | INTEGER | Row of the recipe.
ChartCol | INTEGER | Column of the recipe.
OperationName | STRING | Name of the operation.
OperationDescr | STRING | Description of the operation.
OperationType | STRING | Recipe type: PFC recipe or matrix recipe.
OperationTemplateID | INTEGER | ID of the Operation template.


Operating during Runtime

Manual -> Reporting -> Report Viewer -> Operating during Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

the Report Viewer screen is switched to in Runtime with a screen switching function. Depending on the configured report definition, reports for AML, CEL, archives and online values can be displayed. You can also do the following with these reports, if the corresponding functions are configured:

  • Update: Reload report definition and data and display report
  • Print: on the printer defined for values and logs
  • Export: as a PDF file to the defined export folder

Parameters | Description
Refresh | Reloads the report definition and the data and displays the report with the updated data. After the report file in the Editor has been changed, the screen must be called up again; a reload is not sufficient.
Print | Prints the report on the printer defined for values and logs. Note: The printout can also be evacuated to its own thread. This ensures that Runtime can be operated during printing.
Create PDF | Saves the report currently being displayed as a PDF file in the folder defined for export. Standard path: %PUBLIC%\Documents\zenon_Projects\[PROJECTNAME]>\Export Note: The PDF creation can also be evacuated to its own thread. This ensures that Runtime can be operated during the creation and export.
Report list | Displays the reports defined in the screen switching function. The list can be searched. Long lists are broken up into several pages.

Navigation, zoom and search

The report header offers elements for:

  • Navigation
  • Zoom
  • Search

Parameters

Description

Page navigation

Displays number of pages and current page. Enables navigation in the document by means of

  • Cursor keys
  • Selection of a particular page

Zoom

Selection of a zoom level from a drop-down list:

  • Page Width
  • Whole Page
  • 500%
  • 200%
  • 150%
  • 100% (default)
  • 75 %
  • 50 %
  • 25%

Search

Input of a search term in the search field.

  • Find: Displays the first place of finding
  • Next: Navigates to further places of finding

Wildcards cannot be used.


Troubleshooting

Manual -> Reporting -> Report Viewer -> Troubleshooting

Error messages in pop-ups

Error message | Meaning
DataTable missing for DataSet: <DatasetName> | A dataset is used in the report definition, but there is no table with this name in the configuration. The report cannot be displayed.
DataSet not used for DataTable: <TableName> | A table was defined, but the report definition does not use this name for a dataset. This message is only given after a missing table has been established.


Runtime help

Manual -> Runtime help

zenon offers the possibility to create a context-sensitive help for projects running in the Runtime. This Runtime-Help is based on HTML-Pages that have been compiled into CHM-format.

The Runtime-Help is available for:

Parameters | Description
Main menus | The help text can be accessed directly via the main menu.
Dynamic elements | For the context menu of each dynamic element a separate help page can be defined.
Function Open help | Function open help

The Runtime help enables the use of all major graphics formats (e.g. JPG, BMP, GIF, PNG, ...), text formats and
back and forward navigation.

tutorial License information

Part of the standard license of the Editor and Runtime.


Preparatory work

Manual -> Runtime help -> Preparatory work

Installing HTML Help Workshop

The HTML Help Workshop compiles HTML-Files into CHM-format. The Runtime-Help is based on CHM-files. HTML Help Workshop is available on the zenon installation medium and can be found in the following path: \AdditionalSoftware\HTML Help Workshop.

Creating a help project:

There are many different tools to create HTML-files. It is also possible to save texts in a HTML-format in MS Word.

All necessary settings are already defined in this standard help project.

Preparatory work in the HTML Help Workshop:

After starting the HTML Help Workshop the standard help project has to be loaded. With button Add/Remove Topic Files the HTM(L) files can be inserted into the help project.

Clicking the button Save and Compile or Compile creates a file RT_Help.chm in the folder of the current help project. All HTM(L) files for this help project are included in this CHM file.

If there are changes in the HTM(L) files later on, the help project has to be compiled again.

Several help files:

If the Runtime help should be distributed to several files, the files should be copied to a new folder for the next help file. Now the help project can be renamed and the HTM(L) files can be replaced by the new ones. A new compile of the new help project finishes the new help file.

Preparatory work for language changeable help:

After the help project has been created in one language, all files of the folder should be copied to the folder of the next language. Now the HTM(L) files can be replaced with those of the new language. After starting the HTML Help Workshop the Language under International Settings has to be changed to the new language. A new compile of the help project finishes the help for the new language.

The names of the help projects (*hpp, *.chm) and the names of the HTM(L) files have to be identical in all languages!


Engineering in the Editor

Manual -> Runtime help -> Engineering in the Editor

In the context menu of Files/Help in the project-manager, CHM files can be inserted. The standard language is inserted directly into this folder. If no standard files are inserted, in the later projecting no files can be selected!


Language switch

Manual -> Runtime help -> Engineering in the Editor -> Language switch

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For language changeable project a separate sub-folder for each language has to be created. The help files for each language are inserted into the appropriate sub-folder. Necessary steps:

  • create in the context menu of Files/Help for each language an own sub-folder, e.g. English and German.
  • translate the entries in the help file
  • compile HTML-Help Workshop again
  • create a RT-Help.chm in each language folder
    • select Add file in the context menu
  • all help files must then be put in the local work version via the context menu


Updating help files

Manual -> Runtime help -> Engineering in the Editor -> Updating help files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If during projecting the existing help files should be replaced by newer ones, this has to be done manually. The new CHM files have to be copied to the appropriate subdirectory of the project. In the Editor the commands Enable changes and Accept changes also enter the new files into the database of the project.


Help in a main menu

Manual -> Runtime help -> Engineering in the Editor -> Help in a main menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

After selecting the desired main menu, a new entry for the help is created. If this entry is selected, the properties can be set in the property-window:

Parameters | Description
Context menu: Action type | The action type has to be set to Help, otherwise the further settings are not available.
Dynamic element: Help file | Here the appropriate help file (*.chm) from the standard language is selected. This entry serves as a default used, if there is no separate help file for the dynamic element.
Dynamic element: Help chapter | Here the appropriate help chapter from the selected help file is selected. The help chapters always have the name of the HTM(L) file, they are based on. This entry serves as a default used, if there is no separate help chapter for the dynamic element.


Help for dynamic elements

Manual -> Runtime help -> Engineering in the Editor -> Help for dynamic elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For each dynamic element a context menu can be selected. If the context menu has an entry with the action type Help, a context-sensitive help for the dynamic element is displayed.


Defining the context menu

Manual -> Runtime help -> Engineering in the Editor -> Help for dynamic elements -> Defining the context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

After selecting the desired context menu, a new entry for the help is created. The following settings in the properties are necessary:

Parameters | Description
Context menu: Action type | The action type has to be set to Help, otherwise the further settings are not available.
Dynamic element: Help file | Here the appropriate help file (*.chm) from the standard language is selected. This entry serves as a default used, if there is no separate help file for the dynamic element.
Dynamic element: Help chapter | Here the appropriate help chapter from the selected help file is selected. The help chapters always have the name of the HTM(L) file, they are based on. This entry serves as a default used, if there is no separate help chapter for the dynamic element.

This context menu now can be used with different dynamic elements.


Defining dynamic elements

Manual -> Runtime help -> Engineering in the Editor -> Help for dynamic elements -> Defining dynamic elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following settings in the properties of the dynamic element are necessary:

Parameters | Description
Context menu | Here the appropriate context menu is selected from the list.
Help file | Here the appropriate help file (*.chm) from the standard language is selected. If no separate help file is defined for the dynamic element, the settings in the context menu are used.
Help chapter | Here the appropriate help chapter from the selected help file is selected. The help chapters always have the name of the HTM(L) file, they are based on. If no separate help chapter is defined for the dynamic element, the settings in the context menu are used.


Help for alarms

Manual -> Runtime help -> Engineering in the Editor -> Help for alarms

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For each alarm a context-sensitive help page can be offered. The appropriate settings are done directly in the alarm. This help is called in the alarm screen (screen of type Alarm Message List) After selecting an entry in the Alarm Message List and clicking the button Help, the corresponding help page is displayed.

The following settings in the properties of the Limits of a variable are necessary:

Parameters | Description
In Alarm Message List | This property has to be activated, otherwise the further properties are not available.
Help file | Here the appropriate help file (*.chm) from the standard language is selected.
Help chapter | Here the appropriate help chapter from the selected help file is selected. The help chapters always have the name of the HTM(L) file, they are based on.


Displaying Help

Manual -> Runtime help -> Displaying Help

The display of the help can be done in two different ways:

  1. External: via theHTML Help of the operation system.
    Consider the restrictions for the language switch!
  2. Intern: via the Help in the HTML screen


HTML Help of the operating system

Manual -> Runtime help -> Displaying Help -> HTML Help of the operating system

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This type of display is used as a default. No further projecting is necessary.

attention Attention

In general, language switching is not possible with the HMTL help on Microsoft operating systems. Help in which the language can be switched must be configured via a HTML screen.

Exception: Help under Windows CE.


Help in HTML screen

Manual -> Runtime help -> Displaying Help -> Help in HTML screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If a screen of the window class HTML and the name HTML-Help exists, it is used instead of the HTML Help of the operating system. The name of the screen is case-sensitive.

The help is displayed in the control element Navigate.

info Information

Language switch: If the language is changed after the CHM Viewer is closed, the new language is displayed when the help is called up again.


Function open help

Manual -> Runtime help -> Function open help

With this function a Help Site can be opened, e.g for menus, limits, dynamic elements:

  1. in the context menu of node function select command New function
  2. go to Application
  3. select Call help
  4. The configuration dialog is opened

Parameters | Description
Help file | Help file (*.CHM), from which a page should be displayed. Click on button ... in order to open the Explorer for selecting a CHM file.
Help chapter | Help page which should be displayed. Manual entry of the file name of the chapter before compiling it with the file name extension htm. Format: Filename.htm

All “Open Help” function calls can be configured:

  • Combination of the name of CHM file and an included HTM file.
  • Only name of the HTM file plus index of an included HTM file.

info Information

At the structure of an HTML presentation each HTM page should have a convincing tag title as this is displayed in Windows CE.


Runtime help in CE

Manual -> Runtime help -> Runtime help in CE

In Windows CE the CHM file is unpacked and the HTM(L) file is displayed in the Internet Explorer or in the screen of type HTML.

For CE devices no special characters such as umlauts, accents, etc. are allowed. All references for Windows CE help objects must be within the following characters:

  • A-Z
  • a-z
  • 0-9

info Information

Language switching: In contrast to other Microsoft Windows operating systems, the language switch in the Runtime in Windows CE also works with the HTML help of the operating system.

Note: Every call of the help in Windows CE closes all other open windows of the Internet Explorer of a user.


Call up EPLAN From help

Manual -> Runtime help -> Call up EPLAN From help

An EPLAN document can also be called up in the event of an alarm (limit breach).

attention Attention

The EPLAN connection must be licensed in zenon. You can obtain licenses from your zenon contact or at info@copalp.com.

To call up EPLAN documents from zenon in Runtime:

  1. Enter the path to the EPLAN program in zenon6.ini
  2. In the zenon Editor, in the property help of the corresponding variables, go to the Help subgroup in the Limits group
  3. In the field for the Help file property, enter the character sequence $PRG:xxxxxx
    (xxxxxx stands for the parameters to call up the correct document; for details, see the Parameters for calling up EPLAN documents section)
  4. Enter a desired character into the field of the Help chapter property
    (this property is ignored, but must not be empty)

The configured EPLAN document is called up when the help is called up in Runtime.

info Information

This functionality can in principle be used for other type of documents such as PDF.

Configuration of zenon6.ini

In zenOn6.ini, enter the path to W3u.exe. W3u.exe is the executable file of the EPLAN viewer. Version 1.7.11 or later is required.

To do this:

  1. Navigate to the [PATH] entry or create this
  2. Enter EDOC_PATH =[path]

    For example: EDOC_PATH=C:\\Programs\EPLAN\View\1.7.11\BIN\W3u.exe

info Information

You can find zenon6.ini in the following path:

Windows 7/8: %ProgramData%\COPA-DATA\System\

Parameters for calling up the EPLAN documents

A jump target with parameters must be provided for calling up an EPLAN document from Runtime help.

Syntax: edit /[path of the EPLAN project] /[DEVICENAME:= (name of the view/page in project)]

Parameters

Description

PROJECTNAME

Project name with complete path.

  • Calling it up from the command line: PROJECTNAME must be given. Alternatively: ProjectAction is used previously. Otherwise the exceptional error System.Argument Exception is triggered.
  • Call via the user interface: it need not be given when calling up via a script or the tool bar, for example. The selected project is used without it being stated.

PAGENAME

Name of page to be checked (optional).

Mandatory if X and Y are used as parameters for cursor placement.

DEVICENAME

Name of a component (optional).

Examples:

  • Opening a project:
    edit /PROJECTNAME:C:\Projects\EPLAN\PLAN100.elk
  • Opening a page:
    edit /PROJECTNAME:C:\Projects\EPLAN\PLAN100.elk /PAGENAME:=AP+ST1/7
  • Open the page and set the cursor to the X, Y position:
    edit /PROJECTNAME:C:\Projects\EPLAN\PLAN100.elk /PAGENAME:=AP+ST1/7/X:200/Y:100
  • Open page with BMK:
    edit /PROJECTNAME:C:\Projects\EPLAN\PLAN100.elk /DEVICENAME:=AP+PT1-G1

Example of calling up from zenon help page:

edit /PROJECTNAME:"D:\##Projects\EPLAN\EPLAN_AlarmConnection\P8_DEMO.elk" /DEVICENAME:=UNIT+PP-B1

You can find further information on configuration in EPLAN in your EPLAN documentation.


SAP interface

Manual -> SAP interface

To connect the SAP ERP level (Enterprise Resource Planning level) to the process level of zenon, both programs communicate using a two-way interface. This gives SAP users direct access to the process level of zenon.

The control system can be configured to send messages about any type of events to the SAP application. Companies can establish a direct link between the process level and the ERP level via a closed loop, getting a complete overview over all processes. This allows them, for example, to monitor warehousing in real-time, as the control system in the SCADA level provides exact data about real resource consumption. With this, companies get important basic data for just-in-time production but also for long-term planning.

zenon provides an integrated communication module, which makes it possible to transfer process data directly to the SAP ERP application and to call up zenon functions directly from the SAP application. In an SAP environment, this data is used, amongst other things, for the following tasks:

  • Transmission of the status of process orders
  • Information about consumption and production of materials
  • Information about the status of resources
  • Transmission of selected process events
  • Transfer of order data to zenon

Process messages in SAP can be used for tasks such as creating electronic lot and operation logs or updating a process order or the stock of materials.

tutorial License information

Must be licensed for Editor and Runtime (single-user, server, standby).

Interactions

  • Maintenance message: Maintenance messages can be created from zenon variables and forwarded to the SAP system. These reports can then trigger other actions in the SAP system, depending on the workflows defined there.
    For example, a maintenance message may automatically trigger the creation of a maintenance task for the affected piece of equipment.
  • Measurement documents: In zenon, it is possible to measure the values of process variables according to time schedules and then transfer them to the SAP system as a measurement reading. These measurement documents can be used in the SAP system for planning and creating maintenance tasks or for statistical purposes.
  • Function calls: SAP RFC-Functionblocks can be called up from zenon and executed in Runtime. The zenon SAP function contains a list of objects that display the parameters and tables of the SAP RFC-Functionblock.
  • Server programs: Call-up of zenon functions from an SAP application. For example, in order to transfer order data to zenon.


Basics and requirements

Manual -> SAP interface -> Basics and requirements

In order to use the direct integration into the SAP world, the computer on which zenon is running must also have, in addition to zenon, the SAP GUI installed. The program libraries included in the SAP GUI are absolutely required for communication with a SAP system. This SAP GUI is supplied with SAP.

No further configurations on the SAP side are required. Installing the SAP GUI is sufficient for enabling data exchange. The rest of the parameters can be entered directly in the development environment of the zenon Editor.

info Information

Integration of SAP into zenon based on SAP ECC 6.0 for the PM-PCS 4.0 scenario

Requirements in zenon

In zenon there must be a license for the SAP Interface module.

Function blocks

Using the RFC interface, actions in the SAP system are executed by calling up function blocks (known as SAP RFC-Functionblocks). This standard function blocks are supplied with the SAP system. User-defined function blocks can also be programmed using the ABAP Workbench. ABAP is a programming language developed by SAP, which is used for all function blocks in the SAP system. The integration in zenon is currently limited to the standard function blocks delivered by SAP. However, a flexible interface was created in the control system, which allows integration of customer-specific function blocks.

The complete descriptions of function blocks with their parameters, internal tables and structures used can be read from the SAP system via RFC API functions or by means of different zenon functions.

Client programs and Server programs

SAP applications make a distinction between Client programs and Server programs when calling up function modules:

  • Client program: Is called up by an external system (such as another SAP application) or an external application (such as zenon) and executed in the SAP application.
  • Server program: Is called up by the SAP application on a different system on an external system. The external system executes the function.


Maintenance reports

Manual -> SAP interface -> Basics and requirements -> Maintenance reports

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The planning system must at all times be informed about malfunctions, downtimes, etc. Productivity indicators can only be calculated correctly when the according uptimes and downtimes are known. The SAP system uses maintenance messagees for this.

Every maintenance message defined in zenon for a process variable can be configured as a malfunction report. Relevant messages are usually documented in SAP. "Relevant" means that the messages require maintenance services in order to be resolved.

Maintenance messages are created from zenon alarms. When there is an alarm for one of the variables linked to the element, a maintenance message will be created in the maintenance module of the SAP system. If there is a Cleared event for an alarm, the maintenance message will be acquired via the document number, and the time stamp of the Cleared event will be recorded.

For each type of message from SAP, you own group of message types can be created in zenon. The most significant property of a message in the SAP system is the "notification type". It defines how the message will be processed in the workflow of the SAP system. There are predefined notification types in the SAP system. If you do not specify one of the predefined notification types when trying to create a maintenance message, the SAP system will not create a maintenance message but will return an error message instead.

info Information

You can also choose to define a maintenance plant and a reporter for every maintenance message. If you do not specify a plant or a reporter, the SAP system will insert default values.

Every maintenance message refers to an installation part that is predefined in the SAP system. Such an installation part can be a "functional location" or "equipment". Every functional location can in turn contain functional locations and/or equipments.

Every functional location and every item of equipment have a unique identification that must be specified when creating a malfunction report. The identification for functional locations or equipments is taken from the resources label of the linked variables. Via the property "Functional location/Equipment", you can configure whether the resources label shall be interpreted as the identification of a functional location or an equipment.

You can now link variables to the maintenance messages you just defined. If there is an alarm for one of the linked variables, a maintenance message will be created in the SAP system using the defined parameters and the value and the limit text of the variable.

The maintenance messages receive a unique document number in the SAP system, which will be stored as a comment in the alarm entry of the zenon variable. This allows you to map the alarm event to the document number of the maintenance message in the SAP system.

attention Attention

If an alarm has a dynamic limit text, the comment field of the entry is not available; instead, an entry to the Chronological Event List will be created, which allows to map the alarm to the document number.


Technical background

Manual -> SAP interface -> Basics and requirements -> Maintenance reports -> Technical background

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Maintenance messages in the SAP system are created by executing the function blocks ALM_PM_MAINTNOT_CREATE and ALM_PM_MAINTNOT_SAVE. If the alarm is cleared, the "Cleared time" will be entered into the maintenance message created before by executing the function blocks ALM_PM_MAINTNOT_MODIFY_DATA and ALM_PM_MAINTNOT_SAVE.

These function blocks are created in the SAP system during the standard installation of the maintenance module and are then available for external applications.

attention Attention

Due to individual adaptations of the SAP system to specific customer requirements, these function blocks may no longer be available! In this case, the SAP system will return the error message FU_NOT_FOUND.

If the event Alarm cleared occurs in zenon for one of the linked variables, the maintenance message belonging to the alarm will be searched via the document number and the time of clearance of the malfunction will be inserted. This happens by executing the ALM_PM_MAINTNOT_MODIFY_DATA function block. The document number of the maintenance message is handed over to the function block with the NUMBER parameter. The values of the fields that need to be changed are specified in the parameter NOTIFHEADER ; the fields that need to be changed are specified with flags in the parameter NOTIF .

The modified maintenance message will then be stored in the SAP database by executing the function blocks ALM_ and BAPI_TRANSACTION_COMMIT.


Measurement readings

Manual -> SAP interface -> Basics and requirements -> Measurement readings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In SAP applications, measured values describe a certain status of a production system at a certain time in the process flow. Any variable existing in zenon can be defined as a measurement document. This allows handing over protocol-independent data from the real time process to the superordinate management level.

In many cases, it is better to aggregate process data already on the process level and then pass it on in a condensed format to the SAP system for analysis. For example, zenon delivers average values and other statistical values calculated from value series to the SAP system. This avoids overloading the management system with raw data.

Measured values and counter readings are recorded cyclically and stored as measured documents for a measuring point in the SAP system. The properties of the measuring point in the SAP system determine whether it is a measured value or a counter. The current variable value is used as the value of the measurement document.

Several measuring points can be defined for every technical location or every piece of equipment in the SAP system. During the definition of the measuring points, you can configure whether the measuring point shall continue a measured value or a counter reading. Counter readings must have monotonously rising values, i.e. every new value you enter must be equal to or higher than the previous value.

Measured values and counter readings of measuring points are passed on to the SAP system by means of what are known as "measurement documents".

In the control system, measured values are recorded according to schedules. For every schedule, you can define the weekdays and the times at which measured values shall be recorded. A schedule can be executed either daily or only on specific weekdays. Furthermore, you can define a starting time and an ending time as well as an interval for every schedule. Between the starting time and the ending time, the measured values of the linked variables in the specified interval will be recorded.

You can link a number of values with every schedule. Every time the schedule is executed, the current values of the variables will be read out and a measurement document for every variable value will be created in the SAP system. Every measuring point has a unique number that must be put down in the measurement document. The resource label of the linked variables is used to determine the number of the measuring point.

info Information

The control system variables and the SAP measuring points are mapped via the ID of the measuring point in the SAP system. This unique consecutive number must be entered in the resource label of the variables in the control system.


Technical background

Manual -> SAP interface -> Basics and requirements -> Measurement readings -> Technical background

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Measurement documents for measuring points and counters are created in the SAP system with the function block "MEASUREM_*" . The measurement document is allocated to a measuring point or counter. Whether it is a measuring point or a counter, will be defined during the creation of the measuring point. The measuring point/counter is identified via a unique number in the SAP system.

The measuring document contains the measuring date (date, time), a measured value and its unit, a reporter (creator of the document) and a short text. If the measuring date is not specified, the date of the creation of the document will be used. In case the unit of the measured value is left out, the unit specified at the measuring point/counter will be used.

Setting the COMMIT_WORK parameter causes the document to be written to the SAP database immediately. Measurement documents are created in the SAP system by executing the function block MEASUREM_DOCUM_RFC_SINGLE_001.

info Information

The MEASUREM_DOCUM_RFC_SINGLE_001 function block is created during the standard installation of the maintenance module in the SAP system.

attention Attention

Due to individual adaptations of the SAP system to specific customer requirements, these function blocks may no longer be available! In this case, the SAP system will return the error message FU_NOT_FOUND.


Function calls

Manual -> SAP interface -> Basics and requirements -> Function calls

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Desired functions in the SAP system can be called up from zenon in the programming interface node with a very small amount of configuration work. To do this, an image of the interface of the function block called up is displayed in the editor with the required parameters, tables and structures and linked to zenon variables or functions. The actual function call is made by executing a zenon function, which is given this image as a parameter.

Function blocks

Actions in the SAP system and the transfer of data to the SAP system are carried out by calling up the function blocks. These function blocks are supplied with the SAP system; however user-defined function blocks can also be created via the ABAP Workbench.

Parameters

Data is transferred to and from function blocks via the import and export parameters. Input data is "imported" from the point of view of the function blocks in the SAP system; result data is "exported". The documentation of the function blocks in the SAP system is based on this point of view.

In addition to import and export parameters, there are also changing parameters, which serve for both the transfer of data and the return of results.

Internal tables

Data in table form or lists can be transferred in what are known as internal or temporary tables and can be transferred by function blocks.

Data types, structures

In addition to the other simple data types (numerical, text, date, time, etc.), data can also be transferred in structures. Data in tables is usually transferred as structures, but parameters can also take on structured data.

Support from the SAP system

The complete interface descriptions of function blocks including their parameters, internal tables and structures used can be read from the SAP system.

The zenon SAP interface makes use of this possibility in that it offers an assistant to select function blocks and to read in the interface description.

The configured objects are also compared with the interface description of the function block in the SAP system called up when an SAP function is called up.


Server programs

Manual -> SAP interface -> Basics and requirements -> Server programs

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order for an SAP application to be able to call up functions in an external system, RFC destinations are managed (transaction SM59). This is used to stipulate how an external system and an SAP application communicate. There are two possibilities in principle:

  • Started: The SAP application starts the external application.
  • Registered: The external system logs into the SAP application using a unique program ID.

zenon uses the registered method.

The external system decides how function calls that are received via the RFC interface are handled. There are two possibilities available for this:

  • Callback-Functions:
    At the RFC interface, Callback functions that are automatically executed by the interfaces are registered. This possibility is primarily suited to when the function calls that are expected via the RFC interface have already been established during implementation of the external application.
  • Name-based decision:
    The name of the function module called up is queried at the interface. A decision is made, using the name, on which action is to be executed. With this possibility, it is possible to react more flexibly and generally to function calls.
    zenon uses this method because the user decides which function calls should be available.

Some standard functions, such as RFC_PING or RFC_SYSTEM_INFO are automatically registered and executed by the RFC interface.


Engineering in the Editor

Manual -> SAP interface -> Engineering in the Editor

Measuring points/maintenance messages and function calls can only be configured in the development environment if there is a licensed SAP interface. If this is licensed there are Settings for the SAP connection in the project tree of the SAP interface node. Details about the configuration of the parameters are described in the following chapters.

Context menu project manager node SAP ERP

Menu item | Action
Save | Saves changes in the SAP ERP configuration.
Export XML all... | Exports all entries as an XML file.
Import XML | Imports entries from an XML file.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.


Toolbar and context menus

Manual -> SAP interface -> Engineering in the Editor -> Toolbar and context menus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Symbol

Action

New message type

Inserts a new empty message into the maintenance messages list.

New time plan

Inserts a new empty time plan into the measurement readings list.

New SAP function

Opens the assistant to select a new SAP function block.

Add variable

Opens the dialog for selecting variables.

New parameter

Creates new parameters for the highlighted function.

New list

Creates new table for the highlighted function.

New structure field

Creates a new structure field for highlighted parameters or highlighted table.

Create standard function

Creates a zenon "Execute SAP function" for the highlighted SAP function.

Jump back to starting element

If you entered the list via function linked elements, the symbol leads back to the start element.
Only available in the context menu when all linked elements are opened.

Save

Saves changes in the SAP configuration.

Delete

Deletes the selected entry after confirming a confirmation message.

Move up

Moves highlighted element in the detail view up by a position.

Move down

Moves highlighted element in the detail view down by a position.

Expand all

Expands all closed structures.

Clicking on the arrow next to the symbol opens the drop-down list to select from:

  • Expand all
  • Reduce all
  • Expand selected
  • Reduce selected

Export XML all...

Exports all entries as an XML file.

Import XML

Imports entries from an XML file.

Properties

Opens the property window.

Help

Opens online help.


Context menu Project manager

Manual -> SAP interface -> Engineering in the Editor -> Toolbar and context menus -> Context menu Project manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Menu item | Action
Save | Saves changes in the SAP ERP configuration.
Export XML all... | Exports all entries as an XML file.
Import XML | Imports entries from an XML file.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.


Context menu node SAP ERP

Manual -> SAP interface -> Engineering in the Editor -> Toolbar and context menus -> Context menu node SAP ERP

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Menu item | Action
Save | Saves changes in the SAP ERP configuration.
Export XML all... | Exports all entries as an XML file.
Import XML | Imports entries from an XML file.
Help | Opens online help.


Maintenance messages context menu

Manual -> SAP interface -> Engineering in the Editor -> Toolbar and context menus -> Maintenance messages context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Menu item | Action
New message type | Inserts a new empty message into the list.
Export all XML maintenance messages | Exports all entries as an XML file.
Import XML | Imports entries from an XML file.
Help | Opens online help.


Maintenance message context menu

Manual -> SAP interface -> Engineering in the Editor -> Toolbar and context menus -> Maintenance message context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Menu item | Action
Add variable | Opens the dialog for selecting variables.
Linked elements | Shows elements linked to the maintenance message in a drop-down list and makes it possible to jump to these elements.
Delete | Deletes the selected entry after confirming a confirmation message.
Export selected XML | Exports selected entries as an XML file.
Properties | Opens the properties window.
Help | Opens online help.


Measurement documents nodes context menu

Manual -> SAP interface -> Engineering in the Editor -> Toolbar and context menus -> Measurement documents nodes context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Menu item | Action
New time plan | Inserts a new empty time plan into the list.
Export all XML measurement documents | Exports all entries as an XML file.
Import XML | Imports entries from an XML file.
Help | Opens online help.


Time plan context menu

Manual -> SAP interface -> Engineering in the Editor -> Toolbar and context menus -> Time plan context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Menu item | Action
Add variable | Opens the dialog for selecting variables.
Linked elements | Shows elements linked to the time plan in a drop-down list and makes it possible to jump to these elements.
Delete | Deletes the selected entry after confirming a confirmation message.
Export selected XML | Exports selected entries as an XML file.
Properties | Opens the property window.
Help | Opens online help.


Maintenance message and measurement document variable list context menu

Manual -> SAP interface -> Engineering in the Editor -> Toolbar and context menus -> Maintenance message and measurement document variable list context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Menu item | Action
Add variable | Opens the dialog for selecting variables.
Linked elements | Shows elements linked to the variable in a drop-down list and makes it possible to jump to these elements.
Remove selected variable | Deletes selected variables from the list.
Help | Opens online help.


Function calls context menu

Manual -> SAP interface -> Engineering in the Editor -> Toolbar and context menus -> Function calls context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Function call nodes context menu

Menu item | Action
New SAP function | Opens the assistant to select an SAP function block.
Export all SAP functions | Exports all entries as an XML file.
Import XML | Imports entries from an XML file.
Help | Opens online help.

Function call table context menu

Parameters | Description
New SAP function | Create new SAP function
Create standard function | Creates a new zenon function to call up the selected SAP function.
Linked elements | Shows elements linked to the SAP function in a drop-down list and makes it possible to jump to these elements.
Delete | Deletes the selected entry after confirming a confirmation message.
Export selected XML | Exports selected entries as an XML file.
Import XML | Imports entries from an XML file.
Read RFC function block from SAP system | Reads in the interface description of the function block from the SAP system. If no SAP name is given, the assistant to select the function block is displayed.
Display documentaton of the RFC function block | Reads in the documentation of the function block from the SAP system and displays it as an HTML file using the web browser.
Help | Opens online help.


Individual SAP function context menu

Manual -> SAP interface -> Engineering in the Editor -> Toolbar and context menus -> Individual SAP function context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

SAP function context menu

Parameters | Description
New parameter | Create new parameter with the SAP function.
New report | Create new table with the SAP function.
Create standard function | Creates a new zenon function to call up the selected SAP function.
Linked elements | Shows elements linked to the SAP function in a drop-down list and makes it possible to jump to these elements.
Delete | Deletes the selected entry after confirming a confirmation message.
Export selected XML | Exports selected entries as an XML file.
Properties | Opens the property window.
Read RFC function block from SAP system | Reads in the interface description of the function block from the SAP system. If no SAP name is given, the assistant to select the function block is displayed.
Display documentaton of the RFC function block | Reads in the documentation of the function block from the SAP system and displays it as an HTML file using the web browser.
Help | Opens online help.

Context menu of the parameter lists of an SAP function

TAGs

Description

New parameter

Create new parameter with the SAP function.

New report

Create new table with the SAP function.

New structure field

Create new structure field for parameter or table.

Linked elements

Shows elements linked to the SAP function in a drop-down list and makes it possible to jump to these elements.

Delete

Deletes the selected entry after confirming a confirmation message.

Expand/reduce nodes

Display or hide structure fields of parameters and tables.
  • Expand all

Display structure fields of all parameters and tables.
  • Reduce all

Hide structure fields of all parameters and tables.
  • Expand selected

Display structure fields of all selected parameters and tables.
  • Reduce selected

Hide structure fields of all selected parameters and tables.

Help

Opens online help.

Context menu parameter list of an SAP function with structure field selected

TAGs | Description
New structure field | Create new structure field for parameter or table.
Linked elements | Shows elements linked to the SAP function in a drop-down list and makes it possible to jump to these elements.
Delete | Deletes selected structure fields.
Move up | Push selected structure field up by one position.
Move down | Push selected structure field down by one position.
Help | Opens online help.


Connection parameters to an SAP system

Manual -> SAP interface -> Engineering in the Editor -> Connection parameters to an SAP system

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to establish a connection to an SAP system, some basic parameters must be specified. These are configured in the SAP ERP properties in the project manager detail window. The following groups are available:

Parameters | Description
SAP ERP system | Settings for the connected SAP ERP system.
Server programs | Settings for Server programs.
SAP logon | Settings for the registration on the SAP system.
Messages | Settings for messages.
Error search | Settings for troubleshooting.

You can find details on the individual properties in the properties help for the respective property.


Messages

Manual -> SAP interface -> Engineering in the Editor -> Messages

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The planning system must at all times be informed about malfunctions, downtimes, etc. The SAP system uses maintenance messages for this. Every maintenance message defined in zenon for a process variable can be configured as a malfunction report.

info Information

If there is an alarm for one of the linked variables, a maintenance message will be created in the SAP system using the defined notification type and the limit text of the alarm. The number of the installation part (functional location or equipment) will be acquired from the resources label of the variable.

Maintenance message context menu (group)

Menu item | Action
New message type | Inserts a new empty message into the list.
Export all XML maintenance messages | Exports all entries as an XML file.
Import XML | Imports entries from an XML file.
Help | Opens online help.

Maintenance message context menu

Menu item | Action
Add variable | Opens the dialog for selecting variables.
Linked elements | Shows elements linked to the maintenance message in a drop-down list and makes it possible to jump to these elements.
Delete | Deletes the selected entry after confirming a confirmation message.
Export selected XML | Exports selected entries as an XML file.
Properties | Opens the properties window.
Help | Opens online help.


Measurement readings

Manual -> SAP interface -> Engineering in the Editor -> Measurement readings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In SAP applications, measured values describe a certain status of a production system at a certain time in the process flow. Any variable existing in zenon can be defined as a measurement document. This allows handing over protocol-independent data from the real time process to the superordinate management level. Measurement documents are passed on to an SAP system based on a fixed time schedule.

info Information

At the times defined in the schedule, the current values of the linked variables are read out. Then, a measurement document in the SAP system is created for every variable value.

Measurement documents context menu (group)

Menu item | Action
New time plan | Inserts a new empty time plan into the list.
Export all XML measurement documents | Exports all entries as an XML file.
Import XML | Imports entries from an XML file.
Help | Opens online help.

Measurement documents context menu

Menu item | Action
Add variable | Opens the dialog for selecting variables.
Linked elements | Shows elements linked to the time plan in a drop-down list and makes it possible to jump to these elements.
Delete | Deletes the selected entry after confirming a confirmation message.
Export selected XML | Exports selected entries as an XML file.
Properties | Opens the property window.
Help | Opens online help.


Server programs

Manual -> SAP interface -> Engineering in the Editor -> Server programs

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use Server programs:

  1. Go to the property group SAP ERP system/Server programs.
  2. Enter, for the Program ID property, the program ID of the RFC destination via which the connection to the SAP application is to be established.
  3. Define, for each desired SAP function call, whether it is to be executed as a Server program. To do this, configure the properties in the nodes Server program of the function calls.

The call can also be made via the programming interface.

Limitations

The following limitations are applicable for Server programs:

  • Server programs can only be registered in zenon on standalone computers or Server 1, but not on Clients or Server 2. When switching between Server 1 and Server 2, the server programs on the old server are de-registered and registered on the new server.
    Background information: SAP applications allow the registration of several external systems on the same RFC destination. However the system on which the Server program is executed is not defined.
  • In principle, an external system can register with the destination system more than once. Because with zenon, the evaluation of the Server program called up is only carried out by means of the name, this is prevented. If the same function module (same FB name) is configured in several SAP functions as a Server program, then the registration of a pre-existing registration of the same name is de-registered again. Thus the last-registered SAP function is active.
  • Only zenon functions that can be executed on the local computer can be linked. To do this, the Current computer property in the Execution group must be activated for the zenon function. If, in the selection dialog, a different function was selected, this is not applied. Filtering for functions that meet this condition is not possible.
  • Calls of SAP functions as a Client program are always asynchronous.
    If the call of an SAP function as a Client is linked to an SAP function to be called up as a Server program, this is only executed once the Server program has completed execution. Any response values that may be required thus do not achieve the Server program call!

Error message

If an error occurs when calling up a Server program, a corresponding Exception is returned to the SAP application:

  • If the SAP application attempts to call a Server program that was not registered by zenon, the Exception FUNCTION_NOT_IMPLEMENTED is returned.
  • If an error occurs when the linked zenon function is called up, the Exception INTERNAL_ERROR is returned with a description of the error.
  • If the call via the API (ServerCall event) returns an error that is not RFC_OK (tpSapErrorOk = 0), the Exception INTERNAL_ERROR is also returned.
    Recommendation: Assign, in the implementation of the Events, the LastError property to the SAP function with a meaningful text.

Entries into CEL

The writing of log entries in the CEL can be controlled using the LOG messages in the CEL property. It is activated by default.

Trace

The SAP interface writes logs as Traces in the current working folder. In zenon, this is either the program folder or the project folder. The RFC_TRACE_DIR environment variable can be used to stipulate a fixed folder for Trace files.


Call via the programming interface

Manual -> SAP interface -> Engineering in the Editor -> Server programs -> Call via the programming interface

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Server programs can also be executed using the zenon programming interface. To do this, the interface of the SAPFunction object was supplemented with the StartServer and StopServer methods and the ServerCall event.

  • StartServer: This method registers SAPFunction as a Server program. The settings of the zenon project are used for the connection to the SAP application.
  • StopServer: De-registers SAPFunction.
  • ServerCall: This event is triggered when a function from an SAP application is called up. Within events, the values of the import parameters can be evaluated and the export parameters can be set.

Example of a Server program in VBA

The example shows, using the Z_RFC_ADD2 function module, how the SAPFunction object is initialized and registered as a Server program:

Public WithEvents obFunRfcAdd As SapFunction

Public Sub FbAdd()

' Collection of the SAP functions in the project

Dim obFunctions As SapFunctions

' Parameter that is transferred to the SAP function

Dim obParOper1 As SapParameter ' Parameter 'I_OPER1'

Dim obParOper2 As SapParameter ' Parameter 'I_OPER2'

' Parameter that is returned by the SAP function

Dim obParResult As SapParameter ' Parameter 'E_RESULT'

' === Get collection of the SAP functions

Set obFunctions = thisProject.SapFunctions

' === Create SAP function "Z_RFC_ADD2" if not present

Set obFunRfcAdd = obFunctions.Item("Z_RFC_ADD2")

If obFunRfcAdd Is Nothing Then

Set obFunRfcAdd = obFunctions.CreateSapFunction("Z_RFC_ADD2")

If Not obFunRfcAdd Is Nothing Then

' === Create parameter if not present

Set obParameters = obFunRfcAdd.Parameters

If Not obParameters Is Nothing Then

' First operand

Set obParOper1 = obParameters.Item("I_OPER1")

If obParOper1 Is Nothing Then

Set obParOper1 = obParameters.CreateSapParameter("I_OPER1")

End If

' Second operand

Set obParOper2 = obParameters.Item("I_OPER2")

If obParOper2 Is Nothing Then

Set obParOper2 = obParameters.CreateSapParameter("I_OPER2")

End If

' Result

Set obParResult = obParameters.Item("E_RESULT")

If obParResult Is Nothing Then

Set obParResult = obParameters.CreateSapParameter("E_RESULT")

End If

End If

End If

End If

=== Start Server program

If Not obFunRfcAdd Is Nothing Then

bOk = obFunRfcAdd.StartServer()

End If

End Sub

=== Incoming function call

Private Sub obFunRfcAdd_ServerCall(ByVal obFunction As ISapFunction, ByRef Error As tpSapError)

If obFunction.Name = "Z_RFC_ADD2" Then

Set obParameters = obFunction.Parameters

If Not obParameters Is Nothing Then

Dim obParOper1 As SapParameter ' Parameter 'I_OPER1'

Dim obParOper2 As SapParameter ' Parameter 'I_OPER2'

Dim obParResult As SapParameter ' Parameter 'E_RESULT'

Dim Val1 As Integer

Dim Val2 As Integer

' === Get parameter objects

Set obParOper1 = obParameters.Item("I_OPER1")

Set obParOper2 = obParameters.Item("I_OPER2")

Set obParResult = obParameters.Item("E_RESULT")

' === Read input parameter

Val1 = obParOper1.Value

Val2 = obParOper2.Value

' === Set output parameter

obParResult.Value = Val1 + Val2

Error = tpSapError_Ok

Else

Error = tpSapError_Failure

End If

Else

Error = tpSapError_Failure

End If

End Sub

Private Sub obFunRfcAdd_ActivityChanged(ByVal obFunction As ISapFunction, ByVal Activity As tpSapActivity)

' If the activity status of the SAP function changes,

' the "ActivityChanged" event is triggered

thisProject.Variables.Item("Active").Value = obFunction.Activity

End Sub

Private Sub Project_Inactive()

' === End Server program

If Not obFunRfcAdd Is Nothing Then obFunRfcAdd.StopServer

' When Runtime is ended at the latest, the object of the function module

' must be deleted because otherwise there will be memory leaks.

thisProject.SapFunctions.DeleteSapFunction ("Z_RFC_ADD2")

End Sub


Function calls

Manual -> SAP interface -> Engineering in the Editor -> Function calls

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Actions in the SAP System and/or in zenon, as well as the transfer of data between zenon and the SAP system are initiated and executed by the call from the RFC function modules. Standard RFC Function blocks are supplied with the SAP system. However, user-defined function blocks can also be programmed via the ABAP Workbench.

Desired SAP function blocks can be called up directly from zenon. To do this, an image of the interface of the function block to be called up is displayed in the Editor with the required parameters, tables and structures and linked to zenon variables. The actual function call is made by executing a zenon function, which is given this image as a parameter.

Note: The SAP RFC interface only permits one function call at a time. To avoid overlapping function calls, the activity can be monitored using a variable.

SAP naming convention

When creating new user-generated objects in an SAP application, the following naming convention should be adhered to:

  • The names of self-created objects should start with Y or Z. This prevents these objects being overwritten during an update of the SAP application. Original SAP objects never start with Y or Z.


Select function block with assistant

Manual -> SAP interface -> Engineering in the Editor -> Function calls -> Select function block with assistant

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To select a function block from SAP:

  1. In the SAP interface detail view, select the Function calls node

  2. Select New SAP function... in the context menu or in the tool bar
  3. The assistant for the selection of the SAP function module is opened.
    Note: To do this, the Use assistants setting must be activated in the options of the zenon project.

    Attention: Test your project in a test system before you call up SAP function blocks in a productive system. Errors when calling up can impair the integrity of the data in the SAP system.

  4. Select the desired function block.

Select function module dialog

Parameters | Description
Select function block | Combobox for selection of SAP function blocks. The search term can be entered freely or selected from a drop-down list.
List of function blocks | List of function blocks found that correspond to the search term.
Back | Switches back to the assistant start screen.
Finish | Saves function block with all attendant SAP elements in a zenon SAP function.
Cancel | Creates an empty SAP function in zenon.


SAP functions

Manual -> SAP interface -> Engineering in the Editor -> Function calls -> SAP functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

An SAP function displays a function block from the SAP system in zenon. It contains a list of objects that display the parameters and tables of the SAP function block. With an SAP function, variables can be linked that provide information on the call status and result of the last call.

Create SAP function

SAP functions are created via the New SAP function menu item in the context menu of the Function calls node or the list of SAP functions.

If the use assistants property was activated in the project options, the assistant starts for the selection of an SAP function block. The assistant reads in the interface description of the selected function block from the SAP and creates all objects in the editor.

The SAP functions can also be edited manually:

  • To compare the SAP function with the interface description in the SAP system in the process, select the Read in RFC function block from SAP system command. If no function block name has been given, the assistant is opened to select function blocks. Settings that have already been defined, in particular linked variables, are not changed in the process.
  • When creating an SAP function, the Function name property receives an automatically-created name for the SAP function; this can be changed at will.
  • The RFC function block property contains the name of the function block in the SAP system. The given name must correspond to the name in the SAP system, otherwise the FU_NOT_FOUND Exception occurs when the SAP function is called up.


Activity monitoring

Manual -> SAP interface -> Engineering in the Editor -> Function calls -> SAP functions -> Activity monitoring

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A (numerical) variable linked with the Activity property can assume three different values depending on the status of the SAP function:

  • 0: The SAP function is inactive and is not currently being executed.
  • 1: The SAP function is queued in the call queue (the SAP RFC interface only permits one function call at a time).
  • 2: The function call is sent to the SAP system and a response from the SAP system is awaited.
    After this, the variable value goes back to 0 (inactive).

This variable can be used for an interlocking, for instance, to avoid overlapping function calls.


Error messages

Manual -> SAP interface -> Engineering in the Editor -> Function calls -> SAP functions -> Error messages

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Variables give information on the result of the last call of the SAP function. To do this, the variables are linked to the respective properties:

  • Error code: contains a numerical code that corresponds to the result of the last call.
  • Error text: a short description of the last error code that occurred.
  • Error description: extensive description of the last error that is generated by the SAP RFC interface.

Error codes of the RFC interface

Error code | Error text | Meaning
-1 | No connection to SAP system | SAP system cannot be reached (network error, registration etc.).
0 | OK | No error occurred.
1 | Error occurred | Unknown error, details in the error description property.
2 | Exception raised | Exception occurred in the function block (invalid parameter etc.).
3 | System exception raised, connection closed | Exception occurred in the system.
4 | Call received | Other function call still active.

Note:

  • The language of the error text depends on the system language of Runtime
  • Not all codes occur when the function blocks are called up.


Server program

Manual -> SAP interface -> Engineering in the Editor -> Function calls -> SAP functions -> Server program

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To execute a function in zenon with a function call as a Server program:

  1. Configure an SAP function.
  2. Select a zenon function for the Function property.
  3. Ensure that the Current computer property is activated for the zenon function.
  4. Activate the Server program property for the SAP function.
  5. If necessary, stipulate a waiting period is waited before and after calling the linked function, so that variables can be written or read with certainty. You set these using the Waiting period property.
    A waiting period is most of all recommended for variables on controllers with slow communication and/or long read cycles.
  6. If necessary, link the Activity property to a variable. This is set to active (2) when the server program is called up.

The procedure when going into the function call from the SAP application:

  • The zenon function stated in the Function property is executed.
  • The parameter values for import and export are replaced with their linked variables.

If no zenon function is linked to the SAP function, only the parameter values for import and export are replaced with their linked values. Thus the values of export parameters can be calculated from the values of the import parameters using math variables for example, without a function having to be executed.


RFC function block documentation

Manual -> SAP interface -> Engineering in the Editor -> Function calls -> SAP functions -> RFC function block documentation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The documentation for an SAP function block can be called up via the Display documentation of the RFC function block in the context menu.

The documentation

  • must be present in the SAP system for this
  • is read in in the language of the registered SAP user
  • Is displayed in the web browser in HTML format.

Documentation that has already been read in is stored in the "Temp" folder of the current Windows user and called up from there next time it is displayed.

Individual design of the display

To design the display of the documentation individually:

  1. Create a stylesheet with the name sapdoc.css
  2. Store the stylesheet in the "Temp" folder of the user

Example for a stylesheet

BODY,H1,H2,H3,H4,H5,H6,P,TD,TH,UL,DL,DIV {font-family: Geneva, Arial, Helvetica, sans-serif;}

BODY,TD {font-size: 90%;}

H1 {font-size: 120%; color: 1c1e41;}

H2 {font-size: 110%; color: 1c1e41;}

H3 {font-size: 100%; color: 1c1e41;}

H4 {font-size: 90%; font-style: italic; color: 1c1e41;}

H5 {font-size: 90%; font-style: normal; font-weight: lighter; color: 1c1e41;}

TH {font-size: 90%; font-weight: bold; text-align: left; color: 1c1e41;}


Parameters, tables and structure fields

Manual -> SAP interface -> Engineering in the Editor -> Function calls -> Parameters, tables and structure fields

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When calling up an SAP function, data is transferred via parameters and tables. The values of the parameters, tables and their structure fields are taken from the linked variables (incoming parameters) or allocated to the linked variables after the call (return parameters).

Create parameters, tables and structure fields

Parameters, tables and structure fields are created via the context menu in the parameter list of an SAP function.

  • Naming
    • When being created via the context menu, the objects receive automatically-created names (Name in SAP system property). These must be changed in such a way that they correspond to the related objects in the SAP system.
    • When creating an SAP function with the help of the assistant, the names are automatically issued according to the interface description in the SAP system.
  • Parameters and tables
    • When the SAP function is called up, only those parameters and tables are used that are also actually in the interface description of the function block in the SAP system.
    • If non-optional parameters or tables are not configured or not linked to variables, they are populated with initial values when the SAP function is called up. This generally leads to an Exception and thus to an error message when a function is called up.
  • Informative properties
    • Some properties of parameters, tables and structure fields (type, optional and info) are only for information. These are populated with the information from the interface description in the SAP system by the assistant when an SAP function is created, but can be changed at any time.
    • They are not evaluated when the SAP function is called up. Instead, the actual inputs of the interface description in the SAP system are used.


Link variables

Manual -> SAP interface -> Engineering in the Editor -> Function calls -> Link variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Variable property is used to link variables of an SAP function with parameters, tables and structure fields.

To link variables:

  • Use either the Variable property in the properties window: Click on the ... button to open the dialog for selecting variables
    or
  • Drag & drop the desired variable onto an object in the parameter list with the mouse

If structure variables are linked to structured parameters and tables, the variables of the structure fields are also populated with the structure element of the variable if possible.

Attention: This currently only works when linking via drag & drop.

Calling up an SAP function

When calling up an SAP function, the values of the variables are read, which are linked with parameters and tables for the transfer of data to the function block and are allocated to the parameters and tables.

And vice versa, the parameters and table values that are returned from a function call are allocated to the linked variables.

Row number for tables

Objects for tables can be linked via a variable with the Number of lines property.

Accepting values:

  • Before a function call: The value of the variable determines the number of table lines processed in zenon and provided by (Number of Lines).
  • After the function call: the value provides the number of lines in the table returned from the function call.


Call up SAP functions with zenon

Manual -> SAP interface -> Engineering in the Editor -> Function calls -> Call up SAP functions with zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

SAP functions are called up using the zenon function Execute SAP function. The function has the internal ID of the SAP function to be executed as a parameter.

To call up an SAP function of zenon in Runtime:

  1. Create a new zenon function via Functions -> Context menu -> New functions
  2. Select, in the Application node, the Execute SAP function entry.
  3. The dialog for configuring functions is opened.
  4. Select the desired SAP function
  5. Confirm the configuration by clicking on the OK button

Execute SAP function dialog

Parameters | Description
SAP function | Selection of an SAP function from drop-down list. The function must already be created in the project.
Show this dialog in Runtime | Opens this dialog in Runtime for the execution of the function.
OK | Creates function with the selected parameters.
Cancel | Creates function without parameter.
Help | Opens online help.

Hint: In the editor, the Create standard function item in the context menu can be used to automatically create a function for a selected SAP function, which executes the selected SAP function in Runtime.


Scheduler

Manual -> Scheduler

The Scheduler allows the automatic execution of actions at a defined time or in a defined time grid. This can for example be changing the value of a variable, executing a System function and much more.

tutorial License information

Part of the standard license of the Editor and Runtime.

The Scheduler works with the absolute times in the Schedules. Therefore, the following functions are not available in the Scheduler:

  • Relative Times, e.g. Shift start, shift end,…
  • User defined events

info Information

In difference to the Production and Facility Scheduler (PFS), which has to be licensed, the Scheduler is also available under Windows CE.

Change between Scheduler and PFS

The Scheduler is used if the module Production & Facility Scheduler (PFS) is not licensed. Its functionality is similar to the PFS, but the functional range is limited.

  • Updating the Scheduler to the PFS is possible at any time by licensing the module, the defined scheduler data is compatible.
  • However, data created in the PFS cannot be used in the Scheduler!


Creating a schedule

Manual -> Scheduler -> Creating a schedule

A new schedule can be created in the detailview of the Scheduler.

Parameters | Description
Function new ... | Creates a new schedule.
Insert | Inserts an existing schedule.
Save | Saves the changes.
Undo | After the confirmation all changes are undone.
Options | Opens the settings dialog of the Scheduler.
Help | Opens the Online help


Switching points

Manual -> Scheduler -> Switching points

info Information

Per default switching points are always created as inactive in the Runtime and must be activated decidedly in order for them to work. Per default switching point are created as active in the Editor. .


Create an analog switching point

Manual -> Scheduler -> Switching points -> Create an analog switching point

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

An analog switching point allows to set the value of a numeric variable (e.g. UINT, INT, etc.) once at a certain time.

Then the days can be selected and be added or removed.

info Information

There is the possibility to pre-select the scheduler objects with the mouse; when opening the object catalog these objects are displayed as selected objects. Additionally the start and end times are accepted according to the selected range.


Add variables

Manual -> Scheduler -> Switching points -> Create an analog switching point -> Add variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Variables can be selected. The starting time can be entered:

Parameters | Description
Time of begin | Time, when the switch point has to be executed.
Add variable | Adds a new variable to the schedule. This is also possible during Runtime.
Add function | Adds a new function to the schedule. This is also possible during Runtime.
Set value | Allows the setting of values.
Delete | Removes the schedules link to a variable or function. Switching points using the variable or function are deleted.

The set value for variables can be defined within the variable limits (binary variables 0 or 1).

In the filed of Min/Max value the value range of the variable is dispayed.

The finished switching plan should look like below.


Add functions

Manual -> Scheduler -> Switching points -> Create an analog switching point -> Add functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Functions for the switching point can be freely selected.

Any functions – even project overlapping – can be linked to the start or end time. Here it is also possible to link several or different functions for the start and end time.

info Information

With the function “Execute VBA macro” also VBA macros can be executed at switching points.


Create an on/off switching point

Manual -> Scheduler -> Switching points -> Create an on/off switching point

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The functionality on/off switching points allows to set a binary variable to 0 or to 1 for a defined period of time.

info Information

At the begin of such a switching plan the variable is set to TRUE and at the end it is set to FALSE. If you want it the other way round, you first create the switching point and then open its menu with a doubleclick. Here you can set the values by hand (edit, set active or inactive or change the time).

In the Editor you can do this with the right mouse button, in the Runtime there is a special MDI function.

A new switching point can be created with the context menu.

info Information

Only binary variables can be selected.

The start and end time can be entered.

Example Example

If a user only needs a single time (only one switching point), the end time has to be set to the start time or the duration has to be 00:00:00. Then variables/functions can be defined for only one point of time.


Editing of switching points

Manual -> Scheduler -> Switching points -> Editing of switching points

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With a doubleclick on an existing switching point the edit dialog is opened. Here all the properties like e.g. start and end times can be edited. Additionally there is the possibility to create new numerical and on/off (binary) switching points.


Colors of the switching points

Manual -> Scheduler -> Switching points -> Colors of the switching points

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The color indicates the type of switching point.

Parameters | Description
Green | numeric switching point
Khaki | binary switching point
Blue | two overlapping binary switching points
turquoise | two overlapping switching points, one binary, one numerically


The settings of the Scheduler

Manual -> Scheduler -> The settings of the Scheduler

The settings of the Scheduler can be defined with the context menu of the detail view and the command Settings.


Time change

Manual -> Scheduler -> The settings of the Scheduler -> Time change

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this configuration it can be set, which time changes are the basis for calculation.

Parameters | Description
Positive time change | The time is set ahead, the Systemtime is set into the future (e.g. summer time)
Make up for switching points | Actions between the current time and the newly set time, are executed directly after the time setting.
Recalculate switching points | Actions between the current time and the newly set time, are ignored and not executed. Switching points are recalculated.
Negative time change | The time is set back, the Systemtime is set into the past (e.g. winter time)
Reject switching points | Switching points are recalculated. Switiching points are calculated when the original time is reached.
Recalculate switching points | Action, between the current time and the newly set time, are recalculated. (That means that when the defined time is reached, they are executed.) This causes a double execution of swithing points in the corrected time period.
SB Switch | Standby Server switch, valid for timeout during redundance switch.
Reject switching points | The execution of switching points starts according to the current position of the Standby. Switching points in the switching period might not be executed.
Recalculate switching points | The switching points are recalculated and exectued according to the new time. This might cause a double execution of switching points.
Tolerance zone for time deviation | Tolerance, in how far the systemtime can be changed, without causing a recalculation of switching points according to the criteria described above.

attention Attention

Always carry out a switch to daylight saving time/standard time with the automatic Windows time switching. Never change the time manually, because this could lead to errors with times that are relevant to zenon.


Holidays

Manual -> Scheduler -> The settings of the Scheduler -> Holidays

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Holidays can be insert automatically depending on the country.

The basis data for the holidays can be found in the zenon program folder in the file Feiertage.txt and can be edited with any text editor.

The entries for a country start with the country name in brackets and the international telephone prefix.

The definition of holidays can be found in the following line, the name and date of the holiday.

[Austria] 45

All Saint's Day, 1998/11/01

All Saint's Day, 1999/11/01

All Saint's Day, 2000/11/01

All Saint's Day, 2001/11/01

All Saint's Day, 2002/11/01

Ascension Day, 1998/05/21

Ascension Day, 1999/05/13

Ascension Day, 2000/06/01

Ascension Day, 2001/05/24

Ascension Day, 2002/05/09

...

The correct definition is necessary.

Doubleclicking the plan allows to correct the input.


Create a special schedule

Manual -> Scheduler -> Create a special schedule

Additional to the legal holidays any number of special schedules can be created (e.g. company holidays). These can be created as special schedules with the context menu of the scheduler. Here the same rule as with holidays is valid; if a special schedule exists, the switching points of the standard schedule are overwritten.

First the time is defined.

The special day is added to the table:

attention Attention

It is not possible to execute several special days at the same time. I.e. if for a time a special day already exists, no other special day can be created.


Delete a special schedule

Manual -> Scheduler -> Delete a special schedule

Special schedules can be deleted with the context menu entry Delete. Also time-models can be deleted from this context menu by selecting the entry Time.


Copy or replace schedules

Manual -> Scheduler -> Copy or replace schedules

With the right mouse button a schedule can be copied and linked to other variables via replace. The replace dialog opens and the replacement can either be executed or canceled. If canceled an identical scheduler is created.


Schedules in integration projects

Manual -> Scheduler -> Schedules in integration projects

If a schedule with data of a sub-project should be executed, the according function of the sub-project has to be called.

The data for the scheduler always come from the project,from which the screen switch function is.


Screens

Manual -> Screens

Screens are central elements of a project. They display the configured equipment, inform, and provide user elements.
Screens consist of vector elements and/or dynamic elements. These are linked with variables or functions. Screens are configured in the main window of the Editor.

zenon offers a large number of pre-defined screen types, such as alarm message lists, Extended Trend and many others. The advantage of these screen types is that the desired functionality is connected to the screen type. You only need to create the screen type and you immediately have a variety of pre-defined functions available.

You can find an overview of screen types in the Types of screen section.

tutorial License information

Part of the standard license of the Editor and Runtime.

Main window

In the main window documents such as screens, reports, etc. are displayed and edited. The main window is the only window that cannot be hidden.

Open multiple documents parallel.

You can display multiple screens in the main window at the same time. The screens can be selected with tabs at the top of the main window and can be positioned via options in menu item Windows. When switching the tabs, the elements in the properties window are amended to the selected tab.

To close open screens, use the keyboard shortcut Ctrl+F4, the context menu or the command Screen-> Close.

Context menu documents

Right-click on the tab of a document in order to open the context menu.

Parameters | Description
Save | Saves the document.
Close | Closes the document.
Close all others | Closes all other documents.

Position elements in the screen

Activate elements by clicking on the symbol in the Toolbar elements and open them with the mouse in the main window.

There are multiple possibilities for moving the elements:

  • Move quickly: Click element and position it with the mouse.
  • Position exactly: Click element and position it with the arrow keys.
  • Turning: Rotate the element with the "handle" on the Reference point as desired.

Positioning of elements in the Editor

Elements can be assigned visibility levels in the Editor and also be hidden individually.

Attention: Control elements are always displayed at the uppermost position. That also applies if they are covered by other elements in the Editor. This ensures that they can always be reached.

Adjustment to resolution

Screens and their elements are automatically adjusted to the screen resolution in Runtime. This can be prevented. To display screen elements in the size and position configured in the Editor, activate the Do not adapt element to screen resolution property for the corresponding screen in the Display group.


Graphics quality

Manual -> Screens -> Graphics quality

In zenon the quality of the displayed graphics can be tuned to the resources for the system. This setting is made using the project setting Graphics quality in group Graphical design. These settings only have an effect on Runtime. DirectX is always used in the Editor.

Possible options are:

  • Windows Basic: Basic graphics settings. Recommended for resource-weak hardware.
  • DirectX Software: Graphics calculations are done by the CPU. Depending on the graphic you can use more than one CPU. Using DirectX Software may cause a high CPU workload.
  • DirectX Hardware: A part of the graphic calculation is done by the graphics card by which the performance is increased. If this setting is not supported by the used system, zenon automatically switches to DirectX Software. Generally speaking DirectX Hardware is preferable and DirectX Software should only be used if necessary.

attention Attention
  • DirectX is not available under Windows CE.
  • DirectX cannot be used for OCX.

DirectX

DirectX allows a higher quality of graphics than than Windows Basic.

To use DirectX, several requirements must be fulfilled:

Requirement

Description

DirectX Hardware or DirectX Software must be activated.

In the project settings you must select DirectX Hardware or DirectX Software for property Graphical design.

The operating system must support DirectX 11.1.

DirectX hardware and DirectX software only works on operating systems that support DirectX11.1.

If the system does not support DirectX 11.1, it automatically switches to Windows Enhanced.

The current DirectX- Runtime must be installed. For zenon it is installed together with the setup. For the Web Client it must be installed manually.

The screen or element must support DirectX.

Only supported elements or screens can be displayed with DirectX.

For DirectX Hardware the minimum requirements must be fulfilled.

You can find details on the minimum requirements in the System requirements when using DirectX chapter. If they are not met, it automatically switches to DirectX Software.

If the operating system does not provide any hardware acceleration (e.g. Remote Desktop), it may not be possible to use DirectX Hardware.

DirectX 11.1

The following applies when using DirectX 11.1:

  • DirectX 11.1 is available natively under Windows 8 and later versions of the operating system.
  • DirectX 11.1 cannot be used under Windows 7 and Server 200R2 without a Service Pack and versions earlier than this.
  • For Windows 7 SP1 and Server 2008 R2 SP1, a Windows Service Pack must be installed

Install Service Pack for Windows 7 SP1 and Server 2008 R2 SP1

To install the Service Pack:

  1. Download the platform update KB2670838 from the Microsoft support website.
  2. Select the version that corresponds to your operating system:
    • 32-Bit
    • 64-Bit
  3. Select the corresponding installation file.

Note: This only concerns Windows 7 SP1 and Server 2008 R2 SP1. DirectX 11.1 is already present on more recent versions. The update cannot be installed on older versions.


DirectX: Improve graphics performance

Manual -> Screens -> Graphics quality -> DirectX: Improve graphics performance

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There is a graphics card in each computer. This is important for bringing the graphics to the screen.

If the graphics card has dedicated graphics memory, the graphics card has its own working memory and it is thus a separate graphics card and not an integrated graphics processor. Graphics cards with dedicated graphics memory and a graphics processor are normally used in the form of plug-in cards in the computer. These generally offer high performance.

An integrated graphics processor is located in the main processor directly and cannot be removed. This generally does not have its own graphics memory and thus needs part of the working memory. Such graphics cards generally offer low graphics performance.

High graphics performance is necessary for good and quick visualization of screens. The graphics performance is improved by DirectX, however it can be the case that high-resolution screens with many elements and effects lead to long waiting times.

In this case, the graphics performance can be additionally improved in that you are aware of the following things.

Possible influences on the graphics performance:

Effects

The application of effects for elements can have an effect on the graphics performance when the following properties are used:

  • Shadow size for values not equal to 100%
  • Blur for values greater than 0
  • Spread for values greater than 0

Hint Possibilities for increasing the graphics performance
  • If possible, use alternative designs for which these effects are not needed.

Number of elements

The performance requirements increase with the number of elements configured.

attention Attention

Note the following information when adding elements into symbols:

  • Symbols are mostly used more than once; as a result of this, each element added has a corresponding effect on performance.

For a better overview and increased graphics performance, the following is recommended in this case:

Hint Possibilities for increasing the graphics performance

Display from several elements:

  • If possible, combine several elements into one element.

Examples:

  • Use a rectangle element to display a rectangle and not a polygon element.
  • Combine several individual polygon elements into one polygon element.

Limitations on the extent of the screen:

  • Distribute elements to several screens that you each allocate a task.
  • Only call up the screen that the user needs for the current task.

Hiding elements for specific zoom levels:

Different details are required at different zoom levels.

  • You should therefore set the visibility of the elements for certain zoom levels.

Nested elements (symbols, combined elements and faceplates)

An element that is in a screen directly offers higher performance than an element that is in a nested element, for example in a symbol.

Hint Possibilities for increasing the graphics performance
  • Refrain from unnecessary hierarchical complexity if possible.

Color gradients

Color gradients require more power than simple filled colors.

Hint Possibilities for increasing the graphics performance
  • Elements with color gradients configured that are only difficult to see in the screen or are barely visible sometimes only have a minor visual effect. In this case, these can be replaced with a simple fill color.
  • Refrain from color gradients by using other design alternatives, such as flat design.

Dynamics

The use of dynamics for elements can, without a visible effect, lead to an increased requirement for performance.

Examples of dynamics:

  • Panning,
  • Scaling,
  • Rotation.

Hint Possibilities for increasing the graphics performance
  • Only use dynamics if it is really necessary.
  • Use static means instead of dynamics if the desired effect is the same.
  • Avoid an unnecessary high value precision for the dynamics.

Resolutions and elements sizes

The number of screen points for the display can have a direct effect on the graphics performance.

Hint Possibilities for increasing the graphics performance
  • Avoid unnecessarily high graphics resolutions.
  • Reduce the resolution:
    • Reduce the monitor resolution.
    • Reduce the element sizes.

Overlapping of elements

If an element has to be redrawn due to a change, this can lead to elements underneath and above this also having to be redrawn.

Hint Possibilities for increasing the graphics performance
  • Avoid an overlapping of elements that changes often and quickly.
  • Avoid a refresh rate that is too quick with permanent value changing.

Large graphics files

Large graphics files need, due to the large number of pixels, corresponding power.

Hint Possibilities for increasing the graphics performance
  • Amend the graphics to the output size.
  • Avoid high resolutions.
  • Use zenon elements instead of graphics files if possible.

Number of open screens

Several screens open at the same time can require more graphics performance.

Hint Possibilities for increasing the graphics performance
  • Only call up required screens.
  • Close screens that you no longer need.
  • Create task-specific overview screens of many detail views.

Truncations

The use of rounded corners for elements can require more graphics performance.

Hint Possibilities for increasing the graphics performance
  • Refrain from using rounded corners if possible.
  • Instead, use design alternatives such as flat design.

Note: It is recommended that test of graphics performance and ergonomics are carried out on the respective target platform even in early phases.


DirectX: Comparison between DirectX hardware and DirectX software

Manual -> Screens -> Graphics quality -> DirectX: Comparison between DirectX hardware and DirectX software

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In principle the graphic output between DirectX hardware and DirectX software is identical. The same graphic properties are supported for screens and screen elements with both graphics options.

When selecting the graphics options DirectX hardware or DirectX software, the following is to be noted:

DirectX Hardware

Allows additional hardware acceleration due to a DirectX-compatible graphics processor (GPU). This can be in the form of an integrated graphics processor or ideally a dedicated graphics card integrated into the computer system. A DirectX-compatible graphics card ensures that certain graphics operations are sped up. This subsequently leads to the computer system being under less load and a potential performance improvement.

Hint Hint

For extensive visualization, it is recommended that corresponding graphics support in the form of a powerful graphics card is used, in order to create suitable requirements for ergonomic functionality. You can find out more details on the minimum requirements for the use of DirectX in the System requirements for the use of DirectX chapter.

DirectX Software

If DirectX hardware is not available as an option, the DirectX software graphics option can be used. After selecting this option , DirectX uses emulation to execute the graphics operations on the CPU of the computer. As a result of this, it is possible that there is an increased load on the system, particularly the CPU and the memory.

Note: The freely-available computer performance of a single-core or multi-core CPU is used to the full with this graphics option.

Hint Hint

For extensive visualizations, it is recommended that graphic support in the form of a powerful multi-core CPU is used, in order to create suitable requirements for ergonomic functionality. You can find out more details on the minimum requirements for the use of DirectX in the System requirements for the use of DirectX chapter.


DirectX: Error treatment

Manual -> Screens -> Graphics quality -> DirectX: Error treatment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Errors are displayed in the Diagnosis Viewer.

DirectX is not initialized.

If DirectX cannot be initialized during the call up of a screen or in continuous operation, an attempt is made to initialize DirectX again. During this process, zenon Editor and Runtime continue to run normally. You can attempt to rectify the problem in this time. Possible causes and solutions can be found out with the Diagnosis Viewer.

A progress bar appears during reinitialization. To cancel the reinitialization:

  1. Click on the Cancel button.
  2. Confirm the error message that is shown to you.
  3. Depending on whether you have canceled the process, either the editor or Runtime is ended.

Note: Errors that make reinitialization of DirectX impossible are announced by means of an error message.

Diagnosis Viewer

DirectX provides individual messages in the Diagnosis Viewer with:

  • an error message.
  • possible reasons for the error,
  • error codes.

The display take place in an own module DirectX. For errors, the error text is displayed in the Error text field; for warnings and debug information, the corresponding messages are displayed in the General text field:

  • For the successful call up of a screen at least one DEBUG success message is displayed.
  • Warning point out events which can influence the operation.
  • If an error occurs which cannot be fixed, an error message is displayed.

info Information

If a message is not completely displayed in the table in the Diagnosis Viewer, open the entry via double click to display the whole message.

Check list for error checking

A check to see whether DirectX is working can be carried out by activating the debug messages in the Diagnosis Viewer. A corresponding message is shown if the check is successful.

  • Are DirectX-specific warnings or error messages displayed in the Diagnosis Viewer?
  • Is property DirectX Hardware or DirectX Software activated in project setting Graphics quality?
  • Are the minimum requirements for DirectX met? You can find details on the minimum requirements in the System requirements when using DirectX.
  • Is DirectX supported by the screen or the element?
  • Does the display with Windows Basic work properly?
  • Does the display work with another driver?
  • Does the display work with a graphics card of another manufacturer?


Context menu Project manager

Manual -> Screens -> Context menu Project manager

Menu item | Action
New screen | Creates a new screen with the default name 'Picture' as a standard screen type.
Export XML all... | Exports all entries as an XML file.
Import XML... | Imports entries from an XML file. Note: Existing frames are not replaced during XML import using the Screens node. Existing frames are overwritten via the Frames node during XML import. In this case, all screens and their elements are adapted to the new frame.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.


Detail view of toolbar and context menu

Manual -> Screens -> Detail view of toolbar and context menu

Context menu

Menu item

Action

New screen

Adds a new screen to the list and puts the focus onto this entry.

Open screen

Opens the main window for the screen highlighted.

Create standard function

Opens the assistants to select a picture and for the configuration of details, in order to create a suitable function automatically. The action is documented in the output window.

Jump back to starting element

Click to go to back the element from which you jumped to the screen.

Copy

Copies the selected entries to the clipboard.

Paste

Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".

Delete

Deletes selected entries after a confirmation from list.

Expand/collapse

Allows all or selected nodes to be expanded or collapsed. Selection:

  • Expand all
  • Collapse all
  • Expand selected
  • Reduce selected

Export selected XML

Exports all selected entries as an XML file.

Import XML

Imports entries from an XML file.

Note: Existing frames are not replaced during XML import using the Screens node. Existing frames are overwritten via the Frames node during XML import. In this case, all screens and their elements are adapted to the new frame.

Export screen/symbol as a graphic file...

Exports the screen/symbol as a graphics file. The file selection dialog offers the corresponding graphics formats supported on the system. In principle, all Windows Imaging Component (WIC) codecs that support saving are provided for selection. The size of the graphics results from the screen or symbol to be exported.

Create template for screen type

Opens dialog for creating a new template for adding control elements in the screen type.

Remove all filters

Removes all filter settings.

Edit selected cell

Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.

Replace text in selected column

Opens the dialog for searching and replacing texts.

Properties

Opens the Properties window for the selected entry.

Help

Opens online help.

Note: Subscreens of faceplates linked in the screen container cannot be edited. These can only be displayed and copied.


Creating a screen

Manual -> Screens -> Creating a screen

To create a screen:

  1. Select, in the Screens node or in the detail view of the screens, the New screen command in the context menu or in the tool bar.
  2. A new standard screen is created.
  3. If required, select a special screen type in the properties or in the detail view.
  4. Configure the properties such as size, frames on which it is based, interactions, etc.

Note: Screens take the size of the frame on which they are based. Sizes smaller than the frame are ignored. If screens are defined as larger than the frame, they become a world view. For navigation and scrolling in world views, a worldview overview screen, touch control and the mouse can be used.


Toolbar screens

Manual -> Screens -> Toolbar screens

A toolbar is available for editing screens. Per default, it is displayed below the menu bar.

Symbol

(from left to right)

Function

Save screen

Save the current screen.

Save all

Saves all changed screens.

Cut

Cuts the selected element and stores it in the clipboard; works across projects, too. Only available if an element has been selected.

Copy

Saves a copy of the current screen to the clipboard. Only available if an element has been selected.

Paste

Inserts (i.e. pastes) a screen from the clipboard. Only available if the clipboard contains data.

Transfer format

Transfers the formatting of the element that has just been selected to the next element that is selected.

Redraw screen

Refreshes the display.

Undo

Allows undoing up to 100 actions. By default, 10 actions can be undone.

Define the number of actions: Options -> Settings ->Settings -> number of undoable actions. Enter a number between 1 and 100.

Edit mode

Switches from Zoom to Edit mode .

Zoom

Provides two zoom modes:

  • Variable zoom:
    A predefined value can be selected from the combobox, or you can directly enter any value between 15% and 400%.
  • Zoom tool:
    You can zoom directly in the screen with the two magnifier symbols (+ and -). The CTRL key switches between the different modes. The defined zoom is saved for each single screen.

Close zoom mode: Click on the Edit mode symbol in the Elements toolbar.

Help

Opens the online help

Options for symbol bar

Clicking on the arrow opens the submenu:

Active: Tool bar is displayed

If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar.

Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.


Toolbar Elements

Manual -> Screens -> Toolbar Elements

Symbol | Function
Edit mode | Switches from Zoom to Edit mode .
Ellipse/Circle | With frame and fill color, type of frame and fill pattern (circle).
Arc of a circle | With definable line thickness, line color and line type.
Segment of a circle | Draws circle segment with an opening angle of 180º (changeable), definable line thickness, color and line type.
Line | With definable line thickness, line color and line type.
Polygon | With frame and fill color, type of frame and fill pattern.
Polyline | With line type and line color.
Rectangle | With frame and fill color, type of frame and fill pattern.
Pipe | With frame and fill color, type of frame and fill pattern
Static text | With font color and selection of the type of font.
Button | Operating field in button display.
Combined element | Display of one or more variables on a screen point in color or symbol (chained characters).
Universal slider | Slider control or rotating control.
Switch | Simple command initiation or set value input element
Combo-/Listbox | Link values of variables with text messages.
Command Processing element | Only available with a license for SICAM 230
Button Screen Alarm | Only available with a license for SICAM 230
Numerical value | Display values numerically.
Bar display | Display value as bar graph.
Pointer instrument | Value in instrument display.
Dynamic text | Display limit value texts
Trend element | Simple line graphics
WPF element | Displays valid WPF XAML files.
ActiveX Element | Insert ActiveX control.
Clock | Show date and time.
Multibin | Display several variables in one screen point in color and symbol (string).
Message element | Display texts from a text table.
Status element | Apply colors from status configuration.
Options for symbol bar | Clicking on the arrow opens the submenu: Active: Tool bar is displayed If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar. Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.


Context menu Elements

Manual -> Screens -> Context menu Elements

Commands adapted to the situation are available to you in the context menu. You can also get to these commands using menus and toolbars.

Command

Description

Symbol

Opens drop-down list with commands. The following are available depending on symbol status:

  • Create element group
  • Resolve
  • Changing to individual editing mode/leaving individual editing mode
  • Insert in existing element group
  • Convert symbol into element group
  • Editing in the symbol editor
  • Inserting in the symbol library
  • Create element group

Creates an element group.

  • Resolve

Resolves an element group into its screen elements.

  • Changing to individual editing mode/leaving individual editing mode

Switches to the individual editing mode or back to the symbol editing mode. The individual editing mode enables you to edit individual elements of a symbol.

  • Insert in existing element group

Inserts symbol into an existing element group.

  • Convert symbol into element group

Converts a symbol into an element group.

  • Edit in symbol editor

Opens a symbol in the symbol editor in order to edit it there.

  • Inserting in the symbol library

Opens the dialog to add an element group from a screen of a symbol library. In doing so, the element group is converted into a symbol and inserted as a symbol. The element group in the screen is retained as an element group.

Element Position

Opens drop-down list for changing the position of the element:

  • Foreground: Moves selected elements into foreground
  • Background: Moves selected elements into background
  • Forward: Moves selected elements one layer up
  • Backward: Moves selected elements one layer down.

Arrange

Opens drop-down list for rearranging elements.

Linked elements

Opens drop-down list with dynamically linked elements, such as: Variables, functions, fonts, symbols etc.

Replace links

Find/replace function
e.g. tank 1 temperature is replaced by tank 2 temperature

Cut

Cuts the selected objects and stores them in the clipboard.

Copy

Copies selected objects

Paste

Pastes copied or cut objects form the clipboard.

Paste in same position

Pastes copied or cut objects form the clipboard.

Delete

Deletes selected objects

Transfer format

Transfers the properties of a selected element to another one / multiple elements.

  • Transfer to an element:

    Click on element with original properties
    -> Click on Transfer properties symbol or command in the context menu
    -> Click on target element: Properties are transferred

  • Transfer to multiple elements:

    Select source element
    -> Select target element with the Ctrl key held down (source and target element are highlighted)
    > Click on the Transfer properties symbol or command in the context menu
    -> Properties of the source element are transferred to the target elements.

Source and target object determine which properties are transferred.

If several elements were chosen as source, the properties of the first selected element are transferred.

Full-screen mode

The full-screen hides all remaining windows and shows only the main window with all opened documents (screens, reports, ...) in full-screen mode.

The full-screen mode can be closed by:

  • the displayed button for closing the full-screen mode
  • the short key Shift+F9

Redraw screen/symbol

Refreshes the display.

Display grid

Switches the grid on or off.

Use grid

Switches the orientation of elements to the grid on or off.

On: All objects are automatically aligned with the grid.

Note: The Ctrl button deactivates this setting temporarily. If the Ctrl button is held when moving an element, the element is not aligned to the grid.

Use magnetic points

Switches magnetic points on or off.

Use: If you move an object near the handling point of another object, it snaps in place at the handling point.

Zoom

Changes the resolution in fixed steps between 15% and 400%.

Export screen/symbol as a graphic file...

Exports the screen/symbol as a graphics file. The file selection dialog offers the corresponding graphics formats supported on the system. In principle, all Windows Imaging Component (WIC) codecs that support saving are provided for selection. The size of the graphics results from the screen or symbol to be exported.

Insert vector graphics

Opens the dialog for inserting an external vector graphic.

Note: Import of vector graphics is not available for the 64-bit Editor.

Properties

Opens the property window for the selected element.

Help

Opens online help.


XML export and XML import

Manual -> Screens -> XML export and XML import

Exporting screens

The included variables and functions are exported with the screens. The export file for the screens has the following sections:

  • Screens
  • Frames
  • Symbols
  • Variables
  • Functions

To export screens:

  1. highlight the desired screens
  2. select Export selected XML... in the context menu of the detail view
    Alternate: select, in the context menu of the Screen node, the XML export all... command
  3. the selection dialog for the saving location is opened
  4. select the desired saving location
  5. assign a name
  6. pay attention to file type XML
  7. confirm by clicking on the Save button

The selected screens are exported to an XML file and can be imported in this or in other projects at any time.

Importing screens

To import screens:

  1. in the context menu of node Screens or in the detail view Screens select the Import XML command
  2. the selection dialog for the saving location is opened
  3. navigate to the saving location of the desired XML file
  4. Select the desired file
  5. confirm the import by clicking on the Open button

The screens are imported.

Name conflicts during the import

At the import of a screen the name (attribute ShortName) which is stored in the XML file is used for the name of the screen which is created. If a screen with the same name already exist, the import is halted and an error message is displayed:

Parameters | Description
Yes | The screen described in the error message is replaced by the screen from the XML file at the import. If a new conflict occurs, the error message is displayed again.
No | The screen described in the error message is not imported. The existing screen is maintained. If a new conflict occurs, the error message is displayed again.
Yes, all | The screen described in the error message is replaced by the screen from the XML file at the import. This setting is used automatically when errors due to using the same name occur. All affected screen are replaced.
No, all | The screen described in the error message is not imported. The existing screen is maintained. This setting is used automatically when errors due to using the same name occur. All affected screen are maintained.

Note: Only the ShortName is used. The file name does not matter for the name of the screens which should be imported. Thus it cannot be used to solve the conflict.

Variables and functions in screens

Dynamic elements and Frames are automatically imported together with the screens. Variables and functions have to be imported manually before from the same file.

Only variables and functions of the first level are treated, i.e. variables and functions that are directly linked to the screen. As on the one hand variables can be linked to functions (e.g. setting values) but on the other hand functions can be linked to variables (e.g. limit functions), it can be necessary to first import the variables, then the functions, and then the variables again. Then all links should work correctly.

Example: A screen contains a button with a function Send value to hardwrae to a variable. The function is imported with the screen but not the variable.

info Information

Here we recommend using the XML Import Wizards.


Screen elements

Manual -> Screens -> Screen elements

You use two types of screen elements in zenon:

  1. static vector elements
  2. Dynamic elements

You have many key combinations available when editing screen elements. You can find details in the help, in the graphics key combinations section.

In this section, you can find information on:

  • Insert into the main window
  • Define properties
  • Change element size
  • Rotate element
  • Line height
  • Behavior in Runtime:
    • Movement
    • Graphic display
    • Sequence in Runtime
    • Visibility
    • Covered elements
  • Vector elements in zenon
  • Dynamic elements in zenon

Insert into the main window

The selected element can be selected several time in the main window and arranged there. Which element is selected and therefore active is shown by a symbol under the peak of the mouse pointer. To draw the template:

  1. press the left mouse button
  2. move the mouse
  3. release the mouse button

Exception: Polyline, Polygon and tube

  • A mouse click inserts a new supporting position
  • A double-click or the Esc key stops pulling

Elements can be freely rotated with the mouse; to do this:

  1. click on the element with the mouse
  2. rotate it with the yellow sizing handle

The touch point and therefore the rotation point can be set in Reference point properties.

Define properties

For elements in the main window, the properties are set in the Property window. The corresponding element must be activated in the main window to do this.

You can also select several elements at the same time and assign these common properties. For this, the following applies:

  • Different values for different properties are marked in red.
  • Properties which cannot be changed jointly are deactivated.

You also receive help instructions for the properties when the elements are created. To do this, activate the help window in zenon.

Change element size

In order to change the size of an element, you can use the mouse, keyboard, properties or a dialog:

  • With the mouse:
    1. Click on one of the handles of the element frame
    2. drag the element to the desired size
  • With the keyboard:
    • Activate the desired sizing handle (mouse pointer must be over the sizing handle)
    • Drag it with the cursor keys:
    • By pressing a cursor key you change the position by 1 pixel.
    • With the Shift key: + cursor: By pressing a cursor key you change the position by 10 pixel.
  • With the property window: In the property group Position you can enter the position and the size of the element accurate to the last pixel.
  • With a dialog: Double clicking a handle opens a dialog in which you can enter the position accurate to the last pixel.

Note: If, for the Graphic size property, original size has been selected for the value with the element multibin, combined element, button or switch, then the width and height of the respective graphics file can no longer be changed.

Rotate element

Elements can be rotated freely. The pivot point is set with the properties in the group Reference point.

You set the rotation angle as follows:

  • With the mouse: Click on the element and rotate it with the help of the green handle.
  • With the property window: With property Rotation angle [°] in group Position.
  • With a dialog: A dialog is opened, in which you can enter the rotation angle, by double clicking the green sizing handle.

info Information

Window-based screen elements such as ActiveX, lists or combobox/listbox cannot be rotated in Runtime. Configuration in the Editor is possible for ActiveX, but this has no effect on the display in Runtime.

Row height

The row height can be defined for certain elements, regardless of the font size, using the Representation/Line height [pixel] property. The default value is 0 pixels. The row height is thus set regardless of the font size. Each value above 0 defines a fixed value in pixels for the row height. If a line height is defined, then graphical illustrations are not scaled according to the line height but adapted to the font size.

Attention: If the row height

  • is selected is too large, nothing is displayed in Runtime in certain circumstances.
  • is selected as smaller than the font size, then graphical illustrations are cut off.

In the Runtime

Movement

Movement of elements is interpreted as follows:

  • Rotate first (statically and dynamically)
  • Then zoom (dynamically, X and Y)

Graphic display

Elements with graphics only show the graphics if the attendant value is present.

If the variable does not have a value or the value has not yet been requested, graphics in elements (such as a combined element) are not shown in Runtime. This also applies for variables from subprojects for which the project server cannot be reached. However in this case, a communication problem in shown (blue square) - if this is activated. If the server for a subproject cannot be reached after values have already been transferred to the variable, the graphics are displayed until the screen is opened again.

If there are communication problems with the PLC, the variables receive at least 0 or the last known value with the status invalid (INVALID). The graphics are thus shown.

Sorting order

In Runtime, the following sequence is generally applicable for the display of elements, from top to bottom:

  • WPF element: always in the foreground
  • ActiveX Element: always in the foreground, unless it is overlaid by a WPF element
  • Dynamic elements and vector elements

Visibility

The visibility of an element in Runtime is defined by the properties on the Visibility/flashing group. The settings of the Visibility property are used to define whether the visibility of a variable or an interlocking is determined.

  • Variable: The visibility is controlled by a variable. The element is always visible if no variable is defined. If a variable has been defined, the visibility is either taken from the limit properties of these variables or defined by the value range that is defined in the from and to properties.
  • Interlocking: The visibility is controlled by an interlocking. The element is always visible if no interlocking is defined. The Visible if interlocked property is used to define whether the element is visible, if it is interlocked or if it is not interlocked.

Visibility with interlocking

Interlocking linked | Interlocking active | Visible if interlocked | Result
X | X | X | Visible
X | X | - | Invisible
X | - | X | Invisible
X | X | - | Visible
- | - | - | Visible

Action in the event of a conflict

If the same interlocking for interlockings in the project properties for User administration or Graphical design and the visibility for the screen element are both configured, the local setting has higher priority than the setting in the project properties.

info Information

Screen elements that are linked to a variable that have neither a value nor a status are switched to invisible in Runtime.

Covered elements

The following applies for overlaid elements:

  • If a vector element overlays a dynamic element:
    • the dynamic elements or the overlaid part is not displayed
    • The dynamic elements can be operated, even if they are fully covered.
  • If several dynamic elements are overlaid, only the visible (clickable) parts can be operated.

info Information

Elements that are covered in Runtime can be controlled with the keyboard. For details on configuration, see the Runtime manual, Defining sequences in frames chapter.

Vector elements in zenon:

You create vector elements in zenon with the character editor. Select the desired element in the Elements toolbar and place it in the main window using the mouse. Configure the properties with the Properties window. The element must be selected in the main window to do this.

Element | Properties
Ellipse | With frame and fill color, type of frame and fill pattern
Circle | Select the ellipse symbol and hold down the Shift key when drawing; with frame and fill color; type of frame and fill pattern
Arc of a circle | With definable line thickness, color and type
Segment of a circle | With definable line thickness, color and type
Line | With definable line thickness, color and type
Polygon | With frame and fill color, type of frame and fill pattern
Polyline | With line type and color (also filling pattern and color for an area description)
Square | select Rectangle symbol, hold down the Shift key when drawing; with frame and fill color; type of frame and fill pattern
Rectangle | with frame and fill color, type of frame and fill pattern
Rounded rectangle | with frame and fill color, type of frame and fill pattern
Pipe | With frame and fill color, type of frame and fill pattern
Static text | With font color and selection of the type of font

Importing your own vector graphics

Vector elements that have been created in external programs can be imported as a screen and included. To do this, go to Files-> Graphics -> Add file in the project manager.

Note: Import of vector graphics is not available for the 64-bit Editor.

Dynamic elements in zenon

You create dynamic screen elements in zenon with the character editor. Select the desired element in the Elements toolbar and place it in the main window using the mouse. Configure the properties with the Properties window. The element must be activated in the main window to do this. Graphic elements can be activated directly here through variables. For many elements, a configuration dialog is shown when they are being created.

Dynamic elements in zenon:

Element

Function

ActiveX

Inserts any desired ActiveX controls. These must already be installed on the computer.

Bar display

Displays the size of a signal in bar form. In doing so, the length of the bar changes with the signal size.

Command Processing element

Makes it possible to send commands for the Command module. Requires license forSICAM 230.

Button Screen Alarm

Enables alarming with color and flashing via the screen. Requires license forSICAM 230.

Bitmap button

Links a graphics file (pixel graphics: *.bmp, *.jpg, *.gif, or *.png or vector graphics: *.wmf) with a button.

Warning! This element is only available if the project property Create RT files for has been set to lower than 6.50. This function has been integrated into the button element from version 6.50.

Button

Enables actions such as "execute function" or "write set value" to be instigated. It can display text and graphics and be created as a transparent object via other elements.

Warning! If the project property Create RT files for is set to lower than 6.50, only text output is displayed in runtime. Graphics and the invisible function must then be configured with the bitmap button and the invisible button elements. You then find these two elements at the bottom of the elements drop-down list.

Combined element

Displays statuses of variables via symbols, screens and texts in graphic form also be used as a switch or as a button.

Combo-/Listbox

Displays a text in a combo box or a list box regardless of variable value. When an entry is selected, the attendant value is sent or the attendant function is executed.

Dynamic text

Displays the value of a string variable in alphanumeric form or the current limit text of numeric variables.

Message element

Reads text from a text file, depending on two variables, and displays this.

Multibin

Enables, independently of variable values, a graphic to be displayed or symbols to be colored and a status text to be provided.

Switch

Displays values of a binary variable and modifies these.

Move symbol

Enables a symbol to be moved, rotated and changed in size regardless of variable values.

Trend element

Displays values in the form of trend curves.

Clock

Displays the current time and date.

Universal slider

Provides sliders in different graphical forms.

Invisible button

Transparent object, with which actions such as "execute function" or "write set value" can be triggered.

Warning! This element is only available if the project property Create RT files for has been set to lower than 6.50. This function has been integrated into the button element from version 6.50.

WPF element

Displays WPF-XAML files in zenon.

Numerical value

Displays the value of a variable in numerical form.

Pointer instrument

Displays the value of a variable in the form of an analog measuring tool with a indicator as display element.

Status element

Transfers properties from linked variables to a symbol and displays statistical limit texts.

Define properties

For many dynamic elements, a configuration dialog opens to select variables and/or functions that define the elements in runtime. The properties can also be set independently of the configuration dialog in the properties window. They can be changed at any time here. The corresponding element must be activated in the main window to do this.

You can also select several elements at the same time and assign these common properties. For this, the following applies:

  • Different values for different properties are marked in red.
  • Properties which cannot be changed jointly are deactivated.

You also receive help instructions for the properties when the elements are created. To do this, activate the properties list in zenon.

Display in the main window

You can obtain information on a dynamic element in the main window by:

Tool tip when the mouse is moved over it:

  • Element type
  • Element name
  • Function name/function type
  • Linked variables

In the status bar on activation:

  • Mouse pointer position
  • Element type
  • Element name
  • Start point
  • Width/height


.NET Controls

Manual -> Screens -> Screen elements -> .NET Controls

The ActiveX control CD_DotNetControlContainer.Container makes it possible to use any .NET Windows Forms Controls as dynamic elements in zenon. In doing so, all functions implemented in the .NET control are supported. It can be used with all zenon versions from 5.50 on which support ActiveX.

Note: .NET Framework 3.5 or higher must be available.

info Information

You can read more about the use of .NET with zenon in the Programming interfaces manual in the .NET chapter.

To use the ActiveX control CD_DotNetControlContainer.Container:

  1. create a dynamic element of the type ActiveX
  2. select CD_DotNetControlContainer.Container from the list of available controls
  3. click on button Properties
  4. the dialog for configuring the control opens

Parameters | Description
Load | Opens the file manager for selecting a .NET Control Assembly. Note: The .NET Control Assembly must be in the same folder as Runtime. It is always the absolute path to the .NET Control Assembly that is saved, e.g.: C:\Controls\Assembly.dll.
SelectUserControl | Selection of the .NET Controls from the ones available in the selected .NET Control Assembly.
Preview | Displays the absolute path to the .NET Control Assembly. Field left below: Preview of the control. Field right below: List of properties for the selected .NET Control.
Symbol: By categories | Displays properties sorted by categories.
Symbol: Alphabetical | Display properties in alphabetic order.
Symbol: Property pages | Displays property pages.
OK | Confirms configuration. This is then saved in the zenon ActiveX element as XML stream.
Cancel | Discards configuration.


ActiveX

Manual -> Screens -> Screen elements -> ActiveX

You connect ActiveX elements in projects using the ActiveX dynamic element.

info Information

You can read more about the use of ActiveX with zenon in the Programming interfaces manual in the ActiveX chapter.

To create ActiveX in a screen:

  1. Select the symbol ActiveX in the Elements toolbar.
  2. select the start point in the main window
  3. pull the control element open while pressing and holding the left mouse button
  4. a configuration dialog opens, in which you can select the element and configure it
  5. The shape, size and position can be changed at any time by pulling the vertexes or moving the element
  6. If you press and hold the Alt key while pulling the outer corner points, the change is carried out symmetrically

You define individual properties of the element in the properties window. In order to do this, the element must be active (mouse click) in the main window. To subsequently select or change controls, open the configuration dialog by double-clicking on the properties menu item in the context menu.

attention Attention

Only ActiveX elements that are installed and registered on the computer are shown. Please ensure that all ActiveX elements are also installed on all Runtime systems on which you use the project.
You can also use Remote Transport to register ActiveX elements on remote systems. See: Define files (copy&register)

ActiveX configuration

ActiveX elements

Element | Function
ActiveX elements | List of all ActiveX elements available.
Properties | Opens a configuration dialog for the ActiveX highlighted, if available. You can obtain help and information about the configuration from the manufacturer of the respective ActiveX control.

Variable assignment

Element | Function
Variable assignment | List of variables linked to the ActiveX element.
Variable | Opens the zenon Dialog to select variables if it is possible to link variables.
Down | Sorts highlighted variables downwards.
Up | Sorts highlighted variables upwards.

Position change in Runtime

Windowed ActiveX controls work with untransformed mouse coordinates in Runtime. If an element is rotated, stretched or otherwise changed in terms of its size or position, the control no longer fits and continues to be executed at the original position. The transformed element can therefore no longer be operated at its transformed position using the control.

Windowless ActiveX controls can work with transformed mouse coordinates in Runtime. If an element is rotated, stretched or its position is otherwise changed, the control works if the following requirements have been met:

  • Does not work under Windows CE.
  • Does not contain a control in windowless ActiveX
  • Windowless ActiveX supported transformed characters correctly

info Information

Regard the difference between windowed and windowless ActiveX elements.

Windowed ActiveX elements (e.g. all Microsoft ActiveX Controls) are always in teh foreground.

In contrast you can place for example a dynamic element over windowless ActiveX elements.


Bar display

Manual -> Screens -> Screen elements -> Bar display

You show the numerical size of a signal with the Bar display dynamic element. The length of the bar changes with the signal size in runtime.

To create Bar display in a screen:

  1. select the Bar display symbol in the Elements tool bar or in the Elements drop-down list
  2. select the start point in the main window
  3. pull open the element while pressing and holding the left mouse button
  4. the dialog to assign a variable opens
  5. The shape, size and position can be changed at any time by pulling the vertexes or moving the element
  6. If you press and hold the Alt key while pulling the outer corner points, the change is carried out symmetrically

You define individual properties of the element in the Properties window. In order to do this, the element must be active (mouse click) in the Main window.

To edit the linked variable:

  1. open the variables in the Project Manager Detail view,
  2. drag the desired variable onto the element while holding the left mouse button
  3. the previous variable is substituted by the new one

Color-coded display of the limit violation

At limit violations the color from the variable can color the whole area or only the area starting from the limit violation. This functionality is controlled via property Explicit in group Representation.

This property affects only the display of values with defined limits from variables. Limits from reaction matrices are not considered.

  • Active: If a limit value of the linked variable is breached, only the part of the display that goes into the limit value breach is shown in the color of the respective limit value.
    If the variable has several defined limit values, the corresponding areas of the display are each shown in the color of the limit value.
  • Inactive: If a limit of the linked variable is violated, the complete display is displayed in the color of the violated limit.

Default: inactive


Command Processing element

Manual -> Screens -> Screen elements -> Command Processing element

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Makes it possible to send commands for module Command. Requires license forSICAM 230.

You can find instructions on how to use elements in the help at SICAM 230.


Button Screen Alarm

Manual -> Screens -> Screen elements -> Button Screen Alarm

Attention: The button for screen alarming requires a license for SICAM 230. You can find further instructions on how to use elements in the help at SICAM 230.


Button

Manual -> Screens -> Screen elements -> Button

You create a freely adjustable button the the dynamic element button which you can use interactively in the screen to either carry out a function or as a switch for a binary variable.

The button can

  • display a graphics file
  • animate a graphics file
  • be displayed invisibly

info Information

Buttons are subdivided into text button, bitmap button and invisible button in versions up to and including version 6.22. From version 6.50, all properties that can be configured with buttons are together in the element button.

To create the dynamic element button in a screen:

  1. Select the Button symbol in the Elements tool bar
  2. select the start point in the main window
  3. pull open the element while pressing and holding the left mouse button
  4. The Selection dialog functions open
  5. select the desired function
  6. Define the desired properties in the properties window

    Hint: You can round the corners as you wish

  7. You add variables by dragging & dropping

Labeling

To label the button:

  • Click in the element.
  • enter the text
  • define the text properties in the Representation node

Underline

To underline text, place a & in front of the text to be underlined.

&Text becomes:

If you would like to use the character '&' in text, enter it twice:
1 && 2 becomes 1 & 2.

Line break

To define a line break, use the string \n.

Example:

Line 1 \n

Line 2

Button as switch

To use the button as a switch:

  1. activate the Switch property in the Write set value node
  2. You activate settings to use the button as a momentary switch with the Momentary switch property
  3. Link the button with a binary variable (node Variable / function, property Variable)

Button to execute a function

To link a button to a function:

  1. deactivate the Switch property in the Write set value node
  2. Link the button with a binary variable (node Variable / function, property Function)

Button with graphics

To put graphics on the button:

  1. activate the element
  2. define the desired graphics for the different switch states in the Representation node via Graphics file properties and "Pressed button graphics". You can use the following graphics files: Pixel graphics: *.bmp, *.jpg, *.gif, or *.png or vector graphics: *.wmf.

A button with graphics has a thin 3D frame line as standard, which covers a pixel on each side of the graphic. If the graphics are to be visible, then:

  • In the button properties, select the Transparency border color [%] property in the Color group
    • with the value 100

    or

  • Activate the Transparent property to deactivate background color and frame color

This causes the 3D frame line to not be displayed and the whole graphic is visible.

Invisible button

to define an interactive, transparent user interface:

  1. activate the element
  2. definite the Transparent property in the Color node
  3. remove all labeling from the button
  4. Access to Runtime:
    • The mouse pointer changes when the mouse is moved over the element
    • over a defined key combination (Runtime node, Key combination property)

info Info

The status of the variable cannot be displayed for the invisible button.


Animate graphics

Manual -> Screens -> Screen elements -> Button -> Animate graphics

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

GIF graphics files can be animated in the dynamic element button:

  1. assign a GIF file to a button in the Representation node via Property Graphics file
  2. select the property GIF animation in the same node
  3. choose between Always or animation only if a Boolean variable has a value of 1: To do this, link the properties of both properties Variable


Bitmap Button (up to version 6.22 only)

Manual -> Screens -> Screen elements -> Button -> Bitmap Button (up to version 6.22 only)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Links a graphics file (pixel graphics: *.bmp, *.jpg, *.gif, or *.png or vector graphics: *.wmf) with a button.

If the project property Create RT files for is set to small 6.50, the element button can only display texts in runtime. Graphics must be configured by means of the bitmap button in this case.

Engineering buttons for different Runtime versions:

Button for | Create RT files for <6:50 AM | from 6.50
Text | Button | Button
Graphics | Bitmap button | Button
invisible | Invisible button | Button

to activate a bitmap button:

  • select the Bitmap button symbol in the Elements tool bar
  • select the start point in the main window
  • pull open the element while pressing and holding the left mouse button
  • a dialog opens, in which you can link the desired function to the element
  • The shape, size and position can be changed at any time by pulling the vertexes or moving the element
  • If you press and hold the Alt key while pulling the outer corner points, the change is carried out symmetrically
  • You define individual properties of the element in the properties window. In order to do this, the element must be active (mouse click) in the main window.

In order to select functions, a filtered dialog is opened:

Element

Description

Project tree

Definition of the project from which the function should be selected.

Selection window

Selection of the function.

No selection

Depending on the element:

  • the dialog is canceled
  • already linked functions are deleted

Hint: The size of this dialog can be adjusted. The dialog size and position are saved.

Change linked function

  1. manually
    • in the Project Manager´s Detail view open the functions
    • drag the desired function on the element while holding the left mouse button
    • the previous function is substituted by the new one
  2. automatic
    • Select the entry Replace links from the context menu. For more details see chapter Substitution of variables and functions in dynamic elements.

GIF graphics files can be animated in the dynamic element button:

  1. assign a GIF file to a button in the Representation node via Property Graphics file
  2. select the property GIF animation in the same node
  3. choose between Always or animation only if a Boolean variable has a value of 1: To do this, link the properties of both properties Variable


Invisible button (up to version 6.22 only)

Manual -> Screens -> Screen elements -> Button -> Invisible button (up to version 6.22 only)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If the project property Create RT files for is set to small 6.50, the element button can only display texts in runtime. Invisible buttons must be configured with the invisible button element in this case.

Engineering buttons for different Runtime versions:

Button for | Create RT files for <6:50 AM | from 6.50
Text | Button | Button
Graphics | Bitmap button | Button
invisible | Invisible button | Button

The dynamic element Invisible Button offers the possibility to define an interactive transparent user interface which is linked to a function call.

To activate an invisible button:

  • select the Invisible Button symbol in the Elements tool bar or in the Elements drop-down list
  • select the start point in the main window
  • pull open the element while pressing and holding the left mouse button
  • a dialog opens, in which you can link the desired function to the element
  • The shape, size and position can be changed at any time by pulling the vertexes or moving the element
  • if you press and hold the alt key while pulling the outer corner points, the change is carried out symmetrically
  • You define individual properties of the element in the properties window. In order to do this, the element must be active (mouse click) in the main window.

In order to select functions, a filtered dialog is opened:

Element

Description

Project tree

Definition of the project from which the function should be selected.

Selection window

Selection of the function.

No selection

Depending on the element:

  • the dialog is canceled
  • already linked functions are deleted

Hint: The size of this dialog can be adjusted. The dialog size and position are saved.

Change linked function

  1. manually
    • in the Project Manager´s Detail view open the functions
    • drag the desired function on the element while holding the left mouse button
    • the previous function is substituted by the new one
  2. automatic

Select the entry Replace links from the context menu. For more details see chapter Substitution of variables and functions in dynamic elements.

info Info

For the invisible button the status of the variable cannot be displayed.


Combined element

Manual -> Screens -> Screen elements -> Combined element

The combined element is a dynamic element that can be used universally and can adopt the most varied graphic characteristics:

  • Graphics
  • Screen symbol
  • Text

The form of the display is defined through statuses. Variable values of the main value, values of further values and status information from all linked variables can all serve as statuses. Links can be created as desired via formulas.
Statuses of the main variables (limit attributes) can be transferred directly to the combined element. The combined element also supports the setting of set values in the form of a switcher/momentary switch as well as the sending of functions and serves to implement technical process-related elements for Automatic Line Coloring.

If set values are set via command processing and a response variable is set in the combined element dynamic element, it can be set regardless of the setting of the Setting values active property. All action buttons in the command processing screen that trigger a direct modification of the response variable are then set to invisible.

Create a combined element

To create a combined element in a screen:

  1. Click on the Combined Element symbol in the Elements toolbar and drag the element to the main window with the mouse.
  2. The variable selection dialog opens, filtered for numeric variables.
  3. Select the desired variable
  4. The Assistant for combined element settings opens and guides you through the basic settings. If you prefer to define all settings manually, click on cancel now. You can find details in the Assistant. chapter

When setting up manually, define the Type of display in the Representation node. The symbol from the library is given as a default. You can define screen data and text according to the settings.

You define additional statuses either in the assistant via the New Status or in Combined Element Properties in the display with property node Configuration and test.

Functions and variables can be assigned to the combined element by dragging & dropping. In doing so, the respective variables/functions are each replaced by the new ones.

Combined elements can accept the action for buttons set in the project. To do this, activate the Darstellung im gesperrten Zustand von Tasteneigenschaften des Projekts übernehmen property. In doing so, the settings from the Locked buttons and Interlocked buttons properties are applied. The gray selection only has an effect on non-symbolic text components.

attention Attention

Symbols in a "Combined" element cannot be operated.

Exception: Symbols from the library can be created as clickable buttons.

Link rules

If you have selected Symbol from Library as a display type, you can enter link rules. You open the dialog for entering the element via the Configuration and test property. After selecting the symbol via the Symbol Select button, you can create and edit linking rules. These rules are saved for every status.

Example Example

Variables/functions contained in the symbol:
Var_SWITCH_0010
Var_TEMPERATURE_0010
Fct_ShowTrend_0010
Fct_Help_0000

The variables and functions of the symbol are now replaced with the following rule:
Source: *_0010
replace with: _0020

result of linking rule:
Var_SWITCH_0020
Var_TEMPERATURE_0020
Fct_ShowTrend_0020
Fct_Help_0000

With the help of the linking rule, all variables and functions can be exchanged. If a variable or function does not fit into the scheme, that link cannot be replaced.

When the runtime files are created, the respective links are set for every status, according to the rule.

Example Example

You would like to graphically display whether a motor is switched on and in which direction it is turning.

Information about run direction and on/off state comes from the variables on the control side. The status text displays whether the motor is turning and how it is turning.

  • Select Properties -> Display Type -> Status Text.
  • Open the Enter Element dialog by clicking on Configuration and test.
  • Enter the status text which you want to allocate to the respective value.

It is subsequently displayed in your motor during runtime, for example: 'left', 'right' or no text at all if the motor is not turning.

You will find more information about the evaluation of the status bits in the chapter Statuses.


Assistant

Manual -> Screens -> Screen elements -> Combined element -> Assistant

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

An assistant is available for the basic configuration of the combined element. This opens as soon as you have selected a variable for the combined element.

In the first step, you select the display type. The following display types are available:

  • Symbol from library
  • Status texts and screen symbols
  • Graphics file and screen symbol
  • Only screen symbol

info Information

You can define additional statuses in all status selection windows. The New Status button is available for this.

Default: Symbol from library.
This setting is also displayed as standard in the properties if you create the combined element without the assistant.

You can define statuses as soon as you have selected a type of display. The first status is always the default status.
Hint: A value cannot be entered for the default status; a value must be entered for all other statuses. You can only edit one status at a time.

Symbol from library

Click on the empty window at the bottom left to select a symbol from the global symbol library or from the project library. You can delete the selected symbol again by clicking on the X next to the window.

Setting | Description
Value | Numerical value at which the status becomes active. Default: no value From 2. Status: Entry required.
New status | Creates a new status for the combined element.

info Information

For Symbol from library, clickable buttons can be created in any form.

Status texts and screen symbols

Each condition can be labeled with a text and with a foreground and background color.

Setting | Description
Value | Numerical value at which the status becomes active. Default: no value From 2. Status: Entry required.
Status text | Text as it is displayed in runtime.
Color | Font color of the status text.
Fill color | Background color of the status text.
New status | Creates a new status for the combined element.

Graphics file and screen symbol

Click on the <No graphic selected> button at the bottom left to select a screen file (*.bmp, *.gif, *.jpg, *.png etc.). You have two options for screen selection:

  1. Pictures from the project:

    Pictures which you have already stored in the graphics directory of a project (see chapter on Editor -> Project Manager -> Files) are offered to you automatically by the assistant.

  2. Absolute path to other directories:
    • Activate direct file selection for this
    • The window switches to direct selection
    • Click on the button ...
    • Select the corresponding file with the explorer
Setting | Description
Value | Numerical value at which the status becomes active. Default: no value From 2. Status: Entry required.
New status | Creates a new status for the combined element.

Only screen symbol

You can give a common symbol for all combined element statuses.
This symbol:

  • must already be present on the screen
  • applies for all statuses
  • can be labeled for each status with its own fill color
Setting | Description
Value | Numerical value at which the status becomes active. Default: no value From 2. Status: Entry required.
Screen symbol | Drop-down list to select a symbol. If no symbols are displayed, then no symbols are present in the current screen.
Fill color | Names the allocated status.
New status | Creates a new status for the combined element.


Clickable buttons in any desired form

Manual -> Screens -> Screen elements -> Combined element -> Clickable buttons in any desired form

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the combined element, clickable buttons can also be created in any desired form.

info Information

This option is available from version 6.51. For projects for earlier versions, the property is treated as inactive.

To create clickable buttons in any form desired:

  1. Create a combined element in the Symbol from libraryattributes
  2. In combined element properties, activate the Symbol form defines the click area property in the Representation node

info Information

This property does not work under Windows CE, because the required functionality is not available under Windows CE.

Elements

There can be further symbols or combined elements in the symbol. These are triggered correctly corresponding to the click area. For symbols, the element limits are used completely normally, with a combined element this depends on the Symbol form defines the click area property, either the individual click areas of the elements or the environment rectangle of the combined element.

The following elements have their own special click area:

  • Rounded rectangle (present as its own vector element up to version 6.50)
  • Button
  • Combined element with "Symbol form for click area" property
  • Circle
  • Segment of a circle
  • Arc of a circle
  • Line
  • Pipeline
  • Polygon
  • Polyline
  • Rectangle
  • Static text
  • Symbol (correct click areas of the symbol elements are used)

All other elements have their surround as a click area.

Special attributes

Special attribute

Effect

Are never treated specially:

  • Type of line
  • Filling pattern
  • Transparencies of all type
    (except text element)

Areas are always clickable.

Transparency for static test:

Elements behave as though the element did not exist. As a result, it is possible to name elements without unintentionally enlarging the click area.

Does not influence the click area.

Hint: If a transparent text element is to influence the click area:

  • Deactivate the Transparent property
  • Place a transparent element over or under this manually

Button

Is used for the click area; GIF animation for "pressed" is not available here. This corresponds to the behavior with an inactive Symbol form defines the click area property.

Symbol protrudes from the combined element.

Symbol is displayed, but clicks are only interpreted within the combined element.

Comment: If elements protrude outside symbol limits or symbols protrude out from the limits of a combined element, this can lead to display problems and blurring effects.

Click areas

In the Editor, areas larger than the click area are sometimes defined, in order to make these easier to click on. For example, a line with 1 pixel thickness in the editor can be selected using a width of 8 pixels.

The display of the click area is exact in Runtime. For example, a line of 1 pixel thickness is also only selectable from a width of 1 pixel.

The calculation of the click area for the combined element works regardless of the Graphics quality property's setting. However, a different click area is calculated for the elements regardless of this setting.

info Information

If the mouse pointer is above the combined element, it is analyzed whether the cursor is in the click area of the element. The load placed on the CPU can then be high with a large number of elements in the combined element symbol.


Clickable buttons example

Manual -> Screens -> Screen elements -> Combined element -> Clickable buttons in any desired form -> Clickable buttons example

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Example 1

status Symbol form defines the click area | Action
active | No click
inactive | Click

Example 2

status Symbol form defines the click area | Action
active | Click
inactive | Click

Example 3

status Symbol form defines the click area | Action
active | No click
inactive | Click


States

Manual -> Screens -> Screen elements -> Combined element -> States

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You get to the statuses window via the Configuration and test property in the Representation node.

Clicking on the ... button or on the "Click Here" text opens the window:

Here

  • you edit existing statuses
  • add the new statuses
  • specify in which direction statuses are to be processed.

The settings in the upper part of the window are the same for all types of display. In the lower third, individual settings for the four different types of display are made.

Common Settings

Status definition

Lists all defined statuses. A status can consist of values and status. The element is processed from the first status up to the last entry. The first complete match is shown. Exception: The Overlapping property (for symbols from the library) or Chained (for texts) is active.

Parameters | Description
Default value | The status defined when creating the element. It is always in the first position and can longer be changed or deleted.
Value | Shows the defined (32 bit) value.
Status | shows the defined status. An "F" at the end of the status display indicates a formula.
New | Defines new statuses. in doing so, values, status and formulas of the status currently highlighted are taken on as initial values.
Delete | Deletes the selected status. The default status cannot be deleted.
upwards/downwards | changes the order in which statuses are processed. The default status is always in the first position.

Formula variables

shows all variables that were defined for input in formulas. Existing variables are marked with a green tick, non-existent variables are marked with a red cross. Non-existent variables can be replaced by exiting variables via Change. The Add and Change buttons open the dialog to select variables.

Value

Enables

  • input of a value for a status via a matrix or numerically
  • the definition of a formula
Parameters | Description
Value | Defining the value via a preset bit structure
Value | Enter the numeric value.
Formula | Opens the window to enter formulas. In the formula variable area, defined variables are available. Linking is performed by logical, bitwise and comparative operators.

attention Attention

For non-binary variables, the value is entered in the signal resolution. Settings in the measuring range or the non-linear value adjustment are not supported in this element.

Status

Enables status information to be requested.

Attention: Most statuses can only be requested if the driver supports the status processing.

No. | Short term | Long name | Comment
0 | M1 | User status 1 |
1 | M2 | User status 2 |
2 | M3 | User status 3 |
3 | M4 | User status 4 |
4 | M5 | User status 5 |
5 | M6 | User status 6 |
6 | M7 | User status 7 |
7 | M8 | User status 8 |
8 | NET_SEL | Select in the network |
9 | REVISION | Revision |
10 | PROGRESS | In process |
11 | TIMEOUT | Timeout exceeded |
12 | MAN_VAL | Manual value | Only available for formulas
13 | M14 | User status 14 | Only available for formulas
14 | M15 | User status 15 | Only available for formulas
15 | M16 | User status 16 | Only available for formulas
16 | GI | General query |
17 | SPONT | Spontaneous |
18 | INVALID | Invalid |
19 | T_CHG_A | Time change announcement |
20 | OFF | Switched off |
21 | T_EXTERN | Real time external | Only available for formulas
22 | T_INTERN | Realtime internal | Only available for formulas
23 | N_SORTAB | Not sortable | Only available for formulas
24 | FM_TR | Error message transformer value |
25 | RM_TR | Working message transformer value |
26 | INFO | Information for the variable |
27 | ALT_VAL | Substitute value |
28 | RES28 | Reserved |
29 | N_UPDATE | Not updated |
30 | T_STD | Standard time | Only available for formulas
31 | RES31 | Reserved |
32 | COT0 | Cause of transmission bit 1 | Only available for formulas
33 | COT1 | Cause of transmission bit 2 | Only available for formulas
34 | COT2 | Cause of transmission bit 3 | Only available for formulas
35 | COT3 | Cause of transmission bit 4 | Only available for formulas
36 | COT4 | Cause of transmission bit 5 | Only available for formulas
37 | COT5 | Cause of transmission bit 6 | Only available for formulas
38 | N_CONF | Negative acceptance of Select by device (IEC60870 [P/N]) | Only available for formulas
39 | TEST | Test bit (IEC 60870 [T]) |
40 | WR_ACK | Writing acknowledged | Only available for formulas
41 | WR_SUC | Writing successful | Only available for formulas
42 | NORM | Normal status | Only available for formulas
43 | N_NORM | Deviation from normal status | Only available for formulas
44 | BL_870 | IEC 60870 Status: blocked |
45 | SB_870 | IEC 60870 Status: substituted |
46 | NT_870 | IEC 60870 Status: not topical |
47 | OV_870 | IEC 60870 Status: overflow |
48 | SE_870 | IEC 60870 Status: select |
49 | T_INVAL | Time invalid | Only available for formulas
50 | RES50 | reserved |
51 | RES51 | reserved |
52 | RES52 | reserved |
53 | RES53 | reserved |
54 | RES54 | reserved |
55 | RES55 | reserved |
56 | RES56 | reserved |
57 | RES57 | reserved |
58 | RES58 | reserved |
59 | RES59 | reserved |
60 | RES60 | reserved |
61 | RES61 | reserved |
62 | RES62 | reserved |
63 | RES63 | reserved |

info Information

The short terms for the status bits have been unified for all languages since version 6.50. You can find more details and how you can use the old short terms in chapter Status bits - new short terms.

Not acknowledged: If option Flashing is active for the limit of the variable, the bit not acknowledged is set. With the option Acknowledge flashing also acknowledges alarm in the alarm configuration, the alarm is acknowledged and the bit not acknowledged is set to 0 (see also chapter Acknowledge flashing for alarms).

Individual settings

Individual settings for the 4 types of display of statuses is available in the subchapters:

  • Symbol from library
  • Status texts and screen symbols
  • Graphics file and screen symbol
  • Only screen symbol

Configuring the status for variables that have not yet been linked

Sometimes you must define a combined element but you do not yet have a real, existing variable available. For example, if the combined element is supposed to be used in a symbol of the symbol library and it the variable link will be created only after pulling it into the screen. In this case, you first work with a 'dummy variable', which you then subsequently replace with an existing variable. You can then define all statuses in the combined element if existing variables have not yet been linked. You have no access with dummy variables in the test mode only.

This is how you create a 'dummy' variable:

  • Enter a symbolic name into the properties of the combined element in the Variable input field.
  • Click in the Representation area in the Configuration and test field: The page statuses in the element input are opened.
  • In the list of formula variables, existing variables are marked with a green check mark. Variables that do not exist are marked with a red X. You can add further variables:
  • Use the Add button for existing variables.
    With Change, you can replace existing and non-existing variables with other variables.
  • To add a non-existent variable, click on Add and then on No selection. You get a formula variable named after the following scheme: X00: <empty>. (00 stands for a two-digit number.)
    Highlight the variable and click in the <empty> area; assign a label.
    If you enter the name of an existing variable, the link is established and the mark changes from a red X to a green check mark.

Formulas

Read how a formula is created in the chapter on the Formula Editor.


Symbol from library

Manual -> Screens -> Screen elements -> Combined element -> States -> Symbol from library

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The general settings for all display types can be found in the chapter on statuses.

Parameters | Description
Display element |
Symbol from library | Clicking on the symbol opens the dialog to select a symbol. Clicking on the X next to the symbol deletes the selected symbol.
Edit linking rule | Variables and functions contained in the symbol can be exchanged with the help of linking rules. Attention: If a variable or function does not fit into the scheme, that link cannot be replaced.
Color | Only active if the Original Symbol Colors property in Specific Settings is turned off.
Color | Choice of color.
Fill color | Choice of fill color.
From ALC | The color of the linked source is used.
Specific settings |
Original symbol colors | Active: Transfers original color from symbol. Deactivates Take color of main variable property.
Flashing | Active: Symbol flashes in runtime if status has been achieved.


Status texts and screen symbols

Manual -> Screens -> Screen elements -> Combined element -> States -> Status texts and screen symbols

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The general settings for all display types can be found in the chapter on statuses.

Parameters | Description
Display element |
Status Text | Text for the status.
Text when pressed | Text with pressed Symbol.
Color |
Color | Choice of color.
Fill color | Choice of fill color.
From ALC | The color of the linked source is used.
Specific settings |
Flashing | Active: Symbol flashes in runtime if status has been achieved.
Transparent | Active: Fill color is set to transparent.


Graphics file and screen symbol

Manual -> Screens -> Screen elements -> Combined element -> States -> Graphics file and screen symbol

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The general settings for all display types can be found in the chapter on statuses.

Parameters | Description
Display element |
Graphics | Clicking on Graphics opens the graphics selection dialog. Delete: Remove name from text line.
Specific settings |
Flashing | Active: Symbol flashes in runtime if status has been achieved.


Only screen symbol

Manual -> Screens -> Screen elements -> Combined element -> States -> Only screen symbol

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The general settings for all display types can be found in the chapter on statuses.

Parameters | Description
Color |
Color | Choice of color.
From ALC | The color of the linked source is used.
Specific settings |
Original symbol colors | Active: Transfers original color from symbol.
symbol transparent | Active: Symbol color is set to transparent.
Flashing | Active: Symbol flashes in runtime if status has been achieved.


Test mode

Manual -> Screens -> Screen elements -> Combined element -> Test mode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The test mode simulates the Runtime: You can test the change of a value and see how your Combined Element would behave during the Runtime. You can only activate this tab if all links refer to existing variables.

Note: In test mode, the symbol is displayed in a lower resolution than on the screen in Runtime .


Formula editor

Manual -> Screens -> Screen elements -> Combined element -> Formula editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The formula editor provides support when creating formulas with logical or comparative operators with a combined element, for interlockings and commands. If additional variables are required for a formula, create these in the formula variables area of the status window by clicking on the Add button. existing formulas are displayed in the status list with the lettersF .

Note on the input of decimal points:

  • Decimal separator: Comma (,) is automatically converted into a dot (.):
  • Zero as a decimal point is removed automatically; 23,000 automatically becomes 23

Creating a formula

Click on the Formula button in the status window The formula editor opens

You select the bits for your formula in the left screen.

On the right, you find the operators for logical and comparative operations.

The formula created is displayed in the Formula area.

info Information

Up to 99 variables can be linked in one formula. X01 to X99. The length of the formula must not exceed 4096 characters.

The meaning of the bits:

Parameters

Description

value bits

32 value bits (from 0 -31) are available. They describe the variable value bit by bit. For binary variables, only bit 0 is of importance, for SINT and USINT only the bits from 0-7, etc.

Note: The value refers to the raw value (signal range) of the variables and not to the converted measuring range.

status bits

Here you find the most commonly used status bits. You find the exact definition and use of the status bits in the Status Bits List.

not acknowledged

Not acknowledged is treated like a usual status bit. But here it is listed separately, because it does not belong to the classical variable statuses.

value and status

All values (value bits and status bits) in the formula are considered as binary value and can be linked with logical operators such as AND or OR.
The total value and overall status are an exception to this. In order to get a Boolean result this total value has to be ORed with a constant bitwise. For this, we use the operator &.
For the result 0 (false) of this logical ORing we get the binary value 0 (false), otherwise 1 (true).

Example: see chapter Example bit by bit ORing

info Info

The status bits NORM and N_NORM are only available in the formula editor and cannot be engineered via the status.

If other settings outside the formula are set for the current status, they are combined with the formula with a logical AND.

Refer to the examples section for examples.

info Information

Formulas with binary X values and bitwise linking can be used with a maximum of 2 binary values. If more values are required, the linking must be carried out without binary X values.

Example:

X01.Value & X02.Value -> works

X01.Value & X02.Value & X03.Value -> does not work

But:

X01.00 AND X02.00 AND X03.00 AND X04.00 AND X05.00 -> works


List of status bits

Manual -> Screens -> Screen elements -> Combined element -> Formula editor -> List of status bits

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Short term | Long name | zenon Logic label
0 | M1 | User status 1 | _VSB_ST_M1
1 | M2 | User status 2 | _VSB_ST_M2
2 | M3 | User status 3 | _VSB_ST_M3
3 | M4 | User status 4 | _VSB_ST_M4
4 | M5 | User status 5 | _VSB_ST_M5
5 | M6 | User status 6 | _VSB_ST_M6
6 | M7 | User status 7 | _VSB_ST_M7
7 | M8 | User status 8 | _VSB_ST_M8
8 | NET_SEL | Select in the network | _VSB_SELEC
9 | REVISION | Revision | _VSB_REV
10 | PROGRESS | In operation | _VSB_DIREC
11 | TIMEOUT | Runtime exceedance | _VSB_RTE
12 | MAN_VAL | Manual value | _VSB_MVALUE
13 | M14 | User status 14 | _VSB_ST_14
14 | M15 | User status 15 | _VSB_ST_15
15 | M16 | User status 16 | _VSB_ST_16
16 | GI | General interrogation | _VSB_GR
17 | SPONT | Spontaneous | _VSB_SPONT
18 | INVALID | Invalid | _VSB_I_BIT
19 | T_CHG_A | Daylight saving time/winter time announcement | _VSB_SUWI
20 | OFF | Switched off | _VSB_N_UPD
21 | T_EXTERN | Real time external | _VSB_RT_E
22 | T_INTERN | Realtime internal | _VSB_RT_I
23 | N_SORTAB | Not sortable | _VSB_NSORT
24 | FM_TR | Error message transformer value | _VSB_DM_TR
25 | RM_TR | Working message transformer value | _VSB_RM_TR
26 | INFO | Information for the variable | _VSB_INFO
27 | ALT_VAL | Alternate value If no value was transferred, the defined alternate value is used otherwise the last valid value is used. | _VSB_AVALUE
28 | RES28 | Reserved for internal use (alarm flashing) | _VSB_RES28
29 | N_UPDATE | Not updated | _VSB_ACTUAL
30 | T_STD | Standard time | _VSB_WINTER
31 | RES31 | Reserved for internal use (alarm flashing) | _VSB_RES31
32 | COT0 | Cause of transmission bit 1 | _VSB_TCB0
33 | COT1 | Cause of transmission bit 2 | _VSB_TCB1
34 | COT2 | Cause of transmission bit 3 | _VSB_TCB2
35 | COT3 | Cause of transmission bit 4 | _VSB_TCB3
36 | COT4 | Cause of transmission bit 5 | _VSB_TCB4
37 | COT5 | Cause of transmission bit 6 | _VSB_TCB5
38 | N_CONF | Negative acceptance of Select by device (IEC 60870) | _VSB_PN_BIT
39 | TEST | Test bit (IEC870 [T]) | _VSB_T_BIT
40 | WR_ACK | Writing acknowledged | _VSB_WR_ACK
41 | WR_SUC | Writing successful | _VSB_WR_SUC
42 | NORM | Normal status | _VSB_NORM
43 | N_NORM | Deviation normal status | _VSB_ABNORM
44 | BL_870 | IEC 60870 Status: blocked | _VSB_BL_BIT
45 | SB_870 | IEC 60870 Status: substituted | _VSB_SP_BIT
46 | NT_870 | IEC 60870 Status: not topical | _VSB_NT_BIT
47 | OV_870 | IEC 60870 Status: overflow | _VSB_OV_BIT
48 | SE_870 | IEC 60870 Status: select | _VSB_SE_BIT
49 | T_INVAL | Time invalid | not defined
50 | CB_TRIP | Breaker tripping detected | not defined
51 | CB_TR_I | Breaker tripping detection inactive | not defined
52 | RES52 | reserved | not defined
53 | RES53 | reserved | not defined
54 | RES54 | reserved | not defined
55 | RES55 | reserved | not defined
56 | RES56 | reserved | not defined
57 | RES57 | reserved | not defined
58 | RES58 | reserved | not defined
59 | RES59 | reserved | not defined
60 | RES60 | reserved | not defined
61 | RES61 | reserved | not defined
62 | RES62 | reserved | not defined
63 | RES63 | reserved | not defined

info Information

In formulas all status bits are available. For other use the availability can be reduced.

You can read details on status processing in the Status processing chapter.


Logical operators

Manual -> Screens -> Screen elements -> Combined element -> Formula editor -> Logical operators

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Logical links: Variables will only be checked for the logical value '0'; if the value does not equal '0', it will be considered as '1'.

In contrast to bit formulas, the technical range can be modified by a stretch factor -> (not equal '0' or '1').

Operator | Meaning
AND | logical 'AND'
NOT | Negation
OR | logical 'OR'
XOR | logical 'EXCLUSIVE OR'

The operators have the following priority in the formula calculation:

Priority | Operator
1 | & (operator for bit formulas)
2 | NOT
3 | AND
4 | XOR/OR

info Info

Up to 99 variables can be linked in one formula. X01 to X99.

info Info

The status bits NORM and N_NORM are only available in the formula editor and cannot be engineered via the status.


Bit formulas

Manual -> Screens -> Screen elements -> Combined element -> Formula editor -> Bit formulas

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Bit formulas only have a logical high or low state. In contrast to logical formulas, the raw value is already predefined (0,1).

Operator | Description
& | AND
| | OR


Comparison operators

Manual -> Screens -> Screen elements -> Combined element -> Formula editor -> Comparison operators

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Comparison operators serve for the direct comparison of two numeric values. The result of this comparison is a binary value. "0“ if the condition is not fulfilled and „1“ if the condition is fulfilled.

Operator | Description
< | less
> | greater
<= | Less then or equal
>= | greater or equal
= | Equal
<> | unequal

To the left and to the right of the comparison operator, there has to be a (total) value or a (total) status, single bits cannot be used with these comparison operators.

There can also be a constant to the right of the comparison operator. (the constants can only be integers; a comparison to a floating point number is not possible.)
These constants are entered as hexadecimal values or decimal values in the combined element. Hexadecimal figures are automatically converted to decimal values by clicking on OK (for example, 0x64 is in decimal figures 100).

Example Example

X01.value >= X02.value
The result is 1, if the value of X01 is higher than or equal to the value of X02

X01.value = 0x64
The result is 1, if the value of X01 is exactly equal to the numeric value 100 (= hex 0x64)

(X01.value = 0x64) OR (X01.value = 0x65)
The result is 1, if the value of X01 is exactly equal to the numeric value 100 or 101 (= hex 0x64 and hex 0x65)


Examples for formulas

Manual -> Screens -> Screen elements -> Combined element -> Formula editor -> Examples for formulas

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Simple logical AND linking between two bit values

Example Example

Formula: X01.03 AND X02.03

This formula has the status TRUE, if both bit 3 of variable 1 and bit 3 of variable 2 both have the value 1.

comparison of an analogue value or status of a variable

Example Example

(X01.Value> X02.Value)

Compare analog values with each other on a logical basis

Example Example

(X01.Value> X02.Value) AND (X01.Value = X02.Value)

Compare with value bits and status bits

Example Example

(X01.Value> X02.Value) AND (X01.Value = X02.Value) OR (X01.03 = X02.03)

Compare a value with a decimal or hexadecimal value

Example Example

Formula: (X01.Value = 111)

Formula: (X01.Value = 0x6F)

If a hexadecimal values is used, this is later transferred to decimal by clicking on OK. If a decimal value is entered and confirmed, the value continues to be displayed as a decimal value after reopening.

info Info

It is not possible to use a comma or a period when entering values.


Display of variable information

Manual -> Screens -> Screen elements -> Combined element -> Display of variable information

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can display information on variables with the help of the combined element for:

  • Resources label
  • Measuring unit
  • Variable identification
  • Variable name
  • Time stamp

Engineering:

  1. Create a combined element.
  2. As type of display, select Status text & screen symbol.
  3. Create a default state.
  4. Enter the following placeholder as status text.
    Pay attention to capital letters and small letters when entering the data!
    The figures are examples.

Resources label

Placeholder | Description
%r | Shows the resources label.
%r,1,2 | Shows the resources label starting at position 1 for 2 characters
%R | Shows the resources label.
%R,3,2 | Shows the resources label minus the first 3 and the last 2 characters.

Measuring unit

Placeholder | Description
%u | Shows the measuring unit of the linked main variables.
%u,1,2 | Shows the measuring unit starting at position 1 for 2 characters.
%U | Shows the measuring unit of the linked main variables.
%U,3,2 | Shows the measuring unit minus the first 3 and the last 2 characters

Variable identification

Placeholder | Description
%l | shows the variable identification.
%l,1,2 | Shows the variable identification starting at position 1 for 2 characters
%L | shows the variable identification.
%L.3.2 | Shows the variable identification minus the first 3 and the last 2 characters.

Variable name

Placeholder | Description
%n | shows the variable name.
%n,1,2 | shows the variable name starting at position 1 for 2 characters
%N | shows the variable name.
%N,3,2 | Shows the variable name minus the first 3 and the last 2 characters.

Time stamp

Placeholder | Description
%t | Shows the time stamp.
%t,1,2 | Shows the time stamp starting at position 1 for 2 characters
%T | Shows the time stamp.
%T,3,2 | Shows the time stamp minus the first 3 and the last 2 characters.

The formats for the time settings from the operating system are applied.


Combo-/Listbox

Manual -> Screens -> Screen elements -> Combo-/Listbox

You link values of variables with texts using the combo/list box dynamic element. You use this in two ways:

  1. If a text is selected in runtime, the value of the variable changes to the value that is linked to this text.
  2. If the value reaches the value of the defined value, the linked text is displayed in the combo/list box with the current value.

Create a Combo/List box

To create the Combo/List box dynamic element in a screen:

  1. select the Combo-/Listbox symbol in the Elements tool bar
  2. select the start point in the main window
  3. pull open the element while pressing and holding the left mouse button
  4. a Dialog opens in which you can link the desired variable to the element. Variables can also be linked to the element by Drag&Drop. Drag a variable onto a combo/list box and this then replaces the variables that were there before.
    The following variable types are supported:
    • Binary
    • Numerical
    • string

info Info

No semicolon (;) can be displayed in the text for string variables, because the semicolon is used as a separator.

The combo/list box element supports the same additional functionalities as the numerical value element:

  • Lock, Status, Visibility, Dynamic Colors.
  • Dynamic colors: The background color is only accepted for existing entries. The part of the element that is not filled with entries is displayed in the standard background color.

Linking of macros to element events (such as LeftClickUp ...) is not supported.

attention Attention

It is not possible to modify colors and fonts in the combo/list box under Windows CE.

Comboboxes/listboxes can be created dynamically or statically. The ID_PROP_COMBOLIST_DYNCONTENT_USE property switches between static and dynamic operation. Fixed entries are defined in the Editor during static operation. In dynamic operation, a content variable is linked and its value is interpreted in Runtime.

Difference between combobox and list box

The texts are opened individually in a window in the Combo box.

Note for the display of the combobox in the Editor: The first line is shown in the background color; the rest of the box is transparent. Thus other elements are not covered in the Editor. The display in Runtime is as usual.

The values are displayed in a list and the current value is marked in the List box. If there are more statuses than can be displayed in the list, a scroll bar is displayed.

info Info

If the variable has a value which has not been defined in the combo box/list box entries, no text is displayed or marked.

Static combobox or list box

Fixed entries are configured in the Editor for a static box. These are displayed and used in Runtime.

To enter values:

  1. Open the Representation group.
  2. Select the display type using the Type property: Combobox or List box.

    Default value Listbox

  3. Deactivate the Entries from string variable property
  4. Click on the ... button in the Entries property
  5. The dialog for configuration of the entries is opened

  1. enter the values for statuses
  2. Link the values with the texts for statuses

Entries dialog

Entries

Parameters

Description

Entries

List of entries already defined.

No.

Consecutive number, is assigned automatically.

Value

Value that was assigned under Entries/Value.

Send value

Yes: Send value is active.

No: Send value is inactive.

Text

Character string that was entered intoEntries/Text .

Function

Function that was linked to the Entries/Function field.

Parameters

Parameter that was issued for the function for substitution.

Variable

Linked visibility variable.

New

Creates a new entry with:

  • consecutive number
  • Set active value

Delete

Removes the selected entry. Only one entry can be removed; it is not possible to select several entries.

Copy

Copies selected element and adds it at the end of the list as new element. The settings of the copied elements are taken over.

Upwards/downwards

Moves the selected entry upwards or downwards and adapts the consecutive numbering to suit.

Entry creation

Parameters

Description

Entry creation

Configuration of entries in the list.

Text

Entry of the character string which is linked to the value.

Value

Numerical value.

The values that can be entered depends on the data type of the variables.

Send value

activates or deactivates set value:

Active: The value is set as a set value.
Inactive: The value entered only serves to index the selection.
Attention: Set value only affects the value, not the function. The function is always sent. Set value must be inactive for a function call without linked variable.

Function

Function that is executed when the entry is selected in Runtime. Click on the ... button to open the dialog for selecting a function.
Attention: The function is only executed if you select the entry via the combo box/list box during runtime. If the triggering value changes and reaches the level of the variable, the function is not executed. Set value must be inactive for a function call without linked variable.

Parameter for substitution

Entry of the character sequence for substitution via parameters. Replaces the key word {PARAM} in the substitution dialog of the screen switching for indices.

Visibility variable

Variables for which the value changes and thus limit violations can be evaluated in Runtime. If there is a limit breach of the visibility variables, the Visibility property is evaluated by this limit breach. It determines if the entry is visible in the list or not. The entry is displayed in the list as standard (there is no limit breach). Clicking on the ... button to open the dialog to select a variable.

Attention: A value change during operation can lead to, with comboboxes, an open combobox being closed.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.

Sorting entries

The entries can be sorted using:

  • Upwards and Downwards buttons: Highlight the desired element and move it with the buttons.
  • Drag & drop: Drag the element to the desired place with the mouse. A red line displays the point where the element is inserted.

Dynamic combobox or list box

For dynamic operation, a string variable that defines the content must be linked using the Variable property. Any static entries that may be configured at the same time in Runtime are ignored. The value of the content variable is evaluated and interpreted. To do this, the value of the variables must correspond to a valid layout in Runtime.

Layout

The string value displays a list of entries. Each entry consists of a value and a text that is separated with a comma ",". Entries are concluded with a semi-colon ";". If the text part of an entry contains an "@" character, the text part is translated with the help of the existing language table.

Example of a valid string value:

1,one;2,two;3,three;

Example of a valid string value with translation:

1,@one;2,@two;3,@three;

Configuration

To link a variable:

  1. Open the Representation group.
  2. Select the display type using the Type property: Combobox or List box.

    Default value Listbox

  3. Activate the property Entries from string variable
  4. Select, using the Variable property, the desired variable
    (clicking on the ... button opens the dialog for variable selection)
  5. Select the string variable with the configured entries

Mark element in list when selected

The elements displayed in the combo box or list box can be marked in color in runtime. To do this:

  • navigate to Group Color in properties
  • select Properties in the group Colors static
    • Text color when selected for the text color
    • Background color for selected entry for the text background color

These colors are then used during runtime. Operating system settings are ignored, as are the colors of linked variables.

info Information

The colors of the operating system were used up to version 6.50. When converting the project:

  • the background color is set to that configured in the operating system
  • if the text color is set as a statically defined color

On computers where the colors have been changed in the operating system, this may lead to different behavior during runtime.

Error treatment

Errors are displayed as log entries in the Diagnosis Server:

Message | Level | Meaning
The value '%s' of the content variable '%s' is not valid, entries might be incorrect or missing! | Error | The string variable linked in the Variable property has a value with invalid layout. The text is evaluated as far as possible. The current value is also logged to make error analysis in Runtime easier.


Dynamic text

Manual -> Screens -> Screen elements -> Dynamic text

With the Dynamic Text dynamic element, you display the current limit value text in the event of the limit being breached or display the value of a string variable in alphanumeric form. If there is no limit violation, the text defined in the Editor is displayed.

To create a dynamic text in a screen:

  1. Select the Dynamic text symbol in the Elements tool bar
  2. Select the start point in the main window.
  3. Pull open the element while pressing and holding the left mouse button.
  4. the dialog to select a variable opens
  5. Select the desired variable
  6. Define the desired properties in the properties window Above all:

    Select the type for Display text. If limit value text is selected here, then stipulate the text that is displayed as long as there is no limit value breach in the Text property.

Behavior in Runtime

Value for Display text:

Variable unit: The element is updated as soon as a Unit conversion function is executed.

Limit text: The color from the limit text is used for the text. If a dynamic color has been configured for the element, this is used.

Language file

The language of all displayed content of the display text types is translated if the language file contains corresponding entries.
Exception: The variable name is not translated.


Ellipse

Manual -> Screens -> Screen elements -> Ellipse

To draw an ellipse:

  1. select the Ellipse/Circle symbol in the Elements tool bar or in the Elements drop-down list
  2. select the start point in the main window
  3. pull open the ellipse while pressing and holding the left mouse button
  4. The shape, size and position can be changed at any time by pulling the vertexes or moving the element
  5. If you press and hold the Alt key while pulling the outer corner points, the change is carried out symmetrically
  6. define the desired properties in the properties window


Circle

Manual -> Screens -> Screen elements -> Circle

In order to draw a circle:

  1. Select the Ellipse/Circle symbol in the Elements tool bar
  2. select the start point in the main window
  3. hold down the shift key
  4. pull open the circle while pressing and holding the left mouse button
  5. The shape, size and position can be changed at any time by pulling the vertexes or moving the element
  6. if you press and hold alt while pulling the outer corner points, the change is carried out symmetrically
  7. if you want the circle to retain its shape press and hold Shift while pulling
  8. define the desired properties in the Properties window


Arc of a circle

Manual -> Screens -> Screen elements -> Arc of a circle

In order to draw an arc of a circle:

  • Select the Arc of a circle symbol in the Elements toolbar
  • select the start point in the main window
  • pull open the arc of the circle while pressing and holding the left mouse button
  • pulling upwards to the right opens the arc of the circle to the left; all directions work along the same lines
  • to change the opening direction, move a central touch point over the opposite line
  • The shape, size and position can be changed at any time by pulling the vertexes or moving the element
  • if you press and hold alt while pulling the outer corner points, the change is carried out symmetrically
  • hold down the shift key whilst moving it and the aspect ratio is maintained
  • define the desired properties in the properties window

info Info

The arc of the circle is always displayed as a quadrant and can be extended by copying and pasting.
Filling patterns and fill colors are not available for arcs of circles.


Segment of a circle

Manual -> Screens -> Screen elements -> Segment of a circle

attention Attention

With the segment of a circle, you draw the desired part of a circle or ellipse.

To draw a segment of a circle:

  1. Select the Segment of a circle symbol in the Elements tool bar
  2. select the start point in the main window
  3. pull on the segment of the circle pressing and holding the left mouse button
  4. pulling upwards to the right opens the segment to the left and vice versa
  5. to change the opening direction, move a central touch point over the opposite line
  6. The shape, size and position can be changed at any time by pulling the vertexes or moving the element
  7. if you press and hold Alt while pulling the outer corner points, the change is carried out symmetrically
  8. hold down the shift key whilst moving it and the aspect ratio is maintained
  9. you have two possibilities to change the opening angle or to open the circle segment upwards or downwards:
    • move the mouse over one of the two divided touch points until the mouse pointer on the outermost of the two points turns into a black cross with arrows and move the point into the desired direction
      or
    • Change the angle settings properties under Opening angle. For example:
      - for opening downwards: End angle [°] 180° and Start angle [°] to 0°
      - for opening downwards:
      Angle data can have a maximum of two decimal points.
      Note: Because the corner points calculated from angle data are pixels, and these must be whole numbers, it can be the case that the angle display deviates from the data somewhat. For example 45° does not give whole number of pixels. It is rounded off internally in zenon and the the angle is displayed as 44.75°.
  10. Define the desired properties in the properties window

Key:

1) touch points for opening angle

2) touch point for height

info Info

If you would like to use the segment of a circle as an arc of a circle, change the Filling pattern property to the value of transparent. Only the outer line is displayed with the transparent display type.
The opening angle must always be > 0° and < 360°.

Attention

The Segment of a circle element is not available in Windows CE.

Segment thickness

The segment thickness of the segment of a circle can be defined with the help of properties from the Segment thickness group. If the Adjustable segment thickness property is activated, then the ellipsis at the start and end angle of the outer edge to the center only displays the thickness set. Thus hose-like forms with different start thicknesses and end thicknesses can be displayed in a curved form.

Both circle-shaped and elliptical segments are supported. The End thickness equals start thickness property is available to display forms with the same thickness.

If 0 is defined as the segment thickness for Thick start angles [pixel] and Thickness end angles [pixel], then an arc of a circle is displayed.

Note on availability: Not available for Graphics quality Windows Basis, for Windows CE project aktiv or for Color gradient With brightness values.


Line

Manual -> Screens -> Screen elements -> Line

To draw a line:

  1. Select the Line symbol in the Elements tool bar
  2. select the start point in the main window
  3. pull out the line while pressing and holding the left mouse button
  4. The shape, size and position can be changed at any time by pulling the vertexes or moving the element
  5. If you press and hold the Alt key while pulling the outer corner points, the change is carried out symmetrically
  6. define the desired properties in the properties window

info Info

Filling patterns and fill colors are not available for lines.


Message element

Manual -> Screens -> Screen elements -> Message element

With the Message Element, you can show text in Runtime depending on the value of process variables. The source for texts are text files, made up as tables. You can configure these freely.

To create the Message Element in a screen:

  1. Select the Message element symbol in the Elements tool bar
  2. Select the start point in the main window.
  3. Pull open the element while pressing and holding the left mouse button.
  4. The dialog to select several variables opens.
  5. Select the desired variables.
  6. Define the desired properties in the properties window

Construction of the table

  • Create a text document.
  • Save it in Unicode format.
  • Use the character |(ASCII-Code 124) as a column separator.
  • Example:

    Off|On|Diff|Fault

    Off|On|True|False

    Text1|Text2|Text3|Text4

  • The linked variables define lines and columns of the text to be shown.

Variable column selection

This variable must be a word variable (UINT) and defines the column position from which the text is taken. At the same time, it controls the type of processing.

bit set | effect
Bit 15 (bit with the highest value | Message element blocked; nothing is displayed any more.
Bit 14 | Update of the screen output switched off; last active text is displayed.

Variables for cell activation

The addressing of cells takes place by means of the bit number and not the numerical value.

The other variables define the cell positions from which the text is taken. The cell positions result from:

Value | Line
1 | Line 1
2 | Line 2
4 | Line 3

Each line variable is responsible for a maximum of 16 lines. If more than 16 lines are needed, further line variables can be defined.

If line 1 and line 2 are to be displayed alternately, the value of the line variable must be 3. If all 16 bits of the first variable are set, lines 1 to 16 are displayed alternately. If all 16 bits of the 2nd variable are set, lines 17 to 32 are displayed alternately.

  • Example:

If the first bit of the first variables and the first bit of the second variable is set, lines 1 and 17 are displayed alternately.


Multibin

Manual -> Screens -> Screen elements -> Multibin

You can define several elements with the Multibin dynamic element:

  • display graphics depending on variable values
  • Color symbols
  • Issue status text
  • link numerical values and binary values
  • display a switch or key for the first variable, provided the first variable is a binary variable

Create the multi binary element

To create a multi-binary in a screen:

  1. Select the Multibin symbol in the Elements tool bar
  2. select the start point in the main window
  3. pull open the element while pressing and holding the left mouse button
  4. the dialog to Assign a variable opens
  5. select the desired variables
  6. Define the desired properties in the properties window

Define statuses

You define the settings for variable statuses to be displayed in the dialog to enter elements:

  1. click on the Representation node
  2. on the Configuration property
  3. the dialog for status definition opens
  4. defined statuses are processed from top to bottom
  5. The settings for the first applicable status are displayed


Multi-binary element

Manual -> Screens -> Screen elements -> Multibin -> Multi-binary element

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Other topics in this chapter

Graphics file

Status texts and screen symbols

Switch settings

To assign the multi binary element to certain statuses:

  1. In the Representation node, click on the Configuration property.
  2. The dialog for inputting elements opens.
  3. Select the desired display type:
    • Graphics file: Representation of the information in pixel graphics files; this also enables moved screens
    • Status Text and Screen Symbol Display of symbols and text information
  4. Defined statuses processed from top to bottom and the setting for the first applicable status are displayed.


Graphics file

Manual -> Screens -> Screen elements -> Multibin -> Multi-binary element -> Graphics file

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Display of the information in graphics files. Also allows moving images.

Type of display

Property | Description
Graphics file | Active: Graphics files are used for the display of the states in Runtime. Their configuration is explained here.
Status texts and screen symbols | Active: Status text and screen symbols are used for the display of statuses in Runtime. The symbol or the element group must already be present on the screen. The symbol shown in the drop-down list flashes on the screen until the Enter element dialog is closed. Its configuration is explained in the Status text and screen symbol chapter.
In original size | Active: Graphics are displayed in original size. Inactive: Graphics are stretched or compressed to the display size.

Options

Property | Description
Display status | Highlights the element in runtime with a red dot at exception status.
Recognize flashing of all variables | Active: Sum alarming of all linked process variables. The graphics or color are determined by the current status. Active flashing states remain kept until quitting.

Status 0 (LOW)

Property

Description

Status 0 (LOW)

Settings for the current status in line with display type.

Graphics

Selection of graphics. A click on the ... button opens the file selection dialog.

  • If desired files in the Files/Graphics nodes are not yet present in the Project Manager, these can be added in the selection dialog.
  • to select a file directly from any desired folder on the computer, the Direct file selection property must be activated.

Further statuses

Property

Description

Further statuses

Select further variables via the ... button and sorting of statuses via the Upwards and Downwards buttons.

For each of the linked variables, there must be a discrete status defined; this is defined by entering the values for multibit information and numerical values. Multibit values must be assigned several times: Number of statuses minus 1; example double message=3.

If a discrete state has occurred, it is displayed. If none of the indicated values is present, the status 0 [LOW], globally valid for the element, is displayed.

Note: For non-binary variables, the value is entered in the signal resolution.

Switch settings

If a binary variable is linked as the first variable, this can be used as a switch or momentary switch.
For configuration, see the Switch settings chapter.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Status texts and screen symbols

Manual -> Screens -> Screen elements -> Multibin -> Multi-binary element -> Status texts and screen symbols

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Display of symbols and text information. The color of the current status is transferred to the symbol at the same time.

Type of display

Property | Description
Graphics file | Active: Graphics files are used for the display of the states in Runtime. Their configuration is explained in the Graphics file chapter.
Status texts and screen symbols | Active: Status text and screen symbols are used for the display of statuses in Runtime. The symbol or the element group must already be present on the screen. The symbol shown in the drop-down list flashes on the screen until the Enter element dialog is closed. Their configuration is explained here.
Display status text | Active: Status texts are displayed in Runtime.
Background color can be set | Active: The background color for the text can be freely chosen.

Options

Property | Description
Display status | Active: Highlights the element in Runtime with a red dot with exception status.
Color only filling area | Active: Only the fill areas of the static elements are colored, the border stays the same
Recognize flashing of all variables | Active: Sum alarming of all linked process variables. The graphics or color are determined by the current status. Active flashing states remain kept until quitting.
Fill color for flashing | Background color when flashing. Clicking on the color opens the dialog to select the color.

Status 0 (Low)

Property | Description
Status text | Text that it is displayed in runtime. Input is only possible if the Display status text property is active.
Symbol color/text color | Select the color for the symbol and status text. Clicking on the color opens the dialog to select the color.
Text background color | Selection of the background color for the status text. Clicking on the color opens the dialog to select the color. Only available if the configurable background property is active.

Further statuses

Property

Description

Further statuses

Select further variables via the ... button and sorting of statuses via the Upwards and Downwards buttons.

For each of the linked variables, there must be a discrete status defined; this is defined by entering the values for multibit information and numerical values. Multibit values must be assigned several times: Number of statuses minus 1; example double message=3.

If a discrete state has occurred, it is displayed. If none of the indicated values is present, the status 0 [LOW], globally valid for the element, is displayed.

Note: For non-binary variables, the value is entered in the signal resolution.

Status text

Text that it is displayed in runtime. Input is only possible if the Display status text property is active.

Symbol color/text color

Select the color for the symbol and status text. Clicking on the color opens the dialog to select the color.

Text background color

Selection of the background color for the status text. Clicking on the color opens the dialog to select the color.

Only available if the configurable background property is active.

Switch settings

If a binary variable is linked as the first variable, this can be used as a switch or momentary switch.
For configuration, see the Switch settings chapter.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Switch settings

Manual -> Screens -> Screen elements -> Multibin -> Multi-binary element -> Switch settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If a binary variable is linked as the first variable, this can be used as a switch or momentary switch.

Property | Description
Read only | Active: It is not possible to input setpoints in runtime.
Switch | Active: Element acts as a switch for setpoint input.
Momentary switch On | Active: Writes setpoint HIGH. The preferred position for the switch goes to Off.
Momentary switch OFF | Active: Writes setpoint LOW. The preferred position for the switch goes to On.
Holding time in ms | Holding time of the setpoint status in milliseconds.
Authorization groups | Defines the necessary authorization level for set value element.
Key combination | Key combination for set value input
Remove | Removes key combination


Polygon

Manual -> Screens -> Screen elements -> Polygon

To draw a polygon:

  1. Select the Polygon symbol in the Elements toolbar
  2. In the main window, select the start point by clicking the left mouse button
  3. pull the first section
  4. place an initial corner point with a simple mouse click (left)
  5. draw another line and place the corner points
  6. set the end point by double clicking or pressing the escape key
  7. The shape, size and position can be changed at any time by pulling the vertexes or moving the element
  8. hold down the shift key when pulling; this way, only horizontal or vertical movements away from the original position are possible
  9. Define the desired properties in the properties window

    Hint: You define the rounding of the lines with the Rounding property. To do this, select a value between 0 (no rounding) and 1 (maximum rounding).

Adding corners:

To add corners (corner points):

  • move the mouse cursor to a line of the polygon:
  • right-click
  • select menu item Adding a node in the selected element from the context menu

or:

  • press Ctrl and Shift simultaneously
  • move the mouse cursor to a line of the polygon:
  • the mouse cursor changes to an arrow with a plus-symbol
  • left-click in order to add a corner

Removing corners:

  • move the mouse cursor to a corner of the polygon:
  • right-click
  • select menu item Deleting the node in the selected element from the context menu

or:

  • press Ctrl and Shift simultaneously
  • move the mouse cursor to a corner of the polygon:
  • the mouse cursor changes to an arrow with a plus-symbol
  • left-click to delete the corner

info Information

The With brightness values property is not available for polygons.


Polyline

Manual -> Screens -> Screen elements -> Polyline

To draw a polyline:

  1. Select the Polyline symbol in the Elements toolbar
  2. In the main window, select the start point by clicking the left mouse button
  3. pull the first section
  4. place an initial corner point with a simple mouse click (left)
  5. draw another line and place the corner points
  6. set the end point by double clicking or pressing the escape key
  7. The shape, size and position can be changed at any time by pulling the vertexes or moving the element
  8. hold down the shift key when pulling; this way, only horizontal or vertical movements away from the original position are possible
  9. Define the desired properties in the properties window

    Hint: You define the rounding of the lines with the Rounding property. To do this, select a value between 0 (no rounding) and 1.

Adding corners:

To add corners (corner points):

  • move the mouse cursor to a line of the polygon:
  • right-click
  • select menu item Adding a node in the selected element from the context menu

or:

  • press Ctrl and Shift simultaneously
  • move the mouse cursor to a line of the polygon:
  • the mouse cursor changes to an arrow with a plus-symbol
  • left-click in order to add a corner

Removing corners:

  • move the mouse cursor to a corner of the polygon:
  • right-click
  • select menu item Deleting the node in the selected element from the context menu

or:

  • press Ctrl and Shift simultaneously
  • move the mouse cursor to a corner of the polygon:
  • the mouse cursor changes to an arrow with a plus-symbol
  • left-click to delete the corner

attention Attention

If you shape a polyline to a polygon and the Invert background option is active, the sizing handles for the start and end of the line are invisible when overlapping. You deactivate this option at Options -> Settings -> Corner points - Invert background.


Rectangle

Manual -> Screens -> Screen elements -> Rectangle

To draw a rectangle:

  1. Select the Rectangle symbol in the Elements tool bar
  2. select the start point in the main window
  3. drag the rectangle while pressing and holding the left mouse button
  4. The shape, size and position can be changed at any time by pulling the vertexes or moving the element
  5. If you press and hold the Alt key while pulling the outer corner points, the change is carried out symmetrically
  6. define the desired properties in the properties window

    Hint: You can round the corners at will in order to created a rectangle with rounded corners


Square

Manual -> Screens -> Screen elements -> Square

In order to draw a square:

  1. Select the Rectangle symbol in the Elements tool bar
  2. hold down the shift key
  3. select the start point in the main window
  4. pull open the square while pressing and holding the left mouse button
  5. The shape, size and position can be changed at any time by pulling on the corner points or moving the element;
    if the 'square' shape is to be retained hold down the shift key whilst pulling on the corner points
  6. if you press and hold alt while pulling the outer corner points, the change is carried out symmetrically
  7. define the desired properties in the properties window


Pipe

Manual -> Screens -> Screen elements -> Pipe

To draw a tube:

  1. select the Pipe symbol in the Elements tool bar
  2. In the main window, select the start point by clicking the left mouse button
  3. pull the first section
  4. place an initial corner point with a simple mouse click (left)
  5. draw another line and place the corner points
  6. set the end point by double clicking or pressing the esc key
  7. The shape, size and position can be changed at any time by pulling the vertexes or moving the element
  8. hold down the shift key when pulling; this way, only horizontal or vertical movements away from the original position are possible
  9. Define the desired properties in the properties window

    Hint: You define the rounding of the lines with the Rounding property. To do this, select a value between 0 (no rounding) and 1 (maximum rounding).

Adding corners:

To add corners (corner points):

  • move the mouse cursor to a line of the polygon:
  • right-click
  • select menu item Adding a node in the selected element from the context menu

or:

  • press Ctrl and Shift simultaneously
  • move the mouse cursor to a line of the polygon:
  • the mouse cursor changes to an arrow with a plus-symbol
  • left-click in order to add a corner

Removing corners:

  • move the mouse cursor to a corner of the polygon:
  • right-click
  • select menu item Deleting the node in the selected element from the context menu

or:

  • press Ctrl and Shift simultaneously
  • move the mouse cursor to a corner of the polygon:
  • the mouse cursor changes to an arrow with a plus-symbol
  • left-click to delete the corner


Switch

Manual -> Screens -> Screen elements -> Switch

You show the value of a binary variable in graphic form and modify it with the Switch dynamic element. The element can also be used as a switch for one-stage unsecured command processing.

To create Switch in a screen:

  • Select the Switch symbol in the Elements toolbar
  • select the start point in the main window
  • pull open the element while pressing and holding the left mouse button
  • the dialog to select a binary variable opens
  • select the variable you want to assign
  • define the desired properties in the properties window

    To use the element as a switch, activate the Momentary switch property in the Write set value node


Static text

Manual -> Screens -> Screen elements -> Static text

The element offers the possibility to use embedded fonts.

To enter statistical text:

  1. select the Statistical Text symbol in the Elements tool bar
  2. select the start point in the main window
  3. pull the text field open while pressing and holding the left mouse button
  4. The shape, size and position can be changed at any time by pulling the vertexes or moving the element
  5. if you press and hold the alt key while pulling the outer corner points, the change is carried out symmetrically
  6. Define the desired properties in the properties window

To enter text:

  1. click on the text field with a delayed double click

    or: select Edit in the context menu

  2. write the desired text

info Information

The text is automatically wrapped as standard, depending on the size of the text field. To turn off the wrapping, deactivate the property Automatic word wrap in the Representation node.

Hint: If a Textwinkel [°] (Representation) is defined in the property, it is not possible to wrap the text. An angle display with text wrapping can also be achieved by rotating the whole element (including the frame lines, if activated).

Underline

To underline text, place a & in front of the text to be underlined.

&Text becomes:

If you would like to use the character '&' in text, enter it twice:
1 && 2 becomes 1 & 2.

Line break

To define a line break, use the string \n.

Example:

Line 1 \n

Line 2

info Information

Input is no longer limited to 80 characters from version 6.51 onwards.


Move symbol (up to version 6.22 only)

Manual -> Screens -> Screen elements -> Move symbol (up to version 6.22 only)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the Move Symbol dynamic element, you can move elements you wish to move horizontally or vertically or change their size (zoom) regardless of the status of other variables. To do this, connect the elements to a symbol.

To create Move Symbol in a screen:

  • select the Move Symbol symbol in the Elements tool bar
  • select the start point in the main window
  • pull open the element while pressing and holding the left mouse button
  • select the desired variable and define the desired properties in the properties window
  • You can only use symbols that are already in the screen

The Move Symbol dynamic element is available up to version 6.22. From version 6.50, use dynamic properties of an element such as Position, Size and rotation dynamic or Color for all dynamic actions.


Trend element

Manual -> Screens -> Screen elements -> Trend element

With the Trend Element dynamic element, you display all values in runtime in the form of trend curves, where several process variables can be displayed at the same time.

In order for the Trend Element to display values, the Harddisk data storage active property in the Harddisk data storage node of variable properties must be active. Cycle time [s] and Number of values must correspond to the Update time and the Period of representation in the trend element, otherwise the drawing of the curve is restarted every time the screen is called up. Each change can have an effect on other Trend Elements that use the same process variables.

Create a Trend Element:

To create a Trend Element in a screen:

  1. select the Trend Element symbol in the Elements tool bar or in the Elements drop-down list
  2. select the start point in the main window
  3. pull open the element while pressing and holding the left mouse button
  4. the dialog to assign several numeric variables opens
  5. select the desired variables
  6. all curves are automatically created in the Trend Element

    To add a curve later:

    • In properties, select the {Curve new} property in the Curves node

      or:

    • drag the desired variable onto the Trend-Element while holding the left mouse button
  7. Define the desired properties in the properties window
    • You define Graphic properties of the curves in the Curves node of properties
    • You determine cycle time and number of values in the properties of the respective variable in the Harddisk data storage node

info Information

Functions and variables can also be linked to the Element by Drag&Drop. If no curves have been defined in he Editor, the trend element is not shown in Runtime.


Clock

Manual -> Screens -> Screen elements -> Clock

With the Clock dynamic element, you show the current time in Runtime or you convert numerical values into a time. The date/and or the time can be displayed as an absolute time period or a time difference.

Display

The display in Runtime depends on whether a variable was linked.

  • If no variable is linked to the element, the current system time is displayed in absolute time in Runtime.
    To do this, set, in the Representation group, the Type of display property to the value System time/absolute time.
  • If a variable is linked, then its value can be displayed as:
    • Time difference: The variable must contain the number of seconds.
      The integer values in the seconds area -2147483648 (min(DINT)) to + 4294967295 (max(UDINT)) can be displayed.
      It is also possible to display negative values: A variable value of -60 is displayed in mm:ss format as -01:00. Thus if -01:40 is this displayed, the resulting variable value is -100.
    • Absolute time period: The Unix time - the seconds passed since January 1, 1970 00:00 UTC in the positive range.

      Only positive values up to 2147483647 can be displayed. A variable value outside this area leads to an incorrect display: The hh:mm part remains 00:00 or 01:00 in winter time.

Engineering

To create a Clock in a screen:

  1. select the Clock symbol in the Elements tool bar or in the Elements drop-down list
  2. select the start point in the main window
  3. pull open the element while pressing and holding the left mouse button
  4. If a variable is to be linked, then:
    Link the desired variable in the Variable / function section or by dragging & dropping the element
    • All variables can be linked, with the exception of STRING and BOOL variables.
    • The fractions of FLOAT variables (from data types REAL and DATA_AND_TIME for example) are not taken into account.
  5. Define the desired properties in the properties window, most of all:
  6. Select the Type of display property in the Representation group
    • System time/absolute time period The time is displayed as an absolute time.
      Note: Context menu and tooltip are not supported.
    • Time difference: The time difference is given in minutes and seconds The linked variable must contain the number of seconds.
      The integer values in the seconds area -2147483648 (min(DINT)) to + 4294967295 (max(UDINT)) can be displayed. It is therefore also possible to display negative values.
      Examples in mm:ss format: The variable value 50 is displayed as 00:50, the variable value 100 is displayed as 01:40.
      The variable value -60 is displayed as -01:00. Thus if -01:40 is this displayed, the resulting variable value is -100.
  7. Select the desired display using the Formating property

info Information

With absolute time period with the Write set value via element, the input field has time difference formatting.

For example:

  • Formatting of the absolute time period hh:mm:ss dd.mm.yy
    is displayed in the element as: dd:hh:mm:ss
  • dd.mm.yyyy (for example 17.12.2008)
    as ddddd (14230 days since 1. 1. 1970).


Universal slider

Manual -> Screens -> Screen elements -> Universal slider

With the Universal slider element, you show variables in the form of sliders, bar graphs, LED bar displays or any other sliders you wish. The sliders allow set value elements to be set in runtime.

To create the universal slider in a screen:

  1. select the Universal Slider symbol in the Elements tool bar or in the Elements drop-down list
  2. select the start point in the main window
  3. pull open the element while pressing and holding the left mouse button
  4. the dialog to assign a variable opens
  5. select the variable you want to assign
  6. the universal slider configuration assistant opens

  7. select the alignment:
    horizontal, vertical or round

  8. select the shape:
    slider/turn-around, bar, LED bars or moving scale

  9. You a given a preview:
    Define the title display and position of the value display.

  10. You define other properties in the properties window

    Hint: You change the display and shape of a universal slider in properties in the Universal slider node

info Information

A drag indicator can display the minimum or maximum value of the variables within a certain period of time. Double-clicking the element in runtime resets the marking of minimum and maximum.

Color-coded display of the limit violation

At limit violations the color from the variable can color the whole area or only the area starting from the limit violation. This functionality is controlled via property Bar explicit in group Universal slider.

This property affects only the display of values with defined limits from variables. Limits from reaction matrices are not considered.

  • Active: If a limit value of the linked variable is breached, only the part of the display that goes into the limit value breach is shown in the color of the respective limit value.
    If the variable has several defined limit values, the corresponding areas of the display are each shown in the color of the limit value.
  • Inactive: If a limit of the linked variable is violated, the complete display is displayed in the color of the violated limit.

Default: inactive


WPF element

Manual -> Screens -> Screen elements -> WPF element

With the WPF dynamic element, valid WPF/XAML files in zenon can be integrated and displayed.

info Information

All brand and product names in this documentation are trademarks or registered trade marks of the respective title holder.


Basics

Manual -> Screens -> Screen elements -> WPF element -> Basics

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

XAML

XAML stands for Extensible Application Markup Language. The description language developed by Microsoft and based on XML defines the syntax in Silverlight applications and WPF user interfaces. XAML makes it possible to separate design and programming. The designer prepares the graphical user interface and creates basic animations that are then used by the developers/project planners. The project planner can control these .xaml files in a purposeful manner and animate them accordingly.

WPF

WPF stands for Windows Presentation Foundation and describes a graphics framework that is part of the Windows .NET framework:

  • WPF displays the programming environment.
  • XAML describes, based on XML, the interface hierarchy as a markup language. Depending on the construction of the XAML file, there is the possibility to link properties, events and transformations of WPF elements with variables and functions of
    CD_PRODUCTNAME<.
  • The framework unites the different areas of presentation such as user interface, drawing, graphics, audio, video, documents and typography.

Microsoft .NET 3.5 or higher is required for execution.


WPF in process visualization

Manual -> Screens -> Screen elements -> WPF element -> Basics -> WPF in process visualization

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

XAML makes different design possibilities possible for zenon. Display elements and dynamic elements can be adapted graphically regardless of the project planning. For example, laborious illustrations are first created by designers and then imported into zenon as an XAML file and linked to the desired logic. There are many possibilities for using this, for example:

Dynamic elements in analog-look

Graphics no longer need to be drawn in zenon, but can be imported directly as an XAML file. This makes it possible to use complex, elaborately illustrated elements in process visualization. Reflections, shading, 3D effects etc. are supported as graphics. The elements that are adapted to the respective industry environment make intuitive operation possible, along the lines of the operating elements of the machine.

Intricate illustrations for intuitive operation

The integration of XAML-based display elements improves the graphics of projects and makes it very easy to display processes clearly. Elements optimized for usability make operation easier. A clear display of data makes it easier to receive complex content. The flexible options for adapting individual elements makes it easier to use for the operator. It is therefore possible for the project planners to determine display values, scales and units on their own.

Clear presentation of data and summaries

Grouped display elements make it possible to clearly display the most important process data, so that the equipment operator is always informed of the current process workflow. Graphical evaluations, display values and sliders can be grouped into an element and make quick and uncomplicated control possible.

Industry-specific displays

Elements such as thermometers, scales or bar graphs are part of the basic elements of process visualization. It is possible, using XAML, to adapt these to the respective industry. Thus equipment operators can find the established and usual elements that they already know from the machines in process visualization at the terminal.

Adaptation to corporate design

Illustrations can be adapted to the respective style requirements of the company, in order to achieve a consistent appearance through to the individual process screen. For example, the standard operation elements from zenon can be used, which can then be adapted to color worlds, house fonts and illustration styles of the corporate design.


Transfer of values from zenon to WPF

Manual -> Screens -> Screen elements -> WPF element -> Basics -> Transfer of values from zenon to WPF

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon always works internally with the double or string. These are sent to the WPF element. The WPF element is embedded in a .NET container. It usually needs to be converted so that the data type can be used. This conversion can automatically be carried out by .NET.

The values are sent in accordance with the following rules:

  • If the .NET type (System.Object) for zenon is not evident, the value is sent as it is to .NET. .NET must take care of the display or conversion itself.
  • If the .NET type is a Boolean type (System.Boolean), then zenon writes according to the .NET convention 0 or -1.
  • If the .NET type is known, a check is carried out to see if .NET can convert the value. The converter from .NET is used for this.
    • Yes: The value is sent.
    • No: The value is sent nevertheless. If .NET reacts with an error message, the value of zenon is converted into a string and sent again.


Referenced objects

Manual -> Screens -> Screen elements -> WPF element -> Basics -> Referenced objects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In WPF not only standard objects such as rectangles, buttons, text fields, etc. can be used, but also WPF user controls, which are referenced as assemblies.

WPF user controls are individually created objects. For example, this element can look like a tacho and provide special properties and optical effects, such as a "Value" property, which causes the pointer of the tacho to move and display the value when it is set.

The workflow for this:

  • The appearance of a user controls is labeled with standard objects, which are offered by WPF.
  • The properties and interactions are programmed.
  • The whole package is compiled and present in the form of a .NET assembly.

This assembly can also be used for WPF projects. To do this, it must be referenced (linked) in the WPF editor (for example: Microsoft Expression Blend). To do this, select the assembly in the zenon file selection dialog:

From this point in time, the WPF user controls of the assembly in the tool box can be selected under Custom user controls and used in the WPF project.

Used referenced assemblies in zenon

To use an assembly in zenon, this must be provided as a file.
Collective files in .cdwpf format administer these independently; no further configuration is necessary. Assemblies must be added to the Files folder for .xaml files:

  • Click on Files on the project tree
  • Select Other
  • Select Add file... in the context menu
  • The configuration dialog opens
  • Insert the desired assembly

When displaying a WPF file in the WPF element (Editor and Runtime), the assemblies from this folder are loaded. It is thus also ensured that that when the Runtime files are transferred using Remote Transport, all referenced assemblies are present on the target computer.

A collective file (.cdwpf) can exist alongside an XAML file with the same name. All assemblies (*.dll) from all collective files and the Other folder are copied to the work folder. Only the highest file version is used if there are several assemblies with the same name.

attention Attention

Assemblies are only only removed after loading when the application is ended. That means:

If a WPF file with a referenced assembly in zenon is displayed, then this assembly is loaded is in the memory until zenon is ended, even if the screen is closed again. If you would like to remove an assembly from the Files/Other folder, the Editor must first be restarted, so that the assembly is removed.

Multi-project administration

With multi-project administration, the same assembly must be used in all projects. If an assembly is replaced by another version in a project, it must also be replaced in all other projects that are loaded in the Editor or in Runtime.


Allocation of zenon object to WPF content

Manual -> Screens -> Screen elements -> WPF element -> Basics -> Allocation of zenon object to WPF content

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon objects are allocated to WPF content using the name of the WPF object. In doing so, note:

Visual objects do not have a RuntimeNamePropertyAttribute property. Therefore at the time when the WPF content is loaded and created, the additional information of name is not available.

Thus a clear allocation of zenon objects to WPF objects is not possible. Therefore only logical objects are listed in the configuration dialog of zenon. Which WPF objects the RuntimeNamePropertyAttribute has available is visible in MSDN or on the Microsoft website.

Workaround

Nevertherless, the following workaround is possible to animate visual objects:

For visual elements, the animateable property is linked to the text property of an invisible text box using a data connection.

Because the text box as a logical object supports the name property, this is displayed in zenon.

The textbox property can also be animated with zenon.

This visual object is also indirectly animated as a result.


Workflows

Manual -> Screens -> Screen elements -> WPF element -> Basics -> Workflows

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The WPF/XAML technology makes new workflows in process visualization possible. The separation of design and functionality ensures a clear distinction of roles between the project planners and designers; design tasks can be easily fulfilled by using pre-existing designs, which no longer need to be modified by the project planner.

The following people are involved in the workflow to create WPF elements in zenon:

  • Designer
    • illustrates elements
    • takes care of the graphics for MS Expression Design
  • MS Expression Blend operator
    • Animates elements
    • Creates variables for the animation of WPF elements in zenon, which project planners can access
  • Project planner
    • Integrates elements into zenon:
    • stores logic and functionality

We make a distinction:

  • Workflow with Microsoft Expression Blend
  • Workflow with Adobe Illustrator


Workflow with Microsoft Expression Blend

Workflow with Microsoft Expression Blend

When using Microsoft Expression Blend, a WPF element is created in four stages:

  1. Illustration of elements in MS Expression Blend
  2. Open element in MS Expression Design and export as WPF
  3. Animation in MS Expression Blend
  4. Integration into zenon

You can find an example for creating a WPF elements with Microsoft Expression Blend in the Create button as XAML file with Microsoft Expression Blend chapter.


Workflow with Adobe Illustrator

Workflow with Adobe Illustrator

Based on traditional design processes with Adobe Illustrator the following workflow is available:

  1. Illustration of elements in Adobe Illustrator
  2. Import of .ai files and preparation in MS Expression Design
  3. WPF export from MS Expression Design
  4. Animation in MS Expression Blend
  5. Integration into zenon

You can find an example for creation in the Workflow with Adobe Illustrator chapter.


Guidelines for designers

Manual -> Screens -> Screen elements -> WPF element -> Guidelines for designers

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This section informs you how to correctly create WPF files in Microsoft Expression Blend and Adobe Illustrator. The tutorials on Creating a button element and a bar graph element show you how fully functional WPF files for zenon can be created from pre-existing graphics in a few steps.

The following tools were used for this:

  • Adobe Illustrator CS3 (AI)
  • Microsoft Expression Design 4 (ED)
  • Microsoft Expression Blend 4 (EB)
  • zenon 6.51

info Information

If referenced objects (assemblies) are used in WPF, note the instructions in the Referenced objects chapter.


Workflow with Microsoft Expression Blend

Manual -> Screens -> Screen elements -> WPF element -> Guidelines for designers -> Workflow with Microsoft Expression Blend

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With Microsoft Expression Blend, a WPF element:

  • is illustrated
  • is converted into WPF format using MS Expression Design
  • animated

The following example shows the illustration and conversion of a button element into an XAML file.

Note: A test version of "Microsoft Expression Blend" can be downloaded from the Microsoft website.


Create button as an XAML file with Microsoft Expression Blend

Manual -> Screens -> Screen elements -> WPF element -> Guidelines for designers -> Workflow with Microsoft Expression Blend -> Create button as an XAML file with Microsoft Expression Blend

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Create button as an XAML file with Microsoft Expression Blend

Create button

  1. Start Expression Blend
  2. select the New Project option

  3. Select WPF as project type
  4. give it a path and name of your choice (MyBlendProject, for example)

    The Language and Version settings can be ignored, because no functionality is to be programmed.

  5. After the dialog has been confirmed with OK, Microsoft Blend creates a new project with the chosen settings. Expression Blend adds an empty XAML file which already contains a class reference.
  6. Delete the CS file that belongs to the XAML file using the context menu.
  7. Rename the XAML file MainControl.xaml to MyButton.xaml.
  8. The development size of the file is set at 640 x 480 pixels as standard and must still be changed:
    1. switch to XAML view
    2. correct the size to 100 x 100 pixels
    3. Delete the class reference x:Class="MyBlendProject.MyButton"

  9. switch to Design view

  10. add a button via the tool bar
  11. define the properties
    • Width: 50
    • Height: 50
    • Margins: 25

    The button is therefore at the center of the control.

  12. Save the changes and open the file in Internet Explorer to check it. You will see that the button is displayed in a size of 50 x 50 pixels.

Make button scalable

If you integrate this status into zenon, the button will always have the exact size of 50 x 50 pixels. Because the button can be implemented as a scalable button, switch to Expression Blend again:

  1. select the button in the tree view
  2. select the Group Into->Viewbox button in the context menu
  3. the button is inserted into a Viewbox
  4. Define the properties of the viewbox
    • Width: Auto
    • Height: Auto
  5. save the file

  6. If you now open the file in Internet Explorer, the button is automatically scaled when the IE window size is changed. This file will now also automatically adapt to changes in the size of the WPF element in zenon.

Change name

Before you can integrate the file into zenon, you must give the WPF element a name. The WPF elements are not named in Expression Blend as standard, and are labeled with square brackets and their type. zenon content is assigned to WPF content via the name of the WPF elements:

  • in tree view, change the name
    • of the button on MyButton
    • of the ViewBox to MyViewBox

This button can now be integrated in zenon as an XAML file.


Workflow with Adobe Illustrator

Manual -> Screens -> Screen elements -> WPF element -> Guidelines for designers -> Workflow with Adobe Illustrator

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When Adobe Illustrator is used, a WPF element:

  • is illustrated in Adobe Illustrator
  • is converted into a WPF in MS Expression Design
  • is animated in MS Expression Blend

The following example shows the illustration and conversion of a bar graph element into an XAML file.


Bar graph illustration

Bar graph illustration

A bar graph is created in Adobe Illustrator.

  1. AI: Starting element for bar graph

    Illustrated in Adobe Illustrator CS3.

  2. AI: Path view of bar graph in Adobe Illustrator

    • All effects must be converted (Object -> Convert appearance)
    • All lines are transformed into paths (Object -> Path -> Contour line)
    • Do not use filters such as shading, blurring etc.

Notes on compatibility

Illustrations that were created with Adobe Illustrator are in principle suitable for WPF export. However, not all Illustrator effects can become corresponding effects in Expression Design/Blend. Note:

Effect

Description

Clipping masks

Clipping masks created in Adobe Illustrator are not correctly interpreted by Expression Design. These are usually shown in Blend as areas of black color.

We recommend creating illustrations without clipping masks.

Filters and effects

Not all Adobe Illustrator filters are transferred into Expression Design accordingly: Thus blurring filters, shading filters and corner effects from Illustrator do not work in Expression Design.

Solution:

  • Most effects can be converted so that they can be read correctly by Expression Design using the Object -> Convert appearance command in Adobe Illustrator.
  • Corner effects from Adobe Illustrator are correctly interpreted by MS Design if they are converted to AI in paths.

Text fields

To be able to link text fields with code, these must be created separately in Expression Blend. "Labels" are required for dynamic texts; simple "text fields" are sufficient for static information.

There is no possibility to create text labels in MS Design. These must be directly created in MS Blend.

Transparencies and group transparencies

There can be difficulties in Adobe Illustrator with the correct interpretation of transparency settings, in particular from group transparency settings.

However MS Expression Blend and MS Expression Design do offer the possibility to create new transparency settings.

Multiply levels

These level settings in Adobe Illustrator are not always correctly displayed by MS Expression Blend.

However, there is the possibility to "Multiply levels" directly in Expression Design.

Indicating instruments and standard positions

To prepare the graphics optimally for animation, the indicator and slider must always be set to the starting position, usually 0 or 12:00 o'clock.

Thus the position parameters for rotations etc. are also correct in Blend and an animation can be implemented without conversion of position data.


WPF export

WPF export

WPF files are required for animation in Microsoft Expression Blend. We recommend Microsoft Expression Design for this export, because it provides good results and most Illustrator effects are correctly interpreted.

Note: There is a free plug-in for the direct export of WPF files from Adobe Illustrator available on the internet. This plug-in provides a quick, uncomplicated way of exporting from Illustrator, however it is less suited to the current application because it lead to graphical losses. Even color deviations from the original document are possible.

Files in .ai format can regularly be imported into Expression Design; the paths are retained in the process.
Attention: Some common Illustrator effects cannot be displayed by Expression Design correctly however (see Illustration chapter).

We export the pre-created bar graph element in 5 stages:

  1. ED: Import
    • Import the prepared Illustrator file in Microsoft Expression Design via File -> Import
  2. ED: Optimization

    • If the starting file is not correctly displayed in MS Expression Design, it can still be subsequently edited and optimized here
  3. ED: Select

    • Highlight the element for WPF export with the direct selection arrow in MS Expression Design; in this case it is the whole clock
  4. ED: Start export

    • Start the export via File -> Export
    • the dialog for configuring the export settings opens
  5. ED: Export settings

    • Enter the following export settings:
    1. Format: XAML Silverlight 4 / WPF Canvas

      Always name objects: Activate with tick

      Place the grouped object in an XAML layout container: Activate with tick

    2. Text: Editable text block
    3. Line effects: Rasterize all

The exported file has .xaml file suffix. It is prepared and animated in MS Expression Blend in the next stage.


Animation in Blend

Animation in Blend

With MS Expression Blend:

  • static XAML files from MS Expression Design are animated
  • Variables for controlling effects that can be addressed by zenon are created

In thirteen steps, we go from a static XAML to an animated element, that can be embedded in zenon:

  1. EB:create project

    1. Open Microsoft Expression Blend
    2. Create a new project
    3. Select the Project type of WPF- >WPF Control Library
    4. Give it a name (in our tutorial: My_Project)
    5. Select a location where it is to be saved
    6. Select a language (in our tutorial: C#)
    7. Select Framework Version 3.5
  2. EB: delete MainControl.xaml.cs

    1. Navigate to MainControl.xaml.cs
    2. Delete this file using the Delete command in the context menu
  3. EB: Open exported XAML file

    1. Open the context menu for My_Project (right mouse button)
    2. Select Add existing element…
    3. Select the XAML file exported from Microsoft Expression Design, in order to open this in Microsoft Expression Blend
  4. EB: Open MainControl.xaml

    1. Open the automatically created MainControl.xaml
    2. In the Objects and Time axes area, navigate to the UserControl entry
  5. EB: Adapt XAML code

    1. Click on UserControl with the right mouse button
    2. Select Display XAML in the contextual menu.
    3. Delete lines 7 and 9 in the XAML code:

      x:Class="My_Project.MainControl"

      d:DesignWidth="640" d:DesignHeight="480"

  6. EB: check XAML code

    • The XAML code should now look like this:

    <UserControl

    xmlns=http://schemas.microsoft.com/winfx/2006/xaml/presentation
    xmlns:x=http://schemas.microsoft.com/winfx/2006/xaml
    xmlns:d=http://schemas.microsoft.com/expression/blend/2008
    xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"

    mc:Ignorable="d"
    x:Name="UserControl">

    <Grid x:Name="LayoutRoot"/>

    </UserControl>

  7. EB: Copy elements

    1. Open the XAML file imported from Expression Design
    2. Mark all elements
    3. Select Delete in the context menu
    4. Change back to the automatically created XAML file
  8. EB: Insert element

    1. Click on Layout Root with the right mouse button
    2. Select Insert
  9. EB: Adapt layout type

    1. Click on Layout root -> Change layout type -> Viewbox with the right mouse button
    2. The structure should now look like this: UserControl -> LayoutRoot -> Grid -> Elements
    3. Give a name for LayoutRoot and Grid by double-clicking on the names
  10. EB: Texts and values

    • Dynamic and static texts are labeled with text fields
    • Values (numbers) are issued with Labels
  11. EB: Insert labels

    • Labels replace numbers that are to be subsequently linked using INT variables (must be carried out for all number elements)
  12. EB: Set property

    • To display 100%, set the bar graph element's MaxHeight property to 341 (the maximum height of the indicator element is 340)
  13. EB: prepare for use in zenon

    1. Delete all name labels (names may only be given for elements that are to be addressed via zenon)
    2. Save the XAML file with any desired name
    3. Integrate the XAML file into zenon

A tip for checking: If the XAML file is displayed with no problems in Microsoft Internet Explorer and the window size of Internet Explorer adapts to it, it will also be correctly used in zenon.


Engineering in zenon

Manual -> Screens -> Screen elements -> WPF element -> Engineering in zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use WPF with zenon, Microsoft Framework 3.5 must be installed on both the editor computer and on Runtime.

Conditions for WPF display in zenon

The animation is currently available for simple variables; arrays and structures cannot be animated. Therefore the following WPF functions can be implemented in zenon:

  • Element properties that correspond to simple data types, such as String, Int, Bool etc.
  • Element properties of the "Object" type, which can be set with simple data types
  • Element events can be used with functions; the parameters of the events are not however available in and cannot be evaluated in zenon
  • Element transformation, for which a render transform is present for the element in the XAML file

    Attention: if the content is outside of the area of the WPF element during transformation, this part of the content is lost or is not labeled

Notes on dBase: No shade can be displayed in zenon for WPF elements.

attention Attention

If the Runtime files were created for a project for a version before 6.50, existing WPF elements are not included into Runtime screens.

Display on Windows 7

If a WPF screen contains a slider and Windows 7 Aero Effects are used, this may lead to refresh problems in zenon Editor.


CDWPF files (collective files)

Manual -> Screens -> Screen elements -> WPF element -> Engineering in zenon -> CDWPF files (collective files)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Rules for the use of collective files:

  • The files can be in the ZIP file directly or in a joint folder.
  • The name of the XAML file should correspond to the names of the collective file.
  • Only one XAML file may be contained.
  • The preview graphic should be small and no more than 64 pixels high.
    Name of the preview file: preview.png or the name of the XAML file with the suffix png.
  • Any number of assemblies can be used. The distinction is made on the basis of the file version in numerical form.
  • Collective files do not need to contain an assembly.
  • All folders are searched and only *.dll, *.xaml and *.png files are taken into account.
  • If a If a collective file (.cdwpf) is replaced by a file with a different version, all corresponding CDWPF files in all symbols and images in all projects must be adapted.


create WPF element

Manual -> Screens -> Screen elements -> WPF element -> Engineering in zenon -> create WPF element

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a WPF element

  1. In the elements toolbar, select the symbol for WPF element or the Elements entry in the menu
  2. Select the start point in the main window.
  3. Pull open the element with the mouse.
  4. In properties, select Representation the propertyXAML file in the group.
  5. The file selection dialog opens.
  6. Select the desired file
    Files of the following formats are valid:
    • *.xaml: Extensible Application Markup Language
    • *.cdwpf: WPF collective file, also shows preview image

    (the file must already be present in the Project Manager under Files/graphics or created in the dialog.)

  7. configure the links.

info Information

If referenced objects (assemblies) are used in WPF, note the instructions in the Referenced objects chapter.


Configuration of the linking

Manual -> Screens -> Screen elements -> WPF element -> Engineering in zenon -> Configuration of the linking

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure a WPF element

  1. In properties, select WPF links the propertyConfiguration in the group.
  2. The dialog with three tabs opens with a preview of the XAML file and the elements present in the file

Dialog Configuration

Parameters

Description

Available elements

Shows the named file elements in a tree structure. The selected element can be linked with process data.

WPF is assigned to process data based on the element name. Therefore elements are only shown if they and the attendant elements have a name. Allocations are configured and shown in the Properties, Events, Transformations tabs.

Preview

The selected element is shown flashing in the preview.

Properties

Configuration and display of properties (variables, authorizations, interlockings, linked values).

Events

Configuration and display of events (functions).

Transformations

Configuration and display of transformations.

Name

Name of the property.

Connection

Selection of link.

Link type

Type of link (variable, authorization, function)

WPF info

Shows the current value for properties in WPF content. For the user, it is directly visible what type of property it is (Boolean, string, etc.).

Linked

Shows if a property is currently being used.

Not contained by default in the view, but can be selected using Context menu->Column selection.

info Information

Only logical objects can be displayed in the configuration dialog. Visual objects are not displayed. You can read about backgrounds and how visual objects can be animated in the Allocation of zenon object to WPF content.

Edit hyperlinks

All configured hyperlinks can be edited from the properties of the element. Click on the element and open the property group WPF links. Hyperlinks can be further configured here, without having to open the dialog.

Limitations:

  • The linking type cannot be changed here.
  • New linkings can only be created via the configuration dialog.
  • Insertion of a WPF elements into a symbol: WPF linkings cannot be exported.


Properties

Properties

The properties enable the linking of:

  • Variables
  • Values
  • Authorizations and interlockings

Parameters |  | Description
Name | Name of the property.
Connection | Linked variable, authorization or linked value. Clicking in the column opens the respective selection dialog, depending on the entry in the Link type column.
Link type | Selection of linking.
WPF info | Shows the current value for properties in WPF content. For the user, it is directly visible what type of property it is (Boolean, string, etc.).
Linked | Shows if a property is currently being used. Not contained by default in the view, but can be selected using Context menu->Column selection.

Create link

To create a link:

  1. Highlight the line with the property that is to be linked
  2. Click in the Link type cell
  3. select the desired link from the drop-down list.

    Available are:

    • <not linked> (deletes an existing link)
    • Authorization/interlocking
    • Variable
    • Value linking
  4. Click in the Link cell
  5. The dialog for configuring the desired link opens

info Information

Properties of WPF and zenon can be different. If, for example the visibility property is linked, there are three values available in .NET:

0 - visible

1 - invisible

2- collapsed

These values must be displayed via the linked zenon variable.


Link authorization or interlocking

Manual -> Screens -> Screen elements -> WPF element -> Engineering in zenon -> Configuration of the linking -> Properties -> Link authorization or interlocking

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Link authorization or interlocking

Authorizations cannot be granted for the whole WPF element. The element is allocated a user level. Authorizations are granted within the user level for individual controls. If an authorization is active, the value 1 is written to the element.

To link an authorization or interlocking with a WPF property:

  1. Highlight the line with the property that is to be linked
  2. Click in the Link type cell
  3. Select Authorization/interlocking from the drop down menu
  4. Click in the Link cell
  5. The dialog for configuring the authorizations opens

Parameters | Description
Link authorization/interlocking | Setting the authorizations.
Linked status | selection of an authorization that is linked to a WPF control from the drop down list. For example, visibility and operability of a WPF button can depend on a user's status.

Authorization | Description
Authorization available | If the user has sufficient rights to operate the WPF element, a value of 1 is written to the property.
Authorization does not exist | If the user does not have sufficient rights to operate the WPF element, a value of 1 is written to the property.
Not interlocked | If the element is not locked, the value 1 is written to the property.
Interlocked | If the element is locked, the value 1 is written to the property.
Can be operated | If authorization is present and the element is not locked, then a value of 1 is written to the property.
Cannot be operated | If authorization is not present or the element is not locked, then a value of 1 is written to the property.


Events

Events

Events make it possible to link zenon functions to a WPF element.

Parameters |  | Description
Name | Name of the property.
Connection | Linked function. Clicking in the cell opens the configuration dialog.
Link type | Selection of linking. Clicking in the cell opens the selection dialog.
WPF info | Shows the current value for properties in WPF content. For the user, it is directly visible what type of property it is (Boolean, string, etc.).
Linked | Shows if a property is currently being used. Not contained by default in the view, but can be selected using Context menu->Column selection.

Link functions

To create a link:

  1. Highlight the line with the property that is to be linked
  2. Click in the Link type cell
  3. Select from the drop down list function
  4. Click in the Link cell
  5. The dialog for configuring the function opens

Parameters |  | Description
Linked function | Selection of the function to be linked. Clicking on the ... button opens the dialog for Function selection.
OK | Accepts selection and closes dialog.
Cancel | Discards changes and closes dialog.
Help | Opens online help.


Transformation

Transformation

The WPF element does not support rotation. If, for example, the WPF element is in a symbol and the symbol is rotated, the WPF element does not rotate with it. Therefore there is a different mechanism for Transformation with WPF to turn elements or to otherwise transform them. These transformations are configured in the Transformation tab.

Attention: If the content is outside of the WPF element area, this part of the contents is lost, i.e. it is not shown.

Parameters

Description

Name

Name of the property.

Connection

Selection of the linked variables.

Transformations are displayed in XAML as transformation objects with their own properties. If an element supports a transformation, then the possible properties of the transformation object are displayed in list view. (more on this in: Integrate button as WPF XAML in zenon

For example, if the linked variable is set at the value of 10, then this value is written as a WPF target and the WPF element is rotated by 10°.

Type of link

Selection of transformation link type.

WPF info

Shows the current value for properties in WPF content. For the user, it is directly visible what type of property it is (Boolean, string, etc.).

Linked

Shows if a property is currently being used.

Not contained by default in the view, but can be selected using Context menu->Column selection.

Link transformations

To link a transformation with a WPF property:

  1. Highlight the line with the property that is to be linked
  2. Click in the Link type cell
  3. Select from the Transformation drop down list
  4. Click in the Link cell
  5. The dialog for configuring the variables opens

The configuration also makes it possible to convert from zenon into WPF units.

Parameters

Description

Linked variables

Selection of the variable to be linked. A click on the ... button opens the selection dialog.

Value range of WPF element

Data to convert variable values into WPF values.

Convert value range

Active: WPF unit conversion is switched on.

Effect on Runtime: The current zenon value (incl. zenon unit) is converted to the WPF range using standardized minimum and maximum values.

For example: The value of a variable varies from 100 to 200. With the variables, the standardized range is set to 100 - 200. The aim is to display this change in value using a WPF rotary knob. For this:

  • for Transformations, the RotateTransform.Angle property is linked to the variables
  • Adjust value activated
  • a WPF value range of 0 to 360 is configured

Now the rotary knob can be turned at a value of 150, for example, by 180 degrees.

Minimum

Defines the lowest WPF value.

Maximum

Defines the highest WPF value.

OK

Accepts settings and ends the dialog.

Cancel

Discards settings and ends the dialog.

Help

Opens online help.


Validity of XAML Files

Manual -> Screens -> Screen elements -> WPF element -> Engineering in zenon -> Validity of XAML Files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

XAML files are valid subject to certain requirements:

  • correct name space
  • no class references
  • Scalability

Correct name space

The WPF element can only display WPF content, i.e.:

Only XAML files with the correct WPF namespace can be displayed by the WPF element. Files that use a Silverlight namespace cannot be loaded or displayed. However, in most cases it is suffice to change the Silverlight namespace to the WPF namespace.

WPF-Namespace:

xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation" xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"

No use of class references

Because the XAML files can be loaded dynamically, it is not possible to use XAML files that contain references to classes ("class" key in header). Functions that have been programmed in independently-created C#- files cannot be used.

Scalability

If the content of a WPF element is adjusted to the size of the WPF element, then the controls of the WPF element are interlaced in a control that offers this functionality, such as a view box for example. n addition, care must be taken to ensure that the height and width elements are configured as automatic.

Checking an XAML file to see if it is correct

To check if an XAML file has the correct format:

  • Open XAML file in Internet Explorer
    • If it can be opened without additional plug-ins (Java or similar), then it can be assumed with a high degree of certainty that this file can be loaded and displayed by zenon
    • if problems occur during loading, these are then shown in Internet Explorer and the lines in which problems arise can be clearly seen

The scaling can also be tested in this manner: If the file has been created correctly, the content will adjust to the size of the Internet Explorer window.

Error message

If an invalid file is used in zenon, then an error message is displayed in the output window when loading the file in the WPF element.

For example:

"error when loading xaml-Datei:C:\ProgramData\COPA-DATA\SQL\781b1352-59d0-437e-a173-08563c3142e9\FILES\zenon\custom\media\UserControl1.xaml

The attribute "Class" cannot be found in XML namespace "http://schemas.microsoft.com/winfx/2006/xaml". Line 7 Position 2."


Pre-built elements

Manual -> Screens -> Screen elements -> WPF element -> Engineering in zenon -> Pre-built elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon is already shipped with several WPF elements. More are available for download in the web shop.

All WPF elements have properties which determine the graphical design of the respective element (Dependency Properties). Setting the values via an XAML file or linking the property via zenon can directly change the look in the Runtime. The following tables contain the respective Dependency Properties, depending on the control.

Elements:

  • Round display
  • Progress bar
  • Vertical bar graph
  • Temperature control
  • Analog clock
  • Universal slider
  • Pareto diagram
  • Sankey diagram
  • Waterfall diagram

Replacing assembly with a newer version

Per project only one assembly for a WPF element can be used in the Editor as well as the Runtime. If two versions of an assembly are available in a project, then the first loaded file is used. A user enquiry is made as to which version should be used. No further actions are needed for the maintenance of the versions used up until now. If a newer version is chosen, all corresponding CDWPF files in all symbols and images in all projects must be adapted.

Note for Multi-Project Administration: If an assembly in a project is replaced by a new version, it must also be replaced in all other projects that are loaded in the Editor or in Runtime.


Circular gauge control

Circular gauge control

Property

Function

Value

CurrentValue

Current value which should be displayed.

Double

IsReversed

Scale orientation - clockwise or anti-clockwise

Boolean

ElementFontFamily

Element font.

Font

MinValue

Minimum value of the scale.

Double

MaxValue

Maximum value of the scale.

Double

ScaleRadius

Radius of the scale.

Double

ScaleStartAngle

Angle at which the scale starts.

Double

ScaleLabelRotationMode

Alignment of the scale caption.

Enum:

  • None
  • Automatic
  • SurroundIn
  • SurroundOut

ScaleSweepAngle

Angel area which defines the size of the scale.

Double

ScaleLabelFontSize

Font size of the scale caption.

Double

ScaleLabelColor

Font color of the scale caption.

Color

ScaleLabelRadius

Radius on which the scale caption is orientated.

Double

ScaleValuePrecision

Accuracy of the scale caption.

Integer

PointerStyle

Shape of the pointer displaying the value.

Enum:

  • Arrow
  • Rectangle
  • TriangleCap
  • Pentagon
  • Triangle

MajorTickColor

Color of main ticks on the scale.

Color

MinorTickColor

Color of sub ticks on the scale.

Color

MajorTickSize

Size of main ticks on the scale.

Size

MinorTickSize

Size of sub ticks on the scale.

Size

MajorTicksCount

Number of main ticks on the scale.

Integer

MajorTicksShape

Shape/type of main ticks on the scale.

Enum:

  • Rectangle
  • Trapezoid
  • Triangle

MinorTicksShape

Shape/type of sub ticks on the scale.

Enum:

  • Rectangle
  • Trapezoid
  • Triangle

MinorTicksCount

Number of sub ticks on the scale.

Integer

PointerSize

Size of the pointer.

Size

PointerCapRadius

Size of the pointer fastening point.

Double

PointerBorderBrush

Color of pointer border.

Brush

PointerCapStyle

Shape/type of pointer fastening point.

Enum:

  • BackCap
  • FrontCap
  • Screw

PointerCapBorderBrush

Color of pointer fastening point.

Brush

PointerBrush

Color of pointer.

Brush

GaugeBorderBrush

Color of the element border.

Brush

GaugeBackgroundBrush

Color of element background.

Brush

PointerCapColorBrush

Color of pointer fastening point.

Brush

GaugeMiddlePlate

Radius of the element background middle plate.

Double

PointerOffset

Offset of the pointer (displacement).

Double

RangeRadius

Radius of the total range display.

Double

RangeThickness

Thickness of the total range display.

Double

RangeStartValue

Start value of the total range display.

Double

Range1EndValue

End value of the 1st area and start value of the 2nd range.

Double

Range2EndValue

End value of the 2nd area and start value of the 3rd range.

Double

Range3EndValue

End value of the 3rd area and start value of the 4th range.

Double

Range4EndValue

End value of the 4th area and start value of the 5th range.

Double

Range5EndValue

End value of the 5th area and start value of the 6th range.

Double

Range6EndValue

End value of the 6th range.

Double

Range1ColorBrush

Color of the first range.

Brush

Range2ColorBrush

Color of the sedond range.

Brush

Range3ColorBrush

Color of the third range.

Brush

Range4ColorBrush

Color of the fourth range.

Brush

Range5ColorBrush

Color of element fifth range.

Brush

Range6ColorBrush

Color of element sixth range.

Brush

ScaleOuterBorderBrush

Color of the scale border.

Brush

ScaleBackgroundBrush

Color of scale background.

Brush

ValueTextFrameStyle

Shape/type of value display.

Enum:

  • LargeFrame
  • SmallFrame
  • None

ValueTextContent

Content of the value display.

Enum:

  • Text
  • TextValue
  • Value

ValueTextSize

Font size of the value display.

Double

ValueTextColor

Font size of the value display.

Color

IsGlasReflection

Activate the glass effect on the element.

Boolean

GaugeOffsett

Lowering the rotation point of the whole element.

Double


Progress bar - ProgressBarControl

Progress bar - ProgressBarControl
Property | Function | Value
CurrentValue | Current value which should be displayed. | Double
MinValue | Minimum value of the value area. | Double
MaxValue | Maximum value of the value area. | Double
ProgressbarDivisionCount | Number of divisions of the progress bar. | Integer
VisibilityText | Visibility of the value display. | Boolean
TextSize | Font size of the value display. | Double
TextColor | Color of the value display. | Color
ProgressBarBoxedColor | Color of the border of the progress bar. | Color
ProgressBarMarginDistance | Distance of the progress bar box from the element edge (left, top, right, down). | Double
ProgressBarInactiveBrush | Indicator color not active. | Brush
ProgressBarActiveBrush | Indicator color active. | Brush
ProgressBarPadding | Distance of the progress bar from the progress bar box (left, top, right, down). | Double
ElementBorderBrush | Color of the element border. | Brush
ElementBackgroundBrush | Color of element background. | Brush


Bar graph vertical - VerticalBargraphControl

Bar graph vertical - VerticalBargraphControl
Property | Function | Value
CurrentValue | Current value which should be displayed. | Double
MinValue | Minimum value of the scale. | Double
MaxValue | Maximum value of the scale. | Double
MajorTicksCount | Number of main ticks on the scale. | Integer
MinorTicksCount | Number of sub ticks on the scale. | Integer
MajorTickColor | Color of main ticks on the scale. | Color
MinorTickColor | Color of sub ticks on the scale. | Color
ElementBorderBrush | Color of the element border. | Brush
ElementBackgroundBrush | Color of element background. | Brush
ElementGlassReflection | Activate the glass effect on the element. | Visibility
ElementFontFamily | Element font. | Font
ScaleFontSize | Font size of the scale. | Double
ScaleFontColor | Font color of the scale. | Color
IndicatorBrush | Bar graph fill color. | Brush
BargraphSeparation | Number of bar graph dividion. | Integer
BargraphSeparationColor | Color of the scale division. | Color


Temperature indicator - TemperatureIndicatorControl

Manual -> Screens -> Screen elements -> WPF element -> Engineering in zenon -> Pre-built elements -> Temperature indicator - TemperatureIndicatorControl

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Temperature indicator - TemperatureIndicatorControl

Property

Function

Value

CurrentValue

Current value which should be displayed.

Double

MinValue

Minimum value of the scale.

Double

MaxValue

Maximum value of the scale.

Double

MajorTicksCount

Number of main ticks on the scale.

Integer

MinorTicksCount

Number of sub ticks on the scale.

Integer

TickNegativColor

Color of the negative main tick (gradient to TickPositivColor).

Color

TickPositivColor

Color of the positive main tick (gradient to TickNegativColor).

Color

MinorTickColor

Color of the sub ticks.

Color

ElementBorderBrush

Color of the element border.

Brush

ElementBackgroundBrush

Color of element background.

Brush

ElementGlassReflection

Activate the glass effect on the element.

Visibility

ElementFontFamily

Element font.

Font

IndicatorColor

Color of the indicator fill color.

Color

IndicatorBorderColor

Color of the indicator border.

Color

MajorTickSize

Size of main ticks on the scale.

Size

MinorTickSize

Size of sub ticks on the scale.

Size

ScaleLetteringDistance

Distance of the scale caption (vertical), each x. main tick should be captioned.

Integer

IndicatorScaleDistance

Distance between indicator and scale (horizontal).

Double

ScaleFontSize

Font size of the scale.

Double

ScaleFontColor

Font color of the scale.

Color

Unit

Unit.

String

ElementStyle

Shape/type of element.

Enum:

  • SmallFrame
  • Unit
  • None


Analog clock - AnalogClockControl

Analog clock - AnalogClockControl

Property

Function

Value

ElementStyle

Shape/type of element.

Enum:

  • SmallNumbers
  • BigNumbers
  • No

ElementBackgroundBrush

Color of element background.

Brush

ElementGlassReflection

Activate the glass effect on the element.

Visibility

Offset

Value in hours (h) which displays the time lag to the system clock.

Int16

OriginText

Text which is displayed in the clock (e.g. location).

String


Universal slider - UniversalReglerControl

Universal slider - UniversalReglerControl

Property

Function

Value

CurrentValue

Current value which should be displayed.

Double

ElementFontFamily

Element font.

Font

MinValue

Minimum value of the scale.

Double

MaxValue

Maximum value of the scale.

Double

Radius

Double

ScaleRadius

Radius of the scale.

Double

ScaleStartAngle

Angle at which the scale starts.

Double

ScaleLabelRotationMode

Alignment of the scale caption.

Enum:

  • None
  • Automatic
  • SurroundIn
  • SurroundOut

ScaleSweepAngle

Angel area which defines the size of the scale.

Double

ScaleLabelFontSize

Font size of the scale caption.

Double

ScaleLabelColor

Font color of the scale caption.

Color

ScaleLabelRadius

Radius on which the scale caption is orientated.

Double

ScaleValuePrecision

Accuracy of the scale caption.

Integer

ElementStyle

Display type of the element

Enum:

  • Knob
  • Plate
  • None

MajorTickColor

Color of main ticks on the scale.

Color

MinorTickColor

Color of sub ticks on the scale.

Color

MajorTickSize

Size of main ticks on the scale.

Size

MinorTickSize

Size of sub ticks on the scale.

Size

MajorTicksCount

Number of main ticks on the scale.

Integer

MajorTicksShape

Shape/type of main ticks on the scale.

Enum:

  • Rectangle
  • Trapezoid
  • Triangle

MinorTicksShape

Shape/type of sub ticks on the scale.

Enum:

  • Rectangle
  • Trapezoid
  • Triangle

MinorTicksCount

Number of sub ticks on the scale.

Integer

BackgroundBorderBrush

Color of the element border.

Brush

BackgroundBrush

Color of element background.

Brush

PointerCapColorBrush

Color of pointer fastening point.

Brush

GaugeMiddlePlate

Radius of the element background middle plate.

Double

ValueFontSize

Font size of the value display.

Double

ValueFontColor

Font size of the value display.

Color

IsGlasReflection

Activate the glass effect on the element.

Boolean

KnobBrush

Color of the knob.

Brush

IndicatorBrush

Color of the indicator.

Brush

IndicatorBackgroundBrush

Background color of the inactive indicator.

Brush

KnobSize

Diameter of the knob.

Double

KnobIndicatorSize

Indicator size of the knob.

Size

ElementSize

Size of the element.

Size

VisibilityKnob

Activating of the knob.

Boolean

ValuePosition

Position of the value display.

Double

ValueVisibility

Activating the value display.

Boolean


Pareto diagram

Pareto diagram

The Pareto diagram, WPF element is available to exclusive partners of COPA-DATA and is available to these via the Partner Portal.

An example of a Pareto diagram in Runtime is shown below:

The following settings can be made in the WPF configuration window under COPADATA-ELEMENT:

Property | Function | Value
zenonBarColor1 | Color of the first Bar | Color (String)
zenonBarColor2 | Color of the sedond Bar | Color (String)
zenonBarColor3 | Color of the third Bar | Color (String)
zenonBarColor4 | Color of the fourth Bar | Color (String)
zenonBarColor5 | Color of element fifth Bar | Color (String)
zenonBarColor6 | Color of element sixth Bar | Color (String)
zenonBarColor7 | Color of element seventh Bar | Color (String)
zenonBarColor8 | Color of element eighth Bar | Color (String)
zenonBarColor9 | Color of element ninth Bar | Color (String)
zenonBarColor10 | Color of element tenth Bar | Color (String)
zenonColorPercentageLine | Color of the percentage line (relative sum frequency). | Color (String)
zenonLineVisibility | Visibility of the percentage line (relative sum frequency). | Boolean
zenonVariable1_Label | Labeling for the 1st Bar | String
zenonVariable1_Value | Value of the 1st Bar | Double
zenonVariable2_Label | Labeling for the 2nd Bar | String
zenonVariable2_Value | Value of the 2nd Bar | Double
zenonVariable3_Label | Labeling for the 3rd Bar | String
zenonVariable3_Value | Value of the 3rd Bar | Double
zenonVariable4_Label | Labeling for the 4th Bar | String
zenonVariable4_Value | Value of the 4th Bar | Double
zenonVariable5_Label | Labeling for the 5th Bar | String
zenonVariable5_Value | Value of the 5th Bar | Double
zenonVariable6_Label | Labeling for the 6th Bar | String
zenonVariable6_Value | Value of the 6th Bar | Double
zenonVariable7_Label | Labeling for the 7th Bar | String
zenonVariable7_Value | Value of the 7th Bar | Double
zenonVariable8_Label | Labeling for the 8th Bar | String
zenonVariable8_Value | Value of the 8th Bar | Double
zenonVariable9_Label | Labeling for the 9th Bar | String
zenonVariable9_Value | Value of the 9th Bar | Double
zenonVariable10_Label | Labeling for the 10th Bar | String
zenonVariable10_Value | Value of the 10th Bar | Double

The following events can be used and linked to zenon functions:

Event | Function | Value
zenonBar1Click | Function that is executed when the 1st bar is clicked on. | Function
zenonBar2Click | Function that is executed when the 2nd bar is clicked on. | Function
zenonBar3Click | Function that is executed when the 3rd bar is clicked on. | Function
zenonBar4Click | Function that is executed when the 4th bar is clicked on. | Function
zenonBar5Click | Function that is executed when the 5th bar is clicked on. | Function
zenonBar6Click | Function that is executed when the 6th bar is clicked on. | Function
zenonBar7Click | Function that is executed when the 7th bar is clicked on. | Function
zenonBar8Click | Function that is executed when the 8th bar is clicked on. | Function
zenonBar9Click | Function that is executed when the 9th bar is clicked on. | Function
zenonBar10Click | Function that is executed when the 10th bar is clicked on. | Function


Sankey diagram

Sankey diagram

The Sankey diagram, WPF element is available to exclusive partners of COPA-DATA and is available to these via the Partner Portal.

The Sankey wizard must be used to model a Sankey diagram. The wizard creates an XML file that is then evaluated by the WPF element. To do this, the zSankeyName property must be given the name of the XML file. The XML file must be in the Other folder of a project. This is saved there by the wizard.

An example of a Sankey diagram in Runtime is shown below:

The following settings can be made in the WPF configuration window under COPADATA-ELEMENT:

Property | Function | Value
FontSize | Font size of the texts. | Integer
zBackgroundColor | Background color of the diagram. | Color (String)
zFontColor | Color of the texts. | Color (String)
zFontFamily | Font of all texts. | Font (String)
zLossDetectionActive | Automatic loss detection activated/deactivated. If true, then losses are automatically shown at a node points as flows. | Boolean
zNoDataText | Text that is displayed if there are no values to display and zPrevireActive is false. | String
zNoValidXMLText | Text that is displayed if no valid XML file with entered name has been found and zPreviewActive is false. | String
zNumberOfDecimalPlaces | Denotes how many decimal places are to be displayed. | Integer
zPreviewActive | Display of a preview activated/deactivated. The preview can be displayed if There is no data present (the modeled diagram is filled with default values) or the XML file was not found or this does not contain a valid definition (an example Sankey diagram is displayed). | Boolean
zRefreshRate | Rate at which the diagram is refreshed in ms. | Integer
zSankeyName | Name of the XML file with the modeling of the diagram. | String
zShowRelativeValues | Display of the values in absolute false or relative values true. | Boolean

Note: The Sankey diagram does not work in zenon Web Client.


Waterfall diagram

Waterfall diagram

The waterfall diagram, WPF element is available to exclusive partners of COPA-DATA and is available to these via the Partner Portal.

The meaning and waterfall chart wizard must be used to model a waterfall diagram. A waterfall can be modeled with this wizard. The information is saved directly for the variables concerned in the Analyzer --> Parameters for waterfall diagram.

An example of a waterfall diagram in Runtime is shown below:

The following settings can be made in the WPF configuration window under COPADATA-ELEMENT:

Property | Function | Value
zenonRefreshRate | Time between the refreshes of the diagram in ms. | Integer
zenonWaterfallIdentifier | Name of the waterfall diagram. | String
zenonZSystemModel | Equipment group of the variables used. | String

Note: The waterfall diagram does not work in zenon Web Client.


Examples: Integration of WPF in zenon

Manual -> Screens -> Screen elements -> WPF element -> Engineering in zenon -> Examples: Integration of WPF in zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can see how XAML files are created and integrated as WPF elements in zenon from the following examples:

  • Integrate button as WPF XAML in zenon
  • Integrate bar graph as WPF XAML in zenon
  • Integrate DataGrid Control in zenon

Other topics in this chapter

Integrate button as WPF XAML in zenon

Integrate bar graph as WPF XAML in zenon

Integrate DataGrid Control in zenon


Integrate button as WPF XAML in zenon

Manual -> Screens -> Screen elements -> WPF element -> Engineering in zenon -> Examples: Integration of WPF in zenon -> Integrate button as WPF XAML in zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Integrate button as WPF XAML in zenon

Example structure:

  • Creating a button in Microsoft Expression Blend
  • Integrate into zenon
  • Link to a variable and a function
  • adjust the button to the size of the element
  • Create button

As a first step, create a button as described in the Create button as XAML file with Microsoft Expression Blend chapter. To be able to use the XAML file in zenon, insert this in the project tree in the Files/graphics folder.

Integrate button

Note: A zenon project with the following content is used for the following description:

  • An empty screen as a start screen
  • an internal variable int of type Int
  • a function Funktion_0 of typeSend value to hardware with:
    • Direct to hardware option activated
    • Set was set to 45

To integrate the button:

  1. open the empty screen
  2. place a WPF element in the screen
  3. select XAML file in the properties window
  4. select the XAML file (e. g. MyButton.xaml and close the dialog
  5. select the Configuration property

Configure the button

The configuration dialog shows a preview of the selected XAML file. All elements named in the XAML file are listed in the tree:

  1. select the WPF button, which is in LayoutRoot->MyViewBox->MyButton
  2. Look in the Properties EntryContent tab; this contains the button's text
  3. Click the Link type column
  4. Select Variable from the drop down list
  5. Click in the Link column
  6. the variable selection dialog is opened
  7. select the int variable to link this variable with the Content property

Events

To also assign events:

  1. select the events tab

  2. look for the 'Click' entry, this event is triggered by the WPF element, as soon as the button is clicked
  3. Click in the Link type column
  4. Select Function from the drop down list
  5. Click in the Link column
  6. the function selection dialog is opened
  7. select Function_0
  8. Confirm the changes with OK
  9. Insert a numerical value element into the screen
  10. Link this numerical value element to the int variables too.
  11. Compile the Runtime files and start Runtime.

The WPF element is displayed in Runtime, the button text is 0. As soon as you click on the button, the click event is triggered and the set value function is carried out. The value 45 is sent directly to the hardware and both numerical value and button display the value 45 .

Define a set value of 30 via the numerical value element; this value is then also assumed by the WPF element.

Authorization

Similar to a numerical value, a WPF element can be locked according to authorizations (lock symbol) or switched to be operable. Set the user authorization level to 1 for the WPF element and create a user called Test withauthorization level 1. In addition, set up the functions Login with dialog and Logout . You link these two functions with 2 new text buttons on the screen.

In the WPF element configuration dialog, select the MyButton WPF button and select the Properties: tab

  1. Select the IsEnabled element
  2. Click in the Link type column
  3. Select Authorizations/interlocking from the drop down list
  4. Click in the Link column
  5. In the drop-down list, select the Authorized option

  6. Close the dialog with OK

Compile the Runtime file and note that Authorizations to be Transferred must also be selected. After Runtime has been started, the WPF button is displayed as deactivated on the screen and cannot be operated. If you now log in as the user Test, the button is activated and can be operated. The button is locked again as soon as you log out.

Transformation

The XAML files must still be adapted to use transformations:

  1. switch to the Expression Blend program
  2. select MyButton, so that the properties of the element are visible in the events window

  3. Under Transform at RenderTransform select the Apply relative transform option

    As a result of this, a block is inserted into the XAML file, which save the transformation settings in runtime.

  4. Save the file and replace the old version in zenon with this new file.
  5. Open the WPF element configuration dialog again:
    1. select the MyButton button
    2. select the Transformations tab

    1. select the RotateTransform.Angle element
    2. Click in the Link type column
    3. Select Transformations from the drop down list
    4. Click in the Link column
    5. the variable selection dialog is opened
    6. select the int variable to link this variable with the RotateTransform.Angle property

Compile the Runtime files and start Runtime. Log in as the Test user and click on the button. The button has the value 45 and the WPF element rotates by 45°.


Integrate bar graph as WPF XAML in zenon

Manual -> Screens -> Screen elements -> WPF element -> Engineering in zenon -> Examples: Integration of WPF in zenon -> Integrate bar graph as WPF XAML in zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Integrate bar graph as WPF XAML in zenon

Example structure:

  • Creating a bar graph in Adobe Illustrator and converting it to WPF
  • Integrate into zenon
  • Linking with variables
  • Adapting the bar graph WPF element

Create bar graph

The first step is to generate a bar graph as described in the Workflow with Adobe Illustrator chapter. To be able to use the XAML file in zenon, insert this in the project tree in the Files/graphics folder.

Integrate bar graph

Note: A zenon project with the following content is used for the following description:

  • An empty screen as a start screen
  • Four variables from the internal driver for
    • Scale 0
    • Scale central
    • Scale high
    • Current value
  • A variable from the mathematics driver for displaying the current value (255)

To integrate the bar graph:

  1. open the empty screen
  2. place a WPF element in the screen
  3. select XAML file in the properties window
  4. Select the desired XAML file (for example bar graph_vertical.xaml) and close the dialog

Adjust bar graph

Before configuration, the scale of the XAML file is adapted if necessary:

To do this:

  • Create a new mathematics variable that calculates the new value in relation to the scaling, for example:
  • Variable: 0-1000
  • Mathematic variable {value created in xaml file}*Variable/1000

    The XAML file is then configured.

Configure bar graph

  1. Click on the WPF element and select the Configuration property
  2. The configuration dialog shows a preview of the selected XAML file.
  3. Select the minimum value, the average value and the maximum value and link each of these to the corresponding variable in the Content property

  4. Select the Slider and link the Value property to the mathematics variables (in our example: calculation)

  5. Check the project planning in Runtime:


Integrate DataGrid Control in zenon

Manual -> Screens -> Screen elements -> WPF element -> Engineering in zenon -> Examples: Integration of WPF in zenon -> Integrate DataGrid Control in zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Integrate DataGrid Control in zenon

To create DataGrid control, you need:

  • WPF Toolkit: available as a download at http://wpf.codeplex.com
  • Visual Studio

Ensure that you always create projects that are based on .NET Framework 3.5.

Create WPF user control

  1. Create a WPF User Control in Visual Studio.

    In our example, it is given the name MyWPFLibrary.

  2. Add the WPF Toolkit assemblies to the references. To do this:
    1. Right-click on the project
    2. Select Add reference…
    3. Select this in the .NET tab
    4. Select System.Data and System.Data.DataSetExtensions too if these are not already present
  3. Create a new data connection in Server Explorer. To do this:
    1. right-click on Data Connections
    2. Select Add connection…

    In our example, the database Northwind is used; this has been created by Microsoft as an example database.

    After adding the connection, the Server Explorer window should look a little like this:

    A new DataSet is created in the next step.

Creating a DataSet

  1. Right-click on the project
  2. In the context menu, select the Ad New Item....
  3. Create a new DataSet.
  4. double click the DataSet It should now open in the designer.
  5. Drag the tables that you need into the DataSet design window.

The XAML file is configured in the next step.

Configuration of XAML file

  1. Insert the namespaces into the XAML file.
    You need the namespace of the WPF toolkits and a reference to the class:

  2. Define the resources and the DataGrid that is to be used in the WPF:

    <UserControl.Resources>

    <my1:MyDataSet x:Key="MyDataSet" />

    <CollectionViewSource x:Key="customersViewSource" Source="{Binding Path=Customers, Source={StaticResource MyDataSet}}" />

    </UserControl.Resources>

    <Grid DataContext="{StaticResource customersViewSource}">

    <my:DataGrid Height="304" HorizontalAlignment="Left" Margin="6,7,0,0" Name="dataGrid1" VerticalAlignment="Top" Width="497" DisplayMemberPath="CompanyName" ItemsSource="{Binding}" SelectedValuePath="CustomerID" />

    </Grid>

  3. Open the code-behind file (xaml.cs) and insert the following lines in the constructor:

    public UserControl1()

    {

    InitializeComponent();

    MyWPFLibrary.MyDataSet ds = ((MyWPFLibrary.MyDataSet)(this.FindResource("MyDataSet")));

    MyWPFLibrary.MyDataSetTableAdapters.CustomersTableAdapter ta = new MyWPFLibrary.MyDataSetTableAdapters.CustomersTableAdapter();

    ta.Fill(ds.Customers);

    System.Windows.Data.CollectionViewSource customersViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("customersViewSource")));

    customersViewSource.View.MoveCurrentToFirst();

    }

    This has the following effect:

    • Get DataSet
    • Create a new ReportAdapter
    • Fill DataSet
    • Provide this information to the DataGrid Control

The solution can now be built.

Build

Now create the solution Some DLLs are created in the output folder in the process.

You now have a DLL with the necessary functionality available. However zenon can only display XAML files that cannot be linked to the code-behind file. Therefore another DLL is required that references the DLL that has just been built. To do this:

  1. Create another project, another WPF user control library.
  2. It was called DataGridControl in our example.
  3. Insert a reference to the project that has just been built into this new project.

  4. The XAML files looks as follows:

  5. Because all necessary content is contained in the DLL and no code-behind is necessary, delete:

    x:Class="test.UserControl1"

  6. Also delete (for the positioning) the following lines

    mc:Ignorable="d"

    d:DesignHeight="300" d:DesignWidth="300"

  7. Define what is to be displayed in the XAML file. To do this, add the following lines:

    <UserControl xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"

    xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"

    xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"

    xmlns:d="http://schemas.microsoft.com/expression/blend/2008"

    xmlns:mywpflib="clr-namespace:MyWPFLibrary;assembly=MyWPFLibrary">

    <Grid x:Name="GridName">

    <mywpflib:UserControl1 HorizontalAlignment="Left" Name="userControl11" VerticalAlignment="Top"/>

    </Grid>

    </UserControl>

    The xmlns:mywpflib="clr-namespace:MyWPFLibrary;assembly=MyWPFLibrary" line defines the namespace mywpflib and stipulates that this should use the assembly built before.

  8. Insert a pre-existing name into the TAGs of the grid.
  9. Insert the control mywpflib:UserControl1 from our library and give it a name, because zenon can only modify objects that have a name.
  10. Construct this solution.
    This now leads to an error message:

  11. To rectify the error, simply delete the code-behind file and carry out a rebuild.

In the next step, the XAML file is added in zenon.

Steps in zenon

  1. Open the zenon Editor
  2. Go to File -> Graphics
  3. Select Add file... in the context menu

  4. Select the XAML file from the save location and insert this.

  5. Insert the DLLs with the functionality for the XAML file. To do this:
    1. Select, in the context menu, File -> OtherAdd file....
    2. Select the WPFToolkit.dll and the DLL of the first project

  6. Create a screen.
  7. Insert a WPF element and select an XAML file. You should now see the following:

Note: If the XAML file is to be deleted or updated within the zenon project, it may be the case that the DLLs are still open and cannot be deleted from the file folder. The editor must be restarted in order to delete them. It may also be sufficient to deactivate the project and reactivate it again.


Error treatment

Manual -> Screens -> Screen elements -> WPF element -> Engineering in zenon -> Error treatment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Entries in LOG files

Entry | Level | Meaning
Xaml file found in %s with different name, using default! | Warning | The name of the collective file and the name of the XAML file contained therein do not correspond. To avoid internal conflicts, the file with the name of the collective file and the suffix .xaml is used.
no preview image found in %s | Warning | The collective file does not contain a valid preview graphic (preview.png or [names of the XAML file].png). Thus no preview can be displayed.
Xaml file in %s not found or not unique! | Error | The collective file does not contain an XAML file or several files with the suffix .xaml. It cannot be used.
Could not remove old assembly %s | Warning | There is an assembly that is to be replaced with a newer version, but cannot be deleted.
Could not remove old assembly %s | Error | A new version is available for an assembly in the work folder, but it cannot be copied there. Possible reason: The old example is still loaded, for example. The old version continues to be used, the new version cannot be used,
file exception in %s | Error | A file error occurred when accessing a collective file.
Generic exception in %s | Error | A general error occurred when accessing a collective file.


Numerical value

Manual -> Screens -> Screen elements -> Numerical value

You display numerical values with the numerical values dynamic element.

To create a numerical value in a screen:

  1. Select the Numeric value symbol in the Elements tool bar
  2. select the start point in the main window
  3. pull open the element while pressing and holding the left mouse button
  4. the dialog to assign a numerical value opens
  5. select the desired variable and define the desired properties in the properties window

info Info

The following applies in runtime: A decimal value can be entered with a comma as well as with a period as a separator. It is always displayed as a period.


Pointer instrument

Manual -> Screens -> Screen elements -> Pointer instrument

You display the indicating instrument with the indicating instrument dynamic element.

To create an indicating instrument in a screen:

  1. select the Indicating Instrument symbol in the Elements tool bar or in the Elements drop-down list
  2. select the start point in the main window
  3. pull open the element while pressing and holding the left mouse button
  4. the dialog to assign a numerical value opens
  5. select the desired variable and define the desired properties in the properties window

Color-coded display of the limit violation

At limit violations the color from the variable can color the whole area or only the area starting from the limit violation. This functionality is controlled via property Explicit in group Representation.

This property affects only the display of values with defined limits from variables. Limits from reaction matrices are not considered.

  • Active: If a limit value of the linked variable is breached, only the part of the display that goes into the limit value breach is shown in the color of the respective limit value.
    If the variable has several defined limit values, the corresponding areas of the display are each shown in the color of the limit value.
  • Inactive: If a limit of the linked variable is violated, the complete display is displayed in the color of the violated limit.

Default: inactive


Status element

Manual -> Screens -> Screen elements -> Status element

You control a screen symbol with a Status Element dynamic element. In doing so, properties of a linked variable such as colors or flashing for example are transferred to a symbol. You can therefore also show statistical limit value texts.

To create the Status Element in a screen:

  1. Select the Status Element symbol in the Elements tool bar or in the Elements drop-down list
  2. Select the start point in the main window.
  3. Pull open the element while pressing and holding the left mouse button.
  4. the dialog to select a variable opens
  5. Select the desired variable
  6. Define the desired properties in the properties window

info Information

Instead of the Status element dynamic element, the dynamics properties of the corresponding element can be used.


Edit screen elements

Manual -> Screens -> Edit screen elements

The are many possibilities available to you for editing screen elements:

  • Graphic actions
  • Automated replacement
  • Background graphics
  • Selection dialog functions
  • Variables selection dialog


Graphic actions

Manual -> Screens -> Edit screen elements -> Graphic actions

Graphic actions are also possible in zenon. To do this, use:

  • Element properties
  • Commands in the Edit menu
  • Actions with the mouse:
    • Holding down the ctrl key when moving the mouse copies the element.
    • Moving with the right mouse button pressed opens the content menu, with a choice of whether to copy or move the item
  • the context menu

info Information

Graphic actions such as shading and blurring can have an effect on the performance of the system, both in the editor and in runtime.

Entering values

To enter values within a defined limit, there are also sliders for many properties. These can be accessed via the ... button+. Changes in values made with the slider are displayed in the properties field immediately.

When selecting colors, the color activated in the palette is displayed directly in the object as a preview.


Truncations

Manual -> Screens -> Edit screen elements -> Graphic actions -> Truncations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The elements Rectangle and Button and Polygon, Polyline and Tube can be displayed with truncations.

info Information

Truncations are available only with limitations if property Windows CE projectis activated or if property Graphics quality has value Windows Base.

rectangle and button

You define the degree of truncation with the properties in Rounded corners node. 2 values can be given for each corner point:

  • X value: Percentage value for the rounding based on the width of the element
  • Y-value: is a percentage value for the rounding based on the height of the element

0% means no rounding.
100 % means a quadrant.

If the Proportional property is activated, only the X value can be entered.

The values can be defined separately for each angle. If the value of an angle is set at -1, it then takes its rounding value from the All x [%] or All y [%] property.

info Information

If the value for All x [%] or All y [%] is changed, all values are set to -1 on the corresponding axis. Therefore different values can be re-harmonized very easily.

Hint: There is a small yellow triangle in the lower right quadrant of the element. Click on it with the mouse and move the triangle up to the desired rounding.

Example:

There is a GIF file on the button with a transparent background. A red color gradient was defined for the button. The rounding of the angles was defined with All x [%] and Proportional, afterwards this value was changed individually for the lower left angle.

info Information

If the With brightness values property is used for displaying the fill color, no rounded edges can be used. If this element is activated for an element, that uses rounded-off corners, the element is displayed with non-rounded corners.

Polygon, Polyline und Tube

You can define the degree of rounding for polygons, polylines and tubes with the Rounding property in the Representation node. Enter a value between 0 and 1 for this.


Effects for screen elements

Manual -> Screens -> Edit screen elements -> Graphic actions -> Effects for screen elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Several graphical elements can be highlighted with the help of effects in the Runtime.

You can find additional effects in chapter effects for frames.


Glow effect

Manual -> Screens -> Edit screen elements -> Graphic actions -> Effects for screen elements -> Glow effect

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Many zenon support the glow effect.

Requirements

To use glow effect for a graphical element, the following requirements must be fulfilled:

  • The project property Graphical design/Graphics quality must be set to DirectX Hardware or DirectX Software. For details see chapter Graphics quality.
  • The graphical element must be supported.
    Except for the following exceptions all graphical elements are supported: WMF, symbols, combi element, ActiveX, WPF, all Win32 control elements, windows and several special control elements.
  • The element must be visible.
    If the element is invisible, the glow effect is invisible automatically as it is derived directly from the element.

Configuration

To configure the glow effect for a supported element:

  1. make sure that property Graphics quality is set to DirectX Hardware or DirectX Software
  2. create the element
  3. go to property node Effects
  4. activate the Activate property in the Glow (only DirectX) node
  5. configure transparency, color, spread and visibility

    If you configure several properties for the same effect, the stronger is executed in the Runtime. For details, see Dependance of the configuration section. (For example: An invisible glow effect is always invisible; the settings for flashing has no effect anymore.)

Default value for the glow effect:

  • Activate: inactive
  • Only active if clicked: inactive
  • Transparency [%]: 20 %
  • Spread [pixel]: 15 Pixel
  • Coloring: inactive
  • Color: #FFFF90 (yellow)
  • Variable for color: None
  • Variable for visibility: None
  • Take over visibility from limit: inactive
  • Visible from: 0
  • Visible to: 0
  • Variable for flashing: None
  • Take over flash color from limit: inactive
  • Make 2. flash state invisible: inactive

Dependencies of the configuration

Variable for visibility

Visibility has especially strong effects. If the glow effect is set to invisible, flashing and color is ignored. Dependencies:

  1. Variable for visibility is linked and Take over visibility from limit is active:
    • Invisible in the limit is activated: Glow effect is invisible.
    • Invisible in the limit is not activated:
      The glow effect configured in the properties is displayed. Dependent of the settings the glow effect can also flash.
  2. Variable for visibility is linked and Take over visibility from limit is not active:
    • The variable value lies within the limits of properties of Visible from and Visible to:
      The glow effect configured in the properties is displayed. Dependent of the settings the glow effect can also flash.
    • The variable value lies outside the limits of properties of Visible from and Visible to:
      Glow effect is invisible
  3. Variable for visibility is not linked:
    The glow effect configured in the properties is displayed. Dependent of the settings the glow effect can also flash.

Variable for flashing

For all states for which the originally configured glow effect is displayed, you get the glow effect which is configured in the properties. At this for example the color for a limit can come from an own variable; for details see Color from variable.

  1. Variable for flashing is linked, Take over flash color from limit is active and Make 2. flash state invisible is active:
    • Limit was violated:
      Glow effect flashes and alternates between colored glow effect (from limit violation) and the originally configured glow effect.
    • Limit was not violated:
      Glow effect does not flash and the glow effect is displayed as it was originally configured.
  2. Variable for flashing is linked, Take over flash color from limit is active and Make 2. flash state invisible is not active:
    • Limit violation is active:
      Glow effect flashes and alternates between colored glow effect (from limit violation) and no glow effect.
    • Limit violation is not active:
      Glow effect does not flash and the glow effect is displayed as it was originally configured.
  3. Variable for flashing is linked and Take over flash color from limit is not active:
    • Limit violation is active:
      Glow effect flashes and alternates between originally configured glow effect and no glow effect.
    • Limit violation is not active:
      Glow effect does not flash and the glow effect is displayed as it was originally configured.
  4. Variable for flashing is not:
    Glow effect can be displayed dependent on other properties.

Color from variable:

Represents the possibility to define the color of the glow effect at normal view via the limit of a variable. This is also true for the normal view when the glow effect does not flash.

  1. Variable for color linked:
    1. Limit violation is active:
      The color from the violated limit is used.
    2. Limit violation is not active:
      For coloring the glow effect the defined color from property Color is used.
  2. Variable for color not linked:
    For coloring the glow effect the defined color from property Color is used.

Coloring:

Defines whether the glow effect is created as image of the actual element or whether it is colored with a single color.

  1. Coloring active and Variable for color linked:
    1. Limit violation is active:
      For coloring the glow effect the color from the violated limit is used.
    2. Limit violation is not active:
      For coloring the glow effect the defined color from property Color is used.
  2. Coloring active and Variable for color not linked:
    For coloring the glow effect the defined color from property Color is used.
  3. Coloring not active: An image of the actual element with all corresponding colors of the element for the glow effect is used.

Hints for configuration

To receive good results:

  • Select a rather lower value for Transparency [%]. Without coloring the value may be a little bit higher than with coloring.
  • Do not select a too small value for Spread [pixel]. It should be >5 for the effect to be visible outside of the element.
    Attention: Too high values (>20) can lead to the glow effect being reduced very much. In this case the visibility can be increased by reducing the transparency. In general the glow effect needs a lot of performance. Thus you should use it consider it well when and where to use it. A higher value for Spread [pixel] costs more performance which especially affects elements which lie close together.
  • As for DirectX the glow effect (just like the shadow) is derived from the original element, dynamic changes of the element affect the effect. In addition bitmap graphics can be equipped with this effect. Thus for example a PNG graphic with semi-transparent areas as well as a GIF animation obtain a correct glow effect which is created dynamically during the display. The glow effect just as the shadow also affects text by which correlating effects can be achieved.


Examples for glow effects

Examples for glow effects

Glow effect

Element without glow effect:

Element with glow effect:

Color

Default color 0xFFFF90 (yellow):

Color 0xFFFFFF (white):

Transparency

0% transparency:

20% transparency:

60% transparency:

Spread

0 pixel spread and 0% transparency:

5 pixel spread and 0% transparency:

10 pixel spread and 0% transparency:

20 pixel spread and 0% transparency:

Color 0xFFFF90, 5 pixel spread and 20% transparency:

Color 0xFFFF90, 20 pixel spread and 20% transparency:

Texts

5 pixel spread and 0% transparency:

Color 0xFF0000, 5 pixel spread and 0% transparency:

Large font with 15 pixel spread and 0% transparency:

Large font with color 0xFF0000, 35 pixel spread and 20% transparency:

Part-transparent graphic

Original:

20 pixel spread and 20% transparency:

Color 0xFF0000, 20 pixel spread and 20% transparency:

Without color, 20 pixel spread and 20% transparency plus shadow with 40 pixel distance, 60% transparency, black and 5 pixel soft focus.

Element changes

3D button in contrast colors, 15 pixel spread and 0% transparency on 3D button:

3D button in contrast colors, pressed with 15 pixel spread and 0% transparency on 3D button:


Error treatment

Error treatment

Output

Entry | Level | Description
DirectX: Screen'Screen name' - Element ' Element name' uses an effect which cannot be displayed with the selected graphics setting. | Warning | At an element the glow effect is activated. However DirectX Softwaree or DirectX Hardware is not selected or not available.

Check list for error localizing

  • Is DirectX turned on?
  • Is DirectX available on the system? An according check can carried out by activating the debug messages in the Diagnosis Viewer. For successful support, an appropriate message is displayed.
  • Does the element support the glow effect?
  • Is the element visible?
  • Cause static properties (e.g. transparency) the glow effect not to be displayed or displayed differently?
  • Cause dynamic properties the glow effect not to be displayed or displayed differently?
  • Is a property selected which causes the glow effect only under certain circumstances (e.g. button element with property "Only active if pressed")?


Frame and Shadows

Manual -> Screens -> Edit screen elements -> Graphic actions -> Effects for screen elements -> Frame and Shadows

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Elements can be expanded with frames and shadows.

Exception: Status elements cannot obtain shadows.

info Information

If the transparency of an object (for example the background color) is changed, the display of the preconfigured shading also changes accordingly. However, the values for color and transparency of shading remain the same in the process.

Allocate frame and Shadows

  • To give an element a frame, select Frame in the property Border type node Borders/Shadows.
  • To give an element a frame, select Frame in the property Border type node Borders/Shadows.

For shadows and frames, you can define

  • Distance: distance of the frame or shadow to the element.
  • Frame color: Color of frame or shadow.

For frames, you can define

  • Line width: The width of the frame.

For shadows, you can define

  • Angle: The angle in degrees with which the shadow falls, starting from the outside right counterclockwise.

  • Transparency: Transparency of the shadow between 0 and 100%, with 0% being opaque and 100% being transparent.
  • Size of shadow: Size of shadow in pixels.
  • Blurring: Blurs the surface color and makes the transition to shadow softer.
    Note: if a value is irregularly set to 0 here, then the calculation affects system performance.

info Information

Transparency for lines or fill colors of an element have an effect on the shadow. For example: If the fill color is set to 100% transparent, then no shade will be visible for the fill area.


Examples

Examples

Shade with an angle of 45 degrees moved by 10 pixels

Shade with an angle of 45 degrees moved by 30 pixels

Shade with size of 30 pixels

Shade with size of -20 pixels

Shade with a size of -20 pixels and transparent color gradient in the element

Rounded rectangle with a blur of 10


Move elements

Manual -> Screens -> Edit screen elements -> Graphic actions -> Move elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To move elements, use:

from version 6.50

the properties from the respective element:

  • Position
  • Size and rotation dynamic

You can also animate elements with properties

  • Colors dynamicin the nodeColor
  • Flashingin the nodeVisibility/flashing
  • Visibilityin the nodeVisibility/flashing

up to and including version 6.22 and Runtime compatibility

  • Alternatively, you can also use the Move Symbol dynamic element


Color gradient and transparency

Manual -> Screens -> Edit screen elements -> Graphic actions -> Color gradient and transparency

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Elements can be given color gradients or switched to transparent.

To do this, select the corresponding element properties in the Color node:

Color gradient

Color gradients can be set in the following direction for the following elements:

Element | Linear | Starting from a defined point | Starting from a defined point with beams
Rectangle | yes | yes | yes
Circle | yes | yes | no
Segment of a circle | yes | yes | no
Polygon | yes | yes | yes
Button | yes | yes | yes

To define a color gradient, select Color Gradientas a Filling pattern.

You can now define the color gradient via the properties of the group Color gradient. You can also define the color gradient with the mouse. To do this, click on the yellow circle in the element with (connecting line to the middle point) and move the circle until you reach the desired gradient.

info Information

Right angles are positioned horizontally at angles between 45° and 135° and between 225° and 315°.

The With brightness values property is not available for polygons.

Color gradient under Window CE or for graphics quality Windows Basis

Under Windows CE or for settings Windows Basis for property Graphics quality, color gradients for vector elements can only be accomplished via brightness values. The Color gradient property is not available. For the display of color gradients use property:

  • Offset [%]: only works for element rectangle
  • Angle [°]: only works for element rectangle
  • Brightness outside
  • Brightness inside

Note:

Property With brightness values need not extra be activated.

Property Angle [°] can only be changed in steps of 90° under Windows CE and at setting Windows Basis for property Graphics quality.

Button

For element button under Windows CE and Windows Basis the following is also true:

  • For property Filling the values Starting from a defined point and Starting from a defined point with beams are not available.
  • The Angle [°] property is not available.

Transparency

You can switch an element to be completely transparent with the Transparent property.

To switch elements to be partially transparent, use the properties for fill color transparency, gradient color and frame color. Here, you define the covering power of the colors with values between 0 and 100 percent. In doing so, 0 is opaque and 100 is completely transparent. All values between this appear transparent according to how they are set.

Examples

Transparency: fill color = 100, fill color 2 = 100

Transparency: fill color = 50, fill color 2 = 100

Transparency: fill color = 0, fill color 2 = 100

info Information

Control elements to control list fields such as screen scroll bars do not support transparency.


Transfer format

Manual -> Screens -> Edit screen elements -> Graphic actions -> Transfer format

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To transfer the properties of a selected element to another one / multiple elements:

  1. Transfer to an element:
    1. Click on element with original properties -
    2. Click on the Transfer properties symbol
      or the corresponding command in the context menu
    3. Click on target element: Properties are transferred
  2. Transfer to multiple elements:
    1. Select source element -
    2. Select target element with Ctrl key held down (source and target elements are highlighted)
    3. Click on the Transfer properties symbol or the corresponding command in the context menu
    4. The source element´s properties are transferred to the target elements.

If several elements were chosen as source, the properties of the first selected element are transferred.

info Information

Accept properties via properties window:

If several elements are highlighted, the properties of the last respective highlighted element in the properties input is displayed. If the properties window is displayed in the Grouped view mode or in the All properties mode mode, the respective property can be transferred to all highlighted elements by pressing the Return key. This is not possible in the dialog view mode. For details, see the Properties window chapter, Multiselect section.

Rules for transferring formats

Transferred are:

  • Properties that directly define an element in form, color, and appearance and are not influenced by a variable.

Not transferred are:

  • Deactivated properties
  • Direct properties that it does not make sense to transfer, such as texts and Graphics files

    Exception:

    • Graphics files for a switch are copied as you normally always want to have the same switches.
    • Graphics files for buttons are not copied as different ones are normally used.
  • Properties from groups:
    • Authorization
    • Automatic Line Coloring
    • General
    • Position
    • Size and rotation dynamic
    • Runtime
    • VBA macros
    • Write set value
  • Everything that comes directly from variables
  • Variables and linked functions


Copy, Insert and Move

Manual -> Screens -> Edit screen elements -> Graphic actions -> Copy, Insert and Move

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To copy, move or delete elements on a screen,use

  • Commands in the Edit menu
  • Actions with the mouse:

    Holding down the ctrl key when moving the mouse copies the element.
    Moving with the right mouse button pressed opens the content menu, with a choice of whether to copy or move the item

  • the context menu

Move

Objects can be moved with the mouse or the keyboard, with the exception of frames. You can use special effects in combination with function keys when moving:

Key | Action | Result
Ctrl | move with mouse | object is copied.
Shift | move with mouse | object can only be moved horizontally and vertically.
Shift | move with arrows | Each key press moves the object by 10 pixels.
Right mouse button | move with mouse | The context menu lets you choose between Copy and Move.
Space bar |  | Mouse pointer becomes a hand. With this hand, the editing area can be moved with the left mouse button.


Designing lists

Manual -> Screens -> Edit screen elements -> Graphic actions -> Designing lists

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The display of certain lists can be modified in Runtime. Not all configuration options are available for all lists. The configuration can differ depending on the screen type; for example, headers for Batch Control can be configured with different properties as those for AML. Most of all, list elements for AML, Batch Control, CEL, Extended Trend, Report Viewer or RGM have various design options.

For example, the following are available:

  • General display
  • Headers and scroll bars
  • Graphic for checkbox


Display

Manual -> Screens -> Edit screen elements -> Graphic actions -> Designing lists -> Display

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Representation area, the font and line height can be configured and the Extended graphical settings property can be activated.

Font

Select the font to be used for the list using the Font property. Click on the ... button to open the dialog to select a font. You can configure the fonts offered here in the Screens/font lists node.

Line height

You can define the line height regardless of the font size with the Line height [pixel] property.

attention Attention

Extended graphical settings

This property allows you to use customizable horizontal and vertical scroll bars, the header and the grid.

Preview

By activating the Extended graphical settings property in the Editor, the header and scroll bars can be previewed. This way, details such as color fill effects, light effects or grids can be configured more easily.

Attention: As the size of the scroll bars equals their size in the Runtime, the total size of the list in the Editor can vary from the size in the Runtime. This is also true for the size of the header and the font of the header.

Display of binary values

Binary values in configurable lists can be displayed graphically or numerically in Runtime. The display is configured using the properties in the Representation/Boolean values display group.


Headers and scroll bars

Manual -> Screens -> Edit screen elements -> Graphic actions -> Designing lists -> Headers and scroll bars

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Headers allow, in Runtime:

  • Columns to be moved
  • The size to be changed
  • The sorting to be changed.

Headers are generally configured in the Representation/Header area. Headers for AML and CEL differ from this; for details, see the section entitled Headers for AML / CEL.

Headers general

To be able to use headers in Runtime, activate the Show header property.

You fix the header with the Static header property. It can then no longer be changed in Runtime. Only the column width can still be changed.

To activate the filter line in Runtime, activate the Display filter line property.
Note: Pre-configured filters are also executed if the filter line is not displayed.

You define the height of the header using the Height of the header [in pixels] property. The height is automatically determined on the basis of the font if the value is 0. The maximum height is 255 pixels.

Header for AML and CEL

To use headers in AML or CEL screens:

  1. navigate to Group Alarm Message List in project properties
  2. In the Header AML property, select the value Operable header
    (alternatively you can also switch the header to inoperable or invisible here)

info Information

You can prohibit the manipulation and/or the visibility of the header for each screen Alarm Message List by deactivating the property Show header or Make header editable for the tabular view.

Sorting in Runtime

To mark the relevant column for sorting in Runtime and to determine the sorting sequence, configure the graphic element for the title line:

  1. Select the Graphics files for the Display style property
  2. Link the Sort ascending and Sort descending properties with a graphics file
  3. The selected graphic for the respective sorting direction is displayed in Runtime for the sorting of relevant columns
  4. Clicking on the graphic changes the sorting sequence
  5. Clicking in the column title activates the column for sorting

Configuring the appearance for scroll bars and grid

To define the size and appearance of scroll bars, the header or grids:

  1. Activate, in the Representation group, the Extended graphical settings property
  2. Define the desired properties in the groups Scroll bars and Header and grid

You can find information on the individual properties in the embedded help.

info Information

If the Graphics file property is selected for the Display style property, then all elements for which no graphics file has been selected are shown with a color gradient. Transparent graphics cannot be used for control elements for lists.


Graphic for checkbox

Manual -> Screens -> Edit screen elements -> Graphic actions -> Designing lists -> Graphic for checkbox

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Checkboxes with graphics can be designed individually. To do this, assign the desired graphics to the corresponding properties in the Editor. The graphics must already be created in the Files\graphics node. The defined graphics are drawn in Runtime with the aspect ratio being taken into account.

You define which graphics file is used for the status of a check box with the properties in the Representation group:

  • On: The check box is switched on (activated).
  • On (inactive): The check box is switched on (activated) and cannot be changed.
  • Off: The check box is switched off.
  • Off (inactive): The check box is switched off and cannot be changed.


Add and delete dots

Manual -> Screens -> Edit screen elements -> Graphic actions -> Add and delete dots

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Add and delete dots for polylines, polygons and tubes:

Adding corners:

To add corners (corner points):

  • move the mouse cursor to a line of the polygon:
  • right-click
  • select menu item Adding a node in the selected element from the context menu

or:

  • press Ctrl and Shift simultaneously
  • move the mouse cursor to a line of the polygon:
  • the mouse cursor changes to an arrow with a plus-symbol
  • left-click in order to add a corner

Removing corners:

  • move the mouse cursor to a corner of the polygon:
  • right-click
  • select menu item Deleting the node in the selected element from the context menu

or:

  • press Ctrl and Shift simultaneously
  • move the mouse cursor to a corner of the polygon:
  • the mouse cursor changes to an arrow with a plus-symbol
  • left-click to delete the corner


Arrows in vector elements

Manual -> Screens -> Edit screen elements -> Graphic actions -> Arrows in vector elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A symbol for the start and end of a line can be defined for all vector elements that display open figures. This applies for:

  • Line
  • Polyline
  • Unfilled arc of a circle
  • Unfilled segment of a circle

To add a symbol:

  1. ensure that the Graphics quality property (Screens node) is activated
  2. draw the element
  3. In properties, in the End of line group, select the properties for:
    1. Start type: Symbol for start of line.
    2. End type: Symbol for end of line.
    3. Size: enlargement factor for line width. The factor relates to the line width of the vector element as defined in the Line width [Pixel] property. Default = 0

The following symbols are available:

from left or to the left:

from the right or to the right:

info Information

These elements are not available:

  • under Windows CE, because Graphics quality must be activated
  • with a filled circle segment
  • with a filled arc of a circle


Example for arrows

Manual -> Screens -> Edit screen elements -> Graphic actions -> Arrows in vector elements -> Example for arrows

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Vector elements with start and end symbols with an enlargement factor of 1.5:


Grid

Manual -> Screens -> Edit screen elements -> Graphic actions -> Grid

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In zenon Editor, there is the possibility to turn on a grid, in order to align elements at an incremental position. The grid makes it possible to align elements precisely on the screen. The basic settings are in the Options/Settings menu:

Grid

Parameters

Description

Display grid

Active: Shows the grid that can be defined in the main window under Grid type.
Inactive: Grid is not displayed.

Use grid

Active: Screen elements are automatically aligned with the grid. This function is independent from the option Display grid.

Color

Defines the grid color. The windows color palette is used for selection.

Display

Drop-down list with the type of grid display:

  • full
  • Intersections

Vertical space

Defines the horizontal and vertical distance between unique marker points. Therefore, it also defines how finely scaled element sized can be displayed. Recommended grid distance: 10 pixels horizontally and vertically.

Horizontal space

In the picture context menu, you decide

Menu entry | Description
Display grid | Switch grid to visible or invisible.
Use grid | Elements are aligned in the grid.
Use magnetic points | Touch points of objects move into place when neared and align themselves to each other.

info Information

If grid points are 5 pixels or less, only the grid lines that are more than 5 pixels apart are displayed. The smaller grid lines are also used tor the positioning.


Font

Manual -> Screens -> Edit screen elements -> Graphic actions -> Font

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A default font is automatically created when creating a project. This is provided as the standard font for new objects. The default font cannot be deleted. If you require other fonts:

  • create the desired font in the Fonts node (subnode of Screens)
  • select the font in the object properties (node Representation, property Font)


Select

Manual -> Screens -> Edit screen elements -> Graphic actions -> Select

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Objects are selected by means of a mouse click. To select several objects:

  • When clicking, hold down the shift or ctrl key
    or
  • Drag a rectangle with the mouse

To deselect an object again, click on it with the Ctrl button held down.

Change the selection sequence

If objects are to be aligned next to one another, the object that is selected first is used as a reference. You recognize the reference object as a completely-filled sizing handle. To make a different object the reference object:

  1. Hold down the Shift key
  2. Click the mouse onto the object that is to be the reference object

Aligning a selected object

You can find further information on selecting objects in the Editor/toolbars/alignment and Editor/menu bar/Edit chapters


Scale, center and zoom

Manual -> Screens -> Edit screen elements -> Graphic actions -> Scale, center and zoom

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Scaling

This you can scale elements in two ways:

  1. proportional: Hold down the shift key when scaling
  2. around the center: hold down the shift key to do this

Note: If an angel dissimilar to 0 via property Rotation angle [°] was defined for an element, scaling via arrow keys is not possible.

info Information

Scaling of symbols:

If the symbol contains a static text element and is embedded in this element as text, then this text:

  • Is scaled in the Editor
  • Is not scaled in Runtime

This only applies to symbols. Embedded text is neither scaled in the Editor nor in Runtime in all arrangements.

Center

The currently selected element can be centered in the editing window with the H key.

Zoom

Editor

There are two zoom modes available in the Editor above the Zoom symbol:

  • Variable zoom:
    A predefined value can be selected from the combobox, or you can directly enter any value between 15% and 400%.
  • Zoom tool:
    You can zoom directly in the screen with the two magnifier symbols (+ and -). The CTRL key switches between the different modes. The defined zoom is saved for each single screen.

Close zoom mode: Click on the Edit mode symbol in the Elements toolbar.

Runtime

A screen can only be zoomed within the limits that have been set for the following properties:

  • Width (maximum) [pixels]
  • Height (maximum) [pixels]
  • Breite(Minimum) [Pixel]
  • Höhe(Minimum) [Pixel]

If a limit has been reached when zooming, then an attempt is made to continue zooming in the free directions. The page ratio is taken into account in the process.

Faceplate screens cannot be zoomed.


Keyboard shortcuts

Manual -> Screens -> Edit screen elements -> Graphic actions -> Keyboard shortcuts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Shortcuts for the graphic editor:

Note for shortcuts: The plus sign (+) means that keys a pressed together.
For example:

Ctrl+A means: Hold key Ctrl and then press key A.

Ctrl++ means hold key Ctrl and press key +.

General

Command | Key combination
Main window: Scroll content with 'moving hand' | Press and hold Space
Close current screen | Ctrl+F4
Open properties | Alt+Return

Select

Command

Key combination

Select several objects

Press Shift or Ctrl

Deselect selected object during multi-select

Ctrl+mouse click

Selection: Change sort order. Defines the element on which all others realign

Press Shift during selection

Select hidden objects
  1. Press Alt
  2. Click object and move it

Select all elements of a screen.

Ctrl+A

Select next element according to the order of their creation

Tab

Select previous element according to the order of their creation

Shift+Tab

Positioning

Command | Key combination
Move selected object. | Cursor keys
Move by 10 pixels each time you press a cursor key | Shift+arrow keys
Move only horizontally or only vertically | Press Shift during moving
Centers the selected object in the working section | H

Actions

Command | Key combination
Saves changes | Ctrl+S
Pastes element from the clipboard | Ctrl+V Shift+Ins
Inserts element from the clipboard at its original position; original and copy lie congruently on top of each user | Ctrl+Shift+V
Copies selected element. | Ctrl+C Ctrl+Ins
Copy instead of move | Press Ctrl during moving
Deletes selected element | Del
Cuts out the selected element | Shift+Del Ctrl+X
Undoes changes | Ctrl+Z Alt+Backspace
Add or delete node in the selected element. Add: Mouse cursor turns to plus symbol (+). Delete: Mouse cursor turns to minus symbol (-). Works for polylines, polygons and pipe elements. | Ctrl+Shift
Cancel drawing of polylines and polygons | S
Cancel drawing of polylines and polygons and delete the section which was drawn last | Esc
Move selected elements one level up | +
Move selected elements one level down | -
Move selected elements to the foreground | Ctrl++
Move selected elements to the background | Ctrl+-

Scaling

Command

Key combination

Change size

Move mouse cursor to the handle so that the mouse cursor changes to an arrow. After that you can position accurate to the last pixel with the help of the Cursor keys or in steps of 10 pixels with the help of the Cursor keys+Shift.

Note: If an angel dissimilar to 0 via property Rotation angle [°] was defined for an element, scaling via arrow keys is not possible.

Scaling object around the center

Press Alt during scaling.

Proportional scaling

Press Shift during scaling


Assign a key to a control element

Manual -> Screens -> Edit screen elements -> Graphic actions -> Assign a key to a control element

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Operable elements in a screen can be linked using a key combination and operated in this way. This applies, for example, to:

  • Execution of control elements and assigned functions such as print, move screen, etc.
  • Send value (such as with switch)
  • Set focus of certain windows (such as curve list in Extended Trend or Comboboxes in the Recipe Group Manager)

The element control function can be carried out with the keyboard in Runtime.

To assign a key to a control element:

  1. Highlight the control element
  2. Navigate to the Key combination property (object properties -> Runtime -> Keyboard operation)
  3. Click on the ... button or in the input field
  4. The dialog for defining the key combination is opened

Parameters | Description
Key combination | Input of the key combination. Click in the field and press the desired key or key combination, for example: A. The key combination is displayed in the input field.
X | Deletes the character sequence in the input field.
OK | Accepts key combination and closes dialog.
Cancel | Discards input/change and closes dialog.
Help | Opens online help.


Replacing linking of variables and functions

Manual -> Screens -> Edit screen elements -> Replacing linking of variables and functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If several variables or functions are to be replaced at the same time, it is best if you use automatic replacement for:

  • Replacing linking in the Editor screen
  • Replacing linking with screen switching
  • Replace indices
  • Symbols

You can also read about automated replacement for configuration in the Efficient configuration with zenon manual in the Reusing elements section.


Naming conventions

Manual -> Screens -> Edit screen elements -> Replacing linking of variables and functions -> Naming conventions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To be able to replace variables and other elements securely, the naming should be systematic and standardized if possible. You therefore support not only the reusability, but also maintenance and reverse engineering.

Different systems support you with systematic naming.

For example: Energy industry

Germany

  • KKS (Kraftwerk-Kennzeichen-System - Power Plant Classification System), for details (in German), see http://de.wikipedia.org/wiki/Kraftwerk-Kennzeichensystem
  • DIN 6779 (Kennzeichnungssystematik für technische Produkte und technische Produktdokumentation - Classification System for Technical Products and Technical Product Documentation), for details (in German), see http://de.wikipedia.org/wiki/DIN_6779
  • AKZ (Anlagenkennzeichnungssystem - Equipment Classification System), for details (in German), see http://de.wikipedia.org/wiki/Anlagenkennzeichnungssystem

International

  • KKS (Power Plant Classification System), for details, see http://en.wikipedia.org/wiki/KKS_Power_Plant_Classification_System

Such standards exist for all industries. It is recommended that their naming convention is used.

SQL example

Variables are to be named in accordance with the KKS in an energy project. A corresponding variable with the label C01_MDY10-QA001_QA07 indicates:

  • Wind energy equipment C01 (row C, no. 1)
  • Wind turbine controlMDY10, Power part QA001,
  • Power protection QA07


Replacing linking in the Editor screen

Manual -> Screens -> Edit screen elements -> Replacing linking of variables and functions -> Replacing linking in the Editor screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Linked variables or functions can be permanently replaced in the Editor in a rule-based manner. The replacement is not limited to the functions or variables defined in the properties of the Variable / function group. All other variables used the screen can, such as variables for Visibility, Flashing, Size and rotation dynamic and others.

To replace variables or functions in a rule-based manner in the element directly:

  1. Highlight the desired element and open it by right clicking the element in the context menu
  2. select Replace Links
  3. The dialog for the replacement of links opens

Property | Description
Source | Enter the partial string to be searched for. Place holder * and ? can be used. Placeholders are only permitted as prefix or suffix; e.g. *xxx or xxx*.
Objective | Entry of the partial string
Name | Swaps information in process variable names.
Identification | Exchanges information in the identification
Note capitalization | When swapping, be sure that any capitalization is an exact match.
Accept | Swaps target strings from the source for those defined in the target.
Variable/function | Opens the selection list for variables/functions in relation to the selected line in the list. Clicking on the variable in the list defines new target variables. Alternative: Double-click on the source variable in question.

Replace

a) Replace by manual selection

  • select the element from the list that you would like as the source
  • select a target element via the variable/function button
  • the previous element is replaced by the new one

b) automated replacement with rules

  • In the source input field, define the parameters for the element that you wish to replace
  • define the parameter for the new variable/function in the target input field
  • specify what is to be replaced via Name/Identification
  • Click on Accept

info Information

The target variable or target function can also be in a different project as the source variable or source function. In doing so, all projects concerned must be started and available on the same computer in Runtime.

attention Attention

When replacing variables, be aware of the type and signal resolution. If you replace a variable with one of an incompatible type, this can lead to errors during execution. You will be warned when making the substitution; the substitution will however be carried out.

info Information

Replace via Drag&Drop: Elements that can only contain one variable or function can be swapped by dragging & dropping. Drag the new variable or function to the element using the mouse. It automatically replaces the previous one.


Replacing linking with screen switching

Manual -> Screens -> Edit screen elements -> Replacing linking of variables and functions -> Replacing linking with screen switching

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Linked variables or functions in one or more elements, as well as Alias in the ALC can be replaced with screen switching. In doing so, the elements in the screen are not replaced on a lasting basis, but the screen switching is linked in Runtime.

To replace linking when screen switching:

  1. Configure a screen switching function
  2. Contains elements that can be replaced in the screen, the dialog for replacement is opened
  3. Assign the function to a button in order to be able to execute screen switching in Runtime

Property | Description
Source | Enter the partial string to be searched for. Place holder * and ? can be used. Placeholders are only permitted as prefix or suffix; e.g. *xxx or xxx*.
Objective | Entry of the partial string
Name | Swaps information in process variable names.
Identification | Exchanges information in the identification
Note capitalization | When swapping, be sure that any capitalization is an exact match.
Accept | Swaps target strings from the source for those defined in the target.
Variable/function | Opens the selection list for variables/functions in relation to the selected line in the list. Clicking on the variable in the list defines new target variables. Alternative: Double-click on the source variable in question.

Replace

a) Replace by manual selection

  • select the element from the list that you would like as the source
  • select a target element via the variable/function button
  • the previous element is replaced by the new one

b) automated replacement with rules

  • In the source input field, define the parameters for the element that you wish to replace
  • define the parameter for the new variable/function in the target input field
  • specify what is to be replaced via Name/Identification
  • Click on Accept

info Information

The target variable or target function can also be in a different project as the source variable or source function. In doing so, all projects concerned must be started and available on the same computer in Runtime.

attention Attention

When replacing variables, be aware of the type and signal resolution. If you replace a variable with one of an incompatible type, this can lead to errors during execution. You will be warned when making the substitution; the substitution will however be carried out.

Replacing interlockings

In the dialog, the variables of the interlockings used in this screen appear next to the variables directly linked to the screen. This also includes the result variable of an interlocking. If a variable was linked to both the elements of a screen and with interlockings of a screen, they only appear once in the dialog.

The variables to be replaced for all interlockings that use these variables are replaced in Runtime. In addition to the variables normally linked to interlocking, the result variables linked to the interlocking are replaced for the screen.

Replacement in integration projects

If variables or functions are replaced between a subproject and the integration project, it must be ensured that all projects involved in Runtime are available and started on the computer.

Example Example

Screen switching to a screen of the subproject is configured in the subproject. In doing so, the variable variable1 of the subproject is replaced by the variable variable2 of the integration project. In order for this replacement to be carried out in Runtime, the integration project must be the start project.

If the subproject is the start project, the variable2 variable of the integration project is not available. No replacement is carried out and the original variable1 variable of the subproject is used.

The user is not informed that the replacement was not successful in Runtime.


Example: Replace linked variables, rule-based

Manual -> Screens -> Edit screen elements -> Replacing linking of variables and functions -> Replacing linking with screen switching -> Example: Replace linked variables, rule-based

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

All variables with Tank1 in the name are to be replaced by Tank4.

  1. Enter, into the Source text field, Tank1. With the * character, you can include all variables that start with Tank1.
  2. Enter, in the Ziel text field, Tank4.
  3. Click on Accept.
  4. The variables Tank1_max and Tank1_min are replaced by the variables Tank4_max and Tank4_min.


Replace indices

Manual -> Screens -> Edit screen elements -> Replacing linking of variables and functions -> Replace indices

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When switching screens in Runtime, variables can be replaced dynamically using indexing rules and functions via parameters.

Key words in the substitution rule:

  • Values via indexing variables: for example {X01}
  • Parameters: {PARAM}

attention Attention

Because the names are replaced, variables and functions must always be given different names. Variables and functions are replaced if the names are the same.

Example: If there is a test variable and a test function and the test variable is to be replaced, the test function is also replaced at the same time.

Hint: Name variables and functions each with a prefix (for example var_ and func_). You therefore always have a overview in lists too.

Create parameters for indexing variables and functions

Parameters for indexing variables

Indexing variables can be selected in the dialog to replace indexes. Each variable is defined using its own parameters. This is displayed in the list of indexing variables.

Parameters for functions

Parameters for functions are used in the substitution dialog for indexes of screen switching. In doing so, the key word {PARAM} is replaced by the content of the parameter entry in the substitution rule.

Note: Avoid character sequences that are also used for parameter of the indexing variables, such as {X01}.

Functions that are linked to the following screen elements can be replaced using parameters:

  • Button
  • Combo-/Listbox
  • Combined element

To set a parameter, enter the character sequence for the parameter into the corresponding property:

  • Button and combined element: Parameter for substitution property in the Variable / function group
  • Combo / list box Parameter for substitution option in the configuration dialog of the static combo box or list box

When executing a function in Runtime that uses substitution, the key word {PARAM} is replaced by its respective entry. If the entry does not provide a meaningful result, the original value is displayed.

Examples:

  • If the result of the replacement is motor[13], but index 13 does not exist, the original value is displayed.
  • If the parameter is 1 and the rule is to replace motor[3] with motor[1] and both parameters exist, the element that previously displayed motor[3] will now display motor[1].

Replace indexes dialog

Indexing rules

Parameters

Description

Indexing rules

Configuration of the rules for the replacement of variables and functions.

Source

Entry of the source that is to be substituted.

Target

Entry of the target. Parameters for values from indexing values such as ({X1} and parameters {PARAM} for functions can also be used.

Case sensitive
  • Active: The replacement is case-sensitive.

List of rules

List of defined rules.

Add rule

Clicking on the button adds the defined rule available via Source and Target to the list.

Remove rule

Clicking on the button deletes the selected rule from the list.

Arrow upwards

Clicking on the button arranges the selected rule in the list one position up.

Arrow downwards

Clicking on the button arranges the selected rule in the list one position down.

Indexing variables

Parameters | Description
Indexing variables | Configuration of the indexing variables.
List of rules | Shows the selected indexing variables.
Add | Clicking on the button opens the dialog to add and remove indexing variables. Selected variables are added in sequence and given a parameter. This can be used in the replacement rules for the respective indexing variable. The values of these variables are genereally used during replacement.

Replacement preview

Parameters | Description
Replacement preview | Displays the configured replacements.
List of planned replacements | Lists all configured substitutions. Clicking on an entry also fills the Source and Target options in the indexing rules section.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

attention Attention

If index variables are used in a network project, the Client must first fetch the value from the Server. Then the calculation is executed. On devices with outdated hardware, this may cause delays when screen switching.
Therefore index variables should always be set to Harddisk data storage active in a network project.


Replace indexes dialog

Manual -> Screens -> Edit screen elements -> Replacing linking of variables and functions -> Replace indices -> Replace indexes dialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Indexing rules

Parameters

Description

Indexing rules

Configuration of the rules for the replacement of variables and functions.

Source

Entry of the source that is to be substituted.

Target

Entry of the target. Parameters for values from indexing values such as ({X1} and parameters {PARAM} for functions can also be used.

Case sensitive
  • Active: The replacement is case-sensitive.

List of rules

List of defined rules.

Add rule

Clicking on the button adds the defined rule available via Source and Target to the list.

Remove rule

Clicking on the button deletes the selected rule from the list.

Arrow upwards

Clicking on the button arranges the selected rule in the list one position up.

Arrow downwards

Clicking on the button arranges the selected rule in the list one position down.

Indexing variables

Parameters | Description
Indexing variables | Configuration of the indexing variables.
List of rules | Shows the selected indexing variables.
Add | Clicking on the button opens the dialog to add and remove indexing variables. Selected variables are added in sequence and given a parameter. This can be used in the replacement rules for the respective indexing variable. The values of these variables are genereally used during replacement.

Replacement preview

Parameters | Description
Replacement preview | Displays the configured replacements.
List of planned replacements | Lists all configured substitutions. Clicking on an entry also fills the Source and Target options in the indexing rules section.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

attention Attention

If index variables are used in a network project, the Client must first fetch the value from the Server. Then the calculation is executed. On devices with outdated hardware, this may cause delays when screen switching.
Therefore index variables should always be set to Harddisk data storage active in a network project.


Configure replacement of indexes

Manual -> Screens -> Edit screen elements -> Replacing linking of variables and functions -> Replace indices -> Configure replacement of indexes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure the replacement of indices:

  1. All variables and functions used in the screen are displayed in the Source field of the Replacement preview.
  2. Left-click the variable or function for which you want to create an indexing rule.
  3. In the Indexing rules area, the variable/function is entered in the fields Source and Target.
    Alternatively, you can also enter the desired variable/function directly into the Source field in the Indexing rules.
  4. Define the indexing rule.
    The dynamic part of the rule is inserted in curly brackets, for example {X01}.

    Example:

    The source variable Motor1.drehzahl is replaced by the target Motor{X01}.drehzahl ,
    the placeholder X01 is replaced with the respective value of the index variable in Runtime.
    The replacement rule would thus be:

    Source: Motor1

    Target: Motor{X01}

  5. Carry this over to Add Rule by left clicking in the indexing rules.
  6. All indexing rules that have been created are displayed in this list.
  7. You can change the order of the entries using the button with the arrow symbol.

    Attention: The substitutions are executed in the order in which they are displayed in the list!

  8. Variables that are not present on the screen but are used in the replacement can be inserted via the Add Variables... button in the Indexing Variables window.
  9. The variables which are in this list are always kept in the memory in order to minimize waiting time when the screen is loaded.

info Information

For the placeholder * the same rules as for Replace links are valid.

Replace throughout the project

If the target is in a different project to the source, this can be displayed with #.

Example Example

Source: VAR_1

Target: VAR_1 in Projekt_1

You thus enter VAR_1 as the source and Projekt_1#VAR_1 as the target.

Source: SUBPROJEKT1#VAR_1

Target: {X01}VAR_1

The index variable X01 is a string variable and has the project name including # as a value, for example SUBPROJEKT4#.


replace multiples with indexing variables and function parameters

Manual -> Screens -> Edit screen elements -> Replacing linking of variables and functions -> Replace indices -> replace multiples with indexing variables and function parameters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The parameters for indexing variables and functions can be combined as desired and used as often as desired.

Rules:

If the parameter is configured as a character string {X01} and this index exists for indexing variables, then {X01} is not replaced by the value of the indexing variables, but only {PARAM} by the character sequence {X01}, without an attendant variable being searched for.

Examples

Different parameters

  • Base values:
    • The value for the Parameter for substitution property is 1.
    • Index X01 has the value 2.
    • Index X02 has the value 3.
  • Rule:
    • Replace monitor[3] with monitor[{PARAM}{X01}{X02}{PARAM}{X02}]
  • Result:
    • monitor[12313]

Parameter for function is identical to parameter for indexing variables

  • Base values:
    • The value for the Parameter for substitution property is {X01}.
    • Index X01 has the value 2.
    • Index X02 has the value 3.
  • Rule:
    • Replace monitor[3] with monitor[{PARAM}{X01}{X02}{PARAM}{X02}]
  • Result:
    • mon[{X01}23{X01}3]


Background graphics

Manual -> Screens -> Edit screen elements -> Background graphics

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A graphics file can be displayed in the background of every screen. These graphics are positioned in the visibility level furthest to the back and are covered by all other screen elements. It works along the lines of the background graphics of Windows Desktop.

Options such as centered or tiled are available for positioning. It is not possible to freely move the graphics.

Only graphics data that is already available in the project in the Files/Graphics area can be used. See: Files.

Hint: If you wish to use the same background graphics for several screens, you can pre-define the background graphics in the frames. See: Background graphics for frames

Hint: Alternatively, a button with a graphics file can be used without a linked function to display a freely-positionable graphics file


Functions Selection dialog

Manual -> Screens -> Edit screen elements -> Functions Selection dialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to select functions, a filtered dialog is opened:

Element

Description

Project tree

Definition of the project from which the function should be selected.

Selection window

Selection of the function.

No selection

Depending on the element:

  • the dialog is canceled
  • already linked functions are deleted

Hint: The size of this dialog can be adjusted. The dialog size and position are saved.

Change linked function

  1. manually
    • in the Project Manager´s Detail view open the functions
    • drag the desired function on the element while holding the left mouse button
    • the previous function is substituted by the new one
  2. automatic
    • Select the entry Replace links from the context menu. For more details see chapter Substitution of variables and functions in dynamic elements.


Variables selection dialog

Manual -> Screens -> Edit screen elements -> Variables selection dialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to select variables, a filtered dialog is displayed.

Hint: The size of this dialog can be adjusted. The dialog size and position are saved.

Note: These variables can also be used throughout projects sometimes. When selecting throughout projects, ensure that the corresponding projects are available in Runtime.

Linking a variable

Elements that can only be linked with one unique variable open the following dialog:

Element

Description

Project tree

Selection of the project from which the variable is to be selected.

Selection window

Selection of the variable which shall be linked. It can be linked in two ways:

  • By double-clicking on the desired variable: The dialog is closed automatically.
  • By selecting the desired variable and subsequently clicking OK.

No selection

Depending on the element:

  • the dialog is canceled
  • Variables that are already linked are deleted (such as linked lot variables in the Historian)

Note: If the desired variable is not displayed, there can by several reasons for this:

  • You have selected a filter and the desired variable does not match the filter: Check whether there is a filter active in the filter line. The information about filtered elements which is displayed at the bottom of the selection window also helps when checking for an active filter.
  • The dialog is filtered by the Editor and the variable does not match the filter. The filtered display takes place when only special data types are allowed; e.g. for the dynamic element Numerical value no string variables can be linked.
  • You have selected the wring project in the project tree.

attention Attention

The dialog generally allows the choice of multiple variables via the usual Windows keyboard shortcuts, but in this step only one can be linked. For multiple selection the first chosen variable is assigned to the element.

Linking multiple variables:

Elements that can be linked with multiple variables open the following dialog:

Element

Description

Project tree

Definition of the project from which the variable shall be selected.

Selection window

Selection of the variables:

  • Double click the selected variable in order to add it to the variable list.
  • You can move the selected variable to the variable list via Drag&Drop
  • Select the desired variable. With the help of Ctrl and/or Shift multi-selection is possible. By clicking Add the selected variables are added to the variable list.

Variable list

Lists all selected variables.

Add

Adds the currently selected variable of the selection window to the variable list.

Delete

Removes the variables which are selected in the variable list from the list.

No selection

Depending on the element:

  • the dialog is canceled
  • certain links such as lot variables in archiving can be released

Note: If the desired variable is not displayed, there can by several reasons for this:

  • You have selected a filter and the desired variable does not match the filter: Check whether there is a filter active in the filter line. The information about filtered elements which is displayed at the bottom of the selection window also helps when checking for an active filter.
  • The dialog is filtered by the Editor and the variable does not match the filter. The filtered display takes place when only special data types are allowed; e.g. for the dynamic element Numerical value no string variables can be linked.
  • You have selected the wring project in the project tree.
  • Change linked variable

Select the entry Replace links from the element´s context menu. For more details see chapter Substitution of variables and functions in dynamic elements.


Frames

Manual -> Screens -> Frames

Frames form the basis for the layout of the window and the screens displayed during the Runtime. You structure the display on the screen and determine the position. Each screen is assigned to a frame and displayed in the screen area defined by the frame.

Frames determine the general window properties such as position, size, appearance and manipulation options during runtime.

Frames:

  • Provides an overview of all screen areas defined in a project.
  • Can be freely defined using the Define free frame shape property.
  • Enable special functions to be allocated to all screens available in a frame, for instance:

    Return to last screen, Set focus on frame, Take focus from frame, Close frame, Acknowledge flashing alarms, Print screenshot.

  • Change all screens based on the corresponding frame
  • Screens always appear in the same size at the defined location in runtime and cannot be moved as desired
  • Can be automatically closed in Runtime if the focus is lost
  • Screens within a frame can be changed at will in online operation.

info Information

If there is no frame when creating a screen, then zenon automatically creates a default frame that covers the whole screen.

Context menu Project manager

Menu item | Action
Create new frame | Creates a new frame.
Open Frame Editor | Opens the frame editor in the main window and shows the list of frames in detail view.
Export XML all... | Exports all entries as an XML file.
Import XML... | Imports entries from an XML file. Note: Existing frames are overwritten via the Frames node during XML import. In this case, all screens and their elements are adapted to the new frame.
Help | Opens online help.


Frame detail view of toolbar and context menu

Manual -> Screens -> Frames -> Frame detail view of toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Menu item | Action
Create new frame | Adds a new frame to the list and puts the focus onto this entry.
Open Frame Editor | Opens the frame editor in the main window.
Define free frame shape | Changes to the main window to define a free frame shape.
Jump back to starting element | If you entered the list via function linked elements, the symbol leads back to the start element. Only available in the context menu when all linked elements are opened.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Export selected XML | Exports all selected entries as an XML file.
Import XML | Imports entries from an XML file. Note: Existing frames are overwritten via the Frames node during XML import. In this case, all screens and their elements are adapted to the new frame.
Remove all filters | Removes all filter settings.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Help | Opens online help.


Frame editor

Manual -> Screens -> Frames -> Frame editor

You can define and position all frames in the frame editor.


Opening the frame editor

Manual -> Screens -> Frames -> Frame editor -> Opening the frame editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To open the frame editor:

  • In the project manager, click on the desired frame twice in Frames Detail View

    or

  • select Project Manager -> Frames -> Context Menu -> Open Frame Editor

The size displayed in the frame editor is dependent on the monitor size set in monitor administration. See chapter on monitor configuration.) If the monitor settings are subsequently changed, the frame editor must be closed and reopened in order for it to take the new monitor settings into account.

The red frame for the alarm status line is automatically created at the upper edge of the screen by zenon for each project. Its position can be changed via the properties in the Position group. To do this, the Use standard position property must be deactivated.


Create new frame

Manual -> Screens -> Frames -> Frame editor -> Create new frame

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You have two possibilities to create a new frame:

  • Create a new frame in the size defined in the monitor properties:
    Project Manager -> Frames -> Context menu -> Create new frame

or

Frame detail view -> Context menu -> New frame

  • Mounting a new frame:

Main Window-> Context Menu -> Draw New Frame

Note: The mouse pointer becomes a black square with a cross in the upper left left corner as the starting point. With this, you drag the frame in the size you have defined to the desired position.

Create new frame

To create a palette:

  1. In the project manager, select the Frames sub item in the Screens node.
  2. Select New frame in the context menu.
  3. A new waterfall frame is created.
  4. The initial size is determined by the size of the display.
  5. click in the new frame and drag the frame over the touch point to the desired size

    The size, as well as the size when called up in Runtime and the properties for moving are modified by means of the properties on the Position group.

  6. Position the frame at the desired location in the window.
  7. Define the desired properties in the properties window

attention Attention

If frames receive the same name in the global project and in the subproject, then frames in the global project are automatically given the prefix g_.

Example Example

three areas must be present in the whole project:

  • A header appears at the top of the screen with the time and a logo.
    A header frame is defined for this area. This defines the size and position of the header.
  • A menu appears at the bottom of the screen.
    A menu bar is created.
  • Interim process screens.
    A process screen is created.

The frames are always displayed in the defined size at the defined location. All screens created then are linked to one of these frames and in the Runtime opened in it. If the screen design is changed, because, for instance, menu bars are to be displayed at the top and the header is to be a footer, only the position of the frames need be changed. The screens contained in the frames are automatically carried over.

Hint: Never place the templates directly above one another. This way you ensure that you always have access to the screens in Runtime.

Change the size in Runtime

if the size of a frame can be changed in Runtime, the permitted size changes can be limited by means of the following properties in the Position group:

  • Breite(Minimum) [Pixel]: Defines the minimum width.
  • Breite(Maximum) [Pixel]: Defines the maximum width.
  • Höhe(Minimum) [Pixel]: Defines the minimum height.
  • Höhe(Maximum) [Pixel]: Defines the maximum height.

These limits only have an effect on manipulation using Multi-Touch gestures.

Positioning frames

The position and orientation of a frame or a group of selected frame can be selected via the Arrange context menu in the main window.

Positioning with connection points

If the option 'Use connection points' was activated (see chapter Editor, Section Settings), the connection points of frames stick to those of other frames. In addition, frames can connect to the screen border and to a possibly present (if activated in the project) alarm line.


Frame with free frame shape

Manual -> Screens -> Frames -> Frame editor -> Create new frame -> Frame with free frame shape

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can adapt the frame shape to your individual wishes using the Freely defineable frame shape property. After you have activated this property, you arrive at the frame editor in one of the following ways:

  • Click on the button of the Define free frame shape property
  • Click on the corresponding symbol frame in the toolbar
  • Select the menu entry Define Free Frame in the context menu when selecting the frame
  • Select the Define Free Frame menu entry in the Context menu in the frame editor
  • Double click on a frame in the frame editor

Here, you can create the frame as you wish with the rectangle, circle, rounded rectangle and polygon elements. The transparent area is shown as a white-gray chessboard pattern.

info Information

Freely defineable frame shape is not available:

  • For alarm status line frame
  • Under Windows CE

If the Define free frame shape property is deactivated an existing free frame form is not displayed in either the frame editor or the screen editor.

Freely defineable frame shape Cannot be used with Border.

You decide how the respective element influences the appearance of the frame with the help of the Area utilization property. To do this, the following settings are available:

Parameters | Description
Cover | The surface of the element is used as the screen area.
Cut | The surface of the element is removed from the surfaces underneath. For instance, you can create "holes" in the frame, for example.
ORed | This is either cut out or covered according to whether a covering element is under the element or not.
info Info
The way the surface is used always relates to the surfaces under the element. If you, for example, draw a covering element over a cutting element, the surface is displayed filled. If you reverse the sequence, the cutting element is removed from the covering element.


Display frames in frame editor

Manual -> Screens -> Frames -> Frame editor -> Create new frame -> Display frames in frame editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Frames can be switched to visible or invisible by:

  • Property Display in Frame Editor:
    activated: displays frame
  • Drag&dop:
    invisible Drag frame from the main window
    visible: drag frame from the detail view into the main window
  • Detail view-> View of frame editor:
    invisible: Deactivate checkbox
    visible: Activate checkbox

You obtain information on the name and position of the frame in the upper left corner of the frame and via tooltip if you move the mouse pointer over the frame.

info Information

A system menu or an alarm status line is automatically taken into account in the frame editor and always displayed in the foreground. An incorrectly positioned frame can therefore not hide any important information during runtime.


Positioning and actions in Runtime

Manual -> Screens -> Frames -> Frame editor -> Positioning and actions in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Frames can be switched to fixed or relatively defined positions in Runtime. In this way, keyboard screens or pop-up screens can be positioned exactly where the mouse pointer or the element to be switched is located. Frames can be switched in runtime:

  • at an absolute position
  • relative to the mouse position
  • relative to element

Absolute and relative positions are defined in the properties of the frame in the zenon Editor.

Keep position when displaying again

Windows always take their screen position from the template. If pop up screens are planned and moved whilst the program is running, the pop up screen is moved back to the planned position the next time the screen switching function is activated. Using the Keep position and size on reopening property, the template can be set to keep its position as long as it is open, regardless of screen switches. If the property is active:

  • If a screen is opened in Runtime in a manually-moved frame, its position and size are also retained if the screen is switched.
  • If another screen is opened in the in the same template, its position is retained. This also applies for a substituted call.

With this, a different position position for a template can be used on each client, because the local position is always saved.

Absolute Positioning

The frame is always switched at fixed, pre-defined coordinates. A fixed screen position is always used for all screens that are loaded automatically by the system, e.g. by the time control or a limit violation.

Relative positioning

Relative positioning is especially suited to loading pop-ups, keyboard screens or command processing screens. This is possible for all screen switches, set value inputs with freely defined keyboard screens, and command processing screens that are started manually by the user. It does not matter whether the action was triggered by a screen switch function, a set value function or directly via an element. Relative positioning is available for:

  • dynamic elements to which you can allocate a function
  • dynamic elements that can be used to send a set value (buttons, combined elements)
  • Main and Context Menus
  • execute the screen-specific function in the Alarm Message List screen

Relative positioning also works for nested function calls, i.e. when screen switching or the setting of values are triggered by a script. If the screen would stand over the screen border, it is automatically positioned at the screen border. This also applies to multi-monitor management, where screen would rise into the neighboring monitor.

attention Attention

Relative positioning only works when called up directly by the user, not with automated functions or via VBA.

relative to the element

Positions the reference point of the frame relative to the element from which the screen switch was initiated (e.g. a button or a combined element). The frame's reference point is then always placed on the element's calculated reference point. If the frame cannot be switched off in this position because the screen would then be outside the visible screen area, the alternative reference points are used.

First define a reference point for your frame and then the preferred position in the element. The following settings are available:

Property

Value

Reference point element vertical
  • bottom
  • top

Reference point element horizontal
  • Left
  • Right

Vertical movement in pixels

Enter the desired movement

Horizontal movement in pixels

Enter the desired movement

Alternative position

Define an alternative position for the reference point of the frame and the reference point at the element. Proceed with the definition of the alternative positions in the same way as with the definition of the favored positions. The alternative position is used when the frame can not be placed at the favored position.

Relative to the mouse pointer

The screen is displayed depending on the position of the mouse pointer. If the reference point is at the top left side, the frame will be loaded to the bottom right side of the reference point. If the screen cannot be displayed completely at the configured position, the position will be moved until the complete screen is inside the displayed area of the screen.

Define the frame's reference point above the two properties, vertical reference point and horizontal reference point. The reference point is marked on the frame with a red dot. The following settings are available:

Property

Value

Reference point frame vertical
  • top
  • bottom
  • centered

Horizontal frame reference point
  • Left
  • Right
  • Centered

Example Example

you have a button at the right border of the screen and try to position a popup window on its right side:

  • Reference point element: right/centered
  • Reference point element: left/centered

In Runtime, the popup screen will appear on the right side of the button, centered to the middle of the button. The popup window will not cover the button.

You use the same frame also for a button on the left screen border. There may not be enough room on the right side to completely display the popup screen. The alternative configured position will therefore be used. For this, you place the

  • alternative reference point for the element on: left/centered
  • the frame's alternative reference point on right/centered

Change the size in Runtime

The size with which a screen is called up in Runtime and the permitted changes in size are configured with the properties of the Position group.

Property

Description

Width (maximum) [pixels]:

Defines the maximum width.

Height (maximum) [pixels]:

Defines the maximum height.

Limitation Minimum:

Defines limits for minimum. Possible values:

  • Without. No limitation
    If a different value is selected, the selected limit in Runtime is displayed with a dotted line in the frame window.
  • Width: Width limitation.
  • Height. Height limitation.
  • Relative: Limitation to a percentage value of the set screen size.

Only has an effect on Multi-Touch gestures. The corresponding values are defined with the Value (minimum) property.

Default: Without

Opening size:

Defines the size with with which a screen based on this frame is called up in Runtime:

  • Frame size. Size as defined in Width (maximum) [pixels] and Height (maximum) [pixels].
    If a different value is selected, the size in Runtime is displayed with a dotted line in the frame window.
  • Width [px]. Width as defined in Value (Opening size), height is amended accordingly.
  • Height [px]. Size as defined in Value (Opening size), width is amended accordingly.
  • Relative [%]. The size defined in Width (maximum) [pixels] and Height (maximum) [pixels] is amended to the percentage value defined in Value (Opening size).

The corresponding values are defined with the Value (Opening size) property.

Default: Frame size

Moving and zooming

Frames can be moved and zoomed in Runtime.

Move

Moving always relates to the monitors defined in the monitor administration. These settings are not supported under Windows CE.

The moving of frames in Runtime can be limited to:

  • Frame border: The frame cannot be moved beyond the monitor limit.
  • Frame border area: The frame can be moved beyond the monitor limit. However there must be an area on the monitor (Minimum frame margin) that can be accessed for further actions.

The limit is only effective if the frame is already within the defined limit when it is opened. If the moving of a frame is not limited, it can - with Multi-Touch gestures for example - be moved beyond the visible area.

info Information

The moving of frames is most of all envisaged for full-screen operation. The Runtime application itself should not be moved to a different screen. If Runtime is moved, this can lead to limitations when moving.

Zoom

The limits also apply for zooming. If a limit is reached when zooming, an attempt is made to continue zooming in the free space. In doing so, the side ratio is retained.


Call up frame several times

Manual -> Screens -> Frames -> Frame editor -> Call up frame several times

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Frames can be called up several times in Runtime: Screens can therefore also be called up several times. To make frames able to be called up more than once, activate the Frame can be opened multiple times property in the General group of the frame properties.

If this option is activated, the frame is created as an independent instance each time a screen is called up. That means: Screens that have been opened before in this frame remain open.

For example: A screen is called up 100 times:

  • Frame can be opened multiple times active: 100 screens are open on the monitor
  • Frame can be opened multiple times inactive: 1 screen is open on the monitor

Notes for project configuration

If screens that are switched more than once are covered by others, it can happen that these screens remain open, invisible and inaccessible in the background, until Runtime is closed.

The person configuring the project must therefore ensure that no screens get into the background this way.
Recommendations:

  • Activating Always in the foreground property: This keeps the frame/screen in the foreground at all times.
  • Configuration of the Close frame function: This closes all screens that are based on this frame, including those opened in the background.
  • Configuring frames as freely placeable: Operators should be able to place frames on the screen according to their requirements. For example, using touch, with the mouse, or configuration of the relative position of the frame to a control or mouse pointer.

Recommendation: This option is most of all suited to configuring pop-ups.

Only open once per symbol

To open only one screen once per symbol, configure a button that is switched to invisible once it is first opened:

  1. Create a button in the symbol.
  2. Control the visibility of the button with a bool variable
  3. Set this bool variable as a screen-active variable in the screen

As soon as the screen has been opened once, the button can no longer be operated.


Deleting frames

Manual -> Screens -> Frames -> Frame editor -> Deleting frames

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To delete frames, you can:

  • Highlight one or more of the frames with the mouse and select Delete in the context menu or press the Delete key
  • Highlight one or more of the frames in the detail view and select Delete in the context menu or press the Delete key

A request to confirm this action is made before it is deleted.

attention Attention

Deletion of frames cannot be undone.


Define background graphics for frames

Manual -> Screens -> Frames -> Define background graphics for frames

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A graphics file can be displayed in the background of every screen. These graphics are positioned in the visibility level furthest to the back and are covered by all other screen elements. They are positioned via properties; it is not possible to position them freely. Only graphics data that is already available in the project manager in the files/graphics area can be used.

If several screens use the same background color, this is defined with the screen frame:

  1. In properties, click on the Graphics file property in the Background graphic node
  2. select a file from the files/Graphics node in project manager
  3. define the position with the Alignment property

this graphics file is then used for all screens that are created using this frame. However, individual graphics files can still be defined as a background screen for each screen.

Warning! The graphics file is saved with the screens. Changing the graphics file or how they are set up in the frame is only effective for new screens. Existing screens must be changed manually.


Distributed engineering with frames

Manual -> Screens -> Frames -> Distributed engineering with frames

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In multiuser operation, all usual mechanisms for allowing and accepting changes are implemented. In the frame editor however, in contrast to the screens, every frame is handled individually in the frame editor as opposed to the entire screen being released. For a better overview, frames where changes are not permitted are marked with a dotted border.


Main frames

Manual -> Screens -> Frames -> Main frames

Screens that were opened last can be displayed in the system driver using the Last screen open variable. Which templates are incorporated into the display is defined with the Main frames property in the project manager (Graphical design, Runtime general). Click on the ... button to open the dialog for selecting a template:

  • Frames are selected or deselected with a mouse click.
  • Selected frames are displayed with a blue background.
  • Clicking on OK accepts the selection and closes the dialog.

info Information

This property also has an effect on the Screen: Return to last function.


Effects for frames

Manual -> Screens -> Frames -> Effects for frames

Frames can also be provided with effects.

You can find additional effects for screen elements in chapter effects for screen elements.


Highlight frame

Manual -> Screens -> Frames -> Effects for frames -> Highlight frame

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the help of Highlight frame you can highlight a screen in order to draw attention to this screen. For this the frame, on which the screen is based, is highlighted by coloring the remaining area of the Runtime. For this a color and a transparency are defined for the surrounding of the frame of the screen which covers the screen lying below. The screen lying below cannot be operated.

Note:

The screens must be based on different frames with different sizes.

You must not call up more than one screen with this property at any time.

These settings are ignored when used in a faceplate container.

Configuration

To use Highlight frame, call up a screen that is to be on top of another, larger screen. Configuration:

  1. navigate to group Display in the screen properties.
  2. Activate the Modal dialog property.
  3. Activate the Highlight frame property.
  4. With property Surrounding color you configure the color with which the surrounding of the active screen should be colored.
    This property always affects the frame on which the screen is based.
  5. With property Surrounding transparency configure the transparency of property Surrounding color.
  6. Engineer a button for the screen in order to be able to close it in the Runtime.

As soon as you open this screen above another, the area surrounding the frame is colored. Thus optically highlighting the screen. Only this screen can still be operated. After closing the screen, other screens are displayed in normal color again and can be operated.

Example

Screen is opened:

Second screen with active effect Highlight frame is also opened. Everything outside the additionally opened screen is highlighted with the color defined in property Surrounding color and the transparency defined in property Surrounding transparency.


Palettes

Manual -> Screens -> Palettes

Color palettes make it possible to compile individual colors into color palettes. You can define a color set such as this, which can be easily edited at any time, both in the editor and in Runtime. All colors that are defined with the help of palette colors can be easily changed over with this; either centrally or globally with the help of a global project. The colors of the color palette can be used anywhere where colors are used.

This allows the implementation of corporate designs (CD) requirements to be implemented without problems. If necessary, the design can be replaced completely (switching palettes) or only individual colors (color switch in palette) can be changed centrally.

Engineering

Color palettes are created in the editor, can be exported and imported and there is a function to switch these in runtime. Color palettes can be created in both a global project and a local project.

Note: All palettes of a project always contain the same amount of colors. The number of colors of a global project and local project can thus be different.

Attention: In the event of conflicts in the Runtime, the local project's color palettes take priority.

Context menu Project manager

Menu item | Action
New palette | Creates a new color palette with the standard names Color palette plus continuous Index number.
Export XML all... | Exports all entries as an XML file.
Import XML... | Imports entries from an XML file.
Help | Opens online help.


Detail view of color palette toolbar and context menu

Manual -> Screens -> Palettes -> Detail view of color palette toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Toolbar and context menu

no. | Symbol | Action
01 | New palette | Creates a new color palette with the standard names Color palette plus continuous Index number.
02 | Create standard function | opens the dialog to create a Palette Switching Function and automatically activates the selected palette in the drop-down list.
03 | Delete color palette | Delete the palette of the highlighted color. Palettes can only be deleted individually
04 | New color | Creates a new color with the standard color white and the standard name Color plus Index number. New colors are always created for for all palettes of the project. Hint: Give clearly distinct names for the global project and the local project.
05 | Delete color | Deletes the selected color from all palettes of the project. Note: The command is only active if the last color in each palette is highlighted. Because: Only the last color of a palette can be deleted, so that the index numbers continue to work. Furthermore, the color must be deleted for all palettes, so that the number of colors remains identical in all palettes.
06 | Copy | Copies the selected colors to the clipboard.
07 | Paste | Pastes selected colors from the clipboard.
08 | Jump back to starting element | If you entered the list via function linked elements, the symbol leads back to the start element. Only available in the context menu when all linked elements are opened.
09 | Palette in the Editor | opens a drop-down lists with all palettes that can be defined in the local project and in the global project.
10 | Save | Saves all changes to the color palettes.
11 | Export selected XML ... | Exports all selected palettes as an XML file.
12 | Import XML... | Imports entries from an XML file.
13 | Properties | Opens the property window.
14 | Help | Opens online help.


Create and edit colors

Manual -> Screens -> Palettes -> Create and edit colors

You can create color palettes globally or in a local project. Global color palettes are available in all projects, local color palettes are only available in the project in which they were created. If there are conflicts when setting these in runtime, the color projects of the local project take priority(see alsoColor palettes in Runtime).

Create color palette

To create a color palette:

  • select the Color Palettes node (either below Screens in the local project of global project)
  • select the New Color Palette command in the context menu
  • a new palette is created with:
    • Standard name Palette plus Index number (for example Palette 0)
    • the same number of colors as the pre-existing palettes, all colors are white as standard

Rename color palette

To rename a palette individually:

  • select the palette or one or more colors of the palette
  • In properties, select Palette the propertyPalette name in the group
  • enter the desired palette name
    Hint: Give them clear names in order to clearly distinguish between the global project and the local project

Delete color palette

To delete a palette:

  • highlight the palette's complete column
  • In the context menu, select the Delete Color Palette command or press del
  • the palette will be deleted without asking for confirmation.
    Note: Palettes can only be deleted individually


Creating and editing colors

Manual -> Screens -> Palettes -> Creating and editing colors

Create color

In order to create a color:

  • select a color or a palette
  • In the context menu, select New Color or press the insert key
  • at the lower end of the color table, a new color is inserted for all palettes with
    • Standard color white and
    • Color plus Index number, for example Color10
  • define the color and give it a name

Rename color

To rename a color:

  • select the color
  • In properties, select Color the propertyColor name in the group
  • enter the desired name
    Tip: You can already differentiate between a global project and a local project when giving it a name, so that you know where the palette comes from when choosing the color palettes later

define color

to define a color:

  • highlight the desired color in the palette
  • enter the color:
    • either directly into the table cell in the detail view, as a hexadecimal code or via the selection dialog by clicking on ...
    • or in the properties in the Color group in the Property Color field as a hexadecimal code or via the selection dialog by clicking on ...

define color via dialog

To select pre-defined base colors from a dialog or to create your own colors:

  • in the detail view, click in the cell with the desired color or in Properties Color on ...
  • the dialog for the selection of standard colors opens

  • click on a standard color to allocate it
  • to define your own color, click on the Define Color button

  • define the color
  • using the Add Color button, add it to User-Defined Colors
  • select the desired color
  • assign the color by clicking on OK

Copy Color

To copy several colors of the same color definition:

  • highlight the hexadecimal code of the color in the input field of the desired color
  • copy the hexadecimal code with ctrl+C or the Copy command in the context menu
  • insert the hexadecimal code for all colors which should receive the same color definition with ctrl+V or the Insert command in the context menu

Delete color

Colors from palette are distinguished clearly by means of their index in the palettes (= row number in palette window). Therefore the colors can only be deleted at the end of the palette, because otherwise the indices of subsequent colors would change. Because all palettes in the project must have the same color, only complete rows can be deleted. To delete a color from all palettes:

  • Highlight the rows to be deleted, starting with the lower end of the palette colors
  • In the context menu, select Delete Color or press the delete key


Use palettes in the editor

Manual -> Screens -> Palettes -> Use palettes in the editor

Selecting the active palette in the editor

In the editor, a palette can be used as the active palette for display and color selection from the local or global project.

To select a palette for display in the editor:

  • Click on the table of color palettes with the right mouse button.
  • select Color palette in the editor in the context menu
  • select the desired palette from the drop-down list

Note: Palettes from the local project are arranged before those from the global project.

Attention: If there are palettes with the same name in the global and local projects, only the palettes from the local project are offered for selection.

attention Attention

If there is a different number of colors configured per palette in the global and local project, there may be less colors available for the active palette selection!

Palette definitions from the local project always have priority: If there is at least one color configured in the local project palettes, the amount of colors from the local palette are offered; otherwise the amount of a colors in the global project are offered.

Colors missing from the active palette are displayed in white.

Selecting the palette colors

Colors from the palette are assigned in the editor via:

  • Dialog in properties
  • Drag & drop the description of a color into the corresponding field in properties
  • Direct input of the description of a color in the corresponding field in properties

If an element is assigned a color via properties, the color dialog opens with two tabs:

  • Colors Selecting a particular color
  • Color palettes: selecting a particular color palette from the active color palette

If there are not palettes with at least one color configured in the local or global project, or if the property does not allow a color to be assigned, only the tab colors are displayed.

Colors for multi-user projects

Changes to color palettes can only be enabled, transferred or discarded for all palettes of a project.


Create Runtime files

Manual -> Screens -> Palettes -> Create Runtime files

The palettes of the global project and local project are carried over in a joint list when creating Runtime files. There may be conflicts in doing so. Note:

  • The local project always has priority.
  • Each palette displays the unified amount and therefore contains as many colors as the largest palette.
  • If the palette of the global project and the local project contain different amounts of colors, the shorter palettes are filled with white, so that all palettes have the same amounts of colors and a color is available in each palette for each color index.
  • With palettes that have the same name, the palettes of the local project are used and filled with the colors of the global project if this contains more colors.

Example:

  • There are 3 palettes in the global project: Global 1, Global 2 and Palette 1 with 10 colors each.
  • There are two colors in the local project: Palette 1 and Palette 2 with 5 colors each.
  • In Runtime there is then:
    • Palette 1 comes from the local project and overwrites Palette 1 from the global project; it contains the 5 colors from the local project plus the colors 6 - 10 fromPalette 1 from the global project
    • Palette 2 contains the 5 colors from the local project plus the colors 6 - 10 initialized as white
    • Global 1: Contains the 10 colors from the global project
    • Global 2: Contains the 10 colors from the global project

Switch colors in Runtime

To switch colors in runtime, you need the Switch palette function (see chapter on switching color palettes).

You can find an example of switching in Runtime in the chapter on the example for editor und Runtime.


Switch color palette function

Manual -> Screens -> Palettes -> Switch color palette function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When starting runtime, the first palette in the project automatically becomes active, so long as another palette is not activated via a start script.

The active palette can be changed in runtime by means of the Switch palette function. All screens and elements are then relabeled with the colors of the new palette.

The respective active palette is defined via the name of the palette. If no palette exists with the given name, the first palette in the project is activated.

To create the Switch palette function:

  • In the project manager, select the New Function.. command in the Functions node.
  • navigate to Applications
  • selectSwitch Color Palette

  • confirm with OK
  • The dialog to select the color palette is opened

Parameters | Description
Palette | Select the desired color palette from the drop-down list.
Show this dialog in the Runtime | Enables a new color palette to be selected in runtime.


Export and import

Manual -> Screens -> Palettes -> Export and import

Color palettes can be exported as XML files and imported from these.

Export

To export a palette:

  • select the desired palette
    to select several palettes use the ctrl or shift key or hold down the left mouse button and move the mouse over the title line of the table
    (Note: selected palettes can no longer be deselected individually)
  • only complete selected palettes can be exported, not individual colors
  • select Export selected XML... in the context menu or in the tool bar
  • in the file manager that opens, select a location to save the file and a name for the XML file

Import

To import a palette:

  • select Import XML... in the context menu or in the tool bar
  • select the file you wish to import in the file manager that opens
  • The palettes saved in the XML file will be imported
  • Attention: The sequence during exporting is taken into account:
    If, for example, a palette is exported to the third place in the table, this is imported at the same place or added at the end if the project has fewer palettes Palettes already present here are overwritten. That means:
    • If palettes are at the location that is imported to, the names and colors of the existing palettes are overwritten.
    • If a palette is imported to a free location, it is inserted at the end of the sequence and named with the consecutive standard names.
    • If the name of an imported palette is already used for a palette at a different location, then the colors and not the name of the overwritten palette are replaced.
    • If the imported palette features more colors than those that already exist, the missing colors are supplemented with white in the existing palettes
    • If the imported palette has fewer colors than the existing one, the missing colors are accepted by the overwritten palette or supplemented with white, if no palette was overwritten.


Error message

Manual -> Screens -> Palettes -> Error message

When transferring elements, for example by importing XML files or copying & pasting, some palette colors may no longer be displayed correctly. Possible reasons:

  • no color palettes have been created in the project yet
  • Palettes have a different number of colors
  • Colors were deleted

The corresponding error message is displayed in the properties input field, the element is displayed in white.

Error message | Reason
No palette loaded! | No palettes were configured in the local and global project.
Palette color not available! | The is no color in the project's palette with the corresponding index.


Example for Editor and Runtime

Manual -> Screens -> Palettes -> Example for Editor and Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the editor

This is how you use color palettes in the editor for example:

  • create a screen with a button with text and a graphic element
  • choose Fill color in properties
  • click on ...
  • the dialog for selecting colors opens
  • select the Color palette tab
  • the colors of the active color palette are displayed
  • select the desired color
  • repeat this step for the properties Border color and Text color
  • Screen with basic color palette

  • In the color palette table, right-click in a cell
  • select Color palette in the editor in the context menu
  • in the drop down list, select a different palette, for example, Palette 2
  • Screen in the editor:

In Runtime

The screen with the color palette activated in the editor is displayed in Runtime.

If you have configured a switching function (see chapter on Color palette switching function), you can change the color palette in runtime.

To do this:

  • Click on the element.
  • If the Offer this dialog in Runtime option was activated, a new palette can be selected in Runtime; otherwise the palette given in the function is shown automatically

  • the element is switched to the new colors


Fonts

Manual -> Screens -> Fonts

In zenon all the fonts installed in the operating system can be used. The Fonts node is under the Screens node in the Project Manager.

Context menu Project manager

Menu item | Action
New font list | Creates a new font list in the detail view
Export XML all... | Exports all entries as an XML file.
Import XML... | Imports entries from an XML file.
Help | Opens online help.

info Information

The selected font must also be present on the target system with Runtime. If the font is not present on the target system, another font present on the system from the same family is used.

Compatibility with DirectX

Not all fonts are suitable for use with Direct X. TrueType and OpenType are suitable for use with DirectX. Bitmap fonts are not suitable. Unsuitable fonts are replaced by a suitable font in Runtime.

  • Recommended for use zenon and suitable for Direct X:
    • TrueType (.ttf)
    • OpenType (.otf)
  • Not suitable:
    • Bitmap (.fon) such as System or Script for example
    • Adobe Type 1 (.pfm/.pfb)


Font lists

Manual -> Screens -> Fonts -> Font lists

By default, one font list exists. This is displayed in the detail view if the Screens / Fonts node is selected in the Project Manager.

Toolbar and context menu

Parameters | Description
New font list | Creates a new font list (same functionality as in the Project Manager). See chapter Creating a new font list.
Delete font list | Deletes the selected font list.
Font new | Creates a new font. The Windows dialog 'Font' is opened, where the font type, style, size, etc. can be defined. See chapter Creating a new font.
Delete font | Removes the selected font from the font list.
Jump back to starting element | If you entered the list via function linked elements, the symbol leads back to the start element. Only available in the context menu when all linked elements are opened.
Font list in Editor | Displays all existing font list, the active one is marked.
Save | Saves the changes.
Export selected XML | Exports selected elements as an XML file. For details, see the Import/Export Screens /Fonts chapter.
Import XML | Imports elements from an XML file.
Properties | Opens the property window.
Help | Opens online help.

The name of the font list can be changed in properties.

attention Attention

Name changes performed later on will not be integrated automatically. If you change the name of a font list after creating a function Language Change for this font list, you also have to change the name of the font list in that function.

Font lists: Global project versus project

The Editor always has a font list actively switched. To use fonts from the standard project and the global project, the font lists in these two projects must be named the same.

Note when using font lists in global projects:

  • If font lists are named the same in a global project and a standard project, the font list of the standard project takes priority in Runtime.
  • If there are different names, two font lists are present in the standard project, either one of these is used in Runtime as desired.

To avoid this effect: Plan a language switching function by selecting the font list.


Creating a new font list

Manual -> Screens -> Fonts -> Font lists -> Creating a new font list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to link elements to fonts, which do not belong to Font list 1, another font list has to be created.

Creating further font lists:

A new font list can be created in the Project Manager in the section Screens / Fonts with the entry Font list new from the context menu. The new font list is displayed in the detail view of the Project Manager.

The default font is also automatically created in the first position here.

Activating a font list:

To activate a font list, click in the header for the desired font list and select the entry Font list in the Editor from the context menu. This can be necessary for language switchable texts. So you can check already in the Editor, how the element with the font will look in the Runtime. (e.g. whether the font is too large for a button). See chapter: Language switch / Fonts

info Information

There is no default font list for Runtime. If several font lists are planned, the font list to be used in Runtime must be set using Language switching.


Default font and system font

Manual -> Screens -> Fonts -> Default font and system font

Every new element is linked to a default font. This is the font that is assigned to the element type. Changing the property Font of an element causes that every new element of that element type is connected to this new font. After the editor is restarted, the default font is used for all element types again. The default font is Arial 10 and is on the second position of the list. Position.

The following fonts are automatically created when a project is first created:

Font | Font style | Font size | Information
Arial | Standard | 8 |
Arial | Standard | 10 | Default font
Arial | Standard | 12 |
Arial | Standard | 14 |
Arial | Standard | 20 |
  • The default font can be edited. The changes take effect everywhere where this font is linked.
  • The system font is not scalable, which can lead to problems during zooming or when adjusting the resolution automatically.
  • The default font can be changed via the Font property. The dialog is the same one that opens when New font is selected in the context menu.


Creating a new font

Manual -> Screens -> Fonts -> Default font and system font -> Creating a new font

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

One font list exists by default, which is displayed in the detail view of the Project Manager and can be filled with different fonts.

Creating a new font in the font list:

Click in the window of the detail view and open the context menu with a right mouse click. Select the entry 'Font new' here.

The Windows dialog Font is opened. Here the following settings are available:

Parameters | Description
Font | All fonts of the operating system are sorted alphabetically
Font style | Bold, italic, etc.
Font size | Font size in pixels
Effects | Underlined, strike-out
Color | Selection of the font color
Script | Western, Cyrillic, etc.

info Information

The color settings are ignored. Text is displayed in black unless the color has been explicitly edited in the properties Text colors only change in the Runtime (e.g. because of limit violations).

For fonts in global projects refer to chapter: Project administration / global project

attention Attention

All fonts used must be installed on all computers on which the project will be started.
The installation can also be carried out with Remote Transport. See also: Define files (copy&register)


Naming and numbering fonts and font lists

Manual -> Screens -> Fonts -> Naming and numbering fonts and font lists

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When creating a zenon project, 5 default fonts are created. The name of the font list and the default font are dependent on the language in which the Editor was started. This applies for standard projects and global projects.

The fonts are given numbers. Number 1 and 2 are standard fonts. These two numbers cannot be changed, all other numbers can be adapted individually. When creating dynamic elements, this is automatically allocated to the font with number 2.

The Editor always has a font list actively switched. To use fonts from the standard project and the global project, the font lists in these two projects must be named the same.

Note: zenon projects that have been converted from version 5.50 into a later version have no default font list if the project has no fonts in 5.50.

Global and local

Fonts from the local standard project have a higher priority than fonts from the global project.
For example: There is a font with the number 50 in the global project. This font can be used in the workspace in any standard project as long as the standard project does not have a font with the number 50. If there is also a number 50 in the standard project, this font is used.

The fonts with the numbers 1 and 2 cannot be deleted in the standard project. That means: The fonts with the number 1 and 2 can be changed in the global project. However, they cannot be used in the standard project, because these two numbers are always present in the standard project and have a higher priority. An offset can be used to differentiate fonts from the global project and the standard project. For example, font 2 from the standard project can become font 2002 in the global project.

Workaround to use fonts 1 and 2 from the global project in the standard project: Delete the font list in the standard project and name a new empty font list the same as the font list in the global project.

Delete font list

If the fonts with the numbers 1 and 2 from the global project are to be used in the standard project, the font list must be deleted in the standard project. To do this:

  1. This is how you create a project backup:
  2. If adapted fonts from a standard project are to be used globally:
    1. Carry out an XML export of the font list from the standard project
    2. Carry out an XML import of the font list into the global project
  3. Open the SQL folder for the standard project

    Hint: Highlight the project in zenon -> press Ctrl+Alt+E -> Explorer opens the project folder -> navigate on to zenon/system

  4. close the workspace
  5. Delete the file named fonts.bin
  6. open the workspace
  7. Now name an empty font list with the same name as the font list in the global project

Now the fonts with the numbers 1 and 2 from the global project are used in the standard project. New elements use the font with number 2 from the global project, if this is available, and the system font if the global project is not available.

Dynamic and static

Fonts for the Static text vector element and for dynamic elements are saved differently. The reason for this: Static text can also embed fonts.

Embedded means: The font is not linked to a font list, but is instead local and only configured for this element.

Attention: This does not mean that the font is embedded in the screen and is thus always displayed correctly. The font must continue to be present in the system that is displaying it.

Import and export via XML

When importing and exporting via XML, the Name property is used for identification with dynamic elements. If for example, in the global project there is a font with the name "zenon" and in the local standard project there is another font that also has the name "zenon", then the font of the local project is used during import and export.

Hint: The font names must be clear in the global project and standard project. The Editor does not check this.

VBA

VBA uses the Number property of the font for dynamic elements. Here, the offset can be useful for fonts in the global project and in the standard project.

For example: Font 2 from the standard project is replaced by 2002 from the global project. For vector elements, the font number is saved in the second position of the font string. In the font string "0 7 0 0 700 255 0 0 0 3 2 5 34 Arial", the number of the font is7 and can easily be replaced by 2007 from the global project.


Linking fonts to elements

Manual -> Screens -> Fonts -> Linking fonts to elements

There are two possibilities to link a font to a dynamic or vector element (e.g: Text).

Parameters | Description
Drag&Drop | The table in the detail view has the following structure: Numbers, font lists and fonts After clicking the number of the desired font, it can be linked to the element with Drag&Drop.
Properties | It is also possible to link the font in the properties of the selected element. Under 'Representation/Font' the dialog 'Enter element' is opened.


Embedded and linked fonts

Manual -> Screens -> Fonts -> Linking fonts to elements -> Embedded and linked fonts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Fonts can either be embedded in elements or linked to them.

Parameters

Description

link

Fonts are linked by default.

embed

For the static text vector element, there is the possibility of embedding the font. The font is then no longer linked to a font list, but is instead local and only configured for this element.

Attention: This does not mean that the font is embedded in the screen and is thus always displayed correctly. The font must continue to be present in the system that is displaying it.

info Information

Scaling of symbols:

If the symbol contains a static text element and is embedded in this element as text, then this text:

  • Is scaled in the Editor
  • Is not scaled in Runtime

This only applies to symbols. Embedded text is neither scaled in the Editor nor in Runtime in all arrangements.


Symbols and element groups

Manual -> Screens -> Symbols and element groups

Symbols and element groups are screen elements to which vector screen elements and dynamic screen elements are assigned as screen macros. Both are used as screen symbols in screens. The color attribute of a screen symbol can be changed by means of dynamic elements (status element, multi-binary element and combined element) in Runtime.

  • Symbols are collected in a symbol library and can be created there. They are either linked to a screen or inserted into a screen as an element group. As soon as they are linked, each change to the symbol in the library has an effect on the symbol in the screen. Symbols can also be inserted into a screen as an element group. The connection to the library is thus released. Changes to the symbol do not have an effect on the element group.
  • Element groups can be created in a screen from several elements. An element group can also be inserted as a symbol in a symbol library. In doing so, it is converted into a symbol when inserted. However the element group in the screen remains as an element group.

zenon distinguishes between three symbol libraries:

Symbol library

Property

General symbol library

Symbols are available in all projects. The general symbol library node is located in the project manager below the currently-loaded projects.

Label when linking in the screen: [symbol group]/[symbol name]

Rules:

  • The dialog for selecting variables offers all projects of the workspace for linking.
  • These symbols are saved in the zenon program folder and only updated when the Editor starts. These symbols are not saved during project backup.
  • Interlockings and aliases for ALC cannot be configured.
    Warning: If symols that contain interlockings or aliases are added, these settings are removed.

Symbol library the global project

Symbols are available for all projects of the workspace.

Label when linking in the screen: (g)[symbol name]

Rules:

  • The symbols copied into the symbol library of the global project retain their variable linking without changes.
  • The variable dialog offers all projects of the workspace for linking. Linked variables are placed in front of the name of the respective project.
  • The name of the Variable can be amended in the properties window. This way, for example, the prefix can be deleted with the project origin.
  • The symbols are also backed up when a project is backed up.
  • Interlockings and aliases for ALC cannot be configured.
    Warning: If symols that contain interlockings or aliases are added, these settings are removed.

Symbol library the project

Symbols are only available in the current project.

Label when linking in the screen: [Symbol name]

Rules:

  • The symbols are saved in the project folder. The project symbol library is in the current project in the Screens node and is backed up together with project backup.
  • Interlockings and aliases for ALC can be configured. These properties are also retained when symbols are added.

Symbols can be copied by dragging & dropping.

  • From the general symbol library into the symbol library in the global project
  • From the symbol library in the global project into the symbol library in the project or vice versa

Direct copying from the symbol library into the symbol library in the project or copying from the project or global project into the general symbol library is not possible.

In order to be able to work with both libraries at the same time, the preview of the libraries is displayed in separate windows. In doing so, the names of the libraries are displayed in the tabs on the main screen.

info Information

Scaling of symbols:

If the symbol contains a static text element and is embedded in this element as text, then this text:

  • Is scaled in the Editor
  • Is not scaled in Runtime

This only applies to symbols. Embedded text is neither scaled in the Editor nor in Runtime in all arrangements.

Screen symbols and symbols from the a symbol library

  • Screen symbols: Symbols or element groups contained in a screen.
  • Symbols from a library: Are edited in the library and linked in the screen.

attention Attention

Symbols from the General symbol library are saved locally in their own file (*.sym) in the zenon program folder. These files must always be added manually to back-up the project with multi-user projects and when forwarding projects. Symbols from the symbol library in the local project and the global project are automatically included in the respective project backup.

Hint: Always save symbols locally.

Project manager context menu

Menu item | Action
Export XML all.. | Exports all entries as an XML file.
Import XML | Imports from an XML file.
Open in new window... | Opens a new window to view and edit the variable. (Default: at the bottom of the Editor.)
Help | Opens online help.

Checking symbols

Symbols are checked to see if they are present and correct:

  • when the Runtime is compiled
  • when the Editor is closed and new Runtime files are created

Missing symbols are marked red in the output window. The error message shows the name of the affected screens and symbols.

Menu symbols

As soon as a symbol is opened in the symbol editor, the screens menu item is replaced by a symbol in the tool bar.

Possible actions are:

Menu item

Action

Save symbol

Saves the current symbol.

Save all symbols

Saves all symbols.

Change symbol size / background color

Opens the dialog for configuration of symbol size and background color.

Note: Changes of the background color always affect all symbols in the global system library.

Tool bar

Opens a list of all symbols, used in the current screen. For each symbol its graphical components are listed.

Full-screen mode

The full-screen hides all remaining windows and shows only the main window with all opened documents (screens, reports, ...) in full-screen mode.

The full-screen mode can be closed by:

  • the displayed button for closing the full-screen mode
  • the short key Shift+F9

Redraw symbol

Refreshes the display.

Display grid

Switches the grid on or off.

Use grid

Switches usage of the grid on or off.

On: All objects are automatically aligned with the grid.

Use magnetic points

Switches magnetic points on or off.

Use: If you move an object near the handling point of another object, it snaps in place at the handling point.

Tab order for focus

Opens drop-down list for definition of horizontal or vertical order for Keyboard operation.

Order for left/right: Determines the horizontal order.

Order for up/down: Determines the vertical order.

Zoom

Changes the resolution in fixed steps between 15% and 400%.

Screenshot print current symbol

The current symbol is printed on the default printer. Set printer properties via File -> Standard configuration -> standard.

Insert vector graphics

Opens the dialog for inserting an external vector graphic.


Symbol detail view toolbar and context menu

Manual -> Screens -> Symbols and element groups -> Symbol detail view toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The symbol library can be operated from the context menu or the toolbar:

Commands in the context menu and toolbar

Toolbar position | Context menu | Function
1 | Symbol new | Creates a new symbol.
3 | Open symbol | Opens the symbol in the symbol editor for editing purposes.
2 | New symbol group | A new symbol group is created and can be filled with selected symbols from the library or with self-defined symbols. (Copy and Paste). Only available in the global symbol library.
4 | Insert symbol as element group in screen | Creates an element group from the symbol and adds this to a screen (for details, see the Element gropus chapter).
5 | Insert symbol in screen | Links the symbol in the screen (for details, see the Symbols chapter).
not available | Linked elements | Opens the sub-menu with linked elements and the possibility to jump back into the starting element.
6 | Jump back to starting element | Jumps back to the starting element (only toolbar).
7 | Copy | Copies the selected symbol to the clipboard (only hierarchical view).
8 | Paste | Inserts the copied symbol in the active group (only hierarchical view).
9 | Delete | Deletes the selected symbol or symbol group (only hierarchical view). Attention: Deleting cannot be undone!
10 | Expand/collapse node | Allows expansion/reduction of the selected node or all nodes in the hierarchical view.
11 | Flat view | Arranges all symbols in a flat view. Facilitates the search for certain symbols. Note: In this view, you can´t create nor delete symbols and it is also impossible to copy or insert symbols from the clipboard.
12 | Hierarchic view | Sorts all symbols hierarchical in subgroups and shows dependencies.
13 | Export selected XML | Opens the dialog for XML-export of the selected symbols. (For details, see chapter Import/Export of symbols.)
14 | Export screen/symbol as a graphic file... | Exports the screen/symbol as a graphics file. The file selection dialog offers the corresponding graphics formats supported on the system. In principle, all Windows Imaging Component (WIC) codecs that support saving are provided for selection. The size of the graphics results from the screen or symbol to be exported.
15 | Import XML | Imports symbols from an XML-file (see chapter Import/Export of symbols).
16 | Remove all filters | Removes all filter settings.
17 | Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
18 | Replace text in selected cell | Opens the dialog for searching and replacing texts.
19 | Properties | Opens the Properties window for the selected entry.
20 | Help | Opens online help.


Configure size and background color

Manual -> Screens -> Symbols and element groups -> Configure size and background color

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure the symbol size and background color:

  1. Set the focus to the symbol editor.
  2. Select, in the General properties group, the desired parameters for the display of the symbol in the symbol editor:
    1. Background color: Defines the background color for symbols in the symbol editor. Clicking on Color opens the palette.
      Note: Changes to the background color always affect all symbols in the global system library.
    2. Width [pixels]: Entry of the width of the symbol in pixels.
    3. Height [pixels]: Entry of the height of the symbol in pixels.


Release properties from link

Manual -> Screens -> Symbols and element groups -> Release properties from link

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For optimum use of symbols, it is sometimes necessary to assign individual values to individual properties from system elements. For example, a motor symbol has a heading in which the name is contained.

You can release the Text property with this function. If the symbol is dragged onto the screen, the Text property can be changed individually for each motor.

This function is available for all properties.

Engineering

The symbol editor is opened when a symbol is opened. The symbol editor consists of a window divided into two parts to edit the selected symbol.

The symbol is edited in the upper area; in the lower area, the released properties of the element of this symbol are listed. You have different possibilities to release elements:

  1. Drag&Drop
    1. Move the desired properties by dragging & dropping from the property window in the lower area of the symbol editor.
    2. Note: You must always click on the name of the property (not the value) and move it into the release area by dragging & dropping.
  2. Property context menu
    1. Right-click on the name of the property.
    2. Select Release [property] in the context menu
    3. The property is entered in the list
  3. Property toolbar
    1. Left-click on the name of the property.
    2. Click in the toolbar on the release symbol (green arrow upwards above text field)
    3. The property is entered in the list

Note: If the entry is not offered or the symbol is displayed as deactivated, the element cannot be released. Possible reasons:

  • No screen element selected in the symbol editor
  • Property was already released
  • Element does not support release (ActiveX, for example)

The release area is a list that can be filtered. You can filter according to individual properties as needed. A context menu is available for all actions.

Context menu for release list:

Parameters | Description
Remove selected property | Removes release of the element.
Undo | Revises last action.
Help | Opens online help.

Editing released properties

If the symbol is displayed in a screen, the additional node $_Element Name is available. All properties that have been released individually have been released. These are separated from the linking principle (released) and only concern this symbol if changed. If a property of one of the elements is selected in the Properties window, this element flashes in the screen.

The released properties can be changed:

  • With the properties in the $_element_name branch
  • with the Linked Symbol Wizard

Linked Symbol Wizard

The linked symbol wizard is available to you in order to edit released properties easily and with a clear overview:

  1. Double click on a symbol that:
    1. Is linked in the screen and
    2. has released properties
  2. The linked symbol wizard opens.
  3. Select the property to be changed.
  4. Enter the new value.
    Note: Each change is accepted immediately!
  5. Close the wizard by clicking on Exit.

Parameters | Description
Select an element in the symbol: | Selection of an element in the symbol from the drop-down list.
Select the exported property to | Selection of the released property from a list.
Display of property | Displays the property to be changed.
Input field | Input of the new value of the property by means of text entry/number entry, drop-down list or selection dialog - depending on the property.
Exit | Closes wizard

info Information

The wizard does not support all possible symbol properties.


Create and delete your own symbols

Manual -> Screens -> Symbols and element groups -> Create and delete your own symbols

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Create symbols either in the symbol editor or in a screen. Elements of a symbol can be:

  • Vector Elements
  • Dynamic elements
  • other symbols: Symbols can be inserted into element groups.

info Information

Elements contained in a symbol should only be placed within the symbol area and not jut out. If elements jut out over the symbol borders, artifacts may occur at the display in the Runtime. This is also true for elements using symbols (e.g. combi element).

In the symbol editor:

  1. Select New symbol in the context menu or in the tool bar.
  2. Click in the input field for Element Name and assign a name (periods are not permitted in symbol names).
  3. Create the symbol in the symbol editor.
  4. Add any individual properties (see sub-chapter on releasing inherited properties)
  5. Save the symbol.

On the screen:

  1. Select one or more element in the screen.
  2. In the context menu, select Symbol -> Create Embedded Symbol (or -> Insert into Existing embedded Symbol)
    or select it in the Edit-> Symbol -> Create Embedded Symbol menu.
  3. Save the screen.

attention Attention

Fonts and graphics in symbols for use throughout the project:

Fonts: fonts are defined through their ID. Ensure that the same ID is assigned to the desired font in all projects in which the symbol is used.

Graphics: Graphics embedded into a symbol are not saved with the symbol. The corresponding graphics must be copied manually to the graphics library of the corresponding project.

Embed symbols into symbols or link symbols to symbols

You can also link existing symbols or create them as an element group when creating symbols in a similar manner to the screens (see Insert symbol into screen). In doing so, you must heed the following rules:

  • A symbol must not contain any recursion i.e. it must not link to itself.
  • Project symbols must not be linked across projects!
  • Symbols from the global library may not contain any links to project symbols.

info Information

You can only edit the contents of symbols in the symbol editor. If you insert it into a screen as an element group, this cannot be edited in the screen editor.

attention Attention

You can only link symbols from the project library within the respective project. It is not possible to link symbols from the project library across projects. To use a symbol from another project library in another project, you can create an element group from it.

Delete or remove

To delete a symbol:

  1. Highlight the symbol in the library.
  2. Select the Delete command in the context menu or in the tool bar.

To remove an element group in a screen:

  1. Highlight the element group in the library.
  2. In the context menu, select Symbol -> Remove
  3. the element group is removed in its elements.
  4. if the symbol for the symbol library has already been inserted, it remains there unchanged; it is deleted from symbol administration however.

To delete a symbol:

  1. Highlight the symbol in the library.
  2. Select Delete in the context menu.
  3. The symbol remains unchanged in the symbol library, but it is deleted from symbol administration.

info Information

To edit individual elements of a symbol without removing the symbol assignment, select:

  • For symbols: Edit in symbol editor
  • For element groups: Switch to single edit mode


Transferring your own symbols to the library

Manual -> Screens -> Symbols and element groups -> Create and delete your own symbols -> Transferring your own symbols to the library

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Element groups created in a screen can be inserted into a symbol library as symbols.

To insert an element group into a symbol library as a symbol:

  1. In the context menu of the element group, select Symbol -> Insert into symbol library.
  2. The dialog for symbol definition opens.
  3. Select the desired symbol library and the appropriate folder.
  4. Confirm the dialog with OK.
  5. Change to the selected symbol library.
  6. The element group was converted into a symbol and entered with the name Elementgruppe_Nr. (Nr is a continuous numbering of the existing element groups, starting with 1)
  7. Name it as you wish.
  8. To continue editing the symbol or to allocate it individual properties (see Release Inherited Properties), , open the symbol by double-clicking on it or via the Open Symbol context command in the symbol editor.


Add symbols to screen

Manual -> Screens -> Symbols and element groups -> Add symbols to screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Symbols can be inserted into a screen in two ways:

  • Element groups: These are no longer connected to the symbol in the library; changes to the original symbol have no effect on the embedded symbol.
  • Symbols: Remain linked to the original symbol. Changes to the symbol also change the symbol in the screen.

attention Attention

You can only link symbols from the project library within the respective project. It is not possible to link symbols from the project library across projects. To use a symbol from a project library in another project, you can create an element group.

info Information

If you have activated the Display frame around dynamic elements in the Editor property, you can distinguish between embedded symbols and linked symbols at a glance: An arrow symbol is displayed in the upper right corner for symbols. You can find this property under Options -> Settings in the Settings area.


Element groups

Manual -> Screens -> Symbols and element groups -> Add symbols to screen -> Element groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This is how you insert a symbol as an element group:

  • hold down the ctrl key and move it by dragging & dropping

    or

  • Select the Insert symbol as an element group in the screen in the context menu of the symbol to embed the symbol into the current screen

Element groups can then be broken down to their individual elements or their individual elements can be edited. To do this, select Symbol -> Change to individual editing mode in the context menu or Edit-> Symbol -> Element group individual editing mode in the menu.

Element groups do not change if the original symbol from which they were created is changed in the library, as they are no longer linked to it.

Replace linked variables

When creating an element group from a symbol that contains variables, the dialog to replace variables and functions opens. Here, you can automatically replace the elements present with those you want for this symbol. You can find details on automatic replacement of variables and functions in the chapter on Replace links in the Editor.

To replace variables in symbols that have already been inserted, select the Replace Links command in the context menu.

Hint: Ensure that the variables are named uniquely and meaningfully from the start.


Symbols

Manual -> Screens -> Symbols and element groups -> Add symbols to screen -> Symbols

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Symbols do not save variables that are physically present in the symbol library, only variable names. When inserting variables into a screen as a link, the variable names saved in the symbol can be assigned to variables from the project. If the project is given a variable that corresponds to a variable name saved in the symbol, this is linked automatically - without an extra rule.

Insert symbol in screen

This is how you link a symbol to a screen:

  • move the symbol by dragging & dropping it into the screen

    or

  • In the context menu, select the Symbol - Insert into screen symbol

Symbols are only saved as a reference in the screen. Each change of the symbol in the library has a direct effect on the symbol on the screen. For example, if a dynamic element is added to a symbol, it is also available in all screens in which this symbol is used.
Exception: Changes to the symbol size only have an effect on the screen if the original size symbol is selected in the Graphic size symbol property.

You can do the following to symbols:

  • Convert to element groups: Symbol context menu -> Convert symbol into element group
  • Edit them in symbol editor: Symbol -> Edit in Symbol Editor
  • Insert in existing element group: Symbol -> Insert in existing element group

Symbols cannot be broken down into their elements and their elements cannot be changed in Edit elements (context menu -> Symbol -> Change to individual editing mode mode or the Edit -> Symbol -> Symbol/ element group individual editing mode menu).

attention Attention

With symbols, use only embedded fonts, because linked fonts are not scaled with the symbol. The position of the text would move in relation to the graphics in the symbol.


Replacing linked variables or linked functions

Manual -> Screens -> Symbols and element groups -> Add symbols to screen -> Symbols -> Replacing linked variables or linked functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When inserting a symbol that contains variables, the dialog to replace variables and functions opens. Here, you can automatically replace the elements present with those you want for this symbol. ALC aliases that are die used in elements in the symbol can also be replaced. Several entries are separated by a semicolon (;).

You can also get to this dialog using the Preview property in the Linking rule node of the element.

info Information

The process for symbols can also be applied to faceplate screen containers. The same properties and rules apply. Exception: The Hierarchical names property is not available.

Replacing linked variables or linked functions

Linking rule

Property | Description
Linking rule | Configuration of which character sequence can be replaced and how.
Source | Enter the character string to be searched for. Permitted wildcards: * and ? Wildcards are only permitted as a prefix or suffix; e.g. *xxx or xxx*.
Replace by | Entry of the character string that is to be replaced.
Name | Swaps information in process variable names.
Identification | Exchanges information in the identification
Note capitalization | When swapping, be sure that any capitalization is an exact match.
Hierarchical names | Permitted combined names. Is not available for ALC aliases and faceplate containers. These are always used without a symbol prefix.

Preview

Property | Description
Preview | Display of the selected and replaced elements.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.

You can find further details on automatic replacement of variables and functions in the chapter on replacing linking of variables and functions .

Hint: Ensure that the variables are named clearly and sensibly from the start.

Hierarchical names

If the Hierarchical names property in the Linking rule node is active, the names of the linked variables from the object names of the symbol and the variables defined in the symbol are combined. The two names are separated by a dot: "Symbolname.Variable"

Example Example

Variable name: Motor.Speed
The symbol object name is "Motor". The dynamic element that is used in the symbol has the placeholder "Speed" as a linked variable.
The placeholder "Speed" can be easily typed in for the symbol property when creating the variable.

Combined names also work with nested symbols:
If you have a "Pump" symbol, which in turn contains a "Motor" symbol and a "Convertor" symbol with the variable placeholder "Output", then the linking works if there is a Pump.Motor.Output variable and a Pump.Convertor.Output variable.


Symbol selection in the Combined element

Manual -> Screens -> Symbols and element groups -> Add symbols to screen -> Symbol selection in the Combined element

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To link combined elements with a symbol:

  1. select Symbol from library in the combined element properties in the Representation node in the Type of display property
  2. Click on Configuration and test
  3. the configuration dialog opens:

The general settings for all display types can be found in the chapter on statuses.

Parameters | Description
Display element |
Symbol from library | Clicking on the symbol opens the dialog to select a symbol. Clicking on the X next to the symbol deletes the selected symbol.
Edit linking rule | Variables and functions contained in the symbol can be exchanged with the help of linking rules. Attention: If a variable or function does not fit into the scheme, that link cannot be replaced.
Color | Only active if the Original Symbol Colors property in Specific Settings is turned off.
Color | Choice of color.
Fill color | Choice of fill color.
From ALC | The color of the linked source is used.
Specific settings |
Original symbol colors | Active: Transfers original color from symbol. Deactivates Take color of main variable property.
Flashing | Active: Symbol flashes in runtime if status has been achieved.


Tool bar

Manual -> Screens -> Symbols and element groups -> Tool bar

Via Edit -> Symbol ->Symbol list... Open a list that displays all symbols of the active screen:

Parameters | Description
Available symbols/Element groups | List of the symbols and element groups in the screen.
No. | Number of the symbol or the element group.
Name | Name of the symbol or the element group

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.

You sort the symbols according to number or name by clicking on the respective column title. A symbol selected in the list of symbols is blinking in the screen.


XML export and XML import

Manual -> Screens -> Symbols and element groups -> XML export and XML import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Import/export of symbols is possible from the project and the global symbol library. Single or selected symbols or the entire library can be imported or exported. The path for the export can be defined freely.

Export symbols

To export symbols:

  1. highlight the desired symbols
  2. select Export selected XML... in the context menu of the detail view
    Alternate: select, in the context menu of the project symbol library node, the XML export all... command
  3. the selection dialog for the saving location is opened
  4. select the desired saving location
  5. assign a name
  6. pay attention to file type XML
  7. confirm by clicking on the Save button

The selected symbols are exported to an XML file and can be imported in this or in other projects at any time.

Import symbols

To import symbols:

  1. in the context menu of the node or the detail view of the Project symbol library or in the detail view of the Global symbol library select Import XML... command
  2. the selection dialog for the saving location is opened
  3. navigate to the saving location of the desired XML file
  4. Select the desired file
  5. confirm the import by clicking on the Open button

The symbols are imported.

Name conflicts during the import

At the import of a symbols the name (attribute ShortName) which is stored in the XML file is used for the name of the symbol which is created. If a symbol with the same name already exist, the import is halted and an error message is displayed:

Parameters | Description
Yes | The symbol described in the error message is replaced by the symbol from the XML file at the import. If a new conflict occurs, the error message is displayed again.
No | The symbol described in the error message is not imported. The existing symbol is maintained. If a new conflict occurs, the error message is displayed again.
Yes, all | The symbol described in the error message is replaced by the symbol from the XML file at the import. This setting is used automatically when errors due to using the same name occur. All affected symbols are replaced.
No, all | The symbol described in the error message is not imported. The existing symbol is maintained. This setting is used automatically when errors due to using the same name occur. All affected symbols are maintained.

Note: Only the ShortName is used. The file name does not matter for the name of the symbol which should be imported. Thus it cannot be used to solve the conflict.


Visibility levels

Manual -> Screens -> Visibility levels

Similar to CAD programs, you can define visibility levels in the Editor and allocate them with unique elements. That way you can easily hide unused elements in complex images and show them again anytime. 15 visibility levels are available. Levels are allocated using the properties Visibility level in the nodeGeneral. Unique levels can be activated and deactivated using the buttons of the toolbar Visibility levels:

Symbol (from left to right) | Function
Show all visibility levels | Shows all levels.
Hide all visibility levels | Hides all levels.
Visibility level<No.> | Shows / hides the relevant visibility level.
Options for symbol bar | Clicking on the arrow opens the submenu: Active: Tool bar is displayed If the toolbar is not displayed, it can be activated using the Menu Options -> Toolbar. Note: For free placed tool bar (undocked from the Editor) options are not displayed. The tool bar can be closed by clicking on button X.

info Information

Visibility levels only apply to the Editor and have no effect in Runtime.

Note on control elements: Control elements are always displayed at the uppermost position. That also applies if they are covered by other elements in the Editor. This ensures that they can always be reached.


Screen types

Manual -> Screens -> Screen types

Screens are created in the basic setting with the Standard screen type. A drop-down list can be used to select special screen types for the properties in the screen properties.

attention Attention

If a type is changed from a standard type to a special type, the new screen type is fixed with the screen and can no longer be changed.

Special screen types

zenon offers a range of special screen types for special tasks. After selecting a special screen type, all user elements for the respective screen type are available in the Control elements menu. Menu item add template opens a selection dialog for adding pre-defined layouts with certain control elements at pre-defined locations.

info Information

Special screen types need only be created once, even when used multiple times. They can be opened with different data by means of the screen switching function.

Special screen types as a start screen

Each screen type can also be used as a start screen in theory.

Attention: Special screen types are opened with an empty filter and thus no data are opened.


Special screen types

Manual -> Screens -> Screen types -> Special screen types

Special screen types in zenon:

Screen type | Description
Active Directory user administration | Allows the administration of the Active Directory users and user groups in Runtime.
Alarm Message List | Collects alarm messages and displays them in list form.
Alarm Message List Filter | filter for the Alarm Message List.
Equipment Model | Switch equipment models as a screen in Runtime.
Archive revision | Display of saved archive values in a table and editing of these Attention: Only available if the Historian is licensed.
Batch | Creating defaults for master recipe in module Batch Control. Attention: Only available if Batch Control is licensed.
Command Processing | Display of command processing. ATTENTION: Only available if the Energy Edition is licensed.
User list | Display of users and the possibility to edit these with the Edit user screen.
User Groups List | Display of user groups and the possibility to edit these with the Edit user screen.
Edit User | Creating, editing and deleting users.
Chronological Event List | Collects process events, system events and user defaults and displays them in list form.
Chronological Event List Filter | Filter for the Chronological Event List
Extended Trend | Displays online and archive values as diagrams.
Faceplate | Incorporates several screens of a different type into one screen.
Energy forecast | Screen for the display of Energy forecast Attention: only available if SICAM 230 is licensed.
HTML | Makes it possible to display a screen in HTML, customized for Microsoft Internet Explorer.
Industrial Maintenance Manager | Display of maintenance information. ATTENTION: Only available if the Industrial Maintenance Manager is licensed. Note: Not available under Windows CE.
Industrial Performance Analyzer | Analyzes alarms in order to localize weak points (downtime) of equipment. Note: Not available under Windows CE.
Keyboard | Creates a freely definable virtual keyboard.
Load Management | planning and display of energy use management (electricity, gas). Attention: Only available with a license for Load Management. Note: Not available under Windows CE.
Login | Individually-designable window for temporary login in Runtime, as well as input of a signature and login via a function.
Message Control | Screen for managing the message queu in Message Control.
Notepad | Displays protocols and text files which were created from database requests or existing text files.
Production & Facility Scheduler | Administrates schedules and profiles. Attention: Only available if the Production & Facility Scheduler (PFS) is licensed.
Report Generator | For the output of reports that are produced by means of the extended Report Generator. Attention: Only available if the Report Generator is licensed. If you only want to display reports but not edit them, you do not need a license for Runtime.
Report Viewer | Serves to display RDL reports for Archive, AML, CEL and online values. Attention: only available if reporting is licensed.
Recipegroup Manager | Administrates recipes and their use within a recipe group. Attention: Only available if the Recipegroup Manager (RGM) is licensed.
S7 Graph | is used for sequential chains with alternative or parallel step sequences (SFC). Displays the current status of chain control in the PLC in runtime.
Standard Recipes | Administrates recipes
Variable diagnosis | Displays variables in Runtime and sends set values to the hardware Note: Not available under Windows CE.
Video | Displays online and saved videos (*.avi). Note: Not available under Windows CE.
Worldview overview | Makes it possible to scroll standard screens which are larger than the screen resolution.
Time filter | Enables general filter settings to be set for lists. The lists that are controlled by this are defined in the screen switching function.


Create special screen types

Manual -> Screens -> Screen types -> Special screen types -> Create special screen types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a special screen type:

  1. create a new screen or select an existing screen of the type Standard
  2. click on the predefined Standard type in the properties in the Screen type at General node

    Alternative: In the Screen detail view, click on the screen type of the elements and select the desired screen type from the drop-down list

  3. Select the desired screen type from the drop-down list.
  4. select the desired control elements in menu Control elements
    • Add template opens a selection dialog for adding pre-defined layouts with certain control elements at pre-defined locations.
    • Elements that are already present on the screen are displayed in gray and can no longer be selected

info Information

Limitation for automatic insertion of the template:

If there is already a static element, such as a control element, in the screen, no frame or frame text is inserted when inserting the default control elements.

Recommendation: Insert, after creating a special screen type in the first stage, the default control elements from the template and then further elements.


Template for standard screens and special screen types

Manual -> Screens -> Screen types -> Special screen types -> Template for standard screens and special screen types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For special screen types and also for standard screen you can use templates for automatic inserting and positioning elements. Templates can be created from every screen by yourself. For special screen types pre-defined templates are shipped with zenon.

Templates are stored as compressed zip files which include three files:

  • Meta data: XML file with the description of the template (name, description, size, etc.).
  • Screen elements: XML file with the exported elements of the screen.
  • Preview: Bitmap file with a preview of the template.

Shipped template

The shipped templates are available in different resolutions and also optimized for touch screens. These templates cannot be changed or deleted. Pre-defined templates by COPA-DATA are saved in the zenon program folder under: \Templates\ScreenTypes\[LANGUAGE]\[name of the screen type]\[Dateiname].zip.

Example: You can find the english templates for the Alarm Message List under %Program Files (x86)%\COPA-DATA\zenon 8.7\Templates\ScreenTypes\ENGLISH\Alarm Message list\

Note: Only templates for the currently-set language are loaded.

User-defined template

Users can create and save templates for all screen types. They can also be edited and deleted.

User-defined templates are saved in the zenon data folder: Templates\ScreenTypes\<name of screen type>\<file name>.zip.
e. B.: %ProgramData%\COPA-DATA\zenon700\Templates\ScreenTypes\Alarm Message List\3e9afbcf-f93d-46d9-a199-e00effe4811c.zip.

Note: The path depends on whether it is registered at the installation or via the Startup Tool. If the latter is the case, the current program folder is used as data folder.


Use templates

Manual -> Screens -> Screen types -> Special screen types -> Template for standard screens and special screen types -> Use templates

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use templates for a screen:

  1. open the screen
  2. select Add template in the control element menu
  3. the dialog fir selecting pre-defined and user-defined templates is opened

    Note: for screen of type Standard only user-defined template are available

  4. Select the desired template
  5. Click on Accept
  6. the elements defined in the templates are inserted at the pre-defined location

Parameters | Description
List field templates (left) | Displays all pre-defined and user-defined template.
Preview to template (top right) | Preview of the screen at taking over the selected template.
Description template (bottom right) | Description of the template.
Delete existing screen elements | Active: Already existing elements in the screen are deleted when taking over the template.
Apply | Inserts the elements of the selected template in the screen and closes the dialog.
Cancel | Closes dialog without inserting elements.
Help | Opens online help.


Create templates

Manual -> Screens -> Screen types -> Special screen types -> Template for standard screens and special screen types -> Create templates

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Folders and template can be newly created, deleted, renamed and moved for user-defined templates. Shipped, pre-defined templates cannot be changed or deleted.

Create folder or template

To create a folder, select:

  • button New folderin the dialog
  • or command New folder in the context menu
  • or use the Ins key

To create a template:

  1. highlight the desired screen in the detail view
  2. select command Create template for screen type in the context menu or in the tool bar
  3. the dialog for creating own templates is opened
  4. select an existing folder or create a new one
  5. enter a name for the new template
  6. you can add a description as an option
  7. Confirm with OK
  8. the template is added to the highlighted folder

Parameters | Description
List field templates (left) | Displays all pre-defined and user-defined template. Makes it possible to delete or rename folder and templates and to add folders via the context menu.
Preview to template (top right) | Preview of the screen at taking over the selected template.
Description template (bottom right) | Description of the template.
New folder | Creates a new folder. You can create several levels.
Rename | Opens field with names for editing. This can also be achieved with the F2 key or a delayed double click.
Delete | Deletes the selected folder with all subfolders after a confirmation request.
OK | Create template and closes dialog.
Cancel | Closes the dialog without creating the template.
Help | Opens online help.

Delete folder

To delete a folder or a template:

  1. highlight the folder or template
  2. select
    1. button Delete in the dialog
    2. or command Delete in the context menu
    3. or use the Del key

The folder or template is deleted after a confirmation request. For folders possible subfolders including all their templates are also deleted.

Rename folder or template

To rename a folder or a template:

  • Select the Rename command in the context menu
  • or use the Rename button
  • or highlight the element and open it by pressing the F2 key or a delayed double click on the text for editing.
  • or at templates change the text in filed Name

Move folders or templates

Folders and template can be moved via drag & drop with the help of the mouse to other folders.


Context menu create template for screen type

Manual -> Screens -> Screen types -> Special screen types -> Template for standard screens and special screen types -> Create templates -> Context menu create template for screen type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Context menu create template for screen type

In the dialog for creating new template context menus are also available.

Context menu for folder

Parameters | Description
New folder | Creates a new folder below the highlighted level.
Delete | Deletes the highlighted folder after a confirmation message.
Rename | Opens the folder caption for renaming.
Help | Opens online help.

Context menu for templates

Parameters | Description
Delete | Deletes the highlighted template after a confirmation message.
Rename | Opens the template caption for renaming.
Help | Opens online help.


Screen type specific functions

Manual -> Screens -> Screen types -> Screen type specific functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If a Button dynamic element is created in a screen with a special screen type, the additional property Screen type specific function is available in properties in the nodes (Variable / function nodes). With this property, you can link special functions that depend on the screen type with a button.

If screen-type specific functions are invalid, for example as a result of copying a button to a screen of a different type, then the invalid linking is pointed out and this can be replaced. Invalid functions are removed during compiling.

attention Attention

In addition to a screen-type specific function, it is also possible to link a general function with the button. VBA events (such as LeftClickDown) can also be executed in Runtime.

In this case, note the sequence of execution when clicking on the button:

  1. VBA events
  2. Screen-type-specific function
  3. General function

A function is only executed if the previous event has been completed.

Enter element dialog

Parameters | Description
List of functions | Lists all specific functions available for the screen type. Functions that are not available for this button are shown in gray. Clicking on an entry selects this for linking.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Active Directory user administration

Manual -> Screens -> Screen types -> Active Directory user administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can access the Windows Active Directory in Runtime with an Active Directory user administration screen. You can create, delete and edit organization units, users and user groups and assign them rights in zenon.

info Information

Active Directory, AD LDS and ADAM (for Windows XP) are not available with Windows CE.

Domains in Runtime

In Runtime, the domain of the user who started Runtime for the Active Directory login is used. Only the users who belong to this domain can log in.

User authorization

attention Attention

Rights that are issued in zenon are applicable for the respective project or the workspace. Rights that are issued in the Active Directory are applicable globally.

If rights have been issued to users or user groups of the Active Directory, then the rights for these users are applicable in all zenon projects!

Creating an Active Directory user administration screen

To create an Active Directory user administration screen:

  1. in the tool bar or in the context menu of node Screens select command New screen
  2. an empty screen of type Standard is opened
  3. Change the screen type in the detail view; to do this:
    1. click on Standard in the Screen type column
    2. Select Active Directory user administration in the drop-down list
  4. Click in the screen.
  5. select menu item Control elements from the menu bar
  6. Click on Add template in the drop-down list.
  7. The dialog for selecting a template is opened.
  8. Select the desired template.
  9. Standard elements are placed in pre-defined positions; these can be deleted or positioned elsewhere.
  10. You can add further elements using the Control elements menu.
  11. Name the screen. To do this:
    1. Click on the screen name in the detail view in the name column
    2. Give it its own name
  12. Create a screen switch function in order to be able to call up the screen in Runtime

Active Directory user administration screen

Parameters | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.
Login | Control elements for logging into the Active Directory.
Domain name | Entry and display of the domain name.
User name | Entry and display of the AD user name.
Password | Entry of the password.
Login | Clicking logs the user into the AD.
Logout | Clicking logs the user out.
Active Directory Explorer | Control elements for the display and administration of the Active Directory. Contains the Active Directory detail view: Window in which the structure of the Active Directory is displayed.
Create new organization unit (tree) | Opens the dialog to create a new organization unit in the tree.
Delete organization unit... (Tree) | Deletes the organization unit selected in the tree after requesting confirmation.
One level up | Navigates to one level higher in the structure.
Create new organization unit | Creates a new organization unit below the element selected in the tree. The corresponding dialog is opened:
Create new user | Opens the dialog to crate a new user.
Create new user group | Opens the dialog to create a new user group.
Edit object | Opens the dialog to edit the selected object.
Delete object | Deletes the selected object.

You can find details on use in zenon and configuration of the Active Directory in the user administration manual, in chapters:

  • Active Directory user administration with zenon Runtime
  • User administration with Microsoft Active Directory

attention Attention

Rights that are issued in zenon are applicable for the respective project or the workspace. Rights that are issued in the Active Directory are applicable globally.

If rights have been issued to users or user groups of the Active Directory, then the rights for these users are applicable in all zenon projects!


Equipment Model

Manual -> Screens -> Screen types -> Equipment Model

With an equipment model screen, the following is possible in Runtime:

  • Other, already-open screens can be filtered for certain equipment groups
  • All functions linked to a certain equipment group are automatically listed consecutively

Filtering for an equipment group always has an effect on the screens that have already been opened. If screens are called up again or reloaded, they are displayed again without the equipment model screen filter.

info Information

There are equipment models from global projects and local projects available. In the event of naming conflicts, local equipment projects are preferred.

Hint: Ensure that you use clear names when configuring equipment models. For example, give global equipment models a corresponding prefix or suffix. This way you avoid having the same names in local and global equipment models. And you can easily identify the origin of the displayed equipment model in selection lists.

You can find details on configuration and use of equipment model screens in the Equipment modeling manual in the Equipment model screen type and Filtering in Runtime chapters.


Faceplate

Manual -> Screens -> Screen types -> Faceplate

Faceplate is the term for a zenon screen that can accept several screens of different types using screen containers and display these consecutively in Runtime. For example, with faceplates:

  • Several screens can be displayed in a screen at the same time
  • Several time filters can be applied to the same screen type at the same time
  • Data from a screen can be applied to another screen using a filter

Permitted screen types for faceplates

The following screen types can be linked in faceplates:

  • AML
  • AML filter
  • Equipment Model
  • CEL
  • CEL filter
  • ETM
  • HTML
  • Report Generator
  • Report Viewer
  • Standard
  • Time filter

Faceplates in the detail view

Subscreens linked in faceplates are displayed as a group below the faceplate screen in the detail view.

It is possible to filter the subscreens in the Name column. All subscreens appropriate to the filter and the respective faceplate are displayed. Subscreens can be copied, but no longer edited.


Creating a faceplate screen

Manual -> Screens -> Screen types -> Faceplate -> Creating a faceplate screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A faceplate screen consists of screen containers and the optional buttons Filter and Filter editable.

Screen container:

Screen containers show the name of the container and the name of the and type of linked screen. For screens that have already been linked, this information is accentuated by automatically-defined background colors. This information in the Editor thus always overlays the content of the linked screen that is positioned at the same location.

The size of the container can be adapted to the size of the linked screen. To do this, navigate to the Accept size of linked screen property in the Position group. Clicking on the ... button accepts the size of the linked screen for the container.

Faceplate screen

Faceplate screen:

Control elements

Description

Insert template

Opens the dialog for selecting a template for the screen type.

Templates are shipped together with zenon and can also be created by the user.

Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.

Screen container

Element that is linked to an existing screen as displays the content of the linked screen in Runtime.

Several screen containers can be used in a faceplate screen.

If the option Border around dynamic elements (Options -> Settings) has been activated, then a symbol is displayed in the upper right-hand corner. This indicates that the content is linked.

The container contains information on the linked screen.

Filter

Calls up a window in Runtime with the filters configured in the Editor. Only filters that have been unlocked can be edited.

Filter editable

Calls up a window in Runtime with the filters configured in the Editor and allows the editing of all filters - regardless of the requirements in the Editor.

Creating a screen

To create a faceplate screen:

  1. Create a new screen
  2. Select, as a Screen type, Faceplate from the drop-down list
  3. Open the Control elements menu
  4. Select Insert template
  5. Select the template with the desired number of screen containers

    The screen containers are displayed. In addition, the Filter and Filter editable buttons are created.

  6. Link the screen containers that have been created to the desired zenon screens

    You have the following options for linking a screen to a container:

    • Drag & drop:
      Move a screen into the container by dragging & dropping it. A symbol is displayed when the mouse is positioned over the target, which indicates if the screen can be linked.
      Note: If several screens are moved to a container at the same time by dragging & dropping, the screen that is selected first is linked.
    • Selection via property:
      Select a screen via the Screen property in the Representation property group. Only permitted screen types are offered for linking.
    • Dialog in the container:
      Call up the dialog to select a screen by double-clicking on the empty screen container. Only permitted screen types are offered for linking.
      Note: Double-clicking on a container that has already been filled opens the linked screen.

  7. Issue a meaningful name for each screen container in the General/Element name property

Hints:

  • Double-clicking on the screen container opens:
    • With the screen container empty: the dialog to link a screen
    • With the screen container configured: the linked screen in the new tab
  • The Show preview in the Editor property can be used to switch the display of the linked screen in the screen container on or off in the Editor. It is recommended that the display is turned off in the event of performance problems.

info Information

When giving it a name for the Element name property, ensure that there are unique identifications. This is how you ensure that there is a unique selection when creating screen switching.

Creating screen containers manually

To create screen containers manually:

  1. Open the Control Elements menu
  2. Select Screen container
  3. Drag the screen container into the screen with the mouse
  4. The dialog for selecting a screen is opened
  5. Select the desired screen from the list and confirm this selection by clicking OK
  6. Assign a unique name for the screen container
  7. Repeat this step for desired screen containers

info Information

Only faceplates with permitted screen types can be created in the Editor. However, for the standard screen type, a screen type that is not permitted can subsequently be set. If such screen types are selected in the Editor, the linking is deleted. An empty container is shown in Runtime


Replace links

Manual -> Screens -> Screen types -> Faceplate -> Replace links

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Functions, variables, locking variables and ALC aliases linked in the container can be replaced automatically.

To replace links:

  1. Navigate to the Linking rule group in the properties of the container.
  2. Configure the corresponding replacements directly or use the dialog.
  3. Clicking on the ... button in the Preview property opens the dialog to configure and preview the replacements.

Replacements for several containers can be undertaken at the same time using multiple selection. In this case, the rules must be defined using the properties. The dialog with the preview is then not available.

Linking rule

Property | Description
Linking rule | Configuration of which character sequence can be replaced and how.
Source | Enter the character string to be searched for. Permitted wildcards: * and ? Wildcards are only permitted as a prefix or suffix; e.g. *xxx or xxx*.
Replace by | Entry of the character string that is to be replaced.
Name | Swaps information in process variable names.
Identification | Exchanges information in the identification
Note capitalization | When swapping, be sure that any capitalization is an exact match.
Hierarchical names | Permitted combined names. Is not available for ALC aliases and faceplate containers. These are always used without a symbol prefix.

Preview

Property | Description
Preview | Display of the selected and replaced elements.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.

You can find further details on automatic replacement of variables and functions in the chapter on replacing linking of variables and functions .

Hint: Ensure that the variables are named clearly and sensibly from the start.

The defined linking rule is applied to the following objects if they are present in the screen:

  • Functions
  • Variables
  • Interlocking variables
  • ALC aliases

Procedure

When switching to a faceplate screen, the linking rule for the objects to be replaced using the linking rule configured for the screen container is displayed in the preview list of the screen switching. The preview of the screen container also already shows the objects that have been replaced. Different screen containers can use the same screen, but define different linking rules.

In Runtime, only the replacement rule configured for the screen container is applied to the linked screen. Then, if configured, the linking rule is applied to the screen switching function.

If a linking rule cannot be deleted in Runtime, a LOG entry is created.


Configuring screen switching

Manual -> Screens -> Screen types -> Faceplate -> Configuring screen switching

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a new function to call up a variable diagnosis screen:

  1. Select New function
  2. Select Screen switch
  3. Select faceplate screen or a subscreen linked in the faceplate
  4. The dialog for configuring and linking filters is opened

  5. Configure the desired filter
    Tip: You can configure different filters of the same type
  6. Link screen containers to the filter
    Note: Only filters that are supported by the screen type in the screen container can be supported.
    AML, CEL, time and equipment model filters can be applied to subscreens
  7. Confirm the configuration by clicking on the OK button

Filter dialog

Parameters

Description

Filter

Tab to configure the filters for screen containers in the faceplate.

Replace links

Tab in which the linked variables can be replaced.

Replace indices

Tab in which the indexes can be replaced.

List of filters

List of all filters created. These filters can be allocated individual screen containers.

The list is sorted alphabetically according to filter. The entries in each group can be sorted according to description or filter parameters by clicking on the column title.

Checkbox

Active: If the option Offer this dialog in Runtime has been activated for the dialog, this filter is available in Runtime for configuration.

Inactive: This filter cannot be selected in Runtime.

Default: active

New

Opens the dialog to select a filter type and creates a new filter in the list accordingly.

Shortcut: Ins key

Edit

Opens a configuration dialog depending on the filter type.
The dialog can also be opened by double clicking on the filter in the list.

Duplicate

Copies the selected filter and inserts it with a new name into the group of the corresponding filters.

Remove

Removes the currently-selected filter from the list.

Shortcut: Del key

Screen container

Assignment of filters to screen containers.

List of filters

Lists all screen containers and the respective linked filters.

The names of the containers consist of: Identifiers for the screen container plus the name of the screen plus the screen type.

Filters that have already been linked are displayed alphabetically below the container name. Each container entry has a Link filter button. Clicking the Link filter button opens the dialog to select a filter.

Link filter

Clicking this opens the dialog to select a filter that is to be linked to the container. Only filters that can be linked to the selected container are shown.

Several filters per container can be selected, however not several screens of the same type. Filter types that are already linked to the respective screen container are no longer available for selection.

This button is displayed for each screen container at the end of its filter list.

Edit

Opens a configuration dialog depending on the filter type.
The dialog can also be opened by double clicking on the filter in the list.

Remove

Deletes the linking of the currently-selected filter to the screen container.

Shortcut: Del key

Show this dialog in Runtime

Active: This dialog is opened in Runtime before the function is executed.

Only filters whose checkboxes have been activated in Runtime are offered for editing in Runtime. All other filters are displayed but cannot be edited.

Note: This setting can be overcome in Runtime in the screen with the Filter editable button.

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Help

Opens online help.


Create a new filter

Manual -> Screens -> Screen types -> Faceplate -> Configuring screen switching -> Create a new filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Filters for screen containers are created and administered in the upper area of the Filter tab.

To create a filter:

  1. Click on the New button.
  2. The dialog for selecting a filter type is opened

  3. The following are displayed:
    • General filters
    • Screen-type-specific filter
  4. select the desired filter.
    You can select several filters at the same time:
    • Ctrl+mouse click: selects all filters clicked
    • Mouse click -> Shift key + mouse click: selects all filters between the first and the second click
    • Clicking on the filter heading: selects all filters of this group
    • Ctrl+A: selects all filters
    • Ctrl+D: deselects all filters
    • Shift+[letter]: selects the next filter that starts with the corresponding letter

    If only one filter is selected, clicking on OK opens the corresponding configuration dialog.
    No dialog is opened if several filters are selected. Each selected filter must be configured manually once it has been created.

  5. Configure the filter.
  6. close the configuration by clicking OK.

Filter types

Different filter types are available for faceplates. During configuration, only filters that are suitable for the screen types present in the faceplate are offered. If, for example, none of the linked screen types uses lots, then the lot filter is also not offered.

Filter

Description

General filters

Filters that are available regardless of the configured screen types.

Time

Configuration of time filters.

Text

Limitation of the display to messages that contain certain search terms.

Lots

Configuration of a lot filter.

Available if, in the faceplate, an AML, CEL, Extended Trend or Report Generator screen is linked.

Status

Configuration of the status that is to be filtered.

Equipment Model

Configuration of a filter for equipment groups from the global project or the local project.

Project

Selection of the projects of an integration project that are to be filtered.

Note: Generally only available if several projects have been created in an integration project. With the filter configuration for faceplates, the project filter is also offered for individual projects.

Screen-type-specific filter

Filters that are available depending on the configured screen types.

Alarm Message List (general)

Configuration of which alarms are displayed.

Alarm Message List (column settings)

Configuration of which columns of the AML are displayed, including the sequence and sorting.

Equipment Model (general)

Configuration of the filter for an equipment model screen.

Chronological Event List (general)

Configuration of which events are displayed.

Chronological Event List (column settings)

Configuration of which columns of the CEL are displayed, including the sequence and sorting.

Extended Trend (general)

Configuration of the following settings for Extended Trend:

  • Data
  • Display
  • X-axis

Extended Trend (printer settings)

Configuration of the printer settings for Extended Trend.

Extended Trend (column settings)

Configuration of the column settings for Extended Trend.

HTML (general)

Configuration of the filter for an HTML screen.

Report Generator (file)

Configuration of the report file of the Report Generator to be called up.

Report Generator (parameters)

Configuration of the parameters of the Report Generator to be used.

Report Viewer (report definition)

Configuration of the report definitions of the Report Viewer to be used.

Linked screens

Configuration of the linked screens for time filters, Alarm Message List and Chronological Event List.


Link filter

Manual -> Screens -> Screen types -> Faceplate -> Configuring screen switching -> Link filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Filters for screen containers are linked and administered in the lower area of the Filter tab.

To link a screen container to a filter:

  1. Click, in the screen container window, on the Link filter button.
  2. The dialog to link a filter is opened

  3. Select the desired filter.
  4. Confirm the linking by clicking on the OK button

Selection of filter for linking

Several filters can be linked to each screen container. However only one filter can be linked per filter type. Filter types that are already linked to the respective screen container are no longer available for selection.

The list of filters is sorted alphabetically according to filter. The entries in each group can be sorted according to description or filter parameters by clicking on the column title.

Several filters can be selected at the same time.

  • Ctrl+mouse click: selects all filters clicked
  • Mouse click -> Shift key + mouse click: selects all filters between the first and the second click
  • Clicking on the filter heading: selects all filters of this group
  • Ctrl+A: selects all filters
  • Ctrl+D: deselects all filters
  • Shift+[letter]: selects the next filter that starts with the corresponding letter


Transfer of filters when screen switching to other screen types

Manual -> Screens -> Screen types -> Faceplate -> Configuring screen switching -> Transfer of filters when screen switching to other screen types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For screen switching to certain screen types, Faceplate screens or subscreens of a faceplate can be selected as the screen to be called up or screen to be refreshed. If the faceplate screen is selected as the screen to be updated, the filter is applied to all suitable subscreens.

Screen types that allow faceplates and subscreens as a source/target with screen switching:

  • AML filter
  • Equipment Model
  • CEL filter
  • Time filter

Supported screen containers in the faceplate that is selected as the screen to be updated:

  • AML
  • AML filter
  • Equipment Model
  • CEL
  • CEL filter
  • Extended Trend
  • Time filter


Replace linking and indexes

Manual -> Screens -> Screen types -> Faceplate -> Configuring screen switching -> Replace linking and indexes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab, all variables and functions of linked screens are listed. These can also be replaced automatically as with other screen switching.

For details see:

  • Replacing linking of variables and functions
  • Replacing linking with screen switching
  • Replace indices

Particular feature when replacing faceplate screens

The settings for the replacement of variables and functions are applied not just in a faceplate screen, but also in all embedded screens. Replacements that have already been configured for the container via the properties of the Linking rule group are displayed in the Replace linking tab. In Runtime, only the replacement rule configured for the screen container is applied to the linked screen. Then, if configured, the linking rule is applied to the screen switching function.

Example:

Initial situation:

  • The faceplate screen contains a variable, Test1, and a screen, CEL.
  • The CEL screen also contains a variable Test1.
  • When switching screens, the variable Test1 is replaced by Test2.

Result:

  • The faceplate screen is called up and displays, instead of the variable Test1, the variable Test2.
  • The linked CEL screen is displayed as embedded.
  • The variable Test1 is also replaced by Test2 in the CEL screen.


Use faceplate in Runtime

Manual -> Screens -> Screen types -> Faceplate -> Use faceplate in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In Runtime, at places where screen containers are placed, the screens linked in these are displayed. The screens take on the size of their screen container and can be operated in the same way as all other switched screens.

Two containers with different screens are shown in the following faceplate screen.

info Information

Only faceplates with permitted screen types can be created in the Editor. However, for the standard screen type, a screen type that is not permitted can subsequently be set. If such screen types are selected in the Editor, the linking is deleted. An empty container is shown in Runtime

Changes to frames and screens

The screens in the containers are adapted to borders and frames.

The screen to be displayed is cut accordingly if:

  • The frame has been configured to be smaller than the screen that it is to display
  • A faceplate screen has been called up as a pop-up and its size has been changed


Editing filters

Manual -> Screens -> Screen types -> Faceplate -> Use faceplate in Runtime -> Editing filters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The filters for the screens in the screen containers configured in the Editor can be edited depending on the settings in Runtime.

Filter cannot be edited

In order for there to be no possibility of editing a filter when a screen is called up in Runtime, deactivate the Offer this dialog in Runtime (activated filters can be edited in Runtime) option in the Configuration of screen switching.

This block can be circumvented with the Filter editable button.

Selected filter editable

In order for filters to be able to be edited in Runtime when a screen is called up:

  • Activate, in the configuration of screen switching,
    • in the Filter list, the checkbox for each desired filter
    • The Offer this dialog in Runtime (activated filters can be edited in Runtime) option.

The dialog to select and edit the filter is displayed in Runtime when the screen is called up. All filters approved for editing can be selected and edited. All other filters are blocked. However, blocked filters can also be unlocked with the Filter editable button.

Display and edit all filters in Runtime

The dialog with all filters freely editable can be called up in Runtime with the Filter editable button.

If filters are only to be edited to a limited extent, but a user is to have unlimited access, then:

  1. Configure the screen switching with limited/no access possibilities for the filter
  2. Create a Filter editable button
  3. Grant corresponding access rights for the button, for users and user groups

In Runtime, the filters can only be edited as stipulated in the screen switching. However the users authorized for the button can edit all configurable filters.


Filter screens

Manual -> Screens -> Screen types -> Filter screens

You use filter screens to design individual filter pages with their own filter dialogs. You can do this according to aspects such as touch operation, filtering of special areas only, ability to switch languages, etc.

The following is provided as filter screens:

  • Alarm Message List Filter
  • Chronological Event List Filter
  • Time/Lot Filter


Creating filter screens

Manual -> Screens -> Screen types -> Filter screens -> Creating filter screens

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This is how you create filter screens:

  • Alarm Message List Filter
  • Chronological Event List Filter
  • Time/Lot Filter


Creating an Alarm Message List filter screen

Manual -> Screens -> Screen types -> Filter screens -> Creating filter screens -> Creating an Alarm Message List filter screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

It is possible to adjust filter settings for the Alarm Message List in Runtime with the help of the Alarm Message List Filter screen. Only the filter elements that are actually required are configured and provided to the user The appearance can also be freely defined and thus adapted to different end devices. All filter settings that are available in the filter for the function to switch the screen to the Chronological Event List screen can be configured.

Therefore:

  • Only the filter elements that are actually required are configured and provided to the user
  • The user only has these filters displayed and has an overview
  • The appearance can be freely defined and can, for example, ensure ease of use by means of a touch screen.

For details of use in Runtime, see Using the Alarm Message List Filter chapter.

For the definition of filter criteria, see Filter Alarm Message List Filter chapter.

attention Attention

Screens of type Alarm Message List Filter, Chronological Event List Filter and Time Filter must be engineered with an own frame. If they use the same frame as other screens, all screens based on this frame are closed when the screen is closed.

Creating an Alarm Message List filter screen

To create an Alarm Message List filter screen:

  1. in the toolbar or in the context menu of node Screens select entry New screen
  2. an empty screen of type Standard is opened
  3. Change the screen type in the detail view.
    To do this:
    1. click on Standard in the Screen type column
    2. Select Alarm Message List filter from the drop down list
  4. Select your own frame
    (AML filter cannot be based on the same template as other screens)
  5. Click in the screen.
  6. Select the Control elements menu item in the menu bar
  7. Click on Add template in the drop-down list
  8. The dialog for selecting a template is opened.
  9. Select the desired template.
  10. Select additional elements as required and insert them into the desired place on the screen
  11. Name the screen according to the selected filter.
    To do this:
    1. Click on the screen name in the detail view in the name column
    2. Select a suitable pre-defined name from the drop-down list it give it a name of your own
  12. Create a screen switch function in order to be able to call up the screen in Runtime


Control elements

Control elements

The Alarm Message filter screen can contain the following control and display elements.

Element

Description

Insert template

Opens the dialog for selecting a template for the screen type.

Templates are shipped together with zenon and can also be created by the user.

Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.

You can read more about templates for this screen type in the Templates chapter.

General filters

Drop-down list of different general filters.

Insert all elements: General filters

Inserts all elements from the area of general filters into pre-defined places. Elements can be arranged individually.

Insert all elements: General filter (Touch)

Inserts all elements from the area of general filters into pre-defined places. Elements can be arranged individually. The elements were optimized for touch operation.

Variable filter

Alarms of which variables are displayed:
  • Variable name

Filter according to names of variables.
  • Identification

Filter according to identification of variables.
  • Case sensitive

Note capitalization when filtering the variables.

Type of alarms

Which alarms are displayed:
  • Only not acknowledged alarms

Only unacknowledged
  • Only cleared alarms

Only historical
  • Only current alarms

Only current
  • Comment required

Alarms that require a comment when acknowledged
  • Minimum time alarms active - days

Only alarms that have been current for at least the given number of days.
  • Minimum time alarms active - hours

Only alarms that have been current for at least the given number of hours.
  • Minimum time alarms active - minutes

Only alarms that have been current for at least the given number of minutes.
  • Minimum time alarms active - seconds

Only alarms that have been current for at least the given number of seconds.
  • Minimum time alarms active - milliseconds

Only alarms that have been current for at least the given number of milliseconds.

Type of alarms (Touch)

Elements optimized for touch operation for the display of alarm type, along the lines of the Alarm type menu.

  • Only not acknowledged alarms
  • Only cleared alarms
  • Only current alarms
  • Comment required
  • Minimum time active alarms - Button: Days (up)
  • Minimum time active alarms - Touch box: Days
  • Minimum time active alarms - Button: Days (down)
  • Minimum time active alarms - Button: Hours (up)
  • Minimum time active alarms - Touch box: Hours
  • Minimum time active alarms - Button: Hours (down)
  • Minimum time active alarms - Button: Minutes (up)
  • Minimum time active alarms - Touch box: Minutes
  • Minimum time active alarms - Button: Minutes (down)
  • Minimum time active alarms - Button: Seconds (up)
  • Minimum time active alarms - Touch box: Seconds
  • Minimum time active alarms - Button: Seconds (down)
  • Minimum time active alarms - Button: Milliseconds (up)
  • Minimum time active alarms - Touch box: Milliseconds
  • Minimum time active alarms - Button: Milliseconds (down)

Origin of the data

Where does the data come from:
  • Ringbuffer

From the ring buffer.
  • Historical data

From an archive.
  • Text: Max. number:

Text for Maximum number input field

  • Input field: Max. number:

Input of the maximum alarms to be displayed when historical alarms are displayed.

0: displays all

Alarm/event groups/alarm/event classes/alarm areas

List field for grouped display:
  • Alarm/event groups

Alarm/event groups
  • Alarm/event classes

Alarm/event classes
  • Alarm areas

Alarm areas

Time filter

Selection of different time filters.

Insert all elements

Opens drop-down list to select pre-defined elements for certain time periods.

Absolute period of time: classic display

Elements for the absolute time period in classic display.

Absolute period of time: compact display

Elements for the absolute time period in compact display.

Relative period of time

Elements for the relative time period.

Starting from HH:MM:SS

Elements for a time period from a defined time.

Starting from day - HH:MM:SS

Elements for a time period from a defined day at a defined time.

Starting from day, month - HH:MM:SS

Elements for a time period from a defined day in a defined month at a defined time.

Time period: 15/30/60 minutes

Elements for a time period of 15, 30 or 60 minutes.

Time period: one day

Elements for a time period of one day.

Time period: 1 or 2 weeks

Elements for a time period over one or two weeks.

Each week can be selected, both for the view for a week as as well as for the view for two weeks. With the two-week view, a time period of 14 days is selected, depending on the week selected.

Time period: one month

Elements for a time period of one month.

Time period: one year

Elements for a time period of one year.

Insert all elements (Touch)

Opens the drop-down list to select pre-defined elements for certain time periods, which have been optimized for touch operation. Like Insert all elements, the following are available:

  • Absolute period of time: classic display
  • Relative period of time
  • Starting from HH:MM:SS
  • Starting from day - HH:MM:SS
  • Starting from day, month - HH:MM:SS
  • Time period: 15/30/60 minutes
  • Time period: one day
  • Time period: 1 or 2 weeks
  • Time period: one month
  • Time period: one year

Time filter type (label)

Labeling for time filter type.

Time filter type (combobox)

Combobox: Time filter type

Time filter type (display)

Field for time filter type display.

Time filter type (radio group)

Radio buttons that show or hide certain elements in Runtime:

  • No filter
  • Absolute time filter
  • Relative time filter
  • Starting from HH:MM:SS
  • Starting from day - HH:MM:SS
  • Starting from day, month - HH:MM:SS
  • Time period 15 minutes
  • Time period 30 minutes
  • Time period 60 minutes
  • Time period 1 day
  • Time period 1 week
  • Time period 2 weeks
  • Time period 1 month
  • Time period 1 year

Time from

Fields and labeling for stating "from" time.

  • From year (label)
  • From year (combobox)
  • From month (label)
  • From month (combobox)
  • From day (label)
  • From day (combobox)
  • From hour (label)
  • From hour (combobox)
  • From minute (label)
  • From minute (combobox)
  • From second (label)
  • From second (combobox)
  • From (spin control)

Time to

Fields and labeling for stating "to" time.

  • To year (label)
  • To year (combobox)
  • To month (label)
  • To month (combobox)
  • To day (label)
  • To day (combobox)
  • To hour (label)
  • To hour (combobox)
  • To minute (label)
  • To minute (combobox)
  • To second (label)
  • To second (combobox)
  • To (spin control)

Time from (Touch)

Fields and labeling for stating "from" time, optimized for touch operation.

  • From year (label)
  • From year (combobox)
  • From month (label)
  • From month (combobox)
  • From day (label)
  • From day (combobox)
  • From hour (label)
  • From hour (combobox)
  • From minute (label)
  • From minute (combobox)
  • From second (label)
  • From second (combobox)
  • From (spin control)

Time to (Touch)

Fields and labeling for stating "to" time, optimized for touch operation.

  • To year (label)
  • To year (combobox)
  • To month (label)
  • To month (combobox)
  • To day (label)
  • To day (combobox)
  • To hour (label)
  • To hour (combobox)
  • To minute (label)
  • To minute (combobox)
  • To second (label)
  • To second (combobox)
  • To (spin control)

Filter absolute time

Fields and labeling for stating absolute time filter.

  • From (label)
  • From date (calendar display)
  • From date (date display)
  • From time (time display)
  • To (label)
  • To date (calendar display)
  • To date (date display)
  • To time (time display)

Time period

Fields and labeling for stating time periods.

  • From year (label)
  • From year (combobox)
  • From month (label)
  • From month (combobox)
  • Week (label)
  • Week (combobox)
  • From day (label)
  • From day (combobox)
  • Start time (label)
  • Start time (combobox)

Time period (Touch)

Fields and labeling for stating "from" time, optimized for touch operation.

  • From year (label)
  • From year (up)
  • From year (touchbox)
  • From year (down)
  • From month (label)
  • From month (up)
  • From month (touchbox)
  • From month (down)
  • Week (label)
  • Week (up)
  • Week (touchbox)
  • Week (down)
  • From day (label)
  • From day (up)
  • From day (touchbox)
  • Button: From day (down)
  • Start time (label)
  • Start time (up)
  • Start time (touchbox)
  • Start time button (down)

Lots

Elements for lot selection in Runtime.

Archive list

List of archives available in Runtime.

Archive list status

Status of the archive list with number for:

  • available
  • filtered
  • displayed

Lot list

List of available lots.

Lot list status

Status of the lot list with number for:

  • available
  • filtered
  • displayed

Apply time filter to lot list.

Applies the configured time filter to the selection in the lot list.

Lot name filter (Input field)

Entry of a character sequence for filtering the lot names in the lot list.

Lot name filter (Button)

Button to execute filtering for lot names.

Text filter

Drop-down list of different text filters.

Insert all elements: Text filter

Inserts all elements for text filters.

No text filter

Radio button to deselect text filter.

Search for (separate words by Space)

Radio button to activate the search

Text: Search text

Labeling for search field.

Input field: Search text

Field for input of search term.

Options

Search options
  • Case sensitive

Capitalization must be noted.
  • Words do not need to be in the text completely

Fragments can also be searched for.
  • At least one word must be in the text

At least one search term from several must be in the result.
  • All words must be in the text

All search terms must be included in the result.
  • Exact filter text must be in the text

Exact text from the input field must be contained in the result.

Show list without refresh

Switches the AML in stopped state. New alarms are not added.

OK | Button: Applies the filter settings and closes the screen. Note on faceplates: In faceplates, AML filter, CEL filter and time/lot filter screens can be used. When configuring these in Runtime, clicking on OK closes the complete faceplate. If the filter settings are to be saved and the faceplate is to stay open, click on Accept.
Cancel | Button: Cancels the configuration of the filter settings.
Apply | Button: Accepts the filter settings.
Refresh search | Button: Updates the filtered display.


Template

Template

Template | Description
List field templates (left) | Displays all pre-defined and user-defined template.
Preview and description (right) | Shows preview and description of the selected template.
Standard | Inserts standard elements.
Scada | Special templates, optimized for mouse operation.
Only variable & text filter | Adds elements for filtering for variables and text.
Without alarm groups | Adds elements for filtering for variables, text and pending minimum time without alarm groups.
Standard | Inserts standard elements.
Filters for variables, text & time | Adds elements for filtering for variables, text and time.
Filters for variables, text & time (from month) | Adds variables for filtering for variables, text and relative time range from month.
Filters for variables, text & time (from hour) | Adds variables for filtering for variables, text and relative time range from hour.
Filters for variables, text & time (from day) | Adds variables for filtering for variables, text and relative time range from day.
Filters for variables, text & time (absolute - table) | Adds elements for filtering for variables, text and absolute time range.
Filters for variables, text & time (absolute - compact) | Adds elements for filtering for variables, text and absolute time range in compact form.
Filters for variables, text & time (absolute) | Adds elements for filtering for variables, text and absolute time range.

Close dialog

Parameters | Description
Delete existing screen elements | Active: Already existing elements in the screen are deleted when taking over the template.
Apply | Inserts the elements of the selected template in the screen and closes the dialog.
Cancel | Closes dialog without inserting elements.
Help | Opens online help.


Create a screen of the type CEL Filter

Manual -> Screens -> Screen types -> Filter screens -> Creating filter screens -> Create a screen of the type CEL Filter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

It is possible to adjust filter settings for the Chronological Event List in Runtime with the help of the Chronological Event List Filter screen. Only the filter elements that are actually required are configured and provided to the user The appearance can also be freely defined and thus adapted to different end devices. All filter settings that are also available in the filter for the function to switch the screen to the Chronological Event List screen can be configured.

Therefore:

  • Only the filter elements that are actually required are configured and provided to the user
  • The user only has these filters displayed and has an overview
  • The appearance can be freely defined and can, for example, ensure ease of use by means of a touch screen.

For details of use in the Runtime, see Using the CEL Filter chapter.

For the definition of filter criteria, see Filter screen switch CEL Filter chapter.

attention Attention

Screens of type Alarm Message List Filter, Chronological Event List Filter and Time Filter must be engineered with an own frame. If they use the same frame as other screens, all screens based on this frame are closed when the screen is closed.

Create a screen of type Chronological Event List Filter

To create a screen of type Chronological Event List Filter:

  1. Select, in the toolbar or in the context menu of the Screens node, the New Screen command
  2. An standard empty screen is opened
  3. Change the screen type in the detail view; to do this:
    1. click on Standard in the Screen type column
    2. select Chronological Event List Filter from the drop-down list
  4. select your own frame
    (CEL filter cannot be based on the same frame as other screens)
  5. Click in the screen.
  6. Select the Control elements menu item in the menu bar
  7. Click on Add template in the drop-down list
  8. The dialog for selecting a template is opened
  9. select the desired template
  10. Select additional elements as required and insert them into the desired place on the screen
  11. Name the screen according to the selected filter
    To do this:
    1. Click on the screen name in the detail view in the name column
    2. Select a suitable pre-defined name from the drop-down list it give it a name of your own
  12. Create a screen switch function in order to be able to call up the screen in Runtime


Control elements

Control elements

The screen of type Chronological Event List Filter can contain the following control and display elements.

Element

Description

Insert template

Opens the dialog for selecting a template for the screen type.

Templates are shipped together with zenon and can also be created by the user.

Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.

You can read more about templates for this screen type in the Templates chapter.

General filters

Drop-down list of different general filters.

Always display system messages in list

Shows a checkbox in Runtime to display or filter system messages. System messages are messages that do not relate to a variable.

Operation in Runtime:

  • Active: System messages are always displayed in Runtime. This also applies if they are to be filtered out by the text or variable filter.
    Exception: However system messages are not shown despite the checkbox being activated if they are filtered out by the time filter or the filters for data origin (ring buffer or historic data).

Example: Only messages with the text "XY" are to be displayed. However if the option is active, system messages that do not contain the term are also displayed.

Insert all elements: General filters

Inserts all elements from the area of general filters into pre-defined places. Elements can be arranged individually.

Variable filter

Alarms of which variables are displayed:
  • Variable name

Filter according to names of variables.
  • Identification

Filter according to identification of variables.
  • Case sensitive

Note capitalization when filtering the variables.

Origin of the data

Where does the data come from:
  • Ringbuffer

From the ring buffer.
  • Historical data

From an archive.
  • Text: Max. number:

Text for Maximum number input field

  • Input field: Max. number:

Input of the maximum alarms to be displayed when historical alarms are displayed.

0: displays all

Runtime settings

  • Show list without refresh

Switches the AML in stopped state. New alarms are not added.
  • Show relative times

Switches between the normal display and the relative-time display without the entries losing focus.

Relative time: All entries are displayed in the time distance to the selected entry.

The displayed time is the difference time passed since the selected entry. The selected entry automatically gets the time stamp 0. The other events have a:

  • positive time difference to the selected entry if they occurred later
  • negative time difference to the selected entry if they occurred earlier

Alarm/event groups/alarm/event classes/alarm areas

List field for grouped display:
  • Alarm/event groups

Alarm/event groups
  • Alarm/event classes

Alarm/event classes
  • Alarm areas

Alarm areas

Time filter

Drop-down list of different time filters.

Insert all elements

Opens drop-down list to select pre-defined elements for certain time periods.

Absolute period of time: classic display

Elements for the absolute time period in classic display.

Absolute period of time: compact display

Elements for the absolute time period in compact display.

Relative period of time

Elements for the relative time period.

Starting from HH:MM:SS

Elements for a time period from a defined time.

Starting from day - HH:MM:SS

Elements for a time period from a defined day at a defined time.

Starting from day, month - HH:MM:SS

Elements for a time period from a defined day in a defined month at a defined time.

Time period: 15/30/60 minutes

Elements for a time period of 15, 30 or 60 minutes.

Time period: one day

Elements for a time period of one day.

Time period: 1 or 2 weeks

Elements for a time period over one or two weeks.

Each week can be selected, both for the view for a week as as well as for the view for two weeks. With the two-week view, a time period of 14 days is selected, depending on the week selected.

Time period: one month

Elements for a time period of one month.

Time period: one year

Elements for a time period of one year.

Insert all elements (Touch)

Opens the drop-down list to select pre-defined elements for certain time periods, which have been optimized for touch operation. Like Insert all elements, the following are available:

  • Absolute period of time: classic display
  • Relative period of time
  • Starting from HH:MM:SS
  • Starting from day - HH:MM:SS
  • Starting from day, month - HH:MM:SS
  • Time period: 15/30/60 minutes
  • Time period: one day
  • Time period: 1 or 2 weeks
  • Time period: one month
  • Time period: one year

Time filter type (label)

Labeling for time filter type.

Time filter type (combobox)

Combobox: Time filter type

Time filter type (display)

Field for time filter type display.

Time filter type (radio group)

Radio buttons that show or hide certain elements in Runtime:

  • No filter
  • Absolute time filter
  • Relative time filter
  • Starting from HH:MM:SS
  • Starting from day - HH:MM:SS
  • Starting from day, month - HH:MM:SS
  • Time period 15 minutes
  • Time period 30 minutes
  • Time period 60 minutes
  • Time period 1 day
  • Time period 1 week
  • Time period 2 weeks
  • Time period 1 month
  • Time period 1 year

Time from

Fields and labeling for stating "from" time.

  • From year (label)
  • From year (combobox)
  • From month (label)
  • From month (combobox)
  • From day (label)
  • From day (combobox)
  • From hour (label)
  • From hour (combobox)
  • From minute (label)
  • From minute (combobox)
  • From second (label)
  • From second (combobox)
  • From (spin control)

Time to

Fields and labeling for stating "to" time.

  • To year (label)
  • To year (combobox)
  • To month (label)
  • To month (combobox)
  • To day (label)
  • To day (combobox)
  • To hour (label)
  • To hour (combobox)
  • To minute (label)
  • To minute (combobox)
  • To second (label)
  • To second (combobox)
  • To (spin control)

Time from (Touch)

Fields and labeling for stating "from" time, optimized for touch operation.

  • From year (label)
  • From year (combobox)
  • From month (label)
  • From month (combobox)
  • From day (label)
  • From day (combobox)
  • From hour (label)
  • From hour (combobox)
  • From minute (label)
  • From minute (combobox)
  • From second (label)
  • From second (combobox)
  • From (spin control)

Time to (Touch)

Fields and labeling for stating "to" time, optimized for touch operation.

  • To year (label)
  • To year (combobox)
  • To month (label)
  • To month (combobox)
  • To day (label)
  • To day (combobox)
  • To hour (label)
  • To hour (combobox)
  • To minute (label)
  • To minute (combobox)
  • To second (label)
  • To second (combobox)
  • To (spin control)

Filter absolute time

Fields and labeling for stating absolute time filter.

  • From (label)
  • From date (calendar display)
  • From date (date display)
  • From time (time display)
  • To (label)
  • To date (calendar display)
  • To date (date display)
  • To time (time display)

Time period

Fields and labeling for stating time periods.

  • From year (label)
  • From year (combobox)
  • From month (label)
  • From month (combobox)
  • Week (label)
  • Week (combobox)
  • From day (label)
  • From day (combobox)
  • Start time (label)
  • Start time (combobox)

Time period (Touch)

Fields and labeling for stating "from" time, optimized for touch operation.

  • From year (label)
  • From year (up)
  • From year (touchbox)
  • From year (down)
  • From month (label)
  • From month (up)
  • From month (touchbox)
  • From month (down)
  • Week (label)
  • Week (up)
  • Week (touchbox)
  • Week (down)
  • From day (label)
  • From day (up)
  • From day (touchbox)
  • Button: From day (down)
  • Start time (label)
  • Start time (up)
  • Start time (touchbox)
  • Start time button (down)

Lots

Elements for lot selection in Runtime.

Archive list

List of archives available in Runtime.

Archive list status

Status of the archive list with number for:

  • available
  • filtered
  • displayed

Lot list

List of available lots.

Lot list status

Status of the lot list with number for:

  • available
  • filtered
  • displayed

Apply time filter to lot list.

Applies the configured time filter to the selection in the lot list.

Lot name filter (Input field)

Entry of a character sequence for filtering the lot names in the lot list.

Lot name filter (Button)

Button to execute filtering for lot names.

Text filter

Drop-down list of different text filters.

Insert all elements: Text filter

Inserts all elements for text filters.

No text filter

Radio button to deselect text filter.

Search for (separate words by Space)

Radio button to activate the search

Text: Search text

Labeling for search field.

Input field: Search text

Field for input of search term.

Options

Search options
  • Case sensitive

Capitalization must be noted.
  • Words do not need to be in the text completely

Fragments can also be searched for.
  • At least one word must be in the text

At least one search term from several must be in the result.
  • All words must be in the text

All search terms must be included in the result.
  • Exact filter text must be in the text

Exact text from the input field must be contained in the result.

OK | Button: Applies the filter settings and closes the screen. Note on faceplates: In faceplates, AML filter, CEL filter and time/lot filter screens can be used. When configuring these in Runtime, clicking on OK closes the complete faceplate. If the filter settings are to be saved and the faceplate is to stay open, click on Accept.
Cancel | Button: Cancels the configuration of the filter settings.
Apply | Button: Accepts the filter settings.
Refresh search | Button: Updates the filtered display.


Template

Template

Template | Description
List field templates (left) | Displays all pre-defined and user-defined template.
Preview and description (right) | Shows preview and description of the selected template.
Standard | Inserts standard elements.
Scada | Special templates, optimized for mouse operation.
Standard | Inserts standard elements.
Filters for variables, text & time (absolute - compact) | Adds elements for filtering for variables, text and absolute time range in compact form.
Filters for variables, text & time (absolute) | Adds elements for filtering for variables, text and absolute time range.
Filters for variables, text & time (from month) | Adds variables for filtering for variables, text and relative time range from month.
Filters for variables, text & time (from hour) | Adds variables for filtering for variables, text and relative time range from hour.
Filters for variables, text & time (from day) | Adds variables for filtering for variables, text and relative time range from day.
Filters for variables, text & time (absolute - table) | Adds elements for filtering for variables, text and absolute time range.
Filters for variables, text & time (type can be selected) | Adds elements for filtering for variables, text and selectable time range.

Close dialog

Parameters | Description
Delete existing screen elements | Active: Already existing elements in the screen are deleted when taking over the template.
Apply | Inserts the elements of the selected template in the screen and closes the dialog.
Cancel | Closes dialog without inserting elements.
Help | Opens online help.


Creating a time/lot filter screen

Manual -> Screens -> Screen types -> Filter screens -> Creating filter screens -> Creating a time/lot filter screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

It is possible to make changes to the time filter settings in Runtime using a time filter screen. The following screens can be influenced by the filter:

  • Alarm Message List
  • Archive revision
  • Chronological Event List
  • Extended Trend

The advantage of this type of screen is that only the filter elements that are actually necessary can be configured. Therefore the user does not need to get to grips with numerous filter settings. Only the filter settings that he needs are displayed. Furthermore, you are completely free to change the appearance and can, for example, ensure ease of use by means of a touch screen.

attention Attention

Screens of type Alarm Message List Filter, Chronological Event List Filter and Time Filter must be engineered with an own frame. If they use the same frame as other screens, all screens based on this frame are closed when the screen is closed.

In the time filter screen, all time filter settings that are also present in the filter for the function to switch screens to the appropriate screen can be engineered.

Create screen of type Time filter

In order to create a Time filter screen:

  1. Select, in the toolbar or in the context menu of the Screens node, the New Screen command
  2. An standard empty screen is opened
  3. Change the screen type in the detail view; to do this:
    1. click on Standard in the Screen type column
    2. Select Time filter from the drop down list
  4. Select your own frame
    (time filter cannot be based on the same frame as other screens)
  5. Click in the screen.
  6. Select the Control elements menu item in the menu bar
  7. Click on Add template in the drop-down list
  8. The dialog for selecting a template is opened
  9. Select the desired template
  10. Standard elements are placed in pre-defined positions; these can be deleted or positioned elsewhere
  11. You can add further elements using the Control elements menu
  12. Name the screen according to the selected filter
    To do this:
    1. Click on the screen name in the detail view in the name column
    2. Select a suitable pre-defined name from the drop-down list it give it a name of your own

    Attention: The pre-defined names are not available under Windows CE.

  13. Create a screen switch function in order to be able to call up the screen in Runtime


Control elements

Control elements

For time filter screens, there are also elements that have been optimized for touch-screen operation in addition to the conventional elements.

Control element

Description

Insert template

Opens the dialog for selecting a template for the screen type.

Templates are shipped together with zenon and can also be created by the user.

Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.

You can read more about templates for this screen type in the Templates chapter.

Insert all elements

Opens drop-down list to select pre-defined elements for certain time periods.

Absolute period of time: classic display

Elements for the absolute time period in classic display.

Absolute period of time: compact display

Elements for the absolute time period in compact display.

Relative period of time

Elements for the relative time period.

Starting from HH:MM:SS

Elements for a time period from a defined time.

Starting from day - HH:MM:SS

Elements for a time period from a defined day at a defined time.

Starting from day, month - HH:MM:SS

Elements for a time period from a defined day in a defined month at a defined time.

Time period: 15/30/60 minutes

Elements for a time period of 15, 30 or 60 minutes.

Time period: one day

Elements for a time period of one day.

Time period: 1 or 2 weeks

Elements for a time period over one or two weeks.

Each week can be selected, both for the view for a week as as well as for the view for two weeks. With the two-week view, a time period of 14 days is selected, depending on the week selected.

Time period: one month

Elements for a time period of one month.

Time period: one year

Elements for a time period of one year.

Insert all elements (Touch)

Opens the drop-down list to select pre-defined elements for certain time periods, which have been optimized for touch operation. Like Insert all elements, the following are available:

  • Absolute period of time: classic display
  • Relative period of time
  • Starting from HH:MM:SS
  • Starting from day - HH:MM:SS
  • Starting from day, month - HH:MM:SS
  • Time period: 15/30/60 minutes
  • Time period: one day
  • Time period: 1 or 2 weeks
  • Time period: one month
  • Time period: one year

Time filter type (label)

Labeling for time filter type.

Time filter type (combobox)

Combobox: Time filter type

Time filter type (display)

Field for time filter type display.

Time filter type (radio group)

Radio buttons that show or hide certain elements in Runtime:

  • No filter
  • Absolute time filter
  • Relative time filter
  • Starting from HH:MM:SS
  • Starting from day - HH:MM:SS
  • Starting from day, month - HH:MM:SS
  • Time period 15 minutes
  • Time period 30 minutes
  • Time period 60 minutes
  • Time period 1 day
  • Time period 1 week
  • Time period 2 weeks
  • Time period 1 month
  • Time period 1 year

Time from

Fields and labeling for stating "from" time.

  • From year (label)
  • From year (combobox)
  • From month (label)
  • From month (combobox)
  • From day (label)
  • From day (combobox)
  • From hour (label)
  • From hour (combobox)
  • From minute (label)
  • From minute (combobox)
  • From second (label)
  • From second (combobox)
  • From (spin control)

Time to

Fields and labeling for stating "to" time.

  • To year (label)
  • To year (combobox)
  • To month (label)
  • To month (combobox)
  • To day (label)
  • To day (combobox)
  • To hour (label)
  • To hour (combobox)
  • To minute (label)
  • To minute (combobox)
  • To second (label)
  • To second (combobox)
  • To (spin control)

Time from (Touch)

Fields and labeling for stating "from" time, optimized for touch operation.

  • From year (label)
  • From year (combobox)
  • From month (label)
  • From month (combobox)
  • From day (label)
  • From day (combobox)
  • From hour (label)
  • From hour (combobox)
  • From minute (label)
  • From minute (combobox)
  • From second (label)
  • From second (combobox)
  • From (spin control)

Time to (Touch)

Fields and labeling for stating "to" time, optimized for touch operation.

  • To year (label)
  • To year (combobox)
  • To month (label)
  • To month (combobox)
  • To day (label)
  • To day (combobox)
  • To hour (label)
  • To hour (combobox)
  • To minute (label)
  • To minute (combobox)
  • To second (label)
  • To second (combobox)
  • To (spin control)

Filter absolute time

Fields and labeling for stating absolute time filter.

  • From (label)
  • From date (calendar display)
  • From date (date display)
  • From time (time display)
  • To (label)
  • To date (calendar display)
  • To date (date display)
  • To time (time display)

Time period

Fields and labeling for stating time periods.

  • From year (label)
  • From year (combobox)
  • From month (label)
  • From month (combobox)
  • Week (label)
  • Week (combobox)
  • From day (label)
  • From day (combobox)
  • Start time (label)
  • Start time (combobox)

Time period (Touch)

Fields and labeling for stating "from" time, optimized for touch operation.

  • From year (label)
  • From year (up)
  • From year (touchbox)
  • From year (down)
  • From month (label)
  • From month (up)
  • From month (touchbox)
  • From month (down)
  • Week (label)
  • Week (up)
  • Week (touchbox)
  • Week (down)
  • From day (label)
  • From day (up)
  • From day (touchbox)
  • Button: From day (down)
  • Start time (label)
  • Start time (up)
  • Start time (touchbox)
  • Start time button (down)

Lots

Elements for lot selection in Runtime.

Archive list

List of archives available in Runtime.

Archive list status

Status of the archive list with number for:

  • available
  • filtered
  • displayed

Lot list

List of available lots.

Lot list status

Status of the lot list with number for:

  • available
  • filtered
  • displayed

Apply time filter to lot list.

Applies the configured time filter to the selection in the lot list.

Lot name filter (Input field)

Entry of a character sequence for filtering the lot names in the lot list.

Lot name filter (Button)

Button to execute filtering for lot names.

OK

Button: Applies the filter settings and closes the screen.

Note on faceplates: In faceplates, AML filter, CEL filter and time/lot filter screens can be used. When configuring these in Runtime, clicking on OK closes the complete faceplate. If the filter settings are to be saved and the faceplate is to stay open, click on Accept.

Cancel

Button: Cancels the configuration of the filter settings.

Apply

Button: Accepts the filter settings.

Refresh search

Button: Updates the filtered display.

Emphasis of Touch elements

Control elements for touch operation can be emphasized by means of colored emphasis. To do this, the following properties in the Color group are configured in the screen for touch elements:

  • Text color on focus: Text color if the element is in focus
  • Background color on focus: Background color if the element is in focus
  • Text color without focus: Text color if the element is not in focus
  • Background color without focus: Background color if the element is not in focus


Template

Template

Several pre-defined templates are available for time filter screens.

Template | Description
List field templates (left) | Displays all pre-defined and user-defined template.
Preview and description (right) | Shows preview and description of the selected template.
Standard | Inserts standard elements.
Scada | Template for mouse operation
Absolute | Inserts elements for absolute time.
Absolute calendar | Inserts elements for absolute time with calendar.
Absolute compact | Inserts elements for absolute time in compressed design.
Standard | Inserts standard elements.
from month | Inserts elements for time range from month.
from hour | Inserts elements for time range from hour.
from day | Inserts elements for time range from day.
Touch | Templates, optimized for touch operation.
Absolute | Inserts elements for absolute time.
Standard | Inserts standard elements.
from month | Inserts elements for time range from month.
from hour | Inserts elements for time range from hour.
from day | Inserts elements for time range from day.
Preview to template (top right) | Preview of the screen at taking over the selected template.
Description template (bottom right) | Description of the template.
Delete existing screen elements | Active: Already existing elements in the screen are deleted when taking over the template.

Close dialog

Parameters | Description
Delete existing screen elements | Active: Already existing elements in the screen are deleted when taking over the template.
Apply | Inserts the elements of the selected template in the screen and closes the dialog.
Cancel | Closes dialog without inserting elements.
Help | Opens online help.


Pre-defined names

Manual -> Screens -> Screen types -> Filter screens -> Creating filter screens -> Pre-defined names

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Pre-defined names are available for time filters.

Attention: The pre-defined names are not available under Windows CE.

To select a name:

  1. In the detail view, define as a time filter, chronological event list filter or alarm message list filter
  2. Click twice in the name field in the 'Name' column
  3. Select the desired pre-defined name from the drop-down.
    • TIMEFILTER_ABSOLUTE
    • TIMEFILTER_DAY
    • TIMEFILTER_HOUR
    • TIMEFILTER_MONTH
    • TIMEFILTER_PERIOD
    • TIMEFILTER_PERIOD_DAY
    • TIMEFILTER_PERIOD_MINUTE
    • TIMEFILTER_PERIOD_MONTH
    • TIMEFILTER_PERIOD_WEEK
    • TIMEFILTER_PERIOD_YEAR
    • TIMEFILTER_RELATIVE

Note: CEL filter and AML filter screens also have a pre-defined name, CEL_FILTER and AML_FILTER.


Use filter screen

Manual -> Screens -> Screen types -> Filter screens -> Creating filter screens -> Use filter screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Filter screens

Filter screens make it possible to transfer a preset filter from one screen to another. The filter of the source screen is set using the target screen. The screens can also be of a different screen type.

attention Attention

In order for the time to be taken from the screen to be called up in Runtime, the following time range must be selected in the Editor for the screen switching function for the Alarm Message List or the Chronological Event List in the time filter: Set filter at time filter type

Call definition

The following requirements must be met for the set filters to be used:

  1. Set filter for time filter type is selected as a time period for the time filter.
  2. The screen (Alarm Message List Filter, Chronological Event List filter or Time/Lot Filter screen) is activated using a button or a combined element. Only in this way can the relationship between filter screen and source screen be maintained.
  3. The source screen and filter screen must be configured on different frames or monitors. The filter for the filter screen can only be updated if the source screen is open. This is only possible if both screens do not use the same frame or the same monitor.
  4. The screen to be called up must be compatible with the filter screen to be called up (see table).
Source screen | AML filter | CEL filter | Time filter
Archive revision | T | T | T
Extended Trend | T | T | T
Time filter | T | T | X
Alarm Message List Filter | X | C | T
Chronological Event List Filter | C | X | T
Alarm Message List | X | C | T
Chronological Event List | C | X | T

Key:

  • C: Common settings are updated.
  • T: Time settings are updated.
  • X: All settings are updated.

info Information

No filtering

The filter screen is not filtered, but opened with the configured values, if:

  • One of the conditions 1 to 3 is not met or
  • The Screen to call up setting is not activated for the Screen switching function or
  • The screen is not called up via a screen element

In this case, the Accept, Close and Update buttons are grayed out in Runtime and have no function.

Update

When a filter screen is called up (Alarm Message List filter, Chronological Event List filter, time filter), the screens configured in the screen switching function are updated in two ways:

  • If the filter screen is called up via a screen element, the target screens on the same monitor as the source screen are updated.
  • If the filter is called up in a different way or if the Update on all monitors setting is activated, all target screens configured are updated.

They are updated as soon as you click the Accept button or as soon as you closes the filter screen with the close Close button. The Cancel button discards the changes and closes the filter screen.

Update filter settings

You update the current filter settings for the source screen using the Update button. If the filter screen is not called up by a screen element or if the Calling screen has not been activated, all monitors are searched for screens that can be used for updating. The first screen that is found is then this is used for updating.


Screen switch to a filter screen

Manual -> Screens -> Screen types -> Filter screens -> Screen switch to a filter screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a function to switch to a filter screen:

  1. Select New function.
  2. Select Screen switching.
  3. Select the desired screen:
    • AML filter
    • CEL filter
    • Time filter
  4. The dialog for configuration and linking of the filter for the selected screen type is opened.
    The tabs shown depend on the screen type.
  5. Configure the corresponding tabs.

info Information

Tabs for special screen types:

  • AML filter: Screens, General, Text, Time, Lots, Column settings
  • CEL filter: Screens, General, Text, Time, Lots, Column settings
  • Time filter: Screens, Time, Lots, Column settings


Screens

Manual -> Screens -> Screen types -> Filter screens -> Screen switch to a filter screen -> Screens

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab, you can define the screens that are to be updated by the screen filter.

The following settings are available:

Filter is taken from the following screen

Parameters

Description

Filter is taken from the following screen

Definition of the screen form which the filter is to be taken.

Calling screen

Active: The filter settings are take over from the screen from which the filter screen is called up. The screen button is grayed out. You cannot explicitly select a screen, because the filter is always updated from the calling screen with this setting.

Note: Settings in the General, Text and Time tabs are locked.

Predefined screen

Click on button opens the Screen selection dialog.

Select the screen from which the filter - when clicking button Update during Runtime - should be read.

Subscreens of faceplates can be selected for screen switching to AML filter, CEL filter, time filter and equipment model. For these screens, the name of the faceplate screen is placed in front of the subscreen in order to clearly distinguish them from other screens.

Attention: When the filter screen is first called up using the function, the filter configured in the function is used, not the filter of the screen stated here!

Note: It therefore only makes sense to select a screen which can adopt or fill the screen filter.

The screen selected is entered into the list of screens to be updated. If you delete it from the list, the next screen on the list is automatically entered here.

Note: Not available if you have activated the Calling screen checkbox.

Screens to be updated

Parameters | Description
Screens to be updated | Selection of the screens that are to be updated. Subscreens of faceplates can be selected for screen switching to AML filter, CEL filter, time filter and equipment model. For these screens, the name of the faceplate screen is placed in front of the subscreen in order to clearly distinguish them from other screens.
Screen selection | Click the button to open dialog Screen selection of the filter screens. Select the desired screen.
Update | Stipulation of where the filter should take effect.
Update on all monitors | Active: The screens from the list of the screens which must be updated are updated on all accessible monitors.


General

Manual -> Screens -> Screen types -> Filter screens -> Screen switch to a filter screen -> General

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This tab is only available for the Alarm Message List filer and Chronological Event List and shows the standard filter for the respective list. See Alarm Message List filter and Chronological Event List filter.

AML

Variable filter

Parameters

Description

Variable filter

Limitation to alarms of certain variables

Variable name

Enter the name or part of the name of the variable you want to filter.

Use of the wild card * is possible. Wildcards are only permitted as a prefix or suffix; e.g. *xxx or xxx*.

Note: Filter terms entered in Runtime or in the Editor are automatically saved on the local computer in zenon6.ini and are available for selection in the drop-down list.

Identification

Enter the identification or part of the identification of the variables you want to filter. Wild card * is possible.

Use of the wild card * is possible. Wildcards are only permitted as a prefix or suffix; e.g. *xxx or xxx*.

Note: Filter terms entered in Runtime or in the Editor are automatically saved on the local computer in zenon6.ini and are available for selection in the drop-down list.

Case sensitive

Active: Capitalization is recognized when filtering for variable name and/or identification.

Type of alarms

Parameters

Description

Type of alarms

Type of alarm that is displayed.

Only not acknowledged alarms

Active: Only alarms that have not yet been acknowledged by the user are displayed.

Only cleared alarms

Active: Only alarms that have already passed, i.e. whose values no longer in the critical range, are displayed.

Only current alarms

Active: Only alarms that are still active, i.e. whose values are still in the critical range, are displayed.

Comment required

Active: Only alarms are shown for which it is necessary to leave a comment are displayed.

Alarms must be current for

Use the spin control to define the minimum time that an alarm should be active in order for it to be displayed. Possible settings:

  • Days
  • Hours (hr.)
  • Minutes (min.)
  • Seconds (sec.)
  • Milliseconds (ms)

Origin of the data

Parameters | Description
Origin of the data | Display of current or current and historical alarms.
Ringbuffer | Active: Only data from the ring buffer are displayed.
Historical data Maximum number | Active: Data from the ring buffer and historical data from the AML are displayed. The maximum number of the data which should be displayed includes the data from the ring buffer.

Alarm/event groups/classes and alarm areas

Parameters | Description
Alarm/event groups/classes, alarm areas | Selection of groups, classes and alarm area.
Alarm/event groups | From the existing alarm/event groups select the one from which alarms should be displayed.
Alarm/event classes | From the existing alarm/event classes select the one from which alarms should be displayed.
Alarm areas | From the existing alarm areas select the one from which alarms should be displayed.
Runtime settings | Behavior of the AML in Runtime
Show list without refresh | Active: As long as the list is displayed no new entries are added.


Text

Manual -> Screens -> Screen types -> Filter screens -> Screen switch to a filter screen -> Text

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can define the standard values for text filtering in this tab. Only available for Alarm Message List and Chronological Event List.

Filter by

Parameters | Description
Filter by |
No text filter | The text filter is not used.
Search for (words separated by spaces) | The text filter filter is used. Further options are activated.
Input field | Enter the corresponding words or character strings.

Options

Parameters | Description
Options |
Note capitalization | Active: The filtering is case-sensitive.
Words do not have to appear in the text in full | Active: Parts of words can also be taken into account during filtering.
At least one word must be in the text | Active: At least one word of the search string has to be in the text.
All words must be present in the text | Active: All words must be present in the search string. In doing so, the sequence plays no role.
Filter text must appear in the text exactly | Active: The text must be exactly as defined in the search string.


Time

Manual -> Screens -> Screen types -> Filter screens -> Screen switch to a filter screen -> Time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab, you define the time period that is to be used when the filter screen is opened.

Filter

Selection of the filter.

Parameters

Description

No time filter

Active: No time filter is used.

Note: all Runtime entries since 1. 1. 1990 are displayed.

Absolute filter

Active: A fixed period of time is entered in the editor. When the function is executed, the defined absolute time period is exactly used.

In the settings section, the corresponding options can be shown and configured there.

Note: Time is saved in UTC. For details see chapter Handling of date and time in chapter Runtime.

Relative period of time

Active: A relative time period is entered.

In the settings section, the corresponding options can be shown and configured there.

Attention: this filter is constantly updated.

From

Active: A time from which the filter is effective is stated. If the time is not reached on the current day, filtering takes place from the corresponding time the previous day.

Selection of the area mode from drop-down list:

  • From HH:MM:SS o'clock
  • From day - HH:MM:SS o'clock
  • Starting on day, month at HH:MM:SS

In the settings section, the corresponding options can be shown and configured there.

Attention: The start point of this filter is not updated automatically. Only the existing times are used when shown.
The end time point is not defined with this filter, it is carried over.

Time period

Active: A fixed time period is entered. Selection of the area mode from drop-down list:

  • One day
  • One week
  • Two weeks
  • One month
  • One Year
  • 15 minutes
  • 30 minutes
  • 60 minutes

In the settings section, the corresponding options can be shown and configured there.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Absolute period of time

Absolute period of time

You define a fixed time period with the absolute filter. When the function is executed, the defined absolute time period is exactly used. To set the filter:

  1. Select, in the Filter section, the Absolute time period option
  2. Configure the desired time in the Settings section

Parameters | Description
Settings | Configuration of the time filter.
Propose current date/time | Active: Time filter is displayed in Runtime.
Preset | Active: The time filter is prescribed in the Editor. Only the start time can still be configured in Runtime.
From | Start time of the filter. Selection of day, month, year, hour, minute and second
To | End time of the filter. Selection of day, month, year, hour, minute and second

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Relative period of time

Relative period of time

A relative time period is entered.

Attention: This filter is updated constantly and continues to run.
Example: You set a relative time of 10 minutes and switch to a screen with this time filter at 12:00. You are then shown the data from 11:50 to 12:00 when switching. If the screen stays open, the filter is automatically updated. At 12:01, you see the data from 11:51 - 12:01 etc.

To set the filter:

  1. Select, in the Filter section, the Relative period of time option
  2. Configure the desired time in the Settings section

Parameters | Description
Settings | Configuration of the time filter.
Propose current date/time | Active: Time filter is displayed in Runtime.
Preset | Active: The time filter is prescribed in the Editor. Only the start time can still be configured in Runtime. Selection of the relative time period in days, hours, minutes and seconds.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Specify time period in the Editor

Specify time period in the Editor

With this method, you enter a fixed time period into the editor, which is applied when the function is carried out in Runtime. You can then only define the start time in Runtime, but no further filter settings.

For example: You set a 30 minute time filter. In Runtime, you can now only set when this 30 minute time period is to start. However, you cannot change the filter to a day filter.

attention Attention

When using this type of filter, you can also no longer amend all other filters in Runtime that are available in the General tab. It is still possible to filter for text, status and equipment.

To create the filter:

  1. The screen must have the Filter button to start the filter in Runtime
  2. select the desired filter
  3. Configure the selected time period

Tip for time period: Activate the Offer this dialog in Runtime option in the filter dialog. This way you can amend the start time before the function is carried out. Do not have the filter displayed in Runtime when the function is turned on; this way the current time period is always used. If you have activated the Use last closed time period option, the previous time period is shown.
For example: You have set a 30 minute filter. It is 10.45 when the function is activated. If the Use last closed time period option is deactivated, the filter is set to the current time period 10:30:00 to 10:59:59. If the option is activated, the filter is set to the previous time period of 10:00:00 to 10:29:59.


Time filter can be configured in Runtime

Time filter can be configured in Runtime

With this method, you stipulate a time filter in the Editor. This can be amended in Runtime before execution. To create the filter:

  1. The screen must have Filter and Display filter buttons
  2. select the desired filter:
    • Absolute period of time
    • Relative period of time
  3. Select, in the Settings section, the option Propose current date/time
  4. The filter dialog is opened in Runtime with the current date and time


Lots

Manual -> Screens -> Screen types -> Filter screens -> Screen switch to a filter screen -> Lots

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab, you can define the lots that are to be displayed.

Filter

Settings for the application of the lot filter. Selection of one of the options:

  • No lot filter
  • Apply lot filter directly
Parameters | Description
No lot filter | Active: The lot filter is deactivated and cannot be configured. Filtering for lots is not carried out in Runtime.
Apply lot filter directly | Active: The filter configured here is applied in Runtime directly.

Archive(s)

Configuration of filtering for archives. Selection of one of the options:

  • No filter
  • Static
  • From variable

Parameters

Description

No filter

Active: Filtering for archive names is not carried out.

Static

Active: Archives whose identification corresponds to the character string entered in the input field are filtered for.

Input of the archive identifications in the input field:

  • Several identifications are separated by a comma (,).
  • * or empty: All archives, no filter.

From variable

Active: The value of the variables linked here is applied as a filter for archive names in Runtime.

Click on button ... in order to open the dialog for selecting a variable.

Only available for all modules if the Apply lot filter directly option has been selected:

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.
  • If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for archive names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Name(s)

Configuration of the filtering to names. Selection of one of the options:

  • No filter
  • Static
  • From variable

Parameters

Description

No filter

Active: Filtering for lot names is not carried out.

Static

Active: Lot names that correspond to the character string entered in the input field are filtered for.

Input of the lot name in the input field:

  • Several entries are separated by a pipe character (|).
  • * or empty: All lots of all displayed archives, no filter.

From variable

Active: The value of the variable linked here is applied as a filter for lot names in Runtime.

Click on the ... button to open the dialog for selecting a variable.

Not available if the option Apply lot filter directly has been selected.

Notes for variables in Runtime:

  • The variable selection is only activated in Runtime if a valid variable has already been linked in Runtime. The ... button is always deactivated in Runtime. The option can be selected, but no new variable can be linked.

If the variable is not signed into the driver at the time at which the lot filter is applied, the variable is signed in and read. This can lead to delays with slow driver connections/protocols.

Attention: If the selected variable is not found in Runtime, there is no filtering for lot names. This also applies if the value of the variable cannot be determined. The filter then corresponds to the No filter setting.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Column settings

Manual -> Screens -> Screen types -> Filter screens -> Screen switch to a filter screen -> Column settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab, you define how the archive list and the lot list from the time/lot filter screen are displayed in Runtime:

  • Selection of the columns to be displayed
  • Sorting of the columns
  • Formatting of columns:
    • Labeling
    • Width
    • Alignment

Archive list

Parameters | Description
Archive list | Configuration of the archive list. Display of the configured columns.
Column selection | Clicking on the button opens a dialog to select and sort the columns.
Column Format | Clicking on the button opens a dialog to format the list.

Lot list

Parameters | Description
Lot list | Configuration of the lot list. Display of the configured columns.
Column selection | Clicking on the button opens a dialog to select and sort the columns.
Column Format | Clicking on the button opens a dialog to format the list.
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Column selection

Column selection

Selection and sequence of the columns.

Button | Function
Available columns | List of columns that can be displayed in the table.
Selected columns | Columns that are displayed in the table.
Add | Moves the selected column from the available ones to the selected items. After you confirm the dialog with OK, they are shown in the detail view.
Add all | Moves all available columns to the selected columns.
Remove | Removes the marked columns from the selected items and shows them in the list of available columns. After you confirm the dialog with OK, they are removed from the detail view.
Remove all | All columns are removed from the list of the selected columns.
Up | Moves the selected entry upward. This function is only available for unique entries, multiple selection is not possible.
Down | Moves the selected entry downward. This function is only available for unique entries, multiple selection is not possible.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Column Format

Column Format

Configuration of the properties of the columns for configurable lists. The settings have an effect on the respective list in the Editor or - when configuring screen switching - in Runtime.

Available columns

Parameters | Description
Available columns | List of the available columns via Column selection. The highlighted column is configured via the options in the Settings area.

Settings

Parameters

Description

Settings

Settings for selected column.

Labeling

Name for column title.

The column title is online language switchable. To do this, the @ character must be entered in front of the name.

Width

Width of the column in characters.
Calculation: Number time average character width of the selected font.

Alignment

Alignment. Selection by means of radio buttons.

Possible settings:

  • Left-justified: Text is justified on the left edge of the column.
  • Centered: Text is displayed centered in the column.
  • Right: Text is justified on the right edge of the column.

Deactivate column filter in the Runtime

Active: The filter for this column cannot be changed in Runtime.

Note: Only available for:

  • Batch Control
  • Extended Trend
  • Filter screens
  • Message Control
  • Recipegroup Manager

User defined colors

Properties in order to define user-defined colors for text and background. The settings have an effect on the Editor and Runtime.

Note:

  • These settings are only available for configurable lists.
  • In addition, the respective focus in the list can be signalized in Runtime by means of different text and background colors. These are configured using the project properties.

User defined colors

Active: User-defined colors are used.

Text color

Color for text display. Clicking on the color opens the palette to select a color.

Background color

Color for the display of the cell background. Clicking on the color opens the palette to select a color.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


HTML

Manual -> Screens -> Screen types -> HTML

Makes it possible to display a screen in HTML. The Microsoft Web Browser Control currently installed on the computer is used as the rendering engine.

info Information

The possibilities for browsers are limited in Windows CE. Pages may not be displayed as expected.

Compatibility mode

The behavior of compatibility mode can be amended using the Windows Registry.

Example: Set compatibility mode for Internet Explorer 11:

  1. Navigate to the key HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION
  2. Add the following DWORD value: Zenrt32.exe
    (note capitalization)
  3. Set its decimal value to: 11001

Note: On a 64-bit computer, add the same DWORD value in the following key:

HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION


Creating a screen of the type HTML

Manual -> Screens -> Screen types -> HTML -> Creating a screen of the type HTML

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to create screen HTML:

  1. create a new screen
  2. select HTML as screen type
  3. an empty screen is created
  4. Click on Add template in the drop-down list
  5. The dialog for selecting a template is opened
  6. select the desired template
  7. Add further desired control elements as required.

Addresses for the navigation and the search are defined when function Screen switch is created.

HTML screen

Control element | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.
Browser | Control elements for the browser.
Browser Window | The browser is displayed.
Address field | Field for entry of the address (URL).
Home page | The start page is called up.
Search forward | Go forward.
Search back | Go back.
Refresh search | Refresh display.
Cancel | Stop navigation.
Search | Control elements for the search. When clicking a link in the Search field, the corresponding page is shown in the browser. So e.g. in the field Search a navigation bar or the results of a search engine can be displayed without changing the contents, when a link is activated.
Search window | Display of the search.
Search field | Search for address or file.
Start page | Back to home in the search area.
Forward | Page down in the search area.
Search back | Page up in the search area.
Refresh | Refresh display in search area.
Cancel | Cancel search action.
Filter | Open filterbox.


Screen switch to an HTML screen

Manual -> Screens -> Screen types -> HTML -> Screen switch to an HTML screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a function to call up an HTML screen:

  • Select New function.
  • Select Screen switching.
  • Select the HTML screen .
  • The configuration dialog is opened.
  • Configure the parameters for browser and search.
    The browser address can be statically configured or transferred from a variable.
  • Confirm the configuration by clicking on OK.

HTML screen switch function

Addresses

Parameters

Description

Addresses

Selection of the type of address entry for the home page:

  • Static URL: Enter a fixed address in the browser window or select from its drop-down list.
  • URL from variable: Selection of a variable in the Variable field, which transfers the address in Runtime.

Variable

Enter the variables that transfer the URL of the home page in Runtime. Click on button ... in order to open the dialog for selecting a variable. The variables can only be entered in the field directly.

Only available if, for Addresses, URL from variable has been selected.

Browser Window

Enter the URL that is to be opened in Runtime as a home page. Selection by means of a drop-down list or direct input in the field.

Only available if, for Addresses, Static URL has been selected.

Search window

Selection of the URL that is used for search in the Internet. Selection by means of a drop-down list or direct input in the field.

Progress

Parameters | Description
Progress | Number of addresses that are available for the drop-down list.
Search addresses | Number of addresses that are noted for the search range and are available in the drop-down list. Minimum: 0 Maximum: 20 Default: 10
Browser addresses | Number of addresses that are noted for the home page. Minimum: 0 Maximum: 20 Default: 10

General

Parameters

Description

Show this dialog in the Runtime
  • Active: Opens the dialog when the screen is opened in the Runtime. Settings can be amended.
  • Inactive: The settings made here are applicable in Runtime. These can no longer be amended.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Notepad

Manual -> Screens -> Screen types -> Notepad

With the notepad you can display text files and (optionally) edit them.


Creating screen Notepad

Manual -> Screens -> Screen types -> Notepad -> Creating screen Notepad

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The display size of the screen Notepad is taken from the frame size. The file which is opened must be determined during the definition of the Screen switch.

In order to create a Notepad:

  1. Select the Screens node in the project manager.
  2. Click on the top left in the detail view on the New screen symbol.

    Note: A screen is created automatically. You can change the properties of the screen in the property window.

  3. Issue a screen name.
  4. Select Notepad as the screen type
  5. An empty screen is created.
  6. Click, in the Control elements menu, on the Add template command.
  7. The dialog for selecting a template is opened.
  8. Select the desired template.

Control element | Action
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.
Notepad window | Displays the selected notepad.
Notepad functions | Control elements for using the notepad.
File... | Opens the dialog for selecting a file.
Refresh search | Refreshes the selected window.
Save | Saves the text file in the given folder.
Save as... | Opens the dialog for selecting a save path and name.
Close | Closes the current window.
Print | Prints the content of the notepad on the defined printer.
Print with dialog... | Opens the dialog to select a printer before printing.
Navigation |  | Control element for navigation.
Line up |  | Goes one line up in the text file.
Line down |  | Goes one line down in the text file.
Column right |  | Goes one column right in the text file.
Column left |  | Goes one column left in the text file.
Page up |  | Goes one page up in the text file.
Page down |  | Goes one page down in the text file.
Page right |  | Goes one page right in the text file.
Page left |  | Goes one page left in the text file.


Function screen switch to Notepad

Manual -> Screens -> Screen types -> Notepad -> Function screen switch to Notepad

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to create a function to switch to the screen Notepad:

  • select New Function
  • select Screen switch
  • select the screen Notepad
  • a dialog for defining the file which should be displayed is opened

Parameters | Description
File name | Selection of the file which is to be displayed Click on ... button to open the selection dialog. The file must have already been created in the project manager in the File/Texts and formats node. If no appropriate file has been created, you can select on in the dialog using symbol Add file. Allowed file types: TXT, HTM, HTML, FRM.
read only | Active: In the Runtime the text can only be read but not edited.


Operating during Runtime

Manual -> Screens -> Screen types -> Notepad -> Operating during Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following control elements are available:

Control element | Action
Notepad window | Displays the selected notepad.
Notepad functions | Control elements for using the notepad.
File... | Opens the dialog for selecting a file.
Refresh search | Refreshes the selected window.
Save | Saves the text file in the given folder.
Save as... | Opens the dialog for selecting a save path and name.
Close | Closes the current window.
Print | Prints out the content of the notepad on the defined printer.
Print with dialog... | Opens the dialog to select a printer before printing.
Navigation |  | Control element for navigation.
Line up |  | Goes one line up in the text file.
Line down |  | Goes one line down in the text file.
Column right |  | Goes one column right in the text file.
Column left |  | Goes one column left in the text file.
Page up |  | Goes one page up in the text file.
Page down |  | Goes one page down in the text file.
Page right |  | Goes one page right in the text file.
Page left |  | Goes one page left in the text file.


Video

Manual -> Screens -> Screen types -> Video

Video recordings - online and from saved data - can be shown in zenon with the use of a screen for video display and video recording. The format used is .avi.

Videos are played back in Runtime in the center of the assigned frame. They are controlled using control elements.

Note: The codec required to play back videos must be installed on the computer.

info Information

The control of videos integrated into notebooks via the manufacturer's driver does not always work properly with zenon. In this case:

  • Install a camera from a third-party provider
  • Then select the integrated camera as a source


Creating a screen of the type Video

Manual -> Screens -> Screen types -> Video -> Creating a screen of the type Video

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to create screen Video:

  1. create a new screen
  2. select Video as screen type
  3. an empty screen is created
  4. Click on Add template in the drop-down list
  5. The dialog for selecting a template is opened
  6. select the desired template

info Information

Add template adds pre-defined control elements to pre-defined locations in the screen. All control elements can be added, deleted and freely positioned. Other dynamic elements and vector elements can also be added.


Screen switch - video

Manual -> Screens -> Screen types -> Video -> Screen switch - video

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With screen Video you can display two types of videos in the Runtime:

  1. saved videos (*.avi)
  2. Videos of a surveillance camera

Which video is shown depends on which tab was shown when you saved the dialog.

info Information

If video files and online video should be displayed, create to screen switch functions.

In order to create a function to switch to the screen Video:

  • select New Function
  • select Screen switch
  • select the screen Video
  • a dialog for the definition of the video source opens.
    • Video file
    • Video online


Video file

Manual -> Screens -> Screen types -> Video -> Screen switch - video -> Video file

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The parameters needed for the display of screen Video for showing a surveillance camera are the following:

  • Set the video which should be shown
  • Settings for position, speed, volume and zoom factor of the display

Parameters | Description
AVI file | Saved video file to be displayed
Options and parameters |
Playbar | Display of a slider in the video screen.
Menu | Display of a menu in the playbar for operating the video (only possible with activated playbar)
Videopos centered | Reference point for the position of the video display in zooming actions. Active: The zoomed video is placed in the center of the frame. Inactive: The video display is zoomed to bottom right.
Autostart | Video file is automatically started when opening the screen
Continuous play | Video file is restarted after each end.
Speed | Playback speed in thousandths of the original speed. Default: 1000 (original speed)
Zoom | Zoom factor for correctly-proportioned zooming in or zooming out as a percentage of the original size. Default: 100 (original size)
Volume | Volume in thousandths of the original volume. Default: 1000 (original volume)
TimrFreq | Note: are not currently used. Timer Frequency. Default: 500


Video online

Manual -> Screens -> Screen types -> Video -> Screen switch - video -> Video online

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The parameters needed for the display of screen Video for showing a surveillance camera are the following:

  • Setting of the video driver
  • Setting of the recording options if the video should be recorded

Parameters | Description
Video - drivers | Selection of the video driver used. Note: the driver should support Microsoft Capturing.
Recording options | Options for the recording and saving of the video as an AVI-file or Bitmaps. If only online video should be displayed, there are no settings needed.
Name or abbreviation | Name of the file to be saved.
Generate name automatically | Name is automatically generated from the system time during recording.
Activate cap. Time limit | Time limit for the recording in seconds.
Format | AVI or BMP.
Autostart of recording | Recording is automatically started when the screen is displayed.
Use DOS buffers | Only relevant for 16-bit systems.
Frame Rate | Number of pictures per second for recording
Video buffers | Reserved buffer for video recording in MB
Max Drop Rate | Maximum amount of "drooped frames" in percent during recording. Value: 0 to 100 Default: 10
Video | Driver specific settings.
Views ... | Setting depends on the selected driver.
Format ... | Setting depends on the selected driver.
Compress ... | Setting depends on the selected driver.
Source ... | Setting depends on the selected driver.
Audio | Settings for the sound recording
Capture audio | Activates the sound recording.
Audio format | Driver specific settings.


Operating during Runtime

Manual -> Screens -> Screen types -> Video -> Operating during Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Videos are displayed as centered in the frame.

Control element | Description
Filter | Filter settings.
Control | Control elements to control the videos.
Play | Play video.
Cancel | Stop playback/resume playback.
Recording | Record video.
Pause | Stop video during playback.
Video online | Elements for controlling an online video.
Format | Output format.
Source | Data source.
Display | Display Video.
Compression | Data compression.
Video file | Elements for controlling a video file.
Magnification | Enlargement of the section.
Speed | Speed.
>> (forward) | Jumps one step (frame) further.
<< (back) | Jumps one step back.
Eject | Eject.


Screen Functions

Manual -> Screens -> Screen Functions

When the standard function is created from the context menu in the detail view, <CD_PRODUCTNANE> creates a function screen switch for the selected screen. Other functions can be configured using the Functions node and the New function command.


Screen with index

Manual -> Screens -> Screen Functions -> Screen with index

With this function, a screen is called up in Runtime whose name is defined by a string variable. The variable is selected with this function.

A string variable is to be selected from the list of variables as a transfer parameter.

Note for multiple-monitor systems: It is not possible to select monitors. The function always relates to the first monitor.


Close screen

Manual -> Screens -> Screen Functions -> Close screen

A defined screen in Runtime is closed with this screen. If, with a multiple-monitor projects, a screen is switched to several monitors, it is possible to select which screen is closed on which monitor.

To configure the function:

  1. Select, in the list of functions, in the Screens node, the Close screen function
  2. select the desired picture
  3. Select, with multiple-monitor projects, the virtual monitor on which the screen is to be closed from list:
    • All
    • Current monitor
    • Designated virtual monitor

Close screen

Parameters | Description
Close screen | Configuration of which screens are closed when the function is called up.
All screens with the name | All opened screens with the selected name are closed. Click the ... button and a dialog opens to select a screen. For further details, see the screen selection dialog section.
Calling screen | The calling screen is closed. This also happens if several screens with the same name are opened; only the screen from which the call comes is closed. With this option selected, the monitor selection cannot be configured manually. Recommendation: Suitable for closing pop-ups.

Monitor selection

Parameters

Description

Monitor selection

Configuration of the monitor for which the closing of the screen is to be configured.

Monitor

Selection of the monitor from the list.

  • All monitors
  • Current monitor
  • Selection of a virtual monitor
    (Note: the real monitors are displayed hen called up in Runtime.)

Only available for multi-monitor systems and only for the All screens with the name option.

Show this dialog in Runtime

Active: This dialog is opened in Runtime before the function is executed.

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Help

Opens online help.

Screen selection dialog

In the screens selection dialog, screens can be selected for the execution of functions from:

  • Current project
  • Subprojects
  • All projects in the workspace with the Keep project in memory option active

Parameters | Description
Project tree window | Displays all projects in the workspace. Screens can be selected from the current project and from all projects with the Keep project in memory option active
Screens window | Selection of the screen. If several screens are selected, the screen at the top of the list is used for the execution of the function.
No selection | Removes selection and closes dialog.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Screen: Return to last

Manual -> Screens -> Screen Functions -> Screen: Return to last

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function, it is possible to switch to the screen of a template previously called up and since closed during online operation. These screens that were previously open are administered in a buffer after they have been closed. When opened again, the same function that is used to to open the screen is executed once again. This means that screen filters are not saved but have to be recreated. By executing the Screen switching function, the screens of the corresponding frames are stored in the memory.

Attention: Each call of the screen switch function counts, even if the screen switch does not ensue directly but is entered in the screen properties as a start function.

To configure the function:

  1. Define the frames to be taken into account in the Main frames project property in the Graphical design/Runtime general group.
  2. Define the number of screens that are to be gone back by with the Anzahl f. Bild zurück Fkt. project property in the Functions group.
  3. Configure the Screen: Return to last function.
    In the selected functions function, Main frames must also be selected in the project property.
    Note for multiple-monitor systems: It is not possible to select monitors. The function always relates to all monitors.

info Information

A screen is only entered into the previous screen list if it is closed. Templates that are open in the background are not considered closed screens however. If screens are switched in several templates above one another, then the previous screen list remains empty because all screens are still open.

Hint: In general, never place the templates directly above one another.

Delete path

The path-back screen can be deleted in Runtime:

  • Automatically when the user is changed using the DelPicBackPathAtLogout project property in the User administration group.
  • Individually by configuring the Delete path-back screen function.


Delete path for "Screen: Return to last"

Manual -> Screens -> Screen Functions -> Delete path for "Screen: Return to last"

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

with this function, the path of the Screen: Return to last function can be deleted in Runtime.

To configure the function:

  1. Select, in the list of functions, in the Screen: Return to last node, the Delete path-back screen function.
  2. The function is created.
  3. Link the function to a button in the screen.

Note: The Screen-back path can also be deleted automatically in Runtime in the event of a user change. To do this, the DelPicBackPathAtLogout project property in the User administration group must be configured.


Screen: Move center

Manual -> Screens -> Screen Functions -> Screen: Move center

With this function, the screen center can be moved or the zoom factor can be changed in worldview function.

Requirements:

  • The screen must be larger than the monitor resolution
  • In the screen properties, the Screen size from frame must be deactivated in the Frame group
  • The size must be defined using the Width [pixels] and Height [pixels] properties

info Information

This function is not available under Windows CE.

Screen center and zoom dialog

Parameters | Description
Screen | Selection of the screen for the new center Clicking on the button opens the dialog to select the screen.
Select screen center | Settings for the screen center
Object name | Set desired center of the screen via an object from the object list
Coordinates | Enter desired screen center in coordinates (x,y)
Set zoom steps | Settings for the zoom factor.
in % | Set desired zoom factor in percent.
Step | Set desired zoom factor via the defined zoom steps.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Applies settings and closes the dialog.

Note: If the Worldview is called up several times, this function is only applied to the last screen called up.


Screen switch

Manual -> Screens -> Screen Functions -> Screen switch

The screen switch function makes it possible to switch between process screens in runtime

Example Example

In a project, there is a Start screen and a screen of type Alarm Message List. During runtime, it should be possible to switch between these two screens. So, for example, a button is created in the Start screen and a function of type screen switching in the Alarm Information list screen. After this, the function is linked to the button, for example by dragging & dropping. Now during runtime, the Start screen can be left by pressing the button and the Alarm Message List can be switched on.

Configure screen switching

To configure the function:

  1. Create a new function
  2. navigate to node Screens
  3. Select the Screen switch function
  4. The dialog for selecting a screen is opened
  5. Select a screen
  6. The dialog to replace variables and functions is opened
  7. Close the dialog by clicking on OK
  8. Allocate a button to the function

Screen selection dialog

In the screens selection dialog, screens can be selected for the execution of functions from:

  • Current project
  • Subprojects
  • All projects in the workspace with the Keep project in memory option active

Parameters | Description
Project tree window | Displays all projects in the workspace. Screens can be selected from the current project and from all projects with the Keep project in memory option active
Screens window | Selection of the screen. If several screens are selected, the screen at the top of the list is used for the execution of the function.
No selection | Removes selection and closes dialog.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Activate input to the element with the focus

Manual -> Screens -> Screen Functions -> Activate input to the element with the focus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function activates the element that is being focused on in the frame selected.


Set focus to frame

Manual -> Screens -> Screen Functions -> Set focus to frame

This function sets the focus to a defined frame when operating the keys in Runtime.

To configure the function:

  1. Select, in the list of functions, in the Screens node, the Set focus to frame function
  2. The dialog for selecting a screen is opened
  3. select the frame you wish to assign
  4. For multi-monitor projects, select the virtual monitor for opening the frame

The frame with a focus is displayed with a frame in runtime. The line width and color of the frame are defined in the Graphical design/Screens node in project properties.

Frame selection dialog

In the frame selection dialog, frames can be selected for the execution of functions, from:

  • Current project
  • Subprojects
  • All projects in the workspace with the Keep project in memory option active

Parameters | Description
Project tree window | Displays all projects in the workspace. Frames can be selected from the current project and from all projects with the Keep project in memory option active
Frames window | Selection of a frame. If several frames are selected, the frame at the top of the list is used to execute the function.
No selection | Removes selection and closes dialog.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.

Set focus on frame with multiple frames called up

If a frame is displayed on a monitor several times, then the focus is switched in the reverse of the switching sequence each time the functions of the focus are executed. If, for example, with a frame that is called up several times, the screens Screen1, Screen2 and Screen3 are open and then the focus is set to this frame, the focus goes to the last screen opened, Screen3. When the Set focus to frame function is called up again, the focus is set to Screen2 etc.


Move focus

Manual -> Screens -> Screen Functions -> Move focus

This function set the focus on a particular element in runtime with keyboard operation and can therefore be used to navigate within a frame.

Property | Action
Direction | Define the direction in which the focus should be moved. The following defined sequence applies in the editor in the context menu or under Edit/change focus sequence...
on the element | Definition of the element for the focus. Enter the object name of the element.


Take focus away from frame

Manual -> Screens -> Screen Functions -> Take focus away from frame

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function takes the focus from the current frame in runtime. To continue operating the keyboard, the focus must be set to a frame again.


Show menu

Manual -> Screens -> Screen Functions -> Show menu

This function controls the display of main menus.

  1. Create a new function with New function
  2. In the Screens node, select the Display menu function
  3. Define the action to be carried out and the main menu

Parameters | Description
Action | Selection of the action:
Show menu | The selected menu is displayed.
Hide menu | The selected menu is hidden.
Change menu | The current menu is hidden and the selected menu is displayed instead.
If no menu exists | The selected menu is displayed, if no menu is displayed at the moment.
Menu | Selection of menu.
Show this dialog in the Runtime | Active: This dialog is opened when the function is carried out in Runtime.


Monitor assign

Manual -> Screens -> Screen Functions -> Monitor assign

In a multi-monitor-environment you can assign a certain virtual monitor to a single real monitor.


Move frame to foreground

Manual -> Screens -> Screen Functions -> Move frame to foreground

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function, screens that are covered by other screens in Runtime can be moved to the foreground. A frame is selected - and a monitor assignment if multiple monitors have been configured. In Runtime, when executed, all instances of the defined frame are moved to the foreground of the selected monitor. This function is mainly useful for screens and frames that are called up with a title bar.

To configure the function:

  1. in the context menu of the function node, select New function
  2. Open the Screens node in the selection dialog.
  3. Select the Move frame to foreground function.
  4. The dialog for selecting a frame is opened
  5. Highlight the desired frame and confirm them by clicking OK
  6. Link the function to a button.

Selection dialog for frame

Parameters

Description

Project tree window

Displays all projects in the workspace. Frames can be selected from the current project and from all projects with the Keep project in memory option active.

Frames window

Selection of a frame.

If several frames are selected, the frame at the top of the list is used to execute the function.

No selection

Removes selection and closes dialog.

Monitor

For multi-monitor systems, the selection of the monitor for which this function is configured from a drop-down list:

  • All monitors
  • Current monitor
  • Designated virtual monitor

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Help

Opens online help.


Close frame

Manual -> Screens -> Screen Functions -> Close frame

With this function, the selected frame with all screens that are based on it are closed. In contrast to the Close screen function, the precise screen name need not to be given in this case. If, with a multiple-monitor projects, a frame is switched to several monitors, it is possible to select which frame is closed on which monitor.

To configure the function:

  1. Select, in the list of functions, in the Screens node, the Close frame function
  2. select the frame you wish to assign
  3. Select, with multiple-monitor projects, the virtual monitor on which the frame is to be closed, from the drop-down list:
    • All
    • Current monitor
    • Designated virtual monitor

Close frame

Parameters | Description
Close frame | Configuration of which frames are closed when the function is called up.
All frames with the name | All opened frames with the selected name are closed. Click on the ... button to open the dialog to select a frame. For details, see the Frame selection dialog section.
Calling frame | The calling frame is closed. This also happens if several frames with the same name are opened; only the frame from which the call comes is closed. With this option selected, the monitor selection cannot be configured manually.

Monitor selection

Parameters

Description

Monitor selection

Configuration of the monitor for which the closing of the frame is to be configured.

Monitor

Selection of the monitor from the list.

  • All monitors
  • Current monitor
  • Selection of a virtual monitor
    (Note: the real monitors are displayed hen called up in Runtime.)

Only available for multi-monitor systems and only for the All frames with the name option.

Show this dialog in Runtime

Active: This dialog is opened in Runtime before the function is executed.

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Help

Opens online help.


Frame selection dialog

Manual -> Screens -> Screen Functions -> Close frame -> Frame selection dialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the frame selection dialog, frames can be selected for the execution of functions, from:

  • Current project
  • Subprojects
  • All projects in the workspace with the Keep project in memory option active

Parameters | Description
Project tree window | Displays all projects in the workspace. Frames can be selected from the current project and from all projects with the Keep project in memory option active
Frames window | Selection of a frame. If several frames are selected, the frame at the top of the list is used to execute the function.
No selection | Removes selection and closes dialog.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Print screenshot

Manual -> Screens -> Screen Functions -> Print screenshot

This function is used to make a screenshot of the entire screen or of frames (process screens, lists, trend curves, etc.) in the Runtime.

Give the frame and the additional options as the transfer parameters. This function is configured via the following dialog.

Property

Description

Selected print area

Display of the selected area.

Define print area

Selection of the area which should be printed.

Total screen area

Prints screenshot of the whole screen. For multi-monitor systems the contents of the standard monitor is printed.

Frame list

Only available if the Total screen area property is inactive.

Select the desired frame via double click. It is displayed in field Selected print area.

Note: If the selected frame is not active during Runtime, nothing is printed.

Monitor

Only available if a frame has been selected and the Total screen area property is inactive.

Select the desired monitor from the drop-down list:

  • All
  • Current monitor
  • Designated virtual monitor

Note: If you have selected a frame which covers more than one screen , you must select current monitor in order to print the whole frame.

Print options

With margin

At printing a margin is left for tacking.

Inverted

Reverses bright/dark areas.

Fax

The hardcopy is rerouted to the fax. For this you must select a fax device as printer for screenshots in the Printer settings.


Setpoint input for keyboard screen

Manual -> Screens -> Screen Functions -> Setpoint input for keyboard screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Setpoint input for keyboard screen function is not available for the keyboard screen. In addition the text field Set value must have been created. It makes it possible to set or set and send a previously defined value.

Parameters | Description
Setpoint input | Input of the target value.
Action | Selection of action from drop-down list. (for possible actions, see the following table.)
OK | Accepts inputs, closes dialog and creates functions with value and action.
Cancel | Discards inputs, closes dialog and creates functions without setpoint and action.
Help | Opens online help.

Actions in the drop-down list:

Action

Description

Suggest value

The setpoint default is written to the keyboard screen.

Accept value

The following happens:

  • the set value default is written to the keyboard screen
  • The keyboard screen is closed with OK

RGM: Accept and send value

If the keyboard screen is called up from the Recipe Group Manger recipe table, then:

  • The setpoint default is written to the keyboard screen
  • The keyboard screen is closed with OK
  • The recipe value is written to the variable

RGM: Accept value and save recipe

If the keyboard screen is called up from the Recipe Group Manger recipe table, then:

  • The setpoint default is written to the keyboard screen
  • The keyboard screen is closed with OK
  • The recipe is saved

RGM: Write and send value and save recipe

If the keyboard screen is called up from the Recipe Group Manger recipe table, then:

  • The setpoint default is written to the keyboard screen
  • The keyboard screen is closed with OK
  • The recipe value is written to the variable
  • The recipe is saved


Show overview window

Manual -> Screens -> Screen Functions -> Show overview window

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Show overview window function displays the overview window in Runtime, which shows the real monitors or frames in a multi-monitor system. A monitor and/or a frame can be activated by means of a mouse click.

To configure the function:

  1. Create a new function
  2. navigate to node Screens
  3. Select the Show overview window function
  4. the dialog for configuring the overview window is opened
  5. Select your configuration
  6. Close the dialog by clicking on OK
  7. Allocate a button to the function

Displaying the overview window

Settings

Parameters | Description
Settings | The function can either open, close or toggle the overview window. Selection is carried out by means of radio buttons:
Display | The overview window is opened.
Toggle | The display is switched between open and closed.
Close | The overview window is closed.

Display of

Parameters | Description
Display of | Selection of display in the overview window. Either frames or monitors are displayed.
Frames | The overview window divides the screen into frames.
Monitors | The overview window divides the screen into monitors.
Position | Position of the overview window on the screen, calculated in pixels from the upper left edge.

Window style

Parameters | Description
Window style |
with title | Active: The overview window has a Windows title bar.
System menu | Active: A system menu is displayed if the title bar is activated.
with border | Active: Overview window is displayed with a border. The window size can be adjusted in Runtime by dragging the border. Selection of the border width by means of radio buttons:
fine | Bold border.
bold | Fine border.

Color

Parameters | Description
Color | Definition of the colors in the overview screen. Clicking on Color opens the palette.
Background color | Color of window background
current view | Currently displayed frames/monitors.
Border | Color of border.
Selected | Selected frames/monitors.
OK | Accepts settings, closes dialog and creates functions with assignment.
Cancel | Discards settings, closes dialog and creates functions with standard settings.
Help | Opens online help.


Standard Recipes

Manual -> Standard Recipes

Recipes collect set values and commands in a list which can be executed in the Runtime with the help of a function.

Recipes can be engineered either in the Editor or in the Runtime (with the help of screen Recipe standard).

A collection of several recipes is created and administrated with the help of the Recipegroup Manager.

tutorial License information

Part of the standard license of the Editor and Runtime.

Project manager context menu

Menu item | Action
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.


Engineering in the Editor

Manual -> Standard Recipes -> Engineering in the Editor


Context menu Project manager

Manual -> Standard Recipes -> Engineering in the Editor -> Context menu Project manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Menu item | Action
Recipe new | Creates a new recipe in the list and opens the name for editing.
Export XML all.. | Exports all entries as an XML file.
Import XML | Imports from an XML file.
Import ASCII | Imports from an ASCII file.
Editor profile | Opens the drop-down list in which you can allocate an Editor profile.
Help | Opens online help.


Context menu detail view

Manual -> Standard Recipes -> Engineering in the Editor -> Context menu detail view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tool Bar

Menu item | Action
Recipe new | Creates a new recipe in the list and opens the name for editing.
Create standard function | Opens the dialog for selecting a recipe and an action and creates a suitable function. The action is documented in the output window.
Add variable | Opens the dialog for selecting variables.
Jump back to starting element | If you entered the list via function linked elements, the symbol leads back to the start element. Only available in the context menu when all linked elements are opened.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the content from the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of".
Delete | Deletes selected entries.
Move up | Moves the entry up one place in the recipe list.
Move down | Moves the entry down one place in the recipe list.
Edit set value | Activates cell Set value in order to insert a value.
Export selected XML | Exports selected entries as an XML file.
Import XML | Imports from an XML file.
Export selected ASCII | Exports selected entries as an ASCII file.
Import ASCII | Imports from an ASCII file.
Rename | Makes it possible to rename the selected recipe. It is also possible by left-clicking the field with the mouse or by pressing F2.
Properties | Opens the property window.
Help | Opens online help.

Context menu tree in detail view

Menu item | Action
Add variable | Opens the dialog for selecting variables.
Recipe new | Creates a new recipe in the list and opens the name for editing.
Create standard function | Opens the dialog for selecting a recipe and for the definition of the desired action
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the content from the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of".
Delete | Deletes selected entries.
Export selected XML | Exports selected entries as an XML file.
Import XML | Imports from an XML file.
Export selected ASCII | Exports selected entries as an ASCII file.
Import ASCII | Imports from an ASCII file.
Rename | Makes it possible to rename the selected recipe. It is also possible by left-clicking the field with the mouse or by pressing F2.
Properties | Opens the property window.
Help | Opens online help.

Context menu details

Menu item | Action
Add variable | Opens the dialog for selecting variables.
Delete variable | Deletes selected variable after a confirmation message.
Move up | Moves selected variable up on place.
Move down | Moves selected variable down on place.
Edit set value | Opens the cell with the set value in order to change it.
Remove filter | Removes all current filter settings.
Help | Opens online help.


Create Standard Recipe screen type

Manual -> Standard Recipes -> Engineering in the Editor -> Create Standard Recipe screen type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The handling of the recipes in the Runtime is realized with a screen of the screen type Standard recipe. This screen must be created in the editor first.

After the screen is opened an empty screen is displayed. You can add the default control elements via menu Control elements ->Add template. Changes that have been done successfully can be logged in the Chronological Event List.

Parameters

Description

Insert template

Opens the dialog for selecting a template for the screen type.

Templates are shipped together with zenon and can also be created by the user.

Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.

Buttons

Recipe new

Create a new recipe

Save recipe

Save current recipe under the same name

Read recipe from PLC

The values of the variables of the selected recipe are read from the process and entered into the table. Changes have to be saved!

Duplicate recipe

Copy current recipe.

Delete recipe

Delete current recipe

Edit recipe

Edit the current recipe.

Export Recipe

Save current recipe as *.txt

Import Recipe

Load current recipe from *.txt

Write recipe

The values of the variables of the selected recipe are written to the process as displayed in the table.

Next recipe

Move to the next recipe

Last recipe

Move to the last recipe

Previous recipe

Move to the previous recipe

first recipe

Move to the first recipe

All values ++

All values of the selected recipe are increased by 1

All value - -

All values of the selected recipe are decreased by 1

Add variable ...

Add a variable to the selected recipe It is also possible to use variables of other loaded projects.

Remove variable

Remove the selected variable from the recipe

Edit set value

Change the value of the selected variable in the recipe A decimal value can be entered with a colon as well as with a point, the decimal point will automatically be changed to a point.

Attention: If this element does not exist in the screen, the recipes in the list element are displayed read-only.

General

Recipe name

Name or selection of the current recipe

Recipe window

Display of the current recipe in a table

Writing progress

Progress bar, indicating the writing of the recipe.

The control element displays the progress bar from bottom to top or from left to right depending on the location and form of the element.

The control element is hidden in the Runtime and is only displayed during the writing of the recipe.

Note: The control element is only displayed if property Write synchronously is active.

Synchronous writing:

If property Write synchronously is active, the control element writing progress is displayed if a recipe is written to the control until the writing confirmation arrived at the recipe module. It does not matter whether the writing confirmation is positive or negative. If you want to react to a negative writing confirmation, you can do this with the help of a reaction matrix.

info Information

Buttons can be protected with password and authorization level. For details see Operation in Runtime chapter.


Create a new recipe

Manual -> Standard Recipes -> Engineering in the Editor -> Create a new recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to create a new recipe, select New Recipe from the context menu of the folder Recipes / Standard recipes in the Project manager. The newly created recipe is displayed in the detail view of the Project Manager. Further definitions are also realized in the Detail view.


Adding variables to a recipe

Manual -> Standard Recipes -> Engineering in the Editor -> Adding variables to a recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

After creating a new recipe variables can be added to the recipe.

attention Attention

String variable cannot be written to the PLC with a standard recipe. For string variables use the Recipegroup Manager.

Variables are selected in the dialog 'Filter: Variable selection'. The variables are applied either by double clicking them or by clicking button Add. Multi-select is possible. Varialbes from loaded sub-projects can be used. All variables added to a recipe must not be read-only. If the definitions of variables are changed (scaling), also the defined values of the recipes are changed accordingly.

info Information

A decimal value can be entered with a colon as well as with a point, the decimal point will automatically be changed to a point.

Sorting variables

You can sort variables any way you like:

Select the variable that you want to change the sequence of and choose one of the following actions:

  • use arrow buttons in the lower right corner to move items
  • choose" Up" or "Down" in the context menu

Context menu Variable view

Parameters | Description
Add variable | Opens the dialog to select variables.
Delete variable | Deletes selected variables from the list after confirming a warning message.
Move up | Moves selected variable up on place.
Move down | Moves selected variable down on place.
Edit set value | Activates cell Set value and highlights the current set value.
Remove all filters | Removes all set filter.
Help | Opens online help.


Editing set values

Manual -> Standard Recipes -> Engineering in the Editor -> Editing set values

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to edit the set values of the variables you can either select Edit set value from the context menu or you can change it directly in the column set value. For the checking of the setpoint value the technical minimum and maximum values for each variable are displayed with it. Multi-select is avaibale for deleting variables, but not for editing variables.

The variable '_LASTRECIPE' includes the name of the last executed standard recipe.

This allows to realize a recipe administration, as this variable at any time offers information, which recipe is active at the moment.

The variable '_LASTNEWRECIPE' includes the name of the last created standard recipe.

The variables "_LASTRECIPE" and "_LASTNEWRECIPE" can be based on any driver and must be writeable.

attention Attention

Exceptions:

The Variable “_LASTRECIPE” cannot be realized with the Standard System Driver.

The Variable “_LASTRECIPE” cannot be realized with the Standard System Driver.


Check write set value

Manual -> Standard Recipes -> Engineering in the Editor -> Editing set values -> Check write set value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When writing values, the value receives a status bit that is has been written. If the writting process is successful, the corresponding status bit is set:

  • WR-ACK

    The driver received a value for writing.

  • WR-SUC

    Value 1: Writing successful.

    Value 0: Writing not successful. The value could not be written.

info Information

In case of reload or Server-Standby switch, the currently active responses or writing affirmations are discarded.

This status combination are active until the next value change is triggered. Then both states are set to 0 until the writing action is finished. For evaluation the following bit combination must be requested in the reaction matrix:

WR-ACK, WR-SUC

Result:

  • WR-ACK 1, WR-SUC 1: Writing action successful.
  • WR-ACK 1, WR-SUC 0: Writing action not successful.

attention Attention

The mechanism only shows, that the writing action was successful (or not successful) to the PLC. This does not mean, that the value has indeed been changed in the PLC, since the PLC can reset/overwrite the value immediately. (For example for writing the outputs or the transient bits which are only set for a short time.)

Modules

This mechanism can be used in the following modules:

  • function Write set value: Activate option Wait for writing confirmation in the configuration dialog of the function.
  • Standard recipes: Activate property Write synchronously.
  • Recipegroup Manager: Activate property Write synchronously.
  • Command Processing

Entry in CEL

  • Function Write set value

    For the entry in the CEL you must activate property Function Set SV in node Chronological Event List in the project settings. After this the positive or negative response the execution of the function is written to the CEL.

  • Standard recipes and Recipegroup Manager

    For the entry in the CEL a system driver variable is used which is set to 1 when a recipe is written successfully. A global variable is evaluated on the Server, a local variable on every Client in order to determine when the recipe executed last was written completely.
    With this variables a CEL entry can be created via limit or reaction matrix. The query is carried out via a multi analog or a multi binary reaction matrix.


Write recipes

Manual -> Standard Recipes -> Engineering in the Editor -> Write recipes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The execution of the recipe can happen:

  • in the Runtime via a button in screen Recipe standard,
  • via calling up a function engineered in the Editor for the recipe execution via:
    • Script (e.g. AUTOSTART-Script)
    • Variable status
    • Dynamic screen element e.g. Button


Function screen switch standard recipe

Manual -> Standard Recipes -> Function screen switch standard recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Function screen switch to a standard recipe makes it possible to call up a screen of type standard recipe in the Runtime.

To engineer the function:

  1. create a new function
  2. select screen switch
  3. select the deleted screen of type Standard recipe
  4. the filter dialog opens for
    • Recipe selection
    • Column settings
  5. define recipe and column settings
  6. Close the dialog by clicking on OK


Tab Recipe selection

Manual -> Standard Recipes -> Function screen switch standard recipe -> Tab Recipe selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters

Description

Recipes

Selection of the recipe which should be displayed when the screen is called up.

Show this dialog in the Runtime

active: In the Runtime this dialog is displayed at the screen switch. The selected recipe can be changed.

inactive: The screen is opened with the recipe defined in the Editor. No possibility for change in the Runtime.


Tab column settings

Manual -> Standard Recipes -> Function screen switch standard recipe -> Tab column settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Here you define which columns are displayed in what form in the list field.

Parameters | Description
Available columns | Definition of the columns displayed in the Runtime.
Parameters | Definition of the properties for highlighted columns.
Labeling: | Label of the columns in the Runtime.
Width: | Width of the column in pixels.
Alignment: | Text alignment of the column.


Operating during Runtime

Manual -> Standard Recipes -> Operating during Runtime

In online operation the following functions are available for script use:

Parameters | Description
Single recipe direct | Direct despatch of the activated recipe
Single recipe with offline dialog | Changing of the parameters of the activated recipe
Single recipe with online dialog | Selection of a recipe and changing of its parameters

By using the function Recipe single with offline dialog the recipe mask is opened.

The control buttons are:

Parameters

Description

Save

Save changes in the recipe

Close

Close recipe settings.

Send

Send recipe to the hardware with the current parameters.

Add variable

Add new variable with the variables list.

Remove variable

Temporary deletion of the selected variable from the recipe (permanently deleted if recipe is saved).

Edit set value

Change set value of selected variable.

A decimal value can be entered with a colon as well as with a point, the decimal point will automatically be changed to a point.

Attention: If this element does not exist in the screen, the recipes in the list element are displayed read-only.

By using the function Recipe single with online dialog, the recipe and the parameters of the recipe can be selected and changed. The recipe selection is opened. The operation is similar to the parametrization in the Editor with the exception that recipes cannot be deleted.

info Information

In case of reload or Server-Standby Switch, the present responses or writing affirmations are distorted.

You will find more information on changed Runtime files in the chapter Project and Workspace / RT changeable files.

Authorization in Runtime

Actions in the Runtime can be protected with password and authorization level:

  • When recipes are deleted, saved, changed or duplicated, the logged in user has to fulfil the authorization requirements that have been set in the authorization level section of the recipe. If the user does not fulfill the authorization requirements, the function is not executed.
  • At password-protected button Change set value the value in the list can only be changed if the user has the respective authorization level. If this is not the case the dialog for login is opened for active temporary login as soon as a column for changing a value is clicked.
  • If button Save changes is protected with a password and the user does not have the necessary authorization level, the dialog for temporary login is opened after a recipe change when the dialog is closed in order to make saving of the changes possible.


Recipe - Functions

Manual -> Standard Recipes -> Operating during Runtime -> Recipe - Functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to alloww operation in the Runtime, the according recipe functions have to be created.

When the standard function is created from the context menu in the detail view, zenon automatically creates a function Standard recipe for the selected recipe.


Single recipe

Manual -> Standard Recipes -> Operating during Runtime -> Recipe - Functions -> Single recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The individual recipe functions are available in three versions:

  • Single recipe direct
  • Single recipe with offline dialog
  • Single recipe with online dialog

Single recipe direct

This function is used to execute a defined recipe in the Runtime. In a recipe only process variables of one driver can be selected.

Give the recipe as a transfer parameter. This function is configured via an input dialog.

Single recipe with offline dialog

This function is used to change a defined recipe, before it is executed in the Runtime (set value change).

Give the recipe as a transfer parameter. This function is configured via an input dialog.

The new recipe is available in the recipe list.

Only the set value setting of the recipe is activated during online operation.

Possible operations in Editor and Runtime are:

Parameters | Description
Add variable | add a new variable to the recipe
Remove variable | remove a variable from the recipe
Edit set value | change the values of the recipe

Single recipe with online dialog

This function is used to select and change a recipe before it is issued during online operation (change of set value).

Give the recipe as the transfer parameter. This function is configured via an input dialog.

In the Runtime the recipe selection is opened.

Configurable entries are

Parameters | Description
New | create a new recipe
Copy | copy selected recipe and save it under a new name
Change | Change the name of the selected recipe
Delete | delete selected recipe

The new recipe is available in the recipe list.

Configurable options are:

Add variable | add a new variable to the recipe
Remove variable | remove a variable from the recipe
Edit set value | change the values of the recipe

In order to prevent changes to the recipe entries and at the same time permit selection of the individual recipes during online operation, make an entry in the zenon6.ini file.

[FUNKTIONEN] |
REZEPT_AENDERN= | 0: change not permitted 1: 1: change permitted (default)


Standard recipe

Manual -> Standard Recipes -> Operating during Runtime -> Recipe - Functions -> Standard recipe

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function an existing recipe can be executed, read from the hardware or exported in the Runtime. Additionally new recipes can be imported or created with the current values from the hardware.

To create the function:

  1. create a new function
  2. in the Recipes node, select the Display menu function
  3. the dialog for the recipe selection is opened
  4. on tab Recipe selection select the recipe which should be called up
  5. on tab Action to be executed you define the action which should be carried out in the Runtime

Recipe selection

Parameters | Description
Select recipe | Selection of the recipe that should be read or written
Recipe name from variable | The name of the recipe that should be read or written is given by the selected variable. Attention: In the Runtime the string variable has to contain a valid recipe name e.g. Recipe_4 before execution. Otherwise the function will not be executed.

Action to be executed

Parameters | Description
Write values | The values of the variables of the selected recipe are written to the PLC.
Read values | The values of the variables of the selected recipe are read from the PLC and replace the current values in the recipe.
Duplicate recipe | The source recipe creates a copy of itself with the name of the target recipe. The name of the duplicated recipe is not stored in the variable _LASTNEWRECIPE. For details about configuration see chapter Duplicate recipe.
Export Recipe | Exports recipe. For details about configuration see chapter Export recipe.
Import Recipe | Imports recipes from file or variable. For details about configuration see chapter Import recipe.
Show this dialog in the Runtime | Offer dialog in the Runtime in order to change settings.

Duplicate recipe

Parameters

Description

Select target recipe

Selection of an existing recipe, which should be overwritten with the data of the source recipe.

Attention: The data of the target recipe are overwritten.

New Recipe

(Generate name)

A new recipe is created according to the standard syntax. With this gaps in the recipe order are filled up automatically.

Example: Recipe_0 and Recipe_2 already exist. Duplicating the first time creates a recipe with the name Recipe_1. Duplicating a second time creates a recipe with the name Recipe_3.

Target recipe from variable

The name of the target recipe is defined by the contents of a string variable.

Note: If the string variable of the target recipe does not contain text, a recipe name is given automatically.

Export Recipe

Parameters | Description
Generate file name automatically | The filename is created automatically.
Define file name | Click on the ... button to open the dialog to select a folder and give it a name.
File name from variable | The name of the file is defined by the contents of a string variable.

Import Recipe

Parameters | Description
Define file name | Click on the ... button to open the dialog to select a folder and a file.
File name from variable | Recipe is imported from linked variable


Status information for recipes and recipegroup manager

Manual -> Standard Recipes -> Operating during Runtime -> Status information for recipes and recipegroup manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Runtime status information is provided at

  • Read/write
  • Export/Import
  • Saving

If a recipe written, this variable contains the result of the writing operation.

Values

Write recipe

System driver variable Standard recipe/RGM recipe completely written

Value | Result
0 | Send initialization value before the recipe
1 | Write completed successfully
2 | Write not executed because of a parameter error
3 | Write not completed successfully
5 | Write terminated because RT is being ended
6 | Timeout occurred

Note: If the network functionality is active in the project, the system driver variable Standar recipe/RGM recipe completely written (local) is relevant for the function executed on the local computer.

info Information

Writing means writing to the driver. The driver then transfers the recipe to the control. That means:

  • Property Write synchronously inactive: Value 1 for Standard recipe/RGM recipe written completely does not mean that the values are available in the control. They are written on the driver.
  • Write synchronously property active: The value change take place when all values on the control are topical.

Note: The progress display at writing is only display if property Write synchronously is active.

Recipe in progress

System driver variable Standard recipe/RGM recipe function in progress

Value

Result

-1

is being executed

0

Initialization value read successfully

1

User has no authorization

2

no authorization in the network

3

chancel by user

4

Error - could not read everything successfully, e.g.

  • Communication with the hardware is interrupted before read was started
  • a data block is not available on the PLC
  • Error during transmission

5

Error during save of the recipe file

6

Function cancelled via VBA

Screen type specific functions

During

  • reading (system driver variable: Standard recipe/RGM recipe reading all values finished
  • Exporting/Importing and
  • Saving

of a recipe via screen specific function - the following values are available:

Value

Result

0

Initialization value waits for response from driver

1

read successfully

2

Error during Read, Export/Import or Save:

  • Communication with the hardware is interrupted before read was started
  • a data block is not available on the PLC
  • Error during transmission


Status processing

Manual -> Status processing

With the status administration you get a better overview in the process and in the network. Each variable can have its own statuses. Altogether there are 64 states/attributes. The most common are spontaneous, invalid, manual value and replacement value.

Each stored value in zenon consists of three parts of information: value, time stamp and status. That means, that for each archived value also the status is stored.

In the Runtime there are several possibilities to evaluate the status of a variable, as for example: the combined element, the reaction matrices and the Report Generator. The status is also accessible in VBA or VSTA as well as in the recipegroup manager.

tutorial License information

Part of the standard license of the Editor and Runtime.


Status bits

Manual -> Status processing -> Status bits

The following status bits are available in zenon:

Bit number | Short term | Long name | zenon Logic label
0 | M1 | User status 1 | _VSB_ST_M1
1 | M2 | User status 2 | _VSB_ST_M2
2 | M3 | User status 3 | _VSB_ST_M3
3 | M4 | User status 4 | _VSB_ST_M4
4 | M5 | User status 5 | _VSB_ST_M5
5 | M6 | User status 6 | _VSB_ST_M6
6 | M7 | User status 7 | _VSB_ST_M7
7 | M8 | User status 8 | _VSB_ST_M8
8 | NET_SEL | Select in the network | _VSB_SELEC
9 | REVISION | Revision | _VSB_REV
10 | PROGRESS | In operation | _VSB_DIREC
11 | TIMEOUT | Runtime exceedance | _VSB_RTE
12 | MAN_VAL | Manual value | _VSB_MVALUE
13 | M14 | User status 14 | _VSB_ST_14
14 | M15 | User status 15 | _VSB_ST_15
15 | M16 | User status 16 | _VSB_ST_16
16 | GI | General interrogation | _VSB_GR
17 | SPONT | Spontaneous | _VSB_SPONT
18 | INVALID | Invalid | _VSB_I_BIT
19 | T_CHG_A | Daylight saving time/winter time announcement | _VSB_SUWI
20 | OFF | Switched off | _VSB_N_UPD
21 | T_EXTERN | Real time external | _VSB_RT_E
22 | T_INTERN | Realtime internal | _VSB_RT_I
23 | N_SORTAB | Not sortable | _VSB_NSORT
24 | FM_TR | Error message transformer value | _VSB_DM_TR
25 | RM_TR | Working message transformer value | _VSB_RM_TR
26 | INFO | Information for the variable | _VSB_INFO
27 | ALT_VAL | Alternate value If no value was transferred, the defined alternate value is used otherwise the last valid value is used. | _VSB_AVALUE
28 | RES28 | Reserved for internal use (alarm flashing) | _VSB_RES28
29 | N_UPDATE | Not updated | _VSB_ACTUAL
30 | T_STD | Standard time | _VSB_WINTER
31 | RES31 | Reserved for internal use (alarm flashing) | _VSB_RES31
32 | COT0 | Cause of transmission bit 1 | _VSB_TCB0
33 | COT1 | Cause of transmission bit 2 | _VSB_TCB1
34 | COT2 | Cause of transmission bit 3 | _VSB_TCB2
35 | COT3 | Cause of transmission bit 4 | _VSB_TCB3
36 | COT4 | Cause of transmission bit 5 | _VSB_TCB4
37 | COT5 | Cause of transmission bit 6 | _VSB_TCB5
38 | N_CONF | Negative acceptance of Select by device (IEC 60870) | _VSB_PN_BIT
39 | TEST | Test bit (IEC870 [T]) | _VSB_T_BIT
40 | WR_ACK | Writing acknowledged | _VSB_WR_ACK
41 | WR_SUC | Writing successful | _VSB_WR_SUC
42 | NORM | Normal status | _VSB_NORM
43 | N_NORM | Deviation normal status | _VSB_ABNORM
44 | BL_870 | IEC 60870 Status: blocked | _VSB_BL_BIT
45 | SB_870 | IEC 60870 Status: substituted | _VSB_SP_BIT
46 | NT_870 | IEC 60870 Status: not topical | _VSB_NT_BIT
47 | OV_870 | IEC 60870 Status: overflow | _VSB_OV_BIT
48 | SE_870 | IEC 60870 Status: select | _VSB_SE_BIT
49 | T_INVAL | Time invalid | not defined
50 | CB_TRIP | Breaker tripping detected | not defined
51 | CB_TR_I | Breaker tripping detection inactive | not defined
52 | RES52 | reserved | not defined
53 | RES53 | reserved | not defined
54 | RES54 | reserved | not defined
55 | RES55 | reserved | not defined
56 | RES56 | reserved | not defined
57 | RES57 | reserved | not defined
58 | RES58 | reserved | not defined
59 | RES59 | reserved | not defined
60 | RES60 | reserved | not defined
61 | RES61 | reserved | not defined
62 | RES62 | reserved | not defined
63 | RES63 | reserved | not defined

info Information

In formulas all status bits are available. For other use the availability can be reduced.

The single states are not available for all drivers.

As the statuses of each variable can also be accessed from VBA/VSTA in form of a 64 bit value, the bit position of each status is also listed in the detailed description below. This information is necessary for the individual evaluation with VBA/VSTA.

There are two possibilities for display in Runtime: the short form and the long form. These are separated in the description by a "/".

For each user status, its own text can be defined. This text then is displayed in the different modules (editors such as Runtime). Short text and long text is separated by a semi-colon ";".

To do this, the following entries must be inserted into project.ini:

[STATUS]

STATUS0=MS_K;My status 0

STATUS1=ET;Own text

......

STATUS63=RES;not used


User status 1 to 8 (M1-M8) and 14 to 16 (M14-M16)

Manual -> Status processing -> Status bits -> User status 1 to 8 (M1-M8) and 14 to 16 (M14-M16)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Display | Set | Available
0 to 7 | M1; user state 1 to M8; user state 8 | by the user | with all drivers Exception: Not available for internal driver
13 to 15 | M14; user state 14 to M16; user state 16 | by the user | with all drivers Exception: Not available for internal driver

The total of 11 user status bits can be used project-specifically. Examples of usage for these user status bits are e.g.: special interlockings for commands or flags for own information.


Select in the network (NET_SEL)

Manual -> Status processing -> Status bits -> Select in the network (NET_SEL)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Display | Set | Available
8 | NET_SEL; selected in zenon network | automatic | with all drivers

The NET_SEL status bit highlights the response variable during command processing in the zenon network. If the NET_SEL bit is set, another command selection - from a further workspace (for example from another client in the network) - cannot be executed on the same response variable.

The NET_SEL status bit is set:

  • If a command processing screen that is linked to the response variable is opened.
  • When executing a command action using the context menu or in the Command Sequencer module.
  • When executing an auto/remote command (via VBA, Process Gateway etc.).


Revision (REVISION)

Manual -> Status processing -> Status bits -> Revision (REVISION)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
9 | REVISION; Revision | by the user | with all drivers

Variables can be set to revision. If this status is active, alarms and setting of commands are suppressed by the process control system. So it is possible to exclude single parts of a process from alarming and operating.

Note: Only the alarms and commands are suppressed. All other limit value properties linked to this such as Limit color, Function, Invisible, Flashing etc. are not affected by this and are displayed and/or executed. The current variable values are also shown on the screens as before and also archived.

If linked functions or other properties are suppressed, create a reaction matrix that evaluates the revision status.


In operation (PROGRESS)

Manual -> Status processing -> Status bits -> In operation (PROGRESS)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Display | Set | Available
10 | PROGRESS; In operation | automatic | only in certain drivers

The status bit in operation together with command processing (only SICAM 230 or zenon Energy Edition) is used to show that a switch is in operation, as a result of which the switch will change its position (on/off). The status bit is set and reset when runtime monitoring is started, if this has been successfully completed or overwritten (TIMEOUT) .
The automatic setting of the bit in Runtime can be activated by activating the Set status PROGRESS property.

If the written command already matches the response value, the bit is not set. Only response values ON and AUS can be monitored.


Run time exceeded (TIMEOUT)

Manual -> Status processing -> Status bits -> Run time exceeded (TIMEOUT)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Display | Set | Available
11 | TIMEOUT; Runtime exceeded | automatic; from runtime monitoring in command processing | only in certain drivers

The status runtime exceeded is, in conjunction with the command (SICAM 230 or zenon Energy Edition only) to visualize that exceeding the time for the response variable (runtime) of a switching element has been detected. The reset is done by a change of the confirmation or another command set.


Manual value (MAN_VAL)

Manual -> Status processing -> Status bits -> Manual value (MAN_VAL)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
12 | MAN_VAL; Manual value | automatic | with all drivers

This status is set, as soon as a value in an archive has been changed by hand. This can be done in the Report Generator or in screen Archive revision.


General interrogation (GI)

Manual -> Status processing -> Status bits -> General interrogation (GI)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
16 | GI; General interrogation | automatic | with all drivers

After initializing Runtime, the first image that is read is named “general request”. That means that the value has not changed since Runtime start.


Spontaneous (SPONT)

Manual -> Status processing -> Status bits -> Spontaneous (SPONT)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
17 | SPONT; Spontaneous | automatic | with all drivers

Current value is valid. Everything OK.


Invalid (INVALID)

Manual -> Status processing -> Status bits -> Invalid (INVALID)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
18 | INVALID; Invalid | automatic | with all drivers

This bit is set, if there is a problem in the communication with the driver or with a single variable. The evaluation of single variables is only supported by spontaneous drivers. Most of the zenon drivers however are polling drivers, thus only a general problem in the communication can be indicated (and not a separate one for each variable).


Summer/winter time announcement (T_CHG_A)

Manual -> Status processing -> Status bits -> Summer/winter time announcement (T_CHG_A)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
19 | T_CHG_A; Daylight saving/winter time announcement (T_CHG_A) | automatic | In certain drivers

This status is set one hour before summer / winter time change (or the other way round). This status can be evaluated by the user. In zenon this status is solely informative.


Switched off (OFF)

Manual -> Status processing -> Status bits -> Switched off (OFF)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
20 | OFF; Switched off | by the user | with all drivers

If a variable is not needed online, it can be switched off. So it is no longer read from the hardware and no longer updated.

This status can e.g. be used to exclude not yet active parts of the process from the alarm handling.


Realtime external (T_EXTERN)

Manual -> Status processing -> Status bits -> Realtime external (T_EXTERN)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
21 | T-EXTERN | automatic | only in certain drivers

The time stamp is taken from an external device. zenon takes the value as it is. All modules now use this time stamp.


Realtime internal (T_INTERN)

Manual -> Status processing -> Status bits -> Realtime internal (T_INTERN)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
22 | T-INTERN | automatic | with all drivers

The time stamp is added by the zenon driver. As soon as the value is read correctly, it is stamped. All modules now use this time stamp.


Not sortable (N_SORTAB)

Manual -> Status processing -> Status bits -> Not sortable (N_SORTAB)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
23 | N_SORTAB | automatic | for IEC standards

Only for SICAM 230.

Concerns real-time data flow at the SSI protocol. SSI is used for SK1703 and concerns the AK driver.

State no longer used.

Originally: If a telegram arrived much too late, it receives the status N_SORTAB if it could not be sorted in. As now there is a secondary sorting, the state has no meaning anymore.


Default message transformer value (FM_TR)

Manual -> Status processing -> Status bits -> Default message transformer value (FM_TR)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
24 | FM_TR | automatic | for IEC standards

Only for SICAM 230.

Only for SSI protocol: Implausibel transformer value. IN newer protocols this information is transported via INVALID bit.

SSI is used for SK1703 and concerns the AK driver.


Run message transformer value (RM_TR)

Manual -> Status processing -> Status bits -> Run message transformer value (RM_TR)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
25 | RM_TR | automatic | for IEC standards

Only for SICAM 230.

Concerns SSI protocol and IEC870-101: As long as it is stepped this BIT comes along.

SSI is used for SK1703 and concerns the AK driver.


Info for variable (INFO)

Manual -> Status processing -> Status bits -> Info for variable (INFO)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
26 | INFO | automatic | for IEC standards

Only for SICAM 230.

No longer used.


Alternative value (ALT_VAL)

Manual -> Status processing -> Status bits -> Alternative value (ALT_VAL)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
27 | ALT_VAL; alternative value | by the user | with all drivers

To simulate a value, it can be switched to the alternative value. At this the value is completely uncoupled from the process as with Switched off (OFF). Similar to Switch off the last process value is displayed. There is however the possibility to change the alternate value in the Runtime; e.g. via the set value dialog

  • Modify substitute value: Changes only the alternate value
  • Switch to and modify alternate value: Switched to alternate value and changes it to the set value.
  • Modify spontaneous value: Despite of an alternate value, a set value is sent to the hardware. The variable however retains the alternate value.
  • Switch to spontaneous value: Switches off the alternate value.

Additional possibilities to influence the alternate value are the Recipegroup Manager or the Programming Interface.

If at the time of the switching to the alternate value the status was invalid (INVALID), the status remains. The value has the state invalid and alternate value set.

The alternate value is not sent to the connected hardware, but stays in the process image on the computer. This value is sent to all modules of zenon and further processed there. So it is for example archived and alarms are created.

Using this status information these values can especially be marked in the report. So on the one hand the changes are traceable, on the other hand the further processing works with correct values.

Example Example

If an outside temperature sensor is defective, it may send an unrealistic value, e.g. -280°C. Now the user can enter the correct value instead of the defective value by reading the temperature, e.g. 14°C. Now this value is archived, alarmed and logged.

All modules in zenon now use this alternate value.


Not updated (N_UPDATE)

Manual -> Status processing -> Status bits -> Not updated (N_UPDATE)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
29 | N_UPDATE | automatic | with all drivers

The status Not updated (N_UPDATE) is set if a value has been requested from the hardware, but no valid value could be read.


Standard time (T_STD)

Manual -> Status processing -> Status bits -> Standard time (T_STD)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
30 | T_STD | automatic | with all drivers

This status indicates, whether the time stamp is in winter time (bit high) or in summer time (bit low).


Cause of Transmission (COTx)

Manual -> Status processing -> Status bits -> Cause of Transmission (COTx)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
32 - 37 | COT0 to COT5 | automatic | for IEC standards

The Cause of Transmission (COT) according to the IEC60870 protocol.

The value of the Cause of Transmission (see IEC60870-5-101 7.2.3) is mapped to status bits 32 - 37. With this up to 6 COTx could be set (x represents bit numbers 0 to 5). For example the lowest bit of the COT value is shunted to status bit 32 and called COT0 in zenon.

The whole COT value can be evaluated in the Runtime via a reaction matrix (multi-numeric or multi-binary). For each COTx bit the value of the cause of transmission is increased as follows:

  • COT0 = 2^0 = 1
  • COT1 = 2^1 = 2
  • COT2 = 2^2 = 4
  • COT3 = 2^3 = 8
  • COT4 = 2^4 = 16
  • COT5 = 2^5 = 32

Example

Typical COT values:

Status | Value | Cause of Transmission | Short name
COT0, COT1 | 1+2 = 3 | spontaneous | COT_spont
COT0, COT1, COT2 | 1+2+4 = 7 | activation confirmation | COT_actcon
COT1, COT3 | 2+8 = 10 | activation termination | COT_actterm
COT2, COT4 | 4+16 = 20 | interrogated by station interrogation | COT_inrogen

info Information

The module Command uses the cause of transmission for Runtime exceeded of commands.

Attention:

  • Not all drivers support COT.
  • Some Energy driver support only an area restricted to Runtime exceeded in Command.
  • Some drivers support COT although the protocol itself does not contain COT (e.g. DNP3). You can find details in the corresponding driver documentation.


P/N-Bit (N_CONF)

Manual -> Status processing -> Status bits -> P/N-Bit (N_CONF)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
38 | N_CONF | automatic | for IEC standards

The P/N bit from an IEC870-5-104 telegram is displayed in the N_CONF status bit.


Test bit (TEST)

Manual -> Status processing -> Status bits -> Test bit (TEST)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
39 | TEST | automatic | for IEC standards

The Test bit from an IEC870-5-104 telegram is displayed in the status bit TEST.


Acknowledge writing (WR_ACK)

Manual -> Status processing -> Status bits -> Acknowledge writing (WR_ACK)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Display | Set | Available
40 | WR_ACK | automatic | Driver specific

Is used by the zenon functions Write set value, Write recipe and Command Processing to request a write confirmation from the driver.

Note: You can find more detailed information in the Variables manual in the Checking writing of set values chapter.


Writing successful (WR_SUC)

Manual -> Status processing -> Status bits -> Writing successful (WR_SUC)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Display | Set | Available
41 | WR_SUC | automatic | Driver specific

If for a Write set value or Write recipe action or command processing, a write confirmation is to be requested (WR_ACK), this status bit is set accordingly after the write process.

Note: You can find more detailed information in the Variables manual in the Checking writing of set values chapter.


Normal status (NORM)

Manual -> Status processing -> Status bits -> Normal status (NORM)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
42 | NORM | automatic | with all drivers

The normal status is defined in the variable properties and evaluated in the status bit NORM.


Deviation normal status (N_NORM)

Manual -> Status processing -> Status bits -> Deviation normal status (N_NORM)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Advertisement | Set | Available
43 | N_NORM | automatic | with all drivers

For bit variables the driver compares the process status with the defined normal status and writes the result to the status bit N_NORM.


BL_870

Manual -> Status processing -> Status bits -> BL_870

Bit number | Advertisement | Set | Available
44 | BL_870 | automatic | IEC870 IEC850 (partly)

Signals IEC status blocked in accordance with standard 60870-101 or 104. The value is blocked for transferring and remains in the status it had before it was blocked. This status bit can be selected in Multi reaction matrices, in Combined elements and in the Interlocking formula.

In VBA the top 32 bits can be polled with StatusExtValue(). With SetValueWithStatusEx() all 64 status bits can be polled.


SB_870

Manual -> Status processing -> Status bits -> SB_870

Bit number | Advertisement | Set | Available
45 | SB_870 | automatic | IEC870 IEC850 (partly)

Signals IEC status substituted in accordance with standard 60870-101 or 104. The value was set by an user or an automatic source. This status bit can be selected in Multi reaction matrices, in Combined elements and in the Interlocking formula.

In VBA the top 32 bits can be polled with StatusExtValue(). With SetValueWithStatusEx() all 64 status bits can be polled.


NT_870

Manual -> Status processing -> Status bits -> NT_870

Bit number | Advertisement | Set | Available
46 | NT_870 | automatic | IEC870 IEC850 (partly)

Signals IEC status not topical in accordance with standard 60870-101 or 104. The value was not updated or was not available for a certain period of time. This status bit can be selected in Multi reaction matrices, in Combined elements and in the Interlocking formula.

In VBA the top 32 bits can be polled with StatusExtValue(). With SetValueWithStatusEx() all 64 status bits can be polled.


OV_870

Manual -> Status processing -> Status bits -> OV_870

Bit number | Advertisement | Set | Available
47 | OV_870 | automatic | IEC870 IEC850 (partly)

Signals Overflow in accordance with standard 60870-101 or 104. The value lies outside the predefined bandwidth.


SE_870

Manual -> Status processing -> Status bits -> SE_870

Bit number | Advertisement | Set | Available
48 | SE_870 | automatic | IEC870 IEC850 (partly)

This S/E bit is used in accordance with standard IEC 60870-101 or 104 together with functionality Select before operate and serves for distinction between Select- and Execute- states of a command.

Values:

  • 0 = execute
  • 1 = select


T_INVAL

Manual -> Status processing -> Status bits -> T_INVAL

Bit number | Advertisement | Set | Available
49 | T_INVAL | automatic | IEC870

T_INVAL is set by driver IEC870 if the received real time stamp is marked as invalid. In this case, the local PC time is stamped. In the IEC870 Slave of the Process Gateways the T_INVAL is forwarded in message direction in the time stamp.


Breaker tripping detected (CB_TRIP)

Manual -> Status processing -> Status bits -> Breaker tripping detected (CB_TRIP)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Display | Set | Available
50 | Breaker tripping detected | Automatic from command processing | with all drivers

The status bit takes the value 1 if breaker tripping detection has been activated in the Command processing module and breaker tripping is detected.

The detection occurs if:

  • the value of the response variable changes from <>0 to 0 and
    • The status bit CB_TR_I (51) is not 1
    • The status bit PROGRESS (10) is not 1
    • The value of the response variable is already defined (i.e. it is not the initial value for this variable)

A change to the value of the variable from 0 to <>0 resets this bit again. This bit is also reset if the PROGRESS status bit (10) becomes active. A change of CB_TR_I does not have an influence on a breaker trip that has already been detected.

This status bit can be explicitly modified with the "Status", "Status on" or "Status off" action in the command processing. The status bit contains this status up until the value of the variable switches from <>0 to 0 or from 0 to <>0. A requirement for this is that the CB_TR_I status bit is 0. This means that breaker tripping detection is not suppressed.

Network

In the network the evaluation is carried out on the server which is responsible for the process. The evaluation is indeed also carried out on the Standby Server but the result is not written to the status bits. The current state of CB_TR_I and CB_TRIP are synchronized when the Standby Server is started or reconnected. If the response variable is a variable on a local computer, the evaluation is also carried out on the client computer.


Breaker tripping detection inactive (CB_TR_I)

Manual -> Status processing -> Status bits -> Breaker tripping detection inactive (CB_TR_I)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Display | Set | Available
51 | Breaker tripping detection inactive | automatic as result of the formula of property Suppress detection in the command processing | with all drivers

Shows that breaker tripping detection is suppressed in command processing for the variable.

The new calculation is triggered in the event of a status change or value change of a variable if this has been defined in the command for calculations in formulas. The formula is not evaluated and the result is not written to the status if:

  • one of the variables in the formula does not have a defined value and status yet
    or
  • one of the variables is invalid (INVALID).

This status bit can be explicitly modified with the "Status", "Status on" or "Status off" action in the command processing. The status bit will then remain in this state until the result of the formula changes and a different status bit status occurs as a result.

Attention: The detection of a breaker tripping (CB_TRIP) and the setting breaker tripping detection inactive at the same time does not work.

Example: The "RM.Value<1" will detect breaker tripping (CB_TRIP = 1), because CB_TR_I is not yet active at the time of the value change.

Network

In the network the evaluation is carried out on the server which is responsible for the process. The evaluation is indeed also carried out on the Standby Server but the result is not written to the status bits. The current state of CB_TR_I and CB_TRIP are synchronized when the Standby Server is started or reconnected. If the response variable is a variable on a local computer, the evaluation is also carried out on the client computer.


Usage

Manual -> Status processing -> Usage


Reaction matrices

Manual -> Status processing -> Usage -> Reaction matrices

The reaction matrices are the most sophisticated way to deal with statuses.

Here single statuses can be evaluated and cause alarms. Basically a status can be treated like a value. As with a value it is also possible with a status to cause certain actions.

As for example:

  • Generate alarm
  • Generate entry in CEL
  • Execute function
  • Flashing
  • Color change
  • Print

Example:

If a value becomes invalid, it gets the state INVALID. This happens when the driver loses the connection to the PLC. You can create a reaction matrix, which causes an alarm, as soon as the value becomes invalid (INVALID). There is the possibility to evaluate these alarms afterwards.


Dynamic elements

Manual -> Status processing -> Usage -> Dynamic elements

All dynamic elements offer the possibility to display the status of the linked variable. This is done with the property Display status of variable.

Then it is possible to display the status in the Runtime withe the right mouse button.

In the Runtime the status is displayed by clicking the dynamic element with the right mouse button. As long as the mouse button stays pressed down, the variable name and the current status of the variable is displayed.

If status display is activated, any not normal status is indicated with a red square in the upper right corner of the element.

This indicates, that the value no longer is spontaneous. By clicking the element with the right mouse button it becomes obvious, that somebody changed the status to the alternative value.


Combined element

Manual -> Status processing -> Usage -> Combined element

The Combined Element offers the possibility to evaluate and graphically display the stati. In difference to the Reaction Matrices, this evaluation only effects the graphical display in the screen.

That means:

1 | changing the color
2 | displaying another symbol
3 | displaying another text
4 | displaying another bitmap
5 | changing the color of a symbol


Report Generator

Manual -> Status processing -> Usage -> Report Generator

Also the Report Generator offers the possibility to evaluate the stati.

This is done by using the function variabler with the status as a parameter.

The syntax is the following:

=variabler(Temperature_outside,status)

In the Runtime the display can look like below.

Temperature_outside

21ºC

ALT_VAL


Recipegroup Manager

Manual -> Status processing -> Usage -> Recipegroup Manager

The Recipegroup Manager offers the possibility to read, display and change all stati, as long as they are not set by the process (driver). To set status bits, go to dialog Editing a recipe and use column Actions.


VBA

Manual -> Status processing -> Usage -> VBA

In VBA there are all possibilities to access and change all stati, as long as they are not set by the process (driver).


Time control

Manual -> Time control

In the time control, you can define all function calls that should be executed at a defined (fixed) time or cyclically.
So for example important production data can be saved daily on a server in the network.

tutorial License information

Part of the standard license of the Editor and Runtime.

Project Manager context menu

Menu item | Action
New time function | Creates a new function for the time control.
Export XML all... | Exports all entries as an XML file.
Import XML... | Imports entries from an XML file.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.


Engineering in the Editor

Manual -> Time control -> Engineering in the Editor

The definition of the time control functions is done in the folder Time control in Project Manager. Pre-existing time functions are shown in the detail view after selection.

With the context menu and the command Time function newa new time function can be created.

In the properties window the properties of the new time function are now displayed and can be edited.

The properties are described in detail in the properties help of the Editor.

Note: Turn of the month and turn of the year refers to the set execution date and not to the turn of the month/year on 01. 01. 00:00 a.m. If the change should be executed at exact this point in time, the engineering must be doen for this point in time; e.g. 01. 01. 2012 00:00:00 o'clock.


Time control detail view of toolbar and context menu

Manual -> Time control -> Time control detail view of toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu

Menu item | Action
New time function | Inserts a new time function in the list.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Clear | Deletes selected entries after a confirmation from list.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Properties | Opens the Properties window for the selected entry.
Export selected XML | Exports all selected entries as an XML file.
Import XML | Imports entries from an XML file.
Remove all filters | Removes all filter settings.
Help | Opens online help.


Tools

Manual -> Tools

A range of tools support you for the management, analysis and configuration of zenon:

  • Diagnosis Viewer: Allows zenon LOG files to be read and configured.
  • Keyblock Runtime Start: Starts zenon Runtime and at the same time blocks all Windows system keys.
  • Online updating of the zenon Help: Allows online updating of zenon Help.
  • Project Translation Interface: Tool for the translation of zenon language files. Opens or saves data for the zenon Language Translation Wizard. With this, projects can be imported into or exported out of zenon.
  • Startup Tool: Makes it possible to start the Editor and Runtime with certain parameters, to administer different zenon versions on one computer, to administer SQL instances and to define languages for Editor and Runtime.
  • System Information Collector: Reads system information and zenon information, displays it in an output window and saves it as a ZIP file.

The following are available for zenon Logic:

  • zenon Logic Runtime Manager: Administer all stand-alone/manual-start zenon Logic Runtime projects on your computer.
    The documentation for this tool is part of the zenon Logic documentation.


Diagnosis Viewer

Manual -> Tools -> Diagnosis Viewer

All zenon modules such as Editor, Runtime, drivers, etc. as well as zenon Analyzer write messages to a joint log file. These can be read and configured with the Diagnosis Viewer program. The Diagnosis Viewer allows the reading of existing log files, online logging, saving of the current view, setting parameters for the Diagnosis Clients and the Diagnosis Server.

tutorial License information

Part of the standard license of the Editor and Runtime.

Starting the Diagnosis Viewer

The Diagnosis Viewer will be installed in the folder: %Program Files (x86)%\Common Files\COPA-DATA\STARTUP. Call it up under:

  • Windows 8: Enter "Diagnosis Viewer" on the desktop for Apps
  • Windows 7: Start/All Programs/zenon/Version Independent Tools -> Diagnosis Viewer.

The Diagnosis Viewer is only available in English.

Using IPv6

The Diagnosis Server also works with Diagnosis Clients which addresses via IPv6 addresses. For this the format of the log file has been adapted. The Diagnosis Viewer only reads the new format of the log files. If files from older zenon versions are opened (or vice versa), the IP address of the Diagnosis Client is not displayed correctly.

Driver analysis

zenon driver log all errors in the log files. The default folder for the log files is subfolder LOG in directory ProgramData, example:

C:\ProgramData\COPA-DATA\LOG. Log files are text files with a special structure.

Attention: With the default settings, a driver only logs error information. With the Diagnosis Viewer you can enhance the diagnosis level for most of the drivers to "Debug" and "Deep Debug". With this the driver also logs all other important tasks and events.

In the Diagnosis Viewer you can also:

  • follow currently created entries live
  • customize the logging settings
  • change the folder in which the log files are saved

Note:

  1. In Windows CE even errors are not logged per default due to performance reasons.
  2. The Diagnosis Viewer displays all entries in UTC (coordinated world time) and not in local time.
  3. The Diagnosis Viewer does not display all columns of a log file per default. To display more columns activate property Add all columns with entry in the context menu of the column header.
  4. If you only use Error logging, the problem description is in column Error text. For other diagnosis level the description is in column General text.
  5. For communication problems many drivers also log error numbers which the PLC assigns to them. They are displayed in Error text and/or Error code and/or Driver error parameter(1 and 2). Hints on the meaning of error codes can be found in the driver documentation and the protocol/PLC description.
  6. At the end of your test set back the diagnosis level from Debug or Deep Debug. At Debug and Deep Debug there are a great deal of data for logging which are saved to the hard drive and which can influence your system performance. They are still logged even after you close the Diagnosis Viewer.


General

Manual -> Tools -> Diagnosis Viewer -> General

The zenon Diagnosis System logs error messages from zenon and zenon Analyzer. It consists of three parts:

  • Diagnosis Server: local or or defined in zenon6.ini defined zenLogSrv
  • Diagnosis Clients: all modules, drivers, services, etc. which write messages
  • Diagnosis Viewer: Analysis program

Versions

From version zenon 7.00 on the service zenLogSrv is used instead of the zenSysSrv for the diagnosis system. That means:

  • Diagnosis systems up to version 6.51 and from version 7.00 are each compatible among themselves.
  • The diagnosis mechanism of zenon 6.51 SP0 and zenon 7.00 SP0 are not compatible.
Compatibility | Diagnosis Server 6.51 SP0 and earlier | Diagnosis Server 7.00 SP0 and higher
Diagnosis Client 6.51 SP0 and earlier | compatible | incompatible
Diagnosis Viewer 6.51 SP0 and earlier | compatible | incompatible
Diagnosis Client 7.00 SP0 and higher | incompatible | compatible
Diagnosis Viewer 7.00 SP0 and higher | incompatible | compatible

With the Diagnosis Viewer version 7.00 SP0 and higher you can open log files which were created by Diagnosis Server version 6.51 SP0 (or earlier). It does not work the other way round.

Default ports

  • Version 7 and higher: 50780 (port of service zenLogSrv)
  • up to 6.51: 1101 (port of service zenSysSrv)

If the port cannot be opened, the service closes itself.

attention Attention

If the port to which the Diagnosis Viewer should connect is closes, then it is tried to start the local Diagnosis Server. This makes sure that local logging is carried out if no Diagnosis Server is available in the network.

Memory occupancy

Service zenLogSrv buffers log entries until they can be written in the log file. If the memory consumptions increases continuously by zenLogSrv, it is an indicator that the log file cannot be written.


Topology of the diagnosis system

Manual -> Tools -> Diagnosis Viewer -> Topology of the diagnosis system

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The topology of the diagnosis system differs for versions up to 6.51 SP0 and from 7.00 SP0 on.

Topology before zenon 7.00 SP0

The diagram displays all possible connections for which zenSysSrv is responsible. Each arrow represents a network connection between the applications. All applications connect to the zenSysSrv on port 1101 regardless of whether Client and Server are on the same computer or communicate with each other via a network.

  1. The Editor sends log entries, commands and data of the Remote Transport to zenSysSrv. zenSysSrv sends the configuration of the Diagnosis Clients (Editor, Runtime, driver, Web Server, Web Client, etc.) and the Remote Transport data to the Editor.
  2. The Diagnosis Viewer sends diagnosis commands, diagnosis configurations and log entries to zenSysSrv. zenSysSrv sends diagnosis data and the Diagnosis Client configuration to the Diagnosis Viewer.
  3. zenSysSrv sends the Diagnosis Client configuration to the Diagnosis Clients. The Diagnosis Clients send log entries to zenSysSrv.

zenSysSrv reacts correspondingly to each incoming message:

  • Log entries are written in log files.
  • Remote Transport commands (start Runtime, write/read back data, etc.) are executed.
  • Diagnosis commands (set Server/Client configuration, start online logging, etc.) are executed.

Topology as of zenon 7.00 SP0

The diagram displays all possible connections for which zenSysSrv and zenLogSrv (as of version 7.00 SP0) are responsible. Each arrow represents a network connection between the applications. All applications connect to zenLogSrv on port 50780. The editor connects to zenSysSrv on port 1101. It is regardless of whether Client and Server are on the same computer or communicate with each other via a network.

  1. The Editor sends commands and data of the Remote Transport to zenSysSrv. zenSysSrv sends data of the Remote Transport to the Editor.
  2. The Editors send log entries to zenLogSrv. zenLogSrv sends the Diagnosis Client configuration to the Editor.
  3. The Diagnosis Viewer sends diagnosis commands, diagnosis configurations and log entries to zenSysSrv. zenSysSrv sends diagnosis data and the Diagnosis Client configuration to the Diagnosis Viewer.
  4. The zenSysSrv sends log entries to the zenLogSrv. zenLogSrv sends the Diagnosis Client configuration to zenSysSrv.
  5. zenLogSrv sends the Diagnosis Client configuration to the Diagnosis Clients. The Diagnosis Clients send log entries to zenLogSrv.

zenSysSrv reacts to: incoming Remote Transport commands.
zenLogSrv reacts to incoming diagnosis commands and log entries

Example

IN an environment with a central Diagnosis Server the Runtime is started on a device. Based on the Runtime version the configuration is read from zenon6.ini. Versions before 7.00 SP0 read entry LOG_CONFIG from [SYS_REMOTE], later versions read this entry from [LOGGING_SYSTEM]. This configuration is used to establish a diagnosis connection. (For details see Standard procedure.) Each additional component loaded by the Runtime (driver, zenNetSrv, etc.) also establish a diagnosis connection.


Standard procedure

Manual -> Tools -> Diagnosis Viewer -> Standard procedure

As default only error messages (errors) are sent from the Clients to the Diagnosis Server.

The Diagnosis Server saves the received messages in TXT files with a special structure. The default folder for the log files is subfolder LOG in folderProgramData. For example: %ProgramData%\COPA-DATA \LOG.
For more information see manual Installation and Updates chapter File structure.

Note: Under Windows CE error messages are also not created per default due to resource issues.

In order to report not only error messages to the Diagnosis Server but also other information important for the diagnosis, the according settings have to be defined for the Client.

You can also configure the behavior of the Server.

Configuration

The configuration of the connection is done in zenon6.inI divided in:

  • Diagnosis Clients
  • Diagnosis Server
  • Versions to make sure that the configuration of the versions does not affect each other

The configuration of the Diagnosis Viewer also enables you to configure settings for the connection:

  • Settings of the server
  • Connection settings Diagnosis Server connection
  • Diagnosis Client
  • Diagnosis Viewer - Analysis Program

We recommend to do the configuration of the connection for Server and Client via zenon6.ini.

Procedure

The Diagnosis Server is:

  • a service at the PC.
    The service starts automatically when the operating system boots. The local service can only be started once.
  • an application under CE.
    Under CE only one process can use the port. Additionally started processes terminate themselves as the port cannot be opened. If the local configuration of the Diagnosis Server is set under CE in such a way that only the user interface is displayed (INIT=2), several processes could emerge by the Diagnosis Clients trying to start the local Diagnosis Server.

As soon as a Diagnosis Client gets active, the following steps are carried out:

  1. The Diagnosis Client reads and uses the configuration from zenon6.ini. If no configuration is available in zenon6.ini, the default configuration (Diagnose Server=localhost:50780) is used.
  2. The Diagnosis Client tries to establish a connection to the Diagnosis Server:

    Establishing successful:

    1. The diagnosis connection has been established and the log entries are sent.

    Establishing failed:

    1. The Diagnosis Client tries to start and use the local Diagnosis Server.
      On a PC it tries to start the service.
      Under CE it tries to create the process.
    2. The Diagnosis Client tries to establish a connection to the local Diagnosis Server. If it succeeds, the diagnosis connection is established and the log entries are sent.

    If it fails, no log entries are created.


Entries in zenon6.ini

Manual -> Tools -> Diagnosis Viewer -> Standard procedure -> Entries in zenon6.ini

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The configuration of zenSysSrv and zenLogSrv is carried out via zenon6.ini. At this it is differentiated between version 7.00 and up and versions 6.51 and earlier. With this you can configure old and new Diagnosis Clients and Diagnosis Servers independent of each other on one device. For example, the LOG entries of old Diagnosis Clients are diverted, without the LOG entries of new clients being affected.

Diagnosis Server before Version 7.00 SP0

INI entry

Description

[SYS_REMOTE]

Section in zenon6.ini.

Contains parameters for zenSysSrv (Remote Transport and Diagnosis Server).

LOGDirectory=

Defines folder for the LOG files.

If there is no entry, the LOG folder in the %ProgramData% folder is used as a default value.

Example:
LOGDirectory= %ProgramData%\COPA-DATA\zenon651\LOG

CONFIG=

Configuration string for the Diagnosis Server and zenSysSrv. Remote Transport and the diagnosis system use the same server configuration up to and including version 6.51 SP0. The string consists of the following parts: DEVICE=[Device];HOST=[Hostname];PORT=[Port];TIMEOUT=[Timeout]

  • DEVICE: Sets the communication type used.
    TCP/IP and serial are available.
  • HOST: Is set to the computer name of the Diagnosis Server.
  • PORT: states the port to be used.
  • TIMEOUT: Provides the time-out time for the connection in seconds.
  • BAUD: Provides the connection speed of a serial connection.

PC configuration:

  • DEVICE=TCP/IP
  • HOST=localhost
  • PORT=1101
  • TIMEOUT=10

CE configuration:

  • DEVICE=COM1
  • BAUD=115200

LOGMinFreeDiskSpace=

Defines minimum memory (in MB) that must be available on the hard drive. LOG files are deleted before this value is gone below.

Default: 1024

LOGMaxUsedDiskSpace=

Defines the maximum memory on the hard drive in MB used for LOG files. LOG files are deleted if this value is exceeded.

Default: 1024

LOGMinUsedDiskSpace=

Defines memory on the hard drive (in MB) that is used even if there are no LOG files.

Default: 5

LOGLogLifeTime=

Defines the lifecycle of the LOG files in seconds. Older LOG files are deleted.

Default: 1209600 (corresponds to 14 days)

LOGImageCnt=

Defines the number of LOG entries, after which all incremental LOG files are written.

  • 0: inactive (default)

LOGLogUpdateTime=

Number of milliseconds, after which the LOG entries received are written to a LOG file.

Default: 2000

LOGMaxBufferedRecs=

Defines the number of LOG entries that are buffered if they cannot be written to files.

Default: 10240

LOGMaxLogFileSize=

Maximal size of a log file in bytes. If a log file reaches this size, it is closed and a new log file is created.

Default: 5242880 (corresponds to 5 MB)

LOGCheckDiskTime=

Defines the interval in seconds, in which the memory occupied by LOG files is checked.

Default: 60

INIT=

Action when starting the application with Windows CE:

  • 0: end immediately
  • 1 (or other value greater than 2): Open listening port in minimize to system tray
  • 2: only display surface

Default: 1

Note: As part of the separation of zenSysServ and zenLogServ for zenon 7.00, this default value was also changed for other versions. The default value was previously 2.

Diagnosis Server from Version 7.00 SP0

INI entry

Description

[LOGGING_SYSTEM]

Section in zenon6.ini.

Contains parameters for the Diagnosis Server. Only affects zenLogSrv and has no effect on zenSysSrv.

LOGDirectory=

Defines the folder for the LOG files.

If there is no entry, the following is used as a standard value:

  • The path extracted from the Registry,
    for example: %ProgramData%\COPA-DATA\LOG
  • the LOG folder in the ProgramData folder of the zenLogSrv, if no path is defined in the registry,
    e. g. %ProgramData%\COPA-DATA\zenon700\LOG

CONFIG=

Configuration string for the Diagnosis Server. The string consists of the following parts: DEVICE=TCP/IP;HOST=[Hostname];PORT=[Port];TIMEOUT=[Timeout]

  • DEVICE: Sets the communication type used and must always be set to TCP/IP
  • HOST: Is set to the computer name of the Diagnosis Server.
  • PORT: states the port to be used.
  • TIMEOUT: Provides the time-out time for the connection in seconds.

Configuration:

  • DEVICE=TCP/IP
  • HOST=localhost
  • PORT=50780
  • TIMEOUT=10

LOGMinFreeDiskSpace=

Defines minimum memory (in MB) that must be available on the hard drive. LOG files are deleted before this value is gone below.

Default: 1024

LOGMaxUsedDiskSpace=

Defines the maximum memory on the hard drive in MB used for LOG files. LOG files are deleted if this value is exceeded.

Default: 1024

LOGMinUsedDiskSpace=

Defines memory on the hard drive (in MB) that is used even if there are no LOG files.

Default: 5

LOGLogLifeTime=

Defines the lifecycle of the LOG files in seconds. Older LOG files are deleted.

Default: 1209600 (corresponds to 14 days)

LOGImageCnt=

Defines the number of LOG entries, after which all incremental LOG files are written.

Default: 0

LOGLogUpdateTime=

Number of milliseconds, after which the LOG entries received are written to a LOG file.

Default: 2000

LOGMaxBufferedRecs=

Defines the number of LOG entries that are buffered if they cannot be written to files.

Default: 10240

LOGMaxLogFileSize=

Maximal size of a log file in bytes. If a log file reaches this size, it is closed and a new log file is created.

Default: 5242880 (corresponds to 5 MB)

LOGCheckDiskTime=

Defines the interval in seconds, in which the memory occupied by LOG files is checked.

Default: 60

INIT=

Action when starting the application with Windows CE:

  • 0: end immediately
  • 1 (or other value greater than 2): Open listening port in minimize to system tray
  • 2: only display surface

Default: 1

Diagnosis Client before Version 7.00 SP0:

INI entry

Description

[SYS_REMOTE]

Section in zenon6.ini.

Contains parameters for the Diagnosis Client.

LOG_CONFIG=

A configuration string for the Diagnosis Client is stored here. The string consists of the following parts: DEVICE=TCP/IP;HOST=[Hostname];PORT=[Port];TIMEOUT=[Timeout]

  • DEVICE: Sets the communication type used and must always be set to TCP/IP
  • HOST: Is set to the computer name of the Diagnosis Server.
  • PORT: states the port to be used.
  • TIMEOUT: Provides the time-out time for the connection in seconds.

Configuration:

  • DEVICE=TCP/IP
  • HOST=localhost
  • PORT=1101
  • TIMEOUT=10

Diagnosis Client from Version 7.00 SP0

INI entry

Description

[LOGGING_SYSTEM]

Section in zenon6.ini.

Contains parameters for the Diagnosis Client.

LOG_CONFIG=

A configuration string for the Diagnosis Client is stored here. The string consists of the following parts:

DEVICE=TCP/IP;HOST=[Hostname];PORT=[Port];TIMEOUT=[Timeout]

  • DEVICE: Sets the communication type used and must always be set to TCP/IP
  • HOST: Is set to the computer name of the Diagnosis Server.
  • PORT: states the port to be used.
  • TIMEOUT: Provides the time-out time for the connection in seconds.

Configuration:

  • DEVICE=TCP/IP
  • HOST=localhost
  • PORT=50780
  • TIMEOUT=10

Note:

INIT under CE

Under Windows CE we urgently recommend to not set entry INIT= (in section [LOGGING_SYSTEM] or [SYS_REMOTE]) to value 2.

Reason: The value 2 means that both SysSrvCE and LogSrvCE only display the user interface and do not open the listening port.
If now a Diagnosis Client wants to establish a connection, it will fail. As in this case the Diagnosis Clients start process LogSrvCE and the process does not open the port, each Diagnosis Client starts such a process. This leads to several parallel LogSrvCE processes and to a delay in starting the Diagnosis Clients as it waits for the timeout of the connection while establishing the diagnosis connection.

zenLogSrv on a system with different versions

If zenLogSrv is used on a system with different versions as a central local diagnosis server, the entry LOG_CONFIG in the [SYS_REMOTE] such must be as follows:
DEVICE=TCP/IP;HOST=localhost;PORT=5780;TIMEOUT=10

Reason: Older clients then use zenLogSrv as the Diagnosis Server. New clients do this automatically. This service is switched on automatically on the PC when the system is started; it must be started manually with CE.

Attention: If the port cannot be reached, older clients start zenSysSrv and retry connecting to it.


Windows CE

Manual -> Tools -> Diagnosis Viewer -> Standard procedure -> Windows CE

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Under Windows CE the Diagnosis Server is started as an application.

At the configuration of the connection consider the recommendation for parameter INIT:

Under Windows CE we urgently recommend to not set entry INIT= (in section [LOGGING_SYSTEM] or [SYS_REMOTE]) to value 2.

Reason: The value 2 means that both SysSrvCE and LogSrvCE only display the user interface and do not open the listening port.
If now a Diagnosis Client wants to establish a connection, it will fail. As in this case the Diagnosis Clients start process LogSrvCE and the process does not open the port, each Diagnosis Client starts such a process. This leads to several parallel LogSrvCE processes and to a delay in starting the Diagnosis Clients as it waits for the timeout of the connection while establishing the diagnosis connection.

User interface under CE

Transport Service (zenSysSrv)

Parameters

Description

Start

Opens the Listening port and enables zenSysSrv to receive Remote Transport commands.

Browse

Opens the dialog for browsing the file system.

Stop

Terminates the receiving of Remote Transport commands and closes the Listening port.

Configuration

Selection of an existing server configuration from drop-down list. New connections cannot be configured. See section Entries in zenon6.ini for the configuration of the connection.
Available are:

  • Configuration from zenon6.ini
  • Standard configuration for TCP/IP
  • Standard configuration for COM1 to COM4

Hide

Minimizes the user interface into the task bar.

Exit

Terminates the application and closes the Listening port if necessary.

X
(button top right)

Minimizes the user interface into the task bar.

Logging Service (zenLogSrv)

Parameters

Description

Start

Opens the Listening port and enables zenLogSrv to receive log entries.

Stop

Terminates the receiving of log entries and closes the Listening port.

Configuration

Selection of an existing configuration from drop-down list. New connections cannot be configured. See section Entries in zenon6.ini for the configuration of the connection.
Available are:

  • Configuration from zenon6.ini
  • Standard configuration for TCP/IP

Hide

Minimizes the user interface into the task bar.

Exit

Terminates the application and closes the Listening port if necessary.

X
(button top right)

Minimizes the user interface into the task bar.


Diagnosis Server

Manual -> Tools -> Diagnosis Viewer -> Diagnosis Server

The Diagnosis Server:

  • Creates and manages log files.
  • The Server is:
    • implemented from zenon 7.00 on as zenLogSrv
    • up until zenon 6.51 integrated in the zenSysSrv.
  • The configuration of the server is read from the zenon6.ini.
  • The server writes the received log data into the log file.
  • The saving location for the files has to be configured. Standard: %ProgramData%\COPA-DATA\LOG\
  • Log files are named after the following fashion LOG<YYMMTThhmmss>.txt.
  • The server is multi client able. Several evaluations can connect to the server simultaneously.
  • It is possible to connect to the server online, to see the current logging messages.
  • It is possible to connect to diagnosis servers other than the local and to execute the same tasks (configuring server, configuring clients, online logging) as on the local server.
  • The parameters of the current server (with which the Diagnosis Viewer is connected) can be modified. If a modification of another diagnosis server is needed, the server connection can be changed in the menu under File – Connect to….
  • The menu entry Settings – Server configuration is only available, if online logging is not used at the moment.


System integrity monitoring

Manual -> Tools -> Diagnosis Viewer -> Diagnosis Server -> System integrity monitoring

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

At the start of the Runtime a monitoring thread with high priority is also started. The monitoring thread checks critical parameters every ten seconds and writes corresponding warnings or errors in module Supervisor of the Diagnosis Server.

The following parameters are monitored.

Parameters | Limit
Warning threshold for used handles | > 5000
Error threshold for used handles | > 9000
Warning threshold for used GDI objects | > 5000
Error threshold for used GDI objects | > 9000
Warning threshold for CPU use for the main thread | > 70 %
Error threshold for CPU use for the main thread | > 90 %
Warning threshold for total CPU use | > 70 %
Warning threshold for total CPU use | > 90 %
Warning threshold for free main memory | < 30 %
Error threshold for free main memory | < 10 %
Warning threshold for OnTimer in the main frame | > 1000 ms
Error threshold for OnTimer in the main frame | > 5000 ms


Settings of the server

Manual -> Tools -> Diagnosis Viewer -> Diagnosis Server -> Settings of the server

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Diagnosis Server can be configured via entries in file zenon6.ini or via dialog Server configuration in the Diagnosis Client. We recommend to do the settings in file zenon6.ini.

Configuration via zenon6.ini

See section Entries in zenon6.ini.

Configuration via dialog

To configure the Diagnosis Server via the dialog:

  1. start the Diagnosis Viewer
  2. open entry File Connect to....
  3. configure the desired Server
    (Take care of the correct port selection depending on the version!)
  4. open entry Settings -> Server configuration
  5. configure the events which should be logged
  6. Close the dialog by clicking on OK.

Note: All changes are written to zenon6.ini when the dialog is confirmed.

Configuration of the events which should be logged by the Diagnosis Viewer:

Parameters | Description
Modules | Selection of the modules which you want to configure.
Messagelevel | Selection of the events which should be logged. Default: Errors
LOGImageCnt | Number of records, after which all incremental fields will be written. Default: 0 (not active)
LOGMinFreeDiskSpace | It is continuously checked, if less than the configured minimal free disk space is available. The oldest log files are deleted. Minimal free disk space in MB, before log files are deleted. Default: 1024 MB
LOGMaxUsedDiskSpace | Maximal used disk space for the log in MB. Default: 1024 MB
LOGMinUsedDiskSpace | Minimal used disk space in MB independent whether LOGMinFreeDiskSpace is under-run. Default: 5 MB
LOGLogUpdateTime | Time in ms, after which the received entries are saved. Default: 2000 ms
LOGMaxBufferedRecs | The server buffers the contents of all incremental log fields for diverse applications, in order to be able to write images of them into the log file. With the start of a log file and after configurable number of log entries a complete image for all addresses is written into the log file. Received data are written to the log files. The entry is done via temporary buffer. It can be configured whether the data should be written immediately or delayed. Number of buffered entries if they cannot be saved. Default: 10240
LOGMaxLogFileSize | The server writes the received log data into the log file. If this log file reaches the configured size, a new file is started. Maximal size of a single log file in bytes. Default: 5 MB
LOGDirectory | Folder in which the log files are written. Default: %ProgramData%\COPA-DATA\LOG\
LOGLogLifeTime | It is continuously cheked, if the lifetime of the log files is exceeded. The oldest log files are deleted. Number of seconds to keep the log files. Default: 14 days
LOGCheckDiskTime | Time in sec, in which the used disk space id checked. Default: 60 s
Message level for all modules | Settings are taken over for all modules.
Default values | Restore default settings.
Accept | Take over settings for this module.
Cancel | Discards changes and closes dialog.
OK | Applies changes and closes dialog.


Diagnosis Client

Manual -> Tools -> Diagnosis Viewer -> Diagnosis Client

All programs which create log entries are Diagnosis Clients. These log entries are sent to the Diagnosis Server via TCP/IP. Server computer and port are read - dependent on the used version - from the local zenon6.ini and contacted. If the connection fails the following procedure is carried out cyclically:

  • If the Diagnosis Server cannot be reached, a attempt to reconnect is made every 500 ms.
  • If no connection could be established after half the timeout time, the system tries to start the service zenSysSrv or zenLogSrv.

The settings are configured via entry LOG_CONFIG= in section [SYS_REMOTE] (up to 6.51) or [LOGGING_SYSTEM] (from 7.00).

Configuration Diagnosis Client

To configure the Diagnosis Client via the dialog:

  1. start the Diagnosis Viewer
  2. open entry Settings -> Client configuration
    (only available if logging is inactive)
  3. highlight a Client
  4. click on List of parameters
  5. The dialog for configuration is opened
  6. configure the Client
  7. Close the dialog by clicking on OK.
  8. repeat the procedure for other Clients if necessary

Client list

Parameters | Description
Clients | Lists all available Clients.
Refresh | Updates the list of the Clients.
List of parameters | Opens the dialog for configuring the selected Client.
Close | Closes the dialog.

Configure Client

The available standard modules:

Parameters

Description

Modules

Selection of the modules which you want to configure.

The list is made up of standard modules and modules dependent on the respective client.

  • General: General messages
  • Net: Network messages
  • Proxy: Messages of the zenon Proxy
  • Db: Messages of ZenDbSrv
  • SysSrv: Messages of ZenSysSrv
  • Driver: Messages from a driver
  • Log: Messages from logging
  • SAT: SICAM 230 specific messages

Messagelevel

Type of information which should be logged.

All

Selects all.

None

Deselects all.

Message Level for all Modules

Assigns highlighted message levels to all modules.

Max Buffered records

Number of records to be buffered if no connection to the server is established.
Default: 256

OK

Applies all changes and closes dialog.

Cancel

Discards all changes and closes the dialog.

Accept

Applies all changes. The dialog remains open.

Default values

Enters the default values.


Diagnosis Viewer - Analysis Program

Manual -> Tools -> Diagnosis Viewer -> Diagnosis Viewer - Analysis Program

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Diagnosis Viewer is used to display the log data. It connects to the Diagnosis Server in order to display data online or read back historic log files. Log files contain not only the log data, additional information which is important for the analysis such as column headings are also saved in them.

To display a log file:

  1. select File -> Open
  2. the dialog for selecting a log file is opened with focus on the configured default folder
  3. select the desired file
  4. the log file is displayed

  5. Double click an entry to open the detail view

Recognizing queue overflow at driver

If messages of a driver are deleted because of queue overflow, the Diagnosis Client and the Diagnosis Server set a marker in the new entry when writing a new entry for all activated modules that older entries were deleted from the queue. The overflow recognitions contained in the opened log files are counted:

Parameters | Description
Column Record version | This column must be part of the column selection. It shows the version of the data record. Version 8x tags overflows.
Counter 82 | 8 refers to overflow, 2 refers to the concerned version of the data record.
Status line queue overflows | If status bar is active, the number of overflows is displayed there.

Note: Not all entries written in the log file are displayed. If a not displayed log data record is tagged with an overflow, it will be displayed at the next visualized data record of this client. If several not displayed entries in a row are tagged with an overflow, the counter in the status bar can deviate from the number of data records with overflow tags.


Global settings

Manual -> Tools -> Diagnosis Viewer -> Diagnosis Viewer - Analysis Program -> Global settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The entries are in the English language.

Parameters

Description

File

Commands in menu File.

Open

Opens dialog for selecting a log file saved in TXT format. Each newly opened log file is displayed in its own window.

Open to active document

Each new log file is added to the active window.

Close

Closes the active window.

Save

Saves the log files of the active window.

Save as

Saves the current view of the active window (e.g. filter settings) to a file to be selected.

Remote Download

Only available, if a connection to a Remote Diagnosis Server exists. Enables the download of logging files of the Remote Server to the local log folder. A subdirectory with the name of the PC is created. Only file, which have changed or which are new, are available.

Connect to

Opens the dialog for the Connection selection.

Online

Activates the online error view.
If online logging is started, all incoming entries are displayed. The same filter dialog as for reading files can also be set here.

Difference: If no log connection is selected, all incoming log entries will be displayed, otherwise only the ones from the selected clients.

If the filter of the log connection is modified, all entries not fulfilling the filter criteria will be lost. (Logging file nevertheless is created and all entries are saved.) Displayed entries can be saved.

Offline

Deactivates the online error view. (Default)

Exit

Closes the Diagnosis Viewer.


Connection settings Diagnosis Server connection

Manual -> Tools -> Diagnosis Viewer -> Diagnosis Viewer - Analysis Program -> Global settings -> Connection settings Diagnosis Server connection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Diagnosis Viewer automatically connects to a selected standard Server at the start. If no standard server is defined, localhost is used as standard server. The Server configuration can also be done via zenon6.ini (recommended).

Select Diagnosis Server

Click on File -> Connect to... to open the dialog for selecting a Server:

Parameters

Description

List Server

Lists all configured Servers and displays them:

  • Status
  • Name
  • Port
  • Timeout

OK

Applies settings and closes the dialog.

Cancel

Discards settings and closes the dialog.

New Server

Opens the dialog for configuring a new Server.

Delete Server

Selected Server entry is deleted from the list.

Edit Server

Opens the dialog for configuring the selected Server.

Connect to

Establishes a connection to the selected Server.

As default

Selected server becomes the standard server.

Create and edit Diagnosis Server

Click on New Server or Edit Server in dialog Diagnosis Server connection to open the dialog for configuring the Server:

Parameters | Description
Server name | Name of the PC to which to connect. The following must run on the PC: up to version 6.51: zenSysSrv from version 7.00: zenLogSrv
Port | Port of the service on the target computer: up to version 6.51: 1101 from version 7.00 on: 50780
Timeout | Time in seconds to wait for a response from the Sysservice. Default: 10 s
OK | Applies settings and closes the dialog.
Cancel | Discards settings and closes the dialog.


Column settings

Manual -> Tools -> Diagnosis Viewer -> Diagnosis Viewer - Analysis Program -> Global settings -> Column settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A number of pre-defined columns can be selected in the menu under Settings -> Column settings. These columns and their entries are automatically displayed on opening a new file. Also the sorting and the column width of the selection are regarded. On opening the column width has to be set to Autosize.

Parameters | Description
available | available columns
selected | Columns which are displayed
> | adds columns selected at "available" to "selected"
>> | adds all available columns at "available" to "selected"
< | removes selected columns from "selected"
<< | removes all available columns from "selected"
^ | sorts selected entries one level higher (multi-select is possible)
v | sorts selected entries one level lower (multi-select is possible)
OK | Applies settings and closes the dialog.
Cancel | Discards settings and closes the dialog.

Columns can also be configured via the context menu:

Parameters | Description
Add all columns with entry | Adds all columns which contain entries.
Remove Column | Hides the selected column.
Remove all empty columns | Hides all columns which do not contain entries.
Column width automatic | The width of the selected column is automatically adjusted to the longest entry
All columns widths automatic | The width of all columns is automatically adjusted to the longest entry


Possibilities of Filtering

Manual -> Tools -> Diagnosis Viewer -> Possibilities of Filtering

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To define filters open the corresponding filter dialog via the corresponding symbol or the tab of the filter.

Symbol bar filter

To use the symbol bar, you must activate it in menu View via menu item Icon bar.

Symbol | Tool tip | Description
1 | Change pre-filter settings | Opens dialog with five tabs for defining filters.
2 | Change pre-filter for IP-ProcessID-LogID | Opens tab IP address - Process No - Log ID.
3 | Change pre-filter for modules | Opens tab Modules.
4 | Change pre-filter for additional columns | Opens tab Additional columns.
5 | Change pre-filter for time interval | Opens tab Time interval.
6 | Change pre-filter for coloring | Opens tab Colors.

Filter dialog

Tabs | Description
IP-ProcessID-LogID | Opens tab IP address - Process No - Log ID for configuring the connection which should be logged.
Modules | Opens tab Modules for the modules which should be logged.
Additional columns | Opens tab Additional columns for selecting additional columns which should be displayed.
Time interval | Opens tab Time interval for defining time filter.
Colors | Opens tab Colors for selecting the color-coding of information.


IP address - Process No - Log ID

Manual -> Tools -> Diagnosis Viewer -> Possibilities of Filtering -> IP address - Process No - Log ID

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration of the connections and processes which should be displayed.

Parameters | Description
available | List of available connections.
selected | List of selected connections.
Pfeiltasten | Add selected (>) or all (>>) connections to list selected or removes them from the list (< or <<).
OK | Applies all changes on all tabs and closes the dialog.
Abbrechen | Discards all changes on all tabs and closes the dialog.


Modules

Manual -> Tools -> Diagnosis Viewer -> Possibilities of Filtering -> Modules

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Selection of the modules which should be displayed.

Parameters | Description
Module filter active | Active: It is filtered on modules. With this only log data records are displayed which are assigned to a selected module.
available | Available modules.
selected | Selected modules.
Cursor keys | Add selected (>) or all (>>) connections to list selected or removes them from the list (< or <<).
OK | Applies all changes on all tabs and closes the dialog.
Cancel | Discards all changes on all tabs and closes the dialog.


Additional columns

Manual -> Tools -> Diagnosis Viewer -> Possibilities of Filtering -> Additional columns

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Selection of the columns which should be displayed additionally.

Parameters | Description
available | List of the available columns. All field definitions existing in the file are displayed.
selected | List of the selected columns.
Cursor keys | Add selected (>) or all (>>) connections to list selected or removes them from the list (< or <<).
OK | Applies all changes on all tabs and closes the dialog.
Cancel | Discards all changes on all tabs and closes the dialog.


Time interval

Manual -> Tools -> Diagnosis Viewer -> Possibilities of Filtering -> Time interval

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration of the time filter for displaying the entries.

Parameters | Description
Start time: | Selection of the date and point in time from which entries should be displayed. Default: actual date
End time: | Selection of the date and point in time up to which entries should be displayed. Default: actual date
Reset time interval | Sets filter back to default value.
OK | Applies all changes on all tabs and closes the dialog.
Cancel | Discards all changes on all tabs and closes the dialog.


Colors

Manual -> Tools -> Diagnosis Viewer -> Possibilities of Filtering -> Colors

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Selection of the color-coding of the information.

Parameters | Description
Colors for: | Selection of the color
IP address | Active: Different IP addresses are colored differently.
Modules | Active: Different modules are colored differently.
Log connection | Active: Different names of the log connection are colored differently.
no colors | Active: Entries are not colored.
OK | Applies all changes on all tabs and closes the dialog.
Cancel | Discards all changes on all tabs and closes the dialog.


Reading the log files

Manual -> Tools -> Diagnosis Viewer -> Reading the log files

One or more log files can be opened in an analysis at the same time. A pre-filter has to be set to limit the display. This is possible with five property pages. This filter can be modifies later on. If the filter is set, only the entries fulfilling these filter criteria are displayed. The entries are listed chronologically.

Filter columns

Another filter possibility is available with the filter columns. Filter criteria can be entered for each column in the input field below the column header. The fields support regular expressions, so that also complex filter criteria can be defined. The list can be sorted ascending or descending by clicking the column headers. Displayed entries can be saved. Fields to be displayed can be selected using the Settings -> Column settings menu entry.

Standard fields in the log file:

ID | Parameters | Description
i | IP address | IP address. These fields identify the clients and allow the message to be assigned.
i | Log ID | entry ID These fields identify the clients and allow the message to be assigned.
i | Message Level | Name of the message level for which the message was entered.
i | Module | Name of the module, which entered the message.
i | Process ID | ID of the project. These fields identify the clients and allow the message to be assigned.
i | Record type | Type of entry.
i | Record version | Version number of the entry.
i | Thread ID | ID of the thread, from which the message was entered.
i | Timestamp | Time of the message in UTC.

Optional fields with fix ID.

ID | Constant | Description
1 | Name of log connection | Name of logging connection
2 | Thread name | Name of the threads.
3 | Name of source files | Name of the source file.
4 | Source line | Source line
5 | Assert condition | Assert condition
6 | Computer name | Computer name
7 | Function name | Function name
8 | Project name | Project name
9 | Project GUID | GUID of the project.
10 | Project path | Project path
11 | Sent Data | Sent data
12 | Received data | Received data
13 | no. serial interface | Number of the serial interface.
14 | Baudrate | Baud rate
15 | dtr setting | DTR setting.
16 | rts setting | RTS setting.
17 | Serial char. length | Serial character length
18 | Parity | Parity
19 | No. stopbits | Number of stop bits
20 | CTS | CTS.
21 | dsr | DSR
22 | dsr sensitivity | DSR sensitivity.
23 | Network port no. | Port number in the network.
24 | Server name | Server name.
25 | Standby name | Name of standby server
26 | Client name | Client name.
27 | Server IP | IP address server.
28 | Standby IP | IP address standby.
29 | Client IP | IP address client.
30 | Binary buffer | Binary buffer.
31 | Pointer | Pointer
32 | Class name | Class name
33 | Error code | Error code:
34 | DLL instance handle | DLL instance handle
35 | DLL name | DLL name
36 | Driver error parameter 1 | Driver error parameter 1
37 | Driver error parameter 2 | Driver error parameter 2
38 | Trace Message | Trace message
39 | Errortext | Error text
40 | Error file name | Name of error file.
41 | Success condition | Condition for success
42 | Value if successful | Value when successful
43 | Net adress | Net address:
44 | Datablock | Data block.
45 | Offset | Offset:
46 | Bit number | Bit number
47 | Area in PLC | Area in the PLC.
48 | Communication direction | Shows the direction of the communication in a string.
49 | General text | General text
50 | Main version no. | Number of main version.
51 | Sub version no. | Number of sub-version.
52 | Build no. | Build number.
53 | Servicepack | Service Pack.
54 | Hotfix no. | Hotfix number
55 | Sending client | Client, which sent the command
56 | Target client for command | Client that is the target of the command.
57 | Database no. | Number of database.
58 | Datapoint no. | Datapoint number (channel number)
59 | Datapoint value | Value of datapoint
60 | Datapoint status | Status of datapoint
61 | Datapoint timestamp | Time stamp of datapoint in seconds
62 | Duration in ms | Error wait time in milliseconds.
63 | Number, counter | number, counter.


Structure of the log file

Manual -> Tools -> Diagnosis Viewer -> Structure of the log file

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Log files are ANSI text files. The single fields are separated by tabs. The final character is CR+LF. So, the Notepad can be opened to display the files.

Log files contain information sequentially, not chronologically sorted.


Message levels

Manual -> Tools -> Diagnosis Viewer -> Structure of the log file -> Message levels

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Eight groups exist for the subdivision of log messages. They are bit coded and therefore can be combined.

1 | Error messages
2 | Warnings
4 | Success message
8 | TRACE
16 | ASSERT
32 | Log messages
64 | Debug
128 | Extended debug


Search function

Manual -> Tools -> Diagnosis Viewer -> Structure of the log file -> Search function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With View/Find the current window can be searched. All hits are marked.


Profiles

Manual -> Tools -> Diagnosis Viewer -> Structure of the log file -> Profiles

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Column settings can be saved as profiles.

To save profiles:

  1. enter a name into the filed in the tool bar
  2. click on the disk symbol on the right-hand side

To load profiles:

  1. select a saved profile from the combo box
  2. click on the second symbol on the right-hand side with the disk

The profiles are saved a *.lvs files.


Handling of errors and messages for the Diagnosis Viewer

Manual -> Tools -> Diagnosis Viewer -> Handling of errors and messages for the Diagnosis Viewer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Error

Error

Possible causes

The port cannot be opened.
  • Another application uses the port.
    Check via "netstat".
  • The ports for entries
    [SYS_REMOTE] CONFIG and
    [LOGGING_SYSTEM] CONFIG
    are identical. zenLogSrv and zenSysSrv then try to open the same port.

Diagnosis Clients do not start the zenLogSrv
  • zenAdminSrv was terminated. Without it the service cannot be started.
  • zenLogSrv is not registered as a service at the PC. In this case enter the following in the command line: zenLogSrv.exe –Service
  • Diagnosis Clients are not of version 7.00 SP0 or higher. The zenLogSrv is only supported from this version on.
  • Under Windows CE: The individual components (Runtime, SysSrvCE, LogSrvCE) are located in different folders. They must be located in the same folder. Otherwise the components do not find one another.

Under CE many processes are created by SysSrvCE.exe or LogSrvCE.exe.
  • One of the two entries in zenon6.ini
    [SYS_REMOTE] INIT or
    [LOGGING_SYSTEM] INIT
    has the value 2.
    As a result the application only displays the user interface and does not open the Listening port. Each Diagnosis Client then tries to start the process as it cannot connect to the Diagnosis Server.

Several processes crash.

(Unhandled Exceptions of the Diagnosis Server at receiving log messages or configuration commands or of the Diagnosis Client and Diagnosis Viewer during booting or during receiving the configuration)
  • The versions do not match. Diagnosis Clients, Diagnosis Server and Diagnosis Viewer must either all have version 7.00 SP0 or higher or all version 6.51 SP0 or earlier (see Compatibility).

LOG entries

Entry

Description

SysSrv received not supported network message!

zenSysSrv received a network telegram which is not supported. Example: Log entries.

LogSrv received not supported network message!

zenLogSrv received a network telegram which is not supported. Example: Remote Transport commands

Could not open listening port. Server will be stopped.

The zenLogSrv or the zenSysSrv could not open its Listening port. The error message is logged as follows:

  • zenLogSrv and zenSysSrv at PC:
    Entry in the Windows event display.
  • zenSysSrv under CE:
    Message box for the user and log entry to the Diagnosis Server.
  • zenLogSrv under CE:
    Message box for the user.

The following log entries are assigned to different systems. The first part of the messages states whether service or Client are effected:

  • SysSrv: zenSysSrv
  • SysCli: Client to the zenSysSrv
  • LogSrv: zenLogSrv
  • LogCli: Diagnosis Client
Entry | Description
[SysSrv/LogSrv/SysCli/LogCli] Info InitString [String] | A network connection has been initialized with the displayed configuration string. Server opens ports and Clients connect to the Server.
[SysSrv/LogSrv/SysCli/LogCli] WINSOCK ERROR | An exception occurred during a network operation. The details are also displayed.
[SysSrv/LogSrv] Accept Failed! | An incoming connection from a Client could not be accepted.
[SysSrv/LogSrv/SysCli/ LogCli] Write Faild | Not all data which should be sent could be sent. The number of the sent bytes and the number of the bytes which should be sent is displayed.
[SysSrv/LogSrv] Client [String] in List Delete! | The Client log off from the Server.
[SysSrv/LogSrv] Client [String] in List Insert | The Client log on to the Server.


Keyblock Runtime Start

Manual -> Tools -> Keyblock Runtime Start

Keyblock Runtime Start is a program with which zenon Runtime runs as a shell. In doing so, zenon Runtime is started, but all Windows system tasks are blocked. Shortcuts such as Windows key or Ctrl+Alt+Del no longer have an effect. User can no longer access the operating system but only work on the zenon user interface.

The precondition for this is that the project properties are set Runtime title to No title (full screen). Then zenon runs in full screen mode and the Runtime cannot be minimized.

Note also the information provided in the Protect Runtime files chapter.

tutorial License information

Part of the standard license of the Editor and Runtime.


Usage

Manual -> Tools -> Keyblock Runtime Start -> Usage

To use Keyblock Runtime Start:

  1. in the Windows start folder under COPA-DATA open the zenon tools
  2. Select Keyblock Runtime Start
  3. the program starts and automatically starts the Runtime
  4. The program blocks all access to the operating system.
    • locked shortcuts:

      Ctrl+Alt+Del

      Ctrl+Esc

      Alt+Tab

      Alt+Esc

      Alt+F4

      Windows key
      When locking the system keys, the normal operation of the scroll bars with the mouse in the Runtime is also blocked. You can work around the blocking with the help of the context menu.

    • Hiding the Control Panel in the start menu
    • Locking the tool bar for operation
    • Prevents

      Changing passwords

      Closing Windows

      Logout

      Locking the computer

      User change

    • Hiding all element in the task manager

info Information

If Keyblock Runtime Start is started using the startup process of the operating system:

  • take care that the auto start folder is user-specific: If an other user is logged in, the program is not executed.
  • Processing the startup process programs can be prevented by pressing the Shift key when the operating system is booting.

This locking cannot be bypassed during Runtime. When the Runtime is closed normally, the system restrictions are canceled. If the Runtime should be operable without these limitations, the Runtime must be started instead of Keyblock Runtime Start.

attention Attention

Take care that you engineer a possibility to close the Runtime in your project. There is no possibility to end the Runtime regularly.

  • if it can only be ended by turning off the computer
  • all system keys are still locked after a restart

To make systems keys available after an irregular ending (e.g. black out):

  • start the Runtime again with the help of Keyblock Runtime Start
  • end the Runtime regularly via a close button


Protect Runtime files

Manual -> Tools -> Keyblock Runtime Start -> Protect Runtime files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The access to the Runtime files can be strongly restricted and therefore well protected. At this only a single Windows user has read and write rights for the Runtime folder. All other Windows user do not have any rights in the Runtime folder including read rights. Operators in the Runtime log on as zenon user.

In order to limit access to the file system:

  1. Only create a single Windows user (for instance: zenon_ADMIN) who is authorized to start zenon as well as to read and write in the zenon Runtime folder.
  2. Disable access to the zenon Runtime folder for all other Windows users – including read authorizations!
  3. Disable any remote access to the user zenon_ADMIN.
  4. Block any software for remote maintenance or remote access such as zenon Remote Desktop.
  5. Make sure that zenon can only be started if this user (zenon_ADMIN) is logged in.
    Since other Windows users do not have read authorization Runtime will only start in the context of this user (zenon_ADMIN).
  6. Make sure that zenon runs as shell:
    1. For this purpose, create a zenon autostart with Keyblock Runtime Start
    2. activate the property Lock system keys in the group Runtime settings of project properties
    3. start zenon in full-screen mode: Set property Runtime title to No title
    4. also bear multi-screen systems in mind in the configuration
    5. disable Explorer start
    6. do not offer file selection dialogues
      (in this case no functions may be projected which require the user to select files in Runtime)

The access to the zenon file system is then protected.


Online updating of the zenon Help:

Manual -> Tools -> Online updating of the zenon Help:

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Documentation Download Tool administers the updating of your online help including embedded help, dialog help, tooltips and the PDF product documentation from zenon and zenon Logic.

The updating is carried out online. An internet connection is necessary for this.

Contents of the documentation update:

The Documentation Download Tool supports the updates of:

  • zenon and zenon Logic product documentation
  • Driver Documentation
  • Tutorials
  • Glossary

File formats of the documentation update:

The Documentation Download Tool supports the updates of:

  • Online help for zenon and zenon Logic (.chm)
  • zenon product documentation (.pdf)

Note: The tool is only available in English

tutorial License information

Part of the standard license of the Editor and Runtime.


Installation

Manual -> Tools -> Online updating of the zenon Help: -> Installation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Documentation Download Tool is automatically installed with zenon.


Starting the program

Manual -> Tools -> Online updating of the zenon Help: -> Starting the program

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To start the Documentation Download Tool:

  • Go to the folder C:\Program Files (x86)\Common Files\COPA-DATA\STARTUP.
  • Start the program DokumentationDownloadTool.exe by double clicking on it.
  • The program start dialog opens


Navigation

Manual -> Tools -> Online updating of the zenon Help: -> Navigation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

It is possible to navigate through the individual dialogs by means of the navigation bar in the lower area of the dialog:

Button | Description
Exit | Closes the Documentation Download Tool
Back | Goes back one dialog in the tool process.
Next | Goes forward one dialog in the tool process.
Proxy Settings | Opens/closes expandable list for the configuration of the proxy settings. Only active in the start dialog.


Proxy Settings

Manual -> Tools -> Online updating of the zenon Help: -> Proxy Settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The proxy settings of your network can only be configured using the Proxy Settings entry.

To call this up, click on Proxy Settings in the start window of the tool. It is only possible to call this up in the start dialog. This property is not active in subsequent dialogs.

Parameters | Description
Auto-detect proxy settings for this network | The proxy settings of your system are used for communication with the internet. (Default: active)
Manual proxy configuration | Enables the proxy settings to be configured.
Proxy: | Address of the proxy server
Port: | Port of the proxy server (default: 8080)
User | User name on the proxy server (optional)
Password: | Password on the proxy server (optional)

info Information

The Documentation Download Tool notes these proxy settings. If you regularly change your password, you must also change the password in the proxy settings of the Documentation Download Tool.


Incorrect proxy settings

Manual -> Tools -> Online updating of the zenon Help: -> Proxy Settings -> Incorrect proxy settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

An error dialog appears with incorrect entries.

Confirm this error dialog with OK to automatically return to input of the Proxy Settings.


Selection of version

Manual -> Tools -> Online updating of the zenon Help: -> Selection of version

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this dialog, select the version of zenon to be updated.

Parameters | Description
List of installed versions | Lists the versions of zenon installed on the computer. Select the version to be updated by simply clicking. Note: only one version of COPA-DATA can be updated each time. Multiple selection is not possible.
Exit | Closes the Documentation Download Tool
Next | Goes forward one dialog in the tool process.
Proxy Settings | Not active in this dialog.


Language dialog

Manual -> Tools -> Online updating of the zenon Help: -> Language dialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this dialog, you select the zenon language to be updated.

Parameters

Description

List of available languages

Lists the languages available for zenon:

  • English (ENGLISH)
  • French (FRENCH)
  • German (GERMAN)
  • Italian (ITALIAN)
  • Russian (RUSSIAN)
  • Spanish (SPANISH)

Select the language to be updated by clicking on it.

Note: only one version of COPA-DATA can be updated each time. Multiple selection is not possible.

Exit

Goes back one dialog in the tool process.

Back

Goes back one dialog in the tool process.

Next

Goes forward one dialog in the tool process.

Proxy Settings

Not active in this dialog.


No updates available

Manual -> Tools -> Online updating of the zenon Help: -> Language dialog -> No updates available

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If online and offline help is up to date, a dialog appears:

Clicking on the OK button reverts to the Language dialog.


Language-dependent content of zenon help

Manual -> Tools -> Online updating of the zenon Help: -> Language dialog -> Language-dependent content of zenon help

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Available language content for zenon and zenon Logic:

Language | Embedded help | Online/offline help | Online/offline driver documentation
English | English | English | English
French | French | English | English
German | German | German | German
Italian | Italian | Italian | English
Russian | Russian | English | English
Spanish | Spanish | English | English


Overview of available updates

Manual -> Tools -> Online updating of the zenon Help: -> Overview of available updates

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Once the update conditions have been selected, a dialog with the available updates is displayed:

Parameters | Description
List of available Updates. | List of the documents that are available for the selected version of zenon. Note: the list is for information only. Selection is not possible.
Exit | Closes the Documentation Download Tool
Back | Goes back one dialog in the tool process.
Next | Goes forward one dialog in the tool process.
Proxy Settings | Not active in this dialog.


Status dialog

Manual -> Tools -> Online updating of the zenon Help: -> Status dialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This dialog shows the progress when downloading the PDF and/or online help file to be updated.

Parameters

Description

Fileinformation

Detailed information on the file that is currently being downloaded:

  • File origin
  • File size
  • Save location on the local computer

Current File:

Status of the current file including current download speed

Overall Progress

Status of the complete update including percentage and remainder display

Exit
  • Cancels the download that is currently in progress
  • Closes the Documentation Download Tool

Pause

Pauses the current download

Resume

Resumes the download that was paused (by clicking on Pause).

This button is only active if the Pause button has been pressed beforehand

Cancel

Cancels the current download

Proxy Setting

Not active in this dialog.


Download complete

Manual -> Tools -> Online updating of the zenon Help: -> Status dialog -> Download complete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following dialog is shown once the download has been completed:

Parameters | Description
Exit | Closes the Documentation Download Tool
Resume | Not active in this dialog.
Restart | Reverts to the start dialog of the tool.
Proxy Settings | Not active in this dialog.


Cancel

Manual -> Tools -> Online updating of the zenon Help: -> Status dialog -> Cancel

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following dialog is displayed once the Cancel button has been clicked:

Parameters | Description
Exit | Closes the Documentation Download Tool
Resume | Not active in this dialog.
Restart | Reverts to the start dialog of the tool
Proxy Settings | Not active in this dialog.


Startup Tool

Manual -> Tools -> Startup Tool

The Startup Tool makes it possible:

  • to start Editor and Runtime with certain parameters
  • to run different zenon versions on one computer in parallel
    (already installed zenon versions are automatically created in the Startup Tool)
  • to administrate different SQL instances for the same zenon version
  • to administrate the settings for different versions
  • to define the language of the Editor and the Runtime before the start
  • To define the language of the web client

tutorial License information

Part of the standard license of the Editor and Runtime.

attention Attention

The Startup Tool does not start when the service zenAdminSrv is not running. If it is not active, you can start it manually in the Windows Control Panel under Administrative tools/Services.


Start dialog

Manual -> Tools -> Startup Tool -> Start dialog

You administrate the currently installed zenon versions in the start dialog. From version 7.10, you have the possibility to choose whether to start Editor and Runtime as a 32-bit application or as a 64-bit application.

If only a 32-bit version of zenon 7.10 was specified or an older version was detected, only one button is shown for the Editor and Runtime respectively:

If both versions are specified, separate buttons for 32-bit and for 64-bit are displayed.

Button

Function

List of zenon versions.

Shows all installed zenon versions.

Move entry down

Moves the selected entry in the list downwards.

Move entry up

Moves the selected entry in the list upwards.

Editor

Starts the Editor of the selected zenon version

Two separate buttons are available for 64-bit versions. The button for 64-bit contains a corresponding indication in the bottom left corner.

Runtime

Starts the Runtime of the selected zenon version

Two separate buttons are available for 64-bit versions. The button for 64-bit contains a corresponding indication in the bottom left corner.

Register

Registers all services of the selected zenon version.

  • Standard: Registers zenon. ZenSysSrv is registered as a process.
  • Terminal Server: Registers zenon for use with a terminal server. Procedures:
    ZenDBSrv is deregistered and no longer re-registered and also not started.
    ZenSysSrv is registered as a service.
    The entries in zenon6.ini are amended for use on the terminal server.

If, in an entry, there are no parameters stored for workspace and/or Runtime, the current version is re-registered. This applies for registration as standard and as a terminal server.

Help

Opens online help.

Tools

Opens a dialog for starting additional applications of the selected zenon version

If the tools for a valid 64-bit version are opened, then the tools are displayed in two lists for 32-bit tools and 64-bit tools.

Processes during starting

When starting the Editor or the Runtime, data from the start settings are written to the zenon6.ini file. Existing settings in the INI file are overwritten.

Since version 5, network communication has been handled with the two services zenNetSrv.exe and zenSysSrv.exe. Both files must exist in the zenon folder. As these services are version dependent, they must be registered for the appropriate version.

attention Attention

After conversion of a project into a later zenon version, this can no longer be edited with the previous version and will no longer run on it. However, the backup version created during the conversion can still be used in the original editor.

For network projects, the same zenon Editor versions must be started on the server and clients.


Application

Manual -> Tools -> Startup Tool -> Start dialog -> Application

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Entry | Function
Options | Opens the dialog for configuring the settings.
Exit | Closes the Startup Tool.

Options

  • The Options entry in the Application menu opens the dialog to configure the properties for:
  • General: general settings
  • Network configuration: Configuration of the network and the strong encryption of network communication
  • Listening ports: Configuration of the listening ports
  • Service startup: Start programs as a service


General

Manual -> Tools -> Startup Tool -> Start dialog -> Application -> General

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

General settings:

Parameters

active

inactive

Start Startup Tool mimimized

Starts the Startup Tool minimized. You can reach the tool with the help of its icon in the task bar.

The context menu offers all possible actions from the Start dialog for the active zenon.

Opens the tool on the desktop (default).

Remember last registered version

Sets the chosen version as standard and selects it automatically at the next start. Then the version is not registered again (default).

Offers the first version in the list when starting the Startup Tool. When the Editor or the Runtime are started, the respective version is always registered again.

Register all OCX files of selected version

registers all OCX files (ActiveX controls) which exist in the program folder.

This option makes sure that there are always appropriate ActiveX controls for each version (default).

Attention: It has no influence on the registration of ActiveX controls and COM servers which are listed in the individual settings of the respective version.

registers only the pre-set components.

This option accelerates the registration process and is appropriate for all projects which do not use ActiveX.

Set Language for Editor or Runtime

Starts Editor or Runtime with the language selected in the selection list.

Makes sure that zenon always uses the defined language when started from the Startup Tool. This does not influence the direct start of >CD_PRODUCTNAME<.exe.

Starts Editor or Runtime with the language defined in zenon6.ini. There the set language is the language which has lastly been used in zenon or defined there under Options -> Settings -> Editor and Runtime selected language (default).


Network configuration

Manual -> Tools -> Startup Tool -> Start dialog -> Application -> Network configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following applies for zenon from version 7 onwards:

  • you can use IPv6
  • you can encrypt the transfer in the network.

This dialog configures:

  • Time-outs
  • the use of TCP/IP via IPv4 or IPv6
  • the serious encryption of the network communication at the local computer

Parameters

Description

General settings

General settings.

Changes of these settings are written to the registry in files zenon6.ini or zenon.ini and overwrite possibly varying manual configuration.

Changed settings must be carried out for all Runtime computers or all connected stations. At changes of the IPv6 settings, the computer must be restarted.

Changes are carried out after leaving the dialog only after the confirmation of a warning message with click on button Yes.

Network communication timeout

Time-out for network communication in seconds.
Default = 30

Equals entry NET_TIMEOUT_MSEC= in file zenon6.ini.

Network module timeout

Time-out for module communication in seconds.
Default = 30

Equals entry NET_NETMODULE_TIMEOUT_MSEC= in file zenon6.ini.

Time synchronisation with server project

Active: Time is compared with a server project (default).

Inactive: Time is not compared (for circular redundancy, for example)

Equals entry TIMESYNCH in file zenon6.ini.

Use IPv6 for all TCP/IP connections

Active: All TCP connections are only established via IPv6.

Inactive: All TCP connections are only established via IPv4.

Dual operation is not possible.

Equals entry USEIPV6= in file zenon6.ini.

Note: If this option is changed, the computer must be rebooted. The change must also be carried out on all connected stations.

The following components are not affected by the setting:

  • Driver communication with the PLCs
  • Protocol communication in the Process Gateway plug-ins
  • Workbench and Runtime communication in zenon Logic

Attention: Only works with version 7 onwards. No versions prior to version 7 can be started if this is active.

Encrypt network communication

Settings for serious encryption in the network

Encrypt network communication

Active: Communication in the network is encrypted.

Note: This encryption is also applicable for zenon web client communication.

Password

Enter password.

For the criteria, see the "Network encryption password" section in the Strong encryption of network communication chapter.

The displayed length is always set at 20 characters, in order to hide the actual length.

The password defined here is stored encrypted in the zenon6.ini.

Verify password

Enter the password for verification again.

attention Attention

If entries were changed manually in the local zenon6.ini, they are overwritten as soon as the confirmation message is answered with "Yes" at the registration.

Messages

For explanations about system messages and error messages see chapter Message at registration.

info Information

You can find notes on error messages from strong encryption in:

Network handbook -> Strong encryption of network communication chapter -> Error messages section.


Listening ports

Manual -> Tools -> Startup Tool -> Start dialog -> Application -> Listening ports

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab, the ports that are used by zenon can be individually configured for individual applications. The settings that were saved in the respective zenon6.ini file are used in Runtime.

attention Attention

Note the following during configuration:

  • Changes in this tab can trigger a restart of the computer.
  • All computers with which communication takes place must have the same settings.
  • These settings are not available under Windows CE.
  • If an IP address is defined, it must be amended if the setting for IPv6 is activated or deactivated
  • If a defined network address is not connected at the time when the service is started, no listening socket is opened
  • Error messages are not logged in the diagnosis server but in the Windows application event log

Listening ports dialog

Parameters

Description

Application

List with all configurable applications. The selected application can be configured by means of the options in Settings.

Settings

Settings for the application selected in Application.

All network adapters

All available network cards are used for the binding of the listening ports. (as before). This is a standard setting.

Single local IP address

The local address defined here is used for the binding of the listening ports.

Supported protocols:

  • IPv4
  • IPv6

Single network adapter

The first address of the network card defined here is used for the binding of the listening ports.

Default port

The standard port number is used for the binding.

Customer port

The port number defined here is used for the binding.

OK

Applies all changes in all tabs and closes the dialog.

Cancel

Discards all changes in all tabs and closes the dialog.

Port assignment

Assignment of the standard ports to applications:

Application | Standard port
Administration Service | 50777
Analyzer Connector Service | 50778
Analyzer License Service | 50779
DB Service | 1103
Logging Service | 50780
Network Service | 1100
SNMP Trap Service | 50782
Transport Service | 1101
WEB Service Classic | 1102
WEB Service Tunneling | 8080


Service startup

Manual -> Tools -> Startup Tool -> Start dialog -> Application -> Service startup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Programs can be started automatically using the zenStartupMgr service. You can use this to start Runtime automatically as a service.

Dialog Service startup

Parameters | Description
Liste Services | List of configured services.
New | Opens dialog to select a program.
Edit | Opens the dialog to edit the highlighted entry.
Delete | Deletes the highlighted entry.
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.

Select program dialog

Parameters | Description
Program | Path to the program that is to be started as a service. A click on the ... button opens the file selection dialog. Maximum length: 259 characters
Parameters | Input of parameters. Maximum length: 259 characters
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.

Start Runtime as a service

To start Runtime as a service:

  1. Register the file zenStartupMgr.exe as a service:
  2. Configure the properties for sign-in.
  3. Start, if necessary, Remote Transport with zenStartupMgr
  4. Define the Runtime to be started in the Startup Tool
  5. Configure a start delay for zenon Runtime if you are using a dongle license

You can find details on this in the Runtime manual in the Starting Runtime as a service chapter.

Attention: If Runtime is started using the zenStartupMgr, it can no longer be stopped or restarted by users.

Register service

To register zenStartupMgr.exe as a service:

  1. Open the command line.
  2. Go to the save location of the file zenStartupMgr.exe.
    (default with 32-bit OS: %ProgramFiles(x86)%\Common Files\COPA-DATA\zenStartupMgr
    (default 64-bit OS: %ProgramFiles\Common Files\COPA-DATA\zenStartupMgr)
  3. Register the file as a service with the zenStartupMgr.exe –service command.
    Note: The service, if it is already running, is first stopped and then registered. If zenStartupMgr is running, it is closed.

Configure service for the use of many drivers

Windows as an operating system limits the number of windows that can be created due to its fixed, reserved desktop memory, depending on the version and possible integration with the desktop.

Version/action | Interactive Desktop | Non-Interactive Desktop
Windows 7 32-Bit | 12 MB | 512 KB
Windows 7/Windows Server 2008 R2 64-bit | 20 MB | 768 KB

zenon drivers each need several windows. The number of drivers that can be used can be influenced using the Allow data exchange between service and desktop option in the properties of the service.

  • Inactive A maximum of 20 drivers can be started.
  • Active: As many drivers as there are in a Runtime started as a user process can be started.

To activate the Allow data exchange between service and desktop option:

  1. Open the Windows Service Manager.
  2. Open the properties of the zenStartupMgr service.
  3. Go to the Login tab.

  4. Activate the Allow data exchange between service and desktop.
    This service must be configured to automatic start type. With the service active, the user logged on to the computer is notified if the zenon Runtime as a service opens an additional window, for example in the event of a new alarm and active status line.

    Note Windows 8/Server 2012: In order for the service to be able to be started, the entry must be set correctly in the Windows registry:

    1. Go to the entry HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Windows.
    2. Open or create the DWORD value NoInteractiveServices.
    3. Set the decimal value of 1 to 0.
  5. To stop Runtime messages being displayed on the desktop:
    Deactivate the Detection of inactive services service.


Item

Manual -> Tools -> Startup Tool -> Start dialog -> Item

The menu Item has the following entries:

Entry | Function
New | Creates a new entry in the list and opens dialog Properties.
Delete | Deletes the selected entry after confirming a confirmation message.
Properties | Opens dialog Properties for the selected entry.


Help

Manual -> Tools -> Startup Tool -> Start dialog -> Help

In menu help the following entries exist:

  • Help: opens the online help
  • Info about: shows current version information.


Properties

Manual -> Tools -> Startup Tool -> Properties

In dialog Properties the parameters for each entry are defined:

Entry | Function
General | General settings
Database | Settings for the database connection
Extras | Settings for registering ActiveX controls (OCX) and COM servers (DLL) and for starting additional programs or batch files.


General

Manual -> Tools -> Startup Tool -> Properties -> General

In this part, details about the zenon versions are entered. The path to the 32-bit version of zenon is absolutely necessary. If the Startup Tool detects a 64-bit version, the path to the 64-bit version is also unlocked for input.

The following properties are available for a selected entry:

General

Parameters

Description

Name

Distinct name as it should be displayed in the list. This entry is absolutely essential.

Version

Startup Tool automatically enters the version number of zenon. For this you must first select the program path under Path.

Programm path (32-bit)

Program path in which the executable 32-bit version of the zenon file (Zenrt32.exe) is located.

If a 64-bit version of zenon is detected here, the Program path (64-bit) property is also unlocked for input.

Programm path (64-bit)

Program path in which the executable 64-bit version of the zenon file (Zenrt32.exe) is located.

Input only possible if the path to the 32-bit version was stated and a 64-bit version was detected by zenon.

As soon as both paths have been entered correctly, the buttons for starting Editor and Runtime are divided into two buttons, one for 32-bit and one for 64-bit.

Editor

Parameters | Description
Workspace | The desired workspace when the Editor is started. As soon as this is entered all projects which are in this workspace are displayed automatically in the drop-down list under Editor project.
Editor-Project | Select the project which should be active after the Editor started.
Overwrite INI settings | Active: The settings of this dialog are always used when the Editor is started. Changes made while working with the Editor are discarded. (This affects Workspace, Editor-Project, RT-Project and RT-Path).
Take over INI settings | Active: All amended settings for Workspace, Editor project, RT project and RT path are saved in zenon6.ini after the Editor is closed, read into the Startup Tool and used again on the next restart.

Runtime

Parameters | Description
RT-Project | Project that is set as the start project for Runtime.
RT-Path | Path of the project. If the Runtime project is part of the workspace, the path is entered automatically.

info Info

Unknown parameters?

If the settings for the workspace are unknown, use the following approach.

  1. Enter Name, Path and Workspace
  2. Leave Editor-Project, RT-Project and RT-Path empty
  3. Activate Read back the INI settings
  4. Leave dialog by clicking OK.

After the Editor has been started and closed once, the start settings are automatically taken from the INI file.


Database

Manual -> Tools -> Startup Tool -> Properties -> Database

Define the database properties. It is possible to use different SQL instances for the different entries (zenon versions).

attention Attention

As of version 6.51 the SQL instance can be defined and the password is saved in an encrypted form. New entries have a higher priority than existing entries.

Compatibility: If nothing is changed, the existing entries remain valid. If you change an entry for version 6.51 or higher, the new entries are valid. Older versions must be maintained separately. You can find the settings for version previous to 6.51 in chapter Database previous version 6.51.

Display dialog: The display of the dialog is automatically adopted to the selected version (previous 6.51, as of 6.51).

Entry

Function

Read from zenDB.ini

Clicking on the button reads off the settings from the zenDB.ini file and the following fields are automatically filled:

  • SQL instance
  • DB Path
  • User
  • Password

Clear all fields

All input field are cleared.

Empty entries are not written to zenDB.ini at registering.

SQL Instance

Name of the SQL server instance which should be used.

The name can be entered directly in the input field or can be selected from the drop-down list.
Note: By clicking on the drop-down list the local computer is searched for instances which are then listed. The search may take some time.

DB Path

Path for the SQL database of the zenon projects.
For example: C:\ProgramData\COPA-DATA\SQL\

Attention: Different SQL Servers (for example 2008R2 and 2012) must use separate paths.

Background: When converting projects the GUID stays the same. If the same folders are used, both instances overwrite each others database files.

User

User name for the database.

Necessary rights

In the SQL Server the user must have the following Server roles:

  • public
  • sysadmin

Password

Password of the user. It is stored encrypted. The entry length is always displayed with 20 characters regardless of the actual length.

Attention: The encryption is done via the Startup Tool. Therefore you must carry out the database setting via the Startup Tool.

These settings are saved in the zenDB.ini file.


Database previous version 6.51

Manual -> Tools -> Startup Tool -> Properties -> Database -> Database previous version 6.51

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Setting of the database property before zenon 6.51:

Entry

Function

Read from zenDB.ini

After a click on the button, the settings from file zenDB.ini are read and the fields Provider, DB Path are filled automatically.

Clear all fields

All input field are cleared.

Empty entries are not written to zenDB.ini at registering.

Provider

Connection to the SQL instance. Important information:

  • Instance name
  • Used provider
  • User name
  • User password

For example:
Provider=SQLNCLI.1;
Password=srv_000;
Persist Security Info=False;
User ID=zenOnSrv;
Initial Catalog=%s;
Data Source=localhost\ZENON_DEV;

DB Path

Path for the SQL database of the zenon projects.
For example: C:\ProgramData\COPA-DATA\SQL\

Attention: It is necessary that SQL Server 2005 and SQL Server 2008 R2 use different folders.

Background: When converting projects the GUID stays the same. If the same folders are used, both instances overwrite each others database files.

attention Attention

The entry for Provider differs in this dialog from the entry in the zenDB.ini.

Dialog: String starts with Provider=...

zenDB.ini: String starts with Provider=Provider=...


Extras

Manual -> Tools -> Startup Tool -> Properties -> Extras

Here, you create ActiveX controls (*.ocx) or COM servers (*.dll) which should be registered together with the respective zenon version. The OCX and DLL can originate from any source, i.e. they can be written by you or by other manufacturers. Additionally you can define programs which are carried out before the starting or after the closing the Editor or the Runtime.

Registration ActiveX Controls - COM Server

All files listed here are automatically registered together with the respective zenon version - independent of the central setting register.

Parameters | Description
Filename/Filepath | List of all files to be registered
Add | opens the Windows dialog for selecting a file to be registered. There you can select OCX or DLL files individually and add them to the list. First select the wanted file type (OCX or DLL). All files are saved with path information. If the path changes, remove the link with Remove and create a new one.
Remove | Removes all selected entries from the selection list of the files to be registered.

Pre-start and post-start programs

With Pre Start and Post Start, you can define programs and batch files which should be executed before starting or after closing zenon.

Parameters | Description
Pre Start | External program that should be started, before the Editor or Runtime is started.
Post Start | External program that should be started, after the Editor or Runtime is closed. Attention: Post Start is only executed if the Read back the INI settings (Item->Properties->General) option was activated.


Message at registering

Manual -> Tools -> Startup Tool -> Message at registering

Pop-up at registering

Message

Meaning

You have changed the IPv6 setting. All internal TCP/IP connections will be switched to IPv6/IPv4.

To ensure that all affected components are properly switched you have to restart the computer! You will also have to change this setting on all connected station!

Do you really want to apply the change?

You change the settings for the IP protocol from IPv4 to IPv6 or vice versa.

After the changes you must restart the computer for all services to be adapted accordingly. The change must also be carried out on all connected stations.

These changes are written to zenon6.ini or zenon.ini together with the registration and overwrite any manual configurations.

Gerneral network configuration settings will be changed.

You have to restart the runtime to apply the changes!

Attention: Do not forget to adept the settings on other stations as well.

Apply settings.

Are you sure this is your intent?

You change general settings in the same ways as time outs.

These changes are written to zenon6.ini or zenon.ini together with the registration and overwrite any manual configurations.

You must adapted changed settings for all Runtimes.

Message at registering

At registering the service all steps are displayed in an own window which closes after 4 seconds automatically. When an error occurs, an warning message informs you about the cause. After confirming the message the procedure is canceled. zenon is not started. Possible error messages:

Message | Reason | Hint
Couldn´t find zenNetSrv Service! | File zenNetSrv.exe is missing from the zenon program folder or a wrong version is available. | Most of the time the fastest an safest solution is a new installation of zenon.
zenNetSrv.exe still running! | The service zenNetSrv.exe could not be stopped. | It is possible that a security tool is running on the computer which prevents the access.
Couldn´t find zenSysSrv Service! | File zenNetSrv.exe is missing from the zenon program folder or a wrong version is available. | Most of the time the fastest an safest solution is a new installation of zenon.
zenSysSrv.exe still running! | The service zenSysSrv.exe could not be stopped. | It is possible that a security tool is running on the computer which prevents the access.


Command line

Manual -> Tools -> Startup Tool -> Command line

You can also operate the Startup Tool using the command line. For this file zenon_Startup.exe must be present in the system path. You can find the file

  • for Windows 7/8 in the C:\Program Files\Common Files\COPA-DATA\STARTUP folder

In the commando line you can:

  • create new entries
  • reorganize existing entries (e.g. after older versions have been deleted)
  • register entries


Parameters

Manual -> Tools -> Startup Tool -> Command line -> Parameters

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The input is started with zenon_Startup.exe followed by a Parameter and possible field names.

Parameters:

Parameters | Function | Field name | Return value
-new | creates a new entry. | yes, list see also new | 0 or 1
-reg | registers services | Name of the entry | none
-reorg | checks and reorganizes existing entries | not available | none

If the startup tool is only called up with -reg, only the version is re-registered. In doing so, zenon6.ini is accessed on a read-only basis only. The version defined in the [PATH] section is registered; all parameters are taken from zenon6.ini.

Using several parameters at once:

It is possible to use several parameters at once. If several -new parameters are used at once, the return value cannot be evaluated unambiguously.

In general when several parameters are used, it is proceeded in the following order:

  1. –new: Create new entries.
  2. –reg: Register the stated entry.
  3. –reorg: Remove all invalid entries for deleted zenon versions.


new - Creating new entries

Manual -> Tools -> Startup Tool -> Command line -> Parameters -> new - Creating new entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameter -new is used for creating new entries. It needs at least two field names:

  • NAME as unique name for the entry

    If the name of the entry is already available, no entry is created.

  • PATH as path in which zenon is stored.

Syntax

The syntax is constructed as follows: zenon_Startup.exe -> Parameter > Field name="TEXT"

  1. zenon_Startup.exe
  2. Space
  3. Parameters
  4. Space
  5. Field name
  6. = character
  7. opening quotation marks
  8. Text
  9. closing quotation marks

Example Example

zenon_Startup.exe -new NAME="New entry" PATH="C:\Example Directory\zenon"

Field name

The following field names can be used:

Field name | Mandatory field | Description
NAME | X | Unique name of the entry. For example: NAME="Test"
PATH | X | The user path in which zenon is saved. For example: PATH="C:\Program Files (x86)\COPA-DATA\zenon 7.10 SP0"
PATH64 | - | The application path, in which the 64-bit version of zenon is located. For example: PATH="C:\Program Files\COPA-DATA\zenon 7.10 SP0"
PROJECT_RT | - | Name of the Runtime project which should be started. For example: PROJECT_RT="Test project"
PROJECT_RT_PATH | - | The Runtime folder of the project (see PROJECT_RT). For example: PROJECT_RT_PATH="C:\Users\Public\Documents\zenon_projects\test projekt"
PROJECT_ED | - | The project which should be activated in the Editor. For example: PROJECT_ED="Test project"
WSP | - | The workspace with which the Editor should be loaded. For example: WSP="C:\Users\Public\Documents\zenon_projects\DEMO622.WSP6"
SQLSRV | - | Name of the SQL Server which should be used by the Editor. For example: SQLSRV="MSSQL$ZENON_DEV"
PROVIDER | - | Provider string for the initialization of the SQL connection. For example: PROVIDER="Provider=SQLNCLI.1;Password=000;Persist Security Info=False;User ID=zenOnSrv;Initial Catalog=%s;Data Source=localhost\ZENON_DEV;"
DBPATH | - | Path for the SQL database which should be used For example: DBPATH="C:\ProgramData\COPA-DATA\SQL\"
PRESTART | - | Program call which is executed before the start of the Editor or the Runtime or the registering of this version. For example: PRESTART="C:\zenon versions\zenon 6.50\Dlls\zenVNCCli.exe"
POSTSTART | - | Program call which is executed after the Editor is closed. For example: POSTSTART="C:\zenon versions\zenon 6.50\Dlls\zenVNCCli.exe" Attention: Post Start is only executed when in the Startup Tool or in Startup.ini option Read back the INI settings (Item -> Properties -> General) is activated.

The field names are separated by spaces.

info Information

Paths with spaces must always be put between parentheses.

Return Values

0 - execution faultless

1 - entry could not be created


reorg - reorganizing of entries

Manual -> Tools -> Startup Tool -> Command line -> Parameters -> reorg - reorganizing of entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameter -reorg checks all entries whether the linked zenon version is still available in the file system. If the application files are no longer found, the entry is finally deleted from the Startup Tool.

The command does not provide a return value. After execution the Startup Tool is started.

Example: zenon_Startup.exe -reorg


reg - register entries

Manual -> Tools -> Startup Tool -> Command line -> Parameters -> reg - register entries

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The –reg parameter registers all necessary services in the folder of the stated entry. It is called up via:

  • -reg "Name of the entry"

If the Startup Tool has already been started, nothing is registered but the Startup Tool is moved to the foreground.

The command does not provide a return value.

Example Example

zenon_Startup.exe -reg "Version 6.50"

registers version 6.50.

Prerequisite: there is an entry with this name in the Startup Tool.


System Information Collector

Manual -> Tools -> System Information Collector

When solving problems, COPA-DATA Support may ask for the relevant data about your operating system and zenon. The easiest way for you to create this data is in an automated manner with the System Information Collector and then sending this to Support.


Starting the System Information Collector

Manual -> Tools -> System Information Collector -> Starting the System Information Collector

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The System Information Collector is also installed when zenon is installed. It is located at:

  • Computer in the path: %Program Files (x86)%\Common Files\COPA-DATA\STARTUP
  • Installation medium in the path \Additional Software\System Information Collector.

To start the System Information Collector:

  1. Windows 8: enter SIC as a search term for Apps on the desktop
    Windows 7: go to Start/All Programs/zenon/Version Independent Tools
    or: start it from the installation medium
  2. Click on System Information Collector
  3. The System Information Collector starts

Menu and tool bar

Menu

The following options are available to you in the menu:

  • File
    • New Scan: Opens the Start window.
    • Open: opens a saved report
    • Save: saves the currently-displayed report as a ZIP file
    • Exit: closes the System Information Collector
  • Edit
    • Copy: copies highlighted text to the clipboard
    • Find: opens a dialog to search the current report
  • View
    • Expand: expands all nodes
    • Collapse: closes all nodes
  • Help
    • About: Information on the program version

With the exception of Exit and About, all options are available via the tool bar.

Toolbar

Symbol | Description
Home New Scan | Opens the Start window.
Open | Opens a saved report.
Save | Saves the currently-displayed report as a ZIP file.
Copy | Copies highlighted text to the clipboard.
Find | Opens a dialog to search the current report
Expand | Expands all nodes.
Collapse | Closes all nodes.


Collecting information

Manual -> Tools -> System Information Collector -> Collecting information

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To collect information in an automated manner:

  1. Start the System Information Collector
  2. Select one of the four options by clicking on the corresponding button
    • Full: collects information about the system and zenon. Dump files are not collected
    • System: collects information about the system only
    • Scada: collects information about zenon, without dump files
    • Scada with dumpfiles: collects information about zenon and includes dump files

  3. The System Information Collector creates a report with the desired information

  4. The completed report is displayed in the main window


Using the information

Manual -> Tools -> System Information Collector -> Using the information

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

All information collected is displayed in the System Information Collector. They can:

  • Save the report
  • Navigate through the report and search for certain information
  • Highlight selected information and copy it to the clipboard

Saving a report

To save a report:

  1. Click on the Save symbol or the Save command in the File menu
  2. The dialog for voluntary entry of a password for the encryption of a report opens
  3. the dialog for selecting a folder and file name is opened
  4. The report is saved as a ZIP file

Open report

To open a saved report:

  1. Click on the Folder symbol in the tool bar
  2. Select the report
  3. If you have entered a password for the encryption of the report when saving, enter it again now or jump the step by clicking on OK
  4. The report is opened

Saving selected information

To saved selected information only:

  1. highlight the relevant information.
  2. Click on the Copy symbol or the Copy command in the Edit menu
  3. The selection is saved to the clipboard
  4. Insert the content into a text file and save this
  5. Repeat this process for further selected information


Forward report to COPA-DATA

Manual -> Tools -> System Information Collector -> Forward report to COPA-DATA

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The report can, depending on its size, be forwarded as an e-‑mail or uploaded to a defined save location to COPA-DATA. You can find out details on how you forward the report and which online save location you can use for this from your COPA-DATA Support contact.


User administration

Manual -> User administration

zenon supports user administration for the Editor and for online operation Runtime. The password system fulfills the guidelines of the FDA (Food and Drug Administration, 21 CFR Part 11). It is also possible to administer Active Directory users in Runtime.

tutorial License information

Part of the standard license of the Editor and Runtime.

The concept

The concept of zenon user administration assumes that different users have different operating rights (authorization levels and function authorizations). Administrators also have different rights, but have additional administrative rights, such as the administration of users. Users can be administered via zenon and the Windows Active Directory.

Each user can be assigned several different authorizations. A maximum of 128 (0 to 127) authorizations can be configured. Users can be assigned to the individual authorization levels and the attendant project-specific password design in relation to this can be created completely freely. Each user can have any level allocated. Thus e.g. user 1 can have levels 0, 1, 5 and 6 assigned and user 2 can have levels 0, 1, 6, 8 and 10 assigned. Authorizations can only be issued if the administrator has those rights himself.

The user is logged in in Runtime using the login function and a login screen. If the user is to be logged in automatically based on an event (e.g. position of a key known to the system), the Login without password function is used. This function is projected with a limit value or a Rema of the variable in the variable management, respectively. With multi-project administration, users can automatically be logged in to subprojects with automatic login.

If during a defined period of time there is no operation, an automatic time-triggered logout can be engineered. Users can log off from the system at any time using the logout function. The user SYSTEM is thus logged in.

Creating users and issuing rights

In zenon, you can create and administer users in two ways:

  1. zenon Editor and Runtime:
    Users are created in the Editor and given rights. You can log in in Runtime. Administrators can also create users in Runtime and issue rights.
  2. AD and AD LDS:

    Active Directory Lightweight Directory Services (AD LDS) is a simplified version of the Active Directory and is suitable for use on normal desktop operating systems; it is not necessary to use a server operating system. Active Directory (AD) and AD LDS can be used in zenon for the user administration in zenon Runtime. AD and AD LDS are not available for the zenon Editor.

    User groups that are created in AD or AD LDS receive authorizations in zenon, if user groups with the same name are created in zenon. A separate screen can be used to to read AD and AD LDS from zenon Runtime and edit them. Users who are created here have user rights for all zenon projects, regardless of the project from which they were created.


Engineering in the zenon Editor

Manual -> User administration -> Engineering in the zenon Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Users and user groups, passwords and authorizations are defined in the Editor. Settings can be modified in Runtime. Not all changes in the Editor are accepted after a simple reload. Changes in Runtime must be reloaded into the Editor in order to be able to be edited there and to guarantee the same status for Runtime and the Editor. Note the RT changeable data property when transferring Runtime files. Here, it is specified whether the configuration of the user administration is transferred to Runtime and overwrites the configuration in Runtime. The contents of the user administration are not replaced by default when transferred to Runtime.


Context menu Project manager

Manual -> User administration -> Engineering in the zenon Editor -> Context menu Project manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu user administration

Menu item | Action
Editor profiles | Opens the drop-down list with predefined editor profiles.
Help | Opens online-help

Context menu user

Menu item | Action
New user | Opens the dialog for creating a new user and adds the new user to the list of the detail view.
Export XML all... | Exports all entries as an XML file.
Import XML | Imports entries from an XML file.
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.

Context menu user group

Menu item | Action
New user group | Opens the dialog for creating a new user group and adds the new user group to the list of the detail view.
Export XML all... | Exports all entries as an XML file.
Import XML | Imports entries from an XML file.
Editor profiles | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.

Context menu detail view: see also User administration detail view toolbar and context menu


Toolbar and context menu detail view

Manual -> User administration -> Engineering in the zenon Editor -> Toolbar and context menu detail view

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Menu item/symbol | Action
New user | Opens the dialog for creating a new user and adds the new user to the list of the detail view.
Jump back to starting element | If you entered the list via function linked elements, the symbol leads back to the start element. Only available in the context menu when all linked elements are opened.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Export selected XML.. | Exports all selected entries as an XML file.
Import XML | Imports entries from an XML file.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Remove all filters | Removes all filter settings.
Properties | Opens the Properties window for the selected entry.
Help | Opens online help.

Context menu user group

Menu item | Action
New user group | Opens the dialog for creating a new user group and adds the new user group to the list of the detail view.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Export selected XML | Exports all selected entries as an XML file.
Import XML | Imports entries from an XML file.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Remove all filters | Removes all filter settings.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Help | Opens online help.


Creating a user

Manual -> User administration -> Engineering in the zenon Editor -> Creating a user

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a new user:

  1. navigate to node User administration/User
  2. in the context menu of the project manager, the detail view or in the tool bar select New user...
  3. The dialog for configuration is opened
  4. in the individual tabs define the settings for:
    • User
    • Password
    • Message Control
    • Authorization levels
    • User groups

info Information

Recommendation: As first user define an administrator. Only they can access all functions and therefore reactivate users who were locked because they have been blocked by the system.


User

Manual -> User administration -> Engineering in the zenon Editor -> Creating a user -> User

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration of the user:

Parameters

Description

User name

Enter the username. The user logs in to the system with his username.

Maximum length: 20 characters.

Note: This name must be unique.

Complete name

Enter the full name of the user. With this you can allocate a username to a real person.

Administrator

Active: The user gets the status of an administrator.

Only an administrator can create new users, edit users, delete passwords, etc. in the Runtime.

Active

Active: The user is active and can login in the Runtime.

Note: According to FDA 21 PART 11 regulations, a user can never be deleted, so it is possible to trace who carried out which action at any time. Therefore for projects which adhere to these regulations, a user must not be deleted but only deactivated.

To prevent the deletion of users, deactivate the User administration property in the Deleting users group in the project properties.

Locked

Active: The user is locked in the Runtime and cannot login.

This option is set automatically if a user enters an incorrect password more than is permitted.

Lock code

Four-digit PIN code.

This code is used by the user for the command input in order to lock and unlock different areas.

Login profile

Selection of the Runtime profile that is used for login from a drop-down list:

  • None
  • Default
  • Last

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Change password

Manual -> User administration -> Engineering in the zenon Editor -> Creating a user -> Change password

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Defining or changing the password.

Passwords may have a maximum of 20 characters. The minimum length is defined in the project settings in property Minimum password length in group User administration. The default value is 6 characters.

Parameters | Description
Old password | Current password.
New password | Enter new password. For language-spanning projects take care that it must be possible to enter the characters with the respective keyboard in the Runtime.
Confirm password | Repeat the password.

Note: The function Copy and paste is not available for entering information in the password field.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Message Control

Manual -> User administration -> Engineering in the zenon Editor -> Creating a user -> Message Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Options for using the users in module Message Control.

Parameters

Description

Message Control User

Active: The user is used by the module Message Control.

Telephone

Number of the voice-compatible telephone device of the user. Used for text to speech.

Enter numbers. In addition, the following are permitted:

  • The prefix + as an abbreviation for 00 of the international area code is permitted.
  • The following separators are also permitted in AD user administration: Minus (-), slash (/) and space
    Note: When communicating between AD and Message Control, separators are ignored as soon as the data from the is mapped to a zenon object.

Cell phone

Mobile phone number of the user. Used for messages via GSM and SMS (text messages).

Enter numbers. In addition, the following are permitted:

  • The prefix + as an abbreviation for 00 of the international area code is permitted.
  • The following separators are also permitted in AD user administration: Minus (-), slash (/) and space
    Note: When communicating between AD and Message Control, separators are ignored as soon as the data from the is mapped to a zenon object.

Email

E-mail address of the user

Substitute person

If a user has not been reached or they do not accept the message, a substitute person can be given. A click on button ... Opens the dialog to select a user.

PIN code

PIN code with which the user confirms the message.

NA code

PIN code with which the user rejects the receipt of the message (not available). The message is then sent to the next user in the list.

If there is no other user entered in the list, the message is entered as "not successfully acknowledged". The function assigned to this is executed. In addition, a "rejected by" CEL entry is created in each case.

Note: You can find further information on the assignment of functions in the Confirmation of receipt - confirmation of receipt settings chapter.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

attention Attention

The acknowledgment codes for PIN (confirmation) and NA (rejection) must differ and should not be too similar.

If both codes are identical the code is interpreted as PIN and therefore as confirmation of the message.

If an unknown code is received, an SMS and e-‑mail is sent to the substitute person. The error message is played back for voice messages.


Authorization levels

Manual -> User administration -> Engineering in the zenon Editor -> Creating a user -> Authorization levels

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Defining the authorization level for the user.

Parameters | Description
Available authorization levels | List of all available authorizations.
Selected authorization levels | List of assigned authorizations.
Button double arrow to the right | Entries selected in the list Available authorization levels are added to list Selected authorization levels.
Button double arrow to the left | Selected entries in list Selected authorization levels are removed from the list.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


User groups

Manual -> User administration -> Engineering in the zenon Editor -> Creating a user -> User groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Assignment of the user to user groups.

Parameters | Description
Available user groups | List of all available user groups.
Selected user groups | List of assigned user groups.
Button double arrow to the right | Entries selected in the list Available user groups are added to list Selected user groups.
Button double arrow to the left | Selected entries in list Selected user groups are removed from the list.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Create a user group

Manual -> User administration -> Engineering in the zenon Editor -> Create a user group

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a user group:

  1. Highlight the User Groups entry in the tree view of the Project Manager under the user administration entry
  2. Right-click on the detailed view area (Project Manager Detail View) or directly on the User Groups entry
  3. Select the New user group command in the context menu or alternatively click on the corresponding symbol in the toolbar
  4. The Create new user group dialog is opened.
  5. Define the name and authorization levels

info Information

Each user group must have an unambiguous name in a project.

It is possible to create user groups with the same name in the global project and in the local project. If this is the case, the authorizations of the user group from the local project are used in the event of a conflict. If the local user group is deleted, the user again receives the rights from the group of the global project after the Runtime files are compiled in the Editor.

Example:

A user group A is present in both the local project and in the global project. In the global project it is allocated the authorization levels 1, 2, 3, 100 and 101, and authorization levels 1 and 2 in the local project. In Runtime, the rules from the local project apply; only the authorization levels 1 and 2 are allocated. If user group A is not present in the local project, members of group A have authorization levels 1, 2, 3, 100 and 101 from the global project.


Name the user group

Manual -> User administration -> Engineering in the zenon Editor -> Create a user group -> Name the user group

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters | Description
Name | Name of the new user group Attention: @ is not a valid character for a user group.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Authorization levels

Manual -> User administration -> Engineering in the zenon Editor -> Create a user group -> Authorization levels

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Assignment of the authorization level to a user group.

Parameters | Description
Available authorization levels | List of all available authorizations
Selected authorization levels | List of assigned authorizations
Button double arrow to the right | Entries selected in the list Available authorization levels are added to list Selected authorization levels.
Button double arrow to the left | Selected entries in list Selected authorization levels are removed from the list.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Order in Message Control

Manual -> User administration -> Engineering in the zenon Editor -> Create a user group -> Order in Message Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Defines the order of users within a group for the use of module Message Control.

Parameters | Description
Users | List of all available users.
Up | Moves selected user up one place.
Down | Moves selected user down one place.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Editing an user

Manual -> User administration -> Engineering in the zenon Editor -> Editing an user

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A user is changed by selecting the user from the list in the detail view. As a result of this, the corresponding properties are displayed in the properties window and can be changed here.


Changing a user group

Manual -> User administration -> Engineering in the zenon Editor -> Changing a user group

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A user group is changed by selecting the user group from the list in the detail view. The respective parameters are displayed in the properties window as a result of this. You can change the Name and Authorization levels parameters.

info Information

If you rename a user group, all users that are linked to this user group lose this link. The user group is displayed with (del).

If there is already a user group with the same name in the global project however, all users previously linked to the group that has now been renamed assume all authorization levels of this user group.


Changing the names of the authorization levels

Manual -> User administration -> Engineering in the zenon Editor -> Changing the names of the authorization levels

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can change the names of the authorization groups globally for your project. To do this, go to the User administration group in project properties and click on the Rename authorization levels property there.

Open the editing field with a double click in the desired line of the Name column. Make the changes. The input is closed as soon as the focus is no longer in the field or it has been confirmed with Enter. The name is not changed if you press Esc or leave the edit field empty.


Function authorizations

Manual -> User administration -> Engineering in the zenon Editor -> Function authorizations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Function authorizations can be assigned in zenon. These function authorizations relate to functions in Runtime and the configuration of modules in the Editor. If a user does not have the function authorization, then

  • In Runtime: the corresponding functions cannot be executed
  • in the Editor: Tool bars and context menus of the corresponding module are grayed out

Configuration of the function authorizations

Function authorizations are configured in the zenon Editor.

Assigning the function authorizations

This assignment is effected by means of:

  • Function authorizations Runtime
  • Function authorizations Editor

For global projects, the assignment is the same as for the Editor. In the process, the possibilities for selection are determined by the node points present in a global project.

As soon as one or more authorization levels greater than 0 are used, a login dialog appears when the project is loaded in the Editor. This dialog also appears if only one user was created in the project. This means that projects can be protected in the Editor. When entering the user name and password, a distinction is made between capital letter and small letters (case sensitivity).

In general, the following applies:

  • All project configurations for drag over and drag & drop take module rights into account.
  • For module rights that are not granted:
    • The respective menu and tool bars are grayed out in the zenon Editor.
    • No change to the project configuration is possible in the nodes and sub-nodes of the detail view.
    • The corresponding key combinations are not active.
    • The properties are grayed out in the properties window. As a result of this, further or "more in-depth" project configurations cannot be reached (for example combined elements, reaction matrix statuses, archive configuration etc.).
    • If there are no module rights for the function authorization screen, editing of screens with the mouse is also no longer possible.

attention Attention

Therefore please note, even at the engineering stage, that at least one user is assigned to the following three authorization levels:

  • Load project
  • Project
  • User administration


Configuration of function authorizations

Manual -> User administration -> Engineering in the zenon Editor -> Function authorizations -> Configuration of function authorizations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To issue a function authorization:

  1. Select the user administration project properties in the project properties User administration
  2. In the Function authorizations properties field, click on the ... button
  3. The dialog for configuration is opened.
  4. Issue the function authorization for the respective function in Runtime and/or for the respective module in the Editor.
  5. Allocate the desired function authorization to an authorization level.

To do this, it is necessary to have the respective licensing rights for the corresponding module. This is not taken in to account when engineering the individual authorization levels.

Note: Changes to the function authorizations are only effective once the Editor has been restarted and/or the project has been reloaded.


Function authorizations Runtime

Manual -> User administration -> Engineering in the zenon Editor -> Function authorizations -> Function authorizations Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For all actions, the user must be logged in and have the corresponding authorization levels.

Function authorizations, general

Parameters

Description

Edit Extended Trend

Curves in Extended Trend can be edited in Runtime. The following control elements are not available if the user does not have authorization:

  • Diagram
  • Curves
  • Settings
  • Cursor on/off
  • X-Axis

Return to last screen (PgUp)

Screen 'back' functions can be executed in Runtime.

Screen switch: Enable "Show this dialog in Runtime"

The Screen switch function, with the Show this dialog in Runtime option active, can only be executed if the user who is logged in meets authorization requirements.

Notepad: Open file

The function file open in screenNotepad can only be carried out if the logged in user has the appropriate authorization level.

Notepad: Save file

The function save in screenNotepad can only be carried out if the logged in user has the appropriate authorization level.

Function authorizations for alarms

Parameters

Description

Change alarm comment

A Comment necessary for acknowledgement may be changed.

Enter alarm comment

A comment necessary for acknowledgement can be entered.

Delete alarm

Alarms can be deleted in Runtime.

Acknowledge alarm via alarm status line / context menu

Acknowledging an alarm via the alarm status line or the context menu is only possible if there is an authorization in the project of the alarm that is currently displayed.

For multi-project administration: Acknowledging the system message in the alarm status line or via the context menu is only possible if there is authorization in the integration project.

Comment: System messages are messages that appear in the alarm status line when a certain (configurable) number of alarms has been reached.

Acknowledge alarm via screen Alarm Message List

Acknowledging via Alarm message List screens is only possible with authorization in the project linked to the variable (multi-project administration).
Note: If there is no authorization, the blinking is stopped but the alarm is not acknowledged.

Acknowledge alarm via function

Acknowledging via a function is only possible if there is an authorization for the selected alarms in the respective projects.

Edit archive

Archive data (Archive server) can be amended in Runtime.

You can set different authorization groups for each of these acknowledging methods. This allows you, for example, to configure that a certain user group can only acknowledge via the alarm status line, not in any other way.

info Info

Acknowledging an alarm is only possible if there is an authorization for the selected alarms in the according projects.

Function authorization Batch Control

Parameters | Description
Batch Control: Control recipe - create, rename, duplicate | Control recipes in the Batch Control module can only be created and administered if the user has the corresponding rights.
Batch Control: Control recipe - edit phase | Control recipes in the Batch Control module can only be edited if the user has the corresponding rights.
Batch Control: Control recipe - Delete | Control recipes in the Batch Control module can only be deleted if the user has the corresponding rights.
Batch Control: Control recipe (execution) - skip active condition | When executing control recipes in the Batch Control module, a phase can only be exited if the user has the corresponding rights.
Batch Control: Control recipe (execution) - exit phase | When executing control recipes in the Batch Control module, pending conditions can only be skipped if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - switch execution mode | In test mode, with master recipes in the Batch Control module, the execution mode can only be switched if the user has the corresponding rights.
Batch Control: Control recipe (execution) - switch execution mode | When executing control recipes in the Batch Control module, the execution mode can only be switched if the user has the corresponding rights.
Batch Control: Control recipe (execution) - execute, jump single steps | When executing control recipes in the Batch Control module, the execution of individual steps can only be skipped if the user has the corresponding rights.
Batch Control: Control recipe (execution) - hold phase | When executing control recipes in the Batch Control module, a phase can only be stopped if the user has the corresponding rights.
Batch Control: Control recipe (execution) - resume phase | When executing control recipes in the Batch Control module, a phase can only be continued if the user has the corresponding rights.
Batch Control: Control recipe (execution) - restart phase | When executing control recipes in the Batch Control module, a phase can only be restarted if the user has the corresponding rights.
Batch Control: Control recipe (execution) - pause phase | When executing control recipes in the Batch Control module, a phase can only be paused if the user has the corresponding rights.
Batch Control: Control recipe (execution) - abort recipe | When executing control recipes in the Batch Control module, execution of the recipe can only be aborted if the user has the corresponding rights.
Batch Control: Control recipe (execution) - hold recipe | When executing control recipes in the Batch Control module, a recipe can only be stopped if the user has the corresponding rights.
Batch Control: Control recipe (execution) - resume recipe | When executing control recipes in the Batch Control module, a recipe can only be continued if the user has the corresponding rights.
Batch Control: Control recipe (execution) - restart recipe | When executing control recipes in the Batch Control module, a recipe can only be restarted if the user has the corresponding rights.
Batch Control: Control recipe (execution) - pause recipe | When executing control recipes in the Batch Control module, a recipe can only be paused if the user has the corresponding rights.
Batch Control: Control recipe (execution) - start recipe | When executing control recipes in the Batch Control module, a recipe can only be restarted if the user has the corresponding rights.
Batch Control: Control recipe (execution) - stop recipe | When executing control recipes in the Batch Control module, a recipe can only be stopped if the user has the corresponding rights.
Batch Control: Operation: create, edit, rename, duplicate, save | Operations in the Batch Control module can only be created, edited or administered if the user has the corresponding rights.
Batch Control: Operation: release | Operations in the Batch Control module can only be approved if the user has the corresponding rights.
Batch Control: Operation: delete | Operations in the Batch Control module can only be deleted if the user has the corresponding rights.
Batch Control: Master recipe: create, edit, rename, duplicate, save | Master recipes in the Batch Control module can only be created and administered if the user has the corresponding rights.
Batch Control: Master recipe - release | Master recipes in the Batch Control module can only be approved if the user has the corresponding rights.
Batch Control: Master recipe - Delete | Master recipes in the Batch Control module can only be deleted if the user has the corresponding rights.
Batch Control: Master recipe - Switch between test mode and edit mode | Switching between test mode and editing mode is only possible for master recipes in the Batch Control module if the user has the corresponding rights
Batch Control: Master recipe - highlight as outdated | Master recipes in the Batch Control module can only be marked as obsolete if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - skip active condition | In test mode, with master recipes in the Batch Control module, it is only possible to skip a pending condition if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - escape phase | In test mode, with master recipes in the Batch Control module, it is only possible to exit a phase if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - execute, jump single step | In test mode, with master recipes in the Batch Control module, it is only possible to skip the execution of individual steps if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - hold phase | In test mode, with master recipes in the Batch Control module, a phase can only be stopped if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - edit phase | In test mode, with master recipes in the Batch Control module, a phase can only be edited if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - resume phase | In test mode, with master recipes in the Batch Control module, a phase can only be continued if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - restart phase | In test mode, with master recipes in the Batch Control module, a phase can only be started if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - pause phase | In test mode, with master recipes in the Batch Control module, a phase can only be paused if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - abort recipe | In test mode, with master recipes in the Batch Control module, a recipe can only be aborted if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - hold recipe | In test mode, with master recipes in the Batch Control module, a recipe can only be held if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - continue recipe | In test mode, with master recipes in the Batch Control module, a recipe can only be continued if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - restart recipe | In test mode, with master recipes in the Batch Control module, a recipe can only be continued if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - pause recipe | In test mode, with master recipes in the Batch Control module, a recipe can only be paused if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - start recipe | In test mode, with master recipes in the Batch Control module, a recipe can only be started if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - stop recipe | In test mode, with master recipes in the Batch Control module, a recipe can only be stopped if the user has the corresponding rights.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Function authorizations Editor

Manual -> User administration -> Engineering in the zenon Editor -> Function authorizations -> Function authorizations Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters

Description

Load project

The project can only be loaded in the Editor, If the logged-in user is assigned to the corresponding user level.

Comment: In order to not be blocked out of a project, at least one user must be assigned to this function authorization.

Switch on/off history of changes

The history of changes can only be switched on or off in the Editor, If the logged-in user is assigned to the corresponding user level.

Project

The project properties can only be amended in the Editor, If the logged-in user is assigned to the corresponding user level.

Comment: In order to not be blocked out of a project, at least one user must be assigned to this function authorization.

Variables

Only then is the Variables node available in the Editor for editing and engineering, If the logged-in user is assigned to the corresponding user level.

Screens

Only then is the Screens node available in the Editor for editing and engineering, If the logged-in user is assigned to the corresponding user level.

Functions

Only then can functions and scripts be edited or engineered in the Editor, If the logged-in user is assigned to the corresponding user level.

Language file

Only then can language switching be edited or engineered in the Editor, If the logged-in user is assigned to the corresponding user level.

Historian

Only then is the Historian module available in the Editor for editing and engineering, If the logged-in user is assigned to the corresponding user level.

Recipes

Only then can standard recipes and the Recipegroup Manager be edited or engineered in the Editor, If the logged-in user is assigned to the corresponding user level.

Time control

Only then can time control be edited or engineered in the Editor, If the logged-in user is assigned to the corresponding user level.

Programming interfaces

Only then is the Programming interfaces node available in the Editor for editing and engineering, If the logged-in user is assigned to the corresponding user level.

zenon Logic

Only then can zenon Logic projects be edited or engineered in the Editor, If the logged-in user is assigned to the corresponding user level.

Production & Facility Scheduler

Only then is the Production& Facility Scheduler module available in the Editor for editing and engineering, If the logged-in user is assigned to the corresponding user level.

Interlockings

Only then can interlockings be edited or engineered in the Editor, If the logged-in user is assigned to the corresponding user level.

Load Management

Only then is the Load management module available in the Editor for editing and project configuration, If the logged-in user is assigned to the corresponding user level.

Message Control

Only then is the Message Control module available in the Editor for editing and project configuration, If the logged-in user is assigned to the corresponding user level.

Menus

Only then can menus be edited or engineered in the Editor, If the logged-in user is assigned to the corresponding user level.

Report Generator

Only then is the Report Generator available in the Editor for editing and engineering, If the logged-in user is assigned to the corresponding user level.

User administration

Only then can users and user groups be edited or engineered in the Editor, If the logged-in user is assigned to the corresponding user level.

Comment: In order to not be blocked out of a project, at least one user must be assigned to this function authorization.

SAP interface

Only then is the SAP interface module available in the Editor for editing and engineering, If the logged-in user is assigned to the corresponding user level.

Files

Only then is the Files node available in the Editor for editing and engineering, If the logged-in user is assigned to the corresponding user level.

Batch Control

Only then is the Batch Control module available in the Editor for editing and engineering, If the logged-in user is assigned to the corresponding user level.

Change

Opens the dialog to select the authorization levels.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

info Info

With the help of Ctrl and/or Shift you can select more than one entry at a time.

  • By pressing and holding Ctrl you can select a number of entries.
  • By pressing and holding Shift and select two entriey, you select all entries which lie between the two selected entries.
  • By pressing and holding both Ctrl and Shift and selecting two entries, all entries which lie between the selected entries are selected. The entries which were selected beforehand remain selected.


Screen types, dialogs and functions for login and user administration

Manual -> User administration -> Engineering in the zenon Editor -> Screen types, dialogs and functions for login and user administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Login

It is possible to log in to Runtime by means of:

  • A Login screen: Permanent login, temporary login and/or entry of a signature via screen switching.
  • Temporary login modal dialog: Is used for a temporary login if no login screen is linked.
  • Login with dialog function: Login via a modal dialog or the login screen if this has been linked.
  • Login without password function: Logging in a user without entering a password by means of direct linking or by chip identification system.

If a login screen is to be used for temporary login or the Login with dialog function is to be used, it must be linked in the Screen for Login project property.

User administration

The following types of user are available:

  • User list screen: Lists all zenon users who have been created and makes it possible to create, edit or delete these via the Edit user screen and to configure authorization levels.
  • User group list screen Lists all zenon user groups that have been created and makes it possible to create new ones and configure authorization levels.
  • Edit user screen: Makes it possible to edit users and passwords in Runtime.
  • Change user function: Opens a dialog to edit users and user groups.
  • Change password function: Opens a dialog to edit your own password.


Creating a screen of the type Login

Manual -> User administration -> Engineering in the zenon Editor -> Screen types, dialogs and functions for login and user administration -> Creating a screen of the type Login

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a login screen:

  1. Create a new screen in the Editor.
  2. Select login as the screen type.
  3. Select Add template in the control elements menu.
  4. Adapt the screen to your requirements:
  5. Create a function for screen switching to this screen and link it with a button.

Screen of type Login

Control element | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.
Current user (display) | Display of the currently logged in user
User name | Input area for username.
Password | Input field for password.
Signature | Input field for signature.
Login | Button to close the screen after login.
Cancel | Cancels the login process.
Apply | Applies all changes and leaves the dialog open. Exception: The window is closed if the maximum number of invalid login attempts has been set to 0 using the Max. user error property.

info Information

When logging in/out, the corresponding entries are created in the CEL all projects concerned.


Screen switch to login

Manual -> User administration -> Engineering in the zenon Editor -> Screen types, dialogs and functions for login and user administration -> Creating a screen of the type Login -> Screen switch to login

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With screen switching, you define which screen is opened in Runtime for user login.

To create a screen switch to a login screen:

  1. Create a function.
  2. Select screen switching.
  3. select the login screen.
  4. Link the function to a button.


Creating a user list screen

Manual -> User administration -> Engineering in the zenon Editor -> Screen types, dialogs and functions for login and user administration -> Creating a user list screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The user list screen lists all zenon users of the project who have been created and makes it possible to call up the Edit user screen and thus create, edit or delete users and configure authorization levels. Users from the global project are not displayed and cannot be administered.

Note: This screen type is not available under Windows CE.

To create a user list screen:

  1. Create a new screen in the Editor.
  2. Select user list as the screen type.
  3. Select Add template in the control elements menu.
  4. Adapt the screen to your requirements:
  5. Create a function for screen switching to this screen and link it with a button.

User list screen

Control element | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.
User list | Displays the configured users.
New | Opens the screen defined in screen switching to create a new user.
Edit | Opens the screen defined in screen switching to edit a new user.
Delete | Deletes the selected user after requesting confirmation.
Function authorizations | Opens the dialog for issuing function authorizations.


Screen switching to the user list

Manual -> User administration -> Engineering in the zenon Editor -> Screen types, dialogs and functions for login and user administration -> Creating a user list screen -> Screen switching to the user list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With screen switching, you define which screen is opened in Runtime for the creation or editing of users.

To create a screen switch to a user list screen:

  1. Create a function.
  2. Select screen switching.
  3. Select user list screen.
  4. The dialog for configuration is opened.
  5. Configure the screen switching.
  6. Confirm the configuration by clicking on OK.
  7. Link the function to a button.

User list dialog

Parameters | Description
Column settings | Display and configuration of the columns. Changing the order is carried out by moving the mouse or with the column selection button. The column width is set by moving the mouse or with the column format button.
Column selection | Opens the dialog for configuration of the columns.
Column Format | Opens the dialog to format the columns..
Linked screens | Configuration of the screens that are opened in Runtime by clicking on the New and Edit buttons.
Screen for "New user" button | Opens the dialog to select a screen in order to select a screen to create a new user in Runtime. Only Edit user screens can be selected.
Screen for "Edit user" button | Opens the dialog to select a screen in order to select a screen to edit a user in Runtime. Only Edit user screens can be selected.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Column selection

Manual -> User administration -> Engineering in the zenon Editor -> Screen types, dialogs and functions for login and user administration -> Creating a user list screen -> Screen switching to the user list -> Column selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column selection

Configuration of the columns to be displayed:

Button | Function
Available columns | List of columns that can be displayed in the table.
Selected columns | Columns that are displayed in the table.
Add | Moves the selected column from the available ones to the selected items. After you confirm the dialog with OK, they are shown in the detail view.
Add all | Moves all available columns to the selected columns.
Remove | Removes the marked columns from the selected items and shows them in the list of available columns. After you confirm the dialog with OK, they are removed from the detail view.
Remove all | All columns are removed from the list of the selected columns.
Up | Moves the selected entry upward. This function is only available for unique entries, multiple selection is not possible.
Down | Moves the selected entry downward. This function is only available for unique entries, multiple selection is not possible.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


Column Format

Manual -> User administration -> Engineering in the zenon Editor -> Screen types, dialogs and functions for login and user administration -> Creating a user list screen -> Screen switching to the user list -> Column Format

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Column Format

Configuration of the properties of the columns for configurable lists. The settings have an effect on the respective list in the Editor or - when configuring screen switching - in Runtime.

Available columns

Parameters | Description
Available columns | List of the available columns via Column selection. The highlighted column is configured via the options in the Settings area.

Settings

Parameters

Description

Settings

Settings for selected column.

Labeling

Name for column title.

The column title is online language switchable. To do this, the @ character must be entered in front of the name.

Width

Width of the column in characters.
Calculation: Number time average character width of the selected font.

Alignment

Alignment. Selection by means of radio buttons.

Possible settings:

  • Left-justified: Text is justified on the left edge of the column.
  • Centered: Text is displayed centered in the column.
  • Right: Text is justified on the right edge of the column.

Deactivate column filter in the Runtime

Active: The filter for this column cannot be changed in Runtime.

Note: Only available for:

  • Batch Control
  • Extended Trend
  • Filter screens
  • Message Control
  • Recipegroup Manager

User defined colors

Properties in order to define user-defined colors for text and background. The settings have an effect on the Editor and Runtime.

Note:

  • These settings are only available for configurable lists.
  • In addition, the respective focus in the list can be signalized in Runtime by means of different text and background colors. These are configured using the project properties.

User defined colors

Active: User-defined colors are used.

Text color

Color for text display. Clicking on the color opens the palette to select a color.

Background color

Color for the display of the cell background. Clicking on the color opens the palette to select a color.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.


Creating a user group list screen

Manual -> User administration -> Engineering in the zenon Editor -> Screen types, dialogs and functions for login and user administration -> Creating a user group list screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The user group list screen lists all zenon user groups created in the project and makes it possible to create new groups and assign authorization levels. User groups from the global project are not displayed and cannot be administered.

Note: This screen type is not available under Windows CE.

To create a user group list screen:

  1. Create a new screen in the Editor.
  2. Select user group list as the screen type.
  3. Select Add template in the control elements menu.
  4. Adapt the screen to your requirements:
  5. Create a function for screen switching to this screen and link it with a button.

User list screen

Control element | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.

Group list

Control elements for the display of the user groups.

Control element | Description
Previous group | Goes to the previous group.
Group list | List of available user groups.
Next group | Goes to the next group.
New group | Creates a new user group. The focus is set to the group name control element for input. Clicking on the OK button after input creates a new user group.
Delete group | Deletes selected group after a confirmation message.

Properties

Issue of group names and confirmation/rejection of changes.

Control element | Description
Group name | Display or entry of a group name.
OK | Applies changes.
Cancel | Discards all changes since the last acceptance with OK.

Authorization levels

Configuration of the authorization levels.

Control element | Description
Available authorization levels | Display of the authorization levels available.
Previous available authorization level | Goes to the previous level.
Listbox | Display of the authorization levels.
Next available level | Goes to the next level.
Apply level (>>) | Moves selected level from available authorization levels to selected authorization levels.
Remove level (<<) | Moves selected level from selected authorization levels to available authorization levels.
Selected authorization levels | Display of the authorization levels selected for the user group.
Previous selected level | Goes to the previous level.
Listbox | Display of the selected authorization levels.
Next selected level | Goes to the next level.


Screen switching to user group list

Manual -> User administration -> Engineering in the zenon Editor -> Screen types, dialogs and functions for login and user administration -> Creating a user group list screen -> Screen switching to user group list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With screen switching, you also define which screen is opened in Runtime for the creation or editing of user groups.

To create a screen switch to a user group list screen:

  1. Create a function.
  2. Select screen switching.
  3. Select the user group list screen
  4. Confirm the configuration by clicking on OK.
  5. Link the function to a button.


Create Edit user screen

Manual -> User administration -> Engineering in the zenon Editor -> Screen types, dialogs and functions for login and user administration -> Create Edit user screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This screen type allows the editing of users in Runtime. Depending on the configuration of screen switching, users can be created or edited and passwords can be changed. Users and user groups from the global project cannot be administered.

Note: This screen type is not available under Windows CE.

To create an Edit user screen:

  1. Create a new screen in the Editor.
  2. Select Edit use as a type.
  3. Select Add template in the control elements menu.
  4. Adapt the screen to your requirements:
  5. Create a function for screen switching to this screen and link it with a button.

Edit user screen

Control element | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.

User

Control element for user configuration.

Control element

Description

User name

Enter the username. The user logs in to the system with his username.

Maximum length: 20 characters.

Note: This name must be unique.

Complete name

Enter the full name of the user. With this you can allocate a username to a real person.

Administrator

Checkbox.

Active: The user gets the status of an administrator.

Only an administrator can create new users, edit users, delete passwords, etc. in the Runtime.

Active

Checkbox.

Active: The user is active and can login in the Runtime.

Note: According to FDA 21 PART 11 regulations, a user can never be deleted, so it is possible to trace who carried out which action at any time. Therefore for projects which adhere to these regulations, a user must not be deleted but only deactivated.

To prevent the deletion of users, deactivate the User administration property in the Deleting users group in the project properties.

Locked

Checkbox.

Active: The user is locked in the Runtime and cannot login.

This option is set automatically if a user enters an incorrect password more than is permitted.

Lock code for command processing

Four-digit PIN code.

This code is used by the user for the command input in order to lock and unlock different areas.

Login profile

Selection of the Runtime profile that is used for login from a drop-down list:

  • None
  • Default
  • Last

Change password

Control element for password configuration.

Control element | Description
Old password | Current password.
New password | Enter new password. For language-spanning projects take care that it must be possible to enter the characters with the respective keyboard in the Runtime.
Confirm password | Repeat the password.

Message Control

Control element for configuration of Message Control.

Control element

Description

Message Control User

Checkbox.

Active: The user is used by the module Message Control.

Telephone

Number of the voice-compatible telephone device of the user. Used for text to speech.

Enter numbers. In addition, the following are permitted:

  • The prefix + as an abbreviation for 00 of the international area code is permitted.

The following separators are also permitted in AD user administration: Minus (-), slash (/) and space
Note: When communicating between AD and Message Control, separators are ignored as soon as the data from the is mapped to a zenon object.

Cell phone

Mobile phone number of the user. Used for messages via GSM and SMS (text messages).

Enter numbers. In addition, the following are permitted:

  • The prefix + as an abbreviation for 00 of the international area code is permitted.

The following separators are also permitted in AD user administration: Minus (-), slash (/) and space
Note: When communicating between AD and Message Control, separators are ignored as soon as the data from the is mapped to a zenon object.

Email

E-mail address of the user

Substitute person

If a user has not been reached or they do not accept the message, a substitute person can be given. A click on button ... Opens the dialog to select a user.

Select substitute person

Click on the ... button to open the dialog to select a substitute person.

PIN code

PIN code with which the user confirms the message.

NA code

PIN code with which the user rejects the receipt of the message (not available). The message is then sent to the next user in the list.

If there is no other user entered in the list, the message is entered as "not successfully acknowledged". The function assigned to this is executed. In addition, a "rejected by" CEL entry is created in each case.

Note: You can find further information on the assignment of functions in the Confirmation of receipt - confirmation of receipt settings chapter.

Authorization levels

Control element to configure the authorization levels.

Control element | Description
Available authorization levels | List of all available authorizations.
Selected authorization levels | List of all available authorizations.
Apply authorization level (>>) | Entries selected in the list Available authorization levels are added to list Selected authorization levels.
Remove authorization level (<<) | Selected entries in list Selected authorization levels are removed from the list.

User groups

Control element to configure the user groups.

Control element | Description
Available user groups | List of all available user groups.
Selected user groups | List of assigned user groups.
Apply user group (>>) | Entries selected in the list Available user groups are added to list Selected user groups.
Remove user group (<<) | Selected entries in list Selected user groups are removed from the list.

Touch

Control element for navigation in list boxes, optimized for Touch operation.

Control element | Description
Available authorization level up | Navigates one authorization level up in the Available authorization levels list box.
Available authorization level down | Navigates one authorization level down in the Available authorization levels list box.
Selected authorization group up | Navigates one authorization level up in the Selected authorization levels list box.
Selected authorization group down | Navigates one authorization level down in the Selected authorization levels list box.
Available user groups up | Navigates one authorization level up in the Available user groups list box.
Available user groups down | Navigates one authorization level down in the Available user groups list box.
Selected user group up | Navigates one authorization level up in the Selected user groups list box.
Selected user group down | Navigates one authorization level down in the Selected user groups list box.

OK/Cancel

Control element to confirm or discard changes.

Control element | Description
OK | Applies changes.
Cancel | Discards all changes since the last acceptance with OK.


Screen switching for edit user

Manual -> User administration -> Engineering in the zenon Editor -> Screen types, dialogs and functions for login and user administration -> Create Edit user screen -> Screen switching for edit user

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the screen switching, you define how the edit user screen is called up. Depending on the configuration, you can:

  • Create a new user
  • Edit a user from the user list or from a string variable
  • Change passwords

To create a screen switch to an edit user screen:

  1. Create a function.
  2. Select screen switching.
  3. Select the edit user screen.
  4. The dialog for configuration is opened.
  5. Configure the screen switching.
  6. Confirm the configuration by clicking on OK.
  7. Link the function to a button.

User list dialog

Parameters

Description

Create new user

The edit user screen is used to create a new user. The corresponding control elements are activated.

Apply user from calling screen

If the call is from the user list screen, the edit user screen that is selected in the user list is used to edit the user. The corresponding control elements are activated.

Note: The editing user must have administrator rights in Runtime. At least one user must be selected in the list.

Apply user from variable

The edit user screen whose name is transferred form the defined string variable is used to edit the user. The corresponding control elements are activated.

Click on the ... button to open the dialog for selecting a variable.

Change password of logged in user

The edit user screen is only used to change the password of the user who is currently logged on. The corresponding control elements are activated.

Show dialog in Runtime

Active: When calling up the function in Runtime, this dialog is opened and the user can adjust the configuration before execution.

The dialog is displayed on the current computer in Runtime. During network operation when activating the client the dialog is also displayed on the client

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
Help | Opens online help.


zenon login and user administration in Runtime

Manual -> User administration -> zenon login and user administration in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Windows AD or AD LDS can also be used for user administration. Users can be logged in permanently or temporarily and administered in Runtime.

Particularly important values or functions can also be protected by means of a signature. To do this, the Signature necessary property must be activated for the corresponding property. In this case, the user must enter their password and signature again, even if they are logged in and have the appropriate rights. In doing so, an additional entry is created in the Chronological Event List.

attention Attention

Settings for users who are changed in the editor can only be applied if the RT changeable data project property (General group) allows overwriting of user properties when writing Runtime files.

Settings changed in Runtime can be applied using the Import Runtime files command (Runtime files tool bar) in the Editor. To do this, decompiling must be permitted in the RT changeable data property.


Login process and administration

Manual -> User administration -> zenon login and user administration in Runtime -> Login process and administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The current user SYSTEM will be logged in with the approved user level LEVEL 0 after Runtime is started. In multi-project administration, users can also be automatically be logged into all subprojects.

Rules for login in Runtime.

Logging in in the Runtime has the following safety precautions:

  • Password

    A user is locked after having entered a wrong password several times and they are logged out automatically. Therefore no elements of the system can be operated if they require an authorization level higher than 0. They cannot carry out any operations linked to a user level any more. The number of login attempts that are permitted is configured in the project settings with the Max. user error property.

    The user name that was used for the login attempt is logged in the Chronological Event List. The administrator has to unlock this user (deactivating the Locked property).

  • User name

    If a non-existent user name is entered, the error message 'Invalid user name' is displayed. After three unsuccessful attempts, the system is blocked for all elements that require a higher authorization level than 0. No user is therefore in a position to carry out protected operations with a user level. Only the administrator can unlock the system.

    The username of a user trying to log in incorrectly is logged in the Chronological Event List as an event for the user that is currently logged in.

    If a correct user name is used for login but the password field remains empty, this is considered an invalid password. The user is blocked after a defined number of permitted unsuccessful attempts (default 2, block after a third failed attempt).

  • Logging in after deactivation

    If an user is deactivated and he tries to log in, this is not possible. This attempt is logged in the Chronologic Event list.

Note: Changes to the password via functions, screens, dialogs and API are also checked and lead to the user being blocked if the current password is entered incorrectly several times. The number of characters in the field of the current password does not provide any indication of its the length of the password.

Requirements for AD and AD LDS use

In order to be able to use AD and AD LDS for logging in to zenon Runtime, the zenon project property User administration/Access to Active Directory must be configured.

  • AD: Yes must be selected for the property and the computer must be in the domain.
  • AD LDS: ADAM/AD-LDS must be selected for the property. The properties AD-LDS connection, AD-LDS username and AD-LDS password correctly configured.
    Note: ADAM is no longer supported.
    • AD LDS must be prepared accordingly.

Administration is possible for:

  • Windows 8, Windows 8.1 and Windows Server 2012
  • Windows 7
  • Windows Server 2008

attention Attention

Rights that are issued in zenon are applicable for the respective project or the workspace. Rights that are issued in the Active Directory are applicable globally.

If rights have been issued to users or user groups of the Active Directory, then the rights for these users are applicable in all zenon projects!

Management in Runtime

Each user has the possibility to change his own password. But he cannot edit another user. Only an administrator can do that. Changes in Runtime must be read back in the Editor, in order to be available there. Note the RT changeable data property when transferring Runtime files. Here, it is specified whether the configuration of the user administration is transferred to Runtime and overwrites the configuration in Runtime. The contents of the user administration are not replaced by default when transferred to Runtime.

The administrator can use the Change User function to:

  • Create new users
  • Amend existing users (except user name for login)
  • Create, amend or delete user groups

    If an administrator creates a new user group in Runtime, they are automatically a member of this group.

  • Issuing authorization levels

    The administrator can only give users authorization levels that they have. This avoids, that an administrator opens the entire system to himself.

Note: User and user groups from the Editor global project are combined with the users and user groups of the project. They can neither be edited in Runtime, nor read back in the Editor.

attention Attention

Compliance with FDA 21 CFR Part 11:

  • Neither user nor administrator can change the username in the Runtime.
  • Deleting users can be prohibited in the project settings with the help of the Deleting users property in the User administration group.

Password

The user himself is the only one knowing his password. And he is the only one able to change his password. Once the user has been given a password by the Administrator, they must change it when they first log in. This makes sure, that no administrator knows user passwords und thus could effect wrong signatures. (Important for FDA 21 PART 11).

If an user forgets his password, the administrator can delete his password und enter a new initial password. To do this the administrator does not have to know the password. The user must change their password the next time they log in.

For more information on changed Runtime files see also chapter: Project and workspace/RT changeable data

attention Attention

Login via screen of type Login: If, when logging in via a Login screen, no password is entered for a valid user, you do not receive an error message. The user is not logged in. Even after three failed login tries with no password entered the system is not logged.

If entering a wrong password and/or a not existing user name, the system is locked after three tries as usual.


User login

Manual -> User administration -> zenon login and user administration in Runtime -> User login

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Users can be logged in permanently or temporarily. Login is carried out by means of a modal dialog or a login screen.


Permanent login

Manual -> User administration -> zenon login and user administration in Runtime -> User login -> Permanent login

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

After a permanent login, the user is permanently logged in and can carry out all operations that they are authorized to do. For actions that the user is not authorized to carry out, a message is shown accordingly.

Permanent login can be effected by means of:

  • A screen switch to a login screen
  • The function Login with dialog
  • The Login without password function

Hint: Password-protected buttons can be made invisible for logged-in users. To do this, the Locked buttons property (Project properties -> User administration -> Login and signature) must be configured accordingly.

Note: Temporary login is not possible for logged-in users. Logged-in users therefore do not receive a dialog to log in temporarily for functions for which they do not have sufficient authorization.


Temporary login

Manual -> User administration -> zenon login and user administration in Runtime -> User login -> Temporary login

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If an operation that requires authentication is necessary for a user who is not logged in, or entry of a signature is required, the user can be logged in temporarily. To do this, the User administration property (-> Login and signature -> Temp. login active) must be activated.

Temporary login can be effected by means of:

  • Modal dialog, which is automatically called up by zenon.
  • Login screen that is linked to the Screen for Login property.

Calling up login in Runtime:

  1. The configured dialog to log in or enter a signature is opened when a password-protected function is executed.
    If a Login screen is linked, this is opened. Otherwise a modal dialog is opened.
  2. The user can log themselves in and execute operations in accordance with their rights. If the user does not have authorizations, they receive a corresponding message.
  3. The user is automatically logged out again immediately after the operation

info Information

Temporary login:

  • Is only effective after the function is executed
  • Supports switches, but not buttons
  • Is deactivated for permanently logged in users

Screen of type Login

This screen type allows temporary login and/or the entry of a signature.

Control element | Description
Current user (display) | Display of the currently logged in user
User name | Input area for username.
Password | Input field for password.
Signature | Input field for signature.
Login | Button to close the screen after login.
Cancel | Cancels the login process.
Apply | Applies all changes and leaves the dialog open. Exception: The window is closed if the maximum number of invalid login attempts has been set to 0 using the Max. user error property.

Temporary login modal dialog

This dialog allows temporary login. If a signature is required, this must be entered in a second stage.

Control element | Description
Current user (display) | Display of the currently logged in user
User name | Input area for username.
Password | Input field for password.
OK | Button to close the screen after login.
Cancel | Cancels the login process.


Automatic login and logout for subprojects

Manual -> User administration -> zenon login and user administration in Runtime -> User login -> Automatic login and logout for subprojects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In multi-project administration, users can be logged into subprojects and logged out from them automatically.

To allow a user to be able to log in and out automatically, the following must be the case in the Editor:

  • The user must be created in the global project
  • For each project that is to allow automatic login/logout, automatic login should be allowed

Attention: Users from the global project cannot be edited in Runtime.

Configuration in the Editor..

To configure automatic login/logout:

  1. Open the project properties.
  2. Navigate to node User administration
  3. Activate the Automatic login/logout in subprojects property.
  4. Repeat this step for all projects that are to support automatic login/logout.

Application in Runtime

Log into Runtime with a global user in a project.

The following applies in Runtime:

  • When logging into a project, a global user is automatically logged in to all subprojects that support it. They are logged out of all subprojects when logging out.
  • No corresponding dialogs are called up in the subprojects when logging in or out. Users who are already logged in are logged out.
  • If the user logs out from a subproject, then:
    • They are logged out of this project and all its subprojects
    • They remain logged in to all superordinate projects in which they are logged in
  • When logging in/out, the corresponding entries are created in the CEL all projects concerned.
  • Automatic login/logout only works in the direction of projects to subprojects, never the other way round.

Note: This functionality is not suitable for temporary login.

Procedure for Windows users

A Windows user who is already logged into a subproject (AD/ADAM) is reused in a subproject with automatic login. To do this, the context (AD path or ADAM path) must be the same. If a Windows user is used for the first time in the login chain, the password is checked at this point. If a check at the start of the login chain returns invalidity, the complete login process is canceled. If a login attempt in a subproject is rejected, this login is canceled, but the process is continued for all other projects.


Administer users and user groups

Manual -> User administration -> zenon login and user administration in Runtime -> Administer users and user groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Users and user groups can also be administered in Runtime.

info Information

Note the following with changes in Runtime:

  • Write them back to the Editor of the project configuration computer
  • Do not overwrite them with Editor settings

The following possibilities are available for user administration in Runtime:

Action

Average

Create user
  • User list screen
  • Edit user screen
  • Change user function

Edit user
  • User list screen
  • Edit user screen
  • Change user function

Delete user
  • User list screen
  • Change user function

Change password
  • Edit user screen
  • Change user function
  • Change password function

Assign function authorization
  • Change user function

Creating a user group
  • User group list screen

Edit user group
  • User group list screen

Assign authorization level
  • User group list screen

attention Attention

Do not delete a user who is a general module owner.


Screen types to administer users and user groups

Manual -> User administration -> zenon login and user administration in Runtime -> Screen types to administer users and user groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Users cannot only be administered in Runtime with functions and modal dialogs; they can also be administered by means of special screen types:

  • User list: Lists all users and offers possibilities to create, edit and delete users as well as to assign function authorizations.
  • User group list: Lists all user groups and offers the possibility to create and administer user groups and to assign function authorizations.
  • Edit user: Allows the creation and administration of users.

You must be logged in as an administrator for all actions. Exception: Users without administrator rights can change their own password.


User list

Manual -> User administration -> zenon login and user administration in Runtime -> Screen types to administer users and user groups -> User list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You administer user lists with this screen.
In doing so, the following applies:

  • You must be logged in as an administrator.
  • You can create new users.
  • You can edit users.
  • You can delete users.
  • You can only issue function authorizations that you have yourself directly or as a member of a user group.

To administer users in lists:

  1. Log in as an administrator.
  2. Create a user list screen.
  3. Configure the desired settings.
    • Clicking on New opens an edit user screen. This must be linked for screen switching.
    • Clicking on Edit opens an edit user screen. This must be linked for screen switching.

You can read details about the control elements in the Create user list screen chapter.


User Groups List

Manual -> User administration -> zenon login and user administration in Runtime -> Screen types to administer users and user groups -> User Groups List

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You administer user groups with this screen.
In doing so, the following applies:

  • You must be logged in as an administrator.
  • You can only administer user groups to which you also belong.
  • You can create new user groups.
    User groups that you create are assigned to you immediately. The group thus has at least one member and can be assigned further users.

To administer user groups:

  1. Log in as an administrator.
  2. Open a user group list screen.
  3. Configure the desired settings. The possible settings correspond to those in the Editor.

You can read details about the control elements in the Create user group list screen chapter.


Edit users and change password

Manual -> User administration -> zenon login and user administration in Runtime -> Screen types to administer users and user groups -> Edit users and change password

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can administer other users with this screen. All users can also change their own password.
In doing so, the following applies:

  1. You must be logged in as an administrator.
    Exception: Users without administrator rights can change their own password.
  • You can only issue authorization levels that you have yourself directly or as a member of a user group.
  • You can only assign user groups to which you also belong.
  • You cannot change your own authorization levels or user groups in Runtime.

Edit User

To administer users:

  1. Log in as an administrator.
  2. Open an edit user screen
    or open a user list and click on New or Edit there.
  3. Configure the desired settings. The possible settings correspond to those in the Editor or the Change user function.

You can read details about the control elements in the Create edit user screen chapter.

Change password

A modal dialog is called up in order for users to be able to change their own password. This dialog can also be replaced by an edit user screen. The dialog or screen can be called up modally if:

  • The Change password function is executed
  • The user who is logged in is to change their password (new user, expired password, password reset)

To allow users to edit their password by means of a screen:

  1. Link, in the User administration Login and signature project properties, the Screen for password change property to an edit user screen.
  2. The screen is opened modally instead of the modal dialog.
  3. Users can change their password.


Functions for the user administration module

Manual -> User administration -> zenon login and user administration in Runtime -> Functions for the user administration module

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following functions are available for the user administration in Runtime:

  • Login with dialog: Opens a modal dialog or the login screen for permanent login in Runtime.
  • Login without password: Logs in the user defined in the Editor without password entry or allows login with a chip identification system.
  • Logout: Logs out the user who is currently logged in and logs in the System user with authorization level 0.
  • Change user: Opens a dialog to edit users and user groups.
  • Change password: Opens a dialog in Runtime to change the password.


Login with dialog

Manual -> User administration -> zenon login and user administration in Runtime -> Functions for the user administration module -> Login with dialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function opens in Runtime, depending on the configuration:

  • The modal login dialog
  • The login screen

Modal dialog

Control element | Description
Current user (display) | Display of the currently logged in user
User name | Input area for username.
Password | Input field for password.
OK | Button to close the screen after login.
Cancel | Cancels the login process.

The attempt is logged in the Chronological Event list.

Size and position

The size and position of the login window in Runtime can be defined in zenon6.ini:

  1. Open zenon 6.ini.
  2. Create or modify the area:

    [Command Processing]

  3. Enter a values for:

    POSITION= left, right, top, bottom

    Default: POSITION= 0.001, 0.999, 0.835, 0.964

    Attention: The size relates to the screen size and not the size of the main window.

info Information

You can find zenon6.ini in the following path:

Windows 7/8: %ProgramData%\COPA-DATA\System\


Login without password

Manual -> User administration -> zenon login and user administration in Runtime -> Functions for the user administration module -> Login without password

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The function makes it possible to log in a user to zenon without a password in the Runtime. For this the user is directly named or logged in via Chip Ident System. This function can be executed by an event (status of a key) or by time control. The login is logged in the Chronologic Event List.

In order to create the function login without password:

  • create a new function
  • navigate to node User administration
  • select Login without password
  • the dialog for the selection of user opens
  • select the type of log in

Parameters

Description

User direct

Logs in the selected user.

User from variable

Logs in the user with the user name from the transferred variable. Makes it possible to log in a user via a Chip Ident System.

Click on button ... in order to open the dialog for selecting a String variable. For details see the "Log in via Chip Ident System" section.

Log in via Chip Ident System

The log in User from variable makes it possible to use Chip ident Systems such as Eucher or Keba Identsystem. In order to use the log in with a variable, pay attention to the following:

  • The user must exist in the zenon user administration or in the Active Directory with the same user name as in the chip.

    for example: User name in the chip is J. Smith. Then there must exist a J. Smith with respective rights in the user administration or in the Active Directory.

  • If the user holds his chip in front of the chip reader, the String variable (e.g. username) is filled with the data of the chip (e.g. J. Smith) and the user is logged in.
  • In order for this to work, a reaction matrix of the type String must exist which reacts to each value change and executes the function.
    • This reaction matrix must be linked with the variable (e.g. username).


Logout

Manual -> User administration -> zenon login and user administration in Runtime -> Functions for the user administration module -> Logout

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When this function is used in Runtime, the current user is logged out and the user SYSTEM is logged in with authorization level 0. The log in of an user is logged in the Chronologic Event List. If an Active Directory user is logged in, they are also logged out.

No transfer parameters are needed.

attention Attention

Automatic logout vs. automatic function:

  • Automatic Logout: Happens permanently after a certain time period has passed after the last user action
  • Automatic function: Happens only once after a certain time period has passed after the last user action


Change user

Manual -> User administration -> zenon login and user administration in Runtime -> Functions for the user administration module -> Change user

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Change user function makes it possible to create and administer users and to assign them authorization levels in Runtime.

To create the function:

  1. Create a new function.
  2. Go to the User administration section.
  3. Select the Change user function.
  4. Link the function to a button.

Use in Runtime

This dialog is opened in Runtime when the function is called up. This allows the creation and editing of:

  • Users
  • User groups

info Information

Rules:

  • Administrators can administer all other users and their settings.
  • Administrators cannot grant additional authorization levels themselves or add themselves to other user groups.
  • Users without administrator rights can only change their password and their settings for Message Control.


User

Manual -> User administration -> zenon login and user administration in Runtime -> Functions for the user administration module -> Change user -> User

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Users are configured in this tab.

Parameters | Description
List user | Lists all configured users.
New | Opens the dialog to create and amend new users.
Change | Opens the dialog to create and amend new users.
Delete | Deletes the selected user after requesting confirmation.
Change function authorization | Opens the dialog dialog to assign function authorizations to authorization levels for Runtime.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.

Administer users

To administer a user:

  1. Highlight the user in the list.
  2. Select the desired action by clicking on one of the buttons.


User

Manual -> User administration -> zenon login and user administration in Runtime -> Functions for the user administration module -> Change user -> User -> User

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
User

Entry of the user data.

Parameters

Description

User name

Enter the username. The user logs in to the system with his username.

Maximum length: 20 characters.

Note: This name must be unique.

Complete name

Enter the full name of the user. With this you can allocate a username to a real person.

Administrator

Active: The user gets the status of an administrator.

Only an administrator can create new users, edit users, delete passwords, etc. in the Runtime.

Active

Active: The user is active and can login in the Runtime.

Note: According to FDA 21 PART 11 regulations, a user can never be deleted, so it is possible to trace who carried out which action at any time. Therefore for projects which adhere to these regulations, a user must not be deleted but only deactivated.

To prevent the deletion of users, deactivate the User administration property in the Deleting users group in the project properties.

Locked

Active: The user is locked in the Runtime and cannot login.

This option is set automatically if a user enters an incorrect password more than is permitted.

Lock code

Four-digit PIN code.

This code is used by the user for the command input in order to lock and unlock different areas.

Login profile

Selection of the Runtime profile that is used for login from a drop-down list:

  • None
  • Default
  • Last

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.


Change password

Manual -> User administration -> zenon login and user administration in Runtime -> Functions for the user administration module -> Change user -> User -> Change password

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Change password

Issue of the password for the user.

Parameters | Description
Old password | Current password.
New password | Enter new password. For language-spanning projects take care that it must be possible to enter the characters with the respective keyboard in the Runtime.
Confirm password | Repeat the password.

Note: The function Copy and paste is not available for entering information in the password field.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
info Information
An administrator can only enable users for groups for which he has the rights himself.


Message Control

Manual -> User administration -> zenon login and user administration in Runtime -> Functions for the user administration module -> Change user -> User -> Message Control

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Message Control

Configuration for Message Control.

Parameters

Description

Message Control User

Active: The user is used by the module Message Control.

Telephone

Number of the voice-compatible telephone device of the user. Used for text to speech.

Enter numbers. In addition, the following are permitted:

  • The prefix + as an abbreviation for 00 of the international area code is permitted.
  • The following separators are also permitted in AD user administration: Minus (-), slash (/) and space
    Note: When communicating between AD and Message Control, separators are ignored as soon as the data from the is mapped to a zenon object.

Cell phone

Mobile phone number of the user. Used for messages via GSM and SMS (text messages).

Enter numbers. In addition, the following are permitted:

  • The prefix + as an abbreviation for 00 of the international area code is permitted.
  • The following separators are also permitted in AD user administration: Minus (-), slash (/) and space
    Note: When communicating between AD and Message Control, separators are ignored as soon as the data from the is mapped to a zenon object.

Email

E-mail address of the user

Substitute person

If a user has not been reached or they do not accept the message, a substitute person can be given. A click on button ... Opens the dialog to select a user.

PIN code

PIN code with which the user confirms the message.

NA code

PIN code with which the user rejects the receipt of the message (not available). The message is then sent to the next user in the list.

If there is no other user entered in the list, the message is entered as "not successfully acknowledged". The function assigned to this is executed. In addition, a "rejected by" CEL entry is created in each case.

Note: You can find further information on the assignment of functions in the Confirmation of receipt - confirmation of receipt settings chapter.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.

attention Attention

The acknowledgment codes for PIN (confirmation) and NA (rejection) must differ and should not be too similar.

If both codes are identical the code is interpreted as PIN and therefore as confirmation of the message.

If an unknown code is received, an SMS and e-‑mail is sent to the substitute person. The error message is played back for voice messages.


Authorization levels

Manual -> User administration -> zenon login and user administration in Runtime -> Functions for the user administration module -> Change user -> User -> Authorization levels

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Authorization levels

Configuration of the authorization levels.

Parameters | Description
Available authorization levels | List of all available authorizations.
Selected authorization levels | List of assigned authorizations.
Button double arrow to the right | Entries selected in the list Available authorization levels are added to list Selected authorization levels.
Button double arrow to the left | Selected entries in list Selected authorization levels are removed from the list.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.


User groups

Manual -> User administration -> zenon login and user administration in Runtime -> Functions for the user administration module -> Change user -> User -> User groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
User groups

Assignment of user groups.

Note: You can only assign user groups that you have yourself.

Parameters | Description
Available user groups | List of all available user groups.
Selected user groups | List of assigned user groups.
Button double arrow to the right | Entries selected in the list Available user groups are added to list Selected user groups.
Button double arrow to the left | Selected entries in list Selected user groups are removed from the list.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.


Issue function authorizations

Manual -> User administration -> zenon login and user administration in Runtime -> Functions for the user administration module -> Change user -> User -> Issue function authorizations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Issue function authorizations

Issue of function authorizations to authorization levels.

Note: You can only issue function authorizations that you have yourself directly or as a member of a user group.

Parameters | Description
List of functions | List of functions present and the assigned authorization levels.
Change | Opens the dialog to assign a new authorization level.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.

Function authorizations, general

Parameters

Description

Edit Extended Trend

Curves in Extended Trend can be edited in Runtime. The following control elements are not available if the user does not have authorization:

  • Diagram
  • Curves
  • Settings
  • Cursor on/off
  • X-Axis

Return to last screen (PgUp)

Screen 'back' functions can be executed in Runtime.

Screen switch: Enable "Show this dialog in Runtime"

The Screen switch function, with the Show this dialog in Runtime option active, can only be executed if the user who is logged in meets authorization requirements.

Notepad: Open file

The function file open in screenNotepad can only be carried out if the logged in user has the appropriate authorization level.

Notepad: Save file

The function save in screenNotepad can only be carried out if the logged in user has the appropriate authorization level.

Function authorizations for alarms

Parameters

Description

Change alarm comment

A Comment necessary for acknowledgement may be changed.

Enter alarm comment

A comment necessary for acknowledgement can be entered.

Delete alarm

Alarms can be deleted in Runtime.

Acknowledge alarm via alarm status line / context menu

Acknowledging an alarm via the alarm status line or the context menu is only possible if there is an authorization in the project of the alarm that is currently displayed.

For multi-project administration: Acknowledging the system message in the alarm status line or via the context menu is only possible if there is authorization in the integration project.

Comment: System messages are messages that appear in the alarm status line when a certain (configurable) number of alarms has been reached.

Acknowledge alarm via screen Alarm Message List

Acknowledging via Alarm message List screens is only possible with authorization in the project linked to the variable (multi-project administration).
Note: If there is no authorization, the blinking is stopped but the alarm is not acknowledged.

Acknowledge alarm via function

Acknowledging via a function is only possible if there is an authorization for the selected alarms in the respective projects.

Edit archive

Archive data (Archive server) can be amended in Runtime.

You can set different authorization groups for each of these acknowledging methods. This allows you, for example, to configure that a certain user group can only acknowledge via the alarm status line, not in any other way.

info Info

Acknowledging an alarm is only possible if there is an authorization for the selected alarms in the according projects.

Function authorization Batch Control

Parameters | Description
Batch Control: Control recipe - create, rename, duplicate | Control recipes in the Batch Control module can only be created and administered if the user has the corresponding rights.
Batch Control: Control recipe - edit phase | Control recipes in the Batch Control module can only be edited if the user has the corresponding rights.
Batch Control: Control recipe - Delete | Control recipes in the Batch Control module can only be deleted if the user has the corresponding rights.
Batch Control: Control recipe (execution) - skip active condition | When executing control recipes in the Batch Control module, a phase can only be exited if the user has the corresponding rights.
Batch Control: Control recipe (execution) - exit phase | When executing control recipes in the Batch Control module, pending conditions can only be skipped if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - switch execution mode | In test mode, with master recipes in the Batch Control module, the execution mode can only be switched if the user has the corresponding rights.
Batch Control: Control recipe (execution) - switch execution mode | When executing control recipes in the Batch Control module, the execution mode can only be switched if the user has the corresponding rights.
Batch Control: Control recipe (execution) - execute, jump single steps | When executing control recipes in the Batch Control module, the execution of individual steps can only be skipped if the user has the corresponding rights.
Batch Control: Control recipe (execution) - hold phase | When executing control recipes in the Batch Control module, a phase can only be stopped if the user has the corresponding rights.
Batch Control: Control recipe (execution) - resume phase | When executing control recipes in the Batch Control module, a phase can only be continued if the user has the corresponding rights.
Batch Control: Control recipe (execution) - restart phase | When executing control recipes in the Batch Control module, a phase can only be restarted if the user has the corresponding rights.
Batch Control: Control recipe (execution) - pause phase | When executing control recipes in the Batch Control module, a phase can only be paused if the user has the corresponding rights.
Batch Control: Control recipe (execution) - abort recipe | When executing control recipes in the Batch Control module, execution of the recipe can only be aborted if the user has the corresponding rights.
Batch Control: Control recipe (execution) - hold recipe | When executing control recipes in the Batch Control module, a recipe can only be stopped if the user has the corresponding rights.
Batch Control: Control recipe (execution) - resume recipe | When executing control recipes in the Batch Control module, a recipe can only be continued if the user has the corresponding rights.
Batch Control: Control recipe (execution) - restart recipe | When executing control recipes in the Batch Control module, a recipe can only be restarted if the user has the corresponding rights.
Batch Control: Control recipe (execution) - pause recipe | When executing control recipes in the Batch Control module, a recipe can only be paused if the user has the corresponding rights.
Batch Control: Control recipe (execution) - start recipe | When executing control recipes in the Batch Control module, a recipe can only be restarted if the user has the corresponding rights.
Batch Control: Control recipe (execution) - stop recipe | When executing control recipes in the Batch Control module, a recipe can only be stopped if the user has the corresponding rights.
Batch Control: Operation: create, edit, rename, duplicate, save | Operations in the Batch Control module can only be created, edited or administered if the user has the corresponding rights.
Batch Control: Operation: release | Operations in the Batch Control module can only be approved if the user has the corresponding rights.
Batch Control: Operation: delete | Operations in the Batch Control module can only be deleted if the user has the corresponding rights.
Batch Control: Master recipe: create, edit, rename, duplicate, save | Master recipes in the Batch Control module can only be created and administered if the user has the corresponding rights.
Batch Control: Master recipe - release | Master recipes in the Batch Control module can only be approved if the user has the corresponding rights.
Batch Control: Master recipe - Delete | Master recipes in the Batch Control module can only be deleted if the user has the corresponding rights.
Batch Control: Master recipe - Switch between test mode and edit mode | Switching between test mode and editing mode is only possible for master recipes in the Batch Control module if the user has the corresponding rights
Batch Control: Master recipe - highlight as outdated | Master recipes in the Batch Control module can only be marked as obsolete if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - skip active condition | In test mode, with master recipes in the Batch Control module, it is only possible to skip a pending condition if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - escape phase | In test mode, with master recipes in the Batch Control module, it is only possible to exit a phase if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - execute, jump single step | In test mode, with master recipes in the Batch Control module, it is only possible to skip the execution of individual steps if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - hold phase | In test mode, with master recipes in the Batch Control module, a phase can only be stopped if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - edit phase | In test mode, with master recipes in the Batch Control module, a phase can only be edited if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - resume phase | In test mode, with master recipes in the Batch Control module, a phase can only be continued if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - restart phase | In test mode, with master recipes in the Batch Control module, a phase can only be started if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - pause phase | In test mode, with master recipes in the Batch Control module, a phase can only be paused if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - abort recipe | In test mode, with master recipes in the Batch Control module, a recipe can only be aborted if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - hold recipe | In test mode, with master recipes in the Batch Control module, a recipe can only be held if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - continue recipe | In test mode, with master recipes in the Batch Control module, a recipe can only be continued if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - restart recipe | In test mode, with master recipes in the Batch Control module, a recipe can only be continued if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - pause recipe | In test mode, with master recipes in the Batch Control module, a recipe can only be paused if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - start recipe | In test mode, with master recipes in the Batch Control module, a recipe can only be started if the user has the corresponding rights.
Batch Control: Master recipe (test mode) - stop recipe | In test mode, with master recipes in the Batch Control module, a recipe can only be stopped if the user has the corresponding rights.


User group

Manual -> User administration -> zenon login and user administration in Runtime -> Functions for the user administration module -> Change user -> User group

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

User groups are configured in this tab.

Parameters | Description
List of user groups | Lists all configured user groups.
New | Opens the dialog to create and amend new user groups.
Change | Opens the dialog to create and amend new user groups.
Delete | Deletes the selected user group after confirmation.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.

Administer user groups

To administer a user group:

  1. Highlight the user group in the list.
  2. Select the desired action by clicking on one of the buttons.


User group

Manual -> User administration -> zenon login and user administration in Runtime -> Functions for the user administration module -> Change user -> User group -> User group

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
User group

Creation of a new user group.

Parameters | Description
Name | Name of the new user group Attention: @ is not a valid character for a user group.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.


Authorization levels

Manual -> User administration -> zenon login and user administration in Runtime -> Functions for the user administration module -> Change user -> User group -> Authorization levels

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Authorization levels

Assignment of the authorization level to a user group.

Parameters | Description
Available authorization levels | List of all available authorizations
Selected authorization levels | List of assigned authorizations
Button double arrow to the right | Entries selected in the list Available authorization levels are added to list Selected authorization levels.
Button double arrow to the left | Selected entries in list Selected authorization levels are removed from the list.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.


Change password

Manual -> User administration -> zenon login and user administration in Runtime -> Functions for the user administration module -> Change password

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When this function is used, the user who is logged in can change their current password in Runtime. For system-internal users no changes are possible.

A dialog to change the password is called up in Runtime.

Required inputs:

Parameters | Description
Old password | Enter current password.
New password | Enter new password.
Confirm password | Enter new password again.
OK | Accepts the new password and closes the dialog.
Cancel | Cancels the process.

If no password has been assigned to the user, he can define it, the first time he executes the function in the Runtime. In this case, no old password is asked for in the dialog.


Password protection for dynamic elements

Manual -> User administration -> zenon login and user administration in Runtime -> Password protection for dynamic elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

All dynamic elements that either execute a function or allow the setting of values can be linked to an authorization group for the Runtime.

Create a dynamic element. E.g. a text button. In the properties window the properties of the element are displayed.

In the group 'User' select the property 'Authorization group'. Here the authorization group necessary to execute the function can be defined.

In dynamic elements where the setting of values should be secured, a variable has to be linked and the property "Allow setting values" has to be activated in the properties window, before the authorization group can be defined.


Accept changes in the Editor in Runtime

Manual -> User administration -> zenon login and user administration in Runtime -> Accept changes in the Editor in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Not all changes to the user administration are accepted in Runtime after a reload. Note most of all:

The maximum number of incorrect password inputs

If you change the standard value for the maximum number of erroneous attempts for entering a password in the Editor, this change is only effective once Runtime is restarted. Reloading alone is not sufficient, because otherwise as many attempts at entering a password as desired would be possible. You change the value at: Project properties -> User administration -> Max. user error

Changes to user groups and authorizations

If user groups are added or removed or authorizations are changed in the Editor, these changes are not accepted in Runtime for users that are logged in on reloading. In order for these changes to be effective, users who are logged in must log out of the system and log in again. This also applies to use by Active Directory users.


Administering Active Directory users from zenon Runtime

Manual -> User administration -> Administering Active Directory users from zenon Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can access the Windows Active Directory in Runtime with an Active Directory user administration screen. You can create, delete and edit organization units, users and user groups and assign them rights in zenon.

info Information

Active Directory, AD LDS and ADAM (for Windows XP) are not available with Windows CE.

Domains in Runtime

In Runtime, the domain of the user who started Runtime for the Active Directory login is used. Only the users who belong to this domain can log in.

User authorization

attention Attention

Rights that are issued in zenon are applicable for the respective project or the workspace. Rights that are issued in the Active Directory are applicable globally.

If rights have been issued to users or user groups of the Active Directory, then the rights for these users are applicable in all zenon projects!


Creating an Active Directory user administration screen

Manual -> User administration -> Administering Active Directory users from zenon Runtime -> Creating an Active Directory user administration screen

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create an Active Directory user administration screen:

  1. in the tool bar or in the context menu of node Screens select command New screen
  2. an empty screen of type Standard is opened
  3. Change the screen type in the detail view; to do this:
    1. click on Standard in the Screen type column
    2. Select Active Directory user administration in the drop-down list
  4. Click in the screen.
  5. select menu item Control elements from the menu bar
  6. Click on Add template in the drop-down list.
  7. The dialog for selecting a template is opened.
  8. Select the desired template.
  9. Standard elements are placed in pre-defined positions; these can be deleted or positioned elsewhere.
  10. You can add further elements using the Control elements menu.
  11. Name the screen. To do this:
    1. Click on the screen name in the detail view in the name column
    2. Give it its own name
  12. Create a screen switch function in order to be able to call up the screen in Runtime

Active Directory user administration screen

Parameters | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.
Login | Control elements for logging into the Active Directory.
Domain name | Entry and display of the domain name.
User name | Entry and display of the AD user name.
Password | Entry of the password.
Login | Clicking logs the user into the AD.
Logout | Clicking logs the user out.
Active Directory Explorer | Control elements for the display and administration of the Active Directory. Contains the Active Directory detail view: Window in which the structure of the Active Directory is displayed.
Create new organization unit (tree) | Opens the dialog to create a new organization unit in the tree.
Delete organization unit... (Tree) | Deletes the organization unit selected in the tree after requesting confirmation.
One level up | Navigates to one level higher in the structure.
Create new organization unit | Creates a new organization unit below the element selected in the tree. The corresponding dialog is opened:
Create new user | Opens the dialog to crate a new user.
Create new user group | Opens the dialog to create a new user group.
Edit object | Opens the dialog to edit the selected object.
Delete object | Deletes the selected object.


Screen switching to Active Directory user administration

Manual -> User administration -> Administering Active Directory users from zenon Runtime -> Screen switching to Active Directory user administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use the Active Directory user administration screen in Runtime, configure screen switching. In doing so, you can set pre-settings for the organization units to be displayed. This is how you can control the organization units that respective users can select.

Configuring screen switching:

  1. Create a screen switch to an Active Directory user administration screen function.
  2. Issue a domain name, in order to open the AD of a certain domain in Runtime.
    You can also leave the name empty. Then the domain name must be entered in Runtime when logging in.
  3. Configure the organization units to be displayed.
    You can have them all displayed, or select specific ones.
  4. Close the dialog by clicking on OK and link the function with a button in the screen.

Filter dialog

Parameters

Description

Domain name

Entry of the domain for which the Active Directory is to be loaded when screen switching.

Organization units

Selection of the organization units to be displayed. Selection by means of radio buttons:

  • All: All nodes of the AD structure organization of the domains are displayed in Runtime.
  • Specific: Allows the selection of certain organization units. Clicking on the ... button in the input field opens the dialog to select the organization units.

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Help

Opens online help.

Select organization units

If you select specific organization units in the filter dialog, the dialog to enter the login files is opened first, then the dialog to select the organization units.

Login

Parameters

Description

User currently logged in

Active: The user who is currently logged into the computer is logged in to the AD to select the organization units.

Explicit login

Active: A certain user who is logged in to the AD to select the organization units.

  • Domain: Entry of the domains whose structure is to be displayed.
  • Username: User. Can remain empty if reading of the data only is sufficient.
  • Password:

OK

Applies settings and opens the Select organization units dialog.

Cancel

Discards all changes and closes the dialog.

Organization units

Parameters | Description
List of organization units | Display of all organization units of the selected domain. Selection from the folder tree.
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.


Administer Active Directory users in Runtime.

Manual -> User administration -> Administering Active Directory users from zenon Runtime -> Administer Active Directory users in Runtime.

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Organization units, user groups and users of the active directory can be administered from zenon Runtime with an Active Directory user administration screen.

attention Attention

Rights that are issued in zenon are applicable for the respective project or the workspace. Rights that are issued in the Active Directory are applicable globally.

If rights have been issued to users or user groups of the Active Directory, then the rights for these users are applicable in all zenon projects!

Active Directory user administration screen

The screen is cleared when screen switching

To administer users in the AD:

  1. Enter the domain name (can already be defined in the screen switching), user name and password
  2. Click on Login
  3. The connection is created.
    If errors occur, check the configuration in the Active Directory and in zenon.
  4. The domain data is read and displayed in the window.
  5. Edit the desired elements. Available actions:
    • Creating and deleting organization units
    • Creating, editing and deleting users
    • Creating, editing and deleting user groups

Note: The user who is logged on must have the corresponding rights in the domain.

Parameters | Description
Login | Control elements for logging into the Active Directory.
Domain name | Entry and display of the domain name.
User name | Entry and display of the AD user name.
Password | Entry of the password.
Login | Clicking logs the user into the AD.
Logout | Clicking logs the user out.
Active Directory Explorer | Control elements for the display and administration of the Active Directory. Contains the Active Directory detail view: Window in which the structure of the Active Directory is displayed.
Create new organization unit (tree) | Opens the dialog to create a new organization unit in the tree.
Delete organization unit... (Tree) | Deletes the organization unit selected in the tree after requesting confirmation.
One level up | Navigates to one level higher in the structure.
Create new organization unit | Creates a new organization unit below the element selected in the tree. The corresponding dialog is opened:
Create new user | Opens the dialog to crate a new user.
Create new user group | Opens the dialog to create a new user group.
Edit object | Opens the dialog to edit the selected object.
Delete object | Deletes the selected object.

Tree context menu

Depending on the element selected, the context menu in the tree (left window) provides the following commands:

Command | Description
Create new organization unit | Creates a new organization unit below the element selected in the tree. The corresponding dialog is opened:
Create new user | Deletes the organization unit selected in the tree after requesting confirmation.

Toolbar and context menu detail view

Depending on the element selected, the context menu and the tool bar in the detail view (right window) provide the following commands:

Command | Description
One level up | Navigates to one level higher in the structure.
Create new organization unit | Creates a new organization unit below the element selected in the tree. The corresponding dialog is opened:
Create new user | Opens the dialog to crate a new user.
Create new user group | Opens the dialog to create a new user group.
Edit selected object | Opens the dialog to edit the selected object.
Delete selected object | Deletes the selected object.


Manage organization unit

Manual -> User administration -> Administering Active Directory users from zenon Runtime -> Administer Active Directory users in Runtime. -> Manage organization unit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can create and delete AD organization units in the tree and in the detail view.

Creating an organization unit

To create a new organization unit:

  1. Click in the screen on the button or select Create new organization unit in the context menu of a highlighted element.
  2. The dialog to configure an organization unit is opened

  3. Give it a name.
    Maximum length: 64 characters
  4. Click on OK.

Edit organization unit

The name of the organization unit can be changed.

Attention: When changing the name, links to users and user groups that are used in the Message Control module are destroyed.

To edit an organization unit in the tree:

  1. Select the desired organization unit and click on the corresponding button or command in the context menu. In the detail view, click on the Edit object or the Edit selected object command in the context menu.
  2. The dialog editing is opened.
  3. Edit the object.
  4. If you click on the OK button, you are asked how linking should be handled:

  5. Select the desired option:
    • Yes: The renaming is carried out.
      An attempt is made to restore linking to users and user groups that are used in the Message Control module.
      This process can take some time.
    • No: The change is made immediately.
      Warning: Linking to users and user groups that are used in the Message Control module can be destroyed!
    • Cancel: The renaming is not applied and the dialog is closed.

Delete organization unit

To delete an organization unit in the tree, select the desired organization unit and click on the corresponding button or command in the context menu. In the detail view, click on the Delete object button or the Delete selected object command in the context menu.

Note: An organization unit can only be deleted if it no longer contains any objects.


Managing users

Manual -> User administration -> Administering Active Directory users from zenon Runtime -> Administer Active Directory users in Runtime. -> Managing users

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

New users can be created and existing users can be edited and deleted. Users with the same visual name in the list can be distinguished by the information in the tool tip.

  • Create new user: Click on the corresponding button, or the command in the tool bar or the context menu.
  • Edit user: Double-click a user entry or click on the corresponding button or on the Edit selected object command in the context menu.
  • Delete user: Highlight the desired user and press the Del button, click on the corresponding button or on the Delete selected object command in the context menu.

When creating and editing, a dialog is opened, in which you can configure the user.

Creating or editing a user dialog

The dialog consists of three tabs. You can also find notes on the options in the Project configuration in the Editor/Creation of a user chapter.

User properties

User

Parameters

Description

User

Settings for user data.

User name

Unique name of the user for the login.

Complete name

Displayed name of the user.

Email

E-mail address of the user

Telephone

Number of the voice-compatible telephone device of the user. Used for text to speech.

Enter numbers. In addition, the following are permitted:

  • The prefix + as an abbreviation for 00 of the international area code is permitted.

The following separators are also permitted in AD user administration: Minus (-), slash (/) and space
Note: When communicating between AD and Message Control, separators are ignored as soon as the data from the is mapped to a zenon object.

GSM

Mobile phone number of the user. Used for messages via GSM and SMS (text messages).

Enter numbers. In addition, the following are permitted:

  • The prefix + as an abbreviation for 00 of the international area code is permitted.

The following separators are also permitted in AD user administration: Minus (-), slash (/) and space
Note: When communicating between AD and Message Control, separators are ignored as soon as the data from the is mapped to a zenon object.

Password

Parameters | Description
Password | Settings for the password.
Set password | Active: The password is set again.
Password | Enter new password. For language-spanning projects take care that it must be possible to enter the characters with the respective keyboard in the Runtime.
Password confirmation | Repeat the password.
User must change password on next login | Active: The user must, as soon as they log in to the system, change their password.
Password does not expire | Active: Password never needs to be changed

Actions

Parameters | Description
Actions | Configuration of actions for the account.
Deactivate user | Active: The user is deactivated and can no longer log in.
Unblock user | Active: The blocked user is unblocked and can log in in Runtime again.
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.

User groups of the user

  1. Select, in the Existing user groups window, the desired user groups from the existing ones.
  2. Add the selected groups to the list of selected user groups with the cursor key ->.
  3. You can also select user groups that have already been allocated and remove them again with the cursor key <-.

Parameters | Description
Existing user groups | List of configured user groups.
Selected user groups | List of the user groups selected for the user.
Cursor keys | Clicking moves the highlighted groups to the corresponding list.
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.

Runtime settings

General

Parameters

Description

General

General settings.

Administrator

Active: The user takes on the role of a zenon administrator. Only an administrator can unblock zenon user accounts that have been blocked.

Note: If a user is stipulated as an administrator, then this role is also applicable for all zenon projects!

Login profile

Selection of the Runtime profile that is used for login from a drop-down list:

  • None
  • Default
  • Last

Lock code for command

Four-digit PIN code.

This code is used by the user for the command input in order to lock and unlock different areas.

Message Control

Parameters

Description

Message Control

Settings for Message Control.

Message Control user

Active: The user is used by the module Message Control.

PIN code

PIN code with which the user confirms the message.

NA code

PIN code with which the user rejects the receipt of the message (not available). The message is then sent to the next user in the list.

If there is no other user entered in the list, the message is entered as "not successfully acknowledged". The function assigned to this is executed. In addition, a "rejected by" CEL entry is created in each case.

Note: You can find further information on the assignment of functions in the Confirmation of receipt - confirmation of receipt settings chapter.

Substitute person

Parameters | Description
Substitute person | If a user has not been reached or they do not accept the message, a substitute person can be given. A click on button ... Opens the dialog to select a user.
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.

Substitute person dialog

If a substitute person is to be selected for the Message Control module, a click on the button opens a dialog with previously-configured users.

Parameters | Description
List of persons | List of users available.
None selected | A user who is already defined in the dialog is
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.

Select the desired user and click on OK.

To remove a substitute person who has already been configured, click on None and then on OK.


Managing user groups

Manual -> User administration -> Administering Active Directory users from zenon Runtime -> Administer Active Directory users in Runtime. -> Managing user groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

New user groups can be created and existing user groups can be edited and deleted.

  • Creating a new user group: Click on the corresponding button, or the command in the tool bar or the context menu.
  • Editing user groups: Double-click a user group entry or click on the corresponding button or on the Edit selected object command in the context menu.
  • Deleting user groups: Highlight the desired user group and press the Del button, click on the corresponding button or on the Delete selected object command in the context menu.

When creating and editing, a dialog is opened, in which you can configure the user.

Creating or editing a user dialog

The dialog consists of three tabs. You can also find notes on configuration in the Project configuration in the Editor/Creation of a user chapter.

Properties of the user group

Parameters | Description
Name | Entry of a unique, valid name for the database backup.
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.

Users in this user group

  1. Select, in the Existing users window, the desired users from the existing users.
  2. Add the selected users with the cursor key -> to the list of selected users.
  3. You can also select users who have already been allocated and remove them again with the cursor key <-.

Parameters | Description
List of existing users | List of configured users.
List of selected users | List of the users selected for this group.
Cursor keys | Clicking on a cursor key moves the selected user to the corresponding group.
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.

Runtime settings

#

General

Parameters | Description
General | General settings. Configuration of the authorization levels.
List of existing authorization levels | List of the authorization levels configured in zenon.
List of selected authorization levels | List of authorization levels that are allocated to this group.
Cursor keys | Clicking on a cursor key moves the authorization levels to the corresponding group.

Message Control

Parameters | Description
Message Control | Configuration for zenon Message Control.
Group call active | Active: All members of the user group are messaged when messaging via Message Control.
Sequence of messaging | List of all available users. Sequencing is carried out using the cursor keys.
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.


External user administration with Microsoft Active Directory

Manual -> User administration -> External user administration with Microsoft Active Directory

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With zenon, you can also use Microsoft Active Directory for user administration:

  • User groups in Active Directory that have the same name as zenon user groups receive the same rights as in zenon
  • Can be managed with zenon users in the Active Directory in Runtime

attention Attention

Rights that are issued in zenon are applicable for the respective project or the workspace. Rights that are issued in the Active Directory are applicable globally.

If rights have been issued to users or user groups of the Active Directory, then the rights for these users are applicable in all zenon projects!

In order to be able to use AD and AD LDS for logging in to zenon Runtime, the zenon project property User administration/Access to Active Directory must be configured.

  • AD: Yes must be selected for the property and the computer must be in the domain.
  • AD LDS: ADAM/AD-LDS must be selected for the property. The properties AD-LDS connection, AD-LDS username and AD-LDS password correctly configured.
    Note: ADAM is no longer supported.
  • AD LDS must be prepared accordingly.


Active Directory (AD)

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory (AD)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Active Directory can be used in zenon for the user administration in the zenon Runtime. For the zenon Editor AD is not available.

The active directory can be used for three types of zenon:

  1. The name of the authorization group in zenon user administration corresponds to the of the group names of a user group in Active Directory: Automatic assignment of the Active Directory user to zenon authorization group. All AD group users receive user rights that are defined in the zenon authorization group. See User groups in zenon and groups in Active Directory have the same name
  2. In the description of the Active Directory group, the zenon authorization levels and the project are stored in a certain syntax. All users of the group receive the user rights stored in the AD group in zenon. See Assignment of an Active Directory user to zenon authorization levels
  3. The Active Directory schema is expanded by fields in which the zenon authorization levels are saved. This requires an Active Directory extension schema. However this is not suitable for use in an FDA 21 CFR Part 11 regulated environment. See: Active Directory extension schema.

info Information

When checking the password in zenon, the max. password age is also checked from the Active Directory.

info Information

Active Directory, AD LDS and ADAM (for Windows XP) are not available with Windows CE.


General

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory (AD) -> General

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to be able to use the users of the Active Directory (hereinafter called AD) in zenon, a domain based on a Windows server operating system is required. In order to be able to administer user in the Active Directory, the server has to be a DNS server.

So a domain controller with DNS and Active Directory has to be available to be able to use these user accounts as users of zenon on a PC in the domain.

Access to the users of the Active Directory has to be activated in the properties of the project.

Basic knowledge about the Active Directory and the Windows server technology is assumed.

attention Attention

If login is via Active Directory, all computers without exception must have access to the Active Directory. This also applies to clients and Web Clients.

Background: A client is logged in directly from the client to the Active Directory. The zenon Runtime server is not involved in this.
An Active Directory user can therefore only be logged on if a client:

  • Is a member of the domain
    and
  • has access to the domain


Setting the zenon authorization levels in the description field of an Active Directory group

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory (AD) -> Setting the zenon authorization levels in the description field of an Active Directory group

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Windows users from the Active Directory can be used in zenon.

Individual users can be allocated in the Active Directory groups. The names of the groups must be as described in the following syntax:

zenon project name##free text

The description contains the user authorization following this syntax:

free text ##GRP=HEX-number## free text

info Information

Group name and group description are not case-sensitive.

In order to increase readability, the HEX-number is divided in four parts (one for each authorization group) which are separated by a dash.

Structure of the HEX number
FFFFFFFF | FFFFFFFF | FFFFFFFF | FFFFFFFF
Authorization levels 1 | Authorization levels 2 | Authorization levels 3 | Authorization levels 4

Example Example

Group name: MASCHINE01##service staff

Group description: free text##GRP=FFFFFFFF-FFFFFFFF-FFFFFFFF-FFFFFFFF##free text

The users which are allocated to MACHINE01##service staff receive authorization level 0 - 127 in zenon.

It is not necessary to enter all 32 digits. Missing digits are interpreted as 0.

Example Example

Group description: free text##GRP=7##free text

The users which are allocated to a group with this description receive authorization level 0, 1 and 2 in zenon.

7 hexadecimal equals 111 as binary number. For each 1 in the binary number, the corresponding authorization level is set. The right most bit stands for authorization level 0. The bit to the left of this, stands for authorization level 1 and so on.

A user can be allocated to multiple groups. In this case the user receives the sum of the authorization levels of each group.

If a user is logged in to zenon, first it is checked whether the user exist in zenon locally. If not, the Active Directory is search for the user. If the user also does not exist there, the user is not logged in an a corresponding entry in the CEL is created. If the user is present in AD, but authorization levels in zenon are not defined for these users, the following entry is created CEL: 'No user rights defined for the user in the AD.' The user is logged in with authorization level 0.


The same user groups in zenon and in Active Directory

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory (AD) -> The same user groups in zenon and in Active Directory

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following applies for users in zenon and in Active Directory:

  • If a user is in the AD, but not in zenon, then:
    • The user groups are checked in zenon
    • The group authorization levels to which the user belongs, are allocated to the AD user
  • If a user exists in both AD and in zenon and the user logs into Runtime, then:
    • The local zenon user has priority over the AD user
    • If no authorization levels are checked in AD, because the local user is logged in


Active Directory extension scheme

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory (AD) -> Active Directory extension scheme

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Note: This expansion should not be used in an FDA 21 CFR Part11 regulated environment. For FDA 21 CFR Part 11 compliant user administration, use either the User groups in zenon and groups in the Active Directory method or Allocation of an Active Directory user to zenon authorization levels.

info Information

Active Directory, AD LDS and ADAM (for Windows XP) are not available with Windows CE.


Installation of the schema extension

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory (AD) -> Active Directory extension scheme -> Installation of the schema extension

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order for the users in AD to also be able to be assigned the 128 authorization levels of zenon, the AD schema must be supplemented with these entries (4 integer values).

For this purpose, two files (zenonUserLevel.exe and zAD_UserDlg.exe) are copied to the server (ideally to their own folder). As soon as the setup (zenonUserLevel.exe) has been started, this folder and the files contained therein must no longer be renamed or deleted.

attention Attention

You can find the two files zenonUserLevel.exe and zAD_UserDlg.exe on the zenon installation medium in the /Software/zenonUserLevel/ folder

A reference to the zAD_UserDlg.exe file is stored in the AD schema.

Furthermore, 4 integer values (zenonUserLevel1, zenonUserLevel2, zenonUserLevel3, zenonUserLevel4) are added to the AD schema.

info Information

Only a user from the Schema administrators group can make these changes! The domain administrator normally has these rights.


Granting user rights

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory (AD) -> Active Directory extension scheme -> Granting user rights

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

After the successful extension of the schema the authorization levels can be granted to the single users.

For this purpose, the Microsoft Management Console (MMC) with the Active Directory Users and Computers plug-in is opened.

A context menu is opened by clicking on the desired user with the right mouse button. A new menu item is visible in the context menu: zenonUserLevel.

In this context menu, the zenonUserLevel entry has to be selected, so that the administration tool (zAD_UserDlg.exe) for the selected user is opened.

info Information

The authorization levels for zenon can only be granted directly to the user, groups and organization units are not supported.

Up to 128 authorization levels per user can be defined with the help of the administration tool.

info Information

As a default, the authorization level 0 is granted to each user; this cannot be deactivated in the administration tool.

This level corresponds to the SYSTEM user of zenon.


Description of the administration tool

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory (AD) -> Active Directory extension scheme -> Granting user rights -> Description of the administration tool

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Description of the administration tool

Parameters | Description
[first line] | LDAP parameter that serves as connection string.
Last name | Last name of the selected user.
First Name | First name of the selected user.
User Level | Four integer values represent 32 authorization levels. They are inputted by activating or deactivating the checkboxes or directly inputting into the field.
# | Updates display of authorization levels.
Select | Activates all checkboxes in a column.
Clear | Deactivates all checkboxes in a column.
Save | Saves current settings.
Cancel | Rejects all changes made since the last save and closes the dialog.
OK | Saves all settings and closes dialog.
Logging | Displays logging information.


Schema extension – details

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory (AD) -> Schema extension – details

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To clarify the whole background, the schema extensions are explained in detail here, so that they can be checked in the event of problems.

In order to be able to see the details of the AD schema, ADSI Edit has to be installed on the server. This tool is available as soon as the Support Tools from the Microsoft Server CD have been installed.

To be found on the CD under: CD_ROOT/SUPPORT/TOOLS/SUPTOOLS.msi

Then the ADSI Edit plug-in can be opened in the Microsoft Management Console (MMC). Now different connections can be established.


Schema

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory (AD) -> Schema

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The additional attributes can be checked in the schema. These are normally listed at the bottom.

zenonUserLevel1 - zenonUserLevel4


Configuration

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory (AD) -> Configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

After the connection to configuration has been defined, the details of the single AD objects can be checked and edited. In this case, only the object user-display in the single 'DisplaySpecifiers' is of interest, because here the link between user object and AdministrationTool is established.

The properties of the user-Display object only contain attributes with the names adminContextMenu.

This attribute contains the link to the administration tool (zAD_UserDlg.exe).

This entry can also be amended manually if necessary.

To do this:

  1. Select the entry
  2. Press Remove button
  3. Adapt the parameters
  4. Use Add to add again

The parameter has the following structure:

,name of the menu entry, path of the file zAD_UserDlg.exe

Example Example

Example, if the EXE file is in the folder D:\\AD_Users.

,&zenonUserLevel,D:/AD_Users/zAD_UserDlg.exe


Domain

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory (AD) -> Domain

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If the connection domain is openen, it looks similar to the MMC with the PlugIn Active Directory Users and Computers. Exactly this information can also be found here, but with more details.

If you check the properties of a user object and scroll down to the bottom of the list, here you will also find 4 integer values for the authorization levels.


Active Directory Lightweight Directory Services - AD LDS

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Active Directory Lightweight Directory Services (abbreviation: AD LDS) is a simplified version of the Active Directory and is suitable for use on normal desktop operating systems; it is not necessary to use a server operating system. LikeAD, AD LDS also supports:

  1. The name of the authorization group in zenon user administration corresponds to the of the group names of a user group in Active Directory: Automatic assignment of the Active Directory user to zenon authorization group. All AD group users receive user rights that are defined in the zenon authorization group. See User groups in zenon and groups in Active Directory have the same name
  2. In the description of the Active Directory group, the zenon authorization levels and the project are stored in a certain syntax. All users of the group receive the user rights stored in the AD group in zenon. See Assignment of an Active Directory user to zenon authorization levels

You can use AD LDS with:

  • Windows 7
  • Windows 8
  • Windows Server 2008
  • Windows Server 2012


AD LDS with Windows 8 and Windows Server 2012

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 8 and Windows Server 2012

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use AD LDS with Windows 8, Windows 8.1 or Windows Server 2012 and zenon:

  1. Install AD LDS
  2. Create a new AD LDS instance
  3. Import an AD LDS schema
  4. Install Remote Administration for Windows Server
  5. Configure the Active Directory snap-in in order to manage the AD LDS instances
  6. Define the roles, organization units, users and user groups

Note: The instructions on installation and use of AD LDS sometimes use screenshots with an English user interface.


Installing AD LDS

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 8 and Windows Server 2012 -> Installing AD LDS

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Windows 8

To install AD LDS under Windows 8:

  1. Open Control Panel.
  2. Open Programs and Features.
  3. Select Turn Windows features on or off.

  4. Activate the check box in front of Active Directory Lightweight Directory Services.
  5. Click on OK.

Windows Server 2012

To install AD LDS under Windows Server 2012:

  1. Go to Manage -> Add Roles and Features.
  2. The wizard is started.

  3. Select Role-based or feature-based installation.
  4. Click on Next.

  5. Select a server from the server pool.
  6. Click on Next.

  7. Activate the check box in front of Active Directory Lightweight Directory Services for server roles.
  8. Click on Next.

  9. Activate the check box for Include management tools.
  10. Click on Add Features.

  11. Click on Next.

  12. Confirm the automatic restart of the server.


Create new AD LDS instance

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 8 and Windows Server 2012 -> Create new AD LDS instance

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a new AD LDS instance:

  1. In Windows, go to the %ProgramData%\Microsoft\Windows\Start Menu\Programs\Administrative Tools folder.
  2. Start the Setup Assistant for Active Directory Lightweight Directory Services file.

  3. Click on Next.

  4. Select unique instance as the installation type.
  5. Click on Next.

  6. Assign an instance name.
  7. Click on Next.

  8. Enter the port number for LDAP and SSL.
    Default LDAP: 389
    Default SSL: 636
    Note: If you change one of the port numbers, this must also be amended in one of the following steps.
  9. Click on Next.

  10. Activate the option for an application directory partition.
  11. Enter Partition name.

    Note: The partition name is used together with the port number and server name in zenon. In this example, the entry in the corresponding zenon AD-LDS connection property would be: \\w8x64-vm0009.testenv.local:389/DC=copadata,DC=com

  12. Click on Next in the assistant.

  13. Enter the save location for data files and restores. (you can leave it at the default setting.)
  14. Click on Next.

  15. Select the authorization levels with which authorization processes are to be carried out. (Network service account in this example)

    Note: If the computer on which you install AD LDS is not a member of a domain, you receive a warning message accordingly:

    This will not impair the functionality as long as you do not carry out any replications. Confirm the notice by clicking Yes

  16. Click on Next in the assistant.

  17. Enter the user who is to administer AD LDS. The user who is currently logged on is used in this example.
    The user does not need to be a local administrator or domain administrator. A group can also be given.
    However: An individual user must be given in zenon. This can be a member of a group.

    The user configured here is used in zenon in the AD-LDS username and AD-LDS password properties:

  18. Click on Next in the assistant.

  19. Import the required LFIF files: You need:
    • MS-InetOrgPerson.LDF
    • MS-User.LDF
    • MS-UserProxy.LDF
  20. Click on Next.

  21. Confirm the configuration by clicking on Next

    The installation is carried out.

  22. Close the assistant by clicking on the Finish button


Importing an AD LDS schema

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 8 and Windows Server 2012 -> Importing an AD LDS schema

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To import LD ADS schemas:

  1. Open the command line.
  2. Navigate to the AD LDS folder: WINDIR%\ADAM.
  3. Enter the following command and press the Enter key:

    ldifde -i -s localhost:389 -c CN=Configuration,DC=X #ConfigurationNamingContext -f MS-adamschemaw2k8.ldf

    Note: If you have configured a dedicated user for the AD LDS partition, you must also enter:

    • User
    • Domain
    • Passwort for ldifde

    Syntax: (user: ADLDS, domain: T08-12en64, password: password): ldifde -i -s localhost:389 -c CN=Configuration,DC=X #ConfigurationNamingContext -f MS-adamschemaw2k8.ldf -b ADLDS T08-12en64 Copadata1

  4. You receive a confirmation once the changes have been made.

  5. Enter the following command and press the Enter key (the rules for dedicated users also apply here too, as with the previous step):

    ldifde -i -s localhost:389 -c CN=Configuration,DC=X #ConfigurationNamingContext -f MS-AdamSyncMetadata.ldf

  6. You receive a confirmation once it has been successfully carried out.


Installing Remote Server administration under Windows 8

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 8 and Windows Server 2012 -> Installing Remote Server administration under Windows 8

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Under Windows 8, you must still install the Remote Server administration. To do this:

  1. Open Control Panel.
  2. Open Programs and Features.
  3. Select Turn Windows features on or off.

  4. Activate the check box in front of Remote server administration tools.
  5. Click on OK.

Note: If the remote server administration tools are not displayed, download these from the MIcrosoft website and install them.


Tools

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 8 and Windows Server 2012 -> Tools

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following tools are helpful for the administration of AD LDS:

  • Microsoft mmc with the Active Directory schema snap-in: mmc –a
  • ADSI Edit
  • ADExplorer (can be downloaded from Microsoft Sysinternals)


Configuring Active Directory schema snap-in

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 8 and Windows Server 2012 -> Configuring Active Directory schema snap-in

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure the Active Directory schema snap-in:

  1. Open the command line with administrator rights.

  2. Enter the following command and press the Enter key: regsvr32 schmmgmt.dll
  3. You receive a confirmation after successful registration:

  4. Open the version.
    Enter: mmc /a
  5. The administration console is opened:

  6. Click, in the File menu, on the Add/remove snap-in command.

  7. Select Active Directory Schema.
  8. Click on Add.
  9. Click on OK.
  10. Highlight the Active Directory Schema entry.
  11. Select the Change Active Directory Domain Controller command in the context menu

  12. Enter the server name and the port in the empty field. In our example: w8x64-vm0026.testenv.local:389.
    Select your server and port here.
    You now see this view:

  13. Save the snap-in via File -> Save.
  14. Optional:
    1. Open the Classes folder and navigate to the organization entry.

    2. Click on Properties in the context menu.
    3. Open the Attributes tab.

    4. Click on Add and search for maxPwdAge. Click on OK.

      Add lockoutDuration and lockoutThreshold too.

      Close the dialog by clicking on OK.

      These steps are optional and require the corresponding rights. maxPwdAge defines the time period in which the password is valid before it must be replaced. lockoutDuration defines how long a user is blocked after their password has repeatedly been entered incorrectly. The permitted number of incorrect password entries is defined with lockoutThreshold.

  15. Open the Classes folder and navigate to the user entry.
    1. Click on Properties in the context menu.
    2. Open the Attributes tab.
    3. Click on Add and search for sAMAccountName. Click on OK.
      Add groupMembershipSAM and userAccountControl too.

    Close the dialog by clicking on OK.

  16. Close the console.

Password guidelines

The guidelines for password complexity, minimum password length and minimum password age are configured in the local security guidelines of the computer. If the computer on which AD LDS is running is in a workgroup, you see the local security guidelines. If the computer is in a domain, you see the domain security policies. Depending on your installation, you must configure the password guidelines.

For local security guidelines:

  1. Go to %ProgramData%\Microsoft\Windows\Start Menu\Programs\Administrative Tools\Tools\
  2. Start Local Security Policy
  3. Configure Password Policy

  4. Configure Account Lockout Policy


Configure roles, organization units and users

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 8 and Windows Server 2012 -> Configure roles, organization units and users

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Use the ADSI Editor to configure the roles, organization units and users. You can find it in the path

%ProgramData%\Microsoft\Windows\Start Menu\Programs\Administrative Tools\.

To set up configurations with the ADSI editor:

  1. Start the ADSI editor.

  2. Select Establish connection in the context menu.
  3. The dialog for the connection settings is opened.

  4. Configure the following options according to your selected settings:
    • Connection point: DC=copadata,DC=com
    • Computer: localhost:389
    • Close the dialog by clicking on OK.
  5. You should now have the following view of the editor (open the tree in the left window by clicking on the cursor or double clicking on the entry):

This is the starting point for all other configurations. In our example:

  • Configuring roles
  • Configuring maxPwdAge
  • Creating an organization unit
  • Creating a group
  • Creating a user
  • Adding users to groups


Configuring roles

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 8 and Windows Server 2012 -> Configure roles, organization units and users -> Configuring roles

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Configuring roles

In this chapter, you find out how you can issue zenon read rights for the structure of the AD LDS tree.

To do this:

  1. Expand the folder called CN=Roles.

  2. Highlight CN=Readers.
  3. select Properties in the context menu
  4. The properties dialog is opened

  5. Navigate to the member entry.
  6. Click on Edit.
  7. Click on Add Windows account.
  8. Add the user Everyone (everyone) for the local host.
  9. Close the dialog.
  10. You will have the following view


Configuring the password duration

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 8 and Windows Server 2012 -> Configure roles, organization units and users -> Configuring the password duration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Configuring the password duration

This area is important if you want dedicated password rules for the zenon organization unit. If you do not configure these rules, the local security guidelines of the computer on which AD LDS was installed are applied.

To configure rules:

  1. Highlight the folder called DC=copdata,DC=com.
  2. Click on Refresh.
  3. Close the ADSI editor.
  4. Open the editor again.
  5. Highlight the entry DC=copdata,DC=com.
  6. Open the properties using the context menu:

  7. Navigate to the maxPwdAge entry.
  8. Enter a valid value (format: DD:HH:MM:SS) and close the dialog.

    Note: If the entry maxPwdAge is not available, check to see if the property has been added correctly. The updating or closing and reopening of the editor can also rectify the problem.

  9. Navigate to the lockoutDuration entry
  10. Enter a valid value (format: DD:HH:MM:SS) and close the dialog.

  11. Go to the lockoutThreshold entry.
  12. Enter a valid value and close the dialog.


Creating an organization unit

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 8 and Windows Server 2012 -> Configure roles, organization units and users -> Creating an organization unit

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Creating an organization unit

To create a organization unit:

  1. Highlight the folder called DC=copdata,DC=com.

  2. Select New -> Object in the context menu.

  3. Select organizational unit as a class.
  4. Click on Next.

  5. Enter a name as a value.
  6. Click on Next.
  7. Click on Close.


Creating a user group

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 8 and Windows Server 2012 -> Configure roles, organization units and users -> Creating a user group

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Creating a user group

To create user groups:

  1. Highlight the folder with the organization unit that has been created.

  2. Select New -> Object in the context menu.

  3. Select the Group entry.
  4. Click on Next.

  5. Enter a name for Value.
  6. Click on Next.

  7. Click on Finish.
  8. Click on the More attributes button.
  9. Select the groupAttributes entry

  10. Enter 2147483650 in Edit attribute.
  11. Click on Define.

  12. Click on OK.
  13. Select, in the More attributes dialog, the sAMAccountName property.

  14. Enter the same value as for group.
  15. Click on Define.

  16. Click on OK.
  17. Click on Finish.


Creating a user

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 8 and Windows Server 2012 -> Configure roles, organization units and users -> Creating a user

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Creating a user

To create a user:

  1. Highlight the organization unit.

  2. Select New -> Object in the context menu.

  3. Select the User object.

  4. Enter a name as a value.
  5. Click on Next.

  6. Click on More attributes.
  7. Select sAMAccountName.

  8. Enter the same value as for User.
    Note: This is important in order for the user to be used in zenon.
  9. Click on Define.

  10. Click on OK.
  11. Click on More attributes.
  12. Select displayName.

  13. Enter a description for the display
  14. Click on Define.

  15. Click on OK.
  16. Click on Finish.


Adding users to groups and setting a password

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 8 and Windows Server 2012 -> Configure roles, organization units and users -> Adding users to groups and setting a password

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Adding users to groups and setting a password

In this section, you add a user to a group and issue a password.

Adding a user

To add users to a group:

  1. Highlight the group.

  2. select Properties in the context menu

  3. Highlight member
  4. Click on Edit.

  5. Click on Add DN.
    The dialog to add a previously-configured user is opened

  6. Enter, for the user from our example: CN=zenon1,OU=zenon users OU,DC=copadata,DC=com
  7. Click on OK to close the dialog.

  8. Click on OK.

Set password

Now define a password for the user. To do this:

  1. Highlight the user that has just been created.

  2. Select Reset password in the context menu.
  3. Issue a password.
    Note: the password must meet the requirements of the local security guidelines.
  4. Close the dialog.
  5. Select Properties in the context menu of the user

  6. Select msDS-UserAccountDisabled in the properties.

  7. Set the value to incorrect.

The user can now be used in zenon.


AD LDS with Windows 7

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 7

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

AD LDS can also be used with Windows 7. You can find the setups for these on the Microsoft website.

After installation, configuration is carried out via System control-> Administration in the same way as the description for Windows Server 2008.


Create new AD LDS instance

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 7 -> Create new AD LDS instance

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a new AD LDS instance:

  1. Call up, in the Active Directory Lightweight Directory Services Control Panel, the AD LDS Setup Wizard.

  2. Start the wizard:

  3. Select the A unique instance option.

  4. Give the instance a name.

  5. Configure the ports. Default:
    • LDAP: 389
    • SSL: 636

    Note: If you change the pre-set port here, you must also amend the port in some of the following settings.

  6. Specify the Partition Name.

    In our example: o=zenon,c=com

    The Partition Name is used together with the port and the server name later in zenon.

    This configuration can also be set up later in zenon. Continue with configuration in the wizard.

  7. Define the save location.
    The setting can be left as the default setting.

  8. Define the service account for AD LDS.

    In our example: Network service account

    If the computer on which AD LDS is installed is not a member of a domain, you receive a warning message:

    This does not impair the functionality of AD LDS. Exception: You use the Replication function.

    Confirm the warning by clicking on the Yes button.

  9. Define the user who receives administrator rights.

    In our example, we use Currently logged on user. In our case, a local user with administrator rights.

    The user and their password are used later in zenon.

    This configuration can be set up later. Continue with configuration in the wizard.

  10. Import the required LDIF files:
    • MS-InetOrgPerson.LDF
    • MS-User.LDF
    • MS-UserProxy.LDF

  11. Finish the installation


Importing an AD LDS schema

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 7 -> Importing an AD LDS schema

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To import the AD LDS schema:

  1. In Windows Explorer, navigate to the %WINDIR%\ADAM folder.
  2. Select [Shift key + right mouse click] in the context menu: Open input request here.

  3. Enter the following character string:

    ldifde -i -s localhost -c CN=Configuration,DC=X #ConfigurationNamingContext -f MS-AdamSchemaW2k8.ldf

  4. Press the Return key:

  5. Enter the following character string:

    ldifde -i -s localhost:389 -c CN=Configuration,DC=X #ConfigurationNamingContext -f MS-AdamSyncMetadata.ldf

    Note: If you have changed a port, it must be amended here accordingly.

  6. Press the Return key:


Configuring the AD Snap-in schema

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 7 -> Configuring the AD Snap-in schema

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure the Snap-in schema, first register using the command prompt (administrator rights are required):

  1. Click on the Start button
  2. Navigate to Command prompt
  3. Select Run as administrator in the context menu
  4. At the command prompt, enter: regsvr32 schmmgmt.dll
  5. Confirm by pressing the Return key

Configuration

  1. Click on the Start button
  2. Open Run
  3. Enter: mmc /a

  4. Click on File -> Add/Remove Snap-in...

  5. Select Active Directory Schema
  6. Click on Add
  7. click on OK

  8. Navigate to Active Directory Schema
  9. Select Change Active Directory Domain Controller... in the context menu

  10. Enter the server and port (in this example) localhost:389

  11. You should now see this window:

  12. Navigate to Classes -> organization
  13. Open Properties

  14. Click on Add
    1. Search for maxPwdAge
    2. click on OK

    1. Repeat this step for lockoutDuration

    1. and for lockoutThreshold

  15. click on OK

These steps are absolutely necessary to have maxPwdAge available in the organization unit, which is configured next.

  • maxPwdAge defines the maximum password age; the password must be changed after this time.
  • lockoutDuration defines how long a user is locked out for after they have repeatedly entered their password incorrectly.
  • lockoutThreshold defines the number of possible failed attempts before a user is locked out for a certain period.

In the local security guidelines, you define the regulations for:

  • Password complexity
  • Minimum password length
  • Age


Configure organization units, groups and users

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 7 -> Configure organization units, groups and users

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure organization units, groups and users:

  1. Open Start -> Administrative Tools -> ADSI Edit

  2. Select Connect to... in the context menu
  3. Use the following settings (change other settings if they have been set up previously):
    1. Connection Point: o=zenon,c=com
    2. Computer: localhost:389

    You should now see the following configuration:

Configuring maxPwdAge

  1. Highlight O=zenon,c=com
  2. Click on Refresh
  3. Close ADSI Edit
  4. Open ADSI Edit again
  5. Highlight O=zenon,c=com
  6. Select Properties in the context menu.

  7. navigate to maxPwdAge
    1. Enter a valid value
    2. Format: DD:HH:MM:SS (in our example 10:00:00:00)

    Note: If the maxPwdAge property is not visible, check to see that it has been correctly added. A refresh, or closing and opening ADSI Edit or reloading the schemas may rectify the problem.

  8. Navigate to lockoutDuration
    1. Enter a valid value
    2. Format: DD:HH:MM:SS (in our example 00:00:10:00, -> 10 minutes)

  9. Navigate to lockoutThreshold

  10. Enter the same value as in the local security guidelines (3 for example)

Note: The settings for the duration of the account block are ignored in AD LDS. The lockoutDuration property (O=zenon,c=com) is used.


User

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 7 -> Configure organization units, groups and users -> User

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
User

To create a user:

  1. Highlight the organization unit
  2. Select New -> Object in the context menu

  3. Select the User class

  4. Enter a name (in our example: zenon1)

  5. Click on Next
  6. Switch to the Attributes tab
  7. Click on More attributes
    1. Navigate to Select a property to view
    2. Select sAMAccountName in the drop-down list
    3. Navigate to Edit Attribute
    4. Enter the same value as for the user (zenon1)
      (this configuration is necessary in order for the user to be able to be used in zenon.)

  8. Click on Set
  9. Now select displayName in Select a property to view
  10. Enter a value for the display of a name, such as 1st zenon user

  11. Click on Set, then on OK and on Finish

Adding a user to the group

To add users to a group:

  1. Select zenon user group
  2. Select Properties in the context menu.

  3. Highlight member
  4. Click on Edit.

  5. To add (user) to the AD LDS account that was created beforehand:
    1. Click on Add DN...
    2. At the input field, enter: CN=zenon1,OU=zenon users OU,O=zenon,C=com

    1. You receive the result:

  6. Define a password for the user zenon1

    Note: the password must meet the requirements of the local security guidelines

  7. Set the the set msDS-UserAccountDisabled property to False for user zenon1

The user has now been created and can be used in zenon.


Organization units

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 7 -> Configure organization units, groups and users -> Organization units

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Organization units

To create a organization unit:

  1. Highlight O=zenon,c=com
  2. Select New -> Object in the context menu

  3. Select organizationalUnit

  4. Enter a name (in our example: zenon users OU)

  5. Click on Next and then on Finish


Groups

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows 7 -> Configure organization units, groups and users -> Groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Groups

To create a group:

  1. Highlight the organization unit
  2. Select New -> Object in the context menu

  3. Select group

  4. Enter a name (in our example: zenon user group)

  5. Click on Next
  6. Switch to the Attributes tab
  7. Click on More attributes
    1. Navigate to Select a property to view
    2. Select groupAttributes in the drop-down list
    3. Navigate to Edit Attribute
    4. Enter the value 2147483650 (represents an account group)

  8. Click on Set
  9. Now select sAMAccountName in Select a property to view
  10. Enter the same value as for the group (zenon user group)

    Note: This setting is necessary in order for the user groups in zenon to be configured

  11. Click on OK and then in Finish


AD LDS with Windows Server 2008

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> AD LDS with Windows Server 2008

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To install the AD LDS server role:

  1. Select Server Manager in the administrative tools

  2. Click on Add Roles

  3. Add the AD LDS Role


zenon administration with Active Directory

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> zenon administration with Active Directory

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For use in zenon, first configure the settings in the Editor and set the user identification to AD LDS level in Runtime.

info Information

Active Directory, AD LDS and ADAM (for Windows XP) are not available with Windows CE.


Editor

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> zenon administration with Active Directory -> Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration is carried out in the project properties in User administration:

  • A user group with the name zenon user group was created

  • and authorization levels were added


Runtime - system driver variables

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> zenon administration with Active Directory -> Runtime - system driver variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
  • The user zenon1 can log in to zenon:

    The Complete name property in zenon corresponds to the AD LDS attribute displayName.

    The User identification property corresponds to the AD LDS attribute sAMAccountName.

  • The user receives their authorization levels from the zenon group:

  • The remaining days until the password must be changed are displayed (with a day's difference):

Error treatment

If errors in Runtime occur, check if:

  • The settings have been set up correctly:
    • User name
    • sAMAccountName
  • The firewall settings have been set up correctly:
  • The Editor configuration is correct for:
    • Connection
    • Password

If the user does not receive any authorization levels from the zenon group, check if:

  • The names correspond to each other
  • sAMAccountName of the group in AD LDS was set
  • The user in AD LDS was added to the group

AD

If operating authorizations from the user group in AD are to come, the following must be the case in AD LDS:

  • The description property must be amended for the group
  • The group must have the exact same name as the project

For further information, see the Setting the zenon authorization levels in the description field of an Active Directory group section.


Problem handling

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Lightweight Directory Services - AD LDS -> Problem handling

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Check the connection to the AD LDS directory

  1. Start the Microsoft ADExplorer on the computer on which the zenon Editor or zenon Runtime is used.
  2. Attempt to establish a connection to the AD LDS directory with the settings used in zenon.
  3. The causes of the error can be:
    • Incorrect host name
    • Incorrect port
    • Firewall rules in the network

User cannot log in

Check to see if all attributes are set correctly in AD LDS:

  • sAMAccountName
  • groupMembershipSAM
  • userAccountControl

The user does not receive all authorization levels that were assigned to them.

  • Please check:
  • Is the Name of the zenonUser group configured the same that in AD LDS?
  • Is the AD LDS user assigned to the corresponding AD LDS group?
  • Is the attribute sAMAccountName set in the AD LDS group?

No content in the snap-in

If no content is displayed after opening the Active Directory schema snap-ins, the access rights must be amended. To do this:

  1. Select Permissions... in the context menu

  2. Assign the necessary users the corresponding rights
    (you add new users by clicking on Add)

  3. Click on the Advanced button

  4. Click on the Advanced button
  5. Open the Permissions tab
  6. Activate the Apply to this object and all descendant objects option for the respective user

  7. Close the console and open it again (mmc /a) for further configuration


Active Directory Application Mode - ADAM (Windows XP only)

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Application Mode - ADAM (Windows XP only)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Active Directory Application Mode (ADAM) is designed for use with Windows XP. Windows XP is no longer supported by zenon, because Microsoft has discontinued the product and no longer supports it. This documentation only relates to systems that still run under Windows XP.

For current operating systems, use Active Directory Lightweight Directory Services:

  • Windows 7
  • Windows 8/8.1
  • Windows Server 2008
  • Windows Server 2012

Requirements

In order to be able to use Active Directory Application Mode for zenon, you must pay attention to the following points when configuring ADAM.

  1. Create a new ADAM instance
  2. Bring in an AD schema
  3. In order to make access possible for the ADAM user, click Program -> Administration -> Local security guidelines. In the following dialog click Security settings -> Account guidelines. Define the desired settings for password guidelines and account blocking guidelines.
  4. Configure the ADAM Snap-in schema.
  5. In Snap-In make a right-click under Classes -> Organization and select properties. On tab Attribute enter maxPxdAge as optional attribute. With this you make sure that the password validation and the password change work analog to the Active Directory.

    Note: You must enter the validity period of the password in nanoseconds.

  6. Create user and user groups in ADAM. Pay attention to the following:
    • At the user and at the user group you must enter the name again manually under Property -> Attribute-Editor at the Attribute sAMAccountName.
    • At the user group you must enter the name as described in Using the Active Directory.
    • You can create the zenon authorization levels as described in Using the Active Directory under attributedescription.

info Information

In order to display the username with the help of the system driver variable, you must set the username manually in ADAM at the user under Properties -> Attribute-Editor at the Attribute displayName.


Create new instance of ADAM

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Application Mode - ADAM (Windows XP only) -> Create new instance of ADAM

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This is how you install an instance of ADAM using the Active Directory Application Mode setup assistant

  • Click on start to launch the Active Directory Application Mode setup assistant, show all programs and then on ADAM, and then click on Create ADAM instance.
  • On the welcome page, click on Next.
  • On the set up options page, you can choose if you wish to install a separate ADAM instance or would like to assign an existing configuration to a new instance. Because you are installing the first ADAM instance, click on install separate instance Click on "Next" after this.
  • On the

    Instance name

    page, enter a name for the ADAM instance to be installed. The name is used to clearly identify the ADAM instance on the local computer. Then click on

    Next

    .
  • On the

    Ports

    page, enter the communication ports that are to be used by the ADAM instance. ADAM can communicate using LDAP (Lightweight Directory Access Protocol) or SSL (Secure Sockets Layer). You must therefore give a value for both ports. Then click on

    Next

    .

info Information

If one of the standard ports is already used on the computer on which you install ADAM, the Active Directory Application Setup Assistant automatically looks for the next available port, starting with 50000. For example, ports 389 and 636, as well as ports 3268 and 3269 are used on global catalog servers. Therefore, when installing ADAM on a domain controller, the standard values

50000

for the LDAP port and

50001

are assigned to the SSL port.
  • On the

    Application directory partition

    page, you can create an application partition or a name context) by clicking on

    Yes, create application directory partition

    . If, you click on

    No, do not create application directory partition

    you must create an application partition manually after installation. If you create an application partition, you must enter a defined name for the new partition. Then click on

    Next

    .

info Information

ADAM supports defined names in X.500 and in DNS style (Domain Name System) for upper level directory partitions.
  • On the

    File path

    page, you can display and amend the installation directories for ADAM files and recovery files (protocol files). ADAM files and recovery files are saved under %ProgramFiles(x86)%

    \Microsoft ADAM\Instanzname\data

    by default. In doing so,

    Instance name

    displays the ADAM instance name that you enter on the

    Instance name

    page. Click on

    Next

    , to import the standard paths.

info Information

When installing ADAM on a Windows XP XP, you must install these files on the same logical volume. When installing ADAM under Windows Serve 2003 and Windows Server 2003 R2 in a production environment, it is recommended that you install the files on separate physical data carriers.

Program files and administration programs are installed by ADAM in

%windir%\ADAM

.
  • On the

    Select service account

    page, select an account that is used as a service account for ADAM. The selected account determines the security context in which the ADAM instance is executed. If you do not install ADAM on a domain controller, the network service account of Active Directory Application Mode Setup Assistant is used by default. Click on

    Next

    , to import the

    Network service account

    standard setting. When installing ADAM on a domain controller, click on

    This account

    instead and then select a domain user account as an ADAM service account.

info Information

You can change the ADAM service account after installing ADAM with the command line program

dsmgmt

. When installing ADAM on a domain controller, you must select a domain user account as an ADAM service account.
  • On the

    ADAM administrators

    page, select a user or a group as a standard administrator for the ADAM instance. The selected user or selected group has full administrator functionality for the ADAM instance. As standard, the current registered user is given by the Active Directory Application Mode Setup Assistant. You can change this selection in each local account or domain account or in each group in the network. Click on the standard value

    Current registered user

    , and then click on

    Next

    .
  • You can import two LDF files with user class object definitions into the ADAM scheme on the

    Import LDIF file

    page. Importing user class object definitions is optional.
    • Click on

      Import selected LDIF file for this ADAM instance

      .
    • Click on

      MS-InetOrgPerson.LDF

      and then on

      Add

      .
    • Click on

      MS-User.LDF

      and then on

      Add

      .
    • Click on

      MS-UserProxy.LDF

      ,on

      Add

      and then on

      Next

      .
  • On the

    Ready for installation

    page, you can verify the selected installation options. If you click on

    Next

    , the Active Directory Application Mode Setup Assistant starts by copying the files and installing ADAM on the computer.
  • If the Active Directory Application Setup Assistant has successfully finished installing ADAM, the following message is shown: "The Active Directory Application Setup Assistant mode was concluded successfully." If the

    Finish assistant

    page is displayed, click on

    Finish

    to close the assistant.

info Information

If the Active Directory Application Setup Assistant is not successfully concluded, the reason for the error is displayed on the

Summary

page.
  • If an error occurs in the Active Directory Application Assistant, before the

    Summary

    is opened, you can verify the error message displayed. Furthermore, you can click on

    Start

    and then on

    Execute

    and enter one of the following filenames:

    %windir%\Debug\Adamsetup.log

    %windir%\Debug\Adamsetup_loader.log

    . The files

    %windir%\Debug\Adamsetup.log

    and

    %windir%\Debug\Adamsetup_loader.log

    contain useful information for dealing with problems in relation to ADAM setup errors.


Input AD scheme

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Application Mode - ADAM (Windows XP only) -> Input AD scheme

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This is how you use the Active Directory/ADAM synchronization program for the first time

  • click on Start,
  • Open All Programs,
  • Click on ADAM and
  • then on ADAM administration programs:

    A command window in the ADAM directory opens.

To extend the ADAM schema to the standard schema objects of Windows Server in Active Directory:

  • Enter the following command on one line of the command prompt:

    ldifde -i -s localhost -c CN=Configuration,DC=X #ConfigurationNamingContext -f MS-AdamSchemaW2k8.ldf

  • Press the Return key.


Configure ADAM scheme snap-in

Manual -> User administration -> External user administration with Microsoft Active Directory -> Active Directory Application Mode - ADAM (Windows XP only) -> Configure ADAM scheme snap-in

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuring the ADAM scheme snap-in administration program.

You can administer the ADAM scheme with another ADAM administration program, the ADAM scheme snap-in. If you have already used the Active Directory scheme snap-in, you should be familiar with the ADAM scheme. Before you can use the ADAM scheme snap-in, you must create an MMC file for it, as described in this process.

  • Click on start, then on Execute, enter mmc /a and then click on OK.
  • In the file menu, click on Add/remove snap-in and then click on Add.
  • Click on the independent snap-ins available in the ADAM scheme, on Add, on Close and then click on OK.
  • To save this console, click on Save in the File menu.
  • Enter the following filename and then click on Save:
    %windir%\system32\adamschmmgmt.msc
  • Create a connection to the ADAM instance using the ADAM scheme snap-in. To do this, right click on ADAM scheme in the console structure and click on change ADAM server. Enter localhost at ADAM server and 389 at Port.
  • Click on OK. The ADAM scheme snap-in now looks as follows. You can search through and display the classes and attributes of the ADAM scheme.
  • To create a link for the ADAM scheme snap-in start menu, carry out the following actions:
    • Right click on Start, click on Open – all users, double-click on the folder programs, and double-click on the ADAM folder.
    • Move to New in the file menu, and then click on link.
    • In the assistant to create links, enter adamschmmgmt.msc as the save location for the element and then click on Next.
    • On the select program description page, enter the name for the link and the name of the ADAM scheme, and then click on Finish.


about AD/AD LDS properties used in zenon

Manual -> User administration -> about AD/AD LDS properties used in zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Encryption

NTLM/Kerberos encryption is used to log in a zenon AD/ADAM user. No explicit encryption is envisaged for ADSI (MS APIs for AD) for the exchange of data other than passwords in the session that is already logged on.

List of the properties in AD/ AD LDS used by zenon

Domain

General form | Remark
defaultNamingContext |
distinguishedName | From containers.
name | From containers.
objectClass | From containers.
maxPwdAge |
lockoutDuration |

User group

General form | Remark
distinguishedName |
name |
sAMAccountName |
member | Possible amendment of the value necessary in AD/AD LDS.
description |
groupMembershipSAM | Is set when editing in zenon in the Active Directory user administration screen.
groupType |
objectClass |

User

General form | Remark
distinguishedName |
sAMAccountName |
displayName |
memberOf | Possible amendment of the value necessary in AD/AD LDS.
mail |
telephoneNumber |
Mobile |
pwdLastSet |
userAccountControl |
groupMembershipSAM | Is set when editing in zenon in the Active Directory user administration screen.
userPrincipalName | Possible amendment of the value necessary in AD/AD LDS.
objectClass |
objectCategory |
ZenOnUserLevel1 | Not a default property of AD/AD LDS. Is not normally needed. Only present for compatibility reasons.
ZenOnUserLevel2 | Not a default property of AD/AD LDS. Is not normally needed. Only present for compatibility reasons.
ZenOnUserLevel3 | Not a default property of AD/AD LDS. Is not normally needed. Only present for compatibility reasons.


Variables

Manual -> Variables

Variables, also called process variables or data points, are the interface between the data source (PLC, field bus, etc.) and zenon. They represent certain measured values or states of the hardware, including properties such as scaling, limit values, etc.

The variables are defined in the central variable list of a project and are available here from everywhere (functions, screens, archives, etc.). Integration projects can directly access the variables of lower level projects.

A variable is always based on two components: data type and driver object type. These two components are independent and thus can be configured independently.

tutorial License information

Part of the standard license of the Editor and Runtime.

Context menu Project manager

Menu item | Action
New variable... | Opens the wizard for creating a new variable.
Export XML all... | Exports all entries as an XML file.
Import XML... | Imports entries from an XML file.
Extended import/export | Opens the menu for importing and exporting of -Step 7 projects, dBase and CSV. Note: For additional information please read the chapter Step 7-project import in the book import - export.
Display unused variables | Creates a project analysis for unused variables in the current project and displays it as a result list in its own window.
Open in new window. | Opens a new window in order to view and edit the variable. (Default: at the bottom of the Editor.)
Editor profile | Opens the drop-down list with predefined editor profiles.
Help | Opens online help.

Each variable can have its own attributes. A total of 64 statuses/attributes have been defined.

info Information

Screen elements that are linked to a variable that have neither a value nor a status are switched to invisible in Runtime.


Variables detail view of toolbar and context menu

Manual -> Variables -> Variables detail view of toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tool Bar

No. | Symbol | Action
01 | New variable | Opens the dialog for creating a new variable.
02 | Create standard function | Opens the wizard for selecting the variables and the set values and creates a matching function. The action is documented in the output window.
03 | Variable use | Creates a project analysis for selected variables in the current project and displays it as a result list in its own window.
04 | Display unused variables | Creates a project analysis for unused variables in the current project and displays it as a result list in its own window.
05 | Jump back to starting element | If you entered the list via function linked elements, the symbol leads back to the start element. Only available in the context menu when all linked elements are opened.
06 | Copy | Copies the selected entries to the clipboard.
07 | Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
08 | Delete | Deletes selected entries after a confirmation from list.
09 | Expand/collapse | Drop-down list in order to expand or to collapse all nodes or the selected nodes.
10 | Activate all | Activates all inactive elements of a structure variable.
11 | Activate | Activates the selected elements of a structure variable.
12 | Deactivate | Deactivates the selected elements of a structure variable.
13 | Export selected XML | Exports selected elements as an XML file.
14 | Import XML | Imports variables from an XML file.
15 | Import/Export | Opens the menu for importing and exporting of -Step 7 projects, dBase and CSV. Note: For additional information please read the chapter Step 7-project import in the book import - export.
16 | Extended filter | Activate/Deactivate expanded filter Activating opens the dialog to select the filter criteria.
17 | Remove all filters | Removes all filter settings.
18 | Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
19 | Replace text in selected column | Opens the dialog for searching and replacing texts.
20 | Replace text in limits | Opens the dialog for the selection of the Dynamic properties Once the property has been selected, the search and replace dialog is opened by clicking on OK.
21 | Properties | Opens the Properties window for the selected entry.
22 | Help | Opens online help.

Context menu

Menu item

Action

New variable

Opens the dialog for creating a new variable.

Create standard function

Opens the wizard for selecting the variables and the set values and creates a matching function. The action is documented in the output window.

Linked elements

Opens the submenu with linked elements.

Variable use

Creates a project analysis for selected variables in the current project and displays it as a result list in its own window.

Display unused variables

Creates a project analysis for unused variables in the current project and displays it as a result list in its own window.

Copy

Copies the selected entries to the clipboard.

Paste

Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".

Delete

Deletes selected entries after a confirmation from list.

Expand/collapse node

Allows all or selected nodes to be expanded or collapsed. Selection:

  • Expand all
  • Collapse all
  • Expand selected
  • Reduce selected

Activate all

Activates all inactive elements of a structure variable.

Activate

Activates the selected elements of a structure variable.

Deactivate

Deactivates the selected elements of a structure variable.

Export selected XML

Exports all selected entries as an XML file.

Import XML

Imports entries from an XML file.

Extended import/export

Opens the menu for importing and exporting of -Step 7 projects, dBase and CSV.

Note: For additional information please read the chapter Step 7-project import in the book import - export.

Extended filter

Activate/Deactivate expanded filter

Activating opens the dialog to select the filter criteria.

Remove all filters

Removes all filter settings.

Edit selected cell

Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.

Replace text in selected column

Opens the dialog for searching and replacing texts.

Replace text in limits

Opens the dialog for the selection of the Dynamic properties Once the property has been selected, the search and replace dialog is opened by clicking on OK.

Properties

Opens the Properties window for the selected entry.

Help

Opens online help.


Naming of objects

Manual -> Variables -> Naming of objects

The name of an object must be unique in zenon.

info Information

Note the following when assigning names:

  • the characters # and @ are not permitted in variable names.
  • The maximum length for Name, Identification and String archive filler value is 128 characters each.
  • The maximum length for Resources label is 255 characters.

The variable names are case-sensitive. You can create variables with the same name which only differ from each other by writing a single letter in upper or in lower case. For example the variables test and Test are two different variables.

Attention: Identical names, which only differ from each other due to capitalization, can be a problem with drivers or zenon Logic with:

  1. Driver configuration:

    If the driver name only differs in terms of capitalization, both drivers use the same allocation file.

  2. zenon Logic:

    zenon Logic does not differentiate between upper and lower case. Two variables which differ in zenon only by case sensitivity cannot be used in zenon Logic. This concerns variables:

    • for a zenon Logic project with zenon Logic driver, IEC870 driver and IEC850 driver
    • which are set to externally visible in zenon
    • which are assigned to a driver for which a zenon Logic project for Simulation - programmed has been created

info Information

Recommendation: Use unique object names which differ from each other not only by case sensitivity.


Activating variables in zenon

Manual -> Variables -> Activating variables in zenon

Variables are activated in zenon when screens to which they are linked are opened. They are read from this point onwards. When closing a variable, the linked variables are deactivated again and reading is ended.

info Information

The switching time of screens in Runtime depends on the number of linked variables. Only once all variables have been successfully signed in can the screen be operated.

If many variables are operated, this can slow the switching time. In this case, a progress bar is shown, which displays the loading progress.

Activate (Advise):

Variable values are always queried by the driver. This happens regardless of whether they are needed at the moment in the project or not, even if, for example, a variable has no limit value, is not displayed and the value is also not recorded. The driver thus always has current values and the current status of the variables and can provide these if necessary without querying them.

  • Advantage: Data is immediately available. For example, the toggling of variable values in the Write set value Function or in screen elements such as Switch is executed more quickly because the variable does not need to be queried especially before switching.
  • Disadvantage: Higher load for the communication to the control unit.

The following functionalities ensure that the variables are always activated:

  • Alarms administration
  • CEL
  • Archive Manager
  • VBA/VSTA Online Container
  • PropertyHarddisk data storage active activated
  • PropertyPermanently read variable activated
  • Keep update list in the memory option is activated in the driver configuration (General tab)

Variables that are activated via the Permanently read variable property are also available to other Windows applications.

Hint: If the variable value is to be toggled, we recommend activating the Permanently read variable property.

Queries (Request):

If variables are not activated, values and status are queried from the driver if necessary.

If variable values need to be asked especially, Runtime waits until the driver knows the value of the variables. If the value is not available due to a breakdown in communication with the control unit, the waiting time corresponds to the timeout time of the driver.


Datatypes

Manual -> Variables -> Datatypes

Each variable is based on an IEC data type. The data type has the same properties as the variable itself (unit, signal resolution, limits, etc.). This does not include driver-specific properties such as addressing of the PLC, for example. A data type is a variable template without connection to the process. This connection to the process is only established with the driver object type for the variable.

On creating a new variable a data type has to be selected. All properties of the data type are inherited to the variable. In doing so, the properties are referenced by the data type on which they are based. That means: If a property of the data type is changed, it is also changed for all variables that have been created with this data type. If a property is a reference, it is marked with a symbol (arrow) in the properties window. This reference can also be cut. A more detailed description can be found in the Inheritance concept chapter.

Context menu Project manager

Menu item | Action
New simple datatype... | Opens the dialog for creating a new data type.
New structure datatype... | Opens the dialog for creating a new structure data type.
Export XML all... | Exports all entries as an XML file.
Import XML... | Imports entries from an XML file.
Help | Opens online help.

IEC datatypes:

IEC data types are standardized in the IEC 61131-3 by the IEC. At the the moment zenon supports the following IEC data types:

Short name

Long name

Comment / value range

Number of bits

BOOL

Boolean

Bit: 0/1

1

BYTE

SINT

Short integer

Signed byte:

-128 to 127

8

USINT

Unsigned short integer

Byte: 0 to 255

8

INT

Integer

Signed word:

-32768 to 32767

16

UINT

Unsigned integer

Word: 0 to 65535

16

DINT

Double integer

Signed double:

-2147483648 to 2147483647

32

UDINT

Unsigned double integer

Double:

0 to 4294967295

32

LINT

Long Integer

Because zenon cannot hold the value range of a 64 bit number, the actual value range is restricted to 52 bits. Numbers with signs are possible from –2251799813685248 to 2251799813685247. Numbers outside of this range cause a overflow or underflow, according to a 52-bit integer.

The following components work with a full 64 bit resolution in the zenon Runtime:

  1. The shared memory VBA Interface, when the value was entered in signal resolution.
  2. The shared memory zenon Logic interface.
  3. The driver kit works for the whole range of 64 bits, and so do all the drivers, provided the driver supports this IEC data type. At the moment, these are Sample32, Internal and STRATON32.

RGM and recipes cannot save even a 52 bit value with full accuracy.

64 or 52

ULINT

Unsigned long integer

Because zenon cannot hold the value range of a 64 bit number, the actual value range is restricted to 52 bits. Numbers without signs are possible from 0 to 4503599627370495. Numbers outside of this range cause a overflow or underflow, according to a 52-bit integer.

The following components work with a full 64 bit resolution in the zenon Runtime:

  1. The shared memory VBA Interface, when the value was entered in signal resolution.
  2. The shared memory zenon Logic interface.
  3. The driver kit works for the whole range of 64 bits, and so do all the drivers, provided the driver supports this IEC data type. At the moment, these are Sample32, Internal and STRATON32.

RGM and recipes cannot save even a 52 bit value with full accuracy.

64 or 52

REAL

Real numbers

Real numbers

32

LREAL

Real numbers

Real numbers

64

STRING

Variable-length single byte character string

ASCII string (the max. string length depends on the driver).
The string length is set to 5 characters by default. The correct length is to be given during configuration if necessary.

>= 8 x string length

WSTRING

Variable length

multi-byte character string

Contains multi-byte strings, for example strings in Unicode coding (UTF-8 etc).
The string length is set to 5 characters by default. The correct length is to be given during configuration if necessary.

>= N x string length

DATE

Date

IEC date in steps of 1 day

16

TIME

Duration

Duration in the IEC format. IEC time in steps of 1 ms, signed integer

32

TOD

Time of day

Time of day in steps of 1 ms

32

DATE_AND_TIME

Date and time of day

Defines a period of time with 64 bit and is saved in a binary-coded decimal format.

64

attention Attention

In zenon the data types DATE, TIME, TOD are treated as a data type UDINT in the Unix time format (bygone seconds since 01.01.1970). The data type DATE_AND_TIME equals data type FLAOT in the Unix time format. With this the time is saved exactly to millisecond, i.e. three digits after the decimal point. The driver coverts the data type used in zenon to the corresponding data type and sends the new value to the PLC.
Not all drivers support these data types. Please check the corresponding driver documentation whether the used driver supports the data types.

You can find information on how the inheritance of data type properties works in the Inheritance concept section.


Data types detail view toolbar and context menu

Manual -> Variables -> Datatypes -> Data types detail view toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu

Menu item | Action
New simple data type | Opens the dialog for creating a new simple data type.
New structure data type | Opens the dialog for creating a new structure data type.
New structure element | Opens the dialog for adding a structure element to a structure data type.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of...".
Delete | Deletes selected entries after a confirmation from list.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Export selected XML | Exports all selected entries as an XML file.
Import XML | Imports entries from an XML file.
Remove all filters | Removes all filter settings.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Replace text in limits | Opens the dialog for the selection of the Dynamic properties Once the property has been selected, the search and replace dialog is opened by clicking on OK.
Properties | Opens the Properties window for the selected entry.
Help | Opens online help.


Types of data types

Manual -> Variables -> Datatypes -> Types of data types

Basically there a two different kinds of data types:

  • simple data types; in turn, these consist of:
    • pre-configured simple data types
    • user-defined simple data types
  • Structure data types


Pre-configured simple data types

Manual -> Variables -> Datatypes -> Types of data types -> Pre-configured simple data types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

These are delivered together with zenon and are immediately available when a new variable is created. They conform to the standardized simple data types of IEC 61131-3 such as INT, USINT etc. They define a set value area (fixed upper and lower limit) with a defined number of values. That is why real numbers can be depicted as float-point numbers only with a certain accuracy.

The properties of the simple data types can be changed. The names of these data types always match with the names of the basic IEC data types, these and the IEC data types cannot be deleted or renamed.

The data types only become visible in zenon, once a driver is created. Each driver opens a list of data types it supports. If an IEC data type does not exist in the list of data types, it is not supported by any driver in the project.

Changes in the properties of the data types affect all linked variables and thus also affect all linked structure data types.


User-defined simple data types

Manual -> Variables -> Datatypes -> Types of data types -> User-defined simple data types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

These data types can be created by the user. On creating an existing data type is used. All properties of this basic data type are copied to the new data type and can be changed later on. There is no reference to the data type on which it was originally based. All data types can therefore be configured independently of one another.

For the user-defined data types all properties including name and IEC data type can be changed.

attention Attention

All variables that are based on a data type where the IEC data type is changed may need to be subsequently configured manually.

Example

An IEC data type INT is changed to an IEC data type BOOL. All set value limits of all variables and at all positions, where the variable is used (screens), are no longer correct. It becomes even more critical, if the properties in the variables were overwritten and no longer have a reference to the data type!

When creating a new user-defined data type, a basic data type that has the same IEC data type to that which is needed should always be used.

attention Attention

A subsequent change of the IEC data type explicitly is not recommended!
A number of settings depend on the IEC data type and have to be re-configured by hand if the IEC data type is changed. (Example: Signal resolution, measuring range, hysteresis, set value limits, non-linear value adjustment, etc.).
When changing the IEC data type, all properties specific to this data type have to be checked! Sometimes, the properties have to be adapted before the change, since for BOOL variables the signal resolution and the measuring range cannot be changed, for example.


Creating a new user-defined datatype

Manual -> Variables -> Datatypes -> Types of data types -> User-defined simple data types -> Creating a new user-defined datatype

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Open the folder Variables and select Datatypes.

Now all existing datatypes are listed in the detail view. On the first opening only the pre-defined datatypes corresponding to the IEC datatypes are in this list. A user-defined datatype is always based on an IEC datatype. Click into the list with the right mouse button an in the context menu select Create simple datatype....

In the dialog opening now enter the name of the user-defined datatype and select an existing datatype. This datatype is a template for the new datatype to be created. All properties are copied into the new one. They can subsequently be changed in the properties window. No reference to the basic datatype, being the basis of the new one, exists any longer.

info Information

The name of the data type is limited to 128 characters.

Click on Finish. The new user-defined datatype now appears in the list of simple datatypes in the detail view.


Changing the properties of a user-defined data type

Manual -> Variables -> Datatypes -> Types of data types -> User-defined simple data types -> Changing the properties of a user-defined data type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The properties of a user-defined data type can be changed in the properties window, where all properties of the data type are listed.

Please pay attention that you do not modify the IEC data type because thereby the signal resolution would also be modified.


Deleting an user-defined datatype

Manual -> Variables -> Datatypes -> Types of data types -> User-defined simple data types -> Deleting an user-defined datatype

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Select the datatype to be deleted in the list in the detail view and confirm the delete action in the following dialog box.

attention Attention

If an user-defined datatype is deleted, all variables based on this datatype are also deleted.


Structure data types

Manual -> Variables -> Datatypes -> Types of data types -> Structure data types

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Structure data types are always user-defined data types. In contrast to the simple data types that only allow a flat variable list, they allow to build a structure. This structure can even be nested and so it can become very complex.

If a structure variable is needed, a structure data type has to be created first. A structure consists of a structure name and structure elements. Structure elements can be simple data types or other structures. Structure elements can also be arrays (fields) with up to three dimensions.

attention Attention

You must define, during creation, whether the structure element should use a linked or embedded type. Changes afterwards are not possible.

Example for a structure datatype:

Two structures are displayed in the illustration above.

The structure Controller consists of two elements: Engine speed set and Engine speed actual.

  • The structure element Engine speed actual is linked to the datatype INT, i.e. all properties of the datatype INT are inherited to this structure element.
  • The structure element Engine speed set is embedded into the structure. So all properties of this datatype can be configured in the structure element itself.

The structure Engine consists of the following structure elements: Activity Input, Charging Rate, Voltage, Temperature[3] and Engine Speed Control.

  • The structure element Activity Input is linked to the pre-defined data type UINT - all properties are taken from UINT.
  • The structure element Charging Rate has the embedded data type INT - all properties can be defined in the structure element.
  • The structure element Voltage is linked to the user-defined data type Voltage. The element gets all properties from this data type.
  • The structure element Temperature is a one-dimensional array of three elements of the pre-defined data type SINT.
  • The structure element Engine Speed Control is linked to the structure Controller mentioned above. Structures in a structure cannot be embedded. They are always linked to the original structure. The structure contains two further structure elements: Engine Speed Set and Engine Speed Actual, which get their properties from the original structure.


Creating a structure datatype

Manual -> Variables -> Datatypes -> Types of data types -> Structure data types -> Creating a structure datatype

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This is how you create a structure datatype:

  1. Right click on a user-defined datatype in the list and select New structure datatype in the context menu.
  2. You define the names in the dialog box that now appears.

    Note: The name of the data type is limited to 128 characters.

  3. Confirm the settings with Finish. The name of the structure datatype can be changed later on in the properties window.
  4. Now a dialog opens, with which the first structure element can be created.
  5. Please use an unique name.
  6. Select the data type upon which the element should be based. Click on the ... button to open the selection dialog.

    You can also link structures as structure elements. It is not possible to embed structures as structure elements. It is also only possible to link entire structures and not parts of a structure.

  7. Define if the data type is to be embedded or linked.
  8. Define the array dimensions.
    If you do not want to use an array, set the dimensions to 0.
  9. Confirm the settings with Finish.

Embed or link

Parameters | Description
Embedded structure elements | can have properties that differ from their basic datatypes. The properties are defined individually for each structure element and are saved there.
Linked structure elements | Always get all their properties from the basic datatypes that they are linked to. If the basic data type is changed, all linked elements are changed in the same way!


Inserting further structure elements

Manual -> Variables -> Datatypes -> Types of data types -> Structure data types -> Inserting further structure elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To insert further structure elements:

  1. Right-click on the desired structure data type.
  2. Select New structure element... in the context menu.
  3. Define it in the dialog box that opens
    1. A clear description (name is limited to 128 characters)
    2. the array dimensions and
    3. whether you wish to embed or link the structure element.

If you now highlight the structure data type in the detail view, the existing structure elements are shown as sub-points.


Changing the properties of a structure element

Manual -> Variables -> Datatypes -> Types of data types -> Structure data types -> Changing the properties of a structure element

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To change the properties of a structure element:

Embedded structure elements

  1. Highlight the structure element in the detail view.
  2. Change the desired properties in the properties window

Linked structure element

With linked structure elements, the following can be changed in the Properties window:

  • Name
  • Offsets
  • Array dimensions
  • Description

All other properties must be changed directly at the original data type.

attention Attention

Note that changes to the data type have a direct effect on all variables related to them and also have an effect on all other structure data types linked to this data type.

Changes to the data type are not recommended. These must be prepared and carried out with due care. In particular when changing the IEC data type settings, measuring range settings, set value limit settings, etc.

In certain circumstances, all variables and all screens in which these variables are used must be manually adjusted afterwards!


Moving a structure element

Manual -> Variables -> Datatypes -> Types of data types -> Structure data types -> Moving a structure element

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Elements of a structure data type can be moved by dragging & dropping. To move elements:

  1. Highlight the desired element.
  2. You can also select several interrelated elements
  3. Click in the selection and drag the element to the desired position

For multi-user projects, a check is carried out to see if the status of the data type to be changed is set to Allow changes or can be set to this.

Moving several objects

interrelated elements can be moved by dragging & dropping. For this, the following applies:

  • Only interrelated structure elements can be moved.

  • If a gap is recognized with multiple selection, the drop action is refused.


Deleting a structure datatype

Manual -> Variables -> Datatypes -> Types of data types -> Structure data types -> Deleting a structure datatype

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To delete a structure data type:

  1. Right-click on the structure data type in the list.
  2. Select Delete in the context menu.
  3. The structure data type is deleted with all its structure elements.

attention Attention

When deleted, all variables that are based on this structure data type are also deleted!


Driver

Manual -> Variables -> Driver

zenon offers more than 300 different connections to different PLCs, bus systems and applications.

To communicate with a data source it is necessary to link an interface driver (protocol driver). The driver establishes the connection between a PLC and zenon. The data source not necessarily is a PLC. The DDE driver communicates with a DDE server, the OPC client driver with an OPC server, the SNMP driver with SNMP agents, etc.

A number of different drivers are available and they also can be used at the same time.

attention Attention

Under Windows CE only one type of a driver can be started at the time.

Context menu Project manager

Menu item | Action
New driver... | Opens the detail view for selecting a driver.
Help | Opens online help.

On creating a new variable, it has to be defined for which driver the variable is created.

The zenon drivers are protocol drivers. They should not be confused with the interface drivers of the operating system (e.g. drivers for LAN cards of drivers for a serial interface). The zenon drivers are always based on the interface drivers of the operating system and communicate with the respective protocol (e.g. Modbus RTU, MPI, Melsec A, etc.) that is understandable for the PLC.

Basic drivers are available in zenon free of charge: Variables based on these drivers are not counted for licensed I/Os:

Parameters

Description

Simulator driver SIMUL32

For internal variables.

These can be defined as failure-proof variables (hard disk data) or as flag types; flag objects can automatically change their value for dynamic simulation

Mathematics driver MATHDR32

Variables of this driver are used for the calculation of mathematical functions or for counters.

System driver Sysdrv

variables for monitoring and controlling the hardware, the network and other project-specific properties.

Internal driver Internal

User-defined variables without connection to a PLC. (Similar to the user-defined variables of the system driver).

Each variable has an individual value. So it is not possible e.g. to extract bit or byte variables from an integer variable.

Defining address information is not necessary, the according properties in the properties window cannot be edited.

Detailed driver descriptions for the individual drivers can be found in the corresponding driver documentation, which is available to you via the online help in the Driver chapter and on the installation medium.

When a new driver is created, a selection dialog is opened, where all available drivers are listed. The information for this dialog are in the files Treiber_DE.xml, Treiber_EN.xml etc. depending on the language. You can open or edit these XML files with the driverinfo.exe. tool


Driver detail view toolbar and context menu

Manual -> Variables -> Driver -> Driver detail view toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu

Menu item | Action
Driver new | Opens the dialog for creating a new driver.
Change driver | Opens the selection window for defining a driver.
Delete | Deletes selected entries after a confirmation from list.
Driver configuration | Opens the dialog for configuring the driver.
Import variables from the driver | Opens the dialog for importing variables.
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Remove all filters | Removes all filter settings.
Help | Opens online help.


Driver object type

Manual -> Variables -> Driver -> Driver object type

The driver object types define which area of a variable should be referred to in the PLC. At the moment all manufacturer use different names for the areas of their PLCs. In the Siemens world there are datablocks, markers, in/output etc. in the Modbus world there are coils and holding registers. Each driver creates an internal list with the available driver object types. When creating a new variable, the area in the PLC to which it is allocated must be specified.

There is a strict distinction between data type and driver object type

The strict distinction makes it possible to create a structure as a data type completely independently and thus independently of the PLC. This structure as a variable can be linked to any driver. A structure can, for example, be linked to the corresponding driver 1:1 with a Siemens PLC as well as a Modbus PLC with the corresponding drivers.


Creating a driver

Manual -> Variables -> Driver -> Creating a driver

In order to create a new driver:

  1. Right-click on Driver in the Project Manage and select Driver new in the context menu.
  2. In the following dialog the control system offers a list of all available drivers.

  3. Select the desired driver and give it a name:
    • The driver name has to be unique, i.e. if one and the same driver is to be used several times in one project, a new name has to be given each time.
    • The driver name is part of the file name. Therefore it may only contain characters which are supported by the operating system. Invalid characters are replaced by an underscore (_).
    • Attention: This name cannot be changed later on.
  4. Confirm the dialog with OK. In the following dialog the single configurations of the drivers are defined.

Only the respective required drivers need to be loaded for a project. Later loading of an additional driver is possible without problems.

info Information

For new projects and for existing projects which are converted to version 6.21 or higher, the following drivers are created automatically:

  • Internal
  • MathDr32
  • SysDrv.


Configuration of a driver

Manual -> Variables -> Driver -> Configuration of a driver

The configuration dialog is opened when a driver is created. In order to be able to open the dialog later for editing, double click on the driver in the list or click on the Configuration property.

Parameters

Description

Mode

Allows to switch between hardware mode and simulation mode

  • Hardware:

    A connection to the control is established.

  • Simulation static

    No communication between to the control is established, the values are simulated by the driver. In this modus the values remain constant or the variables keep the values which were set by zenon Logic. Each variable has its own memory area. E.g. two variables of the type marker with offset 79 can have different values in the Runtime and do not influence each other. Exception: The simulator driver.

  • Simulation - counting

    No communication between to the control is established, the values are simulated by the driver. In this modus the driver increments the values within a value range automatically.

  • Simulation - programmed

    N communication is established to the PLC. The values are calculated by a freely programmable simulation project. The simulation project is created with the help of the zenon Logic Workbench and runs in a zenon Logic Runtime which is integrated in the driver. For details see chapter Driver simulation.

Keep update list in the memory

Variables which were requested once are still requested from the control even if they are currently not needed.
This has the advantage that e.g. multiple screen switches after the screen was opened for the first time are executed faster because the variables need not be requested again. The disadvantage is a higher load for the communication to the control.

Output can be written

Active: Outputs can be written.

Inactive: Writing of outputs is prevented.

Note: Not available for every driver.

Variable image remanent

This option saves and restores the current value, time stamp and the states of a data point.

Fundamental requirement: The variable must have a valid value and time stamp.

The variable image is saved in mode hardware if:

  • one of the states S_MERKER_1(0) up to S_MERKER8(7), REVISION(9), AUS(20) or ERSATZWERT(27) is active

The variable image is always saved if:

  • the variable is of the object type Driver variable
  • the driver runs in simulation mode. (not programmed simulation)

The following states are not restored at the start of the Runtime:

  • SELECT(8)
  • WR-ACK(40)
  • WR-SUC(41)

The mode Simulation - programmed at the driver start is not a criterion in order to restore the remanent variable image.

Stop on Standby Server

Setting for redundancy at drivers which allow only on communication connection. For this the driver is stopped at the Standby Server and only started at the upgrade.

Attention: If this option is active, the gapless archiving is no longer guaranteed.

Active: Sets the driver at the not-process-leading Server automatically in a stop-like state. In contrast to stopping via driver command, the variable does not receive status switched off but an empty value. This prevents that at the upgrade to the Server irrelevant values are created in the AML, CEL and Historian.

Note: Not available if the CE terminal serves as a data server. You can find further information in the zenon Operator manual in the CE terminal as a data server chapter.

Global Update time

Active: The set Global update time in ms is used for all variables in the project. The priority set at the variables is not used.
Inactive: The set priorities are used for the individual variables.

Priority

The polling times for the individual priority classes are set here. All variables with the according priority are polled in the set time.

The allocation to the variables takes place separately in the settings of the variable properties.
The communication of the individual variables are graduated in respect of importance or necessary topicality using the priorities. Thus the communication load is distributed better.

Attention: Priority classes are not supported by each driver For example, drivers that communicate spontaneously do not support it.

Close dialog

Parameters | Description
OK | Applies all changes in all tabs and closes the dialog.
Cancel | Discards all changes in all tabs and closes the dialog.
Help | Opens online help.

Update time for cyclical drivers

The following applies for cyclical drivers:

For Set value, Advising of variables and Requests, a read cycle is immediately triggered for all drivers - regardless of the set update time. This ensures that the value is immediately available for visualization after writing. Update times can therefore be shorter than pre-set for cyclical drivers.


Driver simulation

Manual -> Variables -> Driver -> Driver simulation

If the underlying process is not available when configuring, this can be simulated and tested in advance. Three modes are available for this:

  • Simulation static: constant values simulated by the driver
  • Simulation - counting: values simulated by the driver are counted up
  • simulation - programmed: Values are calculated via a simulation project with zenon Logic

attention Attention

If the driver is stopped in mode Simulation - counting, only the counting is stopped. The variable is not switched to faulty. In all other modes the driver is really stopped.

Note: Simulation - programmed is not supported by drivers for:

  • Internal variables
  • Mathematical variables
  • Simulator variables
  • System variables

info Information

zenon variables which represent the zenon Logic IO variables are available in the project in state Driver simulation programmed.

tutorial License information

Part of the standard license of the Editor and Runtime.


Simulation static

Manual -> Variables -> Driver -> Driver simulation -> Simulation static

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For a static simulation, no communication to the control is established; the values are simulated by the driver. In this mode the value remains constant. Values can be changed by the Runtime or the user. At a restart of the Runtime with Simulation - static theses values will however not be saved and are lost.


Simulation - counting

Manual -> Variables -> Driver -> Driver simulation -> Simulation - counting

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For a counting simulation, no communication to the control is established; instead the values are simulated by the driver. In this mode, the driver increments the values within a value range automatically, starting with 0. If the maximum value has been reached, the counting process starts at 0 again.

info Information

For negative starting values, the counting process only starts at 0.

INT uses the maximum value from USINT to count.

attention Attention

If the driver is stopped in mode Simulation - counting, only the counting is stopped. The variable is not switched to faulty. In all other modes the driver is really stopped.


Simulation - programmed

Manual -> Variables -> Driver -> Driver simulation -> Simulation - programmed

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For Simulation - programmed, no communication is established to the PLC; instead, the values are calculated by a freely programmable simulation project. The simulation project is created with the help of the zenon Logic Workbench and runs in the zenon Logic Runtime. It enables the status and time stamp of variables to be modified on the driver. Write commands to variables by zenon are forwarded to the simulation, redundant servers and Standby Servers are synchronized. This is how you also simulate complex processes.

To start the simulation program, select the Simulation - programmed mode in driver configuration.

info Information

Windows CE

Simulation - programmed is not available for Windows CE.


Editor

Manual -> Variables -> Driver -> Driver simulation -> Simulation - programmed -> Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


Create project

Create project

To create a program for Simulation - programmed, you must:

  • select a single process driver
  • make sure that the project name is valid.

attention Attention

Simulation - programmed is not supported by drivers for:

  • Internal variables
  • Mathematical variables
  • Simulator variables
  • System variables

To create a simulation project:

  • click in the group Driver simulation project in the property Edit on Click here ->
  • A new zenon Logic project is created.
  • Name and port numbers for Event port and Standard port are automatically issued; change these as you wish
  • the zenon Logic Workbench is opened

The simulation project's workshop is automatically closed if:

  • the zenon editor is closed
  • a driver is deleted and its simulation project is currently being edited in Workbench
  • the simulation project for the driver is deleted via the Delete property
  • the simulation project is renamed

info Information

Port numbers: At creating the simulation project for this project a distinct port number is assigned automatically. An automatically assigned port number is only unique for the respective project. In multi-hierarchical projects, it must be ensured that a port number is only used once in all projects that run in Runtime. If a port number is used more than once, communication errors can occur with zenon Logic Workbench/Runtime.

Port numbers can be amended manually. A port number must meet the following conditions:

  • It must be free in the project.
  • It must be unique for all projects that run in Runtime.
  • It must be available on the computer on which the driver runs.

Permitted port numbers:

  • Minimum: 6000 (with automatic allocation, manually: recommended)
  • Maximum: 6999 (with automatic allocation, manually: recommended)

Project archiving

A zenon Logic project contains many files and folders. To manage them, in particular to simplify distributed engineering, all files are archived in compressed form in the Simul_<Treiber-ID>.zip file in the <Sql Projekt Pfad>\FILES\zenon\custom\drivers. This file is in the driver files in the editor. When starting zenon Logic Workbench, the files are automatically decompressed are compressed again when it is ended.

Creating variables

When creating variables in a simulation project, the succession is important:

  1. create the variable
  2. select the valid data type in the zenon Logic Workbench
  3. after that activate property embed symbol

Background: Variables are created with the PLC marker driver object type by default. This object type does not support all data types for all drivers. If a variable is copied in the zenon Logic Workbench with active property embed symbol, you must deactivate this property in order to change the data type. With this the variable is then deleted in zenon.

info Information

Error message "Can not create variable"

A variable cannot be created in the simulation object if the driver does not have driver object types - exception

driver variable - which support this data type.

On activation of embed symbol, the error message "can not create variable" is displayed.

Structure data types

At creating variable with a structure data type:

  • they are created with the driver object type PLC marker if possible
  • all driver object types with the exception of driver variable are tried until one can be used for all elements
  • if no fitting driver object type is available,
    • no variable is created for non-structure variables
    • driver object type PLC marker is used for structure variables

Example:

A structure data type contains elements of type UINT and STRING. A variable is created for S7TCP driver and embed symbol is activated.

  • The variable is not created in PLC marker but as Ext. Data module, in which all structure elements are present.
  • A new type LINT is added; it is not supported by the Ext. Datablock.
  • When a new variable is created, it is created as type PLC marker. Only the first complex variable can be activated (UINT). The object type Ext. remains for the existing structure variable Data and the last structure element (LINT) cannot be activated.

Compiling the files

If a simulation project is compiled in zenon Logic Workbench, this causes a variable to be created in zenon and the Runtime program file.
When compiling, a subfolder is created in Runtime-Folder\RT\FILES\zenon\custom\drivers with the name of the simulation project. The file with the code of the simulation is SIMULRT.COD is archived in this folder.

The following message is displayed in the output window:

SIMULRT.COD

And if compiled with the C compiler, then also:

T5APP.DLL

attention Attention

For multi-user projects you must not create simulation projects offline. They cannot be deleted anymore.


Delete project

Delete project

To delete a simulation project:

  1. click on the Click Here-> button in the Delete property in the Driver simulation project group
  2. confirm this when requested to do so
  3. the ZIP file with the project files is deleted
  4. the zenon Logic Workbench is ended

Note:

  • the Runtime folder for the simulation project remains
  • function Undo is not available for this action,
  • click on Edit to create a new simulation project
  • for multi-user projects:
    • the driver must be configured to Make changes possible so that the simulation program can be deleted
    • the project is not displayed as deleted on other Clients as long as it has not been synchronized;

      if you try to open a deleted project before it has been synchronized (click on Edit), a new simulation project will be created

    • you cannot reverse the deletion of single-user projects via Cancel changes

attention Attention

The Simulation project is immediately removed from the local database and the server database when deleted. This action cannot be undone!

Note: Manual deletion of the ZIP file of the driver also leads to the simulation project being deleted. Requirement: The zenon Logic Workbench for this driver is not opened. We do not recommend doing it this way!


Distributed engineering

Distributed engineering

For multi-user projects, all running zenon Logic Workbenches that are part of the project are closed when:

  • Accept changes for modules that are completely locked for other users in Enable changes, such as variables, drivers and data types
  • Discard changes:
    • new projects are not created on the server
    • Changes in the simulation program are lost
    • Driver files not present in the server database are also lost in the local database
  • Synchronize:
    changes made locally to the simulation program program are lost
  • Update local version:
    changes made locally to the simulation program in the simulation program are lost

attention Attention

The status of the simulation project's ZIP file may not be additionally modified(Accept Changes, Enable Changes, Discard Changes multi-user status), to ensure correct Accept Changes and Enables Changes for the driver!

Delete project

For multi-user projects

  • the driver must be configured to Make changes possible so that the simulation program can be deleted
  • the project is not displayed as deleted on other Clients as long as it has not been synchronized;
    • if you try to open a deleted project before it has been synchronized (click on Edit), a new simulation project will be created
  • you cannot reverse the deletion of single-user projects via Cancel changes

attention Attention

A simulation project with the status of Enable Changes cannot be deleted in Offline mode.

A simulation project created offline in a multi-user project can therefore no longer be deleted.


Change driver

Change driver

For a driver change in zenon the following is true:

  • The simulation project is maintained.
  • All ports are however set to 0. To receive working port numbers, open the project in the Editor. At this new port numbers are entered automatically. Port numbers can also be assigned manually.

attention Attention

Drivers that are linked to a zenon Logic project using the integrated solution cannot be exchanged.


XML export/import

XML export/import

A project in mode Simulation - programmed can be exported via XML. It can however not be imported as new project for another driver.

Workaround:

  1. Export the zenon Logic programs.
  2. Import them to the new project for the new driver.
  3. Replace the variables via search and replace.


Driver configuration

Manual -> Variables -> Driver -> Driver simulation -> Simulation - programmed -> Driver configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There are four modes available when configuring the driver:

  • Hardware
  • Simulation - counting
  • Simulation static
  • Simulation - programmed

Select the simulation - programmed mode.


Driver variable status

Driver variable status

The status of zenon Logic is shown in the driver variables SimulRTState at Offset 60. The variable is numerical and cannot be written to. The value informs you of the status of Runtime:

Bit | Meaning | Description
31 | without application | Runtime has not loaded a program, the program was stopped or not loaded to Runtime.
30 | not instanced | Runtime was not instanced, for example because the DLL with Runtime could not be loaded, there is too little memory, the DLL is not present or is the wrong version.
18 | p-code available | p-code is available together with compiled code, switching is possible.
17 | compiled code active | Runtime runs with compiled code (otherwise: interpreted p-code)
16 | compiled code available | Compiled code from the C compiler is available
15 | application is loaded | An application is present, Runtime is running
14 | can't start - missing handlers | Some "C" functions are missing
13 | active breakpoints installed | At least one breakpoint was set by the debugger.
12 | CT segment exists | Application was compiled with the "complex variables in separate segment".
11 | Reserved | (internal, for Runtime only.)
10 | sysinfo request is available | (internal, for Runtime only.)
9 | freeze event production | Binding does not transmit events.
8 | single cycle mode | (intern, for Runtime and debugger only.)
7 | Reserved | (internal, for Runtime only.)
6 | locked variables | At least one variable is blocked.
5 | trigo functions are in degrees | Trigonometric functions are stated in degrees.
4 | log message(s) in stack | (internal, for Runtime only.)
3 | application stopped between 2 progs | Runtime stopped between two steps during debugging
2 | application stopped on SFC breakpt | (internal, for Runtime only.)
1 | application stopped on error | Runtime stopped with a serious error, restart required.
0 | application is running | TRUE = application is in "run" mode. FALSE = application pauses in "cycle to cycle" mode.

info Information

The driver variable SimulRTState with Offset 60 displays the status of Runtime on the server. This is also true when the variable is displayed on the Standby.


Cyclical synchronization

Cyclical synchronization

Simulations run in a network on the server and Standby Server independently of one another. When the Standby Server starts, there is a synchronization with the server, however:

  • This first synchronization is postponed by the packet runtime
  • Small differences in the execution lead to growing diversion

The status of the simulated variables also therefore becomes different. In order to keep these differences low, use the Transfer driver simulation image to standby to synchronize the simulation image:

  • create a new function
  • Select Transfer driver simulation image to standby

  • The dialog to select the driver opens

  • In the list, all process-connected drivers (with the exception of the simulator) are available (clicking on the column heading changes the sorting)
  • Select the driver that is to be synchronized
  • Each time a function is called up on the Standby Server, an image is requested from the server for the selected driver

The differences in the current simulation status can be minimized through cyclical activation. Adapt the grid of the execution to the extent of the data to be synced, because this places a load on the network and computer.

The Execution of the function is set at Standby Server and fixed; it cannot be changed. It only happens if:

  • The computer is the Standby Server
  • The Server is online
  • The project is a network project
  • Drivers were selected for syncing

To change the selection of the drivers

  • In the driver properties, click in the General group in the Parameter properties
  • The dialog for selecting the driver opens


zenon Logic Workbench

Manual -> Variables -> Driver -> Driver simulation -> Simulation - programmed -> zenon Logic Workbench

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Simulation - programmed is programmed in the in the zenon Logic Workbench, which works in close conjunction with the zenon Editor. For the simulation, (in contrast to the integrated solution) only the variables of a driver are exchanged between the editors.

Definition of the variables to be exchanged:

When starting zenon Logic Workbench, all driver variables that are not yet present in zenon Logic are created as global variables. The Embed symbol is automatically activated for these.

Visibility

If a new variable is defined in Workbench in the global or retain area, this is only visible in zenon Logic. To make it visible in zenon too, the Embed symbols option must be activated. From this point in time, all variables are updated by both editors.

If the Embed symbol option is deactivated, the variable is deleted in the zenon editor. This action enables global or retain variables to be defined in zenon Logic, which are not visible for zenon.

For a newly-created variable created by the zenon Logic Workbench in zenon, an attempt is made to assign this to the SPSMERKER area. In the event that the zenon driver does not support the configured data type, a search is made for the first data area that supports the data type. If no area is found, the variable cannot be created.

A variable is only locked if in the case of a multi-user project and the enable changes status has not been set.

Project Settings

Some settings under Project -> Project parameters... >-Further options-> Extended in zenon Logic influence the functionality of the simulation.

Extended settings

Description

Runtime: execute mode

Recommendation:

Mode: triggered

cycle time: 1/4 to 1/3 of the driver update time
for frequent value changes to simulated variables lead to increased load placed on the computer.

compiler/options: Embed symbols of all variables

Recommendation: Deactivate.
Active: Data for a variable are exchanged, because the symbol names are assigned in Runtime.

But: Changes to the configuration of the variables are not updated between zenon and zenon Logic. It is no longer possible to make changes online.

compiler/options: Retain capitalization of symbols

without effect: Variable names are always converted to capitals in Runtime.

compiler/options: Create status bits for variables with a profile

Active: The status of variables is simulated or reacted to in the simulation program.

"C" compiler

Native code is supported.

Name of the DLL that the compiled code must contain: t5app.dll.


Runtime

Manual -> Variables -> Driver -> Driver simulation -> Simulation - programmed -> Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com


Functionality

Functionality

zenon Logic Runtime offers the following functions:

  • File transfer
  • Data types:
    • BOOL
    • BYTE
    • DINT
    • DWORD
    • INT
    • LINT
    • LREAL
    • REAL
    • SINT
    • STRING
    • TIME
    • UDINT
    • UINT
    • USINT
    • WORD
  • zenon arrays (see also Arrays and simulation)
  • Date stamp/time stamp
  • Digital recording of values
  • Dynamically linked function blocks, stored in t5block*.dll
  • Hot Restart
  • Logging:
    • Trace messages from the program (printf)
    • Error messages in Runtime
    • all sent to Workbench and to the diagnosis server
  • Machine code: Native compiled code with C post compiler (not available under Windows CE)
  • Online Change
  • Programming languages: IL, AS, FDB, LD, ST
  • Retain Data (remanant Data)
  • Special function blocks and features:
    • Data serialization
    • dynamic memory allocation
    • embedded recipes
    • embedded variable lists
    • File Management
    • Files
    • Math
    • Random
    • Signals
    • String tables
    • Trigonometry
    • Time
  • Spontaneous communication
    • Value change as an event
    • 16 connections
    • Hysteresis
  • UDP & TCP/IP for IEC languages
  • Variable interlocking


Arrays and simulation

Arrays and simulation

To simulate multidimensional arrays at driver simulation, you must activate property 'Save complex variables in own segment' in the zenon Logic Workbench.

Arrays with start index 1

If at a simulation arrays with start index 1 exist, these arrays are created with one more index in the zenon Logic Workbench.

Example Example

In zenon an array has indices 1 to 4. This array has the indices 0 to 4 in the zenon Logic Workbench.

This guarantees that the same indices are used in zenon and in zenon Logic. Index 0 is not transferred to the driver.

If you change array in the zenon Logic Workbench, you must consider this additional index.


Runtime files

Runtime files

When creating the Runtime files, a subfolder with the name of the simulation project is created in the Runtime folder of the project in the path \RT\FILES\zenon\custom\drivers. The file with the code of the simulation is simulrt.cod and is archived in this folder.

Once successfully compiled in the Workbench and transferred to the Runtime folder, the following message is shown in the output window of the Editor:

SIMULRT.COD

And if compiled with the C compiler, then also:

T5APP.DLL

Remote Transport

The Runtime files for the simulation are created as a subfolder of the driver files. For remote transport, the and all information contained in it is transferred to the target computer


Data exchange

Data exchange

The exchange of data from zenon Logic Runtime to the driver starts with the 2nd cycle of zenon Logic Runtime. Therefore the first run is available to initialize all variables in Runtime.

Data is only exchanged if:

  • The variable is requested and:
    • did not yet receive a value
    • does not have the status Switched off (OFF/_VSB_N_UPD) or Alternate value (ALT_VAL/_VSB_AVALUE) in the driver
    • is still required by the driver.
    • has changed value or status

The exchange of data to the driver is carried out asynchronously to the Runtime cycle. The driver runs through the value changes once per update cycle. All values changed - with the exception of the Switched off (OFF/_VSB_N_UPD) or Alternate value (ALT_VAL/_VSB_AVALUE) status - are entered into the list of variables to be updated in the driver and sent to Runtime.

Transfer driver simulation image to standby function

This function is only executed on the Standby Server (for configuration, see Cyclical comparison chapter). The data is synchronously fetched from the driver on the server that is compiling the image. The driver has 5 seconds of time for this. Because the data for the image is created in the same thread in which the simulation is running, it must be ensured that the simulation is processed within 5 seconds. If this time is exceeded, no image is transferred for this driver.

Value simulation

Value changes are not transferred immediately, but stored in a buffer. The size of the buffer amounts to 8192 value changes or the five time the number of variables, according to whatever value is greater. The delay in transferring resulting from the driver cycle can be up to 100 ms. If the value changes again whilst it is waiting to be transferred, all values that have not yet been transferred are sent to Runtime and the new value is then noted. This can lead to an increased load for the computer and network, but ensures that all values are transferred in Runtime.

Driver write command

If simulation - programmed is configured and active, the write commands at standby are passed through in Runtime.

Write operations are carried out by the driver asynchronously to Runtime. Data is exchanged via a buffer. The size of the buffer amounts to 8192 value changes or the five time the number of variables, according to whatever value is greater.

Write commands are ran through after their values are changed in Runtime. If a write command cannot be executed correctly, the error message Write queue full! Write command for <DP-Name> lost! is displayed.

If the status bits are activated, setting Writing successful will display if the value was written from the driver to the value of the variable. The Runtime program should delete this status again after processing the write command. A status bit that is already active does not cause any delay in the driver writing again. Write commands are also executed if the Runtime program was stopped by a breakpoint.

Note: Not all write commands from the driver must be visible in Runtime. If several write commands are in the buffer,only the last one is visible in Runtime.

switch off variables, switch to substitute value

If the variable is switched off or switched to a substitute value, this is not recognizable for Runtime. Changes in values that are also carried out by Runtime are not assigned to the variables in the driver. If the variables are again switched to spontaneous value or activated, the current value is again carried over from Runtime to the driver. When turning off the spontaneous value, status bit OFF is set. When you switch back to the spontaneous value, the OFF bit is reset.


Data storage

Data storage

Retain Data

Retain data is stored in the SimulRt<TreiberID>.ret file. One file such as this is created per simulation, provided retain variables are present. The file is taken into account when a comparison is carried out in the network.

Driver remanent

The Simulation - programmed setting at the driver start is not a criterion in order to restore the remanant variable image.


Redundancy

Redundancy

Start on the Standby Server

If the driver is already running on a Standby Server, then the image for the simulation should already be available. In this case, the simulation is started "hot" with this image. If there is no image, a warm a start is carried out.

Transfer driver simulation image to standby function

This function is only executed on the Standby Server (for configuration, see Cyclical comparison chapter). The data is synchronously fetched from the driver on the server that is compiling the image. The driver has 5 seconds of time for this. Because the data for the image is created in the same thread in which the simulation is running, it must be ensured that the simulation is processed within 5 seconds. If this time is exceeded, no image is transferred for this driver.

Synchronization

In addition to the program files of the simulation, the following are also compared:

  • Retain data (*.ret)
  • all *.simul files
    This file extension is created by the simulation program for simulation specific files and archived in the folder with the computer description below the Runtime folder.


Status

Status

Status simulation

For the status simulation, in zenon Logic under Project -> Project parameters -> Extended -> Compiler -> Options -> Create status bits for variables with a profile must be active. If the status of a variable is modified, this triggers the transmission of a variable to the driver.

Changes to the following states does not trigger a value change at the driver and is also not taken over from the simulation:

  • Real time external (T_EXTERN/_VSB_RT_E)
  • Real time internal (T_INTERN/_VSB_RT_I)
  • Standard time (T_STD/_VSB_WINTER)
  • Writing acknowledged (WR_ACK/_VSB_WR_ACK)
  • Writing successful (WR_SUC/_VSB_WR_SUC)
  • Normal status (NORM/_VSB_NORM)
  • Deviation from normal status (N_NORM/_VSB_ABNORM)
  • Select in the network (NET_SEL/_VSB_SELEC)
  • Runtime exceeded (TIMEOUT/_VSB_RTE)
  • In process (PROGRESS/_VSB_DIREC)
  • Switched off (OFF/_VSB_N_UPD)
  • Substitute value (ALT_VAL/_VSB_AVALUE)

info Information

State bit Writing successful (WR_SUC/_VSB_WR_SUC) is available in the Runtime program and can be set back in order to display successful writing.

However only setting back the state does not trigger the transfer to the zenon Runtime. Only value changes are transferred from the driver to the Runtime.

Status bits handled differently

The following status bits cancel each other out:

Bit

Description

17: Spontaneous
(SPONT/_VSB_SPONT)

Status Spontaneous is set. This is the status set if status handling is turned off or no status was defined. Status GI + INAVLID is deleted.

18: Invalid
(INVALID/_VSB_I_BIT)

Status INVALID is set. Status SPONTAN + GI is deleted.

16: General query
(GI/_VSB_GR)

Status General query is set. Status SPONTAN + INAVLID is deleted.

8: Select in the network
(NET_SEL/_VSB_SELEC)

If this status bit is active (BSO activation/deactivation) the following status bits are accepted with 0 and also transmitted as 0 to the driver to identify a change:

  • Select in the network (NET_SEL)
  • Cause of transmission (COTx)
  • Select (SE_870)
  • N_CONF (P/N-BIT)
  • Test bit (TEST)
  • Writing successful (WR_SUC)

select before operate (SBO)

Status simulation must be available in the Runtime program in order for Select Before Operate to be reacted to. The procedure for Select Before Operate is defined in Runtime.

Activation

If a SBO select is sent to the driver, it triggers a value being written with state Select in the network (NET_SEL) + cause of transmission (COT_act).

A corresponding SBO procedure must be implemented and must start in Runtime.

The state bit Select in the network (NET_SEL) must be set back in the Runtime program.

Deactivation

The deactivation triggers the writing of a values with status Select in the network (NET_SEL) + Cause of transmission (COT_deact).

The SBO procedure must be ended in Runtime accordingly.

The state bit Select in the network (NET_SEL) must be set back in the Runtime program.


Start / stop

Start / stop

Driver start

The value updating only starts at the Standby Server if the driver has received the process image from its server. The image must be received within the time out module, otherwise the driver will start without an image. If the Standby Server is upgraded to the server within the waiting waiting time, waiting is also ended. Drivers that start in a network project or without a network have no waiting time. This behavior applies for both the simulation as well as for the hardware mode.

Runtime start

If the driver starts the simulation - programmed, the first stage is loading the DLL with the simulation Runtime. After this, Runtime is parametered and the Runtime program starts, provided it can be successfully loaded.

If an image of Runtime is present, Runtime is started hot with this. Otherwise, a warm start is carried out. If this is also not possible, an attempt is made to start Runtime cold. If there is no valid program, Runtime boots up stopped. The status of all variables is set to INVALID.

The simulation program runs in it own thread and is therefore completely independent from the driver cycle.

info Information

Retain variables

Retain data contain only the value of the zenon Logic variables not their status. This means for the start:

  • Warm start: The status which was set for a variable is restored - regardless of whether it is a retain variable or not.
  • Cold start with retain variables: Only the value of the retain variable in zenon Logic is restored, not the status.

Stop Runtime

If Runtime is stopped, the status INVALID is set for all variables. Variables that are requested when Runtime is stopped have the status INVALID as initialization. Runtime secures the data for the warm start and online change:

  • SIMULRT.HOT: contains the data for the hot restart.
  • SIMULRT.UPD: contains the data for the online change.

Both these files are created in the Runtime program folder. Runtime must have write authorization for this folder.

Reload

  • Recompiling the simulation project:
    causes the corresponding driver to be reloaded.
  • Modification of the Time Out module:
    is not recognized as a change by Runtime and does not cause the driver to be reloaded.

Standard implementation in the driver kit triggers a hot restart when reloading the simulation project. If this is not possible (for example because the program is different), a cold start is carried out with retain.

Removing Runtime

If Runtime is running, this is stopped. Before Runtime is removed, all outstanding value updates are sent to the driver. Only then is Runtime released and SimulRuntime.dll removed from the PC.


Driver commands

Driver commands

Driver commands are used to influence drivers via zenon, e.g. start and stop.
The engineering is implemented with the help of function Driver commands.

Stop/start driver

If the driver is stopped in simulation - programmed mode, this will result in Runtime being removed from the memory. All variables obtain status INVALID. When the driver is restarted, the simulation is reloaded and Runtime is started.

Switch hardware/simulation driver

When switching between modes Hardware and Simulation, the driver behaves according to the following pattern:

  1. If the driver was configured for hardware mode in the Editor:
    • the driver is set to mode Simulation static after function Driver command is executed with parameter Driver in simulation mode.
  2. If the driver was configured in the Editor for one of the simulation modes (static, counting, programmed:
    • the driver is set to hardware mode and communicated with the control after function Driver command is executed with parameter Driver in hardware mode.
    • the driver then changes back to the configured simulation mode after function Driver command was executed with parameter Driver in simulation mode


Variable assignment

Variable assignment

The zenon driver is allocated to the zenon Logic variables via the names converted into capital letters. If the zenon Runtime requests a variable from the driver, it forwards this to the simulation. If no simulation is loaded, the variable receives status Switched off ( OFF/VSB_N_UPD) when the driver is stopped. Otherwise it receives status Invalid (INVALID/_VSB_I_BIT). Variables of driver variable object type are never requested by the simulation.


Time stamp

Time stamp

To use the time stamp, in zenon Logic under Project -> Project parameters -> Extended -> Compiler -> Options ->Statusbit create for variables with profile must be activated.

If in the Runtime program, the date for a variable is set, the value of the date and time is used as the time stamp. When the date or time changes during the last cycle, this always triggers a transfer of the value to the driver. This also applies if neither the value nor the status have changed.

Most drivers only transfer a new time stamp if the value and/or status change at the same time. An example of an exception is the IEC870 driver, which also transfers new timestamps from the hardware (or Simulation - programmed) with the same value and same status to Runtime.

info Information

It must be ensured that the date and time always increase. If this is not the case, this can lead to problems when archiving. The date must be a value greater or less than 0.

Variables stamped by the Runtime program receive the status Real time external (T_EXTERN/_VSB_RT_E).

All variables to be transferred to the driver that are not stamped by Runtime receive a joint time stamp in the cycle. This ensures that the time corresponds to that of the change. These drivers receive the status Real time internal (T_INTERN/_VSB_RT_I).

Date & Time

The following applies for all date and time information:

  • Times are UTC.
  • All times must be between 02. 01. 1970 and 2038.
  • Dates are converted into a string in the format YYYY/MM/DD.
  • The time is converted into the format HH:MM:SS.


Pleas not for variables in simulation projects

Manual -> Variables -> Driver -> Driver simulation -> Simulation - programmed -> Pleas not for variables in simulation projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following is true for the creation and modification of variables in simulation projects:

  1. zenon Logic

    If variables are created for a simulation project in the zenon Logic Workbench, they do not have a valid addressing for the communication. If the communication is switch to hardware, the communication can be interrupted when the new variables are used in screens without a adjusting the addressing correctly.

  2. Rename

    If a variable is renamed in a simulation project, the name of the variable is also changed in zenon accordingly. So for example you must adjust the names of variables which are used in a VBA project also in the VBA code.

  3. Integrated solutions

    Variables of integrated solutions such as zenon Logic, IEC870 or IEC850 must not be renamed in the simulation project. In this case the variables lose their project information.
    For example: If you rename Project0/Global/NewVar to myNeVariablenwVar in the simulation project, it becomes myNewVar in zenon. After the renaming a communication with the zenon Logic Runtime is impossible.

  4. Communication based on variable names

    Variables of a driver which communicates based on the variable names must not be renamed in the simulation project.

  5. Deleting or importing variables

    If a variable is deleted or imported while online change is activated in zenon Logic, all variables are removed and inserted again in zenon Logic.

  6. Variables with active "embed" symbol

    Variables which exist in a program and whoses "embed" symbol is active are not available via the Shared Memory interface in zenon. If a variable with an active "embed" symbol is moved from the global area to a program, the variable is deleted in zenon.


Error messages

Manual -> Variables -> Driver -> Driver simulation -> Simulation - programmed -> Error messages

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Engineering in the zenon Editor

Error message

Cause and solution

The choosen name is already used for another driver or contains invalid characters! Please choose a different name.

The new name of the simulation project is already used in the project or is not valid.

  • Give it a valid name

The simulation project from the <File name>/<Description> driver has not been compiled and cannot be supported! Please compile the project in Workbench.

A simulation project is available for the driver in Workbench. This was not compiled however.

  • Start the zenon Logic Workbench with this driver's simulation project
  • compile the project

Hint: I does not make a difference if the diver settings are set to simulation - programmed in the driver settings

Write queue full! Write command for <Name Variable> lost!

Displays the loss of a write command.


Change driver

Manual -> Variables -> Driver -> Change driver

Drivers can be changed in zenon. The variables remain accessible and functional after the driver has been changed, provided that they are present in the driver that has been changed. The change of the driver definition is only possible for the released drivers which have been declared as being compatible.

attention Attention

Drivers that are linked to a zenon Logic project using the integrated solution cannot be exchanged.

To change an existing driver:

  1. Select the driver to be changed in the detail view
  2. open the context menu with a right-click
  3. Select the Change driver command
  4. The same dialog dialog for creating a driver is opened
  5. select the new driver

The necessary settings for the driver(s) (interfaces, interrupt address, etc.) are defined when the variables are configured.

Example Example

The address concept for zenon is not available when a project is being created. Only the variables to be used have been defined.

To allow parallel processing of a project, the driver for simulator variables is included as driver. The generation of the screens with dynamic linkages and the on-line test (setpoint input, etc.) can be carried out.

Once the final address concept with the linkage to zenon is available, the driver is changed and can be used under project conditions.

The change of a driver is only possible under the prerequisite that the driver used during the configuring and finally used in the end has the same properties (variable types).


Delete Driver

Manual -> Variables -> Driver -> Delete Driver

To delete drivers:

  1. Select the desired driver (multiple selection is possible).
  2. Select Delete in the context menu or in the tool bar.
  3. The drivers are deleted

    The deletion process must be confirmed with a confirmation request.

Attention: All variables belonging to it are also deleted.


Driver variables

Manual -> Variables -> Driver -> Driver variables

The driver kit implements a number of driver variables. These are divided into:

  • Information
  • Configuration
  • Statistics and
  • Error message

The definitions of the variables defined in the driver kit are available in the import file drvvar.dbf (on the CD in the directory: CD_Drive:/Predefined/Variables) and can be imported from there.

Note: Variable names must be unique in zenon. If driver variables are to be imported from drvvar.dbf again, the variables that were imported beforehand must be renamed.

info Information

Not every driver supports all driver variants.

For example:

  • Variables for modem information are only supported by modem-compatible drivers
  • Driver variables for the polling cycle only for pure polling drivers
  • Connection-related information such as ErrorMSG only for drivers that only edit one connection at a a time

Information

Name from import | Type | Offset | Description
MainVersion | UINT | 0 | Main version number of the driver.
SubVersion | UINT | 1 | Sub version number of the driver.
BuildVersion | UINT | 29 | Build version number of the driver.
RTMajor | UINT | 49 | zenon main version number
RTMinor | UINT | 50 | zenon sub version number
RTSp | UINT | 51 | zenon Service Pack number
RTBuild | UINT | 52 | zenon build number
LineStateIdle | BOOL | 24.0 | TRUE, if the modem connection is idle
LineStateOffering | BOOL | 24.1 | TRUE, if a call is received
LineStateAccepted | BOOL | 24.2 | The call is accepted
LineStateDialtone | BOOL | 24.3 | Dialtone recognized
LineStateDialing | BOOL | 24.4 | Dialing active
LineStateRingBack | BOOL | 24.5 | While establishing the connection
LineStateBusy | BOOL | 24.6 | Target station is busy
LineStateSpecialInfo | BOOL | 24.7 | Special status information received
LineStateConnected | BOOL | 24.8 | Connection established
LineStateProceeding | BOOL | 24.9 | Dialing completed
LineStateOnHold | BOOL | 24.10 | Connection in hold
LineStateConferenced | BOOL | 24.11 | Connection in conference mode.
LineStateOnHoldPendConf | BOOL | 24.12 | Connection in hold for conference
LineStateOnHoldPendTransfer | BOOL | 24.13 | Connection in hold for transfer
LineStateDisconnected | BOOL | 24.14 | Connection terminated.
LineStateUnknow | BOOL | 24.15 | Connection status unknown
ModemStatus | UDINT | 24 | Current modem status
TreiberStop | BOOL | 28 | Driver stopped For driver stop, the variable has the value TRUE and an OFF bit. After the driver has started, the variable has the value FALSE and no OFF bit.
SimulRTState | UDINT | 60 | Informs the status of Runtime for driver simulation.

Configuration

Name from import | Type | Offset | Description
ReconnectInRead | BOOL | 27 | If TRUE, the modem is automatically reconnected for reading
ApplyCom | BOOL | 36 | Apply changes in the settings of the serial interface. Writing to this variable immediately results in the method SrvDrvVarApplyCom being called (which currently has no further function).
ApplyModem | BOOL | 37 | Apply changes in the settings of the modem. Writing this variable immediately calls the method SrvDrvVarApplyModem. This closes the current connection and opens a new one according to the settings PhoneNumberSet and ModemHwAdrSet.
PhoneNumberSet | STRING | 38 | Telephone number, that should be used
ModemHwAdrSet | DINT | 39 | Hardware address for the telephone number
GlobalUpdate | UDINT | 3 | Update time in milliseconds (ms).
BGlobalUpdaten | BOOL | 4 | TRUE, if update time is global
TreiberSimul | BOOL | 5 | TRUE, if driver in sin simulation mode
TreiberProzab | BOOL | 6 | TRUE, if the variables update list should be kept in the memory
ModemActive | BOOL | 7 | TRUE, if the modem is active for the driver
Device | STRING | 8 | Name of the serial interface or name of the modem
ComPort | UINT | 9 | Number of the serial interface.
Baud rate | UDINT | 10 | Baud rate of the serial interface.
Parity | SINT | 11 | Parity of the serial interface
ByteSize | USINT | 14 | Number of bits per character of the serial interface Value = 0 if the driver cannot establish any serial connection.
StopBit | USINT | 13 | Number of stop bits of the serial interface.
Autoconnect | BOOL | 16 | TRUE, if the modem connection should be established automatically for reading/writing
PhoneNumber | STRING | 17 | Current telephone number
ModemHwAdr | DINT | 21 | Hardware address of current telephone number
RxIdleTime | UINT | 18 | Modem is disconnected, if no data transfer occurs for this time in seconds (s)
WriteTimeout | UDINT | 19 | Maximum write duration for a modem connection in milliseconds (ms).
RingCountSet | UDINT | 20 | Number of ringing tones before a call is accepted
ReCallIdleTime | UINT | 53 | Waiting time between calls in seconds (s).
ConnectTimeout | UINT | 54 | Time in seconds (s) to establish a connection.

Statistics

Name from import | Type | Offset | Description
MaxWriteTime | UDINT | 31 | The longest time in milliseconds (ms) that is required for writing.
MinWriteTime | UDINT | 32 | The shortest time in milliseconds (ms) that is required for writing.
MaxBlkReadTime | UDINT | 40 | Longest time in milliseconds (ms) that is required to read a data block.
MinBlkReadTime | UDINT | 41 | Shortest time in milliseconds (ms) that is required to read a data block.
WriteErrorCount | UDINT | 33 | Number of writing errors
ReadSucceedCount | UDINT | 35 | Number of successful reading attempts
MaxCycleTime | UDINT | 22 | Longest time in milliseconds (ms) required to read all requested data.
MinCycleTime | UDINT | 23 | Shortest time in milliseconds (ms) required to read all requested data.
WriteCount | UDINT | 26 | Number of writing attempts
ReadErrorCount | UDINT | 34 | Number of reading errors
MaxUpdateTimeNormal | UDINT | 56 | Time since the last update of the priority group Normal in milliseconds (ms).
MaxUpdateTimeHigher | UDINT | 57 | Time since the last update of the priority group Higher in milliseconds (ms).
MaxUpdateTimeHigh | UDINT | 58 | Time since the last update of the priority group High in milliseconds (ms).
MaxUpdateTimeHighest | UDINT | 59 | Time since the last update of the priority group Highest in milliseconds (ms).
PokeFinish | BOOL | 55 | Goes to 1 for a query, if all current pokes were executed

Error message

Name from import | Type | Offset | Description
ErrorTimeDW | UDINT | 2 | Time (in seconds since 1.1.1970), when the last error occurred.
ErrorTimeS | STRING | 2 | Time (in seconds since 1.1.1970), when the last error occurred.
RdErrPrimObj | UDINT | 42 | Number of the PrimObject, when the last reading error occurred.
RdErrStationsName | STRING | 43 | Name of the station, when the last reading error occurred.
RdErrBlockCount | UINT | 44 | Number of blocks to read when the last reading error occurred.
RdErrHwAdresse | DINT | 45 | Hardware address when the last reading error occurred.
RdErrDatablockNo | UDINT | 46 | Block number when the last reading error occurred.
RdErrMarkerNo | UDINT | 47 | Marker number when the last reading error occurred.
RdErrSize | UDINT | 48 | Block size when the last reading error occurred.
DrvError | USINT | 25 | Error message as number
DrvErrorMsg | STRING | 30 | Error message as text
ErrorFile | STRING | 15 | Name of error log file


Driver documentation

Manual -> Variables -> Driver -> Driver documentation

Please find information on all zenon drivers in the corresponding driver documentation. You can find this in the Driver chapter.

info Information

If you cannot find a driver documentation, you will receive help from support@copadata.com.


Create, modify and use variables

Manual -> Variables -> Create, modify and use variables

Variables can be created:

  • as simple variables
  • in arrays
  • as structure variables

Variable dialog

To create a new variable, regardless of which type:

  1. Select the New variable command in the Variables node in the context menu

  2. The dialog for configuring variables is opened
  3. configure the variable
  4. The settings that are possible depends on the type of variables

Property

Description

Name

Distinct name of the variable. If a variable with the same name already exists in the project, no additional variable can be created with this name.

Maximum length: 128 Zeichen

Attention: The characters # and @ are not permitted in variable names. If non-permitted characters are used, creation of variables cannot be completed and the Finish button remains inactive.
Note: For some drivers, the addressing is possible over the property Symbolic address, as well.

Driver

Select the desired driver from the drop-down list.

Note: If no driver has been opened in the project, the driver for internal variables (Intern.exe) is automatically loaded.

Driver object type

Select the appropriate driver object type from the drop-down list.

Data type

Select the desired data type. Click on the ... button to open the selection dialog.

Array settings

Expanded settings for array variables. You can find details in the Arrays chapter.

Addressing options

Expanded settings for arrays and structure variables. You can find details in the respective section.

Automatic element activation

Expanded settings for arrays and structure variables. You can find details in the respective section.

Inheritance from data type

Measuring range, Signal range and Set value are always:

  • derived from the datatype
  • Automatically adapted if the data type is changed

Note for signal range: If a change is made to a data type that does not support the set signal range, the signal range is amended automatically. For example, for a change from INT to SINT, the signal range is changed to 127. The amendment is also carried out if the signal range was not inherited from the data type. In this case, the measuring range must be adapted manually.


Simple variables

Manual -> Variables -> Create, modify and use variables -> Simple variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Simple variables always consist of a data type and a driver object type. They form the basis for array variables and structure variables.


Creating a simple variable

Manual -> Variables -> Create, modify and use variables -> Simple variables -> Creating a simple variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Project manager right-click on Variable and select "New variable..." in the context menu.

Define name, driver , driver object type and data type in the following dialog.

Property | Description
Name | Distinct name of the variable. If a variable with the same name already exists in the project, no additional variable can be created with the same name.
Driver | Select the desired driver from the drop-down list.
Driver object type | Select the appropriate driver object type from the drop-down list.
Data type | Select the desired data type. Click on the ... button to open the selection dialog.

The newly created variable is displayed in the detail view of the project manager. You can edit additional properties of the variable in its property window.


Changing the properties of a simple variable

Manual -> Variables -> Create, modify and use variables -> Simple variables -> Changing the properties of a simple variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Changes of variable properties are done in the properties window. Select the variable to change in the detail view and enter the desired changes in the properties window.


Modify variable

Manual -> Variables -> Create, modify and use variables -> Simple variables -> Changing the properties of a simple variable -> Modify variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The dialog Modify variable is opened if one ore more variables are selected and one of the following properties is selected:

  1. Data type
  2. Driver
  3. Driver object type
  4. Array settings
    1. Dim 1
    2. Dim 2
    3. Dim 3
    4. Start index
  5. Offset calculation
  6. Data type

Here, settings are changed for all variables which have been selected with multiple selection to make them uniform.

Modification, if several variables have been selected:

If the value of the selected property is the same for all selected variables, it is displayed in the dialog; otherwise the entry stays empty. Empty means, that the setting has not been defined. If a selection has been done, it is no longer possible to make 'no selection'. If this is desired, the dialog has to be closed with Cancel and then reopened (exception: (Exception: checkboxes).

As long as the driver has not been specified, the combobox Driver object type lists all driver object types available for the driver of the selected variable. As soon as a driver is selected, only the driver object types of the specified driver are listed. If a driver from or to a zenon Logic driver is changed, the name of the variable is automatically changed and adopted.
With multiple variables selected, checkboxes can have one of three states: on, off and undefined. Fields that are not defined are not changed at the variable. If a field has been specified, it sets the new value for all selected variables.

Check before the modification:

For each variable before modification it is checked, if the resulting settings are allowed.

Example Example

Example for an invalid modification: An array variable and a simple variable have been selected; the array dimension is changed. Error: A simple variable must not subsequently be changed to an array variable.

For variables that cannot be changed to the new settings, an error message is generated. Before the modification these are listed in the dialog 'Error modifying variable', after the modification in the output window of the Editor.


Error modifying variable

Manual -> Variables -> Create, modify and use variables -> Simple variables -> Changing the properties of a simple variable -> Error modifying variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If a modification for one or more variables is not possible, the dialog Error modifying variable opens. Here the variables that cannot be changed in this way, are listed. It is opened, before the modification is made and only if there are variables that cannot be changed. The entries can be sorted and filtered.

Parameters | Description
Name | Name of the variable, which cannot be changed.
Driver | Name of the driver with the driver identification, on which the variable is based.
Data type | Datatype used by the variable.
Driver object type | Driver object type that the variable uses.
Message | Description of the cause, why the variable cannot be changed.
Cancel | Modifying the variable is stopped. No modifications are made.
Ignore all | All variables, which cannot be changed, are ignored. The variables, which can be changed, are modified. A message for all ignored variables is generated in the output window. The text is the same as in the 'Message'.
Back | Return to modification dialog.
Status line | Number of selected variables and obstacles. The variable is considered non-modifiable once the first obstacle is recognized. Thee can be more obstacles, which then are not analyzed. In complex variables (arrays or structures) also all activated variables are checked, if they can handle the changes. A message is generated for each non-modifiable, activated variable. This means, that the number of obstacles can be higher than the number of selected variables.


Deleting simple variables

Manual -> Variables -> Create, modify and use variables -> Simple variables -> Deleting simple variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the detail view, click on the variable to be deleted with the right mouse button to get the delete option in the following context menu:

Clicking on Delete opens the following security dialog:


Arrays

Manual -> Variables -> Create, modify and use variables -> Arrays

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Arrays are fields of data types or variables. We make a distinction:

  • Data type arrays: Can only be implemented in structures.
  • Variables Arrays: Can also be implemented with simple data types.

Arrays can have up to three dimensions.

Example Example

Example for a two-dimensional array variable:

Engine speed [2.3]
This variable consists of six variables (2x3):

  • Engine Speed [1.1]
  • Engine Speed [1.2]
  • Engine Speed [1.3]
  • Engine Speed [2.1]
  • Engine Speed [2.2]
  • Engine speed [2.3]

Internal arrays are handled like structures. That especially concerns addressing.

attention Attention

Array variables that are based on a stratonNG or straton32 driver must not start with 1. A zenon array with dimensions 1,2,2 is created as a simple variable in zenon Logic.

Inactive variables

Single variables of an array can be set inactive. Inactive variable

  • Not available in zenon
  • Are not registered with the driver
  • Are not taken into account when the I/Os for the license size are calculated

In this way, reserve variables can be created in an array, which can be activated at a later point in time e.g. when expanding.

Size of block array (up to version 5.50)

Up to version 5.50, the size of the block array could be defined using the Block array size property. It is therefore possible to use only one licensed variable, for example, in the RGM or in VBA, but to indirectly address several variables with drivers that use offset addresses. This property remains for compatibility reasons.

Variables with the suffix [0] to [n] are created.
Warning: No other variables with the same name can exist in the project!

Note: The internal driver does not support this property. A value can be defined in the Editor, but no variables are displayed (value is always 0).


Create array variable

Manual -> Variables -> Create, modify and use variables -> Arrays -> Create array variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Simple array variables are created like simple variables.

Property | Description
Name | Distinct name of the variable. If a variable with the same name already exists in the project, no additional variable can be created with this name.
Driver | Select the desired driver from the drop-down list. Note: If no driver has been opened in the project, the driver for internal variables (Intern.exe) is automatically loaded.
Driver object type | Select the appropriate driver object type from the drop-down list.
Data type | Select the desired data type. Click on the ... button to open the selection dialog.
Automatic addressing | zenon calculates an automatic address allocation. This depends on the granularity of the driver object type used and the IEC data type on which the data type used is based.
Offset address follows data type offset and start offset | The offset follows the projected offset and bit for the structure element allocated.
Manual addressing | Manual addressing.
Each datatype starts with new offset | Defines how single array elements are positioned with automatic addressing. Active: a new offset is started for each array. Inactive: Offsets are used in full (variables are addressed in a row).
Activate all elements | On creating the new array variable all elements are automatically activated
Activate element manually | The elements are not activated when created. They have to activated in the variable list individually. This can be done via the context menu of the variable list.


Addressing

Manual -> Variables -> Create, modify and use variables -> Arrays -> Addressing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Arrays are usually addressed automatically. In doing so, the following is given for the array variables:

  • Net address
  • Start offset
  • Data block (optional)
  • Bit number (optional)

Nothing more has to be set for single array elements. The address is calculated automatically.

If arrays are to be addressed manually, the Manual addressing option has to be deactivated, either when creating the array or at a later point in time in the properties window.

The address is calculated again when changes are made to:

  • Data type of an array
  • Driver object type
  • Driver
  • Array dimension


Example for an array with automatic addressing for a INT variable

Manual -> Variables -> Create, modify and use variables -> Arrays -> Addressing -> Example for an array with automatic addressing for a INT variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

We would like to create an array of five integer variables.

Basic configuration

In the variables configuration dialog

  • Name Free issue
  • Driver: S7 TCP/IP
  • Driver object type: Ext. Data blocks
  • Data type: INT
  • Array: Start index is 1
  • Dim 1: 5
  • Dim 2: 0
  • Addressing: Automatic addressing
  • Each data type starts with new offset: active
  • Element activation: Activate all elements

After clicking OK, the five defined variables are created in the variable list. Additionally a corresponding array variable is created in which we can set the array properties.

Detail configuration

When selecting the array variable in the detail view, the properties of the whole array can be edited in the properties window. The most important settings are in the group Addressing. There we set the following for the array:

  • Data block
  • Network address (=bus address)
  • Start offset

As "Automatic addressing" was activated, all the addresses of the single array elements depend on this start offset. In our example, we change the Data block to 50, we leave the network address at 0 and we change the offset to 100.

The granularity of the S7 datablocks is 8 bit. So the datablock area is byte-oriented. Each INT variable needs 16 bits. This results in the following automatic addressing for our array:

Array | Net address | Data block | Offset
Array of INT[1] | 0 | 50 | 100
Array of INT[2] | 0 | 50 | 102
Array of INT[3] | 0 | 50 | 104
Array of INT[4] | 0 | 50 | 106
Array of INT[5] | 0 | 50 | 108

Each offset is two higher than the previous, as a 16 bit variable needs two 8 bit offsets.

Taking a S5 driver instead of the S7 driver changes the addressing. On the S5, the datablock area has a granularity of 16 bits. The datablock area of a S5 PLC is word-oriented. Identical projecting would lead to the following result:

Array | Net address | Data block | Offset
Array of INT[1] | 0 | 50 | 100NT
Array of INT[2] | 0 | 50 | 101
Array of INT[3] | 0 | 50 | 102
Array of INT[4] | 0 | 50 | 103
Array of INT[5] | 0 | 50 | 104

each offset now is only 1 higher than the previous, as a 16 bit variable needs only one 16 bit offset.


Example for an array with automatic addressing for a BOOL variable

Manual -> Variables -> Create, modify and use variables -> Arrays -> Addressing -> Example for an array with automatic addressing for a BOOL variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

We proceed as in the example of automatic addressing with INT data type; however we use the standard data type BOOL as a data type. All other settings stay as described there and we now create a new array variable.

We set the following values in the array variable properties:

Data block: 50

Net address: 0

Offset: 100

Bit number: 0

With an S7 driver, the following screen results with automatic addressing:

Array | Net address | Data block | Offset | Bit number
Array of INT[1] | 0 | 50 | 100 | 0
Array of INT[2] | 0 | 50 | 101 | 0
Array of INT[3] | 0 | 50 | 102 | 0
Array of INT[4] | 0 | 50 | 103 | 0
Array of INT[5] | 0 | 50 | 104 | 0

A 1 bit variable has enough room in a 8 bit offset. Due to the Each data type starts with new offset option being activated, each array element starts a new offset.

If we deactivate this property in the array variable, we get the following addressing:

Array | Net address | Data block | Offset | Bit number
Array of INT[1] | 0 | 50 | 100 | 0
Array of INT[2] | 0 | 50 | 100 | 1
Array of INT[3] | 0 | 50 | 100 | 2
Array of INT[4] | 0 | 50 | 100 | 3
Array of INT[5] | 0 | 50 | 100 | 4

Now the bits are all in one offset. If the offset would not be big enough (e.g. array of 20 BOOL variable), the next bit would be the first of the next offset. An array of 20 BOOL variable would be from offset 100 bit number 0 to offset 102 bit number 3.


Example of an array with manual addressing:

Manual -> Variables -> Create, modify and use variables -> Arrays -> Addressing -> Example of an array with manual addressing:

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For manual addressing, the Manual addressing property must be selected in the variable configuration. Then the address information for each array element can be manually issued for:

  • Net address
  • Offset
  • Data block (optional)
  • Bit number (optional)

This could look as follows for the example of an array with automatic addressing for a BOOL variable:

Array | Net address | Data block | Offset | Bit number
Array of INT[1] | 0 | 50 | 100 | 0
Array of INT[2] | 0 | 50 | 100 | 2
Array of INT[3] | 0 | 50 | 101 | 0
Array of INT[4] | 0 | 50 | 101 | 2
Array of INT[5] | 0 | 50 | 102 | 0

attention Attention

If either the start offset of the array or the size of the array dimension is changed, all address information (offset and bit address) is recalculated.

If the start offset is changed, the offsets of the variables already activated are also changed by the delta of the change. The offset difference between the activated variable and the array variables is thus retained.


Changing the properties of an array

Manual -> Variables -> Create, modify and use variables -> Arrays -> Changing the properties of an array

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The properties are changed using the Properties window and the Modify variable dialog.

Note two special properties in particular:

  • Last used offsetshows which offset (including bit number) was the last used in automatic addressing.
  • Size in bytes: shows how many bytes are used by the selected array.

The following cannot be changed:

  • Name
  • Activating the elements

Property | Description
Driver | Select the desired driver from the drop-down list. Note: If no driver has been opened in the project, the driver for internal variables (Intern.exe) is automatically loaded.
Driver object type | Select the appropriate driver object type from the drop-down list.
Data type | Select the desired data type. Click on the ... button to open the selection dialog.
Automatic addressing | zenon calculates an automatic address allocation. This depends on the granularity of the driver object type used and the IEC data type on which the data type used is based.
Offset address follows data type offset and start offset | The offset follows the projected offset and bit for the structure element allocated.
Manual addressing | Manual or semi-automatic addressing.
Each datatype starts with new offset | Defines how single array elements are positioned with automatic addressing. Active: a new offset is started for each array. Inactive: Offsets are used in full (variables are addressed in a row).

Notes on changing the IEC data type

If the data type of an array is changed, then the following applies:

  • As long as the value of the current signal range is within the signal range of the data type, no amendment is made.
  • The measuring range is not adapted.

    Exception: Signal and measurements ranges are always adapted for the BOOL data type.

For the adaptation of the signal range, the new signal range must be less than the previous one:

  • SingalbereichMin is only adapted if SignalbereichMinNeu <is SignalbereichMinAlt
  • SignalbereichMax is only adapted if SignalbereichMaxNeu < is SignalbereichMinAlt


De/activating array elements

Manual -> Variables -> Create, modify and use variables -> Arrays -> De/activating array elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Each array element can be de/activated individually. Activating is either done on creating the array (activate all elements) or manually via the context menus of the single array elements. Inactive array elements are handled by automatic addressing as though they were active. The inactive elements are place holders, that can be activated at any time.


Structure variables

Manual -> Variables -> Create, modify and use variables -> Structure variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A structure consists of individual elements. These are always data types. On creating a structure element always an existing data type has to be selected. Structure elements can be either embedded or linked.

Parameters | Description
Embedded structure elements | can have properties that differ from their basic datatypes. The properties are defined individually for each structure element and are saved there.
Linked structure elements | Always get all their properties from the basic datatypes that they are linked to. If the basic data type is changed, all linked elements are changed in the same way!

Structure data types

You can find details on creating structure data types in the Data types/Structure data types section.

Structure variables

Structure variables are always based on a structure data type. So as a matter of principle they get the structure of the basic datatype. When creating a structure variable, a number of options can be defined:

Parameters

Description

Arrays

It is possible to select whether the structure is created as a single structure variable or as an array. Up to three dimensions can be defined for a structure array.

Addressing

The structure variable can now be addressed manually or automatically. As a default addressing is defined automatically. The calculation of the addressing thereby depends on the granularity of the driver object type that is used and the structure elements that are used.

With automatic addressing, each data type can be started with a new offset.

Activating elements with structure variables

It can be set, whether all elements of the structure should be activated.

Activating means, that all elements are set active. Active variables can be used in zenon at once. Inactive variables are not available to zenon, are not counted for the licensed I/Os and are not registered in the driver. Therefore reserve areas can be created in a structure, which can be activated at a later point in time. All elements of a structure variable can be activated or deactivated via the context menu at any time.

Note: Deactivated structure variables are also taken into account when addresses are calculated. If this is not desired, the addresses must either be issued manually or the corresponding structure element must be deleted from the data type.

Behavior during XML import

Structures

Structures which differ from existing ones can be imported in already existing structures. Variables based on this are automatically adapted.

  • The structure elements are identified by their name.
  • At already existing structure elements the type is adapted if necessary.
  • Non-existing elements are added.
  • Elements which do not exist in the structure data type are removed.

Inactive variables

At the import of structure variables, active and inactive variables are imported. Existing imports are not overwritten at the import. If an inactive variable is imported to a project and then activated, it stays active even after a new XML import.


Changing structure variables

Manual -> Variables -> Create, modify and use variables -> Structure variables -> Changing structure variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a structure variable:

  1. Create a simple variable
  2. Select a structure data type as the data type
  3. Select the driver and driver object type
  4. Define the array dimensions

Property | Description
Name | Distinct name of the variable. If a variable with the same name already exists in the project, no additional variable can be created with this name.
Driver | Select the desired driver from the drop-down list. Note: If no driver has been opened in the project, the driver for internal variables (Intern.exe) is automatically loaded.
Driver object type | Select the appropriate driver object type from the drop-down list.
Data type | Select the desired data type. Click on the ... button to open the selection dialog.
Automatic addressing | zenon calculates an automatic address allocation. This depends on the granularity of the driver object type used and the IEC data type on which the data type used is based.
Offset address follows data type offset and start offset | The offset follows the projected offset and bit for the structure element allocated.
Manual addressing | Manual or semi-automatic addressing.
Each datatype starts with new offset | Defines how single structure elements are positioned with automatic addressing. Active: a new offset is started for each structure element. A bit offset > 0 increases the offset by 1. Inactive: Offsets are used in full (variables are addressed in a row).
Activate all elements | All elements are automatically activated when the new structure variable is created.
Activate element manually | The elements are not activated when created. They have to activated in the variable list individually. This can be done via the context menu of the variable list.

Datatype organization with automatic addressing

  • A driver BYTE granularity can only use the bit 0 to 7 with BOOL. All other data types start at bit 0.
  • With WORD: BOOL bits 0 to 15, U(S)INT the bits 0 and 8. All other data types start at bit 0.
  • With DWORD: BOOL bits 0 to 31, U(S)INT the bits 0, 8, 16, 24. (U)INT - the bits 0 and 16. All other data types start at bit 0.
  • Strings must always start at bit 0.
    As a result of this: If, with the current address, the > bit offset is 0, the variable is set to bit 0 and offset+1.

Example

USINT = 8 bit, WORD granularity = 16 bit.

The variable can only start with the bits 0 or 8. If, for example 2 is planned as a bit offset and the current address is Offset=0 Bit=0, the variable is set to Offset 0 Bit 8. If the current address were Offset=0 and Bit=7, to Offset=1 Bit=0


Simple structure with automatic addressing

Manual -> Variables -> Create, modify and use variables -> Structure variables -> Changing structure variables -> Simple structure with automatic addressing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Example

The first step is to create a structure data type. To do this, we create a slider structure with four elements:

  • Engine speed set (UINT),
  • Engine speed actual (USINT),
  • Array [2] of
    • on/off (BOOL) and
  • monitoring (SINT).

Then we have to create a structure variable with the Create variable dialog, which is based on this data type. For this example, we use:

  • the S7 TCP/IP driver
  • the Range data block
  • the array dimension 0
  • the activated options
    • Automatic addressing
    • Each datatype starts with new offset
    • Activate all elements

The defined structure with all elements appears in the variable list after confirming the settings with Finish.

When selecting the structure variable "Engine Speed Control" in the detail view, the properties of the whole structure can be edited in the properties window. The most important settings are in the group Addressing. There the datablock, the net address (= bus address) and the start offset can be changed. As Automatic addressing was activated, all the addresses of the single structure elements depend on this start offset.

In our example, we use the settings:

Data block: 50

Offset: 100

Net address: 0

The granularity of the S7 datablocks is 8 bit. So the datablock area is byte-oriented. Each UINT variable needs 16 bits, each USINT variable 8 bits, each BOOL variable 1 bit and each SINT variable 8 bits.

This results in the following automatic addressing for our structure:

Variable | Net address | Data block | Offset | Bit number
Engine Speed Control.Engine Speed Set | 0 | 50 | 100 | 0
Engine Speed Control.Engine Speed Actual | 0 | 50 | 102 | 0
Engine Speed Control.Engine Speed.On/Off[1] | 0 | 50 | 104 | 0
Engine Speed Control.Engine Speed.On/Off[2] | 0 | 50 | 105 | 1
Engine Speed Control.Engine Speed.Monitoring | 0 | 50 | 106 | 0

"Last used offset": 106 bit 7

The individual elements of the structure variable are thus optimally fit into the offsets.

The 8 bit variable "Engine Speed Control.Engine Speed.Set" uses one offset, the 16 bit variable "Engine Speed Control.Engine Speed.Actual" uses two offsets, the two BOOL variable use two bit in one offset and the variable "Engine Speed Control.Engine Speed.Monitoring" uses one offset.

The addresses can be changed in the structure data type or in the address settings of the structure variable, but not in the single structure variable elements. That would only be possible with manual addressing.

Taking a S5 driver instead of the S7 driver changes the addressing. On the S5, the datablock area has a granularity of 16 bits. The datablock area of a S5 PLC is word-oriented.

Identical projecting would lead to the following result:

Variable | Net address | Data block | Offset | Bit number
Engine Speed Control.Engine Speed Set | 0 | 50 | 100 | 0
Engine Speed Control.Engine Speed Actual | 0 | 50 | 101 | 0
Engine Speed Control.Engine Speed.On/Off[1] | 0 | 50 | 102 | 0
Engine Speed Control.Engine Speed.On/Off[2] | 0 | 50 | 102 | 1
Engine Speed Control.Engine Speed.Monitoring | 0 | 50 | 102 | 8

"Last used offset": 102 bit 15

The individual elements of the structure variable are again optimally adapted to the offsets here.

The 8 bit "Engine Speed Control.Engine Speed.Set" variable uses half an offset (bits 0 to 7), the 16 bit variable "Engine Speed Control.Engine Speed.Actual" uses one offset. The two BOOL variables only use the first two bits of the offset 102 and so the variable "Engine Speed Control.Engine Speed.Monitoring" starts in the same offset with bit number 8.


Structure variable as an array with automatic addressing

Manual -> Variables -> Create, modify and use variables -> Structure variables -> Changing structure variables -> Structure variable as an array with automatic addressing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Array with a structure element with simple data type

Variables are addressed in packed form, based on the offset with the structure element, according to IEC data type and granularity. There is thus no difference to "packed" addressing.

Structure variable as an array

The address of the first structure element of the index n is derived from the address of the last structure element at the index n-1 plus the offset at the structure element.

If the Each data type starts with new offset property is

  • active: The index always starts at a whole offset (bit is 0, maybe shifted by the offset at the structure element).
  • inactive: is "packed" according to data type and granularity and shifted by the offset of the structure element. Regardless of this, the variable is set up according to data type and granularity.

Example

We use the same example as in the Simple structure with automatic addressing, however we change the array dimension 1 from 0 to 2 in the structure variable properties.

After clicking on Finish, the variable list looks as follows:

The existing structure was changed to the effect that now each structure element is available twice.

For our example with the S7 driver, this results in the following automatic addressing, provided that we activated: Each data type starts with new offset:

Variable | Net address | Data block | Offset | Bit number
Engine Speed Control[1].Engine Speed.Set | 0 | 50 | 100 | 0
Engine Speed Control[1].Engine Speed.Actual | 0 | 50 | 101 | 0
Engine Speed Control[1].Engine Speed.Ein/Aus[1] | 0 | 50 | 103 | 0
Engine Speed Control[1].Engine Speed.Ein/Aus[2] | 0 | 50 | 103 | 1
Engine Speed Control[1].Engine Speed.Monitoring | 0 | 50 | 104 | 0
Engine Speed Control[2].Engine Speed.Set | 0 | 50 | 105 | 0
Engine Speed Control[2].Engine Speed.Actual | 0 | 50 | 106 | 0
Engine Speed Control[2].Engine Speed.Ein/Aus[2] | 0 | 50 | 108 | 0
Engine Speed Control[2].Engine Speed.Ein/Aus[2] | 0 | 50 | 108 | 1
Engine Speed Control[2].Engine Speed.Monitoring | 0 | 50 | 109 | 0

"Last used offset": 109 bit 7

The array structure was created exactly like a simple structure. The second structure array starts exactly, where the first ends.

Changing the driver to S5 results in the following:

Variable | Net address | Data block | Offset | Bit number
Engine Speed Control[1].Engine Speed.Set | 0 | 50 | 100 | 0
Engine Speed Control[1].Engine Speed.Actual | 0 | 50 | 101 | 0
Engine Speed Control[1].Engine Speed.Ein/Aus[1] | 0 | 50 | 102 | 0
Engine Speed Control[1].Engine Speed.Ein/Aus[2] | 0 | 50 | 102 | 1
Engine Speed Control[1].Engine Speed.Monitoring | 0 | 50 | 102 | 8
Engine Speed Control[2].Engine Speed.Set | 0 | 50 | 103 | 0
Engine Speed Control[2].Engine Speed.Actual | 0 | 50 | 104 | 0
Engine Speed Control[2].Engine Speed.Ein/Aus[2] | 0 | 50 | 105 | 0
Engine Speed Control[2].Engine Speed.Ein/Aus[2] | 0 | 50 | 105 | 1
Engine Speed Control[2].Engine Speed.Monitoring | 0 | 50 | 105 | 7

"Last used offset": 105 bit 15

Each datatype starts with new offset

The array structure was created exactly like a simple structure. The second structure array starts exactly, where the first ends. Here, differences are possible, depending on the Each data type starts with new offset option: If this option is activated, the next structure array always starts at a new offset, even if the next structure would fit into the current offset.

Example Example

The last structure element is a SINT (8 bits) and uses offset 102 bits 0 to 7. For the example of the S5 driver (16 bit offsets) the next structure would start as shown below:

  • Option "Each data type starts with new offset" activated: Offset 103 bit 0
  • Option "Each data type starts with new offset" deactivated: Offset 102 bit 8. The structures are now directly after one another.


Manual addressing

Manual -> Variables -> Create, modify and use variables -> Structure variables -> Changing structure variables -> Manual addressing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Addresses can be issued semi-automatically or completely manually with manual addressing.

Semi-automatic solution

The offsets and the bit numbers are defined in the structure elements in the data type. But there only a relative offset is defined. In the structure variable, a start offset is defined and all relative offsets are added to this start offset.

Example

As in Simple structure with automatic addressing, we create the structure slider structure data type. A desired offset is then set for the individual structure elements, for example offset 3 for the Engine speed set structure element.

For structure variables, the automatic addressing option is activated when it is created. A start offset of 100 is defined in the properties of the structure variable. zenon then calculates, at the address of the "Drehzahl-Regelung.Drehzahl.Soll" variable, the offset 103 (100 from the structure + 3 of the structure element).

If the relative offset is to be subsequently changed, the following steps have to be carried out:

  • First the offset in the structure element in the data type has to be changed.
  • Then the start offset must be changed for the structure variable (for example to 101).
  • And then back to the initial offset (100 in our example).

Background: The new address calculation is only done, when the start offset in the structure variable is changed, and not if only the offset in a structure element is changed.

Fully manual solution

Basically the projecting is the same as for the semi-automatic solution with the exception, that in the structure variable the addresses are entered by hand for each element.

If the start-offset of a structure variable is changed, the offsets of the variables already activated are also changed by the delta of the change. The offset difference between the activated variable and the array variables is thus retained.


Changing structure variables

Manual -> Variables -> Create, modify and use variables -> Structure variables -> Changing structure variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Changes are made via the Properties and Variable dialogs.

The following cannot be changed:

  • Name
  • Activating the elements

Property | Description
Driver | Select the desired driver from the drop-down list. Note: If no driver has been opened in the project, the driver for internal variables (Intern.exe) is automatically loaded.
Driver object type | Select the appropriate driver object type from the drop-down list.
Data type | Select the desired data type. Click on the ... button to open the selection dialog.
Automatic addressing | zenon calculates an automatic address allocation. This depends on the granularity of the driver object type used and the IEC data type on which the data type used is based.
Offset address follows data type offset and start offset | The offset follows the projected offset and bit for the structure element allocated.
Manual addressing | Manual or semi-automatic addressing.
Each datatype starts with new offset | Defines how single structure elements are positioned with automatic addressing. Active: a new offset is started for each structure element. Inactive: Offsets are used in full (variables are addressed in a row).


Changing the properties

Manual -> Variables -> Create, modify and use variables -> Structure variables -> Changing structure variables -> Changing the properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Changes are made in the properties window.

Note that changes in the structure variable can affect the single elements of the structure variable (e.g. address calculation when you change the start offset or the driver). The properties of each element of the structure variable can be changed individually. Changes can either be made in the single elements or in the structure elements of the basic structure data type. The changes then are inherited. (See the Inheritance concept chapter in relation to this)


De/activating structure elements

Manual -> Variables -> Create, modify and use variables -> Structure variables -> Changing structure variables -> De/activating structure elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The element has to be selected and then the appropriate command from the context menu is executed. Inactive array elements are treated as though they were active by the automatic addressing. The inactive elements are place holders, that can be activated at any time.

Inactive variable

  • Not available in zenon
  • Are not registered with the driver
  • Are not taken into account when the I/Os for the license size are calculated

Important notes

Note when deactivating variables:

  • Variable references in screen elements are lost in deactivation. These connections can only be restored manually.
  • If a structure element is based on an IEC data type that is not permitted with the selected driver, then this element cannot be activated.
  • If variables are deactivated and then again activated, the dynamic elements for these variables are not updated in the Editor. In order to update them, click on the corresponding variable in the property window of the element.


Changing the sequence

Manual -> Variables -> Create, modify and use variables -> Structure variables -> Changing structure variables -> Changing the sequence

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The sequence of the structure elements of a structure variable can only be changed in the corresponding structure data type. When changing the structure data type all structure variables based on it are also changed!


Deleting structure variables

Manual -> Variables -> Create, modify and use variables -> Structure variables -> Deleting structure variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Highlight the variable in the detail view and press the Delete key.


Project overlapping variables

Manual -> Variables -> Create, modify and use variables -> Project overlapping variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Variables can also be selected from other projects and used throughout the project. This is also possible in different hierarchies. Variables from superordinate projects, projects at the same level and subordinate projects, but also variables from unconnected projects can be used as desired.

To use variables throughout a project, all projects concerned must, in Runtime:

  • Be loaded
  • Contactable in the network zenon does not check the contactability in the network in Runtime.

In the project, the variables that come from other projects are displayed with the following wording:
[Project name]#[Variable name], for example Project1#WIZ_VAR_10

If cross-project use is not possible, projects in the variable selection dialog are displayed as grayed out.

If project names are subsequently changed or projects are copied, the correct assignment must be ensured. For this use the dialog for replacing project references.

attention Attention

Note the special conditions for cross-project variables in the command processing.


Use in zenon Analyzer

Manual -> Variables -> Create, modify and use variables -> Use in zenon Analyzer

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Variables can be provided with specific reports information for the use in COPA-DATA product zenon Analyzer. There is a group of properties therefor.

The following properties in the zenon Analyzer variable properties group provide information for reports in the zenon Analyzer:

  • Visual name: Entry of a display name of the variable in zenon Analyzer. This must be unique in the project. The check is not carried out when issued in zenon, but when imported into zenon Analyzer. If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.
  • Meaning: Entry of the (Meaning) of a variable in the zenon Analyzer. Entry is manual or by means of the Meaning and Waterfall Chart Wizard. Several meanings are separated by a comma.
    Syntax:[Meaning1],[Meaning2],…,[MeaningN]
  • Parameter for waterfall diagram: Parameters of a variable for a waterfall diagram in zenon Analyzer. Entry is manual or by means of the Meaning and Waterfall Chart Wizard. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
    Syntax: [model name],[row index],[index in row],[color code];

The data takeover from zenon into zenon Analyzer is possible by an export with the Analyzer Export Wizard.


Inheritance concept

Manual -> Variables -> Inheritance concept

Inheritance means that the properties of an object are passed on to an object based on the first one. The inherited object in principle gets all properties from the basic object, but single properties or even all can be changed = overwritten.

In contrast there is also the possibility of linking. Here again the new object gets all the properties from the basic object, but they cannot be changed/overwritten in the basic object. Changes are only possible in the basic object.

For both cases the following is true: If a property is changed in the base object, all objects that are derived from this base object also accept the change. The individual objects are not saved with the derived object directly, but are always referenced by the base object.

Exception: As soon as a value for a derived object is overwritten (changed), this property loses the reference to the base object (only for the inheritance). If such an overwritten property is changed in the basic object, these changed no longer effect the inherited object. However this only concerns the property that was interrupted in the connection to the base object. All other properties are applied by the basic object as before. An overwritten property can be turned back into a derived property at any time.


Inheritance in zenon

Manual -> Variables -> Inheritance concept -> Inheritance in zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In zenon the base objects are the data types. Both simple and structure data types link their properties to the variables based on them.

The variables are the objects based on the data types. In principle, they inherit all their properties. Exceptions are properties which

Can be only set at the variable, e.g. the addressing that is based on the driver object type and not the data type.

In the structures there are the structure elements. These can be either embedded or linked. If they are linked, they get all the properties from the data type that they are linked to. All changes in the basic data type are directly passed on. But no properties can be overwritten, as they only are linked and not inherited.

The embedded structure elements of a structure data type in principle do not have a reference to their basic data type at all. They are copies, where all properties can be changed individually. Changes in the basic data type do not effect them. Embedded structure elements can at any time be changed back to linked structure elements and vice versa.


Inheriting properties with structure datatypes and structure variables

Manual -> Variables -> Inheritance concept -> Inheritance in zenon -> Inheriting properties with structure datatypes and structure variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Structure variables are handled in the same way as simple variables. But the properties have to be set for every single structure element. Each element of a structure variable is linked to a structure element of the structure data type it is based on.

Additionally a structure element again can be linked to a data type.

So the structure variable element inherits the properties from the structure element, which again can be linked to a data type.

It becomes even more complex, if structures are used in structures:

Variable with structure in structure

In the example the variable is Motor.Drehzahl Regelung. Drezahl is deduced from the structure Motor. This again contains the structure element Speed Control, which again is a structure. This structure is linked to the Engine structure, as structures in structures can only be linked. In this structure, Speed Control is linked to the data type INT.

So if there are changes in this data type, these changes directly affect the variables Engine.Speed Control. Engine.Speed Actual.

So be careful with changes in data types.

Overwriting properties or restoring the inheritance from the data type are done as described above.


Inheriting properties of a datatype with simple variables

Manual -> Variables -> Inheritance concept -> Inheriting properties of a datatype with simple variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

All properties are inherited from a data type when a new variable is created. This is marked with a checkmark in the property.

Inherited properties are marked with a checkmark

In this example all properties are inherited from the data type except "Unit". This property was overwritten in the variable. If the unit of measurement property is changed in the basic data type, the unit of measurement property is changed for all variables based on this data type. But not in variable, where this property was overwritten (changed).

attention Attention

Please be aware, that changes to the data type always change all variables based on that data type (except properties that were overwritten accordingly).


Overwriting properties

Manual -> Variables -> Inheritance concept -> Inheriting properties of a datatype with simple variables -> Overwriting properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Properties of variables can be overwritten in two ways:

  • The property is changed using keyboard or mouse input. As soon as the change is applied, this connection's property is separated from the data type.
  • The property is separated from the data type using the corresponding context menu. In doing so, either the selected property can be selected from the data type or all properties of the variable. (screenshot!)

the tick disappears as soon as a property is overwritten. All changes to a data type then no longer have an effect on these overwritten properties of a variable.


Restoring the properties of a datatype

Manual -> Variables -> Inheritance concept -> Inheriting properties of a datatype with simple variables -> Restoring the properties of a datatype

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Select the overwritten property and in the context menu execute Link all properties with datatype or only Link<Name>with datatype. This property or all properties again are marked with the checkmark.


Value calculation

Manual -> Variables -> Value calculation

The value calculation defines the value range of a variable using different properties.

Fluctuating values can be picked up using different properties, in order to prevent unwanted reactions such as alarms or archive entries. In doing so, a distinction is made between:

  • Hysteresis: Prevents the transfer of fluctuating values from the driver to variables.
  • Prevents the creation of archive entries for fluctuating values in relation to the measuring range.
  • Threshold value: Prevents unwanted reactions such as alarms for fluctuating numerical values.


Hysteresis

Manual -> Variables -> Value calculation -> Hysteresis

Hysteresis defines the area within which a value change is ignored. This avoid fluctuating values that would constantly trigger limit breaches being displayed in a screen element.

In <CD_ PRODUCTNAME>, hysteresis can be stipulated in the properties of the variables (Value calculation/Hysteresis) for:

  • Value calculations of the variables: Positive for signal properties and Negative for signal for signal range

    Values that change that are within hysteresis are not transferred to variables from the driver.

  • Entries in the archive in the event of a value change: Positive for archive und Negative for archive properties for measuring range

    Changed values that are within the hysteresis are not entered into the archive.

Example Example

A limit value of 50° C is defined. The temperature normally fluctuates somewhat. Therefore the limit is breached each time the 50° limit is exceeded or gone under, which triggers an alarm and an entry in the archive.

To prevent this, the following is defined as hysteresis for the variable:

  • Positive for signal: 2
  • Negative for signal: 2

And for the archive as hysteresis:

  • Positive for archive: 8
  • Negative for archive: 6

Thus:

  • Only exceeding 52° and going below 48° is considered a limit breach
  • Only once 58° is exceeded or 44° is gone below is an archive entry created

Note: Hysteresis that is to avoid unwanted reactions (such as alarms) to limit breaches due to fluctuating values can be created using threshold values.

info Information

Note:

  • Not every driver supports hysteresis. You can find information on whether your driver supports hysteresis in the documentation for the corresponding driver.
  • Integration project: If hysteresis is configured for a variable in a subproject, this has no effect if the variable is in an archive of the integration project.


Limits

Manual -> Variables -> Limits

Limits have the task to trigger a reaction, as soon as a limit or a status is violated or reached. The limit is entered in the Editor and fixed or is set variably depending on the value of a variable in the Runtime. The kinds of reaction can be manifold. For example: Color changes, entries in alarm and chronologic event list, function calls etc. are possible. The execution of the reaction is carried out in zenon.

The engineering of

  • limits defines the behavior of numerical variables.
  • Status defines the behavior for binary variables (low, high or logical 0, 1).

    Note: For reasons of universal validity, the term "limit" also is used for "status" hereafter.

If an additional evaluation of the variable's status information is needed, this has to be carried out using a reaction matrix. Reaction matrices can also be used for string values. More information on reaction matrices can be found in the chapter Reaction matrix.

Use with EPLAN

With an alarm, an EPLAN document can also be called up. To do this, the EPLAN connection must be licensed and the path to the EPLAN program must be defined in the zenon6.ini file.
Configuration:

  • Input of the character sequence $PRG:xxxxxx in the Help file property in the Limits group

    Note: xxxxxx is the placeholder for the parameters to be given

  • The Help chapter property is ignored, but must not be empty

For details, see the Calling up EPLAN from the help chapter in the Runtime help manual.


Defining limits in the Editor

Manual -> Variables -> Limits -> Defining limits in the Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Selecting a variable in the detail view of the Project Manager shows all the properties of the selected variable in the properties window.

To create a new limit, click New limit. Each time you click on Insert limits, a new limit (Limit 1, Limit 2, …) is added to the list.

All available properties for defining limits are listed in the properties window and are described in the properties help. The context sensitive help is automatically displayed when selecting a property.

Any number of limits can be defined per variable.

Clicking on the plus in front of the property Limit opens the list. All defined limits are listed in this group. Now a limit can be selected to open the properties of this limit.


Delay

Manual -> Variables -> Limits -> Defining limits in the Editor -> Delay

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Delay time [s] property can be used to configure a value for a time delay in the properties for the limit. This value defined the time range in seconds in which the limit breach must occur in order for the action defined for the limit breach to be carried out.
Default value: 0 - no delay

Maximum value: 4294967295 seconds

The delay time applies regardless of which way the limit as breached.

Example:

  • Engineering
    • Limit value 1 has a value of 50.
    • Limit value 2 has a value of 100.
    • The delay time is 3 s.
  1. The value increases to 110.
    • After the breach has occurred for 3 seconds, the limit breach for the value 100 is displayed.
  2. The value decreases to 70.
    • Once this value has lasted for 3 seconds, the alarm for the limit breach 100 is deactivated and a limit breach for the value 50 is displayed.
  3. If the value goes below 40, the alarm is deactivated after 3 seconds.

Time stamp and value

The time of the first violation is entered as the time stamp for the limit violation in the AML and the CEL.
The first value after the delay time is entered as value, not the value that triggers the alarm.

Key:

Digit

Description

1

Time of limit breach.

Start of the configured delay time.

Value to be triggered.

2

End of the configured delay time. Alarm received:

  • Time: Time of limit violation (1)
  • Value displayed: Value after the delay time (2)

attention Attention

In combination with the Flashing property, this property has the following effect in the network:

  • Limit value with flashing and without delay:
    Linked elements will flash on the server and on the clients.
  • Limit value with flashing and delay:
    Linked elements will only flash on the server, not on the clients.
  • Alarm with flashing and without delay:
    Linked elements will flash on the server and on the clients.
  • Alarm with flashing and delay:
    Linked elements will flash on the server and on the clients.


Threshold

Manual -> Variables -> Limits -> Defining limits in the Editor -> Threshold

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Thresholds prevent unwanted reactions to fluctuating numerical values. They create a limit hysteresis. The limit is therefore a different one for the start of the limit breach than the end of the limit breach.

For example: Limit max. at 100, threshold value 10. As soon as the value of the variable reaches 100, the limit is violated. If the values goes down to 95, nothing happens. Only once the value goes down to 89 does the limit violation end.

Thresholds can be set for maximum or minimum. For maximum, the threshold moves downwards, and upwards for minimum.
for example maximum value a maximum value of 900 and a threshold of 10 result in 890
The limit will be violated when exceeding 900 and the critical area will be left when falling under 890.
Example minimum value: a minimum value of 900 and a threshold of 10 result in 910
The limit will be violated when falling below 900 and the critical area will be left when exceeding 910.
As opposed to the hysteresis, this property will only affect the alarm behavior and not the representation of the value.


Deduce limits from datatypes

Manual -> Variables -> Limits -> Defining limits in the Editor -> Deduce limits from datatypes

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Limits can already be defined in the datatype. The limits engineered there are available in all variables based on that data type. The inheritance concept works here as described above: all properties are inherited from the datatype and can be overwritten in each single variable. So a limit also can be deactivated in a single variable. A limit inherited from the datatype cannot be deleted in a single variable (deleting is only possible in the datatype). But further limits can be added in the variable. These variable-specific limits of course can be deleted in the variable.

More information on reaction matrices can be found in the chapter Datatypes.


Multiple selection

Manual -> Variables -> Limits -> Defining limits in the Editor -> Multiple selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If several variables are selected, the properties of all these variables can be edited at the same time. If one of the selected variables does not have the limit to be edited, it will not be added there.

With this multi-selection properties, that differ from variable to variable, are displayed in red in the properties window. (The property of the first selected variable is displayed). If properties do not exist for all the selected variables (e.g. limits), they are marked in yellow.


Deleting limits

Manual -> Variables -> Limits -> Defining limits in the Editor -> Deleting limits

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Click “delete limit” in the properties.


Overlapping limits

Manual -> Variables -> Limits -> Defining limits in the Editor -> Overlapping limits

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Analog limits can be defined overlapping. In this case zenon automatically checks which limit is valid.

Example Example

Limit 1 (maximum) is defined 100. Limit 2 (maximum) is defined 200. If the variable in the Runtime gets a value between 100 and 199, limit 1 is violated. If the value is higher than 200, limit 2 is violated.


Limit preview

Manual -> Variables -> Limits -> Defining limits in the Editor -> Limit preview

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The limit values defined for the variable can be displayed in a dialog for

  • Variables: for the limit values
    Note: No reaction matrix can be linked.
  • Screen elements that refer to limit values, colors, glow, flashing or visibility of variables: for the respective properties

Display limit value preview

In order to display the limit value preview, open the dialog by means of the respective property:

Element | Property group | Property
Screen elements | Flashing | Display blinking preview
Screen elements | Colors static | Limit preview
Screen elements | Colors dynamic | Display color preview for Text/line color Display color preview for Fill color Display color preview for Gradient color
Screen elements | Glow (only DirectX) | Display color preview for Variable for color Display visibility preview for Variable for visibility Display blinking preview for Variable for flashing
Screen elements | Visibility | Display visibility preview
Variables | Limits | Limit preview

Limit value preview dialog

Parameters

Description

Limit preview

Display of the defined limit value with the following properties:

  • Minimum/Maximum
  • Limit text
  • Limit color
  • Flashing
  • Invisible
  • Limit

OK

Closes the dialog.

Cancel

Closes the dialog.

Help

Opens online help.


Limits in the Runtime

Manual -> Variables -> Limits -> Limits in the Runtime

For binary variables zenon reacts on reaching the status (positive edge). For numerical variables the control system reacts on reaching or violating the defined maximum (equal or bigger) and reaching or violating the defined minimum (equal or smaller). This is called a limit violation.

info Information

A binary variable has two limits, a Min limit and a Max limit. Care that: Enter the Min limit as limit 1, and the Max limit as limit 2.

At the calculation of limits of numerical variables, the raw value of the variable (signal resolution) for the use in zenon is always calculated in a linear way unless it is defined differently with function 'non linear value adjustment".

Example: A temperature sensor sends its value to the control. The corresponding byte variable has a signal resolution of 0...255. In zenon the corresponding variable has a measuring range from 0..100. Hence:

Control | Control system
0 | 0
127 | 50
255 | 100

If a limit is violated, when zenon is started, the reaction is executed immediately on starting the Runtime.

Exception: If the reaction should be an entry in the alarm or CEL list, the system first checks whether the entry already exists from the previous session. If this is true, the entry is not done again! So double entries are avoided. All other reactions are nevertheless executed.

attention Attention

Only one limit of a variable can be active at a time.

More information on the conversion of the signal range to the measuring range can be found in the properties help section of the properties window if you select the "Value" property.


End of a limit violation

Manual -> Variables -> Limits -> Limits in the Runtime -> End of a limit violation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If a limit is violated, a value change within the limit range does not lead to a new reaction.

For example: A limit range of 100-200 is configured. If the value changes from 110 to 115, there is no further reaction. If the value changes to 210, there is a reaction again because of the next limit.

Unwanted reactions for fluctuating numerical values can be avoided by using thresholds.


Dynamic limit text

Manual -> Variables -> Limits -> Dynamic limit text

The dynamic limit text allows it to include the current values of other variables in the limit text of a variable or a Reaction matrices (Rema). At that a fixed text can be linked via an index with key words generated from a language table (see also Using key words in text lists ). In the Runtime this limit text can be displayed in the Alarm Message List, Chronologic Event List and/or the alarm status bar. The dynamic limit value text is not displayed in the Dynamic text dynamic element and in the Status element dynamic element.

Syntax

The following nomenclature is valid for the parameterization of the limit texts:

Parameters | Description
$ | Denotes a dynamic limit text; this character must be on the first position in the limit text.
; | Separator of commands. Is used in order to separate the constant text from the dynamic text. When separating variables, no space must be left between the separator and the variable.
@Text | Text from the currently loaded language table
%PV | Value of another variable with the name „PV“
@Text+%PV | Composed keyword for the text from the currently loaded language table. Here the value of variable 'PV' is saved and when being displayed a text is searched in the language table which is a combination of 'text' and variable value.

This text encoding works only for the Alarm Message List or the Chronological Event List. This coding does not work in text elements. The using of combined keywords makes it possible to create dynamic limit texts which can have more than 80 characters.

Example Example 1

Limit text = $@Text; X-Pos ;%Value1; Y-Pos ;%Value2

The following preconditions are valid:

  • @Text is a key word in the language table corresponding to „Text from table“
  • Value1 is an integer variable with the value 14
  • Value2 is an integer variable with the value 12

Output = Text from table X-Pos 14 Y-Pos 12

Example Example 2

$OFF in position ;%String1

The following preconditions are valid:

  • %String1 is a string variable with the content „ORT“

Output = OUT in position ORT

Example Example 3

$%@message_+value1
The following prerequisites apply:

  • @message_ is a part of a keyword in the language table
  • Value1 is an integer variable with the value 12

With the combined keyword, the result is the keyword „message_12“ and the corresponding text from the language table

Example Example 4

$%@message_+String1
The following prerequisites apply:

  • @message_ is a part of a keyword in the language table
  • String1 is a string variable with the content „zenon“.

With the combined keyword, the result is the keyword „message_zenon“ and the corresponding text from the language table

Limits for dynamic limit texts

The storage of dynamic limit texts leads to a number of limits:

  1. Static text is stored in the storage area of the limit text:
    maximal 1024 characters
  2. Values of the linked variables are stored in the storage area of the commentary text:
    Maximum 80 characters.
  3. If dynamic limit texts are used, no commentaries can be used for these alarms.

This limits can be evaded:

Getting around the limitation by means of long dynamic limit value texts

Variable values for dynamic limit texts can be evacuated in an own file.

Requirements: In the project properties in group Alarm Message List the property Long dynamic limit texts AML or in group Chronological Event List the property Long dynamic limit texts CEL is active.
Instead of the commentary field the values are stored in an own file.

1032 bytes are available per limit value in principle. Of this, a certain number of bytes is deducted for each linked variable in the limit value text. The amount deducted depends on the data type. Therefore when several linked variables are used in the dynamic limit value text, there are also correspondingly less characters available.

Example 1: Dynamic limit with a string variable:
Of the 1032 byte:

  • 9 bytes are used for structural information
  • 1023 bytes remain for the content of the string variable

Example 2: Dynamic limit with two string variables:
Of the 1032 byte

  • 18 (2 x 9) bytes are used for structural information
  • 1014 bytes remain for the content of both string variables

Note:

  • There is no limitation to the permitted number of variables per limit value text.
  • The number of bytes needed for the structure information depends on the data type.
  • The file names for the additional created files are Dxxx.aml or Dxxx.cel.
  • For the ring buffer the additional information is saved in aml.bin und cel.bin.

Error texts during Runtime:

Parameters | Description
XXX | The value of a linked variable has changed.
--- | values of linked variables are not available (can happen at program start).
>>> | Maximum number of characters for the dynamic limit value text has been exceeded.


Dynamic key words in limit texts

Manual -> Variables -> Limits -> Dynamic limit text -> Dynamic key words in limit texts

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Alarm messages from Boolean variables do not provide the reason why an alarm was triggered when dealing with collective messages. The cause can be transferred using an index variable, so that the limit text prints out the cause for the alarm anyway. The correct text is found and displayed using the dynamic limit text (see Language switching chapter). For this, no fixed word can be used as a key word, but instead a dynamic one. This is comprised of prefix+value of index variable: %@errornr+mIndex

It is possible to use multi-dimensional key words (several indices).
For example: fixed text; @Motorfehler%meinIndex1-%meinIndex2 becomes, for example @Motorfehler4-67 in Runtime. This key word is then searched for in the language table and the respective text is displayed.

Examples

Example 1

$@error in module: ;%moduleNr;@error type: ;%@errornr+mIndex;

Description:

$ defines a dynamic limit value text.

@error in module: a normal key word from the language table

%moduleNr: Is replaced by the value of the ModuleNr value in Runtime (Functionality of the dynamic limit text)

@error type: a normal key word from the language table

@errornr: The first part of the dynamic key word

+mIndex: Is replaced in Runtime by the value of the mIndex variable and supplements the keyword @errornr

Result:

Value of mIndex | Keyword
1 | @errornr1
2 | @errornr2

Example 2: Strings

$%@Message_+Internal_UINT_001;/;%@Reason_+Internal_STRING_004

If Index_UINT_001 has the value 4 and Index_STRING_004 has the value 'Fire', then the texts Message_4 and Cause_of_fire are searched for in the language table and displayed in the AML/CEL.


Reaction matrices

Manual -> Variables -> Reaction matrices

info Information

Limit information can be defined centrally in a reaction matrix (abbr. rema).
When for example for a number of filling levels the same filling level control is carried out, it can be defined in a single reaction matrix. This makes it possible to change for example the value of the lower limit at a central point.

Advantages with respect to limits:

  • Reaction matrices can be used multiple times. A reaction matrix can be linked to several variables that even can be based on different data types.
  • Reaction matrices can handle each value change of a numeric variable as a new limit violation. This is not possible in limits.
  • With reaction matrixes, a status such as invalid, for example, (see status processing) can be requested. This is also not possible with limit values.

More information on limits can be found in the chapter Limits.


Creating a reaction matrix

Manual -> Variables -> Reaction matrices -> Creating a reaction matrix

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Select "Reaction matrix" in the Project Manager and open the context menu with the right mouse button. Select New reaction matrix there.

In the dialog box that appears, enter the name and type of reaction matrix. Note that this assignment cannot be changed later. However the name can be changed later.

The individual types of reaction matrix are used for the following evaluations:

Parameters | Description
Binary | Evaluation of discrete states (bit-oriented)
Numerical | Evaluation of analog states (value-oriented)
Multi binary | Extended evaluation of 32 bit variables; the first 16 bits determine the value of the variable and are passed on as numeric value; rerouting of status bits; special function (switch-off of data points when status bit is set) (Protective data configuring - only SAT-specific)
Multi numeric | Extended evaluation with simultaneous status routing and special function (switch-off of data points when status bit is set)
String | collation


Editing a reaction matrix

Manual -> Variables -> Reaction matrices -> Editing a reaction matrix

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to edit a reaction matrix:

  • select the reaction matrix from the detail view
  • select the desired command from the context menu

Context menu detail view reaction matrix

Parameters | Description
New reaction matrix | Creates a new reaction matrix.
Configuration | Opens the dialog for configuring the reaction matrix.
Copy | Copy selected reaction matrix.
Paste | Paste copied or cut reaction matrix.
Delete | Delete selected reaction matrix.
Export selected XML | Exports selected reaction matrices as an XML file.
All filters removed. | Removes all filter settings.
Edit selected cell | Opens cell for editing if the cell is allowed to be edited in the list.
Properties | Opens the property window.
Help | Opens the online help.

Dialog states and reactions

By clicking Configuration the dialog for configuring the states is opened. The configuration possibilities depend on the type of reaction matrix.

In list States you can also select more than one status at a time and edit them. Different settings are highlighted with the help of a red background or a red frame.

Hint: Thus you can change the status and the value for more the one state.

Context menu states

In the list field States the following commands are available in the context menu:

Command | Description
Creating a new status | Creates a new status based on the currently selected state.
Create a new sub-status | Only for multi-binary: Creates a new sub-status for the selected status.
Copy | Copies selected status to the clipboard. Note for multi binary: You can only copy main states. Sub-stated are copied together with their main states.
Paste | Pastes the selected status from the clipboard.
Delete | Deletes selected status from the list. The default status cannot be deleted.
Test | Opens the dialog for testing the status.
Up | Moves selected entries up. (Also possible with Drag&Drop.)
Down | Moves selected entry down. (Also possible with Drag & Drop.)
Help | Opens the online help for the respective reaction matrix.

You can find general settings and the definition of the values at the respective Rema:

  • Binary
  • Numerical
  • String
  • Multi-binary states and reactions
  • Multi-numeric states and reactions

info Information

In case of reload or Server-Standby Switch, the present responses or writing affirmations are distorted.


Types of reaction matrices

Manual -> Variables -> Reaction matrices -> Types of reaction matrices

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There are five types of reaction matrices available:

  • Binary
  • Numerical
  • String
  • Multibinary
  • Multi numeric

For multi-binary and multi-numeric types, AML/CEL text, status routing and variable handling can also be configured.


Binary

Manual -> Variables -> Reaction matrices -> Types of reaction matrices -> Binary

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A binary reaction matrix is used for the evaluation of any kind of flags and status bits of variables. The evaluation is bit-oriented. Also analog variables can be evaluated in this way.

Parameters

Description

States

List of the engineered states with value, state and cause of transmission.

New status

Creates a new status based on the currently selected state.

Sub-status

Only for multi-binary: Creates a new sub-status for the selected status.

Delete

Deletes all selected statues from the list.

Test

Opens the dialog for testing the status.

Up

Moves selected states up.

Down

Moves selected states down.

Status

Selection of the states.

Cause of transmission

Additional status for cause of transmission.

Function

Opens the dialog for linking a function. You can deselect an already linked function with the help of button No selection in this dialog.

Call via the Alarm Message List

Only available if you activated option In Alarm Message List in AML/CEL.

Active: Function is called via the AML.

Additional attributes

Limit color

Color when a limit has been violated.

Flashing

Active: Flashes when a limit has been violated.

Invisible

Active: Will be switch to invisible when a limit has been violated.

Help file

Clicking on ... opens the dialog to open a help file in chm format. It must have already been created in the project manager under files/help.

The linked help file is opened in Runtime if:

  • A help chapter has been entered
  • The corresponding alarm is selected in the Alarm Message list and
  • The Open help button is clicked

Note: The property can only be configured if the In Alarm Message List property is active.

Help chapter

Indication of the help chapter. Must contain an entry in order for help to be opened in Runtime.

Note: Only available if the In Alarm Message List property is activated.

Additional information 1

In the Runtime the additional information entered can be assessed in a VBA macro.

Additional information 2

In the Runtime the additional information entered can be assessed in a VBA macro.

AML/CEL

In Alarm Message List

Active: Will be entered in the AML.

To acknowledge

Only available if In Alarm Message List is activated.

Active: Must be acknowledged.

Comment required

To be able to acknowledge the alarm, a comment must be entered beforehand. The user must be authorized to carry out the necessary function.

To delete

Only available if In Alarm Message List is activated.

Active: Must be deleted.

Print

Only available if In Alarm Message List is activated.

Active: Will be printed via the set standard printer.

In Chronological Event List

Active: Will be entered in the CEL.
Hint: If the initial value (the first value that comes from the controller) or the value when Runtime is started already violates the limit value or the Rema status is active as a result, no entry is created in the CEL. Only once the limit violation has been rectified and then is violated again, or the state becomes inactive and then active again, is a CEL entry generated.

Alarm/event group

Allocation to an alarm/event group.

Alarm/event class

Allocation to an alarm/event class.

Value

Parameters | Description
Value | Current value of variable.
Limit text | Text which is displayed when at a limit violation.
Delay | Time period which the limit violation must last in order for the limit to be active.
Status text for counter in the mathematics driver | Assignment of four possible status numbers for a counter in the mathematics driver. For this the variable must have a reaction matrix.

The definition of the combination of state and/or status value is made by way of releasing the option fields. The state value is the binary encoded non-scaled value of the variables. The value transformed into the measuring range (linear or non-linear value adjustment) is not considered!

The bit assignment is:

Status: |
Non-scaled value bit "0" set | 2^0 = 1
Non-scaled value bit "1" set | 2^1 = 2
Non-scaled value bit "2" set | 2^2 = 4 ....

Two linkages are possible. The meaning of the fields is

Status: |
not considered | dot, not set
check for "0" | 0, bit is checked for logical value "0"
check for "1" | 1, bit is checked for logical value "1"

The sequence of the configuring is decisive for the later use. During the processing of the reaction matrix in online operation the check of the state and status bit combination is started in the top line. The check in the Runtime system is continued until the line which meets the given states. All other states are not checked further. If no line fulfills the current variable condition, the default entry applies. This enables prioritization of the limit texts for the chronological event list, alarming and the alarm information list. The status evaluation is done in the same way as the value evaluation of the variable.

Analysis

In binary variables only bit 0 is evaluated. The other bits are ignored, In 8 bit variables (IEC data types SINT, USINT) only the bits 0 to 7 are evaluated, and so on.

Example | (single information and monitoring for disturbance)
check whether INVALID-bit is set | ................, ............1...
Check whether bit 0 is set | ...............0, ................
Check whether bit 1 is set | ...............1, ................

In the above example, irrespective of the condition of the single information, the check is completed after the first line when the INVALID bit is present (no connection to PLC - data point disturbed). The variable properties (alarm, blinking, CEL, etc.) are controlled exclusively by this condition. Once the INVALID bit is no longer present, the other lines are processed. If the sequence is to be changed, then this can be effected with the selection of the respective line and the operations New, Delete, Upwards und Down.


Numeric

Manual -> Variables -> Reaction matrices -> Types of reaction matrices -> Numeric

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A numeric reaction matrix is used for the evaluation of any kind of limit states and status bits of the variables. In contrast to the binary matrix here the numerical values are evaluated. Not the PLC value but the adjusted measuring range value (linear or non-linear value adjustment) is used.

Parameters

Description

States

List of the engineered states with value, state and cause of transmission.

New status

Creates a new status based on the currently selected state.

Sub-status

Only for multi-binary: Creates a new sub-status for the selected status.

Delete

Deletes all selected statues from the list.

Test

Opens the dialog for testing the status.

Up

Moves selected states up.

Down

Moves selected states down.

Status

Selection of the states.

Cause of transmission

Additional status for cause of transmission.

Function

Opens the dialog for linking a function. You can deselect an already linked function with the help of button No selection in this dialog.

Call via the Alarm Message List

Only available if you activated option In Alarm Message List in AML/CEL.

Active: Function is called via the AML.

Additional attributes

Limit color

Color when a limit has been violated.

Flashing

Active: Flashes when a limit has been violated.

Invisible

Active: Will be switch to invisible when a limit has been violated.

Help file

Clicking on ... opens the dialog to open a help file in chm format. It must have already been created in the project manager under files/help.

The linked help file is opened in Runtime if:

  • A help chapter has been entered
  • The corresponding alarm is selected in the Alarm Message list and
  • The Open help button is clicked

Note: The property can only be configured if the In Alarm Message List property is active.

Help chapter

Indication of the help chapter. Must contain an entry in order for help to be opened in Runtime.

Note: Only available if the In Alarm Message List property is activated.

Additional information 1

In the Runtime the additional information entered can be assessed in a VBA macro.

Additional information 2

In the Runtime the additional information entered can be assessed in a VBA macro.

AML/CEL

In Alarm Message List

Active: Will be entered in the AML.

To acknowledge

Only available if In Alarm Message List is activated.

Active: Must be acknowledged.

Comment required

To be able to acknowledge the alarm, a comment must be entered beforehand. The user must be authorized to carry out the necessary function.

To delete

Only available if In Alarm Message List is activated.

Active: Must be deleted.

Print

Only available if In Alarm Message List is activated.

Active: Will be printed via the set standard printer.

In Chronological Event List

Active: Will be entered in the CEL.
Hint: If the initial value (the first value that comes from the controller) or the value when Runtime is started already violates the limit value or the Rema status is active as a result, no entry is created in the CEL. Only once the limit violation has been rectified and then is violated again, or the state becomes inactive and then active again, is a CEL entry generated.

Alarm/event group

Allocation to an alarm/event group.

Alarm/event class

Allocation to an alarm/event class.

Value

Parameters

Description

Value

Definition of the declaration of value:

  • any: any change of value violates the limit
  • greater: Enter of a limit
  • smaller: Enter of a limit
  • equal: Enter of a limit
  • Range Enter of an area (from ... to)

Limit text

Text which is displayed when at a limit violation.

Treat each change of value as new limit violation

Active: Each change in value is displayed as a limit violation.

Delay

Time period which the limit violation must last in order for the limit to be active.

Status text for counter in the mathematics driver

Assignment of four possible status numbers for a counter in the mathematics driver. For this the variable must have a reaction matrix.

info Information

A decimal value can be entered with either a comma or a point as a decimal separator, it will automatically be changed to a point.


String

Manual -> Variables -> Reaction matrices -> Types of reaction matrices -> String

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A string reaction matrix is used for the evaluation of limit values and status bits of the string variables. In addition to the known configurations of limit value and status combinations, further configurations are possible.

Parameters

Description

States

List of the engineered states with value, state and cause of transmission.

New status

Creates a new status based on the currently selected state.

Sub-status

Only for multi-binary: Creates a new sub-status for the selected status.

Delete

Deletes all selected statues from the list.

Test

Opens the dialog for testing the status.

Up

Moves selected states up.

Down

Moves selected states down.

Status

Selection of the states.

Cause of transmission

Additional status for cause of transmission.

Function

Opens the dialog for linking a function. You can deselect an already linked function with the help of button No selection in this dialog.

Call via the Alarm Message List

Only available if you activated option In Alarm Message List in AML/CEL.

Active: Function is called via the AML.

Additional attributes

Limit color

Color when a limit has been violated.

Flashing

Active: Flashes when a limit has been violated.

Invisible

Active: Will be switch to invisible when a limit has been violated.

Help file

Clicking on ... opens the dialog to open a help file in chm format. It must have already been created in the project manager under files/help.

The linked help file is opened in Runtime if:

  • A help chapter has been entered
  • The corresponding alarm is selected in the Alarm Message list and
  • The Open help button is clicked

Note: The property can only be configured if the In Alarm Message List property is active.

Help chapter

Indication of the help chapter. Must contain an entry in order for help to be opened in Runtime.

Note: Only available if the In Alarm Message List property is activated.

Additional information 1

In the Runtime the additional information entered can be assessed in a VBA macro.

Additional information 2

In the Runtime the additional information entered can be assessed in a VBA macro.

AML/CEL

In Alarm Message List

Active: Will be entered in the AML.

To acknowledge

Only available if In Alarm Message List is activated.

Active: Must be acknowledged.

Comment required

To be able to acknowledge the alarm, a comment must be entered beforehand. The user must be authorized to carry out the necessary function.

To delete

Only available if In Alarm Message List is activated.

Active: Must be deleted.

Print

Only available if In Alarm Message List is activated.

Active: Will be printed via the set standard printer.

In Chronological Event List

Active: Will be entered in the CEL.
Hint: If the initial value (the first value that comes from the controller) or the value when Runtime is started already violates the limit value or the Rema status is active as a result, no entry is created in the CEL. Only once the limit violation has been rectified and then is violated again, or the state becomes inactive and then active again, is a CEL entry generated.

Alarm/event group

Allocation to an alarm/event group.

Alarm/event class

Allocation to an alarm/event class.

Value

Parameters

Description

Value

Definition of the declaration of value:

  • any: any change of value violates the limit
  • greater: Enter of a limit
  • smaller: Enter of a limit
  • equal: Enter of a limit
  • Range Enter of an area (from ... to)

Case sensitive

On comparing with the limit string differences in capitalization are regarded.

Regard wildcards

The limit string can have wildcards.

(Wildcards are only allowed as prefix or suffix; e.g. *xxx or xxx*.)

Limit text

Text which is displayed when at a limit violation.

Treat each change of value as new limit violation

Active: Each change in value is displayed as a limit violation.

Delay

Time period which the limit violation must last in order for the limit to be active.

Status text for counter in the mathematics driver

Assignment of four possible status numbers for a counter in the mathematics driver. For this the variable must have a reaction matrix.

Example Example

Example:

In the sequence for an evaluation large after small:

  • Strings: Mein,Name,ist,Hase.
  • Sequence of Execution: ist,Name,Mein,Hase.
  • Reason:
    ist: Starts with a lower-case letter, therefore it is higher than the other strings.
    Name N is is greater than M and H,
    Mein: M is greater than H

Display in the Vale column for AML and CEL

Only values of numeric data types can be displayed in the Value column for AML and CEL. The column remains empty for entries with a String data type.


Multi-reaction matrices in general

Manual -> Variables -> Reaction matrices -> Types of reaction matrices -> Multi-reaction matrices in general

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tabs | Description
States and reactions | Configuration for the states and reactions for the Multi-binary reaction matrix and the Multi-numeric reaction matrix.
AML/CEL text | Configuration for the output of the value next to the limit text in the AML and CEL.
Status routing | Configuration of the status routing.
Special functions | Configuration of special functions.

Note: The bits NORM and N_NORM are available for both types of multi reaction matrices but not for the standard matrices.

Information processing

The upper 16 bits (bit 16 ... 31) are used in the protective data configuring for the information processing; the information number is stored in the upper 16 bits.

The function of the multi-binary reaction matrix is identical to the binary response matrix for the main states. If any of the main states are changed, the respective configuring states (alarm, CEL, text, etc.) are executed:

  • If a main state has substates, the substates are checked first on reaching the main state.
  • If no substate corresponds to the current state of the variables, the respective state configuring (alarm, CEL, text, etc.) of the main state is executed.
  • If the substate corresponds with the current state of the variables, the respective state configuring (alarm, CEL, text, etc.) of the substate is carried out.
  • If the state of the variables changes from the substate to the main state, there is no new output to the chronologic event list and the alarm list (e.g. breaker tripping treatment in the SAT system).

Example:

Parameters | Description
Main value | Engineering -> Lower valuexxxxxx00 no alarm, CEL text off -> xxxxx100 alarm, CEL text Breaker tripping off xxxxxx01 no alarm, CEL text On xxxxxx10 alarm, CEL text Difference xxxxxx11 alarm, CEL text Malfunction
Change from "ON" to "OFF" | no alarm, CEL entry "on"
Change from "ON" to "OFF" | Alarm entry Breaker tripping off, CEL text Breaker tripping off -> Acknowledgement of the breaker tripping (change of BREAKER TRIPPING OFF to OFF) cleared alarm breaker tripping off, no renewed CEL text

For the output in the CEL and in the process screens the entire contents of the variable can be separated to two parts. One part is used for the limit definition, the second part (value) is used in the screens. (Field of application: protection telegrams in SAT 1703).

Cause of transmission

Multi-binary and multi-analog reaction matrixes allow evaluation of the transfer cause accordingly

The IEC 60870-5-101/104 standard. The transmission cause consists of:

Bit | Description
6 bit | Value of the cause of transmission 0 ... 63
1 bit | N_CONF (P/N-Bit): 0 = positive 1 = negative confirmation
1 bit | Test bit

In the reaction matrix, the identification of the transmission cause + the N_CONF Bit (P/N bit) can be assigned to each status. So the status is only violated, if the received transmission cause is the same as the defined transmission cause.

Parameters | Description
Transfer cause checkbox | Activates the evaluation of the transfer cause input field.
Transfer cause input field | Expects a value of 0-63 as identification of the transfer cause.


Multi-binary states and reactions

Manual -> Variables -> Reaction matrices -> Types of reaction matrices -> Multi-reaction matrices in general -> Multi-binary states and reactions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A multi-binary reaction matrix is used for the evaluation of value, state and status bits of digital variables. The lower bits (bit 0.15) are used as value for the display in screens (dynamic elements) and in the chronologic events list (field "value"). In addition to the known configurations of value and status combinations, further configurations are possible.

Parameters

Description

States

List of the engineered states with value, state and cause of transmission.

New status

Creates a new status based on the currently selected state.

Sub-status

Only for multi-binary: Creates a new sub-status for the selected status.

Delete

Deletes all selected statues from the list.

Test

Opens the dialog for testing the status.

Up

Moves selected states up.

Down

Moves selected states down.

Status

Selection of the states.

Cause of transmission

Additional status for cause of transmission.

Function

Opens the dialog for linking a function. You can deselect an already linked function with the help of button No selection in this dialog.

Call via the Alarm Message List

Only available if you activated option In Alarm Message List in AML/CEL.

Active: Function is called via the AML.

Additional attributes

Limit color

Color when a limit has been violated.

Flashing

Active: Flashes when a limit has been violated.

Invisible

Active: Will be switch to invisible when a limit has been violated.

Help file

Clicking on ... opens the dialog to open a help file in chm format. It must have already been created in the project manager under files/help.

The linked help file is opened in Runtime if:

  • A help chapter has been entered
  • The corresponding alarm is selected in the Alarm Message list and
  • The Open help button is clicked

Note: The property can only be configured if the In Alarm Message List property is active.

Help chapter

Indication of the help chapter. Must contain an entry in order for help to be opened in Runtime.

Note: Only available if the In Alarm Message List property is activated.

Additional information 1

In the Runtime the additional information entered can be assessed in a VBA macro.

Additional information 2

In the Runtime the additional information entered can be assessed in a VBA macro.

AML/CEL

In Alarm Message List

Active: Will be entered in the AML.

To acknowledge

Only available if In Alarm Message List is activated.

Active: Must be acknowledged.

Comment required

To be able to acknowledge the alarm, a comment must be entered beforehand. The user must be authorized to carry out the necessary function.

To delete

Only available if In Alarm Message List is activated.

Active: Must be deleted.

Print

Only available if In Alarm Message List is activated.

Active: Will be printed via the set standard printer.

In Chronological Event List

Active: Will be entered in the CEL.
Hint: If the initial value (the first value that comes from the controller) or the value when Runtime is started already violates the limit value or the Rema status is active as a result, no entry is created in the CEL. Only once the limit violation has been rectified and then is violated again, or the state becomes inactive and then active again, is a CEL entry generated.

Alarm/event group

Allocation to an alarm/event group.

Alarm/event class

Allocation to an alarm/event class.

Checkbox Status

Each status can have one of 5 possible states. They are defined by clicking in the checkbox before the respective status.

Possible states:

  • not considered (dot)
  • on (1)
  • off (0)
  • coming (arrow upwards)
  • going (arrow downwards)
  • alternating (dual arrow)

Value

Parameters | Description
Value | Current value of variable.
Limit text | Text which is displayed when at a limit violation.
Delay | Time period which the limit violation must last in order for the limit to be active.
Status text for counter in the mathematics driver | Assignment of four possible status numbers for a counter in the mathematics driver. For this the variable must have a reaction matrix.

info Information

A decimal value can be entered with either a comma or a point as a decimal separator, it will automatically be changed to a point.


Multi-numeric states and reactions

Manual -> Variables -> Reaction matrices -> Types of reaction matrices -> Multi-reaction matrices in general -> Multi-numeric states and reactions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A multi-numeric reaction matrix is used for the evaluation of limit values and status bits of the variables. In addition to the known configurations of limit value and status combinations, further configurations are possible.

Parameters

Description

States

List of the engineered states with value, state and cause of transmission.

New status

Creates a new status based on the currently selected state.

Sub-status

Only for multi-binary: Creates a new sub-status for the selected status.

Delete

Deletes all selected statues from the list.

Test

Opens the dialog for testing the status.

Up

Moves selected states up.

Down

Moves selected states down.

Status

Selection of the states.

Cause of transmission

Additional status for cause of transmission.

Function

Opens the dialog for linking a function. You can deselect an already linked function with the help of button No selection in this dialog.

Call via the Alarm Message List

Only available if you activated option In Alarm Message List in AML/CEL.

Active: Function is called via the AML.

Additional attributes

Limit color

Color when a limit has been violated.

Flashing

Active: Flashes when a limit has been violated.

Invisible

Active: Will be switch to invisible when a limit has been violated.

Help file

Clicking on ... opens the dialog to open a help file in chm format. It must have already been created in the project manager under files/help.

The linked help file is opened in Runtime if:

  • A help chapter has been entered
  • The corresponding alarm is selected in the Alarm Message list and
  • The Open help button is clicked

Note: The property can only be configured if the In Alarm Message List property is active.

Help chapter

Indication of the help chapter. Must contain an entry in order for help to be opened in Runtime.

Note: Only available if the In Alarm Message List property is activated.

Additional information 1

In the Runtime the additional information entered can be assessed in a VBA macro.

Additional information 2

In the Runtime the additional information entered can be assessed in a VBA macro.

AML/CEL

In Alarm Message List

Active: Will be entered in the AML.

To acknowledge

Only available if In Alarm Message List is activated.

Active: Must be acknowledged.

Comment required

To be able to acknowledge the alarm, a comment must be entered beforehand. The user must be authorized to carry out the necessary function.

To delete

Only available if In Alarm Message List is activated.

Active: Must be deleted.

Print

Only available if In Alarm Message List is activated.

Active: Will be printed via the set standard printer.

In Chronological Event List

Active: Will be entered in the CEL.
Hint: If the initial value (the first value that comes from the controller) or the value when Runtime is started already violates the limit value or the Rema status is active as a result, no entry is created in the CEL. Only once the limit violation has been rectified and then is violated again, or the state becomes inactive and then active again, is a CEL entry generated.

Alarm/event group

Allocation to an alarm/event group.

Alarm/event class

Allocation to an alarm/event class.

Value

Parameters

Description

Value

Definition of the declaration of value:

  • any: any change of value violates the limit
  • greater: Enter of a limit
  • smaller: Enter of a limit
  • equal: Enter of a limit
  • Range Enter of an area (from ... to)

Limit text

Text which is displayed when at a limit violation.

Treat each change of value as new limit violation

Active: Each change in value is displayed as a limit violation.

Delay

Time period which the limit violation must last in order for the limit to be active.

Status text for counter in the mathematics driver

Assignment of four possible status numbers for a counter in the mathematics driver. For this the variable must have a reaction matrix.

info Information

A decimal value can be entered with either a comma or a point as a decimal separator, it will automatically be changed to a point.


Configuration AML/CEL text

Manual -> Variables -> Reaction matrices -> Types of reaction matrices -> Multi-reaction matrices in general -> Configuration AML/CEL text

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab the output for AML and CEL is configured.


Configuration status routing

Manual -> Variables -> Reaction matrices -> Types of reaction matrices -> Multi-reaction matrices in general -> Configuration status routing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab the status routing is configured. Routes bits (also negated ones) to other bits.

Possible sources: Value bit 0 ... 31l

Parameters | Description
Source bit | Select source bit from list box
NEG | Negate source bit during the routing
Status bit | Select target bit from list box
Apply | Accept selected routing
Delete | Delete selected routing;Beware: There is no further query
Up | Move selected routing in the sequence upwards
Down | Move selected routing in the sequence downwards


Configuration special functions

Manual -> Variables -> Reaction matrices -> Types of reaction matrices -> Multi-reaction matrices in general -> Configuration special functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab special functions are configured.

With active status bits variables can be switched off automatically or status changes (for reset) can be let pass at switched off variables. For details see chapter Status definition.

Parameters | Description
switch off for | status bits where the data point is to be switched off Check for "0" or "1" is possible
allow to pass for | status bits where a change in status is to be allowed to pass
No old/new comparison | No monitoring of changes
No old/new comparison for ET-route | No monitoring of changes on the real-time route


Test

Manual -> Variables -> Reaction matrices -> Types of reaction matrices -> Test

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Makes it possible for settings for the reaction matrix to be tested. Depending on the configuration of the reaction matrix, a simulation of what happens when defined values are reached is carried out. Entries in the CEL or AML are simulated. This feature concerns SICAM 230.

Parameters | Description
Status | To simulate status changes.
Value | Simulation of value changes.
Test result | Output of changes from status and value in CEL and AML.
Send RT | Send changes in real time.
SendenNEZ | Send changes.


Dynamic limit texts in reaction matrices

Manual -> Variables -> Reaction matrices -> Dynamic limit texts in reaction matrices

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Dynamic limit texts can also be displayed in reaction matrices:

$ %PV

$ @text

See also Dynamic limit text.

Reaction matrices can be used for multiple variables.


Status for value change and delay time

Manual -> Variables -> Reaction matrices -> Status for value change and delay time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A status can generate alarms depending on values and delay time. For example, an alarm can be created if a variable has not changed for a certain time.

Configuration:

  • Value: any
  • Treat each change of value as new limit violation: acive
  • Delay: >0

In this case:

  • the alarm is activated if the value is a longer constant than the delay time.
  • If the value changes within the delay time, the delay time restarts. For example, an alarm can be created if a variable has not changed for a certain time.


List of status bits

Manual -> Variables -> Reaction matrices -> List of status bits

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Bit number | Short term | Long name | zenon Logic label
0 | M1 | User status 1 | _VSB_ST_M1
1 | M2 | User status 2 | _VSB_ST_M2
2 | M3 | User status 3 | _VSB_ST_M3
3 | M4 | User status 4 | _VSB_ST_M4
4 | M5 | User status 5 | _VSB_ST_M5
5 | M6 | User status 6 | _VSB_ST_M6
6 | M7 | User status 7 | _VSB_ST_M7
7 | M8 | User status 8 | _VSB_ST_M8
8 | NET_SEL | Select in the network | _VSB_SELEC
9 | REVISION | Revision | _VSB_REV
10 | PROGRESS | In operation | _VSB_DIREC
11 | TIMEOUT | Runtime exceedance | _VSB_RTE
12 | MAN_VAL | Manual value | _VSB_MVALUE
13 | M14 | User status 14 | _VSB_ST_14
14 | M15 | User status 15 | _VSB_ST_15
15 | M16 | User status 16 | _VSB_ST_16
16 | GI | General interrogation | _VSB_GR
17 | SPONT | Spontaneous | _VSB_SPONT
18 | INVALID | Invalid | _VSB_I_BIT
19 | T_CHG_A | Daylight saving time/winter time announcement | _VSB_SUWI
20 | OFF | Switched off | _VSB_N_UPD
21 | T_EXTERN | Real time external | _VSB_RT_E
22 | T_INTERN | Realtime internal | _VSB_RT_I
23 | N_SORTAB | Not sortable | _VSB_NSORT
24 | FM_TR | Error message transformer value | _VSB_DM_TR
25 | RM_TR | Working message transformer value | _VSB_RM_TR
26 | INFO | Information for the variable | _VSB_INFO
27 | ALT_VAL | Alternate value If no value was transferred, the defined alternate value is used otherwise the last valid value is used. | _VSB_AVALUE
28 | RES28 | Reserved for internal use (alarm flashing) | _VSB_RES28
29 | N_UPDATE | Not updated | _VSB_ACTUAL
30 | T_STD | Standard time | _VSB_WINTER
31 | RES31 | Reserved for internal use (alarm flashing) | _VSB_RES31
32 | COT0 | Cause of transmission bit 1 | _VSB_TCB0
33 | COT1 | Cause of transmission bit 2 | _VSB_TCB1
34 | COT2 | Cause of transmission bit 3 | _VSB_TCB2
35 | COT3 | Cause of transmission bit 4 | _VSB_TCB3
36 | COT4 | Cause of transmission bit 5 | _VSB_TCB4
37 | COT5 | Cause of transmission bit 6 | _VSB_TCB5
38 | N_CONF | Negative acceptance of Select by device (IEC 60870) | _VSB_PN_BIT
39 | TEST | Test bit (IEC870 [T]) | _VSB_T_BIT
40 | WR_ACK | Writing acknowledged | _VSB_WR_ACK
41 | WR_SUC | Writing successful | _VSB_WR_SUC
42 | NORM | Normal status | _VSB_NORM
43 | N_NORM | Deviation normal status | _VSB_ABNORM
44 | BL_870 | IEC 60870 Status: blocked | _VSB_BL_BIT
45 | SB_870 | IEC 60870 Status: substituted | _VSB_SP_BIT
46 | NT_870 | IEC 60870 Status: not topical | _VSB_NT_BIT
47 | OV_870 | IEC 60870 Status: overflow | _VSB_OV_BIT
48 | SE_870 | IEC 60870 Status: select | _VSB_SE_BIT
49 | T_INVAL | Time invalid | not defined
50 | CB_TRIP | Breaker tripping detected | not defined
51 | CB_TR_I | Breaker tripping detection inactive | not defined
52 | RES52 | reserved | not defined
53 | RES53 | reserved | not defined
54 | RES54 | reserved | not defined
55 | RES55 | reserved | not defined
56 | RES56 | reserved | not defined
57 | RES57 | reserved | not defined
58 | RES58 | reserved | not defined
59 | RES59 | reserved | not defined
60 | RES60 | reserved | not defined
61 | RES61 | reserved | not defined
62 | RES62 | reserved | not defined
63 | RES63 | reserved | not defined

info Information

In formulas all status bits are available. For other use the availability can be reduced.

You can read details on status processing in the Status processing chapter.


Functions for variables

Manual -> Variables -> Functions for variables

Functions make it possible to start commands in Runtime using a button or script.

To create a function:

  1. select New function... in the context menu or in the tool bar
  2. navigate to the variable
  3. select the desired function


Export data

Manual -> Variables -> Functions for variables -> Export data

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function makes it possible to export variable data in Runtime.

The export format and the file name are defined in the Editor. The storage location when executed in Runtime is the Export folder in the Runtime folder.

Hint: You can get to the project folder by highlighting the project in the Editor and pressing the key combination Ctrl+Alt+R.

To create the function:

  1. Create a new function
  2. Select Export data
  3. The configuration dialog is opened

Parameters

Description

Output format

Format

Select one of the possible file types:

  • dBase IV (*.dbf)
  • XML (*.xml)
  • CSV (*.txt)

As Unicode

This checkbox is only active if you have selected CSV (*.txt) as the file type.
Active: File is saved in Unicode (UTF-16).

File names

Create the filenames.
A maximum of 8 characters are permitted for DBF files.

Note: The name can no longer be changed in Runtime.

Runtime storage location: Export folder in Runtime folder.

Variables

Variables selection

Selection of variables to be exported. A click on the button opens the dialog to select variables.

This selection can no longer be changed in Runtime.

Note: For a variable to be selectable, you must activate property Harddisk data storage active in group Harddisk data storage for this variable.

Initialize values again

For the HD values, a ring buffer is filled and stored.
Active: The ring buffer is emptied and reinitialized for the export.
Inactive: The ring buffer is kept for the export:


Read dBase file

Manual -> Variables -> Functions for variables -> Read dBase file

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function is used to read in a DBase file again and issue it as a recipe during online operation.

Give the dBase file as the transfer parameter. The file and directory name have to be DOS compatible.

This file contains the process variable names and the according set values. If the defined variable exists in the project, the value defined in the dBase file is written to the PLC as a new set value.

The dBaseIV file must have the following structure and contents:

Description | Type | Value | Comment
NAME | Char | 32 | process variable name
WERT | Num | 20 | Technical value
TYP | Char | 8 | Data type (C=String, N=Numeric)
DIRECTION | Char | 12 |


Print current values

Manual -> Variables -> Functions for variables -> Print current values

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function is used to create a simple log of current variable values (process and derived variables) during online operation.

Give a formatting file as the transfer parameter. This function is configured via an input dialog.

Configurable options are:

Parameters | Description
System buttons | OK, Cancel, Help
With dialog cancel | displays abort dialog during generation in online operation
Select format file | Opens a dialog box for the selection of the *.FRM file. This file is created with the button below. The format FRM is described further below in this chapter.
Start format editor | starts text editor for creation of file
Font | sets font which will be used

Select the file (*.FRM file type by clicking on the “Select format file” button.

Defined keywords are used in the format file. The corresponding variable parameters are entered during online operation instead of the keywords.

Keywords:

Keyword | Description
@TTA.name | outputs variable names
@TTA.wert | outputs current technical value; outputs binary status as value or string variable
@TTA.einheit | outputs unit defined for process variable
@TTA.text | outputs text defined for process variable
@TTA.status | outputs current status bit of process variables in succession with short names (from ZENON6.INI)

The following keywords are available for formatting the output page or as general information:

Keyword | Description
%DATE | outputs current date
%TIME | outputs current time
%PAGE | outputs current page number

Texts for the header and footer can be defined. The sections (header, main section, footer) have to be marked in front and behind the section with "%%". Three empty lines have to be entered behind the last "%%".

Using tabs will result in problems when outputting texts of different lengths. Only empty spaces can be used for positioning The “@” key character is not counted.

FRM file “PROJEKT.FRM”

%%
Page header
%%
%%
%date Measuring value log of equipment XYZ %time o' clock

Identification techn. value unit of measurement
Value 1 @Value1.wert bar
Value 2 @VALUE2.wert kV
Value 3 @VALUE3.wert ºF

Page %page
%%
%%
Page footer
%%

Online printing with the “PROJEKT.FRM” file

Header text

21.02.1995 Measuring value log of equipment XYZ 12:00 o' clock

Identification techn. value unit of measurement
Value 1 0.63 bar
Value 2 9.98 kV
> Value 3 17.3 ºF

> Page 5

Footer text

If the desired format of the current values is narrower as the space between the TTA key words, a QRF file with the same name can be used. In the QRF file the process variables are assigned to defined markers. Each marker (xxx) begins with a “$” and is defined with a certain syntax.

"define $" xxx as "Variable" |
- xxx | freely chosen identifier or number
Variable | Variable name

attention Attention

The QRF definition format that the code expects is, for example:
define "$001" as "REAL_VAR_NAME"
The quotes are important here.

These markers can be accessed in the FRM file The variable parameters are then addressed via other parameters.

$xxx.1 | process variable name
$xxx.2 | Technical value
$xxx.3 | Unit
$xxx.4 | Status text

Note: Variable names with a period must be set in apostrophes, for example: "Variable.Test".

Example of a QRF file's structure:

QRF file “MOMENT.QRF”

"define $001" as "TTA1 "
"define $002" as "TTA2"

FRM file “MOMENT.FRM”

%%
Header text
%%
%%
Main section
Value of TTA1= @$001.2
Value of TTA2= @$002.2
%%
%%
Footer text
%%

Online printout with the “MOMENT.FRM” file

Header text
Value of TTA1= 100.25
Value of TTA2= 25.745
Footer text


HD administration active

Manual -> Variables -> Functions for variables -> HD administration active

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function is used to activate HD administration (filing of the online values with configured HD feature; online trend) during online operation.

No transfer parameters are needed.


HD administration inactive

Manual -> Variables -> Functions for variables -> HD administration inactive

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function is used to deactivate HD administration (filing of the online values with configured HD feature ; online trend) during online operation.

attention Attention

No more values are saved! Online values are updated. No transfer parameters are needed.


HD administration inactive/active

Manual -> Variables -> Functions for variables -> HD administration inactive/active

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function is used to switch HD administration (filing of the online values with configured HD feature; online trend) between the two states during online operation. The states stored in the file project.ini will be read in when online operation is started.

[DEFAULT] |
... |
HDDATEN= | 0 - inactive
 | 1 - active


Write set value

Manual -> Variables -> Functions for variables -> Write set value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This function is used to set a set value for a variable in online operation.

The variable, the set value and the way how to set the value have to be given as transfer parameters. This function is configured via an input dialog. The function is configured with its own dialogs for:

  • numerical variables
  • binary variables
  • string variables

The set value dialog box is used for input in Runtime. If the keyboard screen SETVALUEKBD is available in the project, it is used automatically.

info Information

In case of reload or Server-Standby Switch, the present responses or writing affirmations are distorted.


for numeric variables

Manual -> Variables -> Functions for variables -> Write set value -> for numeric variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters

Description

Set value settings

Configuration of the target value.

Set value

Input of the set value to be set for the variable.

Minimum

Input of the minimum value.

Maximum

Input of the maximum value.

Use set value limits of the variable

Active: The set value limits are taken from the variable definition (Description/Set value).
Inactive: The set value limits can directly be defined in the function (Minimum and Max).

Options

Configuration of the options.

Propose current value

Active: The value is read from the hardware and then is proposed as a default or directly sent to the hardware. Additionally the caption of the field Set value changes to Change by and the value entered there is added to the default (subtracted if negative value).
Inactive: The value defined under Set value is proposed as a default or directly sent to the hardware.

Direct to the hardware

Active: After activating the function the value is directly sent to the hardware not asking for a further confirmation.
Inactive: Before sending the value to the hardware the set value dialog is opened and the user can change the settings in the Runtime.

Wait for writing confirmation

Active: The function only finshes execution once a positive confirmation of the write action is received or the fixed defined timeout of 30 seconds is over.
In scripts this can make sure, that the following function is not started, before this one is finished.
The confirmation can also be evaluated with the status bit WR-SUC.
Inactive: Do not wait for the writing confirmation.

Write set value via

Configuration of how the target value is to be set:

  • Standard dialog box: Set value in Runtime set using a dialog box.
  • Screen: Set value in Runtime set using a screen.
  • Program: Set value in Runtime set using a program. Selection by clicking on the ... button.

OK

Configuration is accepted, function created and the dialog is closed.

Cancel

Configuration is rejected, function created without parameters and the dialog is closed.

Help

Online help is opened.

info Information

A decimal value can be entered with a colon as well as with a point, the decimal point will automatically be changed to a point.


for binary variables

Manual -> Variables -> Functions for variables -> Write set value -> for binary variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters

Description

LOW (0)

Value of variables will be set to LOW (0)

HIGH (1)

Value of variables will be set to HIGH (1)

TOGGLE

Value of variable is switched to complementary status.

Hint: If the variable value is to be toggled, we recommend activating the Permanently read variable property. Otherwise Runtime waits until the driver knows the value of the variables. If the value is not available due to a breakdown in communication with the control unit, the waiting time corresponds to the timeout time of the driver.

Parameters

Description

Set value settings

Configuration of the target value.

Set value

Input of the set value to be set for the variable.

Minimum

Input of the minimum value.

Maximum

Input of the maximum value.

Use set value limits of the variable

Active: The set value limits are taken from the variable definition (Description/Set value).
Inactive: The set value limits can directly be defined in the function (Minimum and Max).

Options

Configuration of the options.

Propose current value

Active: The value is read from the hardware and then is proposed as a default or directly sent to the hardware. Additionally the caption of the field Set value changes to Change by and the value entered there is added to the default (subtracted if negative value).
Inactive: The value defined under Set value is proposed as a default or directly sent to the hardware.

Direct to the hardware

Active: After activating the function the value is directly sent to the hardware not asking for a further confirmation.
Inactive: Before sending the value to the hardware the set value dialog is opened and the user can change the settings in the Runtime.

Wait for writing confirmation

Active: The function only finshes execution once a positive confirmation of the write action is received or the fixed defined timeout of 30 seconds is over.
In scripts this can make sure, that the following function is not started, before this one is finished.
The confirmation can also be evaluated with the status bit WR-SUC.
Inactive: Do not wait for the writing confirmation.

Write set value via

Configuration of how the target value is to be set:

  • Standard dialog box: Set value in Runtime set using a dialog box.
  • Screen: Set value in Runtime set using a screen.
  • Program: Set value in Runtime set using a program. Selection by clicking on the ... button.

OK

Configuration is accepted, function created and the dialog is closed.

Cancel

Configuration is rejected, function created without parameters and the dialog is closed.

Help

Online help is opened.


for string variables

Manual -> Variables -> Functions for variables -> Write set value -> for string variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters

Description

Set value settings

Configuration of the target value.

Set value

Input of the set value to be set for the variable.

Options

Configuration of the options.

Propose current value

Active: The value is read from the hardware and then is proposed as a default or directly sent to the hardware. Additionally the caption of the field Set value changes to Change by and the value entered there is added to the default (subtracted if negative value).
Inactive: The value defined under Set value is proposed as a default or directly sent to the hardware.

Direct to the hardware

Active: After activating the function the value is directly sent to the hardware not asking for a further confirmation.
Inactive: Before sending the value to the hardware the set value dialog is opened and the user can change the settings in the Runtime.

Wait for writing confirmation

Active: The function only finshes execution once a positive confirmation of the write action is received or the fixed defined timeout of 30 seconds is over.
In scripts this can make sure, that the following function is not started, before this one is finished.
The confirmation can also be evaluated with the status bit WR-SUC.
Inactive: Do not wait for the writing confirmation.

Write set value via

Configuration of how the target value is to be set:

  • Standard dialog box: Set value in Runtime set using a dialog box.
  • Screen: Set value in Runtime set using a screen.
  • Program: Set value in Runtime set using a program. Selection by clicking on the ... button.

OK

Configuration is accepted, function created and the dialog is closed.

Cancel

Configuration is rejected, function created without parameters and the dialog is closed.

Help

Online help is opened.


Check write set value

Manual -> Variables -> Functions for variables -> Write set value -> Check write set value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When writing values, the value receives a status bit that is has been written. If the writting process is successful, the corresponding status bit is set:

  • WR-ACK

    The driver received a value for writing.

  • WR-SUC

    Value 1: Writing successful.

    Value 0: Writing not successful. The value could not be written.

info Information

In case of reload or Server-Standby switch, the currently active responses or writing affirmations are discarded.

This status combination are active until the next value change is triggered. Then both states are set to 0 until the writing action is finished. For evaluation the following bit combination must be requested in the reaction matrix:

WR-ACK, WR-SUC

Result:

  • WR-ACK 1, WR-SUC 1: Writing action successful.
  • WR-ACK 1, WR-SUC 0: Writing action not successful.

attention Attention

The mechanism only shows, that the writing action was successful (or not successful) to the PLC. This does not mean, that the value has indeed been changed in the PLC, since the PLC can reset/overwrite the value immediately. (For example for writing the outputs or the transient bits which are only set for a short time.)

Modules

This mechanism can be used in the following modules:

  • function Write set value: Activate option Wait for writing confirmation in the configuration dialog of the function.
  • Standard recipes: Activate property Write synchronously.
  • Recipegroup Manager: Activate property Write synchronously.
  • Command Processing

Entry in CEL

  • Function Write set value

    For the entry in the CEL you must activate property Function Set SV in node Chronological Event List in the project settings. After this the positive or negative response the execution of the function is written to the CEL.

  • Standard recipes and Recipegroup Manager

    For the entry in the CEL a system driver variable is used which is set to 1 when a recipe is written successfully. A global variable is evaluated on the Server, a local variable on every Client in order to determine when the recipe executed last was written completely.
    With this variables a CEL entry can be created via limit or reaction matrix. The query is carried out via a multi analog or a multi binary reaction matrix.


Driver commands

Manual -> Variables -> Functions for variables -> Driver commands

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This chapter describes standard functions that are valid for most zenon drivers. Not all functions described here are available for every driver. For example, a driver that does not, according to the data sheet, support a modem connection also does not have any modem functions.

Driver commands are used to influence drivers using zenon; start and stop for example.
The engineering is implemented with the help of function Driver commands. To do this:

  • create a new function
  • select Variables -> Driver commands
  • The dialog for configuration is opened

Parameters

Description

Drivers

Drop-down list with all drivers which are loaded in the project.

Current state

Fixed entry which has no function in the current version.

Driver commands

Drop-down list for the selection of the command.
  • Start driver (online mode)

Driver is reinitialized and started.
  • Stop driver (offline mode)

Driver is stopped. No new data is accepted.

Note: If the driver is in offline mode, all variables that were created for this driver receive the status switched off (OFF; Bit 20).

  • Driver in simulation mode

Driver is set into simulation mode.
The values of all variables of the driver are simulated by the driver. No values from the connected hardware (e.g. PLC, bus system, ...) are displayed.
  • Driver in hardware mode

Driver is set into hardware mode.
For the variables of the driver the values from the connected hardware (e.g. PLC, bus system, ...) are displayed.
  • Driver-specific command

Enter driver-specific commands. Opens input field in order to enter a command.
  • Activate driver write set value

Write set value to a driver is allowed.
  • Deactivate driver write set value

Write set value to a driver is prohibited.
  • Establish connection with modem

Establish connection (for modem drivers) Opens the input fields for the hardware address and for the telephone number.
  • Disconnect from modem

Terminate connection (for modem drivers)

Show this dialog in the Runtime

The dialog is shown in Runtime so that changes can be made.

Driver commands in the network

If the computer, on which the driver command function is executed, is part of the zenon network, additional actions are carried out. A special network command is sent from the computer to the project server, which then executes the desired action on its driver. In addition, the Server sends the same driver command to the project standby. The standby also carries out the action on its driver.

This makes sure that Server and Standby are synchronized. This only works if the Server and the Standby both have a working and independent connection to the hardware.


Write time to variable

Manual -> Variables -> Functions for variables -> Write time to variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function a connected PLC can be synchronized with the PC. When executing this function, the System time is taken and saved in a String varialbe of the format: DD.MM.YYYY HH:MM:SS

The name of the variable has to be given as a parameter.


Read time from variable

Manual -> Variables -> Functions for variables -> Read time from variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With this function the PC can be synchronized with a connected PLC. On executing the function a string variable is read from the PLC. If the difference between PC and PLC time is larger than one second, the PC system time is set and an entry in the CEL is generated. The string variable must have the following format: DD.MM.YYYY HH:MM:SS.

Note: Time is saved as local time. For details see chapter Handling of date and time in chapter Runtime.

The name of the variable has to be given as a parameter.


Screen variable-diagnosis

Manual -> Variables -> Screen variable-diagnosis

With the screen type variable-diagnosis it is possible to display variables in the runtime and to set target values. You will find more information on the pre-defined screen types in the chapter 'Screens / Screen types'.)


Create screen Variable diagnosis

Manual -> Variables -> Screen variable-diagnosis -> Create screen Variable diagnosis

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to create screen Variable diagnosis:

  • create a new screen
  • select Variable diagnosis as screen type
  • an empty screen is created
  • select the menu item Add template from menu Control elements or select the desired control elements for the operation in the Runtime

Control element | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.
Display options | Control elements for the display.
Variable diagnosis | List field in the Runtime.
Value display: Decimal | The variable values in the list (actual value, set value) are displayed decimal.
Value display: Hexadecimal | The variable values in the list (actual value, set value) are displayed hexadecimal.
Value display: Binary | The variable values in the list (actual value, set value) are displayed binary.
Value display: Octal | The variable values in the list (actual value, set value) are displayed octal.
Value display: Exponential | The variable values in the list (actual value, set value) are displayed decimal exponential.
Variables |
Add variable | Add a variable to the list in the Runtime
Remove variable | Remove variable from the list in the Runtime
Update value |
Updating actual value ON | Switch on automatic updating of current variable values.
Updating actual value OFF | Switch off automatic updating of current variable values.
Refresh actual values | Update the current values of the variables.
All variables: Write set value | Write the set values of all variables to the hardware.
Selected variables: Write set value | Write the set values of the selected variables to the hardware.
Edit set value | Edit the set value of the selected variable.
Selected variables |
Switch to spontaneous value | Switch selected variable to spontaneous value.
Switch to alternate value | Switch selected variable to alternate value.
Modify alternate value | Modify the alternate value of the selected variable.
Set revision | Switch on the revision for selected variables. To do this, the REVISION status bit (bit 09) is set.
Reset revision | Switch off the revision for selected variables. To do this, the REVISION status bit (bit 09) is reset.
Set OFF status | Switch on the spontaneous value for the selected variable. To do this, the OFF status bit (bit 20) is reset.
Reset OFF status | Switch off the spontaneous value for the selected variable. To do this, the OFF status bit (bit 20) is set.
Filter profiles | Buttons for filter settings in Runtime.
Profile selection | Select profile from list.
Save | Saves current setting as a profile.
Delete | Deletes selected profile.
Import | Imports filter profiles from export file.
Export | Exports filter profiles in the file.

info Information

A decimal value can be entered with either a comma or a point as a decimal separator, it will automatically be changed to a point.

In order to use the variable diagnosis in the Runtime, create a function screen switch to the screen.

info Information

You can for the satus bits NORM and N_NORM filter.


Screen switch - Variable diagnosis

Manual -> Variables -> Screen variable-diagnosis -> Screen switch - Variable diagnosis

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The parameters needed for opening a screen of the type Variable diagnosis are the variables to be displayed in the screen and the default set values for the selected variables.

In order to create a function to switch to the screen Variable diagnosis:

  • select New Function
  • select Screen switch
  • select the screen Variable diagnosis
  • the dialog for the configuration is opened

Parameters

Description

Variables

List of the variables and their properties.

Add variable

Opens the dialog for the variable selection in order to add one or more variables.

Remove variable

Selected variables are released from the screen.

Edit set value

The default set values for the variables of the screen can be changed. Set values can also be changed by clicking the cell with the set value.

Options

Base for display

Defines the display of the values in the Runtime.

Possible values:

  • Decimal
  • Hexadecimal
  • Binary
  • Octal
  • Decimal exponential

Refresh actual values on

Active: The actual values are updated when the window is called up in the Runtime.

Show this dialog in the Runtime

Active: Opens the dialog when the screen is opened in the Runtime.

info Information

You can change the columns (displayed text, column type and column width) by right-clicking the column header. You can find the setting for this in the context menu. They are transferred from the Editor to the Runtime and can be changed their in the same name if necessary.


measuring unit conversion

Manual -> Variables -> measuring unit conversion

measuring unit conversion enables conversion and switching of base units into conversion units, for example meters into yards or meters into decimeters, centimeters and millimeters. A base unit contains the initial value for a conversion. The conversion measuring unit contains the converted value in relation to the base value. Both have a unit name. A Factor, a Offset and a Shift of the decimal point can be defined for conversion units, based on the relevant base unit.

A base unit can be selected when setting parameters for a variable. It is possible to switch between the different units during runtime using the Unit switching function.

tutorial License information

Part of the standard license of the Editor and Runtime.

Context menu Project manager

Menu item | Action
New base unit | Creates a new base unit.
Export XML all | Exports all entries as an XML file.
Import XML | Imports measuring units from an XML file.
Help | Opens online help.

info Information

You must not use the unit conversion together with the variablerw Report function. This Report function provides a unit conversion for older projects. If the unit defined in the measuring unit conversion of a variable is changed by the report function in Runtime, you must carry out the configuration in the measuring unit conversion again.


Units detail view of toolbar and context menu

Manual -> Variables -> measuring unit conversion -> Units detail view of toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Context menu units detail view

Menu item | Action
New base unit | Creates a new base unit.
Export XML all | Exports all entries as an XML file.
Import XML | Imports measuring units from an XML file.
Help | Opens online help.

Context menu and tool bar base unit/conversion unit

Menu item | Action
New base unit | Creates a new base unit.
New conversion unit | Creates a new conversion unit for the superordinate base unit.
Linked elements: Jump back to starting element | Drop-down list with link back to the element from which you can reach the measuring unit. Only available if the unit is linked to another element.
Rename | Makes it possible to rename the unit. Attention: If units are renamed, all measuring units that are already linked to variables or used in functions must then have the respective variable or command amended manually. See also: Allocate a base unit to a variable Measuring Unit conversion function.
Export XML all | Exports all entries as an XML file.
Import XML | Imports measuring units from an XML file.
Copy | Copies the selected entries to the clipboard.
Paste | Pastes the contents of the clipboard. If an entry with the same name already exists, the content is pasted as "Copy of".
Delete | Deletes selected entries.
Help | Opens online help.


Engineer measuring units

Manual -> Variables -> measuring unit conversion -> Engineer measuring units

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You must create a base unit and a conversion unit for the conversion, as well as defining the parameters for conversion. The conversion is carried out using the formula y=kx+d (Austria) or y=mx+b (Germany). Each base unit can be allocated to a variable as a measuring unit.

To create a new base unit:

  • select the measuring units node in Project Manager
  • right-click on measuring units
  • select the New base unit command from the context menu
  • a new entry is created in the list
  • give the measuring unit a name
  • create the conversion unit

To create a new conversion unit:

  • right-click on a base unit
  • select the Conversion unit command from the context menu
  • a new entry is created in the list
  • give the unit a name
  • define a Factor for the conversion
  • define a value for the Shift of the decimal point
  • define a value for the Offset


Allocate a base unit to a variable

Manual -> Variables -> measuring unit conversion -> Allocate a base unit to a variable

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Base units are allocated to a variable in the Measuring unit property (General node).

You are free to name units as you wish here. If the measuring unit conversion is used during runtime, select a pre-defined basis unit from the drop-down list.

Hint: If you give it a name of your choice, it is best to create a link with the same name straight away in Node units - the basic unit.

You must create a Unit conversion function in order to be able to convert during runtime.

attention Attention

If a measuring unit is subsequently renamed, variables already linked to this are not automatically renamed.

To rename measuring units already linked:

  • select detail view in Project Manager
  • select the measuring units column or add this to the view if it is still displayed
  • in the context menu, select the Text command in Replace selected column
  • In the opening dialog, search by name and replace it with the new name


Function measuring unit conversion

Manual -> Variables -> measuring unit conversion -> Function measuring unit conversion

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to carry out measuring unit conversion in the Runtime, create function unit conversion:

  • select the Functions node in Project Manager
  • in the context menu, select the command New function...
  • navigate to the variable
  • Select the measuring unit conversion function

    Note: The execution of function Unit conversion triggers a refresh of the report if it is displayed at the moment.

  • The dialog for the definition of the measuring unit conversion opens.

Property | Description
Unit conversion | Dialog for the allocation of conversion units to basic units.
Base unit | List of the created basic units.
Switch to | Drop-down list for the selection of the conversion unit. You can either select a conversion unit or the basic unit. Engineered conversion unit: In the Runtime the basic unit is converted to the conversion unit. <Base unit>: The basic unit is still active in the Runtime.

info Information

The units are not exported with the XML export of this function. You must export the units separately.

attention Attention

If a measuring unit is renamed afterwards, the renamed basic unit is automatically taken into consideration in the function. However you must change the conversion units manually.


Runtime

Manual -> Variables -> measuring unit conversion -> Runtime

Each variable value for each input or output in addition to those used as standard when converting signal units to measuring range units is converted in runtime.

  • Output: A conversion unit for a variable is activated with the Unit switch function. The value in measuring units is subject to the pre-defined offset and factor. In addition, to convert the value into a string, the number of decimals set for a variable is corrected accordingly.
  • Input The conversion is carried out along the lines of output in the other direction.

Limitations:

  • At the export the new units are exported.
  • Values that are saved as a string are not recalculated for output. These values remain in the measuring unit that was active at the time of creating the string. This particularly affects all values inserted into the text of a CEL entry, such as "Set value changed from OLD to NEW" etc.
  • Operating hours and operations counters in Industrial Maintenance Manager are always displayed in base units here.
  • Outputs in the EMS screen are always displayed in the base unit.

VBA

Values above VBA are always accessed in base units. For example, Variable.Value does not provide a value with units switched, because it is not a value output. 4 new functions have been incorporated into Variable. so that unit switching can also be used above VBA:

Keyword | Description
SecondaryUnitName | gives the name of the conversion unit set
SecondaryUnitDigits | gives the decimals for the conversion unit set
CalcSecondaryUnitValue | converts the value of the base unit into the value of the conversion unit
CalcPrimaryUnitValue | converts the value of the conversion unit into the value of the base unit


Wizards

Manual -> Wizards

In order to be able to handle recurring tasks in the engineering phase easily and expeditiously, zenon offers wizards for different fields of engineering.

Users can also create their own wizards.

tutorial License information

Part of the standard license of the Editor and Runtime.

Start wizards

To start a wizard:

  • Select, in the File drop-down list, Wizards ...

    or

  • press the short cut Alt+F12

The wizard for project creation is automatically offered when a new project is created.

Settings zenon6.ini

For wizards to be displayed, the settings for VBA and/or VSTA must be set correctly in file zenon6.ini:

[VBA]

EIN=1

[VSTA]

ON=1

If VSTA wizards are not displayed although the settings are correct, set entry LOADED= to 1 in area [VSTA].


Topics

Manual -> Wizards -> Topics

The following wizards are available in zenon:

  • Analyzer
    • Export Wizard for Analyzer 2.10
    • Export Wizard for Analyzer 2.20
    • Meaning and Waterfall Chart Wizard
    • Sankey Wizard
  • Export - Import
    • FactoryLink Import Wizard
    • PDiag import wizard
    • WinCC Import Wizard
    • XML export wizard
    • XML Import Wizard
  • Language Table
    • Language Table Wizard
    • Language Translation Wizard
    • System Text Wizard VSTA
  • Meterin Point Administration Wizard
    Metering point administration is a tool to manage technical data and administer metering points.
  • Pharmaceutical
    • Pharmaceutical Wizard
  • Project
    • Backup Comparison Wizard
    • Documentation wizard
    • Project Wizard
  • Variables
    • Variable creation wizard
    • Driver Simulation
    • IEC850 Driver Configuration
  • Wizards VSTA
    • Demo Wizard: Empty template that can be amended individually.


Analyzer

Manual -> Wizards -> Topics -> Analyzer

The zenon Analyzer has wizards that support correct setting of parameters for the SCADA system and the export of data from the SCADA system. The zenon SCADA system is currently supported.

Wizards:

  • Export Wizard for Analyzer 2.10: supports the export of metadata from zenon for the zenon Analyzer, version 2.10.
  • Export Wizard for Analyzer 2.20: supports the export of metadata from zenon for the zenon Analyzer, version 2.20.
  • Meaning and Waterfall Chart Wizard: Helps you prepare a zenon project for the processing of variable information in zenon Analyzer.
  • Analyzer Export Wizard: supports the export of metadata from zenon from version 7.10 SP0 for the zenon Analyzer.
  • Sankey Wizard: supports you when creating Sankey diagrams that you can see in the Runtime or which are used in zenon Analyzer.

The wizards for zenon Analyzer are automatically installed when installing zenon 7.20. The Analyzer Export Wizard has its own DLL. Meaning and Waterfall Chart Wizard and Sankey Wizard share a DLL. Installation and maintenance thus differ from other zenon wizards. Analyzer wizards are automatically kept up to date with the updates from zenon from version 7.20. The update can, if required, also be carried out manually via the build file contained in the zenon Analyzer installation medium for zenon from version 7.10. These wizards are not updated by means of the update mechanism of the zenon wizard. For details, see the Installation and Update chapter in the zenon Analyzer manual.

Syntax for inputs in zenon

Input in in zenon depends on the version of zenon that is used.

Up to zenon 7.11

Up to and including zenon version 7.11, the meaning and waterfall model is entered in the zenon Resources label property. These can contain meanings for several categories.

The following is applicable to entries in the resource label property:

  • Categories are separated by a semicolon (;).
  • Areas within a category are separated by a comma (,).
  • Categories are marked by an index:
    • ME=: Identifies a (Meaning).
      Syntax: ME=[main meaning as text],[additional meaning as text],[additional meaning as text],…;
      Example: ME=Station_1,Station_2;
    • WF=: Identifies a variable for the waterfall display.
      Syntax: WF=[model name text],[line index INT],[index in column INT],[color code as text #XXXXXX];
    • Every other entry is also understood as a Meaning

Complete syntax for the Resources label property: ME=[meaning1],[meaning2],…,[meaningN];WF=[model name],[row index],[index in row],[color code];

Attention: The Resources label property is limited to 256 characters in the zenon Editor.

From zenon 7.20

From zenon 7.20, there are separate properties in zenon for the definition of Meaning and waterfall, as well as the input of a display name. These entries do not need an identification in front of them.

The following properties in the zenon Analyzer variable properties group provide information for reports in the zenon Analyzer:

  • Visual name: Entry of a display name of the variable in zenon Analyzer. This must be unique in the project. The check is not carried out when issued in zenon, but when imported into zenon Analyzer. If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.
  • Meaning: Entry of the (Meaning) of a variable in the zenon Analyzer. Entry is manual or by means of the Meaning and Waterfall Chart Wizard. Several meanings are separated by a comma.
    Syntax:[Meaning1],[Meaning2],…,[MeaningN]
  • Parameter for waterfall diagram: Parameters of a variable for a waterfall diagram in zenon Analyzer. Entry is manual or by means of the Meaning and Waterfall Chart Wizard. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
    Syntax: [model name],[row index],[index in row],[color code];

Attention: All these input fields are limited to 256 characters in the zenon Editor.

  • When exporting to zenon Analyzer, both the previous property and the new one are checked. If both are assigned, the entries of the new properties are taken on. Entries that are created using the Meaning and Waterfall Chart Wizard are always entered into the new properties.


Export Wizard for Analyzer 2.10

Manual -> Wizards -> Topics -> Analyzer -> Export Wizard for Analyzer 2.10

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon Export Wizard for Analyzer 2.10 supports the export of metadata from zenon from version 7.10 SP0 for the zenon Analyzer 2.10.

The following can be exported:

  • Data from the global project
    • Equipment models
    • Alarm/event classes
    • Alarm/event groups
    • User
  • Data from selected projects:
    • Archives
    • Variables

Note: The wizard is only available in English.

Compatibility:

The Analyzer Export Wizard works with zenon from version 7.10 SP0. There is a separate wizard available for each supported version of zenon.

Other topics in this chapter

Install and call up wizard

Start window

Configuration

Close wizard


Install and call up wizard

Manual -> Wizards -> Topics -> Analyzer -> Export Wizard for Analyzer 2.10 -> Install and call up wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The wizard is automatically installed with zenon for each supported version of zenon Analyzer.

Starting the wizard

For wizards to be displayed, the settings for VBA and/or VSTA must be set correctly in file zenon6.ini:

[VBA]

EIN=1

[VSTA]

ON=1

If VSTA wizards are not displayed although the settings are correct, set entry LOADED= to 1 in area [VSTA].

To start the wizard:

  1. in zenon open menu File
    or press the shortcut Alt+F12
  2. select the entry Wizards...
  3. the selection dialog is opened
  4. navigate to the Analyzer node
  5. select the Analyzer Export Wizard

    Screenshots - Expanding

  6. Start the wizard by clicking on OK


Start window

Manual -> Wizards -> Topics -> Analyzer -> Export Wizard for Analyzer 2.10 -> Start window

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When the wizard is opened, you receive an overview page that lists all exportable objects.

The individual objects are configured for the export on individual tabs.

Click on the button with the arrow to navigate through the configuration of the export.


Configuration

Manual -> Wizards -> Topics -> Analyzer -> Export Wizard for Analyzer 2.10 -> Configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When exporting with the Analyzer Export Wizard, all modules selected in the Settings tab are offered in sequence for detailed configuration. You get to the next level by clicking on the button with the right arrow. You can select individual tabs directly by clicking on the title of the tab.

The following tabs are available for configuration of the export:

  • Settings: Options for collection metadata
  • Equipment model: Export of the model groups from the global project
  • Event classes: Alarm/Event classes from global project
  • Event Event groups: Alarm/event groups from global project
  • Users: User from global project
  • Projects. Projects from workspace
  • Historian: Archives of the selected projects
  • Variables: Variables of the selected projects
  • Finish: Start of the export and output of the result

Attention: Only one global project can be exported to the database! Workspaces with projects that are to be exported to the database must include this global project.

Other topics in this chapter

Navigation

Settings

Equipment model

Alarm/event classes

Event groups

Users

Projects

Historian

Variables

Finish


Navigation

Navigation

Navigation through the tabs is carried out by means of the navigation bar in the lower area of the wizard window:

Button

Description

Arrow left

Goes back one tab in the wizard process.

Arrow right

Goes forward one tab in the wizard process.

Export

Exports the data to the Analyzer database.

Is only active if the Finish tab is opened.

Cancel

Closes the wizard without exporting.

When closing, a dialog asks if the configuration is to be saved

  • Yes: writes the settings configured in the Settings tab to the registry and closes the wizard; the wizard is opened with these settings the next time it is restarted
  • No: closes the wizard without saving the configuration

The configuration is saved for each specific user.

Individual tabs can also be selected by clicking directly on the title of the tab.


Settings

Settings

In this tab:

  1. You define the database to which the wizard connects
  2. You define general options for exporting
  3. You start the data readout

Parameters

Description

Settings

Information and hints about current export processes.

Database settings

Connection settings to the Analyzer server.

DB host

Computer on which the database is located.

DB instance

Instance of the database.

DB name

Name of the database.

Authentication

Type of authentication:

  • Windows Authentication: Windows login information is used.
  • SQL Server Authentication: Login with data from an SQL server user.

User name

Entry of the user name.

Only for login with SQL Server Authentication. Display only with Windows Authentication.

Password

Entry of the password.

Only for login with SQL Server Authentication. No input possible with Windows Authentication.

Remember password

Password is saved for next connection.

Only for login with SQL Server Authentication. Inactive for Windows Authentication.

Options

General options for the export.

Load every project of this workspace into the memory

Active: Loads all projects present in the workspace, even if they are not active and not set to Keep project in memory.

Keep the existing data in the Analyzer database

Active: Only entries from the workspace are written to the database.

Inactive: Entries in the database are also updated or deleted.
Exception: Projects are not deleted

Preselect existing Analyzer database content

Active: Entries already present in the database are preselected in the individual areas.

Load Data

Load Data

Clicking on the button loads, depending on the Load every project of this workspace into the memory parameter - the data from the currently loaded project into the wizard.

In doing so, a check is made to see if data is present in the Analyzer database. Pre-existing data is combined with the data from the workspace and loaded into the wizard. In the event of naming conflicts, a dialog to rectify the error is called up.

If the loading of data has been successfully concluded, the export can be configured in the following tabs.

Renaming objects

Objects must always be named the same in the Analyzer database and in zenon. If objects that are already present in the database are renamed in zenon, these changes can be accepted or rejected when the data is combined. Rejection of the changes leads to the wizard being closed, because only objects with identical names can be handled correctly.

Dialog for renaming

In the event of conflicts in the naming of objects, a dialog for dealing with the error is opened:

Parameters

Description

List of amended objects

Contains all objects that were changed. Previous name and new name are displayed. The following renamed objects are displayed in the list:

  • Name of the equipment models
  • Names of the alarm/event classes
  • Names of the alarm/event groups
  • Project name
  • Variable name

Exceptions:

  • Users are always recreated
  • Archive names are only created once in the database as a visual name and can be overwritten in the zenon Analyzer

Rename

Renames all objects listed in the database, closes the dialog and stops reading in data.

Cancel

Leaves the previous name in the database, finishes reading in data and closes the wizard.


Equipment model

Equipment model

Configuration of the model group which should be exported from the global project.

attention Attention

Each equipment group in zenon may only be assigned to one individual time model.

If several time model groups are assigned, the Analyzer Wizard Export uses the first that it finds and exports this to the metadata of the Analyzer. Other time model groups are ignored.

Parameters

Description

Equipment modeling

Information and notes on exporting.

Selection of equipment/medium

Drop-down list to select what is offered in List of equipment models/media for configuration:

  • Plant: displays equipment models
  • Media: displays media

List of equipment models/media

List field with the possibility to select equipment models and model groups or media. To select an entry, activate the check box in front of the entry.

In the list field the name, as it is stored in the database, is always displayed in the individual nodes. If the name was changed, the original name from the zenon project is displayed in brackets.

Equipment groups that were deleted in the global project are no longer displayed.

If, in the Settings tab, the option Keep the existing data in the Analyzer database was selected, amended objects in the database are deleted or updated.

Select all

Clicking on the button selects all equipment groups

Deselect all

Clicking on the button deselects all equipment groups.


Alarm/event classes

Alarm/event classes

Configuration of the alarm/event classes which should be exported from the global project.

Parameters

Description

Alarm/event classes

Information and notes on exporting.

List of the alarm/event classes

List field with the possibility to select the alarm/event classes. To select an entry, activate the check box in front of the entry.

Sorting: Clicking on the column identifier sorts the entries after this column upwards or downwards.

Multiple selection: If several rows are highlighted, a click in the check box sets the options for all selected rows.

Alarm/event classes that were deleted in the global project are no longer displayed here.

If, in the Settings tab, the option Keep the existing data in the Analyzer database was selected, amended objects in the database are deleted or updated.

Select all

Selects all entries in the list and activates the checkboxes.

Deselect all

Selects all entries in the list and deactivates the check boxes.


Event groups

Event groups

Configuration of the alarm/event groups which should be exported from the global project.

Parameters

Description

Alarm/event groups

Information and notes on exporting.

List of the alarm/event groups

List field in which you can select alarm/event groups. To select an entry, activate the check box in front of the entry.

Sorting: Clicking on the column identifier sorts the entries after this column upwards or downwards.

Multiple selection: If several rows are highlighted, a click in the check box sets the options for all selected rows.

Alarm/event classes that were deleted in the global project are no longer displayed here.

If, in the Settings tab, the option Keep the existing data in the Analyzer database was selected, amended objects in the database are deleted or updated.

Select all

Selects all entries in the list and activates the checkboxes.

Deselect all

Selects all entries in the list and deactivates the check boxes.


Users

Users

Configuration of the user which should be exported from the global project.

Parameters

Description

Users

Information and notes on exporting.

User List

List field with selection possibility for users. To select an entry, activate the check box in front of the entry.

Sorting: Clicking on the column identifier sorts the entries after this column upwards or downwards.

Multiple selection: If several rows are highlighted, a click in the check box sets the options for all selected rows.

If, in the Settings tab, the option Keep the existing data in the Analyzer database was selected, amended objects in the database are deleted or updated.

If a user was renamed in zenon they are considered new and recreated in the project. The previous user is deleted.

Select all

Selects all entries in the list and activates the checkboxes.

Deselect all

Selects all entries in the list and deactivates the check boxes.


Projects

Projects

Configuration of the local projects which should be exported. The names for the server and standby-server can be changed here. To do this:

  1. Highlight the project in the list of projects
  2. Enter the desired name for the server and standby-server

If the name of the server or standby server is changed in the zenon project, then this is only updated in th analyzer database if the Network active setting was activated in the project properties.

Parameters

Description

Projects

Information and notes on exporting.

Project list

List field with selection possibility for projects. To select an entry, activate the check box in front of the entry.

Sorting: Clicking on the column identifier sorts the entries after this column upwards or downwards.

Multiple selection: If several rows are highlighted, a click in the check box sets the options for all selected rows.

If, in the Settings tab, the option Keep the existing data in the Analyzer database was selected, amended objects in the database are deleted or updated.

Server

Address of the server for the project selected in the list window.

Standby

Address of the server for the project selected in the list window.

Select all

Selects all entries in the list and activates the checkboxes.

Deselect all

Selects all entries in the list and deactivates the check boxes.


Historian

Historian

Selection of the archive from the selected projects. Only base archives are displayed. Aggregated archives are not displayed in the list, but are also selected with the base archives and written to the database.

Parameters

Description

Historian

Information and notes on exporting.

Archive list

List field with possibility to select for archives. To select an entry, activate the check box in front of the entry.

Sorting: Clicking on the column identifier sorts the entries after this column upwards or downwards.

Multiple selection: If several rows are highlighted, a click in the check box sets the options for all selected rows.

If, in the Settings tab, the option Keep the existing data in the Analyzer database was selected, amended objects in the database are deleted or updated.

Select all

Selects all entries in the list and activates the checkboxes.

Deselect all

Selects all entries in the list and deactivates the check boxes.


Variables

Variables

Configuration of the variables from the local project which should be exported. When selecting variables, the entries offered can be prefiltered.

Parameters

Description

Variables

Information and notes on exporting.

Variable Filter

Selection of the variable filter using the following option fields:

  • Show all: All variables are displayed.
  • Historians only: Only archive variables are displayed.
  • Equipment groups only: Only variables are displayed which are part of the selected Equipment model.
  • Show not selected only: Only variables that were not selected are displayed.

Filter row

Input of alphanumerical characters according to which the List of variables is to be filtered.

List of variables

List field with possibility to select variables. To select an entry, activate the check box in front of the entry.

Sorting: Clicking on the column identifier sorts the entries after this column upwards or downwards.

Multiple selection: If several rows are highlighted, a click in the check box sets the options for all selected rows.

If, in the Settings tab, the option Keep the existing data in the Analyzer database was selected, amended objects in the database are deleted or updated.

Select all

Selects all entries in the list and activates the checkboxes.

Deselect all

Selects all entries in the list and deactivates the check boxes.

Rules for the export of variables with reaction matrices

If linked variables are exported with reaction matrices, the limit value text and the status value of the reaction matrix statuses are also exported to the STATUSNAME table in the metadata database of the Analyzer. Because only certain states can be evaluated in the reports, they must be pre-sorted using the wizard.

The following statuses of the reaction matrices can be exported or excluded:

Rema

Rules

Numeric
  • The default status is ignored.
  • If several statuses with the same status and limit value condition are set, then only the first status and its status text are exported.
  • Only statuses with a value that is equal to a limit value are exported (limit value condition).
  • The limit value conditions greater than, less than, as desired and range are ignored.

Multi numeric
  • Correspond to the rules for numeric.
  • Substatuses are also ignored.

Binary

  • Only statuses that have value bits set consistently from right to left in the bit mask (0 or 1) are set.
    For example:
    ........ ....10.. 1
    ........ .....100 .
    ........ .....100 1
    The following are ignored, for example
    ........ ........ 1
    ........ ......00 1
    ........ .10..100 1

Multi binary
  • Correspond to the rules for Binary.
  • In addition, substatuses and statuses are also ignored with edge definitions in the bit mask.

String

  • Are completely ignored and not exported.


Finish

Finish

To export the configured data:

  1. In the Finish tab, click on the Export button

  2. the export is started
  3. The exported elements are shown in the output window with the attendant success and error messages
    In addition, the number of objects that have been added, replaced or deleted, and the number of errors that occurred are shown.

  4. Click on Close to close the wizard

Reconfiguring the wizard

To reconfigure the wizard:

  1. Open the Settings tab
  2. click on button Load data
  3. Configure the tabs


Close wizard

Manual -> Wizards -> Topics -> Analyzer -> Export Wizard for Analyzer 2.10 -> Close wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To close the wizard:

  • Click on the Cancel button
  • a dialog prompts whether the configuration should be saved
    • Clicking on Yes writes the settings configured in the Settings tab to the registry and closes the wizard; the wizard is opened with this configuration next time it is started
    • Click on No closes the wizard and the configuration is not saved.


Export Wizard for Analyzer 2.20

Manual -> Wizards -> Topics -> Analyzer -> Export Wizard for Analyzer 2.20

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon Analyzer Export Wizard 2.20 supports the export of metadata from zenon from version 7.0 SP0 for the zenon Analyzer 2.20.

The following can be exported:

  • Data from the global project
    • Equipment models
    • Alarm/event classes
    • Alarm/event groups
    • User
  • Data from selected projects:
    • Archives
    • Variables, with:

      - Visual name (see visual names section)

      - Meaning (see meaning section)

      - Parameter for waterfall diagram (see parameter waterfall chart section)

  • Sankey diagrams (see Sankey charts section)

Note: The wizard is only available in English.

Compatibility:

The Analyzer Export Wizard works with zenon from version 7.10 SP0. There is a separate wizard available for each supported version of zenon.

Other topics in this chapter

Sankey diagrams

Install and call up wizard

Start window

Configuration

Close wizard


Sankey diagrams

Manual -> Wizards -> Topics -> Analyzer -> Export Wizard for Analyzer 2.20 -> Sankey diagrams

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The wizard automatically reads the definition for Sankey diagrams from all activated projects and the global project. These are in the zenon project folder \Files\Others.
In doing so, the following applies:

  • Only valid XML files that were created for the zenon Analyzer are taken into account.
    Diagrams that have the Trueand Valid attributes set to True in the Sankey XML file are valid. All other Sankey diagrams are ignored and not loaded.
  • All Sankey diagram definitions are written to the zenon Analyzer metadata database in the SANKEY_DIAGRAMM tables, SANKEY_OBJECT and SANKEY_VARIABLE. .
  • Diagrams are added depending on the setting for the Keep the existing data in the Analyzer database option:
    • Active: Only new diagrams are added to the Analyzer database.
    • Inactive: New diagrams are added and existing diagrams are updated.
  • Diagrams deleted in zenon (XML files) are not deleted in the Analyzer. Diagrams can only be deleted in the database directly in zenon Analyzer.
  • For the adding or updating of diagrams, the following must apply to all required zenon variables:
    • Be selected via the Variables tab
      or
    • already be in the database

    If variables that are required for the Sankey diagram are not selected for export, the Sankey diagram is not exported.

  • If the Sankey diagram already exists, the metadata database tables are updated according to the changes.
  • Clicking on the Export button in the Finish tab starts the export of the Sankey diagrams from zenon in to zenon Analyzer.
    The diagrams are only exported once all other data such as projects or variables have been exported. The success of the export is shown in the message list of the Finish tab.

attention Attention

The import of Sankey diagrams is carried out automatically in the background. There are no user interface or configuration options available.


Install and call up wizard

Manual -> Wizards -> Topics -> Analyzer -> Export Wizard for Analyzer 2.20 -> Install and call up wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The wizard is automatically installed with zenon for each supported version of zenon Analyzer.

Starting the wizard

For wizards to be displayed, the settings for VBA and/or VSTA must be set correctly in file zenon6.ini:

[VBA]

EIN=1

[VSTA]

ON=1

If VSTA wizards are not displayed although the settings are correct, set entry LOADED= to 1 in area [VSTA].

To start the wizard:

  1. In zenon open menu File
    or press the shortcut Alt+F12
  2. Select the entry Wizards.
  3. The selection dialog is opened
  4. Navigate to the Analyzer node
  5. Select the desired version of the Analyzer Export Wizard.

    Screenshots - Expanding

  6. Start the wizard by clicking on OK


Start window

Manual -> Wizards -> Topics -> Analyzer -> Export Wizard for Analyzer 2.20 -> Start window

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When the wizard is opened, you receive an overview page that lists all exportable objects.

The individual objects are configured for the export on individual tabs.

Click on the button with the arrow to navigate through the configuration of the export.


Configuration

Manual -> Wizards -> Topics -> Analyzer -> Export Wizard for Analyzer 2.20 -> Configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When exporting with the Analyzer Export Wizard, all modules available for export are offered for detailed configuration. Only the selected data is exported. The export of Sankey diagrams is carried out in the background, without the possibility of configuration. You get to the next level by clicking on the button with the right arrow. You can also select individual tabs directly by clicking on the title of the tab.

The following tabs are available for configuration of the export:

  • Settings: Options for the export of metadata
  • Equipment models: Export of the equipment groups from the global project
  • Event classes: Alarm/Event classes from global project
  • Event groups: Alarm/event groups from global project
  • Users: User from global project
  • Projects. Projects from workspace
  • Archives: Archives of the selected projects
  • Variables: Variables of the selected projects
  • Finish: Start of the export and output of the result

Other topics in this chapter

Navigation

Settings

Equipment models

Alarm/event classes

Event groups

Users

Projects

Archives

Variables

Finish


Navigation

Navigation

Navigation through the tabs is carried out by means of the navigation bar in the lower area of the wizard window:

Button

Description

Arrow left

Goes back one tab in the wizard process.

Arrow right

Goes forward one tab in the wizard process.

Export

Exports the data to the Analyzer database.

Is only active if the Finish tab is opened.

Cancel

Closes the wizard without exporting.

When closing, a dialog asks if the configuration is to be saved

  • Yes: Writes the settings set in the Settings tab to the registry and closes the wizard. The wizard is opened with this configuration the next time it is started.
  • No: Closes the wizard without saving the configuration

The configuration is saved for each specific user.

Individual tabs can also be selected by clicking directly on the title of the tab.


Settings

Settings

In this tab:

  1. You define the database to which the wizard connects
  2. You define general options for exporting
  3. You start the data readout

Settings

Parameters | Description
Settings | Information and hints about current export processes.

Database settings

Parameters

Description

Database settings

Connection settings to the Analyzer server.

DB host

Computer on which the database is located.

DB instance

Instance of the database.

DB name

Name of the database.

Authentication

Type of authentication:

  • Windows Authentication: Windows login information is used.
  • SQL Server Authentication: Login with data from an SQL server user.

User name

Entry of the user name.

Only for login with SQL Server Authentication.
Display only for Windows Authentication.

Password

Entry of the password.

Only for login with SQL Server Authentication.
No input possible with Windows Authentication.

Remember password

Password is saved for next connection.

Only for login with SQL Server Authentication.
Inactive with Windows Authentication.

Projects

Parameters

Description

Projects

List of the available projects in the current zenon workspace. The checkbox shows whether the data of the project is used:

  • Active: Project is used.

Projects that are active in the memory are pre-selected. Inactive projects can be added by means of selection with a checkbox.

Options

Parameters

Description

Options

General options for the export.

Keep the existing data in the Analyzer database
  • Active: Only completely new entries from the workspace are written to the database.
    Note: If linkings from variables, archives etc. are changed or new ones are created, these are not transferred. If these are also transferred, the checkbox must be set to Inactive
  • Inactive: Entries in the database are also updated or deleted. New entries are created, amended entries are updated and deleted entries are removed.
    Exception: Projects and Sankey diagrams are not deleted.

Preselect existing Analyzer database content
  • Active: Entries already present in the database are preselected in the individual areas.

Load Data

Load Data

Clicking on the button loads, depending on the Load every project of this workspace into the memory parameter - the data from the currently loaded project into the wizard.

In doing so, a check is made to see if data is present in the Analyzer database. Pre-existing data is combined with the data from the workspace and loaded into the wizard. In the event of naming conflicts, a dialog to rectify the error is called up.

If the loading of data has been successfully concluded, the export can be configured in the following tabs.

Renaming objects

Objects must always be named the same in the Analyzer database and in zenon. If objects that are already present in the database are renamed in zenon, these changes can be accepted or rejected when the data is combined. Rejection of the changes leads to the wizard being closed, because only objects with identical names can be handled correctly.

Dialog for renaming

In the event of conflicts in the naming of objects, a dialog for dealing with the error is opened:

Parameters

Description

List of amended objects

Contains all objects that were changed. Previous name and new name are displayed. The following renamed objects are displayed in the list:

  • Name of the equipment models
  • Names of the alarm/event classes
  • Names of the alarm/event groups
  • Project name
  • Variable name

Exceptions:

  • Users are always recreated
  • Archive names are only created once in the database as a Visualname and can be overwritten in the zenon Analyzer

Rename

Renames all objects listed in the database, closes the dialog and stops reading in data.

Cancel

Leaves the previous name in the database, finishes reading in data and closes the wizard.


Equipment models

Equipment models

Configuration of the model group which should be exported from the global project.

attention Attention

Each equipment group in zenon may only be assigned to one individual time model.

If several time model groups are assigned, the Analyzer Wizard Export uses the first that it finds and exports this to the metadata of the Analyzer. Other time model groups are ignored.

Parameters

Description

Equipment models

Information and notes on exporting.

Selection of equipment/medium

Drop-down list to select a model that is offered in the Equipment models/media list for configuration.

List of equipment models/media

List field with the possibility to select equipment models and model groups or media. To select an entry, activate the check box in front of the entry.

In the list field the name, as it is stored in the database, is always displayed in the individual nodes. If the name was changed, the original name from the zenon project is displayed in brackets.

Equipment groups that were deleted in the global project are no longer displayed.

If, in the Settings tab, the Keep the existing data in the Analyzer database option is deselected, amended objects in the database are deleted or updated.

Select all

Clicking on the button selects all equipment groups

Deselect all

Clicking on the button deselects all equipment groups.


Alarm/event classes

Alarm/event classes

Configuration of the alarm/event classes which should be exported from the global project.

Parameters

Description

Event classes

Information and notes on exporting.

List of the alarm/event classes

List field with the possibility to select the alarm/event classes. To select an entry, activate the check box in front of the entry.

Sorting: Clicking on the column identifier sorts the entries after this column upwards or downwards.

Multiple selection: If several lines are highlighted, the selection applies for all selected lines.

Alarm/event classes that were deleted in the global project are no longer displayed here.

If, in the Settings tab, the Keep the existing data in the Analyzer database option is deselected, amended objects in the database are deleted or updated.

Select all

Selects all entries in the list and activates the checkboxes.

Deselect all

Selects all entries in the list and deactivates the check boxes.


Event groups

Event groups

Configuration of the alarm/event groups which should be exported from the global project.

Parameters

Description

Event groups

Information and notes on exporting.

List of the alarm/event groups

List field in which you can select alarm/event groups. To select an entry, activate the check box in front of the entry.

Sorting: Clicking on the column identifier sorts the entries after this column upwards or downwards.

Multiple selection: If several lines are highlighted, the selection applies for all selected lines.

Alarm/event classes that were deleted in the global project are no longer displayed here.

If, in the Settings tab, the Keep the existing data in the Analyzer database option is deselected, amended objects in the database are deleted or updated.

Select all

Selects all entries in the list and activates the checkboxes.

Deselect all

Selects all entries in the list and deactivates the check boxes.


Users

Users

Configuration of the user which should be exported from the global project.

Parameters

Description

Users

Information and notes on exporting.

User List

List field with selection possibility for users. To select an entry, activate the check box in front of the entry.

Sorting: Clicking on the column identifier sorts the entries after this column upwards or downwards.

Multiple selection: If several lines are highlighted, the selection applies for all selected lines.

If, in the Settings tab, the Keep the existing data in the Analyzer database option is deselected, amended objects in the database are deleted or updated.

If a user was renamed in zenon they are considered new and recreated in the project. The previous user is deleted.

Select all

Selects all entries in the list and activates the checkboxes.

Deselect all

Selects all entries in the list and deactivates the check boxes.


Projects

Projects

Configuration of the local projects which should be exported. The names for Server 1 and Server 2 can be changed here.

To change the name of a Server or Standby Server:

  1. Highlight the project in the list of projects.
  2. Enter the desired name for Server 1 and Server 2.

If the name of Server 1 or Server 2 is changed in the zenon project, then this is only updated in th analyzer database if the Network active setting was activated in the project properties.

Parameters

Description

Projects

Information and notes on exporting.

Project list

List field with selection possibility for projects. To select an entry, activate the check box in front of the entry.

Sorting: Clicking on the column identifier sorts the entries after this column upwards or downwards.

Multiple selection: If several lines are highlighted, the selection applies for all selected lines.

If, in the Settings tab, the Keep the existing data in the Analyzer database option is deselected, amended objects in the database are deleted or updated.

Server 1

Address of the Server 1 for the project selected in the list window.

Server 2

Address of the Server 2 for the project selected in the list window.

Select all

Selects all entries in the list and activates the checkboxes.

Deselect all

Selects all entries in the list and deactivates the check boxes.


Archives

Archives

Selection of the archive from the selected projects. Only base archives are displayed. Aggregated archives are not displayed in the list, but are also selected with the base archives and written to the database.

Parameters

Description

Archives

Information and notes on exporting.

Archive list

List field with possibility to select for archives. To select an entry, activate the check box in front of the entry.

Sorting: Clicking on the column identifier sorts the entries after this column upwards or downwards.

Multiple selection: If several lines are highlighted, the selection applies for all selected lines.

If, in the Settings tab, the Keep the existing data in the Analyzer database option is deselected, amended objects in the database are deleted or updated.

Select all

Selects all entries in the list and activates the checkboxes.

Deselect all

Selects all entries in the list and deactivates the check boxes.


Variables

Variables

Configuration of the variables to be exported from the selected local projects. When selecting variables, the entries offered can be prefiltered.

Parameters

Description

Variables

Information and notes on exporting.

Display

Selection of which variables are displayed, via the following option fields:

  • All: All variables are displayed.
  • Selected: Only variables that have already been selected are displayed.
  • Unselected: Only variables that have not yet been selected are displayed.

Variable filter

Selection of the variable filter using the following option fields:

  • All: All variables are displayed.
  • Archives: Only archive variables are displayed.
  • Equipment groups: Only variables are displayed which are part of the selected Equipment model.

Filter row

Input of alphanumerical characters according to which the List of variables is to be filtered.

List of variables

List field with possibility to select variables. To select an entry, activate the check box in front of the entry.

The following are displayed:

  • Name (Analyzer): Name in zenon Analyzer.
  • Name (Workspace): Can be issued from zenon 7.20 in the Editor by means of the Visual name property. Must be unique in the project. See also chapter Visual name
  • Meaning: Can be issued from zenon 7.20 in the Editor by means of the Meaning property. See also chapter Meaning
  • Ressource label:corresponds to the Resources label property in zenon. Is used for zenon up to and including version 7.11 for meaning and parameter waterfall diagram. From version 7.20, there are separate properties available for this in zenon.
  • Identification: It corresponds to the Identification property in zenon.

Sorting: Clicking on the column identifier sorts the entries after this column upwards or downwards.

Multiple selection: If several lines are highlighted, the selection applies for all selected lines.

If, in the Settings tab, the Keep the existing data in the Analyzer database option is deselected, amended objects in the database are deleted or updated.

Select all

Selects all entries in the list and activates the checkboxes.

Deselect all

Selects all entries in the list and deactivates the check boxes.

Rules for the export of variables with reaction matrices

If linked variables are exported with reaction matrices, the limit value text, the limit value color and the status value of the reaction matrix statuses are also exported to the STATUSNAME table in the metadata database of the Analyzer. Because only certain states can be evaluated in the reports, they must be pre-sorted using the wizard.

The following statuses of the reaction matrices can be exported or excluded:

Rema

Rules

Numeric
  • The default status is ignored.
  • If several statuses with the same status and limit value condition are set, then only the first status and its status text are exported.
  • Only statuses with a value that is equal to a limit value are exported (limit value condition).
  • The limit value conditions greater than, less than, as desired and range are ignored.

Multi numeric
  • Correspond to the rules for numeric.
  • Substatuses are also ignored.

Binary

  • Only statuses that have value bits set consistently from right to left in the bit mask (0 or 1) are set.
    For example:
    ........ ....10.. 1
    ........ .....100 .
    ........ .....100 1
    The following are ignored, for example
    ........ ........ 1
    ........ ......00 1
    ........ .10..100 1

Multi binary
  • Correspond to the rules for Binary.
  • In addition, substatuses and statuses are also ignored with edge definitions in the bit mask.

String

  • Are completely ignored and not exported.

Import of variable information from zenon

The following properties in the zenon Analyzer variable properties group provide information for reports in the zenon Analyzer:

  • Visual name: Entry of a display name of the variable in zenon Analyzer. This must be unique in the project. The check is not carried out when issued in zenon, but when imported into zenon Analyzer. If this property is changed after the first export to a zenon Analyzer, these changes are not applied in the zenon Analyzer.
  • Meaning: Entry of the (Meaning) of a variable in the zenon Analyzer. Entry is manual or by means of the Meaning and Waterfall Chart Wizard. Several meanings are separated by a comma.
    Syntax:[Meaning1],[Meaning2],…,[MeaningN]
  • Parameter for waterfall diagram: Parameters of a variable for a waterfall diagram in zenon Analyzer. Entry is manual or by means of the Meaning and Waterfall Chart Wizard. The individual parameters are separated by a comma. Several waterfalls are divided by a semicolon.
    Syntax: [model name],[row index],[index in row],[color code];

Other topics in this chapter

Visual name

Meaning

Parameter waterfall diagram


Visual name

Visual name

The wizard reads the Analyzer/Visual name property when loading the zenon workspace from zenon 7.20 and displays this for each variable in the Variables tab. . The following applies for visual names:

  • The name must be unique for each project.
  • Names in a project that appear several tines are highlighted in red.
  • The Visual name are entered when writing the data to the metadata database.
  • In the event of duplicated name within a project, the Visual name is only entered for the first variable found. For the second variable, the Name of the variables is entered in zenon.
  • The Visual name is only set when the variable is exported for the first time. If this is subsequently changed in the Editor, this change is no longer applied in the metadata database. Changes are of course applied to a new metadata database when exporting to a new database.
  • With a version of zenon before 7.20, the visual name is always taken from the zenon Identification property.


Meaning

Meaning

From zenon 7.20, the wizard reads the Analyzer/Meaning property and displays this for each variable in the Variables tab. .
The following applies for meanings:

  • If there are entries for Meaning, the corresponding entries in the Resources label are ignored.
  • If there are no entries, corresponding entries from the Resources label are accepted.
  • The identification ME= is no longer necessary but can continue to be used. If a variable is assigned several meanings, a comma is used as a separator.
  • With a version of zenon before 7.20, the meaning is always taken from the zenon Resources label property.


Parameter waterfall diagram

Parameter waterfall diagram

The wizard reads the Analyzer/Parameter for waterfall diagram property when loading the zenon workspace from zenon 7.20 and displays this for each variable in the Variables tab. . The following applies for waterfall:

  • If there are entries for Parameter for waterfall diagram, the corresponding entries in the Resources label are ignored.
  • If there are no entries, corresponding entries from the Resources label are accepted.
  • The identification WF= is no longer necessary but can continue to be used. The individual elements of a model are separated by a comma. If several waterfall models are assigned to a variable, a semicolon is used as a separator.
  • With versions of zenon before 7.20, the waterfall parameters are always taken from the zenon Resources label property.


Finish

Finish

To export the configured data:

  1. In the Finish tab, click on the Export button .

  2. the export is started
  3. The exported elements are shown in the output window with the attendant success and error messages
    In addition, the number of objects that have been added, replaced or deleted, and the number of errors that occurred are shown.

  4. Click the Close button to close the wizard

Reconfiguring the wizard

To reconfigure the wizard:

  1. Open the Settings tab.
  2. Click on the Load data button.
  3. Configure the tabs.


Close wizard

Manual -> Wizards -> Topics -> Analyzer -> Export Wizard for Analyzer 2.20 -> Close wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To close the wizard:

  • Click on the Cancel button .
  • A dialog prompts whether the configuration should be saved.
    • Yes: Writes the settings set in the Settings tab to the registry and closes the wizard. The wizard is opened with this configuration the next time it is started. The configuration is saved for each specific user.
    • No: Closes the wizard without saving the configuration


Meaning and Waterfall Chart Wizard

Manual -> Wizards -> Topics -> Analyzer -> Meaning and Waterfall Chart Wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Meaning and Waterfall Chart Wizard helps you prepare a zenon project for the processing of variable information in the zenon Analyzer.

Note: The wizard is only available in English.

attention Attention

If the Multi-User is used with a project with distributed engineering (Multi-User), then Enable changes must be activated in the zenon Editor for:

  • The project (context menu of the project)
  • The variables (context menu of the variables or the Variables module)

Otherwise the changes made by the Meaning and Waterfall Chart Wizard cannot be applied. These are then discarded.

The Meaning and Waterfall Chart Wizard helps you, when engineering projects in zenon, to configure:

  • Meanings (Meaning)
  • Waterfall charts (Waterfall)

The wizard writes the configuration in the corresponding properties of the variables selected in the wizard. The target properties depend on the version of zenon that is used.

From zenon 7.20

  • Meanings:

    The Meanings are written in the Analyzer/Meaning property. Several entries are separated by a comma (,).

  • Waterfall:

    The parameters for waterfall diagrams are written in the Analyzer/Parameter for waterfall diagram property. The parameters for a diagram are separated by a comma (,). Several diagrams are separated by a semi colon (;)

The following applies for both properties: If there are still entries in the General/Resources label property from previous versions of zenon, these are deleted and entered in the corresponding properties for zenon 7.20.

Up to zenon 7.11:

Meanings and parameters for waterfall diagrams are written to the Resources label variable property. In doing so, the prefix WF= is added for meanings and the prefix WF= is added for waterfall parameters.

For further information, see the Analyzer Wizards chapter.

Other topics in this chapter

Install and call up wizard

Start window

Configuration


Install and call up wizard

Manual -> Wizards -> Topics -> Analyzer -> Meaning and Waterfall Chart Wizard -> Install and call up wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The wizard is automatically installed together with zenon.

Starting the wizard

For wizards to be displayed, the settings for VBA and/or VSTA must be set correctly in file zenon6.ini:

[VBA]

EIN=1

[VSTA]

ON=1

If VSTA wizards are not displayed although the settings are correct, set entry LOADED= to 1 in area [VSTA].

To start the wizard:

  1. In zenon open menu File
    or press the shortcut Alt+F12
  2. Select the entry Wizards
  3. The selection dialog is opened
  4. Navigate to node Analyzer.
  5. Select the Meaning and Waterfall Chart Wizard.

    Screenshots - Expanding

  6. Start the wizard by clicking on OK .


Start window

Manual -> Wizards -> Topics -> Analyzer -> Meaning and Waterfall Chart Wizard -> Start window

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When opening the wizard, you receive an overview that lists and explains all objects that can be configured. Configuration starts with the Settings tab..

Meaning

zenon variables often receive technically-orientated names in the project. This naming is often not meaningful enough for display in a zenon Analyzer report. The variables can be given an unique name for display in the zenon Analyzer report. This name is saved to the corresponding variable property depending on the zenon version. Target property and entry are automatically selected by the wizard.

After import into zenon Analyzer, this name is used for reports without the existing variable name needing to be changed. For details, see the Analyzer Wizards chapter in the online help.

Waterfall

Some zenon Analyzer reports can display a waterfall diagram using zenon variables. To do this, information on the appearance of the diagram must already be present in the resource label of the selected variable. The structure and appearance of a waterfall diagram can be defined with a wizard. The waterfall information is saved to the corresponding variable property depending on the zenon version. Target property and entry are automatically selected by the wizard. For details, see the Analyzer Wizards chapter in the online help.

Navigation

Click on the button with the arrow to navigate through the configuration of the export.


Configuration

Manual -> Wizards -> Topics -> Analyzer -> Meaning and Waterfall Chart Wizard -> Configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Meaning and Waterfall Chart Wizard is configured with the following tabs:

  • Settings: Loading the data from the projects.
    Only once the data to be loaded is selected are other tabs available for meanings and/or waterfall diagrams.
  • Meaning filter: Filter settings for meanings.
  • Meaning: Selection and assignment of the meanings.
  • Waterfall filter: Filter settings for waterfall.
  • Waterfall: Selection of variables for waterfall diagram.
  • Finish: Acceptance of configuration and configuration by the wizard.

Other topics in this chapter

Navigation

Settings

Meaning filter

Meaning

Waterfall filter

Waterfall

Finish


Navigation

Navigation

Navigation through the tabs is carried out by means of the navigation bar in the lower area of the wizard window:

General Analyzer Schema Graphics Template

Button | Description
Arrow left | Goes back one tab in the wizard process.
Arrow right | Goes forward one tab in the wizard process.
Finish | Writes all changes to the zenon variable in the Editor and closes the wizard.
Cancel | Ends the wizard without making changes.

Individual tabs can also be selected by clicking directly on the title of the tab.


Settings

Settings

Selection and loading of the tabs to be configured.

Parameters | Description
Settings | Setting for which tabs are to be loaded.
Load every project of this workspace into the memory | Active: Projects from the workspace that are not in the memory are loaded. Once the wizard has been ended or once the Finish action has been executed, these are removed.
Define Meanings | Active: The tabs Meaning filter and Meaning are loaded.
Define Waterfall | Active: The tabs Waterfall filter and Waterfall are loaded.
Load data | Clicking on the button searches through the variables of all projects loaded in the workspace and loads the required information for the filter and editing the variables. The corresponding tabs are displayed in the wizard. A progress bar is displayed during the loading process.

After loading, all tabs are available for configuration.


Meaning filter

Meaning filter

The variables to be edited are pre-filtered with this tab. If an object is not selected in any group, all variables are available in the Meaning tab.

Parameters | Description
List of equipment groups | Filtering for individual models by activating the respective checkboxes. No selection: Variables of all equipment models are selected.
List of projects | Filtering for individual checkboxes by activating the respective checkboxes. No selection: Variables of all projects are selected.
List of archives | Filtering for individual archives by activating the respective checkboxes. No selection: Variables of all archives are selected.


Meaning

Meaning

The meanings of the variables are edited in this tab. Variables can be selected and given new meanings, and existing meanings can be removed.

Variable selection

Parameters

Description

Search meaning

Input of a search term lists all variables with their corresponding meanings.

The list is immediately updated with the entry of a character. Placeholders cannot be used.

List Variablen

List of the variables available after filtering.

Selection of variables for editing: Activation of the checkbox before the variables.

Existing meanings of the variables are shown in the Meanings column. In doing so, only meanings are displayed. Other entries or entries for the waterfall chart are hidden or ignored when editing.

The variables can be sorted by clicking on a column label.

Select all

Clicking this selects all variables for editing.

Deselect all

Clicking this deselects all variables.

Display statistics

Display how many variables:

  • Are present in the list
  • Have been selected
  • Have been changed

Reset

Resets all changes that have been made by clicking on Update meaning.

Note: Changes are only accepted finally after clicking on Finish.

Add meanings

Add new meanings | Allows meanings to be added to variables. New meanings are entered in the input field, added to the list and assigned to the selected variables using the Update meaning button.
Eingabefeld | Entry of a new meaning. Maximum length: 50 characters
Liste Meanings | Lists all meanings that have been created.
Add to list | Adds entry from text field to the list of meanings.
Remove from list | Deletes selected entry from the list of Meanings.
Remove all | Deletes all entries from the list of Meanings.
Update meaning | Clicking this assigns a new meaning to all entries in the list ofMeanings. The meanings to be added are displayed in the Meanings (preview) column; the row with the variables has a green background.

Remove meanings

Remove existing meanings | Allows meanings to be removed from variables. If a variable is selected, all assigned meanings are displayed in the list of Meanings. Meanings that are to be retained are deleted from the list by clicking on the Remove from list button. Clicking on the Update meaning button removes the meanings from the selected variables.
List Meanings | Lists all of the meanings assigned to the selected variables.
Remove from list | Deletes selected entry from the list of Meanings.
Remove all | Deletes all entries from the list of Meanings.
Update meaning | Clicking this removes all entries in the list of Meanings from the selected variables. The row with the variables has a red background.

Attention: Changes and new entries are only written to the zenon variable once the Finish action in the Finish tab has been executed.

Example of color identification

  • Red: All Meanings of the variable have been deleted.
  • Green: Variable has received a new Meaning.


Waterfall filter

Waterfall filter

You define the waterfall diagram in this tab. To do this, all variables must be assigned to the same equipment group. If variables from an archive are used, the archive and the variables must be assigned to the same equipment group.

Parameters | Description
List of equipment groups | Selection of an equipment group.
List of projects | Selection of a project.
List of archives | Select an archive.

An equipment group and a project must be selected. As a option, it is also possible to select an archive from the appropriate equipment group.

No variables can be displayed in the Waterfall tab:

  • No project was selected
  • No equipment group was selected
  • Objects were selected that are not assigned to the same equipment group


Waterfall

Waterfall

Waterfall definitions can be created and edited on this tab:

Parameters

Description

New

Active: A new waterfall definition is created.

Update

Active: An existing waterfall definition is edited. Select from drop-down list.

Chart

Entry of a name for a new waterfall definition.

Save

Clicking on the button saves the entries.

Note: All changes are only written to the zenon variable once the Finish action in the Finish tab has been executed.

Variablenliste

Lists all variables that correspond to the configuration on the Waterfall filter tab. Bool and String variables are not displayed.

The list can also be sorted by clicking on the column heading. Existing waterfall definitions are displayed in the Waterfalls column. New or amended waterfall definitions are displayed in the Waterfalls (preview) column.

Chart

Waterfall definitions can be created or amended here by dragging & dropping.

Note: All changes are only written to the zenon variable once the Finish action in the Finish tab has been executed.

Creating a waterfall definition

To create a new waterfall definition:

  1. Select New.
  2. Move the desired variable by drag&drop in sequence in the Chart area
  3. Arrange the bar according to the rules
  4. Enter a name in the Chart input field
  5. Click on Save.
  6. The configuration is saved in the Waterfalls (preview) column
  7. Switch to tab Finish.
  8. Click on Finish.

Rules

The following rules apply when creating and editing waterfall definitions:

  1. For the first bar, the variable in the upper left corner of the character area must be dragged.
  2. The second bar can only be inserted below the first bar.
  3. All other bars can be inserted either below the existing bar or to the right of an existing bar.
    • The first row can only contain one bar.
    • If a bar is inserted to the right of an existing bar, the bar above this is extended.
  4. The selected variable is displayed in green.
  5. Each variable can only be used once.
  6. The bar contains an index:
    • First number: Row index
    • Second number: Column index
  7. The name of the selected variable is displayed in the tooltip of the bar.

Changing the color of a bar

To change the color of a bar:

  1. Right-click on the bar
  2. The dialog to select the color opened:
  3. select the desired color
  4. Click OK.

Moving the bar

Bars can be moved if:

  • It is a short bar
  • The movement is within a row

To move a bar, drag & drop it to the new position. All other bars between the old and the new position are moved by one place.

Deleting a bar

Bars can be deleted if:

  • It is a short bar
  • There is no other bar below or to the right

To delete a bar, drag & drop it to a free location outside the Chart field (but not in the variable list).

The bar is deleted. All other bars are moved accordingly.

Saving a waterfall definition

To save a waterfall definition:

  1. Enter a name in the Chart input field
  2. Click on the Save button.
  3. The definition is saved in the variable list and the new entry is displayed in the Waterfalls (preview) column
  4. The new waterfall definition is only written to the zenon variable after clicking on the Finish button in the Finish tab.

Editing a waterfall definition

To edit a new waterfall definition:

  1. Select Update.
  2. Select the desired waterfall definition from the drop-down list.

    Attention: Only definitions that correspond to the configuration in the Waterfall filter tab are offered.

  3. The waterfall definition is displayed in the Chart area
  4. Change the definition in accordance with the rules:
    • Adding a bar:
    • Deleting a bar: If a bar is deleted, the variable is highlighted in red in the list.
    • Moving a bar:
    • Changing the color:
  5. Click on Save.
  6. All changes are displayed in the Waterfalls (preview) column
  7. Switch to tab Finish.
  8. Click on Finish.


Finish

Finish

In this tab, the changes are written to the variables in zenon and the result is displayed in the output field.

Clicking on the 'Finish' button writes the changes to the zenon variable in the Editor.

The changes made are displayed in the output field:

  • Update MEANINGS variable definition: Changes to the variables that are carried out and that concern the meanings.
  • Update WATERFALL variable definition: Changes to the variables that have been carried out and that concern the waterfall definition
  • Notes on new and deleted entries, warnings and error messages.

    When importing into zenon, the length of the entry is checked for the corresponding properties. This must not consist of more than 250 characters If the entry is longer, the sequence is cut off after the 250th character and an error message is written in the output field of the 'Finish' tab.


Sankey Wizard

Manual -> Wizards -> Topics -> Analyzer -> Sankey Wizard

A Sankey diagram is a graphic display of quantity flows. The quantities are displayed by arrows with a thickness proportional to the quantity. Sankey diagrams are important aids for the visualization of energy and material flows, as well as inefficiencies and potential for saving when using resources.

The Sankey Wizard supports you when creating Sankey diagrams that you can see in zenon Runtime and in zenon Analyzer.

Three scenarios are possible:

  • Create a new Sankey diagram.
  • Use a pre-existing Sankey diagram as a template.
  • Edit an existing Sankey diagram.

The Sankey diagram is saved in an XML file.

Note: The wizard is only available in English.

tutorial License information

Part of the standard license of the Editor and Runtime.

Other topics in this chapter

Installing the Sankey wizard

Starting the Sankey wizard

Start window

Navigation

Action - select action

Variables - select variables

Diagram - create diagram

Finish - complete


Installing the Sankey wizard

Manual -> Wizards -> Topics -> Analyzer -> Sankey Wizard -> Installing the Sankey wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The wizard is automatically installed together with zenon.


Starting the Sankey wizard

Manual -> Wizards -> Topics -> Analyzer -> Sankey Wizard -> Starting the Sankey wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For wizards to be displayed, the settings for VBA and/or VSTA must be set correctly in file zenon6.ini:

[VBA]

EIN=1

[VSTA]

ON=1

If VSTA wizards are not displayed although the settings are correct, set entry LOADED= to 1 in area [VSTA].

To start the Sankey wizard, proceed as follows:

Screenshots - Expanding

  1. Start the zenon Editor.
  2. Click on File in the tool bar on the left.
  3. Click on Wizards.

Note: You can also open the selection window with the available wizards with the key combination Alt+F12.

The selection window with the available wizards opens.

Screenshots - Expanding

  1. Expand the Analyzer node
  2. Then click on Sankey Wizard.
  3. Start the wizard by clicking on OK .


Start window

Manual -> Wizards -> Topics -> Analyzer -> Sankey Wizard -> Start window

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When opening the wizard, you receive an overview that lists and explains all objects that can be configured. Configuration starts with the Action tab.

Click on the button with the arrow or on the title of the tab to navigate through the configuration of the export.


Navigation

Manual -> Wizards -> Topics -> Analyzer -> Sankey Wizard -> Navigation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Navigation through the tabs is carried out by means of the navigation bar in the lower area of the wizard window:

General Analyzer Schema Graphics Template

Button | Description
Arrow left | Goes back one tab in the wizard process.
Arrow right | Goes forward one tab in the wizard process.
Finish | Writes all changes to the zenon variable in the Editor and closes the wizard.
Cancel | Ends the wizard without making changes.

Individual tabs can also be selected by clicking directly on the title of the tab.


Action - select action

Manual -> Wizards -> Topics -> Analyzer -> Sankey Wizard -> Action - select action

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Select, in the Action tab, the desired action by activating it.

There are the following three possibilities:

Parameters | Description
Create diagram | Creates a new diagram.
Use existing diagram as template | Uses an existing diagram as a template. Note: In this case, variables must be linked to node connections again. The variable linkings of existing diagrams are not shown in the template.
Edit diagram | Allows the editing of an existing diagram.

List of the diagrams that have been created

The window in the middle shows a list with the diagrams that have already been created. The entries are grayed out if Create_Diagram has been selected. The following information for this is visible:

Parameters | Description
Project | Name of the project in which the diagram is saved
Diagram | Shows the name of the diagram.
Description | Shows the description of the diagram.
Analyzer | Active: The diagram can be used in the Analyzer and in Runtime. Inactive: The diagram can only be used in Runtime.
Valid | Active: The diagram is valid. Inactive: The diagram is not valid. You cannot use the diagram in either the Analyzer or in Runtime. Note: In this case, edit the diagram and amend it until it is valid.

Project Settings

You can change the following settings for the project in this area:

Parameters | Description
Name | Enter a name for the project here. Note: The name must be unique. Otherwise a warning dialog will make you aware of this. A newly-created program with a name that already exists would replace the existing one if the warning dialog is confirmed. However if you click on No in the warning dialog, _1 is automatically added to the name.
Save into project | Here you select the project in which your diagram is to be saved.
Description | Enter a description here. Note: This is optional.
Create diagram for Analyzer | Active: Only variables that are in archives are shown. Note: The variables that you want to use must first be exported with the Analyzer Export Wizard. Inactive: Selection of the variables is possible without limitations, however the diagram cannot be used in zenon Analyzer, only in zenon Runtime.

Note: Once this tab is left, it is no longer possible to edit the settings that have been made.


Variables - select variables

Manual -> Wizards -> Topics -> Analyzer -> Sankey Wizard -> Variables - select variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can select variables for your project in this tab.

Select project

Parameters | Description
Select project | List of all active zenon projects. Select the project(s) from which you want to select variables for your diagram here. Note: Multiple selection is possible.

Select data source

Parameters

Description

Select data source

Select the data source here (archives).
Note: The Online Data option is available for all other variables that do not come from archives. This option can only be selected if you have not activated the create for Analyzer option in the Action tab. Live values, i.e. online values, are used for Runtime. Historical values are used for zenon Analyzer.

  • Short name
    Short identification of the archive
  • Long name
    Full name of the archive
  • Project
    Project name of the archive
  • Parent archive
    Version of the archive used

Variables

Parameters

Description

Project variables

Select the variables that you want to link to your diagram here. Multiple selection is possible.

Possibilities for this:

  • Double-click on the desired variable.
  • Highlight the desired variable and then click on Add->.
  • Hold down the Ctrl key, highlight several variables, click on Add->.
  • Click on Add all-> to select all variables.

Variable list:

  • Name
    Variable name
  • Project
    Name of the project of the variable
  • Archive:
    Short identification of the archive
  • Aggregation:
    Aggregation type of the archive
    • AVG (Average)
    • Max (Maximum value)
    • Min (Minimum value)
    • Sum (Sum)
    • RAW (Raw data format - without aggregation)

Button Add ->

Adds selected variable(s) to the list of Diagram variables.

Button Add all ->

Adds all variables to the list of Diagram variables.

Button <- Delete

Removes selected variable(s) from the list of the Diagram variables.

Button <- Delete all

Removes all variables form the list of Diagram variables.

Diagram variables

Parameters

Description

Diagram variables

You can see all selected variables here. These are relevant for the next tab when creating the diagram.

To delete variables again:

  • Highlight the variable that you want to delete and click on <-Delete.
  • Hold down the Ctrl key, highlight several variables that you want to delete at the same time and click on <-Delete.
  • Click on <-Delete all to delete all selected variables again.

Variable list:

  • Name
    Variable name
  • Project
    Name of the project of the variable
  • Archive:
    Short identification of the archive
  • Aggregation:
    Aggregation type of the archive
    • AVG (Average)
    • Max (Maximum value)
    • Min (Minimum value)
    • Sum (Sum)
    • RAW (Raw data format - without aggregation)

Note: Once you have left this tab, changes to the settings that have been made here are possible.


Diagram - create diagram

Manual -> Wizards -> Topics -> Analyzer -> Sankey Wizard -> Diagram - create diagram

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You are able to draw a diagram in this tab.

Drawing area

You position your nodes and connections in the drawing area.

Node

Parameters | Description
Name | Node name
Color | Color of the node. Displays the last selected color. Clicking on the button opens the color selection dialog.
Create | Creates nodes and positions these on the drawing area.
Delete | Deletes selected nodes from the drawing area. Only active if at least one node in th drawing area has been selected.

Diagram

Parameters

Description

Validate

Checks whether all nodes have been linked and/or whether the links are occupied with a variable.

The result of the validation is displayed in a dialog.

  • Node xx is not connected!
    The node is not connected to another node.
  • A connection of node xx has no variable linked!
    The linking of the node does not have an assigned variable.

Save

Saves the current project configuration. A check is also carried out before saving.

Reset

Deletes all nodes and previously-configured connections.

Diagram settings

Parameters | Description
Loss detection | Automatic loss detection with an additional connection that visualizes the differential flow. activated: Automatic loss detection is calculated. deactivated: There is no calculation of the differential flow. Default: deactivated
Positive | If, for a node, the quantity of outflows exceeds the quantity of inflows, a differential flow is displayed in the selected color. Only active if property Loss detection is active. Note: This differential flow is only visible in zenon Runtime or in zenon Analyzer.
Negative | If, for a node, the quantity of inflows exceeds the quantity of outflows, a differential flow in the selected color is displayed. Only active if property Loss detection is active. Note: This differential flow is only visible in zenon Runtime or in zenon Analyzer.

Connections (Variables)

Parameters | Description
Connections (Variables) | List of all the variables available for linking. If a variable is already linked to a connection, this variable is shown in green in the selection list. Note: These variables are provided in the Variables tab.
Link variable | Links the selected variable to the selected connection. Not active if no connection is selected. Note: If a second node and a variable is selected, the connection is also drawn in addition to the linking.
Delete | Deletes selected connection. Multiple selection of connections is possible. Not active if no connection is selected.

Other topics in this chapter

Create diagram

Display of Sankey diagram in zenon Analyzer

Examples of views: Wizard - zenon Analyzer


Create diagram

Create diagram

This is how you create a Sankey diagram with the Sankey wizard:

Creating nodes and connections:

General Analyzer Schema Graphics Template

  1. Enter, in the Node window, under the Name field, a name for the node to be created.
  2. Select a color for the node by clicking on the Color field.
  3. Then click on Create.
  4. Create as many nodes as you want and sort them as you want.
  5. Connect the nodes by dragging a node output (to the right of the node) to a node input (to the left of the node).

Note: A node can have connections to several nodes or several nodes can have connections to one node. The size of the output node changes depending on how many connections there are. Nodes that are only connected on one side are displayed as round or oval. Nodes that have connections on both sides are shown as angular.

There are the following possibilities with regard to node connections:

Back-coupling: Establish a connection from the output of a node to its input

To do this:

  • Double-click on the node on which you want to create the back-coupling.

or

  • Drag the connection from the output of the node to its input.

Establish a connection between 2 nodes and link a variable to it at the same time:

To do this:

  1. Highlight both nodes that you want to connect and the variable that you want to link to it.
  2. Click on Link Variable.

Linking variables to connections:

There are several possibilities for linking variables to connections:

General Analyzer Schema Graphics Template

Drag&Drop

  • Drag the desired variable from the Connections (Variables) window to the desired node connection.

Note: Provided that you have already established the connection between the nodes.

Button Link Variable

  1. Highlight the desired node connection
  2. Highlight the variable that you want to link to the connection.
  3. Click on the Link Variable button.

Note: You can only link one variable to each connection.

Linking a variable to several node connections:

  1. Hold down the Ctrl key and highlight several node connections.
  2. Highlight the desired variable
  3. Click on Link Variable

    or

  4. Drag the variable to the highlighted node connections.

Note: Move the mouse to a connection in order to see the name of the variable that is linked to the connection.

Diagram settings:

General Analyzer Schema Graphics Template

If you activate the Loss Detection option, loss detection is calculated automatically.

You can select the colors that are to be used for the display of the differential flows in the Positive and Negative fields.

Concluding the drawing of the diagram:

General Analyzer Schema Graphics Template

Once you have finished drawing your diagram,

  • Click on the button Validate:

If all your connections are correct, a dialog appears informing you that the diagram is valid. Otherwise a dialog appears informing you that there are still nodes that are not connected or that variables are not linked to the connections.
In order for a diagram to be valid:

  • All nodes must be connected
  • All connections must be occupied with a variable
  • No nodes can overlap if they are moved towards inputs (left) or outputs (right)

To save your diagram,

  • Click on the Save button.

The diagram you have created is validated. The diagram is saved and marked as valid or invalid. You are shown the project in which it is saved.

To redraw the diagram,

  • Click on the Reset button.

All the nodes you have drawn and your connections are thus deleted.

info Information

Clicking on the Validate or Save buttons orientates the nodes to the right and left side of the drawing area.

Note: Nodes must not overlap in the process.

Editing nodes:

Once you have created some nodes, you can

Issue several nodes with the same name:

  1. Hold down the Ctrl key.
  2. Highlight the nodes that you want to name.
  3. Enter a name.

Select the same color for several nodes:

  1. Hold down the Ctrl key.
  2. Highlight the nodes that you want to color.
  3. Then select a color.

Moving several nodes at the same time:

  1. Hold down the Ctrl key.
  2. Select the node that you want to move.
  3. Move the nodes. Your connections are also moved.

Note: You can also edit a node individually by highlighting it and make the desired change.

Deleting nodes:

  1. Highlight the node that you want to delete.
  2. Click, in the Node window, on Delete or use the Delkey.

Deleting several nodes at the same time:

  1. Hold down the Ctrl key and highlight the node that you want to delete.
  2. Click, in the Node window, on Delete or use the Delkey.

Note: When the node is deleted, its connections are also deleted.

Deleting connections:

  1. Highlight the connection that you want to delete.
  2. Click, in the Connections (Variables) window, on Delete or use the Delkey.

Deleting several connections at the same time:

  1. Hold down the Ctrl key and highlight the connections that you want to delete.
  2. Click, in the Connections (Variables) window, on Delete or use the Delkey.


Display of Sankey diagram in zenon Analyzer

Display of Sankey diagram in zenon Analyzer

The nodes are always rearranged in zenon Analyzer and do not follow the exact positioning in the wizard in the process. The display of the Sankey diagram is automatically optimized in zenon Analyzer for legibility and clarity.

The width of the connection is taken into account specially for this arrangement. This width is dependent on the respective values shown (the more there are, the thicker it is).

Horizontal arrangement

Nodes are distributed horizontally over the whole width in proportion to their number.

Example: With three nodes, the display of the first connection will end in the middle of the display.

Vertical arrangement

The vertical arrangement of the nodes is always carried out in a vertical line in zenon Analyzer. This means that the first level is always arranged in a vertical line, regardless of the project configuration in the wizard.

The end nodes are automatically arranged from top to bottom at equal distances.

info Information

Please note the following examples of views.


Examples of views: Wizard - zenon Analyzer

Examples of views: Wizard - zenon Analyzer

Example of horizontal arrangement

Sankey wizard configuration

General Analyzer Schema Graphics Template

zenon Analyzer view

General Analyzer Schema Graphics Template

Example of vertical arrangement

Sankey wizard configuration

General Analyzer Schema Graphics Template

zenon Analyzer view

General Analyzer Schema Graphics Template

Example of mixed arrangement

Sankey wizard configuration

General Analyzer Schema Graphics Template

zenon Analyzer view

General Analyzer Schema Graphics Template


Finish - complete

Manual -> Wizards -> Topics -> Analyzer -> Sankey Wizard -> Finish - complete

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Finish tab, you can see whether the diagram you have created is valid and the location where the diagram you have created has been saved.

  • Click on the Finish button.

To close the Sankey wizard:

  • Click on the Close button.

info Information

The configuration of your Sankey diagram is saved in an XML file.

This is in the project manager of the selected project in the Files node in the Other folder.

With the Analyzer Export Wizard, you can accept the modeled Sankey diagram for use in zenon Analyzer.

You can read details of this export in the Analyzer Export Wizard. manual


Import - Export

Manual -> Wizards -> Topics -> Import - Export

Wizards for export and import of data.


FactoryLink import wizard

Manual -> Wizards -> Topics -> Import - Export -> FactoryLink import wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The FactoryLink Import Wizard is an assistant that supports the user when porting a FactoryLink project to zenon.

attention Attention

The zenon Editor language should be set to English, in order to ensure that the FactoryLink project is imported with as few errors as possible.


Export of project data from FactoryLink

Manual -> Wizards -> Topics -> Import - Export -> FactoryLink import wizard -> Export of project data from FactoryLink

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

FactoryLink project data is exported via the Menu Display - Library Converter in the ClientBuilder application. Here, the desired libraries all all project data to be converted must be selected.

attention Attention

ASCII must be selected as the target format.

In addition, there must be access to all bitmaps used in the project. All files must remain in the file structure that was created by FactoryLink .


Import of the project

Manual -> Wizards -> Topics -> Import - Export -> FactoryLink import wizard -> Import of the project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A selection dialog is displayed using the File - Wizards... menu, which displays all wizards available in zenon. The FactoryLink Import wizard is in the Wizards - Export/import - FactoryLink Import Wizard group.


Welcome

Welcome

On the first page of the wizards, the process and the following pages of the wizard are briefly explained.


Preparation

Preparation

Basic information for executing the wizard is available on this page. To exclude the possibility of two names of screens and templates when importing, it is recommended that you create a new project in zenon. The zenon dialog to create a new project can be called up by clicking on Create empty project if the project that is currently loaded is not to be empty.

attention Attention

After creating a new project, the zenon wizard selection dialog opens automatically. This selection dialog must be closed, because the FactoryLink Import Wizard remains active in the background.


TAG selection

TAG selection

On this page, the file imltags.asc of the FactoryLink project to be imported must be selected. All of the project's variable information is imported into zenon by clicking 'Import!'. The wizard opens the file with the variable information and reads names, types and descriptions of the variables. The internal driver is used as a standard driver in zenon.

info Information

After the variables have been imported, the drivers used in zenon can be changed via Properties -> Addressing -> Driver Connection -> Driver.


Mimic selection

Mimic selection

On this page, all relevant folders in which picture data, templates, bitmaps and project symbols are located must be selected.

In addition to normal import as a picture symbol, there is also the possibility to create a symbol in the wizard. In doing so, the wizard creates a picture with all symbols contained in the project. These symbols must now be manually copied into the local symbol library of the zenon project. If the project contains FactoryLink animations (for example Symbols Bit Group), in which variables with symbols are linked, the wizard can transfer these animations to a zenon combined element.


Events

Events

A summary of the conversions is shown on this page. The list can be filtered for certain event if required.


List of importable objects

Manual -> Wizards -> Topics -> Import - Export -> FactoryLink import wizard -> List of importable objects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
  • Import of variable names, description and types, transfer of FactoryLink connections to the zenon internal driver
  • The import and creation of FactoryLink templates and mimics.
  • Import of FactoryLink Bitmaps in the picture folder of the zenon project manager
  • Import and creation of static picture elements:
  • Rectangle
  • Lines
  • Rounded rectangle
  • Circle/ellipse
  • Text
  • Polygons
  • Polylines
  • Pie charts
  • Bitmaps
  • Import of MultiLang texts from text elements in zenon language tables
  • Fonts from FactoryLink projects are approximated in size and adapted to existing standard project fonts
  • Possibility of creating a symbol, which contains all symbols for manual import into the local symbol library
  • FactoryLink symbol import as zenon symbols
  • Alternative symbol import from zenon symbol library, if manual import was carried out
  • Conversion of CB animations (ColorBit) to a zenon combined element
  • Conversion of CB animations (ColorBit) to a zenon combined element
  • Conversion of DR animations (display register) to a zenon text element
  • Conversion of SR animations (send register) to a zenon text button


PDiag import wizard

Manual -> Wizards -> Topics -> Import - Export -> PDiag import wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon PDiag import wizard supports PDiag messages during import. This wizard can also serve as a template for your own expansions in this respect.

The PDiag import wizard is only available in English.


Requirements

Manual -> Wizards -> Topics -> Import - Export -> PDiag import wizard -> Requirements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The wizard imports an XML file exported from the process diagnosis (PDiag) Simatic module. This export can be carried out with the menu item Process diagnosis | Export in Simatic Manager.

The XML file created in this way is imported with the wizard in zenon. In doing so, variables that are based on the S7-TCP driver, of driver object type Alarm S are created. Each message and each accompanying value corresponds to a zenon variable.

Only UINT variables are imported as accompanying values. In doing so, the message text is analyzed for the Simatic PDiag identifier "@1X%2d@", "@1X%3d@" und "@1X%4d@" and adapted for zenon accordingly. It is also possible to use the language table for dynamic texts. In doing so, the texts outside the wizard are to be transferred to the zenon.

This wizard also imports S7 graph messages, which are automatically generated and thus also contained in the XML file.


Settings

Manual -> Wizards -> Topics -> Import - Export -> PDiag import wizard -> Settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To start the wizard:

  1. Select Wizards.. in the File menu.

    Alternatively: The key combination Alt+F12

  2. The dialog to select the zenon wizards is opened
  3. Open the Export/Import nodes
  4. Select PDIAG wizard

The wizard leads to, via the

  • Welcome
  • Settings
  • Finish

tabs, to the import of an XML file.


Welcome

Welcome

The Welcome tab contains a short explanation of how the wizard works and what it requires.

To get to the Settings tab, click on the Settings menu or on the arrow on the bottom left.


Settings

Settings

You can adjust the import settings in the Settings tab.

Setting | Description
Driver | Selection of the S7-TCP driver from the active project for which the import is to be carried out.
PDIAG XML File | Selection of the XML file to be imported.
Identification | Optional entry for variable identification. This entry can be filtered in the variable list.
Net Adress | Defines the net address for the zenon variable addressing. You can see the valid net address in the driver configuration.
Alarm Group | Sets the alarm/event group of the messages to be imported. Attention: The wizard does not create alarm/event classes in zenon independently. These must be manually created before the import.
In IPA | Active: Sets the Save in IPA database property for the variables. This transfers the messages to the industrial performance analyzer.
use Identification also as prefix for variable | Active: For the variable names of the alarm variables, the variable detection given in the wizard is used as a prefix for the variable names. This option supports unique variable names for projects with several drivers.
Get Alarm Class | Active: The message priority set in Simatic Manager is interpreted as zenon alarm/event class. Attention: The wizard does not create alarm/event groups in zenon independently. These must be manually created before the import.

The import is started with Finish. This button is only active in the Finish tab. Click on Finish in the menu or on the arrow at the bottom left.


Finish

Finish

To start the import, click on the Import button.


Import of messages

Manual -> Wizards -> Topics -> Import - Export -> PDiag import wizard -> Import of messages

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Notices are given during the import:

After the import has finished, there is a note stating how many variables were imported.

Important messages

Message | Description
message text too long | The alarm text is too long and will be cut to the valid length in zenon.
creating attribute variable for dynamic limit text | In addition to the message variable, an accompanying value variable for the dynamic limit value text is created.


WinCC Import Wizard

Manual -> Wizards -> Topics -> Import - Export -> WinCC Import Wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The WinCC Import Wizard imports selected parts of an existing WinCC project to the currently loaded zenon project. The import of the WinCC project data is carried out using two programs:

  • WinCC Graphics Converter: exports WinCC screens, frames and symbols from WinCC in an XML file
  • WinCC Import Wizard: imported
    • Data blocks (structure TAGs), TAGs, alarms and archives directly
    • Screens, frames and symbols via XML files which were previously created with the help of the WinCC Graphics Converter


Installation

Manual -> Wizards -> Topics -> Import - Export -> WinCC Import Wizard -> Installation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To execute the WinCC Import Wizard, you must first install all components.

info Information

Note that zenon should NOT be installed on the same computer as WinCC.

Installation WinCC Graphics Converter

In order to access the WinCC information, the WinCC Graphics Converter must be installed on the computer on which the WinCC project runs. The program is located on the zenon installation medium in folder \Additional Software\WinCC Graphics Converter.

After the installation you can find the converting tool for different WinCC versions under Start - All Programs - COPA-DATA - WinCC Graphics Converter. Always start the tool for matching version.

info Information

For using the converter, .NET Framework 3.5 must be installed. When installing the converter, it is checked whether it is available. If the framework is missing, the installation is canceled. In this case first install .NET Framework 3.5 and then start the installation of the converter again.

Installation of the wizard for zenon 7.0 and higher

The wizard is automatically installed together with the zenon Editor. No separate settings are needed. You can start the wizard right away in the zenon Editor under File - Wizards... and there under Export/Import.

Installation of the wizard for zenon 6.51

As the wizard is not a part of 6.51 SP0, you must carry out the followuing steps for the installation:

  • Install at least Build 6 of zenon 6.51. You can request Build 6 from your distributor or from the COPA-DATA Support.
  • Install the wizard together with the WinCC Graphics Converter. This setup installs the WinCC Graphics Converter tool and also the wizard if zenon 6.51 SP0 is installed. You can request the setup from your distributor or from the COPA-DATA Support.
  • After the installation, start the zenon Editor. The dialog for updating the wizard is displayed. The wizard is added to the VSTA workspace by starting the update.
    If you want to carry out this step later, you can return to this dialog in the zenon Editor via menu File - Update wizards.... To get to this dialog at any time.

  • Start the VSTA Editor in the zenon Editor in the File - Open VSTA Editor... and select, in the Project Explorer window, the References node. Carry out menu item Add Reference.. in the context menu in order to add two missing references:
    • MSDASC: In the Add Reference dialog click on tab COM and add the component Microsoft OLE DB Service Component 1.0 Type Library to the project.
    • ADODB: In the Add Reference dialog click on tab Browse. Navigate to the folder C:\Program Files (x86)\Microsoft.NET\Primary Interop Assemblies and select file adodb.dll.

  • In window Project Explorer you can now select node WorkspaceAddin and compile the add-in via menut item Build in the context menu.

After the compiling was successful, the wizard is available in the zenon Editor under File - Wizards... and there under Export/Import.


WinCC Graphics Converter

Manual -> Wizards -> Topics -> Import - Export -> WinCC Import Wizard -> WinCC Graphics Converter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The WinCC Graphics Converter makes it possible to select screens, frames and symbols in WinCC projects and export them as XML files.

info Information

At the moment XML files can be created from WinCC projects of versions 7.0 and 7.0 SP1.


Welcome

Welcome

With the help of the WinCC Graphics Converter you can convert WinCC graphics files (PDL) to an XML format which the WinCC Import Wizard can read. Existing graphics information are saved as PNG files and WMF files together with the XML files and stored in a selected folder.

To execute the converter:

  1. click on Start
  2. navigate to COPA-DATA -> WinCC Graphics Converter
  3. start the WinCC Graphics Converter
  4. follow the instructions of the wizard


Select .pdl files

Select .pdl files

On this tab you select the PDL files which should ne exported from the WinCC project. To do this:

  1. click on button Select .pdl files
  2. navigate to the project folder which contains the PDL files

    Note: In order that the files can be selected, the WinCC project must be loaded on the computer!

  3. select the desired files
  4. all selected PDL files are displayed in the preview window


Select output folder

Select output folder

On this tab you select the folder in which the export files should be saved. To do this:

  1. click on button Select output folder
  2. avigate to the folder in which the export files should be saved
  3. Note: You can create a new folder in the selection dialog


Convert

Convert

On this tab you can carry out the conversion.

After the successful export copy the folder to the computer with the zenon project in which the data should be imported or make sure that the computer with the zenon project has access to the export folder.


WinCC Import Wizard

Manual -> Wizards -> Topics -> Import - Export -> WinCC Import Wizard -> WinCC Import Wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The WinCC Import Wizard is started via the wizard dialog of the Editor and can be used to import the following WinCC elements:

  • Import of the Screens (the XML files created with the WinCC Graphics Converter are converted to frames, screens and symbols in zenon)
  • Import of the WinCC Tags (only S7 TCP)
  • Import of the WinCC Structure Tags (only S7 TCP)
  • Import Alarm Limits
  • Import Archive Tags

Starting the wizard

For wizards to be displayed, the settings for VBA and/or VSTA must be set correctly in file zenon6.ini:

[VBA]

EIN=1

[VSTA]

ON=1

If VSTA wizards are not displayed although the settings are correct, set entry LOADED= to 1 in area [VSTA].

To start the wizard:

  1. in zenon open menu File
    or press the shortcut Alt+F12
  2. select the entry Wizards...
  3. the selection dialog is opened
  4. navigate to the Export/Import node
  5. select the WinCC Import Wizard
  6. Start the wizard by clicking on OK

The wizard is divided into areas:

  • Welcome: Overview over the wizard.
  • Settings: Settings for the connection to the WinCC project. After the connection has been established successfully, the tabs for the direct import are displayed:
    • Data Blocks: Structure Tags from WinCC
    • TAGs Tags from WinCC
    • Alarm Limits: Alarm classes and alarms from WinCC
    • Archive TAGs Archive files from WinCC
  • Screens: Import of the screens from WinCC via the WinCC Graphics Converter


Welcome

Welcome

The start page of the wizard informs you about all other import steps:

The direct import of data is only possible after you have configured the connection to the WinCC project on tab Settings.


Settings

Settings

On this tab you configure the connection to the WinCC project whose data should be imported.

Parameters | Description
WinCC DB connection | Configuration of the connection to the WinCC database.
Connected with | Display of the active connection.
Connect | Establishes a connection.
New Connection | Opens the dialog for configuring a new connection.
Driver selection (S7 TCP) | Configuration of the zenon drivers.
Driver | Selection of a zenon driver from the drop-down list.
Create new Driver | Opens the dialog for creating a new driver.

attention Attention

In order that the connection can be established, the WinCC project must be active or opened in the WinCC Explorer on the PC with which the connection should be established.

Configuration of the connection

To establish a connection:

  1. click on button New connection
  2. The dialog for the connection settings is opened

  3. on tab Provider select the provider Microsoft OLE DB Provider for SQL Server
  4. on tab Connection:
    1. For server name enter the instance of the SQL server in which the WinCC project is located. For example: HOSTNAME\WINCC
      Important: The WinCC SQL server instance (sqlsrv.exe) must be enabled in the firewall.
    2. For logon information enter your access data. At first you must create the access data with the help of SQL Server Management Studio in the SQL server instance.
      Important: Activate option Allow saving password
    3. For database select the WinCC Editor project. This is the database name without the suffix _R
      Note: The project must be loaded and running in the WinCC Editor. Otherwise the project is not available in the SQL server.
    4. Test the connection
  5. Close the configuration dialog with OK
  6. after that you can establish the connection to the WinCC project in the wizard via button Connect.
  7. select a zenon driver

After a successful connection and the selection of a zenon driver, the tabs for the direct import are displayed.


Data Blocks

Data Blocks

On this tab you select the data blocks which are displayed in the WinCC Explorer under Data Blocks and then imported as data types to zenon.

The WinCC data blocks are grouped according to drivers and are displayed sorted according to block type and name.

To import data blocks:

  1. select the desired data blocks
  2. click on Import Data Blocks

Result

Data blocks in WinCC:

Data types in zenon


TAGs

TAGs

On this tab TAGs (S7) are selected and imported as zenon variables, which are displayed as Tag Management in the WinCC Explorer. The export can be carried out directely to zenon or to a CSV file.

To import tags:

  1. select the desired TAGs
  2. click on Import Tags or Import to CSV

Result

Tags in WinCC:

Variables in zenon:


Alarm Limits

Alarm Limits

On this tab alarm classes and limits are imported:

  • Import Alarm Classes : Imports alarm classes to an existing global project.
  • Import Alarms: Imports alarm classes and groups to the local zenon project and creates variables for the limits.

Import Alarm Classes

Imports alarm classes from WinCC to a global project in zenon. The global project must already exist and must be active in zenon.

To import alarm classes:

  1. select the desired alarm classes
  2. click on Import Alarm Classes

Result

Alarm classes in WinCC:

Alarm classes in zenon:

Import Alarms

With this kind of import all alarm classes and alarm groups are imported to the zenon project. The WinCC limit texts are replaced by limit variables.

To import alarms:

  1. select the desired alarms
  2. click on Import Alarms

Result

Alarms in WinCC:

Alarms in zenon:


Archive TAGs

Archive TAGs

On this tab TAGs which are entered under Tag Logging in the WinCC Explorer can be selected and imported. The import is carried out in one of the two newly created archives BINARY and ANALOG in the zenon project.

attention Attention

TAGs are only created in the zenon archive if they were imported as TAGs beforehand.

To import Archive Tags:

  1. select the desired Archive TAGs
  2. click on Import Archiv Tags

Result

Archive TAGs in WinCC:

Archives in zenon:


Screens

Screens

In this tab you can import the XML files which were created with the WinCC Graphics Converter to the active zenon project. In zenon frames, screens and standard screen elements are created based on the information stored in the XML files and based on the WMF and PNG files which are stored in the folder.

Parameters | Description
List of files | Shows all existing files in the selected folder.
Select Folder | Opens the dialog for selecting the folder with the import files.
Select All | Selects all existing files on the screen.
Import XML | Starts the import.

To import screens:

  1. select the desired XML files
  2. click on Import XML

Result

Screens in WinCC:

Screens in zenon:

Which WinCC screen elements are automatically created in the zenon Editor?

Standard screen elements

  • Line
  • Polygon
  • Polyline
  • Ellipse
  • Circle
  • Elipse Segment
  • Pie Segment
  • Elipse Arc
  • Circular Arc
  • Rectangle
  • Rounded Rectangle
  • Static Text

Tube objects

  • Polygon tube
  • T-piece
  • Double T-piece
  • Tube bend

Smart objects

  • I/O Field
  • Graphic Object
  • Windows Objects
  • Button

For all other WinCC objects a placeholder is created in zenon.

Error treatment

Errors when importing screens are displayed in the zenon output window when the Runtime files are created.

Error message | Error treatment
The symbol "could not be found in the symbol library"! | A placeholder for non-interpretable elements has been placed in the screen. Background: For each non-interpretable element, a symbol is created in the screen using the wizard. This is not in the symbol library however. You therefore have the opportunity to check to see if elements (placeholders) in a screen still need work carried out on them.
WRN:(FDV_RECETTE_TUNNEL_TPOS_DETAILS_FOU2->(ZONE_CNS0)Variable: could not be found in the project! | Signifies variable names, that are stored in WinCC in I\O Field Element but are not (including in WinCC) created as variables.


XML export wizard VSTA

Manual -> Wizards -> Topics -> Import - Export -> XML export wizard VSTA

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You export all desired modules of a project into a folder of your choice with the XML export wizard. An independent XML file is created for each module.

The wizard is only available in English.


Start wizard

Manual -> Wizards -> Topics -> Import - Export -> XML export wizard VSTA -> Start wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To start the wizard:

  • Click on File-> Wizards...
    • or press the short cut Alt+F12
  • The selection window with the available wizards opens
  • Select the Export/import folder

  • Select XML export wizard there

  • click on OK
  • The wizard starts with the welcome page and displays:
    • brief instructions
    • the zenon version
    • the name of the project from which the export is taking place
    • Project GUID
    • Project path

  • The cursor key leads you step by step through the wizard
    • Alternatively, clicking a tab opens the respective setting
  • To activate the Export button, the Export XML progress page must be open


Select XML files

Manual -> Wizards -> Topics -> Import - Export -> XML export wizard VSTA -> Select XML files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Select which module of the project is to be imported:

  • Click on Select Directory to define the folder for export
  • Select the modules and elements that are to be exported by ticking the checkboxes (scroll down if necessary)


Export

Manual -> Wizards -> Topics -> Import - Export -> XML export wizard VSTA -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To start the export:

  • click on the Export button
  • the desired modules are exported
  • The output window displays which modules are exported with what success
  • The wizard closes automatically three seconds after the end of the export


XML Import Wizard

Manual -> Wizards -> Topics -> Import - Export -> XML Import Wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This wizard helps with importing variables, functions, screens and scripts from a XML file.

attention Attention

This wizard does not support distributed engineering and is not available in multiuser projects.


Language Table

Manual -> Wizards -> Topics -> Language Table

Wizards for language switching.


Language Table Wizard

Manual -> Wizards -> Topics -> Language Table -> Language Table Wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Language Table Wizard replaces the old Language Change Wizard (VBA).

The Wizard

  • Searches the active projects for translatable texts or key words (text marked with a "@") and
  • writes this
    • either to the selected language table in the active project or
    • in the global project as an option.

For reference purposes, at least on table (ZENONSTR.TXT) must be selected for the import.

If texts without as "@" character are found, these can be set as a key word in a project. To do this, a "@" is written at the start of the text.

Note: The wizard is only available in English.


Calling up the wizard

Manual -> Wizards -> Topics -> Language Table -> Language Table Wizard -> Calling up the wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The wizard can also be selected directly in the dialog for starting wizards.

To start the wizard manually:

  1. Click on File-> Wizards...

    or press the short cut Alt+F12

  2. The selection window with the available wizards opens
  3. Select the Language Table folder
  4. Select Language Table Wizard there
  5. click on OK
  6. The wizard starts with the welcome page


Start window

Manual -> Wizards -> Topics -> Language Table -> Language Table Wizard -> Start window

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When opening the wizard, you get an overview page with English-language documentation for the wizard.

The navigation through the wizard is done by clicking on the individual tabs or step by step by clicking on the arrow keys.

Click on Cancel to close the wizard.


Settings

Manual -> Wizards -> Topics -> Language Table -> Language Table Wizard -> Settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Import options

It is possible to select the following in the "Import options" group:

  • Whether existing texts are to be overwritten in the selected language table,
  • Whether translatable texts found are to be set as key words in the project (texts are marked in the project with a @) and
  • whether the language tables are to be used by the global project.

Select language tables

In the "Select language tables", depending on the setting of the "Add keywords to language table global project" option, the language tables of the active project or the global project are displayed. The key word is entered in the selected language tables as a text. At least one table must be selected.

Project options

In the "Project options" grouping, it is possible to select which project-related texts of key words are to be searched for.

Screen elements

In the "Screen elements" grouping, it is possible to select which screen elements are to be searched.


Finish

Manual -> Wizards -> Topics -> Language Table -> Language Table Wizard -> Finish

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The search for translatable text and key words can now be started on this tab. To do this, click the Finish button.

After this, a search is carried out and it is possible to write to the selected language tables.


Language Translation Wizard

Manual -> Wizards -> Topics -> Language Table -> Language Translation Wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This wizard is for the preparation of data for the Project Translation Interface, a translation tool.

In doing so, all relevant data for translation is prepared and compressed into a ZIP file. This ZIP file can then be unzipped in the Procect Translation Interface and the language tables can be edited or supplemented. After editing, the ZIP file can be loaded into the wizard and the edited language tables can be reimported into the project.

Note: The wizard is only available in English.

tutorial License information

Part of the standard license of the Editor and Runtime.

The Language Translation Wizard is also suppled with the paid-for Project Translation Interface.


Start wizard

Manual -> Wizards -> Topics -> Language Table -> Language Translation Wizard -> Start wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To start the wizard:

  1. Click on File-> Wizards...

    or press the short cut Alt+F12

  2. The selection window with the available wizards opens
  3. Select the Language Table folder
  4. Select Language Translation Wizard there

  5. click on OK
  6. The wizard starts with the welcome page


Start window

Manual -> Wizards -> Topics -> Language Table -> Language Translation Wizard -> Start window

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When opening the wizard, you get an overview page with English-language documentation for the wizard.

The navigation through the wizard is done by clicking on the individual tabs or step by step by clicking on the arrow keys.

Click on Cancel to close the wizard.


Export

Manual -> Wizards -> Topics -> Language Table -> Language Translation Wizard -> Export

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When carrying out the export, the wizard evaluates all texts from screen elements, limits and other project objects, which are translatable text marked with a @.

These texts are prepared into an XML file and exported with the selected language tables as a ZIP file. In addition, a screenshot of all screens is created and also provided in the ZIP file. The ZIP file also contains the font lists of the selected project and those of the global project.

Button | Description
Zip Name: | Name of the export file
C:\ | Save location of the export file. A click on button ... Opens the file browser for selecting a target folder.
Liste Sprachdateien | List field with the possibility to select the existing language files in the project.
Select all | Selects all entries in the list and activates the checkboxes.
Deselect all | Selects all entries in the list and deactivates the check boxes.
Export | Exports the files to the target folder. Is only active if one or more language tables are selected.
Arrow left | Goes back one tab in the wizard process.
Arrow right | Goes forward one tab in the wizard process.
Cancel | Closes the wizard without exporting.

attention Attention

The following special characters must not be used in the screen names:
: / \ * < >

These special characters are removed and replaced by a serial number.


Import

Manual -> Wizards -> Topics -> Language Table -> Language Translation Wizard -> Import

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The ZIP file to be imported can be selected in this tab.

Button | Description
... | Save location of the import file. A click on button ... Opens the file browser to select a file folder.
List of language files | List field with the possibility to select the language files to be translated and imported.
Select all | Selects all entries in the list and activates the checkboxes.
Deselect all | Selects all entries in the list and deactivates the check boxes.
Import | Imports the selected language tables in the current zenon project. Is only active if one or more language files are selected.
Arrow left | Goes back one tab in the wizard process.
Cancel | Closes the wizard without importing.

attention Attention

If a new language file was added in zenon 6.51, the project must be reloaded in the workspace once the wizard has been ended.

The language files are automatically updated in version 7.00 SP0 onwards.


System Text Wizard

Manual -> Wizards -> Topics -> Language Table -> System Text Wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The System Text Wizard allows the import of system text into the language table. System texts are Runtime texts that are used in zenon dialogs and menus and cannot be changed by the user. In order to be able to make these texts, which are predetermined by zenon, compatible with language switching, these texts must first be imported into the language table with this wizard. The number of the key words and texts imported can be limited in the settings.

Note: The wizard is only available in English.


Calling up the wizard

Manual -> Wizards -> Topics -> Language Table -> System Text Wizard -> Calling up the wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The wizard can also be selected directly in the dialog for starting wizards.

To start the wizard manually:

  1. Click on File-> Wizards...

    or press the short cut Alt+F12

  2. The selection window with the available wizards opens
  3. Select the Language Table folder
  4. Select System TExt Wizard there
  5. click on OK
  6. The wizard starts with the welcome page


Start window

Manual -> Wizards -> Topics -> Language Table -> System Text Wizard -> Start window

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When opening the wizard, you get an overview page with English-language documentation for the wizard.

The navigation through the wizard is done by clicking on the individual tabs or step by step by clicking on the arrow keys.

Click on Cancel to close the wizard.


Settings

Manual -> Wizards -> Topics -> Language Table -> System Text Wizard -> Settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The settings for importing the system texts are combined together in the "Settings" tab.

Project settings

General settings can be changed in the "Project settings" grouping: The "Overwrite existing language table" option denotes whether texts with existing key words are to be overwritten. "Add keyword to language table global project" stipulates whether system texts are to be written to the project active in zenon (checkbox is not activated) or to a zenon global project (if the checkbox is activated). Depending on the option selected in the "Select Language" grouping, existing language tables can be selected.

Select language

The languages supported by zenon are available in the "Select language" grouping. Activation of the corresponding checkbox selects the language to be written into the language table. It is possible to select multiple items in the process. The relevant language table can be selected in the drop-down list. These language tables must have already been configured in zenon.

Select category

System texts can be activated according to modules in the "Select category" grouping.


Finish

Manual -> Wizards -> Topics -> Language Table -> System Text Wizard -> Finish

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Clicking on the "Finish" button starts the import with the given settings. These settings can then be saved once the wizard has been exited.


Metering Point Administration

Manual -> Wizards -> Topics -> Metering Point Administration

Metering point administration is a tool to manage technical data and administer metering points.

  • In zenon Editor, the project configuration is created with the Metering Point Administration Wizard. .
  • For display in Runtime, a corresponding ActiveX element is configured in the Editor in any desired zenon screen.
  • Meters can be assigned to metering points in Runtime, meters can be replaced and values can be (manually) corrected.

The wizard tool is available in English and German.

tutorial License information

Part of the standard license of the Editor and Runtime.


General - project configuration

Manual -> Wizards -> Topics -> Metering Point Administration -> General - project configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To use the metering point administration, the following project configuration steps are necessary:

  1. Configure variables in zenon Editor.
    Note: corresponding variables can also be created for relative values in the wizard directly.
  2. Configure archives in zenon Editor.
    Note: Archives can also be created directly from the wizard.
  3. In zenon Editor, start the Metering Point Administration wizard.
  4. Create metering points and meters in the wizard.
    Note: Meters can also be created in Runtime.
  5. In the wizard, assign the metering points to absolute value variables and relative value variables from archives.
    Note: Relative values can also be calculated automatically.
  6. Configure a screen in zenon Editor.
  7. Place an ActiveX element in this zenon screen.
  8. You assign meters to the corresponding metering points in Runtime.
  9. If necessary, enter current values for manual metering points in Runtime for the meters.


Install and call up metering point administration

Manual -> Wizards -> Topics -> Metering Point Administration -> Install and call up metering point administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Metering Point Administration is automatically installed as part of the zenon standard installation.

Starting the wizard

For wizards to be displayed, the settings for VBA and/or VSTA must be set correctly in file zenon6.ini:

[VBA]

EIN=1

[VSTA]

ON=1

If VSTA wizards are not displayed although the settings are correct, set entry LOADED= to 1 in area [VSTA].

To call up the tool, proceed as follows:

  1. Start the zenon Editor.
  2. Click on File in the toolbar.
  3. Click on Wizards.

Note: You can also open the selection window with the available wizards and tools with the keyboard shortcut Alt+F12.

The selection window with the available wizards and tools opens.

  1. Select the Metering Point Administration folder.
  2. There, click on Metering Point Administration.
  3. Click on OK.


Wizard - start dialog

Manual -> Wizards -> Topics -> Metering Point Administration -> Wizard - start dialog

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Metering Point Administration wizard starts with the welcome page in English.

  • To continue, click on the Metering Point Administration button.
    The dialog switches back to the configuration dialog for metering point administration.
  • Clicking on the Exit button closes the wizard.


Wizard - Metering Point Administration

Manual -> Wizards -> Topics -> Metering Point Administration -> Wizard - Metering Point Administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Once the start dialog for the wizard has been confirmed, start the configuration of the metering point administration Configuration starts with the Database tab.

If database settings have already been saved, an attempt to establish a connection is started automatically when the wizard is called up. If this is successful, a switch to the Measuring points tab is made. If the establishment of a connection is unsuccessful, a corresponding error message is shown.

Navigation through the tabs is carried out by clicking on the title of the tab.

It is possible to select from German or English in the drop-down list for the display language.

Parameters

Description

Database

Tab for the settings of the necessary database connection.

Metering Points

Tab for the creation and administration of metering points in zenon Editor.

Each metering point is assigned corresponding archives and variables.

Meter

Tab for the creation and administration of users.

Display language

Drop-down list to select the display language for the wizard.

  • German
  • English

Navigation

Button | Description
Exit | Closes the wizard. Changes that have not been saved are lost in the process.
info Information
Settings changed in the wizard are saved in the user profile of the operating system and loaded at the next opening by the same user.


Database

Manual -> Wizards -> Topics -> Metering Point Administration -> Wizard - Metering Point Administration -> Database

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You configure the communication settings for a database in this tab.

Parameters

Description

Database Host

Drop-down list for the selection of the database server.

Select, for example, your computer in this field. Note: Your computer is shown as a default when the tab is opened.

Authentication

Drop-down list for selection of the login method:

  • Windows Authentication (Default):
    The login to the database is carried out with the information of the user logged in to the local computer.
  • SQL Server Authentication:
    User name and password are entered manually. The corresponding login data must be available for database login.

User name

User name for login to a database.

Grayed out if the authentication is Windows Authentication.

Password

Password for login to a database.
For security reasons, each letter is shown with a * when the password is entered.

Grayed out if the authentication is Windows Authentication.

Connect

Establishes the connection to the configured database server.

If no connection is possible (for example due to incorrect entry of user name and/or password), an error message is called up.

Grayed out if it is already connected to a database server.

Disconnect

Disconnects an existing connection to a database server.

Grayed out if no connection is active.

Database Name

Drop-down list to select a database.

This list shows all available databases of the database server configured under Datenbank-Host.

If this list is empty, there is no connection to a database server or there is no SQL database available on the selected computer.

Start configuration

Switches to the Metering point tab.

If there is not currently a connection to a database, a connection with the login information that has already been entered is established when clicking on the Start configuration button.

If this input is incorrect or incomplete, no further settings can be changed in the Metering points or Meters tabs. A connection to a database is always necessary for this!

Navigation

Button | Description
Exit | Closes the wizard. Changes that have not been saved are lost in the process.
info Information
If there is already a connection to a database, all input fields are grayed out.


Database - evaluation and amendment

Manual -> Wizards -> Topics -> Metering Point Administration -> Wizard - Metering Point Administration -> Database -> Database - evaluation and amendment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Database - evaluation and amendment

If a connection to a database is established, the structure of this database is evaluated immediately. Tables required for metering point administration are created automatically if required. The validation is carried out in the Editor and in Runtime.

If amendments to the existing database are required, you are informed of this by means of a dialog. The dialog only appears if amendments are necessary.

Evaluation dialog

  • Confirm this dialog with Yes if the database is to be amended to the corresponding tables.
  • Cancel closes the dialog. No amendments are made in the dialog. Configuration of metering points is not possible. The wizard jumps to the Database tab.

Validation of the archives

A validation is carried out on starting - errors are visualized.

If a problem occurs when validating the archives, this is signaled by a red warning symbol next to the problematic element. You get a detailed description in the tool tip, if you move to the warning symbol with the mouse.

Example of a view - Runtime


Industrial Maintenance Manager compatibility

Manual -> Wizards -> Topics -> Metering Point Administration -> Wizard - Metering Point Administration -> Database -> Industrial Maintenance Manager compatibility

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Industrial Maintenance Manager compatibility

The functionality of the Industrial Maintenance Manager (IMM) can be used for meters in metering point administration. The IMM is for the administration of machine and maintenance data. Service intervals can be planned and administered with ease. You can see at a glance which devices, items of equipment, machines, etc. have to be maintained today / this week / next month etc. Furthermore, the service work that has been completed in the past is also logged.

When checking the database, the table names of an existing IMM project configuration are checked. If necessary, these names are amended after confirmation.

  • Confirm this dialog with Yes if the table names are to be amended.
  • No closes the dialog. No amendments to the table names are made in the database. Configuration of metering points is possible.

IMM table names:

  • Table for devices: Devices
  • Table for maint. works: MaintenanceWorks
  • Table for history: MaintenanceHistory
  • Table for documents: Documents

info Information

Project configurations from zenon version 7.20 are not affected by this. From version 7.20, the table names for the Industrial Maintenance Manager can no longer be freely configured.


Metering Points

Manual -> Wizards -> Topics -> Metering Point Administration -> Wizard - Metering Point Administration -> Metering Points

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

New metering points are created in this tab and existing ones are administered.

Parameters

Description

New...

Opens the dialog to create a new Metering Point.

Edit...

Opens the dialog to edit the selected metering point.

Delete

Deletes the selected Metering Point.

List of metering points

List of the metering points that have been created, as configured in the dialog to create a new metering point.

Selection by means of clicking. The selected metering point is underlined in color. Multiple selection is not possible.

  • Name
    Name of the metering point
  • Description
    Short description of the metering point
  • Location
    Location of the metering point
  • Automatic
    Active, if Metering Point behavior is automatic.
  • Metering point Type
    Type of the metering point
  • Calculation active
    Active if Calculate relative value has been activated.
  • Meter name
  • Meter description
  • Relative value variable
    Assigned variables for the relative value.
  • Absolute value variable
    Assigned variables for the absolute value.

You can find out more information in the dialog description.

Navigation

Button | Description
Exit | Closes the wizard. Changes that have not been saved are lost in the process.


Create new metering points

Manual -> Wizards -> Topics -> Metering Point Administration -> Wizard - Metering Point Administration -> Metering Points -> Create new metering points

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Create new metering points

Click, in the Metering points tab, on New to create a new metering point.

The following dialog opens, in which you can configure the new metering point.

Parameters

Description

Name

Name of the metering point.

(Mandatory field)

Description

Description of the metering point.

Optional entry

Location

Location of the metering point.

Optional entry

MeteringType

Type assignment of the metering point.

Optional entry

Note: A list is kept with all the previously-configured metering point types. These types are displayed when the first applicable letter is typed. If the type that has been entered does not exist in the list, that type is added to the list (auto suggest).

Metering Point behavior

Option field for selection of the value entry

  • Automatic:
    When this option is activated, both cyclical and spontaneous archives can be selected for the absolute value. The values are taken from the variable.
    Relative values can be automatically calculated in due course.
    You can find further information on this behavior in the Relative value tab.
  • Manual:
    When this option is activated, only spontaneous archives can be selected for the absolute value.
    The meter values must be read and entered manually.

Note: The list of the archives and the list of variables for absolute and relative values is filtered according to the metering point behavior. This means that, with manual metering point administration, only spontaneous archives or variables from spontaneous archives are displayed in the list of archives and variables.

Attention: If you change the metering point behavior of an existing measuring point, the absolute variable and the relative value variable must be reselected.

Project selection

Drop-down list with projects from the current workspace in zenon Editor.
Note: Archives and variables available are tied to a project.

Select the desired project in this field.

Absolute value

Tab for the configuration of the absolute value of the metering point.

Relative value

Tab for the configuration of the relative value of the metering point.

Summary

Checking and conclusion of the configuration of metering point administration.

Navigation

Parameters | Description
Cancel | Discards all changes in all tabs and closes the dialog.
attention Attention
Each metering point must have a respective absolute value variable and a relative value variable assigned.


Absolute value

Manual -> Wizards -> Topics -> Metering Point Administration -> Wizard - Metering Point Administration -> Metering Points -> Create new metering points -> Absolute value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Absolute value

In this tab, a metering point is assigned to an absolute value variable.

Parameters | Description
Variable from archive | In the list of variables, variables from the selected archive (list of archives) are displayed. Select a corresponding archive and a corresponding variable for the absolute value.
Add variable to archive | Variables from the project are displayed. The selected variable is added to the selected archive.
New archive | Opens dialog for the creation of a new archive. Only active if Add variable to archive is active.

Archives (list)

Here, you select an archive from which you want to have variables displayed or to which you want to add a selected variable.

Note: Existing project configurations of archives are displayed in the list. In addition, it is possible to create a new archive directly in the wizard by clicking on the New archive button.

Parameters

Description

Short name

Archive reference.

Archive ID

Archive name

Type

Archive type

  • Cyclic
    Archive is cyclical.
    Values are saved in configured time intervals.
  • EventTriggerd
    Archive is event-triggered.
    Note: Event-triggered archives can only be used for automatic metering points.
    Direct configuration of event-triggered archives in the metering point administration is not possible.
  • Value Change
    Archive is spontaneous.
    Each change to a value is immediately written to the variable in the archive. Hysteresis can be configured.

Archive trigger

Trigger in order to write values to an archive.

Note: Only available with event-triggered archives.

Cycle time

Time interval in which values are written to the archive with cyclical scanning.

Format:

  • n.A.
    If archive type is Value Change or EventTriggerd.
  • DD:HH:MM:SS
  • Month With monthly cycle

Saving cycle

Time interval between the creation of new archive files.
Format:

  • DD:HH:MM:SS
  • Month With monthly save cycle.
  • Year With annual change save cycle.

Variables (list)

Parameters | Description
Name | Name of the variable.
Measuring unit | Measuring unit of the variables.
Identification | Identification of the variable.
Driver | Driver of the variable.
Equipment Groups | Equipment group that is assigned to the variable. Note: A variable can also be assigned to several equipment groups.

Navigation

Parameters | Description
Cancel | Discards all changes in all tabs and closes the dialog.


Relative value

Manual -> Wizards -> Topics -> Metering Point Administration -> Wizard - Metering Point Administration -> Metering Points -> Create new metering points -> Relative value

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Relative value

In this tab, a metering point is assigned to a relative value variable.

Parameters

Description

Create variable

A new variable is created for the relative value.

Type: LREAL, driver: INTERN.

Name

Name of the new variable to be created.

A valid name, based on the selected absolute value variable, is proposed. The name must be unique and can be given as desired. No special characters are permitted. A maximum of 256 characters can be entered.

The entry is validated. The result of the validation (success or error) is shown next to the input field by means of a symbol.

Note: Only visible if Create variable has been selected. A variable must be selected in the Absolute value tab, so that a proposed name is shown here.

Variable from archive

Shows list of archives and variables based on this in the selected archive.

Add variable to archive

Variables from the project are displayed. The selected variable is added to the selected archive.

Calculate relative value

Checkbox to activate the automatic calculation of relative values:

Selection is optional with automatic metering points.

Selection is automatically activated with manual metering points. This automatic preselection cannot be deactivated.

Note: You can get further information on the automatic calculation of relative values in the zenon Logic chapter.

New archive

Opens dialog for the creation of a new archive.

Not active if Variable from archive is active.

Archives

Archives that were previously created in zenon Editor or with the New archive button are ready for selection in list form. Only cyclical archives are displayed.

Archives (list)

Here, you select an archive from which you want to have variables displayed or to which you want to add a selected variable.

Note: Existing project configurations of archives are displayed in the list. In addition, it is possible to create a new archive directly in the wizard by clicking on the New archive button.

Parameters

Description

Short name

Archive reference.

Archive ID

Archive name

Type

Archive type

  • Cyclic
    Archive is cyclical.
    Values are saved in configured time intervals.
  • EventTriggerd
    Archive is event-triggered.
    Note: Event-triggered archives can only be used for automatic metering points.
    Direct configuration of event-triggered archives in the metering point administration is not possible.
  • Value Change
    Archive is spontaneous.
    Each change to a value is immediately written to the variable in the archive. Hysteresis can be configured.

Archive trigger

Trigger in order to write values to an archive.

Note: Only available with event-triggered archives.

Cycle time

Time interval in which values are written to the archive with cyclical scanning.

Format:

  • n.A.
    If archive type is Value Change or EventTriggerd.
  • DD:HH:MM:SS
  • Month With monthly cycle

Saving cycle

Time interval between the creation of new archive files.
Format:

  • DD:HH:MM:SS
  • Month With monthly save cycle.
  • Year With annual change save cycle.

Variables (list)

Parameters | Description
Name | Name of the variable.
Measuring unit | Measuring unit of the variables.
Identification | Identification of the variable.
Driver | Driver of the variable.
Equipment Groups | Equipment group that is assigned to the variable. Note: A variable can also be assigned to several equipment groups.
info Information
The list of variables is hidden if Create variable is active.

Navigation

Parameters | Description
Cancel | Discards all changes in all tabs and closes the dialog.


Summary

Manual -> Wizards -> Topics -> Metering Point Administration -> Wizard - Metering Point Administration -> Metering Points -> Create new metering points -> Summary

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Summary

The configurations of a metering point are evaluated and concluded in this tab.

The result is shown in the summary window in two fields.

Summary

Parameters

Description

Field for project configuration information

The upper field contains a summary of the configuration of the metering points.

The text information is distinguished by being displayed in different colors.

Black text color

Settings are correct. These are created and applied by clicking on Save & New.

Red text color

Errors in the configured settings must be checked once again and improved.

No saving is possible in this case.

Green text color

New settings are created and applied. Saving is now possible.

Blue text color

Amended project configurations are shown in blue text.

Orange text color

Warning messages.

Project configurations that are not recommended are shown in orange.

Field for additional information

General information about the steps carried out is shown in this field if available.

The color coding of the texts is the same as in the field for project configuration information. However in this text field, only successful (green text) and faulty steps (red text) are shown.

Save & New

Accepts settings and creates the new metering point. All values are reset and it is possible to continue with the configuration of other metering points.

If the project configuration in incorrect, corresponding project information is shown in the field for project configuration information.

Cancel

Discards all changes in all tabs and closes the dialog.


Edit metering points

Edit metering points

To edit an existing metering point, proceed as follows:

  1. Select a metering point that you want to edit in the Measuring points tab.
    The selected metering point is accented in color.
  2. Then click on the Edit button or double click on the desired metering point.
  3. The existing project configuration is shown in the Dialog Edit Metering Point.
  4. If you add more information, administer the metering point as you wish and click in the Summary tab on Save & Close.

Summary:

Amended settings are shown in the summary in blue.

  • Clicking on Save & Close saves the amended settings.


Delete Metering Point

Delete Metering Point

To delete an existing metering point, proceed as follows:

  1. Select a metering point that you want to delete in the Metering Points tab.
  2. Then click on the Delete button.
  3. A warning dialog appears.
  4. Confirm the deletion by clicking on the OK button.
  5. The selected metering point is deleted.

Warning dialog

Parameters | Description
OK | Selected metering point is deleted.
Cancel | Cancels deletion process. Warning dialog is closed without an action.
info Information
If an automatic metering point with automatic relative value calculation is deleted, the attendant project configurations (variables and code lines) are removed in zenon Logic.


New archive

New archive

The "New archive" button is visible:

  • If, in the Absolute value tab of the wizard, the Add variable to archive button is active.
  • If, in the Relative value tab of the wizard, the Create variable or Add variable to archive buttons are active.

Parameters

Description

Archiv Short name

Short name for the archive to be created.

Maximum 2 characters, 0-9 or A-Z, must be unique.

Attention: You cannot change the identification afterwards.

Archive ID

Name of the archive.

Default: empty

Archive type

Type of recording:

  • Cyclic
    The data is written to the archive in the set interval (default).
  • ValueChange
    Record on change

Cycle time

Define the cycle (days, hours, minutes and seconds) in which values for cyclical archives are to be read.

Default: 15 minutes (for cyclical archives)

Monthly

If active: The values are read in each time the month changes (monthly archive).

Default: inactive.

Saving cycle

Define the cycle time (days, hours and minutes) in which new archive files are to be created.

Default: 1 day

Note: grayed out if cycle time is monthly

Monthly

If active: The archive file is saved each time the month changes

Default: inactive.

Close dialog

Parameters | Description
Save | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.
info Information
You can get further information about archives in the Historian manual, in the Edit archives chapter.

Triggered or event-triggered archives are not available for metering point administration.


Background information

Manual -> Wizards -> Topics -> Metering Point Administration -> Wizard - Metering Point Administration -> Metering Points -> New archive -> Background information

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Background information

When creating new archives for absolute value and relative value variables in metering point administration, the duration of storage for archive files is set to the maximum possible value.

This is necessary because manual editing via the metering point administration is not possible for non-evacuated archive files (in *.ARX format). This does not include data that has been evacuated to SQL; subsequent manual editing of this is always possible.

Recommendation

To keep the number of files to be stored within limits, it is recommended that you configure a sufficiently large save cycle.

Hint Hint

Always configure your save cycle >= 1 day.
You can get further information in the Historian manual, in the Edit archive, Save chapter.

Offset and waiting time

To ensure correct archiving of the relative value, the metering point administration module carries out automatic project configurations.

The following settings are set automatically:

  • Offset: 5 seconds (only for relative value archives)
    You can find further information in the Historian manual, in the Edit archive, Recording type chapter.
  • VACO waiting time: 10 seconds
    If an automatic measuring point calculation is activated for relative value, the waiting time of the VACO must be set to 10 seconds and the offset for new relative value archives to 5 seconds.
    For existing relative value archives, the offset must be checked manually and amended accordingly.
    You can find more information in the VACO function block chapter.

Information during project configuration

The corresponding information is shown during project configuration in the Summary tab for the Metering Points:

  • Archive for absolute values should have offset 0 (corresponding warning message)
  • Relative value archive must have offset 5 (information, amendment is automatic)
  • Both archives should be different (corresponding waning message)


Visualization of incorrect project configurations

Manual -> Wizards -> Topics -> Metering Point Administration -> Wizard - Metering Point Administration -> Metering Points -> New archive -> Visualization of incorrect project configurations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Visualization of incorrect project configurations

If a problem occurs when configuring a project, this is signaled by a red warning symbol next to the problematic element. You get a detailed description in the tool tip, if you move to the warning symbol with the mouse.


Archive validation

Manual -> Wizards -> Topics -> Metering Point Administration -> Wizard - Metering Point Administration -> Metering Points -> New archive -> Archive validation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Archive validation

Archives used in the Metering Point Administration module are evaluated during project configuration.

Archive validation for the project configuration is carried out:

  • After the wizard has started, in the list of metering points.
    A cause for the incorrect project configuration could be editing the archive in zenon Editor directly.
  • When creating/editing metering points (Editor).
  • When creating a new archive using metering point administration (Editor and Runtime).
    Validation is triggered by clicking on the Save button.

Configuration criteria for relative value archives

Certain configuration criteria are applicable for automatic metering points for relative value archives. These criteria result due to the logic of the relative value calculation.
Archives created with the wizard always correspond to these criteria.

  • The cycle time must not be greater than the save cycle.
  • The save cycle must be an integral multiple of the cycle time.
  • If monthly change is selected as a cycle time, the save cycle must be a monthly change or yearly change.
  • If monthly change is selected as a save cycle, the cycle time must be a maximum of 1 day.


Examples

Manual -> Wizards -> Topics -> Metering Point Administration -> Wizard - Metering Point Administration -> Metering Points -> New archive -> Archive validation -> Examples

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Examples

Cycle time greater than save cycle

Save cycle not a whole-number multiple of the cycle time

Incorrect cycle time for monthly save cycle


Meter

Manual -> Wizards -> Topics -> Metering Point Administration -> Wizard - Metering Point Administration -> Meter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab, there is the possibility to create new meters, to administer them and to display the meters that have already been created in a list.

Parameters | Description
New... | Opens the dialog to crate a new meter.
Edit... | Opens a dialog to edit the selected meter.
Delete | Deletes the selected meter.

List of the configured meters

Parameters | Description
Name | Name of the meter.
Description | Description of the meter.
Manufacturer | Manufacturer of the meter.
Meter type | Type assignment of the meter.
Serial Number | Serial number of the meter.
Note | Note for the meter.
Year of construction | Year of construction of the meter.

Navigation

Button | Description
Exit | Closes the wizard. Changes that have not been saved are lost in the process.


Create new meter

Create new meter

In this dialog (both in the wizard and in Runtime), meters are configured and existing project configurations are amended.

Parameters | Description
Name | Identification of the meter. (Mandatory field)
Description | Description for the meter. Optional entry
Note | Note in relation to the meter. Optional entry
MeteringType | Type assignment of the meter. Drop-down list with types that have already been configured. This drop-down list also corresponds to the type list for the creation of a new metering point. Optional entry
Manufacturer | Name of the manufacturer of the meter. Optional entry
Serial Number | Serial number of the meter. Optional entry
Year of construction | Year of construction of the meter. Optional entry

Close dialog

Parameters | Description
Save & New | Saves the new meter. The dialog to create a new meter is then called up with empty content again. Other meters can be configured.
Cancel | Discards all changes and closes the dialog.

Note: Once the entries have been saved, a new entry is written to the database and the new entry is added to the list.


Configuration of a meter

Manual -> Wizards -> Topics -> Metering Point Administration -> Wizard - Metering Point Administration -> Meter -> Create new meter -> Configuration of a meter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Configuration of a meter

To create a new meter, proceed as follows:

  1. Click on the Meter button in the wizard
  2. Click on New.
  3. The dialog to create a new meter or amend an existing one is opened.

  4. Enter the information about the meter.

Note: Incorrect entries are signaled by a red warning triangle next to the input field.


Edit meter

Edit meter

To edit a meter that already exists, proceed as follows:

  1. Switch to the Meter tab.
  2. Select the corresponding meter in the list of the configured meters.
  3. Click on Edit.
  4. The Edit meter dialog is opened.
  5. Add any other desired information and administer the meter as you wish.
  6. Click on Save & Close.


Delete meter

Delete meter

To delete an existing meter, proceed as follows:

  1. Select a meter that you want to delete in the Meter tab.
  2. Then click on the Delete button and confirm the warning dialog with OK.
  3. The meter you have elected is deleted.

Note: If a meter is already connected to a metering point, it cannot be deleted. The Delete button is grayed out in this case. To delete a meter that has already been assigned, it must first be deleted from the metering point or replaced in Runtime.


Engineering in the zenon Editor

Manual -> Wizards -> Topics -> Metering Point Administration -> Engineering in the zenon Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In zenon Editor, configure an ActiveX element in a screen in order to be able to use metering point administration in Runtime.

  1. To do this, create a new screen in zenon Editor.
  2. Select the ActiveX element and draw an area in the screen with it.
  3. The Enter element dialog is opened.
  4. In this dialog, select MeteringPointControl.MeteringPointUserControl from the list of the ActiveX elements.
  5. Ensure that this ActiveX element is at least 900 pixels wide and 575 pixels high so that is is displayed correctly in Runtime.

info Information

You can find information about the ActiveX element in the Screens manual in the Screen elements/ActiveX chapter.


Metering Point Administration - administration of metering points in Runtime

Manual -> Wizards -> Topics -> Metering Point Administration -> Metering Point Administration - administration of metering points in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following is carried out in Runtime:

  • Configured metering points and meters are linked to one another.
  • New meters are created.
  • Existing meter information is amended.
  • Manual values are entered.


Database

Manual -> Wizards -> Topics -> Metering Point Administration -> Metering Point Administration - administration of metering points in Runtime -> Database

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters

Description

Database Host

Drop-down list for the selection of the database server.

Select, for example, your computer in this field. Note: Your computer is shown as a default when the tab is opened.

Authentication

Drop-down list for selection of the login method:

  • Windows Authentication (Default):
    The login to the database is carried out with the information of the user logged in to the local computer.
  • SQL Server Authentication:
    User name and password are entered manually. The corresponding login data must be available for database login.

User name

User name for login to a database.

Grayed out if the authentication is Windows Authentication.

Password

Password for login to a database.
For security reasons, each letter is shown with a * when the password is entered.

Grayed out if the authentication is Windows Authentication.

Connect

Establishes the connection to the configured database server.

If no connection is possible (for example due to incorrect entry of user name and/or password), an error message is called up.

Grayed out if it is already connected to a database server.

Disconnect

Disconnects an existing connection to a database server.

Grayed out if no connection is active.

Database Name

Drop-down list to select a database.

This list shows all available databases of the database server configured under Datenbank-Host.

If this list is empty, there is no connection to a database server or there is no SQL database available on the selected computer.

Start configuration

Switches to the Metering point tab.

If there is not currently a connection to a database, a connection with the login information that has already been entered is established when clicking on the Start configuration button.

If this input is incorrect or incomplete, no further settings can be changed in the Metering points or Meters tabs. A connection to a database is always necessary for this!

Navigation

Button | Description
Exit | Closes the wizard. Changes that have not been saved are lost in the process.
info Information
If there is already a connection to a database, all input fields are grayed out.


Metering Points

Manual -> Wizards -> Topics -> Metering Point Administration -> Metering Point Administration - administration of metering points in Runtime -> Metering Points

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Metering points in zenon Runtime are administered in this tab.

Parameters | Description
Assign Meter... | Only active if the selected metering point has not been assigned a meter.
Replace Meter... | Only active if the selected metering point has already been assigned a meter.
Manual value input... | Allows manual entry of values for the selected meter. If, in the selection of metering points, a metering point with automatic value transfer is selected, the Manual entry of values button is grayed out.
Post-editing... | Allows subsequent manual editing of relative values of metering points.
History... | Keeps a log of edited metering points and replaced meters.
Reload | Loads zenon project configurations in Runtime and gets new settings from the database.
info Information
If a variable of a project is not available, this is signalized by a red warning symbol in the list view. In this case, check to see if a project with these variables is loaded.


Assign, replace or remove meter

Manual -> Wizards -> Topics -> Metering Point Administration -> Metering Point Administration - administration of metering points in Runtime -> Metering Points -> Assign, replace or remove meter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Assign, replace or remove meter

In this dialog, individual meters can be assigned to a metering point, amended or removed.

With automatic metering points, the dialog for subsequent editing always opens when there is a change to the allocation of meters (new assignment, change, deletion).

Metering Point

Parameters | Description
Name | Name of the metering point. Cannot be changed in this dialog.
Location | Location of the metering point. Cannot be changed in this dialog.
Description | Description of the metering point. Cannot be changed in this dialog.
Measuring unit | Measuring unit of the metering point. Cannot be changed in this dialog.
Meter type | Type of meter. Cannot be changed in this dialog.

Manual

Parameters | Description
Date and time | Date and time of the meter allocation or meter replacement. Default: Query time period, rounded up to a complete hour. Clicking on the drop-down list opens a dialog to select the date and time. Note: Only the entry of dates from 1. 1. 2000 is possible. Calls before this date are not valid and are signalized by a red warning symbol.
Range | The range of the absolute value variable.
Min. | Minimum input range. Cannot be changed in this dialog.
Max. | Maximum input range. Cannot be changed in this dialog.
Old value | Value of the old meter at the time of replacement. Default: 0 Note: Only visible when a meter is replaced.
New value | Value of the new meter at the time of replacement. Default: 0 Note: If the entry is outside the input range of the variable (min./max.), the incorrect entry is automatically amended to the range.

Available meters

Parameters | Description
Available meters | List of available meters All meters of the appropriate meter type that are not yet assigned to a metering point are displayed. Only one meter per metering point can be assigned.
Select | Assigns the selected meter and transfers its values to the Assign meter range.
Delete | Deletes the assignment of a meter to a metering point. The meter itself is not deleted and remains in the list of meters.

Assign Meter

Parameters | Description
Name | Name of the assigned meter. Cannot be changed in this dialog.
Description | Description of the assigned meter Cannot be changed in this dialog.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.


Project configuration - meter assignment

Manual -> Wizards -> Topics -> Metering Point Administration -> Metering Point Administration - administration of metering points in Runtime -> Metering Points -> Assign, replace or remove meter -> Project configuration - meter assignment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Project configuration - meter assignment

To assign a meter to a metering point or to amend an existing assignment:

  1. Select a metering point in the list of metering points.
  2. Click on:
    1. Assign Meter if the meter has not yet been assigned to a meter.
    2. Replace Meter if the meter has already been assigned to a meter.
  3. The Assign Meter/Replace Meter dialog is opened.
  4. If a meter is replaced or assigned, enter the current value of the newly-assigned meter in New value.
    Note: A warning dialog appears if this value is already present in the archive.
    Entries that do not correspond to the input range are automatically amended to the maximum value or minimum value.
  5. In the event of a meter replacement or when a meter assignment is deleted:
    Also enter the current value of the meter to be replaced or deleted in the Old value input field.
    Entries that do not correspond to the input range are automatically amended to the maximum value or minimum value.
  6. Select a meter from the list of available meters.
    Note: All meters with the same metering point type as the selected metering point are displayed here.
  7. Configure the meter assignment:
    1. Click on the Select button to assign the selected meter to the metering point.
    2. Click on the Delete button to release a meter that has already been assigned from the metering point.
  8. The selected meter is:
    1. Applied in the Assign Meter area.
    2. Removed from the Assign meter area.
  9. Click on OK to end the assignment.
  10. The dialog is closed:
    1. For manual metering points:
      Absolute values are written to the absolute value archive. Corresponding relative values are calculated automatically and written to the relative value archive.
    2. For automatic metering points:
      The dialog for subsequent editing is opened.


Meter assignment for manual metering points

Manual -> Wizards -> Topics -> Metering Point Administration -> Metering Point Administration - administration of metering points in Runtime -> Metering Points -> Assign, replace or remove meter -> Meter assignment for manual metering points

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Meter assignment for manual metering points

Values are automatically written to the archive depending on the action:

  1. Reassign meter:
    New value
  2. Remove meter:
    Old value
  3. Replace meter:
    Both values
    Note: Time stamp for replacement:
    1. Old value: Current time stamp
    2. New value: Two seconds later than the time stamp of the old value.

Relative value calculation

The relative values are automatically recalculated.

  1. During assignment:
    1. Relative values between the new value and the last absolute value found before that are recalculated.
    2. Relative values between the new value and the last absolute value found after that are recalculated.
  2. During deletion:
    1. Relative values between the old value and the last absolute value found before that are recalculated.
    2. Relative values between the old value and the first absolute value found after that are recalculated.
  3. When replacing:
    1. Relative values between the old value and the last absolute value found before that are subsequently calculated.
    2. Relative values between the new value and the last absolute value found after that are recalculated.

Warning dialog

If a meter replacement is carried out at a time at which an archive entry already exists, this must be overwritten. A dialog warns of this.

Parameters | Description
Yes | Applies settings and closes the dialog.
No | Discards all changes and closes the dialog.
Cancel | Retains all changes. The changes are not carried out. The dialog remains open for corrections.


Meter assignment for automatic metering points

Manual -> Wizards -> Topics -> Metering Point Administration -> Metering Point Administration - administration of metering points in Runtime -> Metering Points -> Assign, replace or remove meter -> Meter assignment for automatic metering points

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Meter assignment for automatic metering points

With automatic metering points, the post editing dialog always opens when amending the assignment of a meter.
The new values are only applied to the relative value archive after completion of the project configuration in the post editing dialog!


Manual value input

Manual -> Wizards -> Topics -> Metering Point Administration -> Metering Point Administration - administration of metering points in Runtime -> Metering Points -> Manual value input

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Manual value input

Manual values can only be entered for manual (i.e. not automatic) metering points. With the manual value entry, values can be entered for a certain point in time. Value entries for the future are not permitted.

Metering Point

Parameters | Description
Name | Name of the metering point. Cannot be changed in this dialog.
Location | Location of the metering point. Cannot be changed in this dialog.
Description | Description of the metering point. Cannot be changed in this dialog.
Measuring unit | Measuring unit of the metering point. Cannot be changed in this dialog.
Meter type | Type of meter. Cannot be changed in this dialog.

Settings for manual value

Parameters | Description
Date and time | Date and time of the entry of the absolute value. Clicking on the drop-down list opens a dialog to select the date and time. Note: Only the entry of dates from 1. 1. 2000 is possible. Calls before this date are not valid and are signalized by a red warning symbol. Default: Query time point, rounded up to a complete hour.
Value | Absolute value of the manual meter. Note: If the entry is outside the input range of the variable (Min./Max.), this is signalized by a red warning symbol. Default: 0
Range | Range of the absolute value.
Min. | Minimum value of the absolute value variable Cannot be changed in this dialog.
Max. | Maximum value of the absolute value variable Cannot be changed in this dialog.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.


Manual value input

Manual -> Wizards -> Topics -> Metering Point Administration -> Metering Point Administration - administration of metering points in Runtime -> Metering Points -> Manual value input -> Manual value input

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Manual value input

To enter values manually:

  1. Select a manual metering point from the list of metering points.
  2. Click on the Manual value input button.
  3. The Manual value input dialog is opened.
  4. Select the date and time of the manual value:
    To do this, click on the Date and time drop-down list or enter the corresponding time in the input field directly.
    Attention: Manual value entries must not be in the future!
  5. Enter the new value in the input field
    Note: The valid input range of the selected variable is shown under Range.
  6. Click OK to apply the new value with the configured time stamp.
  7. The value input is validated.
    A warning dialog opens if there is already a value for the selected time point.
  8. The relative values are automatically recalculated.
    The following takes place after the values are entered:
    1. From the entered value until the last absolute value found is subsequently calculated.
    2. From the entered value until the next subsequent absolute value found is subsequently calculated.

Dialog in the event of duplicate value entries

If there is already an archive entry at the selected time point, this must be overwritten. A dialog warns of this.

Parameters | Description
Yes | Applies settings and closes the dialog.
No | Discards all changes and closes the dialog.
Cancel | Retains all changes. The changes are not carried out. The dialog remains open for corrections.

Show manual entries

Hint Hint

To have manual value entries shown, use the Post-editing button.


Post-editing

Manual -> Wizards -> Topics -> Metering Point Administration -> Metering Point Administration - administration of metering points in Runtime -> Metering Points -> Post-editing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Post-editing

Values from an archive can be subsequently edited in this dialog. Missing entries for relative values can be interpolated in order to get continuous values and thus, for example, close gaps more quickly as a result.

If, for an automatic metering point, the meter is replaced or deleted, the dialog for subsequent editing also opens.

Metering Points

Parameters | Description
Name | Name of the metering point. Cannot be changed in this dialog.
Location | Location of the metering point. Cannot be changed in this dialog.
Description | Description of the metering point. Cannot be changed in this dialog.
MeteringType | Type of the metering point Cannot be changed in this dialog.

Values

Parameters | Description
Time period | Time range from relative values and absolute values that is to be displayed.
From | Start of the time query Clicking on the drop-down list opens a dialog to select the date and time. Note: Only the entry of dates from 1. 1. 2000 is possible. Calls before this date are not valid and are signalized by a red warning symbol. Default: Query time point - 2 h (rounded up to a full minute).
To | End of the time query Clicking on the drop-down list opens a dialog to select the date and time. Note: Only the entry of dates from 1. 1. 2000 is possible. Calls before this date are not valid and are signalized by a red warning symbol. Default: Query time point (rounded up to the next whole minute).
Load | Loads the archive files for the absolute and relative values for the selected time range and lists these individually in the list of archive entries.
Interpolate | Smooths the relative values in the range between two selected absolute values. Selection of start and end by clicking and pressing the Shift key.
Apply | Writes the changes that have been made into the archive.
Range | Value range of absolute value.
Min. | Minimum value of the variable that is assigned to the metering point. Cannot be changed in this dialog.
Max. | Maximum value of the variable that is assigned to the metering point. Cannot be changed in this dialog.

List of archive entries

This list is empty when the dialog is called up. After the query time has been entered and the Load button is clicked on, the list is filled with the archive entries that are found.

Parameters | Description
Time | Time of the archive entry. Format: DD.MM.YYYY hh:mm:ss
Absolute value | Absolute value of the archive entry.
Relative value | Relative value of the archive entry.

Close dialog

Parameters | Description
Close | Closes the dialog.


Subsequent editing of values

Manual -> Wizards -> Topics -> Metering Point Administration -> Metering Point Administration - administration of metering points in Runtime -> Metering Points -> Post-editing -> Subsequent editing of values

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Subsequent editing of values

To edit values subsequently:

  1. Select the desired metering point in the Metering points tab.
  2. Click on the Post-editing... button.
  3. The post editing dialog is opened
  4. Select a time range.
  5. Click on Load to load the archive data for the absolute and relative values for the selected time range.
  6. The value entries that are found are shown in the list.

Interpolate values

There must be valid absolute values in order to be able to interpolate values.

  1. Go to the list of archive entries and select the absolute values that you want to use for filling with interpolated relative values.
  2. To do this, hold down the Shift key and select the start and end values that are to be used for interpolation.
  3. Click on Interpolate to automatically calculate relative values between these.
  4. The new values are shown in the relative value column.
  5. Click on the Apply button to transfer the newly-calculated relative values to the archive.

A dialog is called up if the start or end values for interpolation are not valid:

Enter relative values

  1. Click on the list of the archive entries for the relative value that you want to change.
  2. The field to enter the relative value is unlocked.
  3. Enter the desired new relative value.
  4. The entry is validated.

Validation

If the value entered is outside the valid input range, it is not possible to complete the entering of the values in the input field. This is visualized with a red warning symbol at the start of the line. You can get other error details in the tool tip if you move the mouse over the warning symbol.

Note: empty value entries are not permitted. In this case, enter the figure 0.


History

Manual -> Wizards -> Topics -> Metering Point Administration -> Metering Point Administration - administration of metering points in Runtime -> Metering Points -> History

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
History

The metering point history dialog shows the course of configuration of the selected metering point. Changes are not envisaged in this dialog.

Parameters | Description
Name | Name of the metering point. Cannot be changed in this dialog.
Location | Location of the metering point. Cannot be changed in this dialog.
Description | Description of the metering point. Cannot be changed in this dialog.
MeteringType | Type of the metering point Cannot be changed in this dialog.

History

Parameters

Description

Time

Time of the meter assignment or the meter replacement.

Old meter name

Name of the old meter.

Old meter value

Value of the old meter.

New meter name

Name of the new meter.

New meter value

Value of the new meter.

User ID

ID of the user who has entered the meter replacement.

User name

Name of the user who has entered the meter replacement.

Change type

The change that has been made is shown.

  • Added
    When a meter is assigned for the first time
    = Assign Meter
  • Changed
    When a meter replacement is carried out
    = Replace Meter
  • Deleted
    The assignment of a meter has been removed. No new meter was assigned to the metering point.

Close

Closes the dialog.

info Information

The history only shows changes of meter assignments for a metering point.

Value changes are not displayed in the history.


Meter

Manual -> Wizards -> Topics -> Metering Point Administration -> Metering Point Administration - administration of metering points in Runtime -> Meter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Meters are administered in Runtime in this tab.

Parameters | Description
New | Opens the dialog to crate a new meter.
Edit | Opens the dialog to edit the selected meter.
Delete | Deletes the selected meter.

List of the meters

Parameters | Description
Name | Name of the meter that has been created.
Description | Description of the meter.
Manufacturer | Manufacturer of the meter.
Meter type | Meter type of the meter.
Serial Number | Serial number of the meter.
Note | Note in relation to the meter that has been created.
Year of construction | Year of construction of the meter.


Create new meter

Manual -> Wizards -> Topics -> Metering Point Administration -> Metering Point Administration - administration of metering points in Runtime -> Meter -> Create new meter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Create new meter

In this dialog (both in the wizard and in Runtime), meters are configured and existing project configurations are amended.

Parameters | Description
Name | Identification of the meter. (Mandatory field)
Description | Description for the meter. Optional entry
Note | Note in relation to the meter. Optional entry
MeteringType | Type assignment of the meter. Drop-down list with types that have already been configured. This drop-down list also corresponds to the type list for the creation of a new metering point. Optional entry
Manufacturer | Name of the manufacturer of the meter. Optional entry
Serial Number | Serial number of the meter. Optional entry
Year of construction | Year of construction of the meter. Optional entry

Close dialog

Parameters | Description
Save & New | Saves the new meter. The dialog to create a new meter is then called up with empty content again. Other meters can be configured.
Cancel | Discards all changes and closes the dialog.

Note: Once the entries have been saved, a new entry is written to the database and the new entry is added to the list.


Configuration of a meter in Runtime

Manual -> Wizards -> Topics -> Metering Point Administration -> Metering Point Administration - administration of metering points in Runtime -> Meter -> Create new meter -> Configuration of a meter in Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Configuration of a meter in Runtime

To create a new meter, proceed as follows:

  1. Click on the Meter tab.
  2. Click on New.
  3. The dialog to create a new meter or amend an existing one is opened.

  4. Enter the information about the meter.

Note: Incorrect entries are signaled by a red warning triangle next to the input field.


Edit meter

Manual -> Wizards -> Topics -> Metering Point Administration -> Metering Point Administration - administration of metering points in Runtime -> Meter -> Edit meter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Edit meter

To edit a meter that already exists, proceed as follows:

  1. Switch to the Meter tab.
  2. Select the corresponding meter in the list of the configured meters.
  3. Click on Edit.
  4. The Edit meter dialog is opened.
  5. Add any other desired information and administer the meter as you wish.
  6. Click on Save & Close.


Delete meter

Manual -> Wizards -> Topics -> Metering Point Administration -> Metering Point Administration - administration of metering points in Runtime -> Meter -> Delete meter

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Delete meter

To delete an existing meter, proceed as follows:

  1. Select a meter that you want to delete in the Meter tab.
  2. Then click on the Delete button and confirm the warning dialog with OK.
  3. The meter you have elected is deleted.

Note: If a meter is already connected to a metering point, it cannot be deleted. The Delete button is grayed out in this case. To delete a meter that has already been assigned, it must first be deleted from the metering point or replaced in Runtime.


zenon Logic components of metering point administration

Manual -> Wizards -> Topics -> Metering Point Administration -> zenon Logic components of metering point administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The calculation of relative values with automatic metering points is implemented with the Calculate relative value setting active with zenon Logic.

Necessary configurations are automatically applied by the metering point administration. You can find information about these automated steps in the Summary tab of the Metering Point Administration wizard in zenon Editor. You are informed of any problems that occur in this tab.

tutorial License information

Additional licensing of zenon Logic is not necessary. The standard licensing is sufficient.


zenon Logic project configurations for metering point administration

Manual -> Wizards -> Topics -> Metering Point Administration -> zenon Logic components of metering point administration -> zenon Logic project configurations for metering point administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When creating automatic metering points with the Calculate relative value setting activated, the following actions are carried out in the background:

Creation of a driver

  1. Typ STRATONNG
  2. Name: MeteringPoint
  3. Amendment of the driver settings
    1. Host: localhost
    2. Port: 14731
      The port number is increasing by 1 for every loaded project if there are many projects in the workspace.

Creation of a zenon Logic project

  1. Name: MeteringPoint
  2. Host: localhost
  3. Port: 14731
    The port number is increasing by 1 for every loaded project if there are many projects in the workspace.

Creation of a program in the zenon Logic project for the calculation of relative values

Name: RelativeValueCalculation

Once configuration has been completed, the zenon Logic project and the zenon project are compiled.

The zenon Logic Workbench must be closed during the configuration of a metering point in the wizard. If there is a problem, a corresponding warning message appears in the Summary of the wizard.

attention Attention

All manual changes to the MeteringPoint driver, as well as the changes to the zenon Logic MeteringPoint project (including RelativValueCalculation program) can lead to automatic relative value calculation no longer working.


Apply changes in zenon Logic

Manual -> Wizards -> Topics -> Metering Point Administration -> zenon Logic components of metering point administration -> Apply changes in zenon Logic

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Changes to the configuration of metering points can lead to changes in the zenon Logic Program.

These changes are not applied in Runtime by reloading. The current zenon Logic program is only loaded when Runtime is restarted.

Example Example

Change to the cycle time of an existing archive.

In order for correct calculations to take place for a metering point with calculated relative values (Calculate relative value property active), zenon Runtime must be restarted.


VACO function block

Manual -> Wizards -> Topics -> Metering Point Administration -> zenon Logic components of metering point administration -> VACO function block

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The VACO function block in zenon Logic carries out the calculation of relative values.

When creating automatic metering points with the "Calculate relative value" setting activated, an instance of the function block is created in the zenon Logic program RelativValueCalculation for the corresponding metering point. If an automatic metering point with activated relative value calculation is deleted or the relative value calculation for an automatic metering point is deactivated, the attendant project configurations (variables and lines of code) are removed in zenon Logic.

Programming - source code

//Instance for Metering Point MessstellenName

VACO_MessstellenID(ANY_TO_LREAL({AbsolutVariablenName}),INT#1,{FunktionsTriggerVariablenName},T#5s,FALSE,0.0);

{RelativVariablenName}:=ANY_TO_DatenTypRelativVariable(VACO_0001);

{ArchivTriggerVariablenName}:=VACO_MessstellenID.TA;


ArchivTrigger function block

Manual -> Wizards -> Topics -> Metering Point Administration -> zenon Logic components of metering point administration -> ArchivTrigger function block

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The ArchivTrigger function block carries out the necessary calculations (in the background) in order to trigger cyclical archives with the configured cycle time.

If the project configuration of a cyclical archive for the metering point administration in zenon is changed, the zenon Logic program is automatically updated after the wizard is opened.

Programming - source code

//Instance for Trigger RE

Trigger_RE(ULINT#1420066800,ULINT#900,ULINT#28800,False,False,False);

OUT_TF_RE:=Trigger_RE.TF;


Pharmaceutical

Manual -> Wizards -> Topics -> Pharmaceutical

Wizards for the pharmaceutical industry.


Pharmaceutical Wizard

Manual -> Wizards -> Topics -> Pharmaceutical -> Pharmaceutical Wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The pharmaceutical wizard enables the management of validated projects for the pharmaceutical industry. It summarizes the relevant settings necessary for a Good Manufacturing Process (GMP) project. These settings can be managed and changed in the wizard. The settings are loaded into the wizard either via an existing project or via a configuration files.

The following settings are managed:

  • General project settings
  • User administration
  • User groups
  • Settings for the Chronologic Event List
  • Settings for the Alarm Message List
  • XML template

Engineered settings in the wizard can be:

  • written back to the active project
  • saved in a new project
  • saved to a special configuration file
    These configuration files created in the wizard can be used over and over again and can be enhanced. However they can be only read and edited with the wizard.


Start wizard

Manual -> Wizards -> Topics -> Pharmaceutical -> Pharmaceutical Wizard -> Start wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To start the wizard:

  1. Click on File-> Wizards...

    or press the short cut Alt+F12

  2. The selection window with the available wizards opens
  3. Select the Pharmaceutical folder
  4. select the Pharmaceutical Wizard there

  5. click on OK
  6. The wizard starts with the welcome page


Welcome

Manual -> Wizards -> Topics -> Pharmaceutical -> Pharmaceutical Wizard -> Welcome

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tab Welcome informs you about performance and use of the wizard.

The navigation through the wizard is done by clicking on the individual tabs or step by step by clicking on the arrow keys.

Click on Cancel to close the wizard. All changes made to a file or project since the last saving are discarded.


Settings

Manual -> Wizards -> Topics -> Pharmaceutical -> Pharmaceutical Wizard -> Settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab:

  • Settings are loaded
  • Project descriptions are adapted

Parameters | Description
Configuration | Definition which project is edited.
Load from active project | Loads the settings of the active project in the workspace into the wizard.
Load from configuration file | Loads data from a saved configuration file (*.cof). The file is selected from the list. The list displays all available configuration files in the selected folder (Select directory). Info: The configuration files can only be read, created and edited with the wizard.
Select directory | Opens file selection dialog in order to select the folder in which the desired configuration files (*.cof) are available. They are displayed in the list below the button.
Templates | Settings for XML and XRS templates.
Project description | Information about the project as defined in property Project description of the dialog. It is taken over by the loaded project and can be edited. For checking purposes all changes are displayed on tab Finish.
Author | Author of the project.
Manager | Project manager.
Company | Company.
Comment | Comment.


Project properties

Manual -> Wizards -> Topics -> Pharmaceutical -> Pharmaceutical Wizard -> Project properties

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Settings for:

  • Network
  • Authorization in the network
  • History of changes

Parameters

Description

Network

Internal ID: Project properties

Network

Properties for use of the project in a network.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

GRP_Net

Active

Internal ID: Project properties

Network active

Active: The project is used as a network project. A server must be defined.
Inactive: The project is a standalone project.
Default: inactive.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

NetActive

Server name

Internal ID: Project properties

Server 1

Only available if property Network active is active.
Computer which establishes the connection to the hardware for network projects and which manages the project data. The clients connect to this computer.

Clicking on ... opens the dialog with a list of the computers available in the network.

Hint name: The IP address is not sufficient; the name of the computer must be entered. "localhost" must not be used as name.
If the name is changed, it cannot be reloaded. It is updated only after the Runtime has been restarted.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

NetServer

Standby name

Internal ID: Project properties

Network active

Active: The project is used as a network project. A server must be defined.
Inactive: The project is a standalone project.
Default: inactive.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

NetActive

Redundancy type

Internal ID: Project properties

Redundancy type

Only available if a computer has been specified in property Server 2.

zenon supports two types of redundancy:

  • Software redundancy: The system consists of one PLC and two redundant control system computers. Both computers must have a connection to the PLC. Both computers communicate with the control and at the same time keep the data from the control updated. The communication to the control is managed by the computer which is the server. The server communicates bidirectionally, the standby communicates unidirectionally. If the Server crashes, the Standby Server takes over the bidirectional communication with the PLC.
  • Hardware redundancy: The system consists of two redundant PLCs and two redundant control system computers. Each server communicates bidirectionally with one PLC. Both computers and both PLCs are synchronizing their data. If one component in the first system crashes, the second system takes over.

Default: Software redundancy

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

NetType

Network authorization

Internal ID: Project properties

Authorization

Properties for the operating authorization in the network.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

GRP_Token

Active

Internal ID: Project properties

Authorization in network active

Only available if property Network active is active.
The authorization in the network makes sure that in the network only one station at a time can carry out active operations (e.g. change set values). Passiv, reading access is always possible regardless of the option.
Active: Only on computer can operate the project at a time (e.g. acknowledge alarms, write set values).
Inactive: Several computers can operate the project at the same time.
Default: inactive

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

NetTokenActive

Timeout for request [s]

Internal ID: Project properties

Timeout for request [s]

Only available if the Authorization in network active property has been activated.
If the authorization in the network is blocked by a station, it can be requested by another computer. Within the time limit defined here the request must be answered. After the time expires without an answer, the requesting station automatically receives the authorization.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

NetTokenQuestion

Timeout for acknowlewdgement [s]

Internal ID: Project properties

Timeout for authorization [s]

Only available if the Authorization in network active property has been activated.
Within this time the computer (Client) which has the authorization must report to the Server. If this does not happen, the authorization is released automatically.
Attention: This value must be smaller than the time defined in property Timeout [s].

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

NetTokenQuit

History of changes

Internal ID: Project properties

History of changes

Properties for the history of changes.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

GRP_ChangeLog

Active

Internal ID: Project properties

History of changes active

Active: Changes to the project are also logged.
Inactive: Changes to the project are not logged.
Default: inactive.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

ChangeLogAktiv

Detailing level

Internal ID: Project properties

Detailling level

Only available if property History of changes active is active.

Selection of details levels from drop-down list.

  • Object: Only the object names of the changed objects are logged. Details concerning properties and their values are not displayed in the History of changes.
  • Properties: Additionally to the object names the changed properties and the new values are displayed in the history of changes.
  • Value changes: This setting causes the most detail level of logging. Not only the new value of a property is displayed but also the old one. This makes a complete tracability of the changes of values possible.

Default: Properties

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

ChangeLogState


User administration

Manual -> Wizards -> Topics -> Pharmaceutical -> Pharmaceutical Wizard -> User administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Settings for the user administration:

Parameters

Description

User administration

Internal ID: User administration

User administration

Project-related properties for user administration.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

GRP_Password

Delete users

Internal ID: User administration

Deleting users

  • Active: Deletion of a user in Runtime is permitted.
  • Inactive: Users can only be marked as deleted. The users remain in the list of users, but are no longer valid for operation in Runtime (in accordance with FDA guidelines).

Default: active

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

DelUser

Minimum password length

Internal ID: User administration

Minimum password length

Minimum length of the password in characters.

  • Minimum: 0
  • Maximum: 20

Default: 6

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

MinPwLength

Period of password validity [days]

Internal ID: User administration

Password - period of validity [d]

Enter a time period (in days) defining how long a password should stay valid. After the time expired, you must enter a new password.

  • Minimum: 0 - The password never expires and need not be renewed. For this setting the value 2147483647 is written to system driver variable "Days until password expires".
  • Maximum: 4294967295

Default: 0
Attention: For productions according to the FDA guidelines entry 0 is not allowed as the rules of the FDA demand a cyclic change of the password.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

PWValid

Number of invalid user name inputs

Internal ID: User administration

Minimum password length

Minimum length of the password in characters.

  • Minimum: 0
  • Maximum: 20

Default: 6

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

MinPwLength

Number of invalid password inputs

Internal ID: User administration

Max. password error

Number of incorrect password entries.
The corresponding user is blocked if this number is exceeded. The block can only be lifted by an administrator. A corresponding dialog is created in the Chronological Event List (CEL).

  • Minimum: 0
  • Maximum: 65535

Default: 3

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

PasswordTries

User administration storage

Saving the user administration

Selected user storage

Select where you want to save the user administration:

  • Project
  • Active Directory (AD)
  • Active Directory Application Mode (ADAM)

ADAM connection string

Internal ID: User administration

AD-LDS connection

Connection path to ADAM or AD LDS.

You must enter the connection path in the following form: [PC name]:[port]/[organization]

Example: w3k:50000/O=720,c=com

More about the AD LDS in the online help.

More about ADAM in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

ADAM

ADAM user identification

Internal ID: User administration

AD-LDS username

User name of a local user of the ADAM/AD LDS PC with administration rights.

More about the AD LDS in the online help.

More about ADAM in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

ADAMUser

ADAM password

Internal ID: User administration

AD-LDS password

Password of the local user of the ADAM/AD LDS PC.

More about the AD LDS in the online help.

More about ADAM in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

ADAMPwd

Log out/log in

Properties for log in and log out.

Activate automatical logout

Internal ID: User administration

Activate automatical logout

  • Active: The user is automatically logged out if there is no operation for the time period defined in the Time [min] property.
  • Inactive: The user is not automatically logged out by the system.

Default: inactive

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

AutoLogout

Activate temporary login

Internal ID: User administration

Temp. login active

Activation of temporary login for users who want to operate an element but are not logged in:

  • Active: A user who needs operating authorization is requested to enter their identification and password. To do this, the login screen or a modal dialog is called up, depending on the configuration. The user is automatically logged out again immediately after the operation
  • Inactive: The user who needs operating authorization is informed that they are not entitled to carry out this operation.

Default: active

Note:

  • You can define the position and size of the modal dialog in the zenon6.ini file at [Befehlsgabe] Position =.
  • The login screen can be used instead of the modal dialog. This is defined with the Screen for Login with signature property.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

TempLogin

Locked buttons style

Internal ID: User administration

Locked buttons

Only available if the property is Temp. login active inactive.
Defines the look of buttons that are locked due to the configuration of the authorization. Is combined in the Runtime for the operation of keys with property Interlocked buttons (graphical design).

Possible formats:

  • Grey
  • Normal
  • Invisible

Default: Normal

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

DisabledButtonStyle

Set names for authorization levels

Conforms to property Rename authorization levels.

You can assign a name to each of the 128 authorization levels. Click in the right-hand column in order to enable the renaming.


User groups

Manual -> Wizards -> Topics -> Pharmaceutical -> Pharmaceutical Wizard -> User groups

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab you assign authorization levels to user groups.

Parameters | Description
User groups | List of user groups
User group levels | List of the authorization levels
Delete | Deletes selected object without confirmation message.

Click on a user group in order to show its authorization level. Click on the level in order to edit it. The name is automatically adapted. Click on an empty level in order to insert a new authorization level.

When clicking on Delete , you can delete both the groups and the assigned authorization levels. At deleting no confirmation message is displayed.


CEL & alarms

Manual -> Wizards -> Topics -> Pharmaceutical -> Pharmaceutical Wizard -> CEL & alarms

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Configuration of the Chronological Event List and the Alarm Message List.

Parameters

Description

Chronlogic Event List and Alarm Message List

Internal ID: CEL & alarms

Chronological Event List

Properties for administration of the Chronological Event List (CEL).

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

GRP_CEL

CEL active

Internal ID: CEL & alarms

CEL active

  • Active: The Chronological Event List (CEL) is active in the Runtime. Events are recorded and the CEL is available.
  • Inactive: No event are recorded.

Default: active

Note: Changes take effect after the Runtime has been restarted.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

CELAdminActive

Update automatically

Internal ID: CEL & alarms

Update automatically

Only available if property CEL active is active.

  • Active: During the time the CEL is opened in the Runtime, new events are immediately added when they occur.
  • Inactive: As long as the CEL is opend no new entries are added. The new entries are added when the CEL is opened the next time.
    Default: active

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

CELSpontan

Print system messages

Internal ID: CEL & alarms

Print system messages

Active: At online printing system messages are also printed.
Inactive: At online printing system messages are not printed.
Default: active

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

CELSysMsgPrint

Long dynamic limit texts CEL

Internal ID: CEL & alarms

Long dynamic limit texts CEL

Determines whether the comment field for dynamic limit texts is available. The dynamic limit allows you to include the current values of other variables in the limit text of a variable.

  • Active: Dynamic contents will be stored in a file with the file format D*.CEL. It will be stored in addition to the file C*.CEL. The comment filed can therefore been used for comments. Dynamic limit value texts can have a maximum length of 1024 characters.
  • Inactive: The comment field is used for dynamic limit texts and is therefore not available for comments. Maximum length: 80 characters.

Default: Inactive.

More in the online help

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

CELLongDynLimits

Signature text editable

Internal ID: CEL & alarms

Signature text editable

Active: A dialog to edit the signature text is opened in Runtime.

Inactive: The signature text cannot be changed in Runtime.

Default: inactive

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

EditSignature

Data storage CEL

Internal ID: CEL & alarms

Data storage CEL

Properties for saving Chronological Event List entries (CEL) in the main memory and to the hard drive.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

GRP_CEL_Mem

Size of the ringpuffer

Internal ID: CEL & alarms

Size of the ringbuffer

Only available if property CEL active is active.
Size of the CEL ring buffer. If the ring buffer overflows (cel.bin), the entries are transferred to the CEL archive (*.cel).
Minimum: 1
Maximum: 32767
Default: 100

Note: In the Runtime it is possible that more entries are displayed than you engineered as old entries are only removed from the CEL when the list is updated.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

CELMemCount

Save CEL data

Internal ID: CEL & alarms

Save CEL data

Only available if property CEL active is active.

  • Ring buffer and historic data: All CEL entries (*.cel) are saved.
  • Only ring buffer: Only a defined number of CEL entries (cel.bin) is saved. The number is defined via property Size of the ringbuffer.
  • Default: On CE devices only the ring buffer (cel.bin) is saved on the hard disk; on PCs the historic entries (*.cel) are also saved.

Default: Default
The files (cel.bin and *.cel) are saved in folder\project folder\computer name\project name.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

CelOnlyStack

Save ringpuffer on change

Internal ID: CEL & alarms

Save ringbuffer on change

Selection of the type of data saving:

  • Active: Each change of the data of the Chronological Event List (CEL) triggers the saving of the data (cel.bin).
  • Inactive: Data of the CEL (cel.bin) are only when the Runtime is closed or when function Save AML and CEL ring buffer is executed. Recommended especially for low performance. Historic data (*.cel) can be saved independently at every value change.

Note: If the property is set to active, this can lead to a considerable load being placed on the system - with flash disks most of all. If the property is set to inactive, this can lead to data being lost in the event of Runtime closing unexpectedly. Inactive Recommended especially for low performance.

Default: inactive

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

SaveCelStack

Logging

Internal ID: CEL & alarms

Logging

General properties for the Chronological Event List (CEL).

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

GRP_CEL_Common

Alarm acknowledgement

Internal ID: CEL & alarms

Alarm acknowledgement

Only available if property Alarm Message List active is active.
Active: If an alarm is acknowledged, an entry is created in the Chronological Event List (CEL).
Inactive: Acknowledging an alarm does not trigger an entry in the CEL.
Default: Inactive.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

AlarmCELAcknowledge

Function Set SW

Internal ID: CEL & alarms

Function Set SV

Only available if property CEL active is active.

  • Active: At successful writing of values to the hardware, a corresponding entry is entered in the CEL.
  • Inactive: The successful writing of values is not logged in the CEL.

Default: inactive

Note: This setting only has an effect on Runtime if the writing of the set value is carried out using the Write set value function.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

CELPokeAck

Send recipes

Internal ID: CEL & alarms

Send recipes

Only available if property CEL active is active.

  • No logging: The changing of standard recipes and recipes of the Recipegroup Manager (RGM) is not logged in the CEL.
  • Log recipes: When sending a recipe, it is logged with the name of the recipe in the CEL.
  • Log recipes and values: When writing a recipe, it is logged in the CEL with:
    • Name of the recipe
    • New and old values of the variables
    • Names of the variable

Default: no logging

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

RecipeWriteToCEL

Change recipes

Internal ID: CEL & alarms

Change recipes

Only available if property CEL active is active.

  • No logging: Changing standard recipes and recipes of the Recipegroup Manager (RGM) is not logged in the CEL.
  • Log recipes: When changing a recipe, it is logged with the name of the changed recipe in the CEL.
  • Log recipes and values: The following is logged in the CEL when the recipe is changed:
    • Name of the recipe
    • New and old values of the variables
    • Names of the variable

Default: no logging

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

RecipeChangeToCEL

Alarm groups

Alarm/event groups

Add

Adds the character string entered in the input field as new alarm/event group. Adding can also be carried out via key Enter.

Remove

Deletes highlighted alarm/event group.

Alarm classes

Alarm/event classes

Add

Adds the character string entered in the input field as new alarm/event class. Adding can also be carried out via key Enter.

Remove

Deletes highlighted alarm/event group.


Templates I

Manual -> Wizards -> Topics -> Pharmaceutical -> Pharmaceutical Wizard -> Templates I

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab you can edit the following elements:

  • Screens
  • Datatypes
  • Palettes
  • Reaction matrices

In each right-hand list the XML files, which exist in the current configuration file for the element, are displayed and edited.

Buttons | Function
Right-hand list |
Export | Opens the dialog for exporting XML files which were created in the Editor via command Exported selected XML.
Import | Opens the dialog for importing XML files which were created in the Editor via command Exported selected XML. Import is carried out in folder %ProgrammData%\Copa-Data\zenon700\Templates\PharmaWizard.
Delete | Deletes XML files that have been created in the Editor using the Export selected XML command.
Left-hand list |
Add | Adds templates from the left-hand list. As an alternative you can also carry out a double click on the template. Saving to the current project or to another project is carried out on tab Finish.
Remove | Removes template from the list.


Templates II

Manual -> Wizards -> Topics -> Pharmaceutical -> Pharmaceutical Wizard -> Templates II

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab you can edit the following elements:

  • Symbols
  • Reports from the Report Generator

In each right-hand list the XML files, which exist in the current configuration file for the element, are displayed and edited. Reports are saved as XRS files.

Buttons | Function
Right-hand list |
Export | Opens the dialog for importing XML files which were created in the Editor via command Exported selected XML.
Import | Opens the dialog for importing XML files which were created in the Editor via command Exported selected XML. C:\\ProgrammData\Copa-Data\zenon700\Templates\PharmaWizard.
Delete | Deletes XML files which were created in the Editor via command Exported selected XML.
Left-hand list |
Add | Adds templates from the left-hand list. As an alternative you can also carry out a double click on the template. Saving to the current project or to another project is carried out on tab Finish.
Remove | Removes template from the list.


Finish

Manual -> Wizards -> Topics -> Pharmaceutical -> Pharmaceutical Wizard -> Finish

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this tab:

  • the project description is entered
  • you define how the changed engineering is saved

Parameters | Description
Project description | Information about the project as defined on tab Settings. Display only, cannot be changed.
Author | Name of the engineer.
Manager | Name of the manager.
Company | Company.
Comment | Comments to the project.
Save configuration settings | Options for saving changes done by the wizard.
Message field | Messages about success/failure of save actions.
... in current project | All settings are loaded in the current project. With this the settings in the project are overwritten.
... as new project | A new project is created with the defined settings and the selected frames. You must first select a project name.
... as fíle | A new configuration file of file name *.cof is created. If the name of an existing configuration file is used it is overwritten. Attention: The created configuration files can only be read, created and edited with the wizard.
Name | Name of the configuration file.


Project

Manual -> Wizards -> Topics -> Project

Wizards for:

  • Project creation
  • the compare of project backups
  • the creation of a project documentation


Project comparison

Manual -> Wizards -> Topics -> Project -> Project comparison

The wizard makes it possible to compare project backups. At this it is analyzed which objects and elements were deleted, added and/or changed. The result can be saved and displayed as XML or HTML file.

Requirements

The wizard can read in and compre project backups which:

  • were saved as zip file
  • were created with activated versioning
  • were created with activated XML export

To activate versioning and XML export:

  1. open the General node in project settings.
  2. go to section Versioning
  3. Activate the Versioning active property
  4. Activate the XML export active property

Temporary files

During the compare the wizard unzips the project backup in the temporary fodler BackUpComparisonWorkingFolder. It is created in path C:\Users\Public\Documents\zenon_Projects\Worspace. This temporary folder is deleted when the wizard is closed.


Start wizard

Manual -> Wizards -> Topics -> Project -> Project comparison -> Start wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To start the wizard:

  1. Click on File-> Wizards...

    or press the short cut Alt+F12

  2. The selection window with the available wizards opens
  3. Select the Project folder
  4. select the Backup Comparison Wizard there

  5. click on OK
  6. The wizard starts with the welcome page


Welcome

Manual -> Wizards -> Topics -> Project -> Project comparison -> Welcome

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tab Welcome informs you about performance and use of the wizard.

The navigation through the wizard is done by clicking on the individual tabs or step by step by clicking on the arrow keys.

Click on Cancel to close the wizard.


Settings

Manual -> Wizards -> Topics -> Project -> Project comparison -> Settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab the two project backups which should be compared are selected and the zenon modules which should be part of the compare.

Parameters

Description

Select project backups

Selection of the backup files.

Latest version

Latest version. A click on button ... Opens the file browser to select a project backup.

Note: Per default project backups are in folder %ProgramData%\COPA-DATA\SQL2008R2\BACKUP\[Project]; via export however they can be stored in any folder.

Older version

Older version. A click on button ... Opens the file browser to select a project backup.

Select project modules

Selection of the modules which should be compared. Selection takes place via activating the checkboxes in front of the module names.

These settings are saved for each user individually and are available when the wizard is opened again.

Cursor keys

Click on the button to go to the previous or next tab.

Cancel

Closes the wizard.


Compare

Manual -> Wizards -> Topics -> Project -> Project comparison -> Compare

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab the project backups are compared on basis of the selected modules.

Parameters

Description

List field

After you click on button Compare the differences of the project backups are displayed in the list field.

Content of the columns:

  • Module: Name of the module.
  • Result: Name of the object.
  • Element: Display and description of the element.
  • Parameter: Name of the changed parameter.
  • Old: Previous value of a changed parameter.
  • New: New value of a changed parameter.

Color-coded marking:

  • blue: new objects and elements
  • red: deleted objects and elements
  • green: changed objects and elements
  • black: unchanged objects and elements

Navigation

Elements for the navigation in the list.

Changed elements

Active: Click on the button with the vertical arrow in order to jump to the previous/next changed element.

Deleted elements

Active: Click on the button with the vertical arrow in order to jump to the previous/next deleted element.

New elements

Active: Click on the button with the vertical arrow in order to jump to the previous/next new element.

Show only differences

Active: After you click on button Compare only the differences are displayed color-coded; unchanged elements are not displayed.

If this option is changed, you must start the compare again by clicking Compare.

Compare

Compares the project backups in accordance with the selection and displays them in the list field.

vertical double arrow buttons

Click on the button to jump to the previous/next module.

Vertical arrow buttons

Click on the button to jump to the previous/next result of the same type depending on the setting.

  • Changed elements
  • Deleted elements
  • New elements

Horizontal arrow keys

Click on the button to go to the previous or next tab.

Cancel

Closes the wizard.

Example project compare:

All objects:

Some changes:

In module screens:

  • the screen batch was deleted
  • in screen SYSTEM_2 a text element was changed
  • in screen START a button named Button_1 was added
  • in screen ALARM nothing was changed

Only differences:

The changes are visible in the same way as in the previous screenshot. Objects and elements which have not been changed are hidden.


Documentation

Manual -> Wizards -> Topics -> Project -> Project comparison -> Documentation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab you can display and save the result of the project backup compare as XML file or HTML file.

Parameters

Description

Settings

Settings for type of documentation.

Create XML

Active: An XML file is created.

Create HTML

Active: A HTML file is created.

Save Path

Path to the folder in which the file is saved. Display only. Selection is carried out via button Compare.

Create documentation

Click on button:

  • to open the file browser: Select the saving location and give a name to the documentation file.
  • The documentation is saved in the desired type and is displayed in the list field.

List field

Display documentation.

Arrow button

Click on the button to go to the previous tab.

Cancel

Closes the wizard.

Example XML file

Display in the wizard:

Display as XML file:

Example HTML file

At the creation of an HTML file, an XML and an XSLT file are also created at the saving location. These two files are used to generate the HTML file dynamically:

Structure of the HTML file:


Project Wizard

Manual -> Wizards -> Topics -> Project -> Project Wizard

With this wizard you can create basic objects for new projects. You can configure:

  • Information about the project
  • Drivers also with driver variables
  • Graphics settings
  • Basic screens with symbols, WPF element, AML, CEL, system information and an overview of the simulation variables
  • Navigation

Settings changed in the wizard are saved in the user profile of the operating system and loaded at the next opening by the same user.

The wizard is executed in English; the language in the project corresponds to that of the open zenon Editor. This wizard is automatically executed when a new project is created.

Hint multi-user projects: The wizard does not support multi-user projects. When a new multi-user project is created, the wizard is not automatically started. With a manual start, it is ended again with a warning message.

info Information

If the wizard is selected manually via the Wizard selection dialog, then the following must be the case:

  • An empty project must be created
  • The project must be active


Start wizard

Manual -> Wizards -> Topics -> Project -> Project Wizard -> Start wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This wizard is automatically executed when a new project is created. It can also be selected directly in the dialog for starting wizards.

Attention: If the wizard is started in an existing project, existing objects may be changed or overwritten.

To start the wizard manually:

  1. Click on File-> Wizards...

    or press the short cut Alt+F12

  2. The selection window with the available wizards opens
  3. Select the Project folder

  4. Select the VSTA Project Wizard there

  5. click on OK
  6. The wizard starts with the welcome page

If you call up the wizard from an existing project, you receive a warning:

By clicking on Yes, you confirm that you accept changes to your existing configuration.


Welcome

Manual -> Wizards -> Topics -> Project -> Project Wizard -> Welcome

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tab Welcome informs you about performance and use of the wizard.

The navigation through the wizard is done by clicking on the individual tabs or step by step by clicking on the arrow keys.

Click on Close to close the wizard.

Click on Overwrite to create the project and overwrite possibly existing objects. Only active if tab Finish is opened.


Project info

Manual -> Wizards -> Topics -> Project -> Project Wizard -> Project info

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab you configure general project settings and settings concerning versioning and history of change.

Parameters

Description

Author

Author of the project.

Manager

Responsible manager.

Company

Company.

Comment

Comments to the project.

Backup settings

Settings for versioning.

Versionierung

Internal ID: Project info

Versioning active

Active: Project versioning is used. Every project backup is saved with an own version number.

Inactive: no versioning of the project backup.

Default: inactive

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

VersionActive

XML export active

Internal ID: Project info

XML export active

Active: At each project backup an zip file (version.zip) is inserted. It includes 24 XML files with the backups of the individual modules.

Note: For multi-user projects only for local backups.

Default: inactive

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

BackupWithXML

History of changes

Settings for history of changes.

Active

Internal ID: Project info

History of changes active

Active: Changes to the project are also logged.
Inactive: Changes to the project are not logged.
Default: inactive.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

ChangeLogAktiv

Detailing levels

Internal ID: Project info

Detailling level

Only available if property History of changes active is active.

Selection of details levels from drop-down list.

  • Object: Only the object names of the changed objects are logged. Details concerning properties and their values are not displayed in the History of changes.
  • Properties: Additionally to the object names the changed properties and the new values are displayed in the history of changes.
  • Value changes: This setting causes the most detail level of logging. Not only the new value of a property is displayed but also the old one. This makes a complete tracability of the changes of values possible.

Default: Properties

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

ChangeLogState

Cursor keys

Move one tab forward or back.

Overwrite

Creates project and overwrites possibly existing object. Only active if tab Finish is opened.

Close

Closes the wizard.
The made changes can be saved for the current user.


Drivers

Manual -> Wizards -> Topics -> Project -> Project Wizard -> Drivers

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab the necessary zenon drivers are selected.

Parameters

Description

Driver list

List of zenon drivers. Selection is done by clicking on the driver.

Driver information

Display of the information about the selected driver.

Driver name

Name of the driver how it should be displayed in the project. Free text input.

Internal ID: Drivers

Identification

Unique name of the driver.
zenon identifies the driver with the help of this name and not with the help of the file name. Thus it is possible to load the same driver several times. This is for example necessary when you must access same control types which are connected to differenent serial interfaces.
Attention: This property is not available for language switch.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

Name

Add

Adds the selected driver to the list of driver to be created.

Remove

Removes the selected driver from the list drivers to be created.

Liste anzulegender Treiber

List of drivers to be created with name, description and file name.

Create screen with driver statistic variables

Active: For each driver a screen with driver variables is created.

Cursor keys

Move one tab forward or back.

Overwrite

Creates project and overwrites possibly existing object. Only active if tab Finish is opened.

Close

Closes the wizard.
The made changes can be saved for the current user.


Graphic settings

Manual -> Wizards -> Topics -> Project -> Project Wizard -> Graphic settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab you configure the resolution and the settings for the Runtime and touch screens.

Parameters

Description

General project settings

General graphical settings for the project.

Current primary monitor size

Display of the current screen resolution. For multi-monitor systems the resolution of the main screen is displayed.

Screen resolution

Selection of desired screen resolution from drop-down list.

Runtime title

Internal ID: Graphic settings

Driver invisible

Active: Started drivers are not displayed in the Windows task bar in the Runtime.

Inactive: Started drivers are displayed in the Windows task bar in the Runtime.

Default: Inactive.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

DriverInvisible

Graphics quality

Internal ID: Graphic settings

Graphics quality

Setting for the quality of the graphics display.
DirectX allows a higher quality than Windows Basic. In principle, when using DirectX, the DirectX Hardware setting is preferable and DirectX Software should only be used if absolutely necessary. Possible selection:

  • Windows Basic: Basic graphics settings. Recommended for resource-weak hardware.
  • DirectX Software: Graphics calculation is done by the CPU and can lead to high CPU load.
  • DirectX Hardware: A part of the graphics calculation is done by the graphics card. If the system does not support the setting, it automatically switches to DirectX Software.

Default: DirectX Hardware.

Attention: DirectX Not available under Windows CE. DirectX cannot be used for OCX.

Note:
When switching the mode during the engineering, there can be slight pixel deviation. There set this property before you create screens.
At activating Windows Base for all line types which use Line width [Pixel] >> 1, all line types are set to solid line.
More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

UseGDIplus

Menu position

Selection of the menu location from drop-down list.

Runtime settings

Settings for the Runtime.

Alarm status active

Internal ID: Graphic settings

Status line active

Only available if property Alarm Message List active is active.

  • Active: As soon as an alarm occurs, a red status line with alarm information is displayed at the top of screen in the Runtime. In this status line the alarm can also be acknowledged with a double right click if the logged in user has the corresponding rights.
  • Inactive: No status line is displayed.

Default: active

Attention multi-project administration: The setting in the integration project defines the behavior for sub-projects, regardless of the setting of the sub-projects. The alarm status line of the uppermost project is always used in Runtime.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

AlarmStatusActive

Note: This wizard automatically activated property Alarm Message List active.

Driver invisible

Internal ID: Graphic settings

Driver invisible

Active: Started drivers are not displayed in the Windows task bar in the Runtime.

Inactive: Started drivers are displayed in the Windows task bar in the Runtime.

Default: Inactive.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

DriverInvisible

Touch operation

Settings for the touch operaton

Multi-Touch

Internal ID: Graphic settings

Multi-Touch active

Active: Multi-Touch can be used. Flicks (short swipe) and right click (touch and hold) are deactivated.
Requirements: All corresponding driver and devices are available. The device must be connected and switched on.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

MultiTouch

Mauszeiger visible

Internal ID: Graphic settings

Cursor visible

  • Active: The mouse pointer is visible in Runtime.
  • Inactive: The mouse pointer will not be displayed during Runtime For projects with a touchscreen, the display of the mouse pointer can be considered to be distracting and can be switched off with this property.

Default: active
Attention: This setting only has a effect on zenon, not on Windows standard elements such as title bars, menus, scroll bars, etc. For Windows elements, the mouse pointer must be deactivated in the operating system directly.

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

CursorVisible

Automatic keyboard

Internal ID: Graphic settings

Automatic keyboard

For projects with a touch screen.

  • Active: A keyboard screen is automatically called if input is necessary (for example to write a setpoint value or to log in).
  • Inactive: No keyboard screen is opened.

(Default) Inactive:

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

Touchscreen

Create keyboard screen

Active: Creates DIALOGKBD for alphanumeric input and SETVALUEKBD for numeric input. For details see chapter Create screen of type keyboard. For it to be used in the Runtime, you must activate option Automatic keyboard.

Keybooard size (%)

Internal ID: Graphic settings

Keyboard size [%]

Defines in which size in percent - starting from the original size - the automatic keyboard should be displayed in the Runtime.
Minimum: 50 %
Maximum: 300 %
Default: 100 %

More in the online help.

This function is to be addressed for the zenon API (with class name) and in XML export (without class name) as follows:

KeyboardSize

Cursor keys

Move one tab forward or back.

Overwrite

Creates project and overwrites possibly existing object. Only active if tab Finish is opened.

Close

Closes the wizard.
The made changes can be saved for the current user.


Screen selection

Manual -> Wizards -> Topics -> Project -> Project Wizard -> Screen selection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab you can select screens which should be created in the project.

Attention: The screen switch function to the selected screens are configured with the default settings. No special settings such as filter, variables, etc. are made.

Parameters

Description

Screen types

Configuration of the screen.

Selection field

Selection of the screen type from drop-down list.

Frames list

Selection of the frame for the screen. Size and preview are displayed.

Width

Width of the screen.

Display only,

Height

Height of the screen.

Display only,

Preview

Preview of the selected screen type with the selected frame. Standard is dispalyed as empty.

Input field name

Free label of the screen name.

Add

Adds screen with selected name to list of screens.

Remove

Removes selected screen from list of screens.

Screens list

Lists all configured screens with names, screen types and size.

A maximum of 14 screens can be created.

Demo project

Settings for a example project.

Create demo screens

Active: Exemplary screens are created for the engineering. Selection of the demo screens:

  • Demo pages: Example pages (are always created)
  • Alarm Message List: AML
  • Chronological Event List: CEL
  • System information: Pages with system information, number depending on the resolution

Cursor keys

Move one tab forward or back.

Overwrite

Creates project and overwrites possibly existing object. Only active if tab Finish is opened.

Close

Closes the wizard.
The made changes can be saved for the current user.

Example configuration


Finish

Manual -> Wizards -> Topics -> Project -> Project Wizard -> Finish

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab the project is created.

Click on button Overwrite to create the project according to the settings on the tabs. Possible already existing objects are overwritten. The wizard remains open for further configuration. To close the wizard, click on button Close.


Examples in the Runtime

Manual -> Wizards -> Topics -> Project -> Project Wizard -> Examples in the Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Below you will find two example how your entry in the wizard effects the display in the Runtime.

  • Example 1: With the create demo screens option active.
  • Example 2: Without example screens.

Other topics in this chapter

With demo screens

Without demo screens


With demo screens

With demo screens

Start page:

Navigation:

SIMUL information:

Report Viewer:

AML:

CEL:

SystemInfo_1 ( for each screen resolution 1-3 screens):

SystemInfo_2 (1280x1024):

Driver:


Without demo screens

Without demo screens

Start page:

Navigation:


Documentation wizard

Manual -> Wizards -> Topics -> Project -> Documentation wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This wizard leads you through the steps needed to create a HTML document of the active project.

It can be defined, which modules should be included in the documentation and which not.

The wizard can be edited.


Variables

Manual -> Wizards -> Topics -> Variables

Wizards for variables.


Variable creation wizard

Manual -> Wizards -> Topics -> Variables -> Variable creation wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This wizard serves to create many variables quickly.

attention Attention

This wizard does not support distributed engineering and is not available in multiuser projects.


Driver Simulation

Manual -> Wizards -> Topics -> Variables -> Driver Simulation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The wizard creates an own straton program for each driver in the zenon project for which a driver simulation project is created. This straton program simulates for all variable pairs of the driver, for which a substitution rule applies, a direct allocation from command variable to response variable.

Example

  • zenon variables:
    • Test_CO : USINT
    • Test_RV : USINT
    • Switch_CO: USINT
    • Switch_RV: LREAL
  • Rules for substitutions:
    • *_CO -> *_RV
  • Results in straton:


Start wizard

Manual -> Wizards -> Topics -> Variables -> Driver Simulation -> Start wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To start the wizard:

  1. Click on File-> Wizards...

    or press the short cut Alt+F12

  2. The selection window with the available wizards opens
  3. Select the Variables folder
  4. select the Driver Simulation Wizard there

  5. click on OK
  6. The wizard starts with the welcome page


Welcome

Manual -> Wizards -> Topics -> Variables -> Driver Simulation -> Welcome

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tab Welcome informs you about performance and use of the wizard.

The navigation through the wizard is done by clicking on the individual tabs or step by step by clicking on the arrow keys.

Click on Close to close the wizard.


Settings

Manual -> Wizards -> Topics -> Variables -> Driver Simulation -> Settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab the substitution rules are created.

Parameters | Description
Execute wizard when compiling straton project | Active: As soon as action Create Runtime files is executed in zenon, the wizard is also executed. Note: The logic for creating the straton project is running in the background. The user interface of the wizard is not displayed.
Drivers with simulation project | Lists all drivers of the zenon project currently active in the zenon Editor for which a driver simulation project was created. If a driver is selected in this list, the defined substitution rules for this driver are displayed in area Replacement pattern.
Replacement pattern | Substitution rules.
COMMAND Variable | Command variable. Only one wildcard (*) is allowed.
RESPONSE Variable | Response variable. Only one wildcard (*) is allowed.
Add | Adds rules to List of rules.
Modify | Makes it possible to change selected rules.
Remove | Removes selected rules from the List of rules.
List of rules | Lists the defined rules.
Cursor keys | Moves to the previous or next tab.
Close | Closes wizard.

If rules are changed, the recreation of the simulation project is offered when you close the dialog. For this a dialog is opened:

Note: Confirm this dialog with Yes if all substitution rules are deleted for a driver. Simulation projects without substitution rules are not considered at the automatic creation of the Runtime files in zenon.


Rebuild

Manual -> Wizards -> Topics -> Variables -> Driver Simulation -> Rebuild

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab you can trigger a rebuild of all straton simulation projects.

Click on button Rebuild in order to start the recreation of the driver simulation project for all corresponding drivers in the project.


IEC850 Driver Configuration

Manual -> Wizards -> Topics -> Variables -> IEC850 Driver Configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The add-on IEC850 Driver Configuration allows you to read IEDs that are already present in SCL files and to create connections in the IEC850 driver with this.

tutorial License information

zenon Energy Edition must be licensed in order to use the add-on.


Install and call up metering point administration

Manual -> Wizards -> Topics -> Variables -> IEC850 Driver Configuration -> Install and call up metering point administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The IEC850 Driver Configuration add-on is automatically installed as part of the zenon standard installation.

Starting the wizard

To call up the tool, proceed as follows:

  1. Start the zenon Editor.
  2. Click on File in the toolbar.
  3. Click on Wizards.

Note: You can also open the selection window with the available wizards and tools with the keyboard shortcut Alt+F12.

The selection window with the available wizards opens.

  1. Select the folder Variables.
  2. Then click on IEC850 Driver Configuration.
  3. Click on OK.
  4. The wizard starts with the page Configuration

info Information

The Add-on IEC850 Driver Configuration is only available in English language.


Configuration

Manual -> Wizards -> Topics -> Variables -> IEC850 Driver Configuration -> Configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The IEC850 driver is configured in this tab.

Requirements:

  • An SCL file (*.scl, *.icd, *.cid, *.scd, *.ssd) must be present
  • IEC850 drivers must be present in zenon or created in the add-on

Parameters

Description

File selection

Selection of the SCL file. Click on the ... button to open the file selection dialog

Treeview

Tree view for connections and drivers available.

File name

Display of the selected SCL file.

Project name

Display of the zenon project for which the driver has been configured.

List of connections

Lists all connections contained in the SCL file.

List of drivers

Lists all drivers IEC850 drivers created in the project and in the add-on with their connections. Drivers can be added or deleted using the context menu. Connections are allocated by dragging & dropping and can be deleted via the context menu.

Note: Further connections can be added to drivers that have already been created in zenon. Connections or drivers that already exist in zenon cannot be deleted.

OK

Applies settings and closes the dialog.

Cancel

Discards all changes and closes the dialog.

Configuring the driver

To configure drivers:

  1. Select the desired SCL file.
  2. Create new drivers as required.
  3. Select the desired connection.
  4. Drag & drop the connection to the desired driver.

  5. Edit the Net address of the connection if necessary.
  6. Configure all required drivers and connections.
  7. Close the add-on by clicking on the OK button.

Adding a driver

To add a driver:

  1. Select the New Driver command in the context menu of the driver list.
  2. The dialog to create a driver is opened.

  3. Please use an unique name.
  4. Confirm the dialog by clicking on OK.
  5. The driver is displayed in the list.
  6. The driver is created in zenon by clicking on OK when the add-on is closed.

Delete Driver

To delete a driver:

  1. Highlight the desired driver.
  2. Select Delete driver in the context menu.
  3. The driver is deleted without requesting confirmation.

Note: Only drivers that have not yet been created in zenon can be deleted.

Editing the network address:

To amend a Net address:

  1. Highlight the desired Net address for the driver in the driver list.
  2. Select Edit net address in the context menu.
  3. The dialog to issue a Net address is opened.

  4. Assign a value.
  5. Confirm the dialog by clicking OK
  6. When closing the add-on by clicking on OK, the new Net address of the connection is assigned in zenon.

Note: Only network addresses that have not yet been created in zenon can be edited.

Delete connection

To delete a connection:

  1. Highlight the desired connection for the driver in the driver list.
  2. Select Delete connection in the context menu.
  3. The connection is deleted

Note: Only connections that have not yet been deleted in zenon can be deleted.

Accept driver configuration in the project

To accept the new configuration, click on the OK button.

  • The configuration is checked.

    If there are drivers without connections, then there is a notice.

  • New drivers are created in zenon.
  • New connections are created in zenon.
  • The result is displayed in an output window.


Configuration

Configuration

To configure drivers:

  1. Select the desired SCL file.
    To do this, click on the ... button in File selection.
  2. Select, from the left List of connections, the desired reports.
    Highlight the reports that you want to assign to the host of a driver.
    Multiple selection is possible in the process.
  3. Drag & drop the selected reports to the desired driver in the right-hand list.
    If your selection is dragged over a host, these reports are automatically applied to the list of the respective host.
    Note: If no host has been created for a connection, no assignment is possible. To do this, create corresponding hosts with the context menu.

  4. Close the add-on by clicking on the OK button.

Allocation rules

For the allocation of reports from a file to the drivers of a project configuration in zenon, each report of a file can only be allocated a driver once in zenon.

Each report from the list of connections can only be assigned to a host of the list of drivers once. With multiple selection, reports that have already been assigned are ignored if there is a reassignment by means of drag&drop. Only the reports that have not been used are taken into account in the process and the new host is added.

Delete reports

To delete a report:

  1. Highlight the desired report in the node of the host that is allocated to the reports.
  2. Select, in the context menu, the entry Delete report.
  3. The allocation of the report to a host is removed.

Note: Deletion using multiple selection is not possible. Several reports are highlighted. However only the last report highlighted is deleted.

Accept driver configuration in the project

To accept the new configuration, click on theOK or the Apply button.

  • The configuration is checked.
  • New drivers are created in zenon.
  • New connections are created in zenon.
  • The result is displayed in an output window.

  • The add-on is closed by clicking on the OK button.


Administer driver

Administer driver

Adding a driver

To add a driver:

  1. Select the New Driver command in the context menu of the driver list.
  2. The driver is shown in the list with the default entry Edit.
  3. Please use an unique name.
  4. The driver is created in zenon by clicking on the Apply button or when closing the add-on by clicking on OK.

Delete Driver

To delete a driver:

  1. Highlight the desired driver.
  2. Select, in the context menu, the entry Delete driver.
  3. The driver is deleted without requesting confirmation.

Note: Only drivers that have not yet been created in zenon can be deleted.


Context menu

Manual -> Wizards -> Topics -> Variables -> IEC850 Driver Configuration -> Context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There are different versions of the context menu. The content of the context menu depends on the position of the node on which it is used.

Context menu

Parameters

Description

New driver

Creates a new IEC850 driver. A new entry is created in the list of drivers. The name can be changed by clicking on the new entry.

If the name of the driver has already been used, an error message is called up.

The driver is also created in the zenon Editor.
Default: Edit (must be changed)

Attention: If a driver is created in the add-on with the context menu and the default driver name edit is changed after clicking on the Apply button, two drivers are configured in the zenon Editor!

Note: only available in List of drivers.

New connection

Creates a new connection and calls up the New connection dialog For the configuration of the connection.

Note: only available in List of drivers.

Delete driver

Deletes selected driver.
However this is only possible if the driver has been newly created directly in the add-on. Existing drivers from a project configuration in the zenon Editor are grayed out and Delete Driver is not available.
All drivers are grayed out if the add-on is restarted!

Attention: No drivers are deleted in the Editor as a result! If this has already been created by clicking on the Apply button, the driver remains in the project configuration of the Editor.

Note: only available in List of drivers.

Edit connection

Calls up the dialog to configure the connection.
The following can be changed:

  • Net address
  • IP address
  • Name of connection.

Note: only available in List of drivers. Only available in the node of the respective connection.

Delete connection

Deletes selected connection without requesting confirmation.

However this is only possible if the connection has been created in the add-on directly. Existing connections from a project configuration in the zenon Editor are grayed out and Delete Connection is not available.
All connections are grayed out if the add-on is restarted!

Note: only available in List of drivers. Only available in the node of the respective connection.

New host

Creates a new host entry in the Reports node. Naming of the host by highlighting the host entry.

Default: Edit (must be changed).

Note: only available in List of drivers. Only available in the Reports node.

Delete host

Deletes configured host without requesting confirmation. Multiple selection is not possible.

All reports assigned to the host are also deleted.

Hosts and assigned reports and also removed from the driver configuration in the Editor.

Note: only available in List of drivers. Only available in the node of the respective host.

Edit report

Opens dialog for report configuration.

Multiple selection is possible, but it is always only the last-highlighted entry that is edited. Editing of several reports with multiple selection is not possible.

Note: only available in List of drivers. Only available if a report is selected in the node of the host.

Delete report

Deletes selected report without requesting confirmation.

Multiple selection is possible, but it is always only the last-highlighted entry that is deleted. Deletion of several reports with multiple selection is not possible.

Note: only available in List of drivers. Only available if a report is selected in the node of the host.

Expand all

All nodes are expanded.

Collapse all

All nodes are collapsed.


Connection configuration dialog

Connection configuration dialog

Not all properties are available for the configuration of the connection. Properties that are not available are grayed out.

Parameters | Description
Net address: | Corresponds to the Net address property in variable configuration. Note: If the configured net address has already been issued in the driver configuration, the next-highest available number is issued. Maximum value: 65535
IP address: | IP address of the server to which a connection is to be made.
Name | Freely definable name. Is used for the names of variables when variables are imported.

Close dialog

Parameters | Description
OK | Applies settings and closes the dialog.
Cancel | Discards all changes and closes the dialog.

Connections can only be configured in the add-on if they can be called up using the context menu.

This calling up is only possible if.

  1. The Connection has been created in the add-on using the context menu.
  2. This configuration in the add-on has not been transferred by clicking on the Apply or OK button in the Editor configuration.

You edit configurations that already exist directly in the zenon Editor in the driver settings.

info Information

You can find further information on this in the Variables manual, in the Drivers chapter, or in the driver documentation for the IEC850 drivers, in the Connections chapter.


Reports configuration dialog

Reports configuration dialog

Not all properties are available for the configuration of the reports. Properties that are not available are grayed out.

Trigger options

The Use preconfigured (SCL) options property is activated by default. All subordinate options are thus also activated. To not use all options, deactivate Use preconfigured (SCL) options in order to deactivate individual options.

Parameters

Description

Use preconfigured (SCL) options

Active:

The driver activates a report without overwriting the data attributes of the RCB. The content of the SCL file of the server is defined as a result of this. The following data attributes are affected by this:

  • IntgPd
  • BufTime
  • TrgOps
  • OptFields

Inactive:

The driver writes the data attributes of the RCB during activation.

You can activate/deactivate the following trigger options regardless of one another.

  • TrgOp: data-change
  • TrgOp: quality-change
  • TrgOp: data-update
  • TrgOp: integrity
  • TrgOp: general-interrogation

Default: all active

Note: Not all servers support TrgOps data-change and data-update together. TrgOp intergity can also lead to an unnecessary overload of communication if a an IntgPd (Integrity Period) that is too short was defined in the server for RCB. In case of doubt, set TrgOps: data-change + quality-change + general-interrogation.

Optional fields

The Optional Fields are written on the server when a report is activated. These correspond to the bits in the OptFlds data attribute of the RCB.

Clicking on the checkbox activates or deactivates the respective information.
The Data set name property is always activated. This cannot be changed, because the driver cannot evaluate the reports received without this option.

Parameters | Description
Integrity period: | Time interval (IntgPd) in milliseconds in which the server sends an Integrity Report. Default: 7000 ms Note: not active if TrgOp integrity is deactivated or Use preconfigured (SCL) options is activated. Because an Integrity Report does not normally contain value changes, it is expressly recommended that only one report on the server is activated with TrgOp: integrity. With an activated integrity report, the server can detect a connection failure more quickly. However zenon does not need this report.
Buffer time: | Time interval (BufTime) in milliseconds in which the server collects the data for a report. Default: 500 ms Note: not active if Use preconfigured (SCL) options is activated.
info Information
You can find a more detailed description of the Trigger options in the IEC850 driver documentation in the statically assigned RCB chapter.


Configuration

Configuration

To create a connection directly in the add-on:

  1. Create a new driver in the add-on.
  2. Select the driver that has just been created and select New Connection in the context menu.
  3. The dialog to issue a Net address is opened.

  4. Assign a value.
  5. Confirm the dialog by clicking OK
  6. When closing the add-on by clicking on OK, the new Net address of the connection is assigned in zenon.

Note: Only network addresses that have not yet been created in zenon can be edited.

Changing an existing net address

  1. Select the driver that has been created and select Edit Connection in the context menu.
  2. The dialog to issue a net address is opened.

  3. Assign a value.
  4. Confirm the dialog by clicking OK
  5. When closing the add-on by clicking on OK, the new net address of the connection is assigned in zenon.

Note: Only network addresses that have not yet been created in zenon can be edited.


Create and adapt wizards

Manual -> Wizards -> Create and adapt wizards

Wizards are common VBA forms that contain certain functions in the code part. As a result of this, the formulas are recognized as zenon wizard.

The wizards supplied with zenon can form the basis of your own wizards.

Your own wizards can be stored in your own folders. All required information must be entered into the file named wizards.ini. This can be included when the wizard is updated.

VBA and VSTA wizards

To create wizards the following information is necessary for VBA and VSTA:

  • Name
  • Description
  • Category
  • Display in the dialog
  • Version number

These functions are read by zenon in order to identify forms as wizards and to display corresponding information in the wizard dialog.

The demo wizard offers an empty template that can be individually adapted. For details on creating VSTA wizards see chapter Details VSTA wizards.

Name

States the wizard name as it is displayed in the dialog for the wizard.

Example: VSTA project wizard

VBA | VSTA
Public Function GetWizardName() As String GetWizardName = "Project-Wizard" End Function | GetWizardName (Type string)

Description

Contains the description of the wizard as it is displayed in area "Descripton" of the dialog.

Example: This wizard creates a simple zenon Project (V.1)

VBA | VSTA
Public Function GetWizardInfo() As String GetWizardInfo = "Wizard for creation of a project" End Function | GetWizardInfo (Type string)

Category

States the category in which the wizard is sorted.

For example: Project

Note: You can use existing categories. VBA and VSTA wizards can be sorted in the same category.

VBA | VSTA
Public Function GetWizardCategory() As String GetWizardCategory = "Project" End Function | GetWizardCategory (Type string)

Display in the dialog

Defines whether the wizards is displayed in the dialog. With this you can hide a wizard without deleting all functions or removing them from the add-in:

= true: is displayed

= false: is hidden.

VBA | VSTA
Public Function IsZenOnWizard() As Boolean IsZenOnWizard = True End Function | IsZenOnWizard (Type bool)

Version number

States the version number which is displayed at the description. The version number is used to manage the update of the wizards.

Example: (V.1)

Note: Within a wizard class there must not be different functions with the same name. This is also true when they report back different parameters.

VBA | VSTA
Public Function GetWizardVersion() As Integer GetWizardVersion = 6 End Function | GetWizardVersion (Type int)


Details VSTA Wizard

Manual -> Wizards -> Create and adapt wizards -> Details VSTA Wizard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

VSTA Wizard

#region Wizard_Identification

/// <summary>
/// This Static method returns the name of the wizard,
/// which will be displayed in the wizard-tree.
/// </summary>
/// <returns></returns>

static public string GetWizardName()
{
string strValue = "Name of the wizard";
return strValue;
}

/// <summary>
/// This Static method returns the description of the wizard,
/// which will be displayed at the bottom of the wizard-dialog.
/// </summary>/// <returns></returns>
static public string GetWizardInfo()
{
string strValue = "A more detailed description of the wizard.";
return strValue;
}

/// <summary>
/// This static method returns the category name of the wizard,
/// which will be used as node-name in the wizards-tree.
/// </summary>
/// <returns></returns>

static public string GetWizardCategory()
{
string strValue = "Wizard category";
return strValue;
}

/// <summary>
/// This static method returns a bool which can be used to "switch" the wizard
/// on/off in the wizard dialog (false=wizard is not shown in the tree).
/// </summary>
/// <returns></returns>

static public bool IsZenOnWizard()
{
bool bValue=true;
} return bValue;

/// <summary>
/// This static method returns the version of the wizard.
/// Indicated at the bottom of the wizard-dialog.
/// </summary>
/// <returns>wizard version</returns>

static public int GetWizardVersion()
{
int nValue = 1;
return nValue;
}

/// <summary>
/// This method is called when the wizard has been selected in the
/// wizard dialog and confirmed with "OK".
/// </summary>

public void StartWizard()
{
this.Show();
}
#endregion

VB.Net

'This shared method returns the name of the wizard,
'which will be displayed in the wizard-tree.

Public Shared Function GetWizardName() As String
GetWizardName = "Name of the wizard"
End Function

'This shared method returns the description of the wizard,
'which will be displayed at the bottom of the wizard-dialog.

Public Shared Function GetWizardInfo() As String
GetWizardInfo = "A more detailed description of the wizard."
End Function

'This shared method returns the category name of the wizard,
'which will be used as node-name in the wizards-tree.

Public Shared Function GetWizardCategory() As String
GetWizardCategory = "Wizard category"
End Function

'This shared method returns a bool which can be used to "switch" the wizard
'on/off in the wizard dialog (false=wizard is not shown in the tree).

Public Shared Function IsZenOnWizard() As Boolean
IsZenOnWizard = True
End Function

'This shared method returns the version of the wizard.
'Indicated at the bottom of the wizard-dialog.

Public Shared Function GetWizardVersion() As Integer
GetWizardVersion = 1
End Function

'This method is called when the wizard has been selected in the
'wizard dialog and confirmed with "OK".

Public Sub StartWizard()
Me.Show()
End Sub

C# Workspace

For the Editor to create an instance of the VSTA class dynamically, you must add an additional function to the "Default" Workspace Code. This code segment must exist so that the wizard is displayed after selection in the dialog. This code segment should not be modified!

#region Wizard

/// <summary>
/// This Routine Enables the Dynamic creation of VSTA-Wizards.
/// </summary>
/// <param name="strClassname"></param>

public void StartWizard(string strClassname)
{

//Retrieve the ClassType by its Typename:

Type t = Type.GetType(strClassname);
if(t!=null)
{

//Since the ClassType has been found, let's create it.
//The wizard from ClassType %strClassname% is required
//to have a Constructor with ZenWorkspace Parameter!

object[] Params = new object[] { this.ZenWorkspace };
object Wizard = Activator.CreateInstance(t, Params);
if (Wizard != null)
{
t.InvokeMember("StartWizard", BindingFlags.Public | BindingFlags.Instance | BindingFlags.InvokeMethod, null, Wizard, null);
}
}
}
#endregion

And for the VB.Net workspace like this:
'This Routine Enables the Dynamic creation of VSTA-Wizards,
'and should not be modified or removed!

Public Sub StartWizard(ByVal strClassname As String)
Dim obClassType As Type
Dim obWizard As Object
Dim obParams(0) As Object
obClassType = Type.GetType(strClassname)
If (Not obClassType Is Nothing) Then
obParams(0) = Me.ZenWorkspace
obWizard = Activator.CreateInstance(obClassType, obParams)
If (Not obWizard Is Nothing) Then
obClassType.InvokeMember("StartWizard", System.Reflection.BindingFlags.Public Or System.Reflection.BindingFlags.Instance Or ystem.Reflection.BindingFlags.InvokeMethod, obWizard, Nothing, Nothing)
End If
End If
End Sub


Update wizards

Manual -> Wizards -> Update wizards

When installing a zenon Service Pack, a wizard update is automatically offered.

Existing wizards are not overwritten by the setup. It can therefore be necessary for the wizards to be manually imported and updated.

attention Attention

This information is only applicable for wizards that were programmed in C#. That is all wizards that are shown in the Update wizards window.

This information does not apply to wizards that were programmed in .Net, such as.

  • Analyzer Wizards
  • Sankey Wizard

.Net Wizards are integrated by means of a DLL and automatically kept up to date with the updates of zenon. The update can, if required, also be carried out manually via the build file contained in the zenon Analyzer installation medium for zenon.

Request update

An update can also be initiated manually at any time by selecting Update wizards in the File drop-down menu.

Parameters

Description

Wizard list

Lists all VBA wizards and VSTA wizards present in the add-in that is running.

  • Name

Name of the wizard.
  • Object name

VBA/VSTA object name.
  • Previous Version

Version currently being used.
  • Create

Version that it is being updated to.
  • Information

Status information and information on the pending action:

  • New: Wizard does not exist in the VBA file.
  • Changed: A new version is available.
  • No longer supported: The existing wizard is obsolete and will be deleted.
  • Type

VBA or VSTA
  • User-specific

wizard was created or changed by the user

Data source

Possibility of defining your own folder for your own wizards. The save location of the individual wizards.ini is entered.

The entries for this are saved in zenon.ini in the [VSTA] section or [VBA] as WIZARDPATH=.

Additional folder for VSTA wizards

Individual save location for your own VSTA wizards.

Additional folder for VBA wizards

Individual save location for your own VBA wizards.

Remember me again

The dialog will open again when the Editor is next started.

Start update

The wizards selected in the wizard list are updated.

Cancel

The dialog is ended without updating and is only offered again after the next installation of a Service Pack.

Make sure that you are up to date

As objects which are not instanced at the time the dialog is opened are not checked, some objects are always offered for update. This makes sure that you do not work with out-of-date versions. The versions displayed in the update dialog is only used as information for the Consulting and Development departments.

Distribute wizards throughout the company

If you have written your own wizards and would also like to make these available to other users, then you can also use this method.
To do this, you export the wizard from your VBA/VBA development environment and ideally place the export files in an approved network drive. ini files serve to control the imports. These must be created accordingly and also stored in the network.
You can find a description of the files here: For VBA and for VSTA.

Now you only need to show your colleagues the location where it is saved and the wizards can easily import these into your Editor. If you have changed or new wizards, you only need to export the new status, store it and increase the version number. You can therefore easily distribute wizards in your company.

Possible errors when updating VSTA wizards

Error

Possible causes

No VSTA wizards are displayed in the update dialog
  • Only wizards that are in the add-in at the time are listed.
    If VSTA wizards are not shown, the VSTA add-in must be activated with the Start Editor. To do this, in zenon6.ini, in the [VSTA] section, set LOADED= to 1.
  • If the workspace cannot be compiled due to errors in the code, no wizards are listed.

You can read how the original wizards are recovered in the Recover original wizards section.

A particular wizard is not displayed.
  • The wizard does not support the required methods.
  • The workspace was not yet compiled after the wizard was implemented; the add-in that is running does not contain the wizard.

Self-created wizards are not displayed.
  • The configured path is incorrect.
  • The wizards.ini in the path configured is obsolete or defective.

Recovering original wizards

If wizards are not displayed in the list of the wizards, you can recover the original wizards. To do this:

  1. End the zenon Editor
  2. Navigate to the folder: %ProgramData%\COPA-DATA\zenonxxx\VSTAWorkspace (xxx stands for the zenon version)
  3. Rename the complete folder
  4. Restart the Editor
  5. The folder and the wizards are recreated


Structure of the wizards.ini

Manual -> Wizards -> Update wizards -> Structure of the wizards.ini

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Creation of the INI file for administering the wizard in VSTA and VBA.

info Information

This documentation is only available in English.


VSTA wizards.ini

Manual -> Wizards -> Update wizards -> Structure of the wizards.ini -> VSTA wizards.ini

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

[DEFAULT]: Contains global settings

COUNT: Amount of wizards included in the INI (must be modified when adding/removing a wizard to the ini

[MYWORKSPACE] Contains settings for the Workspace.cs

VERSION: Current version

[WIZARD_X]: Contains settings of a wizard:

NAME: Name as indicated in the update dialog

CLASSNAME: Name of the form class representing the wizard.

VERSION: Version number

PATH:path-expansion to location of the files.

DELETE: 1 when the wizard is to be removed from the workspace

FILES: The amount of files included in this wizard

FILE_X: The name of a file included in the wizard

TYPE_X: The type of the file (required for the Form.cs and Resx file)

DEP_X: The name of a file on which this file depends

Example

[DEFAULT]

COUNT=3

[MYWORKSPACE]

VERSION=1

[WIZARD_1]

NAME=Import-Wizard

CLASSNAME=Wizard_Exportxml

VERSION=3

PATH=\Wizard_Exportxml

DELETE=0

FILES=3

FILE_1=Wizard_Exportxml.cs

TYPE_1=Form

FILE_2=Wizard_Exportxml.Designer.cs

DEP_2=Wizard_Exportxml.cs

FILE_3=Wizard_Exportxml.resx

DEP_3=Wizard_Exportxml.cs

TYPE_3=EmbeddedResource

[WIZARD_2]

NAME=Wizard_Project

CLASSNAME=Wizard_Project

VERSION=1

PATH=\Wizard_Project

DELETE=0

FILES=3

FILE_1=Wizard_Project.cs

TYPE_1=Form

FILE_2=Wizard_Project.Designer.cs

DEP_2=Wizard_Project.cs

FILE_3=Wizard_Project.resx

DEP_3=Wizard_Project.cs

TYPE_3=EmbeddedResource

[WIZARD_3]

NAME=Demo Wizard

CLASSNAME=Wizard_Demo

VERSION=1

PATH=\Wizard_Demo

DELETE=0

FILES=3

FILE_1=Wizard_Demo.cs

TYPE_1=Form

FILE_2=Wizard_Demo.Designer.cs

DEP_2=Wizard_Demo.cs

FILE_3=Wizard_Demo.resx

DEP_3=Wizard_Demo.cs

TYPE_3=EmbeddedResource


VBA wizards.ini

Manual -> Wizards -> Update wizards -> Structure of the wizards.ini -> VBA wizards.ini

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

[DEFAULT]: Contains global settings

COUNT: Amount of wizards included in the INI (must be modified when adding/removing a wizard to the ini

[MYWORKSPACE] Contains settings for the Workspace.cs

VERSION: Current version

[WIZARD_X]: Contains settings of a wizard:

NAME: Name as indicated in the update dialog

VERSION: Current version

PATH:path-expansion to location of the files.

VB_NAME: Name of the VBA object representing the wizard.

VB_TYPE: 0=form, 1=class

DELETE: 1 when the wizard is to be removed from the workspace

Example

[DEFAULT]

COUNT=3

[MYWORKSPACE]

VERSION=3

[WIZARD_1]

NAME=Wizard for creating variables

VERSION=8

PATH=\CreateVariables\frmCreateVariables.frm

VB_NAME=frmCreateVariables

VB_TYPE=0

DELETE=0

[WIZARD_2]

NAME=Document Wizard

VERSION=12

PATH=\DocuWizard\frmDocuWizardEx.frm

VB_NAME=frmDocuWizardEx

VB_TYPE=0

DELETE=0

[WIZARD_3]

NAME=Import-Wizard

VERSION=3

PATH=\ImportWizard\frmImportWizard.frm

VB_NAME=frmImportWizard

VB_TYPE=0

DELETE=1


Required methods for updating

Manual -> Wizards -> Update wizards -> Structure of the wizards.ini -> Required methods for updating

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Example of methods that are required for the wizard to be displayed in the update dialog:

VBA

'The following methods define the form as a control system wizard. If IsZenOnWizard is set to false,

'the wizard does not appear in the Wizard dialog and does not influence the wizard update dialog.

Public Function GetWizardName() As String

GetWizardName = "Empty Wizard"

End Function

Public Function GetWizardInfo() As String

GetWizardInfo = "<TODO: Add description here>"

End Function

Public Function GetWizardCategory() As String

GetWizardCategory = "<TODO: Add category-information here>"

End Function

Public Function IsZenOnWizard() As Boolean

IsZenonWizard = False

End Function

Public Function GetWizardVersion() As Integer

GetWizardVersion = 6

End Function

VSTA

#region Wizard_Identification

/// <summary>

/// This Static method returns the name of the wizard,

/// which will be displayed in the wizard-tree.

/// </summary>

/// <returns></returns>

static public string GetWizardName()

{

string strValue = "Demo Wizard";

return strValue;

}

/// <summary>

/// This Static method returns the description of the wizard,

/// which will be displayed at the bottom of the wizard-dialog.

</summary>/// <returns></returns>

static public string GetWizardInfo()

{

string strValue = "This is our Demo Wizard";

return strValue;

}

/// <summary>

/// This static method returns the category name of the wizard,

/// which will be used as node-name in the wizards-tree.

/// </summary>

/// <returns></returns>

static public string GetWizardCategory()

{

string strValue = "Wizard VSTA";

return strValue;

}

/// <summary>

/// This static method returns a bool which can be used to "switch" the wizard

/// on/off in the wizard dialog (false=wizard is not shown in the tree).

/// </summary>

/// <returns></returns>

static public bool IsZenOnWizard()

{

bool bValue = false;

return bValue;

}

/// <summary>

/// This static method returns the version of the wizard.

/// Indicated at the bottom of the wizard-dialog.

/// </summary>

/// <returns>wizard version</returns>

static public int GetWizardVersion()

{

int nValue = 1;

return nValue;

}

/// <summary>

/// This method is called when the wizard has been selected in the

/// wizard dialog and confirmed with "OK".

/// </summary>

public void StartWizard()

{

this.Show();

}

#endregion


Worldview

Manual -> Worldview

A worldview in zenon is any screen for which the Screen size from frame option has been deactivated and which is larger or the same size as the frame. It makes it possible to display screens that have a size that exceeds the frame size and allows navigation and zooming in these screens. With this it is possible to display very large equipment completely and to navigate in them. In the worldview you can zoom in on parts of the equipment. Dependent on the zoom steps you can define which details are displayed (zooming, panning and decluttering). You can also jump directly to elements.

info Information

Some elements cannot be zoomed such as Combo/Listbox, Alarm Message List, diagram of the Extended Trend and so on. The size of these elements remains constant. However their position changes.

tutorial License information

Part of the standard license of the Editor and Runtime.


Engineering in the Editor

Manual -> Worldview -> Engineering in the Editor

To use a worldview, you need:

  1. a screen which is larger than its frame; this is the worldview
  2. a screen of type Worldview overview; this is used for navigating in the worldview and affects the frame of the worldview

Note: These two screen must be based on different frames.

When calling up the screen of type Worldview overview, you define which frame is controlled by this screen.

Hints:

  • Do not use the Worldview as start screen.
  • Start the Worldview and the Worldview overview together with the help of a script.

info Information

A worldview overview necessary when navigating a worldview screen with Multi-touch. With Multi-touch, you can directly navigate in the worldview.

Screen elements

The visibility of dynamic elements, vector elements and their names for object lists are defined in the properties of the respective objects: Runtime/Worldview display/...


Create worldview

Manual -> Worldview -> Engineering in the Editor -> Create worldview

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to create a worldview:

  1. create a new screen
  2. go to property group Frame
  3. select the Screen size from frame property
  4. deactivate this property (remove tick if necessary)
  5. for properties Width [pixels] and Height [pixels] select values which exceed the size of the frame

    Maximum values: 32.000

  6. create a screen switch fucntion for this screen

info Information

Faceplates are not suitable for worldview. Linked screens are not scaled in screen containers, but always shown in their original size.


Creating a screen of the type Worldview overview

Manual -> Worldview -> Engineering in the Editor -> Creating a screen of the type Worldview overview

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to create screen of type Worldview overview:

  1. create a frame for the screen
  2. Ensure that the size is suitable (recommended size: 550 x 350 pixels)
  3. for the frame activate properties Always in the foreground and Do not close after losing focus
  4. create a new screen
  5. chose Worldview overview as type
  6. assign the screen to the frame
  7. add the desired elements in order to control the worldview via menu Control elements
  8. add a function for closing the screen of type worldview navigation
  9. create a screen switch function for the screen of type Worldview overview

Parameters | Description
Insert template | Opens the dialog for selecting a template for the screen type. Templates are shipped together with zenon and can also be created by the user. Templates add pre-defined control elements to pre-defined locations in the screen. Elements that are not necessary can also be removed individually once they have been created. Additional elements are selected from the drop-down list and palced in the screen. Elements can be moved in the screen and placed individually.
Windows | Control elements for the overview window.
Overview Window | Display the screen which is controlled.
Object list | List of the directly controllable Objects.
Show zoom steps | Displays the current zoom level.
Zoom | Control elements for the operation of the zoom.
Zoom Minimum | Turns off zooming. The screen is displayed in the size of the frame.
Zoom Maximum | Maximum zoom level.
+ | Zoom into the screen.
- | Zoom out of the screen.
Zoom slider | Slider for setting the zoom level.
Navigation | Buttons for navigation in the diagram.
Left | Moves the displayed section to the left.
Right | Moves the displayed section to the right.
Up | Moves the displayed section up.
Down | Moves the displayed section down.


Zoom steps

Manual -> Worldview -> Engineering in the Editor -> Zoom steps

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Zoom steps define the relation of frame size and displayed screen. The display takes place in steps to which percentage numbers are assigned. 100 % equals the frame size. The larger the section, the lower the step.

Note: Worldview zooming is not possible in faceplates

To engineer zoom steps:

  1. navigate to group Graphical design/Runtime general in project properties
  2. Click on the ... button in the Zoom steps for world view property
  3. the dialog for configuring zoom steps is opened

Parameters | Description
Existing zoom steps. | In the list you can find the available zoom steps.
New... | Creates a new zoom step. You can edit the proposed value manually. The value must be between 1 and 100.
Edit... | Opens the field for the percentage value for the highlighted step.
Delete... | Deletes the selected zoom step.

Minimum zoom step

The minimum step is limited to the relation of the screen size to the frame size.

Example:

  • 10 zoom steps from 10% to 100% are engineered.
  • The screen is twice as large as the frame.
    • The zoom steps come up to 50%. From this point on the full screen size is displayed.
  • The screen is four times as large as the frame.
    • The zoom steps come up to 20 %.


Objects

Manual -> Worldview -> Engineering in the Editor -> Objects

Each element in a screen can be given a unique name. This name can also be used for navigation in the worldview overview. A click on the name in the object list moves the displayed section until the element is in the middle of the displayed section.

To define objects:

  1. click on the desired element
  2. navigate to Group Runtime in properties
  3. Click on the Name for object list property
  4. enter a name for the object

In the Runtime all named objects are displayed in the object list.


Function screen switch to Worldview overview

Manual -> Worldview -> Function screen switch to Worldview overview

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

At calling up a screen of type Worldview overview in the Runtime you define which Frame is navigated by the screen. The screen which should be controlled must not have property Screen size from frame and must be larger than the corresponding frame.

To engineer a function screen switch to a screen of type Worldview overview:

  1. create a new function
  2. select screen switch
  3. the dialog for selecting a screen is opened
  4. select the screen of type Worldview overview
  5. the dialog for configuring the screen is opened

Parameters | Description
Display of the overview screen for the frame | Selection of the frame which should be controlled from drop-down list.
Border color | Defines color display in the Runtime:
Standard | Color for the frame in the screen that indicates the currently selected area. Clicking on Color opens the palette.
When selecting with right click | Color of the border if the section is clicked with the right mouse button for moving. Clicking on Color opens the palette.
Settings |
Frame width | Width for the frame in the screen that indicates the currently selected area.
Cyclic update of the overview screen | Active: Dynamic elements in the assigned screen are updated at defined time intervals.
Seconds | Time in seconds for the cyclic update.
Highlight selected object on selection | Active: If you click a object in the object list, the object is highlighted.
Zoom | Properties for zoom.
Maintain aspect ratio | Active: The aspect ratio between the height and the width is maintained while pulling.
Deactivate lateral drag points | Active: The drag points of the border are deactivated and no longer displayed. Exception: Corner points.
Zooming with +/- keys in | Selection on how to use keys + and - for zooming. The keys must be assigned appropriately.
% | With the assigned keys zooming is done in percentage steps. Enter a value between 1 and 100. Default: 10
Zoom steps | With the assigned keys zooming is done in zoom steps.
Moving with arrow keys in pixels | Enter the number of pixels by which the screen is moved when using the arrow keys. The keys must be assigned appropriately. Enter a value between 1 and 16,000. Default: 100
OK | Applies information, closes dialog and opens dialog for replacing links.
Cancel | Discards all changes and closes dialog.
Help | Opens online help.

info Information

Changes of the property in the Editor only take effect in the Runtime after the screen of type Worldview overview is called up again.


Operating during Runtime

Manual -> Worldview -> Operating during Runtime

To be able to navigate in a worldview in the Runtime, use:

  • a screen of the type Worldview overview
    or
  • Multi-Touch gestures on a touch screen

Worldview Overview

  1. call up screen Worldview with the help of a screen switch function
  2. call up the screen of type Worldview overview with the help of a Screen switch function

Hint: Use a script in order to always call up both screen switch functions.

With the help of the control elements, the mouse and the keyboard you can navigate and zoom in the worldview. You can find details in the Worldview overview chapter.

Multi-Touch

You can also go directly to the worldview without its own worldview overview by means of Multi-Touch. You can find details in the Navigation with Multi-Touch in the worldview chapter.


Worldview Overview

Manual -> Worldview -> Operating during Runtime -> Worldview Overview

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the Runtime you have several possibilities to control zoom size and displayed section in the worldview overview:

  • Control elements
  • Mouse and touch
  • Keyboard

The control elements can also by operated via touch screen. The points of contact for the operation via mouse are dimensioned respectively in order to be also operated via touch without problems.

When using Multi-Touch gestures, you can directly navigate in the worldview and a Worldview overview type screen is not necessary.

info Information

The worldview overview is always in the foreground as its own window in Runtime, regardless of the settings for screen elements in the Editor.


Navigation with control elements

Manual -> Worldview -> Operating during Runtime -> Worldview Overview -> Navigation with control elements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Parameters | Description
Zoom min. | Turns off zoom. The section is displayed in the size of the frame.
Zoom max. | Maximum zoom level.
+ | Zoom into the screen.
- | Zoom out of the screen.
Slider | Slider for setting the zoom level.
Move left | Moves the displayed section to the left.
Right | Moves the displayed section to the right.
Up | Moves the displayed section up.
Down | Moves the displayed section down.
Object list | List of the directly controllable Objects. Click on an object in order to center the object in the displayed screen section.


Navigation with the mouse

Manual -> Worldview -> Operating during Runtime -> Worldview Overview -> Navigation with the mouse

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the mouse and touch operation the following action are available:

  • Move section:

    To move the displayed section of the worldview, you have several possibilities:

    1. In the section click on the center and move the mouse over the frame while holding the left mouse button.
    2. Press the space bar and click in the worldview. The form of the mouse cursor changes to a hand. Now you can move the worldview with the help of the mouse. Left mouse clicks are not registered in the worldview when the space bar is pressed.
    3. Click in the section with the right mouse button and move the mouse over the frame while holding the right mouse button.
    4. Press and hold the mouse wheel and move the mouse over the frame.
  • Zooming:
    Click in the section and spin the mouse wheel in order to zoom. Zooming is carried out in the defined zoom steps. During zooming the mouse cursor remains over the selected position in the screen.
  • Scrolling:
    The worldview can be scrolled with the mouse wheel:
    • Vertical: Click in the worldview and spin the mouse wheel.
    • Horizontal: Click in the worldview, hold and press key Shift and spin the mouse wheel.

      Shift key + mouse wheel upwards: scroll to the right

      Shift key + mouse wheel downwards: scroll to the left

info Information

Frames can also be moved with the mouse if the screen is not a worldview. To do this, the Move Frame via mouse property must be activated. In Runtime, a left mouse click in a free area of the screen and then moving the mouse with the mouse button held down moves the whole screen.

Reciprocal effects

The Move Frame via mouse property cannot be activated at the same time as the properties Move horizontally and Move vertically. Either movement of a frame with a mouse, or the horizontal/vertical movement by means of touch operation can be activated.

Note this special case: With the following scenario, both properties are set and remain unconfigurable after that:

  • The Move horizontally or Move vertically property is activated.
  • Recognition project property for Interaction is set to Windows 7 or deactivated.
  • Move Frame via mouse property is activated.
  • Recognition property is set to Windows 8 again.

Solution:

  • Set the Recognition property back to Windows 7 or deactivated.
  • Deactivate the Move Frame via mouse property.


Navigation with the keyboard

Manual -> Worldview -> Operating during Runtime -> Worldview Overview -> Navigation with the keyboard

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can also use the keyboard for zooming and moving. For this you must assign keys to control elements, for example:

  • up -> arrow key up
  • down -> arrow key down
  • left -> arrow key left
  • right -> arrow key right
  • + (slider) -> key +
  • - (slider) -> key -

To assign a key to a control element:

  1. Highlight the control element
  2. go to property Key combination
  3. Click on the ... button or in the input field
  4. the dialog for defining the key combination is opened
  5. click in field key combination
  6. press the desired key or key combination on the keyboard, e.g.: +
  7. the key combination is displayed in the input field
  8. Close the dialog by clicking on OK


Navigation with Multi-Touch in the worldview

Manual -> Worldview -> Operating during Runtime -> Navigation with Multi-Touch in the worldview

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Multi-Touch gestures for zooming and scrolling are suitable for navigation on touch panels in the worldview. For this a screen of type Worldview overview is not necessary. The navigation can be implemented with:

  • Windows 7 touch gestures
  • Windows 8 touch gestures

Rules

  • Move: If a screen in a container is not a worldview, it accepts the settings of the faceplate screen.

Moving the worldview or worldview in the container of a faceplate

  • Screen is bigger than the frame: Content of the screen is moved.
  • Screen is the same size or smaller than the frame: No reaction.

Worldview embedded in faceplate.

  • Screen is bigger than the frame: Content of screen is moved.
  • Screen is the same size or smaller than the frame: No reaction.

Move the frame or border with the mouse if the screen is a worldview and the same size or smaller than the frame:

  • With the right mouse button: No reaction.
  • With the left mouse button: Frame is moved.

Change worldview size

The size of the worldview cannot be changed.
Exception: If the worldview is a faceplate, the size cannot be changed.

Click with right mouse button:

  • Screen is bigger than the frame: Contents are moved.
  • Screen is the same size or smaller than the frame: No reaction.

Project conversion

Values for Move horizontally and Move vertically when converting from an earlier version to zenon 7.20:

  • Screen is bigger than the frame: Move.
  • Screen is the same size or smaller than the frame: No reaction.


Navigation under Windows 7

Manual -> Worldview -> Operating during Runtime -> Navigation with Multi-Touch in the worldview -> Navigation under Windows 7

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To be able to use Multi-Touch gestures under Windows 7 to navigate in the worldview, you must:

  • activate them via property Multi-Touch for zoom and scroll
  • or implement them via VBA/VSTA

Zoom and scroll via property Multi-Touch for zoom and scroll

To use Multi-Touch without VBA/VSTA:

  1. In the project properties in the Interaction node for the Recognition property, activate Windows 7.
  2. Deactivate property Screen size from frame in node Frame at the properties of the screen
  3. Activate property Multi-Touch for zoom and scroll in node Interaction at the properties of the screen

With this you can scroll and zoom in the screen with touch operation using Multi-Touch gestures. With this VBA/VSTA for zooming and scrolling is deactivated.

Zoom and scroll via VBA/VSTA

To implement zooming and scrolling via VBA/VSTA Events, property Multi-Touch for zoom and scroll must not be active.

The following is available in the DynPicture:

  • Property

    int ZoomLevel: Displays the current zoom level in the worldview (valid value only in the Runtime and for a worldview).

  • Style

    SetZoomAndPos(float ZoomX, float ZoomY, int ZoomLevel, int CursorX, int CursorY, int PosX, int PosY, int PosMode):

    ZoomX -> New zoom factor X direction; if not used, set to 0

    ZoomY -> New zoom factor Y direction; if not used, set to 0

    ZoomLevel -> Zoom level, if not used, set to -1

    CursorX -> Cursorposition X

    CursorY -> Cursorposition Y

    PosX -> New position X (see PosMode)

    PosY -> New position Y (see PosMode)

    PosMode -> Coordinates in Pos

    -1 = PosX, PosY are ignored

    0 = center point , original coordinates

    1 = center point, zoomed coordinates

    2 = left top, original coordinates

    3 = left top, zoomed coordinates

    4 = zoomed coordinates of the cursor from the top left
    The position of the window is changed in such a way that after the zooming the mouse cursor is still over the position of the screen

Attention: ZoomX, ZoomY and ZoomLevel can never be used simultaneously. Either you enter a ZoomLevel or a zoom factor for x and y axis.


Navigation under Windows 8

Manual -> Worldview -> Operating during Runtime -> Navigation with Multi-Touch in the worldview -> Navigation under Windows 8

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To navigate in a worldview with Multi-Touch under Windows 8:

  1. In the project properties in the Interaction node for the Recognition property, activate Windows 8.
  2. Deactivate, for the screen in the Frame group, the Screen size from frame property and define the screen size as larger than the frame.
  3. navigate to group Interaction in the screen properties.
  4. Configure the properties for Zoomen and Verschieben.

For the move gesture, you can define the direction - horizontal, vertical or both. To do this, use the Horizontal verschieben and Vertikal verschieben properties.


zenon Operator

Manual -> zenon Operator

The zenon Operator is adapted to machine operation. It consists of Editor and Runtime. The Runtime is available for PC operating systems and CE operating systems. For Windows CE there a restrictions determined by the system.

The principle functionality conforms with the zenon Supervisor. Towards the zenon Supervisor the Operator has functional restrictions.

For Editing am Operator project you can either user the Editor of the zenon Operator or the Editor of the zenon Supervisor. If you engineer functionalities in the Supervisor Editor which are not available in the Operator Runtime, they are simply not executed.


Restrictions for the zenon Operator

Manual -> zenon Operator -> Restrictions for the zenon Operator

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The functionalities of the zenon Operator differ from those of the zenon Supervisor. For deployment under Windows CE there will be further restrictions of the operating system. You can find details in the following overview:

Key:

  • +: Standard
  • *: possible
  • -: not possible
  • o: licensable as an optional module
Features Operator Runtime | for PC | for CE
General |  |
ActiveX Controls | + | *
Dongle licensing | * | -
64 - 8192 TAGs | * | *
Direct X/Graphics | * | -
Global project | * | *
Multi-project in the Editor | - (only 1 project plus gloabl project) | - (only 1 project plus gloabl project)
Multi-project in the Runtime | - (only 1 project plus gloabl project) | - (only 1 project plus gloabl project)
Wizards | + | -
Modules |  |
Historian | - | -
Historian Starter Edition | o | o (CE 6.0 or above)
Historian SQL | - | -
Automatic Line Coloring | o | o
Batch Control | o | -
Load Management | - | -
Extended Trend | - | -
Extended Trend Starter Edition | o | o (CE 6.0 or above)
Industrial Maintenance Manager | - | -
Industrial Performance Analyzer | - | -
Message Control including Text To Speech Engine | o | -
OPC Server | - | -
PLC Diagnose Step 7 Graph | o | o
Process Gateway | - | -
Production & Facility Scheduler | - (Scheduler available) | - (Scheduler available)
Project simulation | - | -
Report Generator (without data storage) | o (read only) | -
RDL Viewer | o | -
Recipegroup Manager | o | o (CE 6.0 or above)
SAP interface | - | -
Scheduler | + | +
SQL Export | - | -
SQL Server | - | -
Text to Speech Engine | - | -
Driver: 1 driver included, exceptions Energy driver (IEC870-101/103/104, IEC850, DNP3, Modbus Energy) | * | *
Driver: several instances | - | -
S7 Graph | o | o
Network |  |
zenon network | + (only Server Client) | + (only Server Client)
Redundancy | - (Server Client only) Redundancy is not supported, but a connection to a redundant system is possible. | - (Server Client only) Redundancy is not supported, but a connection to a redundant system is possible.
zenon Web Server Pro Light, 3 Clients. Only with connection to the local Runtime | o | o
zenon Web Server/zenon Web Server Pro | o | -
zenon Web Client | * | - (Classic clients are possible.)
Programming interfaces |  |
Access via API | + | +
Process Control Engine | + | +
VBA/VSTA | Runtime: - Editor: + | -
zenon Logic |  |
zenon Logic Monitoring Builder/Viewer | + | -
Number of variables zenon Logic Runtime | 64 - 8192 | 64 - 8192
zenon Logic Workbench Pro | o | -

All not mentioned modules/functionalities are available with the zenon Operator.


Special restrictions for CE version

Manual -> zenon Operator -> Restrictions for the zenon Operator -> Special restrictions for CE version

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Modules which are available in Windows CE 6.0 and higher versions:

  • Historian Starter Edition
    Restrictions see manual Historian, chapter Historian Starter Edition.
  • Extended Trend Starter Edition
    Restrictions see manual Extended Trend.
    In addition the following control elements are not available in CE projects:
    • Diagram button
    • Curve button
    • Chart settings
    • Print dialog
    • X axis button
    • Cursor output window
    • Filter profiles
  • Recipegroup Manager

Acknowledge alarm status line

In Windows CE you cannot acknowledge the alarm status line with a right click.

Historian

For archiving only the Historian Starter Edition is available for Windows CE. It has a few restrictions compared to the Historian. For details see chapter Historian Starter Edition in manual Historian.

Resolution of the CE device and display of the CEL and AML filter dialogs

The Alarm administration and the Chronological Event List (CEL) permit a filter selection in the Runtime. However it can only be used with a resolution of 800x600 or higher. The Profile administration in the corresponding screens is not available. As a consequence, the buttons Save and Delete do not work. As the Print dialog cannot be executed in Windows CE, the corresponding button does also no longer work.

Screen types which are not available:

  • Variable diagnosis
  • Video

User administration

Active Directory and ADAM/AD LDS are not available with Windows CE..

Dynamics

Dynamics such as rotation, changing height and width or X and Y position are not available

Dynamic elements

ActiveX elements: Registration in Windows CE:

Active X – Elements must be registered before they can be used in CE. You can find help on this in the chapter entitled 'Engineering hints - Active X'.

Universal slider

The diaplay as Ribbon is not available.

XAML and WPF files

WPF is not available. Therefore XAML which is used as description language for WPF is not used.

Filter in AML and CEL

The filters for the Alarm Message List and for the Chronological Event List cannot be engineered if property Windows CE project is activated. As these dialogs are very large this limitation was introduced in order to ensure the operability even on small displays (PDAs). If you create a Windows CE project without activating property Windows CE project, you can use the filter dialogs as usual.

Filter profiles

It is not possible to work with profiles in Runtime under Windows CE.

Freely defineable frame shape

For frames the Freely defineable frame shape is not available under Windows CE.

Functions

Select printer

The function Select printer is not available for all CE devices.
Note: You can find this function in the function group Application.

Graphics

Rotation angle and dynamic positioning

The property Rotation angle [°] and properties of the group Size and rotation dynamic are not available under Windows CE. Previously engineered properties are reset when the property is Windows CE project activated.

Filling effects

Filling effects of static elements may be displayed differently than on a PC depending on the CE terminal.

For static elements only filling patterns complete and not filled are availlable for Windows CE
For the static elements there are only the following line types for Windows CE: full, dashed, without.

3D Filling patterns

3D patterns are available but need more graphic resources of the CE terminals.
So they are not recommended.

Graphics quality

DirectX, as well as graphics functions such as shaded filling and transparency are not available under Windows CE.
Note: Transparent GIF files and PNG files with restrictions can be displayed.

GIF files

To display GIF files in Windows CE, you must make sure that file IMGDECEMP.dll is available on the target device. If the file is missing, you can request the IMGDECEMP.dll file from COPA-DATA Consulting.

Lines

Lines cannot be displayed with rounded corners. Even when the project properties under Graphics quality Windows Basis is chosen, rounded corners are not displayed under CE.

Display of the recipe names

In the screen of type Recipegroup Manager the recipe names can only be displayed in a combobox. The display of the listbox (via Style L) is not supported by CE platforms.

Main menus

Under Windows CE only the standard main menus can be displayed. It is not possible to change color, font size or font type.

Licensing (dongle)

Dongle licensing is not available for Windows CE, neither locally nor with a network dongle.

Multi-Project capability

Windows CE does not offer Multi-project capability, i.e. only one project can run at a time. This is the reason why there can be no hierarchies (Integration project) in network projects. This limitation does not apply to the global project.

Project size

With Windows CE 6 or higher, the working memory can be used in full, but it is limited on some CE devices. This can therefore lead to memory bottlenecks, most of all if Extended Trend and Historian Starter Edition are used. Please note the 20% rule in these cases.

info Information

20% Rule: With all zenon screens called up and the maximum number of alarms in the memory active, at least 20% of the working memory should still be free. If this limit is not considered, we cannot guarantee a trouble-free operation of zenon.

The available central memory can be found out with the system driver variable Free disk space %.

Cross reference list

If a button in a CE project is linked to a function, which is not available under Windows CE, it is indicated with 'Function deleted' in the Runtime.

Right mouse button

The function for the right double-click is not available under Windows CE.

Redundancy

Redundancy combined with a CE device as client is possible. Redundancy in the sense that the CE device takes over the role of the Server or the Standby Server is not possible.

Write set value

Set value options for elements or functions do not work with macros or programs. Set point inputs are only possible with the standard dialog box or in the element with the numerical value.

If on a CE device a set value is sent to a HD variable (e.g. with the Universal slider), a certain delay will occur, because writing on a storage card is not fast enough. Delays can also occur, if set value actions are logged in the CEL and the CEL is written to the storage card for each entry (project property).

Driver simulation

Simulation - programmed is not vailable for Windows CE 6.

Vector elements

Arc of a circle

In Windows CE, the static element Arc of circle is only displayed correctly with a line thickness of 1.
Attention: Thicker line arcs are also not displayed correctly in network projects. The line arcs look jagged then and do not look like the ones engineered on the PC.

Segment of a circle

The static element Segment of a circle is not available in Windows CE.

Variables

Variables of data type LINT are not available in Windows CE.

Worldview display

The world view is not available under Windows CE due to the graphics requirements.

WMF and EMF files

The use of Meta Files (*.wmf) und (*.emf) is not possible.


zenon for Windows CE

Manual -> zenon Operator -> zenon for Windows CE

The CE Runtime of the zenon Operator can run on different CE hardware platforms. Generally, the CE version of zenon offers the same functionalities as the PC version of zenon Operator however with some limitations which result from the lower hardware resources.

You can find detailed information about the installation of the zenon and zenon Logic Runtimes for Windows CE in these chapters:

  • zenon Operator Runtime for Windows CE
  • zenon Logic Runtime for Windows CE

tutorial License information

The zenon Runtime for Windows CE must be licensed.


General

Manual -> zenon Operator -> zenon for Windows CE -> General

Windows CE is an open, scaleable platform for a great number of devices for communication, entertainment, industrial and mobile data processing. Generally speaking Windows CE is an operating system reduced to the essential, which only needs very low hardware resources. This means, that now very low-priced hardware components can be equipped with a Windows based operating system.
The newly developed standard Windows CE allows the realisation of novel devices which can communicate with each other, exchange information with Windows based PCs and connect to the internet.
Windows CE is a 32 bit operating system with functions such as multitasking and multithreading. Windows CE has an open structure and supports a great variety of devices. Windows CE is compact, and thus offers high performance even with limited memory.

Advantages of Windows CE are among others:

  • quick boot up of the device as the operating system is unpacked in the memory for every boot up
  • as no software can be installed on the CE device, there is no danger that abortive installations or viruses can influence the operating system
  • high level of ruggedness as there a normally no moving parts (such as hard disks) in a CE device

Disadvantages of Windows CE are among others:

  • limited functionality as not the whole Windows API (Application Programming Interface) is available
  • slower read and write access on the Compact Flash card
  • reduced life cycles of the storage media because of frequent access

The zenon Runtime with CE offers the same functionalities as with a PC. They are restricted by lesser hardware resources and limitations of the operating system.


Creating projects for CE

Manual -> zenon Operator -> zenon for Windows CE -> General -> Creating projects for CE

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The editor is a tool to create midgets, small or medium applications as well as major projects. The projecting tool is always the same. Independent of the platform for the projects, always the full engineering comfort is available. You have full project data compatibility independent of the resolution.

CE-Editor

For CE projects in the Editor under -> Properties -> General check box 'Windows CE Project' is activated. Thus only the functions which are available under Windows CE are activated. All other functions are grayed out. Excluding VBA: In the Editor VBA can be used for wizards. It cannot be used in the Runtime.

Depending on the license the Editor is limited to 8,192 TAGs.

VBA under CE

In the Editor VBA can be used for wizards. It cannot be used in the Runtime.


Licensing

Manual -> zenon Operator -> zenon for Windows CE -> General -> Licensing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Runtime for Windows CE can be licensed with the Remote Transport. When you establish the connection to the target system, you can enter the serial number and the license number for the CE version. The serial number is saved on the CE device in the zenon6.ini file. The activation number is saved in the registry.

info Information

The serial number and the activation number are not fully checked for validity when they are entered in the Remote Transport on the PC. The full check for validity is performed during the start of the Runtime on the CE device. Therefore, it is necessary to start the Runtime once after updating the serial number/activation number in order to check whether the numbers were entered correctly.

Standard shipment includes a CE demo serial number that does not need an activation number.

Example Example

Demo serial number for CE 6.0 0.59211400.0.-256.0

The demo version for CE 6.0:

  • is limited to
    • 4,096 variables
    • a duration of 10 minutes
  • contains
    • Process Control Engine
    • Extended Trend Module (Starter Edition)
    • Historian (Starter Edition)
    • zenon WEB Server Pro (3 clients)

attention Attention

With the Windows Mobile Edition only roughly 800 - 1000 variables can be loaded depending on the available memory of the used device, the installed programs and the size of the project.


Requirements

Manual -> zenon Operator -> zenon for Windows CE -> Requirements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Under Windows CE the control system is executable on the most different devices independent of the hardware manufacturer. For each combination of operating system and processor type, a special Runtime is required, that has to be compiled and maintained for this specific platform.
Minimum requirement for the CE device:

  • 64 MB RAM memory
  • 32 MB free hard disk space

As the processor speed strongly depends on the processor type, a minimum speed is hard to define. But generally we recommend, that the processor should have a minimal clock rate of 400 MHz.
Recommended:

  • 128 MB RAM or more
  • 64 MB or more
  • Processor with 800 MHz for ARM processors or 600 MHz for x86 architecture
  • Network interface

info Information

Runtime and projects should be stored on a permanent writable remanent memory.

CE devices with touchscreen usually have a low screen resolution. This has to be considered when creating projects. Some dialogs, e.g. the variable selection for the standard recipes, the temporary login dialog and other dialogs in the Runtime, are hard to operate or even not operable at all at a screen resolution of 320 x 240. But there is no minimal requirement in this case.
The engineering hints include a guideline for engineering low resolutions.

attention Attention

zenon must be installed in the according version. PC version and CE version of zenon have to match (same version, same service pack).

Start Runtime at the CE panel

To start zenon at a CE panel, all of the required modules must be available in the image.

Should modules be missing, then after double-clicking on zenonrce.exe a rotating hourglass will only be shown. After the hourglass has disappeared the zenon Runtime will not be started nor will an error message will be shown.

This action shows that elements are missing in the CE operating system and that the image was not generated correctly. Contact the manufacturer of the panel to correct the error. The COPA-DATA support is happy to help the manufacturer with the error analysis.


CE - versions and supported processors

Manual -> zenon Operator -> zenon for Windows CE -> Requirements -> CE - versions and supported processors

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the current zenon version 7.20 the following Windows CE versions and processors are supported:

  • CE 6.00 for x86
  • CE 6.00 for ARMV4/V5

info Information

You can find information about the supported CE versions and processors for earlier zenon versions in the corresponding documentation or you can contact the COPA-DATA support.


Compatibility

Manual -> zenon Operator -> zenon for Windows CE -> Requirements -> Compatibility

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon CE installation medium contains all previous compatible Runtime versions as ZIP file. These files contain binary data but no complete executable Runtimes.

If Runtime files are created with a newer Editor version, they perhaps need older drivers for the Runtime. To do this:

  • navigate to the respective ZIP file in folder Runtime compatibility on the installation medium.
  • unpack the driver from the file
  • transfer the driver to the device


System files

Manual -> zenon Operator -> zenon for Windows CE -> System files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Windows CE Runtime requires the existence of certain system files. In case one of these files is missing, the operating system sends an error message during Runtime start, that one or various components have not been found. The following system files are required:

File | Description
mfc90u.dll | Necessary for the Runtime. On startup, an error message pops up if this file does not exist.
msvcr90.dll | Necessary for the Runtime. On startup, an error message pops up if this file does not exist.
atl90.dll | Not necessary for starting the Runtime but for the use of drivers with network connections or the use of zenon in a network. If this file does not exist, the device will not work as a client; TCP/IP driver connections will not work.
IMGDECMP.dll | Not necessary for starting the Runtime but necessary for displaying Transparency if Alpha Blending is not integrated in the operating system. Animation of GIF files is not possible with Windows CE.
VBSCRIPT.dll + JSCRIPT.dll | Not necessary for starting the Runtime. This file is needed for the PCE (Process Control Engine).

Some of these system files are installed together with the installation of zenon for CE and can be transferred to the CE device using the UpdateCE Tool. All these system files should be integrated in the operating system image of the CE device by the manufacturer.

attention Attention

For manufactures of Windows CE OS-images:
CE versions older than 6.0 need the file toolhelp.dll. Activate the following option in Platform Manager in order that the file is available on the CE device and Toolhelp.h is available in SDK.
Core OS -> Display Based Device ->Core OS Services -> Debugging Tools -> Toolhelp API. Thus the Toolhelp.dll is part of the image.
Hint: Always use the most up-to-date Servicepack of the Platform Builder.

Note: File toolhelp.dll is not used for Windows CE 6 and should not be used with CE 6.


Runtime

Manual -> zenon Operator -> zenon for Windows CE -> System files -> Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Runtime for Windows CE consists of the following files:

File name | Description
zenonrCE.exe | Runtime application
Cd_tooCE.dll | Necessary for the Runtime
ZennetsrvCE.dll | The control system netservice for Windows CE. Necessary for network projects.
SysSrvCE.exe | Transport service
LogCliLibCE.dll | The logserver client
zenon6.ini | Text file with settings for the Runtime like e.g. start project, language of the Runtime, etc.
UpdateCE.exe | Application, necessary for the CE Update tool.
RgermaCE.dll | German language file
RengliCE.dll | English language file
RfrancCE.dll | French language file
RitaliCE.dll | Italian language file
RrussiCE.dll | Russian language file
RspaniCE.dll | Spanish language file

Install the Runtime to the CE device with the entry CE Runtime Update-Programme (under menu Option).

info Information

The following is true for a connection to Windows CE 6.0 with CX1000, Profibus or SYCONuni: Make sure that the file CDMemDrv.dll has been transferred to the device. CDMemDrv.dll is a Windows CE device driver. The DLL is available for x86 and for ARMV4I.

Additionally there are a number of other drivers for hardware communication. If the processor type of the CE device is recognised by the editor, the Remote Transport automatically transports the drivers used in the project to the CE device. The manner or The number of transferred files is displayed in the Output Window of the Editor.

These files always have to be compatible with the according CE version and with the according processor type. Mixing files from different CE versions or even service packs can lead to failures and unwanted side effects, and is thus is not permitted.

info Info

If, when starting zenonrce.exe, the syssrvce.exe file is also executed, then it can be ensured that a TCP connection can always be established. Thus only one file is necessary for the autostart functionality. However a time delay between both starts must be configured.

Reason: When starting zenonRCE, zenLogSrvCE also starts automatically. However when starting syssrvce, zenLogSrvCE is also started.

If zenonRCE and syssrvce are started within a very short period of time, both attempt to start zenLogSrvCE. This leads to an error message.

Solution: To avoid this, configure a time delay between the start of zenonRCE and zenLogSrvCE. To do this, you can set the STARTDELAY= entry in zenon6.ini. Runtime (zenLogSrvCE) is thus started later. A check is then made to see whether zenLogSrvCE is already running and this does not start again.


Network

Manual -> zenon Operator -> zenon for Windows CE -> Network

Of course zenon under Windows CE can still be used in a network. The CE terminal can be a server or a client in combination with other terminals or standard PCs. Another possibility is, that the CE terminal is used as a dataserver in combination with a PC.

Redundancy in a network is not supported under Windows CE, i.e. a CE terminal cannot be a standby server. If however PCs are used as server ans standby server, the CE terminal can connect as a client and in the case of a redundancy switch automatically connects to the current server.

info Information

Multi-project functionality is not supported under Windows CE.

But several CE projects can be combined in an integration project on a PC.

If the CE Runtime should be used in a network, the following requirements have to be fulfilled:

  • Network connection of the CE terminal
  • TCP/IP network with full (!) Name resolution
  • Unique computer name and IP address in the network
  • Necessary system files and Runtime on the CE terminal (Refer to chapter “Requirements”)
  • Runtime licence with network support on the CE terminal

info Information

If a CE terminal i used n a network, no matter if server or client, on the CE terminal a Runtime licence with network has to be used.

Not network licence is necessary for Remote Transport!

If this network license does not exist, zenon is automatically started as standalone and each CE device establishes an own connection to the PLC.


Network settings

Manual -> zenon Operator -> zenon for Windows CE -> Network -> Network settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As the name resolution under Windows CE does not always exist, the computer names and the IP addresses of the CE terminal and the PC have to be defined. On the PC there is the file HOSTS for this purpose; it can be found in the folder /Windows/System32/Drivers/ETC. In this file the IP address and the computer name of the CE terminal have to be entered in capitals and separated by a tabstopp. For example: 192.168.0.100 WINDOWSCE2

info Information

When saving the file, care that there is no file extension .txt!

The link between computer names and the IP addresses has to be defined on the PC as well as on the CE terminal, if the network does not fully support a dynamic name resolution. (In the dynamic name resolution the computer names are resolved based on the IP address). On the PC this information is stored in the HOSTS file under /Windows/system32/drivers/etc.

The operating system Windows CE does not support teh functionality of a HOSTS file. The computer name and the IP address have to be entered in the zenon6.ini of the CE terminal, so that the name resolution also works correctly on the CE terminal. The following entry is needed:

Example Example

[IPADDR]
My computer name=my IP address
CE terminal name =CE terminal IP address

SERVERNAME=192.168.1.152

Under SERVERNAME enter the name of your server. Enter the according IP address of your server.

Example: Your server is PC0815 and has the IP address 192.52.9.32, so you enter: PC0815=192.52.9.32

Care that the computer name is entered in CAPITALS!

Other examples

[IPADDR]

WINDOWSCE2=192.168.0.100

PC1=192.168.0.1

If the CE terminal does not know its own name, it also has to be entered here.

attention Attention

Do not use dynamic IP addresses, if there is no name resolution in the network.


CE terminal as server

Manual -> zenon Operator -> zenon for Windows CE -> Network -> CE terminal as server

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this constellation the project on the CE terminal is a server project (with limited functionality). All other computers, which connect to the terminal, are clients (PC clients, CE clients and Web clients are possible).

Used drivers are started on the CE terminal. As a CE terminal is used as the server, the functionality is also limited on the PC clients. The use of a CE terminal as a standby server is, as already mentioned, not possible.

This model has the following characteristics:

The CE project still has a limited functionality, i.e. no data archiving and no optional modules are available.

The CE terminal sends process data to all connected clients. Alarm administration, REMAs, mathematical calculations are handled on the CE terminal.

With many connected clients the CE terminal has to cope with rather heavy network load, which of course is not good for the performance of the CE terminal.

Engineering the CE terminal as a server in practice:

In order to be able to define the CE terminal as a server, the computer name of the CE terminal has to be entered as the server in the project configuration. Make sure, that the name is entered in capitals. After you have finished the project, you have to transport the Runtime files to the server (CE terminal) with Remote Transport. Then one time you have to transport the Runtime files to all clients.

For the whole system only one single project has to be created. Future project changes only have to be transported to the server. In the case of project changes all clients get the new project data.

In the project only functionality supported on the CE terminal should be used. The option CE project is a useful tool for this purpose. It avoids, that you use modules (screens, functions, etc.), which are not supported under Windows CE.

In order to allow data archiving, the use of modules such as the extended trend or the Report Generator, and provide a number of clients with data without a performance loss on the operating terminal in spite of using Windows CE, the following second possibility was implemented:


CE terminal as client

Manual -> zenon Operator -> zenon for Windows CE -> Network -> CE terminal as client

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Here the project on the CE terminal is not a server project. So the project on the CE terminal connects to a server as a client. This server can be a PC as well as another CE terminal.

This model has the following characteristics:

The CE project on the client has limited functionality, i.e. on the CE client only functionality supported by CE is available. Archives, extended Trend, Reports, etc. are not available. The project on the server however can contain such elements, if the server is a PC. On a PC client - if licenced - the full project is available. In order not to confuse the user the system offers the option: Visible under CE. If this checkbox is not activated, the according element is not displayed on the CE terminal.

The network load on the CE client is negligible, because there is always only one connection - that to the server. The drivers in this case are started at the server.

Engineering the CE terminal as a client:

For the whole system only one single project has to be created. This project runs on the server, which administers all data.

Engineering is done on the PC and the created Runtime files are transported to the server and the clients with Remote Transport.

If later changes in the project are done, the changed files have to be transported to the server with Remote Transport. The clients will update the changes after executing the function Reload project online.

The option CE project does not have to be activated. Thus the entire functionality of zenon is available for the project. As only a limited functional range is available on the CE side, functions that are not supported under CE will not be executed there (modules, special functions, etc.).

In order not to confuse the operating personnel by offering them screens and elements on the CE terminal, whioch will not work or are not supported there, for screens and elements the option Visible under CE can be used in the Editor. So the implementing engineer has the possibility to realise his project in the way, that a part of it is available under CE and another part only on the PC (PC server, other clients, …).


Possibilities for diagnosis

Manual -> zenon Operator -> zenon for Windows CE -> Network -> Possibilities for diagnosis

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

CE terminal as server

In order to make sure, that the CE terminal really works as a server, you can try the delete a driver used in the project with the Explorer on the CE terminal, while the Runtime is running. If this is possible, then Runtime on the CE terminal does not run as a server (applications opened exclusively cannot be deleted). It is possible that the CE terminal does not know its correct name or Runtime on the CE terminal does not have a network license.

CE terminal as client

If the client cannot establish a connection to the server, this is indicated with blue squares on the dynamic elements. The option Display status has to be activated for the elements in the properties window.

System driver

The system driver offers a variety of variables for network diagnosis.

Misc.

If the CE terminal isused in a network, it should be possible to establish a connection to the CE terminal by using the command: "telnet COMPUTER NAME 1100" in the command box. (Cursor flashing in the top left corner). Runtime has to be started on the CE terminal.

COMPUTER NAME her means the name of the CE terminal (look it up in the Control Panel); 1100 is the port for the communication of the control system network service (zennetsrvce.dll).

If the connection with Telnet cannot be established, either the name resolution in the network does not work, or the Runtime on the CE terminal has no network licence, or the system file ATLCEx00.dll does not exist on the terminal.

The file zennetsrvce.dll for the respective platform is automatically transported to the CE terminal by Remote Transport (Remote transport all Runtime files). If this is not the case, the Runtime files for CE probably are not installed on the terminal. If in the Editor menu Option the command CE Runtime Update exists, the Runtime files for CE are installed.

If it happens, that sometimes one and sometimes another client connects, the reason might be, that both CE terminals have the same computer name. Windows CE does not generate an error message, if a computer name already is used in the network.


CE terminal as data server

Manual -> zenon Operator -> zenon for Windows CE -> Network -> CE terminal as data server

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to allow data archiving, the use of modules such as the extended trend or the Report Generator, and provide a number of clients with data without a performance loss on the operating terminal in spite of using Windows CE, the following possibility of the dataserver was implemented:

This model has the following characteristics:

Here the CE terminal works as a dataserver, i.e. in the background all driver data are sent to another computer (PC server), which has the real server functionality. Here data can be archived, alarms and CEL are administered, and any number of clients gets the data. Also the use of other modules such as Recipegroup Manager, Message Control, SQL Server, Extended Trend, etc. is possible.

On the second hand the CE terminal is one of these clients and so gets all online data, screens, alarm messages, etc. from the server.

In case of a server failure, the CE terminal does the administration of alarms and CEL.

attention Attention

The CE terminal does not save the alarm and CEL entries, while the server is inactive.

Modules not supported under CE will not work. You have to make sure, that no data for the archives are saved on the CE terminal. The CE terminal does not support the connected clients with data. Clients indicate problems in the communication with a blue square.

Like in the redundant network (server and standby server) also here the primary server is dominant, i.e. after starting the PC server the CE terminal is again the standby server and works as dataserver. Driver data such as HDD data are aligned. The server uses the last valid alarm and CEL list and sends these to all clients (also dataserver). The archiving module on the PC server agan can archive and the other clients align with the server und get data from it. The alignment of system and mathematics driver only works in parts because of technical reasons.

If the dataserver fails, the communication problem is indicated with a red square on the elements on the server and all clients. The server will not directly connect to the PLC!

This constellation can also be used universally in a PC network, e.g. when using an inefficient PC directly on the machine, which has the data connection to the process. Data archiving however is not done on this PC but on a zenon server which has the real server functionality in the network.

Conclusion: If the dataserver fails, there is no communication with the PLC. All clients indicate disturbed values and no data are archived. If the server fails, also at that time there is no archiving. For the entire time of the failure, there are no archived data. If the server fails, the dataserver takes over the alarm administration, but alarms received or cleared during this time will not be taken over by the server.

Defining the dataserver concept in practice:

Engineering is done on the PC and the created Runtime files are transported to the server and the CE terminal with Remote Transport. All clients (also the dataserver behaves like a client) are automatically updated, if the project is edited.

attention Attention

In the project configuration the computer name of the PC has to be entered as the server, the name of the CE terminal as the standby server. Additionally the option Standby as dataserver has to be activated.

The option CE project does not have to be activated. Thus the entire functionality of zenon is available for the project. As only a limited functional range is available on the CE side, functions that are not supported under CE will not be executed there (modules, special functions, etc.).

In order not to confuse the operating personnel by offering them screens and elements on the CE terminal, whioch will not work or are not supported there, for screens and elements the option Visible under CE can be used in the Editor. So the implementing engineer has the possibility to realise his project in the way, that a part of it is available under CE and another part only on the PC (PC server, other clients, …).

Other limitations of the dataserver:

  • The system and mathematics driver are handled especially in the dataserver concept (and only here): In the dataserver concept both the system and the mathematics driver only run on the server. So the dataserver gets no values of these drivers. On the dataserver mathematicy and systemdriver only start, as soon as the server is stopped. As soon as the server is online again, both drivers again only run on the server. From that time the dataserver gets no data from the system and mathematics driver. So mathematics variables do not work correctly in the dataserver concept.
  • Global variables of the system driver like Names of current clients, Number of connected clients, Current server are administered by the server. The server does not send these variables to the dataserver. So the data server shows its own local contents in these variables, which is not consistent with the server. The system does not offer these data, so this behaviour cannot be changed.
    The only exception are the local variables of the system driver like Free memory, Free harddisk space, etc. These variables are always updated locally on the according computer.
  • Evaluated network:
    • Variables of the internal driver that have, in the Internal Variable properties group, the Calculation property configured to Network are not available for CE Terminal as a data server.
      If this property has been configured locally, only clients and Server 2 are supported. Server 1 is not supported with this configuration at all.
    • If a variable has the Only read from Standby Server property activated, variable values are not supplied from Server 2 or from Server 1. In this case, a blue square is displayed for the variable to indicate a communication problem.
    • Drivers that have the Stop on the Standby Server property activated do not run on the Server 1 if Server 2 is the data server.
      Note: This property is in the configuration dialog of each driver in the General tab.
      In this case, a blue square is displayed for the variable to indicate a communication problem.
    • Because the data server of the CE terminals is not an "actual" server, the zenon redundancy switching function is not available.

info Information

As an alternative to the dataserver concept from version 6.20 upwards the project-overlapping archiving can be used to archive data from different CE terminals. To do this every CE terminal needs a network licence and in the project the CE terminal has to be defined as a server.

On a PC with a Historian licence, the CE projects are added as sub-projects. In the integration project variables from the sub-projects can be added in the archive configuration.

Note: You can get further information in the help for archiving.


Connection via Windows Mobile Device Center

Manual -> zenon Operator -> zenon for Windows CE -> Connection via Windows Mobile Device Center

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the help of the Microsoft program Windows Mobile Device Center you can establish a connection between an industrial CE terminal and a PC.


USB connection under Windows 7

Manual -> zenon Operator -> zenon for Windows CE -> Connection via Windows Mobile Device Center -> USB connection under Windows 7

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

At a USB connection between the CE device and a computer under Windows 7:

  1. make sure that a connection to the Internet is possible
  2. connect both devices via USB cable
  3. at an existing internet connection the Windows Mobile Device Center is installed automatically and the connection is established
  4. You can transfer data as described in chapter Update of Windows CE Runtime .

info Information

If there is no active Internet connection at the USB connection, there is no automatic installation and configuration. In this case:

  • establish the Internet connection
  • go to the Device Manager in the Control Panel
  • right click on the unknown device
  • select update driver software
  • Windows installs the drivers
  • Windows installs the Windows Mobile Adapter and with this the Windows Mobile Device Center


Update of the Windows CE Runtime

Manual -> zenon Operator -> zenon for Windows CE -> Connection via Windows Mobile Device Center -> Update of the Windows CE Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To perform an update of Windows CE Runtime:

  • make sure that the zenon Transport Service (SysSrvCE.exe) runs in the CE device
  • make sure that you do not have established a remote connection via the zenon Editor to the device
  • In the zenon Menu, select Options and then Update Windows CE Runtime.
  • The dialog for transfer of Runtime files opens
  • configure the link
  • define the data you want to transfer
  • choose the appropriate version
  • start the update

Note: If you are transferring/installing Runtime for the first time, note the information in the Manual installation and Runtime update chapter.

Configure connection

You can configure the connections to the Windows CE device in the tab Connection.

Parameters | Description
Serial | Settings for serial connection with Windows CE device, you have to select a port.
TCP/IP | Settings for TCP/IP-connection to the Windows CE device.
Adress | IP address.
Name | Computer name
Syssrvce.exe starts with these settings | Settings for starting syssrvce.exe.
Serial | Active:: serial connection selected, port must be selected.
TCP/IP | Active: TCP/IP-connection selected.
Connection with MS ActiveSync | Settings for connection via MS ActiveSync
Use MS ActiveSync for initial transport of syssrvce.exe | Active: syssrvce.exe is transferred during the first transport via MS ActiveSync.
Destination folder | Target folder.
Help | Opens online-help
Save | Saves all changes.
Exit | Closes the update CE-tool and reminds you before to save unsaved changes.

Define files you want to transfer

Parameters | Description
Files to update | Files to be transferred.
HMI Runtime | Active: Transfers zenon files to the target device. Default: active
PLC Runtime | Active: Transfers zenon Logic files to the target device. Default: inactive
OS system files | Active: Transfers necessary files for the OS. Default: active
Update zenon6.ini | Transfers zenon6.ini to the target device. This way, the license information of the target device is also changed.
Options |
Language | Desired target system language. Default: English
HMI drivers | Selection of HMI drivers for transfer.
Available | List of available dirves.
Selected | List of selected drivers.
Add | Adds chosen drivers to the list of selected drivers.
Add all | Adds all drivers to the list of selected drivers.
Remove | Removes chosen drivers from the list of selected drivers.
Remove all | Removes all drivers from the list of selected drivers.
Help | Opens online-help
Save | Saves all changes.
Exit | Closes the update CE-tool and reminds you before to save unsaved changes.

Select version

Select the correct version in the tab Versions if it wasn´t automatically recognized.

Parameters | Description
WinCE version | Version of the target device Windows CE OS. Click the button to open a drop-down list for selection.
Processor type | Processor of the device.
Source path | Path to the folder that contains the files. Click the button ... and a dialog opens to select a folder.
New | Inserts a new, empty entry in the list.
Delete | Deletes the selected entry from the list
Test | Verifies settings.
Help | Opens online-help
Save | Saves all changes.
Exit | Closes the update CE-tool and reminds you before to save unsaved changes.

Start update

To establish a connection:

  • click on the button Start on the tab Update.

  • The data that shall be transferred is verified and displayed in a window.
  • Start the transfer to the target device by clicking on the button Next .

If the transfer cannot be initiated because files are missing, an error message with a list of missing files pops up:

  • If you get the error message The current update was not completed, the update was interrupted or not executed properly.

info Information

If you want to replace zenVNCServer.exe via update, it is terminated and restarted after the update. For this the file zenVNCSrvCE.exe must contain the

the following entry in the UpdateCE.ini in section [SOURCES_FILES_GENERAL] (exists per default):

  • zenVNCSrvCE.exe
  • zenVNCCfgCE.exe


Recipegroup Manager

Manual -> zenon Operator -> zenon for Windows CE -> Recipegroup Manager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Filter dialog in the Runtime

If you activate property Show dialog in the Runtime at the options of the Recipe value list in the screen switch, there are only restricted options available in Windows CE:

  • Recipe Filter
  • Column settings (for recipe table)

Recipe selection, Equipment modeling and column settings for the recipe list are not available.


Transparency

Manual -> zenon Operator -> zenon for Windows CE -> Transparency

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In Windows CE GIF files can be displayed transparent. In contrast the transparent setting in the extended graphic functions is not available in Windows CE.

To display a transparent GIF in Windows CE:

  • file IMGDECEMP.dll must be available at the target device.
    If the file is missing, you can request it via support@copadata.com.
  • Transparency can be either 0% or 100%. No intermediate values are possible.

info Information

Transparency for PNG files from 0% to 100% in Windows CE in no part of zenon. It can however be used under certain prerequisites.

  • zenon Version 6.22 SP1 or higher is not used
  • Alpha blending must already be implemented by the manufacturer of the target device; COPA-DATA does not provide any support for this


Pocket PC and Windows Mobile Edition

Manual -> zenon Operator -> zenon for Windows CE -> Pocket PC and Windows Mobile Edition

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If you quit zenon with X on a Pocket PC or on a Windows Mobile device, please notice that the application does not quit but keeps on runnning in the background.

In order to avoid an additional start of zenon on your device, we have created the tool Start_CERT.exe which brings the application into the foreground if it is already running or otherwise starts it as usual.

We recommend to start the Runtime on a Pocket PC or Windows Mobile platform by using Start_CERT.exe instead of a direct link.

Note: Pocket PC will not be supported for zenon version 7 and above.


zenon Remote Desktop

Manual -> zenon Remote Desktop

The zenon Remote Desktop allows you to establish a Remote Desktop connection to a remote target system and administrate a remote computer easily. This means that you can establish a visual connection from your PC to another PC or CE device. You will see the desktop as it looks like on the target system.

The zenon Remote Desktop offers two connection types: one for watching only and one for operating the remote system.

tutorial License information

Part of the standard license of the Editor and Runtime.

Differences between zenon Network, zenon Remote Desktop and Windows Remote Desktop

The zenon Remote Desktop is no substitute for a zenon network. It is nothing more than a simple transmission of screen data. This means that all connected computers will show the same screen. With the zenon network you can show different screens on every client.

The advantage of the zenon Remote Desktop over the Windows Remote Desktop is that several computers can connect to the target system at the same time. At the same time, the control system stays fully operable, even if a remote connection is active. When using Windows Remote Desktop, operation is only possible from the remote PC or on the target system at any time.

Activation

In order to avoid security loopholes, zenon Remote Desktop is not activated when installed on the PC. In order to use it you must activate it (see Configuration). In Windows CE, you have to start the Remote Desktop service zenVNCSrvCE.exe manually or via the Windows CE startup mechanisms.

When zenon is uninstalled, the setup program does not uninstall the zenon Remote Desktop. It remains on the PC. See chapter Uninstall for instructions on how to remove it.

attention Attention

The zenon Remote Desktop is shipped with standard passwords. We recommend to change these passwords with the configuration software! See chapter Configuration.


Structure

Manual -> zenon Remote Desktop -> Structure

The zenon Remote Desktop consists of three components:

Parameters

Description

zenon Remote Desktop service

The zenon Remote Desktop service transfers the desktop information via the network to the viewing software. The service does not have a user interface on the PC. It runs in the background as an invisible Windows program. It is not started as a Windows service.
In Windows CE, the service can be seen as a tray icon.

The zenon Remote Desktop service also has an integrated HTTP web server. This web server serves as a connection point for any kind of web browser. You can start a visual Remote Desktop connection directly in your browser.

zenon Remote Desktop configuration

The configuration software allows you to change the behavior of the service.

zenon Remote Desktop monitoring software

The viewing software allows you to view the zenon Remote Desktop from your PC. There are two different types of this software:

  • A standard Windows viewing software that you can start from the Remote Transport in the Editor or via the Windows start menu.
  • Direct connection with a standard web browser without any third-party software. In this case, the Remote Desktop will be displayed directly in the web browser.


Configuration

Manual -> zenon Remote Desktop -> Configuration

The zenon Remote Desktop configuration software allows you to adjust the Remote Desktop connection to your requirements.

Setting

Description

Enable Remote Desktop service

Activates the Remote Desktop service.

If the service is deactivated, it is completely unregistered and no longer available. You can only reactivate it with this configuration software.

Consider that with an active HTTP server you should change the password before the deactivation.

Enable built-in HTTP Server

Activates the built-in HTTP Server. The displayed start page is fixed and cannot be changed.

Attention: If you have deactivated the HTTP Server, you can still reach the login page via a browser refresh.
The page will then be routed from the normal HTTP port (5600) to the Remote Desktop port (5610). This way you can still login and have full access. To avoid access, change the password or block the Remote Desktop port 5610.

Primary password

Enables operating access to the computer.

Password treatment:

  • The standard password after the first installation is SCADA-ALL.
    We recommend to change the standard password to avoid unauthorized access.
  • The length of the password in limited to 8 characters.
    You can howeverenter the standard password SCADA-ALL.
  • The password can be changed at anytime without having to know the current password.
  • If you don not enter a password, a warning message will be displayed as soon as you click outside the field.

View-only password

When establishing a connection, you have to enter this password to get view-only access to the Desktop.

Password treatment:

  • The standard password after the first installation is SCADA.
    We recommend to change the standard password to avoid unauthorized access.
  • The size of the password is limited to 8 characters.
  • The password can be changed at anytime without having to know the current password.
  • If you don not enter a password, a warning message will be displayed as soon as you click outside the field.

Log information to zenVNC.log

The zenon Remote Desktop service writes analysis information to file zenVNC.log. The file is located in user temp folder. C:\Users\Default\AppData\Local\Temp

You can only see these folders if you have activated the option show hidden files and folders in the folder properties of the Windows Explorer.

Log detailed debugging information

The zenon Remote Desktop service writes detailed error and debugging information to file zenVNC.log. This option is only used for extensive error analysis.

Block remote input events

If you do not want full access from the outside, even if the primary password is known, you can set this option. Operating access from remote PCs are blocked. Only view-only access is possible.

Block remote input on local activity

If there is local activity on the computer (with keyboard or mouse), it cannot be operated from a remote PC. Remote operation is enabled again after the configured time.

attention Attention

If you do not change the passwords, everbody will be able to access your PC!!

Empty passwords are possible but not recommended. Empty passwords allow full access to your PC for everybody.

info Information

All changes are applied only after pressing OK. This always leads to a restart of the zenon Remote Desktop service. Connected computers are disconnected.


Establishing a connection

Manual -> zenon Remote Desktop -> Establishing a connection

You can establish a Remote Desktop connection in one of the following ways:

Integrated into Remote Transport:

The zenon Remote Desktop is directly integrated in zenon. You can establish a connection using the Remote Desktop: button Start connection button in the toolbar of Remote Transport. The target system configured in the Remote Transport will be used automatically. If no computer has been entered there, the server configured in the network configuration will be used.

Please consider that TCP/IP must be configured as the transport medium in the Remote Transport.

The connection is established in the same way as if you would use the start menu. However, you do not have to enter the remote computer name.

Via the start menu:

If you want to establish a Remote Desktop connection to another target system, you can use the link " Start - COPA-DATA - ToolsXX - Start zenon Remote Desktop connection" in the start menu.

Parameters | Description
Server | Enter the computer name or the IP address of the target system here.
Connection profile | The connection profiles determine the required network bandwidth. The lower the configured available bandwidth, the higher the screen data compression and the lower the screen quality. This option can only be configured at the beginning of the connection and can not be changed afterwards. If you want to change it, you have to disconnect first.
Options | Opens the Connection Options dialog. You can also change the connection options while the connection is active. You can find a description of the options in the chapter Connection options.

After clicking on Connect, the connection is established.

Via the web browser:

You can also establish a connection via a standard web browser. This requires the Java Runtime on your computer. You can get the current version from the Java website: http://www.java.com.

Start the web browser and enter the computer name or the IP address of the target system in the address line, followed by the port number 5600

Example: http://MyRemotePCName:5600.

info Information

For all connections the following is true: A connection to the local PC is not possible!

If you experience connection problems, please check the requirements.


Authentification

Manual -> zenon Remote Desktop -> Establishing a connection -> Authentification

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Standard viewing software

While the connection is being established, you will see a dialog that allows you to make sure you are connecting to the right target system.

You will only need to enter the connection password in this dialog. A username is not required.

Web interface:

_

You have to enter the connection password in this dialog. In the title bar, you can see the remote desktop that you are connected to.

Passwords

You will need to know the connection passwords to be able to establish a connection. The Primary password gives you full access to the remote desktop. The View-only password only allows the viewing mode. According to the password you enter, one of the two modes will be started. The size of the password is limited to 8 characters. (for details see chapter Configuration)

attention Attention

If the option 'Block remote Input Events' is set in the configuration software of the remote desktop, you will not be able to operate the remote system, even if you use the primary password.

info Information

By default the Primary password is SCADA-ALL and the View-only password is SCADA. You can change the passwords at any time with the configuration software on the remote system (see chapter Configuration).


Standard viewing software

Manual -> zenon Remote Desktop -> Establishing a connection -> Standard viewing software

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

After establishing a connection, the viewing software will show the screen of the remote desktop.

Further settings can be made via the toolbar, the context menu or the drop-down list. Even if the toolbar is not visible, you can use the context menu by right-clicking on the title bar of the viewing software or on the symbol in the taskbar. If you are in full screen mode, you have to deactivate it first by using the keyboard shortcut <Ctrl><Alt><Shift><F>.

The toolbar and the context menu offer the following options:

Parameters

Description

Close

Closes the connection and quits the program.

Connection options...

Opens the dialog for editing the connection options. See chapter Connection options

Connection info

Opens a dialog that shows information about the current connection.

Request screen refresh

Brings about a refresh and redraw of the remote desktop.

Full Screen

switches to full screen mode

  • If the remote computer and the local computer use the same screen resolution, the remote screen will fill the local screen.
  • If the remote computer uses a lower screen resolution, the remote desktop will be centered and surrounded with a black border.
  • If the remote computer uses a higher screen resolution than the local computer, you will only see a part of the remote desktop. You can then scroll with the mouse to move the screen to the area outside of the visible area.

You can use the keyboard shortcut <Alt><Tab> to switch between the remote computer and the local computer.

You can end the full screen mode with the keyboard shortcut Ctrl+Alt+Shift+F.

Show Tool bar

Active: Toolbar is displayed.

Send Ctrl-Alt-Del

This action has no effect.

Send Ctrl-Esc

Opens the start menu of the remote desktop.

Ctrl key down

Presses the Ctrl key of the remote desktop. Click again to release the key.

Alt key down

Presses the Alt key of the remote desktop. Click again to release the key.

New connection...

Opens the dialog for a new Remote Desktop connection. See Establishing a connection. The existing connection will be closed.

Save connection info as...

Saves a link to this connection as an RDC file (Remote Desktop Communication file) You can put this link on your desktop, for example. When saving, you will be asked if you want to store the password in the file.
Note: Storing the password in the file constitutes a security risk.

By double-clicking on the link, you will start the connection software and establish a connection to the configured remote desktop without having to enter a computer name (and password, if you have chosen to store it in the file).

Note: The Transfer files option to transfer data is only available up to version 6.22SP1 build 7.


Connection options

Manual -> zenon Remote Desktop -> Establishing a connection -> Standard viewing software -> Connection options

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can configure the following options on tab Connection:

Parameters | Description
Scale by | Scales the display of the remote desktop to the configured size. This option is useful if the remote desktop has a higher screen resolution than the local computer.
Full-screen mode | Switches to fullscreen mode. You can end the full screen mode with the keyboard shortcut <Ctrl><Alt>Shift<F.
Deiconify on remote Bell event | This setting has no effect.

You can configure the following options on tab Globals:

Parameters | Description
Show toolbars by default | Shows the toolbar. If you have deactivated the toolbar, you can reactivate it via the context menu.
Warn at switching to the full-screen mode | If you change to full screen mode, you will receive a message explaining how you can leave full screen mode.
Number of connections to remember | The viewing software remembers recent connections. When you establish a connection you can choose from a list of recent connections. Here you can configure the number of connections to be remembered.
Clear the list of saved connections | Deletes the list of saved connections.
Dot cursor | The local mouse cursor is displayed as a black dot right above the remote mouse cursor.
Small dot cursor | The local mouse cursor is displayed as a small black dot right above the remote mouse cursor.
Normal arrow | The local mouse cursor is displayed as a standard Windows mouse arrow right above the remote mouse cursor.
No local cursor | Only the remote mouse cursor is displayed.


Web viewing software

Manual -> zenon Remote Desktop -> Establishing a connection -> Web viewing software

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can use the following options in the browser interface:

Parameters | Description
Disconnect | Closes the connection. The web browser remains open.
Options | Here you can configure several connection options. These options are not documented. We recommend to keep the original settings. Changes are not saved. If you make any changes, the original settings will be restored for the next connection attempt.
Clipboard | Allows to read out text saved in the clipboard of the zenon Remote Desktop or to send text to the clipboard. The dialog shows you the clipboard of the zenon Remote Desktop. If you change the text, it will be sent to the clipboard of the zenon Remote Desktop after clicking on Close.
Send Ctrl-Alt-Del | This option is not supported.
Refresh | Refreshes the screen contents.


Limitations

Manual -> zenon Remote Desktop -> Limitations

The zenon Remote Desktop runs in the user context. It is started when the user logs in to Windows.

This means that a remote connection can only be established if a user is logged in. Remote login with Ctrl-Alt-Del is not possible. If the user logs out, the zenon Remote Desktop service will also stop. Any connected viewers will be disconnected.

If the remote computer is locked, you will also not be able to establish a connection. The computer is also locked if a screen saver with the option On resume, password protect is running.

If several users are logged in at the remote computer at the same time (fast user switching), the zenon Remote Desktop service will also be started several times. However, the viewing software will only be able to connect to the service that was started first. If this first user is not active, the connection will be established, but after entering the password, it will be closed immediately.

The connection will also be closed if the user that logged in first clicks on Switch user as he becomes inactive.


Preconditions / troubleshooting

Manual -> zenon Remote Desktop -> Preconditions / troubleshooting

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to establish a connection to a remote system, the following preconditions must be fulfilled:

  • zenon (at least version 6.22 or higher) must be installed.
  • The zenon Remote Desktop service (zenVNCSrv.exe) must be activated at the PC. You can activate the service using the zenon Remote Desktop configuration software (see also Configuration). You can check if the service is running by using the Windows task manager.
  • A user must be logged in at the remote PC and the PC must not be locked. See chapter Limitations.
  • In Windows CE, you must start the zenon Remote Desktop service zenVNCSrvCE.exe, either manually or via the Windows CE startup options. Please look up the documentation of the device to find out how you can activate these startup options. You can check if the service is running by using the Windows CE task manager (if available).
  • The service must be registered in the Windows Firewall and in all other firewalls. The ports 5600 (http port) and 5610 (zenon Remote Desktop port) must be registered. You can check if these ports are registered and activated by establishing a Telnet connection from another PC to port 5600 and 5610. For that, start the command prompt (cmd.exe) and enter the following command:
    telnet RemotePCName 5610.
    If the connection is successful, a black window appears.
    In Windows, Telnet is not installed by default. You can install the program by performing the following steps:
    Click on Start > Control Panel > Programs and then on 'Turn Windows features on and off'.
    Activate the check box 'Telnet client' in the Windows features list and click on 'OK'.
  • The ports 5600 and 5610 should not be used by other programs. If they are used by other programs, the system will randomly select other ports. You can check the port assignment with the Windows command netstat -n -a -o in the command prompt. You can find out the process ID of the zenon Remote Desktop service zenVNCSrv.exe in the "Processes" tab of the task manager. If the ID is not visible, you can activate the column "PID (Process ID)" in the menu "View - Select columns...".
  • If you establish the connection via the Editor, make sure that TCP/IP is set as the transport medium in the Remote Transport. You also have to enter a computer as the target system, either for Remote Transport or as project server.
  • Windows fast user switching is not supported. It leads to disconnection. See chapter Limitations

info Information

Deactivated HTTP server:

If you have deactivated the HTTP Server, you can still reach the login page via a browser refresh.
The page will then be routed from the normal HTTP port (5600) to the zenon Remote Desktop port (5610). This way you can still login and have full access. To avoid access, change the password or block the Remote Desktop port 5610.


Uninstallation

Manual -> zenon Remote Desktop -> Uninstallation

The zenon Remote Desktop is not uninstalled with zenon because it is used across versions. The setup program cannot check which zenon versions are used.

In order to remove the zenon Remote Desktop, you must perform the following steps:

  1. Start the configuration software.
  2. Remove the tick next to Enable Remote Desktop service.
  3. Click on OK.
  4. The zenon Remote Desktop service is ended and deregistered.

Now you can delete the files zenVNCSrv.exe, zenVNCcfg.exe and oem.dll in folder C:\Program Files\Common Files\COPA-DATA\zenVNCSrv.


zenon Science Package for LEGO MINDSTORMS

Manual -> zenon Science Package for LEGO MINDSTORMS

The zenon Science Package for LEGO MINDSTORMS enables the programming of LEGO Mindstorms NXT and MINDSTORMS EV3 Brick. Programs are created in zenon Logic and executed on the LEGO Controller with straton. zenon Logic is the programming environment in accordance with IEC 61131-3 included in zenon.

tutorial License information

The zenon Science Package for LEGO MINDSTORMS contains a limited license (for details, see the zenon Science Package license chapter). This is installed if you do not have a licensed zenon installation on the computer.

This instruction takes you through the installation and programming for the automation of a LEGO Mindstorms NXT 2.0 or MINDSTORMS EV3 Brick with zenon. Only information with regard to the operation with zenon Logic/straton is contained in this documentation. Please find basic information on the programming and operation of LEGO MINDSTORMS objects in the LEGO documentation.

All necessary software is included on the installation medium for zenon Science Package for LEGO MINDSTORMS. This package does not contain any LEGO hardware, components or controls.

For the configuration of LEGO hardware with zenon use the following software:

  • zenon: Software for monitoring and controlling which contains the integrated zenon Logic.
  • zenon Logic Workbench: Programming environment for programs running on the embedded straton firmware.
  • straton: Firmware for the LEGO Controller.

Please find all required applications and information on the installation media. These should already have been created in your zenon folder on the computer. The most important folders are:

  • FIRMWARE: This folder contains the firmware you can load onto your LEGO MINDSTORMS Controller with the LEGO Firmware Loader.
  • USB_DRIVER: This folder contains the INF file for the USB-to-serial driver.

info Information

LEGO, MINDSTORMS, NXT and EV3 are trademarks and products of the company LEGO.


zenon Science Package for Lego MINDSTORMS 2.0

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon Science Package for LEGO MINDSTORMS 2.0 enables the programming of LEGO Mindstorms NXT 2.0 objects. Programs are created in zenon Logic and executed on the LEGO Controller with straton. zenon Logic is the programming environment in accordance with IEC 61131-3 included in zenon.


Installation

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Installation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For using the zenon Science Package for LEGO the following is required:

  • zenon from version 7.00 SP0 on
  • Firmware for the LEGO Controller

If you have already installed zenon 7.00 or higher on your computer you will also have a license for using the zenon Science Package for LEGO. If you haven't installed zenon yet install the zenon version from the installation medium. This is a limited License for using LEGO MINDSTORMS 2.0.


Install zenon

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Installation -> Install zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to install zenonin the current version:

  1. Connect the installation medium to the computer
  2. If the installation does not start automatically, select start.exe
  3. select zenon 7.20
  4. follow the instructions of the installation wizard

Note: If you already have a zenon version from 7.00 on no installation is required.


zenon Science Package License

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Installation -> Install zenon -> zenon Science Package License

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon Science Package for LEGO MINDSTORMS 2.0 is contained in the zenon standard license. If this version is installed on a system without zenon it will run with a zenon Science Package License. With this license it is also possible to create and edit zenon projects within the scope of the licensed modules.

This license contains:

  • 128 variables
  • Extended Trend Starter Edition
  • Historian Starter Edition
  • VBA
  • zenon Logic Workbench
  • straton firmware

Note: This license is executable for 90 minutes. The Editor must then be closed and re-started.


Demo projects

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Installation -> Demo projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can also get two demo projects in the COPA-DATA Forum (www.copadata.com/forums):

  • MINDSTORMS_DEMO: Gives an overview over sensors and controller. Use this project to become familiar with LEGO MINDSTORMS 2.0 and its programming.
  • LEGO_DEMO_SHOOTERBOT: A sample project for the Shooterbot. This can be adjusted to your needs.

Load the working area with both projects into zenon:

  1. right-click on the current workspace
  2. in the context menu working space select -> read backup...
  3. Go to the working area backup on the installation medium (*.wsb)
  4. select the file and click on OK

To open projects:

  1. in the working space go to node zenon Logic (IEC 61131-3)
  2. select the node by left-clicking on it
  3. select the project mindstorms
  4. click on the symbol open in the toolbar or double-click on the project in order to open the project in the zenon Logic Workbench


Install firmware

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Installation -> Install firmware

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to be able to use your LEGO MINDSTORMS 2.0 with zenon you have to load straton firmware on the Controller. This chapter will show you how to:

  • load straton firmware on the Controller
  • update already existing straton firmware or replace other already existing firmware
  • create a USB connection with the Controller with the COPA-DATA USB driver
  • establish a Bluetooth connection with the Controller

load straton firmware on the Controller

In order to load straton firmware on the LEGO MINDSTORMS NXT 2.0 Controller the LEGO MINDSTORMS NXT 2.0 software is required, which was delivered with your LEGO MINDSTORMS NXT 2.0.

attention Attention

If on the Controller there already is a different firmware than the one delivered by LEGO please proceed as described in section Dealing with already existing firmware.

In order to load the firmware:

  1. Start the LEGO MINDSTORMS NXT 2.0 software.
  2. In menu Tools -> select Update NXT Firmware

  3. Ensure that the correct format is used: *.rfw.
    If the file suffix is still *.bin, change this to *.rfw.
    In zenon 7.20, the file is called: STRATON_NXT_103_2011_08_10.rfw.
    You can find this on the installation medium in the path: AdditionalSoftware\Science Package - Firmware\NXT2.
  4. Click on the Browse button.
  5. Select the folder containing the firmware.

  6. Start the NXT Controller.
    To do so, press the orange button.
  7. Connect the Controller via USB with the computer.
  8. Click on the button Download to load the firmware on the Controller.

  9. Remove the USB cable.
  10. The Controller starts with the updated firmware

info Information

In order to update the loaded straton later on or replace it again with firmware by LEGO follow the instructions in section Dealing with already existing firmware.


Dealing with already existing firmware

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Installation -> Dealing with already existing firmware

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If firmware not provided by LEGO is already present on the Controller this has to be set to the Firmware load mode in order to be able to install other firmware. This mode is also required if the straton firmware is supposed to be updated or LEGO firmware loaded again. In order to set the Controller to Firmware load mode:

  1. Press for at least 5 seconds until you hear a quiet clicking noise
    • both the orange start button and
    • the Rest button on the back of the device.
      You can best reach the Rest button with a pointed object.

  2. Switch on the NXT Controller by pressing the orange button.

  3. The NXT Controller starts in the Firmware load mode . You can hear a regular sound.
  4. Start the download of the desired firmware.
    To do so, a connection via USB or Bluetooth must be established. For the USB connection with zenon/straton the COPA-DATA driver is required.

attention Attention

The Firmware load mode can only be closed by downloading a firmware.


USB connection without LEGO firmware

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Installation -> Dealing with already existing firmware -> USB connection without LEGO firmware

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If the firmware applied is not provided by LEGO probably the corresponding driver must be installed. In this case the USB Controller is not recognized during the connection with the computer. To establish a USB connection:

  1. Open the System control -> System -> Device manager.
  2. Double-click on Unknown device.
  3. In the tab Driver click on Update driver.
  4. The dialog for selecting the driver is opened.
  5. Select Search the computer for driver software.
  6. Select the folder containing the Mindstorm_straton.inf .
  7. A warning regarding the driver manufacturer is displayed.
  8. Select Install driver nevertheless.
  9. The device can now communicate via USB.


Establish a Bluetooth connection with the Controller

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Installation -> Establish a Bluetooth connection with the Controller

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If the computer is provided with a Bluetooth port the connection with the Controller can also be established via Bluetooth. In order to configure Bluetooth for the connection between computer and Controller:

  1. Switch on the LEGO Controller by pressing the orange button.

  2. Press the orange button again.
  3. Select Settings with the right gray arrow button.

  4. Confirm selection by pressing the orange button.
  5. Go to the menu for Bluetooth settings by using the gray buttons .
    1. Activate Bluetooth.
    2. Assign a Bluetooth name.
    3. Set the Bluetooth status to visible.
    4. Leave the Bluetooth menu by clicking on the dark gray button.
  6. Change to menu Connections.
  7. Select Bluetooth using the gray buttons.
  8. Now the Controller can be found via Bluetooth.
  9. Open the Bluetooth device manager on the computer.
    1. Select Add device.
    2. Windows will search for visible Bluetooth devices.
    3. Select your MINDSTORMS NXT Controller from the list and click on Next.
    4. The MINDSTORM Controller requires to enter a password for establishing the connection:
      1234_ is suggested. Confirm the password by pressing the orange button.
    5. The password defined in the MINDSTORMS 2.0 Controller must also be entered on the computer.
    6. Click on Next.
  10. The connection is being established and the drivers are being installed.
  11. Double-click on the created Bluetooth device.
    The installed device and the assigned COM port are displayed. Connect the zenon Logic Workbench with this COM port or connect zenon with the stratonNG driver.In order to adjust the port:
    1. Click on properties.
    2. Click on the Advanced button.
    3. Change the port number according to your specifications.


Create a connection between zenon Logic and straton

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Create a connection between zenon Logic and straton

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to create a connection between zenon Logic and straton:

  1. Start zenon. The project MINDSTORMS is opened.
    If you would like to open a different project or working area open the working area for the project via the context menu for the working area.
    If you would like to create a new project:
    1. select the file -> Project new
    2. create a new zenon Logic project by first right-clicking on the node zenon Logic and then selecting in the project tree zenon Logic Project new...
  2. Open the zenon Logic project by double-clicking in the Workbench.
  3. In the zenon Logic Workbench click on Tools -> communication parameter.

  4. The dialog Options with the tab Debug is opened in order to configure the connection.
  5. Click on the button ... in order to open the dialog for the settings of the serial communication.

  6. Configure the serial setting corresponding to the settings for the LEGO Controller.
    Note: In this dialog only COM ports 1 to 4 can be selected. However, in the dialog Options tab Debug you can enter the COM port directly in to the field communication parameter.

  7. You will thus have configured the connection between zenon Logic and straton.


Add NXT driver in zenon Logic

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Create a connection between zenon Logic and straton -> Add NXT driver in zenon Logic

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to add the NXT driver in zenon Logic:

  1. In the project tree in the zenon Logic Workbench double-click on Fieldbus configuration.
  2. In the window I/O driver click on the symbol or the command in the context menu for Add configuration.

  3. The dialog for configuration is opened.

  4. Select LEGO Mindstorms NXT 2.0.
  5. There are three sections:
    • NXT (Status)
    • Drives
    • Sensors

    Clicking on the plus (+) before the section opens a subarea. For each of these sections predefined variables can easily be created.

Create variables

Create the required variables:

  1. Right-click on the branch NXT, Drives or Sensors.

  2. Select Create variable in the context menu.

Drives

There are two versions: easy and advanced. As a start it is best to select easy and then Create variable. Please find more information on the use of Advanced Variables in section Use of complex variables.

Sensors

Before creating a variable in section Sensors a sensor type in field Type must be selected. To do so, double-click on the field Value.

Configuration example:


Connect NXT Controller

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Create a connection between zenon Logic and straton -> Connect NXT Controller

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to connect the NXT Controller:

  1. On the Controller select USB as connection medium:
    1. Press the orange button.
    2. Use the gray buttons to go to the menu Settings and open it by pressing the orange button.
    3. Select Connection.
    4. Select USB.
      (If you would like to connect via Bluetooth select Bluetooth.)
  2. Compile the zenon Logic project:
    1. Right-click on mindstorms in the project tree.
    2. Select Compile project in the context menu.
  3. Go online:
    1. Select the entry Online in the zenon Logic menu Project.
    2. The request for download is opened:

    3. Click on Yes.
  4. The project is online and you can watch how the sensors read values.


Controller basic settings

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Create a connection between zenon Logic and straton -> Controller basic settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Basic configuration

  1. Configure the communication settings (details see following section: Settings).
  2. Activate or deactivate Bluetooth (details see following section: Connection).
  3. In case of active Bluetooth: Assign a unique name for the Bluetooth communication.

Operation

Switch on

In order to switch on the Controller press the orange button.

Menu navigation

  • Open menu: Press the orange button.
  • Close menu: Press the dark gray button.
  • Navigate in the menu: Press the left or right gray arrow button. Select a menu entry with the orange button. In order to leave a submenu without saving press the dark gray button.

Switch off

  1. Select Turn off in the main menu and press the orange button.
  2. Select an option:
    1. Save: Saves all settings on the flash memory and closes the Controller. The currently loaded straton application, retain data and the configuration (Connection, Volume) are saved on the flash memory.
    2. Don't save: The application is saved without saving data or configuration on the flash memory.
    3. Cancel: Saving is cancelled and the main menu opened.

During the next start the data saved last (straton application, retain data etc.) are loaded.

straton Menu

With the straton menu you can start or stop the loaded straton application. In order to open the menu select the entry straton in the main menu.

Statistics

Statistics displays information on the currently running application. In order to display the corresponding data select the entry Statistics in the main menu. The following is being displayed:

  • the name of the loaded application
  • code size in kB
  • database size in kB
  • the execution time of the straton cycle
  • the cycle latency in microseconds

Menu Settings

In this menu the following is configured and displayed:

  • Versions: Information on the version used.
  • Bluetooth: Bluetooth activation or deactivation. Name and contacts can be managed.
    • Name: Enter a name for the Bluetooth device. The name should be unique in the Bluetooth network.
    • On/Off: Activates/deactivates Bluetooth at the Controller.
    • Visibility: Determines if the device is visible for other Bluetooth devices.
    • Search: Starts search for Bluetooth devices. In order to add a device to the Bluetooth contacts select it from the list of devices found.
    • Contacts: Manage contacts. You can remove contacts (devices which may be connected) or establish connections (e.g. for pairing).

Connection

Select the connection to be used by the straton communication server. Connection for the communication with the zenon Logic Workbench. The communication server also includes a MODBUS slave. The zenon driver for straton must also be connected with the communication server. Possible options are:

  • USB
  • Bluetooth: incoming Bluetooth connection
  • RS-485: RS-485 port with the parameters 115200, E, 8, 1
    Attention: Using RS-485 deactivates the sensor port 4. Please also bear in mind that the straton communication server protocol can only be used point-to-point.
  • None: The communication server is not used.

Volume

Defines the volume of the built-in speakers. Valid values are 0 to 4, with:

  • 0: switched off
  • 4: Maximum


Develop straton applications for NXT

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The following restrictions apply for straton applications on LEGO MINDSTORMS 2.0:

straton Runtime:

  • Maximum size of code: 26 kB
  • Maximum size of straton database: 20 kB

Note: Size of code and database can be checked in the menu Statistics.

zenon Logic Workbench

  • Only COM ports 1 - 9 can be used. If a USB device or a Bluetooth COM port was assigned a higher port number than 9 this has to be manually configured to a port number lower than 10.
  • In the Workbench only ports COM1 – COM4 can be selected. However, port numbers can be entered directly into the parameter string, e.g. COM9:19200,N,8,1. (See also section Establish connection between zenon Logic and straton.)
    Note: In case of a USB or Bluetooth connection it is sufficient to enter the port, e.g. COM5

info Information

Please find general information on the programming of LEGO MINDSTORMS NXT 2.0 in the LEGO documentation.


Use NXT communication ports

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Use NXT communication ports

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

NXT objects contain three communication ports which can be addressed by the straton application.

With the menu Settings one of these connections is selected for the communication server. This connection can subsequently not be used out of the straton application (e.g. by a MODBUS Master or a function block). However, if a MODBUS Slave configuration was added a MODBUS Slave can use the configured port.

Please find further information on the use of the serial port in the straton program and on the MODBUS I/O driver in the zenon Logic documentation. To do so, in the Workbench press the key F1 or use the menu Help.

All ports which are not being used by the communication server can be used by the straton application and are addressed as follows:


USB

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Use NXT communication ports -> USB

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The NXT component can be connected with a computer via the USB port. NXT is recognized as serial connection by the computer.

The USB port can be addressed by the straton application by selecting USB as COM port.


Bluetooth

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Use NXT communication ports -> Bluetooth

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The Bluetooth port can be used in two different ways:

  1. For incoming connections:
    in this case the connection is established from a remote device, e.g. a computer. In this case the string BT is sufficient in order to use the Bluetooth port.
  2. For outgoing connections:
    NXT is configured in order to establish a connection with another Bluetooth device, for instance another NXT object. In this case use a string beginning with BT and ending with the name of the device, for instance: BT:NXT.
    Note: The device to be addressed must already be contained in the Bluetooth contacts. In order to manually add a device to the contacts start the Search and manually establish the connection once. For the first contact a pairing is probably required.


RS-485 Port (serial)

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Use NXT communication ports -> RS-485 Port (serial)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

NXT objects also contain a serial RS-485 port. It is however shared with sensor 4. Thus only the port or the sensor can be used.

The RS-485 port is addressed via character string HS. With this the port is opened with the help of the following parameter per default:

  • Baud rate: 115200 bit/s
  • Parity: even
  • Data bits: 8
  • Stop bit: 1

Adapt parameter

If you want to adapt the communication parameters, add them after the colon separated by commas. The order:

  • Baud rate in bits/s
  • Parity: N (none), E (even), O (odd), M (mark) and S (space)
  • Data bits
  • Stop bit

For example: HS:19200,N,8,1

Note: If you use the RS-485 port with MODBUS or the straton protocol, always set Data bits to 8.


Fieldbus

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Use NXT communication ports -> Fieldbus

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With straton NXT it is also possible to use the MODBUS Slave and MODBUS Master configuration. Please find information on MODBUS in the zenon Logic documentation. To do so, in the Workbench press the key F1 or use the menu Help. The use of NXT sensor and motor ports are configured in the LEGO MINDSTORMS NXT 2.0 configuration.


Status variables

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Use NXT communication ports -> Fieldbus -> Status variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Status variables

The following status variables are available:

  • STATUS_BATTERYVOLTAGE: current battery charge in millivolt.
  • STATUS_BATTERYSTATE: Battery capacity.
    Value: 0 to 4 (as displayed on the NXT display)
  • STATUS_BLUETOOTHSTATE: Bluetooth status
    Values:
    • 0: on
    • 1: visible
    • 2: connected
    • 3: connected and visible
    • 4: off
  • STATUS_USBSTATE: USB status
    Values:
    • 0: disconnected
    • 1: connected
    • 2: operating
  • STATUS_RECHARGEABLE: Status for rechargebale batteries
    Values:
    • 0: No rechargeable batteries existing
    • 1: rechargeable batteries existing
  • STATUS_ERROR: Error code


Drive Variables

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Use NXT communication ports -> Fieldbus -> Drive Variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Drive Variables

The following variables are available for the drive:

  • PORT_x_AUTOSPEED (SINT, Output): Defines the motor speed.
    Values: from -100 to 100
    • 0: Motor off
    • -100: Maximum speed backward
    • 100: Maximum speed forward
  • PORT_x_TACHOCOUNT (DINT, Input): Contains absolute number of motor revolutions in angular degrees. 360° are one complete revolution per second. Valid values: from -2,147,483,648 to 2,147,483,647.

Complex variables

More complex drive operations are configured with more complex variables. Select them in the entry Create advanced variables in the context menu.

attention Attention

Do not use the AUTOSPEED variable and the Advanced Variables at the same time. Using them at the same time may result in an undefined behaviour of the drive.

Please find a description on how to configure these variables in section Using complex variables.


Color sensor variables

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Use NXT communication ports -> Fieldbus -> Color sensor variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Color sensor variables

The following variables are available for the color recognition:

  • PORT_x_COLOR (INT, Output): Defines the sensor mode.
    • 0: Passive mode (measure brightness)
    • 1: Red is being measured.
    • 2: Green is being measured.
    • 3: Blue is being measured.
    • 4: All colors are being measured
  • PORT_x_VALUE (INT, Input)

    If the mode is passive, red, green or blue:

    • A value between 0 and 255 defines the color intensity.

    If the mode is all colors:

    • 1: black
    • 2: blue
    • 3: green
    • 4: yellow
    • 5: red
    • 6: white
  • PORT_x_RED: In the mode all colors the intensity of the color red is measured.
  • PORT_x_GREEN: In the mode all colors the intensity of the color green is measured.
  • PORT_x_BLUE: In the mode all colors the intensity of the color blue is measured.
  • PORT_x_GRAY: Brightness is measured


Touch Sensor Multiplexer (HT)

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Use NXT communication ports -> Fieldbus -> Touch Sensor Multiplexer (HT)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Touch Sensor Multiplexer (HT)

The following variables are available for the touch sensors:

When using the HiTechnic Touch Sensor Multiplexer up to four sensors can be connected with a NXT port:

  • PORT_x_SWITCH1: Status of sensor 1
  • PORT_x_SWITCH2: Status of sensor 2
  • PORT_x_SWITCH3: Status of sensor 3
  • PORT_x_SWITCH4: Status of sensor 4


Gyroscopic sensor (HT)

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Use NXT communication ports -> Fieldbus -> Gyroscopic sensor (HT)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Gyroscopic sensor (HT)

The LEGO MINDSTORMS 2.0 NXT Gyro Sensor gives information on the number of motor revolutions and the direction of the revolutions. The revolutions are measured in angular degrees. 360° are one complete revolution per second.

After the start of the straton application the sensor is automatically calibrated during connection. To do so, the current zero value is calculated. This takes about 200 ms. During this period of time the sensor must not be moved.

  • PORT_x_VALUE: Number of angular grades per rotation second
  • PORT_x_INVALID: Set to TRUE when:
    • the sensor is being calibrated
    • the value cannot be read


Digital Acceleration Sensor (HT)

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Use NXT communication ports -> Fieldbus -> Digital Acceleration Sensor (HT)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Digital Acceleration Sensor (HT)

The LEGO MINDSTORMS 2.0 NXT acceleration sensor includes a 3-axis accelerometer measuring acceleration in the three axes x, y and z. The acceleration is displayed within the scope of -2g to +2g with approximately 200 steps per g.

The acceleration sensor can also be used to measure the gradient in three axes. This is possible because gravitation is perceived as acceleration. If the sensor is motionless in the normal horizontal position the x-axis and y-axis, being horizontal, will be close to zero, while the z-axis' value will be close to 200, corresponding to 1g. If the sensor is then inclined the other axes will also perceive gravity and the z-axis' value will decrease. Since gravity is divided among the three part vectors the gradient of the sensor can be determined.

  • PORT_x_VALUE_X: Acceleration in direction of the x-axis
  • PORT_x_VALUE_Y: Acceleration in direction of the y-axis
  • PORT_x_VALUE_Z: Acceleration in direction of the z-axis
  • PORT_x_INVALID: Set to TRUE if the data of the sensor cannot be read.


Digital Compass Sensor (HT)

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Use NXT communication ports -> Fieldbus -> Digital Compass Sensor (HT)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Digital Compass Sensor (HT)

The LEGO MINDSTORMS 2.0 NXT Compass Sensor contains a magnetic digital compass to measure the earth's magnetic field and calculate a heading angle. The Compass Sensor can be connected to a NXT port with a NXT standard cable and uses the digital I2C communication protocol. The current heading is calculated to the next integral angular degree.

The HiTechnic Compass Sensor is influenced by local magnetic interferences, as is any other magnetic compass, too. Metal objects such as motors, batteries or cables may cause magnetic interferences. Local magnetic interferences may cause the compass to produce a heading deviating several degrees from the current magnetic heading. This effect is called compass deviation. In order to correct this deviation the HiTechnic Compass Sensor has a built-in calibration function correcting deviations and saving these values in the compass.

The calibration is optional and usually not required during normal operation. In order to minimize the need to calibrate install the compass in a distance of at least 10 to 15 cm (4 - 6 inches) to NXT and the NXT motors.

In order to calibrate the compass in the program:

  • Select calibration mode.
  • Program your NXT object so that it rotates within a very narrow circle.
  • It must rotate between 1½ and 2 times (more than 360 degrees).
  • It must complete a full turn in approximately 20 seconds.

The compass will maintain the calibration settings until another calibration is made, even though it is being unplugged.

  • PORT_x_VALUE: Current heading in degrees.

    0: North

  • PORT_x_INVALID: Set to TRUE if the data of the sensor cannot be read.
  • PORT_x_CAL: (Display) Controls the calibration mode.
    • TRUE change to calibration mode
    • FALSE: change to measuring mode.

    Note: In the calibration mode the sensor provides invalid data.


Other sensors

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Use NXT communication ports -> Fieldbus -> Other sensors

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Other sensors

The following additional variables for sensors are available:

  • PORT_x_VALUE: sensor value, depends on sensor
    • Sound dB
    • Sound dBA
    • Ultrasonic: distance in centimeters (cm)
    • Temperature: temperature in Celsius centigrade (°C/10)
  • PORT_x_INVALID:
    • TRUE: sensor is in error status


Functions

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Functions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to select functions these must be located in the corresponding folder. Copy the Mindstorms NXT folder from the HWDEF folder on the installation medium into the HWDEF folder of your straton installation.
For example: %ProgramData%\COPA-DATA\zenon7.20711\straton\HWDEF\Mindstorms NXT

The following functions are available:

  • BUTTONENABLE: straton takes over control of NXT buttons.
  • BUTTONGET: Transmits information on which button was pressed.
  • DISPLAYERASE: Erases screen content.
  • DISPLAYLINE: Draws a line.
  • DISPLAYPIXEL: Draws a pixel.
  • DISPLAYSTRING: Writes a string.
  • SOUNDFREQUENCY: Sound output.


BUTTONENABLE

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Functions -> BUTTONENABLE

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

BOOL BUTTONENABLE (BOOL ENABLE)

During the activation with ENABLE and status TRUE the control is being passed on to straton using the buttons on the NXT object. The button status can be read with BUTTONGET.

Note:

  • The menu System on the NXT object is deactivated in this case.
  • Activating this function is only possible if the menu on the NXT object is inactive.
  • This status can be interrupted, for instance by a Bluetooth pairing dialog. In this case BUTTONGET returns the value -1.

Response value:

  • TRUE: Activity successfully completed.


BUTTONGET

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Functions -> BUTTONGET

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

SINT BUTTONGET

Return values:

  • -1: buttons cannot be read by straton. The menu System on the NXT object is activated.
  • 0: no button pressed.
  • 1: left button pressed.
  • 2: button Entry (orange button) pressed.
  • 3: right button pressed.
  • 4: button Leave (dark gray button) pressed.


DISPLAYERASE

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Functions -> DISPLAYERASE

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

BOOL DISPLAYERASE

Erases the screen contents.

Response value:

  • TRUE: Activity successfully completed.


DISPLAYLINE

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Functions -> DISPLAYLINE

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

BOOL DISPLAYLINE (USINT X1,USINT Y1,USINT X2, USINT Y2, BOOL C)

Draws a line from point X1,Y1 to point X2,Y2.

Values for C:

  • TRUE: draws a line
  • FALSE: erases the line

Response value:

  • TRUE: Activity successfully completed.


DISPLAYPIXEL

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Functions -> DISPLAYPIXEL

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

BOOL DISPLAYPIXEL (USINT X, USINT Y, BOOL C)

Draws a point with the coordinates X,Y.

Values for C:

  • TRUE: draws a point
  • FALSE: erases the point

Response value:

  • TRUE: Activity successfully completed.


DISPLAYSTRING

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Functions -> DISPLAYSTRING

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

BOOL DISPLAYSTRING(USINT X, USINT Y, STRING TEXT)

Writes a string beginning with the indicated XY position.

Response value:

  • TRUE: Activity successfully completed.


SOUNDFREQUENCY

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Develop straton applications for NXT -> Functions -> SOUNDFREQUENCY

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

BOOL SOUNDFREQUENCY(UDINT FREQ, UDINT DUR, USINT VOL)

Plays a tone with the indicated frequency in Hz during the defined length in milliseconds. The volume (VOL) is indicated in a range of 1 to 4. It is limited by the configured maximum volume in the menu Volume.

Response value:

  • TRUE: Activity successfully completed.


Connect MINDSTORMS 2.0 Runtime with zenon

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Connect MINDSTORMS 2.0 Runtime with zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For creating a new zenon Logic project in zenon it is recommended to use the stratonNG driver. This supports serial communication.

When creating a new zenon Logic project in the dialog define the name of the project and the driver used.

Select STRATONNG from the drop-down menu.

Note: The selection of the driver cannot subsequently be changed again.

Configuration of stratonNG driver

To configure the driver:

  1. in the zenon project tree select the node Variables -> Driver
  2. highlight the stratonNG driver
    Note: this is displayed with the name defined for the project, e.g. straton: mindstorms
  3. select Driver configuration in the context menu
  4. the dialog for the driver configuration is opened
  5. open the tab Connections

To edit the driver:

  1. highlight the connection name
  2. Click on Edit.
  3. configure the link
  4. click on Save and then OK

Configuration of the driver for the connection within the scope of LEGO MINDSTORMS 2.0:

Option

Description

Connection name

Must correspond to the project name.

If the name is different from that of the project this will result in errors during the connection with the Controller.

Addressing

In the communication with straton NXT via USB or Bluetooth it is sufficient to set the port without further settings, e.g. COM5:

Primary IP address

Entering COM port.

Entries beginning with COM and ending with a colon are interpreted as COM ports.

Attention: The colon (:) must be present at the end of the port definition. Otherwise it is not possible to establish a connection.

If no further parameters are indicated the standard configuration of the COM port is used:

  • Baud rate: 115200 bit/s
  • Parity: even
  • Data bits: 8
  • Stop bit: 1

If you want to adapt the communication parameters, add them after the colon separated by commas. The order:

  • Baud rate in bits/s
  • Parity: N (none), E (even), O (odd), M (mark) and S (space)
  • Data bits
  • Stop bit

For example: COM5:19200,N,8,1

Limitations: If a COM port is indicated it is not possible to use:

  • Event connection
  • Multiple connections (more than one connection with a driver)

The documentation of these settings refers to the communication in the scope of LEGO MINDSTORMS 2.0. Please find details on the general configuration of the stratonNG driver in the online help (F1) in chapter stratonNG.


Questions and answers

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Questions and answers

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The most common questions regarding installation and operation of LEGO MINDSTORM with straton and the zenon Science Package.

Question | Answer
Why is an error message displayed during installation? | Probably there is already a zenon installation present in the system. Use the existing installation. Details: Error message during the installation of the zenon Science Package.
How do I change back to the original LEGO firmware? | Changing back corresponds to the proceeding during the installation of the straton firmware if other firmware already exists. Details: Activate original LEGO firmware.
How can I proceed if the LEGO Firmware Loader does not find the Controller? | Change the USB port or re-install its driver. Details: LEGO Firmware Loader does not find the Controller.
How do I proceed if the zenon Logic Workbench driver does not communicate with my Controller? | This may have several causes. Check the settings and if all devices are online. Details: zenon Logic Workbench driver does not communicate with the Controller
How do I proceed if the stratonNG driver does not communicate with my Controller? | This may have several causes. Check the communication parameters, the Runtime and the project. Details: stratonNG driver does not communicate with the Controller.

Further questions and answers can also be found in the COPA-DATA user forum: www.copadata.com/forums/.


Error message during the installation of the zenon Science Package

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Questions and answers -> Error message during the installation of the zenon Science Package

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

An error message is displayed during the installation of the zenonScience Package which refers to an already existing installation.

This zenon version has already been installed on your system. You don't have to install zenon and can use the existing version. Import the demo projects from the installation medium and continue with Install firmware.


Activate original LEGO firmware

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Questions and answers -> Activate original LEGO firmware

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If firmware not provided by LEGO is already present on the Controller this has to be set to the Firmware load mode in order to be able to install other firmware. This mode is also required if the straton firmware is supposed to be updated or LEGO firmware loaded again. In order to set the Controller to Firmware load mode:

  1. Press for at least 5 seconds until you hear a quiet clicking noise
    • both the orange start button and
    • the Rest button on the back of the device.
      You can best reach the Rest button with a pointed object.

  2. Switch on the NXT Controller by pressing the orange button.

  3. The NXT Controller starts in the Firmware load mode . You can hear a regular sound.
  4. Start the download of the desired firmware.
    To do so, a connection via USB or Bluetooth must be established. For the USB connection with zenon/straton the COPA-DATA driver is required.

attention Attention

The Firmware load mode can only be closed by downloading a firmware.

Download of the LEGO firmware:

  1. Connect the Controller via USB with the computer.
  2. Start the LEGO MINDSTORMS NXT 2.0 software.
  3. In menu Tools select the entry Update NXT Firmware.
  4. The original LEGO MINDSTOMS NXT firmware is preselected.
  5. Click on the button Download.
  6. The Controller restarts with the original LEGO firmware.


LEGO Firmware Loader does not find the Controller

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Questions and answers -> LEGO Firmware Loader does not find the Controller

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If the LEGO Firmware Loader does not find the Controller connect the USB cable with a different USB port By doing so the USB driver is installed for the Firmware Loader mode.

If this does not solve the problem deinstall the driver. To do this:

  1. Open the device manager in the system control while the Controller is connected.
  2. Select the LEGO MINDSTORMS NXT Firmware Update Mode driver.
  3. Right-click on it.

  4. Select Deinstall in the context menu.
  5. Remove the USB cable from the LEGO MINDSTORMS 2.0 Controller and reconnect it.
  6. The driver is automatically reinstalled.


zenon Logic Workbench driver does not communicate with the Controller

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Questions and answers -> zenon Logic Workbench driver does not communicate with the Controller

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The communication with the Controller is a point-to-point communication via a virtual serial port. It is only possible to connect one application at a time.

If the communication fails there might be several reasons. The most frequent include:

  1. The stratonNG driver and zenon are still online.
  2. The COM port settings are incorrect. Select the correct COM port settings in the menu Communication parameters.
  3. The connection settings for the Controller are not set to the correct medium (USB or Bluetooth). Select the currently used connection.


stratonNG driver does not communicate with the Controller

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Questions and answers -> stratonNG driver does not communicate with the Controller

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The communication with the Controller is a point-to-point communication via a virtual serial port. It is only possible to connect one application at a time.

If the communication fails there might be several reasons. The most frequent include:

  1. The zenon Logic Workbench is still online.
  2. The COM port settings are incorrect.
  3. The straton Runtime has not been started on the LEGO MINDSTORMS 2.0 Controller.
    In order to start the Runtime:
    1. Press the orange button.
    2. As soon as you see the entry straton press the orange button again.
    3. Select Start and press the orange button.

    You can tell that the Runtime is running when the square symbol next to the battery status is rotating.

  4. The straton project was not downloaded to the Controller.
    If a project was downloaded please check if it is the correct project.
  5. The symbol names of the variable have not been activated.
  6. The connection name of the stratonNG driver is not identical with the name of the zenon Logic project.
  7. The connection settings for the Controller are not set to the correct medium (USB or Bluetooth). Select the currently used connection.


Use of complex variables

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for Lego MINDSTORMS 2.0 -> Use of complex variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This section explains how to control a motor with complex variables.

info Information

The use of complex variables is only recommended for experienced users!

With an additional programming you can make the NXT motors move by a predefined angle. This is required in order to engineer very precise movements. For engineering:

  1. Create all variables by right-clicking on the port and selecting Create advanced variables in the context menu.

  2. You receive 15 variables.

The variables relevant for you are:

  • PORT_n_FLAGS
    • Bit mask from which variables should be written.
  • PORT_n_TACHOLIMIT
    • The relative limit for the degrees with which the motor is supposed to rotate.
    • Attention: This value is always positive, even if the motor rotates backwards.
  • PORT_n_MODE
    • Mode the motor is supposed to use.
    • Does not refer to forward or backward or increasing or decreasing speed, but to internal commands.
  • PORT_n_SPEED
    • Motor speed.
    • Range: -100 (backward) to 100 (forward)
  • PORT_n_RUNSTATE
    • How the motor is supposed to run.
    • Physical properties (set speed instantly, Ramp UP or Ramp DOWN)

attention Attention

All variables must be written in a cycle!

That means: The variables cannot be forced from the zenon Logic Workbench.

Structure

Internally, NXT uses a structure. Create all variables of this structure by right-clicking on the port and selecting Create advanced variables in the context menu. This structure is written in every cycle. However, since PORT_n_FLAGS is set by straton to 0 after each cycle nothing else will happen.

The variable PORT_n_Flags is a bit mask for those variables which are relevant in this cycle for the structure straton queries. In order to give a Move n degree command set the PORT_n_FLAGS variable to a bit mask [ST]:

It is then defined that the data for PORT_n_MODE, PORT_n_SPEED and PORT_n_TACHOLIMIT are available. Which values must these variables have?

For PORT_n_MODE also a bit mask is required. In principle always both must be set if you would like to create a forward movement [ST]:

Now you have set the bit mask on which variables are supposed to be updated as well as some internal flag parameters.

Now we can focus on the more interesting part: The rotation mode of the motor - PORT_n_RUNSTATE. No bit mask is available in this case. The values are exclusive.

And finally: PORT_n_SPEED and PORT_n_TACHOLIMIT:

attention Attention

Make absolutely sure that these values are not written in every cycle. Otherwise the rotation command is executed in every cycle. However, you still have to write all variables in every cycle. Block the writing of these values.


zenon Science Package for LEGO MINDSTORMS EV3

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for LEGO MINDSTORMS EV3

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon Science Package for LEGO MINDSTORMS EV3 enables the programming of LEGO Mindstorms EV3 objects.

Preparation:

  • zenon 7.20 already installed and installations medium available.
    If you have not installed zenon, you must install the zenon Science Package, version 7.20 or higher.


Requirements

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for LEGO MINDSTORMS EV3 -> Requirements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Hardware:

  • Netgear WNA1100 Wi-Fi Dongle
  • LEGO MINDSTORMS EV3 with firmware version 1.03E or 1.03H or higher.

Software:

  • zenon from version 7.20 on
  • LEGO MINDSTORMS EV3 Runtime (available on the installation medium in the path \AdditionalSoftware\Science Package - Firmware\EV3)
  • Bricx Command Center (available at http://bricxcc.sourceforge.net/)

Firmware for LEGO MINDSTORMS EV3

The firmware on the LEGO MINDSTORMS EV3 must be at least version 1.03E or 1.03H or higher.

To check the version of the firmware, select Brick Info in the Settings tab of LEGO MINDSTORMS EV3. You can download the most recent firmware (*.bin file) from the LEGO website.

Use the LEGO software to update the firmware.


Installation

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for LEGO MINDSTORMS EV3 -> Installation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The installation comprises:

  • zenon Science Package
  • EV3 Setup
  • zenon Logic Editor and Runtime

If you have already installed zenon 7.20 or higher, you can execute the EV3 setup immediately.

Installation of the zenon Science Package

Start the installation from the zenon installation medium and follow the notes in the installation assistant. You can also download the zenon Science Package from the COPA-DATA home page. This installation already includes zenon Logic.

Installation of straton Runtime on LEGO EV3

  1. Install the Bricx Command Center.
    You can find the program at http://bricxcc.sourceforge.net/test_releases.
  2. Download a current test_release.
    test_release2013007.zip is used in these instructions.
  3. Connect the LEGO MINDSTORMS EV3 to the PC with a USB cable.
  4. Open Bricx CC: Tools -> Find Brick
  5. Configure the connection:

    • Port: usb
    • Brick Type: EV3
    • Firmware: Linux
  6. Open Bricx Explorer: Tools -> Explorer.

  7. Create a new folder called T5 Runtime.
  8. Open, on the installation medium, the folder T5 Runtime in the following path:\AdditionalSoftware\Science Package – Firmware\EV3\apps.
  9. Copy the files contained therein and add these to your T5 Runtime folder in the Brick Explorer.
  10. Open the \AdditionalSoftware\Science Package – Firmware\EV3\prjs folder on the installation medium.
  11. Copy the file there called t5ev3 to the folder in which the T5 Runtime folder is also located.

  • On the LEGO EV3 Brick, the new entry T5 Runtime is now available.


Create a zenon Logic project

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for LEGO MINDSTORMS EV3 -> Create a zenon Logic project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon Logic contains a fully-integrated configuration tool for the LEGO MINDSTORMS EV3, as well as a library with Functions and Function Blocks.

The first stage is to create a zenon project and a zenon Logic project in this.

Create a zenon project

  1. Open the zenon Editor
  2. Select File -> New project.
  3. The dialog to create a project is opened.

  4. Enter a name for the project.
  5. Click on OK.
    • The wizard to create the project is started.
    • Close the wizard.

Alternatively, you can also open the supplied demo project.

Create a zenon Logic project

  1. In the zenon Editor, go to zenon Logic (IEC 61131-3).
  2. In the context menu or in the tool bar of the detail view, select zenon Logic New project.

  3. The dialog to create a project is opened.
  4. Enter a name for the project.
  5. Click on Fertigstellen.


EV3 configuration in zenon Logic

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for LEGO MINDSTORMS EV3 -> EV3 configuration in zenon Logic

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Runtime administers an allocation table, which contains the LEGO MINDSTORMS EV3 Inputs and Outputs. A tool for configuration is integrated into the zenon Logic Workbench.

To start the configuration:

  1. In the zenon Logic Workbench, double click on Field bus configuration.

  2. The I/O driver window is opened.
  3. Right click on a free position in this window.
  4. Select Add configuration in the context menu.
  5. The Add configuration window is opened.

  6. Select the All node.
  7. Select LEGO EV3.
  8. Click on OK.

The configuration is created in the tree view:

LEGO EV3 configuration

  • EV3
    • Buttons
  • Sensors
    • Port 0
    • Port 1
    • Port 2
    • Port 3


Define sensor type

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for LEGO MINDSTORMS EV3 -> EV3 configuration in zenon Logic -> Define sensor type

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can define the type of sensor for each port in the Sensors group.

To do this:

  1. Double-click on the port.
  2. The configuration window will open
  3. Double-click on Type.
  4. The selection list is opened.
  5. Select the desired type.

  6. Close the dialog by clicking on OK.


Create variables

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for LEGO MINDSTORMS EV3 -> EV3 configuration in zenon Logic -> Create variables

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can create variables automatically or connect them manually.

Create variables automatically

  1. Right-click on the port.
  2. Select Create variables in the context menu.
  3. All required variables are created automatically.

Note: If the sensor type is set to None, no variables are created.

Connect variables manually

To connect variables manually:

  1. Right-click on the port.
  2. Select Add variables in the context menu
  3. The dialog for configuration is opened.
  4. Clicking on a value opens the selection list of the values that are possible for this type.

Configure variables

Parameter

Description

Symbol

Selection of a variable in accordance with IEC 61131-3 syntax.

Area

Range.

Format

Data type:

  • 32 bit float
  • Signed 16 bit integer
  • Signed 32 bit integer
  • Signed 8 bit integer
  • Single bit
  • Unsigned 16 bit integer
  • Unsigned 32 bit integer
  • Unsigned 8 bit integer

Offset

Is not used.

Bit Number

Bit number.

Datatypes

You can connect variables with any desired data type to the LEGO EV3 I/Os. Runtime automatically converts the values to the data type of the variable.

Note: STRING variables are not supported.


Blocks and Functions function

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for LEGO MINDSTORMS EV3 -> EV3 configuration in zenon Logic -> Blocks and Functions function

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Some Function Blocks and Functions are provided in the library to control LEDs, sounds, LCD and motors of the LEGO EV3.

The following Function Blocks are described in more detail:

  • LED
  • Sound
  • Motor


LED

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for LEGO MINDSTORMS EV3 -> EV3 configuration in zenon Logic -> Blocks and Functions function -> LED

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Set LED pattern:

Parameter

Description

SetLed

Creates an LED pattern

[IN] LED

Index of the LED pattern to be applied:

  • 0: All LEDs off.
  • 1-9: Corresponding LED pattern.

[OUT] Q

Current LED pattern.


Sound

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for LEGO MINDSTORMS EV3 -> EV3 configuration in zenon Logic -> Blocks and Functions function -> Sound

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Set sound playback.

General:

Parameter

Description

PlaySnd

Play back sounds.

[IN] ENABLE

Switch on sound playback:

  • TRUE: Sounds are played back.
    To activate playback, the setting must have previously been FALSE.
  • FALSE: Sounds are not played back.

[IN] FREQ

Frequency of the sound.

[IN] DURATION

Duration of the signal.

[IN] VOLUME

Volume

  • Minimum: 0
  • Maximum: 100

[OUT] PLAYING

TRUE, if sounds are played back.

System sounds:

Parameter

Description

PlaySysSnd

Play back system sound.

[IN] ENABLE

Switch on sound playback:

  • TRUE: Sounds are played back.
    To activate playback, the setting must have previously been FALSE.
  • FALSE: Sounds are not played back.

[IN] SND

Index of the system sound.

[IN] VOLUME

Volume.

  • Minimum: 0
  • Maximum: 100

[OUT] PLAYING

TRUE, if a system sound is played back.

Symbol

Variable name in accordance with IEC 61131-3 syntax.

Area
  • Data Exchange
  • Data Status.

Format

Data type:

  • 32 bit float
  • Signed 16 bit integer
  • Signed 32 bit integer
  • Signed 8 bit integer
  • Single bit
  • Unsigned 16 bit integer
  • Unsigned 32 bit integer
  • Unsigned 8 bit integer

Offset

Is not used.

Bit Number

Bit number.


Motor

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for LEGO MINDSTORMS EV3 -> EV3 configuration in zenon Logic -> Blocks and Functions function -> Motor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Set motor.

Motor information

Motor information:

Parameter | Description
MotorInfos | Call up motor information.
[IN] MOTOR | Index of the motor: 1 - 4
[OUT] SPEED | Current speed.
[OUT] TACHO | Current number of revolutions to display the distance covered.

Run motor

Run a motor:

Parameter

Description

Rotate

Run a motor.

[IN] MOTOR

Index of the motor: 1 - 4

[IN] START

Start motor:

  • TRUE: Motor is started. To start, the setting must have previously been set to FALSE.
  • FALSE: Motor is not started.

[IN] POWER

Force to be applied:

  • -255 to -1: Backwards.
  • 0: Stop.
  • 1 to 255: Forward.

[OUT] RUNNING

TRUE if the motor is running.

[OUT] SPEED

Current speed.

Run several motors:

Parameter

Description

Rotate2

Run several motors.

[IN] MOTORS

Index of the motor numbers.

  • Motor 1: 1
  • Motor 2: 2
  • Motor 3: 4
  • Motor 4: 8

Example: To address Motors 1 and 2, enter 3 (1 + 2).

[IN] START

Start motor:

  • TRUE: Motor is started. To start, the setting must have previously been set to FALSE.
  • FALSE: Motor is not started.

[IN] POWER

Force to be applied:

-255 to -1: Backwards.

0: Stop.

1 to 255: Forward.

[OUT] RUNNING

TRUE if the motor is running.

[OUT] SPEED

Current speed.

Rotation angle

Rotation angle for a motor:

Parameter

Description

RotateAngel

Rotation angle for a motor.

[IN] MOTORS

Index of the motor: 1 - 4

[IN] START

Start motor:

  • TRUE: Motor is started. To start, the setting must have previously been set to FALSE.
  • FALSE: Motor is not started.

[IN] POWER

Force to be applied:

  • -255 to -1: Backwards.
  • 0: Stop.
  • 1 to 255: Forward.

[IN] ANGLE

Angle in degrees.

[IN] BRAKE

Brake.

  • TRUE: Motor is braked at the end.
  • FALSE: Motor is not braked.

[OUT] RUNNING

TRUE if the motor is running.

[OUT] SPEED

Current speed.

Angle of rotation for several motors:

Parameter

Description

RotateAngel2

Angle of rotation for several motors.

[IN] MOTORS

Index of the motor numbers.

  • Motor 1: 1
  • Motor 2: 2
  • Motor 3: 4
  • Motor 4: 8

Example: To address Motors 1 and 2, enter 3 (1 + 2).

[IN] START

Start motor:

  • TRUE: Motor is started. To start, the setting must have previously been set to FALSE.
  • FALSE: Motor is not started.

[IN] POWER

Force to be applied:

  • -255 to -1: Backwards.
  • 0: Stop.
  • 1 to 255: Forward.

[IN] ANGLE

Angle in degrees.

[IN] BRAKE

Brake.

  • TRUE: Motor is braked at the end.
  • FALSE: Motor is not braked.

[OUT] RUNNING

TRUE if the motor is running.

[OUT] SPEED

Current speed.

Speed

Speed for a motor:

Parameter

Description

RotateCount

Run a motor for a defined number of counter impulses.

[IN] MOTORS

Index of the motor: 1 - 4

[IN] START

Start motor:

  • TRUE: Motor is started. To start, the setting must have previously been set to FALSE.
  • FALSE: Motor is not started.

[IN] POWER

Force to be applied:

  • -255 to -1: Backwards.
  • 0: Stop.
  • 1 to 255: Forward.

[IN] COUNT

Number of rotation impulses.

[IN] BRAKE

Brake.

TRUE: Motor is braked at the end.

FALSE: Motor is not braked.

[OUT] RUNNING

TRUE if the motor is running.

[OUT] SPEED

Current speed.

Speed for several motors:

Parameter

Description

RotateCount2

Run several motors for a defined number of counter impulses.

[IN] MOTORS

Index of the motor numbers.

  • Motor 1: 1
  • Motor 2: 2
  • Motor 3: 4
  • Motor 4: 8

Example: To address Motors 1 and 2, enter 3 (1 + 2).

[IN] START

Start motor:

  • TRUE: Motor is started. To start, the setting must have previously been set to FALSE.
  • FALSE: Motor is not started.

[IN] POWER

Force to be applied:

  • -255 to -1: Backwards.
  • 0: Stop.
  • 1 to 255: Forward.

[IN] COUNT

Number of rotation impulses.

[IN] BRAKE

Brake.

  • TRUE: Motor is braked at the end.
  • FALSE: Motor is not braked.

[OUT] RUNNING

TRUE if the motor is running.

[OUT] SPEED

Current speed.

Running time

Running time for a motor:

Parameter

Description

RotateTime

Run a motor for a defined time period.

[IN] MOTORS

Index of the motor: 1 - 4

[IN] START

Start motor:

  • TRUE: Motor is started. To start, the setting must have previously been set to FALSE.
  • FALSE: Motor is not started.

[IN] POWER

Force to be applied:

  • -255 to -1: Backwards.
  • 0: Stop.
  • 1 to 255: Forward.

[IN] SECONDS

Time that the motor runs, in seconds.

[IN] BRAKE

Brake.

  • TRUE: Motor is braked at the end.
  • FALSE: Motor is not braked.

[OUT] RUNNING

TRUE if the motor is running.

[OUT] SPEED

Current speed.

Speed for several motors:

Parameter

Description

RotateTime2

Run several motors for a defined time period.

[IN] MOTORS

Index of the motor numbers.

  • Motor 1: 1
  • Motor 2: 2
  • Motor 3: 4
  • Motor 4: 8

Example: To address Motors 1 and 2, enter 3 (1 + 2).

[IN] START

Start motor:

  • TRUE: Motor is started. To start, the setting must have previously been set to FALSE.
  • FALSE: Motor is not started.

[IN] POWER

Force to be applied:

  • -255 to -1: Backwards.
  • 0: Stop.
  • 1 to 255: Forward.

[IN] SECONDS

Time that the motors run, in seconds.

[IN] BRAKE

Brake.

  • TRUE: Motor is braked at the end.
  • FALSE: Motor is not braked.

[OUT] RUNNING

TRUE if the motor is running.

[OUT] SPEED

Current speed.

Motor power output

Define the power output for a motor:

Parameter

Description

SetPower

Define the power output for a motor whilst it is turning.

[IN] MOTORS

Index of the motor: 1 - 4

[IN] SET

Define power output:

  • TRUE: Power output is defined. To do this, the setting must have previously been set to FALSE.
  • FALSE: Power output is not changed.

[IN] POWER

Force to be applied:

  • -255 to -1: Backwards.
  • 0: Stop.
  • 1 to 255: Forward.

Define power output for several motors:

Parameter

Description

SetPower2

Run several motors for a defined time period.

[IN] MOTORS

Index of the motor numbers.

  • Motor 1: 1
  • Motor 2: 2
  • Motor 3: 4
  • Motor 4: 8

Example: To address Motors 1 and 2, enter 3 (1 + 2).

[IN] SET

Define power output:

  • TRUE: Power output is defined. To do this, the setting must have previously been set to FALSE.
  • FALSE: Power output is not changed.

[IN] POWER

Force to be applied:

  • -255 to -1: Backwards.
  • 0: Stop.
  • 1 to 255: Forward.

Stop motor

Stop a motor:

Parameter | Description
StopMotor | Stop a motor.
[IN] MOTOR | Index of the motor: 1 - 4
[IN] STOP | Motor is stopped.

Stop several motors:

Parameter

Description

StopMotor2

Stop several motors.

[IN] MOTORS

Index of the motor numbers.

  • Motor 1: 1
  • Motor 2: 2
  • Motor 3: 4
  • Motor 4: 8

Example: To address Motors 1 and 2, enter 3 (1 + 2).

[IN] STOP

Motors are stopped.


Connect EV3 to zenon Logic Editor

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for LEGO MINDSTORMS EV3 -> Connect EV3 to zenon Logic Editor

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

LEGO MINDSTORMS EV3 and zenon Logic communicate via Wi-Fi.

To establish communication:

  1. Insert the Netgear WNA1100 Wi-Fi Dongle into the USB port of the Brick.
  2. Switch on the Wi-Fi on the LEGO MINDSTORMS EV3.
    To do this:
    1. Open the Settings tab (tool symbol).
    2. Activate the Wi-Fi.
  3. Connect to your network.

    You can find further information about Wi-Fi in your LEGO MINDSTORMS EV3 instructions.

  4. Define the IP address of the LEGO MINDSTORMS EV3 in zenon Logic Editor.
    To do this:
    1. Open the Tools menu.
    2. Select the Communication parameters command.
    3. The dialog to select the IP address is opened.
    4. Select the IP address of the EV3. (See also the First steps in the demo project chapter.)

      Note:
      - You can find the correct IP address in the Brick in the Settings tab (tool symbol ) under Brick Info.
      - Runtime uses port 1100.

  5. Start the T5 Runtime on the LEGO MINDSTORMS EV3.
    To do this:
    1. Select, in the App tab (arrow symbol) of the Brick, T5 Runtime.
    2. Press the middle switch on the Brick.
    3. Starts the Runtime.

You can now create a new program in the zenon Logic Workbench to control your LEGO MINDSTORMS EV3 with the help of the program.


First steps in the demo project

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for LEGO MINDSTORMS EV3 -> First steps in the demo project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

You can try out the basic functions and configuration of LEGO MINDSTORMS EV3 with zenon and zenon Logic with the supplied demo project.

To do this:

  1. Open the demo project called EV3_DEMO in zenon Editor.
  2. Connect the sensors and motors to the corresponding ports.

  3. Configure the zenon Logic: LEGO_EV3 driver.

Configuring the driver

To configure the driver:

  1. In the zenon project, go to the Driver node (below Variables).
  2. Right-click on the driver zenon Logic: LEGO_EV3.
  3. Select Driver configuration in the context menu

  4. The configuration window will open

  5. In the General tab, select the Hardware entry for the Mode option.
  6. Switch to tab Connections (1).

    1. Highlight the LEGO_EV3 connection (2).
    2. Click on Edit (3).
    3. For the Primary IP address option, enter the IP address of your Brick.
      You can find the address in the Brick in the Settings tab (tool symbol) under Brick Info.
    4. Change the Primary port no option (4) to 1100.
    5. Confirm the input by clicking Save (5).
  7. Close the window by clicking on OK.

Configure zenon Logic project and start Runtime

Once you have configured the driver, open the zenon Logic project.
To do this:

  1. In the zenon Editor, go to zenon Logic (IEC 61131-3).
  2. Double click on the project

  3. Open, in zenon Logic Workbench, the Tools menu.
  4. Click on Communication parameters.

  5. The dialog to configure communication parameters is opened.
    (See also Connect EV3 to zenon Logic Editor chapter.)

  6. Enter the IP address of your LEGO MINDSTORMS EV3 Brick and its port number.
    Format: IP address port number.
    You can find the address in the Brick in the Settings tab (tool symbol) under Brick Info.
    Port number: 1100.
  7. Use straton Runtime to connect to the EV3.
    to do this:
    • Open the menu Project
    • Select the Online entry.
    • Confirm the question after downloading the project with OK.
    • Load the project into the EV3.
      (Alternatively: Project -> Download application.)
  8. Switch to the zenon Editor
  9. In the Runtime files tool bar, click on Create all Runtime files.
  10. Click on Start Runtime.

EV3 Runtime is started.


COPA-DATA Forum

Manual -> zenon Science Package for LEGO MINDSTORMS -> zenon Science Package for LEGO MINDSTORMS EV3 -> COPA-DATA Forum

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For questions in relation to the zenon Science Package, you can also receive information and support in the Science Package Thread in the COPA-DATA Forum: www.copadata.com/forums.


zenon Web Server, Web Server Pro and Web Server Pro Light

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon Web Server is currently available in three different versions: Their functions are briefly described in the following:

tutorial License information

zenon Web Server, zenon Web Server Pro and zenon Web Server Pro Light require a license to run. For more details, see the Licensing chapter.

zenon Web Server:

  • Forwards data packets from the Primary Server via the zenon Web Server to the zenon Web Client.
  • Handles licensing.
  • Only acts as a viewer.
  • Active operating actions that have an effect on the process, such as write set value, write recipe, save PFS settings, acknowledge alarms etc. are not possible.

Note: Passive operating actions such as screen switching, logging in or logging out are possible.

  • Can be installed on a separate computer, such as in a DMZ for example.
  • Supports network encryption.
  • Supports HTTP tunneling.
  • Many clients possible (depending on the license).

zenon Web Server Pro:

  • Same functionality as zenon Web Server, except:
    • Allows active user actions with zenon Supervisor and zenon Operator Runtime.
  • Start and operation under Windows CE are subject to certain limitations.
  • Can be installed on a separate computer, such as in a DMZ for example.
  • Supports network encryption.
  • Supports HTTP tunneling.
  • Many clients possible (depending on the license).

zenon Web Server Pro Light:

  • Allows active user actions with zenon Supervisor and zenon Operator Runtime.
  • The Primary Server that zenon Web Client connects to must be the same computer on which zenon Web Server Pro Light runs.
    Note: For projects with redundancy, zenon Web Server Pro Light must be implemented redundantly - one instance on the Server and one on the Standby Server.
  • Maximum 3 clients.
  • No support for encrypted network traffic. It does not start or it ends itself with encrypted communication.
  • HTTP tunneling is not supported.
  • Projects must run on the same computer as the "server". Projects that run on this computer as a client are not supported.
  • Multiple projects are supported if all projects run locally as a server.

Note: Web Server is supplied as a 32-bit application up to zenon 7.10. From version 7.11 onwards, it has also been available as a 64-bit application.


Example of configuration with zenon Web Server:

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Example of configuration with zenon Web Server:

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

From PC1, you connect as a client via the Web Server to PC2 as a gateway, to the Primary Server, i.e. to PC3 (see the following illustration). With the help of zenon Web Server and zenon Web Client, the project can be displayed on PC1 in a web browser by PC3, without an additional local installation of Runtime being necessary on PC1. The following installations are necessary for this function:

Note: The following arrangement of components is merely a recommendation. You are free to decide which components are installed on which computer. However it must be noted that a web client for a project A cannot be used on a computer that is the server for project A.

Also: When using zenon Web Server Pro Light, this must be installed on the computer on which Runtime is running. This is PC3 in our example.

  1. PC1: Install zenon Web Client and the web browser on this computer.
  2. PC2: Install the publishing service and zenon Web Server on this computer.

    Note: With regard to the publishing service, this handbook relates to the IIS Publishing Service. If the IIS Publishing Service is installed on this computer, the home page for the zenon Web Client is configured automatically. However there are also alternative publishing services, such as the one from Apache. You are free to decide which of these you use. Furthermore, there is the possibility to not have the publishing service at all. However in this case there are additional steps that you have to carry out manually. You can find these steps in detail in the Publishing service chapter.

  3. PC3: zenon Runtime and the project must be on this computer, and optionally also the zenon Editor.

    Note: If zenon Web Server is not licensed, it starts in demo mode. The automatic start with the operating system does not happen in this case and the web server must be started manually via the user interface. The session is automatically ended after 30 minutes. A maximum of 2 clients can connect to it.

Configuring the individual components:

Configuration is usually still necessary after installation. For example, after installation of zenon Web Server on PC2, the global.vars file is important. This file is, among other things, automatically installed as well and still needs some amendments. For details, read the global_vars.js settings chapter.

The Runtime project on PC3 requires the following basic settings in the zenon Editor:

  • Project property -> Network -> Activate active network.
  • Enter project property -> network -> Server 1 -> computer (name) with Runtime.

If you have finished the installation and configuration, you can have Runtime displayed on PC1. To do this, you open a web browser and enter: RechnernamePC2\zenon\index.htm


Required components and their definitions

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Required components and their definitions

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Components | Description
Primary Server | The server on which Runtime, the Editor and the project is running and to which a client connects via the zenon Web Server.
zenon Web Server | Forwards data packets from the Primary Server via the zenon Web Server to the zenon Web Client. Also handles licensing. Cannot write values.
zenon Web Server Pro | Allows active user actions with zenon Supervisor. Starting and operation with Windows CE is subject to certain limitations.
zenon Web Server Pro Light | Allows active user actions with zenon Operator and zenon Supervisor.
Publishing service | For publishing documents, such as HTML pages, via the HTTP protocol.
zenon Web Client | The zenon Web Client is a program that runs in a standard web browser and displays a project. It connects to a Primary Server using a zenon Web Server. It shows the project of the Primary Server, just as a normal client would do. Only difference: With the zenon Web Client the project is displayed in a browser.
Web browser | Web browsers are special computer programs for the display of web sites in the World Wide Web or the general display of documents and data. Source: http://de.wikipedia.org/wiki/Webbrowser

Administrator rights are required for installation and/or configuration of zenon Web Server, zenon Web Client and the publishing service.

Note: No administrator rights are required for normal operation. The normal user rights are sufficient.


Publishing service installation

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Required components and their definitions -> Publishing service installation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If you use a Windows operating system on your computer, it is no longer necessary to install the publishing service. This need only be activated via Windows features. The following example relates to the IIS Publishing Service. However others can also be used, such as the one from Apache. In this case, the file storage locations may be different. Please note the following info box in this case.

To activate the IIS Publishing Service, proceed as follows:

  1. Open the Control Panel of your PC.
  2. Click on Programs and Features.

    Note: The arrangement of the icons in the Control Panel may look different on your computer.

  3. Click on Turn Windows features on or off.

  4. Activate the Internet Information Services option
  5. Activate all World Wide Web Services there.

If the services have been activated successfully, you will find the following folder in the root directory: C:\inetpub\wwwroot

info Info

If the zenon Web Server was already installed before the publishing service or if a different publishing service is used, the folder created during installation of the Web Server C:\Program Files (x86) \COPA-DATA\zenonWebserver\zenon must be moved manually to C:\inetpub\wwwroot or to the root folder of the alternative publishing service.

Note: The publishing service provides easier access to the configuration files for the web browser. However if the configuration files are accessible locally or in the network, the publishing service need not be used at all.


zenon Web Server Installation

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Required components and their definitions -> zenon Web Server Installation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Note the following criteria when selecting the computer for the Web Server or publishing service:

  • TCP communication from the Web Server to the Primary Server must be possible.
  • There must be complete naming resolution between the Web Server and the Primary Server in the network.

Hint: If the Web Server is to be contactable from outside, it is strongly recommended that a VPN connection is used and the Web Server and the computer with the publishing service is placed in a DMZ.

It is recommended that the zenon Web Server is installed on the same computer on which you have installed the publishing service.

To do this:

  1. Start the installation from the installation medium.
  2. Follow the instructions given to you by the installation wizard.
  3. Restart the computer

The zenon folder is automatically created in the wwwroot folder of the IIS publishing service. This folder contains, among other things, some important configuration files that must be installed. For example, global_vars.js. is an important file You must amend some settings in this file. Read more about this in the zenon Web Server configuration chapter.


zenon Web Server configuration/start

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Required components and their definitions -> zenon Web Server Installation -> zenon Web Server configuration/start

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure the Web Server, or start it manually:

  1. Open the Control Panel or the Start Menu.
  2. Click on zenon Web Server.

    The dialog for configuration and licensing opens:

  3. Select a connection via TCP or HTTP

    Attention: Only activate the option for HTTP tunneling if you have also explicitly configured all web clients for this. TCP is used as a standard.

  4. Click on the Start button to start the web server manually.

Note: In normal operation, zenon Web Server is automatically started with the computer as a Windows service. If it has been closed or if you are in the process of entering a new license number, it must be restarted manually. If there is no valid license, the Web Server is not started as a service but in demo mode via the dialog.

Parameters

Description

State:

Displays version and status of the Web Server:

Possible versions:

  • zenon Web Server
  • zenon Web Server Pro
  • zenon Web Server Pro Light

Possible status messages:

  • running: Web Server is running with valid license
  • stopped: Web Server stopped:
  • Demo mode: Web Server is running in demo mode without license
  • not installed: Web Server not registered as service or installation error

Max. number of clients:

Maximum number of clients that are permitted to connect to the Web Server. The number is defined by the license.
Two clients are licensed for 30 minutes in demo mode.

Number of active clients:

Displays the number of clients currently connected.

Start

Starts the Web Server

Stop

Stops the Web Server

Refresh

Refreshes the display.

Diagnosis Viewer

Opens the Diagnosis Viewer.

HTTP tunneling

Active: HTTP tunneling is activated.

Not available in the Web Server Pro Light version.
Note: Can only be changed if the Web Server has the status stopped. Cannot be switched during operation.

Active clients

List of connected clients.

OK

Applies settings and closes the dialog.

Cancel

Discards the changes and closes the dialog.

Starting and configuring under Windows CE.

There is no start dialog for Windows CE. zenon Web Server is already integrated into Runtime.

To start zenon Web Server under Windows CE, the following must be the case:

  • The Network active property must be activated in the project,
  • Runtime must have been started,
  • zenon Web Server must be licensed

Note: HTTP tunneling is not available with Windows CE.

With Windows CE, the functionality is subject to all the limitations that are generally applicable for Windows CE and zenon Web Server under Windows CE.

Info: No publishing service is installed with Runtime and the integrated Web Server. However any desired publishing service can be used on a Windows computer with the corresponding configuration files.


Settings in global_vars.js

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Required components and their definitions -> zenon Web Server Installation -> zenon Web Server configuration/start -> Settings in global_vars.js

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The connection parameters that are required to establish the connection from the web client to the Primary Server are in the global_vars.js configuration file. This file is in the C:\inetpub\wwwroot\zenon\config\ folder if IIS Publishing is being used.

Amend the content of this file by entering into each line what the comments request from you.

Inhalt global_vars.js:

// Here enter the exact string how your project is named

var PROJECTNAME = "ENTER_PROJECTNAME_HERE";

// Please enter here the computername, where your zenon Runtime is installed and running

var RUNTIMESERVER= "ENTER_RUNTIMESERVERNAME_HERE";

// Here you have to enter computername, where you installed the zenon Web Server

var WEBSERVER = "ENTER_WEBSERVERNAME_HERE";

// Enter an optional init-zenon-function to be executed when the zenon Web Clients connects to its server. Defaultvalue = "Init"

var INITFUNCTION = "Init";

// Enable zoom feature (will stretch the project resolution to the size of the zenon Web Client control) OFF = "0" / ON = "1"

var ZOOM = "0";

// Here you have to enter the version number corresponding to the zenon Web Client.

var VERSION = "7,20,0,0";

// Enable HTTP tunnelling feature: 0 = inactive (available on zenon WebClient version 7.00 and higher)

var HTTP = "1";

Parameters

Parameters

Description

Projectname

Defines the name of the Runtime project.

Example:

var PROJECTNAME = "PROJECTNAME";

Note: The project must as a server project on the stipulated Runtime server.

Primary Server

Denotes the target computer on which Runtime for the project runs.

Example:

var RUNTIMESERVER = "SERVERNAME";

The name must correspond with the server name in the project configuration.

Note: The IP address must not be used here. There must be naming resolution between the computer with the Web Server and the Primary Server in the network in both directions. Pinging the name must produce identical results on both computers.

Primary Server redundancy

Only the name of the Primary Server is given for redundant Runtime projects, not the name of the Standby Server. The name of the Standby Server is saved in the project's project.ini file. zenon Web Client saves this locally the first time it connects with the Runtime Server. That means: The Primary Server has to be online the first time a connection to a redundant project is made. For each further connection, the redundancy concept then will work, i.e. the zenon Web Client first tries to establish a connection to the Primary Server. If it cannot be reached, it automatically connects to the standby server.

Web Server redundancy

If, in addition to zenon Primary Server, the zenon Web Server is also to be operated as redundant, the following must be the case:

  • Two copies of zenon Web Server installed and licensed on different computers
  • Both copies of zenon Web Server, separated by a comma, must be entered in the variable declaration on the HTML page:

    var WEBSERVER = "WEBSERVER,WEB-STANDBY-SERVER";

Web Server

Denotes the target computer on which zenon Web Server was installed. Attention: That is not the publishing server!

Example:

var WEBSERVER = "WEBSERVER";

Note: Instead of the name of the computer with the Web Server, the IP address of the computer with the Web Server can also be used here. If the Web Server is behind an NAT router and port forwarding is configured on the computer with the Web Server, the IP address of the NAT router can also be used.

Initfunction

Defines a zenon function that is executed when a project is started in the browser.

var INITFUNCTION = "Init";

For example:

var INITFUNCTION = "Init";

Default: "Init"

Note: The wording must correspond to the function names in zenon (capitalization).

Zoom

Defines if the project can be zoomed in or out of in the browser view.

var ZOOM = "WERT";

0: OFF

1: ON

For example:

var ZOOM = "0";

Note: The zoom adjustment is only considered on initializing, not when the Runtime is running. If a certain size is wanted, it has to be defined by the ActiveX control. If you do not open the browser window as maximized and then maximize it later, this can lead to display problems.

var VERSION

Defines the zenon Web Client version.

var VERSION = "WERT";

for example:

var VERSION = "7,20,0,0";

This must always be the same or higher than the version of zenon Runtime.

Note: When entering parameters in the global_vars.js file, note capitalization.


zenon Web Client Installation

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Required components and their definitions -> zenon Web Client Installation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

There are four possibilities for installation of zenon Web Client as a 32-bit application.

Note: It is recommended that you carry out the installation using the first option.

1. Via the index.htm page:

It is recommended that you carry out the following steps on the computer on which the Publishing service has been installed or activated. It is PC2 in this example. For details, see the screen in the Example configuration with zenon Web Server chapter. However the Web Client is not necessarily required on this computer. You are free to choose the computer.

  1. Start the index.htm page by entering the following in the web browser: http://Publishingserver//zenon/index.htm

  2. Then click on the Starting the zenon Web Client icon.
  3. The WebClientSmall setup must be carried out first.

    Note: Administrator rights are required for this. The WebClientSmall setup also requires an Internet connection during installation, in order to download further components. If your computer does not have an Internet connection, use the major installation and one of the other methods of installation.

  4. The init.htm page continues to be called up by the index.htm page.
  5. The init.htm uploads the Javascript files. These then load the zenon Web Client plug-in.

Note: If you need the larger file from the Web Client, you must amend the index.htm page manually. You can read more about this in the index.htm chapter.

You can also, as an option, open the index.htm page from the zenon folder. This folder is automatically created in the wwwroot directory when the Web Server is installed.

2. Via Copy and Paste

After installation of the Publishing service (IIS) and the zenon Web Server, the installation files for the zenon Web Client are in the subdirectory. C:\inetpub\wwwroot\zenon\controlversions\version720SP0\WebClient.exe or WebClient_small.exe.

Copy the WebClient_small.exe. bzw. WebClient.exe. application from there.

  1. Add these into your preferred local save location.
  2. Install the application.

3. Via the start installation medium:

  1. Copy, from the folder ...\Setup\wwwroot\controlversions\version720SP0\WebClient.exe, the WebClient.exe bzw. WebClient_small.exe application.
  2. Add these into your preferred local save location.
  3. Install the application.

Note: zenon Web Client primarily consists of an ActiveX control. This provides the information in a browser exactly as in a normal Runtime client. The connection to the Runtime server is implemented with zenon Web Server. zenon Web Client logs errors in the local diagnosis server. The diagnosis server is also installed when zenon Web Client is installed.

4. Via the init.htm page:

Start the web browser and go to the init.htm page, in which you enter the following: http://Publishingserver/zenon/init.htm

  1. From there, start the WebClient.exe application

Note: The number of web clients that can be used at the same time depends on your license.

Attention: This may need to be added as a "trusted site" in the Internet Explorer settings under Extras -> Internet options -> Security.

To do this:

  • Open the web browser.
  • Click on Internet Options.
  • Click on Security.
  • Click on Trusted sites
  • Click on Sites.
  • Enter the page.


zenon Web Client - compatibility

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Required components and their definitions -> zenon Web Client Installation -> zenon Web Client - compatibility

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With the zenon Web Client, you access different versions of Runtime, along the lines of Runtime compatibility. The version number of the Web Client must only be the same or higher than the Runtime version.

The Runtime online compatibility makes interoperability of Runtime systems (also via Web Clients) in the zenon network possible even if the version of the client Runtime is higher than the version of the server Runtime.

The current Runtime cam load projects of the following versions:

  • 6.20 SP4
  • 6.21 SP0
  • 6.21 SP1
  • 6.22 SP0
  • 6.22 SP1
  • 6.50 SP0
  • 6.51 SP0
  • 7.00 SP0
  • 7.10 SP0
  • 7.11 SP0

Due to the multi-project administration projects from different versions can be loaded. For example the Integration project can have version 7.11, a sub-project version 7.00 and another sub-project version 6.51.

info Information

It is best to always use the zenon Web Client with the highest Service Pack number within a version.


Language setting of zenon Web Client

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Required components and their definitions -> zenon Web Client Installation -> Language setting of zenon Web Client

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To configure the language for the Web Client:

  1. Start the Startup Tool.
  2. Select the General menu entry.
  3. Select the desired language in the Language for Editor and Runtime drop-down list.

Available languages for the Web Client:

  • Chinese
  • German
  • English
  • French
  • Italian
  • Russian
  • Spanish
  • Czech

info Information

You can get further information for the language setting in the Startup Tool in the Tools manual in the General chapter.


Creation of the HTML page for the project entry

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Required components and their definitions -> zenon Web Client Installation -> Creation of the HTML page for the project entry

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A project start page is required, so that the web browser can start zenon Web Client and then connect to the corresponding Primary Server. This page contains the necessary code. Java Script is used as a script language.

Requirements:

  • JavaScript must be activated in the browser.
  • The zenon Web Client must also be installed locally on the computer on which the web browser is executed.

Recommendation: Switch, before the project entry page (init.htm), to a start page (index .htm ) , that allows the download of the Web Client. This start page contains hyperlinks:

  • To download the zenon Web Client controls
  • To project entry page init.htm, which carries out a browser check and makes the connection from zenon Web Server to the Primary Server.


Example of project start page init.htm for TCP and HTTP

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Required components and their definitions -> zenon Web Client Installation -> Creation of the HTML page for the project entry -> Example of project start page init.htm for TCP and HTTP

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On the project entry page, a browser check checks to see which browser the Web Client uses. Depending on the result, the Web Client is started or an error message is given.

Example of project start:

The start page calls up three scripts in order to check the browser used and either to establish a connection to Runtime or to issue an error message:

  • global_vars.js: Defines values of transfer parameters to start the Web Client
  • browsercheck.js: Checks the version of the browser
  • initcode.js: Defines functions that are used to start the Web Client

Note: The settings only differ for connections using TCP and HTTP in terms of the UseHTTP entry.


index.htm

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Required components and their definitions -> zenon Web Client Installation -> index.htm

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The page index.htm is the start page for our example. It starts by default in English and can be switched to other languages directly on the page on the top right.

The page index.htm:

  • Informs you about compatible browsers
  • Offers links to start the zenon Web Clients
  • Offers a link to the installation of zenon Web Client controls; this is necessary if zenon is not installed on the computer with the Web Client
  • Calls up the project entry page init.htm when the Web Client is started, which carries out the browser check


init.htm

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Required components and their definitions -> zenon Web Client Installation -> init.htm

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The init.htm file checks the browser being used and then either starts the project or gives an error message.

Scripts are used for this:

  1. The configuration is loaded from global_vars.js.
  2. The browser is determined by browsercheck.js.
  3. If it is a supported browser, the appropriate function to include the zenon Web Client from initcode.js is executed.

Example:

<html>

<head>

<title></title>

</head>

<BODY scroll="no" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0" BGCOLOR=#FFFFFF>

<script language="javascript" type="text/javascript" src="global_vars.js"></script>

<script language="javascript" type="text/javascript" src="browsercheck.js"></script>

<script language="javascript" type="text/javascript" src="initcode.js"></script>

<script language="JavaScript" type="text/javascript">

switch(browsercheck()) {

case "IEXPLORER":

runIexplorer(PROJECTNAME,RUNTIMESERVER,WEBSERVER,INITFUNCTION,ZOOM,VERSION);

break;

case "NPAPI":

runNPAPI(PROJECTNAME,RUNTIMESERVER,WEBSERVER,INITFUNCTION,ZOOM,VERSION);

break;

case "UNSUPPORTED_BROWSER":

alert(navigator.appName + ' : ' + navigator.appVersion + ' is not supported!');

break;

default:

alert("invalid parameter");

break;

}

</script>

</html>


browsercheck.js

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Required components and their definitions -> zenon Web Client Installation -> browsercheck.js

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This JavaScript finds out which browser the the Web Client wants to start and gives the result back to init.htm.

function browsercheck(){

var UserAgent = navigator.userAgent;

var fWin32 = (UserAgent.lastIndexOf('Win') != -1) && (UserAgent.lastIndexOf('Windows 3.1') == -1) && (UserAgent.lastIndexOf('Win16') == -1);

var fMSIE = (UserAgent.lastIndexOf('MSIE ') != -1);

var fNPAPI = (UserAgent.lastIndexOf('Firefox/') != -1) || (UserAgent.lastIndexOf('Chrome/') != -1) || ((UserAgent.lastIndexOf('Safari') != -1) && (UserAgent.lastIndexOf('Version/') != -1));

if(fWin32)

{

//Win32-Browser

if(fMSIE)

{

//Internet Explorer --> use ActiveX-Control

return "IEXPLORER";

}

if(fNPAPI)

{

//Firefox, Chrome or Safari --> use NPAPI-Plugin

return "NPAPI";

}

}

//Non-Win32-Browser or not supported Browser (Opera, ...)

return "UNSUPPORTED_BROWSER";

}


initcode.js

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Required components and their definitions -> zenon Web Client Installation -> initcode.js

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This Javascript sets:

  • The <embed> entry to start zenon Web clients in Apple Safari, Google Chrome or Mozilla Firefox
  • The <object> entry to start zenon Web clients in Microsoft Internet Explorer

Script:

function runNPAPI(PROJECTNAME,RUNTIMESERVER,WEBSERVER,INITFUNCTION,ZOOM,VERSION) {

document.write ('<embed type="application/x-zenon"');

document.write (' width=100%');

document.write (' height=100%');

document.write (' Project="' +PROJECTNAME+ '"');

document.write (' Server="' +RUNTIMESERVER+ '"');

document.write (' WebServer="' +WEBSERVER+ '"');

document.write (' Load="-1"');

document.write (' ScrollV="0"');

document.write (' Scrollh="0"');

document.write (' InitFunction="' +INITFUNCTION+ '"');

document.write (' Zoom="' +ZOOM+ '"');

document.write (' UseHTTP = "' +HTTP+ '"');

document.write ('>');

document.write (' </EMBED> ');

}

function runIexplorer(PROJECTNAME,RUNTIMESERVER,WEBSERVER,INITFUNCTION,ZOOM,VERSION) {

document.write ('<object');

document.write (' id="CD_IClient1"');

document.write (' classid="clsid:2A3BC66B-03D7-11D4-991A-080009ABB492"');

document.write (' codebase="zenWebCli.ocx#version=' +VERSION+ '"');

document.write (' width=100%');

document.write (' height=100%');

document.write ('>');

document.write (' <PARAM NAME="Project" VALUE="' +PROJECTNAME+ '">');

document.write (' <PARAM NAME="Server" VALUE="' +RUNTIMESERVER+ '">');

document.write (' <PARAM NAME="WebServer" VALUE="' +WEBSERVER+ '">');

document.write (' <PARAM NAME="Load" VALUE="-1">');

document.write (' <PARAM NAME="ScrollV" VALUE="0">');

document.write (' <PARAM NAME="Scrollh" VALUE="0">');

document.write (' <PARAM NAME="InitFunction" VALUE="' +INITFUNCTION+ '">');

document.write (' <PARAM NAME="Zoom" VALUE="' +ZOOM+ '">');

document.write (' <PARAM NAME="UseHTTP" VALUE="' +HTTP + '">');

document.write ('</object>');

}


Project configuration

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Project configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The project that is to be started using zenon Web Server requires the following basic settings in the zenon Editor:

  • Project property -> Network -> Activate active network.
  • Project property -> Network -> Server 1 -> Enter computer (name) with Runtime.
  • This computer name must also be started in the project start page (globalvars.js) so that a connection can be established.

Start up the zenon Web Server:

To put the zenon Web Server into operation:

  1. Ensure that the WWW publishing services were started and that the entry page is ready
  2. Start the Runtime project on the computer
  3. Start the zenon Web Server.

attention Attention

VBA/VSTA and Data Execution Prevention

Via function Data Execution Prevention (DEP) the operation prevents that the VBA code is executed in the browser.

Microsoft Internet Explorer 8 and 9:
The Microsoft Internet Explorer version 8 and higher offers the possibility to deactivate DEP for the browser.

  • go to Extras -> Internet options -> Advanced-> Security
  • deactivate the option Activate memory protection in order to reduce the risk of online attacks

Other browsers and Internet Explorer from Version 10 (Windows 8)

DEP must be turned off completely as the browser process cannot be excepted explicitly. This is not recommended due to security issues.

to deactivate DEP:

  • Run the command line with administrative rights
  • Execute the following command:
    bcdedit.exe/set {current} nx AlwaysOff
  • restart the computer

The setting can be undone with the command bcdedit.exe/set {current} nx AlwaysOn

General recommendation: Use VSTA instead of VBA.


General limitations

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Project configuration -> General limitations

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Projects that are operated using zenon Web Client have the following limitations:

  • Alarms:
    Acknowledgement of alarms is only possible when zenon Web Server Pro is used.
  • User administration

    AD and ADAM/ADLDS only work with certain limitations (as on standard clients too):
    AD: The computers must be in the same domain
    ADAM/ADLDS: The zenon Web Client needs a physical connection to the zenon Web Server (plus an open port) and to the ADAM/ADLDS server

  • Screens:
    • The screen of type Archive revision is not available.
  • Print:

    Before the first printing on the zenon Web Client the function Select printer has to be executed. Here the printers for the client can be defined. These settings are saved in the zenon6.ini so that this procedures does not have to be executed again with each new print job.

  • IPA:

    The Industrial Performance Analyzer (IPA) module is only available on zenon Web Clients in an intranet, because no connection can be made to the database via the internet. If there is an intranet connection, the database authorizations have to be set accordingly, so that a remote computer can access the database as a zenon Web Client.

  • Menus

    On the zenon Web Client Main menus are not displayed.

  • Monitor Administration:

    The Monitor Administration works only with limited functionality. The web client can only be operated with one monitor.

  • PFS:

    The Production & Facility Scheduler (PFS) is only available in versions 6.01 or higher.

  • Status information:

    The status information, which is displayed by pressing the right mouse button, is not available.

  • Keyboard combinations:

    The key combinations on buttons like e.g. F3 are not available.

  • VBA:

    VBA is only available if VBA has been installed on the zenon Web Client manually. For detailed information, please contact zenon Support.

    Note: VBA macro message boxes are not shown in the web client when Internet Explorer is used.

  • VSTA: zenon Web Server and zenon Web Client support different versions of VSTA.

    In general, zenon Web Client supports VSTA, with the exception of:

    • Debugging
    • Display VSTA editor function
    • Compiling

    For details, see the VSTA with zenon Web Client, zenon Web Server and zenon Web Server Pro chapters.

Additional restrictions for Windows CE:

  • A maximum of three zenon Web Clients can be connect with a CE Runtime simultaneously.
  • The zenon Web Server must be running on the same device as the CE Runtime to which it is connected. It is not possible to connect to a CE Runtime on another device.

The zenon Web Server for CE is licensed via the Remote Licensing.


Encryption of the communication in the network.

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Project configuration -> Encryption of the communication in the network.

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

From zenon version 7, communication in the network can be protected with strong encryption.
From zenon version 7.11, the configuration for the encryption of the communication of the Web Server has been integrated into the Startup Tool.

To activate encryption in the Web Client:

  1. Start the Startup Tool
  2. Select the Options... menu entry
  3. Switch to the Network configuration tab
  4. Activate the Encrypt network communication checkbox to activate encrypted Web Client communication.

info Information

You can get further information for the network configuration in the Startup Tool in the Tools manual in the Network Configuration chapter.


IPv6

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> IPv6

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As of zenon version 7 you can use IPv6 in the network.

info Information

With IPv6, more users and devices can communicate via the Internet in that they use greater numbers to create IP addresses. With IPv4, each IP address is 32- bits long, as a result of which 4.3 billion unique addresses can be formed. Example for an IPv4 address:

172.16.254.1

For comparison: IPv6 addresses are 128- bits long, which allows formation of approximately 340 sextillion (3,4e+38) unique IP addresses. Example of an IPv6 address:

2001:db8:ffff:1:201:02ff:fe03:0405

However IPv6 offers other advantages for network traffic. In most cases, computers and programs recognize IPv6-compatible networks and use the corresponding advantages without the user having to do anything more. IPv6 also frees other network problems that can occur due to the limited addressing area of IPv4. Example: IPv6 reduces the necessity of network address translations (NAT), a service that allows several clients to use a joint IP address, but which does not always work reliably.

The zenon network allows the choice of using IPv6 or IPv4. Dual operation is not possible. The setting is made via:

  • Network configuration in the Startup Tool
    or
  • In zenon6.ini

Attention: IPv6 only works with version 7 onwards.
No versions prior to version 7 can be started if this is active. This concerns zenAdminSrv, zenSysSrv, zenLogSrv and zenDBSrv in particular.

The following components are not affected by the setting; they always use IPv4:

  • Driver communication with the PLCs
  • Protocol communication in the Process Gateway plug-ins
  • Workbench and Runtime communication in zenon Logic

Diagnosis Viewer

The Diagnosis Server also works with Diagnosis Clients which addresses via IPv6 addresses. For this the format of the log file has been adapted. The Diagnosis Viewer only reads the new format of the log files. If files from older zenon versions are opened (or vice versa), the IP address of the Diagnosis Client is not displayed correctly.


Licensing

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Licensing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The licensing determines:

  • The version of zenon Web Server that runs:
    • zenon Web Server
    • zenon Web Server Pro
    • zenon Web Server Pro Light
  • Number of possible parallel zenon Web Client connections (Concurrent Use License)

Note: zenon Web Server runs in demo mode without a valid license. In doing so, the following restrictions apply:

  • the zenon Web Server can only be started manually
  • The duration that the program can run for is limited to 30 minutes
  • The number of possible clients is limited to 2

To switch from demo mode to a valid license, stop the zenon Web Server and enter a valid license number in the License tab. Restart the zenon Web Server manually.

zenon Operator and Windows CE:

zenon Web Server Pro Light is available for zenon Operator.

For Windows CE, there is zenon Web Server Pro Light built into Runtime available - Runtime must be started in order for zenon Web Server Pro Ligt to run. This is limited in functionality due to the platform. Licensing is checked via Remote Transport in the Editor with remote licensing.

You can also enter the license for the web server via the licensing:

  1. Please open Start -> All programs -> COPA-DATA -> Tools 7.11 -> Licensing.

    or:

    Start the zenon Web Server via Control panel -> zenon Web Server.

  2. The dialog for entering license data opens.
    • Select Web Server
  3. enter the serial number and the activation number

    You find the data for this:

    • on your license certificate
    • On the license sticker

      Path Windows 7/8: C:\Users\Public\Documents\zenon_Projects\

    Note: Pay attention to capital letters and small letters when entering the data!

  4. restart the zenon Web Server on the State tab.
  5. Once you have restarted the computer, you will use zenon Web Server with the license entered.

Licensing dialog

Parameters | Description
Editor/Runtime | Active: License is valid for the zenon Editor and/or the zenon Runtime.
Web Server | Active: License valid for zenon Web Server.
Serial number | License serial number. If there is already a license available, its serial number is displayed here. Enter the current serial number here.
Activation number | License activation number. If there is already a license available, its activation number is displayed here.
OK | Import data and start zenon with this license when it is next started.
Cancel | Discard entries and use zenon with the previous license or no license.
Request soft license | Opens the dialog to request a soft license.

Alternative:

  1. Start the Web Server via Control panel -> zenon Web Server.
  2. Enter, in the License tab in zenon Web Server, the serial number and the activation number that is shown on the license form.

  3. Click on Save in order to save the two numbers.
  4. Restart the zenon Web Server on the State tab.

attention Attention

The zenon Web Clients that are connected lose their connection when restarted. The zenon Web Clients will do an automatic reconnect after a certain timeout.

Note: License number and activation number are entered in the zenWebSrv.ini.


Dongle licensing

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Licensing -> Dongle licensing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon supports the WIBU key and Codemeter systems for licensing via a dongle. For details on this, see the Dongle licensing section in the Licensing handbook.

Licensing via a dongle is implemented by means of:

  • A computer-based dongle or
  • Network dongle

Computer-based dongle:

Using a computer-based dongle:

  1. You receive a dongle and a license certificate with a serial number and activation number.
  2. Close the dongle with the same computer on which you have installed the zenon Web Server.
  3. Register the license in the system.

Network dongle:

As an alternative to the dongle on the same computer, you can also use the central COPA-DATA network dongle. This can be plugged into any desired computer in the network. Licensing is carried out in the same way as the computer-based dongle.

info Information

If a copy of zenon Web Server licensed with Codemeter loses the connection to the dongle, the Web Server is ended.


Soft licensing

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Licensing -> Soft licensing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

For soft licensing:

  1. Start the Web Server licensing program.

  2. Click on the License request button for soft licensing.
  3. The form for your license data is opened.

  4. Fill out all fields and click on Next
  5. The program creates a license request certificate with the license number that is valid for your computer.

  6. Send your license request to your sales partner:
    1. By clicking "Send via email"
    2. By clicking "Print as print-out or fax"

      The license number is also included on the license certificate and must correspond to that of your computer.

  7. An infobox summarizes the process.

  8. As soon as you have received your license data, register the license in the system.


Redundancy operation

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Redundancy operation

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon Web Server can also be operated as redundant If a zenon Web Server fails or is stopped, the zenon Web Client automatically switches to the Standby Web Server.

attention Attention

An automatic switch back - as with the Primary Server - is not carried out. zenon Web Client remains connected to the zenon Standby Web Server until:

  • zenon Web Client is restarted or
  • The zenon Standby Web Server is stopped or fails

Then the zenon Web Client tries to connect with the first zenon Web Server defined as standard.

When using just one zenon Web Server, we recommend that you do not use it on the same computer as the Primary Server or the Primary Standby Server, because the zenon Web Server would also fail in the event that this computer fails.


HTTP tunneling

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> HTTP tunneling

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon Web Server can also, instead of TCP connections, accept HTTP connections. HTTP connections are only accepted by zenon Web Clients. The connection from the Web Server to Primary Server is always made via TCP. A separate HTTP connection is created for each connection from the Web Client to the Web Server.

Connections are made via TCP by default.

To use HTTP tunneling, the following must be the case:

  • HTTP must be activated using the configuration dialog or the entry in zenon6.ini
  • Port 8080 or the alternative port configured in zenon6.ini on the PC Web Server must be reachable
  • The Project entry page for Web Clients, which should connect to the Web Server with HTTP tunneling, should have the UseHTTP parameter with a value that is not 0 in the <embed> and <object> entry

Note: HTTP tunneling is not available with Windows CE.

Configuration of the port:

On the computer with zenon Web Server:

  1. Open the zenon6.ini file.
  2. Navigate to the NET_PROXYPORT= entry or create this
  3. Configure the desired port

    Default: 8080
    The Web Server listen on the port, the Web Client connects to the port.

  4. Save the zenon6.ini file.

On the computer with zenon Web Client:

  • Configure the HTTP port in the zenon6.ini file on the computer with the web client by carrying out he above-mentioned steps again on this computer.

Note: Each change to the port number in zenon6.ini on the computer on which the web server is running must also be created accordingly on all computers configured with zenon Web Client. Furthermore, the HTTP port may need to be configured manually on the computer with the web server in the Windows Firewall, as an exceptional port for incoming connections.

Procedure:

The Web Client sends its messages for the Runtime server to the Web Server via HTTP POST. This forwards it to the assigned connection to the Runtime server via TCP. The Runtime server sends its messages for the Web Client via TCP to the Web Server, which buffers them.

The buffer of a connection is emptied by the Web Client through HTTP GET requests. If no message is available for a connection, the client waits for a configurable time (POLLING_INTERVALL entry in zenon6.ini with a standard value of 2 seconds).

For details, see the Procedure for HTTP connection chapter.

Error messages:

If the HTTP connection is active, network-specific messages are sometimes shown in the Diagnosis Viewer instead of HTTP-specific messages. For example, if a connection is made or disconnected or in the event of an HTTP error.


Procedure with HTTP connection

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> HTTP tunneling -> Procedure with HTTP connection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If a Web Client is started, it connects to the Primary Server via the zenonWeb Server:

  1. The user starts the browser and opens the project entry page.
  2. The project entry page instigates the browser to start the Web Client with the pre-defined HTTP tunneling configuration.
  3. The Web Client makes 3 HTTP connections (control, data and file synchronization connection) to the Web Server:
    1. A connection ID is requested from the Web Client.
    2. The Web Server sends a free connection ID if one is available. The ID sent is entered into the list of connection IDs issued. This happens so that no ID can be issued twice and to transfer the HTTP connection to a TCP connection.
    3. The network init packet is sent to the Web Server via the HTTP connection.
    4. The Web Server checks to see if this Web Client is already in the list of active clients. If the client is new, a check is made to see if the maximum number of clients has already been reached. If the client connection can be accepted, a TCP connection is made in Runtime and the init packet is forwarded. The accepted client connection and the server connection that has been made are mapped to each other until the connection has ended: Data from the client connection is forwarded via the server connection and vice versa.
  4. Data exchange:
    1. The Web Server works as a protocol translator between TCP and HTTP and buffers the messages.
    2. Data from Runtime for the Web Client is buffered on the server. The Web Client calls this up by means of GET requests.
    3. Data from the Web Client for Runtime is sent by the Web Client by means of a POST request and forwarded to Runtime by the Web Server.
  5. If the Web Client is ended in the browser (browser is closed or the project entry page is left), the connections to the Web Client are disconnected.
    1. The web client sends a network-end package to Web Server. The Web Server forwards this to Runtime, ends the connection and clears the occupied resources (working memory, ports, connection ID …).
    2. When the client is cleared, an additional HTTP end packet is sent to the Web Server, to ensure that the connection ID was removed from the list.


Supported web browsers:

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Supported web browsers:

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon Web Client supports the following browsers:

  • Microsoft Internet Explorer

    Attention: zenon Web Client, as a 32-bit application, must be used with the 32-bit version of Internet Explorer.
    The 64-bit version cannot be used.

  • Mozilla Firefox
  • Google Chrome up to version 41
    Attention: From version 42, Google Chrome no longer supports NPAPI plugins. Chrome can thus no longer be used as a zenon web client from version 42.
  • Apple Safari

It is recommended that you always use the most up to date version.

info Information

The browser for zenon Web Client must support one of the following operating systems:

  • Windows 7
  • Windows 8 and 8.1
  • Windows Server 2008 and 2008 R2
  • Windows Server 2012

Other operating systems, such as Windows CE, Linux or others are only usable in combination with a terminal server.

Browser start:

The project entry page decides the basis of browser identification, if and how the Web Client is started:

  • Internet Explorer: Start as ActiveX component
  • Firefox: Start as plug-in
  • Chrome: Start as plug-in
  • Safari: Start as plug-in
  • Other browsers or non-supported versions: An error message is displayed; the zenon Web Client does not start

Supported versions:

Browser

From version

Remark

Microsoft Internet Explorer
  • 6.0
  • Recommended from: 8.0
  • 32-bit version only
  • Note the information on memory protection for IE 8/9

Mozilla Firefox
  • 3.6:4 Plug-in container must be activated manually
  • Recommended from: 4.0 (plug-in container is activated as standard)
  • Note the information on configuration and keyboards

Google Chrome

  • 1.0
  • up to version 41
  • recommended: from version 7.0

Apple Safari
  • 3.0
  • recommended: from version 5.0

Mozilla Firefox configuration

For all versions of Mozilla Firefox before version 4, it is necessary to activate the plug-in containers manually.

To do this:

  1. Enter the following in the address line: about:config
  2. The browser may bring up a warning: The guarantee may be invalid here!
  3. Click on the button: I'll be careful, I promise!
  4. Navigate to the dom.ipc.plugins.enabled property
  5. This must be set to true
  6. To set this status:
    1. Right-click on the property
    2. select, in the context menu, the entry: Switching
  7. Close the browser

Note: If these settings are not made, the zenon Web Client in Firefox cannot communicate with Runtime. Screens are displayed, but all variables are displayed as offline; screen elements thus have no values and are highlighted in blue.


Folder for Runtime files

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Folder for Runtime files

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon Web Server saves the Runtime files in the %Temp%\zenWebCli folder as standard.

%Temp% signifies the temporary file folder under Windows. This is saved individually for each user and can be changed under System control-> System -> Advanced system settings-> Environment variables.

Note: The %Temp% folder is user-dependent. Each Windows user thus loads the Runtime files from the Primary computer.

You can define any desired folder as the storage location for the Runtime files with the zenon6.ini entry:

  1. Open the zenon6.ini file.
  2. Navigate to the section

    [PATH]

  3. Create or modify the entry

    WEB_PROJECT_PATH=


VSTA and VBA with zenon Web Client, zenon Web Server and zenon Web Server Pro

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> VSTA and VBA with zenon Web Client, zenon Web Server and zenon Web Server Pro

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Note: VBA is supported by zenon in zenon Web Server and zenon Web Server Pro. However for security reasons, we recommend that you switch to VSTA. You can find out further information on VBA in the macro list.

VSTA is supported by zenon with different versions of zenon Web Server und zenon Web Server Pro.

Function

zenon Web Client with zenon Web Server Standard

zenon Web Client with zenon Web Server Pro

Show VSTA macro dialog

+

+

Execute VSTA macro

+

+

Open VSTA editor

-

-

VSTA events

+

+

Remark
  • No values are written to zenon variables.
  • Windows messages boxes can be opened.
  • Compiling and debugging is not possible.
    To do this, a standard zenon Runtime must be used.
  • All zenon VSTA functionalities are available in full.
  • Compiling and debugging is not possible.
    To do this, a standard zenon Runtime must be used.

Installation:

For the use of VSTA

  • The following applications must be present on the system or installed manually:
    • Microsoft Visual Studio Tools for Applications 2.0 (VSTA 2.0)
    • Microsoft .NET Framework 3.5

    Both programs are on the installation medium for zenon Web Server and/or zenon 7.20.

  • VSTAIntegration.dll must be in the zenon program directory.
    This is installed automatically when zenon is installed.

INI entries:

The following entries must be set in zenon6.ini:

[VSTA]

ON=1

CSHARP=1

[VBA]

EIN=1

EVENT=1


Screen resolution and monitor administration

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Screen resolution and monitor administration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon monitor administration is available in zenon Web Client with limitations.

Important for configuration: The automatic adaptation of the resolution to the client cannot be used for web use. For this reason, the screen size must be set accordingly during configuration. zenon Web Client uses the screen size set for the project as standard: Project properties -> Graphical design -> Monitor administration -> Click on the ... button -> Tab General - Screen resolution.

The resolution can be scaled using the zenon Web Client setting. For details, see Configuration of the example page chapter.

With the help of the zoom property, zenon Web Client can be zoomed to the size of an ActiveX element.

Size in the browser:

The browser always needs some screen area for menus and scroll bars. So the area, which is available for the zenon Web Client, is always smaller than the defined monitor resolution. If you would like to have a full screen of the project in the browser, you must set the screen size as smaller than the screen size on the zenon Web Client.

For example:
Monitor resolution on zenon Web Client PC: 1024x768 pixel
Screen size in monitor administration: 800 x 600.

info Information

If you want to use the multi-project administration on the zenon Web Client, the screen size has to be the same for all projects!

Multi-monitor system:

On a multi-monitor system, the process screens are opened as defined in the profile, on different real monitors. When using a Web Client, these are then outside of the visible area, but can be reached by scrolling.

Recommendation: Configure the monitor profile in such a way that all monitors are on Main monitor mapped; you then have access to all monitors.

info Information

The standard profile is always loaded by default on the zenon Web Client. However, you can stipulate a different monitor profile using the SCREENPROFILE= entry in zenon6.ini.


Implementing the zenon Web Server in the internet environment

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Implementing the zenon Web Server in the internet environment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Note: If a web client is to contact a web server via the Internet, it is strongly recommended that a VPN connection is set up between the network with the Web Client computer, the network with the Web Server computer, and the Primary Server.

To integrate zenon Web Server into an internet environment:

  • Any firewall that may be present must be configured accordingly:
    • Port 1102 on the firewall must be open for incoming packages, so that a zenon Web Client can access a zenon Web Server and therefore access a Primary Server.
    • NAT (Network Address Transformation) must run on the gateway station. NAT transforms the internal LAN address to the address of the gateway station. If, for example, somebody surfs inside the LAN, it always looks as if the gateway station were sending the requests from outside.
    • Static IP address for zenon Web Server:
      The firewall on the gateway station has to be configured in such a way that all incoming packages for port 1102 are automatically sent to the station with the zenon Web Server. That means: This station must have a static IP address.
  • The project entry page has to be adapted so that zenon Web Client knows which station to access in the internet: The amendment is made in global_vars.js or, for older versions, in project_A_X.html (X stands for the language version, such as G for German) :
    • Under Webserver VALUE= WEB-SERVERNAME, the computer name of the gateway station (the station visible from the internet and not the computer name of the real zenon Web Server) has to be entered. The real zenon Web Server is not visible from the internet. The gateway station then automatically forwards the requests from the zenon Web Client to port 1102, then automatically to the real zenon Web Server.


Error treatment

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Error treatment

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Known error messages or execution errors:

  • Crash after browser refresh
  • ActiveX control failed to load
  • ActiveX control not installed correctly
  • Exceptional Web Client error in Internet Explorer 8
  • HTTP error messages
  • Init Runtime Error
  • Keyboards in Firefox
  • Max. clients


Crash after browser refresh

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Error treatment -> Crash after browser refresh

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Using Internet Explorer 6 with the zenon Web Client can lead to Internet Explorer crashing if the browser refresh button is clicked. We therefore recommend that you do not use the refresh button.

This button causes a complete closure and restart of the zenon Web Client. This means, that the connection to the Runtime server is closed and has to be re-established by the Web Client.

Error 101

If zenon Web Client was already installed on the client computer, the following error message can be displayed when zenon Web Client connects to zenon Web Server or Runtime:
Error 101
Project XXX was edited with version XXX and cannot be opened here
In this case:

  1. Uninstalling Web Client
  2. Restart the computer
  3. New installation of zenon Web Client


ActiveX control failed to load

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Error treatment -> ActiveX control failed to load

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If the browser displays an Init Runtime Error, there are several possible reasons for that. The most probable thing:

  • The browser's security settings prevent the correct execution of the ActiveX control.


ActiveX control not installed correctly

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Error treatment -> ActiveX control not installed correctly

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If the browser only displays an X, instead of Runtime, after the project start page has been called up:

  • The ActiveX control for zenon Web Client was not installed correctly
  • The wrong version of zenon Web Client is installed


Exceptional Web Client error in Internet Explorer 8

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Error treatment -> Exceptional Web Client error in Internet Explorer 8

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Error

The Web Client is ended with an exceptional error if VSTA or VBA is executed in the project in the project.

Reason

Microsoft Internet Explorer has a setting for memory protection from version 8. If this is active, executing VBA leads to an exceptional error and Internet Explorer ends. VSTA always activates VBA too.

Solution

Deactivate the memory protection in Internet Explorer under:

Extras->Internet options->Advanced->Enable memory protection to help mitigate online attacks


HTTP error messages

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Error treatment -> HTTP error messages

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Error messages and what they mean:

Entry | Level | Description
NetSrv Error Do Send HTTP failed! HTTP-Status: [HTTP-Status] | ERRORS | The HTTP Web Server has responded to an HTTP POST request with an error.
NetSrv Error Do Send HTTP failed! | ERRORS | The HTTP POST request failed (time-out, for example timeout).
NetSrv Error Do Send HTTP Server failed! Data Management Class Error! | ERRORS | An error occurred when saving a message in the buffer to the HTTP Web Server. The error occurred in the data management class.
NetSrv Error Do Send HTTP Server failed! | ERRORS | An error occurred when saving a message in the buffer to the HTTP Web Server. The error occurred in the buffer list.
NetSrv Error Do Recv HTTP failed! HTTP status: [HTTP-Status] | ERRORS | The HTTP Web Server has responded to an HTTP GET request with an error.
NetSrv Error Do Recv HTTP failed! | ERRORS | The HTTP Get request failed (time-out, for example timeout).
NetSrv Error Do Recv HTTP Server failed! Data Management Class Error! | ERRORS | An error occurred when reading a message in the buffer to the HTTP Web Server. The error occurred in the data management class.
NetSrv Error Do Recv HTTP Server failed! Buffer Too Small! | ERRORS | The packet read from the buffer list is too large for the data buffer. Note: Due to the uniform maximum packet size, which also serves as a buffer length definition, this should never occur.
NetSrv Error Do Recv HTTP Server failed! Error While Copying Data Into Buffer! | ERRORS | An error occurred when copying data from the buffer list.
Error Out Of Memory While Adding Data to HTTP GET Response | ERRORS | Creation of a memory area was not possible when compiling an HTTP response at the HTTP Web Server.
Error On Adding Data to HTTP GET Response | ERRORS | An error occurred when copying data from the buffer list in the HTTP response.
HTTP Send Get Response Failed: [Status] | ERRORS | Sending of a response to an HTTP GET request has failed. The status code is a system error code (can be looked up in the MSDN library).
Error Out Of Memory While Receiving Data from HTTP POST | ERRORS | Creation of a memory area was not possible when reading off an HTTP POST response at the HTTP Web Server.
Error on Receiving Data from HTTP POST [Status] | ERRORS | Reading off data from the HTTP-POST request has failed. The status code is a system error code (can be looked up in the MSDN library).
Error Data Block Of HTTP Post Request Too Large | ERRORS | The data from the request received exceeds the defined maximum packet size.
HTTP Send Post Response Failed: [Status] | ERRORS | Sending of a response to an HTTP POST request has failed. The status code is a system error code (can be looked up in the MSDN library).
Error Out Of Memory While Parsing HTTP Request | ERRORS | Creation of a memory area was not possible when forwarding an HTTP response to the relevant thread.
Memory Error on Creating Receive Buffer | ERRORS | Creation of a memory area when creating the HTTP receipt buffer was not possible.
Error on Creating HTTP Request Event | ERRORS | Creation of events for the receipt of HTTP requests has failed.
Error While Waiting For HTTP Request: [Status] --> Exiting Listening Thread | ERRORS | An error occurred when waiting for an HTTP request. The status code is a system error code (can be looked up in the MSDN library).
Unexpected Result While Waiting For HTTP Request: [Status] --> Exiting Listening Thread | ERRORS | waiting for an HTTP request provides an unexpected result. The status code is a system error code (can be looked up in the MSDN library).
HTTP Request Without ID Received | ERRORS | The connection ID was not present in the HTTP request.
Error on Extracting HTTP-Request-ID From URL | ERRORS | The connection ID of the HTTP request cannot be read off.
Error: Closing HTTP Connection ID [ID] Could Not Be Resolved | ERRORS | An attempt was made to close a connection that does not exist or was already closed. This error is less critical because the request to delete the connection ID when clearing connection resources can be made more than once after it has ended.
HTTP Request With Incompatible ID Format Received | ERRORS | The connection ID in the HTTP request does not have the expected format.
Could Not Assign New HTTP ID Because The Map Is Full | ERRORS | A new connection could not be accepted because there is no more space in the connection list. The list contains space for over 4.2 billion connections, so this message should therefore never appear.
Error During HTTP Accept | ERRORS | An error occurred when accepting the HTTP connection.
Error On Sending HTTP ID: [Status] | ERRORS | The sending of an HTTP response with the connection ID for the new client connection has failed. The status code is a system error code (can be looked up in the MSDN library).
Error: HTTP Connection ID [ID] Could Not Be Resolved | ERRORS | The connection ID of the HTTP request cannot be resolved.
Error: HTTP Request Could Not Be Assigned To The Socket | ERRORS | the HTTP request could not be forwarded to the relevant thread.
Unsupported HTTP-Request Received | ERRORS | An unsupported HTTP request was received. GET and POST requests are supported.
Error While Receiving HTTP Request: [Status] --> Exiting Listening Thread | ERRORS | An error occurred when receiving an HTTP request.
Error on Removing HTTP Connection ID From The Map! | ERRORS | An error occurred when removing a connection ID from the list. Connection IDs are removed if a connection is closed.
Removing HTTP Connection ID [ID] From The Map! | DEBUG | The connection was closed and the ID was removed from the list.
Error on Removing Non-Active HTTP Connection ID From The Map! | ERRORS | An error occurred when removing an inactive connection ID. A connection is then active if no HTTP requests have been received for 5 minutes. Such a connection should really already be removed due to the lack of a watchdog.
Removing Non-Active HTTP Connection ID [ID] From The Map! | DEBUG | The connection ID was removed from the list because the connection is inactive. A connection is then active if no HTTP requests have been received for 5 minutes. Such a connection should really already be removed due to the lack of a watchdog.
Error While Waiting for HTTP Connection Map Check [Status]! | ERRORS | The thread to check the connection ID established an error when waiting for the next cycle and is ended. The status code is a system error code (can be looked up in the MSDN library).
NetSrv Accept HTTP Client Socket Error On Starting HTTP Reply Thread | ERRORS | The thread to respond to HTTP requests could not be started.
NetSrv Info Accept HTTP Client IP:[IP-Adressr]:[Port] Ok | DEBUG | The HTTP connection has been accepted successfully.
NetSrv Memory Error Do Recv HTTP failed! | ERRORS | An error occurred due to too little memory being available when receiving data via HTTP tunneling.

LOG entries from CNSBlockingSocketExceptions

Level: Always ERRORS

Entry: Exception text | Description
Connect: HTTP error | The HTTP Web Server has responded to a connection ID request with an error.
Connect: ID-Data did not have the expected Format | The connection ID provided by the HTTP Web Server does not have the expected format.
Connect: Server denied HTTP ID | The HTTP Web Server has rejected the granting of a connection ID.
Connect: Error during ID-Acquisition | An error occurred when requesting a connection ID (a time-out, for example).
HttpInitialize Failed | HTTP server API could not be initialized
HttpCreateHttpHandle Failed | The HTTP request list could not be created
HttpAddUrl Failed | The server could not enter list mode


Init Runtime Error

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Error treatment -> Init Runtime Error

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If the browser displays an Init Runtime Error, there are several possible reasons for that:

  • Runtime is not active on Runtime Server
  • SERVER NAME in Globalvars.js is spelled or defined incorrectly (always use capital letters).
  • PROJECT NAME in Globalvars.js is spelled or defined incorrectly (always use capital letters).
  • The naming resolution between the Web Server and the Primary Server is not present in the network.
  • The zenon Web Server is not started.

You may find notes on the causes of errors in the zenNetErr.txt file. This logs network information.


Keyboards in Firefox

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Error treatment -> Keyboards in Firefox

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If individual keyboards do not work correctly in Firefox, consider the following note:

attention Attention

Individually adapted screens of type Keyboard may under certain circumstances not work properly with the Mozilla Firefox browser.

Reason: Mozilla Firefox loads new windows in the background without putting the focus on them. Depending on the project configuration, individually-adapted keyboard screens are closed as soon as they are no longer in focus.

Solution: Use a different browser such as Microsoft Internet Explorer or Google Chrome, or use the "Close on loss of focus" frame option".

Automatic keyboards are not affected!


Max. clients

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Error treatment -> Max. clients

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Message to the zenon Web Client.

More clients than are licensed are attempting to connect to the zenon Web Server.


Behavior of Web Client in the event of a loss in connection

Manual -> zenon Web Server, Web Server Pro and Web Server Pro Light -> Error treatment -> Behavior of Web Client in the event of a loss in connection

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the event of a loss of the connection to the Primary Server, the zenon Web Client uses the next connection configuration.

Possible reasons for a loss of connection:

  • The Primary Server fails and the Primary Standby Server takes on its role.
  • The Primary Server comes back and resumes its role again (= the Primary Standby Server end the connection).
  • The Web Server that is currently being used fails.

The connection configurations are gone through in this sequence (from the start again once the end has been reached):

  1. Web Server and Primary Server
  2. Web Server and Primary Standby Server
  3. Web Standby Server and Primary Server
  4. Web Standby Server and Primary Standby Server

If a Web Standby Server has been configured but cannot be contacted, the following happens if the Primary Server comes back:

  1. The Web Client is currently in connection configuration 2 and loses the connection because the Primary Server takes over the process management again.
  2. The Web Client attempts to connect with connection configuration 3 again, but times out because the Web Standby Server cannot be reached.
  3. The Web Client attempts to connect with connection configuration 4 again, but times out because the Web Standby Server cannot be reached.
  4. The Web Client attempts to connect again with connection configuration 1, which also works. The web client is online again.

In the event of a failed connection, the Web Client cannot establish whether it is the Web Server (or the Web Standby Server) or the Primary Server (or Primary Standby Server) that cannot be contacted, which is why these four connection possibilities must be gone through.


zenon Logic

Manual -> zenon Logic

zenon Logic is the programming environment in accordance with IEC 61131 included in zenon. It is available as Editor and Runtime (Soft-PLC).

tutorial License information

Must be licensed in Editor and Runtime.

Note: 8 TAGs are included in the standard license. For details about licensing see chapter Licensing.


Basics zenon Logic Workbench (IEC 61131-3)

Manual -> zenon Logic -> Basics zenon Logic Workbench (IEC 61131-3)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon Logic is an IEC 61131-3 programming environment for different target systems with zenon Logic Runtime kernel. In the case of zenon, the zenon Logic Runtime kernel is designed as a soft PLC for PC and CE platforms.
With the zenon Logic development environment - the Workbench - PLCs can be engineered and programmed in the five defined programming languages of IEC 61131-3.

Context menu Project manager

Menu item | Action
New zenon Logic project | Opens the assistant to create a new zenon Logic project.
Import XML... | Imports entries from an XML file. Attention: At the XML import you must deactivate online change so that the reload of the zenon Logic variable works.
Import external zenon Logic project... | Opens the dialog to select a zenon Logic project folder.
Editor profiles | Opens the context menu with pre-defined Editor profiles.
Help | Opens online help.


General information on zenon Logic help

Manual -> zenon Logic -> Basics zenon Logic Workbench (IEC 61131-3) -> General information on zenon Logic help

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This help manual provides a quick introduction to the use of zenon Logic in conjunction with the integrated solution with zenon. This manual does not provide an instruction into computer languages, functions and function blocks. For this use the extensive help included directly in the zenon Logic Workbench> (IEC 61131-3 programming environment).

The zenon Logic Workbench provides an extensive help functionality. In order to access this help function, open the entry Help in the menu of the zenon Logic Workbench or click here. In order to access a help chapter about a certain topic (e.g. function block), select it with a mouse click and then press F1.

The in zenon integrated zenon Logic Workbench has not TAG limitation independent of I/O or TAG extension of the zenon Editor.


zenon Logic General

Manual -> zenon Logic -> Basics zenon Logic Workbench (IEC 61131-3) -> zenon Logic General

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon Logic is an IEC 61131-3 programming environment for different target systems with zenon Logic Runtime kernel. In the case of zenon, the zenon Logic Runtime kernel is designed as a soft PLC for PC and CE platforms.

zenon Logic Workbench

The zenon Logic Workbench is the tool for programming the zenon Logic PLC. The zenon Logic Workbench is started in the zenon Editor. All five IEC 61131-3 predefined languages are available.

Abbreviation | Long form of the language
SFC | Sequential Function Chart
FBD | Function Block Diagram
LD | Ladder Diagram
ST | ST – Structured Text
IL | Intstuction List

IEC 61131-3

Part three of the IEC 61131 descubes the syntax and semantic of compuer languages for PLCs which have been defined in part 1 of the IEC 61131.

zenon Logic Runtime

The zenon Logic Runtime is the target system and executes the compiled code of the zenon Logic Workbench. The zenon Logic soft PLC is available for the PC and for Windows® CE platforms. Beside the soft PLC there are also hard PLCs, which have implemented the zenon Logic Runtime kernel as OEM software. The manufacturers of these hardware PLCs can be found on www.copalp.com.

You can find more information about zenon Logic here: zenon Logic Runtime (Soft PLC)


zenon Logic detail view toolbar and context menu

Manual -> zenon Logic -> Basics zenon Logic Workbench (IEC 61131-3) -> zenon Logic detail view toolbar and context menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Tool Bar

Parameters | Description
New zenon Logic project | Opens the dialog to create a new project, create it in the list and opens the zenon Logic Workbench with the new project.
Open zenon Logic project in Workbench | Opens the selected project in zenon Logic Workbench.
Delete | Deletes selected entries after a confirmation from list.
Import external zenon Logic project | Opens dialog to select the zenon Logic project files to be imported.
Import XML | Opens dialog to select the XML file to be imported. Attention: At the XML import you must deactivate online change so that the reload of the zenon Logic variable works.
Remove all filters |
Edit selected cell | Opens the selected cell for editing. The binocular symbol in the header shows which cell has been selected in a highlighted line. Only cells that can be edited can be selected.
Replace text in selected column | Opens the dialog for searching and replacing texts.
Properties | Opens the Properties window for the selected entry.
Import XML | Imports entries from an XML file.
Remove all filters | Removes all filter settings.
Help | Opens online help.


First steps with zenon Logic in zenon

Manual -> zenon Logic -> Basics zenon Logic Workbench (IEC 61131-3) -> First steps with zenon Logic in zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Here the first steps in order to create a zenon Logic project in zenon are explained. In addition information is given on how to configure and edit the project in zenon. If you work for the first time with zenon Logic in zenon, we recommend you follow this manual.


Create a zenon Logic project in a zenon project

Manual -> zenon Logic -> Basics zenon Logic Workbench (IEC 61131-3) -> First steps with zenon Logic in zenon -> Create a zenon Logic project in a zenon project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To create a new zenon Logic project:

  1. right click on node zenon Logic (IEC 61131-3) or in the detail view
  2. select in the context menu or in the tool bar command New zenon Logic project...
  3. The configuration dialog is opened
  4. give it a valid name
  5. select the desired driver
    • straton driver are automatically configured
    • for IEC driver the configuration dialog is opened after the dialog is closed
  6. create the project by clicking on Finish

info Information

You adjust the properties of the zenon Logic projects in the zenon project in the properties window of the zenon Editor. You will find a description of the single properties in the property help.

You can change the settings of the zenon Logic project in its project settings. In order to do this open the project settings in the Workbench under Project/Settings....

Notes for project configuration

Note when configuring the project:

General:

  • In the zenon Editor, no zenon Logic projects with the name __Global can be created.
    Note: Projects with the name __Global that already exist are not shown.
  • zenon Logic Workbench creates, for each zenon Logic project, a project with the name <Projectname>__Global. These projects are not visible in the zenon Editor. They are also not deleted if the attendant zenon Logic project is deleted.

Distributed engineering:

  • In the zenon Logic Workbench, lines can be created in the All projects node MultiSpy and the global Binding Editor can be called up. The following is applicable for these settings: They are
    • Not saved as multi-user
    • Not transferred to the project server
    • Removed again in the next synchronization
  • If new zenon Logic projects are created in the zenon Logic Workbench via File -> Add new project, the following is applicable: You will
    • Not transferred to the project server
    • Deleted again in the next synchronization

Attention: Multi-user zenon Logic projects can only be created using the zenon Editor.

info Information

In general you should only create zenon Logic projects with the zenon Editor. This is because the attendant drivers are also automatically created in the zenon project.

New dialog project

Parameters

Description

Name

Freely definable name for the zenon Logic project.

Note: The Name

  • consists of alphabetic characters
  • must not exceed 15 characters
  • must not be empty
  • must only contain valid characters:
  • all numbers and special characters such as \ / , ; ß ä ö ü : * ? " < > | ( )
  • a dot may only be used within the name not at the beginning of the name
  • Button Finish is only active if an valid name was entered.

Driver

Selection of the driver. You have the choice between:

  • stratonNG.(default):
    creates a new connection with the correct project name, the zenon Logic Runtime port and the IP address 127.0.0.1
  • straton32:
    creates a new connection with the zenon Logic Runtime port and the IP address 127.0.0.1
  • IEC870:
    opens configuration dialog
  • IRC850:
    opens configuration dialog

This selection defines the eventual Runtime communication between zenon Logic and zenon. In addition the creation of the operating and monitoring (O and M) variables is based on this:

  • name based at the STRATON driver,
  • address bassed at the IEC driver

Finish

Creates the new zenon Logic project.

Cancel

Cancels project creation

Help

Opens online help.

Driver selection

Decision help for the driver selection:

Driver

Properties

straton32 driver:

Ethernet TCP/IP based.

Advantages:

  • can be used cyclic or spontaneous (on change)
  • supports complex data types (structure data types or arrays)

stratonNG driver:

Defautl driver for zenon Logic projects. Fulfills all requirements just like straton32.

In addition:

  • enables several connections with one driver to several Runtimes at the same time (recommended for using with Windows CE))
  • works more performant ant than the straton32 driver

IEC870 driver:

It is mostly used in the infrastructure automation.

Properties:

  • can be operated serial (-101) or over Ethernet TCP/IP (-104)
  • Data traffic is generally spontaneous (on change)
  • complex data types are not supported

IEC850 driver:

Successor of the IEC60870 standard and is completely object-orientated.

For information about the configuration of the driver see the respective help of the driver:

  • straton32 driver: straton32
  • stratonNG driver: stratonNG
  • IEC870 driver: IEC870
  • IEC850 driver: IEC850

attention Attention

If you have selected a driver once, you cannot change it afterwards.

Exception: Changing from the straton32 to the stratonNG driver is not possible.

Change driver

To make a driver change from starton32 to stratonNG:

  • select the detail view of node Variables/Driver of the zenon Logic project with the straton32 driver
  • select Change driver in the context menu
  • the dialog for the selection of the driver is opened
  • you can only select the stratonNG driver
  • select the driver
  • close the dialog
  • the configuration is taken over in the zenon Logic project


Editing a zenon Logic project

Manual -> zenon Logic -> Basics zenon Logic Workbench (IEC 61131-3) -> First steps with zenon Logic in zenon -> Editing a zenon Logic project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

With a double click on the project or the context menu, you can open an existing zenon Logic project for editing. Alternatively you can click the corresponding icon in the toolbar in the details window.


Deleting a zenon Logic project

Manual -> zenon Logic -> Basics zenon Logic Workbench (IEC 61131-3) -> First steps with zenon Logic in zenon -> Deleting a zenon Logic project

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

To delete a zenon Logic project:

  1. select menu item delete in the context menu of the project or in the tool bar

    (Multi-select is possible)

  2. confirm the confirmation message whether you really want to delete the project
  3. select whether you want to delete the driver of the project

    (When simultaneously deleting several projects, the deleting the driver is prompted for each project.)

attention Attention

When you delete the driver, all variables linked to the driver in zenon are also deleted.


Design of the Workbench

Manual -> zenon Logic -> Basics zenon Logic Workbench (IEC 61131-3) -> First steps with zenon Logic in zenon -> Design of the Workbench

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon Logic Workbench can be divided in the following areas:

Range | Description
1 | In this section documents are displayed and edited (programs, watch lists, ...).
2 | The workspace: Documents are created and opened in this list.
3 | The output window displays messages and provides diagnosis tools.
4 | In the variable editor variables and instances are declared.
5 | The property tab and the Z arrangement are used for the engineering of the graphics documents.
6 | The tab Libraries lists all available functions and function blocks
7 | The tab Spy list displays the online values of selected variables during the debugging.
8 | The tab Definitions displays all definitions.
9 | The tab Graphics lists al graphical objects.

Each section (except section 1) can be shown and hidden with commands from the menu Views.

In the central area you will find the documents of the workspace. If several documents are opened at the same time, you can switch between the different documents using the tab at the bottom. With button X in the header the active document can be closed.

The variable editor and the document area in the center can be maximized at any time with the corresponding button (blue symbol with white line) or a double-click on the header.

If serveral documents are open in the central area, one of these can be fixed in the top or left part. In order to do this right click the corresponding tab an select Fix. With the same menu you can unfix the document at any time and fix another one:


Variable handling

Manual -> zenon Logic -> Basics zenon Logic Workbench (IEC 61131-3) -> Variable handling

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The intelligent integration of zenon Logic in zenon offers considerable advantages in engineering PLC and SCADA projects. The O&M variables (operating and monitoring) from the PLC system are available in zenon with just a few mouse clicks. When changing the variable (name, datatype, ...) these changes are immediately passed on the other system.

The advantage of the integration:

  • Easy handling of O&M variables
  • Immediate alignment of changes
  • Saving of labor because of omission of import/export
  • Increased quality by minimizing causes for errors

attention Attention

External UDFBs from other zenon Logic projects are not part of the zenon Logic project and therefore not available in zenon.


Create O and M variables in zenon Logic

Manual -> zenon Logic -> Basics zenon Logic Workbench (IEC 61131-3) -> Variable handling -> Create O and M variables in zenon Logic

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

All variables created in the zenon Logic Workbench can be marked as O&M (operating and monitoring) variables:

  • Local program variables
  • Global variables
  • Retain variables (=remanent variables)
  • Array variables
  • Structure variables
  • UDFB instances (User Defined Function Block)

Note: Variables of data type TIME cannot be declared as O&M variables.

attention Attention

We recommend that when using UDFB instances as O&M variables to administrate only one zenon Logic project in a zenon project.

If two or more zenon Logic projects are administrated in zenon, the as O&M marked UDFBs appear as structure data types.

Highlight variables as O&M

In order to do this the following steps are necessary:

(Refer to the online help of the zenon Logic Workbench for the exact steps to create a variable in zenon Logic.)

  1. Right click on a variable in the variable list.
  2. Select Properties from the context menu.
  3. Activate checkbox Embed symbol in the following dialog.
  4. Change the profile in the combo box from None to STRATON (*Operating and Monitoring for zenon*).
  5. Click on OK.

Now the O&M variable has been entered in the zenon variable list.

attention Attention

As soon as a zenon Logic variable is declared as O&M variable, you must not edit it as text in the Workbench!

This leads to the loss of variable declarations.

The O&M variable is displayed with a prefix in zenon. The prefix has the following structure:

<zenon Logic project name>/<zenon Logic program name or global or retain>/<variable name>

attention Attention

Variables have a character length limitation. Including prefix the variable name must not be longer than 128 characters.

Activate in variable list

You can set the profile and the flag directly in the variable list of zenon Logic. Thus you do not have to open the context menu and the dialog.

Mark the line Properties of the corresponding variable. Press Ctrl+F12. Thus the profile zenon Logic is displayed in this line. In addition you must activate the checkbox for embedding the symbol via double click or Enter in column Symb..

attention Attention

The checkbox Embed symbol must be activated. Variables for which this checkbox is not active are not able to communicate with zenon using the STARTON driver and will not supply any values.

Additional attributes of the variable

The additional attributes Identification and Description of a variable are also displayed in zenon when you select the profile STRATON (*Operating and Monitoring for zenon*). In zenon the contents of identification and description can be found in the variable properties Identification and Resource label.

Arrays and structure variables

If arrays or structure variables are marked with the profile STRATON (*Operating and Monitoring for zenon*), they are also displayed in the variable list in zenon. You must however activate the desired elements of the variable.

attention Attention

If a O&M variable is an array, you must take care when setting initial values.

Recommendation: Arrays with initial values should not be declared as O&M! If it is inevitable, the string describing the initial value must not be longer than 1024 characters.

UDFB instances

  1. Input variables at UDFB instances are not available via the integrated solution in zenon.
  2. In zenon variables of an UDFB instance cannot be created. This is only possible if an instance of the UDFB is created in zenon Logic and the zenon Logic profile is set.

    UDFB instances which are marked with profile zenon Logic (*Operating and Monitoring for zenon*), they are not automatically available in zenon. In case you want them to be available, you must activate this functionality manually with the help of the following entry in file K5DBXS.INI. In file K5DBXS.INI scroll to section [XS] and enter ShareUDFBDatatype=1 .

    If you deactivate this entry, existing UDFB data types in a project are still modified. However no new UDFBs are created.

Hardware IO declarations

zenon Logic IO variables can be used zenon if in the zenon Logic Workbench they:

  • have a profile
  • have an alias name; this name is used in zenon instead of %IX0.0 (board type, board index, bit number)
    An alias is necessary if the zenon Logic profile is used and property Embed symbol was activated. In this case the variable is also available in zenon (Editor and Runtime).

Note: If an I/O group is deleted in zenon Logic, the variables of the I/O board with zenon Logic profile are also deleted in zenon.

Attention:

  • IO variables cannot be renamed in zenon.
  • IO variables for zenon Logic IO cards cannot be created in zenon.
  • The data type of IO variables should not be changed in zenon: Changes are not adopted in the zenon Logic Workbench.
  • Changes to the hardware IO declaration should always be carried out in zenon Logic. In zenon no new variable for the straton32 driver can be created as hardware I/O variable for zenon Logic.


Create O and M variables in zenon

Manual -> zenon Logic -> Basics zenon Logic Workbench (IEC 61131-3) -> Variable handling -> Create O and M variables in zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

O&M (operating and monitoring) variables for the soft PLC zenon Logic can also be declared in zenon. In order to do this create a variable in zenon as usual:

attention Attention

Take care that the naming convention is IEC 61131-3 compatible (no special characters, ...); otherwise the button Finish will not be available in the dialog. See also: Variable names

info Information

The variables declared in zenon are always entered in the Global area of the variable list in zenon Logic.

Changes to variables of a zenon Logic driver in zenon

If variables of a driver which is linked to a zenon Logic project are deleted:

  • a change recognition in the zenon Logic project is carried out
  • the zenon Logic Workbench connection to the Runtime asks whether the project should be recompiled

This behavior is regardless of whether the changes affects the zenon Logic project.


Using zenon variables in zenon Logic

Manual -> zenon Logic -> Basics zenon Logic Workbench (IEC 61131-3) -> Variable handling -> Using zenon variables in zenon Logic

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

It is very easy to further process variables from PLC systems such as e.g. Siemens S7 or Beckhoff TwinCAT in zenon Logic, variables which were read in by the according zenon drivers in zenon.

One possibility to realize this functionality is the allocations (see Allocations). The variable from the PLC (e.g. S7 ) is linked to a zenon Logic variable with an allocation. In this case only a unidirectional communication is possible.

PLC variables (e.g. from a S7) can be exchanged between zenon and zenon Logic via a shared memory connection bidirectionally (!), easier and quicker . In the properties of the PLC variable the flag Externally visible has to be set to make the variable available in the zenon Logic Workbench.

As soon as this flag is set, the variable is displayed in the variable list of the zenon Logic Workbench.

attention Attention

Regard interactions with property Hysteresis:
If a Hysteresis was configured for the zenon variable, the value in zenon Logic does not match the value in the PLC. It is also possible that it does not match the value in zenon:

  • If the value changes in the PLC and stays within the configured hysteresis, it is not communicated to the zenon Runtime and therefore also not to zenon Logic.
  • If the value is changed by the user in zenon (e.g. via a function) and the value stays within the configured hysteresis, the value remains the same in zenon and in zenon Logic but it changes in the PLC.
  • If the value is changed in zenon Logic and stays within the hysteresis, the value in the PLC and in zenon Logicchanges. It remains however the same in zenon.
    If in this situation the value changes in the PLC and stays within the hysteresis, three different values exist.
    one in the PLC, one in zenon and one in zenon Logic.

Such a variable is especially marked in zenon Logic, as it cannot be changed in zenon Logic. Changing the variable here would lead to problems, as the source of the variable is the PLC programming environment in the external PLC (e.g. S7).

attention Attention

Be careful with the variable name! The name of the variable from an external PLC has to be IEC 61131-3 compatible. Also see Variable names.

In zenon Logic a so-called I/O driver - shared memory driver - must be loaded in order to make the communication for such variable possible in the Runtime.

In order to do this open the fieldbus configuration in the zenon Logic Workbench with File -> Open.... -> Fieldbus configuration.

The following dialog opens with the menu Insert -> Insert configuration...:

Here select the configuration straton to zenon-RT connection. So this configuration is inserted in the tree of the fieldbus configuration:

Now it is guaranteed that the externally visible variables from zenon communicate with zenon Logic.

info Information

Please be aware, that such a connection only works locally on a PC or a CE device. Here it is not possible to communicate with a zenon Logic Runtime on another device.

Arrays and structure variables

With the help of the zenrt driver complex variables (arrays and structure variables )are resolved into a flat structure. The values of variables with the same name in zenon Logic and zenon are exchanged via the shared memory driver.

info Information

The functions for checking the status of a variable and for setting Dirty are not supported at the moment.

The status information (time stamp and status bits) are not supported for complex data types.

If you marked an element of an array or a structure variable as externally visible, a simple variable with the same name is created in the zenon Logic Workbench. If you marked the array or the structure variable itself as externally visible, this complex variable is created in the workbench.

info Information

If you mark an array or a structure variable as externally visible, the individual elements are not created in the Workbench anymore.

You can create variables in the workbench, which contain characters '.' or '[]' in their name. Therefore you can create variables which have the same name as variables which derive from an array or a structure variable. In this case the communication with the zenrt driver is not possible as no distinct allocation can be made.

attention Attention

Array variables in zenon which are based in the straton32 or stratonNG driver must not start with 1. A zenon array with dimensions 1,2,2 is created as a simple variable in zenon Logic.


Variable names

Manual -> zenon Logic -> Basics zenon Logic Workbench (IEC 61131-3) -> Variable handling -> Variable names

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In zenon Logic variable names must be in accordance with the IEC 61131-3 regulations. The correctness of the entry is checked by zenon as well as by zenon Logic (communication take place using the STRATON driver).

For variables of other drivers (e.g. S7 TCO/IP driver), the engineer has to check that the variable name fulfills the regulations of the IEC 61131-3 (communication takes place using shared memory).

Examples for the IEC 61131-3 notation

Permitted name | Impermissible name | Invalid because:
_XYZ | __XYZ | Two underscores.
xy_z | xy__z | Underlined twice.
xyz_ | xyz__ | Two underscores.
MotorOn | Motor On | Space.
Motor_On | Motor On | Slash.
mw10 | 1mw10 | Number at the beginning.
xyz | #xyz | Hash.
_Motor1 | _Motor 1 | Space.
Stoerung | Störung | Umlaut.
Ueberbruecken | Überbrücken | Umlaut.
Mo_tor | Mo-tor | Hyphen.

From version 6.22 SP1 on it is possible to use variables which are following the IEC 61131-3 regulations (free variable names). Take care when using free variable names.

Follow these rules when using free variable names:

  • The following characters are not allowed to be part of a variable name: '(*', '*)', '//', '{' and '}'
  • Variable names are not allowed to start with '__' (two underscores)
  • If free variable names are used when using programming language ST or IL, they must be between curly brackets {}.
  • If free variable names are used with structure of array, they must be between curly brackets {}.
  • Variables with free variable names with a basis data type can be used without curly braces {} in programming languages FBD and LD. They must be declared as global variables.
  • Variables with the same name once with {} and once without {} are regarded as two different variables.

info Information

Structure variables and arrays of structure variables with dot (".") in the name are displayed correctly. Standard arrays with slash ("/") or dot (".") in the name do not display values in the spy list.


Arrays

Manual -> zenon Logic -> Basics zenon Logic Workbench (IEC 61131-3) -> Arrays

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Arrays can be created in zenon and zenon Logic for both systems. The declaration as O&M variable takes place as described in chapters Creating O and M variables in zenon Logic and Creating O and M variables in zenon.

attention Attention

Array variables in zenon which are based in the straton32 or stratonNG driver must not start with 1. A zenon array with dimensions 1,2,2 is created as a simple variable in zenon Logic.

Take care when creating arrays in zenon Logic that you must activate the single elements in zenon.

When creating arrays in zenon, set the array start to 0. Thus the arrays have the same indices in both systems.

attention Attention

Arrays with initial values should not be declared as O&M! If it is inevitable, the string describing the initial value must not be longer than 1024 characters.


Data structure

Manual -> zenon Logic -> Basics zenon Logic Workbench (IEC 61131-3) -> Data structure

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Structure datatypes can be created in zenon or in the zenon Logic Workbench.

info Information

When creating structure data types in zenon the IEC 61131-3 naming convention has to be used otherwise the structure data type is not available in zenon Logic. Also see Variable names. Here the spelling is not checked by zenon!

info Information

If you create structure data types in zenon Logic, they are always declared as linked in zenon.

Therefore it is better to create a structure data type in zenon because then you can decide whether you want a linked or a embedded data type.


Distributed engineering (multiuser)

Manual -> zenon Logic -> Basics zenon Logic Workbench (IEC 61131-3) -> Distributed engineering (multiuser)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

It is possible that more than one engineer are working together on one zenon project. Thus for example one engineer works on a zenon Logic project and another works on the zenon project.

Variables

In distributed engineering O&m variables (operating and monitoring) are handled separately by the zenon Logic project.

You can create variables in zenon Logic as usual. If the variables should also be available in zenon, they have to be equipped with the corresponding property (element group, profile zenon Logic (*Operating and Monitoring for zenon*)). After that the variable in created in zenon. You can check it in for other engineers (apply changes). You cannot edit a checked in variable in the zenon Logic Workbench. It is marked accordingly in the zenon Logic variable list.

Driver

zenon Logic drivers are attended separately in distributed engineering by the zenon Logic project. That means if you want to make changes, you have to check out the STARTON driver (enable changes).

zenon Logic projects

In order to edit a multi-user zenon Logic project, it has to be checked out (enable changes). After the engineering, the changes can be undone or accepted.

Delete zenon Logic project

zenon Logic projects can also be deleted:

  • if they are checked out (enable changes)
  • in Offline mode


Reusing projects

Manual -> zenon Logic -> Basics zenon Logic Workbench (IEC 61131-3) -> Reusing projects

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon Logic projects which were created with the stand-alone Workbench of COPA-DATA can be integrated easily in a zenon project.

Select in the context menu of the detail view of the module zenon Logic (IEC 61131-3) menu itemExternal zenon Logic Import project.... With this command you can indicate an existing zenon Logic project (mark folder) and integrate it in the existing zenon project.

Another possibility is the XML import. In the context menu of the detail view of the module <CA_PRODUCTNAME > (IEC 61131-3) you will find the command Import XML. Thus zenon Logic projects which were first exported in XML can easily be imported in the zenon project.

Note: At the XML import you must deactivate online change so that the reload of the zenon Logic variable works.


zenon Logic Workbench

Manual -> zenon Logic -> zenon Logic Workbench

In this area you can find the manual for the zenon Logic Workbench. It is only available as online help.


zenon Logic Runtime (Soft PLC)

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon Logic Runtime interprets the compiled PLC Code of the zenon Logic Workbench. The Runtime runs on Windows 7 and Windows 8 Embedded PCs, as well as Windows CE platforms.
This chapter gives an overview of the use of the zenon Logic Runtime and the configuration tool zenon Logic Runtime Manager.

attention Attention

Due to performance issues the zenon Logic Runtime Version 6.22 SP0 Build 2 needs the straton driver for the same or earlier zenon versions. Earlier zenon Logic Runtime versions still work with all straton drivers.


User interface

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> User interface

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Usually the zenon Logic Runtime can only be found as a symbol in the system tray. A double-click on the symbol with the green arrow or on menu item Show in the context menu opens the zenon Logic Runtime user interface.

Depending on the current status, the user interface displays different states (running, step mode,break point(s), stopped).

A bar chart shows the PLC load.

In addition to information about the status of the zenon Logic project running, the following actions can be executed in the zenon Logic Runtime user interface:

  • Slider Allowed maximum of the PLC resources:set allowed maximum
  • Settings... button : Makes configuration possible via three tabs
    • General settings
    • Redundancy
    • Advanced users
  • Start/Stop button: opens the dialog to start Runtime or stops Runtime
  • Messages button: opens and closes the message window


Slider Allowed maximum

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> User interface -> Slider Allowed maximum

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The slider Allowed maximum is used to guarantee other applications which run on the same device - such as zenon - system resources.

With this slider the maximal allowed execution time related to the cycle time can be set. If with a set cycle time of 10 ms the slider is set to 50% the PLC cycle may take a maximum of 5ms. If the PLC cycle takes longer that 5 ms, the remaining calculation is done in the next cycle. So one cycle has to be omitted from the PLC. This results in a cycle overflow.

The slider can be set between 10% and 100% steplessly.

The bar graph (PLC load) shows, how high the PLC load is in relation to the setting of the slider. From this you can conclude how to set the slider for an optimal tuning.

PLC load high (Slider between 50 and 100%): Set slider towards 100% or increase cycle time.


Settings

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> User interface -> Settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The settings make it possible to configure the zenon Logic Runtime with the help of three tabs:

  • General settings
  • Redundancy
  • Advanced users


General

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> User interface -> Settings -> General

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In the tab General the different parameter of the zenon Logic Runtime can be changed:

Parameters | Effect
Communication |
Port (Main): | IP port of the zenon Logic Runtime for the cyclic data transfer (e.g. zenon Logic Workbench).
Port (Binding): | IP port of the zenon Logic Runtime for the on change data transfer (e.g. CA_PRODUCTNAME Workbench or binding).
Run-up |
No start. Open this box: | When the zenon Logic Runtime is started, first this box is opened.
Cold start: | Initialized run-up. Also retain variables are started initialized.
Cold start (loading of RETAIN variables): | Initialized run-up with current values of the retain variables. They only contain values, no states (see Info box).
Warm start: | Restart with all variable values from the last stop.
Start in step mode | Starts the zenon Logic Runtime and immediately stops it in debug mode.
Delay [s] | Delays the start by the set number of seconds. Default: 0
Retain Data |
Storage path Retain data | Here the file with the retain variables is stored. The default setting depends on whether the zenon Logic Runtime is started.
Save retain variables with their names | Activate this checkbox if you want to save retain data in the format with the variable names. With this the values of the retain variables can also be saved if you add or delet a retain variable. Note: To save a variable, it must be highlighted as embedded in the <CA:PRODUCTNAME> Workbench. If you do not activate the check box, the retain data are saved the conventional way. After changing the retain variable, the Runtime starts with the initial values for all retain variables. Default: deactivated
Cyclic saving of retain variables | If you deactivate this check box, the retain data are no longer saved cyclically but only when the Runtime is closed. They are still saved after a change but not more frequent than about every 10 ms. Default: activated
Real-time priority | Sets the zenon Logic Runtime process to the windows priority Realtime. If the flag is not set, it means priority Normal.

info Information

If you activated option Save retain variables with names in zenon and also want to use it with manual Runtime start, you must make sure that in file K5DBXS.INI in area [CMD] option RETAINBYNAME is set. With this all retain variables are highlighted as embedded when the zenon Logic Workbench is started.
Hint: The INI file is only checked at the start of the zenon Logic Workbench. Changes during the Workbench runs have no effect.

info Information

Retain variables

Retain data contain only the value of the zenon Logic variables not their status. This means for the start:

  • Warm start: The status which was set for a variable is restored - regardless of whether it is a retain variable or not.
  • Cold start with retain variables: Only the value of the retain variable in zenon Logic is restored, not the status.

info Information

If the zenon Logic Runtime has been started with the zenon Runtime or with the zenon Logic Runtime Manager, changes done in this user interface are not effective after a restart of the zenon Logic Runtime.

Please make the changes as usual in the zenon Logic project properties of the zenon Editors or in the zenon Logic Runtime Manager.

In such cases the dialog helps to determine which parameters were forwarded to the zenon Logic Runtime.

The changes to the settings which were done in this dialog are only effective if the zenon Logic Runtime is started directly (e.g. using the Windows Explorer).


Redundancy

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> User interface -> Settings -> Redundancy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In tab Redundancy you can see the redundancy settings for the zenon Logic Runtime.

You can check or enter the following entries:

Entry | Meaning
Activate redundancy | Runtime runs in redundancy mode
Server port: | Port for replication connection
Server Time-out [ms] | Time-out in order to determine if the passive client is available. After the time-out expires, the replication is stopped.
Client Time-out [ms] | Time-out in order to determine that the active server is no longer available. After the time-out expires, the passive client becomes the active server.
Partner address: | IP address of the redundancy partner.

info Information

You can fing details on configurating the redundancy of zenon Logic and zenon in chapter Redundancy zenon Logic and zenon.

Limitations

Redundancy is not supported in zenon Logic RTK Runtime.


Enhanced settings

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> User interface -> Settings -> Enhanced settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

On this tab you carry out settings for the on change communication with external applications (Binding, zenon driver, ...).

The following settings are available:

Entry | Meaning | Range of values
System | Max. length of the system queue. In this queue e.g. overflows of the event queue are buffered. | 1024 ... 65520 Default: 1024
Alarms | Length of the alarm queue (not used at the moment) | 0 ... 65520 Default: 0
max. connections | Number of possible connections (cannot be changed) | 4 ... 65535 Default: 256
Events | Length of the event queue: In this queue the events of the zenon Logic Runtime event severs are written. From there they are sent via TCP. If this queue overflows, the overflow messages are written in the system queue. | 0 ... 65535 Default: 8192
Messages | Length of the info queue. In this queue the messages to the zenon Logic Workbench are buffered. | 1024 ... 65520 Default: 32768
max. puffer | Buffer size of the events per cycle. This parameter defines how much many variables are handled by the event server per cycle. | 128 ... 65535 Default: 1024
Reset | Restores the default settings |

info Information

If in large projects more than 1024 variables are transferred between zenon Logic and zenon with the straton32.exe driver, the parameter Max. buffer must be increased accordingly. An easy method to find out the number of Max. buffer is the value for the compiled I/Os in the output window of zenon Logic compilers. See illustration below.


Messages

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> User interface -> Messages

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Runtime messages can be displayed in the zenon Logic Runtime user interface. Click on the Messages>> button to activate the view. The message display opens. Click on the Messages<< button to close the message display.

For actions in the message display, click in the message display with the left or right mouse button. You obtain a context menu:

Menu entry | Description
Display time stamp of messages | Adds a time stamp to each message.
Copy messages to the clipboard | Copies selected entries to the clipboard.
Delete all messages | Deletes all messages from the message window.

You administer the settings for zenon Logic logging and the drivers with the diagnosis viewer. In doing so, each zenon Logic Runtime and each bus driver receives their own connection to the diagnosis server as a diagnosis client. This does not include obsolete drivers, for example those from a third-party manufacturer.


Licensing

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> Licensing

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Installation with zenon (zenon Runtime and zenon Logic Runtime on one PC)

The zenon Logic Runtime is automatically licenced with the zenon serial number. During the installation enter the serial number and the activation number in the according dialog. If no licence number is available, click on Demo Version.

Autarchic installation (zenon Logic Runtime without zenon Runtime on one PC)

For an autarkic installation (zenon Logic runs on a PC without the zenon Runtime) you can again enter the serial number and the activation number directly in the installation dialog.

Later licensing with licence order

You also can do the licensing later with the Licence order. Open the license order in the Windows start menu under Programs -> COPA-DATA -> Licensing. For later licensing the serial number and the activation number are entered in this dialog. The procedure is finished with OK.

For soft-licensing the so-called licence number must be read from the hardware configuration of your PC. Click the button for soft licensing and follow the requests in the following dialogs.

Afterwards licensing using the zenon Editor

In the zenon Editor you can open the dialog for licensing using File -> Standard configuration -> License product.... You can enter the serial number and the activation key here.

Information about the license of the zenon Logic Runtime

Open the user interface of the zenon Logic Runtime by clicking on the zenon Logic Runtime icon in the system tray. Then click on the top left corner an select About STARTONRT.... A window appears with information about version and license of the zenon Logic Runtime.


TAG handling zenon - zenon Logic

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> Licensing -> TAG handling zenon - zenon Logic

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The number of the TAGs used in zenon Logic is the number of I/Os in zenon Logic minus the number of the used I/Os with a zenon or zenon Logic profile. These I/Os are already considered at the TAG calculation in zenon.

This makes sure that no I/Os are counted twice.

The used I/Os are displayed in the UI of the <CA_PRODUCTNAME< Runtime.


Demo mode

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> Licensing -> Demo mode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon Logic Runtime starts in Demo Mode if you enter a false (or no) serial number or a false (or no) activation key or if no dongel is connected. The Demo Mode stops the zenon Logic Runtime after 15 minutes. With a special demo serial number the zenon Logic Runtime runs continuously for 30 days. After these 30 days then the maximal time of the zenon Logic Runtime is again 15 minutes.

zenon Logic Mini

You did not buy the zenon Logic Runtime license but you own a valid zenon Runtime license. Then a mini version of the zenon Logic Runtime is licensed automatically. With the mini version up to eight TAGs (=variables) can be used by zenon Logic via input/output mechanisms. TAGs are variables of field bus drivers and variables with profiles (e.g. B&B profile zenon Logic).

Calculation example:

  • four variables for the communication zenon Logic <=> zenon
  • four variables for the communication zenon Logic <=> Profibus
  • This equals the maximum number of eight TAGs (4 + 4 = 8).


Start the zenon Logic Runtime

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> Start the zenon Logic Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon Logic Runtime supports multi-instances and therefore needs parameters (transfer parameters), when it is started.

There are three possibilities in order to start the zenon Logic Runtime:

  1. with the help of the zenon Runtime
  2. with the help of the zenon Logic Runtime Manager
  3. in a DOS Shell/BAT-file

Start with the help of the zenon Runtime

In order to start the zenon Logic Runtime with the zenon Runtime:

  • Select the zenon Logic project in the zenon Editor.
  • Change the Start type (Runtime) as you wish. The properties of Start type are described in the embedded help in zenon.

Start with the help of the zenon Logic Runtime Manager

You can use the zenon Logic Runtime Manger to start the zenon Logic Runtime manually. You will find the zenon Logic Runtime Manager in the folder COPA-DATA in the Windows® start menu. The zenon Logic Runtime manager is used to start zenon Logic Runtime instances on a PC. You can for example chose hard real time here in order to start the zenon Logic real time version (zenon Logic RTK) or to start a zenon Logic Runtime instance during the booting of the system ("Auto start").

You receive accurate information about the individual elements of the zenon Logic Runtime manager by moving the mouse pointer over them. The corresponding help is displayed in the property help.

You receive the complete help about this application by clicking ? in the menu bar.

attention Attention

Runtime Manager must be started with administrator rights.

Start in a DOS Shell

The zenon Logic Runtime can be started in a DOS Shell or something similar (.bat file). For the command the following is true:

  • all commands must be entered in capitals
  • the following signs are allowed:
    -
    /
    no sign

The following handover parameters are available:

Main parameter:

Parameters | Description
PORT=<number> | Communication port. Without parameters: 1200
PORTTRACE=<number> | Event server point, Binding port. Without parameters: PORT+7800
PATH=<DB-Path> | Storage area of the zenon Logic application code. Without parameters: zenon Logic Runtime directory
ZENPATH=<Pfad> | zenon path (without meaning)
ZENPROJECT=<name> | zenon project name (without meaning)
DONTHIDE | Do not hide the Runtime after the start (it is the only parameter without '=')
STEP=<0|1> | Without parameters: no stepping mode. 0: no stepping mode 1: Start in stepping mode
START=<0|1|2|3> | Without parameters: Warm start 0: Display setup dialog 1: Cold start 2: Warm start 3: Hot start
LOWPRIORITY=<0|1> | Without parameters: low priority 0: low priority 1: Windows real time priority
WRITELOG=<0|1> | Without parameters: Create log 0: Do not create log 1: Create log The log-file is created in the PATH folder as STRATONRTLOG.TXT.

Additional parameters:

Parameters | Description
REMPATH=<Path> | Path for remanent data. Without parameters: PATH directory
DELAY=<number> | Start delay in [s]: Delayed start of the zenon Logic Runtime. Without parameters: 0
MAXUTILPRCT=<number> | Position of the slider for maximum PLC workload in %. Without parameters: 100

Event server:

Settings equal to the settings under Settings/Advanced for the event server.

Parameters | Description
QSSYSTEM=<number> | Size of system queue. Without parameters: 1024
QSALARM=<number> | Size of alarm queue. Without parameters: 0
QSEVENT=<number> | Size of event queue. Without parameters: 8192
QSINFO=<number> | Size of info queue. Without parameters: 32768
NBEVENT=<number> | Maximum number of recordable events. Without parameters: 1024
EVENTCON=<number> | Number of possible event connections. Without parameters: 256

Redundancy settings:

Parameters | Description
REDENABLE=<0,1> | Redundancy on/off. Without parameters: 0
REDADDR=<IP> | Redundancy partner address.
REDPORT=<number> | Redundancy port for replication.
REDCLITIMEOUT=<number> | Redundancy client time out [ms]; time out which is used to determine when a passive client becomes an active server. Without parameters: 1000
REDSRVTIMEOUT=<number> | Redundancy server time out [ms]; time out which is used to determine when the replication is stopped. Without parameters: 1000
REDZENON=<0,1> | If set to 1, the partner address is read from PROJECT.INI. Without parameters: 0


zenon Logic Runtime cycle

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> zenon Logic Runtime cycle

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon Logic Runtime cycle consists of:

  • Calc. time: Time for data exchange, calculation, save calculated values, read and write modified values, idle time.
  • Cycle time: Complete cycle time determined by system latency.
  • System latency: Response time of the system.

These values can be displayed in the zenon Logic user interface. Use the shortcut Alt+S or Shift+Alt+A.

Property | Description
Binding exchange | Reading of the Binding values which are published in the network and which were configured by the application (if they were configured).
I/O exchange | Data exchange between the I/O drivers (except Modbus slave/server) and the I/O boards (if they were configured).
Application execution | Execution of the programs.
Digital sampling trace | Execution of the digital sampling (if it was configured).
Events | Sending of the events (Binding or straton32.exe driver of zenon) (if they were configured).
Forced values | Reading of the forced values of zenon from the zenon Logic Workbench (online debugging) and data exchange of the Modbus slave/server (if they were configured).
Sleep | Wait the remaining time until the cycle time is over. When cycle setting is As fast as possible (free run), the time is always 1 ms. The Sleep time is used in order to execute tasks of the operation system and of other windows applications.

Time allocation PLC and Windows

With the help of the slider in the zenon Logic Runtime user interface, you can determine how much time is reserved for the PLC and for Windows. The value displayed in the bar graph always refers to the ratio set in the slide control.


Error messages cycle time

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> zenon Logic Runtime cycle -> Error messages cycle time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When the cycle time is exceeded, messages are displayed in the zenon Logic Runtime or in the Workbench and corresponding entries are written to the log file.

Error message user interface | Entry log file | Meaning
Timing configuration error. (x) cycles lost. | Timing configuration error. (x1) cycles lost. Configured cycle time = (x2) us, maximum execution time = (x3) us, maximum PLC utilisation = (x4). | Number (x) of not executed cycles due to cycle time out. The execution time is higher than the set cycle time or there are not enough CPU resources available.
Timing configuration error. PLC utilization peaked at (x)%. | Timing configuration error. PLC utilization exceeds 80%. Configured cycle time = (x1) us, maximum execution time = (x2) us, maximum PLC utilisation = (x3)%." | The execution time is higher than 80% of the set cycle time; actually (x)%.

Troubleshooting

You can fix exceeding the cycle time by:

  • increasing cycle time
  • decreasing execution time, e.g.:
    • use a system with more CPU resources
    • use C compiled code
    • reduce the program


Close the zenon Logic Runtime

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> Close the zenon Logic Runtime

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon Logic Runtime can be closed manually either by using the context menu of the symbol in the system tray or by using the open window of the zenon Logic Runtime:

Context menu symbol

  • Right clicking the icon in the system tray opens the following context menu:

  • With a click on End, you open a dialog

  • Clicking on Yes stops and closes the Runtime.

In the windows of the zenon Logic Runtime

Another possibility to close the Runtime is in the open window of the zenon Logic Runtime.

  • The following menu opens after a click to the upper, left corner of the window:

  • With a click on End, you open a dialog
  • If you acknowledge the dialog, the zenon Logic Runtime is closed immediately.

info Information

If the zenon Logic Runtime was started together with the zenon Runtime and for the zenon Logic project the start type 'autom. start/stop' was selected in the zenon Editor, the zenon Logic Runtime is automatically closed when the zenon Runtime is closed.


Creating the hot restart file

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> Creating the hot restart file

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

When you close the zenon Logic Runtime, a hot restart file is created automatically. You can trigger the writing of the hot restart file via function WriteHot.

Every time a hot restart file is created, a backup file is also created for which the last character of the file name is replaced with a '_'. In addition the files are created with a header which contains the Checksum of the data. When reading the data, header and checksum are checked. If an error occurs, the backup file is used.

Function WriteHot has the following input parameters:

Parameters | Description
I | Trigger; if this parameter is TRUE; the function is executed.
SYNC | If this parameter is TRUE, the cycle is hold for as long as the hot restart file is written. If the parameter is FALSE, the function is carried out asynchronous.
BUSY | This parameter is TRUE if the function is executed.

info Information

If you call up the function several times in a cycle, only the last call is considered.


Remote systems

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> Remote systems

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This chapter deals with target systems which are not on the local computer. The target system is accessed via Ethernet TCP/IP.


zenon Runtime and zenon Logic Runtime on one remote PC

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> Remote systems -> zenon Runtime and zenon Logic Runtime on one remote PC

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Installation on the target system

First you install and license the zenon Runtime on the remote PC. The zenon Logic Runtime is automatically installed and licensed.

Download the project data with zenon Logic Runtime, start type "autom. start/stop" or "autom. start"

In order to download the zenon and zenon Logic Runtime files, use the Remote Transport function of zenon. You will find more information in the chapter Remote Transport.

The zenon Logic Runtime is started and closed together with the zenon Runtime automatically.

Download of the application data with the zenon Logic Runtime start type "start manually"

If the zenon Logic Runtime is started manually on the target PC (e.g. during boot up of the operating system), the PLC code has to be loaded manually to the target platform with the zenon Logic Workbench. For that

  • enter the correct parameters in the property dialog Workbench in the zenon Editor: Target host and Target port
  • in the zenon Logic Workbench click on the button Online
  • with this the zenon Logic Workbench establishes a connection to the target system.
  • now you can transfer the PLC code to the the target system via button Download; the progress of the download is displayed with the help of a progress bar
  • after the download the PLC starts automatically with the new application.

if the download was successful and the PLC program runs on the target system faultless, RUN is displayed in the tool bar


zenon Logic Runtime autarkic (PC)

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> Remote systems -> zenon Logic Runtime autarkic (PC)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Installation on the target system:

Install the zenon Logic on the target system with the autarkic installation.

Start:

Before downloading the zenon Logic project, start it. The best way is to use the zenon Logic Runtime Manager. With this tool you can also carry out the settings so that the zenon Logic Runtime starts together with the operating system.

Download of the application data with the zenon Logic Runtime start type "start manually"

If the zenon Logic Runtime is started manually on the target PC (e.g. during boot up of the operating system), the PLC code has to be loaded manually to the target platform with the zenon Logic Workbench. For that

  • enter the correct parameters in the property dialog Workbench in the zenon Editor: Target host and Target port
  • in the zenon Logic Workbench click on the button Online
  • with this the zenon Logic Workbench establishes a connection to the target system.
  • now you can transfer the PLC code to the the target system via button Download; the progress of the download is displayed with the help of a progress bar
  • after the download the PLC starts automatically with the new application.
  • if the download was successful and the PLC program runs on the target system faultless, RUN is displayed in the tool bar


zenon Logic Runtime with Real Time Kernel (RTK)

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> zenon Logic Runtime with Real Time Kernel (RTK)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon Logic RTK (Realtime Kernel) is the zenon Logic Runtime system for hard realtime. With that highest determinism and failure safety towards the operating system are guaranteed.

Requirements:

  • The zenon Logic RTK is only available for operating systems Windows 7 in the 32 bit version.
  • The zenon Logic RTK can only be started with the zenon Logic Runtime Manager (flag Hard realtime has to be activated) or or in a DOS-Shell/BAT-file.

attention Attention

Do not operate two real-time extensions in parallel on one computer. This means:

  • If another real-time extension is already active on the computer, do not start the zenon Logic RTK.
  • Only one instance of the zenon Logic RTK can be started at a time.

The Realtime Kernel is designed, so that it triggers the zenon Logic Runtime cycle independent of Windows. So the zenon Logic Runtime cycle is guaranteed to be executed deterministically. Cycle times must be 100 µs or higher.

The PC's part of the calculating capacity can be set with a slider.

Depending on the size of the PLC application and the defined cycle time the slider has to be adjusted to the PLC load. The slider can be set between 10% and 85%. The current load (bar) indicates whether the allowed maximum for executing the PLC cycle is sufficient.

If the bar is near 100%, there is a danger of cycle overflows! In this case set the slider higher (towards 85%). If this is not possible because of the applications in Windows (e.g. bad screen opening times of zenon) the cycle time of the zenon Logic application has to be increased.

attention Attention

If the bar reaches the 100% mark, there is a danger of cycle overflows!

Example Example

Slider at 10%, cycle time 10ms:

The zenon Logic RTK must process the PLC program in 1 ms which equals 10% of the set cycle time of 10 ms.

Slider at 50%, cycle time 5ms:

For executing the PLC program 2.5ms are available for the zenon Logic RTK.

Slider at 85%, cycle time 20ms:

For executing the PLC program 17ms are available for the zenon Logic RTK.

Formula

The following formula can be used to find out, if the setting of the slider does not lead to cycle overflows in combination with the cycle time:

cycle time > (100 / Sliderposition [%] ) * calculating time

In order to find out the calculating time of the PLC cycle, click Shift+Alt+A and note the value Max. Cal. . time [µs].

Assumption:

Max. cal. Time: 274µs

Slider position: 50%

Set cycle time: 1ms (1000µs)

Calculation:

(100/50)*274 = 548µs

This means that the defined cycle time of 1 ms is sufficient.

attention Attention

Please keep in mind: If you do not stick to the described formula, the determinism which is based in the cycle time is not given anymore!

Description of the displayed measuring values (show with ALT+S or SHIFT+ALT+A):

System latency (Alt+S) |
Current [µs] | Current system latency (see also Runtime cycle)
Maximum [µs] | Maximum system latency (since the start of the Runtime)

Extended statistic (Shift+Alt+A) |
Cal. time [µs]. | Current calculation time of the last cycle
Max. cal. time [µs]. | Maximal calculation time for a PLC cycle (since the the start of the Runtime)
Cycle time [µs] | Current cycle time
Min. cycle time [µs] | Minimal cycle time (since the start of the Runtime)
Max. cycle time [µs] | Maximal cycle time (since the start of the Runtime)
Cycle overflow [1] | Counter for cycle time exceedance (since the start of the Runtime)
Driver overflow [1] | Counter for failed PLC cycles of Windows (non-realtime) drivers (since the start of the Runtime)

The value of the cycle time can always only be a multiple of the HAL Timer Periode (time basis). The time basis depends on the selected timer and its time basis (see also zenon Logic RTK configuration). That means: A set cycle time of 10 ms of a hardware with a time basis of 122 µs is not executed with exactly 10,000 ms but with 10,004 ms.


Restrictions and requirements of the zenon Logic RTK

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> zenon Logic Runtime with Real Time Kernel (RTK) -> Restrictions and requirements of the zenon Logic RTK

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Hardware requirements for the zenon Logic RTK

ACPI:

The hardware (PC or IPC) and the operating system (Windows 7) must support ACPI:

  • ACPI-Multiprocessor-P
  • ACPI-PC (Advanced Configuration and Power Interface)
  • ACPI uniprocessor PC

You can check whether your PC supports ACPI in the system control (system/device manager/computer).

CPUs:

The zenon Logic RTK is supported from the following processor generations on:

  • Pentium II or younger
  • AMD Athlon XP or younger

Limitations

The zenon Logic Real Time Kernel (RTK) runs as a separate process at hardware level independently of the operating system. In contrast, zenon Logic Runtime runs on Windows®. The real-time-enabled zenon Logic RTK has a few restrictions compared to the zenon Logic Runtime.

  • zenon Logic redundancy is not supported
  • Not all function blocks are supported
  • Not all I/O drivers are supported
  • Some real-time drivers must be registered/deregistered manually

Note: The zenon Logic real time components are only available for Windows 7 and Windows 8 under 32-bit.

Function blocks

The following funciton blocks are not processed directly in the Kernel Mode, but only emulated:

  • all file operations (category 'Files')
  • all TCP/IP modules (category 'TCP-IP')

Following function blocks are not supported by the zenon Logic RTK:

  • day_time_local (Category 'Clock')

info Information

In order to determine exactly which function blocks the zenon Logic standard library supports, use the feature of the configuration of the zenon Logic Workbench (main menu: Project/Configuration/Upload).

After you have selected the configuration, the function blocks which are not supported are marked red in the library.

I/O Driver

The following zenon Logic I/O drivers are executed by the zenon Logic RTK in Kernel Mode (real time):

  • Profibus (Hilscher CIF Profibus)
  • Hilscher SYCON universal (Hilscher SYCON configuration)

You can find more information about supported I/O drivers here: zenon Logic I/O driver support

Register and de-register real time drivers

There is a small chance that the real time driver of the zenon Logic RTK must be registered and de-registered manually. In order to do this start the command prompt via:
Start > execute > cmd.

Use the following syntax:

  • Register:

    <Folder of the zenon Logic RTK>:\ stratonrtkvm -regsrv

  • De-register:

    Folder of the zenon Logic RTK>:\ stratonrtkvm -unregsrv

Example of the <folder of the zenon Logic RTK>: C:\Program Files\COPA-DATA\zenon720


zenon Logic RTK configuration

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> zenon Logic Runtime with Real Time Kernel (RTK) -> zenon Logic RTK configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon Logic Real Time Kernel (RTK) runs as an own instance on hardware level and is independent of the operating system. The Timerticks which are used for control are directly obtained from the motherboard. Which timer are available depends on the used hardware. The configuration is carried out by the zenon Logic RTK configurator.


Start RTK configuration

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> zenon Logic Runtime with Real Time Kernel (RTK) -> zenon Logic RTK configuration -> Start RTK configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Double click the button for zenon Logic RTK Configurator in the windows control panel.

The window for editing the configuration opens. In the left window you see a menu tree with the following options:

  • CDrtHAL configuration
  • Basic settings
  • Task manager
  • Hardware configuration
  • Access to the physical memory
  • Log messages

In the right-hand window you can see information about the menu items and configure the RTK.


RTK basis information

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> zenon Logic Runtime with Real Time Kernel (RTK) -> zenon Logic RTK configuration -> RTK basis information

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

After the start menu item 'CDrtHal configuration' is active in the left-hand window of the configuration software. In the right-hand window displays basic information about the configuration and the system:

Property | Information
Version | Version of the real time driver (CDrtHAL).
Status | RTK is active or inactive
Interrupt controller | Type of interrupt controller.
High precision event timer | Support depends on hardware:
Process cores | Number of available process cores.


RTK basic settings

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> zenon Logic Runtime with Real Time Kernel (RTK) -> zenon Logic RTK configuration -> RTK basic settings

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

RTK basic settings

In the basic setting you define the following:

  • Source for the Timertick
  • CPU on which the RTK is carried out
  • Basic time as basis for the multiplication factor for the calculation of the cycle time

Timer for real-time source

Which time is displayed on the selection list depends on the used hardware. This information is also displayed on the start page of the RTK configuration. Available can be:

  • Interrupt-Controller APIC
  • Interrupt-Controller PIC
  • HPET (High precision event timer)

The follwoing possibilities arisefrom this:

  1. PIC without HPET
    • Timer (8254 Timer), basic times: 334 µs, 143 µs, 112 µs, 53 µs
    • Profiles (real-time clock), basic times: 488 µs, 244 µs, 122 µs
  2. APIC without HPET
    • Profiles (real-time clock), basic times: 488 µs, 244 µs, 122 µs
    • Profiles (local APIC), basic times: choose anywhere between 50 - 500 µs
    • Unused (8254 Timer), basic times: choose anywhere between 50 - 500 µs
  3. APIC with HPET
    • Timer (HPET timer o), basic times: 500 µs, 250 µs, 125 µs
    • Profiles (local APIC), basic times: choose anywhere between 50 - 500 µs
    • Unused (HPET timer 2), basic times: choose anywhere between 50 - 500 µs

Whether and to what extend basic times are available depends on the hardware (real-time clock) and the operating system. When using the 'timer' real-time source, the source for the Windows Timer Interrupt is used for the real time execution. In this case the set basic time must be an integral factor of the Windows Timer Interrupt basic time.

real-time source: depends on the operating system Select using list field (drop down).

We recommend the following basic setting: Unused (HPET Timer2).

Real time CPU: Select the CPU on which the process of the RTK should be carried out.

Basic time: Basic time of the timerticks. Depending on the real time source, the basic time is selected from a list or entered freely. During operation the multiplication factor for the timer ticks refers to the entered basic time.

attention Attention

When using Profile: Real time source the kernel profiling must not be activated under any circumstances as long as a zenon Logic RTK application is executed. For more information about kernel profiling see: http://www.microsoft.com/downloads/details.aspx?familyid=9d467a69-57ff-4ae7-96ee-b18c4790cffd&displaylang=en


RTK Taskmanager

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> zenon Logic Runtime with Real Time Kernel (RTK) -> zenon Logic RTK configuration -> RTK Taskmanager

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The task manager displays cycle times and execution times.

Property | Information
Cycle time (in microseconds) | Minimal, maximal and current value. Cycle refers to the cycles of the Timerticks based on the basic time.
Execution time (in microseconds) | Minimal, maximal and current value.


RTK hardware configuration

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> zenon Logic Runtime with Real Time Kernel (RTK) -> zenon Logic RTK configuration -> RTK hardware configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A seperate reserved storage area is needed for the communictation with the I/O drivers (e.g. Profibus) which are executed in the kernel mode. zenon Logic RTK and the I/O driver system agree on an area on which both have read and write access.

The configuration offers three settings:

Options | Effect
Generally prohibit access to the physical memory. | Free access memory areas are a saftey risk with regards to malware. Thus access to the physical memory is prohibited in the shipping state. Basic setting.
Generally allow access to the physical memory. | Allows the communication to use the whole memory, zenon Logic RTK und Profibus set their communication areas randomly. Unsafe setting which is not recommended.
Allow access to a defined physical memory area. | . zenon Logic RTK and I/O driver have a strictley allocated memory area. Recommended setting


Define memory area

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> zenon Logic Runtime with Real Time Kernel (RTK) -> zenon Logic RTK configuration -> RTK hardware configuration -> Define memory area

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
Define memory area

In order to allocate a fixed memory area for zenon Logic and I/O driver, click on Access to the physical memory in the left window and then on Allow access to defined physical memory area in the right selection window.

Property | Information
Area | The number is assigned by the configurator automatically.
Base address | Start address for the free memory. It can for example be determined with the help of the Hilscher Tool (included in the delivery of the card).
Length | Length of the free area. Attention: must be stated in Bytes.
Add area | Creates a new entry in the list.
Delete | Deletes an existing entry from the list.


RTK Logs

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> zenon Logic Runtime with Real Time Kernel (RTK) -> zenon Logic RTK configuration -> RTK Logs

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Messages from the RTK are displayed in the area Log messages.

Property | Information
Date/Time | When did the event happen
Type | What type of message (status, error, ...)
Description | What has happened?


Close RTK configuration

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> zenon Logic Runtime with Real Time Kernel (RTK) -> zenon Logic RTK configuration -> Close RTK configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

By clicking button OK all changes are saved and the configurator is closed. If the system needs to reboot, a corresponding message is displayed.

If you close the configurator by clicking the close symbol (X) or by clicking Cancel, a dialog appears asking whether you want to save the changes.


Blue Screen Handling

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> zenon Logic Runtime with Real Time Kernel (RTK) -> Blue Screen Handling

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

A probable Bluescreen of Death (BSOD) is recognized by the zenon Logic RTK immediately.

If the zenon Logic RTK is configured for stopping in case of a BSOD, the shut down program - if defined - is executed immediately, i.e. before the theoretically next cycle.

If the zenon Logic RTK is configured to continue running, the next cycle is executed after a short delay of ca. 10 ms (switching the graphics mode).

In order to achieve this, the zenon Logic function RTK_OnBugCheck of the zenon Logic standard library must be set to TRUE in the zenon Logic application.

attention Attention

In case of a BSOD the execution of the zenon Logic application can be limited.

Following functions are no longer supported when this occurs:

File operations, TCP functions, functions of the serial interface, no real time field bus driver, system clock functions, RETAIN variables, writing log messages (changes reserved by product version cycles).

In order to check in the zenon Logic application if a BSOD has occurred, use the zenon Logic function RTK_IsBugCheck.

System requirements for smooth continuous running after a BSOD:

  • Windows® 7 (32 Bit)

Options for Profibus Master (Hilscher CIF Profibus):

No restart after stop (keeping outputs): If this option is active, the outputs of the Profibus I/Os remain set after the shut down. Otherwise the outputs would be set to the defined alternate values after the shut down sequence.


Error codes at starting the zenon Logic RTK

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> zenon Logic Runtime with Real Time Kernel (RTK) -> Error codes at starting the zenon Logic RTK

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The displayed error code refers to starting the STRATONRTKVM.exe.

Error code | Meaning
0x00000000 | If an error occured in the zenon Logic RTK, usually the error is explained in a message: The log message with the error code 0x00000000 can be ignored.
0xFFFFFFFF | A timeout occured on starting the STRATONRTKVM.exe. Possible reasons: STRATONRTKVM.exe does not exist, too high load of the system. Attention: After such an error make sure that the STRATONRTKVM.exe as well as the STRATONRTK.exe no longer run (task manager) before you restart STRATONRTK.
0x00000001 – 0x0000FFFF | Is an error code of the zenon Logic virtual machine (COPALP error message).
0xFFFF01, 0xFFFF02 | Error loading the non-realtime bus drivers! probable reason: incompatible (old) version of one or more bus driver(s).
0xFFFFF000 | rtHAL error code (0xFFFFF000 is added to the rtHAL code)
0xFFFFF001 | Make sure, that the rtHAL driver has been installed correctly. If the problem still exists, contact your zenon support and tell them the Windows version (service pack, hot fix, ...) and the used Windows HAL. The name of the used HAL is shown in the device manager under computer. System requirements: ACPI, Pentium II or AMD Athlon or higher.

rtHAL error codes:

0x0

No error

Possible error codes on starting

Error code | Meaning
0x1 | Error while loading the driver. Reason: Driver is not registered correctly.
0x2 | START could not be executed. Reason: Wrong version of the driver is installed.

Error codes during Runtime

Error code | Meaning
0x6 | SUSPEND could not be executed.
0x7 | STOP could not be executed.

Internal zenon Logic virtual machine error codes

#define T5RET_OK 0
#define T5RET_ERROR 1
#define T5RET_BADCODE 2 /* invalid app code - bad header */
#define T5RET_BADCODETARGET 3 /* invalid code - bad target id */
#define T5RET_BADCODEVERSION 4 /* invalid code - bad version */
#define T5RET_EXECSIZE 5 /* exec buffer overflow */
#define T5RET_BADREQUEST 6 /* unknown comm request */
#define T5RET_SERVEREAD 7 /* cannot process read request */
#define T5RET_UNKNOWNTIC 8 /* unknocn tic code */
#define T5RET_DATA8OVERFLOW 9 /* too many DATA8 used */
#define T5RET_DATA16OVERFLOW 10 /* too many DATA16 used */
#define T5RET_DATA32OVERFLOW 11 /* too many DATA32 used */
#define T5RET_DIVZERO 12 /* division by 0 in TIC (32bit) */
#define T5RET_TIMEOVERFLOW 13 /* too many TIME variables */
#define T5RET_CANTACTIME 14 /* active timers not supported */
#define T5RET_SAFETICLOOP 15 /* awful loop in TIC (safe mode) */
#define T5RET_OUTOFTIC 16 /* TIC code ointer out of range */
#define T5RET_UNKNOWNSTF 17 /* not supported std function */
#define T5RET_LDIVZERO 18 /* division by 0 in TIC (64bit) */
#define T5RET_DATA64OVERFLOW 19 /* too many DATA64 used */
#define T5RET_STRINGOVERFLOW 20 /* too many strings */
#define T5RET_SDIVZERO 21 /* division by zero in TIC (8 bit) */
#define T5RET_WDIVZERO 22 /* division by zero in TIC (16 bit) */
#define T5RET_HOTRESOURCES 23 /* HOT restart: system resources used */
#define T5RET_HOTMAP 24 /* invalid var map in hot restart */
#define T5RET_HOTACTIME 25 /* change of active timer map */
#define T5RET_HOTSTAMP 26 /* bad build stamp for hot restart */
#define T5RET_HOTSFC 27 /* SFC changed - no hot restart! */
#define T5RET_HOTRETAIN 28 /* retain def has changed - no hot */
#define T5RET_HOTFORMAT 29 /* bad DB format - no hot restart! */
#define T5RET_CYCLEOVERFLOW 30 /* cycle time overflow */
#define T5RET_RETAINSTORING 31 /* cant store retain variables */
#define T5RET_ARRAYBOUND 32 /* array index out of bounds */
#define T5RET_RECURSE 33 /* recursive call of sub-program */
#define T5RET_XVOVERFLOW 34 /* too many external variables used */
#define T5RET_NOBSAMPLING 35 /* sampling trace not supported */
#define T5RET_TASKOVERFLOW 36 /* too many tasks */
#define T5RET_HOTCALLSTACK 37 /* call stack overflow (hot) */
#define T5RET_STACKOVER 38 /* stack overlow */
#define T5RET_HOTASI 39 /* cannot hot restart ASi */
#define T5RET_TOXC 40 /* OXC limit reached */
#define T5RET_WOXC 41 /* OXC info */


Redundancy zenon Logic and zenon

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> Redundancy zenon Logic and zenon

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon Logic can be used redundantly and offers the possibility to combine the zenon redundancy with the zenon Logic redundancy.

In this chapter the configuration of the zenon/zenon Logic redundancy is described. The zenon/zenon Logic redundancy is referred to as SCADA logic redundancy from here on.

Further terms:

  • zenon server = dominant zenon server
  • zenon SB = zenon Standby Server
  • Active zenon Logic Runtime = zenon Logic Runtime instance being executed
  • Passive zenon Logic Runtime = backup system (Standby) of zenon Logic Runtime

Operating systems

Redundancy can be used with the following operating systems:

  • Windows 7
  • Windows 8
    Note: Windows 8 RT is not supported for reasons relating to the system.
  • Windows CE

Limitations

Redundancy is not supported in zenon Logic RTK Runtime.


Requirements

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> Redundancy zenon Logic and zenon -> Requirements

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Two PCs are necessary for SCADA logic redundancy. The both PCs are connected via Ethernet TCP/IP (100 MBit, recommended 1 GBit).

attention Attention

The SCADA logic redundancy demands that both systems, zenon and zenon Logic, are installed on one PC.

We recommend to set the cycle time of the zenon Logic project to twice the cycle time of a single project, but at least to 50 ms.

Since SCADA logic implies that zenon Logic and zenon communicate with each other using the shared memory driver (zenon Logic to zenonRT connection), it must be guaranteed that the zenon server and the active zenon Logic Runtime run on the same PC.

In order to prevent a one-sided switching from zenon Logic or zenon, a synchronization between the zenon Logic Runtime and the zenon Runtime must be engineered. A watchdog is used for this.

Watchdog

zenon Logic

The status of the zenon project (stand alone/Server/Standby Server/client) is transferred via the shared memory command area and is evaluated by the redundancy function block. It has a freely definable time out value as input. As output binary values for redundancy switch and active, passive and failed Runtimes etc. are output. They determine the reaction of the zenon Logic Runtime.

To make it clear from which zenon project the watchdog or the status originates,

  • the zenon Runtime driver or the shared memory area must have the zenon project GUID
  • the zenon Runtime driver or the shared memory area must have the zenon Logic project name

zenon

A watchdog generated by the zenon Runtime driver is transferred via the shared memory command area and evaluated in zenon. This evaluation takes place in accordance with the settings of properties Failure recognition after [s] and Function for failure recognition. They define a time out time and a function (normally Exit Runtime).

In order for the correct watchdog to be evaluated, it must be clear for several active zenon Logic projects from which zenon Logic project the watchdog originated. The following must be the case for this:

  • the zenon Runtime driver or the shared memory area must have the zenon Logic project name

attention Attention

The start of the zenon Runtime must not be performed from the zenon Editor but with a direct call from the zenon Runtime!

The zenon redundancy must be set up. Details: See help chapter Network.


Configure redundancy

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> Redundancy zenon Logic and zenon -> Configure redundancy

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

zenon Logic and zenon can control each other in redundant operation by means of a watchdog. If the zenon Logic Runtime fails:

  • the local zenon Runtime is also closed
  • both systems are switched to redundancy mode

Configuration in zenon

To activate redundancy:

  • activate property Redundant operation in group Runtime of the properties of the zenon Logic project in zenon
  • define
    • Failure recognition after [s]
    • Function for failure recognition

Configuration in <CAD_PRODUCTNAME>

The settings for redundancy are made in tab Redundancy of the straton Runtime.

Watchdog

With the watchdog each side checks the other for changes to this counter. If the counter for a projected time is not changed, this is reported to the program:

  • zenon: a function configured in an integrated project is carried out (Function for failure recognition)
  • zenon Logic: A function block output becomes active

The watchdog examination starts as soon as the other side has changed its watchdog for the first time. This is necessary because the time is needed to start or the zenon Logic Runtime does not necessarily need to start with the zenon Runtime.

info Information

If zenon Logic Runtime is a started manually, the following command line settings must be made:

  • zenon path:

    ZENPATH=<Pfad>

  • Name zenon project:

    ZENPROJECT=<name>

  • Information on zenon network project:

    REDENABLE=<0,1>

    REDZENON=<0,1>

Watchdog in zenon

zenon checks zenon Logic Runtime Watchdog if:

  • zenon Logic Runtime executes code, timeout is <> 0 and Runtime can be assigned to an integrated zenon Logic project
  • zenon Logic Runtime is stopped
  • zenon Logic Runtime is passive or started passively
  • zenon Logic Runtime is ended and was previously passive or active

Function for recognizing failures

With the Function for failure recognition property, a function is selected that is executed as soon as the time-out defined in Failure recognition after [s] for the watchdog has expired. The watchdog is only rechecked if Runtime is registered again.

If a function from another project is used, the project must already have been loaded when the project with the integrated zenon Logic project is loaded.

Logging

The zenon Logic zenRt driver connection can be logged with the diagnosis Viewer. The module name is zenon Logic. Each message contains the name of the zenon project and the name of the zenon Logic project. The logging includes:

  • Error
    • zprj:<z-project> sprj:<s-project> Runtime <Runtime Process ID> watchdog expired.
      Runtime watchdog was not operated by Runtime for too long.
    • zprj:<z-project> sprj: <s-project> Runtime: <Runtime process ID> Unknown straton project.
      zenon Logic Project cannot be assigned to an integrated zenon project.
  • Warnings
    • vm: <Vm process ID> zenon project '<Name>' unknown
      Name of the zenon Logic projects is not known in zenon.

Watchdog in zenon Logic Runtime

The following applies for zenon Logic watchdog:

  • The zenon watchdog is checked regularly as long as the timeout of the >CD_PRODUCTNAME< failure recognition is <>0.
    This check takes place if:
    • Code is executed
    • Runtime is active or passive.

Function block zenrt_Red and RedSwitch

In zenon Logic you can check with the help of function blocks whether a connection to a zenon Server exists and you can switch the zenon Logic state if necessary.

The function block zenrt_Red checks via the timeout information from driver "straton_to_zenon_Runtime_Connection" whether zenon Logic is connected to a zenon Server. If this is not the case, you can switch the affected zenon Logic to inactive with the help of function block RedSwitch and switch the Standby to active.

For more information about function blocks see the zenon Logic online help.

Time handling in function block zenrt_Red

The number of switch attempts count up in the time-out cycle. If the zenon Logic Runtime project cannot be assigned to a zenon network project, the network timeout time (Timeout [s] property in Network group) is added to the failure recognition time (Failure recognition after [s] property). The time that the ERROR output is active is now no longer MAX_SWITCH * cycle but MAX_SWITCH * timeout [+ network timeout].

The non-process-handling, non-dominant zenon computer is considered a Standby Server.
The non-process handling, dominant computer (server starts as standby) is not considered a standby.


OEM specification

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> OEM specification

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In this OEM specification the possibilities of the COPA-DATA zenon Logic Runtime are described which are referred to in the zenon Logic Workbench help with "see OEM specification".

Configuration (Project properties)

As a standard the zenon Logic Workbench contains several features and an extensive library of functions and function blocks.. Depending on the Runtime configuration, some features or blocks may be not available. Therefore it is possible to select configurations for the Workbench in order to highlight the features which are not supported by the Runtime.

In the zenon Logic Workbench a list of this configurations is available under Project -> Configuration.... This can change with the product/version cycle.

File administration function (function blocks)

This function makes it possible to read and write files sequentially.

The follwoing functions are supported by zenon Logic Runtime versions

  • CE
  • RT (PC)
  • RTK (PC)

and are implemented not blocking:

F_ROPEN, F_WOPEN, F_AOPEN, F_CLOSE, F_EOF, FA_READ, FA_WRITE, FM_READ, FM_WRITE, FB_READ, FB_WRITE, F_EXIST, F_GETSIZE, F_COPY, F_DELETE, F_RENAME, LogFileCSV

The follwoing functions are only supported by zenon Logic Runtime versions

  • CE
  • RT (PC)

and are implemented not blocking:

F_EXIST, F_GETSIZE, F_COPY, F_DELETE, F_RENAME

The possible paths vary depending on the operation system. Note that some folders are write-protected if UAC (User Account Control) is activated.

SFC execution

The execution of the SFC program equals that of a T5 standard target system und follows the information of the zenon Logic Workbench help.

The exclusiveness of transitions within a divergence is supported.

Interlink applications - Binding

A maximum of 65535 Binding variables can be published in the network. However this value is reduced by every variable which is sent to zenon using the event service.

The standard IP port number of a zenon Logic Runtime is 9000.

Project properties - "C" compiler

This feature is supported by all zenon Logic target systems (RT, CE, RTK). All C compilers which are normally proposed by the zenon Logic Workbench can be used. Attention: Only use the default name of the created Runtime-DLL.

LogFileCSV (function block)

See first point: File administration function (function blocks).

Additional OEM relevant features and functions:

Feature | RT (PC) | RTK (PC) | CE
DTAT (function block) | x | x | x
TCP/IP management functions | x | x | x
Dynamic memory allocation function | x | x | x
PrintF (function) | x | x | x
Step by step debugging | x | x | x
Functions for real time clock administration | x | x | x
Digital sampling recording | x | x | x
UDP management function | x | x | x
T5 registry management functions | - | - | -
DTFORMAT (function) | x | x | x
GETSYSINFO (function) - _SYSINFO_CYCLESTAMP_MS | x | x | x
Variable status bits | x | -1 | x
DAY_TIME (function) | x | x | x
SET_DAY_TIME (function)2 | x | - | x

Key:

  • x: Supported
    • 1: Driver which support the variable status bits are only emulated or not supported by the zenon Logic RTK. Therefore no access is granted to the status bits or the time stamps.
    • 2: zenon internally works with UNIX time. Therefore only system times within their validity are allowed (0-MAXDINT starting with 1.1.1970 0:00 GMT). Data which refer to an earlier point in time affect the functionality of the zenon Runtime.
  • -: Not supported

Retain variables (remantent flags)

Retain variables saved at the defined saving location - normally in the instance path (hand over parameter PATH) - when the Runtime is stopped or closed in a normal way. Depending on the system, it can be the hard disk or a flash card.

With function "WriteHot" retain data and hot restart data can be saved explicitly, e.g. after every change or cyclically.

Some zenon Logic I/O drivers support saving the RETAIN values to the SRAM (battery buffered RAM), e.g. the ThinkIO/System758 driver.

In order for the RETAIN values to be loaded when the PLC application is restarted, the zenon Logic Runtime must be started with the corresponding handover parameters/settings (cold start - load RETAIN variables).

You can find information regarding the configuration of Retain data with the zenon Logic Runtime in the chapter settings/general.

I/O Driver

You can find more information about supported I/O drivers here: zenon Logic I/O driver support

You can find information about the support of Online Change or Hot Restart here: zenon Logic I/O driver: Hot-Restart/Online Change


Forwarding time stamps and variable status information

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> Forwarding time stamps and variable status information

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

As of version 6.22 SP1 Build 3 the zenon Logic Runtime automatically forwards time stamp and variable status information from the zenon Logic I/O driver to the event handler of the zenon Logic Runtime and thus via straton32 to zenon. Therefore in zenon (e.g. CEL) the time stamp of the source (I/O driver slave or server) are displayed and not the time stamp of the zenon Logic Runtime.

The following prerequisites are necessary:

  • The variable must have a time stamp in the zenon Logic I/O driver. It depends on the protocol. Some drivers do not provide time stamps.
  • The zenon Logic project must have been compiled and loaded with compiler flag Create status bit for variable with profile turned on.

Overview forwarding the time stamp:

Note: The names zenon and zenon Logic in the graphic are just examples. They can be different depending on the configuration and correspond to zenon and zenon Logic.


zenon Logic I/O driver support

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> zenon Logic I/O driver support

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

I/O drivers which are supported by different zenon Logic Runtime types:

Drivers | RT (PC) | RTK (PC) | CE
Advantech ADAM 5550 | - | - | -
Anybus Configuration | x | E | -
ApplicomIO Configuration | x | E | -
AS-interface | x | - | -
BECKHOFF CX1000 | - | - | x
Brodersen IOTOOLS | x | E | -
CAN-bus | - | - | -
Hilscher CIF Profibus | x | x1 | x
Hilscher SYCON Configuration | x | E | x2
Hischer SYCON Configuration [universal] | x | x | x
Hilscher SYCON.net Configuration | x | E | -
IEC 60870 Slave | x | - | x
IEC 61850 Client | x | E1 | x
IEC 61850 Server | x | - | x
Interbus-S | x | E | -
MODBUS Master Protocol | x | E | x
MODBUS Slave Protocol | x | E | x
PROFINET IO | x | E | x
SoftNet ProfibusDP | x | E | -
straton to zenon Runtime connection | x | - | x
ThinkIO/IO System 758 | - | - | x
Wago 750-860 | - | - | -
Weihenstephan Standard - Client | x | E | x
Win32 Shared memory | x | - | -
XFlow | - | - | -

Legend

x: Fully supported

-: Not supported

E: Carried out as emulation (performance loss possible, determinism is limited in the PLC cycle, driver selection at a BSOD)

1: The driver specific function blocks do not work under zenon Logic RTK.

2: Hilscher DLLs must be available on the target platform.


zenon Logic I/O driver: Hot-Restart/Online Change

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> zenon Logic I/O driver: Hot-Restart/Online Change

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The zenon Logic I/O drivers support the Hot-Restart or Online Change in different ways:

Drivers | Hot-Restart | Online Change | Online Change including change of the bus driver configuration
Anybus Configuration | x | x | x1
ApplicomIO Configuration | x | x | x1
AS-interface | x | x | x1
BECKHOFF CX1000 | x | x | -
Brodersen IOTOOLS | x | x | x1
Hilscher CIF Profibus | x | x | -
Hilscher SYCON Configuration | x | x | x1
Hischer SYCON Configuration [universal] | x | x | x1
Hilscher SYCON.net Configuration | x | x | x1
IEC 61850 Client | x | x | -
Interbus-S | x | x | -
MODBUS Master Protocol | x | x | x1
MODBUS Slave Protocol | x | x | x1
PROFINET IO | x | x | -
SoftNet ProfibusDP | x | x | x1
straton to zenon Runtime connection | x | x | -2
ThinkIO/IO System 758 | x | x | -
Weihenstephan Standard - Client | x | x | x1
Win32 Shared memory | x | x | x1

Legend

x: Functionality available

-: Functionality not available

1: Online Change including the change of the bus driver configuration is always followed by the reinitialization of the I/O driver. Because of the reinitialization I/Os can fail for a short period!

2: No need for change in the bus driver configuration.


Error messages

Manual -> zenon Logic -> zenon Logic Runtime (Soft PLC) -> Error messages

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Errors during the execution are logged in the log file.

Error message | Description
General error. | Error which could not be specified any further.
Invalid application code - bad header. | STRATON.cod file is invalid. Header invalid.
Invalid application code - bad target ID. | STRATON.cod file is invalid. Target ID invalid.
Invalid application code - bad version. | STRATON.cod file is invalid. Version invalid.
Unknown communication request. | Host and Runtime not compatible (T5 protocol).
Cannot process read request. | Incoming communication request cannot be processed.
Unknown TIC code. | Invalid instruction in file straton.cod.
Too many DATA8 used. | Too many SINT/USINT variables used.
Too many DATA16 used. | Too many INT/UINT variables used.
Too many DATA32 used. | Too many DINT/UDINT/REAL variables used.
Division by 0 in TIC (32bit). | Division by 0 in the PLC logic of the user.
Too many TIME variables. | Memory overflow for online change.
Infinite loop in TIC (safe mode). | Not closed loop in the application code.
Standard function used, which is not supported by this runtime. | PLC logic of the user refers to a function which is not available in this version of the Runtime.
Division by 0 in TIC (64bit). | Division by 0 in the PLC logic of the user.
Too many DATA64 used. | Too many LINT/LREAL variables used.
Too many strings. | Memory overflow for online change.
Division by zero in TIC (8 bit). | Division by 0 in the PLC logic of the user.
Division by zero in TIC (16 bit). | Division by 0 in the PLC logic of the user.
Hot restart: System resources used. | Hot restart not possible.
Invalid variable map in hot restart. | Hot restart not possible.
Bad build stamp for hot restart. | Hot restart not possible. Invalid straton.cod version.
SFC changed - no hot restart! | Hot restart not possible.
Retain definition has changed - no hot restart. | Hot restart not possible.
Bad DB format - no hot restart! | Hot restart not possible.
Cycle time overflow. | Cycle time overflow. For details, see the Cycle time error messages section.
Can not store retain variables. | Not enough memory in order to save retain variable.
Array index out of bounds. | Access to invalid array index.
Recursive call of sub-program. | A sub-program calls up itself.
Too many external variables used. | Memory overflow for online change.
Too many tasks. | Memory overflow for online change.
Call stack overflow (hot). | Memory overflow for online change.
Stack overflow. | Too many call ups of intricate sub programs.
Can not hot restart (ASi). | Hot restart not possible (Asi bus driver).
Online change not supported. | Online change not possible
Online change failed - Bad code. | Online change not possible. Invalid straton.cod version.
Online change - Not the same application. | Online change not possible
Online change failed - IO drivers. | Online change not possible
Online change failed - CT segment changed. | Online change not possible
Online change failed - bus drivers. | Online change not possible. Bus driver does not permit online change.
Online change failed - variable map / profiles. | Online change not possible
Online change failed - tasks. | Online change not possible
Online change failed - MODBUS. | Online change not possible
Online change failed - CAN bus. | Online change not possible
Online change failed - event production. | Online change not possible
Online change failed - change D8 alloc. | Online change not possible
Online change failed - change D16 alloc. | Online change not possible
Online change failed - change D32 alloc. | Online change not possible
Online change failed - change D64 alloc. | Online change not possible
Online change failed - change TMR alloc. | Online change not possible
Online change failed - change STR alloc. | Online change not possible
Online change failed - change FBI alloc. | Online change not possible
Online change failed - change CFC alloc. | Online change not possible
Online change failed - change XV alloc. | Online change not possible
Online change failed - STR buff size. | Online change not possible
Online change failed - STR length. | Online change not possible
Online change failed - FBI buffer. | Online change not possible
Online change failed - FBI changed. | Online change not possible
Online change failed - Program style. | Online change not possible
Online change failed - Number of programs. | Online change not possible

Error message cycle time

When the cycle time is exceeded, messages are displayed in the zenon Logic Runtime or in the Workbench and corresponding entries are written to the log file.

Error message user interface | Entry log file | Meaning
Timing configuration error. (x) cycles lost. | Timing configuration error. (x1) cycles lost. Configured cycle time = (x2) us, maximum execution time = (x3) us, maximum PLC utilisation = (x4). | Number (x) of not executed cycles due to cycle time out. The execution time is higher than the set cycle time or there are not enough CPU resources available.
Timing configuration error. PLC utilization peaked at (x)%. | Timing configuration error. PLC utilization exceeds 80%. Configured cycle time = (x1) us, maximum execution time = (x2) us, maximum PLC utilisation = (x3)%." | The execution time is higher than 80% of the set cycle time; actually (x)%.

Troubleshooting

You can fix exceeding the cycle time by:

  • increasing cycle time
  • decreasing execution time, e.g.:
    • use a system with more CPU resources
    • use C compiled code
    • reduce the program


zenon Logic Runtime Manager

Manual -> zenon Logic -> zenon Logic Runtime Manager

The zenon Logic Runtime Manager administrates all zenon Logic Runtime projects, which are stand alone or must be started manually, on your computer. It does not matter whether there is a zenon Runtime installed on the computer.


Why should you use the zenon Logic Runtime Manager?

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Why should you use the zenon Logic Runtime Manager?

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
  • If you created your zenon Logic project in zenon and you set the zenon property of the zenon Logic project RT start type to start manually, the zenon Logic Runtime Manager is the ideal tool for organizing the parameters for the manual start.
  • If you want to start your zenon Logic Runtime project during the booting of the Windows operating system, you can set this with one mouse click in the zenon Logic Runtime Manager.
  • If you want to reorganize your zenon Logic project, you can do this with the zenon Logic Runtime Manager.
  • If you want to run the zenon Logic Runtime autarchically (without the zenon Runtime), it is best to call up the zenon Logic Runtime instance using the zenon Logic Runtime Manager.


Main menu

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Main menu

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com
  • Configurations: There you can administrate the zenon Logic Runtime projects
  • Languages: There you can switch between languages online
  • Settings: Enter the path of the zenon Logic Runtime
  • %: Open the help
  • Exit: Exits the program - Hint: Do not forget to save the settings before you exit the zenon Logic Runtime Manager!


Properties help

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Place the mouse cursor over an element in the zenon Logic Runtime Manager in order to see the corresponding help text in the property help.

In addition all elements of the zenon Logic Runtime Managers are described here:


Configuration list

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> Configuration list

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

This list contains all available zenon Logic Runtime configurations.

Click on an entry in the list in order to display its parameter settings.

After that click on Edit in order to change the parameters.

Click on Save in order to save the changes.


zenon Logic project folder

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> zenon Logic project folder

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The selected path of the zenon Logic Runtime project (storage location of the PLC code) is entered there automatically. You can change this entry manually by left-clicking the folder symbol.

info Information

Before you are able to edit any setting which you have already saved, you must first select the concerning configuration in the list. After that click on button Edit. In order to save the changes, click on button Save.


Name of the configuration

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> Name of the configuration

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

The name of the last path of the zenon Logic Runtime files is entered automatically if a new configuration is created. You can changes this name freely.

info Information

Before you are able to edit any setting which you have already saved, you must first select the concerning configuration in the list. After that click on button Edit. In order to save the changes, click on button Save.


Port (Main)

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> Port (Main)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Enter the main port for the zenon Logic Runtime instance. This port defines the connection of the zenon Logic Workbench and a zenon drivers. Per default this port is set to 1200.

info Information

Before you are able to edit any setting which you have already saved, you must first select the concerning configuration in the list. After that click on button Edit. In order to save the changes, click on button Save.


Port (Binding)

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> Port (Binding)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Enter the binding port for the zenon Logic Runtime instance. The binding port defines the connection for spontaneous TCP/IP communication to other zenon Logic Runtimes. Per default this port is set to 7800 higher than the main port.

info Information

Before you are able to edit any setting which you have already saved, you must first select the concerning configuration in the list. After that click on button Edit. In order to save the changes, click on button Save.


Startup

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> Startup

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Define the startup behavior of the zenon Logic Runtime instance.

  • Cold start - The zenon Logic Runtime starts with initialized variables.
  • Cold start (load RETAIN variables) - The zenon Logic Runtime starts initialized with remanent markers.
  • Hot restart - The zenon Logic Runtime starts with the variable values from the time the Runtime was stopped.

info Information

Before you are able to edit any setting which you have already saved, you must first select the concerning configuration in the list. After that click on button Edit. In order to save the changes, click on button Save.


Start in step mode

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> Start in step mode

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to start the zenon Logic Runtime in step mode, activate this checkbox.

info Information

Before you are able to edit any setting which you have already saved, you must first select the concerning configuration in the list. After that click on button Edit. In order to save the changes, click on button Save.


Windows real time priority

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> Windows real time priority

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order for the zenon Logic Runtime instance to run in the Windows real time priority, activate this check box.

info Information

We recommend to always have the real time priority activated. First and foremost deactivating the real time priority is used for testing purposes (e.g. if there may be infinite loops).

info Information

Before you are able to edit any setting which you have already saved, you must first select the concerning configuration in the list. After that click on button Edit. In order to save the changes, click on button Save.


Hard real time

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> Hard real time

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If you activate this checkbox, the zenon Logic real time PLC (zenon Logic RTK) is called up when the configuration is started. As the zenon Logic real time PLC may only run once on the computer, it is validated that this checkbox is only activated for one configuration.

info Information

Before you are able to edit any setting which you have already saved, you must first select the concerning configuration in the list. After that click on button Edit. In order to save the changes, click on button Save.


Report output

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> Report output

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Activate this checkbox in order to activate the writing of messages of the Runtime in a log file.

info Information

Writing a log file will influence the performance.

info Information

The log file is named "zenon Logic RTLOG.txt" and is saved in the zenon Logic Runtime project folder.

info Information

Before you are able to edit any setting which you have already saved, you must first select the concerning configuration in the list. After that click on button Edit. In order to save the changes, click on button Save.


Auto start

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> Auto start

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to start a zenon Logic Runtime instance directly with the booting of the Windows operating system, activate this checkbox.

info Information

Before you are able to edit any setting which you have already saved, you must first select the concerning configuration in the list. After that click on button Edit. In order to save the changes, click on button Save.


Button "New"

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> Button "New"

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If you want to create a configuration, click on button New. After that a dialog opens in which you can select the folder in which you want to save the zenon Logic Runtime files (the PLC code). Confirm your selection with OK. You can change the name of the configuration. In order to save the configuration and the name of the configuration, click on Save.


Button "Edit"

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> Button "Edit"

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Before you can change the parameters of a configuration, you must click on button Edit after you have selected an entry from the configuration list. In order to save the changes, you must click on Save.


Button "Save"

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> Button "Save"

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Click on button Save in order to save all changes.


Button "Delete"

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> Button "Delete"

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to delete a configuration, select the entry from the configuration list and click on button Delete.


Button "Start"

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> Button "Start"

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

In order to start the zenon Logic Runtime with the respective configuration, select a configuration from the list and click on button Start. The zenon Logic Runtime starts immediately.

info Information

If the folder of the configuration does not contain any zenon Logic Runtime files (PLC code), the <CA_PRODUCTNAME >Runtime starts in mode No program.


zenon Logic Runtime (settings)

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> zenon Logic Runtime (settings)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Enter the folder of the zenon Logic Runtime (folder of stratonRT.exe). In order to browse through your hard disk, left-click the folder symbol.


Language selection (languages)

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> Language selection (languages)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

Select the desired language by clicking on the respective flag.


Show splash screen (setting)

Manual -> zenon Logic -> zenon Logic Runtime Manager -> Properties help -> Show splash screen (setting)

Previous chapter Next chapter Show all Show all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. E-Mail: documentation@copadata.com

If you activate this check box, the splash screen of the zenon Logic Runtime Manager is displayed at the start.


Drivers

Drivers

In this area you can find the zenon driver documentation.


Tutorials

Tutorials

In this area you can find the zenon tutorials.


Glossary

Glossary

In this glossary all important terms which are used in zenon are described briefly.


A

Glossary -> A

absolute time period

The exact point in time at which an action shall be executed.

absolute time period

Time period that is not related to the current time.

activation number

An individual string of characters that unlocks the product. This number is checked against the serial number + the dongle number resp. the serial number + the license number.

Active Directory

The directory service of Microsoft Windows server operating systems, which manages different objects in a network, such as users, groups, computers, servers, file sharing and other devices like printers or scanners and their properties.

Active Directory Application Mode

Functionally limited version of the Active Directory service, which is used for the connection of applications or services that require LDAP-compliant information.The user management of zenon can optionally read user information from this service.

Active Directory Lightweight Directory Service

Functionally limited version of the Actvie Directory directory service. It is used for applications and services which need LDAP conform information. Available from Windows Vista, Windows Server 2008.The zenon user administration can read out the user information from AD LDS.

Active X

A software component model for active content by Microsoft. ActiveX components extend Microsoft's Component Object Model (COM) standards.

ActiveX

A software component model for active content by Microsoft. ActiveX components extend Microsoft's Component Object Model (COM) standards.

ActiveX control

A dynamic element in the control system or a control element for VBA/VSTA based on the Microsoft ActiveX technology.

ActiveX element

A dynamic element in the control system or a control element for VBA/VSTA based on the Microsoft ActiveX technology.

ActiveX interface

Allows you to pass data/control commands to ActiveX.

ActiveX settings

The parameters that define the behavior of an ActiveX element.

actual deviation

Difference between the actual value and the desired value

actual value

The current value in the process image. This can be the sponateous value, the alternate value or the faulty value (status I-bit).

actuator

Technical device that translates an input value into a different output value in order to cause an action or an effect. In process measuring and control, actuators constitute the counterparts of sensors and are the controlling elements in a closed loop control. They transform the signals of a control unit into (most frequently) mechanical action (movements). One example for such an action is opening and closing a valve.

AD LDS

Functionally limited version of the Actvie Directory directory service. It is used for applications and services which need LDAP conform information. Available from Windows Vista, Windows Server 2008.The zenon user administration can read out the user information from AD LDS.

ADAM

Functionally limited version of the Active Directory service, which is used for the connection of applications or services that require LDAP-compliant information.The user management of zenon can optionally read user information from this service.

agent

A small program that monitors devices communicating bidirectionally with zenon drivers and that also allows you to change settings.

alarm area entry

Assignes an alarm/event class to an alarm area. Each entry has status variables which display the status of all alarms in the alarm/event class.

alarm cause

Freely definable cause for the occurrence of an alarm in the Industrial Performance Analyzer. The possible alarm causes are managed in a list and can assigned to alarms in the IPA. Alarm causes can be used as filter criterion.

Alarm entry

A single event which is saved in the Alarm Message List.

Alarm Message List Filter

Screen type with which user-specific filter screen for the Alarm Message List can be engineered.

alarm statistics

Evaluation of alarms (length, frequency, etc.) with the help of the Industrial Performance Analyzer.

alarm status line

Information line which is always displayed in the foreground in front of all programs in the Runtime. It displays either the oldest or the newest alarm which has not been acknowledged.

alarm/event class

Is used for classifying events in the AML/CEL. Can be used freely, e.g. for the local allocation to areas but also for the grouping according to priorities such as message, failure, alarm etc.In contrast to alarm/event groups, the alarm/event classes can be used for coloring the AML/CEL. Likewise alarm/event classes can be assigend to alarm areas.

alarm/event group

Is used for grouping events in the AML/CEL. Can be used freely, e.g. for the local allocation to areas but also for the grouping according to priorities such as message, failure, alarm etc.In contrast to alarm/event classes, alarm/event groups can be log off from the control.

Alarm-S associated value

Driver object type which transfers the associated value of the S7-PDiag system to the control system. The associated value contains e.g. the step number of the failed step in S7 Graph.

Alarm-S message

Driver object type which transfers information of the S7-Pdiag system to the control system. On offset 0 the message number with data type UDINT is transferred.On the offset of the message number a data type BOOL is used to define whether the message is active.

Alarm-S telegram

Alarm message of Siemens Simatic S7 PDIAG system.The telegrams can be read via S7TCPC driver from the control and can be inserted directly in the Alarm Message List as alarm entries.

Alarm-S variable

A variable which is based on the driver object type Alarm-S message.

ALC

Automatic Line Coloring is a module which makes it possible dependent on the state of the process to color lines (depicted by line, rectangle, line-vector element). As process engineering element the combined element is used.The ALC is used for the simple automatic dynamization of lines in process engineering (for media) and for topological grids in electrical engineering (for electric current).

Alt

Key which - together with another key - triggers special program actions or sums up menu steps; e.g. Alt+F4 - exit a program.

Alt key

Key which - together with another key - triggers special program actions or sums up menu steps; e.g. Alt+F4 - exit a program.

alternate value

The alternate value can have many functions. For one thing it is used to fill up archives with the predefined alternate value of the variable. For another thing the user can overwrite the current value with the alternate value. This value is not transferred to the connected hardware but stays in the process image of the computer. This value is sent to and used in all zenon modules.

animation

A technique in which a moving images is created by displaying several single images.

API

Interface for apllication programming which is made available by a software system for other programms in order for connecting and interaction with the system.

Application Programming Interface

Interface for apllication programming which is made available by a software system for other programms in order for connecting and interaction with the system.

arc of a circle

Vector element which depicts a quadrant.

archive

Storage location for historic data. The following data are saved: value, time stamp in ms and the status of the variables.

archive data

Values of all variables engineered in the archive which have been saved in the archive in the Runtime.

archive evacuation

After a definable period of time archive files can be removed from the system. The time and the format in which the data are stored can be defined.

archive file

File in which the Historian saves archive data.

archive revision

Screen type in which archives can be opened and individual data sets can be modified.

archive saving cycle

Temporal distance between the creation of new archive data.

archive saving format

File format in which archives are saved.

archive variable

A variable which is used in an archive. Depending on the settings the values of the variable are recorded in the archive.

array

Field of variables of the same type. The field can have up to three dimensions. The numbering of the indices starts at 0 or at 1. In contrast to block arrays every variable can be used individualy in all modules and counts as a single TAG for licensing.

ASCII

The American Standard Code for Information Interchange is a character-encoding scheme based on the ordering of the English alphabet. ASCII codes represent text in computers, communications equipment, and other devices that use text. Most modern character-encoding schemes are based on ASCII, though they support many more characters than did ASCII.

assembly line

Automated production system in which several processing stations are connected with each other with the help of conveyor belts. Different products may use various assembly lines which then use different parts of the production line.

assistant

Guides the user through the parameterization and simplifies the creation of complex objects. In contrast to the VBA wizards, it is integrated directly in the program and cannot be modified.

autarkic

Existing independent of other components.

authorization group

Sums up 32 authorization levels in a variable of type UDINT.

authorization level

Defines whether a user can carry out an action. For each control element in a screen an authorization level can be assigend. Likewise authorization levels can be assigned for special functions such as acknowledge alarm, load project in Editor, etc.There are 128 levels (0 - 127) whereas 0 is the system level which every user has.

automate

The transfer of work from humans to automats or the summary of recurring functional routines.

Automatic Line Coloring

Automatic Line Coloring is a module which makes it possible dependent on the state of the process to color lines (depicted by line, rectangle, line-vector element). As process engineering element the combined element is used.The ALC is used for the simple automatic dynamization of lines in process engineering (for media) and for topological grids in electrical engineering (for electric current).

automation

The transfer of work from humans to automats or the summary of recurring functional routines.

AVI

Audio Video Interleave (AVI) is a multimedia container format introduced by Microsoft. AVI files can contain both audio and video data in a file container that allows synchronous audio-with-video playback.


B

Glossary -> B

background graphic

External raster graphic which is displayed behind all screen element.

backspace

Key which deletes the character on the left side of the cursor.

backspace key

Key which deletes the character on the left side of the cursor.

backup

Additional saving of data (e.g. projects or workspace) in order to restore them later.

backward compatibility

Backward compatibility refers to new or extended versions that can be used under the operation conditions of an earlier version.

bar display

Dynamic element for the analog display of a signal. At this the length of a bar varies analog to the size of the signal.

base unit

Measuring unit whose value is used as the base for the calculation of the value of the conversion unit.

Batch operation

Automatic and sequential processing of a stack of single operations.

Beckhoff-TwinCAT

Uses any compatible PC as real time control with multi PLC system, NC axis control, programming environment and control station. Substitutes conventional PLC and NC/CNC controls and control devices.

binary value

Value which has only two states. It can either be 0 or 1, Low or High, etc.

binary variable

Variable whose value can take on one of two states. 0 or 1, Low or High, True or False, etc.

bitmap

Two dimensional raster graphics format which was developt for the operating systems Microsoft Windows and OS/2 and was introduced with Windows 3.0. In general the file ending is .bmp, sometimes .dib.

bitmap button

Dynamic element with which an action (execute function, write set value) is triggered. The bitmap button can only display graphics files. From 6.50 on it is replaced by the dynamic element button.

block array

One dimensional variable field whose field size is adjustable. The complete block is read and written at once by the driver. With this better performance is possible especially at control using symbolic addressing.

block write

Summary of several write commands to a write telegram. This is for example used when a recipe is written.

Blue Screen of Death

Is a colloquialism used for the error screen displayed by some operating systems, most notably Microsoft Windows, after encountering a critical system error that can cause the system to shut down to prevent irreversible damage to the system's integrity. It serves to present information for diagnostic purposes that was collected as the operating system issued a bug check.

BMP

Two dimensional raster graphics format which was developt for the operating systems Microsoft Windows and OS/2 and was introduced with Windows 3.0. In general the file ending is .bmp, sometimes .dib.

breakpoint

Describes a certain position in a program at which the debugger stops when processing commands.

BSOD

Is a colloquialism used for the error screen displayed by some operating systems, most notably Microsoft Windows, after encountering a critical system error that can cause the system to shut down to prevent irreversible damage to the system's integrity. It serves to present information for diagnostic purposes that was collected as the operating system issued a bug check.

build

Builds contain bug fixes. Every time the version is compiled, the build nummer is increased. This builds are made available for customers concerned. Builds are only partially subjected to the quality assurance process. All builds are summarized in Service Packs which pass through the complete quality assurance process.

bus driver

Computer program or module which is used for the interaction with connected (field) buses.

bus terminal

Intelligent series terminal which can process different analog and digital input and output signals. It is housed and wired in a simple and compact way just as a conventional series terminal. In contrast to a series terminal, it is equipped with intelligent electronics.

bus terminal controller

A bus terminal unit generally consists of a bus coupler and several electrical terminal blocks. The bus couper has an interface to a fieldbus and thus connects the bus terminals with the control system. Bus coupler which haver their own "intellegent" electronics are called bus terminal controller.

button

Describes a graphic element in the user interface. By clicking the element the linked command is carried out.

button for screen alarming

Dynamic element with which the screen alarming can be implemented. Only available for SICAM 230.


C

Glossary -> C

calendar dispaly

Control element which displays a calendar for selecting a date.

CE Editor

Special editor for Windows CE projects which allows only the settings suitable for Windows CE.

CEL

Central management of events in the control system. The Chronological Event List (CEL) is maintained twice: Once as a ring buffer in the memory and once as historic data stored in files on the hard disk.In contrast to the Alarm Message List the CEL manages only the time stamp "received".

CEL entry

A single event which is saved in the Chronological Event List.

CEL event

A limit violation which triggers an entry in the Chronological Event List.

central server project

A multi-user project is managed centrally on a computer which has been defined as server. Changes can be made in any number of connected local project copy.

CFC

Is a sort of freehand FBD editor. Other than in the network-oriented FBD editor where the connections between inputs, operators and outputs are set automatically they have to be drawn by the programmer. All boxes can be placed freely which makes it possible to program feedback loops without interim variables.

check recipe values

Checks the recipe values in the control system with the values in the control. If they match, they are displayed green, otherwise red.

checkbox

A standard element of the graphical user interface (GUI) of a software. In general a checkbox has two states. Sometimes it can have three or more states.

checking for changes

Data are scaned for modifications.

Chronological Event List

Central management of events in the control system. The Chronological Event List (CEL) is maintained twice: Once as a ring buffer in the memory and once as historic data stored in files on the hard disk.In contrast to the Alarm Message List the CEL manages only the time stamp "received".

Chronological Event List Filter

Screen type with which user-specific filter screen for the Chronological Event List can be engineered.

client

A program which communicates with another program - the server - in order to obtain access to services (functions) and/or data.

client project

Project for which network is activated and a server in entered. It obtains all data (except local variables of the intern driver and the system driver) from the server project via the network (TCP/IP communication).

CoDeSys

IEC 61131-3 PLC system by company 3S.

column setting

Defines the width, header, sorting order, sorting type, grid display, background color etc.

COM port

Serial communication interface.

Combined element

Universal dynamic element which can take on various graphical characteristics: graphics, symbol from library, symbol embedded in screens or text.The display is defined by the variable values of the main variable or additional variables. It is possible to: - evaluate status information of all linked variables- create any link via formulas- transfer states of the main variable directly to the combined element- implement procedural elements for the Automatic Line Coloring

combo-/listbox

Dynamic element which - dependent on the variable value - displays a text in the selection list. By selecting an entry the corresponding value is written or the corresponding function is carried out.You can define whether a combobox or a listbox is displayed.

combobox

A user interface control GUI element, similar to a list box, which allows the user to choose one value from a list. When a drop-down list is inactive, it displays a single value. When activated, it displays (drops down) a list of values, from which the user may select one. When the user selects a new value, the control reverts to its inactive state, displaying the selected value.

command element

Dynamic element with which commands for module Commands are written.

Command Processing

Describes a special way of writing set input in the energy sector. The command is written via a variable (aktion variable) and read back via a second variable (response variable).Before a command is written, the interlocking conditions are checked. It is also checked whether the control allows the writing - Select Before Operate.

compile

At compiling the program written in a source language - also called source code - is converted in a semanticly equivalent program in the target language.In general this is a translation of a source code written by a programmer in an assambler language, byte code or machine language.

compiler

A compiler is a computer program (or set of programs) that transforms source code written in a computer language (the source language) into another computer language (the target language, often having a binary form known as object code). The most common reason for wanting to transform source code is to create an executable program.

connection timeout

Period of time in which no response from the control can take place without triggering a reaction.

Continuous Function Chart

Is a sort of freehand FBD editor. Other than in the network-oriented FBD editor where the connections between inputs, operators and outputs are set automatically they have to be drawn by the programmer. All boxes can be placed freely which makes it possible to program feedback loops without interim variables.

control element

Special elements for each screen type with which the control, selection and input is implemented. These elements can be buttons, static texts, combo boxes, list boxes, graphical displays, input fields, radio buttons, spin controls, calendar displays, date displays or time displays.

control room

Technical equipment which supports during the control of a process. ???

conversion unit

Measuring unit whose value is calculated from the base unit at the unit conversion: The value is multiplied by a factor increased or decreased by an offset. In addition a point shifting can take place.

CSV

Character Separated Values - describes the structure of a text file for saving or exchanging simply structured data.

CSV file

File which contains data of type CSV (Character separated values).

cyclic recording

The data are saved to the archive according to preset time intervals.

cyclic scanning

The data are saved to the archive according to preset time intervals.

cycling archiving

The data are stored in the archive according to the set time intervall.


D

Glossary -> D

data block number

Distinct number of a data block in a Siemens control.

dBase

dBase was the first widely used database management system (DBMS) for microcomputers, published by Ashton-Tate for CP/M, and later on IBM PC under DOS.dBase's underlying file format, the .dbf file, is widely used in many other applications needing a simple format to store structured data.

decluttering

Function of teh worldview: dependent on the set zoom level, certain objects are displayed/hidden.With this the clarity of the worldview is increased.

diagnosis client

Program which connects with the diagnosis server via TCP/IP and which sends error protocols to the diagnosis server. Each zenon program acts as a diagnosis client.

Diagnosis Server

Program for error analysis: error protocols are sent from the diagnosis clients to the server and stored by it in LOG files.The diagnosis server is integrated in the transport service.

diagnosis settings

Defines which bits of information are sent to the diagnosis server.

dialog font

The type of font which is used in the default program dialogs in the Runtime.

digital signal

Transfers a piece of information, e.g. an electrical alternating voltage in terms of a numerical order which describes the piece of information mathemetically in contrast to an analog signal which transfers a physical quantity directly or with the help of another physical quantity.

distributed engineering

Simultaneous editing of a project in the Editor by several users on several computers.

dongle

Hardware which protects software from unauthorized use.

dongle license

Ties the use of the software to the presence of a dongle at the computer or the network.

dongle licensing

Type of licensing for which the license is bound to a dongle. In contrast to the soft-licensing this type of licensing is not computerbound and therefor portable.

dongle number

Unambiguous number which is burned in the dongle and must match the product ID of the serial number. The dongle number can be seen on a sticker on the dongle. It can also be read out using the WIBU-KEY software.

dongle server

Computer on which a special dongle software runs which enables the access to a network dongle.

driver

A computer program or module which controls the interaction with connected or build-in devices (hardware). For this it uses interfaces to the communication bus or other communication systems with which the device is connected in order to send or receive control signals or data to or from the device.

driver command

A command with which you can set a driver to a defined state. Example: start driver, stop driver, etc.

driver image

Each driver manages the current state of the processes/signal states in the image. Changes of the driver images are synchronized with the process image.

driver object type

Specifies an area of a control. Varries from manufacturer to manufacturer. Possible types are: marker, data block, holding register, coil, etc.

drop-down list

A user interface control GUI element, similar to a list box, which allows the user to choose one value from a list. When a drop-down list is inactive, it displays a single value. When activated, it displays (drops down) a list of values, from which the user may select one. When the user selects a new value, the control reverts to its inactive state, displaying the selected value.

dynamic element

A dynamic element represents variable values in graphic form. The internal managing is based on vectors. Therefore lossless scaling is possible.

dynamization

Dependent on variable values, a display is changed. The change can be manifold: color change, flashing, display of differnet graphics files, change of position, rotation, visibility, transparency, etc.


E

Glossary -> E

Editor profile

Saved the position and availability of buttons of the tool bars and the order of the tool bars in the Editor. In addition the position and the size of teh Editor windows is saved.You can save up to 10 Editor profiles.

EIB

Standard in accordance to EN 50090 in the current version of the KNX standard also in accordance with ISO/IEC 14543-3. Describes how sensors and actuators are connected with each other in a house and defines how they must communicate with each other (protocol).

EIB interface

Interface which conforms to the EIB standard.

embedded data type

Data type which is integrated in a structure data type as structure element. In contrast to the linked data type it is a copy of the original data type. With this all properties can be defined at the structure element.

embedded symbol

A group of graphical elements in a screen which are combined and receive an unambiguous name. In contrast to linked symbols, the storage location is in the screen.

End

Key which moves the cursor last possible position or to the end of the line.

End key

Key which moves the cursor last possible position or to the end of the line.

energy forecast

Special screen type; only available for SICAM 230.

equipment

Methodical compilation of components in order to fulfill a certain purpose.

equipment group

Element of the equipment modeling for assigning objects (variables, recipes, functions, archives, etc.) to a physical equipment across projects.

equipment identifier

Additional identifier for variables that allows them to be filtered in the Industrial Performance Analyzer. An equipment identifier can be specified as a prefix in the name or the identification of the variable.

equipment model

Allows you to subdivide a physically existing system into any number of hierarchically structured equipment groups.

Equipment modeling

A module which makes it possible to group objects in equipment groups after the fashion of a hierachical tree. Variables, recipes, functions, archives etc. can be allocated to these equipment groups across projects. It can be filtered for the equipment groups in the Editor and in the Runtime. The equipment modeling can only be carried out in a global project.

European Installation Bus

Standard in accordance to EN 50090 in the current version of the KNX standard also in accordance with ISO/IEC 14543-3. Describes how sensors and actuators are connected with each other in a house and defines how they must communicate with each other (protocol).

event port

TCP port via which the application communicates events.

event-triggered archiving

The data are saved to the archive when a positive edge occurs on the event variable.

event-triggered recording

The data are written to the archive at the positive edge of the event variable.

Extended Trend

Displays online values and historic values in term of curves in a diagram.

external variable

External variables allow for the data exchange with the PLC via a driver. An external variable is the image of a defined memory areain the PLC. This memory area can be read and written to by both the control system and the PLC.


F

Glossary -> F

fault locating

Enhancement of the Automatic Line Coloring. If a fault is reported by a ground fault relay or a short circuit relay, the affected lines are colored with a fault color.

FBD

Is a diagram, that describes a function between input variables and output variables. A function is described as a set of elementary blocks. Input and output variables are connected to blocks by connection lines. An output of a block may also be connected to an input of another block.

FDA 21 CFR Part 11

Use of safe, computer-generated time-stamped protocols in order to record user input independent of date and time and to record actions which create, change or delete electronic entries.

FDA 21 Code of Federal Regulations Part 11

Use of safe, computer-generated time-stamped protocols in order to record user input independent of date and time and to record actions which create, change or delete electronic entries.

FIFO

Describes a process of saving data in which the elements which have been saved first are taken from the memory first. The opposite principle is called last in first out (LIFO).

filter profile

Saves the used filters of the current screen in the Runtime. Any number of filter profiles can be saved.

first in first out

Describes a process of saving data in which the elements which have been saved first are taken from the memory first. The opposite principle is called last in first out (LIFO).

Frame

Defines the size and location of an area on the monitor in which screens are displayed in the Runtime. Each screen is based on a frame. You can define certain settings for a frame which are then transferred to all screens which are based on the particular frame.

Frame Editor

Graphical user interface with which the size and location of frames can be defined.

frame shape editor

Graphical user interface with which you can define freely the form of frames.

function block diagram

Is a diagram, that describes a function between input variables and output variables. A function is described as a set of elementary blocks. Input and output variables are connected to blocks by connection lines. An output of a block may also be connected to an input of another block.


G

Glossary -> G

GIF

Graphics Interchange Format is a graphics format with a good lossless compression for graphics with low color depth (up to 256 different colors per single image). Furthermore several single images can be saved as one file and they can be interpreted as animation.

global project

Serves as a template for objects which can be used in all projects of the same workspace; e.g. frames, users, fonts, equipment models, etc.

granularity

Defines with how many digits values are read from the control. For example the values from a Siemens S7 control are read with the granularity byte. So it is not possible to read a single bit. You must always read the whole byte which contains the corresponding bit.

grid element

Part of an electrical grid. For example: line, generator, switch, transformer, etc. A combined element or a line, a polyline or a pipe is used to depict theses elements in a screen.

ground fault recognition device

A line protection device for identifing ground faults in a grid element.


H

Glossary -> H

handler

Person or organization who induce using e.g. a software without being the user themselves.

hard disk data storage

Saves variable values cyclically in a FIFO ring memory on the hard disk. For each variable a file with the file extension HDD is created in the Runtime folder.

hard PLC

PLC implemented as hardware in a control cabinet. For example micro PLC, compact PLC, panel PLC, embedded PLC, etc.

hardware modus

In contrast to the simulation mode a communication with the control is established. The variable values are calculated by the control. The communication can be stopped via driver commando (offline mode) and restarted (online mode).

Historian

Module which is used to record historical data. The historian is used to administrate archives.

hot restart

In straton hot restart means the restart of a straton application with exactly the same variable values as during the closing of the application.

HTML

Is a text-based markup language for structuring content such as texts, graphics and hyperlinks in a document. The screen of type HTML displays HTML content.

HTML file

Text file which is structured in accordance with the HTML standard of the W3C.


I

Glossary -> I

IEC 61131-3

IEC 61131-3 is the third part (of 8) of the open international standard IEC 61131, and was first published in December 1993 by the IEC. The current (second) edition was published in 2003. Part 3 of IEC 61131 deals with programming languages and defines two graphical and two textual PLC programming language standards:1.) Ladder diagram (LD), graphical 2.) Function block diagram (FBD), graphical 3.) Structured text (ST), textual 4.) Instruction list (IL), textual 5.) Sequential function chart (SFC), has elements to organize programs for sequential and parallel control processing.

IEC data type

Simple data type defined in IEC 61131-3 such as INT, USINT, etc.A fixed area of values (fixed top and bottom limit) with an exactly defined number of values is defined. Therefore real numbers can be displayed only as floating point numbers with a certain accuracy.

IMM

Module for the administration of machine and maintenance data. Service intervals can comfortably be planned and administered. At a glance you will see, which device, equipment, machine, etc. has to be maintained today / this week / next month etc. Additionally it logs all the maintenance work performed in the past. The module saves thedata in any SQL database supporting ODBC.

Industrial Maintenance Manager

Module for the administration of machine and maintenance data. Service intervals can comfortably be planned and administered. At a glance you will see, which device, equipment, machine, etc. has to be maintained today / this week / next month etc. Additionally it logs all the maintenance work performed in the past. The module saves thedata in any SQL database supporting ODBC.

Industrial Performance Analyzer

Module which helps to analyze alarm data statistically. With this convenient tool, you can localize and disclose weak points in your system. You find out quickly which errors occur most often and which errors cause the longest downtimes.The Runtime writes alarm and shift information (when using the Production & Facility Manager) in an ODBC-able database. Several Runtime systems can save their data in one central database. Therefore the data evaluation can be carried out across several pieces of equipment/systems.

input field

Control element in which you can enter characters.

instance DB

Data block in S7 which contains the runtime variables for a S7 Graph sequential function chart. Each function chart has excatly one instance DB. In general the instance DB has the same number as the function data block of the functional chart.

instance DB variable

Variable as block array which contains the whole instance DB of a S7 Graph sequential function chart. All status information is read out via this variable.

internal driver

Driver on which variables can be created which are meant to save information which cannot or should not be saved on the control. The driver is integrated in the Runtime.

internal variable

Internal variables have no connection to the PLC. Internal variables are stored in the memory of the control system and are based on internal drivers, like the Internal Driver, the System Driver, the Mathematics Driver or the Simulator Driver. Internal variables can be used to perform local calculations, for example.

IP address

Are used in computer networks which are based on the internet protocol (IP) in order to transfer data from the sender to the designeted recipient. With the address the data package can indentify the recipient distinctly.

IPA

Module which helps to analyze alarm data statistically. With this convenient tool, you can localize and disclose weak points in your system. You find out quickly which errors occur most often and which errors cause the longest downtimes.The Runtime writes alarm and shift information (when using the Production & Facility Manager) in an ODBC-able database. Several Runtime systems can save their data in one central database. Therefore the data evaluation can be carried out across several pieces of equipment/systems.


J

Glossary -> J

JPEG

A graphics standard created by the Joint Photographic Experts Group.A commonly used method of lossy compression for photographic images. The degree of compression can be adjusted, allowing a selectable tradeoff between storage size and image quality. JPEG typically achieves 10:1 compression with little perceptible loss in image quality. JPEG compression is used in a number of image file formats. JPEG/Exif is the most common image format used by digital cameras and other photographic image capture devices; along with JPEG/JFIF, it is the most common format for storing and transmitting photographic images on the World Wide Web.[

JPG

A graphics standard created by the Joint Photographic Experts Group.A commonly used method of lossy compression for photographic images. The degree of compression can be adjusted, allowing a selectable tradeoff between storage size and image quality. JPEG typically achieves 10:1 compression with little perceptible loss in image quality. JPEG compression is used in a number of image file formats. JPEG/Exif is the most common image format used by digital cameras and other photographic image capture devices; along with JPEG/JFIF, it is the most common format for storing and transmitting photographic images on the World Wide Web.[


K

Glossary -> K

keyboard

An input device which contains a number of keys as control elements.


L

Glossary -> L

ladder diagram

Is a programming language that represents a program by a graphical diagram based on the circuit diagrams of relay-based logic hardware. It is primarily used to develop software for programmable logic controllers (PLCs) used in industrial control applications.

latch

A kind of bistable multivibrator, an electronic circuit which has two stable states and thereby can store one bit of information.A circuit incorporating latches has state; its output may depend not only on its current input, but also on its previous inputs.

latch

A switching takes on a certain state and stays in this state until it is reset manually.

LD

Is a programming language that represents a program by a graphical diagram based on the circuit diagrams of relay-based logic hardware. It is primarily used to develop software for programmable logic controllers (PLCs) used in industrial control applications.

left

Key which moves the cursor to the left.

left key

Key which moves the cursor to the left.

left-click

Activating the left mouse button.

license form

Document which contains the granted license. Among other things the license form describes the licensed product range, the serial number, the activation number and for soft-licensing the license number.

license sticker

Sticker which contains the serial number and the activation number. The sticker is applied to licensed hardware in order to render a proof of license.

list box

A standard element of a graphical user interface (GUI). It is used to display several entries in list form from which the user can choose. In general the entries contain text. However icons and text and icons are also possible.

local project copy

Image of the central server project on a computer which is connected to the server. All changes of a multi-user project are made in this project and are sent to ther server vie "check in".

LOG file

Text file in which error protocols are stored.


M

Glossary -> M

maintenance report

Maintenance or service notification which is sent to the SAP maintenance module.

mathematics driver

Driver which is integrated in the Runtime and which provides mathematical functions.

measurement reading

Data record in the SAP plant maintenance (PM): A description of the condition at a physical or logical place at a point in time.

mesh network

A type of networking wherein each node in the network may act as an independent router, regardless of whether it is connected to another network or not. It allows for continuous connections and reconfiguration around broken or blocked paths by ?hopping? from node to node until the destination is reached.

message element

Dynamic element which - dependent on the values of two variable - reads and displays a text from a text file.

message variable

Variable of type string which displays the status text of the S7 Graph heuristics.

method

In object-oriented programming, a method is a subroutine that is exclusively associated either with a class (in which case it is called a class method or a static method) or with an object (in which case it is an instance method).

Modbus RTU

Standardized communication protocol for connecting to Modbuc controls via a serial interface. As standard defined by Modbus-IDA (www.modbus.org).The protocl can also be routed via TCP/IP. Normally protocol Open Modbus TCP/IP is used for this purpose.

monitoring viewer

Tool for displaying all zenon Logic programs in the zenon Runtime. It is a part of the PLC diagnosis.

multibin

Dynamic element which - dependent on the variable value - displays a graphics file, colors a symbol or shows a status text. Binary and numeric variables can be linked to it. If a binary variable is linked first, multibin can be also used as switch or a momentary switch for the first variabel.The defined states are processed from top to bottom. The settings of the first applicable status are displayed.

multi-user project

Can be edited in the Editor by several users on several computers.


N

Glossary -> N

network dongle

Hardware on which a certain number of software licenses which can be used simultaneously is booked. Access is carried out via a network.


O

Glossary -> O

on change archiving

On every change of the value, the value is written into the archive together with the time stamp and the status.

online modus

The driver is in hardware mode and communicates with the control. The driver is started.

Open Modbus TCP/IP

Standardized communication protocol for connecting to Modbus controls via TCP/IP. As standard defined by Modbus-IDA (www.modbus.org).

operating hours counter

A variable which is used for totalling the time a device has been in use.

operating system

An operating system (OS) is an interface between hardware and user which is responsible for the management and coordination of activities and the sharing of the resources of a computer, that acts as a host for computing applications run on the machine


P

Glossary -> P

packaging system

Compilation of pieces of equipment whose task is to package products.

page down key

Key which moves the cursor down to the bottom of the monitor.

page up key

Key which moves the cursor up to the top of the monitor.

PCE

System for extending the Runtime by two freely programmable tasks.The Process Control Engine consists of two parts: programming environment for creating tasks and a runtime system which executes VB script or Java code once or periodically.The tasks be started via the Runtime or via functions. The connection to the Runtime takes place with the help of variables.

PCE

System for extending the Runtime by two freely programmable tasks.The Process Control Engine consists of two parts: programming environment for creating tasks and a runtime system which executes VB script or Java code once or periodically.The tasks be started via the Runtime or via functions. The connection to the Runtime takes place with the help of variables.

PCE project

Sums up several tasks for the Process Control Engine (PCE).

PDC

Collective term for logging data about states and processes during operation.

PDC system

System for logging plant data. It consists of PDC equipment, PDC area terminal, PDC group computer which are connected to the guide computer via the PDC interface.

PFS

Comprehensive tool for managing time-controlled events directly from within zenon. Twoexecution modes are supported: Absolute times and relative times. All times can be displayed in a calendar module with preview options, which allow to check future switching points.

PgDn

Key which moves the cursor down to the bottom of the monitor.

PgUp

Key which moves the cursor up to the top of the monitor.

pipe

Vector element which depicts a polyline for which the filling color can be defined if the is set to > 1.

plant data collection

Collective term for logging data about states and processes during operation.

PLC

A programmable logic controller (PLC) is a digital computer used for automation of electromechanical processes,such as control of machinery on factory assembly lines, amusement rides, or lighting fixtures. PLCs are used in many industries and machines. Unlike general-purpose computers, the PLC is designed for multiple inputs and output arrangements, extended temperature ranges, immunity to electrical noise, and resistance to vibration and impact. Programs to control machine operation are typically stored in battery-backed or non-volatile memory. A PLC is an example of a real time system since output results must be produced in response to input conditions within a bounded time, otherwise unintended operation will result.

PLC diagnosis

Module for online display of functional chart information of S7 Graph or of all programs of the zenon Logic control directly in the zenon Runtime.With the S7 Graph integration, information about the faulty step can be talken over directly in the Alarm Message List via the Alarm-S variable. In addition the S7 Graph heuristics is available for error analysis.For the zenon Logic integration with the zenon Logic Monitoring Viewer you can assign access rights to programs and variables. Acccording to his rights the user can force variable values.

PNG

Portable Network Graphics (PNG) is a bitmapped image format that employs lossless data compression. PNG was created to improve upon and replace GIF (Graphics Interchange Format) as an image-file format not requiring a patent license.

polygon

Vector element which describes a polygon via its corner points.

polyline

Vector element which displays a line which is defined along side several support points. The line is drawn from the first point to the second point. Then to the third point and so on.

pop-up

A visual element in a computer program. The element "pops up" and covers other parts of the GUI. In General the position of a pop-up element is random.

pop-up screen

Screen in the Runtime which partly obscures other screens.

port number

Is part of an IP address and can take on a value between 0 and 65535. The number identifies a communication channel distinctly. For the communication with TCP/IP the IP address and the port number are always necessary in order to address a recipient distinctly. Protocols UDP and SCTP also use port numbers.

positive edge

The value change of a variable from a smaller value to a larger value.

process connection

The project communicates with the control (driver in hardware mode).

Process Control Engine

System for extending the Runtime by two freely programmable tasks.The Process Control Engine consists of two parts: programming environment for creating tasks and a runtime system which executes VB script or Java code once or periodically.The tasks be started via the Runtime or via functions. The connection to the Runtime takes place with the help of variables.

Process Control Engine

System for extending the Runtime by two freely programmable tasks.The Process Control Engine consists of two parts: programming environment for creating tasks and a runtime system which executes VB script or Java code once or periodically.The tasks be started via the Runtime or via functions. The connection to the Runtime takes place with the help of variables.

process control system

Makes it possible to control process-optimized equipment. In general it consists of components which are close to the process and operating and controlling stations.

processor architecture

Processor have a wide range of tasks with very different requirements specifications. Thus different processor architectures have been developed which implement differnet concepts concerning structure and functionality.

processor family

Represents a specific, highly developed architecture which characterizes the processor and differs distinctly from other processor families. Each processor family has its own set of command and needs a compiler which is suitable excatly for this processor family.

product ID

The first item of the serial number is the unambiguous product ID which identifies the license decisively. For dongle licensing the product ID matches the dongle number.

production line

Production facility with which production steps are carried out in spatial and temporal order.

programmable logic controller

A programmable logic controller (PLC) is a digital computer used for automation of electromechanical processes,such as control of machinery on factory assembly lines, amusement rides, or lighting fixtures. PLCs are used in many industries and machines. Unlike general-purpose computers, the PLC is designed for multiple inputs and output arrangements, extended temperature ranges, immunity to electrical noise, and resistance to vibration and impact. Programs to control machine operation are typically stored in battery-backed or non-volatile memory. A PLC is an example of a real time system since output results must be produced in response to input conditions within a bounded time, otherwise unintended operation will result.

programming interface

They offer programming tools such as PCE, VBA and VSTA for the extension of the existing functionalities.

project simulation

At this no only a single driver but the whole project is set to simulation. Depending on the settings all Runtime data are copied in a simulation image so that switching operations can also be recorded and analyzed in simulation mode.

project tree

Structured graphic display of all projects and modules in a workspace.

property help

Window in the Editor which displays short explanations for the selected property.

property window

Display area in which the properties of the selected elements are displayed.


Q

Glossary -> Q


R

Glossary -> R

reactivate

Summarizes identical alarms to a single entry in the ALarm Message List. The accumulated numbe rof alarms, the time and the status of the last active alarm can be displayed.

recipe group

The recipe group sums up the RGM recipes in the recipegroup manager. At the recipe group the variables and the min./max. values are defiend. These definitiona are true for all RGM recipes of the recipe group.

recipegroup name

Unambiguous name of a recipegroup in the Recipegroup Manager.

reconnect delay

Period of time which passes after a connection is terminated and a new connection buildup is started.

record on change

If a variable value changes, it is written to the archive.

relative path

Defines the path to files and folders starting at a defined start folder (e.g. ...\folder).

relative period of time

Time range time which is dependened on the current point in time and which has a defined start and end time.

relative point of time

Dependent of en event the action is carried out.

relative position

Position on the monitor screen which depends on another object.

relative switching point

Dependent on an event a defined action is carried out.

remanent

Made available permanently.

remanent data

Saves data automatically to a non-volatile volume. Thus the data are still available after the software has been closed or the device has been turned off.

remote port

TCP port which should be addressed on a remote device.

Remote Transport

Provides several functionalities in order to maintain a project on a remote computer: transfering Runtime files, defining the start project, starting and ending the Runtime, etc.

Report Generator

Tool for creating reports. There are functions for reading out data from the different modules, e.g. Alarm Message List, Chronological Event List, Historian, online values, any SQL database...For data from the Historian it is possible to edit them and write them back to the Historian as manual values.The data can be formated and converted. The resulting reports can be displayed, saved and printed.

response variable

At Command variable which reads back the value/status from the control.

revision

Status of a variable for which alarm handling and Command are suppressed by the process control system. With this it is possible to except singular parts of the equipment from alarming and processing. The current value of the control is still displayed on the screen.

RGM recipe

RGM recipes make a grouped recipe management possible. Each RGM recipe is assigned to a recipe group. All data types can be used. States can be processed. Allocations from on variable to another can be carried out.

right

Key which moves the cursor to the right.

right key

Key which moves the cursor to the right.

ring buffer

A ring buffer constantly saves a definable amount of data. If the memory space is full, the data are overridden either using the FIFO or LIFO method.

root node

First level in a tree structure.

RT

The Runtime allows you to execute projects platform-independently, i.e. independent of the employed hardware and operating system. The Runtime is the "platform" for running projects. The Runtime does not require a development environment to work.

Runtime data

All data which are created and managed by the Runtime, e.g. data of the Alarm Message List, the Chronological Event List, the Historian, etc.The data created by the Editor (Runtime files) and which are later changed in the Runtime also count; such as data for the standard recipes, recipegroup manager, user administration, etc.

Runtime files

Are files created by the Editor which are read and interpreted by the Runtime. Some Runtime files are modified by the Runtime; e.g. standard recipe, recipegroup manager, etc.The Runtime files are stored in the Runtime folder.

Runtime folder

In this folder te Runtime files of the project are stored. The path is entered in zenon6.ini when defining the start project. The Runtime folder can be changed in the project properties. There are two sub-folder - 'RT' and one with the name of the computer - in the Runtime folder. All Runtime files which have been created by the Editor are in folder 'RT'. All data files which have been created in the Runtime are in folder 'computer name'.

Runtime profile

Saves the position of the currently displayed screens and the used filters in the Runtime.The Runtime profiles are user-dependent. An administrator can manage the profiles of other users and of the user "system".Any number of Runtime profiles can be saved.

Runtime status

Shows whether the Runtime is in hardware mode or in simulation mode.


S

Glossary -> S

S7

Programming software for Siemens Simatic. STEP is a German acronym (STeuerungen Einfach Programmieren) which means 'program controls easily'.

S7 file

Project file for the Siemens programming system Step 7. The variables of these projects can be applied to the variable list via S7 import.

S7 Graph

S7 Graph is based on the Siemens programming software Step 7. It is used for sequential procedures with alternative or parallel step sequence (SFC). In the Runtime the current state of procedure control in the PLC can be displayed in the screen type with the same name.

S7 Graph heuristics

Analyzes the S7 Graph sequential function chart and determines all transitions which prevent forwarding to the next step. The conditons which prevent a forwarding are displayed in the message variabel.

S7 import

The variables of a S7 project can be taken over to the variable list with the help of the S7 import.

S7 PDiag

Enables the engineering of the Siemens S7 process diagnosis. With the help of the process diagnosis faulty states outside the automation system (e.g. end switch cannot be reached) can be detected.

S7 program

Program for S7 controls. The programming is carried out using the Step 7 software. The varibales can be applied to the variable list via the S7 import.

S7 project file

Storage for S7 programs which can be edited in Siemens Step 7. The variables can be taken over in the variable list with the help of the S7 import.

SAP interface

Module for the data exchange of variable values and alarms with an external SAP system.

SCADA

Concept for monitoring and controlling technical processes.

SCADA logic

PLC logic integrated in the SCADA system. It has no direct connection to the process but receives its information preferably via the SCADA system.

scalability

Ability to adjsut to changed conditions regarding size of a system or numbe rof components.

scaling

Change in size or the adjustment of different properties to an existing scale.

Screen

A limited area on the monitor which contains elements/objects for operating, controling, monitoring, evaluating, etc. machinery, equipment, processes.There are different types of screens which bring along predefined functions. Screens are always based on templates which define there location on the monitor. You can display several screens simultaneously and also on several monitors.

Screen

A display device which is connected to a computer.

screen alarming

The screen alarming guides the user - e.g. via flashing elements - to the screen in which the alarm is displayed in the Runtime. The engineering is carried out with the help of the alarm areas.

Screen element

All elements (symbols, dynamic and vector elements and control elements) which can exist in a screen.

screen keyboard

Screen of type keyboard.

screen symbol

Symbol which is embedded in or linked to a screen.

screen type

Defines the type of screen and the elements which are available in it as standard. For each screen type there are elements (buttons, lists, etc.) available which adapted for the functions.For example in screen type Alarm Message List all objects are available which are necessary to display and filter alarms.

screen type specific function

Function which is available for an element if the element is used in a certain screen type.

screenshot

Image of the whole monitor content or of a part of it.

scroll arrow

Graphical element in the scroll bar via which the scroll box can be moved horizontally or vertically.

scroll bar

Graphical tooll for moving the monitor content along side a horizontal or vertical axis.

scroll box

Graphical element in the scroll bar via which the displayed content can be moved horizontally or vertically. The ratio of the scroll box to the scroll bar equals the ratio of the displayed content to the whole content of the element.

search for ground fault

At a ground fault the grid area concerned can be colored with the ground fault color with the help of this function. With this the faulty area can be localized.

segment of a circle

Vector element which depicts any part of a circle or ellipse. When you choose display type transparent, only the outer line is displayed.

series terminal

In electrical engineering a terminal acts as an undoable connection of wires. Series terminals can be added next to each other on a support rail (e.g. DIN rail TS35 "top-hat rail")as desired.

server port

Default TCP port on a server via which clients communicate with the server.

Service Pack

Service Packs are accumulated bug fixes for a certain version. They pass through the complete quality assurance process. They include all builds which have been released up to then. Service Pack 0 is the first official release of a version.

set value

Value which is transferred to the control and which should overwritte the existing value in the control.

Shift

The key is mainly used to enter a capitalized letter. It is also used to enter shortcuts.

shift time

Start and end time or several shifts. The definition is carried out in the Production & Facility Scheduler.

short circuit recognition device

A line protection device for identifing short circuits in a grid element.

shortcut

By pressing predefined keys simultaneously, an action is triggered. Is used to help the user carry out a command sequence.

SI unit

The International System of Units (abbreviated SI from the French le Système international d'unités[1]) is the modern form of the metric system and is generally a system devised around the convenience of the number ten.

Simatic S7

Programming software for Siemens Simatic. STEP is a German acronym (STeuerungen Einfach Programmieren) which means 'program controls easily'.

Simatic Step 7

Programming software for Siemens Simatic. STEP is a German acronym (STeuerungen Einfach Programmieren) which means 'program controls easily'.

SIMOTION

System by Siemens for automation of production equipment focusing on motion control. SIMOTION consists of the SIMOTION SCOUT and the SIMOTION kernel for different hardware platforms. The scout is the engineering system for creating a project with hardware configuration and user data.

simple data type

Data type which is based directly on an IEC data type and which compements it with properties of the variable such as unit, scaling, limit, etc. All these properties can be inherited by the variables based on the data type.

Simple Network Management Protocol

Common protocol for monitoring and protocoling networks. SNMP agents (hardware and/or software) deliver data about the activities of all components (hubs, router, bridges, etc.) to the MIB (Management Information Base) located on a monitoring computer. Components are checked for reachability and are controlled.

simple variable

Variable which is based on a simple data type.

simulation

Processes are simulated on a model in order to receive information about the real system or to substitute the real system.

simulation - counting

Possibility to set a driver to simulation. At this no communication to the control is established but all values are initialized with 0 and are then increased by 1 according to the defined update time until the maximum is reached. Then they start again at 0.

simulation - programmed

Possibility to set a driver to simulation. At this no communication to the control is established but the values are calcualted by a freely programmable simulation project. The simulation project is created with the help of the zenon Logic Workbench and runs in the zenon Logic Runtime.

simulation - static

Possibility to set a driver to simulation. At this no communication to the control is established but the values are initialized with 0.

simulation image

Memory area in which all values of the simulation are stored.

simulation mode

In contrast to the hardware mode no communication with the control takes place. The variable values are calculated via the set simulation type (static, counting, programmed).

simulation project

zenon Logic project which is used to simulate an external control. For all variables which are based in the driver simulated values can be provided.

simulator driver

Driver on which variables can be created which are meant to save information which cannot or should not be saved on the control. In contrast to the intern driver, this driver is numerically addressed and the variable values can be influenced automatically in terms of various increment and decrement functions.

sizing handle

Graphical element (rectangle, circle, rhomb or sun symbol) with which the color and shape of a screen element can be changed.

slider

Controlelr whose impact is defined by the movement alongside a scale on a long axis.

slot PLC

PLC implemented on a PC card. Also known as hard PLC with housing.

SNMP

Common protocol for monitoring and protocoling networks. SNMP agents (hardware and/or software) deliver data about the activities of all components (hubs, router, bridges, etc.) to the MIB (Management Information Base) located on a monitoring computer. Components are checked for reachability and are controlled.

soft PLC

A soft PLC (programmable logic controller in software) consists of a PC or a microcontroller, a PLC software and an I/O components or filedbus extension such as a Bus Terminal.

soft-license

Ties the use of the software to the input of a correct license number.

soft-licensing

Type of licensing for which the license is bound to a certain computer. For this the license number is used.

SP

Service Packs are accumulated bug fixes for a certain version. They pass through the complete quality assurance process. They include all builds which have been released up to then. Service Pack 0 is the first official release of a version.

spin control

Control element which has two buttons with arrows for up and down. The element makes it possible for the user the browse through a predefined range of values. With the arrow buttons the displayed value is increases or decreased by one.

splash screen

Information which is displayed at the start of the program.

sponaneous data traffic

Establishing connections in the network and transferring data only if needed.

spontaneus value

Current variable value which matches the values in the control. This means that the value is not impaired (I-bit), not set to revision and not the alternate value.

SQL

Database language for defining, querying and manipulating data in a relational database. SQL is standardized by ANSI and ISO and is supported by nearly all myjor database systems. SQL includes the following database languages: Data Manipulation Language, Data Definition Language, Data Control Language.

SQL database

Database system for electronical data management which supports SQL as query language. In general it is a relational database.

SQL Server

A relational model database server running on Microsoft Windows operating systems. The Editor uses the database to store data.

SQL Server service

Process which provides database functionality. The service must be started in order to work with the Editor.

ST

Is one of the 5 languages supported by the IEC 61131-3 standard. It is designed for programmable logic controllers (PLCs). It is a high level language that is block structured and syntactically resembles Pascal. All of the languages share IEC61131 Common Elements. The variables and function calls are defined by the common elements so different languages can be used in the same program.

standalone

A project which has no network connection. It cannot be addresses from a client or a standby server. It can display and process data from other projects which run in the same Runtime; e.g. display variable value, entries from the Alarm Message List or Chronological Event List, trend curves, record variable values in the Historian, allocate variable values to other variables, etc.

standard function

For some modules you can create a predefined function directly in the detail view. At thi the function is used which is used most frequently with the module; e.g. "Write set value" for variables.

standard port

Default TCP port via which the applicaton usually communicates.

standard profile

With the help of the standard profile you can reset the look of the Editor to the delivery state. All tool bars, window positions, etc. are reset to the original state.

standby

Programm which has all current data and connections of the server at its disposal and which can take over instantly when the server fails.

standby output

Defines the "normal" power output of a generator. In order to compensate peak loads, a generator can be set to its peak performance (limited in time).

standby project

Project for which network is activated and a server is entered. The project together with the the server project is redundantly responsible for the whole data management. All data are provided by the server project and are saved locally.After the standybe project recognizes the failure of the server project, it becomes the new server project itself and gains data superiority. Starting at this moment client projects can connect to it.

Standby Server

Programm which has all current data and connections of the server at its disposal and which can take over instantly when the server fails.

start index

Defines the starting point of an array.

start project

Teh project which is loaded first when the Runtime is started. There can be only one start project for each computer. The start projet is saved in files 'zenon6.ini'.

Starter Edition

Modules with limited range of functions which are included in the base package (not for Windows CE).

Startup Tool

Program for managing different versions. The version-dependent components such as database service, transport service, ActiveX elements etc. can be registered and the application can be started.Additional parameters such as language, transfer parameters, used SQl Server, start project, etc. can be defined.

static text

Vector element which depicts a fixed text.

status element

Dynamic element which displays static limit texts and transfers properties of the linked variable such as color, flashing etc. to a symbol.

Step 7

Programming software for Siemens Simatic. STEP is a German acronym (STeuerungen Einfach Programmieren) which means 'program controls easily'.

Step 7 file

Project file for the Siemens programming system Step 7. The variables of these projects can be applied to the variable list via S7 import.

Step 7 program

Program for S7 controls. The programming is carried out using the Step 7 software. The varibales can be applied to the variable list via the S7 import.

straton

Flexible IEC 61131-3 programming environment by COPALP for all five languages: sequential functional chart (SFC), function block diagram (FBD), ladder diagram (LDP), structures text ST) and instruction list (IL). Covers many parts of the insturial automation: guide level (SCADA logic), control level (Soft-SPS) and field level (straton embedded). Soft PLC, SCADA logic and straton Workbench are integrated in process control system zenon by COPA-DATA.

straton application

All porgrams, variables and the I/O configuration of a straton project.

straton RTK

Runtime system for hard real time which runs independent of the operating system.

straton Runtime

Runs straton projects in a platform-independent environment, i.e. independent of the used hardware and operating system. The runtime environment provides the "platform" on which the projects run.The Runtime does not need the Workbench in order to run.

straton with real time kernel

Runtime system for hard real time which runs independent of the operating system.

string variable

Variable whose value contsists of a alphanumeric character sequence.

structure data type

Compound structure which is combined using structure elements. These can be either simple data types or existing other structure data types.

structure element

A part of a structure data type. It is either based on a simple data type or on a structure data type. For simple data types you can distinguish whether they are embedded or linked.Embedded means that a copy of the data type is created and all properties can be defined at the structure element. For linked data types only s reference to the data type is created. All properties are taken over from there.

structure variable

Variable which is based on a structure data type.

Structured Query Language

Database language for defining, querying and manipulating data in a relational database. SQL is standardized by ANSI and ISO and is supported by nearly all myjor database systems. SQL includes the following database languages: Data Manipulation Language, Data Definition Language, Data Control Language.

structured text

Is one of the 5 languages supported by the IEC 61131-3 standard. It is designed for programmable logic controllers (PLCs). It is a high level language that is block structured and syntactically resembles Pascal. All of the languages share IEC61131 Common Elements. The variables and function calls are defined by the common elements so different languages can be used in the same program.

switch

Dynamic element which displays and modifies the value of a binary variable. It can also be used as a momentary switch.

switching cycle counter

A variable which is used for totalling the switching cycles of a device. One switching cycle meants that the device has been switched on and switch off.

switching operations preview

Switching operations are displayed in a list before they are carried out.

switching point

Definition of a point in time at which an action is carried out.

switching time

Point in time at which a switching point is carried out.

symbol

Summary of different dynamic elements and vector elements to a new element whose size change affects all included elements proportionally.A symbol can either be embedded in a screen or linked to a screen. Linked symbols are saved in the global system library or in the project symbol library.

symbol element

Single dynamic element or vector element which is embedded in a symbol.

system driver

Driver which is integrated in the Runtime and which provides predefined variables. The variables contain information about the project or the hardware on which the project has been started.

system driver variable

Variable which is based on the system driver.

system status

Status information of a computer; e.g. operating system, start project, licensing, Runtime status, etc.


Symbols

Glossary -> Symbols

.NET

A software platform developed by Microsoft. It consists of a runtime environment, a set of class libraries (API) intended for programmers and a number of associated service programs (services). At the moment, the platform can only be used to its full extent in Windows.

.NET framework

The .NET framework is Microsoft's programming model for ?managed code?. It is used for creating sophisticated applications for seamless and secure communication and allows for the modelling of a wide variety of business processes. The current .NET framework 3.5 consists of (amongst others): Windows Presentation Foundation (WPF), Windows Workflow Foundation (WF), Windows Communication Foundation (WCF), Windows CardSpace, LINQ and full Visual Studio 2008 integration.

3D angle unit

Outdated vector element that was used for representing an angle with a three-dimensional fill pattern.

3D fill effect

Graphical objects like squares, circles, etc. get a three-dimensional appearance by adding gradients to the fill color.

3S

Manufacturer of CoDeSys. 3S is short for Smart Software Solutions.


T

Glossary -> T

tab

Describes the single pages of a dialog in which certain setting can be made.

TAG

One TAG equals one variable and is independent of the data type. Internal varibales are not taken into account for the calculation of TAGs.TAGs are used exclusively for licensing. In order to calculate the license size, the number of TAGs for the following drivers is added up:? All SPS and bus driversInternal process variables (internal drivers) and process variables of? system driver? mathematics driver and? simulator driverare not taken into account.

target host

IP address or computer name of the target system

target port

TCP port which should be addressed on the target system.

target recipe

Recipe on which information is written during copy recipe. The source recipe is written on the target recipe.

task

A program in VB script or Java for the Process Control Engine (PCE).

TCP

TCP provides reliable, ordered delivery of a stream of bytes from a program on one computer to another program on another computer. Besides the Web, other common applications of TCP include e-mail and file transfer. Among its other management tasks, TCP controls segment size, flow control, the rate at which data is exchanged, and network traffic congestion.

TCP/IP

Is the set of communications protocols used for the Internet and other similar networks.

template

Defines the size and location of an area on the monitor in which screens are displayed in the Runtime. Each screen is based on a frame. You can define certain settings for a frame which are then transferred to all screens which are based on the particular frame.

text button

Dynamic element with which an action (execute function, write set value) is triggered. The text button can only display text. From 6.50 on it is replaced by the dynamic element button.

TIF

Tagged Image File Format (abbreviated TIFF or TIF) is a file format for storing images, including photographs and line art.

TIFF

Tagged Image File Format (abbreviated TIFF or TIF) is a file format for storing images, including photographs and line art.

time display

Control element which displays an alterable time designation.

time filter

Adjustable filter for limiting the displayed data to a certain period of time. There are absolute filter (from - to are entered firmly) and relative filter (starting from now and lasting a certain period of time).

title bar

Horizontal bar at the top edge of a window, a dialog or a tool bar in which the name of the document, the program or the tools bar is displayed

toolbar

A row, a column or a block of buttons which are displayed on the monitor screen. If you click on these buttons, the linked commands are carried out. The tool bars can be customized and moved on the monitor screen. The setting is saved int eh Editor profiles. Tool bars are only available in the Editor.

topological line

Vector element for coloring lines for the topological display of electric grids. Only available for SICAM 230.

topological strand

Dynamic element for coloring lines for the topological display of electric grids. Only available for SICAM 230.

touch screen

Input device with which the process of a programm can be seemingly controlled by touching parts of the screen of a technical device, usually a computer. The "touch-sensitive" screen of the touch screen can thereby either be produced dynamically via a monitor or a projection or physical (e.g. printed).

transient event

Event which is triggered briefly in order to indicate a changed state. Most often it is a bit which is set to 1 briefly and then reset to 0 again. It can also be a Windows Message on which a reaction is carried out in a programming language.

Transmission Control Protocol

TCP provides reliable, ordered delivery of a stream of bytes from a program on one computer to another program on another computer. Besides the Web, other common applications of TCP include e-mail and file transfer. Among its other management tasks, TCP controls segment size, flow control, the rate at which data is exchanged, and network traffic congestion.

transport service

Process (zenSysSrv.exe) which acts as a receiver for the Remote Transport and in which the the Diagnosis Server is integrated. Thus it is necessary for the execution of all zenon applications.

trend element

Dynamic element for displaying values in terms of trend curves.

trigger variable

Variable which triggers something when its value changes; e.g. carry out an allocation or write a value to the archive.

TÜV - German Association for Technical Inspection

Registered association which carries out technical safety checks on a commercial basis. The checks are mainly officially required by the German government.


U

Glossary -> U

UDP

Uses a simple transmission model without implicit hand-shaking dialogues for guaranteeing reliability, ordering, or data integrity. Thus, UDP provides an unreliable service and datagrams may arrive out of order, appear duplicated, or go missing without notice. UDP assumes that error checking and correction is either not necessary or performed in the application, avoiding the overhead of such processing at the network interface level. Time-sensitive applications often use UDP because dropping packets is preferable to waiting for delayed packets, which may not be an option in a real-time system.

undo check out

Releases locked elements/modules in a multi-user project without taking over the carried out adaptiations in the central server project. The changes are replaced by the version on the server and are therefore lost.

Uniform Resource Locator

Stands for Uniform Resource Locator and identifies and locates a resource via the used network protocol (e.g. HTTP or FTP) and the location of the resource in the computer network.

universal slider

Dynamic element which dispalys sliders with different characteristics. Values of variables can be displayed as slider, bar dispaly, LED bar display etc.

URL

Stands for Uniform Resource Locator and identifies and locates a resource via the used network protocol (e.g. HTTP or FTP) and the location of the resource in the computer network.

user administration

Programm or part of a programm in which you can define which users exist in a system, which rules apply to them when logging on to the system and which rights they have in the system.

User Datagram Protocol

Uses a simple transmission model without implicit hand-shaking dialogues for guaranteeing reliability, ordering, or data integrity. Thus, UDP provides an unreliable service and datagrams may arrive out of order, appear duplicated, or go missing without notice. UDP assumes that error checking and correction is either not necessary or performed in the application, avoiding the overhead of such processing at the network interface level. Time-sensitive applications often use UDP because dropping packets is preferable to waiting for delayed packets, which may not be an option in a real-time system.


V

Glossary -> V

variable diagnosis

Screen type for displaying variable values, time stamps and states. Variable values can also be written.

VBA wizards

A VBA programm which supports the user during engineering and creates or edits objects automatically. All wizards are available in source code and can be customized.

vector element

A vector element is a graphical element. Its internal representation is based on vectors. That is why it can be scaled freely. As opposed to a dynamic element, the vector element does not represent a variable value.

vector graphics

Consists of mathematical primitives which can be described a level, e.g. lines, circles, polygons, etc. In contrast to raster graphics size change can be carried out lossless.

VGA

Describes a computer graphics standard (EISA, 1978) in which predetermined combinations of monitor resolution, number of colors (color bit depth) and refresh rate were defined.Today VGA is mostly used for a monitor resolution of 640 x 480 pixel.

Video Graphics Array

Describes a computer graphics standard (EISA, 1978) in which predetermined combinations of monitor resolution, number of colors (color bit depth) and refresh rate were defined.Today VGA is mostly used for a monitor resolution of 640 x 480 pixel.

Vista

Operating system by Microsoft. Successor of Windows XP.

VM

Runs straton projects in a platform-independent environment, i.e. independent of the used hardware and operating system. The runtime environment provides the "platform" on which the projects run.The Runtime does not need the Workbench in order to run.


W

Glossary -> W

Wakos

Takes alarms from the process guide-system and creates error messages in a SAP-ERP system using interface SAP-RFC. The alarm messages from the guide-system are stored in a database for later evaluation. The display is done via a list in which a wait-guide classifies the messages. Only major alarms are taken over to teh SAP system.

window

In the Editor there are several windows available which can be moves, changed in size and displayed or not displayed. For example the output window displays the status information when loading a project andd when creating the Runtime files.The position and size of the windows are saved in the Editor profiles.

Windows CE

Is an operating system developed by Microsoft for minimalistic computers and embedded systems. Windows CE is a distinctly different operating system and kernel, rather than a trimmed-down version of desktop Windows. It is not to be confused with Windows XP Embedded which is NT-based. Windows CE is supported on Intel x86 and compatibles, MIPS, ARM, and Hitachi SuperH processors.

Windows CE project

Every project can be used with Windows CE. Some functions however are not available in the Windows CE Runtime. Therefore there are individual Windows CE projects in which only those functions which are available for Windows CE can be engineered. You can define a Windows CE project by activating project property 'Windows CE project'.

Windows CE Runtime

An especially compiled Runtime for Windows CE. The Runtime only runs on the processor architecture and operating system version for which it has been compiled.

Windows Vista

Operating system by Microsoft. Successor of Windows XP.

Windows XP

Operating system by Microsoft. XP stands for "eXPerience".

Windows XP Embedded

Operating system by Microsoft. It originates from Windows XP Professional and differs from Windows CE/PocketPC by addressing a different kind of device class. XP Embedded can only run on x86 hardware. Area of usage are devices which are based on a x86 processor.

wizards

A VBA programm which supports the user during engineering and creates or edits objects automatically. All wizards are available in source code and can be customized.

workspace

An administrative unit in the Editor in which projects can be grouped. Only projects which are added to a workspace can be edited in the Editor.

worldview overview

Screen type for the downscaled display of a worldview and for the navigation in the worldview.

write set value

Transfers a set value from the control system to the control.

write telegram

Data package which is sent to a control in order to write one or more set values there.

write value

Transfers a value from the control system to the control.


X

Glossary -> X

XML

Extensible Markup Language - can be used to display hierarchical structured data in terms of a text file.

XML file

Text file which is structured in accordance with the Extensible Markup Language.

XP embedded

Operating system by Microsoft. It originates from Windows XP Professional and differs from Windows CE/PocketPC by addressing a different kind of device class. XP Embedded can only run on x86 hardware. Area of usage are devices which are based on a x86 processor.


Y

Glossary -> Y


Z

Glossary -> Z

zenon

Object-orientated process control system by COPA-DATA.

zenon API

Programming interface which provides the access to the Editor and the Runtime for programming environments. With this automation tasks can be handles; key word: automatic engineering. In addition the rang of functions can be enhanced with the help of self-written programs.The interface is used by VBA/VSTA and is also available for external application. Microsoft COM technology is used as a basis.

zenon Editor

Graphical user interface for creating, editing and maintaining zenon projects.

zenon Runtime

Die Runtime / Laufzeitumgebung lässt Projekte plattformunabhängig ablaufen, das heißt, unabhängig von der verwendeten Hardware und dem Betriebssystem. Eine Laufzeitumgebung stellt die ?Plattform? dar, in der die Projekte ablaufen. Die Runtime benötigt zum Ablauf keine Entwicklungsumgebung.

zenon Web Client

Displays projects in a web browser; e.g. Internet Explorer, Firefox.

zenon Web Server

Enables the access to zenon projects via a web client. The web server acts as licence administration and proxy server.

zoom

To focus a screen detail and to change its view size. 100% means that each pixel of a graphic matches exactly one pixel on the screen.

zoom button

Graphical object in the graphical user interface of a programm with which the zoom function can be turned on/off.

zoom slider

Linear, graphical controler with whose operation zoom levels can be changed.


If you cannot find a solution for your problem in our online help, please feel free to contact our support team or take part in our online forum.

Support teams

As a user of the service level agreement Basic (included in each license for free), the best way to reach the support is via e-mail to support@copadata.com.
You can find information about telephonic availability of our support team on our home page: Support availability

As owner of a service level agreement Advanced or Premium, please use the phone number provided in your contract.

You receive information about the COPA-DATA service level agreements from our sales team which you can reach via e-mail to sales@copadata.com.

Forum

You can also find valuable information and support from other users and the COPA-DATA experts in the COPA-DATA Forum.

Downloads

On the COPA-DATA home page users of all service level agreements can find manuals, tutorial and videos as downloads.
Users with advanced or premium service level agreements also have access to service packs, VBA examples and pre-recorded workshops.

In order to download files, you must be logged-in as 'member' . The registration is free and you gain access to information which is exclusive to our customers.


zenon Logic Runtime supports the "printf" function to track messages whilst the program is being executed. These messages are displayed in the output window of the Workbendh. To do this, the Workbench be online in zenon Logic Runtime.

However this only works if, in the Diagnosis Viewer, the logging level "Messages" is active for all modules on the diagnosis client. You can find details on these logging levels in the Diagnosis Viewer manual, in the Diagnose Client ##12470 section

The printf command works with the simulator of the zenon Logic Workbench without additional configuration.


Example of code for logging in to an Everywhere Server:

// get authentication information from the user interface

String userName = arg0[0].getString("UserName");

String password = arg0[0].getString("Password");

String server = arg0[0].getString("Server");

String project = arg0[0].getString("Project");

String port = arg0[0].getString("Port");

Date curTime = new Date();

// full username -> as described

String fullUserName = Long.toHexString(curTime.getTime())+"|"; // 8 digit hex timestamp

fullUserName = fullUserName + Settings.Secure.ANDROID_ID +"|";

fullUserName = fullUserName + userName;

// set the authentication to basic https (OClientBehaviour from odata4j)

OClientBehavior authBehavior = OClientBehaviors.basicAuth(fullUserName, "=" + password);

OClientBehavior allowSelfSignedBehavior = AllowSelfSignedCertsBehavior.allowSelfSignedCerts();

// Consumer declaration: private ODataConsumer consumer;

// here the url to the server has to be inserted

// we have https:"the server IP or name":Portnumber(for HTTPS 8050)/zendata(fixed)/Projectname

consumer = ODataConsumers.newBuilder("https://"+server+":"+port+"/zendata/"+project).setClientBehaviors

(authBehavior, allowSelfSignedBehavior).build();


Receiving alarms

The example shows how alarms are updated. This syntax can also be used for the other data types In the same way.

private class RequestPollAlarmsTask extends ConnectionTask{

public RequestPollAlarmsTask(EverywhereConnectionHandler handler) {

super(handler);

}

@Override

protected Void doInBackground(Bundle... arg0) {

try {

lock.acquire();

} catch (InterruptedException e1) {

// TODO Auto-generated catch block

e1.printStackTrace();

}

int updateIntervall = arg0[0].getInt("Intervall");

String filter = arg0[0].getString("Filter");

try

{

// Consumer declaration: private ODataConsumer consumer;

// alarms declaration: private Enumerable <OEntity>

alarms = consumer.getEntities("Alarms").expand("Variable").execute();

isConnected=true;

}

catch (Exception e)

{

isConnected=false;

connectionException=e;

}

lock.release();

return null;

}


HLP_FKT_ACM_RSP

Interne ID: HLP_FKT_ACM_RSP

Guardar búfer anular AML y CEL

Esta función guarda las alarmas y eventos actuales en los archivos ALARM.BIN y CEL.BIN.

Más en el manual online


HLP_FKT_ALARM_BLINK_QUIT

Interne ID: HLP_FKT_ALARM_BLINK_QUIT

Alarmas: reconocer parpadeo

Esta función reconoce el parpadeo de todos los elementos de la imagen abierta actualmente de una plantilla seleccionada.

Más en el manual online


HLP_FKT_ALARM_GRP_KLASSEN

Interne ID: HLP_FKT_ALARM_GRP_KLASSEN

Activar/desactivar lista de mensajes de alarma, grupos o clases de alarmas/eventos

Esta función activa o desactiva un grupo de alarmas/eventos, una clase de alarmas/eventos o la administración de alarmas completa.

Más en el manual online


HLP_FKT_ALARM_GRUPPEN_VERB

Interne ID: HLP_FKT_ALARM_GRUPPEN_VERB

Grupo de alarmas/eventos log in/log off

Esta función activa o desactiva la conexión del SPS para un grupo de alarmas/eventos seleccionado.

Más en el manual online


HLP_FKT_AML_AUS

Interne ID: HLP_FKT_AML_AUS

Lista de mensajes de alarma desactivada

Esta función desactiva la administración total de alarmas.

Más en el manual online


HLP_FKT_AML_DEL

Interne ID: HLP_FKT_AML_DEL

Eliminar alarmas

Esta función elimina las alarmas filtradas.

Más en el manual online


HLP_FKT_AML_EIN

Interne ID: HLP_FKT_AML_EIN

Lista de mensajes de alarma activada

Esta función activa la administración total de alarmas.

Más en el manual online


HLP_FKT_AML_EXP

Interne ID: HLP_FKT_AML_EXP

Exportar AML

Esta función exporta las entradas filtradas de la lista de alarmas a un formato externo.

Más en el manual online.


HLP_FKT_AML_QTT

Interne ID: HLP_FKT_AML_QTT

Reconocer alarmas

Esta función reconoce las alarmas filtradas.

Más en el manual online


HLP_FKT_AML_TGL

Interne ID: HLP_FKT_AML_TGL

Lista de mensajes de alarma activada/desactivada

Esta función activa o desactiva la administración total de alarmas.

Más en el manual online


HLP_FKT_ANALYZER_REPORT_CREATE

Interne ID: HLP_FKT_ANALYZER_REPORT_CREATE

Analyzer: crear informe

Esta función establece una conexión con un Analyzer Server, permite la configuración de un informe en el editor así como la creación y archivo del informe durante el runtime.

Más en el manual online.


HLP_FKT_APP_HELP

Interne ID: HLP_FKT_APP_HELP

Llamar a la ayuda

Esta función abre una página de ayuda seleccionada de un archivo CHM.

Más en el manual online


HLP_FKT_APP_PALETTESWITCH

Interne ID: HLP_FKT_APP_PALETTESWITCH

Cambiar paleta de colores

Crea una función para cambiar de paletas de color durante el runtime.

Más en el Manual online.


HLP_FKT_APP_RT_PROFILES

Interne ID: HLP_FKT_APP_RT_PROFILES

Perfil de runtime

Crea una función con la que durante el runtime se puede abrir la administración de perfiles, crear un perfil o cargarlo.

Más en el Manual online.


HLP_FKT_APP_SAVE_REMDATA

Interne ID: HLP_FKT_APP_SAVE_REMDATA

Guardar datos remanentes

Permite guardar los datos para los módulos configurados. Están disponibles: Búfer anular-AML, búfer anular-CEL, driver del sistema y driver matemático, driver interno, imágenes remanentes de todos los drivers y bloqueo de comandos.

Más en el Manual online.


HLP_FKT_APP_TEXT_LISTE

Interne ID: HLP_FKT_APP_TEXT_LISTE

Cambio de idioma

Esta función cambia el idioma seleccionado en proyectos con varios idiomas.

Más en el manual online


HLP_FKT_APP_UNITS_SWITCH

Interne ID: HLP_FKT_APP_UNITS_SWITCH

Cambio de unidad

Esta función cambia entre la unidad base y la unidad de conversión. La asignación se produce en un diálogo que aparece al crear la función y se puede modificar posteriormente con la propiedad Parámetros.

Más en el manual online.


HLP_FKT_ARV_AKT

Interne ID: HLP_FKT_ARV_AKT

Mostrar archivos activos

Esta función muestra una lista de los archivos activos del módulo opcional Servidor de archivos.

Más en el manual online


HLP_FKT_ARV_AUS

Interne ID: HLP_FKT_ARV_AUS

Finalizar archivo

Esta función finaliza un archivo seleccionado del módulo opcional Servidor de archivos.

Más en el manual online


HLP_FKT_ARV_EIN

Interne ID: HLP_FKT_ARV_EIN

Iniciar archivo

Esta función inicia un archivo seleccionado del módulo opcional Servidor de archivos.

Más en el manual online


HLP_FKT_ARV_EXP

Interne ID: HLP_FKT_ARV_EXP

Exportar archivo

Esta función exporta las entradas filtradas de archivos del módulo opcional Servidor de archivos a un formato externo.

Más en el manual online


HLP_FKT_ARV_IND

Interne ID: HLP_FKT_ARV_IND

Indexar archivo

Esta función indexa archivos. Se ejecutará siempre en el servidor que lleve el proceso.

Más en el manual online


HLP_FKT_BATCH_CR_CREATE

Interne ID: HLP_FKT_BATCH_CR_CREATE

Crear receta de control

Permite crear durante el runtime una receta de control predefinida en el editor.

Más en la Ayuda online.


HLP_FKT_BATCH_STATE_CMD

Interne ID: HLP_FKT_BATCH_STATE_CMD

Ejecutar comando de recetas-/cambio de modo

Permite enviar durante el runtime comandos de control a la ejecución de lotes.

Más en el Manual online.


HLP_FKT_BEDIENBERECHTIGUNG

Interne ID: HLP_FKT_BEDIENBERECHTIGUNG

Licencia de uso en la red

Esta función pide o concede la autorización de uso para la red.

Más en el manual online


HLP_FKT_BILD

Interne ID: HLP_FKT_BILD

ERROR, No name defined!

Description as text.


HLP_FKT_BILD_AUS

Interne ID: HLP_FKT_BILD_AUS

Cerrar pantalla

Esta función cierra una imagen seleccionada.

Más en el manual online


HLP_FKT_BILD_EIN

Interne ID: HLP_FKT_BILD_EIN

Cambio de pantalla

Esta función abre una imagen seleccionada. Antes se puede abrir facultativamente un diálogo para el usuario.

Más en el manual online


HLP_FKT_BILD_FOKUS

Interne ID: HLP_FKT_BILD_FOKUS

Mover foco

Esta función aplica el foco establecido a un elemento determinado de una imagen cuya plantilla tenga el foco.

Más en el manual online


HLP_FKT_BILD_MENU

Interne ID: HLP_FKT_BILD_MENU

Mostrar Menú

Esta función abre o cierra un menú principal seleccionado. Antes se puede abrir facultativamente un diálogo para el usuario.

Más en el manual online


HLP_FKT_BILD_MITTE

Interne ID: HLP_FKT_BILD_MITTE

Desplazar centro de pantalla

Esta función desplaza y/o hace zoom sobre una imagen global.

Más en el manual online


HLP_FKT_BILD_SW_KDBMDI

Interne ID: HLP_FKT_BILD_SW_KDBMDI

Valor predeterminado para la imagen del teclado

Esta función establece un valor predefinido (valor propuesto) para una imagen del tipo Teclado o escribe un valor predefinido y cierra la imagen.

Más en el manual online


HLP_FKT_BILD_VAR

Interne ID: HLP_FKT_BILD_VAR

Pantalla indexada

Con esta función se selecciona una variable que contiene el nombre de la pantalla que se va a abrir.

Más en el manual online.


HLP_FKT_BILD_ZURUECK

Interne ID: HLP_FKT_BILD_ZURUECK

Pantalla anterior

Esta función vuelve a la imagen anteriormente abierta de la plantilla seleccionada.

Atención: Independientemente de la selección en la función durante el runtime solo se tendrán en cuenta los marcos que se hayan definido de manera general en la propiedad de proyecto Marcos principales en el grupo Diseño gráfico/runtime.

Más en el manual online.


HLP_FKT_CEL_EXP

Interne ID: HLP_FKT_CEL_EXP

Exportar CEL

Esta función exporta las entradas filtradas de la lista cronológica de eventos (CEL) a un formato externo.

Más en el manual online.


HLP_FKT_CHANGE_ALC_COLOR

Interne ID: HLP_FKT_CHANGE_ALC_COLOR

Cambiar colores de fuente ALC

Función para la configuración de los colores fuente ALC para la detección de errores en redes eléctricas.

Más en el Manual online.


HLP_FKT_DATEIOPERATION

Interne ID: HLP_FKT_DATEIOPERATION

Operación de archivo

Esta función copia, elimina o desplaza los archivos seleccionados. Antes se puede abrir facultativamente un diálogo para el usuario.

Más en el manual online


HLP_FKT_DBASE_READ

Interne ID: HLP_FKT_DBASE_READ

Leer archivo Dbase

Esta función lee un archivo dbase seleccionado y lo ejecuta como receta.

Más en el manual online


HLP_FKT_DEL_PIC_BACK_PATH

Interne ID: HLP_FKT_DEL_PIC_BACK_PATH

Eliminar la ruta de 'Pantalla anterior'

Esta función elimina la ruta de la función .

Más en el manual online.


HLP_FKT_DIAGRAM_PRINT

Interne ID: HLP_FKT_DIAGRAM_PRINT

Imprimir diagrama de tendencia ampliada

Con ayuda de esta función puede imprimir diagramas de la tendencia ampliada o guardarlos en un archivo (JPG, BMP o SVG), sin tener que activar la imagen del tipo tendencia ampliada.

Más en el manual online


HLP_FKT_EINGABE_FOCUS

Interne ID: HLP_FKT_EINGABE_FOCUS

Activar entrada al elemento enfocado

Esta función activa la funcionalidad del elemento que esté siendo enfocado.

Más en el manual online


HLP_FKT_EMS_START

Interne ID: HLP_FKT_EMS_START

Iniciar administración de la carga

Con ayuda de esta función se inicia la optimización de un área de suministro seleccionada en el módulo Administración de la carga.

Esta función solo se ejecuta en el servidor.

Más en el manual online.


HLP_FKT_EMS_STOP

Interne ID: HLP_FKT_EMS_STOP

Parar administración de la carga

Con ayuda de esta función se finaliza la optimización de un área de suministro seleccionada en el módulo Administración de la carga.

Esta función solo se ejecuta en el servidor.

Más en el manual online.


HLP_FKT_EXP_DATEN

Interne ID: HLP_FKT_EXP_DATEN

Exportar datos

Esta función exporta los valores (*.HDD) de las variables seleccionadas guardados en el disco duro a un formato externo.

Más en el manual online


HLP_FKT_GNDFLT_ACKNOWLEDGE

Interne ID: HLP_FKT_GNDFLT_ACKNOWLEDGE

Reconocer pérdida a tierra

Función para reconocer un mensaje de pérdida a tierra. Abre un diálogo para elegir una variable.

Más en el Manual online.


HLP_FKT_GNDFLT_SEARCH_END

Interne ID: HLP_FKT_GNDFLT_SEARCH_END

Finalizar búsqueda de pérdida a tierra

Función para finalizar la búsqueda de pérdidas a tierra.

Más en el Manual online.


HLP_FKT_GNDFLT_SEARCH_START

Interne ID: HLP_FKT_GNDFLT_SEARCH_START

Iniciar búsqueda de pérdida a tierra

Función para iniciar la búsqueda de pérdidas a tierra.

Más en el Manual online.


HLP_FKT_GRAPH7_HEURISTIK

Interne ID: HLP_FKT_GRAPH7_HEURISTIK

Analizar heurística S7-Graph

Esta función le permite ejecutar la heurística S7-Graph sin tener que activar la imagen del tipo S7-Graph.

Más en el manual online.


HLP_FKT_HDD_AUS

Interne ID: HLP_FKT_HDD_AUS

Administración HD desactivada

Esta función desactiva el almacenamiento de datos en el disco duro. Los archivos HDD no serán escritos.

Más en el manual online


HLP_FKT_HDD_EIN

Interne ID: HLP_FKT_HDD_EIN

Administración HD activada

Esta función activa el almacenamiento de datos en el disco duro. Los archivos HDD serán escritos.

Más en el manual online


HLP_FKT_HDD_TGL

Interne ID: HLP_FKT_HDD_TGL

Tendencias desactivadas/activadas

Esta función activa o desactiva el almacenamiento de datos en el disco duro. Los archivos HDD (no) serán escritos.

Más en el manual online


HLP_FKT_HLP_FKT_AUS

Interne ID: HLP_FKT_HLP_FKT_AUS

Funciones desactivadas con valores límite

Esta función desactiva la administración de funciones. Las funciones ejecutadas automáticamente (p. ej. control del tiempo, violación de los límites, etc.) no serán ejecutadas.

Más en el manual online


HLP_FKT_HLP_FKT_EIN

Interne ID: HLP_FKT_HLP_FKT_EIN

Funciones activadas con valores límite

Esta función activa la administración de funciones. Las funciones ejecutadas automáticamente (p. ej. control del tiempo, violación de los límites, etc.) serán ejecutadas.

Más en el manual online


HLP_FKT_HLP_FKT_TGL

Interne ID: HLP_FKT_HLP_FKT_TGL

Funciones activadas/desactivadas con valores límite

Esta función activa o desactiva la administración de funciones. Las funciones ejecutadas automáticamente (p. ej. control del tiempo, violación de los límites, etc.) (no) serán ejecutadas.

Más en el manual online


HLP_FKT_IMM_CHECKMAINT

Interne ID: HLP_FKT_IMM_CHECKMAINT

Determinar matenimientos abiertos

Esta función detecta el número de mantenimientos vencidos del Industrial Maintenance Manager para las instalaciones especificadas. Puede determinar el periodo para analizar. El número de mantenimientos pendientes se escribirá en variables de estado libremente definibles.

Más en el manual online


HLP_FKT_IPA_CREATE_DOCUMENT

Interne ID: HLP_FKT_IPA_CREATE_DOCUMENT

Crear/imprimir documento IPA

Esta función crea un documento con los datos filtrados del Industrial Performance Analyzer y lo imprime o guarda como documento HTML.

Más en el manual online


HLP_FKT_MOMENTAN_PRT

Interne ID: HLP_FKT_MOMENTAN_PRT

Imprimir valores actuales

Esta función imprime los valores actuales de las variables seleccionadas.

Más en el manual online


HLP_FKT_MONITOR_ZUORDNEN

Interne ID: HLP_FKT_MONITOR_ZUORDNEN

Asignar monitor

Esta función asigna a un monitor virtual seleccionado un monitor real seleccionado. Antes se puede abrir facultativamente un diálogo para el usuario.

Más en el manual online


HLP_FKT_MOUSE_REVERSE

Interne ID: HLP_FKT_MOUSE_REVERSE

Simular click derecho

Esta función interpreta el próximo clic del ratón como un clic del botón derecho.

Más en el manual online


HLP_FKT_MSG_AUS

Interne ID: HLP_FKT_MSG_AUS

Desactivar envío de mensaje

Esta función desactiva el envío de mensajes del módulo opcional Message Control.

Más en el manual online


HLP_FKT_MSG_EDB

Interne ID: HLP_FKT_MSG_EDB

Mostrar base de datos de destino

Esta función abre un diálogo, en el cual el usuario puede editar en el banco de datos destinatario del módulo opcional Message Control.


HLP_FKT_MSG_EIN

Interne ID: HLP_FKT_MSG_EIN

Activar envío de mensaje

Esta función activa el envío de mensajes del módulo opcional Message Control.

Más en la ayuda online.


HLP_FKT_MSG_SAVEQUEUE

Interne ID: HLP_FKT_MSG_SAVEQUEUE

Guardar cola de espera actual

Guarda una imagen de la cola actual durante el runtime.

Más en la ayuda online.


HLP_FKT_MSG_SUPPRESS

Interne ID: HLP_FKT_MSG_SUPPRESS

Suprimir grupos/clases/áreas/equipos

Desactiva o activa elementos de la lista para los que hay que enviar mensajes.

Más en la ayuda online.


HLP_FKT_NACHLADEN

Interne ID: HLP_FKT_NACHLADEN

Recargar

Esta función recarga los archivos runtime modificados en el editor.

Más en el manual online


HLP_FKT_PFS_EVENT

Interne ID: HLP_FKT_PFS_EVENT

PFS - activar evento personalizado

Esta función ejecuta un evento PFS previamente creado por el usuario.

Más en el manual online


HLP_FKT_PRT_AMLCEL

Interne ID: HLP_FKT_PRT_AMLCEL

Imprimir AML o CEL

Esta función imprime las entradas filtradas de la lista de alarmas o de la lista cronológica de eventos (CEL).

Más en el manual online


HLP_FKT_PRT_HARDCOPY

Interne ID: HLP_FKT_PRT_HARDCOPY

Imprimir captura de pantalla

Esta función imprime la pantalla actual o la imagen actualmente abierta de una plantilla seleccionada. En sistemas con varios monitores se puede seleccionar el monitor para marcos. La impresión se puede hacer opcionalmente por un fax.

Más en el manual online


HLP_FKT_PRT_ONLINE

Interne ID: HLP_FKT_PRT_ONLINE

Encender/apagar impresión online

Esta función activa o desactiva la impresión online de la lista de alarmas o de la lista cronológica de eventos (CEL).

Más en el manual online


HLP_FKT_PRT_ONLINE_SWITCH

Interne ID: HLP_FKT_PRT_ONLINE_SWITCH

Cambiar impresora online

Esta función cambia la impresión online a la impresora que elija. Antes se puede abrir facultativamente un diálogo para el usuario.

Más en el manual online


HLP_FKT_PRT_WAHL

Interne ID: HLP_FKT_PRT_WAHL

Seleccionar impresora

Esta función abre un diálogo donde el usuario puede seleccionar impresoras para las distintas tareas de impresión.
Observación: ¡Esta función no está disponible para todos los dispositivos CE!

Más en el manual online


HLP_FKT_PWD_LOGIN

Interne ID: HLP_FKT_PWD_LOGIN

Login con diálogo

Esta función abre el diálogo estándar de login.

Más en el manual online


HLP_FKT_PWD_LOGIN_DIREKT

Interne ID: HLP_FKT_PWD_LOGIN_DIREKT

Login sin contraseña

Esta función registra a un usuario seleccionado, sin preguntale por la contraseña.

Más en el manual online


HLP_FKT_PWD_LOGOUT

Interne ID: HLP_FKT_PWD_LOGOUT

Logout

Esta función saca al usuario actualmente registrado.

Más en el manual online


HLP_FKT_PWD_PWDEDIT

Interne ID: HLP_FKT_PWD_PWDEDIT

Cambiar contraseña

Esta función abre un diálogo donde el usuario actualmente registrado puede cambiar su contraseña.

Más en el manual online


HLP_FKT_PWD_USREDIT

Interne ID: HLP_FKT_PWD_USREDIT

Cambiar usuario

Esta función abre un diálogo donde un administrador registrado puede crear, editar o eliminar usuarios y grupos de usuarios.

Más en el Manual online.


HLP_FKT_QUIT

Interne ID: HLP_FKT_QUIT

Finalizar runtime

Esta función finaliza el runtime del sistema de control.

Más en el manual online


HLP_FKT_REDUNDANZ

Interne ID: HLP_FKT_REDUNDANZ

Cambio de redundancia

Esta función intercambia el servidor primario por el servidor standby del proyecto.

Más en el manual online


HLP_FKT_REPORTVIEWER_PRINT

Interne ID: HLP_FKT_REPORTVIEWER_PRINT

Report Viewer: exportar / imprimir

Permite emitir informes durante el runtime como PDF o como impresión online.

Más en el manual online.


HLP_FKT_REZ_DIREKT

Interne ID: HLP_FKT_REZ_DIREKT

Receta estándar individual directa

Esta función envía los valores de una receta estándar seleccionada al control.

Más en el manual online


HLP_FKT_REZ_WAHL

Interne ID: HLP_FKT_REZ_WAHL

Receta estándar individual con diálogo

Esta función abre un diálogo donde el usuario puede modificar y ejecutar una receta estándar.

Más en el manual online


HLP_FKT_REZ_WAHL_ONL

Interne ID: HLP_FKT_REZ_WAHL_ONL

Receta estándar individual con diálogo online

Esta función abre un diálogo donde el usuario puede seleccionar una receta estándar y ejecutarla y/o modificarla.

Más en el manual online


HLP_FKT_REZEPT

Interne ID: HLP_FKT_REZEPT

Receta estándar

Esta función escribe, lee, copia, importa o exporta una receta estándar seleccionada. Antes se puede abrir facultativamente un diálogo para el usuario.

Más en el manual online


HLP_FKT_RGM

Interne ID: HLP_FKT_RGM

Adm. de grupos de recetas

Esta función escribe, lee, copia, importa o exporta una receta seleccionada del módulo opcional Administrador de grupo de recetas (RGM). Antes se puede abrir facultativamente un diálogo para el usuario.

Más en el manual online


HLP_FKT_SAP_CALL_FUNCTION

Interne ID: HLP_FKT_SAP_CALL_FUNCTION

Ejecutar función SAP

Ejecuta una función SAP definida en una interfaz SAP durante el tiempo de ejecución. La función SAP desencadena a su vez una llamada a función remota (RFC-Remote Function Call) en el sistema SAP.

Más en el manual online.


HLP_FKT_SAT1

Interne ID: HLP_FKT_SAT1

Activar comando de salida

Función SAT


HLP_FKT_SAT2

Interne ID: HLP_FKT_SAT2

Genearar protocolo de cambio de turno

Función SAT


HLP_FKT_SAT_SEA_RUN

Interne ID: HLP_FKT_SAT_SEA_RUN

Secuencia de comandos automática

Función SAT.


HLP_FKT_SAT_TOP_ERDSCHLUSS

Interne ID: HLP_FKT_SAT_TOP_ERDSCHLUSS

Topología - Búsqueda de pérdidas a tierra

Activa o desactiva la búsqueda de pérdidas a tierra. Al empezar la búsqueda de pérdidas a tierra se congelarán las averías actualmente existentes. Las nuevas averías se mostrarán después de que haya terminado la búsqueda.


HLP_FKT_SAT_TOP_LOADSHEDDING

Interne ID: HLP_FKT_SAT_TOP_LOADSHEDDING

Topología - Comprobar conexiones

Con ayuda de la función Loadshedding (Desconexión de carga) se puede determinar y representar con variables el estado de suministro de los dispositivos topológicos.

Se pueden utilizar hasta 32 fuentes.


HLP_FKT_SCHABFOCUS_AUS

Interne ID: HLP_FKT_SCHABFOCUS_AUS

Quitar foco del marco

Esta función elimina el foco establecido de la imagen actualmente abierta de una plantilla seleccionada. Así puede crear proyectos utilizando únicamente el teclado.

Más en el manual online


HLP_FKT_SCHABFOCUS_EIN

Interne ID: HLP_FKT_SCHABFOCUS_EIN

Situar foco en el marco

Esta función aplica el foco a la imagen actualmente abierta de una plantilla seleccionada. Así puede crear proyectos utilizando únicamente el teclado.

Más en el manual online


HLP_FKT_SCHABLONE_AUS

Interne ID: HLP_FKT_SCHABLONE_AUS

Cerrar marco

Esta función cierra la imagen actualmente abierta de una plantilla seleccionada.

Más en el manual online


HLP_FKT_SCHABLONE_BRINGTOFRONT

Interne ID: HLP_FKT_SCHABLONE_BRINGTOFRONT

Mover marco al primer plano

Esta función coloca en un primer plano pantallas que han sido superpuestas por otras. Se seleccionará un marco que durante el runtime coloca todas las instancias del marco definido en un primer plano del monitor seleccionado.

Más en el Manual online.


HLP_FKT_SCRIPT_DIR

Interne ID: HLP_FKT_SCRIPT_DIR

Ejecutar script

Esta función ejecuta el script seleccionado.

Más en el manual online


HLP_FKT_SCRIPT_WHL

Interne ID: HLP_FKT_SCRIPT_WHL

Script con selección online

Esta función abre un diálogo donde el usuario puede seleccionar y ejecutar un script.

Más en el manual online


HLP_FKT_SENDE_NACHRICHT

Interne ID: HLP_FKT_SENDE_NACHRICHT

Enviar mensaje

Esta función envía un mensaje del módulo opcional Message Control.

Más en el manual online


HLP_FKT_SHRTFLT_ACKNOWLEDGE

Interne ID: HLP_FKT_SHRTFLT_ACKNOWLEDGE

Reconocer mensaje de cortocircuito

Función para reconocer un mensaje de cortocircuito. Abre un diálogo para elegir una variable.

Más en el Manual online.


HLP_FKT_SIMULATION

Interne ID: HLP_FKT_SIMULATION

Simulación on/off

Esta función activa o desactiva la simulación.


HLP_FKT_TBL_AUS

Interne ID: HLP_FKT_TBL_AUS

Report Generator: ejecutar

Esta función ejecuta un informe seleccionado del módulo opcional Report Generator .

Más en el manual online


HLP_FKT_TBL_EXP

Interne ID: HLP_FKT_TBL_EXP

Report Generator: exportar

Esta función exporta un informe seleccionado del módulo opcional Report Generator a un formato externo.

Más en el manual online


HLP_FKT_TBL_EXPW

Interne ID: HLP_FKT_TBL_EXPW

Impresión online empezar nueva página

Esta función finaliza una página con la impresión online activada y empieza otra nueva. El número de página vuelve a comenzar con 1.

Más en el manual online


HLP_FKT_TBL_PRN

Interne ID: HLP_FKT_TBL_PRN

Report Generator: imprimir

Esta función imprime un informe seleccionado del módulo opcional Report Generator .

Más en el manual online


HLP_FKT_TM_READ

Interne ID: HLP_FKT_TM_READ

Leer hora de variable

Esta función lee el tiempo de una variable de cadena del control y sincroniza correspondientemente la hora del sistema operativo. Así se puede sincronizar la hora del sistema de control con la del sistema operativo.

Más en el manual online


HLP_FKT_TM_WRITE

Interne ID: HLP_FKT_TM_WRITE

Escribir hora en variable

Esta función lee la hora del sistema operativo y la escribe en una variable de cadena en el control. Así se puede sincronizar la hora del sistema de control con la del sistema operativo.

Más en el manual online


HLP_FKT_TREIBERKOMMANDO

Interne ID: HLP_FKT_TREIBERKOMMANDO

Comandos de driver

Esta función envía un comando seleccionado a un driver seleccionado. Antes se puede abrir facultativamente un diálogo para el usuario.

Más en el manual online


HLP_FKT_UEBERSICHT

Interne ID: HLP_FKT_UEBERSICHT

Mostrar ventana de vista general

Esta función abre una ventana de vista general, de manera que se pueda simular en un sistema de un monitor, un sistema de varios monitores.

Más en el manual online


HLP_FKT_VAR_ALIGN_VM_IMAGE

Interne ID: HLP_FKT_VAR_ALIGN_VM_IMAGE

Transferir imagen de simulación del driver al servidor standby

Sólo se ejecutará en el servidor standby.

Requiere una imagen para los drivers seleccionados durante la ejecución del servidor. El driver tiene 5 segundos para ello.

Más en el manual online


HLP_FKT_VAR_SOLLWERT

Interne ID: HLP_FKT_VAR_SOLLWERT

Escribir valor predeterminado

Esta función envía un valor nuevo de la variable seleccionada al control.

Más en el manual online


HLP_FKT_VBA_IDE

Interne ID: HLP_FKT_VBA_IDE

Abrir editor VBA

Esta función abre el editor VBA.

Más en el manual online.


HLP_FKT_VBA_MAKRO

Interne ID: HLP_FKT_VBA_MAKRO

Ejecutar macro VBA

Esta función ejecuta una macro VBA seleccionada.

Atención: El evento VBA project inactive se ejecutará antes de los scripts AUTO_END_xxx . Por lo tanto la función zenon Ejecutar macro VBA ya no se ejecutará en los scripts debido a que VBA no estará funcionando más en ese momento. Las macros VBA que deban ejecutarse al finalizar el runtime, se tendrán que activar con el evento Project.Inactive.

Más en el manual online.


HLP_FKT_VBA_MCR

Interne ID: HLP_FKT_VBA_MCR

Mostrar diálogo de macro VBA

Esta función abre el diálogo de la macro VBA.

Más en el manual online.


HLP_FKT_VBA_PCE

Interne ID: HLP_FKT_VBA_PCE

Abrir editor PCE

Esta función abre el editor del módulo opcional Process Control Engine (PCE).

Más en el manual online.


HLP_FKT_VSTA_CALLMACRO

Interne ID: HLP_FKT_VSTA_CALLMACRO

Ejecutar macro VSTA

Esta función ejecuta una macro VSTA seleccionada.

Más en el manual online.


HLP_FKT_VSTA_SHOWIDE

Interne ID: HLP_FKT_VSTA_SHOWIDE

Abrir editor VSTA

Esta función abre el editor VSTA.

Más en el manual online.


HLP_FKT_VSTA_SHOWMACRODLG

Interne ID: HLP_FKT_VSTA_SHOWMACRODLG

Mostrar diálogo de macro VSTA

Esta función abre el diálogo de la macro VSTA.

Más en el manual online.


HLP_FKT_WND_AUDI_AUFUEHREN

Interne ID: HLP_FKT_WND_AUDI_AUFUEHREN

Ejecutar archivo audio

Esta función ejecuta una única vez un archivo de sonido seleccionado (*.wav).

Más en el manual online.


HLP_FKT_WND_AUDI_START

Interne ID: HLP_FKT_WND_AUDI_START

Iniciar sonido continuo

Esta función ejecuta repetidamente un archivo de sonido (*.wav) .

Más en el manual online.


HLP_FKT_WND_AUDI_STOP

Interne ID: HLP_FKT_WND_AUDI_STOP

Finalizar sonido continuo

Esta función detiene la ejecución repetida de un archivo de sonido (*.wav).

Más en el manual online.


HLP_FKT_WND_BTN

Interne ID: HLP_FKT_WND_BTN

Al fondo

Esta función coloca el runtime del sistema de control en un plano de fondo.

Más en el manual online.


HLP_FKT_WND_PROG_AUFUEHREN

Interne ID: HLP_FKT_WND_PROG_AUFUEHREN

Iniciar programa

Esta función inicia un programa externo. Se pueden definir los parámetros de transmisión. Antes se puede abrir facultativamente un diálogo para el usuario.

Más en el manual online.


HLP_FKT_WND_TOP

Interne ID: HLP_FKT_WND_TOP

En primer plano

Esta función coloca el runtime zenon en un primer plano.

Atención: Al colocarlo en un primer plano se tapará la barra de estado de alarmas.

Más en el manual online


HLP_GRP_FKT_AMLCEL

Interne ID: HLP_GRP_FKT_AMLCEL

AML y CEL

Este grupo contiene funciones para trabajar con la lista de alarmas y la lista cronológica de eventos (CEL).

Más en el manual online.


HLP_GRP_FKT_ANWENDUNG

Interne ID: HLP_GRP_FKT_ANWENDUNG

Aplicación

Este grupo contiene funciones para trabajar con las configuraciones del proyecto.

Más en el manual online.


HLP_GRP_FKT_ARV

Interne ID: HLP_GRP_FKT_ARV

Servidor de históricos

Este grupo contiene funciones para el módulo opcional Servidor de archivos.

Más en el manual online.


HLP_GRP_FKT_BILD

Interne ID: HLP_GRP_FKT_BILD

Pantallas

Este grupo contiene funciones para trabajar con imágenes.

Más en el manual online.


HLP_GRP_FKT_FAULT_LOCATION

Interne ID: HLP_GRP_FKT_FAULT_LOCATION

Detección de error en redes eléctricas

Contiene funciones para la detección de errores en redes eléctricas.

Más en el Manual online.


HLP_GRP_FKT_FAVORITEN

Interne ID: HLP_GRP_FKT_FAVORITEN

Favoritos

Este grupo contiene los favoritos personales. Éstos se pueden ajustar con Drag&Drop o con el menú contextual en las funciones correspondientes.

Más en el manual online


HLP_GRP_FKT_NACHRICHT

Interne ID: HLP_GRP_FKT_NACHRICHT

Message Control

Este grupo contiene funciones para el módulo opcional Message Control.

Más en el manual online


HLP_GRP_FKT_NETZ

Interne ID: HLP_GRP_FKT_NETZ

Red

Este grupo contiene funciones para trabajar con una red.

Más en el manual online.


HLP_GRP_FKT_PASSWORT

Interne ID: HLP_GRP_FKT_PASSWORT

Administración de usuario

Este grupo contiene funciones para la administración de usuarios.

Más en el manual online.


HLP_GRP_FKT_REZEPT

Interne ID: HLP_GRP_FKT_REZEPT

Recetas

Este grupo contiene funciones para trabajar con recetas estándar y recetas del módulo opcional Administrador de grupo de recetas.

Más en el manual online.


HLP_GRP_FKT_SCRIPT

Interne ID: HLP_GRP_FKT_SCRIPT

Script

Este grupo contiene funciones para trabajar con scripts.

Más en el manual online.


HLP_GRP_FKT_TABELLE

Interne ID: HLP_GRP_FKT_TABELLE

Report Generator / Report Viewer / Analyzer

Este grupo contiene funciones para el Report Generator, el Report Viewer y para el producto de COPA-DATA zenon Analyzer.

Más en el manual online.


HLP_GRP_FKT_VARIABLE

Interne ID: HLP_GRP_FKT_VARIABLE

Variable

Este grupo contiene funciones para trabajar con variables.

Más en el manual online.


HLP_GRP_FKT_VBA

Interne ID: HLP_GRP_FKT_VBA

VBA

Este grupo contiene funciones para trabajar con macros VBA.

Más en el manual online.


HLP_GRP_FKT_VSTA

Interne ID: HLP_GRP_FKT_VSTA

VSTA

Este grupo contiene funciones para trabajar con macros VSTA.

Más en el manual online.


HLP_GRP_FKT_WINDOWS

Interne ID: HLP_GRP_FKT_WINDOWS

Windows

Este grupo contiene funciones para trabajar con la funcionalidad del sistema operativo.

Más en el manual online.


ID_230TOP_PROP_B_FOS

Interne ID: ID_230TOP_PROP_B_FOS

Límite para la localización del error desde la protección

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TopologyBorderFOS


ID_230TOP_PROP_B_SHL

Interne ID: ID_230TOP_PROP_B_SHL

Límite para Selfhealing

Si la propiedad está establecida: El elemento actúa como límite para una región self-healing.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TopologyBorderSHL


ID_230TOP_PROP_B_SV

Interne ID: ID_230TOP_PROP_B_SV

Límite para cálculo de distribución de corriente

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TopologyBorderSV


ID_230TOP_PROP_B_WBR

Interne ID: ID_230TOP_PROP_B_WBR

Limite para regulación de rango ancho

Si la propiedad está establecida: El elemento actúa como límite para una región regulación de rango amplio.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TopologyBorderWBR


ID_230TOP_PROP_INVISIBLE

Interne ID: ID_230TOP_PROP_INVISIBLE

en RT oculto

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RTInvisible


ID_230TOP_PROP_LIRE

Interne ID: ID_230TOP_PROP_LIRE

Intercambiar dirección efectiva/montaje

Intercambia la referencia izquierda/derecha en elementos topológicos que tengan una referencia direccional.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TopologyLRChanged


ID_230TOP_PROP_NC_CABLETYPE

Interne ID: ID_230TOP_PROP_NC_CABLETYPE

Tipo de cable

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NCCableType


ID_230TOP_PROP_NC_CURRENTMAX

Interne ID: ID_230TOP_PROP_NC_CURRENTMAX

Capacidad de corriente [A]

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NCCCurrentMax


ID_230TOP_PROP_NC_I_MAX

Interne ID: ID_230TOP_PROP_NC_I_MAX

Carga máxima asingnable

Maximal load which can be assigned.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NCCurrentMax


ID_230TOP_PROP_NC_I_VAL

Interne ID: ID_230TOP_PROP_NC_I_VAL

Carga [A]

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NCCurrentVal


ID_230TOP_PROP_NC_I_VAR

Interne ID: ID_230TOP_PROP_NC_I_VAR

Valor de medición de corriente / carga

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NCCurrentVar


ID_230TOP_PROP_NC_LENGTH

Interne ID: ID_230TOP_PROP_NC_LENGTH

Longitud [m]

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NCCLength


ID_230TOP_PROP_NC_REAKT

Interne ID: ID_230TOP_PROP_NC_REAKT

Reactancia [Ohm]

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NCCReactance


ID_230TOP_PROP_NC_RESIST

Interne ID: ID_230TOP_PROP_NC_RESIST

Resistencia [Ohm]

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NCCResistance


ID_230TOP_PROP_NC_TYPE

Interne ID: ID_230TOP_PROP_NC_TYPE

Tipo

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NCType


ID_230TOP_PROP_NC_U_VAL

Interne ID: ID_230TOP_PROP_NC_U_VAL

Nivel de tensión [V]

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NCVoltageVal


ID_230TOP_PROP_NC_U_VAR

Interne ID: ID_230TOP_PROP_NC_U_VAR

Valor de medición tensión

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NCVoltageVar


ID_230TOP_PROP_RES_NR

Interne ID: ID_230TOP_PROP_RES_NR

Tipo de equipo

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TopologyResourceNr


ID_230TOP_PROP_USE_FRAME

Interne ID: ID_230TOP_PROP_USE_FRAME

Utilizar efectos/bordes para ribeteado

Si la propiedad está establecida: El borde (anchura / distancia) parametrizado en Efectos/Bordes se utilizará también para el ribeteado con los elementos Combi.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TopologyUseFrame


ID_230TOP_PROP_ZUORD_VAR

Interne ID: ID_230TOP_PROP_ZUORD_VAR

Prefijo para variables cartográficas

Variable que sirve de base para las variables en la topología.

En la topología puede establecer una variable para cada línea. Esta variable servirá de base para futuras variables

que vaya a definir al proyectar en la topología. Puede asignar a estas variables valores relativos a la potencia

calculados por la topología.

Haga clic sobre el botón para abrir el diálogo de selección de variables.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NCMappingVar


ID_230TOP_PROP_ZUORD_VAR_IN

Interne ID: ID_230TOP_PROP_ZUORD_VAR_IN

Prefix für Ergebnisvariablen

Esta función se invocará para zenon API (con nombre de clase):

NCMappingVarIn


ID_230TOP_PROP_ZUORD_VAR_OUT

Interne ID: ID_230TOP_PROP_ZUORD_VAR_OUT

Prefix für Eingangsvariablen

Esta función se invocará para zenon API (con nombre de clase):

NCMappingVarOut


ID_ADMINUSER

Interne ID: ID_ADMINUSER

Administrador

Activado: Este usuario es un administrador. Por lo tanto puede editar a otros usuarios en el runtime y desbloquear el sistema.
Desactivado: Este usuario no es un administrador.
Por defecto: desactivado

ATENCIÓN: Un administrador puede conceder a otros usuarios únicamente las autorizaciones que él mismo posee.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Admin


ID_ADRESSPARAM

Interne ID: ID_ADRESSPARAM

Parámetros de dirección externos

Propiedad externa para zenon Logic Sólo afecta a variables que no sean del driver straton.
Propiedades del perfil en zenon Logic (como p. ej. "incrustado" o parámetros de direccionamiento para profibus).

Esta propiedad se muestra solo como información. Editable solo con zenon Logic.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Adressparam


ID_ALARM_BEREICH_ALARMVAR

Interne ID: ID_ALARM_BEREICH_ALARMVAR

Número de alarmas activas

Variable que contiene como valor el número de alarmas activas en esta área de alarmas.
Abre el diálogo de selección de variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmVar


ID_ALARM_BEREICH_QUITVAR

Interne ID: ID_ALARM_BEREICH_QUITVAR

Número de alarmas no reconocidas

Variable que contiene como valor el número de alarmas no reconocidas en esta área de alarmas.
Abre el diálogo de selección de variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

QuitVar


ID_ALARM_BEREICH_STATUSVAR

Interne ID: ID_ALARM_BEREICH_STATUSVAR

Variable de estado

El primer bit de esta variable de byte muestra si hay alarmas activas en esta área de alarmas.
Abre el diálogo de selección de variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StatusVar


ID_ALARM_BEREICHITEM_ALARMVAR

Interne ID: ID_ALARM_BEREICHITEM_ALARMVAR

Número de alarmas activas

Variable que contiene como valor el número de alarmas activas de la clase de alarmas/eventos seleccionada en esta área de alarmas.
Abre el diálogo de selección de variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmVar


ID_ALARM_BEREICHITEM_DELETE

Interne ID: ID_ALARM_BEREICHITEM_DELETE

{Eliminar vínculo de clase}

Se eliminará la entrada de área.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DeleteEntry


ID_ALARM_BEREICHITEM_KLASSE

Interne ID: ID_ALARM_BEREICHITEM_KLASSE

Alarma/Clase de evento

Clase de alarmas/eventos para la entrada de área

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Class


ID_ALARM_BEREICHITEM_QUITVAR

Interne ID: ID_ALARM_BEREICHITEM_QUITVAR

Número de alarmas no reconocidas

Variable que contiene como valor el número de alarmas no reconocidas de la clase de alarmas/eventos seleccionada en esta área de alarmas.
Abre el diálogo de selección de variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

QuitVar


ID_ALARM_BEREICHITEM_STATUSVAR

Interne ID: ID_ALARM_BEREICHITEM_STATUSVAR

Variable de estado

El primer bit de esta variable de byte muestra si hay alarmas activas de la clase de alarmas/eventos seleccionada en esta área de alarmas.
Abre el diálogo de selección de variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StatusVar


ID_ALARM_PROP_BEREICH_ID

Interne ID: ID_ALARM_PROP_BEREICH_ID

Nr

Identifica el área de alarmas. El número se asignará automáticamente y se puede modificar.

Mínimo: 1

Máximo: 2147483647

Observación: Dentro de un proyecto solo se puede asignar cada número una sola vez al área de alarmas. Si en la administración de multiproyectos se asigna el mismo número a varias áreas de alarmas en diferentes proyectos se producirá un aviso al crear los archivos runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Id


ID_ALARM_PROP_BEREICH_ITEMS

Interne ID: ID_ALARM_PROP_BEREICH_ITEMS

Vínculo de clase}

Refleja la variable de estado, el número de alarmas activas y de alarmas no reconocidas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Items


ID_ALARM_PROP_BEREICH_NAME

Interne ID: ID_ALARM_PROP_BEREICH_NAME

Nombre:

Nombre del área de alarmas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_ALARM_PROP_BEREICH_NEU

Interne ID: ID_ALARM_PROP_BEREICH_NEU

{Vínculo de clase nuevo}

Crea una nueva entrada de área para el área de alarmas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

New


ID_ALARM_PROP_GRPKLS

Interne ID: ID_ALARM_PROP_GRPKLS

General

Propiedades para los grupos o clases de alarmas/eventos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_GrpCls


ID_ALARM_PROP_GRPKLS_COLOR

Interne ID: ID_ALARM_PROP_GRPKLS_COLOR

Color

Color del grupo o clase de alarmas/eventos.
El color de la clase de alarmas/eventos puede utilizarse para la representación en las listas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Color


ID_ALARM_PROP_GRPKLS_FUNKTION

Interne ID: ID_ALARM_PROP_GRPKLS_FUNKTION

Función

Nombre de la función que se ejecuta cuando se produzca una alarma de esta clase o grupo. Con un clic sobre el botón se abre un diálogo para elegir las funciones. También puede introducir el nombre de la función manualmente en el campo de texto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Function


ID_ALARM_PROP_GRPKLS_ID

Interne ID: ID_ALARM_PROP_GRPKLS_ID

Nr

Identifica el grupo de alarmas/eventos o la clase de alarmas/eventos. El número se asignará automáticamente y se puede modificar.

Mínimo: 1

Máximo: 2147483647

Observación: Dentro de un proyecto solo se puede asignar cada número una sola vez al grupo de alarmas/eventos así como a la clase de alarmas/eventos. Si en la administración de multiproyectos se asigna el mismo número a varios grupos de alarmas/eventos o clases de alarmas/eventos en diferentes proyectos se producirá un aviso al crear los archivos runtime.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Id


ID_ALARM_PROP_GRPKLS_IMAGE

Interne ID: ID_ALARM_PROP_GRPKLS_IMAGE

Archivo gráfico

Seleccione un gráfico para el grupo o clase de alarmas/eventos. Haciendo clic izquierdo sobre el botón se abre la selección de archivos. Seleccione el archivo gráfico deseado.

Por defecto: ningún archivo

Más información sobre grupos de alarmas/eventos en el manual online

Más información sobre clases de alarmas/eventos en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Image


ID_ALARM_PROP_GRPKLS_NAME

Interne ID: ID_ALARM_PROP_GRPKLS_NAME

Nombre:

Nombre del grupo o clase de alarmas/eventos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_ALARM_PROP_GRPKLS_STATUSVAR

Interne ID: ID_ALARM_PROP_GRPKLS_STATUSVAR

Variable de estado

Nombre de la variable cuyo valor muestra si el grupo o clase está activado en ese momento o si las alarmas de este grupo o clase están siendo ignoradas.

Sólo se pueden utilizar variables binarias. Con un clic sobre el botón se abre un diálogo para elegir las variables. También puede introducir el nombre de la variable manualmente en el campo de texto.

Valor de la variable = 1: Grupo o clase activada.

Los grupos o clases de alarmas/eventos se puede activar con ayuda de la función Grupo de alarmas/eventos log in/log off.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StatusVar


ID_ALARM_PROP_GRPKLS_TEXT

Interne ID: ID_ALARM_PROP_GRPKLS_TEXT

Descripción

Descripción del grupo o clase de alarmas/eventos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Description


ID_ALARM_VERWALTUNG

Interne ID: ID_ALARM_VERWALTUNG

Alarm-Verwaltung

Abriendo el diálogo de configuración para la lista de mensajes de alarma.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera: ""


ID_ALPHABACKCOLOR

Interne ID: ID_ALPHABACKCOLOR

Transparencia color de relleno [%]

Sólo disponible si la propiedad Con valores de luminosidad no está activada y para la propiedad de proyecto Calidad gráfica no se haya seleccionado Windows Basis.

Define con un valor entre 0 y 100 por ciento la cobertura del color.

0: cubriente

100: completamente transparente

Todos los valores intermedios se representan más o menos transparentes dependiendo de la configuración.

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlphaBackColor


ID_ALPHABACKCOLOR2

Interne ID: ID_ALPHABACKCOLOR2

Transparencia gradiente de color [%]

Solo disponible si en la propiedad Estampado de relleno se ha seleccionado Gradiente.

Sólo disponible si la propiedad Con valores de luminosidad no está activada y para la propiedad de proyecto Calidad gráfica no se haya seleccionado Windows Basis.

Define con un valor entre 0 y 100 por ciento la cobertura del color.

0: cubriente

100: completamente transparente

Todos los valores intermedios se representan más o menos transparentes dependiendo de la configuración.

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlphaBackColor2


ID_ALPHACOLORRAHMEN

Interne ID: ID_ALPHACOLORRAHMEN

Transparencia color del borde [%]

Sólo disponible si la propiedad Con valores de luminosidad no está activada.

Sólo disponible si la propiedad del proyecto Calidad gráfica está activada.

Define con un valor entre 0 y 100 porciento la cobertura del color.

0: Oculto

100: cubriente.

Todos los valores intermedios se representan más o menos transparentes dependiendo de la configuración.

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlphaBorderColor


ID_ALPHALINECOLOR

Interne ID: ID_ALPHALINECOLOR

Transparencia color de líneas [%]

Sólo disponible si la propiedad Con valores de luminosidad no está activada y para la propiedad de proyecto Calidad gráfica no se haya seleccionado Windows Basis.

Define con un valor entre 0 y 100 por ciento la cobertura del color.

0: cubriente

100: completamente transparente

Todos los valores intermedios se representan más o menos transparentes dependiendo de la configuración.

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlphaLineColor


ID_AML_AKTIV

Interne ID: ID_AML_AKTIV

Lista de mensajes de alarma activada

Activado: La administración de alarmas está activada en el runtime. Las alarmas se grabarán y la lista de mensajes de alarma estará disponible.
Desactivado: Las alarmas no se grabarán.
Por defecto: activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmAdminActive


ID_AML_BLINKQUIT

Interne ID: ID_AML_BLINKQUIT

Reconocimiento de parpadeo

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.
Activado: Al reconocer el parpadeo de un elemento se reconocerá también la alarma correspondiente en la lista de mensajes de alarma.
Desactivado: El reconocimiento del parpadeo de un elemento solo finaliza el parpadeo. La alarma correspondiente no estará reconocida.
Por defecto: desactivado.
El parpadeo de elementos se puede reconocer con un doble clic en el botón derecho del ratón sobre el elemento correspondiente o con la función "Reconocer parpadeo".

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmFlashAcknowledge


ID_AML_CLS_COLOR

Interne ID: ID_AML_CLS_COLOR

Color de clase de alarmas/eventos

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.

  • no utilizar: Los colores de las clases de alarmas/eventos no se utilizarán en la lista de mensajes de alarma en el runtime.
  • como color de texto: Los colores de las clases de alarmas/eventos se utilizarán en la lista de mensajes de alarma en el runtime como colores de texto para las entradas correspondientes.
  • como color de fondo de fila: Los colores de las clases de alarmas/eventos se utilizarán en la lista de mensajes de alarma en el runtime como colores de fondo para las entradas correspondientes.

Por defecto: como color de texto:

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmClsColor


ID_AML_COLOR_DEL

Interne ID: ID_AML_COLOR_DEL

Color

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.

Solo disponible para alarmas con la propiedad Eliminación obligatoria activada.

Color para el sello horario de Alarma eliminada en la lista de mensajes de alarma. Define también el color para el gráfico en la columna estado de alarmas.

Este color se utiliza sólo para alarmas activas no para las históricas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmColorDel


ID_AML_COLOR_GEHT

Interne ID: ID_AML_COLOR_GEHT

Color

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.
Color para Tiempo para despejar en la lista de mensajes de alarma. Define también el color para el gráfico en la columna estado de alarmas.

Este color se utiliza sólo para alarmas activas no para las históricas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmColorClr


ID_AML_COLOR_KOMMT

Interne ID: ID_AML_COLOR_KOMMT

Color

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.
Color para Tiempo para recibir en la lista de mensajes de alarma. Define también el color para el gráfico en la columna estado de alarmas.

Este color se utiliza sólo para alarmas activas no para las históricas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmColorRec


ID_AML_COLOR_QUIT

Interne ID: ID_AML_COLOR_QUIT

Color

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.
Color para Tiempo para reconocer en la lista de mensajes de alarma. Define también el color para el gráfico en la columna estado de alarmas.

Este color se utiliza sólo para alarmas activas no para las históricas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmColorAkn


ID_AML_COMES_PREF

Interne ID: ID_AML_COMES_PREF

Prefijo

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.

Entrada del prefijo que se encuentra a la izquierda del sello horario de la alarma recibida. El prefijo ayuda a reconocer rápidamente el sello horario deAlarma recibida. Si la entrada se deja vacía no se mostrará ningún prefijo.

Por defecto: >>

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmPrefComes


ID_AML_COMES_PREF_IMAGE

Interne ID: ID_AML_COMES_PREF_IMAGE

Prefijo del archivo gráfico

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.

Defina un archivo que deba mostrarse además o en lugar del Prefijo a la izquierda del sello horario de la alarma recibida. El gráfico ayuda a reconocer rápidamente el sello horario de Alarma recibida. Si define un archivo además del Prefijo, éste se mostrará a la izquierda del prefijo.

Por defecto: ningún archivo

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmPrefImageComes


ID_AML_COUNT1

Interne ID: ID_AML_COUNT1

Mensaje 1 número de alarmas

Solo disponible cuando la propiedad Barra de estado activa esté activada.
Número de entradas en AML necesarias para que este mensaje se muestre en la fila de estado de alarmas en el runtime. Este mensaje se superpondrá a la barra de estado de alarmas.
Mínimo: 0 (No se mostrará ningún mensaje)
Máximo: 100
Por defecto:: 0
Atención: El valor tiene que ser menor que el valor en la propiedad Mensaje 2 número de alarmas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmMsgCnt1


ID_AML_COUNT2

Interne ID: ID_AML_COUNT2

Mensaje 2 número de alarmas

Solo disponible cuando la propiedad Barra de estado activa esté activada.
Número de entradas en AML necesarias para que este mensaje se muestre en la fila de estado de alarmas en el runtime. Este mensaje se superpondrá a la barra de estado de alarmas.
Mínimo: 0 (No se mostrará ningún mensaje)
Máximo: 100
Por defecto:: 0
Atención: El valor tiene que ser menor que el valor en la propiedad Mensaje 3 número de alarmas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmMsgCnt2


ID_AML_COUNT3

Interne ID: ID_AML_COUNT3

Mensaje 3 número de alarmas

Solo disponible cuando la propiedad Barra de estado activa esté activada.
Número de entradas en AML necesarias para que este mensaje se muestre en la fila de estado de alarmas en el runtime. Este mensaje se superpondrá a la barra de estado de alarmas.
Mínimo: 0 (No se mostrará ningún mensaje)
Máximo: 100
Por defecto:: 0
Atención: El valor tiene que ser menor que el valor en la propiedad Tamaño del búfer circular.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmMsgCnt3


ID_AML_DELETEINCEL

Interne ID: ID_AML_DELETEINCEL

Eliminar alarma

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.
Activado: Cuando se elimina una alarma de las de eliminación obligatoria, se efectuará una entrada en la Lista de eventos cronológica (CEL).
Desactivado: Al eliminar alarmas no se efectuará ninguna entrada en CEL.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmCELDelete


ID_AML_DETACH

Interne ID: ID_AML_DETACH

Administración del búfer anular

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.
Cuando se excede en la memoria el número de alarmas determinado en la propiedad Tamaño del búfer circular se ejecutará una de las siguientes acciones:
Rechazar nuevas: Las alarmas nuevas serán ignoradas. Atención: ¡Estas alarmas no se guardarán y en consecuencia se perderán!
First In First Out: Una nueva alarma desplaza a la alarma más antigua del búfer anular al archivo correspondiente. Por ejemplo: con un tamaño de búfer anular de 5 cuando se produzca la sexta alarma la primera alarma se desplazará al archivo correspondiente para hacer sitio a dicha sexta alarma actual (a la manera en que funciona una cola de espera).
Last In First Out: Una nueva alarma desplaza a la alarma más reciente del búfer anular al archivo correspondiente. Por ejemplo: con un tamaño de búfer anular de 5 cuando se produzca la sexta alarma la quinta alarma se desplazará al archivo correspondiente. La séptima alarma desplazará a la sexta, etc.

Por defecto: First In First Out

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmDetach


ID_AML_GOES_PREF

Interne ID: ID_AML_GOES_PREF

Prefijo

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.

Entrada del prefijo que se encuentra a la izquierda del sello horario de la alarma recibida. El prefijo ayuda a reconocer rápidamente el sello horario de Alarma despejada. Si la entrada se deja vacía no se mostrará ningún prefijo.

Por defecto: >>

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmPrefGoes


ID_AML_GOES_PREF_IMAGE

Interne ID: ID_AML_GOES_PREF_IMAGE

Prefijo del archivo gráfico

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.

Defina un archivo que deba mostrarse además o en lugar del Prefijo a la izquierda del sello horario de la alarma despejada. El gráfico ayuda a reconocer rápidamente el sello horario de Alarma despejada. Si define un archivo además del Prefijo, éste se mostrará a la izquierda del prefijo.

Por defecto: ningún archivo

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmPrefImageGoes


ID_AML_GRP_CLEARED

Interne ID: ID_AML_GRP_CLEARED

Alarma despejada

Propiedades para la representación de Alarma despejada en la lista de información de alarmas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_AML_Cleared


ID_AML_GRP_COLOR

Interne ID: ID_AML_GRP_COLOR

Farben AML-Einträge

Propiedades para definir los colores para la administración de alarmas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera: ""


ID_AML_GRP_DEL

Interne ID: ID_AML_GRP_DEL

Alarma eliminada

Propiedades para la representación de Alarma eliminada en la lista de información de alarmas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_AML_Deleted


ID_AML_GRP_IMAGE

Interne ID: ID_AML_GRP_IMAGE

Graphik AML-Einträge

Propiedades para la configuración gráfica de la lista de información de alarmas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:


ID_AML_GRP_MEM

Interne ID: ID_AML_GRP_MEM

Almacenamiento de datos AML

Propiedades para el almacenamiento de las alarmas en la memoria central y en el disco duro.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_AML_Mem


ID_AML_GRP_QUIT

Interne ID: ID_AML_GRP_QUIT

Alarma reconocida

Propiedades para la representación de Alarma reconocida en la lista de información de alarmas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_AML_Acknowledged


ID_AML_GRP_RECIVED

Interne ID: ID_AML_GRP_RECIVED

Alarma recibida

Propiedades para la representación de Alarma recibida en la lista de información de alarmas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_AML_Received


ID_AML_GRP_STATUSBAR

Interne ID: ID_AML_GRP_STATUSBAR

Barra de estado de alarmas

Propiedades para la barra de estado de la administración de alarmas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_AML_StatusBar


ID_AML_IMAGE_DEL

Interne ID: ID_AML_IMAGE_DEL

Estado del archivo gráfico

Selección de un archivo gráfico para el estado Alarma eliminada. Puede ver este archivo alternativamente al color seleccionado del estado en el runtime en la lista de información de alarmas. Para ello seleccione en el filtro para la AML en la pestaña Configuraciones de columna para la columna estado de alarma el modo de visualización Archivo gráfico.

Por defecto: ningún archivo

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmImageDel


ID_AML_IMAGE_GEHT

Interne ID: ID_AML_IMAGE_GEHT

Estado del archivo gráfico

Seleccione un archivo gráfico para el estado Alarma despejada. Puede ver este archivo alternativamente al color seleccionado del estado en el runtime en la lista de información de alarmas. Para ello seleccione en el filtro para AML en la pestaña Configuraciones de columna el modo de visualización para la columna de estado de alarma Archivo gráfico.

Por defecto: ningún archivo

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmImageClr


ID_AML_IMAGE_KOMMT

Interne ID: ID_AML_IMAGE_KOMMT

Estado del archivo gráfico

Seleccione un archivo gráfico para el estado Alarma recibida. Puede ver este archivo alternativamente al color seleccionado del estado en el runtime en la lista de información de alarmas. Para ello seleccione en el filtro para AML en la pestaña Configuraciones de columna el modo de visualización para la columna de estado de alarma Archivo gráfico.

Por defecto: ningún archivo

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmImageRec


ID_AML_IMAGE_QUIT

Interne ID: ID_AML_IMAGE_QUIT

Estado del archivo gráfico

Seleccione un archivo gráfico para el estado Alarma reconocida. Puede ver este archivo alternativamente al color seleccionado del estado en el runtime en la lista de información de alarmas. Para ello seleccione en el filtro para AML en la pestaña Configuraciones de columna el modo de visualización para la columna de estado de alarma Archivo gráfico.

Por defecto: ningún archivo

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmImageAkn


ID_AML_LISTENTRY

Interne ID: ID_AML_LISTENTRY

Configuraciones de columna AML

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.
Abre el diálogo para definir las columnas que se mostrarán en la lista de mensajes de alarma.
Estas configuraciones se aplicarán por defecto a la lista de mensajes de alarma, el filtro de la lista de mensajes de alarma y la barra de estado de alarmas. Se pueden modificar al definir cada función de alarma.

Estas configuraciones se aplicarán también para exportar con CSV, XML o DBF.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmListEntry


ID_AML_LST_STYLE

Interne ID: ID_AML_LST_STYLE

Encabezado AML

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.

  • Ningún encabezado: Durante el runtime no se mostrará en la lista de mensajes de alarma ningún encabezado con título de columna .
  • Encabezado fijo: Se mostrará un encabezado fijo en la lista de mensajes de alarma con el correspondiente título de columna
  • Encabezado editable: Se mostrará un encabezado manejable en la lista de mensajes de alarma con el correspondiente título de columna Las columnas individuales pueden desplazarse durante el runtime y se les puede ajustar el ancho. Se puede ordenar según una columna cualquiera.

Atención: Las configuraciones Ningún encabezado y Encabezado editable solo funcionan durante el runtime si para el elemento de lista de la pantalla de AML la propiedad Configuraciones gráficas ampliadas está desactivada o si en las propiedades de proyecto del grupo Diseño gráfico la propiedad Calidad gráfica está en off.
Por defecto: Encabezado editable

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmHeader


ID_AML_MEMCOUNT

Interne ID: ID_AML_MEMCOUNT

Tamaño del búfer circular

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.
Número máximo de entradas para el búfer anular.

Mínimo: 10
Máximo: 32767
Por defecto:: 100

Recomendado: Número mínimo de variables con alarma.

Atención: El búfer anular debe ser lo suficientemente grande. Durante el runtime el búfer anular se manejará dinámicamente en la memoria de trabajo Por lo que se mostrarán también alarmas de tamaño mayor al búfer anular. En el archivo de memoria del búfer anular (alarm.bin) solo se guardarán las alarmas hasta un número determinado. Todas las entradas se registrarán paralelamente en el archivo de alarma (*.aml) en la carpeta runtime. Los dos archivos estarán sincronizados. En caso de desbordamiento del búfer, el archivo de alarmas puede contener entradas no reconocidas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmMemCount


ID_AML_MITREAKTZEIT

Interne ID: ID_AML_MITREAKTZEIT

Utilizar tiempo reactivado

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.
Activado: Cuando la misma alarma salte varias veces consecutivas solo se creará una fila en la lista de mensajes de alarma. En la lista se puede representar información adicional (p. ej. contador de alarmas).
Desactivado: Cada alarma tendrá una fila propia en la lista de mensajes de alarma.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmTimeReactive


ID_AML_MSG1

Interne ID: ID_AML_MSG1

Mensaje 1 texto

Solo disponible cuando el valor de la propiedad Mensaje 1 número de alarmas sea mayor que 0.
Texto del mensaje para la propiedad Mensaje 1 número de alarmas que se mostrará en la barra de estado durante el runtime. Este mensaje se superpondrá a la barra de estado de alarmas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmMsg1


ID_AML_MSG2

Interne ID: ID_AML_MSG2

Mensaje 2 texto

Solo disponible cuando el valor de la propiedad Mensaje 2 número de alarmas sea mayor que 0.
Texto del mensaje para la propiedad Mensaje 2 número de alarmas que se mostrará en la barra de estado durante el runtime. Este mensaje se superpondrá a la barra de estado de alarmas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmMsg2


ID_AML_MSG3

Interne ID: ID_AML_MSG3

Mensaje 3 texto

Solo disponible cuando el valor de la propiedad Mensaje 3 número de alarmas sea mayor que 0.
Texto del mensaje para la propiedad Mensaje 3 número de alarmas que se mostrará en la barra de estado durante el runtime. Este mensaje se superpondrá a la barra de estado de alarmas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmMsg3


ID_AML_ONLY_STACK

Interne ID: ID_AML_ONLY_STACK

Guardar datos AML

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.

  • Sólo búfer circular Sólo se guardarán en el disco duro las alarmas actuales (alarm.bin).
  • Búfer anular y datos históricos: También se guardarán las alarmas históricas (*.aml).
  • Por defecto: En los dispositvos CE sólo se guardará el Ringpuffer (alarm.bin) en el disco duro; en los PCs se guardarán también las entradas históricas (*.aml).

Por defecto: Por defecto.
Los archivos(alarm.bin y *.aml) serán guardados en la carpeta \Carpeta del proyecto\Nombre del ordenador\Nombre del proyecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AmlOnlyStack


ID_AML_QUIT_PREF

Interne ID: ID_AML_QUIT_PREF

Prefijo

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.

Entrada del prefijo que se encuentra a la izquierda del sello horario de la alarma reconocida. El prefijo ayuda a reconocer rápidamente el sello horario deAlarma reconocida. Si la entrada se deja vacía no se mostrará ningún prefijo.

Por defecto: --

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmPrefQuit


ID_AML_QUIT_PREF_IMAGE

Interne ID: ID_AML_QUIT_PREF_IMAGE

Prefijo del archivo gráfico

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.

Defina un archivo que deba mostrarse además o en lugar del Prefijo a la izquierda del sello horario de la alarma reconocida. El gráfico ayuda a reconocer rápidamente el sello horario de Alarma reconocida. Si define un archivo además del Prefijo, éste se mostrará a la izquierda del prefijo.

Por defecto: ningún archivo

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmPrefImageQuit


ID_AML_QUITINCEL

Interne ID: ID_AML_QUITINCEL

Reconocimiento de alarma

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.
Activado: Cuando se reconozca una alarma se registrará una entrada en la lista cronológica de eventos (CEL).
Desactivado: El reconocimiento de alarmas no dará lugar a ninguna entrada en CEL.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmCELAcknowledge


ID_AML_STATUS_AKTIV

Interne ID: ID_AML_STATUS_AKTIV

Barra de estado activa

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.

  • Activado: En cuanto salte una alarma se mostrará durante el runtime una barra de estado roja en la parte superior de la pantalla con información sobre la alarma. En esta barra de estado se puede reconocer la alarma haciendo doble clic derecho con el ratón, siempre y cuando el usuario registrado tenga la autorización necesaria.
  • Desactivado: No se mostrará ninguna barra de estado.

Por defecto: activado

Atención administración de proyectos múltiples: La configuración en el proyecto de integración define el comportamiento de proyectos subordinados con independencia de la configuración de los proyectos subordinados. Durante el runtime se utilizará siempre la barra de estado de alarmas del proyecto superior.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmStatusActive


ID_AML_STATUS_DISPLAY

Interne ID: ID_AML_STATUS_DISPLAY

Mostrar

Solo disponible cuando la propiedad Barra de estado activa esté activada.

  • alarma más antigua: Dependiendo de la configuración de la propiedad Mover siguiente se mostrará solo la alarma más antigua no reconocida en la barra de estado en el runtime (desactivado) o se mostrará la alarma más antigua de primera (activado).
  • Alarma más reciente: Dependiendo de la configuración de la propiedad Mover siguiente se mostrará solo la alarma más recienteno reconocida en la barra de estado en el runtime (desactivado) o se mostrará la alarma más reciente de primera (activado).

Por defecto: Alarma más antigua:

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmStatusDisplay


ID_AML_STATUS_FONT

Interne ID: ID_AML_STATUS_FONT

Fuente

Solo disponible cuando la propiedad Barra de estado activa esté activada.
Tipo de fuente para la barra de estado en el runtime

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmStatusFont


ID_AML_STATUS_SUBSEQ

Interne ID: ID_AML_STATUS_SUBSEQ

Mover siguiente

Solo disponible cuando la propiedad Barra de estado activa esté activada.

  • Activado: Durante el runtime se mostrarán todas las alarmas no reconocidas en la barra de estado una detrás de otra. En cuanto se reconozca una alarma con un doble clic derecho del ratón, se mostrará la siguiente alarma. Dependiendo de la configuración de la propiedad Mostrar se mostrará la alarma más antigua o la más reciente.
  • Desactivado: En la barra de estado se mostrará siempre solo una alarma. La barra de estado se quedará vacía cuando se reconozca la alarma.

Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmStatusAlign


ID_AML_UNACKBLINK

Interne ID: ID_AML_UNACKBLINK

Las alarmas no reconocidas parpadean

Activado: Las filas no seleccionadas con alarmas no reconocidas parpadearan en la lista de alarmas.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmUnackBlink


ID_AUTOLOGOFFTIME

Interne ID: ID_AUTOLOGOFFTIME

Tiempo [mín]

Tiempo sin operaciones (en minutos) después del cual se desconectará al usuario, cuando la propiedad Logout automático activado esté activada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AutoLogoutTime


ID_AUTOLOGOUT

Interne ID: ID_AUTOLOGOUT

Logout automático activado

  • Activado: Se desconectará automáticamente al usuario cuando transcurra el tiempo definido en la propiedad Tiempo [mín] sin que se haya realizado ninguna operación.
  • Desactivado: El sistema no desconectará automáticamente al usuario.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AutoLogout


ID_BACKUP_FILE_NAME

Interne ID: ID_BACKUP_FILE_NAME

Nombre de archivo

Nombre del archivo de seguridad.
Por defecto: AAAA-MM-DD_hh-mm-ss nombredelproyecto.zip.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_BiffiDCM_NV

Interne ID: ID_BiffiDCM_NV

NV-Index

Ei índice NV sólo es relevante para los datos del nodo.

Introduzca aquí el índice de las variables de red (NVI/NVO) de la variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NV-Index


ID_BiffiDCM_SENDDIRECT

Interne ID: ID_BiffiDCM_SENDDIRECT

Send directly

La configuración sólo es relevante para los datos del nodo.

Introduzca si desea que un valor predeterminado se transmita al DCM directamente o amortiguado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Send_direct


ID_BiffiDCM_TRANSIENT

Interne ID: ID_BiffiDCM_TRANSIENT

Transient command

La configuración sólo es relevante para los datos del nodo.

Determine si desea que el driver vuelva a colocar en 0 el valor actual recibido a través de un comando de evento, es decir, que se trataría de un borrado implícito. (P. ej. ICON2K Open, Close, Stop)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Transient


ID_BURPVI_ADDRESS

Interne ID: ID_BURPVI_ADDRESS

PVI Name

Es el nombre de la variable SPS. El nombre se forma a partir del Nombre de tarea/nombre de la variable . Para variables globales: Sólo Nombre de la variable

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BURPVI_ADDRESS


ID_BURPVI_GROUP

Interne ID: ID_BURPVI_GROUP

PVI Address

Información sobre direcciones para el driver Bernecker & Reiner PVI (BURPVI)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_PVI_Address


ID_BURPVI_VL_LENGTH

Interne ID: ID_BURPVI_VL_LENGTH

PVI Length (VL)

Longitud de la variable en bytes.
En las variables individuales la longitud de la variable se corresponde a la longitud de los datos del proceso. En las variables de campo la longitud de la variable se define como longitud del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BURPVI_VL_LENGTH


ID_BURPVI_VN_ELEMENTS

Interne ID: ID_BURPVI_VN_ELEMENTS

PVI Number of Elements (VN)

Número de elementos en las variables de campo.
En las variables de campo multidimensionales se introduce el número de elementos de todas las dimensiones de campo (Ejemplo: var[10][5] => VN=50).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BURPVI_VN_ELEMENTS


ID_BURPVI_VT_TYPE

Interne ID: ID_BURPVI_VT_TYPE

PVI Type (VT)

Tipo de variable en el control. Los valores posibles están descritos en el manual online. La utilización de un tipo de dato divergente en zenon puede dar lugar a un typecasting.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BURPVI_VT_TYPE


ID_CEL_AKTIV

Interne ID: ID_CEL_AKTIV

CEL activo

  • Activado: La lista cronológica de eventos (CEL) está activada en el runtime. Los eventos se grabarán y la lista CEL estará disponible.
  • Desactivado: No se grabarán los eventos.

Por defecto: activado

Observación: Las modificaciones no se aplicarán hasta que se vuelva a reiniciar el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CELAdminActive


ID_CEL_ARCHIVE_CHANGE

Interne ID: ID_CEL_ARCHIVE_CHANGE

Datos de archivo

Solo disponible cuando la propiedad CEL activo esté activada.

  • Ninguna protocolización: No se protocolizará la edición de archivos en la CEL.
  • Protocolizar modificaciones: Al editar archivos se protocolizará en la CEL:
    • el nombre del archivo
    • el valor nuevo y antiguo de las variables
    • el sello horario nuevo y antiguo de las variables
    • el nombre de la variable

Por defecto: Ninguna protocolización

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ArchiveChangeToCEL


ID_CEL_CLS_COLOR

Interne ID: ID_CEL_CLS_COLOR

Color de clase de alarmas/eventos

Solo disponible cuando la propiedad CEL activo esté activada.

no utilizar: Los colores de las clases de alarmas/eventos no se utilizarán en la CEL en el runtime.

como color de texto: Los colores de las clases de alarmas/eventos se utilizarán en la CEL en el runtime como colores de texto para las entradas correspondientes. Sobrescribirán la selección en la propiedad Texto clasificado.

como color de fondo de fila: Los colores de las clases de alarmas/eventos se utilizarán en la CEL durante el runtime como colores de fondo para las entradas correspondientes.

Por defecto: como color de texto:

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CELClsColor


ID_CEL_COLOR_SORT

Interne ID: ID_CEL_COLOR_SORT

Texto clasificado

Solo disponible cuando la propiedad CEL activo esté activada.

Define el color del texto para las entradas ordenadas en la lista cronológica de eventos (CEL).
Observaciones:

  • Si para la propiedad Color de clase de alarmas/eventos se elige como color del texto éste color tendrá preferencia sobre la elección en Texto clasificado.
  • Para SICAM 230: Para tener el mismo color en toda la lista tiene que elegir en la propiedad Texto sin clasificar el mismo color.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CELColorSort


ID_CEL_COLOR_UNSORT

Interne ID: ID_CEL_COLOR_UNSORT

Texto sin clasificar

Sólo disponible si la propiedad CEL activo está activada.
Color del texto para las entradas no ordenadas de la lista cronológica de eventos (CEL).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CELColorUnsort


ID_CEL_GRP_ALLGEMEIN

Interne ID: ID_CEL_GRP_ALLGEMEIN

Protocolización

Propiedades generales para la lista cronológica de eventos (CEL).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_CEL_Common


ID_CEL_GRP_COLOR

Interne ID: ID_CEL_GRP_COLOR

Entradas de colores CEL

Propiedades para definir los colores para la lista cronológica de eventos (CEL).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_CEL_Color


ID_CEL_GRP_MEM

Interne ID: ID_CEL_GRP_MEM

Almacenamiento de datos CEL

Propiedades para el almacenamiento de las entradas de la lista cronológica de eventos (CEL) en la memoria central y en el disco duro.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_CEL_Mem


ID_CEL_LISTENTRY

Interne ID: ID_CEL_LISTENTRY

Configuraciones de columna CEL

Solo disponible cuando la propiedad CEL activo esté activada.
Abre el diálogo para definir las columnas en la CEL.
Estas configuraciones se aplicarán por defecto y se podrán modificar al definir cada función individual en la CEL.

Estas configuraciones se aplicarán también para exportar con CSV, XML o DBF.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CELListEntry


ID_CEL_LST_STYLE

Interne ID: ID_CEL_LST_STYLE

Encabezado CEL

Solo disponible cuando la propiedad CEL activo esté activada.
ningún encabezado: Durante el runtime no se mostrará en la CEL ningún encabezado con título de columna.
encabezado fijo: En la CEL se mostrará un encabezado fijo con el correspondiente título de columna.
encabezado editable: En la CEL se mostrará un encabezado editable con el correspondiente título de columna. Las columnas individuales se pueden desplazar durante el runtime, se puede modificar su anchura y se pueden ordenar en base una columna cualquiera.
Por defecto: Encabezado editable

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CELHeader


ID_CEL_MEMCOUNT

Interne ID: ID_CEL_MEMCOUNT

Tamaño del búfer circular

Solo disponible cuando la propiedad CEL activo esté activada.
Tamaño del búfer anular de CEL. En caso de desbordamiento del búfer anular (cel.bin) las entradas se transmitirán al archivo CEL (*.cel).
Mínimo: 10
Máximo: 32767
Por defecto:: 100

Observación: Puede ser que durante el runtime se muestren más entradas de las proyectadas debido a que las entradas antiguas no se eliminan de la CEL hasta que no se actualice la lista.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CELMemCount


ID_CEL_ONLY_STACK

Interne ID: ID_CEL_ONLY_STACK

Guardar datos CEL

Solo disponible cuando la propiedad CEL activo esté activada.

  • Búfer anular y datos históricos: Se guardarán todas las entradas CEL (*.cel).
  • Sólo Ringpuffer: Solo se guardará un número determinado de entradas CEL (cel.bin). Dicho número se definirá con la propiedad Tamaño del búfer circular.
  • Por defecto: En los dispositivos CE sólo se guardará el búfer anular (cel.bin); en los PCs se guardarán también las entradas históricas (*.cel).

Por defecto: Por defecto
Los archivos (cel.bin y *.cel) se guardarán en la carpeta \Carpeta del proyecto\Nombre del ordenador\Nombre del proyecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CelOnlyStack


ID_CEL_RECIPE_CHANGE

Interne ID: ID_CEL_RECIPE_CHANGE

Modificar recetas

Solo disponible cuando la propiedad CEL activo esté activada.

  • Ninguna protocolización: La modificación de las recetas estándar y las recetas del administrador del grupo de recetas (RGM) no se protocolizará en la CEL.
  • Protocolizar recetas: Al modificar una receta, ésta se protocolizará en la CEL con el nombre de la receta modificada.
  • Protocolizar recetas y valores: Al modificar una receta, ésta se protocolizará en la CEL con:
    • el nombre de la receta
    • los valores nuevos y antiguos de las variables
    • el nombre de las variables

Por defecto: ninguna protocolización

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RecipeChangeToCEL


ID_CEL_RECIPE_WRITE

Interne ID: ID_CEL_RECIPE_WRITE

Escribir receta

Solo disponible cuando la propiedad CEL activo esté activada.

  • Ninguna protocolización: La escritura de recetas estándar y recetas del administrador del grupo de recetas (RGM) no se protocolizará en la CEL.
  • Protocolizar recetas: Al escribir una receta, ésta se protocolizará con el nombre de la receta en la CEL.
  • Protocolizar recetas y valores: Al escribir una receta, ésta se protocolizará en la CEL con:
    • el nombre de la receta
    • los valores nuevos y antiguos de las variables
    • el nombre de las variables

Por defecto: ninguna protocolización

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RecipeWriteToCEL


ID_CEL_SPONTAN

Interne ID: ID_CEL_SPONTAN

Actualizar automáticamente

Solo disponible cuando la propiedad CEL activo esté activada.

  • Activado: Mientras la CEL esté abierta durante el runtime se le irán añadiendo los eventos nuevos en cuanto ocurran.
  • Desactivado: Mientras la CEL esté abierta no se le añadirán nuevas entradas. Las nuevas entradas se añadirán la próxima vez que se abra la CEL.
    Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CELSpontan


ID_CEL_SYSMSGPRT

Interne ID: ID_CEL_SYSMSGPRT

Imprimir mensajes del sistema

Activado: Con la impresión online se imprimirán también los mensajes del sistema.
Desactivado: Con la impresión online no se imprimirán los mensajes del sistema.
Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CELSysMsgPrint


ID_CEL_VERWALTUNG

Interne ID: ID_CEL_VERWALTUNG

CEL-Verwaltung

Se abrirá el diálogo de configuración para la lista cronológica de eventos (CEL).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CELAdministration


ID_CHANGELOG_COMMENT

Interne ID: ID_CHANGELOG_COMMENT

Comentario

Comentario para la entrada seleccionada en el histórico de cambios.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Comment


ID_CHANGELOG_FILTER_DATASETS

Interne ID: ID_CHANGELOG_FILTER_DATASETS

Max. Datensätze

Determina el número máximo de entradas que se pueden mostrar en las listas.
Mínimo: 0.
Es decir, se mostrarán todas las entradas.
Máximo: 2147483647.
Por defecto: 1000.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Datensätze


ID_CHANGELOG_FILTER_PROP_GRP0

Interne ID: ID_CHANGELOG_FILTER_PROP_GRP0

Erweiterter Filter

Propiedades para el filtro ampliado del histórico de cambios.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:


ID_CHANGELOG_FILTER_TIME_MAX

Interne ID: ID_CHANGELOG_FILTER_TIME_MAX

Max. Zeitstempel

Solo disponible si el rango de tiempo está activado:
Momento más tarde posible para las entradas mostradas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TimestampMax


ID_CHANGELOG_FILTER_TIME_MIN

Interne ID: ID_CHANGELOG_FILTER_TIME_MIN

Min. Zeitstempel

Solo disponible si el rango de tiempo está activado:
Momento más temprano posible para las entradas mostradas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TimestampMin


ID_CHANGELOG_FILTER_TIMERANGE

Interne ID: ID_CHANGELOG_FILTER_TIMERANGE

Zeitbereich aktiv

Activado: Se puede filtrar el rango de tiempo.
Desactivado: No se puede filtrar el rango de tiempo.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TimeRange


ID_CHANGELOG_PROP_GRP0

Interne ID: ID_CHANGELOG_PROP_GRP0

General

Propiedades generales para las entradas en el histórico de cambios.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_COLOR_COLOR_GRP

Interne ID: ID_COLOR_COLOR_GRP

Color

Contiene todas las propiedades de los colores para paletas de colores.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Color


ID_COLOR_COLOR_NAME

Interne ID: ID_COLOR_COLOR_NAME

Nombre del color

Nombre del color.

Por defecto: Color más número de índice, p. ej.: Color 1

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ColorName


ID_COLOR_COLOR_VALUE

Interne ID: ID_COLOR_COLOR_VALUE

Color

Permite seleccionar o definir el color. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: blanco (#FFFFFF)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ColorValue


ID_COLOR_PALETTE_GRP

Interne ID: ID_COLOR_PALETTE_GRP

Paleta de colores

Contiene las propiedades de la paleta de colores.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Palette


ID_COLOR_PALETTE_NAME

Interne ID: ID_COLOR_PALETTE_NAME

Nombre de la paleta

Name der Farbpalette.

Default: Color palette plus Indexnummer, z. B.: Color palette 1

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PaletteName


ID_COLORRAHMEN

Interne ID: ID_COLORRAHMEN

Color de marco

Define el color del marco del elemento. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.Al seleccionar Automático cambia el valor del color dependiendo del valor de la Color de relleno.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BorderColor


ID_COMPLEXITEM_BITOFFSET

Interne ID: ID_COMPLEXITEM_BITOFFSET

Bit Offset

Número de bit del elemento de estructura en la estructura.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BitOffset


ID_COMPLEXITEM_HASREF

Interne ID: ID_COMPLEXITEM_HASREF

Vinculado con tipo de dato

Activado: El elemento está vinculado con el tipo de dato subyacente. Las modificaciones en el tipo de dato subyacente repercutirán directamente sobre el elemento. Las propiedades del elemento no se pueden editar más.
Desactivado: El elemento ya no está vinculado con el tipo de dato subyacente.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HasRef


ID_COMPLEXITEM_INDEX

Interne ID: ID_COMPLEXITEM_INDEX

Pos. en la estructura

Posición de la variable en la estructura.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ItemIndex


ID_COMPLEXITEM_OFFSET

Interne ID: ID_COMPLEXITEM_OFFSET

Offset

Offset del elemento de estructura en la estructura.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Offset


ID_DELUSER

Interne ID: ID_DELUSER

Eliminar usuario

  • Activado: Está permitido eliminar a un usuario en el runtime.
  • Desactivado: Solo se pueden marcar usuarios como eliminados. El usuario seguirá en la lista de usuarios pero no podrá realizar operaciones en el runtime (según la norma FDA).

Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DelUser


ID_DISABLEDBUTTONS

Interne ID: ID_DISABLEDBUTTONS

Botones bloqueados

Sólo disponible si la propiedad Login temporal activado está desactivada.
Define el aspecto de los botones que estén bloqueados como consecuencia de la configuración de la autorización de usuarios. Durante el runtime se combina con la propiedad Botones interbloqueados (Forma gráfica) para el manejo de las teclas.

Posibles formas de representación:

  • Gris
  • Normal
  • Invisible

Por defecto: Normal

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DisabledButtonStyle


ID_DNP3_OPERATION

Interne ID: ID_DNP3_OPERATION

Command Mode

Selección del modo de comando de la lista desplegable:

  • Automatic SBO: Al escribir se ejecutará un Select. Después de que la estación remota confirme el Selects seguirá un Operate. El estado de las variables se configurará como CoT_actterm. Esto se aplica para Outputs Binarios y Outputs Analógicos. Un Output Binario del tipo BOOL mediante el comando se puede utilizar también para Close y Trip configurando QoC en 2.
  • Direct Operate: Para escribir Outputs Binarios y Outputs Analógicos se utilizará Function Code 0x5 - Direct Operate -.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Command_Mode


ID_DNP3_SCANGROUP

Interne ID: ID_DNP3_SCANGROUP

Scangroup

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Scangroup


ID_DNP3_VARIATION

Interne ID: ID_DNP3_VARIATION

Variation

Selección de la variación de la lista desplegable:

  • Por defecto: Se utilizará la variación para variables tal y como se envie de la estación remota.
    Si se utiliza otra variación que la enviada por la estación remota o una para variables que no pertenezcan a ninguna clase pero que deban ser leídas de todas formas, se podrá definir entonces una variación alternativa. Seleccionar de la lista desplegable. Las alternativas que se ofrezcan dependen del tipo de objeto del driver de las variables. Los valores numéricos corresponden a los valores permitidos de la variación para este tipo de dato.

El driver requerirá una lectura manual con la variación definida después de cada sondeo de Clase 0 o activado por una variable de sondeo de clase. Si se selecciona otra variación que no sea Por defecto se deberá también activar siempre la propiedad Lectura continua de variable.

Observación: La estación remota tendrá que soportar la lectura de la variación.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variation


ID_DNP3TG_EXPLICITREAD

Interne ID: ID_DNP3TG_EXPLICITREAD

Classless read

Asignación de los valores a la variable en caso de consultas de lectura explícitas:

  • Desactivado: Los valores que se reciban mediante Integrity-Poll, Event-Poll oder unsolicited responses se asignarán a la variable.
    Los valores que se reciban como respuesta a una consulta de lectura explícita no se asignarán.
  • Activado: A la variable solo se le asignarán los valores que se reciban como respuesta a una consulta de lectura explícita.

Más en el manual online de drivers.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Classless_Read


ID_DNP3TG_OPERATION

Interne ID: ID_DNP3TG_OPERATION

Command Mode

Solo para tipos de objetos de driver Binary Output y Analog Output. Selección del Command Mode de la lista desplegable:

  • Automatic SBO: Al escribir se ejecutará Select. Después de la confirmación del Selects por la estación remota seguirá un Operate. El estado de las variables se fijará en CoT_actterm. Esto se aplica para Outputs binarios y Outputs analógicos. Un Output binario del tipo BOOL se puede utilizar también mediante el comando también para Close y Trip fijando el QoC en 2.
  • Direct Operate: Para escribir Outputs Binarios y Outputs Analógicos se utilizará Function Code 0x5 - Direct Operate -.
  • Direct Operate NoAck: Para escribir Outputs Binarios y Outputs Analógicos se utilizará Function Code 0x5 - Direct Operate -. El control no producirá ninguna respuesta; no se confirmará si se han escrito con éxito.

Por defecto: Direct Operate

Más en el manual online de drivers.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Command_Mode


ID_DRV_KNOTEN

Interne ID: ID_DRV_KNOTEN

Conexión de driver

Propiedades específicas de driver para la variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_DriverConnection


ID_DRV_STRAT_CREATE

Interne ID: ID_DRV_STRAT_CREATE

Editar

Sólo disponible si se ha seleccionado un driver del proceso, el nombre del proyecto es válido y se ha seleccionado un solo driver. No disponible para Driver para la variable del simulador.

Haciendo clic se abre el proyecto de simulación en el entorno de trabajo zenon Logic. Si no existe ningún proyecto de simulación para este driver, se creará automáticamente.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CreateSimulPrj


ID_DRV_STRAT_DEL

Interne ID: ID_DRV_STRAT_DEL

Eliminar

Sólo disponible si hay un proyecto de simulación definido y un sólo driver seleccionado.

Elimina el proyecto de simulación después de hacer una pregunta de seguridad.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DelSimulPrj


ID_DRV_STRAT_EV_PORT

Interne ID: ID_DRV_STRAT_EV_PORT

Puerto de eventos

Sólo disponible si hay un proyecto de simulación creado.

Puerto TCP/IP para el intercambio espontáneo de datos. El número de puerto tiene que ser unívoco, tiene que estar libre en el proyecto y disponible en el ordenador en el que funcione el servidor. Al crear un proyecto de simulación se le otorgará automáticamente un número de puerto unívoco.

Observación: El número de puerto otorgado automáticamente sólo es unívoco para el proyecto correspondiente. En proyectos multijerárquicos tiene que comprobarlo para evitar fallos de comunicación con el entorno de trabajo/runtime zenon Logic.

Mínimo: 6001 (con asignación automática, se recomienda: manual)

Máximo: 6998 (con asignación automática, se recomienda: manual)

Por defecto: 6001

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SimulEvPort


ID_DRV_STRAT_GRP

Interne ID: ID_DRV_STRAT_GRP

Proyecto de simulación del driver

Contiene todas las propiedades para la configuración de la Simulación - programada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Simulation


ID_DRV_STRAT_NAME

Interne ID: ID_DRV_STRAT_NAME

Nombre:

Nombre del proyecto de simulación. Si al iniciar el entorno de trabajo zenon Logic no existe ningún nombre válido, se le asignará uno automáticamente. Éste nombre estará compuesto por el nombre del driver y su descripción.

Condiciones para nombres válidos:

- no debe estar vacío

- debe ser unívoco en el proyecto

- sólo puede contener caracteres permitidos por zenon Logic; están prohibidos: /\:*?<>!|"

Mínimo: 1 caracter

Máximo: 15 caracteres.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SimulName


ID_DRV_STRAT_PORT

Interne ID: ID_DRV_STRAT_PORT

Puerto estándar

Sólo disponible si hay un proyecto de simulación creado.

Puerto TCP/IP para la comunicación con el entorno de trabajo zenon Logic.
Números de puerto permitidos:

  • Mínimo: 6000 (con asignación automática, se recomienda: manual)
  • Máximo: 6999 (con asignación automática, se recomienda: manual)

Por defecto: 6000

El número de puerto tienen que:

  • estar libre en el proyecto
  • ser único para todos los proyectos que funcionen durante el runtime
  • estar disponible en el ordenador en el que funcione el driver.

Al crear el proyecto de simulación se le otorgará automáticamente un número de puerto unívoco en el proyecto.

Observación: El número de puerto otorgado automáticamente sólo es unívoco para el proyecto correspondiente. En proyectos multijerárquicos tiene que comprobarlo para evitar fallos de comunicación con el entorno de trabajo/runtime zenon Logic.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SimulPort


ID_DYN_PROP_BLINKVAR

Interne ID: ID_DYN_PROP_BLINKVAR

Tomar el parpadeo de los valores límites

Variable cuyos valores determinan el parpadeo del elemento. Haciendo clic sobre el botón ... se abre el diálogo de selección para la variable.

A diferencia del parpadeo normal, parpadea todo el elemento y no sólo el valor representado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BlinkVariable


ID_DYN_PROP_BLINKVAR_PREVIEW

Interne ID: ID_DYN_PROP_BLINKVAR_PREVIEW

Mostrar vista previa del parpadeo

Muestra el valor límite definido en la variable para el parpadeo. Solo disponible si para la propiedad Tomar el parpadeo de los valores límites se ha configurado una variable.

Haciendo clic sobre el botón ... se abre un diálogo para mostrar los límites definidos. Los límites solo se mostrarán, no se pueden modificar. Las modificaciones deberán realizarse directamente en las propiedades de variables para Valores límites.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

BlinkVarPreview


ID_DYN_PROP_FILLCOLORVAR_PREVIEW

Interne ID: ID_DYN_PROP_FILLCOLORVAR_PREVIEW

Mostrar vista previa del color

Muestra el límite definido para la variable para el color de relleno. Solo disponible si para la propiedad Color de relleno se ha configurado una variable.

Haciendo clic sobre el botón ... se abre un diálogo para mostrar los límites definidos. Los límites solo se mostrarán, no se pueden modificar. Las modificaciones deberán realizarse directamente en las propiedades de variables para Valores límites.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

BackColorVarPreview


ID_DYN_PROP_GLOWEFFECT_BLINKVAR

Interne ID: ID_DYN_PROP_GLOWEFFECT_BLINKVAR

Variable para parpadeo

Variable cuyo límite o límites determinan el parpadeo para el efecto resplandor. Con un clic sobre el botón ... se abre el diálogo de selección de variables.

Por defecto: Ninguna variable vinculada

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GlowEffectBlinkVariable


ID_DYN_PROP_GLOWEFFECT_GLOWCOLOR_VARIABLE

Interne ID: ID_DYN_PROP_GLOWEFFECT_GLOWCOLOR_VARIABLE

Variable para color

Solo disponible si la propiedad Activar está activada. Lla propiedad Colorear tiene que estar activada.

Nombre de la variable cuyos colores de valor límite determinarán el color del resplandor. Con un clic sobre el botón ... se abre el diálogo de selección de variables. También se puede introducir el nombre manualmente en el campo de texto. Cuando no haya ninguna variable vinculada se utilizará el color definido en la propiedad Color .

Por defecto: Ninguna variable vinculada

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GlowEffectGlowColorVariable


ID_DYN_PROP_GLOWEFFECT_SICHTBARKEIT_AUSGRENZWERT

Interne ID: ID_DYN_PROP_GLOWEFFECT_SICHTBARKEIT_AUSGRENZWERT

Aplicar visibilidad del valor límite

Solo disponible si la propiedad Activar está activada. Además tiene que haber una variable definida en la propiedad Variable para visibilidad.

Activado: La visibilidad del efecto resplandor se determinará por las propiedades de los valores límite de la variable.

Atención: Por lo menos con un valor límite de estas variables tiene que estar activada la propiedad Oculto.

Desactivado: La visibilidad estará influenciada por las propiedades del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GlowEffectVisibilityFromLimit


ID_DYN_PROP_GLOWEFFECT_SICHTBARKEIT_BIS

Interne ID: ID_DYN_PROP_GLOWEFFECT_SICHTBARKEIT_BIS

Visible para

Solo disponible si la propiedad Activar está activada. Además tiene que haber una variable definida en la propiedad Variable para visibilidad y la propiedad Aplicar visibilidad del valor límite tiene que estar desactivada.

Define el valor hasta el que el efecto resplandor será visible.
Mínimo: valor mínimo posible de las variables vinculadas en Variable para visibilidad.
Máximo: valor máximo posible de las variables vinculadas en Variable para visibilidad.
Por defecto: valor máximo posible de la variable vinculada en Variable para visibilidad.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GlowEffectVisibilityTo


ID_DYN_PROP_GLOWEFFECT_SICHTBARKEIT_VARIABLE

Interne ID: ID_DYN_PROP_GLOWEFFECT_SICHTBARKEIT_VARIABLE

Variable para visibilidad

Solo disponible si la propiedad Activar está activada.

Nombre de las variables cuyo valor determina la visibilidad del efecto resplandor. La visibilidad se tomará o de las propiedades del valor límite de esta variable (propiedad Aplicar visibilidad del valor límite activada) o del rango de valor definido en las propiedades Visible desde y Visible para. Con un clic sobre el botón ... se abre el diálogo de selección de variables. También se puede introducir el nombre manualmente en el campo de texto.

Observación: Cuando no hay ninguna variable vinculada el efecto resplandor estará siempre visible.

Por defecto: Ninguna variable vinculada

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GlowEffectVisibilityVariable


ID_DYN_PROP_GLOWEFFECT_SICHTBARKEIT_VON

Interne ID: ID_DYN_PROP_GLOWEFFECT_SICHTBARKEIT_VON

Visible desde

Solo disponible si la propiedad Activar está activada. Además tiene que haber una variable definida en la propiedad Variable para visibilidad y la propiedad Aplicar visibilidad del valor límite tiene que estar desactivada.

Define el valor hasta el que el efecto resplandor será visible.
Mínimo: valor mínimo posible de las variables vinculadas en Variable para visibilidad.
Máximo: valor máximo posible de las variables vinculadas en
.Por defecto: valor mínimo posible de la variable vinculada en Variable para visibilidad.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GlowEffectVisibilityFrom


ID_DYN_PROP_GLOWEFFECT_USEBLINKCOLOR

Interne ID: ID_DYN_PROP_GLOWEFFECT_USEBLINKCOLOR

Tomar color de parpadeo del valor límite

Solo disponible si la propiedad Activar está activada. Además debe haber una variable definida en la propiedad Variable para parpadeo.

Activado: Toma el color para el efecto resplandor en el parpadeo del límite activo de las variables definidas en la propiedad Color parpadeante del límite. Esta propiedad es independiente de la propiedad Colorear. El efecto resplandor no cambia con el parpadeo a invisible sino al efector resplandor configurado como activo.

Por defecto: desactivado

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GlowEffectUseBlinkColor


ID_DYN_PROP_TEXTCOLORVAR_PREVIEW

Interne ID: ID_DYN_PROP_TEXTCOLORVAR_PREVIEW

Mostrar vista previa del color

Muestra el límite definido para la variable para el color del texto o líneas. Solo disponible si para la propiedad Color de texto/línea se ha configurado una variable.

Haciendo clic sobre el botón ... se abre un diálogo para mostrar los límites definidos. Los límites solo se mostrarán, no se pueden modificar. Las modificaciones deberán realizarse directamente en las propiedades de variables para Valores límites.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

LineColorVarPreview


ID_DYN_PROP_USEBLINKCOLOR

Interne ID: ID_DYN_PROP_USEBLINKCOLOR

Color parpadeante del límite

Activado: Aplica el color de fondo del parpadeo del límite activo de las variables para Tomar el parpadeo de los valores límites. El elemento no se vuelve invisible al parpadear sino que toma el color de fondo activo.

Por defecto: Desactivado

Observación: Este color no se considerará cuando el color de fondo Transparente esté configurado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UseBlinkColor


ID_DYN_PROP_VISVAR_PREVIEW

Interne ID: ID_DYN_PROP_VISVAR_PREVIEW

Mostrar vista previa de visibilidad

Muestra el límite definido para la variable para la visibilidad. Solo disponible si para la propiedad Variable en el grupo Visibilidad hay una variable configurada.

Haciendo clic sobre el botón ... se abre un diálogo para mostrar los límites definidos. Los límites solo se mostrarán, no se pueden modificar. Las modificaciones deberán realizarse directamente en las propiedades de variables para Valores límites.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

VisVarPreview


ID_DYNPICTURE_DONTRESIZEELEMS

Interne ID: ID_DYNPICTURE_DONTRESIZEELEMS

No adaptar elementos a la resolución de la pantalla

Activado: Los elementos contenidos en la pantalla no se ajustarán automáticamente durante el runtime a la resolución de la pantalla, sino que mantendrán la posición y el tamaño proyectados en el editor.

Por defecto:desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DontResizeElements


ID_DYNPICTURE_MOVEBYMOUSE

Interne ID: ID_DYNPICTURE_MOVEBYMOUSE

Desplazar marco con el ratón

Activado: La pantalla se puede mover con el ratón durante el runtime aunque no sea una pantalla global. Haciendo clic izquierdo del ratón en un área libre de la pantalla y moviendo el ratón pulsado se mueve toda la pantalla.

Observación: Si la pantalla está incrustada en un faceplate, se ignorará esta configuración. En este caso son las configuraciones del faceplate las que determinan el movimiento. Si se mueve un faceplate, se moverán también todas las pantallas que contenga.

Interacción: Las propiedades Desplazar marco con el ratón por un lado y las propiedades Desplazar horizontalmente y Desplazar verticalmente por otro lado no se pueden activar al mismo tiempo. Se puede activar, o bien el desplazamiento de un marco con el ratón, o bien el desplazamiento horizontal/vertical por manejo táctil.

Atención caso especial: En el siguiente caso se pueden establecer ambas propiedades y después permanecen inconfigurables.

  • Se activa la propiedad Desplazar horizontalmente o Desplazar verticalmente.
  • La propiedad de proyecto Evaluación para Interacción se establece en Windows 7 o Desactivado.
  • Se activa la propiedad Desplazar marco con el ratón.
  • La propiedad Evaluación se vuelve a establecer en Windows 8.

Solución:

  • Vuelva a establecer la propiedad Evaluación en Windows 7 o Desactivado.
  • Desactive la propiedad Desplazar marco con el ratón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MoveByMouse


ID_DYNPICTURE_MULTITOUCH

Interne ID: ID_DYNPICTURE_MULTITOUCH

Multitouch para hacer zoom y desplazarse

Activado: Para hacer zoom y desplazarse en la pantalla global se pueden emplear gestos multitouch sin tener que programarlos en VSTA. Cuando esta propiedad esté activada no se crearán eventos VBA/VSTA para gestos multitouch.

Solo disponible si se trata de una pantalla global (pantalla más grande que el marco y Aplicar tamaño de pantalla del marco no está activado) y para la propiedad Multitouch activado se haya seleccionado Windows 7.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MultiTouch


ID_DYNPICTURE_MULTITOUCH_GROUP

Interne ID: ID_DYNPICTURE_MULTITOUCH_GROUP

Interacción

Propiedades para configurar la interacción durante el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Interaction


ID_DYNPICTURE_MULTITOUCH_MOVE

Interne ID: ID_DYNPICTURE_MULTITOUCH_MOVE

Verschieben

Solo disponible cuando se haya desactivado la propiedad Aplicar tamaño de pantalla del marco y se haya configurado la propiedad de proyecto Evaluación para Windows 8.

Define la reacción al gesto Desplazar. Seleccionar de la lista desplegable:

  • Desplazar contenido: El contenido se puede desplazar horizontal o verticalmente. La dirección se definirá con las propiedades Horizontal verschieben y Vertikal verschieben.
  • Ninguna reacción

Por defecto: Desplazar contenido

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MultiTouchMove


ID_DYNPICTURE_MULTITOUCH_MOVE_HOR

Interne ID: ID_DYNPICTURE_MULTITOUCH_MOVE_HOR

Horizontal verschieben

Solo estará disponible cuando para la propiedad Verschieben se haya configurado Desplazar contenido.

Define si el contenido se puede desplazar horizontalmente. Seleccionar de la lista desplegable:

  • Desplazar horizontalmente: El contenido se puede desplazar horizontalmente
  • Ninguna reacción

Por defecto: Desplazar horizontalmente

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MultiTouchMoveHor


ID_DYNPICTURE_MULTITOUCH_MOVE_VER

Interne ID: ID_DYNPICTURE_MULTITOUCH_MOVE_VER

Vertikal verschieben

Solo estará disponible cuando para la propiedad Verschieben se haya configurado Desplazar contenido.

Define si el contenido se puede desplazar verticalmente. Seleccionar de la lista desplegable:

  • Desplazar verticalmente. El contenido se puede desplazar verticalmente
  • Ninguna reacción

Por defecto: Desplazar verticalmente

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MultiTouchMoveVer


ID_DYNPICTURE_MULTITOUCH_ZOOM

Interne ID: ID_DYNPICTURE_MULTITOUCH_ZOOM

Zoomen

Solo disponible cuando se haya desactivado la propiedad Aplicar tamaño de pantalla del marco y se haya configurado la propiedad de proyecto Evaluación para Windows 8.

Define la reacción al gesto Zoom. Seleccionar de la lista desplegable:

  • Hacer zoom en contenido
  • Ninguna reacción

Por defecto: Hacer zoom en contenido

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MultiTouchZoom


ID_DYNPICTURE_PROP1

Interne ID: ID_DYNPICTURE_PROP1

Nombre de archivo

Nombre del archivo de la pantalla.
El nombre del archivo se generará automáticamente por el sistema y no se podrá modificar.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_DYNPICTURE_PROP2

Interne ID: ID_DYNPICTURE_PROP2

Marco

Modificación del marco correspondiente sin que los elementos de pantalla se adapten al tamaño de la pantalla (se estiren o compriman).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Template


ID_DYNPICTURE_PROP3

Interne ID: ID_DYNPICTURE_PROP3

Tipo de pantalla

Estándar: Tipo de imagen para crear pantallas del proceso. Se pueden utilizar todos los elementos vectoriales y dinámicos.
Tipos de pantallas especiales: Las pantallas que no sean del tipo "estándar", hay que crearlas sólo una vez y se pueden abrir con distintos datos mediante filtros especiales de la función Cambio de pantalla. En el momento en que se elija un tipo de pantalla especial aparecerán en el menú Elementos de control para el manejo del tipo de pantalla correspondiente.

Atención: En el momento en que se cambia el tipo de pantalla de estándar a especial, queda fijado y no se puede volver a cambiar.

Por defecto: Estándar

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Type


ID_DYNPICTURE_PROP4

Interne ID: ID_DYNPICTURE_PROP4

Color de fondo

Define el color de fondo de la pantalla. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.
Por defecto: Color sacado de la plantilla.
Observación: El color tomado del marco se aplicará como copia y no estará vinculado. Las modificaciones posteriores del color del marco no tendrán ningún efecto sobre las pantallas existentes, solo sobre las de nueva creación.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackgroundColor


ID_DYNPICTURE_PROP5

Interne ID: ID_DYNPICTURE_PROP5

X desde

Coordenadas X del punto de esquina superior izquierdo de la pantalla (en unidades lógicas). Esta propiedad solo sirve de información y no es modificable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MinX


ID_DYNPICTURE_PROP6

Interne ID: ID_DYNPICTURE_PROP6

X hasta

Coordenadas X del punto de esquina inferior derecho de la pantalla (en unidades lógicas). Esta propiedad solo sirve de información y no es modificable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxX


ID_DYNPICTURE_PROP7

Interne ID: ID_DYNPICTURE_PROP7

Y desde

Coordenadas Y del punto de esquina superior izquierdo de la pantalla (en unidades lógicas). Esta propiedad solo sirve de información y no es modificable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MinY


ID_DYNPICTURE_PROP8

Interne ID: ID_DYNPICTURE_PROP8

Y hasta

Coordenadas Y del punto de esquina inferior derecho de la pantalla (en unidades lógicas). Esta propiedad solo sirve de información y no es modificable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxY


ID_DYNPICTURE_PROP9

Interne ID: ID_DYNPICTURE_PROP9

Altura [píxeles]

Solo disponible si la propiedad Aplicar tamaño de pantalla del marco está desactivada.
Altura de la pantalla en píxeles.

Observación: Los entradas de tamaño que sean menores que el marco se ignorarán. Si la pantalla se define más grande que el marco se convierte en Pantalla global. Para navegar y desplazarse por pantallas globales se puede utilizar una pantalla del tipo Vista general de pantalla global, el control táctil y el ratón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Height


ID_DYNPICTURE_PROP10

Interne ID: ID_DYNPICTURE_PROP10

Anchura [píxeles]

Solo disponible si la propiedad Aplicar tamaño de pantalla del marco está desactivada.
Anchura de la pantalla en píxeles.

Observación: Los entradas de tamaño que sean menores que el marco se ignorarán. Si la pantalla se define más grande que el marco se convierte en Pantalla global. Para navegar y desplazarse por pantallas globales se puede utilizar una pantalla del tipo Vista general de pantalla global, el control táctil y el ratón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Width


ID_DYNPICTURE_PROP11

Interne ID: ID_DYNPICTURE_PROP11

Función de inicio

Función que se ejecutará automáticamente al abrir la pantalla durante el runtime.
Abre el diálogo de selección de funciones.
Si se debe ejecutar más de una función se deberá crear un script con las funciones deseadas y vincular aquí la función para ejecutar el script.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StartFunction


ID_DYNPICTURE_PROP12

Interne ID: ID_DYNPICTURE_PROP12

Función de finalización

Función que se ejecutará automáticamente al cerrar la pantalla durante el runtime.
Abre el diálogo de selección de funciones.
Si se debe ejecutar más de una función se deberá crear un script con las funciones deseadas y vincular aquí la función para ejecutar el script.

ATENCIÓN: Al abrir otra pantalla con el mismo marco se cerrará automáticamente esa pantalla y se ejecutará la función vinculada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EndFunction


ID_DYNPICTURE_PROP13

Interne ID: ID_DYNPICTURE_PROP13

Aplicar tamaño de pantalla del marco

Activado: El tamaño y posición de la pantalla se definirán por el marco vinculado.
Desactivado: La anchura y altura de la pantalla se pueden definir más grandes que el marco. La posición de la esquina superior izquierda se definirá siempre por el marco.
Por defecto: activado.

Observación: Los entradas de tamaño que sean menores que el marco se ignorarán. Si la pantalla se define más grande que el marco se convierte en Pantalla global. Para navegar y desplazarse por pantallas globales se puede utilizar una pantalla del tipo Vista general de pantalla global, el control táctil y el ratón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SizeFromTemplate


ID_DYNPICTURE_PROP14

Interne ID: ID_DYNPICTURE_PROP14

Diálogo modal

Configuración para la representación como diálogo modal:

  • Activado: Mientras la pantalla esté abierta durante el runtime no se podrán manejar los elementos en otra pantalla. Las que sí se podrán manejar son las pantallas que se hayan abierto dentro la pantalla modal.
  • Desactivado: Las demás pantallas se podrán manejar como de costumbre.

Por defecto: Desactivado

Observación: Esta configuración se ignorará si se utiliza en un contenedor de faceplates.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Modal


ID_DYNPICTURE_PROP15

Interne ID: ID_DYNPICTURE_PROP15

Visible con CE

Activado: La pantalla se representará también con Windows CE.
Desactivado: La pantalla no se representará con Windows CE.
Por defecto: activado.

En redes con ordenadores y dispositivos CE se podrán utilizar de esta manera funcionalidades en el ordenador no soportadas por Windows CE sin que surjan problemas en los dispositivos CE.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowInCE


ID_DYNPICTURE_PROP16

Interne ID: ID_DYNPICTURE_PROP16

Archivo gráfico

Selección del gráfico de fondo que se mostrará en el nivel más alejado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackgroundPic


ID_DYNPICTURE_PROP17

Interne ID: ID_DYNPICTURE_PROP17

Alineación

Sólo disponible después seleccionar un Archivo gráfico.
Tipo de representación del gráfico de fondo en la pantalla:

  • normal: Tamaño original posicionado en la esquina superior izquierda.
  • centrado: Tamaño original centrado en la pantalla.
  • ampliado: Ampliado de forma que ocupe toda la pantalla.
  • en mosaico: Tamaño original en mosaicos uno al lado de otro.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackgroundPicStyle


ID_DYNPICTURE_PROP18

Interne ID: ID_DYNPICTURE_PROP18

Rahmen-Style

Solo disponible si se ha seleccionado un borde al definir el marco:
Tipo de borde de la pantalla.
Borde grueso: Se representará un borde grueso alrededor de la pantalla. Se puede modificar el tamaño de la pantalla en el runtime.
Borde fino: Se representará un borde fino alrededor de la pantalla.
Ningún borde: No se representará ningún borde alrededor de la pantalla.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BorderStyle


ID_DYNPICTURE_PROP19

Interne ID: ID_DYNPICTURE_PROP19

Titel anzeigen

Solo disponible si se ha seleccionado un borde para la pantalla::
Activado: Utilizar barra de título de Windows para esta pantalla. La pantalla se puede desplazar en el runtime.
Desactivado: No utilizar ninguna barra de título.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowTitle


ID_DYNPICTURE_PROP20

Interne ID: ID_DYNPICTURE_PROP20

Pantalla activa variable

La variable bit vinculada aquí se configurará en 1 cuando se abra la pantalla y se reseteará a 0 cuando se cierre la pantalla.
Abre el diálogo de selección filtrado para variables bit.

ATENCIÓN: Al abrir otra pantalla con el mismo marco se cerrará automáticamente esta pantalla y se ejecutará la función vinculada.

Ejemplo: El color de fondo de los botones en una barra de operaciones deberá mostrar la pantalla que esté abierta en ese momento. Las variables bit que estén vinculadas a las pantallas individuales tienen todas el color límite verde para el valor 1 y el color límite blanco para el valor 0. Estas variables bit se vincularán al color de fondo dinámico de los botones correspondientes. El botón que activa la pantalla abierta en ese momento tiene siempre el color de fondo verde y todos los demás son blancos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PicActivVar


ID_DYNPICTURE_PROP21

Interne ID: ID_DYNPICTURE_PROP21

Color de fondo

Define el color de fondo del símbolo en el editor de símbolos. Haga clic en el botón para abrir la gama de colores o introduzca los colores RGB como valores hexadecimales.

Atención: El color de fondo definido aquí solo sirve como color de fondo del editor de símbolos. No tendrá efecto en la representación en el editor ni en el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackgroundColor


ID_DYNPICTURE_PROP22

Interne ID: ID_DYNPICTURE_PROP22

Altura [píxeles]

Define la altura del símbolo en píxeles. La altura configurada sirve como altura original para el símbolo cuando lo arrastre a una pantalla.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Height


ID_DYNPICTURE_PROP23

Interne ID: ID_DYNPICTURE_PROP23

Anchura [píxeles]

Define la anchura del símbolo en píxeles. La anchura configurada sirve como anchura original para el símbolo cuando lo arrastre a una pantalla.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Width


ID_DYNPICTURE_PROP24

Interne ID: ID_DYNPICTURE_PROP24

Etiquetado automático

activado: Para las letras, números y teclas de función de una pantalla del tipo Teclado se aplicarán los textos originales de la distribución del teclado del sistema operativo. No se pueden definir otros textos. Aunque se hayan utilizado otros textos para las teclas, en el runtime se volverá a los textos originales. Las teclas de funciones como Tab o Shift pueden cambiar de texto.

desactivado: Todas las teclas se pueden inscribir individualmente y se mostrarán así en el runtime.

Por defecto: activado

Observación: A la tecla bloqueo de números del teclado no se le asignará automáticamente un texto, éste se podrá ajustar en cualquier momento durante el runtime con independencia de la configuración de esta propiedad.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AutoKBLayout


ID_DYNPICTURE_PROP_GRP0

Interne ID: ID_DYNPICTURE_PROP_GRP0

General

Propiedades generales de la pantalla.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Picture


ID_DYNPICTURE_PROP_GRP1

Interne ID: ID_DYNPICTURE_PROP_GRP1

Marco

Propiedades para el tamaño y posición de la pantalla que se tomarán del marco vinculado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Size


ID_DYNPICTURE_PROP_GRP2

Interne ID: ID_DYNPICTURE_PROP_GRP2

Representación

Propiedades para el aspecto exterior de la pantalla.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Representation


ID_DYNPICTURE_PROP_GRP3

Interne ID: ID_DYNPICTURE_PROP_GRP3

Ejecución

Funciones y variables vinculados con la pantalla.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Functions


ID_DYNPICTURE_PROP_GRP4

Interne ID: ID_DYNPICTURE_PROP_GRP4

Gráfico de fondo

En todas las pantallas se puede mostrar un archivo gráfico como fondo. Este gráfico estará posicionado en el nivel de visibilidad más alejado y estará tapado por todos los otros elementos de la pantalla. Para posicionar tiene a su disposición posibilidades como centrado o en mosaico. No es posible desplazarlo libremente.

También se puede utilizar un botón con un archivo gráfico sin función vinculada para representar un archivo gráfico libremente posicionable

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Background


ID_DYNPICTURE_PROP_GRP5

Interne ID: ID_DYNPICTURE_PROP_GRP5

General

Propiedades para el tamaño y color de fondo del editor de símbolos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Symbols


ID_DYNPICTURE_PROP_GRP6

Interne ID: ID_DYNPICTURE_PROP_GRP6

Color

Propiedades para la configuración del color de la pantalla.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

GRP_Color


ID_DYNPICTURE_SCHAB_HIGHLIGHT_ALPHA

Interne ID: ID_DYNPICTURE_SCHAB_HIGHLIGHT_ALPHA

Transparencia del entorno

Solo disponible si la propiedad Resaltar marco está activada.

Determina la transparencia de la Color del entorno del marco en el que se basa la pantalla. Haciendo clic sobre el botón ... se abre una regleta deslizante para definir la transparencia.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AmbientAlpha


ID_DYNPICTURE_SCHAB_HIGHLIGHT_COLOR

Interne ID: ID_DYNPICTURE_SCHAB_HIGHLIGHT_COLOR

Color del entorno

Solo disponible si la propiedad Resaltar marco está activada.

Determina el color del entorno del marco en el que se basa la pantalla. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar el color.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AmbientColor


ID_DYNPICTURE_SCHAB_HIGHLIGHT_TYPE

Interne ID: ID_DYNPICTURE_SCHAB_HIGHLIGHT_TYPE

Resaltar marco

Solo disponible si la propiedad Diálogo modal está activada.

  • Activado: Se resaltará el marco en el que se basa la pantalla. Toda el área fuera del marco se coloreará con un Color del entorno y Transparencia del entorno configurable. El área del marco resaltado no resultará afectado por ese color. Solo se puede abrir una pantalla al mismo tiempo con esta propiedad.

Observación: Esta configuración se ignorará si se utiliza en un contenedor de faceplates.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Highlight


ID_EDITSIGNATURE

Interne ID: ID_EDITSIGNATURE

Texto de firma editable

Activado: En el runtime se abrirá un diálogo para editar un texto de firma.

Desactivado: El texto de firma no se podrá modificar en el runtime.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EditSignature


ID_ELE_BITMAP_DOWN

Interne ID: ID_ELE_BITMAP_DOWN

Archivo gráfico al presionar

Imagen que se mostrará sobre el botón en estado presionado (*.bmp, *.wmf, *.jpg, *.gif). Haciendo clic sobre el botón ... se abre el diálogo de selección de archivos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FileNameDown


ID_ELE_CORNER_ALL_X

Interne ID: ID_ELE_CORNER_ALL_X

Todos X [%]

Sólo disponible si la propiedad Con valores de luminosidad no está activada.

Define el valor de redondeo del eje X en porcentaje para todos los puntos de esquina. Este valor se utilizará para todos los puntos de esquina que tengan un valor -1. Los puntos de esquina se pueden definir también individualmente.

Si se cambia el valor de redondeo, todos los puntos de esquina tomarán automáticamente el valor -1. De forma que todos los puntos de esquina se resetearán al valor indicado aquí.

Rango de valor: 0 % a 100 %.

Por defecto: 20

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CornerAll_X


ID_ELE_CORNER_ALL_Y

Interne ID: ID_ELE_CORNER_ALL_Y

Todos Y [%]

Sólo disponible si la propiedad Proporcional está activada y la propiedad Con valores de luminosidad no está activada.

Define el valor de redondeo del eje Y en porcentaje para todos los puntos de esquina. Este valor se utilizará para todos los puntos de esquina que tengan un valor -1. Los puntos de esquina se pueden definir también individualmente.

Si se cambia el valor de redondeo, todos los puntos de esquina tomarán automáticamente el valor -1. De forma que todos los puntos de esquina se resetearán al valor indicado aquí.

Rango de valor: 0 % a 100 %.

Por defecto: 20

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CornerAll_Y


ID_ELE_CORNER_LEFTBOTTOM_X

Interne ID: ID_ELE_CORNER_LEFTBOTTOM_X

Izquierda/Abajo X [%]

Sólo disponible si la propiedad Con valores de luminosidad no está activada y la propiedad de proyecto Calidad gráfica está activada.

Define el valor de redondeo del eje X para el punto de esquina inferior izquierdo. Haciendo clic sobre el botón ... se abre una regleta deslizante para configurar el redondeo. Valores posibles:

-1: Se utilizará la configuración de Todos X [%].

0 a 100: Redondeo en porcentaje.

Por defecto: -1

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CornerLeftBottom_X


ID_ELE_CORNER_LEFTBOTTOM_Y

Interne ID: ID_ELE_CORNER_LEFTBOTTOM_Y

Izquierda/Abajo Y [%]

Sólo disponible si la propiedad Proporcional está activada, la propiedad Con valores de luminosidad no está activada y la propiedad de proyecto Calidad gráfica está activada.

Define el valor de redondeo del eje Y para el punto de esquina inferior izquierdo. Haciendo clic sobre el botón ... se abre una regleta deslizante para configurar el redondeo. Valores posibles:

-1: Se utilizará la configuración de Todos Y [%].

0 a 100: Redondeo en porcentaje.

Por defecto: -1

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CornerLeftBottom_Y


ID_ELE_CORNER_LEFTTOP_X

Interne ID: ID_ELE_CORNER_LEFTTOP_X

Izquierda/Arriba X [%]

Sólo disponible si la propiedad Con valores de luminosidad no está activada y la propiedad de proyecto Calidad gráfica está activada.

Define el valor de redondeo del eje X para el punto de esquina superior izquierdo. Haciendo clic sobre el botón ... se abre una regleta deslizante para configurar el redondeo. Valores posibles:

-1: Se utilizará la configuración de Todos X [%].

0 a 100: Redondeo en porcentaje.

Por defecto: -1

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CornerLeftTop_X


ID_ELE_CORNER_LEFTTOP_Y

Interne ID: ID_ELE_CORNER_LEFTTOP_Y

Izquierda/Arriba Y [%]

Sólo disponible si la propiedad Proporcional está activada, la propiedad Con valores de luminosidad no está activada y la propiedad de proyecto Calidad gráfica está activada.

Define el valor de redondeo del eje Y para el punto de esquina superior izquierdo. Haciendo clic sobre el botón ... se abre una regleta deslizante para configurar el redondeo. Valores posibles:

-1: Se utilizará la configuración de Todos Y [%].

0 a 100: Redondeo en porcentaje.

Por defecto: -1

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CornerLeftTop_Y


ID_ELE_CORNER_PROPORTIONAL

Interne ID: ID_ELE_CORNER_PROPORTIONAL

Proporcional

Sólo disponible si la propiedad Con valores de luminosidad no está configurada.

Activado: Para el redondeo de las esquinas sólo se puede introducir el valor X. El valor Y es siempre igual.

El porcentaje introducido en Todos X [%] se refiere al lado más corto (ancho o alto) del elemento.

Desactivado: Los valores X e Y se pueden introducir libremente. El valor X se refiere a la anchura del elemento y el valor Y a la altura.

Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CornerProportional


ID_ELE_CORNER_RIGHTBOTTOM_X

Interne ID: ID_ELE_CORNER_RIGHTBOTTOM_X

Derecha/Abajo X [%]

Sólo disponible si la propiedad Con valores de luminosidad no está activada.

Define el valor de redondeo del eje X para el punto de esquina inferior derecho. Haciendo clic sobre el botón ... se abre una regleta deslizante para configurar el redondeo. Valores posibles:

-1: Se utilizará la configuración de Todos X [%].

0 a 100: Redondeo en porcentaje.

Por defecto: -1

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CornerRightBottom_X


ID_ELE_CORNER_RIGHTBOTTOM_Y

Interne ID: ID_ELE_CORNER_RIGHTBOTTOM_Y

Derecha/Abajo Y [%]

Sólo disponible si la propiedad Proporcional está activada, la propiedad Con valores de luminosidad no está activada y la propiedad de proyecto Calidad gráfica está activada.

Define el valor de redondeo del eje Y para el punto de esquina inferior derecho. Haciendo clic sobre el botón ... se abre una regleta deslizante para configurar el redondeo. Valores posibles:

-1: Se utilizará la configuración de Todos Y [%].

0 a 100: Redondeo en porcentaje.

Por defecto: -1

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CornerRightBottom_Y


ID_ELE_CORNER_RIGHTTOP_X

Interne ID: ID_ELE_CORNER_RIGHTTOP_X

Derecha/Arriba X [%]

Sólo disponible si la propiedad Con valores de luminosidad no está activada y la propiedad de proyecto Calidad gráfica está activada.

Define el valor de redondeo del eje X para el punto de esquina superior derecho. Haciendo clic sobre el botón ... se abre una regleta deslizante para configurar el redondeo. Valores posibles:

-1: Se utilizará la configuración de Todos X [%].

0 a 100: Redondeo en porcentaje.

Por defecto: -1

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CornerRightTop_X


ID_ELE_CORNER_RIGHTTOP_Y

Interne ID: ID_ELE_CORNER_RIGHTTOP_Y

Derecha/Arriba Y [%]

Sólo disponible si la propiedad Proporcional está activada, la propiedad Con valores de luminosidad no está activada y la propiedad de proyecto Calidad gráfica está activada.

Define el valor de redondeo del eje Y para el punto de esquina superior derecho. Haciendo clic sobre el botón ... se abre una regleta deslizante para configurar el redondeo. Valores posibles:

-1: Se utilizará la configuración de Todos Y [%].

0 a 100: Redondeo en porcentaje.

Por defecto: -1

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CornerRightTop_Y


ID_ELE_DRAGBEGIN

Interne ID: ID_ELE_DRAGBEGIN

DragBegin

Macro VBA que se ejecutará cuando comience el arrastre.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DragBegin


ID_ELE_DRAGDROP

Interne ID: ID_ELE_DRAGDROP

DragDrop

Macro VBA que se ejecutará cuando se suelte el botón del ratón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DragDrop


ID_ELE_DRAGOVER

Interne ID: ID_ELE_DRAGOVER

DragOver

Macro VBA que se ejecutará cuando se mueva el cursor sobre el elemento mientras el botón izquierdo esté pulsado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DragOver


ID_ELE_EMBEDDED_FONT

Interne ID: ID_ELE_EMBEDDED_FONT

Fuente

Selección de la fuente para la representación.

ATENCIÓN: Esta opción solo funciona con fuentes incrustadas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Font


ID_ELE_LAYER

Interne ID: ID_ELE_LAYER

Nivel de visibilidad

Seleccione de la lista desplegable uno de los 16 niveles de visibilidad (de 0 a 15). Con la barra de símbolos Niveles de visibilidad puede decidir qué niveles se muestran o se ocultan en el editor. Con ello se consigue poder proyectar también pantallas complejas con una visión general. Los niveles se pueden utilizar individualmente. Los niveles no influyen en la información de primer plano/fondo ni en la representación en el runtime.
Por defecto: 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Layer


ID_ELE_LIGHTNING

Interne ID: ID_ELE_LIGHTNING

Gradiente de color

Sólo disponible cuando Estampado de relleno se haya configurado como Gradiente de color.

Define el gradiente de color para elementos vectoriales.

lineal: gradiente uniforme
puntual: Gradiente de los márgenes al centro

puntual con rayos: Gradiente de los márgenes al centro formando rayos

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Lightning


ID_ELE_LINECOLOR

Interne ID: ID_ELE_LINECOLOR

Color de línea

Define el color de las líneas del elemento. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LineColorEx


ID_ELE_NUM_BASE_ON

Interne ID: ID_ELE_NUM_BASE_ON

Mostrar base numérica

Sólo disponible cuando haya seleccionado binario, hexadecimal u octal en la propiedad Base numérica para visualización.

Muestra detrás del valor una descripción breve para la base numérica:

Se mostrarán las descripciones breves siguientes:

- Para binario: b

- Para decimal: ninguna descripción breve

- Para exponencial decimal: ninguna descripción breve

- Para hexadecimal: h

- Para octal: o

Por defecto: Activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowValueBasis


ID_ELE_PROP0

Interne ID: ID_ELE_PROP0

Nombre del elemento

Asigne un nombre de elemento.
No puede estar vacío.

Observación: Asigne un nombre único para el Contenedor de pantallas para garantizar una selección clara al configurar el cambio de pantalla.
Atención: Esta propiedad no está disponible para el cambio de idioma.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_ELE_PROP1

Interne ID: ID_ELE_PROP1

Colocar foco en el elemento

Activado: El elemento dinámico se puede manejar con el teclado.
Desactivado: El elemento dinámico no se puede manejar con el teclado.
Por defecto: activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Tab


ID_ELE_PROP2

Interne ID: ID_ELE_PROP2

Visible con WinCE

Controla la visibilidad de los elementos y pantallas en Windows CE. Los proyectos de CE utilizados en un PC se pueden configurar con mayor flexibilidad, con lo cual se consigue una mejor manejabilidad para el usuario. Se pueden, por ejemplo, ocultar botones que lleven a pantallas que no se puedan representar con CE (p. ej. IPA).

Activado: La pantalla/elemento se representará también con Windows CE.

Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UnderCE


ID_ELE_PROP5

Interne ID: ID_ELE_PROP5

Tipo

ComboBox: Este elemento se utilizará como ComboBox.
ListBox: Este elemento se utilizará como ListBox.
Por defecto: ListBox.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ControlType


ID_ELE_PROP10

Interne ID: ID_ELE_PROP10

Punto inicial X [píxeles]

Coordenadas X del punto de esquina superior izquierdo del elemento (en píxeles).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StartX


ID_ELE_PROP11

Interne ID: ID_ELE_PROP11

Punto inicial Y [píxeles]

Coordenadas Y del punto de esquina superior izquierdo del elemento (en píxeles).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StartY


ID_ELE_PROP12

Interne ID: ID_ELE_PROP12

Punto final X [píxeles]

Coordenadas X del punto de esquina inferior derecho del elemento (en píxeles).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EndX


ID_ELE_PROP13

Interne ID: ID_ELE_PROP13

Punto final Y [píxeles]

Coordenadas Y del punto de esquina inferior derecho del elemento (en píxeles).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EndY


ID_ELE_PROP14

Interne ID: ID_ELE_PROP14

Anchura [píxeles]

Anchura del elemento (en píxeles).

Observación: Solo disponible en los elementos multibin, combi, botón e interruptor cuando para la propiedad Tamaño del gráfico se haya seleccionado Ajustado como valor.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Width


ID_ELE_PROP15

Interne ID: ID_ELE_PROP15

Altura [píxeles]

Altura del elemento (en píxeles).

Observación: Solo disponible en los elementos multibin, combi, botón e interruptor cuando para la propiedad Tamaño del gráfico se haya seleccionado Ajustado como valor.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Height


ID_ELE_PROP16

Interne ID: ID_ELE_PROP16

Nombre para lista de objetos

El elemento se inscribirá en la lista de la estación de la pantalla global con el texto que se introduzca aquí.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Stationname


ID_ELE_PROP17

Interne ID: ID_ELE_PROP17

Visible desde

Nivel más bajo de zoom en el que el elemento sea visible en pantalla global.
Por defecto: -1
Tenga en cuenta que visible significa que en los niveles de zoom de -1 hasta -1 el elemento se mostrará en todos los niveles de zoom.

Los niveles de zoom que se mostrarán en la pantalla global se proyectan con la propiedad del proyecto Diseño gráfico -> Runtime general -> Niveles de zoom para vista global.

Atención: Este nivel de zoom afectará a todos los tipos de pantalla y marcos. Si se define un nivel de zoom mayor de 0 el elemento solo se mostrará en la pantalla global, ya que los otros tipos de pantalla se activarán automáticamente con el nivel de zoom 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ZoomMin


ID_ELE_PROP18

Interne ID: ID_ELE_PROP18

Visible para

Nivel más alto de zoom en el que el elemento sea visible en la pantalla global.

Por defecto: -1
Tenga en cuenta que visible significa que en los niveles de zoom de -1 hasta -1 el elemento se mostrará en todos los niveles de zoom.

Los niveles de zoom que se mostrarán en la pantalla global se proyectan con la propiedad del proyecto Diseño gráfico -> Runtime general -> Niveles de zoom para vista global.

Atención: Este nivel de zoom afectará a todos los tipos de pantalla y marcos. Si se define un nivel de zoom mayor de 0 el elemento solo se mostrará en la pantalla global, ya que los otros tipos de pantalla se activarán automáticamente con el nivel de zoom 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ZoomMax


ID_ELE_PROP19

Interne ID: ID_ELE_PROP19

Fuente

Selección de la fuente para la representación.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Font


ID_ELE_PROP20

Interne ID: ID_ELE_PROP20

Init

Macro VBA que se ejecutará al iniciar el elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Init


ID_ELE_PROP21

Interne ID: ID_ELE_PROP21

LeftClickUp

Macro VBA que se ejecutará en el elemento al soltar el botón izquierdo del ratón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LeftClickUp


ID_ELE_PROP22

Interne ID: ID_ELE_PROP22

LeftClickDown

Macro VBA que se ejecutará en el elemento al pulsar el botón izquierdo del ratón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LeftClickDown


ID_ELE_PROP23

Interne ID: ID_ELE_PROP23

LeftDoubleClick

Macro VBA que se ejecutará en el elemento al hacer doble clic sobre el botón izquierdo del ratón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LeftDClick


ID_ELE_PROP24

Interne ID: ID_ELE_PROP24

RightClickUp

Macro VBA que se ejecutará en el elemento al soltar el botón derecho del ratón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RightClickUp


ID_ELE_PROP25

Interne ID: ID_ELE_PROP25

RightClickDown

Macro VBA que se ejecutará en el elemento al pulsar el botón derecho del ratón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RightClickDown


ID_ELE_PROP26

Interne ID: ID_ELE_PROP26

RightDoubleClick

Macro VBA que se ejecutará en el elemento al hacer doble clic sobre el botón derecho del ratón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RightDClick


ID_ELE_PROP27

Interne ID: ID_ELE_PROP27

SetFocus

Macro VBA que se ejecutará cuando el foco se coloque sobre el elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SetFocus


ID_ELE_PROP28

Interne ID: ID_ELE_PROP28

KillFocus

Macro VBA que se ejecutará cuando el elemento pierda el foco.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

KillFocus


ID_ELE_PROP29

Interne ID: ID_ELE_PROP29

Draw

Macro VBA que se ejecutará cuando se dibuje de nuevo el elemento en la pantalla.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Draw


ID_ELE_PROP30

Interne ID: ID_ELE_PROP30

Menú contextual

Menú contextual para el elemento.
Con un clic derecho sobre el elemento se abre el menú contextual en el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Menu


ID_ELE_PROP31

Interne ID: ID_ELE_PROP31

Herramientas

Texto que se mostrará en el runtime como tooltip para el elemento. Se mostrará automáticamente un tooltip en el runtime cuando el puntero del ratón esté quieto un rato sobre el elemento. Se pueden insertar saltos de línea con \n.

  • Máximo: 79 caracteres
    Atención: La combinación de caracteres \n se cuenta dentro del límite de 79 caracteres.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Tooltip


ID_ELE_PROP32

Interne ID: ID_ELE_PROP32

Archivo de ayuda

Archivo de ayuda (*.chm) que se debe utilizar para este elemento junto con un menú contextual. Haciendo clic sobre ... se abre un diálogo para seleccionar un archivo.
Atención: Solo estarán disponibles los archivos de ayuda que se hayan añadido en el nodo "Archivos/Ayuda".

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Helpfile


ID_ELE_PROP33

Interne ID: ID_ELE_PROP33

Capítulo de ayuda

Capítulo de ayuda que se debe utilizar para este elemento junto con un menú contextual. Nombre de la página HTML en la que se basa.
Atención: Esta entrada distingue las mayúsculas/minúsculas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HelpCapture


ID_ELE_PROP34

Interne ID: ID_ELE_PROP34

MouseOver

Macro VBA que se ejecutará cuando el cursor se mueva sobre el elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MouseOver


ID_ELE_PROP35

Interne ID: ID_ELE_PROP35

Activar valor predeterminado

Activado: Está permitido establecer valores predeterminados para el elemento dinámico correspondiente.
Desactivado: En este elemento la variable está protegida contra escritura.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsSetValue


ID_ELE_PROP36

Interne ID: ID_ELE_PROP36

Cambiar de valor predeterminado

Valor que se debe escribir como predeterminado o proponer por defecto.
Cuando "proponer valor actual" esté activado: Valor que se añadirá al valor actual.
En combinación con la propiedad "Sin diálogo" se puede implementar un interruptor de incremento (valor positivo) o decremento (valor negativo).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SetValue


ID_ELE_PROP37

Interne ID: ID_ELE_PROP37

Texto de valor predeterminado

Texto del valor predeterminado

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SetValueText


ID_ELE_PROP38

Interne ID: ID_ELE_PROP38

Pantalla

Pantalla vinculada que se representará en el contenedor de pantallas. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar una pantalla.

Tipos de pantallas permitidos: AML, filtro AML, modelo de equipo, CEL, filtro CEL, ETM, HTML, Report Generator, Report Viewer, estándar, filtro de tiempo

Más en la Ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PictureContainerPictureName


ID_ELE_PROP39

Interne ID: ID_ELE_PROP39

Mínimo

Solo disponible si "Aplicar límites predeterminados de variable" no está activado:
Límite inferior del rango permitido para el valor predeterminado.

ATENCIÓN: El valor introducido aquí se ignorará cuando se seleccione una variable para establecer el valor mínimo predeterminado dinámico.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Min


ID_ELE_PROP40

Interne ID: ID_ELE_PROP40

Máximo

Solo disponible si "Aplicar límites predeterminados de variable" no está activado:
Límite superior del rango permitido para el valor predeterminado.

ATENCIÓN: El valor introducido aquí se ignorará cuando se seleccione una variable para establecer el valor máximo predeterminado dinámico.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Max


ID_ELE_PROP41

Interne ID: ID_ELE_PROP41

Sin diálogo

Activado: El valor introducido se escribirá como valor predeterminado sin posibilidad de modificaciones en el runtime.
Desactivado: Antes de que se escriba en el hardware el usuario tiene la posibilidad de modificar el valor en el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HWDirect


ID_ELE_PROP42

Interne ID: ID_ELE_PROP42

Proponer valor actual

Activado: El valor actual de las variables del proceso se propondrá al establecer el valor predeterminado.
En este caso antes de escribirlo se añadirá el valor en "Valor predeterminado / Cambiar en" al valor actual (valor positivo) o se le restará (valor negativo).
Desactivado: Se propondrá el valor definido en "Valor predeterminado / Cambiar en".

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Preset


ID_ELE_PROP43

Interne ID: ID_ELE_PROP43

Aplicar límite del valor predeterminado de la variable

Activado: La limitación del rango en el que pueden escribirse los valores predeterminados, no está definida con un “mínimo” y un “máximo” sino que se tomará de la definición de la variable.
Desactivado: La limitación del rango se puede definir directamente con un "mínimo" y un "máximo".

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LimitFromVar


ID_ELE_PROP44

Interne ID: ID_ELE_PROP44

Escribir valor predeterminado con

Establecer valor predeterminado con:
Comando: El valor nuevo se establecerá con la acción Establecer valor predeterminado en el Comando.

Máscara de entrada: El valor nuevo se introducirá en la máscara de entrada estándar. Si existe una pantalla del tipo "Teclado" con el nombre "SETVALUEKBD" (para variables numéricas) o "SETSTRINGKBD" (para variables cadena), se utilizará esta pantalla en lugar de la máscara de entrada estándar.

Elemento: El valor nuevo se introducirá directamente en el elemento (solo para los elementos valor numérico y elemento de texto).

Programa: El valor nuevo se introducirá en un programa externo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SetValueWith


ID_ELE_PROP45

Interne ID: ID_ELE_PROP45

Mostrar vista previa en el editor

Activado: En el editor se mostrará una vista previa de la pantalla vinculada.
En caso de problemas de rendimiento se recomienda su desactivación.

Estándar: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowPreviewInEditor


ID_ELE_PROP46

Interne ID: ID_ELE_PROP46

Nivel de autorización

Nivel de contraseña para establecer valores predeterminados o para ejecutar funciones con el elemento dinámico seleccionado.
Mínimo: 0
Máximo: 127.
Por defecto: 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Passwordlevel


ID_ELE_PROP47

Interne ID: ID_ELE_PROP47

Firma necesaria

Activado: El manejo del elemento requiere una firma.

También a los usuarios ya registrados se les pedirá aquí otra vez la contraseña por razones de seguridad. El texto de la firma se protocolizará cuando se haya usado correctamente en la Lista cronológica de eventos (CEL).

Atención: Sólo los usuarios registrados pueden firmar una acción. No se puede usar un login temporal para las acciones que requieren ser firmadas.

Desactivado: No se requiere ninguna firma.

Por defecto: desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Signature


ID_ELE_PROP48

Interne ID: ID_ELE_PROP48

Texto de firma

Este texto se protocolizará junto con la firma en la Lista cronológica de eventos (CEL) o se propondrá en el runtime por defecto cuando la firma esté definida como editable en las propiedades del proyecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SignatureText


ID_ELE_PROP49

Interne ID: ID_ELE_PROP49

Programa externo

Solo disponible si se ha seleccionado un programa externo para establecer el valor predeterminado:
El valor predeterminado se establecerá con un programa externo que se seleccionará en la caja de diálogo abierta aquí.

Dicho programa se iniciará y tendrá los siguientes parámetros:
1) nombre de la variable vinculada
2) valor propuesto según su definición en las propiedades correspondientes
3) coordenada izquierda del elemento en píxeles
4) coordenada superior del elemento en píxeles
5) coordenada derecha del elemento en píxeles
6) coordenada inferior del elemento en píxeles
7) mínimo permitido para el valor predeterminado según su definición en las propiedades correspondientes
8) máximo permitido para el valor predeterminado según su definición en las propiedades correspondientes

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SetProgram


ID_ELE_PROP50

Interne ID: ID_ELE_PROP50

Texto de firma editable

Define si el texto de firma puede puede ser editado. Seleccionar de la lista desplegable:

  • Aplicar configuraciones de proyecto: Se aplicarán las configuraciones de la propiedad de proyecto Texto de firma editable.
  • Sí: El texto puede ser editado.
  • No: El texto no puede ser editado.

Por defecto: Aplicar configuraciones de proyecto

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SignatureEditModus


ID_ELE_PROP51

Interne ID: ID_ELE_PROP51

Mostrar texto del valor límite

Activado: El texto de estado/valor límite de la variable asignada se mostrará en el elemento.
Desactivado: No se mostrará ningún texto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ContitionText


ID_ELE_PROP52

Interne ID: ID_ELE_PROP52

Colorear sólo área de relleno

Activado: Los círculos, polígonos, rectángulos que estén asignados al símbolo vinculado solo modificarán su color de relleno después de la definición del color de la variable. El color del contorno se mantiene.
Desactivado: También se coloreará el contorno según corresponda.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FillArea


ID_ELE_PROP58

Interne ID: ID_ELE_PROP58

Función

Nombre de la función vinculada.
Abre el diálogo de selección de funciones.
Esta función se ejecutará cuando se haga clic con el ratón sobre el botón en el runtime o cuando se pulse la combinación de teclas vinculada.
Si se debe ejecutar más de una función se deberá crear un script con las funciones deseadas y vincular aquí la función para ejecutar el script.

Sólo SICAM 230 y el elemento Alarma de pantalla:

Además de la propiedad estándar Cambio de pantalla mediante la función vinculada se localizará la pantalla, cuyos estados de alarma se deban mostrar.
¡Obligatorio (excepto con la configuración Global activada)!

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Function


ID_ELE_PROP59

Interne ID: ID_ELE_PROP59

Variable

Nombre de la variable vinculada Haciendo clic sobre el botón ... se abre el diálogo de selección de variables.
El valor de esta variable se mostrará en este elemento y se puede configurar también aquí.

Observación: Solo disponible para botones que se utilicen como Interruptor.

Consejo: Cuando se quiera bascular el valor de la variable le recomendamos activar la propiedad Lectura continua de variable. En otro caso el runtime espera hasta que el driver conozca el valor de la variable. Si el valor no está disponible a causa de una pérdida de la comunicación con el control el tiempo de espera corresponderá al tiempo de espera del driver.

Solo SICAM 230 y el elemento alarma de pantallas:
La descripción anterior sólo afecta a los elementos Botón de texto, Botón bitmap y Botón invisible.
Significado en SICAM 230: En la variable seleccionada (32 bit) se representarán los estados de las clases de alarmas/eventos. Por cada clase se escribirán 2 bits (orden ascendente de número de clase).

  • Bit inferior: Alarma activada/desactivada
  • Bit superior: Alarma reconocida/no reconocida

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variable


ID_ELE_PROP60

Interne ID: ID_ELE_PROP60

Interruptor

Solo disponible si la propiedad Activar valor predeterminado no está activada.

Activado: El elemento cambia el valor de una variable bit.
Desactivado: El elemento ejecuta una función.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Switch


ID_ELE_PROP61

Interne ID: ID_ELE_PROP61

Pulsador

Sólo disponible si Interruptor está activado. (Excepción: En el Elemento dinámico Interruptor está siempre disponible.)
Activado: El estado predeterminado - definido en la propiedad Pulsador ON - sólo será efectivo mientras esté pulsado el botón izquierdo con un mínimo de duración de Tiempo de parada [ms].
Desactivado: El estado predeterminado se mantendrá aunque se suelte el ratón.
Por defecto:desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Scanner


ID_ELE_PROP62

Interne ID: ID_ELE_PROP62

Pulsador ON

Sólo disponible si Pulsador está activado:
Activado: El pulsador se pone en ON.
Desactivado: El pulsador se pone en OFF.
Por defecto: desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ScannerOn


ID_ELE_PROP63

Interne ID: ID_ELE_PROP63

Reacción inmediata

Sólo disponible si Interruptor está activado:
Activado: El interruptor cambia inmediatamente su posición en el runtime, independientemente de que el bit vinculado se haya configurado o no en el control. En el próximo ciclo de actualización del driver se leerá el bit desde el control. El interruptor se volverá a adaptar a la posición concreta del bit en el control.
Atención: El interruptor volverá a ser manejable de forma visible cuando se haya leído el valor desde el control.

Desactivado: El interruptor no cambiará su posición hasta que se haya escrito el bit en el PLC y se haya vuelto a leer.

Por defecto: desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FastReaction


ID_ELE_PROP64

Interne ID: ID_ELE_PROP64

Tiempo de parada [ms]

Sólo disponible si Interruptor está activado:
Si Pulsador está activado: Tiempo (en ms) que se retiene un estado partiendo del clic izquierdo sobre el elemento correspondiente.

Si Pulsador está desactivado: Retraso de la reacción con clic izquierdo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ReactionTime


ID_ELE_PROP65

Interne ID: ID_ELE_PROP65

Combinación de teclas:

Las combinaciones de teclas son compatibles con la ejecución de elementos de pantalla editables. Por ejemplo:

- ejecutar elementos de control y funciones asignadas a un elemento
- Escribir valor predeterminado (p. ej. con un interruptor)
- Establecer foco en ventanas determinadas (p. ej. lista de curvas en la tendencia ampliada o en las combobox en el RGM)

Haciendo clic sobre el campo se abre un diálogo para definir la combinación de teclas. En el diálogo se introducirá directamente la combinación deseada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShortCut


ID_ELE_PROP66

Interne ID: ID_ELE_PROP66

Archivo gráfico

Gráfico que se mostrará sobre el botón cuando no esté pulsado (*.bmp, *.wmf, *.jpg, *.gif, *.png). Haciendo clic sobre el botón ... se abre el diálogo de selección de archivos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FileName


ID_ELE_PROP67

Interne ID: ID_ELE_PROP67

Archivo gráfico para off (0)

Bitmap predefinido o personalizado para el estado-LOW del interruptor.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BitmapLow


ID_ELE_PROP68

Interne ID: ID_ELE_PROP68

Archivo gráfico para on (1)

Bitmap predefinido o personalizado para el estado-HIGH del interruptor.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BitmapHigh


ID_ELE_PROP69

Interne ID: ID_ELE_PROP69

Desde cero

Solo afecta a la representación de valores con prefijos:
Activado: La barra llega desde cero hasta el valor actual de la variable vinculada.
Desactivado: La barra llega desde el valor menor mostrado hasta el valor actual de la variable vinculada.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FromZero


ID_ELE_PROP70

Interne ID: ID_ELE_PROP70

Tipo de visualización

Hora absoluta: Se mostrará la hora del reloj del sistema con el formato correspondiente.
Lapso de tiempo: Se mostrará el valor de una variable vinculada en el formato de horario configurado. Por defecto Hora absoluta.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ViewType


ID_ELE_PROP71

Interne ID: ID_ELE_PROP71

Formateo

Formato de visualización de la hora/fecha.
Se seleccionará una cadena de formato de la lista.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Format


ID_ELE_PROP72

Interne ID: ID_ELE_PROP72

Visualización a dos líneas

Solo disponible con la hora absoluta:
Activado: Si aparecen la hora y la fecha a la vez se mostrará la hora en la primera fila y la fecha en la segunda.
Desactivado: La fecha y la hora se mostrarán en una misma fila.
Por defecto: activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TwoLines


ID_ELE_PROP73

Interne ID: ID_ELE_PROP73

Separador

Solo disponible con lapso de tiempo:
Carácter separador para la visualización de la hora/fecha.
(p. ej. : en 10:15)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Separator


ID_ELE_PROP75

Interne ID: ID_ELE_PROP75

Símbolo:

Se puede elegir un símbolo de la lista de símbolos existentes en la pantalla.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Symbol


ID_ELE_PROP76

Interne ID: ID_ELE_PROP76

Texto

Solo disponible si se ha vinculado una variable numérica y para la propiedad Texto para mostrar se ha seleccionado Texto del valor límite.

Entrada del texto que se mostrará durante el runtime cuando no se viole ningún límite. Si se viola algún límite se mostrará el texto del valor límite configurado en la variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DynText


ID_ELE_PROP77

Interne ID: ID_ELE_PROP77

Tipo de línea

Selección del tipo de línea para el elemento de la lista.
Atención: Si en las propiedades de proyecto en el nodo Diseño gráfico se ha desactivado la propiedad Calidad gráfica, solo se podrá utilizar el ancho de línea >1 con una línea del tipo "línea continua".
Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LineType


ID_ELE_PROP78

Interne ID: ID_ELE_PROP78

Estampado de relleno

Selección del tipo de relleno para el elemento de la lista.

Esta propiedad solo estará disponible cuando la propiedad Con valores de luminosidad esté desactivada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FillPattern


ID_ELE_PROP79

Interne ID: ID_ELE_PROP79

Función específica de pantalla

Solo disponible en pantallas con un tipo de pantalla especial (Tipo de pantalla no estándar):
Vínculo con una función específica del tipo de pantalla. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar una función específica para este tipo de pantalla. Esta función se ejecutará cuando se haga clic con el ratón sobre el botón durante el runtime o se pulse la combinación de teclas vinculada.

Atención: Además de la función específica para el tipo de pantalla se puede vincular al botón una función general. En ese caso tenga en cuenta el orden de ejecución al pulsar el botón: Primero se ejecutará la función específica del tipo de pantalla. Una vez que ésta haya finalizado se ejecutará la función general. Si durante el runtime hay eventos VBA vinculados al botón, dichos eventos se ejecutarán antes de las funciones.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MDIFunction


ID_ELE_PROP80

Interne ID: ID_ELE_PROP80

Etiqueta

Rótulo del elemento en el editor.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Legend


ID_ELE_PROP81

Interne ID: ID_ELE_PROP81

Estilo L

Estilo Windows del elemento solo para uso interno.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StyleL


ID_ELE_PROP82

Interne ID: ID_ELE_PROP82

Estilo H

Estilo Windows del elemento solo para uso interno.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StyleH


ID_ELE_PROP83

Interne ID: ID_ELE_PROP83

Horizontal

Punto de referencia horizontal del elemento. Valores posibles: izquierda, centrado, derecha.
Este punto se tomará como punto de partida para el cálculo del ángulo de inicio para la rotación (estática y dinámica) así como para el cambio de tamaño dinámico.

Por defecto: Izquierda

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HorizontalOrigin


ID_ELE_PROP84

Interne ID: ID_ELE_PROP84

Vertical

Punto de referencia vertical del elemento. Valores posibles: arriba, centrado, abajo.
Este punto se tomará como punto de partida para el cálculo del ángulo de inicio para la rotación (estática y dinámica) así como para el cambio de tamaño dinámico.

Por defecto: Arriba

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VerticalOrigin


ID_ELE_PROP85

Interne ID: ID_ELE_PROP85

Número de símbolo de pantalla

Número único del símbolo o grupo de elementos.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PropSymbolNumber


ID_ELE_PROP86

Interne ID: ID_ELE_PROP86

Nombre del símbolo

Nombre del símbolo.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LinkName


ID_ELE_PROP91

Interne ID: ID_ELE_PROP91

Mínimo

Valor menor de la variable que se representará en el elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ViewMin


ID_ELE_PROP92

Interne ID: ID_ELE_PROP92

Máximo

Valor mayor de la variable que se representará en el elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ViewMax


ID_ELE_PROP93

Interne ID: ID_ELE_PROP93

Importe absoluto

Para el elemento Valor numérico sólo disponible si Mostrar valor en porcentaje está desactivado.

Activado: Muestra el valor de la variable sin prefijos (-200 = 200).
Desactivado: Representación normal del valor.
Por defecto: desactivado.

Observación: La entrada del valor predeterminado en este es caso en porcentaje.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Absolute


ID_ELE_PROP97

Interne ID: ID_ELE_PROP97

Siempre

Activado: La animación se ejecuta siempre.
Desactivado: La animación no se ejecuta. Opcionalmente se puede encender y apagar la animación con una Variable vinculada.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Animate


ID_ELE_PROP98

Interne ID: ID_ELE_PROP98

Variable

Variable bit que enciende y apaga la animación.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AnimateVar


ID_ELE_PROP99

Interne ID: ID_ELE_PROP99

Categoría

Concepto para la categorización. También se puede filtrar o agrupar según esta propiedad.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Category


ID_ELE_PROP100

Interne ID: ID_ELE_PROP100

Descripción

Descripción más detallada del símbolo o grupo de elementos. También se puede filtrar según esta propiedad.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Description


ID_ELE_PROP101

Interne ID: ID_ELE_PROP101

Color de texto

Color de texto del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextColor


ID_ELE_PROP102

Interne ID: ID_ELE_PROP102

Color de relleno

Sólo disponible si se ha desactivado la propiedad Transparente.

Define el color de relleno del elemento. Haciendo clic sobre el botón se abre la gama de los colores predefinidos. O introduzca el nombre del color manualmente como código hexadecimal (RGB) en el campo de entrada. El color de relleno se puede modificar dinámicamente con la propiedad Color de relleno del grupo Colores dinámicos.

Observación: Como color para los elementos nuevos creados se tomará el mismo que se haya utilizado por última vez para ese tipo de elemento.

Atención: En la ventana de vista general de la Pantalla global los cambios de color en el editor no tendrán efecto durante el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColor


ID_ELE_PROP103

Interne ID: ID_ELE_PROP103

Color de barra

Color para las barras del gráfico de barras. El color configurado se utilizará cuando no se viole ningún límite de la variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextColor


ID_ELE_PROP104

Interne ID: ID_ELE_PROP104

Transparente

Activado: Desactiva el color de fondo del elemento.

Con un botón esta opción lo convierte en Botón invisible. Como botón invisible se puede colocar sobre otros elementos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Transparent


ID_ELE_PROP108

Interne ID: ID_ELE_PROP108

Füllfarbe

Color de relleno/fondo del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColor


ID_ELE_PROP109

Interne ID: ID_ELE_PROP109

Grupo de símbolos

Define la pertenencia del símbolo a un grupo. Este valor no se puede modificar. Los símbolos de la Galería de símbolos en el proyecto global o en el proyecto local tomarán el valor Proyecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Group


ID_ELE_PROP111

Interne ID: ID_ELE_PROP111

Texto fila 1

Primera línea en el botón.
Con el carácter & se representará subrayado el próximo carácter en el runtime. Para representar el caracter & por sí mismo hay que introducir ”&&”.

Con los caracteres \n se produce un salto de línea.

Atención: Para utilizar \n la propiedad Texto fila 2 tiene que estar vacía.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Text1


ID_ELE_PROP112

Interne ID: ID_ELE_PROP112

Texto fila 2

Segunda línea en el botón.
Con el carácter & se representará subrayado el próximo carácter en el runtime. Para representar el caracter & por sí mismo hay que introducir ”&&”.

Observación: Esta propiedad sirve para la compatibilidad con versiones antiguas. En versiones actuales: Utilizar la propiedad Texto fila 1 y comenzar las líneas nuevas con \n.

Atención: Esta línea tiene que estar vacía cuando se quiera utilizar el salto de línea automático.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Text2


ID_ELE_PROP113

Interne ID: ID_ELE_PROP113

Salto de línea automático

Activado: Para el texto en el elemento se realizará el ajuste automático de línea.
El largo de las líneas depende del ancho del elemento.
Desactivado: El texto se mostrará en una línea.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Wordbreak


ID_ELE_PROP114

Interne ID: ID_ELE_PROP114

Texto al pulsar

Texto de los botones que aparecerá cuando estén pulsados.

Los caracteres \n hacen saltar a una línea nueva.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DownText


ID_ELE_PROP115

Interne ID: ID_ELE_PROP115

Ejecución de función al presionar

Activado: La función vinculada se ejecutará al pulsar sobre el elemento.
Desactivado: La función vinculada se ejecutará al soltar el elemento.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FktOnDown


ID_ELE_PROP116

Interne ID: ID_ELE_PROP116

Forma de botón

Forma del botón:
angular: Las esquinas del botón serán rectas, los redondeos se configuran con las propiedades del grupo Redondeado.
redondo: El botón se representará redondo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BtnStyleBorder


ID_ELE_PROP117

Interne ID: ID_ELE_PROP117

Gradiente de color invertido

Solo disponible cuando el relleno del botón no sea monocromo.
Activado: Se invertirá el gradiente de luminosidad.
Desactivado: No se invertirá el gradiente de luminosidad.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BtnStyleInvert


ID_ELE_PROP118

Interne ID: ID_ELE_PROP118

Relleno

Relleno del botón:
Monocromo: Ningún gradiente
lineal: gradiente uniforme
con rayos: De abajo al centro el color de relleno 1, luego gradiente del centro hasta arriba
puntual: Gradiente de los márgenes al centro

puntual con rayos: Gradiente de los márgenes al centro formando rayos

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BtnStyleFill


ID_ELE_PROP121

Interne ID: ID_ELE_PROP121

Mostrar estado de la variable

Activado: El estado de las variables se representará con un cuadrado de color en el elemento.

Color:
Un cuadrado rojo indica que hay problemas de comunicación con el PLC.
Un cuadrado azul en el cliente indica que el cliente ha perdido la conexión al servidor.
Un cuadrado azul en la estación indica que el valor no ha sido inicializado.

Posición del cuadrado en el elemento con forma:

redonda: borde superior, en el centro
redondeada: esquina superior derecha un poco hacia la izquierda
angular y todas las demás: esquina superior derecha

Desactivado: El estado no se mostrará.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowState


ID_ELE_PROP122

Interne ID: ID_ELE_PROP122

Alineación horizontal

Alineación horizontal de salida del elemento para visualizar. Configuraciones posibles de la lista desplegable:

- centrado
- alineado a la izquierda
- alineado a la derecha

Por defecto: Centrado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HorizontalAlign


ID_ELE_PROP123

Interne ID: ID_ELE_PROP123

Alineación vertical

Alineación vertical de salida del elemento para visualizar. Configuraciones posibles de la lista desplegable:

- centrado
- arriba
- abajo

Por defecto: Centrado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VerticalAlign


ID_ELE_PROP124

Interne ID: ID_ELE_PROP124

Bordes del elemento

Lista desplegable para seleccionar el tipo de borde. Están disponibles:

Borde Fino

3D

Por defecto: Borde fino

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Frame


ID_ELE_PROP125

Interne ID: ID_ELE_PROP125

Mostrar unidad

Solo disponible:
En general: cuando la propiedad Mostrar valor esté activada.
Con el elemento Reloj: cuando como Tipo de visualización se haya seleccionado Lapso de tiempo.
Con el elemento Indicador: cuando la propiedad 3D esté activada.

Activado: La unidad técnica de la variable vinculada se mostrará detrás del valor.
Cuando el valor se represente en porcentaje, se utilizará el signo de por ciento % en lugar de la unidad técnica de la variable vinculada.
Desactivado: La unidad técnica no se mostrará.
Por defecto: activado.

Observación:

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowUnit


ID_ELE_PROP126

Interne ID: ID_ELE_PROP126

Mostrar valor en porcentaje

Activado: El valor de la variable se representará en 0-100%.
0% = rango de medición mínimo
100% = rango de medición máximo
La conversión será lineal. Las entradas de valores predeterminados serán también porcentuales.
Desactivado: El valor se representará como de costumbre.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Percentage


ID_ELE_PROP127

Interne ID: ID_ELE_PROP127

3D

Activado: El elemento se representará en 3 dimensiones.
Desactivado: El elemento se representará plano.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ThreeDimensional


ID_ELE_PROP129

Interne ID: ID_ELE_PROP129

Representación en porcentajes

Activado: El valor de la variable se representará en 0-100%.
0% = rango de medición mínimo
100% = rango de medición máximo
La conversión será lineal. Las entradas de valores predeterminados serán también porcentuales.
Desactivado: El valor se representará como de costumbre.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Percentage


ID_ELE_PROP130

Interne ID: ID_ELE_PROP130

Cinta

Sólo disponible si la propiedad Arco no está activada.

No disponible para Windows CE.

  • Activado: El valor se representa con una banda que va desde el valor mínimo al actual.
  • Desactivado: No se mostrará ninguna banda.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Ribbon


ID_ELE_PROP131

Interne ID: ID_ELE_PROP131

Arco

Sólo disponible si la propiedad Cinta no está activada.

  • Activado: El valor se representa con un arco que va desde el valor mínimo al actual.
  • Desactivado: No se mostrará ningún arco.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Pie


ID_ELE_PROP132

Interne ID: ID_ELE_PROP132

Explícito

Esta propiedad solo afecta a la representación de valores con límites definidos de variables. Los valores límite de las matrices de reacción no serán evaluados.

  • Activado: Si se viola un límite de la variable vinculada solo se representará en el color del límite correspondiente la parte hasta donde alcance la violación del límite.
    Si la variable tiene varios límites definidos las distintas áreas se representarán en el color del límite correspondiente.
  • Desactivado: Si se viola un límite de la variable vinculada se mostrará toda la representación con el color del límite violado.

Por defecto: Desactivado

Observación: Solo disponible con el elemento Indicador cuando la representación como Cinta o Arco esté activada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Explicit


ID_ELE_PROP135

Interne ID: ID_ELE_PROP135

Mostrar curvas como superficie

Activado: Las curvas se representarán como planos.
Desactivado: Las curvas se representarán como líneas.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Area


ID_ELE_PROP136

Interne ID: ID_ELE_PROP136

No interpolar

Activado: Los valores se enlazarán en niveles sin interpolación.
Desactivado: Los valores se enlazarán con interpolación.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NoInterpolation


ID_ELE_PROP137

Interne ID: ID_ELE_PROP137

Mostrar valores numéricos

Activado: Los valores de la última actualización se mostrarán en números para todas las variables vinculadas.
Desactivado: Los valores no se mostrarán.
Por defecto: activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NumericalValues


ID_ELE_PROP138

Interne ID: ID_ELE_PROP138

Mostrar ejes

Activado: Se mostrarán los ejes temporal y porcentual.
Desactivado: Los ejes no se mostrarán.
Por defecto: activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Axes


ID_ELE_PROP139

Interne ID: ID_ELE_PROP139

Mostrar información de curva

Activado: El nombre o el texto breve modificado y el rango de medición de las variables vinculadas se mostrarán en una leyenda.
Desactivado: No se mostrará ninguna leyenda.
Por defecto: activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Addresses


ID_ELE_PROP140

Interne ID: ID_ELE_PROP140

Establecer valor al mover el ratón

Activado: Envío continuo de valores nuevos mientras se mueva el ratón.
Desactivado: Envío único del valor nuevo cuando se suelte el botón del ratón.
(Solo si en la sección “Valor predeterminado” está activada la opción “directo al hardware”)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MouseMovement


ID_ELE_PROP141

Interne ID: ID_ELE_PROP141

Mostrar valor

Se puede elegir si se muestra adicionalmente el valor actual en número, la posición del elemento y el color de la fuente.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowValue


ID_ELE_PROP142

Interne ID: ID_ELE_PROP142

Tamaño del gráfico

Definición del tamaño del gráfico.

  • Ajustado: El tamaño del gráfico se ajustará al tamaño del elemento.
  • Tamaño original: El gráfico vinculado se representará en tamaño original.
    Si selecciona está opción no podrá configurar individualmente las propiedades Anchura [píxeles] y Altura [píxeles] en los elementos multibin, combi, botón e interruptor.

Por defecto: Ajustado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GraphicSize


ID_ELE_PROP150

Interne ID: ID_ELE_PROP150

Ancho de línea [píxeles]

Ancho de línea (en píxeles).
Mínimo: 0
El ancho de línea es en este caso de 1 píxel.
Máximo: 40
Por defecto:: 1
Atención: Si en las propiedades de proyecto en el nodo Diseño gráfico se ha establecido la propiedad Calidad gráfica en Windows Basis, el ancho de línea >1 solo se puede utilizar con una línea del tipo "línea continua".

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LineWidth


ID_ELE_PROP151

Interne ID: ID_ELE_PROP151

Color del valor

Color para el valor que se desea representar.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ValueColor


ID_ELE_PROP152

Interne ID: ID_ELE_PROP152

Posición del valor

Posición para el valor que se desea representar.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ValuePos


ID_ELE_PROP153

Interne ID: ID_ELE_PROP153

Ángulo de inicio

Definición del ángulo inicial (0°=abajo, continuando en el sentido de las agujas del reloj).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StartAngle


ID_ELE_PROP154

Interne ID: ID_ELE_PROP154

Ángulo de apertura

Ángulo de apertura de la amplitud del indicador (máx. 360° - Ángulo inicial).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OpeningAngle


ID_ELE_PROP155

Interne ID: ID_ELE_PROP155

Ancho de desplazamiento [%]

Esta propiedad define el % en que se desplazará la curva al llegar al límite de la representación; se pueden introducir valores de 0%-100% directamente como entradas o con la barra desplegable.
0%: Por cada nueva entrada suprimir la más antigua.
50%: En caso de desbordamiento eliminar la mitad del área de la pantalla y continuar escribiendo.
100%: En caso de desbordamiento eliminar todo el área de la pantalla y recomenzar.
Por defecto: 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ScrollWidth


ID_ELE_PROP156

Interne ID: ID_ELE_PROP156

Sentido del desplazamiento

Esta propiedad define la disposición del eje temporal que se va a representar.
A la derecha: A la izquierda el valor más antiguo, a la derecha el más actual.
A la izquierda: A la derecha el valor más antiguo, a la izquierda el más actual.
Arriba: Abajo el valor más antiguo, arriba el más actual.
Abajo: Arriba el valor más antiguo, abajo el más actual.
Cuando se muestren los ejes, una flecha en la esquina inferior izquierda del elemento indicará la dirección de recorrido.
Por defecto: A la derecha.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Direction


ID_ELE_PROP157

Interne ID: ID_ELE_PROP157

Texto

Texto que se representará en la pantalla.

Con el carácter & se representará subrayado el próximo carácter en el runtime. Para representar el caracter & por sí mismo hay que introducir ”&&”.

Con los caracteres \n se produce un salto de línea.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Text


ID_ELE_PROP158

Interne ID: ID_ELE_PROP158

Textwinkel [°]

Winkel für die Darstellung des Textes.

ACHTUNG: Diese Option funktioniert nur bei eingebetteten Schriften.

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextAngle


ID_ELE_PROP159

Interne ID: ID_ELE_PROP159

Buchstabenneigung [°]

Buchstabenneigung.

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextLetterAngle


ID_ELE_PROP160

Interne ID: ID_ELE_PROP160

Base numérica para visualización

Introduzca aquí el sistema numérico para la representación de los valores. Tiene disponibles los siguientes sistemas numéricos:

  • Binaria: Representación binaria. Este formato se mostrará con una "b" detrás del valor.
  • Decimal: Representación decimal.
  • Exponencial: Representación decimal con escritura exponencial. Ejemplo: 1E+03 corresponde a 1000 en la representación decimal.
  • Hexadecimal: Representación hexadecimal. Este formato se mostrará con una "h" detrás del valor.
  • Octal: Representación octal. Este formato se mostrará con una "o" detrás del valor.

Por defecto: Decimal.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ValueBase


ID_ELE_PROP161

Interne ID: ID_ELE_PROP161

Mostrar escala

Activado: En el elemento se mostrará una escala.
Desactivado: En el elemento no se mostrará ninguna escala.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowScale


ID_ELE_PROP162

Interne ID: ID_ELE_PROP162

Distancia [píxeles]

Distancia entre la escala y el elemento (en píxeles).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ScaleDistance


ID_ELE_PROP163

Interne ID: ID_ELE_PROP163

Altura [píxeles]

Altura de la escala (en píxeles).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ScaleHeight


ID_ELE_PROP164

Interne ID: ID_ELE_PROP164

Líneas principales

Rango de valor para las divisiones principales (mostrar cifras) de la escala.

Ejemplo: La entrada 50 hace que se muestre una división principal con 50 pasos: 0 - 50 - 100 - 150 ...

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MainTicks


ID_ELE_PROP165

Interne ID: ID_ELE_PROP165

Líneas secundarias

Rango de valor para las divisiones secundarias (no mostrar cifras) de la escala.
Ejemplo: La entrada 100 dará lugar a que se muestren las divisiones secundarias cada mil pasos empezando por el menor valor representado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SmallTicks


ID_ELE_PROP166

Interne ID: ID_ELE_PROP166

Color línea principal

Color para las divisiones principales (mostrar cifras) de la escala.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MainTickColor


ID_ELE_PROP167

Interne ID: ID_ELE_PROP167

Color líneas secundarias

Color para las divisiones secundarias (no mostrar cifras) de la escala.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SmallTickColor


ID_ELE_PROP168

Interne ID: ID_ELE_PROP168

Mostrar leyenda

Si se activa se mostrará un texto (valores) para la escala.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowLegend


ID_ELE_PROP169

Interne ID: ID_ELE_PROP169

Distancia [píxeles]

Distancia entre la leyenda y la escala (en píxeles).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LegendDistance


ID_ELE_PROP170

Interne ID: ID_ELE_PROP170

Color de leyenda

Color de la leyenda.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LegendColor


ID_ELE_PROP171

Interne ID: ID_ELE_PROP171

Logarítmico

Activado: Escala logarítmica.
Desactivado: Escala lineal.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Logarithmic


ID_ELE_PROP172

Interne ID: ID_ELE_PROP172

Dirección inversa

Inversión del valor mínimo-máximo en la representación gráfica

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ReverseDirection


ID_ELE_PROP173

Interne ID: ID_ELE_PROP173

Discreto

Entrada del valores solo en los pasos configurados.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Discrete


ID_ELE_PROP174

Interne ID: ID_ELE_PROP174

Niveles discretos

Número de pasos para la propiedad Niveles discretos.

Mínimo: 2

Máximo: 20

Por defecto: 5

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DiscreteSteps


ID_ELE_PROP175

Interne ID: ID_ELE_PROP175

Mostrar botón

En lugar del valor actual se mostrará en el elemento un elemento de manejo (botón).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowKnob


ID_ELE_PROP176

Interne ID: ID_ELE_PROP176

Forma del botón

Seleccionar la forma del botón de la lista. (plano, con relieve, hundido)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

KnobStyle


ID_ELE_PROP177

Interne ID: ID_ELE_PROP177

Color del botón

Color del botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

KnobColor


ID_ELE_PROP191

Interne ID: ID_ELE_PROP191

Forma

Lineal: Representación como barra o regleta de desplazamiento.
Redondo: Representación como elemento puntero.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Shape


ID_ELE_PROP192

Interne ID: ID_ELE_PROP192

Alineación

Sólo disponible para la forma lineal:
Horizontal: Representación horizontal de la barra o regleta de desplazamiento.
Vertical: Representación vertical de la barra o regleta de desplazamiento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Align


ID_ELE_PROP193

Interne ID: ID_ELE_PROP193

Ángulo de inicio

Solo disponible para forma redonda:
Posición del indicador para el valor mínimo (0° abajo).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Start


ID_ELE_PROP194

Interne ID: ID_ELE_PROP194

Ángulo final

Solo disponible para forma redonda:
Posición del indicador para el valor máximo (0° abajo).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

End


ID_ELE_PROP195

Interne ID: ID_ELE_PROP195

Estilo

Estilos de representación disponibles:
– Regleta de desplazamiento/giratoria
– Barras
– Barras LED
– Escala móvil

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Style


ID_ELE_PROP196

Interne ID: ID_ELE_PROP196

Tipo de indicador

Señalización gráfica del valor actual con
– Línea
– Puntero
–Triángulo

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Pointer


ID_ELE_PROP197

Interne ID: ID_ELE_PROP197

Barra explícita

Solo disponible cuando para la propiedad Estilo se haya elegido Barras, Escala móvil o Barras LED.

Esta propiedad solo afecta a la representación de valores con límites definidos de variables. Los valores límite de las matrices de reacción no serán evaluados.

  • Activado: Si se viola un límite de la variable vinculada solo se representará en el color del límite correspondiente la parte hasta donde alcance la violación del límite.
    Si la variable tiene varios límites definidos las distintas áreas se representarán en el color del límite correspondiente.
  • Desactivado: Si se viola un límite de la variable vinculada se mostrará toda la representación con el color del límite violado.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Explicit


ID_ELE_PROP198

Interne ID: ID_ELE_PROP198

Color indicador/barra

Color para el puntero o barra.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PointerColor


ID_ELE_PROP199

Interne ID: ID_ELE_PROP199

Mostrar indicador de arrastre

Activar visualización mínimo/máximo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MinMaxView


ID_ELE_PROP200

Interne ID: ID_ELE_PROP200

Tipo de representación

Señalización gráfica (Aguja de arrastre) del valor máximo/mínimo con:
– Línea
– Puntero
–Triángulo

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MinMaxShape


ID_ELE_PROP201

Interne ID: ID_ELE_PROP201

Color del valor mínimo

Color para el mínimo representado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MinColor


ID_ELE_PROP202

Interne ID: ID_ELE_PROP202

Color del valor máximo

Color para el máximo representado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxColor


ID_ELE_PROP203

Interne ID: ID_ELE_PROP203

Resetear automáticamente

Resetear automáticamente el puntero de arrastre para mínimo/máximo después del tiempo configurado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AutoReset


ID_ELE_PROP204

Interne ID: ID_ELE_PROP204

Resetear después de [min]

Tiempo para el reseteo automático del mín/máx. Mostrar.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AutoResetTime


ID_ELE_PROP211

Interne ID: ID_ELE_PROP211

Izquierda [píxeles]

Distancia entre el margen izquierdo del elemento y la representación gráfica (en píxeles).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LeftFrame


ID_ELE_PROP212

Interne ID: ID_ELE_PROP212

Derecha [píxeles]

Distancia entre el margen derecho del elemento y la representación gráfica (en píxeles).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RightFrame


ID_ELE_PROP213

Interne ID: ID_ELE_PROP213

Arriba [píxeles]

Distancia entre el margen superior del elemento y la representación gráfica (en píxeles).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TopFrame


ID_ELE_PROP214

Interne ID: ID_ELE_PROP214

Abajo [píxeles]

Distancia entre el margen inferior del elemento y la representación gráfica (en píxeles).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BottomFrame


ID_ELE_PROP221

Interne ID: ID_ELE_PROP221

Mostrar título

Mostrar título.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowTitle


ID_ELE_PROP222

Interne ID: ID_ELE_PROP222

Posición de título

Posición para el título.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TitlePos


ID_ELE_PROP223

Interne ID: ID_ELE_PROP223

Color de título

Color del texto para el título.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TitleColor


ID_ELE_PROP224

Interne ID: ID_ELE_PROP224

Texto del título

Texto que se mostrará como título.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TitleText


ID_ELE_PROP225

Interne ID: ID_ELE_PROP225

Distancia [píxeles]

Distancia entre el título y la representación del valor (en píxeles).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ValueDistance


ID_ELE_PROP231

Interne ID: ID_ELE_PROP231

Sentido del desplazamiento

Dirección de rotación de la barra.
hacia arriba: El valor menor abajo, el mayor arriba.
hacia abajo: El valor menor arriba, el mayor abajo.
hacia la izquierda: El valor menor a la derecha, el mayor a la izquierda.
hacia la derecha: El valor menor a la izquierda, el mayor a la derecha.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Direction


ID_ELE_PROP241

Interne ID: ID_ELE_PROP241

Horas

Horas del periodo de representación.
Por defecto: 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RepresentationHour


ID_ELE_PROP242

Interne ID: ID_ELE_PROP242

Minutos

Minutos del periodo de representación.
Mínimo: 0
Máximo: 59.
Por defecto: 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RepresentationMinute


ID_ELE_PROP243

Interne ID: ID_ELE_PROP243

Segundos

Segundos del periodo de representación.
Mínimo: 0
Máximo: 59.
Por defecto: 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RepresentationSecond


ID_ELE_PROP251

Interne ID: ID_ELE_PROP251

Horas

Horas del tiempo de actualización.
Mínimo: 0
Máximo: 119304.
Por defecto: 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RefreshHour


ID_ELE_PROP252

Interne ID: ID_ELE_PROP252

Minutos

Minutos del tiempo de actualización.
Mínimo: 0
Máximo: 59.
Por defecto: 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RefreshMinute


ID_ELE_PROP253

Interne ID: ID_ELE_PROP253

Segundos

Segundos del tiempo de actualización.
Mínimo: 0
Máximo: 59.
Por defecto: 1.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RefreshSecond


ID_ELE_PROP254

Interne ID: ID_ELE_PROP254

Milisegundos

Milisegundos del tiempo de actualización.
Mínimo: 0
Máximo: 999.
Por defecto: 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RefreshMilliSecond


ID_ELE_PROP256

Interne ID: ID_ELE_PROP256

Parámetros para sustitución

Entrada de la secuencia de caracteres para la sustitución mediante parámetros. Sustituye en el diálogo de sustitución del cambio de pantalla a la contraseña {PARAM}.

Observación: Evite secuencias de caracteres que se utilicen también para parámetros de las variables de indexación como {X01}.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FunctionParameter


ID_ELE_PROP262

Interne ID: ID_ELE_PROP262

Color de línea

Color normal, cuando se viole el valor límite se utilizará el color de valor límite.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LineColor


ID_ELE_PROP263

Interne ID: ID_ELE_PROP263

Tipo de línea

Línea continua, guiones, punto y coma.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LineStyle


ID_ELE_PROP264

Interne ID: ID_ELE_PROP264

Rango mínimo de visualización

Mínimo del área de representación técnica para la curva (Aumento de sección).
Mínimo: Valor mínimo de la variable.
Máximo: Valor máximo de la variable.
Por defecto: Valor mínimo de la variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ViewMin


ID_ELE_PROP265

Interne ID: ID_ELE_PROP265

Rango máximo de visualización

Máximo del área de representación técnica para la curva (Aumento de sección).
Mínimo: Valor mínimo de la variable.
Máximo: Valor máximo de la variable.
Por defecto: Valor máximo de la variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ViewMax


ID_ELE_PROP266

Interne ID: ID_ELE_PROP266

Nombre de la curva

Se mostrará cuando se haya establecido la opción "Mostrar información de curvas".
Si esta propiedad está vacía se mostrará el nombre de la variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TrendText


ID_ELE_PROP271

Interne ID: ID_ELE_PROP271

Tipo de representación

Selección del tipo de representación de la lista desplegable:

  • Archivo gráfico y símbolo de pantalla: Para cada estado se puede seleccionar un archivo gráfico o un símbolo de pantalla (símbolo del grupo de elementos).
    Además se puede modificar el color del símbolo de pantalla.
  • Sólo símbolo de pantalla: Para cada estado se puede asignar un color a cada símbolo existente en la pantalla.
  • Símbolo de la galería: Para cada estado se puede seleccionar un símbolo de la galería así como el color de las líneas y del fondo.
  • Carácter: Para cada estado se puede definir un carácter (sólo SICAM 230).
  • Texto de estado y símbolo de pantalla: Para cada estado se puede definir un texto.
    Además se puede cambiar el color de un símbolo de pantalla.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RepresentationStyle


ID_ELE_PROP272

Interne ID: ID_ELE_PROP272

Superponer

Solo disponible para el tipo de representación "Símbolo de la galería":
Activado: Si hay varias asignaciones de valores activadas se representarán superpuestas, es decir, se mostrarán todos los estados activados.
Desactivado: Solo se mostrará el estado activado con la mayor prioridad.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Overlapping


ID_ELE_PROP273

Interne ID: ID_ELE_PROP273

Colores separados

Solo disponible si está activado "Superpuesto":
Activado: Cada estado se representará con su color definido.
Desactivado: Se utilizará el color del estado activado con mayor prioridad.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SeparateColors


ID_ELE_PROP274

Interne ID: ID_ELE_PROP274

Parpadeo separado

Solo disponible si está activado "Superpuesto":
Activado: El parpadeo de cada estado se representará por separado.
Desactivado: Se utilizará el parpadeo del estado activado con mayor prioridad.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SeparateBlinking


ID_ELE_PROP275

Interne ID: ID_ELE_PROP275

Textos encadenados

Sólo disponible para el tipo de representación "Texto de estado":
Activado: Cuando se den varios estados, los textos se representarán como cadena combinada.
Desactivado: Se utilizará el texto del estado activado con mayor prioridad.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Chained


ID_ELE_PROP276

Interne ID: ID_ELE_PROP276

Transparente

Activado: El trasfondo del símbolo es transparente.
Desactivado: El trasfondo del símbolo se puede definir por separado para cada estado.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FillColor


ID_ELE_PROP278

Interne ID: ID_ELE_PROP278

A tamaño original

Activado: El bitmap se representará en su tamaño original.
Desactivado: El bitmap se ampliará hasta el tamaño del elemento.
Por defecto: activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OriginalSize


ID_ELE_PROP279

Interne ID: ID_ELE_PROP279

Símbolo de pantalla activo

Solo disponible si para la propiedad Tipo de representación se ha seleccionado Archivo gráfico y símbolo de pantalla o Texto de estado y símbolo de pantalla.

  • Activado: Además del archivo gráfico animado o el texto de estado se puede mostrar un símbolo de pantalla.
  • Desactivado: No se utilizará ningún símbolo de pantalla.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsPictureSymbol


ID_ELE_PROP280

Interne ID: ID_ELE_PROP280

Símbolo de pantalla

Solo disponible cuando para la propiedad Tipo de representación se haya seleccionado Sólo símbolo de pantalla o cuando se haya activado la propiedad Símbolo de pantalla activo.
Selección del símbolo de pantalla cuyo color cambie según el estado. Puede ser un símbolo o un grupo de elementos.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PictureSymbol


ID_ELE_PROP281

Interne ID: ID_ELE_PROP281

Colorear sólo área de relleno

Activado: El cambio de color afecta solo a la superficie de relleno.
Desactivado: El cambio de color afecta también a las líneas.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FillAreaOnly


ID_ELE_PROP282

Interne ID: ID_ELE_PROP282

Tomar parpadeo de la variable principal

Activado: Se aplica el atributo de parpadeo de la variable principal y se puede reconocer sobre el elemento.
Desactivado: No se produce ningún parpadeo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BlinkingFromVariable


ID_ELE_PROP283

Interne ID: ID_ELE_PROP283

Considerar parpadeo de todas las variables

Solo disponible cuando esté activado "Aplicar parpadeo de la variable principal":
Activado: Se aplican los atributos de parpadeo de todas las variables.
Desactivado: Solo se aplica el atributo de parpadeo de la variable principal o no hay ningún parpadeo (dependiendo de la propiedad "Aplicar parpadeo de la variable principal").

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BlinkingFromAllVariables


ID_ELE_PROP284

Interne ID: ID_ELE_PROP284

Parpadeo de fondo transparente

Activado: El trasfondo del símbolo es transparente durante el parpadeo (el trasfondo del bitmap no se puede representar de forma transparente).
Desactivado: El trasfondo del símbolo no es transparente.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BlinkingBackGroundTransparent


ID_ELE_PROP285

Interne ID: ID_ELE_PROP285

Color parpadeante

Color de fondo cuando no se haya seleccionado "Trasfondo de parpadeo transparente".

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BlinkingBackColor


ID_ELE_PROP286

Interne ID: ID_ELE_PROP286

Mostrar estado de la variable principal

Si se selecciona la opción "Mostrar estado" cuando se pulse el botón derecho del ratón durante el funcionamiento online además de las variables se mostrará el bit de estado actual para la variable constituida.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowState


ID_ELE_PROP287

Interne ID: ID_ELE_PROP287

Mostrar estado con cuadrado

Cuando ocurra un estado de excepción (p. ej. "Defectuoso"), se verá una marca roja en la superficie superior derecha del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RedPoint


ID_ELE_PROP288

Interne ID: ID_ELE_PROP288

Tipo tipológico

Tipo tipológico

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TopologyType


ID_ELE_PROP289

Interne ID: ID_ELE_PROP289

Lado del transformador

Lado del transformador

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TransformerSide


ID_ELE_PROP290

Interne ID: ID_ELE_PROP290

Número de fuente

Número de fuente

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SupplyNumber


ID_ELE_PROP291

Interne ID: ID_ELE_PROP291

Configuración y test

Abre el diálogo para definir los estados.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StateAndTest


ID_ELE_PROP292

Interne ID: ID_ELE_PROP292

Aplicar el color de la variable principal

Activado: El color de relleno de los símbolos incrustados y los símbolos de la galería con el estado Por defecto se tomará de la variable principal cuando ésta viole el límite.
Eso quiere decir que: Mientras exista una violación del límite de las variables principales se tomará como color de relleno el color del límite. La definición del color de los estados se sobrescribirá. Otros atributos de estado como p. ej. Parpadeo, Transparencia o Color original del símbolo se tomarán sin embargo de la definición del estado. Esta propiedad no tiene ningún efecto sobre la representación bitmap.

Excepción: Si en el estado Por defecto está activada la propiedad Color original del símbolo se utilizará siempre el color original del símbolo.
Desactivado: El color de las variable principales no tiene ningún efecto sobre los colores del elemento combinado.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ColorFromVariable


ID_ELE_PROP293

Interne ID: ID_ELE_PROP293

Darstellung im gesperrten Zustand von Tasteneigenschaften des Projekts übernehmen

Configuración sobre si el comportamiento de las teclas se aplicará de la propiedad de proyecto. Para ello se tendrán en cuenta las configuraciones de las siguientes propiedades de proyecto.

  • Login y firma -> Botones bloqueados
  • Elementos bloqueados/interbloqueados -> Botones interbloqueados

Configuraciones posibles:

  • Activado: Se aplicarán las configuraciones de las propiedades de proyecto.
    Observación: La configuración Gris no tendrá efecto sobre los símbolos en el texto.
  • Desactivado: No se aplicarán las configuraciones.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DisabledStyleAsButtons


ID_ELE_PROP294

Interne ID: ID_ELE_PROP294

Mantener estado presionado

Sólo disponible si las propiedades Interruptor, Pulsador y Reacción inmediata están activadas.

Activado: Mientras el ratón esté pulsado sobre este elemento no se modificará la representación gráfica - aunque cambie el valor en el PLC. Para el elemento Botón tiene que estar activada la propiedad 3D.
Desactivado: El elemento representa siempre el valor de la variable tomado del PLC.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StayPressed


ID_ELE_PROP296

Interne ID: ID_ELE_PROP296

Configuración

Abre el diálogo para definir los estados.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Status


ID_ELE_PROP301

Interne ID: ID_ELE_PROP301

Tiempo para el cambio de texto [s]

En varios bits configurados de las variables de filas después del tiempo proyectado se producirá automáticamente el cambio de texto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextChangeTime


ID_ELE_PROP302

Interne ID: ID_ELE_PROP302

Archivo de texto

Selección del archivo de texto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MessageText


ID_ELE_PROP303

Interne ID: ID_ELE_PROP303

Selección de columnas

La variable de columnas tiene que ser una variable de palabras y define la posición de la columna de la cual se toma el texto.

ATENCIÓN: La variable de columna debe seleccionarse antes de la variable de fila.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variable


ID_ELE_PROP304

Interne ID: ID_ELE_PROP304

Activar filas

La variable de fila define la posición de la fila de la cual se toma el texto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ColVars


ID_ELE_PROP306

Interne ID: ID_ELE_PROP306

Configuraciones ActiveX

Selección del elemento ActiveX y de la variable vinculada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ActiveX


ID_ELE_PROP312

Interne ID: ID_ELE_PROP312

Luminosidad fuera

Solo disponible si "Sobre valores de luminosidad" está activado:
Luminosidad en el borde exterior del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OuterBrightness


ID_ELE_PROP313

Interne ID: ID_ELE_PROP313

Luminosidad dentro

Solo disponible si "Sobre valores de luminosidad" está activado:
Luminosidad en el centro del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InnerBrightness


ID_ELE_PROP321

Interne ID: ID_ELE_PROP321

Modificar dirección X activado

Activado: El movimiento horizontal del elemento vinculado está disponible.
Desactivado: El movimiento horizontal del elemento vinculado no está disponible.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsXActive


ID_ELE_PROP322

Interne ID: ID_ELE_PROP322

Variable

Nombre de la variable para el movimiento horizontal del elemento.
Abre el diálogo de selección de variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

XVariable


ID_ELE_PROP323

Interne ID: ID_ELE_PROP323

Valor mín. de la variable

Valor mínimo de la variable para el movimiento horizontal del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

XVarMin


ID_ELE_PROP324

Interne ID: ID_ELE_PROP324

Valor máx. de la variable

Valor máximo de la variable para el movimiento horizontal del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

XVarMax


ID_ELE_PROP325

Interne ID: ID_ELE_PROP325

Movimiento mín. [píxeles]

Posición horizontal del elemento para el valor mínimo de la variable (en píxeles).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

XViewMin


ID_ELE_PROP326

Interne ID: ID_ELE_PROP326

Movimiento máx. [píxeles]

Posición horizontal del elemento para el valor máximo de la variable (en píxeles).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

XViewMax


ID_ELE_PROP327

Interne ID: ID_ELE_PROP327

Modificar dirección Y activado

Activado: El movimiento vertical del elemento vinculado está disponible.
Desactivado: El movimiento vertical del elemento vinculado no está disponible.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsYActive


ID_ELE_PROP328

Interne ID: ID_ELE_PROP328

Variable

Nombre de la variable para el movimiento vertical del elemento.
Abre el diálogo de selección de variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

YVariable


ID_ELE_PROP329

Interne ID: ID_ELE_PROP329

Valor mín. de la variable

Valor mínimo de la variable para el movimiento vertical del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

YVarMin


ID_ELE_PROP330

Interne ID: ID_ELE_PROP330

Valor máx. de la variable

Valor máximo de la variable para el movimiento vertical del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

YVarMax


ID_ELE_PROP331

Interne ID: ID_ELE_PROP331

Movimiento mín. [píxeles]

Posición vertical del elemento para el valor mínimo de la variable (en píxeles).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

YViewMin


ID_ELE_PROP332

Interne ID: ID_ELE_PROP332

Movimiento máx. [píxeles]

Posición vertical del elemento para el valor máximo de la variable (en píxeles).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

YViewMax


ID_ELE_PROP333

Interne ID: ID_ELE_PROP333

Modificar anchura activado

Activado: Se puede hacer zoom a lo ancho del elemento vinculado.
Desactivado: No se puede hacer zoom a lo ancho del elemento vinculado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsXZoomActive


ID_ELE_PROP334

Interne ID: ID_ELE_PROP334

Variable

Nombre de la variable para hacer zoom a lo ancho del elemento.
Abre el diálogo de selección de variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

XZoomVariable


ID_ELE_PROP335

Interne ID: ID_ELE_PROP335

Valor mín. de la variable

Valor mínimo de la variable para hacer zoom a lo ancho del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

XZoomVarMin


ID_ELE_PROP336

Interne ID: ID_ELE_PROP336

Valor máx. de la variable

Valor máximo de la variable para hacer zoom a lo ancho del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

XZoomVarMax


ID_ELE_PROP337

Interne ID: ID_ELE_PROP337

Anchura mín. [%]

Factor de zoom a lo ancho del elemento para el valor mínimo de la variable (en %).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

XZoomViewMin


ID_ELE_PROP338

Interne ID: ID_ELE_PROP338

Anchura máx. [%]

Factor de zoom a lo ancho del elemento para el valor máximo de la variable (en %).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

XZoomViewMax


ID_ELE_PROP339

Interne ID: ID_ELE_PROP339

Modificar altura activado

Activar zoom a lo alto del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsYZoomActive


ID_ELE_PROP340

Interne ID: ID_ELE_PROP340

Variable

Nombre de la variable para hacer zoom a lo alto del elemento.
Abre el diálogo de selección de variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

YZoomVariable


ID_ELE_PROP341

Interne ID: ID_ELE_PROP341

Valor mín. de la variable

Valor mínimo de la variable para hacer zoom a lo alto del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

YZoomVarMin


ID_ELE_PROP342

Interne ID: ID_ELE_PROP342

Valor máx. de la variable

Valor máximo de la variable para hacer zoom a lo alto del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

YZoomVarMax


ID_ELE_PROP343

Interne ID: ID_ELE_PROP343

Altura mín. [%]

Factor de zoom a lo alto del elemento para el valor mínimo de la variable (en %).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

YZoomViewMin


ID_ELE_PROP344

Interne ID: ID_ELE_PROP344

Altura máx. [%]

Factor de zoom a lo alto del elemento para el valor máximo de la variable (en %).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

YZoomViewMax


ID_ELE_PROP345

Interne ID: ID_ELE_PROP345

Drehen aktiv

Activado: Se puede girar el elemento vinculado.
Desactivado: No se puede girar el elemento vinculado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsTwistActive


ID_ELE_PROP346

Interne ID: ID_ELE_PROP346

Variable

Nombre de la variable para girar el elemento.
Abre el diálogo de selección de variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TwistVariable


ID_ELE_PROP347

Interne ID: ID_ELE_PROP347

Valor mín. de la variable

Valor mínimo de la variable para girar el elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TwistVarMin


ID_ELE_PROP348

Interne ID: ID_ELE_PROP348

Valor máx. de la variable

Valor máximo de la variable para girar el elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TwistVarMax


ID_ELE_PROP349

Interne ID: ID_ELE_PROP349

Rotación mín [°]

Ángulo de giro del elemento para el valor mínimo de la variable (en °).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TwistViewMin


ID_ELE_PROP350

Interne ID: ID_ELE_PROP350

Rotación máx. [°]

Ángulo de giro del elemento para el valor máximo de la variable (en °).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TwistViewMax


ID_ELE_PROP351

Interne ID: ID_ELE_PROP351

Entradas

Solo disponible si la propiedad Entradas de la variable de cadena está desactivada.

Haciendo clic sobre el botón ... se abre el diálogo para definir las entradas para una List-/combobox estática.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Status


ID_ELE_PROP354

Interne ID: ID_ELE_PROP354

Color de rellleno

Color de fondo del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ButtonFillColor


ID_ELE_PROP357

Interne ID: ID_ELE_PROP357

Global

Las alarmas se tendrán en cuenta en todo el sistema.
Utilización principal: Suma de alarmas de la lista de alarmas globales.
Activado: Las alarmas se tendrán en cuenta independientemente de la pantalla vinculada.
La función vinculada se utilizará sólo para cambiar de pantalla.

Desactivado: Solo se tendrán en cuenta las alarmas de la pantalla vinculada.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BAGlobal


ID_ELE_PROP358

Interne ID: ID_ELE_PROP358

Proyecto

Selección de un proyecto individual o de todos los proyectos.

Sólo disponible si Global está activado.

Utilización en proyectos multijerárquicos.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BAProjekt


ID_ELE_PROP359

Interne ID: ID_ELE_PROP359

Prioridad

Prioridad de las clases de alarmas/eventos.
Activado: Aunque se seleccionen varias clases de alarmas/eventos se mostrará sólo una.
Reglas de prioridad:

  1. Cuanto menor sea el número de clase, mayor será la prioridad.
  2. Las no reconocidas tienen mayor prioridad que las reconocidas,

Desactivado: todas las clases seleccionadas se mostrarán al mismo tiempo (juntas).

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BAPriorit?t


ID_ELE_PROP360

Interne ID: ID_ELE_PROP360

Oculto

El elemento no se mostrará en el runtime

Activado: El elemento se ocultará en el runtime.
Se utilizará cuando el elemento controle sólo una variable de pantalla pero él mismo no deba ser mostrado.

Desactivado: El elemento se mostrará como un botón.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BAUnsichtbar


ID_ELE_PROP361

Interne ID: ID_ELE_PROP361

Clases de alarmas/eventos

Selección de las clases de alarmas/eventos que se mostrarán.

Abre el catálogo de selección de las clases.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BAKlassen


ID_ELE_PROP362

Interne ID: ID_ELE_PROP362

Primera clase de alarma/evento para representar

A partir de esta clase se escribirán los estados de las clases en la variable de imagen.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Offset


ID_ELE_PROP363

Interne ID: ID_ELE_PROP363

Fuente

Sustitución de variables y/o funciones en un símbolo o contenedor de faceplates:

Introduzca la variable de origen/función de origen. Se pueden utilizar los marcadores de posición (?, *). Cuando hay varias entradas se separan por un punto y coma (;).

Los destinos se definen con la propiedad Destino .
Por ejemplo: Las variables en el símbolo: Tanque1.Nivel de llenado y Tanque1.Posición de la válvula. Han de ser sustituidas por las variables Tank2.Estado de llenado y Tank2.Posición de la válvula.
Para ello introduzca en Fuente : *1* y en Destino 2. En el runtime se sustituirán las variables 1 por las variables 2.

Más en el manual online bajo Símbolos y Faceplates.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SubstituteSource


ID_ELE_PROP364

Interne ID: ID_ELE_PROP364

Destino

Sustitución de variables y/o funciones en un símbolo o contenedor de faceplates:
Introduzca las nuevas variables/funciones para asignar. No se permite ningún marcador de posición. Cuando hay varias entradas se separan por un punto y coma (;).

Las fuentes se definen antes con la propiedad Fuente .
Por ejemplo: Las variables en el símbolo: Tanque1.Nivel de llenado y Tanque1.Posición de la válvula. Han de ser sustituidas por las variables Tank2.Estado de llenado y Tank2.Posición de la válvula.
Para ello introduzca en Fuente : *1* y en Destino 2. En el runtime se sustituirán las variables 1 por las variables 2.

Más en el manual online bajo Símbolos y Faceplates.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SubstituteDestination


ID_ELE_PROP365

Interne ID: ID_ELE_PROP365

mediante nombres de variables

Sustitución de variables en un símbolo o contenedor de faceplates mediante variables:

  • Activado: La sustitución de los vínculos se realizará a través del nombre de las variables.
  • Desactivado La sustitución de los vínculos se realizará a través de la identificación de las variables.

Más en el manual online bajo Símbolos y Faceplates.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SubstituteOnName


ID_ELE_PROP366

Interne ID: ID_ELE_PROP366

Respetar mayúsculas/minúsculas

Tratamiento de las mayúsculas/minúsculas en las entradas para la fuente y el destino cuando se sustituyan variables y/o funciones en un símbolo o contenedor de faceplates:

  • Activado: Se tendrá en cuenta la escritura en mayúsculas/minúsculas.
  • Desactivado: No se tendrá en cuenta la escritura en mayúsculas/minúsculas.

Más en el manual online bajo Símbolos y Faceplates.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SubstituteMatchCase


ID_ELE_PROP367

Interne ID: ID_ELE_PROP367

Aplicar tamaño de la pantalla vinculada

Haciendo clic sobre el botón ... se ajusta el tamaño del contenedor al tamaño de la pantalla vinculada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SizeFromLinkedPicture


ID_ELE_PROP377

Interne ID: ID_ELE_PROP377

Posición del foco izquierda/derecha

Define la posición horizontal para el manejo del teclado en el runtime. La posición se define con un menú contextual y con el ratón en la ventana principal y no se puede modificar aquí.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TABOrderH


ID_ELE_PROP378

Interne ID: ID_ELE_PROP378

Posición del foco arriba/abajo

Define la posición vertical para el manejo del teclado en el runtime. La posición se define con un menú contextual y con el ratón en la ventana principal y no se puede modificar aquí.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TABOrderV


ID_ELE_PROP379

Interne ID: ID_ELE_PROP379

Líneas principales

Define las líneas divisorias principales de la escala.
Valor que define la distancia entre las líneas divisorias principales. El valor tiene que ser mayor o igual que el valor de la Líneas secundarias. Con el mismo valor no se mostrarán Líneas secundarias.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MainTicks


ID_ELE_PROP380

Interne ID: ID_ELE_PROP380

Líneas secundarias

Define la subdivisión de la escala entre Líneas principales.

Valor que define la distancia entre las líneas divisorias secundarias. El valor tiene que ser menor o igual que el valor de la Líneas principales. Con el mismo valor no se mostrará ninguna línea divisoria secundaria.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SmallTicks


ID_ELE_PROP381

Interne ID: ID_ELE_PROP381

Representación de las clases de alarmas/eventos seleccionados

Modo en el que se escribirán los estados de las clases en la variable de imagen.

Activado: Los estados de las clases de alarmas/eventos seleccionados se escribirán sin excepciones en la variable de imagen.
P. ej.: Clases seleccionadas 1,3 -> Clase1: Bits 0,1; Clase 3: Bits 2,3

Desactivado: Los estados de las clases de alarmas/eventos seleccionados se escribirán en posiciones fijas en las variables de imagen.
P. ej. Clases seleccionadas 1,3 -> Clase1: Bits 0,1;0 (Clase 2: Bits 2.3); Clase 3: Bits 4,5

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AbbModus


ID_ELE_PROP382

Interne ID: ID_ELE_PROP382

Tipo de función

Solo disponible si tiene la licencia para Automatic Line Coloring (ALC).

Selección del tipo de función del elemento. Haciendo clic en Tipo de función se abre una lista desplegable para seleccionar:

  • Finalización: Para barras colectoras terminales; al compilar en el editor se suprime el mensaje de error "Línea conectada solo por un lado".
  • Generador: El elemento funciona como generador (análogamente a Fuente) - cuando haya actividad el color se transmitirá a la línea siguiente.
  • Ninguna función: El elemento no tiene ninguna función en ALC.
  • Vínculo: La información de ALC se transmitirá de un vínculo de origen a otro de destino.
  • Fuente: Cuando la fuente esté activada su color se transmitirá a la línea siguiente.
  • Interruptor: El color se transmitirá a la línea siguiente cuando el interruptor esté apagado y abastecido por una fuente.
  • Válvula: Funciona de manera análoga al Interruptor. El color se transmitirá a la línea siguiente cuando la válvula esté abierta o semiabierta y cuando esté abastecida por una fuente. Valores de la variable principal: ver Manual.
  • Sumidero: Este tipo de función no tiene ningún efecto en la coloración. Con VBA se puede preguntar si esta máquina consumidora está abastecida.
  • Transformador: Cuando el elemento está abastecido, una Fuente (color) se convierte en otra.
  • Seccionador: funciona de manera análoga al Interruptor, pero contiene un interbloqueo topológico Seccionador bajo carga. El color se transmitirá a la línea siguiente cuando el seccionador esté cerrado y abastecido por una fuente.

Por defecto: Ninguna función

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCType


ID_ELE_PROP383

Interne ID: ID_ELE_PROP383

Fuente

Solo disponible si se ha seleccionado un tipo de función Fuente o Transformador:
Selección de las fuentes/transformadores vinculados.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCSourceID


ID_ELE_PROP384

Interne ID: ID_ELE_PROP384

Color de ALC

Solo disponible si tiene la licencia para Automatic Line Coloring (ALC):
Activado: Se utilizará el color automático de la fuente(s) vinculada.
Desactivado: Se utilizará el color estándar.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCUseColor


ID_ELE_PROP385

Interne ID: ID_ELE_PROP385

Mostrar suministros múltiples

Solo disponible si la propiedad Color de ALC está activada.
Define el tipo de representación cuando el elemento esté conectado a varias fuentes activas:
Fuente con mayor prioridad: Solo se utilizará el color de la fuente con mayor prioridad.
Dos fuentes con mayor prioridad: Los diferentes colores de las dos fuentes con mayor prioridad se representarán con líneas discontinuas.
Color alternativo: Color alternativo para la coloración con abastecimiento múltiple.

Por defecto: Fuente con mayor prioridad

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCMultiSource


ID_ELE_PROP386

Interne ID: ID_ELE_PROP386

Número de vínculo

Solo disponible si se ha seleccionado un tipo de función Enlace:
Número de identificación del enlace. Otro enlace en otra pantalla con el mismo número de identificación tomará los datos del enlace fuente.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCLinkID


ID_ELE_PROP387

Interne ID: ID_ELE_PROP387

Mostrar suministro asegurado

Sólo disponible cuando Color de ALC esté activado.

Selección de cómo debe representarse el suministro asegurado:

  • Doble ancho
  • Brillo doble
  • Normal

Por defecto: normal

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCMSecuredSupply


ID_ELE_PROP388

Interne ID: ID_ELE_PROP388

Prioridad de representación

Solo disponible si la propiedad Color de ALC está activada.

Define la prioridad de representación cuando el elemento esté conectado a varias fuentes activas.
Abastecimiento múltiple: El elemento se representará según las reglas del abastecimiento múltiple.
Abastecimiento asegurado: El elemento se representará según las reglas del abastecimiento asegurado.
Ninguna prioridad: Las reglas de coloración para Abastecimiento múltiple y para Abastecimiento asegurado se aplicarán al mismo tiempo en el caso de que se cumplan ambos criterios.

Por defecto: Abastecimiento múltiple
Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCPrecedence


ID_ELE_PROP389

Interne ID: ID_ELE_PROP389

Resetear al salir

Sólo disponible si Pulsador está activado:
Cuando se retira el ratón con pulsador apretado, el valor de la variable se resetea automáticamente.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ResetOnLeave


ID_ELE_PROP391

Interne ID: ID_ELE_PROP391

Marco/color sombreado

Sólo disponible si como Tipo de marco se ha seleccionado Marco o Sombra.

Definición del color del marco o sombra. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PunchFrameColor


ID_ELE_PROP392

Interne ID: ID_ELE_PROP392

Distancia [píxeles]

Sólo disponible si como Tipo de marco se ha seleccionado marco o sombra.

Distancia del marco o sombra al elemento en píxeles. La dirección de la distancia se determina con la sombra por la propiedad Ángulo [°]. El tamaño del rango del valor depende de la resolución de la pantalla.

Por defecto: 10

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PunchFrameOffset


ID_ELE_PROP393

Interne ID: ID_ELE_PROP393

Ancho de línea [píxeles]

Definición del ancho de línea para el marco en píxeles.

Por defecto: 1

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PunchFrameWidth


ID_ELE_PROP394

Interne ID: ID_ELE_PROP394

Modificar etiqueta con teclas de control

Sólo disponible una vez haya desactivado Etiquetado automático en las propiedades de la pantalla.

activado: Para escribir un texto sobre el botón utilice Texto fila 1 normal hasta Texto fila 2 con Ctrl + Alt (Alt Gr). La entrada de Texto fila 1 y Texto fila 2 es inválida.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ChangeText


ID_ELE_PROP395

Interne ID: ID_ELE_PROP395

Texto fila 1 normal

Sólo disponible cuando Modificar etiqueta con teclas de control esté activado.
Texto de la primera fila del botón sin que la tecla Control esté pulsada.
Observación: Con el carácter & se representará subrayado el próximo carácter en el runtime. Para representar el carácter & por sí mismo hay que introducir ”&&”.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Text1Normal


ID_ELE_PROP396

Interne ID: ID_ELE_PROP396

Texto fila 1 con shift

Sólo disponible si Modificar etiqueta con teclas de control está activado.
Texto de la primera fila del botón cuando la tecla Bloq Mayús esté pulsada.
Observación: Con el carácter & se representará subrayado el próximo carácter en el runtime. Para representar el carácter & por sí mismo hay que introducir ”&&”.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Text1Shift


ID_ELE_PROP397

Interne ID: ID_ELE_PROP397

Texto fila con Ctrl

Sólo disponible si Modificar etiqueta con teclas de control está activado.
Texto de la primera fila del botón cuando la tecla Control esté pulsada.
Observación: Con el carácter & se representará subrayado el próximo carácter en el runtime. Para representar el carácter & por sí mismo hay que introducir ”&&”.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Text1Ctrl


ID_ELE_PROP398

Interne ID: ID_ELE_PROP398

Texto fila 1 con Ctrl + Alt (Alt Gr)

Sólo disponible si Modificar etiqueta con teclas de control está activado.
Texto de la primera fila del botón cuando las teclas Control y Alt Gr estén pulsadas.
Observación: Con el carácter & se representará subrayado el próximo carácter en el runtime. Para representar el carácter & por sí mismo hay que introducir ”&&”.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Text1CtrlAlt


ID_ELE_PROP399

Interne ID: ID_ELE_PROP399

Texto fila 2 normal

Sólo disponible si Modificar etiqueta con teclas de control está activado.
Texto de la segunda fila del botón sin que la tecla Control esté pulsada.
Observación: Con el carácter & se representará subrayado el próximo carácter en el runtime. Para representar el carácter & por sí mismo hay que introducir ”&&”.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Text2Normal


ID_ELE_PROP400

Interne ID: ID_ELE_PROP400

Texto fila 2 con shift

Sólo disponible si Modificar etiqueta con teclas de control está activado.
Texto de la segunda fila del botón cuando la tecla Bloq Mayús esté pulsada.
Observación: Con el carácter & se representará subrayado el próximo carácter en el runtime. Para representar el carácter & por sí mismo hay que introducir ”&&”.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Text2Shift


ID_ELE_PROP401

Interne ID: ID_ELE_PROP401

Texto fila 2 con Ctrl

Sólo disponible si Modificar etiqueta con teclas de control está activado.
Texto de la segunda fila del botón cuando la tecla Control esté pulsada.
Observación: Con el carácter & se representará subrayado el próximo carácter en el runtime. Para representar el carácter & por sí mismo hay que introducir ”&&”.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Text2Ctrl


ID_ELE_PROP402

Interne ID: ID_ELE_PROP402

Texto fila 2 con Ctrl + Alt (Alt Gr)

Sólo disponible si Modificar etiqueta con teclas de control está activado.
Texto de la segunda fila del botón cuando las teclas Control y Alt Gr estén pulsadas.
Observación: Con el carácter & se representará subrayado el próximo carácter en el runtime. Para representar el carácter & por sí mismo hay que introducir ”&&”.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Text2CtrlAlt


ID_ELE_PROP403

Interne ID: ID_ELE_PROP403

Tipo de inicio

Sólo disponible si en las propiedades de proyecto está activado Calidad gráfica.

Símbolo definido para el punto de partida de la línea. Haciendo clic sobre el campo se abre un diálogo para elegir un elemento.

Sólo disponible para arcos y segmentos de círculo si Estampado de relleno está configurado sin.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LineCapStart


ID_ELE_PROP404

Interne ID: ID_ELE_PROP404

Tipo final

Sólo disponible si en las propiedades de proyecto está activado Calidad gráfica.

Símbolo definido para el punto final de la línea. Haciendo clic sobre el campo se abre un diálogo para elegir un elemento.

Sólo disponible para arcos y segmentos de círculo si Estampado de relleno está configurado sin.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LineCapEnd


ID_ELE_PROP405

Interne ID: ID_ELE_PROP405

Tamaño

Sólo disponible si en las propiedades de proyecto está activado Calidad gráfica.

Define el factor de aumento para el ancho de la línea de flecha. El factor se refiere a la anchura de línea del elemento vectorial como se encuentre definido en la propiedad Ancho de línea [píxeles].

Sólo disponible para arcos y segmentos de círculo si Estampado de relleno está configurado sin.

Valor: mayor o igual a 1

Por defecto: 4

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LineCapScale


ID_ELE_PROP_BACKCOLOR2

Interne ID: ID_ELE_PROP_BACKCOLOR2

Gradiente de color

Sólo disponible si la propiedad Estampado de relleno está activada con el gradiente y la propiedad de proyecto Calidad gráfica está activada.

Define el segundo color para el gradiente. Al seleccionar Automático cambia el valor del color dependiendo del valor de la Color de relleno.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColor2


ID_ELE_PROP_BACKCOLORBUTTON2

Interne ID: ID_ELE_PROP_BACKCOLORBUTTON2

Verlaufsfarbe

Sólo disponible si la propiedad Relleno no está configurada como Monocromo.

Define el segundo color para el gradiente. Al seleccionar Automático cambia el valor del color dependiendo del valor de la Color de relleno.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColor2


ID_ELE_PROP_COLORGRADIENTANGLE

Interne ID: ID_ELE_PROP_COLORGRADIENTANGLE

Ángulo [°]

Define la dirección del gradiente de color partiendo del centro del elemento.

Valores: 0° a 360°

Por defecto: 0°

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ColorGradientAngle


ID_ELE_PROP_COLORGRADIENTOFFSET

Interne ID: ID_ELE_PROP_COLORGRADIENTOFFSET

Versatz [%]

Sólo disponible cuando en un elemento vectorial esté configurada la propiedad Gradiente de color o cuando en un elemento dinámico Botón la propiedad Relleno esté configurada como: lineal o puntual o puntual con rayos.

Define la distancia del punto de gradiente de color desde el centro del elemento. Se trata de un valor porcentual.

Valores: 0 define el centro del elemento,100 el borde.
Observación: El valor se puede establecer también fuera del elemento y por lo tanto no está limitado a 100.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ColorGradientOffset


ID_ELE_PROP_GLOWEFFECT_2NDBLINKSTATEVISIBLE

Interne ID: ID_ELE_PROP_GLOWEFFECT_2NDBLINKSTATEVISIBLE

2° estado de parpadeo invisible

Solo disponible si la propiedad Activar está activada. Además debe haber una variable definida en la propiedad Variable para parpadeo y la propiedad Tomar color de parpadeo del valor límite tiene que estar activada.

Activado: El efecto resplandor no cambia con el parpadeo al efecto resplandor configurado sino a invisible. De esta manera es posible un parpadeo entre invisible y el color de parpadeo del límite.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GlowEffect2ndBlinkStateVisible


ID_ELE_PROP_GLOWEFFECT_ACTIVE

Interne ID: ID_ELE_PROP_GLOWEFFECT_ACTIVE

Activar

Solo disponible si la propiedad del proyecto Calidad gráfica está establecida para DirectX Hardware o DirectX Software y la propiedad del proyecto Proyecto WindowsCE no está activada. La disponibilidad depende también del elemento gráfico.

Activado: El efecto resplandor se aplicará para el elemento.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GlowEffectActive


ID_ELE_PROP_GLOWEFFECT_ALPHA

Interne ID: ID_ELE_PROP_GLOWEFFECT_ALPHA

Transparencia [%]

Valor de transparencia con el que el efecto resplandor se aplicará al elemento. Unidad: en porcentaje. Haciendo clic sobre el botón ... se abre la regleta deslizante.

Mínimo: 0%, cubriente

Máximo: 100%, totalmente transparente

Por defecto: 20%

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GlowEffectAlpha


ID_ELE_PROP_GLOWEFFECT_COLOR

Interne ID: ID_ELE_PROP_GLOWEFFECT_COLOR

Color

Solo disponible si la propiedad Activar está activada. Lla propiedad Colorear tiene que estar activada.

Determina el color del efecto resplandor. Haciendo clic sobre el botón ... se abre una paleta de colores para seleccionar un color. Es posible introducir directamente el valor hexadecimal en el campo.

Por defecto: 0xFFFF90 (amarillo)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GlowEffectColor


ID_ELE_PROP_GLOWEFFECT_EVENT

Interne ID: ID_ELE_PROP_GLOWEFFECT_EVENT

Solo estará activado cuando esté siendo pulsado

Solo disponible si la propiedad Activar está activada y se trata de un elemento botón.

Activado: El efecto resplandor solo se representará cuando el botón esté pulsado. El efecto resplandor podrá cambiar el color, parpadear o hacerse invisible mientras esté pulsado.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GlowEffectEvent


ID_ELE_PROP_GLOWEFFECT_SPREAD

Interne ID: ID_ELE_PROP_GLOWEFFECT_SPREAD

Extensión [Píxel]

Define el factor de expansión para el efecto resplandor. Se definirá como número de píxeles que se calcula por cada lado para la expansión.

Mínimo: 0, ninguna expansión

Máximo: 50

Por defecto: 15

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GlowEffectSpread


ID_ELE_PROP_GLOWEFFECT_USECOLOR

Interne ID: ID_ELE_PROP_GLOWEFFECT_USECOLOR

Colorear

Solo disponible si la propiedad Activar está activada.

Activado: El efecto resplandor para el elemento se coloreará. De esta manera se representará el efecto resplandor total con un solo color definido. El color se puede configurar con la propiedad Color o con una variable definida en la propiedad Variable para color. Cuando ambas propiedades están activadas, se utilizará el color Variable para color.

Desactivado: Los colores del elemento se aplicarán para el efecto resplandor.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GlowEffectUseColor


ID_ELE_PROP_GRP0

Interne ID: ID_ELE_PROP_GRP0

General

Propiedades generales del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

General


ID_ELE_PROP_GRP1

Interne ID: ID_ELE_PROP_GRP1

Posición

Propiedades para la posición y tamaño del elemento dinámico.

Observación: Las configuraciones de este grupo no tienen ningún efecto sobre la representación de determinados elementos de control en las pantallas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Position


ID_ELE_PROP_GRP2

Interne ID: ID_ELE_PROP_GRP2

Representación en vista global

Propiedades para el comportamiento del elemento en la representación de pantalla global.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Overview


ID_ELE_PROP_GRP3

Interne ID: ID_ELE_PROP_GRP3

Colores

Propiedades de color del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Color


ID_ELE_PROP_GRP4

Interne ID: ID_ELE_PROP_GRP4

Macros VBA

Propiedades para las macros VBA vinculadas al elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VBA


ID_ELE_PROP_GRP5

Interne ID: ID_ELE_PROP_GRP5

Eventos generales

Macros VBA para eventos generales.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

General_Events


ID_ELE_PROP_GRP6

Interne ID: ID_ELE_PROP_GRP6

Escribir valor predeterminado

Propiedades para establecer valores predeterminados.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SetValueGroup


ID_ELE_PROP_GRP7

Interne ID: ID_ELE_PROP_GRP7

Variable / función

Propiedades para variable o función vinculada al elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Element


ID_ELE_PROP_GRP8

Interne ID: ID_ELE_PROP_GRP8

Configuraciones de visualización

Propiedades para la visualización del valor en el elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DisplayArea


ID_ELE_PROP_GRP9

Interne ID: ID_ELE_PROP_GRP9

Colores estáticos

Propiedades para la representación cromática del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Colors_Static


ID_ELE_PROP_GRP10

Interne ID: ID_ELE_PROP_GRP10

Limites estáticos del valor predeterminado

Límites predefinidos fijos del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SetValueLimits_Static


ID_ELE_PROP_GRP11

Interne ID: ID_ELE_PROP_GRP11

Representación

Propiedades para la representación gráfica del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Representation


ID_ELE_PROP_GRP12

Interne ID: ID_ELE_PROP_GRP12

Escala

Propiedades para la representación de una escala.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Scale


ID_ELE_PROP_GRP13

Interne ID: ID_ELE_PROP_GRP13

Indicador de arrastre

Propiedades para la representación de la forma básica del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Look


ID_ELE_PROP_GRP14

Interne ID: ID_ELE_PROP_GRP14

Borde

Propiedades para el marco del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Border


ID_ELE_PROP_GRP15

Interne ID: ID_ELE_PROP_GRP15

Título

Propiedades para la representación del título.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Title


ID_ELE_PROP_GRP16

Interne ID: ID_ELE_PROP_GRP16

Botón

Propiedades para la dirección del movimiento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Knob


ID_ELE_PROP_GRP17

Interne ID: ID_ELE_PROP_GRP17

Tiempo de representación

Periodo de tiempo que se representará en las curvas.
(Horas, minutos, segundos)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Time


ID_ELE_PROP_GRP18

Interne ID: ID_ELE_PROP_GRP18

Tiempo de actualización

Intervalo de tiempo en el que se actualizará la representación (es decir, se añadirá un valor nuevo).
(Horas, minutos, segundos)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Refresh


ID_ELE_PROP_GRP20

Interne ID: ID_ELE_PROP_GRP20

Configuraciones de símbolo de pantalla

Propiedades para utilizar un símbolo de pantalla para la Tipo de representación.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PictSymbol


ID_ELE_PROP_GRP21

Interne ID: ID_ELE_PROP_GRP21

Coloración automática de líneas

Propiedades para Automatic Line Coloring (ALC).

Encontrará más propiedades en las propiedades de proyecto en el grupo Coloración automática de líneas.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALC


ID_ELE_PROP_GRP22

Interne ID: ID_ELE_PROP_GRP22

Evento de ratón

Macros VBA para eventos de ratón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Mouse_Events


ID_ELE_PROP_GRP23

Interne ID: ID_ELE_PROP_GRP23

Drag&Drop

Macros VBA para eventos Drag&Drop.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DragDrop_Events


ID_ELE_PROP_GRP24

Interne ID: ID_ELE_PROP_GRP24

Gradiente de color

Propiedades para la configuración de gradientes de color. Sólo disponible si el Gradiente de color está seleccionado como Estampado de relleno.
Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

3D-Filling


ID_ELE_PROP_GRP25

Interne ID: ID_ELE_PROP_GRP25

Coloración automática de líneas

Propiedades para ALC.

Solo disponible con licencia para Automatic Line Coloring (ALC).
Encontrará otras propiedades basadas en elementos de pantalla en las propiedades de los elementos correspondientes en el grupo Coloración automática de líneas.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ALC


ID_ELE_PROP_GRP26

Interne ID: ID_ELE_PROP_GRP26

Redondeado

Propiedades para la representación de esquinas redondeadas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Roundness


ID_ELE_PROP_GRP27

Interne ID: ID_ELE_PROP_GRP27

Valor binario

Propiedades para establecer un valor predeterminado binario.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BinaryValue


ID_ELE_PROP_GRP28

Interne ID: ID_ELE_PROP_GRP28

Valor numérico

Propiedades para establecer un valor predeterminado analógico.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AnalogValue


ID_ELE_PROP_GRP29

Interne ID: ID_ELE_PROP_GRP29

Encabezado y rejilla

Propiedades para el encabezado y la rejilla.

Más en el manual online para AML

Más en el manual online para CEL

Más en el manual online para ETM.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Heading


ID_ELE_PROP_GRP30

Interne ID: ID_ELE_PROP_GRP30

Crear entradas dinámicamente

Propiedades para el combo-/listbox dinámico.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DynEntries


ID_ELE_PROP_GRP31

Interne ID: ID_ELE_PROP_GRP31

Botón de alarma de pantalla

Sólo disponible en SICAM 230.
Propiedades para el elemento de alarma de pantallas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BA-Elem


ID_ELE_PROP_GRP33

Interne ID: ID_ELE_PROP_GRP33

Detección de cortocircuitos

Contiene las propiedades para detectar errores de cortocircuitos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShortFaults


ID_ELE_PROP_GRP34

Interne ID: ID_ELE_PROP_GRP34

Formateo de texto

Propiedades para el formato del texto representado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextAlign


ID_ELE_PROP_GRP35

Interne ID: ID_ELE_PROP_GRP35

Configuraciones Bitmap

Propiedades para la utilización del elemento con diversos bitmaps para mostrar los estados.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BMPSettings


ID_ELE_PROP_GRP36

Interne ID: ID_ELE_PROP_GRP36

Configuraciones de símbolos

Propiedades para la utilización del elemento con símbolos de la galería para mostrar los estados.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LibSymSettings


ID_ELE_PROP_GRP37

Interne ID: ID_ELE_PROP_GRP37

Topología

Propiedades para SICAM 230.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MrLinzSettings


ID_ELE_PROP_GRP38

Interne ID: ID_ELE_PROP_GRP38

Modo de representación

Configuración para la representación gráfica de la regleta.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SuperLook


ID_ELE_PROP_GRP39

Interne ID: ID_ELE_PROP_GRP39

Punto de referencia

Determina el punto de inicio para el cálculo del ángulo de rotación o para el cambio de tamaño dinámico del elemento.

ATENCIÓN: Para elementos no rectangulares los datos se refieren siempre a al rectángulo abarcador.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RelPoint


ID_ELE_PROP_GRP40

Interne ID: ID_ELE_PROP_GRP40

Runtime

Propiedades para el comportamiento runtime del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Runtime


ID_ELE_PROP_GRP41

Interne ID: ID_ELE_PROP_GRP41

Manejo del teclado

Propiedades para manejar online el elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Operation


ID_ELE_PROP_GRP43

Interne ID: ID_ELE_PROP_GRP43

Archivo gráfico

Propiedades para el archivo gráfico del elemento dinámico Botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GraphicFile


ID_ELE_PROP_GRP44

Interne ID: ID_ELE_PROP_GRP44

Autorización

Propiedades para la autorización de uso del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Rights


ID_ELE_PROP_GRP45

Interne ID: ID_ELE_PROP_GRP45

Visibilidad

Propiedades para la visibilidad del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DynamicVisibility


ID_ELE_PROP_GRP46

Interne ID: ID_ELE_PROP_GRP46

Área de visualización estática

Propiedades para el área de visualización del elemento definida de forma fija.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Displayrange_Static


ID_ELE_PROP_GRP47

Interne ID: ID_ELE_PROP_GRP47

Parpadeo

Propiedades para el parpadeo del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DynamicBlinking


ID_ELE_PROP_GRP48

Interne ID: ID_ELE_PROP_GRP48

Regleta universal

Configuración de la regleta.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Universal_Slider


ID_ELE_PROP_GRP49

Interne ID: ID_ELE_PROP_GRP49

Leyenda

Configuración de la leyenda de la regleta.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Legend


ID_ELE_PROP_GRP50

Interne ID: ID_ELE_PROP_GRP50

Marco/Sombra

Propiedades para el marco y la sombra del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PunchFrame


ID_ELE_PROP_GRP51

Interne ID: ID_ELE_PROP_GRP51

Ángulo de apertura

Definición del ángulo para el segmento de círculo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Segment


ID_ELE_PROP_GRP52

Interne ID: ID_ELE_PROP_GRP52

Mostrar valores booleanos

Propiedades para la visualización de valores binarios.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GraphicalImage


ID_ELE_PROP_GRP53

Interne ID: ID_ELE_PROP_GRP53

Archivo gráfico

Configuración para archivos gráficos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MsgCtrlImages


ID_ELE_PROP_GRP54

Interne ID: ID_ELE_PROP_GRP54

Color de estado

Configuración para la identificación con color del estado de un mensaje.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MsgCtrlColors


ID_ELE_PROP_GRP55

Interne ID: ID_ELE_PROP_GRP55

Encabezado

Contiene propiedades para la configuración del encabezado de una lista.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ListHeader


ID_ELE_PROP_GRP_ALC_FAULTS

Interne ID: ID_ELE_PROP_GRP_ALC_FAULTS

Detección de pérdida a tierra

Contiene las propiedades para detectar errores de pérdidas a tierra.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GndFaults


ID_ELE_PROP_GRP_ALC_FOS

Interne ID: ID_ELE_PROP_GRP_ALC_FOS

Localización del error desde la protección/distribución de carga

Propiedades para la detección de errores.

Más en la Ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FOS_LoadBal


ID_ELE_PROP_GRP_EFFECTS

Interne ID: ID_ELE_PROP_GRP_EFFECTS

Efectos

Contiene propiedades para la configuración de efectos de pantalla.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Effects


ID_ELE_PROP_GRP_GLOW_EFFECT

Interne ID: ID_ELE_PROP_GRP_GLOW_EFFECT

Glow (solo DirectX)

Propiedades para la configuración del efecto resplandor. Solo disponible si la propiedad Calidad gráfica está establecida para DirectX Hardware o DirectX Software.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GlowEffect


ID_ELE_PROP_GRP_LINECAPS

Interne ID: ID_ELE_PROP_GRP_LINECAPS

Finales de líneas

Contiene las propiedades para la forma del principio y final de las líneas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LineCaps


ID_ELE_PROP_GRP_SW

Interne ID: ID_ELE_PROP_GRP_SW

Escribir valor predeterminado

Propiedades para establecer valores predeterminados.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SetValue


ID_ELE_PROP_GRPMULTITOUCH

Interne ID: ID_ELE_PROP_GRPMULTITOUCH

Multitouch_Interaction

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Multitouch_Interaction


ID_ELE_PROP_SYMBOLFORM_CLICKAREA

Interne ID: ID_ELE_PROP_SYMBOLFORM_CLICKAREA

La forma del símbolo define el área para hacer clic

Permite crear un botón para hacer clic con una forma libremente definible. Sólo disponible para la opción Símbolo de la galería del elemento combinado.

Activado: La forma del símbolo se utilizará como área para hacer clic, cada elemento del símbolo se tendrá en cuenta por separado para el área de clic.

Desactivado: La forma del elemento combinado (todo el rectángulo) se utilizará como área para hacer clic.

Por defecto: Desactivado

Atención: No disponible para Windows CE.

Esta propiedad está disponible a partir de la versión 6.51. En proyectos para versiones anteriores la propiedad se tratará como desactivada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SymbolFormClickArea


ID_ELE_PROP_UNIT_POS

Interne ID: ID_ELE_PROP_UNIT_POS

Unidad-Posición [%]

Sólo disponible si Mostrar unidad está activada.

Posiciona la representación de la unidad de manera que permite alinear unidades con diferente ancho a valores listados uno encima de otro. Para el posicionamiento se introduce un porcentaje entre 0 y 100.

La unidad se coloca siempre a la derecha de la posición seleccionada y el valor correspondiente, a su izquierda, dependiendo de la alineación configurada.

Por defecto: 0 - no corresponde a ninguna alineación porcentual, el valor y la unidad se representan siempre juntos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UnitPos


ID_ELE_SplineTension

Interne ID: ID_ELE_SplineTension

Redondeo

Sólo disponible si en las propiedades de proyecto está activada la opción Calidad gráfica en los nodos Diseño gráfico/Pantallas.

Define la redondez para polilíneas, polígonos y tuberías.

Valores: 0,0 (ninguna redondez) hasta 1,0. (redondez máxima)

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SplineTension


ID_ELE_TEXT_FROM_VARIABLE

Interne ID: ID_ELE_TEXT_FROM_VARIABLE

Texto tomado del valor de la variable

Sólo disponible para variables de cadena.

Activado: El texto se tomará del valor de la variable vinculada.

Desactivado: El texto se tomará de la matriz de reacción.

Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextFromVariable


ID_ELE_TEXT_TEXTSOURCE

Interne ID: ID_ELE_TEXT_TEXTSOURCE

Texto para mostrar

Selección del contenido de la lista desplegable que se mostrará durante el runtime:

  • Identificación de los recursos: Se mostrará el contenido de la propiedad de variables Identificación del equipo.
  • Texto del valor límite: Mientras no se viole ningún límite se mostrará el contenido de la propiedad de pantalla Texto. Si se viola un límite se mostrará el contenido de la propiedad de variables Texto del valor límite.
  • Unidad de medida: Se mostrará el contenido de la propiedad de variables Unidad.
  • Identificación de las variables: Se mostrará el contenido de la propiedad de variables Identificación.
  • Nombre de las variables: Se mostrará el contenido de la propiedad de variables Nombre:.
  • Valor de las variables: Se mostrará el valor de las variables.

Por defecto: Texto de valor límite

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextSource


ID_ELE_TEXT_TRANSLATE_TEXT

Interne ID: ID_ELE_TEXT_TRANSLATE_TEXT

Traducir texto de avido

Activado: Los textos que se vayan mostrar se traducirán. Cuando se está editando un texto se mostrará el borrador sin traducción.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TranslateText


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE

Cross Slide

Activado: Reconocimiento configurado para Cross Slide.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_CrossSlide


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_EXACT

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_EXACT

Cross Slide Exact

Activado: Reconocimiento configurado para Cross Slide Exact.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_CrossSlideExact


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_HORIZONTAL

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_HORIZONTAL

Cross Slide Horizontal

Activado: Reconocimiento configurado para Cross Slide Horizontal.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_CrossSlideHorizontal


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_REARRANGE

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_REARRANGE

Cross Slide Rearrange

Activado: Reconocimiento configurado para Cross Slide Rearrange.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_CrossSlideRearrange


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_SELECT

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_SELECT

Cross Slide Select

Activado: Reconocimiento configurado para Cross Slide Select.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_CrossSlideSelect


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_SPEED_BUMP

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_SPEED_BUMP

Cross Slide Speed Bump

Activado: Reconocimiento configurado para Cross Slide Speed Bump.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_CrossSlideSpeedBump


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_DRAG

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_DRAG

Drag

Activado: Reconocimiento configurado para Drag.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_Drag


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_HOLD

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_HOLD

Hold

Activado: Reconocimiento configurado para Hold.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_Hold


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_HOLD_MOUSE

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_HOLD_MOUSE

Hold (Mouse)

Activado: Reconocimiento configurado para Hold (Mouse).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_HoldMouse


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION

Manipulation

Activado: Reconocimiento configurado para Manipulation.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_Manipulation


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_EXACT

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_EXACT

Exact

Activado: Reconocimiento configurado para Exact.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_Exact


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_RAILS_X

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_RAILS_X

Rails X

Activado: Reconocimiento configurado para Rails X.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_RailsX


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_RAILS_Y

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_RAILS_Y

Rails Y

Activado: Reconocimiento configurado para Rails Y.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_RailsY


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_ROTATION

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_ROTATION

Rotation

Activado: Reconocimiento configurado para Rotation.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_Rotation


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_ROTATION_INERTIA

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_ROTATION_INERTIA

Rotation Inertia

Activado: Reconocimiento configurado para Rotation Inertia.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_RotationInertia


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_SCALING

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_SCALING

Scaling

Activado: Reconocimiento configurado para Scaling.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_Scaling


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_SCALING_INERTIA

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_SCALING_INERTIA

Scaling Inertia

Activado: Reconocimiento configurado para Scaling Inertia.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_ScalingInertia


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_TRANSLATION_INERTIA

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_TRANSLATION_INERTIA

Translation Inertia

Activado: Reconocimiento configurado para Translation Inertia.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_TranslationInertia


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_TRANSLATION_X

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_TRANSLATION_X

Translation X

Activado: Reconocimiento configurado para Translation X.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_TranslationX


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_TRANSLATION_Y

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_TRANSLATION_Y

Translation Y

Activado: Reconocimiento configurado para Translation Y.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_TranslationY


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_SECONDARY_TAP

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_SECONDARY_TAP

Secondary Tap

Activado: Reconocimiento configurado para Secondary Tap.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_SecondaryTap


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_TAP

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_TAP

Tap

Activado: Reconocimiento configurado para Tap.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_Tap


ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_TAP_DOUBLE

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_FLAG_TAP_DOUBLE

Tap Double

Activado: Reconocimiento configurado para Tap Double.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_TapDouble


ID_ELEMENT_INTERACTION_CONFIGURATION_GRP

Interne ID: ID_ELEMENT_INTERACTION_CONFIGURATION_GRP

Análisis de gestos VSTA

Propiedades para el análisis de gestos para elementos dinámicos con VSTA.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GestureRecognition


ID_ELEMENT_PROP_INTERACTION_ACTIVE

Interne ID: ID_ELEMENT_PROP_INTERACTION_ACTIVE

Reconocimiento de gestos activado

Activa el análisis de gestos. Los gestos se definen con otras propiedades.

Solo disponible cuando en las propiedades del proyecto del grupo Interacción para la propiedad Evaluación se haya establecido Windows 8.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GestureRecognitionActive


ID_ELESEG_END_ANGLE

Interne ID: ID_ELESEG_END_ANGLE

Ángulo final [°]

Fin del ángulo de apertura. El ángulo de apertura del segmento de círculo se mostrará entre el ángulo de inicio y el angulo final.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SegEndAngle


ID_ELESEG_OFFSET_ADJUSTABLE

Interne ID: ID_ELESEG_OFFSET_ADJUSTABLE

Grosor del segmento configurable

Grosor de segmento para el segmento de círculo. No disponible con Calidad gráfica Windows Basis, con Proyecto WindowsCE activado o con Gradiente de color Con valores de luminosidad.

Activado: El grosor de segmento de círculo se puede configurar individualmente.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OffsetAdjustable


ID_ELESEG_OFFSET_END

Interne ID: ID_ELESEG_OFFSET_END

Grosor del ángulo final [Píxel]

Grosor de segmento en el ángulo final desde el borde exterior de la elipse hasta el centro en píxeles. Sólo disponible si la propiedad Grosor del segmento configurable está activada y la propiedad El grosor final corresponde al grosor inicial está desactivada.

Mínima: 0 Píxel

Máximo: Valor menor de la mitad de la altura o la mitad de la anchura del elemento.

Por defecto: 0:00

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EndOffset


ID_ELESEG_OFFSET_END_EQUALS_START

Interne ID: ID_ELESEG_OFFSET_END_EQUALS_START

El grosor final corresponde al grosor inicial

Activado: Establece el grosor de segmento para el ángulo final con el mismo valor que el del ángulo inicial. Se desactivará la propiedad Grosor del ángulo final [Píxel]. Con ello se representará el elemento completo con un grosor de segmento uniforme. Solo disponible si la propiedad Grosor del segmento configurable está activada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OffsetEndEqualsStart


ID_ELESEG_OFFSET_GRP

Interne ID: ID_ELESEG_OFFSET_GRP

Espesor del segmento

Propiedades para el grosor de segmento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SegmentOffsets


ID_ELESEG_OFFSET_START

Interne ID: ID_ELESEG_OFFSET_START

Grosor del ángulo inicial [Píxel]

Grosor de segmento en el ángulo inicial desde el borde exterior de la elipse hasta el centro en píxeles. Solo disponible si la propiedad Grosor del segmento configurable está activada.

Mínima: 0 Píxel

Máximo: Valor menor de la mitad de la altura o la mitad de la anchura del elemento.

Por defecto: 0:00

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StartOffset


ID_ELESEG_START_ANGLE

Interne ID: ID_ELESEG_START_ANGLE

Ángulo de inicio [°]

Inicio del ángulo de apertura. El ángulo de apertura del segmento de círculo se mostrará entre el ángulo de inicio y el angulo final.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SegStartAngle


ID_ELREST_DEVPARAM

Interne ID: ID_ELREST_DEVPARAM

Device parameter

Las propiedades siguientes sirven para direccionar el driver ELREST32.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Device parameter


ID_EMS_PROP0

Interne ID: ID_EMS_PROP0

Nombre:

Eindeutige Bezeichnung zur Identifizierung von Geräten, Gebieten und Anlagen im Administración de la carga.

Achtung: Namen sollten über alle Netze/Versorgungsgebiete im Administración de la carga eindeutig sein.

Mehr im Online Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_EMS_PROP1

Interne ID: ID_EMS_PROP1

Descripción

Entrada opcional de un nombre largo o una descripción detallada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Longtext


ID_EMS_PROP2

Interne ID: ID_EMS_PROP2

Consumo ajustado

Variable a la que se envía el consumo de grupo, depurada de los valores de apagado de las máquinas y de la utilización de los depósitos. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AdjConsumption


ID_EMS_PROP3

Interne ID: ID_EMS_PROP3

Estimación

Variable a la que se envía el consumo previsto del grupo. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GasPrognosis


ID_EMS_PROP4

Interne ID: ID_EMS_PROP4

Carga optimal

Variable a la que se envía el resultado de la distribución de la carga para el grupo. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OptimumLoad


ID_EMS_PROP5

Interne ID: ID_EMS_PROP5

Velocidad del viento

Variable para el valor de la velocidad del viento. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Wind


ID_EMS_PROP6

Interne ID: ID_EMS_PROP6

Temperatura

Variable para el valor de la temperatura. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Temp


ID_EMS_PROP7

Interne ID: ID_EMS_PROP7

Días característicos

Variable para el reconocimiento de los días (laborables o festivos). Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Days


ID_EMS_PROP8

Interne ID: ID_EMS_PROP8

Consumo total actual

Variable que contiene el valor actual del consumo del área. El valor debe representar la diferencia del contador por unidad de tiempo de la suma del consumo del área de suministro. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Atención: Compruebe que el valor se transmite de forma cíclica, ya que dicho valor origina el cálculo de optimización.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ActValue


ID_EMS_PROP9

Interne ID: ID_EMS_PROP9

Promedio de consumo actual

Variable del proceso con el valor actual medio de consumo (resultante de los valores registrados). Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ActMean


ID_EMS_PROP10

Interne ID: ID_EMS_PROP10

Consumo final estimado

Variable que contiene el valor final de la previsión al final del periodo de facturación. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ProgEndValue


ID_EMS_PROP11

Interne ID: ID_EMS_PROP11

Valor inicial de la estimación

Variable que contiene el valor inicial de la previsón al principio del periodo de previsión. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ProgStartValue


ID_EMS_PROP12

Interne ID: ID_EMS_PROP12

Último valor de conmutación

Variable que contiene la suma de los valores de suministro medios para los que se han planificado conmutaciones en el periodo actual. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Atención: Esta variable debe estar configurada para el Driver interno para asegurar su buen funcionamiento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LastSwitchValue


ID_EMS_PROP13

Interne ID: ID_EMS_PROP13

Primer valor de conmutación

Variable que contiene el valor calculado de los recursos en el cual se ejecutará la próxima conmutación. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Atención: Esta variable debe estar configurada para el Driver interno para asegurar su buen funcionamiento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FirstSwitchValue


ID_EMS_PROP14

Interne ID: ID_EMS_PROP14

Margen de error estimado

Variable que contiene el posible error de previsión del valor final de la previsión. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ProgChannelValue


ID_EMS_PROP15

Interne ID: ID_EMS_PROP15

Promedio estimado

Variable que contiene el actual valor medio de la previsión real. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ProgMean


ID_EMS_PROP16

Interne ID: ID_EMS_PROP16

Promedio del margen de error estimado

Variable que contiene el posible error de previsión del valor medio de la previsión real. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ProgChannelMean


ID_EMS_PROP17

Interne ID: ID_EMS_PROP17

Límite de referencia

Variable que contiene el límite actual configurado del límite de la capacidad de suministro. Cuando su valor cambia durante el tiempo de ejecución, se cambiará también el límite de la capacidad de suministro para un periodo de facturación. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Limit


ID_EMS_PROP18

Interne ID: ID_EMS_PROP18

Límite de suministro adaptado

Variable con límite de la capacidad de suministro ajustado (corregido por exceso) al haberse excedido el límite del periodo anterior. Si el límite de la capacidad de suministro se sobrepasa en un periodo, dicho límite se aumentará en la medida del exceso.

Si no vincula ninguna variable, no se aumentará el límite de la capacidad de suministro después de un exceso.

Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AdjustedLimit


ID_EMS_PROP19

Interne ID: ID_EMS_PROP19

Desviación actual en bruto

Variable para la desviación media de la previsión real. Refleja la diferencia entre el valor medio previsto para la previsión real y el límite de la capacidad de suministro. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DeviationActual


ID_EMS_PROP20

Interne ID: ID_EMS_PROP20

Desviación actual en neto

Variable para la desviación media de la previsión del valor actual. Refleja la diferencia entre el valor medio previsto para la previsión del valor actual y el límite de la capacidad de suministro. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DeviationReal


ID_EMS_PROP21

Interne ID: ID_EMS_PROP21

Cambio de día

Uhrzeit, zu der das Administración de la carga einen Tageswechsel vornimmt. Diese Einstellung ist für alle Geräte wichtig, deren maximale Schalthäufigkeit pro Zeitheit 24 Stunden überschreitet. Der Tageszähler wird normalerweise um 00 Uhr zurückgesetzt. Mit dieser Einstellung passiert das Rücksetzen zu einer anderen definierten Uhrzeit.

Maximalwert: 23:59:59

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DayChangeover


ID_EMS_PROP22

Interne ID: ID_EMS_PROP22

Periodo de facturación

Duración de un periodo de facturación en hh:mm:ss. El facturación tendencial y la optimización utilizan este tiempo como horizonte de cálculo. Generalmente se utilizan como valores 15, 30 ó 60 minutos.

Valor máximo: 23:59:59

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ForecastHorizon


ID_EMS_PROP23

Interne ID: ID_EMS_PROP23

Activar hiséresis [%]

Define el área de la histéresis con el porcentaje, en el que no se deberán conectar las cargas para que se mantenga la Distancia de seguridad [%] con el límite de suministro.

Por defecto: 0

Atención: Cuando el área es demasiado grande se pueden llegar a superar los límites de suministro.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HysteresisOn


ID_EMS_PROP24

Interne ID: ID_EMS_PROP24

Desactivar histéresis [%]

Define el área de la histéresis con el porcentaje, en el que no se deberán conectar las cargas para que se mantenga la Distancia de seguridad [%] con el límite de suministro.

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HysteresisOff


ID_EMS_PROP25

Interne ID: ID_EMS_PROP25

Distancia de seguridad [%]

Distancia de seguridad a los límites de suministro en porcentaje. Las propiedades Activar hiséresis [%] y Desactivar histéresis [%] afectan a la distancia de seguridad.

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SafetyClearance


ID_EMS_PROP26

Interne ID: ID_EMS_PROP26

Ciclo de optimización

Ciclo en hh:mm:ss en el que se calcula la optimización a corto plazo. La pantalla mostrada se actualiza después de cada optimización, como mínimo una vez cada ciclo.

Por defecto: 0:00:30

Valor máximo: 23:59:59

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OptCycle


ID_EMS_PROP27

Interne ID: ID_EMS_PROP27

Tiempo muerto inicio del intervalo de tarifas

Tiempo en hh:mm:ss al principio de un intervalo de facturación. Durante este periodo no se realizará ninguna conmutación por parte de la optimización, debido a que los resultados de las previsiones son todavía poco precisos.

Por defecto: 00:00:00

Valor máximo: 23:59:59

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DeadLength


ID_EMS_PROP37

Interne ID: ID_EMS_PROP37

Proporción máx. gas líquido/suministro

Sólo disponible si existe por lo menos una planta de gas líquido en el área de suministro.

Defina la cantidad de gas máxima que pueden utilizar las máquinas del depósito de gas líquido. Introduzca la cantidad como relación entre el gas existente en el depósito de gas líquido y el que consume la máquina.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxLqGasDelivery


ID_EMS_PROP38

Interne ID: ID_EMS_PROP38

Proporción mín. de gas líquido/suministro

Sólo disponible si existe por lo menos una planta de gas líquido en el área de suministro.

Defina la cantidad de gas mínima que tienen que utilizar las máquinas del depósito del gas líquido. Introduzca la cantidad como relación entre el gas existente en el depósito de gas líquido y el que consume la máquina.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MinLqGasDelivery


ID_EMS_PROP39

Interne ID: ID_EMS_PROP39

Error de estimación por exceso

Variable para el error de previsión por exceso. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UpperErrorBound


ID_EMS_PROP40

Interne ID: ID_EMS_PROP40

Error de estimación por defecto

Variable para el error de previsión por defecto. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LowerErrorBound


ID_EMS_PROP41

Interne ID: ID_EMS_PROP41

Consumo actual

Variable a la que se envía el consumo actual de grupo con las desconexiones de las máquinas. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Consumption


ID_EMS_PROP42

Interne ID: ID_EMS_PROP42

Energía diaria

Variable para el consumo de grupo para el periodo de facturación del día. Actúa como variable marcador para los archivos futuros. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DayEnergy


ID_EMS_PROP44

Interne ID: ID_EMS_PROP44

Disponibilidad

Variable, die angibt, ob der Erzeuger für das Administración de la carga verfügbar ist, und somit geschalten werden kann. Ist die Verfügbarkeit gegeben, verbleibt der Erzeuger in seinem zuletzt gültigen Schaltzustand. Öffnen Sie mit einem Klick auf die Schaltfläche den Dialog zur Variablenauswahl.

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Active


ID_EMS_PROP45

Interne ID: ID_EMS_PROP45

Retraso de encendido

Zeit in hh:mm:ss, die der Erzeuger zum Einschalten benötigt. Die Leistung des Gerätes steht dem Administración de la carga erst nach Ablauf der Zeit zur Verfügung.

Maximalwert: 23:59:59

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OnDelay


ID_EMS_PROP46

Interne ID: ID_EMS_PROP46

Retraso del apagado

Zeit in hh:mm:ss, die der Erzeuger zum Einschalten benötigt. Die Leistung des Gerätes steht dem Administración de la carga erst nach Ablauf der Zeit zur Verfügung.

Maximalwert: 23:59:59

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OffDelay


ID_EMS_PROP47

Interne ID: ID_EMS_PROP47

Preaviso activado

Variable para el preaviso cuando se enciende una máquina. Se establecerá un preaviso según el Tiempo del aviso previo configurado. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WarnOn


ID_EMS_PROP48

Interne ID: ID_EMS_PROP48

Preaviso desactivado

Variable para el preaviso cuando se apaga una máquina. Se establecerá un preaviso según el Tiempo del aviso previo configurado. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WarnOff


ID_EMS_PROP50

Interne ID: ID_EMS_PROP50

Estado de conmutación

Variable que informa sobre el estado de conmutación actual de la máquina (ON o OFF). Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

State


ID_EMS_PROP51

Interne ID: ID_EMS_PROP51

Encender

Variable para encender la máquina. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SwitchOn


ID_EMS_PROP52

Interne ID: ID_EMS_PROP52

Apagar

Variable para apagar la máquina. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SwitchOff


ID_EMS_PROP55

Interne ID: ID_EMS_PROP55

Potencia actual

Proporciona el valor de medición del consumo actual de una planta de cogeneración. Este valor debe corresponder siempre a un nivel de conmutación definido para que pueda ser procesado correctamente. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Consumption


ID_EMS_PROP56

Interne ID: ID_EMS_PROP56

{Hora de bloqueo nueva}

Crea un tiempo de bloqueo nuevo. Para ello pulse sobre el campo o sobre el botón. A los tiempos de bloqueo se les asigna junto a su nombre de "Tiempo de bloqueo" un número consecutivo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NewLock


ID_EMS_PROP57

Interne ID: ID_EMS_PROP57

{Eliminar hora de bloqueo}

Elimina el tiempo de bloqueo correspondiente después de una pregunta de seguridad. Para ello pulse sobre el campo o sobre el botón. La numeración consecutiva de los siguientes tiempos de bloqueo se ajustará reduciendo un nivel.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DelLock


ID_EMS_PROP58

Interne ID: ID_EMS_PROP58

Inicio

Comienzo del tiempo de bloqueo en formato hh:mm:ss.

Valor máximo: 23:59:59

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LockStart


ID_EMS_PROP59

Interne ID: ID_EMS_PROP59

Fin

Fin del tiempo de bloqueo en formato hh:mm:ss.

Valor máximo: 23:59:59

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LockStop


ID_EMS_PROP60

Interne ID: ID_EMS_PROP60

Tipo

Establece qué acciones están prohibidas durante el tiempo de bloqueo:

  • Off: No se puede apagar durante el tiempo de bloqueo.
  • On: No se puede encender durante el tiempo de bloqueo.
  • Ambos: No se puede ni encender ni apagar durante el tiempo de bloqueo.

Por defecto: Ambos

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LockType


ID_EMS_PROP61

Interne ID: ID_EMS_PROP61

Tiempo de encendido mínimo

Minimale Zeit in hh:mm:ss, die der Erzeuger nach dem Schalten auf Spitzenleistung eingeschaltet bleiben muss. Erst nach Ablauf dieser Zeit wird der Erzeuger vom Administración de la carga wieder für Abschaltvorgänge berücksichtigt.

Maximalwert: 23:59:59

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MinOn


ID_EMS_PROP62

Interne ID: ID_EMS_PROP62

Tiempo de encendido máximo

Maximale Zeit in hh:mm:ss, die der Erzeuger nach dem Schalten auf Spitzenleistung eingeschalten bleiben kann. Nach Ablauf der Zeit wird der Erzeuger vom Administración de la carga automatisch abgeschaltet, selbst wenn dies zu einem Überschreiten der Bezugsgrenze führen sollte.

Maximalwert: 23:59:59

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxOn


ID_EMS_PROP63

Interne ID: ID_EMS_PROP63

Hora de apagado mínima

Minimale Zeit in hh:mm:ss, die der Erzeuger nach dem Abschalten in diesem Zustand bleiben muss. Erst nach Ablauf dieser Zeit wird der Erzeuger vom Administración de la carga wieder für Einschaltvorgänge berücksichtigt.

Maximalwert: 23:59:59

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MinOff


ID_EMS_PROP64

Interne ID: ID_EMS_PROP64

Hora de apagado máxima

Maximale Zeit in hh:mm:ss, die der Erzeuger nach dem Abschalten in diesem Zustand bleiben kann. Nach Ablauf der Zeit wird der Erzeuger vom Administración de la carga automatisch eingeschaltet, unabhängig davon, ob die aktuelle Bezugsgrenze überschritten ist.

Maximalwert: 23:59:59

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxOff


ID_EMS_PROP67

Interne ID: ID_EMS_PROP67

Tiempo del aviso previo

Tiempo en hh:mm:ss necesario para el preaviso de una conmutación. Mediante la variable Preaviso de conmutación el sistema puede emitir un preaviso al usuario para que esté informado antes de que se produzca la conmutación.

Valor máximo: 23:59:59

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Warn


ID_EMS_PROP68

Interne ID: ID_EMS_PROP68

Frecuencia máxima de conmutación

Número máximo de conmutaciones Por unidad de tiempo. El encendido y el apagado se tienen en cuenta como dos conmutaciones diferentes. El cambio de potencia nominal a potencia máxima también se tiene en cuenta como una conmutación.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxSwitch


ID_EMS_PROP69

Interne ID: ID_EMS_PROP69

Por unidad de tiempo

Unidad de tiempo en hh:mm:ss para la Frecuencia máxima de conmutación.

Valor máximo: 23:59:59

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SwitchUnit


ID_EMS_PROP70

Interne ID: ID_EMS_PROP70

Determinar capacidad

Seleccione de la lista desplegable cómo se debe determinar de la potencia.

  • por defecto: El consumo de energía se determina a través de la potencia nominal. Este valor se determina de manera fija.
  • medido: El consumo actual de energía se determina a través de la variable de Potencia actual.

Por defecto: por defecto

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PowerType


ID_EMS_PROP71

Interne ID: ID_EMS_PROP71

Potencia en stanby

Introduzca aquí la potencia nominal del generador.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Power


ID_EMS_PROP72

Interne ID: ID_EMS_PROP72

Variable de la capacidad en standby

Este valor de la variable sobreescribe durante el tiempo de ejecución el valor fijo configurado para la potencia nominal. Así se puede ajustar la potencia actual de un generador durante el tiempo de ejecución, por ejemplo cuando se registra que la potencia rebasa una medida determinada. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PowerVar


ID_EMS_PROP73

Interne ID: ID_EMS_PROP73

Prioridad de encendido

Legt die Priorität für das Einschalten des Geräts fest. Je größer der Wert, desto höher die Priorität. Geräte mit höherer Priorität werden zuerst vom Administración de la carga berücksichtigt.

Minimum: 0

Maximum: 32000

Default: 0

Mehr im Online-Handbuch..

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OnPrio


ID_EMS_PROP74

Interne ID: ID_EMS_PROP74

Prioridad de apagado

Legt die Priorität zum Ausschalten des Geräts fest. Je größer der Wert, desto höher die Priorität. Geräte mit höherer Priorität werden zuerst vom Administración de la carga berücksichtigt.

Minimum: 0

Maximum: 32000

Default: 0

Mehr im Online-Handbuch..

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OffPrio


ID_EMS_PROP75

Interne ID: ID_EMS_PROP75

Proporción del grupo [%]

Porcentaje de la potencia de la máquina respecto a la potencia total del grupo de máquinas.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GroupShare


ID_EMS_PROP76

Interne ID: ID_EMS_PROP76

Ganancia [€/kWh]/Prioridad

Beneficio de la máquina en € por kwh o prioridad de conmutación.

Esta función calcula con un total de 7 cifras, independientemente de que se encuentren delante o detrás de la coma decimal.

Valor máximo: 9999999

Valor mínimo: 0.000001

Por defecto: 1.000000

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Revenue


ID_EMS_PROP77

Interne ID: ID_EMS_PROP77

Temperatura mín. [°C]

Temperatura mínima. Por debajo de esta temperatura no se debe utilizar la máquina.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MinTemp


ID_EMS_PROP78

Interne ID: ID_EMS_PROP78

Temperatura máx. [°C]

Temperatura máxima en °C. Por encima de esta temperatura no se debe utilizar la máquina.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxTemp


ID_EMS_PROP79

Interne ID: ID_EMS_PROP79

Máxima potencia

Introduzca aquí la potencia máxima deseada. El módulo EMS puede cambiar del valor de la potencia nominal a la potencia máxima. El valor del suministro se reducirá en la diferencia de la potencia conectada.

Cuando el generador sólo dispone de una potencia conectable y no hay por lo tanto una potencia básica, entonces sólo hay que configurar la potencia máxima del generador.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PeakPower


ID_EMS_PROP80

Interne ID: ID_EMS_PROP80

Preaviso de conmutación

Define la variable que avisa a los usuarios de una operación de encendido para las conmutaciones correspondientes a la variable Tiempo del aviso previo. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WarnSwitch


ID_EMS_PROP83

Interne ID: ID_EMS_PROP83

Cambiar a standby

Variable de comando que cambia a Standby. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SwitchOff


ID_EMS_PROP84

Interne ID: ID_EMS_PROP84

Encender a máxima potencia

Variable de comando para conmutaciones a la máxima potencia. Por regla general se conmuta de la potencia nominal a la máxima potencia. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SwitchOn


ID_EMS_PROP86

Interne ID: ID_EMS_PROP86

Estado de conmutación

Variable a la que se envía el estado actual de conmutación del generador (ON o OFF). Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

State


ID_EMS_PROP87

Interne ID: ID_EMS_PROP87

Plan de capacidad

Define la variable del horario de encendido para los valores de potencia predeterminados. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PowerPlan


ID_EMS_PROP88

Interne ID: ID_EMS_PROP88

Horario de encendido

Define la variable del plan para las conmutaciones. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Schedule


ID_EMS_PROP89

Interne ID: ID_EMS_PROP89

Nivel actual de llenado

Variable a la que se envía el nivel de llenado actual del depósito de gas. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ActualLevel


ID_EMS_PROP90

Interne ID: ID_EMS_PROP90

Capacidad de vaciado como objetivo

Variable con el valor predeterminado de la capacidad de vaciado. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WithdrawalSet


ID_EMS_PROP91

Interne ID: ID_EMS_PROP91

Capacidad actual de vaciado

Variable a la que se envía el valor actual de la capacidad de vaciado. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WidthdrawalActual


ID_EMS_PROP92

Interne ID: ID_EMS_PROP92

Nivel mínimo de llenado como objetivo

Variable predeterminada con el valor límite del nivel de llenado mínimo. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MinSetLevel


ID_EMS_PROP93

Interne ID: ID_EMS_PROP93

Valor umbral para la desviación del valor de llenado

Histéresis para los valores de nivel de llenado.

Esta función calcula con un total de 7 cifras, independientemente de que se encuentren delante o detrás de la coma decimal.

Valor máximo: 9999999

Valor mínimo: 0.000000

Por defecto: 0.000000

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Threshold


ID_EMS_PROP94

Interne ID: ID_EMS_PROP94

Nivel máx. de llenado [kWh]

Maximaler Füllstand des Gasspeichers in kWh. Dieser Wert darf durch das Administración de la carga nicht überschritten werden.

Die Funktion rechnet mit insgesamt 7 Stellen, unabhängig davon, ob sie sich vor oder hinter dem Dezimalpunkt befinden.

Maximalwert: 9999999

Minimalwert: 0.000000

Default: 0.000000

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxLevel


ID_EMS_PROP95

Interne ID: ID_EMS_PROP95

Nivel de llenado mínimo [kWh]

Minimaler Füllstand des Gasspeichers in kWh. Dieser Wert darf durch das Administración de la carga nicht unterschritten werden.

Die Funktion rechnet mit insgesamt 7 Stellen, unabhängig davon, ob sie sich vor oder hinter dem Dezimalpunkt befinden.

Maximalwert: 9999999

Minimalwert: 0.000000

Default: 0.000000

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MinLevel


ID_EMS_PROP96

Interne ID: ID_EMS_PROP96

Capacidad máxima de vaciado [kWh]

Capacidad máxima de vaciado del depósito de gas en kwh.

Esta función calcula con un total de 7 cifras, independientemente de que se encuentren delante o detrás de la coma decimal.

Valor máximo: 9999999

Valor mínimo: 0.000000

Por defecto: 0.000000

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxWithdrawal


ID_EMS_PROP97

Interne ID: ID_EMS_PROP97

Costes básicos [€/kWh]

Beneficio del depósito de gas en € por kwh.

Esta función calcula con un total de 7 cifras, independientemente de que se encuentren delante o detrás de la coma decimal.

Valor máximo: 9999999

Valor mínimo: 0.000001

Por defecto: 1.000000

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BaseCosts


ID_EMS_PROP98

Interne ID: ID_EMS_PROP98

Costes de penalización [€/kWh]

Costes de penalización del depósito de gas en € por kwh.

Esta función calcula con un total de 7 cifras, independientemente de que se encuentren delante o detrás de la coma decimal.

Valor máximo: 9999999

Valor mínimo: 0.000000

Por defecto: 1.000000

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Penalty


ID_EMS_PROP99

Interne ID: ID_EMS_PROP99

Capacidad máxima de inyección [kWh]

Capacidad máxima de llenado del depósito de gas en kwh.

Esta función calcula con un total de 7 cifras, independientemente de que se encuentren delante o detrás de la coma decimal.

Valor máximo: 9999999

Valor mínimo: 0.000000

Por defecto: 0.000000

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxInjection


ID_EMS_PROP100

Interne ID: ID_EMS_PROP100

Almacenamiento de tuberías

activado: Este depósito de gas es un depósito de tuberías.

Para que en el área de suministro se pueda crear un depósito de gas líquido hay que definir previamente un depósito de tuberías.

Atención: Por cada área de suministro sólo se puede definir un depósito de tuberías.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Netzspeicher


ID_EMS_PROP101

Interne ID: ID_EMS_PROP101

Nivel máx. de llenado en el depósito de la red para el vaciado

Nivel de llenado máximo en el depósito de la red para vaciado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxPressure


ID_EMS_PROP102

Interne ID: ID_EMS_PROP102

Administración de carga iniciada para área de suministro

Variable, die zur Laufzeit angibt, ob das im Administración de la carga Bild angezeigte Versorgungsgebiet aktiviert wurde. Die Aktivierung erfolgt über eine Funktion. Die Variable muss vom Typ BOOL sein. Öffnen Sie mit einem Klick auf die Schaltfläche den Dialog zur Variablenauswahl.

Mehr im Online Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Running


ID_EMS_PROP103

Interne ID: ID_EMS_PROP103

Variable de prioridad de encendido

Variable que ajusta dinámicamente la prioridad de encendido del dispositivo durante el tiempo de ejecución . Así puede p.ej. dependiendo de la temperatura exterior, cambiar el orden de los generadores en la jerarquía del EMS. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OnPrioVar


ID_EMS_PROP104

Interne ID: ID_EMS_PROP104

Variable de prioridad de apagado

Variable, die die Ausschaltpriorität des Geräts während der Laufzeit dynamisch anpasst. Damit können z.B. Erzeuger in Abhängigkeit von einer Außentemperatur in der Administración de la carga Hierarchie umgereiht werden. Öffnen Sie mit einem Klick auf die Schaltfläche den Dialog zur Variablenauswahl.

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OffPrioVar


ID_EMS_PROP105

Interne ID: ID_EMS_PROP105

Estado de conmutación interno

Variable en la que se reflejan los diferentes estados de los dispositivos. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DispoStatus


ID_EMS_PROP106

Interne ID: ID_EMS_PROP106

Variable del tiempo de encendido mínimo

Variable que ajusta el tiempo mínimo de encendido durante el tiempo de ejecución. Un valor existente en el runtime sobreescribe el valor configurado en la proyección. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MinOnVar


ID_EMS_PROP107

Interne ID: ID_EMS_PROP107

Variable del tiempo máximo de encendido

Variable que ajusta el tiempo máximo de encendido durante el tiempo de ejecución. Un valor existente en el runtime sobreescribe el valor configurado en la proyección. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxOnVar


ID_EMS_PROP108

Interne ID: ID_EMS_PROP108

Variable del tiempo de apagado mínimo

Variable que ajusta el tiempo mínimo de apagado durante el tiempo de ejecución. Un valor existente en el runtime sobreescribe el valor configurado en la proyección. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MinOffVar


ID_EMS_PROP109

Interne ID: ID_EMS_PROP109

Variable del tiempo máximo de apagado

Variable que ajusta el tiempo máximo de apagado durante el tiempo de ejecución. Un valor existente en el runtime sobreescribe el valor configurado en la proyección. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxOffVar


ID_EMS_PROP110

Interne ID: ID_EMS_PROP110

{Nivel nuevo}

Crea un nuevo nivel de conmutación. Para ello pulse sobre el campo o sobre el botón. A los niveles de conmutación se les asigna junto al nombre "Nivel de conmutación" un número consecutivo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NewStufe


ID_EMS_PROP111

Interne ID: ID_EMS_PROP111

{Eliminar nivel}

Elimina el nivel de conmutación actual. Para ello pulse sobre el campo o sobre el botón. La numeración consecutiva de los siguientes niveles de conmutación se ajustará reduciendo un nivel.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DelGrade


ID_EMS_PROP112

Interne ID: ID_EMS_PROP112

Potencia del paso

Potencia del nivel de conmutación. La potencia posterior durante el tiempo de ejecución deber corresponder exactamente a uno de los valores definidos en los niveles de conmutación.

Por defecto: 0.000000

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GradePower


ID_EMS_PROP113

Interne ID: ID_EMS_PROP113

Variable de la potencia del paso

Variable con la que se puede ajustar dinámicamente la potencia de un nivel de conmutación en una planta de cogeneración durante el runtime. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GradePowerVar


ID_EMS_PROP114

Interne ID: ID_EMS_PROP114

Tiempo del aviso previo

Tiempo en hh:mm:ss necesario para el preaviso de una conmutación. Mediante la variable Preaviso activado o Preaviso desactivado el sistema puede enviar un preaviso al usuario. El usuario será informado antes de que la conmutación tenga efectivamente lugar .

Valor máximo: 23:59:59

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GradeWarn


ID_EMS_PROP115

Interne ID: ID_EMS_PROP115

Preaviso activado

Define la variable que avisa a los usuarios de una operación de encendido para las conmutaciones correspondientes al Tiempo del aviso previo. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GradeWarnOn


ID_EMS_PROP116

Interne ID: ID_EMS_PROP116

Preaviso desactivado

Define la variable que avisa a los usuarios de una operación de apagado para las conmutaciones correspondientes a la variable Tiempo del aviso previo. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GradeWarnOff


ID_EMS_PROP117

Interne ID: ID_EMS_PROP117

Retraso de encendido

Zeit in hh:mm:ss, die das BHKW zum Einschalten benötigt. Die Leistung des Gerätes steht dem Administración de la carga erst nach Ablauf dieser Zeit zur Verfügung.

Maximalwert: 23:59:59

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GradeOnDelay


ID_EMS_PROP118

Interne ID: ID_EMS_PROP118

Retraso del apagado

Tiempo en hh:mm:ss necesario para el apagado de la planta de cogeneración. Se producirá una caída de la potencia después del vencimiento del tiempo fijado.

Valor máximo: 23:59:59

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GradeOffDelay


ID_EMS_PROP119

Interne ID: ID_EMS_PROP119

Tiempo de encendido mínimo

Minimale Zeit in hh:mm:ss, die das BHKW nach dem Schalten auf Spitzenleistung eingeschaltet bleiben muss. Erst nach Ablauf dieser Zeit wird der Erzeuger vom Administración de la carga wieder für Abschaltvorgänge berücksichtiigt.

Maximalwert: 23:59:59

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GradeMinOn


ID_EMS_PROP120

Interne ID: ID_EMS_PROP120

Tiempo de encendido máximo

Maximale Zeit in hh:mm:ss, die das BHKW nach dem Schalten auf Spitzenleistung eingeschalten bleiben kann. Nach Ablauf der Zeit wird der Erzeuger vom Administración de la carga automatisch abgeschalten, selbst wenn diese zu einem Überschreiten der Bezugsgrenze führen sollte.

Maximalwert: 23:59:59

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GradeMaxOn


ID_EMS_PROP121

Interne ID: ID_EMS_PROP121

Variable de valor predeterminado

Variable global de valores predeterminados que enciende/apaga la planta de cogeneración. Los valores individuales o las variables de los niveles de potencia sirven únicamente para indicar el nivel de potencia. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SetValue


ID_EMS_PROP122

Interne ID: ID_EMS_PROP122

Histéresis

Die Hysterese definiert den erlaubten Bereich, in dem der aktuelle Wert noch einer der Schaltstufen zugeordnet werden kann. Liegt ein Verbrauchswert nicht innerhalb der Hysterese einer der projektierten Schaltstufen, gilt das BHKW für das Administración de la carga als inaktiv.

Default: 0

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Hysteresis


ID_EMS_PROP123

Interne ID: ID_EMS_PROP123

Conmutaciones previstas

Ermöglicht die Verknüpfung einer String-Variablen, die alle geplanten Schalthandlungen aus dem Administración de la carga erhält. Klick auf die Schaltfläche ... öffnet Dialog zur Variablenauswahl.

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ScheduledActions


ID_EMS_PROP124

Interne ID: ID_EMS_PROP124

Potencia

Potencia nominal de la máquina en kw.

Este valor puede ajustarse dinámicamente durante el tiempo de ejecución asignando a una variable la propiedad Variable de potencia.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Power


ID_EMS_PROP125

Interne ID: ID_EMS_PROP125

Variable de potencia

La potencia actual consumida por una máquina se puede ajustar durante el tiempo de ejecución con una variable, p. ej. cuando se registra que la potencia sobrepasa un determinado punto de medición. Este valor de la variable sobreescribe durante el tiempo de ejecución el valor fijo determinado de Potencia. Abra el diálogo para elegir la variable haciendo clic sobre el botón.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PowerVar


ID_EMS_PROP127

Interne ID: ID_EMS_PROP127

Prioridades como factor primario

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PrimaryPrio


ID_EMS_PROP128

Interne ID: ID_EMS_PROP128

Prioridades como factor primario activo

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PrioAsPrimary


ID_EMS_PROP129

Interne ID: ID_EMS_PROP129

{Nivel nuevo}

Description as text.

Esta función se invocará para zenon API (con nombre de clase):

NewStufe


ID_EMS_PROP130

Interne ID: ID_EMS_PROP130

Variable de valor predeterminado

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SetValue


ID_EMS_PROP131

Interne ID: ID_EMS_PROP131

Potencia actual

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Consumption


ID_EMS_PROP132

Interne ID: ID_EMS_PROP132

Histéresis

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Hysteresis


ID_EMS_PROP133

Interne ID: ID_EMS_PROP133

Prioridad de encendido

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OnPrio


ID_EMS_PROP134

Interne ID: ID_EMS_PROP134

Variable de prioridad de encendido

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OnPrioVar


ID_EMS_PROP135

Interne ID: ID_EMS_PROP135

Prioridad de apagado

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OffPrio


ID_EMS_PROP136

Interne ID: ID_EMS_PROP136

Variable de prioridad de apagado

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OffPrioVar


ID_EMS_PROP137

Interne ID: ID_EMS_PROP137

{Eliminar nivel}

Description as text.

Esta función se invocará para zenon API (con nombre de clase):

DelGrade


ID_EMS_PROP138

Interne ID: ID_EMS_PROP138

Potencia del paso

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GradePower


ID_EMS_PROP139

Interne ID: ID_EMS_PROP139

Variable de la potencia del paso

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GradePowerVar


ID_EMS_PROP140

Interne ID: ID_EMS_PROP140

Retraso de encendido

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GradeOnDelay


ID_EMS_PROP141

Interne ID: ID_EMS_PROP141

Retraso del apagado

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GradeOffDelay


ID_EMS_PROP142

Interne ID: ID_EMS_PROP142

Tiempo de encendido mínimo

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GradeMinOn


ID_EMS_PROP143

Interne ID: ID_EMS_PROP143

Tiempo de encendido máximo

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GradeMaxOn


ID_EMS_PROP144

Interne ID: ID_EMS_PROP144

Tiempo del aviso previo

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GradeWarn


ID_EMS_PROP145

Interne ID: ID_EMS_PROP145

Preaviso activado

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GradeWarnOn


ID_EMS_PROP146

Interne ID: ID_EMS_PROP146

Preaviso desactivado

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GradeWarnOff


ID_EMS_PROP_GRP0

Interne ID: ID_EMS_PROP_GRP0

General

Propiedades generales para los niveles de Administración de la carga.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_EMS_PROP_GRP1

Interne ID: ID_EMS_PROP_GRP1

Valores de entrada

Configuraciones para todos los valores actuales y límites del suministro.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_InputValues


ID_EMS_PROP_GRP2

Interne ID: ID_EMS_PROP_GRP2

Parámetro de gas específico

Estas propiedades están sólo disponibles para redes, áreas de suministro y grupos de máquinas de redes de gas.

Estos parámetros influyen en la elección de los dispositivos que se conectan automáticamente para optimizar.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_GasParameters


ID_EMS_PROP_GRP4

Interne ID: ID_EMS_PROP_GRP4

Tiempos de bloqueo

A través de rangos de tiempo libremente definibles se pueden excluir de la optimización dispositivos individuales del Administración de la carga. Los dispositivos con un tiempo de bloqueo definido no se tendrán en cuenta por el Administración de la carga durante ese tiempo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Locks


ID_EMS_PROP_GRP6

Interne ID: ID_EMS_PROP_GRP6

Pasos de conmutación

Estas propiedades están sólo disponibles para generadores de redes eléctricas.

Las plantas modulares de cogeneración se diferencian de los generadores estándar en que tienen niveles de conmutación predefinidos. Una planta modular de cogeneración sólo acepta los valores de potencia que estén predefinidos como niveles de conmutación. El Administración de la carga sólo puede cambiar de un nivel de conmutación al siguiente superior o inferior.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Schaltstufen


ID_EMS_PROP_GRP9

Interne ID: ID_EMS_PROP_GRP9

Valores calculados

Mit Hilfe von Prozessvariablen können wichtige Parameter für die Prognose und Optimierung während der Laufzeit angepasst werden. Damit können abhängig von Messwerten wichtige Administración de la carga Parameter wie zum Beispiel Schaltprioritäten an den aktuellen Prozess angepasst werden.

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_CalculatedValues


ID_EMS_PROP_GRP10

Interne ID: ID_EMS_PROP_GRP10

Parámetro

Estas configuraciones influyen de manera fundamental en la optimización del área de suministro seleccionada. Las modificaciones de estos parámetros influyen directamente en las operaciones de conmutación previstas automáticamente por el Administración de la carga.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Parameters


ID_EMS_PROP_GRP11

Interne ID: ID_EMS_PROP_GRP11

Tiempos de conmutación

Con ayuda de estos parámetros, el Administración de la carga puede tener en cuenta diferentes tiempos de ejecución u órdenes temporales dirigidas a dispositivos individuales. Los tiempos de conmutación suponen un factor esencial a la hora de elegir un dispositivo para una operación de conmutación.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ProducerTimes


ID_EMS_PROP_GRP12

Interne ID: ID_EMS_PROP_GRP12

Tipo/Capacidad

Estas propiedades están sólo disponibles para dispositivos de redes de gas.

Las configuraciones aquí reunidas determinan el comportamiento básico de los dispositivos relevantes de la red de gas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ConsumerTypePower


ID_EMS_PROP_GRP13

Interne ID: ID_EMS_PROP_GRP13

Capacidad/Prioridad

Estas propiedades están sólo disponibles para dispositivos de redes de electricidad. Determinan el comportamiento básico de los dispositivos relevantes en la red de electricidad.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ProducerPrioPower


ID_EMS_PROP_GRP14

Interne ID: ID_EMS_PROP_GRP14

Variables de conmutación

Con ayuda de las variables del proceso se pueden ajustar parámetros importantes para la previsión y optimización durante el tiempo de ejecución. Así, dependiendo de los valores de medición, se pueden ajustar al proceso actual parámetros importantes para el Administración de la carga, como p. ej. prioridades de conmutación.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ConsumerVariables


ID_EMS_PROP_GRP15

Interne ID: ID_EMS_PROP_GRP15

Variables de conmutación

Con ayuda de las variables del proceso se pueden ajustar parámetros importantes para la previsión y optimización durante el tiempo de ejecución. Así, dependiendo de los valores de medición, se pueden ajustar al proceso actual parámetros importantes para el Administración de la carga, como p. ej. prioridades de conmutación.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_VarGasCons


ID_EMS_PROP_GRP16

Interne ID: ID_EMS_PROP_GRP16

Variables de conmutación

Con ayuda de las variables del proceso se pueden ajustar parámetros importantes para la previsión y optimización durante el tiempo de ejecución. Así, dependiendo de los valores de medición, se pueden ajustar al proceso actual parámetros importantes para el Administración de la carga, como p. ej. prioridades de conmutación.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ProducerVariables


ID_EMS_PROP_GRP17

Interne ID: ID_EMS_PROP_GRP17

Nivel de llenado

Estas propiedades están sólo disponibles para depósitos de gas y plantas de gas líquido en redes de gas.

El nivel de llenado constituye el parámetro más importante para depósitos de gas. Cuando el Administración de la carga conoce el nivel de llenado actual con sus valores mínimos y máximos, puede llenar los depósitos en caso de excedentes y vaciarlos en caso de necesidad.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_GasFillLevel


ID_EMS_PROP_GRP19

Interne ID: ID_EMS_PROP_GRP19

Información del estado

Define la transmisión de información sobre el estado para el Administración de la carga.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Status


ID_EMS_PROP_GRP20

Interne ID: ID_EMS_PROP_GRP20

Capacidad

Sintetiza las entradas para la potencia.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ProducerPower


ID_EMS_PROP_GRP21

Interne ID: ID_EMS_PROP_GRP21

Prioridad

Contiene la configuración de las prioridades para encender y apagar.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ProducerPrio


ID_EMS_PROP_GRP22

Interne ID: ID_EMS_PROP_GRP22

Hora de inicio

Configuraciones para fijar el tiempo de encendido.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SwitchOn


ID_EMS_PROP_GRP23

Interne ID: ID_EMS_PROP_GRP23

Tiempo de apagado

Configuraciones para fijar el tiempo de apagado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SwitchOff


ID_EMS_PROP_GRP24

Interne ID: ID_EMS_PROP_GRP24

Frecuencia de conmutación

Contiene parámetros para determinar la Frecuencia máxima de conmutación Por unidad de tiempo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SwitchFrequency


ID_EMS_PROP_GRP25

Interne ID: ID_EMS_PROP_GRP25

Información del estado

Determina cómo se transmite la información a Estado de conmutación y Estado de conmutación interno.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ProducerStatus


ID_EMS_PROP_GRP26

Interne ID: ID_EMS_PROP_GRP26

Pasos de conmutación

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Schaltstufen


ID_EMS_PROP_GRP27

Interne ID: ID_EMS_PROP_GRP27

Información del estado

Determina cómo se transmite la información a Potencia actual, Estado de conmutación interno y Estado de conmutación.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ConsumerStatus


ID_EMS_PROP_GRP28

Interne ID: ID_EMS_PROP_GRP28

Prioridad

Description as text.

Esta función se invocará para zenon API (con nombre de clase):

GRP_ProducerPrio


ID_EMS_PROP_GRP29

Interne ID: ID_EMS_PROP_GRP29

Capacidad/Prioridad

Description as text.

Esta función se invocará para zenon API (con nombre de clase):

GRP_ProducerPrioPower


ID_EMS_PROP_GRP30

Interne ID: ID_EMS_PROP_GRP30

Capacidad

Description as text.

Esta función se invocará para zenon API (con nombre de clase):

GRP_ProducerPower


ID_ERSETZEN_ZUSAMMEN

Interne ID: ID_ERSETZEN_ZUSAMMEN

Nombres jerárquicos

Sustitución de variables en un símbolo:

  • Activado: El nombre de las variables vinculadas se formará a partir del compuesto del nombre del objeto de símbolo y de la variable definida en el símbolo. Los dos nombres estarán separados por un punto: "Nombre del símbolo.Variable"
  • Desactivado: Se utilizarán los nombres normales de las variables.

Por defecto: Desactivado

Ejemplo:
Nombre de variable: Motor.Revoluciones
El nombre del objeto del símbolo es "Motor". El elemento dinámico instalado en el símbolo tiene como variable vinculada el marcador de posición "Revoluciones".
El marcador "Revoluciones" se puede escribir con el teclado al crear el símbolo en la propiedad de la variable.
Los nombres compuestos funcionan también con símbolos anidados:
Si se tiene un símbolo "Bomba" que contiene a su vez un símbolo "Motor" y un símbolo "Convertidor" con el marcador "Potencia" el vínculo funcionará si en el proyecto hay una variable Bomba.Motor.Potencia y una variable Bomba.Convertidor.Potencia.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SubstituteCombinedName


ID_EXTERNVISIBLE

Interne ID: ID_EXTERNVISIBLE

Visible externamente

Propiedad externa para zenon Logic. Sólo afecta a variables que no sean del driver zenon Logic.
Activado: La variable es también visible en zenon Logic y se puede utilizar en proyectos zenon Logic. La definición de la variable no se puede modificar en zenon Logic. El valor de la variable se puede modificar.

Atención: Tenga en cuenta las interacciones con la propiedad Histéresis. Más detalles en el manual online.
Desactivado: La variable no es visible en zenon Logic.
Por defecto: desactivado

Atención: Los nombres de las variables para zenon Logic deben atenerse a las disposiciones del IEC 61131-3, es decir, sólo están permitidos números, letras, y guiones bajos. Además el nombre no debe empezar con un número. Eso supone que las estructuras y arrays del sistema de control no podrán verse externamente porque contienen paréntesis o puntos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ExternVisible


ID_EXTERNVISIBLE_FOR

Interne ID: ID_EXTERNVISIBLE_FOR

Visible externamente para

Sólo disponible si la propiedad Visible externamente está activada.

Decida explícitamente en qué proyectos zenon Logic debe estar visible la variable. Si deja el campo de entrada vacío, la variable estará visible para todos los proyectos zenon Logic. También puede especificar los proyectos zenon Logic individualmente. Separe el nombre de los proyectos individuales por un punto y coma (";"). También puede trabajar con wildcards, p. ej. P1* corresponde a todos los proyectos zenon Logic que empiecen por P1. (Observación: Las wildcards están solo permitidas como prefijo o sufijo, es decir, *xxx o xxx*.)

El número de caracteres está limitado a un máximo de 64.

Por defecto: -

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ExternVisibleFor


ID_FILE_NAME

Interne ID: ID_FILE_NAME

Nombre de archivo

Nombre del archivo integrado.
Los archivos externos que se integren de esta manera se guardarán tanto en el directorio runtime como en el directorio de la base de datos del proyecto.
Atención: Siempre que se creen nuevos archivos runtime se sobrescribirán los archivos de la carpeta runtime por los de la carpeta de la base de datos. Por eso los archivos externos solo se deben modificar con el menú contextual del archivo correspondiente y no de forma externa para que los archivos se modifiquen también en la carpeta de la base de datos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_FKT_PROP1

Interne ID: ID_FKT_PROP1

Tipo

El tipo se seleccionará al crear la función de la lista de funciones del sistema y se puede modificar aquí posteriormente.
Abre el diálogo para seleccionar la función.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FktType


ID_FKT_PROP2

Interne ID: ID_FKT_PROP2

Parámetro

El parámetro de transmisión de la función depende del tipo de función.
Haciendo clic sobre el botón ... se abre un diálogo para seleccionar la dirección de conmutación y el tiempo de supresión.
Dependiendo del tipo de función se abrirá el diálogo de parámetro correspondiente.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Parameters


ID_FKT_PROP3

Interne ID: ID_FKT_PROP3

Nombre:

Descripción única de la función.
La descripción se otorgará por el sistema al crear una función pero se podrá modificar posteriormente a no ser que la nueva descripción se utilice ya para otra función.
Máximo: 128 caracteres.
Por defecto: Función_x (x corresponde a un número consecutivo).

Atención: Esta propiedad no está disponible para el cambio de idioma.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_FKT_PROP4

Interne ID: ID_FKT_PROP4

Ordenador actual

Solo disponible en proyectos de red:
La función se ejecutará en el ordenador en el que se activó.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsActual


ID_FKT_PROP5

Interne ID: ID_FKT_PROP5

Servidor primario

Sólo disponible en proyectos de red:
La función se ejecutará en el servidor primario del proyecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsServer


ID_FKT_PROP6

Interne ID: ID_FKT_PROP6

Servidor standby

Sólo disponible en proyectos de red:
La función se ejecutará en el servidor Standby del proyecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsStandBy


ID_FKT_PROP7

Interne ID: ID_FKT_PROP7

Cliente

Sólo disponible en proyectos de red:
La función se ejecutará en todas las máquinas clientes del proyecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsClient


ID_FKT_PROP_GRP0

Interne ID: ID_FKT_PROP_GRP0

General

Propiedades generales para la función.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_FKT_PROP_GRP1

Interne ID: ID_FKT_PROP_GRP1

Ejecución

Sólo disponible en proyectos de red:
Selección del ordenador(es) en el(los) que se ejecutará la función.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Execution


ID_FKT_VBA_XML_PROP_587

Interne ID: ID_FKT_VBA_XML_PROP_587

Distancia horizontal [píxeles]

Distancia horizontal del final de la curvatura a la esquina efectiva en píxeles.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Offset_H


ID_FKT_VBA_XML_PROP_588

Interne ID: ID_FKT_VBA_XML_PROP_588

Distancia vertical [píxeles]

Distancia vertical del final de la curvatura a la esquina efectiva en píxeles.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Offset_V


ID_FKTLEVELLIST

Interne ID: ID_FKTLEVELLIST

Autorizaciones de funciones

Durante el runtime se pueden bloquear determinadas funciones del sistema (p. ej.: Cargar proyecto) para los usuarios no autorizados a través de los niveles de autorización. Para el editor se pueden asignar módulos individuales a los niveles de autorización.

Haciendo clic sobre el botón ... se abre el diálogo para configurar el nivel de autorización para el runtime y el editor.

Atención: ¡Para cada nivel de autorización se tiene que asignar por lo menos un usuario! ¡En otro caso, puede ocurrir que se quede encerrado fuera del proyecto!

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FktLevelList


ID_FONT_NAME

Interne ID: ID_FONT_NAME

Nombre:

Identificación libremente definible, sirve sólo como información.
Por defecto: Nueva fuente x (x corresponde a un número sucesivo).
Atención: Esta propiedad no está disponible para el cambio de idioma.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_FONT_NUMMER

Interne ID: ID_FONT_NUMMER

Número

Número de fuente único.
El sistema otorgará un número al crear una fuente. Los números 1 y 2 están otorgados de manera fija y no se pueden modificar. Todos los demás números de fuente se pueden modificar posteriormente siempre que el número nuevo no se use ya para otra fuente.

Observación: En el caso de números iguales en el proyecto global y en el proyecto se utilizará la fuente del proyecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Number


ID_FONT_PROP_GRP

Interne ID: ID_FONT_PROP_GRP

Fuente

Contiene propiedades para el tipo de fuente.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_FONT_SCHRIFTART

Interne ID: ID_FONT_SCHRIFTART

Tipo de fuente

Selección del tipo de fuente de los tipos de fuente instalados en el ordenador.
Atención: El diálogo para seleccionar el tipo de fuente es un diálogo Windows estándar. Con él se pueden seleccionar también otras propiedades como el color de la fuente. Estas configuraciones adicionales no tendrán ningún efecto para la representación en zenon.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Font


ID_FONTLIST_NAME

Interne ID: ID_FONTLIST_NAME

Nombre:

Nombre de la lista de fuentes.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_FONTLIST_PROP_GRP

Interne ID: ID_FONTLIST_PROP_GRP

Lista de fuentes

Propiedades para la lista de fuentes.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_FRAME_BEGRENZUNG

Interne ID: ID_FRAME_BEGRENZUNG

Limitación

Sólo disponible si la propiedad Desplazar está configurada como Restringir al límite del monitor.

Define el tipo de restricción para el desplazamiento de marcos:

  • Borde del marco: El marco no se podrá mover más allá de los límites del monitor.
  • Rango del borde del marco: El marco se podrá mover más allá de los límites del monitor. Tiene que quedar un rango libre en el monitor que se pueda tocar para otras acciones. El tamaño de este rango del borde se puede configurar con la propiedad Margen mínimo del marco .

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LimitationArea


ID_FRAME_BEGRENZUNG_CONTACTPOINTSIZE

Interne ID: ID_FRAME_BEGRENZUNG_CONTACTPOINTSIZE

Margen mínimo del marco

Solo disponible si el valor para la propiedad Desplazar está configurado como Restringir al límite del monitor y la propiedad Limitación está configurada como Rango del borde del marco.

Define el tamaño del rango del borde del marco en píxeles. Este rango no se puede mover más allá del borde del monitor. Así el rango definido se mantiene disponible como superficie para tocar y mover el marco en el rango visible.

  • Mínimo: 0
  • Máximo: no definido
    Si el rango se define de un tamaño mayor que la pantalla o se hace zoom durante el runtime, la pantalla se comportará como un límite del borde del marco.

Por defecto: 30

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LimitationContactPointSize


ID_FRAME_VERSCHIEBEN

Interne ID: ID_FRAME_VERSCHIEBEN

Desplazar

Define posibles restricciones al desplazar el objeto:

  • sin restricción
  • restringir al límite del monitor
    Observación: El tipo de restricción se define con la propiedad Limitación

No disponible con Windows CE.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LimitationType


ID_GFXRT_CHECKIMAGE_0FF

Interne ID: ID_GFXRT_CHECKIMAGE_0FF

Off

Selección de un gráfico que represente durante el runtime el estado "El valor es 0 y se puede editar la propiedad".
Solo disponible si la propiedad Vista numérica está desactivada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CheckOffImage


ID_GFXRT_CHECKIMAGE_0FF_INACTIVE

Interne ID: ID_GFXRT_CHECKIMAGE_0FF_INACTIVE

Off (desactivado)

Selección de un gráfico que represente durante el runtime el estado "El valor es 0 y no se puede editar la propiedad".
Solo disponible si la propiedad Vista numérica está desactivada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CheckOffImageInActive


ID_GFXRT_CHECKIMAGE_0N

Interne ID: ID_GFXRT_CHECKIMAGE_0N

On

Selección de un gráfico que represente durante el runtime el estado "El valor es 1 y se puede editar la propiedad".
Solo disponible si la propiedad Vista numérica está desactivada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CheckOnImage


ID_GFXRT_CHECKIMAGE_0N_INACTIVE

Interne ID: ID_GFXRT_CHECKIMAGE_0N_INACTIVE

On (desactivado)

Selección de un gráfico que represente durante el runtime el estado "El valor es 1 y no se puede editar la propiedad".
Solo disponible si la propiedad Vista numérica está desactivada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CheckOnImageInActive


ID_GFXRT_HEADERHEIGHT

Interne ID: ID_GFXRT_HEADERHEIGHT

Altura del encabezado [Píxeles]

Configuración de la altura del encabezado en píxeles.

Mínimo: 0 - La altura se ajustará automáticamente al tamaño de la fuente.

Máximo: 255

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HeaderHeight


ID_GFXRT_HEADERSTATIC

Interne ID: ID_GFXRT_HEADERSTATIC

Encabezamiento estático

  • Activado: Durante el runtime no se podrán desplazar las columnas con Drag&Drop ni se podrán ordenar. La anchura de la columna se podrá ajustar.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HeaderStatic


ID_GFXRT_SHOWFILTER

Interne ID: ID_GFXRT_SHOWFILTER

Mostrar fila de filtro

  • Activado: La barra del filtro se mostrará durante el runtime.
  • Desactivado: La barra del filtro se ocultará durante el runtime.
    Observación: Los filtros configurados se ejecutarán también con la barra del filtro oculta.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowFilter


ID_GFXRT_SHOWHEADER

Interne ID: ID_GFXRT_SHOWHEADER

Mostrar encabezado

  • Activado: El encabezado se mostrará durante el runtime.
  • Desactivado: El encabezado se ocultará durante el runtime. También se ocultará así la barra del filtro aunque los filtros configurados se seguirán aplicando.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowHeader


ID_GRP_CORNER

Interne ID: ID_GRP_CORNER

Corners

Esta función se invocará para zenon API (con nombre de clase):

Corners


ID_HILFE_GRP

Interne ID: ID_HILFE_GRP

Ayuda

Propiedades para la ayuda online del objeto.
Si no hay ninguna ayuda definida aquí, se puede definir un capítulo de ayuda general directamente en el menú contextual de este elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Help


ID_IEC870_103_FktType

Interne ID: ID_IEC870_103_FktType

IEC870-103 FUNCTION TYPE

Introduzca un valor. Según la norma corresponde a FUN

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IEC870_103_FktType


ID_IEC870_103_Index

Interne ID: ID_IEC870_103_Index

IEC870-103 Index

Introduzca un valor. Corresponde al orden de MEA a ASDU 3 o 9.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IEC870_103_Index


ID_IEC870_103_InfNo

Interne ID: ID_IEC870_103_InfNo

IEC870-103 INFORMATION NUMBER

Introduzca un valor. Según la norma corresponde a INF.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IEC870_103_InfNo


ID_IEC870_COA1

Interne ID: ID_IEC870_COA1

IEC870 COA

Introduzca la dirección del objeto común, Common Object Address (COA). Los límites de los rangos de valor disponibles se ajustan a las configuraciones del driver.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IEC870_COA1


ID_IEC870_IOA1

Interne ID: ID_IEC870_IOA1

IEC870 IOA

Introduzca la dirección del objeto común, Common Object Address (COA). Los límites de los rangos de valor disponibles se ajustan a las configuraciones del driver.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IEC870_IOA1


ID_IEC870_TYPE

Interne ID: ID_IEC870_TYPE

IEC870 Type identification

Seleccione el tipo de ASDU del punto de datos de la lista desplegable.

por defecto: T00 internal state

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IEC870_TYPE


ID_IEC62056_ADDRESS

Interne ID: ID_IEC62056_ADDRESS

IEC62056 Address

Entrada de la dirección de OBIS.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IEC62056_ADDRESS


ID_IEC62056_TIMEADJUST

Interne ID: ID_IEC62056_TIMEADJUST

IEC62056 Time Adjustment

Corrección del sello horario. Selección del tipo de ajuste horario de la lista desplegable.

  • Ninguno: No se produce ninguna corrección.
  • Inicio de intervalo: La corrección tiene efecto sobre el sello horario inicial.
  • Fin de intervalo: La corrección tiene efecto sobre el sello horario final.

Por defecto: Ninguno

El intervalo al que se aplica la modificación se configura con la propiedad IEC62056 Time Interval.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IEC62056_TIMEADJUST


ID_IEC62056_TIMEINTERVAL

Interne ID: ID_IEC62056_TIMEINTERVAL

IEC62056 Time Interval

Entrada del intervalo de tiempo en minutos.

Solo disponible si para la propiedad IEC62056 Time Adjustment no se ha seleccionado ninguno.

Máximo: 65535

Por defecto: 15

Por ejemplo: Con el intervalo 15 y Fin de intervalo para IEC62056 Time Adjustment el sello horario se fijará siempre al final de un cuarto de hora.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IEC62056_TIMEINTERVAL


ID_IMM_DNS

Interne ID: ID_IMM_DNS

Base de datos

Definición de la conexión ODBC a la base de datos del Industrial Maintenance Manager (IMM).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IMMDns


ID_IMM_TABLEDEV

Interne ID: ID_IMM_TABLEDEV

Tabla para dispositivos

Nombre de la tabla en la base de datos para dispositivos.
Mostrar solo el nombre estándar. Se utilizará también para la administración de medidas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IMMTableDevice


ID_IMM_TABLEDOC

Interne ID: ID_IMM_TABLEDOC

Tabla para documentos

Nombre de la tabla en la base de datos para documentos.

Mostrar solo el nombre estándar.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IMMTableDoc


ID_IMM_TABLEHIST

Interne ID: ID_IMM_TABLEHIST

Tabla para el histórico

Nombre de la tabla en la base de datos para la historia.

Mostrar solo el nombre estándar.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IMMTableHist


ID_IMM_TABLEMAINT

Interne ID: ID_IMM_TABLEMAINT

Tabla para trabajos de mantenimiento

Nombre de la tabla en la base de datos para los trabajos de mantenimiento.

Mostrar solo el nombre estándar.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IMMTableMaint


ID_IMM_USERLVL

Interne ID: ID_IMM_USERLVL

Nivel de autorización

Grupo de autorización que se requiere para poder eliminar datos de la base de datos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IMMUserLvl


ID_INITIALVALUE

Interne ID: ID_INITIALVALUE

Valores iniciales externos

Propiedad externa para zenon Logic. Sólo afecta a variables que no sean del driver straton.
Valor inicial de la variable en zenon Logic para el encendido en frío o caliente.
La entrada permitida depende del tipo de dato de la variable. Así para las variables de números enteros sólo se pueden introducir valores sin decimales. Para variables con coma flotante hay que utilizar un punto como separación de los decimales, con una coma no funciona.
El sistema de control no comprueba en este caso la validez de la entrada. Ello puede dar lugar a un mensaje de error en zenon Logic.

ATENCIÓN: En variables del driver interno, esta propiedad debe tener el mismo valor que el valor inicial de las configuraciones para variables internas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InitialValue


ID_KNOTEN_VERKN

Interne ID: ID_KNOTEN_VERKN

Regla de vínculación

Propiedades para sustituir los vínculos de variables y/o funciones para símbolos y contenedores en faceplates.

Más en el manual online bajo Símbolos y Faceplates.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Linkings


ID_LASTUSEDOFFSET

Interne ID: ID_LASTUSEDOFFSET

Último offset utilizado

Muestra el último offset utilizado por el direccionamiento automático.
Esta propiedad sirve solo de información y no es modificable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LastUsedOffset


ID_LEVELEDIT

Interne ID: ID_LEVELEDIT

Renombrar niveles de autorización

A los 128 niveles de autorización se les puede asignar un número además de su nombre. Aquí se abre el diálogo para definir el nombre.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserLevelList


ID_LEVELLIST

Interne ID: ID_LEVELLIST

Niveles de autorización

Se puede asignar al usuario uno o más de los 128 grupos de autorización.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserLevel


ID_MATHVAR_PROP_ENABLE_VAR

Interne ID: ID_MATHVAR_PROP_ENABLE_VAR

Activar cálculo

Asigna a las variables matemáticas una variable cuyo valor controla si él cálculo se ejecuta. La asignación de una variable activa la propiedad.

Haciendo clic sobre el botón ... o en el campo con las variables se abre un diálogo para seleccionar una variable.

Por defecto: desactivado, ninguna variable asignada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EnableCalc


ID_MATHVAR_PROP_FORMEL

Interne ID: ID_MATHVAR_PROP_FORMEL

Fórmula

Abre el diálogo para introducir la fórmula para calcular la variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Formula


ID_MINPWLENGTH

Interne ID: ID_MINPWLENGTH

Longitud mínima de contraseña

Longitud mínima de la contraseña en caracteres.

  • Mínimo: 0
  • Máximo: 20

Por defecto: 6

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MinPwLength


ID_MONITOR_VERWALTUNG

Interne ID: ID_MONITOR_VERWALTUNG

Administración del monitor

Se abre el diálogo de configuración para la administración de monitores.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MonitorAministration


ID_MSGCONTROL_DISPATCHER_ACTIVE

Interne ID: ID_MSGCONTROL_DISPATCHER_ACTIVE

Tipo de envío activo

Activado: Se pueden enviar mensajes a través de este medio.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Active


ID_MSGCONTROL_ENGINE_EXPORTTOMESSAGE32

Interne ID: ID_MSGCONTROL_ENGINE_EXPORTTOMESSAGE32

Exportar configuraciones al Messag32.ini (v6.XX)

Guarda las configuraciones realizadas a partir de la versión 7, para versiones 6.xx en el messag32.ini. Haciendo clic sobre el botón se inicia la exportación. Las configuraciones actuales de messag32.ini se sobrescribirán después de una pregunta de seguridad. Las configuraciones de messag32.ini sirven para compatibilizar y solo afectan a las versiones 6.xx. de zenon. A partir de la versión 7 se guardarán las configuraciones en zenon6.ini .

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ExportToMessag32


ID_MSGCONTROL_ENGINE_GRP

Interne ID: ID_MSGCONTROL_ENGINE_GRP

Message Control

Grupo para configuraciones superpuestas de proyectos en Message Control.

Observación: Estas propiedades no son específicas de proyecto. Por lo tanto las modificaciones realizadas en esta área durante el runtime no tendrán efecto hasta que se reinicie el runtime.

Las configuraciones específicas de proyecto se configuran en el árbol del proyecto en el nodo Message Control con las propiedades para Configuraciones específicas de proyecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MsgCtrlSettings


ID_MSGCONTROL_MODEM_COUNTWELCOME

Interne ID: ID_MSGCONTROL_MODEM_COUNTWELCOME

Repetir texto de bienvenida

Número de repeticiones para el texto de bienvenida.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CountWelcome


ID_MSGCONTROL_MODEM_GRP

Interne ID: ID_MSGCONTROL_MODEM_GRP

Mensaje de voz (archivo de audio)

Configuraciones para el grupo teléfono.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DispatchSettings


ID_MSGCONTROL_MODEM_IGNOREDISCONNECT

Interne ID: ID_MSGCONTROL_MODEM_IGNOREDISCONNECT

Ignorar colgado de auricular

Activado: Se ignorarán las interrupciones de la conexión (p. ej. cuando el receptor cuelga) y el mensaje se reproducirá al completo antes de que se corte la conexión.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IgnoreDisconnect


ID_MSGCONTROL_MODEM_LINEID

Interne ID: ID_MSGCONTROL_MODEM_LINEID

Id de la línea

Dispositivo ID creado automáticamente que identifica el módem seleccionado. Sirve para diferenciar los dispositivos cuando haya varios módems con el mismo nombre. Solo para ver, no es modificable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LineId


ID_MSGCONTROL_MODEM_LINENAME

Interne ID: ID_MSGCONTROL_MODEM_LINENAME

Nombre de la línea

Selección del módem para utilizar de la lista desplegable.

Si no se muestra ninguna lista desplegable es porque no hay ningún módem configurado para ese ordenador.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Line


ID_MSGCONTROL_MODEM_TIMEOUT

Interne ID: ID_MSGCONTROL_MODEM_TIMEOUT

Tiempo de espera

Tiempo en minutos después del que se debe interrumpir y cortar una conexión existente . El intervalo de tiempo tiene que ser mayor que el tiempo necesario para reproducir y confirmar el mensaje.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TimeOut


ID_MSGCONTROL_OUTLOOK_GRP

Interne ID: ID_MSGCONTROL_OUTLOOK_GRP

Mensaje de e-mail (Outlook)

Grupo para configuraciones del tipo de envío Outlook.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DispatchSettings


ID_MSGCONTROL_OUTLOOK_PROFILE

Interne ID: ID_MSGCONTROL_OUTLOOK_PROFILE

Perfil

Nombre del perfil de Outlook que debe utilizarse para el envío. Seleccionar de la lista desplegable. Los perfiles ya deben estar creados.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Profile


ID_MSGCONTROL_OUTLOOK_SUBJECT

Interne ID: ID_MSGCONTROL_OUTLOOK_SUBJECT

Asunto (Id)

Asunto unívoco del mensaje enviado. Sirve como criterio en los mensajes entrantes para saber si el mensaje está dirigido al Message Control y debe ser procesado.

Longitud mínima: 4 caracteres

Más en el manual online.

Observación acuse de recibo: Los e-mails entrantes tienen que contener este texto en el asunto para que el sistema los procese. Los e-mails que no contengan este texto no serán reenviados al Message Control. El asunto del acuse de recibo entrante tiene que estar precedido por 3 caracteres cualquiera, como p. ej. RE:.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Subject


ID_MSGCONTROL_PROJECT_ACTIVEATSTARTUP

Interne ID: ID_MSGCONTROL_PROJECT_ACTIVEATSTARTUP

Activado al iniciar el runtime

Activado: El Message Control se reiniciará con el runtime.

Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ActiveAtStartup


ID_MSGCONTROL_PROJECT_ATTEMPTS

Interne ID: ID_MSGCONTROL_PROJECT_ATTEMPTS

Máximo número de intentos

Número máximo de intentos de envío en caso de errores de envío reconocidos como errores de hardware.
Si la llamada se interrumpe por el destinatario sin confirmación ni rechazo no se repetirá.

Máximo: 100

Mínimo: 1

Por defecto: 3

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Attempts


ID_MSGCONTROL_PROJECT_CELITEMS

Interne ID: ID_MSGCONTROL_PROJECT_CELITEMS

Protocolizar en CEL

Establece cuáles son los eventos que se protocolizarán en la CEL. Seleccionar de la lista desplegable:

  • todas las confirmaciones:
    todos los mensajes
  • ninguna confirmación:
    ningún mensaje
  • solo confirmaciones negativas:
    solo mensajes que hayan sido rechazados o no contestados (también repeticiones)
  • solo confirmaciones positivas:
    solo mensajes que ya hayan sido reconocidos

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CelDetail


ID_MSGCONTROL_PROJECT_COLOR_ERROR

Interne ID: ID_MSGCONTROL_PROJECT_COLOR_ERROR

Error de envío

Define el color con el que la columna de estado se representará en la pantalla del tipo Message Control cuando un envío resulte fallido. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ErrorColor


ID_MSGCONTROL_PROJECT_COLOR_SENDING

Interne ID: ID_MSGCONTROL_PROJECT_COLOR_SENDING

Enviando mensaje

Define el color con el que la columna de estado se representará en la pantalla del tipo Message Control cuando se está realizando el envío. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SendingColor


ID_MSGCONTROL_PROJECT_COLOR_SENT

Interne ID: ID_MSGCONTROL_PROJECT_COLOR_SENT

Mensaje enviado

Define el color con el que la columna de estado se representará en la pantalla del tipo Message Control cuando se realiza un envío con éxito. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SentColor


ID_MSGCONTROL_PROJECT_GRP

Interne ID: ID_MSGCONTROL_PROJECT_GRP

Configuraciones específicas de proyecto

Contiene configuraciones específicas de proyecto para la configuración del módulo Message Control.

Las configuraciones globales para el envío se realizan en el área de trabajo con las propiedades del grupo Message Control.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MsgCtrlSettings


ID_MSGCONTROL_PROJECT_LOG_DELETE

Interne ID: ID_MSGCONTROL_PROJECT_LOG_DELETE

Protocolizar eliminación manual de mensajes en CEL.

Activado: La eliminación manual de entradas de la CEL se protocolizará en la CEL.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LogDeleteActions


ID_MSGCONTROL_PROJECT_STATUSIMAGE_ERROR

Interne ID: ID_MSGCONTROL_PROJECT_STATUSIMAGE_ERROR

Error de envío

Define un gráfico que se mostrará en la pantalla del tipo Message Control en la columna de estado cuando el intento de envío de un mensaje resulte fallido. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un archivo gráfico.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ErrorImage


ID_MSGCONTROL_PROJECT_STATUSIMAGE_SENDING

Interne ID: ID_MSGCONTROL_PROJECT_STATUSIMAGE_SENDING

Enviando mensaje

Define un gráfico que se mostrará en la pantalla del tipo Message Control en la columna de estado mientras se esté intentando enviar un mensaje. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un archivo gráfico.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SendingImage


ID_MSGCONTROL_PROJECT_STATUSIMAGE_SENT

Interne ID: ID_MSGCONTROL_PROJECT_STATUSIMAGE_SENT

Mensaje enviado

Define un gráfico que se mostrará en la pantalla del tipo Message Control en la columna de estado en cuanto el mensaje haya sido enviado con éxito. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un archivo gráfico.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SentImage


ID_MSGCONTROL_PROJECT_SUBJECT_DYN

Interne ID: ID_MSGCONTROL_PROJECT_SUBJECT_DYN

Parte dinámica del asunto

Define la parte del asunto específica del proyecto para los mensajes salientes y entrantes. Se utilizará junto con la propiedad Mensaje de e-mail (Outlook)/Asunto (Id) o Mensaje de e-mail (SMTP) /Asunto del e-mail en las configuraciones globales de envío Message Control. De esta manera se filtrarán los mensajes entrantes según su contenido para ser reenviadas al Message Control.

El texto puede contener marcadores de posición para:

  • Código de la tabla de idiomas
  • Nombre de una variable
  • Entrada compuesta en la tabla de idiomas

Sintaxis:

  • Las partes del texto se separan por punto y coma (;),
  • $ indica un texto que contiene parámetros
  • @ indica cambio de idioma
  • % indica variables
  • El texto tiene que terminar con un punto y coma (;)

Ejemplo: $@Atención;%Var1;

Puede encontrar una lista con los parámetros en el capítulo Texto del valor límite y texto libre.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SubjectDyn


ID_MSGCONTROL_PROJECT_TIMETOWAIT

Interne ID: ID_MSGCONTROL_PROJECT_TIMETOWAIT

Tiempo de espera entre intentos [min]

Tiempo de espera en minutos para la repetición entre dos intentos de envío o el reenvío de un mensaje.

Por defecto: 5

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TimeToWait


ID_MSGCONTROL_SMSGATEWAY_GRP

Interne ID: ID_MSGCONTROL_SMSGATEWAY_GRP

Mensaje SMS (SMS-Gateway)

Configuraciones para SMS-Gateway.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DispatchSettings


ID_MSGCONTROL_SMSGATEWAY_INBOX

Interne ID: ID_MSGCONTROL_SMSGATEWAY_INBOX

Carpeta de entrada

Carpeta de entrada del servidor de SMS para el envío de SMS.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Inbox


ID_MSGCONTROL_SMSGATEWAY_ORIGINID

Interne ID: ID_MSGCONTROL_SMSGATEWAY_ORIGINID

Reconocimento de remitente

Reconocimiento de remitente para el envío de SMS.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OriginId


ID_MSGCONTROL_SMSGATEWAY_OUTBOX

Interne ID: ID_MSGCONTROL_SMSGATEWAY_OUTBOX

Carpeta de salida

Carpeta de salida del servidor de SMS para el envío de SMS.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Outbox


ID_MSGCONTROL_SMSGATEWAY_PREFIX

Interne ID: ID_MSGCONTROL_SMSGATEWAY_PREFIX

Primera letra de los archivos SMS

Letra de inicio de los archivos SMS. Debe ser unívoca para cada proyecto.

Longitud: 1 caracter

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Prefix


ID_MSGCONTROL_SMSGATEWAY_SEMAPHOREPREFIX

Interne ID: ID_MSGCONTROL_SMSGATEWAY_SEMAPHOREPREFIX

Primera letra de los archivos de bloqueo/semáforo

Letra de inicio del archivo de bloqueo. Debe ser unívoca para cada proyecto.

Longitud: 1 caracter

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SemaPrefix


ID_MSGCONTROL_SMSGATEWAY_SMARTALARM

Interne ID: ID_MSGCONTROL_SMSGATEWAY_SMARTALARM

Smart Alarming

Activado: Se utilizará smartalarming .

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SmartAlarm


ID_MSGCONTROL_SMSGATEWAY_STATUSBOX

Interne ID: ID_MSGCONTROL_SMSGATEWAY_STATUSBOX

Carpeta de estado

Carpeta del servidor de SMS para la información del estado de los envíos de SMS.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Statusbox


ID_MSGCONTROL_SMSGATEWAY_TIMEOUT

Interne ID: ID_MSGCONTROL_SMSGATEWAY_TIMEOUT

Tiempo de espera

Timeout para los mensajes de salida en minutos. Establece el lapso de tiempo después del cual se interpretará que un mensaje "no ha podido ser enviado".

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TimeOut


ID_MSGCONTROL_SPEECH_GRP

Interne ID: ID_MSGCONTROL_SPEECH_GRP

Mensaje de voz (conversión de texto en voz)

Configuraciones para el discurso de voz.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DispatchSettings


ID_MSGCONTROL_SPEECH_RATE

Interne ID: ID_MSGCONTROL_SPEECH_RATE

Velocidad del flujo de voz

Velocidad de la voz.

Mínimo: -10

Máximo: 10

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Rate


ID_MSGCONTROL_SPEECH_VOICEID

Interne ID: ID_MSGCONTROL_SPEECH_VOICEID

Voz

Selección de la voz y el idioma de una lista desplegable.
Tenga en cuenta la selección de las voces compatibles con el editor:

  • Editor de 32 bits: C:\Windows\SysWOW64\Speech\SpeechUX\sapi.cpl
  • Editor de 64 bits: C:\Windows\System32\Speech\SpeechUX\sapi.cpl

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VoiceId


ID_MSGCONTROL_SPEECH_VOLUME

Interne ID: ID_MSGCONTROL_SPEECH_VOLUME

Volumen

Volumen de la voz. El número corresponde al valor porcentual del valor máximo de la voz seleccionada.

Máximo: 100

Mínimo: 0
0: El valor del sistema operativo se aplicará sin modificaciones.

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Volume


ID_MSGCTRL_GRP

Interne ID: ID_MSGCTRL_GRP

Message Control

Propiedades para la utilización del usuario en Message Control.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MessageControl


ID_MSGCTRL_MAIL_POP_APOP

Interne ID: ID_MSGCTRL_MAIL_POP_APOP

Utilizar APOP para autentificación

Controla la autentificación en el servidor de entrada del correo.

Activado: Para la autentificación se utilizará el comando APOP en lugar del usuario (USER) y la contraseña (PASS).

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PopUseApop


ID_MSGCTRL_MAIL_POP_GROUP

Interne ID: ID_MSGCTRL_MAIL_POP_GROUP

Servidor de entrada del correo

Propiedades para la configuración del servidor POP3 para el correo entrante.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InboundServerSettings


ID_MSGCTRL_MAIL_POP_KEEP_MAILS

Interne ID: ID_MSGCTRL_MAIL_POP_KEEP_MAILS

Dejar e-mails leídos en el servidor

Activado: Los e-mails no se eliminarán en el servidor después de ser descargados.

Por defecto: Desactivado

Observación: : Debido a que POP3 no incluye ninguna posibilidad para filtrar los e-mails al descargarlos, se descargarán siempre todos los e-mails existentes en la entrada del correo. Si esta propiedad está activada aumenta el consumo de memoria del servidor y puede reducir el rendimiento al descargar los e-mails.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PopKeepMails


ID_MSGCTRL_MAIL_POP_PASSWORD

Interne ID: ID_MSGCTRL_MAIL_POP_PASSWORD

Contraseña

Contraseña para registrarse en el servidor de entrada del correo (POP3).

La contraseña se guardará codificada y solo se descodificará para la autentificación. En la entrada no se mostrarán caracteres en el texto claro. El campo mostrará siempre 16 caracteres independientemente de la longitud que pueda tener la contraseña.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PopPassword


ID_MSGCTRL_MAIL_POP_POLLING_INTERVALL

Interne ID: ID_MSGCTRL_MAIL_POP_POLLING_INTERVALL

Intervalo mínimo entre dos consultas (s)

Distancia mínima en segundos entre dos intentos de descarga. El valor no deberá ser inferior a los requisitos del servidor POP3.

Valor mínimo: 10

Por defecto: 60

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PopPollingIntervall


ID_MSGCTRL_MAIL_POP_PORT

Interne ID: ID_MSGCTRL_MAIL_POP_PORT

Puerto

Puerto con el que se conectará el servidor POP3.

Valor máximo: 65535

Por defecto para una conexión no asegurada: 110

Por defecto para una conexión asegurada: 995

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PopPort


ID_MSGCTRL_MAIL_POP_SECURITY

Interne ID: ID_MSGCTRL_MAIL_POP_SECURITY

Codificación

Selección de la codificación para la conexión. Haciendo clic se abre una lista desplegable para seleccionar. Opciones posibles:

Ninguna: la conexión se establecerá de manera insegura.

SSL versión 2 und 3: la conexión se establecerá con el modelo de codificación híbrido SSL.

TLS versión 1: la conexión se establecerá con TLS. La versión TLS es la siguiente a SSL y corresponde a SSL 3.1.

Por defecto: SSL versión 2 y 3

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PopSecurity


ID_MSGCTRL_MAIL_POP_SERVER

Interne ID: ID_MSGCTRL_MAIL_POP_SERVER

Dirección del servidor

Dirección completa del servidor POP3.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PopServer


ID_MSGCTRL_MAIL_POP_USERNAME

Interne ID: ID_MSGCTRL_MAIL_POP_USERNAME

Nombre de usuario

Nombre de usuario para registrarse en el servidor de entrada del correo (POP3).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PopUser


ID_MSGCTRL_MAIL_SMTP_AUTHENTICATION

Interne ID: ID_MSGCTRL_MAIL_SMTP_AUTHENTICATION

Autentificación en el servidor de entrada del correo

Selección de la autentificación en el servidor de salida del correo. Haciendo clic se abre una lista desplegable para seleccionar.

Ninguna autentificación: El envío se realizará sin autentificación.

Antes de enviar un e-mail informar al servidor de entrada del correo: Antes de enviar un mensaje se informará al servidor POP3.

Utilizar autentificación SMTP en el servidor de salida del correo: Antes de enviar un mensaje se informará al servidor SMPT.

Por defecto: Sin selección

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SmtpAuthentication


ID_MSGCTRL_MAIL_SMTP_GROUP

Interne ID: ID_MSGCTRL_MAIL_SMTP_GROUP

Servidor de salida del correo

Propiedades para la configuración del servidor SMPT para el correo de salida.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OutboundServerSettings


ID_MSGCTRL_MAIL_SMTP_IS_POP_SERVER

Interne ID: ID_MSGCTRL_MAIL_SMTP_IS_POP_SERVER

Utilizar servidor de entrada del correo para los e-mails salientes

Activado: El servidor de entrada del correo se utilizará como servidor para el correo de salida. Esta propiedad solo afecta a la dirección del servidor.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SmtpUsePopServer


ID_MSGCTRL_MAIL_SMTP_OTHER_CREDENTIALS

Interne ID: ID_MSGCTRL_MAIL_SMTP_OTHER_CREDENTIALS

Utilizar otros datos de registro que el servidor de entrada del correo

Solo disponible si para la propiedad Autentificación en el servidor de entrada del correo se ha seleccionado Autentificación SMTP en el servidor de salida del correo.

Activado: Para la autentificación en el servidor de salida del correo se utilizarán otros datos de registro que en el servidor de entrada del correo.

Desactivado: Se utilizarán los mismos datos de registro para el servidor de entrada y el de salida del correo.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SmtpDifferentCredentials


ID_MSGCTRL_MAIL_SMTP_PASSWORD

Interne ID: ID_MSGCTRL_MAIL_SMTP_PASSWORD

Contraseña

Contraseña para el servidor de salida del correo.

Solo disponible si la propiedad Utilizar otros datos de registro que el servidor de entrada del correo está activada. Si la propiedad está desactivada la contraseña será la definida en la propiedad Contraseña del grupo Servidor de entrada del correo.

La contraseña se guardará codificada y solo se descodificará para la autentificación. En la entrada no se mostrarán caracteres en el texto claro. El campo mostrará siempre 16 caracteres independientemente de la longitud que pueda tener la contraseña.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SmtpPassword


ID_MSGCTRL_MAIL_SMTP_POP_GROUP

Interne ID: ID_MSGCTRL_MAIL_SMTP_POP_GROUP

Mensaje de e-mail (SMTP)

Configuraciones para el envío de e-mails por SMTP.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DispatchSettings


ID_MSGCTRL_MAIL_SMTP_PORT

Interne ID: ID_MSGCTRL_MAIL_SMTP_PORT

Puerto

Puerto para la conexión al servidor de salida del correo (SMTP).

Máximo: 65535

Por defecto: 25

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SmtpPort


ID_MSGCTRL_MAIL_SMTP_SECURITY

Interne ID: ID_MSGCTRL_MAIL_SMTP_SECURITY

Codificación

Selección de la codificación para la conexión. Haciendo clic se abre una lista desplegable para seleccionar. Opciones posibles:

Ninguna: la conexión se establecerá de manera insegura.

SSL versión 2 und 3: la conexión se establecerá con el modelo de codificación híbrido SSL.

TLS versión 1: la conexión se establecerá con TLS. La versión TLS es la siguiente a SSL y corresponde a SSL 3.1.

Por defecto: ninguna

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SmtpSecurity


ID_MSGCTRL_MAIL_SMTP_SERVER

Interne ID: ID_MSGCTRL_MAIL_SMTP_SERVER

Dirección del servidor

Solo disponible si el Utilizar servidor de entrada del correo para los e-mails salientes está desactivado.

Dirección completa del servidor SMTP.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SmtpServer


ID_MSGCTRL_MAIL_SMTP_SRCADDR

Interne ID: ID_MSGCTRL_MAIL_SMTP_SRCADDR

Dirección para e-mails salientes

Solo disponible si la propiedad El nombre de usuario será la dirección para los e-mails salientes está desactivada o no está disponible.

Dirección del remitente para los e-mails salientes.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SmtpOutMailAddress


ID_MSGCTRL_MAIL_SMTP_SRCADDR_IS_USERNAME

Interne ID: ID_MSGCTRL_MAIL_SMTP_SRCADDR_IS_USERNAME

El nombre de usuario será la dirección para los e-mails salientes

Solo disponible si la propiedad Autentificación en el servidor de entrada del correo contiene un valor distinto de Ninguna autentificación.

Activado: El nombre de usuario utilizado para la autentificación en el servidor SMTP se utilizará como dirección del remitente para los e-mails salientes.

Desactivado: se utilizará el remitente definido en la propiedad Dirección para e-mails salientes.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SmtpUserIsOutMailAddress


ID_MSGCTRL_MAIL_SMTP_SUBJECT

Interne ID: ID_MSGCTRL_MAIL_SMTP_SUBJECT

Asunto del e-mail

Entrada del asunto para los e-mails salientes.

Los e-mails entrantes tienen que contener este texto en el asunto para que el sistema los procese. Los e-mails que no contengan este texto no serán ni reenviados al Message Control ni serán eliminados por el servidor.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SmtpSubject


ID_MSGCTRL_MAIL_SMTP_USERNAME

Interne ID: ID_MSGCTRL_MAIL_SMTP_USERNAME

Nombre de usuario

Nombre de usuario para el servidor de salida del correo.

Solo disponible si Utilizar otros datos de registro que el servidor de entrada del correo está activada. Cuando la propiedad esté desactivada, se mostrará el nombre de usuario de la propiedad Nombre de usuario en el grupo Servidor de entrada del correo. En caso contrario se mostrará el último nombre de usuario introducido para el servidor de salida del correo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SmtpUser


ID_NETZ_APP_CLOSE_BOX

Interne ID: ID_NETZ_APP_CLOSE_BOX

Finalizar notificación

Solo disponible si la propiedad Red activa está activada.

  • Activado: Al finalizar el runtime en un servidor se mostrará un aviso a todos los clientes conectados comunicándoles la finalización del runtime. La finalización del runtime se retrasará 70 segundos para que los clientes puedan finalizar correctamente sus entradas.
  • Desactivado: El runtime en el servidor se cerrará inmediatamente sin avisar a los clientes.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AppCloseBox


ID_NICHTLINIARE_ANPASSUNG

Interne ID: ID_NICHTLINIARE_ANPASSUNG

Ajuste no lineal de valores

Ajuste de valores no lineal mediante macros VBA.
Propiedades para la conversión no lineal de valores PLC en valores de visualización.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_NonlinAdjust


ID_OPCUA_BROWSENAME

Interne ID: ID_OPCUA_BROWSENAME

Browse name

Corresponde al Browse name de la especificación OPC UA.

Sólo se permiten vínculos jerárquicos hacia adelante partiendo de la carpeta del objeto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BrowseName


ID_PASSWORD_SHOWLOCK

Interne ID: ID_PASSWORD_SHOWLOCK

Identificación gráfica activada

Activado: Los elementos bloqueados se pueden marcar con el símbolo de un candado o cualquier otro gráfico libremente definible.
Por defecto: Desactivado:

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowLock


ID_PICTURE_MIN

Interne ID: ID_PICTURE_MIN

Botones Mín/Máx

Solo disponible cuando se muestre una barra de título en la pantalla:
Activado: Los botones para aumentar y disminuir la pantalla se mostrarán el la barra de título.
Desactivado: No se mostrarán dichos botones.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowMinimize


ID_PICTURE_SYSMENU

Interne ID: ID_PICTURE_SYSMENU

Menú del sistema

Solo disponible cuando se muestre una barra de título en la pantalla:
Activado: El menú del sistema de la pantalla se mostrará en la barra de título.
Desactivado: No se mostrará dicho botón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowSysMenu


ID_PICTURE_TITLE

Interne ID: ID_PICTURE_TITLE

Nombre:

Nombre unívoco de pantalla.
Por defecto: Picture x (x corresponde a un número sucesivo).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Title


ID_PREDEFINED_BITMAPS

Interne ID: ID_PREDEFINED_BITMAPS

Gráficos predefinidos

Se pueden seleccionar de la lista bitmaps predefinidos para el estado LOW/HIGH .

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PredefinedBitmaps


ID_PROFILENAME

Interne ID: ID_PROFILENAME

Nombre de perfil externo

Propiedad externa para zenon Logic. Afecta sólo a variables que no sean del driver straton.
Nombre del perfil configurado en zenon Logic (p. ej. STRATON, ProfDP).

Esta propiedad se muestra solo para información. Editable solo con zenon Logic.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Profilename


ID_PROJECT_ALC_CONFIG

Interne ID: ID_PROJECT_ALC_CONFIG

Configuración ALC

Se abrirá el diálogo de configuración para Automatic Line Coloring (ALC).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCConfig


ID_PROJECT_ALC_GROUNDFAULTMODE

Interne ID: ID_PROJECT_ALC_GROUNDFAULTMODE

Modo de búsqueda de pérdida a tierra

Determina si en la búsqueda de la pérdida a tierra se coloreará la parte de red potencialmente afectada o toda la red en la que se encuentre la pérdida a tierra.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCGroundFaultMode


ID_PROJECT_ALC_MARKERLINE

Interne ID: ID_PROJECT_ALC_MARKERLINE

Ancho de línea del marcador de pantalla

Define el ancho de línea para el marcador de pantalla en píxeles.

Por defecto: 3 Píxel

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCMarkerLine


ID_PROJECT_ALC_MARKERSIZE

Interne ID: ID_PROJECT_ALC_MARKERSIZE

Tamaño del marcador de pantalla

Define el tamaño del marcador de pantalla en píxeles.

Por defecto: 20 Píxel

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCMarkerSize


ID_PROJECT_ALC_MARKERTYPE

Interne ID: ID_PROJECT_ALC_MARKERTYPE

Tipo de representación del marcador de pantalla

Forma de representación para el marcador de pantalla. Están disponibles:

  • Triángulo:
  • Círculo
  • Cuadrado
  • Cruz

Por defecto: Triángulo:

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCMarkerType


ID_PROJECT_ALC_MAXOVERLOAD

Interne ID: ID_PROJECT_ALC_MAXOVERLOAD

Sobrecarga de corriente máxima permitida [%]

Sobrecarga de corriente máxima permitida en porcentaje.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCMaxOverload


ID_PROJECT_ALC_SEARCHMODE

Interne ID: ID_PROJECT_ALC_SEARCHMODE

Modo de coloración

Establece el modo de coloración para el estado UNDEFINED. Haciendo clic se abre una lista desplegable para seleccionar:

  • Estándar: El color de la fuente se extenderá partiendo de las fuentes activadas en la red mientras que el siguiente interruptor esté apagado.
  • Suministro prioritario: Colorea solo las líneas que puedan estar potencialmente abastecidas por una fuente, pero no que lo estén claramente por una sola.

Por defecto: Estándar

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCSearchMode


ID_PROJECT_ASMACTIVE

Interne ID: ID_PROJECT_ASMACTIVE

IPA activo

El Industrial Performance Analyzer (IPA) sirve para mostrar y analizar en las distintas listas los datos de alarmas y los tiempos de paradas causados.

Observación: El módulo Modul Industrial Performance Analyzer requiere una licencia extra.

Activado: Tiene disponible la funcionalidad del Industrial Performance Analyzer. Ahora puede editar aquí las demás propiedades que desee para el IPA.

Por defecto: desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AsmActive


ID_PROJECT_ASMAKZ

Interne ID: ID_PROJECT_ASMAKZ

Identificación del equipo

Las identificaciones de los equipos le ayudan en la pantalla del tipo Industrial Performance Analyzer a filtrar los datos de alarmas. La identificación del equipo definida aquí puede aparecer en el nombre o la identificación de la variable que ha causado la alarma.

Haciendo clic izquierdo sobre el botón se abre un diálogo para definir las identificaciones del equipo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AKZ


ID_PROJECT_ASMAKZMODE

Interne ID: ID_PROJECT_ASMAKZMODE

Identificar equipo por

La definición de la identificación del equipo se puede introducir como un prefijo en el nombre o en la identificación de la variable. Hay que tener esto en cuenta al definir la variable .
Identificación: Una parte de la identificación de la variable se utiliza para la identificacion del equipo en el Industrial Performance Analyzer (IPA).
Nombre de la variable: Una parte del nombre de la variable se utiliza para la identificacion del equipo.

Por defecto: Nombre de la variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AkzMode


ID_PROJECT_ASMBUFFERSIZE

Interne ID: ID_PROJECT_ASMBUFFERSIZE

Tamaño del búfer

Número máximo de alarmas escritas en el búfer.

Observación: Cuando el búfer está lleno y se siguen guardando alarmas en él, se irán eliminando las más antiguas. Téngalo en cuenta a la hora de configurar.
Mínimo: 0
Máximo: 4294967295.
Por defecto: 10000.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AsmBufferSize


ID_PROJECT_ASMCYCLETIME

Interne ID: ID_PROJECT_ASMCYCLETIME

Ciclo de almacenamiento

Defina el intervalo en el que los datos de las alarmas se deben escribir del búfer a la base de datos. Por razones de rendimiento el Industrial Performance Analyzer (IPA) no mantiene una conexión permanente con la base de datos. Determine con ayuda del ciclo de almacenamiento la frecuencia con la que se deben escribir los datos en la base de datos.

Introduzca el intervalo de tiempo en formato HH:MM:SS.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AsmCycleTime


ID_PROJECT_ASMDNS

Interne ID: ID_PROJECT_ASMDNS

Base de datos

Defina aquí la conexión a una base de datos compatible con ODBC (p. ej. Microsoft SQL-Server) en la que el Industrial Performance Analyzer deba guardar los datos de las alarmas. Haciendo clic izquierdo sobre botón se abre un diálogo para seleccionar la fuente de datos. Si todavía no ha creado ninguna fuente de datos, puede hacerlo ahora con ayuda de este diálogo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AsmDns


ID_PROJECT_ASMPREDEFFILTER

Interne ID: ID_PROJECT_ASMPREDEFFILTER

Predefinir filtro de tiempo

Al analizar los datos de alarmas en la pantalla del tipo Industrial Performance Analyzer en el runtime se pueden establecer filtros de tiempo como ayuda para ver sólo las alarmas de un determinado periodo.

Haciendo clic izquierdo sobre el botón se abre un diálogo para definir los filtros de tiempo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PredefFilter


ID_PROJECT_ASMTABLE

Interne ID: ID_PROJECT_ASMTABLE

Nombre de tabla

Introduzca un nombre para la tabla del Industrial Performance Analyzers en la base de datos compatible con ODBC. Si todavía no existe una tabla con ese nombre, al iniciar el runtime se creará automáticamente.

Observación: Para que el nombre de la tabla sea válido sólo puede contener caracteres alfanuméricos y/o espacios y no puede empezar con un número. No puede contener más de 128 caracteres.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AsmTable


ID_PROJECT_BACKUPTIME

Interne ID: ID_PROJECT_BACKUPTIME

Momento de la protección

Muestra el momento de la última copia de seguridad del proyecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackupTime


ID_PROJECT_BACKUPXML

Interne ID: ID_PROJECT_BACKUPXML

Exportación XML activada

Activado: En cada protección del proyecto se incluirá un archivo ZIP (Version.zip). Éste archivo contiene 24 archivos XML con las protecciones para los módulos individuales.

Observación: En proyectos multiusuario solo con la protección local.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackupWithXML


ID_PROJECT_DBD_SERVER

Interne ID: ID_PROJECT_DBD_SERVER

Servidor de base de datos

Esta propiedad solo se puede introducir al crear un proyecto.
Muestra el servidor de base de datos de un proyecto multiusuario.
Si no hay ninguna entrada significa que el proyecto no es multiusuario y que la base de datos del proyecto está archivada en el ordenador local.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DatabaseServer


ID_PROJECT_IPA_ALARMCAUSELIST

Interne ID: ID_PROJECT_IPA_ALARMCAUSELIST

Causas de alarma

En la pantalla del tipo Industrial Performance Analyzer a cada alarma registrada se le puede asignar una causa de alarmas de una lista. Se pueden filtrar las causas de alarmas.

La lista de las causas de alarmas se administra aquí.

Haciendo clic izquierdo sobre el botón se abre un diálogo para definir las posibles causas de alarmas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AsmAlarmCauseListe


ID_PROJECT_IPA_SHIFTINFOPFS

Interne ID: ID_PROJECT_IPA_SHIFTINFOPFS

Turno de PFS

Toma las horas para los turnos definidos del módulo del Production & Facility Scheduler (PFS). Las horas de los turnos se administrarán allí.

Activado: El turno actual correspondiente a la alarma se lee del Production & Facility Scheduler (PFS).
Desactivado: El turno actual correspondiente a la alarma se lee de una variable vinculada y una lista definida.
Por defecto: activado.
Atención: El Production & Facility Scheduler es un módulo opcional para el que necesita licencia si desea utilizarlo aquí.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AsmShiftInfoPFS


ID_PROJECT_IPA_SHIFTINFOVARIABLE

Interne ID: ID_PROJECT_IPA_SHIFTINFOVARIABLE

Turno tomado de la variable

Sólo disponible si ha activado IPA activado. Además tiene que estar desactivado Turno del PFS.

Nombre de la variable cuyo valor proporciona información sobre el turno actual. Seleccione una variable del tipo INT. Con ella podrá crear el siguiente modelo de turnos.
Por ejemplo:

1 = Turno de mañana, 2 = Turno de tarde, 3 = Turno de noche, -1 = Descanso. La descripción del turno para el análisis se puede definir mediante la propiedad Nombre del turno de la lista.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AsmShiftInfoVariable


ID_PROJECT_IPA_SHIFTLIST

Interne ID: ID_PROJECT_IPA_SHIFTLIST

Nombre de turno de la lista

Sólo disponible si ha activado IPA activado. Además tiene que estar desactivado el Nombre del turno del PFS.

Aquí puede definir el nombre para los valores de la variable que ha vinculado al Turno de la variable.

Haciendo clic izquierdo sobre el botón se abre un diálogo para asignar nombres a valores individuales.

A los nombres de turnos se les pueden asignar los valores de una variable vinculada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AsmShiftNameListe


ID_PROJECT_IPA_SHIFTPFS

Interne ID: ID_PROJECT_IPA_SHIFTPFS

Nombre de turno de PFS

Toma los nombres de los turnos definidos del módulo del Production & Facility Scheduler (PFS). Los nombres de los turnos se administran allí.

Activado: El turno actual correspondiente a la alarma se lee del Production & Facility Scheduler (PFS).
Desactivado: El turno actual correspondiente a la alarma se lee de una variable vinculada y una lista definida.
Por defecto: activado.

Atención: El Production & Facility Scheduler es un módulo opcional para el que necesita licencia si desea utilizarlo aquí.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AsmShiftNamePFS


ID_PROJECT_IPA_USRLEVEL

Interne ID: ID_PROJECT_IPA_USRLEVEL

Para eliminar

Con la pantalla del tipo Industrial Performance Analyzer se pueden eliminar durante el runtime los datos de alarmas que se encuentren en la base de datos. Para evitar que se produzcan abusos puede configurar el tipo de autorización que debe tener el usuario para eliminar entradas.

Seleccione la autorización de uso deseada del menú desplegable.

Por defecto: 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AsmUsrLvl


ID_PROJECT_IPA_USRLEVELCAUSE

Interne ID: ID_PROJECT_IPA_USRLEVELCAUSE

Para editar

Con la pantalla del tipo Industrial Performance Analyzer se pueden editar durante el runtime los datos de alarmas que se encuentren en la base de datos. Para evitar que se produzcan abusos puede configurar el tipo de autorización que debe tener el usuario para editar entradas.

Seleccione la autorización de uso deseada del menú desplegable.

Por defecto: 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AsmUsrLvlCause


ID_PROJECT_MAIN_TEMPLATES

Interne ID: ID_PROJECT_MAIN_TEMPLATES

Marcos principales

Nombre de los marcos que aparecerán en la variable driver del sistema Última pantalla abierta. Haciendo clic sobre ... se abre un diálogo para seleccionar un marco.

Observaciones:

  • Esta propiedad afecta a la función Pantalla anterior.
  • Si se modifica el nombre de un marco, habrá que volverlo a introducir aquí, cuando sea necesario. Sino la variable del driver del sistema Última pantalla abierta no podrá identificar las pantallas basadas en ese marco.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MainTemplates


ID_PROJECT_MULTIUSER

Interne ID: ID_PROJECT_MULTIUSER

Proyecto multiusuario

Activado: El proyecto se utilizará como proyecto multiusuario. En el árbol del proyecto hay un nodo adicional "En progreso".

Desactivado: El proyecto se utilizará como proyecto individual.

Por defecto: desactivado

Esta propiedad se puede activar solo con el menú contextual del proyecto.

ATENCIÓN: Si se activa esta propiedad será de forma irreversible, no se podrá anular. Lo que se puede hacer es hacer una copia de seguridad de un proyecto multiusuario de forma que quede convertido en un nuevo proyecto individual.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MultiUser


ID_PROJECT_RTVERSION

Interne ID: ID_PROJECT_RTVERSION

Crear archivos RT para

Selección de la versión para la que se crean los archivos runtime:

  • 6.20 SP4: Los archivos runtime se crean para la versión 6.20 Servicepack 4.
  • 6.21 SP0: Los archivos runtime se crean para la versión 6.21 Servicepack 0.
  • 6.21 SP1: Los archivos runtime se crean para la versión 6.21 Servicepack 1.
  • 6.22 SP0: Los archivos runtime se crean para la versión 6.22 Servicepack 0.
  • 6.22 SP1: Los archivos runtime se crean para la versión 6.22 Servicepack 1.
  • 6.50 SP0: Los archivos runtime se crean para la versión 6.50 Servicepack 0.
  • 6.51 SP0: Los archivos runtime se crean para la versión 6.51 Servicepack 0.
  • 7.00 SP0: Los archivos runtime se crean para la versión 7.00 Servicepack 0.
  • 7.10 SP0: Los archivos runtime se crean para la versión 7.10 Servicepack 0.
  • 7.11 SP0: Los archivos runtime se crean para la versión 7.11 Servicepack 0.
  • 7.20 SP0: Los archivos runtime se crean para la versión 7.20 Servicepack 0.
  • Por defecto: Los archivos runtime se crean para la versión actual del editor.

Atención: Para garantizar la consistencia de los archivos runtime, después de cada modificación de esta propiedad se deberán volver a crear todos los archivos runtime. También se convertirán las configuraciones de todos los drivers. Las configuraciones que no existan en la versión correspondiente se establecerán por defecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RTVersion


ID_PROJECT_RUNTIMELASSO

Interne ID: ID_PROJECT_RUNTIMELASSO

Lazo de runtime

Activado: Moviendo el ratón con el botón izquierdo presionado se pueden seleccionar varios elementos en el runtime. Se puede acceder a estos elementos con una macro VBA.
Desactivado: No se utiliza la funcionalidad de lazo.
Por defecto: desactivado
Observación: El lazo solo funciona con elementos que sean 'accesibles a través del teclado' y que estén vinculados a una variable o función. No se eligen elementos estáticos. La función lazo se puede activar o desactivar para elementos individuales de pantalla con la propiedad Runtime/Seleccionable con lazo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RuntimeLasso


ID_PROJECT_USEVERSION

Interne ID: ID_PROJECT_USEVERSION

Versionar activado

Activado: Se utilizará el versionado de proyectos. Cada copia de seguridad del proyecto se guardará con un número de versión propio.

Desactivado: ningún versionado de las copias de seguridad del proyecto.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VersionActive


ID_PROJECT_VERSIONDETAIL

Interne ID: ID_PROJECT_VERSIONDETAIL

Número de detalle

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VersionDetail


ID_PROJECT_VERSIONNUMBER

Interne ID: ID_PROJECT_VERSIONNUMBER

Versión principal

Solo disponible si la propiedad Versionar activado está activada.

Número a otorgar por el usuario. Éste se completará de forma interna con un número de detalle, separado por un punto y se representará como Versión del proyecto.

Atención: Las modificaciones aleatorias de este número afectarán a la consistencia del versionado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VersionNumber


ID_PROJECT_VERSIONS

Interne ID: ID_PROJECT_VERSIONS

Versionar

Propiedades para el versionado de copias de seguridad del proyecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Versioning


ID_PROJECT_VERSIONSTRING

Interne ID: ID_PROJECT_VERSIONSTRING

Versión del proyecto

Solo disponible si la propiedad Versionar activado está activada.

Muestra la versión del proyecto. El número de versión se compone del número otorgado por el usuario de la Versión principal y el número de detalle interno después del punto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VersionString


ID_PROJECT_ZOOM_STEPS

Interne ID: ID_PROJECT_ZOOM_STEPS

Niveles de zoom para vista global

Se abrirá el diálogo para definir el nivel de zoom de la funcionalidad de pantalla global.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ZoomSteps


ID_PROJEKT_ADAM

Interne ID: ID_PROJEKT_ADAM

Conexión AD-LDS

Ruta de conexión para ADAM o AD LDS.

La ruta de conexión debe introducirse de la siguiente manera: [PC-Name]:[Port]/[Organisation]

Por ejemplo: w3k:50000/O=720,c=com

Más sobre AD LDS en el manual online.

Más sobre ADAM en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ADAM


ID_PROJEKT_ADAM_PWD

Interne ID: ID_PROJEKT_ADAM_PWD

Contraseña AD-LDS

Contraseña del usuario local del ordenador ADAM/AD LDS.

Más sobre AD LDS en el manual online.

Más sobre ADAM en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ADAMPwd


ID_PROJEKT_ADAM_USER

Interne ID: ID_PROJEKT_ADAM_USER

Nombre de usuario AD-LDS

Nombre de usuario de un usuario local del ordenador ADAM/AD LDS con derechos de administrador.

Más sobre ADAM en el manual online.

Más sobre ADAM en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ADAMUser


ID_PROJEKT_ALARM_CEL

Interne ID: ID_PROJEKT_ALARM_CEL

AML y CEL

Propiedades para las alarmas en la lista cronológica de eventos (CEL).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_AML_CEL


ID_PROJEKT_ALLGEMEIN

Interne ID: ID_PROJEKT_ALLGEMEIN

General

Propiedades generales del proyecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Project


ID_PROJEKT_ALT_PATH

Interne ID: ID_PROJEKT_ALT_PATH

Carpeta de datos

Vacío: La ruta estándar se utilizará para guardar la lista de mensajes de alarma, la lista cronológica de eventos (CEL), datos del disco duro, datos de archivos, etc. (Ruta del proyecto\Nombre del ordenador\Nombre del proyecto).
Ruta: La ruta que se introduzca aquí se utilizará para guardar los datos ("Ruta introducida\Nombre del ordenador\Nombre del proyecto").
Atención: En caso de que la ruta no exista (por problemas de red o porque no haya un medio transportable), el runtime no escribirá más datos. Esto supone: Pérdida de datos del 100%. El runtime se sigue pudiendo manejar pero hay que reiniciarlo. La disponibilidad de la carpeta se puede comprobar con las variables driver del sistema Carpeta de datos runtime no disponible.
Consejo: No coloque nunca la carpeta de datos en una unidad de disco extraíble como un lápiz USB ni en una unidad de disco en la red. Lo mejor es grabar los datos localmente y asegurarlos externamente.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AltDataPath


ID_PROJEKT_AML

Interne ID: ID_PROJEKT_AML

Lista de mensajes de alarma

Propiedades para la configuración de alarmas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_AML


ID_PROJEKT_AUTOMATIC_FUNC

Interne ID: ID_PROJEKT_AUTOMATIC_FUNC

Ejecución automática de función

Propiedades para la ejecución automática de funciones.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_AutoFunc


ID_PROJEKT_AUTOMATIC_FUNCTION

Interne ID: ID_PROJEKT_AUTOMATIC_FUNCTION

Función

Solo disponible si la propiedad Ejecución automática de función activada. está activada:
Función que se ejecutará después de trancurrir el tiempo sin operaciones.
Si se debe ejecutar más de una función se deberá crear un script con las funciones deseadas y vincular aquí la función para ejecutar el script.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Function


ID_PROJEKT_AUTOMATIC_FUNCTION_ACTIVE

Interne ID: ID_PROJEKT_AUTOMATIC_FUNCTION_ACTIVE

Ejecución automática de función activada.

  • Activado: Ejecución automática de función cuando el ordenador no se utilice durante el periodo de tiempo determinado en la propiedad Tiempo sin operaciones (en minutos). Selección de la función a ejecutar mediante la propiedad Función.
  • Desactivado: Ninguna ejecución automática de función.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FuncActive


ID_PROJEKT_AUTOMATIC_FUNCTION_TIME

Interne ID: ID_PROJEKT_AUTOMATIC_FUNCTION_TIME

Tiempo sin operaciones (en minutos)

Solo disponible si la propiedad Ejecución automática de función activada. está activada:
periodo de tiempo que debe transcurrir sin realizar ninguna operación para que se ejecute la función definida.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FuncActiveTime


ID_PROJEKT_BLINK_FREQUENCY

Interne ID: ID_PROJEKT_BLINK_FREQUENCY

Frecuencia parpadeo [déc. de seg.]

Frecuencia de parpadeo de elementos dinámicos en décimas de segundo (p. ej. La entrada 5 corresponde a un parpadeo cada 1/2 segundo).

  • Mínimo: 0
  • Máximo: 2147483647
  • Por defecto: 5

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BlinkRate


ID_PROJEKT_CEL

Interne ID: ID_PROJEKT_CEL

Lista cronológica de eventos

Propiedades para la administración de la lista cronológica de eventos (CEL).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_CEL


ID_PROJEKT_CHANGELOG

Interne ID: ID_PROJEKT_CHANGELOG

Histórico de modificaciones

Propiedades para el histórico de cambios.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ChangeLog


ID_PROJEKT_CHANGELOG_AKTIV

Interne ID: ID_PROJEKT_CHANGELOG_AKTIV

Histórico de modificaciones activado

Activado: Las modificaciones en el proyecto se protocolizarán también.
Desactivado: Las modificaciones en el proyecto no se protocolizarán.
Por defecto: desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ChangeLogAktiv


ID_PROJEKT_CHANGELOG_AUTOCHECKOUT

Interne ID: ID_PROJEKT_CHANGELOG_AUTOCHECKOUT

Permitir modificaciones automáticamente

Solo disponible en proyectos multiusuario y si el histórico de cambios está activado:
Activado: Se permitirán automáticamente los cambios en las entradas de la lista cuando se inserten comentarios. Se tendrán que hacer a mano.
Desactivado: Solo se podrán insertar comentarios después de que se hayan permitido modificaciones para las entradas antes a mano.
Por defecto: desactivado.

ATENCIÓN: Esta funcionalidad requiere mucha potencia cuando está activada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ChangeLogCheckout


ID_PROJEKT_CHANGELOG_DETAIL

Interne ID: ID_PROJEKT_CHANGELOG_DETAIL

Nivel de detalle

Solo disponible si la propiedad Histórico de modificaciones activado está activada.

Selección del paso detallado de la lista desplegable:

  • Objeto: Solo se grabarán los nombres de objetos de los objetos modificados. Los detalles sobre las propiedades modificadas y sus valores no aparecerán en el histórico de cambios.
  • Propiedades: Además del nombre del objeto se grabarán en el histórico las propiedades modificadas así como sus valores nuevos.
  • Cambios de valor: Esta configuración ofrece el nivel mayor posible de grabación. Junto con el valor nuevo de una propiedad se guardará también el valor antiguo. Así es posible un rastreo completo de los cambios de valor.

Por defecto: Propiedades

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ChangeLogState


ID_PROJEKT_CURSOR_VISIBLE

Interne ID: ID_PROJEKT_CURSOR_VISIBLE

Cursor visible

  • Activado: El puntero del ratón estará visible durante el runtime.
  • Desactivado: El puntero del ratón no se mostrará durante el runtime. En proyectos con pantalla táctil la visualización del puntero del ratón puede resultar molesta por lo que se puede desactivar con esta propiedad.

Por defecto: activado
Atención: Esta configuración afecta solo a zenon pero no a elementos estándar de Windows como líneas de título, menús, barras de desplazamiento, etc. Para los elementos de Windows hay que desactivar el puntero del ratón directamente en el sistema operativo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CursorVisible


ID_PROJEKT_DRIVER_INVISIBLE

Interne ID: ID_PROJEKT_DRIVER_INVISIBLE

Driver oculto

Activado: Los drivers iniciados no se mostrarán durante el runtime en la barra de tareas de Windows.

Desactivado: Los drivers iniciados se mostrarán durante el runtime en la barra de tareas de Windows.

Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DriverInvisible


ID_PROJEKT_ENABLEMENU

Interne ID: ID_PROJEKT_ENABLEMENU

Menús principales activados

Mostrar menús principales durante el runtime:

  • Activado: En el margen superior de la ventana de runtime se reservará una barra para la visualización del menú .
  • Desactivado: No se mostrará ningún menú principal en el runtime.

Por defecto: desactivado
Atención: Cuando se utilicen menús principales se deberá activar esta opción.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EnableMenu


ID_PROJEKT_EXPORT_UNICODE

Interne ID: ID_PROJEKT_EXPORT_UNICODE

Exportación de texto en Unicode

Activado: Exportación de texto en archivos Unicode.
Desactivado: Exportación de texto en archivos ANSI.
Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ExportUnicode


ID_PROJEKT_GDIPLUS

Interne ID: ID_PROJEKT_GDIPLUS

Calidad gráfica

Configuración de la calidad de la representación gráfica.
DirectX permite una calidad mayor que Windows Basis. En principio, al utilizar DirectX es preferible la configuración DirectX Hardware y utilizar solamente DirectX Software cuando sea imprescindible. Selección posible:

  • Windows Basis: Propiedades gráficas básicas. Recomendado para hardware poco potente.
  • DirectX Software: El CPU realiza el cálculo gráfico por lo que utilizará una mayor capacidad.
  • DirectX Hardware: Parte de los cálculos gráficos se transferirán a la tarjeta gráfica Si el sistema no es compatible con la configuración cambiará automáticamente a DirectX Software.

Por defecto: DirectX Hardware.

Atención: DirectX no está disponible con Windows CE. DirectX no se puede utilizar para OCX.

Observaciones:
Al cambiar el modo durante la proyección pueden producirse leves desviaciones de píxeles. La propiedad deberá establecerse por lo tanto antes de crear las pantallas.
Al activar Windows Basis todos los tipos de línea que utilicen Ancho de línea [píxeles] >1 se restablecerán como Línea continua.
Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UseGDIplus


ID_PROJEKT_GRP0

Interne ID: ID_PROJEKT_GRP0

Imprimir

Propiedades para la impresión online de la lista de mensajes de alarma (AML) o de la lista cronológica de eventos (CEL).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Print


ID_PROJEKT_GRP1

Interne ID: ID_PROJEKT_GRP1

Nombre/Carpeta

Propiedades para el nombre y el espacio de memoria del proyecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_PROJEKT_GRP2

Interne ID: ID_PROJEKT_GRP2

Configuraciones de runtime

Propiedades para el comportamiento del runtime en el proyecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Runtime


ID_PROJEKT_GRP3

Interne ID: ID_PROJEKT_GRP3

Teclado

Propiedades para el manejo táctil.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Touch


ID_PROJEKT_GRP4

Interne ID: ID_PROJEKT_GRP4

Logout automático

Propiedades para un log off automático.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_AutoLogout


ID_PROJEKT_GRP5

Interne ID: ID_PROJEKT_GRP5

Login y firma

Propiedades para un log in temporal.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_TempLogin


ID_PROJEKT_GRP6

Interne ID: ID_PROJEKT_GRP6

Industrial Performance Analyzer

Propiedades para el Industrial Performance Analyzer (IPA).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_IPA


ID_PROJEKT_GRP7

Interne ID: ID_PROJEKT_GRP7

Diseño gráfico

Propiedades para la visualización gráfica del runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Graphics


ID_PROJEKT_GRP8

Interne ID: ID_PROJEKT_GRP8

Almacenamiento datos IPA

Propiedades para el almacenamiento de datos del Industrial Performance Analyzer (IPA).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Storage


ID_PROJEKT_GRP9

Interne ID: ID_PROJEKT_GRP9

Evaluación

Propiedades para el análisisde los datos del Industrial Performance Analyzer (IPA).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Analysis


ID_PROJEKT_GRP10

Interne ID: ID_PROJEKT_GRP10

General

Propiedades generales para el archivo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_PROJEKT_GRP11

Interne ID: ID_PROJEKT_GRP11

General

Propiedades generales para el proyecto zenon Logic.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

General


ID_PROJEKT_GRP12

Interne ID: ID_PROJEKT_GRP12

General

Propiedades generales para la copia de seguridad.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_PROJEKT_GRP13

Interne ID: ID_PROJEKT_GRP13

Elementos bloqueados/interbloqueados

Propiedades para mostrar elementos bloqueados.
Los elementos que estén bloqueados por un grupo de autorización o un interbloqueo se representarán con un símbolo de candado o con cualquier otro gráfico libremente elegible.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_LockSymbol


ID_PROJEKT_GRP14

Interne ID: ID_PROJEKT_GRP14

Pantallas

Propiedades para mostrar las pantallas en el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Pictures


ID_PROJEKT_GRP15

Interne ID: ID_PROJEKT_GRP15

Industrial Maintenance Manager

Propiedades del Industrial Maintenance Manager (IMM). Estas propiedades sólo están disponibles cuando se tiene la licencia para el Industrial Maintenance Manager.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_IMM


ID_PROJEKT_GRP16

Interne ID: ID_PROJEKT_GRP16

Autorizaciones

Autorizaciones de uso para eliminar y editar entradas en la base de datos del Industrial Performance Analyzer (IPA).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Rights


ID_PROJEKT_GRP17

Interne ID: ID_PROJEKT_GRP17

Runtime general

Contiene las configuraciones para el runtime.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_RuntimeGeneral


ID_PROJEKT_GRP18

Interne ID: ID_PROJEKT_GRP18

Active Directory/AD-LDS

Propiedades para la configuración de

- Active Directory (AD)

- Active Directory Application Mode (ADAM)

- Active Directory Lightweight Directory Services (AD LDS)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ActiveDirectory


ID_PROJEKT_GRP19

Interne ID: ID_PROJEKT_GRP19

Selección de colores para las listas de objetos

Configuración de colores para resaltar los elementos con foco en listas configurables. Estas propiedades afectarán a las siguietes listas:

  • Active Directory:
    • Lista en la ventana de Active Directory (pero no: árbol)
  • AML
  • Filtro AML/filtro CEL/filtro de tiempo:
    • Lotes: Selección de archivo
    • Lotes: Selección de lotes
  • Lote:
    • Lista de las recetas maestras
    • Lista de las recetas de control
  • CEL
  • Lista de usuarios:
    • Lista de usuarios
  • Tendencia ampliada:
    • Lista de curvas ampliada
  • Message Control
    • Cola de espera de mensajes
  • RGM:
    • Lista de recetas y tabla de valores de receta (pero no: tabla de valores de receta CE)

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

GFX_Lists


ID_PROJEKT_GRP_INTERACTION

Interne ID: ID_PROJEKT_GRP_INTERACTION

Interacción

Propiedades para el manejo Multi-Touch.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Interaction


ID_PROJEKT_GUID

Interne ID: ID_PROJEKT_GUID

ID del proyecto

Cada proyecto se identificará con un GUID unívoco. Esta propiedad no se podrá modificar.
Es también el nombre del subdirectorio donde está guardado el proyecto en el directorio SQL.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GUID


ID_PROJEKT_KEYBOARD_SIZE

Interne ID: ID_PROJEKT_KEYBOARD_SIZE

Tamaño del teclado [%]

Define el tamaño en porcentaje – partiendo del tamaño original – en que se representará el teclado automático en el runtime.
Mínimo: 50 %
Máximo: 300 %
Por defecto: 100 %

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

KeyboardSize


ID_PROJEKT_LIMIT_FUNCTION_ON_START

Interne ID: ID_PROJEKT_LIMIT_FUNCTION_ON_START

Ejecutar función límite al iniciar runtime

Ejecución de las funciones límite al iniciar el runtime con violación actual del límite

  • Activado: Al iniciar el runtime se ejecutará nuevamente una función vinculada al límite actual.
  • Desactivado: Al iniciar el runtime no se ejecutará nuevamente una función vinculada al límite actual.

Por defecto: activado.
Atención: ¡Esta propiedad afecta sólo a los valores límites que no sean alarmas!
Ejemplos:

  • Ejemplo 1: El runtime finaliza sin que se haya violado ningún límite. Posteriormente se viola un límite y después se inicia el runtime. Cuando el límite violado sea una alarma, se ejecutará la función vinculada al iniciar el runtime. Cuando el límite no es una alarma, se utilizará la configuración de esa propiedad.
  • Ejemplo 2: El runtime finaliza habiéndose violado un límite que no sea una alarma. La función vinculada se ejecuta en el momento en el que se haya violado el límite. Cuando el runtime se inicia de nuevo, este límite sigue estando violado. Dependiendo de esta propiedad se ejecutará de nuevo la función vinculada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LimitFunctionOnStart


ID_PROJEKT_MAIN_WINDOW

Interne ID: ID_PROJEKT_MAIN_WINDOW

Título runtime

Representación de la ventana principal del runtime.

  • Ningún título: Representación de toda la superficie. La barra de título no se mostrará
  • Título con botón min. y max.: Se puede cambiar el tamaño de la ventana así como desplazarla. No se puede cerrar (ni en el menú contextual, ni en la barra de tareas ni con combinación de teclas Alt+F4). Haciendo clic derecho sobre la barra de título se abre el menú contextual.
  • Título con sistema, botón min. y max.: Se puede cambiar el tamaño de la ventana así como desplazarla, también se puede cerrar haciendo clic sobre el botón X. Haciendo clic derecho sobre la barra de título se abre el menú contextual.
  • Título con menú del sistema: Se puede desplazar la ventana y también se puede cerrar haciendo clic sobre el botón X. Haciendo clic derecho sobre la barra de título se abre el menú contextual.
  • Título sin botones: Se puede desplazar la ventana y también se puede cerrar haciendo clic sobre el botón X. Haciendo clic derecho sobre la barra de título se abre el menú contextual.

Por defecto: Ningún título

Atención: Cuando se modifica esta propiedad en el editor hay que reiniciar el runtime Con solo recargar no funciona debido a que para adoptar la ventana principal hay que cerrar primero el runtime y después volver a abrirlo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MainWindowStyle


ID_PROJEKT_MULTITOUCH

Interne ID: ID_PROJEKT_MULTITOUCH

Multitouch activado

Activado: Se puede utilizar Multi-Touch. Se desactivarán los gestos (pequeños movimientos de arrastre) y los clic derechos (pulsar y mantener).
Requisitos: Que existan todos los drivers y dispositivos correspondientes. El dispositivo tiene que estar conectado y activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MultiTouch


ID_PROJEKT_NAME

Interne ID: ID_PROJEKT_NAME

Nombre del proyecto

Nombre unívoco del proyecto.
Sirve para una mejor legibilidad, internamente se utilizará por lo general GUID.

Están permitidos: Las cifras, las letras y los siguientes caracteres especiales: $, -, @, _, {}, ~, !, ()
Observación: Tenga en cuenta al cambiar el nombre del proyecto que tendrá que ajustar las posibles referencias superpuestas en proyectos de integración o las variables, funciones y VBA utilizadas de manera superpuesta en varios proyectos. Utilice para ello el Diálogo para sustituir referencias de proyectos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_PROJEKT_NETWORK_REDUNDANCY_GRP

Interne ID: ID_PROJEKT_NETWORK_REDUNDANCY_GRP

Configuraciones para redundancia

Propiedades para la configuración de la redundancia.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_NetRed


ID_PROJEKT_NETZ

Interne ID: ID_PROJEKT_NETZ

Red

Propiedades para la utilización del proyecto en una red.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Net


ID_PROJEKT_NETZ_AKTIV

Interne ID: ID_PROJEKT_NETZ_AKTIV

Red activa

Activado: El proyecto se utilizará como proyecto de red. Hay que definir un servidor.
Desactivado: El proyecto es un proyecto Standalone.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NetActive


ID_PROJEKT_NETZ_DATENSERVER

Interne ID: ID_PROJEKT_NETZ_DATENSERVER

Servidor 2 como servidor de datos

El servidor definido aquí está conectado al hardware y hace un bucle con los datos al servidor. Solo disponible si en la propiedad Servidor 2 hay definido un ordenador.

Activado: Servidor 2 se utilizará como servidor de datos.

Desactivado: Servidor 1 se utilizará como servidor de datos.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NetDataServer


ID_PROJEKT_NETZ_REDUNDANZTYP

Interne ID: ID_PROJEKT_NETZ_REDUNDANZTYP

Tipo de redundancia

¡Sólo disponible después de que se haya registrado un ordenador para la propiedad Servidor 2!

zenon es compatible con dos tipos de redundancia:

  • Redundancia de software: El sistema consiste en un control y dos ordenadores redundantes con sistema de control. Ambos ordenadores tienen que estar conectados al control. Ambos ordenadores se comunican con el control y al mismo tiempo mantienen actualizados los datos del control. El ordenador con función de servidor se encarga de la comunicación con el control. El servidor se comunica de forma bidireccional y el standy, unidireccional. Si cae el servidor, el servidor standby se encargaría de la comunicación bidireccional con el control.
  • Redundancia del hardware: El sistema consiste en dos controles redundantes y en dos ordenadores redundantes con sistema de control. Cada ordenador se comunica de manera bidireccional con un control. Ambos ordenadores y ambos controles sincronizan sus datos. En caso de que un componente del primer sistema fallara, el segundo tomaría sus funciones.

Por defecto: Redundancia de software

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NetType


ID_PROJEKT_NETZ_ROUTING_AKTIV

Interne ID: ID_PROJEKT_NETZ_ROUTING_AKTIV

Routing activado

  • Activado: El ordenador funciona como calculadora de nodos y puede rutar paquetes. Así todos los paquetes de red de afuera pasan por este ordenador
    Esta configuración puede dar lugar a cuellos de botella e influye en las posibles topologías de red. Es conveniente su utilización en constelaciones de red especiales como p. ej. redes WAN o redes rutadas.

Recomendación: Desactivar la configuración.

Por defecto: Desactivado

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NetRoutingActive


ID_PROJEKT_NETZ_SB

Interne ID: ID_PROJEKT_NETZ_SB

Servidor 2

Solo disponible si en la propiedad Servidor 1 hay un ordenador registrado.

Haciendo clic sobre ... se abre un diálogo con una lista de los ordenadores disponibles en la red.
En sistemas redundantes este ordenador se encargará de ocupar la posición del servidor primario en caso de que éste cayera. La caída se percibirá cuando el servidor primario no reaccione durante el tiempo definido en la propiedad Network communication timeout en el Startup Tool. Un búfer específico en el standby puenteará el tiempo muerto entre la caída del servidor y su puesta en marcha para evitar que se pierdan datos.

Observación para el nombre: "localhost" no se puede utilizar como nombre.
Si se cambia el nombre no se podrá recargar. No se actualizará hasta que se vuelva a reiniciar el runtime.
Atención: El servidor primario y el standby tienen que tener la misma hora del sistema.
Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NetSB


ID_PROJEKT_NETZ_SERVER

Interne ID: ID_PROJEKT_NETZ_SERVER

Servidor 1

Solo disponible si está activada la propiedad Red activa.
Ordenador que en los proyectos de red establece la conexión con el hardware y administra los datos de los proyectos. Las máquinas clientes se conectan a este ordenador.

Haciendo clic sobre ... se abre un diálogo con una lista de los ordenadores disponibles en la red.

Observación para el nombre: La dirección IP no es suficiente, se requiere introducir el nombre del ordenador. "localhost" no se puede utilizar como nombre.
Si se cambia el nombre no se podrá recargar. No se actualizará hasta que se vuelva a reiniciar el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NetServer


ID_PROJEKT_NETZ_TIMEOUT

Interne ID: ID_PROJEKT_NETZ_TIMEOUT

Timeout [s]

Solo disponible si la propiedad Red activa está activada.

Intervalo de tiempo en segundos en el que el ordenador tiene que reaccionar ante un perro guardián. El tiempo definido aquí se dividirá en tercios y después cada tercio un perro guardián se encargará de comprobar la conexión al servidor. Si el servidor reacciona ante por lo menos uno de los tres perro guardianes se entenderá que hay conexión al servidor. La comunicación al servidor se comprobará únicamente con esta funcionalidad perro guardián.
Atención: El timeout de la red tiene que suponer por lo menos la mitad del timeout TCP del sistema operativo.

Tenga en cuenta las particularidades de las Conexiones de marcado y WAN . La configuración estándar para el perro guardián aquí implica que la conexión estar establecida permanentemente.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NetTimeout


ID_PROJEKT_NETZ_TOKEN

Interne ID: ID_PROJEKT_NETZ_TOKEN

Licencia de uso

Propiedades para la autorización de uso en la red.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Token


ID_PROJEKT_NETZ_TOKEN_AKTIV

Interne ID: ID_PROJEKT_NETZ_TOKEN_AKTIV

Licencia de uso activada

Solo disponible si está activada la propiedad Red activa.
La autorización de uso en la red asegura que solo haya una estación en la red que pueda ejecutar operaciones al mismo tiempo (p. ej. modificar valores predeterminados). Lo que siempre será posible es un acceso pasivo de lectura.
Activado: Solo un ordenador a la vez puede editar el proyecto (p. ej. reconocer alarmas, establecer valores determinados).
Desactivado: Varios ordenadores a la vez pueden editar el proyecto.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NetTokenActive


ID_PROJEKT_NETZ_TOKEN_QUESTION

Interne ID: ID_PROJEKT_NETZ_TOKEN_QUESTION

Tiempo de espera para consulta [s]

Solo disponible si la propiedad Licencia de uso activada está activada.
Si una estación en la red bloquea la autorización de usuario se puede solicitar desde otro ordenador. Plazo de tiempo establecido para responder a la pregunta. Después de transcurrir el plazo sin respuesta, la estación requirente obtendrá automáticamente la autorización.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NetTokenQuestion


ID_PROJEKT_NETZ_TOKEN_QUIT

Interne ID: ID_PROJEKT_NETZ_TOKEN_QUIT

Tiempo de espera para la licencia de uso[s]

Solo disponible si la propiedad Licencia de uso activada está activada.
Dentro de este periodo el ordenador (cliente) que tenga la autorización de uso tiene que reportarse al servidor. En caso de que no se reporte, la autorización de uso se liberará automáticamente.
Atención: Este valor tiene que ser menor que el tiempo establecido en la propiedad Timeout [s].

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NetTokenQuit


ID_PROJEKT_NOT_TRANSLATED

Interne ID: ID_PROJEKT_NOT_TRANSLATED

Mostrar palabras clave no traducidas

Configuración para la representación de palabras clave que no existan en ningún archivo de idiomas:

Activado: Representación durante el runtime de una palabra clave, por ejemplo: @Texto.
Desactivado: Representación durante el runtime sin arroba @ previa, por ejemplo: Texto

Observación: Si la palabra clave existe en uno de los archivos de idiomas pero no hay una traducción, durante el runtime no se mostrará ningún texto (cadena vacía).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowNotTranslated


ID_PROJEKT_PASSWORT

Interne ID: ID_PROJEKT_PASSWORT

Administración de usuario

Propiedades relativas al proyecto para la administración de usuarios.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Password


ID_PROJEKT_POKEACK

Interne ID: ID_PROJEKT_POKEACK

Función configurar valor predeterminado

Solo disponible cuando la propiedad CEL activo esté activada.

  • Activado: Cuando los valores se han escrito con éxito en el hardware se producirá la correspondiente entrada en la CEL.
  • Desactivado: La escritura de estos valores no se protocolizará en la CEL.

Por defecto: Desactivado

Observación: Esta propiedad solo tendrá efecto durante el runtime cuando el establecimiento del valor predeterminado se ejecute con la función Escribir valor predeterminado .

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CELPokeAck


ID_PROJEKT_PRINT_ACTIVE

Interne ID: ID_PROJEKT_PRINT_ACTIVE

Impresión activa

Activado: La lista cronológica de eventos (CEL) o la lista de mensajes de alarma (AML) se imprimirá online: Para cada entrada en la lista AML o CEL el evento se enviará a la impresora definida en las propiedades del proyecto.
Desactivado: Ninguna impresión online.
Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PrintActive


ID_PROJEKT_PRINT_AML_CEL

Interne ID: ID_PROJEKT_PRINT_AML_CEL

Impresión para

Solo disponible si está activada la propiedad Impresión activa.
Permite seleccionar si se desea imprimir AML o CEL durante el runtime. Solo se puede imprimir una de las dos lista a la vez.

  • Lista de mensajes de alarma: La lista de mensajes de alarma (AML) se imprimirá online.
  • Lista cronológica de eventos: La lista cronológica de eventos (CEL) se imprimirá online:

Por defecto: Lista de mensajes de alarma

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PrintCEL


ID_PROJEKT_PRINT_LINES_PAGE

Interne ID: ID_PROJEKT_PRINT_LINES_PAGE

Filas por página

Solo disponible si está esté activada la propiedad Impresión activa.
Número de líneas por página que se imprimirán con la impresión online.
Mínimo: 0

Máximo: 65535
Por defecto:: 72

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PrintLines


ID_PROJEKT_PROP_GRP_INPUT_VISUALISATION_PEN

Interne ID: ID_PROJEKT_PROP_GRP_INPUT_VISUALISATION_PEN

Visualización de entrada para lápiz

Propiedades para la utilización de Multi-Touch con lápiz.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_PenInputVisualisation


ID_PROJEKT_PROP_GRP_INPUT_VISUALISATION_TOUCH

Interne ID: ID_PROJEKT_PROP_GRP_INPUT_VISUALISATION_TOUCH

Visualización de entrada para Touch

Propiedades para la utilización de Multi-Touch con los dedos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_TouchInputVisualisation


ID_PROJEKT_PROP_GRP_MULTITOUCH

Interne ID: ID_PROJEKT_PROP_GRP_MULTITOUCH

Multi-Touch

Propiedades para la utilización de Multi-Touch en el proyecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Multitouch


ID_PROJEKT_PROP_MULTITOUCH_MODE

Interne ID: ID_PROJEKT_PROP_MULTITOUCH_MODE

Evaluación

Selección de cómo interpretar los gestos Multi-Touch:

  • Desactivado: Desactiva Multitouch.
  • Windows 7: Activa los gestos respaldados por Windows 7. De esta manera se puede utilizar Multi-Touch para hacer zoom y desplazarse en la pantalla global y se puede implementar Multi-Touch mediante VSTA.
  • Windows 8: Activa los gestos respaldados por Windows 8. Así se puede parametrizar Multi-Touch ampliamente con las propiedades de zenon.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MultitouchMode


ID_PROJEKT_PROP_PEN_ACTIVE

Interne ID: ID_PROJEKT_PROP_PEN_ACTIVE

Activado

Activado: Las propiedades para el manejo táctil con lápiz están disponibles.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InputVisualisationPenActive


ID_PROJEKT_PROP_PEN_BARREL

Interne ID: ID_PROJEKT_PROP_PEN_BARREL

Stift-Taste

Activado: La opción Tecla lápiz está disponible para el manejo táctil con lápiz.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InputVisualisationPenBarrel


ID_PROJEKT_PROP_PEN_DOUBLETAP

Interne ID: ID_PROJEKT_PROP_PEN_DOUBLETAP

Doppelt Tippen

Activado: La opción Tecleo doble está disponible para el manejo táctil con lápiz.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InputVisualisationPenPenDoubleTap


ID_PROJEKT_PROP_PEN_PRESS_AND_HOLD

Interne ID: ID_PROJEKT_PROP_PEN_PRESS_AND_HOLD

Drücken und Halten

Activado: La opción Pulsar y mantener está disponible para el manejo táctil con lápiz.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InputVisualisationPenPressAndHold


ID_PROJEKT_PROP_PEN_RIGHTTAP

Interne ID: ID_PROJEKT_PROP_PEN_RIGHTTAP

Drücken und Tippen

Activado: La opción Pulsar y teclear está disponible para el manejo táctil con lápiz.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InputVisualisationPenRightTap


ID_PROJEKT_PROP_PEN_TAP

Interne ID: ID_PROJEKT_PROP_PEN_TAP

Tippen

Activado: La opción Teclear está disponible para el manejo táctil con lápiz.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InputVisualisationPenTap


ID_PROJEKT_PROP_TOUCH_ACTIVE

Interne ID: ID_PROJEKT_PROP_TOUCH_ACTIVE

Activado

Activado: Las propiedades para el manejo táctil con dedo están disponibles.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InputVisualisationTouchActive


ID_PROJEKT_PROP_TOUCH_CONTACT

Interne ID: ID_PROJEKT_PROP_TOUCH_CONTACT

Kontakt

Activado: La opción Contacto está disponible para el manejo táctil con dedo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InputVisualisationTouchContact


ID_PROJEKT_PROP_TOUCH_DOUBLETAP

Interne ID: ID_PROJEKT_PROP_TOUCH_DOUBLETAP

Doppelt Tippen

Activado: La opción Tecleo doble está disponible para el manejo táctil con dedo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InputVisualisationTouchDoubleTap


ID_PROJEKT_PROP_TOUCH_PRESS_AND_HOLD

Interne ID: ID_PROJEKT_PROP_TOUCH_PRESS_AND_HOLD

Drücken und Halten

Activado: La opción Pulsar y mantener está disponible para el manejo táctil con dedo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InputVisualisationTouchPressAndHold


ID_PROJEKT_PROP_TOUCH_RIGHTTAP

Interne ID: ID_PROJEKT_PROP_TOUCH_RIGHTTAP

Drücken und Tippen

Activado: La opción Pulsar y teclear está disponible para el manejo táctil con dedo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InputVisualisationTouchRightTap


ID_PROJEKT_PROP_TOUCH_TAP

Interne ID: ID_PROJEKT_PROP_TOUCH_TAP

Tippen

Activado: La opción Teclear está disponible para el manejo táctil con dedo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InputVisualisationTouchTap


ID_PROJEKT_RATED_NET_DETECT_OFF_TIME

Interne ID: ID_PROJEKT_RATED_NET_DETECT_OFF_TIME

Tiempo muerto después de conmutar [s]

Tiempo de espera (en segundos) para el cambio de servidor primario tras un cambio de nivel.

Sólo disponible si el Modo redundancia es Evaluado.

  • Mínimo: 0
  • Máximo: 65535

Por defecto: 10

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NetDetectOffTime


ID_PROJEKT_RATED_NET_HYSTERESIS

Interne ID: ID_PROJEKT_RATED_NET_HYSTERESIS

Histéresis

Histéresis en puntos de evaluación que deben sobrepasarse para que se active el retraso en la conmutación.

Sólo disponible si el Modo redundancia es Evaluado.

Mínimo: 0
Máximo: 4294967296

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NetHysteresis


ID_PROJEKT_RATED_NET_REDUNDANCY_MODE

Interne ID: ID_PROJEKT_RATED_NET_REDUNDANCY_MODE

Modo redundancia

Tipo del modo de redundancia para la evaluación de la red. Cuando el valor proyectado sea = Evaluado éste controlará la conmutación de la redundancia.

  • Dominante: No realiza ninguna evaluación.
  • No dominante: El resultado de la evaluación es siempre cero. No se realizará ninguna conmutación.
  • Evaluado: Se ejecutará una evaluación y se conmutará en consecuencia.

Por defecto: No dominante

Observación: Solo activado si el Tipo de redundancia es Redundancia de software.
No activado si Red activa está desactivado, si Tipo de redundancia es Redundancia de hardware o no se ha determinado ningún Servidor 1 y Servidor 2.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NetMode


ID_PROJEKT_RATED_NET_SUM

Interne ID: ID_PROJEKT_RATED_NET_SUM

Evaluaciones

Muestra la suma de la evaluación y el número de las variables definidas en la evaluación. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar y configurar las variables para la evaluación de la redundancia.
Sólo disponible si el Modo redundancia es Evaluado.

Por defecto: vacío.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NetSummarization


ID_PROJEKT_RATED_NET_SWITCH_DELAY

Interne ID: ID_PROJEKT_RATED_NET_SWITCH_DELAY

Retraso de conmutación [s]

Tiempo de retraso (en segundos) para el ascenso a servidor primario.

Sólo disponible si el Modo redundancia es Evaluado.

  • Mínimo: 0
  • Máximo: 65535

Por defecto: 30 s

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NetSwitchDelay


ID_PROJEKT_SAME_COMMENTS

Interne ID: ID_PROJEKT_SAME_COMMENTS

Mismos comentarios

Activado: Los comentarios que se añadan a una alarma durante el runtime se archivarán también en la entrada correspondiente de la lista cronológica de eventos (CEL).
Desactivado: Los comentarios de una alarma solo se archivarán en la lista de mensajes de alarma.
Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SameComments


ID_PROJEKT_SCHALTFOLGEN

Interne ID: ID_PROJEKT_SCHALTFOLGEN

Secuencias de comandos

Propiedades referidas al proyecto para el módulo Secuencias.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

GRP_SwitchingSequences


ID_PROJEKT_SEL_WITH_BORDER

Interne ID: ID_PROJEKT_SEL_WITH_BORDER

Selección con bordes

  • Activado: En la lista de mensajes de alarma (AML) y en la lista cronológica de eventos (CEL) las filas seleccionadas se resaltarán con un borde. Se recomienda para una mejor legibilidad para altas resoluciones de pantalla.
  • Desactivado: El color de fondo de las filas seleccionadas se invertirá. Se recomienda para una mejor legibilidad para bajas resoluciones de pantalla.

Por defecto: desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SelBorder


ID_PROJEKT_STARTBILD

Interne ID: ID_PROJEKT_STARTBILD

Imagen de inicio

Al iniciar el runtime se abrirá automáticamente esta pantalla. La primera pantalla creada en un proyecto se archivará aquí automáticamente.
Haciendo clic sobre el botón ... se abre un diálogo para seleccionar la pantalla.

Observación: Los tipos de pantalla especiales establecidos como pantalla de inicio se activarán con un filtro vacío y sin datos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StartPictureName


ID_PROJEKT_TOUCH1

Interne ID: ID_PROJEKT_TOUCH1

Posición preferida

Propiedades para la posición preferida en la que el teclado automático se abrirá en relación al elemento seleccionado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_KeyboardPosition


ID_PROJEKT_TOUCH2

Interne ID: ID_PROJEKT_TOUCH2

Posición alternativa

Propiedades para la posición alternativa en la que el teclado automático se abrirá en relación al elemento seleccionado cuando no se pueda abrir en la posición preferida.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_KeyboardPositionAlt


ID_PROJEKT_TOUCHSCREEN

Interne ID: ID_PROJEKT_TOUCHSCREEN

Teclado automático

Para proyectos con pantalla táctil.

  • Activado: Se abrirá automáticamente una ventana con teclado cuando sea necesaria una entrada (p. ej.: para establecer un valor predeterminado o registrarse).
  • Desactivado: No se abrirá ninguna ventana de teclado.

Por defecto: desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Touchscreen


ID_PROJEKT_TOUCHSCREEN_HORZ

Interne ID: ID_PROJEKT_TOUCHSCREEN_HORZ

Desplazamiento horizontal [píxeles]

Distancia horizontal (en píxeles) al elemento seleccionado para la posición preferida del teclado automático.
Por defecto: 2.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

KeyboardPixelHorz


ID_PROJEKT_TOUCHSCREEN_HORZ_ALT

Interne ID: ID_PROJEKT_TOUCHSCREEN_HORZ_ALT

Desplazamiento horizontal [píxeles]

Distancia horizontal (en píxeles) al elemento seleccionado para la posición alternativa del teclado automático.
Por defecto: 2.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

KeyboardPixelHorzAlt


ID_PROJEKT_TOUCHSCREEN_RIGHTLEFT

Interne ID: ID_PROJEKT_TOUCHSCREEN_RIGHTLEFT

Horizontal

Posición horizontal del teclado automático para la posición preferida.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

KeyboardPosHorz


ID_PROJEKT_TOUCHSCREEN_RIGHTLEFT_ALT

Interne ID: ID_PROJEKT_TOUCHSCREEN_RIGHTLEFT_ALT

Horizontal

Posición horizontal del teclado automático para la posición alternativa.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

KeyboardPosHorzAlt


ID_PROJEKT_TOUCHSCREEN_TOPBOT

Interne ID: ID_PROJEKT_TOUCHSCREEN_TOPBOT

Vertical

Posición vertical del teclado automático para la posición preferida.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

KeyboardPosVert


ID_PROJEKT_TOUCHSCREEN_TOPBOT_ALT

Interne ID: ID_PROJEKT_TOUCHSCREEN_TOPBOT_ALT

Vertical

Posición vertical del teclado automático para la posición alternativa.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

KeyboardPosVertAlt


ID_PROJEKT_TOUCHSCREEN_VERT

Interne ID: ID_PROJEKT_TOUCHSCREEN_VERT

Desplazamiento vertical [píxeles]

Distancia vertical (en píxeles) al elemento seleccionado para la posición preferida del teclado automático.
Por defecto: 2.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

KeyboardPixelVert


ID_PROJEKT_TOUCHSCREEN_VERT_ALT

Interne ID: ID_PROJEKT_TOUCHSCREEN_VERT_ALT

Desplazamiento vertical [píxeles]

Distancia vertical (en píxeles) al elemento seleccionado para la posición alternativa del teclado automático.
Por defecto: 2.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

KeyboardPixelVertAlt


ID_PROJEKT_TREND_MILLISEC

Interne ID: ID_PROJEKT_TREND_MILLISEC

Tendencia y valores HD en milisegundos

  • Activado: La representación y procesado interno de los valores der HD, así como la actualización de las pantallas activas tienen lugar en milisegundos.
  • Desactivado: La representación y procesado interno de los valores der HD, así como la actualización de las pantallas activas tienen lugar en segundos.

Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TrendMilliSec


ID_PROJEKT_VARBEZEICHNER

Interne ID: ID_PROJEKT_VARBEZEICHNER

Mostrar variables con

Mostrar variables en el runtime mediante:
si se hace clic derecho del ratón durante el runtime sobre el elemento y se mantiene pulsado el ratón se mostrará aquí según esta propiedad el nombre, la identificación o la dirección de la variable como información .
Además se utiliza esta propiedad para mostrar por defecto la variable en la leyenda del elemento de tendencia.
También se utiliza esta propiedad para representar el elemento de tendencia y en la caja de diálogo del elemento Multibin en el editor.
Dirección: Las variables se mostrarán con su dirección.
Identificación: Las variables se mostrarán con su identificación.
Nombre: Las variables se mostrarán con su nombre.
Por defecto: Nombre.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VarIdentifier


ID_PROJEKT_VERWALTUNG

Interne ID: ID_PROJEKT_VERWALTUNG

Projekt-Verwaltung

Se abrirá el diálogo de configuración para el proyecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ProjectAdministration


ID_PROJEKT_VERZEICHNIS

Interne ID: ID_PROJEKT_VERZEICHNIS

Carpeta runtime

Carpeta para los archivos runtime del proyecto.
En esta carpeta se guardarán los archivos runtime creados y la carpeta se guardará como carpeta de inicio del runtime.
Por defecto se introducirá aquí la carpeta establecida al crear el proyecto. La carpeta se puede modificar aquí posteriormente.

¡Observación! Los datos históricos ya creados del runtime deberán copiarse manualmente en la nueva carpeta.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WorkingPath


ID_PROJEKT_WINDOWS_CE

Interne ID: ID_PROJEKT_WINDOWS_CE

Proyecto WindowsCE

  • Activado: Las funcionalidades no compatibles con Windows CE se ocultarán en el editor (gris o invisible).
  • Desactivado: Toda la funcionalidad con licencia del editor está disponible.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WindowsCE


ID_PROP_COMBOLIST_DYNCONTENT_USE

Interne ID: ID_PROP_COMBOLIST_DYNCONTENT_USE

Entradas de la variable de cadena

Activado: Las entradas para el combo-/listbox se definirán con la variable de cadena seleccionada en la propiedad Variable.

Desactivado: Las entradas se definirán en el editor con el diálogo de la propiedad Entradas.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UseDynContent


ID_PROP_COMBOLIST_DYNCONTENT_VARIABLE

Interne ID: ID_PROP_COMBOLIST_DYNCONTENT_VARIABLE

Variable

Solo disponible si la propiedad Entradas de la variable de cadena está activada.

Selección de la variable de cadena que contiene las entradas para el combo-/listbox. Haciendo un clic sobre el botón ... se abre el diálogo de selección de variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DynContentVariable


ID_PROP_COMBOLIST_FGCOLOR_SEL

Interne ID: ID_PROP_COMBOLIST_FGCOLOR_SEL

Color de texto al seleccionar

Define el color del texto cuando se selecciona un elemento. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante. El color es estático y no utiliza la variable vinculada.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextColorSelected


ID_PROP_COMBOLIST_HGCOLOR_SEL

Interne ID: ID_PROP_COMBOLIST_HGCOLOR_SEL

Color de fondo al seleccionar

Define el color de fondo cuando se selecciona un elemento. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante. El color es estático y no utiliza la variable vinculada.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColorSelected


ID_PROP_COMBOLIST_SOFORTREAKT

Interne ID: ID_PROP_COMBOLIST_SOFORTREAKT

Reacción inmediata

Permite, en drivers de reacción lenta, que se muestre una reacción como ya producida aunque falte la respuesta del driver.

activado: Muestra una reacción del driver como producida aunque todavía no haya tenido lugar.

Por defecto: activado

Observación: En caso de que el driver no reaccione no se percibirá la falta de reacción.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InstantReaction


ID_PROP_ELE_RT_LASSO

Interne ID: ID_PROP_ELE_RT_LASSO

Seleccionable con lazo

La selección con el lazo durante el runtime permite la identificación de elementos dinámicos para utilizar eventos VBA.
Activado: Se puede seleccionar el elemento con el lazo durante el runtime.
Desactivado: No se puede seleccionar el elemento durante el runtime.
Por defecto: activado

Atención: ¡Para que el elemento se pueda seleccionar durante el runtime dentro de las propiedades del proyecto tiene que estar activada adicionalmente la propiedad Lazo de runtime!

Observación de comando: Si se utiliza la propiedad Manejo a dos manos no puede estar activado el lazo para el elemento de control Ejecutar2. Nivel.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LassoSelect


ID_PROP_GRP_SYSTEMMODEL_GROUP

Interne ID: ID_PROP_GRP_SYSTEMMODEL_GROUP

General

Propiedades generales del grupo de equipos.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_PROP_GRP_SYSTEMMODEL_MODEL

Interne ID: ID_PROP_GRP_SYSTEMMODEL_MODEL

General

Propiedades generales del modelo de equipo.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_PROP_MSGCTRL_MESSAGE_ACKREQ

Interne ID: ID_PROP_MSGCTRL_MESSAGE_ACKREQ

Confirmación de recibo obligatoria

Se requiere la confirmación de recibo del mensaje.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AckReq


ID_PROP_MSGCTRL_MESSAGE_ACKTIMEOUT

Interne ID: ID_PROP_MSGCTRL_MESSAGE_ACKTIMEOUT

Tiempo de espera para confirmación de recibo

Lapso de tiempo para la confirmación del mensaje.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AckTimeOut


ID_PROP_MSGCTRL_MESSAGE_ATTACHMENT

Interne ID: ID_PROP_MSGCTRL_MESSAGE_ATTACHMENT

Archivo adjunto

Nombre del adjunto de un mensaje. Solo para e-mails con SMTP.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Attachment


ID_PROP_MSGCTRL_MESSAGE_ATTEMPTS

Interne ID: ID_PROP_MSGCTRL_MESSAGE_ATTEMPTS

Intentos

Número de intentos de envío.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Attempts


ID_PROP_MSGCTRL_MESSAGE_CODESFROMFUNCTION

Interne ID: ID_PROP_MSGCTRL_MESSAGE_CODESFROMFUNCTION

Códigos específicos de función

Muestra si se utiliza un código individual para la confirmación.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CodesFromFunction


ID_PROP_MSGCTRL_MESSAGE_CUSTOMID

Interne ID: ID_PROP_MSGCTRL_MESSAGE_CUSTOMID

Custom Identifier

Identificador personalizado.
Solo se puede establecer con VBA/VSTA en el evento MessageCreated.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CustomIdentifier


ID_PROP_MSGCTRL_MESSAGE_CYCLECOUNTER

Interne ID: ID_PROP_MSGCTRL_MESSAGE_CYCLECOUNTER

Número de ciclos de envío

Número de reenvios de este mensaje.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CycleCounter


ID_PROP_MSGCTRL_MESSAGE_DESTINATION

Interne ID: ID_PROP_MSGCTRL_MESSAGE_DESTINATION

Destino

Dirección de destino del mensaje (dirección de correo electrónico, número de teléfono).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Destination


ID_PROP_MSGCTRL_MESSAGE_GUID

Interne ID: ID_PROP_MSGCTRL_MESSAGE_GUID

GUID

Identificación (GUID) del mensaje.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GUID


ID_PROP_MSGCTRL_MESSAGE_MAXATTEMPTS

Interne ID: ID_PROP_MSGCTRL_MESSAGE_MAXATTEMPTS

Nr. máx de intentos

Número máximo de intentos de envío.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxAttempts


ID_PROP_MSGCTRL_MESSAGE_MESSAGE

Interne ID: ID_PROP_MSGCTRL_MESSAGE_MESSAGE

Mensaje

Texto del mensaje.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MessageText


ID_PROP_MSGCTRL_MESSAGE_SEND

Interne ID: ID_PROP_MSGCTRL_MESSAGE_SEND

Siguiente intento

Hora para el siguiente intento de envío del mensaje.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Send


ID_PROP_MSGCTRL_MESSAGE_SENT

Interne ID: ID_PROP_MSGCTRL_MESSAGE_SENT

Creado / último envío

Hora en la que se creó el mensaje o en la que se realizó el último intento de envío.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Sent


ID_PROP_MSGCTRL_MESSAGE_TIMETOWAIT

Interne ID: ID_PROP_MSGCTRL_MESSAGE_TIMETOWAIT

Tiempo de espera

Tiempo de espera en minutos para la vigilancia del timeout y el reenvío de mensajes.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TimeToWait


ID_PROP_MSGCTRL_MESSAGE_TITLE

Interne ID: ID_PROP_MSGCTRL_MESSAGE_TITLE

Asunto

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Title


ID_PROP_MSGCTRL_MESSAGE_USER

Interne ID: ID_PROP_MSGCTRL_MESSAGE_USER

Nombre del destinatario

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserName


ID_PROP_SKIN_ADVANCEDSETTINGS

Interne ID: ID_PROP_SKIN_ADVANCEDSETTINGS

Configuraciones gráficas ampliadas

Sólo disponible para PCs.

Controla la utilización de barras desplegables horizontales y verticales ajustables, del encabezado y de la rejilla. Si activa esta propiedad podrá ajustar como desee la visualización del campo de listas.

Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AdvancedStyleH


ID_PROP_SKIN_ADVANCEDSETTINGS_GROUP

Interne ID: ID_PROP_SKIN_ADVANCEDSETTINGS_GROUP

Barras desplegables

Propiedades para las barras desplegables horizontales y verticales.

Más sobre AML en el manual online .

Más sobre CEL en el manual online .

Más sobre ETM en el manual online .

Más sobre RGM en el manual online .

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SkinAdvanced


ID_PROP_SKIN_ENABLEHEADER

Interne ID: ID_PROP_SKIN_ENABLEHEADER

Encabezado editable

Sólo disponible si ha seleccionado el encabezado editable en las configuraciones de proyecto del grupo Lista de mensajes de alarma para la propiedad Encabezado AML o del grupoLista cronológica de eventos para la propiedad Encabezado CEL.

Disponible para la lista de salida del cursor en la tendencia ampliada.

Permite manejar el encabezado para el correspondiente campo de listas. En el runtime puede desplazar las columnas individualmente y modificar su anchura. Puede ordenar la representación según una columna determinada.

activado: El encabezado es manejable.

Por defecto: activado

Más en el manual online para AML

Más en el manual online para CEL

Más sobre ETM en el manual online .

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EnableHeader


ID_PROP_SKIN_GRIDCOLORH

Interne ID: ID_PROP_SKIN_GRIDCOLORH

Color de línea horizontal

Define el color de las líneas de las líneas horizontales de la rejilla en la representación de listas en el runtime. Haciendo clic izquierdo sobre el botón se abre la paleta de colores predefinidos. También puede introducir directamente el nombre del color como código hex (RGB).

Como color para los elementos nuevos creados se tomará el mismo que se haya utilizado por última vez para ese tipo de elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GridColorH


ID_PROP_SKIN_GRIDCOLORV

Interne ID: ID_PROP_SKIN_GRIDCOLORV

Color de línea vertical

Define el color de las líneas de las líneas horizontales de la rejilla en la representación de listas en el runtime. Haciendo clic izquierdo sobre el botón se abre la paleta de colores predefinidos. También puede introducir directamente el nombre del color como código hex (RGB).

Como color para los elementos nuevos creados se tomará el mismo que se haya utilizado por última vez para ese tipo de elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GridColorV


ID_PROP_SKIN_GRIDGRP

Interne ID: ID_PROP_SKIN_GRIDGRP

Rejilla

Propiedades para la rejilla del campo de listas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SkinGrid


ID_PROP_SKIN_GRIDSIZEH

Interne ID: ID_PROP_SKIN_GRIDSIZEH

Ancho de línea horizontal [píxeles]

Anchura de las líneas horizontales de la rejilla en píxeles. Cambie el valor para modificar las líneas horizontales de la rejilla en la representación de listas en el runtime. Si introduce 0 las líneas horizontales no se verán.

Por defecto: 1.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GridSizeH


ID_PROP_SKIN_GRIDSIZEV

Interne ID: ID_PROP_SKIN_GRIDSIZEV

Ancho de línea vertical [píxeles]

Anchura de las líneas verticales de la rejilla en píxeles. Cambie el valor para modificar las líneas verticales de la rejilla en la representación de listas en el runtime. Si introduce 0 las líneas verticales no se verán.

Por defecto: 1.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GridSizeV


ID_PROP_SKIN_GRIDTYPEH

Interne ID: ID_PROP_SKIN_GRIDTYPEH

Tipo de línea horizontal

Define el tipo de las líneas de las líneas horizontales de la rejilla en la representación de listas en el runtime. Haga clic sobre la línea y seleccione el tipo de línea deseado (línea continua, línea interrumpida, línea rayada, etc.).

Por defecto: línea continua.

Atención: Esta propiedad solo está disponible cuando el valor de la propiedad corresponda a Ancho de línea horizontal [píxeles] 1 . Para valores >1 se utilizará siempre la línea continua.

Observación: Sólo se mostrará la rejilla si está activada en la función Cambio de pantalla o en el filtro del runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GridTypeH


ID_PROP_SKIN_GRIDTYPEV

Interne ID: ID_PROP_SKIN_GRIDTYPEV

Tipo de línea vertical

Define el tipo de línea de las líneas verticales de la rejilla en la representación de listas en el runtime. Haga clic sobre la línea y seleccione el tipo de línea deseado (línea continua, línea interrumpida, línea rayada, etc.).

Por defecto: línea continua.

Atención: Esta propiedad solo está disponible cuando el valor de la propiedad corresponda a Ancho de línea vertical [píxeles] 1 . Para valores >1 se utilizará siempre la línea continua.

Observación: Sólo se mostrará la rejilla si está activada en la función Cambio de pantalla o en el filtro del runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GridTypeV


ID_PROP_SKIN_HEADERBAR_BACKCOLOR

Interne ID: ID_PROP_SKIN_HEADERBAR_BACKCOLOR

Color de relleno

Defina el primer color de fondo para el gradiente del encabezado. Haciendo clic sobre el botón se abre la gama de los colores predefinidos. O introduzca el nombre del color manualmente como código hexadecimal (RGB) en el campo de entrada.

Como color para los elementos nuevos creados se tomará el mismo que se haya utilizado por última vez para ese tipo de elemento.

Más en el manual online para AML

Más en el manual online para CEL

Más sobre ETM en el manual online .

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HeaderBackColor


ID_PROP_SKIN_HEADERBAR_BACKCOLOR2

Interne ID: ID_PROP_SKIN_HEADERBAR_BACKCOLOR2

Gradiente de color

Sólo disponible si en las configuraciones de proyecto en el grupo Lista de mensajes de alarma para la propiedad Encabezado AML o en el grupo Lista cronológica de eventos para la propiedad Encabezado CEL ha seleccionado Encabezado editable o Encabezado fijo. Además debe activar también las propiedades Configuraciones gráficas ampliadas y Mostrar encabezado para el campo de listas correspondiente.

Disponible para la lista de salida del cursor en la tendencia ampliada.

Esta propiedad sólo tendrá efecto si ha seleccionado en la propiedad Estilo de visualización Gradiente de color.

Defina el segundo color de relleno para el gradiente del encabezado. Haciendo clic sobre el botón se abre la gama de los colores predefinidos. O introduzca el nombre del color manualmente como código hexadecimal (RGB) en el campo de entrada. Al seleccionar Automático cambia el valor dependiendo del valor de la configuración Color de relleno.

Como color para los elementos nuevos creados se tomará el mismo que se haya utilizado por última vez para ese tipo de elemento.

Más en el manual online AML

Más en el manual online CEL

Más sobre ETM en el manual online .

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HeaderBackColor2


ID_PROP_SKIN_HEADERBAR_COLORGRADIENTANGLE

Interne ID: ID_PROP_SKIN_HEADERBAR_COLORGRADIENTANGLE

Ángulo

Sólo disponible si en las configuraciones de proyecto en el grupo Lista de mensajes de alarma para la propiedad Encabezado AML o en el grupo Lista cronológica de eventos para la propiedad Encabezado CEL ha seleccionado Encabezado editable o Encabezado fijo. Además debe activar también las propiedades Configuraciones gráficas ampliadas y Mostrar encabezado para el campo de listas correspondiente.

Disponible para la lista de salida del cursor en la tendencia ampliada.

Esta propiedad sólo tendrá efecto si ha seleccionado en la propiedad Estilo de visualización Gradiente de color.

Defina el ángulo en el que se extiende la dirección del gradiente. Como punto de partida se utilizará el punto definido con la propiedad Offset.

Mínimo: 0

Máximo: 360

Por defecto: 0

Más en el manual online AML

Más en el manual online CEL

Más sobre ETM en el manual online .

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HeaderColorGradientAngle


ID_PROP_SKIN_HEADERBAR_COLORGRADIENTOFFSET

Interne ID: ID_PROP_SKIN_HEADERBAR_COLORGRADIENTOFFSET

Offset

Defina la distancia del punto del gradiente desde el centro del encabezado hacia la izquierda o derecha en porcentaje. 0 corresponde al centro del encabezado, 100 al margen derecho y -100 al margen izquierdo.

Mínimo: -100

Máximo: 100

Por defecto: 0

Más en el manual online AML

Más en el manual online CEL

Más sobre ETM en el manual online .

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HeaderColorGradientOffset


ID_PROP_SKIN_HEADERBAR_FONT

Interne ID: ID_PROP_SKIN_HEADERBAR_FONT

Fuente

Defina la fuente que desee utilizar en el texto del encabezado. Haciendo clic sobre el botón se abre un diálogo para elegir las fuentes predefinidas.

Como fuente para los elementos nuevos creados se tomará la misma que se haya utilizado por última vez para ese tipo de elemento.

Más en el manual online para AML

Más en el manual online para CEL

Más en el manual online para ETM.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HeaderFont


ID_PROP_SKIN_HEADERBAR_FONT_COLOR

Interne ID: ID_PROP_SKIN_HEADERBAR_FONT_COLOR

Color de texto

Defina el color que desee utilizar en el texto del encabezado. Haciendo clic sobre el botón se abre la gama de los colores predefinidos. O introduzca el nombre del color manualmente como código hexadecimal (RGB) en el campo de entrada.

Como color para los elementos nuevos creados se tomará el mismo que se haya utilizado por última vez para ese tipo de elemento.

Más en el manual online para AML

Más en el manual online para CEL

Más sobre ETM en el manual online .

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HeaderFontColor


ID_PROP_SKIN_HEADERBAR_GRP

Interne ID: ID_PROP_SKIN_HEADERBAR_GRP

Encabezado

Propiedades para el encabezado del campo de listas.

Más en el manual online para AML

Más en el manual online para CEL

Más sobre ETM en el manual online .

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SkinHeader


ID_PROP_SKIN_HEADERBAR_LIGHTNING

Interne ID: ID_PROP_SKIN_HEADERBAR_LIGHTNING

Efecto luminoso

Seleccione el tipo de gradiente para el encabezado entre las siguientes opciones:

Lineal: gradiente constante

Partiendo de un punto: Gradiente desde los márgenes al punto de inicio definido del gradiente de color.

Partiendo de un punto con rayos: Gradiente desde los márgenes al punto de inicio definido del gradiente de color con creación de rayos.

Por defecto: Lineal

Más en el manual online AML

Más en el manual online CEL

Más sobre ETM en el manual online .

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HeaderLightning


ID_PROP_SKIN_HEADERBAR_PRJSORTDOWN

Interne ID: ID_PROP_SKIN_HEADERBAR_PRJSORTDOWN

Orden descendente

Sólo disponible si ha activado Configuraciones gráficas ampliadas.

Seleccione un archivo gráfico que deba mostrarse en el runtime en el encabezado del campo de listas para orden descendente. Este gráfico se utilizará si ha seleccionado en Estilo de visualización Archivo gráfico.

Por defecto: ningún archivo

Más en el manual online para AML

Más en el manual online para CEL

Más sobre ETM en el manual online .

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DescDownImage


ID_PROP_SKIN_HEADERBAR_PRJSORTUP

Interne ID: ID_PROP_SKIN_HEADERBAR_PRJSORTUP

Orden ascendente

Sólo disponible si ha activado Configuraciones gráficas ampliadas.

Selecciones un archivo gráfico que deba mostrarse en el runtime en el encabezado del campo de listas para orden ascendente. Este gráfico se utilizará si ha seleccionado en Estilo de visualización Archivo gráfico.

Por defecto: ningún archivo

Más en el manual online para AML

Más en el manual online para CEL

Más sobre ETM en el manual online .

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AscSortImage


ID_PROP_SKIN_HEADERBAR_PRJSPAN

Interne ID: ID_PROP_SKIN_HEADERBAR_PRJSPAN

Fondo

Sólo disponible si ha activado Configuraciones gráficas ampliadas.

Seleccione un archivo gráfico que deba mostrarse como fondo en el runtime en el encabezado del campo de listas . Este gráfico se utilizará si ha seleccionado en Estilo de visualización Archivo gráfico.

Por defecto: ningún archivo

Más en el manual online para AML

Más en el manual online para CEL

Más sobre ETM en el manual online .

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HeaderBarImage


ID_PROP_SKIN_HEADERBAR_STYLE

Interne ID: ID_PROP_SKIN_HEADERBAR_STYLE

Estilo de visualización

Sólo disponible si en las configuraciones de proyecto en el grupo Lista de mensajes de alarma para la propiedad Encabezado AML o en el grupo Lista cronológica de eventos para la propiedad Encabezado CEL ha seleccionado Encabezado editable o Encabezado fijo. Además debe activar también las propiedades Configuraciones gráficas ampliadas y Mostrar encabezado para el campo de listas correspondiente.

Disponible para la lista de salida del cursor en la tendencia ampliada.

Aquí puede definir el aspecto del encabezado del campo de listas. Seleccione una de las siguientes opciones:

Gradiente de color: Utiliza un gradiente de color especial para el encabezado, que podrá ajustar como desee con las configuraciones Color de relleno, Gradiente de color, Efecto luminoso, Offset y Ángulo.

Archivo gráfico: Utiliza los archivos gráficos seleccionados para las áreas individuales. Si no hay ningún archivo gráfico seleccionado aparecerá la indicación Gradiente de color.

Estándar: Utiliza la configuración estándar para el encabezado. Sólo se pueden modificar la Fuente y el Color de texto a través de las respectivas configuraciones.

Por defecto: Estándar.

Más en el manual online para AML

Más en el manual online para CEL

Más sobre ETM en el manual online .

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HeaderStyle


ID_PROP_SKIN_HORBAR_BACKCOLOR

Interne ID: ID_PROP_SKIN_HORBAR_BACKCOLOR

Color de relleno

Defina el primer color de fondo para el gradiente de la barra desplegable horizontal. Haciendo clic sobre el botón se abre la gama de los colores predefinidos. O introduzca el nombre del color manualmente como código hexadecimal (RGB) en el campo de entrada.

Como color para los elementos nuevos creados se tomará el mismo que se haya utilizado por última vez para ese tipo de elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColorH


ID_PROP_SKIN_HORBAR_BACKCOLOR2

Interne ID: ID_PROP_SKIN_HORBAR_BACKCOLOR2

Color de gradiente

Esta propiedad sólo tendrá efecto si ha seleccionado en la propiedad Estilo de visualización Gradiente de color.

Defina el segundo color de fondo para el gradiente de la barra desplegable horizontal. Haciendo clic sobre el botón se abre la gama de los colores predefinidos. O introduzca el nombre del color manualmente como código hexadecimal (RGB) en el campo de entrada. Al seleccionar Automático cambia el valor dependiendo del valor de la configuración Color de relleno.

Como color para los elementos nuevos creados se tomará el mismo que se haya utilizado por última vez para ese tipo de elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColor2H


ID_PROP_SKIN_HORBAR_BUTTONHEIGHT

Interne ID: ID_PROP_SKIN_HORBAR_BUTTONHEIGHT

Altura de flecha desplegable [píxeles]

Defina la altura en píxel de la flecha desplegable en la barra desplegable horizontal. Ajuste el valor a sus previsiones.

Por defecto: 12.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ButtonHeightH


ID_PROP_SKIN_HORBAR_BUTTONWIDTH

Interne ID: ID_PROP_SKIN_HORBAR_BUTTONWIDTH

Ancho de flecha desplegable [píxeles]

Defina el ancho en píxel de la flecha desplegable en la barra desplegable horizontal. Ajuste el valor a sus previsiones.

Por defecto: 12.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ButtonWidthH


ID_PROP_SKIN_HORBAR_COLORGRADIENTANGLE

Interne ID: ID_PROP_SKIN_HORBAR_COLORGRADIENTANGLE

Ángulo [°]

Sólo disponible si ha activado Configuraciones gráficas ampliadas.

Esta propiedad sólo tendrá efecto si ha seleccionado en la propiedad Estilo de visualización Gradiente de color.

Defina el ángulo en el que se extiende la dirección del gradiente. Como punto de partida se utilizará el punto definido con la propiedad Versatz [%].

Mínimo: 0

Máximo: 360

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ColorGradientAngleH


ID_PROP_SKIN_HORBAR_COLORGRADIENTOFFSET

Interne ID: ID_PROP_SKIN_HORBAR_COLORGRADIENTOFFSET

Versatz [%]

Defina la distancia del punto del gradiente desde el centro de la barra desplegable horizontal hacia la izquierda o derecha en porcentaje. 0 corresponde al centro de la barra desplegable horizontal, 100 al margen derecho y -100 al margen izquierdo.

Mínimo: -100

Máximo: 100

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ColorGradientOffsetH


ID_PROP_SKIN_HORBAR_GRP

Interne ID: ID_PROP_SKIN_HORBAR_GRP

Barra desplegable horizontal

Propiedades para las barras desplegables horizontales del campo de listas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SkinHorBar


ID_PROP_SKIN_HORBAR_LIGHTNING

Interne ID: ID_PROP_SKIN_HORBAR_LIGHTNING

Gradiente de color

Seleccione el tipo de gradiente para la barra desplegable horizontal entre las siguientes opciones:

Lineal: gradiente constante

Partiendo de un punto: Gradiente desde los márgenes al punto de inicio definido del gradiente de color.

Partiendo de un punto con rayos: Gradiente desde los márgenes al punto de inicio definido del gradiente de color con creación de rayos.

Por defecto: Lineal

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LightningH


ID_PROP_SKIN_HORBAR_PRJLEFTBMP

Interne ID: ID_PROP_SKIN_HORBAR_PRJLEFTBMP

Flecha desplegable a la izquierda

Sólo disponible si ha activado Configuraciones gráficas ampliadas.

Seleccione un archivo gráfico que deba mostrarse en el runtime en el campo de listas para la flecha desplegable izquierda de la barra desplegable horizontal. Este gráfico se utilizará si ha seleccionado en Estilo de visualización Archivo gráfico.

Por defecto: ningún archivo

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BitmapLeftH


ID_PROP_SKIN_HORBAR_PRJRIGHTBMP

Interne ID: ID_PROP_SKIN_HORBAR_PRJRIGHTBMP

Flecha desplegable a la derecha

Sólo disponible si ha activado Configuraciones gráficas ampliadas.

Seleccione un archivo gráfico que deba mostrarse en el runtime en el campo de listas para la flecha desplegable derecha de la barra desplegable horizontal. Este gráfico se utilizará si ha seleccionado en Estilo de visualización Archivo gráfico.

Por defecto: ningún archivo

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BitmapRightH


ID_PROP_SKIN_HORBAR_PRJSPAN

Interne ID: ID_PROP_SKIN_HORBAR_PRJSPAN

Fondo archivo gráfico

Sólo disponible si ha activado Configuraciones gráficas ampliadas.

Seleccione un archivo gráfico que deba mostrarse como fondo en el runtime en el campo de listas para la barra desplegable horizontal. Este gráfico se utilizará si ha seleccionado en Estilo de visualización Archivo gráfico.

Por defecto: ningún archivo

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BitmapSpanH


ID_PROP_SKIN_HORBAR_PRJTHUMBBMP

Interne ID: ID_PROP_SKIN_HORBAR_PRJTHUMBBMP

Campo desplegable

Sólo disponible si ha activado Configuraciones gráficas ampliadas.

Seleccione un archivo gráfico que deba mostrarse en el runtime en el campo de listas para el campo desplegable de la barra desplegable horizontal. Este gráfico se utilizará si ha seleccionado en Estilo de visualización Archivo gráfico.

Por defecto: ningún archivo

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BitmapThumbH


ID_PROP_SKIN_HORBAR_STYLE

Interne ID: ID_PROP_SKIN_HORBAR_STYLE

Estilo de visualización

Sólo disponible si ha activado Configuraciones gráficas ampliadas.

Aquí puede definir el aspecto del encabezado del campo de listas. Seleccione una de las siguientes opciones:

Gradiente de color: Utiliza un gradiente de color especial para el encabezado, que podrá ajustar como desee con las configuraciones Color de relleno, Color de gradiente, Gradiente de color, Versatz [%] y Ángulo [°].

Archivo gráfico: Utiliza los archivos gráficos seleccionados para las áreas individuales. Si no hay ningún archivo gráfico seleccionado aparecerá la indicación Gradiente de color.

Estándar: Utiliza la configuración estándar para el encabezado. Sólo se pueden modificar la fuente y el color del texto a través de las respectivas configuraciones.

Por defecto: Estándar.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BarStyleH


ID_PROP_SKIN_HORBAR_THUMBSIZE

Interne ID: ID_PROP_SKIN_HORBAR_THUMBSIZE

Ancho del campo desplegable [píxeles]

Defina el ancho en píxel del campo desplegable de la barra desplegable horizontal. Ajuste el valor a sus previsiones.

Por defecto: 20.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ThumbSizeH


ID_PROP_SKIN_NOSELECTION

Interne ID: ID_PROP_SKIN_NOSELECTION

No marcar fila seleccionada

Aquí define si desea que la fila seleccionada esté gráficamente destacada en el campo de listas. Si activa la propiedad no podrá ver qué entrada ha seleccionado. Todas las filas de la lista se mostrarán igual.

Por defecto: desactivado.

Más en el manual online para AML

Más en el manual online para CEL

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HideSelection


ID_PROP_SKIN_SHOWBORDER

Interne ID: ID_PROP_SKIN_SHOWBORDER

Mostrar líneas de marco

Permite mostrar un borde alrededor de un elemento. Los marcas de las propiedades Estilo L y Estilo H se harán visibles.

activado: El borde se mostrará alrededor del elemento correspondiente.

Por defecto: desactivado

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowBorder


ID_PROP_SKIN_SHOWHEADER

Interne ID: ID_PROP_SKIN_SHOWHEADER

Mostrar encabezado

Sólo disponible si ha seleccionado encabezado editable o encabezado fijo en las configuraciones de proyecto del grupo Lista de mensajes de alarma para la propiedad Encabezado AML o del grupo Lista cronológica de eventos para la propiedad Encabezado CEL.
Disponible para la lista de salida del cursor en la tendencia ampliada.

Muestra el encabezado para el campo de listas correspondiente. En el grupo Encabezado puede ajustar a su gusto el aspecto del encabezado.

activado: El encabezado se mostrará.

Por defecto: activado

Más en el manual online para AML

Más en el manual online para CEL

Más sobre ETM en el manual online .

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowHeader


ID_PROP_SKIN_VERBAR_BACKCOLOR

Interne ID: ID_PROP_SKIN_VERBAR_BACKCOLOR

Color de relleno

Defina el primer color de fondo para el gradiente de la barra desplegable vertical. Haciendo clic sobre el botón se abre la gama de los colores predefinidos. O introduzca el nombre del color manualmente como código hexadecimal (RGB) en el campo de entrada.

Como color para los elementos nuevos creados se tomará el mismo que se haya utilizado por última vez para ese tipo de elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColorV


ID_PROP_SKIN_VERBAR_BACKCOLOR2

Interne ID: ID_PROP_SKIN_VERBAR_BACKCOLOR2

Gradiente de color

Esta propiedad sólo tendrá efecto si ha seleccionado en la propiedad Estilo de visualización Gradiente de color.

Defina el segundo color de fondo para el gradiente de la barra desplegable vertical. Haciendo clic sobre el botón se abre la gama de los colores predefinidos. O introduzca el nombre del color manualmente como código hexadecimal (RGB) en el campo de entrada. Al seleccionar Automático cambia el valor dependiendo del valor de la configuración Color de relleno.

Como color para los elementos nuevos creados se tomará el mismo que se haya utilizado por última vez para ese tipo de elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColor2V


ID_PROP_SKIN_VERBAR_BUTTONHEIGHT

Interne ID: ID_PROP_SKIN_VERBAR_BUTTONHEIGHT

Altura de flecha desplegable [píxeles]

Defina la altura en píxel de la flecha desplegable en la barra desplegable vertical. Ajuste el valor a sus previsiones.

Por defecto: 12.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ButtonHeightV


ID_PROP_SKIN_VERBAR_BUTTONWIDTH

Interne ID: ID_PROP_SKIN_VERBAR_BUTTONWIDTH

Ancho de flecha desplegable [píxeles]

Defina el ancho en píxel de la flecha desplegable en la barra desplegable vertical. Ajuste el valor a sus previsiones.

Por defecto: 12.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ButtonWidthV


ID_PROP_SKIN_VERBAR_COLORGRADIENTANGLE

Interne ID: ID_PROP_SKIN_VERBAR_COLORGRADIENTANGLE

Ángulo [°]

Sólo disponible si ha activado Configuraciones gráficas ampliadas.

Esta propiedad sólo tendrá efecto si ha seleccionado en la propiedad Estilo de visualización Gradiente de color.

Defina el ángulo en el que se extiende la dirección del gradiente. Como punto de partida se utilizará el punto definido con la propiedad Versatz [%].

Mínimo: 0

Máximo: 360

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ColorGradientAngleV


ID_PROP_SKIN_VERBAR_COLORGRADIENTOFFSET

Interne ID: ID_PROP_SKIN_VERBAR_COLORGRADIENTOFFSET

Versatz [%]

Defina la distancia del punto del gradiente desde el centro de la barra desplegable vertical hacia la izquierda o derecha en porcentaje. 0 corresponde al centro de la barra desplegable vertical, 100 al margen derecho y -100 al margen izquierdo.

Mínimo: -100

Máximo: 100

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ColorGradientOffsetV


ID_PROP_SKIN_VERBAR_GRP

Interne ID: ID_PROP_SKIN_VERBAR_GRP

Barra desplegable vertical

Propiedades para las barras desplegables verticales del campo de listas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SkinVerBar


ID_PROP_SKIN_VERBAR_LIGHTNING

Interne ID: ID_PROP_SKIN_VERBAR_LIGHTNING

Gradiente de color

Seleccione el tipo de gradiente para la barra desplegable horizontal entre las siguientes opciones:

Lineal: gradiente constante

Partiendo de un punto: Gradiente desde los márgenes al punto de inicio definido del gradiente de color.

Partiendo de un punto con rayos: Gradiente desde los márgenes al punto de inicio definido del gradiente de color con creación de rayos.

Por defecto: Lineal

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LightningV


ID_PROP_SKIN_VERBAR_PRJLEFTBMP

Interne ID: ID_PROP_SKIN_VERBAR_PRJLEFTBMP

Flecha desplegable hacia arriba

Sólo disponible si ha activado Configuraciones gráficas ampliadas.

Seleccione un archivo gráfico que deba mostrarse en el runtime en el campo de listas para la flecha desplegable hacia arriba de la barra desplegable vertical. Este gráfico se utilizará si ha seleccionado en Estilo de visualización Archivo gráfico.

Por defecto: ningún archivo

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BitmapLeftV


ID_PROP_SKIN_VERBAR_PRJRIGHTBMP

Interne ID: ID_PROP_SKIN_VERBAR_PRJRIGHTBMP

Flecha desplegable hacia abajo

Sólo disponible si ha activado Configuraciones gráficas ampliadas.

Seleccione un archivo gráfico que deba mostrarse en el runtime en el campo de listas para la flecha desplegable hacia abajo de la barra desplegable vertical. Este gráfico se utilizará si ha seleccionado en Estilo de visualización Archivo gráfico.

Por defecto: ningún archivo

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BitmapRightV


ID_PROP_SKIN_VERBAR_PRJSPAN

Interne ID: ID_PROP_SKIN_VERBAR_PRJSPAN

Fondo archivo gráfico

Sólo disponible si ha activado Configuraciones gráficas ampliadas.

Seleccione un archivo gráfico que deba mostrarse como fondo en el runtime en el campo de listas para la barra desplegable vertical. Este gráfico se utilizará si ha seleccionado en Estilo de visualización Archivo gráfico.

Por defecto: ningún archivo

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BitmapSpanV


ID_PROP_SKIN_VERBAR_PRJTHUMBBMP

Interne ID: ID_PROP_SKIN_VERBAR_PRJTHUMBBMP

Campo desplegable

Sólo disponible si ha activado Configuraciones gráficas ampliadas.

Seleccione un archivo gráfico que deba mostrarse en el runtime en el campo de listas para el campo desplegable de la barra desplegable vertical. Este gráfico se utilizará si ha seleccionado en Estilo de visualización Archivo gráfico.

Por defecto: ningún archivo

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BitmapThumbV


ID_PROP_SKIN_VERBAR_STYLE

Interne ID: ID_PROP_SKIN_VERBAR_STYLE

Estilo de visualización

Sólo disponible si ha activado Configuraciones gráficas ampliadas.

Aquí puede definir el aspecto del encabezado del campo de listas. Seleccione una de las siguientes opciones:

Gradiente de color: Utiliza un gradiente de color especial para el encabezado, que podrá ajustar como desee con las configuraciones Color de relleno, Gradiente de color, Gradiente de color, Versatz [%] y Ángulo [°].

Archivo gráfico: Utiliza los archivos gráficos seleccionados para las áreas individuales. Si no hay ningún archivo gráfico seleccionado aparecerá la indicación Gradiente de color.

Estándar: Utiliza la configuración estándar para el encabezado. Sólo se pueden modificar la fuente y el color del texto a través de las respectivas configuraciones.

Por defecto: Estándar.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BarStyleV


ID_PROP_SKIN_VERBAR_THUMBSIZE

Interne ID: ID_PROP_SKIN_VERBAR_THUMBSIZE

Ancho del campo desplegable [píxeles]

Defina el ancho en píxel del campo desplegable en la barra desplegable vertical. Ajuste el valor a sus previsiones.

Por defecto: 20.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ThumbSizeV


ID_PROP_SYSTEMMODEL_GROUP_NAME

Interne ID: ID_PROP_SYSTEMMODEL_GROUP_NAME

Nombre:

Nombre del grupo. Se le asignará automáticamente un número sucesivo al crearse que puede cambiar si lo desea.

Por defecto: GrupoX (X corresponde a un número sucesivo)

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_PROP_SYSTEMMODEL_ROOT_NAME

Interne ID: ID_PROP_SYSTEMMODEL_ROOT_NAME

Nombre:

Nombre del modelo. Se le asignará automáticamente un número sucesivo al crearse que puede cambiar si lo desea.

Por defecto: ModeloX (X corresponde a un número sucesivo)

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_PROP_SYSTEMMODELGOUP

Interne ID: ID_PROP_SYSTEMMODELGOUP

Grupos de equipos

Vincula el elemento con un modelo de instalación. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un grupo de instalaciones.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SystemModelGroup


ID_PROP_VIEWLIMITFROMVAR

Interne ID: ID_PROP_VIEWLIMITFROMVAR

Aplicar rango de visualización de las variables

Toma el área de visualización de la variable vinculada. Así se pueden actualizar estas áreas de visualización al sustituir por una variable con otro rango de valores.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ViewLimitFromVar


ID_PROP_WPFCONNECTION

Interne ID: ID_PROP_WPFCONNECTION

WPFConnection

Muestra los vínculos WPF existentes.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WPFConnection


ID_PROP_WPFCONNECTION_DELETE

Interne ID: ID_PROP_WPFCONNECTION_DELETE

{Eliminar vínculo}

Haciendo clic sobre el botón se elimina esta conexión.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DeleteConnection


ID_PROP_WPFCONNECTIONS

Interne ID: ID_PROP_WPFCONNECTIONS

Vínculos WPF

Recoge todas los vínculos configurados en WPF. Las conexiones se pueden configurar aquí sin tener que abrir el diálogo.

Restricciones:

  • El tipo de vínculo no se puede modificar aquí.
  • Solo se pueden crear nuevos vínculos con el diálogo de configuración.
  • Insertar un elemento WPF en un símbolo: Los vínculos WPF no se pueden exportar.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WPFConnection


ID_PROP_WPFELEM_CONFIG_LINKS

Interne ID: ID_PROP_WPFELEM_CONFIG_LINKS

Configuración

Abre un diálogo para la configuración del archivo XAML. Se pueden asignar propiedades, eventos, transformaciones y autorizaciones de uso.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LinksConfig


ID_PROP_WPFELEM_XAMLFILE

Interne ID: ID_PROP_WPFELEM_XAMLFILE

Archivo XAML

Selección del archivo XAML para el elemento WPF. Haciendo clic sobre el botón ... se abre el diálogo de selección. El archivo tiene que haber sido creado en el administrador de proyectos bajo Archivos/Gráficos o haber sido seleccionado en el diálogo a través del símbolo Añadir archivo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FileName


ID_PROP_WPFPROP_AUTH_CONNECTION_TYPE

Interne ID: ID_PROP_WPFPROP_AUTH_CONNECTION_TYPE

Tipo de autorización

Auswahl des Berechtigungstyps aus Dropdownliste:

  • Bedienbar: Wenn die Bedienberechtigung vorhanden ist und das Element nicht verriegelt ist, dann wird der Wert 1 auf die Eigenschaft geschrieben.
  • Bedienberechtigung nicht vorhanden: Besitzt der Benutzer nicht genügend Rechte, um das WPF-Element zu bedienen, wird der Wert 1 auf die Eigenschaft geschrieben.
  • Bedienberechtigung vorhanden: Besitzt der Benutzer genügend Rechte, um das WPF-Element zu bedienen, wird der Wert 1 auf die Eigenschaft geschrieben.
  • Nicht bedienbar: Fehlt die Bedienberechtigung oder ist das Element verriegelt, dann wird der Wert 1 auf die Eigenschaft geschrieben.
  • Nicht verriegelt: Ist das Element nicht durch die Verriegelung gesperrt, wird der Wert 1 auf die Eigenschaft geschrieben.
  • Verriegelt: Ist das Element durch die Verriegelung gesperrt, wird der Wert 1 auf die Eigenschaft geschrieben.

Mehr im Online-Handbuch.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Type


ID_PROP_WPFPROPCONNECTION_FUNCTION

Interne ID: ID_PROP_WPFPROPCONNECTION_FUNCTION

Función

Función vinculada. Haciendo clic sobre el botón ... se abre un diálogo para elegir una función.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Function


ID_PROP_WPFPROPCONNECTION_VARIABLE

Interne ID: ID_PROP_WPFPROPCONNECTION_VARIABLE

Variable

Variable vinculada. Haciendo clic sobre el botón ... se abre un diálogo para elegir una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variable


ID_PUNCHFRAME_ALPHA

Interne ID: ID_PUNCHFRAME_ALPHA

Transparencia [%]

Sólo disponible si como Tipo de marco se ha seleccionado sombra y la propiedad del proyecto Calidad gráfica.

Define la transparencia de la sombra entre 0 y 100 %.

0: cubriente

100: transparente

Por defecto: 60

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PunchFrameAlpha


ID_PUNCHFRAME_ANGLE

Interne ID: ID_PUNCHFRAME_ANGLE

Ángulo [°]

Sólo disponible si como Tipo de marco se ha seleccionado sombra y la propiedad de proyecto Calidad gráfica.

Ángulo en grados en el que se desplaza la sombra.

Valores: 0° a 359°. 0° corresponde a la posición exterior derecha (las 3 h.), continuará en el sentido contrario a las manillas del reloj.

Por defecto: 0°

Haciendo clic sobre el botón ...se abre la regleta deslizante.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PunchFrameAngle


ID_PUNCHFRAME_SIZE

Interne ID: ID_PUNCHFRAME_SIZE

Tamaño de la sombra [%]

Sólo disponible si como Tipo de marco se ha seleccionado sombra y la propiedad de proyecto Calidad gráfica.

Valor en píxel que define el tamaño de la sombra de forma independiente.

El tamaño del rango del valor depende de la resolución de la pantalla.

Valor positivo: Sombra más grande que el elemento

Valor negativo: Sombra más pequeña que el elemento

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PunchFrameSize


ID_PUNCHFRAME_SOFTFOCUS

Interne ID: ID_PUNCHFRAME_SOFTFOCUS

Difuminado

Sólo disponible si como Tipo de marco se ha seleccionado sombra y la propiedad de proyecto Calidad gráfica.

Define el grado de difusión en el número de píxeles que se utilizan para la mezcla. Cuanto mayor sea el valor, más difuminada será la transición de la sombra. Haciendo clic sobre el botón ... se abre una regleta deslizante para configurar el valor.

Valores: 0 a 50

0: Ninguna difusión

50: Difusión máxima

Por defecto: 0

Atención: Si un valor se configura de forma desigual a 0 el cálculo de la sombra puede frenar la capacidad del sistema. Lo cual afecta especialmente en el editor para desplazar la sombra o para posicionar otros objetos sobre la sombra. Durante el runtime afectará a todas los cambios de pantalla.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PunchFrameSoftFocus


ID_PUNCHFRAME_TYPE

Interne ID: ID_PUNCHFRAME_TYPE

Tipo de marco

Lista desplegable para seleccionar el tipo de borde. Están disponibles:

Ningún borde/sombra No se mostrará ningún borde ni sombra.
Borde: El elemento puede tener un borde.
Sombra: El elemento puede tener una sombra. (Sólo disponible si en las propiedades de proyecto está activado Calidad gráfica.)
Excepción: Algunos elementos pueden no tener ninguna sombra.

Por defecto: Ningún borde/sombra

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PunchFrameType


ID_PWVALID

Interne ID: ID_PWVALID

Periodo de validez de la contraseña [d]

Entrada del periodo de tiempo (en días) en que la contraseña tendrá validez. Una vez transcurrido ese tiempo habrá que establecer una contraseña nueva.

  • Mínimo: 0 - La contraseña no expirará nunca y no habrá que renovarla. Con esta configuración se escribirá como valor 2147483647 en la variable driver del sistema "Días hasta que expire la contraseña".
  • Máximo: 4294967295

Por defecto: 0
Atención: Para producciones según las normas de la FDA no está permitida aquí la entrada 0 debido a que las normas de la FDA requieren un cambio cíclico de la contraseña.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PWValid


ID_READWRITE

Interne ID: ID_READWRITE

Avtivar valor predeterminado externo

Propiedad externa para zenon Logic. Sólo afecta a variables que no sean del driver straton.
Activado: El valor de la variable se puede modificar en zenon Logic. La definición de la variable no se puede modificar en zenon Logic.
Desactivado: La variable no se puede modificar en zenon Logic.
Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ReadWrite


ID_RECIPE_GRP1

Interne ID: ID_RECIPE_GRP1

General

Propiedades generales para la receta.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_RECIPE_PW

Interne ID: ID_RECIPE_PW

Nivel de autorización

Grupo de autorización necesario para modificar la receta durante el runtime.
Un usuario solo puede cambiar (leer, modificar manualmente, eliminar) valores de receta si tiene el nivel de contraseña exigido.
Mínimo: 0
Máximo: 127.
Por defecto: 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PasswordLevel


ID_REMA_PROP1

Interne ID: ID_REMA_PROP1

Nombre:

Nombre unívoco de la matriz de reacción.

ATENCIÓN: Esta propiedad no está disponible para el cambio de idioma.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_REMA_PROP2

Interne ID: ID_REMA_PROP2

Tipo

Tipo de matriz de reacción:
Binario: Análisis de estados discretos (bitorientado)
Multi-binario: análisis ampliado de variables de 32 bits; los primeros 16 bits determinan el valor de la variable y se transmitirán como valor numérico; cambio de la clasificación de bits de estado; función especial (desactivar variables con un estado de bit determinado) (proyección de datos protegidos- específico solo para SAT)
Analógico: Análisis de estados analógicos (orientados a valores)
Multianalógico: análisis ampliado con clasificación simultánea de estado y función especial (desactivar variables con un estado de bit determinado)
Cadena: Comparación del texto
Al crear una nueva matriz de reacción se determinará el tipo y posteriormente no se podrá modificar.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Type


ID_REMA_PROP46

Interne ID: ID_REMA_PROP46

Información adicional 1

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.

Mehr im Online-Handbuch

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserProperty1


ID_REMA_PROP47

Interne ID: ID_REMA_PROP47

Información adicional 2

In der Runtime kann die hier eingegebene Zusatzinformation in einem VBA Makro ausgewertet werden.

Mehr im Online-Handbuch

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserProperty2


ID_REMA_PROP_GRP0

Interne ID: ID_REMA_PROP_GRP0

General

Propiedades generales para la matriz de reacción.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_REMA_STATES

Interne ID: ID_REMA_STATES

Configuración

Se abrirá el diálogo para definir los estados.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

States


ID_RGM_BACKCOLOR_INTERLOCKED_RECIPE_PARAMETER

Interne ID: ID_RGM_BACKCOLOR_INTERLOCKED_RECIPE_PARAMETER

Color de fondo para parámetros de receta interbloqueados

Selección del color de fondo para parámetros de receta interbloqueados. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: gris (#D3D3D3)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColorInterlockedParameter


ID_RGM_BACKCOLOR_INVALID_PLC

Interne ID: ID_RGM_BACKCOLOR_INVALID_PLC

Color de fondo para valores PLC inválidos

Selección del color de fondo para valores PLC inválidos. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: azul (#3D6894)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColorInvalidPLC


ID_RGM_BACKCOLOR_INVALID_VALUE

Interne ID: ID_RGM_BACKCOLOR_INVALID_VALUE

Color de fondo para valores de receta inválidos

Selección del color de fondo para celdas con valores inválidos. De esta manera se marcan los parámetros que se encuentren fuera del valor mínimo/máximo o cuya acción se base en una variable que no exista o no esté disponible. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: rojo (#DD4814)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColorInvalidValue


ID_RGM_BACKCOLOR_MATCH_PLC

Interne ID: ID_RGM_BACKCOLOR_MATCH_PLC

Color de fondo si el valor de receta es igual al valor PLC

Selección del color de fondo para valores correspondientes Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: verde (#96BD33)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColorMatchPLC


ID_RGM_BACKCOLOR_NOMATCH_PLC

Interne ID: ID_RGM_BACKCOLOR_NOMATCH_PLC

Color de fondo si el valor de receta es diferente al valor PLC

Selección del color de fondo para valores PLC diferentes Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: rojo (#DD4814)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColorNoMatchPLC


ID_RGM_GROUP_COLORS

Interne ID: ID_RGM_GROUP_COLORS

Colores

Propiedades para configurar colores para señalizar los resultados de la comprobación de recetas y para mostrar interbloqueos.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

Colors


ID_RGM_INTERLOCKING

Interne ID: ID_RGM_INTERLOCKING

Interbloqueo

Propiedades para la configuración de los colores para mostrar interbloqueos.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

Interlocking


ID_RGM_PROP06

Interne ID: ID_RGM_PROP06

Nombre de grupo

Nombre del grupo de recetas.

Con la configuración Archivos binarios para la propiedad DataSource están permitidos solo los caracteres alfanuméricos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_RGM_PROP13

Interne ID: ID_RGM_PROP13

Número de receta

Número de la receta.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RecipeNumber


ID_RGM_PROP14

Interne ID: ID_RGM_PROP14

Nombre de receta

Nombre para la receta. El nombre para la receta debe ser unívoco. Si se ha seleccionado Archivos binarios para la propiedad DataSource, el nombre solo puede contener caracteres alfanuméricos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RecipeName


ID_RGM_PROP15

Interne ID: ID_RGM_PROP15

Comentario 1

Fila 1 del comentario para la receta actual.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Comment1


ID_RGM_PROP16

Interne ID: ID_RGM_PROP16

Comentario 2

Fila 2 del comentario para la receta actual.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Comment2


ID_RGM_PROP21

Interne ID: ID_RGM_PROP21

Escribir sincrónicamente

Se establecerá en el grupo de recetas para todas las recetas de este grupo y se puede sobrescribir con cada receta.

Activado: Al escribir una receta se bloquearán todos los elementos de control en la pantalla del administrador del grupo de recetas hasta que el driver responda que todos los valores de la receta han sido escritos con éxito o que el Tiempo de espera [ms] configurado haya transcurrido.

Desactivado: Los valores de la receta se escribirán sin esperar una respuesta. Los elementos de control vuelven a estar manejables de inmediato. La respuesta del driver se efectuará a través del bit de estado WR_SUC, que se fijará en 1 en cuanto los valores se hayan escrito con éxito.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WriteSync


ID_RGM_PROP22

Interne ID: ID_RGM_PROP22

Tiempo de espera [ms]

Se establecerá en el grupo de recetas para todas las recetas de este grupo y se puede sobrescribir con cada receta.

Si Escribir sincrónicamente está activado se puede introducir aquí un tiempo de espera. Los elementos de control de la pantalla Administrador del grupo de recetas se liberarán a más tardar después de ese tiempo. Si se introduce como Tiempo de espera el valor 0, zenon calculará el tiempo de espera de la siguiente manera: 30000+(100*Número de puntos de datos)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WriteTimeout


ID_RGM_PROP23

Interne ID: ID_RGM_PROP23

Nivel de autorización

Selección de los niveles de autorización de la lista desplegable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PWLevel


ID_RGM_PROP26

Interne ID: ID_RGM_PROP26

Valor mín.

Sólo disponible si la propiedad Aplicar límite del valor predeterminado de la variable no está activada.

Valor mínimo de las variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Min


ID_RGM_PROP27

Interne ID: ID_RGM_PROP27

Valor máx.

Sólo disponible si la propiedad Aplicar límite del valor predeterminado de la variable no está activada.

Valor máximo de las variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Max


ID_RGM_RECIPE_VALUE_CHECK

Interne ID: ID_RGM_RECIPE_VALUE_CHECK

Validación del valor de receta

Propiedades para la configuración de los colores para mostrar los resultados de la comprobación de recetas.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

RecipeValueCheck


ID_RGM_TEXTCOLOR_INTERLOCKED_RECIPE_PARAMETER

Interne ID: ID_RGM_TEXTCOLOR_INTERLOCKED_RECIPE_PARAMETER

Color de texto para parámetros de receta interbloqueados

Selección del color de texto para parámetros de receta interbloqueados.Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: negro (#000000)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextColorInterlockedParameter


ID_RGM_TEXTCOLOR_INVALID_PLC

Interne ID: ID_RGM_TEXTCOLOR_INVALID_PLC

Color de texto para valores PLC inválidos

Selección del color de texto para valores PLC inválidos. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: blanco (#FFFFFF)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextColorInvalidPLC


ID_RGM_TEXTCOLOR_INVALID_VALUE

Interne ID: ID_RGM_TEXTCOLOR_INVALID_VALUE

Color de texto para valores de receta inválidos

Selección del color de texto para celdas con valores inválidos. De esta manera se marcan los parámetros que se encuentren fuera del valor mínimo/máximo o cuya acción se base en una variable que no exista o no esté disponible. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: blanco (#FFFFFF)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextColorInvalidValue


ID_RGM_TEXTCOLOR_MATCH_PLC

Interne ID: ID_RGM_TEXTCOLOR_MATCH_PLC

Color de texto si el valor de la receta es igual al valor PLC

Selección del color del texto para valores correspondientes Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: blanco (#FFFFFF)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextColorMatchPLC


ID_RGM_TEXTCOLOR_NOMATCH_PLC

Interne ID: ID_RGM_TEXTCOLOR_NOMATCH_PLC

Color de texto si el valor de la receta es distinto al valor PLC

Selección del color del texto para valores PLC diferentes Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: blanco (#FFFFFF)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextColorNoMatchPLC


ID_SAP_ADDITIONAL_GRP

Interne ID: ID_SAP_ADDITIONAL_GRP

Mensajes

Determine en las siguientes propiedades qué informaciones adicionales deben ser enviadas con los mensajes de avería.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SapAdditional


ID_SAP_DEBUG_GRP

Interne ID: ID_SAP_DEBUG_GRP

Búsqueda de errores

Propiedades para comprobar la conexión y la protocolización.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SapDebug


ID_SAP_FIELD_GRP

Interne ID: ID_SAP_FIELD_GRP

Campo de estructura

Parámetros para la configuración de datos de un campo de estructura para SAP ERP.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SapStructField


ID_SAP_FUNC_ACTIVITY_GRP

Interne ID: ID_SAP_FUNC_ACTIVITY_GRP

Supervisión de la actividad

Contiene propiedades para la supervisión de la actividad.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SapFuncActivity


ID_SAP_FUNC_ACTIVITY_VAR

Interne ID: ID_SAP_FUNC_ACTIVITY_VAR

Actividad

Variable numérica para supervisión de la actividad de la función SAP. Se puede utilizar p. ej. para interbloqueos para evitar así invocaciones superpuestas.

Valores posibles: 0, 1, 2

  • 0: desactivado
  • 1: En la fila de espera de invocaciones
  • 2: Invocación activa

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ActivityVar


ID_SAP_FUNC_ERROR_CODE_VAR

Interne ID: ID_SAP_FUNC_ERROR_CODE_VAR

Código de error

Variable numérica para el código de error de la invocación de función.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ErrorVar


ID_SAP_FUNC_ERROR_GRP

Interne ID: ID_SAP_FUNC_ERROR_GRP

Mensajes de error

Contiene propiedades para la configuración de los mensajes de error para las funciones SAP.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SapFuncError


ID_SAP_FUNC_ERROR_TEXT_VAR

Interne ID: ID_SAP_FUNC_ERROR_TEXT_VAR

Texto de error

Variable de cadena para la descripción corta del último error ocurrido.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ErrorTextVar


ID_SAP_FUNC_INFO

Interne ID: ID_SAP_FUNC_INFO

Info

Texto corto libremente definible. Sólo sirve de información. Al crear una función SAP con el Asistente se establecerá una descripción de la interfaz correspondiente, en caso de que exista, en el sistema SAP.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Info


ID_SAP_FUNC_LABEL

Interne ID: ID_SAP_FUNC_LABEL

Nombre de función

Descripción libremente definible para la función SAP.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Label


ID_SAP_FUNC_LAST_ERROR_VAR

Interne ID: ID_SAP_FUNC_LAST_ERROR_VAR

Descripción de error

Variable de cadena para la descripción extensa del último error ocurrido.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LastErrorVar


ID_SAP_FUNC_NAME

Interne ID: ID_SAP_FUNC_NAME

Bloque de funciones RFC

Nombre del bloque de funciones invocado en el sistema SAP.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_SAP_FUNC_SERVERFUNC

Interne ID: ID_SAP_FUNC_SERVERFUNC

Función

Selección de una función de zenon a la que se llame desde el programa del servidor. Haciendo clic sobre el botón ... se abre un diálogo para elegir una función.

Observación: Si se llama a la función desde otro proyecto asegúrese de que dicho proyecto esté funcionando durante el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ServerFunction


ID_SAP_FUNC_SERVERPRG

Interne ID: ID_SAP_FUNC_SERVERPRG

Ejecutar como programa del servidor

Definición de una función SAP como programa del servidor.

  • Activado: La función se ejecutará como programa del servidor.
  • Desactivado: La función se ejecutará como programa del cliente.

Por defecto: Desactivado

Si hay una variable vinculada con la propiedad Actividad, durante la llamada al programa del servidor se configurará como activada (2).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ServerPgm


ID_SAP_FUNC_SERVERPRG_GRP

Interne ID: ID_SAP_FUNC_SERVERPRG_GRP

Programa del servidor

Propiedades para proyectar funciones SAP como programas de servidor.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

GRP_SapFuncServerPrg


ID_SAP_FUNC_WAIT

Interne ID: ID_SAP_FUNC_WAIT

Tiempo de espera

Entrada de un periodo de tiempo en milisegundos, que se esperará antes y después de llamar a la función vinculada, para que los valores de las variables se hayan escrito o leído con seguridad. Se recomienda sobre todo para variables con controles de comunicación lenta y/o ciclos de lectura largos.

  • Mínimo: 0
  • Máximo: 4294967295
  • Por defecto: 0

Recomendación:

  • Variables del driver interno o driver del sistema: Valores bajos cercanos a 0 ms.
  • Driver matemático: Valores entre 100 – 200 ms. (Este driver se actualizará, dependiendo de la utilización del sistema, más o menos cada 100 ms.)
  • Otros drivers y controles: Valores que están algo por encima del tiempo de actualización del driver. En caso de un mayor número de variables serán equivalentemente mayores.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Wait


ID_SAP_FUNCTION_GRP

Interne ID: ID_SAP_FUNCTION_GRP

Función SAP

Contiene propiedades para la configuración básica de funciones SAP.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SapFunctions


ID_SAP_LOG_TO_CEL

Interne ID: ID_SAP_LOG_TO_CEL

Mensajes log en CEL

Escritura de mensajes log en la CEL.

  • Activado: Los mensajes se escribirán en la CEL.
  • Desactivado: Los mensajes no se escribirán en la CEL.

Por defecto: activado

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

LogToCEL


ID_SAP_LOGON_GRP

Interne ID: ID_SAP_LOGON_GRP

SAP Logon

Determine en las siguientes propiedades las informaciones sobre el mandante y los usuarios requeridas para la conexión.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SapLogon


ID_SAP_NOTIFICATION_GRP

Interne ID: ID_SAP_NOTIFICATION_GRP

Mensaje de mantenimiento

Con las siguientes propiedades determina qué informaciones adicionales deben ser enviadas con los mensajes de avería.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SapNotification


ID_SAP_PAR_TAB_INFO

Interne ID: ID_SAP_PAR_TAB_INFO

Info

Texto corto libremente definible. Sirve sólo de información y al crear una función SAP con el asistente se establecerá una descripción de la interfaz correspondiente, en caso de que exista, en el sistema SAP.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Info


ID_SAP_PAR_TAB_NAME

Interne ID: ID_SAP_PAR_TAB_NAME

Nombre en el sistema SAP

Nombre del parámetro, tabla o campo de estructura en el sistema SAP.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_SAP_PAR_TAB_OPTIONAL

Interne ID: ID_SAP_PAR_TAB_OPTIONAL

Opcional

Determina si el parámetro o la tabla es opcional. Los parámetros y tablas opcionales pueden ser omitidos al invocar un bloque de funciones.

Sirve sólo de información y al crear una función SAP con el asistente se establecerá una descripción de la interfaz correspondiente en el sistema SAP.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Optional


ID_SAP_PAR_TAB_TYPE

Interne ID: ID_SAP_PAR_TAB_TYPE

Tipo

Tipo de parámetro. Dependiente del tipo de función. Sirve sólo de información y al crear una función SAP con el asistente se establecerá una descripción de la interfaz correspondiente en el sistema SAP.

Importación: el valor del parámetro se aplicará al bloque de funciones al invocar.

La exportación: El valor del parámetro se devolverá por la invocación de función.

Changing: tanto parámetros de entrada como de salida.

Tabla: Tabla de tipos de funciones. No modificable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Type


ID_SAP_PAR_TAB_VARIABLE

Interne ID: ID_SAP_PAR_TAB_VARIABLE

Variable

Variable zenon vinculada al parámetro, a la tabla o al campo de estructura. Para tablas suele ser una variable array.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variable


ID_SAP_PARAMETER_GRP

Interne ID: ID_SAP_PARAMETER_GRP

Parámetro

Contiene propiedades para la configuración de los parámetros para funciones SAP.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SapParameter


ID_SAP_PROGRAMID

Interne ID: ID_SAP_PROGRAMID

ID del programa

Entrada del ID del programa del destino RFC mediante el cual se establecerá la conexión a la aplicación SAP y se llamará al programa del servidor.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapProgramId


ID_SAP_PROP_CLIENT

Interne ID: ID_SAP_PROP_CLIENT

Mandante

Número o nombre del mandante del sistema SAP, con el que se desea establecer la conexión.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapClient


ID_SAP_PROP_END_TIME

Interne ID: ID_SAP_PROP_END_TIME

Hasta

Momento hasta el que se ejecuta el programa horario.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EndTime


ID_SAP_PROP_EQUIPMENT

Interne ID: ID_SAP_PROP_EQUIPMENT

Área técnica/Equipment

Muestra si el sistema SAP trata a la identificación de los recursos de la variable como un número de un puesto técnico o como un equipo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapEquipment


ID_SAP_PROP_EVERY_DAY

Interne ID: ID_SAP_PROP_EVERY_DAY

Cada día

El horario se ejecutará todos los días. Cuando esta propiedad está activada, se desactivan las propiedades de los días individuales.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EveryDay


ID_SAP_PROP_FRIDAY

Interne ID: ID_SAP_PROP_FRIDAY

Viernes

El horario se ejecutará todos los viernes. Sólo se podrá activar cuando "Todos los días" esté desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Friday


ID_SAP_PROP_INTERVAL

Interne ID: ID_SAP_PROP_INTERVAL

Todos/as

Intervalo en el que el horario se ejecutará. Si no se especifica un tiempo final, el horario se ejecutará hasta la medianoche del día elegido.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Interval


ID_SAP_PROP_LANGUAGE

Interne ID: ID_SAP_PROP_LANGUAGE

Idioma

Idioma del usuario. El procesamiento por el sistema SAP de las diéresis y demás caracteres especiales depende del idioma elegido.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapLanguage


ID_SAP_PROP_MESSBELEG

Interne ID: ID_SAP_PROP_MESSBELEG

Crear recibo de medición

Activado: Cree un recibo de medición para enviarlo al sistema SAP.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapMeasDoc


ID_SAP_PROP_MONDAY

Interne ID: ID_SAP_PROP_MONDAY

Lunes

El horario se ejecutará todos los lunes. Sólo se podrá activar cuando "Todos los días" esté desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Monday


ID_SAP_PROP_NOTIFICATION_TYPE

Interne ID: ID_SAP_PROP_NOTIFICATION_TYPE

Tipo de mensaje

Uno de los tipos de mensajes predeterminados en el sistema SAP. La reacción del sistema SAP a la avería depende de la clase de mensaje.

Si no se especifica la clase de mensaje, el sistema SAP no puede informar de la avería, por lo que reaccionará con un mensaje de error.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapNotificationType


ID_SAP_PROP_PASSWORD

Interne ID: ID_SAP_PROP_PASSWORD

Contraseña

Contraseña del usuario del sistema SAP.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapPassword


ID_SAP_PROP_PLANT

Interne ID: ID_SAP_PROP_PLANT

Fábrica

Trabajo de mantenimiento en mensajes de avería. Si no se introduce ningún trabajo de mantenimiento, el sistema SAP utiliza por defecto el lugar de la planta (puesto técnico, equipo) al que se refiere el mensaje de avería.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapPlant


ID_SAP_PROP_REPORTER

Interne ID: ID_SAP_PROP_REPORTER

Emisor

En el sistema SAP se registrará adicionalmente el emisor del que procede el mensaje de avería.

Si no se especifica un emisor, el sistema SAP registrará por defecto al usuario registrado en el sistema.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapReporter


ID_SAP_PROP_ROUTER

Interne ID: ID_SAP_PROP_ROUTER

Cadena de router

Dirección IP o nombre del enrutador SAP con el que se establece la conexión. En caso de que la conexión funcione a través de varios enrutadores SAP („Hops"), hay que especificar el enrutador más cercano al sistema de control .

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapRouter


ID_SAP_PROP_SATURDAY

Interne ID: ID_SAP_PROP_SATURDAY

Sábado

El horario se ejecutará todos los sábados. Sólo se podrá activar cuando "Todos los días" esté desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Saturday


ID_SAP_PROP_SERVER

Interne ID: ID_SAP_PROP_SERVER

Servidor de aplicaciones

Dirección IP o nombre del enrutador SAP con el que se establece la conexión.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapServer


ID_SAP_PROP_START_TIME

Interne ID: ID_SAP_PROP_START_TIME

A partir de las/A las

Hora de inicio del horario. Si se especifica 00.00.00 para el intervalo y para la hora final, el horario se ejecutará sólo una vez a esa hora en los días elegidos .

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StartTime


ID_SAP_PROP_SUNDAY

Interne ID: ID_SAP_PROP_SUNDAY

Domingo

El horario se ejecutará todos los domingos. Sólo se podrá activar cuando "Todos los días" esté desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Sunday


ID_SAP_PROP_SYSTEM

Interne ID: ID_SAP_PROP_SYSTEM

Número del sistema

Número del sistema SAP (también denominado número de instancia) con el que se establecerá la conexión. En un servidor de aplicaciones pueden funcionar varios sistemas SAP con diferentes IDs de sistema.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapSystemId


ID_SAP_PROP_TEST

Interne ID: ID_SAP_PROP_TEST

Comprobar la conexión

Intenta crear una conexión al sistema SAP con las configuraciones especificadas. Cuando no se puede conectar, se produce un aviso de error detallado en forma de un buzón de mensajes.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapTest


ID_SAP_PROP_THURSDAY

Interne ID: ID_SAP_PROP_THURSDAY

Jueves

El horario se ejecutará todos los jueves. Sólo se podrá activar cuando "Todos los días" esté desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Thursday


ID_SAP_PROP_TRACE

Interne ID: ID_SAP_PROP_TRACE

Protocolización

Controla la protocolización de la comunicación al sistema SAP.

activado: La comunicación entre zenon y el sistema SAP se protocolizará.

Por defecto: Desactivado

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapTrace


ID_SAP_PROP_TUESDAY

Interne ID: ID_SAP_PROP_TUESDAY

Martes

El horario se ejecutará todos los martes. Sólo se podrá activar cuando "Todos los días" esté desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Tuesday


ID_SAP_PROP_USER

Interne ID: ID_SAP_PROP_USER

Usuario

Nombre del usuario del sistema SAP.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapUser


ID_SAP_PROP_VAR_NAME

Interne ID: ID_SAP_PROP_VAR_NAME

Nombre:

Nombre de las variables seleccionadas para el horario elegido.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapVarName


ID_SAP_PROP_VAR_TAG

Interne ID: ID_SAP_PROP_VAR_TAG

Identificación

Identificación de las variables seleccionadas para el horario elegido.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapVarTag


ID_SAP_PROP_VAR_TYPE

Interne ID: ID_SAP_PROP_VAR_TYPE

Tipo

Tipo de las variables seleccionadas para el horario elegido.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapVarType


ID_SAP_PROP_VAR_UNIT

Interne ID: ID_SAP_PROP_VAR_UNIT

Unidad

Unidad de las variables seleccionadas para el horario elegido.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SapVarUnit


ID_SAP_PROP_WEDNESDAY

Interne ID: ID_SAP_PROP_WEDNESDAY

Miércoles

El horario se ejecutará todos los miércoles. Sólo se podrá activar cuando "Todos los días" esté desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Wednesday


ID_SAP_SCHEDULE_DATE_GRP

Interne ID: ID_SAP_SCHEDULE_DATE_GRP

Día de la semana

Con estas propiedades puede establecer en qué día o días debe ejecutarse el horario.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ScheduleDate


ID_SAP_SCHEDULE_MEAS_DOC_GRP

Interne ID: ID_SAP_SCHEDULE_MEAS_DOC_GRP

Recibo de medición

Con las siguientes propiedades puede establecer qué emisor debe ser registrado para los mensajes de avería.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ScheduleMeasDoc


ID_SAP_SCHEDULE_TIME_GRP

Interne ID: ID_SAP_SCHEDULE_TIME_GRP

Hora

Con las siguientes propiedades puede establecer a qué hora se debe ejecutar el horario.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ScheduleTime


ID_SAP_SERVERPRG_GRP

Interne ID: ID_SAP_SERVERPRG_GRP

Programas del servidor

Configuraciones de conexión para la aplicación SAP.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

GRP_SapServerPrg


ID_SAP_SYSTEM_GRP

Interne ID: ID_SAP_SYSTEM_GRP

Sistema SAP R/3

Introduzca en las siguientes propiedades los nombres o números del servidor SAP, del enrutador SAP y del sistema SAP que desee utilizar para establecer la conexión.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SapSystem


ID_SAP_TAB_ROWCOUNT_VAR

Interne ID: ID_SAP_TAB_ROWCOUNT_VAR

Número de líneas

Variable numérica para el número de filas que se tomará de la variable vinculada a la tabla o también el número de filas leídas al invocar la función SAP.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RowCountVar


ID_SAP_TABLE_GRP

Interne ID: ID_SAP_TABLE_GRP

Tabla

Contiene propiedades para la tabla de tipos de funciones.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SapTable


ID_SATBEF_PROP1

Interne ID: ID_SATBEF_PROP1

Modo

Selección de la utilización prevista

Especificación: El elemento de comando sirve para activar el comando

Invocación de la función: El elemento de comando sirve para ejecutar el comando
Esta opción sólo existe por razones de compatibilidad con versiones antiguas y no debería ser utilizada más.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Mode


ID_SATBEF_PROP2

Interne ID: ID_SATBEF_PROP2

Pantalla

Selección de la pantalla que se abrirá al activar el elemento en el runtime.

Sólo se ofrecerán pantallas del tipo "Comando"

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PictSwitch_Dlg


ID_SATBEF_PROP3

Interne ID: ID_SATBEF_PROP3

Parámetro

Abre el diálogo de parámetros del elemento de comando.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PictFilter_Dlg


ID_SATBEF_PROP4

Interne ID: ID_SATBEF_PROP4

Función

Selección de la función para ejecutar en modo: Función .
Ya no se usa. Sólo se mantiene por razones de compatibilidad con versiones antiguas.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Function


ID_SATBEF_PROP5

Interne ID: ID_SATBEF_PROP5

Grupo de activación

Selección del grupo de activación.

Sólo necesario en relación con la función precedente.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ActivationGroup


ID_SATBEF_PROP6

Interne ID: ID_SATBEF_PROP6

Siempre disponible

Activado: Seleccionar comando directamente con un clic del ratón (izquierdo)

Desactivado: Sólo es posible seleccionar el comando si se ha seleccionado antes la función (Funciones ->Aplicación ->Activar comando)
Después de activar el comando en el runtime se mostrará un recuadro móvil en todos los elementos de comando que se hayan proyectado así.

Crear una nueva acción de comando haciendo clic derecho con el ratón -> Acción nueva.

Atención: en vista de diálogo sólo es posible en la ventana izquierda.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlwaysSelectable


ID_SATBEF_PROP_GRP1

Interne ID: ID_SATBEF_PROP_GRP1

Acción

Propiedades para acciones de comandos

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Action


ID_SAVE_ALWAYS_BIN_AML

Interne ID: ID_SAVE_ALWAYS_BIN_AML

Guardar búfer anular al cambiar de valor

Solo disponible cuando la propiedad Lista de mensajes de alarma activada esté activada.

  • Activado: Cada modificación de datos en la lista de mensajes de alarma hará que se almacene todo el búfer anular (alarm.bin).
  • Desactivado: Los datos de la lista de mensajes de alarma (alarm.bin) solo se guardarán al finalizar el runtime o al ejecutar la función Guardar búfer anular de AML y CEL. Los datos históricos (*.aml) se pueden guardar al cambiar cada valor con independencia de esta configuración.

Por defecto: desactivado
Observación: Si la propiedad se configura como activada, eso puede dar lugar a una carga considerable para el sistema - sobre todo con discos flash -. Si la propiedad se configura como desactivada puede dar lugar a una finalización inesperada del runtime con pérdida de datos. Desactivada Se recomienda sobre todo para poco rendimiento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SaveAmlStack


ID_SAVE_ALWAYS_BIN_CEL

Interne ID: ID_SAVE_ALWAYS_BIN_CEL

Guardar búfer anular al cambiar de valor

Selección de tipo de almacenamiento de datos.

  • Activado: Cada modificación de datos en la lista cronológica de eventos (CEL) hará que se almacenen los datos (cel.bin).
  • Desactivado: Los datos de la lista CEL (cel.bin) se guardarán al finalizar el runtime o al ejecutar la función Guardar memoria anular de AML y CEL. Se recomienda para poco rendimiento. Los datos históricos (*.cel) se pueden guardar al cambiar cada valor con independencia de esta configuración.

Observación: Si la propiedad se configura como activada, eso puede dar lugar a una carga considerable para el sistema - sobre todo con discos flash -. Si la propiedad se configura como desactivada puede dar lugar a una finalización inesperada del runtime con pérdida de datos. Desactivada Se recomienda sobre todo para poco rendimiento.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SaveCelStack


ID_SCREEN_GRP_API

Interne ID: ID_SCREEN_GRP_API

Interfaz de programación

Grupo para configurar los accesos API.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

API


ID_SCREEN_GRP_MULTITOUCH_POINTER_MSG

Interne ID: ID_SCREEN_GRP_MULTITOUCH_POINTER_MSG

Eventos Multi-Touch

Propiedades para el análisis de eventos Multi-Touch.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PointerMessages


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE

Cross Slide

Activado: Reconocimiento configurado para Cross Slide.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_CrossSlide


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_EXACT

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_EXACT

Cross Slide Exact

Activado: Reconocimiento configurado para Cross Slide Exact.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_CrossSlideExact


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_HORIZONTAL

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_HORIZONTAL

Cross Slide Horizontal

Activado: Reconocimiento configurado para Cross Slide Horizontal.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_CrossSlideHorizontal


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_REARRANGE

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_REARRANGE

Cross Slide Rearrange

Activado: Reconocimiento configurado para Cross Slide Rearrange.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_CrossSlideRearrange


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_SELECT

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_SELECT

Cross Slide Select

Activado: Reconocimiento configurado para Cross Slide Select.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_CrossSlideSelect


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_SPEED_BUMP

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_CROSS_SLIDE_SPEED_BUMP

Cross Slide Speed Bump

Activado: Reconocimiento configurado para Cross Slide Speed Bump.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_CrossSlideSpeedBump


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_DRAG

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_DRAG

Drag

Activado: Reconocimiento configurado para Drag.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_Drag


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_HOLD

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_HOLD

Hold

Activado: Reconocimiento configurado para Hold.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_Hold


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_HOLD_MOUSE

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_HOLD_MOUSE

Hold (Mouse)

Activado: Reconocimiento configurado para Hold (Mouse).

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_HoldMouse


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION

Manipulation

Activado: Reconocimiento configurado para Manipulation.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_Manipulation


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_EXACT

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_EXACT

Exact

Activado: Reconocimiento configurado para Exact.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_Exact


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_RAILS_X

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_RAILS_X

Rails X

Activado: Reconocimiento configurado para Rails X.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_RailsX


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_RAILS_Y

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_RAILS_Y

Rails Y

Activado: Reconocimiento configurado para Rails Y.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_RailsY


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_ROTATION

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_ROTATION

Rotation

Activado: Reconocimiento configurado para Rotation.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_Rotation


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_ROTATION_INERTIA

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_ROTATION_INERTIA

Rotation Inertia

Activado: Reconocimiento configurado para Rotation Inertia.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_RotationInertia


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_SCALING

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_SCALING

Scaling

Activado: Reconocimiento configurado para Scaling.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_Scaling


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_SCALING_INERTIA

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_SCALING_INERTIA

Scaling Inertia

Activado: Reconocimiento configurado para Scaling Inertia.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_ScalingInertia


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_TRANSLATION_INERTIA

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_TRANSLATION_INERTIA

Translation Inertia

Activado: Reconocimiento configurado para Translation Inertia.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_TranslationInertia


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_TRANSLATION_X

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_TRANSLATION_X

Translation X

Activado: Reconocimiento configurado para Translation X.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_TranslationX


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_TRANSLATION_Y

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_MANIPULATION_TRANSLATION_Y

Translation Y

Activado: Reconocimiento configurado para Translation X.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_TranslationY


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_SECONDARY_TAP

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_SECONDARY_TAP

Secondary Tap

Activado: Reconocimiento configurado para Secondary Tap.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_SecondaryTap


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_TAP

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_TAP

Tap

Activado: Reconocimiento configurado para Tap.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_Tap


ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_TAP_DOUBLE

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_FLAG_TAP_DOUBLE

Tap Double

Activado: Reconocimiento configurado para Tap Double.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Gestures_TapDouble


ID_SCREEN_INTERACTION_CONFIGURATION_GRP

Interne ID: ID_SCREEN_INTERACTION_CONFIGURATION_GRP

Análisis de gestos VSTA

Propiedades para el reconocimiento de gestos para pantallas mediante VSTA.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GestureRecognition


ID_SCREEN_PROP_INTERACTION_ACTIVE

Interne ID: ID_SCREEN_PROP_INTERACTION_ACTIVE

Reconocimiento de gestos activado

Activa el análisis de gestos. Los gestos se definen con otras propiedades.

Solo disponible cuando en las propiedades del proyecto del grupo Interacción para la propiedad Evaluación se haya establecido Windows 8.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GestureRecognitionActive


ID_SCREEN_PROP_NCPOINTERDOWN_MSG

Interne ID: ID_SCREEN_PROP_NCPOINTERDOWN_MSG

NCPointerDown

Activado: Se analizará el evento NCPointerDown.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NCPointerDown


ID_SCREEN_PROP_NCPOINTERUP_MSG

Interne ID: ID_SCREEN_PROP_NCPOINTERUP_MSG

NCPointerUp

Activado: Se analizará el evento NCPointerUp.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NCPointerUp


ID_SCREEN_PROP_NCPOINTERUPDATE_MSG

Interne ID: ID_SCREEN_PROP_NCPOINTERUPDATE_MSG

NCPointerUpdate

Activado: Se analizará el evento NCPointerUpdate.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NCPointerUpdate


ID_SCREEN_PROP_POINTERACTIVATE_MSG

Interne ID: ID_SCREEN_PROP_POINTERACTIVATE_MSG

PointerActivate

Activado: Se analizará el evento PointerActivate.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PointerActivate


ID_SCREEN_PROP_POINTERCAPTURECHANGED_MSG

Interne ID: ID_SCREEN_PROP_POINTERCAPTURECHANGED_MSG

PointerCaptureChanged

Activado: Se analizará el evento PointerCaptureChanged.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PointerCaptureChanged


ID_SCREEN_PROP_POINTERDEVICECHANGE_MSG

Interne ID: ID_SCREEN_PROP_POINTERDEVICECHANGE_MSG

PointerDeviceChange

Activado: Se analizará el evento PointerDeviceChange.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PointerDeviceChange


ID_SCREEN_PROP_POINTERDEVICEINRANGE_MSG

Interne ID: ID_SCREEN_PROP_POINTERDEVICEINRANGE_MSG

PointerDeviceInRange

Activado: Se analizará el evento PointerDeviceInRange.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PointerDeviceInRange


ID_SCREEN_PROP_POINTERDEVICEOUTOFRANGE_MSG

Interne ID: ID_SCREEN_PROP_POINTERDEVICEOUTOFRANGE_MSG

PointerDeviceOutOfRange

Activado: Se analizará el evento PointerDeviceOutOfRange.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PointerDeviceOutOfRange


ID_SCREEN_PROP_POINTERDOWN_MSG

Interne ID: ID_SCREEN_PROP_POINTERDOWN_MSG

PointerDown

Activado: Se analizará el evento PointerDown.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PointerDown


ID_SCREEN_PROP_POINTERENTER_MSG

Interne ID: ID_SCREEN_PROP_POINTERENTER_MSG

PointerEnter

Activado: Se analizará el evento PointerEnter.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PointerEnter


ID_SCREEN_PROP_POINTERHWHEEL_MSG

Interne ID: ID_SCREEN_PROP_POINTERHWHEEL_MSG

PointerHWheel

Activado: Se analizará el evento PointerHWheel.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PointerHWheel


ID_SCREEN_PROP_POINTERLEAVE_MSG

Interne ID: ID_SCREEN_PROP_POINTERLEAVE_MSG

PointerLeave

Activado: Se analizará el evento PointerLeave.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PointerLeave


ID_SCREEN_PROP_POINTERMESSAGE_HANDLING

Interne ID: ID_SCREEN_PROP_POINTERMESSAGE_HANDLING

Datos en crudo-Enrutamiento de eventos

Solo disponible cuando se haya configurado la propiedad Evaluación en las propiedades de proyecto para Interacción en Windows 8.

Selección de la lista desplegable de los eventos que se desee analizar:

  • Todos los eventos: se analizarán todos los eventos.
  • Desactivado: el análisis está desactivado
  • Solo eventos seleccionados: solo se analizarán los eventos marcados con los cuadros de comprobación.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RawEventRouting


ID_SCREEN_PROP_POINTERUP_MSG

Interne ID: ID_SCREEN_PROP_POINTERUP_MSG

PointerUp

Activado: Se analizará el evento PointerUp.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PointerUp


ID_SCREEN_PROP_POINTERUPDATE_MSG

Interne ID: ID_SCREEN_PROP_POINTERUPDATE_MSG

PointerUpdate

Activado: Se analizará el evento PointerUpdate.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PointerUpdate


ID_SCREEN_PROP_POINTERWHEEL_MSG

Interne ID: ID_SCREEN_PROP_POINTERWHEEL_MSG

PointerWheel

Activado: Se analizará el evento PointerWheel.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PointerWheel


ID_SCRIPT_DEL

Interne ID: ID_SCRIPT_DEL

{Eliminar Script}

Se eliminará el script

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DeleteScript


ID_SCRIPT_GRP0

Interne ID: ID_SCRIPT_GRP0

General

Configuraciones generales para el script.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_SCRIPT_IMEX_NAME

Interne ID: ID_SCRIPT_IMEX_NAME

Nombre:

Nombre unívoco de la receta.
Por defecto: Receta_x (x corresponde a un número consecutivo).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RecipeName


ID_SCRIPT_NAME

Interne ID: ID_SCRIPT_NAME

Nombre:

Nombre unívoco del script.

Por defecto: Script_x (x corresponde a un número consecutivo).

Se pueden definir scripts propios y se pueden seleccionar scripts predefinidos. Introducción de un nombre en el Combobox para scripts propios o selección de la lista desplegable:

  • AUTOSTART: El script se ejecutará al iniciar el runtime (ordenador individual o servidor) automáticamente tras activar la pantalla de inicio (en el ordenador individual o servidor) cuando el proyecto sea el proyecto de inicio del runtime.
  • AUTOEND: Al finalizar el modo runtime (ordenador individual o servidor) el script se ejecutará automáticamente (en el ordenador individual o servidor) cuando el proyecto sea el proyecto de inicio del runtime.
    Atención: Las macros VBA que haya que ejecutar en AUTOEND tienen que ser invocadas con Project.Inactive. Los archivos cíclicos no pueden ser introducidos en el script AUTOEND.
  • AUTOSTART_CLIENT: El script se ejecutará al iniciar el runtime del cliente automáticamente antes de activar la pantalla de inicio en el cliente cuando el proyecto sea el proyecto de inicio del runtime.
  • AUTOEND_CLIENT: Al finalizar el modo runtime del cliente el script se ejecutará automáticamente en el cliente cuando el proyecto sea el proyecto de inicio del runtime.
  • AUTOSTART_SRVPRJ: El script se ejecutará al iniciar el runtime en el ordenador que sea el servidor del proyecto, automáticamente antes de activar la pantalla de inicio cuando el proyecto no sea el proyecto de inicio del runtime.
  • AUTOEND_SRVPRJ: A finalizar el modo runtime el script se ejecutará automáticamente en el ordenador que sea el servidor del proyecto cuando el proyecto no sea el proyecto de inicio del runtime.

Atención: Esta propiedad no está disponible para el cambio de idioma.

Observación para proyectos multiusuarios: Al cambiar los nombres de los scripts, los parámetros de las funciones relacionadas se ajustarán automáticamente después de la pregunta de control Permitir modificaciones. Si todo está correcto, se modificará el script.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_SCRIPT_NEW

Interne ID: ID_SCRIPT_NEW

{Script nuevo}

Se creará un nuevo script con el nombre por defecto Script_x (x corresponde a un número consecutivo).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NewScript


ID_SCRIPT_SYNCWRITE

Interne ID: ID_SCRIPT_SYNCWRITE

Escribir sincrónicamente

Activado: La ejecución de la función con esta receta no finalizará hasta que se reciba un mensaje de respuesta positivo de la escritura o transcurra el tiempo de espera definido.
Así se asegura en los scripts que la función siguiente no se ejecute hasta que ésta se haya finalizado efectivamente.
El mensaje de respuesta se puede solicitar también con el bit de estado "WR-SUC“.
Desactivado: No se esperará ninguna confirmación escrita.
Por defecto: desactivado

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SyncWrite


ID_SCRIPT_SYNCWRITE_TIMEOUT

Interne ID: ID_SCRIPT_SYNCWRITE_TIMEOUT

Tiempo de espera [ms]

Si está activada la "Escritura sincronizada“ se puede introducir aquí un tiempo de espera.
Si se introduce 0 el sistema de control calculará el tiempo de espera así:
3000+(100*número de puntos de datos)
Mínimo: 0
Máximo: 4294967295.
Por defecto: 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SyncWriteTimeout


ID_SEA_PROP_ABBRUCH

Interne ID: ID_SEA_PROP_ABBRUCH

Cancelar

Estado de las variables de interrupción, en las que se interrumpe la secuencia de conmutación.

0 ... OFF

1 ... ON

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Cancel


ID_SEA_PROP_ABBRUCH_PV

Interne ID: ID_SEA_PROP_ABBRUCH_PV

Cancelar-Variable

Con la variable seleccionada se puede interrumpir la secuencia de conmutación.

Variable del proceso o marcador (recomendado: driver interno BOOL).

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CancelVariable


ID_SEA_PROP_DIREKT

Interne ID: ID_SEA_PROP_DIREKT

Directamente ejecutable

La secuencia de conmutación se inicia con una función (Aplicación->Funcionamiento automático de la secuencia de conmutación).

Cuando no se producen errores, deja de funcionar automáticamente.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DirectExecute


ID_SEA_PROP_GRP0

Interne ID: ID_SEA_PROP_GRP0

General

Parámetros de la secuencia de conmutación

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_SEA_PROP_LERNEN

Interne ID: ID_SEA_PROP_LERNEN

Permitir aprendizaje

La secuencia de conmutación puede grabar conmutaciones en el runtime.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LearningEnabled


ID_SEA_PROP_NAME

Interne ID: ID_SEA_PROP_NAME

Descripción

Nombre unívoco de la secuencia de conmutación

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_SEA_PROP_VAR

Interne ID: ID_SEA_PROP_VAR

Variable

Variable (obligatorio), en la que se representan los estados de la secuencia de conmutación.
Variable marcador (recomendado: Driver interno DWORD).

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variable


ID_SGW_PROP1

Interne ID: ID_SGW_PROP1

Nombre:

Distinct name of the Gateway Parameter Set.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_SGW_PROP2

Interne ID: ID_SGW_PROP2

Variable de origen

Name of the variable linked as source.

  • In Mirroring mode, state and value of this variable are transferred to the output side.
  • In Setpoint mode, the setpoint event of this variable is passed to the output setpoint action.
  • In all other modes, the state of this variable is evaluated to trigger output actions.

Opens the variable selection dialog.

Usually used with wildcards.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SourceVariable


ID_SGW_PROP3

Interne ID: ID_SGW_PROP3

Variable de referencia

Name of the variable linked as target.

  • In "Mirroring" Mode, this is the output variable.
  • In all other modes, the variable defined in the targets Command Group as "Response variable" serves as Reference to the Command and Setpoint actions.

Opens the variable selection dialog.

Usually used with wildcards.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Add


ID_SGW_PROP5

Interne ID: ID_SGW_PROP5

Filtro de etiquetas de recursos

Text based filter: Only apply this Gateway rule to input variables with matching Resource label (wildcards can be used).

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SourceFilter


ID_SGW_PROP6

Interne ID: ID_SGW_PROP6

Modo

Mode of the Gateway

  • IEC
  • Mirroring
  • Non IEC
  • Source IEC emulation

Target IEC emulation

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Mode


ID_SGW_PROP7

Interne ID: ID_SGW_PROP7

Grupo de comandos

Name of the Command group to be used.
Selection from drop down box.

Not available in "Mirroring" Mode.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CmdGrp


ID_SGW_PROP8

Interne ID: ID_SGW_PROP8

Interbloqueo

Link an existing interlocking to this element.

If a condition in one of the formulas of the interlocking is true, this element is locked so that no operation is possible.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Locking


ID_SGW_PROP9

Interne ID: ID_SGW_PROP9

Interbloqueo reflejo

This parameter defines what should be transferred when the interlocking condition goes.

Mirroring mode plus interlocking required.

  • Edge: Current value.
    Current source value will be transferred only.
  • Gage: Current value & Updates.
    Current source value and further changes will be transferred

Gage: Updates.
No transfer of the current source value but all further changes.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MirrorMode


ID_SGW_PROP10

Interne ID: ID_SGW_PROP10

Evento

Trigger event (Source).

Select an IEC event, Limit- or REMA Counter number from the drop down box.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CounterID


ID_SGW_PROP11

Interne ID: ID_SGW_PROP11

Acciones menú ID

Action Mapping (Target).

Actions defined in the Reference variables Command group.

Select an existing action from drop down box.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ActionID


ID_SGW_PROP12

Interne ID: ID_SGW_PROP12

Seleccionar variable de respuesta

Mark response variable. To indicate Gateway activity the response variable can be marked with a user defined state bit. This allows a differentiation from HMI user actions.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MarkResponse


ID_SGW_PROP13

Interne ID: ID_SGW_PROP13

Protocolizar acciones bloqueadas

Enables/disables CEL entry for blocking events.

When enabled all actions blocked by the Gateway Module will be logged in the Event list. Actions blocked at Command Group level will be logged according to the Command Groups logging settings.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WriteCEL


ID_SGW_PROP14

Interne ID: ID_SGW_PROP14

Vista previa

Opens the dialog for display of variables which would be linked according to the wildcard rules.
In this dialogue also a traffic light indication (red-yellow-green) will be displayed which informs about the validity of the rules.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Info


ID_SGW_PROP_GRP0

Interne ID: ID_SGW_PROP_GRP0

General

Displays properties for the Gateway.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_SGW_PROP_GRP1

Interne ID: ID_SGW_PROP_GRP1

Entrada

Displays general properties.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Input


ID_SGW_PROP_GRP2

Interne ID: ID_SGW_PROP_GRP2

Salida

Displays input properties.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_OutPut


ID_SGW_PROP_GRP3

Interne ID: ID_SGW_PROP_GRP3

Desencadenador

Displays trigger properties.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TriggerNew1


ID_SGW_PROP_T_DEL

Interne ID: ID_SGW_PROP_T_DEL

{Eliminar desencadenador}

By clicking the selected trigger will be deleted.
This can also be done in the left part of the window using the right mouse button.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CurveDel


ID_SGW_PROP_T_NEU

Interne ID: ID_SGW_PROP_T_NEU

{Desencadenador nuevo}

By clicking a new trigger will be created.
This can also be done in the left part of the window using the right mouse button.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TriggerNew


ID_SIZEINBYTE

Interne ID: ID_SIZEINBYTE

Tamaño en bytes

Mostrar el tamaño completo de la variable de estructura en bytes.
Esta propiedad solo sirve de información y no es modificable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SizeInByte


ID_SPRECON870_COUNTER_NODE

Interne ID: ID_SPRECON870_COUNTER_NODE

Counters

Propiedades para el grupo contador.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_Counters


ID_SPRECON870_COUNTERACTIVE

Interne ID: ID_SPRECON870_COUNTERACTIVE

Counter value handling

Solo disponible si en la configuración de drivers hay un grupo creado.

Aktivado: El driver utilizará el procesamiento contador.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_CounterActive


ID_SPRECON870_COUNTERGROUP

Interne ID: ID_SPRECON870_COUNTERGROUP

Counter group

Solo disponible si la propiedad Counter value handling está activada.

Nombre para identificar el grupo contador como esté configurado en el driver.

El comportamiento de la variable se definirá a través de la asignación de la variable a un grupo contador. El grupo contador representa una clase de matriz de reacción que regula el procesamiento de los valores contadores (p. ej. transformación de valores absolutos a relativos).

Por defecto: < No group >

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_CounterGroupID


ID_SPRECON870_INITVAL

Interne ID: ID_SPRECON870_INITVAL

Initial value

El valor inicial se utilizará solamente si la propiedad Reverse direction only está activada o la dirección de red de la variable remite a una conexión marcada como Internal connection. Para variables del tipo de dato String no se puede establecer ningún valor inicial.
Si se inicia el runtime y no se le ha asignado a la variable ningún valor de la imagen remanente, se escribirán el valor inicial y el estado NT en dicha variable.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_ReverseDirectionInitialValue


ID_SPRECON870_MAXCOUNTDIFF

Interne ID: ID_SPRECON870_MAXCOUNTDIFF

Maximum counter difference

Solo disponible si la propiedad Counter value handling está activada.

Define la diferencia máxima entre dos valores contadores transmitidos. La diferencia máxima se refiere al valor contador regulado (cálculo de valores). Si se excede la diferencia máxima de valores contadores se ejecutará la configuración de la propiedad Max. counter diff. exceeded.

Mínimo: 0 - desactivado, no se supervisará la modificación máxima.

Máximo: 65535

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_MaxCounterDifference


ID_SPRECON870_ONMAXCOUNTDIFF

Interne ID: ID_SPRECON870_ONMAXCOUNTDIFF

Max. counter diff. exceeded

Solo disponible si la propiedad Counter value handling está activada.

Tratamiento de valores contadores (relativos/absolutos), en los que la supervisión corresponde a Maximum counter difference.

Seleccionar de la lista desplegable:

- Disabled

- Set INVALID state: El estado se establecerá y en consecuencia se activará Replacement value handling - siempre que esté configurado -. Este tratamiento se aplicará también al desbordamiento contador de los valores absolutos. Cuando se llegue al estado de error, se establecerá el estado INVALID y se rechazará el valor contador actual. El último valor contador recibido se marcará como inválido. Los cálculos que requieran un valor contador anterior no se podrán ejecutar hasta que se vuelvan a recibir dos valores contadores. El estado INVALID se reseteará en cuanto se reciba un valor contador con una diferencia menor que las configuraciones de la propiedad Replacement value handling.

Por defecto: Disabled

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_OnMaxCounterDifference


ID_SPRECON870_ONNOUPDATE

Interne ID: ID_SPRECON870_ONNOUPDATE

Not updated in time

Solo disponible si la propiedad Counter value handling está activada.

Define el comportamiento si los valores contadores no se actualizan dentro del periodo de tiempo. O bien se activará el tratamiento alternativo (ver más abajo). Selección de la lista desplegable:
- Disabled: Se utilizarán las configuraciones de las propiedades Replacement value handling.

- Set INVALID state: El estado se establecerá como INVALID.

Por defecto: Disabled

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_OnNoUpdate


ID_SPRECON870_REMANENT

Interne ID: ID_SPRECON870_REMANENT

Remanent

Solo disponible si la propiedad Reverse direction enable está activada. El último valor, el sello horario y el estado de la variable se guardarán en la imagen remanente. Después de un reinicio el último valor, el sello horario y el estado de la variable se leerán de la imagen remanente y se asignarán a la variable.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_ReverseDirectionRemanent


ID_SPRECON870_REVDIR_NODE

Interne ID: ID_SPRECON870_REVDIR_NODE

Reverse direction

Propiedades para Reverse direction.

Esta función se invocará para zenon API (con nombre de clase):

SPRECON870_ReverseDirection


ID_SPRECON870_REVDIRENABLED

Interne ID: ID_SPRECON870_REVDIRENABLED

Reverse direction enable

Activación de Reverse-direction.

Activado: Después de una consulta general correspondiente la variable se enviará en Reverse-direction.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_ReverseDirectionEnable


ID_SPRECON870_REVDIRONLY

Interne ID: ID_SPRECON870_REVDIRONLY

Reverse direction only

Solo disponible si la propiedad Reverse direction enable está activada.
Activada. A estas variables no se les asignará nunca un valor recibido del control. Después de iniciar el runtime se les asignará a las variables el valor inicial configurado o un valor de la imagen remanente. Después solo se podrá modificar la variable mediante Establecer valor predeterminado.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_ReverseDirectionOnly


ID_SPRECON870_STRUCT_COA1

Interne ID: ID_SPRECON870_STRUCT_COA1

COA1

Entrada estructurada para COA.

Entrada de Byte 1 para IEC870 COA.

Más en el manual PDF

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_StructuredCOA1


ID_SPRECON870_STRUCT_COA2

Interne ID: ID_SPRECON870_STRUCT_COA2

COA2

Entrada estructurada para COA.

Entrada de Byte 2 para IEC870 COA.

Más en el manual PDF

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_StructuredCOA2


ID_SPRECON870_STRUCT_IOA1

Interne ID: ID_SPRECON870_STRUCT_IOA1

IOA1

Entrada estructurada para IOA.

Entrada de Byte 2 para IEC870 IOA.

Más en el manual PDF

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_StructuredIOA1


ID_SPRECON870_STRUCT_IOA2

Interne ID: ID_SPRECON870_STRUCT_IOA2

IOA2

Entrada estructurada para IOA.

Entrada de Byte 1 para IEC870 IOA.

Más en el manual PDF

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_StructuredIOA2


ID_SPRECON870_STRUCT_IOA3

Interne ID: ID_SPRECON870_STRUCT_IOA3

IOA3

Entrada estructurada para IOA.

Entrada de Byte 0 para IEC870 IOA.

Más en el manual PDF

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_StructuredIOA3


ID_SPRECON870_SUBSTITUTE_NODE

Interne ID: ID_SPRECON870_SUBSTITUTE_NODE

Replacement value handling

Propiedades para el tratamiento de valores alternativos. Las propiedades se utilizarán si en el grupo la propiedad está establecida como. El tratamiento alternativo se aplicará a todas las variables del driver.

Atención: Si se activa el tratamiento alternativo en el driver no se podrá proyectar en zenon ninguna estrategia de valor alternativo para esta variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_ReplacementHandling


ID_SPRECON870_SUBSTVALUETYPE

Interne ID: ID_SPRECON870_SUBSTVALUETYPE

Replacement value handling

Selección del tratamiento alternativo cuando la variable tiene el estado INVALID o NT_870. Seleccionar de la lista desplegable:

- Disabled Nigún tratamiento alternativo.

- Last valid value: Cambia al último valor no alterado. Para ello tiene que haberse guardado una imagen del proceso de este valor. Cuando no haya un valor último no alterado, se utilizará el valor disponible (p. ej. 0 + INVALID).

- Use replacement value: La variable se escribirá con el valor de la propiedad Replacement value.

- Use replacement variable: La variable se escribirá tanto con el valor como con el estado de la variable de la propiedad Replacement variable.
Excepción: Si la variable de valor alternativo no muestra ni el estado INVALID ni el estado NT_870 no se cambiará a esta variable sino que que se mantendrá la variable propia con su valor y estado.
Caso especial estado GI: Dado que durante una Consulta general no tiene que existir todavía un valor alternativo, se puede dar una variable por un corto tiempo como INVALID hasta que se reciba el valor alternativo.

Todas las configuraciones excepto Disabled establecen el bit de estado ALT_VAL. En cuanto desaparezca la causa para el tratamiento alternativo ( INVALID o NT_870 ) la variable volverá a tomar el valor del proceso y el bit de estado ALT_VAL se reseteará.

Por defecto: Disabled

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_ReplacementType


ID_SPRECON870_SUBSTVALUEVAL

Interne ID: ID_SPRECON870_SUBSTVALUEVAL

Replacement value

Valor con el que se escribirá la variable cuando para la propiedad Replacement value handling se haya seleccionado Use replacement value.

Mínimo: 4294967295

Máximo: 0

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_ReplacementValue


ID_SPRECON870_SUBSTVALUEVAR

Interne ID: ID_SPRECON870_SUBSTVALUEVAR

Replacement variable

Variable cuyo valor y estado se aplicará cuando para la propiedad Replacement value handling se haya seleccionado Use replacement value. Todos los cambios de valor de la variable de valor alternativo se representarán en la variable alterada. Haciendo un clic sobre el botón ... se abre el diálogo de selección de variables.

Atención: Como variable solo se puede seleccionar una variable del mismo driver. Si en el diálogo se selecciona la variable de otro driver, el diálogo se cerrará pero no se aplicarán las configuraciones.

Por defecto: vacío.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SPRECON870_ReplacementVariable


ID_STARTATNEWOFFSET

Interne ID: ID_STARTATNEWOFFSET

Cada tipo de dato se inicia con un nuevo offset

Sólo disponible si el direccionamiento automático está activado:
Activado: Cada tipo de dato de la variable de estructura se inicia con un nuevo offset.
Desactivado: Los tipos de dato de la variable de estructura pueden estar también en el mismo offset.
Por defecto: activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsStartAtNewOffset


ID_STRATON_1

Interne ID: ID_STRATON_1

Nombre del proyecto

Nombre del proyecto zenon Logic. Máximo 15 caracteres.

ATENCIÓN: Las modificaciones del nombre del proyecto disolver vínculos con elementos dinámicos.
ATENCIÓN: Esta propiedad no está disponible para el cambio de idioma.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_STRATON_2

Interne ID: ID_STRATON_2

Carpeta de proyecto

Directorio de trabajo del proyecto zenon Logic.

ATENCIÓN: No se puede modificar esta propiedad.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WorkingFolder


ID_STRATON_3

Interne ID: ID_STRATON_3

Host de destino

El runtime host (dirección IP o nombre del ordenador) del sistema de destino zenon Logic para la conexión del entorno de trabajo para p. ej. Depurar online.
Por defecto: localhost.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VMHost


ID_STRATON_4

Interne ID: ID_STRATON_4

Puerto de destino

El puerto runtime del sistema de destino zenon Logic para la conexión del entorno de trabajo. Esta información es para el entorno de trabajo zenon Logic para conectarse al sistema de destino (runtime zenon Logic ) para p. ej. Depurar online
Mínimo: 0
Máximo: 4294967295.
Por defecto: 1200.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VMPort


ID_STRATON_5

Interne ID: ID_STRATON_5

Tipo de inicio

El tipo de inicio define si se inicia y de qué manera el runtime zenon Logic con el runtime del sistema de control.
Iniciar automáticamente: El runtime zenon Logic se inicia con el runtime del sistema de control. Si se finaliza el runtime del sistema de control, el runtime zenon Logic continuará funcionando.
Iniciar/finalizar automáticamente: El runtime zenon Logic se inicia con el runtime del sistema de control. Si se finaliza el runtime del sistema de control, el runtime zenon Logic se finalizará también.
Iniciar manualmente: El inicio o finalización del runtime del sistema de control no afecta para nada al runtime zenon Logic. En este caso hay que iniciar el runtime zenon Logic manualmente (p. ej. con el zenon Logic Runtime Manager).
Por defecto: Iniciar/finalizar automáticamente

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VMStartTyp


ID_STRATON_6

Interne ID: ID_STRATON_6

Punto de inicio

Esta propiedad sólo es relevante para los tipos de inicio del runtime “Iniciar/finalizar automáticamente” e “Iniciar automáticamente”.
Todos los ordenadores: En este modo se iniciará y finalizará el runtime zenon Logic con el runtime del sistema de control en todos los ordenadores que tengan cargado el proyecto del sistema de control (servidor, cliente y servidor standby).
Servidor 1: En este modo se iniciará y finalizará el runtime zenon Logic sólo en un servidor primario. El runtime zenon Logic no se iniciará en las máquinas clientes ni en los servidores standby.
Servidor 1 y servidor 2: En este modo se iniciará y finalizará el runtime zenon Logic sólo en el servidor primario y en el servidor standby. En las máquinas clientes no se iniciará el runtime zenon Logic.
Por defecto: todos los ordenadores

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VMStartArea


ID_Syskron_LDS_FKT_RD

Interne ID: ID_Syskron_LDS_FKT_RD

Syskron_LDS Function Read

Defina aquí la función de acceso para leer. Con un clic sobre el botón se abre un diálogo para elegir la función de acceso. También puede introducir el nombre de la función de acceso manualmente en el campo de texto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Syskron_LDS_FKT_RD


ID_Syskron_LDS_FKT_WR

Interne ID: ID_Syskron_LDS_FKT_WR

Syskron_LDS Function Write

Defina aquí la función de acceso para escribir. Con un clic sobre el botón se abre un diálogo para elegir la función de acceso. También puede introducir el nombre de la función de acceso manualmente en el campo de texto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Syskron_LDS_FKT_WR


ID_Syskron_LDS_PARAM_RD

Interne ID: ID_Syskron_LDS_PARAM_RD

Syskron_LDS Parameters Read

Defina aquí todos los parámetros para la transferencia de funciones. Con un clic sobre el botón se abre un diálogo para introducir todos los parámetros de transmisión de funciones que se transmiten a la función del runtime para leer.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Syskron_LDS_PARAM_RD


ID_Syskron_LDS_PARAM_WR

Interne ID: ID_Syskron_LDS_PARAM_WR

Syskron_LDS Parameters Write

Defina aquí todos los parámetros para la transferencia de funciones. Con un clic sobre el botón se abre un diálogo para introducir todos los parámetros de transmisión de funciones que se transmiten a la función del runtime para escribir. El último parámetro de transferencia será siempre el último valor predeterminado enviado por zenon.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Syskron_LDS_PARAM_WR


ID_SYSVAR_INHALT

Interne ID: ID_SYSVAR_INHALT

Typ

Definición del tipo de variable del sistema. Seleccionar de la lista desplegable.
El contenido sólo se puede modificar cuando no exista todavía ninguna variable con ese nuevo tipo. Por ejemplo: Sólo puede crear una variableServidor actual por proyecto.

Atención: Si modifica el tipo, se modificará también el nombre de la variable y eventualmente el del tipo de dato. Tenga en cuenta que al utilizar las variables en elementos dinámicos se deberá ajustar eventualmente el área de visualización o el nombre de la variable en VBA/VSTA.

Para variables del driver del sistema definidas por el usuario, la lista desplegable estará vacía.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Inhalt


ID_SYSVAR_THEMA

Interne ID: ID_SYSVAR_THEMA

Thema

Grupo lógico de la variable del sistema.

Para variables del driver del sistema definidas por el usuario, la lista desplegable estará vacía.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Thema


ID_TEMPLATE_PROP1

Interne ID: ID_TEMPLATE_PROP1

Nombre:

Nombre unívoco del marco.

  • Máximo: 28 caracteres en el proyecto, 27 caracteres en el proyecto global.

Por defecto: Template_x (x corresponde a un número consecutivo).
Observación: Si se modifica el nombre, habrá que volverlo a introducir, cuando sea necesario, en la propiedad Marcos principales. Sino la variable del driver del sistema Última pantalla abierta no podrá identificar las pantallas basadas en ese marco.
Atención: Esta propiedad no está disponible para el cambio de idioma.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TemplateName


ID_TEMPLATE_PROP2

Interne ID: ID_TEMPLATE_PROP2

Arriba [píxeles]

Coordenadas Y del punto de esquina superior izquierdo del marco en píxeles (partiendo de la resolución de pantalla configurada).
Mínimo: -2147483648
Máximo: 2147483647.
Por defecto: 0.

ATENCIÒN: Le recomendamos que no defina marcos mayores de 32000*32000 píxeles para evitar efectos de ensuciado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PosTop


ID_TEMPLATE_PROP3

Interne ID: ID_TEMPLATE_PROP3

Izquierda [píxeles]

Coordenadas X del punto de esquina superior izquierdo del marco en píxeles (partiendo de la resolución de pantalla configurada).
Mínimo: -2147483648
Máximo: 2147483647.
Por defecto: 0.

ATENCIÒN: Le recomendamos que no defina marcos mayores de 32000*32000 píxeles para evitar efectos de ensuciado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PosLeft


ID_TEMPLATE_PROP4

Interne ID: ID_TEMPLATE_PROP4

Derecha [píxeles]

Coordenadas X del punto de esquina inferior derecho del marco en píxeles (partiendo de la resolución de pantalla configurada).
Mínimo: -2147483648
Máximo: 2147483647.
Por defecto: Máximo de resolución actual de pantalla.

ATENCIÓN: Le recomendamos que no defina marcos mayores de 32000*32000 píxeles para evitar efectos de ensuciado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PosRight


ID_TEMPLATE_PROP5

Interne ID: ID_TEMPLATE_PROP5

Abajo [píxeles]

Coordenadas Y del punto de esquina inferior derecho del marco en píxeles (partiendo de la resolución de pantalla configurada).
Mínimo: -2147483648
Máximo: 2147483647.
Por defecto: Máximo de resolución actual de pantalla.

ATENCIÓN: Le recomendamos que no defina marcos mayores de 32000*32000 píxeles para evitar efectos de ensuciado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PosBottom


ID_TEMPLATE_PROP7

Interne ID: ID_TEMPLATE_PROP7

Color de fondo

Color de fondo propuesto para todas las pantallas nuevas definidas sobre este marco.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackgroundColor


ID_TEMPLATE_PROP8

Interne ID: ID_TEMPLATE_PROP8

Archivo gráfico

Selección del gráfico de fondo como plantilla para todas las pantallas nuevas definidas sobre este marco.
Observación: Una modificación del archivo gráfico no dará lugar a que se modifiquen las pantallas ya existentes basadas en este marco.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackgroundPicture


ID_TEMPLATE_PROP9

Interne ID: ID_TEMPLATE_PROP9

Alineación

Sólo disponible después de haber seleccionado una Archivo gráfico:

Tipos de representación posibles:
En mosaico: tamaño original en mosaicos uno al lado de otro.

Estirado: rellena el formato, ampliado a toda la pantalla.

normal: Tamaño original posicionado en la esquina izquierda superior.
centrado: Tamaño original centrado en la pantalla.

Por defecto: Normal:

No se puede desplazar libremente.

Observación: Una modificación del alineamiento no afectará a las pantallas basadas en el marco.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackgroundPictureStyle


ID_TEMPLATE_PROP10

Interne ID: ID_TEMPLATE_PROP10

Siempre en primer plano

Activado: No hay ninguna otra pantalla que tape este área en el funcionamiento online. Las pantallas en el fondo se podrán seguir manejando.
Desactivado: Las pantallas de este marco podrán ser tapadas por otras pantallas.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowForeground


ID_TEMPLATE_PROP11

Interne ID: ID_TEMPLATE_PROP11

Título

Solo disponible si ha seleccionado un borde para el marco:
Activado: Utilice barras de título Windows para las pantallas de este marco. Las pantallas se pueden desplazar en el runtime.
Desactivado: No utilizar ninguna barra de título.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowTitle


ID_TEMPLATE_PROP12

Interne ID: ID_TEMPLATE_PROP12

Menú del sistema

Sólo disponible cuando el título esté activado:
Activado: Mostrar menú Windows del sistema en la barra de título.
Desactivado: No mostrar ningún menú del sistema.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowSysMenu


ID_TEMPLATE_PROP13

Interne ID: ID_TEMPLATE_PROP13

Botones Mín/Máx

Sólo disponible cuando el título esté activado:
Activado: Mostrar campo de símbolos Windows en la barra de título.
Desactivado: No mostrar ningún campo de símbolos.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowMinimize


ID_TEMPLATE_PROP14

Interne ID: ID_TEMPLATE_PROP14

Tipo de marco

Definición del tipo de borde. El tipo define también si el tamaño del marco es modificable durante el runtime.

  • Ajuste de tamaño posible: El tamaño del marco se puede modificar durante el runtime. Se representará un borde grueso alrededor del marco.
  • Tamaño fijo: El tamaño no puede modificarse. Se representará un borde fino alrededor del marco.
  • Ningún borde: El tamaño no puede modificarse. No se representará ningún borde alrededor del marco.

Por defecto: Ningún borde

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BorderStyle


ID_TEMPLATE_PROP18

Interne ID: ID_TEMPLATE_PROP18

Mostrar en el editor de marcos

Activado: El marco seleccionado se mostrará en el editor de marcos.
Desactivado: El marco seleccionado no se mostrará en el editor de marcos.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VisibleInEditor


ID_TEMPLATE_PROP20

Interne ID: ID_TEMPLATE_PROP20

Utilizar posición estándar

activado: Posiciona el marco para la barra del estado de alarmas en la parte superior de la pantalla.

Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StandardPosition


ID_TEMPLATE_PROP21

Interne ID: ID_TEMPLATE_PROP21

Posicionamiento

Determina la posición del marco y de las pantallas basadas en él durante el runtime.

utilizar la posición absoluta: Posiciona el marco en las coordenadas definidas en Posición.

relativo al elemento: Posiciona el punto de referencia del marco relativo al elemento desde el que se activó el cambio de pantalla. Aquí puede determinar tanto el punto de referencia del marco (en Punto de referencia-marco) como el punto de referencia del elemento (en Punto de referencia-elemento) incluidas las distancias al elemento. En el runtime se establecerá el punto de referencia del marco siempre en el punto de referencia calculado del elemento. Cuando el marco no se pueda abrir en esta posición porque la pantalla quedaría fuera del área de pantalla visible, se utilizarán los puntos de referencia alternativos. Puede configurar estos puntos para el marco en Punto de referencia-marco y para el elemento en Elemento del punto de referencia alternativo.

relativo al ratón: La pantalla se activará independientemente del punto de referencia del marco. Éste corresponde a la posición actual del puntero del ratón. Determinar el punto de referencia en Punto de referencia-marco. En el editor de marcos se representará como un punto rojo. Ejemplo: Si el punto de referencia se encuentra arriba a la izquierda, el marco se activará partiendo del punto de referencia abajo a la derecha.
Si la pantalla no se puede representar completamente en esa posición, la posición se desplazará hasta que la pantalla completa se pueda representar en el monitor.

Por defecto: Utilizar posición absoluta

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PosType


ID_TEMPLATE_PROP22

Interne ID: ID_TEMPLATE_PROP22

Vertical

Sólo se activará cuando seleccione Posicionamiento relativo al elemento o relativo al ratón.

Seleccione de la lista desplegable el punto de referencia deseado para el marco. Elija entre arriba, abajo o centrado.

Por defecto: Arriba

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RefVert


ID_TEMPLATE_PROP23

Interne ID: ID_TEMPLATE_PROP23

Horizontal

Sólo se activará cuando seleccione Posicionamiento relativo al elemento o relativo al ratón.

Seleccione de la lista desplegable el punto de referencia deseado para el marco. Elija entre izquierda, derecha o centrado.

Por defecto: Izquierda

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RefHorz


ID_TEMPLATE_PROP24

Interne ID: ID_TEMPLATE_PROP24

Vertical

Sólo se activará cuando seleccione Posicionamiento relativo al elemento.

Seleccione de la lista desplegable el punto de referencia preferido para el elemento. Al abrir el marco se intentará partir de este punto. Elija entre arriba o abajo.

Por defecto: Arriba

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PosVert


ID_TEMPLATE_PROP25

Interne ID: ID_TEMPLATE_PROP25

Horizontal

Sólo se activará cuando seleccione Posicionamiento relativo al elemento.

Seleccione de la lista desplegable el punto de referencia preferido para el elemento. Al abrir el marco se intentará partir de este punto. Elija entre izquierda o derecha.

Por defecto: Izquierda

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PosHorz


ID_TEMPLATE_PROP26

Interne ID: ID_TEMPLATE_PROP26

Desplazamiento vertical [píxeles]

Sólo se activará cuando seleccione Posicionamiento relativo al elemento.

Introduciendo un valor numérico positivo o negativo, desplazará verticalmente el punto de referencia preferido hasta la posición deseada.

Por defecto: 2

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PixelVert


ID_TEMPLATE_PROP27

Interne ID: ID_TEMPLATE_PROP27

Desplazamiento horizontal [píxeles]

Sólo se activará cuando seleccione Posicionamiento relativo al elemento.

Introduciendo un valor numérico positivo o negativo, desplazará usted horizontalmente el punto de referencia preferido a la posición deseada.

Por defecto: 2

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PixelHorz


ID_TEMPLATE_PROP28

Interne ID: ID_TEMPLATE_PROP28

Vertical alternativo

Sólo se activará cuando seleccione Posicionamiento relativo al elemento.

Seleccione de la lista desplegable el punto de referencia alternativo para el marco. Al abrir el marco se utilizará el punto de referencia alternativo cuando no sea posible abrirlo con el punto de referencia preferido. Elija entre arriba, abajo o centrado.

Por defecto: Arriba

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AltRefVert


ID_TEMPLATE_PROP29

Interne ID: ID_TEMPLATE_PROP29

Horizontal alternativo

Sólo se activará cuando seleccione Posicionamiento relativo al elemento.

Seleccione de la lista desplegable el punto de referencia alternativo para el marco. Al abrir el marco se utilizará el punto de referencia alternativo cuando no sea posible abrirlo con el punto de referencia preferido. Elija entre izquierda, derecha o centrado.

Por defecto: Izquierda

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AltRefHorz


ID_TEMPLATE_PROP30

Interne ID: ID_TEMPLATE_PROP30

Vertical

Sólo se activará cuando seleccione Posicionamiento relativo al elemento.

Seleccione de la lista desplegable el punto de referencia alternativo para el elemento. Al abrir el marco se utilizará el punto de referencia alternativo cuando no sea posible abrirlo con el punto de referencia preferido. Elija entre arriba o abajo.

Por defecto: Arriba

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AltPosVert


ID_TEMPLATE_PROP31

Interne ID: ID_TEMPLATE_PROP31

Horizontal

Sólo se activará cuando seleccione en Posicionamiento relativo al elemento.

Seleccione de la lista desplegable el punto de referencia alternativo para el elemento. Al abrir el marco se utilizará el punto de referencia alternativo cuando no sea posible abrirlo con el punto de referencia preferido. Elija entre izquierda o derecha.

Por defecto: Izquierda

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AltPosHorz


ID_TEMPLATE_PROP32

Interne ID: ID_TEMPLATE_PROP32

Desplazamiento vertical [píxeles]

Sólo se activará cuando seleccione Posicionamiento relativo al elemento.

Introduciendo un valor numérico positivo o negativo, desplazará verticalmente el punto de referencia alternativo hasta la posición deseada.

Por defecto: 2

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AltPixelVert


ID_TEMPLATE_PROP33

Interne ID: ID_TEMPLATE_PROP33

Desplazamiento horizontal [píxeles]

Sólo se activará cuando seleccione Posicionamiento relativo al elemento.

Introduciendo un valor numérico positivo o negativo, desplazará usted horizontalmente el punto de referencia alternativo a la posición deseada.

Por defecto: 2

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AltPixelHorz


ID_TEMPLATE_PROP34

Interne ID: ID_TEMPLATE_PROP34

Cerrar al perder el foco

Controla el comportamiento del marco cuando se pierde el foco.

Activado: Al hacer clic izquierdo fuera del marco éste se cerrará automáticamente, cuando se haga clic en un área de la plantalla que aunque pertenezca al runtime zenon pero no pertenezca ni al marco en cuestión ni a un marco con la propiedad No cerrar al perder el foco configurada.

Por defecto: Desactivado

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CloseOnClickOutside


ID_TEMPLATE_PROP35

Interne ID: ID_TEMPLATE_PROP35

Forma libre de marco

Permite la utilización de las formas libres de plantillas para la plantilla seleccionada. Así es posible definir plantillas con p. ej. esquinas redondeadas, agujeros, etc.

  • Activado: La forma libre de marco se utilizará para este marco y las pantallas vinculadas con él.
  • Desactivado: No hay formas libres de marco disponibles. Una forma libre de marco ya existente no se mostrará en el editor de marcos y pantallas.

Por defecto: Desactivado

Observaciones:

  • No disponible para marcos Barra de estado de alarmas y Windows CE.
  • No se puede combinar con propiedades del grupo Borde.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UseFreeForming


ID_TEMPLATE_PROP36

Interne ID: ID_TEMPLATE_PROP36

Definir forma libre de marco

Sólo disponible si ha activado Forma libre de marco .

Defina la forma para el marco seleccionado. Haga clic izquierdo sobre el botón para abrir el marco correspondiente en el editor de formas de marcos. Allí podrá establecer la forma del marco con ayuda de círculos, rectángulos, rectángulos redondeados y polígonos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DefineFreeForm


ID_TEMPLATE_PROP37

Interne ID: ID_TEMPLATE_PROP37

No cerrar al perder el foco

Activado: Al perder el foco el marco se mantiene abierto. Al perder el foco no se permitirá que se cierre otro marco en caso de que se hiciera clic sobre él. Así se pueden definir áreas de pantalla en las que no se cierren los marcos configurados con Cerrar al perder el foco al hacer clic sobre ellos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IgnoreCloseOnClick


ID_TEMPLATE_PROP38

Interne ID: ID_TEMPLATE_PROP38

Mantener posición y tamaño al volver a abrir

Activado: Un marco que haya sido desplazado manualmente en el runtime, al abrirse una nueva pantalla no se colocará en su posición configurada si ya está abierta en el mismo cliente. Su posición y tamaño se mantienen.

Observación: Esta opción tiene que estar activada para que se guarde la posición del marco antes de recargar y después de recargar el marco se active en la misma posición guardada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NoMoveOnReopen


ID_TEMPLATE_PROP39

Interne ID: ID_TEMPLATE_PROP39

Anchura (máximo) [píxeles]

Define la anchura máxima del marco en píxeles partiendo del punto de anclaje izquierdo.

  • Máximo: 10000
    No existe con CE

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PosWidth


ID_TEMPLATE_PROP40

Interne ID: ID_TEMPLATE_PROP40

Altura (máximo) [píxeles]

Define la altura máxima del marco en píxeles partiendo del punto de anclaje superior.

  • Máximo: 10000
    No existe con CE

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PosHeight


ID_TEMPLATE_PROP41

Interne ID: ID_TEMPLATE_PROP41

El marco se puede activar varias veces

Activado: El marco se puede activar varias veces durante el runtime. Las pantallas basadas en este marco que se invoquen se activarán con un marco nuevo en lugar de con el mismo. Si se trata de la misma pantalla se volverá a activar otra vez dicha pantalla.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OpenMultiple


ID_TEMPLATE_PROP_GRP0

Interne ID: ID_TEMPLATE_PROP_GRP0

General

Propiedades generales para el marco.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_TEMPLATE_PROP_GRP1

Interne ID: ID_TEMPLATE_PROP_GRP1

Borde

Propiedades para el borde del marco.

No estarán disponibles si la propiedad Forma libre de marco está activada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Frame


ID_TEMPLATE_PROP_GRP2

Interne ID: ID_TEMPLATE_PROP_GRP2

Posición

Propiedades para la posición y el tamaño del marco.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Position


ID_TEMPLATE_PROP_GRP3

Interne ID: ID_TEMPLATE_PROP_GRP3

Gráfico de fondo

En todas las pantallas se puede mostrar un archivo gráfico como fondo. Se asignarán automáticamente gráficos de fondo para marcos para todas las pantallas nuevas que se basen en esos marcos. Las pantallas ya existentes deben ajustarse después manualmente.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_BackgroundPicture


ID_TEMPLATE_PROP_GRP4

Interne ID: ID_TEMPLATE_PROP_GRP4

Punto de referencia-marco

Defina aquí el punto de referencia del marco. Interdependientemente el marco se activará en el runtime cuando en Posicionamiento haya seleccionado relativo al ratón o relativo al elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_TemplateReference


ID_TEMPLATE_PROP_GRP5

Interne ID: ID_TEMPLATE_PROP_GRP5

Punto de referencia-elemento

Sólo se activará cuando seleccione Posicionamiento relativo al elemento.

Defina aquí el punto de referencia al elemento. Dependiendo de ello se activará el marco. Si el punto de referencia es por ejemplo izquierda/centrado con 0 pixel de distancia, el punto de referencia del marco se posicionará exactamente en ese punto de referencia al lado izquierdo en el centro del elemento. El punto de referencia del marco se establece en Punto de referencia-marco.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_PrimaryReference


ID_TEMPLATE_PROP_GRP6

Interne ID: ID_TEMPLATE_PROP_GRP6

Elemento del punto de referencia alternativo

Sólo se activará cuando seleccione Posicionamiento relativo al elemento.

Defina aquí el punto de referencia alternativo al elemento. Sólo será efectivo cuando el marco no se pueda activar en el área de representación de la pantalla. Se recomienda utilizar siempre la configuración opuesta al punto de referencia regular (configurado en Punto de referencia-elemento). Ejemplo: Si el punto de referencia es derecha/centrado, el punto de referencia alternativo debería ser izquierda/centrado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_AlternativeReference


ID_TEMPLATE_PROP_GRP7

Interne ID: ID_TEMPLATE_PROP_GRP7

Forma libre de marco

Propiedades para la forma libre de los marcos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_FreeTemplateShape


ID_TEMPLOGIN

Interne ID: ID_TEMPLOGIN

Login temporal activado

Activación del login temporal para usuarios que deseen usar un elemento pero no estén registrados:

  • Activado: A los usuarios que necesiten una autorización de uso se les pedirá su identificación y contraseña. Para ello se abrirá - según la configuración - una pantalla de tipo Login un diálogo modal. Después de la operación se deslogeará automáticamente al usuario.
  • Desactivado: A los usuarios que necesiten autorización de uso se les informará de que no están autorizados para dicha operación.

Por defecto: activado

Observaciones:

  • La posición y el tamaño de la máscara de registro se pueden definir en zenon6.ini bajo [Comando] Posición =.
  • En lugar del diálogo modal se puede utilizar la pantalla del tipo Login. Ésta se definirá con la propiedad Pantalla para login con firma.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TempLogin


ID_TIMEFILTER_MODIFYTIMEPERIOD

Interne ID: ID_TIMEFILTER_MODIFYTIMEPERIOD

ModifyTimePeriod

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ModifyTimePeriod


ID_TOPOLOGIE_PROP1

Interne ID: ID_TOPOLOGIE_PROP1

Línea discontinua 1

Línea discontinua 1

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BrokenLine1


ID_TOPOLOGIE_PROP2

Interne ID: ID_TOPOLOGIE_PROP2

Línea discontinua 2

Línea discontinua 2

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BrokenLine2


ID_TOPOLOGIE_PROP3

Interne ID: ID_TOPOLOGIE_PROP3

Ancho de línea

Ancho de línea

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LineWidth


ID_TOPOLOGIE_PROP4

Interne ID: ID_TOPOLOGIE_PROP4

Nombre de objeto como vínculo

Nombre de objeto como vínculo

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OBJNameLink


ID_TOPOLOGIE_PROP5

Interne ID: ID_TOPOLOGIE_PROP5

Modo de visualización

Modo de visualización

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DisplayMode


ID_TOPOLOGIE_PROP6

Interne ID: ID_TOPOLOGIE_PROP6

Ancho de línea asegurado

Ancho de línea asegurado

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LineWidthFGES


ID_TOPOLOGIE_PROP7

Interne ID: ID_TOPOLOGIE_PROP7

Ancho del borde

Ancho del borde

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SaumWidth


ID_TOPOLOGIE_PROP8

Interne ID: ID_TOPOLOGIE_PROP8

Símbolo F1

Símbolo F1

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SymbolF1


ID_TOPOLOGIE_PROP9

Interne ID: ID_TOPOLOGIE_PROP9

Símbolo F2

Símbolo F2

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SymbolF2


ID_TOPOLOGIE_PROP10

Interne ID: ID_TOPOLOGIE_PROP10

Símbolo FGES

Símbolo FGES

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SymbolFGES


ID_TOPOLOGIE_PROP11

Interne ID: ID_TOPOLOGIE_PROP11

Borde del símbolo

Borde del símbolo

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SymbolSaum


ID_TOPOLOGIE_PROP12

Interne ID: ID_TOPOLOGIE_PROP12

Símbolo F1 colores

Símbolo F1 colores

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SymbolF1_Mode


ID_TOPOLOGIE_PROP13

Interne ID: ID_TOPOLOGIE_PROP13

Símbolo F2 colores

Símbolo F2 colores

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SymbolF2_Mode


ID_TOPOLOGIE_PROP14

Interne ID: ID_TOPOLOGIE_PROP14

Símbolo FGES Colores

Símbolo colores FGES

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SymbolFGES_Mode


ID_TOPOLOGIE_PROP15

Interne ID: ID_TOPOLOGIE_PROP15

Color borde del símbolo

Colores borde del símbolo

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SymbolSaum_Mode


ID_TOPOLOGIE_PROP16

Interne ID: ID_TOPOLOGIE_PROP16

Variable SS_1_1

Variable SS_1_1

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variable_SS_1_1


ID_TOPOLOGIE_PROP17

Interne ID: ID_TOPOLOGIE_PROP17

Variable SS_1_2

Variable SS_1_2

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variable_SS_1_2


ID_TOPOLOGIE_PROP18

Interne ID: ID_TOPOLOGIE_PROP18

Variable SS_1_3

Variable SS_1_3

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variable_SS_1_3


ID_TOPOLOGIE_PROP19

Interne ID: ID_TOPOLOGIE_PROP19

Variable SS_1_4

Variable SS_1_4

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variable_SS_1_4


ID_TOPOLOGIE_PROP20

Interne ID: ID_TOPOLOGIE_PROP20

Variable inicio1

Variable inicio1

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variable_Start1


ID_TOPOLOGIE_PROP21

Interne ID: ID_TOPOLOGIE_PROP21

Punto de división de la variable estándar

Punto de división estándar de la variable

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VariableStandardIsolatingPoint


ID_TOPOLOGIE_PROP22

Interne ID: ID_TOPOLOGIE_PROP22

Variable inicio2

Variable inicio 2

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variable_Start2


ID_TOPOLOGIE_PROP23

Interne ID: ID_TOPOLOGIE_PROP23

Variable SS_2_1

Variable SS_2_1

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variable_SS_2_1


ID_TOPOLOGIE_PROP24

Interne ID: ID_TOPOLOGIE_PROP24

Variable SS_2_2

Variable SS_2_2

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variable_SS_2_2


ID_TOPOLOGIE_PROP25

Interne ID: ID_TOPOLOGIE_PROP25

Variable SS_2_3

Variable SS_2_3

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variable_SS_2_3


ID_TOPOLOGIE_PROP26

Interne ID: ID_TOPOLOGIE_PROP26

Variable SS_2_4

Variable SS_2_4

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variable_SS_2_4


ID_TOPOLOGIE_PROP27

Interne ID: ID_TOPOLOGIE_PROP27

Caracteres en otro lugar por separado

Caracter separado en otro lugar

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DistributionLineCharacter


ID_TOPOLOGIE_PROP31

Interne ID: ID_TOPOLOGIE_PROP31

Reactancia

Reactancia en ohmios para detectar la posición errónea.
Sólo en conexión con la opción lugar del fallo y topología.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Reactance


ID_TOPOLOGIE_PROP_GRP1

Interne ID: ID_TOPOLOGIE_PROP_GRP1

Topología

Elemento\\Topología

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Topology


ID_TOPOLOGIE_PROP_GRP2

Interne ID: ID_TOPOLOGIE_PROP_GRP2

Coloreado

Elemento\\Topología\\Control de símbolos

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TopColors


ID_TOPOLOGIE_PROP_GRP3

Interne ID: ID_TOPOLOGIE_PROP_GRP3

Línea de distribución

Elemento\\Topología\\Cadena

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Strang


ID_TOPOLOGIE_PROP_GRP4

Interne ID: ID_TOPOLOGIE_PROP_GRP4

Cálculos de red

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NetCalc


ID_TOPOLOGIE_PROP_GRP5

Interne ID: ID_TOPOLOGIE_PROP_GRP5

Cable

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NetCalcCable


ID_TREIBER_CONFIG

Interne ID: ID_TREIBER_CONFIG

Configuración

Abre el diálogo de configuración para el driver.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Configuration


ID_TREIBER_FILE

Interne ID: ID_TREIBER_FILE

Nombre de archivo

Nombre de archivo del driver.
El archivo se encuentra en el directorio del programa del sistema de control.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NameFile


ID_TREIBER_GRP0

Interne ID: ID_TREIBER_GRP0

General

Propiedades generales para el driver.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_TREIBER_NAME

Interne ID: ID_TREIBER_NAME

Descripción

Nombre unívoco del driver.
zenon identifica el driver a través de este nombre y no a través del nombre del archivo. Así se puede cargar el mismo driver varias veces. Es necesario p. ej. en drivers seriales cuando tienen que acceder con el mismo tipo de control a diferentes interfaces seriales.
Atención: Esta propiedad no está disponible para el cambio de idioma.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_TREIBER_PROP6

Interne ID: ID_TREIBER_PROP6

Descripción

Descripción del driver.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Description


ID_TREIBER_PROP_GRP0

Interne ID: ID_TREIBER_PROP_GRP0

Direccionamiento

Propiedades generales para el driver.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Address


ID_TREIBER_PROP_GRP1

Interne ID: ID_TREIBER_PROP_GRP1

Conexión de driver

Refleja la configuración de la conexión con el tipo de dato IEC, la prioridad y standby.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Driver


ID_TREIBER_PROP_GRP2

Interne ID: ID_TREIBER_PROP_GRP2

Configuraciones array

Propiedades para la estructura de variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Structure


ID_TREIBER_PROP_GRP3

Interne ID: ID_TREIBER_PROP_GRP3

Opciones de estructura

Opciones para elementos de estructura.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_StructureOpts


ID_TREIBER_PROP_GRP4

Interne ID: ID_TREIBER_PROP_GRP4

Opciones de direccionamiento

Opciones para el direccionamiento de variables array.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_AddressOpts


ID_TREND_DEL

Interne ID: ID_TREND_DEL

{Eliminar curva}

La curva se eliminará.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CurveDel


ID_TREND_NEU

Interne ID: ID_TREND_NEU

{Nueva curva}

Se creará una nueva curva para el elemento de tendencia.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CurveNew


ID_TYPE_GW_NEW

Interne ID: ID_TYPE_GW_NEW

{Valor límite nuevo}

Se creará un nuevo valor límite para el tipo de dato.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NewLimit


ID_UEBER_HELLIGKEIT

Interne ID: ID_UEBER_HELLIGKEIT

Con valores de luminosidad

Sólo disponible si como Estampado de relleno se ha seleccionado Sobre gradiente de color .

Activado: La luminosidad del gradiente de color se puede definir libremente.
Desactivado: La luminosidad del gradiente de color se establecerá automáticamente.

Observación: Si está propiedad está activada no se podrá volver a modificar el estampado del relleno. Tampoco se podrán configurar esquinas redondeadas. Si se activa la opción para un elemento que utiliza esquinas redondeadas, el elemento no se representará con las esquinas redondeadas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Brightness


ID_UNIT_PROP_DECSHIFT

Interne ID: ID_UNIT_PROP_DECSHIFT

Desplazamiento de la coma

Corrección de cifras tras la coma. Este valor determina el desplazamiento de la cantidad de cifras tras la coma en la unidad de conversión frente a la unidad base.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DecShift


ID_UNIT_PROP_FACTOR

Interne ID: ID_UNIT_PROP_FACTOR

Factor

Entrada del factor de conversión con el que se convierte el valor de la unidad base en el valor de la unidad de conversión (k para y=kx+d o m para y=mx+b).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Factor


ID_UNIT_PROP_GRP0

Interne ID: ID_UNIT_PROP_GRP0

General

Propiedades para la conversión de unidades.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_UNIT_PROP_NAME

Interne ID: ID_UNIT_PROP_NAME

Unidad

Entrada de la unidad base desde la que se convierte o de la unidad de conversión a la que se convierte. Por ejemplo C°, K, m, y, celsius, kelvin, metros, yardas etc.

La entrada está limitada a 50 caracteres.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_UNIT_PROP_OFFSET

Interne ID: ID_UNIT_PROP_OFFSET

Offset

de una unidad primaria (d para y=kx+d)

Entrada del offset de conversión con el que se convierte el valor de la unidad base en el valor de la unidad de conversión (k para y=kx+d o m para y=mx+b).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Offset


ID_USER_ACTIVE

Interne ID: ID_USER_ACTIVE

Usuario activado

Activado: Se aceptará al usuario en el runtime.
Desactivado: No se aceptará al usuario en el runtime
Por defecto: activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserActive


ID_USER_GROUPS

Interne ID: ID_USER_GROUPS

Grupos de usuarios

Todos los grupos de usuarios asignados al usuario seleccionado.

Haga clic sobre el botón para añadir o eliminar grupos de usuarios.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserGroups


ID_USER_GRP

Interne ID: ID_USER_GRP

Usuario

Propiedades para el usuario.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_USER_LOCKCODE

Interne ID: ID_USER_LOCKCODE

Código de bloqueo

Código PIN de 4 cifras.

Este código se utiliza por el usuario para bloquear o desbloquear las distintas áreas. El bloqueo con este código impide que se produzca una desbloqueo involuntario que pueda causar accidentes.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LockCode


ID_USER_LOCKED

Interne ID: ID_USER_LOCKED

Bloqueado

Activado: El usuario está bloqueado.
Desactivado: El usuario no está bloqueado.
Por defecto: desactivado.

Después de un número definido de entradas inválidas de la contraseña se bloqueará automáticamente al usuario. Aquí se puede quitar el bloqueo.
En el runtime solo un administrador puede desbloquear a un usuario, ya que solo un administrador puede editar usuarios.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserLocked


ID_USER_MSGCTRL_EMAIL

Interne ID: ID_USER_MSGCTRL_EMAIL

E-mail

Dirección de e-mail del usuario.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MsgEmail


ID_USER_MSGCTRL_ERSATZUSER

Interne ID: ID_USER_MSGCTRL_ERSATZUSER

Sustituto

Persona sustituta en caso de que no se localice al usuario. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un usuario.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MsgErsatzUser


ID_USER_MSGCTRL_GSM

Interne ID: ID_USER_MSGCTRL_GSM

GSM

Número de teléfono móvil del usuario. Se utilizará para GSM y SMS.

Entrada en cifras, se permite el carácter + como abreviación para 00 antes de los prefijos internacionales.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MsgGSM


ID_USER_MSGCTRL_NACKCODE

Interne ID: ID_USER_MSGCTRL_NACKCODE

Código NA

Not-Available-Code, con el que el usuario puede rechazar la recepción del mensaje.

Observación: Este código se deberá diferenciar claramente del código de la propiedad Código PIN.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MsgNACKCode


ID_USER_MSGCTRL_PHONE

Interne ID: ID_USER_MSGCTRL_PHONE

Teléfono

Número de teléfono fijo del usuario. Se utilizará para conversión de voz en texto.

Entrada en cifras, se permite el carácter + como abreviación para 00 antes de los prefijos internacionales.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MsgPhone


ID_USER_MSGCTRL_PINCODE

Interne ID: ID_USER_MSGCTRL_PINCODE

Código PIN

Código PIN con el que el usuario confirma la recepción del mensaje.

Observación: Este código se deberá diferenciar claramente del código de la propiedad Código NA.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MsgPinCode


ID_USER_MSGCTRL_USER

Interne ID: ID_USER_MSGCTRL_USER

Usuario del Message Control

Activado: El usuario es utilizado por Message Control.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsMsgCtrlUser


ID_USERGROUP_GRP

Interne ID: ID_USERGROUP_GRP

Grupo de usuarios

Propiedades para los grupos de usuarios.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_USERGROUP_LEVEL

Interne ID: ID_USERGROUP_LEVEL

Niveles de autorización

Todos los niveles de autorización asignados al grupo de usuarios seleccionado.

Haga clic sobre el botón para añadir o eliminar niveles de autorización.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserGroupLevel


ID_USERGROUP_NAME

Interne ID: ID_USERGROUP_NAME

Nombre:

Nombre del grupo de usuarios seleccionado.

Haga clic en el campo de entrada para cambiar el nombre.

Observación: La arroba @ no es un carácter válido para el nombre de un grupo de usuarios.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserGroupName


ID_USERGRP_MSGCTRL_ISMSGCTRL

Interne ID: ID_USERGRP_MSGCTRL_ISMSGCTRL

Grupo Message Control

Activado: El grupo de usuarios es utilizado por Message Control.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsMsgCtrlGroup


ID_USERGRP_MSGCTRL_USERORDER

Interne ID: ID_USERGRP_MSGCTRL_USERORDER

Orden de los usuarios

Establece el orden de los usuarios en el grupo. Haciendo clic sobre el botón ... se abre un diálogo para configurar el orden.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserGroupOrder


ID_USERKENNUNG

Interne ID: ID_USERKENNUNG

Nombre de usuario

Identificación unívoca con la que se tiene que registrar el usuario.
En diversas acciones del usuario se puede mostrar esta secuencia en la lista cronológica de eventos (CEL). En la lista CEL hay una columna específica para mostrar esta información. Adicionalmente se puede mostrar esta información con ayuda de una variable del driver del sistema.
Máximo: 20 caracteres.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserIdentification


ID_USERNAME

Interne ID: ID_USERNAME

Nombre completo

Nombre del usuario.
En diversas acciones de usuario se podrá mostrar este orden de caracteres en la lista cronológica de eventos (CEL). Debería ser el nombre completo del usuario. En la lista CEL hay una columna específica para mostrar esta información. Adicionalmente se puede mostrar esta información con ayuda de una variable del driver del sistema.
Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserName


ID_USERPASSWORD

Interne ID: ID_USERPASSWORD

Contraseña

Abre la caja de diálogo para cambiar la contraseña.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserPassword


ID_VAR_AKS_GRP1

Interne ID: ID_VAR_AKS_GRP1

AKS-General

Los puntos de datos del driver AK se parametrizan con el OPM.

Encontrará más información sobre la parametrización en la ayuda de SICAM230 y en la ayuda de TOOLBOX II.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AKS-General


ID_VAR_AKS_GRP1_ENG

Interne ID: ID_VAR_AKS_GRP1_ENG

AKS-General

Datapoints will be engineered by OPM.

Further information available in SICAM230 help and in TOOLBOX II help.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AKS-General


ID_VAR_AKS_GRP2

Interne ID: ID_VAR_AKS_GRP2

AKS-Extended

Los puntos de datos del driver AK se parametrizan con el OPM.

Encontrará más información sobre la parametrización en la ayuda de SICAM230 y en la ayuda de TOOLBOX II.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AKS-Extended


ID_VAR_AKS_GRP2_ENG

Interne ID: ID_VAR_AKS_GRP2_ENG

AKS-Extended

Datapoints will be engineered by OPM.

Further information available in SICAM230 help and in TOOLBOX II help.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AKS-Extended


ID_VAR_AKS_GRP3

Interne ID: ID_VAR_AKS_GRP3

Redundanz

Los puntos de datos del driver AK se parametrizan con el OPM.

Encontrará más información sobre la parametrización en la ayuda de SICAM230 y en la ayuda de TOOLBOX II.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Redundancy


ID_VAR_AKS_GRP3_ENG

Interne ID: ID_VAR_AKS_GRP3_ENG

Redundancy

Datapoints will be engineered by OPM.

Further information available in SICAM230 help and in TOOLBOX II help.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Redundancy


ID_VAR_AKS_GRP4

Interne ID: ID_VAR_AKS_GRP4

Befehle

Los puntos de datos del driver AK se parametrizan con el OPM.

Encontrará más información sobre la parametrización en la ayuda de SICAM230 y en la ayuda de TOOLBOX II.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Command


ID_VAR_AKS_GRP4_ENG

Interne ID: ID_VAR_AKS_GRP4_ENG

Command

Datapoints will be engineered by OPM.

Further information available in SICAM230 help and in TOOLBOX II help.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Command


ID_VAR_ALARMBEREICH

Interne ID: ID_VAR_ALARMBEREICH

Alarmbereiche

Aquí se puede vincular la variable a un área de alarmas.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmDomain


ID_VAR_ALARMBEREICH1

Interne ID: ID_VAR_ALARMBEREICH1

Área de alarmas 1

Primera área de alarmas al que se asignarán las variables. Seleccionar de la lista desplegable.

Más en la Ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmDomain


ID_VAR_ALARMBEREICH2

Interne ID: ID_VAR_ALARMBEREICH2

Área de alarmas 2

Segunda área de alarmas al que se asignarán las variables. Seleccionar de la lista desplegable.

Más en la Ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmDomain2


ID_VAR_ALARMBEREICH3

Interne ID: ID_VAR_ALARMBEREICH3

Área de alarmas 3

Tercera área de alarmas al que se asignarán las variables. Seleccionar de la lista desplegable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmDomain3


ID_VAR_ALARMBEREICH4

Interne ID: ID_VAR_ALARMBEREICH4

Área de alarmas 4

Cuarta área de alarmas al que se asignarán las variables. Seleccionar de la lista desplegable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmDomain4


ID_VAR_ALARMKANAL0

Interne ID: ID_VAR_ALARMKANAL0

Variable de alarma 1

Sólo disponible en SICAM 230.
Primera variable para de alarma de pantalla.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmPV0


ID_VAR_ALARMKANAL1

Interne ID: ID_VAR_ALARMKANAL1

Variable de alarma 2

Sólo disponible en SICAM 230.
Segunda variable para la alarma de pantalla.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmPV1


ID_VAR_ALARMKANAL2

Interne ID: ID_VAR_ALARMKANAL2

Variable de alarma 3

Sólo disponible en SICAM 230:
Tercera variable para la alarma de pantalla.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmPV2


ID_VAR_ALARMQUIT

Interne ID: ID_VAR_ALARMQUIT

Variable de reconocimiento

Cuando se reconoce una alarma de las variables de control, el valor de las variables reconocidas pasará a ser el valor definido en Valor de reconocimiento.

Haciendo clic sobre el botón ... se abre un diálogo para seleccionar una variable binaria.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmQuitPV


ID_VAR_ALARMQUIT_VALUE

Interne ID: ID_VAR_ALARMQUIT_VALUE

Valor de reconocimiento

Cuando se reconoce normal o visualmente una alarma de esta variable, la variable seleccionada en Variable de reconocimiento visual o Variable de reconocimiento tomará este valor.

Selección 0 o 1.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmQuitPVValue


ID_VAR_ALARMVIEWQUIT

Interne ID: ID_VAR_ALARMVIEWQUIT

Variable de reconocimiento visual

Cuando se reconoce visualmente una alarma de las variables de control, el valor de estas variables reconocidas visualmente pasará a ser el valor definido en Valor de reconocimiento.

Haciendo clic sobre el botón ... se abre un diálogo para seleccionar una variable binaria.

Más en la Ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmViewQuitPV


ID_VAR_ARCHHYSTNEG

Interne ID: ID_VAR_ARCHHYSTNEG

Negativo para el archivo

Histéresis para el almacenamiento de cambios de valor referidos al rango de medición.

Área de histéresis para la entrada de cambios de valores decrecientes. Los valores solo se almacenarán en el archivo cuando el cambio se encuentre por debajo del área de histéresis configurada aquí.
Por defecto: 0 (ninguna histéresis)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ArchHystNeg


ID_VAR_ARCHHYSTPOS

Interne ID: ID_VAR_ARCHHYSTPOS

Positivo para el archivo

Histéresis para el almacenamiento de cambios de valor referidos al rango de medición.

Área de histéresis para la entrada de cambios de valores crecientes. Los valores solo se almacenarán en el archivo cuando el cambio se encuentre por encima del área de histéresis configurada aquí.
Por defecto: 0 (ninguna histéresis)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ArchHystPos


ID_VAR_ARRAYSIZE

Interne ID: ID_VAR_ARRAYSIZE

Tamaño del bloqueo array

Definición del tamaño del bloque array. El driver lee o escribe el tamaño configurado con una petición de lectura o escritura. De esta manera se garantiza que los datos sean consistentes. Los datos son únicamente procesables en el administrador de grupos de recetas y mediante la interfaz de programación.
Atención: Configurable en el Driver interno pero sin función durante el runtime (valor siempre 0).

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ArraySizeOld


ID_VAR_ARRDIM1

Interne ID: ID_VAR_ARRDIM1

Dim 1

Tamaño de la primera dimensión del array.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Dim1


ID_VAR_ARRDIM2

Interne ID: ID_VAR_ARRDIM2

Dim 2

Tamaño de la segunda dimensión del array.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Dim2


ID_VAR_ARRDIM3

Interne ID: ID_VAR_ARRDIM3

Dim 3

Tamaño de la tercera dimensión del array.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Dim3


ID_VAR_AUSRICHTUNG

Interne ID: ID_VAR_AUSRICHTUNG

Alineación

La posición de la variable dentro del offset definido depende de la granularidad del driver.

Para variables byte:
HiByte: Byte superior en offset de palabra.
LoByte: Byte inferior en offset de palabra.
HiWord-HiByte Byte superior en palabra superior en offset de palabra doble.
HiWord-LoByte: Byte inferior en palabra superior en offset de palabra doble.
LoWord-HiByte: Byte superior en palabra inferior en offset de palabra doble.
LoWord-LoByte: Byte inferior en palabra inferior en offset de palabra doble.

Para variables de palabra:
HiWord: Palabra superior en offset de palabra doble.
LoWord: Palabra inferior en offset de palabra doble.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Alignment


ID_VAR_BASETYPE

Interne ID: ID_VAR_BASETYPE

Tipo de dato IEC

Tipo de dato subyacente.

ATENCIÓN: Si se modifica el tipo de dato subyacente con posterioridad se tendrán que comprobar y ajustar todas las demás propiedades del tipo de dato.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ID_DataTyp


ID_VAR_BEZEICHNUNG

Interne ID: ID_VAR_BEZEICHNUNG

General

Propiedades generales de la variable o el tipo de dato.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Title


ID_VAR_BIT

Interne ID: ID_VAR_BIT

Número de bit

Número del bit dentro del offset configurado.
Mínimo: 0
Máximo: 65535.
Por defecto: 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BitAddr


ID_VAR_BMKENNUNG

Interne ID: ID_VAR_BMKENNUNG

Identificación del equipo

Cualquier cadena.
No se utiliza en zenon de forma interna, pero está disponible para la exportación de valores para permitir la asignación de los valores exportados en sistemas de administración (p. ej. ERP).

Longitud máxima: 255 caracter

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Recourceslabel


ID_VAR_CANCEL_OPERATE

Interne ID: ID_VAR_CANCEL_OPERATE

Cancelar Operate

Si está activado con un comando se puede enviar también después de un Operate un Cancel .

Observación: Esta propiedad solo está disponible en Energy Edition.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CancelOperate


ID_VAR_CPLX_OFFSET

Interne ID: ID_VAR_CPLX_OFFSET

Iniciar offset

Offset de inicio para la variable de estructura.
En este offset se empezará con el direccionamiento de las variables contenidas.
Mínimo: 0
Máximo: 4294967295.
Por defecto: 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Offset


ID_VAR_DB

Interne ID: ID_VAR_DB

Bloque de datos

Número del bloque de datos.
Mínimo: 0
Máximo: 4294967295.
Por defecto: 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DataBlock


ID_VAR_DDEAKTIV

Interne ID: ID_VAR_DDEAKTIV

Lectura continua de variable

  • Activado: La variable está registrada siempre en el driver. Así se leerá continuamente por el driver aunque no se necesite en el proceso en ese momento. El driver tendrá así siempre disponibles los valores actuales y el estado actual de las variables y los podrá proporcionar inmediatamente cuando sea necesario. La variable está también disponible para otras aplicaciones Windows (p. ej. Excel, Visual Basic, etc.). Las aplicaciones Windows con funcionalidad cliente DDE pueden utilizar así los valores de las variables. Tiempo de actualización: 0,5 s
    La activación de esta opción aporta la ventaja de que, por ejemplo, la basculación entre los valores de variables en la función Escribir valor predeterminado o en el elemento de de pantalla interruptor se ejecutará más rápidamente por que no hay que consultar a la variable antes de conmutar. La desventaja es que habrá una mayor carga de la comunicación con el control.
  • Desactivado: La variable no se consultará continuamente por el driver sino solo cuando el runtime requiera valores o estados. No estará disponible para otras aplicaciones Windows con DDE.

Por defecto: Desactivado

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DDEActive


ID_VAR_DESC

Interne ID: ID_VAR_DESC

Descripción

Descripción del tipo de dato.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Description


ID_VAR_EINHEIT

Interne ID: ID_VAR_EINHEIT

Unidad

Unidad técnica de la variable para la representación en el runtime. Si en el nodo Unidades de medida se han creado Unidades base, estarán disponibles para su selección en una lista desplegable.
Máximo: 50 caracteres
Por defecto: vacío

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Unit


ID_VAR_ERSATZ

Interne ID: ID_VAR_ERSATZ

Archivfüllwert

Este valor se utilizará para rellenar los archivos cíclicos. Cuando haya intervalos de tiempo en los que no hubiera conexión al hardware, se utilizará este valor mientras el hardware no transmita otro. En otro caso se utilizará el último valor válido para rellenar.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlternateValue


ID_VAR_EXTERN

Interne ID: ID_VAR_EXTERN

Configuraciones externas

Propiedades externas para zenon Logic. Sólo afecta a variables que no sean del driver straton.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_External


ID_VAR_GW_AKTIV

Interne ID: ID_VAR_GW_AKTIV

Valor límite activado

Activado: El límite se tendrá en cuenta en el runtime.
Desactivado: El límite se ignorará en el runtime.
Por defecto: activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Active


ID_VAR_GW_ALARM

Interne ID: ID_VAR_GW_ALARM

En la lista de mensajes de alarma

Activado: Si se viola un límite se creará una entrada en la lista de mensajes de alarma.
Desactivado:: No se creará ninguna entrada en la lista de mensajes de alarma.
Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Alarm


ID_VAR_GW_ALARMVERW

Interne ID: ID_VAR_GW_ALARMVERW

Invocación a través del botón en la pantalla de lista de mensajes de alarma

Sólo disponible cuando el límite sea una alarma:

  • Activado: La función vinculada no se ejecutará espontáneamente durante el funcionamiento online sino solo cuando se pulse el botón "Función" en la lista de alarmas.
  • Desactivado: La función se ejecutará espontáneamente en cuanto salte la alarma.

Por defecto: desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AML_Call


ID_VAR_GW_AMLCEL

Interne ID: ID_VAR_GW_AMLCEL

AML/CEL

Propiedades para la lista cronológica de eventos (CEL) y la lista de alarmas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_AML_CEL


ID_VAR_GW_BLINKEN

Interne ID: ID_VAR_GW_BLINKEN

Parpadeo

Activado: Los elementos dinámicos vinculados a esta variable empezarán a parpadear en cuanto se exceda este valor límite.
El parpadeo se puede reconocer haciendo doble clic derecho.
Desactivado: Este límite no producirá ningún parpadeo.
Por defecto: desactivado.
Atención: En combinación con la propiedad Tiempo de retraso [s] esta propiedad repercute en la red de la siguiente manera:
Valor límite con parpadeo y sin retraso: Los elementos vinculados parpadean en el servidor y en los clientes.
Valor límite con parpadeo y retraso: Los elementos vinculados parpadean en el servidor pero no en las máquinas clientes.
Alarma con parpadeo y sin retraso: Los elementos vinculados parpadean en el servidor y en los clientes.
Alarma con parpadeo y retraso: Los elementos vinculados parpadean en el servidor y en las máquinas clientes.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Blinking


ID_VAR_GW_CEL

Interne ID: ID_VAR_GW_CEL

En la lista cronológica de eventos

Activado: En caso de violación de un límite se creará una entrada en la lista cronológica de eventos (CEL).
Desactivado: No se creará una entrada en la lista cronológica de eventos.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Cel


ID_VAR_GW_DEL

Interne ID: ID_VAR_GW_DEL

{Eliminar valor límite}

Se eliminará el valor límite.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DelLimit


ID_VAR_GW_DRUCKEN

Interne ID: ID_VAR_GW_DRUCKEN

Imprimir

Activado: La alarma o violación del valor límite se imprimirá online para esta variable según la configuración de la propiedad Impresión para en el grupo AML y CEL de las propiedades de proyecto.
Desactivado: Ninguna impresión online.
Por defecto: Desactivado

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Print


ID_VAR_GW_FARBE

Interne ID: ID_VAR_GW_FARBE

Color del valor límite

Información de colores para la coloración de símbolos y el color de estado para la utilización de variables en el elemento binario, la definición de colores de los textos de las alarmas en la lista de mensajes de alarma se realizará al definir las clases de alarmas/eventos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Color


ID_VAR_GW_FKT

Interne ID: ID_VAR_GW_FKT

Función

Propiedades para la función vinculada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Function


ID_VAR_GW_FUNKTION

Interne ID: ID_VAR_GW_FUNKTION

Función

Función que se ejecutará automáticamente en el runtime cuando se viole un límite.
Si el estado está definido como alarma se puede impedir la ejecución espontánea de la función. Para ello seleccione la opción Invocación a través del botón en la pantalla de lista de mensajes de alarma.
Si se debe ejecutar más de una función se deberá crear un script con las funciones deseadas y vincular aquí la función para ejecutar el script.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Function


ID_VAR_GW_GRENZWERT

Interne ID: ID_VAR_GW_GRENZWERT

Valor límite

Solo disponible si no hay ningún límite dinámico definido:
Define el valor a partir del cual se viola el límite.
En la propiedad "Mínimo / Máximo" se determina si los valores por encima o por debajo provocan una violación del límite.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LimitValue


ID_VAR_GW_GRP1

Interne ID: ID_VAR_GW_GRP1

Límites

Propiedades para la calcular el valor límite.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Ranges


ID_VAR_GW_GRUPPE

Interne ID: ID_VAR_GW_GRUPPE

Alarma/Grupo de eventos

Asignación de un grupo de alarmas/eventos (máx. 65535) para el límite utilizado como alarma.
La asignación a un grupo de alarmas/eventos se realiza mediante selección en la lista.
Por defecto: 0 - (no utilizado).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Group


ID_VAR_GW_HILFE

Interne ID: ID_VAR_GW_HILFE

Archivo de ayuda

Sólo disponible cuando el límite sea una alarma.

Archivo (*.chm), del cual se mostrará un capítulo de ayuda para esta alarma en la lista de alarmas.

Más sobre el archivo de ayuda en la ayuda online.

Proyección para EPLAN:
es posible invocar una página desde EPLAN. Para ello tiene que tener la licencia para la conexión con EPLAN y tiene que estar definida la ruta al programa EPLAN en zenon6.ini.
Configuración:

  • Entrada de la secuencia de caracteres $PRG:xxxxxx
  • xxxxxx es un marcador de posición para los parámetros a asignar.
  • Se ignorará la propiedad Capítulo de ayuda pero no puede estar vacía.

Más sobre EPLAN en la ayuda online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HelpFile


ID_VAR_GW_HILFEKAP

Interne ID: ID_VAR_GW_HILFEKAP

Capítulo de ayuda

Solo disponible si el límite es una alarma:
Capítulo de ayuda que se mostrará para esta alarma en la lista de alarmas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HelpCapture


ID_VAR_GW_HLP

Interne ID: ID_VAR_GW_HLP

Ayuda

Propiedades para el capítulo de ayuda vinculado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Help


ID_VAR_GW_KLASSE

Interne ID: ID_VAR_GW_KLASSE

Alarma/Clase de evento

Asignación de una clase de alarmas/eventos (máx. 65535) para el límite utilizado como alarma.
La asignación a una clase de alarmas/eventos se realiza mediante selección en la lista.
Por defecto: 0 - (no utilizado).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Class


ID_VAR_GW_KOMMENTAR

Interne ID: ID_VAR_GW_KOMMENTAR

Comentario requerido

Solo disponible si la propiedad Reconocimiento obligatorio está activada.

Activado: Antes de poder reconocer una alarma hay que introducir un comentario. El usuario tiene que disponer para ello de autorización para la función Introducir comentario de alarma.

Por defecto: Desactivado

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmComment


ID_VAR_GW_LOESCHEN

Interne ID: ID_VAR_GW_LOESCHEN

Eliminación obligatoria

Solo disponible si la propiedad Reconocimiento obligatorio está activada.
Activado: La alarma tendrá que ser reconocida y eliminada antes de suprimirla del Búfer anular.
Desactivado: No se requiere eliminación.
Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmDelete


ID_VAR_GW_MINMAX

Interne ID: ID_VAR_GW_MINMAX

Mínimo/Máximo

Mínimo: Violación del límite al alcanzar o quedar por debajo del límite definido.
Máximo: Violación del límite al alcanzar o sobrepasar el límite definido.
Por defecto: Mínimo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsMax


ID_VAR_GW_NEW

Interne ID: ID_VAR_GW_NEW

{Valor límite nuevo}

Se creará un nuevo valor límite.
Son posibles hasta 65535 valores límite.
Las variables bit tienen siempre dos valores límite.
No se pueden usar valores límite para variables de cadena. En su lugar se puede utilizar aquí (como también en otras variables) una matriz de reacción.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NewLimit


ID_VAR_GW_PREVIEW

Interne ID: ID_VAR_GW_PREVIEW

Vista previa del valor límite

Muestra el límite definido para la variable. Solo disponible si en la propiedad Matriz de reacción no hay ninguna matriz de reacción vinculada.

Haciendo clic sobre el botón ... se abre un diálogo para mostrar los límites definidos. Los límites solo se mostrarán, no se pueden modificar. Las modificaciones deberán realizarse directamente en las propiedades de variables para Valores límites.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

LimitPreview


ID_VAR_GW_QUITTIEREN

Interne ID: ID_VAR_GW_QUITTIEREN

Reconocimiento obligatorio

Sólo disponible para alarmas.
Activado: La alarma tiene que ser reconocida antes de suprimirla del Búfer anular.
Desactivado: No se requiere el reconocimiento de la alarma.
Por defecto en alarmas: activado, en otro caso desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmAcknowledge


ID_VAR_GW_SCHWELLWERT

Interne ID: ID_VAR_GW_SCHWELLWERT

Valor umbral

Se puede introducir un valor umbral aplicable para despejar un valor límite. Así se pueden evitar reacciones no deseadas con valores numéricos parpadeantes.
Ejemplo 1: Valor máximo = 900, valor umbral = 10, resulta 890
El límite se viola a partir de un valor de 900 y deja la zona crítica cuando baja de 890.
Ejemplo 2: Valor mínimo = 900, valor umbral = 10, resulta 910
El límite se viola a partir de un valor de 900 y deja la zona crítica cuando sube de 910.
A diferencia de la histéresis, esta propiedad no afecta a la representación del valor sino sólo al comportamiento de la alarma.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ThresholdValue


ID_VAR_GW_TEXT

Interne ID: ID_VAR_GW_TEXT

Texto del valor límite

Este texto se mostrará durante el runtime cuando se violen los límites, según se haya configurado, en la lista de mensajes de alarma, en la lista cronológica de eventos y/o en la barra de estado de alarmas.

Texto dinámico del valor límite: permite insertar valores actuales de otras variables en el texto del valor límite de una variable y de matrices de reacción. Para ello se puede vincular también un texto fijo a través de un índice con palabras clave de una tabla de idiomas. Esto da lugar a algunas limitaciones:
El texto estático se archivará en la memoria para el valor límite con un máximo de 1024 caracteres. Los valores de las variables vinculadas se archivarán en la memoria para el comentario con un máximo limitado a 80 caracteres.

Las limitaciones se pueden obviar con la ampliación para los textos largos dinámicos de valores límite. Para ello active Textos largos dinámicos de valor límite CEL o Textos largos dinámicos de valor límite AML. Los valores de las variables para los textos dinámicos de valores límite se transferirán a un archivo propio. Atención: Al utilizar valores límite dinámicos no se puede introducir ningún comentario.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Text


ID_VAR_GW_UNSICHTBAR

Interne ID: ID_VAR_GW_UNSICHTBAR

Oculto

Activado: El estado no se representará en el elemento dinámico "Elemento de estado" o no se representarán los elementos cuya visibilidad se controle con esta variable.
Desactivado: La violación de un límite no afectará a la visibilidad.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Invisible


ID_VAR_GW_VARIABEL

Interne ID: ID_VAR_GW_VARIABEL

Valor límite dinámico activado

Controla si el valor límite está definido, o bien de manera fija, o bien de manera dinámica a través de una variable.

  • Desactivado: El valor límite se define mediante una asignación fija de valor.
  • Activado: El valor límite se define mediante el valor de otra variable.
    AML/CEL: Como sello horario para la violación de los límites en la AML y/o CEL se utilizará el sello horario más reciente de las dos variables.

Por defecto: Desactivado

ATENCIÓN: Cuando se modifique el valor límite variable de manera que el valor actual de la variable sin modificación se encuentre en el área violada, se producirá también una violación del límite.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsVariable


ID_VAR_GW_VARIABLE

Interne ID: ID_VAR_GW_VARIABLE

Variable

Solo disponible si el límite dinámico está activado:
Variable que se utilizará como límite dinámico.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variable


ID_VAR_GW_VERZOEGEUNG

Interne ID: ID_VAR_GW_VERZOEGEUNG

Tiempo de retraso [s]

Periodo en segundos, en el que la violación del límite tendrá que estar activa. El valor tiene que existir ininterumpidamente por lo durante menos el intervalo de tiempo determinado para que se ejecuten las acciones definidas para la violación del límite.
AML/CEL:

  • Como sello horario para la violación de los límites en AML y/o CEL se utilizará el momento de la primera violación del límite.
  • Como valor se registrará el primer valor después del retraso, no el valor que desencadenó la alarma.

ATENCIÓN: En combinación con la propiedad Parpadeo esta propiedad repercute en la red de la siguiente manera:

  • Valor límite con parpadeo y sin retraso: Los elementos vinculados parpadean en el servidor y en las máquinas clientes.
  • Valor límite con parpadeo y retraso: Los elementos vinculados parpadean solo en el servidor pero no en los clientes.
  • Alarma con parpadeo y sin retraso: Los elementos vinculados parpadean en el servidor y en las máquinas clientes.
  • Alarma con parpadeo y retraso: Los elementos vinculados parpadean en el servidor y en las máquinas clientes.

Mínimo: 00
Máximo: 4294967295
Por defecto:: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Delay


ID_VAR_GW_ZUSATZ_ATTRIB

Interne ID: ID_VAR_GW_ZUSATZ_ATTRIB

Atributos adicionales

Propiedades adicionales para el límite.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_AddAttrib


ID_VAR_HDAKTIV

Interne ID: ID_VAR_HDAKTIV

Almacenamiento de datos en el disco duro On

Activado: Los valores de las variables se guardarán en el disco duro (memoria anular) para su evaluación en el elemento dinámico "Elemento de tendencia" o para exportar/importar los valores.

Desactivado: No se guardarán los valores de las variables.

Por defecto: desactivado

Los datos HD requieren una capacidad de 24 bytes por cada valor HD guardado con independencia del tipo de variable a guardar. Además del valor se guardarán las siguientes informaciones:
- Tiempo en el que se midió el valor.
- Milisegundos al leer el valor.
- Estado del valor para ajustar los elementos en correspondencia.
- Contador para la identificación inequívoca del valor (driver espontáneo).

Observación: El almacenamiento de datos se analizará también para Cambio de pantalla a una pantalla del tipo Tendencia ampliada cuando se anlicen datos online.
Las variables del tipo cadena no son compatibles con la grabación de datos en el disco duro.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HDActive


ID_VAR_HDRDA

Interne ID: ID_VAR_HDRDA

Tipo de grabación

Solo disponible si la propiedad Almacenamiento de datos en el disco duro On está activada.
Datos del disco duro (cíclico): Escritura cíclica de los valores en el disco duro.
Valores reordenados (RDA): Los valores se escribirán por bloques del driver al disco duro. (Sirve para análisis post-mortem de errores de control.)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsKDAActiv


ID_VAR_HDUPDATE

Interne ID: ID_VAR_HDUPDATE

Tiempo de ciclo [s]

Solo disponible si la propiedad Almacenamiento de datos en el disco duro On está activada:
Intervalo de tiempo [en segundos] para el archivo de los valores online en el disco duro (memoria anular) para su evaluación en el elemento dinámico Tendencia, para Datos online en la Tendencia ampliada o para la exportación/importación de valores.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HDUpdate


ID_VAR_HDWERTE

Interne ID: ID_VAR_HDWERTE

Número de valores

Solo disponible si la propiedad Almacenamiento de datos en el disco duro On está activada:
número de valores para el archivo de valores online en el disco duro (memoria anular) para su evaluación en el elemento dinámico Tendencia, para datos online en la Tendencia ampliada o para exportar/importar los valores.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HDSize


ID_VAR_HYSTERESE

Interne ID: ID_VAR_HYSTERESE

Histéresis

Propiedades para la histéresis.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Hysteresis


ID_VAR_HYSTNEG

Interne ID: ID_VAR_HYSTNEG

Negativo para señal

Histéresis para el valor límite referida al área de señal.

Área de histéresis para la entrada de cambios de valores decrecientes. Los valores solo se interpretarán como violación del valor límite cuando el cambio se halle por debajo del área de histéresis configurada aquí
Por defecto: 0 (ninguna histéresis)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HystNeg


ID_VAR_HYSTPOS

Interne ID: ID_VAR_HYSTPOS

Positivo para señal

Histéresis para el valor límite referida al área de señal.

Área de histéresis para la entrada de cambios de valores crecientes. Los valores solo se interpretarán como violación del valor límite cuando el cambio se halle por encima del área de histéresis configurada aquí
Por defecto: 0 (ninguna histéresis)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HystPos


ID_VAR_INTERN_INITIALWERT

Interne ID: ID_VAR_INTERN_INITIALWERT

Valor inicial

El valor definido aquí se utilizará al iniciar el runtime como valor actual de la variable cuando la propiedad "Remanencia" esté configurada en "Valor inicial".

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Initial_value


ID_VAR_INTERN_LOKAL

Interne ID: ID_VAR_INTERN_LOKAL

Cálculo

Local: En proyectos de red la variable interna se analizará y administrará de manera local, es decir, en las máquinas clientes.
Lo cual quiere decir que el valor de la variable puede ser diferente en cada máquina y que los valores límite se analizarán de maneral local.
Red: La variable interna se analizará y administrará para los proyectos de red en el servidor del proyecto. Tendrá el mismo valor en el servidor y en todos los clientes.
Por defecto: local.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Local


ID_VAR_INTERN_REMANENZ

Interne ID: ID_VAR_INTERN_REMANENZ

Remanencia

Off: Al iniciar el runtime se utilizará como valor inicial el valor alternativo de la variable, en caso de variables de cadena se utilizará una cadena vacía.
Valor inicial: El valor inicial será el valor indicado en la propiedad "Valor inicial".
Remanente: Al reiniciar el runtime se utilizará como valor inicial el último valor de las variables.
Por defecto: off.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Remanenz


ID_VAR_KANALTYP

Interne ID: ID_VAR_KANALTYP

Tipo de objeto del driver

Dependiendo del driver utilizado al crear la variable se seleccionará un tipo de objeto y se podrá modificar posteriormente aquí.
Siemens: Bloque de datos, marcador, entrada/salida.
Modbus: Coil y Holding Register.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ID_DriverTyp


ID_VAR_KENNUNG

Interne ID: ID_VAR_KENNUNG

Identificación

Cadena libremente definible para identificar la variable o el tipo de dato.
Se puede utilizar en el cambio de idioma online en lugar del nombre de la variable, ya que dicho nombre no se puede cambiar de idioma.

Longitud máxima: 128 caracter

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Tagname


ID_VAR_LBOUND

Interne ID: ID_VAR_LBOUND

Índice de inicio

Seleccione el índice de inicio del array de la lista desplegable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LBound


ID_VAR_LINANPASS

Interne ID: ID_VAR_LINANPASS

Ajuste lineal de valores

Ajuste lineal de valores mediante el rango de medición.
Configuraciones para la conversión lineal de valores PLC en valores de visualización.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_LinAdjust


ID_VAR_LOCKING

Interne ID: ID_VAR_LOCKING

Grupo de comandos

Vínculo de un grupo de comandos a esta variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Locking


ID_VAR_MAKROHARDWARE

Interne ID: ID_VAR_MAKROHARDWARE

AdjustHardwareValue

Solo disponible si Ajuste de valores no lineal está activado:
Con cada cambio del valor crudo (PLC) se llamará a la macro para actualizar el valor en zenon.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AdjustHardware


ID_VAR_MAKROZENON

Interne ID: ID_VAR_MAKROZENON

AdjustScadaValue

Solo disponible si el ajuste de valores no lineal está activado:
Al escribir un valor del sistema de control se llamará a la macro para actualizar el valor crudo (PLC).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AdjustZenon


ID_VAR_MAXGRADIENT

Interne ID: ID_VAR_MAXGRADIENT

Gradiente máximo

Sólo disponible en SICAM 230.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxGradient


ID_VAR_MESSMAX

Interne ID: ID_VAR_MESSMAX

Rango máximo de medición

Valor máximo de las variables en zenon.
Si no está definido por Ajuste no lineal de valores de otra manera, el valor crudo de las variables (resolución de la señal) se convertirá siempre de forma lineal en el rango de medición para su utilización en el sistema de control. Todas las demás entradas de numéricas de valores para la variable en el editor y en el runtime se refieren al área de medición (p. ej. la definición de valores límite, límites predefinidos, área de representación, valores predefinidos,...).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RangeMax


ID_VAR_MESSMIN

Interne ID: ID_VAR_MESSMIN

Rango mínimo de medición

Valor mínimo de las variables en zenon.
Si no está definido de otra manera por Ajuste no lineal de valores , el valor crudo de las variables (resolución de la señal) se convertirá siempre de forma lineal en el rango de medición para su utilización en el sistema de control. Todas las demás entradas de numéricas de valores para la variable en el editor y en el runtime se refieren al área de medición (p. ej. la definición de valores límite, límites predefinidos, área de representación, valores predefinidos,...).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RangeMin


ID_VAR_NACHKOMMA

Interne ID: ID_VAR_NACHKOMMA

Cifras decimales

Número de decimales del valor de la variable para su representación en el sistema de control.
Mínimo: 00
Máximo: 10
Por defecto:: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Digits


ID_VAR_NAME

Interne ID: ID_VAR_NAME

Nombre:

Nombre unívoco de la variable. Normas aplicables a los nombres:

  • Longitud máxima: 128 caracter
  • los caracteres # y @ no están permitidos para nombres de variables.

Observación: Para drivers basados en una conexión con zenon Logic hay que tener en cuenta un prefijo. Ver detalles en el apartado Crear variables B y B en zenon Logic en el manual.
Los cambios del nombre de la variable repercutirán en los entornos de programación (VBA, VSTA, PCE).

Atención: Esta propiedad no está disponible para el cambio de idioma.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_VAR_NETADDR

Interne ID: ID_VAR_NETADDR

Dirección de red

Dirección de bus o dirección de la red de las variables.
Mínimo: 0
Máximo: 4294967295
Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NetAddr


ID_VAR_NORMALZUSTAND

Interne ID: ID_VAR_NORMALZUSTAND

Valor normal

Elija de la lista desplegable si el valor normal para esta variable o tipo de dato debe estar en On o Off. Disponible para variables y tipos de datos del tipo BOOL, UINT y WORD para todos los drivers.

Por defecto: Off

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NormalState


ID_VAR_NORMALZUSTANDAKT

Interne ID: ID_VAR_NORMALZUSTANDAKT

Activado

Permite definir el estado normal para variables y tipos de datos BOOL, UINT y WORD para todos los driver.

Activado: Se puede definir un estado normal.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NormalStateActive


ID_VAR_OFFSET

Interne ID: ID_VAR_OFFSET

Offset

Offset de la variable.
Con controles de direccionamiento lineal: el área de almacenamiento.
Con controles de resolución de nombres: la dirección de asignación.
Mínimo: 0
Máximo: 4294967295.
Por defecto: 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Offset


ID_VAR_OFS_SOURCE

Interne ID: ID_VAR_OFS_SOURCE

Cálculo del offset

Seleccione el tipo de cálculo deseado para el offset. Tiene las siguientes opciones:

  • Direccionamiento según offset de tipo de dato y offset de inicio
  • Direccionamiento automático
  • Direccionamiento manual

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OfsSource


ID_VAR_PRIORITAET

Interne ID: ID_VAR_PRIORITAET

Prioridad

Si no se utiliza el tiempo de configuración global en la configuración del driver, se pueden establecer allí tiempos de actualización para las distintas prioridades. Aquí se asigna una prioridad a una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UpdatePriority


ID_VAR_PROP_ANALYZER1

Interne ID: ID_VAR_PROP_ANALYZER1

Nombre para mostrar

Entrada de un nombre para mostrar para la variable en zenon Analyzer. Tiene que ser único en el proyecto, pero no se comprobará por zenon. La comprobación se realizará al importar a zenon Analyzer.

Esta propiedad proporciona informaciones que se utilizarán en la configuración de informes en zenon Analyzer. La exportación de zenon a zenon Analyzer se produce con el Analyzer Export Wizard.

Atención: Si esta propiedad se modifica después de la primera exportación a zenon Analyzer, dichas modificaciones no se aplicarán en zenon Analyzer.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VisualName


ID_VAR_PROP_ANALYZER2

Interne ID: ID_VAR_PROP_ANALYZER2

Significado

Esta propiedad proporciona informaciones que se utilizarán en la configuración de informes en zenon Analyzer.
Los datos se pueden introducir manualmente o se pueden configurar con el Meaning and Waterfall Chart Wizard. La exportación de zenon a zenon Analyzer se produce con el Analyzer Export Wizard.

Entrada del significado (Meaning) de una variable en zenon Analyzer. Si hay varios significados se separarán con una coma.
Sintaxis: [Meaning1],[Meaning2],…,[MeaningN]

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Meaning


ID_VAR_PROP_ANALYZER3

Interne ID: ID_VAR_PROP_ANALYZER3

Parámetro para el diagráma en cascada

Esta propiedad proporciona informaciones que se utilizarán en la configuración de informes en zenon Analyzer.
Los datos se pueden introducir manualmente o se pueden configurar con el Meaning and Waterfall Chart Wizard. La exportación de zenon a zenon Analyzer se produce con el Analyzer Export Wizard.

Parámetros de una variable para un diagrama en cascada en zenon Analyzer. Los distintos parámetros se separarán con una coma. Si hay varios modelos de cascada se separarán con un punto y coma.
Sintaxis: [Nombre del modelo],[Índice de líneas],[Índice en la línea],[Código de color];

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WaterfallParam


ID_VAR_PROP_GRP0

Interne ID: ID_VAR_PROP_GRP0

Direccionamiento

Propiedades el direccionamiento de la variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Address


ID_VAR_PROP_GRP1

Interne ID: ID_VAR_PROP_GRP1

Cálculo del valor

Definición del área de valor de las variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Value


ID_VAR_PROP_GRP2

Interne ID: ID_VAR_PROP_GRP2

Configuraciones adicionales

Propiedades ampliadas para la variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Extended


ID_VAR_PROP_GRP3

Interne ID: ID_VAR_PROP_GRP3

Almacenamiento de datos en el disco duro

Propiedades para guardar valores de variables en el disco duro.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_HardDisk


ID_VAR_PROP_GRP4

Interne ID: ID_VAR_PROP_GRP4

Valores límites

Propiedades del comportamiento de los valores límite o de las alarmas de la variable.

Las propiedades de este grupo estarán disponibles solo cuando Matriz de reacción activa no esté activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Limits


ID_VAR_PROP_GRP7

Interne ID: ID_VAR_PROP_GRP7

Protocolización en CEL

Propiedades para protocolizar en la lista cronológica de eventos (CEL).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SetValueProtocol


ID_VAR_PROP_GRP8

Interne ID: ID_VAR_PROP_GRP8

Manejo de alarmas

Propiedades para el reconocimiento y las áreas de alarma.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Alarmhandling


ID_VAR_PROP_GRP9

Interne ID: ID_VAR_PROP_GRP9

Alarma de pantalla

Sólo disponible en SICAM 230:
Propiedades para la alarma de imagen.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_PictureAlarm


ID_VAR_PROP_GRP10

Interne ID: ID_VAR_PROP_GRP10

Estado normal

Propiedades para el estado normal de una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_NormalState


ID_VAR_PROP_GRP11

Interne ID: ID_VAR_PROP_GRP11

Variable interna

Propiedades para las variables internas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_InternalVariable


ID_VAR_PROP_GRP12

Interne ID: ID_VAR_PROP_GRP12

Variable del driver del sistema

Propiedades para las variables del driver del sistema.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SystemVariable


ID_VAR_PROP_GRP13

Interne ID: ID_VAR_PROP_GRP13

Analyzer

Propiedades para la utilización en zenon Analyzer.

Más en el Manual online.

Esta función se invocará para zenon API (con nombre de clase):

GRP_Analyser


ID_VAR_PROP_GRP_GOOSE

Interne ID: ID_VAR_PROP_GRP_GOOSE

GOOSE

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GOOSE


ID_VAR_READWRITE

Interne ID: ID_VAR_READWRITE

Activar valor predeterminado

Activado: Liberar esta variable para acciones "Establecer valor predeterminado".
Desactivado: Esta variable está protegida contra escritura.
Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InOut


ID_VAR_REMA

Interne ID: ID_VAR_REMA

Matriz de reacción

Seleccione con ayuda de la lista desplegable una matriz de reacción disponible para la variable seleccionada. Si no desea utilizar una matriz de reacción, seleccione la entrada <No utilizar ninguna>.

Por defecto: <No utilizar ninguna>

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Rema


ID_VAR_REMA_KNOTEN

Interne ID: ID_VAR_REMA_KNOTEN

Matriz de reacción

Propiedades para utilizar una matriz de reacción para la variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Rema


ID_VAR_REMAAKTIV

Interne ID: ID_VAR_REMAAKTIV

Matriz de reacción activa

Activado: En lugar de los límites se usará una matriz de reacción.
Desactivado: Los límites se pueden definir para la variable.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsRemaActiv


ID_VAR_SBO

Interne ID: ID_VAR_SBO

Select Before Operate

Atención: Esta funcionalidad solo es compatible con los drivers IEC870 y IEC850 y solo cuando en el Comando se haya seleccionado para la propiedad tipo de acción Comando de conmutación. No utilice esta funcionalidad con el driver DNP3_NG, aquí se puede configurar Auto-SBO directamente en la variable.

Activado: Antes de escribir el valor de las variables en el hardware zenon preguntará si la variable en el hardware está preparada para la acción = Select before Operate (SBO).
Atención: Con comandos de impulso no se ejecutará el reseteo automático del valor de la variable después del intervalo de tiempo definido en la propiedad retraso de flancos.

Desactivado: El valor de la variable se escribirá en el hardware sin consulta previa = Direct execute.
Por defecto: desactivado
Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SBO


ID_VAR_SIGMAX

Interne ID: ID_VAR_SIGMAX

Área de señal máx.

Valor máximo de las variables en el sistema de control.
Si no está definido por Ajuste no lineal de valores de otra manera, el valor bruto de las variables (resolución de la señal) se calculará siempre de forma lineal en el área de medición para su utilización el el sistema de control. Todas las demás entradas de numéricas de valores para la variable en el editor y en el runtime se refieren al área de medición (p. ej. la definición de valores límite, límites predefinidos, área de representación, valores predefinidos,...).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SignalMax


ID_VAR_SIGMIN

Interne ID: ID_VAR_SIGMIN

Área de señal mín.

Valor mínimo de las variables en el sistema de control.
Si no está definido por Ajuste no lineal de valores de otra manera, el valor bruto de las variables (resolución de la señal) se calculará siempre de forma lineal en el área de medición para su utilización el el sistema de control. Todas las demás entradas de numéricas de valores para la variable en el editor y en el runtime se refieren al área de medición (p. ej. la definición de valores límite, límites predefinidos, área de representación, valores predefinidos,...).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SignalMin


ID_VAR_SIGNAL

Interne ID: ID_VAR_SIGNAL

Rango del valor PLC

Rango de valor de la variable en el control.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SignalRange


ID_VAR_SOLLMAX

Interne ID: ID_VAR_SOLLMAX

Valor predeterminado máx.

El máximo configurado aquí para acciones "Escribir valor predeterminado" se puede aplicar a elementos dinámicos en lugar de tener que configurarlo allí por separado.
Se recomienda sobre todo si se producen modificaciones posteriormente en el rango de medición de las variables, ya que dichas modificaciones se pueden ajustar aquí de manera central y no habría que ajustarlas en cada elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ValueMax


ID_VAR_SOLLMIN

Interne ID: ID_VAR_SOLLMIN

Valor predeterminado mínimo

El mínimo configurado aquí para acciones "Escribir valor predeterminado" se puede aplicar a elementos dinámicos en lugar de tener que configurarlo allí por separado.
Se recomienda sobre todo si se producen modificaciones posteriormente en el rango de medición de las variables, ya que dichas modificaciones se pueden ajustar aquí de manera central y no habría que ajustarlas en cada elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ValueMin


ID_VAR_STANDBY

Interne ID: ID_VAR_STANDBY

Leer sólo del servidor standby

Activado: Se mostrará el valor de la variable del servidor standby.
Desactivado: Se mostrará el valor de la variable del servidor.
(solo con drivers de hardware)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Standby


ID_VAR_STRINGLAENGE

Interne ID: ID_VAR_STRINGLAENGE

Longitud de cadena

Sólo disponible para variables de cadena:
Número máximo de caracteres que la variable puede aceptar.
Mínimo: 0 caracteres
Por defecto: 65535 caracteres
Por defecto: 5 caracter

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StringLength


ID_VAR_STRINGLAENGE2

Interne ID: ID_VAR_STRINGLAENGE2

Longitud de cadena

Sólo disponible para variables de cadena:
Número máximo de caracteres que la variable puede aceptar.
Mínimo: 00
Máximo: 65535
Por defecto:: 5

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxStringLen


ID_VAR_SWP_ACT

Interne ID: ID_VAR_SWP_ACT

Valor antiguo y nuevo

  • Activado: Al modificar el valor predeterminado de esta variable se protocolizarán el valor antiguo y el nuevo en la lista cronológica de eventos (CEL).
  • Desactivado: Solo se protocolizará el valor nuevo.

Por defecto:desactivado

Recomendación: Active la propiedad Lectura continua de variable. De esa manera el valor está siempre disponible y no tiene que consultarlo cada vez.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SV_Act


ID_VAR_SWP_ART

Interne ID: ID_VAR_SWP_ART

Protocolización

Determina cómo se protocolizará el Escribir valor predeterminado en la lista CEL:

  • Todo: Todas las acciones "Escribir valor predeterminado" de esta variable mediante elementos dinámicos y las funciones "Escribir valor predeterminado" se protocolizarán en la lista cronológica de eventos (CEL).
  • Nada: No se protocolizará ninguna acción "Escribir valor predeterminado" en la lista CEL.
  • Sólo con elemento dinámico: Solo se protocolizarán las acciones "Escribir valor predeterminado" con elementos dinámicos en la lista CEL.

Por defecto: Sólo con elemento dinámico

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SetValueProtocol


ID_VAR_SWP_VBA

Interne ID: ID_VAR_SWP_VBA

Configurar valor predeterminado con VBA

Activado: El establecimiento del valor predeterminado de esta variable a través de una macro VBA se protocolizará en la lista cronológica de eventos (CEL).
Desactivado: El establecimiento del valor predeterminado de esta variable a través de una macro VBA no se protocolizará.
Por defecto: activado

Observación: Con variables configuradas como variables de comando en IEC870 process gateway si la propiedad está activada cada comando se protocolizará como Escribir valor predeterminado a través de la interfaz COM en la lista CEL.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SV_VBA


ID_VAR_SYMBADDR

Interne ID: ID_VAR_SYMBADDR

Dirección simbólica

Secuencia de caracteres para la dirección simbólica de la variable.

Longitud máxima: 128 caracteres.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SymbAddr


ID_VAR_TREIBER

Interne ID: ID_VAR_TREIBER

Driver

Driver para la variable. Se seleccionará al crearse la variable y se podrá modificar aquí posteriormente .

Observación: Los drivers para proyectos de zenon Logic no se podrán modificar posteriormente.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Driver


ID_VAR_TYPE

Interne ID: ID_VAR_TYPE

Tipo de dato

Tipo de dato de la variable. Se seleccionará al crearse la variable y se podrá modificar aquí posteriormente.
Observación: Para variables de estructura no se podrá volver a modificar el tipo de dato después de crear las variables.
Atención: Si el tipo de dato se modifica posteriormente habrá que comprobar y ajustar todas las demás propiedades de la variable.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ID_DataTyp


ID_VAR_USEMAKRO

Interne ID: ID_VAR_USEMAKRO

Adaptación no lineal con macros

El ajuste del valor no lineal se utiliza en variables cuyo valor crudo (control) no se pueda escalar linealmente al valor de medición (sistema de control).
Activado: Los valores crudos no se escalarán linealmente (con macros VBA) a valores del sistema de control.
Después de activar la opción “Ajuste no lineal de valores” se introducirán las macros VBA para la conversión en "AdjustHardwareValue" y "AdjustZenOnValue".
Desactivado: Los valores crudos se escalan de forma lineal a valores del sistema de control.
Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UseMacro


ID_VAR_WERTATTRIB

Interne ID: ID_VAR_WERTATTRIB

Atributos del valor

Propiedades para los atributos de valor de la variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ValueAttrib


ID_VAR_ZWREMANR

Interne ID: ID_VAR_ZWREMANR

Grupo de contadores

Sólo disponible en SICAM 230.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CounterGroup


ID_VARGROUP

Interne ID: ID_VARGROUP

Grupo de variables externo

Propiedad externa para zenon Logic. Sólo afecta a variables que no sean del driver straton32.
Grupo de variables en zenon Logic ("Global" , "Retain" o vacío).

Esta propiedad se muestra solo para información. Editable solo con zenon Logic.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Vargroup


ID_VARINASM

Interne ID: ID_VARINASM

Guardar en la base de datos IPA

Activado: Las alarmas de esta variable están disponibles para su análisis en el Industrial Performance Analyzer (IPA).
Desactivado: Las alarmas de esta variable no se tendrán en cuenta para su análisis en el Industrial Performance Analyzer (IPA).
Por defecto: Desactivado

Atención: El Industrial Performance Analyzer es un módulo opcional para el que necesita licencia si desea utilizarlo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VarInASM


ID_VERRIEG_CBTR_FORMULA

Interne ID: ID_VERRIEG_CBTR_FORMULA

Suprimir detección

Introducción de la fórmula con la que se suprime el reconocimiento de una caída del interruptor. Haciendo clic sobre el botón ... se abre el editor de fórmulas.

Para la fórmula se pueden utilizar todas las variables de la lista del grupo de comandos, también son posibles las sustituciones de nombres con '*' como en la definición de las Condiciones de interbloqueo de una acción.

Observación: Las variables utilizadas en la fórmula no podrán ser eliminadas de la lista del grupo de comandos.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CBTR_Formula


ID_VERRIEG_CBTR_MONITORED

Interne ID: ID_VERRIEG_CBTR_MONITORED

Detección de caídas del interruptor

Sólo disponible si la propiedad Establecer estado PROGRESS está activada.

Activado: Supervisa si la variable de respuesta cambia inesperadamente su valor de <> 0 a 0.

Por defecto: Desactivado

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CBTR_Act


ID_VERRIEG_PROP1

Interne ID: ID_VERRIEG_PROP1

Nombre:

Nombre unívoco del interbloqueo o comando.
Por defecto: Interbloqueo/grupo de comandos x (x corresponde a un número sucesivo).
Atención: Esta propiedad no está disponible para el cambio de idioma.

Más en el manual online sobre la creación de un:

- Interbloqueo

- Comando

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_VERRIEG_PROP2

Interne ID: ID_VERRIEG_PROP2

Variable de acción

Nombre de las variables vinculadas al grupo de comandos.
Abre el diálogo de selección de variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_VERRIEG_PROP3

Interne ID: ID_VERRIEG_PROP3

Nombre de la variable de respuesta

Nombre de la variable o máscara para sustituir la variable de respuesta.
Un asterisco incluido en el nombre (*) sirve como marcador para el texto de sustitución. Sólo se puede utilizar un marcador de posición en el nombre. Para la máscara hay que tener en cuenta que la sustitución de este nombre dará lugar también a un nombre de variable existente.
Si la variable (de sustitución o absoluta) utilizada aquí no existe en el momento de crear los archivos runtime, ese grupo de comandos no estará disponible en el runtime. Al crear los archivos runtime se producirá un aviso que alerte de este error
Entrada directa o diálogo de selección de la variable.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ReturnInformation


ID_VERRIEG_PROP4

Interne ID: ID_VERRIEG_PROP4

Establecer estado PROGRESS

Activado: Con las acciones Comando y Actualizar se establecerá el bit de estado En proceso (PROGRESS) para la variable de respuesta cuando las acciones se inicien en el runtime.
El bit sirve para realizar una visualización gráfica para mostrar al usuario que se está ejecutando una acción. Con la ayuda de un elemento combi o de una matriz de reacción podrá consultar el bit de estado y realizar una visualización gráfica.

Desactivado: El bit de estado no se establecerá.

Por defecto: desactivado.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DesiredDirection


ID_VERRIEG_PROP5

Interne ID: ID_VERRIEG_PROP5

Supervisión del tiempo de ejecución

Determina el transcurso de la supervisión del tiempo de ejecución.

Observación: Esta supervisión del tiempo de ejecución solo estará activada para el tipo de acción Comando de conmutación y Comando de pulso.

  • ninguno: Ninguna supervisión del tiempo de ejecución.
  • solo mediante variable de respuesta (VR): El valor de la variable de respuesta se utilizará para comprobar si el proceso se ha realizado con éxito. La supervisión solo se activará cuando el valor que deba ser escrito sea distinto del valor actual de la variable de acción.
  • solo mediante causa de transmisión (COT): La COT (Cause of Transmission) se utiliza para comprobar si el proceso se ha desarrollado con éxito.
    Para la acción 'Comando' se evaluarán los bits de estado de la causa de transmisión (COTx). La supervisión finalizará cuando se llegue a COT_actterm (10).
  • mediante COT y VR: Espera y reacciona a la COT y a modificaciones de valor en la variable de respuesta. Combina las propiedades de solo mediante variable de respuesta (VR) y solo mediante causa de transmisión (COT).

En general se aplica: Si la supervisión del tiempo de ejecución no finaliza con éxito dentro de la propiedad Tiempo de espera proyectada por la acción, el bit de estado se establecerá en TIMEOUT.

Por defecto: ninguna:

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WatchDogTimer


ID_VERRIEG_PROP6

Interne ID: ID_VERRIEG_PROP6

Tipo de acción

Solo disponible con la acción Comando:
Tipo de comando.
Comando de conmutación: Escribe el valor de la propiedad Comando.
Comando Pulso: Escribe el valor de la propiedad Comando. Después del Retraso de flanco se escribirá el valor 0. Esta escritura no estará supervisada en el tiempo de ejecución.

Observación: Solo disponible para la acción de comando Comando Pulso. Si en el comando se seleccionan otras acciones, éstas se registrarán previamente en el Tipo de acción y a partir de entonces aparecerán en gris en el procesamiento.

Por defecto: Comando de conmutación.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Type


ID_VERRIEG_PROP7

Interne ID: ID_VERRIEG_PROP7

Estado de respuesta/Dirección de conmutación

Define el valor previsto o el estado de la variable de respuesta según la ejecución de la acción.

Las entradas posibles se diferencian según la acción.

  • OFF: Se desactivará el estado de respuesta - el valor será 0
  • DIFF: Estado intermedio entre 0 y 1.
  • ON: Se activará el estado de respuesta - el valor será 1
  • ninguno: Se ignorará el estado de respuesta - el valor no se modificará
  • DIR: xx (solo disponible para la acción de comando Entrada de valor predeterminado)
  • Sollwert: xx (solo disponible para la acción de comando Entrada de valor predeterminado)
  • STÖR: Error.

No disponible para las acciones: Bloquear, Bloqueo y Desbloquear.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Direction


ID_VERRIEG_PROP8

Interne ID: ID_VERRIEG_PROP8

Tiempo de espera cancelable

Permite interrumpir el timeout durante la supervisión del tiempo de ejecución.

Si el comando Execute-está ya siendo ejecutado -después de que se haya recibido COT_actcon - el botón Cancelar interrumpirá la supervisión del tiempo de ejecución. Así los botones, por ejemplo, volverán a estar activados y serán manejables.
Pero: Al interrumpir durante la ejecución el módulo no transferirá ninguna desactivación (Cancel) al driver.
Si esta propiedad está activada durante una supervisión del tiempo de ejecución se activará el botón Cancel en la pantalla Comando. El usuario puede así finalizar la supervisión del tiempo de ejecución haciendo clic sobre este botón.

Por defecto: Desactivado

Observación: Solo disponible para las acciones de grupos de comandos Comando y Entrada del valor predeterminado. ¡No se establecerá ningún bit de timeout!

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TimeoutAbortable


ID_VERRIEG_PROP9

Interne ID: ID_VERRIEG_PROP9

Suprimir entrada CEL

Activado: Al ejecutar una acción no se generará ninguna entrada en la lista cronológica de eventos (CEL).
Desactivado: Al ejecutar una acción se generará una entrada en la lista cronológica de eventos (CEL).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CELBlock


ID_VERRIEG_PROP10

Interne ID: ID_VERRIEG_PROP10

Tiempo de espera

Tiempo de espera para la supervisión del tiempo de ejecución en segundos para el tipo de acción Comando de conmutación y Comando de pulso.

Esta configuración sirve también como tiempo de espera para Select con los IO (Information Objects). Solo disponible con las acciones Comando, Comando auto/remoto, Comprobar respuesta, Entrada del valor predeterminado y Comando obligatorio.

  • Mínimo: 0
  • Máximo: 4294967295
  • Por defecto: 30

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Timeout


ID_VERRIEG_PROP11

Interne ID: ID_VERRIEG_PROP11

Vínculo lógico

Abre el diálogo para definir la fórmula para la condición.
Las condiciones de interbloqueo se calcularán en la red siempre de manera local. Al utilizar variables locales (p. ej. del driver del sistema o variables internas) puede ocurrir que en un cliente se cumplan otras condiciones que en el servidor.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Formula


ID_VERRIEG_PROP12

Interne ID: ID_VERRIEG_PROP12

Desbloqueable

Sólo disponible en SICAM 230 o cuando tenga la licencia del Energy Edition :
Activado: El interbloqueo se puede desbloquear manualmente en pantallas del tipo comando.
Por defecto: desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Delocking


ID_VERRIEG_PROP13

Interne ID: ID_VERRIEG_PROP13

Texto de bloqueo

Descripción de la condición de interbloqueo.
En el runtime se puede mostrar este texto en la imagen del tipo comando (si tiene la licencia del Energy Edition) o se puede analizar en una macro VBA.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Text


ID_VERRIEG_PROP14

Interne ID: ID_VERRIEG_PROP14

Comando

Solo disponible con la acción 'Comando':
Define el valor que se escribirá en la variable de comando con la acción 'Comando'.
Observación: no activado con los comandos Bloquear, Sustituir, Liberar, Corrección manual, Revisión, Entrada de valor predeterminado y Entrada de estado.

0: La variable de comando se configura en 0.
1: La variable de comando se configura en 1.
Por defecto: 1.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CommandState


ID_VERRIEG_PROP15

Interne ID: ID_VERRIEG_PROP15

Estados modificables

Solo disponible para la acción de comando 'Entrada de estado':

Por defecto: ninguna:

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

State


ID_VERRIEG_PROP16

Interne ID: ID_VERRIEG_PROP16

Comparación valor nominal/actual

Activado: Se comprobará si el valor de la variable de respuesta se corresponde con la dirección de conmutación a ejecutar. En ese caso, se mostrará en el comando un mensaje de interbloqueo desbloqueable.
Desactivado: No se comprobará la dirección de conmutación.
Observación: Solo activado si se ha seleccionado la acción de grupo de comandos Comando Pulso.

Por defecto: desactivado

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Actual


ID_VERRIEG_PROP17

Interne ID: ID_VERRIEG_PROP17

Pantalla modal

Activado: Con independencia de la propiedad 'Diálogo modal ' de la pantalla, la pantalla de comando se activará de forma modal. Es decir, que no se podrán manejar otras pantallas hasta que se haya cerrado la pantalla.
Desactivado: La pantalla de comando se activará de manera normal.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Modal


ID_VERRIEG_PROP18

Interne ID: ID_VERRIEG_PROP18

Variable de respuesta como título de pantalla

Activado: La identificación de la variable de respuesta se utilizará como título de pantalla.
Desactivado: El nombre de la pantalla se utilizará como título de pantalla.
Por defecto: desactivado.
ATENCIÓN: Para activar el título de pantalla tiene que estar activada adicionalmente la propiedad Título en la plantilla correspondiente.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RM-Titel


ID_VERRIEG_PROP19

Interne ID: ID_VERRIEG_PROP19

Pantalla

Nombre de la pantalla que se abrirá cuando no haya ninguna pantalla de acción específica y la pantalla no se abra con la función Cambio de pantalla.

Observación: Si el comando se inicia estableciendo un valor determinado en un elemento habrá que vincular aquí una pantalla.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PicGUID


ID_VERRIEG_PROP20

Interne ID: ID_VERRIEG_PROP20

Pantalla

Imagen del tipo comando que se utiliza en el menú contextual del elemento al ejecutar la acción. Si no hay ninguna imagen introducida, se utilizará la imagen correspondiente a la propiedad Pantalla en el grupo de comandos. Una imagen proyectada pero no existente dará lugar a un mensaje de error al crear los archivos runtime. La acción no se aplicará en este caso.
Por defecto: ninguna.

Observación: Si el comando se inicia estableciendo un valor determinado en un elemento, se ignorará esta propiedad y se utilizará siempre la imagen correspondiente a la propiedad Pantalla en el grupo de comandos.
No estará activado cuando el tipo de acción Comando auto/remoto esté activado.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PicGUID


ID_VERRIEG_PROP21

Interne ID: ID_VERRIEG_PROP21

Botón de acción

No disponible para las acciones 'Bloqueo', Comando auto/remoto o si no hay asignada ninguna pantalla de comandos.
Dentro de las pantallas del tipo Comando hay definido un Botón de acción al que está asignada la acción.
Si el grupo de comandos es utilizado con otra pantalla (p. ej. con una función) se mantiene de todas formas la asignación al botón de acción. Si falta dicho botón la acción no estará disponible en la imagen.
En la lista de selección sólo se mostrarán los botones de acción no asignados todavía.
Por defecto: Ninguno

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CmdBtn


ID_VERRIEG_PROP22

Interne ID: ID_VERRIEG_PROP22

Cerrar automáticamente

Activado: Después de ejecutar la acción la pantalla de comandos se cerrará automáticamente.
Desactivado: La pantalla de comandos no se cerrará automáticamente.
No estará activado cuando el tipo de acción Comando auto/remoto esté activado.

Por defecto: desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CloseMDIWnd


ID_VERRIEG_PROP23

Interne ID: ID_VERRIEG_PROP23

Manejo a dos manos

Sólo disponible para la ejecución en dos niveles:

  • Activado: El elemento de control Ejecutar 2° Nivel solo es operable si al mismo tiempo se pulsa la tecla CTRL.
    Atención: Para el elemento de control Ejecutar 2° Nivel la propiedad Seleccionable con lazo no puede estar activada para el manejo a dos manos.
  • Desactivado: El elemento de control será siempre manejable.

Por defecto: desactivado
No estará activado cuando el tipo de acción Comando auto/remoto esté activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TwoHand


ID_VERRIEG_PROP24

Interne ID: ID_VERRIEG_PROP24

Retraso de flanco

Solo disponible si en la propiedad Tipo de acción se ha seleccionado el Comando Pulso.
Después del transcurso de ese tiempo en milisegundos el valor de la variable de comando se reseteará - dependiendo de la dirección de conmutación - a 0 o 1. No se ejecutará el reseteo del valor cuando la propiedad Select Before Operate de la variable de acción esté activada.

Observación: Si en los comandos se selecciona la acción Comando auto/remoto o Comando obligatorio dichas acciones se registrarán previamente en Tipo de acción y estarán desactivadas para su posterior edición.

Observación:
Mínimo: 00
Máximo: 4294967295
Por defecto:: 1000
Atención: No se esperará a que haya terminado la supervisión del intervalo de tiempo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EdgeDelay


ID_VERRIEG_PROP25

Interne ID: ID_VERRIEG_PROP25

Dos niveles

Activado: La acción no se ejecutará hasta que el control accione „Ejecutar 2“.

Desactivado: La acción se ejecutará:

  • después de que se desbloquee el último interbloqueo
  • inmediatamente, cuando no haya ningún interbloqueo

No estará activado cuando el tipo de acción Comando auto/remoto esté activado.

Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TwoLevel


ID_VERRIEG_PROP29

Interne ID: ID_VERRIEG_PROP29

Valor predeterminado

Sólo disponible cuando la propiedad Estado de respuesta/Dirección de conmutación se configure como DIR. Esto solo es posible con las acciones de comando Sustituir, Corrección manual y Entrada de valor predeterminado.

Define el valor predeterminado para escribir.

Por defecto: 0

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ValueDirectly


ID_VERRIEG_PROP30

Interne ID: ID_VERRIEG_PROP30

Variable de eventos

Muestra el resultado de la condición de interbloqueo en la variable seleccionada.

Haciendo clic sobre botón se abre un diálogo de selección de la variable. También puede introducir directamente el nombre de la variable en el campo.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ValueVariable


ID_VERRIEG_PROP31

Interne ID: ID_VERRIEG_PROP31

Utilizar Qualifier of Command

Sólo disponible si tiene la licencia de Energy Edition.

Puede añadir información adicional a los comandos (Qualifier of Command) cuando el driver sea compatilble. Drivers compatibles: IEC850, IEC870 y DNP3.

activado: Activa la entrada bajo Qualifier of Command.

Observación: Solo disponible con las acciones de comando Comando auto/remoto, Comando Pulso y Comando obligatorio.

Por defecto: Desactivado

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UseQOC


ID_VERRIEG_PROP32

Interne ID: ID_VERRIEG_PROP32

Qualifier of Command

Introduzca un valor numérico que se envíe como parámetro de comando al driver. Según el driver, se analizará de forma distinta.

  • IEC850: Los valores 0 - 3 se introducirán para los comandos en el campo Check sino, serán ignorados.
  • IEC870: Los valores 0 - 31 se introducirán para los comandos en el campo QU sino, serán ignorados.
  • DNP3: El valor 1 para el comando significa Pulsar, en otro caso Cerrojo.

Mínimo: 00
Máximo: 127
Por defecto:: 0

Observación: Esta entrada solo estará disponible si Utilizar Qualifier of Command está activado.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

QOC


ID_VERRIEG_PROP33

Interne ID: ID_VERRIEG_PROP33

Nombre:

Parte libremente definible del nombre de un interbloqueo.

Si se introduce aquí un nombre, la denominación completa estará formada por: Nombre:: Vínculo lógico, por ejemplo: Nombre: X03 no reconocido AND X02.

Si se introduce ningún nombre aquí, la denominación completa estará formada automáticamente por: Condición <Index>: Vínculo lógico, por ejemplo: Condición 01: X03 no reconocido AND X02.

Por defecto: Condición <Index>

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_VERRIEG_PROP34

Interne ID: ID_VERRIEG_PROP34

ID del menú

ID de la acción. El ID de menú se utilizará para crear Menús contextuales en el runtime. Cuando dos acciones tienen el mismo ID se marcarán en el árbol de acciones con un símbolo especial. Con la compilación se comprobará que el mismo valor de comando se utilice solo una vez por variable.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CmdMenuID


ID_VERRIEG_PROP35

Interne ID: ID_VERRIEG_PROP35

Variable de interbloqueo

Variable que se puede utilizar para la condición de interbloqueo. Haciendo clic sobre el botón ... se puede intercambiar la variable sin tener que ajustar la fórmula.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_VERRIEG_PROP_DEL

Interne ID: ID_VERRIEG_PROP_DEL

{Eliminar condición}

Se eliminará la condición.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Delete


ID_VERRIEG_PROP_GRP0

Interne ID: ID_VERRIEG_PROP_GRP0

General

Propiedades generales para el interbloqueo o comandos.

Más en el manual online sobre la creación de un:

- Interbloqueo

- Comando

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_VERRIEG_PROP_GRP4

Interne ID: ID_VERRIEG_PROP_GRP4

Pantalla de comandos

Propiedades para la pantalla de comandos.

Observación: Si se activa el tipo de acción Comando auto/remoto las propiedades del grupo Pantalla de comandos no serán modificables.

Pantalla de comandos

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Picture


ID_VERRIEG_PROP_GRP5

Interne ID: ID_VERRIEG_PROP_GRP5

Opciones

Propiedades para las opciones de comandos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Options


ID_VERRIEG_PROP_GRP6

Interne ID: ID_VERRIEG_PROP_GRP6

Configuraciones de acción

Propiedades para las configuraciones de acción de comandos.

Observaciones:

  • El tipo de acción Comando auto/remoto no es compatible con autorizaciones. El grupo de propiedades Autorización se ocultará.
  • El tipo de acción Bloqueo no es compatible con condiciones. Las condiciones que se puedan haber proyectado no tendrán efecto durante el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_VERRIEG_PROP_GRP7

Interne ID: ID_VERRIEG_PROP_GRP7

Variable

Propiedades para las variables de interbloqueo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_VERRIEG_PROP_GRP8

Interne ID: ID_VERRIEG_PROP_GRP8

Condición

Propiedades para las condiciones de interbloqueo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_VERRIEG_PROP_GRP9

Interne ID: ID_VERRIEG_PROP_GRP9

Autorización

Contiene propiedades para establecer los niveles de autorización para interbloquear y desbloquear.
Observación: Si se activa el tipo de acción Comando auto/remoto se ocultará la autorización para el grupo de propiedades.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Rights


ID_VERRIEG_PROP_GRP10

Interne ID: ID_VERRIEG_PROP_GRP10

Procesamiento de estado

Configuraciones para el procesamiento de estado de los comandos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StatusHandling


ID_VERRIEG_PROP_GRP11

Interne ID: ID_VERRIEG_PROP_GRP11

Pantalla de comandos

Configuraciones para la pantalla de comandos en el comando.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CommandScreen


ID_VERRIEG_PROP_NEW

Interne ID: ID_VERRIEG_PROP_NEW

{Condición nueva}

Se creará una nueva condición.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

New


ID_VORSCHAU

Interne ID: ID_VORSCHAU

Vista previa

Abre un diálogo para sustituir los vínculos. Las modificaciones en la vista previa se aplicarán a las propiedades Fuente y Destino y al contrario.
Disponible para símbolos y faceplates. Solo estará activado para símbolos cuando ya exista un vínculo con el símbolo, para el contenedor de faceplates solo cuando haya una pantalla vinculada al contenedor.

Más en el manual online bajo Símbolos y Faceplates.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Preview


ID_WORKSPACE_PROP_MSGCTRL

Interne ID: ID_WORKSPACE_PROP_MSGCTRL

MessageControl

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MessageControl


ID_WORKSPACE_PROP_PATH

Interne ID: ID_WORKSPACE_PROP_PATH

Archivo del área de trabajo

Nombre y sitio donde se guarda el archivo del área de trabajo. Solo ver.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Workspacepath


ID_WORKSPACE_PROPS_GRP

Interne ID: ID_WORKSPACE_PROPS_GRP

Área de trabajo

Contiene propiedades para el área de trabajo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Arbeitsbereich


ID_WPF_CONNECTION_DOUBLEVALUE

Interne ID: ID_WPF_CONNECTION_DOUBLEVALUE

Valor

Entrada de un valor numérico para la variable vinculada. Solo disponible si la propiedad Valor de cadena está desactivada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Value


ID_WPF_CONNECTION_ISSTRING

Interne ID: ID_WPF_CONNECTION_ISSTRING

Valor de cadena

Elegir si el valor vinculado es un valor numérico o un valor de cadena.

  • Activado: Valor de cadena

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

IsString


ID_WPF_CONNECTION_UNIT

Interne ID: ID_WPF_CONNECTION_UNIT

Unidad

Unidad de medida utilizada. Seleccionar de la lista desplegable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Unit


ID_WPF_CONNECTION_USEVALUEADJUST

Interne ID: ID_WPF_CONNECTION_USEVALUEADJUST

Convertir rango de valores

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UseValueAdjust


ID_WPF_CONNECTION_VALUE

Interne ID: ID_WPF_CONNECTION_VALUE

Valor de cadena

Entrada para el valor de cadena. Solo disponible si la propiedad Valor de cadena está activada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StringValue


ID_WPF_CONNECTION_VALUEMAX

Interne ID: ID_WPF_CONNECTION_VALUEMAX

Máximo

Valor para el máximo de las variables configuradas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Max


ID_WPF_CONNECTION_VALUEMIN

Interne ID: ID_WPF_CONNECTION_VALUEMIN

Mínimo

Valor para el mínimo de las variables configuradas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Min


ID_WRONGPW

Interne ID: ID_WRONGPW

Número máximo de errores de usuario

Número de las entradas permitidas de un nombre de usuario no existente.
Si se sobrepasa ese número el sistema se bloquea. Ningún usuario podrá registrase con excepción de los administradores. Cuando un administrador se registre el sistema se desbloqueará automáticamente. Se creará una entrada correspondiente en la lista cronológica de eventos (CEL). Los cambios de este valor no serán efectivos en el runtime hasta que no se reinicie.

  • Mínimo: 0
  • Máximo: 65535

Por defecto: 3

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserTries


ID_WRONGUSER

Interne ID: ID_WRONGUSER

Número máximo de errores de contraseña

Número de las entradas permitidas de una contraseña errónea.
Si se sobrepasa ese número se bloqueará al usuario. Este bloqueo solo se puede quitar por un administrador. Se creará la entrada correspondiente el la lista cronológica de eventos (CEL).

  • Mínimo: 0
  • Máximo: 65535

Por defecto: 3

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PasswordTries


ID_ZEITSTG_PROP1

Interne ID: ID_ZEITSTG_PROP1

Nombre:

Nombre de la función de tiempo.
Por defecto: Función de tiempo x (x corresponde a un número sucesivo).

ATENCIÓN: Esta propiedad no está disponible para el cambio de idioma.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_ZEITSTG_PROP2

Interne ID: ID_ZEITSTG_PROP2

Función

Función que se ejecutará controlada por tiempo .
Abre el diálogo de selección de funciones.
.Si se debe ejecutar más de una función se deberá crear un script con las funciones deseadas y vincular aquí la función para ejecutar el script.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Function


ID_ZEITSTG_PROP3

Interne ID: ID_ZEITSTG_PROP3

Activado

Activado: La función de tiempo se ejecutará en el runtime.
Desactivado: La función de tiempo no se ejecutará en el runtime.
Por defecto: activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Active


ID_ZEITSTG_PROP4

Interne ID: ID_ZEITSTG_PROP4

Tipo de ejecución

A partir ese día: La función se ejecutará a partir del día programado todos los días a la hora programada.
solo ese día: La función se ejecutará una vez el día programado a la hora programada.
cíclico a partir de ese día: La función se ejecutará a partir del día programado con el intervalo cíclico definido.
cíclico solo este día: La función se ejecutará solo el día de la semana programado con el intervalo cíclico definido.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Type


ID_ZEITSTG_PROP5

Interne ID: ID_ZEITSTG_PROP5

Momento de inicio

Fecha en la que o a partir de la cual se deberá ejecutar la función de tiempo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ExecuteDate


ID_ZEITSTG_PROP7

Interne ID: ID_ZEITSTG_PROP7

Intervalo

Intervalo de tiempo con el que se ejecutará la reacción.
Por defecto: 00:15:00.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Interval


ID_ZEITSTG_PROP8

Interne ID: ID_ZEITSTG_PROP8

Intervalo un mes

Solo disponible si para la propiedad Tipo de ejecución se ha seleccionado el valor cíclico.
Activado: La función se ejecutará con un intervalo de un mes al cambiar el mes.
Desactivado: Se utilizarán las otras configuraciones para ejecutar la función.
Por defecto: Desactivado

Observación: Los cambios de mes o año se refieren a la fecha de ejecución configurada y no al cambio concreto de 01. 01. 00:00 horas. Si el cambio se ha de ejecutar exactamente en ese momento, habrá que configurar la proyección para ese momento p. ej. 01. 01. 2012 00:00:00 horas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Monthly


ID_ZEITSTG_PROP9

Interne ID: ID_ZEITSTG_PROP9

Intervalo un año

Solo disponible si para la propiedad Tipo de ejecución se ha seleccionado el valor cíclico.
Activado: La función se ejecutará con un intervalo de un año al cambiar el año.
Desactivado: Se utilizarán las otras configuraciones para ejecutar la función.
Por defecto: Desactivado

Observación: Los cambios de mes o año se refieren a la fecha de ejecución configurada y no al cambio concreto de 01. 01. 00:00 horas. Si el cambio se ha de ejecutar exactamente en ese momento, habrá que configurar la proyección para ese momento p. ej. 01. 01. 2012 00:00:00 horas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Yearly


ID_ZEITSTG_PROP10

Interne ID: ID_ZEITSTG_PROP10

Lunes

Activado: La función se ejecutará (también) los lunes.
Desactivado: La función no se ejecutará los lunes.
Por defecto: activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Monday


ID_ZEITSTG_PROP11

Interne ID: ID_ZEITSTG_PROP11

Martes

Activado: La función se ejecutará (también) los martes.
Desactivado: La función no se ejecutará los martes.
Por defecto: activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Tuesday


ID_ZEITSTG_PROP12

Interne ID: ID_ZEITSTG_PROP12

Miércoles

Activado: La función se ejecutará (también) los miércoles.
Desactivado: La función no se ejecutará los miércoles.
Por defecto: activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Wednesday


ID_ZEITSTG_PROP13

Interne ID: ID_ZEITSTG_PROP13

Jueves

Activado: La función se ejecutará (también) los jueves.
Desactivado: La función no se ejecutará los jueves.
Por defecto: activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Thursday


ID_ZEITSTG_PROP14

Interne ID: ID_ZEITSTG_PROP14

Viernes

Activado: La función se ejecutará (también) los viernes.
Desactivado: La función no se ejecutará los viernes.
Por defecto: activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Friday


ID_ZEITSTG_PROP15

Interne ID: ID_ZEITSTG_PROP15

Sábado

Activado: La función se ejecutará (también) los sábados.
Desactivado: La función no se ejecutará los sábados.
Por defecto: activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Saturday


ID_ZEITSTG_PROP16

Interne ID: ID_ZEITSTG_PROP16

Domingo

Activado: La función se ejecutará (también) los domingos.
Desactivado: La función no se ejecutará los domingos.
Por defecto: activado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Sunday


ID_ZEITSTG_PROP_GRP0

Interne ID: ID_ZEITSTG_PROP_GRP0

General

Propiedades generales para la función de tiempo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_TimeFct


ID_ZEITSTG_PROP_GRP1

Interne ID: ID_ZEITSTG_PROP_GRP1

Configuraciones de tiempo

Configuraciones de tiempo para la función.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Timeadj


ID_ZEITSTG_PROP_GRP3

Interne ID: ID_ZEITSTG_PROP_GRP3

Triggerzeitpunkte

Solo con el tipo de ejecución cíclico:
Selección del cambio de mes o año.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:


ID_ZEITSTG_PROP_GRP4

Interne ID: ID_ZEITSTG_PROP_GRP4

Dias de ejecución

Selección del día(s) en el(los) que se ejecutará la función.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ExecutionDays


ID_ZUWEIS_PROP1

Interne ID: ID_ZUWEIS_PROP1

Nombre:

Nombre unívoco de la asignación.
Por defecto: Asignación x (x corresponde a un número sucesivo).

ATENCIÓN: Esta propiedad no está disponible para el cambio de idioma.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_ZUWEIS_PROP2

Interne ID: ID_ZUWEIS_PROP2

Variable de origen

Nombre de la variable cuyo valor se asignará a la variable de destino.
Abre el diálogo de selección de las variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SourceVariable


ID_ZUWEIS_PROP3

Interne ID: ID_ZUWEIS_PROP3

Variable de destino

Nombre de la variable cuyo valor se asignará a la variable de origen.
Abre el diálogo de selección de las variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TargetVariable


ID_ZUWEIS_PROP4

Interne ID: ID_ZUWEIS_PROP4

Variable desencadenante

La variable bit vinculada aquí activa la asignación. Si no hay ninguna variable vinculada la asignación funcionará de manera espontánea. Lo cual quiere decir, que siempre que se modifique el valor de la variable de origen dicho valor se escribirá automáticamente en la variable de destino.
Abre el diálogo de selección de las variables filtrado para variables bit.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TriggerVariable


ID_ZUWEIS_PROP5

Interne ID: ID_ZUWEIS_PROP5

Tipo de desencadenador

Borde: La asignación se ejecutará cuando el valor de la variable de disparo vinculada cambie de 0 a 1.
Nivel: La asignación se ejecutará mientras el valor de la variable de disparo vinculada sea 1.
Por defecto: Borde.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TriggerType


ID_ZUWEIS_PROP_GRP0

Interne ID: ID_ZUWEIS_PROP_GRP0

General

Propiedades generales para la asignación.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_ZW_PROP_ABFRAGE

Interne ID: ID_ZW_PROP_ABFRAGE

Variable de lectura del contador

Variable para escaneos del contador

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

QueryPV


ID_ZW_PROP_AUSGANGABS

Interne ID: ID_ZW_PROP_AUSGANGABS

Salida de tipo de contador: absoluto

Salida como valor absoluto

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OutputAbs


ID_ZW_PROP_AUSGANGREL

Interne ID: ID_ZW_PROP_AUSGANGREL

Salida de tipo de contador: relativo

Representación como valor realtivo.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OutputRel


ID_ZW_PROP_EINGANGABS

Interne ID: ID_ZW_PROP_EINGANGABS

Entrada de tipo de contador

Valor absoluto o relativo

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InputAbs


ID_ZW_PROP_GRP0

Interne ID: ID_ZW_PROP_GRP0

General

Con las siguientes propiedades establece las propiedades del valor de la matriz de reacción.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


ID_ZW_PROP_MAXWERT

Interne ID: ID_ZW_PROP_MAXWERT

Contenido máximo del contador

Estado máximo del contador

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxCount


ID_ZW_PROP_NAHANDLING

Interne ID: ID_ZW_PROP_NAHANDLING

Tratamiento NA

Modo para procesamiento "no actualizado" (Valor fuera del periodo)

Cambiar a INVALID-Bit: El valor se tomará como inválido

Cambio al valor de reserva: El valor se establecerá como valor de sustitución parametrizado

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NAHandling


ID_ZW_PROP_NAME

Interne ID: ID_ZW_PROP_NAME

Descripción

Nombre del grupo de contadores

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


ID_ZW_PROP_NUMBER

Interne ID: ID_ZW_PROP_NUMBER

ID

Número interno del grupo de contadores

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Number


ID_ZW_PROP_OFFSET

Interne ID: ID_ZW_PROP_OFFSET

Offset [s]

Tiempo en segundos después del inicio para el primer escaneo

Así se garantizará que la conexión sea correcta.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Offset


ID_ZW_PROP_OVHANDLING

Interne ID: ID_ZW_PROP_OVHANDLING

Tratamiento OV

Comportamiento al exceder el valor absoluto o la gradiente.

Cambiar a INVALID-Bit: El valor se tomará como inválido

Cambio al valor de reserva: El valor se establecerá como valor de sustitución parametrizado

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OVHandling


ID_ZW_PROP_TARIF

Interne ID: ID_ZW_PROP_TARIF

Variable para el código de tarifa

Variable de control para identificación de tarifas

Asignación a estados de aplicación 1...8

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TariffPV


ID_ZW_PROP_TIMEOUT

Interne ID: ID_ZW_PROP_TIMEOUT

Ventana de tiempo [s]

Timeout para test completo.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Timeout


ID_ZW_PROP_TRIGGER

Interne ID: ID_ZW_PROP_TRIGGER

Variable desencadenante

Desde el momento del escaneo hasta el término del periodo: 1

Sino: 0

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TriggerPV


ID_ZW_PROP_ZYKLUSZEIT

Interne ID: ID_ZW_PROP_ZYKLUSZEIT

Tiempo cíclico de grupos [s]

Tiempo del ciclo en segundos para escaneos del contador

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CycleTime


IDD_VARVERWALTUNG5

Interne ID: IDD_VARVERWALTUNG5

Nombre:

Nombre del tipo de dato. La longitud está limitada a 128 caracteres.
Atención: Esta propiedad no está disponible para el cambio de idioma.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


IDP_3TFORM_EDITOR

Interne ID: IDP_3TFORM_EDITOR

Utilización de áreas

Determine los efectos que tendrá el elemento creado para la plantilla.

Configuraciones posibles:

Cubriente: La superficie del elemento se utilizará como área de la pantalla

Cortante: La superficie del elemento se suprimirá de la de las superficies por debajo

Con disjunción lógica: Dependiendo de si encuentra o no una superficie cubriente bajo el elemento, quedará cortado o cubierto

Observación: La utilización de la superficie se refiere siempre a la superficie por debajo de elemento.

Para los elementos nuevos creados se utilizará la última configuración seleccionada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Combine


IDP_AMISTS_DEVICE

Interne ID: IDP_AMISTS_DEVICE

AMISTS device

Se puede introducir tanto un dispositivo como un dispositivo de conmutación de potencia. Éste tendrá que encontrarse en la base de datos del servidor de transacciones.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AMISTSDevice


IDP_AMISTS_LSDGROUP

Interne ID: IDP_AMISTS_LSDGROUP

AMISTS load switch group

Para programas de conmutación se especificará aquí el grupo de dispositivos de conmutación de potencia.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AMISTSLSGroup


IDP_AMISTS_REFERENCE

Interne ID: IDP_AMISTS_REFERENCE

AMISTS reference

A través de aquí se establecerá la conexión entre las variables y el servidor de transacciones correspondiente tal y como esté parametrizado en la configuración del driver.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AMISTSReference


IDP_AMISTS_RELAYADDRESS

Interne ID: IDP_AMISTS_RELAYADDRESS

AMISTS relayAddress

Para un dispositivo de conmutación de potencia se especificará aquí el relé correspondiente en valores de 1 a 5. Para un solo dispositivo no es relevante esta información.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AMISTSRelayNumber


IDP_AMISTS_RELAYPROGRAM

Interne ID: IDP_AMISTS_RELAYPROGRAM

AMISTS relayProgram

Aquí se introducirá un programa de conmutación. Éste tendrá que ejecutarse en el bloque 17 de la parametrización del servidor de transacciones.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AMISTSLSDProgram


IDP_AML_BACKCOLOR_STATE

Interne ID: IDP_AML_BACKCOLOR_STATE

Color de fondo

Color de fondo para la barra de estado de alarmas. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: #FF0000

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColorOfState


IDP_AML_BACKCOLOR_STATE1

Interne ID: IDP_AML_BACKCOLOR_STATE1

Mensaje 1 color de fondo

Color de fondo para el mensaje 1. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: #0000FF

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColorOfState1


IDP_AML_BACKCOLOR_STATE2

Interne ID: IDP_AML_BACKCOLOR_STATE2

Mensaje 2 color de fondo

Color de fondo para el mensaje 2. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: #0000FF

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColorOfState2


IDP_AML_BACKCOLOR_STATE3

Interne ID: IDP_AML_BACKCOLOR_STATE3

Mensaje 3 color de fondo

Color de fondo para el mensaje 3. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: #0000FF

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColorOfState3


IDP_AML_LONGLIMITS

Interne ID: IDP_AML_LONGLIMITS

Textos largos dinámicos de valor límite AML

Define si el campo para comentarios está disponible para textos dinámicos de valor límite. El texto del valor límite dinámico permite insertar valores actuales de otras variables en el texto del valor límite de una variable.

  • Desactivado: El campo para comentarios se está utilizando para textos dinámicos de valor límite y está bloqueado para comentarios. Longitud máxima: 80 caracteres.
  • Activado: Se permiten comentarios y textos dinámicos de valores límites. Los contenidos dinámicos se guardarán en un archivo bajo el nombre convencional de D*.AML. Adicionalmente se guardarán en el archivo A*.AML. El campo para comentarios se puede utilizar así para comentarios. Los textos dinámicos de valor límite pueden contener un máximo de 254 caracteres.

Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlarmLongDynLimits


IDP_AML_TEXTCOLOR_STATE

Interne ID: IDP_AML_TEXTCOLOR_STATE

Color de texto

Color del texto para la barra de estado de alarmas. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: #000000

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextColorOfState


IDP_AML_TEXTCOLOR_STATE1

Interne ID: IDP_AML_TEXTCOLOR_STATE1

Mensaje 1 color de texto

Color de fondo para el mensaje 1. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: #FFFFFF

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextColorOfState1


IDP_AML_TEXTCOLOR_STATE2

Interne ID: IDP_AML_TEXTCOLOR_STATE2

Mensaje 2 color de texto

Color de fondo para el mensaje 2. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: #FFFFFF

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextColorOfState2


IDP_AML_TEXTCOLOR_STATE3

Interne ID: IDP_AML_TEXTCOLOR_STATE3

Mensaje 3 color de texto

Color de fondo para el mensaje 3. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: #FFFFFF

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextColorOfState3


IDP_BATCH_ACTION_ALLOC_GRP

Interne ID: IDP_BATCH_ACTION_ALLOC_GRP

Asignar parámetros

Contiene propiedades para la asignación de parámetros.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActAllocGrp


IDP_BATCH_ACTION_CEL_CLASS

Interne ID: IDP_BATCH_ACTION_CEL_CLASS

Clase

Asignación de una Clase de alarmas/eventos ya existente a los mensajes CEL para el evento seleccionado. Seleccionar de la lista desplegable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CelClass


IDP_BATCH_ACTION_CEL_GROUP

Interne ID: IDP_BATCH_ACTION_CEL_GROUP

Grupo

Asignación de un Grupo de alarmas/eventos ya existente a los mensajes CEL para el evento seleccionado. Seleccionar de la lista desplegable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CelGroup


IDP_BATCH_ACTION_CELACTIVE

Interne ID: IDP_BATCH_ACTION_CELACTIVE

Crear entrada CEL

Activado: El texto definido en la propiedad Texto de mensaje CEL se anotará en la CEL.

La entrada se generará en la lista CEL en el servidor con el usuario registrado en ese momento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActCelEn


IDP_BATCH_ACTION_CELMSG

Interne ID: IDP_BATCH_ACTION_CELMSG

Texto de mensaje CEL

Solo disponible si la propiedad Crear entrada CEL está activada.

Texto que se anotará en la CEL. Puede contener palabras clave del cambio de idioma.

Máximo: 512 caracter

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActCelMsg


IDP_BATCH_ACTION_DESCR

Interne ID: IDP_BATCH_ACTION_DESCR

Descripción

Entrada de texto libre para describir el evento seleccionado.
La descripción no estará visible durante el runtime y solo vale para el editor.
Máximo: 512 caracter

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActDescr


IDP_BATCH_ACTION_DESTTAG

Interne ID: IDP_BATCH_ACTION_DESTTAG

Parámetro de destino

Sólo disponible si hay un Parámetro de origen seleccionado.

Parámetro al que se transmitirá el valor del parámetro seleccionado en la propiedad Parámetro de origen. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un parámetro. Sólo se ofrecerán parámetros del tipo correspondiente. Si se renombra el parámetro el cambio de nombre se aplicará automáticamente

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActDestTag


IDP_BATCH_ACTION_FUNC

Interne ID: IDP_BATCH_ACTION_FUNC

Función

Función que deberá ser ejecutada. Haciendo clic sobre el botón ... se abre un diálogo de selección.

Se puede seleccionar una función del proyecto local o de otro proyecto. El proyecto y la función tienen que estar disponibles durante el runtime. Si se renombra la función el cambio de nombre se aplicará automáticamente.

En el runtime se comprobará durante la validación si la función existe.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActFunc


IDP_BATCH_ACTION_FUNCTION_GRP

Interne ID: IDP_BATCH_ACTION_FUNCTION_GRP

Función

Contiene una propiedad para seleccionar la función.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActFuncGrp


IDP_BATCH_ACTION_GENERAL_GRP

Interne ID: IDP_BATCH_ACTION_GENERAL_GRP

General

Contiene propiedades generales para eventos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActGeneral


IDP_BATCH_ACTION_LOG_GRP

Interne ID: IDP_BATCH_ACTION_LOG_GRP

Entrada CEL

Contiene propiedades para entradas en CEL y en los archivos LOG.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActLogGrp


IDP_BATCH_ACTION_LOGMSG

Interne ID: IDP_BATCH_ACTION_LOGMSG

Texto de mensaje log

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActLogMsg


IDP_BATCH_ACTION_LOGMSG_EN

Interne ID: IDP_BATCH_ACTION_LOGMSG_EN

Crear entrada log

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActLogEn


IDP_BATCH_ACTION_PRIO

Interne ID: IDP_BATCH_ACTION_PRIO

Orden de ejecución

Muestra el orden de ejecución cuando para el mismo evento hay varias reacciones definidas. El orden de ejecución se determinará por la posición en la lista definida. El orden de ejecución se puede modificar en la lista a través de la barra de símbolos o el menú contextual del evento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActPrio


IDP_BATCH_ACTION_REACTION_GRP

Interne ID: IDP_BATCH_ACTION_REACTION_GRP

Reacciones

Contiene propiedades para reacciones.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActSetTagGrp


IDP_BATCH_ACTION_RECIPE_GRP

Interne ID: IDP_BATCH_ACTION_RECIPE_GRP

Influencia de recetas

Contiene propiedades para el modo de ejecución y comando.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActRecipeGrp


IDP_BATCH_ACTION_RESCMD

Interne ID: IDP_BATCH_ACTION_RESCMD

Comando

Receta o comando de función básica que se ejecutará durante el runtime cuando se produzca el evento. Los comandos de receta influyen en la ejecución de toda la receta. Los comandos de función básica influyen solo en la función básica para la que se haya configurado la reacción o para la que se produzca el evento. El comando de receta o el comando de función básica solo se ejecutará durante el runtime cuando el comando esté igualmente permitido. Por ejemplo: Una receta no podrá continuar cuando esté detenida. Una función básica no podrá reiniciarse cuando la función básica esté pausada en el runtime o esté ejecutándose.

Observación: La validación de la receta en el runtime no comprueba la plausibilidad de los comandos de función básica o los comandos de receta.

Selección del comando de la lista desplegable:

  • Detener función básica
  • Continuar función básica
  • Reiniciar función básica
  • Pausar función básica
  • Ignorar
  • Interrumpir receta
  • Detener receta
  • Continuar receta
  • Reiniciar receta
  • Pausar receta
  • Parar receta

Por defecto: Ignorar

Observación: Solo se puede establecer un comando por evento. Para todos los demás eventos del mismo tipo, la propiedad se establecerá automáticamente comoIgnorar. También para Activar "Finalizar runtime" la propiedad se establecerá automáticamente como Ignorar. Si se modifica el Evento esta configuración se podrá establecer también en Ignorar.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActResCmd


IDP_BATCH_ACTION_RESCMDMODE

Interne ID: IDP_BATCH_ACTION_RESCMDMODE

Modo

Mediante esta reacción se puede controlar en el runtime el modo de ejecución como reacción al evento.

Selección del modo de ejecución de la lista desplegable:

  • Automático
  • Semiautomático
  • Ignorar
  • Manual

Por defecto: Ignorar

Observación: Solo se puede establecer el modo de ejecución una vez por evento. Para todos los demás eventos del mismo tipo, el modo se establecerá automáticamente como Ignorar. También para Activar "Finalizar runtime" el modo se establecerá automáticamente como Ignorar. Si se cambia el Evento a un evento para el que ya haya una reacción configurada para el modo de ejecución, la reacción al modo de ejecución del evento modificado se establecerá como Ignorar. Si todavía no hay ninguna reacción para el modo de ejecución para el nuevo evento, se mantendrá la reacción del modo de ejecución. Excepción: "Finalizar runtime" activado

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActResCmdMode


IDP_BATCH_ACTION_SETTAG

Interne ID: IDP_BATCH_ACTION_SETTAG

Parámetro

Parámetro en el que se escribirá el valor predefinido como reacción al evento. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un parámetro. Reglas para la selección de parámetros:

  • Solo se pueden seleccionar parámetros de la función básica que a la que pertenezca la reacción.
  • Se pueden seleccionar tanto parámetros de respuesta como de comando.
  • Si se renombra un parámetro el cambio de nombre se aplicará automáticamente.
  • El valor predeterminado del parámetro se puede introducir dependiendo del tipo de dato del parámetro.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActSetTag


IDP_BATCH_ACTION_SETTAG_BO

Interne ID: IDP_BATCH_ACTION_SETTAG_BO

Valor boolenao

Solo estará disponible si en la propiedad Parámetro se ha seleccionado un parámetro del tipo Binario.

Valor predeterminado para un parámetro binario. Seleccionar de la lista desplegable:

  • Off (0)
  • On (1)
  • Bascular: cambia el estado
    Al iniciar la función básica se consultará el valor y se escribirá invertido en la reacción. Si no se recibe ningún valor válido se puede reaccionar con la reacción "Variable vinculada defectuosa".

Por defecto: Off (0)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActSetTBool


IDP_BATCH_ACTION_SETTAG_DUR

Interne ID: IDP_BATCH_ACTION_SETTAG_DUR

Duración

Solo estará disponible si en la propiedad parámetros se ha seleccionado un Parámetro del tipo Duración.

Valor predeterminado en días, horas, minutos y segundos para parámetros del tipo Duración. El lapso de tiempo se escribirá como valor en segundos en la variable vinculada al parámetro.

  • Valor máximo: 0T 00:00:00
  • Valor mínimo: 9999T 23:59:59
  • Por defecto: 0T 00:00:00

Por ejemplo: 30 minutos y 5 segundos = 1805

En el runtime se comprobará durante la validación de la receta si el valor en segundos se encuentra dentro de los límites mínimos/máximos de la variable vinculada al parámetro.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActSetTDuration


IDP_BATCH_ACTION_SETTAG_GRP

Interne ID: IDP_BATCH_ACTION_SETTAG_GRP

Parámetro establecer valor predeterminado

Contiene propiedades para parámetros de Establecer valor predeterminado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActReactGrp


IDP_BATCH_ACTION_SETTAG_MEUNIT

Interne ID: IDP_BATCH_ACTION_SETTAG_MEUNIT

Tag Einheit

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActSetTagMeUnit


IDP_BATCH_ACTION_SETTAG_NUM

Interne ID: IDP_BATCH_ACTION_SETTAG_NUM

Valor numérico

Solo estará disponible si en la propiedad Parámetro se ha seleccionado un parámetro del tipo Numérico.

Valor predeterminado para parámetros del tipo Numérico.
Se puede definir un número entero positivo o negativo o un número con coma flotante que como reacción se escribirá en el parámetro.

En el runtime se comprobará durante la validación de la receta si el valor se encuentra dentro de los límites mínimos/máximos de la variable vinculada al parámetro.

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActSetTNum


IDP_BATCH_ACTION_SETTAG_STR

Interne ID: IDP_BATCH_ACTION_SETTAG_STR

Valor de cadena

Solo estará disponible si en la propiedad Parámetro se ha seleccionado un parámetro del tipo Cadena.

Valor predeterminado para parámetros del tipo Cadena.

Durante el runtime al validar la receta se comprobará si el largo del valor de cadena es menor que la Longitud de cadena máxima de la variable de cadena vinculada al parámetro.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActSetTStr


IDP_BATCH_ACTION_SRCTAG

Interne ID: IDP_BATCH_ACTION_SRCTAG

Parámetro de origen

Parámetro cuyo valor se aplicará al parámetro seleccionado en la propiedad Parámetro de destino. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un parámetro.

Al iniciar la función básica durante el runtime se consultará el valor de la variable vinculado al parámetro de origen. Si no se recibe ningún valor válido se puede reaccionar con la reacción "Variable vinculada defectuosa". Si se renombra el parámetro el cambio de nombre se aplicará automáticamente.

Durante el runtime al validar la receta se comprobará si el Parámetro de destino existe y si las variables vinculadas al parámetro son válidas y del tipo correcto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActSrcTag


IDP_BATCH_ACTION_TYPE

Interne ID: IDP_BATCH_ACTION_TYPE

Evento

Selección del tipo de evento con el que se ejecutará la reacción de la lista desplegable.
Para cada elemento se pueden definir varias reacciones. El orden de ejecución se puede establecer en la vista de detalle.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchActType


IDP_BATCH_CEL_CLASS_CMD

Interne ID: IDP_BATCH_CEL_CLASS_CMD

Clase para comandos

Asignación de una Clase de alarmas/eventos ya existente a los mensajes CEL para comandos. Seleccionar de la lista desplegable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ClassCmd


IDP_BATCH_CEL_CLASS_JUMP_FORCE_STEP

Interne ID: IDP_BATCH_CEL_CLASS_JUMP_FORCE_STEP

Clase para Jump/Force/Step

Asignación de una Clase de alarmas/eventos ya existente a los mensajes CEL para saltar, forzar y ejecutar paso a paso. Seleccionar de la lista desplegable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ClassStep


IDP_BATCH_CEL_CLASS_RECIPE

Interne ID: IDP_BATCH_CEL_CLASS_RECIPE

Clase para manejo de recetas

Asignación de una Clase de alarmas/eventos ya existente a los mensajes CEL para el manejo de recetas. Seleccionar de la lista desplegable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ClassRecipe


IDP_BATCH_CEL_CLASS_VALUE

Interne ID: IDP_BATCH_CEL_CLASS_VALUE

Clase para cambiar valores

Asignación de una Clase de alarmas/eventos ya existente a los mensajes CEL para cambios de valores. Seleccionar de la lista desplegable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ClassValue


IDP_BATCH_CEL_GROUP_CMD

Interne ID: IDP_BATCH_CEL_GROUP_CMD

Grupo para comandos

Asignación de un Grupo de alarmas/eventos ya existente a los mensajes CEL para comandos. Seleccionar de la lista desplegable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GroupCmd


IDP_BATCH_CEL_GROUP_JUMP_FORCE_STEP

Interne ID: IDP_BATCH_CEL_GROUP_JUMP_FORCE_STEP

Grupo para Jump/Force/Step

Asignación de un Grupo de alarmas/eventos ya existente a los mensajes CEL para saltar, forzar y ejecutar paso a paso. Seleccionar de la lista desplegable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GroupStep


IDP_BATCH_CEL_GROUP_RECIPE

Interne ID: IDP_BATCH_CEL_GROUP_RECIPE

Grupo para el manejo de recetas

Asignación de un Grupo de alarmas/eventos ya existente a los mensajes CEL para el manejo de recetas. Seleccionar de la lista desplegable.

Más en la Ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GroupRecipe


IDP_BATCH_CEL_GROUP_VALUE

Interne ID: IDP_BATCH_CEL_GROUP_VALUE

Gruppo para cambio de valores

Asignación de un Grupo de alarmas/eventos ya existente a los mensajes CEL para cambios de valores. Seleccionar de la lista desplegable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GroupValue


IDP_BATCH_CELGROUPCLASS_GRP

Interne ID: IDP_BATCH_CELGROUPCLASS_GRP

Grupos/clases de eventos CEL

Contiene propiedades para la asignación de grupos y clases para mensajes CEL a recetas, comandos, cambios de valores, saltar, forzar y ejecutar paso a paso.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CELGroupClass


IDP_BATCH_COMMUNICATION_FAILURE

Interne ID: IDP_BATCH_COMMUNICATION_FAILURE

Acción en caso de interrupción de la comunicación

Configuración de la reacción en casos de interrupción en la comunicación. Seleccionar de la lista desplegable:

  • Detener función básica
  • Pausar función básica

Las condiciones para el reconocimiento de interrupciones en la comunicación se definirán en las funciones básicas con la propiedad Interrupción de la comunicación.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CommunicationFailureAction


IDP_BATCH_COMMUNICATION_FAILURE_GRP

Interne ID: IDP_BATCH_COMMUNICATION_FAILURE_GRP

Interrupción de la comunicación

Propiedades para la reacción en casos de interrupción en la comunicación. Las condiciones para el reconocimiento de interrupciones en la comunicación se definirán en las funciones básicas con la propiedad Interrupción de la comunicación.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CommunicationFailure


IDP_BATCH_CS_DESCRIPTION

Interne ID: IDP_BATCH_CS_DESCRIPTION

Descripción

Texto libre para describir la estrategia de control.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Description


IDP_BATCH_CS_GENERAL_GRP

Interne ID: IDP_BATCH_CS_GENERAL_GRP

General

Contiene propiedades para la configuración de las estrategias de control.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


IDP_BATCH_CS_IDENTIFIER

Interne ID: IDP_BATCH_CS_IDENTIFIER

Número de estrategia de control

Número único de la estrategia de control para identificarla dentro de esta función básica.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Identifier


IDP_BATCH_CS_NAME

Interne ID: IDP_BATCH_CS_NAME

Nombre:

Nombre de la estrategia de control.

El nombre:

  • tiene que ser único dentro de la función básica.
  • no debe estar vacío
  • no debe contener puntos
  • no puede contener únicamente espacios en blanco
  • puede tener como máximo 256 caracteres

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


IDP_BATCH_EVENT_EXECUTE_STARTUP

Interne ID: IDP_BATCH_EVENT_EXECUTE_STARTUP

Permitir ejecución antes de iniciar el evento

Activado: El evento se puede ejecutar antes del evento Función básica iniciada.

Desactivado: El evento no se podrá ejecutar hasta que no haya ejecutado el evento Función básica iniciada.

Solo configurable para eventos que sean posibles tanto antes como después de la Función básica iniciada. Para todos los demás eventos el valor se establecerá automáticamente dependiendo de su tipo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ExecuteBeforeStartEvent


IDP_BATCH_EXECUTION_AFTER_RESTART_GRP

Interne ID: IDP_BATCH_EXECUTION_AFTER_RESTART_GRP

Acción al reiniciar el runtime

Propiedades para definir acciones al reiniciar el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ExecutionAfterRestart


IDP_BATCH_GLOB_CYCLETIME

Interne ID: IDP_BATCH_GLOB_CYCLETIME

Tiempo de ciclo [s]

Tiempo en segundos para el ciclo dentro del cual se creará una nueva imagen.

  • Mínimo: 30 s
  • Máximo: 4294967295 s

Por defecto: 30 s

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CycleTime


IDP_BATCH_GLOB_CYCLEWRITEACTIVE

Interne ID: IDP_BATCH_GLOB_CYCLEWRITEACTIVE

Activar escritura cíclica

Activado: Se escribirá una imagen cíclicamente según el tiempo configurado en la propiedad Tiempo de ciclo [s].

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CyclicWriteActive


IDP_BATCH_GLOB_CYCLICIMAGE_GROUP

Interne ID: IDP_BATCH_GLOB_CYCLICIMAGE_GROUP

Imagen de receta

Contiene propiedades para escribir la imagen de forma cíclica.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CyclicImage


IDP_BATCH_GLOB_EXPLANATION_NEEDED

Interne ID: IDP_BATCH_GLOB_EXPLANATION_NEEDED

Se requiere un motivo para cambiar el valor

Activado: Para realizar modificaciones de valores durante el runtime el usuario tiene que introducir un motivo para la modificación. Antes de ejecutar la modificación aparecerá un diálogo para introducir el motivo. Esta configuración se aplica para todo el módulo de Modul Batch Control y no se podrá modificar de forma local para recetas o funciones básicas individuales.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ExplanationNeeded


IDP_BATCH_GLOB_JOBVARIABLE

Interne ID: IDP_BATCH_GLOB_JOBVARIABLE

Variable de tarea

Selección de las variables de tarea. Haciendo clic sobre el botón ... se abre un diálogo para elegir una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

JobVariable


IDP_BATCH_GLOB_JOBVARIABLE_APPLYTYPE

Interne ID: IDP_BATCH_GLOB_JOBVARIABLE_APPLYTYPE

Aplicar valor de la variable de tarea en

Selección de la lista desplegable de cuándo tendrá efecto el valor de la variable de tarea:

  • Crear receta de control
  • Iniciar receta de control

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

JobVariableApplyType


IDP_BATCH_GLOB_JOBVARIABLE_GRP

Interne ID: IDP_BATCH_GLOB_JOBVARIABLE_GRP

Variable de tarea

Grupo para las propiedades de las variables de tarea.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

JobVariableGrp


IDP_BATCH_GLOB_SETVALUE_GRP

Interne ID: IDP_BATCH_GLOB_SETVALUE_GRP

Editar parámetros

Propiedades para editar parámetros durante el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ParamChange


IDP_BATCH_GLOB_WRITE_TIMEOUT

Interne ID: IDP_BATCH_GLOB_WRITE_TIMEOUT

Tiempo de espera para escritura protegida

Timeout para la escritura segura en segundos.

Mínimo: 10 s
Máximo: 3600 s
Por defecto: 20 s

El tiempo de espera se aplica a la suma de de todos los tiempos de espera para la escritura segura de los parámetros de control: La espera de los valores para todos los parámetros que se vayan a escribir junto con la espera de la confirmación de los parámetros escritos junto con la espera de la lectura de las variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WriteTimeout


IDP_BATCH_GLOB_WRITE_VARS

Interne ID: IDP_BATCH_GLOB_WRITE_VARS

Escritura protegida

Grupo para propiedades para la escritura segura.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WriteVars


IDP_BATCH_GLOB_WRITEIMAGE_ONPHASEACTIVATION

Interne ID: IDP_BATCH_GLOB_WRITEIMAGE_ONPHASEACTIVATION

Escribir imagen de receta al activar una función básica

Activado: Cada vez que se active una función básica se escribirá una imagen.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WriteImageOnPhaseActivation


IDP_BATCH_JOBVARIABLE_LIST

Interne ID: IDP_BATCH_JOBVARIABLE_LIST

Variable de tarea individual

Selección de variables de tarea individuales. Se pueden asignar individualmente mediante una función. Haciendo clic sobre el botón ... se abre un diálogo para elegir una o varias variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

JobVariableList


IDP_BATCH_KBD_BOOL

Interne ID: IDP_BATCH_KBD_BOOL

Parámetro binario

Configuración del teclado para la entrada de parámetros binarios. Haciendo clic sobre el botón ... se abre un diálogo para elegir una pantalla del tipo Teclado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BoolKbd


IDP_BATCH_KBD_NUM

Interne ID: IDP_BATCH_KBD_NUM

Parámetros numéricos

Configuración del teclado para la entrada de parámetros numéricos. Haciendo clic sobre el botón ... se abre un diálogo para elegir una pantalla del tipo Teclado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NumKbd


IDP_BATCH_KBD_SPAN

Interne ID: IDP_BATCH_KBD_SPAN

Parámetros de duracións

Configuración del teclado para la entrada de parámetros de duración. Haciendo clic sobre el botón ... se abre un diálogo para elegir una pantalla del tipo Teclado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SpanKbd


IDP_BATCH_KBD_STRING

Interne ID: IDP_BATCH_KBD_STRING

Parámetro cadena

Configuración del teclado para la entrada de parámetros de cadena. Haciendo clic sobre el botón ... se abre un diálogo para elegir una pantalla del tipo Teclado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StringKbd


IDP_BATCH_MR_GENERAL_GRP

Interne ID: IDP_BATCH_MR_GENERAL_GRP

GRP_General

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


IDP_BATCH_OP_GENERAL_GRP

Interne ID: IDP_BATCH_OP_GENERAL_GRP

GRP_General

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


IDP_BATCH_PHASE_ABORTING_CND

Interne ID: IDP_BATCH_PHASE_ABORTING_CND

Cancelado

Condición para cambiar de cancelando a cancelado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AbortingCnd


IDP_BATCH_PHASE_CHECK_TRANS_STARTUP

Interne ID: IDP_BATCH_PHASE_CHECK_TRANS_STARTUP

Prüfe Transientbedingungen vor Start Event

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CheckTransCndBeforeStartEvent


IDP_BATCH_PHASE_CONTROLSTRATEGIES_ACTIVE

Interne ID: IDP_BATCH_PHASE_CONTROLSTRATEGIES_ACTIVE

Estrategias de control activadas

Activado: Las estrategias de control están permitidas para esta función básica. Por debajo de la función básica se ocultará el nodo Estrategias de control para configurar las estrategias de control.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ControlStrategiesActive


IDP_BATCH_PHASE_CONTROLSTRATEGIES_GRP

Interne ID: IDP_BATCH_PHASE_CONTROLSTRATEGIES_GRP

Estrategias de control

Contiene propiedades para activar las estrategias de control.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ControlStrategies


IDP_BATCH_PHASE_CONTROLSTRATEGIES_TAG

Interne ID: IDP_BATCH_PHASE_CONTROLSTRATEGIES_TAG

Parámetro de estrategia de control

Solo disponible si la propiedad Estrategias de control activadas está activada.

Vínculo de un parámetro de comando numérico. El cual definirá la estrategia de control que se activará en la ejecución.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ControlStrategiesTag


IDP_BATCH_PHASE_DESCRIPTION

Interne ID: IDP_BATCH_PHASE_DESCRIPTION

Descripción

Cadena libremente definible para describir más detalladamente la función básica. La descripción se puede cambiar de un idioma a otro.

Longitud máxima: 512 caracteres

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Description


IDP_BATCH_PHASE_DONE

Interne ID: IDP_BATCH_PHASE_DONE

Condición de conmutación

Define la condición de conmutación. Haciendo clic sobre el botón ... o sobre la entrada se abre el Editor de fórmulas para definir una condición.
La condición se puede mostrar durante el runtime pero no se puede modificar. El periodo de tiempo que se espera a que se cumpla la condición se define con la propiedad Duración máxima ejecución.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Done


IDP_BATCH_PHASE_ERROR_PLC

Interne ID: IDP_BATCH_PHASE_ERROR_PLC

Error-PLC

Introducción de la fórmula para el reconocimiento de errores PLC. Haciendo clic sobre el botón ... se abre un diálogo para configurar la fórmula.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PlcError


IDP_BATCH_PHASE_ESCAPING

Interne ID: IDP_BATCH_PHASE_ESCAPING

Condición de salida

Condición para salir de una función básica.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Escaping


IDP_BATCH_PHASE_EXPLANATION_NEEDED

Interne ID: IDP_BATCH_PHASE_EXPLANATION_NEEDED

Se requiere un motivo para modificar la duración mínima de la ejecución

Activado: Para realizar modificaciones de valores de esta función básica durante el runtime el usuario tiene que introducir un motivo para la modificación. Antes de ejecutar la modificación aparecerá un diálogo para introducir el motivo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ExplanationMinExecTimeNeeded


IDP_BATCH_PHASE_FAILURE

Interne ID: IDP_BATCH_PHASE_FAILURE

Interrupción de la comunicación

Introducción de la fórmula para el reconocimiento de interrupciones en la comunicación. Haciendo clic sobre el botón ... se abre un diálogo para configurar la fórmula.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Failure


IDP_BATCH_PHASE_FAILURE_GRP

Interne ID: IDP_BATCH_PHASE_FAILURE_GRP

Interrupción de la comunicación

Propiedades par el reconocimiento de interrupciones en la comunicación.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GPR_Failure


IDP_BATCH_PHASE_GENERAL_GRP

Interne ID: IDP_BATCH_PHASE_GENERAL_GRP

General

Propiedades generales de la función básica.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


IDP_BATCH_PHASE_HOLDING_CND

Interne ID: IDP_BATCH_PHASE_HOLDING_CND

Detenido

Condición para cambiar de deteniendo a detenido.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HoldingCnd


IDP_BATCH_PHASE_INTERLOCKING

Interne ID: IDP_BATCH_PHASE_INTERLOCKING

Interbloqueo de entrada

Define la condición para el interbloqueo de entrada. Haciendo clic sobre el botón ... o la entrada se abre el editor de fórmulas para definir una condición.
Si se configura un interbloqueo de entrada la función básica no se ejecutará durante el runtime hasta que se cumpla la condición para el interbloqueo de entrada. La fórmula puede consistir en uno o varios parámetros de comando y parámetros de respuesta de la función básica. Se pueden utilizar el valor y el estado de las variables. La fórmula produce como resultado TRUE o FALSE. La condición se puede mostrar durante el runtime pero no será modificable.
El tiempo de espera para el interbloqueo de entrada se configurará con la propiedad Tiempo de espera del interbloqueo de entrada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Interlocking


IDP_BATCH_PHASE_MINEXECTIME

Interne ID: IDP_BATCH_PHASE_MINEXECTIME

Duración mínima ejecución

Tiempo de ejecución mínimo de la función básica.

  • >0: Periodo de tiempo mínimo después de escribir los parámetros de comando que se esperará con independencia de que se cumpla la condición de conmutación.
  • 0: No se comprobará el tiempo de ejecución.

La duración mínima de la ejecución puede sobrepasar el Duración máxima ejecución.

El tiempo de espera seguirá corriendo sin interrumpirse con independencia del estado de la receta (por ej. también con Pausar receta) y también al finalizar y reiniciar el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MinExecTime


IDP_BATCH_PHASE_NAME

Interne ID: IDP_BATCH_PHASE_NAME

Nombre:

Nombre de la función básica. Deberá ser unívoco para cada agregado. El nombre no puede contener puntos, ni estar formado solo por espacios en blanco ni estar vacío. El nombre se puede cambiar de un idioma a otro.
Por defecto: Función básica x (x corresponde a un número sucesivo).

Longitud máxima: 256 caracteres

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


IDP_BATCH_PHASE_PARENT_UNIT_DESCRIPTION

Interne ID: IDP_BATCH_PHASE_PARENT_UNIT_DESCRIPTION

Descripción del agregado

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UnitDescription


IDP_BATCH_PHASE_PARENT_UNIT_NAME

Interne ID: IDP_BATCH_PHASE_PARENT_UNIT_NAME

Agregado

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Unit


IDP_BATCH_PHASE_PAUSING_CND

Interne ID: IDP_BATCH_PHASE_PAUSING_CND

Pausado

Condición para cambiar de pausando a pausado.
Para la condición se puede definir una Fórmula. La fórmula puede consistir en uno o varios parámetros de comando y parámetros de respuesta de la función básica. Se pueden utilizar el valor y el estado de las variables.
Opción: Para la validez de la función básica se pueden vincular variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PausingCnd


IDP_BATCH_PHASE_RECOVER

Interne ID: IDP_BATCH_PHASE_RECOVER

Interrupción de la comunicación reconocida

Introducción de la fórmula para reconocer cuando se ha restablecido la comunicación después de una interrupción. Haciendo clic sobre el botón ... se abre un diálogo para configurar la fórmula.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Recover


IDP_BATCH_PHASE_RESTARTING_CND

Interne ID: IDP_BATCH_PHASE_RESTARTING_CND

Reiniciado

Condición para cambiar de iniciando a funcionando.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RestartingCnd


IDP_BATCH_PHASE_STOPPING_CND

Interne ID: IDP_BATCH_PHASE_STOPPING_CND

Parado

Condición para cambiar de parando a parado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StoppingCnd


IDP_BATCH_PHASE_TOALLOCATION

Interne ID: IDP_BATCH_PHASE_TOALLOCATION

Tiempo de espera de asignación de agregado

Tiempo en días, horas, minutos y segundos que se esperará a la asignación del agregado. El tiempo de espera se puede modificar durante el runtime mientras que la receta se encuentre en el estado editable.

Una vez terminado el tiempo definido se desencadenará el evento Tiempo de espera a la asignación del agregado excedido y el elemento se representará resaltado. Las acciones posteriores deberán ser definidas por el ingeniero del proyecto. Si no se producen otras acciones se continuará esperando.

Máximo: 9999T 23:59:59
Por defecto: 0T 00:00:00

Observación: A cada agregado solo se le puede asignar una sola receta con el estado En ejecución.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ToAllocation


IDP_BATCH_PHASE_TODONE

Interne ID: IDP_BATCH_PHASE_TODONE

Duración máxima ejecución

Duración en días, horas, minutos y segundos en que la condición definida en la propiedad Condición de conmutación tiene que restituir el valor TRUE. El tiempo de espera comienza a contar al escribir los parámetros de comando. Si dentro del tiempo de espera no se cumple la condición se desencadenará el evento Tiempo de ejecución máximo excedido y se seguirá esperando. Si no se ha definido ninguna reacción para el evento que cause otro comportamiento, se seguirá esperando hasta que se cumpla la condición.

Observación: El tiempo sigue contando cuando la receta/la función básica se ponen en pausa.

Si se configurará como tiempo de espera 0T 00:00:00 no se desencadenará el evento.

  • Valor mínimo: 0T 00:00:00
  • Valor máximo: 9999T 23:59:59
  • Por defecto: 0T 00:00:00

El tiempo de espera seguirá corriendo sin interrumpirse con independencia del estado de la receta (por ej. también con Pausar receta) y también al finalizar y reiniciar el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ToDone


IDP_BATCH_PHASE_TOINTERLOCK

Interne ID: IDP_BATCH_PHASE_TOINTERLOCK

Tiempo de espera del interbloqueo de entrada

Duración en días, horas, minutos y segundos en que la condición definida en la propiedad Interbloqueo de entrada tiene que restituir el valor TRUE. El tiempo de espera comienza a contar al empezar a comprobar el interbloqueo de entrada Si dentro del tiempo de espera no se cumple la condición se desencadenará el evento Tiempo de espera excedido para la condición de conmutación y se seguirá esperando. Si no se ha definido ninguna reacción para el evento que cause otro comportamiento, se seguirá esperando hasta que se cumpla la condición.

Si se configurará como tiempo de espera 0T 00:00:00 no se desencadenará el evento.

  • Valor mínimo: 0T 00:00:00
  • Valor máximo: 9999T 23:59:59
  • Por defecto: 0T 00:00:00

El tiempo de espera seguirá corriendo sin interrumpirse con independencia del estado de la receta (por ej. también con Pausar receta) y también al finalizar y reiniciar el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ToInterlocking


IDP_BATCH_PHASE_TOPHASEEND

Interne ID: IDP_BATCH_PHASE_TOPHASEEND

Tiempo de espera de la condición siguiente

Tiempo en días, horas, minutos y segundos en el que se deberá desactivar la función básica. El tiempo de espera comienza a correr cuando se cumpla la condición de conmutación. Si dentro del tiempo de espera no se cumple la condición se desencadenará el evento Tiempo de espera excedido para la siguiente condición de conmutación y se seguirá esperando. Si no se ha definido ninguna reacción para el evento que cause otro comportamiento, se seguirá esperando hasta que se cumpla la condición.

Si se configurará como tiempo de espera 0T 00:00:00 no se desencadenará el evento.

  • Valor mínimo: 0T 00:00:00
  • Valor máximo: 9999T 23:59:59
  • Por defecto: 0T 00:00:00

Observación: La existencia de condiciones siguientes depende de la estructura de la receta. Es mejor que la configuración de un tiempo de espera se realice en el runtime y no en el editor.

El tiempo de espera seguirá corriendo sin interrumpirse con independencia del estado de la receta (por ej. también con Pausar receta) y también al finalizar y reiniciar el runtime.

Más en la ayuda online en el capítulo Tiempos.
Más en la ayuda online en el capítulo Condición siguiente.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ToPhaseEnd


IDP_BATCH_PHASE_TRANS_CND_GRP

Interne ID: IDP_BATCH_PHASE_TRANS_CND_GRP

Condiciones de estado transiente

Grupo con propiedades para las condiciones de transición.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GPR_TransCnd


IDP_BATCH_PHASE_USER_GRP

Interne ID: IDP_BATCH_PHASE_USER_GRP

Función básica de usuario

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_User


IDP_BATCH_PHASE_USERFKT

Interne ID: IDP_BATCH_PHASE_USERFKT

Función

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserPFunc


IDP_BATCH_PHASE_USERMSG

Interne ID: IDP_BATCH_PHASE_USERMSG

Texto de mensaje

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserPMsg


IDP_BATCH_PHASE_USERPHASE

Interne ID: IDP_BATCH_PHASE_USERPHASE

Función básica de usuario

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserPhase


IDP_BATCH_PHASE_USERTIMEOUT

Interne ID: IDP_BATCH_PHASE_USERTIMEOUT

Tiempo de espera de la operación

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UserPTimeout


IDP_BATCH_RECIPE_FRAME_GRP

Interne ID: IDP_BATCH_RECIPE_FRAME_GRP

Mostrar elementos de control del editor

Contiene propiedades para los elementos de manejo en el editor de recetas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Appearance


IDP_BATCH_RECIPE_FRAME_PN

Interne ID: IDP_BATCH_RECIPE_FRAME_PN

Ventana acoplable

Activado: En el editor de recetas se mostrará la lista de las ventanas acoplables.

Desactivado: En el editor de recetas se oculatrá la lista de ventanas acoplables.

Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WithPanes


IDP_BATCH_RECIPE_FRAME_TB

Interne ID: IDP_BATCH_RECIPE_FRAME_TB

Barras de herramientas

Activado: En el editor de recetas se mostrarán las barras de símbolos.

Desactivado: En el editor de recetas se ocultarán las barras de símbolos. Se recomienda cuando se hayan configurado acciones de símbolos individuales sobre botones propios.

Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WithTBs


IDP_BATCH_RESTART_AFTER_FAILURE

Interne ID: IDP_BATCH_RESTART_AFTER_FAILURE

Reiniciar después de una caída del sistema

Definición de la acción al reiniciar después de que el runtime haya sido finalizado de forma irregular a causa de una caída del sistema.

Seleccionar de la lista desplegable:

  • Detener receta: Después del reinicio se detendrá toda la receta.
  • Pausar receta: Después del reinicio se pausará toda la receta.
  • Mantener estado de receta: Después del reinicio la receta tendrá el mismo estado que antes de la finalización.

Por defecto: Mantener estado de receta

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RestartAfterFailure


IDP_BATCH_RESTART_AFTER_RTEND

Interne ID: IDP_BATCH_RESTART_AFTER_RTEND

Reiniciar después de una finalización normal del runtime

Definición de la acción al reiniciar después de que el runtime haya sido finalizado de forma normal.

Seleccionar de la lista desplegable:

  • Detener receta: Después del reinicio se detendrá toda la receta.
  • Pausar receta: Después del reinicio se pausará toda la receta.
  • Mantener estado de receta: Después del reinicio la receta tendrá el mismo estado que antes de la finalización.

Por defecto: Mantener estado de receta

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RestartAfterRTEnd


IDP_BATCH_SINGLEVERSIONAPPROVED

Interne ID: IDP_BATCH_SINGLEVERSIONAPPROVED

Liberar solo una versión

Activado: Durante el runtime se puede liberar solo una nueva versión por cada receta maestra.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SingleVersionApproved


IDP_BATCH_TAG_DATATYPE

Interne ID: IDP_BATCH_TAG_DATATYPE

Tipo de dato de parámetros

Selección del tipo de dato de la lista desplegable para el tipo de parámetro seleccionado en la la propiedad Tipo . Se puede elegir como tipo de dato:

  • Binario: datos binarios
  • Numérico: datos numéricos
  • Cadena: Secuencia de caracteres.
  • Duración: Duración

La selección del tipo de dato influirá en las propiedades disponibles del grupo Escribir valor predeterminado.

Observación: El tipo de dato del parámetro se puede seguir modificando incluso después de que tenga una variable vinculada y se haya definido un valor para el parámetro de comando. Lo cual puede dar lugar a errores al validar la receta en el runtime.

Atención: Para estrategias de control solo se puede ver. Solo será posible hacer modificaciones en la función básica.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DataType


IDP_BATCH_TAG_DEFVALUE

Interne ID: IDP_BATCH_TAG_DEFVALUE

Valor parámetros

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DefValue


IDP_BATCH_TAG_DEFVALUE_BOOL

Interne ID: IDP_BATCH_TAG_DEFVALUE_BOOL

Valor binario

Solo disponible cuando en el grupo General se haya establecido la propiedad Tipo como Comando y se haya establecido la propiedad Tipo de dato de parámetros como Binario.

Valor para el parámetro de comando binario. Selección de la lista desplegable:
Off(0):
On (1):
Bascular: cambia el estado

Por defecto: Off (0)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DefValueBool


IDP_BATCH_TAG_DEFVALUE_MEUNIT

Interne ID: IDP_BATCH_TAG_DEFVALUE_MEUNIT

Einheit

Unidad para el valor.

Se aplicará de la variable vinculada a la propiedad Variable (General/Vinculación de la variable). Solo para ver, no se puede modificar aquí.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DefValueMeUnit


IDP_BATCH_TAG_DEFVALUE_NUM

Interne ID: IDP_BATCH_TAG_DEFVALUE_NUM

Valor numérico

Solo disponible cuando en el grupo General se haya establecido la propiedad Tipo como Comando y se haya establecido la propiedad Tipo de dato de parámetros como Numérica.

Valor para el parámetro de comando numérico.

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DefValueNum


IDP_BATCH_TAG_DEFVALUE_STR

Interne ID: IDP_BATCH_TAG_DEFVALUE_STR

Valor de cadena

Serie de caracteres que se utilizará para el valor del parámetro.
Solo disponible si en el grupo General se ha establecido la propiedad General como Comando y la propiedad Tipo de dato de parámetros como Cadena .

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DefValueStr


IDP_BATCH_TAG_DEFVALUE_TIME

Interne ID: IDP_BATCH_TAG_DEFVALUE_TIME

Valor temporal

Solo disponible cuando en el grupo General se haya establecido la propiedad Tipo como Comando y se haya establecido la propiedad Tipo de dato de parámetros como Duración.

Duración en días, horas, minutos y segundos para el parámetro de comando Duración.

Valor máximo: 0T 00:00:00

Valor mínimo: 9999T 23:59:59

Por defecto: 0T 00:00:00

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DefValueTime


IDP_BATCH_TAG_DESCRIPTION

Interne ID: IDP_BATCH_TAG_DESCRIPTION

Descripción

Texto libre para describir más detalladamente el parámetro. Durante el runtime se puede cambiar el idioma del texto y se mostrará en el diálogo para editar la función básica y en el diálogo para editar los parámetros.

Máximo: 512 caracter

Atención: Para estrategias de control solo se puede ver. Solo será posible hacer modificaciones en la función básica.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Description


IDP_BATCH_TAG_EXPLANATION_NEEDED

Interne ID: IDP_BATCH_TAG_EXPLANATION_NEEDED

Se requiere un motivo para cambiar el valor

Activado: Para poder realizar cambios en el valor de este parámetro durante el runtime el usuario deberá introducir un motivo para la modificación. Antes de ejecutar la modificación aparecerá un diálogo para introducir el motivo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ExplanationNeeded


IDP_BATCH_TAG_GENERAL_GRP

Interne ID: IDP_BATCH_TAG_GENERAL_GRP

General

Propiedades generales para parámetros.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


IDP_BATCH_TAG_KBD

Interne ID: IDP_BATCH_TAG_KBD

Representación del teclado

Solo disponible si la propiedad Utilizar representación del teclado está activada.

Selección de la pantalla conectable del tipo Teclado. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar una pantalla.

Atención: Para estrategias de control solo se puede ver. Solo será posible hacer modificaciones en la función básica.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Keyboard


IDP_BATCH_TAG_KBD_LAYOUT

Interne ID: IDP_BATCH_TAG_KBD_LAYOUT

Teclados

Grupo de propiedades para modificar parámetros utilizando teclados.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Keyboard


IDP_BATCH_TAG_KBD_USAGE

Interne ID: IDP_BATCH_TAG_KBD_USAGE

Utilizar representación del teclado

Activado: Para este parámetro se utilizará un teclado virtual. La pantalla conectable del tipo Teclado se define con la propiedad Representación del teclado.

Sólo disponible si Modificable en la receta maestra está activado.

Por defecto: desactivado.

Atención: Para estrategias de control solo se puede ver. Solo será posible hacer modificaciones en la función básica.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UseKeyboard


IDP_BATCH_TAG_MATERIAL

Interne ID: IDP_BATCH_TAG_MATERIAL

Seguimiento del material

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Material


IDP_BATCH_TAG_MAX

Interne ID: IDP_BATCH_TAG_MAX

Parámetro máximo

Solo disponible cuando en el grupo General se haya establecido la propiedad Tipo como Comando y se haya establecido la propiedad Tipo de dato de parámetros como Numérica.

Valor máximo para el parámetro.

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Max


IDP_BATCH_TAG_MIN

Interne ID: IDP_BATCH_TAG_MIN

Parámetro mínimo

Solo disponible cuando en el grupo General se haya establecido la propiedad Tipo como Comando y se haya establecido la propiedad Tipo de dato de parámetros como Numérica.

Valor mínimo para el parámetro.

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Min


IDP_BATCH_TAG_NAME

Interne ID: IDP_BATCH_TAG_NAME

Nombre:

Nombre del parámetro. Tiene que ser unívoco dentro de la función básica. El nombre no puede estar vacío, ni contener puntos, ni consistir únicamente en espacios en blanco. Distinguir mayúsculas/minúsculas Durante el runtime se puede cambiar el idioma del nombre y se mostrará en el diálogo para editar la función básica y en el diálogo para editar los parámetros.

Máximo: 256 caracter

Por defecto: Parámetro x, x será un número sucesivo otorgado automáticamente para garantizar un nombre unívoco.

Atención: Para estrategias de control solo se puede ver. Solo será posible hacer modificaciones en la función básica.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


IDP_BATCH_TAG_PARAMCHANGE_GRP

Interne ID: IDP_BATCH_TAG_PARAMCHANGE_GRP

Editar parámetros

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_ParamEdit


IDP_BATCH_TAG_PARENT_PHASE

Interne ID: IDP_BATCH_TAG_PARENT_PHASE

Función básica

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Phase


IDP_BATCH_TAG_PARENT_UNIT

Interne ID: IDP_BATCH_TAG_PARENT_UNIT

Agregado

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Unit


IDP_BATCH_TAG_RECIPEPARAM

Interne ID: IDP_BATCH_TAG_RECIPEPARAM

Modificable en la receta maestra

Solo disponible cuando en el grupo General se haya establecido la propiedad Tipo como Comando.

Activado: El creador de recetas puede modificar los parámetros durante el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RecipeParam


IDP_BATCH_TAG_TAGTYPE

Interne ID: IDP_BATCH_TAG_TAGTYPE

Tipo

Selección del tipo de parámetro de la lista desplegable:

  • Inicial: Parámetro de comando que se escribirá antes del evento inicial.
    Valor: Parámetro de comando que se escribirá después del interbloqueo de entrada. El valor definido para el parámetro de comando se escribirá durante la ejecución de la función básica en la variable vinculada con el parámetro de comando.
  • Respuesta: Parámetros de respuesta. Los parámetros de respuesta se pueden describir durante el runtime mediante reacciones.

Durante el runtime al validar la receta para parámetros de comando se comprobará si:

  • existe una variable vinculada y es del tipo correcto
  • el valor del parámetro de comando se encuentra dentro de los límites predefinidos de las variables vinculadas
  • en la función básica existe solo un parámetro de comando por variable (evita que un parámetro de comando describa la variable p. ej. con 0 y otro parámetro de comando la describa con 1)

Atención: Para estrategias de control solo se puede ver. Solo será posible hacer modificaciones en la función básica.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TagType


IDP_BATCH_TAG_TIME_MAX

Interne ID: IDP_BATCH_TAG_TIME_MAX

Tiempo máx. variable

Máximo para el Valor duración de una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxTime


IDP_BATCH_TAG_TIME_MIN

Interne ID: IDP_BATCH_TAG_TIME_MIN

Tiempo mín. variable

Mínimo para el Valor duración de una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MinTime


IDP_BATCH_TAG_VALUE_MAX

Interne ID: IDP_BATCH_TAG_VALUE_MAX

Valor máx.

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ValueMax


IDP_BATCH_TAG_VALUE_MIN

Interne ID: IDP_BATCH_TAG_VALUE_MIN

Valor mín.

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ValueMin


IDP_BATCH_TAG_VALUES_GRP

Interne ID: IDP_BATCH_TAG_VALUES_GRP

Escribir valor predeterminado

Grupo para propiedades para escribir el valor predeterminado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Values


IDP_BATCH_TAG_VAR_ACTVALUE

Interne ID: IDP_BATCH_TAG_VAR_ACTVALUE

Variable de valor actual

La variable vinculada representa el valor actual del parámetro. El valor de la variable se mostrará durante el runtime en las listas de parámetros para una función básica seleccionada.

Atención: Para estrategias de control solo se puede ver. Solo será posible hacer modificaciones en la función básica.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ActValueVar


IDP_BATCH_TAG_VAR_DATENART

Interne ID: IDP_BATCH_TAG_VAR_DATENART

Tipo de dato de la variable

Tipo de dato de la variable. Solo ver.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VarDataType


IDP_BATCH_TAG_VAR_MAX

Interne ID: IDP_BATCH_TAG_VAR_MAX

Valor máximo de la variable

Valor máximo de la variable. Solo ver.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VarMax


IDP_BATCH_TAG_VAR_MIN

Interne ID: IDP_BATCH_TAG_VAR_MIN

Valor mínimo de la variable

Valor mínimo de la variable. Solo ver.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VarMin


IDP_BATCH_TAG_VAR_STRLENGTH

Interne ID: IDP_BATCH_TAG_VAR_STRLENGTH

Longitud de cadena

Largo de cadena igual al proyectado en la variable. Solo ver

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VarStrLength


IDP_BATCH_TAG_VAR_TREIBER

Interne ID: IDP_BATCH_TAG_VAR_TREIBER

Driver

Nombre del archivo EXE del driver de la variable. Solo ver.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VarDriver


IDP_BATCH_TAG_VAR_TREIBERBEZ

Interne ID: IDP_BATCH_TAG_VAR_TREIBERBEZ

Descripción del driver

Nombre del driver de la variable. Solo ver.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VarDriverDesc


IDP_BATCH_TAG_VAR_UNIT

Interne ID: IDP_BATCH_TAG_VAR_UNIT

Unidad

Unidad de la variable. Solo ver.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VarUnit


IDP_BATCH_TAG_VARIABLE

Interne ID: IDP_BATCH_TAG_VARIABLE

Variable

Variable vinculada con el parámetro. Haciendo clic sobre el botón ... se abre el diálogo de selección de variables.

Variablen werden dabei abhängig vom gewählten Tipo de dato de parámetros gefiltert angezeigt. Se puede seleccionar una variable del proyecto local o de otro proyecto. La variable y el proyecto tienen que estar disponibles también durante el runtime. Si se renombra la variable el cambio de nombre se aplicará automáticamente.

Atención: Para estrategias de control solo se puede ver. Solo será posible hacer modificaciones en la función básica.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variable


IDP_BATCH_TAG_VARIABLE_GRP

Interne ID: IDP_BATCH_TAG_VARIABLE_GRP

Vinculación de la variable

Propiedades para vincular variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Variable


IDP_BATCH_TAG_VARIATIONMAX

Interne ID: IDP_BATCH_TAG_VARIATIONMAX

Abweichung positiv

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VariationMax


IDP_BATCH_TAG_VARIATIONMIN

Interne ID: IDP_BATCH_TAG_VARIATIONMIN

Abweichung negativ

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VariationMin


IDP_BATCH_UNIT_DESCRIPTION

Interne ID: IDP_BATCH_UNIT_DESCRIPTION

Descripción

Cadena libremente definible para describir más detalladamente el agregado. Esta descripción está disponible durante el runtime en el diálogo de selección de la función básica. La descripción se puede cambiar de idioma.

Longitud máxima: 512 caracteres

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Description


IDP_BATCH_UNIT_GENERAL_GRP

Interne ID: IDP_BATCH_UNIT_GENERAL_GRP

General

Propiedades generales del agregado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


IDP_BATCH_UNIT_NAME

Interne ID: IDP_BATCH_UNIT_NAME

Nombre:

Nombre del agregado. El nombre debe ser unívoco para cada proyecto. El nombre no puede contener puntos, ni estar formado solo por espacios en blanco, ni estar vacío. El nombre se puede cambiar de un idioma a otro.

Por defecto: Agregado x (x corresponde a un número sucesivo).

Longitud máxima: 256 caracteres

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


IDP_BATCH_UNIT_RT_CR_DESCR

Interne ID: IDP_BATCH_UNIT_RT_CR_DESCR

Descripción

Configuración de las variables que transmiten durante el runtime la Descripción de la receta de control. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarCrDescr


IDP_BATCH_UNIT_RT_CR_ID

Interne ID: IDP_BATCH_UNIT_RT_CR_ID

ID

Configuración de las variables que transmiten durante el runtime el ID de la receta de control. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarCrId


IDP_BATCH_UNIT_RT_CR_JOBID

Interne ID: IDP_BATCH_UNIT_RT_CR_JOBID

Número de tarea (Texto)

Configuración de las variables que transmiten como texto durante el runtime el número de tarea de la receta de control. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarCrJobId


IDP_BATCH_UNIT_RT_CR_NAME

Interne ID: IDP_BATCH_UNIT_RT_CR_NAME

Nombre:

Configuración de las variables que transmiten durante el runtime el Nombre de la receta de control. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarCrName


IDP_BATCH_UNIT_RT_ERR_NUM

Interne ID: IDP_BATCH_UNIT_RT_ERR_NUM

Fehler (numerisch)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarErrorNum


IDP_BATCH_UNIT_RT_ERR_TXT

Interne ID: IDP_BATCH_UNIT_RT_ERR_TXT

Fehler (Text)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarErrorTxt


IDP_BATCH_UNIT_RT_FAILURE_COUNT

Interne ID: IDP_BATCH_UNIT_RT_FAILURE_COUNT

Número de interrupciones de comunicación activas

Configuración de las variables que muestran durante el runtime el número de interrupciones en la comunicación reconocidas. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para elegir una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarCommErrorCount


IDP_BATCH_UNIT_RT_FAILURE_FIXED_COUNT

Interne ID: IDP_BATCH_UNIT_RT_FAILURE_FIXED_COUNT

Número de interrupciones de comunicación solucionadas

Configuración de las variables que muestran durante el runtime el número de interrupciones en la comunicación solucionadas. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para elegir una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarCommErrorGoneCount


IDP_BATCH_UNIT_RT_FAILURE_RECOVERED_COUNT

Interne ID: IDP_BATCH_UNIT_RT_FAILURE_RECOVERED_COUNT

Número de interrupciones de comunicación reconocidas

Configuración de las variables que muestran durante el runtime el número de interrupciones en la comunicación reconocidas. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para elegir una variable.
Durante el runtime se mostrará el número de interrupciones en la comunicación reconocidas hasta que se finalice la receta en la que hayan ocurrido.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarCommErrorAcknCount


IDP_BATCH_UNIT_RT_GRP

Interne ID: IDP_BATCH_UNIT_RT_GRP

Información de runtime

Propiedades para las informaciones del runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RT_Info


IDP_BATCH_UNIT_RT_GRP_CR

Interne ID: IDP_BATCH_UNIT_RT_GRP_CR

Receta de control

Propiedades para la configuración de informaciones del runtime para recetas de control.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RT_CR_Info


IDP_BATCH_UNIT_RT_GRP_ERR

Interne ID: IDP_BATCH_UNIT_RT_GRP_ERR

Error

Propiedades para la configuración de informaciones del runtime para los errores que ocurran.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RT_ERR_Info


IDP_BATCH_UNIT_RT_GRP_MATRIX

Interne ID: IDP_BATCH_UNIT_RT_GRP_MATRIX

Informaciones de matriz

Grupo para propiedades con informaciones sobre las recetas matriz en el agregado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RT_Matrix_Step_Info


IDP_BATCH_UNIT_RT_GRP_MR

Interne ID: IDP_BATCH_UNIT_RT_GRP_MR

Receta maestra

Propiedades para la configuración de informaciones del runtime para recetas maestras.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RT_MR_Info


IDP_BATCH_UNIT_RT_GRP_PH

Interne ID: IDP_BATCH_UNIT_RT_GRP_PH

Funciones básicas

Propiedades para la configuración de informaciones del runtime para funciones básicas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RT_PH_Info


IDP_BATCH_UNIT_RT_GRP_REE

Interne ID: IDP_BATCH_UNIT_RT_GRP_REE

Ejecución

Propiedades para la configuración de informaciones del runtime para la ejecución (REE).

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RT_REE_Info


IDP_BATCH_UNIT_RT_MATRIX_STEP_COUNT

Interne ID: IDP_BATCH_UNIT_RT_MATRIX_STEP_COUNT

Número de pasos

Configuración de las variables en las que se escribe durante el runtime el número de pasos en la receta matriz. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable. Se pueden seleccionar todas las variables numéricas cuyo tipo de dato sea >= 2 Byte.

Para recetas PFC el valor se fijará siempre en 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarMatrixStepCount


IDP_BATCH_UNIT_RT_MATRIX_STEP_NAME

Interne ID: IDP_BATCH_UNIT_RT_MATRIX_STEP_NAME

Identificador del paso actual

Configuración de las variables para la descripción del paso matriz en el que se encuentran los objetos que se han asignado a este agregado. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Para recetas PFC el valor estará siempre vacío.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarMatrixCurrentStepName


IDP_BATCH_UNIT_RT_MATRIX_STEP_NUMBER

Interne ID: IDP_BATCH_UNIT_RT_MATRIX_STEP_NUMBER

Paso actual

Configuración de las variables para el número del paso matriz en el que se encuentran los objetos que se han asignado a este agregado. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable. Se pueden seleccionar todas las variables numéricas cuyo tipo de dato sea >= 2 Byte.

Para recetas PFC el valor será siempre 0.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarMatrixCurrentStepNumber


IDP_BATCH_UNIT_RT_MR_DESCR

Interne ID: IDP_BATCH_UNIT_RT_MR_DESCR

Descripción

Configuración de las variables que transmiten durante el runtime la Descripción de la receta maestra. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarMrDescr


IDP_BATCH_UNIT_RT_MR_ID

Interne ID: IDP_BATCH_UNIT_RT_MR_ID

ID

Configuración de las variables que transmiten durante el runtime el ID de la receta maestra. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarMrId


IDP_BATCH_UNIT_RT_MR_NAME

Interne ID: IDP_BATCH_UNIT_RT_MR_NAME

Nombre:

Configuración de las variables que transmiten durante el runtime el Nombre de la receta maestra. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarMrName


IDP_BATCH_UNIT_RT_MR_SOURCE_VERSION

Interne ID: IDP_BATCH_UNIT_RT_MR_SOURCE_VERSION

Versión inicial

Configuración de las variables que transmiten durante el runtime la versión de la receta fuente para esta versión. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarMrSourceVersion


IDP_BATCH_UNIT_RT_MR_VERSION

Interne ID: IDP_BATCH_UNIT_RT_MR_VERSION

Versión

Configuración de las variables que transmiten durante el runtime la versión de la receta maestra. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarMrVersion


IDP_BATCH_UNIT_RT_PH_LIST

Interne ID: IDP_BATCH_UNIT_RT_PH_LIST

Funciones básicas activas

Configuración de las variables que muestran durante el runtime el nombre de las funciones básicas activadas. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarPhList


IDP_BATCH_UNIT_RT_PLC_ERR_ACKN

Interne ID: IDP_BATCH_UNIT_RT_PLC_ERR_ACKN

Anzahl der quittierten Kommunikationsfehler

Configuración de las variables que muestran durante el runtime el número de interrupciones en la comunicación reconocidas. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarPlcErrorAckn


IDP_BATCH_UNIT_RT_PLC_ERR_COUNT

Interne ID: IDP_BATCH_UNIT_RT_PLC_ERR_COUNT

Anzahl der anstehenden Kommunikationsfehler

Configuración de las variables que muestran durante el runtime el número de interrupciones en la comunicación actuales. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarPlcErrorCnt


IDP_BATCH_UNIT_RT_PLC_ERR_GONE

Interne ID: IDP_BATCH_UNIT_RT_PLC_ERR_GONE

Anzahl der behobenen Kommunikationsfehler

Configuración de las variables que muestran durante el runtime el número de interrupciones en la comunicación solucionadas. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarPlcErrorGone


IDP_BATCH_UNIT_RT_PLCERROR_COUNT

Interne ID: IDP_BATCH_UNIT_RT_PLCERROR_COUNT

Número de errores-PLC existentes

Configuración de las variables que muestran durante el runtime el número de errores PLC existentes. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para elegir una variable.
Durante el runtime se mostrará el número de errores PLC existentes para la función básica activada como (0 o 1).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarInternalPlcErrorCount


IDP_BATCH_UNIT_RT_PLCERROR_FIXED_COUNT

Interne ID: IDP_BATCH_UNIT_RT_PLCERROR_FIXED_COUNT

Número de errores-PLC solucionados

Configuración de las variables que muestran durante el runtime el número de errores PLC solucionados. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para elegir una variable.
Durante el runtime se mostrará el número de errores PLC solucionados hasta que se finalice la receta en la que hayan ocurrido.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarInternalPlcErrorFixedCount


IDP_BATCH_UNIT_RT_REE_CNT

Interne ID: IDP_BATCH_UNIT_RT_REE_CNT

Número de recetas activas

Configuración de las variables que muestran durante el runtime el número de recetas activadas. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarReeCnt


IDP_BATCH_UNIT_RT_REE_MODUS_NUM

Interne ID: IDP_BATCH_UNIT_RT_REE_MODUS_NUM

Modo de ejecución (numérico)

Configuración de las variables que muestran durante el runtime el modo de ejecución de una receta como valor numérico. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarReeModusNum


IDP_BATCH_UNIT_RT_REE_MODUS_TXT

Interne ID: IDP_BATCH_UNIT_RT_REE_MODUS_TXT

Modo de ejecución (Texto)

Configuración de las variables que muestran durante el runtime el estado de ejecución de una receta como texto. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarReeModusTxt


IDP_BATCH_UNIT_RT_REE_STATUS_NUM

Interne ID: IDP_BATCH_UNIT_RT_REE_STATUS_NUM

Estado de ejecución (numérico)

Configuración de las variables que muestran durante el runtime el estado de ejecución de una receta como valor numérico. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarReeStatusNum


IDP_BATCH_UNIT_RT_REE_STATUS_TXT

Interne ID: IDP_BATCH_UNIT_RT_REE_STATUS_TXT

Estado de ejecución (Texto)

Configuración de las variables que muestran durante el runtime el estado de ejecución de una receta como texto. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarReeStatusTxt


IDP_BATCH_UNIT_RT_RUN_ERR_COUNT

Interne ID: IDP_BATCH_UNIT_RT_RUN_ERR_COUNT

Número de errores del proceso activos

Configuración de las variables que muestran durante el runtime el número de errores del proceso actuales. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarRunErrorCnt


IDP_BATCH_UNIT_RT_RUN_ERR_GONE

Interne ID: IDP_BATCH_UNIT_RT_RUN_ERR_GONE

Número de errores del proceso despejados

Configuración de las variables que muestran durante el runtime el número de errores del proceso históricos. Haciendo clic sobre el campo de propiedades o el botón ... se abre un diálogo para seleccionar una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtInfoVarRunErrorGone


IDP_BATCH_VERSION_ACTIVE

Interne ID: IDP_BATCH_VERSION_ACTIVE

Versionar activado

Activado: La versionización de recetas está activada y se utilizará durante el runtime.

Desactivado: La versionización está desactivada.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VersionActive


IDP_BATCH_VERSION_GRP

Interne ID: IDP_BATCH_VERSION_GRP

Versionar

Contiene propiedades para versionar recetas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VersionGrp


IDP_BUTTONSAMPLE

Interne ID: IDP_BUTTONSAMPLE

Auswahl

Ejemplo para un driver de muestra.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SampleButton


IDP_CEL_ARVERRPERIOD

Interne ID: IDP_CEL_ARVERRPERIOD

Evacuación de archivos [h]

Tiempo en horas para el tratamiento de errores.

Si al almacenar archivos se detecta un fallo se producirá una entrada en la lista cronológica de eventos (CEL) después del intervalo de tiempo establecido.

Cuando un archivo ARX no pueda ser leído se le cambiará el nombre a .ar_ y se utilizará el siguiente archivo.
Por defecto: 12

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ArciveOverPeriod


IDP_CEL_LONGLIMITS

Interne ID: IDP_CEL_LONGLIMITS

Textos largos dinámicos de valor límite CEL

Define si el campo para comentarios está disponible para textos dinámicos de valor límite. El valor límite dinámico permite insertar valores actuales de otras variables en el texto del valor límite de una variable.

  • Activado: Los contenidos dinámicos se guardarán en un archivo bajo el nombre convencional de D*.CEL. Este archivo se creará adicionalmente al archivo C*.CEL. El campo para comentarios se puede utilizar así para comentarios. Los textos dinámicos de valor límite pueden contener un máximo de 1024 caracteres.
  • Desactivado: El campo para comentarios se está utilizando para textos dinámicos de valor límite y está bloqueado para comentarios. Longitud máxima: 80 caracteres.

Por defecto: desactivado.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CELLongDynLimits


IDP_CEL_TEXTLEN

Interne ID: IDP_CEL_TEXTLEN

Largo de textos de valor límite estáticos CEL

Largo en caracteres del texto estático del valor límite en la lista CEL.

Establece el número de caracteres que puede tener como máximo el texto estático del valor límite en la lista CEL. Los valores mínimos y máximos también se aplicarán para VBA/VSTA.

  • Mínimo: 127
  • Máximo: 1023

Por defecto: 127

Limitación: Para la exportación dBase la longitud está limitada a 256 caracteres.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CELTextLen


IDP_DEL_PIC_BACK_PATH_AT_LOGOUT

Interne ID: IDP_DEL_PIC_BACK_PATH_AT_LOGOUT

Eliminar la ruta de 'Pantalla anterior' al cambiar de usuario

Configuración para eliminar automáticamente la ruta de la función Pantalla anterior al cambiar de usuario.

  • Activado: Al cambiar de usuario se eliminará la ruta de Pantalla anterior.

Por defecto:desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DelPicBackPathAtLogout


IDP_DYN_ELE_KBD

Interne ID: IDP_DYN_ELE_KBD

Utilizar representación del teclado

Al seleccionar el elemento durante el runtime se activará el teclado.
Al seleccionar un campo de entrada libre durante el runtime se activará la pantalla de teclado DIALOGKBD (si existe).
Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

KbdUsage


IDP_DYN_ELE_KBD_NAME

Interne ID: IDP_DYN_ELE_KBD_NAME

Representación del teclado

Nombre de la pantalla de teclado vinculada.
Solo disponible cuando se use la pantalla de teclado:

Si no se ha introducido aquí ninguna pantalla, con variables de cadena saldrá SETSTRINGKBD, con variables numéricas (no variables bit) saldrá SETVALUEKBD y con variables bit saldrá SETBOOLKBD.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

KbdName


IDP_DYNELE_ALC_ALIAS

Interne ID: IDP_DYNELE_ALC_ALIAS

Utilizar alias

Sólo disponible si Color de ALC está activado.
Activado: Se utilizará un alias. El elemento toma sus colores ALC en el runtime de otro elemento del modelo topológico, sin ser parte del modelo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCAlias


IDP_DYNELE_ALC_ALIAS_NAME

Interne ID: IDP_DYNELE_ALC_ALIAS_NAME

Alias

Sólo disponible si Color de ALC está activada.

Define el elemento fuente para Utilizar alias. Haciendo clic sobre el botón ... se abre un diálogo para elegir un elemento existente.
Observación: No se pueden utilizar alias para símbolos en la galería general de símbolos o en la galería de símbolos del proyecto global.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCAliasName


IDP_DYNELE_ALC_ALTCOL

Interne ID: IDP_DYNELE_ALC_ALTCOL

Color alternativo

Solo disponible si la propiedad Mostrar suministros múltiples tiene el valor Color alternativo.

Color alternativo para la coloración de ALC con abastecimiento múltiple.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCAlternativeColor


IDP_DYNELE_ALC_DASHLEN

Interne ID: IDP_DYNELE_ALC_DASHLEN

Línea discontinua con suministro múltiple

Solo disponible si la propiedad Mostrar suministros múltiples tiene el valor Dos fuentes con mayor prioridad.

Define la longitud de la línea discontínua en píxeles para la coloración con línea discontínua de ALC en caso de abastecimiento múltiple.

Mínimo: 0 (longtitud automática de línea discontínua)

Máximo: 32767

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCDashLen


IDP_DYNELE_ALC_EXCHANGEINOUT

Interne ID: IDP_DYNELE_ALC_EXCHANGEINOUT

Cambiar entrada/salida

Solo disponible si se ha configurado como Tipo de función Trafo, Interruptor, Válvula o Seccionador.

Activado: Desplaza la entrada del elemento ALC hacia la derecha o hacia abajo y la salida hacia la izquierda o hacia arriba.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCExchangeInOut


IDP_DYNELE_ALC_GROUNDFAULTTYPE

Interne ID: IDP_DYNELE_ALC_GROUNDFAULTTYPE

Tipo

Sólo disponible si se ha configurado como Tipo de función Interruptor.

Determina la dirección (Primero/Después) y el tipo de procesamiento del mensaje (Ninguno, Mensaje permanente o Limpiador):

ninguno: interruptor normal

Mensaje permanente: El mensaje se procesará como desencadenante de pérdida a tierra

Limpiador: Los mensajes que entren durante la Búsqueda no se tendrán en cuenta

Después: se esperará 2 s al primer flanco ascendente de una dirección

Primero: se utilizará el estado actual de la dirección

Por defecto: ninguna

Más en el Manual online .

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCGroundFaultType


IDP_DYNELE_ALC_GROUNDFAULTVARDISP

Interne ID: IDP_DYNELE_ALC_GROUNDFAULTVARDISP

Mostrar

Sólo disponible si ha sido seleccionado un Tipo.
Determina la variable de salida de la detección de errores para mostrar el estado del dispositivo de reconocimiento de pérdidas a tierra. La variable vinculada aquí debe ser una variable local para evitar problemas de red. Haciendo clic sobre el botón ... se abre un diálogo para elegir una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCGroundFaultVarDisp


IDP_DYNELE_ALC_GROUNDFAULTVARFWD

Interne ID: IDP_DYNELE_ALC_GROUNDFAULTVARFWD

Adelante

Sólo disponible si ha sido seleccionado un Tipo.
Determina la variable para el reconocimiento de pérdidas a tierra hacia delante. Haciendo clic sobre el botón ... se abre un diálogo para elegir una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCGroundFaultVarFwd


IDP_DYNELE_ALC_GROUNDFAULTVARREV

Interne ID: IDP_DYNELE_ALC_GROUNDFAULTVARREV

Atrás

Sólo disponible si ha sido seleccionado un Tipo.
Determina la variable para el reconocimiento de pérdidas a tierra hacia atrás. Haciendo clic sobre el botón ... se abre un diálogo para elegir una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCGroundFaultVarRev


IDP_DYNELE_ALC_GROUNDFAULTVARTRG

Interne ID: IDP_DYNELE_ALC_GROUNDFAULTVARTRG

Desencadenación

Sólo disponible si ha sido seleccionado un Tipo.
Determina la variable que muestra el reconocimiento de una pérdida a tierra. Para mensajes direccionados de pérdidas a tierra hay que definir adicionalmente la dirección (Atrás o Adelante). Haciendo clic sobre el botón ... se abre un diálogo para elegir una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCGroundFaultVarTrg


IDP_DYNELE_ALC_LINELENGTH

Interne ID: IDP_DYNELE_ALC_LINELENGTH

Longitud de la línea [km]

Línea ALC: Longitud de la línea.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCLength


IDP_DYNELE_ALC_LINEREACT

Interne ID: IDP_DYNELE_ALC_LINEREACT

Valor de reactancia de la línea [Ohm]

Valor máximo de reactancia permitido de la línea en ohmios.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCReact


IDP_DYNELE_ALC_LINERESIST

Interne ID: IDP_DYNELE_ALC_LINERESIST

Valor de resistencia de la línea [Ohm]

Valor máximo de reactancia permitido de la línea en ohmios.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCResist


IDP_DYNELE_ALC_LOADTYPE

Interne ID: IDP_DYNELE_ALC_LOADTYPE

Carga

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCLoadType


IDP_DYNELE_ALC_LOADVAL

Interne ID: IDP_DYNELE_ALC_LOADVAL

Carga fija [A]

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCLoadVal


IDP_DYNELE_ALC_MAXITYPE

Interne ID: IDP_DYNELE_ALC_MAXITYPE

Límite de la capacidad de corriente

Interruptor ALC: Valor límite de la capacidad máxima de corriente [Selección fijo/variable].

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCMaxIType


IDP_DYNELE_ALC_MAXIVAL

Interne ID: IDP_DYNELE_ALC_MAXIVAL

Límite de la capacidad de corriente fijo [A]

Interruptor ALC: Valor límite de capacidad de corriente fijo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCMaxIVal


IDP_DYNELE_ALC_PROTID

Interne ID: IDP_DYNELE_ALC_PROTID

Schutzgerät-ID

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCProtID


IDP_DYNELE_ALC_REVSRC

Interne ID: IDP_DYNELE_ALC_REVSRC

Fuente para retroalimentación

Sólo disponible si ha seleccionado el Transformador en la propiedad Tipo de función.

Selección de los transformadores vinculados.

Si selecciona cualquier otra fuente distinta a UNDEFINED [0] el transformador podrá retroalimentarse. Ello quiere decir que el transformador se comporta igual en ambas direcciones - de la entrada a la salida (hacia adelante) y de la salida a la entrada (hacia atrás). La única diferencia consiste en que posteriormente se utilizará el número de fuente de la propiedad Fuente para retroalimentación y no de la propiedad Fuente.

Observación: Estados de red erróneos o configuraciones erróneas, como p. ej. que no se coloreen de forma especial la alimentación simultánea de entrada y salida o el cortocircuito de entrada y salida. Eso quiere decir que el transformador capaz de retroalimentarse se comporta como dos transformadores antiparalelos que no son capaces de retroalimentarse.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCReverseSourceID


IDP_DYNELE_ALC_SHORTFAULTTYPE

Interne ID: IDP_DYNELE_ALC_SHORTFAULTTYPE

Tipo

Sólo disponible si se ha configurado como Tipo de función Interruptor.

Determina el procesamiento del mensaje (ninguno o mensaje permanente) y su dirección (primero/después).

ninguno: interruptor normal

Mensaje permanente: El mensaje se procesará como desencadenante de pérdida a tierra

Después: se esperará al primer flanco ascendente de una dirección

Primero: se utilizará el estado actual de la dirección

Por defecto: ninguna

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCShortFaultType


IDP_DYNELE_ALC_SHORTFAULTVARDISP

Interne ID: IDP_DYNELE_ALC_SHORTFAULTVARDISP

Mostrar

Sólo disponible si ha sido seleccionado un Tipo.

Determina la variable de salida para la detección de errores para mostrar el estado del dispositivo de reconocimiento de pérdidas a tierra. La variable vinculada aquí debe ser una variable local para evitar problemas de red. Haciendo clic sobre el botón ... se abre un diálogo para elegir una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCShortFaultVarDisp


IDP_DYNELE_ALC_SHORTFAULTVARFWD

Interne ID: IDP_DYNELE_ALC_SHORTFAULTVARFWD

Adelante

Sólo disponible si ha sido seleccionado un Tipo.
Determina la variable para el reconocimiento de pérdidas a tierra hacia delante. Haciendo clic sobre el botón ... se abre un diálogo para elegir una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCShortFaultVarFwd


IDP_DYNELE_ALC_SHORTFAULTVARREV

Interne ID: IDP_DYNELE_ALC_SHORTFAULTVARREV

Atrás

Sólo disponible si ha sido seleccionado un Tipo.
Determina la variable para el reconocimiento de pérdidas a tierra hacia atrás. Haciendo clic sobre el botón ... se abre un diálogo para elegir una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCShortFaultVarRev


IDP_DYNELE_ALC_SHORTFAULTVARTRG

Interne ID: IDP_DYNELE_ALC_SHORTFAULTVARTRG

Desencadenación

Sólo disponible si ha sido seleccionado un Tipo.

Determina la variable para el mensaje del dispositivo de reconocimiento de pérdidas a tierra. Para mensajes direccionados de pérdidas a tierra hay que definir adicionalmente la dirección (Adelante o Atrás). Haciendo clic sobre el botón ... se abre un diálogo para elegir una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCShortFaultVarTrg


IDP_DYNELE_ALC_VARCALCI

Interne ID: IDP_DYNELE_ALC_VARCALCI

Valor de medición del flujo de corriente calculado

Línea ALC: Valor de medición del flujo de corriente calculado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCVarCalcI


IDP_DYNELE_ALC_VARCURI

Interne ID: IDP_DYNELE_ALC_VARCURI

Valor de medición del flujo de corriente actual

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCVarCurI


IDP_DYNELE_ALC_VARCURP

Interne ID: IDP_DYNELE_ALC_VARCURP

Valor de medición de la potencia aparente actual

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCVarCurP


IDP_DYNELE_ALC_VARLOAD

Interne ID: IDP_DYNELE_ALC_VARLOAD

Carga variable

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCVarLoad


IDP_DYNELE_ALC_VARMAXI

Interne ID: IDP_DYNELE_ALC_VARMAXI

Variable del límite de la capacidad de corriente

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCVarMaxI


IDP_DYNELE_ALC_VARPROTREACT

Interne ID: IDP_DYNELE_ALC_VARPROTREACT

Valor de reactancia de seguridad

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ALCVarProtReact


IDP_DYNELE_LIMITCOLOR_ACTIVE

Interne ID: IDP_DYNELE_LIMITCOLOR_ACTIVE

Utilizar color del valor límite

Puede determinar si se debe mostrar en el runtime el color del valor límite definido de la variable vinculada al elemento. El color variará, según el tipo de elemento, en el texto o en el indicador de la regleta universal.

Activado: El color del valor límite definido se mostrará en el runtime.

Por defecto: activado (para garantizar la compatibilidad)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LimitColor


IDP_ELE_POS_START_ANGLE

Interne ID: IDP_ELE_POS_START_ANGLE

Ángulo de rotación [°]

Ángulo libremente definible para girar el elemento.
Los valores positivos giran en el sentido contrario a las agujas del reloj y los negativos a favor. Los valores mayores de 360° se representarán como su diferencia con 360° (400° corresponde a 40°). Sólo se pueden introducir números enteros

Con los elementos girados no son posibles las siguientes acciones:

  • reflejar
  • rotar +/- 90°
  • escalar con flechas

Por defecto: 0

Observación: En proyecciones con Windows CE esta configuración se desactivará y reseteará.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Angle


IDP_ELE_VAR_LOCKING

Interne ID: IDP_ELE_VAR_LOCKING

Interbloqueo

Vínculo de un interbloqueo existente a este elemento.

Cuando se cumpla la condición de una fórmula de interbloqueo, se bloqueará este elemento de manera que no sea posible ninguna condición. En caso de que esté definido en las propiedades del proyecto, durante el interbloqueo se mostrará el símbolo de un candado sobre el elemento.

Observación: No se pueden utilizar interbloqueos para símbolos en la galería general de símbolos o en la galería de símbolos del proyecto global.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Locking


IDP_ELE_VISIBILITY_INTERLOCKINGS

Interne ID: IDP_ELE_VISIBILITY_INTERLOCKINGS

Interbloqueo

Solo disponible si para la propiedad Visibilidad se ha seleccionado Del interbloqueo.

Nombre del interbloqueo cuyo valor determina la visibilidad del elemento. Seleccionar de la lista desplegable. La lista contiene todos los interbloqueos existentes y utilizables. Si no hay ningún interbloqueo vinculado el elemento estará siempre visible.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

Interlocking


IDP_ELE_VISIBILITY_TYPE

Interne ID: IDP_ELE_VISIBILITY_TYPE

Visibilidad

Selección de dónde se determina la visibilidad del elemento:

  • De la variable
  • Del interbloqueo

Por defecto: De la variable

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VisibilityType


IDP_ELE_VISIBILITY_WHEN_INTERLOCKED

Interne ID: IDP_ELE_VISIBILITY_WHEN_INTERLOCKED

Visible cuando está interbloqueado

Determina la visibilidad del elemento con interbloqueo seleccionado:

  • Activado: El elemento estará visible si está interbloqueado.
  • Desactivado: El elemento estará visible si no está interbloqueado.

Por defecto: desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VisibleWhenInterlocked


IDP_ELEDYN_MT_RIGHTCLICKACTION

Interne ID: IDP_ELEDYN_MT_RIGHTCLICKACTION

RightClickMTAction

Description as text.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RightClickMTAction


IDP_EVERY_WHERE_ACCESS_LEVEL

Interne ID: IDP_EVERY_WHERE_ACCESS_LEVEL

Niveles de autorización

Lista desplegable para seleccionar los niveles de autorización que tendrán acceso al Everywhere Server.

Por defecto: 0 (= acceso ilimitado)
Niveles de autorización disponibles: 0 - 127

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EveryWhereAccessLevel


IDP_EVERY_WHERE_NODE

Interne ID: IDP_EVERY_WHERE_NODE

Everywhere Server

Propiedades para el Everywhere Server by zenon.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

EveryWhereSettings


IDP_FRAME_AUFSCHALTGROESSE_TYP

Interne ID: IDP_FRAME_AUFSCHALTGROESSE_TYP

Tamaño de apertura

Define el tamaño con el que se activará durante el runtime una pantalla basada en este marco.

  • Tamaño del marco: El tamaño se define como en Anchura (máximo) [píxeles] y Altura (máximo) [píxeles].
    Si se selecciona otro valor el tamaño se mostrará durante el runtime con una línea de puntos en la ventana de marcos.
  • Anchura [px]: Anchura definida como en Valor (tamaño de apertura), la altura se ajustará en correspondencia.
  • Altura [px]: Altura definida como en Valor (tamaño de apertura), la anchura se ajustará en correspondencia.
  • Relativo [%]: El tamaño definido en Anchura (máximo) [píxeles] y Altura (máximo) [píxeles] se modificará al valor porcentual definido en Valor (tamaño de apertura).

Los valores correspondientes se definen con la propiedad Valor (tamaño de apertura).

Por defecto: Tamaño del marco

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

OpeningSizeType


IDP_FRAME_AUFSCHALTGROESSE_WERT

Interne ID: IDP_FRAME_AUFSCHALTGROESSE_WERT

Valor (tamaño de apertura)

Valor para el tipo de definición de tamaño seleccionado en la propiedad Tamaño de apertura al activar durante el runtime.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

OpeningSizeValue


IDP_FRAME_BEGRENZUNG_TYP

Interne ID: IDP_FRAME_BEGRENZUNG_TYP

Limitación mínimo

Tipo de restricción para el valor mínimo:

  • Sin: Ningún límite.
    Si se selecciona otro valor, el límite seleccionado se mostrará durante el runtime en la ventana de marcos con una línea discontinua.
  • Anchura: Límite de anchura.
  • Altura: Límite de altura.
  • Relativo: Límite de un porcentaje del tamaño de pantalla configurado.

Solo tiene efecto con gestos Multi-Touch. Los valores correspondientes se definen con la propiedad Valor (mínimo).

Por defecto: Sin

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MinSizeType


IDP_FRAME_BEGRENZUNG_WERT

Interne ID: IDP_FRAME_BEGRENZUNG_WERT

Valor (mínimo)

Valor para la configuración seleccionada en la propiedad.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

MinSizeValue


IDP_FRAME_HEIGHTMAX

Interne ID: IDP_FRAME_HEIGHTMAX

Höhe(Maximum) [Pixel]

Altura máxima de un marco cuyo tamaño sea modificable durante el runtime. No disponible para proyectos CE.

Valores permitidos:

  • Mínimo: Valor off Altura (máximo) [píxeles]
  • Máximo: 4294967295 (DWORD)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PosHeightMax


IDP_FRAME_HEIGHTMIN

Interne ID: IDP_FRAME_HEIGHTMIN

Höhe(Minimum) [Pixel]

Altura mínima de un marco cuyo tamaño sea modificable durante el runtime. No disponible para proyectos CE.

Valores permitidos:

  • Mínimo: 0
  • Máximo: Valor para Tamaño de apertura.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PosHeightMin


IDP_FRAME_WIDTHMAX

Interne ID: IDP_FRAME_WIDTHMAX

Breite(Maximum) [Pixel]

Anchura máxima de un marco cuyo tamaño sea modificable durante el runtime. No disponible para proyectos CE.

Valores permitidos:

  • Mínimo: Valor off Anchura (máximo) [píxeles]
  • Máximo: 4294967295 (DWORD)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PosWidthMax


IDP_FRAME_WIDTHMIN

Interne ID: IDP_FRAME_WIDTHMIN

Breite(Minimum) [Pixel]

Anchura mínima de un marco cuyo tamaño sea modificable durante el runtime. No disponible para proyectos CE.

Valores permitidos:

  • Mínimo: 0
  • Máximo: Valor off Tamaño de apertura.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PosWidthMin


IDP_GESTUREDOUBLETAP_FUNCTION

Interne ID: IDP_GESTUREDOUBLETAP_FUNCTION

Función

Selección de una función proyectada en zenon como reacción al gesto Doble tecleo. No se pueden utilizar las funciones específicas de pantalla.
Solo estarán disponibles si para la propiedad Reacción se ha seleccionado Ejecutar función propia.

Más en la Ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GestureDoubleTapFunction


IDP_GESTUREDOUBLETAP_GROUP

Interne ID: IDP_GESTUREDOUBLETAP_GROUP

Pulsar dos veces

Propiedades para administrar los gestos Doble Teclear durante el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GestureDoubleTapGroup


IDP_GESTUREDOUBLETAP_REACTION

Interne ID: IDP_GESTUREDOUBLETAP_REACTION

Reacción

Selección de la reacción al gesto Doble tecleo de la lista desplegable.
Las reacciones disponibles dependen del tipo de pantalla o del elemento de pantalla.

Si se elige la reacción Ejecutar función propia, dicha función tendrá que estar definida en la propiedad Función.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GestureDoubleTapReaction


IDP_GESTUREMANIPULATION_GROUP

Interne ID: IDP_GESTUREMANIPULATION_GROUP

Manipulation

Propiedades para manipular pantallas y elementos de pantallas con manejo táctil.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GestureManipulationGroup


IDP_GESTUREMANIPULATION_X

Interne ID: IDP_GESTUREMANIPULATION_X

Desplazar horizontalmente

Determinación de la reacción a un gesto para desplazamiento horizontal. La reacción configurable depende de la pantalla o el elemento de pantalla que se desee configurar.

Interacción: Las propiedades Desplazar marco con el ratón por un lado y las propiedades Desplazar horizontalmente y Desplazar verticalmente por otro lado no se pueden activar al mismo tiempo. Se puede activar, o bien el desplazamiento de un marco con el ratón, o bien el desplazamiento horizontal/vertical por manejo táctil.

Atención caso especial: En el siguiente caso se pueden establecer ambas propiedades y después permanecen inconfigurables.

  • Se activa la propiedad Desplazar horizontalmente o Desplazar verticalmente.
  • La propiedad de proyecto Evaluación para Interacción se establece en Windows 7 o Desactivado.
  • Se activa la propiedad Desplazar marco con el ratón.
  • La propiedad Evaluación se vuelve a establecer en Windows 8.

Solución:

  • Vuelva a establecer la propiedad Evaluación en Windows 7 o Desactivado.
  • Desactive la propiedad Desplazar marco con el ratón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GestureManipulationX


IDP_GESTUREMANIPULATION_X_Y_IN_ONE

Interne ID: IDP_GESTUREMANIPULATION_X_Y_IN_ONE

Desplazar

Determinación de la reacción a un gesto de desplazamiento. La reacción configurable depende de la pantalla o el elemento de pantalla que se desee configurar.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GestureManipulationXY


IDP_GESTUREMANIPULATION_Y

Interne ID: IDP_GESTUREMANIPULATION_Y

Desplazar verticalmente

Determinación de la reacción a un gesto para desplazamiento vertical. La reacción configurable depende de la pantalla o el elemento de pantalla que se desee configurar.

Interacción: Las propiedades Desplazar marco con el ratón por un lado y las propiedades Desplazar horizontalmente y Desplazar verticalmente por otro lado no se pueden activar al mismo tiempo. Se puede activar, o bien el desplazamiento de un marco con el ratón, o bien el desplazamiento horizontal/vertical por manejo táctil.

Atención caso especial: En el siguiente caso se pueden establecer ambas propiedades y después permanecen inconfigurables.

  • Se activa la propiedad Desplazar horizontalmente o Desplazar verticalmente.
  • La propiedad de proyecto Evaluación para Interacción se establece en Windows 7 o Desactivado.
  • Se activa la propiedad Desplazar marco con el ratón.
  • La propiedad Evaluación se vuelve a establecer en Windows 8.

Solución:

  • Vuelva a establecer la propiedad Evaluación en Windows 7 o Desactivado.
  • Desactive la propiedad Desplazar marco con el ratón.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GestureManipulationY


IDP_GESTUREMANIPULATION_ZOOM

Interne ID: IDP_GESTUREMANIPULATION_ZOOM

Hacer zoom

Determinación de la reacción a un gesto de zoom. La reacción configurable depende de la pantalla o el elemento de pantalla que se desee configurar.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GestureManipulationZoom


IDP_GESTURETAP_FUNCTION

Interne ID: IDP_GESTURETAP_FUNCTION

Función

Selección de una función proyectada en zenon como reacción al gesto Tecleo. No se pueden utilizar las funciones específicas de pantalla.
Solo estarán disponibles si para la propiedad Reacción se ha seleccionado Ejecutar función propia.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GestureTapFunction


IDP_GESTURETAP_GROUP

Interne ID: IDP_GESTURETAP_GROUP

Escritura

Propiedades para el comportamiento del gesto Teclear durante el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GestureTapGroup


IDP_GESTURETAP_REACTION

Interne ID: IDP_GESTURETAP_REACTION

Reacción

Selección de la reacción al gesto Tecleo de la lista desplegable.
Las reacciones disponibles dependen del tipo de pantalla o del elemento de pantalla.

Si se elige la reacción Ejecutar función propia, dicha función tendrá que estar definida en la propiedad Función.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GestureTapReaction


IDP_GESTURETAPANDHOLD_FUNCTION

Interne ID: IDP_GESTURETAPANDHOLD_FUNCTION

Función

Selección de una función proyectada en zenon como reacción al gesto Teclear y mantener. No se pueden utilizar las funciones específicas de pantalla.
Solo estarán disponibles si para la propiedad Reacción se ha seleccionado Ejecutar función propia.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GestureTapAndHoldFunction


IDP_GESTURETAPANDHOLD_GROUP

Interne ID: IDP_GESTURETAPANDHOLD_GROUP

Presionar y mantener

Propiedades para el comportamiento del gesto Teclear y mantener durante el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GestureTapAndHoldGroup


IDP_GESTURETAPANDHOLD_REACTION

Interne ID: IDP_GESTURETAPANDHOLD_REACTION

Reacción

Selección de la reacción al gesto Teclear y mantener de la lista desplegable.
Las reacciones disponibles dependen del tipo de pantalla o del elemento de pantalla.

Si se elige la reacción Ejecutar función propia, dicha función tendrá que estar definida en la propiedad Función.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GestureTapAndHoldReaction


IDP_GFXRT_ROWHEIGHT

Interne ID: IDP_GFXRT_ROWHEIGHT

Altura de fila [píxeles]

Permite la configuración de la altura de la fila independientemente del tamaño de la fuente.

Valor máximo: 255 px
Valor mínimo: 0 px - la altura de la fila se ajustará al tamaño de la fuente.

Por defecto: 0

Atención: Si se elige una altura de fila

  • demasiado grande, puede ser que no se muestre durante el runtime.
  • más pequeña que el tamaño de la fuente se cortarán las representaciones gráficas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RowHeight


IDP_GFXRT_SHOW_BOOL_AS_NUMBER

Interne ID: IDP_GFXRT_SHOW_BOOL_AS_NUMBER

Vista numérica

Activado: Los varlores binarios se mostrarán numéricos durante el runtime. En caso de que el elemento de listas lo permita, los valores binarios se podrán introducir también de forma numérica.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowBoolAsNumber


IDP_GRP_FCNMANAGER

Interne ID: IDP_GRP_FCNMANAGER

Funciones

Propiedades para la administración de funciones.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_FuncManager


IDP_GRP_HDDMANAGER

Interne ID: IDP_GRP_HDDMANAGER

Almacenamiento de datos en el disco duro

Propiedades para la administración de datos del disco duro (HDD).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_HDD


IDP_GRP_RGMKEYBOARDS

Interne ID: IDP_GRP_RGMKEYBOARDS

Teclados

Selección de un teclado para realizar entradas en la tabla de valores de recetas durante el runtime. Se pueden vincular pantallas del tipo Teclado para:

  • entradas binarias
  • entradas numéricas
  • entradas de cadena

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

GRP_RGM_KEYBOARDS


IDP_GRP_RGMSETTING

Interne ID: IDP_GRP_RGMSETTING

Administrador de grupos de recetas

Opciones para el estado de receta en el RGM.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_RGM


IDP_GRP_RT_BATCHPREF

Interne ID: IDP_GRP_RT_BATCHPREF

Módulo de licencia en runtime

Propiedades para el comportamiento del runtime cuando existan varios módulos con licencia.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

GRP_BatchPreferred


IDP_GRP_RTDIALOGES

Interne ID: IDP_GRP_RTDIALOGES

Mensajes de runtime para

Propiedades para las notificaciones runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_RTMessageBoxes


IDP_HDD_ACTIVE

Interne ID: IDP_HDD_ACTIVE

Datos HDD activos

  • Activado: Se grabarán los datos del disco duro (HDD).
  • Desactivado: No se grabarán los datos del disco duro (HDD).

Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Active


IDP_HDD_FILLDATA

Interne ID: IDP_HDD_FILLDATA

Búfer de datos

  • Activado: La memoria tampón amortiguará un número fijo de bytes determinado por el sistema internamente y los irá guardando por bloques.
  • Desactivado: Se irán guardando los valores entrantes.

Por defecto: activado.

Cálculo: se guardarán todos los ciclos kte. k es el divisor entero mayor de los valores HD para guardar, será menor o igual que 84.
Por ejemplo: Número de valores 300 -> Guardar cada 75. Valor:

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FillData


IDP_LIST_BACKCOLOR_SELECT_FOCUS

Interne ID: IDP_LIST_BACKCOLOR_SELECT_FOCUS

Color de fondo con foco

Color de fondo de una entrada de la lista cuando el foco esté sobre el elemento. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: Valor del sistema operativo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColorSelectFocus


IDP_LIST_BACKCOLOR_SELECT_NOFOCUS

Interne ID: IDP_LIST_BACKCOLOR_SELECT_NOFOCUS

Color de fondo sin foco

Color de fondo de una entrada de la lista cuando el foco no esté sobre el elemento. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: Valor del sistema operativo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColorSelectNoFocus


IDP_LIST_TEXTCOLOR_SELECT_FOCUS

Interne ID: IDP_LIST_TEXTCOLOR_SELECT_FOCUS

Color de texto con foco

Color para el texto de una entrada de la lista cuando el foco esté sobre el elemento. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: Valor del sistema operativo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextColorSelectFocus


IDP_LIST_TEXTCOLOR_SELECT_NOFOCUS

Interne ID: IDP_LIST_TEXTCOLOR_SELECT_NOFOCUS

Color de texto sin foco

Color para el texto de una entrada de la lista cuando el foco no esté sobre el elemento. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: Valor del sistema operativo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextColorSelectNoFocus


IDP_LOCKED_BUTTONS

Interne ID: IDP_LOCKED_BUTTONS

Botones interbloqueados

Define el aspecto de los botones en el runtime que estén bloqueados por un interbloqueo. Durante el runtime se combina con la propiedad Botones bloqueados (Administración de usuarios) para el manejo de las teclas.

Posibles formas de representación:

  • Gris
  • Normal
  • Invisible

Por defecto: Normal

Esta propiedad funciona independientemente de la propiedad Identificación gráfica activada . Un botón gris puede mostrar también p. ej. el símbolo de un candado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LockedButtonStyle


IDP_MENU_SEP_COLOR

Interne ID: IDP_MENU_SEP_COLOR

Color

Defina el color de relleno de la línea divisoria. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Por defecto: Negro

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SeparatorColor


IDP_MENU_SEP_GROUP

Interne ID: IDP_MENU_SEP_GROUP

Separador

Configuraciones generales para la línea divisoria en un menú.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Separator


IDP_MENU_SEP_WIDTH

Interne ID: IDP_MENU_SEP_WIDTH

Anchura

Defina el ancho de la línea divisoria en píxels.

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SeparatorWidth


IDP_MODUL_KBD_LAYOUT

Interne ID: IDP_MODUL_KBD_LAYOUT

Teclados

Grupo teclados disponibles en Batch Control.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ModulKbdLayout


IDP_MSGCTRL_GENERALSETTINGS_GRP

Interne ID: IDP_MSGCTRL_GENERALSETTINGS_GRP

Configuraciones de teléfono

Propiedades para las configuraciones del teléfono.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PhoneSettings


IDP_MSGCTRL_GSM_SMS_BULK_DELETE

Interne ID: IDP_MSGCTRL_GSM_SMS_BULK_DELETE

Eliminar SMS con indicador de estado-sintaxis del comando AT+CMGD

Define el procedimiento al eliminar mensajes. La sintaxis del comando +CMGD AT tiene dos posibilidades: Marca de estado e Índice.

  • Activado: Los mensajes se eliminarán con el método Marca de estado.
    Todos los mensajes leídos se eliminarán de una vez.
    Hinweis: Este método es más rápido pero no es compatible con todos los módems.
  • Desactivado: Los mensajes se eliminarán con el método Índice( por defecto). Los mensajes leídos se eliminarán individualmente.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BulkDelete


IDP_MSGCTRL_GSM_SMS_CHECK_MODEM

Interne ID: IDP_MSGCTRL_GSM_SMS_CHECK_MODEM

Comprobar conexión

Haciendo clic sobre el botón se comprueba la conexión al módem. Se comprobará:

1. La apertura y preparación del puerto COM definido en la propiedad Conexión del módem (serial).

2. Respuesta del módem.

3. La autentificación PIN, cuando sea necesaria.

4. La configuración del módem. Para la configuración se utilizará una entrada fantasma para Número de la central de SMS dado que la validez de ese número de teléfono no se podrá comprobar hasta que no se envíe un SMS.

Se mostrará en un mensaje con el resultado (éxito o fallo) de la comprobación. Las informaciones erróneas se escribirán en los archivos LOG.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CheckModem


IDP_MSGCTRL_GSM_SMS_COM_PORT

Interne ID: IDP_MSGCTRL_GSM_SMS_COM_PORT

Conexión del módem (serial)

Selección del puerto COM disponible para el módem. Haciendo clic se abre una lista desplegable para seleccionar. Se puede seleccionar el puerto correcto en el sistema de control en el grupo Teléfono y módem.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SerialPort


IDP_MSGCTRL_GSM_SMS_GRP

Interne ID: IDP_MSGCTRL_GSM_SMS_GRP

Mensaje SMS (GSM-Módem)

Configuraciones para el envío de SMS a través de GSM.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DispatchSettings


IDP_MSGCTRL_GSM_SMS_PIN

Interne ID: IDP_MSGCTRL_GSM_SMS_PIN

Código PIN

Entrada del PIN para el módem. La entrada solo puede contener cifras. Si para la utilización del módem no se necesita ningún PIN, se ignorará el valor de esta propiedad.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PersonalIdentificationNumber


IDP_MSGCTRL_GSM_SMS_SMSC_NUMBER

Interne ID: IDP_MSGCTRL_GSM_SMS_SMSC_NUMBER

Número de la central de SMS

Entrada del número de teléfono del SMSC (central de mensajes cortos) del proveedor GSM utilizado. La entrada tiene que ser un número de teléfono válido y solo puede contener cifras. Se permite + como prefijo internacional.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SmscPhoneNumber


IDP_NET_CHECK

Interne ID: IDP_NET_CHECK

Resultado

Salida del resultado de la comprobación de la topología de redes.

No es posible ninguna entrada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Check


IDP_NET_COMPUTER

Interne ID: IDP_NET_COMPUTER

Nombre del ordenador

Nombre del ordenador de destino en la red. Haciendo clic sobre el botón ... se abre una lista desplegable con los ordenadores conectados a la red.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Computer


IDP_NET_COMPUTER_GRP

Interne ID: IDP_NET_COMPUTER_GRP

Ordenador

Propiedades para el ordenador en la topología de redes.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Computer


IDP_NET_DIRECTORY

Interne ID: IDP_NET_DIRECTORY

Carpeta de destino del proyecto de inicio

Carpeta runtime del proyecto de inicio en el ordenador de destino. Los archivos del proyecto de inicio se almacenarán en esta carpeta con todos los demás proyectos relacionados en correspondencia a la estructura del PC local. Utilice el nombre de proyecto como nombre del ordenador para crear automáticamente la misma estructura que en el ordenador de programación.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WorkingPath


IDP_NET_PROJECT

Interne ID: IDP_NET_PROJECT

Proyecto de inicio

Proyecto de inicio para el ordenador de destino. Haciendo clic sobre la lista desplegable se abre una lista de todos los proyectos ya existentes.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


IDP_PRJ_CHANGE_PWD_PIC

Interne ID: IDP_PRJ_CHANGE_PWD_PIC

Pantalla para cambiar la contraseña

Selección de una pantalla del tipo Editar usuario para cambiar la contraseña propia. Se activará la pantalla en lugar del diálogo modal. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar una pantalla.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ChangePwdPicture


IDP_PRJ_DISMENUITEMS_DRAWING

Interne ID: IDP_PRJ_DISMENUITEMS_DRAWING

Puntos del menú bloqueados

Define el comportamiento de muestra de entradas de menú durante el runtime:

  • Normal: Los menús se mostrarán durante el runtime. Si se carece de la autorización de uso requerida aparecerá un diálogo de información.
  • Gris: Los menús estarán en gris y no manejables durante el runtime.
  • Invisible Las entradas de menú no se mostrarán durante el runtime.

Observación: La propiedad estará desactivada si la propiedad Login temporal activado está activada.

Por defecto: Normal

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DisMenuItemsDrawing


IDP_PRJ_LOGIN_PIC

Interne ID: IDP_PRJ_LOGIN_PIC

Pantalla para login

Selección de la pantalla que se utilizará para registrarse o ejecutar la función Login con diálogo. Seleccionar haciendo clic sobre el botón ... Solo se pueden seleccionar pantallas del tipo Login. Si no hay ninguna pantalla vinculada se activará un diálogo modal para el Login.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LoginPicture


IDP_PRJ_LOGINSIGNATURE_PIC

Interne ID: IDP_PRJ_LOGINSIGNATURE_PIC

Pantalla para login con firma

Selección de la pantalla que se activará para el login con firma. Seleccionar haciendo clic sobre el botón ... Solo se pueden seleccionar pantallas del tipo Login. Si no hay ninguna pantalla vinculada se activará un diálogo modal para el Login con firma.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LoginSignaturePicture


IDP_PRJ_RECURSIVE_LOGIN

Interne ID: IDP_PRJ_RECURSIVE_LOGIN

Login/Logout automático en subproyectos

Permite el registro/salida (login/logout) automático en subproyectos.

Activado: Un usuario del proyecto global que se registre en un proyecto se registrará también automáticamente en todos los subproyectos y al salirse se saldrá igualmente de todos los proyectos.

No disponible para proyectos globales y proyectos con la propiedad Proyecto WindowsCE activada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RecursiveLogin


IDP_PRN_MAXJOBS

Interne ID: IDP_PRN_MAXJOBS

Número máx. de tareas de impresión

Número máximo de tareas de impresión en el administrador de impresión de Windows. Cuando se sobrepase este número se generará una entrada en la lista cronológica de eventos (CEL).

  • Mínimo: 0
  • Máximo: 65535
  • Por defecto: 90

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MaxPrintJobs


IDP_PROJEKT_LOCKVAR

Interne ID: IDP_PROJEKT_LOCKVAR

Bloqueo de utilización

Permite establecer un bloqueo condicionado en proyectos sin red mediante una variable binaria.
Haciendo clic sobre el botón ... se abre un diálogo para elegir una variable binaria.

Valor de respuesta:

  • >0: Carece de autorización de uso.
  • 0: Autorización de uso existente

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LockVar


IDP_PWL_EXECUTE

Interne ID: IDP_PWL_EXECUTE

Nivel de autorización para ejecutar

Define los niveles de autorización necesarios para interbloquear. Haciendo clic en Niveles se abre una lista desplegable para seleccionar.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PwlExecute


IDP_PWL_UNLOCK

Interne ID: IDP_PWL_UNLOCK

Nivel de autorización para desbloquear

Define los niveles de autorización necesarios para desbloquear. Haciendo clic en Niveles se abre una lista desplegable para seleccionar.

Observación: desactivado con las acciones de comando del tipo Comando obligatorio.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PwlUnlock


IDP_RGM_BINARYPARAMETER

Interne ID: IDP_RGM_BINARYPARAMETER

Parámetro binario

Selección de un teclado para entradas binarias Haciendo clic sobre el botón ... se abre un diálogo para seleccionar una pantalla del tipo Teclado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BoolKbd


IDP_RGM_DATASOURCE

Interne ID: IDP_RGM_DATASOURCE

DataSource

Selección del fichero deseado para el administrador del grupo de recetas de la lista desplegable.

  • MS Access DB: Base de datos MS Access DB No apto para Windows CE.
  • Archivos binarios (compatible con CE): Para utilizar el RGM en el PC y con Windows CE.

Por defecto: Archivos binarios (compatible con CE)

Observación: Si se activa la opción Proyecto WindowsCE el archivo de datos se configurará automáticamente en Datos binarios. No está prevista una conversión de los datos a posteriori.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DataSource


IDP_RGM_FILTER

Interne ID: IDP_RGM_FILTER

Texto filtro

Entrada de los textos de filtro para variables.

Máximo: 65535 caracter

Más en la ayuda online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Filter


IDP_RGM_GROUP_ALLGEMEIN

Interne ID: IDP_RGM_GROUP_ALLGEMEIN

General

Configuraciones generales para grupos de recetas.

Observación: Se pueden añadir como máximo 32.000 variables a un grupo de recetas.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Allgemein


IDP_RGM_GROUP_FEEDBACK

Interne ID: IDP_RGM_GROUP_FEEDBACK

Feedback

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback


IDP_RGM_GROUP_FEEDBACK_CHECK

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK

Feedback verificar valores de receta

Variables de respuesta para Comprobar valor de receta.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check


IDP_RGM_GROUP_FEEDBACK_CHECK_CMT1

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK_CMT1

Comentario 1

Comentario 1 de la última receta comprobada.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check_Comment1


IDP_RGM_GROUP_FEEDBACK_CHECK_CMT2

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK_CMT2

Comentario 2

Comentario 2 de la última receta comprobada.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check_Comment2


IDP_RGM_GROUP_FEEDBACK_CHECK_CMT3

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK_CMT3

Comentario 3

Comentario 3 de la última receta comprobada.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check_Comment3


IDP_RGM_GROUP_FEEDBACK_CHECK_CMT4

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK_CMT4

Comentario 4

Comentario 4 de la última receta comprobada.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check_Comment4


IDP_RGM_GROUP_FEEDBACK_CHECK_CMT5

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK_CMT5

Comentario 5

Comentario 5 de la última receta comprobada.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check_Comment5


IDP_RGM_GROUP_FEEDBACK_CHECK_CMT6

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK_CMT6

Comentario 6

Comentario 6 de la última receta comprobada.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check_Comment6


IDP_RGM_GROUP_FEEDBACK_CHECK_CMT7

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK_CMT7

Comentario 7

Comentario 7 de la última receta comprobada.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check_Comment7


IDP_RGM_GROUP_FEEDBACK_CHECK_CMT8

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK_CMT8

Comentario 8

Comentario 8 de la última receta comprobada.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check_Comment8


IDP_RGM_GROUP_FEEDBACK_CHECK_DIFFER

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK_DIFFER

Comprobar receta - Desviaciones

Desviaciones del resultado de la comprobación de la receta como texto.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check_Different


IDP_RGM_GROUP_FEEDBACK_CHECK_NAME

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK_NAME

Nombre de receta

Nombre de la última receta comprobada.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check_Name


IDP_RGM_GROUP_FEEDBACK_CHECK_NUMBER

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK_NUMBER

Número de receta

Número de la última receta comprobada.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check_Number


IDP_RGM_GROUP_FEEDBACK_CHECK_RESULT

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK_RESULT

Comprobar receta - Resultado

Resultado de la comprobación de la receta como valor numérico.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check_Result


IDP_RGM_GROUP_FEEDBACK_CHECK_RIGHTS

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK_RIGHTS

Nivel de autorización

Nivel de autorización de uso de la última receta comprobada.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check_Rights


IDP_RGM_GROUP_FEEDBACK_CHECK_STATUS_NR

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK_STATUS_NR

Número de estado de receta

Estado de la última receta comprobada como número.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check_Status_Nr


IDP_RGM_GROUP_FEEDBACK_CHECK_STATUS_TXT

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK_STATUS_TXT

Texto de estado de receta

Estado de la última receta comprobada. El texto tiene el formato: 1 - @Texto
Este texto se escribirá como texto sin formato en la variable. Para ver el texto traducido tiene que estar activada la propiedad Traducir texto de avido en el elemento indicador (texto dinámico).

Haciendo clic sobre el botón ... se abre el diálogo de selección de variables.

Valores: Ver Variables del driver del sistema - Recetas estándar y Administrador de grupos de recetas.

Más en la ayuda online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check_Status_Txt


IDP_RGM_GROUP_FEEDBACK_CHECK_TIMECHANGE

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK_TIMECHANGE

Hora de la modificación

Hora de la última modificación de receta de la última receta comprobada.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check_Timechange


IDP_RGM_GROUP_FEEDBACK_CHECK_USERCHANGE

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK_USERCHANGE

Usuario de la modificación

Nombre del usuario registrado en la última modificación de receta de la última receta comprobada.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check_Userchange


IDP_RGM_GROUP_FEEDBACK_CHECK_VERSION

Interne ID: IDP_RGM_GROUP_FEEDBACK_CHECK_VERSION

Versión de receta

Versión de la última receta comprobada.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Check_Version


IDP_RGM_GROUP_FEEDBACK_READ

Interne ID: IDP_RGM_GROUP_FEEDBACK_READ

Feedback leer receta

Variables de respuesta para Leer receta.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Read


IDP_RGM_GROUP_FEEDBACK_READ_CMT1

Interne ID: IDP_RGM_GROUP_FEEDBACK_READ_CMT1

Comentario 1

Comentario 1 de la última receta leída.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Read_Comment1


IDP_RGM_GROUP_FEEDBACK_READ_CMT2

Interne ID: IDP_RGM_GROUP_FEEDBACK_READ_CMT2

Comentario 2

Comentario 2 de la última receta leída.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Read_Comment2


IDP_RGM_GROUP_FEEDBACK_READ_CMT3

Interne ID: IDP_RGM_GROUP_FEEDBACK_READ_CMT3

Comentario 3

Comentario 3 de la última receta leída.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Read_Comment3


IDP_RGM_GROUP_FEEDBACK_READ_CMT4

Interne ID: IDP_RGM_GROUP_FEEDBACK_READ_CMT4

Comentario 4

Comentario 4 de la última receta leída.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Read_Comment4


IDP_RGM_GROUP_FEEDBACK_READ_CMT5

Interne ID: IDP_RGM_GROUP_FEEDBACK_READ_CMT5

Comentario 5

Comentario 5 de la última receta leída.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Read_Comment5


IDP_RGM_GROUP_FEEDBACK_READ_CMT6

Interne ID: IDP_RGM_GROUP_FEEDBACK_READ_CMT6

Comentario 6

Comentario 6 de la última receta leída.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Read_Comment6


IDP_RGM_GROUP_FEEDBACK_READ_CMT7

Interne ID: IDP_RGM_GROUP_FEEDBACK_READ_CMT7

Comentario 7

Comentario 7 de la última receta leída.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Read_Comment7


IDP_RGM_GROUP_FEEDBACK_READ_CMT8

Interne ID: IDP_RGM_GROUP_FEEDBACK_READ_CMT8

Comentario 8

Comentario 8 de la última receta leída.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Read_Comment8


IDP_RGM_GROUP_FEEDBACK_READ_NAME

Interne ID: IDP_RGM_GROUP_FEEDBACK_READ_NAME

Nombre de receta

Nombre de la última receta leída.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Read_Name


IDP_RGM_GROUP_FEEDBACK_READ_NUMBER

Interne ID: IDP_RGM_GROUP_FEEDBACK_READ_NUMBER

Número de receta

Número de la última receta leída.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Read_Number


IDP_RGM_GROUP_FEEDBACK_READ_RESULT

Interne ID: IDP_RGM_GROUP_FEEDBACK_READ_RESULT

Receta terminada de leer

Resultado de la lectura de receta como valor numérico.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Read_Result


IDP_RGM_GROUP_FEEDBACK_READ_RIGHTS

Interne ID: IDP_RGM_GROUP_FEEDBACK_READ_RIGHTS

Nivel de autorización

Nivel de autorización de uso de la última receta leída.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Read_Rights


IDP_RGM_GROUP_FEEDBACK_READ_STATUS_NR

Interne ID: IDP_RGM_GROUP_FEEDBACK_READ_STATUS_NR

Número de estado de receta

Estado de la última receta leída como número.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Read_Status_Nr


IDP_RGM_GROUP_FEEDBACK_READ_STATUS_TXT

Interne ID: IDP_RGM_GROUP_FEEDBACK_READ_STATUS_TXT

Texto de estado de receta

Estado de la última receta leída. El texto tiene el formato: 1 - @Texto
Este texto se escribirá como texto sin formato en la variable. Para ver el texto traducido tiene que estar activada la propiedad Traducir texto de avido en el elemento indicador (texto dinámico).

Haciendo clic sobre el botón ... se abre el diálogo de selección de variables.

Valores: Ver Variables del driver del sistema - Recetas estándar y Administrador de grupos de recetas.

Más en la ayuda online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Read_Status_Txt


IDP_RGM_GROUP_FEEDBACK_READ_TIMECHANGE

Interne ID: IDP_RGM_GROUP_FEEDBACK_READ_TIMECHANGE

Hora de la modificación

Hora de la última modificación de receta de la última receta leída.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Read_Timechange


IDP_RGM_GROUP_FEEDBACK_READ_USERCHANGE

Interne ID: IDP_RGM_GROUP_FEEDBACK_READ_USERCHANGE

Usuario de la modificación

Nombre del usuario registrado en la última modificación de receta de la última receta leída.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Read_Userchange


IDP_RGM_GROUP_FEEDBACK_READ_VERSION

Interne ID: IDP_RGM_GROUP_FEEDBACK_READ_VERSION

Versión de receta

Versión de la última receta leída.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Read_Version


IDP_RGM_GROUP_FEEDBACK_WRITE

Interne ID: IDP_RGM_GROUP_FEEDBACK_WRITE

Feedback escribir receta

Variables de respuesta para Escribir receta.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Write


IDP_RGM_GROUP_FEEDBACK_WRITE_CMT1

Interne ID: IDP_RGM_GROUP_FEEDBACK_WRITE_CMT1

Comentario 1

Comentario 1 de la última receta escrita.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Write_Comment1


IDP_RGM_GROUP_FEEDBACK_WRITE_CMT2

Interne ID: IDP_RGM_GROUP_FEEDBACK_WRITE_CMT2

Comentario 2

Comentario 2 de la última receta escrita.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Write_Comment2


IDP_RGM_GROUP_FEEDBACK_WRITE_CMT3

Interne ID: IDP_RGM_GROUP_FEEDBACK_WRITE_CMT3

Comentario 3

Comentario 3 de la última receta escrita.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Write_Comment3


IDP_RGM_GROUP_FEEDBACK_WRITE_CMT4

Interne ID: IDP_RGM_GROUP_FEEDBACK_WRITE_CMT4

Comentario 4

Comentario 4 de la última receta escrita.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Write_Comment4


IDP_RGM_GROUP_FEEDBACK_WRITE_CMT5

Interne ID: IDP_RGM_GROUP_FEEDBACK_WRITE_CMT5

Comentario 5

Comentario 5 de la última receta escrita.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Write_Comment5


IDP_RGM_GROUP_FEEDBACK_WRITE_CMT6

Interne ID: IDP_RGM_GROUP_FEEDBACK_WRITE_CMT6

Comentario 6

Comentario 6 de la última receta escrita.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Write_Comment6


IDP_RGM_GROUP_FEEDBACK_WRITE_CMT7

Interne ID: IDP_RGM_GROUP_FEEDBACK_WRITE_CMT7

Comentario 7

Comentario 7 de la última receta escrita.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Write_Comment7


IDP_RGM_GROUP_FEEDBACK_WRITE_CMT8

Interne ID: IDP_RGM_GROUP_FEEDBACK_WRITE_CMT8

Comentario 8

Comentario 8 de la última receta escrita.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Write_Comment8


IDP_RGM_GROUP_FEEDBACK_WRITE_NAME

Interne ID: IDP_RGM_GROUP_FEEDBACK_WRITE_NAME

Nombre de receta

Nombre de la última receta escrita.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Write_Name


IDP_RGM_GROUP_FEEDBACK_WRITE_NUMBER

Interne ID: IDP_RGM_GROUP_FEEDBACK_WRITE_NUMBER

Número de receta

Número de la última receta escrita.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Write_Number


IDP_RGM_GROUP_FEEDBACK_WRITE_RESULT

Interne ID: IDP_RGM_GROUP_FEEDBACK_WRITE_RESULT

Receta terminada de escribir

Resultado de la escritura de la receta como valor numérico.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Write_Result


IDP_RGM_GROUP_FEEDBACK_WRITE_RIGHTS

Interne ID: IDP_RGM_GROUP_FEEDBACK_WRITE_RIGHTS

Nivel de autorización

Nivel de autorización de uso de la última receta escrita.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Write_Rights


IDP_RGM_GROUP_FEEDBACK_WRITE_STATUS_NR

Interne ID: IDP_RGM_GROUP_FEEDBACK_WRITE_STATUS_NR

Número de estado de receta

Estado de la última receta escrita como número.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Write_Status_Nr


IDP_RGM_GROUP_FEEDBACK_WRITE_STATUS_TXT

Interne ID: IDP_RGM_GROUP_FEEDBACK_WRITE_STATUS_TXT

Texto de estado de receta

Estado de la última receta escrita. El texto tiene el formato: 1 - @Texto
Este texto se escribirá como texto sin formato en la variable. Para ver el texto traducido tiene que estar activada la propiedad Traducir texto de avido en el elemento indicador (texto dinámico).

Haciendo clic sobre el botón ... se abre el diálogo de selección de variables.

Valores: Ver Variables del driver del sistema - Recetas estándar y Administrador de grupos de recetas.

Más en la ayuda online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Write_Status_Txt


IDP_RGM_GROUP_FEEDBACK_WRITE_TIMECHANGE

Interne ID: IDP_RGM_GROUP_FEEDBACK_WRITE_TIMECHANGE

Hora de la modificación

Hora de la última modificación de receta de la última receta escrita.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Write_Timechange


IDP_RGM_GROUP_FEEDBACK_WRITE_USERCHANGE

Interne ID: IDP_RGM_GROUP_FEEDBACK_WRITE_USERCHANGE

Usuario de la modificación

Nombre del usuario registrado en la última modificación de receta de la última receta escrita.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Write_Userchange


IDP_RGM_GROUP_FEEDBACK_WRITE_VERSION

Interne ID: IDP_RGM_GROUP_FEEDBACK_WRITE_VERSION

Versión de receta

Versión de la última receta escrita.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_Write_Version


IDP_RGM_GROUP_FEEDBACK_XMLIMPORT

Interne ID: IDP_RGM_GROUP_FEEDBACK_XMLIMPORT

Feedback importación XML

Variables de respuesta para importar XML.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_XMLImport


IDP_RGM_GROUP_FEEDBACK_XMLIMPORT_RESULT

Interne ID: IDP_RGM_GROUP_FEEDBACK_XMLIMPORT_RESULT

Resultado de la importación

Importación XML realizada con éxito.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Feedback_XMLImport_Result


IDP_RGM_INTERLOCKING

Interne ID: IDP_RGM_INTERLOCKING

Interbloqueo

Asignación de un interbloqueo a variables. Seleccionar de la lista desplegable.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Interlocking


IDP_RGM_KEYBOARD

Interne ID: IDP_RGM_KEYBOARD

Representación del teclado

Vínculo de una pantalla del tipo teclado que se activará durante el runtime haciendo clic izquierdo sobre la variable para introducir los valores. Haciendo clic sobre el botón se abre un diálogo de selección.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Keyboard


IDP_RGM_NUMERICPARAMETER

Interne ID: IDP_RGM_NUMERICPARAMETER

Parámetros numéricos

Selección de un teclado para entradas numéricas Haciendo clic sobre el botón ... se abre un diálogo para seleccionar una pantalla del tipo Teclado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NumKbd


IDP_RGM_RCP_COMMENT3

Interne ID: IDP_RGM_RCP_COMMENT3

Comentario 3

Fila 3 del comentario para la receta actual.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Comment3


IDP_RGM_RCP_COMMENT4

Interne ID: IDP_RGM_RCP_COMMENT4

Comentario 4

Fila 4 del comentario para la receta actual.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Comment4


IDP_RGM_RCP_COMMENT5

Interne ID: IDP_RGM_RCP_COMMENT5

Comentario 5

Fila 5 del comentario para la receta actual.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Comment5


IDP_RGM_RCP_COMMENT6

Interne ID: IDP_RGM_RCP_COMMENT6

Comentario 6

Fila 6 del comentario para la receta actual.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Comment6


IDP_RGM_RCP_COMMENT7

Interne ID: IDP_RGM_RCP_COMMENT7

Comentario 7

Fila 7 del comentario para la receta actual.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Comment7


IDP_RGM_RCP_COMMENT8

Interne ID: IDP_RGM_RCP_COMMENT8

Comentario 8

Fila 8 del comentario para la receta actual.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Comment8


IDP_RGM_RCP_COMMENTS_GRP

Interne ID: IDP_RGM_RCP_COMMENTS_GRP

Comentarios

Grupo de comentarios de receta. Se pueden introducir 8 comentarios por receta.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Comments


IDP_RGM_RECIPE_ALLGEMEIN

Interne ID: IDP_RGM_RECIPE_ALLGEMEIN

General

Propiedades generales de recetas.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Allgemein


IDP_RGM_RECIPE_STATUS

Interne ID: IDP_RGM_RECIPE_STATUS

Estado

Selección del estado de receta de la lista desplegable: (Configuración del estado en la propiedad Administrador de grupos de recetas /Identificador estado de recetas.) El estado de receta puede configurarse de manera distinta por cada Versión de receta. Esta propiedad se puede modificar también en el runtime.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Status


IDP_RGM_RECIPE_VERSION

Interne ID: IDP_RGM_RECIPE_VERSION

Versión de receta

Muestra el número de versión de la receta seleccionada. Solo para ver, no se permiten modificaciones. El número de versión se establecerá automáticamente por el sistema. Se pueden crear como máximo 89999 versiones de recetas.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RecipeVersion


IDP_RGM_REPORTFONT

Interne ID: IDP_RGM_REPORTFONT

Letra de tabla ajustable

  • Activado: En pantallas del tipo Administrador del grupo de recetas se puede configurar este paso. Se utilizará la fuente configurada en la propiedad Fuente.
  • Desactivado: Se utilizará la fuente estándar.

Por defecto: Desactivado

Si se utiliza una tabla personalizada (creada con el generador de informes), se utilizarán las fuentes configuradas en el informe.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ReportFont


IDP_RGM_SHADOW_VARIABLE

Interne ID: IDP_RGM_SHADOW_VARIABLE

Variable gráfica de receta

Las variables de receta gráficas permiten modificar una receta RGM mediante una pantalla durante el runtime. Para cada variable existente en un grupo de recetas se puede definir una variable de receta gráfica. Durante el runtime se sustituirá la variable RGM por una variable de receta gráfica usando la función Adm. de grupos de recetas con la acción Escribir valores de receta en variables de receta gráficas y después de una modificación se reescribirá en el RGM usando la acción Escribir variables de receta gráficas en valor de receta.

Haciendo clic sobre el botón se abre un diálogo para seleccionar variables sombra. Por cada grupo de recetas se puede utilizar una variable de receta gráfica solo una vez.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShadowVariable


IDP_RGM_STATUS_LIST

Interne ID: IDP_RGM_STATUS_LIST

Identificador estado de recetas

Configuración del indicador de estado. Haciendo clic sobre la propiedad se abre un diálogo de configuración. La lista de estados se utilizará para seleccionar el estado de la receta.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StatusList


IDP_RGM_STRINGPARAMETER

Interne ID: IDP_RGM_STRINGPARAMETER

Parámetro cadena

Selección de un teclado para entradas de cadena Haciendo clic sobre el botón ... se abre un diálogo para seleccionar una pantalla del tipo Teclado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

StringKbd


IDP_RGM_VARLNK_ALLGEMEIN

Interne ID: IDP_RGM_VARLNK_ALLGEMEIN

General

Propiedades generales para las variables en un grupo de recetas.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

General


IDP_RGM_VARLNK_BORDERS

Interne ID: IDP_RGM_VARLNK_BORDERS

Valores límite

Configuraciones para valores límite.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ValueBorders


IDP_RGM_VARLNK_GENERAL

Interne ID: IDP_RGM_VARLNK_GENERAL

Propiedades de los valores

Propiedades para valores.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ValueGeneral


IDP_RGM_VARLNK_RANGEFROMVAR

Interne ID: IDP_RGM_VARLNK_RANGEFROMVAR

Aplicar límite del valor predeterminado de la variable

Activado: Los límites de valores prestablecidos se tomarán dinámicamente de la variable y se establecerán en el grupo de recetas de manera no fija.

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RangeFromVar


IDP_RGM_VARLNK_SHADOW

Interne ID: IDP_RGM_VARLNK_SHADOW

Variable gráfica de receta

Propiedades para las variables de receta gráficas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShadowVarGrp


IDP_RGM_VISIBILITYVAR

Interne ID: IDP_RGM_VISIBILITYVAR

Variable de visibilidad

Selección de una variable para controlar la visibiliada. Haciendo clic sobre el botón ... se abre un diálogo de selección.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VisibilityVar


IDP_RT_BATCH_PREFMODULE

Interne ID: IDP_RT_BATCH_PREFMODULE

Módulo preferido

Selección del módulo que se utilizará en el runtime cuando existan al mismo tiempo varios módulos con licencia:

  • Batch Control
  • Secuencias de conmutación

Por defecto: Batch Control

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BatchPrefered


IDP_RTD_ACTION_OK

Interne ID: IDP_RTD_ACTION_OK

Exportación de datos

  • Activado: Cuando los datos se hayan exportado con éxito se mostrará un mensaje en el runtime.
  • Desactivado: No se mostrará dicho mensaje.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ActionOK


IDP_RTD_DLGFONT

Interne ID: IDP_RTD_DLGFONT

Fuente para el diálogo

Sólo disponible si Fuente para el diálogo editable está activado.

Defina aquí la fuente que desea utilizar en el runtime para diálogos y configuraciones variadas. Haciendo clic sobre el botón se abre un diálogo para elegir las fuentes.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RtDlgFont


IDP_RTD_ENDLGFONT

Interne ID: IDP_RTD_ENDLGFONT

Fuente para el diálogo editable

Permite mostrar diálogos y configuraciones variadas en el runtime con una fuente configurable. Seleccione la fuente deseada con ayuda de esta propiedad Fuente para el diálogo.

  • Activado: La fuente seleccionada abajo Fuente para el diálogo se utilizará en el runtime.
  • Desactivado: La fuente del sistema se utilizará en el runtime para diálogos y configuraciones variadas.

Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EnRtDlgFont


IDP_RTD_FILE_REPLACE

Interne ID: IDP_RTD_FILE_REPLACE

Sustituit archivos

  • Activado: Cuando en una exportación de datos se sobrescriba un archivo se mostrará un mensaje en el runtime.
  • Desactivado: No se mostrará dicho mensaje.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FileReplace


IDP_RTD_INSUFFICIENT_LEVEL

Interne ID: IDP_RTD_INSUFFICIENT_LEVEL

Licencia de uso insuficiente

Solo disponible si la propiedad Entrada errónea está activada.

  • Activado: Si un usuario registrado ejecuta una función durante el runtime para la que se requiere un nivel de autorización que no posee se mostrará una ventana con un mensaje de error.
  • Desactivado: Si se trata del nivel de autorización equivocado no aparecerá ningún mensaje de error. La variable driver del sistema Ninguna autorización para funciones se establecerá de todas maneras y se podrá analizar mediante el valor límite o la matriz de reacción.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InsufficientLevel


IDP_RTD_INVALID_INPUT

Interne ID: IDP_RTD_INVALID_INPUT

Entrada errónea

  • Activado: Las entradas erróneas de usuarios (al establecer valores predeterminados, registrarse, etc.) harán que aparezca en el runtime el mensaje correspondiente.
  • Desactivado: Los mensajes serán suprimidos. Para este caso, el driver del sistema dispone de variables bit, con las que vinculando una función con un valor límite se puede reaccionar a cada entrada errónea individualmente.

Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

InvalidInput


IDP_RTP_PICTBACKCOUNT

Interne ID: IDP_RTP_PICTBACKCOUNT

Número para la función 'Pantalla anterior'

Número de pantallas que se registrará en la lista para la función Número para la función 'Pantalla anterior'.
Observación: Cada invocación de la función Cambio de pantalla cuenta aunque no se produzca directamente sino que esté configurado como Función de inicio en las propiedades de pantalla.

  • Mínimo: 0
  • Máximo: 65535
  • Por defecto: 10

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackPictCount


IDP_RTP_SYSKEYLOCK

Interne ID: IDP_RTP_SYSKEYLOCK

Bloquear teclas del sistema

  • Activado: Las combinaciones de teclas como Alt+Esc, Ctrl+Esc, Alt+Tab, Alt-F4 etc. se bloquearán en el runtime.
  • Desactivado: Las combinaciones de teclas no se bloquearán.

Por defecto: Desactivado

Observación: También se pueden bloquear todas las teclas del sistema para el runtime. Ver más detalles en IKeyblock Runtime Start.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SysKeyLock


IDP_RTP_WATCHFILES

Interne ID: IDP_RTP_WATCHFILES

Indexar archivos runtime

Activado: Para el acceso rápido se activará un directorio caché para los datos runtime.

Desactivado: No se utilizará el directorio caché.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FileWatcher


IDP_SAMPLE

Interne ID: IDP_SAMPLE

Sample Additional

Ejemplo para un driver de muestra.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SampleTest


IDP_SCHALTFOLGEN_VISIBLE

Interne ID: IDP_SCHALTFOLGEN_VISIBLE

Nombre para mostrar en la rejilla de secuencias de comandos

Configuración de la visualización del texto durante el runtime para el módulo Secuencias de conmutación.

El usuario puede configurar aquí qué texto de la variable se mostrará en la trama de conmutación.

  • Nombre de variable
    Utiliza el nombre de la variable como texto para mostrar en la trama de conmutación
  • Identificación de variable
    Utiliza la identificación de la variable como texto para mostrar en la trama de conmutación.
    Esta identificación se proyectará para la variable en la propiedad Identificación.
  • Dirección simbólica
    Utiliza la dirección simbólica como texto para mostrar en la trama de conmutación.
    Esta identificación se proyectará para la variable en la propiedad Dirección simbólica.

Por defecto: Nombre de variable

Más en la ayuda online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VisibleChartName


IDP_SHIFT_BLOCK_DESCRIPTION

Interne ID: IDP_SHIFT_BLOCK_DESCRIPTION

Descripción

Propiedades generales del bloque de turnos.

Esta función se invocará para zenon API (con nombre de clase):

Description


IDP_SHIFT_BLOCK_GENERAL_GRP

Interne ID: IDP_SHIFT_BLOCK_GENERAL_GRP

General

Esta función se invocará para zenon API (con nombre de clase):

General


IDP_SHIFT_BLOCK_NAME

Interne ID: IDP_SHIFT_BLOCK_NAME

Nombre

Esta función se invocará para zenon API (con nombre de clase):

Name


IDP_SHIFT_MODEL_DESCRIPTION

Interne ID: IDP_SHIFT_MODEL_DESCRIPTION

Descripción

Cadena libremente definible para describir más detalladamente el modelo de turno. La descripción se puede cambiar de idioma.

Longitud máxima: 512 caracteres.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

Description


IDP_SHIFT_MODEL_GENERAL_GRP

Interne ID: IDP_SHIFT_MODEL_GENERAL_GRP

General

Propiedades generales del modelo de turnos.

Esta función se invocará para zenon API (con nombre de clase):

General


IDP_SHIFT_MODEL_GROUP_DESCRIPTION

Interne ID: IDP_SHIFT_MODEL_GROUP_DESCRIPTION

Descripción

Cadena libremente definible para describir más detalladamente el modelo de turno. La descripción se puede cambiar de idioma.

Longitud máxima: 512 caracteres.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

Description


IDP_SHIFT_MODEL_GROUP_GENERAL_GRP

Interne ID: IDP_SHIFT_MODEL_GROUP_GENERAL_GRP

General

Propiedades generales del modelo de turnos.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

General


IDP_SHIFT_MODEL_GROUP_NAME

Interne ID: IDP_SHIFT_MODEL_GROUP_NAME

Nombre

Nombre del modelo de turno. El nombre tiene que ser único para cada proyecto, no puede estar formado solo por espacios en blanco ni estar vacío. Los siguientes caracteres están prohibidos: / \ : * ? < > ! | " ' # % @ .

El nombre se puede cambiar de un idioma a otro.

Por defecto: Grupo de modelos de turno x (x corresponde a un número sucesivo).

Longitud máxima: 256 caracteres.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

Name


IDP_SHIFT_MODEL_NAME

Interne ID: IDP_SHIFT_MODEL_NAME

Nombre

Nombre del modelo de turno. El nombre tiene que ser único para cada proyecto, no puede estar formado solo por espacios en blanco ni estar vacío. Los siguientes caracteres están prohibidos: / \ : * ? < > ! | " ' # % @ .

El nombre se puede cambiar de un idioma a otro.

Por defecto: Modelos de turno x(x corresponde a un número sucesivo).

Longitud máxima: 256 caracteres.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

Name


IDP_STRATON_CMD_BINDPORT

Interne ID: IDP_STRATON_CMD_BINDPORT

Puerto de eventos

Esta propiedad sólo es relevante para los tipos de inicio del runtime “iniciar/finalizar automáticamente” e “iniciar automáticamente”.

Número de puerto que el runtime zenon Logic abre al iniciar. "Binding" representa al puerto para la transmisión de datos espontánea (desencadenada por eventos).
Mínimo: 0
Máximo: 4294967295.
Por defecto: 9000

Atención: Debe superar al puerto principal en 7800.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CMDBindPort


IDP_STRATON_CMD_HOST

Interne ID: IDP_STRATON_CMD_HOST

Host

Esta propiedad sólo es relevante para los tipos de inicio del runtime "iniciar/finalizar automáticamente" e "iniciar automáticamente".
¡El runtime zenon Logic sólo se iniciará si estos parámetros concuerdan con la dirección IP propia o el nombre del ordenador!

Normalmente debe poner aquí "localhost" o 127.0.0.1. En algunos casos es necesario introducir una dirección IP concreta o el nombre del ordenador. Esto es necesario si el runtime zenon Logic tiene que iniciarse en un solo ordenador para varios proyectos individuales iguales. Otra razón puede ser que el runtime zenon Logic deba iniciarse en una máquina cliente zenon pero no en el servidor.

La modificación de este parámetro copia automáticamente la dirección host y el puerto principal en la configuración del driver straton32 correspondiente. En caso de que no lo desee debe modificar manualmente este parámetro en el driver straton32.

Por defecto: localhost

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CMDHost


IDP_STRATON_CMD_LOG

Interne ID: IDP_STRATON_CMD_LOG

Protokolldatei führen

Esta propiedad sólo es relevante para los tipos de inicio del runtime “iniciar/finalizar automáticamente” e “iniciar automáticamente”.
Activado: Los mensajes de error que emita el runtime zenon Logic se guardarán en un archivo.
Desactivado: Los mensajes de error que emita el runtime zenon Logic no se guardarán en un archivo.
Por defecto: desactivado.

ATENCIÓN: ¡Escribir en los archivos de protocolo puede afectar al ciclo PLC!

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CMDTrace


IDP_STRATON_CMD_MAINPORT

Interne ID: IDP_STRATON_CMD_MAINPORT

Puerto estándar

Esta propiedad sólo es relevante para los tipos de inicio del runtime "iniciar/finalizar automáticamente" e "iniciar automáticamente".
Número de puerto que abre el runtime zenon Logic al iniciar. "Principal" representa el puerto para la lectura cíclica de los valores zenon Logic.

La modificación de este parámetro copia automáticamente la dirección host y el puerto principal en la configuración del driver straton32 correspondiente. En caso de que no lo desee debe modificar manualmente este parámetro en el driver straton32.

Mínimo: 00
Máximo: 4294967295
Por defecto:: 1200

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CMDMainPort


IDP_STRATON_CMD_PRIO

Interne ID: IDP_STRATON_CMD_PRIO

Prioridad de tiempo real

Esta propiedad sólo es relevante para los tipos de inicio del runtime “iniciar/finalizar automáticamente” e “iniciar automáticamente”.
Activado: Asigna al proceso del runtime zenon Logic la prioridad de Windows "Tiempo real".
Desactivado: Asigna al proceso del runtime zenon Logic la prioridad de Windows "Normal".
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CMDPrio


IDP_STRATON_CMD_REDUNDANCY

Interne ID: IDP_STRATON_CMD_REDUNDANCY

Funcionamiento redundante

Activado: El runtime zenon Logic se iniciará de forma redundante.
Desactivado:: El runtime zenon Logic no se iniciará de forma redundante.

Por defecto: Desactivado.

ATENCIÓN: Hay que iniciar el runtime standby.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CMDRedundancy


IDP_STRATON_CMD_RETAINBYNAME

Interne ID: IDP_STRATON_CMD_RETAINBYNAME

Guardar variables retenidas con nombre

Guarda las variables retenidas con su nombre de variable si ha seleccionado el Tipo de inicio iniciar/finalizar automáticamente. Además las variables de retención se incrustarán automáticamente en zenon Logic.

Observación: Para utilizar también esta función con el inicio de runtime manual tiene que activar dicha opción. Adicionalmente deberá activar la opción a través de los parámetros de filas de comandos o del diálogo de configuración/archivo INI.

Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CMDRetainByName


IDP_STRATON_CMD_START

Interne ID: IDP_STRATON_CMD_START

Inicio

Esta propiedad sólo es relevante para los tipos de inicio del runtime “iniciar/finalizar automáticamente” e “iniciar automáticamente”.
Inicio en frío: Inicio comenzado. También las variables de retención se inicializarán.
Inicio en frío (cargar variables RETAIN): Inicio comenzado con los valores actuales de las variables de retención.
Inicio en caliente: Reiniciar con todos los valores de las variables como al finalizar.
Por defecto: Inicio en frío:

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CMDStartup


IDP_STRATON_CMD_STEP

Interne ID: IDP_STRATON_CMD_STEP

Inicio en modo pasos

Esta propiedad sólo es relevante para los tipos de inicio del runtime “iniciar/finalizar automáticamente” e “iniciar automáticamente”.
Activado: Inicia el runtime zenon Logic pero lo pone enseguida en modo debugging.
Desactivado: Inicia el runtime zenon Logic normal.
Por defecto: desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CMDStep


IDP_STRATON_FKT_WDG_TO

Interne ID: IDP_STRATON_FKT_WDG_TO

Función para detección de averías

Selección de la función que debe ser ejecutada después del transcurso del periodo definido en la propiedad Detección de averías después de [s]. Haciendo clic sobre el botón ... se abre un diálogo para elegir una función.

Después del transcurso del timeout la comprobación del watchdog empezará después de volver a registrar el runtime. Si se utiliza una función de otro proyecto, dicho proyecto debe estar cargado cuando se carge el proyecto con el proyecto zenon Logic integrado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VmFktWdgTo


IDP_STRATON_RUNTIME

Interne ID: IDP_STRATON_RUNTIME

Runtime

Propiedades para el runtime zenon Logic (Soft PCL).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Runtime


IDP_STRATON_TIMEOUT

Interne ID: IDP_STRATON_TIMEOUT

Tiempo de espera para conexión [s]

Timeout (en segundos) para la conexión a sistemas de destino zenon Logic.
En plataformas de destino de muy baja capacidad se puede aumentar este timeout.
Mínimo: 0
Máximo: 4294967295.
Por defecto: 10.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Timeout


IDP_STRATON_WDG_TO

Interne ID: IDP_STRATON_WDG_TO

Detección de averías después de [s]

Entrada del tiempo en segundos dentro del que se debe cambiar el watchdog del runtime zenon Logic. Después del transcurso del tiempo se ejecutará la función configurada en Función para detección de averías.

0: desactiva el temporizador watchdog

Por defecto: para proyectos nuevos 30 s, para proyectos existentes 0 s.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VmWdgTo


IDP_STRATON_WORKBENCH

Interne ID: IDP_STRATON_WORKBENCH

Workbench

Propiedades para el workbench zenon Logic.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Workbench


IDP_USER_LOGIN_RTP

Interne ID: IDP_USER_LOGIN_RTP

Perfil del runtime

Selección de los perfiles de runtime que se asignan al usuario al registrarse. Perfiles posibles:

ninguno. No se asignará ningún perfil

POR DEFECTO: Se asignará el perfil POR DEFECTO

ÚLTIMO: Se asignará el perfil ÚLTIMO

Por defecto: ninguno.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LoginRTP


IDP_VALUE_LEADING_ZEROS

Interne ID: IDP_VALUE_LEADING_ZEROS

Mostrar ceros destacados

Sólo disponible cuando haya seleccionado binario, decimal, hexadecimal u octal en la propiedad Base numérica para visualización.

Decida si desea que se muestren los ceros cuando se muestren los valores numéricos.

  • Desactivado: Los ceros a la izquierda no se mostrarán.
  • Activado: Los valores numéricos se representarán según su base numérica con una cantidad de cifras diferente. El puesto de las cifras no ocupadas se rellenará con ceros a la izquierda.

Por defecto: Desactivado

Para las diferentes bases numéricas tiene las siguiente posibilidades:

  • Binaria: 32 cifras
  • Decimal: 10 cifras
  • Hexadecimal: 8 cifras
  • Octal: 11 cifras

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ShowLeadingZeros


IDP_WSP_MON_FRAME_CX

Interne ID: IDP_WSP_MON_FRAME_CX

Anchura de la ventana del runtime [píxeles]

Anchura en píxeles de la ventana principal durante el runtime.

Observación: Esta configuración solo será aplicable al ordenador local.

Rango de valor: 0 a 65535
Por defecto: 0 (automático)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RTMainFrame_CX


IDP_WSP_MON_FRAME_CY

Interne ID: IDP_WSP_MON_FRAME_CY

Altura ventana del runtime [píxeles]

Altura en píxeles de la ventana principal durante el runtime.

Observación: Esta configuración solo será aplicable al ordenador local.

Rango de valor: 0 a 65535
Por defecto: 0 (automático)

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RTMainFrame_CY


IDP_WSP_MON_GRP

Interne ID: IDP_WSP_MON_GRP

Tamaño local del runtime

Grupo para la configuración aplicable a todos los proyectos del tamaño de la ventana principal durante el runtime.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

CompMonSettings


IDS_A_GERAET

Interne ID: IDS_A_GERAET

A-Device

Número del dispositivo A.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DeviceA


IDS_ANIMATION

Interne ID: IDS_ANIMATION

Animación GIF

Propiedades para la animación cuando se utiliza un archivo GIF animado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Animation


IDS_B_GERAET

Interne ID: IDS_B_GERAET

B-Device

Número del dispositivo B.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DeviceB


IDS_BACNETNG_DATATYPE

Interne ID: IDS_BACNETNG_DATATYPE

BACnet data type

Defina cómo debe representarse una variable numérica o una variable de cadena en una propiedad BACnet. Seleccione el tipo de dato deseado de la lista desplegable. Las descripciones de los tipos de dato posibles se encuentran en el manual online.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BACnetDataType


IDS_BACNETNG_EVENTSTATE

Interne ID: IDS_BACNETNG_EVENTSTATE

BACnet event state

Representar estado del Estado de evento como número. En este caso se puede definir libremente el texto para el Estado de evento.

Valores:

-1: Se utilizará el texto.

0: Normal

1: Error

2: Off-normal

3: High-limit

4: Low-limit

5: Life-safety-alarm

Por defecto: -1

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BACnetEventState


IDS_BACNETNG_PROPERTYID

Interne ID: IDS_BACNETNG_PROPERTYID

BACnet property ID

Configure el ID de propiedad para propiedades específicas de usuarios o cuano no desee introducir la propiedad con el nombre o identificación.

Observación: Sólo si establece -1 se localizará la propiedad con el nombre o identificación.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BACnetPropertyID


IDS_BACNETNG_STRINGLENGTH

Interne ID: IDS_BACNETNG_STRINGLENGTH

BACnet string length

Sólo disponible si ha seleccionado en la propiedad BACnet data type el tipo de dato BITSTRING.

Defina aquí el largo del bitstring en bits.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BACnetStringLength


IDS_BACNETNG_WRITEPRIORITY

Interne ID: IDS_BACNETNG_WRITEPRIORITY

BACnet write priority

Determine la prioridad de escritura con la que se escribirá la variable. Si introduce 0, la variable se escribirá sin información de la prioridad.

Los valores posibles son de 0 - 16.

Prioridad más baja: 16

Prioridad más alta: 1

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BACnetWritePriority


IDS_BAZ_WERT

Interne ID: IDS_BAZ_WERT

Befehlsausgabezeit

Befehlsausgabezeit

TK160: Befehlsausgabezeit in ms

IEC Datentypen:

0… wie in AX parametriert

1… kurz

2… mittel

3… lang

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BAZ_WERT


IDS_BAZ_WERT_ENG

Interne ID: IDS_BAZ_WERT_ENG

Command output time

TI160: Command output time in ms

IEC Data types:

0… as parameterized in AX

1… short

2… medium

3… long

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BAZ_WERT


IDS_BITSIZE

Interne ID: IDS_BITSIZE

BitSize

Tamaño bit del control.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NGBitsize


IDS_C_GERAET

Interne ID: IDS_C_GERAET

C-Device

Número del dispositivo B.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DeviceC


IDS_CTI_SECONDARYOBJECT

Interne ID: IDS_CTI_SECONDARYOBJECT

Secondary object

Determina el tipo de objeto secundario para

- Hora/Contador

- Drum

- Variable loop

- Variable de alarma

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SecondaryObject


IDS_DATENPUNKT

Interne ID: IDS_DATENPUNKT

Datapoint

Número del punto de datos de DDC.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Datapoint


IDS_DLL

Interne ID: IDS_DLL

Dll

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Dll


IDS_DP_GERAET

Interne ID: IDS_DP_GERAET

Datapoint to...

Dispositivo destinatario, p. ej. dispositivo B.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DeviceDp


IDS_DP_TYPE

Interne ID: IDS_DP_TYPE

Telegrammkennung

Telegrammtyp, Typkennung

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DP_TYPE


IDS_DP_TYPE_ENG

Interne ID: IDS_DP_TYPE_ENG

Telegram Identifier

Telegram type, Message type

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DP_TYPE


IDS_DYNAMICFARBE

Interne ID: IDS_DYNAMICFARBE

Colores dinámicos

Definición de los colores del elemento mediante los colores límite de la variable seleccionada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Colors_Dynamic


IDS_DYNAMISCH

Interne ID: IDS_DYNAMISCH

Tamaño y rotación dinámica

Propiedades sobre la dinámica del elemento.
La representación del elemento se ajustará dinámicamente durante el runtime mediante estados de variables. No disponible para proyectos con Windows CE.

Observación: Las configuraciones de este grupo no tienen ningún efecto sobre la representación de determinados elementos de control en las pantallas.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Dynamic


IDS_EIB_ADRESSE

Interne ID: IDS_EIB_ADRESSE

EIB-Address

Las propiedades siguientes sirven para direccionar el driver EibV2_32.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EIB-Address


IDS_EKANAL

Interne ID: IDS_EKANAL

Ersatz-PV

Ersatzvariable

Im Fehlerfall wird auf den Wert dieser Variablen umgeschaltet.

(siehe auch Parameter "Invalid-Behandlung")

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EW_EKANAL


IDS_EKANAL_ENG

Interne ID: IDS_EKANAL_ENG

Substitute variable

Substitute variable

In case of invalid state will be switched over to the value of this variable.

(see also parameter "Invalid treatment")

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EW_EKANAL


IDS_ELE_PROP_DREHEN

Interne ID: IDS_ELE_PROP_DREHEN

Girar

La rotación del elemento depende del valor de una variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Twist


IDS_ELE_PROP_XRICHTUNG

Interne ID: IDS_ELE_PROP_XRICHTUNG

Posición X dinámica

El desplazamiento horizontal del elemento depende del valor de la variable seleccionada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

XPos


IDS_ELE_PROP_XZOOMEN

Interne ID: IDS_ELE_PROP_XZOOMEN

Modificar anchura

La anchura del elemento depende del valor de la variable seleccionada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

XZoom


IDS_ELE_PROP_YRICHTUNG

Interne ID: IDS_ELE_PROP_YRICHTUNG

Posición Y dinámica

El desplazamiento vertical del elemento depende del valor de la variable seleccionada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

YPos


IDS_ELE_PROP_YZOOMEN

Interne ID: IDS_ELE_PROP_YZOOMEN

Modificar altura

La altura del elemento depende del valor de la variable seleccionada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

YZoom


IDS_ETS2_DATABASE

Interne ID: IDS_ETS2_DATABASE

ETS Database

Defina la base de datos deseada. Con un clic sobre el botón se abre un diálogo para elegir la base de datos. También puede introducir el nombre de la base de datos manualmente en el campo de texto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ETS2Database


IDS_EW

Interne ID: IDS_EW

Ersatzwert

Ersatzwert auf den umgeschaltet wird.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EW


IDS_EW_ENG

Interne ID: IDS_EW_ENG

Substitute value

Substitute value to be switched on

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EW


IDS_EWB

Interne ID: IDS_EWB

auf Ersatzwert schalten

Auf Ersatzwert schalten

Aktiv: Ersatzwert wird verwendet

Inaktiv: Ersatzwert wird nicht verwendet

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EWB


IDS_EWB_ENG

Interne ID: IDS_EWB_ENG

Toggle to substitute value

Switch to substitute value

Active: Substitute value will be used

Inactive: Substitute value will not be used

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EWB


IDS_EWB_INI

Interne ID: IDS_EWB_INI

Ersatzwert/Normalzustand initialisieren

Ersatzwert Initialisierung

Aktiv: Ersatzwert in der Runtime wird durch Normalzustand überschrieben

Inaktiv: Ersatzwert wird beibehalten

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EWB_INI


IDS_EWB_INI_ENG

Interne ID: IDS_EWB_INI_ENG

Inititialize substitute value/normal state

Initialization of substitute value

Active: Substitute value will be overwritten in runtime by normal state

Inactive: Substitute value will be kept

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EWB_INI


IDS_FOCUS_LINECOLOR

Interne ID: IDS_FOCUS_LINECOLOR

Color de línea del foco

Define el color del marco que identifica el objeto con el foco en el runtime. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FocusLineColor


IDS_FOCUS_LINEWIDTH

Interne ID: IDS_FOCUS_LINEWIDTH

Ancho de línea del foco

Define el ancho de línea del marco que identifica el objeto con el foco en el runtime.

Por defecto: 3 Píxel

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FocusLineWidth


IDS_GA

Interne ID: IDS_GA

GA-Antwort

Antwort auf Generalabfrage

Aktiv: Datenpunkt wird bei Generalabfrage gesendet

Inaktiv: Datenpunkt wird bei Generalabfrage nicht gesendet

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GA


IDS_GA_ENG

Interne ID: IDS_GA_ENG

GI-Reply

Datapoint answers to General request

Active: Datapoint will be sent at General request

Inactive: Datapoint will not be sent at General request

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GA


IDS_GLOW_BLINKVAR_PREVIEW

Interne ID: IDS_GLOW_BLINKVAR_PREVIEW

Mostrar vista previa del parpadeo

Muestra el límite definido para la variable de parpadeo con Glow. Solo disponible si para la propiedad Variable para parpadeo se ha configurado una variable.

Haciendo clic sobre el botón ... se abre un diálogo para mostrar los límites definidos. Los límites solo se mostrarán, no se pueden modificar. Las modificaciones deberán realizarse directamente en las propiedades de variables para Valores límites.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

GlowEffectBlinkVariablePreview


IDS_GLOW_COLORVAR_PREVIEW

Interne ID: IDS_GLOW_COLORVAR_PREVIEW

Mostrar vista previa del color

Muestra el límite definido para la variable de color con Glow. Solo disponible si para la propiedad Variable para color se ha configurado una variable.

Haciendo clic sobre el botón ... se abre un diálogo para mostrar los límites definidos. Los límites solo se mostrarán, no se pueden modificar. Las modificaciones deberán realizarse directamente en las propiedades de variables para Valores límites.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

GlowEffectGlowColorVariablePreview


IDS_GLOW_VISVAR_PREVIEW

Interne ID: IDS_GLOW_VISVAR_PREVIEW

Mostrar vista previa de visibilidad

Muestra el límite definido para la variable de visibilidad con Glow. Solo disponible si para la propiedad Variable para visibilidad se ha configurado una variable.

Haciendo clic sobre el botón ... se abre un diálogo para mostrar los límites definidos. Los límites solo se mostrarán, no se pueden modificar. Las modificaciones deberán realizarse directamente en las propiedades de variables para Valores límites.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

GlowEffectVisibilityVariablePreview


IDS_GT

Interne ID: IDS_GT

GT (Wdh.-rate in ms)

Befehlszykluszeit (Retriggerzeit) in ms

Regulierbefehle, Retriggerbefehle

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GT


IDS_GT_ENG

Interne ID: IDS_GT_ENG

GT [ms]

Command cycle (retriggered) time in ms

Regulating-, triggered commands

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GT


IDS_HAUPTGRUPPE

Interne ID: IDS_HAUPTGRUPPE

Main group

Introduzca el número del grupo principal deseado.

Mínimo: 0

Máximo: 15

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MainGroup


IDS_HGFARBE_VARIABLE

Interne ID: IDS_HGFARBE_VARIABLE

Color de relleno

Nombre de la variable cuyos colores de valor límite influirán en el color de fondo/relleno del elemento.
Abre diálogo de selección de las variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColorVariable


IDS_HGFARBE_VARIABLE2

Interne ID: IDS_HGFARBE_VARIABLE2

Gradiente de color

Nombre de la variable cuyo color del valor límite debe influir sobre el gradiente de color del elemento.
Haga clic en el campo de entrada para abrir un diálogo de selección de la variable.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColorVariable2


IDS_HGFARBE_VARIABLE2_PREVIEW

Interne ID: IDS_HGFARBE_VARIABLE2_PREVIEW

Mostrar vista previa del color

Muestra el límite definido para la variable para el color de relleno. Solo disponible si para la propiedad Gradiente de color se ha configurado una variable.

Haciendo clic sobre el botón ... se abre un diálogo para mostrar los límites definidos. Los límites solo se mostrarán, no se pueden modificar. Las modificaciones deberán realizarse directamente en las propiedades de variables para Valores límites.

Más en el manual online.

Esta función se invocará para zenon API (con nombre de clase):

BackColorVariable2Preview


IDS_I_BIT

Interne ID: IDS_I_BIT

Invalid-Behandlung

keine: keine Behandlung.

letzter gültiger Wert: Umschaltung auf Ersatzwertabbild mit letzem ungestörtem Wert.

Umschaltung auf Ersatzwert: Umschaltung auf Ersatzwertabbild; Wert von parametriertem Ersatzwert.

Umschaltung auf Ersatz-PV: Umschaltung auf Ersatzwertabbild; Wert von der Ersatz-PV.

Ersatzwert nachführen: Umschaltung auf Ersatzwertabbild; Wert muss händisch nachgeführt werden.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

I_BIT


IDS_I_BIT_ENG

Interne ID: IDS_I_BIT_ENG

Invalid treatment

Invalid treatment

No: no treatment

Last valid value: switch to substitute image; using last valid value

Toggle to substitute value: switch to substitute image; using parameterized substitute value

Toggle to substitute PV: switch to substitute image; using value from substitute PV

Correct substitute value: switch to substitute image; value must be corrected manually

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

I_BIT


IDS_IEC61850_ADDR

Interne ID: IDS_IEC61850_ADDR

IEC61850-Address

IEC Dirección-61850

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

I61850_ADR


IDS_IEC61850_CDC

Interne ID: IDS_IEC61850_CDC

CDC

CDC

Selección de CDC para la ampliación de los "nodos lógicos"

Por defecto: Por defecto

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

I61850_CDC


IDS_IEC61850_EWB

Interne ID: IDS_IEC61850_EWB

Toggle to substitute value

Cambiar al valor de sustitución

Activado: Valor actual = Valor de sustitución

Desactivado: Valor actual = Valor del proceso

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EWB


IDS_IEC61850_EWB_INI

Interne ID: IDS_IEC61850_EWB_INI

Inititialize substitute value

Inicializar valor de sustitución/estado normal

Activado: El valor de sustitución en el runtime se sobrescribirá por el estado del proceso.

Desactivado: El valor de sustitución se mantiene.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

EW_INI


IDS_IEC61850_GOOSE_ATTR1

Interne ID: IDS_IEC61850_GOOSE_ATTR1

GOOSE Attr1

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GOOSE_ATTR1


IDS_IEC61850_GOOSE_ATTR1_POS

Interne ID: IDS_IEC61850_GOOSE_ATTR1_POS

GOOSE Attr1 dataset position

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GOOSE_ATTR1_POS


IDS_IEC61850_GOOSE_ATTR2

Interne ID: IDS_IEC61850_GOOSE_ATTR2

GOOSE Attr2

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GOOSE_ATTR2


IDS_IEC61850_GOOSE_ATTR2_POS

Interne ID: IDS_IEC61850_GOOSE_ATTR2_POS

GOOSE Attr2 dataset position

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GOOSE_ATTR2_POS


IDS_IEC61850_GOOSE_ATTR3

Interne ID: IDS_IEC61850_GOOSE_ATTR3

GOOSE Attr3

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GOOSE_ATTR3


IDS_IEC61850_GOOSE_ATTR3_POS

Interne ID: IDS_IEC61850_GOOSE_ATTR3_POS

GOOSE Attr3 dataset position

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GOOSE_ATTR3_POS


IDS_IEC61850_GOOSE_ATTR4

Interne ID: IDS_IEC61850_GOOSE_ATTR4

GOOSE Attr4

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GOOSE_ATTR4


IDS_IEC61850_GOOSE_ATTR4_POS

Interne ID: IDS_IEC61850_GOOSE_ATTR4_POS

GOOSE Attr4 dataset position

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GOOSE_ATTR4_POS


IDS_IEC61850_GOOSE_ATTR5

Interne ID: IDS_IEC61850_GOOSE_ATTR5

GOOSE Attr5

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GOOSE_ATTR5


IDS_IEC61850_GOOSE_ATTR5_POS

Interne ID: IDS_IEC61850_GOOSE_ATTR5_POS

GOOSE Attr5 dataset position

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GOOSE_ATTR5_POS


IDS_IEC61850_GOOSE_IDX

Interne ID: IDS_IEC61850_GOOSE_IDX

GOOSE Index

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GOOSE_INDEX


IDS_IEC61850_IBIT

Interne ID: IDS_IEC61850_IBIT

Invalid treatment

Procesamiento inválido

ninguno: ningún procesamiento

último valor válido: Cambio a la imagen del valor de reserva con el último valor no alterado.

Cambio al valor de sustitución: Cambio a la imagen del valor de reserva; valor de reserva parametrizado.

Cambio al PV de sustitución: Cambio a la imagen del valor de reserva; valor del PV de reserva.

Correción manual del valor de sustitución: Cambio a la imagen del valor de reserva; el valor deberá actualizarse manualmente.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

I_BIT


IDS_IEC61850_LANNR

Interne ID: IDS_IEC61850_LANNR

IEC61850-Stationnumber

IEC61850-Stationsnummer

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

I61850_LAN


IDS_IEC61850_MERKER

Interne ID: IDS_IEC61850_MERKER

Marker

Marcador

Activado: Variable sin referencia al proceso (no se comprobará la dirección; para uso interno)

Desactivado: Se actualizará la variable por el proceso

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MERKER


IDS_IEC61850_ST_SAVE

Interne ID: IDS_IEC61850_ST_SAVE

Save state

Grabar estado

Activado: El estado de las variables se guardará en el disco duro.

Se restaurará al reiniciarse el runtime.

Desactivado: El estado no se guardará.

Por defecto: Desactivado

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ST_SAVE


IDS_IEC61850_VAL_SAVE

Interne ID: IDS_IEC61850_VAL_SAVE

Save value

Guardar valor

Activado: El valor de las variables se guardará en el disco duro.

Se restaurará al reiniciarse el runtime.

Desactivado: El valor no se guardará.

Por defecto: Desactivado

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VAL_SAVE


IDS_IEC61850_WERT

Interne ID: IDS_IEC61850_WERT

IEC61850-Value

IEC61850 Wert

Este valor es fijo en CDCs INS, INC, SGCB y ACD, se analizará como mensaje único/comando único

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

I61850_VAL


IDS_IGROUP

Interne ID: IDS_IGROUP

iGroup

Grupo de índices del control.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NGIGroup


IDS_ILON_DATAPOINT

Interne ID: IDS_ILON_DATAPOINT

iLON Datapoint

Haciendo clic sobre el botón se abre una conexión al rúter ILON para seleccionar las variables.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

iiLonDataPoint


IDS_INOUT

Interne ID: IDS_INOUT

Prozessrichtung

Prozessrichtung

Empfangen: Datenpunkt wird nur empfangen (z.B. Meldungen, Messwerte)

Senden: Datenpunkt wird gesendet (z.B. Befehle, Sollwerte).

Damit ein Datenpunkt gesendet werden kann, muss auch SW setzen aktiv aktiviert sein (siehe "Sollwert setzen").

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Send


IDS_INOUT_ENG

Interne ID: IDS_INOUT_ENG

Prozess direction

Process direction

Receive: Datapoint will be received only (e.g. messages, measuring values)

Send: Datapoint will be sent (e.g. commands, setpoints).

To be able to be sent, the datapoint has to have also the Set value active property active (see "Set value").

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Send


IDS_KURVE_NEU

Interne ID: IDS_KURVE_NEU

Curvas

Propiedades para las curvas del elemento de tendencia.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Curves


IDS_LINIENFARBE_VARIABLE

Interne ID: IDS_LINIENFARBE_VARIABLE

Color de texto/línea

Nombre de la variable cuyos colores de valor límite influirán en el color de las líneas/texto del elemento.
Abre diálogo de selección de las variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LineColorVariable


IDS_LOGID

Interne ID: IDS_LOGID

Log ID

Introduzca la dirección del log (Log ID) en el control.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Log ID


IDS_LON_DATABASE

Interne ID: IDS_LON_DATABASE

LON Database

Con un clic sobre el botón se abre la base de datos Lon para seleccionar las variables.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LonDatabase


IDS_MERKER

Interne ID: IDS_MERKER

Merker

Aktiv: Variable ohne Prozessbezug (Adresse wird nicht geprüft; für interne Verwendung)

siehe auch Interntreiber

Inaktiv: Variable wird vom Prozess aktualisiert

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MERKER


IDS_MERKER_ENG

Interne ID: IDS_MERKER_ENG

Marker

Active: Datapoint will not be updated by process value (can be used as internal variable, doesn't need a datapoint address)

Inactive: Datapoint will be updated by process value

see also Driver Intern

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MERKER


IDS_MITTELGRUPPE

Interne ID: IDS_MITTELGRUPPE

Middle group

Introduzca el número del grupo medio deseado.

Mínimo: 0

Máximo: 7

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

MiddleGroup


IDS_NG_ADRESSE

Interne ID: IDS_NG_ADRESSE

Beckhoff specific

Configuración para el tamaño bit y Igroup.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NGAddress


IDS_NODE

Interne ID: IDS_NODE

Node

Introduzca la dirección del nodo de control.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Node


IDS_NWMAGENT

Interne ID: IDS_NWMAGENT

NWM-Agent kopieren

Con esta función puede copiar de nuevo un agente ya creado.

El nuevo agente debe estar previamente creado.

Se crearán todas las variables correspondientes.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NWM-Agent


IDS_NWMPARA

Interne ID: IDS_NWMPARA

NWM-Parameter

Abrir el diálogo de parámetros.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NWM-Parameter


IDS_OKT1

Interne ID: IDS_OKT1

O1/Region

Regionsnummer bzw. Octet 1 (CASDU1)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

R_NR


IDS_OKT1_ENG

Interne ID: IDS_OKT1_ENG

O1/Region number

Region number or Octet 1 (CASDU1)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

R_NR


IDS_OKT2

Interne ID: IDS_OKT2

O2/Komponente

Komponentennummer bzw. Octet 2 (CASDU2)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

K_NR


IDS_OKT2_ENG

Interne ID: IDS_OKT2_ENG

O2/Component

Component number or Octet 2 (CASDU2)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

K_NR


IDS_OKT3

Interne ID: IDS_OKT3

O3/Baugruppe

Baugruppennummer bzw. Octet 3 (IOA1)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

B_NR


IDS_OKT3_ENG

Interne ID: IDS_OKT3_ENG

O3/Board

Board number or Octet 3 (IOA1)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

B_NR


IDS_OKT4

Interne ID: IDS_OKT4

O4/Wertnummer

Wertnummer bzw. Octet 4 (IOA2)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

W_NR


IDS_OKT4_ENG

Interne ID: IDS_OKT4_ENG

O4/Value number

Value number or Octet 4 (IOA2)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

W_NR


IDS_OKT5

Interne ID: IDS_OKT5

O5/Datenart

Datenart bzw. Octet 5 (IOA3)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DA


IDS_OKT5_ENG

Interne ID: IDS_OKT5_ENG

O5/Subaddress

Data type or Octet 5 (IOA3)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DA


IDS_OKT6

Interne ID: IDS_OKT6

Point

Pointnummer bzw. Octet 6

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PT


IDS_OKT6_ENG

Interne ID: IDS_OKT6_ENG

Point

Point number or Octet 6

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

PT


IDS_POS1

Interne ID: IDS_POS1

Position 1

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Position1


IDS_POS2

Interne ID: IDS_POS2

Position 2

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Position2


IDS_PROJEKT_ACTIVE_DIR

Interne ID: IDS_PROJEKT_ACTIVE_DIR

Acceso al Active Directory

Seleccione si desea utilizar el Active Directory, ADAM o ninguno de los dos. Tiene las siguientes opciones:

- ADAM - Active Directory Application Mode: Utiliza ADAM o AD LDS. Asegúrese de realizar la configuración correspondiente para las propiedades Conexión AD-LDS , Nombre de usuario AD-LDS y Contraseña AD-LDS .

- Sí: Utiliza Active Directory.

- No: No localiza al usuario de ADAM ni AD LDS o AD. Los usuarios utilizados en zenon son totalmente independientes de los usuarios de Windows.

Por defecto: No

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

UseActiveDirectory


IDS_PROJEKT_DIRS

Interne ID: IDS_PROJEKT_DIRS

Fichero de archivos

Se abrirá el diálogo de configuración para las rutas de proyecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ProjectPaths


IDS_PROJEKT_INFO

Interne ID: IDS_PROJEKT_INFO

Descripción de proyecto

Se abrirá el diálogo de configuración para la información del proyecto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ProjectInfo


IDS_PROJEKT_MODIFILES

Interne ID: IDS_PROJEKT_MODIFILES

Datos RT modificables

Se abrirá el diálogo de configuración para los datos modificables del runtime.
Recetas estándar, administrador del grupo de recetas, Scheduler o Production & Facility Scheduler y administración de usuarios.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ProjectModidata


IDS_PROJEKT_REMTRANS

Interne ID: IDS_PROJEKT_REMTRANS

Transporte remoto

Se abrirá el diálogo de configuración para el transporte remoto.
El transporte remoto sirve para transportar, cargar, iniciar y finalizar un proyecto en un ordenador lejano y para solicitar el estado actual.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ProjectTransport


IDS_RED

Interne ID: IDS_RED

redundante Peripherieadresse

Redundante Adresse

Aktiv: Redundante Adresse verwenden

Inaktiv: Keine redundante Adresse

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RED


IDS_RED_ENG

Interne ID: IDS_RED_ENG

Redundancy Peripheral address

Redundant address

Active: Use redundant address

Inactive: No redundant address

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

RED


IDS_REG

Interne ID: IDS_REG

Regulierbefehl

Regulierbefehle, Retriggerbefehle

Aktiv: Befehl ist Regulierbefehl

Inaktiv: Standardbefehl

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

REG


IDS_REG_ENG

Interne ID: IDS_REG_ENG

Enable regulating commands

Regulating-, triggered commands

Active: Command is regulating-, triggered command

Inactive: Standard command

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

REG


IDS_RLINE

Interne ID: IDS_RLINE

REYDISP-Linie

REYDISP Liniennummer

Nur bei Störschrieb-Datenpunkt

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LINIE


IDS_RLINE_ENG

Interne ID: IDS_RLINE_ENG

REYDISP-Line

REYDISP line number

Only for disturbance data datapoints

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LINIE


IDS_ROKT1

Interne ID: IDS_ROKT1

Red. O1/Region

Redundante Peripherieadresse

Regionsnummer bzw. Octet 1 (CASDU1)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

R_2


IDS_ROKT1_ENG

Interne ID: IDS_ROKT1_ENG

Red. O1/Region number

Redundant datapoint address

Region number or Octet 1 (CASDU1)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

R_2


IDS_ROKT2

Interne ID: IDS_ROKT2

Red. O2/Komponente

Redundante Peripherieadresse

Komponentennummer bzw. Octet 2 (CASDU2)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

K_2


IDS_ROKT2_ENG

Interne ID: IDS_ROKT2_ENG

Red. O2/Component

Redundant datapoint address

Region number or Octet 2 (CASDU2)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

K_2


IDS_ROKT3

Interne ID: IDS_ROKT3

Red. O3/Baugruppe

Redundante Peripherieadresse

Baugruppennummer bzw. Octet 3 (IOA1)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

B_2


IDS_ROKT3_ENG

Interne ID: IDS_ROKT3_ENG

Red. O3/Board

Redundant datapoint address

Region number or Octet 3 (IOA1)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

B_2


IDS_ROKT4

Interne ID: IDS_ROKT4

Red. O4/Wertnummer

Redundante Peripherieadresse

Wertnummer bzw. Octet 4 (IOA2)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

W_2


IDS_ROKT4_ENG

Interne ID: IDS_ROKT4_ENG

Red. O4/Value number

Redundant datapoint address

Region number or Octet 4 (IOA2)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

W_2


IDS_ROKT5

Interne ID: IDS_ROKT5

Red. O5/Datenart

Redundante Peripherieadresse

Datenart bzw. Octet 5 (IOA3)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

D_2


IDS_ROKT5_ENG

Interne ID: IDS_ROKT5_ENG

Red. O5/Subaddress

Redundant datapoint address

Region number or Octet 5 (IOA3)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

D_2


IDS_SE_ADRESSE

Interne ID: IDS_SE_ADRESSE

Address

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SeAddress


IDS_SE_STANDARD

Interne ID: IDS_SE_STANDARD

Standard

activado: Todos los dispositivos C en un dispositivo B se tendrán por "Tipo C". Los dispositivos C no se seleccionarán directamente, sino que los puntos de datos de los dispositivos C se tratarán como si estuvieran
en el dispositivo B.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Standard


IDS_SICHTBARKEIT

Interne ID: IDS_SICHTBARKEIT

Visibilidad/parpadeo

Propiedades para la visibilidad y el parpadeo del elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Visibility


IDS_SICHTBARKEIT_AUSGRENZWERT

Interne ID: IDS_SICHTBARKEIT_AUSGRENZWERT

Tomar del valor límite

Sólo disponible después de haber seleccionado una variable:

  • Activado: La visibilidad del elemento estará influida por las propiedades de los valores límite de la variable.

    Atención: En por lo menos un límite de la variable tiene que estar activada la propiedad Oculto.

  • Desactivado: La visibilidad estará influenciada por las propiedades del elemento.

Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VisibilityFromLimit


IDS_SICHTBARKEIT_BIS

Interne ID: IDS_SICHTBARKEIT_BIS

Hasta

Solo disponible después de haber seleccionado una variable y si no se aplica la visibilidad del valor límite:

El mayor valor de la variable en el que el elemento sea visible.

  • Mínimo: menor valor posible de la variable vinculada.
  • Máximo: mayor valor posible de la variable vinculada.

Por defecto: mayor valor posible de la variable vinculada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VisibilityTo


IDS_SICHTBARKEIT_VARIABLE

Interne ID: IDS_SICHTBARKEIT_VARIABLE

Variable

Solo disponible si para la propiedad Visibilidad se ha seleccionado De la variable.

Nombre de las variables cuyo valor determina la visibilidad del elemento. La visibilidad se tomará o de las propiedades del límite de estas variables o se determinará con el rango de valor definido en las propiedades Desde y Hasta.
Haciendo clic sobre el botón ... se abre un diálogo para elegir las variables. El nombre se puede introducir también manualmente en el campo de texto.
Cuando no hay ninguna variable vinculada, el elemento está siempre visible.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VisibilityVariable


IDS_SICHTBARKEIT_VON

Interne ID: IDS_SICHTBARKEIT_VON

Desde

Solo disponible después de haber seleccionado una variable y si no se aplica la visibilidad del valor límite:

Valor mínimo de la variable con la que el elemento es visible.

  • Mínimo: menor valor posible de la variable vinculada.
  • Máximo: mayor valor posible de la variable vinculada.

Por defecto: menor valor posible de la variable vinculada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VisibilityFrom


IDS_ST_SAVE

Interne ID: IDS_ST_SAVE

Status speichern

Aktiv: Status der Variablen wird auf Festplatte gespeichert.

Wird bei Neustart der Runtime rückgelesen.

Inaktiv: Status wird nicht gespeichert.

Default: Inaktiv

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ST_SAVE


IDS_ST_SAVE_ENG

Interne ID: IDS_ST_SAVE_ENG

Save state

Save status

Active: The status bits (e.g. Revision) of the datapoint will be saved (STATUS.BIN) and will be reread at start of runtime.

Inactive: The status bits of the datapoint will not be saved.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ST_SAVE


IDS_STRING78

Interne ID: IDS_STRING78

Área de visualización dinámica

Propiedades para el rango de visualización dinámica.
Permite modificar dinámicamente el rango de visualización durante el runtime mediante valores de variables.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Displayrange_Dynamic


IDS_STRING79

Interne ID: IDS_STRING79

Mínimo

Variable que define el mínimo del área de visualización en el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DynMinVar


IDS_STRING80

Interne ID: IDS_STRING80

Máximo

Variable que define el máximo del área de visualización en el runtime.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

DynMaxVar


IDS_STRING81

Interne ID: IDS_STRING81

Limites dinámicos del valor predeterminado

Propiedades para los límites dinámicos predeterminados.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SetValueLimits_Dynamic


IDS_STRING82

Interne ID: IDS_STRING82

Mínimo

Solo disponible si Aplicar límite del valor predeterminado de la variable no está activado:
Variable cuyo valor actual se aplicará como límite predeterminado inferior para el elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SetValueDynMin


IDS_STRING83

Interne ID: IDS_STRING83

Máximo

Solo disponible si "Aplicar límites predeterminados de la variable" no está activado:
Variable cuyo valor actual se aplicará como límite predeterminado superior para el elemento.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SetValueDynMax


IDS_SYMADRESSE

Interne ID: IDS_SYMADRESSE

3S Arti specific

Las propiedades siguientes sirven para direccionar el driver 3S_Arti_NG.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NGAddress


IDS_SYMNAME

Interne ID: IDS_SYMNAME

Symbol name

Nombre del símbolo de las variables en el control.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

NGSymName


IDS_TRANS

Interne ID: IDS_TRANS

Transparente Daten

Transparente Daten

Nur bei Störschrieb-Datenpunkt.

DISTO: Störschriebauswertung mit DISTO

REYDISP: Störschriebauswertung für REYROLL

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TRANS


IDS_TRANS_ENG

Interne ID: IDS_TRANS_ENG

Transparent Data

Transparent Data

Only for disturbance data datapoints.

DISTO: Storing of disturbance records by DISTO

REYDISP: Storing of disturbance records by REYROLL

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TRANS


IDS_UNTERGRUPPE

Interne ID: IDS_UNTERGRUPPE

Sub group

Introduzca el número del subgrupo deseado.

Mínimo: 0

Máximo: 255

Por defecto: 0

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SubGroup


IDS_VAL_SAVE

Interne ID: IDS_VAL_SAVE

Wert speichern

Aktiv: Wert der Variablen wird auf Festplatte gespeichert.

Wird bei Neustart der Runtime rückgelesen.

Inaktiv: Wert wird nicht gespeichert.

Default: Inaktiv.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VAL_SAVE


IDS_VAL_SAVE_ENG

Interne ID: IDS_VAL_SAVE_ENG

Save value

Save value

Active: The value of the datapoint will be saved (STATUS.BIN) and will be reread at start of runtime.

Inactive: The value will not be saved and is 0 at restart.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VAL_SAVE


IDS_VAR_ERSATZWERT_STRING

Interne ID: IDS_VAR_ERSATZWERT_STRING

Valor de llenado del archivo de la cadena

Este valor se utilizará para variables cadena para rellenar los archivos cíclicos. Cuando haya intervalos de tiempo en los que no hubiera conexión al hardware, se utilizará este valor mientras el hardware no transmita otro. En otro caso se utilizará el último valor válido para rellenar.

Longitud máxima: 128 caracteres.
ATENCIÓN: Esta propiedad no está disponible para el cambio de idioma.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

AlternateValueString


IDS_VTA

Interne ID: IDS_VTA

Adressierungsart

Adresstyp

Muss mit Parametrierung in GW1703.ini und der Gegenstelle übereinstimmen.

STA: Systemtechnisch

VTA: Verfahrenstechnisch

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VTA


IDS_VTA_ENG

Interne ID: IDS_VTA_ENG

Typ of addressing

Address type

In accordance to parameterization of GW1703.ini and remote station.

STA: System technical

VTA: Process technical (PTA in GW1703.ini)

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VTA


IDS_WDH

Interne ID: IDS_WDH

WDH (Anz. Wdh.)

Max. Anzahl an Wiederholungen

Regulierbefehle, Retriggerbefehle

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WDH


IDS_WDH_ENG

Interne ID: IDS_WDH_ENG

Repeats

Max. count of repeats

Regulating-, triggered commands

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

WDH


IDS_Z_NR

Interne ID: IDS_Z_NR

Zielnummer

LAN-Stations- oder LAN-Gruppennummer

Bei serieller Ankopplung Linkadresse

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Z_NR


IDS_Z_NR_ENG

Interne ID: IDS_Z_NR_ENG

Destination number

LAN station or LAN group number

Link address if serial connection

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Z_NR


IDS_Z_TYP

Interne ID: IDS_Z_TYP

Zieltyp

Auswahl LAN-Station oder LAN-Gruppe

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Z_TYP


IDS_Z_TYP_ENG

Interne ID: IDS_Z_TYP_ENG

Destination typ

Selection of LAN station or LAN group

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Z_TYP


IDS_ZEIT

Interne ID: IDS_ZEIT

Time

Zeitbeigabe

Aktiv: Rechnerzeit wird beim Empfang beigegeben.

Inaktiv: Zeit aus Telegramm wird verwendet.

Invalide oder unplausible Zeit wird automatisch durch die Rechnerzeit ersetzt.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ZEIT


IDS_ZEIT_ENG

Interne ID: IDS_ZEIT_ENG

Time stamp by AKS

Time setting

Active: Computer time will be used when received

Inactive: Telegram time will be used

Invalid or implausible time stamp will be replaced automatically by computer time.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ZEIT


IDS_ZENMENU_PROP01

Interne ID: IDS_ZENMENU_PROP01

ID del menú

Nombre de la entrada de menú.

En Tipo de acción Comando se pueden seleccionar de una lista desplegable las acciones previamente definidas en el comando.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


IDS_ZENMENU_PROP02

Interne ID: IDS_ZENMENU_PROP02

Texto

Descripción de la entrada de menú. La entrada debe ser unívoca. En el caso de que haya varias entradas con el mismo texto durante el runtime se mostrará solamente la primera de estas entradas de menú.

Observación: Si en el campo de propiedades Tipo de acción se selecciona mediante la lista desplegable el valor Comando, el valor de la propiedad Texto: se rellenará previamente con $ALL$.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Caption


IDS_ZENMENU_PROP04

Interne ID: IDS_ZENMENU_PROP04

Archivo

Solo disponible para el tipo de acción "Ayuda":
Archivo de ayuda del que se mostrará un capítulo.
Normalmente se mostrarán las páginas de ayuda del elemento vinculado. Si un elemento no tiene ninguna página de ayuda vinculada se mostrará la página que se defina aquí.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HelpFile


IDS_ZENMENU_PROP05

Interne ID: IDS_ZENMENU_PROP05

Capítulo

Solo disponible para el tipo de acción "Ayuda":
Archivo de ayuda que se mostrará.

ATENCIÓN: Esta entrada tiene en cuenta mayúsculas/minúsculas.
Normalmente se mostrarán las páginas de ayuda del elemento vinculado. Si un elemento no tiene ninguna página de ayuda vinculada se mostrará la página que se defina aquí.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

HelpCapture


IDS_ZENMENU_PROP06

Interne ID: IDS_ZENMENU_PROP06

Archivo gráfico

Archivo gráfico que se muestra en el margen izquierdo.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Picture


IDS_ZENMENU_PROP07

Interne ID: IDS_ZENMENU_PROP07

Marca de verificación

Antes de la entrada de menú se muestra una marca de verificación. Sólo sirve para la representación gráfica.

Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Checked


IDS_ZENMENU_PROP08

Interne ID: IDS_ZENMENU_PROP08

Activado

Activado: La entrada de menú se mostrará de manera normal y la acción vinculada a ella se ejecutará cuando se accione.
Desactivado: La entrada se mostrará grisada y la acción vinculada a ella no se ejecutará.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Enabled


IDS_ZENMENU_PROP09

Interne ID: IDS_ZENMENU_PROP09

Visible

Controla si la entrada de menú se muestra en el runtime.

Por defecto: activado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Visible


IDS_ZENMENU_PROP10

Interne ID: IDS_ZENMENU_PROP10

Separador activado

Activado: En lugar de una entrada de menú aparecerá una línea divisoria horizontal. Se puede definir la anchura y el color de la línea.

Por defecto: Desactivado

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Seperator


IDS_ZENMENU_PROP11

Interne ID: IDS_ZENMENU_PROP11

Submenú

La entrada de menú no ejecuta ninguna acción, sino que abre un submenú.

Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Popup-Menu


IDS_ZENMENU_PROP12

Interne ID: IDS_ZENMENU_PROP12

Tipo de acción

Los tipos de acciones siguientes están disponibles en el menú principal y en el contextual:

Función: Se ejecuta una función.
Ayuda: Se muestra una entrada de ayuda.
Ninguna acción: No se ejecuta ninguna acción.
Establecer valor predeterminado: Se escribirá un valor predeterminado en una variable.

Los tipos de acciones siguientes se pueden ejecutar solo en el menú contextual:

Reconocer alarma: Reconoce todas las alarmas para variables con las que esté vinculado el elemento dinámico al que se refiere el menú contextual.
Reconocer parpadeo: Desactiva el parpadeo de todas las alarmas para las variables que estén vinculadas con el elemento dinámico al que se refiere el menú contextual. Con ello no se reconoce la alarma.
Comando: Ejecuta un comando.
Macro VBA: Se ejecutará una macro VBA.

Más en el manual online

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Type


IDS_ZENMENU_PROP13

Interne ID: IDS_ZENMENU_PROP13

Nivel de autorización

Nivel de contraseña para ejecutar esta entrada de menú.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Password


IDS_ZENMENU_PROP14

Interne ID: IDS_ZENMENU_PROP14

Color de texto

Color del texto para el menú seleccionado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

TextColor


IDS_ZENMENU_PROP15

Interne ID: IDS_ZENMENU_PROP15

Color de fondo

Color de fondo para el menú seleccionado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackColor


IDS_ZENMENU_PROP16

Interne ID: IDS_ZENMENU_PROP16

Fuente

Tipo de fuente del menú. Vale para todas las entradas de menú.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Font


IDS_ZENMENU_PROP17

Interne ID: IDS_ZENMENU_PROP17

Función

Solo disponible para el tipo de acción "Función":
Función que se ejecutará mediante la entrada de menú seleccionada.
Si se debe ejecutar más de una función se deberá crear un script con las funciones deseadas y vincular aquí la función para ejecutar el script.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Function


IDS_ZENMENU_PROP18

Interne ID: IDS_ZENMENU_PROP18

VBA-Macro

Solo disponible para el tipo de acción "Macro VBA":
Macro VBA que se ejecutará mediante la entrada de menú seleccionada.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

VBA-Macro


IDS_ZENMENU_PROP19

Interne ID: IDS_ZENMENU_PROP19

Variable

Solo disponible para el tipo de acción "Establecer valor predeterminado":
Variable sobre la que se escribirá un valor predeterminado mediante la entrada del menú.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Variable


IDS_ZENMENU_PROP20

Interne ID: IDS_ZENMENU_PROP20

Cambiar de valor predeterminado

Solo disponible para el tipo de acción "Establecer valor predeterminado":
Valor numérico que se escribirá como valor predeterminado sobre la variable seleccionada. Solo se esperarán y aceptarán valores numéricos. Se aceptarán valores con hasta 6 decimales.
Si la propiedad Proponer valor actual está activada, el valor actual de la variable aumentará (valor positivo) en dicho valor o disminuirá (valor negativo).

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Sollwert


IDS_ZENMENU_PROP21

Interne ID: IDS_ZENMENU_PROP21

Variable del elemento

Solo disponible para el tipo de acción "Establecer valor predeterminado" y menús contextuales:
Activado: La variable para establecer el valor predeterminado se tomará del elemento dinámico.
Desactivado: La variable para establecer el valor predeterminado se establecerá en las propiedades de la entrada de menú.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

FromElem


IDS_ZENMENU_PROP22

Interne ID: IDS_ZENMENU_PROP22

Diálogo

Solo disponible para el tipo de acción "Establecer valor predeterminado":
Activado: Al ejecutar la acción antes de escribir el valor predeterminado se abrirá una caja de diálogo que permite al usuario modificar el valor predeterminado antes de escribirlo.
Si hay pantallas de teclados (p. ej. SETVALUEKBD, SETSTRINGKBD o SETBOOLKBD) éstas se activarán automáticamente en lugar de la caja de diálogo.
Desactivado: El valor definido en las propiedades de la entrada de menú se enviará directamente al hardware.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

SWDialog


IDS_ZENMENU_PROP23

Interne ID: IDS_ZENMENU_PROP23

Proponer valor actual

Solo disponible para el tipo de acción "Establecer valor predeterminado":
Activado: El valor actual de la variable se propondrá como valor predeterminado.
Desactivado: El valor predeterminado se establecerá directamente en las propiedades de la entrada de menú.
Por defecto: desactivado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

ActValue


IDS_ZENMENU_PROP24

Interne ID: IDS_ZENMENU_PROP24

Nombre:

Nombre unívoco del menú.
Por defecto: Nuevo menú principal x o nuevo menú contextual x (x equivale a un número continuo).

ATENCIÓN: Esta propiedad no está disponible para el cambio de idioma.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Name


IDS_ZENMENU_PROP34

Interne ID: IDS_ZENMENU_PROP34

Interbloqueo

Selección de un interbloqueo para la entrada de menú.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Locking


IDS_ZENMENU_PROP36

Interne ID: IDS_ZENMENU_PROP36

Archivo gráfico

Gráfico de fondo para la entrada de menú.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackgroundPicture


IDS_ZENMENU_PROP37

Interne ID: IDS_ZENMENU_PROP37

Alineación

Tamaño del gráfico de fondo para la entrada de menú.
Tamaño original: La pantalla se representará en su tamaño original. La entrada de menú se ajustará al tamaño de la pantalla.
Ampliado: La pantalla se ampliará hasta el tamaño de la entrada de menú.
Por defecto: Tamaño original.

Por ejemplo: Los menús deben ser utilizados en un proyecto con pantalla táctil. Para el tamaño de las entradas de menú individuales se utilizarán por defecto las configuraciones del sistema operativo. Con un gráfico de fondo en tamaño original se puede ajustar individualmente el tamaño de las entradas de menú.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

BackgroundPicRepres


IDS_ZENMENU_PROP_GRP2

Interne ID: IDS_ZENMENU_PROP_GRP2

Autorización

Propiedades de la autorización de uso de la entrada de menú.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Rights


IDS_ZENMENU_PROP_GRP3

Interne ID: IDS_ZENMENU_PROP_GRP3

Representación / Tipo

Propiedades para la representación de la entrada de menú.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Represantation


IDS_ZENMENU_PROP_GRP4

Interne ID: IDS_ZENMENU_PROP_GRP4

Función/macro

Función o macro VBA que se ejecutará con esta entrada de menú.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Function


IDS_ZENMENU_PROP_GRP5

Interne ID: IDS_ZENMENU_PROP_GRP5

Escribir valor predeterminado

Propiedades para el valor que se desea escribir.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_SetValue


IDS_ZENMENU_PROP_GRP6

Interne ID: IDS_ZENMENU_PROP_GRP6

Ayuda

Propiedades para la página de ayuda para la entrada del menú.
Esta funcionalidad permite mostrar páginas de ayuda basadas en HTML de un archivo CHM Datei durante el runtime. En los menús contextuales la ayuda también puede ser sensible al contexto.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_Help


IDS_ZENMENU_PROP_GRP7

Interne ID: IDS_ZENMENU_PROP_GRP7

Gráfico de fondo

Propiedades para el gráfico de fondo de la entrada de menú.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_BackgroundPicture


IDS_ZENMENU_PROP_GRP8

Interne ID: IDS_ZENMENU_PROP_GRP8

Acción

Propiedades de la acción que se ejecutará con la entrada del menú.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

Action


IDS_ZENMENU_PROP_GRP9

Interne ID: IDS_ZENMENU_PROP_GRP9

General

Configuraciones generales del menú seleccionado.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

GRP_General


IDS_ZYKLISCH_LESEN

Interne ID: IDS_ZYKLISCH_LESEN

Read cyclical

Establece de qué manera se transmite el valor por el control.

activado: El valor se pedirá cíclicamente por el control.

Por defecto: Desactivado

Observación: Hay que tener mucho cuidado al elegir esta opción ya que hace que la carga del bus aumente enormemente.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

CyclicReading


LOCK_BITMAP_LOCKING

Interne ID: LOCK_BITMAP_LOCKING

Interbloqueo de archivo gráfico

Sólo disponible si Identificación gráfica activada está activada.

Selección del archivo gráfico que muestra un elemento interbloqueado. El archivo debe estar creado en el administrador de proyectos en archivos/gráficos de nodos como archivo bitmap.

Formato permitido: 16 x 16 píxel, los bitmaps mayores se representarán comprimidos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LockLockBitmap


LOCK_BITMAP_USER

Interne ID: LOCK_BITMAP_USER

Archivo gráfico bloqueado

Sólo disponible si Identificación gráfica activada está activada.

Selección del archivo gráfico que muestra un elemento bloqueado para el uso. El archivo debe estar creado en el administrador de proyectos en archivos/gráficos de nodos como archivo bitmap.

Formato permitido: 16 x 16 píxel, los bitmaps mayores se representarán comprimidos.

Más en el manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LockUserBitmap


LOCK_FILL_COLOR

Interne ID: LOCK_FILL_COLOR

Color de relleno del símbolo de cerrojo

Sólo disponible si Identificación gráfica activada está activada.
Define el color de relleno del símbolo de candado. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LockFillColor


LOCK_LINE_COLOR

Interne ID: LOCK_LINE_COLOR

Color de línea del símbolo de cerrojo

Sólo disponible si Identificación gráfica activada está activada.

Define el color de las líneas del símbolo de candado. Haciendo clic sobre el botón ... se abre un diálogo para seleccionar un color o paleta de colores. La entrada se puede hacer también directamente en el campo como valor hexadecimal con # delante.

Más en el Manual online.

Esta función se localizará para zenon API (con nombre de clase) y en la exportación XML (sin nombre de clase) de la siguiente manera:

LockLineColor